CREATE TABLE `%%TBL-PREFIX%%base_authorization_action` (
  `id` int(11) NOT NULL auto_increment,
  `groupId` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `availableForGuest` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `groupId` (`groupId`,`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_authorization_action` (`id`, `groupId`, `name`, `availableForGuest`) VALUES
(11, 6, 'add_comment', 0),
(12, 6, 'delete_comment_by_content_owner', 0),
(67, 6, 'search_users', 1),
(171, 6, 'view_profile', 1);

CREATE TABLE `%%TBL-PREFIX%%base_authorization_group` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `moderated` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_authorization_group` (`id`, `name`, `moderated`) VALUES
(3, 'rate', 0),
(6, 'base', 1),
(7, 'admin', 1);

CREATE TABLE `%%TBL-PREFIX%%base_authorization_moderator` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_authorization_moderator_permission` (
  `id` int(11) NOT NULL auto_increment,
  `moderatorId` int(11) NOT NULL,
  `groupId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `moderatorId` (`moderatorId`),
  KEY `groupId` (`groupId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_authorization_permission` (
  `id` int(11) NOT NULL auto_increment,
  `actionId` int(11) NOT NULL,
  `roleId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `actionId` (`actionId`,`roleId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_authorization_permission` (`id`, `actionId`, `roleId`) VALUES
(42, 11, 12),
(43, 11, 27),
(44, 11, 28),
(45, 11, 29),
(46, 11, 30),
(47, 12, 12),
(48, 12, 29),
(49, 12, 30),
(50, 67, 12),
(51, 67, 27),
(52, 67, 28),
(53, 67, 29),
(54, 67, 30),
(55, 171, 1),
(56, 171, 12),
(57, 171, 27),
(58, 171, 28),
(59, 171, 29),
(60, 171, 30);

CREATE TABLE `%%TBL-PREFIX%%base_authorization_role` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `sortOrder` int(11) NOT NULL,
  `displayLabel` tinyint(1) default '0',
  `custom` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_authorization_role` (`id`, `name`, `sortOrder`, `displayLabel`, `custom`) VALUES
(1, 'guest', 0, 0, NULL),
(12, 'wqewq', 1, 0, NULL);

CREATE TABLE `%%TBL-PREFIX%%base_authorization_user_role` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  `roleId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `userId` (`userId`),
  KEY `roleId` (`roleId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_avatar` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  `hash` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_billing_gateway` (
  `id` int(11) NOT NULL auto_increment,
  `gatewayKey` varchar(50) NOT NULL,
  `adapterClassName` varchar(100) NOT NULL,
  `active` tinyint(1) NOT NULL default '0',
  `mobile` tinyint(1) NOT NULL default '0',
  `recurring` tinyint(1) NOT NULL default '0',
  `dynamic` tinyint(1) default '1',
  `currencies` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `gatewayKey` (`gatewayKey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_billing_gateway_config` (
  `id` int(10) NOT NULL auto_increment,
  `gatewayId` int(10) NOT NULL,
  `name` varchar(50) NOT NULL,
  `value` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_billing_gateway_product` (
  `id` int(10) NOT NULL auto_increment,
  `gatewayId` int(10) NOT NULL,
  `pluginKey` varchar(255) NOT NULL,
  `entityType` varchar(50) NOT NULL,
  `entityId` int(10) NOT NULL,
  `productId` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_billing_product` (
  `id` int(11) NOT NULL auto_increment,
  `productKey` varchar(255) NOT NULL,
  `adapterClassName` varchar(100) NOT NULL,
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `productKey` (`productKey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_billing_sale` (
  `id` int(11) NOT NULL auto_increment,
  `hash` varchar(32) NOT NULL,
  `pluginKey` varchar(255) default NULL,
  `entityKey` varchar(50) NOT NULL,
  `entityId` int(10) default NULL,
  `entityDescription` varchar(255) default NULL,
  `gatewayId` int(11) NOT NULL,
  `userId` int(11) default NULL,
  `transactionUid` varchar(32) default NULL,
  `price` float(9,3) NOT NULL,
  `period` int(10) default NULL,
  `quantity` int(10) NOT NULL,
  `totalAmount` float(9,3) NOT NULL default '0.000',
  `currency` varchar(3) NOT NULL,
  `recurring` tinyint(1) NOT NULL default '0',
  `status` enum('init','prepared','verified','delivered','processing','error') NOT NULL default 'init',
  `timeStamp` int(10) NOT NULL default '0',
  `extraData` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_comment` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  `commentEntityId` int(11) NOT NULL,
  `message` text NOT NULL,
  `createStamp` int(11) NOT NULL,
  `attachment` text,
  PRIMARY KEY  (`id`),
  KEY `userId` (`userId`),
  KEY `commentEntityId` (`commentEntityId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_comment_entity` (
  `id` int(11) NOT NULL auto_increment,
  `entityType` varchar(255) NOT NULL,
  `entityId` int(11) NOT NULL,
  `pluginKey` varchar(100) NOT NULL,
  `active` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `entityType` (`entityType`,`entityId`),
  KEY `pluginKey` (`pluginKey`),
  KEY `pluginKey_2` (`pluginKey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_component` (
  `id` int(11) NOT NULL auto_increment,
  `className` varchar(50) NOT NULL,
  `clonable` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_component` (`id`, `className`, `clonable`) VALUES
(70, 'BASE_CMP_AboutMeWidget', 0),
(69, 'BASE_CMP_RssWidget', 1),
(68, 'BASE_CMP_UserViewWidget', 0),
(67, 'BASE_CMP_JoinNowWidget', 0),
(66, 'BASE_CMP_ProfileWallWidget', 0),
(65, 'BASE_CMP_UserAvatarWidget', 0),
(64, 'BASE_CMP_IndexWallWidget', 0),
(61, 'BASE_CMP_AddNewContent', 0),
(62, 'BASE_CMP_CustomHtmlWidget', 1),
(63, 'BASE_CMP_UserListWidget', 0),
(207, 'BASE_CMP_MyAvatarWidget', 0);

CREATE TABLE `%%TBL-PREFIX%%base_component_entity_place` (
  `id` int(11) NOT NULL auto_increment,
  `componentId` int(11) NOT NULL,
  `placeId` int(11) NOT NULL,
  `clone` tinyint(4) NOT NULL default '0',
  `entityId` int(11) NOT NULL,
  `uniqName` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`entityId`,`uniqName`),
  KEY `componentId` (`componentId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_component_entity_position` (
  `id` int(11) NOT NULL auto_increment,
  `componentPlaceUniqName` varchar(50) NOT NULL,
  `section` enum('top','left','bottom','right') NOT NULL,
  `order` int(11) NOT NULL,
  `entityId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`entityId`,`componentPlaceUniqName`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_component_entity_setting` (
  `id` int(11) NOT NULL auto_increment,
  `entityId` int(11) NOT NULL,
  `name` varchar(50) NOT NULL default '',
  `value` longtext NOT NULL,
  `componentPlaceUniqName` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `componentUniqName` (`entityId`,`componentPlaceUniqName`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_component_place` (
  `id` int(11) NOT NULL auto_increment,
  `componentId` int(11) NOT NULL,
  `placeId` int(11) NOT NULL,
  `clone` tinyint(1) unsigned default '0',
  `uniqName` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `uniqName` (`uniqName`),
  KEY `componentId` (`componentId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

INSERT INTO `%%TBL-PREFIX%%base_component_place` (`id`, `componentId`, `placeId`, `clone`, `uniqName`) VALUES
(328, 69, 3, 0, 'profile-BASE_CMP_RssWidget'),
(317, 69, 2, 0, 'index-BASE_CMP_RssWidget'),
(327, 69, 1, 0, 'dashboard-BASE_CMP_RssWidget'),
(324, 67, 2, 0, 'index-BASE_CMP_JoinNowWidget'),
(325, 68, 3, 0, 'profile-BASE_CMP_UserViewWidget'),
(323, 66, 3, 0, 'profile-BASE_CMP_ProfileWallWidget'),
(329, 70, 3, 0, 'profile-BASE_CMP_AboutMeWidget'),
(322, 65, 3, 0, 'profile-BASE_CMP_UserAvatarWidget'),
(321, 64, 2, 0, 'index-BASE_CMP_IndexWallWidget'),
(318, 62, 1, 0, 'dashboard-BASE_CMP_CustomHtmlWidget'),
(319, 62, 3, 0, 'profile-BASE_CMP_CustomHtmlWidget'),
(320, 63, 2, 0, 'index-BASE_CMP_UserListWidget'),
(326, 62, 2, 0, 'index-BASE_CMP_CustomHtmlWidget'),
(316, 61, 2, 0, 'index-BASE_CMP_AddNewContent'),
(100001, 62, 2, 1, 'admin-4b543d8cdc488'),
(100002, 62, 1, 1, 'admin-4b543f4714cdc'),
(100152, 207, 2, 0, 'index-BASE_CMP_MyAvatarWidget');

CREATE TABLE `%%TBL-PREFIX%%base_component_place_cache` (
  `id` int(11) NOT NULL auto_increment,
  `placeId` int(11) NOT NULL,
  `state` longtext NOT NULL,
  `entityId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `userId` (`entityId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_component_position` (
  `id` int(11) NOT NULL auto_increment,
  `componentPlaceUniqName` varchar(50) NOT NULL default '',
  `section` enum('top','right','bottom','left','sidebar') NOT NULL,
  `order` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `componentPlaceUniqName` (`componentPlaceUniqName`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

INSERT INTO `%%TBL-PREFIX%%base_component_position` (`id`, `componentPlaceUniqName`, `section`, `order`) VALUES
(9976, '0', 'left', 1),
(9977, '1', 'left', 2),
(9978, '2', 'left', 3),
(6975, 'admin-4c627f1bdc9db', 'top', 0),
(6986, 'admin-4c62811170310', 'top', 0),
(11019, 'profile-BASE_CMP_UserViewWidget', 'right', 0),
(10404, 'index-BASE_CMP_AddNewContent', 'sidebar', 1),
(10403, 'index-BASE_CMP_MyAvatarWidget', 'sidebar', 0),
(11197, 'admin-4b543f4714cdc', 'right', 1),
(11149, 'index-BASE_CMP_UserListWidget', 'left', 2),
(11147, 'admin-4b543d8cdc488', 'left', 0),
(11148, 'index-BASE_CMP_JoinNowWidget', 'left', 1),
(11206, 'profile-BASE_CMP_AboutMeWidget', 'left', 1),
(11205, 'profile-BASE_CMP_UserAvatarWidget', 'left', 0);

CREATE TABLE `%%TBL-PREFIX%%base_component_setting` (
  `id` int(11) NOT NULL auto_increment,
  `componentPlaceUniqName` varchar(50) NOT NULL,
  `name` varchar(50) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `componentPlaceUniqName` (`componentPlaceUniqName`,`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

INSERT INTO `%%TBL-PREFIX%%base_component_setting` (`id`, `componentPlaceUniqName`, `name`, `value`) VALUES
(775, 'admin-4b543d8cdc488', 'content', 'مرحبا بكم في موقعنا الجديد ! لا تتردد في المشاركة في مجتمعنا !'),
(776, 'admin-4b543d8cdc488', 'nl_to_br', '0'),
(777, 'admin-4b543d8cdc488', 'title', 'أهلاً بك'),
(778, 'admin-4b543d8cdc488', 'show_title', '0'),
(779, 'admin-4b543d8cdc488', 'icon', 'ow_ic_warning'),
(780, 'admin-4b543d8cdc488', 'wrap_in_box', '1'),
(832, 'admin-4b543f4714cdc', 'content', '<p>\nمرحباً بكم في موقعنا ! هنا بعض الروابط القليلة السريعة التي تحتاجها إلى بدء طريقك:\n</p>\n<ul class="ow_regular">\n<li><a href="profile/avatar">تغيير الصورة الرمزية </a></li>\n<li><a href="profile/edit">تغيير تفاصيل الملف الشخصي</a></li>\n<li><a href="my-profile">معاينة/إعادة ترتيب ملفي الشخصي</a></li>\n<li><a href="users">أنظر من يتواجد في الموقع</a></li>\n</ul>\n\n<p>\nلا تتردد في المشاركة في موقعنا الإجتماعي !\n</p>'),
(833, 'admin-4b543f4714cdc', 'nl_to_br', '0'),
(834, 'admin-4b543f4714cdc', 'title', 'أهلاً بك !'),
(835, 'admin-4b543f4714cdc', 'show_title', '1'),
(836, 'admin-4b543f4714cdc', 'icon', 'ow_ic_info'),
(837, 'admin-4b543f4714cdc', 'wrap_in_box', '0'),
(838, 'admin-4b543f4714cdc', 'freeze', '0'),
(1366, 'admin-4b543d8cdc488', 'freeze', '0');

CREATE TABLE `%%TBL-PREFIX%%base_config` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `key` varchar(100) NOT NULL,
  `name` varchar(100) NOT NULL,
  `value` text,
  `description` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `key` (`key`,`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_config` (`id`, `key`, `name`, `value`, `description`) VALUES
(16, 'base', 'avatar_big_size', '190', 'قياس عرض صورة المستخدم الرمزية'),
(17, 'base', 'avatar_size', '90', 'قياس إرتفاع صورة المستخدم الرمزية'),
(18, 'admin', 'admin_menu_state', '[]', NULL),
(19, 'base', 'selectedTheme', 'graphite', 'الستايل المختار.'),
(20, 'base', 'military_time', '0', 'Desc'),
(21, 'base', 'site_name', 'موقعي', 'إسم الموقع'),
(22, 'base', 'confirm_email', '1', 'تأكيد البريد الالكتروني'),
(23, 'base', 'user_view_presentation', 'table', 'تقديم عرض المستخدم'),
(24, 'base', 'site_tagline', 'موقعي الجميل', 'وصف الموقع المختصر'),
(25, 'base', 'site_description', 'هذا هو واحد من المواقع التي تعتمد على برمجية مجتمع Oxwall.', 'وصف الموقع'),
(26, 'base', 'site_timezone', 'America/New_York', 'توقيت الموقع'),
(27, 'base', 'site_use_relative_time', '1', 'إستخدام التاريخ / الوقت النسبي'),
(31, 'base', 'display_name_question', 'realname', 'السؤال المستخدم لإسم الظهور'),
(32, 'base', 'site_email', 'admin@example.com', 'عنوان البريد الإلكتروني والذي منه سوف يستلم المستخدمون التبليغات والبريد الجماعي.'),
(34, 'base', 'google_analytics', NULL, NULL),
(46, 'base', 'mail_smtp_enabled', '0', 'Smtp مفعلة'),
(45, 'base', 'date_field_format', 'mdy', 'تنسيق التاريخ'),
(47, 'base', 'mail_smtp_host', 'المستضيف', 'مستضيف Smtp'),
(48, 'base', 'mail_smtp_user', 'إسم المستخدم', 'مستخدم Smtp'),
(49, 'base', 'mail_smtp_password', 'كلمة السر', 'كلمة سر Smtp'),
(50, 'base', 'mail_smtp_port', 'المنفذ', 'منفذ Smtp'),
(51, 'base', 'mail_smtp_connection_prefix', '', 'بادئة إتصال Smpt (tsl, ssl)'),
(56, 'base', 'splash_screen', '0', NULL),
(57, 'base', 'who_can_join', '1', NULL),
(58, 'base', 'who_can_invite', '1', NULL),
(59, 'base', 'guests_can_view', '1', NULL),
(61, 'base', 'guests_can_view_password', '', NULL),
(62, 'base', 'splash_leave_url', 'http://wall.fm/', NULL),
(70, 'base', 'maintenance', '0', NULL),
(69, 'base', 'mandatory_user_approve', '0', 'mandatory_user_approve'),
(74, 'base', 'billing_currency', 'USD', 'Site currency 3-char code'),
(78, 'base', 'tf_allow_pic_upload', '1', NULL),
(79, 'base', 'tf_max_pic_size', '2.500000', NULL),
(80, 'base', 'soft_build', '4890', 'إصدار البرمجية الحالي'),
(81, 'base', 'update_soft', '0', 'علم تحديث أساس البرمجية'),
(85, 'base', 'unverify_site_email', '', 'عنوان البريد الإلكتروني والذي منه سوف يستلم المستخدمون التبليغات والبريد الجماعي.'),
(115, 'base', 'soft_version', '1.3.2', NULL),
(139, 'base', 'site_installed', '0', NULL),
(140, 'base', 'check_mupdates_ts', '0', 'آخر تحقق زمني للتحديثات اليدوية.'),
(676, 'contact_importer', 'yahoo_consumer_key', '', ''),
(674, 'contact_importer', 'facebook_app_secret', '', ''),
(179, 'admin', 'mass_mailing_timestamp', '0', NULL),
(200, 'base', 'dev_mode', '0', NULL),
(228, 'chuppochat', 'network_email', 'qw11888887@qw.com', 'بريد مدير الشبكة الالكتروني'),
(225, 'chuppochat', 'info_questions', '', 'أسئلة معلومات المستخدم'),
(226, 'chuppochat', 'gender_icon_assoc', '{"question":"sex","assoc":{"1":"male","2":"female"}}', 'أيقونة الجنس'),
(227, 'chuppochat', 'network_user', 'qwe', 'إسم المستخدم لمدير الشبكة'),
(229, 'chuppochat', 'network_key', 'foo', 'مفتاح الشبكة'),
(241, 'base', 'default_avatar', '[]', 'الصورة الرمزية الإفتراضية'),
(249, 'base', 'language_switch_allowed', '1', 'السماح للمستخدمين تبديل اللغات في الموقع'),
(276, 'base', 'rss_loading', '0', NULL),
(277, 'base', 'cron_is_active', '1', 'العلم يظهر إذا ما كان سكريبت كرون مفعلاً بعد تثبيت البرمجية'),
(675, 'contact_importer', 'yahoo_app_id', '', ''),
(673, 'contact_importer', 'facebook_api_key', '', ''),
(348, 'base', 'users_count_on_page', '30', 'عدد المستخدمين في الصفحة'),
(367, 'base', 'join_display_photo_upload', 'display', 'عرض حقل ''رفع الصور'' في صفحة الإشتراك.'),
(368, 'base', 'join_photo_upload_set_required', '1', 'جعل ''رفع الصور'' حقلاً مطلوباً في صفحة الإشتراك.'),
(369, 'base', 'join_display_terms_of_use', NULL, 'عرض حقل ''شروط الإستخدام'' في صفحة الإشتراك.'),
(448, 'base', 'favicon', '1', NULL),
(404, 'base', 'html_head_code', '', 'الكود (meta, css, js) يضاف من لوحة المدير داخل قسم الرأسية لوثيقة HTML.'),
(405, 'base', 'html_prebody_code', '', 'الكود (js) يضاف قبل وسم الإغلاق ''body''.'),
(678, 'contact_importer', 'yahoo_consumer_secret', '', ''),
(444, 'base', 'tf_user_custom_html_disable', '1', NULL),
(445, 'base', 'tf_user_rich_media_disable', '0', NULL),
(446, 'base', 'tf_comments_rich_media_disable', '0', NULL),
(447, 'base', 'tf_resource_list', '["clipfish.de","youtube.com","google.com","metacafe.com","myspace.com","novamov.com","myvideo.de"]', NULL),
(677, 'contact_importer', 'yahoo_domain_verification_file', '', ''),
(683, 'base', 'cachedEntitiesPostfix', '4f686d3066acc', NULL);

CREATE TABLE `%%TBL-PREFIX%%base_cron_job` (
  `id` int(11) NOT NULL auto_increment,
  `methodName` varchar(200) NOT NULL default '',
  `runStamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `className` (`methodName`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_db_cache` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `value` mediumtext NOT NULL,
  `expireStamp` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_document` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(255) NOT NULL,
  `class` varchar(255) default NULL,
  `action` varchar(255) default NULL,
  `uri` varchar(255) default NULL,
  `isStatic` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `key` (`key`),
  UNIQUE KEY `uriIndex` (`uri`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_document` (`id`, `key`, `class`, `action`, `uri`, `isStatic`) VALUES
(1, 'base_static_1', NULL, NULL, 'static/my-new-page', 1),
(2, 'base_static_5', NULL, NULL, 'my-page-2', 1),
(3, 'admin_pages', 'ADMIN_Pages', 'index', NULL, 0),
(23, 'page-679283', NULL, NULL, 'join', 1),
(39, 'page-119658', NULL, NULL, 'terms-of-use', 1),
(50, 'page_109195700', NULL, NULL, 'mmm', 1);

CREATE TABLE `%%TBL-PREFIX%%base_email_verify` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(10) NOT NULL default '0',
  `type` enum('user','site') NOT NULL,
  `email` varchar(128) NOT NULL,
  `hash` varchar(32) NOT NULL,
  `createStamp` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`),
  UNIQUE KEY `hash` (`hash`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_entity_tag` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `entityId` int(10) unsigned NOT NULL,
  `entityType` varchar(255) NOT NULL,
  `tagId` int(10) unsigned NOT NULL,
  `active` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `entityId` (`entityId`),
  KEY `entityType` (`entityType`),
  KEY `tagId` (`tagId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_flag` (
  `id` int(11) NOT NULL auto_increment,
  `type` varchar(50) default NULL,
  `entityId` int(11) default NULL,
  `userId` int(11) default NULL,
  `reason` varchar(50) default NULL,
  `title` varchar(100) default NULL,
  `url` varchar(100) default NULL,
  `timestamp` int(11) default NULL,
  `langKey` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `type` (`type`,`entityId`,`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_geolocation_country` (
  `id` int(11) NOT NULL auto_increment,
  `cc2` char(2) NOT NULL,
  `cc3` char(3) NOT NULL,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_geolocation_country` (`id`, `cc2`, `cc3`, `name`) VALUES
(1, 'AW', 'ABW', 'أروبا'),
(2, 'AF', 'AFG', 'أفغانستان'),
(3, 'AO', 'AGO', 'أنغولا'),
(4, 'AI', 'AIA', 'أنغيلا'),
(5, 'AL', 'ALB', 'ألبانيا'),
(6, 'AD', 'AND', 'أندورا'),
(7, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(8, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(9, 'AR', 'ARG', 'الأرجنتين'),
(10, 'AM', 'ARM', 'أرمينيا'),
(11, 'AS', 'ASM', 'ساموا الأمريكية'),
(12, 'AQ', 'ATA', 'أنتاركتيكا'),
(13, 'TF', 'ATF', 'الأقاليم الجنوبية الفرنسية'),
(14, 'AG', 'ATG', 'انتيغوا وبربودا'),
(15, 'AU', 'AUS', 'أستراليا'),
(16, 'AT', 'AUT', 'النمسا'),
(17, 'AZ', 'AZE', 'أذربيجان'),
(18, 'BI', 'BDI', 'بوروندي'),
(19, 'BE', 'BEL', 'بلجيكا'),
(20, 'BJ', 'BEN', 'بنين'),
(21, 'BF', 'BFA', 'بوركينا فاسو'),
(22, 'BD', 'BGD', 'بنغالاديش'),
(23, 'BG', 'BGR', 'بلغاريا'),
(24, 'BH', 'BHR', 'البحرين'),
(25, 'BS', 'BHS', 'جزر البهاما'),
(26, 'BA', 'BIH', 'البوسنه والهرسك'),
(27, 'BY', 'BLR', 'روسيا البيضاء'),
(28, 'BZ', 'BLZ', 'بليز'),
(29, 'BM', 'BMU', 'برمودا'),
(30, 'BO', 'BOL', 'بوليفيا'),
(31, 'BR', 'BRA', 'البرازيل'),
(32, 'BB', 'BRB', 'باربادوس'),
(33, 'BN', 'BRN', 'بروناي دار السلام'),
(34, 'BT', 'BTN', 'بوتان'),
(35, 'BV', 'BVT', 'جزيرة بوفيت'),
(36, 'BW', 'BWA', 'بوتسوانا'),
(37, 'CF', 'CAF', 'جمهورية أفريقيا الوسطى'),
(38, 'CA', 'CAN', 'كندا'),
(39, 'CH', 'CHE', 'سويسرا'),
(40, 'CL', 'CHL', 'تشيلي'),
(41, 'CN', 'CHN', 'الصين'),
(42, 'CI', 'CIV', 'كوت ديفوار'),
(43, 'CM', 'CMR', 'الكاميرون'),
(44, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(45, 'CG', 'COG', 'الكونغو'),
(46, 'CK', 'COK', 'جزر كوك'),
(47, 'CO', 'COL', 'كولومبيا'),
(48, 'KM', 'COM', 'جزر القمر'),
(49, 'CV', 'CPV', 'الرأس الأخضر'),
(50, 'CR', 'CRI', 'كوستا ريكا'),
(51, 'CU', 'CUB', 'كوبا'),
(52, 'KY', 'CYM', 'جزر كايمان'),
(53, 'CY', 'CYP', 'قبرص'),
(54, 'CZ', 'CZE', 'التشيك'),
(55, 'DE', 'DEU', 'ألمانيا'),
(56, 'DJ', 'DJI', 'جيبوتي'),
(57, 'DM', 'DMA', 'دومينيكا'),
(58, 'DK', 'DNK', 'الدنيمارك'),
(59, 'DO', 'DOM', 'الدومينيكان'),
(60, 'DZ', 'DZA', 'الجزائر'),
(61, 'EC', 'ECU', 'الإكوادور'),
(62, 'EG', 'EGY', 'مصر'),
(63, 'ER', 'ERI', 'إريتريا'),
(64, 'ES', 'ESP', 'إسبانيا'),
(65, 'EE', 'EST', 'إستونيا'),
(66, 'ET', 'ETH', 'إثيوبيا'),
(67, 'FI', 'FIN', 'فنلندا'),
(68, 'FJ', 'FJI', 'فيجي'),
(69, 'FK', 'FLK', 'جزر فوكلاند (مالفيناس)'),
(70, 'FR', 'FRA', 'فرنسا'),
(71, 'FO', 'FRO', 'جزر فارو'),
(72, 'FM', 'FSM', 'ولايات ميكرونيزيا الموحدة'),
(73, 'GA', 'GAB', 'الغابون'),
(74, 'GB', 'GBR', 'المملكة المتحدة'),
(75, 'GE', 'GEO', 'جورجيا'),
(76, 'GG', 'GGY', 'غيرنسي'),
(77, 'GH', 'GHA', 'غانا'),
(78, 'GI', 'GIB', 'جبل طارق'),
(79, 'GN', 'GIN', 'غينيا'),
(80, 'GP', 'GLP', 'جوادلوب'),
(81, 'GM', 'GMB', 'غامبيا'),
(82, 'GW', 'GNB', 'غينيا بيساو'),
(83, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(84, 'GR', 'GRC', 'اليونان'),
(85, 'GD', 'GRD', 'غرينادا'),
(86, 'GL', 'GRL', 'غرينلاند'),
(87, 'GT', 'GTM', 'غواتيمالا'),
(88, 'GF', 'GUF', 'غيانا الفرنسية'),
(89, 'GU', 'GUM', 'غوام'),
(90, 'GY', 'GUY', 'غيانا'),
(91, 'HK', 'HKG', 'هونغ كونغ'),
(92, 'HN', 'HND', 'هندوراس'),
(93, 'HR', 'HRV', 'كرواتيا'),
(94, 'HT', 'HTI', 'هايتي'),
(95, 'HU', 'HUN', 'هنغاريا'),
(96, 'ID', 'IDN', 'إندونيسيا'),
(97, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(98, 'IN', 'IND', 'الهند'),
(99, 'IO', 'IOT', 'إقليم المحيط الهندي البريطاني'),
(100, 'IE', 'IRL', 'إيرلندا'),
(101, 'IR', 'IRN', 'إيران'),
(102, 'IQ', 'IRQ', 'العراق'),
(103, 'IS', 'ISL', 'أيسلندا'),
(104, 'IL', 'ISR', 'إسرائيل'),
(105, 'IT', 'ITA', 'إيطاليا'),
(106, 'JM', 'JAM', 'جامايكا'),
(107, 'JE', 'JEY', 'جيرسي'),
(108, 'JO', 'JOR', 'الأردن'),
(109, 'JP', 'JPN', 'اليابان'),
(110, 'KZ', 'KAZ', 'كازاخستان'),
(111, 'KE', 'KEN', 'كينيا'),
(112, 'KG', 'KGZ', 'قيرغيزستان'),
(113, 'KH', 'KHM', 'كامبوديا'),
(114, 'KI', 'KIR', 'كيريباتي'),
(115, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(116, 'KR', 'KOR', 'جمهورية كوريا'),
(117, 'KW', 'KWT', 'الكويت'),
(118, 'LA', 'LAO', 'لاو'),
(119, 'LB', 'LBN', 'لبنان'),
(120, 'LR', 'LBR', 'ليبيريا'),
(121, 'LY', 'LBY', 'ليبيا'),
(122, 'LC', 'LCA', 'سانت لوسيا'),
(123, 'LI', 'LIE', 'ليختنشتاين'),
(124, 'LK', 'LKA', 'سيريلانكا'),
(125, 'LS', 'LSO', 'ليسوتو'),
(126, 'LT', 'LTU', 'ليتوانيا'),
(127, 'LU', 'LUX', 'لوكسيمبورغ'),
(128, 'LV', 'LVA', 'لاتفيا'),
(129, 'MO', 'MAC', 'ماكاو'),
(130, 'MF', 'MAF', 'سانت مارتن'),
(131, 'MA', 'MAR', 'المغرب'),
(132, 'MC', 'MCO', 'موناكو'),
(133, 'MD', 'MDA', 'مولدوفا'),
(134, 'MG', 'MDG', 'مدغشقر'),
(135, 'MV', 'MDV', 'جزر المالديف'),
(136, 'MX', 'MEX', 'المكسيك'),
(137, 'MH', 'MHL', 'جزر مارشال'),
(138, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(139, 'ML', 'MLI', 'مالي'),
(140, 'MT', 'MLT', 'مالطا'),
(141, 'MM', 'MMR', 'ميانمار'),
(142, 'ME', 'MNE', 'الجبل الأسود'),
(143, 'MN', 'MNG', 'منغوليا'),
(144, 'MP', 'MNP', 'جزر ماريانا الشمالية'),
(145, 'MZ', 'MOZ', 'موزامبيق'),
(146, 'MR', 'MRT', 'موريتانيا'),
(147, 'MS', 'MSR', 'مونتسيرات'),
(148, 'MQ', 'MTQ', 'مارتينيك'),
(149, 'MU', 'MUS', 'موريشيوس'),
(150, 'MW', 'MWI', 'ملاوي'),
(151, 'MY', 'MYS', 'ماليزيا'),
(152, 'YT', 'MYT', 'مايوت'),
(153, 'NA', 'NAM', 'ناميبيا'),
(154, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(155, 'NE', 'NER', 'النيجر'),
(156, 'NF', 'NFK', 'جزيرة نورفولك'),
(157, 'NG', 'NGA', 'نيجيريا'),
(158, 'NI', 'NIC', 'نيكاراغوا'),
(159, 'NU', 'NIU', 'نيوي'),
(160, 'NL', 'NLD', 'هولندا'),
(161, 'NO', 'NOR', 'النرويج'),
(162, 'NP', 'NPL', 'نيبال'),
(163, 'NR', 'NRU', 'ناورو'),
(164, 'NZ', 'NZL', 'نيوزيلاندا'),
(165, 'OM', 'OMN', 'عمان'),
(166, 'PK', 'PAK', 'باكستان'),
(167, 'PA', 'PAN', 'بنما'),
(168, 'PE', 'PER', 'بيرو'),
(169, 'PH', 'PHL', 'الفلبين'),
(170, 'PW', 'PLW', 'بالاو'),
(171, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(172, 'PL', 'POL', 'بولندا'),
(173, 'PR', 'PRI', 'بورتو ريكو'),
(174, 'KP', 'PRK', 'جمهورية كوريا الشعبية الديمقراطية'),
(175, 'PT', 'PRT', 'البورتوغال'),
(176, 'PY', 'PRY', 'باراغواي'),
(177, 'PS', 'PSE', 'فلسطين المحتلة'),
(178, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(179, 'QA', 'QAT', 'قطر'),
(180, 'RE', 'REU', 'ريونيون'),
(181, 'RO', 'ROM', 'رومانيا'),
(182, 'RU', 'RUS', 'الإتحاد الروسي'),
(183, 'RW', 'RWA', 'رواندا'),
(184, 'SA', 'SAU', 'السعودية'),
(185, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(186, 'SD', 'SDN', 'السودان'),
(187, 'SN', 'SEN', 'السنغال'),
(188, 'SG', 'SGP', 'سنغافورة'),
(189, 'GS', 'SGS', 'جورجيا الجنوبية وجزر ساندويتش الجنوبية'),
(190, 'SB', 'SLB', 'جزر سليمان'),
(191, 'SL', 'SLE', 'سيراليون'),
(192, 'SV', 'SLV', 'السلفادور'),
(193, 'SM', 'SMR', 'سان مارينو'),
(194, 'SO', 'SOM', 'الصومال'),
(195, 'PM', 'SPM', 'سان بيار وميكلون'),
(196, 'RS', 'SRB', 'صربيا'),
(197, 'ST', 'STP', 'ساو تومي وبرينسيبي'),
(198, 'SR', 'SUR', 'سورينام'),
(199, 'SK', 'SVK', 'سلوفاكيا'),
(200, 'SI', 'SVN', 'سلوفينيا'),
(201, 'SE', 'SWE', 'السويد'),
(202, 'SZ', 'SWZ', 'سوازيلند'),
(203, 'SC', 'SYC', 'سيشيل'),
(204, 'SY', 'SYR', 'سوريا'),
(205, 'TC', 'TCA', 'جزر تركس وكايكوس'),
(206, 'TD', 'TCD', 'تشاد'),
(207, 'TG', 'TGO', 'توغو'),
(208, 'TH', 'THA', 'تايلند'),
(209, 'TJ', 'TJK', 'طاجيكيستان'),
(210, 'TK', 'TKL', 'توكيلاو'),
(211, 'TM', 'TKM', 'تركمينيستان'),
(212, 'TL', 'TLS', 'تيمور الشرقية'),
(213, 'TO', 'TON', 'تونغا'),
(214, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(215, 'TN', 'TUN', 'تونس'),
(216, 'TR', 'TUR', 'تركيا'),
(217, 'TV', 'TUV', 'توفالو'),
(218, 'TW', 'TWN', 'تايوان'),
(219, 'TZ', 'TZA', 'تانزانيا'),
(220, 'UG', 'UGA', 'أوغاندا'),
(221, 'UA', 'UKR', 'أوكرانيا'),
(222, 'UM', 'UMI', 'جزر الولايات المتحدة البعيدة الصغيرة'),
(223, 'UY', 'URY', 'الأوروغواي'),
(224, 'US', 'USA', 'الولايات المتحدة'),
(225, 'UZ', 'UZB', 'أوزباكستان'),
(226, 'VA', 'VAT', 'دولة الفاتيكان'),
(227, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(228, 'VE', 'VEN', 'فنزويلا'),
(229, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(230, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(231, 'VN', 'VNM', 'فييتنام'),
(232, 'VU', 'VUT', 'فانواتو'),
(233, 'WF', 'WLF', 'واليس وفوتونا'),
(234, 'WS', 'WSM', 'ساموا'),
(235, 'YE', 'YEM', 'اليمن'),
(236, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(237, 'ZM', 'ZMB', 'زامبيا'),
(238, 'ZW', 'ZWE', 'زمبابواي');

CREATE TABLE `%%TBL-PREFIX%%base_geolocation_ip_to_country` (
  `id` int(11) NOT NULL auto_increment,
  `ipFrom` int(10) unsigned zerofill NOT NULL,
  `ipTo` int(10) unsigned zerofill NOT NULL,
  `cc2` char(2) NOT NULL,
  `cc3` char(3) NOT NULL,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `ipTo` (`ipTo`),
  KEY `ipFrom` (`ipFrom`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(1, 0016777216, 0033554431, 'AU', 'AUS', 'أستراليا'),
(2, 0040894464, 0041418751, 'IT', 'ITA', 'إيطاليا'),
(3, 0041418752, 0041943039, 'GB', 'GBR', 'المملكة المتحدة'),
(4, 0050331648, 0069956103, 'US', 'USA', 'الولايات المتحدة'),
(5, 0069956104, 0069956111, 'BM', 'BMU', 'برمودا'),
(6, 0069956112, 0072349055, 'US', 'USA', 'الولايات المتحدة'),
(7, 0072349056, 0072349119, 'BM', 'BMU', 'برمودا'),
(8, 0072349120, 0083886079, 'US', 'USA', 'الولايات المتحدة'),
(9, 0100663296, 0121195295, 'US', 'USA', 'الولايات المتحدة'),
(10, 0121195296, 0121195327, 'IT', 'ITA', 'إيطاليا'),
(11, 0121195328, 0134693119, 'US', 'USA', 'الولايات المتحدة'),
(12, 0134693120, 0134693375, 'CA', 'CAN', 'كندا'),
(13, 0134693376, 0134730239, 'US', 'USA', 'الولايات المتحدة'),
(14, 0134730240, 0134730495, 'CA', 'CAN', 'كندا'),
(15, 0134730496, 0152305663, 'US', 'USA', 'الولايات المتحدة'),
(16, 0152305664, 0152338431, 'GB', 'GBR', 'المملكة المتحدة'),
(17, 0152338432, 0167772159, 'US', 'USA', 'الولايات المتحدة'),
(18, 0184549376, 0201636503, 'US', 'USA', 'الولايات المتحدة'),
(19, 0201636504, 0201636511, 'PR', 'PRI', 'بورتو ريكو'),
(20, 0201636512, 0201859071, 'US', 'USA', 'الولايات المتحدة'),
(21, 0201859072, 0201859087, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(22, 0201859088, 0201897983, 'US', 'USA', 'الولايات المتحدة'),
(23, 0201897984, 0201898239, 'PR', 'PRI', 'بورتو ريكو'),
(24, 0201898240, 0202296847, 'US', 'USA', 'الولايات المتحدة'),
(25, 0202296848, 0202296855, 'PR', 'PRI', 'بورتو ريكو'),
(26, 0202296856, 0202385407, 'US', 'USA', 'الولايات المتحدة'),
(27, 0202385408, 0202385919, 'PR', 'PRI', 'بورتو ريكو'),
(28, 0202385920, 0202621343, 'US', 'USA', 'الولايات المتحدة'),
(29, 0202621344, 0202621351, 'PR', 'PRI', 'بورتو ريكو'),
(30, 0202621352, 0202621431, 'US', 'USA', 'الولايات المتحدة'),
(31, 0202621432, 0202621439, 'PR', 'PRI', 'بورتو ريكو'),
(32, 0202621440, 0202621479, 'US', 'USA', 'الولايات المتحدة'),
(33, 0202621480, 0202621487, 'PR', 'PRI', 'بورتو ريكو'),
(34, 0202621488, 0202621495, 'US', 'USA', 'الولايات المتحدة'),
(35, 0202621496, 0202621503, 'PR', 'PRI', 'بورتو ريكو'),
(36, 0202621504, 0202621703, 'US', 'USA', 'الولايات المتحدة'),
(37, 0202621704, 0202621711, 'PR', 'PRI', 'بورتو ريكو'),
(38, 0202621712, 0202625287, 'US', 'USA', 'الولايات المتحدة'),
(39, 0202625288, 0202625295, 'PR', 'PRI', 'بورتو ريكو'),
(40, 0202625296, 0202696783, 'US', 'USA', 'الولايات المتحدة'),
(41, 0202696784, 0202696791, 'PR', 'PRI', 'بورتو ريكو'),
(42, 0202696792, 0202706431, 'US', 'USA', 'الولايات المتحدة'),
(43, 0202706432, 0202706943, 'PR', 'PRI', 'بورتو ريكو'),
(44, 0202706944, 0202934671, 'US', 'USA', 'الولايات المتحدة'),
(45, 0202934672, 0202934687, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(46, 0202934688, 0202935551, 'US', 'USA', 'الولايات المتحدة'),
(47, 0202935552, 0202935807, 'PR', 'PRI', 'بورتو ريكو'),
(48, 0202935808, 0202938479, 'US', 'USA', 'الولايات المتحدة'),
(49, 0202938480, 0202938495, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(50, 0202938496, 0203625391, 'US', 'USA', 'الولايات المتحدة'),
(51, 0203625392, 0203625399, 'PR', 'PRI', 'بورتو ريكو'),
(52, 0203625400, 0203658303, 'US', 'USA', 'الولايات المتحدة'),
(53, 0203658304, 0203658367, 'PR', 'PRI', 'بورتو ريكو'),
(54, 0203658368, 0203658415, 'US', 'USA', 'الولايات المتحدة'),
(55, 0203658416, 0203658423, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(56, 0203658424, 0203658751, 'US', 'USA', 'الولايات المتحدة'),
(57, 0203658752, 0203658831, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(58, 0203658832, 0203658847, 'US', 'USA', 'الولايات المتحدة'),
(59, 0203658848, 0203658879, 'PR', 'PRI', 'بورتو ريكو'),
(60, 0203658880, 0203658927, 'US', 'USA', 'الولايات المتحدة'),
(61, 0203658928, 0203658951, 'PR', 'PRI', 'بورتو ريكو'),
(62, 0203658952, 0203658967, 'US', 'USA', 'الولايات المتحدة'),
(63, 0203658968, 0203658991, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(64, 0203658992, 0203659039, 'US', 'USA', 'الولايات المتحدة'),
(65, 0203659040, 0203659095, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(66, 0203659096, 0204047103, 'US', 'USA', 'الولايات المتحدة'),
(67, 0204047104, 0204047119, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(68, 0204047120, 0204047231, 'US', 'USA', 'الولايات المتحدة'),
(69, 0204047232, 0204047247, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(70, 0204047248, 0204047255, 'US', 'USA', 'الولايات المتحدة'),
(71, 0204047256, 0204047263, 'PR', 'PRI', 'بورتو ريكو'),
(72, 0204047264, 0204047295, 'US', 'USA', 'الولايات المتحدة'),
(73, 0204047296, 0204047303, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(74, 0204047304, 0204047311, 'US', 'USA', 'الولايات المتحدة'),
(75, 0204047312, 0204047335, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(76, 0204047336, 0204047431, 'US', 'USA', 'الولايات المتحدة'),
(77, 0204047432, 0204047455, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(78, 0204047456, 0204047463, 'US', 'USA', 'الولايات المتحدة'),
(79, 0204047464, 0204047479, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(80, 0204047480, 0204047487, 'US', 'USA', 'الولايات المتحدة'),
(81, 0204047488, 0204047535, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(82, 0204047536, 0204047551, 'PR', 'PRI', 'بورتو ريكو'),
(83, 0204047552, 0204047559, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(84, 0204047560, 0204047567, 'PR', 'PRI', 'بورتو ريكو'),
(85, 0204047568, 0204047591, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(86, 0204047592, 0204047615, 'PR', 'PRI', 'بورتو ريكو'),
(87, 0204047616, 0204047999, 'US', 'USA', 'الولايات المتحدة'),
(88, 0204048000, 0204048007, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(89, 0204048008, 0204048015, 'US', 'USA', 'الولايات المتحدة'),
(90, 0204048016, 0204048031, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(91, 0204048032, 0204048055, 'PR', 'PRI', 'بورتو ريكو'),
(92, 0204048056, 0204048063, 'US', 'USA', 'الولايات المتحدة'),
(93, 0204048064, 0204048127, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(94, 0204048128, 0204126151, 'US', 'USA', 'الولايات المتحدة'),
(95, 0204126152, 0204126159, 'PR', 'PRI', 'بورتو ريكو'),
(96, 0204126160, 0204152831, 'US', 'USA', 'الولايات المتحدة'),
(97, 0204152832, 0204153855, 'PR', 'PRI', 'بورتو ريكو'),
(98, 0204153856, 0205500987, 'US', 'USA', 'الولايات المتحدة'),
(99, 0205500988, 0205500991, 'CA', 'CAN', 'كندا'),
(100, 0205500992, 0205813063, 'US', 'USA', 'الولايات المتحدة'),
(101, 0205813064, 0205813071, 'PR', 'PRI', 'بورتو ريكو'),
(102, 0205813072, 0205953311, 'US', 'USA', 'الولايات المتحدة'),
(103, 0205953312, 0205953319, 'PR', 'PRI', 'بورتو ريكو'),
(104, 0205953320, 0205953327, 'US', 'USA', 'الولايات المتحدة'),
(105, 0205953328, 0205953351, 'PR', 'PRI', 'بورتو ريكو'),
(106, 0205953352, 0209965359, 'US', 'USA', 'الولايات المتحدة'),
(107, 0209965360, 0209965367, 'PR', 'PRI', 'بورتو ريكو'),
(108, 0209965368, 0210022479, 'US', 'USA', 'الولايات المتحدة'),
(109, 0210022480, 0210022487, 'PR', 'PRI', 'بورتو ريكو'),
(110, 0210022488, 0210784255, 'US', 'USA', 'الولايات المتحدة'),
(111, 0210784256, 0210784383, 'BO', 'BOL', 'بوليفيا'),
(112, 0210784384, 0210784767, 'US', 'USA', 'الولايات المتحدة'),
(113, 0210784768, 0210786303, 'BO', 'BOL', 'بوليفيا'),
(114, 0210786304, 0211410031, 'US', 'USA', 'الولايات المتحدة'),
(115, 0211410032, 0211410039, 'PR', 'PRI', 'بورتو ريكو'),
(116, 0211410040, 0211410119, 'US', 'USA', 'الولايات المتحدة'),
(117, 0211410120, 0211410135, 'PR', 'PRI', 'بورتو ريكو'),
(118, 0211410136, 0211595575, 'US', 'USA', 'الولايات المتحدة'),
(119, 0211595576, 0211595583, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(120, 0211595584, 0211595615, 'US', 'USA', 'الولايات المتحدة'),
(121, 0211595616, 0211595623, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(122, 0211595624, 0211595639, 'PR', 'PRI', 'بورتو ريكو'),
(123, 0211595640, 0211596823, 'US', 'USA', 'الولايات المتحدة'),
(124, 0211596824, 0211596831, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(125, 0211596832, 0211597055, 'US', 'USA', 'الولايات المتحدة'),
(126, 0211597056, 0211597071, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(127, 0211597072, 0211597375, 'US', 'USA', 'الولايات المتحدة'),
(128, 0211597376, 0211597439, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(129, 0211597440, 0211597719, 'US', 'USA', 'الولايات المتحدة'),
(130, 0211597720, 0211597727, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(131, 0211597728, 0211597743, 'PR', 'PRI', 'بورتو ريكو'),
(132, 0211597744, 0211597759, 'US', 'USA', 'الولايات المتحدة'),
(133, 0211597760, 0211597775, 'PR', 'PRI', 'بورتو ريكو'),
(134, 0211597776, 0211597791, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(135, 0211597792, 0211598399, 'US', 'USA', 'الولايات المتحدة'),
(136, 0211598400, 0211598463, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(137, 0211598464, 0211598639, 'US', 'USA', 'الولايات المتحدة'),
(138, 0211598640, 0211598655, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(139, 0211598656, 0211654127, 'US', 'USA', 'الولايات المتحدة'),
(140, 0211654128, 0211654135, 'PR', 'PRI', 'بورتو ريكو'),
(141, 0211654136, 0212105495, 'US', 'USA', 'الولايات المتحدة'),
(142, 0212105496, 0212105503, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(143, 0212105504, 0212122039, 'US', 'USA', 'الولايات المتحدة'),
(144, 0212122040, 0212122047, 'PR', 'PRI', 'بورتو ريكو'),
(145, 0212122048, 0212733527, 'US', 'USA', 'الولايات المتحدة'),
(146, 0212733528, 0212733535, 'PR', 'PRI', 'بورتو ريكو'),
(147, 0212733536, 0212787199, 'US', 'USA', 'الولايات المتحدة'),
(148, 0212787200, 0212788223, 'PR', 'PRI', 'بورتو ريكو'),
(149, 0212788224, 0212788479, 'US', 'USA', 'الولايات المتحدة'),
(150, 0212788480, 0212788607, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(151, 0212788608, 0212788631, 'US', 'USA', 'الولايات المتحدة'),
(152, 0212788632, 0212788639, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(153, 0212788640, 0212788655, 'US', 'USA', 'الولايات المتحدة'),
(154, 0212788656, 0212788663, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(155, 0212788664, 0212788807, 'US', 'USA', 'الولايات المتحدة'),
(156, 0212788808, 0212788815, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(157, 0212788816, 0212788863, 'US', 'USA', 'الولايات المتحدة'),
(158, 0212788864, 0212788991, 'PR', 'PRI', 'بورتو ريكو'),
(159, 0212788992, 0212789039, 'US', 'USA', 'الولايات المتحدة'),
(160, 0212789040, 0212789055, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(161, 0212789056, 0212789063, 'PR', 'PRI', 'بورتو ريكو'),
(162, 0212789064, 0212789079, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(163, 0212789080, 0212789087, 'US', 'USA', 'الولايات المتحدة'),
(164, 0212789088, 0212789095, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(165, 0212789096, 0212789111, 'US', 'USA', 'الولايات المتحدة'),
(166, 0212789112, 0212789119, 'PR', 'PRI', 'بورتو ريكو'),
(167, 0212789120, 0212789127, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(168, 0212789128, 0212789143, 'US', 'USA', 'الولايات المتحدة'),
(169, 0212789144, 0212789151, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(170, 0212789152, 0212789183, 'US', 'USA', 'الولايات المتحدة'),
(171, 0212789184, 0212789191, 'PR', 'PRI', 'بورتو ريكو'),
(172, 0212789192, 0212789215, 'US', 'USA', 'الولايات المتحدة'),
(173, 0212789216, 0212789223, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(174, 0212789224, 0212791295, 'US', 'USA', 'الولايات المتحدة'),
(175, 0212791296, 0212791447, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(176, 0212791448, 0212791487, 'US', 'USA', 'الولايات المتحدة'),
(177, 0212791488, 0212791807, 'PR', 'PRI', 'بورتو ريكو'),
(178, 0212791808, 0212791815, 'US', 'USA', 'الولايات المتحدة'),
(179, 0212791816, 0212791839, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(180, 0212791840, 0212792271, 'US', 'USA', 'الولايات المتحدة'),
(181, 0212792272, 0212792279, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(182, 0212792280, 0212793167, 'US', 'USA', 'الولايات المتحدة'),
(183, 0212793168, 0212793175, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(184, 0212793176, 0212793199, 'US', 'USA', 'الولايات المتحدة'),
(185, 0212793200, 0212793207, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(186, 0212793208, 0212793215, 'PR', 'PRI', 'بورتو ريكو'),
(187, 0212793216, 0212793343, 'US', 'USA', 'الولايات المتحدة'),
(188, 0212793344, 0212794367, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(189, 0212794368, 0212794575, 'US', 'USA', 'الولايات المتحدة'),
(190, 0212794576, 0212794583, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(191, 0212794584, 0212794783, 'US', 'USA', 'الولايات المتحدة'),
(192, 0212794784, 0212794791, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(193, 0212794792, 0212794799, 'US', 'USA', 'الولايات المتحدة'),
(194, 0212794800, 0212794815, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(195, 0212794816, 0212794879, 'US', 'USA', 'الولايات المتحدة'),
(196, 0212794880, 0212794887, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(197, 0212794888, 0212794895, 'US', 'USA', 'الولايات المتحدة'),
(198, 0212794896, 0212794911, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(199, 0212794912, 0212794943, 'PR', 'PRI', 'بورتو ريكو'),
(200, 0212794944, 0212794975, 'US', 'USA', 'الولايات المتحدة'),
(201, 0212794976, 0212794983, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(202, 0212794984, 0212838527, 'US', 'USA', 'الولايات المتحدة'),
(203, 0212838528, 0212838535, 'PR', 'PRI', 'بورتو ريكو'),
(204, 0212838536, 0212890775, 'US', 'USA', 'الولايات المتحدة'),
(205, 0212890776, 0212890783, 'PR', 'PRI', 'بورتو ريكو'),
(206, 0212890784, 0212900583, 'US', 'USA', 'الولايات المتحدة'),
(207, 0212900584, 0212900591, 'PR', 'PRI', 'بورتو ريكو'),
(208, 0212900592, 0212977063, 'US', 'USA', 'الولايات المتحدة'),
(209, 0212977064, 0212977071, 'PR', 'PRI', 'بورتو ريكو'),
(210, 0212977072, 0213162607, 'US', 'USA', 'الولايات المتحدة'),
(211, 0213162608, 0213162615, 'PR', 'PRI', 'بورتو ريكو'),
(212, 0213162616, 0213498031, 'US', 'USA', 'الولايات المتحدة'),
(213, 0213498032, 0213498039, 'PR', 'PRI', 'بورتو ريكو'),
(214, 0213498040, 0213575847, 'US', 'USA', 'الولايات المتحدة'),
(215, 0213575848, 0213575855, 'PR', 'PRI', 'بورتو ريكو'),
(216, 0213575856, 0213579471, 'US', 'USA', 'الولايات المتحدة'),
(217, 0213579472, 0213579479, 'PR', 'PRI', 'بورتو ريكو'),
(218, 0213579480, 0213608911, 'US', 'USA', 'الولايات المتحدة'),
(219, 0213608912, 0213608919, 'PR', 'PRI', 'بورتو ريكو'),
(220, 0213608920, 0213608927, 'US', 'USA', 'الولايات المتحدة'),
(221, 0213608928, 0213608951, 'PR', 'PRI', 'بورتو ريكو'),
(222, 0213608952, 0213895679, 'US', 'USA', 'الولايات المتحدة'),
(223, 0213895680, 0213895743, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(224, 0213895744, 0213925631, 'US', 'USA', 'الولايات المتحدة'),
(225, 0213925632, 0213925887, 'PR', 'PRI', 'بورتو ريكو'),
(226, 0213925888, 0213936791, 'US', 'USA', 'الولايات المتحدة'),
(227, 0213936792, 0213936799, 'PR', 'PRI', 'بورتو ريكو'),
(228, 0213936800, 0213936871, 'US', 'USA', 'الولايات المتحدة'),
(229, 0213936872, 0213936879, 'PR', 'PRI', 'بورتو ريكو'),
(230, 0213936880, 0213936895, 'US', 'USA', 'الولايات المتحدة'),
(231, 0213936896, 0213936903, 'PR', 'PRI', 'بورتو ريكو'),
(232, 0213936904, 0214187007, 'US', 'USA', 'الولايات المتحدة'),
(233, 0214187008, 0214187775, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(234, 0214187776, 0214187807, 'US', 'USA', 'الولايات المتحدة'),
(235, 0214187808, 0214187815, 'PR', 'PRI', 'بورتو ريكو'),
(236, 0214187816, 0214187895, 'US', 'USA', 'الولايات المتحدة'),
(237, 0214187896, 0214188031, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(238, 0214188032, 0214237247, 'US', 'USA', 'الولايات المتحدة'),
(239, 0214237248, 0214237311, 'PR', 'PRI', 'بورتو ريكو'),
(240, 0214237312, 0214249471, 'US', 'USA', 'الولايات المتحدة'),
(241, 0214249472, 0214253567, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(242, 0214253568, 0214448335, 'US', 'USA', 'الولايات المتحدة'),
(243, 0214448336, 0214448343, 'PR', 'PRI', 'بورتو ريكو'),
(244, 0214448344, 0214697983, 'US', 'USA', 'الولايات المتحدة'),
(245, 0214697984, 0214698007, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(246, 0214698008, 0214698015, 'PR', 'PRI', 'بورتو ريكو'),
(247, 0214698016, 0214698023, 'US', 'USA', 'الولايات المتحدة'),
(248, 0214698024, 0214698031, 'PR', 'PRI', 'بورتو ريكو'),
(249, 0214698032, 0214698095, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(250, 0214698096, 0214698103, 'PR', 'PRI', 'بورتو ريكو'),
(251, 0214698104, 0214698135, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(252, 0214698136, 0214698143, 'PR', 'PRI', 'بورتو ريكو'),
(253, 0214698144, 0214698159, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(254, 0214698160, 0214698239, 'PR', 'PRI', 'بورتو ريكو'),
(255, 0214698240, 0214698271, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(256, 0214698272, 0214698303, 'US', 'USA', 'الولايات المتحدة'),
(257, 0214698304, 0214698319, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(258, 0214698320, 0214698335, 'PR', 'PRI', 'بورتو ريكو'),
(259, 0214698336, 0214698367, 'US', 'USA', 'الولايات المتحدة'),
(260, 0214698368, 0214698375, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(261, 0214698376, 0214698383, 'US', 'USA', 'الولايات المتحدة'),
(262, 0214698384, 0214698639, 'PR', 'PRI', 'بورتو ريكو'),
(263, 0214698640, 0214698655, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(264, 0214698656, 0214699231, 'PR', 'PRI', 'بورتو ريكو'),
(265, 0214699232, 0214699295, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(266, 0214699296, 0214699303, 'US', 'USA', 'الولايات المتحدة'),
(267, 0214699304, 0214699311, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(268, 0214699312, 0214699335, 'PR', 'PRI', 'بورتو ريكو'),
(269, 0214699336, 0214699359, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(270, 0214699360, 0214699383, 'US', 'USA', 'الولايات المتحدة'),
(271, 0214699384, 0214699415, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(272, 0214699416, 0214699519, 'US', 'USA', 'الولايات المتحدة'),
(273, 0214699520, 0214699647, 'PR', 'PRI', 'بورتو ريكو'),
(274, 0214699648, 0214858655, 'US', 'USA', 'الولايات المتحدة'),
(275, 0214858656, 0214858671, 'NL', 'NLD', 'هولندا'),
(276, 0214858672, 0216417663, 'US', 'USA', 'الولايات المتحدة'),
(277, 0216417664, 0216417727, 'PR', 'PRI', 'بورتو ريكو'),
(278, 0216417728, 0216637639, 'US', 'USA', 'الولايات المتحدة'),
(279, 0216637640, 0216637647, 'PR', 'PRI', 'بورتو ريكو'),
(280, 0216637648, 0216820479, 'US', 'USA', 'الولايات المتحدة'),
(281, 0216820480, 0216820487, 'PR', 'PRI', 'بورتو ريكو'),
(282, 0216820488, 0216835615, 'US', 'USA', 'الولايات المتحدة'),
(283, 0216835616, 0216835623, 'PR', 'PRI', 'بورتو ريكو'),
(284, 0216835624, 0216881191, 'US', 'USA', 'الولايات المتحدة'),
(285, 0216881192, 0216881199, 'PR', 'PRI', 'بورتو ريكو'),
(286, 0216881200, 0216996407, 'US', 'USA', 'الولايات المتحدة'),
(287, 0216996408, 0216996415, 'PR', 'PRI', 'بورتو ريكو'),
(288, 0216996416, 0216996543, 'US', 'USA', 'الولايات المتحدة'),
(289, 0216996544, 0216996559, 'PR', 'PRI', 'بورتو ريكو'),
(290, 0216996560, 0217027999, 'US', 'USA', 'الولايات المتحدة'),
(291, 0217028000, 0217028007, 'PR', 'PRI', 'بورتو ريكو'),
(292, 0217028008, 0217046775, 'US', 'USA', 'الولايات المتحدة'),
(293, 0217046776, 0217046783, 'PR', 'PRI', 'بورتو ريكو'),
(294, 0217046784, 0234881023, 'US', 'USA', 'الولايات المتحدة'),
(295, 0234881024, 0251658239, 'AU', 'AUS', 'أستراليا'),
(296, 0251658240, 0260227071, 'FR', 'FRA', 'فرنسا'),
(297, 0260227072, 0260231167, 'GB', 'GBR', 'المملكة المتحدة'),
(298, 0260231168, 0260976639, 'FR', 'FRA', 'فرنسا'),
(299, 0260976640, 0260980735, 'GB', 'GBR', 'المملكة المتحدة'),
(300, 0260980736, 0264482815, 'FR', 'FRA', 'فرنسا'),
(301, 0264482816, 0264486911, 'DE', 'DEU', 'ألمانيا'),
(302, 0264486912, 0264495103, 'FR', 'FRA', 'فرنسا'),
(303, 0264495104, 0264503295, 'CH', 'CHE', 'سويسرا'),
(304, 0264503296, 0264617983, 'FR', 'FRA', 'فرنسا'),
(305, 0264617984, 0264667135, 'DE', 'DEU', 'ألمانيا'),
(306, 0264667136, 0264699903, 'FR', 'FRA', 'فرنسا'),
(307, 0264699904, 0264716287, 'CH', 'CHE', 'سويسرا'),
(308, 0264716288, 0264798207, 'FR', 'FRA', 'فرنسا'),
(309, 0264798208, 0264802303, 'GB', 'GBR', 'المملكة المتحدة'),
(310, 0264802304, 0265023487, 'FR', 'FRA', 'فرنسا'),
(311, 0265023488, 0265027583, 'GB', 'GBR', 'المملكة المتحدة'),
(312, 0265027584, 0265277439, 'FR', 'FRA', 'فرنسا'),
(313, 0265277440, 0265289727, 'GB', 'GBR', 'المملكة المتحدة'),
(314, 0265289728, 0268435455, 'FR', 'FRA', 'فرنسا'),
(315, 0268435456, 0289011535, 'US', 'USA', 'الولايات المتحدة'),
(316, 0289011536, 0289011543, 'IT', 'ITA', 'إيطاليا'),
(317, 0289011544, 0323243895, 'US', 'USA', 'الولايات المتحدة'),
(318, 0323243896, 0323243903, 'FR', 'FRA', 'فرنسا'),
(319, 0323243904, 0332132119, 'US', 'USA', 'الولايات المتحدة'),
(320, 0332132120, 0332132127, 'IL', 'ISR', 'إسرائيل'),
(321, 0332132128, 0355993887, 'US', 'USA', 'الولايات المتحدة'),
(322, 0355993888, 0355993895, 'IT', 'ITA', 'إيطاليا'),
(323, 0355993896, 0368674047, 'US', 'USA', 'الولايات المتحدة'),
(324, 0368674048, 0368674303, 'ES', 'ESP', 'إسبانيا'),
(325, 0368674304, 0385875967, 'US', 'USA', 'الولايات المتحدة'),
(326, 0402653184, 0404684799, 'US', 'USA', 'الولايات المتحدة'),
(327, 0404692992, 0404979711, 'US', 'USA', 'الولايات المتحدة'),
(328, 0405012480, 0405143551, 'CA', 'CAN', 'كندا'),
(329, 0405143552, 0405180415, 'US', 'USA', 'الولايات المتحدة'),
(330, 0405180416, 0405184511, 'CA', 'CAN', 'كندا'),
(331, 0405184512, 0405192703, 'US', 'USA', 'الولايات المتحدة'),
(332, 0405209088, 0405295103, 'US', 'USA', 'الولايات المتحدة'),
(333, 0405299200, 0405331967, 'US', 'USA', 'الولايات المتحدة'),
(334, 0405340160, 0405364735, 'US', 'USA', 'الولايات المتحدة'),
(335, 0405405696, 0405422079, 'PR', 'PRI', 'بورتو ريكو'),
(336, 0405422080, 0405798911, 'US', 'USA', 'الولايات المتحدة'),
(337, 0405831680, 0405843967, 'US', 'USA', 'الولايات المتحدة'),
(338, 0405843968, 0405848063, 'CA', 'CAN', 'كندا'),
(339, 0405848064, 0405864447, 'PR', 'PRI', 'بورتو ريكو'),
(340, 0405864448, 0405909503, 'US', 'USA', 'الولايات المتحدة'),
(341, 0405921792, 0405929983, 'CA', 'CAN', 'كندا'),
(342, 0405929984, 0405938175, 'US', 'USA', 'الولايات المتحدة'),
(343, 0405962752, 0405970943, 'US', 'USA', 'الولايات المتحدة'),
(344, 0406003712, 0406011903, 'US', 'USA', 'الولايات المتحدة'),
(345, 0406044672, 0406052863, 'US', 'USA', 'الولايات المتحدة'),
(346, 0406061056, 0406102015, 'US', 'USA', 'الولايات المتحدة'),
(347, 0406142976, 0406147071, 'US', 'USA', 'الولايات المتحدة'),
(348, 0406147072, 0406151167, 'CA', 'CAN', 'كندا'),
(349, 0406159360, 0406175743, 'US', 'USA', 'الولايات المتحدة'),
(350, 0406183936, 0406188031, 'CA', 'CAN', 'كندا'),
(351, 0406192128, 0406208511, 'CA', 'CAN', 'كندا'),
(352, 0406216704, 0406241279, 'US', 'USA', 'الولايات المتحدة'),
(353, 0406241280, 0406257663, 'PR', 'PRI', 'بورتو ريكو'),
(354, 0406274048, 0406282239, 'PR', 'PRI', 'بورتو ريكو'),
(355, 0406298624, 0406306815, 'PR', 'PRI', 'بورتو ريكو'),
(356, 0406323200, 0406388735, 'US', 'USA', 'الولايات المتحدة'),
(357, 0406388736, 0406454271, 'CA', 'CAN', 'كندا'),
(358, 0406454272, 0406847487, 'US', 'USA', 'الولايات المتحدة'),
(359, 0406847488, 0407408639, 'CA', 'CAN', 'كندا'),
(360, 0407408640, 0407597055, 'US', 'USA', 'الولايات المتحدة'),
(361, 0407601152, 0407605247, 'US', 'USA', 'الولايات المتحدة'),
(362, 0407609344, 0407613439, 'US', 'USA', 'الولايات المتحدة'),
(363, 0407633920, 0408420351, 'CA', 'CAN', 'كندا'),
(364, 0408420352, 0408502271, 'US', 'USA', 'الولايات المتحدة'),
(365, 0408502272, 0408518655, 'CA', 'CAN', 'كندا'),
(366, 0408518656, 0408535039, 'US', 'USA', 'الولايات المتحدة'),
(367, 0408535040, 0408551423, 'CA', 'CAN', 'كندا'),
(368, 0408551424, 0408719359, 'US', 'USA', 'الولايات المتحدة'),
(369, 0408723456, 0409255935, 'US', 'USA', 'الولايات المتحدة'),
(370, 0409272320, 0409337855, 'US', 'USA', 'الولايات المتحدة'),
(371, 0409337856, 0409354239, 'CA', 'CAN', 'كندا'),
(372, 0409370624, 0409509887, 'US', 'USA', 'الولايات المتحدة'),
(373, 0409534464, 0409550847, 'US', 'USA', 'الولايات المتحدة'),
(374, 0409567232, 0409731071, 'US', 'USA', 'الولايات المتحدة'),
(375, 0409731072, 0409862143, 'CA', 'CAN', 'كندا'),
(376, 0409862144, 0410124287, 'US', 'USA', 'الولايات المتحدة'),
(377, 0410124288, 0410189823, 'CA', 'CAN', 'كندا'),
(378, 0410189824, 0410648575, 'US', 'USA', 'الولايات المتحدة'),
(379, 0410648576, 0410714111, 'CA', 'CAN', 'كندا'),
(380, 0410714112, 0411164671, 'US', 'USA', 'الولايات المتحدة'),
(381, 0411164672, 0411168767, 'CA', 'CAN', 'كندا'),
(382, 0411172864, 0411303935, 'US', 'USA', 'الولايات المتحدة'),
(383, 0411303936, 0411369471, 'NL', 'NLD', 'هولندا'),
(384, 0411566080, 0411639807, 'US', 'USA', 'الولايات المتحدة'),
(385, 0411639808, 0411643903, 'CA', 'CAN', 'كندا'),
(386, 0411648000, 0411664383, 'CA', 'CAN', 'كندا'),
(387, 0411664384, 0411680767, 'US', 'USA', 'الولايات المتحدة'),
(388, 0411680768, 0411688959, 'CA', 'CAN', 'كندا'),
(389, 0411697152, 0411717631, 'CA', 'CAN', 'كندا'),
(390, 0411721728, 0411746303, 'CA', 'CAN', 'كندا'),
(391, 0411746304, 0411762687, 'PR', 'PRI', 'بورتو ريكو'),
(392, 0411762688, 0411770879, 'CA', 'CAN', 'كندا'),
(393, 0411770880, 0411779071, 'US', 'USA', 'الولايات المتحدة'),
(394, 0411779072, 0411828223, 'PR', 'PRI', 'بورتو ريكو'),
(395, 0411828224, 0411885567, 'US', 'USA', 'الولايات المتحدة'),
(396, 0411893760, 0411975679, 'CA', 'CAN', 'كندا'),
(397, 0411983872, 0411992063, 'US', 'USA', 'الولايات المتحدة'),
(398, 0412024832, 0412057599, 'US', 'USA', 'الولايات المتحدة'),
(399, 0412073984, 0412221439, 'US', 'USA', 'الولايات المتحدة'),
(400, 0412221440, 0412229631, 'CA', 'CAN', 'كندا'),
(401, 0412286976, 0412483583, 'US', 'USA', 'الولايات المتحدة'),
(402, 0412483584, 0412549119, 'CA', 'CAN', 'كندا'),
(403, 0412549120, 0412614655, 'US', 'USA', 'الولايات المتحدة'),
(404, 0412647424, 0412680191, 'US', 'USA', 'الولايات المتحدة'),
(405, 0412680192, 0412688383, 'CA', 'CAN', 'كندا'),
(406, 0412696576, 0412704767, 'US', 'USA', 'الولايات المتحدة'),
(407, 0412708864, 0412909567, 'US', 'USA', 'الولايات المتحدة'),
(408, 0412909568, 0412917759, 'CA', 'CAN', 'كندا'),
(409, 0412942336, 0412946431, 'US', 'USA', 'الولايات المتحدة'),
(410, 0413007872, 0413908991, 'US', 'USA', 'الولايات المتحدة'),
(411, 0413908992, 0413925375, 'PR', 'PRI', 'بورتو ريكو'),
(412, 0413925376, 0415760383, 'US', 'USA', 'الولايات المتحدة'),
(413, 0415760384, 0416022527, 'CA', 'CAN', 'كندا'),
(414, 0416022528, 0416059391, 'US', 'USA', 'الولايات المتحدة'),
(415, 0416088064, 0416153599, 'US', 'USA', 'الولايات المتحدة'),
(416, 0416153600, 0416161791, 'BS', 'BHS', 'جزر البهاما'),
(417, 0416161792, 0416219135, 'US', 'USA', 'الولايات المتحدة'),
(418, 0416219136, 0416251903, 'CA', 'CAN', 'كندا'),
(419, 0416251904, 0416546815, 'US', 'USA', 'الولايات المتحدة'),
(420, 0416546816, 0416579583, 'CA', 'CAN', 'كندا'),
(421, 0416612352, 0416628735, 'US', 'USA', 'الولايات المتحدة'),
(422, 0416628736, 0416636927, 'CA', 'CAN', 'كندا'),
(423, 0416636928, 0416641023, 'US', 'USA', 'الولايات المتحدة'),
(424, 0416645120, 0416743423, 'US', 'USA', 'الولايات المتحدة'),
(425, 0416743424, 0416776191, 'CA', 'CAN', 'كندا'),
(426, 0416776192, 0417202175, 'US', 'USA', 'الولايات المتحدة'),
(427, 0417202176, 0417267711, 'CA', 'CAN', 'كندا'),
(428, 0417267712, 0417288191, 'US', 'USA', 'الولايات المتحدة'),
(429, 0417292288, 0417366015, 'US', 'USA', 'الولايات المتحدة'),
(430, 0417366016, 0417398783, 'CA', 'CAN', 'كندا'),
(431, 0417398784, 0417427455, 'US', 'USA', 'الولايات المتحدة'),
(432, 0417464320, 0417529855, 'CA', 'CAN', 'كندا'),
(433, 0417529856, 0417538047, 'PR', 'PRI', 'بورتو ريكو'),
(434, 0417538048, 0417775615, 'US', 'USA', 'الولايات المتحدة'),
(435, 0417775616, 0417796095, 'CA', 'CAN', 'كندا'),
(436, 0417796096, 0417800191, 'US', 'USA', 'الولايات المتحدة'),
(437, 0417800192, 0417808383, 'BS', 'BHS', 'جزر البهاما'),
(438, 0417808384, 0417820671, 'CA', 'CAN', 'كندا'),
(439, 0417824768, 0417857535, 'US', 'USA', 'الولايات المتحدة'),
(440, 0417857536, 0417923071, 'AR', 'ARG', 'الأرجنتين'),
(441, 0417923072, 0418062335, 'US', 'USA', 'الولايات المتحدة'),
(442, 0418062336, 0418070527, 'CA', 'CAN', 'كندا'),
(443, 0418070528, 0418074623, 'US', 'USA', 'الولايات المتحدة'),
(444, 0418078720, 0418119679, 'CA', 'CAN', 'كندا'),
(445, 0418119680, 0418316287, 'US', 'USA', 'الولايات المتحدة'),
(446, 0418316288, 0418320383, 'CA', 'CAN', 'كندا'),
(447, 0418324480, 0418643967, 'US', 'USA', 'الولايات المتحدة'),
(448, 0418643968, 0418668543, 'CA', 'CAN', 'كندا'),
(449, 0418668544, 0418672639, 'US', 'USA', 'الولايات المتحدة'),
(450, 0418672640, 0418676735, 'CA', 'CAN', 'كندا'),
(451, 0418676736, 0418687743, 'BS', 'BHS', 'جزر البهاما'),
(452, 0418687744, 0418687998, 'DM', 'DMA', 'دومينيكا'),
(453, 0418687999, 0418693119, 'BS', 'BHS', 'جزر البهاما'),
(454, 0418693120, 0418709503, 'CA', 'CAN', 'كندا'),
(455, 0418709504, 0418766847, 'US', 'USA', 'الولايات المتحدة'),
(456, 0418766848, 0418770943, 'CA', 'CAN', 'كندا'),
(457, 0418807808, 0418832383, 'US', 'USA', 'الولايات المتحدة'),
(458, 0418840576, 0419430399, 'US', 'USA', 'الولايات المتحدة'),
(459, 0419430400, 0436207615, 'GB', 'GBR', 'المملكة المتحدة'),
(460, 0436207616, 0452984831, 'US', 'USA', 'الولايات المتحدة'),
(461, 0452984832, 0452985855, 'AU', 'AUS', 'أستراليا'),
(462, 0452985856, 0452986879, 'MY', 'MYS', 'ماليزيا'),
(463, 0452986880, 0452987903, 'SG', 'SGP', 'سنغافورة'),
(464, 0452987904, 0452988927, 'VN', 'VNM', 'فييتنام'),
(465, 0452988928, 0452997119, 'JP', 'JPN', 'اليابان'),
(466, 0452997120, 0453001215, 'IN', 'IND', 'الهند'),
(467, 0453001216, 0453017599, 'AU', 'AUS', 'أستراليا'),
(468, 0453017600, 0453050367, 'JP', 'JPN', 'اليابان'),
(469, 0453050368, 0453115903, 'KR', 'KOR', 'جمهورية كوريا'),
(470, 0453115904, 0453246975, 'VN', 'VNM', 'فييتنام'),
(471, 0453246976, 0453509119, 'IN', 'IND', 'الهند'),
(472, 0453509120, 0455081983, 'CN', 'CHN', 'الصين'),
(473, 0455081984, 0455213055, 'AU', 'AUS', 'أستراليا'),
(474, 0455213056, 0455245823, 'NP', 'NPL', 'نيبال'),
(475, 0455245824, 0455258111, 'JP', 'JPN', 'اليابان'),
(476, 0455258112, 0455262207, 'SG', 'SGP', 'سنغافورة'),
(477, 0455262208, 0455270399, 'JP', 'JPN', 'اليابان'),
(478, 0455270400, 0455274495, 'AU', 'AUS', 'أستراليا'),
(479, 0455274496, 0455278591, 'IN', 'IND', 'الهند'),
(480, 0455278592, 0455344127, 'KR', 'KOR', 'جمهورية كوريا'),
(481, 0455344128, 0456130559, 'CN', 'CHN', 'الصين'),
(482, 0456130560, 0456261631, 'IN', 'IND', 'الهند'),
(483, 0456261632, 0456262655, 'AU', 'AUS', 'أستراليا'),
(484, 0456262656, 0456263679, 'IN', 'IND', 'الهند'),
(485, 0456263680, 0456264703, 'AU', 'AUS', 'أستراليا'),
(486, 0456264704, 0456265727, 'JP', 'JPN', 'اليابان'),
(487, 0456265728, 0456269823, 'ID', 'IDN', 'إندونيسيا'),
(488, 0456269824, 0456271871, 'HK', 'HKG', 'هونغ كونغ'),
(489, 0456271872, 0456294399, 'AU', 'AUS', 'أستراليا'),
(490, 0456294400, 0456327167, 'CN', 'CHN', 'الصين'),
(491, 0456327168, 0456523775, 'TW', 'TWN', 'تايوان'),
(492, 0456523776, 0456540159, 'SG', 'SGP', 'سنغافورة'),
(493, 0456540160, 0456548351, 'AU', 'AUS', 'أستراليا'),
(494, 0456548352, 0456553471, 'JP', 'JPN', 'اليابان'),
(495, 0456553472, 0456554495, 'MY', 'MYS', 'ماليزيا'),
(496, 0456554496, 0456555519, 'PK', 'PAK', 'باكستان'),
(497, 0456555520, 0456556543, 'JP', 'JPN', 'اليابان'),
(498, 0456556544, 0456560639, 'AU', 'AUS', 'أستراليا'),
(499, 0456560640, 0456562687, 'IN', 'IND', 'الهند'),
(500, 0456562688, 0456564735, 'AU', 'AUS', 'أستراليا'),
(501, 0456564736, 0456572927, 'IN', 'IND', 'الهند'),
(502, 0456572928, 0456589311, 'CN', 'CHN', 'الصين'),
(503, 0456589312, 0456654847, 'TH', 'THA', 'تايلند'),
(504, 0456654848, 0457179135, 'IN', 'IND', 'الهند'),
(505, 0457179136, 0461373439, 'AU', 'AUS', 'أستراليا'),
(506, 0461373440, 0461504511, 'CN', 'CHN', 'الصين'),
(507, 0461504512, 0461897727, 'AU', 'AUS', 'أستراليا'),
(508, 0461897728, 0462422015, 'JP', 'JPN', 'اليابان'),
(509, 0462422016, 0462487551, 'CN', 'CHN', 'الصين'),
(510, 0462487552, 0462553087, 'TH', 'THA', 'تايلند'),
(511, 0462553088, 0462618623, 'MY', 'MYS', 'ماليزيا'),
(512, 0462618624, 0462635007, 'TW', 'TWN', 'تايوان'),
(513, 0462635008, 0462651391, 'JP', 'JPN', 'اليابان'),
(514, 0462651392, 0462684159, 'BD', 'BGD', 'بنغالاديش'),
(515, 0462684160, 0463470591, 'CN', 'CHN', 'الصين'),
(516, 0463470592, 0465043455, 'KR', 'KOR', 'جمهورية كوريا'),
(517, 0465043456, 0467927039, 'CN', 'CHN', 'الصين'),
(518, 0467927040, 0468189183, 'JP', 'JPN', 'اليابان'),
(519, 0468189184, 0468713471, 'KR', 'KOR', 'جمهورية كوريا'),
(520, 0468713472, 0469237759, 'TW', 'TWN', 'تايوان'),
(521, 0469237760, 0469499903, 'IN', 'IND', 'الهند'),
(522, 0469499904, 0469565439, 'NZ', 'NZL', 'نيوزيلاندا'),
(523, 0469565440, 0469630975, 'AU', 'AUS', 'أستراليا'),
(524, 0469630976, 0469696511, 'TH', 'THA', 'تايلند'),
(525, 0469696512, 0469762047, 'AU', 'AUS', 'أستراليا'),
(526, 0469762048, 0520093695, 'US', 'USA', 'الولايات المتحدة'),
(527, 0536870912, 0540680895, 'US', 'USA', 'الولايات المتحدة'),
(528, 0540680896, 0540680959, 'BE', 'BEL', 'بلجيكا'),
(529, 0540680960, 0540683775, 'US', 'USA', 'الولايات المتحدة'),
(530, 0540683776, 0540683783, 'DE', 'DEU', 'ألمانيا'),
(531, 0540683784, 0540685567, 'US', 'USA', 'الولايات المتحدة'),
(532, 0540685568, 0540685631, 'FR', 'FRA', 'فرنسا'),
(533, 0540685632, 0540687231, 'US', 'USA', 'الولايات المتحدة'),
(534, 0540687232, 0540687359, 'CA', 'CAN', 'كندا'),
(535, 0540687360, 0540694527, 'US', 'USA', 'الولايات المتحدة'),
(536, 0540694528, 0540694591, 'IT', 'ITA', 'إيطاليا'),
(537, 0540694592, 0540705023, 'US', 'USA', 'الولايات المتحدة'),
(538, 0540705024, 0540705031, 'IE', 'IRL', 'إيرلندا'),
(539, 0540705032, 0540705535, 'US', 'USA', 'الولايات المتحدة'),
(540, 0540705536, 0540705599, 'IE', 'IRL', 'إيرلندا'),
(541, 0540705600, 0540711935, 'US', 'USA', 'الولايات المتحدة'),
(542, 0540711936, 0540712447, 'NL', 'NLD', 'هولندا'),
(543, 0540712448, 0540737535, 'US', 'USA', 'الولايات المتحدة'),
(544, 0540737536, 0540737791, 'BZ', 'BLZ', 'بليز'),
(545, 0540737792, 0540737919, 'BR', 'BRA', 'البرازيل'),
(546, 0540737920, 0540750175, 'BZ', 'BLZ', 'بليز'),
(547, 0540750176, 0540750191, 'MX', 'MEX', 'المكسيك'),
(548, 0540750192, 0540803071, 'BZ', 'BLZ', 'بليز'),
(549, 0540803072, 0540819455, 'US', 'USA', 'الولايات المتحدة'),
(550, 0540819456, 0540823551, 'CA', 'CAN', 'كندا'),
(551, 0540823552, 0540826687, 'US', 'USA', 'الولايات المتحدة'),
(552, 0540826688, 0540826719, 'CA', 'CAN', 'كندا'),
(553, 0540826720, 0540827135, 'US', 'USA', 'الولايات المتحدة'),
(554, 0540827136, 0540827263, 'CA', 'CAN', 'كندا'),
(555, 0540827264, 0540827295, 'US', 'USA', 'الولايات المتحدة'),
(556, 0540827296, 0540827311, 'CA', 'CAN', 'كندا'),
(557, 0540827312, 0540827359, 'US', 'USA', 'الولايات المتحدة'),
(558, 0540827360, 0540827375, 'CA', 'CAN', 'كندا'),
(559, 0540827376, 0540827391, 'US', 'USA', 'الولايات المتحدة'),
(560, 0540827392, 0540827423, 'CA', 'CAN', 'كندا'),
(561, 0540827424, 0540827471, 'US', 'USA', 'الولايات المتحدة'),
(562, 0540827472, 0540827487, 'CA', 'CAN', 'كندا'),
(563, 0540827488, 0540827519, 'US', 'USA', 'الولايات المتحدة'),
(564, 0540827520, 0540827551, 'CA', 'CAN', 'كندا'),
(565, 0540827552, 0540827583, 'US', 'USA', 'الولايات المتحدة'),
(566, 0540827584, 0540827647, 'CA', 'CAN', 'كندا'),
(567, 0540827648, 0540829695, 'US', 'USA', 'الولايات المتحدة'),
(568, 0540829696, 0540829951, 'CA', 'CAN', 'كندا'),
(569, 0540829952, 0540830623, 'US', 'USA', 'الولايات المتحدة'),
(570, 0540830624, 0540830735, 'CA', 'CAN', 'كندا'),
(571, 0540830736, 0540830815, 'US', 'USA', 'الولايات المتحدة'),
(572, 0540830816, 0540830831, 'CA', 'CAN', 'كندا'),
(573, 0540830832, 0540830847, 'US', 'USA', 'الولايات المتحدة'),
(574, 0540830848, 0540830895, 'CA', 'CAN', 'كندا'),
(575, 0540830896, 0543690751, 'US', 'USA', 'الولايات المتحدة'),
(576, 0543690752, 0543691007, 'AR', 'ARG', 'الأرجنتين'),
(577, 0543691008, 0543844351, 'US', 'USA', 'الولايات المتحدة'),
(578, 0543844352, 0543844607, 'CH', 'CHE', 'سويسرا'),
(579, 0543844608, 0603979775, 'US', 'USA', 'الولايات المتحدة'),
(580, 0637534208, 0654311423, 'US', 'USA', 'الولايات المتحدة'),
(581, 0671088640, 0687865855, 'US', 'USA', 'الولايات المتحدة'),
(582, 0721420288, 0736100351, 'JP', 'JPN', 'اليابان'),
(583, 0736100352, 0736624639, 'AU', 'AUS', 'أستراليا'),
(584, 0736624640, 0736886783, 'JP', 'JPN', 'اليابان'),
(585, 0736886784, 0737411071, 'AU', 'AUS', 'أستراليا'),
(586, 0737411072, 0737476607, 'JP', 'JPN', 'اليابان'),
(587, 0737476608, 0738000895, 'AU', 'AUS', 'أستراليا'),
(588, 0738000896, 0738066431, 'JP', 'JPN', 'اليابان'),
(589, 0738066432, 0738197503, 'AU', 'AUS', 'أستراليا'),
(590, 0738197504, 0771751935, 'US', 'USA', 'الولايات المتحدة'),
(591, 0788529152, 0805306367, 'CA', 'CAN', 'كندا'),
(592, 0805306368, 0822083583, 'US', 'USA', 'الولايات المتحدة'),
(593, 0855638016, 0872415231, 'GB', 'GBR', 'المملكة المتحدة'),
(594, 0872415232, 0889192447, 'US', 'USA', 'الولايات المتحدة'),
(595, 0889192448, 0905969663, 'DE', 'DEU', 'ألمانيا'),
(596, 0905969664, 0956301311, 'US', 'USA', 'الولايات المتحدة'),
(597, 0956301312, 0973078527, 'FR', 'FRA', 'فرنسا'),
(598, 0973078528, 0973209599, 'JP', 'JPN', 'اليابان'),
(599, 0973209600, 0973275135, 'IN', 'IND', 'الهند'),
(600, 0973275136, 0973471743, 'JP', 'JPN', 'اليابان'),
(601, 0973471744, 0973602815, 'AU', 'AUS', 'أستراليا'),
(602, 0973602816, 0973864959, 'TH', 'THA', 'تايلند'),
(603, 0973864960, 0973996031, 'JP', 'JPN', 'اليابان'),
(604, 0973996032, 0974782463, 'CN', 'CHN', 'الصين'),
(605, 0974782464, 0974880767, 'MY', 'MYS', 'ماليزيا'),
(606, 0974880768, 0974913535, 'PK', 'PAK', 'باكستان'),
(607, 0974913536, 0974979071, 'NZ', 'NZL', 'نيوزيلاندا'),
(608, 0974979072, 0975044607, 'KR', 'KOR', 'جمهورية كوريا'),
(609, 0975044608, 0977272831, 'CN', 'CHN', 'الصين'),
(610, 0977272832, 0977305599, 'TH', 'THA', 'تايلند'),
(611, 0977305600, 0977338367, 'HK', 'HKG', 'هونغ كونغ'),
(612, 0977338368, 0977346559, 'SG', 'SGP', 'سنغافورة'),
(613, 0977346560, 0977354751, 'JP', 'JPN', 'اليابان'),
(614, 0977354752, 0977371135, 'KR', 'KOR', 'جمهورية كوريا'),
(615, 0977371136, 0977395711, 'PK', 'PAK', 'باكستان'),
(616, 0977395712, 0977397759, 'BD', 'BGD', 'بنغالاديش'),
(617, 0977397760, 0977399807, 'AU', 'AUS', 'أستراليا'),
(618, 0977399808, 0977401855, 'ID', 'IDN', 'إندونيسيا'),
(619, 0977401856, 0977403903, 'AU', 'AUS', 'أستراليا'),
(620, 0977403904, 0977534975, 'CN', 'CHN', 'الصين'),
(621, 0977534976, 0977567743, 'IN', 'IND', 'الهند'),
(622, 0977567744, 0977600511, 'CN', 'CHN', 'الصين'),
(623, 0977600512, 0977666047, 'PH', 'PHL', 'الفلبين'),
(624, 0977666048, 0977731583, 'JP', 'JPN', 'اليابان'),
(625, 0977731584, 0977764351, 'PH', 'PHL', 'الفلبين'),
(626, 0977764352, 0977797119, 'MY', 'MYS', 'ماليزيا'),
(627, 0977797120, 0978321407, 'KR', 'KOR', 'جمهورية كوريا'),
(628, 0978321408, 0978452479, 'JP', 'JPN', 'اليابان'),
(629, 0978452480, 0978583551, 'CN', 'CHN', 'الصين'),
(630, 0978583552, 0978599935, 'JP', 'JPN', 'اليابان'),
(631, 0978599936, 0978640895, 'AU', 'AUS', 'أستراليا'),
(632, 0978640896, 0978644991, 'NZ', 'NZL', 'نيوزيلاندا'),
(633, 0978644992, 0978649087, 'AU', 'AUS', 'أستراليا'),
(634, 0978649088, 0978714623, 'JP', 'JPN', 'اليابان'),
(635, 0978714624, 0978780159, 'TW', 'TWN', 'تايوان'),
(636, 0978780160, 0978784255, 'AU', 'AUS', 'أستراليا'),
(637, 0978784256, 0978788351, 'JP', 'JPN', 'اليابان'),
(638, 0978788352, 0978796543, 'KR', 'KOR', 'جمهورية كوريا'),
(639, 0978796544, 0978812927, 'CN', 'CHN', 'الصين'),
(640, 0978812928, 0979369983, 'JP', 'JPN', 'اليابان'),
(641, 0979369984, 0979435519, 'AU', 'AUS', 'أستراليا'),
(642, 0979435520, 0979468287, 'TH', 'THA', 'تايلند'),
(643, 0979468288, 0979501055, 'AU', 'AUS', 'أستراليا'),
(644, 0979501056, 0979566591, 'JP', 'JPN', 'اليابان'),
(645, 0979566592, 0979599359, 'TW', 'TWN', 'تايوان'),
(646, 0979599360, 0979763199, 'CN', 'CHN', 'الصين'),
(647, 0979763200, 0979894271, 'KR', 'KOR', 'جمهورية كوريا'),
(648, 0979894272, 0980418559, 'AU', 'AUS', 'أستراليا'),
(649, 0980418560, 0980549631, 'JP', 'JPN', 'اليابان'),
(650, 0980549632, 0980680703, 'TW', 'TWN', 'تايوان'),
(651, 0980680704, 0980942847, 'CN', 'CHN', 'الصين'),
(652, 0980942848, 0981467135, 'KR', 'KOR', 'جمهورية كوريا'),
(653, 0981467136, 0981991423, 'CN', 'CHN', 'الصين'),
(654, 0981991424, 0982122495, 'TH', 'THA', 'تايلند'),
(655, 0982122496, 0982171647, 'JP', 'JPN', 'اليابان'),
(656, 0982171648, 0982188031, 'KR', 'KOR', 'جمهورية كوريا'),
(657, 0982188032, 0982253567, 'MY', 'MYS', 'ماليزيا'),
(658, 0982253568, 0982515711, 'KR', 'KOR', 'جمهورية كوريا'),
(659, 0982515712, 0982581247, 'CN', 'CHN', 'الصين'),
(660, 0982581248, 0982614015, 'KR', 'KOR', 'جمهورية كوريا'),
(661, 0982614016, 0982622207, 'AU', 'AUS', 'أستراليا'),
(662, 0982622208, 0982624255, 'JP', 'JPN', 'اليابان'),
(663, 0982624256, 0982626303, 'ID', 'IDN', 'إندونيسيا'),
(664, 0982626304, 0982628351, 'AU', 'AUS', 'أستراليا'),
(665, 0982628352, 0982630399, 'BD', 'BGD', 'بنغالاديش'),
(666, 0982630400, 0982646783, 'SG', 'SGP', 'سنغافورة'),
(667, 0982646784, 0982671359, 'JP', 'JPN', 'اليابان'),
(668, 0982671360, 0982679551, 'IN', 'IND', 'الهند'),
(669, 0982679552, 0982695935, 'SG', 'SGP', 'سنغافورة'),
(670, 0982695936, 0982712319, 'KR', 'KOR', 'جمهورية كوريا'),
(671, 0982712320, 0982745087, 'TH', 'THA', 'تايلند'),
(672, 0982745088, 0982753279, 'AF', 'AFG', 'أفغانستان'),
(673, 0982753280, 0982755327, 'JP', 'JPN', 'اليابان'),
(674, 0982755328, 0982757375, 'BD', 'BGD', 'بنغالاديش'),
(675, 0982757376, 0982759423, 'AU', 'AUS', 'أستراليا'),
(676, 0982759424, 0982761471, 'ID', 'IDN', 'إندونيسيا'),
(677, 0982761472, 0982777855, 'JP', 'JPN', 'اليابان'),
(678, 0982777856, 0983039999, 'KR', 'KOR', 'جمهورية كوريا'),
(679, 0983040000, 0983171071, 'HK', 'HKG', 'هونغ كونغ'),
(680, 0983171072, 0983302143, 'CN', 'CHN', 'الصين'),
(681, 0983302144, 0983564287, 'JP', 'JPN', 'اليابان'),
(682, 0983564288, 0984612863, 'AU', 'AUS', 'أستراليا'),
(683, 0984612864, 0984743935, 'HK', 'HKG', 'هونغ كونغ'),
(684, 0984743936, 0984875007, 'AU', 'AUS', 'أستراليا'),
(685, 0984875008, 0984956927, 'KR', 'KOR', 'جمهورية كوريا'),
(686, 0984956928, 0984965119, 'AU', 'AUS', 'أستراليا'),
(687, 0984965120, 0984973311, 'PK', 'PAK', 'باكستان'),
(688, 0984973312, 0985006079, 'TH', 'THA', 'تايلند'),
(689, 0985006080, 0985071615, 'SG', 'SGP', 'سنغافورة'),
(690, 0985071616, 0985137151, 'JP', 'JPN', 'اليابان'),
(691, 0985137152, 0985202687, 'KR', 'KOR', 'جمهورية كوريا'),
(692, 0985202688, 0985268223, 'SG', 'SGP', 'سنغافورة'),
(693, 0985268224, 0985399295, 'VN', 'VNM', 'فييتنام'),
(694, 0985399296, 0985661439, 'JP', 'JPN', 'اليابان'),
(695, 0985661440, 0987758591, 'CN', 'CHN', 'الصين'),
(696, 0987758592, 0988807167, 'KR', 'KOR', 'جمهورية كوريا'),
(697, 0988807168, 0989855743, 'CN', 'CHN', 'الصين'),
(698, 0989855744, 0991952895, 'KR', 'KOR', 'جمهورية كوريا'),
(699, 0991952896, 0995360767, 'CN', 'CHN', 'الصين'),
(700, 0995360768, 0995532799, 'JP', 'JPN', 'اليابان'),
(701, 0995532800, 0995540991, 'AU', 'AUS', 'أستراليا'),
(702, 0995540992, 0995557375, 'KR', 'KOR', 'جمهورية كوريا'),
(703, 0995557376, 0995622911, 'JP', 'JPN', 'اليابان'),
(704, 0995622912, 0996409343, 'IN', 'IND', 'الهند'),
(705, 0996409344, 0996605951, 'AU', 'AUS', 'أستراليا'),
(706, 0996605952, 0996671487, 'PK', 'PAK', 'باكستان'),
(707, 0996671488, 0996802559, 'TW', 'TWN', 'تايوان'),
(708, 0996802560, 0996868095, 'JP', 'JPN', 'اليابان'),
(709, 0996868096, 0997195775, 'CN', 'CHN', 'الصين'),
(710, 0997195776, 0998244351, 'TW', 'TWN', 'تايوان'),
(711, 0998244352, 0999292927, 'JP', 'JPN', 'اليابان'),
(712, 0999292928, 0999423999, 'IN', 'IND', 'الهند'),
(713, 0999424000, 0999555071, 'JP', 'JPN', 'اليابان'),
(714, 0999555072, 0999686143, 'HK', 'HKG', 'هونغ كونغ'),
(715, 0999686144, 0999751679, 'KR', 'KOR', 'جمهورية كوريا'),
(716, 0999751680, 0999784447, 'CN', 'CHN', 'الصين'),
(717, 0999784448, 0999800831, 'AU', 'AUS', 'أستراليا'),
(718, 0999800832, 0999817215, 'KR', 'KOR', 'جمهورية كوريا'),
(719, 0999817216, 0999849983, 'BD', 'BGD', 'بنغالاديش'),
(720, 0999849984, 0999866367, 'KR', 'KOR', 'جمهورية كوريا'),
(721, 0999866368, 0999882751, 'HK', 'HKG', 'هونغ كونغ'),
(722, 0999882752, 0999948287, 'JP', 'JPN', 'اليابان'),
(723, 0999948288, 1000013823, 'AU', 'AUS', 'أستراليا'),
(724, 1000013824, 1000079359, 'CN', 'CHN', 'الصين'),
(725, 1000079360, 1000341503, 'JP', 'JPN', 'اليابان'),
(726, 1000341504, 1000734719, 'IN', 'IND', 'الهند'),
(727, 1000734720, 1000800255, 'JP', 'JPN', 'اليابان'),
(728, 1000800256, 1000865791, 'AU', 'AUS', 'أستراليا'),
(729, 1000865792, 1001127935, 'JP', 'JPN', 'اليابان'),
(730, 1001127936, 1001390079, 'CN', 'CHN', 'الصين'),
(731, 1001390080, 1002045439, 'IN', 'IND', 'الهند'),
(732, 1002045440, 1002176511, 'KR', 'KOR', 'جمهورية كوريا'),
(733, 1002176512, 1002242047, 'HK', 'HKG', 'هونغ كونغ'),
(734, 1002242048, 1002307583, 'SG', 'SGP', 'سنغافورة'),
(735, 1002307584, 1002373119, 'JP', 'JPN', 'اليابان'),
(736, 1002373120, 1002405887, 'CN', 'CHN', 'الصين'),
(737, 1002405888, 1002422271, 'JP', 'JPN', 'اليابان'),
(738, 1002422272, 1002434559, 'AU', 'AUS', 'أستراليا'),
(739, 1002434560, 1008730111, 'CN', 'CHN', 'الصين'),
(740, 1008730112, 1009778687, 'JP', 'JPN', 'اليابان'),
(741, 1009778688, 1010237439, 'MY', 'MYS', 'ماليزيا'),
(742, 1010237440, 1010302975, 'CN', 'CHN', 'الصين'),
(743, 1010302976, 1010761727, 'JP', 'JPN', 'اليابان'),
(744, 1010761728, 1010827263, 'CN', 'CHN', 'الصين'),
(745, 1010827264, 1017118719, 'JP', 'JPN', 'اليابان'),
(746, 1017118720, 1019215871, 'CN', 'CHN', 'الصين'),
(747, 1019215872, 1019346943, 'JP', 'JPN', 'اليابان'),
(748, 1019346944, 1019478015, 'CN', 'CHN', 'الصين'),
(749, 1019478016, 1019609087, 'KR', 'KOR', 'جمهورية كوريا'),
(750, 1019609088, 1019740159, 'TW', 'TWN', 'تايوان'),
(751, 1019740160, 1021313023, 'CN', 'CHN', 'الصين'),
(752, 1021313024, 1021837311, 'AU', 'AUS', 'أستراليا'),
(753, 1021837312, 1021968383, 'CN', 'CHN', 'الصين'),
(754, 1021968384, 1021986495, 'NZ', 'NZL', 'نيوزيلاندا'),
(755, 1021986496, 1021986559, 'PA', 'PAN', 'بنما'),
(756, 1021986560, 1022033919, 'NZ', 'NZL', 'نيوزيلاندا'),
(757, 1022033920, 1022099455, 'CN', 'CHN', 'الصين'),
(758, 1022099456, 1022361599, 'JP', 'JPN', 'اليابان'),
(759, 1022361600, 1022558207, 'AU', 'AUS', 'أستراليا'),
(760, 1022558208, 1022623743, 'IN', 'IND', 'الهند'),
(761, 1022623744, 1022722047, 'TW', 'TWN', 'تايوان'),
(762, 1022722048, 1022754815, 'CN', 'CHN', 'الصين'),
(763, 1022754816, 1022820351, 'AU', 'AUS', 'أستراليا'),
(764, 1022820352, 1022885887, 'CN', 'CHN', 'الصين'),
(765, 1022885888, 1023148031, 'TW', 'TWN', 'تايوان'),
(766, 1023148032, 1023213567, 'CN', 'CHN', 'الصين'),
(767, 1023213568, 1023238143, 'AU', 'AUS', 'أستراليا'),
(768, 1023238144, 1023246335, 'ID', 'IDN', 'إندونيسيا'),
(769, 1023246336, 1023279103, 'CN', 'CHN', 'الصين'),
(770, 1023279104, 1023311871, 'IN', 'IND', 'الهند'),
(771, 1023311872, 1023328255, 'US', 'USA', 'الولايات المتحدة'),
(772, 1023328256, 1023344639, 'JP', 'JPN', 'اليابان'),
(773, 1023344640, 1023410175, 'CN', 'CHN', 'الصين'),
(774, 1023410176, 1023672319, 'IN', 'IND', 'الهند'),
(775, 1023672320, 1023688703, 'HK', 'HKG', 'هونغ كونغ'),
(776, 1023688704, 1023692799, 'AU', 'AUS', 'أستراليا'),
(777, 1023692800, 1023693823, 'CN', 'CHN', 'الصين'),
(778, 1023693824, 1023696895, 'AU', 'AUS', 'أستراليا'),
(779, 1023696896, 1023705087, 'MY', 'MYS', 'ماليزيا'),
(780, 1023705088, 1023717375, 'JP', 'JPN', 'اليابان'),
(781, 1023717376, 1023721471, 'CN', 'CHN', 'الصين'),
(782, 1023721472, 1023737855, 'KR', 'KOR', 'جمهورية كوريا'),
(783, 1023737856, 1023770623, 'ID', 'IDN', 'إندونيسيا'),
(784, 1023770624, 1023778815, 'PK', 'PAK', 'باكستان'),
(785, 1023778816, 1023787007, 'KR', 'KOR', 'جمهورية كوريا'),
(786, 1023787008, 1023791103, 'AU', 'AUS', 'أستراليا'),
(787, 1023791104, 1023795199, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(788, 1023795200, 1023803391, 'JP', 'JPN', 'اليابان'),
(789, 1023803392, 1023852543, 'MY', 'MYS', 'ماليزيا'),
(790, 1023852544, 1023868927, 'BN', 'BRN', 'بروناي دار السلام'),
(791, 1023868928, 1023901695, 'JP', 'JPN', 'اليابان'),
(792, 1023901696, 1023934463, 'TH', 'THA', 'تايلند'),
(793, 1023934464, 1023950847, 'AU', 'AUS', 'أستراليا'),
(794, 1023950848, 1023954943, 'ID', 'IDN', 'إندونيسيا'),
(795, 1023954944, 1023959039, 'JP', 'JPN', 'اليابان'),
(796, 1023959040, 1023967231, 'AU', 'AUS', 'أستراليا'),
(797, 1023967232, 1023975423, 'IN', 'IND', 'الهند'),
(798, 1023975424, 1023979519, 'CN', 'CHN', 'الصين'),
(799, 1023979520, 1023983615, 'AU', 'AUS', 'أستراليا'),
(800, 1023983616, 1023999999, 'SG', 'SGP', 'سنغافورة'),
(801, 1024000000, 1024032767, 'PH', 'PHL', 'الفلبين'),
(802, 1024032768, 1024065535, 'AU', 'AUS', 'أستراليا'),
(803, 1024065536, 1024131071, 'HK', 'HKG', 'هونغ كونغ'),
(804, 1024131072, 1024163839, 'IN', 'IND', 'الهند'),
(805, 1024163840, 1024184319, 'JP', 'JPN', 'اليابان'),
(806, 1024184320, 1024188415, 'MY', 'MYS', 'ماليزيا'),
(807, 1024188416, 1024196607, 'AU', 'AUS', 'أستراليا'),
(808, 1024196608, 1024229375, 'IN', 'IND', 'الهند'),
(809, 1024229376, 1024262143, 'JP', 'JPN', 'اليابان'),
(810, 1024262144, 1024327679, 'SG', 'SGP', 'سنغافورة'),
(811, 1024327680, 1024328703, 'US', 'USA', 'الولايات المتحدة'),
(812, 1024328704, 1024329279, 'IN', 'IND', 'الهند'),
(813, 1024329280, 1024329343, 'US', 'USA', 'الولايات المتحدة'),
(814, 1024329344, 1024329471, 'IN', 'IND', 'الهند'),
(815, 1024329472, 1024329663, 'US', 'USA', 'الولايات المتحدة'),
(816, 1024329664, 1024329695, 'IN', 'IND', 'الهند'),
(817, 1024329696, 1024330255, 'US', 'USA', 'الولايات المتحدة'),
(818, 1024330256, 1024330271, 'IN', 'IND', 'الهند'),
(819, 1024330272, 1024330367, 'US', 'USA', 'الولايات المتحدة'),
(820, 1024330368, 1024330399, 'IN', 'IND', 'الهند'),
(821, 1024330400, 1024330751, 'US', 'USA', 'الولايات المتحدة'),
(822, 1024330752, 1024330759, 'IN', 'IND', 'الهند'),
(823, 1024330760, 1024331327, 'US', 'USA', 'الولايات المتحدة'),
(824, 1024331328, 1024331519, 'IN', 'IND', 'الهند'),
(825, 1024331520, 1024331551, 'US', 'USA', 'الولايات المتحدة'),
(826, 1024331552, 1024331583, 'IN', 'IND', 'الهند'),
(827, 1024331584, 1024332287, 'US', 'USA', 'الولايات المتحدة'),
(828, 1024332288, 1024332415, 'IN', 'IND', 'الهند'),
(829, 1024332416, 1024332487, 'US', 'USA', 'الولايات المتحدة'),
(830, 1024332488, 1024332495, 'IN', 'IND', 'الهند'),
(831, 1024332496, 1024332927, 'US', 'USA', 'الولايات المتحدة'),
(832, 1024332928, 1024333055, 'IN', 'IND', 'الهند'),
(833, 1024333056, 1024333247, 'US', 'USA', 'الولايات المتحدة'),
(834, 1024333248, 1024333311, 'HK', 'HKG', 'هونغ كونغ'),
(835, 1024333312, 1024333367, 'US', 'USA', 'الولايات المتحدة'),
(836, 1024333368, 1024333375, 'IN', 'IND', 'الهند'),
(837, 1024333376, 1024333415, 'US', 'USA', 'الولايات المتحدة'),
(838, 1024333416, 1024333423, 'IN', 'IND', 'الهند'),
(839, 1024333424, 1024333791, 'US', 'USA', 'الولايات المتحدة'),
(840, 1024333792, 1024333823, 'ID', 'IDN', 'إندونيسيا'),
(841, 1024333824, 1024333951, 'US', 'USA', 'الولايات المتحدة'),
(842, 1024333952, 1024334079, 'IN', 'IND', 'الهند'),
(843, 1024334080, 1024334279, 'US', 'USA', 'الولايات المتحدة'),
(844, 1024334280, 1024334287, 'CN', 'CHN', 'الصين'),
(845, 1024334288, 1024334727, 'US', 'USA', 'الولايات المتحدة'),
(846, 1024334728, 1024334735, 'SG', 'SGP', 'سنغافورة'),
(847, 1024334736, 1024334847, 'US', 'USA', 'الولايات المتحدة'),
(848, 1024334848, 1024334911, 'PH', 'PHL', 'الفلبين'),
(849, 1024334912, 1024335111, 'US', 'USA', 'الولايات المتحدة'),
(850, 1024335112, 1024335119, 'CN', 'CHN', 'الصين'),
(851, 1024335120, 1024335143, 'US', 'USA', 'الولايات المتحدة'),
(852, 1024335144, 1024335151, 'ID', 'IDN', 'إندونيسيا'),
(853, 1024335152, 1024335167, 'JP', 'JPN', 'اليابان'),
(854, 1024335168, 1024335183, 'US', 'USA', 'الولايات المتحدة'),
(855, 1024335184, 1024335199, 'CN', 'CHN', 'الصين'),
(856, 1024335200, 1024335263, 'US', 'USA', 'الولايات المتحدة'),
(857, 1024335264, 1024335271, 'JP', 'JPN', 'اليابان'),
(858, 1024335272, 1024335679, 'US', 'USA', 'الولايات المتحدة'),
(859, 1024335680, 1024335743, 'IN', 'IND', 'الهند'),
(860, 1024335744, 1024335807, 'US', 'USA', 'الولايات المتحدة'),
(861, 1024335808, 1024335871, 'IN', 'IND', 'الهند'),
(862, 1024335872, 1024338311, 'US', 'USA', 'الولايات المتحدة'),
(863, 1024338312, 1024338319, 'PH', 'PHL', 'الفلبين'),
(864, 1024338320, 1024338631, 'US', 'USA', 'الولايات المتحدة'),
(865, 1024338632, 1024338639, 'MY', 'MYS', 'ماليزيا'),
(866, 1024338640, 1024339583, 'US', 'USA', 'الولايات المتحدة'),
(867, 1024339584, 1024339711, 'HK', 'HKG', 'هونغ كونغ'),
(868, 1024339712, 1024339967, 'ID', 'IDN', 'إندونيسيا'),
(869, 1024339968, 1024340511, 'US', 'USA', 'الولايات المتحدة'),
(870, 1024340512, 1024340519, 'TH', 'THA', 'تايلند'),
(871, 1024340520, 1024344063, 'US', 'USA', 'الولايات المتحدة'),
(872, 1024344064, 1024352255, 'SG', 'SGP', 'سنغافورة'),
(873, 1024352256, 1024360447, 'AU', 'AUS', 'أستراليا'),
(874, 1024360448, 1024360535, 'HK', 'HKG', 'هونغ كونغ'),
(875, 1024360536, 1024360543, 'AU', 'AUS', 'أستراليا'),
(876, 1024360544, 1024360671, 'HK', 'HKG', 'هونغ كونغ'),
(877, 1024360672, 1024360703, 'AU', 'AUS', 'أستراليا'),
(878, 1024360704, 1024361007, 'HK', 'HKG', 'هونغ كونغ'),
(879, 1024361008, 1024361039, 'AU', 'AUS', 'أستراليا'),
(880, 1024361040, 1024361087, 'HK', 'HKG', 'هونغ كونغ'),
(881, 1024361088, 1024361103, 'AU', 'AUS', 'أستراليا'),
(882, 1024361104, 1024361135, 'HK', 'HKG', 'هونغ كونغ'),
(883, 1024361136, 1024361151, 'AU', 'AUS', 'أستراليا'),
(884, 1024361152, 1024361183, 'HK', 'HKG', 'هونغ كونغ');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(885, 1024361184, 1024361215, 'AU', 'AUS', 'أستراليا'),
(886, 1024361216, 1024361239, 'HK', 'HKG', 'هونغ كونغ'),
(887, 1024361240, 1024361247, 'AU', 'AUS', 'أستراليا'),
(888, 1024361248, 1024361311, 'HK', 'HKG', 'هونغ كونغ'),
(889, 1024361312, 1024361327, 'AU', 'AUS', 'أستراليا'),
(890, 1024361328, 1024361375, 'HK', 'HKG', 'هونغ كونغ'),
(891, 1024361376, 1024361391, 'AU', 'AUS', 'أستراليا'),
(892, 1024361392, 1024361439, 'HK', 'HKG', 'هونغ كونغ'),
(893, 1024361440, 1024361455, 'AU', 'AUS', 'أستراليا'),
(894, 1024361456, 1024361471, 'HK', 'HKG', 'هونغ كونغ'),
(895, 1024361472, 1024361487, 'TW', 'TWN', 'تايوان'),
(896, 1024361488, 1024361503, 'AU', 'AUS', 'أستراليا'),
(897, 1024361504, 1024361519, 'PH', 'PHL', 'الفلبين'),
(898, 1024361520, 1024361535, 'AU', 'AUS', 'أستراليا'),
(899, 1024361536, 1024361567, 'PH', 'PHL', 'الفلبين'),
(900, 1024361568, 1024361727, 'AU', 'AUS', 'أستراليا'),
(901, 1024361728, 1024361759, 'TW', 'TWN', 'تايوان'),
(902, 1024361760, 1024361775, 'PH', 'PHL', 'الفلبين'),
(903, 1024361776, 1024361791, 'AU', 'AUS', 'أستراليا'),
(904, 1024361792, 1024361807, 'PH', 'PHL', 'الفلبين'),
(905, 1024361808, 1024361823, 'TW', 'TWN', 'تايوان'),
(906, 1024361824, 1024361831, 'AU', 'AUS', 'أستراليا'),
(907, 1024361832, 1024362239, 'TW', 'TWN', 'تايوان'),
(908, 1024362240, 1024362287, 'MY', 'MYS', 'ماليزيا'),
(909, 1024362288, 1024362303, 'SG', 'SGP', 'سنغافورة'),
(910, 1024362304, 1024362335, 'MY', 'MYS', 'ماليزيا'),
(911, 1024362336, 1024362351, 'AU', 'AUS', 'أستراليا'),
(912, 1024362352, 1024362367, 'SG', 'SGP', 'سنغافورة'),
(913, 1024362368, 1024362495, 'AU', 'AUS', 'أستراليا'),
(914, 1024362496, 1024362559, 'MY', 'MYS', 'ماليزيا'),
(915, 1024362560, 1024362575, 'AU', 'AUS', 'أستراليا'),
(916, 1024362576, 1024362599, 'MY', 'MYS', 'ماليزيا'),
(917, 1024362600, 1024362623, 'SG', 'SGP', 'سنغافورة'),
(918, 1024362624, 1024362655, 'AU', 'AUS', 'أستراليا'),
(919, 1024362656, 1024362671, 'SG', 'SGP', 'سنغافورة'),
(920, 1024362672, 1024362687, 'MY', 'MYS', 'ماليزيا'),
(921, 1024362688, 1024362703, 'AU', 'AUS', 'أستراليا'),
(922, 1024362704, 1024362719, 'MY', 'MYS', 'ماليزيا'),
(923, 1024362720, 1024362735, 'SG', 'SGP', 'سنغافورة'),
(924, 1024362736, 1024362759, 'AU', 'AUS', 'أستراليا'),
(925, 1024362760, 1024362767, 'MY', 'MYS', 'ماليزيا'),
(926, 1024362768, 1024362815, 'AU', 'AUS', 'أستراليا'),
(927, 1024362816, 1024362976, 'SG', 'SGP', 'سنغافورة'),
(928, 1024362977, 1024363007, 'AU', 'AUS', 'أستراليا'),
(929, 1024363008, 1024363015, 'SG', 'SGP', 'سنغافورة'),
(930, 1024363016, 1024363023, 'AU', 'AUS', 'أستراليا'),
(931, 1024363024, 1024363039, 'SG', 'SGP', 'سنغافورة'),
(932, 1024363040, 1024363071, 'AU', 'AUS', 'أستراليا'),
(933, 1024363072, 1024363103, 'SG', 'SGP', 'سنغافورة'),
(934, 1024363104, 1024363111, 'AU', 'AUS', 'أستراليا'),
(935, 1024363112, 1024363119, 'SG', 'SGP', 'سنغافورة'),
(936, 1024363120, 1024363135, 'AU', 'AUS', 'أستراليا'),
(937, 1024363136, 1024363199, 'SG', 'SGP', 'سنغافورة'),
(938, 1024363200, 1024363215, 'MY', 'MYS', 'ماليزيا'),
(939, 1024363216, 1024363295, 'SG', 'SGP', 'سنغافورة'),
(940, 1024363296, 1024363319, 'MY', 'MYS', 'ماليزيا'),
(941, 1024363320, 1024363327, 'SG', 'SGP', 'سنغافورة'),
(942, 1024363328, 1024363391, 'AU', 'AUS', 'أستراليا'),
(943, 1024363392, 1024363423, 'MY', 'MYS', 'ماليزيا'),
(944, 1024363424, 1024363439, 'SG', 'SGP', 'سنغافورة'),
(945, 1024363440, 1024363447, 'MY', 'MYS', 'ماليزيا'),
(946, 1024363448, 1024363455, 'AU', 'AUS', 'أستراليا'),
(947, 1024363456, 1024363519, 'SG', 'SGP', 'سنغافورة'),
(948, 1024363520, 1024363999, 'AU', 'AUS', 'أستراليا'),
(949, 1024364000, 1024364015, 'NZ', 'NZL', 'نيوزيلاندا'),
(950, 1024364016, 1024365311, 'AU', 'AUS', 'أستراليا'),
(951, 1024365312, 1024365567, 'MY', 'MYS', 'ماليزيا'),
(952, 1024365568, 1024365823, 'AU', 'AUS', 'أستراليا'),
(953, 1024365824, 1024366335, 'PH', 'PHL', 'الفلبين'),
(954, 1024366336, 1024366591, 'TW', 'TWN', 'تايوان'),
(955, 1024366592, 1024366847, 'AU', 'AUS', 'أستراليا'),
(956, 1024366848, 1024366911, 'PH', 'PHL', 'الفلبين'),
(957, 1024366912, 1024366943, 'AU', 'AUS', 'أستراليا'),
(958, 1024366944, 1024366975, 'PH', 'PHL', 'الفلبين'),
(959, 1024366976, 1024367039, 'TW', 'TWN', 'تايوان'),
(960, 1024367040, 1024367103, 'PH', 'PHL', 'الفلبين'),
(961, 1024367104, 1024368127, 'AU', 'AUS', 'أستراليا'),
(962, 1024368128, 1024368383, 'PH', 'PHL', 'الفلبين'),
(963, 1024368384, 1024368639, 'AU', 'AUS', 'أستراليا'),
(964, 1024368640, 1024369407, 'MY', 'MYS', 'ماليزيا'),
(965, 1024369408, 1024369663, 'AU', 'AUS', 'أستراليا'),
(966, 1024369664, 1024369919, 'PH', 'PHL', 'الفلبين'),
(967, 1024369920, 1024370175, 'TW', 'TWN', 'تايوان'),
(968, 1024370176, 1024370431, 'AU', 'AUS', 'أستراليا'),
(969, 1024370432, 1024370447, 'NZ', 'NZL', 'نيوزيلاندا'),
(970, 1024370448, 1024370687, 'AU', 'AUS', 'أستراليا'),
(971, 1024370688, 1024371455, 'PH', 'PHL', 'الفلبين'),
(972, 1024371456, 1024371711, 'JP', 'JPN', 'اليابان'),
(973, 1024371712, 1024371967, 'AU', 'AUS', 'أستراليا'),
(974, 1024371968, 1024372223, 'JP', 'JPN', 'اليابان'),
(975, 1024372224, 1024372319, 'HK', 'HKG', 'هونغ كونغ'),
(976, 1024372320, 1024372351, 'AU', 'AUS', 'أستراليا'),
(977, 1024372352, 1024372383, 'HK', 'HKG', 'هونغ كونغ'),
(978, 1024372384, 1024372399, 'AU', 'AUS', 'أستراليا'),
(979, 1024372400, 1024372431, 'HK', 'HKG', 'هونغ كونغ'),
(980, 1024372432, 1024372479, 'AU', 'AUS', 'أستراليا'),
(981, 1024372480, 1024372735, 'HK', 'HKG', 'هونغ كونغ'),
(982, 1024372736, 1024373247, 'AU', 'AUS', 'أستراليا'),
(983, 1024373248, 1024373503, 'PH', 'PHL', 'الفلبين'),
(984, 1024373504, 1024373823, 'AU', 'AUS', 'أستراليا'),
(985, 1024373824, 1024373887, 'TW', 'TWN', 'تايوان'),
(986, 1024373888, 1024374015, 'PH', 'PHL', 'الفلبين'),
(987, 1024374016, 1024374079, 'AU', 'AUS', 'أستراليا'),
(988, 1024374080, 1024374111, 'TW', 'TWN', 'تايوان'),
(989, 1024374112, 1024374351, 'AU', 'AUS', 'أستراليا'),
(990, 1024374352, 1024374383, 'US', 'USA', 'الولايات المتحدة'),
(991, 1024374384, 1024374847, 'AU', 'AUS', 'أستراليا'),
(992, 1024374848, 1024374879, 'JP', 'JPN', 'اليابان'),
(993, 1024374880, 1024374895, 'AU', 'AUS', 'أستراليا'),
(994, 1024374896, 1024374903, 'JP', 'JPN', 'اليابان'),
(995, 1024374904, 1024374911, 'AU', 'AUS', 'أستراليا'),
(996, 1024374912, 1024374951, 'JP', 'JPN', 'اليابان'),
(997, 1024374952, 1024374975, 'AU', 'AUS', 'أستراليا'),
(998, 1024374976, 1024375087, 'JP', 'JPN', 'اليابان'),
(999, 1024375088, 1024375151, 'AU', 'AUS', 'أستراليا'),
(1000, 1024375152, 1024375295, 'JP', 'JPN', 'اليابان'),
(1001, 1024375296, 1024375807, 'AU', 'AUS', 'أستراليا'),
(1002, 1024375808, 1024375999, 'TW', 'TWN', 'تايوان'),
(1003, 1024376000, 1024376095, 'PH', 'PHL', 'الفلبين'),
(1004, 1024376096, 1024376111, 'TW', 'TWN', 'تايوان'),
(1005, 1024376112, 1024376127, 'PH', 'PHL', 'الفلبين'),
(1006, 1024376128, 1024376159, 'AU', 'AUS', 'أستراليا'),
(1007, 1024376160, 1024376191, 'TW', 'TWN', 'تايوان'),
(1008, 1024376192, 1024376199, 'PH', 'PHL', 'الفلبين'),
(1009, 1024376200, 1024376255, 'AU', 'AUS', 'أستراليا'),
(1010, 1024376256, 1024376463, 'TW', 'TWN', 'تايوان'),
(1011, 1024376464, 1024376471, 'AU', 'AUS', 'أستراليا'),
(1012, 1024376472, 1024376479, 'TW', 'TWN', 'تايوان'),
(1013, 1024376480, 1024376511, 'PH', 'PHL', 'الفلبين'),
(1014, 1024376512, 1024376575, 'TW', 'TWN', 'تايوان'),
(1015, 1024376576, 1024376703, 'AU', 'AUS', 'أستراليا'),
(1016, 1024376704, 1024376735, 'PH', 'PHL', 'الفلبين'),
(1017, 1024376736, 1024376767, 'AU', 'AUS', 'أستراليا'),
(1018, 1024376768, 1024376799, 'TW', 'TWN', 'تايوان'),
(1019, 1024376800, 1024393215, 'PH', 'PHL', 'الفلبين'),
(1020, 1024393216, 1024458751, 'HK', 'HKG', 'هونغ كونغ'),
(1021, 1024458752, 1024491519, 'SG', 'SGP', 'سنغافورة'),
(1022, 1024491520, 1024589823, 'IN', 'IND', 'الهند'),
(1023, 1024589824, 1024655359, 'HK', 'HKG', 'هونغ كونغ'),
(1024, 1024655360, 1024720895, 'TH', 'THA', 'تايلند'),
(1025, 1024720896, 1024786431, 'TW', 'TWN', 'تايوان'),
(1026, 1024786432, 1025245183, 'JP', 'JPN', 'اليابان'),
(1027, 1025245184, 1025277951, 'CN', 'CHN', 'الصين'),
(1028, 1025277952, 1025294335, 'PH', 'PHL', 'الفلبين'),
(1029, 1025294336, 1025294591, 'JP', 'JPN', 'اليابان'),
(1030, 1025294592, 1025294847, 'HK', 'HKG', 'هونغ كونغ'),
(1031, 1025294848, 1025295103, 'TH', 'THA', 'تايلند'),
(1032, 1025295104, 1025295615, 'CN', 'CHN', 'الصين'),
(1033, 1025295616, 1025295871, 'AU', 'AUS', 'أستراليا'),
(1034, 1025295872, 1025296127, 'GB', 'GBR', 'المملكة المتحدة'),
(1035, 1025296128, 1025296639, 'FR', 'FRA', 'فرنسا'),
(1036, 1025296640, 1025296895, 'MY', 'MYS', 'ماليزيا'),
(1037, 1025296896, 1025297407, 'SG', 'SGP', 'سنغافورة'),
(1038, 1025297408, 1025297919, 'AU', 'AUS', 'أستراليا'),
(1039, 1025297920, 1025298175, 'NZ', 'NZL', 'نيوزيلاندا'),
(1040, 1025298176, 1025298943, 'AU', 'AUS', 'أستراليا'),
(1041, 1025298944, 1025299199, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(1042, 1025299200, 1025300223, 'AU', 'AUS', 'أستراليا'),
(1043, 1025300224, 1025300479, 'SA', 'SAU', 'السعودية'),
(1044, 1025300480, 1025300735, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(1045, 1025300736, 1025300991, 'US', 'USA', 'الولايات المتحدة'),
(1046, 1025300992, 1025302527, 'AU', 'AUS', 'أستراليا'),
(1047, 1025302528, 1025310719, 'VN', 'VNM', 'فييتنام'),
(1048, 1025310720, 1025343487, 'AU', 'AUS', 'أستراليا'),
(1049, 1025343488, 1025376255, 'CN', 'CHN', 'الصين'),
(1050, 1025376256, 1025507327, 'TW', 'TWN', 'تايوان'),
(1051, 1025507328, 1026293759, 'KR', 'KOR', 'جمهورية كوريا'),
(1052, 1026293760, 1026392063, 'JP', 'JPN', 'اليابان'),
(1053, 1026392064, 1026408447, 'CN', 'CHN', 'الصين'),
(1054, 1026408448, 1026416639, 'JP', 'JPN', 'اليابان'),
(1055, 1026416640, 1026420735, 'AU', 'AUS', 'أستراليا'),
(1056, 1026420736, 1026422783, 'JP', 'JPN', 'اليابان'),
(1057, 1026422784, 1026424831, 'AU', 'AUS', 'أستراليا'),
(1058, 1026424832, 1026490367, 'JP', 'JPN', 'اليابان'),
(1059, 1026490368, 1026523135, 'TH', 'THA', 'تايلند'),
(1060, 1026523136, 1026539519, 'CN', 'CHN', 'الصين'),
(1061, 1026539520, 1026555903, 'KR', 'KOR', 'جمهورية كوريا'),
(1062, 1026555904, 1027080191, 'CN', 'CHN', 'الصين'),
(1063, 1027080192, 1027866623, 'TW', 'TWN', 'تايوان'),
(1064, 1027866624, 1027997695, 'AU', 'AUS', 'أستراليا'),
(1065, 1027997696, 1028128767, 'TW', 'TWN', 'تايوان'),
(1066, 1028128768, 1029046271, 'KR', 'KOR', 'جمهورية كوريا'),
(1067, 1029046272, 1029144575, 'JP', 'JPN', 'اليابان'),
(1068, 1029144576, 1029160959, 'SG', 'SGP', 'سنغافورة'),
(1069, 1029160960, 1029177343, 'CN', 'CHN', 'الصين'),
(1070, 1029177344, 1029242879, 'AU', 'AUS', 'أستراليا'),
(1071, 1029242880, 1029308415, 'JP', 'JPN', 'اليابان'),
(1072, 1029308416, 1029439487, 'TH', 'THA', 'تايلند'),
(1073, 1029439488, 1029570559, 'HK', 'HKG', 'هونغ كونغ'),
(1074, 1029570560, 1029636095, 'ID', 'IDN', 'إندونيسيا'),
(1075, 1029636096, 1029668863, 'AU', 'AUS', 'أستراليا'),
(1076, 1029668864, 1029701631, 'IN', 'IND', 'الهند'),
(1077, 1029701632, 1030750207, 'KR', 'KOR', 'جمهورية كوريا'),
(1078, 1030750208, 1031798783, 'JP', 'JPN', 'اليابان'),
(1079, 1031798784, 1035993087, 'CN', 'CHN', 'الصين'),
(1080, 1035993088, 1037565951, 'JP', 'JPN', 'اليابان'),
(1081, 1037565952, 1037591499, 'TW', 'TWN', 'تايوان'),
(1082, 1037591500, 1037591503, 'CN', 'CHN', 'الصين'),
(1083, 1037591504, 1038614527, 'TW', 'TWN', 'تايوان'),
(1084, 1038614528, 1039007743, 'CN', 'CHN', 'الصين'),
(1085, 1039007744, 1039138815, 'HK', 'HKG', 'هونغ كونغ'),
(1086, 1039138816, 1039400959, 'CN', 'CHN', 'الصين'),
(1087, 1039400960, 1039466495, 'HK', 'HKG', 'هونغ كونغ'),
(1088, 1039466496, 1039499263, 'JP', 'JPN', 'اليابان'),
(1089, 1039499264, 1039515647, 'AU', 'AUS', 'أستراليا'),
(1090, 1039515648, 1039523839, 'JP', 'JPN', 'اليابان'),
(1091, 1039523840, 1039532031, 'KR', 'KOR', 'جمهورية كوريا'),
(1092, 1039532032, 1039597567, 'IN', 'IND', 'الهند'),
(1093, 1039597568, 1039613951, 'ID', 'IDN', 'إندونيسيا'),
(1094, 1039613952, 1039638527, 'KR', 'KOR', 'جمهورية كوريا'),
(1095, 1039638528, 1039642623, 'TW', 'TWN', 'تايوان'),
(1096, 1039642624, 1039646719, 'AU', 'AUS', 'أستراليا'),
(1097, 1039646720, 1039654911, 'KR', 'KOR', 'جمهورية كوريا'),
(1098, 1039654912, 1039663103, 'IN', 'IND', 'الهند'),
(1099, 1039663104, 1040187391, 'KR', 'KOR', 'جمهورية كوريا'),
(1100, 1040187392, 1040252927, 'IL', 'ISR', 'إسرائيل'),
(1101, 1040252928, 1040318463, 'GR', 'GRC', 'اليونان'),
(1102, 1040318464, 1040383999, 'CH', 'CHE', 'سويسرا'),
(1103, 1040384000, 1040392191, 'SA', 'SAU', 'السعودية'),
(1104, 1040392192, 1040392447, 'GB', 'GBR', 'المملكة المتحدة'),
(1105, 1040392448, 1040399359, 'SA', 'SAU', 'السعودية'),
(1106, 1040399360, 1040400127, 'GB', 'GBR', 'المملكة المتحدة'),
(1107, 1040400128, 1040400383, 'SA', 'SAU', 'السعودية'),
(1108, 1040400384, 1040416767, 'GB', 'GBR', 'المملكة المتحدة'),
(1109, 1040416768, 1040424959, 'SE', 'SWE', 'السويد'),
(1110, 1040424960, 1040433151, 'PL', 'POL', 'بولندا'),
(1111, 1040433152, 1040449535, 'GB', 'GBR', 'المملكة المتحدة'),
(1112, 1040449536, 1040449791, 'FR', 'FRA', 'فرنسا'),
(1113, 1040449792, 1040450047, 'DE', 'DEU', 'ألمانيا'),
(1114, 1040450048, 1040457727, 'FR', 'FRA', 'فرنسا'),
(1115, 1040457728, 1040465919, 'ME', 'MNE', 'الجبل الأسود'),
(1116, 1040465920, 1040466687, 'DE', 'DEU', 'ألمانيا'),
(1117, 1040466976, 1040467007, 'DE', 'DEU', 'ألمانيا'),
(1118, 1040467072, 1040467087, 'FR', 'FRA', 'فرنسا'),
(1119, 1040467088, 1040467103, 'DE', 'DEU', 'ألمانيا'),
(1120, 1040467104, 1040467135, 'FR', 'FRA', 'فرنسا'),
(1121, 1040467136, 1040467151, 'DE', 'DEU', 'ألمانيا'),
(1122, 1040467584, 1040467647, 'FR', 'FRA', 'فرنسا'),
(1123, 1040467760, 1040467823, 'FR', 'FRA', 'فرنسا'),
(1124, 1040467936, 1040467951, 'FR', 'FRA', 'فرنسا'),
(1125, 1040467968, 1040468223, 'FR', 'FRA', 'فرنسا'),
(1126, 1040468232, 1040468255, 'FR', 'FRA', 'فرنسا'),
(1127, 1040468264, 1040468287, 'FR', 'FRA', 'فرنسا'),
(1128, 1040468416, 1040468479, 'FR', 'FRA', 'فرنسا'),
(1129, 1040468608, 1040468735, 'DE', 'DEU', 'ألمانيا'),
(1130, 1040468736, 1040468767, 'NL', 'NLD', 'هولندا'),
(1131, 1040468800, 1040468831, 'NL', 'NLD', 'هولندا'),
(1132, 1040468864, 1040468991, 'NL', 'NLD', 'هولندا'),
(1133, 1040469056, 1040469071, 'FR', 'FRA', 'فرنسا'),
(1134, 1040469088, 1040469183, 'FR', 'FRA', 'فرنسا'),
(1135, 1040469216, 1040469279, 'FR', 'FRA', 'فرنسا'),
(1136, 1040469312, 1040469343, 'FR', 'FRA', 'فرنسا'),
(1137, 1040469376, 1040469567, 'FR', 'FRA', 'فرنسا'),
(1138, 1040469632, 1040469887, 'FR', 'FRA', 'فرنسا'),
(1139, 1040469904, 1040469919, 'FR', 'FRA', 'فرنسا'),
(1140, 1040469968, 1040469999, 'FR', 'FRA', 'فرنسا'),
(1141, 1040470272, 1040470335, 'DE', 'DEU', 'ألمانيا'),
(1142, 1040470400, 1040470431, 'DE', 'DEU', 'ألمانيا'),
(1143, 1040470784, 1040471295, 'NL', 'NLD', 'هولندا'),
(1144, 1040471488, 1040471711, 'NL', 'NLD', 'هولندا'),
(1145, 1040471744, 1040471775, 'NL', 'NLD', 'هولندا'),
(1146, 1040472992, 1040473343, 'NL', 'NLD', 'هولندا'),
(1147, 1040473856, 1040474111, 'NL', 'NLD', 'هولندا'),
(1148, 1040474112, 1040482303, 'CZ', 'CZE', 'التشيك'),
(1149, 1040482304, 1040515071, 'BE', 'BEL', 'بلجيكا'),
(1150, 1040515072, 1040547839, 'GB', 'GBR', 'المملكة المتحدة'),
(1151, 1040547840, 1040580607, 'RU', 'RUS', 'الإتحاد الروسي'),
(1152, 1040580608, 1040711679, 'GB', 'GBR', 'المملكة المتحدة'),
(1153, 1040711680, 1040719871, 'FR', 'FRA', 'فرنسا'),
(1154, 1040719872, 1040728063, 'DE', 'DEU', 'ألمانيا'),
(1155, 1040736256, 1040744447, 'GB', 'GBR', 'المملكة المتحدة'),
(1156, 1040744448, 1040777215, 'DE', 'DEU', 'ألمانيا'),
(1157, 1040777216, 1040842751, 'IE', 'IRL', 'إيرلندا'),
(1158, 1040842752, 1040973823, 'IT', 'ITA', 'إيطاليا'),
(1159, 1040973824, 1040982015, 'NL', 'NLD', 'هولندا'),
(1160, 1040982016, 1040982279, 'DK', 'DNK', 'الدنيمارك'),
(1161, 1040982280, 1040982287, 'NG', 'NGA', 'نيجيريا'),
(1162, 1040982288, 1040982335, 'DK', 'DNK', 'الدنيمارك'),
(1163, 1040982336, 1040982351, 'ZW', 'ZWE', 'زمبابواي'),
(1164, 1040982352, 1040982359, 'GB', 'GBR', 'المملكة المتحدة'),
(1165, 1040982360, 1040982399, 'DK', 'DNK', 'الدنيمارك'),
(1166, 1040982400, 1040982407, 'CH', 'CHE', 'سويسرا'),
(1167, 1040982408, 1040982487, 'DK', 'DNK', 'الدنيمارك'),
(1168, 1040982488, 1040982495, 'IQ', 'IRQ', 'العراق'),
(1169, 1040982496, 1040982527, 'DK', 'DNK', 'الدنيمارك'),
(1170, 1040982528, 1040982535, 'IQ', 'IRQ', 'العراق'),
(1171, 1040982536, 1040982551, 'DK', 'DNK', 'الدنيمارك'),
(1172, 1040982552, 1040982559, 'FI', 'FIN', 'فنلندا'),
(1173, 1040982560, 1040982567, 'DK', 'DNK', 'الدنيمارك'),
(1174, 1040982568, 1040982575, 'IQ', 'IRQ', 'العراق'),
(1175, 1040982576, 1040982583, 'DK', 'DNK', 'الدنيمارك'),
(1176, 1040982584, 1040982591, 'IQ', 'IRQ', 'العراق'),
(1177, 1040982592, 1040982599, 'DK', 'DNK', 'الدنيمارك'),
(1178, 1040982600, 1040982615, 'IQ', 'IRQ', 'العراق'),
(1179, 1040982616, 1040982623, 'DK', 'DNK', 'الدنيمارك'),
(1180, 1040982624, 1040982631, 'FI', 'FIN', 'فنلندا'),
(1181, 1040982632, 1040982639, 'DE', 'DEU', 'ألمانيا'),
(1182, 1040982640, 1040982647, 'FI', 'FIN', 'فنلندا'),
(1183, 1040982648, 1040982655, 'GB', 'GBR', 'المملكة المتحدة'),
(1184, 1040982656, 1040982663, 'DE', 'DEU', 'ألمانيا'),
(1185, 1040982664, 1040982679, 'NL', 'NLD', 'هولندا'),
(1186, 1040982680, 1040982687, 'DK', 'DNK', 'الدنيمارك'),
(1187, 1040982688, 1040982695, 'FI', 'FIN', 'فنلندا'),
(1188, 1040982696, 1040982703, 'IR', 'IRN', 'إيران'),
(1189, 1040982704, 1040982743, 'FI', 'FIN', 'فنلندا'),
(1190, 1040982744, 1040982751, 'EG', 'EGY', 'مصر'),
(1191, 1040982752, 1040982759, 'FI', 'FIN', 'فنلندا'),
(1192, 1040982760, 1040982783, 'DK', 'DNK', 'الدنيمارك'),
(1193, 1040982784, 1040982911, 'MW', 'MWI', 'ملاوي'),
(1194, 1040982912, 1040983055, 'DK', 'DNK', 'الدنيمارك'),
(1195, 1040983056, 1040983063, 'IE', 'IRL', 'إيرلندا'),
(1196, 1040983064, 1040983079, 'DK', 'DNK', 'الدنيمارك'),
(1197, 1040983080, 1040983087, 'FI', 'FIN', 'فنلندا'),
(1198, 1040983088, 1040983095, 'DK', 'DNK', 'الدنيمارك'),
(1199, 1040983096, 1040983127, 'FI', 'FIN', 'فنلندا'),
(1200, 1040983128, 1040983159, 'DK', 'DNK', 'الدنيمارك'),
(1201, 1040983160, 1040983167, 'FI', 'FIN', 'فنلندا'),
(1202, 1040983168, 1040983359, 'DK', 'DNK', 'الدنيمارك'),
(1203, 1040983360, 1040983487, 'IQ', 'IRQ', 'العراق'),
(1204, 1040983488, 1040983551, 'DK', 'DNK', 'الدنيمارك'),
(1205, 1040983552, 1040983567, 'NG', 'NGA', 'نيجيريا'),
(1206, 1040983568, 1040983575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(1207, 1040983576, 1040983583, 'DK', 'DNK', 'الدنيمارك'),
(1208, 1040983584, 1040983599, 'PH', 'PHL', 'الفلبين'),
(1209, 1040983600, 1040983807, 'DK', 'DNK', 'الدنيمارك'),
(1210, 1040983808, 1040983815, 'NG', 'NGA', 'نيجيريا'),
(1211, 1040983816, 1040983823, 'KW', 'KWT', 'الكويت'),
(1212, 1040983824, 1040984055, 'DK', 'DNK', 'الدنيمارك'),
(1213, 1040984056, 1040984063, 'IQ', 'IRQ', 'العراق'),
(1214, 1040984064, 1040984071, 'NG', 'NGA', 'نيجيريا'),
(1215, 1040984072, 1040984103, 'DK', 'DNK', 'الدنيمارك'),
(1216, 1040984104, 1040984111, 'NG', 'NGA', 'نيجيريا'),
(1217, 1040984112, 1040984119, 'DK', 'DNK', 'الدنيمارك'),
(1218, 1040984120, 1040984135, 'NG', 'NGA', 'نيجيريا'),
(1219, 1040984136, 1040984143, 'DK', 'DNK', 'الدنيمارك'),
(1220, 1040984144, 1040984151, 'NG', 'NGA', 'نيجيريا'),
(1221, 1040984152, 1040984175, 'DK', 'DNK', 'الدنيمارك'),
(1222, 1040984176, 1040984183, 'NG', 'NGA', 'نيجيريا'),
(1223, 1040984184, 1040984191, 'SD', 'SDN', 'السودان'),
(1224, 1040984192, 1040990207, 'DK', 'DNK', 'الدنيمارك'),
(1225, 1040990208, 1040994303, 'CY', 'CYP', 'قبرص'),
(1226, 1040994304, 1040994815, 'RU', 'RUS', 'الإتحاد الروسي'),
(1227, 1040994816, 1040998399, 'CY', 'CYP', 'قبرص'),
(1228, 1041006592, 1041039359, 'CH', 'CHE', 'سويسرا'),
(1229, 1041039360, 1041051647, 'SE', 'SWE', 'السويد'),
(1230, 1041051648, 1041051839, 'NO', 'NOR', 'النرويج'),
(1231, 1041051840, 1041052159, 'SE', 'SWE', 'السويد'),
(1232, 1041052160, 1041052175, 'NO', 'NOR', 'النرويج'),
(1233, 1041052176, 1041072127, 'SE', 'SWE', 'السويد'),
(1234, 1041072128, 1041080319, 'GB', 'GBR', 'المملكة المتحدة'),
(1235, 1041080320, 1041088511, 'IT', 'ITA', 'إيطاليا'),
(1236, 1041088512, 1041096703, 'AT', 'AUT', 'النمسا'),
(1237, 1041096704, 1041235967, 'ES', 'ESP', 'إسبانيا'),
(1238, 1041235968, 1041244159, 'UA', 'UKR', 'أوكرانيا'),
(1239, 1041244160, 1041253119, 'RU', 'RUS', 'الإتحاد الروسي'),
(1240, 1041253120, 1041253375, 'TJ', 'TJK', 'طاجيكيستان'),
(1241, 1041253376, 1041268735, 'RU', 'RUS', 'الإتحاد الروسي'),
(1242, 1041268736, 1041301503, 'NO', 'NOR', 'النرويج'),
(1243, 1041301504, 1041301599, 'IE', 'IRL', 'إيرلندا'),
(1244, 1041301600, 1041301615, 'GB', 'GBR', 'المملكة المتحدة'),
(1245, 1041301616, 1041301887, 'IE', 'IRL', 'إيرلندا'),
(1246, 1041301888, 1041301919, 'GB', 'GBR', 'المملكة المتحدة'),
(1247, 1041301920, 1041302015, 'IE', 'IRL', 'إيرلندا'),
(1248, 1041302016, 1041302271, 'GB', 'GBR', 'المملكة المتحدة'),
(1249, 1041302272, 1041302303, 'IE', 'IRL', 'إيرلندا'),
(1250, 1041302304, 1041302319, 'GB', 'GBR', 'المملكة المتحدة'),
(1251, 1041302320, 1041305887, 'IE', 'IRL', 'إيرلندا'),
(1252, 1041305888, 1041305903, 'GB', 'GBR', 'المملكة المتحدة'),
(1253, 1041305904, 1041305919, 'IE', 'IRL', 'إيرلندا'),
(1254, 1041305920, 1041305983, 'GB', 'GBR', 'المملكة المتحدة'),
(1255, 1041305984, 1041306031, 'IE', 'IRL', 'إيرلندا'),
(1256, 1041306032, 1041306063, 'GB', 'GBR', 'المملكة المتحدة'),
(1257, 1041306064, 1041306399, 'IE', 'IRL', 'إيرلندا'),
(1258, 1041306400, 1041306495, 'GB', 'GBR', 'المملكة المتحدة'),
(1259, 1041306496, 1041306511, 'IE', 'IRL', 'إيرلندا'),
(1260, 1041306512, 1041306527, 'GB', 'GBR', 'المملكة المتحدة'),
(1261, 1041306528, 1041306607, 'IE', 'IRL', 'إيرلندا'),
(1262, 1041306608, 1041306671, 'GB', 'GBR', 'المملكة المتحدة'),
(1263, 1041306672, 1041306751, 'IE', 'IRL', 'إيرلندا'),
(1264, 1041306752, 1041306815, 'GB', 'GBR', 'المملكة المتحدة'),
(1265, 1041306816, 1041307551, 'IE', 'IRL', 'إيرلندا'),
(1266, 1041307552, 1041307599, 'GB', 'GBR', 'المملكة المتحدة'),
(1267, 1041307600, 1041308031, 'IE', 'IRL', 'إيرلندا'),
(1268, 1041308032, 1041308063, 'GB', 'GBR', 'المملكة المتحدة'),
(1269, 1041308064, 1041308287, 'IE', 'IRL', 'إيرلندا'),
(1270, 1041308288, 1041308303, 'GB', 'GBR', 'المملكة المتحدة'),
(1271, 1041308304, 1041308335, 'IE', 'IRL', 'إيرلندا'),
(1272, 1041308336, 1041308343, 'GB', 'GBR', 'المملكة المتحدة'),
(1273, 1041308344, 1041308415, 'IE', 'IRL', 'إيرلندا'),
(1274, 1041308416, 1041308671, 'GB', 'GBR', 'المملكة المتحدة'),
(1275, 1041308672, 1041310063, 'IE', 'IRL', 'إيرلندا'),
(1276, 1041310064, 1041310079, 'GB', 'GBR', 'المملكة المتحدة'),
(1277, 1041310080, 1041310511, 'IE', 'IRL', 'إيرلندا'),
(1278, 1041310512, 1041310527, 'GB', 'GBR', 'المملكة المتحدة'),
(1279, 1041310528, 1041334271, 'IE', 'IRL', 'إيرلندا'),
(1280, 1041334272, 1041334527, 'GB', 'GBR', 'المملكة المتحدة'),
(1281, 1041334528, 1041334783, 'IE', 'IRL', 'إيرلندا'),
(1282, 1041334784, 1041335039, 'GB', 'GBR', 'المملكة المتحدة'),
(1283, 1041335040, 1041335295, 'IE', 'IRL', 'إيرلندا'),
(1284, 1041335296, 1041335327, 'GB', 'GBR', 'المملكة المتحدة'),
(1285, 1041335328, 1041335343, 'IE', 'IRL', 'إيرلندا'),
(1286, 1041335344, 1041335359, 'GB', 'GBR', 'المملكة المتحدة'),
(1287, 1041335360, 1041335519, 'IE', 'IRL', 'إيرلندا'),
(1288, 1041335520, 1041335535, 'GB', 'GBR', 'المملكة المتحدة'),
(1289, 1041335536, 1041335551, 'IE', 'IRL', 'إيرلندا'),
(1290, 1041335552, 1041335807, 'GB', 'GBR', 'المملكة المتحدة'),
(1291, 1041335808, 1041335839, 'IE', 'IRL', 'إيرلندا'),
(1292, 1041335840, 1041335871, 'GB', 'GBR', 'المملكة المتحدة'),
(1293, 1041335872, 1041335887, 'IE', 'IRL', 'إيرلندا'),
(1294, 1041335888, 1041335895, 'GB', 'GBR', 'المملكة المتحدة'),
(1295, 1041335896, 1041335935, 'IE', 'IRL', 'إيرلندا'),
(1296, 1041335936, 1041335967, 'GB', 'GBR', 'المملكة المتحدة'),
(1297, 1041335968, 1041336015, 'IE', 'IRL', 'إيرلندا'),
(1298, 1041336016, 1041336031, 'GB', 'GBR', 'المملكة المتحدة'),
(1299, 1041336032, 1041336063, 'IE', 'IRL', 'إيرلندا'),
(1300, 1041336064, 1041336127, 'GB', 'GBR', 'المملكة المتحدة'),
(1301, 1041336128, 1041336207, 'IE', 'IRL', 'إيرلندا'),
(1302, 1041336208, 1041336223, 'GB', 'GBR', 'المملكة المتحدة'),
(1303, 1041336224, 1041336303, 'IE', 'IRL', 'إيرلندا'),
(1304, 1041336304, 1041336319, 'GB', 'GBR', 'المملكة المتحدة'),
(1305, 1041336320, 1041337471, 'IE', 'IRL', 'إيرلندا'),
(1306, 1041337472, 1041337487, 'GB', 'GBR', 'المملكة المتحدة'),
(1307, 1041337488, 1041337663, 'IE', 'IRL', 'إيرلندا'),
(1308, 1041337664, 1041337695, 'GB', 'GBR', 'المملكة المتحدة'),
(1309, 1041337696, 1041337727, 'IE', 'IRL', 'إيرلندا'),
(1310, 1041337728, 1041337791, 'GB', 'GBR', 'المملكة المتحدة'),
(1311, 1041337792, 1041337855, 'IE', 'IRL', 'إيرلندا'),
(1312, 1041337856, 1041337887, 'GB', 'GBR', 'المملكة المتحدة'),
(1313, 1041337888, 1041337919, 'IE', 'IRL', 'إيرلندا'),
(1314, 1041337920, 1041337935, 'GB', 'GBR', 'المملكة المتحدة'),
(1315, 1041337936, 1041337999, 'IE', 'IRL', 'إيرلندا'),
(1316, 1041338000, 1041338015, 'GB', 'GBR', 'المملكة المتحدة'),
(1317, 1041338016, 1041338031, 'IE', 'IRL', 'إيرلندا'),
(1318, 1041338032, 1041338111, 'GB', 'GBR', 'المملكة المتحدة'),
(1319, 1041338112, 1041338751, 'IE', 'IRL', 'إيرلندا'),
(1320, 1041338752, 1041338815, 'GB', 'GBR', 'المملكة المتحدة'),
(1321, 1041338816, 1041338831, 'IE', 'IRL', 'إيرلندا'),
(1322, 1041338832, 1041338847, 'GB', 'GBR', 'المملكة المتحدة'),
(1323, 1041338848, 1041338879, 'IE', 'IRL', 'إيرلندا'),
(1324, 1041338880, 1041338895, 'GB', 'GBR', 'المملكة المتحدة'),
(1325, 1041338896, 1041338943, 'IE', 'IRL', 'إيرلندا'),
(1326, 1041338944, 1041339007, 'GB', 'GBR', 'المملكة المتحدة'),
(1327, 1041339008, 1041339087, 'IE', 'IRL', 'إيرلندا'),
(1328, 1041339088, 1041339119, 'GB', 'GBR', 'المملكة المتحدة'),
(1329, 1041339120, 1041339263, 'IE', 'IRL', 'إيرلندا'),
(1330, 1041339264, 1041339327, 'GB', 'GBR', 'المملكة المتحدة'),
(1331, 1041339328, 1041339359, 'IE', 'IRL', 'إيرلندا'),
(1332, 1041339360, 1041339391, 'GB', 'GBR', 'المملكة المتحدة'),
(1333, 1041339392, 1041339423, 'IE', 'IRL', 'إيرلندا'),
(1334, 1041339424, 1041339439, 'GB', 'GBR', 'المملكة المتحدة'),
(1335, 1041339440, 1041339519, 'IE', 'IRL', 'إيرلندا'),
(1336, 1041339520, 1041339535, 'GB', 'GBR', 'المملكة المتحدة'),
(1337, 1041339536, 1041339679, 'IE', 'IRL', 'إيرلندا'),
(1338, 1041339680, 1041339711, 'GB', 'GBR', 'المملكة المتحدة'),
(1339, 1041339712, 1041339935, 'IE', 'IRL', 'إيرلندا'),
(1340, 1041339936, 1041339967, 'GB', 'GBR', 'المملكة المتحدة'),
(1341, 1041339968, 1041340063, 'IE', 'IRL', 'إيرلندا'),
(1342, 1041340064, 1041340079, 'GB', 'GBR', 'المملكة المتحدة'),
(1343, 1041340080, 1041340111, 'IE', 'IRL', 'إيرلندا'),
(1344, 1041340112, 1041340127, 'GB', 'GBR', 'المملكة المتحدة'),
(1345, 1041340128, 1041340191, 'IE', 'IRL', 'إيرلندا'),
(1346, 1041340192, 1041340223, 'GB', 'GBR', 'المملكة المتحدة'),
(1347, 1041340224, 1041340255, 'IE', 'IRL', 'إيرلندا'),
(1348, 1041340256, 1041340271, 'GB', 'GBR', 'المملكة المتحدة'),
(1349, 1041340272, 1041340319, 'IE', 'IRL', 'إيرلندا'),
(1350, 1041340320, 1041340335, 'GB', 'GBR', 'المملكة المتحدة'),
(1351, 1041340336, 1041340367, 'IE', 'IRL', 'إيرلندا'),
(1352, 1041340368, 1041340383, 'GB', 'GBR', 'المملكة المتحدة'),
(1353, 1041340384, 1041340447, 'IE', 'IRL', 'إيرلندا'),
(1354, 1041340448, 1041340463, 'GB', 'GBR', 'المملكة المتحدة'),
(1355, 1041340464, 1041340559, 'IE', 'IRL', 'إيرلندا'),
(1356, 1041340560, 1041340607, 'GB', 'GBR', 'المملكة المتحدة'),
(1357, 1041340608, 1041340639, 'IE', 'IRL', 'إيرلندا'),
(1358, 1041340640, 1041340671, 'GB', 'GBR', 'المملكة المتحدة'),
(1359, 1041340672, 1041340735, 'IE', 'IRL', 'إيرلندا'),
(1360, 1041340736, 1041340751, 'GB', 'GBR', 'المملكة المتحدة'),
(1361, 1041340752, 1041340799, 'IE', 'IRL', 'إيرلندا'),
(1362, 1041340800, 1041340863, 'GB', 'GBR', 'المملكة المتحدة'),
(1363, 1041340864, 1041340991, 'IE', 'IRL', 'إيرلندا'),
(1364, 1041340992, 1041341007, 'GB', 'GBR', 'المملكة المتحدة'),
(1365, 1041341008, 1041341151, 'IE', 'IRL', 'إيرلندا'),
(1366, 1041341152, 1041341183, 'GB', 'GBR', 'المملكة المتحدة'),
(1367, 1041341184, 1041341231, 'IE', 'IRL', 'إيرلندا'),
(1368, 1041341232, 1041341247, 'GB', 'GBR', 'المملكة المتحدة'),
(1369, 1041341248, 1041341295, 'IE', 'IRL', 'إيرلندا'),
(1370, 1041341296, 1041341343, 'GB', 'GBR', 'المملكة المتحدة'),
(1371, 1041341344, 1041341855, 'IE', 'IRL', 'إيرلندا'),
(1372, 1041341856, 1041341887, 'GB', 'GBR', 'المملكة المتحدة'),
(1373, 1041341888, 1041341919, 'IE', 'IRL', 'إيرلندا'),
(1374, 1041341920, 1041341935, 'GB', 'GBR', 'المملكة المتحدة'),
(1375, 1041341936, 1041342063, 'IE', 'IRL', 'إيرلندا'),
(1376, 1041342064, 1041342079, 'GB', 'GBR', 'المملكة المتحدة'),
(1377, 1041342080, 1041342207, 'IE', 'IRL', 'إيرلندا'),
(1378, 1041342208, 1041342223, 'GB', 'GBR', 'المملكة المتحدة'),
(1379, 1041342224, 1041342239, 'IE', 'IRL', 'إيرلندا'),
(1380, 1041342240, 1041342255, 'GB', 'GBR', 'المملكة المتحدة'),
(1381, 1041342256, 1041342383, 'IE', 'IRL', 'إيرلندا'),
(1382, 1041342384, 1041342415, 'GB', 'GBR', 'المملكة المتحدة'),
(1383, 1041342416, 1041342431, 'IE', 'IRL', 'إيرلندا'),
(1384, 1041342432, 1041342463, 'GB', 'GBR', 'المملكة المتحدة'),
(1385, 1041342464, 1041342479, 'IE', 'IRL', 'إيرلندا'),
(1386, 1041342480, 1041342511, 'GB', 'GBR', 'المملكة المتحدة'),
(1387, 1041342512, 1041342543, 'IE', 'IRL', 'إيرلندا'),
(1388, 1041342544, 1041342575, 'GB', 'GBR', 'المملكة المتحدة'),
(1389, 1041342576, 1041342591, 'IE', 'IRL', 'إيرلندا'),
(1390, 1041342592, 1041342607, 'GB', 'GBR', 'المملكة المتحدة'),
(1391, 1041342608, 1041342975, 'IE', 'IRL', 'إيرلندا'),
(1392, 1041342976, 1041343023, 'GB', 'GBR', 'المملكة المتحدة'),
(1393, 1041343024, 1041343055, 'IE', 'IRL', 'إيرلندا'),
(1394, 1041343056, 1041343103, 'GB', 'GBR', 'المملكة المتحدة'),
(1395, 1041343104, 1041343487, 'IE', 'IRL', 'إيرلندا'),
(1396, 1041343488, 1041343743, 'GB', 'GBR', 'المملكة المتحدة'),
(1397, 1041343744, 1041344111, 'IE', 'IRL', 'إيرلندا'),
(1398, 1041344112, 1041344159, 'GB', 'GBR', 'المملكة المتحدة'),
(1399, 1041344160, 1041344255, 'IE', 'IRL', 'إيرلندا'),
(1400, 1041344256, 1041344511, 'GB', 'GBR', 'المملكة المتحدة'),
(1401, 1041344512, 1041344607, 'IE', 'IRL', 'إيرلندا'),
(1402, 1041344608, 1041344639, 'GB', 'GBR', 'المملكة المتحدة'),
(1403, 1041344640, 1041344687, 'IE', 'IRL', 'إيرلندا'),
(1404, 1041344688, 1041344719, 'GB', 'GBR', 'المملكة المتحدة'),
(1405, 1041344720, 1041344799, 'IE', 'IRL', 'إيرلندا'),
(1406, 1041344800, 1041344831, 'GB', 'GBR', 'المملكة المتحدة'),
(1407, 1041344832, 1041344895, 'IE', 'IRL', 'إيرلندا'),
(1408, 1041344896, 1041344927, 'GB', 'GBR', 'المملكة المتحدة'),
(1409, 1041344928, 1041345551, 'IE', 'IRL', 'إيرلندا'),
(1410, 1041345552, 1041345583, 'GB', 'GBR', 'المملكة المتحدة'),
(1411, 1041345584, 1041345599, 'IE', 'IRL', 'إيرلندا'),
(1412, 1041345600, 1041345631, 'GB', 'GBR', 'المملكة المتحدة'),
(1413, 1041345632, 1041345647, 'IE', 'IRL', 'إيرلندا'),
(1414, 1041345648, 1041345663, 'GB', 'GBR', 'المملكة المتحدة'),
(1415, 1041345664, 1041345759, 'IE', 'IRL', 'إيرلندا'),
(1416, 1041345760, 1041345767, 'GB', 'GBR', 'المملكة المتحدة'),
(1417, 1041345768, 1041345775, 'IE', 'IRL', 'إيرلندا'),
(1418, 1041345776, 1041345791, 'GB', 'GBR', 'المملكة المتحدة'),
(1419, 1041345792, 1041346047, 'IE', 'IRL', 'إيرلندا'),
(1420, 1041346048, 1041346079, 'GB', 'GBR', 'المملكة المتحدة'),
(1421, 1041346080, 1041346095, 'IE', 'IRL', 'إيرلندا'),
(1422, 1041346096, 1041346119, 'GB', 'GBR', 'المملكة المتحدة'),
(1423, 1041346120, 1041346135, 'IE', 'IRL', 'إيرلندا'),
(1424, 1041346136, 1041346143, 'GB', 'GBR', 'المملكة المتحدة'),
(1425, 1041346144, 1041346151, 'IE', 'IRL', 'إيرلندا'),
(1426, 1041346152, 1041346159, 'GB', 'GBR', 'المملكة المتحدة'),
(1427, 1041346160, 1041346207, 'IE', 'IRL', 'إيرلندا'),
(1428, 1041346208, 1041346215, 'GB', 'GBR', 'المملكة المتحدة'),
(1429, 1041346216, 1041346255, 'IE', 'IRL', 'إيرلندا'),
(1430, 1041346256, 1041346263, 'GB', 'GBR', 'المملكة المتحدة'),
(1431, 1041346264, 1041347071, 'IE', 'IRL', 'إيرلندا'),
(1432, 1041347072, 1041347391, 'GB', 'GBR', 'المملكة المتحدة'),
(1433, 1041347392, 1041358047, 'IE', 'IRL', 'إيرلندا'),
(1434, 1041358048, 1041358079, 'GB', 'GBR', 'المملكة المتحدة'),
(1435, 1041358080, 1041362959, 'IE', 'IRL', 'إيرلندا'),
(1436, 1041362960, 1041362975, 'GB', 'GBR', 'المملكة المتحدة'),
(1437, 1041362976, 1041363007, 'IE', 'IRL', 'إيرلندا'),
(1438, 1041363008, 1041363023, 'GB', 'GBR', 'المملكة المتحدة'),
(1439, 1041363024, 1041363167, 'IE', 'IRL', 'إيرلندا'),
(1440, 1041363168, 1041363455, 'GB', 'GBR', 'المملكة المتحدة'),
(1441, 1041363456, 1041363711, 'IE', 'IRL', 'إيرلندا'),
(1442, 1041363712, 1041363751, 'GB', 'GBR', 'المملكة المتحدة'),
(1443, 1041363752, 1041363759, 'IE', 'IRL', 'إيرلندا'),
(1444, 1041363760, 1041363775, 'GB', 'GBR', 'المملكة المتحدة'),
(1445, 1041363776, 1041363839, 'IE', 'IRL', 'إيرلندا'),
(1446, 1041363840, 1041363871, 'GB', 'GBR', 'المملكة المتحدة'),
(1447, 1041363872, 1041364495, 'IE', 'IRL', 'إيرلندا'),
(1448, 1041364496, 1041364575, 'GB', 'GBR', 'المملكة المتحدة'),
(1449, 1041364576, 1041364607, 'IE', 'IRL', 'إيرلندا'),
(1450, 1041364608, 1041364735, 'GB', 'GBR', 'المملكة المتحدة'),
(1451, 1041364736, 1041365039, 'IE', 'IRL', 'إيرلندا'),
(1452, 1041365040, 1041365055, 'GB', 'GBR', 'المملكة المتحدة'),
(1453, 1041365056, 1041365087, 'IE', 'IRL', 'إيرلندا'),
(1454, 1041365088, 1041365103, 'GB', 'GBR', 'المملكة المتحدة'),
(1455, 1041365104, 1041365151, 'IE', 'IRL', 'إيرلندا'),
(1456, 1041365152, 1041365167, 'GB', 'GBR', 'المملكة المتحدة'),
(1457, 1041365168, 1041365199, 'IE', 'IRL', 'إيرلندا'),
(1458, 1041365200, 1041365247, 'GB', 'GBR', 'المملكة المتحدة'),
(1459, 1041365248, 1041365503, 'IE', 'IRL', 'إيرلندا'),
(1460, 1041365504, 1041365743, 'GB', 'GBR', 'المملكة المتحدة'),
(1461, 1041365744, 1041366031, 'IE', 'IRL', 'إيرلندا'),
(1462, 1041366032, 1041366079, 'GB', 'GBR', 'المملكة المتحدة'),
(1463, 1041366080, 1041366119, 'IE', 'IRL', 'إيرلندا'),
(1464, 1041366120, 1041366127, 'GB', 'GBR', 'المملكة المتحدة'),
(1465, 1041366128, 1041366143, 'IE', 'IRL', 'إيرلندا'),
(1466, 1041366144, 1041366207, 'GB', 'GBR', 'المملكة المتحدة'),
(1467, 1041366208, 1041366271, 'IE', 'IRL', 'إيرلندا'),
(1468, 1041366272, 1041366527, 'GB', 'GBR', 'المملكة المتحدة'),
(1469, 1041366528, 1041367039, 'IE', 'IRL', 'إيرلندا'),
(1470, 1041367040, 1041498111, 'GB', 'GBR', 'المملكة المتحدة'),
(1471, 1041498112, 1041563647, 'SE', 'SWE', 'السويد'),
(1472, 1041563648, 1041596415, 'PL', 'POL', 'بولندا'),
(1473, 1041596416, 1041629183, 'NL', 'NLD', 'هولندا'),
(1474, 1041629184, 1041633103, 'ES', 'ESP', 'إسبانيا'),
(1475, 1041633104, 1041633119, 'GB', 'GBR', 'المملكة المتحدة'),
(1476, 1041633120, 1041694719, 'ES', 'ESP', 'إسبانيا'),
(1477, 1041694720, 1041694847, 'FR', 'FRA', 'فرنسا'),
(1478, 1041694848, 1041694863, 'GB', 'GBR', 'المملكة المتحدة'),
(1479, 1041694864, 1041694895, 'FR', 'FRA', 'فرنسا'),
(1480, 1041694896, 1041694911, 'GB', 'GBR', 'المملكة المتحدة'),
(1481, 1041694912, 1041694919, 'FR', 'FRA', 'فرنسا'),
(1482, 1041694920, 1041694943, 'GB', 'GBR', 'المملكة المتحدة'),
(1483, 1041694944, 1041694959, 'FR', 'FRA', 'فرنسا'),
(1484, 1041694960, 1041694975, 'GB', 'GBR', 'المملكة المتحدة'),
(1485, 1041694976, 1041695711, 'FR', 'FRA', 'فرنسا'),
(1486, 1041695712, 1041695719, 'GB', 'GBR', 'المملكة المتحدة'),
(1487, 1041695720, 1041695727, 'FR', 'FRA', 'فرنسا'),
(1488, 1041695728, 1041695743, 'GB', 'GBR', 'المملكة المتحدة'),
(1489, 1041695744, 1041695759, 'FR', 'FRA', 'فرنسا'),
(1490, 1041695760, 1041695999, 'GB', 'GBR', 'المملكة المتحدة'),
(1491, 1041696000, 1041696831, 'FR', 'FRA', 'فرنسا'),
(1492, 1041696832, 1041696895, 'GB', 'GBR', 'المملكة المتحدة'),
(1493, 1041696896, 1041696911, 'FR', 'FRA', 'فرنسا'),
(1494, 1041696912, 1041696927, 'GB', 'GBR', 'المملكة المتحدة'),
(1495, 1041696928, 1041697699, 'FR', 'FRA', 'فرنسا'),
(1496, 1041697700, 1041697703, 'GB', 'GBR', 'المملكة المتحدة'),
(1497, 1041697704, 1041697727, 'FR', 'FRA', 'فرنسا'),
(1498, 1041697728, 1041697743, 'GB', 'GBR', 'المملكة المتحدة'),
(1499, 1041697744, 1041697823, 'FR', 'FRA', 'فرنسا'),
(1500, 1041697824, 1041697831, 'GB', 'GBR', 'المملكة المتحدة'),
(1501, 1041697832, 1041697855, 'FR', 'FRA', 'فرنسا'),
(1502, 1041697856, 1041697863, 'GB', 'GBR', 'المملكة المتحدة'),
(1503, 1041697864, 1041697895, 'FR', 'FRA', 'فرنسا'),
(1504, 1041697896, 1041697903, 'GB', 'GBR', 'المملكة المتحدة'),
(1505, 1041697904, 1041697919, 'FR', 'FRA', 'فرنسا'),
(1506, 1041697920, 1041697983, 'GB', 'GBR', 'المملكة المتحدة'),
(1507, 1041697984, 1041698135, 'FR', 'FRA', 'فرنسا'),
(1508, 1041698136, 1041698143, 'GB', 'GBR', 'المملكة المتحدة'),
(1509, 1041698144, 1041698247, 'FR', 'FRA', 'فرنسا'),
(1510, 1041698248, 1041698255, 'GB', 'GBR', 'المملكة المتحدة'),
(1511, 1041698256, 1041698263, 'FR', 'FRA', 'فرنسا'),
(1512, 1041698264, 1041698271, 'GB', 'GBR', 'المملكة المتحدة'),
(1513, 1041698272, 1041698591, 'FR', 'FRA', 'فرنسا'),
(1514, 1041698592, 1041698607, 'GB', 'GBR', 'المملكة المتحدة'),
(1515, 1041698608, 1041698703, 'FR', 'FRA', 'فرنسا'),
(1516, 1041698704, 1041698719, 'GB', 'GBR', 'المملكة المتحدة'),
(1517, 1041698720, 1041698727, 'FR', 'FRA', 'فرنسا'),
(1518, 1041698728, 1041698735, 'GB', 'GBR', 'المملكة المتحدة'),
(1519, 1041698736, 1041698807, 'FR', 'FRA', 'فرنسا'),
(1520, 1041698808, 1041698815, 'GB', 'GBR', 'المملكة المتحدة'),
(1521, 1041698816, 1041699287, 'FR', 'FRA', 'فرنسا'),
(1522, 1041699288, 1041699295, 'GB', 'GBR', 'المملكة المتحدة'),
(1523, 1041699296, 1041699583, 'FR', 'FRA', 'فرنسا'),
(1524, 1041699584, 1041699591, 'IT', 'ITA', 'إيطاليا'),
(1525, 1041699592, 1041699615, 'GB', 'GBR', 'المملكة المتحدة'),
(1526, 1041699616, 1041699623, 'FR', 'FRA', 'فرنسا'),
(1527, 1041699624, 1041699631, 'GB', 'GBR', 'المملكة المتحدة'),
(1528, 1041699632, 1041699767, 'FR', 'FRA', 'فرنسا'),
(1529, 1041699768, 1041699807, 'GB', 'GBR', 'المملكة المتحدة'),
(1530, 1041699808, 1041700383, 'FR', 'FRA', 'فرنسا'),
(1531, 1041700384, 1041700607, 'GB', 'GBR', 'المملكة المتحدة'),
(1532, 1041700608, 1041700863, 'FR', 'FRA', 'فرنسا'),
(1533, 1041700864, 1041700895, 'GB', 'GBR', 'المملكة المتحدة'),
(1534, 1041700896, 1041700919, 'FR', 'FRA', 'فرنسا'),
(1535, 1041700920, 1041700927, 'GB', 'GBR', 'المملكة المتحدة'),
(1536, 1041700928, 1041700959, 'FR', 'FRA', 'فرنسا'),
(1537, 1041700960, 1041700967, 'GB', 'GBR', 'المملكة المتحدة'),
(1538, 1041700968, 1041700983, 'FR', 'FRA', 'فرنسا'),
(1539, 1041700984, 1041700991, 'GB', 'GBR', 'المملكة المتحدة'),
(1540, 1041700992, 1041701119, 'FR', 'FRA', 'فرنسا'),
(1541, 1041701120, 1041701151, 'GB', 'GBR', 'المملكة المتحدة'),
(1542, 1041701152, 1041701175, 'FR', 'FRA', 'فرنسا'),
(1543, 1041701176, 1041701231, 'GB', 'GBR', 'المملكة المتحدة'),
(1544, 1041701232, 1041701239, 'FR', 'FRA', 'فرنسا'),
(1545, 1041701240, 1041701247, 'GB', 'GBR', 'المملكة المتحدة'),
(1546, 1041701248, 1041701311, 'FR', 'FRA', 'فرنسا'),
(1547, 1041701312, 1041701551, 'GB', 'GBR', 'المملكة المتحدة'),
(1548, 1041701552, 1041701567, 'FR', 'FRA', 'فرنسا'),
(1549, 1041701568, 1041701631, 'GB', 'GBR', 'المملكة المتحدة'),
(1550, 1041701632, 1041701727, 'FR', 'FRA', 'فرنسا'),
(1551, 1041701728, 1041701735, 'GB', 'GBR', 'المملكة المتحدة'),
(1552, 1041701736, 1041701783, 'FR', 'FRA', 'فرنسا'),
(1553, 1041701784, 1041701791, 'GB', 'GBR', 'المملكة المتحدة'),
(1554, 1041701792, 1041701839, 'FR', 'FRA', 'فرنسا'),
(1555, 1041701840, 1041701847, 'GB', 'GBR', 'المملكة المتحدة'),
(1556, 1041701848, 1041701935, 'FR', 'FRA', 'فرنسا'),
(1557, 1041701936, 1041701951, 'GB', 'GBR', 'المملكة المتحدة'),
(1558, 1041701952, 1041702127, 'FR', 'FRA', 'فرنسا'),
(1559, 1041702128, 1041702143, 'GB', 'GBR', 'المملكة المتحدة'),
(1560, 1041702144, 1041702175, 'FR', 'FRA', 'فرنسا'),
(1561, 1041702176, 1041702183, 'GB', 'GBR', 'المملكة المتحدة'),
(1562, 1041702184, 1041702255, 'FR', 'FRA', 'فرنسا'),
(1563, 1041702256, 1041702263, 'GB', 'GBR', 'المملكة المتحدة'),
(1564, 1041702264, 1041702303, 'FR', 'FRA', 'فرنسا'),
(1565, 1041702304, 1041702311, 'GB', 'GBR', 'المملكة المتحدة'),
(1566, 1041702312, 1041702327, 'FR', 'FRA', 'فرنسا'),
(1567, 1041702328, 1041702335, 'GB', 'GBR', 'المملكة المتحدة'),
(1568, 1041702336, 1041702351, 'FR', 'FRA', 'فرنسا'),
(1569, 1041702352, 1041702487, 'GB', 'GBR', 'المملكة المتحدة'),
(1570, 1041702488, 1041702491, 'FR', 'FRA', 'فرنسا'),
(1571, 1041702492, 1041702623, 'GB', 'GBR', 'المملكة المتحدة'),
(1572, 1041702624, 1041702639, 'FR', 'FRA', 'فرنسا'),
(1573, 1041702640, 1041702655, 'GB', 'GBR', 'المملكة المتحدة'),
(1574, 1041702656, 1041703511, 'FR', 'FRA', 'فرنسا'),
(1575, 1041703512, 1041703519, 'GB', 'GBR', 'المملكة المتحدة'),
(1576, 1041703520, 1041703567, 'FR', 'FRA', 'فرنسا'),
(1577, 1041703568, 1041703615, 'GB', 'GBR', 'المملكة المتحدة'),
(1578, 1041703616, 1041703951, 'FR', 'FRA', 'فرنسا'),
(1579, 1041703952, 1041703967, 'GB', 'GBR', 'المملكة المتحدة'),
(1580, 1041703968, 1041703991, 'FR', 'FRA', 'فرنسا'),
(1581, 1041703992, 1041703999, 'GB', 'GBR', 'المملكة المتحدة'),
(1582, 1041704000, 1041704015, 'FR', 'FRA', 'فرنسا'),
(1583, 1041704016, 1041704039, 'GB', 'GBR', 'المملكة المتحدة'),
(1584, 1041704040, 1041704111, 'FR', 'FRA', 'فرنسا'),
(1585, 1041704112, 1041704127, 'GB', 'GBR', 'المملكة المتحدة'),
(1586, 1041704128, 1041704159, 'FR', 'FRA', 'فرنسا'),
(1587, 1041704160, 1041704175, 'GB', 'GBR', 'المملكة المتحدة'),
(1588, 1041704176, 1041704255, 'FR', 'FRA', 'فرنسا'),
(1589, 1041704256, 1041704271, 'GB', 'GBR', 'المملكة المتحدة'),
(1590, 1041704272, 1041704279, 'FR', 'FRA', 'فرنسا'),
(1591, 1041704280, 1041704287, 'GB', 'GBR', 'المملكة المتحدة'),
(1592, 1041704288, 1041704319, 'FR', 'FRA', 'فرنسا'),
(1593, 1041704320, 1041704335, 'GB', 'GBR', 'المملكة المتحدة'),
(1594, 1041704336, 1041704399, 'FR', 'FRA', 'فرنسا'),
(1595, 1041704400, 1041704431, 'GB', 'GBR', 'المملكة المتحدة'),
(1596, 1041704432, 1041704439, 'FR', 'FRA', 'فرنسا'),
(1597, 1041704440, 1041704455, 'GB', 'GBR', 'المملكة المتحدة'),
(1598, 1041704456, 1041704463, 'FR', 'FRA', 'فرنسا'),
(1599, 1041704464, 1041704487, 'GB', 'GBR', 'المملكة المتحدة'),
(1600, 1041704488, 1041704503, 'FR', 'FRA', 'فرنسا'),
(1601, 1041704504, 1041704511, 'GB', 'GBR', 'المملكة المتحدة'),
(1602, 1041704512, 1041704535, 'FR', 'FRA', 'فرنسا'),
(1603, 1041704536, 1041704575, 'GB', 'GBR', 'المملكة المتحدة'),
(1604, 1041704576, 1041704607, 'FR', 'FRA', 'فرنسا'),
(1605, 1041704608, 1041704623, 'GB', 'GBR', 'المملكة المتحدة'),
(1606, 1041704624, 1041704647, 'FR', 'FRA', 'فرنسا'),
(1607, 1041704648, 1041704655, 'GB', 'GBR', 'المملكة المتحدة'),
(1608, 1041704656, 1041704671, 'FR', 'FRA', 'فرنسا'),
(1609, 1041704672, 1041704687, 'GB', 'GBR', 'المملكة المتحدة'),
(1610, 1041704688, 1041704703, 'FR', 'FRA', 'فرنسا'),
(1611, 1041704704, 1041704711, 'GB', 'GBR', 'المملكة المتحدة'),
(1612, 1041704712, 1041704743, 'FR', 'FRA', 'فرنسا'),
(1613, 1041704744, 1041704759, 'GB', 'GBR', 'المملكة المتحدة'),
(1614, 1041704760, 1041704775, 'FR', 'FRA', 'فرنسا'),
(1615, 1041704776, 1041704783, 'GB', 'GBR', 'المملكة المتحدة'),
(1616, 1041704784, 1041704815, 'FR', 'FRA', 'فرنسا'),
(1617, 1041704816, 1041704823, 'GB', 'GBR', 'المملكة المتحدة'),
(1618, 1041704824, 1041704831, 'FR', 'FRA', 'فرنسا'),
(1619, 1041704832, 1041704863, 'GB', 'GBR', 'المملكة المتحدة'),
(1620, 1041704864, 1041704879, 'FR', 'FRA', 'فرنسا'),
(1621, 1041704880, 1041704887, 'GB', 'GBR', 'المملكة المتحدة'),
(1622, 1041704888, 1041705231, 'FR', 'FRA', 'فرنسا'),
(1623, 1041705232, 1041705239, 'GB', 'GBR', 'المملكة المتحدة'),
(1624, 1041705240, 1041705255, 'FR', 'FRA', 'فرنسا'),
(1625, 1041705256, 1041705279, 'GB', 'GBR', 'المملكة المتحدة'),
(1626, 1041705280, 1041705295, 'FR', 'FRA', 'فرنسا'),
(1627, 1041705296, 1041705311, 'GB', 'GBR', 'المملكة المتحدة'),
(1628, 1041705312, 1041705343, 'FR', 'FRA', 'فرنسا'),
(1629, 1041705344, 1041705367, 'GB', 'GBR', 'المملكة المتحدة'),
(1630, 1041705368, 1041705391, 'FR', 'FRA', 'فرنسا'),
(1631, 1041705392, 1041705439, 'GB', 'GBR', 'المملكة المتحدة'),
(1632, 1041705440, 1041705447, 'FR', 'FRA', 'فرنسا'),
(1633, 1041705448, 1041705455, 'GB', 'GBR', 'المملكة المتحدة'),
(1634, 1041705456, 1041705471, 'FR', 'FRA', 'فرنسا'),
(1635, 1041705472, 1041705519, 'GB', 'GBR', 'المملكة المتحدة'),
(1636, 1041705520, 1041705527, 'FR', 'FRA', 'فرنسا'),
(1637, 1041705528, 1041705535, 'GB', 'GBR', 'المملكة المتحدة'),
(1638, 1041705536, 1041705599, 'FR', 'FRA', 'فرنسا'),
(1639, 1041705600, 1041705663, 'GB', 'GBR', 'المملكة المتحدة'),
(1640, 1041705664, 1041705695, 'FR', 'FRA', 'فرنسا'),
(1641, 1041705696, 1041705703, 'GB', 'GBR', 'المملكة المتحدة'),
(1642, 1041705704, 1041705727, 'FR', 'FRA', 'فرنسا'),
(1643, 1041705728, 1041705815, 'GB', 'GBR', 'المملكة المتحدة'),
(1644, 1041705816, 1041705831, 'FR', 'FRA', 'فرنسا'),
(1645, 1041705832, 1041705855, 'GB', 'GBR', 'المملكة المتحدة'),
(1646, 1041705856, 1041705871, 'FR', 'FRA', 'فرنسا'),
(1647, 1041705872, 1041705879, 'GB', 'GBR', 'المملكة المتحدة'),
(1648, 1041705880, 1041705887, 'FR', 'FRA', 'فرنسا'),
(1649, 1041705888, 1041705895, 'GB', 'GBR', 'المملكة المتحدة'),
(1650, 1041705896, 1041705903, 'FR', 'FRA', 'فرنسا'),
(1651, 1041705904, 1041705911, 'GB', 'GBR', 'المملكة المتحدة'),
(1652, 1041705912, 1041705935, 'FR', 'FRA', 'فرنسا'),
(1653, 1041705936, 1041705951, 'GB', 'GBR', 'المملكة المتحدة'),
(1654, 1041705952, 1041705999, 'FR', 'FRA', 'فرنسا'),
(1655, 1041706000, 1041706007, 'GB', 'GBR', 'المملكة المتحدة'),
(1656, 1041706008, 1041706111, 'FR', 'FRA', 'فرنسا'),
(1657, 1041706112, 1041706143, 'GB', 'GBR', 'المملكة المتحدة'),
(1658, 1041706144, 1041706191, 'FR', 'FRA', 'فرنسا'),
(1659, 1041706192, 1041706239, 'GB', 'GBR', 'المملكة المتحدة'),
(1660, 1041706240, 1041706255, 'FR', 'FRA', 'فرنسا'),
(1661, 1041706256, 1041706287, 'GB', 'GBR', 'المملكة المتحدة'),
(1662, 1041706288, 1041706359, 'FR', 'FRA', 'فرنسا'),
(1663, 1041706360, 1041706367, 'GB', 'GBR', 'المملكة المتحدة'),
(1664, 1041706368, 1041706447, 'FR', 'FRA', 'فرنسا'),
(1665, 1041706448, 1041706463, 'GB', 'GBR', 'المملكة المتحدة'),
(1666, 1041706464, 1041706479, 'FR', 'FRA', 'فرنسا'),
(1667, 1041706480, 1041706487, 'GB', 'GBR', 'المملكة المتحدة'),
(1668, 1041706488, 1041706535, 'FR', 'FRA', 'فرنسا'),
(1669, 1041706536, 1041706543, 'GB', 'GBR', 'المملكة المتحدة'),
(1670, 1041706544, 1041706559, 'FR', 'FRA', 'فرنسا'),
(1671, 1041706560, 1041706567, 'GB', 'GBR', 'المملكة المتحدة'),
(1672, 1041706568, 1041706583, 'FR', 'FRA', 'فرنسا'),
(1673, 1041706584, 1041706591, 'GB', 'GBR', 'المملكة المتحدة'),
(1674, 1041706592, 1041706623, 'FR', 'FRA', 'فرنسا'),
(1675, 1041706624, 1041706631, 'GB', 'GBR', 'المملكة المتحدة'),
(1676, 1041706632, 1041706767, 'FR', 'FRA', 'فرنسا'),
(1677, 1041706768, 1041706799, 'GB', 'GBR', 'المملكة المتحدة'),
(1678, 1041706800, 1041706815, 'FR', 'FRA', 'فرنسا'),
(1679, 1041706816, 1041706847, 'GB', 'GBR', 'المملكة المتحدة'),
(1680, 1041706848, 1041706871, 'FR', 'FRA', 'فرنسا'),
(1681, 1041706872, 1041706879, 'GB', 'GBR', 'المملكة المتحدة'),
(1682, 1041706880, 1041706951, 'FR', 'FRA', 'فرنسا'),
(1683, 1041706952, 1041706975, 'GB', 'GBR', 'المملكة المتحدة'),
(1684, 1041706976, 1041706999, 'FR', 'FRA', 'فرنسا'),
(1685, 1041707000, 1041707007, 'GB', 'GBR', 'المملكة المتحدة'),
(1686, 1041707008, 1041707271, 'FR', 'FRA', 'فرنسا'),
(1687, 1041707272, 1041707279, 'GB', 'GBR', 'المملكة المتحدة'),
(1688, 1041707280, 1041707295, 'FR', 'FRA', 'فرنسا'),
(1689, 1041707296, 1041707319, 'GB', 'GBR', 'المملكة المتحدة'),
(1690, 1041707320, 1041707359, 'FR', 'FRA', 'فرنسا'),
(1691, 1041707360, 1041707367, 'GB', 'GBR', 'المملكة المتحدة'),
(1692, 1041707368, 1041707375, 'FR', 'FRA', 'فرنسا'),
(1693, 1041707376, 1041707383, 'GB', 'GBR', 'المملكة المتحدة'),
(1694, 1041707384, 1041707399, 'FR', 'FRA', 'فرنسا'),
(1695, 1041707400, 1041707415, 'GB', 'GBR', 'المملكة المتحدة'),
(1696, 1041707416, 1041707439, 'FR', 'FRA', 'فرنسا'),
(1697, 1041707440, 1041707447, 'GB', 'GBR', 'المملكة المتحدة'),
(1698, 1041707448, 1041707455, 'FR', 'FRA', 'فرنسا'),
(1699, 1041707456, 1041707463, 'GB', 'GBR', 'المملكة المتحدة'),
(1700, 1041707464, 1041707487, 'FR', 'FRA', 'فرنسا'),
(1701, 1041707488, 1041707495, 'GB', 'GBR', 'المملكة المتحدة'),
(1702, 1041707496, 1041707503, 'FR', 'FRA', 'فرنسا'),
(1703, 1041707504, 1041707519, 'GB', 'GBR', 'المملكة المتحدة'),
(1704, 1041707520, 1041707559, 'FR', 'FRA', 'فرنسا'),
(1705, 1041707560, 1041707583, 'GB', 'GBR', 'المملكة المتحدة'),
(1706, 1041707584, 1041707631, 'FR', 'FRA', 'فرنسا'),
(1707, 1041707632, 1041707639, 'GB', 'GBR', 'المملكة المتحدة'),
(1708, 1041707640, 1041707647, 'FR', 'FRA', 'فرنسا'),
(1709, 1041707648, 1041707655, 'GB', 'GBR', 'المملكة المتحدة'),
(1710, 1041707656, 1041707679, 'FR', 'FRA', 'فرنسا'),
(1711, 1041707680, 1041707687, 'GB', 'GBR', 'المملكة المتحدة'),
(1712, 1041707688, 1041707711, 'FR', 'FRA', 'فرنسا'),
(1713, 1041707712, 1041707743, 'GB', 'GBR', 'المملكة المتحدة'),
(1714, 1041707744, 1041707807, 'FR', 'FRA', 'فرنسا'),
(1715, 1041707808, 1041707815, 'GB', 'GBR', 'المملكة المتحدة'),
(1716, 1041707816, 1041707895, 'FR', 'FRA', 'فرنسا'),
(1717, 1041707896, 1041707903, 'GB', 'GBR', 'المملكة المتحدة'),
(1718, 1041707904, 1041707999, 'FR', 'FRA', 'فرنسا'),
(1719, 1041708000, 1041708007, 'GB', 'GBR', 'المملكة المتحدة'),
(1720, 1041708008, 1041708023, 'FR', 'FRA', 'فرنسا'),
(1721, 1041708024, 1041708031, 'GB', 'GBR', 'المملكة المتحدة'),
(1722, 1041708032, 1041708295, 'FR', 'FRA', 'فرنسا'),
(1723, 1041708296, 1041708303, 'GB', 'GBR', 'المملكة المتحدة'),
(1724, 1041708304, 1041708311, 'FR', 'FRA', 'فرنسا'),
(1725, 1041708312, 1041708319, 'GB', 'GBR', 'المملكة المتحدة'),
(1726, 1041708320, 1041708327, 'FR', 'FRA', 'فرنسا'),
(1727, 1041708328, 1041708351, 'GB', 'GBR', 'المملكة المتحدة'),
(1728, 1041708352, 1041708367, 'FR', 'FRA', 'فرنسا'),
(1729, 1041708368, 1041708383, 'GB', 'GBR', 'المملكة المتحدة'),
(1730, 1041708384, 1041708415, 'FR', 'FRA', 'فرنسا'),
(1731, 1041708416, 1041708431, 'GB', 'GBR', 'المملكة المتحدة'),
(1732, 1041708432, 1041708447, 'FR', 'FRA', 'فرنسا'),
(1733, 1041708448, 1041708463, 'GB', 'GBR', 'المملكة المتحدة'),
(1734, 1041708464, 1041708479, 'FR', 'FRA', 'فرنسا'),
(1735, 1041708480, 1041708487, 'GB', 'GBR', 'المملكة المتحدة'),
(1736, 1041708488, 1041708495, 'FR', 'FRA', 'فرنسا'),
(1737, 1041708496, 1041708511, 'GB', 'GBR', 'المملكة المتحدة'),
(1738, 1041708512, 1041708551, 'FR', 'FRA', 'فرنسا'),
(1739, 1041708552, 1041708559, 'GB', 'GBR', 'المملكة المتحدة'),
(1740, 1041708560, 1041708607, 'FR', 'FRA', 'فرنسا'),
(1741, 1041708608, 1041708615, 'GB', 'GBR', 'المملكة المتحدة'),
(1742, 1041708616, 1041708671, 'FR', 'FRA', 'فرنسا'),
(1743, 1041708672, 1041708695, 'GB', 'GBR', 'المملكة المتحدة'),
(1744, 1041708696, 1041708703, 'FR', 'FRA', 'فرنسا'),
(1745, 1041708704, 1041708735, 'GB', 'GBR', 'المملكة المتحدة'),
(1746, 1041708736, 1041708807, 'FR', 'FRA', 'فرنسا'),
(1747, 1041708808, 1041708815, 'GB', 'GBR', 'المملكة المتحدة'),
(1748, 1041708816, 1041708847, 'FR', 'FRA', 'فرنسا'),
(1749, 1041708848, 1041708855, 'GB', 'GBR', 'المملكة المتحدة'),
(1750, 1041708856, 1041708879, 'FR', 'FRA', 'فرنسا'),
(1751, 1041708880, 1041708895, 'GB', 'GBR', 'المملكة المتحدة'),
(1752, 1041708896, 1041708903, 'FR', 'FRA', 'فرنسا'),
(1753, 1041708904, 1041708911, 'GB', 'GBR', 'المملكة المتحدة'),
(1754, 1041708912, 1041708927, 'FR', 'FRA', 'فرنسا'),
(1755, 1041708928, 1041708943, 'GB', 'GBR', 'المملكة المتحدة'),
(1756, 1041708944, 1041708991, 'FR', 'FRA', 'فرنسا'),
(1757, 1041708992, 1041708999, 'GB', 'GBR', 'المملكة المتحدة'),
(1758, 1041709000, 1041709023, 'FR', 'FRA', 'فرنسا'),
(1759, 1041709024, 1041709055, 'GB', 'GBR', 'المملكة المتحدة'),
(1760, 1041709056, 1041709343, 'FR', 'FRA', 'فرنسا'),
(1761, 1041709344, 1041709375, 'GB', 'GBR', 'المملكة المتحدة'),
(1762, 1041709376, 1041709463, 'FR', 'FRA', 'فرنسا'),
(1763, 1041709464, 1041709471, 'GB', 'GBR', 'المملكة المتحدة'),
(1764, 1041709472, 1041709479, 'FR', 'FRA', 'فرنسا'),
(1765, 1041709480, 1041709487, 'GB', 'GBR', 'المملكة المتحدة'),
(1766, 1041709488, 1041709767, 'FR', 'FRA', 'فرنسا'),
(1767, 1041709768, 1041709775, 'GB', 'GBR', 'المملكة المتحدة'),
(1768, 1041709776, 1041709823, 'FR', 'FRA', 'فرنسا'),
(1769, 1041709824, 1041709831, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(1770, 1041709832, 1041709903, 'FR', 'FRA', 'فرنسا'),
(1771, 1041709904, 1041709911, 'GB', 'GBR', 'المملكة المتحدة'),
(1772, 1041709912, 1041709919, 'FR', 'FRA', 'فرنسا'),
(1773, 1041709920, 1041709927, 'GB', 'GBR', 'المملكة المتحدة'),
(1774, 1041709928, 1041709935, 'FR', 'FRA', 'فرنسا'),
(1775, 1041709936, 1041709943, 'GB', 'GBR', 'المملكة المتحدة'),
(1776, 1041709944, 1041709951, 'FR', 'FRA', 'فرنسا'),
(1777, 1041709952, 1041709983, 'GB', 'GBR', 'المملكة المتحدة'),
(1778, 1041709984, 1041709991, 'FR', 'FRA', 'فرنسا'),
(1779, 1041709992, 1041709999, 'GB', 'GBR', 'المملكة المتحدة'),
(1780, 1041710000, 1041710007, 'FR', 'FRA', 'فرنسا'),
(1781, 1041710008, 1041710015, 'GB', 'GBR', 'المملكة المتحدة'),
(1782, 1041710016, 1041710047, 'FR', 'FRA', 'فرنسا'),
(1783, 1041710048, 1041710055, 'GB', 'GBR', 'المملكة المتحدة'),
(1784, 1041710056, 1041710063, 'FR', 'FRA', 'فرنسا'),
(1785, 1041710064, 1041710079, 'GB', 'GBR', 'المملكة المتحدة'),
(1786, 1041710080, 1041710343, 'FR', 'FRA', 'فرنسا'),
(1787, 1041710344, 1041710359, 'GB', 'GBR', 'المملكة المتحدة'),
(1788, 1041710360, 1041710367, 'FR', 'FRA', 'فرنسا'),
(1789, 1041710368, 1041710383, 'GB', 'GBR', 'المملكة المتحدة'),
(1790, 1041710384, 1041710391, 'FR', 'FRA', 'فرنسا'),
(1791, 1041710392, 1041710407, 'GB', 'GBR', 'المملكة المتحدة'),
(1792, 1041710408, 1041710439, 'FR', 'FRA', 'فرنسا'),
(1793, 1041710440, 1041710455, 'GB', 'GBR', 'المملكة المتحدة'),
(1794, 1041710456, 1041710471, 'FR', 'FRA', 'فرنسا'),
(1795, 1041710472, 1041710487, 'GB', 'GBR', 'المملكة المتحدة'),
(1796, 1041710488, 1041710495, 'FR', 'FRA', 'فرنسا'),
(1797, 1041710496, 1041710511, 'GB', 'GBR', 'المملكة المتحدة'),
(1798, 1041710512, 1041710535, 'FR', 'FRA', 'فرنسا'),
(1799, 1041710536, 1041710543, 'GB', 'GBR', 'المملكة المتحدة'),
(1800, 1041710544, 1041710559, 'FR', 'FRA', 'فرنسا'),
(1801, 1041710560, 1041710567, 'GB', 'GBR', 'المملكة المتحدة'),
(1802, 1041710568, 1041710575, 'FR', 'FRA', 'فرنسا'),
(1803, 1041710576, 1041710583, 'GB', 'GBR', 'المملكة المتحدة'),
(1804, 1041710584, 1041710663, 'FR', 'FRA', 'فرنسا'),
(1805, 1041710664, 1041710671, 'GB', 'GBR', 'المملكة المتحدة'),
(1806, 1041710672, 1041710687, 'FR', 'FRA', 'فرنسا'),
(1807, 1041710688, 1041710695, 'GB', 'GBR', 'المملكة المتحدة'),
(1808, 1041710696, 1041710703, 'FR', 'FRA', 'فرنسا'),
(1809, 1041710704, 1041710711, 'GB', 'GBR', 'المملكة المتحدة'),
(1810, 1041710712, 1041710719, 'FR', 'FRA', 'فرنسا'),
(1811, 1041710720, 1041710727, 'GB', 'GBR', 'المملكة المتحدة'),
(1812, 1041710728, 1041710735, 'FR', 'FRA', 'فرنسا'),
(1813, 1041710736, 1041710743, 'GB', 'GBR', 'المملكة المتحدة'),
(1814, 1041710744, 1041710775, 'FR', 'FRA', 'فرنسا'),
(1815, 1041710776, 1041710783, 'GB', 'GBR', 'المملكة المتحدة'),
(1816, 1041710784, 1041711407, 'FR', 'FRA', 'فرنسا'),
(1817, 1041711408, 1041711439, 'GB', 'GBR', 'المملكة المتحدة'),
(1818, 1041711440, 1041711455, 'FR', 'FRA', 'فرنسا'),
(1819, 1041711456, 1041711463, 'GB', 'GBR', 'المملكة المتحدة'),
(1820, 1041711464, 1041711471, 'FR', 'FRA', 'فرنسا'),
(1821, 1041711472, 1041711519, 'GB', 'GBR', 'المملكة المتحدة'),
(1822, 1041711520, 1041711535, 'FR', 'FRA', 'فرنسا'),
(1823, 1041711536, 1041711567, 'GB', 'GBR', 'المملكة المتحدة'),
(1824, 1041711568, 1041711583, 'FR', 'FRA', 'فرنسا'),
(1825, 1041711584, 1041711599, 'GB', 'GBR', 'المملكة المتحدة'),
(1826, 1041711600, 1041711871, 'FR', 'FRA', 'فرنسا'),
(1827, 1041711872, 1041711879, 'GB', 'GBR', 'المملكة المتحدة'),
(1828, 1041711880, 1041711911, 'FR', 'FRA', 'فرنسا'),
(1829, 1041711912, 1041711927, 'GB', 'GBR', 'المملكة المتحدة'),
(1830, 1041711928, 1041711935, 'FR', 'FRA', 'فرنسا'),
(1831, 1041711936, 1041711951, 'GB', 'GBR', 'المملكة المتحدة'),
(1832, 1041711952, 1041711967, 'FR', 'FRA', 'فرنسا'),
(1833, 1041711968, 1041711983, 'GB', 'GBR', 'المملكة المتحدة'),
(1834, 1041711984, 1041712399, 'FR', 'FRA', 'فرنسا'),
(1835, 1041712400, 1041712415, 'GB', 'GBR', 'المملكة المتحدة'),
(1836, 1041712416, 1041712423, 'FR', 'FRA', 'فرنسا'),
(1837, 1041712424, 1041712431, 'GB', 'GBR', 'المملكة المتحدة'),
(1838, 1041712432, 1041712911, 'FR', 'FRA', 'فرنسا'),
(1839, 1041712912, 1041712919, 'GB', 'GBR', 'المملكة المتحدة'),
(1840, 1041712920, 1041712927, 'FR', 'FRA', 'فرنسا'),
(1841, 1041712928, 1041712935, 'GB', 'GBR', 'المملكة المتحدة'),
(1842, 1041712936, 1041712959, 'FR', 'FRA', 'فرنسا'),
(1843, 1041712960, 1041712967, 'GB', 'GBR', 'المملكة المتحدة'),
(1844, 1041712968, 1041712991, 'FR', 'FRA', 'فرنسا'),
(1845, 1041712992, 1041712999, 'GB', 'GBR', 'المملكة المتحدة'),
(1846, 1041713000, 1041713055, 'FR', 'FRA', 'فرنسا'),
(1847, 1041713056, 1041713063, 'GB', 'GBR', 'المملكة المتحدة'),
(1848, 1041713064, 1041713119, 'FR', 'FRA', 'فرنسا'),
(1849, 1041713120, 1041713135, 'GB', 'GBR', 'المملكة المتحدة'),
(1850, 1041713136, 1041713143, 'FR', 'FRA', 'فرنسا'),
(1851, 1041713144, 1041713151, 'GB', 'GBR', 'المملكة المتحدة'),
(1852, 1041713152, 1041713687, 'FR', 'FRA', 'فرنسا'),
(1853, 1041713688, 1041713695, 'GB', 'GBR', 'المملكة المتحدة'),
(1854, 1041713696, 1041713791, 'FR', 'FRA', 'فرنسا'),
(1855, 1041713792, 1041713799, 'GB', 'GBR', 'المملكة المتحدة'),
(1856, 1041713800, 1041713823, 'FR', 'FRA', 'فرنسا'),
(1857, 1041713824, 1041713831, 'GB', 'GBR', 'المملكة المتحدة'),
(1858, 1041713832, 1041713871, 'FR', 'FRA', 'فرنسا'),
(1859, 1041713872, 1041713887, 'GB', 'GBR', 'المملكة المتحدة'),
(1860, 1041713888, 1041713919, 'FR', 'FRA', 'فرنسا'),
(1861, 1041713920, 1041713927, 'GB', 'GBR', 'المملكة المتحدة'),
(1862, 1041713928, 1041713935, 'FR', 'FRA', 'فرنسا'),
(1863, 1041713936, 1041713951, 'GB', 'GBR', 'المملكة المتحدة'),
(1864, 1041713952, 1041713975, 'FR', 'FRA', 'فرنسا'),
(1865, 1041713976, 1041713983, 'GB', 'GBR', 'المملكة المتحدة'),
(1866, 1041713984, 1041713991, 'FR', 'FRA', 'فرنسا'),
(1867, 1041713992, 1041714007, 'GB', 'GBR', 'المملكة المتحدة'),
(1868, 1041714008, 1041714047, 'FR', 'FRA', 'فرنسا'),
(1869, 1041714048, 1041714055, 'GB', 'GBR', 'المملكة المتحدة'),
(1870, 1041714056, 1041714071, 'FR', 'FRA', 'فرنسا'),
(1871, 1041714072, 1041714079, 'GB', 'GBR', 'المملكة المتحدة'),
(1872, 1041714080, 1041714095, 'FR', 'FRA', 'فرنسا'),
(1873, 1041714096, 1041714103, 'GB', 'GBR', 'المملكة المتحدة'),
(1874, 1041714104, 1041714111, 'FR', 'FRA', 'فرنسا'),
(1875, 1041714112, 1041714175, 'GB', 'GBR', 'المملكة المتحدة'),
(1876, 1041714176, 1041714439, 'FR', 'FRA', 'فرنسا'),
(1877, 1041714440, 1041714455, 'GB', 'GBR', 'المملكة المتحدة'),
(1878, 1041714456, 1041714523, 'FR', 'FRA', 'فرنسا'),
(1879, 1041714524, 1041714527, 'GB', 'GBR', 'المملكة المتحدة'),
(1880, 1041714528, 1041714623, 'FR', 'FRA', 'فرنسا'),
(1881, 1041714624, 1041714695, 'GB', 'GBR', 'المملكة المتحدة'),
(1882, 1041714696, 1041714711, 'FR', 'FRA', 'فرنسا'),
(1883, 1041714712, 1041714719, 'GB', 'GBR', 'المملكة المتحدة'),
(1884, 1041714720, 1041714727, 'FR', 'FRA', 'فرنسا'),
(1885, 1041714728, 1041714735, 'GB', 'GBR', 'المملكة المتحدة'),
(1886, 1041714736, 1041714767, 'FR', 'FRA', 'فرنسا'),
(1887, 1041714768, 1041714783, 'GB', 'GBR', 'المملكة المتحدة'),
(1888, 1041714784, 1041714815, 'FR', 'FRA', 'فرنسا'),
(1889, 1041714816, 1041714847, 'GB', 'GBR', 'المملكة المتحدة'),
(1890, 1041714848, 1041714855, 'FR', 'FRA', 'فرنسا'),
(1891, 1041714856, 1041714879, 'GB', 'GBR', 'المملكة المتحدة'),
(1892, 1041714880, 1041714911, 'FR', 'FRA', 'فرنسا'),
(1893, 1041714912, 1041714919, 'GB', 'GBR', 'المملكة المتحدة'),
(1894, 1041714920, 1041714943, 'FR', 'FRA', 'فرنسا'),
(1895, 1041714944, 1041714975, 'GB', 'GBR', 'المملكة المتحدة'),
(1896, 1041714976, 1041714991, 'FR', 'FRA', 'فرنسا'),
(1897, 1041714992, 1041715023, 'GB', 'GBR', 'المملكة المتحدة'),
(1898, 1041715024, 1041715055, 'FR', 'FRA', 'فرنسا'),
(1899, 1041715056, 1041715071, 'GB', 'GBR', 'المملكة المتحدة'),
(1900, 1041715072, 1041715079, 'FR', 'FRA', 'فرنسا'),
(1901, 1041715080, 1041715087, 'GB', 'GBR', 'المملكة المتحدة'),
(1902, 1041715088, 1041715095, 'FR', 'FRA', 'فرنسا'),
(1903, 1041715096, 1041715103, 'GB', 'GBR', 'المملكة المتحدة'),
(1904, 1041715104, 1041715119, 'FR', 'FRA', 'فرنسا'),
(1905, 1041715120, 1041715143, 'GB', 'GBR', 'المملكة المتحدة'),
(1906, 1041715144, 1041715151, 'FR', 'FRA', 'فرنسا'),
(1907, 1041715152, 1041715167, 'GB', 'GBR', 'المملكة المتحدة'),
(1908, 1041715168, 1041715183, 'FR', 'FRA', 'فرنسا'),
(1909, 1041715184, 1041715199, 'GB', 'GBR', 'المملكة المتحدة'),
(1910, 1041715200, 1041715503, 'FR', 'FRA', 'فرنسا'),
(1911, 1041715504, 1041715535, 'GB', 'GBR', 'المملكة المتحدة'),
(1912, 1041715536, 1041715551, 'FR', 'FRA', 'فرنسا'),
(1913, 1041715552, 1041715615, 'GB', 'GBR', 'المملكة المتحدة'),
(1914, 1041715616, 1041715631, 'FR', 'FRA', 'فرنسا'),
(1915, 1041715632, 1041715647, 'GB', 'GBR', 'المملكة المتحدة'),
(1916, 1041715648, 1041715751, 'FR', 'FRA', 'فرنسا'),
(1917, 1041715752, 1041715775, 'GB', 'GBR', 'المملكة المتحدة'),
(1918, 1041715776, 1041715807, 'FR', 'FRA', 'فرنسا'),
(1919, 1041715808, 1041715823, 'GB', 'GBR', 'المملكة المتحدة'),
(1920, 1041715824, 1041715863, 'FR', 'FRA', 'فرنسا'),
(1921, 1041715864, 1041715911, 'GB', 'GBR', 'المملكة المتحدة'),
(1922, 1041715912, 1041715943, 'FR', 'FRA', 'فرنسا'),
(1923, 1041715944, 1041715951, 'GB', 'GBR', 'المملكة المتحدة'),
(1924, 1041715952, 1041715967, 'FR', 'FRA', 'فرنسا'),
(1925, 1041715968, 1041716015, 'GB', 'GBR', 'المملكة المتحدة'),
(1926, 1041716016, 1041716039, 'FR', 'FRA', 'فرنسا'),
(1927, 1041716040, 1041716063, 'GB', 'GBR', 'المملكة المتحدة'),
(1928, 1041716064, 1041716111, 'FR', 'FRA', 'فرنسا'),
(1929, 1041716112, 1041716223, 'GB', 'GBR', 'المملكة المتحدة'),
(1930, 1041716224, 1041716239, 'FR', 'FRA', 'فرنسا'),
(1931, 1041716240, 1041716247, 'GB', 'GBR', 'المملكة المتحدة'),
(1932, 1041716248, 1041716295, 'FR', 'FRA', 'فرنسا'),
(1933, 1041716296, 1041716303, 'GB', 'GBR', 'المملكة المتحدة'),
(1934, 1041716304, 1041716311, 'FR', 'FRA', 'فرنسا'),
(1935, 1041716312, 1041716319, 'GB', 'GBR', 'المملكة المتحدة'),
(1936, 1041716320, 1041716335, 'FR', 'FRA', 'فرنسا'),
(1937, 1041716336, 1041716343, 'GB', 'GBR', 'المملكة المتحدة'),
(1938, 1041716344, 1041716439, 'FR', 'FRA', 'فرنسا'),
(1939, 1041716440, 1041716479, 'GB', 'GBR', 'المملكة المتحدة'),
(1940, 1041716480, 1041716487, 'FR', 'FRA', 'فرنسا'),
(1941, 1041716488, 1041716527, 'GB', 'GBR', 'المملكة المتحدة'),
(1942, 1041716528, 1041716559, 'FR', 'FRA', 'فرنسا'),
(1943, 1041716560, 1041716607, 'GB', 'GBR', 'المملكة المتحدة'),
(1944, 1041716608, 1041716671, 'FR', 'FRA', 'فرنسا'),
(1945, 1041716672, 1041716703, 'GB', 'GBR', 'المملكة المتحدة'),
(1946, 1041716704, 1041717039, 'FR', 'FRA', 'فرنسا'),
(1947, 1041717040, 1041717103, 'GB', 'GBR', 'المملكة المتحدة'),
(1948, 1041717104, 1041717111, 'FR', 'FRA', 'فرنسا'),
(1949, 1041717112, 1041717119, 'GB', 'GBR', 'المملكة المتحدة'),
(1950, 1041717120, 1041717167, 'FR', 'FRA', 'فرنسا'),
(1951, 1041717168, 1041717183, 'GB', 'GBR', 'المملكة المتحدة'),
(1952, 1041717184, 1041717199, 'FR', 'FRA', 'فرنسا'),
(1953, 1041717200, 1041717247, 'GB', 'GBR', 'المملكة المتحدة'),
(1954, 1041717248, 1041717503, 'FR', 'FRA', 'فرنسا'),
(1955, 1041717504, 1041717511, 'GB', 'GBR', 'المملكة المتحدة'),
(1956, 1041717512, 1041717687, 'FR', 'FRA', 'فرنسا'),
(1957, 1041717688, 1041717695, 'GB', 'GBR', 'المملكة المتحدة'),
(1958, 1041717696, 1041718023, 'FR', 'FRA', 'فرنسا'),
(1959, 1041718024, 1041718031, 'GB', 'GBR', 'المملكة المتحدة'),
(1960, 1041718032, 1041718055, 'FR', 'FRA', 'فرنسا'),
(1961, 1041718056, 1041718063, 'GB', 'GBR', 'المملكة المتحدة'),
(1962, 1041718064, 1041718079, 'FR', 'FRA', 'فرنسا'),
(1963, 1041718080, 1041718119, 'GB', 'GBR', 'المملكة المتحدة'),
(1964, 1041718120, 1041718127, 'FR', 'FRA', 'فرنسا'),
(1965, 1041718128, 1041718135, 'GB', 'GBR', 'المملكة المتحدة'),
(1966, 1041718136, 1041718143, 'FR', 'FRA', 'فرنسا'),
(1967, 1041718144, 1041718159, 'GB', 'GBR', 'المملكة المتحدة'),
(1968, 1041718160, 1041718191, 'FR', 'FRA', 'فرنسا'),
(1969, 1041718192, 1041718215, 'GB', 'GBR', 'المملكة المتحدة'),
(1970, 1041718216, 1041718231, 'FR', 'FRA', 'فرنسا'),
(1971, 1041718232, 1041718255, 'GB', 'GBR', 'المملكة المتحدة'),
(1972, 1041718256, 1041718271, 'FR', 'FRA', 'فرنسا'),
(1973, 1041718272, 1041718311, 'GB', 'GBR', 'المملكة المتحدة'),
(1974, 1041718312, 1041718319, 'FR', 'FRA', 'فرنسا'),
(1975, 1041718320, 1041718327, 'GB', 'GBR', 'المملكة المتحدة'),
(1976, 1041718328, 1041718335, 'FR', 'FRA', 'فرنسا'),
(1977, 1041718336, 1041718351, 'GB', 'GBR', 'المملكة المتحدة'),
(1978, 1041718352, 1041718407, 'FR', 'FRA', 'فرنسا'),
(1979, 1041718408, 1041718415, 'GB', 'GBR', 'المملكة المتحدة'),
(1980, 1041718416, 1041718431, 'FR', 'FRA', 'فرنسا'),
(1981, 1041718432, 1041718455, 'GB', 'GBR', 'المملكة المتحدة'),
(1982, 1041718456, 1041718463, 'FR', 'FRA', 'فرنسا'),
(1983, 1041718464, 1041718479, 'GB', 'GBR', 'المملكة المتحدة'),
(1984, 1041718480, 1041718495, 'FR', 'FRA', 'فرنسا'),
(1985, 1041718496, 1041718503, 'GB', 'GBR', 'المملكة المتحدة'),
(1986, 1041718504, 1041718591, 'FR', 'FRA', 'فرنسا'),
(1987, 1041718592, 1041718607, 'GB', 'GBR', 'المملكة المتحدة'),
(1988, 1041718608, 1041718623, 'FR', 'FRA', 'فرنسا'),
(1989, 1041718624, 1041718639, 'GB', 'GBR', 'المملكة المتحدة'),
(1990, 1041718640, 1041718663, 'FR', 'FRA', 'فرنسا'),
(1991, 1041718664, 1041718671, 'GB', 'GBR', 'المملكة المتحدة'),
(1992, 1041718672, 1041718687, 'FR', 'FRA', 'فرنسا'),
(1993, 1041718688, 1041718703, 'GB', 'GBR', 'المملكة المتحدة'),
(1994, 1041718704, 1041718783, 'FR', 'FRA', 'فرنسا'),
(1995, 1041718784, 1041718799, 'GB', 'GBR', 'المملكة المتحدة'),
(1996, 1041718800, 1041718815, 'FR', 'FRA', 'فرنسا'),
(1997, 1041718816, 1041718847, 'GB', 'GBR', 'المملكة المتحدة'),
(1998, 1041718848, 1041718879, 'FR', 'FRA', 'فرنسا'),
(1999, 1041718880, 1041718911, 'GB', 'GBR', 'المملكة المتحدة'),
(2000, 1041718912, 1041718927, 'FR', 'FRA', 'فرنسا'),
(2001, 1041718928, 1041718943, 'GB', 'GBR', 'المملكة المتحدة'),
(2002, 1041718944, 1041718975, 'FR', 'FRA', 'فرنسا'),
(2003, 1041718976, 1041718991, 'GB', 'GBR', 'المملكة المتحدة'),
(2004, 1041718992, 1041718999, 'FR', 'FRA', 'فرنسا'),
(2005, 1041719000, 1041719007, 'GB', 'GBR', 'المملكة المتحدة'),
(2006, 1041719008, 1041719203, 'FR', 'FRA', 'فرنسا'),
(2007, 1041719204, 1041719207, 'GB', 'GBR', 'المملكة المتحدة'),
(2008, 1041719208, 1041719215, 'FR', 'FRA', 'فرنسا'),
(2009, 1041719216, 1041719223, 'GB', 'GBR', 'المملكة المتحدة'),
(2010, 1041719224, 1041719224, 'FR', 'FRA', 'فرنسا'),
(2011, 1041719225, 1041719227, 'GB', 'GBR', 'المملكة المتحدة'),
(2012, 1041719228, 1041719228, 'FR', 'FRA', 'فرنسا'),
(2013, 1041719229, 1041719231, 'GB', 'GBR', 'المملكة المتحدة'),
(2014, 1041719232, 1041719247, 'FR', 'FRA', 'فرنسا'),
(2015, 1041719248, 1041719263, 'GB', 'GBR', 'المملكة المتحدة'),
(2016, 1041719264, 1041719375, 'FR', 'FRA', 'فرنسا'),
(2017, 1041719376, 1041719391, 'GB', 'GBR', 'المملكة المتحدة'),
(2018, 1041719392, 1041719439, 'FR', 'FRA', 'فرنسا'),
(2019, 1041719440, 1041719487, 'GB', 'GBR', 'المملكة المتحدة'),
(2020, 1041719488, 1041719599, 'FR', 'FRA', 'فرنسا'),
(2021, 1041719600, 1041719615, 'GB', 'GBR', 'المملكة المتحدة'),
(2022, 1041719616, 1041719647, 'FR', 'FRA', 'فرنسا'),
(2023, 1041719648, 1041719663, 'GB', 'GBR', 'المملكة المتحدة'),
(2024, 1041719664, 1041719679, 'FR', 'FRA', 'فرنسا'),
(2025, 1041719680, 1041719695, 'GB', 'GBR', 'المملكة المتحدة'),
(2026, 1041719696, 1041719703, 'FR', 'FRA', 'فرنسا'),
(2027, 1041719704, 1041719711, 'GB', 'GBR', 'المملكة المتحدة'),
(2028, 1041719712, 1041719743, 'FR', 'FRA', 'فرنسا'),
(2029, 1041719744, 1041719759, 'GB', 'GBR', 'المملكة المتحدة'),
(2030, 1041719760, 1041719807, 'FR', 'FRA', 'فرنسا'),
(2031, 1041719808, 1041719855, 'GB', 'GBR', 'المملكة المتحدة'),
(2032, 1041719856, 1041719879, 'FR', 'FRA', 'فرنسا'),
(2033, 1041719880, 1041719903, 'GB', 'GBR', 'المملكة المتحدة'),
(2034, 1041719904, 1041719919, 'FR', 'FRA', 'فرنسا'),
(2035, 1041719920, 1041719935, 'GB', 'GBR', 'المملكة المتحدة'),
(2036, 1041719936, 1041720015, 'FR', 'FRA', 'فرنسا'),
(2037, 1041720016, 1041720031, 'GB', 'GBR', 'المملكة المتحدة'),
(2038, 1041720032, 1041720079, 'FR', 'FRA', 'فرنسا'),
(2039, 1041720080, 1041720087, 'GB', 'GBR', 'المملكة المتحدة'),
(2040, 1041720088, 1041720327, 'FR', 'FRA', 'فرنسا'),
(2041, 1041720328, 1041720335, 'GB', 'GBR', 'المملكة المتحدة'),
(2042, 1041720336, 1041720351, 'FR', 'FRA', 'فرنسا'),
(2043, 1041720352, 1041720367, 'GB', 'GBR', 'المملكة المتحدة'),
(2044, 1041720368, 1041720519, 'FR', 'FRA', 'فرنسا'),
(2045, 1041720520, 1041720527, 'GB', 'GBR', 'المملكة المتحدة'),
(2046, 1041720528, 1041720551, 'FR', 'FRA', 'فرنسا'),
(2047, 1041720552, 1041720559, 'GB', 'GBR', 'المملكة المتحدة'),
(2048, 1041720560, 1041720567, 'FR', 'FRA', 'فرنسا'),
(2049, 1041720568, 1041720607, 'GB', 'GBR', 'المملكة المتحدة'),
(2050, 1041720608, 1041720615, 'FR', 'FRA', 'فرنسا'),
(2051, 1041720616, 1041720639, 'GB', 'GBR', 'المملكة المتحدة'),
(2052, 1041720640, 1041720687, 'FR', 'FRA', 'فرنسا'),
(2053, 1041720688, 1041720703, 'GB', 'GBR', 'المملكة المتحدة'),
(2054, 1041720704, 1041720719, 'FR', 'FRA', 'فرنسا'),
(2055, 1041720720, 1041720735, 'GB', 'GBR', 'المملكة المتحدة'),
(2056, 1041720736, 1041720839, 'FR', 'FRA', 'فرنسا'),
(2057, 1041720840, 1041720847, 'GB', 'GBR', 'المملكة المتحدة'),
(2058, 1041720848, 1041720895, 'FR', 'FRA', 'فرنسا'),
(2059, 1041720896, 1041720927, 'GB', 'GBR', 'المملكة المتحدة'),
(2060, 1041720928, 1041720959, 'FR', 'FRA', 'فرنسا'),
(2061, 1041720960, 1041721007, 'GB', 'GBR', 'المملكة المتحدة'),
(2062, 1041721008, 1041721039, 'FR', 'FRA', 'فرنسا'),
(2063, 1041721040, 1041721087, 'GB', 'GBR', 'المملكة المتحدة'),
(2064, 1041721088, 1041721343, 'FR', 'FRA', 'فرنسا'),
(2065, 1041721344, 1041721375, 'GB', 'GBR', 'المملكة المتحدة'),
(2066, 1041721376, 1041721391, 'FR', 'FRA', 'فرنسا'),
(2067, 1041721392, 1041721439, 'GB', 'GBR', 'المملكة المتحدة'),
(2068, 1041721440, 1041721519, 'FR', 'FRA', 'فرنسا'),
(2069, 1041721520, 1041721599, 'GB', 'GBR', 'المملكة المتحدة'),
(2070, 1041721600, 1041721727, 'FR', 'FRA', 'فرنسا'),
(2071, 1041721728, 1041721791, 'GB', 'GBR', 'المملكة المتحدة'),
(2072, 1041721792, 1041721807, 'FR', 'FRA', 'فرنسا'),
(2073, 1041721808, 1041721855, 'GB', 'GBR', 'المملكة المتحدة'),
(2074, 1041721856, 1041722119, 'FR', 'FRA', 'فرنسا'),
(2075, 1041722120, 1041722127, 'GB', 'GBR', 'المملكة المتحدة'),
(2076, 1041722128, 1041722143, 'FR', 'FRA', 'فرنسا'),
(2077, 1041722144, 1041722159, 'GB', 'GBR', 'المملكة المتحدة'),
(2078, 1041722160, 1041722167, 'FR', 'FRA', 'فرنسا'),
(2079, 1041722168, 1041722191, 'GB', 'GBR', 'المملكة المتحدة'),
(2080, 1041722192, 1041722223, 'FR', 'FRA', 'فرنسا'),
(2081, 1041722224, 1041722271, 'GB', 'GBR', 'المملكة المتحدة'),
(2082, 1041722272, 1041722279, 'FR', 'FRA', 'فرنسا'),
(2083, 1041722280, 1041722383, 'GB', 'GBR', 'المملكة المتحدة'),
(2084, 1041722384, 1041722391, 'FR', 'FRA', 'فرنسا'),
(2085, 1041722392, 1041722399, 'GB', 'GBR', 'المملكة المتحدة'),
(2086, 1041722400, 1041722415, 'FR', 'FRA', 'فرنسا'),
(2087, 1041722416, 1041722431, 'GB', 'GBR', 'المملكة المتحدة'),
(2088, 1041722432, 1041722463, 'FR', 'FRA', 'فرنسا'),
(2089, 1041722464, 1041722503, 'GB', 'GBR', 'المملكة المتحدة'),
(2090, 1041722504, 1041722535, 'FR', 'FRA', 'فرنسا'),
(2091, 1041722536, 1041722551, 'GB', 'GBR', 'المملكة المتحدة'),
(2092, 1041722552, 1041722567, 'FR', 'FRA', 'فرنسا'),
(2093, 1041722568, 1041722575, 'GB', 'GBR', 'المملكة المتحدة'),
(2094, 1041722576, 1041722583, 'FR', 'FRA', 'فرنسا'),
(2095, 1041722584, 1041722623, 'GB', 'GBR', 'المملكة المتحدة'),
(2096, 1041722624, 1041722807, 'FR', 'FRA', 'فرنسا'),
(2097, 1041722808, 1041722815, 'GB', 'GBR', 'المملكة المتحدة'),
(2098, 1041722816, 1041722855, 'FR', 'FRA', 'فرنسا'),
(2099, 1041722856, 1041722863, 'GB', 'GBR', 'المملكة المتحدة'),
(2100, 1041722864, 1041722943, 'FR', 'FRA', 'فرنسا'),
(2101, 1041722944, 1041723007, 'GB', 'GBR', 'المملكة المتحدة'),
(2102, 1041723008, 1041723031, 'FR', 'FRA', 'فرنسا'),
(2103, 1041723032, 1041723135, 'GB', 'GBR', 'المملكة المتحدة'),
(2104, 1041723136, 1041723167, 'FR', 'FRA', 'فرنسا'),
(2105, 1041723168, 1041723175, 'GB', 'GBR', 'المملكة المتحدة'),
(2106, 1041723176, 1041723231, 'FR', 'FRA', 'فرنسا'),
(2107, 1041723232, 1041723263, 'GB', 'GBR', 'المملكة المتحدة'),
(2108, 1041723264, 1041723295, 'FR', 'FRA', 'فرنسا'),
(2109, 1041723296, 1041723391, 'GB', 'GBR', 'المملكة المتحدة'),
(2110, 1041723392, 1041723647, 'FR', 'FRA', 'فرنسا'),
(2111, 1041723648, 1041723775, 'GB', 'GBR', 'المملكة المتحدة'),
(2112, 1041723776, 1041723839, 'FR', 'FRA', 'فرنسا'),
(2113, 1041723840, 1041723903, 'GB', 'GBR', 'المملكة المتحدة'),
(2114, 1041723904, 1041724455, 'FR', 'FRA', 'فرنسا'),
(2115, 1041724456, 1041724463, 'GB', 'GBR', 'المملكة المتحدة'),
(2116, 1041724464, 1041724471, 'FR', 'FRA', 'فرنسا'),
(2117, 1041724472, 1041724479, 'GB', 'GBR', 'المملكة المتحدة'),
(2118, 1041724480, 1041724511, 'FR', 'FRA', 'فرنسا'),
(2119, 1041724512, 1041724527, 'GB', 'GBR', 'المملكة المتحدة'),
(2120, 1041724528, 1041724591, 'FR', 'FRA', 'فرنسا'),
(2121, 1041724592, 1041724607, 'GB', 'GBR', 'المملكة المتحدة'),
(2122, 1041724608, 1041724671, 'FR', 'FRA', 'فرنسا'),
(2123, 1041724672, 1041724927, 'GB', 'GBR', 'المملكة المتحدة'),
(2124, 1041724928, 1041725007, 'FR', 'FRA', 'فرنسا'),
(2125, 1041725008, 1041725023, 'GB', 'GBR', 'المملكة المتحدة'),
(2126, 1041725024, 1041725135, 'FR', 'FRA', 'فرنسا'),
(2127, 1041725136, 1041725167, 'GB', 'GBR', 'المملكة المتحدة'),
(2128, 1041725168, 1041725175, 'FR', 'FRA', 'فرنسا'),
(2129, 1041725176, 1041725231, 'GB', 'GBR', 'المملكة المتحدة'),
(2130, 1041725232, 1041725255, 'FR', 'FRA', 'فرنسا'),
(2131, 1041725256, 1041725271, 'GB', 'GBR', 'المملكة المتحدة'),
(2132, 1041725272, 1041725343, 'FR', 'FRA', 'فرنسا'),
(2133, 1041725344, 1041725407, 'GB', 'GBR', 'المملكة المتحدة'),
(2134, 1041725408, 1041725703, 'FR', 'FRA', 'فرنسا'),
(2135, 1041725704, 1041725711, 'GB', 'GBR', 'المملكة المتحدة'),
(2136, 1041725712, 1041725799, 'FR', 'FRA', 'فرنسا'),
(2137, 1041725800, 1041725807, 'GB', 'GBR', 'المملكة المتحدة'),
(2138, 1041725808, 1041725815, 'FR', 'FRA', 'فرنسا'),
(2139, 1041725816, 1041725823, 'GB', 'GBR', 'المملكة المتحدة'),
(2140, 1041725824, 1041725983, 'FR', 'FRA', 'فرنسا'),
(2141, 1041725984, 1041725999, 'GB', 'GBR', 'المملكة المتحدة'),
(2142, 1041726000, 1041726063, 'FR', 'FRA', 'فرنسا'),
(2143, 1041726064, 1041726079, 'GB', 'GBR', 'المملكة المتحدة'),
(2144, 1041726080, 1041726127, 'FR', 'FRA', 'فرنسا'),
(2145, 1041726128, 1041726151, 'GB', 'GBR', 'المملكة المتحدة'),
(2146, 1041726152, 1041726159, 'FR', 'FRA', 'فرنسا'),
(2147, 1041726160, 1041726167, 'GB', 'GBR', 'المملكة المتحدة'),
(2148, 1041726168, 1041726463, 'FR', 'FRA', 'فرنسا'),
(2149, 1041726464, 1041726471, 'GB', 'GBR', 'المملكة المتحدة'),
(2150, 1041726472, 1041726487, 'FR', 'FRA', 'فرنسا'),
(2151, 1041726488, 1041726543, 'GB', 'GBR', 'المملكة المتحدة'),
(2152, 1041726544, 1041726559, 'FR', 'FRA', 'فرنسا'),
(2153, 1041726560, 1041726591, 'GB', 'GBR', 'المملكة المتحدة'),
(2154, 1041726592, 1041726639, 'FR', 'FRA', 'فرنسا'),
(2155, 1041726640, 1041726655, 'GB', 'GBR', 'المملكة المتحدة'),
(2156, 1041726656, 1041726671, 'FR', 'FRA', 'فرنسا'),
(2157, 1041726672, 1041726687, 'GB', 'GBR', 'المملكة المتحدة'),
(2158, 1041726688, 1041726735, 'FR', 'FRA', 'فرنسا'),
(2159, 1041726736, 1041726751, 'GB', 'GBR', 'المملكة المتحدة'),
(2160, 1041726752, 1041726847, 'FR', 'FRA', 'فرنسا'),
(2161, 1041726848, 1041726855, 'GB', 'GBR', 'المملكة المتحدة'),
(2162, 1041726856, 1041726879, 'FR', 'FRA', 'فرنسا'),
(2163, 1041726880, 1041726903, 'GB', 'GBR', 'المملكة المتحدة'),
(2164, 1041726904, 1041726951, 'FR', 'FRA', 'فرنسا'),
(2165, 1041726952, 1041726959, 'GB', 'GBR', 'المملكة المتحدة'),
(2166, 1041726960, 1041726975, 'FR', 'FRA', 'فرنسا'),
(2167, 1041726976, 1041726979, 'GB', 'GBR', 'المملكة المتحدة'),
(2168, 1041726980, 1041726983, 'FR', 'FRA', 'فرنسا'),
(2169, 1041726984, 1041726987, 'GB', 'GBR', 'المملكة المتحدة'),
(2170, 1041726988, 1041726991, 'FR', 'FRA', 'فرنسا'),
(2171, 1041726992, 1041726992, 'GB', 'GBR', 'المملكة المتحدة'),
(2172, 1041726993, 1041726994, 'FR', 'FRA', 'فرنسا'),
(2173, 1041726995, 1041726995, 'GB', 'GBR', 'المملكة المتحدة'),
(2174, 1041726996, 1041727003, 'FR', 'FRA', 'فرنسا'),
(2175, 1041727004, 1041727028, 'GB', 'GBR', 'المملكة المتحدة'),
(2176, 1041727029, 1041727029, 'FR', 'FRA', 'فرنسا'),
(2177, 1041727030, 1041727036, 'GB', 'GBR', 'المملكة المتحدة'),
(2178, 1041727037, 1041727038, 'FR', 'FRA', 'فرنسا'),
(2179, 1041727039, 1041727042, 'GB', 'GBR', 'المملكة المتحدة'),
(2180, 1041727043, 1041727043, 'FR', 'FRA', 'فرنسا'),
(2181, 1041727044, 1041727049, 'GB', 'GBR', 'المملكة المتحدة'),
(2182, 1041727050, 1041727050, 'FR', 'FRA', 'فرنسا'),
(2183, 1041727051, 1041727070, 'GB', 'GBR', 'المملكة المتحدة'),
(2184, 1041727071, 1041727071, 'FR', 'FRA', 'فرنسا'),
(2185, 1041727072, 1041727089, 'GB', 'GBR', 'المملكة المتحدة'),
(2186, 1041727090, 1041727090, 'FR', 'FRA', 'فرنسا'),
(2187, 1041727091, 1041727091, 'GB', 'GBR', 'المملكة المتحدة'),
(2188, 1041727092, 1041727095, 'FR', 'FRA', 'فرنسا'),
(2189, 1041727096, 1041727103, 'GB', 'GBR', 'المملكة المتحدة'),
(2190, 1041727104, 1041727167, 'FR', 'FRA', 'فرنسا'),
(2191, 1041727168, 1041727231, 'GB', 'GBR', 'المملكة المتحدة'),
(2192, 1041727232, 1041727239, 'FR', 'FRA', 'فرنسا'),
(2193, 1041727240, 1041727247, 'GB', 'GBR', 'المملكة المتحدة'),
(2194, 1041727248, 1041727303, 'FR', 'FRA', 'فرنسا'),
(2195, 1041727304, 1041727311, 'GB', 'GBR', 'المملكة المتحدة'),
(2196, 1041727312, 1041727487, 'FR', 'FRA', 'فرنسا'),
(2197, 1041727488, 1041728047, 'GB', 'GBR', 'المملكة المتحدة'),
(2198, 1041728048, 1041728063, 'FR', 'FRA', 'فرنسا'),
(2199, 1041728064, 1041728095, 'GB', 'GBR', 'المملكة المتحدة'),
(2200, 1041728096, 1041728111, 'FR', 'FRA', 'فرنسا'),
(2201, 1041728112, 1041728127, 'GB', 'GBR', 'المملكة المتحدة'),
(2202, 1041728128, 1041728255, 'FR', 'FRA', 'فرنسا'),
(2203, 1041728256, 1041728511, 'GB', 'GBR', 'المملكة المتحدة'),
(2204, 1041728512, 1041728887, 'FR', 'FRA', 'فرنسا'),
(2205, 1041728888, 1041728895, 'GB', 'GBR', 'المملكة المتحدة'),
(2206, 1041728896, 1041729023, 'FR', 'FRA', 'فرنسا'),
(2207, 1041729024, 1041729279, 'GB', 'GBR', 'المملكة المتحدة'),
(2208, 1041729280, 1041729303, 'FR', 'FRA', 'فرنسا'),
(2209, 1041729304, 1041729311, 'GB', 'GBR', 'المملكة المتحدة'),
(2210, 1041729312, 1041729343, 'FR', 'FRA', 'فرنسا'),
(2211, 1041729344, 1041729359, 'GB', 'GBR', 'المملكة المتحدة'),
(2212, 1041729360, 1041729367, 'FR', 'FRA', 'فرنسا'),
(2213, 1041729368, 1041729391, 'GB', 'GBR', 'المملكة المتحدة'),
(2214, 1041729392, 1041729431, 'FR', 'FRA', 'فرنسا'),
(2215, 1041729432, 1041729455, 'GB', 'GBR', 'المملكة المتحدة'),
(2216, 1041729456, 1041729503, 'FR', 'FRA', 'فرنسا'),
(2217, 1041729504, 1041729519, 'GB', 'GBR', 'المملكة المتحدة'),
(2218, 1041729520, 1041729527, 'FR', 'FRA', 'فرنسا'),
(2219, 1041729528, 1041729535, 'GB', 'GBR', 'المملكة المتحدة'),
(2220, 1041729536, 1041729561, 'FR', 'FRA', 'فرنسا'),
(2221, 1041729562, 1041729564, 'GB', 'GBR', 'المملكة المتحدة'),
(2222, 1041729565, 1041729566, 'FR', 'FRA', 'فرنسا'),
(2223, 1041729567, 1041729567, 'GB', 'GBR', 'المملكة المتحدة'),
(2224, 1041729568, 1041729615, 'FR', 'FRA', 'فرنسا'),
(2225, 1041729616, 1041729623, 'GB', 'GBR', 'المملكة المتحدة'),
(2226, 1041729624, 1041729663, 'FR', 'FRA', 'فرنسا'),
(2227, 1041729664, 1041729791, 'GB', 'GBR', 'المملكة المتحدة'),
(2228, 1041729792, 1041730239, 'FR', 'FRA', 'فرنسا'),
(2229, 1041730240, 1041730247, 'GB', 'GBR', 'المملكة المتحدة'),
(2230, 1041730248, 1041730639, 'FR', 'FRA', 'فرنسا'),
(2231, 1041730640, 1041730655, 'GB', 'GBR', 'المملكة المتحدة'),
(2232, 1041730656, 1041730815, 'FR', 'FRA', 'فرنسا'),
(2233, 1041730816, 1041731071, 'GB', 'GBR', 'المملكة المتحدة'),
(2234, 1041731072, 1041731975, 'FR', 'FRA', 'فرنسا'),
(2235, 1041731976, 1041732031, 'GB', 'GBR', 'المملكة المتحدة'),
(2236, 1041732032, 1041732055, 'FR', 'FRA', 'فرنسا'),
(2237, 1041732056, 1041732063, 'GB', 'GBR', 'المملكة المتحدة'),
(2238, 1041732064, 1041732095, 'FR', 'FRA', 'فرنسا'),
(2239, 1041732096, 1041732111, 'GB', 'GBR', 'المملكة المتحدة'),
(2240, 1041732112, 1041732127, 'FR', 'FRA', 'فرنسا'),
(2241, 1041732128, 1041732191, 'GB', 'GBR', 'المملكة المتحدة'),
(2242, 1041732192, 1041732255, 'FR', 'FRA', 'فرنسا'),
(2243, 1041732256, 1041732295, 'GB', 'GBR', 'المملكة المتحدة'),
(2244, 1041732296, 1041732303, 'FR', 'FRA', 'فرنسا'),
(2245, 1041732304, 1041732311, 'GB', 'GBR', 'المملكة المتحدة'),
(2246, 1041732312, 1041732375, 'FR', 'FRA', 'فرنسا'),
(2247, 1041732376, 1041732383, 'GB', 'GBR', 'المملكة المتحدة'),
(2248, 1041732384, 1041732447, 'FR', 'FRA', 'فرنسا'),
(2249, 1041732448, 1041732455, 'GB', 'GBR', 'المملكة المتحدة'),
(2250, 1041732456, 1041732463, 'FR', 'FRA', 'فرنسا'),
(2251, 1041732464, 1041732479, 'GB', 'GBR', 'المملكة المتحدة'),
(2252, 1041732480, 1041732863, 'FR', 'FRA', 'فرنسا'),
(2253, 1041732864, 1041732871, 'GB', 'GBR', 'المملكة المتحدة'),
(2254, 1041732872, 1041732879, 'FR', 'FRA', 'فرنسا'),
(2255, 1041732880, 1041732927, 'GB', 'GBR', 'المملكة المتحدة'),
(2256, 1041732928, 1041732959, 'FR', 'FRA', 'فرنسا'),
(2257, 1041732960, 1041732967, 'GB', 'GBR', 'المملكة المتحدة'),
(2258, 1041732968, 1041732991, 'FR', 'FRA', 'فرنسا'),
(2259, 1041732992, 1041733103, 'GB', 'GBR', 'المملكة المتحدة'),
(2260, 1041733104, 1041733503, 'FR', 'FRA', 'فرنسا'),
(2261, 1041733504, 1041733535, 'GB', 'GBR', 'المملكة المتحدة'),
(2262, 1041733536, 1041733887, 'FR', 'FRA', 'فرنسا'),
(2263, 1041733888, 1041734143, 'GB', 'GBR', 'المملكة المتحدة'),
(2264, 1041734144, 1041734927, 'FR', 'FRA', 'فرنسا'),
(2265, 1041734928, 1041734943, 'GB', 'GBR', 'المملكة المتحدة'),
(2266, 1041734944, 1041734975, 'FR', 'FRA', 'فرنسا'),
(2267, 1041734976, 1041734991, 'GB', 'GBR', 'المملكة المتحدة'),
(2268, 1041734992, 1041734999, 'FR', 'FRA', 'فرنسا'),
(2269, 1041735000, 1041735039, 'GB', 'GBR', 'المملكة المتحدة'),
(2270, 1041735040, 1041735055, 'FR', 'FRA', 'فرنسا'),
(2271, 1041735056, 1041735087, 'GB', 'GBR', 'المملكة المتحدة'),
(2272, 1041735088, 1041735119, 'FR', 'FRA', 'فرنسا'),
(2273, 1041735120, 1041735167, 'GB', 'GBR', 'المملكة المتحدة'),
(2274, 1041735168, 1041735431, 'FR', 'FRA', 'فرنسا'),
(2275, 1041735432, 1041735495, 'GB', 'GBR', 'المملكة المتحدة'),
(2276, 1041735496, 1041735519, 'FR', 'FRA', 'فرنسا'),
(2277, 1041735520, 1041735551, 'GB', 'GBR', 'المملكة المتحدة'),
(2278, 1041735552, 1041735567, 'FR', 'FRA', 'فرنسا'),
(2279, 1041735568, 1041735583, 'GB', 'GBR', 'المملكة المتحدة'),
(2280, 1041735584, 1041735615, 'FR', 'FRA', 'فرنسا'),
(2281, 1041735616, 1041735663, 'GB', 'GBR', 'المملكة المتحدة'),
(2282, 1041735664, 1041736191, 'FR', 'FRA', 'فرنسا'),
(2283, 1041736192, 1041736207, 'GB', 'GBR', 'المملكة المتحدة'),
(2284, 1041736208, 1041736255, 'FR', 'FRA', 'فرنسا'),
(2285, 1041736256, 1041736263, 'GB', 'GBR', 'المملكة المتحدة'),
(2286, 1041736264, 1041736367, 'FR', 'FRA', 'فرنسا'),
(2287, 1041736368, 1041736391, 'GB', 'GBR', 'المملكة المتحدة'),
(2288, 1041736392, 1041736423, 'FR', 'FRA', 'فرنسا'),
(2289, 1041736424, 1041736463, 'GB', 'GBR', 'المملكة المتحدة'),
(2290, 1041736464, 1041736503, 'FR', 'FRA', 'فرنسا'),
(2291, 1041736504, 1041736511, 'GB', 'GBR', 'المملكة المتحدة'),
(2292, 1041736512, 1041736527, 'FR', 'FRA', 'فرنسا'),
(2293, 1041736528, 1041736535, 'GB', 'GBR', 'المملكة المتحدة'),
(2294, 1041736536, 1041736543, 'FR', 'FRA', 'فرنسا'),
(2295, 1041736544, 1041736551, 'GB', 'GBR', 'المملكة المتحدة'),
(2296, 1041736552, 1041736567, 'FR', 'FRA', 'فرنسا'),
(2297, 1041736568, 1041736599, 'GB', 'GBR', 'المملكة المتحدة'),
(2298, 1041736600, 1041736607, 'FR', 'FRA', 'فرنسا'),
(2299, 1041736608, 1041736631, 'GB', 'GBR', 'المملكة المتحدة'),
(2300, 1041736632, 1041736671, 'FR', 'FRA', 'فرنسا'),
(2301, 1041736672, 1041736695, 'GB', 'GBR', 'المملكة المتحدة'),
(2302, 1041736696, 1041737015, 'FR', 'FRA', 'فرنسا'),
(2303, 1041737016, 1041737031, 'GB', 'GBR', 'المملكة المتحدة'),
(2304, 1041737032, 1041737039, 'FR', 'FRA', 'فرنسا'),
(2305, 1041737040, 1041737055, 'GB', 'GBR', 'المملكة المتحدة'),
(2306, 1041737056, 1041737071, 'FR', 'FRA', 'فرنسا'),
(2307, 1041737072, 1041737119, 'GB', 'GBR', 'المملكة المتحدة'),
(2308, 1041737120, 1041737127, 'FR', 'FRA', 'فرنسا'),
(2309, 1041737128, 1041737151, 'GB', 'GBR', 'المملكة المتحدة'),
(2310, 1041737152, 1041737247, 'FR', 'FRA', 'فرنسا'),
(2311, 1041737248, 1041737279, 'GB', 'GBR', 'المملكة المتحدة'),
(2312, 1041737280, 1041737295, 'FR', 'FRA', 'فرنسا'),
(2313, 1041737296, 1041737303, 'GB', 'GBR', 'المملكة المتحدة'),
(2314, 1041737304, 1041737375, 'FR', 'FRA', 'فرنسا'),
(2315, 1041737376, 1041737391, 'GB', 'GBR', 'المملكة المتحدة'),
(2316, 1041737392, 1041737399, 'FR', 'FRA', 'فرنسا'),
(2317, 1041737400, 1041737423, 'GB', 'GBR', 'المملكة المتحدة'),
(2318, 1041737424, 1041737455, 'FR', 'FRA', 'فرنسا'),
(2319, 1041737456, 1041737463, 'GB', 'GBR', 'المملكة المتحدة'),
(2320, 1041737464, 1041737503, 'FR', 'FRA', 'فرنسا'),
(2321, 1041737504, 1041737535, 'GB', 'GBR', 'المملكة المتحدة'),
(2322, 1041737536, 1041737583, 'FR', 'FRA', 'فرنسا'),
(2323, 1041737584, 1041737599, 'GB', 'GBR', 'المملكة المتحدة'),
(2324, 1041737600, 1041737607, 'FR', 'FRA', 'فرنسا'),
(2325, 1041737608, 1041737615, 'GB', 'GBR', 'المملكة المتحدة'),
(2326, 1041737616, 1041737647, 'FR', 'FRA', 'فرنسا'),
(2327, 1041737648, 1041737663, 'GB', 'GBR', 'المملكة المتحدة'),
(2328, 1041737664, 1041737671, 'FR', 'FRA', 'فرنسا'),
(2329, 1041737672, 1041737695, 'GB', 'GBR', 'المملكة المتحدة'),
(2330, 1041737696, 1041737727, 'FR', 'FRA', 'فرنسا'),
(2331, 1041737728, 1041737743, 'GB', 'GBR', 'المملكة المتحدة'),
(2332, 1041737744, 1041737775, 'FR', 'FRA', 'فرنسا'),
(2333, 1041737776, 1041737823, 'GB', 'GBR', 'المملكة المتحدة'),
(2334, 1041737824, 1041737847, 'FR', 'FRA', 'فرنسا'),
(2335, 1041737848, 1041737855, 'GB', 'GBR', 'المملكة المتحدة'),
(2336, 1041737856, 1041737871, 'FR', 'FRA', 'فرنسا'),
(2337, 1041737872, 1041737879, 'GB', 'GBR', 'المملكة المتحدة'),
(2338, 1041737880, 1041737919, 'FR', 'FRA', 'فرنسا'),
(2339, 1041737920, 1041737935, 'GB', 'GBR', 'المملكة المتحدة'),
(2340, 1041737936, 1041738159, 'FR', 'FRA', 'فرنسا'),
(2341, 1041738160, 1041738167, 'GB', 'GBR', 'المملكة المتحدة'),
(2342, 1041738168, 1041738215, 'FR', 'FRA', 'فرنسا'),
(2343, 1041738216, 1041738223, 'GB', 'GBR', 'المملكة المتحدة'),
(2344, 1041738224, 1041738503, 'FR', 'FRA', 'فرنسا'),
(2345, 1041738504, 1041738511, 'GB', 'GBR', 'المملكة المتحدة'),
(2346, 1041738512, 1041738519, 'FR', 'FRA', 'فرنسا'),
(2347, 1041738520, 1041738543, 'GB', 'GBR', 'المملكة المتحدة'),
(2348, 1041738544, 1041738551, 'FR', 'FRA', 'فرنسا'),
(2349, 1041738552, 1041738559, 'GB', 'GBR', 'المملكة المتحدة'),
(2350, 1041738560, 1041738567, 'FR', 'FRA', 'فرنسا'),
(2351, 1041738568, 1041738575, 'GB', 'GBR', 'المملكة المتحدة'),
(2352, 1041738576, 1041738583, 'FR', 'FRA', 'فرنسا'),
(2353, 1041738584, 1041738591, 'GB', 'GBR', 'المملكة المتحدة'),
(2354, 1041738592, 1041738599, 'FR', 'FRA', 'فرنسا'),
(2355, 1041738600, 1041738607, 'GB', 'GBR', 'المملكة المتحدة'),
(2356, 1041738608, 1041738703, 'FR', 'FRA', 'فرنسا'),
(2357, 1041738704, 1041738711, 'GB', 'GBR', 'المملكة المتحدة'),
(2358, 1041738712, 1041738735, 'FR', 'FRA', 'فرنسا'),
(2359, 1041738736, 1041738743, 'GB', 'GBR', 'المملكة المتحدة'),
(2360, 1041738744, 1041739055, 'FR', 'FRA', 'فرنسا'),
(2361, 1041739056, 1041739063, 'GB', 'GBR', 'المملكة المتحدة'),
(2362, 1041739064, 1041739071, 'FR', 'FRA', 'فرنسا'),
(2363, 1041739072, 1041739087, 'GB', 'GBR', 'المملكة المتحدة'),
(2364, 1041739088, 1041739127, 'FR', 'FRA', 'فرنسا'),
(2365, 1041739128, 1041739175, 'GB', 'GBR', 'المملكة المتحدة'),
(2366, 1041739176, 1041739183, 'FR', 'FRA', 'فرنسا'),
(2367, 1041739184, 1041739207, 'GB', 'GBR', 'المملكة المتحدة'),
(2368, 1041739208, 1041739215, 'FR', 'FRA', 'فرنسا'),
(2369, 1041739216, 1041739231, 'GB', 'GBR', 'المملكة المتحدة'),
(2370, 1041739232, 1041739287, 'FR', 'FRA', 'فرنسا'),
(2371, 1041739288, 1041739303, 'GB', 'GBR', 'المملكة المتحدة'),
(2372, 1041739304, 1041739375, 'FR', 'FRA', 'فرنسا'),
(2373, 1041739376, 1041739383, 'GB', 'GBR', 'المملكة المتحدة'),
(2374, 1041739384, 1041739391, 'FR', 'FRA', 'فرنسا'),
(2375, 1041739392, 1041739423, 'GB', 'GBR', 'المملكة المتحدة'),
(2376, 1041739424, 1041739463, 'FR', 'FRA', 'فرنسا'),
(2377, 1041739464, 1041739471, 'GB', 'GBR', 'المملكة المتحدة'),
(2378, 1041739472, 1041739487, 'FR', 'FRA', 'فرنسا'),
(2379, 1041739488, 1041739503, 'GB', 'GBR', 'المملكة المتحدة'),
(2380, 1041739504, 1041739519, 'FR', 'FRA', 'فرنسا'),
(2381, 1041739520, 1041739535, 'GB', 'GBR', 'المملكة المتحدة'),
(2382, 1041739536, 1041739743, 'FR', 'FRA', 'فرنسا'),
(2383, 1041739744, 1041739751, 'GB', 'GBR', 'المملكة المتحدة'),
(2384, 1041739752, 1041740031, 'FR', 'FRA', 'فرنسا'),
(2385, 1041740032, 1041740039, 'GB', 'GBR', 'المملكة المتحدة'),
(2386, 1041740040, 1041740135, 'FR', 'FRA', 'فرنسا'),
(2387, 1041740136, 1041740143, 'GB', 'GBR', 'المملكة المتحدة'),
(2388, 1041740144, 1041740263, 'FR', 'FRA', 'فرنسا'),
(2389, 1041740264, 1041740271, 'GB', 'GBR', 'المملكة المتحدة'),
(2390, 1041740272, 1041740567, 'FR', 'FRA', 'فرنسا'),
(2391, 1041740568, 1041740575, 'GB', 'GBR', 'المملكة المتحدة'),
(2392, 1041740576, 1041740591, 'FR', 'FRA', 'فرنسا'),
(2393, 1041740592, 1041740607, 'GB', 'GBR', 'المملكة المتحدة'),
(2394, 1041740608, 1041740647, 'FR', 'FRA', 'فرنسا'),
(2395, 1041740648, 1041740655, 'GB', 'GBR', 'المملكة المتحدة'),
(2396, 1041740656, 1041740679, 'FR', 'FRA', 'فرنسا'),
(2397, 1041740680, 1041740687, 'GB', 'GBR', 'المملكة المتحدة'),
(2398, 1041740688, 1041740703, 'FR', 'FRA', 'فرنسا'),
(2399, 1041740704, 1041740719, 'GB', 'GBR', 'المملكة المتحدة'),
(2400, 1041740720, 1041740863, 'FR', 'FRA', 'فرنسا'),
(2401, 1041740864, 1041740879, 'GB', 'GBR', 'المملكة المتحدة'),
(2402, 1041740880, 1041740959, 'FR', 'FRA', 'فرنسا'),
(2403, 1041740960, 1041740975, 'GB', 'GBR', 'المملكة المتحدة'),
(2404, 1041740976, 1041741055, 'FR', 'FRA', 'فرنسا'),
(2405, 1041741056, 1041741087, 'GB', 'GBR', 'المملكة المتحدة'),
(2406, 1041741088, 1041741103, 'FR', 'FRA', 'فرنسا'),
(2407, 1041741104, 1041741119, 'GB', 'GBR', 'المملكة المتحدة'),
(2408, 1041741120, 1041741135, 'FR', 'FRA', 'فرنسا'),
(2409, 1041741136, 1041741151, 'GB', 'GBR', 'المملكة المتحدة'),
(2410, 1041741152, 1041741239, 'FR', 'FRA', 'فرنسا'),
(2411, 1041741240, 1041741263, 'GB', 'GBR', 'المملكة المتحدة'),
(2412, 1041741264, 1041741279, 'FR', 'FRA', 'فرنسا'),
(2413, 1041741280, 1041741295, 'GB', 'GBR', 'المملكة المتحدة'),
(2414, 1041741296, 1041741567, 'FR', 'FRA', 'فرنسا'),
(2415, 1041741568, 1041741575, 'GB', 'GBR', 'المملكة المتحدة'),
(2416, 1041741576, 1041741607, 'FR', 'FRA', 'فرنسا'),
(2417, 1041741608, 1041741615, 'GB', 'GBR', 'المملكة المتحدة'),
(2418, 1041741616, 1041741631, 'FR', 'FRA', 'فرنسا'),
(2419, 1041741632, 1041741647, 'GB', 'GBR', 'المملكة المتحدة'),
(2420, 1041741648, 1041741663, 'FR', 'FRA', 'فرنسا'),
(2421, 1041741664, 1041741679, 'GB', 'GBR', 'المملكة المتحدة'),
(2422, 1041741680, 1041741687, 'FR', 'FRA', 'فرنسا'),
(2423, 1041741688, 1041741823, 'GB', 'GBR', 'المملكة المتحدة'),
(2424, 1041741824, 1041742095, 'FR', 'FRA', 'فرنسا'),
(2425, 1041742096, 1041742111, 'GB', 'GBR', 'المملكة المتحدة'),
(2426, 1041742112, 1041742127, 'FR', 'FRA', 'فرنسا'),
(2427, 1041742128, 1041742135, 'GB', 'GBR', 'المملكة المتحدة'),
(2428, 1041742136, 1041742151, 'FR', 'FRA', 'فرنسا'),
(2429, 1041742152, 1041742159, 'GB', 'GBR', 'المملكة المتحدة'),
(2430, 1041742160, 1041742183, 'FR', 'FRA', 'فرنسا'),
(2431, 1041742184, 1041742191, 'GB', 'GBR', 'المملكة المتحدة'),
(2432, 1041742192, 1041742223, 'FR', 'FRA', 'فرنسا'),
(2433, 1041742224, 1041742239, 'GB', 'GBR', 'المملكة المتحدة'),
(2434, 1041742240, 1041742303, 'FR', 'FRA', 'فرنسا'),
(2435, 1041742304, 1041742335, 'GB', 'GBR', 'المملكة المتحدة'),
(2436, 1041742336, 1041742359, 'FR', 'FRA', 'فرنسا'),
(2437, 1041742360, 1041742367, 'GB', 'GBR', 'المملكة المتحدة'),
(2438, 1041742368, 1041742383, 'FR', 'FRA', 'فرنسا'),
(2439, 1041742384, 1041742391, 'GB', 'GBR', 'المملكة المتحدة'),
(2440, 1041742392, 1041742407, 'FR', 'FRA', 'فرنسا'),
(2441, 1041742408, 1041742415, 'GB', 'GBR', 'المملكة المتحدة'),
(2442, 1041742416, 1041742455, 'FR', 'FRA', 'فرنسا'),
(2443, 1041742456, 1041742463, 'GB', 'GBR', 'المملكة المتحدة'),
(2444, 1041742464, 1041742471, 'FR', 'FRA', 'فرنسا'),
(2445, 1041742472, 1041742479, 'GB', 'GBR', 'المملكة المتحدة'),
(2446, 1041742480, 1041742511, 'FR', 'FRA', 'فرنسا'),
(2447, 1041742512, 1041742591, 'GB', 'GBR', 'المملكة المتحدة'),
(2448, 1041742592, 1041743135, 'FR', 'FRA', 'فرنسا'),
(2449, 1041743136, 1041743143, 'GB', 'GBR', 'المملكة المتحدة'),
(2450, 1041743144, 1041743175, 'FR', 'FRA', 'فرنسا'),
(2451, 1041743176, 1041743215, 'GB', 'GBR', 'المملكة المتحدة'),
(2452, 1041743216, 1041743303, 'FR', 'FRA', 'فرنسا'),
(2453, 1041743304, 1041743311, 'GB', 'GBR', 'المملكة المتحدة'),
(2454, 1041743312, 1041743615, 'FR', 'FRA', 'فرنسا'),
(2455, 1041743616, 1041743623, 'GB', 'GBR', 'المملكة المتحدة'),
(2456, 1041743624, 1041743639, 'FR', 'FRA', 'فرنسا'),
(2457, 1041743640, 1041743647, 'GB', 'GBR', 'المملكة المتحدة'),
(2458, 1041743648, 1041743671, 'FR', 'FRA', 'فرنسا'),
(2459, 1041743672, 1041743679, 'GB', 'GBR', 'المملكة المتحدة'),
(2460, 1041743680, 1041743703, 'FR', 'FRA', 'فرنسا'),
(2461, 1041743704, 1041743719, 'GB', 'GBR', 'المملكة المتحدة'),
(2462, 1041743720, 1041743743, 'FR', 'FRA', 'فرنسا'),
(2463, 1041743744, 1041743759, 'GB', 'GBR', 'المملكة المتحدة'),
(2464, 1041743760, 1041743767, 'FR', 'FRA', 'فرنسا'),
(2465, 1041743768, 1041743775, 'GB', 'GBR', 'المملكة المتحدة'),
(2466, 1041743776, 1041743791, 'FR', 'FRA', 'فرنسا'),
(2467, 1041743792, 1041743799, 'GB', 'GBR', 'المملكة المتحدة'),
(2468, 1041743800, 1041743807, 'FR', 'FRA', 'فرنسا'),
(2469, 1041743808, 1041743823, 'GB', 'GBR', 'المملكة المتحدة'),
(2470, 1041743824, 1041743831, 'FR', 'FRA', 'فرنسا'),
(2471, 1041743832, 1041743847, 'GB', 'GBR', 'المملكة المتحدة'),
(2472, 1041743848, 1041743863, 'FR', 'FRA', 'فرنسا'),
(2473, 1041743864, 1041743871, 'GB', 'GBR', 'المملكة المتحدة'),
(2474, 1041743872, 1041744143, 'FR', 'FRA', 'فرنسا'),
(2475, 1041744144, 1041744151, 'GB', 'GBR', 'المملكة المتحدة'),
(2476, 1041744152, 1041744255, 'FR', 'FRA', 'فرنسا'),
(2477, 1041744256, 1041744263, 'GB', 'GBR', 'المملكة المتحدة'),
(2478, 1041744264, 1041744271, 'FR', 'FRA', 'فرنسا'),
(2479, 1041744272, 1041744295, 'GB', 'GBR', 'المملكة المتحدة'),
(2480, 1041744296, 1041744311, 'FR', 'FRA', 'فرنسا'),
(2481, 1041744312, 1041744327, 'GB', 'GBR', 'المملكة المتحدة'),
(2482, 1041744328, 1041744479, 'FR', 'FRA', 'فرنسا'),
(2483, 1041744480, 1041744543, 'GB', 'GBR', 'المملكة المتحدة'),
(2484, 1041744544, 1041744599, 'FR', 'FRA', 'فرنسا'),
(2485, 1041744600, 1041744607, 'GB', 'GBR', 'المملكة المتحدة'),
(2486, 1041744608, 1041744623, 'FR', 'FRA', 'فرنسا'),
(2487, 1041744624, 1041744895, 'GB', 'GBR', 'المملكة المتحدة'),
(2488, 1041744896, 1041744919, 'FR', 'FRA', 'فرنسا'),
(2489, 1041744920, 1041744927, 'GB', 'GBR', 'المملكة المتحدة'),
(2490, 1041744928, 1041744943, 'FR', 'FRA', 'فرنسا'),
(2491, 1041744944, 1041744951, 'GB', 'GBR', 'المملكة المتحدة'),
(2492, 1041744952, 1041744975, 'FR', 'FRA', 'فرنسا'),
(2493, 1041744976, 1041744983, 'GB', 'GBR', 'المملكة المتحدة'),
(2494, 1041744984, 1041745007, 'FR', 'FRA', 'فرنسا'),
(2495, 1041745008, 1041745031, 'GB', 'GBR', 'المملكة المتحدة'),
(2496, 1041745032, 1041745063, 'FR', 'FRA', 'فرنسا'),
(2497, 1041745064, 1041745071, 'GB', 'GBR', 'المملكة المتحدة'),
(2498, 1041745072, 1041745095, 'FR', 'FRA', 'فرنسا'),
(2499, 1041745096, 1041745143, 'GB', 'GBR', 'المملكة المتحدة'),
(2500, 1041745144, 1041745151, 'FR', 'FRA', 'فرنسا'),
(2501, 1041745152, 1041745191, 'GB', 'GBR', 'المملكة المتحدة'),
(2502, 1041745192, 1041745207, 'FR', 'FRA', 'فرنسا'),
(2503, 1041745208, 1041745215, 'GB', 'GBR', 'المملكة المتحدة'),
(2504, 1041745216, 1041745247, 'FR', 'FRA', 'فرنسا'),
(2505, 1041745248, 1041745279, 'GB', 'GBR', 'المملكة المتحدة'),
(2506, 1041745280, 1041745327, 'FR', 'FRA', 'فرنسا'),
(2507, 1041745328, 1041745343, 'GB', 'GBR', 'المملكة المتحدة'),
(2508, 1041745344, 1041745359, 'FR', 'FRA', 'فرنسا'),
(2509, 1041745360, 1041745375, 'GB', 'GBR', 'المملكة المتحدة'),
(2510, 1041745376, 1041745415, 'FR', 'FRA', 'فرنسا'),
(2511, 1041745416, 1041745423, 'GB', 'GBR', 'المملكة المتحدة'),
(2512, 1041745424, 1041745447, 'FR', 'FRA', 'فرنسا'),
(2513, 1041745448, 1041745471, 'GB', 'GBR', 'المملكة المتحدة'),
(2514, 1041745472, 1041745479, 'FR', 'FRA', 'فرنسا'),
(2515, 1041745480, 1041745487, 'GB', 'GBR', 'المملكة المتحدة'),
(2516, 1041745488, 1041745495, 'FR', 'FRA', 'فرنسا'),
(2517, 1041745496, 1041745535, 'GB', 'GBR', 'المملكة المتحدة'),
(2518, 1041745536, 1041745543, 'FR', 'FRA', 'فرنسا'),
(2519, 1041745544, 1041745551, 'GB', 'GBR', 'المملكة المتحدة'),
(2520, 1041745552, 1041745567, 'FR', 'FRA', 'فرنسا'),
(2521, 1041745568, 1041745575, 'GB', 'GBR', 'المملكة المتحدة'),
(2522, 1041745576, 1041745599, 'FR', 'FRA', 'فرنسا'),
(2523, 1041745600, 1041745615, 'GB', 'GBR', 'المملكة المتحدة'),
(2524, 1041745616, 1041745639, 'FR', 'FRA', 'فرنسا'),
(2525, 1041745640, 1041745647, 'GB', 'GBR', 'المملكة المتحدة'),
(2526, 1041745648, 1041745655, 'FR', 'FRA', 'فرنسا'),
(2527, 1041745656, 1041745663, 'GB', 'GBR', 'المملكة المتحدة'),
(2528, 1041745664, 1041745751, 'FR', 'FRA', 'فرنسا'),
(2529, 1041745752, 1041745767, 'GB', 'GBR', 'المملكة المتحدة'),
(2530, 1041745768, 1041745855, 'FR', 'FRA', 'فرنسا'),
(2531, 1041745856, 1041745871, 'GB', 'GBR', 'المملكة المتحدة'),
(2532, 1041745872, 1041745887, 'FR', 'FRA', 'فرنسا'),
(2533, 1041745888, 1041745959, 'GB', 'GBR', 'المملكة المتحدة'),
(2534, 1041745960, 1041745967, 'FR', 'FRA', 'فرنسا'),
(2535, 1041745968, 1041745983, 'GB', 'GBR', 'المملكة المتحدة'),
(2536, 1041745984, 1041745999, 'FR', 'FRA', 'فرنسا'),
(2537, 1041746000, 1041746015, 'GB', 'GBR', 'المملكة المتحدة'),
(2538, 1041746016, 1041746023, 'FR', 'FRA', 'فرنسا'),
(2539, 1041746024, 1041746031, 'GB', 'GBR', 'المملكة المتحدة'),
(2540, 1041746032, 1041746039, 'FR', 'FRA', 'فرنسا'),
(2541, 1041746040, 1041746047, 'GB', 'GBR', 'المملكة المتحدة'),
(2542, 1041746048, 1041746063, 'FR', 'FRA', 'فرنسا'),
(2543, 1041746064, 1041746079, 'GB', 'GBR', 'المملكة المتحدة'),
(2544, 1041746080, 1041746111, 'FR', 'FRA', 'فرنسا'),
(2545, 1041746112, 1041746135, 'GB', 'GBR', 'المملكة المتحدة'),
(2546, 1041746136, 1041746703, 'FR', 'FRA', 'فرنسا'),
(2547, 1041746704, 1041746735, 'GB', 'GBR', 'المملكة المتحدة'),
(2548, 1041746736, 1041746743, 'FR', 'FRA', 'فرنسا'),
(2549, 1041746744, 1041746751, 'GB', 'GBR', 'المملكة المتحدة'),
(2550, 1041746752, 1041746799, 'FR', 'FRA', 'فرنسا'),
(2551, 1041746800, 1041746823, 'GB', 'GBR', 'المملكة المتحدة'),
(2552, 1041746824, 1041746831, 'FR', 'FRA', 'فرنسا'),
(2553, 1041746832, 1041746847, 'GB', 'GBR', 'المملكة المتحدة'),
(2554, 1041746848, 1041746863, 'FR', 'FRA', 'فرنسا'),
(2555, 1041746864, 1041746895, 'GB', 'GBR', 'المملكة المتحدة'),
(2556, 1041746896, 1041747199, 'FR', 'FRA', 'فرنسا'),
(2557, 1041747200, 1041747439, 'GB', 'GBR', 'المملكة المتحدة'),
(2558, 1041747440, 1041747463, 'FR', 'FRA', 'فرنسا'),
(2559, 1041747464, 1041747487, 'GB', 'GBR', 'المملكة المتحدة'),
(2560, 1041747488, 1041747503, 'FR', 'FRA', 'فرنسا'),
(2561, 1041747504, 1041747519, 'GB', 'GBR', 'المملكة المتحدة'),
(2562, 1041747520, 1041749775, 'FR', 'FRA', 'فرنسا'),
(2563, 1041749776, 1041749783, 'GB', 'GBR', 'المملكة المتحدة'),
(2564, 1041749784, 1041749807, 'FR', 'FRA', 'فرنسا'),
(2565, 1041749808, 1041749815, 'GB', 'GBR', 'المملكة المتحدة'),
(2566, 1041749816, 1041749967, 'FR', 'FRA', 'فرنسا'),
(2567, 1041749968, 1041749975, 'GB', 'GBR', 'المملكة المتحدة'),
(2568, 1041749976, 1041749999, 'FR', 'FRA', 'فرنسا'),
(2569, 1041750000, 1041750007, 'GB', 'GBR', 'المملكة المتحدة'),
(2570, 1041750008, 1041750527, 'FR', 'FRA', 'فرنسا'),
(2571, 1041750528, 1041750543, 'GB', 'GBR', 'المملكة المتحدة'),
(2572, 1041750544, 1041750559, 'FR', 'FRA', 'فرنسا'),
(2573, 1041750560, 1041750591, 'GB', 'GBR', 'المملكة المتحدة'),
(2574, 1041750592, 1041750663, 'FR', 'FRA', 'فرنسا'),
(2575, 1041750664, 1041750671, 'GB', 'GBR', 'المملكة المتحدة'),
(2576, 1041750672, 1041750743, 'FR', 'FRA', 'فرنسا'),
(2577, 1041750744, 1041750751, 'GB', 'GBR', 'المملكة المتحدة'),
(2578, 1041750752, 1041750775, 'FR', 'FRA', 'فرنسا'),
(2579, 1041750776, 1041750783, 'GB', 'GBR', 'المملكة المتحدة'),
(2580, 1041750784, 1041751327, 'FR', 'FRA', 'فرنسا'),
(2581, 1041751328, 1041751343, 'GB', 'GBR', 'المملكة المتحدة'),
(2582, 1041751344, 1041751551, 'FR', 'FRA', 'فرنسا'),
(2583, 1041751552, 1041751583, 'GB', 'GBR', 'المملكة المتحدة'),
(2584, 1041751584, 1041751639, 'FR', 'FRA', 'فرنسا'),
(2585, 1041751640, 1041751647, 'GB', 'GBR', 'المملكة المتحدة'),
(2586, 1041751648, 1041751695, 'FR', 'FRA', 'فرنسا'),
(2587, 1041751696, 1041751719, 'GB', 'GBR', 'المملكة المتحدة'),
(2588, 1041751720, 1041751743, 'FR', 'FRA', 'فرنسا'),
(2589, 1041751744, 1041751759, 'GB', 'GBR', 'المملكة المتحدة'),
(2590, 1041751760, 1041751767, 'FR', 'FRA', 'فرنسا'),
(2591, 1041751768, 1041751775, 'GB', 'GBR', 'المملكة المتحدة'),
(2592, 1041751776, 1041753343, 'FR', 'FRA', 'فرنسا'),
(2593, 1041753344, 1041753535, 'GB', 'GBR', 'المملكة المتحدة'),
(2594, 1041753536, 1041753599, 'FR', 'FRA', 'فرنسا'),
(2595, 1041753600, 1041753775, 'GB', 'GBR', 'المملكة المتحدة'),
(2596, 1041753776, 1041753831, 'FR', 'FRA', 'فرنسا'),
(2597, 1041753832, 1041753839, 'GB', 'GBR', 'المملكة المتحدة'),
(2598, 1041753840, 1041753983, 'FR', 'FRA', 'فرنسا'),
(2599, 1041753984, 1041754111, 'GB', 'GBR', 'المملكة المتحدة'),
(2600, 1041754112, 1041754143, 'FR', 'FRA', 'فرنسا'),
(2601, 1041754144, 1041754151, 'GB', 'GBR', 'المملكة المتحدة'),
(2602, 1041754152, 1041754175, 'FR', 'FRA', 'فرنسا'),
(2603, 1041754176, 1041754191, 'GB', 'GBR', 'المملكة المتحدة'),
(2604, 1041754192, 1041754239, 'FR', 'FRA', 'فرنسا'),
(2605, 1041754240, 1041754247, 'GB', 'GBR', 'المملكة المتحدة'),
(2606, 1041754248, 1041754455, 'FR', 'FRA', 'فرنسا'),
(2607, 1041754456, 1041754463, 'GB', 'GBR', 'المملكة المتحدة'),
(2608, 1041754464, 1041754479, 'FR', 'FRA', 'فرنسا'),
(2609, 1041754480, 1041754495, 'GB', 'GBR', 'المملكة المتحدة'),
(2610, 1041754496, 1041755231, 'FR', 'FRA', 'فرنسا'),
(2611, 1041755232, 1041755239, 'GB', 'GBR', 'المملكة المتحدة'),
(2612, 1041755240, 1041755295, 'FR', 'FRA', 'فرنسا'),
(2613, 1041755296, 1041755303, 'GB', 'GBR', 'المملكة المتحدة'),
(2614, 1041755304, 1041755335, 'FR', 'FRA', 'فرنسا'),
(2615, 1041755336, 1041755343, 'GB', 'GBR', 'المملكة المتحدة'),
(2616, 1041755344, 1041755375, 'FR', 'FRA', 'فرنسا'),
(2617, 1041755376, 1041755391, 'GB', 'GBR', 'المملكة المتحدة'),
(2618, 1041755392, 1041755455, 'FR', 'FRA', 'فرنسا'),
(2619, 1041755456, 1041755471, 'GB', 'GBR', 'المملكة المتحدة'),
(2620, 1041755472, 1041755503, 'FR', 'FRA', 'فرنسا'),
(2621, 1041755504, 1041755519, 'GB', 'GBR', 'المملكة المتحدة'),
(2622, 1041755520, 1041755631, 'FR', 'FRA', 'فرنسا'),
(2623, 1041755632, 1041755647, 'GB', 'GBR', 'المملكة المتحدة'),
(2624, 1041755648, 1041756463, 'FR', 'FRA', 'فرنسا'),
(2625, 1041756464, 1041756471, 'GB', 'GBR', 'المملكة المتحدة'),
(2626, 1041756472, 1041756543, 'FR', 'FRA', 'فرنسا'),
(2627, 1041756544, 1041756567, 'GB', 'GBR', 'المملكة المتحدة'),
(2628, 1041756568, 1041756599, 'FR', 'FRA', 'فرنسا'),
(2629, 1041756600, 1041756607, 'GB', 'GBR', 'المملكة المتحدة'),
(2630, 1041756608, 1041756655, 'FR', 'FRA', 'فرنسا'),
(2631, 1041756656, 1041756663, 'GB', 'GBR', 'المملكة المتحدة'),
(2632, 1041756664, 1041756695, 'FR', 'FRA', 'فرنسا'),
(2633, 1041756696, 1041756703, 'GB', 'GBR', 'المملكة المتحدة'),
(2634, 1041756704, 1041756895, 'FR', 'FRA', 'فرنسا'),
(2635, 1041756896, 1041756911, 'GB', 'GBR', 'المملكة المتحدة'),
(2636, 1041756912, 1041756919, 'FR', 'FRA', 'فرنسا'),
(2637, 1041756920, 1041756927, 'GB', 'GBR', 'المملكة المتحدة'),
(2638, 1041756928, 1041757023, 'FR', 'FRA', 'فرنسا'),
(2639, 1041757024, 1041757039, 'GB', 'GBR', 'المملكة المتحدة'),
(2640, 1041757040, 1041757087, 'FR', 'FRA', 'فرنسا'),
(2641, 1041757088, 1041757095, 'GB', 'GBR', 'المملكة المتحدة'),
(2642, 1041757096, 1041757111, 'FR', 'FRA', 'فرنسا'),
(2643, 1041757112, 1041757127, 'GB', 'GBR', 'المملكة المتحدة'),
(2644, 1041757128, 1041757175, 'FR', 'FRA', 'فرنسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(2645, 1041757176, 1041757179, 'GB', 'GBR', 'المملكة المتحدة'),
(2646, 1041757180, 1041757503, 'FR', 'FRA', 'فرنسا'),
(2647, 1041757504, 1041757519, 'GB', 'GBR', 'المملكة المتحدة'),
(2648, 1041757520, 1041757583, 'FR', 'FRA', 'فرنسا'),
(2649, 1041757584, 1041757591, 'GB', 'GBR', 'المملكة المتحدة'),
(2650, 1041757592, 1041757639, 'FR', 'FRA', 'فرنسا'),
(2651, 1041757640, 1041757647, 'GB', 'GBR', 'المملكة المتحدة'),
(2652, 1041757648, 1041757663, 'FR', 'FRA', 'فرنسا'),
(2653, 1041757664, 1041757671, 'GB', 'GBR', 'المملكة المتحدة'),
(2654, 1041757672, 1041757687, 'FR', 'FRA', 'فرنسا'),
(2655, 1041757688, 1041757695, 'GB', 'GBR', 'المملكة المتحدة'),
(2656, 1041757696, 1041758031, 'FR', 'FRA', 'فرنسا'),
(2657, 1041758032, 1041758039, 'GB', 'GBR', 'المملكة المتحدة'),
(2658, 1041758040, 1041758095, 'FR', 'FRA', 'فرنسا'),
(2659, 1041758096, 1041758111, 'GB', 'GBR', 'المملكة المتحدة'),
(2660, 1041758112, 1041758207, 'FR', 'FRA', 'فرنسا'),
(2661, 1041758208, 1041758239, 'GB', 'GBR', 'المملكة المتحدة'),
(2662, 1041758240, 1041758255, 'FR', 'FRA', 'فرنسا'),
(2663, 1041758256, 1041758271, 'GB', 'GBR', 'المملكة المتحدة'),
(2664, 1041758272, 1041758311, 'FR', 'FRA', 'فرنسا'),
(2665, 1041758312, 1041758343, 'GB', 'GBR', 'المملكة المتحدة'),
(2666, 1041758344, 1041758351, 'FR', 'FRA', 'فرنسا'),
(2667, 1041758352, 1041758375, 'GB', 'GBR', 'المملكة المتحدة'),
(2668, 1041758376, 1041758391, 'FR', 'FRA', 'فرنسا'),
(2669, 1041758392, 1041758415, 'GB', 'GBR', 'المملكة المتحدة'),
(2670, 1041758416, 1041758423, 'FR', 'FRA', 'فرنسا'),
(2671, 1041758424, 1041758431, 'GB', 'GBR', 'المملكة المتحدة'),
(2672, 1041758432, 1041758463, 'FR', 'FRA', 'فرنسا'),
(2673, 1041758464, 1041758495, 'GB', 'GBR', 'المملكة المتحدة'),
(2674, 1041758496, 1041758511, 'FR', 'FRA', 'فرنسا'),
(2675, 1041758512, 1041758527, 'GB', 'GBR', 'المملكة المتحدة'),
(2676, 1041758528, 1041758567, 'FR', 'FRA', 'فرنسا'),
(2677, 1041758568, 1041758599, 'GB', 'GBR', 'المملكة المتحدة'),
(2678, 1041758600, 1041758607, 'FR', 'FRA', 'فرنسا'),
(2679, 1041758608, 1041758631, 'GB', 'GBR', 'المملكة المتحدة'),
(2680, 1041758632, 1041758647, 'FR', 'FRA', 'فرنسا'),
(2681, 1041758648, 1041758671, 'GB', 'GBR', 'المملكة المتحدة'),
(2682, 1041758672, 1041758679, 'FR', 'FRA', 'فرنسا'),
(2683, 1041758680, 1041758687, 'GB', 'GBR', 'المملكة المتحدة'),
(2684, 1041758688, 1041758719, 'FR', 'FRA', 'فرنسا'),
(2685, 1041758720, 1041758975, 'GB', 'GBR', 'المملكة المتحدة'),
(2686, 1041758976, 1041759103, 'FR', 'FRA', 'فرنسا'),
(2687, 1041759104, 1041760255, 'GB', 'GBR', 'المملكة المتحدة'),
(2688, 1041760256, 1041768447, 'DE', 'DEU', 'ألمانيا'),
(2689, 1041768448, 1041776639, 'NO', 'NOR', 'النرويج'),
(2690, 1041776640, 1041784831, 'CZ', 'CZE', 'التشيك'),
(2691, 1041793024, 1041825791, 'GB', 'GBR', 'المملكة المتحدة'),
(2692, 1041825792, 1041842175, 'NL', 'NLD', 'هولندا'),
(2693, 1041842176, 1041891327, 'GB', 'GBR', 'المملكة المتحدة'),
(2694, 1041891328, 1041921535, 'DE', 'DEU', 'ألمانيا'),
(2695, 1041921536, 1041921727, 'US', 'USA', 'الولايات المتحدة'),
(2696, 1041921728, 1041945087, 'DE', 'DEU', 'ألمانيا'),
(2697, 1041945088, 1041945151, 'AT', 'AUT', 'النمسا'),
(2698, 1041945152, 1041958463, 'DE', 'DEU', 'ألمانيا'),
(2699, 1041958464, 1041958527, 'DK', 'DNK', 'الدنيمارك'),
(2700, 1041958528, 1041959423, 'DE', 'DEU', 'ألمانيا'),
(2701, 1041959424, 1041959679, 'US', 'USA', 'الولايات المتحدة'),
(2702, 1041959680, 1042022399, 'DE', 'DEU', 'ألمانيا'),
(2703, 1042022400, 1042087935, 'PT', 'PRT', 'البورتوغال'),
(2704, 1042087936, 1042120703, 'TR', 'TUR', 'تركيا'),
(2705, 1042120704, 1042153471, 'PL', 'POL', 'بولندا'),
(2706, 1042153472, 1042284543, 'GB', 'GBR', 'المملكة المتحدة'),
(2707, 1042284544, 1042288399, 'CH', 'CHE', 'سويسرا'),
(2708, 1042288400, 1042288415, 'GB', 'GBR', 'المملكة المتحدة'),
(2709, 1042288416, 1042292735, 'CH', 'CHE', 'سويسرا'),
(2710, 1042292736, 1042293247, 'NL', 'NLD', 'هولندا'),
(2711, 1042293248, 1042293503, 'GB', 'GBR', 'المملكة المتحدة'),
(2712, 1042293504, 1042293535, 'NL', 'NLD', 'هولندا'),
(2713, 1042293536, 1042293631, 'IR', 'IRN', 'إيران'),
(2714, 1042293632, 1042296063, 'GE', 'GEO', 'جورجيا'),
(2715, 1042296064, 1042296191, 'CY', 'CYP', 'قبرص'),
(2716, 1042296192, 1042296575, 'GE', 'GEO', 'جورجيا'),
(2717, 1042296576, 1042296831, 'BY', 'BLR', 'روسيا البيضاء'),
(2718, 1042296832, 1042297215, 'NL', 'NLD', 'هولندا'),
(2719, 1042297216, 1042297319, 'IR', 'IRN', 'إيران'),
(2720, 1042297320, 1042297327, 'GE', 'GEO', 'جورجيا'),
(2721, 1042297328, 1042297599, 'IR', 'IRN', 'إيران'),
(2722, 1042297600, 1042297855, 'GB', 'GBR', 'المملكة المتحدة'),
(2723, 1042297856, 1042298111, 'NL', 'NLD', 'هولندا'),
(2724, 1042298112, 1042298143, 'US', 'USA', 'الولايات المتحدة'),
(2725, 1042298144, 1042298175, 'NL', 'NLD', 'هولندا'),
(2726, 1042298176, 1042298239, 'IR', 'IRN', 'إيران'),
(2727, 1042298240, 1042298279, 'IQ', 'IRQ', 'العراق'),
(2728, 1042298280, 1042298287, 'IR', 'IRN', 'إيران'),
(2729, 1042298288, 1042298303, 'GB', 'GBR', 'المملكة المتحدة'),
(2730, 1042298304, 1042298335, 'IQ', 'IRQ', 'العراق'),
(2731, 1042298336, 1042298351, 'IR', 'IRN', 'إيران'),
(2732, 1042298352, 1042298367, 'NL', 'NLD', 'هولندا'),
(2733, 1042298368, 1042298623, 'GB', 'GBR', 'المملكة المتحدة'),
(2734, 1042298624, 1042298879, 'NL', 'NLD', 'هولندا'),
(2735, 1042298880, 1042299135, 'GB', 'GBR', 'المملكة المتحدة'),
(2736, 1042299136, 1042299391, 'IQ', 'IRQ', 'العراق'),
(2737, 1042299392, 1042300159, 'NL', 'NLD', 'هولندا'),
(2738, 1042300160, 1042300175, 'BY', 'BLR', 'روسيا البيضاء'),
(2739, 1042300176, 1042300223, 'IQ', 'IRQ', 'العراق'),
(2740, 1042300224, 1042300255, 'AM', 'ARM', 'أرمينيا'),
(2741, 1042300256, 1042300287, 'IR', 'IRN', 'إيران'),
(2742, 1042300288, 1042300351, 'IT', 'ITA', 'إيطاليا'),
(2743, 1042300352, 1042300383, 'IQ', 'IRQ', 'العراق'),
(2744, 1042300384, 1042300415, 'IR', 'IRN', 'إيران'),
(2745, 1042300416, 1042300479, 'NL', 'NLD', 'هولندا'),
(2746, 1042300480, 1042300495, 'IQ', 'IRQ', 'العراق'),
(2747, 1042300496, 1042300543, 'GB', 'GBR', 'المملكة المتحدة'),
(2748, 1042300544, 1042300639, 'IQ', 'IRQ', 'العراق'),
(2749, 1042300640, 1042300647, 'NL', 'NLD', 'هولندا'),
(2750, 1042300648, 1042300655, 'IQ', 'IRQ', 'العراق'),
(2751, 1042300656, 1042300671, 'LB', 'LBN', 'لبنان'),
(2752, 1042300672, 1042300799, 'IQ', 'IRQ', 'العراق'),
(2753, 1042300800, 1042300863, 'IR', 'IRN', 'إيران'),
(2754, 1042300864, 1042300895, 'LB', 'LBN', 'لبنان'),
(2755, 1042300896, 1042300903, 'MD', 'MDA', 'مولدوفا'),
(2756, 1042300904, 1042300911, 'UA', 'UKR', 'أوكرانيا'),
(2757, 1042300912, 1042300919, 'NL', 'NLD', 'هولندا'),
(2758, 1042300920, 1042300927, 'UA', 'UKR', 'أوكرانيا'),
(2759, 1042300928, 1042309119, 'RU', 'RUS', 'الإتحاد الروسي'),
(2760, 1042309120, 1042317311, 'GB', 'GBR', 'المملكة المتحدة'),
(2761, 1042317312, 1042350079, 'ES', 'ESP', 'إسبانيا'),
(2762, 1042350080, 1042415615, 'RU', 'RUS', 'الإتحاد الروسي'),
(2763, 1042415616, 1042546687, 'FR', 'FRA', 'فرنسا'),
(2764, 1042546688, 1042677759, 'ES', 'ESP', 'إسبانيا'),
(2765, 1042677760, 1042743295, 'GR', 'GRC', 'اليونان'),
(2766, 1042743296, 1042808831, 'FR', 'FRA', 'فرنسا'),
(2767, 1042808832, 1042817023, 'DE', 'DEU', 'ألمانيا'),
(2768, 1042817024, 1042825215, 'IE', 'IRL', 'إيرلندا'),
(2769, 1042825216, 1042833407, 'CZ', 'CZE', 'التشيك'),
(2770, 1042833408, 1042841599, 'GB', 'GBR', 'المملكة المتحدة'),
(2771, 1042841600, 1042874367, 'AT', 'AUT', 'النمسا'),
(2772, 1042874368, 1042875399, 'NL', 'NLD', 'هولندا'),
(2773, 1042875400, 1042875407, 'DE', 'DEU', 'ألمانيا'),
(2774, 1042875408, 1042875903, 'NL', 'NLD', 'هولندا'),
(2775, 1042875904, 1042876159, 'GB', 'GBR', 'المملكة المتحدة'),
(2776, 1042876160, 1042876415, 'NL', 'NLD', 'هولندا'),
(2777, 1042876416, 1042876479, 'GB', 'GBR', 'المملكة المتحدة'),
(2778, 1042876480, 1042876671, 'NL', 'NLD', 'هولندا'),
(2779, 1042876672, 1042876927, 'DE', 'DEU', 'ألمانيا'),
(2780, 1042876928, 1042877183, 'NL', 'NLD', 'هولندا'),
(2781, 1042877184, 1042877951, 'DE', 'DEU', 'ألمانيا'),
(2782, 1042877952, 1042880639, 'NL', 'NLD', 'هولندا'),
(2783, 1042880640, 1042880767, 'GB', 'GBR', 'المملكة المتحدة'),
(2784, 1042880768, 1042882559, 'NL', 'NLD', 'هولندا'),
(2785, 1042882560, 1042882815, 'DE', 'DEU', 'ألمانيا'),
(2786, 1042882816, 1042888703, 'NL', 'NLD', 'هولندا'),
(2787, 1042888704, 1042888959, 'GB', 'GBR', 'المملكة المتحدة'),
(2788, 1042888960, 1042889215, 'NL', 'NLD', 'هولندا'),
(2789, 1042889216, 1042889471, 'US', 'USA', 'الولايات المتحدة'),
(2790, 1042889472, 1042889983, 'NL', 'NLD', 'هولندا'),
(2791, 1042889984, 1042890111, 'GB', 'GBR', 'المملكة المتحدة'),
(2792, 1042890112, 1042890815, 'NL', 'NLD', 'هولندا'),
(2793, 1042890816, 1042890819, 'FR', 'FRA', 'فرنسا'),
(2794, 1042890820, 1042890847, 'NL', 'NLD', 'هولندا'),
(2795, 1042890848, 1042890879, 'GB', 'GBR', 'المملكة المتحدة'),
(2796, 1042890880, 1042890944, 'NL', 'NLD', 'هولندا'),
(2797, 1042890945, 1042890950, 'GB', 'GBR', 'المملكة المتحدة'),
(2798, 1042890951, 1042890959, 'NL', 'NLD', 'هولندا'),
(2799, 1042890960, 1042890991, 'GB', 'GBR', 'المملكة المتحدة'),
(2800, 1042890992, 1042891775, 'NL', 'NLD', 'هولندا'),
(2801, 1042891776, 1042891839, 'GB', 'GBR', 'المملكة المتحدة'),
(2802, 1042891840, 1042892015, 'NL', 'NLD', 'هولندا'),
(2803, 1042892016, 1042892031, 'DE', 'DEU', 'ألمانيا'),
(2804, 1042892032, 1042892479, 'NL', 'NLD', 'هولندا'),
(2805, 1042892480, 1042892543, 'PL', 'POL', 'بولندا'),
(2806, 1042892544, 1042892879, 'NL', 'NLD', 'هولندا'),
(2807, 1042892880, 1042892887, 'DE', 'DEU', 'ألمانيا'),
(2808, 1042892888, 1042892959, 'NL', 'NLD', 'هولندا'),
(2809, 1042892960, 1042892967, 'DE', 'DEU', 'ألمانيا'),
(2810, 1042892968, 1042892975, 'PL', 'POL', 'بولندا'),
(2811, 1042892976, 1042892983, 'CH', 'CHE', 'سويسرا'),
(2812, 1042892984, 1042893055, 'NL', 'NLD', 'هولندا'),
(2813, 1042893056, 1042893087, 'GB', 'GBR', 'المملكة المتحدة'),
(2814, 1042893088, 1042893135, 'NL', 'NLD', 'هولندا'),
(2815, 1042893136, 1042893143, 'DE', 'DEU', 'ألمانيا'),
(2816, 1042893144, 1042893183, 'NL', 'NLD', 'هولندا'),
(2817, 1042893184, 1042893311, 'GB', 'GBR', 'المملكة المتحدة'),
(2818, 1042893312, 1042894079, 'NL', 'NLD', 'هولندا'),
(2819, 1042894080, 1042894143, 'DE', 'DEU', 'ألمانيا'),
(2820, 1042894144, 1042894175, 'SE', 'SWE', 'السويد'),
(2821, 1042894176, 1042894559, 'NL', 'NLD', 'هولندا'),
(2822, 1042894560, 1042894591, 'DE', 'DEU', 'ألمانيا'),
(2823, 1042894592, 1042894655, 'FR', 'FRA', 'فرنسا'),
(2824, 1042894656, 1042894783, 'NL', 'NLD', 'هولندا'),
(2825, 1042894784, 1042894847, 'DE', 'DEU', 'ألمانيا'),
(2826, 1042894848, 1042895231, 'NL', 'NLD', 'هولندا'),
(2827, 1042895232, 1042895359, 'DE', 'DEU', 'ألمانيا'),
(2828, 1042895360, 1042895615, 'NL', 'NLD', 'هولندا'),
(2829, 1042895616, 1042895871, 'GB', 'GBR', 'المملكة المتحدة'),
(2830, 1042895872, 1042900479, 'NL', 'NLD', 'هولندا'),
(2831, 1042900480, 1042900735, 'GB', 'GBR', 'المملكة المتحدة'),
(2832, 1042900736, 1042939903, 'NL', 'NLD', 'هولندا'),
(2833, 1042939904, 1043070975, 'ES', 'ESP', 'إسبانيا'),
(2834, 1043070976, 1043079167, 'CZ', 'CZE', 'التشيك'),
(2835, 1043079168, 1043087359, 'DE', 'DEU', 'ألمانيا'),
(2836, 1043087360, 1043095551, 'GB', 'GBR', 'المملكة المتحدة'),
(2837, 1043095552, 1043103743, 'BG', 'BGR', 'بلغاريا'),
(2838, 1043103744, 1043120127, 'DK', 'DNK', 'الدنيمارك'),
(2839, 1043120128, 1043136511, 'FI', 'FIN', 'فنلندا'),
(2840, 1043136512, 1043202047, 'NL', 'NLD', 'هولندا'),
(2841, 1043202048, 1043333119, 'AT', 'AUT', 'النمسا'),
(2842, 1043333120, 1043341311, 'CH', 'CHE', 'سويسرا'),
(2843, 1043341312, 1043349503, 'IT', 'ITA', 'إيطاليا'),
(2844, 1043349504, 1043350587, 'DE', 'DEU', 'ألمانيا'),
(2845, 1043350588, 1043350591, 'AT', 'AUT', 'النمسا'),
(2846, 1043350592, 1043357695, 'DE', 'DEU', 'ألمانيا'),
(2847, 1043357696, 1043365887, 'CH', 'CHE', 'سويسرا'),
(2848, 1043365888, 1043398655, 'PT', 'PRT', 'البورتوغال'),
(2849, 1043398656, 1043464191, 'GB', 'GBR', 'المملكة المتحدة'),
(2850, 1043464192, 1043465215, 'NL', 'NLD', 'هولندا'),
(2851, 1043465216, 1043466503, 'GB', 'GBR', 'المملكة المتحدة'),
(2852, 1043466504, 1043466511, 'NL', 'NLD', 'هولندا'),
(2853, 1043466512, 1043466687, 'GB', 'GBR', 'المملكة المتحدة'),
(2854, 1043466688, 1043466711, 'NL', 'NLD', 'هولندا'),
(2855, 1043466712, 1043474703, 'GB', 'GBR', 'المملكة المتحدة'),
(2856, 1043474704, 1043474719, 'DE', 'DEU', 'ألمانيا'),
(2857, 1043474720, 1043480575, 'GB', 'GBR', 'المملكة المتحدة'),
(2858, 1043480576, 1043488767, 'CH', 'CHE', 'سويسرا'),
(2859, 1043488768, 1043496959, 'DE', 'DEU', 'ألمانيا'),
(2860, 1043496960, 1043505151, 'GB', 'GBR', 'المملكة المتحدة'),
(2861, 1043505152, 1043513343, 'NO', 'NOR', 'النرويج'),
(2862, 1043513344, 1043529727, 'GB', 'GBR', 'المملكة المتحدة'),
(2863, 1043529728, 1043562495, 'NL', 'NLD', 'هولندا'),
(2864, 1043595264, 1043600639, 'DE', 'DEU', 'ألمانيا'),
(2865, 1043600640, 1043600895, 'FR', 'FRA', 'فرنسا'),
(2866, 1043600896, 1043607679, 'DE', 'DEU', 'ألمانيا'),
(2867, 1043607680, 1043607711, 'FR', 'FRA', 'فرنسا'),
(2868, 1043607712, 1043609279, 'DE', 'DEU', 'ألمانيا'),
(2869, 1043609280, 1043609343, 'AT', 'AUT', 'النمسا'),
(2870, 1043609344, 1043609463, 'DE', 'DEU', 'ألمانيا'),
(2871, 1043609464, 1043609471, 'IE', 'IRL', 'إيرلندا'),
(2872, 1043609472, 1043619839, 'DE', 'DEU', 'ألمانيا'),
(2873, 1043619840, 1043620095, 'IE', 'IRL', 'إيرلندا'),
(2874, 1043620096, 1043621503, 'DE', 'DEU', 'ألمانيا'),
(2875, 1043621504, 1043621567, 'GB', 'GBR', 'المملكة المتحدة'),
(2876, 1043621568, 1043623215, 'DE', 'DEU', 'ألمانيا'),
(2877, 1043623216, 1043623231, 'GB', 'GBR', 'المملكة المتحدة'),
(2878, 1043623232, 1043633663, 'DE', 'DEU', 'ألمانيا'),
(2879, 1043633664, 1043633919, 'FR', 'FRA', 'فرنسا'),
(2880, 1043633920, 1043693055, 'DE', 'DEU', 'ألمانيا'),
(2881, 1043693056, 1043693127, 'GB', 'GBR', 'المملكة المتحدة'),
(2882, 1043693128, 1043693183, 'DE', 'DEU', 'ألمانيا'),
(2883, 1043693184, 1043693567, 'GB', 'GBR', 'المملكة المتحدة'),
(2884, 1043693568, 1043718783, 'DE', 'DEU', 'ألمانيا'),
(2885, 1043718784, 1043718815, 'FR', 'FRA', 'فرنسا'),
(2886, 1043718816, 1043857407, 'DE', 'DEU', 'ألمانيا'),
(2887, 1043857408, 1043890183, 'GB', 'GBR', 'المملكة المتحدة'),
(2888, 1043890184, 1043890191, 'NG', 'NGA', 'نيجيريا'),
(2889, 1043890192, 1043890207, 'GB', 'GBR', 'المملكة المتحدة'),
(2890, 1043890208, 1043890239, 'NG', 'NGA', 'نيجيريا'),
(2891, 1043890240, 1043890495, 'GB', 'GBR', 'المملكة المتحدة'),
(2892, 1043890496, 1043890591, 'NG', 'NGA', 'نيجيريا'),
(2893, 1043890592, 1043891775, 'GB', 'GBR', 'المملكة المتحدة'),
(2894, 1043891776, 1043891839, 'NG', 'NGA', 'نيجيريا'),
(2895, 1043891840, 1043892223, 'GB', 'GBR', 'المملكة المتحدة'),
(2896, 1043892224, 1043892239, 'MZ', 'MOZ', 'موزامبيق'),
(2897, 1043892240, 1043892255, 'GB', 'GBR', 'المملكة المتحدة'),
(2898, 1043892256, 1043892287, 'MZ', 'MOZ', 'موزامبيق'),
(2899, 1043892288, 1043892479, 'GB', 'GBR', 'المملكة المتحدة'),
(2900, 1043892480, 1043892735, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(2901, 1043892736, 1043892991, 'MZ', 'MOZ', 'موزامبيق'),
(2902, 1043892992, 1043893567, 'GB', 'GBR', 'المملكة المتحدة'),
(2903, 1043893568, 1043893583, 'NG', 'NGA', 'نيجيريا'),
(2904, 1043893584, 1043894559, 'GB', 'GBR', 'المملكة المتحدة'),
(2905, 1043894560, 1043894591, 'NG', 'NGA', 'نيجيريا'),
(2906, 1043894592, 1043894751, 'GB', 'GBR', 'المملكة المتحدة'),
(2907, 1043894752, 1043894783, 'NG', 'NGA', 'نيجيريا'),
(2908, 1043894784, 1043894847, 'GB', 'GBR', 'المملكة المتحدة'),
(2909, 1043894848, 1043894879, 'NG', 'NGA', 'نيجيريا'),
(2910, 1043894880, 1043895039, 'GB', 'GBR', 'المملكة المتحدة'),
(2911, 1043895040, 1043895167, 'NG', 'NGA', 'نيجيريا'),
(2912, 1043895168, 1043895983, 'GB', 'GBR', 'المملكة المتحدة'),
(2913, 1043895984, 1043895999, 'AO', 'AGO', 'أنغولا'),
(2914, 1043896000, 1043896063, 'GB', 'GBR', 'المملكة المتحدة'),
(2915, 1043896064, 1043896319, 'NG', 'NGA', 'نيجيريا'),
(2916, 1043896320, 1043897343, 'GB', 'GBR', 'المملكة المتحدة'),
(2917, 1043897344, 1043897855, 'KE', 'KEN', 'كينيا'),
(2918, 1043897856, 1043898623, 'GB', 'GBR', 'المملكة المتحدة'),
(2919, 1043898624, 1043898751, 'TZ', 'TZA', 'تانزانيا'),
(2920, 1043898752, 1043898879, 'GB', 'GBR', 'المملكة المتحدة'),
(2921, 1043898880, 1043899391, 'DE', 'DEU', 'ألمانيا'),
(2922, 1043899392, 1043899647, 'CG', 'COG', 'الكونغو'),
(2923, 1043899648, 1043910143, 'GB', 'GBR', 'المملكة المتحدة'),
(2924, 1043910144, 1043910399, 'TZ', 'TZA', 'تانزانيا'),
(2925, 1043910400, 1043912703, 'GB', 'GBR', 'المملكة المتحدة'),
(2926, 1043912704, 1043913215, 'ZM', 'ZMB', 'زامبيا'),
(2927, 1043913216, 1043913727, 'GB', 'GBR', 'المملكة المتحدة'),
(2928, 1043913728, 1043914751, 'DE', 'DEU', 'ألمانيا'),
(2929, 1043914752, 1043914879, 'NG', 'NGA', 'نيجيريا'),
(2930, 1043914880, 1043916799, 'GB', 'GBR', 'المملكة المتحدة'),
(2931, 1043916800, 1043917055, 'NG', 'NGA', 'نيجيريا'),
(2932, 1043917056, 1043921919, 'GB', 'GBR', 'المملكة المتحدة'),
(2933, 1043921920, 1043922943, 'IL', 'ISR', 'إسرائيل'),
(2934, 1043922944, 1043988479, 'ES', 'ESP', 'إسبانيا'),
(2935, 1043988480, 1043988487, 'NL', 'NLD', 'هولندا'),
(2936, 1043988488, 1043988495, 'BE', 'BEL', 'بلجيكا'),
(2937, 1043988496, 1043988503, 'NL', 'NLD', 'هولندا'),
(2938, 1043988504, 1043988511, 'BE', 'BEL', 'بلجيكا'),
(2939, 1043988512, 1043988527, 'NL', 'NLD', 'هولندا'),
(2940, 1043988528, 1043988551, 'BE', 'BEL', 'بلجيكا'),
(2941, 1043988552, 1043988559, 'NL', 'NLD', 'هولندا'),
(2942, 1043988560, 1043988575, 'BE', 'BEL', 'بلجيكا'),
(2943, 1043988576, 1043988607, 'NL', 'NLD', 'هولندا'),
(2944, 1043988608, 1043988639, 'BE', 'BEL', 'بلجيكا'),
(2945, 1043988640, 1043988647, 'NL', 'NLD', 'هولندا'),
(2946, 1043988648, 1043988655, 'BE', 'BEL', 'بلجيكا'),
(2947, 1043988656, 1043988663, 'NL', 'NLD', 'هولندا'),
(2948, 1043988664, 1043988679, 'BE', 'BEL', 'بلجيكا'),
(2949, 1043988680, 1043988711, 'NL', 'NLD', 'هولندا'),
(2950, 1043988712, 1043988719, 'BE', 'BEL', 'بلجيكا'),
(2951, 1043988720, 1043988727, 'NL', 'NLD', 'هولندا'),
(2952, 1043988728, 1043988735, 'BE', 'BEL', 'بلجيكا'),
(2953, 1043988736, 1043988767, 'NL', 'NLD', 'هولندا'),
(2954, 1043988768, 1043988775, 'BE', 'BEL', 'بلجيكا'),
(2955, 1043988776, 1043988799, 'NL', 'NLD', 'هولندا'),
(2956, 1043988800, 1043988823, 'BE', 'BEL', 'بلجيكا'),
(2957, 1043988824, 1043988943, 'NL', 'NLD', 'هولندا'),
(2958, 1043988944, 1043989119, 'BE', 'BEL', 'بلجيكا'),
(2959, 1043989120, 1043989503, 'NL', 'NLD', 'هولندا'),
(2960, 1043989504, 1043989535, 'BE', 'BEL', 'بلجيكا'),
(2961, 1043989536, 1043989543, 'NL', 'NLD', 'هولندا'),
(2962, 1043989544, 1043989567, 'BE', 'BEL', 'بلجيكا'),
(2963, 1043989568, 1043989599, 'NL', 'NLD', 'هولندا'),
(2964, 1043989600, 1043989639, 'BE', 'BEL', 'بلجيكا'),
(2965, 1043989640, 1043989655, 'NL', 'NLD', 'هولندا'),
(2966, 1043989656, 1043989663, 'BE', 'BEL', 'بلجيكا'),
(2967, 1043989664, 1043989695, 'NL', 'NLD', 'هولندا'),
(2968, 1043989696, 1043989751, 'BE', 'BEL', 'بلجيكا'),
(2969, 1043989752, 1043990015, 'NL', 'NLD', 'هولندا'),
(2970, 1043990016, 1043990271, 'BE', 'BEL', 'بلجيكا'),
(2971, 1043990272, 1043990367, 'NL', 'NLD', 'هولندا'),
(2972, 1043990368, 1043990527, 'BE', 'BEL', 'بلجيكا'),
(2973, 1043990528, 1043990543, 'NL', 'NLD', 'هولندا'),
(2974, 1043990544, 1043990559, 'BE', 'BEL', 'بلجيكا'),
(2975, 1043990560, 1043990591, 'NL', 'NLD', 'هولندا'),
(2976, 1043990592, 1043990615, 'BE', 'BEL', 'بلجيكا'),
(2977, 1043990616, 1043990623, 'NL', 'NLD', 'هولندا'),
(2978, 1043990624, 1043990631, 'BE', 'BEL', 'بلجيكا'),
(2979, 1043990632, 1043990783, 'NL', 'NLD', 'هولندا'),
(2980, 1043990784, 1043991039, 'BE', 'BEL', 'بلجيكا'),
(2981, 1043991040, 1043991063, 'NL', 'NLD', 'هولندا'),
(2982, 1043991064, 1043991071, 'BE', 'BEL', 'بلجيكا'),
(2983, 1043991072, 1043991231, 'NL', 'NLD', 'هولندا'),
(2984, 1043991232, 1043992063, 'BE', 'BEL', 'بلجيكا'),
(2985, 1043992064, 1043992319, 'NL', 'NLD', 'هولندا'),
(2986, 1043992320, 1043992575, 'BE', 'BEL', 'بلجيكا'),
(2987, 1043992576, 1043992735, 'NL', 'NLD', 'هولندا'),
(2988, 1043992736, 1043992767, 'BE', 'BEL', 'بلجيكا'),
(2989, 1043992768, 1043992831, 'NL', 'NLD', 'هولندا'),
(2990, 1043992832, 1043993599, 'BE', 'BEL', 'بلجيكا'),
(2991, 1043993600, 1043993855, 'NL', 'NLD', 'هولندا'),
(2992, 1043993856, 1043994643, 'BE', 'BEL', 'بلجيكا'),
(2993, 1043994644, 1043994651, 'NL', 'NLD', 'هولندا'),
(2994, 1043994652, 1043994655, 'BE', 'BEL', 'بلجيكا'),
(2995, 1043994656, 1043994699, 'NL', 'NLD', 'هولندا'),
(2996, 1043994700, 1043994703, 'BE', 'BEL', 'بلجيكا'),
(2997, 1043994704, 1043994707, 'NL', 'NLD', 'هولندا'),
(2998, 1043994708, 1043994711, 'BE', 'BEL', 'بلجيكا'),
(2999, 1043994712, 1043994747, 'NL', 'NLD', 'هولندا'),
(3000, 1043994748, 1043994755, 'BE', 'BEL', 'بلجيكا'),
(3001, 1043994756, 1043994759, 'NL', 'NLD', 'هولندا'),
(3002, 1043994760, 1043994791, 'BE', 'BEL', 'بلجيكا'),
(3003, 1043994792, 1043994795, 'NL', 'NLD', 'هولندا'),
(3004, 1043994796, 1043994811, 'BE', 'BEL', 'بلجيكا'),
(3005, 1043994812, 1043994815, 'NL', 'NLD', 'هولندا'),
(3006, 1043994816, 1043994851, 'BE', 'BEL', 'بلجيكا'),
(3007, 1043994852, 1043994855, 'NL', 'NLD', 'هولندا'),
(3008, 1043994856, 1043994863, 'BE', 'BEL', 'بلجيكا'),
(3009, 1043994864, 1043994867, 'NL', 'NLD', 'هولندا'),
(3010, 1043994868, 1043994871, 'BE', 'BEL', 'بلجيكا'),
(3011, 1043994872, 1043994875, 'NL', 'NLD', 'هولندا'),
(3012, 1043994876, 1043994879, 'BE', 'BEL', 'بلجيكا'),
(3013, 1043994880, 1043994887, 'NL', 'NLD', 'هولندا'),
(3014, 1043994888, 1043994907, 'BE', 'BEL', 'بلجيكا'),
(3015, 1043994908, 1043994911, 'NL', 'NLD', 'هولندا'),
(3016, 1043994912, 1043994931, 'BE', 'BEL', 'بلجيكا'),
(3017, 1043994932, 1043994935, 'NL', 'NLD', 'هولندا'),
(3018, 1043994936, 1043994975, 'BE', 'BEL', 'بلجيكا'),
(3019, 1043994976, 1043994979, 'NL', 'NLD', 'هولندا'),
(3020, 1043994980, 1043994987, 'BE', 'BEL', 'بلجيكا'),
(3021, 1043994988, 1043994991, 'NL', 'NLD', 'هولندا'),
(3022, 1043994992, 1043994995, 'BE', 'BEL', 'بلجيكا'),
(3023, 1043994996, 1043995003, 'NL', 'NLD', 'هولندا'),
(3024, 1043995004, 1043995023, 'BE', 'BEL', 'بلجيكا'),
(3025, 1043995024, 1043995027, 'NL', 'NLD', 'هولندا'),
(3026, 1043995028, 1043995035, 'BE', 'BEL', 'بلجيكا'),
(3027, 1043995036, 1043995051, 'NL', 'NLD', 'هولندا'),
(3028, 1043995052, 1043995059, 'BE', 'BEL', 'بلجيكا'),
(3029, 1043995060, 1043995067, 'NL', 'NLD', 'هولندا'),
(3030, 1043995068, 1043995103, 'BE', 'BEL', 'بلجيكا'),
(3031, 1043995104, 1043995115, 'NL', 'NLD', 'هولندا'),
(3032, 1043995116, 1043995127, 'BE', 'BEL', 'بلجيكا'),
(3033, 1043995128, 1043995131, 'NL', 'NLD', 'هولندا'),
(3034, 1043995132, 1043995135, 'BE', 'BEL', 'بلجيكا'),
(3035, 1043995136, 1043995139, 'NL', 'NLD', 'هولندا'),
(3036, 1043995140, 1043995151, 'BE', 'BEL', 'بلجيكا'),
(3037, 1043995152, 1043995155, 'NL', 'NLD', 'هولندا'),
(3038, 1043995156, 1043995171, 'BE', 'BEL', 'بلجيكا'),
(3039, 1043995172, 1043995175, 'NL', 'NLD', 'هولندا'),
(3040, 1043995176, 1043995183, 'BE', 'BEL', 'بلجيكا'),
(3041, 1043995184, 1043995187, 'NL', 'NLD', 'هولندا'),
(3042, 1043995188, 1043995215, 'BE', 'BEL', 'بلجيكا'),
(3043, 1043995216, 1043995223, 'NL', 'NLD', 'هولندا'),
(3044, 1043995224, 1043995263, 'BE', 'BEL', 'بلجيكا'),
(3045, 1043995264, 1043995267, 'NL', 'NLD', 'هولندا'),
(3046, 1043995268, 1043995279, 'BE', 'BEL', 'بلجيكا'),
(3047, 1043995280, 1043995283, 'NL', 'NLD', 'هولندا'),
(3048, 1043995284, 1043995291, 'BE', 'BEL', 'بلجيكا'),
(3049, 1043995292, 1043995295, 'NL', 'NLD', 'هولندا'),
(3050, 1043995296, 1043995303, 'BE', 'BEL', 'بلجيكا'),
(3051, 1043995304, 1043995311, 'NL', 'NLD', 'هولندا'),
(3052, 1043995312, 1043995663, 'BE', 'BEL', 'بلجيكا'),
(3053, 1043995664, 1043995687, 'NL', 'NLD', 'هولندا'),
(3054, 1043995688, 1043995695, 'BE', 'BEL', 'بلجيكا'),
(3055, 1043995696, 1043995703, 'NL', 'NLD', 'هولندا'),
(3056, 1043995704, 1043995719, 'BE', 'BEL', 'بلجيكا'),
(3057, 1043995720, 1043995735, 'NL', 'NLD', 'هولندا'),
(3058, 1043995736, 1043995743, 'BE', 'BEL', 'بلجيكا'),
(3059, 1043995744, 1043995759, 'NL', 'NLD', 'هولندا'),
(3060, 1043995760, 1043995767, 'BE', 'BEL', 'بلجيكا'),
(3061, 1043995768, 1043995783, 'NL', 'NLD', 'هولندا'),
(3062, 1043995784, 1043995807, 'BE', 'BEL', 'بلجيكا'),
(3063, 1043995808, 1043995831, 'NL', 'NLD', 'هولندا'),
(3064, 1043995832, 1043995863, 'BE', 'BEL', 'بلجيكا'),
(3065, 1043995864, 1043995887, 'NL', 'NLD', 'هولندا'),
(3066, 1043995888, 1043995903, 'BE', 'BEL', 'بلجيكا'),
(3067, 1043995904, 1043995935, 'NL', 'NLD', 'هولندا'),
(3068, 1043995936, 1043995943, 'BE', 'BEL', 'بلجيكا'),
(3069, 1043995944, 1043995951, 'NL', 'NLD', 'هولندا'),
(3070, 1043995952, 1043995975, 'BE', 'BEL', 'بلجيكا'),
(3071, 1043995976, 1043995999, 'NL', 'NLD', 'هولندا'),
(3072, 1043996000, 1043996015, 'BE', 'BEL', 'بلجيكا'),
(3073, 1043996016, 1043996023, 'NL', 'NLD', 'هولندا'),
(3074, 1043996024, 1043996095, 'BE', 'BEL', 'بلجيكا'),
(3075, 1043996096, 1043996103, 'NL', 'NLD', 'هولندا'),
(3076, 1043996104, 1043996111, 'BE', 'BEL', 'بلجيكا'),
(3077, 1043996112, 1043996119, 'NL', 'NLD', 'هولندا'),
(3078, 1043996120, 1043996143, 'BE', 'BEL', 'بلجيكا'),
(3079, 1043996144, 1043996151, 'NL', 'NLD', 'هولندا'),
(3080, 1043996152, 1043996159, 'BE', 'BEL', 'بلجيكا'),
(3081, 1043996160, 1043996691, 'NL', 'NLD', 'هولندا'),
(3082, 1043996692, 1043996703, 'BE', 'BEL', 'بلجيكا'),
(3083, 1043996704, 1043996823, 'NL', 'NLD', 'هولندا'),
(3084, 1043996824, 1043996927, 'BE', 'BEL', 'بلجيكا'),
(3085, 1043996928, 1043997375, 'NL', 'NLD', 'هولندا'),
(3086, 1043997376, 1043997463, 'BE', 'BEL', 'بلجيكا'),
(3087, 1043997464, 1043997471, 'NL', 'NLD', 'هولندا'),
(3088, 1043997472, 1043997519, 'BE', 'BEL', 'بلجيكا'),
(3089, 1043997520, 1043997551, 'NL', 'NLD', 'هولندا'),
(3090, 1043997552, 1043997559, 'BE', 'BEL', 'بلجيكا'),
(3091, 1043997560, 1043997583, 'NL', 'NLD', 'هولندا'),
(3092, 1043997584, 1043997615, 'BE', 'BEL', 'بلجيكا'),
(3093, 1043997616, 1043997631, 'NL', 'NLD', 'هولندا'),
(3094, 1043997632, 1043997639, 'BE', 'BEL', 'بلجيكا'),
(3095, 1043997640, 1043997663, 'NL', 'NLD', 'هولندا'),
(3096, 1043997664, 1043997687, 'BE', 'BEL', 'بلجيكا'),
(3097, 1043997688, 1043997903, 'NL', 'NLD', 'هولندا'),
(3098, 1043997904, 1043997911, 'BE', 'BEL', 'بلجيكا'),
(3099, 1043997912, 1043997927, 'NL', 'NLD', 'هولندا'),
(3100, 1043997928, 1043998079, 'BE', 'BEL', 'بلجيكا'),
(3101, 1043998080, 1043998143, 'NL', 'NLD', 'هولندا'),
(3102, 1043998144, 1043998151, 'BE', 'BEL', 'بلجيكا'),
(3103, 1043998152, 1043998159, 'NL', 'NLD', 'هولندا'),
(3104, 1043998160, 1043998167, 'BE', 'BEL', 'بلجيكا'),
(3105, 1043998168, 1043998191, 'NL', 'NLD', 'هولندا'),
(3106, 1043998192, 1043998195, 'BE', 'BEL', 'بلجيكا'),
(3107, 1043998196, 1043998198, 'NL', 'NLD', 'هولندا'),
(3108, 1043998199, 1043998199, 'BE', 'BEL', 'بلجيكا'),
(3109, 1043998200, 1043998207, 'NL', 'NLD', 'هولندا'),
(3110, 1043998208, 1043998463, 'BE', 'BEL', 'بلجيكا'),
(3111, 1043998464, 1043998719, 'NL', 'NLD', 'هولندا'),
(3112, 1043998720, 1043998735, 'BE', 'BEL', 'بلجيكا'),
(3113, 1043998736, 1043998751, 'NL', 'NLD', 'هولندا'),
(3114, 1043998752, 1043998759, 'BE', 'BEL', 'بلجيكا'),
(3115, 1043998760, 1043998783, 'NL', 'NLD', 'هولندا'),
(3116, 1043998784, 1043998799, 'BE', 'BEL', 'بلجيكا'),
(3117, 1043998800, 1043998847, 'NL', 'NLD', 'هولندا'),
(3118, 1043998848, 1043998863, 'BE', 'BEL', 'بلجيكا'),
(3119, 1043998864, 1043998879, 'NL', 'NLD', 'هولندا'),
(3120, 1043998880, 1043998887, 'BE', 'BEL', 'بلجيكا'),
(3121, 1043998888, 1043998911, 'NL', 'NLD', 'هولندا'),
(3122, 1043998912, 1043998975, 'BE', 'BEL', 'بلجيكا'),
(3123, 1043998976, 1043998983, 'NL', 'NLD', 'هولندا'),
(3124, 1043998984, 1043999007, 'BE', 'BEL', 'بلجيكا'),
(3125, 1043999008, 1043999055, 'NL', 'NLD', 'هولندا'),
(3126, 1043999056, 1043999071, 'BE', 'BEL', 'بلجيكا'),
(3127, 1043999072, 1043999103, 'NL', 'NLD', 'هولندا'),
(3128, 1043999104, 1043999119, 'BE', 'BEL', 'بلجيكا'),
(3129, 1043999120, 1043999143, 'NL', 'NLD', 'هولندا'),
(3130, 1043999144, 1043999151, 'BE', 'BEL', 'بلجيكا'),
(3131, 1043999152, 1043999159, 'NL', 'NLD', 'هولندا'),
(3132, 1043999160, 1043999207, 'BE', 'BEL', 'بلجيكا'),
(3133, 1043999208, 1043999215, 'NL', 'NLD', 'هولندا'),
(3134, 1043999216, 1043999223, 'BE', 'BEL', 'بلجيكا'),
(3135, 1043999224, 1043999487, 'NL', 'NLD', 'هولندا'),
(3136, 1043999488, 1043999751, 'BE', 'BEL', 'بلجيكا'),
(3137, 1043999752, 1043999759, 'NL', 'NLD', 'هولندا'),
(3138, 1043999760, 1043999775, 'BE', 'BEL', 'بلجيكا'),
(3139, 1043999776, 1043999783, 'NL', 'NLD', 'هولندا'),
(3140, 1043999784, 1043999791, 'BE', 'BEL', 'بلجيكا'),
(3141, 1043999792, 1043999823, 'NL', 'NLD', 'هولندا'),
(3142, 1043999824, 1043999831, 'BE', 'BEL', 'بلجيكا'),
(3143, 1043999832, 1043999999, 'NL', 'NLD', 'هولندا'),
(3144, 1044000000, 1044000031, 'BE', 'BEL', 'بلجيكا'),
(3145, 1044000032, 1044000063, 'NL', 'NLD', 'هولندا'),
(3146, 1044000064, 1044000095, 'BE', 'BEL', 'بلجيكا'),
(3147, 1044000096, 1044000767, 'NL', 'NLD', 'هولندا'),
(3148, 1044000768, 1044000831, 'BE', 'BEL', 'بلجيكا'),
(3149, 1044000832, 1044000895, 'NL', 'NLD', 'هولندا'),
(3150, 1044000896, 1044000975, 'BE', 'BEL', 'بلجيكا'),
(3151, 1044000976, 1044000983, 'NL', 'NLD', 'هولندا'),
(3152, 1044000984, 1044000999, 'BE', 'BEL', 'بلجيكا'),
(3153, 1044001000, 1044001023, 'NL', 'NLD', 'هولندا'),
(3154, 1044001024, 1044001279, 'BE', 'BEL', 'بلجيكا'),
(3155, 1044001280, 1044001663, 'NL', 'NLD', 'هولندا'),
(3156, 1044001664, 1044001791, 'BE', 'BEL', 'بلجيكا'),
(3157, 1044001792, 1044001823, 'NL', 'NLD', 'هولندا'),
(3158, 1044001824, 1044001839, 'BE', 'BEL', 'بلجيكا'),
(3159, 1044001840, 1044001847, 'NL', 'NLD', 'هولندا'),
(3160, 1044001848, 1044001855, 'BE', 'BEL', 'بلجيكا'),
(3161, 1044001856, 1044001887, 'NL', 'NLD', 'هولندا'),
(3162, 1044001888, 1044001895, 'BE', 'BEL', 'بلجيكا'),
(3163, 1044001896, 1044001927, 'NL', 'NLD', 'هولندا'),
(3164, 1044001928, 1044001935, 'BE', 'BEL', 'بلجيكا'),
(3165, 1044001936, 1044001983, 'NL', 'NLD', 'هولندا'),
(3166, 1044001984, 1044002023, 'BE', 'BEL', 'بلجيكا'),
(3167, 1044002024, 1044002087, 'NL', 'NLD', 'هولندا'),
(3168, 1044002088, 1044002095, 'BE', 'BEL', 'بلجيكا'),
(3169, 1044002096, 1044002103, 'NL', 'NLD', 'هولندا'),
(3170, 1044002104, 1044002135, 'BE', 'BEL', 'بلجيكا'),
(3171, 1044002136, 1044002175, 'NL', 'NLD', 'هولندا'),
(3172, 1044002176, 1044002239, 'BE', 'BEL', 'بلجيكا'),
(3173, 1044002240, 1044002831, 'NL', 'NLD', 'هولندا'),
(3174, 1044002832, 1044002855, 'BE', 'BEL', 'بلجيكا'),
(3175, 1044002856, 1044002859, 'NL', 'NLD', 'هولندا'),
(3176, 1044002860, 1044002879, 'BE', 'BEL', 'بلجيكا'),
(3177, 1044002880, 1044002883, 'NL', 'NLD', 'هولندا'),
(3178, 1044002884, 1044002891, 'BE', 'BEL', 'بلجيكا'),
(3179, 1044002892, 1044002899, 'NL', 'NLD', 'هولندا'),
(3180, 1044002900, 1044002911, 'BE', 'BEL', 'بلجيكا'),
(3181, 1044002912, 1044002919, 'NL', 'NLD', 'هولندا'),
(3182, 1044002920, 1044002931, 'BE', 'BEL', 'بلجيكا'),
(3183, 1044002932, 1044002947, 'NL', 'NLD', 'هولندا'),
(3184, 1044002948, 1044002959, 'BE', 'BEL', 'بلجيكا'),
(3185, 1044002960, 1044002975, 'NL', 'NLD', 'هولندا'),
(3186, 1044002976, 1044002983, 'BE', 'BEL', 'بلجيكا'),
(3187, 1044002984, 1044002987, 'NL', 'NLD', 'هولندا'),
(3188, 1044002988, 1044002999, 'BE', 'BEL', 'بلجيكا'),
(3189, 1044003000, 1044003003, 'NL', 'NLD', 'هولندا'),
(3190, 1044003004, 1044003019, 'BE', 'BEL', 'بلجيكا'),
(3191, 1044003020, 1044003023, 'NL', 'NLD', 'هولندا'),
(3192, 1044003024, 1044003027, 'BE', 'BEL', 'بلجيكا'),
(3193, 1044003028, 1044003031, 'NL', 'NLD', 'هولندا'),
(3194, 1044003032, 1044003071, 'BE', 'BEL', 'بلجيكا'),
(3195, 1044003072, 1044003079, 'NL', 'NLD', 'هولندا'),
(3196, 1044003080, 1044003099, 'BE', 'BEL', 'بلجيكا'),
(3197, 1044003100, 1044003103, 'NL', 'NLD', 'هولندا'),
(3198, 1044003104, 1044003115, 'BE', 'BEL', 'بلجيكا'),
(3199, 1044003116, 1044003119, 'NL', 'NLD', 'هولندا'),
(3200, 1044003120, 1044003123, 'BE', 'BEL', 'بلجيكا'),
(3201, 1044003124, 1044003131, 'NL', 'NLD', 'هولندا'),
(3202, 1044003132, 1044003147, 'BE', 'BEL', 'بلجيكا'),
(3203, 1044003148, 1044003151, 'NL', 'NLD', 'هولندا'),
(3204, 1044003152, 1044003155, 'BE', 'BEL', 'بلجيكا'),
(3205, 1044003156, 1044003159, 'NL', 'NLD', 'هولندا'),
(3206, 1044003160, 1044003167, 'BE', 'BEL', 'بلجيكا'),
(3207, 1044003168, 1044003171, 'NL', 'NLD', 'هولندا'),
(3208, 1044003172, 1044003175, 'BE', 'BEL', 'بلجيكا'),
(3209, 1044003176, 1044003179, 'NL', 'NLD', 'هولندا'),
(3210, 1044003180, 1044003183, 'BE', 'BEL', 'بلجيكا'),
(3211, 1044003184, 1044003187, 'NL', 'NLD', 'هولندا'),
(3212, 1044003188, 1044003211, 'BE', 'BEL', 'بلجيكا'),
(3213, 1044003212, 1044003215, 'NL', 'NLD', 'هولندا'),
(3214, 1044003216, 1044003223, 'BE', 'BEL', 'بلجيكا'),
(3215, 1044003224, 1044003227, 'NL', 'NLD', 'هولندا'),
(3216, 1044003228, 1044003235, 'BE', 'BEL', 'بلجيكا'),
(3217, 1044003236, 1044003251, 'NL', 'NLD', 'هولندا'),
(3218, 1044003252, 1044003279, 'BE', 'BEL', 'بلجيكا'),
(3219, 1044003280, 1044003283, 'NL', 'NLD', 'هولندا'),
(3220, 1044003284, 1044003291, 'BE', 'BEL', 'بلجيكا'),
(3221, 1044003292, 1044003295, 'NL', 'NLD', 'هولندا'),
(3222, 1044003296, 1044003299, 'BE', 'BEL', 'بلجيكا'),
(3223, 1044003300, 1044003303, 'NL', 'NLD', 'هولندا'),
(3224, 1044003304, 1044003311, 'BE', 'BEL', 'بلجيكا'),
(3225, 1044003312, 1044003315, 'NL', 'NLD', 'هولندا'),
(3226, 1044003316, 1044003319, 'BE', 'BEL', 'بلجيكا'),
(3227, 1044003320, 1044003323, 'NL', 'NLD', 'هولندا'),
(3228, 1044003324, 1044003331, 'BE', 'BEL', 'بلجيكا'),
(3229, 1044003332, 1044003343, 'NL', 'NLD', 'هولندا'),
(3230, 1044003344, 1044003359, 'BE', 'BEL', 'بلجيكا'),
(3231, 1044003360, 1044003362, 'NL', 'NLD', 'هولندا'),
(3232, 1044003363, 1044003363, 'BE', 'BEL', 'بلجيكا'),
(3233, 1044003364, 1044003371, 'NL', 'NLD', 'هولندا'),
(3234, 1044003372, 1044003379, 'BE', 'BEL', 'بلجيكا'),
(3235, 1044003380, 1044003383, 'NL', 'NLD', 'هولندا'),
(3236, 1044003384, 1044003423, 'BE', 'BEL', 'بلجيكا'),
(3237, 1044003424, 1044003427, 'NL', 'NLD', 'هولندا'),
(3238, 1044003428, 1044003459, 'BE', 'BEL', 'بلجيكا'),
(3239, 1044003460, 1044003463, 'NL', 'NLD', 'هولندا'),
(3240, 1044003464, 1044003467, 'BE', 'BEL', 'بلجيكا'),
(3241, 1044003468, 1044003471, 'NL', 'NLD', 'هولندا'),
(3242, 1044003472, 1044003483, 'BE', 'BEL', 'بلجيكا'),
(3243, 1044003484, 1044003487, 'NL', 'NLD', 'هولندا'),
(3244, 1044003488, 1044003511, 'BE', 'BEL', 'بلجيكا'),
(3245, 1044003512, 1044003527, 'NL', 'NLD', 'هولندا'),
(3246, 1044003528, 1044003539, 'BE', 'BEL', 'بلجيكا'),
(3247, 1044003540, 1044003543, 'NL', 'NLD', 'هولندا'),
(3248, 1044003544, 1044003551, 'BE', 'BEL', 'بلجيكا'),
(3249, 1044003552, 1044003563, 'NL', 'NLD', 'هولندا'),
(3250, 1044003564, 1044003575, 'BE', 'BEL', 'بلجيكا'),
(3251, 1044003576, 1044003591, 'NL', 'NLD', 'هولندا'),
(3252, 1044003592, 1044003595, 'BE', 'BEL', 'بلجيكا'),
(3253, 1044003596, 1044003599, 'NL', 'NLD', 'هولندا'),
(3254, 1044003600, 1044003615, 'BE', 'BEL', 'بلجيكا'),
(3255, 1044003616, 1044003631, 'NL', 'NLD', 'هولندا'),
(3256, 1044003632, 1044003635, 'BE', 'BEL', 'بلجيكا'),
(3257, 1044003636, 1044003639, 'NL', 'NLD', 'هولندا'),
(3258, 1044003640, 1044003647, 'BE', 'BEL', 'بلجيكا'),
(3259, 1044003648, 1044003651, 'NL', 'NLD', 'هولندا'),
(3260, 1044003652, 1044003655, 'BE', 'BEL', 'بلجيكا'),
(3261, 1044003656, 1044003659, 'NL', 'NLD', 'هولندا'),
(3262, 1044003660, 1044003663, 'BE', 'BEL', 'بلجيكا'),
(3263, 1044003664, 1044003667, 'NL', 'NLD', 'هولندا'),
(3264, 1044003668, 1044003675, 'BE', 'BEL', 'بلجيكا'),
(3265, 1044003676, 1044003683, 'NL', 'NLD', 'هولندا'),
(3266, 1044003684, 1044003687, 'BE', 'BEL', 'بلجيكا'),
(3267, 1044003688, 1044003691, 'NL', 'NLD', 'هولندا'),
(3268, 1044003692, 1044003695, 'BE', 'BEL', 'بلجيكا'),
(3269, 1044003696, 1044003699, 'NL', 'NLD', 'هولندا'),
(3270, 1044003700, 1044003723, 'BE', 'BEL', 'بلجيكا'),
(3271, 1044003724, 1044003727, 'NL', 'NLD', 'هولندا'),
(3272, 1044003728, 1044003731, 'BE', 'BEL', 'بلجيكا'),
(3273, 1044003732, 1044003751, 'NL', 'NLD', 'هولندا'),
(3274, 1044003752, 1044003755, 'BE', 'BEL', 'بلجيكا'),
(3275, 1044003756, 1044003775, 'NL', 'NLD', 'هولندا'),
(3276, 1044003776, 1044003783, 'BE', 'BEL', 'بلجيكا'),
(3277, 1044003784, 1044003787, 'NL', 'NLD', 'هولندا'),
(3278, 1044003788, 1044003795, 'BE', 'BEL', 'بلجيكا'),
(3279, 1044003796, 1044003799, 'NL', 'NLD', 'هولندا'),
(3280, 1044003800, 1044003807, 'BE', 'BEL', 'بلجيكا'),
(3281, 1044003808, 1044003819, 'NL', 'NLD', 'هولندا'),
(3282, 1044003820, 1044003823, 'BE', 'BEL', 'بلجيكا'),
(3283, 1044003824, 1044003831, 'NL', 'NLD', 'هولندا'),
(3284, 1044003832, 1044003855, 'BE', 'BEL', 'بلجيكا'),
(3285, 1044003856, 1044003871, 'NL', 'NLD', 'هولندا'),
(3286, 1044003872, 1044003879, 'BE', 'BEL', 'بلجيكا'),
(3287, 1044003880, 1044003895, 'NL', 'NLD', 'هولندا'),
(3288, 1044003896, 1044003911, 'BE', 'BEL', 'بلجيكا'),
(3289, 1044003912, 1044003919, 'NL', 'NLD', 'هولندا'),
(3290, 1044003920, 1044003927, 'BE', 'BEL', 'بلجيكا'),
(3291, 1044003928, 1044003959, 'NL', 'NLD', 'هولندا'),
(3292, 1044003960, 1044003967, 'BE', 'BEL', 'بلجيكا'),
(3293, 1044003968, 1044003975, 'NL', 'NLD', 'هولندا'),
(3294, 1044003976, 1044003983, 'BE', 'BEL', 'بلجيكا'),
(3295, 1044003984, 1044003991, 'NL', 'NLD', 'هولندا'),
(3296, 1044003992, 1044004007, 'BE', 'BEL', 'بلجيكا'),
(3297, 1044004008, 1044004079, 'NL', 'NLD', 'هولندا'),
(3298, 1044004080, 1044004095, 'BE', 'BEL', 'بلجيكا'),
(3299, 1044004096, 1044004303, 'NL', 'NLD', 'هولندا'),
(3300, 1044004304, 1044004351, 'BE', 'BEL', 'بلجيكا'),
(3301, 1044004352, 1044004879, 'NL', 'NLD', 'هولندا'),
(3302, 1044004880, 1044004903, 'BE', 'BEL', 'بلجيكا'),
(3303, 1044004904, 1044004911, 'NL', 'NLD', 'هولندا'),
(3304, 1044004912, 1044004927, 'BE', 'BEL', 'بلجيكا'),
(3305, 1044004928, 1044005503, 'NL', 'NLD', 'هولندا'),
(3306, 1044005504, 1044005631, 'BE', 'BEL', 'بلجيكا'),
(3307, 1044005632, 1044005647, 'NL', 'NLD', 'هولندا'),
(3308, 1044005648, 1044005663, 'BE', 'BEL', 'بلجيكا'),
(3309, 1044005664, 1044005695, 'NL', 'NLD', 'هولندا'),
(3310, 1044005696, 1044005799, 'BE', 'BEL', 'بلجيكا'),
(3311, 1044005800, 1044005807, 'NL', 'NLD', 'هولندا'),
(3312, 1044005808, 1044005823, 'BE', 'BEL', 'بلجيكا'),
(3313, 1044005824, 1044005847, 'NL', 'NLD', 'هولندا'),
(3314, 1044005848, 1044005887, 'BE', 'BEL', 'بلجيكا'),
(3315, 1044005888, 1044006143, 'NL', 'NLD', 'هولندا'),
(3316, 1044006144, 1044006911, 'BE', 'BEL', 'بلجيكا'),
(3317, 1044006912, 1044006927, 'NL', 'NLD', 'هولندا'),
(3318, 1044006928, 1044006935, 'BE', 'BEL', 'بلجيكا'),
(3319, 1044006936, 1044006943, 'NL', 'NLD', 'هولندا'),
(3320, 1044006944, 1044007007, 'BE', 'BEL', 'بلجيكا'),
(3321, 1044007008, 1044007023, 'NL', 'NLD', 'هولندا'),
(3322, 1044007024, 1044007031, 'BE', 'BEL', 'بلجيكا'),
(3323, 1044007032, 1044007039, 'NL', 'NLD', 'هولندا'),
(3324, 1044007040, 1044007047, 'BE', 'BEL', 'بلجيكا'),
(3325, 1044007048, 1044007055, 'NL', 'NLD', 'هولندا'),
(3326, 1044007056, 1044007063, 'BE', 'BEL', 'بلجيكا'),
(3327, 1044007064, 1044007087, 'NL', 'NLD', 'هولندا'),
(3328, 1044007088, 1044007119, 'BE', 'BEL', 'بلجيكا'),
(3329, 1044007120, 1044007135, 'NL', 'NLD', 'هولندا'),
(3330, 1044007136, 1044007167, 'BE', 'BEL', 'بلجيكا'),
(3331, 1044007168, 1044007967, 'NL', 'NLD', 'هولندا'),
(3332, 1044007968, 1044007983, 'BE', 'BEL', 'بلجيكا'),
(3333, 1044007984, 1044007991, 'NL', 'NLD', 'هولندا'),
(3334, 1044007992, 1044008007, 'BE', 'BEL', 'بلجيكا'),
(3335, 1044008008, 1044008023, 'NL', 'NLD', 'هولندا'),
(3336, 1044008024, 1044008031, 'BE', 'BEL', 'بلجيكا'),
(3337, 1044008032, 1044008039, 'NL', 'NLD', 'هولندا'),
(3338, 1044008040, 1044008047, 'BE', 'BEL', 'بلجيكا'),
(3339, 1044008048, 1044008063, 'NL', 'NLD', 'هولندا'),
(3340, 1044008064, 1044008095, 'BE', 'BEL', 'بلجيكا'),
(3341, 1044008096, 1044008127, 'NL', 'NLD', 'هولندا'),
(3342, 1044008128, 1044008183, 'BE', 'BEL', 'بلجيكا'),
(3343, 1044008184, 1044008223, 'NL', 'NLD', 'هولندا'),
(3344, 1044008224, 1044008239, 'BE', 'BEL', 'بلجيكا'),
(3345, 1044008240, 1044008255, 'NL', 'NLD', 'هولندا'),
(3346, 1044008256, 1044008279, 'BE', 'BEL', 'بلجيكا'),
(3347, 1044008280, 1044008287, 'NL', 'NLD', 'هولندا'),
(3348, 1044008288, 1044008319, 'BE', 'BEL', 'بلجيكا'),
(3349, 1044008320, 1044008735, 'NL', 'NLD', 'هولندا'),
(3350, 1044008736, 1044009055, 'BE', 'BEL', 'بلجيكا'),
(3351, 1044009056, 1044009087, 'NL', 'NLD', 'هولندا'),
(3352, 1044009088, 1044009183, 'BE', 'BEL', 'بلجيكا'),
(3353, 1044009184, 1044009199, 'NL', 'NLD', 'هولندا'),
(3354, 1044009200, 1044009215, 'BE', 'BEL', 'بلجيكا'),
(3355, 1044009216, 1044009471, 'NL', 'NLD', 'هولندا'),
(3356, 1044009472, 1044009487, 'BE', 'BEL', 'بلجيكا'),
(3357, 1044009488, 1044009503, 'NL', 'NLD', 'هولندا'),
(3358, 1044009504, 1044009535, 'BE', 'BEL', 'بلجيكا'),
(3359, 1044009536, 1044009583, 'NL', 'NLD', 'هولندا'),
(3360, 1044009584, 1044009599, 'BE', 'BEL', 'بلجيكا'),
(3361, 1044009600, 1044009983, 'NL', 'NLD', 'هولندا'),
(3362, 1044009984, 1044011007, 'BE', 'BEL', 'بلجيكا'),
(3363, 1044011008, 1044011039, 'NL', 'NLD', 'هولندا'),
(3364, 1044011040, 1044011043, 'BE', 'BEL', 'بلجيكا'),
(3365, 1044011044, 1044011055, 'NL', 'NLD', 'هولندا'),
(3366, 1044011056, 1044011059, 'BE', 'BEL', 'بلجيكا'),
(3367, 1044011060, 1044011223, 'NL', 'NLD', 'هولندا'),
(3368, 1044011224, 1044011227, 'BE', 'BEL', 'بلجيكا'),
(3369, 1044011228, 1044011427, 'NL', 'NLD', 'هولندا'),
(3370, 1044011428, 1044011431, 'BE', 'BEL', 'بلجيكا'),
(3371, 1044011432, 1044011635, 'NL', 'NLD', 'هولندا'),
(3372, 1044011636, 1044011639, 'BE', 'BEL', 'بلجيكا'),
(3373, 1044011640, 1044011703, 'NL', 'NLD', 'هولندا'),
(3374, 1044011704, 1044011707, 'BE', 'BEL', 'بلجيكا'),
(3375, 1044011708, 1044011731, 'NL', 'NLD', 'هولندا'),
(3376, 1044011732, 1044011735, 'BE', 'BEL', 'بلجيكا'),
(3377, 1044011736, 1044011763, 'NL', 'NLD', 'هولندا'),
(3378, 1044011764, 1044011767, 'BE', 'BEL', 'بلجيكا'),
(3379, 1044011768, 1044011771, 'NL', 'NLD', 'هولندا'),
(3380, 1044011772, 1044011775, 'BE', 'BEL', 'بلجيكا'),
(3381, 1044011776, 1044011791, 'NL', 'NLD', 'هولندا'),
(3382, 1044011792, 1044011795, 'BE', 'BEL', 'بلجيكا'),
(3383, 1044011796, 1044011971, 'NL', 'NLD', 'هولندا'),
(3384, 1044011972, 1044012031, 'BE', 'BEL', 'بلجيكا'),
(3385, 1044012032, 1044012039, 'NL', 'NLD', 'هولندا'),
(3386, 1044012040, 1044012063, 'BE', 'BEL', 'بلجيكا'),
(3387, 1044012064, 1044012087, 'NL', 'NLD', 'هولندا'),
(3388, 1044012088, 1044012095, 'BE', 'BEL', 'بلجيكا'),
(3389, 1044012096, 1044012103, 'NL', 'NLD', 'هولندا'),
(3390, 1044012104, 1044012111, 'BE', 'BEL', 'بلجيكا'),
(3391, 1044012112, 1044012119, 'NL', 'NLD', 'هولندا'),
(3392, 1044012120, 1044012135, 'BE', 'BEL', 'بلجيكا'),
(3393, 1044012136, 1044012143, 'NL', 'NLD', 'هولندا'),
(3394, 1044012144, 1044012151, 'BE', 'BEL', 'بلجيكا'),
(3395, 1044012152, 1044012159, 'NL', 'NLD', 'هولندا'),
(3396, 1044012160, 1044012167, 'BE', 'BEL', 'بلجيكا'),
(3397, 1044012168, 1044012191, 'NL', 'NLD', 'هولندا'),
(3398, 1044012192, 1044012207, 'BE', 'BEL', 'بلجيكا'),
(3399, 1044012208, 1044012239, 'NL', 'NLD', 'هولندا'),
(3400, 1044012240, 1044012255, 'BE', 'BEL', 'بلجيكا'),
(3401, 1044012256, 1044013059, 'NL', 'NLD', 'هولندا'),
(3402, 1044013060, 1044013111, 'BE', 'BEL', 'بلجيكا'),
(3403, 1044013112, 1044013119, 'NL', 'NLD', 'هولندا'),
(3404, 1044013120, 1044013135, 'BE', 'BEL', 'بلجيكا'),
(3405, 1044013136, 1044013143, 'NL', 'NLD', 'هولندا'),
(3406, 1044013144, 1044013247, 'BE', 'BEL', 'بلجيكا'),
(3407, 1044013248, 1044013263, 'NL', 'NLD', 'هولندا'),
(3408, 1044013264, 1044013271, 'BE', 'BEL', 'بلجيكا'),
(3409, 1044013272, 1044013279, 'NL', 'NLD', 'هولندا'),
(3410, 1044013280, 1044013375, 'BE', 'BEL', 'بلجيكا'),
(3411, 1044013376, 1044013439, 'NL', 'NLD', 'هولندا'),
(3412, 1044013440, 1044013575, 'BE', 'BEL', 'بلجيكا'),
(3413, 1044013576, 1044013583, 'NL', 'NLD', 'هولندا'),
(3414, 1044013584, 1044013615, 'BE', 'BEL', 'بلجيكا'),
(3415, 1044013616, 1044013623, 'NL', 'NLD', 'هولندا'),
(3416, 1044013624, 1044014111, 'BE', 'BEL', 'بلجيكا'),
(3417, 1044014112, 1044014119, 'NL', 'NLD', 'هولندا'),
(3418, 1044014120, 1044017167, 'BE', 'BEL', 'بلجيكا'),
(3419, 1044017168, 1044017187, 'NL', 'NLD', 'هولندا'),
(3420, 1044017188, 1044017191, 'BE', 'BEL', 'بلجيكا'),
(3421, 1044017192, 1044017199, 'NL', 'NLD', 'هولندا'),
(3422, 1044017200, 1044017215, 'BE', 'BEL', 'بلجيكا'),
(3423, 1044017216, 1044017247, 'NL', 'NLD', 'هولندا'),
(3424, 1044017248, 1044017359, 'BE', 'BEL', 'بلجيكا'),
(3425, 1044017360, 1044017383, 'NL', 'NLD', 'هولندا'),
(3426, 1044017384, 1044017399, 'BE', 'BEL', 'بلجيكا'),
(3427, 1044017400, 1044017407, 'NL', 'NLD', 'هولندا'),
(3428, 1044017408, 1044017663, 'BE', 'BEL', 'بلجيكا'),
(3429, 1044017664, 1044017983, 'NL', 'NLD', 'هولندا'),
(3430, 1044017984, 1044018039, 'BE', 'BEL', 'بلجيكا'),
(3431, 1044018040, 1044018047, 'NL', 'NLD', 'هولندا'),
(3432, 1044018048, 1044019279, 'BE', 'BEL', 'بلجيكا'),
(3433, 1044019280, 1044019283, 'NL', 'NLD', 'هولندا'),
(3434, 1044019284, 1044019291, 'BE', 'BEL', 'بلجيكا'),
(3435, 1044019292, 1044019295, 'NL', 'NLD', 'هولندا'),
(3436, 1044019296, 1044019315, 'BE', 'BEL', 'بلجيكا'),
(3437, 1044019316, 1044019323, 'NL', 'NLD', 'هولندا'),
(3438, 1044019324, 1044019347, 'BE', 'BEL', 'بلجيكا'),
(3439, 1044019348, 1044019351, 'NL', 'NLD', 'هولندا'),
(3440, 1044019352, 1044019383, 'BE', 'BEL', 'بلجيكا'),
(3441, 1044019384, 1044019399, 'NL', 'NLD', 'هولندا'),
(3442, 1044019400, 1044019403, 'BE', 'BEL', 'بلجيكا'),
(3443, 1044019404, 1044019407, 'NL', 'NLD', 'هولندا'),
(3444, 1044019408, 1044019415, 'BE', 'BEL', 'بلجيكا'),
(3445, 1044019416, 1044019439, 'NL', 'NLD', 'هولندا'),
(3446, 1044019440, 1044019443, 'BE', 'BEL', 'بلجيكا'),
(3447, 1044019444, 1044019471, 'NL', 'NLD', 'هولندا'),
(3448, 1044019472, 1044019491, 'BE', 'BEL', 'بلجيكا'),
(3449, 1044019492, 1044019495, 'NL', 'NLD', 'هولندا'),
(3450, 1044019496, 1044019503, 'BE', 'BEL', 'بلجيكا'),
(3451, 1044019504, 1044019507, 'NL', 'NLD', 'هولندا'),
(3452, 1044019508, 1044019695, 'BE', 'BEL', 'بلجيكا'),
(3453, 1044019696, 1044019699, 'NL', 'NLD', 'هولندا'),
(3454, 1044019700, 1044019819, 'BE', 'BEL', 'بلجيكا'),
(3455, 1044019820, 1044019823, 'NL', 'NLD', 'هولندا'),
(3456, 1044019824, 1044019995, 'BE', 'BEL', 'بلجيكا'),
(3457, 1044019996, 1044019999, 'NL', 'NLD', 'هولندا'),
(3458, 1044020000, 1044020147, 'BE', 'BEL', 'بلجيكا'),
(3459, 1044020148, 1044020151, 'NL', 'NLD', 'هولندا'),
(3460, 1044020152, 1044020215, 'BE', 'BEL', 'بلجيكا'),
(3461, 1044020216, 1044020219, 'NL', 'NLD', 'هولندا'),
(3462, 1044020220, 1044020255, 'BE', 'BEL', 'بلجيكا'),
(3463, 1044020256, 1044020263, 'NL', 'NLD', 'هولندا'),
(3464, 1044020264, 1044020303, 'BE', 'BEL', 'بلجيكا'),
(3465, 1044020304, 1044020319, 'NL', 'NLD', 'هولندا'),
(3466, 1044020320, 1044020511, 'BE', 'BEL', 'بلجيكا'),
(3467, 1044020512, 1044020551, 'NL', 'NLD', 'هولندا'),
(3468, 1044020552, 1044020567, 'BE', 'BEL', 'بلجيكا'),
(3469, 1044020568, 1044020591, 'NL', 'NLD', 'هولندا'),
(3470, 1044020592, 1044020607, 'BE', 'BEL', 'بلجيكا'),
(3471, 1044020608, 1044020671, 'NL', 'NLD', 'هولندا'),
(3472, 1044020672, 1044020735, 'BE', 'BEL', 'بلجيكا'),
(3473, 1044020736, 1044021759, 'NL', 'NLD', 'هولندا'),
(3474, 1044021760, 1044021887, 'BE', 'BEL', 'بلجيكا'),
(3475, 1044021888, 1044022319, 'NL', 'NLD', 'هولندا'),
(3476, 1044022320, 1044022335, 'BE', 'BEL', 'بلجيكا'),
(3477, 1044022336, 1044022351, 'NL', 'NLD', 'هولندا'),
(3478, 1044022352, 1044022415, 'BE', 'BEL', 'بلجيكا'),
(3479, 1044022416, 1044023295, 'NL', 'NLD', 'هولندا'),
(3480, 1044023296, 1044023311, 'BE', 'BEL', 'بلجيكا'),
(3481, 1044023312, 1044023319, 'NL', 'NLD', 'هولندا'),
(3482, 1044023320, 1044023343, 'BE', 'BEL', 'بلجيكا'),
(3483, 1044023344, 1044023359, 'NL', 'NLD', 'هولندا'),
(3484, 1044023360, 1044023407, 'BE', 'BEL', 'بلجيكا'),
(3485, 1044023408, 1044023439, 'NL', 'NLD', 'هولندا'),
(3486, 1044023440, 1044024319, 'BE', 'BEL', 'بلجيكا'),
(3487, 1044024320, 1044024447, 'NL', 'NLD', 'هولندا'),
(3488, 1044024448, 1044024575, 'BE', 'BEL', 'بلجيكا'),
(3489, 1044024576, 1044024835, 'NL', 'NLD', 'هولندا'),
(3490, 1044024836, 1044024843, 'BE', 'BEL', 'بلجيكا'),
(3491, 1044024844, 1044024847, 'NL', 'NLD', 'هولندا'),
(3492, 1044024848, 1044024851, 'BE', 'BEL', 'بلجيكا'),
(3493, 1044024852, 1044024855, 'NL', 'NLD', 'هولندا'),
(3494, 1044024856, 1044024863, 'BE', 'BEL', 'بلجيكا'),
(3495, 1044024864, 1044024867, 'NL', 'NLD', 'هولندا'),
(3496, 1044024868, 1044024875, 'BE', 'BEL', 'بلجيكا'),
(3497, 1044024876, 1044024883, 'NL', 'NLD', 'هولندا'),
(3498, 1044024884, 1044024887, 'BE', 'BEL', 'بلجيكا'),
(3499, 1044024888, 1044024891, 'NL', 'NLD', 'هولندا'),
(3500, 1044024892, 1044024959, 'BE', 'BEL', 'بلجيكا'),
(3501, 1044024960, 1044025351, 'NL', 'NLD', 'هولندا'),
(3502, 1044025352, 1044025599, 'BE', 'BEL', 'بلجيكا'),
(3503, 1044025600, 1044025855, 'NL', 'NLD', 'هولندا'),
(3504, 1044025856, 1044025863, 'BE', 'BEL', 'بلجيكا'),
(3505, 1044025864, 1044025871, 'NL', 'NLD', 'هولندا'),
(3506, 1044025872, 1044025879, 'BE', 'BEL', 'بلجيكا'),
(3507, 1044025880, 1044025927, 'NL', 'NLD', 'هولندا'),
(3508, 1044025928, 1044025935, 'BE', 'BEL', 'بلجيكا'),
(3509, 1044025936, 1044025975, 'NL', 'NLD', 'هولندا'),
(3510, 1044025976, 1044025983, 'BE', 'BEL', 'بلجيكا'),
(3511, 1044025984, 1044026047, 'NL', 'NLD', 'هولندا'),
(3512, 1044026048, 1044026055, 'BE', 'BEL', 'بلجيكا'),
(3513, 1044026056, 1044026079, 'NL', 'NLD', 'هولندا'),
(3514, 1044026080, 1044026087, 'BE', 'BEL', 'بلجيكا'),
(3515, 1044026088, 1044026183, 'NL', 'NLD', 'هولندا'),
(3516, 1044026184, 1044026199, 'BE', 'BEL', 'بلجيكا'),
(3517, 1044026200, 1044026207, 'NL', 'NLD', 'هولندا'),
(3518, 1044026208, 1044026215, 'BE', 'BEL', 'بلجيكا'),
(3519, 1044026216, 1044026247, 'NL', 'NLD', 'هولندا'),
(3520, 1044026248, 1044026255, 'BE', 'BEL', 'بلجيكا'),
(3521, 1044026256, 1044026263, 'NL', 'NLD', 'هولندا'),
(3522, 1044026264, 1044026279, 'BE', 'BEL', 'بلجيكا'),
(3523, 1044026280, 1044026327, 'NL', 'NLD', 'هولندا'),
(3524, 1044026328, 1044026335, 'BE', 'BEL', 'بلجيكا'),
(3525, 1044026336, 1044026383, 'NL', 'NLD', 'هولندا'),
(3526, 1044026384, 1044026391, 'BE', 'BEL', 'بلجيكا'),
(3527, 1044026392, 1044026399, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(3528, 1044026400, 1044026407, 'BE', 'BEL', 'بلجيكا'),
(3529, 1044026408, 1044026423, 'NL', 'NLD', 'هولندا'),
(3530, 1044026424, 1044026431, 'BE', 'BEL', 'بلجيكا'),
(3531, 1044026432, 1044026447, 'NL', 'NLD', 'هولندا'),
(3532, 1044026448, 1044026455, 'BE', 'BEL', 'بلجيكا'),
(3533, 1044026456, 1044026639, 'NL', 'NLD', 'هولندا'),
(3534, 1044026640, 1044026655, 'BE', 'BEL', 'بلجيكا'),
(3535, 1044026656, 1044026663, 'NL', 'NLD', 'هولندا'),
(3536, 1044026664, 1044026671, 'BE', 'BEL', 'بلجيكا'),
(3537, 1044026672, 1044026695, 'NL', 'NLD', 'هولندا'),
(3538, 1044026696, 1044026703, 'BE', 'BEL', 'بلجيكا'),
(3539, 1044026704, 1044026727, 'NL', 'NLD', 'هولندا'),
(3540, 1044026728, 1044026743, 'BE', 'BEL', 'بلجيكا'),
(3541, 1044026744, 1044026751, 'NL', 'NLD', 'هولندا'),
(3542, 1044026752, 1044026759, 'BE', 'BEL', 'بلجيكا'),
(3543, 1044026760, 1044026791, 'NL', 'NLD', 'هولندا'),
(3544, 1044026792, 1044026799, 'BE', 'BEL', 'بلجيكا'),
(3545, 1044026800, 1044026815, 'NL', 'NLD', 'هولندا'),
(3546, 1044026816, 1044026839, 'BE', 'BEL', 'بلجيكا'),
(3547, 1044026840, 1044026855, 'NL', 'NLD', 'هولندا'),
(3548, 1044026856, 1044026863, 'BE', 'BEL', 'بلجيكا'),
(3549, 1044026864, 1044026895, 'NL', 'NLD', 'هولندا'),
(3550, 1044026896, 1044027263, 'BE', 'BEL', 'بلجيكا'),
(3551, 1044027264, 1044027407, 'NL', 'NLD', 'هولندا'),
(3552, 1044027408, 1044027415, 'BE', 'BEL', 'بلجيكا'),
(3553, 1044027416, 1044027423, 'NL', 'NLD', 'هولندا'),
(3554, 1044027424, 1044027431, 'BE', 'BEL', 'بلجيكا'),
(3555, 1044027432, 1044027447, 'NL', 'NLD', 'هولندا'),
(3556, 1044027448, 1044027455, 'BE', 'BEL', 'بلجيكا'),
(3557, 1044027456, 1044027471, 'NL', 'NLD', 'هولندا'),
(3558, 1044027472, 1044027487, 'BE', 'BEL', 'بلجيكا'),
(3559, 1044027488, 1044027519, 'NL', 'NLD', 'هولندا'),
(3560, 1044027520, 1044027527, 'BE', 'BEL', 'بلجيكا'),
(3561, 1044027528, 1044027535, 'NL', 'NLD', 'هولندا'),
(3562, 1044027536, 1044027575, 'BE', 'BEL', 'بلجيكا'),
(3563, 1044027576, 1044027583, 'NL', 'NLD', 'هولندا'),
(3564, 1044027584, 1044027591, 'BE', 'BEL', 'بلجيكا'),
(3565, 1044027592, 1044027663, 'NL', 'NLD', 'هولندا'),
(3566, 1044027664, 1044027671, 'BE', 'BEL', 'بلجيكا'),
(3567, 1044027672, 1044027679, 'NL', 'NLD', 'هولندا'),
(3568, 1044027680, 1044027703, 'BE', 'BEL', 'بلجيكا'),
(3569, 1044027704, 1044027727, 'NL', 'NLD', 'هولندا'),
(3570, 1044027728, 1044027775, 'BE', 'BEL', 'بلجيكا'),
(3571, 1044027776, 1044027839, 'NL', 'NLD', 'هولندا'),
(3572, 1044027840, 1044027903, 'BE', 'BEL', 'بلجيكا'),
(3573, 1044027904, 1044028159, 'NL', 'NLD', 'هولندا'),
(3574, 1044028160, 1044028415, 'BE', 'BEL', 'بلجيكا'),
(3575, 1044028416, 1044028671, 'NL', 'NLD', 'هولندا'),
(3576, 1044028672, 1044028799, 'BE', 'BEL', 'بلجيكا'),
(3577, 1044028800, 1044028927, 'NL', 'NLD', 'هولندا'),
(3578, 1044028928, 1044028935, 'BE', 'BEL', 'بلجيكا'),
(3579, 1044028936, 1044028943, 'NL', 'NLD', 'هولندا'),
(3580, 1044028944, 1044028955, 'BE', 'BEL', 'بلجيكا'),
(3581, 1044028956, 1044028959, 'NL', 'NLD', 'هولندا'),
(3582, 1044028960, 1044028991, 'BE', 'BEL', 'بلجيكا'),
(3583, 1044028992, 1044028995, 'NL', 'NLD', 'هولندا'),
(3584, 1044028996, 1044029011, 'BE', 'BEL', 'بلجيكا'),
(3585, 1044029012, 1044029015, 'NL', 'NLD', 'هولندا'),
(3586, 1044029016, 1044029019, 'BE', 'BEL', 'بلجيكا'),
(3587, 1044029020, 1044029023, 'NL', 'NLD', 'هولندا'),
(3588, 1044029024, 1044029027, 'BE', 'BEL', 'بلجيكا'),
(3589, 1044029028, 1044029031, 'NL', 'NLD', 'هولندا'),
(3590, 1044029032, 1044029035, 'BE', 'BEL', 'بلجيكا'),
(3591, 1044029036, 1044029043, 'NL', 'NLD', 'هولندا'),
(3592, 1044029044, 1044029055, 'BE', 'BEL', 'بلجيكا'),
(3593, 1044029056, 1044029059, 'NL', 'NLD', 'هولندا'),
(3594, 1044029060, 1044029067, 'BE', 'BEL', 'بلجيكا'),
(3595, 1044029068, 1044029071, 'NL', 'NLD', 'هولندا'),
(3596, 1044029072, 1044029311, 'BE', 'BEL', 'بلجيكا'),
(3597, 1044029312, 1044029441, 'NL', 'NLD', 'هولندا'),
(3598, 1044029442, 1044029442, 'BE', 'BEL', 'بلجيكا'),
(3599, 1044029443, 1044029445, 'NL', 'NLD', 'هولندا'),
(3600, 1044029446, 1044029448, 'BE', 'BEL', 'بلجيكا'),
(3601, 1044029449, 1044029451, 'NL', 'NLD', 'هولندا'),
(3602, 1044029452, 1044029452, 'BE', 'BEL', 'بلجيكا'),
(3603, 1044029453, 1044029453, 'NL', 'NLD', 'هولندا'),
(3604, 1044029454, 1044029455, 'BE', 'BEL', 'بلجيكا'),
(3605, 1044029456, 1044029463, 'NL', 'NLD', 'هولندا'),
(3606, 1044029464, 1044029466, 'BE', 'BEL', 'بلجيكا'),
(3607, 1044029467, 1044029467, 'NL', 'NLD', 'هولندا'),
(3608, 1044029468, 1044029470, 'BE', 'BEL', 'بلجيكا'),
(3609, 1044029471, 1044029479, 'NL', 'NLD', 'هولندا'),
(3610, 1044029480, 1044029483, 'BE', 'BEL', 'بلجيكا'),
(3611, 1044029484, 1044029485, 'NL', 'NLD', 'هولندا'),
(3612, 1044029486, 1044029487, 'BE', 'BEL', 'بلجيكا'),
(3613, 1044029488, 1044029488, 'NL', 'NLD', 'هولندا'),
(3614, 1044029489, 1044029489, 'BE', 'BEL', 'بلجيكا'),
(3615, 1044029490, 1044029492, 'NL', 'NLD', 'هولندا'),
(3616, 1044029493, 1044029493, 'BE', 'BEL', 'بلجيكا'),
(3617, 1044029494, 1044029494, 'NL', 'NLD', 'هولندا'),
(3618, 1044029495, 1044029497, 'BE', 'BEL', 'بلجيكا'),
(3619, 1044029498, 1044029498, 'NL', 'NLD', 'هولندا'),
(3620, 1044029499, 1044029501, 'BE', 'BEL', 'بلجيكا'),
(3621, 1044029502, 1044029502, 'NL', 'NLD', 'هولندا'),
(3622, 1044029503, 1044029505, 'BE', 'BEL', 'بلجيكا'),
(3623, 1044029506, 1044029509, 'NL', 'NLD', 'هولندا'),
(3624, 1044029510, 1044029510, 'BE', 'BEL', 'بلجيكا'),
(3625, 1044029511, 1044029511, 'NL', 'NLD', 'هولندا'),
(3626, 1044029512, 1044029535, 'BE', 'BEL', 'بلجيكا'),
(3627, 1044029536, 1044029536, 'NL', 'NLD', 'هولندا'),
(3628, 1044029537, 1044029537, 'BE', 'BEL', 'بلجيكا'),
(3629, 1044029538, 1044029538, 'NL', 'NLD', 'هولندا'),
(3630, 1044029539, 1044029545, 'BE', 'BEL', 'بلجيكا'),
(3631, 1044029546, 1044029546, 'NL', 'NLD', 'هولندا'),
(3632, 1044029547, 1044029548, 'BE', 'BEL', 'بلجيكا'),
(3633, 1044029549, 1044029549, 'NL', 'NLD', 'هولندا'),
(3634, 1044029550, 1044029552, 'BE', 'BEL', 'بلجيكا'),
(3635, 1044029553, 1044029553, 'NL', 'NLD', 'هولندا'),
(3636, 1044029554, 1044029554, 'BE', 'BEL', 'بلجيكا'),
(3637, 1044029555, 1044029556, 'NL', 'NLD', 'هولندا'),
(3638, 1044029557, 1044029557, 'BE', 'BEL', 'بلجيكا'),
(3639, 1044029558, 1044029558, 'NL', 'NLD', 'هولندا'),
(3640, 1044029559, 1044029561, 'BE', 'BEL', 'بلجيكا'),
(3641, 1044029562, 1044029567, 'NL', 'NLD', 'هولندا'),
(3642, 1044029568, 1044029568, 'BE', 'BEL', 'بلجيكا'),
(3643, 1044029569, 1044029569, 'NL', 'NLD', 'هولندا'),
(3644, 1044029570, 1044029572, 'BE', 'BEL', 'بلجيكا'),
(3645, 1044029573, 1044029575, 'NL', 'NLD', 'هولندا'),
(3646, 1044029576, 1044029580, 'BE', 'BEL', 'بلجيكا'),
(3647, 1044029581, 1044029581, 'NL', 'NLD', 'هولندا'),
(3648, 1044029582, 1044029584, 'BE', 'BEL', 'بلجيكا'),
(3649, 1044029585, 1044029585, 'NL', 'NLD', 'هولندا'),
(3650, 1044029586, 1044029586, 'BE', 'BEL', 'بلجيكا'),
(3651, 1044029587, 1044029587, 'NL', 'NLD', 'هولندا'),
(3652, 1044029588, 1044029590, 'BE', 'BEL', 'بلجيكا'),
(3653, 1044029591, 1044029595, 'NL', 'NLD', 'هولندا'),
(3654, 1044029596, 1044029596, 'BE', 'BEL', 'بلجيكا'),
(3655, 1044029597, 1044029598, 'NL', 'NLD', 'هولندا'),
(3656, 1044029599, 1044029599, 'BE', 'BEL', 'بلجيكا'),
(3657, 1044029600, 1044029600, 'NL', 'NLD', 'هولندا'),
(3658, 1044029601, 1044029601, 'BE', 'BEL', 'بلجيكا'),
(3659, 1044029602, 1044029603, 'NL', 'NLD', 'هولندا'),
(3660, 1044029604, 1044029606, 'BE', 'BEL', 'بلجيكا'),
(3661, 1044029607, 1044029608, 'NL', 'NLD', 'هولندا'),
(3662, 1044029609, 1044029609, 'BE', 'BEL', 'بلجيكا'),
(3663, 1044029610, 1044029610, 'NL', 'NLD', 'هولندا'),
(3664, 1044029611, 1044029611, 'BE', 'BEL', 'بلجيكا'),
(3665, 1044029612, 1044029612, 'NL', 'NLD', 'هولندا'),
(3666, 1044029613, 1044029616, 'BE', 'BEL', 'بلجيكا'),
(3667, 1044029617, 1044029618, 'NL', 'NLD', 'هولندا'),
(3668, 1044029619, 1044029620, 'BE', 'BEL', 'بلجيكا'),
(3669, 1044029621, 1044029622, 'NL', 'NLD', 'هولندا'),
(3670, 1044029623, 1044029625, 'BE', 'BEL', 'بلجيكا'),
(3671, 1044029626, 1044029628, 'NL', 'NLD', 'هولندا'),
(3672, 1044029629, 1044029630, 'BE', 'BEL', 'بلجيكا'),
(3673, 1044029631, 1044029631, 'NL', 'NLD', 'هولندا'),
(3674, 1044029632, 1044029634, 'BE', 'BEL', 'بلجيكا'),
(3675, 1044029635, 1044029635, 'NL', 'NLD', 'هولندا'),
(3676, 1044029636, 1044029636, 'BE', 'BEL', 'بلجيكا'),
(3677, 1044029637, 1044029638, 'NL', 'NLD', 'هولندا'),
(3678, 1044029639, 1044029640, 'BE', 'BEL', 'بلجيكا'),
(3679, 1044029641, 1044029641, 'NL', 'NLD', 'هولندا'),
(3680, 1044029642, 1044029642, 'BE', 'BEL', 'بلجيكا'),
(3681, 1044029643, 1044029647, 'NL', 'NLD', 'هولندا'),
(3682, 1044029648, 1044029648, 'BE', 'BEL', 'بلجيكا'),
(3683, 1044029649, 1044029651, 'NL', 'NLD', 'هولندا'),
(3684, 1044029652, 1044029652, 'BE', 'BEL', 'بلجيكا'),
(3685, 1044029653, 1044029659, 'NL', 'NLD', 'هولندا'),
(3686, 1044029660, 1044029660, 'BE', 'BEL', 'بلجيكا'),
(3687, 1044029661, 1044029663, 'NL', 'NLD', 'هولندا'),
(3688, 1044029664, 1044029665, 'BE', 'BEL', 'بلجيكا'),
(3689, 1044029666, 1044029667, 'NL', 'NLD', 'هولندا'),
(3690, 1044029668, 1044029668, 'BE', 'BEL', 'بلجيكا'),
(3691, 1044029669, 1044029669, 'NL', 'NLD', 'هولندا'),
(3692, 1044029670, 1044029672, 'BE', 'BEL', 'بلجيكا'),
(3693, 1044029673, 1044029676, 'NL', 'NLD', 'هولندا'),
(3694, 1044029677, 1044029678, 'BE', 'BEL', 'بلجيكا'),
(3695, 1044029679, 1044029680, 'NL', 'NLD', 'هولندا'),
(3696, 1044029681, 1044029681, 'BE', 'BEL', 'بلجيكا'),
(3697, 1044029682, 1044029682, 'NL', 'NLD', 'هولندا'),
(3698, 1044029683, 1044029684, 'BE', 'BEL', 'بلجيكا'),
(3699, 1044029685, 1044029686, 'NL', 'NLD', 'هولندا'),
(3700, 1044029687, 1044029687, 'BE', 'BEL', 'بلجيكا'),
(3701, 1044029688, 1044029693, 'NL', 'NLD', 'هولندا'),
(3702, 1044029694, 1044029694, 'BE', 'BEL', 'بلجيكا'),
(3703, 1044029695, 1044029703, 'NL', 'NLD', 'هولندا'),
(3704, 1044029704, 1044029711, 'BE', 'BEL', 'بلجيكا'),
(3705, 1044029712, 1044029719, 'NL', 'NLD', 'هولندا'),
(3706, 1044029720, 1044029727, 'BE', 'BEL', 'بلجيكا'),
(3707, 1044029728, 1044029743, 'NL', 'NLD', 'هولندا'),
(3708, 1044029744, 1044029767, 'BE', 'BEL', 'بلجيكا'),
(3709, 1044029768, 1044029775, 'NL', 'NLD', 'هولندا'),
(3710, 1044029776, 1044029783, 'BE', 'BEL', 'بلجيكا'),
(3711, 1044029784, 1044029831, 'NL', 'NLD', 'هولندا'),
(3712, 1044029832, 1044029839, 'BE', 'BEL', 'بلجيكا'),
(3713, 1044029840, 1044029871, 'NL', 'NLD', 'هولندا'),
(3714, 1044029872, 1044029879, 'BE', 'BEL', 'بلجيكا'),
(3715, 1044029880, 1044029895, 'NL', 'NLD', 'هولندا'),
(3716, 1044029896, 1044029919, 'BE', 'BEL', 'بلجيكا'),
(3717, 1044029920, 1044029951, 'NL', 'NLD', 'هولندا'),
(3718, 1044029952, 1044029959, 'BE', 'BEL', 'بلجيكا'),
(3719, 1044029960, 1044029967, 'NL', 'NLD', 'هولندا'),
(3720, 1044029968, 1044029983, 'BE', 'BEL', 'بلجيكا'),
(3721, 1044029984, 1044030015, 'NL', 'NLD', 'هولندا'),
(3722, 1044030016, 1044030031, 'BE', 'BEL', 'بلجيكا'),
(3723, 1044030032, 1044030047, 'NL', 'NLD', 'هولندا'),
(3724, 1044030048, 1044030055, 'BE', 'BEL', 'بلجيكا'),
(3725, 1044030056, 1044030063, 'NL', 'NLD', 'هولندا'),
(3726, 1044030064, 1044030071, 'BE', 'BEL', 'بلجيكا'),
(3727, 1044030072, 1044030111, 'NL', 'NLD', 'هولندا'),
(3728, 1044030112, 1044030119, 'BE', 'BEL', 'بلجيكا'),
(3729, 1044030120, 1044030127, 'NL', 'NLD', 'هولندا'),
(3730, 1044030128, 1044030135, 'BE', 'BEL', 'بلجيكا'),
(3731, 1044030136, 1044030207, 'NL', 'NLD', 'هولندا'),
(3732, 1044030208, 1044030223, 'BE', 'BEL', 'بلجيكا'),
(3733, 1044030224, 1044030231, 'NL', 'NLD', 'هولندا'),
(3734, 1044030232, 1044030239, 'BE', 'BEL', 'بلجيكا'),
(3735, 1044030240, 1044030247, 'NL', 'NLD', 'هولندا'),
(3736, 1044030248, 1044030263, 'BE', 'BEL', 'بلجيكا'),
(3737, 1044030264, 1044030279, 'NL', 'NLD', 'هولندا'),
(3738, 1044030280, 1044030295, 'BE', 'BEL', 'بلجيكا'),
(3739, 1044030296, 1044030303, 'NL', 'NLD', 'هولندا'),
(3740, 1044030304, 1044030311, 'BE', 'BEL', 'بلجيكا'),
(3741, 1044030312, 1044030335, 'NL', 'NLD', 'هولندا'),
(3742, 1044030336, 1044030343, 'BE', 'BEL', 'بلجيكا'),
(3743, 1044030344, 1044030375, 'NL', 'NLD', 'هولندا'),
(3744, 1044030376, 1044030391, 'BE', 'BEL', 'بلجيكا'),
(3745, 1044030392, 1044030399, 'NL', 'NLD', 'هولندا'),
(3746, 1044030400, 1044030407, 'BE', 'BEL', 'بلجيكا'),
(3747, 1044030408, 1044030439, 'NL', 'NLD', 'هولندا'),
(3748, 1044030440, 1044030447, 'BE', 'BEL', 'بلجيكا'),
(3749, 1044030448, 1044030463, 'NL', 'NLD', 'هولندا'),
(3750, 1044030464, 1044030471, 'BE', 'BEL', 'بلجيكا'),
(3751, 1044030472, 1044030487, 'NL', 'NLD', 'هولندا'),
(3752, 1044030488, 1044030495, 'BE', 'BEL', 'بلجيكا'),
(3753, 1044030496, 1044030527, 'NL', 'NLD', 'هولندا'),
(3754, 1044030528, 1044030535, 'BE', 'BEL', 'بلجيكا'),
(3755, 1044030536, 1044030583, 'NL', 'NLD', 'هولندا'),
(3756, 1044030584, 1044030591, 'BE', 'BEL', 'بلجيكا'),
(3757, 1044030592, 1044030607, 'NL', 'NLD', 'هولندا'),
(3758, 1044030608, 1044030623, 'BE', 'BEL', 'بلجيكا'),
(3759, 1044030624, 1044030639, 'NL', 'NLD', 'هولندا'),
(3760, 1044030640, 1044030647, 'BE', 'BEL', 'بلجيكا'),
(3761, 1044030648, 1044030671, 'NL', 'NLD', 'هولندا'),
(3762, 1044030672, 1044030679, 'BE', 'BEL', 'بلجيكا'),
(3763, 1044030680, 1044030711, 'NL', 'NLD', 'هولندا'),
(3764, 1044030712, 1044030719, 'BE', 'BEL', 'بلجيكا'),
(3765, 1044030720, 1044030727, 'NL', 'NLD', 'هولندا'),
(3766, 1044030728, 1044030735, 'BE', 'BEL', 'بلجيكا'),
(3767, 1044030736, 1044030759, 'NL', 'NLD', 'هولندا'),
(3768, 1044030760, 1044030767, 'BE', 'BEL', 'بلجيكا'),
(3769, 1044030768, 1044030815, 'NL', 'NLD', 'هولندا'),
(3770, 1044030816, 1044030823, 'BE', 'BEL', 'بلجيكا'),
(3771, 1044030824, 1044030831, 'NL', 'NLD', 'هولندا'),
(3772, 1044030832, 1044030847, 'BE', 'BEL', 'بلجيكا'),
(3773, 1044030848, 1044030879, 'NL', 'NLD', 'هولندا'),
(3774, 1044030880, 1044030887, 'BE', 'BEL', 'بلجيكا'),
(3775, 1044030888, 1044030895, 'NL', 'NLD', 'هولندا'),
(3776, 1044030896, 1044030903, 'BE', 'BEL', 'بلجيكا'),
(3777, 1044030904, 1044030911, 'NL', 'NLD', 'هولندا'),
(3778, 1044030912, 1044030919, 'BE', 'BEL', 'بلجيكا'),
(3779, 1044030920, 1044030927, 'NL', 'NLD', 'هولندا'),
(3780, 1044030928, 1044030935, 'BE', 'BEL', 'بلجيكا'),
(3781, 1044030936, 1044030959, 'NL', 'NLD', 'هولندا'),
(3782, 1044030960, 1044030967, 'BE', 'BEL', 'بلجيكا'),
(3783, 1044030968, 1044030999, 'NL', 'NLD', 'هولندا'),
(3784, 1044031000, 1044031007, 'BE', 'BEL', 'بلجيكا'),
(3785, 1044031008, 1044031039, 'NL', 'NLD', 'هولندا'),
(3786, 1044031040, 1044031103, 'BE', 'BEL', 'بلجيكا'),
(3787, 1044031104, 1044031119, 'NL', 'NLD', 'هولندا'),
(3788, 1044031120, 1044031127, 'BE', 'BEL', 'بلجيكا'),
(3789, 1044031128, 1044031151, 'NL', 'NLD', 'هولندا'),
(3790, 1044031152, 1044031167, 'BE', 'BEL', 'بلجيكا'),
(3791, 1044031168, 1044031271, 'NL', 'NLD', 'هولندا'),
(3792, 1044031272, 1044031279, 'BE', 'BEL', 'بلجيكا'),
(3793, 1044031280, 1044031287, 'NL', 'NLD', 'هولندا'),
(3794, 1044031288, 1044031295, 'BE', 'BEL', 'بلجيكا'),
(3795, 1044031296, 1044031319, 'NL', 'NLD', 'هولندا'),
(3796, 1044031320, 1044031327, 'BE', 'BEL', 'بلجيكا'),
(3797, 1044031328, 1044031343, 'NL', 'NLD', 'هولندا'),
(3798, 1044031344, 1044031351, 'BE', 'BEL', 'بلجيكا'),
(3799, 1044031352, 1044031359, 'NL', 'NLD', 'هولندا'),
(3800, 1044031360, 1044031360, 'BE', 'BEL', 'بلجيكا'),
(3801, 1044031361, 1044031363, 'NL', 'NLD', 'هولندا'),
(3802, 1044031364, 1044031364, 'BE', 'BEL', 'بلجيكا'),
(3803, 1044031365, 1044031367, 'NL', 'NLD', 'هولندا'),
(3804, 1044031368, 1044031375, 'BE', 'BEL', 'بلجيكا'),
(3805, 1044031376, 1044031399, 'NL', 'NLD', 'هولندا'),
(3806, 1044031400, 1044031431, 'BE', 'BEL', 'بلجيكا'),
(3807, 1044031432, 1044031439, 'NL', 'NLD', 'هولندا'),
(3808, 1044031440, 1044031455, 'BE', 'BEL', 'بلجيكا'),
(3809, 1044031456, 1044031489, 'NL', 'NLD', 'هولندا'),
(3810, 1044031490, 1044031490, 'BE', 'BEL', 'بلجيكا'),
(3811, 1044031491, 1044031494, 'NL', 'NLD', 'هولندا'),
(3812, 1044031495, 1044031495, 'BE', 'BEL', 'بلجيكا'),
(3813, 1044031496, 1044031496, 'NL', 'NLD', 'هولندا'),
(3814, 1044031497, 1044031497, 'BE', 'BEL', 'بلجيكا'),
(3815, 1044031498, 1044031507, 'NL', 'NLD', 'هولندا'),
(3816, 1044031508, 1044031508, 'BE', 'BEL', 'بلجيكا'),
(3817, 1044031509, 1044031509, 'NL', 'NLD', 'هولندا'),
(3818, 1044031510, 1044031510, 'BE', 'BEL', 'بلجيكا'),
(3819, 1044031511, 1044031519, 'NL', 'NLD', 'هولندا'),
(3820, 1044031520, 1044031520, 'BE', 'BEL', 'بلجيكا'),
(3821, 1044031521, 1044031523, 'NL', 'NLD', 'هولندا'),
(3822, 1044031524, 1044031524, 'BE', 'BEL', 'بلجيكا'),
(3823, 1044031525, 1044031531, 'NL', 'NLD', 'هولندا'),
(3824, 1044031532, 1044031532, 'BE', 'BEL', 'بلجيكا'),
(3825, 1044031533, 1044031533, 'NL', 'NLD', 'هولندا'),
(3826, 1044031534, 1044031536, 'BE', 'BEL', 'بلجيكا'),
(3827, 1044031537, 1044031550, 'NL', 'NLD', 'هولندا'),
(3828, 1044031551, 1044031551, 'BE', 'BEL', 'بلجيكا'),
(3829, 1044031552, 1044031552, 'NL', 'NLD', 'هولندا'),
(3830, 1044031553, 1044031553, 'BE', 'BEL', 'بلجيكا'),
(3831, 1044031554, 1044031556, 'NL', 'NLD', 'هولندا'),
(3832, 1044031557, 1044031557, 'BE', 'BEL', 'بلجيكا'),
(3833, 1044031558, 1044031558, 'NL', 'NLD', 'هولندا'),
(3834, 1044031559, 1044031559, 'BE', 'BEL', 'بلجيكا'),
(3835, 1044031560, 1044031562, 'NL', 'NLD', 'هولندا'),
(3836, 1044031563, 1044031563, 'BE', 'BEL', 'بلجيكا'),
(3837, 1044031564, 1044031566, 'NL', 'NLD', 'هولندا'),
(3838, 1044031567, 1044031567, 'BE', 'BEL', 'بلجيكا'),
(3839, 1044031568, 1044031568, 'NL', 'NLD', 'هولندا'),
(3840, 1044031569, 1044031569, 'BE', 'BEL', 'بلجيكا'),
(3841, 1044031570, 1044031571, 'NL', 'NLD', 'هولندا'),
(3842, 1044031572, 1044031572, 'BE', 'BEL', 'بلجيكا'),
(3843, 1044031573, 1044031573, 'NL', 'NLD', 'هولندا'),
(3844, 1044031574, 1044031574, 'BE', 'BEL', 'بلجيكا'),
(3845, 1044031575, 1044031579, 'NL', 'NLD', 'هولندا'),
(3846, 1044031580, 1044031581, 'BE', 'BEL', 'بلجيكا'),
(3847, 1044031582, 1044031582, 'NL', 'NLD', 'هولندا'),
(3848, 1044031583, 1044031584, 'BE', 'BEL', 'بلجيكا'),
(3849, 1044031585, 1044031592, 'NL', 'NLD', 'هولندا'),
(3850, 1044031593, 1044031593, 'BE', 'BEL', 'بلجيكا'),
(3851, 1044031594, 1044031597, 'NL', 'NLD', 'هولندا'),
(3852, 1044031598, 1044031598, 'BE', 'BEL', 'بلجيكا'),
(3853, 1044031599, 1044031599, 'NL', 'NLD', 'هولندا'),
(3854, 1044031600, 1044031600, 'BE', 'BEL', 'بلجيكا'),
(3855, 1044031601, 1044031627, 'NL', 'NLD', 'هولندا'),
(3856, 1044031628, 1044031628, 'BE', 'BEL', 'بلجيكا'),
(3857, 1044031629, 1044031629, 'NL', 'NLD', 'هولندا'),
(3858, 1044031630, 1044031630, 'BE', 'BEL', 'بلجيكا'),
(3859, 1044031631, 1044031635, 'NL', 'NLD', 'هولندا'),
(3860, 1044031636, 1044031636, 'BE', 'BEL', 'بلجيكا'),
(3861, 1044031637, 1044031640, 'NL', 'NLD', 'هولندا'),
(3862, 1044031641, 1044031641, 'BE', 'BEL', 'بلجيكا'),
(3863, 1044031642, 1044031643, 'NL', 'NLD', 'هولندا'),
(3864, 1044031644, 1044031644, 'BE', 'BEL', 'بلجيكا'),
(3865, 1044031645, 1044031651, 'NL', 'NLD', 'هولندا'),
(3866, 1044031652, 1044031652, 'BE', 'BEL', 'بلجيكا'),
(3867, 1044031653, 1044031654, 'NL', 'NLD', 'هولندا'),
(3868, 1044031655, 1044031655, 'BE', 'BEL', 'بلجيكا'),
(3869, 1044031656, 1044031656, 'NL', 'NLD', 'هولندا'),
(3870, 1044031657, 1044031658, 'BE', 'BEL', 'بلجيكا'),
(3871, 1044031659, 1044031666, 'NL', 'NLD', 'هولندا'),
(3872, 1044031667, 1044031667, 'BE', 'BEL', 'بلجيكا'),
(3873, 1044031668, 1044031668, 'NL', 'NLD', 'هولندا'),
(3874, 1044031669, 1044031670, 'BE', 'BEL', 'بلجيكا'),
(3875, 1044031671, 1044031673, 'NL', 'NLD', 'هولندا'),
(3876, 1044031674, 1044031674, 'BE', 'BEL', 'بلجيكا'),
(3877, 1044031675, 1044031675, 'NL', 'NLD', 'هولندا'),
(3878, 1044031676, 1044031677, 'BE', 'BEL', 'بلجيكا'),
(3879, 1044031678, 1044031683, 'NL', 'NLD', 'هولندا'),
(3880, 1044031684, 1044031684, 'BE', 'BEL', 'بلجيكا'),
(3881, 1044031685, 1044031687, 'NL', 'NLD', 'هولندا'),
(3882, 1044031688, 1044031688, 'BE', 'BEL', 'بلجيكا'),
(3883, 1044031689, 1044031690, 'NL', 'NLD', 'هولندا'),
(3884, 1044031691, 1044031692, 'BE', 'BEL', 'بلجيكا'),
(3885, 1044031693, 1044031698, 'NL', 'NLD', 'هولندا'),
(3886, 1044031699, 1044031699, 'BE', 'BEL', 'بلجيكا'),
(3887, 1044031700, 1044031702, 'NL', 'NLD', 'هولندا'),
(3888, 1044031703, 1044031704, 'BE', 'BEL', 'بلجيكا'),
(3889, 1044031705, 1044031709, 'NL', 'NLD', 'هولندا'),
(3890, 1044031710, 1044031710, 'BE', 'BEL', 'بلجيكا'),
(3891, 1044031711, 1044031711, 'NL', 'NLD', 'هولندا'),
(3892, 1044031712, 1044031712, 'BE', 'BEL', 'بلجيكا'),
(3893, 1044031713, 1044031714, 'NL', 'NLD', 'هولندا'),
(3894, 1044031715, 1044031715, 'BE', 'BEL', 'بلجيكا'),
(3895, 1044031716, 1044031717, 'NL', 'NLD', 'هولندا'),
(3896, 1044031718, 1044031719, 'BE', 'BEL', 'بلجيكا'),
(3897, 1044031720, 1044031721, 'NL', 'NLD', 'هولندا'),
(3898, 1044031722, 1044031723, 'BE', 'BEL', 'بلجيكا'),
(3899, 1044031724, 1044031726, 'NL', 'NLD', 'هولندا'),
(3900, 1044031727, 1044031727, 'BE', 'BEL', 'بلجيكا'),
(3901, 1044031728, 1044031751, 'NL', 'NLD', 'هولندا'),
(3902, 1044031752, 1044031759, 'BE', 'BEL', 'بلجيكا'),
(3903, 1044031760, 1044031799, 'NL', 'NLD', 'هولندا'),
(3904, 1044031800, 1044031807, 'BE', 'BEL', 'بلجيكا'),
(3905, 1044031808, 1044031815, 'NL', 'NLD', 'هولندا'),
(3906, 1044031816, 1044031871, 'BE', 'BEL', 'بلجيكا'),
(3907, 1044031872, 1044031879, 'NL', 'NLD', 'هولندا'),
(3908, 1044031880, 1044031887, 'BE', 'BEL', 'بلجيكا'),
(3909, 1044031888, 1044031927, 'NL', 'NLD', 'هولندا'),
(3910, 1044031928, 1044031935, 'BE', 'BEL', 'بلجيكا'),
(3911, 1044031936, 1044031951, 'NL', 'NLD', 'هولندا'),
(3912, 1044031952, 1044031991, 'BE', 'BEL', 'بلجيكا'),
(3913, 1044031992, 1044031999, 'NL', 'NLD', 'هولندا'),
(3914, 1044032000, 1044032031, 'BE', 'BEL', 'بلجيكا'),
(3915, 1044032032, 1044032047, 'NL', 'NLD', 'هولندا'),
(3916, 1044032048, 1044032055, 'BE', 'BEL', 'بلجيكا'),
(3917, 1044032056, 1044032071, 'NL', 'NLD', 'هولندا'),
(3918, 1044032072, 1044032079, 'BE', 'BEL', 'بلجيكا'),
(3919, 1044032080, 1044032103, 'NL', 'NLD', 'هولندا'),
(3920, 1044032104, 1044032127, 'BE', 'BEL', 'بلجيكا'),
(3921, 1044032128, 1044032151, 'NL', 'NLD', 'هولندا'),
(3922, 1044032152, 1044032167, 'BE', 'BEL', 'بلجيكا'),
(3923, 1044032168, 1044032175, 'NL', 'NLD', 'هولندا'),
(3924, 1044032176, 1044032183, 'BE', 'BEL', 'بلجيكا'),
(3925, 1044032184, 1044032191, 'NL', 'NLD', 'هولندا'),
(3926, 1044032192, 1044032199, 'BE', 'BEL', 'بلجيكا'),
(3927, 1044032200, 1044032223, 'NL', 'NLD', 'هولندا'),
(3928, 1044032224, 1044032239, 'BE', 'BEL', 'بلجيكا'),
(3929, 1044032240, 1044032263, 'NL', 'NLD', 'هولندا'),
(3930, 1044032264, 1044032287, 'BE', 'BEL', 'بلجيكا'),
(3931, 1044032288, 1044032303, 'NL', 'NLD', 'هولندا'),
(3932, 1044032304, 1044032327, 'BE', 'BEL', 'بلجيكا'),
(3933, 1044032328, 1044032375, 'NL', 'NLD', 'هولندا'),
(3934, 1044032376, 1044032407, 'BE', 'BEL', 'بلجيكا'),
(3935, 1044032408, 1044032471, 'NL', 'NLD', 'هولندا'),
(3936, 1044032472, 1044032479, 'BE', 'BEL', 'بلجيكا'),
(3937, 1044032480, 1044032527, 'NL', 'NLD', 'هولندا'),
(3938, 1044032528, 1044032559, 'BE', 'BEL', 'بلجيكا'),
(3939, 1044032560, 1044032583, 'NL', 'NLD', 'هولندا'),
(3940, 1044032584, 1044032615, 'BE', 'BEL', 'بلجيكا'),
(3941, 1044032616, 1044032639, 'NL', 'NLD', 'هولندا'),
(3942, 1044032640, 1044032647, 'BE', 'BEL', 'بلجيكا'),
(3943, 1044032648, 1044032695, 'NL', 'NLD', 'هولندا'),
(3944, 1044032696, 1044032703, 'BE', 'BEL', 'بلجيكا'),
(3945, 1044032704, 1044032719, 'NL', 'NLD', 'هولندا'),
(3946, 1044032720, 1044032727, 'BE', 'BEL', 'بلجيكا'),
(3947, 1044032728, 1044032735, 'NL', 'NLD', 'هولندا'),
(3948, 1044032736, 1044032743, 'BE', 'BEL', 'بلجيكا'),
(3949, 1044032744, 1044032775, 'NL', 'NLD', 'هولندا'),
(3950, 1044032776, 1044032783, 'BE', 'BEL', 'بلجيكا'),
(3951, 1044032784, 1044032791, 'NL', 'NLD', 'هولندا'),
(3952, 1044032792, 1044032799, 'BE', 'BEL', 'بلجيكا'),
(3953, 1044032800, 1044032815, 'NL', 'NLD', 'هولندا'),
(3954, 1044032816, 1044032831, 'BE', 'BEL', 'بلجيكا'),
(3955, 1044032832, 1044032855, 'NL', 'NLD', 'هولندا'),
(3956, 1044032856, 1044032863, 'BE', 'BEL', 'بلجيكا'),
(3957, 1044032864, 1044032887, 'NL', 'NLD', 'هولندا'),
(3958, 1044032888, 1044032903, 'BE', 'BEL', 'بلجيكا'),
(3959, 1044032904, 1044032927, 'NL', 'NLD', 'هولندا'),
(3960, 1044032928, 1044032935, 'BE', 'BEL', 'بلجيكا'),
(3961, 1044032936, 1044032951, 'NL', 'NLD', 'هولندا'),
(3962, 1044032952, 1044032959, 'BE', 'BEL', 'بلجيكا'),
(3963, 1044032960, 1044032967, 'NL', 'NLD', 'هولندا'),
(3964, 1044032968, 1044032975, 'BE', 'BEL', 'بلجيكا'),
(3965, 1044032976, 1044032991, 'NL', 'NLD', 'هولندا'),
(3966, 1044032992, 1044032999, 'BE', 'BEL', 'بلجيكا'),
(3967, 1044033000, 1044033031, 'NL', 'NLD', 'هولندا'),
(3968, 1044033032, 1044033055, 'BE', 'BEL', 'بلجيكا'),
(3969, 1044033056, 1044033071, 'NL', 'NLD', 'هولندا'),
(3970, 1044033072, 1044033079, 'BE', 'BEL', 'بلجيكا'),
(3971, 1044033080, 1044033111, 'NL', 'NLD', 'هولندا'),
(3972, 1044033112, 1044033119, 'BE', 'BEL', 'بلجيكا'),
(3973, 1044033120, 1044033135, 'NL', 'NLD', 'هولندا'),
(3974, 1044033136, 1044033159, 'BE', 'BEL', 'بلجيكا'),
(3975, 1044033160, 1044033207, 'NL', 'NLD', 'هولندا'),
(3976, 1044033208, 1044033215, 'BE', 'BEL', 'بلجيكا'),
(3977, 1044033216, 1044033223, 'NL', 'NLD', 'هولندا'),
(3978, 1044033224, 1044033231, 'BE', 'BEL', 'بلجيكا'),
(3979, 1044033232, 1044033335, 'NL', 'NLD', 'هولندا'),
(3980, 1044033336, 1044033343, 'BE', 'BEL', 'بلجيكا'),
(3981, 1044033344, 1044033351, 'NL', 'NLD', 'هولندا'),
(3982, 1044033352, 1044033359, 'BE', 'BEL', 'بلجيكا'),
(3983, 1044033360, 1044033375, 'NL', 'NLD', 'هولندا'),
(3984, 1044033376, 1044033407, 'BE', 'BEL', 'بلجيكا'),
(3985, 1044033408, 1044033431, 'NL', 'NLD', 'هولندا'),
(3986, 1044033432, 1044033447, 'BE', 'BEL', 'بلجيكا'),
(3987, 1044033448, 1044033527, 'NL', 'NLD', 'هولندا'),
(3988, 1044033528, 1044033535, 'BE', 'BEL', 'بلجيكا'),
(3989, 1044033536, 1044033543, 'NL', 'NLD', 'هولندا'),
(3990, 1044033544, 1044033551, 'BE', 'BEL', 'بلجيكا'),
(3991, 1044033552, 1044033575, 'NL', 'NLD', 'هولندا'),
(3992, 1044033576, 1044033583, 'BE', 'BEL', 'بلجيكا'),
(3993, 1044033584, 1044033623, 'NL', 'NLD', 'هولندا'),
(3994, 1044033624, 1044033631, 'BE', 'BEL', 'بلجيكا'),
(3995, 1044033632, 1044033655, 'NL', 'NLD', 'هولندا'),
(3996, 1044033656, 1044033663, 'BE', 'BEL', 'بلجيكا'),
(3997, 1044033664, 1044033671, 'NL', 'NLD', 'هولندا'),
(3998, 1044033672, 1044033687, 'BE', 'BEL', 'بلجيكا'),
(3999, 1044033688, 1044033719, 'NL', 'NLD', 'هولندا'),
(4000, 1044033720, 1044033727, 'BE', 'BEL', 'بلجيكا'),
(4001, 1044033728, 1044033895, 'NL', 'NLD', 'هولندا'),
(4002, 1044033896, 1044033903, 'BE', 'BEL', 'بلجيكا'),
(4003, 1044033904, 1044033927, 'NL', 'NLD', 'هولندا'),
(4004, 1044033928, 1044033935, 'BE', 'BEL', 'بلجيكا'),
(4005, 1044033936, 1044033991, 'NL', 'NLD', 'هولندا'),
(4006, 1044033992, 1044033999, 'BE', 'BEL', 'بلجيكا'),
(4007, 1044034000, 1044034015, 'NL', 'NLD', 'هولندا'),
(4008, 1044034016, 1044034023, 'BE', 'BEL', 'بلجيكا'),
(4009, 1044034024, 1044034031, 'NL', 'NLD', 'هولندا'),
(4010, 1044034032, 1044034039, 'BE', 'BEL', 'بلجيكا'),
(4011, 1044034040, 1044034055, 'NL', 'NLD', 'هولندا'),
(4012, 1044034056, 1044034063, 'BE', 'BEL', 'بلجيكا'),
(4013, 1044034064, 1044034095, 'NL', 'NLD', 'هولندا'),
(4014, 1044034096, 1044034119, 'BE', 'BEL', 'بلجيكا'),
(4015, 1044034120, 1044034127, 'NL', 'NLD', 'هولندا'),
(4016, 1044034128, 1044034135, 'BE', 'BEL', 'بلجيكا'),
(4017, 1044034136, 1044034207, 'NL', 'NLD', 'هولندا'),
(4018, 1044034208, 1044034215, 'BE', 'BEL', 'بلجيكا'),
(4019, 1044034216, 1044034231, 'NL', 'NLD', 'هولندا'),
(4020, 1044034232, 1044034247, 'BE', 'BEL', 'بلجيكا'),
(4021, 1044034248, 1044034263, 'NL', 'NLD', 'هولندا'),
(4022, 1044034264, 1044034271, 'BE', 'BEL', 'بلجيكا'),
(4023, 1044034272, 1044034279, 'NL', 'NLD', 'هولندا'),
(4024, 1044034280, 1044034295, 'BE', 'BEL', 'بلجيكا'),
(4025, 1044034296, 1044034303, 'NL', 'NLD', 'هولندا'),
(4026, 1044034304, 1044034311, 'BE', 'BEL', 'بلجيكا'),
(4027, 1044034312, 1044034327, 'NL', 'NLD', 'هولندا'),
(4028, 1044034328, 1044034335, 'BE', 'BEL', 'بلجيكا'),
(4029, 1044034336, 1044034375, 'NL', 'NLD', 'هولندا'),
(4030, 1044034376, 1044034383, 'BE', 'BEL', 'بلجيكا'),
(4031, 1044034384, 1044034487, 'NL', 'NLD', 'هولندا'),
(4032, 1044034488, 1044034495, 'BE', 'BEL', 'بلجيكا'),
(4033, 1044034496, 1044034511, 'NL', 'NLD', 'هولندا'),
(4034, 1044034512, 1044034519, 'BE', 'BEL', 'بلجيكا'),
(4035, 1044034520, 1044034615, 'NL', 'NLD', 'هولندا'),
(4036, 1044034616, 1044034623, 'BE', 'BEL', 'بلجيكا'),
(4037, 1044034624, 1044034663, 'NL', 'NLD', 'هولندا'),
(4038, 1044034664, 1044034671, 'BE', 'BEL', 'بلجيكا'),
(4039, 1044034672, 1044034735, 'NL', 'NLD', 'هولندا'),
(4040, 1044034736, 1044034743, 'BE', 'BEL', 'بلجيكا'),
(4041, 1044034744, 1044034751, 'NL', 'NLD', 'هولندا'),
(4042, 1044034752, 1044034759, 'BE', 'BEL', 'بلجيكا'),
(4043, 1044034760, 1044034783, 'NL', 'NLD', 'هولندا'),
(4044, 1044034784, 1044034791, 'BE', 'BEL', 'بلجيكا'),
(4045, 1044034792, 1044034847, 'NL', 'NLD', 'هولندا'),
(4046, 1044034848, 1044034855, 'BE', 'BEL', 'بلجيكا'),
(4047, 1044034856, 1044034919, 'NL', 'NLD', 'هولندا'),
(4048, 1044034920, 1044034927, 'BE', 'BEL', 'بلجيكا'),
(4049, 1044034928, 1044034975, 'NL', 'NLD', 'هولندا'),
(4050, 1044034976, 1044034983, 'BE', 'BEL', 'بلجيكا'),
(4051, 1044034984, 1044034999, 'NL', 'NLD', 'هولندا'),
(4052, 1044035000, 1044035007, 'BE', 'BEL', 'بلجيكا'),
(4053, 1044035008, 1044035031, 'NL', 'NLD', 'هولندا'),
(4054, 1044035032, 1044035039, 'BE', 'BEL', 'بلجيكا'),
(4055, 1044035040, 1044035047, 'NL', 'NLD', 'هولندا'),
(4056, 1044035048, 1044035055, 'BE', 'BEL', 'بلجيكا'),
(4057, 1044035056, 1044035063, 'NL', 'NLD', 'هولندا'),
(4058, 1044035064, 1044035071, 'BE', 'BEL', 'بلجيكا'),
(4059, 1044035072, 1044035143, 'NL', 'NLD', 'هولندا'),
(4060, 1044035144, 1044035151, 'BE', 'BEL', 'بلجيكا'),
(4061, 1044035152, 1044035191, 'NL', 'NLD', 'هولندا'),
(4062, 1044035192, 1044035199, 'BE', 'BEL', 'بلجيكا'),
(4063, 1044035200, 1044035223, 'NL', 'NLD', 'هولندا'),
(4064, 1044035224, 1044035231, 'BE', 'BEL', 'بلجيكا'),
(4065, 1044035232, 1044035255, 'NL', 'NLD', 'هولندا'),
(4066, 1044035256, 1044035263, 'BE', 'BEL', 'بلجيكا'),
(4067, 1044035264, 1044035287, 'NL', 'NLD', 'هولندا'),
(4068, 1044035288, 1044035311, 'BE', 'BEL', 'بلجيكا'),
(4069, 1044035312, 1044035327, 'NL', 'NLD', 'هولندا'),
(4070, 1044035328, 1044035351, 'BE', 'BEL', 'بلجيكا'),
(4071, 1044035352, 1044035415, 'NL', 'NLD', 'هولندا'),
(4072, 1044035416, 1044035423, 'BE', 'BEL', 'بلجيكا'),
(4073, 1044035424, 1044035447, 'NL', 'NLD', 'هولندا'),
(4074, 1044035448, 1044035471, 'BE', 'BEL', 'بلجيكا'),
(4075, 1044035472, 1044035479, 'NL', 'NLD', 'هولندا'),
(4076, 1044035480, 1044035487, 'BE', 'BEL', 'بلجيكا'),
(4077, 1044035488, 1044035495, 'NL', 'NLD', 'هولندا'),
(4078, 1044035496, 1044035503, 'BE', 'BEL', 'بلجيكا'),
(4079, 1044035504, 1044035511, 'NL', 'NLD', 'هولندا'),
(4080, 1044035512, 1044035527, 'BE', 'BEL', 'بلجيكا'),
(4081, 1044035528, 1044035559, 'NL', 'NLD', 'هولندا'),
(4082, 1044035560, 1044035591, 'BE', 'BEL', 'بلجيكا'),
(4083, 1044035592, 1044035607, 'NL', 'NLD', 'هولندا'),
(4084, 1044035608, 1044035623, 'BE', 'BEL', 'بلجيكا'),
(4085, 1044035624, 1044035655, 'NL', 'NLD', 'هولندا'),
(4086, 1044035656, 1044035663, 'BE', 'BEL', 'بلجيكا'),
(4087, 1044035664, 1044035671, 'NL', 'NLD', 'هولندا'),
(4088, 1044035672, 1044035679, 'BE', 'BEL', 'بلجيكا'),
(4089, 1044035680, 1044035711, 'NL', 'NLD', 'هولندا'),
(4090, 1044035712, 1044035727, 'BE', 'BEL', 'بلجيكا'),
(4091, 1044035728, 1044035751, 'NL', 'NLD', 'هولندا'),
(4092, 1044035752, 1044035759, 'BE', 'BEL', 'بلجيكا'),
(4093, 1044035760, 1044035791, 'NL', 'NLD', 'هولندا'),
(4094, 1044035792, 1044035807, 'BE', 'BEL', 'بلجيكا'),
(4095, 1044035808, 1044035831, 'NL', 'NLD', 'هولندا'),
(4096, 1044035832, 1044035839, 'BE', 'BEL', 'بلجيكا'),
(4097, 1044035840, 1044035847, 'NL', 'NLD', 'هولندا'),
(4098, 1044035848, 1044035871, 'BE', 'BEL', 'بلجيكا'),
(4099, 1044035872, 1044035887, 'NL', 'NLD', 'هولندا'),
(4100, 1044035888, 1044035895, 'BE', 'BEL', 'بلجيكا'),
(4101, 1044035896, 1044035903, 'NL', 'NLD', 'هولندا'),
(4102, 1044035904, 1044035919, 'BE', 'BEL', 'بلجيكا'),
(4103, 1044035920, 1044035943, 'NL', 'NLD', 'هولندا'),
(4104, 1044035944, 1044035967, 'BE', 'BEL', 'بلجيكا'),
(4105, 1044035968, 1044035975, 'NL', 'NLD', 'هولندا'),
(4106, 1044035976, 1044035991, 'BE', 'BEL', 'بلجيكا'),
(4107, 1044035992, 1044035999, 'NL', 'NLD', 'هولندا'),
(4108, 1044036000, 1044036007, 'BE', 'BEL', 'بلجيكا'),
(4109, 1044036008, 1044036039, 'NL', 'NLD', 'هولندا'),
(4110, 1044036040, 1044036047, 'BE', 'BEL', 'بلجيكا'),
(4111, 1044036048, 1044036079, 'NL', 'NLD', 'هولندا'),
(4112, 1044036080, 1044036087, 'BE', 'BEL', 'بلجيكا'),
(4113, 1044036088, 1044036095, 'NL', 'NLD', 'هولندا'),
(4114, 1044036096, 1044036103, 'BE', 'BEL', 'بلجيكا'),
(4115, 1044036104, 1044036111, 'NL', 'NLD', 'هولندا'),
(4116, 1044036112, 1044036119, 'BE', 'BEL', 'بلجيكا'),
(4117, 1044036120, 1044036127, 'NL', 'NLD', 'هولندا'),
(4118, 1044036128, 1044036135, 'BE', 'BEL', 'بلجيكا'),
(4119, 1044036136, 1044036143, 'NL', 'NLD', 'هولندا'),
(4120, 1044036144, 1044036159, 'BE', 'BEL', 'بلجيكا'),
(4121, 1044036160, 1044036167, 'NL', 'NLD', 'هولندا'),
(4122, 1044036168, 1044036199, 'BE', 'BEL', 'بلجيكا'),
(4123, 1044036200, 1044036231, 'NL', 'NLD', 'هولندا'),
(4124, 1044036232, 1044036239, 'BE', 'BEL', 'بلجيكا'),
(4125, 1044036240, 1044036255, 'NL', 'NLD', 'هولندا'),
(4126, 1044036256, 1044036271, 'BE', 'BEL', 'بلجيكا'),
(4127, 1044036272, 1044036295, 'NL', 'NLD', 'هولندا'),
(4128, 1044036296, 1044036311, 'BE', 'BEL', 'بلجيكا'),
(4129, 1044036312, 1044036327, 'NL', 'NLD', 'هولندا'),
(4130, 1044036328, 1044036335, 'BE', 'BEL', 'بلجيكا'),
(4131, 1044036336, 1044036399, 'NL', 'NLD', 'هولندا'),
(4132, 1044036400, 1044036407, 'BE', 'BEL', 'بلجيكا'),
(4133, 1044036408, 1044036415, 'NL', 'NLD', 'هولندا'),
(4134, 1044036416, 1044036423, 'BE', 'BEL', 'بلجيكا'),
(4135, 1044036424, 1044036471, 'NL', 'NLD', 'هولندا'),
(4136, 1044036472, 1044036479, 'BE', 'BEL', 'بلجيكا'),
(4137, 1044036480, 1044036503, 'NL', 'NLD', 'هولندا'),
(4138, 1044036504, 1044036511, 'BE', 'BEL', 'بلجيكا'),
(4139, 1044036512, 1044036527, 'NL', 'NLD', 'هولندا'),
(4140, 1044036528, 1044036543, 'BE', 'BEL', 'بلجيكا'),
(4141, 1044036544, 1044036559, 'NL', 'NLD', 'هولندا'),
(4142, 1044036560, 1044036567, 'BE', 'BEL', 'بلجيكا'),
(4143, 1044036568, 1044036575, 'NL', 'NLD', 'هولندا'),
(4144, 1044036576, 1044036607, 'BE', 'BEL', 'بلجيكا'),
(4145, 1044036608, 1044036615, 'NL', 'NLD', 'هولندا'),
(4146, 1044036616, 1044036623, 'BE', 'BEL', 'بلجيكا'),
(4147, 1044036624, 1044036647, 'NL', 'NLD', 'هولندا'),
(4148, 1044036648, 1044036655, 'BE', 'BEL', 'بلجيكا'),
(4149, 1044036656, 1044036671, 'NL', 'NLD', 'هولندا'),
(4150, 1044036672, 1044036687, 'BE', 'BEL', 'بلجيكا'),
(4151, 1044036688, 1044036759, 'NL', 'NLD', 'هولندا'),
(4152, 1044036760, 1044036767, 'BE', 'BEL', 'بلجيكا'),
(4153, 1044036768, 1044036775, 'NL', 'NLD', 'هولندا'),
(4154, 1044036776, 1044036783, 'BE', 'BEL', 'بلجيكا'),
(4155, 1044036784, 1044036791, 'NL', 'NLD', 'هولندا'),
(4156, 1044036792, 1044036799, 'BE', 'BEL', 'بلجيكا'),
(4157, 1044036800, 1044036807, 'NL', 'NLD', 'هولندا'),
(4158, 1044036808, 1044036815, 'BE', 'BEL', 'بلجيكا'),
(4159, 1044036816, 1044036863, 'NL', 'NLD', 'هولندا'),
(4160, 1044036864, 1044036864, 'BE', 'BEL', 'بلجيكا'),
(4161, 1044036865, 1044036865, 'NL', 'NLD', 'هولندا'),
(4162, 1044036866, 1044036866, 'BE', 'BEL', 'بلجيكا'),
(4163, 1044036867, 1044036890, 'NL', 'NLD', 'هولندا'),
(4164, 1044036891, 1044036891, 'BE', 'BEL', 'بلجيكا'),
(4165, 1044036892, 1044036899, 'NL', 'NLD', 'هولندا'),
(4166, 1044036900, 1044036900, 'BE', 'BEL', 'بلجيكا'),
(4167, 1044036901, 1044036907, 'NL', 'NLD', 'هولندا'),
(4168, 1044036908, 1044036908, 'BE', 'BEL', 'بلجيكا'),
(4169, 1044036909, 1044036909, 'NL', 'NLD', 'هولندا'),
(4170, 1044036910, 1044036910, 'BE', 'BEL', 'بلجيكا'),
(4171, 1044036911, 1044036927, 'NL', 'NLD', 'هولندا'),
(4172, 1044036928, 1044036928, 'BE', 'BEL', 'بلجيكا'),
(4173, 1044036929, 1044036942, 'NL', 'NLD', 'هولندا'),
(4174, 1044036943, 1044036943, 'BE', 'BEL', 'بلجيكا'),
(4175, 1044036944, 1044036948, 'NL', 'NLD', 'هولندا'),
(4176, 1044036949, 1044036951, 'BE', 'BEL', 'بلجيكا'),
(4177, 1044036952, 1044036957, 'NL', 'NLD', 'هولندا'),
(4178, 1044036958, 1044036958, 'BE', 'BEL', 'بلجيكا'),
(4179, 1044036959, 1044036967, 'NL', 'NLD', 'هولندا'),
(4180, 1044036968, 1044036968, 'BE', 'BEL', 'بلجيكا'),
(4181, 1044036969, 1044036970, 'NL', 'NLD', 'هولندا'),
(4182, 1044036971, 1044036971, 'BE', 'BEL', 'بلجيكا'),
(4183, 1044036972, 1044036976, 'NL', 'NLD', 'هولندا'),
(4184, 1044036977, 1044036977, 'BE', 'BEL', 'بلجيكا'),
(4185, 1044036978, 1044036984, 'NL', 'NLD', 'هولندا'),
(4186, 1044036985, 1044036985, 'BE', 'BEL', 'بلجيكا'),
(4187, 1044036986, 1044036990, 'NL', 'NLD', 'هولندا'),
(4188, 1044036991, 1044036991, 'BE', 'BEL', 'بلجيكا'),
(4189, 1044036992, 1044037007, 'NL', 'NLD', 'هولندا'),
(4190, 1044037008, 1044037010, 'BE', 'BEL', 'بلجيكا'),
(4191, 1044037011, 1044037014, 'NL', 'NLD', 'هولندا'),
(4192, 1044037015, 1044037015, 'BE', 'BEL', 'بلجيكا'),
(4193, 1044037016, 1044037021, 'NL', 'NLD', 'هولندا'),
(4194, 1044037022, 1044037022, 'BE', 'BEL', 'بلجيكا'),
(4195, 1044037023, 1044037023, 'NL', 'NLD', 'هولندا'),
(4196, 1044037024, 1044037025, 'BE', 'BEL', 'بلجيكا'),
(4197, 1044037026, 1044037026, 'NL', 'NLD', 'هولندا'),
(4198, 1044037027, 1044037027, 'BE', 'BEL', 'بلجيكا'),
(4199, 1044037028, 1044037037, 'NL', 'NLD', 'هولندا'),
(4200, 1044037038, 1044037038, 'BE', 'BEL', 'بلجيكا'),
(4201, 1044037039, 1044037042, 'NL', 'NLD', 'هولندا'),
(4202, 1044037043, 1044037043, 'BE', 'BEL', 'بلجيكا'),
(4203, 1044037044, 1044037047, 'NL', 'NLD', 'هولندا'),
(4204, 1044037048, 1044037048, 'BE', 'BEL', 'بلجيكا'),
(4205, 1044037049, 1044037049, 'NL', 'NLD', 'هولندا'),
(4206, 1044037050, 1044037051, 'BE', 'BEL', 'بلجيكا'),
(4207, 1044037052, 1044037056, 'NL', 'NLD', 'هولندا'),
(4208, 1044037057, 1044037057, 'BE', 'BEL', 'بلجيكا'),
(4209, 1044037058, 1044037061, 'NL', 'NLD', 'هولندا'),
(4210, 1044037062, 1044037063, 'BE', 'BEL', 'بلجيكا'),
(4211, 1044037064, 1044037065, 'NL', 'NLD', 'هولندا'),
(4212, 1044037066, 1044037066, 'BE', 'BEL', 'بلجيكا'),
(4213, 1044037067, 1044037070, 'NL', 'NLD', 'هولندا'),
(4214, 1044037071, 1044037071, 'BE', 'BEL', 'بلجيكا'),
(4215, 1044037072, 1044037074, 'NL', 'NLD', 'هولندا'),
(4216, 1044037075, 1044037075, 'BE', 'BEL', 'بلجيكا'),
(4217, 1044037076, 1044037091, 'NL', 'NLD', 'هولندا'),
(4218, 1044037092, 1044037092, 'BE', 'BEL', 'بلجيكا'),
(4219, 1044037093, 1044037098, 'NL', 'NLD', 'هولندا'),
(4220, 1044037099, 1044037100, 'BE', 'BEL', 'بلجيكا'),
(4221, 1044037101, 1044037101, 'NL', 'NLD', 'هولندا'),
(4222, 1044037102, 1044037102, 'BE', 'BEL', 'بلجيكا'),
(4223, 1044037103, 1044037106, 'NL', 'NLD', 'هولندا'),
(4224, 1044037107, 1044037107, 'BE', 'BEL', 'بلجيكا'),
(4225, 1044037108, 1044037109, 'NL', 'NLD', 'هولندا'),
(4226, 1044037110, 1044037110, 'BE', 'BEL', 'بلجيكا'),
(4227, 1044037111, 1044037143, 'NL', 'NLD', 'هولندا'),
(4228, 1044037144, 1044037151, 'BE', 'BEL', 'بلجيكا'),
(4229, 1044037152, 1044037159, 'NL', 'NLD', 'هولندا'),
(4230, 1044037160, 1044037167, 'BE', 'BEL', 'بلجيكا'),
(4231, 1044037168, 1044037191, 'NL', 'NLD', 'هولندا'),
(4232, 1044037192, 1044037223, 'BE', 'BEL', 'بلجيكا'),
(4233, 1044037224, 1044037271, 'NL', 'NLD', 'هولندا'),
(4234, 1044037272, 1044037279, 'BE', 'BEL', 'بلجيكا'),
(4235, 1044037280, 1044037287, 'NL', 'NLD', 'هولندا'),
(4236, 1044037288, 1044037295, 'BE', 'BEL', 'بلجيكا'),
(4237, 1044037296, 1044037667, 'NL', 'NLD', 'هولندا'),
(4238, 1044037668, 1044037671, 'BE', 'BEL', 'بلجيكا'),
(4239, 1044037672, 1044037703, 'NL', 'NLD', 'هولندا'),
(4240, 1044037704, 1044037711, 'BE', 'BEL', 'بلجيكا'),
(4241, 1044037712, 1044037735, 'NL', 'NLD', 'هولندا'),
(4242, 1044037736, 1044037743, 'BE', 'BEL', 'بلجيكا'),
(4243, 1044037744, 1044037767, 'NL', 'NLD', 'هولندا'),
(4244, 1044037768, 1044037783, 'BE', 'BEL', 'بلجيكا'),
(4245, 1044037784, 1044037791, 'NL', 'NLD', 'هولندا'),
(4246, 1044037792, 1044037823, 'BE', 'BEL', 'بلجيكا'),
(4247, 1044037824, 1044037831, 'NL', 'NLD', 'هولندا'),
(4248, 1044037832, 1044037839, 'BE', 'BEL', 'بلجيكا'),
(4249, 1044037840, 1044037855, 'NL', 'NLD', 'هولندا'),
(4250, 1044037856, 1044037887, 'BE', 'BEL', 'بلجيكا'),
(4251, 1044037888, 1044038143, 'NL', 'NLD', 'هولندا'),
(4252, 1044038144, 1044038527, 'BE', 'BEL', 'بلجيكا'),
(4253, 1044038528, 1044038535, 'NL', 'NLD', 'هولندا'),
(4254, 1044038536, 1044038543, 'BE', 'BEL', 'بلجيكا'),
(4255, 1044038544, 1044038559, 'NL', 'NLD', 'هولندا'),
(4256, 1044038560, 1044038567, 'BE', 'BEL', 'بلجيكا'),
(4257, 1044038568, 1044038591, 'NL', 'NLD', 'هولندا'),
(4258, 1044038592, 1044038599, 'BE', 'BEL', 'بلجيكا'),
(4259, 1044038600, 1044038615, 'NL', 'NLD', 'هولندا'),
(4260, 1044038616, 1044038623, 'BE', 'BEL', 'بلجيكا'),
(4261, 1044038624, 1044038639, 'NL', 'NLD', 'هولندا'),
(4262, 1044038640, 1044038647, 'BE', 'BEL', 'بلجيكا'),
(4263, 1044038648, 1044038783, 'NL', 'NLD', 'هولندا'),
(4264, 1044038784, 1044038911, 'BE', 'BEL', 'بلجيكا'),
(4265, 1044038912, 1044038919, 'NL', 'NLD', 'هولندا'),
(4266, 1044038920, 1044038927, 'BE', 'BEL', 'بلجيكا'),
(4267, 1044038928, 1044038935, 'NL', 'NLD', 'هولندا'),
(4268, 1044038936, 1044038943, 'BE', 'BEL', 'بلجيكا'),
(4269, 1044038944, 1044039687, 'NL', 'NLD', 'هولندا'),
(4270, 1044039688, 1044039695, 'BE', 'BEL', 'بلجيكا'),
(4271, 1044039696, 1044039751, 'NL', 'NLD', 'هولندا'),
(4272, 1044039752, 1044039759, 'BE', 'BEL', 'بلجيكا'),
(4273, 1044039760, 1044039775, 'NL', 'NLD', 'هولندا'),
(4274, 1044039776, 1044039855, 'BE', 'BEL', 'بلجيكا'),
(4275, 1044039856, 1044039999, 'NL', 'NLD', 'هولندا'),
(4276, 1044040000, 1044040015, 'BE', 'BEL', 'بلجيكا'),
(4277, 1044040016, 1044040063, 'NL', 'NLD', 'هولندا'),
(4278, 1044040064, 1044040095, 'BE', 'BEL', 'بلجيكا'),
(4279, 1044040096, 1044040103, 'NL', 'NLD', 'هولندا'),
(4280, 1044040104, 1044040111, 'BE', 'BEL', 'بلجيكا'),
(4281, 1044040112, 1044040231, 'NL', 'NLD', 'هولندا'),
(4282, 1044040232, 1044040239, 'BE', 'BEL', 'بلجيكا'),
(4283, 1044040240, 1044040255, 'NL', 'NLD', 'هولندا'),
(4284, 1044040256, 1044040703, 'BE', 'BEL', 'بلجيكا'),
(4285, 1044040704, 1044041727, 'NL', 'NLD', 'هولندا'),
(4286, 1044041728, 1044043775, 'BE', 'BEL', 'بلجيكا'),
(4287, 1044043776, 1044043783, 'NL', 'NLD', 'هولندا'),
(4288, 1044043784, 1044043787, 'BE', 'BEL', 'بلجيكا'),
(4289, 1044043788, 1044043791, 'NL', 'NLD', 'هولندا'),
(4290, 1044043792, 1044043795, 'BE', 'BEL', 'بلجيكا'),
(4291, 1044043796, 1044043799, 'NL', 'NLD', 'هولندا'),
(4292, 1044043800, 1044043803, 'BE', 'BEL', 'بلجيكا'),
(4293, 1044043804, 1044043807, 'NL', 'NLD', 'هولندا'),
(4294, 1044043808, 1044043811, 'BE', 'BEL', 'بلجيكا'),
(4295, 1044043812, 1044043823, 'NL', 'NLD', 'هولندا'),
(4296, 1044043824, 1044043827, 'BE', 'BEL', 'بلجيكا'),
(4297, 1044043828, 1044043835, 'NL', 'NLD', 'هولندا'),
(4298, 1044043836, 1044043847, 'BE', 'BEL', 'بلجيكا'),
(4299, 1044043848, 1044043851, 'NL', 'NLD', 'هولندا'),
(4300, 1044043852, 1044043879, 'BE', 'BEL', 'بلجيكا'),
(4301, 1044043880, 1044043883, 'NL', 'NLD', 'هولندا'),
(4302, 1044043884, 1044043895, 'BE', 'BEL', 'بلجيكا'),
(4303, 1044043896, 1044043903, 'NL', 'NLD', 'هولندا'),
(4304, 1044043904, 1044043907, 'BE', 'BEL', 'بلجيكا'),
(4305, 1044043908, 1044043919, 'NL', 'NLD', 'هولندا'),
(4306, 1044043920, 1044043927, 'BE', 'BEL', 'بلجيكا'),
(4307, 1044043928, 1044043931, 'NL', 'NLD', 'هولندا'),
(4308, 1044043932, 1044043935, 'BE', 'BEL', 'بلجيكا'),
(4309, 1044043936, 1044043943, 'NL', 'NLD', 'هولندا'),
(4310, 1044043944, 1044043955, 'BE', 'BEL', 'بلجيكا'),
(4311, 1044043956, 1044043971, 'NL', 'NLD', 'هولندا'),
(4312, 1044043972, 1044043975, 'BE', 'BEL', 'بلجيكا'),
(4313, 1044043976, 1044043987, 'NL', 'NLD', 'هولندا'),
(4314, 1044043988, 1044043999, 'BE', 'BEL', 'بلجيكا'),
(4315, 1044044000, 1044044003, 'NL', 'NLD', 'هولندا'),
(4316, 1044044004, 1044044007, 'BE', 'BEL', 'بلجيكا'),
(4317, 1044044008, 1044044011, 'NL', 'NLD', 'هولندا'),
(4318, 1044044012, 1044044015, 'BE', 'BEL', 'بلجيكا'),
(4319, 1044044016, 1044044019, 'NL', 'NLD', 'هولندا'),
(4320, 1044044020, 1044044027, 'BE', 'BEL', 'بلجيكا'),
(4321, 1044044028, 1044044035, 'NL', 'NLD', 'هولندا'),
(4322, 1044044036, 1044044043, 'BE', 'BEL', 'بلجيكا'),
(4323, 1044044044, 1044044051, 'NL', 'NLD', 'هولندا'),
(4324, 1044044052, 1044044055, 'BE', 'BEL', 'بلجيكا'),
(4325, 1044044056, 1044044059, 'NL', 'NLD', 'هولندا'),
(4326, 1044044060, 1044044071, 'BE', 'BEL', 'بلجيكا'),
(4327, 1044044072, 1044044083, 'NL', 'NLD', 'هولندا'),
(4328, 1044044084, 1044044099, 'BE', 'BEL', 'بلجيكا'),
(4329, 1044044100, 1044044119, 'NL', 'NLD', 'هولندا'),
(4330, 1044044120, 1044044131, 'BE', 'BEL', 'بلجيكا'),
(4331, 1044044132, 1044044135, 'NL', 'NLD', 'هولندا'),
(4332, 1044044136, 1044044143, 'BE', 'BEL', 'بلجيكا'),
(4333, 1044044144, 1044044163, 'NL', 'NLD', 'هولندا'),
(4334, 1044044164, 1044044167, 'BE', 'BEL', 'بلجيكا'),
(4335, 1044044168, 1044044171, 'NL', 'NLD', 'هولندا'),
(4336, 1044044172, 1044044187, 'BE', 'BEL', 'بلجيكا'),
(4337, 1044044188, 1044044215, 'NL', 'NLD', 'هولندا'),
(4338, 1044044216, 1044044223, 'BE', 'BEL', 'بلجيكا'),
(4339, 1044044224, 1044044243, 'NL', 'NLD', 'هولندا'),
(4340, 1044044244, 1044044247, 'BE', 'BEL', 'بلجيكا'),
(4341, 1044044248, 1044044251, 'NL', 'NLD', 'هولندا'),
(4342, 1044044252, 1044045311, 'BE', 'BEL', 'بلجيكا'),
(4343, 1044045312, 1044045695, 'NL', 'NLD', 'هولندا'),
(4344, 1044045696, 1044045911, 'BE', 'BEL', 'بلجيكا'),
(4345, 1044045912, 1044045919, 'NL', 'NLD', 'هولندا'),
(4346, 1044045920, 1044046079, 'BE', 'BEL', 'بلجيكا'),
(4347, 1044046080, 1044046223, 'NL', 'NLD', 'هولندا'),
(4348, 1044046224, 1044046231, 'BE', 'BEL', 'بلجيكا'),
(4349, 1044046232, 1044046239, 'NL', 'NLD', 'هولندا'),
(4350, 1044046240, 1044046319, 'BE', 'BEL', 'بلجيكا'),
(4351, 1044046320, 1044046327, 'NL', 'NLD', 'هولندا'),
(4352, 1044046328, 1044051987, 'BE', 'BEL', 'بلجيكا'),
(4353, 1044051988, 1044051991, 'NL', 'NLD', 'هولندا'),
(4354, 1044051992, 1044052011, 'BE', 'BEL', 'بلجيكا'),
(4355, 1044052012, 1044052015, 'NL', 'NLD', 'هولندا'),
(4356, 1044052016, 1044052031, 'BE', 'BEL', 'بلجيكا'),
(4357, 1044052032, 1044052039, 'NL', 'NLD', 'هولندا'),
(4358, 1044052040, 1044052063, 'BE', 'BEL', 'بلجيكا'),
(4359, 1044052064, 1044052067, 'NL', 'NLD', 'هولندا'),
(4360, 1044052068, 1044052107, 'BE', 'BEL', 'بلجيكا'),
(4361, 1044052108, 1044052111, 'NL', 'NLD', 'هولندا'),
(4362, 1044052112, 1044052131, 'BE', 'BEL', 'بلجيكا'),
(4363, 1044052132, 1044052135, 'NL', 'NLD', 'هولندا'),
(4364, 1044052136, 1044052223, 'BE', 'BEL', 'بلجيكا'),
(4365, 1044052224, 1044052227, 'NL', 'NLD', 'هولندا'),
(4366, 1044052228, 1044052255, 'BE', 'BEL', 'بلجيكا'),
(4367, 1044052256, 1044052259, 'NL', 'NLD', 'هولندا'),
(4368, 1044052260, 1044052347, 'BE', 'BEL', 'بلجيكا'),
(4369, 1044052348, 1044052359, 'NL', 'NLD', 'هولندا'),
(4370, 1044052360, 1044052363, 'BE', 'BEL', 'بلجيكا'),
(4371, 1044052364, 1044052375, 'NL', 'NLD', 'هولندا'),
(4372, 1044052376, 1044052479, 'BE', 'BEL', 'بلجيكا'),
(4373, 1044052480, 1044052483, 'NL', 'NLD', 'هولندا'),
(4374, 1044052484, 1044052967, 'BE', 'BEL', 'بلجيكا'),
(4375, 1044052968, 1044052971, 'NL', 'NLD', 'هولندا'),
(4376, 1044052972, 1044052983, 'BE', 'BEL', 'بلجيكا'),
(4377, 1044052984, 1044052987, 'NL', 'NLD', 'هولندا'),
(4378, 1044052988, 1044053055, 'BE', 'BEL', 'بلجيكا'),
(4379, 1044053056, 1044053063, 'NL', 'NLD', 'هولندا'),
(4380, 1044053064, 1044053255, 'BE', 'BEL', 'بلجيكا'),
(4381, 1044053256, 1044053263, 'NL', 'NLD', 'هولندا'),
(4382, 1044053264, 1044053455, 'BE', 'BEL', 'بلجيكا'),
(4383, 1044053456, 1044053463, 'NL', 'NLD', 'هولندا'),
(4384, 1044053464, 1044053503, 'BE', 'BEL', 'بلجيكا'),
(4385, 1044053504, 1044059263, 'NL', 'NLD', 'هولندا'),
(4386, 1044059264, 1044059935, 'BE', 'BEL', 'بلجيكا'),
(4387, 1044059936, 1044060031, 'NL', 'NLD', 'هولندا'),
(4388, 1044060032, 1044060063, 'BE', 'BEL', 'بلجيكا'),
(4389, 1044060064, 1044061191, 'NL', 'NLD', 'هولندا'),
(4390, 1044061192, 1044061223, 'BE', 'BEL', 'بلجيكا'),
(4391, 1044061224, 1044061263, 'NL', 'NLD', 'هولندا'),
(4392, 1044061264, 1044061271, 'BE', 'BEL', 'بلجيكا'),
(4393, 1044061272, 1044061343, 'NL', 'NLD', 'هولندا'),
(4394, 1044061344, 1044061375, 'BE', 'BEL', 'بلجيكا'),
(4395, 1044061376, 1044061391, 'NL', 'NLD', 'هولندا'),
(4396, 1044061392, 1044061399, 'BE', 'BEL', 'بلجيكا'),
(4397, 1044061400, 1044061431, 'NL', 'NLD', 'هولندا'),
(4398, 1044061432, 1044061439, 'BE', 'BEL', 'بلجيكا'),
(4399, 1044061440, 1044061695, 'NL', 'NLD', 'هولندا'),
(4400, 1044061696, 1044061703, 'BE', 'BEL', 'بلجيكا'),
(4401, 1044061704, 1044061759, 'NL', 'NLD', 'هولندا'),
(4402, 1044061760, 1044061775, 'BE', 'BEL', 'بلجيكا'),
(4403, 1044061776, 1044061783, 'NL', 'NLD', 'هولندا'),
(4404, 1044061784, 1044061799, 'BE', 'BEL', 'بلجيكا'),
(4405, 1044061800, 1044061831, 'NL', 'NLD', 'هولندا'),
(4406, 1044061832, 1044061839, 'BE', 'BEL', 'بلجيكا'),
(4407, 1044061840, 1044061879, 'NL', 'NLD', 'هولندا'),
(4408, 1044061880, 1044061895, 'BE', 'BEL', 'بلجيكا'),
(4409, 1044061896, 1044061919, 'NL', 'NLD', 'هولندا'),
(4410, 1044061920, 1044061951, 'BE', 'BEL', 'بلجيكا'),
(4411, 1044061952, 1044062015, 'NL', 'NLD', 'هولندا'),
(4412, 1044062016, 1044062047, 'BE', 'BEL', 'بلجيكا'),
(4413, 1044062048, 1044062079, 'NL', 'NLD', 'هولندا'),
(4414, 1044062080, 1044062087, 'BE', 'BEL', 'بلجيكا'),
(4415, 1044062088, 1044062103, 'NL', 'NLD', 'هولندا'),
(4416, 1044062104, 1044062135, 'BE', 'BEL', 'بلجيكا'),
(4417, 1044062136, 1044062175, 'NL', 'NLD', 'هولندا'),
(4418, 1044062176, 1044062199, 'BE', 'BEL', 'بلجيكا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(4419, 1044062200, 1044062223, 'NL', 'NLD', 'هولندا'),
(4420, 1044062224, 1044062239, 'BE', 'BEL', 'بلجيكا'),
(4421, 1044062240, 1044062375, 'NL', 'NLD', 'هولندا'),
(4422, 1044062376, 1044062383, 'BE', 'BEL', 'بلجيكا'),
(4423, 1044062384, 1044062399, 'NL', 'NLD', 'هولندا'),
(4424, 1044062400, 1044062415, 'BE', 'BEL', 'بلجيكا'),
(4425, 1044062416, 1044062455, 'NL', 'NLD', 'هولندا'),
(4426, 1044062456, 1044062471, 'BE', 'BEL', 'بلجيكا'),
(4427, 1044062472, 1044062503, 'NL', 'NLD', 'هولندا'),
(4428, 1044062504, 1044062527, 'BE', 'BEL', 'بلجيكا'),
(4429, 1044062528, 1044062535, 'NL', 'NLD', 'هولندا'),
(4430, 1044062536, 1044062543, 'BE', 'BEL', 'بلجيكا'),
(4431, 1044062544, 1044062575, 'NL', 'NLD', 'هولندا'),
(4432, 1044062576, 1044062583, 'BE', 'BEL', 'بلجيكا'),
(4433, 1044062584, 1044062591, 'NL', 'NLD', 'هولندا'),
(4434, 1044062592, 1044062599, 'BE', 'BEL', 'بلجيكا'),
(4435, 1044062600, 1044062607, 'NL', 'NLD', 'هولندا'),
(4436, 1044062608, 1044062623, 'BE', 'BEL', 'بلجيكا'),
(4437, 1044062624, 1044062647, 'NL', 'NLD', 'هولندا'),
(4438, 1044062648, 1044062655, 'BE', 'BEL', 'بلجيكا'),
(4439, 1044062656, 1044062663, 'NL', 'NLD', 'هولندا'),
(4440, 1044062664, 1044062671, 'BE', 'BEL', 'بلجيكا'),
(4441, 1044062672, 1044063231, 'NL', 'NLD', 'هولندا'),
(4442, 1044063232, 1044063355, 'BE', 'BEL', 'بلجيكا'),
(4443, 1044063356, 1044063363, 'NL', 'NLD', 'هولندا'),
(4444, 1044063364, 1044067327, 'BE', 'BEL', 'بلجيكا'),
(4445, 1044067328, 1044068351, 'NL', 'NLD', 'هولندا'),
(4446, 1044068352, 1044068991, 'BE', 'BEL', 'بلجيكا'),
(4447, 1044068992, 1044069631, 'NL', 'NLD', 'هولندا'),
(4448, 1044069632, 1044070399, 'BE', 'BEL', 'بلجيكا'),
(4449, 1044070400, 1044076607, 'NL', 'NLD', 'هولندا'),
(4450, 1044076608, 1044076799, 'BE', 'BEL', 'بلجيكا'),
(4451, 1044076800, 1044092927, 'NL', 'NLD', 'هولندا'),
(4452, 1044092928, 1044093183, 'BE', 'BEL', 'بلجيكا'),
(4453, 1044093184, 1044094975, 'NL', 'NLD', 'هولندا'),
(4454, 1044094976, 1044099071, 'BE', 'BEL', 'بلجيكا'),
(4455, 1044099072, 1044103263, 'NL', 'NLD', 'هولندا'),
(4456, 1044103264, 1044103423, 'BE', 'BEL', 'بلجيكا'),
(4457, 1044103424, 1044103999, 'NL', 'NLD', 'هولندا'),
(4458, 1044104000, 1044104031, 'BE', 'BEL', 'بلجيكا'),
(4459, 1044104032, 1044104127, 'NL', 'NLD', 'هولندا'),
(4460, 1044104128, 1044104159, 'BE', 'BEL', 'بلجيكا'),
(4461, 1044104160, 1044104287, 'NL', 'NLD', 'هولندا'),
(4462, 1044104288, 1044104319, 'BE', 'BEL', 'بلجيكا'),
(4463, 1044104320, 1044104367, 'NL', 'NLD', 'هولندا'),
(4464, 1044104368, 1044104383, 'BE', 'BEL', 'بلجيكا'),
(4465, 1044104384, 1044104543, 'NL', 'NLD', 'هولندا'),
(4466, 1044104544, 1044104559, 'BE', 'BEL', 'بلجيكا'),
(4467, 1044104560, 1044104831, 'NL', 'NLD', 'هولندا'),
(4468, 1044104832, 1044105023, 'BE', 'BEL', 'بلجيكا'),
(4469, 1044105024, 1044105055, 'NL', 'NLD', 'هولندا'),
(4470, 1044105056, 1044105087, 'BE', 'BEL', 'بلجيكا'),
(4471, 1044105088, 1044105151, 'NL', 'NLD', 'هولندا'),
(4472, 1044105152, 1044106771, 'BE', 'BEL', 'بلجيكا'),
(4473, 1044106772, 1044106775, 'NL', 'NLD', 'هولندا'),
(4474, 1044106776, 1044106787, 'BE', 'BEL', 'بلجيكا'),
(4475, 1044106788, 1044106795, 'NL', 'NLD', 'هولندا'),
(4476, 1044106796, 1044106807, 'BE', 'BEL', 'بلجيكا'),
(4477, 1044106808, 1044106815, 'NL', 'NLD', 'هولندا'),
(4478, 1044106816, 1044107263, 'BE', 'BEL', 'بلجيكا'),
(4479, 1044107264, 1044111359, 'NL', 'NLD', 'هولندا'),
(4480, 1044111360, 1044115455, 'BE', 'BEL', 'بلجيكا'),
(4481, 1044115456, 1044117503, 'NL', 'NLD', 'هولندا'),
(4482, 1044117504, 1044117551, 'BE', 'BEL', 'بلجيكا'),
(4483, 1044117552, 1044117567, 'NL', 'NLD', 'هولندا'),
(4484, 1044117568, 1044118527, 'BE', 'BEL', 'بلجيكا'),
(4485, 1044118528, 1044119551, 'NL', 'NLD', 'هولندا'),
(4486, 1044119552, 1044152319, 'GB', 'GBR', 'المملكة المتحدة'),
(4487, 1044152320, 1044185087, 'IR', 'IRN', 'إيران'),
(4488, 1044185088, 1044193279, 'RU', 'RUS', 'الإتحاد الروسي'),
(4489, 1044193280, 1044201471, 'PL', 'POL', 'بولندا'),
(4490, 1044201472, 1044217855, 'FI', 'FIN', 'فنلندا'),
(4491, 1044217856, 1044226047, 'DK', 'DNK', 'الدنيمارك'),
(4492, 1044226048, 1044234239, 'OM', 'OMN', 'عمان'),
(4493, 1044250624, 1044251391, 'BE', 'BEL', 'بلجيكا'),
(4494, 1044251648, 1044252415, 'BE', 'BEL', 'بلجيكا'),
(4495, 1044252928, 1044253439, 'BE', 'BEL', 'بلجيكا'),
(4496, 1044253696, 1044254463, 'BE', 'BEL', 'بلجيكا'),
(4497, 1044254976, 1044255487, 'BE', 'BEL', 'بلجيكا'),
(4498, 1044256000, 1044256511, 'BE', 'BEL', 'بلجيكا'),
(4499, 1044256768, 1044257535, 'BE', 'BEL', 'بلجيكا'),
(4500, 1044257792, 1044258559, 'BE', 'BEL', 'بلجيكا'),
(4501, 1044259072, 1044259583, 'BE', 'BEL', 'بلجيكا'),
(4502, 1044260096, 1044261631, 'BE', 'BEL', 'بلجيكا'),
(4503, 1044262144, 1044262399, 'BE', 'BEL', 'بلجيكا'),
(4504, 1044263168, 1044263423, 'BE', 'BEL', 'بلجيكا'),
(4505, 1044264192, 1044264447, 'BE', 'BEL', 'بلجيكا'),
(4506, 1044265216, 1044265471, 'BE', 'BEL', 'بلجيكا'),
(4507, 1044265984, 1044266751, 'BE', 'BEL', 'بلجيكا'),
(4508, 1044267520, 1044269567, 'BE', 'BEL', 'بلجيكا'),
(4509, 1044270080, 1044271615, 'BE', 'BEL', 'بلجيكا'),
(4510, 1044272128, 1044272383, 'BE', 'BEL', 'بلجيكا'),
(4511, 1044272896, 1044273151, 'BE', 'BEL', 'بلجيكا'),
(4512, 1044283392, 1044316159, 'FR', 'FRA', 'فرنسا'),
(4513, 1044316160, 1044332543, 'NO', 'NOR', 'النرويج'),
(4514, 1044332544, 1044348927, 'RU', 'RUS', 'الإتحاد الروسي'),
(4515, 1044348928, 1044365311, 'LV', 'LVA', 'لاتفيا'),
(4516, 1044365312, 1044381695, 'SE', 'SWE', 'السويد'),
(4517, 1044381696, 1044384511, 'RU', 'RUS', 'الإتحاد الروسي'),
(4518, 1044384512, 1044384767, 'KZ', 'KAZ', 'كازاخستان'),
(4519, 1044384768, 1044389887, 'RU', 'RUS', 'الإتحاد الروسي'),
(4520, 1044389888, 1044398079, 'FR', 'FRA', 'فرنسا'),
(4521, 1044398080, 1044414463, 'UA', 'UKR', 'أوكرانيا'),
(4522, 1044414464, 1044447231, 'GB', 'GBR', 'المملكة المتحدة'),
(4523, 1044447232, 1044451583, 'SE', 'SWE', 'السويد'),
(4524, 1044451584, 1044451839, 'NO', 'NOR', 'النرويج'),
(4525, 1044451840, 1044453183, 'SE', 'SWE', 'السويد'),
(4526, 1044453184, 1044453263, 'NO', 'NOR', 'النرويج'),
(4527, 1044453264, 1044454399, 'SE', 'SWE', 'السويد'),
(4528, 1044454400, 1044454415, 'NO', 'NOR', 'النرويج'),
(4529, 1044454416, 1044454423, 'SE', 'SWE', 'السويد'),
(4530, 1044454424, 1044454427, 'NO', 'NOR', 'النرويج'),
(4531, 1044454428, 1044454463, 'SE', 'SWE', 'السويد'),
(4532, 1044454464, 1044454495, 'NO', 'NOR', 'النرويج'),
(4533, 1044454496, 1044454511, 'SE', 'SWE', 'السويد'),
(4534, 1044454512, 1044454559, 'NO', 'NOR', 'النرويج'),
(4535, 1044454560, 1044454583, 'SE', 'SWE', 'السويد'),
(4536, 1044454584, 1044454655, 'NO', 'NOR', 'النرويج'),
(4537, 1044454656, 1044454911, 'SE', 'SWE', 'السويد'),
(4538, 1044454912, 1044455423, 'NO', 'NOR', 'النرويج'),
(4539, 1044455424, 1044463615, 'EE', 'EST', 'إستونيا'),
(4540, 1044463616, 1044479999, 'SE', 'SWE', 'السويد'),
(4541, 1044480000, 1044488191, 'CH', 'CHE', 'سويسرا'),
(4542, 1044488192, 1044496383, 'SK', 'SVK', 'سلوفاكيا'),
(4543, 1044496384, 1044512767, 'EE', 'EST', 'إستونيا'),
(4544, 1044512768, 1044578303, 'DK', 'DNK', 'الدنيمارك'),
(4545, 1044578304, 1044580607, 'DE', 'DEU', 'ألمانيا'),
(4546, 1044580608, 1044586495, 'GB', 'GBR', 'المملكة المتحدة'),
(4547, 1044586496, 1044587007, 'DE', 'DEU', 'ألمانيا'),
(4548, 1044587008, 1044587519, 'GB', 'GBR', 'المملكة المتحدة'),
(4549, 1044587520, 1044587775, 'DE', 'DEU', 'ألمانيا'),
(4550, 1044587776, 1044588031, 'GB', 'GBR', 'المملكة المتحدة'),
(4551, 1044588032, 1044588287, 'DE', 'DEU', 'ألمانيا'),
(4552, 1044588288, 1044588575, 'GB', 'GBR', 'المملكة المتحدة'),
(4553, 1044588576, 1044588607, 'DE', 'DEU', 'ألمانيا'),
(4554, 1044588608, 1044589055, 'GB', 'GBR', 'المملكة المتحدة'),
(4555, 1044589056, 1044590463, 'DE', 'DEU', 'ألمانيا'),
(4556, 1044590464, 1044590591, 'GB', 'GBR', 'المملكة المتحدة'),
(4557, 1044590592, 1044590671, 'DE', 'DEU', 'ألمانيا'),
(4558, 1044590672, 1044590847, 'GB', 'GBR', 'المملكة المتحدة'),
(4559, 1044590848, 1044591359, 'DE', 'DEU', 'ألمانيا'),
(4560, 1044591360, 1044591871, 'GB', 'GBR', 'المملكة المتحدة'),
(4561, 1044591872, 1044592127, 'DE', 'DEU', 'ألمانيا'),
(4562, 1044592128, 1044592143, 'GB', 'GBR', 'المملكة المتحدة'),
(4563, 1044592144, 1044592159, 'DE', 'DEU', 'ألمانيا'),
(4564, 1044592160, 1044592191, 'GB', 'GBR', 'المملكة المتحدة'),
(4565, 1044592192, 1044592255, 'DE', 'DEU', 'ألمانيا'),
(4566, 1044592256, 1044592639, 'GB', 'GBR', 'المملكة المتحدة'),
(4567, 1044592640, 1044592655, 'DE', 'DEU', 'ألمانيا'),
(4568, 1044592656, 1044592831, 'GB', 'GBR', 'المملكة المتحدة'),
(4569, 1044592832, 1044594175, 'DE', 'DEU', 'ألمانيا'),
(4570, 1044594176, 1044625407, 'GB', 'GBR', 'المملكة المتحدة'),
(4571, 1044625408, 1044625463, 'DE', 'DEU', 'ألمانيا'),
(4572, 1044625464, 1044625471, 'GB', 'GBR', 'المملكة المتحدة'),
(4573, 1044625472, 1044625535, 'DE', 'DEU', 'ألمانيا'),
(4574, 1044625536, 1044625663, 'GB', 'GBR', 'المملكة المتحدة'),
(4575, 1044625664, 1044625679, 'DE', 'DEU', 'ألمانيا'),
(4576, 1044625680, 1044627455, 'GB', 'GBR', 'المملكة المتحدة'),
(4577, 1044627456, 1044628479, 'DE', 'DEU', 'ألمانيا'),
(4578, 1044628480, 1044629503, 'GB', 'GBR', 'المملكة المتحدة'),
(4579, 1044629504, 1044629759, 'DE', 'DEU', 'ألمانيا'),
(4580, 1044629760, 1044631551, 'GB', 'GBR', 'المملكة المتحدة'),
(4581, 1044631552, 1044631871, 'DE', 'DEU', 'ألمانيا'),
(4582, 1044631872, 1044631951, 'GB', 'GBR', 'المملكة المتحدة'),
(4583, 1044631952, 1044631967, 'DE', 'DEU', 'ألمانيا'),
(4584, 1044631968, 1044632319, 'GB', 'GBR', 'المملكة المتحدة'),
(4585, 1044632320, 1044633855, 'DE', 'DEU', 'ألمانيا'),
(4586, 1044633856, 1044634111, 'GB', 'GBR', 'المملكة المتحدة'),
(4587, 1044634112, 1044634367, 'DE', 'DEU', 'ألمانيا'),
(4588, 1044634368, 1044634623, 'GB', 'GBR', 'المملكة المتحدة'),
(4589, 1044634624, 1044634879, 'DE', 'DEU', 'ألمانيا'),
(4590, 1044634880, 1044635135, 'GB', 'GBR', 'المملكة المتحدة'),
(4591, 1044635136, 1044635391, 'DE', 'DEU', 'ألمانيا'),
(4592, 1044635392, 1044635647, 'GB', 'GBR', 'المملكة المتحدة'),
(4593, 1044635648, 1044636159, 'US', 'USA', 'الولايات المتحدة'),
(4594, 1044636160, 1044638207, 'DE', 'DEU', 'ألمانيا'),
(4595, 1044638208, 1044638223, 'GB', 'GBR', 'المملكة المتحدة'),
(4596, 1044638224, 1044638239, 'DE', 'DEU', 'ألمانيا'),
(4597, 1044638240, 1044638463, 'GB', 'GBR', 'المملكة المتحدة'),
(4598, 1044638464, 1044638719, 'DE', 'DEU', 'ألمانيا'),
(4599, 1044638720, 1044639743, 'GB', 'GBR', 'المملكة المتحدة'),
(4600, 1044639744, 1044643327, 'DE', 'DEU', 'ألمانيا'),
(4601, 1044643328, 1044643839, 'GB', 'GBR', 'المملكة المتحدة'),
(4602, 1044643840, 1044652031, 'DE', 'DEU', 'ألمانيا'),
(4603, 1044660224, 1044664895, 'GR', 'GRC', 'اليونان'),
(4604, 1044664896, 1044664959, 'IR', 'IRN', 'إيران'),
(4605, 1044664960, 1044668415, 'GR', 'GRC', 'اليونان'),
(4606, 1044668416, 1044676607, 'BA', 'BIH', 'البوسنه والهرسك'),
(4607, 1044676608, 1044684799, 'RU', 'RUS', 'الإتحاد الروسي'),
(4608, 1044684800, 1044692991, 'HU', 'HUN', 'هنغاريا'),
(4609, 1044692992, 1044701183, 'AT', 'AUT', 'النمسا'),
(4610, 1044709376, 1044717567, 'RU', 'RUS', 'الإتحاد الروسي'),
(4611, 1044717568, 1044742143, 'GB', 'GBR', 'المملكة المتحدة'),
(4612, 1044742144, 1044750335, 'KW', 'KWT', 'الكويت'),
(4613, 1044750336, 1044750351, 'US', 'USA', 'الولايات المتحدة'),
(4614, 1044750352, 1044750355, 'HU', 'HUN', 'هنغاريا'),
(4615, 1044750356, 1044750359, 'BE', 'BEL', 'بلجيكا'),
(4616, 1044750360, 1044750363, 'GB', 'GBR', 'المملكة المتحدة'),
(4617, 1044750364, 1044750367, 'FI', 'FIN', 'فنلندا'),
(4618, 1044750368, 1044753151, 'NL', 'NLD', 'هولندا'),
(4619, 1044753152, 1044753183, 'DE', 'DEU', 'ألمانيا'),
(4620, 1044753184, 1044753215, 'HU', 'HUN', 'هنغاريا'),
(4621, 1044753216, 1044758527, 'NL', 'NLD', 'هولندا'),
(4622, 1044758528, 1044774911, 'PL', 'POL', 'بولندا'),
(4623, 1044774912, 1044840447, 'NO', 'NOR', 'النرويج'),
(4624, 1044840448, 1044905983, 'FI', 'FIN', 'فنلندا'),
(4625, 1044905984, 1044908031, 'GB', 'GBR', 'المملكة المتحدة'),
(4626, 1044908032, 1044909055, 'US', 'USA', 'الولايات المتحدة'),
(4627, 1044909056, 1044916735, 'GB', 'GBR', 'المملكة المتحدة'),
(4628, 1044916736, 1044917247, 'DE', 'DEU', 'ألمانيا'),
(4629, 1044917248, 1044917279, 'GB', 'GBR', 'المملكة المتحدة'),
(4630, 1044917280, 1044917295, 'US', 'USA', 'الولايات المتحدة'),
(4631, 1044917296, 1044917311, 'DE', 'DEU', 'ألمانيا'),
(4632, 1044917312, 1044917343, 'GB', 'GBR', 'المملكة المتحدة'),
(4633, 1044917344, 1044917359, 'DE', 'DEU', 'ألمانيا'),
(4634, 1044917360, 1044917503, 'GB', 'GBR', 'المملكة المتحدة'),
(4635, 1044917504, 1044917759, 'DE', 'DEU', 'ألمانيا'),
(4636, 1044917760, 1044917823, 'GB', 'GBR', 'المملكة المتحدة'),
(4637, 1044917824, 1044918271, 'DE', 'DEU', 'ألمانيا'),
(4638, 1044918272, 1044918287, 'GB', 'GBR', 'المملكة المتحدة'),
(4639, 1044918288, 1044919295, 'DE', 'DEU', 'ألمانيا'),
(4640, 1044919296, 1044920191, 'GB', 'GBR', 'المملكة المتحدة'),
(4641, 1044920192, 1044920319, 'DE', 'DEU', 'ألمانيا'),
(4642, 1044920320, 1044921343, 'GB', 'GBR', 'المملكة المتحدة'),
(4643, 1044921344, 1044922367, 'US', 'USA', 'الولايات المتحدة'),
(4644, 1044922368, 1044930559, 'DE', 'DEU', 'ألمانيا'),
(4645, 1044930560, 1044930695, 'BE', 'BEL', 'بلجيكا'),
(4646, 1044930696, 1044930703, 'GB', 'GBR', 'المملكة المتحدة'),
(4647, 1044930704, 1044930775, 'BE', 'BEL', 'بلجيكا'),
(4648, 1044930776, 1044930783, 'GB', 'GBR', 'المملكة المتحدة'),
(4649, 1044930784, 1044930791, 'BE', 'BEL', 'بلجيكا'),
(4650, 1044930792, 1044930795, 'GB', 'GBR', 'المملكة المتحدة'),
(4651, 1044930796, 1044930799, 'BE', 'BEL', 'بلجيكا'),
(4652, 1044930800, 1044930807, 'GB', 'GBR', 'المملكة المتحدة'),
(4653, 1044930808, 1044930823, 'BE', 'BEL', 'بلجيكا'),
(4654, 1044930824, 1044930831, 'GB', 'GBR', 'المملكة المتحدة'),
(4655, 1044930832, 1044930847, 'BE', 'BEL', 'بلجيكا'),
(4656, 1044930848, 1044930879, 'FR', 'FRA', 'فرنسا'),
(4657, 1044930880, 1044930911, 'BE', 'BEL', 'بلجيكا'),
(4658, 1044930912, 1044930927, 'DE', 'DEU', 'ألمانيا'),
(4659, 1044930928, 1044930967, 'BE', 'BEL', 'بلجيكا'),
(4660, 1044930968, 1044930979, 'GB', 'GBR', 'المملكة المتحدة'),
(4661, 1044930980, 1044931375, 'BE', 'BEL', 'بلجيكا'),
(4662, 1044931376, 1044931391, 'GB', 'GBR', 'المملكة المتحدة'),
(4663, 1044931392, 1044931407, 'BE', 'BEL', 'بلجيكا'),
(4664, 1044931408, 1044931423, 'GB', 'GBR', 'المملكة المتحدة'),
(4665, 1044931424, 1044931487, 'BE', 'BEL', 'بلجيكا'),
(4666, 1044931488, 1044931495, 'GB', 'GBR', 'المملكة المتحدة'),
(4667, 1044931496, 1044931535, 'BE', 'BEL', 'بلجيكا'),
(4668, 1044931536, 1044931543, 'GB', 'GBR', 'المملكة المتحدة'),
(4669, 1044931544, 1044931551, 'BE', 'BEL', 'بلجيكا'),
(4670, 1044931552, 1044931567, 'GB', 'GBR', 'المملكة المتحدة'),
(4671, 1044931568, 1044931583, 'BE', 'BEL', 'بلجيكا'),
(4672, 1044931584, 1044931623, 'GB', 'GBR', 'المملكة المتحدة'),
(4673, 1044931624, 1044931759, 'BE', 'BEL', 'بلجيكا'),
(4674, 1044931760, 1044931775, 'GB', 'GBR', 'المملكة المتحدة'),
(4675, 1044931776, 1044931831, 'BE', 'BEL', 'بلجيكا'),
(4676, 1044931832, 1044931835, 'GB', 'GBR', 'المملكة المتحدة'),
(4677, 1044931836, 1044931855, 'BE', 'BEL', 'بلجيكا'),
(4678, 1044931856, 1044931871, 'GB', 'GBR', 'المملكة المتحدة'),
(4679, 1044931872, 1044931903, 'BE', 'BEL', 'بلجيكا'),
(4680, 1044931904, 1044931911, 'GB', 'GBR', 'المملكة المتحدة'),
(4681, 1044931912, 1044931915, 'BE', 'BEL', 'بلجيكا'),
(4682, 1044931916, 1044931919, 'GB', 'GBR', 'المملكة المتحدة'),
(4683, 1044931920, 1044931935, 'BE', 'BEL', 'بلجيكا'),
(4684, 1044931936, 1044931951, 'GB', 'GBR', 'المملكة المتحدة'),
(4685, 1044931952, 1044931975, 'BE', 'BEL', 'بلجيكا'),
(4686, 1044931976, 1044931983, 'GB', 'GBR', 'المملكة المتحدة'),
(4687, 1044931984, 1044932063, 'BE', 'BEL', 'بلجيكا'),
(4688, 1044932064, 1044932087, 'GB', 'GBR', 'المملكة المتحدة'),
(4689, 1044932088, 1044932399, 'BE', 'BEL', 'بلجيكا'),
(4690, 1044932400, 1044932407, 'GB', 'GBR', 'المملكة المتحدة'),
(4691, 1044932408, 1044932503, 'BE', 'BEL', 'بلجيكا'),
(4692, 1044932504, 1044932543, 'GB', 'GBR', 'المملكة المتحدة'),
(4693, 1044932544, 1044932675, 'BE', 'BEL', 'بلجيكا'),
(4694, 1044932676, 1044932687, 'GB', 'GBR', 'المملكة المتحدة'),
(4695, 1044932688, 1044932703, 'BE', 'BEL', 'بلجيكا'),
(4696, 1044932704, 1044932707, 'GB', 'GBR', 'المملكة المتحدة'),
(4697, 1044932708, 1044932719, 'BE', 'BEL', 'بلجيكا'),
(4698, 1044932720, 1044932727, 'GB', 'GBR', 'المملكة المتحدة'),
(4699, 1044932728, 1044932735, 'BE', 'BEL', 'بلجيكا'),
(4700, 1044932736, 1044932799, 'GB', 'GBR', 'المملكة المتحدة'),
(4701, 1044932800, 1044932831, 'BE', 'BEL', 'بلجيكا'),
(4702, 1044932832, 1044932839, 'GB', 'GBR', 'المملكة المتحدة'),
(4703, 1044932840, 1044932855, 'BE', 'BEL', 'بلجيكا'),
(4704, 1044932856, 1044932863, 'GB', 'GBR', 'المملكة المتحدة'),
(4705, 1044932864, 1044932939, 'BE', 'BEL', 'بلجيكا'),
(4706, 1044932940, 1044932947, 'GB', 'GBR', 'المملكة المتحدة'),
(4707, 1044932948, 1044932951, 'BE', 'BEL', 'بلجيكا'),
(4708, 1044932952, 1044932959, 'GB', 'GBR', 'المملكة المتحدة'),
(4709, 1044932960, 1044933007, 'BE', 'BEL', 'بلجيكا'),
(4710, 1044933008, 1044933015, 'GB', 'GBR', 'المملكة المتحدة'),
(4711, 1044933016, 1044933023, 'BE', 'BEL', 'بلجيكا'),
(4712, 1044933024, 1044933039, 'GB', 'GBR', 'المملكة المتحدة'),
(4713, 1044933040, 1044933055, 'BE', 'BEL', 'بلجيكا'),
(4714, 1044933056, 1044933071, 'GB', 'GBR', 'المملكة المتحدة'),
(4715, 1044933072, 1044933215, 'BE', 'BEL', 'بلجيكا'),
(4716, 1044933216, 1044933227, 'GB', 'GBR', 'المملكة المتحدة'),
(4717, 1044933228, 1044933303, 'BE', 'BEL', 'بلجيكا'),
(4718, 1044933304, 1044933311, 'GB', 'GBR', 'المملكة المتحدة'),
(4719, 1044933312, 1044933359, 'BE', 'BEL', 'بلجيكا'),
(4720, 1044933360, 1044933375, 'GB', 'GBR', 'المملكة المتحدة'),
(4721, 1044933376, 1044933407, 'BE', 'BEL', 'بلجيكا'),
(4722, 1044933408, 1044933411, 'GB', 'GBR', 'المملكة المتحدة'),
(4723, 1044933412, 1044933415, 'BE', 'BEL', 'بلجيكا'),
(4724, 1044933416, 1044933439, 'GB', 'GBR', 'المملكة المتحدة'),
(4725, 1044933440, 1044933615, 'BE', 'BEL', 'بلجيكا'),
(4726, 1044933616, 1044933623, 'GB', 'GBR', 'المملكة المتحدة'),
(4727, 1044933624, 1044933711, 'BE', 'BEL', 'بلجيكا'),
(4728, 1044933712, 1044933719, 'GB', 'GBR', 'المملكة المتحدة'),
(4729, 1044933720, 1044933727, 'BE', 'BEL', 'بلجيكا'),
(4730, 1044933728, 1044933735, 'GB', 'GBR', 'المملكة المتحدة'),
(4731, 1044933736, 1044933743, 'BE', 'BEL', 'بلجيكا'),
(4732, 1044933744, 1044933759, 'GB', 'GBR', 'المملكة المتحدة'),
(4733, 1044933760, 1044933823, 'BE', 'BEL', 'بلجيكا'),
(4734, 1044933824, 1044933831, 'GB', 'GBR', 'المملكة المتحدة'),
(4735, 1044933832, 1044933843, 'BE', 'BEL', 'بلجيكا'),
(4736, 1044933844, 1044933847, 'GB', 'GBR', 'المملكة المتحدة'),
(4737, 1044933848, 1044933863, 'BE', 'BEL', 'بلجيكا'),
(4738, 1044933864, 1044933871, 'GB', 'GBR', 'المملكة المتحدة'),
(4739, 1044933872, 1044934191, 'BE', 'BEL', 'بلجيكا'),
(4740, 1044934192, 1044934199, 'GB', 'GBR', 'المملكة المتحدة'),
(4741, 1044934200, 1044934239, 'BE', 'BEL', 'بلجيكا'),
(4742, 1044934240, 1044934247, 'GB', 'GBR', 'المملكة المتحدة'),
(4743, 1044934248, 1044934359, 'BE', 'BEL', 'بلجيكا'),
(4744, 1044934360, 1044934503, 'GB', 'GBR', 'المملكة المتحدة'),
(4745, 1044934504, 1044934575, 'BE', 'BEL', 'بلجيكا'),
(4746, 1044934576, 1044934583, 'GB', 'GBR', 'المملكة المتحدة'),
(4747, 1044934584, 1044934591, 'BE', 'BEL', 'بلجيكا'),
(4748, 1044934592, 1044934599, 'GB', 'GBR', 'المملكة المتحدة'),
(4749, 1044934600, 1044934719, 'BE', 'BEL', 'بلجيكا'),
(4750, 1044934720, 1044934783, 'GB', 'GBR', 'المملكة المتحدة'),
(4751, 1044934784, 1044934815, 'BE', 'BEL', 'بلجيكا'),
(4752, 1044934816, 1044934819, 'GB', 'GBR', 'المملكة المتحدة'),
(4753, 1044934820, 1044934823, 'BE', 'BEL', 'بلجيكا'),
(4754, 1044934824, 1044934911, 'GB', 'GBR', 'المملكة المتحدة'),
(4755, 1044934912, 1044935027, 'BE', 'BEL', 'بلجيكا'),
(4756, 1044935028, 1044935031, 'GB', 'GBR', 'المملكة المتحدة'),
(4757, 1044935032, 1044935035, 'BE', 'BEL', 'بلجيكا'),
(4758, 1044935036, 1044935039, 'GB', 'GBR', 'المملكة المتحدة'),
(4759, 1044935040, 1044935231, 'BE', 'BEL', 'بلجيكا'),
(4760, 1044935232, 1044935247, 'GB', 'GBR', 'المملكة المتحدة'),
(4761, 1044935248, 1044935279, 'BE', 'BEL', 'بلجيكا'),
(4762, 1044935280, 1044935295, 'GB', 'GBR', 'المملكة المتحدة'),
(4763, 1044935296, 1044935331, 'BE', 'BEL', 'بلجيكا'),
(4764, 1044935332, 1044935343, 'GB', 'GBR', 'المملكة المتحدة'),
(4765, 1044935344, 1044935355, 'BE', 'BEL', 'بلجيكا'),
(4766, 1044935356, 1044935391, 'GB', 'GBR', 'المملكة المتحدة'),
(4767, 1044935392, 1044935407, 'BE', 'BEL', 'بلجيكا'),
(4768, 1044935408, 1044935423, 'GB', 'GBR', 'المملكة المتحدة'),
(4769, 1044935424, 1044935595, 'BE', 'BEL', 'بلجيكا'),
(4770, 1044935596, 1044935599, 'GB', 'GBR', 'المملكة المتحدة'),
(4771, 1044935600, 1044935623, 'BE', 'BEL', 'بلجيكا'),
(4772, 1044935624, 1044935631, 'GB', 'GBR', 'المملكة المتحدة'),
(4773, 1044935632, 1044935743, 'BE', 'BEL', 'بلجيكا'),
(4774, 1044935744, 1044935751, 'GB', 'GBR', 'المملكة المتحدة'),
(4775, 1044935752, 1044935839, 'BE', 'BEL', 'بلجيكا'),
(4776, 1044935840, 1044935847, 'GB', 'GBR', 'المملكة المتحدة'),
(4777, 1044935848, 1044935879, 'BE', 'BEL', 'بلجيكا'),
(4778, 1044935880, 1044935887, 'GB', 'GBR', 'المملكة المتحدة'),
(4779, 1044935888, 1044935903, 'BE', 'BEL', 'بلجيكا'),
(4780, 1044935904, 1044936063, 'GB', 'GBR', 'المملكة المتحدة'),
(4781, 1044936064, 1044936103, 'BE', 'BEL', 'بلجيكا'),
(4782, 1044936104, 1044936111, 'GB', 'GBR', 'المملكة المتحدة'),
(4783, 1044936112, 1044936123, 'BE', 'BEL', 'بلجيكا'),
(4784, 1044936124, 1044936151, 'GB', 'GBR', 'المملكة المتحدة'),
(4785, 1044936152, 1044936207, 'BE', 'BEL', 'بلجيكا'),
(4786, 1044936208, 1044936215, 'GB', 'GBR', 'المملكة المتحدة'),
(4787, 1044936216, 1044936271, 'BE', 'BEL', 'بلجيكا'),
(4788, 1044936272, 1044936287, 'GB', 'GBR', 'المملكة المتحدة'),
(4789, 1044936288, 1044936303, 'BE', 'BEL', 'بلجيكا'),
(4790, 1044936304, 1044936311, 'GB', 'GBR', 'المملكة المتحدة'),
(4791, 1044936312, 1044936335, 'BE', 'BEL', 'بلجيكا'),
(4792, 1044936336, 1044936351, 'GB', 'GBR', 'المملكة المتحدة'),
(4793, 1044936352, 1044936439, 'BE', 'BEL', 'بلجيكا'),
(4794, 1044936440, 1044936447, 'GB', 'GBR', 'المملكة المتحدة'),
(4795, 1044936448, 1044936455, 'BE', 'BEL', 'بلجيكا'),
(4796, 1044936456, 1044936463, 'GB', 'GBR', 'المملكة المتحدة'),
(4797, 1044936464, 1044936495, 'BE', 'BEL', 'بلجيكا'),
(4798, 1044936496, 1044936503, 'GB', 'GBR', 'المملكة المتحدة'),
(4799, 1044936504, 1044936711, 'BE', 'BEL', 'بلجيكا'),
(4800, 1044936712, 1044936719, 'GB', 'GBR', 'المملكة المتحدة'),
(4801, 1044936720, 1044937183, 'BE', 'BEL', 'بلجيكا'),
(4802, 1044937184, 1044937187, 'GB', 'GBR', 'المملكة المتحدة'),
(4803, 1044937188, 1044937287, 'BE', 'BEL', 'بلجيكا'),
(4804, 1044937288, 1044937311, 'GB', 'GBR', 'المملكة المتحدة'),
(4805, 1044937312, 1044937391, 'BE', 'BEL', 'بلجيكا'),
(4806, 1044937392, 1044937399, 'GB', 'GBR', 'المملكة المتحدة'),
(4807, 1044937400, 1044937487, 'BE', 'BEL', 'بلجيكا'),
(4808, 1044937488, 1044937503, 'GB', 'GBR', 'المملكة المتحدة'),
(4809, 1044937504, 1044937527, 'BE', 'BEL', 'بلجيكا'),
(4810, 1044937528, 1044937531, 'GB', 'GBR', 'المملكة المتحدة'),
(4811, 1044937532, 1044937535, 'BE', 'BEL', 'بلجيكا'),
(4812, 1044937536, 1044937551, 'GB', 'GBR', 'المملكة المتحدة'),
(4813, 1044937552, 1044937567, 'BE', 'BEL', 'بلجيكا'),
(4814, 1044937568, 1044937583, 'GB', 'GBR', 'المملكة المتحدة'),
(4815, 1044937584, 1044937591, 'BE', 'BEL', 'بلجيكا'),
(4816, 1044937592, 1044937599, 'GB', 'GBR', 'المملكة المتحدة'),
(4817, 1044937600, 1044937615, 'BE', 'BEL', 'بلجيكا'),
(4818, 1044937616, 1044937631, 'GB', 'GBR', 'المملكة المتحدة'),
(4819, 1044937632, 1044937679, 'BE', 'BEL', 'بلجيكا'),
(4820, 1044937680, 1044937695, 'GB', 'GBR', 'المملكة المتحدة'),
(4821, 1044937696, 1044937703, 'BE', 'BEL', 'بلجيكا'),
(4822, 1044937704, 1044937711, 'GB', 'GBR', 'المملكة المتحدة'),
(4823, 1044937712, 1044937751, 'BE', 'BEL', 'بلجيكا'),
(4824, 1044937752, 1044937759, 'GB', 'GBR', 'المملكة المتحدة'),
(4825, 1044937760, 1044937847, 'BE', 'BEL', 'بلجيكا'),
(4826, 1044937848, 1044937887, 'GB', 'GBR', 'المملكة المتحدة'),
(4827, 1044937888, 1044937903, 'BE', 'BEL', 'بلجيكا'),
(4828, 1044937904, 1044937911, 'GB', 'GBR', 'المملكة المتحدة'),
(4829, 1044937912, 1044937971, 'BE', 'BEL', 'بلجيكا'),
(4830, 1044937972, 1044937975, 'GB', 'GBR', 'المملكة المتحدة'),
(4831, 1044937976, 1044938047, 'BE', 'BEL', 'بلجيكا'),
(4832, 1044938048, 1044938079, 'GB', 'GBR', 'المملكة المتحدة'),
(4833, 1044938080, 1044938103, 'BE', 'BEL', 'بلجيكا'),
(4834, 1044938104, 1044938107, 'GB', 'GBR', 'المملكة المتحدة'),
(4835, 1044938108, 1044938111, 'BE', 'BEL', 'بلجيكا'),
(4836, 1044938112, 1044938143, 'GB', 'GBR', 'المملكة المتحدة'),
(4837, 1044938144, 1044938239, 'BE', 'BEL', 'بلجيكا'),
(4838, 1044938240, 1044938271, 'GB', 'GBR', 'المملكة المتحدة'),
(4839, 1044938272, 1044938367, 'BE', 'BEL', 'بلجيكا'),
(4840, 1044938368, 1044938399, 'GB', 'GBR', 'المملكة المتحدة'),
(4841, 1044938400, 1044938407, 'BE', 'BEL', 'بلجيكا'),
(4842, 1044938408, 1044938415, 'GB', 'GBR', 'المملكة المتحدة'),
(4843, 1044938416, 1044938423, 'BE', 'BEL', 'بلجيكا'),
(4844, 1044938424, 1044938431, 'GB', 'GBR', 'المملكة المتحدة'),
(4845, 1044938432, 1044938487, 'BE', 'BEL', 'بلجيكا'),
(4846, 1044938488, 1044938511, 'GB', 'GBR', 'المملكة المتحدة'),
(4847, 1044938512, 1044938519, 'BE', 'BEL', 'بلجيكا'),
(4848, 1044938520, 1044938523, 'GB', 'GBR', 'المملكة المتحدة'),
(4849, 1044938524, 1044938631, 'BE', 'BEL', 'بلجيكا'),
(4850, 1044938632, 1044938639, 'GB', 'GBR', 'المملكة المتحدة'),
(4851, 1044938640, 1044938655, 'BE', 'BEL', 'بلجيكا'),
(4852, 1044938656, 1044938695, 'GB', 'GBR', 'المملكة المتحدة'),
(4853, 1044938696, 1044938703, 'BE', 'BEL', 'بلجيكا'),
(4854, 1044938704, 1044946943, 'GB', 'GBR', 'المملكة المتحدة'),
(4855, 1044946944, 1044955135, 'UA', 'UKR', 'أوكرانيا'),
(4856, 1044955136, 1044963327, 'NL', 'NLD', 'هولندا'),
(4857, 1044963328, 1044971519, 'FI', 'FIN', 'فنلندا'),
(4858, 1044971520, 1044979711, 'FR', 'FRA', 'فرنسا'),
(4859, 1044979712, 1044987903, 'FI', 'FIN', 'فنلندا'),
(4860, 1044987904, 1045004287, 'BG', 'BGR', 'بلغاريا'),
(4861, 1045004288, 1045004671, 'GB', 'GBR', 'المملكة المتحدة'),
(4862, 1045004672, 1045004751, 'IE', 'IRL', 'إيرلندا'),
(4863, 1045004752, 1045018207, 'GB', 'GBR', 'المملكة المتحدة'),
(4864, 1045018208, 1045018231, 'FI', 'FIN', 'فنلندا'),
(4865, 1045018232, 1045018367, 'GB', 'GBR', 'المملكة المتحدة'),
(4866, 1045018368, 1045018399, 'ES', 'ESP', 'إسبانيا'),
(4867, 1045018400, 1045018431, 'GB', 'GBR', 'المملكة المتحدة'),
(4868, 1045018432, 1045018495, 'ES', 'ESP', 'إسبانيا'),
(4869, 1045018496, 1045020159, 'GB', 'GBR', 'المملكة المتحدة'),
(4870, 1045020160, 1045020223, 'ES', 'ESP', 'إسبانيا'),
(4871, 1045020224, 1045020671, 'GB', 'GBR', 'المملكة المتحدة'),
(4872, 1045020672, 1045037055, 'NO', 'NOR', 'النرويج'),
(4873, 1045037056, 1045119231, 'GR', 'GRC', 'اليونان'),
(4874, 1045119232, 1045119743, 'AL', 'ALB', 'ألبانيا'),
(4875, 1045119744, 1045135359, 'GR', 'GRC', 'اليونان'),
(4876, 1045135360, 1045141759, 'DE', 'DEU', 'ألمانيا'),
(4877, 1045141760, 1045142015, 'PL', 'POL', 'بولندا'),
(4878, 1045142016, 1045154559, 'DE', 'DEU', 'ألمانيا'),
(4879, 1045154560, 1045154591, 'NL', 'NLD', 'هولندا'),
(4880, 1045154592, 1045154751, 'DE', 'DEU', 'ألمانيا'),
(4881, 1045154752, 1045154783, 'SE', 'SWE', 'السويد'),
(4882, 1045154784, 1045155071, 'DE', 'DEU', 'ألمانيا'),
(4883, 1045155072, 1045155327, 'CH', 'CHE', 'سويسرا'),
(4884, 1045155328, 1045160959, 'DE', 'DEU', 'ألمانيا'),
(4885, 1045160960, 1045160991, 'TR', 'TUR', 'تركيا'),
(4886, 1045160992, 1045161151, 'DE', 'DEU', 'ألمانيا'),
(4887, 1045161152, 1045161183, 'PT', 'PRT', 'البورتوغال'),
(4888, 1045161184, 1045168127, 'DE', 'DEU', 'ألمانيا'),
(4889, 1045168128, 1045233663, 'RU', 'RUS', 'الإتحاد الروسي'),
(4890, 1045233664, 1045241855, 'GB', 'GBR', 'المملكة المتحدة'),
(4891, 1045241856, 1045250047, 'IT', 'ITA', 'إيطاليا'),
(4892, 1045250048, 1045266431, 'CZ', 'CZE', 'التشيك'),
(4893, 1045266432, 1045274623, 'HU', 'HUN', 'هنغاريا'),
(4894, 1045274624, 1045282815, 'IE', 'IRL', 'إيرلندا'),
(4895, 1045282816, 1045299199, 'HU', 'HUN', 'هنغاريا'),
(4896, 1045299200, 1045302271, 'GB', 'GBR', 'المملكة المتحدة'),
(4897, 1045303296, 1045305855, 'DE', 'DEU', 'ألمانيا'),
(4898, 1045307392, 1045315583, 'RU', 'RUS', 'الإتحاد الروسي'),
(4899, 1045315584, 1045319679, 'DE', 'DEU', 'ألمانيا'),
(4900, 1045319680, 1045323775, 'RU', 'RUS', 'الإتحاد الروسي'),
(4901, 1045323776, 1045364735, 'FI', 'FIN', 'فنلندا'),
(4902, 1045364736, 1045430271, 'DK', 'DNK', 'الدنيمارك'),
(4903, 1045430272, 1045436911, 'DE', 'DEU', 'ألمانيا'),
(4904, 1045436912, 1045436919, 'GB', 'GBR', 'المملكة المتحدة'),
(4905, 1045436920, 1045446655, 'DE', 'DEU', 'ألمانيا'),
(4906, 1045446656, 1045446911, 'HU', 'HUN', 'هنغاريا'),
(4907, 1045446912, 1045447167, 'SK', 'SVK', 'سلوفاكيا'),
(4908, 1045447168, 1045447231, 'HU', 'HUN', 'هنغاريا'),
(4909, 1045447232, 1045447239, 'CZ', 'CZE', 'التشيك'),
(4910, 1045447240, 1045447263, 'HU', 'HUN', 'هنغاريا'),
(4911, 1045447264, 1045447279, 'CZ', 'CZE', 'التشيك'),
(4912, 1045447280, 1045447287, 'HU', 'HUN', 'هنغاريا'),
(4913, 1045447288, 1045447295, 'CZ', 'CZE', 'التشيك'),
(4914, 1045447296, 1045447311, 'HU', 'HUN', 'هنغاريا'),
(4915, 1045447312, 1045447423, 'CZ', 'CZE', 'التشيك'),
(4916, 1045447424, 1045447431, 'HU', 'HUN', 'هنغاريا'),
(4917, 1045447432, 1045447439, 'CZ', 'CZE', 'التشيك'),
(4918, 1045447440, 1045447447, 'HU', 'HUN', 'هنغاريا'),
(4919, 1045447448, 1045447471, 'CZ', 'CZE', 'التشيك'),
(4920, 1045447472, 1045447551, 'HU', 'HUN', 'هنغاريا'),
(4921, 1045447552, 1045448031, 'CZ', 'CZE', 'التشيك'),
(4922, 1045448032, 1045448039, 'HU', 'HUN', 'هنغاريا'),
(4923, 1045448040, 1045448055, 'CZ', 'CZE', 'التشيك'),
(4924, 1045448056, 1045448063, 'HU', 'HUN', 'هنغاريا'),
(4925, 1045448064, 1045448159, 'CZ', 'CZE', 'التشيك'),
(4926, 1045448160, 1045448191, 'HU', 'HUN', 'هنغاريا'),
(4927, 1045448192, 1045448239, 'CZ', 'CZE', 'التشيك'),
(4928, 1045448240, 1045448263, 'HU', 'HUN', 'هنغاريا'),
(4929, 1045448264, 1045448543, 'CZ', 'CZE', 'التشيك'),
(4930, 1045448544, 1045448559, 'SK', 'SVK', 'سلوفاكيا'),
(4931, 1045448560, 1045448703, 'CZ', 'CZE', 'التشيك'),
(4932, 1045448704, 1045448767, 'HU', 'HUN', 'هنغاريا'),
(4933, 1045448768, 1045452543, 'CZ', 'CZE', 'التشيك'),
(4934, 1045452544, 1045452799, 'SK', 'SVK', 'سلوفاكيا'),
(4935, 1045452800, 1045454847, 'CZ', 'CZE', 'التشيك'),
(4936, 1045454848, 1045460735, 'DE', 'DEU', 'ألمانيا'),
(4937, 1045460736, 1045460991, 'NL', 'NLD', 'هولندا'),
(4938, 1045460992, 1045461503, 'FR', 'FRA', 'فرنسا'),
(4939, 1045461504, 1045461631, 'DE', 'DEU', 'ألمانيا'),
(4940, 1045461632, 1045461695, 'FR', 'FRA', 'فرنسا'),
(4941, 1045461696, 1045461703, 'DE', 'DEU', 'ألمانيا'),
(4942, 1045461704, 1045461711, 'GB', 'GBR', 'المملكة المتحدة'),
(4943, 1045461712, 1045461719, 'FR', 'FRA', 'فرنسا'),
(4944, 1045461720, 1045461727, 'IT', 'ITA', 'إيطاليا'),
(4945, 1045461728, 1045461735, 'ES', 'ESP', 'إسبانيا'),
(4946, 1045461736, 1045461743, 'NL', 'NLD', 'هولندا'),
(4947, 1045461744, 1045463039, 'DE', 'DEU', 'ألمانيا'),
(4948, 1045463040, 1045471231, 'FI', 'FIN', 'فنلندا'),
(4949, 1045471232, 1045479423, 'UA', 'UKR', 'أوكرانيا'),
(4950, 1045479424, 1045487615, 'SE', 'SWE', 'السويد'),
(4951, 1045487616, 1045495807, 'LT', 'LTU', 'ليتوانيا'),
(4952, 1045495808, 1045692415, 'ES', 'ESP', 'إسبانيا'),
(4953, 1045692416, 1045700607, 'LV', 'LVA', 'لاتفيا'),
(4954, 1045700608, 1045708799, 'KZ', 'KAZ', 'كازاخستان'),
(4955, 1045708800, 1045716991, 'LB', 'LBN', 'لبنان'),
(4956, 1045716992, 1045725183, 'RU', 'RUS', 'الإتحاد الروسي'),
(4957, 1045725184, 1045733375, 'CZ', 'CZE', 'التشيك'),
(4958, 1045733376, 1045741567, 'GB', 'GBR', 'المملكة المتحدة'),
(4959, 1045741568, 1045742031, 'SE', 'SWE', 'السويد'),
(4960, 1045742032, 1045742039, 'GB', 'GBR', 'المملكة المتحدة'),
(4961, 1045742040, 1045742047, 'SE', 'SWE', 'السويد'),
(4962, 1045742048, 1045742111, 'GB', 'GBR', 'المملكة المتحدة'),
(4963, 1045742112, 1045742127, 'SE', 'SWE', 'السويد'),
(4964, 1045742128, 1045742175, 'GB', 'GBR', 'المملكة المتحدة'),
(4965, 1045742176, 1045742199, 'SE', 'SWE', 'السويد'),
(4966, 1045742200, 1045742207, 'GB', 'GBR', 'المملكة المتحدة'),
(4967, 1045742208, 1045742239, 'SE', 'SWE', 'السويد'),
(4968, 1045742240, 1045742247, 'GB', 'GBR', 'المملكة المتحدة'),
(4969, 1045742248, 1045742271, 'SE', 'SWE', 'السويد'),
(4970, 1045742272, 1045742335, 'GB', 'GBR', 'المملكة المتحدة'),
(4971, 1045742336, 1045742351, 'SE', 'SWE', 'السويد'),
(4972, 1045742352, 1045742367, 'GB', 'GBR', 'المملكة المتحدة'),
(4973, 1045742368, 1045742383, 'SE', 'SWE', 'السويد'),
(4974, 1045742384, 1045742391, 'GB', 'GBR', 'المملكة المتحدة'),
(4975, 1045742392, 1045742495, 'SE', 'SWE', 'السويد'),
(4976, 1045742496, 1045742535, 'GB', 'GBR', 'المملكة المتحدة'),
(4977, 1045742536, 1045742551, 'SE', 'SWE', 'السويد'),
(4978, 1045742552, 1045742559, 'GB', 'GBR', 'المملكة المتحدة'),
(4979, 1045742560, 1045742763, 'SE', 'SWE', 'السويد'),
(4980, 1045742764, 1045742767, 'GB', 'GBR', 'المملكة المتحدة'),
(4981, 1045742768, 1045742783, 'SE', 'SWE', 'السويد'),
(4982, 1045742784, 1045742831, 'GB', 'GBR', 'المملكة المتحدة'),
(4983, 1045742832, 1045742839, 'SE', 'SWE', 'السويد'),
(4984, 1045742840, 1045742847, 'GB', 'GBR', 'المملكة المتحدة'),
(4985, 1045742848, 1045743023, 'SE', 'SWE', 'السويد'),
(4986, 1045743024, 1045743031, 'GB', 'GBR', 'المملكة المتحدة'),
(4987, 1045743032, 1045743043, 'SE', 'SWE', 'السويد'),
(4988, 1045743044, 1045743063, 'GB', 'GBR', 'المملكة المتحدة'),
(4989, 1045743064, 1045743095, 'SE', 'SWE', 'السويد'),
(4990, 1045743096, 1045743099, 'GB', 'GBR', 'المملكة المتحدة'),
(4991, 1045743100, 1045743679, 'SE', 'SWE', 'السويد'),
(4992, 1045743680, 1045743743, 'GB', 'GBR', 'المملكة المتحدة'),
(4993, 1045743744, 1045743783, 'SE', 'SWE', 'السويد'),
(4994, 1045743784, 1045743791, 'GB', 'GBR', 'المملكة المتحدة'),
(4995, 1045743792, 1045743803, 'SE', 'SWE', 'السويد'),
(4996, 1045743804, 1045743807, 'GB', 'GBR', 'المملكة المتحدة'),
(4997, 1045743808, 1045743999, 'SE', 'SWE', 'السويد'),
(4998, 1045744000, 1045744007, 'LU', 'LUX', 'لوكسيمبورغ'),
(4999, 1045744008, 1045744063, 'GB', 'GBR', 'المملكة المتحدة'),
(5000, 1045744064, 1045744639, 'SE', 'SWE', 'السويد'),
(5001, 1045744640, 1045745407, 'GB', 'GBR', 'المملكة المتحدة'),
(5002, 1045745408, 1045745607, 'SE', 'SWE', 'السويد'),
(5003, 1045745608, 1045745615, 'FI', 'FIN', 'فنلندا'),
(5004, 1045745616, 1045745623, 'GB', 'GBR', 'المملكة المتحدة'),
(5005, 1045745624, 1045745639, 'SE', 'SWE', 'السويد'),
(5006, 1045745640, 1045745647, 'GB', 'GBR', 'المملكة المتحدة'),
(5007, 1045745648, 1045745655, 'SE', 'SWE', 'السويد'),
(5008, 1045745656, 1045745663, 'GB', 'GBR', 'المملكة المتحدة'),
(5009, 1045745664, 1045745695, 'SE', 'SWE', 'السويد'),
(5010, 1045745696, 1045745759, 'GB', 'GBR', 'المملكة المتحدة'),
(5011, 1045745760, 1045745768, 'SE', 'SWE', 'السويد'),
(5012, 1045745769, 1045745879, 'GB', 'GBR', 'المملكة المتحدة'),
(5013, 1045745880, 1045745919, 'SE', 'SWE', 'السويد'),
(5014, 1045745920, 1045745999, 'GB', 'GBR', 'المملكة المتحدة'),
(5015, 1045746000, 1045746079, 'SE', 'SWE', 'السويد'),
(5016, 1045746080, 1045746095, 'GB', 'GBR', 'المملكة المتحدة'),
(5017, 1045746096, 1045746163, 'SE', 'SWE', 'السويد'),
(5018, 1045746164, 1045746175, 'GB', 'GBR', 'المملكة المتحدة'),
(5019, 1045746176, 1045746431, 'SE', 'SWE', 'السويد'),
(5020, 1045746432, 1045746447, 'GB', 'GBR', 'المملكة المتحدة'),
(5021, 1045746448, 1045746463, 'SE', 'SWE', 'السويد'),
(5022, 1045746464, 1045746543, 'GB', 'GBR', 'المملكة المتحدة'),
(5023, 1045746544, 1045746559, 'SE', 'SWE', 'السويد'),
(5024, 1045746560, 1045746687, 'GB', 'GBR', 'المملكة المتحدة'),
(5025, 1045746688, 1045747071, 'SE', 'SWE', 'السويد'),
(5026, 1045747072, 1045747199, 'GB', 'GBR', 'المملكة المتحدة'),
(5027, 1045747200, 1045747455, 'SE', 'SWE', 'السويد'),
(5028, 1045747456, 1045747583, 'GB', 'GBR', 'المملكة المتحدة'),
(5029, 1045747584, 1045747615, 'SE', 'SWE', 'السويد'),
(5030, 1045747616, 1045747679, 'GB', 'GBR', 'المملكة المتحدة'),
(5031, 1045747680, 1045747711, 'SE', 'SWE', 'السويد'),
(5032, 1045747712, 1045747751, 'GB', 'GBR', 'المملكة المتحدة'),
(5033, 1045747752, 1045747775, 'SE', 'SWE', 'السويد'),
(5034, 1045747776, 1045747815, 'GB', 'GBR', 'المملكة المتحدة'),
(5035, 1045747816, 1045747823, 'SE', 'SWE', 'السويد'),
(5036, 1045747824, 1045747839, 'GB', 'GBR', 'المملكة المتحدة'),
(5037, 1045747840, 1045747871, 'SE', 'SWE', 'السويد'),
(5038, 1045747872, 1045747919, 'GB', 'GBR', 'المملكة المتحدة'),
(5039, 1045747920, 1045747935, 'SE', 'SWE', 'السويد'),
(5040, 1045747936, 1045747967, 'GB', 'GBR', 'المملكة المتحدة'),
(5041, 1045747968, 1045748223, 'SE', 'SWE', 'السويد'),
(5042, 1045748224, 1045748239, 'GB', 'GBR', 'المملكة المتحدة'),
(5043, 1045748240, 1045748287, 'SE', 'SWE', 'السويد'),
(5044, 1045748288, 1045748295, 'GB', 'GBR', 'المملكة المتحدة'),
(5045, 1045748296, 1045748303, 'SE', 'SWE', 'السويد'),
(5046, 1045748304, 1045748319, 'GB', 'GBR', 'المملكة المتحدة'),
(5047, 1045748320, 1045748351, 'SE', 'SWE', 'السويد'),
(5048, 1045748352, 1045748391, 'GB', 'GBR', 'المملكة المتحدة'),
(5049, 1045748392, 1045748395, 'SE', 'SWE', 'السويد'),
(5050, 1045748396, 1045748399, 'GB', 'GBR', 'المملكة المتحدة'),
(5051, 1045748400, 1045748407, 'SE', 'SWE', 'السويد'),
(5052, 1045748408, 1045748463, 'GB', 'GBR', 'المملكة المتحدة'),
(5053, 1045748464, 1045748479, 'SE', 'SWE', 'السويد'),
(5054, 1045748480, 1045749503, 'GB', 'GBR', 'المملكة المتحدة'),
(5055, 1045749504, 1045749759, 'SE', 'SWE', 'السويد'),
(5056, 1045749760, 1045757951, 'GB', 'GBR', 'المملكة المتحدة'),
(5057, 1045757952, 1045790719, 'LV', 'LVA', 'لاتفيا'),
(5058, 1045790720, 1045798911, 'FR', 'FRA', 'فرنسا'),
(5059, 1045798912, 1045889023, 'IT', 'ITA', 'إيطاليا'),
(5060, 1045889024, 1045921791, 'ES', 'ESP', 'إسبانيا'),
(5061, 1045921792, 1045954559, 'PL', 'POL', 'بولندا'),
(5062, 1045954560, 1045987327, 'BE', 'BEL', 'بلجيكا'),
(5063, 1045987328, 1046020095, 'SE', 'SWE', 'السويد'),
(5064, 1046020096, 1046028287, 'AM', 'ARM', 'أرمينيا'),
(5065, 1046028288, 1046036479, 'NO', 'NOR', 'النرويج'),
(5066, 1046036480, 1046052863, 'PL', 'POL', 'بولندا'),
(5067, 1046052864, 1046061055, 'GB', 'GBR', 'المملكة المتحدة'),
(5068, 1046061056, 1046069247, 'DE', 'DEU', 'ألمانيا'),
(5069, 1046069248, 1046085631, 'RU', 'RUS', 'الإتحاد الروسي'),
(5070, 1046085632, 1046150143, 'IL', 'ISR', 'إسرائيل'),
(5071, 1046150144, 1046150399, 'LR', 'LBR', 'ليبيريا'),
(5072, 1046150400, 1046151167, 'IL', 'ISR', 'إسرائيل'),
(5073, 1046151168, 1046216703, 'DE', 'DEU', 'ألمانيا'),
(5074, 1046216704, 1046225647, 'NO', 'NOR', 'النرويج'),
(5075, 1046225648, 1046225655, 'SE', 'SWE', 'السويد'),
(5076, 1046225656, 1046229111, 'NO', 'NOR', 'النرويج'),
(5077, 1046229112, 1046229119, 'SE', 'SWE', 'السويد'),
(5078, 1046229120, 1046282239, 'NO', 'NOR', 'النرويج'),
(5079, 1046282240, 1046289407, 'DE', 'DEU', 'ألمانيا'),
(5080, 1046289408, 1046290431, 'AG', 'ATG', 'انتيغوا وبربودا'),
(5081, 1046290432, 1046298623, 'PL', 'POL', 'بولندا'),
(5082, 1046298624, 1046299903, 'AT', 'AUT', 'النمسا'),
(5083, 1046299904, 1046300159, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5084, 1046300160, 1046300799, 'AT', 'AUT', 'النمسا'),
(5085, 1046300800, 1046300927, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5086, 1046300928, 1046302143, 'AT', 'AUT', 'النمسا'),
(5087, 1046302144, 1046302207, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5088, 1046302208, 1046302911, 'AT', 'AUT', 'النمسا'),
(5089, 1046302912, 1046302975, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5090, 1046302976, 1046305279, 'AT', 'AUT', 'النمسا'),
(5091, 1046305280, 1046305407, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5092, 1046305408, 1046305535, 'AT', 'AUT', 'النمسا'),
(5093, 1046305536, 1046305663, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5094, 1046305664, 1046305791, 'AT', 'AUT', 'النمسا'),
(5095, 1046305792, 1046306815, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5096, 1046306816, 1046308927, 'AT', 'AUT', 'النمسا'),
(5097, 1046308928, 1046309503, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5098, 1046309504, 1046309887, 'AT', 'AUT', 'النمسا'),
(5099, 1046309888, 1046310143, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5100, 1046310144, 1046310399, 'AT', 'AUT', 'النمسا'),
(5101, 1046310400, 1046311935, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(5102, 1046311936, 1046315007, 'AT', 'AUT', 'النمسا'),
(5103, 1046315008, 1046315519, 'FR', 'FRA', 'فرنسا'),
(5104, 1046315520, 1046316031, 'IT', 'ITA', 'إيطاليا'),
(5105, 1046316032, 1046316543, 'FR', 'FRA', 'فرنسا'),
(5106, 1046316544, 1046317055, 'DK', 'DNK', 'الدنيمارك'),
(5107, 1046317056, 1046317567, 'ES', 'ESP', 'إسبانيا'),
(5108, 1046317568, 1046317823, 'GB', 'GBR', 'المملكة المتحدة'),
(5109, 1046317824, 1046318335, 'NL', 'NLD', 'هولندا'),
(5110, 1046318336, 1046318591, 'GB', 'GBR', 'المملكة المتحدة'),
(5111, 1046318592, 1046320127, 'NL', 'NLD', 'هولندا'),
(5112, 1046320128, 1046321151, 'GB', 'GBR', 'المملكة المتحدة'),
(5113, 1046321152, 1046323199, 'NL', 'NLD', 'هولندا'),
(5114, 1046323200, 1046327151, 'ES', 'ESP', 'إسبانيا'),
(5115, 1046327152, 1046327155, 'FR', 'FRA', 'فرنسا'),
(5116, 1046327156, 1046331391, 'ES', 'ESP', 'إسبانيا'),
(5117, 1046331392, 1046331455, 'DE', 'DEU', 'ألمانيا'),
(5118, 1046331648, 1046331679, 'DE', 'DEU', 'ألمانيا'),
(5119, 1046331744, 1046331775, 'DE', 'DEU', 'ألمانيا'),
(5120, 1046331840, 1046331871, 'DE', 'DEU', 'ألمانيا'),
(5121, 1046331904, 1046332159, 'NL', 'NLD', 'هولندا'),
(5122, 1046332160, 1046332415, 'FR', 'FRA', 'فرنسا'),
(5123, 1046333440, 1046333695, 'DE', 'DEU', 'ألمانيا'),
(5124, 1046334720, 1046334975, 'DE', 'DEU', 'ألمانيا'),
(5125, 1046336224, 1046336255, 'DE', 'DEU', 'ألمانيا'),
(5126, 1046336512, 1046337023, 'DE', 'DEU', 'ألمانيا'),
(5127, 1046337536, 1046338047, 'DE', 'DEU', 'ألمانيا'),
(5128, 1046339840, 1046340095, 'FR', 'FRA', 'فرنسا'),
(5129, 1046340096, 1046341119, 'NL', 'NLD', 'هولندا'),
(5130, 1046341632, 1046342143, 'FR', 'FRA', 'فرنسا'),
(5131, 1046342144, 1046342719, 'NL', 'NLD', 'هولندا'),
(5132, 1046343424, 1046343935, 'NL', 'NLD', 'هولندا'),
(5133, 1046344960, 1046345215, 'DE', 'DEU', 'ألمانيا'),
(5134, 1046345328, 1046345727, 'DE', 'DEU', 'ألمانيا'),
(5135, 1046346112, 1046346239, 'DE', 'DEU', 'ألمانيا'),
(5136, 1046346304, 1046346367, 'DE', 'DEU', 'ألمانيا'),
(5137, 1046346512, 1046346559, 'DE', 'DEU', 'ألمانيا'),
(5138, 1046347776, 1046349839, 'IT', 'ITA', 'إيطاليا'),
(5139, 1046349840, 1046349847, 'FR', 'FRA', 'فرنسا'),
(5140, 1046349848, 1046352831, 'IT', 'ITA', 'إيطاليا'),
(5141, 1046352832, 1046352847, 'SM', 'SMR', 'سان مارينو'),
(5142, 1046352848, 1046366807, 'IT', 'ITA', 'إيطاليا'),
(5143, 1046366808, 1046366815, 'PL', 'POL', 'بولندا'),
(5144, 1046366816, 1046413311, 'IT', 'ITA', 'إيطاليا'),
(5145, 1046413312, 1046446079, 'SE', 'SWE', 'السويد'),
(5146, 1046446080, 1046479535, 'DE', 'DEU', 'ألمانيا'),
(5147, 1046479536, 1046479550, 'GB', 'GBR', 'المملكة المتحدة'),
(5148, 1046479551, 1046479687, 'DE', 'DEU', 'ألمانيا'),
(5149, 1046479688, 1046479695, 'GB', 'GBR', 'المملكة المتحدة'),
(5150, 1046479696, 1046479711, 'DE', 'DEU', 'ألمانيا'),
(5151, 1046479712, 1046479743, 'GB', 'GBR', 'المملكة المتحدة'),
(5152, 1046479744, 1046480475, 'DE', 'DEU', 'ألمانيا'),
(5153, 1046480476, 1046480479, 'GB', 'GBR', 'المملكة المتحدة'),
(5154, 1046480480, 1046480719, 'DE', 'DEU', 'ألمانيا'),
(5155, 1046480720, 1046480735, 'GB', 'GBR', 'المملكة المتحدة'),
(5156, 1046480736, 1046481327, 'DE', 'DEU', 'ألمانيا'),
(5157, 1046481328, 1046481375, 'GB', 'GBR', 'المملكة المتحدة'),
(5158, 1046481376, 1046481535, 'DE', 'DEU', 'ألمانيا'),
(5159, 1046481536, 1046481919, 'GB', 'GBR', 'المملكة المتحدة'),
(5160, 1046481920, 1046481963, 'DE', 'DEU', 'ألمانيا'),
(5161, 1046481964, 1046481967, 'GB', 'GBR', 'المملكة المتحدة'),
(5162, 1046481968, 1046482751, 'DE', 'DEU', 'ألمانيا'),
(5163, 1046482752, 1046482943, 'GB', 'GBR', 'المملكة المتحدة'),
(5164, 1046482944, 1046483231, 'DE', 'DEU', 'ألمانيا'),
(5165, 1046483232, 1046483471, 'GB', 'GBR', 'المملكة المتحدة'),
(5166, 1046483472, 1046483583, 'DE', 'DEU', 'ألمانيا'),
(5167, 1046483584, 1046483967, 'GB', 'GBR', 'المملكة المتحدة'),
(5168, 1046483968, 1046484351, 'DE', 'DEU', 'ألمانيا'),
(5169, 1046484352, 1046484479, 'GB', 'GBR', 'المملكة المتحدة'),
(5170, 1046484480, 1046484511, 'DE', 'DEU', 'ألمانيا'),
(5171, 1046484512, 1046484607, 'GB', 'GBR', 'المملكة المتحدة'),
(5172, 1046484608, 1046484623, 'DE', 'DEU', 'ألمانيا'),
(5173, 1046484624, 1046484991, 'GB', 'GBR', 'المملكة المتحدة'),
(5174, 1046484992, 1046485023, 'DE', 'DEU', 'ألمانيا'),
(5175, 1046485024, 1046485031, 'GB', 'GBR', 'المملكة المتحدة'),
(5176, 1046485032, 1046485127, 'DE', 'DEU', 'ألمانيا'),
(5177, 1046485128, 1046485135, 'GB', 'GBR', 'المملكة المتحدة'),
(5178, 1046485136, 1046485159, 'DE', 'DEU', 'ألمانيا'),
(5179, 1046485160, 1046485167, 'GB', 'GBR', 'المملكة المتحدة'),
(5180, 1046485168, 1046485279, 'DE', 'DEU', 'ألمانيا'),
(5181, 1046485280, 1046485287, 'GB', 'GBR', 'المملكة المتحدة'),
(5182, 1046485288, 1046485367, 'DE', 'DEU', 'ألمانيا'),
(5183, 1046485368, 1046485375, 'GB', 'GBR', 'المملكة المتحدة'),
(5184, 1046485376, 1046485495, 'DE', 'DEU', 'ألمانيا'),
(5185, 1046485496, 1046485543, 'GB', 'GBR', 'المملكة المتحدة'),
(5186, 1046485544, 1046485647, 'DE', 'DEU', 'ألمانيا'),
(5187, 1046485648, 1046485655, 'GB', 'GBR', 'المملكة المتحدة'),
(5188, 1046485656, 1046485759, 'DE', 'DEU', 'ألمانيا'),
(5189, 1046485760, 1046485791, 'GB', 'GBR', 'المملكة المتحدة'),
(5190, 1046485792, 1046485823, 'DE', 'DEU', 'ألمانيا'),
(5191, 1046485824, 1046485855, 'GB', 'GBR', 'المملكة المتحدة'),
(5192, 1046485856, 1046486055, 'DE', 'DEU', 'ألمانيا'),
(5193, 1046486056, 1046486063, 'GB', 'GBR', 'المملكة المتحدة'),
(5194, 1046486064, 1046486159, 'DE', 'DEU', 'ألمانيا'),
(5195, 1046486160, 1046486175, 'GB', 'GBR', 'المملكة المتحدة'),
(5196, 1046486176, 1046486183, 'DE', 'DEU', 'ألمانيا'),
(5197, 1046486184, 1046486191, 'GB', 'GBR', 'المملكة المتحدة'),
(5198, 1046486192, 1046486375, 'DE', 'DEU', 'ألمانيا'),
(5199, 1046486376, 1046486383, 'GB', 'GBR', 'المملكة المتحدة'),
(5200, 1046486384, 1046491391, 'DE', 'DEU', 'ألمانيا'),
(5201, 1046491392, 1046491399, 'GB', 'GBR', 'المملكة المتحدة'),
(5202, 1046491400, 1046491423, 'DE', 'DEU', 'ألمانيا'),
(5203, 1046491424, 1046491431, 'GB', 'GBR', 'المملكة المتحدة'),
(5204, 1046491432, 1046491743, 'DE', 'DEU', 'ألمانيا'),
(5205, 1046491744, 1046491775, 'GB', 'GBR', 'المملكة المتحدة'),
(5206, 1046491776, 1046491839, 'DE', 'DEU', 'ألمانيا'),
(5207, 1046491840, 1046492159, 'GB', 'GBR', 'المملكة المتحدة'),
(5208, 1046492160, 1046492319, 'DE', 'DEU', 'ألمانيا'),
(5209, 1046492320, 1046492327, 'GB', 'GBR', 'المملكة المتحدة'),
(5210, 1046492328, 1046492415, 'DE', 'DEU', 'ألمانيا'),
(5211, 1046492416, 1046492447, 'GB', 'GBR', 'المملكة المتحدة'),
(5212, 1046492448, 1046492503, 'DE', 'DEU', 'ألمانيا'),
(5213, 1046492504, 1046492511, 'GB', 'GBR', 'المملكة المتحدة'),
(5214, 1046492512, 1046492543, 'DE', 'DEU', 'ألمانيا'),
(5215, 1046492544, 1046492551, 'GB', 'GBR', 'المملكة المتحدة'),
(5216, 1046492552, 1046492655, 'DE', 'DEU', 'ألمانيا'),
(5217, 1046492656, 1046492663, 'GB', 'GBR', 'المملكة المتحدة'),
(5218, 1046492664, 1046492911, 'DE', 'DEU', 'ألمانيا'),
(5219, 1046492912, 1046492967, 'GB', 'GBR', 'المملكة المتحدة'),
(5220, 1046492968, 1046493071, 'DE', 'DEU', 'ألمانيا'),
(5221, 1046493072, 1046493087, 'GB', 'GBR', 'المملكة المتحدة'),
(5222, 1046493088, 1046493095, 'DE', 'DEU', 'ألمانيا'),
(5223, 1046493096, 1046493103, 'GB', 'GBR', 'المملكة المتحدة'),
(5224, 1046493104, 1046493391, 'DE', 'DEU', 'ألمانيا'),
(5225, 1046493392, 1046493471, 'GB', 'GBR', 'المملكة المتحدة'),
(5226, 1046493472, 1046493487, 'DE', 'DEU', 'ألمانيا'),
(5227, 1046493488, 1046493511, 'GB', 'GBR', 'المملكة المتحدة'),
(5228, 1046493512, 1046493519, 'DE', 'DEU', 'ألمانيا'),
(5229, 1046493520, 1046493535, 'GB', 'GBR', 'المملكة المتحدة'),
(5230, 1046493536, 1046493551, 'DE', 'DEU', 'ألمانيا'),
(5231, 1046493552, 1046493575, 'GB', 'GBR', 'المملكة المتحدة'),
(5232, 1046493576, 1046493583, 'DE', 'DEU', 'ألمانيا'),
(5233, 1046493584, 1046493591, 'GB', 'GBR', 'المملكة المتحدة'),
(5234, 1046493592, 1046493599, 'DE', 'DEU', 'ألمانيا'),
(5235, 1046493600, 1046493631, 'GB', 'GBR', 'المملكة المتحدة'),
(5236, 1046493632, 1046493639, 'DE', 'DEU', 'ألمانيا'),
(5237, 1046493640, 1046493695, 'GB', 'GBR', 'المملكة المتحدة'),
(5238, 1046493696, 1046493951, 'DE', 'DEU', 'ألمانيا'),
(5239, 1046493952, 1046493983, 'GB', 'GBR', 'المملكة المتحدة'),
(5240, 1046493984, 1046494031, 'DE', 'DEU', 'ألمانيا'),
(5241, 1046494032, 1046494039, 'GB', 'GBR', 'المملكة المتحدة'),
(5242, 1046494040, 1046494087, 'DE', 'DEU', 'ألمانيا'),
(5243, 1046494088, 1046494095, 'GB', 'GBR', 'المملكة المتحدة'),
(5244, 1046494096, 1046494303, 'DE', 'DEU', 'ألمانيا'),
(5245, 1046494304, 1046494311, 'GB', 'GBR', 'المملكة المتحدة'),
(5246, 1046494312, 1046494327, 'DE', 'DEU', 'ألمانيا'),
(5247, 1046494328, 1046494335, 'GB', 'GBR', 'المملكة المتحدة'),
(5248, 1046494336, 1046494607, 'DE', 'DEU', 'ألمانيا'),
(5249, 1046494608, 1046494615, 'GB', 'GBR', 'المملكة المتحدة'),
(5250, 1046494616, 1046494623, 'DE', 'DEU', 'ألمانيا'),
(5251, 1046494624, 1046494751, 'GB', 'GBR', 'المملكة المتحدة'),
(5252, 1046494752, 1046494767, 'DE', 'DEU', 'ألمانيا'),
(5253, 1046494768, 1046494775, 'GB', 'GBR', 'المملكة المتحدة'),
(5254, 1046494776, 1046494815, 'DE', 'DEU', 'ألمانيا'),
(5255, 1046494816, 1046494823, 'GB', 'GBR', 'المملكة المتحدة'),
(5256, 1046494824, 1046494831, 'DE', 'DEU', 'ألمانيا'),
(5257, 1046494832, 1046494839, 'GB', 'GBR', 'المملكة المتحدة'),
(5258, 1046494840, 1046494975, 'DE', 'DEU', 'ألمانيا'),
(5259, 1046494976, 1046495007, 'GB', 'GBR', 'المملكة المتحدة'),
(5260, 1046495008, 1046495063, 'DE', 'DEU', 'ألمانيا'),
(5261, 1046495064, 1046495071, 'GB', 'GBR', 'المملكة المتحدة'),
(5262, 1046495072, 1046495079, 'DE', 'DEU', 'ألمانيا'),
(5263, 1046495080, 1046495087, 'GB', 'GBR', 'المملكة المتحدة'),
(5264, 1046495088, 1046495103, 'DE', 'DEU', 'ألمانيا'),
(5265, 1046495104, 1046495127, 'GB', 'GBR', 'المملكة المتحدة'),
(5266, 1046495128, 1046495223, 'DE', 'DEU', 'ألمانيا'),
(5267, 1046495224, 1046495231, 'GB', 'GBR', 'المملكة المتحدة'),
(5268, 1046495232, 1046495351, 'DE', 'DEU', 'ألمانيا'),
(5269, 1046495352, 1046495359, 'GB', 'GBR', 'المملكة المتحدة'),
(5270, 1046495360, 1046495407, 'DE', 'DEU', 'ألمانيا'),
(5271, 1046495408, 1046495415, 'GB', 'GBR', 'المملكة المتحدة'),
(5272, 1046495416, 1046495439, 'DE', 'DEU', 'ألمانيا'),
(5273, 1046495440, 1046495447, 'GB', 'GBR', 'المملكة المتحدة'),
(5274, 1046495448, 1046495487, 'DE', 'DEU', 'ألمانيا'),
(5275, 1046495488, 1046495519, 'GB', 'GBR', 'المملكة المتحدة'),
(5276, 1046495520, 1046495527, 'DE', 'DEU', 'ألمانيا'),
(5277, 1046495528, 1046495535, 'GB', 'GBR', 'المملكة المتحدة'),
(5278, 1046495536, 1046495543, 'DE', 'DEU', 'ألمانيا'),
(5279, 1046495544, 1046495551, 'GB', 'GBR', 'المملكة المتحدة'),
(5280, 1046495552, 1046495567, 'DE', 'DEU', 'ألمانيا'),
(5281, 1046495568, 1046495575, 'GB', 'GBR', 'المملكة المتحدة'),
(5282, 1046495576, 1046495599, 'DE', 'DEU', 'ألمانيا'),
(5283, 1046495600, 1046495607, 'GB', 'GBR', 'المملكة المتحدة'),
(5284, 1046495608, 1046495631, 'DE', 'DEU', 'ألمانيا'),
(5285, 1046495632, 1046495639, 'GB', 'GBR', 'المملكة المتحدة'),
(5286, 1046495640, 1046495647, 'DE', 'DEU', 'ألمانيا'),
(5287, 1046495648, 1046495663, 'GB', 'GBR', 'المملكة المتحدة'),
(5288, 1046495664, 1046495703, 'DE', 'DEU', 'ألمانيا'),
(5289, 1046495704, 1046495719, 'GB', 'GBR', 'المملكة المتحدة'),
(5290, 1046495720, 1046495879, 'DE', 'DEU', 'ألمانيا'),
(5291, 1046495880, 1046495895, 'GB', 'GBR', 'المملكة المتحدة'),
(5292, 1046495896, 1046495999, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(5293, 1046496000, 1046496047, 'GB', 'GBR', 'المملكة المتحدة'),
(5294, 1046496048, 1046496127, 'DE', 'DEU', 'ألمانيا'),
(5295, 1046496128, 1046496135, 'GB', 'GBR', 'المملكة المتحدة'),
(5296, 1046496136, 1046496191, 'DE', 'DEU', 'ألمانيا'),
(5297, 1046496192, 1046496215, 'GB', 'GBR', 'المملكة المتحدة'),
(5298, 1046496216, 1046496231, 'DE', 'DEU', 'ألمانيا'),
(5299, 1046496232, 1046496239, 'GB', 'GBR', 'المملكة المتحدة'),
(5300, 1046496240, 1046496303, 'DE', 'DEU', 'ألمانيا'),
(5301, 1046496304, 1046496511, 'GB', 'GBR', 'المملكة المتحدة'),
(5302, 1046496512, 1046497463, 'DE', 'DEU', 'ألمانيا'),
(5303, 1046497464, 1046497471, 'GB', 'GBR', 'المملكة المتحدة'),
(5304, 1046497472, 1046497479, 'DE', 'DEU', 'ألمانيا'),
(5305, 1046497480, 1046497567, 'GB', 'GBR', 'المملكة المتحدة'),
(5306, 1046497568, 1046497639, 'DE', 'DEU', 'ألمانيا'),
(5307, 1046497640, 1046497647, 'GB', 'GBR', 'المملكة المتحدة'),
(5308, 1046497648, 1046497663, 'DE', 'DEU', 'ألمانيا'),
(5309, 1046497664, 1046497671, 'GB', 'GBR', 'المملكة المتحدة'),
(5310, 1046497672, 1046497719, 'DE', 'DEU', 'ألمانيا'),
(5311, 1046497720, 1046497727, 'GB', 'GBR', 'المملكة المتحدة'),
(5312, 1046497728, 1046497759, 'DE', 'DEU', 'ألمانيا'),
(5313, 1046497760, 1046497775, 'GB', 'GBR', 'المملكة المتحدة'),
(5314, 1046497776, 1046497975, 'DE', 'DEU', 'ألمانيا'),
(5315, 1046497976, 1046497983, 'GB', 'GBR', 'المملكة المتحدة'),
(5316, 1046497984, 1046498047, 'DE', 'DEU', 'ألمانيا'),
(5317, 1046498048, 1046498079, 'GB', 'GBR', 'المملكة المتحدة'),
(5318, 1046498080, 1046498103, 'DE', 'DEU', 'ألمانيا'),
(5319, 1046498104, 1046498111, 'GB', 'GBR', 'المملكة المتحدة'),
(5320, 1046498112, 1046498159, 'DE', 'DEU', 'ألمانيا'),
(5321, 1046498160, 1046498167, 'GB', 'GBR', 'المملكة المتحدة'),
(5322, 1046498168, 1046498175, 'DE', 'DEU', 'ألمانيا'),
(5323, 1046498176, 1046498183, 'GB', 'GBR', 'المملكة المتحدة'),
(5324, 1046498184, 1046498207, 'DE', 'DEU', 'ألمانيا'),
(5325, 1046498208, 1046498215, 'GB', 'GBR', 'المملكة المتحدة'),
(5326, 1046498216, 1046498239, 'DE', 'DEU', 'ألمانيا'),
(5327, 1046498240, 1046498255, 'GB', 'GBR', 'المملكة المتحدة'),
(5328, 1046498256, 1046498263, 'DE', 'DEU', 'ألمانيا'),
(5329, 1046498264, 1046498271, 'GB', 'GBR', 'المملكة المتحدة'),
(5330, 1046498272, 1046498279, 'DE', 'DEU', 'ألمانيا'),
(5331, 1046498280, 1046498295, 'GB', 'GBR', 'المملكة المتحدة'),
(5332, 1046498296, 1046498359, 'DE', 'DEU', 'ألمانيا'),
(5333, 1046498360, 1046498367, 'GB', 'GBR', 'المملكة المتحدة'),
(5334, 1046498368, 1046498455, 'DE', 'DEU', 'ألمانيا'),
(5335, 1046498456, 1046498591, 'GB', 'GBR', 'المملكة المتحدة'),
(5336, 1046498592, 1046498631, 'DE', 'DEU', 'ألمانيا'),
(5337, 1046498632, 1046498639, 'GB', 'GBR', 'المملكة المتحدة'),
(5338, 1046498640, 1046498655, 'DE', 'DEU', 'ألمانيا'),
(5339, 1046498656, 1046498663, 'GB', 'GBR', 'المملكة المتحدة'),
(5340, 1046498664, 1046498679, 'DE', 'DEU', 'ألمانيا'),
(5341, 1046498680, 1046498687, 'GB', 'GBR', 'المملكة المتحدة'),
(5342, 1046498688, 1046498719, 'DE', 'DEU', 'ألمانيا'),
(5343, 1046498720, 1046498727, 'GB', 'GBR', 'المملكة المتحدة'),
(5344, 1046498728, 1046498819, 'DE', 'DEU', 'ألمانيا'),
(5345, 1046498820, 1046499327, 'GB', 'GBR', 'المملكة المتحدة'),
(5346, 1046499328, 1046502655, 'DE', 'DEU', 'ألمانيا'),
(5347, 1046502656, 1046502719, 'GB', 'GBR', 'المملكة المتحدة'),
(5348, 1046502720, 1046502863, 'DE', 'DEU', 'ألمانيا'),
(5349, 1046502864, 1046502951, 'GB', 'GBR', 'المملكة المتحدة'),
(5350, 1046502952, 1046502967, 'DE', 'DEU', 'ألمانيا'),
(5351, 1046502968, 1046502975, 'GB', 'GBR', 'المملكة المتحدة'),
(5352, 1046502976, 1046503135, 'DE', 'DEU', 'ألمانيا'),
(5353, 1046503136, 1046503143, 'GB', 'GBR', 'المملكة المتحدة'),
(5354, 1046503144, 1046503167, 'DE', 'DEU', 'ألمانيا'),
(5355, 1046503168, 1046503207, 'GB', 'GBR', 'المملكة المتحدة'),
(5356, 1046503208, 1046503343, 'DE', 'DEU', 'ألمانيا'),
(5357, 1046503344, 1046503351, 'GB', 'GBR', 'المملكة المتحدة'),
(5358, 1046503352, 1046504415, 'DE', 'DEU', 'ألمانيا'),
(5359, 1046504416, 1046504487, 'GB', 'GBR', 'المملكة المتحدة'),
(5360, 1046504488, 1046504551, 'DE', 'DEU', 'ألمانيا'),
(5361, 1046504552, 1046504559, 'GB', 'GBR', 'المملكة المتحدة'),
(5362, 1046504560, 1046504599, 'DE', 'DEU', 'ألمانيا'),
(5363, 1046504600, 1046504615, 'GB', 'GBR', 'المملكة المتحدة'),
(5364, 1046504616, 1046504671, 'DE', 'DEU', 'ألمانيا'),
(5365, 1046504672, 1046504679, 'GB', 'GBR', 'المملكة المتحدة'),
(5366, 1046504680, 1046504703, 'DE', 'DEU', 'ألمانيا'),
(5367, 1046504704, 1046504735, 'GB', 'GBR', 'المملكة المتحدة'),
(5368, 1046504736, 1046504799, 'DE', 'DEU', 'ألمانيا'),
(5369, 1046504800, 1046504807, 'GB', 'GBR', 'المملكة المتحدة'),
(5370, 1046504808, 1046504871, 'DE', 'DEU', 'ألمانيا'),
(5371, 1046504872, 1046504879, 'GB', 'GBR', 'المملكة المتحدة'),
(5372, 1046504880, 1046504887, 'DE', 'DEU', 'ألمانيا'),
(5373, 1046504888, 1046504895, 'GB', 'GBR', 'المملكة المتحدة'),
(5374, 1046504896, 1046504919, 'DE', 'DEU', 'ألمانيا'),
(5375, 1046504920, 1046504927, 'GB', 'GBR', 'المملكة المتحدة'),
(5376, 1046504928, 1046504943, 'DE', 'DEU', 'ألمانيا'),
(5377, 1046504944, 1046504951, 'GB', 'GBR', 'المملكة المتحدة'),
(5378, 1046504952, 1046504959, 'DE', 'DEU', 'ألمانيا'),
(5379, 1046504960, 1046504999, 'GB', 'GBR', 'المملكة المتحدة'),
(5380, 1046505000, 1046505031, 'DE', 'DEU', 'ألمانيا'),
(5381, 1046505032, 1046505039, 'GB', 'GBR', 'المملكة المتحدة'),
(5382, 1046505040, 1046505055, 'DE', 'DEU', 'ألمانيا'),
(5383, 1046505056, 1046505063, 'GB', 'GBR', 'المملكة المتحدة'),
(5384, 1046505064, 1046505071, 'DE', 'DEU', 'ألمانيا'),
(5385, 1046505072, 1046505087, 'GB', 'GBR', 'المملكة المتحدة'),
(5386, 1046505088, 1046505159, 'DE', 'DEU', 'ألمانيا'),
(5387, 1046505160, 1046505167, 'GB', 'GBR', 'المملكة المتحدة'),
(5388, 1046505168, 1046505183, 'DE', 'DEU', 'ألمانيا'),
(5389, 1046505184, 1046505191, 'GB', 'GBR', 'المملكة المتحدة'),
(5390, 1046505192, 1046505215, 'DE', 'DEU', 'ألمانيا'),
(5391, 1046505216, 1046505247, 'GB', 'GBR', 'المملكة المتحدة'),
(5392, 1046505248, 1046505343, 'DE', 'DEU', 'ألمانيا'),
(5393, 1046505344, 1046505359, 'GB', 'GBR', 'المملكة المتحدة'),
(5394, 1046505360, 1046505415, 'DE', 'DEU', 'ألمانيا'),
(5395, 1046505416, 1046505423, 'GB', 'GBR', 'المملكة المتحدة'),
(5396, 1046505424, 1046505431, 'DE', 'DEU', 'ألمانيا'),
(5397, 1046505432, 1046505439, 'GB', 'GBR', 'المملكة المتحدة'),
(5398, 1046505440, 1046505463, 'DE', 'DEU', 'ألمانيا'),
(5399, 1046505464, 1046505511, 'GB', 'GBR', 'المملكة المتحدة'),
(5400, 1046505512, 1046505551, 'DE', 'DEU', 'ألمانيا'),
(5401, 1046505552, 1046505559, 'GB', 'GBR', 'المملكة المتحدة'),
(5402, 1046505560, 1046505583, 'DE', 'DEU', 'ألمانيا'),
(5403, 1046505584, 1046505591, 'GB', 'GBR', 'المملكة المتحدة'),
(5404, 1046505592, 1046505615, 'DE', 'DEU', 'ألمانيا'),
(5405, 1046505616, 1046505631, 'GB', 'GBR', 'المملكة المتحدة'),
(5406, 1046505632, 1046505663, 'DE', 'DEU', 'ألمانيا'),
(5407, 1046505664, 1046505671, 'GB', 'GBR', 'المملكة المتحدة'),
(5408, 1046505672, 1046505679, 'DE', 'DEU', 'ألمانيا'),
(5409, 1046505680, 1046505687, 'GB', 'GBR', 'المملكة المتحدة'),
(5410, 1046505688, 1046505695, 'DE', 'DEU', 'ألمانيا'),
(5411, 1046505696, 1046505703, 'GB', 'GBR', 'المملكة المتحدة'),
(5412, 1046505704, 1046505727, 'DE', 'DEU', 'ألمانيا'),
(5413, 1046505728, 1046505759, 'GB', 'GBR', 'المملكة المتحدة'),
(5414, 1046505760, 1046505807, 'DE', 'DEU', 'ألمانيا'),
(5415, 1046505808, 1046505823, 'GB', 'GBR', 'المملكة المتحدة'),
(5416, 1046505824, 1046505847, 'DE', 'DEU', 'ألمانيا'),
(5417, 1046505848, 1046505879, 'GB', 'GBR', 'المملكة المتحدة'),
(5418, 1046505880, 1046505895, 'DE', 'DEU', 'ألمانيا'),
(5419, 1046505896, 1046505903, 'GB', 'GBR', 'المملكة المتحدة'),
(5420, 1046505904, 1046505983, 'DE', 'DEU', 'ألمانيا'),
(5421, 1046505984, 1046506015, 'GB', 'GBR', 'المملكة المتحدة'),
(5422, 1046506016, 1046506039, 'DE', 'DEU', 'ألمانيا'),
(5423, 1046506040, 1046506047, 'GB', 'GBR', 'المملكة المتحدة'),
(5424, 1046506048, 1046506119, 'DE', 'DEU', 'ألمانيا'),
(5425, 1046506120, 1046506135, 'GB', 'GBR', 'المملكة المتحدة'),
(5426, 1046506136, 1046506239, 'DE', 'DEU', 'ألمانيا'),
(5427, 1046506240, 1046506271, 'GB', 'GBR', 'المملكة المتحدة'),
(5428, 1046506272, 1046506295, 'DE', 'DEU', 'ألمانيا'),
(5429, 1046506296, 1046506303, 'GB', 'GBR', 'المملكة المتحدة'),
(5430, 1046506304, 1046506327, 'DE', 'DEU', 'ألمانيا'),
(5431, 1046506328, 1046506343, 'GB', 'GBR', 'المملكة المتحدة'),
(5432, 1046506344, 1046506375, 'DE', 'DEU', 'ألمانيا'),
(5433, 1046506376, 1046506383, 'GB', 'GBR', 'المملكة المتحدة'),
(5434, 1046506384, 1046506391, 'DE', 'DEU', 'ألمانيا'),
(5435, 1046506392, 1046506407, 'GB', 'GBR', 'المملكة المتحدة'),
(5436, 1046506408, 1046506415, 'DE', 'DEU', 'ألمانيا'),
(5437, 1046506416, 1046506423, 'GB', 'GBR', 'المملكة المتحدة'),
(5438, 1046506424, 1046506439, 'DE', 'DEU', 'ألمانيا'),
(5439, 1046506440, 1046506447, 'GB', 'GBR', 'المملكة المتحدة'),
(5440, 1046506448, 1046506479, 'DE', 'DEU', 'ألمانيا'),
(5441, 1046506480, 1046506487, 'GB', 'GBR', 'المملكة المتحدة'),
(5442, 1046506488, 1046506495, 'DE', 'DEU', 'ألمانيا'),
(5443, 1046506496, 1046506535, 'GB', 'GBR', 'المملكة المتحدة'),
(5444, 1046506536, 1046506575, 'DE', 'DEU', 'ألمانيا'),
(5445, 1046506576, 1046506591, 'GB', 'GBR', 'المملكة المتحدة'),
(5446, 1046506592, 1046506599, 'DE', 'DEU', 'ألمانيا'),
(5447, 1046506600, 1046506607, 'GB', 'GBR', 'المملكة المتحدة'),
(5448, 1046506608, 1046506623, 'DE', 'DEU', 'ألمانيا'),
(5449, 1046506624, 1046506639, 'GB', 'GBR', 'المملكة المتحدة'),
(5450, 1046506640, 1046506647, 'DE', 'DEU', 'ألمانيا'),
(5451, 1046506648, 1046506655, 'GB', 'GBR', 'المملكة المتحدة'),
(5452, 1046506656, 1046506671, 'DE', 'DEU', 'ألمانيا'),
(5453, 1046506672, 1046506679, 'GB', 'GBR', 'المملكة المتحدة'),
(5454, 1046506680, 1046506687, 'DE', 'DEU', 'ألمانيا'),
(5455, 1046506688, 1046506695, 'GB', 'GBR', 'المملكة المتحدة'),
(5456, 1046506696, 1046506711, 'DE', 'DEU', 'ألمانيا'),
(5457, 1046506712, 1046506743, 'GB', 'GBR', 'المملكة المتحدة'),
(5458, 1046506744, 1046506751, 'DE', 'DEU', 'ألمانيا'),
(5459, 1046506752, 1046506783, 'GB', 'GBR', 'المملكة المتحدة'),
(5460, 1046506784, 1046506791, 'DE', 'DEU', 'ألمانيا'),
(5461, 1046506792, 1046506807, 'GB', 'GBR', 'المملكة المتحدة'),
(5462, 1046506808, 1046506823, 'DE', 'DEU', 'ألمانيا'),
(5463, 1046506824, 1046506839, 'GB', 'GBR', 'المملكة المتحدة'),
(5464, 1046506840, 1046506895, 'DE', 'DEU', 'ألمانيا'),
(5465, 1046506896, 1046506903, 'GB', 'GBR', 'المملكة المتحدة'),
(5466, 1046506904, 1046506927, 'DE', 'DEU', 'ألمانيا'),
(5467, 1046506928, 1046506935, 'GB', 'GBR', 'المملكة المتحدة'),
(5468, 1046506936, 1046506951, 'DE', 'DEU', 'ألمانيا'),
(5469, 1046506952, 1046506959, 'GB', 'GBR', 'المملكة المتحدة'),
(5470, 1046506960, 1046506991, 'DE', 'DEU', 'ألمانيا'),
(5471, 1046506992, 1046506999, 'GB', 'GBR', 'المملكة المتحدة'),
(5472, 1046507000, 1046507007, 'DE', 'DEU', 'ألمانيا'),
(5473, 1046507008, 1046507039, 'GB', 'GBR', 'المملكة المتحدة'),
(5474, 1046507040, 1046507047, 'DE', 'DEU', 'ألمانيا'),
(5475, 1046507048, 1046507055, 'GB', 'GBR', 'المملكة المتحدة'),
(5476, 1046507056, 1046507071, 'DE', 'DEU', 'ألمانيا'),
(5477, 1046507072, 1046507111, 'GB', 'GBR', 'المملكة المتحدة'),
(5478, 1046507112, 1046507143, 'DE', 'DEU', 'ألمانيا'),
(5479, 1046507144, 1046507151, 'GB', 'GBR', 'المملكة المتحدة'),
(5480, 1046507152, 1046507159, 'DE', 'DEU', 'ألمانيا'),
(5481, 1046507160, 1046507175, 'GB', 'GBR', 'المملكة المتحدة'),
(5482, 1046507176, 1046507199, 'DE', 'DEU', 'ألمانيا'),
(5483, 1046507200, 1046507207, 'GB', 'GBR', 'المملكة المتحدة'),
(5484, 1046507208, 1046507223, 'DE', 'DEU', 'ألمانيا'),
(5485, 1046507224, 1046507247, 'GB', 'GBR', 'المملكة المتحدة'),
(5486, 1046507248, 1046507263, 'DE', 'DEU', 'ألمانيا'),
(5487, 1046507264, 1046507519, 'GB', 'GBR', 'المملكة المتحدة'),
(5488, 1046507520, 1046511615, 'DE', 'DEU', 'ألمانيا'),
(5489, 1046511616, 1046511647, 'GB', 'GBR', 'المملكة المتحدة'),
(5490, 1046511648, 1046511695, 'DE', 'DEU', 'ألمانيا'),
(5491, 1046511696, 1046511711, 'GB', 'GBR', 'المملكة المتحدة'),
(5492, 1046511712, 1046511743, 'DE', 'DEU', 'ألمانيا'),
(5493, 1046511744, 1046511751, 'GB', 'GBR', 'المملكة المتحدة'),
(5494, 1046511752, 1046511759, 'DE', 'DEU', 'ألمانيا'),
(5495, 1046511760, 1046511815, 'GB', 'GBR', 'المملكة المتحدة'),
(5496, 1046511816, 1046511847, 'DE', 'DEU', 'ألمانيا'),
(5497, 1046511848, 1046511863, 'GB', 'GBR', 'المملكة المتحدة'),
(5498, 1046511864, 1046511871, 'DE', 'DEU', 'ألمانيا'),
(5499, 1046511872, 1046511903, 'GB', 'GBR', 'المملكة المتحدة'),
(5500, 1046511904, 1046511919, 'DE', 'DEU', 'ألمانيا'),
(5501, 1046511920, 1046511927, 'GB', 'GBR', 'المملكة المتحدة'),
(5502, 1046511928, 1046511935, 'DE', 'DEU', 'ألمانيا'),
(5503, 1046511936, 1046511967, 'GB', 'GBR', 'المملكة المتحدة'),
(5504, 1046511968, 1046511975, 'DE', 'DEU', 'ألمانيا'),
(5505, 1046511976, 1046511991, 'GB', 'GBR', 'المملكة المتحدة'),
(5506, 1046511992, 1046512007, 'DE', 'DEU', 'ألمانيا'),
(5507, 1046512008, 1046512015, 'GB', 'GBR', 'المملكة المتحدة'),
(5508, 1046512016, 1046512031, 'DE', 'DEU', 'ألمانيا'),
(5509, 1046512032, 1046512055, 'GB', 'GBR', 'المملكة المتحدة'),
(5510, 1046512056, 1046512063, 'DE', 'DEU', 'ألمانيا'),
(5511, 1046512064, 1046512095, 'GB', 'GBR', 'المملكة المتحدة'),
(5512, 1046512096, 1046512103, 'DE', 'DEU', 'ألمانيا'),
(5513, 1046512104, 1046512167, 'GB', 'GBR', 'المملكة المتحدة'),
(5514, 1046512168, 1046512175, 'DE', 'DEU', 'ألمانيا'),
(5515, 1046512176, 1046512199, 'GB', 'GBR', 'المملكة المتحدة'),
(5516, 1046512200, 1046512215, 'DE', 'DEU', 'ألمانيا'),
(5517, 1046512216, 1046512223, 'GB', 'GBR', 'المملكة المتحدة'),
(5518, 1046512224, 1046512231, 'DE', 'DEU', 'ألمانيا'),
(5519, 1046512232, 1046512271, 'GB', 'GBR', 'المملكة المتحدة'),
(5520, 1046512272, 1046512303, 'DE', 'DEU', 'ألمانيا'),
(5521, 1046512304, 1046512311, 'GB', 'GBR', 'المملكة المتحدة'),
(5522, 1046512312, 1046512327, 'DE', 'DEU', 'ألمانيا'),
(5523, 1046512328, 1046512335, 'GB', 'GBR', 'المملكة المتحدة'),
(5524, 1046512336, 1046512383, 'DE', 'DEU', 'ألمانيا'),
(5525, 1046512384, 1046512415, 'GB', 'GBR', 'المملكة المتحدة'),
(5526, 1046512416, 1046512447, 'DE', 'DEU', 'ألمانيا'),
(5527, 1046512448, 1046512455, 'GB', 'GBR', 'المملكة المتحدة'),
(5528, 1046512456, 1046512535, 'DE', 'DEU', 'ألمانيا'),
(5529, 1046512536, 1046512543, 'GB', 'GBR', 'المملكة المتحدة'),
(5530, 1046512544, 1046512551, 'DE', 'DEU', 'ألمانيا'),
(5531, 1046512552, 1046512567, 'GB', 'GBR', 'المملكة المتحدة'),
(5532, 1046512568, 1046512607, 'DE', 'DEU', 'ألمانيا'),
(5533, 1046512608, 1046512623, 'GB', 'GBR', 'المملكة المتحدة'),
(5534, 1046512624, 1046512631, 'DE', 'DEU', 'ألمانيا'),
(5535, 1046512632, 1046512671, 'GB', 'GBR', 'المملكة المتحدة'),
(5536, 1046512672, 1046512687, 'DE', 'DEU', 'ألمانيا'),
(5537, 1046512688, 1046512711, 'GB', 'GBR', 'المملكة المتحدة'),
(5538, 1046512712, 1046512727, 'DE', 'DEU', 'ألمانيا'),
(5539, 1046512728, 1046512735, 'GB', 'GBR', 'المملكة المتحدة'),
(5540, 1046512736, 1046512751, 'DE', 'DEU', 'ألمانيا'),
(5541, 1046512752, 1046512759, 'GB', 'GBR', 'المملكة المتحدة'),
(5542, 1046512760, 1046512847, 'DE', 'DEU', 'ألمانيا'),
(5543, 1046512848, 1046512879, 'GB', 'GBR', 'المملكة المتحدة'),
(5544, 1046512880, 1046512895, 'DE', 'DEU', 'ألمانيا'),
(5545, 1046512896, 1046512927, 'GB', 'GBR', 'المملكة المتحدة'),
(5546, 1046512928, 1046512943, 'DE', 'DEU', 'ألمانيا'),
(5547, 1046512944, 1046512967, 'GB', 'GBR', 'المملكة المتحدة'),
(5548, 1046512968, 1046512983, 'DE', 'DEU', 'ألمانيا'),
(5549, 1046512984, 1046512991, 'GB', 'GBR', 'المملكة المتحدة'),
(5550, 1046512992, 1046512999, 'DE', 'DEU', 'ألمانيا'),
(5551, 1046513000, 1046513007, 'GB', 'GBR', 'المملكة المتحدة'),
(5552, 1046513008, 1046513023, 'DE', 'DEU', 'ألمانيا'),
(5553, 1046513024, 1046513031, 'GB', 'GBR', 'المملكة المتحدة'),
(5554, 1046513032, 1046513039, 'DE', 'DEU', 'ألمانيا'),
(5555, 1046513040, 1046513047, 'GB', 'GBR', 'المملكة المتحدة'),
(5556, 1046513048, 1046513055, 'DE', 'DEU', 'ألمانيا'),
(5557, 1046513056, 1046513063, 'GB', 'GBR', 'المملكة المتحدة'),
(5558, 1046513064, 1046513079, 'DE', 'DEU', 'ألمانيا'),
(5559, 1046513080, 1046513111, 'GB', 'GBR', 'المملكة المتحدة'),
(5560, 1046513112, 1046513143, 'DE', 'DEU', 'ألمانيا'),
(5561, 1046513144, 1046513231, 'GB', 'GBR', 'المملكة المتحدة'),
(5562, 1046513232, 1046513239, 'DE', 'DEU', 'ألمانيا'),
(5563, 1046513240, 1046513247, 'GB', 'GBR', 'المملكة المتحدة'),
(5564, 1046513248, 1046513255, 'DE', 'DEU', 'ألمانيا'),
(5565, 1046513256, 1046513263, 'GB', 'GBR', 'المملكة المتحدة'),
(5566, 1046513264, 1046513295, 'DE', 'DEU', 'ألمانيا'),
(5567, 1046513296, 1046513303, 'GB', 'GBR', 'المملكة المتحدة'),
(5568, 1046513304, 1046513327, 'DE', 'DEU', 'ألمانيا'),
(5569, 1046513328, 1046513343, 'GB', 'GBR', 'المملكة المتحدة'),
(5570, 1046513344, 1046513391, 'DE', 'DEU', 'ألمانيا'),
(5571, 1046513392, 1046513439, 'GB', 'GBR', 'المملكة المتحدة'),
(5572, 1046513440, 1046513519, 'DE', 'DEU', 'ألمانيا'),
(5573, 1046513520, 1046513527, 'GB', 'GBR', 'المملكة المتحدة'),
(5574, 1046513528, 1046513551, 'DE', 'DEU', 'ألمانيا'),
(5575, 1046513552, 1046513559, 'GB', 'GBR', 'المملكة المتحدة'),
(5576, 1046513560, 1046513591, 'DE', 'DEU', 'ألمانيا'),
(5577, 1046513592, 1046513607, 'GB', 'GBR', 'المملكة المتحدة'),
(5578, 1046513608, 1046513615, 'DE', 'DEU', 'ألمانيا'),
(5579, 1046513616, 1046513623, 'GB', 'GBR', 'المملكة المتحدة'),
(5580, 1046513624, 1046513655, 'DE', 'DEU', 'ألمانيا'),
(5581, 1046513656, 1046513719, 'GB', 'GBR', 'المملكة المتحدة'),
(5582, 1046513720, 1046513735, 'DE', 'DEU', 'ألمانيا'),
(5583, 1046513736, 1046513759, 'GB', 'GBR', 'المملكة المتحدة'),
(5584, 1046513760, 1046513791, 'DE', 'DEU', 'ألمانيا'),
(5585, 1046513792, 1046513799, 'GB', 'GBR', 'المملكة المتحدة'),
(5586, 1046513800, 1046513831, 'DE', 'DEU', 'ألمانيا'),
(5587, 1046513832, 1046513847, 'GB', 'GBR', 'المملكة المتحدة'),
(5588, 1046513848, 1046513863, 'DE', 'DEU', 'ألمانيا'),
(5589, 1046513864, 1046513871, 'GB', 'GBR', 'المملكة المتحدة'),
(5590, 1046513872, 1046513879, 'DE', 'DEU', 'ألمانيا'),
(5591, 1046513880, 1046513887, 'GB', 'GBR', 'المملكة المتحدة'),
(5592, 1046513888, 1046513919, 'DE', 'DEU', 'ألمانيا'),
(5593, 1046513920, 1046514207, 'GB', 'GBR', 'المملكة المتحدة'),
(5594, 1046514208, 1046514223, 'DE', 'DEU', 'ألمانيا'),
(5595, 1046514224, 1046514239, 'GB', 'GBR', 'المملكة المتحدة'),
(5596, 1046514240, 1046514247, 'DE', 'DEU', 'ألمانيا'),
(5597, 1046514248, 1046514255, 'GB', 'GBR', 'المملكة المتحدة'),
(5598, 1046514256, 1046514279, 'DE', 'DEU', 'ألمانيا'),
(5599, 1046514280, 1046514287, 'GB', 'GBR', 'المملكة المتحدة'),
(5600, 1046514288, 1046514311, 'DE', 'DEU', 'ألمانيا'),
(5601, 1046514312, 1046514319, 'GB', 'GBR', 'المملكة المتحدة'),
(5602, 1046514320, 1046514335, 'DE', 'DEU', 'ألمانيا'),
(5603, 1046514336, 1046514343, 'GB', 'GBR', 'المملكة المتحدة'),
(5604, 1046514344, 1046514359, 'DE', 'DEU', 'ألمانيا'),
(5605, 1046514360, 1046514367, 'GB', 'GBR', 'المملكة المتحدة'),
(5606, 1046514368, 1046514383, 'DE', 'DEU', 'ألمانيا'),
(5607, 1046514384, 1046514391, 'GB', 'GBR', 'المملكة المتحدة'),
(5608, 1046514392, 1046514399, 'DE', 'DEU', 'ألمانيا'),
(5609, 1046514400, 1046514415, 'GB', 'GBR', 'المملكة المتحدة'),
(5610, 1046514416, 1046514423, 'DE', 'DEU', 'ألمانيا'),
(5611, 1046514424, 1046514687, 'GB', 'GBR', 'المملكة المتحدة'),
(5612, 1046514688, 1046516287, 'DE', 'DEU', 'ألمانيا'),
(5613, 1046516288, 1046516735, 'GB', 'GBR', 'المملكة المتحدة'),
(5614, 1046516736, 1046516743, 'DE', 'DEU', 'ألمانيا'),
(5615, 1046516744, 1046516991, 'GB', 'GBR', 'المملكة المتحدة'),
(5616, 1046516992, 1046517031, 'DE', 'DEU', 'ألمانيا'),
(5617, 1046517032, 1046517039, 'GB', 'GBR', 'المملكة المتحدة'),
(5618, 1046517040, 1046517087, 'DE', 'DEU', 'ألمانيا'),
(5619, 1046517088, 1046517799, 'GB', 'GBR', 'المملكة المتحدة'),
(5620, 1046517800, 1046517807, 'DE', 'DEU', 'ألمانيا'),
(5621, 1046517808, 1046517815, 'GB', 'GBR', 'المملكة المتحدة'),
(5622, 1046517816, 1046517831, 'DE', 'DEU', 'ألمانيا'),
(5623, 1046517832, 1046517839, 'GB', 'GBR', 'المملكة المتحدة'),
(5624, 1046517840, 1046517847, 'DE', 'DEU', 'ألمانيا'),
(5625, 1046517848, 1046517855, 'GB', 'GBR', 'المملكة المتحدة'),
(5626, 1046517856, 1046517863, 'DE', 'DEU', 'ألمانيا'),
(5627, 1046517864, 1046517871, 'GB', 'GBR', 'المملكة المتحدة'),
(5628, 1046517872, 1046517903, 'DE', 'DEU', 'ألمانيا'),
(5629, 1046517904, 1046517911, 'GB', 'GBR', 'المملكة المتحدة'),
(5630, 1046517912, 1046517927, 'DE', 'DEU', 'ألمانيا'),
(5631, 1046517928, 1046524159, 'GB', 'GBR', 'المملكة المتحدة'),
(5632, 1046524160, 1046524191, 'DE', 'DEU', 'ألمانيا'),
(5633, 1046524192, 1046524207, 'GB', 'GBR', 'المملكة المتحدة'),
(5634, 1046524208, 1046524215, 'DE', 'DEU', 'ألمانيا'),
(5635, 1046524216, 1046524287, 'GB', 'GBR', 'المملكة المتحدة'),
(5636, 1046524288, 1046524355, 'DE', 'DEU', 'ألمانيا'),
(5637, 1046524356, 1046524415, 'GB', 'GBR', 'المملكة المتحدة'),
(5638, 1046524416, 1046525183, 'DE', 'DEU', 'ألمانيا'),
(5639, 1046525184, 1046525215, 'GB', 'GBR', 'المملكة المتحدة'),
(5640, 1046525216, 1046525247, 'DE', 'DEU', 'ألمانيا'),
(5641, 1046525248, 1046525311, 'GB', 'GBR', 'المملكة المتحدة'),
(5642, 1046525312, 1046525343, 'DE', 'DEU', 'ألمانيا'),
(5643, 1046525344, 1046525439, 'GB', 'GBR', 'المملكة المتحدة'),
(5644, 1046525440, 1046525695, 'DE', 'DEU', 'ألمانيا'),
(5645, 1046525696, 1046526591, 'GB', 'GBR', 'المملكة المتحدة'),
(5646, 1046526592, 1046526599, 'DE', 'DEU', 'ألمانيا'),
(5647, 1046526600, 1046526631, 'GB', 'GBR', 'المملكة المتحدة'),
(5648, 1046526632, 1046526635, 'DE', 'DEU', 'ألمانيا'),
(5649, 1046526636, 1046526719, 'GB', 'GBR', 'المملكة المتحدة'),
(5650, 1046526720, 1046526991, 'DE', 'DEU', 'ألمانيا'),
(5651, 1046526992, 1046526995, 'GB', 'GBR', 'المملكة المتحدة'),
(5652, 1046526996, 1046527487, 'DE', 'DEU', 'ألمانيا'),
(5653, 1046527488, 1046527743, 'GB', 'GBR', 'المملكة المتحدة'),
(5654, 1046527744, 1046527999, 'DE', 'DEU', 'ألمانيا'),
(5655, 1046528000, 1046528255, 'GB', 'GBR', 'المملكة المتحدة'),
(5656, 1046528256, 1046528287, 'DE', 'DEU', 'ألمانيا'),
(5657, 1046528288, 1046528319, 'GB', 'GBR', 'المملكة المتحدة'),
(5658, 1046528320, 1046528335, 'DE', 'DEU', 'ألمانيا'),
(5659, 1046528336, 1046528391, 'GB', 'GBR', 'المملكة المتحدة'),
(5660, 1046528392, 1046528399, 'DE', 'DEU', 'ألمانيا'),
(5661, 1046528400, 1046528459, 'GB', 'GBR', 'المملكة المتحدة'),
(5662, 1046528460, 1046528463, 'DE', 'DEU', 'ألمانيا'),
(5663, 1046528464, 1046528471, 'GB', 'GBR', 'المملكة المتحدة'),
(5664, 1046528472, 1046528479, 'DE', 'DEU', 'ألمانيا'),
(5665, 1046528480, 1046528487, 'GB', 'GBR', 'المملكة المتحدة'),
(5666, 1046528488, 1046528495, 'DE', 'DEU', 'ألمانيا'),
(5667, 1046528496, 1046528519, 'GB', 'GBR', 'المملكة المتحدة'),
(5668, 1046528520, 1046528527, 'DE', 'DEU', 'ألمانيا'),
(5669, 1046528528, 1046528543, 'GB', 'GBR', 'المملكة المتحدة'),
(5670, 1046528544, 1046528559, 'DE', 'DEU', 'ألمانيا'),
(5671, 1046528560, 1046528575, 'GB', 'GBR', 'المملكة المتحدة'),
(5672, 1046528576, 1046528587, 'DE', 'DEU', 'ألمانيا'),
(5673, 1046528588, 1046528599, 'GB', 'GBR', 'المملكة المتحدة'),
(5674, 1046528600, 1046528603, 'DE', 'DEU', 'ألمانيا'),
(5675, 1046528604, 1046528607, 'GB', 'GBR', 'المملكة المتحدة'),
(5676, 1046528608, 1046528639, 'DE', 'DEU', 'ألمانيا'),
(5677, 1046528640, 1046528671, 'GB', 'GBR', 'المملكة المتحدة'),
(5678, 1046528672, 1046528703, 'DE', 'DEU', 'ألمانيا'),
(5679, 1046528704, 1046529279, 'GB', 'GBR', 'المملكة المتحدة'),
(5680, 1046529280, 1046529535, 'DE', 'DEU', 'ألمانيا'),
(5681, 1046529536, 1046530047, 'GB', 'GBR', 'المملكة المتحدة'),
(5682, 1046530048, 1046530687, 'DE', 'DEU', 'ألمانيا'),
(5683, 1046530688, 1046530815, 'GB', 'GBR', 'المملكة المتحدة'),
(5684, 1046530816, 1046530879, 'DE', 'DEU', 'ألمانيا'),
(5685, 1046530880, 1046530943, 'GB', 'GBR', 'المملكة المتحدة'),
(5686, 1046530944, 1046530947, 'DE', 'DEU', 'ألمانيا'),
(5687, 1046530948, 1046530967, 'GB', 'GBR', 'المملكة المتحدة'),
(5688, 1046530968, 1046530975, 'DE', 'DEU', 'ألمانيا'),
(5689, 1046530976, 1046531007, 'GB', 'GBR', 'المملكة المتحدة'),
(5690, 1046531008, 1046531087, 'DE', 'DEU', 'ألمانيا'),
(5691, 1046531088, 1046531095, 'GB', 'GBR', 'المملكة المتحدة'),
(5692, 1046531096, 1046531127, 'DE', 'DEU', 'ألمانيا'),
(5693, 1046531128, 1046531839, 'GB', 'GBR', 'المملكة المتحدة'),
(5694, 1046531840, 1046532095, 'DE', 'DEU', 'ألمانيا'),
(5695, 1046532096, 1046534015, 'GB', 'GBR', 'المملكة المتحدة'),
(5696, 1046534016, 1046534047, 'DE', 'DEU', 'ألمانيا'),
(5697, 1046534048, 1046534143, 'GB', 'GBR', 'المملكة المتحدة'),
(5698, 1046534144, 1046534655, 'DE', 'DEU', 'ألمانيا'),
(5699, 1046534656, 1046534911, 'GB', 'GBR', 'المملكة المتحدة'),
(5700, 1046534912, 1046535167, 'DE', 'DEU', 'ألمانيا'),
(5701, 1046535168, 1046535295, 'GB', 'GBR', 'المملكة المتحدة'),
(5702, 1046535296, 1046535311, 'DE', 'DEU', 'ألمانيا'),
(5703, 1046535312, 1046535359, 'GB', 'GBR', 'المملكة المتحدة'),
(5704, 1046535360, 1046535423, 'DE', 'DEU', 'ألمانيا'),
(5705, 1046535424, 1046535487, 'GB', 'GBR', 'المملكة المتحدة'),
(5706, 1046535488, 1046535615, 'DE', 'DEU', 'ألمانيا'),
(5707, 1046535616, 1046535619, 'GB', 'GBR', 'المملكة المتحدة'),
(5708, 1046535620, 1046535623, 'DE', 'DEU', 'ألمانيا'),
(5709, 1046535624, 1046535631, 'GB', 'GBR', 'المملكة المتحدة'),
(5710, 1046535632, 1046535935, 'DE', 'DEU', 'ألمانيا'),
(5711, 1046535936, 1046536023, 'GB', 'GBR', 'المملكة المتحدة'),
(5712, 1046536024, 1046536039, 'DE', 'DEU', 'ألمانيا'),
(5713, 1046536040, 1046536063, 'GB', 'GBR', 'المملكة المتحدة'),
(5714, 1046536064, 1046536151, 'DE', 'DEU', 'ألمانيا'),
(5715, 1046536152, 1046536159, 'GB', 'GBR', 'المملكة المتحدة'),
(5716, 1046536160, 1046536167, 'DE', 'DEU', 'ألمانيا'),
(5717, 1046536168, 1046536187, 'GB', 'GBR', 'المملكة المتحدة'),
(5718, 1046536188, 1046536199, 'DE', 'DEU', 'ألمانيا'),
(5719, 1046536200, 1046536211, 'GB', 'GBR', 'المملكة المتحدة'),
(5720, 1046536212, 1046536215, 'DE', 'DEU', 'ألمانيا'),
(5721, 1046536216, 1046536255, 'GB', 'GBR', 'المملكة المتحدة'),
(5722, 1046536256, 1046536271, 'DE', 'DEU', 'ألمانيا'),
(5723, 1046536272, 1046536279, 'GB', 'GBR', 'المملكة المتحدة'),
(5724, 1046536280, 1046536283, 'DE', 'DEU', 'ألمانيا'),
(5725, 1046536284, 1046536287, 'GB', 'GBR', 'المملكة المتحدة'),
(5726, 1046536288, 1046536295, 'DE', 'DEU', 'ألمانيا'),
(5727, 1046536296, 1046536319, 'GB', 'GBR', 'المملكة المتحدة'),
(5728, 1046536320, 1046536351, 'DE', 'DEU', 'ألمانيا'),
(5729, 1046536352, 1046536423, 'GB', 'GBR', 'المملكة المتحدة'),
(5730, 1046536424, 1046536431, 'DE', 'DEU', 'ألمانيا'),
(5731, 1046536432, 1046536607, 'GB', 'GBR', 'المملكة المتحدة'),
(5732, 1046536608, 1046536667, 'DE', 'DEU', 'ألمانيا'),
(5733, 1046536668, 1046536703, 'GB', 'GBR', 'المملكة المتحدة'),
(5734, 1046536704, 1046537023, 'DE', 'DEU', 'ألمانيا'),
(5735, 1046537024, 1046537055, 'GB', 'GBR', 'المملكة المتحدة'),
(5736, 1046537056, 1046537071, 'DE', 'DEU', 'ألمانيا'),
(5737, 1046537072, 1046537087, 'GB', 'GBR', 'المملكة المتحدة'),
(5738, 1046537088, 1046537151, 'DE', 'DEU', 'ألمانيا'),
(5739, 1046537152, 1046537215, 'GB', 'GBR', 'المملكة المتحدة'),
(5740, 1046537216, 1046537983, 'DE', 'DEU', 'ألمانيا'),
(5741, 1046537984, 1046538431, 'GB', 'GBR', 'المملكة المتحدة'),
(5742, 1046538432, 1046538447, 'DE', 'DEU', 'ألمانيا'),
(5743, 1046538448, 1046538463, 'GB', 'GBR', 'المملكة المتحدة'),
(5744, 1046538464, 1046538495, 'DE', 'DEU', 'ألمانيا'),
(5745, 1046538496, 1046538751, 'GB', 'GBR', 'المملكة المتحدة'),
(5746, 1046538752, 1046539519, 'DE', 'DEU', 'ألمانيا'),
(5747, 1046539520, 1046540031, 'GB', 'GBR', 'المملكة المتحدة'),
(5748, 1046540032, 1046540287, 'DE', 'DEU', 'ألمانيا'),
(5749, 1046540288, 1046540543, 'GB', 'GBR', 'المملكة المتحدة'),
(5750, 1046540544, 1046541055, 'DE', 'DEU', 'ألمانيا'),
(5751, 1046541056, 1046541311, 'GB', 'GBR', 'المملكة المتحدة'),
(5752, 1046541312, 1046541439, 'DE', 'DEU', 'ألمانيا'),
(5753, 1046541440, 1046541503, 'GB', 'GBR', 'المملكة المتحدة'),
(5754, 1046541504, 1046541567, 'DE', 'DEU', 'ألمانيا'),
(5755, 1046541568, 1046541631, 'GB', 'GBR', 'المملكة المتحدة'),
(5756, 1046541632, 1046541695, 'DE', 'DEU', 'ألمانيا'),
(5757, 1046541696, 1046541727, 'GB', 'GBR', 'المملكة المتحدة'),
(5758, 1046541728, 1046541759, 'DE', 'DEU', 'ألمانيا'),
(5759, 1046541760, 1046541767, 'GB', 'GBR', 'المملكة المتحدة'),
(5760, 1046541768, 1046541783, 'DE', 'DEU', 'ألمانيا'),
(5761, 1046541784, 1046541807, 'GB', 'GBR', 'المملكة المتحدة'),
(5762, 1046541808, 1046542591, 'DE', 'DEU', 'ألمانيا'),
(5763, 1046542592, 1046542847, 'GB', 'GBR', 'المملكة المتحدة'),
(5764, 1046542848, 1046543103, 'DE', 'DEU', 'ألمانيا'),
(5765, 1046543104, 1046543263, 'GB', 'GBR', 'المملكة المتحدة'),
(5766, 1046543264, 1046543295, 'DE', 'DEU', 'ألمانيا'),
(5767, 1046543296, 1046543327, 'GB', 'GBR', 'المملكة المتحدة'),
(5768, 1046543328, 1046543351, 'DE', 'DEU', 'ألمانيا'),
(5769, 1046543352, 1046543359, 'GB', 'GBR', 'المملكة المتحدة'),
(5770, 1046543360, 1046543615, 'DE', 'DEU', 'ألمانيا'),
(5771, 1046543616, 1046544127, 'GB', 'GBR', 'المملكة المتحدة'),
(5772, 1046544128, 1046544383, 'DE', 'DEU', 'ألمانيا'),
(5773, 1046544384, 1046560767, 'IT', 'ITA', 'إيطاليا'),
(5774, 1046560768, 1046585343, 'ES', 'ESP', 'إسبانيا'),
(5775, 1046585344, 1046609919, 'NO', 'NOR', 'النرويج'),
(5776, 1046609920, 1046675455, 'IT', 'ITA', 'إيطاليا'),
(5777, 1046675456, 1046708223, 'ES', 'ESP', 'إسبانيا'),
(5778, 1046708224, 1046740991, 'AT', 'AUT', 'النمسا'),
(5779, 1046740992, 1046757375, 'NL', 'NLD', 'هولندا'),
(5780, 1046757376, 1046765567, 'IT', 'ITA', 'إيطاليا'),
(5781, 1046765568, 1046773759, 'ES', 'ESP', 'إسبانيا'),
(5782, 1046773760, 1046781951, 'FR', 'FRA', 'فرنسا'),
(5783, 1046781952, 1046798335, 'GB', 'GBR', 'المملكة المتحدة'),
(5784, 1046798336, 1046806527, 'HU', 'HUN', 'هنغاريا'),
(5785, 1046806528, 1046814719, 'IT', 'ITA', 'إيطاليا'),
(5786, 1046814720, 1046822911, 'SE', 'SWE', 'السويد'),
(5787, 1046822912, 1046839295, 'IT', 'ITA', 'إيطاليا'),
(5788, 1046847488, 1046855679, 'ES', 'ESP', 'إسبانيا'),
(5789, 1046855680, 1046872063, 'NO', 'NOR', 'النرويج'),
(5790, 1046872064, 1046872583, 'BE', 'BEL', 'بلجيكا'),
(5791, 1046872608, 1046872615, 'BE', 'BEL', 'بلجيكا'),
(5792, 1046872656, 1046872671, 'BE', 'BEL', 'بلجيكا'),
(5793, 1046872976, 1046872999, 'BE', 'BEL', 'بلجيكا'),
(5794, 1046873088, 1046873279, 'BE', 'BEL', 'بلجيكا'),
(5795, 1046873600, 1046878463, 'BE', 'BEL', 'بلجيكا'),
(5796, 1046879256, 1046879263, 'BE', 'BEL', 'بلجيكا'),
(5797, 1046879272, 1046879311, 'BE', 'BEL', 'بلجيكا'),
(5798, 1046879328, 1046879495, 'BE', 'BEL', 'بلجيكا'),
(5799, 1046879504, 1046879511, 'BE', 'BEL', 'بلجيكا'),
(5800, 1046879544, 1046879551, 'BE', 'BEL', 'بلجيكا'),
(5801, 1046879592, 1046879623, 'BE', 'BEL', 'بلجيكا'),
(5802, 1046879648, 1046879655, 'BE', 'BEL', 'بلجيكا'),
(5803, 1046879688, 1046879711, 'BE', 'BEL', 'بلجيكا'),
(5804, 1046879720, 1046879735, 'BE', 'BEL', 'بلجيكا'),
(5805, 1046879776, 1046879791, 'BE', 'BEL', 'بلجيكا'),
(5806, 1046879808, 1046879831, 'BE', 'BEL', 'بلجيكا'),
(5807, 1046879840, 1046879847, 'BE', 'BEL', 'بلجيكا'),
(5808, 1046879896, 1046879911, 'BE', 'BEL', 'بلجيكا'),
(5809, 1046879944, 1046879959, 'BE', 'BEL', 'بلجيكا'),
(5810, 1046879968, 1046880127, 'BE', 'BEL', 'بلجيكا'),
(5811, 1046880136, 1046880143, 'BE', 'BEL', 'بلجيكا'),
(5812, 1046880152, 1046880191, 'BE', 'BEL', 'بلجيكا'),
(5813, 1046880256, 1046880511, 'BE', 'BEL', 'بلجيكا'),
(5814, 1046880520, 1046880527, 'BE', 'BEL', 'بلجيكا'),
(5815, 1046880560, 1046880567, 'RO', 'ROM', 'رومانيا'),
(5816, 1046880592, 1046880615, 'BE', 'BEL', 'بلجيكا'),
(5817, 1046880640, 1046880671, 'BE', 'BEL', 'بلجيكا'),
(5818, 1046880736, 1046880759, 'BE', 'BEL', 'بلجيكا'),
(5819, 1046880904, 1046880911, 'BE', 'BEL', 'بلجيكا'),
(5820, 1046880920, 1046880935, 'BE', 'BEL', 'بلجيكا'),
(5821, 1046880984, 1046881039, 'BE', 'BEL', 'بلجيكا'),
(5822, 1046881056, 1046881071, 'BE', 'BEL', 'بلجيكا'),
(5823, 1046881080, 1046881087, 'BE', 'BEL', 'بلجيكا'),
(5824, 1046881112, 1046881127, 'BE', 'BEL', 'بلجيكا'),
(5825, 1046881136, 1046881239, 'BE', 'BEL', 'بلجيكا'),
(5826, 1046881280, 1046882047, 'BE', 'BEL', 'بلجيكا'),
(5827, 1046882304, 1046884383, 'BE', 'BEL', 'بلجيكا'),
(5828, 1046885376, 1046888447, 'BE', 'BEL', 'بلجيكا'),
(5829, 1046888448, 1046895103, 'GB', 'GBR', 'المملكة المتحدة'),
(5830, 1046896384, 1046897663, 'GB', 'GBR', 'المملكة المتحدة'),
(5831, 1046897664, 1046898431, 'BE', 'BEL', 'بلجيكا'),
(5832, 1046898688, 1046898943, 'BE', 'BEL', 'بلجيكا'),
(5833, 1046899168, 1046904831, 'BE', 'BEL', 'بلجيكا'),
(5834, 1046904832, 1046937599, 'RU', 'RUS', 'الإتحاد الروسي'),
(5835, 1046937600, 1047003135, 'GR', 'GRC', 'اليونان'),
(5836, 1047003136, 1047068671, 'DE', 'DEU', 'ألمانيا'),
(5837, 1047068672, 1047085055, 'RU', 'RUS', 'الإتحاد الروسي'),
(5838, 1047085056, 1047101439, 'GB', 'GBR', 'المملكة المتحدة'),
(5839, 1047101440, 1047109631, 'RU', 'RUS', 'الإتحاد الروسي'),
(5840, 1047109632, 1047117823, 'GB', 'GBR', 'المملكة المتحدة'),
(5841, 1047117824, 1047134207, 'NL', 'NLD', 'هولندا'),
(5842, 1047134208, 1047150591, 'FI', 'FIN', 'فنلندا'),
(5843, 1047150592, 1047158783, 'FR', 'FRA', 'فرنسا'),
(5844, 1047158784, 1047166975, 'RU', 'RUS', 'الإتحاد الروسي'),
(5845, 1047166976, 1047199743, 'FR', 'FRA', 'فرنسا'),
(5846, 1047199744, 1047265279, 'DK', 'DNK', 'الدنيمارك'),
(5847, 1047265280, 1047273471, 'NL', 'NLD', 'هولندا'),
(5848, 1047273472, 1047281663, 'DE', 'DEU', 'ألمانيا'),
(5849, 1047281664, 1047289855, 'TR', 'TUR', 'تركيا'),
(5850, 1047289856, 1047290111, 'RS', 'SRB', 'صربيا'),
(5851, 1047290112, 1047290879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5852, 1047290880, 1047291647, 'RS', 'SRB', 'صربيا'),
(5853, 1047291648, 1047291903, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5854, 1047291904, 1047292927, 'RS', 'SRB', 'صربيا'),
(5855, 1047292928, 1047293423, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5856, 1047293424, 1047293431, 'RS', 'SRB', 'صربيا'),
(5857, 1047293432, 1047293695, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5858, 1047293696, 1047293951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5859, 1047293952, 1047294719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5860, 1047294720, 1047294735, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5861, 1047294736, 1047295247, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5862, 1047295248, 1047295263, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5863, 1047295264, 1047295279, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5864, 1047295280, 1047295295, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5865, 1047295296, 1047295327, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5866, 1047295328, 1047295343, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5867, 1047295344, 1047295399, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5868, 1047295400, 1047295415, 'RS', 'SRB', 'صربيا'),
(5869, 1047295416, 1047295487, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5870, 1047295488, 1047295744, 'RS', 'SRB', 'صربيا'),
(5871, 1047295745, 1047295999, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5872, 1047296000, 1047297023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5873, 1047297024, 1047297567, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5874, 1047297568, 1047297599, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5875, 1047297600, 1047298047, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(5876, 1047298048, 1047300095, 'CH', 'CHE', 'سويسرا'),
(5877, 1047300096, 1047300415, 'GB', 'GBR', 'المملكة المتحدة'),
(5878, 1047300416, 1047300479, 'CH', 'CHE', 'سويسرا'),
(5879, 1047300480, 1047300495, 'FR', 'FRA', 'فرنسا'),
(5880, 1047300496, 1047300607, 'CH', 'CHE', 'سويسرا'),
(5881, 1047300608, 1047300639, 'GB', 'GBR', 'المملكة المتحدة'),
(5882, 1047300640, 1047302143, 'CH', 'CHE', 'سويسرا'),
(5883, 1047302144, 1047302159, 'US', 'USA', 'الولايات المتحدة'),
(5884, 1047302160, 1047302175, 'GB', 'GBR', 'المملكة المتحدة'),
(5885, 1047302176, 1047302191, 'AU', 'AUS', 'أستراليا'),
(5886, 1047302192, 1047306239, 'CH', 'CHE', 'سويسرا'),
(5887, 1047306240, 1047314431, 'PL', 'POL', 'بولندا'),
(5888, 1047314432, 1047322623, 'SE', 'SWE', 'السويد'),
(5889, 1047322624, 1047330815, 'IT', 'ITA', 'إيطاليا'),
(5890, 1047330816, 1047339007, 'RU', 'RUS', 'الإتحاد الروسي'),
(5891, 1047339008, 1047340431, 'SE', 'SWE', 'السويد'),
(5892, 1047340432, 1047340439, 'NO', 'NOR', 'النرويج'),
(5893, 1047340440, 1047340799, 'SE', 'SWE', 'السويد'),
(5894, 1047340800, 1047341055, 'NO', 'NOR', 'النرويج'),
(5895, 1047341056, 1047343871, 'SE', 'SWE', 'السويد'),
(5896, 1047343872, 1047344127, 'NO', 'NOR', 'النرويج'),
(5897, 1047344128, 1047347199, 'SE', 'SWE', 'السويد'),
(5898, 1047347200, 1047363583, 'DE', 'DEU', 'ألمانيا'),
(5899, 1047363584, 1047371775, 'CZ', 'CZE', 'التشيك'),
(5900, 1047371776, 1047379967, 'RU', 'RUS', 'الإتحاد الروسي'),
(5901, 1047379968, 1047396351, 'NL', 'NLD', 'هولندا'),
(5902, 1047396352, 1047461887, 'IT', 'ITA', 'إيطاليا'),
(5903, 1047461888, 1047494655, 'DE', 'DEU', 'ألمانيا'),
(5904, 1047494656, 1047527423, 'PL', 'POL', 'بولندا'),
(5905, 1047527424, 1047535615, 'BE', 'BEL', 'بلجيكا'),
(5906, 1047535616, 1047551999, 'DE', 'DEU', 'ألمانيا'),
(5907, 1047552000, 1047560191, 'RU', 'RUS', 'الإتحاد الروسي'),
(5908, 1047560192, 1047561367, 'DE', 'DEU', 'ألمانيا'),
(5909, 1047561368, 1047561371, 'CN', 'CHN', 'الصين'),
(5910, 1047561372, 1047561375, 'AU', 'AUS', 'أستراليا'),
(5911, 1047561376, 1047561747, 'DE', 'DEU', 'ألمانيا'),
(5912, 1047561748, 1047561751, 'ES', 'ESP', 'إسبانيا'),
(5913, 1047561752, 1047561887, 'DE', 'DEU', 'ألمانيا'),
(5914, 1047561888, 1047561891, 'US', 'USA', 'الولايات المتحدة'),
(5915, 1047561892, 1047563227, 'DE', 'DEU', 'ألمانيا'),
(5916, 1047563228, 1047563231, 'CH', 'CHE', 'سويسرا'),
(5917, 1047563232, 1047563303, 'DE', 'DEU', 'ألمانيا'),
(5918, 1047563304, 1047563307, 'CH', 'CHE', 'سويسرا'),
(5919, 1047563308, 1047563403, 'DE', 'DEU', 'ألمانيا'),
(5920, 1047563404, 1047563407, 'NL', 'NLD', 'هولندا'),
(5921, 1047563408, 1047563411, 'CH', 'CHE', 'سويسرا'),
(5922, 1047563412, 1047563415, 'DE', 'DEU', 'ألمانيا'),
(5923, 1047563416, 1047563419, 'BE', 'BEL', 'بلجيكا'),
(5924, 1047563420, 1047563431, 'DE', 'DEU', 'ألمانيا'),
(5925, 1047563432, 1047563435, 'CH', 'CHE', 'سويسرا'),
(5926, 1047563436, 1047563443, 'DE', 'DEU', 'ألمانيا'),
(5927, 1047563444, 1047563447, 'CH', 'CHE', 'سويسرا'),
(5928, 1047563448, 1047563451, 'DE', 'DEU', 'ألمانيا'),
(5929, 1047563452, 1047563455, 'NL', 'NLD', 'هولندا'),
(5930, 1047563456, 1047563467, 'DE', 'DEU', 'ألمانيا'),
(5931, 1047563468, 1047563471, 'CH', 'CHE', 'سويسرا'),
(5932, 1047563472, 1047563727, 'DE', 'DEU', 'ألمانيا'),
(5933, 1047563728, 1047563731, 'AU', 'AUS', 'أستراليا'),
(5934, 1047563732, 1047566363, 'DE', 'DEU', 'ألمانيا'),
(5935, 1047566364, 1047566367, 'CH', 'CHE', 'سويسرا'),
(5936, 1047566368, 1047566407, 'DE', 'DEU', 'ألمانيا'),
(5937, 1047566408, 1047566415, 'CH', 'CHE', 'سويسرا'),
(5938, 1047566416, 1047566443, 'DE', 'DEU', 'ألمانيا'),
(5939, 1047566444, 1047566447, 'AT', 'AUT', 'النمسا'),
(5940, 1047566448, 1047566455, 'DE', 'DEU', 'ألمانيا'),
(5941, 1047566456, 1047566459, 'CH', 'CHE', 'سويسرا'),
(5942, 1047566460, 1047566475, 'DE', 'DEU', 'ألمانيا'),
(5943, 1047566476, 1047566479, 'CH', 'CHE', 'سويسرا'),
(5944, 1047566480, 1047566507, 'DE', 'DEU', 'ألمانيا'),
(5945, 1047566508, 1047566511, 'CH', 'CHE', 'سويسرا'),
(5946, 1047566512, 1047566535, 'DE', 'DEU', 'ألمانيا'),
(5947, 1047566536, 1047566539, 'CH', 'CHE', 'سويسرا'),
(5948, 1047566540, 1047566559, 'DE', 'DEU', 'ألمانيا'),
(5949, 1047566560, 1047566563, 'CH', 'CHE', 'سويسرا'),
(5950, 1047566564, 1047566847, 'DE', 'DEU', 'ألمانيا'),
(5951, 1047566848, 1047566851, 'AT', 'AUT', 'النمسا'),
(5952, 1047566852, 1047566867, 'DE', 'DEU', 'ألمانيا'),
(5953, 1047566868, 1047566871, 'AT', 'AUT', 'النمسا'),
(5954, 1047566872, 1047566879, 'CH', 'CHE', 'سويسرا'),
(5955, 1047566880, 1047566891, 'DE', 'DEU', 'ألمانيا'),
(5956, 1047566892, 1047566903, 'CH', 'CHE', 'سويسرا'),
(5957, 1047566904, 1047566963, 'DE', 'DEU', 'ألمانيا'),
(5958, 1047566964, 1047566967, 'AT', 'AUT', 'النمسا'),
(5959, 1047566968, 1047566995, 'DE', 'DEU', 'ألمانيا'),
(5960, 1047566996, 1047566999, 'CH', 'CHE', 'سويسرا'),
(5961, 1047567000, 1047567031, 'DE', 'DEU', 'ألمانيا'),
(5962, 1047567032, 1047567035, 'CH', 'CHE', 'سويسرا'),
(5963, 1047567036, 1047567039, 'DE', 'DEU', 'ألمانيا'),
(5964, 1047567040, 1047567043, 'AT', 'AUT', 'النمسا'),
(5965, 1047567044, 1047567047, 'CH', 'CHE', 'سويسرا'),
(5966, 1047567048, 1047567063, 'DE', 'DEU', 'ألمانيا'),
(5967, 1047567064, 1047567067, 'CH', 'CHE', 'سويسرا'),
(5968, 1047567068, 1047567071, 'BE', 'BEL', 'بلجيكا'),
(5969, 1047567072, 1047567119, 'DE', 'DEU', 'ألمانيا'),
(5970, 1047567120, 1047567127, 'CH', 'CHE', 'سويسرا'),
(5971, 1047567128, 1047567143, 'DE', 'DEU', 'ألمانيا'),
(5972, 1047567144, 1047567147, 'CH', 'CHE', 'سويسرا'),
(5973, 1047567148, 1047567151, 'BE', 'BEL', 'بلجيكا'),
(5974, 1047567152, 1047567163, 'DE', 'DEU', 'ألمانيا'),
(5975, 1047567164, 1047567167, 'AT', 'AUT', 'النمسا'),
(5976, 1047567168, 1047567211, 'DE', 'DEU', 'ألمانيا'),
(5977, 1047567212, 1047567227, 'CH', 'CHE', 'سويسرا'),
(5978, 1047567228, 1047567239, 'DE', 'DEU', 'ألمانيا'),
(5979, 1047567240, 1047567243, 'CH', 'CHE', 'سويسرا'),
(5980, 1047567244, 1047567247, 'DE', 'DEU', 'ألمانيا'),
(5981, 1047567248, 1047567255, 'CH', 'CHE', 'سويسرا'),
(5982, 1047567256, 1047567279, 'DE', 'DEU', 'ألمانيا'),
(5983, 1047567280, 1047567287, 'CH', 'CHE', 'سويسرا'),
(5984, 1047567288, 1047567315, 'DE', 'DEU', 'ألمانيا'),
(5985, 1047567316, 1047567319, 'AT', 'AUT', 'النمسا'),
(5986, 1047567320, 1047567359, 'DE', 'DEU', 'ألمانيا'),
(5987, 1047567360, 1047567375, 'ES', 'ESP', 'إسبانيا'),
(5988, 1047567376, 1047567435, 'DE', 'DEU', 'ألمانيا'),
(5989, 1047567436, 1047567439, 'CH', 'CHE', 'سويسرا'),
(5990, 1047567440, 1047567447, 'DE', 'DEU', 'ألمانيا'),
(5991, 1047567448, 1047567451, 'CH', 'CHE', 'سويسرا'),
(5992, 1047567452, 1047567455, 'AT', 'AUT', 'النمسا'),
(5993, 1047567456, 1047567459, 'CH', 'CHE', 'سويسرا'),
(5994, 1047567460, 1047567463, 'DE', 'DEU', 'ألمانيا'),
(5995, 1047567464, 1047567467, 'CH', 'CHE', 'سويسرا'),
(5996, 1047567468, 1047567495, 'DE', 'DEU', 'ألمانيا'),
(5997, 1047567496, 1047567499, 'CH', 'CHE', 'سويسرا'),
(5998, 1047567500, 1047567535, 'DE', 'DEU', 'ألمانيا'),
(5999, 1047567536, 1047567539, 'CH', 'CHE', 'سويسرا'),
(6000, 1047567540, 1047567551, 'DE', 'DEU', 'ألمانيا'),
(6001, 1047567552, 1047567555, 'CH', 'CHE', 'سويسرا'),
(6002, 1047567556, 1047567567, 'DE', 'DEU', 'ألمانيا'),
(6003, 1047567568, 1047567571, 'AT', 'AUT', 'النمسا'),
(6004, 1047567572, 1047567647, 'DE', 'DEU', 'ألمانيا'),
(6005, 1047567648, 1047567651, 'CH', 'CHE', 'سويسرا'),
(6006, 1047567652, 1047567655, 'DE', 'DEU', 'ألمانيا'),
(6007, 1047567656, 1047567659, 'CH', 'CHE', 'سويسرا'),
(6008, 1047567660, 1047567727, 'DE', 'DEU', 'ألمانيا'),
(6009, 1047567728, 1047567731, 'BE', 'BEL', 'بلجيكا'),
(6010, 1047567732, 1047567735, 'DE', 'DEU', 'ألمانيا'),
(6011, 1047567736, 1047567743, 'CH', 'CHE', 'سويسرا'),
(6012, 1047567744, 1047567747, 'DE', 'DEU', 'ألمانيا'),
(6013, 1047567748, 1047567751, 'CH', 'CHE', 'سويسرا'),
(6014, 1047567752, 1047567755, 'LU', 'LUX', 'لوكسيمبورغ'),
(6015, 1047567756, 1047567759, 'CH', 'CHE', 'سويسرا'),
(6016, 1047567760, 1047567799, 'DE', 'DEU', 'ألمانيا'),
(6017, 1047567800, 1047567803, 'CH', 'CHE', 'سويسرا'),
(6018, 1047567804, 1047567847, 'DE', 'DEU', 'ألمانيا'),
(6019, 1047567848, 1047567851, 'CH', 'CHE', 'سويسرا'),
(6020, 1047567852, 1047567855, 'BE', 'BEL', 'بلجيكا'),
(6021, 1047567856, 1047567871, 'DE', 'DEU', 'ألمانيا'),
(6022, 1047567872, 1047567875, 'CH', 'CHE', 'سويسرا'),
(6023, 1047567876, 1047567879, 'AT', 'AUT', 'النمسا'),
(6024, 1047567880, 1047567883, 'CH', 'CHE', 'سويسرا'),
(6025, 1047567884, 1047567935, 'DE', 'DEU', 'ألمانيا'),
(6026, 1047567936, 1047567939, 'CH', 'CHE', 'سويسرا'),
(6027, 1047567940, 1047568047, 'DE', 'DEU', 'ألمانيا'),
(6028, 1047568048, 1047568059, 'CH', 'CHE', 'سويسرا'),
(6029, 1047568060, 1047568083, 'DE', 'DEU', 'ألمانيا'),
(6030, 1047568084, 1047568095, 'CH', 'CHE', 'سويسرا'),
(6031, 1047568096, 1047568159, 'DE', 'DEU', 'ألمانيا'),
(6032, 1047568160, 1047568163, 'CH', 'CHE', 'سويسرا'),
(6033, 1047568164, 1047568167, 'DE', 'DEU', 'ألمانيا'),
(6034, 1047568168, 1047568171, 'ES', 'ESP', 'إسبانيا'),
(6035, 1047568172, 1047568187, 'DE', 'DEU', 'ألمانيا'),
(6036, 1047568188, 1047568191, 'CH', 'CHE', 'سويسرا'),
(6037, 1047568192, 1047568215, 'DE', 'DEU', 'ألمانيا'),
(6038, 1047568216, 1047568219, 'CH', 'CHE', 'سويسرا'),
(6039, 1047568220, 1047568235, 'DE', 'DEU', 'ألمانيا'),
(6040, 1047568236, 1047568239, 'CH', 'CHE', 'سويسرا'),
(6041, 1047568240, 1047568247, 'DE', 'DEU', 'ألمانيا'),
(6042, 1047568248, 1047568251, 'CH', 'CHE', 'سويسرا'),
(6043, 1047568252, 1047568383, 'DE', 'DEU', 'ألمانيا'),
(6044, 1047568384, 1047576575, 'NL', 'NLD', 'هولندا'),
(6045, 1047576576, 1047584767, 'HU', 'HUN', 'هنغاريا'),
(6046, 1047584768, 1047592959, 'NL', 'NLD', 'هولندا'),
(6047, 1047592960, 1047601151, 'BA', 'BIH', 'البوسنه والهرسك'),
(6048, 1047601152, 1047625727, 'RU', 'RUS', 'الإتحاد الروسي'),
(6049, 1047625728, 1047633919, 'NO', 'NOR', 'النرويج'),
(6050, 1047633920, 1047642111, 'FI', 'FIN', 'فنلندا'),
(6051, 1047642112, 1047658495, 'DE', 'DEU', 'ألمانيا'),
(6052, 1047728128, 1047732223, 'SE', 'SWE', 'السويد'),
(6053, 1047740544, 1047740671, 'DE', 'DEU', 'ألمانيا'),
(6054, 1047740672, 1047740927, 'GB', 'GBR', 'المملكة المتحدة'),
(6055, 1047781664, 1047781671, 'GB', 'GBR', 'المملكة المتحدة'),
(6056, 1047782696, 1047782703, 'GB', 'GBR', 'المملكة المتحدة'),
(6057, 1047782720, 1047782751, 'SE', 'SWE', 'السويد'),
(6058, 1047782752, 1047782783, 'NO', 'NOR', 'النرويج'),
(6059, 1047782784, 1047782815, 'FI', 'FIN', 'فنلندا'),
(6060, 1047789568, 1047806031, 'AT', 'AUT', 'النمسا'),
(6061, 1047806032, 1047806047, 'IT', 'ITA', 'إيطاليا'),
(6062, 1047806048, 1047822335, 'AT', 'AUT', 'النمسا'),
(6063, 1047822336, 1047834895, 'DE', 'DEU', 'ألمانيا'),
(6064, 1047834896, 1047834903, 'CY', 'CYP', 'قبرص'),
(6065, 1047834904, 1047838719, 'DE', 'DEU', 'ألمانيا'),
(6066, 1047838720, 1047846911, 'DK', 'DNK', 'الدنيمارك'),
(6067, 1047846912, 1047855103, 'SE', 'SWE', 'السويد'),
(6068, 1047855104, 1047863295, 'DE', 'DEU', 'ألمانيا'),
(6069, 1047871488, 1047887871, 'RU', 'RUS', 'الإتحاد الروسي'),
(6070, 1047887872, 1047920639, 'ES', 'ESP', 'إسبانيا'),
(6071, 1047920640, 1047941119, 'RU', 'RUS', 'الإتحاد الروسي'),
(6072, 1047941120, 1047941375, 'GB', 'GBR', 'المملكة المتحدة'),
(6073, 1047941376, 1047986175, 'RU', 'RUS', 'الإتحاد الروسي'),
(6074, 1047986176, 1047997439, 'SE', 'SWE', 'السويد'),
(6075, 1047997440, 1047997503, 'NO', 'NOR', 'النرويج'),
(6076, 1047997504, 1048012383, 'SE', 'SWE', 'السويد'),
(6077, 1048012384, 1048012391, 'DE', 'DEU', 'ألمانيا'),
(6078, 1048012392, 1048051711, 'SE', 'SWE', 'السويد'),
(6079, 1048051712, 1048117247, 'SA', 'SAU', 'السعودية'),
(6080, 1048117248, 1048125439, 'GB', 'GBR', 'المملكة المتحدة'),
(6081, 1048125440, 1048133631, 'FI', 'FIN', 'فنلندا'),
(6082, 1048133632, 1048158207, 'PL', 'POL', 'بولندا'),
(6083, 1048158208, 1048166399, 'DK', 'DNK', 'الدنيمارك'),
(6084, 1048166400, 1048182783, 'CH', 'CHE', 'سويسرا'),
(6085, 1048182784, 1048184831, 'UA', 'UKR', 'أوكرانيا'),
(6086, 1048184832, 1048186879, 'FR', 'FRA', 'فرنسا'),
(6087, 1048186880, 1048188927, 'LV', 'LVA', 'لاتفيا'),
(6088, 1048188928, 1048190975, 'BE', 'BEL', 'بلجيكا'),
(6089, 1048190976, 1048193023, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(6090, 1048193024, 1048195071, 'RO', 'ROM', 'رومانيا'),
(6091, 1048195072, 1048197119, 'RU', 'RUS', 'الإتحاد الروسي'),
(6092, 1048197120, 1048201215, 'UA', 'UKR', 'أوكرانيا'),
(6093, 1048203264, 1048205311, 'DE', 'DEU', 'ألمانيا'),
(6094, 1048205312, 1048209407, 'RU', 'RUS', 'الإتحاد الروسي'),
(6095, 1048209408, 1048211455, 'UA', 'UKR', 'أوكرانيا'),
(6096, 1048211456, 1048215551, 'PL', 'POL', 'بولندا'),
(6097, 1048215552, 1048221695, 'RU', 'RUS', 'الإتحاد الروسي'),
(6098, 1048221696, 1048223743, 'UA', 'UKR', 'أوكرانيا'),
(6099, 1048223744, 1048225791, 'DK', 'DNK', 'الدنيمارك'),
(6100, 1048225792, 1048227839, 'CZ', 'CZE', 'التشيك'),
(6101, 1048227840, 1048233983, 'RU', 'RUS', 'الإتحاد الروسي'),
(6102, 1048233984, 1048236031, 'UA', 'UKR', 'أوكرانيا'),
(6103, 1048236032, 1048240127, 'RU', 'RUS', 'الإتحاد الروسي'),
(6104, 1048240128, 1048242175, 'IL', 'ISR', 'إسرائيل'),
(6105, 1048242176, 1048244223, 'PL', 'POL', 'بولندا'),
(6106, 1048244224, 1048246271, 'RU', 'RUS', 'الإتحاد الروسي'),
(6107, 1048246272, 1048248319, 'NO', 'NOR', 'النرويج'),
(6108, 1048248320, 1048313855, 'IT', 'ITA', 'إيطاليا'),
(6109, 1048313856, 1048510463, 'GB', 'GBR', 'المملكة المتحدة'),
(6110, 1048510464, 1048575999, 'SE', 'SWE', 'السويد'),
(6111, 1048576000, 1048584191, 'DE', 'DEU', 'ألمانيا'),
(6112, 1048584192, 1048592383, 'IL', 'ISR', 'إسرائيل'),
(6113, 1048600576, 1048602623, 'DE', 'DEU', 'ألمانيا'),
(6114, 1048602624, 1048603135, 'EE', 'EST', 'إستونيا'),
(6115, 1048603136, 1048604671, 'DE', 'DEU', 'ألمانيا'),
(6116, 1048604672, 1048604687, 'EE', 'EST', 'إستونيا'),
(6117, 1048604688, 1048604743, 'DE', 'DEU', 'ألمانيا'),
(6118, 1048604744, 1048604759, 'EE', 'EST', 'إستونيا'),
(6119, 1048604760, 1048604927, 'DE', 'DEU', 'ألمانيا'),
(6120, 1048604928, 1048604965, 'LT', 'LTU', 'ليتوانيا'),
(6121, 1048604966, 1048604975, 'DE', 'DEU', 'ألمانيا'),
(6122, 1048604976, 1048605055, 'LT', 'LTU', 'ليتوانيا'),
(6123, 1048605056, 1048607231, 'DE', 'DEU', 'ألمانيا'),
(6124, 1048607232, 1048607247, 'EE', 'EST', 'إستونيا'),
(6125, 1048607248, 1048607487, 'DE', 'DEU', 'ألمانيا'),
(6126, 1048607488, 1048607519, 'EE', 'EST', 'إستونيا'),
(6127, 1048607520, 1048607743, 'DE', 'DEU', 'ألمانيا'),
(6128, 1048607744, 1048607759, 'EE', 'EST', 'إستونيا'),
(6129, 1048607760, 1048607775, 'DE', 'DEU', 'ألمانيا'),
(6130, 1048607776, 1048607839, 'EE', 'EST', 'إستونيا'),
(6131, 1048607840, 1048608255, 'DE', 'DEU', 'ألمانيا'),
(6132, 1048608256, 1048608287, 'RU', 'RUS', 'الإتحاد الروسي'),
(6133, 1048608288, 1048608671, 'DE', 'DEU', 'ألمانيا'),
(6134, 1048608672, 1048608703, 'EE', 'EST', 'إستونيا'),
(6135, 1048608704, 1048608711, 'DE', 'DEU', 'ألمانيا'),
(6136, 1048608712, 1048608727, 'EE', 'EST', 'إستونيا'),
(6137, 1048608728, 1048608731, 'DE', 'DEU', 'ألمانيا'),
(6138, 1048608732, 1048608767, 'EE', 'EST', 'إستونيا'),
(6139, 1048608768, 1048611583, 'GB', 'GBR', 'المملكة المتحدة'),
(6140, 1048611584, 1048611839, 'FR', 'FRA', 'فرنسا'),
(6141, 1048611840, 1048615423, 'GB', 'GBR', 'المملكة المتحدة'),
(6142, 1048615424, 1048615487, 'US', 'USA', 'الولايات المتحدة'),
(6143, 1048615488, 1048616959, 'GB', 'GBR', 'المملكة المتحدة'),
(6144, 1048616960, 1048621055, 'KE', 'KEN', 'كينيا'),
(6145, 1048621056, 1048625151, 'DE', 'DEU', 'ألمانيا'),
(6146, 1048625152, 1048633343, 'GB', 'GBR', 'المملكة المتحدة'),
(6147, 1048633344, 1048641535, 'NO', 'NOR', 'النرويج'),
(6148, 1048641536, 1048649727, 'FR', 'FRA', 'فرنسا'),
(6149, 1048649728, 1048657919, 'CZ', 'CZE', 'التشيك'),
(6150, 1048657920, 1048674303, 'GB', 'GBR', 'المملكة المتحدة'),
(6151, 1048674304, 1048682495, 'NL', 'NLD', 'هولندا'),
(6152, 1048682496, 1048690687, 'FR', 'FRA', 'فرنسا'),
(6153, 1048690688, 1048707071, 'PL', 'POL', 'بولندا'),
(6154, 1048707072, 1048772607, 'GB', 'GBR', 'المملكة المتحدة'),
(6155, 1048772608, 1048838143, 'NL', 'NLD', 'هولندا'),
(6156, 1048838144, 1048838175, 'DE', 'DEU', 'ألمانيا'),
(6157, 1048838176, 1048838207, 'PL', 'POL', 'بولندا'),
(6158, 1048838208, 1048838239, 'NL', 'NLD', 'هولندا'),
(6159, 1048838240, 1048839935, 'DE', 'DEU', 'ألمانيا'),
(6160, 1048839936, 1048840703, 'NL', 'NLD', 'هولندا'),
(6161, 1048840704, 1048843263, 'DE', 'DEU', 'ألمانيا'),
(6162, 1048843264, 1048843311, 'NL', 'NLD', 'هولندا'),
(6163, 1048843312, 1048843319, 'DE', 'DEU', 'ألمانيا'),
(6164, 1048843320, 1048843599, 'NL', 'NLD', 'هولندا'),
(6165, 1048843600, 1048843607, 'DE', 'DEU', 'ألمانيا'),
(6166, 1048843608, 1048843951, 'NL', 'NLD', 'هولندا'),
(6167, 1048843952, 1048843959, 'DE', 'DEU', 'ألمانيا'),
(6168, 1048843960, 1048843983, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(6169, 1048843984, 1048843991, 'DE', 'DEU', 'ألمانيا'),
(6170, 1048843992, 1048844263, 'NL', 'NLD', 'هولندا'),
(6171, 1048844264, 1048844271, 'DE', 'DEU', 'ألمانيا'),
(6172, 1048844272, 1048844287, 'NL', 'NLD', 'هولندا'),
(6173, 1048844288, 1048844319, 'DE', 'DEU', 'ألمانيا'),
(6174, 1048844320, 1048844351, 'NL', 'NLD', 'هولندا'),
(6175, 1048844352, 1048845567, 'DE', 'DEU', 'ألمانيا'),
(6176, 1048845568, 1048845703, 'NL', 'NLD', 'هولندا'),
(6177, 1048845704, 1048845711, 'DE', 'DEU', 'ألمانيا'),
(6178, 1048845712, 1048845759, 'NL', 'NLD', 'هولندا'),
(6179, 1048845760, 1048845767, 'DE', 'DEU', 'ألمانيا'),
(6180, 1048845768, 1048845855, 'NL', 'NLD', 'هولندا'),
(6181, 1048845856, 1048845863, 'DE', 'DEU', 'ألمانيا'),
(6182, 1048845864, 1048846575, 'NL', 'NLD', 'هولندا'),
(6183, 1048846576, 1048846583, 'DE', 'DEU', 'ألمانيا'),
(6184, 1048846584, 1048846647, 'NL', 'NLD', 'هولندا'),
(6185, 1048846648, 1048846663, 'DE', 'DEU', 'ألمانيا'),
(6186, 1048846664, 1048846687, 'NL', 'NLD', 'هولندا'),
(6187, 1048846688, 1048846695, 'DE', 'DEU', 'ألمانيا'),
(6188, 1048846696, 1048846847, 'NL', 'NLD', 'هولندا'),
(6189, 1048846848, 1048847359, 'DE', 'DEU', 'ألمانيا'),
(6190, 1048847360, 1048847423, 'NL', 'NLD', 'هولندا'),
(6191, 1048847424, 1048847431, 'DE', 'DEU', 'ألمانيا'),
(6192, 1048847432, 1048847455, 'NL', 'NLD', 'هولندا'),
(6193, 1048847456, 1048847463, 'DE', 'DEU', 'ألمانيا'),
(6194, 1048847464, 1048848119, 'NL', 'NLD', 'هولندا'),
(6195, 1048848120, 1048848127, 'DE', 'DEU', 'ألمانيا'),
(6196, 1048848128, 1048848135, 'NL', 'NLD', 'هولندا'),
(6197, 1048848136, 1048848143, 'DE', 'DEU', 'ألمانيا'),
(6198, 1048848144, 1048848479, 'NL', 'NLD', 'هولندا'),
(6199, 1048848480, 1048848487, 'DE', 'DEU', 'ألمانيا'),
(6200, 1048848488, 1048848551, 'NL', 'NLD', 'هولندا'),
(6201, 1048848552, 1048848559, 'DE', 'DEU', 'ألمانيا'),
(6202, 1048848560, 1048848703, 'NL', 'NLD', 'هولندا'),
(6203, 1048848704, 1048848711, 'DE', 'DEU', 'ألمانيا'),
(6204, 1048848712, 1048848735, 'NL', 'NLD', 'هولندا'),
(6205, 1048848736, 1048848743, 'DE', 'DEU', 'ألمانيا'),
(6206, 1048848744, 1048848895, 'NL', 'NLD', 'هولندا'),
(6207, 1048848896, 1048849407, 'DE', 'DEU', 'ألمانيا'),
(6208, 1048849408, 1048849559, 'NL', 'NLD', 'هولندا'),
(6209, 1048849560, 1048849567, 'DE', 'DEU', 'ألمانيا'),
(6210, 1048849568, 1048849599, 'NL', 'NLD', 'هولندا'),
(6211, 1048849600, 1048849607, 'DE', 'DEU', 'ألمانيا'),
(6212, 1048849608, 1048849863, 'NL', 'NLD', 'هولندا'),
(6213, 1048849864, 1048849871, 'DE', 'DEU', 'ألمانيا'),
(6214, 1048849872, 1048850959, 'NL', 'NLD', 'هولندا'),
(6215, 1048850960, 1048850967, 'DE', 'DEU', 'ألمانيا'),
(6216, 1048850968, 1048851031, 'NL', 'NLD', 'هولندا'),
(6217, 1048851032, 1048851039, 'DE', 'DEU', 'ألمانيا'),
(6218, 1048851040, 1048851151, 'NL', 'NLD', 'هولندا'),
(6219, 1048851152, 1048851159, 'DE', 'DEU', 'ألمانيا'),
(6220, 1048851160, 1048851223, 'NL', 'NLD', 'هولندا'),
(6221, 1048851224, 1048851231, 'DE', 'DEU', 'ألمانيا'),
(6222, 1048851232, 1048851591, 'NL', 'NLD', 'هولندا'),
(6223, 1048851592, 1048851607, 'DE', 'DEU', 'ألمانيا'),
(6224, 1048851608, 1048851679, 'NL', 'NLD', 'هولندا'),
(6225, 1048851680, 1048851687, 'DE', 'DEU', 'ألمانيا'),
(6226, 1048851688, 1048851703, 'NL', 'NLD', 'هولندا'),
(6227, 1048851704, 1048851711, 'DE', 'DEU', 'ألمانيا'),
(6228, 1048851712, 1048851743, 'NL', 'NLD', 'هولندا'),
(6229, 1048851744, 1048851751, 'DE', 'DEU', 'ألمانيا'),
(6230, 1048851752, 1048852039, 'NL', 'NLD', 'هولندا'),
(6231, 1048852040, 1048852047, 'DE', 'DEU', 'ألمانيا'),
(6232, 1048852048, 1048852335, 'NL', 'NLD', 'هولندا'),
(6233, 1048852336, 1048852343, 'DE', 'DEU', 'ألمانيا'),
(6234, 1048852344, 1048852807, 'NL', 'NLD', 'هولندا'),
(6235, 1048852808, 1048852815, 'DE', 'DEU', 'ألمانيا'),
(6236, 1048852816, 1048852871, 'NL', 'NLD', 'هولندا'),
(6237, 1048852872, 1048852879, 'DE', 'DEU', 'ألمانيا'),
(6238, 1048852880, 1048853127, 'NL', 'NLD', 'هولندا'),
(6239, 1048853128, 1048853135, 'DE', 'DEU', 'ألمانيا'),
(6240, 1048853136, 1048853143, 'NL', 'NLD', 'هولندا'),
(6241, 1048853144, 1048853151, 'DE', 'DEU', 'ألمانيا'),
(6242, 1048853152, 1048853191, 'NL', 'NLD', 'هولندا'),
(6243, 1048853192, 1048853199, 'DE', 'DEU', 'ألمانيا'),
(6244, 1048853200, 1048853327, 'NL', 'NLD', 'هولندا'),
(6245, 1048853328, 1048853335, 'DE', 'DEU', 'ألمانيا'),
(6246, 1048853336, 1048853575, 'NL', 'NLD', 'هولندا'),
(6247, 1048853576, 1048853583, 'DE', 'DEU', 'ألمانيا'),
(6248, 1048853584, 1048853655, 'NL', 'NLD', 'هولندا'),
(6249, 1048853656, 1048853663, 'DE', 'DEU', 'ألمانيا'),
(6250, 1048853664, 1048853863, 'NL', 'NLD', 'هولندا'),
(6251, 1048853864, 1048853871, 'DE', 'DEU', 'ألمانيا'),
(6252, 1048853872, 1048854055, 'NL', 'NLD', 'هولندا'),
(6253, 1048854056, 1048854063, 'DE', 'DEU', 'ألمانيا'),
(6254, 1048854064, 1048854391, 'NL', 'NLD', 'هولندا'),
(6255, 1048854392, 1048854407, 'DE', 'DEU', 'ألمانيا'),
(6256, 1048854408, 1048854527, 'NL', 'NLD', 'هولندا'),
(6257, 1048854528, 1048855039, 'DE', 'DEU', 'ألمانيا'),
(6258, 1048855040, 1048855047, 'NL', 'NLD', 'هولندا'),
(6259, 1048855048, 1048855055, 'DE', 'DEU', 'ألمانيا'),
(6260, 1048855056, 1048855215, 'NL', 'NLD', 'هولندا'),
(6261, 1048855216, 1048855223, 'DE', 'DEU', 'ألمانيا'),
(6262, 1048855224, 1048855271, 'NL', 'NLD', 'هولندا'),
(6263, 1048855272, 1048855279, 'DE', 'DEU', 'ألمانيا'),
(6264, 1048855280, 1048855895, 'NL', 'NLD', 'هولندا'),
(6265, 1048855896, 1048855903, 'DE', 'DEU', 'ألمانيا'),
(6266, 1048855904, 1048856015, 'NL', 'NLD', 'هولندا'),
(6267, 1048856016, 1048856031, 'DE', 'DEU', 'ألمانيا'),
(6268, 1048856032, 1048856095, 'NL', 'NLD', 'هولندا'),
(6269, 1048856096, 1048856103, 'DE', 'DEU', 'ألمانيا'),
(6270, 1048856104, 1048856359, 'NL', 'NLD', 'هولندا'),
(6271, 1048856360, 1048856367, 'DE', 'DEU', 'ألمانيا'),
(6272, 1048856368, 1048856375, 'NL', 'NLD', 'هولندا'),
(6273, 1048856376, 1048856383, 'DE', 'DEU', 'ألمانيا'),
(6274, 1048856384, 1048856559, 'NL', 'NLD', 'هولندا'),
(6275, 1048856560, 1048856567, 'DE', 'DEU', 'ألمانيا'),
(6276, 1048856568, 1048856687, 'NL', 'NLD', 'هولندا'),
(6277, 1048856688, 1048856695, 'DE', 'DEU', 'ألمانيا'),
(6278, 1048856696, 1048856839, 'NL', 'NLD', 'هولندا'),
(6279, 1048856840, 1048856847, 'DE', 'DEU', 'ألمانيا'),
(6280, 1048856848, 1048856919, 'NL', 'NLD', 'هولندا'),
(6281, 1048856920, 1048856927, 'DE', 'DEU', 'ألمانيا'),
(6282, 1048856928, 1048856999, 'NL', 'NLD', 'هولندا'),
(6283, 1048857000, 1048857007, 'DE', 'DEU', 'ألمانيا'),
(6284, 1048857008, 1048857767, 'NL', 'NLD', 'هولندا'),
(6285, 1048857768, 1048857775, 'DE', 'DEU', 'ألمانيا'),
(6286, 1048857776, 1048858111, 'NL', 'NLD', 'هولندا'),
(6287, 1048858112, 1048858623, 'DE', 'DEU', 'ألمانيا'),
(6288, 1048858624, 1048859095, 'NL', 'NLD', 'هولندا'),
(6289, 1048859096, 1048859103, 'DE', 'DEU', 'ألمانيا'),
(6290, 1048859104, 1048859903, 'NL', 'NLD', 'هولندا'),
(6291, 1048859904, 1048859911, 'DE', 'DEU', 'ألمانيا'),
(6292, 1048859912, 1048860311, 'NL', 'NLD', 'هولندا'),
(6293, 1048860312, 1048860319, 'DE', 'DEU', 'ألمانيا'),
(6294, 1048860320, 1048860407, 'NL', 'NLD', 'هولندا'),
(6295, 1048860408, 1048860415, 'DE', 'DEU', 'ألمانيا'),
(6296, 1048860416, 1048860455, 'NL', 'NLD', 'هولندا'),
(6297, 1048860456, 1048860463, 'DE', 'DEU', 'ألمانيا'),
(6298, 1048860464, 1048860511, 'NL', 'NLD', 'هولندا'),
(6299, 1048860512, 1048860519, 'DE', 'DEU', 'ألمانيا'),
(6300, 1048860520, 1048860607, 'NL', 'NLD', 'هولندا'),
(6301, 1048860608, 1048860615, 'DE', 'DEU', 'ألمانيا'),
(6302, 1048860616, 1048861383, 'NL', 'NLD', 'هولندا'),
(6303, 1048861384, 1048861391, 'DE', 'DEU', 'ألمانيا'),
(6304, 1048861392, 1048861431, 'NL', 'NLD', 'هولندا'),
(6305, 1048861432, 1048861439, 'DE', 'DEU', 'ألمانيا'),
(6306, 1048861440, 1048862247, 'NL', 'NLD', 'هولندا'),
(6307, 1048862248, 1048862255, 'DE', 'DEU', 'ألمانيا'),
(6308, 1048862256, 1048862287, 'NL', 'NLD', 'هولندا'),
(6309, 1048862288, 1048862295, 'DE', 'DEU', 'ألمانيا'),
(6310, 1048862296, 1048862511, 'NL', 'NLD', 'هولندا'),
(6311, 1048862512, 1048862519, 'DE', 'DEU', 'ألمانيا'),
(6312, 1048862520, 1048862623, 'NL', 'NLD', 'هولندا'),
(6313, 1048862624, 1048862639, 'DE', 'DEU', 'ألمانيا'),
(6314, 1048862640, 1048862671, 'NL', 'NLD', 'هولندا'),
(6315, 1048862672, 1048862679, 'DE', 'DEU', 'ألمانيا'),
(6316, 1048862680, 1048862711, 'NL', 'NLD', 'هولندا'),
(6317, 1048862712, 1048862719, 'DE', 'DEU', 'ألمانيا'),
(6318, 1048862720, 1048862919, 'NL', 'NLD', 'هولندا'),
(6319, 1048862920, 1048862927, 'DE', 'DEU', 'ألمانيا'),
(6320, 1048862928, 1048863111, 'NL', 'NLD', 'هولندا'),
(6321, 1048863112, 1048863119, 'DE', 'DEU', 'ألمانيا'),
(6322, 1048863120, 1048863271, 'NL', 'NLD', 'هولندا'),
(6323, 1048863272, 1048863279, 'DE', 'DEU', 'ألمانيا'),
(6324, 1048863280, 1048863319, 'NL', 'NLD', 'هولندا'),
(6325, 1048863320, 1048863327, 'DE', 'DEU', 'ألمانيا'),
(6326, 1048863328, 1048863343, 'NL', 'NLD', 'هولندا'),
(6327, 1048863344, 1048863351, 'DE', 'DEU', 'ألمانيا'),
(6328, 1048863352, 1048863391, 'NL', 'NLD', 'هولندا'),
(6329, 1048863392, 1048863399, 'DE', 'DEU', 'ألمانيا'),
(6330, 1048863400, 1048863575, 'NL', 'NLD', 'هولندا'),
(6331, 1048863576, 1048863591, 'DE', 'DEU', 'ألمانيا'),
(6332, 1048863592, 1048863631, 'NL', 'NLD', 'هولندا'),
(6333, 1048863632, 1048863639, 'DE', 'DEU', 'ألمانيا'),
(6334, 1048863640, 1048863743, 'NL', 'NLD', 'هولندا'),
(6335, 1048863744, 1048863751, 'DE', 'DEU', 'ألمانيا'),
(6336, 1048863752, 1048863791, 'NL', 'NLD', 'هولندا'),
(6337, 1048863792, 1048863799, 'DE', 'DEU', 'ألمانيا'),
(6338, 1048863800, 1048864071, 'NL', 'NLD', 'هولندا'),
(6339, 1048864072, 1048864079, 'DE', 'DEU', 'ألمانيا'),
(6340, 1048864080, 1048864167, 'NL', 'NLD', 'هولندا'),
(6341, 1048864168, 1048864175, 'DE', 'DEU', 'ألمانيا'),
(6342, 1048864176, 1048864471, 'NL', 'NLD', 'هولندا'),
(6343, 1048864472, 1048864479, 'DE', 'DEU', 'ألمانيا'),
(6344, 1048864480, 1048864775, 'NL', 'NLD', 'هولندا'),
(6345, 1048864776, 1048864783, 'DE', 'DEU', 'ألمانيا'),
(6346, 1048864784, 1048865279, 'NL', 'NLD', 'هولندا'),
(6347, 1048865280, 1048865791, 'DE', 'DEU', 'ألمانيا'),
(6348, 1048865792, 1048865903, 'NL', 'NLD', 'هولندا'),
(6349, 1048865904, 1048865911, 'DE', 'DEU', 'ألمانيا'),
(6350, 1048865912, 1048865935, 'NL', 'NLD', 'هولندا'),
(6351, 1048865936, 1048865943, 'DE', 'DEU', 'ألمانيا'),
(6352, 1048865944, 1048866095, 'NL', 'NLD', 'هولندا'),
(6353, 1048866096, 1048866103, 'DE', 'DEU', 'ألمانيا'),
(6354, 1048866104, 1048867031, 'NL', 'NLD', 'هولندا'),
(6355, 1048867032, 1048867039, 'DE', 'DEU', 'ألمانيا'),
(6356, 1048867040, 1048867207, 'NL', 'NLD', 'هولندا'),
(6357, 1048867208, 1048867215, 'DE', 'DEU', 'ألمانيا'),
(6358, 1048867216, 1048867295, 'NL', 'NLD', 'هولندا'),
(6359, 1048867296, 1048867303, 'DE', 'DEU', 'ألمانيا'),
(6360, 1048867304, 1048867327, 'NL', 'NLD', 'هولندا'),
(6361, 1048867328, 1048868351, 'DE', 'DEU', 'ألمانيا'),
(6362, 1048868352, 1048868655, 'NL', 'NLD', 'هولندا'),
(6363, 1048868656, 1048868663, 'DE', 'DEU', 'ألمانيا'),
(6364, 1048868664, 1048869183, 'NL', 'NLD', 'هولندا'),
(6365, 1048869184, 1048869191, 'DE', 'DEU', 'ألمانيا'),
(6366, 1048869192, 1048869263, 'NL', 'NLD', 'هولندا'),
(6367, 1048869264, 1048869279, 'DE', 'DEU', 'ألمانيا'),
(6368, 1048869280, 1048869367, 'NL', 'NLD', 'هولندا'),
(6369, 1048869368, 1048869375, 'DE', 'DEU', 'ألمانيا'),
(6370, 1048869376, 1048869479, 'NL', 'NLD', 'هولندا'),
(6371, 1048869480, 1048869487, 'DE', 'DEU', 'ألمانيا'),
(6372, 1048869488, 1048869543, 'NL', 'NLD', 'هولندا'),
(6373, 1048869544, 1048869551, 'DE', 'DEU', 'ألمانيا'),
(6374, 1048869552, 1048869575, 'NL', 'NLD', 'هولندا'),
(6375, 1048869576, 1048869583, 'DE', 'DEU', 'ألمانيا'),
(6376, 1048869584, 1048869615, 'NL', 'NLD', 'هولندا'),
(6377, 1048869616, 1048869623, 'DE', 'DEU', 'ألمانيا'),
(6378, 1048869624, 1048869687, 'NL', 'NLD', 'هولندا'),
(6379, 1048869688, 1048869695, 'DE', 'DEU', 'ألمانيا'),
(6380, 1048869696, 1048869759, 'NL', 'NLD', 'هولندا'),
(6381, 1048869760, 1048869767, 'DE', 'DEU', 'ألمانيا'),
(6382, 1048869768, 1048869847, 'NL', 'NLD', 'هولندا'),
(6383, 1048869848, 1048869863, 'DE', 'DEU', 'ألمانيا'),
(6384, 1048869864, 1048869951, 'NL', 'NLD', 'هولندا'),
(6385, 1048869952, 1048869967, 'DE', 'DEU', 'ألمانيا'),
(6386, 1048869968, 1048869975, 'NL', 'NLD', 'هولندا'),
(6387, 1048869976, 1048869983, 'DE', 'DEU', 'ألمانيا'),
(6388, 1048869984, 1048870015, 'NL', 'NLD', 'هولندا'),
(6389, 1048870016, 1048870023, 'DE', 'DEU', 'ألمانيا'),
(6390, 1048870024, 1048870087, 'NL', 'NLD', 'هولندا'),
(6391, 1048870088, 1048870095, 'DE', 'DEU', 'ألمانيا'),
(6392, 1048870096, 1048870103, 'NL', 'NLD', 'هولندا'),
(6393, 1048870104, 1048870111, 'DE', 'DEU', 'ألمانيا'),
(6394, 1048870112, 1048870127, 'NL', 'NLD', 'هولندا'),
(6395, 1048870128, 1048870135, 'DE', 'DEU', 'ألمانيا'),
(6396, 1048870136, 1048870279, 'NL', 'NLD', 'هولندا'),
(6397, 1048870280, 1048870287, 'DE', 'DEU', 'ألمانيا'),
(6398, 1048870288, 1048870399, 'NL', 'NLD', 'هولندا'),
(6399, 1048870400, 1048870911, 'DE', 'DEU', 'ألمانيا'),
(6400, 1048870912, 1048871095, 'NL', 'NLD', 'هولندا'),
(6401, 1048871096, 1048871103, 'DE', 'DEU', 'ألمانيا'),
(6402, 1048871104, 1048871935, 'NL', 'NLD', 'هولندا'),
(6403, 1048871936, 1048872703, 'DE', 'DEU', 'ألمانيا'),
(6404, 1048872704, 1048872735, 'NL', 'NLD', 'هولندا'),
(6405, 1048872736, 1048872743, 'DE', 'DEU', 'ألمانيا'),
(6406, 1048872744, 1048873263, 'NL', 'NLD', 'هولندا'),
(6407, 1048873264, 1048873271, 'DE', 'DEU', 'ألمانيا'),
(6408, 1048873272, 1048873743, 'NL', 'NLD', 'هولندا'),
(6409, 1048873744, 1048873751, 'DE', 'DEU', 'ألمانيا'),
(6410, 1048873752, 1048873791, 'NL', 'NLD', 'هولندا'),
(6411, 1048873792, 1048873799, 'DE', 'DEU', 'ألمانيا'),
(6412, 1048873800, 1048873935, 'NL', 'NLD', 'هولندا'),
(6413, 1048873936, 1048873951, 'DE', 'DEU', 'ألمانيا'),
(6414, 1048873952, 1048874151, 'NL', 'NLD', 'هولندا'),
(6415, 1048874152, 1048874159, 'DE', 'DEU', 'ألمانيا'),
(6416, 1048874160, 1048874295, 'NL', 'NLD', 'هولندا'),
(6417, 1048874296, 1048874303, 'DE', 'DEU', 'ألمانيا'),
(6418, 1048874304, 1048874327, 'NL', 'NLD', 'هولندا'),
(6419, 1048874328, 1048874335, 'DE', 'DEU', 'ألمانيا'),
(6420, 1048874336, 1048874359, 'NL', 'NLD', 'هولندا'),
(6421, 1048874360, 1048874367, 'DE', 'DEU', 'ألمانيا'),
(6422, 1048874368, 1048874415, 'NL', 'NLD', 'هولندا'),
(6423, 1048874416, 1048874423, 'DE', 'DEU', 'ألمانيا'),
(6424, 1048874424, 1048874447, 'NL', 'NLD', 'هولندا'),
(6425, 1048874448, 1048874455, 'DE', 'DEU', 'ألمانيا'),
(6426, 1048874456, 1048874471, 'NL', 'NLD', 'هولندا'),
(6427, 1048874472, 1048874479, 'DE', 'DEU', 'ألمانيا'),
(6428, 1048874480, 1048874535, 'NL', 'NLD', 'هولندا'),
(6429, 1048874536, 1048874543, 'DE', 'DEU', 'ألمانيا'),
(6430, 1048874544, 1048874703, 'NL', 'NLD', 'هولندا'),
(6431, 1048874704, 1048874711, 'DE', 'DEU', 'ألمانيا'),
(6432, 1048874712, 1048875015, 'NL', 'NLD', 'هولندا'),
(6433, 1048875016, 1048875023, 'DE', 'DEU', 'ألمانيا'),
(6434, 1048875024, 1048875191, 'NL', 'NLD', 'هولندا'),
(6435, 1048875192, 1048875199, 'DE', 'DEU', 'ألمانيا'),
(6436, 1048875200, 1048875391, 'NL', 'NLD', 'هولندا'),
(6437, 1048875392, 1048875399, 'DE', 'DEU', 'ألمانيا'),
(6438, 1048875400, 1048875671, 'NL', 'NLD', 'هولندا'),
(6439, 1048875672, 1048875679, 'DE', 'DEU', 'ألمانيا'),
(6440, 1048875680, 1048875687, 'NL', 'NLD', 'هولندا'),
(6441, 1048875688, 1048875695, 'DE', 'DEU', 'ألمانيا'),
(6442, 1048875696, 1048875703, 'NL', 'NLD', 'هولندا'),
(6443, 1048875704, 1048875711, 'DE', 'DEU', 'ألمانيا'),
(6444, 1048875712, 1048875823, 'NL', 'NLD', 'هولندا'),
(6445, 1048875824, 1048875839, 'DE', 'DEU', 'ألمانيا'),
(6446, 1048875840, 1048876255, 'NL', 'NLD', 'هولندا'),
(6447, 1048876256, 1048876263, 'DE', 'DEU', 'ألمانيا'),
(6448, 1048876264, 1048876327, 'NL', 'NLD', 'هولندا'),
(6449, 1048876328, 1048876335, 'DE', 'DEU', 'ألمانيا'),
(6450, 1048876336, 1048876807, 'NL', 'NLD', 'هولندا'),
(6451, 1048876808, 1048876815, 'DE', 'DEU', 'ألمانيا'),
(6452, 1048876816, 1048876823, 'NL', 'NLD', 'هولندا'),
(6453, 1048876824, 1048876831, 'DE', 'DEU', 'ألمانيا'),
(6454, 1048876832, 1048876991, 'NL', 'NLD', 'هولندا'),
(6455, 1048876992, 1048876999, 'DE', 'DEU', 'ألمانيا'),
(6456, 1048877000, 1048877023, 'NL', 'NLD', 'هولندا'),
(6457, 1048877024, 1048877031, 'DE', 'DEU', 'ألمانيا'),
(6458, 1048877032, 1048877039, 'NL', 'NLD', 'هولندا'),
(6459, 1048877040, 1048877055, 'DE', 'DEU', 'ألمانيا'),
(6460, 1048877056, 1048877071, 'NL', 'NLD', 'هولندا'),
(6461, 1048877072, 1048877079, 'DE', 'DEU', 'ألمانيا'),
(6462, 1048877080, 1048877103, 'NL', 'NLD', 'هولندا'),
(6463, 1048877104, 1048877111, 'DE', 'DEU', 'ألمانيا'),
(6464, 1048877112, 1048877191, 'NL', 'NLD', 'هولندا'),
(6465, 1048877192, 1048877199, 'DE', 'DEU', 'ألمانيا'),
(6466, 1048877200, 1048877247, 'NL', 'NLD', 'هولندا'),
(6467, 1048877248, 1048877263, 'DE', 'DEU', 'ألمانيا'),
(6468, 1048877264, 1048877287, 'NL', 'NLD', 'هولندا'),
(6469, 1048877288, 1048877295, 'DE', 'DEU', 'ألمانيا'),
(6470, 1048877296, 1048877311, 'NL', 'NLD', 'هولندا'),
(6471, 1048877312, 1048878087, 'DE', 'DEU', 'ألمانيا'),
(6472, 1048878088, 1048878103, 'NL', 'NLD', 'هولندا'),
(6473, 1048878104, 1048878111, 'DE', 'DEU', 'ألمانيا'),
(6474, 1048878112, 1048878335, 'NL', 'NLD', 'هولندا'),
(6475, 1048878336, 1048878343, 'DE', 'DEU', 'ألمانيا'),
(6476, 1048878344, 1048878447, 'NL', 'NLD', 'هولندا'),
(6477, 1048878448, 1048878455, 'DE', 'DEU', 'ألمانيا'),
(6478, 1048878456, 1048878487, 'NL', 'NLD', 'هولندا'),
(6479, 1048878488, 1048878495, 'DE', 'DEU', 'ألمانيا'),
(6480, 1048878496, 1048878543, 'NL', 'NLD', 'هولندا'),
(6481, 1048878544, 1048878551, 'DE', 'DEU', 'ألمانيا'),
(6482, 1048878552, 1048878663, 'NL', 'NLD', 'هولندا'),
(6483, 1048878664, 1048878671, 'DE', 'DEU', 'ألمانيا'),
(6484, 1048878672, 1048878751, 'NL', 'NLD', 'هولندا'),
(6485, 1048878752, 1048878759, 'DE', 'DEU', 'ألمانيا'),
(6486, 1048878760, 1048878815, 'NL', 'NLD', 'هولندا'),
(6487, 1048878816, 1048878823, 'DE', 'DEU', 'ألمانيا'),
(6488, 1048878824, 1048878831, 'NL', 'NLD', 'هولندا'),
(6489, 1048878832, 1048878839, 'DE', 'DEU', 'ألمانيا'),
(6490, 1048878840, 1048878983, 'NL', 'NLD', 'هولندا'),
(6491, 1048878984, 1048878991, 'DE', 'DEU', 'ألمانيا'),
(6492, 1048878992, 1048879047, 'NL', 'NLD', 'هولندا'),
(6493, 1048879048, 1048879055, 'DE', 'DEU', 'ألمانيا'),
(6494, 1048879056, 1048879199, 'NL', 'NLD', 'هولندا'),
(6495, 1048879200, 1048879207, 'DE', 'DEU', 'ألمانيا'),
(6496, 1048879208, 1048879263, 'NL', 'NLD', 'هولندا'),
(6497, 1048879264, 1048879271, 'DE', 'DEU', 'ألمانيا'),
(6498, 1048879272, 1048879335, 'NL', 'NLD', 'هولندا'),
(6499, 1048879336, 1048879343, 'DE', 'DEU', 'ألمانيا'),
(6500, 1048879344, 1048879455, 'NL', 'NLD', 'هولندا'),
(6501, 1048879456, 1048879463, 'DE', 'DEU', 'ألمانيا'),
(6502, 1048879464, 1048879687, 'NL', 'NLD', 'هولندا'),
(6503, 1048879688, 1048879695, 'DE', 'DEU', 'ألمانيا'),
(6504, 1048879696, 1048880311, 'NL', 'NLD', 'هولندا'),
(6505, 1048880312, 1048880327, 'DE', 'DEU', 'ألمانيا'),
(6506, 1048880328, 1048880639, 'NL', 'NLD', 'هولندا'),
(6507, 1048880640, 1048881159, 'DE', 'DEU', 'ألمانيا'),
(6508, 1048881160, 1048881615, 'NL', 'NLD', 'هولندا'),
(6509, 1048881616, 1048881631, 'DE', 'DEU', 'ألمانيا'),
(6510, 1048881632, 1048882071, 'NL', 'NLD', 'هولندا'),
(6511, 1048882072, 1048882079, 'DE', 'DEU', 'ألمانيا'),
(6512, 1048882080, 1048882143, 'NL', 'NLD', 'هولندا'),
(6513, 1048882144, 1048882151, 'DE', 'DEU', 'ألمانيا'),
(6514, 1048882152, 1048882311, 'NL', 'NLD', 'هولندا'),
(6515, 1048882312, 1048882319, 'DE', 'DEU', 'ألمانيا'),
(6516, 1048882320, 1048882495, 'NL', 'NLD', 'هولندا'),
(6517, 1048882496, 1048882503, 'DE', 'DEU', 'ألمانيا'),
(6518, 1048882504, 1048882703, 'NL', 'NLD', 'هولندا'),
(6519, 1048882704, 1048882711, 'DE', 'DEU', 'ألمانيا'),
(6520, 1048882712, 1048882743, 'NL', 'NLD', 'هولندا'),
(6521, 1048882744, 1048882751, 'DE', 'DEU', 'ألمانيا'),
(6522, 1048882752, 1048882823, 'NL', 'NLD', 'هولندا'),
(6523, 1048882824, 1048882831, 'DE', 'DEU', 'ألمانيا'),
(6524, 1048882832, 1048882855, 'NL', 'NLD', 'هولندا'),
(6525, 1048882856, 1048882863, 'DE', 'DEU', 'ألمانيا'),
(6526, 1048882864, 1048882951, 'NL', 'NLD', 'هولندا'),
(6527, 1048882952, 1048882959, 'DE', 'DEU', 'ألمانيا'),
(6528, 1048882960, 1048883167, 'NL', 'NLD', 'هولندا'),
(6529, 1048883168, 1048883175, 'DE', 'DEU', 'ألمانيا'),
(6530, 1048883176, 1048883319, 'NL', 'NLD', 'هولندا'),
(6531, 1048883320, 1048883327, 'DE', 'DEU', 'ألمانيا'),
(6532, 1048883328, 1048883351, 'NL', 'NLD', 'هولندا'),
(6533, 1048883352, 1048883359, 'DE', 'DEU', 'ألمانيا'),
(6534, 1048883360, 1048883871, 'NL', 'NLD', 'هولندا'),
(6535, 1048883872, 1048883879, 'DE', 'DEU', 'ألمانيا'),
(6536, 1048883880, 1048884279, 'NL', 'NLD', 'هولندا'),
(6537, 1048884280, 1048884295, 'DE', 'DEU', 'ألمانيا'),
(6538, 1048884296, 1048884975, 'NL', 'NLD', 'هولندا'),
(6539, 1048884976, 1048884983, 'DE', 'DEU', 'ألمانيا'),
(6540, 1048884984, 1048884991, 'NL', 'NLD', 'هولندا'),
(6541, 1048884992, 1048884999, 'DE', 'DEU', 'ألمانيا'),
(6542, 1048885000, 1048885111, 'NL', 'NLD', 'هولندا'),
(6543, 1048885112, 1048885119, 'DE', 'DEU', 'ألمانيا'),
(6544, 1048885120, 1048885471, 'NL', 'NLD', 'هولندا'),
(6545, 1048885472, 1048885479, 'DE', 'DEU', 'ألمانيا'),
(6546, 1048885480, 1048885575, 'NL', 'NLD', 'هولندا'),
(6547, 1048885576, 1048885583, 'DE', 'DEU', 'ألمانيا'),
(6548, 1048885584, 1048885703, 'NL', 'NLD', 'هولندا'),
(6549, 1048885704, 1048885711, 'DE', 'DEU', 'ألمانيا'),
(6550, 1048885712, 1048885767, 'NL', 'NLD', 'هولندا'),
(6551, 1048885768, 1048885775, 'DE', 'DEU', 'ألمانيا'),
(6552, 1048885776, 1048885815, 'NL', 'NLD', 'هولندا'),
(6553, 1048885816, 1048885823, 'DE', 'DEU', 'ألمانيا'),
(6554, 1048885824, 1048885839, 'NL', 'NLD', 'هولندا'),
(6555, 1048885840, 1048885847, 'DE', 'DEU', 'ألمانيا'),
(6556, 1048885848, 1048886239, 'NL', 'NLD', 'هولندا'),
(6557, 1048886240, 1048886247, 'DE', 'DEU', 'ألمانيا'),
(6558, 1048886248, 1048886343, 'NL', 'NLD', 'هولندا'),
(6559, 1048886344, 1048886351, 'DE', 'DEU', 'ألمانيا'),
(6560, 1048886352, 1048886431, 'NL', 'NLD', 'هولندا'),
(6561, 1048886432, 1048886439, 'DE', 'DEU', 'ألمانيا'),
(6562, 1048886440, 1048886463, 'NL', 'NLD', 'هولندا'),
(6563, 1048886464, 1048886471, 'DE', 'DEU', 'ألمانيا'),
(6564, 1048886472, 1048886615, 'NL', 'NLD', 'هولندا'),
(6565, 1048886616, 1048886623, 'DE', 'DEU', 'ألمانيا'),
(6566, 1048886624, 1048886871, 'NL', 'NLD', 'هولندا'),
(6567, 1048886872, 1048886879, 'DE', 'DEU', 'ألمانيا'),
(6568, 1048886880, 1048886903, 'NL', 'NLD', 'هولندا'),
(6569, 1048886904, 1048886911, 'DE', 'DEU', 'ألمانيا'),
(6570, 1048886912, 1048887039, 'NL', 'NLD', 'هولندا'),
(6571, 1048887040, 1048887047, 'DE', 'DEU', 'ألمانيا'),
(6572, 1048887048, 1048887935, 'NL', 'NLD', 'هولندا'),
(6573, 1048887936, 1048887999, 'DE', 'DEU', 'ألمانيا'),
(6574, 1048888000, 1048891391, 'NL', 'NLD', 'هولندا'),
(6575, 1048891392, 1048891399, 'DE', 'DEU', 'ألمانيا'),
(6576, 1048891400, 1048891823, 'NL', 'NLD', 'هولندا'),
(6577, 1048891824, 1048891831, 'DE', 'DEU', 'ألمانيا'),
(6578, 1048891832, 1048891911, 'NL', 'NLD', 'هولندا'),
(6579, 1048891912, 1048891919, 'DE', 'DEU', 'ألمانيا'),
(6580, 1048891920, 1048892311, 'NL', 'NLD', 'هولندا'),
(6581, 1048892312, 1048892319, 'DE', 'DEU', 'ألمانيا'),
(6582, 1048892320, 1048892343, 'NL', 'NLD', 'هولندا'),
(6583, 1048892344, 1048892351, 'DE', 'DEU', 'ألمانيا'),
(6584, 1048892352, 1048892367, 'NL', 'NLD', 'هولندا'),
(6585, 1048892368, 1048892375, 'DE', 'DEU', 'ألمانيا'),
(6586, 1048892376, 1048892815, 'NL', 'NLD', 'هولندا'),
(6587, 1048892816, 1048892823, 'DE', 'DEU', 'ألمانيا'),
(6588, 1048892824, 1048892863, 'NL', 'NLD', 'هولندا'),
(6589, 1048892864, 1048892871, 'DE', 'DEU', 'ألمانيا'),
(6590, 1048892872, 1048892895, 'NL', 'NLD', 'هولندا'),
(6591, 1048892896, 1048892903, 'DE', 'DEU', 'ألمانيا'),
(6592, 1048892904, 1048893279, 'NL', 'NLD', 'هولندا'),
(6593, 1048893280, 1048893287, 'DE', 'DEU', 'ألمانيا'),
(6594, 1048893288, 1048893303, 'NL', 'NLD', 'هولندا'),
(6595, 1048893304, 1048893311, 'DE', 'DEU', 'ألمانيا'),
(6596, 1048893312, 1048893591, 'NL', 'NLD', 'هولندا'),
(6597, 1048893592, 1048893599, 'DE', 'DEU', 'ألمانيا'),
(6598, 1048893600, 1048893703, 'NL', 'NLD', 'هولندا'),
(6599, 1048893704, 1048893711, 'DE', 'DEU', 'ألمانيا'),
(6600, 1048893712, 1048893719, 'NL', 'NLD', 'هولندا'),
(6601, 1048893720, 1048893727, 'DE', 'DEU', 'ألمانيا'),
(6602, 1048893728, 1048893919, 'NL', 'NLD', 'هولندا'),
(6603, 1048893920, 1048893927, 'DE', 'DEU', 'ألمانيا'),
(6604, 1048893928, 1048893983, 'NL', 'NLD', 'هولندا'),
(6605, 1048893984, 1048893991, 'DE', 'DEU', 'ألمانيا'),
(6606, 1048893992, 1048894039, 'NL', 'NLD', 'هولندا'),
(6607, 1048894040, 1048894047, 'DE', 'DEU', 'ألمانيا'),
(6608, 1048894048, 1048894071, 'NL', 'NLD', 'هولندا'),
(6609, 1048894072, 1048894079, 'DE', 'DEU', 'ألمانيا'),
(6610, 1048894080, 1048894215, 'NL', 'NLD', 'هولندا'),
(6611, 1048894216, 1048894223, 'DE', 'DEU', 'ألمانيا'),
(6612, 1048894224, 1048894471, 'NL', 'NLD', 'هولندا'),
(6613, 1048894472, 1048894479, 'DE', 'DEU', 'ألمانيا'),
(6614, 1048894480, 1048894487, 'NL', 'NLD', 'هولندا'),
(6615, 1048894488, 1048894495, 'DE', 'DEU', 'ألمانيا'),
(6616, 1048894496, 1048894607, 'NL', 'NLD', 'هولندا'),
(6617, 1048894608, 1048894615, 'DE', 'DEU', 'ألمانيا'),
(6618, 1048894616, 1048894671, 'NL', 'NLD', 'هولندا'),
(6619, 1048894672, 1048894679, 'DE', 'DEU', 'ألمانيا'),
(6620, 1048894680, 1048894735, 'NL', 'NLD', 'هولندا'),
(6621, 1048894736, 1048894743, 'DE', 'DEU', 'ألمانيا'),
(6622, 1048894744, 1048894895, 'NL', 'NLD', 'هولندا'),
(6623, 1048894896, 1048894903, 'DE', 'DEU', 'ألمانيا'),
(6624, 1048894904, 1048895031, 'NL', 'NLD', 'هولندا'),
(6625, 1048895032, 1048895039, 'DE', 'DEU', 'ألمانيا'),
(6626, 1048895040, 1048895079, 'NL', 'NLD', 'هولندا'),
(6627, 1048895080, 1048895087, 'DE', 'DEU', 'ألمانيا'),
(6628, 1048895088, 1048895271, 'NL', 'NLD', 'هولندا'),
(6629, 1048895272, 1048895279, 'DE', 'DEU', 'ألمانيا'),
(6630, 1048895280, 1048895439, 'NL', 'NLD', 'هولندا'),
(6631, 1048895440, 1048895447, 'DE', 'DEU', 'ألمانيا'),
(6632, 1048895448, 1048895551, 'NL', 'NLD', 'هولندا'),
(6633, 1048895552, 1048895559, 'DE', 'DEU', 'ألمانيا'),
(6634, 1048895560, 1048895647, 'NL', 'NLD', 'هولندا'),
(6635, 1048895648, 1048895655, 'DE', 'DEU', 'ألمانيا'),
(6636, 1048895656, 1048895967, 'NL', 'NLD', 'هولندا'),
(6637, 1048895968, 1048895975, 'DE', 'DEU', 'ألمانيا'),
(6638, 1048895976, 1048896231, 'NL', 'NLD', 'هولندا'),
(6639, 1048896232, 1048896239, 'DE', 'DEU', 'ألمانيا'),
(6640, 1048896240, 1048896271, 'NL', 'NLD', 'هولندا'),
(6641, 1048896272, 1048896279, 'DE', 'DEU', 'ألمانيا'),
(6642, 1048896280, 1048896319, 'NL', 'NLD', 'هولندا'),
(6643, 1048896320, 1048896327, 'DE', 'DEU', 'ألمانيا'),
(6644, 1048896328, 1048896479, 'NL', 'NLD', 'هولندا'),
(6645, 1048896480, 1048896487, 'DE', 'DEU', 'ألمانيا'),
(6646, 1048896488, 1048896519, 'NL', 'NLD', 'هولندا'),
(6647, 1048896520, 1048896535, 'DE', 'DEU', 'ألمانيا'),
(6648, 1048896536, 1048896671, 'NL', 'NLD', 'هولندا'),
(6649, 1048896672, 1048896679, 'DE', 'DEU', 'ألمانيا'),
(6650, 1048896680, 1048896687, 'NL', 'NLD', 'هولندا'),
(6651, 1048896688, 1048896695, 'DE', 'DEU', 'ألمانيا'),
(6652, 1048896696, 1048896735, 'NL', 'NLD', 'هولندا'),
(6653, 1048896736, 1048896743, 'DE', 'DEU', 'ألمانيا'),
(6654, 1048896744, 1048896871, 'NL', 'NLD', 'هولندا'),
(6655, 1048896872, 1048896879, 'DE', 'DEU', 'ألمانيا'),
(6656, 1048896880, 1048896967, 'NL', 'NLD', 'هولندا'),
(6657, 1048896968, 1048896975, 'DE', 'DEU', 'ألمانيا'),
(6658, 1048896976, 1048897119, 'NL', 'NLD', 'هولندا'),
(6659, 1048897120, 1048897135, 'DE', 'DEU', 'ألمانيا'),
(6660, 1048897136, 1048897239, 'NL', 'NLD', 'هولندا'),
(6661, 1048897240, 1048897247, 'DE', 'DEU', 'ألمانيا'),
(6662, 1048897248, 1048897271, 'NL', 'NLD', 'هولندا'),
(6663, 1048897272, 1048897279, 'DE', 'DEU', 'ألمانيا'),
(6664, 1048897280, 1048897295, 'NL', 'NLD', 'هولندا'),
(6665, 1048897296, 1048897311, 'DE', 'DEU', 'ألمانيا'),
(6666, 1048897312, 1048897319, 'NL', 'NLD', 'هولندا'),
(6667, 1048897320, 1048897327, 'DE', 'DEU', 'ألمانيا'),
(6668, 1048897328, 1048897367, 'NL', 'NLD', 'هولندا'),
(6669, 1048897368, 1048897375, 'DE', 'DEU', 'ألمانيا'),
(6670, 1048897376, 1048897463, 'NL', 'NLD', 'هولندا'),
(6671, 1048897464, 1048897471, 'DE', 'DEU', 'ألمانيا'),
(6672, 1048897472, 1048897495, 'NL', 'NLD', 'هولندا'),
(6673, 1048897496, 1048897503, 'DE', 'DEU', 'ألمانيا'),
(6674, 1048897504, 1048897735, 'NL', 'NLD', 'هولندا'),
(6675, 1048897736, 1048897743, 'DE', 'DEU', 'ألمانيا'),
(6676, 1048897744, 1048898719, 'NL', 'NLD', 'هولندا'),
(6677, 1048898720, 1048898727, 'DE', 'DEU', 'ألمانيا'),
(6678, 1048898728, 1048898991, 'NL', 'NLD', 'هولندا'),
(6679, 1048898992, 1048898999, 'DE', 'DEU', 'ألمانيا'),
(6680, 1048899000, 1048899047, 'NL', 'NLD', 'هولندا'),
(6681, 1048899048, 1048899055, 'DE', 'DEU', 'ألمانيا'),
(6682, 1048899056, 1048899271, 'NL', 'NLD', 'هولندا'),
(6683, 1048899272, 1048899279, 'DE', 'DEU', 'ألمانيا'),
(6684, 1048899280, 1048899287, 'NL', 'NLD', 'هولندا'),
(6685, 1048899288, 1048899295, 'DE', 'DEU', 'ألمانيا'),
(6686, 1048899296, 1048899303, 'NL', 'NLD', 'هولندا'),
(6687, 1048899304, 1048899311, 'DE', 'DEU', 'ألمانيا'),
(6688, 1048899312, 1048899591, 'NL', 'NLD', 'هولندا'),
(6689, 1048899592, 1048899599, 'DE', 'DEU', 'ألمانيا'),
(6690, 1048899600, 1048900071, 'NL', 'NLD', 'هولندا'),
(6691, 1048900072, 1048900079, 'DE', 'DEU', 'ألمانيا'),
(6692, 1048900080, 1048900127, 'NL', 'NLD', 'هولندا'),
(6693, 1048900128, 1048900135, 'DE', 'DEU', 'ألمانيا'),
(6694, 1048900136, 1048900311, 'NL', 'NLD', 'هولندا'),
(6695, 1048900312, 1048900319, 'DE', 'DEU', 'ألمانيا'),
(6696, 1048900320, 1048900343, 'NL', 'NLD', 'هولندا'),
(6697, 1048900344, 1048900351, 'DE', 'DEU', 'ألمانيا'),
(6698, 1048900352, 1048900367, 'NL', 'NLD', 'هولندا'),
(6699, 1048900368, 1048900375, 'DE', 'DEU', 'ألمانيا'),
(6700, 1048900376, 1048900391, 'NL', 'NLD', 'هولندا'),
(6701, 1048900392, 1048900399, 'DE', 'DEU', 'ألمانيا'),
(6702, 1048900400, 1048900703, 'NL', 'NLD', 'هولندا'),
(6703, 1048900704, 1048900711, 'DE', 'DEU', 'ألمانيا'),
(6704, 1048900712, 1048900935, 'NL', 'NLD', 'هولندا'),
(6705, 1048900936, 1048900951, 'DE', 'DEU', 'ألمانيا'),
(6706, 1048900952, 1048901167, 'NL', 'NLD', 'هولندا'),
(6707, 1048901168, 1048901175, 'DE', 'DEU', 'ألمانيا'),
(6708, 1048901176, 1048901199, 'NL', 'NLD', 'هولندا'),
(6709, 1048901200, 1048901207, 'DE', 'DEU', 'ألمانيا'),
(6710, 1048901208, 1048901311, 'NL', 'NLD', 'هولندا'),
(6711, 1048901312, 1048901319, 'DE', 'DEU', 'ألمانيا'),
(6712, 1048901320, 1048901327, 'NL', 'NLD', 'هولندا'),
(6713, 1048901328, 1048901335, 'DE', 'DEU', 'ألمانيا'),
(6714, 1048901336, 1048901615, 'NL', 'NLD', 'هولندا'),
(6715, 1048901616, 1048901623, 'DE', 'DEU', 'ألمانيا'),
(6716, 1048901624, 1048901831, 'NL', 'NLD', 'هولندا'),
(6717, 1048901832, 1048901839, 'DE', 'DEU', 'ألمانيا'),
(6718, 1048901840, 1048901847, 'NL', 'NLD', 'هولندا'),
(6719, 1048901848, 1048901863, 'DE', 'DEU', 'ألمانيا'),
(6720, 1048901864, 1048902335, 'NL', 'NLD', 'هولندا'),
(6721, 1048902336, 1048902343, 'DE', 'DEU', 'ألمانيا'),
(6722, 1048902344, 1048902359, 'NL', 'NLD', 'هولندا'),
(6723, 1048902360, 1048902367, 'DE', 'DEU', 'ألمانيا'),
(6724, 1048902368, 1048902391, 'NL', 'NLD', 'هولندا'),
(6725, 1048902392, 1048902399, 'DE', 'DEU', 'ألمانيا'),
(6726, 1048902400, 1048902447, 'NL', 'NLD', 'هولندا'),
(6727, 1048902448, 1048902455, 'DE', 'DEU', 'ألمانيا'),
(6728, 1048902456, 1048902527, 'NL', 'NLD', 'هولندا'),
(6729, 1048902528, 1048902535, 'DE', 'DEU', 'ألمانيا'),
(6730, 1048902536, 1048902583, 'NL', 'NLD', 'هولندا'),
(6731, 1048902584, 1048902591, 'DE', 'DEU', 'ألمانيا'),
(6732, 1048902592, 1048902671, 'NL', 'NLD', 'هولندا'),
(6733, 1048902672, 1048902679, 'DE', 'DEU', 'ألمانيا'),
(6734, 1048902680, 1048903071, 'NL', 'NLD', 'هولندا'),
(6735, 1048903072, 1048903079, 'DE', 'DEU', 'ألمانيا'),
(6736, 1048903080, 1048903095, 'NL', 'NLD', 'هولندا'),
(6737, 1048903096, 1048903103, 'DE', 'DEU', 'ألمانيا'),
(6738, 1048903104, 1048903679, 'NL', 'NLD', 'هولندا'),
(6739, 1048903680, 1048911871, 'GB', 'GBR', 'المملكة المتحدة'),
(6740, 1048911872, 1048920063, 'IT', 'ITA', 'إيطاليا'),
(6741, 1048920064, 1048936447, 'NL', 'NLD', 'هولندا'),
(6742, 1048936448, 1048944639, 'PL', 'POL', 'بولندا'),
(6743, 1048944640, 1048952831, 'RU', 'RUS', 'الإتحاد الروسي'),
(6744, 1048952832, 1048953407, 'NL', 'NLD', 'هولندا'),
(6745, 1048953408, 1048953439, 'BE', 'BEL', 'بلجيكا'),
(6746, 1048953440, 1048954967, 'NL', 'NLD', 'هولندا'),
(6747, 1048954968, 1048954975, 'BE', 'BEL', 'بلجيكا'),
(6748, 1048954976, 1048969215, 'NL', 'NLD', 'هولندا'),
(6749, 1048969856, 1048969887, 'DE', 'DEU', 'ألمانيا'),
(6750, 1048971064, 1048971068, 'DE', 'DEU', 'ألمانيا'),
(6751, 1048971328, 1048971391, 'DE', 'DEU', 'ألمانيا'),
(6752, 1048972720, 1048972727, 'DE', 'DEU', 'ألمانيا'),
(6753, 1048973440, 1048973567, 'DE', 'DEU', 'ألمانيا'),
(6754, 1048974336, 1048975183, 'DE', 'DEU', 'ألمانيا'),
(6755, 1048976288, 1048976295, 'DE', 'DEU', 'ألمانيا'),
(6756, 1048976297, 1048976302, 'DE', 'DEU', 'ألمانيا'),
(6757, 1048976304, 1048976319, 'DE', 'DEU', 'ألمانيا'),
(6758, 1048976384, 1048976447, 'DE', 'DEU', 'ألمانيا'),
(6759, 1048976512, 1048977407, 'DE', 'DEU', 'ألمانيا'),
(6760, 1048978432, 1048978943, 'DE', 'DEU', 'ألمانيا'),
(6761, 1048979136, 1048979295, 'DE', 'DEU', 'ألمانيا'),
(6762, 1048979456, 1048980495, 'DE', 'DEU', 'ألمانيا'),
(6763, 1048980512, 1048980527, 'DE', 'DEU', 'ألمانيا'),
(6764, 1048980560, 1048980731, 'DE', 'DEU', 'ألمانيا'),
(6765, 1048980736, 1048980791, 'DE', 'DEU', 'ألمانيا'),
(6766, 1048980804, 1048980807, 'DE', 'DEU', 'ألمانيا'),
(6767, 1048980816, 1048980823, 'DE', 'DEU', 'ألمانيا'),
(6768, 1048980832, 1048980959, 'DE', 'DEU', 'ألمانيا'),
(6769, 1048980968, 1048980975, 'DE', 'DEU', 'ألمانيا'),
(6770, 1048981504, 1048981759, 'DE', 'DEU', 'ألمانيا'),
(6771, 1048981792, 1048981823, 'DE', 'DEU', 'ألمانيا'),
(6772, 1048982016, 1048982607, 'DE', 'DEU', 'ألمانيا'),
(6773, 1048982625, 1048982663, 'DE', 'DEU', 'ألمانيا'),
(6774, 1048982688, 1048982695, 'DE', 'DEU', 'ألمانيا'),
(6775, 1048982721, 1048982782, 'DE', 'DEU', 'ألمانيا'),
(6776, 1048982824, 1048982943, 'DE', 'DEU', 'ألمانيا'),
(6777, 1048982960, 1048983023, 'DE', 'DEU', 'ألمانيا'),
(6778, 1048983168, 1048983423, 'DE', 'DEU', 'ألمانيا'),
(6779, 1048983488, 1048983679, 'DE', 'DEU', 'ألمانيا'),
(6780, 1048984832, 1048985167, 'DE', 'DEU', 'ألمانيا'),
(6781, 1048985184, 1048985199, 'DE', 'DEU', 'ألمانيا'),
(6782, 1048985216, 1048985375, 'DE', 'DEU', 'ألمانيا'),
(6783, 1048986880, 1048987135, 'DE', 'DEU', 'ألمانيا'),
(6784, 1049001984, 1049002015, 'DE', 'DEU', 'ألمانيا'),
(6785, 1049002176, 1049002239, 'DE', 'DEU', 'ألمانيا'),
(6786, 1049002624, 1049002751, 'DE', 'DEU', 'ألمانيا'),
(6787, 1049003264, 1049004291, 'DE', 'DEU', 'ألمانيا'),
(6788, 1049004352, 1049004415, 'DE', 'DEU', 'ألمانيا'),
(6789, 1049004544, 1049006079, 'DE', 'DEU', 'ألمانيا'),
(6790, 1049007104, 1049007111, 'DE', 'DEU', 'ألمانيا'),
(6791, 1049007120, 1049007135, 'DE', 'DEU', 'ألمانيا'),
(6792, 1049007360, 1049009535, 'DE', 'DEU', 'ألمانيا'),
(6793, 1049009560, 1049009567, 'DE', 'DEU', 'ألمانيا'),
(6794, 1049009584, 1049009615, 'DE', 'DEU', 'ألمانيا'),
(6795, 1049009624, 1049009631, 'DE', 'DEU', 'ألمانيا'),
(6796, 1049009648, 1049009662, 'DE', 'DEU', 'ألمانيا'),
(6797, 1049009664, 1049011711, 'DE', 'DEU', 'ألمانيا'),
(6798, 1049011968, 1049012223, 'DE', 'DEU', 'ألمانيا'),
(6799, 1049012225, 1049012226, 'DE', 'DEU', 'ألمانيا'),
(6800, 1049012736, 1049016703, 'DE', 'DEU', 'ألمانيا'),
(6801, 1049016704, 1049016711, 'FR', 'FRA', 'فرنسا'),
(6802, 1049016712, 1049016715, 'RU', 'RUS', 'الإتحاد الروسي'),
(6803, 1049016716, 1049016743, 'DE', 'DEU', 'ألمانيا'),
(6804, 1049016744, 1049016751, 'MA', 'MAR', 'المغرب'),
(6805, 1049016752, 1049016759, 'DE', 'DEU', 'ألمانيا'),
(6806, 1049016760, 1049016767, 'FR', 'FRA', 'فرنسا'),
(6807, 1049016768, 1049016815, 'DE', 'DEU', 'ألمانيا'),
(6808, 1049016816, 1049016831, 'NL', 'NLD', 'هولندا'),
(6809, 1049016832, 1049016847, 'DE', 'DEU', 'ألمانيا'),
(6810, 1049016848, 1049016863, 'FR', 'FRA', 'فرنسا'),
(6811, 1049016864, 1049017983, 'DE', 'DEU', 'ألمانيا'),
(6812, 1049017984, 1049018047, 'GE', 'GEO', 'جورجيا'),
(6813, 1049018048, 1049020127, 'DE', 'DEU', 'ألمانيا'),
(6814, 1049020128, 1049020135, 'FR', 'FRA', 'فرنسا'),
(6815, 1049020136, 1049020479, 'DE', 'DEU', 'ألمانيا'),
(6816, 1049020480, 1049020543, 'GE', 'GEO', 'جورجيا'),
(6817, 1049020544, 1049026559, 'DE', 'DEU', 'ألمانيا'),
(6818, 1049026816, 1049032159, 'DE', 'DEU', 'ألمانيا'),
(6819, 1049032168, 1049032171, 'DE', 'DEU', 'ألمانيا'),
(6820, 1049032176, 1049032287, 'DE', 'DEU', 'ألمانيا'),
(6821, 1049032296, 1049032319, 'DE', 'DEU', 'ألمانيا'),
(6822, 1049032400, 1049032639, 'DE', 'DEU', 'ألمانيا'),
(6823, 1049032648, 1049032699, 'DE', 'DEU', 'ألمانيا'),
(6824, 1049032704, 1049034751, 'DE', 'DEU', 'ألمانيا'),
(6825, 1049067520, 1049100287, 'DK', 'DNK', 'الدنيمارك'),
(6826, 1049100288, 1049231359, 'GB', 'GBR', 'المملكة المتحدة'),
(6827, 1049231360, 1049296895, 'DE', 'DEU', 'ألمانيا'),
(6828, 1049362432, 1049362575, 'DE', 'DEU', 'ألمانيا'),
(6829, 1049362576, 1049362943, 'GB', 'GBR', 'المملكة المتحدة'),
(6830, 1049362944, 1049362959, 'DE', 'DEU', 'ألمانيا'),
(6831, 1049362960, 1049363071, 'GB', 'GBR', 'المملكة المتحدة'),
(6832, 1049363072, 1049363135, 'DE', 'DEU', 'ألمانيا'),
(6833, 1049363136, 1049363967, 'GB', 'GBR', 'المملكة المتحدة'),
(6834, 1049363968, 1049364223, 'DE', 'DEU', 'ألمانيا'),
(6835, 1049364224, 1049364991, 'GB', 'GBR', 'المملكة المتحدة'),
(6836, 1049364992, 1049365247, 'DE', 'DEU', 'ألمانيا'),
(6837, 1049365248, 1049365711, 'GB', 'GBR', 'المملكة المتحدة'),
(6838, 1049365712, 1049365719, 'DE', 'DEU', 'ألمانيا'),
(6839, 1049365720, 1049365727, 'GB', 'GBR', 'المملكة المتحدة'),
(6840, 1049365728, 1049365751, 'DE', 'DEU', 'ألمانيا'),
(6841, 1049365752, 1049365887, 'GB', 'GBR', 'المملكة المتحدة'),
(6842, 1049365888, 1049365951, 'DE', 'DEU', 'ألمانيا'),
(6843, 1049365952, 1049366015, 'GB', 'GBR', 'المملكة المتحدة'),
(6844, 1049366016, 1049366271, 'DE', 'DEU', 'ألمانيا'),
(6845, 1049366272, 1049366335, 'GB', 'GBR', 'المملكة المتحدة'),
(6846, 1049366336, 1049366399, 'DE', 'DEU', 'ألمانيا'),
(6847, 1049366400, 1049366527, 'GB', 'GBR', 'المملكة المتحدة'),
(6848, 1049366528, 1049368575, 'DE', 'DEU', 'ألمانيا'),
(6849, 1049368576, 1049368671, 'GB', 'GBR', 'المملكة المتحدة'),
(6850, 1049368672, 1049368687, 'DE', 'DEU', 'ألمانيا'),
(6851, 1049368688, 1049369599, 'GB', 'GBR', 'المملكة المتحدة'),
(6852, 1049369600, 1049369935, 'DE', 'DEU', 'ألمانيا'),
(6853, 1049369936, 1049369983, 'GB', 'GBR', 'المملكة المتحدة'),
(6854, 1049369984, 1049370047, 'DE', 'DEU', 'ألمانيا'),
(6855, 1049370048, 1049370175, 'GB', 'GBR', 'المملكة المتحدة'),
(6856, 1049370176, 1049370255, 'DE', 'DEU', 'ألمانيا'),
(6857, 1049370256, 1049370367, 'GB', 'GBR', 'المملكة المتحدة'),
(6858, 1049370368, 1049370623, 'DE', 'DEU', 'ألمانيا'),
(6859, 1049370624, 1049378815, 'AT', 'AUT', 'النمسا'),
(6860, 1049395200, 1049405055, 'NL', 'NLD', 'هولندا'),
(6861, 1049405056, 1049405183, 'GB', 'GBR', 'المملكة المتحدة'),
(6862, 1049405184, 1049405247, 'LU', 'LUX', 'لوكسيمبورغ'),
(6863, 1049405248, 1049405311, 'NL', 'NLD', 'هولندا'),
(6864, 1049405312, 1049405375, 'BE', 'BEL', 'بلجيكا'),
(6865, 1049405376, 1049405439, 'NL', 'NLD', 'هولندا'),
(6866, 1049405440, 1049405567, 'DE', 'DEU', 'ألمانيا'),
(6867, 1049405568, 1049405631, 'BE', 'BEL', 'بلجيكا'),
(6868, 1049405632, 1049405695, 'AT', 'AUT', 'النمسا'),
(6869, 1049405696, 1049405759, 'CH', 'CHE', 'سويسرا'),
(6870, 1049405760, 1049405823, 'ES', 'ESP', 'إسبانيا'),
(6871, 1049405824, 1049405887, 'FR', 'FRA', 'فرنسا'),
(6872, 1049405888, 1049405951, 'GB', 'GBR', 'المملكة المتحدة'),
(6873, 1049405952, 1049407615, 'NL', 'NLD', 'هولندا'),
(6874, 1049407616, 1049407999, 'CH', 'CHE', 'سويسرا'),
(6875, 1049408000, 1049409023, 'NL', 'NLD', 'هولندا'),
(6876, 1049409024, 1049409279, 'DE', 'DEU', 'ألمانيا'),
(6877, 1049409280, 1049411583, 'NL', 'NLD', 'هولندا'),
(6878, 1049411584, 1049419775, 'GB', 'GBR', 'المملكة المتحدة'),
(6879, 1049419776, 1049427967, 'RU', 'RUS', 'الإتحاد الروسي'),
(6880, 1049427968, 1049436159, 'CZ', 'CZE', 'التشيك'),
(6881, 1049436160, 1049444351, 'DE', 'DEU', 'ألمانيا'),
(6882, 1049444352, 1049460735, 'RU', 'RUS', 'الإتحاد الروسي'),
(6883, 1049460736, 1049468927, 'NO', 'NOR', 'النرويج'),
(6884, 1049468928, 1049477119, 'DE', 'DEU', 'ألمانيا'),
(6885, 1049477120, 1049493503, 'PL', 'POL', 'بولندا'),
(6886, 1049493504, 1049518079, 'FI', 'FIN', 'فنلندا'),
(6887, 1049518080, 1049518095, 'GB', 'GBR', 'المملكة المتحدة'),
(6888, 1049518096, 1049559039, 'FI', 'FIN', 'فنلندا'),
(6889, 1049559040, 1049653095, 'DE', 'DEU', 'ألمانيا'),
(6890, 1049653096, 1049653103, 'US', 'USA', 'الولايات المتحدة'),
(6891, 1049653104, 1049698303, 'DE', 'DEU', 'ألمانيا'),
(6892, 1049698304, 1049706495, 'NL', 'NLD', 'هولندا'),
(6893, 1049706496, 1049707007, 'GB', 'GBR', 'المملكة المتحدة'),
(6894, 1049707008, 1049707519, 'NL', 'NLD', 'هولندا'),
(6895, 1049707520, 1049707775, 'LB', 'LBN', 'لبنان'),
(6896, 1049707776, 1049708031, 'DZ', 'DZA', 'الجزائر'),
(6897, 1049708032, 1049709055, 'GB', 'GBR', 'المملكة المتحدة'),
(6898, 1049709056, 1049709311, 'NL', 'NLD', 'هولندا'),
(6899, 1049709312, 1049709567, 'GB', 'GBR', 'المملكة المتحدة'),
(6900, 1049709568, 1049710591, 'NL', 'NLD', 'هولندا'),
(6901, 1049710592, 1049712639, 'GB', 'GBR', 'المملكة المتحدة'),
(6902, 1049712640, 1049713055, 'IR', 'IRN', 'إيران'),
(6903, 1049713056, 1049713087, 'MA', 'MAR', 'المغرب'),
(6904, 1049713088, 1049713151, 'IR', 'IRN', 'إيران'),
(6905, 1049713152, 1049713663, 'NL', 'NLD', 'هولندا'),
(6906, 1049713664, 1049713791, 'LB', 'LBN', 'لبنان'),
(6907, 1049713792, 1049713919, 'IR', 'IRN', 'إيران'),
(6908, 1049713920, 1049714175, 'GB', 'GBR', 'المملكة المتحدة'),
(6909, 1049714176, 1049714687, 'NL', 'NLD', 'هولندا'),
(6910, 1049714688, 1049715711, 'IR', 'IRN', 'إيران'),
(6911, 1049715712, 1049716735, 'NL', 'NLD', 'هولندا'),
(6912, 1049716736, 1049717759, 'IQ', 'IRQ', 'العراق'),
(6913, 1049717760, 1049718015, 'GB', 'GBR', 'المملكة المتحدة'),
(6914, 1049718016, 1049718271, 'IR', 'IRN', 'إيران'),
(6915, 1049718272, 1049722879, 'NL', 'NLD', 'هولندا'),
(6916, 1049722880, 1049731071, 'IS', 'ISL', 'أيسلندا'),
(6917, 1049731072, 1049739263, 'FI', 'FIN', 'فنلندا'),
(6918, 1049739264, 1049755647, 'NL', 'NLD', 'هولندا'),
(6919, 1049755648, 1049757599, 'DE', 'DEU', 'ألمانيا'),
(6920, 1049757600, 1049757631, 'LU', 'LUX', 'لوكسيمبورغ'),
(6921, 1049757632, 1049757647, 'DE', 'DEU', 'ألمانيا'),
(6922, 1049757648, 1049757663, 'CA', 'CAN', 'كندا'),
(6923, 1049757664, 1049757671, 'BA', 'BIH', 'البوسنه والهرسك'),
(6924, 1049757672, 1049758063, 'DE', 'DEU', 'ألمانيا'),
(6925, 1049758064, 1049758071, 'PL', 'POL', 'بولندا'),
(6926, 1049758072, 1049758095, 'DE', 'DEU', 'ألمانيا'),
(6927, 1049758096, 1049758103, 'ES', 'ESP', 'إسبانيا'),
(6928, 1049758104, 1049758527, 'DE', 'DEU', 'ألمانيا'),
(6929, 1049758528, 1049758559, 'DK', 'DNK', 'الدنيمارك'),
(6930, 1049758560, 1049759983, 'DE', 'DEU', 'ألمانيا'),
(6931, 1049759984, 1049759999, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6932, 1049760000, 1049760639, 'DE', 'DEU', 'ألمانيا'),
(6933, 1049760640, 1049760703, 'IT', 'ITA', 'إيطاليا'),
(6934, 1049760704, 1049760927, 'DE', 'DEU', 'ألمانيا'),
(6935, 1049760928, 1049760959, 'DK', 'DNK', 'الدنيمارك'),
(6936, 1049760960, 1049761023, 'PL', 'POL', 'بولندا'),
(6937, 1049761024, 1049761791, 'DE', 'DEU', 'ألمانيا'),
(6938, 1049761792, 1049762047, 'PL', 'POL', 'بولندا'),
(6939, 1049762048, 1049762271, 'DE', 'DEU', 'ألمانيا'),
(6940, 1049762272, 1049762303, 'DK', 'DNK', 'الدنيمارك'),
(6941, 1049762304, 1049763039, 'DE', 'DEU', 'ألمانيا'),
(6942, 1049763040, 1049763055, 'CH', 'CHE', 'سويسرا'),
(6943, 1049763056, 1049763871, 'DE', 'DEU', 'ألمانيا'),
(6944, 1049763872, 1049763903, 'PL', 'POL', 'بولندا'),
(6945, 1049763904, 1049764447, 'DE', 'DEU', 'ألمانيا'),
(6946, 1049764448, 1049764463, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6947, 1049764464, 1049765695, 'DE', 'DEU', 'ألمانيا'),
(6948, 1049765696, 1049765791, 'PL', 'POL', 'بولندا'),
(6949, 1049765792, 1049766415, 'DE', 'DEU', 'ألمانيا'),
(6950, 1049766416, 1049766431, 'ES', 'ESP', 'إسبانيا'),
(6951, 1049766432, 1049766511, 'DE', 'DEU', 'ألمانيا'),
(6952, 1049766512, 1049766527, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6953, 1049766528, 1049767935, 'DE', 'DEU', 'ألمانيا'),
(6954, 1049767936, 1049767951, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6955, 1049767952, 1049768063, 'DE', 'DEU', 'ألمانيا'),
(6956, 1049768064, 1049768095, 'DK', 'DNK', 'الدنيمارك'),
(6957, 1049768096, 1049768367, 'DE', 'DEU', 'ألمانيا'),
(6958, 1049768368, 1049768375, 'NL', 'NLD', 'هولندا'),
(6959, 1049768376, 1049768383, 'GB', 'GBR', 'المملكة المتحدة'),
(6960, 1049768384, 1049768767, 'DE', 'DEU', 'ألمانيا'),
(6961, 1049768768, 1049768799, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6962, 1049768800, 1049769119, 'DE', 'DEU', 'ألمانيا'),
(6963, 1049769120, 1049769151, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6964, 1049769152, 1049770111, 'DE', 'DEU', 'ألمانيا'),
(6965, 1049770112, 1049770127, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6966, 1049770128, 1049771391, 'DE', 'DEU', 'ألمانيا'),
(6967, 1049771392, 1049771519, 'IT', 'ITA', 'إيطاليا'),
(6968, 1049771520, 1049772895, 'DE', 'DEU', 'ألمانيا'),
(6969, 1049772896, 1049772927, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6970, 1049772928, 1049773055, 'ES', 'ESP', 'إسبانيا'),
(6971, 1049773056, 1049773311, 'PL', 'POL', 'بولندا'),
(6972, 1049773312, 1049774367, 'DE', 'DEU', 'ألمانيا'),
(6973, 1049774368, 1049774399, 'IT', 'ITA', 'إيطاليا'),
(6974, 1049774400, 1049775087, 'DE', 'DEU', 'ألمانيا'),
(6975, 1049775088, 1049775103, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6976, 1049775104, 1049775119, 'CH', 'CHE', 'سويسرا'),
(6977, 1049775120, 1049776447, 'DE', 'DEU', 'ألمانيا'),
(6978, 1049776448, 1049776479, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6979, 1049776480, 1049777023, 'DE', 'DEU', 'ألمانيا'),
(6980, 1049777024, 1049777039, 'CH', 'CHE', 'سويسرا'),
(6981, 1049777040, 1049778111, 'DE', 'DEU', 'ألمانيا'),
(6982, 1049778112, 1049778143, 'ES', 'ESP', 'إسبانيا'),
(6983, 1049778144, 1049778335, 'DE', 'DEU', 'ألمانيا'),
(6984, 1049778336, 1049778351, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6985, 1049778352, 1049778535, 'DE', 'DEU', 'ألمانيا'),
(6986, 1049778536, 1049778543, 'AT', 'AUT', 'النمسا'),
(6987, 1049778544, 1049779063, 'DE', 'DEU', 'ألمانيا'),
(6988, 1049779064, 1049779071, 'PL', 'POL', 'بولندا'),
(6989, 1049779072, 1049779135, 'DE', 'DEU', 'ألمانيا'),
(6990, 1049779136, 1049779167, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6991, 1049779168, 1049782303, 'DE', 'DEU', 'ألمانيا'),
(6992, 1049782304, 1049782335, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(6993, 1049782336, 1049782623, 'DE', 'DEU', 'ألمانيا'),
(6994, 1049782624, 1049782639, 'ES', 'ESP', 'إسبانيا'),
(6995, 1049782640, 1049782743, 'DE', 'DEU', 'ألمانيا'),
(6996, 1049782744, 1049782751, 'IT', 'ITA', 'إيطاليا'),
(6997, 1049782752, 1049783071, 'DE', 'DEU', 'ألمانيا'),
(6998, 1049783072, 1049783103, 'DK', 'DNK', 'الدنيمارك'),
(6999, 1049783104, 1049783743, 'DE', 'DEU', 'ألمانيا'),
(7000, 1049783744, 1049783759, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(7001, 1049783760, 1049784575, 'DE', 'DEU', 'ألمانيا'),
(7002, 1049784576, 1049784831, 'PL', 'POL', 'بولندا'),
(7003, 1049784832, 1049784999, 'DE', 'DEU', 'ألمانيا'),
(7004, 1049785000, 1049785007, 'AT', 'AUT', 'النمسا'),
(7005, 1049785008, 1049787135, 'DE', 'DEU', 'ألمانيا'),
(7006, 1049787136, 1049787391, 'PL', 'POL', 'بولندا'),
(7007, 1049787392, 1049787647, 'DE', 'DEU', 'ألمانيا'),
(7008, 1049787648, 1049788159, 'PL', 'POL', 'بولندا'),
(7009, 1049788160, 1049791047, 'DE', 'DEU', 'ألمانيا'),
(7010, 1049791048, 1049791055, 'PL', 'POL', 'بولندا'),
(7011, 1049791056, 1049817151, 'DE', 'DEU', 'ألمانيا'),
(7012, 1049817152, 1049817159, 'PL', 'POL', 'بولندا'),
(7013, 1049817160, 1049817287, 'DE', 'DEU', 'ألمانيا'),
(7014, 1049817288, 1049817295, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(7015, 1049817296, 1049821183, 'DE', 'DEU', 'ألمانيا'),
(7016, 1049821184, 1049886719, 'FR', 'FRA', 'فرنسا'),
(7017, 1049886720, 1049894911, 'RU', 'RUS', 'الإتحاد الروسي'),
(7018, 1049894912, 1049903103, 'NO', 'NOR', 'النرويج'),
(7019, 1049903104, 1049911295, 'PL', 'POL', 'بولندا'),
(7020, 1049911296, 1049919487, 'FI', 'FIN', 'فنلندا'),
(7021, 1049919488, 1049927679, 'RU', 'RUS', 'الإتحاد الروسي'),
(7022, 1049927680, 1049935871, 'NL', 'NLD', 'هولندا'),
(7023, 1049935872, 1049944063, 'FI', 'FIN', 'فنلندا'),
(7024, 1049944064, 1049952255, 'RU', 'RUS', 'الإتحاد الروسي'),
(7025, 1049952256, 1049960447, 'UA', 'UKR', 'أوكرانيا'),
(7026, 1049960448, 1049968639, 'GB', 'GBR', 'المملكة المتحدة'),
(7027, 1049968640, 1049985023, 'SA', 'SAU', 'السعودية'),
(7028, 1049985024, 1050017791, 'IT', 'ITA', 'إيطاليا'),
(7029, 1050017792, 1050083327, 'KW', 'KWT', 'الكويت'),
(7030, 1050083328, 1050148863, 'ES', 'ESP', 'إسبانيا'),
(7031, 1050148864, 1050157055, 'CY', 'CYP', 'قبرص'),
(7032, 1050157056, 1050173439, 'RU', 'RUS', 'الإتحاد الروسي'),
(7033, 1050173440, 1050174063, 'IT', 'ITA', 'إيطاليا'),
(7034, 1050174064, 1050174079, 'FR', 'FRA', 'فرنسا'),
(7035, 1050174080, 1050181631, 'IT', 'ITA', 'إيطاليا'),
(7036, 1050181632, 1050189823, 'PL', 'POL', 'بولندا'),
(7037, 1050189824, 1050198015, 'DE', 'DEU', 'ألمانيا'),
(7038, 1050198016, 1050206207, 'RU', 'RUS', 'الإتحاد الروسي'),
(7039, 1050206208, 1050214399, 'SK', 'SVK', 'سلوفاكيا'),
(7040, 1050214400, 1050244935, 'DE', 'DEU', 'ألمانيا'),
(7041, 1050244936, 1050244943, 'PL', 'POL', 'بولندا'),
(7042, 1050244944, 1050320231, 'DE', 'DEU', 'ألمانيا'),
(7043, 1050320232, 1050320239, 'GB', 'GBR', 'المملكة المتحدة'),
(7044, 1050320240, 1050340607, 'DE', 'DEU', 'ألمانيا'),
(7045, 1050340608, 1050340639, 'US', 'USA', 'الولايات المتحدة'),
(7046, 1050340640, 1050450711, 'DE', 'DEU', 'ألمانيا'),
(7047, 1050450712, 1050450719, 'NL', 'NLD', 'هولندا'),
(7048, 1050450720, 1050471391, 'DE', 'DEU', 'ألمانيا'),
(7049, 1050471392, 1050471399, 'IT', 'ITA', 'إيطاليا'),
(7050, 1050471400, 1050502559, 'DE', 'DEU', 'ألمانيا'),
(7051, 1050502560, 1050502567, 'US', 'USA', 'الولايات المتحدة'),
(7052, 1050502568, 1050505247, 'DE', 'DEU', 'ألمانيا'),
(7053, 1050505248, 1050505279, 'CA', 'CAN', 'كندا'),
(7054, 1050505280, 1050515647, 'DE', 'DEU', 'ألمانيا'),
(7055, 1050515648, 1050515663, 'DK', 'DNK', 'الدنيمارك'),
(7056, 1050515664, 1050522407, 'DE', 'DEU', 'ألمانيا'),
(7057, 1050522408, 1050522415, 'CH', 'CHE', 'سويسرا'),
(7058, 1050522416, 1050619503, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(7059, 1050619504, 1050619511, 'CH', 'CHE', 'سويسرا'),
(7060, 1050619512, 1050621407, 'DE', 'DEU', 'ألمانيا'),
(7061, 1050621408, 1050621439, 'BE', 'BEL', 'بلجيكا'),
(7062, 1050621440, 1050625959, 'DE', 'DEU', 'ألمانيا'),
(7063, 1050625960, 1050625967, 'AT', 'AUT', 'النمسا'),
(7064, 1050625968, 1050626559, 'DE', 'DEU', 'ألمانيا'),
(7065, 1050626560, 1050626815, 'GB', 'GBR', 'المملكة المتحدة'),
(7066, 1050626816, 1050647431, 'DE', 'DEU', 'ألمانيا'),
(7067, 1050647432, 1050647439, 'NL', 'NLD', 'هولندا'),
(7068, 1050647440, 1050664911, 'DE', 'DEU', 'ألمانيا'),
(7069, 1050664912, 1050664919, 'IT', 'ITA', 'إيطاليا'),
(7070, 1050664920, 1050667519, 'DE', 'DEU', 'ألمانيا'),
(7071, 1050667520, 1050667775, 'FR', 'FRA', 'فرنسا'),
(7072, 1050667776, 1050672479, 'DE', 'DEU', 'ألمانيا'),
(7073, 1050672480, 1050672487, 'SG', 'SGP', 'سنغافورة'),
(7074, 1050672488, 1050673151, 'DE', 'DEU', 'ألمانيا'),
(7075, 1050673152, 1050676470, 'FR', 'FRA', 'فرنسا'),
(7076, 1050676471, 1050676471, 'BE', 'BEL', 'بلجيكا'),
(7077, 1050676472, 1050677335, 'FR', 'FRA', 'فرنسا'),
(7078, 1050677336, 1050677343, 'DE', 'DEU', 'ألمانيا'),
(7079, 1050677344, 1050677505, 'FR', 'FRA', 'فرنسا'),
(7080, 1050677506, 1050677506, 'BE', 'BEL', 'بلجيكا'),
(7081, 1050677507, 1050677702, 'FR', 'FRA', 'فرنسا'),
(7082, 1050677703, 1050677703, 'BE', 'BEL', 'بلجيكا'),
(7083, 1050677704, 1050683711, 'FR', 'FRA', 'فرنسا'),
(7084, 1050683712, 1050683719, 'DK', 'DNK', 'الدنيمارك'),
(7085, 1050683720, 1050684095, 'FR', 'FRA', 'فرنسا'),
(7086, 1050684096, 1050684103, 'GB', 'GBR', 'المملكة المتحدة'),
(7087, 1050684104, 1050684609, 'FR', 'FRA', 'فرنسا'),
(7088, 1050684610, 1050684610, 'LU', 'LUX', 'لوكسيمبورغ'),
(7089, 1050684611, 1050702623, 'FR', 'FRA', 'فرنسا'),
(7090, 1050702624, 1050702631, 'DE', 'DEU', 'ألمانيا'),
(7091, 1050702632, 1050704082, 'FR', 'FRA', 'فرنسا'),
(7092, 1050704083, 1050704083, 'BE', 'BEL', 'بلجيكا'),
(7093, 1050704084, 1050704661, 'FR', 'FRA', 'فرنسا'),
(7094, 1050704662, 1050704662, 'GB', 'GBR', 'المملكة المتحدة'),
(7095, 1050704663, 1050722831, 'FR', 'FRA', 'فرنسا'),
(7096, 1050722832, 1050722839, 'DE', 'DEU', 'ألمانيا'),
(7097, 1050722840, 1050725463, 'FR', 'FRA', 'فرنسا'),
(7098, 1050725464, 1050725471, 'GB', 'GBR', 'المملكة المتحدة'),
(7099, 1050725472, 1050726335, 'FR', 'FRA', 'فرنسا'),
(7100, 1050726336, 1050726343, 'DE', 'DEU', 'ألمانيا'),
(7101, 1050726344, 1050731146, 'FR', 'FRA', 'فرنسا'),
(7102, 1050731147, 1050731147, 'GB', 'GBR', 'المملكة المتحدة'),
(7103, 1050731148, 1050763476, 'FR', 'FRA', 'فرنسا'),
(7104, 1050763477, 1050763477, 'GB', 'GBR', 'المملكة المتحدة'),
(7105, 1050763478, 1050765853, 'FR', 'FRA', 'فرنسا'),
(7106, 1050765854, 1050765854, 'BE', 'BEL', 'بلجيكا'),
(7107, 1050765855, 1050766665, 'FR', 'FRA', 'فرنسا'),
(7108, 1050766666, 1050766666, 'BE', 'BEL', 'بلجيكا'),
(7109, 1050766667, 1050766729, 'FR', 'FRA', 'فرنسا'),
(7110, 1050766730, 1050766730, 'BE', 'BEL', 'بلجيكا'),
(7111, 1050766731, 1050768551, 'FR', 'FRA', 'فرنسا'),
(7112, 1050768552, 1050768558, 'CH', 'CHE', 'سويسرا'),
(7113, 1050768559, 1050804223, 'FR', 'FRA', 'فرنسا'),
(7114, 1050804224, 1050869759, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(7115, 1050869760, 1050935295, 'NL', 'NLD', 'هولندا'),
(7116, 1050940928, 1050941183, 'ES', 'ESP', 'إسبانيا'),
(7117, 1050943232, 1050943487, 'ES', 'ESP', 'إسبانيا'),
(7118, 1050945536, 1050945791, 'ES', 'ESP', 'إسبانيا'),
(7119, 1050948608, 1050948863, 'ES', 'ESP', 'إسبانيا'),
(7120, 1050968064, 1051000831, 'GB', 'GBR', 'المملكة المتحدة'),
(7121, 1051000832, 1051017215, 'RU', 'RUS', 'الإتحاد الروسي'),
(7122, 1051017216, 1051033599, 'NL', 'NLD', 'هولندا'),
(7123, 1051033600, 1051049983, 'FI', 'FIN', 'فنلندا'),
(7124, 1051049984, 1051066367, 'HU', 'HUN', 'هنغاريا'),
(7125, 1051066368, 1051084287, 'NL', 'NLD', 'هولندا'),
(7126, 1051084288, 1051084799, 'BE', 'BEL', 'بلجيكا'),
(7127, 1051084800, 1051096831, 'NL', 'NLD', 'هولندا'),
(7128, 1051096832, 1051097087, 'BE', 'BEL', 'بلجيكا'),
(7129, 1051097088, 1051098111, 'NL', 'NLD', 'هولندا'),
(7130, 1051098112, 1051099135, 'BE', 'BEL', 'بلجيكا'),
(7131, 1051099136, 1051099647, 'NL', 'NLD', 'هولندا'),
(7132, 1051099648, 1051099663, 'BE', 'BEL', 'بلجيكا'),
(7133, 1051099664, 1051099671, 'NL', 'NLD', 'هولندا'),
(7134, 1051099672, 1051099687, 'BE', 'BEL', 'بلجيكا'),
(7135, 1051099688, 1051099695, 'NL', 'NLD', 'هولندا'),
(7136, 1051099696, 1051099711, 'BE', 'BEL', 'بلجيكا'),
(7137, 1051099712, 1051099727, 'NL', 'NLD', 'هولندا'),
(7138, 1051099728, 1051099775, 'BE', 'BEL', 'بلجيكا'),
(7139, 1051099776, 1051099791, 'NL', 'NLD', 'هولندا'),
(7140, 1051099792, 1051099799, 'BE', 'BEL', 'بلجيكا'),
(7141, 1051099800, 1051099807, 'NL', 'NLD', 'هولندا'),
(7142, 1051099808, 1051099815, 'BE', 'BEL', 'بلجيكا'),
(7143, 1051099816, 1051099823, 'NL', 'NLD', 'هولندا'),
(7144, 1051099824, 1051099847, 'BE', 'BEL', 'بلجيكا'),
(7145, 1051099848, 1051099863, 'NL', 'NLD', 'هولندا'),
(7146, 1051099864, 1051099879, 'BE', 'BEL', 'بلجيكا'),
(7147, 1051099880, 1051099887, 'NL', 'NLD', 'هولندا'),
(7148, 1051099888, 1051099927, 'BE', 'BEL', 'بلجيكا'),
(7149, 1051099928, 1051099967, 'NL', 'NLD', 'هولندا'),
(7150, 1051099968, 1051099975, 'BE', 'BEL', 'بلجيكا'),
(7151, 1051099976, 1051099991, 'NL', 'NLD', 'هولندا'),
(7152, 1051099992, 1051100015, 'BE', 'BEL', 'بلجيكا'),
(7153, 1051100016, 1051100023, 'NL', 'NLD', 'هولندا'),
(7154, 1051100024, 1051100031, 'BE', 'BEL', 'بلجيكا'),
(7155, 1051100032, 1051100039, 'NL', 'NLD', 'هولندا'),
(7156, 1051100040, 1051100079, 'BE', 'BEL', 'بلجيكا'),
(7157, 1051100080, 1051100095, 'NL', 'NLD', 'هولندا'),
(7158, 1051100096, 1051100151, 'BE', 'BEL', 'بلجيكا'),
(7159, 1051100152, 1051100159, 'NL', 'NLD', 'هولندا'),
(7160, 1051100160, 1051100455, 'BE', 'BEL', 'بلجيكا'),
(7161, 1051100456, 1051100463, 'NL', 'NLD', 'هولندا'),
(7162, 1051100464, 1051100487, 'BE', 'BEL', 'بلجيكا'),
(7163, 1051100488, 1051100499, 'NL', 'NLD', 'هولندا'),
(7164, 1051100500, 1051100591, 'BE', 'BEL', 'بلجيكا'),
(7165, 1051100592, 1051100607, 'NL', 'NLD', 'هولندا'),
(7166, 1051100608, 1051100631, 'BE', 'BEL', 'بلجيكا'),
(7167, 1051100632, 1051100663, 'NL', 'NLD', 'هولندا'),
(7168, 1051100664, 1051100695, 'BE', 'BEL', 'بلجيكا'),
(7169, 1051100696, 1051100703, 'NL', 'NLD', 'هولندا'),
(7170, 1051100704, 1051100711, 'BE', 'BEL', 'بلجيكا'),
(7171, 1051100712, 1051100735, 'NL', 'NLD', 'هولندا'),
(7172, 1051100736, 1051100831, 'BE', 'BEL', 'بلجيكا'),
(7173, 1051100832, 1051100839, 'NL', 'NLD', 'هولندا'),
(7174, 1051100840, 1051100879, 'BE', 'BEL', 'بلجيكا'),
(7175, 1051100880, 1051100919, 'NL', 'NLD', 'هولندا'),
(7176, 1051100920, 1051100951, 'BE', 'BEL', 'بلجيكا'),
(7177, 1051100952, 1051100967, 'NL', 'NLD', 'هولندا'),
(7178, 1051100968, 1051101047, 'BE', 'BEL', 'بلجيكا'),
(7179, 1051101048, 1051101055, 'NL', 'NLD', 'هولندا'),
(7180, 1051101056, 1051101095, 'BE', 'BEL', 'بلجيكا'),
(7181, 1051101096, 1051101103, 'NL', 'NLD', 'هولندا'),
(7182, 1051101104, 1051101127, 'BE', 'BEL', 'بلجيكا'),
(7183, 1051101128, 1051101151, 'NL', 'NLD', 'هولندا'),
(7184, 1051101152, 1051101183, 'BE', 'BEL', 'بلجيكا'),
(7185, 1051101184, 1051101191, 'NL', 'NLD', 'هولندا'),
(7186, 1051101192, 1051101199, 'BE', 'BEL', 'بلجيكا'),
(7187, 1051101200, 1051101231, 'NL', 'NLD', 'هولندا'),
(7188, 1051101232, 1051101247, 'BE', 'BEL', 'بلجيكا'),
(7189, 1051101248, 1051101279, 'NL', 'NLD', 'هولندا'),
(7190, 1051101280, 1051101287, 'BE', 'BEL', 'بلجيكا'),
(7191, 1051101288, 1051101407, 'NL', 'NLD', 'هولندا'),
(7192, 1051101408, 1051101415, 'BE', 'BEL', 'بلجيكا'),
(7193, 1051101416, 1051101431, 'NL', 'NLD', 'هولندا'),
(7194, 1051101432, 1051101447, 'BE', 'BEL', 'بلجيكا'),
(7195, 1051101448, 1051101463, 'NL', 'NLD', 'هولندا'),
(7196, 1051101464, 1051101471, 'BE', 'BEL', 'بلجيكا'),
(7197, 1051101472, 1051101591, 'NL', 'NLD', 'هولندا'),
(7198, 1051101592, 1051101607, 'BE', 'BEL', 'بلجيكا'),
(7199, 1051101608, 1051101615, 'NL', 'NLD', 'هولندا'),
(7200, 1051101616, 1051101623, 'BE', 'BEL', 'بلجيكا'),
(7201, 1051101624, 1051101631, 'NL', 'NLD', 'هولندا'),
(7202, 1051101632, 1051101647, 'BE', 'BEL', 'بلجيكا'),
(7203, 1051101648, 1051101671, 'NL', 'NLD', 'هولندا'),
(7204, 1051101672, 1051101687, 'BE', 'BEL', 'بلجيكا'),
(7205, 1051101688, 1051101719, 'NL', 'NLD', 'هولندا'),
(7206, 1051101720, 1051101735, 'BE', 'BEL', 'بلجيكا'),
(7207, 1051101736, 1051101783, 'NL', 'NLD', 'هولندا'),
(7208, 1051101784, 1051101799, 'BE', 'BEL', 'بلجيكا'),
(7209, 1051101800, 1051101823, 'NL', 'NLD', 'هولندا'),
(7210, 1051101824, 1051101855, 'BE', 'BEL', 'بلجيكا'),
(7211, 1051101856, 1051101959, 'NL', 'NLD', 'هولندا'),
(7212, 1051101960, 1051101967, 'BE', 'BEL', 'بلجيكا'),
(7213, 1051101968, 1051101983, 'NL', 'NLD', 'هولندا'),
(7214, 1051101984, 1051102007, 'BE', 'BEL', 'بلجيكا'),
(7215, 1051102008, 1051102135, 'NL', 'NLD', 'هولندا'),
(7216, 1051102136, 1051102159, 'BE', 'BEL', 'بلجيكا'),
(7217, 1051102160, 1051102207, 'NL', 'NLD', 'هولندا'),
(7218, 1051102208, 1051102727, 'BE', 'BEL', 'بلجيكا'),
(7219, 1051102728, 1051103233, 'NL', 'NLD', 'هولندا'),
(7220, 1051103234, 1051103247, 'BE', 'BEL', 'بلجيكا'),
(7221, 1051103248, 1051103287, 'NL', 'NLD', 'هولندا'),
(7222, 1051103288, 1051103295, 'BE', 'BEL', 'بلجيكا'),
(7223, 1051103296, 1051103359, 'NL', 'NLD', 'هولندا'),
(7224, 1051103360, 1051103367, 'BE', 'BEL', 'بلجيكا'),
(7225, 1051103368, 1051103439, 'NL', 'NLD', 'هولندا'),
(7226, 1051103440, 1051103447, 'BE', 'BEL', 'بلجيكا'),
(7227, 1051103448, 1051103503, 'NL', 'NLD', 'هولندا'),
(7228, 1051103504, 1051103519, 'BE', 'BEL', 'بلجيكا'),
(7229, 1051103520, 1051103527, 'NL', 'NLD', 'هولندا'),
(7230, 1051103528, 1051103535, 'BE', 'BEL', 'بلجيكا'),
(7231, 1051103536, 1051103543, 'NL', 'NLD', 'هولندا'),
(7232, 1051103544, 1051103567, 'BE', 'BEL', 'بلجيكا'),
(7233, 1051103568, 1051103583, 'NL', 'NLD', 'هولندا'),
(7234, 1051103584, 1051103591, 'BE', 'BEL', 'بلجيكا'),
(7235, 1051103592, 1051103599, 'NL', 'NLD', 'هولندا'),
(7236, 1051103600, 1051103607, 'BE', 'BEL', 'بلجيكا'),
(7237, 1051103608, 1051103639, 'NL', 'NLD', 'هولندا'),
(7238, 1051103640, 1051103647, 'BE', 'BEL', 'بلجيكا'),
(7239, 1051103648, 1051103663, 'NL', 'NLD', 'هولندا'),
(7240, 1051103664, 1051103679, 'BE', 'BEL', 'بلجيكا'),
(7241, 1051103680, 1051103695, 'NL', 'NLD', 'هولندا'),
(7242, 1051103696, 1051103703, 'BE', 'BEL', 'بلجيكا'),
(7243, 1051103704, 1051103767, 'NL', 'NLD', 'هولندا'),
(7244, 1051103768, 1051103775, 'BE', 'BEL', 'بلجيكا'),
(7245, 1051103776, 1051103807, 'NL', 'NLD', 'هولندا'),
(7246, 1051103808, 1051103815, 'BE', 'BEL', 'بلجيكا'),
(7247, 1051103816, 1051103863, 'NL', 'NLD', 'هولندا'),
(7248, 1051103864, 1051103871, 'BE', 'BEL', 'بلجيكا'),
(7249, 1051103872, 1051103879, 'NL', 'NLD', 'هولندا'),
(7250, 1051103880, 1051103887, 'BE', 'BEL', 'بلجيكا'),
(7251, 1051103888, 1051103911, 'NL', 'NLD', 'هولندا'),
(7252, 1051103912, 1051103927, 'BE', 'BEL', 'بلجيكا'),
(7253, 1051103928, 1051103959, 'NL', 'NLD', 'هولندا'),
(7254, 1051103960, 1051103975, 'BE', 'BEL', 'بلجيكا'),
(7255, 1051103976, 1051103991, 'NL', 'NLD', 'هولندا'),
(7256, 1051103992, 1051103999, 'BE', 'BEL', 'بلجيكا'),
(7257, 1051104000, 1051104015, 'NL', 'NLD', 'هولندا'),
(7258, 1051104016, 1051104039, 'BE', 'BEL', 'بلجيكا'),
(7259, 1051104040, 1051104071, 'NL', 'NLD', 'هولندا'),
(7260, 1051104072, 1051104079, 'BE', 'BEL', 'بلجيكا'),
(7261, 1051104080, 1051104111, 'NL', 'NLD', 'هولندا'),
(7262, 1051104112, 1051104143, 'BE', 'BEL', 'بلجيكا'),
(7263, 1051104144, 1051104167, 'NL', 'NLD', 'هولندا'),
(7264, 1051104168, 1051104175, 'BE', 'BEL', 'بلجيكا'),
(7265, 1051104176, 1051104231, 'NL', 'NLD', 'هولندا'),
(7266, 1051104232, 1051104255, 'BE', 'BEL', 'بلجيكا'),
(7267, 1051104256, 1051104311, 'NL', 'NLD', 'هولندا'),
(7268, 1051104312, 1051104319, 'BE', 'BEL', 'بلجيكا'),
(7269, 1051104320, 1051104359, 'NL', 'NLD', 'هولندا'),
(7270, 1051104360, 1051104367, 'BE', 'BEL', 'بلجيكا'),
(7271, 1051104368, 1051104383, 'NL', 'NLD', 'هولندا'),
(7272, 1051104384, 1051104399, 'BE', 'BEL', 'بلجيكا'),
(7273, 1051104400, 1051104503, 'NL', 'NLD', 'هولندا'),
(7274, 1051104504, 1051104527, 'BE', 'BEL', 'بلجيكا'),
(7275, 1051104528, 1051104583, 'NL', 'NLD', 'هولندا'),
(7276, 1051104584, 1051104599, 'BE', 'BEL', 'بلجيكا'),
(7277, 1051104600, 1051104607, 'NL', 'NLD', 'هولندا'),
(7278, 1051104608, 1051104631, 'BE', 'BEL', 'بلجيكا'),
(7279, 1051104632, 1051104679, 'NL', 'NLD', 'هولندا'),
(7280, 1051104680, 1051104695, 'BE', 'BEL', 'بلجيكا'),
(7281, 1051104696, 1051104719, 'NL', 'NLD', 'هولندا'),
(7282, 1051104720, 1051104727, 'BE', 'BEL', 'بلجيكا'),
(7283, 1051104728, 1051104751, 'NL', 'NLD', 'هولندا'),
(7284, 1051104752, 1051104759, 'BE', 'BEL', 'بلجيكا'),
(7285, 1051104760, 1051104791, 'NL', 'NLD', 'هولندا'),
(7286, 1051104792, 1051104799, 'BE', 'BEL', 'بلجيكا'),
(7287, 1051104800, 1051104823, 'NL', 'NLD', 'هولندا'),
(7288, 1051104824, 1051104831, 'BE', 'BEL', 'بلجيكا'),
(7289, 1051104832, 1051104839, 'NL', 'NLD', 'هولندا'),
(7290, 1051104840, 1051104855, 'BE', 'BEL', 'بلجيكا'),
(7291, 1051104856, 1051104935, 'NL', 'NLD', 'هولندا'),
(7292, 1051104936, 1051104943, 'BE', 'BEL', 'بلجيكا'),
(7293, 1051104944, 1051104951, 'NL', 'NLD', 'هولندا'),
(7294, 1051104952, 1051104959, 'BE', 'BEL', 'بلجيكا'),
(7295, 1051104960, 1051104975, 'NL', 'NLD', 'هولندا'),
(7296, 1051104976, 1051104983, 'BE', 'BEL', 'بلجيكا'),
(7297, 1051104984, 1051104991, 'NL', 'NLD', 'هولندا'),
(7298, 1051104992, 1051104999, 'BE', 'BEL', 'بلجيكا'),
(7299, 1051105000, 1051105047, 'NL', 'NLD', 'هولندا'),
(7300, 1051105048, 1051105055, 'BE', 'BEL', 'بلجيكا'),
(7301, 1051105056, 1051105063, 'NL', 'NLD', 'هولندا'),
(7302, 1051105064, 1051105079, 'BE', 'BEL', 'بلجيكا'),
(7303, 1051105080, 1051105103, 'NL', 'NLD', 'هولندا'),
(7304, 1051105104, 1051105119, 'BE', 'BEL', 'بلجيكا'),
(7305, 1051105120, 1051105127, 'NL', 'NLD', 'هولندا'),
(7306, 1051105128, 1051105135, 'BE', 'BEL', 'بلجيكا'),
(7307, 1051105136, 1051105143, 'NL', 'NLD', 'هولندا'),
(7308, 1051105144, 1051105151, 'BE', 'BEL', 'بلجيكا'),
(7309, 1051105152, 1051105191, 'NL', 'NLD', 'هولندا'),
(7310, 1051105192, 1051105199, 'BE', 'BEL', 'بلجيكا'),
(7311, 1051105200, 1051105207, 'NL', 'NLD', 'هولندا'),
(7312, 1051105208, 1051105223, 'BE', 'BEL', 'بلجيكا'),
(7313, 1051105224, 1051105255, 'NL', 'NLD', 'هولندا'),
(7314, 1051105256, 1051105263, 'BE', 'BEL', 'بلجيكا'),
(7315, 1051105264, 1051105271, 'NL', 'NLD', 'هولندا'),
(7316, 1051105272, 1051105279, 'BE', 'BEL', 'بلجيكا'),
(7317, 1051105280, 1051105319, 'NL', 'NLD', 'هولندا'),
(7318, 1051105320, 1051105327, 'BE', 'BEL', 'بلجيكا'),
(7319, 1051105328, 1051105359, 'NL', 'NLD', 'هولندا'),
(7320, 1051105360, 1051105383, 'BE', 'BEL', 'بلجيكا'),
(7321, 1051105384, 1051105439, 'NL', 'NLD', 'هولندا'),
(7322, 1051105440, 1051105455, 'BE', 'BEL', 'بلجيكا'),
(7323, 1051105456, 1051105519, 'NL', 'NLD', 'هولندا'),
(7324, 1051105520, 1051105551, 'BE', 'BEL', 'بلجيكا'),
(7325, 1051105552, 1051105599, 'NL', 'NLD', 'هولندا'),
(7326, 1051105600, 1051105607, 'BE', 'BEL', 'بلجيكا'),
(7327, 1051105608, 1051105703, 'NL', 'NLD', 'هولندا'),
(7328, 1051105704, 1051105711, 'BE', 'BEL', 'بلجيكا'),
(7329, 1051105712, 1051105791, 'NL', 'NLD', 'هولندا'),
(7330, 1051105792, 1051105799, 'BE', 'BEL', 'بلجيكا'),
(7331, 1051105800, 1051105807, 'NL', 'NLD', 'هولندا'),
(7332, 1051105808, 1051105815, 'BE', 'BEL', 'بلجيكا'),
(7333, 1051105816, 1051105831, 'NL', 'NLD', 'هولندا'),
(7334, 1051105832, 1051105839, 'BE', 'BEL', 'بلجيكا'),
(7335, 1051105840, 1051105863, 'NL', 'NLD', 'هولندا'),
(7336, 1051105864, 1051105871, 'BE', 'BEL', 'بلجيكا'),
(7337, 1051105872, 1051105895, 'NL', 'NLD', 'هولندا'),
(7338, 1051105896, 1051105903, 'BE', 'BEL', 'بلجيكا'),
(7339, 1051105904, 1051105911, 'NL', 'NLD', 'هولندا'),
(7340, 1051105912, 1051105927, 'BE', 'BEL', 'بلجيكا'),
(7341, 1051105928, 1051105967, 'NL', 'NLD', 'هولندا'),
(7342, 1051105968, 1051105983, 'BE', 'BEL', 'بلجيكا'),
(7343, 1051105984, 1051105999, 'NL', 'NLD', 'هولندا'),
(7344, 1051106000, 1051106015, 'BE', 'BEL', 'بلجيكا'),
(7345, 1051106016, 1051106031, 'NL', 'NLD', 'هولندا'),
(7346, 1051106032, 1051106039, 'BE', 'BEL', 'بلجيكا'),
(7347, 1051106040, 1051106047, 'NL', 'NLD', 'هولندا'),
(7348, 1051106048, 1051106055, 'BE', 'BEL', 'بلجيكا'),
(7349, 1051106056, 1051106071, 'NL', 'NLD', 'هولندا'),
(7350, 1051106072, 1051106079, 'BE', 'BEL', 'بلجيكا'),
(7351, 1051106080, 1051106095, 'NL', 'NLD', 'هولندا'),
(7352, 1051106096, 1051106103, 'BE', 'BEL', 'بلجيكا'),
(7353, 1051106104, 1051106111, 'NL', 'NLD', 'هولندا'),
(7354, 1051106112, 1051106119, 'BE', 'BEL', 'بلجيكا'),
(7355, 1051106120, 1051106135, 'NL', 'NLD', 'هولندا'),
(7356, 1051106136, 1051106143, 'BE', 'BEL', 'بلجيكا'),
(7357, 1051106144, 1051106167, 'NL', 'NLD', 'هولندا'),
(7358, 1051106168, 1051106175, 'BE', 'BEL', 'بلجيكا'),
(7359, 1051106176, 1051106183, 'NL', 'NLD', 'هولندا'),
(7360, 1051106184, 1051106191, 'BE', 'BEL', 'بلجيكا'),
(7361, 1051106192, 1051106247, 'NL', 'NLD', 'هولندا'),
(7362, 1051106248, 1051106271, 'BE', 'BEL', 'بلجيكا'),
(7363, 1051106272, 1051106303, 'NL', 'NLD', 'هولندا'),
(7364, 1051106304, 1051106311, 'BE', 'BEL', 'بلجيكا'),
(7365, 1051106312, 1051106319, 'NL', 'NLD', 'هولندا'),
(7366, 1051106320, 1051106327, 'BE', 'BEL', 'بلجيكا'),
(7367, 1051106328, 1051106335, 'NL', 'NLD', 'هولندا'),
(7368, 1051106336, 1051106351, 'BE', 'BEL', 'بلجيكا'),
(7369, 1051106352, 1051106391, 'NL', 'NLD', 'هولندا'),
(7370, 1051106392, 1051106399, 'BE', 'BEL', 'بلجيكا'),
(7371, 1051106400, 1051106423, 'NL', 'NLD', 'هولندا'),
(7372, 1051106424, 1051106431, 'BE', 'BEL', 'بلجيكا'),
(7373, 1051106432, 1051106463, 'NL', 'NLD', 'هولندا'),
(7374, 1051106464, 1051106471, 'BE', 'BEL', 'بلجيكا'),
(7375, 1051106472, 1051106511, 'NL', 'NLD', 'هولندا'),
(7376, 1051106512, 1051106519, 'BE', 'BEL', 'بلجيكا'),
(7377, 1051106520, 1051106527, 'NL', 'NLD', 'هولندا'),
(7378, 1051106528, 1051106535, 'BE', 'BEL', 'بلجيكا'),
(7379, 1051106536, 1051106543, 'NL', 'NLD', 'هولندا'),
(7380, 1051106544, 1051106551, 'BE', 'BEL', 'بلجيكا'),
(7381, 1051106552, 1051106591, 'NL', 'NLD', 'هولندا'),
(7382, 1051106592, 1051106599, 'BE', 'BEL', 'بلجيكا'),
(7383, 1051106600, 1051106607, 'NL', 'NLD', 'هولندا'),
(7384, 1051106608, 1051106615, 'BE', 'BEL', 'بلجيكا'),
(7385, 1051106616, 1051106639, 'NL', 'NLD', 'هولندا'),
(7386, 1051106640, 1051106647, 'BE', 'BEL', 'بلجيكا'),
(7387, 1051106648, 1051106663, 'NL', 'NLD', 'هولندا'),
(7388, 1051106664, 1051106671, 'BE', 'BEL', 'بلجيكا'),
(7389, 1051106672, 1051106711, 'NL', 'NLD', 'هولندا'),
(7390, 1051106712, 1051106719, 'BE', 'BEL', 'بلجيكا'),
(7391, 1051106720, 1051106759, 'NL', 'NLD', 'هولندا'),
(7392, 1051106760, 1051106767, 'BE', 'BEL', 'بلجيكا'),
(7393, 1051106768, 1051106775, 'NL', 'NLD', 'هولندا'),
(7394, 1051106776, 1051106783, 'BE', 'BEL', 'بلجيكا'),
(7395, 1051106784, 1051106799, 'NL', 'NLD', 'هولندا'),
(7396, 1051106800, 1051106807, 'BE', 'BEL', 'بلجيكا'),
(7397, 1051106808, 1051106823, 'NL', 'NLD', 'هولندا'),
(7398, 1051106824, 1051106831, 'BE', 'BEL', 'بلجيكا'),
(7399, 1051106832, 1051106847, 'NL', 'NLD', 'هولندا'),
(7400, 1051106848, 1051106863, 'BE', 'BEL', 'بلجيكا'),
(7401, 1051106864, 1051106895, 'NL', 'NLD', 'هولندا'),
(7402, 1051106896, 1051106903, 'BE', 'BEL', 'بلجيكا'),
(7403, 1051106904, 1051106943, 'NL', 'NLD', 'هولندا'),
(7404, 1051106944, 1051106951, 'BE', 'BEL', 'بلجيكا'),
(7405, 1051106952, 1051106959, 'NL', 'NLD', 'هولندا'),
(7406, 1051106960, 1051106967, 'BE', 'BEL', 'بلجيكا'),
(7407, 1051106968, 1051106975, 'NL', 'NLD', 'هولندا'),
(7408, 1051106976, 1051107007, 'BE', 'BEL', 'بلجيكا'),
(7409, 1051107008, 1051107023, 'NL', 'NLD', 'هولندا'),
(7410, 1051107024, 1051107039, 'BE', 'BEL', 'بلجيكا'),
(7411, 1051107040, 1051107055, 'NL', 'NLD', 'هولندا'),
(7412, 1051107056, 1051107063, 'BE', 'BEL', 'بلجيكا'),
(7413, 1051107064, 1051107071, 'NL', 'NLD', 'هولندا'),
(7414, 1051107072, 1051107087, 'BE', 'BEL', 'بلجيكا'),
(7415, 1051107088, 1051107103, 'NL', 'NLD', 'هولندا'),
(7416, 1051107104, 1051107119, 'BE', 'BEL', 'بلجيكا'),
(7417, 1051107120, 1051107127, 'NL', 'NLD', 'هولندا'),
(7418, 1051107128, 1051107135, 'BE', 'BEL', 'بلجيكا'),
(7419, 1051107136, 1051107143, 'NL', 'NLD', 'هولندا'),
(7420, 1051107144, 1051107151, 'BE', 'BEL', 'بلجيكا'),
(7421, 1051107152, 1051107159, 'NL', 'NLD', 'هولندا'),
(7422, 1051107160, 1051107167, 'BE', 'BEL', 'بلجيكا'),
(7423, 1051107168, 1051107183, 'NL', 'NLD', 'هولندا'),
(7424, 1051107184, 1051107215, 'BE', 'BEL', 'بلجيكا'),
(7425, 1051107216, 1051107223, 'NL', 'NLD', 'هولندا'),
(7426, 1051107224, 1051107231, 'BE', 'BEL', 'بلجيكا'),
(7427, 1051107232, 1051107239, 'NL', 'NLD', 'هولندا'),
(7428, 1051107240, 1051107247, 'BE', 'BEL', 'بلجيكا'),
(7429, 1051107248, 1051107279, 'NL', 'NLD', 'هولندا'),
(7430, 1051107280, 1051107287, 'BE', 'BEL', 'بلجيكا'),
(7431, 1051107288, 1051107295, 'NL', 'NLD', 'هولندا'),
(7432, 1051107296, 1051107303, 'BE', 'BEL', 'بلجيكا'),
(7433, 1051107304, 1051107311, 'NL', 'NLD', 'هولندا'),
(7434, 1051107312, 1051107327, 'BE', 'BEL', 'بلجيكا'),
(7435, 1051107328, 1051107329, 'NL', 'NLD', 'هولندا'),
(7436, 1051107330, 1051107359, 'BE', 'BEL', 'بلجيكا'),
(7437, 1051107360, 1051107375, 'NL', 'NLD', 'هولندا'),
(7438, 1051107376, 1051107383, 'BE', 'BEL', 'بلجيكا'),
(7439, 1051107384, 1051107391, 'NL', 'NLD', 'هولندا'),
(7440, 1051107392, 1051107407, 'BE', 'BEL', 'بلجيكا'),
(7441, 1051107408, 1051107423, 'NL', 'NLD', 'هولندا'),
(7442, 1051107424, 1051107455, 'BE', 'BEL', 'بلجيكا'),
(7443, 1051107456, 1051107519, 'NL', 'NLD', 'هولندا'),
(7444, 1051107520, 1051107839, 'BE', 'BEL', 'بلجيكا'),
(7445, 1051107840, 1051115519, 'NL', 'NLD', 'هولندا'),
(7446, 1051115520, 1051121287, 'BE', 'BEL', 'بلجيكا'),
(7447, 1051121288, 1051121295, 'NL', 'NLD', 'هولندا'),
(7448, 1051121296, 1051123711, 'BE', 'BEL', 'بلجيكا'),
(7449, 1051123712, 1051125247, 'NL', 'NLD', 'هولندا'),
(7450, 1051125248, 1051125759, 'BE', 'BEL', 'بلجيكا'),
(7451, 1051125760, 1051131903, 'NL', 'NLD', 'هولندا'),
(7452, 1051131904, 1051197439, 'CH', 'CHE', 'سويسرا'),
(7453, 1051197440, 1051213823, 'CZ', 'CZE', 'التشيك'),
(7454, 1051213824, 1051230207, 'SK', 'SVK', 'سلوفاكيا'),
(7455, 1051230208, 1051238399, 'SE', 'SWE', 'السويد'),
(7456, 1051238400, 1051246591, 'GE', 'GEO', 'جورجيا'),
(7457, 1051246592, 1051254783, 'DE', 'DEU', 'ألمانيا'),
(7458, 1051254784, 1051262975, 'RU', 'RUS', 'الإتحاد الروسي'),
(7459, 1051262976, 1051271167, 'DE', 'DEU', 'ألمانيا'),
(7460, 1051271168, 1051279359, 'IT', 'ITA', 'إيطاليا'),
(7461, 1051279360, 1051295743, 'PT', 'PRT', 'البورتوغال'),
(7462, 1051295744, 1051303935, 'GB', 'GBR', 'المملكة المتحدة'),
(7463, 1051303936, 1051312127, 'SK', 'SVK', 'سلوفاكيا'),
(7464, 1051312128, 1051328511, 'GR', 'GRC', 'اليونان'),
(7465, 1051328512, 1051460095, 'GB', 'GBR', 'المملكة المتحدة'),
(7466, 1051460096, 1051460351, 'ES', 'ESP', 'إسبانيا'),
(7467, 1051460352, 1051525119, 'GB', 'GBR', 'المملكة المتحدة'),
(7468, 1051525120, 1051533311, 'MT', 'MLT', 'مالطا'),
(7469, 1051541504, 1051557887, 'GB', 'GBR', 'المملكة المتحدة'),
(7470, 1051557888, 1051566079, 'RU', 'RUS', 'الإتحاد الروسي'),
(7471, 1051566080, 1051574271, 'IT', 'ITA', 'إيطاليا'),
(7472, 1051574272, 1051574623, 'GB', 'GBR', 'المملكة المتحدة'),
(7473, 1051574624, 1051574655, 'GM', 'GMB', 'غامبيا'),
(7474, 1051574656, 1051575999, 'GB', 'GBR', 'المملكة المتحدة'),
(7475, 1051576000, 1051576015, 'IT', 'ITA', 'إيطاليا'),
(7476, 1051576016, 1051576903, 'GB', 'GBR', 'المملكة المتحدة'),
(7477, 1051576904, 1051576911, 'US', 'USA', 'الولايات المتحدة'),
(7478, 1051576912, 1051577503, 'GB', 'GBR', 'المملكة المتحدة'),
(7479, 1051577504, 1051577519, 'NL', 'NLD', 'هولندا'),
(7480, 1051577520, 1051577535, 'GB', 'GBR', 'المملكة المتحدة'),
(7481, 1051577536, 1051577567, 'NL', 'NLD', 'هولندا'),
(7482, 1051577568, 1051577575, 'BE', 'BEL', 'بلجيكا'),
(7483, 1051577576, 1051577583, 'GB', 'GBR', 'المملكة المتحدة'),
(7484, 1051577584, 1051577587, 'FI', 'FIN', 'فنلندا'),
(7485, 1051577588, 1051577591, 'GB', 'GBR', 'المملكة المتحدة'),
(7486, 1051577592, 1051577599, 'NL', 'NLD', 'هولندا'),
(7487, 1051577600, 1051577855, 'GB', 'GBR', 'المملكة المتحدة'),
(7488, 1051577856, 1051578111, 'NL', 'NLD', 'هولندا'),
(7489, 1051578112, 1051578143, 'GB', 'GBR', 'المملكة المتحدة'),
(7490, 1051578144, 1051578175, 'NL', 'NLD', 'هولندا'),
(7491, 1051578176, 1051578239, 'GB', 'GBR', 'المملكة المتحدة'),
(7492, 1051578240, 1051578263, 'FR', 'FRA', 'فرنسا'),
(7493, 1051578264, 1051578271, 'GB', 'GBR', 'المملكة المتحدة'),
(7494, 1051578272, 1051578279, 'ES', 'ESP', 'إسبانيا'),
(7495, 1051578280, 1051578287, 'GR', 'GRC', 'اليونان'),
(7496, 1051578288, 1051578295, 'GB', 'GBR', 'المملكة المتحدة'),
(7497, 1051578296, 1051578303, 'PL', 'POL', 'بولندا'),
(7498, 1051578304, 1051578335, 'NL', 'NLD', 'هولندا'),
(7499, 1051578336, 1051578343, 'DE', 'DEU', 'ألمانيا'),
(7500, 1051578344, 1051578351, 'NL', 'NLD', 'هولندا'),
(7501, 1051578352, 1051578363, 'GB', 'GBR', 'المملكة المتحدة'),
(7502, 1051578364, 1051578367, 'DE', 'DEU', 'ألمانيا'),
(7503, 1051578368, 1051580415, 'SZ', 'SWZ', 'سوازيلند'),
(7504, 1051580416, 1051584511, 'GB', 'GBR', 'المملكة المتحدة'),
(7505, 1051584512, 1051585663, 'MG', 'MDG', 'مدغشقر'),
(7506, 1051585664, 1051585919, 'GB', 'GBR', 'المملكة المتحدة'),
(7507, 1051585920, 1051586047, 'MG', 'MDG', 'مدغشقر'),
(7508, 1051586048, 1051586175, 'GB', 'GBR', 'المملكة المتحدة'),
(7509, 1051586176, 1051586303, 'MG', 'MDG', 'مدغشقر'),
(7510, 1051586304, 1051590655, 'GB', 'GBR', 'المملكة المتحدة'),
(7511, 1051590656, 1051702527, 'ES', 'ESP', 'إسبانيا'),
(7512, 1051702528, 1051702783, 'US', 'USA', 'الولايات المتحدة'),
(7513, 1051702784, 1051721727, 'ES', 'ESP', 'إسبانيا'),
(7514, 1051721728, 1051729919, 'RU', 'RUS', 'الإتحاد الروسي'),
(7515, 1051729920, 1051738111, 'FI', 'FIN', 'فنلندا'),
(7516, 1051738112, 1051754495, 'BG', 'BGR', 'بلغاريا'),
(7517, 1051754496, 1051762687, 'DE', 'DEU', 'ألمانيا'),
(7518, 1051762688, 1051770879, 'SK', 'SVK', 'سلوفاكيا'),
(7519, 1051770880, 1051779071, 'NO', 'NOR', 'النرويج'),
(7520, 1051779072, 1051787263, 'DE', 'DEU', 'ألمانيا'),
(7521, 1051787264, 1051795455, 'IT', 'ITA', 'إيطاليا'),
(7522, 1051795456, 1051803647, 'RU', 'RUS', 'الإتحاد الروسي'),
(7523, 1051803648, 1051820031, 'CZ', 'CZE', 'التشيك'),
(7524, 1051820032, 1051852799, 'NL', 'NLD', 'هولندا'),
(7525, 1051852800, 1051918335, 'AT', 'AUT', 'النمسا'),
(7526, 1051918336, 1051919359, 'PL', 'POL', 'بولندا'),
(7527, 1051919360, 1051920383, 'AT', 'AUT', 'النمسا'),
(7528, 1051920384, 1051922431, 'PL', 'POL', 'بولندا'),
(7529, 1051922432, 1051983871, 'AT', 'AUT', 'النمسا'),
(7530, 1051986688, 1051987199, 'DE', 'DEU', 'ألمانيا'),
(7531, 1051991808, 1051991935, 'DE', 'DEU', 'ألمانيا'),
(7532, 1051992064, 1051994639, 'DE', 'DEU', 'ألمانيا'),
(7533, 1051994648, 1051994671, 'DE', 'DEU', 'ألمانيا'),
(7534, 1051994700, 1051994703, 'BE', 'BEL', 'بلجيكا'),
(7535, 1051994716, 1051994719, 'DE', 'DEU', 'ألمانيا'),
(7536, 1051994720, 1051994751, 'BE', 'BEL', 'بلجيكا'),
(7537, 1051994792, 1051994799, 'NL', 'NLD', 'هولندا'),
(7538, 1051994800, 1051994831, 'DE', 'DEU', 'ألمانيا'),
(7539, 1051994864, 1051994871, 'DE', 'DEU', 'ألمانيا'),
(7540, 1051994944, 1051995039, 'DE', 'DEU', 'ألمانيا'),
(7541, 1051995392, 1051996159, 'DE', 'DEU', 'ألمانيا'),
(7542, 1051996336, 1051996351, 'DE', 'DEU', 'ألمانيا'),
(7543, 1051996880, 1051996927, 'DE', 'DEU', 'ألمانيا'),
(7544, 1051997440, 1051997695, 'DE', 'DEU', 'ألمانيا'),
(7545, 1051997712, 1051997727, 'DE', 'DEU', 'ألمانيا'),
(7546, 1051997952, 1051997983, 'DE', 'DEU', 'ألمانيا'),
(7547, 1051998248, 1051998255, 'DE', 'DEU', 'ألمانيا'),
(7548, 1051998688, 1051998695, 'DE', 'DEU', 'ألمانيا'),
(7549, 1051999040, 1051999043, 'DE', 'DEU', 'ألمانيا'),
(7550, 1051999136, 1051999151, 'DE', 'DEU', 'ألمانيا'),
(7551, 1051999168, 1051999359, 'DE', 'DEU', 'ألمانيا'),
(7552, 1051999488, 1051999743, 'DE', 'DEU', 'ألمانيا'),
(7553, 1052000000, 1052000063, 'DE', 'DEU', 'ألمانيا'),
(7554, 1052000128, 1052000143, 'DE', 'DEU', 'ألمانيا'),
(7555, 1052000192, 1052000511, 'DE', 'DEU', 'ألمانيا'),
(7556, 1052000520, 1052000527, 'DE', 'DEU', 'ألمانيا'),
(7557, 1052000536, 1052000539, 'DE', 'DEU', 'ألمانيا'),
(7558, 1052000576, 1052000623, 'DE', 'DEU', 'ألمانيا'),
(7559, 1052000632, 1052002303, 'DE', 'DEU', 'ألمانيا'),
(7560, 1052002312, 1052002335, 'DE', 'DEU', 'ألمانيا'),
(7561, 1052002368, 1052002431, 'DE', 'DEU', 'ألمانيا'),
(7562, 1052002440, 1052002447, 'DE', 'DEU', 'ألمانيا'),
(7563, 1052002464, 1052002511, 'DE', 'DEU', 'ألمانيا'),
(7564, 1052002520, 1052002523, 'DE', 'DEU', 'ألمانيا'),
(7565, 1052002528, 1052002535, 'DE', 'DEU', 'ألمانيا'),
(7566, 1052003328, 1052003359, 'DE', 'DEU', 'ألمانيا'),
(7567, 1052003400, 1052003455, 'DE', 'DEU', 'ألمانيا'),
(7568, 1052003480, 1052003487, 'DE', 'DEU', 'ألمانيا'),
(7569, 1052003552, 1052003839, 'DE', 'DEU', 'ألمانيا'),
(7570, 1052003968, 1052003999, 'DE', 'DEU', 'ألمانيا'),
(7571, 1052004672, 1052004759, 'DE', 'DEU', 'ألمانيا'),
(7572, 1052004768, 1052004783, 'DE', 'DEU', 'ألمانيا'),
(7573, 1052004816, 1052004831, 'DE', 'DEU', 'ألمانيا'),
(7574, 1052004896, 1052004959, 'DE', 'DEU', 'ألمانيا'),
(7575, 1052005120, 1052005151, 'DE', 'DEU', 'ألمانيا'),
(7576, 1052005248, 1052005631, 'DE', 'DEU', 'ألمانيا'),
(7577, 1052005888, 1052005911, 'DE', 'DEU', 'ألمانيا'),
(7578, 1052006544, 1052006559, 'DE', 'DEU', 'ألمانيا'),
(7579, 1052006576, 1052006607, 'DE', 'DEU', 'ألمانيا'),
(7580, 1052007040, 1052007103, 'DE', 'DEU', 'ألمانيا'),
(7581, 1052007432, 1052007435, 'DE', 'DEU', 'ألمانيا'),
(7582, 1052007456, 1052007471, 'DE', 'DEU', 'ألمانيا'),
(7583, 1052007520, 1052007535, 'DE', 'DEU', 'ألمانيا'),
(7584, 1052007776, 1052007791, 'DE', 'DEU', 'ألمانيا'),
(7585, 1052007936, 1052008223, 'DE', 'DEU', 'ألمانيا'),
(7586, 1052008516, 1052008527, 'DE', 'DEU', 'ألمانيا'),
(7587, 1052008544, 1052008583, 'DE', 'DEU', 'ألمانيا'),
(7588, 1052008608, 1052008623, 'DE', 'DEU', 'ألمانيا'),
(7589, 1052008672, 1052008687, 'DE', 'DEU', 'ألمانيا'),
(7590, 1052008704, 1052009087, 'DE', 'DEU', 'ألمانيا'),
(7591, 1052009472, 1052009487, 'DE', 'DEU', 'ألمانيا'),
(7592, 1052009504, 1052009535, 'DE', 'DEU', 'ألمانيا'),
(7593, 1052009600, 1052009607, 'DE', 'DEU', 'ألمانيا'),
(7594, 1052010464, 1052010519, 'DE', 'DEU', 'ألمانيا'),
(7595, 1052010528, 1052010559, 'DE', 'DEU', 'ألمانيا'),
(7596, 1052010624, 1052010655, 'DE', 'DEU', 'ألمانيا'),
(7597, 1052010752, 1052011135, 'DE', 'DEU', 'ألمانيا'),
(7598, 1052011264, 1052012335, 'DE', 'DEU', 'ألمانيا'),
(7599, 1052012376, 1052012399, 'DE', 'DEU', 'ألمانيا'),
(7600, 1052012544, 1052013055, 'DE', 'DEU', 'ألمانيا'),
(7601, 1052013060, 1052013063, 'DE', 'DEU', 'ألمانيا'),
(7602, 1052013072, 1052013087, 'DE', 'DEU', 'ألمانيا'),
(7603, 1052013120, 1052013127, 'DE', 'DEU', 'ألمانيا'),
(7604, 1052013144, 1052013151, 'DE', 'DEU', 'ألمانيا'),
(7605, 1052013216, 1052013263, 'DE', 'DEU', 'ألمانيا'),
(7606, 1052013312, 1052013567, 'DE', 'DEU', 'ألمانيا'),
(7607, 1052013696, 1052013823, 'DE', 'DEU', 'ألمانيا'),
(7608, 1052013848, 1052013855, 'DE', 'DEU', 'ألمانيا'),
(7609, 1052013888, 1052013951, 'DE', 'DEU', 'ألمانيا'),
(7610, 1052013960, 1052013963, 'DE', 'DEU', 'ألمانيا'),
(7611, 1052014016, 1052014079, 'DE', 'DEU', 'ألمانيا'),
(7612, 1052014112, 1052014303, 'DE', 'DEU', 'ألمانيا'),
(7613, 1052014592, 1052014623, 'DE', 'DEU', 'ألمانيا'),
(7614, 1052015368, 1052015375, 'DE', 'DEU', 'ألمانيا'),
(7615, 1052015424, 1052015519, 'DE', 'DEU', 'ألمانيا'),
(7616, 1052015552, 1052015583, 'DE', 'DEU', 'ألمانيا'),
(7617, 1052015632, 1052015647, 'DE', 'DEU', 'ألمانيا'),
(7618, 1052015696, 1052015727, 'DE', 'DEU', 'ألمانيا'),
(7619, 1052016000, 1052016127, 'DE', 'DEU', 'ألمانيا'),
(7620, 1052016208, 1052016223, 'DE', 'DEU', 'ألمانيا'),
(7621, 1052016240, 1052016247, 'DE', 'DEU', 'ألمانيا'),
(7622, 1052016256, 1052016323, 'DE', 'DEU', 'ألمانيا'),
(7623, 1052016448, 1052016463, 'DE', 'DEU', 'ألمانيا'),
(7624, 1052016480, 1052016511, 'DE', 'DEU', 'ألمانيا'),
(7625, 1052016680, 1052016687, 'DE', 'DEU', 'ألمانيا'),
(7626, 1052016896, 1052017151, 'DE', 'DEU', 'ألمانيا'),
(7627, 1052017232, 1052017247, 'DE', 'DEU', 'ألمانيا'),
(7628, 1052017280, 1052017343, 'DE', 'DEU', 'ألمانيا'),
(7629, 1052017472, 1052017503, 'DE', 'DEU', 'ألمانيا'),
(7630, 1052017536, 1052017567, 'DE', 'DEU', 'ألمانيا'),
(7631, 1052017600, 1052017663, 'DE', 'DEU', 'ألمانيا'),
(7632, 1052018168, 1052018431, 'DE', 'DEU', 'ألمانيا'),
(7633, 1052018720, 1052018767, 'DE', 'DEU', 'ألمانيا'),
(7634, 1052019200, 1052019455, 'DE', 'DEU', 'ألمانيا'),
(7635, 1052019736, 1052019775, 'DE', 'DEU', 'ألمانيا'),
(7636, 1052019904, 1052020047, 'DE', 'DEU', 'ألمانيا'),
(7637, 1052020673, 1052020702, 'DE', 'DEU', 'ألمانيا'),
(7638, 1052020704, 1052020735, 'DE', 'DEU', 'ألمانيا'),
(7639, 1052022528, 1052022783, 'DE', 'DEU', 'ألمانيا'),
(7640, 1052024832, 1052041327, 'DE', 'DEU', 'ألمانيا'),
(7641, 1052041336, 1052041359, 'DE', 'DEU', 'ألمانيا'),
(7642, 1052041376, 1052041599, 'DE', 'DEU', 'ألمانيا'),
(7643, 1052041728, 1052041863, 'DE', 'DEU', 'ألمانيا'),
(7644, 1052041984, 1052042047, 'DE', 'DEU', 'ألمانيا'),
(7645, 1052042048, 1052042087, 'NL', 'NLD', 'هولندا'),
(7646, 1052042088, 1052042095, 'DE', 'DEU', 'ألمانيا'),
(7647, 1052042144, 1052042191, 'DE', 'DEU', 'ألمانيا'),
(7648, 1052042224, 1052042239, 'DE', 'DEU', 'ألمانيا'),
(7649, 1052042304, 1052042311, 'DE', 'DEU', 'ألمانيا'),
(7650, 1052042368, 1052042431, 'DE', 'DEU', 'ألمانيا'),
(7651, 1052042480, 1052042519, 'DE', 'DEU', 'ألمانيا'),
(7652, 1052042560, 1052042575, 'DE', 'DEU', 'ألمانيا'),
(7653, 1052042584, 1052042687, 'DE', 'DEU', 'ألمانيا'),
(7654, 1052042704, 1052042751, 'DE', 'DEU', 'ألمانيا'),
(7655, 1052042816, 1052042863, 'DE', 'DEU', 'ألمانيا'),
(7656, 1052043008, 1052043103, 'DE', 'DEU', 'ألمانيا'),
(7657, 1052043112, 1052043127, 'DE', 'DEU', 'ألمانيا'),
(7658, 1052043168, 1052043263, 'DE', 'DEU', 'ألمانيا'),
(7659, 1052043528, 1052043535, 'DE', 'DEU', 'ألمانيا'),
(7660, 1052043552, 1052043575, 'DE', 'DEU', 'ألمانيا'),
(7661, 1052043584, 1052043651, 'DE', 'DEU', 'ألمانيا'),
(7662, 1052043664, 1052043679, 'DE', 'DEU', 'ألمانيا'),
(7663, 1052043760, 1052043775, 'DE', 'DEU', 'ألمانيا'),
(7664, 1052044288, 1052044351, 'DE', 'DEU', 'ألمانيا'),
(7665, 1052044384, 1052044399, 'DE', 'DEU', 'ألمانيا'),
(7666, 1052044416, 1052044447, 'DE', 'DEU', 'ألمانيا'),
(7667, 1052044512, 1052044527, 'DE', 'DEU', 'ألمانيا'),
(7668, 1052044544, 1052044927, 'DE', 'DEU', 'ألمانيا'),
(7669, 1052045024, 1052045055, 'DE', 'DEU', 'ألمانيا'),
(7670, 1052045312, 1052046135, 'DE', 'DEU', 'ألمانيا'),
(7671, 1052046336, 1052046591, 'DE', 'DEU', 'ألمانيا'),
(7672, 1052046848, 1052047139, 'DE', 'DEU', 'ألمانيا'),
(7673, 1052049152, 1052049183, 'DE', 'DEU', 'ألمانيا'),
(7674, 1052049408, 1052057599, 'PL', 'POL', 'بولندا'),
(7675, 1052057600, 1052065791, 'RU', 'RUS', 'الإتحاد الروسي'),
(7676, 1052065792, 1052082175, 'SE', 'SWE', 'السويد'),
(7677, 1052082176, 1052090367, 'DE', 'DEU', 'ألمانيا'),
(7678, 1052090368, 1052098559, 'PL', 'POL', 'بولندا'),
(7679, 1052098560, 1052116991, 'SE', 'SWE', 'السويد'),
(7680, 1052116992, 1052119039, 'RU', 'RUS', 'الإتحاد الروسي'),
(7681, 1052119040, 1052121087, 'RO', 'ROM', 'رومانيا'),
(7682, 1052121088, 1052129279, 'RU', 'RUS', 'الإتحاد الروسي'),
(7683, 1052129280, 1052131327, 'BE', 'BEL', 'بلجيكا'),
(7684, 1052131328, 1052135423, 'RU', 'RUS', 'الإتحاد الروسي'),
(7685, 1052135424, 1052137471, 'UA', 'UKR', 'أوكرانيا'),
(7686, 1052137472, 1052139519, 'RU', 'RUS', 'الإتحاد الروسي'),
(7687, 1052139520, 1052141567, 'DE', 'DEU', 'ألمانيا'),
(7688, 1052141568, 1052143615, 'RU', 'RUS', 'الإتحاد الروسي'),
(7689, 1052143616, 1052145663, 'BG', 'BGR', 'بلغاريا'),
(7690, 1052145664, 1052147711, 'UA', 'UKR', 'أوكرانيا'),
(7691, 1052147712, 1052151807, 'RU', 'RUS', 'الإتحاد الروسي'),
(7692, 1052153856, 1052157951, 'UA', 'UKR', 'أوكرانيا'),
(7693, 1052157952, 1052159999, 'DK', 'DNK', 'الدنيمارك'),
(7694, 1052160000, 1052162047, 'LU', 'LUX', 'لوكسيمبورغ'),
(7695, 1052162048, 1052164095, 'CH', 'CHE', 'سويسرا'),
(7696, 1052164096, 1052168191, 'RU', 'RUS', 'الإتحاد الروسي'),
(7697, 1052170240, 1052172287, 'SE', 'SWE', 'السويد'),
(7698, 1052172288, 1052174335, 'PL', 'POL', 'بولندا'),
(7699, 1052174336, 1052176383, 'CZ', 'CZE', 'التشيك'),
(7700, 1052176384, 1052178431, 'NL', 'NLD', 'هولندا'),
(7701, 1052178432, 1052180479, 'DK', 'DNK', 'الدنيمارك'),
(7702, 1052180480, 1052213247, 'RU', 'RUS', 'الإتحاد الروسي'),
(7703, 1052213248, 1052246015, 'FI', 'FIN', 'فنلندا'),
(7704, 1052246016, 1052247039, 'DE', 'DEU', 'ألمانيا'),
(7705, 1052247040, 1052247295, 'FR', 'FRA', 'فرنسا'),
(7706, 1052247296, 1052247359, 'DE', 'DEU', 'ألمانيا'),
(7707, 1052247360, 1052247391, 'FR', 'FRA', 'فرنسا'),
(7708, 1052247392, 1052247407, 'DE', 'DEU', 'ألمانيا'),
(7709, 1052247408, 1052247415, 'GB', 'GBR', 'المملكة المتحدة'),
(7710, 1052247416, 1052247423, 'NL', 'NLD', 'هولندا'),
(7711, 1052247424, 1052247551, 'GB', 'GBR', 'المملكة المتحدة'),
(7712, 1052247552, 1052248095, 'DE', 'DEU', 'ألمانيا'),
(7713, 1052248096, 1052248127, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7714, 1052248128, 1052248135, 'FR', 'FRA', 'فرنسا'),
(7715, 1052248136, 1052248143, 'DE', 'DEU', 'ألمانيا'),
(7716, 1052248144, 1052248159, 'BE', 'BEL', 'بلجيكا'),
(7717, 1052248160, 1052249375, 'DE', 'DEU', 'ألمانيا'),
(7718, 1052249376, 1052249407, 'IT', 'ITA', 'إيطاليا'),
(7719, 1052249408, 1052249471, 'DE', 'DEU', 'ألمانيا'),
(7720, 1052249472, 1052249503, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7721, 1052249504, 1052250655, 'DE', 'DEU', 'ألمانيا'),
(7722, 1052250656, 1052250687, 'GB', 'GBR', 'المملكة المتحدة'),
(7723, 1052250688, 1052250719, 'IL', 'ISR', 'إسرائيل'),
(7724, 1052250720, 1052250735, 'IT', 'ITA', 'إيطاليا'),
(7725, 1052250736, 1052250751, 'NL', 'NLD', 'هولندا'),
(7726, 1052250752, 1052252863, 'DE', 'DEU', 'ألمانيا'),
(7727, 1052252864, 1052252879, 'GB', 'GBR', 'المملكة المتحدة'),
(7728, 1052252880, 1052252895, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7729, 1052252896, 1052252927, 'IT', 'ITA', 'إيطاليا'),
(7730, 1052252928, 1052254207, 'DE', 'DEU', 'ألمانيا'),
(7731, 1052254208, 1052255255, 'NL', 'NLD', 'هولندا'),
(7732, 1052255256, 1052255263, 'GB', 'GBR', 'المملكة المتحدة'),
(7733, 1052255264, 1052255871, 'NL', 'NLD', 'هولندا'),
(7734, 1052255872, 1052255935, 'GB', 'GBR', 'المملكة المتحدة'),
(7735, 1052255936, 1052257279, 'NL', 'NLD', 'هولندا'),
(7736, 1052257280, 1052257791, 'FR', 'FRA', 'فرنسا'),
(7737, 1052257792, 1052258303, 'AT', 'AUT', 'النمسا'),
(7738, 1052258304, 1052260623, 'FR', 'FRA', 'فرنسا'),
(7739, 1052260624, 1052260631, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7740, 1052260632, 1052260639, 'AT', 'AUT', 'النمسا'),
(7741, 1052260640, 1052260735, 'FR', 'FRA', 'فرنسا'),
(7742, 1052260736, 1052260863, 'NL', 'NLD', 'هولندا'),
(7743, 1052260864, 1052260895, 'TR', 'TUR', 'تركيا'),
(7744, 1052260896, 1052261055, 'FR', 'FRA', 'فرنسا'),
(7745, 1052261056, 1052261119, 'NL', 'NLD', 'هولندا'),
(7746, 1052261120, 1052262399, 'FR', 'FRA', 'فرنسا'),
(7747, 1052262400, 1052263423, 'DK', 'DNK', 'الدنيمارك'),
(7748, 1052263424, 1052263935, 'DE', 'DEU', 'ألمانيا'),
(7749, 1052263936, 1052264447, 'DK', 'DNK', 'الدنيمارك'),
(7750, 1052264448, 1052264639, 'SE', 'SWE', 'السويد'),
(7751, 1052264640, 1052264703, 'IT', 'ITA', 'إيطاليا'),
(7752, 1052264704, 1052265471, 'SE', 'SWE', 'السويد'),
(7753, 1052265472, 1052265519, 'IT', 'ITA', 'إيطاليا'),
(7754, 1052265520, 1052265535, 'GB', 'GBR', 'المملكة المتحدة'),
(7755, 1052265536, 1052265599, 'DE', 'DEU', 'ألمانيا'),
(7756, 1052265600, 1052265983, 'IT', 'ITA', 'إيطاليا'),
(7757, 1052265984, 1052266239, 'DE', 'DEU', 'ألمانيا'),
(7758, 1052266240, 1052266495, 'GB', 'GBR', 'المملكة المتحدة'),
(7759, 1052266496, 1052268543, 'BE', 'BEL', 'بلجيكا'),
(7760, 1052268544, 1052268607, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7761, 1052268608, 1052268671, 'BE', 'BEL', 'بلجيكا'),
(7762, 1052268672, 1052268703, 'IT', 'ITA', 'إيطاليا'),
(7763, 1052268704, 1052268719, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7764, 1052268720, 1052268735, 'NL', 'NLD', 'هولندا'),
(7765, 1052268736, 1052268799, 'DE', 'DEU', 'ألمانيا'),
(7766, 1052268800, 1052270591, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7767, 1052270592, 1052271871, 'FR', 'FRA', 'فرنسا'),
(7768, 1052271872, 1052272127, 'BE', 'BEL', 'بلجيكا'),
(7769, 1052272128, 1052272543, 'FR', 'FRA', 'فرنسا'),
(7770, 1052272544, 1052272575, 'AT', 'AUT', 'النمسا'),
(7771, 1052272576, 1052272639, 'SE', 'SWE', 'السويد'),
(7772, 1052272640, 1052274175, 'FR', 'FRA', 'فرنسا'),
(7773, 1052274176, 1052274687, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7774, 1052274688, 1052274943, 'ES', 'ESP', 'إسبانيا'),
(7775, 1052274944, 1052275199, 'IT', 'ITA', 'إيطاليا'),
(7776, 1052275200, 1052275711, 'AT', 'AUT', 'النمسا'),
(7777, 1052275712, 1052276735, 'GB', 'GBR', 'المملكة المتحدة'),
(7778, 1052276736, 1052278207, 'IT', 'ITA', 'إيطاليا'),
(7779, 1052278208, 1052278271, 'GB', 'GBR', 'المملكة المتحدة'),
(7780, 1052278272, 1052278783, 'IT', 'ITA', 'إيطاليا'),
(7781, 1052278784, 1052278823, 'CH', 'CHE', 'سويسرا'),
(7782, 1052278824, 1052278831, 'GB', 'GBR', 'المملكة المتحدة'),
(7783, 1052278832, 1052278847, 'AT', 'AUT', 'النمسا'),
(7784, 1052278848, 1052278863, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7785, 1052278864, 1052278879, 'NL', 'NLD', 'هولندا'),
(7786, 1052278880, 1052284607, 'GB', 'GBR', 'المملكة المتحدة'),
(7787, 1052284672, 1052286975, 'GB', 'GBR', 'المملكة المتحدة'),
(7788, 1052286976, 1052287487, 'CH', 'CHE', 'سويسرا'),
(7789, 1052287488, 1052288255, 'SE', 'SWE', 'السويد'),
(7790, 1052288288, 1052288295, 'IL', 'ISR', 'إسرائيل'),
(7791, 1052288296, 1052288303, 'BE', 'BEL', 'بلجيكا'),
(7792, 1052288304, 1052288319, 'AT', 'AUT', 'النمسا'),
(7793, 1052288384, 1052288511, 'FR', 'FRA', 'فرنسا'),
(7794, 1052288512, 1052289023, 'AT', 'AUT', 'النمسا'),
(7795, 1052289024, 1052289151, 'GB', 'GBR', 'المملكة المتحدة'),
(7796, 1052289152, 1052289183, 'CH', 'CHE', 'سويسرا'),
(7797, 1052289184, 1052289215, 'DE', 'DEU', 'ألمانيا'),
(7798, 1052289216, 1052289279, 'GB', 'GBR', 'المملكة المتحدة'),
(7799, 1052289536, 1052290047, 'GB', 'GBR', 'المملكة المتحدة'),
(7800, 1052290048, 1052290063, 'CH', 'CHE', 'سويسرا'),
(7801, 1052290064, 1052290303, 'GB', 'GBR', 'المملكة المتحدة'),
(7802, 1052290368, 1052290399, 'CH', 'CHE', 'سويسرا'),
(7803, 1052290400, 1052290431, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7804, 1052290432, 1052290559, 'FR', 'FRA', 'فرنسا'),
(7805, 1052290560, 1052290575, 'GB', 'GBR', 'المملكة المتحدة'),
(7806, 1052290576, 1052290591, 'BE', 'BEL', 'بلجيكا'),
(7807, 1052290592, 1052290639, 'GB', 'GBR', 'المملكة المتحدة'),
(7808, 1052290640, 1052290655, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7809, 1052290656, 1052290687, 'DE', 'DEU', 'ألمانيا'),
(7810, 1052290688, 1052290815, 'GB', 'GBR', 'المملكة المتحدة'),
(7811, 1052290816, 1052290831, 'CH', 'CHE', 'سويسرا'),
(7812, 1052290832, 1052291327, 'GB', 'GBR', 'المملكة المتحدة'),
(7813, 1052291328, 1052291583, 'CH', 'CHE', 'سويسرا'),
(7814, 1052291584, 1052291679, 'FI', 'FIN', 'فنلندا'),
(7815, 1052291680, 1052291687, 'TR', 'TUR', 'تركيا'),
(7816, 1052291688, 1052291695, 'GB', 'GBR', 'المملكة المتحدة'),
(7817, 1052291696, 1052291711, 'CH', 'CHE', 'سويسرا'),
(7818, 1052291712, 1052292095, 'FR', 'FRA', 'فرنسا'),
(7819, 1052292096, 1052299263, 'GB', 'GBR', 'المملكة المتحدة'),
(7820, 1052299776, 1052303359, 'GB', 'GBR', 'المملكة المتحدة'),
(7821, 1052303360, 1052307455, 'DE', 'DEU', 'ألمانيا'),
(7822, 1052307456, 1052309247, 'CH', 'CHE', 'سويسرا'),
(7823, 1052309248, 1052309503, 'NO', 'NOR', 'النرويج'),
(7824, 1052309504, 1052310527, 'CH', 'CHE', 'سويسرا'),
(7825, 1052310528, 1052310783, 'FR', 'FRA', 'فرنسا'),
(7826, 1052310784, 1052311039, 'AT', 'AUT', 'النمسا'),
(7827, 1052311040, 1052311551, 'GB', 'GBR', 'المملكة المتحدة'),
(7828, 1052311552, 1052311615, 'DE', 'DEU', 'ألمانيا'),
(7829, 1052311616, 1052311679, 'BE', 'BEL', 'بلجيكا'),
(7830, 1052311680, 1052311871, 'DE', 'DEU', 'ألمانيا'),
(7831, 1052311872, 1052311895, 'BE', 'BEL', 'بلجيكا'),
(7832, 1052311896, 1052311903, 'NL', 'NLD', 'هولندا'),
(7833, 1052311904, 1052311935, 'IT', 'ITA', 'إيطاليا'),
(7834, 1052311936, 1052311967, 'GB', 'GBR', 'المملكة المتحدة'),
(7835, 1052311968, 1052311999, 'DE', 'DEU', 'ألمانيا'),
(7836, 1052312000, 1052312063, 'CH', 'CHE', 'سويسرا'),
(7837, 1052312064, 1052312767, 'DE', 'DEU', 'ألمانيا'),
(7838, 1052312832, 1052312895, 'DE', 'DEU', 'ألمانيا'),
(7839, 1052312896, 1052312903, 'CH', 'CHE', 'سويسرا'),
(7840, 1052312904, 1052312911, 'ES', 'ESP', 'إسبانيا'),
(7841, 1052312912, 1052312927, 'CH', 'CHE', 'سويسرا'),
(7842, 1052312928, 1052313087, 'GB', 'GBR', 'المملكة المتحدة'),
(7843, 1052313088, 1052314751, 'DE', 'DEU', 'ألمانيا'),
(7844, 1052314752, 1052314815, 'ES', 'ESP', 'إسبانيا'),
(7845, 1052314816, 1052314823, 'DE', 'DEU', 'ألمانيا'),
(7846, 1052314824, 1052314831, 'ES', 'ESP', 'إسبانيا'),
(7847, 1052314832, 1052314847, 'IT', 'ITA', 'إيطاليا'),
(7848, 1052314848, 1052315071, 'DE', 'DEU', 'ألمانيا'),
(7849, 1052315072, 1052315103, 'IT', 'ITA', 'إيطاليا'),
(7850, 1052315104, 1052315135, 'AT', 'AUT', 'النمسا'),
(7851, 1052315136, 1052315551, 'DE', 'DEU', 'ألمانيا'),
(7852, 1052315552, 1052315583, 'ES', 'ESP', 'إسبانيا'),
(7853, 1052315584, 1052315647, 'GB', 'GBR', 'المملكة المتحدة'),
(7854, 1052315648, 1052316319, 'DE', 'DEU', 'ألمانيا'),
(7855, 1052316320, 1052316335, 'NL', 'NLD', 'هولندا'),
(7856, 1052316336, 1052316767, 'DE', 'DEU', 'ألمانيا'),
(7857, 1052316768, 1052316799, 'IT', 'ITA', 'إيطاليا'),
(7858, 1052316800, 1052316927, 'DE', 'DEU', 'ألمانيا'),
(7859, 1052317184, 1052317599, 'DE', 'DEU', 'ألمانيا'),
(7860, 1052317600, 1052317607, 'BE', 'BEL', 'بلجيكا'),
(7861, 1052317608, 1052317615, 'DE', 'DEU', 'ألمانيا'),
(7862, 1052317616, 1052317631, 'GB', 'GBR', 'المملكة المتحدة'),
(7863, 1052317632, 1052317663, 'IT', 'ITA', 'إيطاليا'),
(7864, 1052317664, 1052318047, 'DE', 'DEU', 'ألمانيا'),
(7865, 1052318048, 1052318079, 'ES', 'ESP', 'إسبانيا'),
(7866, 1052318080, 1052318207, 'SE', 'SWE', 'السويد'),
(7867, 1052318208, 1052318719, 'DE', 'DEU', 'ألمانيا'),
(7868, 1052319232, 1052319743, 'DE', 'DEU', 'ألمانيا'),
(7869, 1052320000, 1052320079, 'GB', 'GBR', 'المملكة المتحدة'),
(7870, 1052320080, 1052320087, 'CZ', 'CZE', 'التشيك'),
(7871, 1052320088, 1052320095, 'GB', 'GBR', 'المملكة المتحدة'),
(7872, 1052320096, 1052320127, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7873, 1052320128, 1052320255, 'BE', 'BEL', 'بلجيكا'),
(7874, 1052320256, 1052322239, 'GB', 'GBR', 'المملكة المتحدة'),
(7875, 1052322240, 1052322303, 'CH', 'CHE', 'سويسرا'),
(7876, 1052322304, 1052323871, 'GB', 'GBR', 'المملكة المتحدة'),
(7877, 1052323872, 1052323903, 'CH', 'CHE', 'سويسرا'),
(7878, 1052323904, 1052324927, 'GB', 'GBR', 'المملكة المتحدة'),
(7879, 1052324928, 1052324943, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7880, 1052324944, 1052324959, 'NL', 'NLD', 'هولندا'),
(7881, 1052324960, 1052324991, 'ES', 'ESP', 'إسبانيا'),
(7882, 1052324992, 1052325191, 'GB', 'GBR', 'المملكة المتحدة'),
(7883, 1052325192, 1052325199, 'DE', 'DEU', 'ألمانيا'),
(7884, 1052325200, 1052325215, 'AT', 'AUT', 'النمسا'),
(7885, 1052325216, 1052325247, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7886, 1052325248, 1052325311, 'GB', 'GBR', 'المملكة المتحدة'),
(7887, 1052325312, 1052325375, 'NL', 'NLD', 'هولندا'),
(7888, 1052325376, 1052325567, 'GB', 'GBR', 'المملكة المتحدة'),
(7889, 1052325568, 1052325631, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7890, 1052325632, 1052327935, 'GB', 'GBR', 'المملكة المتحدة'),
(7891, 1052327936, 1052328223, 'CH', 'CHE', 'سويسرا'),
(7892, 1052328224, 1052328255, 'IT', 'ITA', 'إيطاليا'),
(7893, 1052328256, 1052328319, 'ES', 'ESP', 'إسبانيا'),
(7894, 1052328320, 1052328447, 'DE', 'DEU', 'ألمانيا'),
(7895, 1052328448, 1052328639, 'CH', 'CHE', 'سويسرا'),
(7896, 1052328640, 1052328671, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7897, 1052328672, 1052328703, 'ES', 'ESP', 'إسبانيا'),
(7898, 1052328704, 1052329983, 'CH', 'CHE', 'سويسرا'),
(7899, 1052329984, 1052330239, 'DE', 'DEU', 'ألمانيا'),
(7900, 1052330240, 1052331167, 'CH', 'CHE', 'سويسرا'),
(7901, 1052331168, 1052331183, 'GB', 'GBR', 'المملكة المتحدة'),
(7902, 1052331184, 1052331199, 'CH', 'CHE', 'سويسرا'),
(7903, 1052331200, 1052331263, 'GB', 'GBR', 'المملكة المتحدة'),
(7904, 1052331264, 1052331615, 'CH', 'CHE', 'سويسرا'),
(7905, 1052331616, 1052331647, 'AT', 'AUT', 'النمسا'),
(7906, 1052331648, 1052331711, 'CH', 'CHE', 'سويسرا'),
(7907, 1052331712, 1052331743, 'GB', 'GBR', 'المملكة المتحدة'),
(7908, 1052331744, 1052332031, 'CH', 'CHE', 'سويسرا'),
(7909, 1052332032, 1052333103, 'IT', 'ITA', 'إيطاليا'),
(7910, 1052333104, 1052333119, 'CH', 'CHE', 'سويسرا'),
(7911, 1052333120, 1052333183, 'FR', 'FRA', 'فرنسا'),
(7912, 1052333184, 1052333311, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7913, 1052333568, 1052334751, 'IT', 'ITA', 'إيطاليا'),
(7914, 1052334752, 1052334759, 'NL', 'NLD', 'هولندا'),
(7915, 1052334760, 1052334767, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7916, 1052334768, 1052334815, 'GB', 'GBR', 'المملكة المتحدة'),
(7917, 1052334816, 1052334847, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7918, 1052334848, 1052335423, 'IT', 'ITA', 'إيطاليا'),
(7919, 1052335424, 1052335455, 'NL', 'NLD', 'هولندا'),
(7920, 1052335456, 1052335519, 'ES', 'ESP', 'إسبانيا'),
(7921, 1052335520, 1052335535, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7922, 1052335536, 1052335551, 'DE', 'DEU', 'ألمانيا'),
(7923, 1052335552, 1052335615, 'AT', 'AUT', 'النمسا'),
(7924, 1052335616, 1052336127, 'BE', 'BEL', 'بلجيكا'),
(7925, 1052336128, 1052336255, 'FR', 'FRA', 'فرنسا'),
(7926, 1052336256, 1052336383, 'GB', 'GBR', 'المملكة المتحدة'),
(7927, 1052336384, 1052337343, 'FR', 'FRA', 'فرنسا'),
(7928, 1052337344, 1052337375, 'DE', 'DEU', 'ألمانيا'),
(7929, 1052337376, 1052337759, 'FR', 'FRA', 'فرنسا'),
(7930, 1052337760, 1052337887, 'GB', 'GBR', 'المملكة المتحدة'),
(7931, 1052337888, 1052337903, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7932, 1052337904, 1052337911, 'NL', 'NLD', 'هولندا'),
(7933, 1052337912, 1052337919, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7934, 1052337920, 1052340111, 'FR', 'FRA', 'فرنسا'),
(7935, 1052340112, 1052340127, 'ES', 'ESP', 'إسبانيا'),
(7936, 1052340128, 1052340135, 'NL', 'NLD', 'هولندا'),
(7937, 1052340136, 1052340223, 'FR', 'FRA', 'فرنسا'),
(7938, 1052340224, 1052340527, 'AT', 'AUT', 'النمسا'),
(7939, 1052340528, 1052340543, 'BE', 'BEL', 'بلجيكا'),
(7940, 1052340544, 1052340575, 'IT', 'ITA', 'إيطاليا'),
(7941, 1052340576, 1052340607, 'NL', 'NLD', 'هولندا'),
(7942, 1052340608, 1052340671, 'HU', 'HUN', 'هنغاريا'),
(7943, 1052340672, 1052340703, 'GB', 'GBR', 'المملكة المتحدة'),
(7944, 1052340704, 1052340719, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7945, 1052340720, 1052340735, 'GB', 'GBR', 'المملكة المتحدة'),
(7946, 1052340736, 1052340767, 'AT', 'AUT', 'النمسا'),
(7947, 1052340768, 1052340799, 'DE', 'DEU', 'ألمانيا'),
(7948, 1052340800, 1052340863, 'GB', 'GBR', 'المملكة المتحدة'),
(7949, 1052340864, 1052341247, 'AT', 'AUT', 'النمسا'),
(7950, 1052341248, 1052341503, 'DE', 'DEU', 'ألمانيا'),
(7951, 1052341504, 1052342271, 'AT', 'AUT', 'النمسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(7952, 1052342272, 1052342303, 'SE', 'SWE', 'السويد'),
(7953, 1052342304, 1052342335, 'CH', 'CHE', 'سويسرا'),
(7954, 1052342336, 1052342463, 'SE', 'SWE', 'السويد'),
(7955, 1052342464, 1052342471, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7956, 1052342472, 1052342479, 'GB', 'GBR', 'المملكة المتحدة'),
(7957, 1052342480, 1052342495, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7958, 1052342496, 1052342527, 'FR', 'FRA', 'فرنسا'),
(7959, 1052342528, 1052343647, 'CH', 'CHE', 'سويسرا'),
(7960, 1052343648, 1052343655, 'NL', 'NLD', 'هولندا'),
(7961, 1052343656, 1052343663, 'GB', 'GBR', 'المملكة المتحدة'),
(7962, 1052343664, 1052343679, 'DE', 'DEU', 'ألمانيا'),
(7963, 1052343680, 1052344319, 'CH', 'CHE', 'سويسرا'),
(7964, 1052344320, 1052344863, 'NL', 'NLD', 'هولندا'),
(7965, 1052344864, 1052344895, 'ES', 'ESP', 'إسبانيا'),
(7966, 1052344896, 1052344959, 'IT', 'ITA', 'إيطاليا'),
(7967, 1052344960, 1052345087, 'CH', 'CHE', 'سويسرا'),
(7968, 1052345088, 1052345135, 'NL', 'NLD', 'هولندا'),
(7969, 1052345136, 1052345151, 'GB', 'GBR', 'المملكة المتحدة'),
(7970, 1052345152, 1052345247, 'FR', 'FRA', 'فرنسا'),
(7971, 1052345248, 1052345279, 'IT', 'ITA', 'إيطاليا'),
(7972, 1052345280, 1052345343, 'DE', 'DEU', 'ألمانيا'),
(7973, 1052345344, 1052345471, 'NL', 'NLD', 'هولندا'),
(7974, 1052345488, 1052345503, 'NL', 'NLD', 'هولندا'),
(7975, 1052345504, 1052345535, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7976, 1052345536, 1052345551, 'AT', 'AUT', 'النمسا'),
(7977, 1052345552, 1052345567, 'GB', 'GBR', 'المملكة المتحدة'),
(7978, 1052345568, 1052345631, 'NL', 'NLD', 'هولندا'),
(7979, 1052345632, 1052345663, 'IT', 'ITA', 'إيطاليا'),
(7980, 1052345664, 1052345695, 'HU', 'HUN', 'هنغاريا'),
(7981, 1052345696, 1052345727, 'PT', 'PRT', 'البورتوغال'),
(7982, 1052345728, 1052345855, 'AT', 'AUT', 'النمسا'),
(7983, 1052345856, 1052346903, 'NL', 'NLD', 'هولندا'),
(7984, 1052346904, 1052346911, 'BE', 'BEL', 'بلجيكا'),
(7985, 1052346912, 1052346943, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(7986, 1052346944, 1052347007, 'ES', 'ESP', 'إسبانيا'),
(7987, 1052347008, 1052347135, 'DE', 'DEU', 'ألمانيا'),
(7988, 1052347136, 1052347391, 'NL', 'NLD', 'هولندا'),
(7989, 1052347392, 1052348415, 'CH', 'CHE', 'سويسرا'),
(7990, 1052348416, 1052348799, 'GB', 'GBR', 'المملكة المتحدة'),
(7991, 1052348800, 1052348831, 'DE', 'DEU', 'ألمانيا'),
(7992, 1052348832, 1052348863, 'CH', 'CHE', 'سويسرا'),
(7993, 1052348864, 1052348879, 'DE', 'DEU', 'ألمانيا'),
(7994, 1052348880, 1052348895, 'GB', 'GBR', 'المملكة المتحدة'),
(7995, 1052348896, 1052348927, 'DE', 'DEU', 'ألمانيا'),
(7996, 1052348928, 1052349119, 'GB', 'GBR', 'المملكة المتحدة'),
(7997, 1052349120, 1052349151, 'BE', 'BEL', 'بلجيكا'),
(7998, 1052349152, 1052349343, 'GB', 'GBR', 'المملكة المتحدة'),
(7999, 1052349344, 1052349375, 'DE', 'DEU', 'ألمانيا'),
(8000, 1052349376, 1052349407, 'GB', 'GBR', 'المملكة المتحدة'),
(8001, 1052349408, 1052349439, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8002, 1052349440, 1052352559, 'GB', 'GBR', 'المملكة المتحدة'),
(8003, 1052352560, 1052352591, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8004, 1052352592, 1052352607, 'GB', 'GBR', 'المملكة المتحدة'),
(8005, 1052352640, 1052352703, 'GB', 'GBR', 'المملكة المتحدة'),
(8006, 1052352704, 1052352767, 'DE', 'DEU', 'ألمانيا'),
(8007, 1052352768, 1052352927, 'GB', 'GBR', 'المملكة المتحدة'),
(8008, 1052352928, 1052352959, 'IT', 'ITA', 'إيطاليا'),
(8009, 1052352960, 1052352991, 'ES', 'ESP', 'إسبانيا'),
(8010, 1052352992, 1052353023, 'BE', 'BEL', 'بلجيكا'),
(8011, 1052353024, 1052353279, 'IT', 'ITA', 'إيطاليا'),
(8012, 1052353280, 1052353407, 'DE', 'DEU', 'ألمانيا'),
(8013, 1052353536, 1052354111, 'DE', 'DEU', 'ألمانيا'),
(8014, 1052354112, 1052354175, 'TR', 'TUR', 'تركيا'),
(8015, 1052354176, 1052354559, 'DE', 'DEU', 'ألمانيا'),
(8016, 1052354560, 1052356607, 'GB', 'GBR', 'المملكة المتحدة'),
(8017, 1052356608, 1052356703, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8018, 1052356704, 1052356735, 'ES', 'ESP', 'إسبانيا'),
(8019, 1052356736, 1052356799, 'RU', 'RUS', 'الإتحاد الروسي'),
(8020, 1052356800, 1052356863, 'IE', 'IRL', 'إيرلندا'),
(8021, 1052356864, 1052358479, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8022, 1052358480, 1052358495, 'GB', 'GBR', 'المملكة المتحدة'),
(8023, 1052358496, 1052358511, 'AT', 'AUT', 'النمسا'),
(8024, 1052358512, 1052358527, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8025, 1052358528, 1052358655, 'DE', 'DEU', 'ألمانيا'),
(8026, 1052358656, 1052359839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8027, 1052359840, 1052359871, 'IE', 'IRL', 'إيرلندا'),
(8028, 1052359872, 1052359935, 'IT', 'ITA', 'إيطاليا'),
(8029, 1052359936, 1052360735, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8030, 1052360736, 1052360743, 'GB', 'GBR', 'المملكة المتحدة'),
(8031, 1052360744, 1052360767, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8032, 1052360768, 1052360783, 'DE', 'DEU', 'ألمانيا'),
(8033, 1052360784, 1052360831, 'IT', 'ITA', 'إيطاليا'),
(8034, 1052360832, 1052360959, 'GB', 'GBR', 'المملكة المتحدة'),
(8035, 1052360960, 1052360991, 'FR', 'FRA', 'فرنسا'),
(8036, 1052360992, 1052361023, 'BE', 'BEL', 'بلجيكا'),
(8037, 1052361024, 1052361039, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8038, 1052361040, 1052361055, 'NL', 'NLD', 'هولندا'),
(8039, 1052361056, 1052361087, 'DE', 'DEU', 'ألمانيا'),
(8040, 1052361088, 1052361151, 'ES', 'ESP', 'إسبانيا'),
(8041, 1052361152, 1052361215, 'GB', 'GBR', 'المملكة المتحدة'),
(8042, 1052361216, 1052361471, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8043, 1052361472, 1052361647, 'BE', 'BEL', 'بلجيكا'),
(8044, 1052361648, 1052361655, 'GB', 'GBR', 'المملكة المتحدة'),
(8045, 1052361656, 1052361663, 'DE', 'DEU', 'ألمانيا'),
(8046, 1052361664, 1052361695, 'BE', 'BEL', 'بلجيكا'),
(8047, 1052361696, 1052361727, 'CH', 'CHE', 'سويسرا'),
(8048, 1052361728, 1052361919, 'IT', 'ITA', 'إيطاليا'),
(8049, 1052361920, 1052361951, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8050, 1052361952, 1052361967, 'IT', 'ITA', 'إيطاليا'),
(8051, 1052361968, 1052361983, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8052, 1052361984, 1052362239, 'IT', 'ITA', 'إيطاليا'),
(8053, 1052362240, 1052362751, 'DK', 'DNK', 'الدنيمارك'),
(8054, 1052362752, 1052362783, 'ES', 'ESP', 'إسبانيا'),
(8055, 1052362784, 1052362815, 'GB', 'GBR', 'المملكة المتحدة'),
(8056, 1052362816, 1052362879, 'CH', 'CHE', 'سويسرا'),
(8057, 1052362880, 1052363039, 'ES', 'ESP', 'إسبانيا'),
(8058, 1052363072, 1052363135, 'GB', 'GBR', 'المملكة المتحدة'),
(8059, 1052363136, 1052363263, 'ES', 'ESP', 'إسبانيا'),
(8060, 1052363264, 1052364543, 'DE', 'DEU', 'ألمانيا'),
(8061, 1052364544, 1052364671, 'BE', 'BEL', 'بلجيكا'),
(8062, 1052364672, 1052364687, 'DE', 'DEU', 'ألمانيا'),
(8063, 1052364688, 1052364695, 'GB', 'GBR', 'المملكة المتحدة'),
(8064, 1052364696, 1052364703, 'NL', 'NLD', 'هولندا'),
(8065, 1052364704, 1052364799, 'GB', 'GBR', 'المملكة المتحدة'),
(8066, 1052364800, 1052366207, 'BE', 'BEL', 'بلجيكا'),
(8067, 1052366208, 1052366271, 'IE', 'IRL', 'إيرلندا'),
(8068, 1052366272, 1052366335, 'GB', 'GBR', 'المملكة المتحدة'),
(8069, 1052366336, 1052366655, 'BE', 'BEL', 'بلجيكا'),
(8070, 1052366656, 1052366719, 'DE', 'DEU', 'ألمانيا'),
(8071, 1052366720, 1052367871, 'BE', 'BEL', 'بلجيكا'),
(8072, 1052367872, 1052368895, 'DK', 'DNK', 'الدنيمارك'),
(8073, 1052368896, 1052369023, 'IE', 'IRL', 'إيرلندا'),
(8074, 1052369024, 1052369039, 'IT', 'ITA', 'إيطاليا'),
(8075, 1052369040, 1052369055, 'DE', 'DEU', 'ألمانيا'),
(8076, 1052369056, 1052369087, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8077, 1052369088, 1052369151, 'IT', 'ITA', 'إيطاليا'),
(8078, 1052369152, 1052369407, 'IE', 'IRL', 'إيرلندا'),
(8079, 1052369408, 1052369663, 'HU', 'HUN', 'هنغاريا'),
(8080, 1052369664, 1052369855, 'CZ', 'CZE', 'التشيك'),
(8081, 1052369888, 1052369919, 'CZ', 'CZE', 'التشيك'),
(8082, 1052369920, 1052370175, 'NO', 'NOR', 'النرويج'),
(8083, 1052370176, 1052370431, 'DK', 'DNK', 'الدنيمارك'),
(8084, 1052370432, 1052370559, 'SE', 'SWE', 'السويد'),
(8085, 1052370560, 1052370623, 'DE', 'DEU', 'ألمانيا'),
(8086, 1052370624, 1052370687, 'IT', 'ITA', 'إيطاليا'),
(8087, 1052370688, 1052370943, 'DK', 'DNK', 'الدنيمارك'),
(8088, 1052370944, 1052372255, 'GB', 'GBR', 'المملكة المتحدة'),
(8089, 1052372256, 1052372287, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8090, 1052372288, 1052372351, 'FI', 'FIN', 'فنلندا'),
(8091, 1052372352, 1052374015, 'GB', 'GBR', 'المملكة المتحدة'),
(8092, 1052374016, 1052375039, 'CH', 'CHE', 'سويسرا'),
(8093, 1052375040, 1052375551, 'DE', 'DEU', 'ألمانيا'),
(8094, 1052375680, 1052375711, 'DE', 'DEU', 'ألمانيا'),
(8095, 1052375712, 1052375807, 'FR', 'FRA', 'فرنسا'),
(8096, 1052375808, 1052376063, 'DE', 'DEU', 'ألمانيا'),
(8097, 1052376320, 1052376831, 'DE', 'DEU', 'ألمانيا'),
(8098, 1052376832, 1052377087, 'ES', 'ESP', 'إسبانيا'),
(8099, 1052377088, 1052377535, 'DE', 'DEU', 'ألمانيا'),
(8100, 1052377536, 1052377599, 'NO', 'NOR', 'النرويج'),
(8101, 1052377600, 1052377743, 'FR', 'FRA', 'فرنسا'),
(8102, 1052377744, 1052377759, 'NL', 'NLD', 'هولندا'),
(8103, 1052377760, 1052377791, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8104, 1052377792, 1052377855, 'GB', 'GBR', 'المملكة المتحدة'),
(8105, 1052377856, 1052377871, 'DE', 'DEU', 'ألمانيا'),
(8106, 1052377872, 1052377887, 'CH', 'CHE', 'سويسرا'),
(8107, 1052377920, 1052377951, 'DE', 'DEU', 'ألمانيا'),
(8108, 1052377952, 1052377983, 'FR', 'FRA', 'فرنسا'),
(8109, 1052377984, 1052378047, 'GB', 'GBR', 'المملكة المتحدة'),
(8110, 1052378048, 1052378079, 'FR', 'FRA', 'فرنسا'),
(8111, 1052378080, 1052378111, 'NL', 'NLD', 'هولندا'),
(8112, 1052378112, 1052378983, 'DE', 'DEU', 'ألمانيا'),
(8113, 1052378984, 1052378991, 'NO', 'NOR', 'النرويج'),
(8114, 1052378992, 1052379031, 'GB', 'GBR', 'المملكة المتحدة'),
(8115, 1052379032, 1052379039, 'DE', 'DEU', 'ألمانيا'),
(8116, 1052379040, 1052379103, 'GB', 'GBR', 'المملكة المتحدة'),
(8117, 1052379104, 1052379135, 'SE', 'SWE', 'السويد'),
(8118, 1052379392, 1052379791, 'DE', 'DEU', 'ألمانيا'),
(8119, 1052379792, 1052379799, 'GB', 'GBR', 'المملكة المتحدة'),
(8120, 1052379800, 1052379807, 'NL', 'NLD', 'هولندا'),
(8121, 1052379808, 1052379839, 'DE', 'DEU', 'ألمانيا'),
(8122, 1052379840, 1052379903, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8123, 1052379904, 1052380063, 'GB', 'GBR', 'المملكة المتحدة'),
(8124, 1052380064, 1052380127, 'DE', 'DEU', 'ألمانيا'),
(8125, 1052380128, 1052380159, 'NL', 'NLD', 'هولندا'),
(8126, 1052380160, 1052381183, 'DE', 'DEU', 'ألمانيا'),
(8127, 1052381440, 1052382623, 'DE', 'DEU', 'ألمانيا'),
(8128, 1052382656, 1052382719, 'ES', 'ESP', 'إسبانيا'),
(8129, 1052382720, 1052382975, 'DE', 'DEU', 'ألمانيا'),
(8130, 1052382976, 1052383999, 'GB', 'GBR', 'المملكة المتحدة'),
(8131, 1052384000, 1052384255, 'NL', 'NLD', 'هولندا'),
(8132, 1052384256, 1052385279, 'GB', 'GBR', 'المملكة المتحدة'),
(8133, 1052385280, 1052385535, 'DE', 'DEU', 'ألمانيا'),
(8134, 1052385536, 1052385615, 'GB', 'GBR', 'المملكة المتحدة'),
(8135, 1052385616, 1052385631, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8136, 1052385632, 1052385695, 'GB', 'GBR', 'المملكة المتحدة'),
(8137, 1052385696, 1052385791, 'FR', 'FRA', 'فرنسا'),
(8138, 1052385792, 1052388863, 'GB', 'GBR', 'المملكة المتحدة'),
(8139, 1052388864, 1052389119, 'NL', 'NLD', 'هولندا'),
(8140, 1052389120, 1052390431, 'GB', 'GBR', 'المملكة المتحدة'),
(8141, 1052390432, 1052390447, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8142, 1052390448, 1052390455, 'GB', 'GBR', 'المملكة المتحدة'),
(8143, 1052390456, 1052390463, 'IT', 'ITA', 'إيطاليا'),
(8144, 1052390464, 1052393471, 'GB', 'GBR', 'المملكة المتحدة'),
(8145, 1052393472, 1052393599, 'CH', 'CHE', 'سويسرا'),
(8146, 1052393600, 1052393695, 'FR', 'FRA', 'فرنسا'),
(8147, 1052393696, 1052394271, 'CH', 'CHE', 'سويسرا'),
(8148, 1052394272, 1052394303, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8149, 1052394304, 1052394367, 'GB', 'GBR', 'المملكة المتحدة'),
(8150, 1052394368, 1052395263, 'CH', 'CHE', 'سويسرا'),
(8151, 1052395264, 1052395679, 'GB', 'GBR', 'المملكة المتحدة'),
(8152, 1052395680, 1052395743, 'DE', 'DEU', 'ألمانيا'),
(8153, 1052395744, 1052395775, 'ES', 'ESP', 'إسبانيا'),
(8154, 1052395776, 1052396031, 'NL', 'NLD', 'هولندا'),
(8155, 1052396032, 1052396543, 'CH', 'CHE', 'سويسرا'),
(8156, 1052396544, 1052396607, 'SE', 'SWE', 'السويد'),
(8157, 1052396608, 1052396671, 'BE', 'BEL', 'بلجيكا'),
(8158, 1052396672, 1052396799, 'SE', 'SWE', 'السويد'),
(8159, 1052396800, 1052396863, 'TR', 'TUR', 'تركيا'),
(8160, 1052396864, 1052396927, 'RO', 'ROM', 'رومانيا'),
(8161, 1052396928, 1052397439, 'HU', 'HUN', 'هنغاريا'),
(8162, 1052397568, 1052399039, 'IT', 'ITA', 'إيطاليا'),
(8163, 1052399040, 1052399103, 'NO', 'NOR', 'النرويج'),
(8164, 1052399104, 1052399903, 'IT', 'ITA', 'إيطاليا'),
(8165, 1052399904, 1052399919, 'DE', 'DEU', 'ألمانيا'),
(8166, 1052399920, 1052399927, 'NL', 'NLD', 'هولندا'),
(8167, 1052399928, 1052399935, 'FR', 'FRA', 'فرنسا'),
(8168, 1052399936, 1052399999, 'IT', 'ITA', 'إيطاليا'),
(8169, 1052400000, 1052400127, 'BE', 'BEL', 'بلجيكا'),
(8170, 1052400128, 1052401151, 'IT', 'ITA', 'إيطاليا'),
(8171, 1052401152, 1052401279, 'BE', 'BEL', 'بلجيكا'),
(8172, 1052401280, 1052401311, 'IT', 'ITA', 'إيطاليا'),
(8173, 1052401312, 1052401343, 'AT', 'AUT', 'النمسا'),
(8174, 1052401344, 1052401407, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8175, 1052401408, 1052401599, 'BE', 'BEL', 'بلجيكا'),
(8176, 1052401600, 1052401631, 'GB', 'GBR', 'المملكة المتحدة'),
(8177, 1052401632, 1052401663, 'RU', 'RUS', 'الإتحاد الروسي'),
(8178, 1052401664, 1052402047, 'FR', 'FRA', 'فرنسا'),
(8179, 1052402048, 1052402175, 'NL', 'NLD', 'هولندا'),
(8180, 1052402176, 1052402271, 'FR', 'FRA', 'فرنسا'),
(8181, 1052402272, 1052402303, 'IT', 'ITA', 'إيطاليا'),
(8182, 1052402304, 1052402367, 'GB', 'GBR', 'المملكة المتحدة'),
(8183, 1052402368, 1052403359, 'FR', 'FRA', 'فرنسا'),
(8184, 1052403360, 1052403391, 'DE', 'DEU', 'ألمانيا'),
(8185, 1052403392, 1052403407, 'IT', 'ITA', 'إيطاليا'),
(8186, 1052403408, 1052403415, 'GB', 'GBR', 'المملكة المتحدة'),
(8187, 1052403416, 1052403423, 'NL', 'NLD', 'هولندا'),
(8188, 1052403424, 1052403455, 'RO', 'ROM', 'رومانيا'),
(8189, 1052403456, 1052403727, 'FR', 'FRA', 'فرنسا'),
(8190, 1052403728, 1052403743, 'NL', 'NLD', 'هولندا'),
(8191, 1052403744, 1052403775, 'FR', 'FRA', 'فرنسا'),
(8192, 1052403776, 1052403839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8193, 1052403840, 1052403967, 'CH', 'CHE', 'سويسرا'),
(8194, 1052403968, 1052404383, 'FR', 'FRA', 'فرنسا'),
(8195, 1052404384, 1052404399, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8196, 1052404400, 1052404447, 'FR', 'FRA', 'فرنسا'),
(8197, 1052404448, 1052404479, 'GB', 'GBR', 'المملكة المتحدة'),
(8198, 1052404480, 1052404767, 'FR', 'FRA', 'فرنسا'),
(8199, 1052404768, 1052404783, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8200, 1052404784, 1052404799, 'GB', 'GBR', 'المملكة المتحدة'),
(8201, 1052404800, 1052404863, 'FR', 'FRA', 'فرنسا'),
(8202, 1052404864, 1052404991, 'GB', 'GBR', 'المملكة المتحدة'),
(8203, 1052404992, 1052405759, 'FR', 'FRA', 'فرنسا'),
(8204, 1052405760, 1052407519, 'AT', 'AUT', 'النمسا'),
(8205, 1052407520, 1052407535, 'FR', 'FRA', 'فرنسا'),
(8206, 1052407536, 1052407551, 'SE', 'SWE', 'السويد'),
(8207, 1052407552, 1052407839, 'AT', 'AUT', 'النمسا'),
(8208, 1052407840, 1052407871, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8209, 1052407872, 1052407887, 'DE', 'DEU', 'ألمانيا'),
(8210, 1052407888, 1052407903, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8211, 1052407904, 1052407935, 'DE', 'DEU', 'ألمانيا'),
(8212, 1052407936, 1052408159, 'AT', 'AUT', 'النمسا'),
(8213, 1052408160, 1052408383, 'GB', 'GBR', 'المملكة المتحدة'),
(8214, 1052408384, 1052408447, 'BE', 'BEL', 'بلجيكا'),
(8215, 1052408448, 1052408511, 'FR', 'FRA', 'فرنسا'),
(8216, 1052408512, 1052408575, 'GB', 'GBR', 'المملكة المتحدة'),
(8217, 1052408576, 1052408831, 'AT', 'AUT', 'النمسا'),
(8218, 1052408832, 1052409855, 'GB', 'GBR', 'المملكة المتحدة'),
(8219, 1052409856, 1052409863, 'NL', 'NLD', 'هولندا'),
(8220, 1052409864, 1052409871, 'DE', 'DEU', 'ألمانيا'),
(8221, 1052409872, 1052409951, 'NL', 'NLD', 'هولندا'),
(8222, 1052409952, 1052409983, 'BE', 'BEL', 'بلجيكا'),
(8223, 1052409984, 1052410047, 'GB', 'GBR', 'المملكة المتحدة'),
(8224, 1052410048, 1052410111, 'BE', 'BEL', 'بلجيكا'),
(8225, 1052411136, 1052412327, 'NL', 'NLD', 'هولندا'),
(8226, 1052412336, 1052412343, 'NL', 'NLD', 'هولندا'),
(8227, 1052412344, 1052412351, 'GB', 'GBR', 'المملكة المتحدة'),
(8228, 1052412352, 1052412415, 'CH', 'CHE', 'سويسرا'),
(8229, 1052412672, 1052412831, 'NL', 'NLD', 'هولندا'),
(8230, 1052412832, 1052412863, 'DE', 'DEU', 'ألمانيا'),
(8231, 1052412864, 1052413951, 'NL', 'NLD', 'هولندا'),
(8232, 1052413952, 1052414335, 'CZ', 'CZE', 'التشيك'),
(8233, 1052414464, 1052414975, 'IE', 'IRL', 'إيرلندا'),
(8234, 1052414976, 1052415999, 'BE', 'BEL', 'بلجيكا'),
(8235, 1052416000, 1052416575, 'DE', 'DEU', 'ألمانيا'),
(8236, 1052416576, 1052416639, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8237, 1052416640, 1052416671, 'GB', 'GBR', 'المملكة المتحدة'),
(8238, 1052416672, 1052416703, 'DE', 'DEU', 'ألمانيا'),
(8239, 1052416704, 1052416735, 'IT', 'ITA', 'إيطاليا'),
(8240, 1052416736, 1052416767, 'DE', 'DEU', 'ألمانيا'),
(8241, 1052416768, 1052417071, 'NO', 'NOR', 'النرويج'),
(8242, 1052417072, 1052417087, 'DE', 'DEU', 'ألمانيا'),
(8243, 1052417088, 1052417119, 'AT', 'AUT', 'النمسا'),
(8244, 1052417120, 1052417151, 'IT', 'ITA', 'إيطاليا'),
(8245, 1052417152, 1052417279, 'GB', 'GBR', 'المملكة المتحدة'),
(8246, 1052417280, 1052417359, 'NO', 'NOR', 'النرويج'),
(8247, 1052417368, 1052417535, 'NO', 'NOR', 'النرويج'),
(8248, 1052417536, 1052418047, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8249, 1052418048, 1052419583, 'BE', 'BEL', 'بلجيكا'),
(8250, 1052419584, 1052420031, 'IT', 'ITA', 'إيطاليا'),
(8251, 1052420064, 1052420095, 'IT', 'ITA', 'إيطاليا'),
(8252, 1052420096, 1052420735, 'GB', 'GBR', 'المملكة المتحدة'),
(8253, 1052420736, 1052420767, 'DE', 'DEU', 'ألمانيا'),
(8254, 1052420768, 1052420783, 'GB', 'GBR', 'المملكة المتحدة'),
(8255, 1052420784, 1052420799, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8256, 1052420800, 1052420863, 'DE', 'DEU', 'ألمانيا'),
(8257, 1052420864, 1052422143, 'GB', 'GBR', 'المملكة المتحدة'),
(8258, 1052422144, 1052422847, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8259, 1052422848, 1052422863, 'SE', 'SWE', 'السويد'),
(8260, 1052422864, 1052422879, 'FR', 'FRA', 'فرنسا'),
(8261, 1052422880, 1052423199, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8262, 1052423200, 1052423231, 'CH', 'CHE', 'سويسرا'),
(8263, 1052423232, 1052423295, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8264, 1052423304, 1052423311, 'CH', 'CHE', 'سويسرا'),
(8265, 1052423360, 1052423423, 'NL', 'NLD', 'هولندا'),
(8266, 1052423424, 1052423967, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8267, 1052424000, 1052424799, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8268, 1052424800, 1052424815, 'GB', 'GBR', 'المملكة المتحدة'),
(8269, 1052424816, 1052424823, 'ES', 'ESP', 'إسبانيا'),
(8270, 1052424824, 1052424831, 'BE', 'BEL', 'بلجيكا'),
(8271, 1052424832, 1052424959, 'GB', 'GBR', 'المملكة المتحدة'),
(8272, 1052424960, 1052425151, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8273, 1052425152, 1052425215, 'BE', 'BEL', 'بلجيكا'),
(8274, 1052425216, 1052426239, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8275, 1052426240, 1052426319, 'PT', 'PRT', 'البورتوغال'),
(8276, 1052426328, 1052426495, 'PT', 'PRT', 'البورتوغال'),
(8277, 1052426512, 1052426527, 'FR', 'FRA', 'فرنسا'),
(8278, 1052427264, 1052427839, 'CH', 'CHE', 'سويسرا'),
(8279, 1052427840, 1052427855, 'GB', 'GBR', 'المملكة المتحدة'),
(8280, 1052427856, 1052427871, 'IT', 'ITA', 'إيطاليا'),
(8281, 1052427872, 1052427903, 'AT', 'AUT', 'النمسا'),
(8282, 1052427904, 1052427967, 'DE', 'DEU', 'ألمانيا'),
(8283, 1052427968, 1052428031, 'GB', 'GBR', 'المملكة المتحدة'),
(8284, 1052428032, 1052428287, 'CH', 'CHE', 'سويسرا'),
(8285, 1052428288, 1052428479, 'ES', 'ESP', 'إسبانيا'),
(8286, 1052428480, 1052428543, 'BE', 'BEL', 'بلجيكا'),
(8287, 1052428544, 1052429407, 'ES', 'ESP', 'إسبانيا'),
(8288, 1052429408, 1052429439, 'FR', 'FRA', 'فرنسا'),
(8289, 1052429440, 1052429567, 'BE', 'BEL', 'بلجيكا'),
(8290, 1052429568, 1052429759, 'ES', 'ESP', 'إسبانيا'),
(8291, 1052429760, 1052429823, 'DE', 'DEU', 'ألمانيا'),
(8292, 1052429824, 1052430335, 'ES', 'ESP', 'إسبانيا'),
(8293, 1052430336, 1052430407, 'BE', 'BEL', 'بلجيكا'),
(8294, 1052430408, 1052430415, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8295, 1052430416, 1052430431, 'FR', 'FRA', 'فرنسا'),
(8296, 1052430432, 1052430463, 'DE', 'DEU', 'ألمانيا'),
(8297, 1052430464, 1052430527, 'BE', 'BEL', 'بلجيكا'),
(8298, 1052430528, 1052430591, 'DE', 'DEU', 'ألمانيا'),
(8299, 1052430592, 1052433407, 'BE', 'BEL', 'بلجيكا'),
(8300, 1052433408, 1052433719, 'DK', 'DNK', 'الدنيمارك'),
(8301, 1052433720, 1052433727, 'FR', 'FRA', 'فرنسا'),
(8302, 1052433728, 1052433919, 'DK', 'DNK', 'الدنيمارك'),
(8303, 1052433920, 1052434431, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8304, 1052434432, 1052434751, 'GB', 'GBR', 'المملكة المتحدة'),
(8305, 1052434752, 1052434783, 'NO', 'NOR', 'النرويج'),
(8306, 1052434784, 1052435455, 'GB', 'GBR', 'المملكة المتحدة'),
(8307, 1052435456, 1052435647, 'NL', 'NLD', 'هولندا'),
(8308, 1052435680, 1052436479, 'NL', 'NLD', 'هولندا'),
(8309, 1052436480, 1052437023, 'DE', 'DEU', 'ألمانيا'),
(8310, 1052437024, 1052437055, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8311, 1052437056, 1052437119, 'DE', 'DEU', 'ألمانيا'),
(8312, 1052437120, 1052437135, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8313, 1052437136, 1052437151, 'DE', 'DEU', 'ألمانيا'),
(8314, 1052437152, 1052437183, 'GB', 'GBR', 'المملكة المتحدة'),
(8315, 1052437184, 1052437247, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8316, 1052437248, 1052437759, 'DE', 'DEU', 'ألمانيا'),
(8317, 1052437760, 1052438015, 'CH', 'CHE', 'سويسرا'),
(8318, 1052438016, 1052438399, 'BE', 'BEL', 'بلجيكا'),
(8319, 1052438528, 1052439503, 'AT', 'AUT', 'النمسا'),
(8320, 1052439520, 1052439551, 'AT', 'AUT', 'النمسا'),
(8321, 1052439552, 1052440575, 'FR', 'FRA', 'فرنسا'),
(8322, 1052440576, 1052441343, 'DE', 'DEU', 'ألمانيا'),
(8323, 1052441600, 1052442623, 'GB', 'GBR', 'المملكة المتحدة'),
(8324, 1052442624, 1052443647, 'DE', 'DEU', 'ألمانيا'),
(8325, 1052446208, 1052446719, 'DE', 'DEU', 'ألمانيا'),
(8326, 1052446720, 1052447743, 'CZ', 'CZE', 'التشيك'),
(8327, 1052447744, 1052447871, 'PL', 'POL', 'بولندا'),
(8328, 1052448000, 1052448127, 'PL', 'POL', 'بولندا'),
(8329, 1052448256, 1052450815, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8330, 1052450816, 1052451839, 'DE', 'DEU', 'ألمانيا'),
(8331, 1052451840, 1052452159, 'NO', 'NOR', 'النرويج'),
(8332, 1052452224, 1052452351, 'NO', 'NOR', 'النرويج'),
(8333, 1052452352, 1052452831, 'ES', 'ESP', 'إسبانيا'),
(8334, 1052452832, 1052452847, 'GB', 'GBR', 'المملكة المتحدة'),
(8335, 1052452848, 1052452863, 'FR', 'FRA', 'فرنسا'),
(8336, 1052452992, 1052452999, 'SK', 'SVK', 'سلوفاكيا'),
(8337, 1052453120, 1052453375, 'FR', 'FRA', 'فرنسا'),
(8338, 1052453376, 1052453887, 'AT', 'AUT', 'النمسا'),
(8339, 1052453888, 1052454911, 'GB', 'GBR', 'المملكة المتحدة'),
(8340, 1052454912, 1052454943, 'FR', 'FRA', 'فرنسا'),
(8341, 1052454944, 1052454959, 'NL', 'NLD', 'هولندا'),
(8342, 1052454976, 1052455359, 'NL', 'NLD', 'هولندا'),
(8343, 1052455424, 1052455935, 'GB', 'GBR', 'المملكة المتحدة'),
(8344, 1052455936, 1052456447, 'NL', 'NLD', 'هولندا'),
(8345, 1052456448, 1052456959, 'CH', 'CHE', 'سويسرا'),
(8346, 1052456960, 1052457983, 'NL', 'NLD', 'هولندا'),
(8347, 1052457984, 1052458367, 'AT', 'AUT', 'النمسا'),
(8348, 1052458432, 1052458495, 'AT', 'AUT', 'النمسا'),
(8349, 1052458496, 1052458847, 'NL', 'NLD', 'هولندا'),
(8350, 1052458848, 1052458863, 'FR', 'FRA', 'فرنسا'),
(8351, 1052458864, 1052458871, 'NL', 'NLD', 'هولندا'),
(8352, 1052458872, 1052458879, 'FR', 'FRA', 'فرنسا'),
(8353, 1052458880, 1052460031, 'GB', 'GBR', 'المملكة المتحدة'),
(8354, 1052460032, 1052460127, 'NO', 'NOR', 'النرويج'),
(8355, 1052460224, 1052460287, 'FR', 'FRA', 'فرنسا'),
(8356, 1052460544, 1052460799, 'NO', 'NOR', 'النرويج'),
(8357, 1052460800, 1052461055, 'DE', 'DEU', 'ألمانيا'),
(8358, 1052461056, 1052461295, 'FR', 'FRA', 'فرنسا'),
(8359, 1052461296, 1052461311, 'BE', 'BEL', 'بلجيكا'),
(8360, 1052461312, 1052461951, 'FR', 'FRA', 'فرنسا'),
(8361, 1052461968, 1052463103, 'FR', 'FRA', 'فرنسا'),
(8362, 1052463104, 1052463615, 'ES', 'ESP', 'إسبانيا'),
(8363, 1052463616, 1052464639, 'GB', 'GBR', 'المملكة المتحدة'),
(8364, 1052464640, 1052464927, 'ES', 'ESP', 'إسبانيا'),
(8365, 1052464960, 1052465087, 'ES', 'ESP', 'إسبانيا'),
(8366, 1052465152, 1052465375, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8367, 1052465408, 1052465663, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8368, 1052466432, 1052468223, 'FR', 'FRA', 'فرنسا'),
(8369, 1052468224, 1052469247, 'GB', 'GBR', 'المملكة المتحدة'),
(8370, 1052469248, 1052470271, 'FR', 'FRA', 'فرنسا'),
(8371, 1052470272, 1052470783, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8372, 1052470784, 1052471007, 'FR', 'FRA', 'فرنسا'),
(8373, 1052471040, 1052471295, 'BE', 'BEL', 'بلجيكا'),
(8374, 1052471296, 1052472511, 'GB', 'GBR', 'المملكة المتحدة'),
(8375, 1052472576, 1052475231, 'GB', 'GBR', 'المملكة المتحدة'),
(8376, 1052475240, 1052475255, 'GB', 'GBR', 'المملكة المتحدة'),
(8377, 1052475264, 1052475391, 'GB', 'GBR', 'المملكة المتحدة'),
(8378, 1052475392, 1052476383, 'FR', 'FRA', 'فرنسا'),
(8379, 1052476416, 1052479487, 'FR', 'FRA', 'فرنسا'),
(8380, 1052479488, 1052479743, 'NL', 'NLD', 'هولندا'),
(8381, 1052479744, 1052479999, 'DE', 'DEU', 'ألمانيا'),
(8382, 1052480000, 1052483583, 'NL', 'NLD', 'هولندا'),
(8383, 1052483584, 1052483999, 'IT', 'ITA', 'إيطاليا'),
(8384, 1052484032, 1052485279, 'IT', 'ITA', 'إيطاليا'),
(8385, 1052485312, 1052485631, 'IT', 'ITA', 'إيطاليا'),
(8386, 1052485632, 1052486655, 'GB', 'GBR', 'المملكة المتحدة'),
(8387, 1052486656, 1052486911, 'CH', 'CHE', 'سويسرا'),
(8388, 1052486912, 1052486975, 'DE', 'DEU', 'ألمانيا'),
(8389, 1052486976, 1052487039, 'FR', 'FRA', 'فرنسا'),
(8390, 1052487040, 1052487167, 'DE', 'DEU', 'ألمانيا'),
(8391, 1052487168, 1052487423, 'GB', 'GBR', 'المملكة المتحدة'),
(8392, 1052487424, 1052487679, 'AT', 'AUT', 'النمسا'),
(8393, 1052487680, 1052488703, 'CH', 'CHE', 'سويسرا'),
(8394, 1052488704, 1052489727, 'GB', 'GBR', 'المملكة المتحدة'),
(8395, 1052489728, 1052490239, 'IE', 'IRL', 'إيرلندا'),
(8396, 1052490240, 1052490751, 'SE', 'SWE', 'السويد'),
(8397, 1052490752, 1052491679, 'AT', 'AUT', 'النمسا'),
(8398, 1052491688, 1052491775, 'AT', 'AUT', 'النمسا'),
(8399, 1052491776, 1052493567, 'BE', 'BEL', 'بلجيكا'),
(8400, 1052493696, 1052494335, 'BE', 'BEL', 'بلجيكا'),
(8401, 1052494336, 1052494591, 'NL', 'NLD', 'هولندا'),
(8402, 1052494592, 1052495439, 'BE', 'BEL', 'بلجيكا'),
(8403, 1052495440, 1052495487, 'FR', 'FRA', 'فرنسا'),
(8404, 1052495488, 1052495551, 'BE', 'BEL', 'بلجيكا'),
(8405, 1052495552, 1052495583, 'GB', 'GBR', 'المملكة المتحدة'),
(8406, 1052495584, 1052495871, 'BE', 'BEL', 'بلجيكا'),
(8407, 1052495872, 1052495879, 'UA', 'UKR', 'أوكرانيا'),
(8408, 1052496128, 1052497407, 'DE', 'DEU', 'ألمانيا'),
(8409, 1052497664, 1052497919, 'DE', 'DEU', 'ألمانيا'),
(8410, 1052497920, 1052498431, 'ES', 'ESP', 'إسبانيا'),
(8411, 1052498432, 1052498495, 'RO', 'ROM', 'رومانيا'),
(8412, 1052498944, 1052499455, 'GB', 'GBR', 'المملكة المتحدة'),
(8413, 1052499968, 1052500191, 'DK', 'DNK', 'الدنيمارك'),
(8414, 1052500208, 1052500319, 'DK', 'DNK', 'الدنيمارك'),
(8415, 1052500480, 1052500991, 'GB', 'GBR', 'المملكة المتحدة'),
(8416, 1052500992, 1052501023, 'FI', 'FIN', 'فنلندا'),
(8417, 1052501032, 1052501039, 'FI', 'FIN', 'فنلندا'),
(8418, 1052501120, 1052501247, 'FI', 'FIN', 'فنلندا'),
(8419, 1052501504, 1052502015, 'CH', 'CHE', 'سويسرا'),
(8420, 1052502016, 1052502783, 'IE', 'IRL', 'إيرلندا'),
(8421, 1052502816, 1052502847, 'IE', 'IRL', 'إيرلندا'),
(8422, 1052503040, 1052504319, 'GB', 'GBR', 'المملكة المتحدة'),
(8423, 1052504320, 1052504351, 'BY', 'BLR', 'روسيا البيضاء'),
(8424, 1052504384, 1052507583, 'GB', 'GBR', 'المملكة المتحدة'),
(8425, 1052507648, 1052507775, 'GB', 'GBR', 'المملكة المتحدة'),
(8426, 1052507904, 1052596447, 'GB', 'GBR', 'المملكة المتحدة'),
(8427, 1052596448, 1052596463, 'IT', 'ITA', 'إيطاليا'),
(8428, 1052596464, 1052602495, 'GB', 'GBR', 'المملكة المتحدة'),
(8429, 1052602496, 1052602623, 'ES', 'ESP', 'إسبانيا'),
(8430, 1052602624, 1052621951, 'GB', 'GBR', 'المملكة المتحدة'),
(8431, 1052621952, 1052622015, 'IE', 'IRL', 'إيرلندا'),
(8432, 1052622016, 1052634943, 'GB', 'GBR', 'المملكة المتحدة'),
(8433, 1052634944, 1052634951, 'IE', 'IRL', 'إيرلندا'),
(8434, 1052634952, 1052644095, 'GB', 'GBR', 'المملكة المتحدة'),
(8435, 1052644096, 1052644351, 'SE', 'SWE', 'السويد'),
(8436, 1052644352, 1052647167, 'GB', 'GBR', 'المملكة المتحدة'),
(8437, 1052647168, 1052647423, 'SE', 'SWE', 'السويد'),
(8438, 1052647424, 1052661759, 'GB', 'GBR', 'المملكة المتحدة'),
(8439, 1052661760, 1052662271, 'SE', 'SWE', 'السويد'),
(8440, 1052662272, 1052665343, 'GB', 'GBR', 'المملكة المتحدة'),
(8441, 1052665344, 1052665599, 'SE', 'SWE', 'السويد'),
(8442, 1052665600, 1052684575, 'GB', 'GBR', 'المملكة المتحدة'),
(8443, 1052684576, 1052684607, 'IT', 'ITA', 'إيطاليا'),
(8444, 1052684608, 1052770303, 'GB', 'GBR', 'المملكة المتحدة'),
(8445, 1052770304, 1052775711, 'CH', 'CHE', 'سويسرا'),
(8446, 1052775712, 1052775727, 'DE', 'DEU', 'ألمانيا'),
(8447, 1052775728, 1052775759, 'CH', 'CHE', 'سويسرا'),
(8448, 1052775760, 1052775767, 'GB', 'GBR', 'المملكة المتحدة'),
(8449, 1052775768, 1052778495, 'CH', 'CHE', 'سويسرا'),
(8450, 1052778496, 1052786687, 'RU', 'RUS', 'الإتحاد الروسي'),
(8451, 1052786688, 1052803071, 'NL', 'NLD', 'هولندا'),
(8452, 1052803072, 1052806655, 'DE', 'DEU', 'ألمانيا'),
(8453, 1052806656, 1052807167, 'MW', 'MWI', 'ملاوي'),
(8454, 1052807168, 1052811263, 'DE', 'DEU', 'ألمانيا'),
(8455, 1052811264, 1052819455, 'RU', 'RUS', 'الإتحاد الروسي'),
(8456, 1052819456, 1052827647, 'DE', 'DEU', 'ألمانيا'),
(8457, 1052827648, 1052835839, 'RU', 'RUS', 'الإتحاد الروسي'),
(8458, 1052835840, 1052844031, 'IR', 'IRN', 'إيران'),
(8459, 1052844032, 1052852223, 'FR', 'FRA', 'فرنسا'),
(8460, 1052868608, 1052871935, 'RS', 'SRB', 'صربيا'),
(8461, 1052871936, 1052871959, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8462, 1052871960, 1052871975, 'RS', 'SRB', 'صربيا'),
(8463, 1052871976, 1052871991, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8464, 1052871992, 1052872000, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8465, 1052872001, 1052872011, 'RS', 'SRB', 'صربيا'),
(8466, 1052872012, 1052872019, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8467, 1052872020, 1052872095, 'RS', 'SRB', 'صربيا'),
(8468, 1052872096, 1052872127, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8469, 1052872128, 1052872143, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8470, 1052872144, 1052872159, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8471, 1052872160, 1052872191, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8472, 1052872192, 1052872207, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8473, 1052872208, 1052872235, 'RS', 'SRB', 'صربيا'),
(8474, 1052872236, 1052872243, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8475, 1052872244, 1052872255, 'RS', 'SRB', 'صربيا'),
(8476, 1052872256, 1052872271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8477, 1052872272, 1052872311, 'RS', 'SRB', 'صربيا'),
(8478, 1052872312, 1052872323, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8479, 1052872324, 1052872343, 'RS', 'SRB', 'صربيا'),
(8480, 1052872344, 1052872355, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8481, 1052872356, 1052872371, 'RS', 'SRB', 'صربيا'),
(8482, 1052872372, 1052872375, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8483, 1052872376, 1052872383, 'RS', 'SRB', 'صربيا'),
(8484, 1052872384, 1052872403, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8485, 1052872404, 1052872407, 'RS', 'SRB', 'صربيا'),
(8486, 1052872408, 1052872411, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8487, 1052872412, 1052872435, 'RS', 'SRB', 'صربيا'),
(8488, 1052872436, 1052872451, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8489, 1052872452, 1052872495, 'RS', 'SRB', 'صربيا'),
(8490, 1052872496, 1052872503, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8491, 1052872504, 1052872507, 'RS', 'SRB', 'صربيا'),
(8492, 1052872508, 1052872511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8493, 1052872512, 1052872523, 'RS', 'SRB', 'صربيا'),
(8494, 1052872524, 1052872527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8495, 1052872528, 1052872539, 'RS', 'SRB', 'صربيا'),
(8496, 1052872540, 1052872543, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8497, 1052872544, 1052872559, 'RS', 'SRB', 'صربيا'),
(8498, 1052872560, 1052872571, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8499, 1052872572, 1052872591, 'RS', 'SRB', 'صربيا'),
(8500, 1052872592, 1052872615, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8501, 1052872616, 1052872639, 'RS', 'SRB', 'صربيا'),
(8502, 1052872640, 1052872643, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8503, 1052872644, 1052872679, 'RS', 'SRB', 'صربيا'),
(8504, 1052872680, 1052872687, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8505, 1052872688, 1052872823, 'RS', 'SRB', 'صربيا'),
(8506, 1052872824, 1052872831, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8507, 1052872832, 1052872883, 'RS', 'SRB', 'صربيا'),
(8508, 1052872884, 1052872895, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8509, 1052872896, 1052876799, 'RS', 'SRB', 'صربيا'),
(8510, 1052884992, 1052901375, 'FR', 'FRA', 'فرنسا'),
(8511, 1052901376, 1053032447, 'NL', 'NLD', 'هولندا'),
(8512, 1053032448, 1053097983, 'IT', 'ITA', 'إيطاليا'),
(8513, 1053097984, 1053106175, 'DE', 'DEU', 'ألمانيا'),
(8514, 1053106176, 1053114367, 'GB', 'GBR', 'المملكة المتحدة'),
(8515, 1053114368, 1053130751, 'BE', 'BEL', 'بلجيكا'),
(8516, 1053130752, 1053138943, 'NL', 'NLD', 'هولندا'),
(8517, 1053138944, 1053147135, 'FI', 'FIN', 'فنلندا'),
(8518, 1053147136, 1053163519, 'SK', 'SVK', 'سلوفاكيا'),
(8519, 1053163520, 1053294591, 'DK', 'DNK', 'الدنيمارك'),
(8520, 1053294848, 1053295103, 'AT', 'AUT', 'النمسا'),
(8521, 1053295392, 1053295423, 'AT', 'AUT', 'النمسا'),
(8522, 1053295456, 1053295471, 'AT', 'AUT', 'النمسا'),
(8523, 1053295616, 1053296639, 'AT', 'AUT', 'النمسا'),
(8524, 1053296640, 1053296927, 'IT', 'ITA', 'إيطاليا'),
(8525, 1053296992, 1053297023, 'IT', 'ITA', 'إيطاليا'),
(8526, 1053297040, 1053297055, 'IT', 'ITA', 'إيطاليا'),
(8527, 1053297112, 1053297151, 'IT', 'ITA', 'إيطاليا'),
(8528, 1053298176, 1053299199, 'CH', 'CHE', 'سويسرا'),
(8529, 1053299712, 1053300147, 'GB', 'GBR', 'المملكة المتحدة'),
(8530, 1053300152, 1053300159, 'GB', 'GBR', 'المملكة المتحدة'),
(8531, 1053300224, 1053300735, 'GB', 'GBR', 'المملكة المتحدة'),
(8532, 1053300736, 1053300991, 'CH', 'CHE', 'سويسرا'),
(8533, 1053300992, 1053301023, 'FR', 'FRA', 'فرنسا'),
(8534, 1053301040, 1053301063, 'FR', 'FRA', 'فرنسا'),
(8535, 1053301072, 1053301135, 'FR', 'FRA', 'فرنسا'),
(8536, 1053301168, 1053301183, 'FR', 'FRA', 'فرنسا'),
(8537, 1053301200, 1053301295, 'FR', 'FRA', 'فرنسا'),
(8538, 1053301304, 1053301359, 'FR', 'FRA', 'فرنسا'),
(8539, 1053301368, 1053301503, 'FR', 'FRA', 'فرنسا'),
(8540, 1053302032, 1053302055, 'FR', 'FRA', 'فرنسا'),
(8541, 1053302056, 1053302063, 'DE', 'DEU', 'ألمانيا'),
(8542, 1053302064, 1053302159, 'FR', 'FRA', 'فرنسا'),
(8543, 1053302176, 1053302191, 'FR', 'FRA', 'فرنسا'),
(8544, 1053302320, 1053302335, 'FR', 'FRA', 'فرنسا'),
(8545, 1053302384, 1053302687, 'FR', 'FRA', 'فرنسا'),
(8546, 1053302704, 1053302711, 'GB', 'GBR', 'المملكة المتحدة'),
(8547, 1053302712, 1053302719, 'FR', 'FRA', 'فرنسا'),
(8548, 1053302728, 1053302735, 'FR', 'FRA', 'فرنسا'),
(8549, 1053302760, 1053302783, 'FR', 'FRA', 'فرنسا'),
(8550, 1053305088, 1053305951, 'GR', 'GRC', 'اليونان'),
(8551, 1053306112, 1053306879, 'GR', 'GRC', 'اليونان'),
(8552, 1053307904, 1053307999, 'GB', 'GBR', 'المملكة المتحدة'),
(8553, 1053308032, 1053308095, 'GB', 'GBR', 'المملكة المتحدة'),
(8554, 1053308160, 1053308543, 'GB', 'GBR', 'المملكة المتحدة'),
(8555, 1053308672, 1053308767, 'GB', 'GBR', 'المملكة المتحدة'),
(8556, 1053308800, 1053308863, 'GB', 'GBR', 'المملكة المتحدة'),
(8557, 1053308928, 1053308991, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8558, 1053309184, 1053309951, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8559, 1053311232, 1053311359, 'CZ', 'CZE', 'التشيك'),
(8560, 1053312000, 1053312815, 'DK', 'DNK', 'الدنيمارك'),
(8561, 1053312848, 1053312871, 'DK', 'DNK', 'الدنيمارك'),
(8562, 1053312880, 1053312911, 'DK', 'DNK', 'الدنيمارك'),
(8563, 1053312928, 1053312959, 'DK', 'DNK', 'الدنيمارك'),
(8564, 1053313024, 1053313343, 'GB', 'GBR', 'المملكة المتحدة'),
(8565, 1053313440, 1053313599, 'GB', 'GBR', 'المملكة المتحدة'),
(8566, 1053313664, 1053313695, 'GB', 'GBR', 'المملكة المتحدة'),
(8567, 1053313728, 1053313791, 'GB', 'GBR', 'المملكة المتحدة'),
(8568, 1053313920, 1053314047, 'GB', 'GBR', 'المملكة المتحدة'),
(8569, 1053314064, 1053314079, 'CZ', 'CZE', 'التشيك'),
(8570, 1053315072, 1053316863, 'GB', 'GBR', 'المملكة المتحدة'),
(8571, 1053317120, 1053317295, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8572, 1053317376, 1053317631, 'GB', 'GBR', 'المملكة المتحدة'),
(8573, 1053318144, 1053318655, 'GB', 'GBR', 'المملكة المتحدة'),
(8574, 1053318656, 1053318911, 'FI', 'FIN', 'فنلندا'),
(8575, 1053318928, 1053318951, 'FI', 'FIN', 'فنلندا'),
(8576, 1053318952, 1053318959, 'EE', 'EST', 'إستونيا'),
(8577, 1053318976, 1053319007, 'FI', 'FIN', 'فنلندا'),
(8578, 1053319168, 1053320191, 'DE', 'DEU', 'ألمانيا'),
(8579, 1053320224, 1053320319, 'DE', 'DEU', 'ألمانيا'),
(8580, 1053326336, 1053326399, 'BE', 'BEL', 'بلجيكا'),
(8581, 1053326432, 1053326447, 'GB', 'GBR', 'المملكة المتحدة'),
(8582, 1053326448, 1053326463, 'BE', 'BEL', 'بلجيكا'),
(8583, 1053326528, 1053326543, 'BE', 'BEL', 'بلجيكا'),
(8584, 1053326560, 1053326567, 'BE', 'BEL', 'بلجيكا'),
(8585, 1053326576, 1053326847, 'BE', 'BEL', 'بلجيكا'),
(8586, 1053326848, 1053327103, 'FI', 'FIN', 'فنلندا'),
(8587, 1053327104, 1053327359, 'DK', 'DNK', 'الدنيمارك'),
(8588, 1053327872, 1053328383, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8589, 1053328640, 1053328799, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8590, 1053328896, 1053329087, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8591, 1053329120, 1053329135, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8592, 1053329144, 1053329151, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8593, 1053329184, 1053329279, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8594, 1053329408, 1053329439, 'ES', 'ESP', 'إسبانيا'),
(8595, 1053329512, 1053329527, 'ES', 'ESP', 'إسبانيا'),
(8596, 1053329632, 1053329647, 'ES', 'ESP', 'إسبانيا'),
(8597, 1053330432, 1053330687, 'ES', 'ESP', 'إسبانيا'),
(8598, 1053331456, 1053331487, 'NL', 'NLD', 'هولندا'),
(8599, 1053331584, 1053331663, 'NL', 'NLD', 'هولندا'),
(8600, 1053331680, 1053331703, 'NL', 'NLD', 'هولندا'),
(8601, 1053331712, 1053331887, 'NL', 'NLD', 'هولندا'),
(8602, 1053331904, 1053331935, 'NL', 'NLD', 'هولندا'),
(8603, 1053332224, 1053332271, 'NL', 'NLD', 'هولندا'),
(8604, 1053332320, 1053332415, 'NL', 'NLD', 'هولندا'),
(8605, 1053332448, 1053332479, 'NL', 'NLD', 'هولندا'),
(8606, 1053332992, 1053334015, 'BE', 'BEL', 'بلجيكا'),
(8607, 1053334016, 1053334191, 'DK', 'DNK', 'الدنيمارك'),
(8608, 1053334200, 1053334223, 'DK', 'DNK', 'الدنيمارك'),
(8609, 1053334240, 1053334527, 'DK', 'DNK', 'الدنيمارك'),
(8610, 1053334528, 1053334783, 'SE', 'SWE', 'السويد'),
(8611, 1053335552, 1053336831, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8612, 1053337088, 1053337119, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8613, 1053337128, 1053337183, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8614, 1053337216, 1053337279, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8615, 1053337600, 1053337631, 'CH', 'CHE', 'سويسرا'),
(8616, 1053338112, 1053338623, 'FI', 'FIN', 'فنلندا'),
(8617, 1053338624, 1053338943, 'NO', 'NOR', 'النرويج'),
(8618, 1053338976, 1053338983, 'NO', 'NOR', 'النرويج'),
(8619, 1053339136, 1053339423, 'NO', 'NOR', 'النرويج'),
(8620, 1053339456, 1053339519, 'NO', 'NOR', 'النرويج'),
(8621, 1053339592, 1053339599, 'NO', 'NOR', 'النرويج'),
(8622, 1053339616, 1053339647, 'NO', 'NOR', 'النرويج'),
(8623, 1053339648, 1053340159, 'AT', 'AUT', 'النمسا'),
(8624, 1053340160, 1053340415, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(8625, 1053340480, 1053340495, 'NL', 'NLD', 'هولندا'),
(8626, 1053340672, 1053341183, 'GB', 'GBR', 'المملكة المتحدة'),
(8627, 1053341440, 1053341615, 'GB', 'GBR', 'المملكة المتحدة'),
(8628, 1053341632, 1053341695, 'GB', 'GBR', 'المملكة المتحدة'),
(8629, 1053343744, 1053344255, 'FI', 'FIN', 'فنلندا'),
(8630, 1053344512, 1053344767, 'BG', 'BGR', 'بلغاريا'),
(8631, 1053345280, 1053345375, 'PK', 'PAK', 'باكستان'),
(8632, 1053345408, 1053345471, 'PK', 'PAK', 'باكستان'),
(8633, 1053348640, 1053348655, 'PT', 'PRT', 'البورتوغال'),
(8634, 1053349120, 1053349631, 'NL', 'NLD', 'هولندا'),
(8635, 1053349888, 1053349951, 'IE', 'IRL', 'إيرلندا'),
(8636, 1053350144, 1053350359, 'IE', 'IRL', 'إيرلندا'),
(8637, 1053350368, 1053350383, 'IE', 'IRL', 'إيرلندا'),
(8638, 1053350400, 1053350479, 'BE', 'BEL', 'بلجيكا'),
(8639, 1053350488, 1053350495, 'BE', 'BEL', 'بلجيكا'),
(8640, 1053350656, 1053350911, 'BE', 'BEL', 'بلجيكا'),
(8641, 1053351936, 1053352191, 'IL', 'ISR', 'إسرائيل'),
(8642, 1053353024, 1053353031, 'IE', 'IRL', 'إيرلندا'),
(8643, 1053353104, 1053353111, 'IE', 'IRL', 'إيرلندا'),
(8644, 1053353136, 1053353215, 'IE', 'IRL', 'إيرلندا'),
(8645, 1053353216, 1053353223, 'GB', 'GBR', 'المملكة المتحدة'),
(8646, 1053353232, 1053353279, 'IE', 'IRL', 'إيرلندا'),
(8647, 1053353984, 1053354239, 'IL', 'ISR', 'إسرائيل'),
(8648, 1053354496, 1053354655, 'IL', 'ISR', 'إسرائيل'),
(8649, 1053354688, 1053354719, 'IL', 'ISR', 'إسرائيل'),
(8650, 1053354752, 1053354831, 'IL', 'ISR', 'إسرائيل'),
(8651, 1053354856, 1053354871, 'IL', 'ISR', 'إسرائيل'),
(8652, 1053354912, 1053355007, 'IL', 'ISR', 'إسرائيل'),
(8653, 1053360128, 1053364223, 'ES', 'ESP', 'إسبانيا'),
(8654, 1053364224, 1053368319, 'CZ', 'CZE', 'التشيك'),
(8655, 1053368320, 1053376511, 'SE', 'SWE', 'السويد'),
(8656, 1053376512, 1053392895, 'HU', 'HUN', 'هنغاريا'),
(8657, 1053392896, 1053401087, 'FR', 'FRA', 'فرنسا'),
(8658, 1053401088, 1053409279, 'DE', 'DEU', 'ألمانيا'),
(8659, 1053409280, 1053415679, 'IR', 'IRN', 'إيران'),
(8660, 1053415680, 1053425663, 'IQ', 'IRQ', 'العراق'),
(8661, 1053425664, 1053556735, 'CH', 'CHE', 'سويسرا'),
(8662, 1053556736, 1053564927, 'FI', 'FIN', 'فنلندا'),
(8663, 1053564928, 1053573119, 'GB', 'GBR', 'المملكة المتحدة'),
(8664, 1053573120, 1053581311, 'NL', 'NLD', 'هولندا'),
(8665, 1053581312, 1053589503, 'CH', 'CHE', 'سويسرا'),
(8666, 1053589504, 1053597695, 'BG', 'BGR', 'بلغاريا'),
(8667, 1053597696, 1053605887, 'DE', 'DEU', 'ألمانيا'),
(8668, 1053605888, 1053614079, 'ES', 'ESP', 'إسبانيا'),
(8669, 1053614080, 1053622271, 'CZ', 'CZE', 'التشيك'),
(8670, 1053622272, 1053630463, 'IT', 'ITA', 'إيطاليا'),
(8671, 1053630464, 1053638655, 'GR', 'GRC', 'اليونان'),
(8672, 1053638656, 1053655039, 'BE', 'BEL', 'بلجيكا'),
(8673, 1053655040, 1053663231, 'UA', 'UKR', 'أوكرانيا'),
(8674, 1053663232, 1053671423, 'RU', 'RUS', 'الإتحاد الروسي'),
(8675, 1053671424, 1053687807, 'LV', 'LVA', 'لاتفيا'),
(8676, 1053687808, 1053702635, 'DE', 'DEU', 'ألمانيا'),
(8677, 1053702636, 1053702639, 'GB', 'GBR', 'المملكة المتحدة'),
(8678, 1053702640, 1053753343, 'DE', 'DEU', 'ألمانيا'),
(8679, 1053818880, 1053819391, 'DE', 'DEU', 'ألمانيا'),
(8680, 1053819424, 1053819439, 'DE', 'DEU', 'ألمانيا'),
(8681, 1053819520, 1053819563, 'DE', 'DEU', 'ألمانيا'),
(8682, 1053819584, 1053819647, 'DE', 'DEU', 'ألمانيا'),
(8683, 1053820160, 1053820927, 'DE', 'DEU', 'ألمانيا'),
(8684, 1053821440, 1053821447, 'GB', 'GBR', 'المملكة المتحدة'),
(8685, 1053821568, 1053821695, 'GB', 'GBR', 'المملكة المتحدة'),
(8686, 1053824016, 1053824023, 'DE', 'DEU', 'ألمانيا'),
(8687, 1053824128, 1053824255, 'NL', 'NLD', 'هولندا'),
(8688, 1053825024, 1053826047, 'ES', 'ESP', 'إسبانيا'),
(8689, 1053826816, 1053827327, 'DE', 'DEU', 'ألمانيا'),
(8690, 1053827328, 1053827583, 'BE', 'BEL', 'بلجيكا'),
(8691, 1053829888, 1053830143, 'DE', 'DEU', 'ألمانيا'),
(8692, 1053831168, 1053831423, 'DE', 'DEU', 'ألمانيا'),
(8693, 1053834944, 1053834975, 'DE', 'DEU', 'ألمانيا'),
(8694, 1053835264, 1053835775, 'DE', 'DEU', 'ألمانيا'),
(8695, 1053837312, 1053837439, 'FK', 'FLK', 'جزر فوكلاند (مالفيناس)'),
(8696, 1053837568, 1053837823, 'GB', 'GBR', 'المملكة المتحدة'),
(8697, 1053837824, 1053838335, 'FK', 'FLK', 'جزر فوكلاند (مالفيناس)'),
(8698, 1053838336, 1053838591, 'DE', 'DEU', 'ألمانيا'),
(8699, 1053840400, 1053840415, 'DE', 'DEU', 'ألمانيا'),
(8700, 1053840448, 1053840511, 'DE', 'DEU', 'ألمانيا'),
(8701, 1053843200, 1053843231, 'DK', 'DNK', 'الدنيمارك'),
(8702, 1053843712, 1053843967, 'DE', 'DEU', 'ألمانيا'),
(8703, 1053843968, 1053844223, 'GB', 'GBR', 'المملكة المتحدة'),
(8704, 1053844224, 1053844479, 'DE', 'DEU', 'ألمانيا'),
(8705, 1053844992, 1053845503, 'DE', 'DEU', 'ألمانيا'),
(8706, 1053845728, 1053845735, 'DE', 'DEU', 'ألمانيا'),
(8707, 1053846016, 1053846527, 'DE', 'DEU', 'ألمانيا'),
(8708, 1053846784, 1053847551, 'DE', 'DEU', 'ألمانيا'),
(8709, 1053847552, 1053849599, 'GB', 'GBR', 'المملكة المتحدة'),
(8710, 1053849600, 1053850367, 'DE', 'DEU', 'ألمانيا'),
(8711, 1053851136, 1053851647, 'DE', 'DEU', 'ألمانيا'),
(8712, 1053851904, 1053851919, 'FR', 'FRA', 'فرنسا'),
(8713, 1053852032, 1053852047, 'IT', 'ITA', 'إيطاليا'),
(8714, 1053852096, 1053852103, 'DE', 'DEU', 'ألمانيا'),
(8715, 1053852112, 1053852127, 'GB', 'GBR', 'المملكة المتحدة'),
(8716, 1053852128, 1053852159, 'DE', 'DEU', 'ألمانيا'),
(8717, 1053855744, 1053859839, 'GB', 'GBR', 'المملكة المتحدة'),
(8718, 1053859840, 1053860863, 'DE', 'DEU', 'ألمانيا'),
(8719, 1053862656, 1053862783, 'DE', 'DEU', 'ألمانيا'),
(8720, 1053862848, 1053862879, 'DE', 'DEU', 'ألمانيا'),
(8721, 1053863424, 1053864959, 'DE', 'DEU', 'ألمانيا'),
(8722, 1053865216, 1053865727, 'DE', 'DEU', 'ألمانيا'),
(8723, 1053865728, 1053865759, 'US', 'USA', 'الولايات المتحدة'),
(8724, 1053865984, 1053866239, 'DE', 'DEU', 'ألمانيا'),
(8725, 1053866240, 1053866495, 'ES', 'ESP', 'إسبانيا'),
(8726, 1053866496, 1053866799, 'DE', 'DEU', 'ألمانيا'),
(8727, 1053866808, 1053866823, 'DE', 'DEU', 'ألمانيا'),
(8728, 1053866832, 1053866847, 'DE', 'DEU', 'ألمانيا'),
(8729, 1053867520, 1053867775, 'DE', 'DEU', 'ألمانيا'),
(8730, 1053867976, 1053867983, 'DE', 'DEU', 'ألمانيا'),
(8731, 1053867992, 1053867999, 'DE', 'DEU', 'ألمانيا'),
(8732, 1053868008, 1053868015, 'DE', 'DEU', 'ألمانيا'),
(8733, 1053868032, 1053868447, 'ES', 'ESP', 'إسبانيا'),
(8734, 1053868448, 1053868455, 'GB', 'GBR', 'المملكة المتحدة'),
(8735, 1053868800, 1053869567, 'DE', 'DEU', 'ألمانيا'),
(8736, 1053870080, 1053870335, 'DE', 'DEU', 'ألمانيا'),
(8737, 1053870336, 1053870591, 'GB', 'GBR', 'المملكة المتحدة'),
(8738, 1053870848, 1053871359, 'DE', 'DEU', 'ألمانيا'),
(8739, 1053871616, 1053871871, 'DE', 'DEU', 'ألمانيا'),
(8740, 1053872384, 1053872447, 'DE', 'DEU', 'ألمانيا'),
(8741, 1053872896, 1053873663, 'DE', 'DEU', 'ألمانيا'),
(8742, 1053876224, 1053876991, 'DE', 'DEU', 'ألمانيا'),
(8743, 1053877248, 1053878271, 'DE', 'DEU', 'ألمانيا'),
(8744, 1053878272, 1053878783, 'GB', 'GBR', 'المملكة المتحدة'),
(8745, 1053878784, 1053879047, 'DE', 'DEU', 'ألمانيا'),
(8746, 1053879056, 1053879071, 'DE', 'DEU', 'ألمانيا'),
(8747, 1053879072, 1053879167, 'GB', 'GBR', 'المملكة المتحدة'),
(8748, 1053879296, 1053882111, 'DE', 'DEU', 'ألمانيا'),
(8749, 1053882368, 1053882879, 'DE', 'DEU', 'ألمانيا'),
(8750, 1053882880, 1053883391, 'GB', 'GBR', 'المملكة المتحدة'),
(8751, 1053883392, 1053884415, 'DE', 'DEU', 'ألمانيا'),
(8752, 1053884416, 1053892607, 'BH', 'BHR', 'البحرين'),
(8753, 1053892608, 1053892619, 'DE', 'DEU', 'ألمانيا'),
(8754, 1053892620, 1053892623, 'GB', 'GBR', 'المملكة المتحدة'),
(8755, 1053892624, 1053892943, 'DE', 'DEU', 'ألمانيا'),
(8756, 1053892944, 1053892959, 'GB', 'GBR', 'المملكة المتحدة'),
(8757, 1053892960, 1053894495, 'DE', 'DEU', 'ألمانيا'),
(8758, 1053894496, 1053894527, 'GB', 'GBR', 'المملكة المتحدة'),
(8759, 1053894528, 1053894719, 'DE', 'DEU', 'ألمانيا'),
(8760, 1053894720, 1053894735, 'FR', 'FRA', 'فرنسا'),
(8761, 1053894736, 1053894743, 'GB', 'GBR', 'المملكة المتحدة'),
(8762, 1053894744, 1053894751, 'GE', 'GEO', 'جورجيا'),
(8763, 1053894752, 1053894783, 'DE', 'DEU', 'ألمانيا'),
(8764, 1053894784, 1053894815, 'IL', 'ISR', 'إسرائيل'),
(8765, 1053894816, 1053894831, 'NL', 'NLD', 'هولندا'),
(8766, 1053894832, 1053894847, 'US', 'USA', 'الولايات المتحدة'),
(8767, 1053894848, 1053895423, 'DE', 'DEU', 'ألمانيا'),
(8768, 1053895424, 1053895679, 'GB', 'GBR', 'المملكة المتحدة'),
(8769, 1053895680, 1053895935, 'US', 'USA', 'الولايات المتحدة'),
(8770, 1053895936, 1053896087, 'DE', 'DEU', 'ألمانيا'),
(8771, 1053896088, 1053896095, 'US', 'USA', 'الولايات المتحدة'),
(8772, 1053896096, 1053896127, 'GB', 'GBR', 'المملكة المتحدة'),
(8773, 1053896128, 1053896159, 'DE', 'DEU', 'ألمانيا'),
(8774, 1053896160, 1053896175, 'US', 'USA', 'الولايات المتحدة'),
(8775, 1053896176, 1053896447, 'DE', 'DEU', 'ألمانيا'),
(8776, 1053896448, 1053896703, 'US', 'USA', 'الولايات المتحدة'),
(8777, 1053896704, 1053900799, 'DE', 'DEU', 'ألمانيا'),
(8778, 1053900800, 1053917183, 'NO', 'NOR', 'النرويج'),
(8779, 1053917184, 1053925375, 'UZ', 'UZB', 'أوزباكستان'),
(8780, 1053925376, 1053933567, 'SE', 'SWE', 'السويد'),
(8781, 1053933568, 1053949951, 'CZ', 'CZE', 'التشيك'),
(8782, 1053949952, 1053984415, 'FR', 'FRA', 'فرنسا'),
(8783, 1053984416, 1053984447, 'US', 'USA', 'الولايات المتحدة'),
(8784, 1053984448, 1053984895, 'FR', 'FRA', 'فرنسا'),
(8785, 1053984896, 1053985023, 'US', 'USA', 'الولايات المتحدة'),
(8786, 1053985024, 1054015487, 'FR', 'FRA', 'فرنسا'),
(8787, 1054015488, 1054089215, 'IT', 'ITA', 'إيطاليا'),
(8788, 1054089216, 1054097407, 'GE', 'GEO', 'جورجيا'),
(8789, 1054097408, 1054105599, 'NL', 'NLD', 'هولندا'),
(8790, 1054105600, 1054113791, 'FR', 'FRA', 'فرنسا'),
(8791, 1054113792, 1054121983, 'NL', 'NLD', 'هولندا'),
(8792, 1054121984, 1054130175, 'AT', 'AUT', 'النمسا'),
(8793, 1054130176, 1054138367, 'LT', 'LTU', 'ليتوانيا'),
(8794, 1054138368, 1054146559, 'AZ', 'AZE', 'أذربيجان'),
(8795, 1054146560, 1054179327, 'RU', 'RUS', 'الإتحاد الروسي'),
(8796, 1054179328, 1054187519, 'GB', 'GBR', 'المملكة المتحدة'),
(8797, 1054187520, 1054195711, 'BG', 'BGR', 'بلغاريا'),
(8798, 1054195712, 1054212095, 'BE', 'BEL', 'بلجيكا'),
(8799, 1054212096, 1054277631, 'DE', 'DEU', 'ألمانيا'),
(8800, 1054277632, 1054343167, 'KW', 'KWT', 'الكويت'),
(8801, 1054343168, 1054351359, 'NL', 'NLD', 'هولندا'),
(8802, 1054351360, 1054359551, 'UA', 'UKR', 'أوكرانيا'),
(8803, 1054359552, 1054367743, 'RO', 'ROM', 'رومانيا'),
(8804, 1054367744, 1054375935, 'FI', 'FIN', 'فنلندا'),
(8805, 1054375936, 1054381055, 'GB', 'GBR', 'المملكة المتحدة'),
(8806, 1054381056, 1054381823, 'EG', 'EGY', 'مصر'),
(8807, 1054381824, 1054384127, 'GB', 'GBR', 'المملكة المتحدة'),
(8808, 1054384128, 1054400511, 'DE', 'DEU', 'ألمانيا'),
(8809, 1054400512, 1054408703, 'GB', 'GBR', 'المملكة المتحدة'),
(8810, 1054408704, 1054416895, 'FR', 'FRA', 'فرنسا'),
(8811, 1054416896, 1054425087, 'DE', 'DEU', 'ألمانيا'),
(8812, 1054425088, 1054441471, 'GR', 'GRC', 'اليونان'),
(8813, 1054441472, 1054449663, 'AZ', 'AZE', 'أذربيجان'),
(8814, 1054449664, 1054457855, 'RU', 'RUS', 'الإتحاد الروسي'),
(8815, 1054457856, 1054474239, 'RO', 'ROM', 'رومانيا'),
(8816, 1054474240, 1054539775, 'AT', 'AUT', 'النمسا'),
(8817, 1054539776, 1054605311, 'IL', 'ISR', 'إسرائيل'),
(8818, 1054605312, 1054613503, 'DE', 'DEU', 'ألمانيا'),
(8819, 1054613504, 1054621695, 'RU', 'RUS', 'الإتحاد الروسي'),
(8820, 1054621696, 1054629887, 'IT', 'ITA', 'إيطاليا'),
(8821, 1054629888, 1054638079, 'IR', 'IRN', 'إيران'),
(8822, 1054638080, 1054646271, 'CH', 'CHE', 'سويسرا'),
(8823, 1054646272, 1054654463, 'SE', 'SWE', 'السويد'),
(8824, 1054654464, 1054662655, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(8825, 1054662656, 1054670847, 'FI', 'FIN', 'فنلندا'),
(8826, 1054670848, 1054671103, 'GB', 'GBR', 'المملكة المتحدة'),
(8827, 1054671168, 1054671231, 'IE', 'IRL', 'إيرلندا'),
(8828, 1054671372, 1054671375, 'IE', 'IRL', 'إيرلندا'),
(8829, 1054671416, 1054671423, 'IE', 'IRL', 'إيرلندا'),
(8830, 1054671432, 1054671439, 'IE', 'IRL', 'إيرلندا'),
(8831, 1054672160, 1054672175, 'IE', 'IRL', 'إيرلندا'),
(8832, 1054672256, 1054672287, 'IE', 'IRL', 'إيرلندا'),
(8833, 1054672320, 1054672335, 'US', 'USA', 'الولايات المتحدة'),
(8834, 1054672336, 1054672367, 'IE', 'IRL', 'إيرلندا'),
(8835, 1054672384, 1054672447, 'IE', 'IRL', 'إيرلندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(8836, 1054672720, 1054672727, 'IE', 'IRL', 'إيرلندا'),
(8837, 1054672744, 1054672767, 'IE', 'IRL', 'إيرلندا'),
(8838, 1054672776, 1054672783, 'IE', 'IRL', 'إيرلندا'),
(8839, 1054672792, 1054672807, 'IE', 'IRL', 'إيرلندا'),
(8840, 1054673664, 1054673727, 'IE', 'IRL', 'إيرلندا'),
(8841, 1054673856, 1054673919, 'IE', 'IRL', 'إيرلندا'),
(8842, 1054673952, 1054674047, 'IE', 'IRL', 'إيرلندا'),
(8843, 1054674080, 1054674111, 'IE', 'IRL', 'إيرلندا'),
(8844, 1054674456, 1054674471, 'IE', 'IRL', 'إيرلندا'),
(8845, 1054674480, 1054674495, 'IE', 'IRL', 'إيرلندا'),
(8846, 1054674504, 1054674511, 'IE', 'IRL', 'إيرلندا'),
(8847, 1054674520, 1054674527, 'GB', 'GBR', 'المملكة المتحدة'),
(8848, 1054674688, 1054675199, 'IE', 'IRL', 'إيرلندا'),
(8849, 1054675456, 1054675711, 'IE', 'IRL', 'إيرلندا'),
(8850, 1054675968, 1054676223, 'US', 'USA', 'الولايات المتحدة'),
(8851, 1054679040, 1054687231, 'UA', 'UKR', 'أوكرانيا'),
(8852, 1054687232, 1054703615, 'MD', 'MDA', 'مولدوفا'),
(8853, 1054703616, 1054711807, 'BG', 'BGR', 'بلغاريا'),
(8854, 1054711808, 1054719999, 'IT', 'ITA', 'إيطاليا'),
(8855, 1054720000, 1054867455, 'NL', 'NLD', 'هولندا'),
(8856, 1054867456, 1054943231, 'DE', 'DEU', 'ألمانيا'),
(8857, 1054943232, 1054943487, 'PL', 'POL', 'بولندا'),
(8858, 1054943488, 1054949807, 'DE', 'DEU', 'ألمانيا'),
(8859, 1054949808, 1054949815, 'ES', 'ESP', 'إسبانيا'),
(8860, 1054949816, 1054963255, 'DE', 'DEU', 'ألمانيا'),
(8861, 1054963256, 1054963263, 'ES', 'ESP', 'إسبانيا'),
(8862, 1054963264, 1054969031, 'DE', 'DEU', 'ألمانيا'),
(8863, 1054969032, 1054969039, 'AT', 'AUT', 'النمسا'),
(8864, 1054969040, 1054978815, 'DE', 'DEU', 'ألمانيا'),
(8865, 1054978816, 1054979071, 'FR', 'FRA', 'فرنسا'),
(8866, 1054979072, 1055129599, 'DE', 'DEU', 'ألمانيا'),
(8867, 1055129600, 1055162367, 'CY', 'CYP', 'قبرص'),
(8868, 1055162368, 1055195135, 'GR', 'GRC', 'اليونان'),
(8869, 1055196160, 1055197823, 'CH', 'CHE', 'سويسرا'),
(8870, 1055197920, 1055198463, 'CH', 'CHE', 'سويسرا'),
(8871, 1055198976, 1055199103, 'CH', 'CHE', 'سويسرا'),
(8872, 1055199360, 1055199375, 'CH', 'CHE', 'سويسرا'),
(8873, 1055199464, 1055199487, 'CH', 'CHE', 'سويسرا'),
(8874, 1055200416, 1055200423, 'PT', 'PRT', 'البورتوغال'),
(8875, 1055201024, 1055201279, 'US', 'USA', 'الولايات المتحدة'),
(8876, 1055203328, 1055203359, 'CZ', 'CZE', 'التشيك'),
(8877, 1055203840, 1055204095, 'CZ', 'CZE', 'التشيك'),
(8878, 1055204864, 1055205375, 'CZ', 'CZE', 'التشيك'),
(8879, 1055205632, 1055205887, 'CZ', 'CZE', 'التشيك'),
(8880, 1055206656, 1055207423, 'CZ', 'CZE', 'التشيك'),
(8881, 1055207680, 1055209471, 'CZ', 'CZE', 'التشيك'),
(8882, 1055209728, 1055210239, 'CZ', 'CZE', 'التشيك'),
(8883, 1055210496, 1055210751, 'SK', 'SVK', 'سلوفاكيا'),
(8884, 1055211264, 1055211519, 'CZ', 'CZE', 'التشيك'),
(8885, 1055212044, 1055212179, 'PT', 'PRT', 'البورتوغال'),
(8886, 1055212184, 1055212247, 'PT', 'PRT', 'البورتوغال'),
(8887, 1055212352, 1055212415, 'PT', 'PRT', 'البورتوغال'),
(8888, 1055212544, 1055212799, 'PT', 'PRT', 'البورتوغال'),
(8889, 1055213056, 1055213307, 'PT', 'PRT', 'البورتوغال'),
(8890, 1055213312, 1055213319, 'PT', 'PRT', 'البورتوغال'),
(8891, 1055213328, 1055213359, 'PT', 'PRT', 'البورتوغال'),
(8892, 1055213368, 1055213455, 'PT', 'PRT', 'البورتوغال'),
(8893, 1055213472, 1055213567, 'PT', 'PRT', 'البورتوغال'),
(8894, 1055213824, 1055214239, 'PT', 'PRT', 'البورتوغال'),
(8895, 1055214272, 1055214847, 'PT', 'PRT', 'البورتوغال'),
(8896, 1055215360, 1055215999, 'PT', 'PRT', 'البورتوغال'),
(8897, 1055216032, 1055216383, 'PT', 'PRT', 'البورتوغال'),
(8898, 1055216896, 1055217663, 'PT', 'PRT', 'البورتوغال'),
(8899, 1055218208, 1055218239, 'PT', 'PRT', 'البورتوغال'),
(8900, 1055218272, 1055218299, 'PT', 'PRT', 'البورتوغال'),
(8901, 1055218352, 1055218383, 'PT', 'PRT', 'البورتوغال'),
(8902, 1055218392, 1055218399, 'PT', 'PRT', 'البورتوغال'),
(8903, 1055218432, 1055218447, 'PT', 'PRT', 'البورتوغال'),
(8904, 1055218464, 1055218471, 'PT', 'PRT', 'البورتوغال'),
(8905, 1055218480, 1055219711, 'PT', 'PRT', 'البورتوغال'),
(8906, 1055220224, 1055220287, 'NL', 'NLD', 'هولندا'),
(8907, 1055220352, 1055220399, 'NL', 'NLD', 'هولندا'),
(8908, 1055221504, 1055221631, 'BE', 'BEL', 'بلجيكا'),
(8909, 1055223040, 1055223807, 'NL', 'NLD', 'هولندا'),
(8910, 1055223904, 1055223999, 'LU', 'LUX', 'لوكسيمبورغ'),
(8911, 1055224064, 1055224463, 'LU', 'LUX', 'لوكسيمبورغ'),
(8912, 1055224576, 1055224607, 'LU', 'LUX', 'لوكسيمبورغ'),
(8913, 1055224832, 1055224911, 'LU', 'LUX', 'لوكسيمبورغ'),
(8914, 1055226112, 1055226175, 'ES', 'ESP', 'إسبانيا'),
(8915, 1055226192, 1055226207, 'ES', 'ESP', 'إسبانيا'),
(8916, 1055226240, 1055226255, 'ES', 'ESP', 'إسبانيا'),
(8917, 1055226264, 1055226271, 'ES', 'ESP', 'إسبانيا'),
(8918, 1055226368, 1055226399, 'ES', 'ESP', 'إسبانيا'),
(8919, 1055227640, 1055227647, 'PT', 'PRT', 'البورتوغال'),
(8920, 1055227904, 1055228159, 'TR', 'TUR', 'تركيا'),
(8921, 1055228928, 1055229183, 'TR', 'TUR', 'تركيا'),
(8922, 1055232000, 1055232255, 'NL', 'NLD', 'هولندا'),
(8923, 1055232512, 1055233023, 'NL', 'NLD', 'هولندا'),
(8924, 1055234064, 1055234079, 'NL', 'NLD', 'هولندا'),
(8925, 1055234080, 1055234127, 'US', 'USA', 'الولايات المتحدة'),
(8926, 1055241984, 1055242239, 'GR', 'GRC', 'اليونان'),
(8927, 1055252736, 1055252991, 'ES', 'ESP', 'إسبانيا'),
(8928, 1055253056, 1055253087, 'ES', 'ESP', 'إسبانيا'),
(8929, 1055256448, 1055256463, 'ES', 'ESP', 'إسبانيا'),
(8930, 1055260672, 1055326207, 'SE', 'SWE', 'السويد'),
(8931, 1055326208, 1055334399, 'RU', 'RUS', 'الإتحاد الروسي'),
(8932, 1055334400, 1055342591, 'IE', 'IRL', 'إيرلندا'),
(8933, 1055342592, 1055358975, 'RO', 'ROM', 'رومانيا'),
(8934, 1055358976, 1055367167, 'GB', 'GBR', 'المملكة المتحدة'),
(8935, 1055367168, 1055375359, 'RU', 'RUS', 'الإتحاد الروسي'),
(8936, 1055375360, 1055391743, 'OM', 'OMN', 'عمان'),
(8937, 1055391744, 1055457279, 'GB', 'GBR', 'المملكة المتحدة'),
(8938, 1055457280, 1055465471, 'BE', 'BEL', 'بلجيكا'),
(8939, 1055465472, 1055467575, 'FR', 'FRA', 'فرنسا'),
(8940, 1055467576, 1055467579, 'ES', 'ESP', 'إسبانيا'),
(8941, 1055467580, 1055469055, 'FR', 'FRA', 'فرنسا'),
(8942, 1055469056, 1055469059, 'CH', 'CHE', 'سويسرا'),
(8943, 1055469060, 1055469063, 'DE', 'DEU', 'ألمانيا'),
(8944, 1055469064, 1055469067, 'IT', 'ITA', 'إيطاليا'),
(8945, 1055469068, 1055469071, 'BE', 'BEL', 'بلجيكا'),
(8946, 1055469072, 1055471615, 'FR', 'FRA', 'فرنسا'),
(8947, 1055471616, 1055472127, 'BE', 'BEL', 'بلجيكا'),
(8948, 1055472128, 1055472159, 'NL', 'NLD', 'هولندا'),
(8949, 1055472160, 1055472383, 'FR', 'FRA', 'فرنسا'),
(8950, 1055472384, 1055472639, 'NL', 'NLD', 'هولندا'),
(8951, 1055472640, 1055473663, 'FR', 'FRA', 'فرنسا'),
(8952, 1055473664, 1055490047, 'GB', 'GBR', 'المملكة المتحدة'),
(8953, 1055490048, 1055522815, 'PL', 'POL', 'بولندا'),
(8954, 1055522816, 1055588351, 'NL', 'NLD', 'هولندا'),
(8955, 1055588352, 1055653887, 'BE', 'BEL', 'بلجيكا'),
(8956, 1055653888, 1055681055, 'FI', 'FIN', 'فنلندا'),
(8957, 1055681056, 1055681071, 'SE', 'SWE', 'السويد'),
(8958, 1055681072, 1055784959, 'FI', 'FIN', 'فنلندا'),
(8959, 1055784960, 1055850495, 'NL', 'NLD', 'هولندا'),
(8960, 1055850496, 1055916031, 'GB', 'GBR', 'المملكة المتحدة'),
(8961, 1055916032, 1055919615, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8962, 1055919616, 1055919871, 'RS', 'SRB', 'صربيا'),
(8963, 1055919872, 1055921151, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8964, 1055921152, 1055921407, 'RS', 'SRB', 'صربيا'),
(8965, 1055921408, 1055924223, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(8966, 1055932416, 1055940607, 'FI', 'FIN', 'فنلندا'),
(8967, 1055948800, 1055956991, 'DE', 'DEU', 'ألمانيا'),
(8968, 1055956992, 1055965183, 'CZ', 'CZE', 'التشيك'),
(8969, 1055965184, 1055973375, 'CH', 'CHE', 'سويسرا'),
(8970, 1055973376, 1055981567, 'FR', 'FRA', 'فرنسا'),
(8971, 1055981568, 1055989759, 'IT', 'ITA', 'إيطاليا'),
(8972, 1055989760, 1055992310, 'DE', 'DEU', 'ألمانيا'),
(8973, 1055992311, 1055992318, 'CH', 'CHE', 'سويسرا'),
(8974, 1055992319, 1055995135, 'DE', 'DEU', 'ألمانيا'),
(8975, 1055995136, 1055995391, 'NL', 'NLD', 'هولندا'),
(8976, 1055995392, 1055997951, 'DE', 'DEU', 'ألمانيا'),
(8977, 1055997952, 1056014335, 'FR', 'FRA', 'فرنسا'),
(8978, 1056022528, 1056030719, 'GB', 'GBR', 'المملكة المتحدة'),
(8979, 1056030720, 1056047103, 'FI', 'FIN', 'فنلندا'),
(8980, 1056047104, 1056178175, 'DK', 'DNK', 'الدنيمارك'),
(8981, 1056178176, 1056194559, 'UA', 'UKR', 'أوكرانيا'),
(8982, 1056194560, 1056210943, 'FR', 'FRA', 'فرنسا'),
(8983, 1056210944, 1056219135, 'PL', 'POL', 'بولندا'),
(8984, 1056219136, 1056227327, 'GB', 'GBR', 'المملكة المتحدة'),
(8985, 1056227328, 1056243711, 'TR', 'TUR', 'تركيا'),
(8986, 1056243712, 1056244447, 'CH', 'CHE', 'سويسرا'),
(8987, 1056244448, 1056244479, 'MC', 'MCO', 'موناكو'),
(8988, 1056244480, 1056251903, 'CH', 'CHE', 'سويسرا'),
(8989, 1056251904, 1056260095, 'RU', 'RUS', 'الإتحاد الروسي'),
(8990, 1056260096, 1056276479, 'CZ', 'CZE', 'التشيك'),
(8991, 1056276480, 1056374783, 'DE', 'DEU', 'ألمانيا'),
(8992, 1056374784, 1056440319, 'SE', 'SWE', 'السويد'),
(8993, 1056440320, 1056473087, 'TR', 'TUR', 'تركيا'),
(8994, 1056473088, 1056505087, 'FI', 'FIN', 'فنلندا'),
(8995, 1056505088, 1056505107, 'SE', 'SWE', 'السويد'),
(8996, 1056505108, 1056505115, 'FI', 'FIN', 'فنلندا'),
(8997, 1056505116, 1056505119, 'SE', 'SWE', 'السويد'),
(8998, 1056505120, 1056505343, 'FI', 'FIN', 'فنلندا'),
(8999, 1056505344, 1056505599, 'SE', 'SWE', 'السويد'),
(9000, 1056505600, 1056505855, 'FI', 'FIN', 'فنلندا'),
(9001, 1056505856, 1056514047, 'PT', 'PRT', 'البورتوغال'),
(9002, 1056514048, 1056522239, 'IT', 'ITA', 'إيطاليا'),
(9003, 1056522240, 1056538623, 'AT', 'AUT', 'النمسا'),
(9004, 1056538624, 1056546815, 'DE', 'DEU', 'ألمانيا'),
(9005, 1056546816, 1056555007, 'NO', 'NOR', 'النرويج'),
(9006, 1056555008, 1056571391, 'GB', 'GBR', 'المملكة المتحدة'),
(9007, 1056571392, 1056669695, 'NL', 'NLD', 'هولندا'),
(9008, 1056702464, 1056874559, 'GB', 'GBR', 'المملكة المتحدة'),
(9009, 1056874560, 1056874567, 'IE', 'IRL', 'إيرلندا'),
(9010, 1056874568, 1056874599, 'GB', 'GBR', 'المملكة المتحدة'),
(9011, 1056874600, 1056874607, 'IE', 'IRL', 'إيرلندا'),
(9012, 1056874608, 1056874639, 'GB', 'GBR', 'المملكة المتحدة'),
(9013, 1056874640, 1056874647, 'IE', 'IRL', 'إيرلندا'),
(9014, 1056874648, 1056874655, 'GB', 'GBR', 'المملكة المتحدة'),
(9015, 1056874656, 1056874679, 'IE', 'IRL', 'إيرلندا'),
(9016, 1056874680, 1056874751, 'GB', 'GBR', 'المملكة المتحدة'),
(9017, 1056874752, 1056874783, 'IE', 'IRL', 'إيرلندا'),
(9018, 1056874784, 1056874919, 'GB', 'GBR', 'المملكة المتحدة'),
(9019, 1056874920, 1056874927, 'IE', 'IRL', 'إيرلندا'),
(9020, 1056874928, 1056874991, 'GB', 'GBR', 'المملكة المتحدة'),
(9021, 1056874992, 1056875007, 'IE', 'IRL', 'إيرلندا'),
(9022, 1056875008, 1056875071, 'GB', 'GBR', 'المملكة المتحدة'),
(9023, 1056875072, 1056875103, 'IE', 'IRL', 'إيرلندا'),
(9024, 1056875104, 1056875111, 'GB', 'GBR', 'المملكة المتحدة'),
(9025, 1056875112, 1056875135, 'IE', 'IRL', 'إيرلندا'),
(9026, 1056875136, 1056875151, 'GB', 'GBR', 'المملكة المتحدة'),
(9027, 1056875152, 1056875167, 'IE', 'IRL', 'إيرلندا'),
(9028, 1056875168, 1056875263, 'GB', 'GBR', 'المملكة المتحدة'),
(9029, 1056875264, 1056875311, 'IE', 'IRL', 'إيرلندا'),
(9030, 1056875312, 1056875615, 'GB', 'GBR', 'المملكة المتحدة'),
(9031, 1056875616, 1056875623, 'IE', 'IRL', 'إيرلندا'),
(9032, 1056875624, 1056875639, 'GB', 'GBR', 'المملكة المتحدة'),
(9033, 1056875640, 1056875671, 'IE', 'IRL', 'إيرلندا'),
(9034, 1056875672, 1056876031, 'GB', 'GBR', 'المملكة المتحدة'),
(9035, 1056876032, 1056876047, 'IE', 'IRL', 'إيرلندا'),
(9036, 1056876048, 1056964607, 'GB', 'GBR', 'المملكة المتحدة'),
(9037, 1056964608, 1061227007, 'US', 'USA', 'الولايات المتحدة'),
(9038, 1061227008, 1061227263, 'HT', 'HTI', 'هايتي'),
(9039, 1061227264, 1061227519, 'BO', 'BOL', 'بوليفيا'),
(9040, 1061227520, 1061588735, 'US', 'USA', 'الولايات المتحدة'),
(9041, 1061588736, 1061588991, 'GU', 'GUM', 'غوام'),
(9042, 1061588992, 1062069247, 'US', 'USA', 'الولايات المتحدة'),
(9043, 1062069248, 1062070271, 'PR', 'PRI', 'بورتو ريكو'),
(9044, 1062070272, 1062497791, 'US', 'USA', 'الولايات المتحدة'),
(9045, 1062497792, 1062498303, 'FM', 'FSM', 'ولايات ميكرونيزيا الموحدة'),
(9046, 1062498304, 1062545919, 'US', 'USA', 'الولايات المتحدة'),
(9047, 1062545920, 1062546431, 'BM', 'BMU', 'برمودا'),
(9048, 1062546432, 1062871551, 'US', 'USA', 'الولايات المتحدة'),
(9049, 1062871552, 1062872063, 'PR', 'PRI', 'بورتو ريكو'),
(9050, 1062872064, 1063305727, 'US', 'USA', 'الولايات المتحدة'),
(9051, 1063305728, 1063305983, 'CA', 'CAN', 'كندا'),
(9052, 1063305984, 1063334911, 'US', 'USA', 'الولايات المتحدة'),
(9053, 1063334912, 1063335423, 'CO', 'COL', 'كولومبيا'),
(9054, 1063335424, 1063568895, 'US', 'USA', 'الولايات المتحدة'),
(9055, 1063568896, 1063569151, 'TZ', 'TZA', 'تانزانيا'),
(9056, 1063569152, 1063573679, 'US', 'USA', 'الولايات المتحدة'),
(9057, 1063573680, 1063573695, 'VN', 'VNM', 'فييتنام'),
(9058, 1063573696, 1063727615, 'US', 'USA', 'الولايات المتحدة'),
(9059, 1063727616, 1063728127, 'GU', 'GUM', 'غوام'),
(9060, 1063728128, 1063747839, 'US', 'USA', 'الولايات المتحدة'),
(9061, 1063747840, 1063748095, 'UG', 'UGA', 'أوغاندا'),
(9062, 1063748096, 1063748607, 'US', 'USA', 'الولايات المتحدة'),
(9063, 1063748608, 1063749119, 'GH', 'GHA', 'غانا'),
(9064, 1063749120, 1063749631, 'US', 'USA', 'الولايات المتحدة'),
(9065, 1063749632, 1063749887, 'LR', 'LBR', 'ليبيريا'),
(9066, 1063749888, 1063750143, 'SA', 'SAU', 'السعودية'),
(9067, 1063750144, 1063750399, 'NG', 'NGA', 'نيجيريا'),
(9068, 1063750400, 1063750463, 'US', 'USA', 'الولايات المتحدة'),
(9069, 1063750464, 1063750527, 'NG', 'NGA', 'نيجيريا'),
(9070, 1063750528, 1063750655, 'US', 'USA', 'الولايات المتحدة'),
(9071, 1063750656, 1063751679, 'NG', 'NGA', 'نيجيريا'),
(9072, 1063751680, 1063895039, 'US', 'USA', 'الولايات المتحدة'),
(9073, 1063895040, 1063899135, 'KR', 'KOR', 'جمهورية كوريا'),
(9074, 1063899136, 1064124927, 'US', 'USA', 'الولايات المتحدة'),
(9075, 1064124928, 1064125695, 'EC', 'ECU', 'الإكوادور'),
(9076, 1064125696, 1064126719, 'US', 'USA', 'الولايات المتحدة'),
(9077, 1064126720, 1064126975, 'EC', 'ECU', 'الإكوادور'),
(9078, 1064126976, 1064127487, 'US', 'USA', 'الولايات المتحدة'),
(9079, 1064127488, 1064127999, 'EC', 'ECU', 'الإكوادور'),
(9080, 1064128000, 1064170799, 'US', 'USA', 'الولايات المتحدة'),
(9081, 1064170800, 1064170807, 'LB', 'LBN', 'لبنان'),
(9082, 1064170808, 1064170991, 'US', 'USA', 'الولايات المتحدة'),
(9083, 1064170992, 1064170999, 'LB', 'LBN', 'لبنان'),
(9084, 1064171000, 1064171007, 'US', 'USA', 'الولايات المتحدة'),
(9085, 1064171008, 1064171135, 'LB', 'LBN', 'لبنان'),
(9086, 1064171136, 1064171263, 'US', 'USA', 'الولايات المتحدة'),
(9087, 1064171264, 1064171551, 'LB', 'LBN', 'لبنان'),
(9088, 1064171552, 1064171559, 'TZ', 'TZA', 'تانزانيا'),
(9089, 1064171560, 1064171575, 'US', 'USA', 'الولايات المتحدة'),
(9090, 1064171576, 1064171583, 'PK', 'PAK', 'باكستان'),
(9091, 1064171584, 1064171607, 'US', 'USA', 'الولايات المتحدة'),
(9092, 1064171608, 1064171615, 'PK', 'PAK', 'باكستان'),
(9093, 1064171616, 1064171631, 'GH', 'GHA', 'غانا'),
(9094, 1064171632, 1064171855, 'US', 'USA', 'الولايات المتحدة'),
(9095, 1064171856, 1064171871, 'TZ', 'TZA', 'تانزانيا'),
(9096, 1064171872, 1064171903, 'US', 'USA', 'الولايات المتحدة'),
(9097, 1064171904, 1064171911, 'LB', 'LBN', 'لبنان'),
(9098, 1064171912, 1064171919, 'US', 'USA', 'الولايات المتحدة'),
(9099, 1064171920, 1064171927, 'PK', 'PAK', 'باكستان'),
(9100, 1064171928, 1064171935, 'US', 'USA', 'الولايات المتحدة'),
(9101, 1064171936, 1064171967, 'LB', 'LBN', 'لبنان'),
(9102, 1064171968, 1064204287, 'US', 'USA', 'الولايات المتحدة'),
(9103, 1064204288, 1064205311, 'MX', 'MEX', 'المكسيك'),
(9104, 1064205312, 1064650751, 'US', 'USA', 'الولايات المتحدة'),
(9105, 1064650752, 1064651775, 'EC', 'ECU', 'الإكوادور'),
(9106, 1064651776, 1065519359, 'US', 'USA', 'الولايات المتحدة'),
(9107, 1065519360, 1065519487, 'CA', 'CAN', 'كندا'),
(9108, 1065519488, 1065611263, 'US', 'USA', 'الولايات المتحدة'),
(9109, 1065611264, 1065615359, 'PR', 'PRI', 'بورتو ريكو'),
(9110, 1065615360, 1065811967, 'US', 'USA', 'الولايات المتحدة'),
(9111, 1065811968, 1065820159, 'CA', 'CAN', 'كندا'),
(9112, 1065820160, 1065873407, 'US', 'USA', 'الولايات المتحدة'),
(9113, 1065873408, 1065877503, 'PR', 'PRI', 'بورتو ريكو'),
(9114, 1065877504, 1065906175, 'US', 'USA', 'الولايات المتحدة'),
(9115, 1065906176, 1065908223, 'KY', 'CYM', 'جزر كايمان'),
(9116, 1065908224, 1065926815, 'US', 'USA', 'الولايات المتحدة'),
(9117, 1065926816, 1065926823, 'CA', 'CAN', 'كندا'),
(9118, 1065926824, 1066139647, 'US', 'USA', 'الولايات المتحدة'),
(9119, 1066401792, 1066475263, 'US', 'USA', 'الولايات المتحدة'),
(9120, 1066475264, 1066475519, 'CA', 'CAN', 'كندا'),
(9121, 1066475520, 1066584063, 'US', 'USA', 'الولايات المتحدة'),
(9122, 1066584064, 1066586111, 'PE', 'PER', 'بيرو'),
(9123, 1066586112, 1066718559, 'US', 'USA', 'الولايات المتحدة'),
(9124, 1066718560, 1066718591, 'PR', 'PRI', 'بورتو ريكو'),
(9125, 1066718592, 1066829311, 'US', 'USA', 'الولايات المتحدة'),
(9126, 1066829312, 1066829567, 'HK', 'HKG', 'هونغ كونغ'),
(9127, 1066829568, 1066830207, 'US', 'USA', 'الولايات المتحدة'),
(9128, 1066830208, 1066830239, 'SG', 'SGP', 'سنغافورة'),
(9129, 1066830240, 1066830271, 'US', 'USA', 'الولايات المتحدة'),
(9130, 1066830272, 1066830303, 'SG', 'SGP', 'سنغافورة'),
(9131, 1066830304, 1066830311, 'US', 'USA', 'الولايات المتحدة'),
(9132, 1066830312, 1066830319, 'SG', 'SGP', 'سنغافورة'),
(9133, 1066830320, 1066830335, 'US', 'USA', 'الولايات المتحدة'),
(9134, 1066830336, 1066830591, 'SG', 'SGP', 'سنغافورة'),
(9135, 1066830592, 1066830799, 'US', 'USA', 'الولايات المتحدة'),
(9136, 1066830800, 1066830807, 'SG', 'SGP', 'سنغافورة'),
(9137, 1066830808, 1066898783, 'US', 'USA', 'الولايات المتحدة'),
(9138, 1066898784, 1066898815, 'CO', 'COL', 'كولومبيا'),
(9139, 1066898816, 1067473471, 'US', 'USA', 'الولايات المتحدة'),
(9140, 1067473472, 1067473535, 'CA', 'CAN', 'كندا'),
(9141, 1067473536, 1067474751, 'US', 'USA', 'الولايات المتحدة'),
(9142, 1067474752, 1067474767, 'NL', 'NLD', 'هولندا'),
(9143, 1067474768, 1067481855, 'US', 'USA', 'الولايات المتحدة'),
(9144, 1067481856, 1067482111, 'CA', 'CAN', 'كندا'),
(9145, 1067482112, 1067494847, 'US', 'USA', 'الولايات المتحدة'),
(9146, 1067494848, 1067494879, 'CA', 'CAN', 'كندا'),
(9147, 1067494880, 1067503615, 'US', 'USA', 'الولايات المتحدة'),
(9148, 1067503616, 1067503743, 'CA', 'CAN', 'كندا'),
(9149, 1067503744, 1067532287, 'US', 'USA', 'الولايات المتحدة'),
(9150, 1067532288, 1067532799, 'HN', 'HND', 'هندوراس'),
(9151, 1067532800, 1067537959, 'US', 'USA', 'الولايات المتحدة'),
(9152, 1067537960, 1067537967, 'GB', 'GBR', 'المملكة المتحدة'),
(9153, 1067537968, 1067562495, 'US', 'USA', 'الولايات المتحدة'),
(9154, 1067562496, 1067562751, 'SL', 'SLE', 'سيراليون'),
(9155, 1067562752, 1067573247, 'US', 'USA', 'الولايات المتحدة'),
(9156, 1067573248, 1067573255, 'SG', 'SGP', 'سنغافورة'),
(9157, 1067573256, 1067575295, 'US', 'USA', 'الولايات المتحدة'),
(9158, 1067575296, 1067577343, 'HN', 'HND', 'هندوراس'),
(9159, 1067577344, 1067617791, 'US', 'USA', 'الولايات المتحدة'),
(9160, 1067617792, 1067618047, 'CN', 'CHN', 'الصين'),
(9161, 1067618048, 1067625967, 'US', 'USA', 'الولايات المتحدة'),
(9162, 1067625968, 1067625983, 'CH', 'CHE', 'سويسرا'),
(9163, 1067625984, 1067653255, 'US', 'USA', 'الولايات المتحدة'),
(9164, 1067653256, 1067653263, 'PR', 'PRI', 'بورتو ريكو'),
(9165, 1067653264, 1067693055, 'US', 'USA', 'الولايات المتحدة'),
(9166, 1067693056, 1067693567, 'CO', 'COL', 'كولومبيا'),
(9167, 1067693568, 1067726847, 'US', 'USA', 'الولايات المتحدة'),
(9168, 1067726848, 1067727359, 'EC', 'ECU', 'الإكوادور'),
(9169, 1067727360, 1067740159, 'US', 'USA', 'الولايات المتحدة'),
(9170, 1067740160, 1067741183, 'HN', 'HND', 'هندوراس'),
(9171, 1067741184, 1067762815, 'US', 'USA', 'الولايات المتحدة'),
(9172, 1067762816, 1067762831, 'CA', 'CAN', 'كندا'),
(9173, 1067762832, 1067780607, 'US', 'USA', 'الولايات المتحدة'),
(9174, 1067780608, 1067780863, 'GB', 'GBR', 'المملكة المتحدة'),
(9175, 1067780864, 1067808783, 'US', 'USA', 'الولايات المتحدة'),
(9176, 1067808784, 1067808799, 'GB', 'GBR', 'المملكة المتحدة'),
(9177, 1067808800, 1067822863, 'US', 'USA', 'الولايات المتحدة'),
(9178, 1067822864, 1067822871, 'CA', 'CAN', 'كندا'),
(9179, 1067822872, 1067824895, 'US', 'USA', 'الولايات المتحدة'),
(9180, 1067824896, 1067825151, 'PR', 'PRI', 'بورتو ريكو'),
(9181, 1067825152, 1067826239, 'US', 'USA', 'الولايات المتحدة'),
(9182, 1067826240, 1067826247, 'CA', 'CAN', 'كندا'),
(9183, 1067826248, 1067908295, 'US', 'USA', 'الولايات المتحدة'),
(9184, 1067908296, 1067908303, 'CH', 'CHE', 'سويسرا'),
(9185, 1067908304, 1067909023, 'US', 'USA', 'الولايات المتحدة'),
(9186, 1067909024, 1067909039, 'SG', 'SGP', 'سنغافورة'),
(9187, 1067909040, 1067918879, 'US', 'USA', 'الولايات المتحدة'),
(9188, 1067918880, 1067918887, 'NL', 'NLD', 'هولندا'),
(9189, 1067918888, 1067923231, 'US', 'USA', 'الولايات المتحدة'),
(9190, 1067923232, 1067923239, 'CA', 'CAN', 'كندا'),
(9191, 1067923240, 1067977895, 'US', 'USA', 'الولايات المتحدة'),
(9192, 1067977896, 1067977903, 'CA', 'CAN', 'كندا'),
(9193, 1067977904, 1067989247, 'US', 'USA', 'الولايات المتحدة'),
(9194, 1067989248, 1067989503, 'EC', 'ECU', 'الإكوادور'),
(9195, 1067989504, 1067998463, 'US', 'USA', 'الولايات المتحدة'),
(9196, 1067998464, 1067998719, 'CO', 'COL', 'كولومبيا'),
(9197, 1067998720, 1068119407, 'US', 'USA', 'الولايات المتحدة'),
(9198, 1068119408, 1068119423, 'DE', 'DEU', 'ألمانيا'),
(9199, 1068119424, 1068167439, 'US', 'USA', 'الولايات المتحدة'),
(9200, 1068167440, 1068167447, 'GB', 'GBR', 'المملكة المتحدة'),
(9201, 1068167448, 1068198879, 'US', 'USA', 'الولايات المتحدة'),
(9202, 1068198880, 1068198911, 'IN', 'IND', 'الهند'),
(9203, 1068198912, 1068199935, 'US', 'USA', 'الولايات المتحدة'),
(9204, 1068199936, 1068204031, 'CA', 'CAN', 'كندا'),
(9205, 1068204032, 1068230655, 'US', 'USA', 'الولايات المتحدة'),
(9206, 1068230656, 1068230911, 'CO', 'COL', 'كولومبيا'),
(9207, 1068230912, 1068284735, 'US', 'USA', 'الولايات المتحدة'),
(9208, 1068284736, 1068284743, 'CA', 'CAN', 'كندا'),
(9209, 1068284744, 1068326911, 'US', 'USA', 'الولايات المتحدة'),
(9210, 1068326912, 1068327167, 'EC', 'ECU', 'الإكوادور'),
(9211, 1068327168, 1068362863, 'US', 'USA', 'الولايات المتحدة'),
(9212, 1068362864, 1068362879, 'GB', 'GBR', 'المملكة المتحدة'),
(9213, 1068362880, 1068419071, 'US', 'USA', 'الولايات المتحدة'),
(9214, 1068419072, 1068421119, 'CO', 'COL', 'كولومبيا'),
(9215, 1068421120, 1068425983, 'US', 'USA', 'الولايات المتحدة'),
(9216, 1068425984, 1068426239, 'EC', 'ECU', 'الإكوادور'),
(9217, 1068426240, 1068480159, 'US', 'USA', 'الولايات المتحدة'),
(9218, 1068480160, 1068480191, 'IN', 'IND', 'الهند'),
(9219, 1068480192, 1068491263, 'US', 'USA', 'الولايات المتحدة'),
(9220, 1068491264, 1068491519, 'HN', 'HND', 'هندوراس'),
(9221, 1068491520, 1071472639, 'US', 'USA', 'الولايات المتحدة'),
(9222, 1071472640, 1071480831, 'CA', 'CAN', 'كندا'),
(9223, 1071480832, 1071985631, 'US', 'USA', 'الولايات المتحدة'),
(9224, 1071985632, 1071985663, 'ML', 'MLI', 'مالي'),
(9225, 1071985664, 1072619023, 'US', 'USA', 'الولايات المتحدة'),
(9226, 1072619024, 1072619039, 'CA', 'CAN', 'كندا'),
(9227, 1072619040, 1072680623, 'US', 'USA', 'الولايات المتحدة'),
(9228, 1072680624, 1072680631, 'CA', 'CAN', 'كندا'),
(9229, 1072680632, 1072922623, 'US', 'USA', 'الولايات المتحدة'),
(9230, 1072922624, 1072922879, 'PH', 'PHL', 'الفلبين'),
(9231, 1072922880, 1072923391, 'CA', 'CAN', 'كندا'),
(9232, 1072923392, 1072923903, 'US', 'USA', 'الولايات المتحدة'),
(9233, 1072923904, 1072924671, 'CA', 'CAN', 'كندا'),
(9234, 1072924672, 1072925183, 'US', 'USA', 'الولايات المتحدة'),
(9235, 1072925184, 1072925695, 'GB', 'GBR', 'المملكة المتحدة'),
(9236, 1072925696, 1072926207, 'CA', 'CAN', 'كندا'),
(9237, 1072926208, 1072926471, 'US', 'USA', 'الولايات المتحدة'),
(9238, 1072926472, 1072926527, 'CA', 'CAN', 'كندا'),
(9239, 1072926528, 1072926591, 'US', 'USA', 'الولايات المتحدة'),
(9240, 1072926592, 1072926719, 'CA', 'CAN', 'كندا'),
(9241, 1072926720, 1072926975, 'PH', 'PHL', 'الفلبين'),
(9242, 1072926976, 1072927487, 'CA', 'CAN', 'كندا'),
(9243, 1072927488, 1072927743, 'US', 'USA', 'الولايات المتحدة'),
(9244, 1072927744, 1072928047, 'CA', 'CAN', 'كندا'),
(9245, 1072928048, 1072928063, 'IE', 'IRL', 'إيرلندا'),
(9246, 1072928064, 1072928095, 'US', 'USA', 'الولايات المتحدة'),
(9247, 1072928096, 1072928263, 'CA', 'CAN', 'كندا'),
(9248, 1072928264, 1072928287, 'US', 'USA', 'الولايات المتحدة'),
(9249, 1072928288, 1072928383, 'CA', 'CAN', 'كندا'),
(9250, 1072928384, 1072928447, 'US', 'USA', 'الولايات المتحدة'),
(9251, 1072928448, 1072929535, 'CA', 'CAN', 'كندا'),
(9252, 1072929536, 1072929791, 'US', 'USA', 'الولايات المتحدة'),
(9253, 1072929792, 1072930047, 'CA', 'CAN', 'كندا'),
(9254, 1072930048, 1072930303, 'US', 'USA', 'الولايات المتحدة'),
(9255, 1072930304, 1072931071, 'CA', 'CAN', 'كندا'),
(9256, 1072931072, 1072931199, 'US', 'USA', 'الولايات المتحدة'),
(9257, 1072931200, 1072932607, 'CA', 'CAN', 'كندا'),
(9258, 1072932608, 1072932863, 'NG', 'NGA', 'نيجيريا'),
(9259, 1072932864, 1072934399, 'CA', 'CAN', 'كندا'),
(9260, 1072934400, 1072934655, 'US', 'USA', 'الولايات المتحدة'),
(9261, 1072934656, 1072934783, 'CA', 'CAN', 'كندا'),
(9262, 1072934784, 1072934847, 'AU', 'AUS', 'أستراليا'),
(9263, 1072934848, 1072934879, 'CA', 'CAN', 'كندا'),
(9264, 1072934880, 1072934911, 'TW', 'TWN', 'تايوان'),
(9265, 1072934912, 1072934943, 'CA', 'CAN', 'كندا'),
(9266, 1072934944, 1072934975, 'PH', 'PHL', 'الفلبين'),
(9267, 1072934976, 1072935039, 'CA', 'CAN', 'كندا'),
(9268, 1072935040, 1072935135, 'US', 'USA', 'الولايات المتحدة'),
(9269, 1072935136, 1072935159, 'CA', 'CAN', 'كندا'),
(9270, 1072935160, 1072935167, 'US', 'USA', 'الولايات المتحدة'),
(9271, 1072935168, 1072935679, 'CA', 'CAN', 'كندا'),
(9272, 1072935680, 1072935807, 'PH', 'PHL', 'الفلبين'),
(9273, 1072935808, 1072936447, 'CA', 'CAN', 'كندا'),
(9274, 1072936448, 1072936703, 'PH', 'PHL', 'الفلبين'),
(9275, 1072936704, 1072937215, 'US', 'USA', 'الولايات المتحدة'),
(9276, 1072937216, 1072937471, 'IR', 'IRN', 'إيران'),
(9277, 1072937472, 1072938239, 'CA', 'CAN', 'كندا'),
(9278, 1072938240, 1072938495, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(9279, 1072938496, 1072939519, 'CA', 'CAN', 'كندا'),
(9280, 1072939520, 1072940031, 'US', 'USA', 'الولايات المتحدة'),
(9281, 1072940032, 1072955391, 'CA', 'CAN', 'كندا'),
(9282, 1072955392, 1073022975, 'US', 'USA', 'الولايات المتحدة'),
(9283, 1073022976, 1073025791, 'HN', 'HND', 'هندوراس'),
(9284, 1073025792, 1073026047, 'NI', 'NIC', 'نيكاراغوا'),
(9285, 1073026048, 1073026303, 'US', 'USA', 'الولايات المتحدة'),
(9286, 1073026304, 1073026431, 'DO', 'DOM', 'الدومينيكان'),
(9287, 1073026432, 1073027071, 'US', 'USA', 'الولايات المتحدة'),
(9288, 1073027072, 1073028351, 'NI', 'NIC', 'نيكاراغوا'),
(9289, 1073028352, 1073028607, 'US', 'USA', 'الولايات المتحدة'),
(9290, 1073028608, 1073029119, 'GD', 'GRD', 'غرينادا'),
(9291, 1073029120, 1073031167, 'PR', 'PRI', 'بورتو ريكو'),
(9292, 1073031168, 1073031231, 'US', 'USA', 'الولايات المتحدة'),
(9293, 1073031232, 1073031263, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(9294, 1073031264, 1073031423, 'US', 'USA', 'الولايات المتحدة'),
(9295, 1073031424, 1073031935, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(9296, 1073031936, 1073033215, 'US', 'USA', 'الولايات المتحدة'),
(9297, 1073033216, 1073035263, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(9298, 1073035264, 1073036032, 'GD', 'GRD', 'غرينادا'),
(9299, 1073036033, 1073036543, 'US', 'USA', 'الولايات المتحدة'),
(9300, 1073036544, 1073037055, 'MX', 'MEX', 'المكسيك'),
(9301, 1073037056, 1073037311, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(9302, 1073037312, 1073037823, 'CO', 'COL', 'كولومبيا'),
(9303, 1073037824, 1073038335, 'GD', 'GRD', 'غرينادا'),
(9304, 1073038336, 1073039359, 'US', 'USA', 'الولايات المتحدة'),
(9305, 1073039360, 1073041407, 'GT', 'GTM', 'غواتيمالا'),
(9306, 1073041408, 1073043455, 'CO', 'COL', 'كولومبيا'),
(9307, 1073043456, 1073045503, 'US', 'USA', 'الولايات المتحدة'),
(9308, 1073045504, 1073047551, 'CO', 'COL', 'كولومبيا'),
(9309, 1073047552, 1073049599, 'PR', 'PRI', 'بورتو ريكو'),
(9310, 1073049600, 1073053695, 'BS', 'BHS', 'جزر البهاما'),
(9311, 1073053696, 1073070079, 'US', 'USA', 'الولايات المتحدة'),
(9312, 1073074176, 1073373183, 'US', 'USA', 'الولايات المتحدة'),
(9313, 1073373184, 1073381375, 'CA', 'CAN', 'كندا'),
(9314, 1073381376, 1073381887, 'NL', 'NLD', 'هولندا'),
(9315, 1073381888, 1074020351, 'US', 'USA', 'الولايات المتحدة'),
(9316, 1074020352, 1074028543, 'CA', 'CAN', 'كندا'),
(9317, 1074028544, 1074098175, 'US', 'USA', 'الولايات المتحدة'),
(9318, 1074102272, 1074118655, 'US', 'USA', 'الولايات المتحدة'),
(9319, 1074118656, 1074120703, 'CA', 'CAN', 'كندا'),
(9320, 1074120704, 1074120719, 'US', 'USA', 'الولايات المتحدة'),
(9321, 1074120720, 1074120959, 'CA', 'CAN', 'كندا'),
(9322, 1074120960, 1074121215, 'US', 'USA', 'الولايات المتحدة'),
(9323, 1074121216, 1074122415, 'CA', 'CAN', 'كندا'),
(9324, 1074122416, 1074122431, 'US', 'USA', 'الولايات المتحدة'),
(9325, 1074122432, 1074125055, 'CA', 'CAN', 'كندا'),
(9326, 1074125056, 1074125311, 'US', 'USA', 'الولايات المتحدة'),
(9327, 1074125312, 1074126847, 'CA', 'CAN', 'كندا'),
(9328, 1074126848, 1074127359, 'US', 'USA', 'الولايات المتحدة'),
(9329, 1074127360, 1074128511, 'CA', 'CAN', 'كندا'),
(9330, 1074128512, 1074128575, 'US', 'USA', 'الولايات المتحدة'),
(9331, 1074128576, 1074135039, 'CA', 'CAN', 'كندا'),
(9332, 1074135040, 1074184191, 'US', 'USA', 'الولايات المتحدة'),
(9333, 1074184192, 1074188287, 'CA', 'CAN', 'كندا'),
(9334, 1074188288, 1074229247, 'US', 'USA', 'الولايات المتحدة'),
(9335, 1074229248, 1074241535, 'CA', 'CAN', 'كندا'),
(9336, 1074241536, 1074672671, 'US', 'USA', 'الولايات المتحدة'),
(9337, 1074672672, 1074672703, 'IN', 'IND', 'الهند'),
(9338, 1074672704, 1074672943, 'US', 'USA', 'الولايات المتحدة'),
(9339, 1074672944, 1074672959, 'DK', 'DNK', 'الدنيمارك'),
(9340, 1074672960, 1074673663, 'US', 'USA', 'الولايات المتحدة'),
(9341, 1074673664, 1074673679, 'CY', 'CYP', 'قبرص'),
(9342, 1074673680, 1074675311, 'US', 'USA', 'الولايات المتحدة'),
(9343, 1074675312, 1074675327, 'NO', 'NOR', 'النرويج'),
(9344, 1074675328, 1074675679, 'US', 'USA', 'الولايات المتحدة'),
(9345, 1074675680, 1074675687, 'GB', 'GBR', 'المملكة المتحدة'),
(9346, 1074675688, 1074680623, 'US', 'USA', 'الولايات المتحدة'),
(9347, 1074680624, 1074680639, 'CA', 'CAN', 'كندا'),
(9348, 1074680640, 1074680703, 'US', 'USA', 'الولايات المتحدة'),
(9349, 1074680704, 1074680719, 'IL', 'ISR', 'إسرائيل'),
(9350, 1074680720, 1074681263, 'US', 'USA', 'الولايات المتحدة'),
(9351, 1074681264, 1074681279, 'CA', 'CAN', 'كندا'),
(9352, 1074681280, 1074681343, 'US', 'USA', 'الولايات المتحدة'),
(9353, 1074681344, 1074681359, 'CA', 'CAN', 'كندا'),
(9354, 1074681360, 1074682687, 'US', 'USA', 'الولايات المتحدة'),
(9355, 1074682688, 1074682751, 'CA', 'CAN', 'كندا'),
(9356, 1074682752, 1074683023, 'US', 'USA', 'الولايات المتحدة'),
(9357, 1074683024, 1074683039, 'CA', 'CAN', 'كندا'),
(9358, 1074683040, 1074683807, 'US', 'USA', 'الولايات المتحدة'),
(9359, 1074683808, 1074683839, 'CA', 'CAN', 'كندا'),
(9360, 1074683840, 1074690895, 'US', 'USA', 'الولايات المتحدة'),
(9361, 1074690896, 1074690911, 'AR', 'ARG', 'الأرجنتين'),
(9362, 1074690912, 1074690943, 'US', 'USA', 'الولايات المتحدة'),
(9363, 1074690944, 1074691007, 'AR', 'ARG', 'الأرجنتين'),
(9364, 1074691008, 1074691135, 'US', 'USA', 'الولايات المتحدة'),
(9365, 1074691136, 1074691199, 'AR', 'ARG', 'الأرجنتين'),
(9366, 1074691200, 1074701583, 'US', 'USA', 'الولايات المتحدة'),
(9367, 1074701584, 1074701591, 'CA', 'CAN', 'كندا'),
(9368, 1074701592, 1074701599, 'US', 'USA', 'الولايات المتحدة'),
(9369, 1074701600, 1074701631, 'CA', 'CAN', 'كندا'),
(9370, 1074701632, 1074702783, 'US', 'USA', 'الولايات المتحدة'),
(9371, 1074702784, 1074702847, 'CA', 'CAN', 'كندا'),
(9372, 1074702848, 1074703615, 'US', 'USA', 'الولايات المتحدة'),
(9373, 1074703616, 1074703871, 'GB', 'GBR', 'المملكة المتحدة'),
(9374, 1074703872, 1074704383, 'US', 'USA', 'الولايات المتحدة'),
(9375, 1074704384, 1074704639, 'GB', 'GBR', 'المملكة المتحدة'),
(9376, 1074704640, 1074704703, 'US', 'USA', 'الولايات المتحدة'),
(9377, 1074704704, 1074704711, 'CH', 'CHE', 'سويسرا'),
(9378, 1074704712, 1074704767, 'US', 'USA', 'الولايات المتحدة'),
(9379, 1074704768, 1074704831, 'CH', 'CHE', 'سويسرا'),
(9380, 1074704832, 1074705727, 'US', 'USA', 'الولايات المتحدة'),
(9381, 1074705728, 1074705743, 'GB', 'GBR', 'المملكة المتحدة'),
(9382, 1074705744, 1074705791, 'US', 'USA', 'الولايات المتحدة'),
(9383, 1074705792, 1074705799, 'IL', 'ISR', 'إسرائيل'),
(9384, 1074705800, 1074705887, 'US', 'USA', 'الولايات المتحدة'),
(9385, 1074705888, 1074705903, 'IL', 'ISR', 'إسرائيل'),
(9386, 1074705904, 1074706175, 'US', 'USA', 'الولايات المتحدة'),
(9387, 1074706176, 1074706303, 'IL', 'ISR', 'إسرائيل'),
(9388, 1074706304, 1074706367, 'US', 'USA', 'الولايات المتحدة'),
(9389, 1074706368, 1074706431, 'GB', 'GBR', 'المملكة المتحدة'),
(9390, 1074706432, 1074706679, 'US', 'USA', 'الولايات المتحدة'),
(9391, 1074706680, 1074706687, 'GB', 'GBR', 'المملكة المتحدة'),
(9392, 1074706688, 1074707775, 'US', 'USA', 'الولايات المتحدة'),
(9393, 1074707776, 1074707839, 'GB', 'GBR', 'المملكة المتحدة'),
(9394, 1074707840, 1074707967, 'US', 'USA', 'الولايات المتحدة'),
(9395, 1074707968, 1074708223, 'GB', 'GBR', 'المملكة المتحدة'),
(9396, 1074708224, 1074708991, 'US', 'USA', 'الولايات المتحدة'),
(9397, 1074708992, 1074709247, 'PH', 'PHL', 'الفلبين'),
(9398, 1074709248, 1074711039, 'US', 'USA', 'الولايات المتحدة'),
(9399, 1074711040, 1074711055, 'IN', 'IND', 'الهند'),
(9400, 1074711056, 1074716679, 'US', 'USA', 'الولايات المتحدة'),
(9401, 1074716680, 1074716687, 'GB', 'GBR', 'المملكة المتحدة'),
(9402, 1074716688, 1074716719, 'US', 'USA', 'الولايات المتحدة'),
(9403, 1074716720, 1074716735, 'GB', 'GBR', 'المملكة المتحدة'),
(9404, 1074716736, 1074733055, 'US', 'USA', 'الولايات المتحدة'),
(9405, 1074733056, 1074737151, 'AU', 'AUS', 'أستراليا'),
(9406, 1074737152, 1074745343, 'CA', 'CAN', 'كندا'),
(9407, 1074745344, 1074757631, 'US', 'USA', 'الولايات المتحدة'),
(9408, 1074757632, 1074765823, 'CA', 'CAN', 'كندا'),
(9409, 1074765824, 1074777343, 'US', 'USA', 'الولايات المتحدة'),
(9410, 1074777344, 1074777599, 'AU', 'AUS', 'أستراليا'),
(9411, 1074777600, 1074783167, 'US', 'USA', 'الولايات المتحدة'),
(9412, 1074783168, 1074783199, 'CA', 'CAN', 'كندا'),
(9413, 1074783200, 1074783231, 'BM', 'BMU', 'برمودا'),
(9414, 1074783232, 1074937855, 'US', 'USA', 'الولايات المتحدة'),
(9415, 1074937856, 1074946047, 'CA', 'CAN', 'كندا'),
(9416, 1074946048, 1074962431, 'US', 'USA', 'الولايات المتحدة'),
(9417, 1074962432, 1074970623, 'CA', 'CAN', 'كندا'),
(9418, 1074970624, 1075073023, 'US', 'USA', 'الولايات المتحدة'),
(9419, 1075077120, 1075117287, 'US', 'USA', 'الولايات المتحدة'),
(9420, 1075117288, 1075117311, 'IN', 'IND', 'الهند'),
(9421, 1075117312, 1075421183, 'US', 'USA', 'الولايات المتحدة'),
(9422, 1075421184, 1075429375, 'CA', 'CAN', 'كندا'),
(9423, 1075429376, 1075478527, 'US', 'USA', 'الولايات المتحدة'),
(9424, 1075478528, 1075494911, 'CA', 'CAN', 'كندا'),
(9425, 1075494912, 1075558143, 'US', 'USA', 'الولايات المتحدة'),
(9426, 1075558144, 1075558911, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(9427, 1075558912, 1075576831, 'US', 'USA', 'الولايات المتحدة'),
(9428, 1075576832, 1075580927, 'GB', 'GBR', 'المملكة المتحدة'),
(9429, 1075580928, 1075585023, 'NL', 'NLD', 'هولندا'),
(9430, 1075585024, 1075593967, 'US', 'USA', 'الولايات المتحدة'),
(9431, 1075593968, 1075593983, 'CA', 'CAN', 'كندا'),
(9432, 1075593984, 1075594975, 'US', 'USA', 'الولايات المتحدة'),
(9433, 1075594976, 1075594991, 'CA', 'CAN', 'كندا'),
(9434, 1075594992, 1075595343, 'US', 'USA', 'الولايات المتحدة'),
(9435, 1075595344, 1075595359, 'CA', 'CAN', 'كندا'),
(9436, 1075595360, 1075596031, 'US', 'USA', 'الولايات المتحدة'),
(9437, 1075596032, 1075596047, 'CA', 'CAN', 'كندا'),
(9438, 1075596048, 1075596831, 'US', 'USA', 'الولايات المتحدة'),
(9439, 1075596832, 1075596847, 'CA', 'CAN', 'كندا'),
(9440, 1075596848, 1075597023, 'US', 'USA', 'الولايات المتحدة'),
(9441, 1075597024, 1075597039, 'CA', 'CAN', 'كندا'),
(9442, 1075597040, 1075597167, 'US', 'USA', 'الولايات المتحدة'),
(9443, 1075597168, 1075597183, 'CA', 'CAN', 'كندا'),
(9444, 1075597184, 1075597375, 'US', 'USA', 'الولايات المتحدة'),
(9445, 1075597376, 1075597407, 'CA', 'CAN', 'كندا'),
(9446, 1075597408, 1075597439, 'IL', 'ISR', 'إسرائيل'),
(9447, 1075597440, 1075597551, 'US', 'USA', 'الولايات المتحدة'),
(9448, 1075597552, 1075597599, 'CA', 'CAN', 'كندا'),
(9449, 1075597600, 1075598367, 'US', 'USA', 'الولايات المتحدة'),
(9450, 1075598368, 1075598383, 'CA', 'CAN', 'كندا'),
(9451, 1075598384, 1075598943, 'US', 'USA', 'الولايات المتحدة'),
(9452, 1075598944, 1075598991, 'CA', 'CAN', 'كندا'),
(9453, 1075598992, 1075599007, 'US', 'USA', 'الولايات المتحدة'),
(9454, 1075599008, 1075599039, 'CA', 'CAN', 'كندا'),
(9455, 1075599040, 1075599471, 'US', 'USA', 'الولايات المتحدة'),
(9456, 1075599472, 1075599487, 'IL', 'ISR', 'إسرائيل'),
(9457, 1075599488, 1075599967, 'US', 'USA', 'الولايات المتحدة'),
(9458, 1075599968, 1075599983, 'IE', 'IRL', 'إيرلندا'),
(9459, 1075599984, 1075601279, 'US', 'USA', 'الولايات المتحدة'),
(9460, 1075601280, 1075601295, 'CA', 'CAN', 'كندا'),
(9461, 1075601296, 1075609599, 'US', 'USA', 'الولايات المتحدة'),
(9462, 1075609600, 1075613695, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(9463, 1075613696, 1075740671, 'US', 'USA', 'الولايات المتحدة'),
(9464, 1075744768, 1075773439, 'US', 'USA', 'الولايات المتحدة'),
(9465, 1075789824, 1075855359, 'US', 'USA', 'الولايات المتحدة'),
(9466, 1075855360, 1075871743, 'DO', 'DOM', 'الدومينيكان'),
(9467, 1075871744, 1075970047, 'US', 'USA', 'الولايات المتحدة'),
(9468, 1075970048, 1075972095, 'CA', 'CAN', 'كندا'),
(9469, 1075972096, 1075972351, 'GB', 'GBR', 'المملكة المتحدة'),
(9470, 1075972352, 1075976191, 'US', 'USA', 'الولايات المتحدة'),
(9471, 1075976192, 1075976447, 'CA', 'CAN', 'كندا'),
(9472, 1075976448, 1075977983, 'US', 'USA', 'الولايات المتحدة'),
(9473, 1075977984, 1075978239, 'CA', 'CAN', 'كندا'),
(9474, 1075978240, 1075983359, 'US', 'USA', 'الولايات المتحدة'),
(9475, 1075983360, 1075984383, 'CA', 'CAN', 'كندا'),
(9476, 1075984384, 1075985919, 'US', 'USA', 'الولايات المتحدة'),
(9477, 1075985920, 1075986431, 'CA', 'CAN', 'كندا'),
(9478, 1075986432, 1075990271, 'US', 'USA', 'الولايات المتحدة'),
(9479, 1075990272, 1075990527, 'CA', 'CAN', 'كندا'),
(9480, 1075990528, 1075995007, 'US', 'USA', 'الولايات المتحدة'),
(9481, 1075995008, 1075995023, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(9482, 1075995024, 1075996991, 'US', 'USA', 'الولايات المتحدة'),
(9483, 1075996992, 1075997071, 'CA', 'CAN', 'كندا'),
(9484, 1075997072, 1075997183, 'US', 'USA', 'الولايات المتحدة'),
(9485, 1075997184, 1075997439, 'CA', 'CAN', 'كندا'),
(9486, 1075997440, 1075999999, 'US', 'USA', 'الولايات المتحدة'),
(9487, 1076000000, 1076000255, 'CA', 'CAN', 'كندا'),
(9488, 1076000256, 1076000767, 'US', 'USA', 'الولايات المتحدة'),
(9489, 1076000768, 1076002047, 'CA', 'CAN', 'كندا'),
(9490, 1076002048, 1076003071, 'US', 'USA', 'الولايات المتحدة'),
(9491, 1076003072, 1076003327, 'CA', 'CAN', 'كندا'),
(9492, 1076003328, 1076003519, 'US', 'USA', 'الولايات المتحدة'),
(9493, 1076003520, 1076003535, 'CA', 'CAN', 'كندا'),
(9494, 1076003536, 1076003583, 'US', 'USA', 'الولايات المتحدة'),
(9495, 1076003584, 1076004351, 'CA', 'CAN', 'كندا'),
(9496, 1076004352, 1076004863, 'US', 'USA', 'الولايات المتحدة'),
(9497, 1076004864, 1076005119, 'CA', 'CAN', 'كندا'),
(9498, 1076005120, 1076005375, 'US', 'USA', 'الولايات المتحدة'),
(9499, 1076005376, 1076005631, 'CA', 'CAN', 'كندا'),
(9500, 1076005632, 1076006399, 'US', 'USA', 'الولايات المتحدة'),
(9501, 1076006400, 1076006655, 'CA', 'CAN', 'كندا'),
(9502, 1076006656, 1076006911, 'US', 'USA', 'الولايات المتحدة'),
(9503, 1076006912, 1076007167, 'CA', 'CAN', 'كندا'),
(9504, 1076007168, 1076007423, 'US', 'USA', 'الولايات المتحدة'),
(9505, 1076007424, 1076007679, 'CA', 'CAN', 'كندا'),
(9506, 1076007680, 1076007935, 'US', 'USA', 'الولايات المتحدة'),
(9507, 1076007936, 1076008191, 'CA', 'CAN', 'كندا'),
(9508, 1076008192, 1076008447, 'US', 'USA', 'الولايات المتحدة'),
(9509, 1076008448, 1076009215, 'CA', 'CAN', 'كندا'),
(9510, 1076009216, 1076009727, 'US', 'USA', 'الولايات المتحدة'),
(9511, 1076009728, 1076009983, 'CA', 'CAN', 'كندا'),
(9512, 1076009984, 1076010239, 'US', 'USA', 'الولايات المتحدة'),
(9513, 1076010240, 1076010495, 'CA', 'CAN', 'كندا'),
(9514, 1076010496, 1076026623, 'US', 'USA', 'الولايات المتحدة'),
(9515, 1076026624, 1076026879, 'CA', 'CAN', 'كندا'),
(9516, 1076026880, 1076028159, 'US', 'USA', 'الولايات المتحدة'),
(9517, 1076028160, 1076028415, 'CA', 'CAN', 'كندا'),
(9518, 1076028416, 1076028927, 'US', 'USA', 'الولايات المتحدة'),
(9519, 1076028928, 1076029183, 'BZ', 'BLZ', 'بليز'),
(9520, 1076029184, 1076029439, 'US', 'USA', 'الولايات المتحدة'),
(9521, 1076029440, 1076029951, 'CA', 'CAN', 'كندا'),
(9522, 1076029952, 1076030783, 'US', 'USA', 'الولايات المتحدة'),
(9523, 1076030784, 1076030847, 'CA', 'CAN', 'كندا'),
(9524, 1076030848, 1076030975, 'US', 'USA', 'الولايات المتحدة'),
(9525, 1076030976, 1076031487, 'CA', 'CAN', 'كندا'),
(9526, 1076031488, 1076031743, 'US', 'USA', 'الولايات المتحدة'),
(9527, 1076031744, 1076031999, 'CA', 'CAN', 'كندا'),
(9528, 1076032000, 1076166655, 'US', 'USA', 'الولايات المتحدة'),
(9529, 1076183040, 1076281695, 'US', 'USA', 'الولايات المتحدة'),
(9530, 1076281696, 1076281727, 'TH', 'THA', 'تايلند'),
(9531, 1076281728, 1076282111, 'US', 'USA', 'الولايات المتحدة'),
(9532, 1076282112, 1076282143, 'AU', 'AUS', 'أستراليا'),
(9533, 1076282144, 1076282351, 'US', 'USA', 'الولايات المتحدة'),
(9534, 1076282352, 1076282367, 'CA', 'CAN', 'كندا'),
(9535, 1076282368, 1076283903, 'US', 'USA', 'الولايات المتحدة'),
(9536, 1076283904, 1076284159, 'NO', 'NOR', 'النرويج'),
(9537, 1076284160, 1076284679, 'US', 'USA', 'الولايات المتحدة'),
(9538, 1076284680, 1076284687, 'HU', 'HUN', 'هنغاريا'),
(9539, 1076284688, 1076285439, 'US', 'USA', 'الولايات المتحدة'),
(9540, 1076285440, 1076285455, 'DK', 'DNK', 'الدنيمارك'),
(9541, 1076285456, 1076291903, 'US', 'USA', 'الولايات المتحدة'),
(9542, 1076291904, 1076291919, 'UA', 'UKR', 'أوكرانيا'),
(9543, 1076291920, 1076292559, 'US', 'USA', 'الولايات المتحدة'),
(9544, 1076292560, 1076292567, 'NL', 'NLD', 'هولندا'),
(9545, 1076292568, 1076294655, 'US', 'USA', 'الولايات المتحدة'),
(9546, 1076294656, 1076294687, 'CY', 'CYP', 'قبرص'),
(9547, 1076294688, 1076294703, 'US', 'USA', 'الولايات المتحدة'),
(9548, 1076294704, 1076294719, 'NO', 'NOR', 'النرويج'),
(9549, 1076294720, 1076295071, 'US', 'USA', 'الولايات المتحدة'),
(9550, 1076295072, 1076295087, 'NL', 'NLD', 'هولندا'),
(9551, 1076295088, 1076295167, 'US', 'USA', 'الولايات المتحدة'),
(9552, 1076295168, 1076295199, 'CY', 'CYP', 'قبرص'),
(9553, 1076295200, 1076306463, 'US', 'USA', 'الولايات المتحدة'),
(9554, 1076306464, 1076306479, 'GB', 'GBR', 'المملكة المتحدة'),
(9555, 1076306480, 1076306511, 'US', 'USA', 'الولايات المتحدة'),
(9556, 1076306512, 1076306527, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(9557, 1076306528, 1076307495, 'US', 'USA', 'الولايات المتحدة'),
(9558, 1076307496, 1076307503, 'DE', 'DEU', 'ألمانيا'),
(9559, 1076307504, 1076307519, 'US', 'USA', 'الولايات المتحدة'),
(9560, 1076307520, 1076307535, 'DE', 'DEU', 'ألمانيا'),
(9561, 1076307536, 1076307743, 'US', 'USA', 'الولايات المتحدة'),
(9562, 1076307744, 1076307807, 'DE', 'DEU', 'ألمانيا'),
(9563, 1076307808, 1076307967, 'US', 'USA', 'الولايات المتحدة'),
(9564, 1076307968, 1076308223, 'DE', 'DEU', 'ألمانيا'),
(9565, 1076308224, 1076308495, 'US', 'USA', 'الولايات المتحدة'),
(9566, 1076308496, 1076308511, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(9567, 1076308512, 1076308575, 'US', 'USA', 'الولايات المتحدة'),
(9568, 1076308576, 1076308591, 'IL', 'ISR', 'إسرائيل'),
(9569, 1076308592, 1076308671, 'US', 'USA', 'الولايات المتحدة'),
(9570, 1076308672, 1076308687, 'DE', 'DEU', 'ألمانيا'),
(9571, 1076308688, 1076308991, 'US', 'USA', 'الولايات المتحدة'),
(9572, 1076308992, 1076309007, 'IE', 'IRL', 'إيرلندا'),
(9573, 1076309008, 1076309119, 'US', 'USA', 'الولايات المتحدة'),
(9574, 1076309120, 1076309135, 'IE', 'IRL', 'إيرلندا'),
(9575, 1076309136, 1076309151, 'US', 'USA', 'الولايات المتحدة'),
(9576, 1076309152, 1076309183, 'DE', 'DEU', 'ألمانيا'),
(9577, 1076309184, 1076309967, 'US', 'USA', 'الولايات المتحدة'),
(9578, 1076309968, 1076309983, 'DE', 'DEU', 'ألمانيا'),
(9579, 1076309984, 1076310015, 'US', 'USA', 'الولايات المتحدة'),
(9580, 1076310016, 1076310271, 'DE', 'DEU', 'ألمانيا'),
(9581, 1076310272, 1076310303, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(9582, 1076310304, 1076310367, 'US', 'USA', 'الولايات المتحدة'),
(9583, 1076310368, 1076310383, 'IE', 'IRL', 'إيرلندا'),
(9584, 1076310384, 1076310399, 'US', 'USA', 'الولايات المتحدة'),
(9585, 1076310400, 1076310431, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(9586, 1076310432, 1076310463, 'AU', 'AUS', 'أستراليا'),
(9587, 1076310464, 1076310527, 'IL', 'ISR', 'إسرائيل'),
(9588, 1076310528, 1076338687, 'US', 'USA', 'الولايات المتحدة'),
(9589, 1076338688, 1076346879, 'CA', 'CAN', 'كندا'),
(9590, 1076346880, 1076387839, 'US', 'USA', 'الولايات المتحدة'),
(9591, 1076387840, 1076393727, 'CA', 'CAN', 'كندا'),
(9592, 1076393728, 1076394239, 'US', 'USA', 'الولايات المتحدة'),
(9593, 1076394240, 1076396031, 'CA', 'CAN', 'كندا'),
(9594, 1076396032, 1076408319, 'US', 'USA', 'الولايات المتحدة'),
(9595, 1076408320, 1076412415, 'CA', 'CAN', 'كندا'),
(9596, 1076412416, 1076424703, 'US', 'USA', 'الولايات المتحدة'),
(9597, 1076424704, 1076428799, 'CA', 'CAN', 'كندا'),
(9598, 1076428800, 1076493311, 'US', 'USA', 'الولايات المتحدة'),
(9599, 1076493312, 1076493375, 'IN', 'IND', 'الهند'),
(9600, 1076493376, 1076543487, 'US', 'USA', 'الولايات المتحدة'),
(9601, 1076543488, 1076559871, 'CA', 'CAN', 'كندا'),
(9602, 1076559872, 1076628991, 'US', 'USA', 'الولايات المتحدة'),
(9603, 1076628992, 1076629247, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(9604, 1076629248, 1076756479, 'US', 'USA', 'الولايات المتحدة'),
(9605, 1076756480, 1076772863, 'CA', 'CAN', 'كندا'),
(9606, 1076772864, 1076850687, 'US', 'USA', 'الولايات المتحدة'),
(9607, 1076850688, 1076850943, 'CA', 'CAN', 'كندا'),
(9608, 1076850944, 1077055487, 'US', 'USA', 'الولايات المتحدة'),
(9609, 1077055488, 1077059583, 'CA', 'CAN', 'كندا'),
(9610, 1077059584, 1077444607, 'US', 'USA', 'الولايات المتحدة'),
(9611, 1077444608, 1077452799, 'CA', 'CAN', 'كندا'),
(9612, 1077452800, 1077460991, 'JP', 'JPN', 'اليابان'),
(9613, 1077460992, 1077469183, 'US', 'USA', 'الولايات المتحدة'),
(9614, 1077469184, 1077477375, 'CA', 'CAN', 'كندا'),
(9615, 1077477376, 1077506047, 'US', 'USA', 'الولايات المتحدة'),
(9616, 1077510144, 1077561327, 'US', 'USA', 'الولايات المتحدة'),
(9617, 1077561328, 1077561343, 'AR', 'ARG', 'الأرجنتين'),
(9618, 1077561344, 1077565503, 'US', 'USA', 'الولايات المتحدة'),
(9619, 1077565504, 1077565567, 'AR', 'ARG', 'الأرجنتين'),
(9620, 1077565568, 1077641215, 'US', 'USA', 'الولايات المتحدة'),
(9621, 1077641216, 1077657599, 'CA', 'CAN', 'كندا'),
(9622, 1077657600, 1077977087, 'US', 'USA', 'الولايات المتحدة'),
(9623, 1077977088, 1077985279, 'CA', 'CAN', 'كندا'),
(9624, 1077985280, 1077993471, 'US', 'USA', 'الولايات المتحدة'),
(9625, 1077993472, 1078001663, 'CA', 'CAN', 'كندا'),
(9626, 1078001664, 1078067199, 'US', 'USA', 'الولايات المتحدة'),
(9627, 1078067200, 1078071295, 'BS', 'BHS', 'جزر البهاما'),
(9628, 1078071296, 1078075391, 'CA', 'CAN', 'كندا'),
(9629, 1078075392, 1078124543, 'US', 'USA', 'الولايات المتحدة'),
(9630, 1078124544, 1078128639, 'CA', 'CAN', 'كندا'),
(9631, 1078128640, 1078202367, 'US', 'USA', 'الولايات المتحدة'),
(9632, 1078206464, 1078247423, 'US', 'USA', 'الولايات المتحدة'),
(9633, 1078247424, 1078251519, 'CA', 'CAN', 'كندا'),
(9634, 1078251520, 1078282751, 'US', 'USA', 'الولايات المتحدة'),
(9635, 1078282752, 1078283007, 'CA', 'CAN', 'كندا'),
(9636, 1078283008, 1078283015, 'US', 'USA', 'الولايات المتحدة'),
(9637, 1078283016, 1078283023, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(9638, 1078283024, 1078283423, 'US', 'USA', 'الولايات المتحدة'),
(9639, 1078283424, 1078283439, 'CA', 'CAN', 'كندا'),
(9640, 1078283440, 1078283999, 'US', 'USA', 'الولايات المتحدة'),
(9641, 1078284000, 1078284031, 'CA', 'CAN', 'كندا'),
(9642, 1078284032, 1078284367, 'US', 'USA', 'الولايات المتحدة'),
(9643, 1078284368, 1078284383, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(9644, 1078284384, 1078287871, 'US', 'USA', 'الولايات المتحدة'),
(9645, 1078287872, 1078288383, 'CA', 'CAN', 'كندا'),
(9646, 1078288384, 1078336447, 'US', 'USA', 'الولايات المتحدة'),
(9647, 1078336448, 1078336455, 'HK', 'HKG', 'هونغ كونغ'),
(9648, 1078336456, 1078336463, 'US', 'USA', 'الولايات المتحدة'),
(9649, 1078336464, 1078336479, 'HK', 'HKG', 'هونغ كونغ'),
(9650, 1078336480, 1078341807, 'US', 'USA', 'الولايات المتحدة'),
(9651, 1078341808, 1078341823, 'PH', 'PHL', 'الفلبين'),
(9652, 1078341824, 1078349311, 'US', 'USA', 'الولايات المتحدة'),
(9653, 1078349312, 1078349823, 'PH', 'PHL', 'الفلبين'),
(9654, 1078349824, 1078413311, 'US', 'USA', 'الولايات المتحدة'),
(9655, 1078415360, 1078456319, 'US', 'USA', 'الولايات المتحدة'),
(9656, 1078456320, 1078460415, 'CA', 'CAN', 'كندا'),
(9657, 1078460416, 1078517759, 'US', 'USA', 'الولايات المتحدة'),
(9658, 1078517760, 1078525951, 'CA', 'CAN', 'كندا'),
(9659, 1078525952, 1078660799, 'US', 'USA', 'الولايات المتحدة'),
(9660, 1078660800, 1078660831, 'CN', 'CHN', 'الصين'),
(9661, 1078660832, 1078661807, 'US', 'USA', 'الولايات المتحدة'),
(9662, 1078661808, 1078661823, 'IN', 'IND', 'الهند'),
(9663, 1078661824, 1078722559, 'US', 'USA', 'الولايات المتحدة'),
(9664, 1078722560, 1078734847, 'AR', 'ARG', 'الأرجنتين'),
(9665, 1078734848, 1078737919, 'CO', 'COL', 'كولومبيا'),
(9666, 1078737920, 1078738943, 'EC', 'ECU', 'الإكوادور'),
(9667, 1078738944, 1078739455, 'VE', 'VEN', 'فنزويلا'),
(9668, 1078739456, 1078739967, 'US', 'USA', 'الولايات المتحدة'),
(9669, 1078739968, 1078743039, 'PE', 'PER', 'بيرو'),
(9670, 1078743040, 1078746111, 'CO', 'COL', 'كولومبيا'),
(9671, 1078746112, 1078747135, 'PE', 'PER', 'بيرو'),
(9672, 1078747136, 1078749183, 'CL', 'CHL', 'تشيلي'),
(9673, 1078749184, 1078750231, 'PE', 'PER', 'بيرو'),
(9674, 1078750232, 1078750239, 'CA', 'CAN', 'كندا'),
(9675, 1078750240, 1078751231, 'PE', 'PER', 'بيرو'),
(9676, 1078751232, 1078753279, 'CO', 'COL', 'كولومبيا'),
(9677, 1078753280, 1078755327, 'AR', 'ARG', 'الأرجنتين'),
(9678, 1078755328, 1078757375, 'PE', 'PER', 'بيرو'),
(9679, 1078757376, 1078767615, 'CL', 'CHL', 'تشيلي'),
(9680, 1078767616, 1078768639, 'CO', 'COL', 'كولومبيا'),
(9681, 1078768640, 1078769663, 'CL', 'CHL', 'تشيلي'),
(9682, 1078769664, 1078771711, 'CO', 'COL', 'كولومبيا'),
(9683, 1078771712, 1078773759, 'EC', 'ECU', 'الإكوادور'),
(9684, 1078773760, 1078775807, 'PE', 'PER', 'بيرو'),
(9685, 1078775808, 1078777855, 'CO', 'COL', 'كولومبيا'),
(9686, 1078777856, 1078780927, 'EC', 'ECU', 'الإكوادور'),
(9687, 1078780928, 1078895103, 'US', 'USA', 'الولايات المتحدة'),
(9688, 1078895104, 1078895359, 'CN', 'CHN', 'الصين'),
(9689, 1078895360, 1078895967, 'US', 'USA', 'الولايات المتحدة'),
(9690, 1078895968, 1078895983, 'CN', 'CHN', 'الصين'),
(9691, 1078895984, 1078931455, 'US', 'USA', 'الولايات المتحدة'),
(9692, 1078935552, 1079148543, 'US', 'USA', 'الولايات المتحدة'),
(9693, 1079164928, 1079320575, 'US', 'USA', 'الولايات المتحدة'),
(9694, 1079320576, 1079328767, 'CA', 'CAN', 'كندا'),
(9695, 1079328768, 1079329919, 'US', 'USA', 'الولايات المتحدة'),
(9696, 1079329920, 1079329951, 'CA', 'CAN', 'كندا'),
(9697, 1079329952, 1079377919, 'US', 'USA', 'الولايات المتحدة'),
(9698, 1079377920, 1079378943, 'CA', 'CAN', 'كندا'),
(9699, 1079378944, 1079379711, 'US', 'USA', 'الولايات المتحدة'),
(9700, 1079379712, 1079380927, 'CA', 'CAN', 'كندا'),
(9701, 1079380928, 1079380991, 'US', 'USA', 'الولايات المتحدة'),
(9702, 1079380992, 1079381567, 'CA', 'CAN', 'كندا'),
(9703, 1079381568, 1079381599, 'US', 'USA', 'الولايات المتحدة'),
(9704, 1079381600, 1079381631, 'WS', 'WSM', 'ساموا'),
(9705, 1079381632, 1079381759, 'CA', 'CAN', 'كندا'),
(9706, 1079381760, 1079382015, 'US', 'USA', 'الولايات المتحدة'),
(9707, 1079382016, 1079382527, 'CA', 'CAN', 'كندا'),
(9708, 1079382528, 1079383039, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(9709, 1079383040, 1079383295, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(9710, 1079383296, 1079383807, 'US', 'USA', 'الولايات المتحدة'),
(9711, 1079383808, 1079384063, 'MH', 'MHL', 'جزر مارشال'),
(9712, 1079384064, 1079384575, 'CA', 'CAN', 'كندا'),
(9713, 1079384576, 1079385087, 'ZW', 'ZWE', 'زمبابواي'),
(9714, 1079385088, 1079385471, 'CA', 'CAN', 'كندا'),
(9715, 1079385472, 1079385599, 'US', 'USA', 'الولايات المتحدة'),
(9716, 1079385600, 1079385855, 'CA', 'CAN', 'كندا'),
(9717, 1079385856, 1079386111, 'SZ', 'SWZ', 'سوازيلند'),
(9718, 1079386112, 1079386623, 'CA', 'CAN', 'كندا'),
(9719, 1079386624, 1079386879, 'SG', 'SGP', 'سنغافورة'),
(9720, 1079386880, 1079387135, 'EG', 'EGY', 'مصر'),
(9721, 1079387136, 1079387391, 'US', 'USA', 'الولايات المتحدة'),
(9722, 1079387392, 1079387647, 'CA', 'CAN', 'كندا'),
(9723, 1079387648, 1079387903, 'US', 'USA', 'الولايات المتحدة'),
(9724, 1079387904, 1079388159, 'PH', 'PHL', 'الفلبين'),
(9725, 1079388160, 1079389439, 'CA', 'CAN', 'كندا'),
(9726, 1079389440, 1079389567, 'US', 'USA', 'الولايات المتحدة'),
(9727, 1079389568, 1079389695, 'CA', 'CAN', 'كندا'),
(9728, 1079389696, 1079389951, 'US', 'USA', 'الولايات المتحدة'),
(9729, 1079389952, 1079390719, 'CA', 'CAN', 'كندا'),
(9730, 1079390720, 1079390975, 'US', 'USA', 'الولايات المتحدة'),
(9731, 1079390976, 1079391231, 'CA', 'CAN', 'كندا'),
(9732, 1079391232, 1079391487, 'US', 'USA', 'الولايات المتحدة'),
(9733, 1079391488, 1079394063, 'CA', 'CAN', 'كندا'),
(9734, 1079394064, 1079394071, 'SG', 'SGP', 'سنغافورة'),
(9735, 1079394072, 1079394079, 'CA', 'CAN', 'كندا'),
(9736, 1079394080, 1079394111, 'US', 'USA', 'الولايات المتحدة'),
(9737, 1079394112, 1079394143, 'AF', 'AFG', 'أفغانستان'),
(9738, 1079394144, 1079394175, 'CA', 'CAN', 'كندا'),
(9739, 1079394176, 1079394207, 'US', 'USA', 'الولايات المتحدة'),
(9740, 1079394208, 1079394239, 'CA', 'CAN', 'كندا'),
(9741, 1079394240, 1079394303, 'US', 'USA', 'الولايات المتحدة'),
(9742, 1079394304, 1079396351, 'CA', 'CAN', 'كندا'),
(9743, 1079396352, 1079397375, 'MP', 'MNP', 'جزر ماريانا الشمالية'),
(9744, 1079397376, 1079397631, 'MH', 'MHL', 'جزر مارشال'),
(9745, 1079397632, 1079399583, 'CA', 'CAN', 'كندا'),
(9746, 1079399584, 1079399599, 'US', 'USA', 'الولايات المتحدة'),
(9747, 1079399600, 1079400447, 'CA', 'CAN', 'كندا'),
(9748, 1079400448, 1079400511, 'FR', 'FRA', 'فرنسا'),
(9749, 1079400512, 1079400575, 'CA', 'CAN', 'كندا'),
(9750, 1079400576, 1079400639, 'US', 'USA', 'الولايات المتحدة'),
(9751, 1079400640, 1079400767, 'CA', 'CAN', 'كندا'),
(9752, 1079400768, 1079400831, 'US', 'USA', 'الولايات المتحدة'),
(9753, 1079400832, 1079401215, 'CA', 'CAN', 'كندا'),
(9754, 1079401216, 1079401471, 'US', 'USA', 'الولايات المتحدة'),
(9755, 1079401472, 1079403775, 'CA', 'CAN', 'كندا'),
(9756, 1079403776, 1079403807, 'US', 'USA', 'الولايات المتحدة'),
(9757, 1079403808, 1079403903, 'CA', 'CAN', 'كندا'),
(9758, 1079403904, 1079403935, 'US', 'USA', 'الولايات المتحدة'),
(9759, 1079403936, 1079403999, 'CA', 'CAN', 'كندا'),
(9760, 1079404000, 1079404031, 'US', 'USA', 'الولايات المتحدة'),
(9761, 1079404032, 1079404543, 'CA', 'CAN', 'كندا'),
(9762, 1079404544, 1079404799, 'US', 'USA', 'الولايات المتحدة'),
(9763, 1079404800, 1079405023, 'CA', 'CAN', 'كندا'),
(9764, 1079405024, 1079405119, 'US', 'USA', 'الولايات المتحدة'),
(9765, 1079405120, 1079405407, 'CA', 'CAN', 'كندا'),
(9766, 1079405408, 1079405439, 'BD', 'BGD', 'بنغالاديش'),
(9767, 1079405440, 1079405567, 'US', 'USA', 'الولايات المتحدة'),
(9768, 1079405568, 1079407103, 'CA', 'CAN', 'كندا'),
(9769, 1079407104, 1079407359, 'US', 'USA', 'الولايات المتحدة'),
(9770, 1079407360, 1079407615, 'CA', 'CAN', 'كندا'),
(9771, 1079407616, 1079408127, 'US', 'USA', 'الولايات المتحدة'),
(9772, 1079408128, 1079408383, 'CA', 'CAN', 'كندا'),
(9773, 1079408384, 1079408415, 'SA', 'SAU', 'السعودية'),
(9774, 1079408416, 1079408447, 'US', 'USA', 'الولايات المتحدة'),
(9775, 1079408448, 1079408639, 'CA', 'CAN', 'كندا'),
(9776, 1079408640, 1079408895, 'US', 'USA', 'الولايات المتحدة'),
(9777, 1079408896, 1079409407, 'PK', 'PAK', 'باكستان'),
(9778, 1079409408, 1079410687, 'CA', 'CAN', 'كندا'),
(9779, 1079410688, 1079410943, 'US', 'USA', 'الولايات المتحدة'),
(9780, 1079410944, 1079411199, 'CA', 'CAN', 'كندا'),
(9781, 1079411200, 1079411455, 'US', 'USA', 'الولايات المتحدة'),
(9782, 1079411456, 1079411711, 'PK', 'PAK', 'باكستان'),
(9783, 1079411712, 1079413311, 'CA', 'CAN', 'كندا'),
(9784, 1079413312, 1079413343, 'US', 'USA', 'الولايات المتحدة'),
(9785, 1079413344, 1079414783, 'CA', 'CAN', 'كندا'),
(9786, 1079414784, 1079415039, 'US', 'USA', 'الولايات المتحدة'),
(9787, 1079415040, 1079415807, 'CA', 'CAN', 'كندا'),
(9788, 1079415808, 1079416319, 'US', 'USA', 'الولايات المتحدة'),
(9789, 1079416320, 1079421951, 'CA', 'CAN', 'كندا'),
(9790, 1079421952, 1079422207, 'US', 'USA', 'الولايات المتحدة'),
(9791, 1079422208, 1079425023, 'CA', 'CAN', 'كندا'),
(9792, 1079425024, 1079425279, 'US', 'USA', 'الولايات المتحدة'),
(9793, 1079425280, 1079433215, 'CA', 'CAN', 'كندا'),
(9794, 1079433216, 1079435263, 'CR', 'CRI', 'كوستا ريكا'),
(9795, 1079435264, 1079437311, 'CA', 'CAN', 'كندا'),
(9796, 1079437312, 1079439359, 'US', 'USA', 'الولايات المتحدة'),
(9797, 1079439360, 1079443199, 'CA', 'CAN', 'كندا'),
(9798, 1079443200, 1079443231, 'PW', 'PLW', 'بالاو'),
(9799, 1079443232, 1079443327, 'CA', 'CAN', 'كندا'),
(9800, 1079443328, 1079443455, 'AU', 'AUS', 'أستراليا'),
(9801, 1079443456, 1079459839, 'US', 'USA', 'الولايات المتحدة'),
(9802, 1079459840, 1079508991, 'CA', 'CAN', 'كندا'),
(9803, 1079508992, 1079566847, 'US', 'USA', 'الولايات المتحدة'),
(9804, 1079566848, 1079567103, 'GB', 'GBR', 'المملكة المتحدة'),
(9805, 1079567104, 1079567359, 'US', 'USA', 'الولايات المتحدة'),
(9806, 1079567360, 1079567615, 'AU', 'AUS', 'أستراليا'),
(9807, 1079567616, 1079574527, 'US', 'USA', 'الولايات المتحدة'),
(9808, 1079574528, 1079578623, 'PR', 'PRI', 'بورتو ريكو'),
(9809, 1079578624, 1079585391, 'US', 'USA', 'الولايات المتحدة'),
(9810, 1079585392, 1079585407, 'IN', 'IND', 'الهند'),
(9811, 1079585408, 1079623679, 'US', 'USA', 'الولايات المتحدة'),
(9812, 1079627776, 1079664639, 'US', 'USA', 'الولايات المتحدة'),
(9813, 1079664640, 1079668735, 'CA', 'CAN', 'كندا'),
(9814, 1079668736, 1079861247, 'US', 'USA', 'الولايات المتحدة'),
(9815, 1079861248, 1079865343, 'CA', 'CAN', 'كندا'),
(9816, 1079865344, 1080033279, 'US', 'USA', 'الولايات المتحدة'),
(9817, 1080033280, 1080295423, 'CA', 'CAN', 'كندا'),
(9818, 1080295424, 1080950783, 'US', 'USA', 'الولايات المتحدة'),
(9819, 1080957952, 1080983551, 'US', 'USA', 'الولايات المتحدة'),
(9820, 1080986624, 1080999935, 'US', 'USA', 'الولايات المتحدة'),
(9821, 1080999936, 1081016319, 'CA', 'CAN', 'كندا'),
(9822, 1081016320, 1081085951, 'US', 'USA', 'الولايات المتحدة'),
(9823, 1081085952, 1081086207, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(9824, 1081086208, 1081122559, 'US', 'USA', 'الولايات المتحدة'),
(9825, 1081122560, 1081122815, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(9826, 1081122816, 1081212927, 'US', 'USA', 'الولايات المتحدة'),
(9827, 1081212928, 1081278463, 'CA', 'CAN', 'كندا'),
(9828, 1081278464, 1081379327, 'US', 'USA', 'الولايات المتحدة'),
(9829, 1081379328, 1081379839, 'VE', 'VEN', 'فنزويلا'),
(9830, 1081379840, 1081385215, 'US', 'USA', 'الولايات المتحدة'),
(9831, 1081385216, 1081385471, 'PA', 'PAN', 'بنما'),
(9832, 1081385472, 1081387519, 'US', 'USA', 'الولايات المتحدة'),
(9833, 1081387520, 1081388031, 'PA', 'PAN', 'بنما'),
(9834, 1081388032, 1081391103, 'US', 'USA', 'الولايات المتحدة'),
(9835, 1081391104, 1081393151, 'PA', 'PAN', 'بنما'),
(9836, 1081393152, 1081393775, 'US', 'USA', 'الولايات المتحدة'),
(9837, 1081393776, 1081393783, 'CL', 'CHL', 'تشيلي'),
(9838, 1081393784, 1081394175, 'US', 'USA', 'الولايات المتحدة'),
(9839, 1081394176, 1081397247, 'CL', 'CHL', 'تشيلي'),
(9840, 1081397248, 1081397759, 'US', 'USA', 'الولايات المتحدة'),
(9841, 1081397760, 1081398783, 'CL', 'CHL', 'تشيلي'),
(9842, 1081398784, 1081399295, 'US', 'USA', 'الولايات المتحدة'),
(9843, 1081399296, 1081401343, 'CL', 'CHL', 'تشيلي'),
(9844, 1081401344, 1081401415, 'US', 'USA', 'الولايات المتحدة'),
(9845, 1081401416, 1081401423, 'AR', 'ARG', 'الأرجنتين'),
(9846, 1081401424, 1081401855, 'US', 'USA', 'الولايات المتحدة'),
(9847, 1081401856, 1081402367, 'AR', 'ARG', 'الأرجنتين'),
(9848, 1081402368, 1081403615, 'US', 'USA', 'الولايات المتحدة'),
(9849, 1081403616, 1081403631, 'AR', 'ARG', 'الأرجنتين'),
(9850, 1081403632, 1081409791, 'US', 'USA', 'الولايات المتحدة'),
(9851, 1081409792, 1081410047, 'PR', 'PRI', 'بورتو ريكو'),
(9852, 1081410048, 1081410559, 'US', 'USA', 'الولايات المتحدة'),
(9853, 1081410560, 1081411583, 'PR', 'PRI', 'بورتو ريكو'),
(9854, 1081411584, 1081413423, 'US', 'USA', 'الولايات المتحدة'),
(9855, 1081413424, 1081413439, 'PR', 'PRI', 'بورتو ريكو'),
(9856, 1081413440, 1081416191, 'US', 'USA', 'الولايات المتحدة'),
(9857, 1081416192, 1081416447, 'PR', 'PRI', 'بورتو ريكو'),
(9858, 1081416448, 1081420319, 'US', 'USA', 'الولايات المتحدة'),
(9859, 1081420320, 1081420351, 'PR', 'PRI', 'بورتو ريكو'),
(9860, 1081420352, 1081443327, 'US', 'USA', 'الولايات المتحدة'),
(9861, 1081443328, 1081444351, 'CL', 'CHL', 'تشيلي'),
(9862, 1081444352, 1081445375, 'US', 'USA', 'الولايات المتحدة'),
(9863, 1081445376, 1081446399, 'CL', 'CHL', 'تشيلي'),
(9864, 1081446400, 1081460735, 'US', 'USA', 'الولايات المتحدة'),
(9865, 1081460736, 1081462783, 'PA', 'PAN', 'بنما'),
(9866, 1081462784, 1081462815, 'CO', 'COL', 'كولومبيا'),
(9867, 1081462816, 1081462847, 'BR', 'BRA', 'البرازيل'),
(9868, 1081462848, 1081479167, 'US', 'USA', 'الولايات المتحدة'),
(9869, 1081479168, 1081483263, 'CA', 'CAN', 'كندا'),
(9870, 1081483264, 1081565183, 'US', 'USA', 'الولايات المتحدة'),
(9871, 1081565184, 1081573375, 'CA', 'CAN', 'كندا'),
(9872, 1081573376, 1081589759, 'US', 'USA', 'الولايات المتحدة'),
(9873, 1081589760, 1081593855, 'BB', 'BRB', 'باربادوس'),
(9874, 1081593856, 1081597951, 'CA', 'CAN', 'كندا'),
(9875, 1081597952, 1081609823, 'US', 'USA', 'الولايات المتحدة'),
(9876, 1081609824, 1081609831, 'LK', 'LKA', 'سيريلانكا'),
(9877, 1081609832, 1081609887, 'US', 'USA', 'الولايات المتحدة'),
(9878, 1081609888, 1081609919, 'IN', 'IND', 'الهند'),
(9879, 1081609920, 1081611415, 'US', 'USA', 'الولايات المتحدة'),
(9880, 1081611416, 1081611423, 'IN', 'IND', 'الهند'),
(9881, 1081611424, 1081611511, 'US', 'USA', 'الولايات المتحدة'),
(9882, 1081611512, 1081611519, 'IN', 'IND', 'الهند'),
(9883, 1081611520, 1081611815, 'US', 'USA', 'الولايات المتحدة'),
(9884, 1081611816, 1081611823, 'IN', 'IND', 'الهند'),
(9885, 1081611824, 1081611831, 'US', 'USA', 'الولايات المتحدة'),
(9886, 1081611832, 1081611839, 'IN', 'IND', 'الهند'),
(9887, 1081611840, 1081611847, 'US', 'USA', 'الولايات المتحدة'),
(9888, 1081611848, 1081611855, 'IN', 'IND', 'الهند'),
(9889, 1081611856, 1081611903, 'US', 'USA', 'الولايات المتحدة'),
(9890, 1081611904, 1081611911, 'IN', 'IND', 'الهند'),
(9891, 1081611912, 1081611919, 'US', 'USA', 'الولايات المتحدة'),
(9892, 1081611920, 1081611927, 'IN', 'IND', 'الهند'),
(9893, 1081611928, 1081611935, 'LK', 'LKA', 'سيريلانكا'),
(9894, 1081611936, 1081611943, 'IN', 'IND', 'الهند'),
(9895, 1081611944, 1081612015, 'US', 'USA', 'الولايات المتحدة'),
(9896, 1081612016, 1081612023, 'IN', 'IND', 'الهند'),
(9897, 1081612024, 1081612159, 'US', 'USA', 'الولايات المتحدة'),
(9898, 1081612160, 1081612191, 'IN', 'IND', 'الهند'),
(9899, 1081612192, 1081612663, 'US', 'USA', 'الولايات المتحدة'),
(9900, 1081612664, 1081612671, 'IN', 'IND', 'الهند'),
(9901, 1081612672, 1081618951, 'US', 'USA', 'الولايات المتحدة'),
(9902, 1081618952, 1081618959, 'GB', 'GBR', 'المملكة المتحدة'),
(9903, 1081618960, 1081639423, 'US', 'USA', 'الولايات المتحدة'),
(9904, 1081639424, 1081639679, 'DE', 'DEU', 'ألمانيا'),
(9905, 1081639680, 1082314751, 'US', 'USA', 'الولايات المتحدة'),
(9906, 1082314752, 1082315263, 'CA', 'CAN', 'كندا'),
(9907, 1082315264, 1082315471, 'US', 'USA', 'الولايات المتحدة'),
(9908, 1082315472, 1082318847, 'CA', 'CAN', 'كندا'),
(9909, 1082318848, 1082434239, 'US', 'USA', 'الولايات المتحدة'),
(9910, 1082434240, 1082434255, 'IN', 'IND', 'الهند'),
(9911, 1082434256, 1082683391, 'US', 'USA', 'الولايات المتحدة'),
(9912, 1082683392, 1082687487, 'CA', 'CAN', 'كندا'),
(9913, 1082687488, 1082945535, 'US', 'USA', 'الولايات المتحدة'),
(9914, 1082945536, 1082949631, 'CA', 'CAN', 'كندا'),
(9915, 1082949632, 1082982399, 'US', 'USA', 'الولايات المتحدة'),
(9916, 1082982400, 1083015167, 'CA', 'CAN', 'كندا'),
(9917, 1083015168, 1083396095, 'US', 'USA', 'الولايات المتحدة'),
(9918, 1083396096, 1083400191, 'BM', 'BMU', 'برمودا'),
(9919, 1083400192, 1083437055, 'US', 'USA', 'الولايات المتحدة'),
(9920, 1083437056, 1083441151, 'CA', 'CAN', 'كندا'),
(9921, 1083441152, 1083621375, 'US', 'USA', 'الولايات المتحدة'),
(9922, 1083621376, 1083637759, 'BS', 'BHS', 'جزر البهاما'),
(9923, 1083637760, 1083686911, 'US', 'USA', 'الولايات المتحدة'),
(9924, 1083686912, 1083703295, 'CA', 'CAN', 'كندا'),
(9925, 1083703296, 1083738367, 'US', 'USA', 'الولايات المتحدة'),
(9926, 1083738368, 1083738879, 'PR', 'PRI', 'بورتو ريكو'),
(9927, 1083738880, 1084067583, 'US', 'USA', 'الولايات المتحدة'),
(9928, 1084067584, 1084067839, 'CA', 'CAN', 'كندا'),
(9929, 1084067840, 1085439999, 'US', 'USA', 'الولايات المتحدة'),
(9930, 1085440000, 1085448191, 'CA', 'CAN', 'كندا'),
(9931, 1085448192, 1085456383, 'US', 'USA', 'الولايات المتحدة'),
(9932, 1085456384, 1085464575, 'PR', 'PRI', 'بورتو ريكو'),
(9933, 1085464576, 1085526015, 'US', 'USA', 'الولايات المتحدة'),
(9934, 1085526016, 1085530111, 'CA', 'CAN', 'كندا'),
(9935, 1085530112, 1085538303, 'US', 'USA', 'الولايات المتحدة'),
(9936, 1085538304, 1085603839, 'CA', 'CAN', 'كندا'),
(9937, 1085603840, 1085849599, 'US', 'USA', 'الولايات المتحدة'),
(9938, 1085849600, 1085857791, 'CA', 'CAN', 'كندا'),
(9939, 1085857792, 1085915135, 'US', 'USA', 'الولايات المتحدة'),
(9940, 1085915136, 1085923327, 'PR', 'PRI', 'بورتو ريكو'),
(9941, 1085923328, 1085997055, 'US', 'USA', 'الولايات المتحدة'),
(9942, 1085997056, 1086013439, 'CA', 'CAN', 'كندا'),
(9943, 1086013440, 1086022079, 'US', 'USA', 'الولايات المتحدة'),
(9944, 1086022080, 1086022111, 'CA', 'CAN', 'كندا'),
(9945, 1086022112, 1086022175, 'US', 'USA', 'الولايات المتحدة'),
(9946, 1086022176, 1086022207, 'CA', 'CAN', 'كندا'),
(9947, 1086022208, 1086022303, 'US', 'USA', 'الولايات المتحدة'),
(9948, 1086022304, 1086022367, 'CA', 'CAN', 'كندا'),
(9949, 1086022368, 1086022591, 'US', 'USA', 'الولايات المتحدة'),
(9950, 1086022592, 1086022655, 'CA', 'CAN', 'كندا'),
(9951, 1086022656, 1086070783, 'US', 'USA', 'الولايات المتحدة'),
(9952, 1086095360, 1086358143, 'US', 'USA', 'الولايات المتحدة'),
(9953, 1086358144, 1086358271, 'PA', 'PAN', 'بنما'),
(9954, 1086358272, 1086359231, 'US', 'USA', 'الولايات المتحدة'),
(9955, 1086359232, 1086359295, 'IL', 'ISR', 'إسرائيل'),
(9956, 1086359296, 1086421503, 'US', 'USA', 'الولايات المتحدة'),
(9957, 1086421504, 1086422015, 'MP', 'MNP', 'جزر ماريانا الشمالية'),
(9958, 1086422016, 1086476543, 'US', 'USA', 'الولايات المتحدة'),
(9959, 1086476544, 1086476607, 'BM', 'BMU', 'برمودا'),
(9960, 1086476608, 1086922751, 'US', 'USA', 'الولايات المتحدة'),
(9961, 1086922752, 1086930943, 'CA', 'CAN', 'كندا'),
(9962, 1086930944, 1086955519, 'US', 'USA', 'الولايات المتحدة'),
(9963, 1086955520, 1086971903, 'CA', 'CAN', 'كندا'),
(9964, 1086971904, 1087008767, 'US', 'USA', 'الولايات المتحدة'),
(9965, 1087008768, 1087009279, 'CY', 'CYP', 'قبرص'),
(9966, 1087009280, 1087016959, 'US', 'USA', 'الولايات المتحدة'),
(9967, 1087016960, 1087021055, 'CA', 'CAN', 'كندا'),
(9968, 1087021056, 1087419903, 'US', 'USA', 'الولايات المتحدة'),
(9969, 1087419904, 1087420159, 'CA', 'CAN', 'كندا'),
(9970, 1087420160, 1087440895, 'US', 'USA', 'الولايات المتحدة'),
(9971, 1087440896, 1087442943, 'PR', 'PRI', 'بورتو ريكو'),
(9972, 1087442944, 1087444223, 'US', 'USA', 'الولايات المتحدة'),
(9973, 1087444224, 1087444479, 'CY', 'CYP', 'قبرص'),
(9974, 1087444480, 1087495519, 'US', 'USA', 'الولايات المتحدة'),
(9975, 1087495520, 1087495535, 'TW', 'TWN', 'تايوان'),
(9976, 1087495536, 1087496703, 'US', 'USA', 'الولايات المتحدة'),
(9977, 1087496704, 1087496959, 'CA', 'CAN', 'كندا'),
(9978, 1087496960, 1087497855, 'US', 'USA', 'الولايات المتحدة'),
(9979, 1087497856, 1087497887, 'CA', 'CAN', 'كندا'),
(9980, 1087497888, 1087554751, 'US', 'USA', 'الولايات المتحدة'),
(9981, 1087554752, 1087554759, 'IL', 'ISR', 'إسرائيل'),
(9982, 1087554760, 1087557631, 'US', 'USA', 'الولايات المتحدة'),
(9983, 1087557632, 1087557887, 'NO', 'NOR', 'النرويج'),
(9984, 1087557888, 1087686655, 'US', 'USA', 'الولايات المتحدة'),
(9985, 1087686656, 1087686911, 'PR', 'PRI', 'بورتو ريكو'),
(9986, 1087686912, 1087715327, 'US', 'USA', 'الولايات المتحدة'),
(9987, 1087715328, 1087717375, 'PA', 'PAN', 'بنما'),
(9988, 1087717376, 1087758335, 'US', 'USA', 'الولايات المتحدة'),
(9989, 1087758336, 1087766527, 'PR', 'PRI', 'بورتو ريكو'),
(9990, 1087766528, 1087862783, 'US', 'USA', 'الولايات المتحدة'),
(9991, 1087862784, 1087864831, 'PA', 'PAN', 'بنما'),
(9992, 1087864832, 1088684031, 'US', 'USA', 'الولايات المتحدة'),
(9993, 1088684032, 1088946175, 'CA', 'CAN', 'كندا'),
(9994, 1088946176, 1089154915, 'US', 'USA', 'الولايات المتحدة'),
(9995, 1089154916, 1089154932, 'AU', 'AUS', 'أستراليا'),
(9996, 1089154933, 1089167359, 'US', 'USA', 'الولايات المتحدة'),
(9997, 1089167360, 1089171455, 'CA', 'CAN', 'كندا'),
(9998, 1089171456, 1089191935, 'US', 'USA', 'الولايات المتحدة'),
(9999, 1089191936, 1089200127, 'CA', 'CAN', 'كندا'),
(10000, 1089200128, 1089306623, 'US', 'USA', 'الولايات المتحدة'),
(10001, 1089306624, 1089339391, 'PR', 'PRI', 'بورتو ريكو'),
(10002, 1089339392, 1089482927, 'US', 'USA', 'الولايات المتحدة'),
(10003, 1089482928, 1089482935, 'CA', 'CAN', 'كندا'),
(10004, 1089482936, 1089488463, 'US', 'USA', 'الولايات المتحدة'),
(10005, 1089488464, 1089488479, 'JP', 'JPN', 'اليابان'),
(10006, 1089488480, 1089493631, 'US', 'USA', 'الولايات المتحدة'),
(10007, 1089493632, 1089493647, 'CA', 'CAN', 'كندا'),
(10008, 1089493648, 1089503871, 'US', 'USA', 'الولايات المتحدة'),
(10009, 1089503872, 1089503879, 'CA', 'CAN', 'كندا'),
(10010, 1089503880, 1089507159, 'US', 'USA', 'الولايات المتحدة'),
(10011, 1089507160, 1089507167, 'CA', 'CAN', 'كندا'),
(10012, 1089507168, 1089526783, 'US', 'USA', 'الولايات المتحدة'),
(10013, 1089526784, 1089527039, 'VE', 'VEN', 'فنزويلا'),
(10014, 1089527040, 1089552383, 'US', 'USA', 'الولايات المتحدة'),
(10015, 1089552384, 1089552391, 'AU', 'AUS', 'أستراليا'),
(10016, 1089552392, 1089557551, 'US', 'USA', 'الولايات المتحدة'),
(10017, 1089557552, 1089557559, 'CA', 'CAN', 'كندا'),
(10018, 1089557560, 1089568351, 'US', 'USA', 'الولايات المتحدة'),
(10019, 1089568352, 1089568359, 'CA', 'CAN', 'كندا'),
(10020, 1089568360, 1089574319, 'US', 'USA', 'الولايات المتحدة'),
(10021, 1089574320, 1089574327, 'CA', 'CAN', 'كندا'),
(10022, 1089574328, 1089576623, 'US', 'USA', 'الولايات المتحدة'),
(10023, 1089576624, 1089576631, 'CA', 'CAN', 'كندا'),
(10024, 1089576632, 1089579215, 'US', 'USA', 'الولايات المتحدة'),
(10025, 1089579216, 1089579223, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10026, 1089579224, 1089579519, 'US', 'USA', 'الولايات المتحدة'),
(10027, 1089579520, 1089580031, 'VE', 'VEN', 'فنزويلا'),
(10028, 1089580032, 1089581287, 'US', 'USA', 'الولايات المتحدة'),
(10029, 1089581288, 1089581295, 'CA', 'CAN', 'كندا'),
(10030, 1089581296, 1089585919, 'US', 'USA', 'الولايات المتحدة'),
(10031, 1089585920, 1089585951, 'CA', 'CAN', 'كندا'),
(10032, 1089585952, 1089587999, 'US', 'USA', 'الولايات المتحدة'),
(10033, 1089588000, 1089588015, 'IN', 'IND', 'الهند'),
(10034, 1089588016, 1089593615, 'US', 'USA', 'الولايات المتحدة'),
(10035, 1089593616, 1089593623, 'CA', 'CAN', 'كندا'),
(10036, 1089593624, 1089631055, 'US', 'USA', 'الولايات المتحدة'),
(10037, 1089631056, 1089631071, 'CA', 'CAN', 'كندا'),
(10038, 1089631072, 1089644815, 'US', 'USA', 'الولايات المتحدة'),
(10039, 1089644816, 1089644831, 'GB', 'GBR', 'المملكة المتحدة'),
(10040, 1089644832, 1089696063, 'US', 'USA', 'الولايات المتحدة'),
(10041, 1089696064, 1089696071, 'GB', 'GBR', 'المملكة المتحدة'),
(10042, 1089696072, 1089703455, 'US', 'USA', 'الولايات المتحدة'),
(10043, 1089703456, 1089703487, 'CA', 'CAN', 'كندا'),
(10044, 1089703488, 1089721503, 'US', 'USA', 'الولايات المتحدة'),
(10045, 1089721504, 1089721519, 'CA', 'CAN', 'كندا'),
(10046, 1089721520, 1089721727, 'US', 'USA', 'الولايات المتحدة'),
(10047, 1089721728, 1089721791, 'CA', 'CAN', 'كندا'),
(10048, 1089721792, 1089723823, 'US', 'USA', 'الولايات المتحدة'),
(10049, 1089723824, 1089723831, 'CA', 'CAN', 'كندا'),
(10050, 1089723832, 1089961983, 'US', 'USA', 'الولايات المتحدة'),
(10051, 1089961984, 1089970175, 'CA', 'CAN', 'كندا'),
(10052, 1089970176, 1089974271, 'PR', 'PRI', 'بورتو ريكو'),
(10053, 1089974272, 1090138111, 'US', 'USA', 'الولايات المتحدة'),
(10054, 1090142208, 1090146303, 'US', 'USA', 'الولايات المتحدة'),
(10055, 1090146304, 1090150399, 'CA', 'CAN', 'كندا'),
(10056, 1090150400, 1090154495, 'US', 'USA', 'الولايات المتحدة'),
(10057, 1090158592, 1090207743, 'US', 'USA', 'الولايات المتحدة'),
(10058, 1090207744, 1090215935, 'CA', 'CAN', 'كندا'),
(10059, 1090220032, 1090355199, 'US', 'USA', 'الولايات المتحدة'),
(10060, 1090355200, 1090363391, 'CA', 'CAN', 'كندا'),
(10061, 1090363392, 1090387967, 'US', 'USA', 'الولايات المتحدة'),
(10062, 1090387968, 1090391300, 'CA', 'CAN', 'كندا'),
(10063, 1090391301, 1090391302, 'US', 'USA', 'الولايات المتحدة'),
(10064, 1090391303, 1090391359, 'CA', 'CAN', 'كندا'),
(10065, 1090391360, 1090391360, 'US', 'USA', 'الولايات المتحدة'),
(10066, 1090391361, 1090396159, 'CA', 'CAN', 'كندا'),
(10067, 1090396160, 1090424831, 'US', 'USA', 'الولايات المتحدة'),
(10068, 1090424832, 1090428927, 'CA', 'CAN', 'كندا'),
(10069, 1090428928, 1090445311, 'US', 'USA', 'الولايات المتحدة'),
(10070, 1090445312, 1090447359, 'CA', 'CAN', 'كندا'),
(10071, 1090447360, 1090447487, 'US', 'USA', 'الولايات المتحدة'),
(10072, 1090447488, 1090448127, 'CA', 'CAN', 'كندا'),
(10073, 1090448128, 1090448255, 'US', 'USA', 'الولايات المتحدة'),
(10074, 1090448256, 1090453503, 'CA', 'CAN', 'كندا'),
(10075, 1090453504, 1090497903, 'US', 'USA', 'الولايات المتحدة'),
(10076, 1090497904, 1090497919, 'AU', 'AUS', 'أستراليا'),
(10077, 1090497920, 1090499583, 'US', 'USA', 'الولايات المتحدة'),
(10078, 1090499584, 1090499839, 'NO', 'NOR', 'النرويج'),
(10079, 1090499840, 1091797263, 'US', 'USA', 'الولايات المتحدة'),
(10080, 1091797264, 1091797279, 'IT', 'ITA', 'إيطاليا'),
(10081, 1091797280, 1091960831, 'US', 'USA', 'الولايات المتحدة'),
(10082, 1091960832, 1092026367, 'CA', 'CAN', 'كندا'),
(10083, 1092026368, 1092075519, 'US', 'USA', 'الولايات المتحدة'),
(10084, 1092075520, 1092091903, 'PR', 'PRI', 'بورتو ريكو'),
(10085, 1092091904, 1093017599, 'US', 'USA', 'الولايات المتحدة'),
(10086, 1093017600, 1093021695, 'CA', 'CAN', 'كندا'),
(10087, 1093021696, 1093025791, 'US', 'USA', 'الولايات المتحدة'),
(10088, 1093025792, 1093033983, 'CA', 'CAN', 'كندا'),
(10089, 1093033984, 1093058559, 'US', 'USA', 'الولايات المتحدة'),
(10090, 1093058560, 1093059071, 'PR', 'PRI', 'بورتو ريكو'),
(10091, 1093059072, 1093059583, 'US', 'USA', 'الولايات المتحدة'),
(10092, 1093059584, 1093066751, 'PR', 'PRI', 'بورتو ريكو'),
(10093, 1093066752, 1093074943, 'US', 'USA', 'الولايات المتحدة'),
(10094, 1093074944, 1093091327, 'CA', 'CAN', 'كندا'),
(10095, 1093091328, 1093107967, 'US', 'USA', 'الولايات المتحدة'),
(10096, 1093107968, 1093108223, 'CA', 'CAN', 'كندا'),
(10097, 1093108224, 1093108735, 'US', 'USA', 'الولايات المتحدة'),
(10098, 1093108736, 1093109247, 'CA', 'CAN', 'كندا'),
(10099, 1093109248, 1093109503, 'US', 'USA', 'الولايات المتحدة'),
(10100, 1093109504, 1093109759, 'CA', 'CAN', 'كندا'),
(10101, 1093109760, 1093110015, 'US', 'USA', 'الولايات المتحدة'),
(10102, 1093110016, 1093110271, 'CA', 'CAN', 'كندا'),
(10103, 1093110272, 1093111295, 'US', 'USA', 'الولايات المتحدة'),
(10104, 1093111296, 1093111551, 'CA', 'CAN', 'كندا'),
(10105, 1093111552, 1093111959, 'US', 'USA', 'الولايات المتحدة'),
(10106, 1093111960, 1093111967, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10107, 1093111968, 1093112063, 'US', 'USA', 'الولايات المتحدة'),
(10108, 1093112064, 1093112319, 'CA', 'CAN', 'كندا'),
(10109, 1093112320, 1093114687, 'US', 'USA', 'الولايات المتحدة'),
(10110, 1093114688, 1093114703, 'CA', 'CAN', 'كندا'),
(10111, 1093114704, 1093114711, 'US', 'USA', 'الولايات المتحدة'),
(10112, 1093114712, 1093114719, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10113, 1093114720, 1093114751, 'CA', 'CAN', 'كندا'),
(10114, 1093114752, 1093114879, 'US', 'USA', 'الولايات المتحدة'),
(10115, 1093114880, 1093115647, 'CA', 'CAN', 'كندا'),
(10116, 1093115648, 1093115903, 'US', 'USA', 'الولايات المتحدة'),
(10117, 1093115904, 1093116415, 'CA', 'CAN', 'كندا'),
(10118, 1093116416, 1093117631, 'US', 'USA', 'الولايات المتحدة'),
(10119, 1093117632, 1093117647, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10120, 1093117648, 1093117951, 'US', 'USA', 'الولايات المتحدة'),
(10121, 1093117952, 1093118207, 'CA', 'CAN', 'كندا'),
(10122, 1093118208, 1093119999, 'US', 'USA', 'الولايات المتحدة'),
(10123, 1093120000, 1093120255, 'CA', 'CAN', 'كندا'),
(10124, 1093120256, 1093120399, 'US', 'USA', 'الولايات المتحدة'),
(10125, 1093120400, 1093120415, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10126, 1093120416, 1093120511, 'US', 'USA', 'الولايات المتحدة'),
(10127, 1093120512, 1093120767, 'GB', 'GBR', 'المملكة المتحدة'),
(10128, 1093120768, 1093122735, 'US', 'USA', 'الولايات المتحدة'),
(10129, 1093122736, 1093122751, 'CA', 'CAN', 'كندا'),
(10130, 1093122752, 1093123071, 'US', 'USA', 'الولايات المتحدة'),
(10131, 1093123072, 1093123583, 'CA', 'CAN', 'كندا'),
(10132, 1093123584, 1093123983, 'US', 'USA', 'الولايات المتحدة'),
(10133, 1093123984, 1093123999, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10134, 1093124000, 1093124607, 'US', 'USA', 'الولايات المتحدة'),
(10135, 1093124608, 1093124863, 'CA', 'CAN', 'كندا'),
(10136, 1093124864, 1093126143, 'US', 'USA', 'الولايات المتحدة'),
(10137, 1093126144, 1093126399, 'CA', 'CAN', 'كندا'),
(10138, 1093126400, 1093126431, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10139, 1093126432, 1093126911, 'US', 'USA', 'الولايات المتحدة'),
(10140, 1093126912, 1093127167, 'CA', 'CAN', 'كندا'),
(10141, 1093127168, 1093130751, 'US', 'USA', 'الولايات المتحدة'),
(10142, 1093130752, 1093131007, 'CA', 'CAN', 'كندا'),
(10143, 1093131008, 1093131231, 'US', 'USA', 'الولايات المتحدة'),
(10144, 1093131232, 1093131247, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10145, 1093131248, 1093133695, 'US', 'USA', 'الولايات المتحدة'),
(10146, 1093133696, 1093133823, 'CA', 'CAN', 'كندا'),
(10147, 1093133824, 1093135359, 'US', 'USA', 'الولايات المتحدة'),
(10148, 1093135360, 1093135615, 'CA', 'CAN', 'كندا'),
(10149, 1093135616, 1093139663, 'US', 'USA', 'الولايات المتحدة'),
(10150, 1093139664, 1093139679, 'CA', 'CAN', 'كندا'),
(10151, 1093139680, 1093139711, 'US', 'USA', 'الولايات المتحدة'),
(10152, 1093139712, 1093140223, 'CA', 'CAN', 'كندا'),
(10153, 1093140224, 1093697535, 'US', 'USA', 'الولايات المتحدة'),
(10154, 1093697536, 1093699071, 'BB', 'BRB', 'باربادوس'),
(10155, 1093699072, 1093700607, 'GD', 'GRD', 'غرينادا'),
(10156, 1093700608, 1093701631, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(10157, 1093701632, 1093708287, 'BB', 'BRB', 'باربادوس'),
(10158, 1093708288, 1093709311, 'LC', 'LCA', 'سانت لوسيا'),
(10159, 1093709312, 1093716479, 'BB', 'BRB', 'باربادوس'),
(10160, 1093716480, 1093717759, 'GD', 'GRD', 'غرينادا'),
(10161, 1093717760, 1093719807, 'BB', 'BRB', 'باربادوس'),
(10162, 1093719808, 1093720319, 'LC', 'LCA', 'سانت لوسيا'),
(10163, 1093720320, 1093721343, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(10164, 1093721344, 1093723391, 'BB', 'BRB', 'باربادوس'),
(10165, 1093723392, 1093723647, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(10166, 1093723648, 1093724415, 'BB', 'BRB', 'باربادوس'),
(10167, 1093724416, 1093725183, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(10168, 1093725184, 1093730303, 'BB', 'BRB', 'باربادوس'),
(10169, 1093730304, 1093730559, 'US', 'USA', 'الولايات المتحدة'),
(10170, 1093730560, 1093730815, 'HK', 'HKG', 'هونغ كونغ'),
(10171, 1093730816, 1093844991, 'US', 'USA', 'الولايات المتحدة'),
(10172, 1093861376, 1094565887, 'US', 'USA', 'الولايات المتحدة'),
(10173, 1094565888, 1094582271, 'CA', 'CAN', 'كندا'),
(10174, 1094582272, 1095450623, 'US', 'USA', 'الولايات المتحدة'),
(10175, 1095450624, 1095467007, 'BS', 'BHS', 'جزر البهاما'),
(10176, 1095467008, 1095627775, 'US', 'USA', 'الولايات المتحدة'),
(10177, 1095627776, 1095628287, 'CA', 'CAN', 'كندا'),
(10178, 1095628288, 1096278015, 'US', 'USA', 'الولايات المتحدة'),
(10179, 1096278016, 1096286207, 'CA', 'CAN', 'كندا'),
(10180, 1096286208, 1096548351, 'US', 'USA', 'الولايات المتحدة'),
(10181, 1096548352, 1096810495, 'CA', 'CAN', 'كندا'),
(10182, 1096810496, 1096884223, 'US', 'USA', 'الولايات المتحدة'),
(10183, 1096884224, 1096888319, 'CA', 'CAN', 'كندا'),
(10184, 1096888320, 1096925183, 'US', 'USA', 'الولايات المتحدة'),
(10185, 1096925184, 1096941567, 'CA', 'CAN', 'كندا'),
(10186, 1096941568, 1096950551, 'US', 'USA', 'الولايات المتحدة'),
(10187, 1096950552, 1096950559, 'CA', 'CAN', 'كندا'),
(10188, 1096950560, 1096952455, 'US', 'USA', 'الولايات المتحدة'),
(10189, 1096952456, 1096952463, 'GB', 'GBR', 'المملكة المتحدة'),
(10190, 1096952464, 1096952519, 'US', 'USA', 'الولايات المتحدة'),
(10191, 1096952520, 1096952527, 'GB', 'GBR', 'المملكة المتحدة'),
(10192, 1096952528, 1096956463, 'US', 'USA', 'الولايات المتحدة'),
(10193, 1096956464, 1096956471, 'GB', 'GBR', 'المملكة المتحدة'),
(10194, 1096956472, 1096956631, 'US', 'USA', 'الولايات المتحدة'),
(10195, 1096956632, 1096956639, 'GB', 'GBR', 'المملكة المتحدة'),
(10196, 1096956640, 1096957247, 'US', 'USA', 'الولايات المتحدة'),
(10197, 1096957248, 1096957255, 'CA', 'CAN', 'كندا'),
(10198, 1096957256, 1096959599, 'US', 'USA', 'الولايات المتحدة'),
(10199, 1096959600, 1096959607, 'GB', 'GBR', 'المملكة المتحدة'),
(10200, 1096959608, 1096960767, 'US', 'USA', 'الولايات المتحدة'),
(10201, 1096960768, 1096960895, 'GB', 'GBR', 'المملكة المتحدة'),
(10202, 1096960896, 1096961023, 'US', 'USA', 'الولايات المتحدة'),
(10203, 1096961024, 1096961151, 'GB', 'GBR', 'المملكة المتحدة'),
(10204, 1096961152, 1096968127, 'US', 'USA', 'الولايات المتحدة'),
(10205, 1096968128, 1096968159, 'CA', 'CAN', 'كندا'),
(10206, 1096968160, 1096968191, 'US', 'USA', 'الولايات المتحدة'),
(10207, 1096968192, 1096968319, 'GB', 'GBR', 'المملكة المتحدة'),
(10208, 1096968320, 1096968447, 'US', 'USA', 'الولايات المتحدة'),
(10209, 1096968448, 1096968575, 'GB', 'GBR', 'المملكة المتحدة'),
(10210, 1096968576, 1097058303, 'US', 'USA', 'الولايات المتحدة'),
(10211, 1097058304, 1097058367, 'IT', 'ITA', 'إيطاليا'),
(10212, 1097058368, 1097063663, 'US', 'USA', 'الولايات المتحدة'),
(10213, 1097063664, 1097063679, 'IT', 'ITA', 'إيطاليا'),
(10214, 1097063680, 1097065151, 'US', 'USA', 'الولايات المتحدة'),
(10215, 1097065152, 1097065167, 'CA', 'CAN', 'كندا'),
(10216, 1097065168, 1097067519, 'US', 'USA', 'الولايات المتحدة'),
(10217, 1097067520, 1097068031, 'GB', 'GBR', 'المملكة المتحدة'),
(10218, 1097068032, 1097069055, 'US', 'USA', 'الولايات المتحدة'),
(10219, 1097069056, 1097069311, 'CA', 'CAN', 'كندا'),
(10220, 1097069312, 1097727999, 'US', 'USA', 'الولايات المتحدة'),
(10221, 1097728000, 1097736191, 'CA', 'CAN', 'كندا'),
(10222, 1097736192, 1097768959, 'US', 'USA', 'الولايات المتحدة'),
(10223, 1097768960, 1097777151, 'CA', 'CAN', 'كندا'),
(10224, 1097777152, 1097800959, 'US', 'USA', 'الولايات المتحدة'),
(10225, 1097800960, 1097800991, 'CY', 'CYP', 'قبرص'),
(10226, 1097800992, 1097830399, 'US', 'USA', 'الولايات المتحدة'),
(10227, 1097830400, 1097834495, 'CA', 'CAN', 'كندا'),
(10228, 1097834496, 1097896191, 'US', 'USA', 'الولايات المتحدة'),
(10229, 1097896192, 1097897215, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10230, 1097897216, 1097947135, 'US', 'USA', 'الولايات المتحدة'),
(10231, 1097947136, 1097949183, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10232, 1097949184, 1097951231, 'US', 'USA', 'الولايات المتحدة'),
(10233, 1097951232, 1097953279, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10234, 1097953280, 1098057375, 'US', 'USA', 'الولايات المتحدة'),
(10235, 1098057376, 1098057407, 'CA', 'CAN', 'كندا'),
(10236, 1098057408, 1098188047, 'US', 'USA', 'الولايات المتحدة'),
(10237, 1098188048, 1098188055, 'CA', 'CAN', 'كندا'),
(10238, 1098188056, 1098353967, 'US', 'USA', 'الولايات المتحدة'),
(10239, 1098353968, 1098353983, 'CA', 'CAN', 'كندا'),
(10240, 1098353984, 1098382143, 'US', 'USA', 'الولايات المتحدة'),
(10241, 1098382144, 1098382175, 'CA', 'CAN', 'كندا'),
(10242, 1098382176, 1098891599, 'US', 'USA', 'الولايات المتحدة'),
(10243, 1098891600, 1098891607, 'AU', 'AUS', 'أستراليا'),
(10244, 1098891608, 1098891623, 'US', 'USA', 'الولايات المتحدة'),
(10245, 1098891624, 1098891631, 'AU', 'AUS', 'أستراليا'),
(10246, 1098891632, 1098891695, 'US', 'USA', 'الولايات المتحدة'),
(10247, 1098891696, 1098891711, 'AU', 'AUS', 'أستراليا'),
(10248, 1098891712, 1098891743, 'US', 'USA', 'الولايات المتحدة'),
(10249, 1098891744, 1098891775, 'AU', 'AUS', 'أستراليا'),
(10250, 1098891776, 1098891871, 'US', 'USA', 'الولايات المتحدة'),
(10251, 1098891872, 1098891887, 'AU', 'AUS', 'أستراليا'),
(10252, 1098891888, 1098891951, 'US', 'USA', 'الولايات المتحدة'),
(10253, 1098891952, 1098891999, 'AU', 'AUS', 'أستراليا'),
(10254, 1098892000, 1098892015, 'US', 'USA', 'الولايات المتحدة'),
(10255, 1098892016, 1098892031, 'AU', 'AUS', 'أستراليا'),
(10256, 1098892032, 1101041279, 'US', 'USA', 'الولايات المتحدة'),
(10257, 1101041280, 1101041407, 'IN', 'IND', 'الهند'),
(10258, 1101041408, 1101078455, 'US', 'USA', 'الولايات المتحدة'),
(10259, 1101078456, 1101078463, 'CA', 'CAN', 'كندا'),
(10260, 1101078464, 1101113135, 'US', 'USA', 'الولايات المتحدة'),
(10261, 1101113136, 1101113143, 'CA', 'CAN', 'كندا'),
(10262, 1101113144, 1101118239, 'US', 'USA', 'الولايات المتحدة'),
(10263, 1101118240, 1101118271, 'GB', 'GBR', 'المملكة المتحدة'),
(10264, 1101118272, 1101121535, 'US', 'USA', 'الولايات المتحدة'),
(10265, 1101121536, 1101121791, 'EC', 'ECU', 'الإكوادور'),
(10266, 1101121792, 1101190655, 'US', 'USA', 'الولايات المتحدة'),
(10267, 1101190656, 1101191167, 'EC', 'ECU', 'الإكوادور'),
(10268, 1101191168, 1101224959, 'US', 'USA', 'الولايات المتحدة'),
(10269, 1101224960, 1101225215, 'EC', 'ECU', 'الإكوادور'),
(10270, 1101225216, 1101267711, 'US', 'USA', 'الولايات المتحدة'),
(10271, 1101267712, 1101267967, 'CA', 'CAN', 'كندا'),
(10272, 1101267968, 1101304063, 'US', 'USA', 'الولايات المتحدة'),
(10273, 1101304064, 1101304319, 'EC', 'ECU', 'الإكوادور'),
(10274, 1101304320, 1101304831, 'US', 'USA', 'الولايات المتحدة'),
(10275, 1101304832, 1101305855, 'HN', 'HND', 'هندوراس'),
(10276, 1101305856, 1101339887, 'US', 'USA', 'الولايات المتحدة'),
(10277, 1101339888, 1101339903, 'CA', 'CAN', 'كندا'),
(10278, 1101339904, 1101352959, 'US', 'USA', 'الولايات المتحدة'),
(10279, 1101352960, 1101355007, 'HN', 'HND', 'هندوراس'),
(10280, 1101355008, 1101357215, 'US', 'USA', 'الولايات المتحدة'),
(10281, 1101357216, 1101357223, 'SE', 'SWE', 'السويد'),
(10282, 1101357224, 1101384415, 'US', 'USA', 'الولايات المتحدة'),
(10283, 1101384416, 1101384447, 'CA', 'CAN', 'كندا'),
(10284, 1101384448, 1101385855, 'US', 'USA', 'الولايات المتحدة'),
(10285, 1101385856, 1101385919, 'DK', 'DNK', 'الدنيمارك'),
(10286, 1101385920, 1101425919, 'US', 'USA', 'الولايات المتحدة'),
(10287, 1101425920, 1101426175, 'EC', 'ECU', 'الإكوادور'),
(10288, 1101426176, 1101431679, 'US', 'USA', 'الولايات المتحدة'),
(10289, 1101431680, 1101431807, 'AU', 'AUS', 'أستراليا'),
(10290, 1101431808, 1101445775, 'US', 'USA', 'الولايات المتحدة'),
(10291, 1101445776, 1101445791, 'CA', 'CAN', 'كندا'),
(10292, 1101445792, 1101461759, 'US', 'USA', 'الولايات المتحدة'),
(10293, 1101461760, 1101462015, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(10294, 1101462016, 1101492623, 'US', 'USA', 'الولايات المتحدة'),
(10295, 1101492624, 1101492639, 'BE', 'BEL', 'بلجيكا'),
(10296, 1101492640, 1101523039, 'US', 'USA', 'الولايات المتحدة'),
(10297, 1101523040, 1101523071, 'GB', 'GBR', 'المملكة المتحدة'),
(10298, 1101523072, 1101542399, 'US', 'USA', 'الولايات المتحدة'),
(10299, 1101542400, 1101542911, 'CO', 'COL', 'كولومبيا'),
(10300, 1101542912, 1101574655, 'US', 'USA', 'الولايات المتحدة'),
(10301, 1101574656, 1101575167, 'EC', 'ECU', 'الإكوادور'),
(10302, 1101575168, 1101617679, 'US', 'USA', 'الولايات المتحدة'),
(10303, 1101617680, 1101617687, 'CA', 'CAN', 'كندا'),
(10304, 1101617688, 1101619247, 'US', 'USA', 'الولايات المتحدة'),
(10305, 1101619248, 1101619255, 'NL', 'NLD', 'هولندا'),
(10306, 1101619256, 1101625343, 'US', 'USA', 'الولايات المتحدة'),
(10307, 1101625344, 1101625407, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10308, 1101625408, 1101635327, 'US', 'USA', 'الولايات المتحدة'),
(10309, 1101635328, 1101635583, 'HN', 'HND', 'هندوراس'),
(10310, 1101635584, 1101650431, 'US', 'USA', 'الولايات المتحدة'),
(10311, 1101650432, 1101650943, 'HN', 'HND', 'هندوراس'),
(10312, 1101650944, 1101668095, 'US', 'USA', 'الولايات المتحدة'),
(10313, 1101668096, 1101668351, 'EC', 'ECU', 'الإكوادور'),
(10314, 1101668352, 1101676135, 'US', 'USA', 'الولايات المتحدة'),
(10315, 1101676136, 1101676143, 'CA', 'CAN', 'كندا'),
(10316, 1101676144, 1101676543, 'US', 'USA', 'الولايات المتحدة'),
(10317, 1101676544, 1101678591, 'EC', 'ECU', 'الإكوادور'),
(10318, 1101678592, 1101681407, 'US', 'USA', 'الولايات المتحدة'),
(10319, 1101681408, 1101681663, 'NL', 'NLD', 'هولندا'),
(10320, 1101681664, 1101685383, 'US', 'USA', 'الولايات المتحدة'),
(10321, 1101685384, 1101685391, 'NL', 'NLD', 'هولندا'),
(10322, 1101685392, 1101726407, 'US', 'USA', 'الولايات المتحدة'),
(10323, 1101726408, 1101726415, 'CA', 'CAN', 'كندا'),
(10324, 1101726416, 1101732199, 'US', 'USA', 'الولايات المتحدة'),
(10325, 1101732200, 1101732207, 'CH', 'CHE', 'سويسرا'),
(10326, 1101732208, 1101750783, 'US', 'USA', 'الولايات المتحدة'),
(10327, 1101750784, 1101751295, 'BM', 'BMU', 'برمودا'),
(10328, 1101751296, 1101837311, 'US', 'USA', 'الولايات المتحدة'),
(10329, 1101837312, 1101837567, 'EC', 'ECU', 'الإكوادور'),
(10330, 1101837568, 1101856767, 'US', 'USA', 'الولايات المتحدة'),
(10331, 1101856768, 1101856775, 'DK', 'DNK', 'الدنيمارك'),
(10332, 1101856776, 1101857295, 'US', 'USA', 'الولايات المتحدة'),
(10333, 1101857296, 1101857311, 'CA', 'CAN', 'كندا'),
(10334, 1101857312, 1101864223, 'US', 'USA', 'الولايات المتحدة'),
(10335, 1101864224, 1101864255, 'BE', 'BEL', 'بلجيكا'),
(10336, 1101864256, 1101869055, 'US', 'USA', 'الولايات المتحدة'),
(10337, 1101869056, 1101869567, 'GH', 'GHA', 'غانا'),
(10338, 1101869568, 1101871103, 'US', 'USA', 'الولايات المتحدة'),
(10339, 1101871104, 1101873151, 'BO', 'BOL', 'بوليفيا'),
(10340, 1101873152, 1101881935, 'US', 'USA', 'الولايات المتحدة'),
(10341, 1101881936, 1101881951, 'GB', 'GBR', 'المملكة المتحدة'),
(10342, 1101881952, 1101905407, 'US', 'USA', 'الولايات المتحدة'),
(10343, 1101905408, 1101905663, 'GH', 'GHA', 'غانا'),
(10344, 1101905664, 1101921407, 'US', 'USA', 'الولايات المتحدة'),
(10345, 1101921408, 1101921471, 'BA', 'BIH', 'البوسنه والهرسك'),
(10346, 1101921472, 1101952439, 'US', 'USA', 'الولايات المتحدة'),
(10347, 1101952440, 1101952447, 'CA', 'CAN', 'كندا'),
(10348, 1101952448, 1101971071, 'US', 'USA', 'الولايات المتحدة'),
(10349, 1101971072, 1101971079, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10350, 1101971080, 1102389247, 'US', 'USA', 'الولايات المتحدة'),
(10351, 1102389248, 1102393343, 'CA', 'CAN', 'كندا'),
(10352, 1102393344, 1102446591, 'US', 'USA', 'الولايات المتحدة'),
(10353, 1102446592, 1102448383, 'HN', 'HND', 'هندوراس'),
(10354, 1102448384, 1102449151, 'US', 'USA', 'الولايات المتحدة'),
(10355, 1102449152, 1102449407, 'SV', 'SLV', 'السلفادور'),
(10356, 1102449408, 1102454527, 'CR', 'CRI', 'كوستا ريكا'),
(10357, 1102454528, 1102454783, 'HN', 'HND', 'هندوراس'),
(10358, 1102454784, 1102512127, 'US', 'USA', 'الولايات المتحدة'),
(10359, 1102512128, 1102516223, 'JM', 'JAM', 'جامايكا'),
(10360, 1102516224, 1103244799, 'US', 'USA', 'الولايات المتحدة'),
(10361, 1103244800, 1103245055, 'EC', 'ECU', 'الإكوادور'),
(10362, 1103245056, 1103474943, 'US', 'USA', 'الولايات المتحدة'),
(10363, 1103474944, 1103475199, 'MH', 'MHL', 'جزر مارشال'),
(10364, 1103475200, 1103603711, 'US', 'USA', 'الولايات المتحدة'),
(10365, 1103603712, 1103605759, 'EC', 'ECU', 'الإكوادور'),
(10366, 1103605760, 1103623167, 'US', 'USA', 'الولايات المتحدة'),
(10367, 1103623168, 1103623679, 'CO', 'COL', 'كولومبيا'),
(10368, 1103623680, 1103930879, 'US', 'USA', 'الولايات المتحدة'),
(10369, 1103930880, 1103931135, 'MX', 'MEX', 'المكسيك'),
(10370, 1103931136, 1103987967, 'US', 'USA', 'الولايات المتحدة'),
(10371, 1103987968, 1103988223, 'BR', 'BRA', 'البرازيل'),
(10372, 1103988224, 1103996927, 'US', 'USA', 'الولايات المتحدة'),
(10373, 1103996928, 1103997439, 'EC', 'ECU', 'الإكوادور'),
(10374, 1103997440, 1104166911, 'US', 'USA', 'الولايات المتحدة'),
(10375, 1104166912, 1104168959, 'CO', 'COL', 'كولومبيا'),
(10376, 1104168960, 1104399071, 'US', 'USA', 'الولايات المتحدة'),
(10377, 1104399072, 1104399079, 'CA', 'CAN', 'كندا'),
(10378, 1104399080, 1104492287, 'US', 'USA', 'الولايات المتحدة'),
(10379, 1104492288, 1104492543, 'PH', 'PHL', 'الفلبين'),
(10380, 1104492544, 1104510975, 'US', 'USA', 'الولايات المتحدة'),
(10381, 1104510976, 1104511743, 'EC', 'ECU', 'الإكوادور'),
(10382, 1104511744, 1105099519, 'US', 'USA', 'الولايات المتحدة'),
(10383, 1105099520, 1105099775, 'EC', 'ECU', 'الإكوادور'),
(10384, 1105099776, 1106320175, 'US', 'USA', 'الولايات المتحدة'),
(10385, 1106320176, 1106320183, 'CA', 'CAN', 'كندا'),
(10386, 1106320184, 1106469695, 'US', 'USA', 'الولايات المتحدة'),
(10387, 1106469696, 1106469759, 'CO', 'COL', 'كولومبيا'),
(10388, 1106469760, 1106469887, 'US', 'USA', 'الولايات المتحدة'),
(10389, 1106469888, 1106470911, 'BS', 'BHS', 'جزر البهاما'),
(10390, 1106470912, 1106475007, 'US', 'USA', 'الولايات المتحدة'),
(10391, 1106475008, 1106475519, 'CO', 'COL', 'كولومبيا'),
(10392, 1106475520, 1106758655, 'US', 'USA', 'الولايات المتحدة'),
(10393, 1106758656, 1106759167, 'EC', 'ECU', 'الإكوادور'),
(10394, 1106759168, 1106759679, 'CO', 'COL', 'كولومبيا'),
(10395, 1106759680, 1106767871, 'US', 'USA', 'الولايات المتحدة'),
(10396, 1106767872, 1106768383, 'CO', 'COL', 'كولومبيا'),
(10397, 1106768384, 1106768895, 'EC', 'ECU', 'الإكوادور'),
(10398, 1106768896, 1106769919, 'CO', 'COL', 'كولومبيا'),
(10399, 1106769920, 1106814719, 'US', 'USA', 'الولايات المتحدة'),
(10400, 1106814720, 1106814975, 'EC', 'ECU', 'الإكوادور'),
(10401, 1106814976, 1107243007, 'US', 'USA', 'الولايات المتحدة'),
(10402, 1107243008, 1107247103, 'TC', 'TCA', 'جزر تركس وكايكوس'),
(10403, 1107247104, 1107275775, 'US', 'USA', 'الولايات المتحدة'),
(10404, 1107275776, 1107279871, 'CA', 'CAN', 'كندا'),
(10405, 1107279872, 1107288063, 'US', 'USA', 'الولايات المتحدة'),
(10406, 1107288064, 1107296255, 'CA', 'CAN', 'كندا'),
(10407, 1107296256, 1107697663, 'US', 'USA', 'الولايات المتحدة'),
(10408, 1107701760, 1107705855, 'CA', 'CAN', 'كندا'),
(10409, 1107705856, 1107820543, 'US', 'USA', 'الولايات المتحدة'),
(10410, 1107853312, 1108025343, 'US', 'USA', 'الولايات المتحدة'),
(10411, 1108025344, 1108029439, 'CA', 'CAN', 'كندا'),
(10412, 1108029440, 1108033535, 'US', 'USA', 'الولايات المتحدة'),
(10413, 1108033536, 1108041727, 'CA', 'CAN', 'كندا'),
(10414, 1108041728, 1108054015, 'US', 'USA', 'الولايات المتحدة'),
(10415, 1108054016, 1108066303, 'CA', 'CAN', 'كندا'),
(10416, 1108066304, 1108492287, 'US', 'USA', 'الولايات المتحدة'),
(10417, 1108500480, 1108525055, 'US', 'USA', 'الولايات المتحدة'),
(10418, 1108525056, 1108541439, 'CA', 'CAN', 'كندا'),
(10419, 1108541440, 1108852735, 'US', 'USA', 'الولايات المتحدة'),
(10420, 1108865024, 1109639199, 'US', 'USA', 'الولايات المتحدة'),
(10421, 1109639200, 1109639215, 'IN', 'IND', 'الهند'),
(10422, 1109639216, 1109641663, 'US', 'USA', 'الولايات المتحدة'),
(10423, 1109641664, 1109641679, 'JP', 'JPN', 'اليابان'),
(10424, 1109641680, 1109642367, 'US', 'USA', 'الولايات المتحدة'),
(10425, 1109642368, 1109642383, 'IL', 'ISR', 'إسرائيل'),
(10426, 1109642384, 1109642415, 'US', 'USA', 'الولايات المتحدة'),
(10427, 1109642416, 1109642431, 'IL', 'ISR', 'إسرائيل'),
(10428, 1109642432, 1109642583, 'US', 'USA', 'الولايات المتحدة'),
(10429, 1109642584, 1109642591, 'DE', 'DEU', 'ألمانيا'),
(10430, 1109642592, 1109643303, 'US', 'USA', 'الولايات المتحدة'),
(10431, 1109643304, 1109643311, 'DE', 'DEU', 'ألمانيا'),
(10432, 1109643312, 1109643519, 'US', 'USA', 'الولايات المتحدة'),
(10433, 1109643520, 1109643551, 'CA', 'CAN', 'كندا'),
(10434, 1109643552, 1109647231, 'US', 'USA', 'الولايات المتحدة'),
(10435, 1109647232, 1109647247, 'AU', 'AUS', 'أستراليا'),
(10436, 1109647248, 1109648319, 'US', 'USA', 'الولايات المتحدة'),
(10437, 1109648320, 1109648335, 'JP', 'JPN', 'اليابان'),
(10438, 1109648336, 1109648927, 'US', 'USA', 'الولايات المتحدة'),
(10439, 1109648928, 1109648943, 'AU', 'AUS', 'أستراليا'),
(10440, 1109648944, 1109650639, 'US', 'USA', 'الولايات المتحدة'),
(10441, 1109650640, 1109650655, 'AU', 'AUS', 'أستراليا'),
(10442, 1109650656, 1109688319, 'US', 'USA', 'الولايات المتحدة'),
(10443, 1109688320, 1109696511, 'CA', 'CAN', 'كندا'),
(10444, 1109696512, 1109705727, 'US', 'USA', 'الولايات المتحدة'),
(10445, 1109705728, 1109705743, 'CG', 'COG', 'الكونغو'),
(10446, 1109705744, 1109705759, 'US', 'USA', 'الولايات المتحدة'),
(10447, 1109705760, 1109705791, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(10448, 1109705792, 1109705823, 'US', 'USA', 'الولايات المتحدة'),
(10449, 1109705824, 1109705839, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(10450, 1109705840, 1109705855, 'US', 'USA', 'الولايات المتحدة'),
(10451, 1109705856, 1109705983, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(10452, 1109705984, 1109707007, 'US', 'USA', 'الولايات المتحدة'),
(10453, 1109707008, 1109707263, 'JM', 'JAM', 'جامايكا'),
(10454, 1109707264, 1109707519, 'US', 'USA', 'الولايات المتحدة'),
(10455, 1109707520, 1109707775, 'MW', 'MWI', 'ملاوي'),
(10456, 1109707776, 1109708639, 'US', 'USA', 'الولايات المتحدة'),
(10457, 1109708640, 1109708671, 'HT', 'HTI', 'هايتي'),
(10458, 1109708672, 1109709823, 'US', 'USA', 'الولايات المتحدة'),
(10459, 1109709824, 1109710847, 'ZM', 'ZMB', 'زامبيا'),
(10460, 1109710848, 1109711175, 'US', 'USA', 'الولايات المتحدة'),
(10461, 1109711176, 1109711183, 'HT', 'HTI', 'هايتي'),
(10462, 1109711184, 1109738495, 'US', 'USA', 'الولايات المتحدة'),
(10463, 1109738496, 1109738623, 'VA', 'VAT', 'دولة الفاتيكان'),
(10464, 1109738624, 1109774175, 'US', 'USA', 'الولايات المتحدة'),
(10465, 1109774176, 1109774183, 'CA', 'CAN', 'كندا'),
(10466, 1109774184, 1109776575, 'US', 'USA', 'الولايات المتحدة'),
(10467, 1109776576, 1109776607, 'CN', 'CHN', 'الصين'),
(10468, 1109776608, 1109776615, 'CA', 'CAN', 'كندا'),
(10469, 1109776616, 1109819391, 'US', 'USA', 'الولايات المتحدة'),
(10470, 1109819392, 1109852159, 'CA', 'CAN', 'كندا'),
(10471, 1109852160, 1109902415, 'US', 'USA', 'الولايات المتحدة'),
(10472, 1109902416, 1109902431, 'CY', 'CYP', 'قبرص'),
(10473, 1109902432, 1109902511, 'US', 'USA', 'الولايات المتحدة'),
(10474, 1109902512, 1109902527, 'CY', 'CYP', 'قبرص'),
(10475, 1109902528, 1109927167, 'US', 'USA', 'الولايات المتحدة'),
(10476, 1109927168, 1109927423, 'AU', 'AUS', 'أستراليا'),
(10477, 1109927424, 1110126591, 'US', 'USA', 'الولايات المتحدة'),
(10478, 1110126592, 1110130687, 'CA', 'CAN', 'كندا'),
(10479, 1110130688, 1110307903, 'US', 'USA', 'الولايات المتحدة'),
(10480, 1110307904, 1110307967, 'AU', 'AUS', 'أستراليا'),
(10481, 1110307968, 1110310911, 'US', 'USA', 'الولايات المتحدة'),
(10482, 1110310912, 1110376447, 'CA', 'CAN', 'كندا'),
(10483, 1110376448, 1110445311, 'US', 'USA', 'الولايات المتحدة'),
(10484, 1110445312, 1110446591, 'CA', 'CAN', 'كندا'),
(10485, 1110446592, 1110449151, 'US', 'USA', 'الولايات المتحدة'),
(10486, 1110449152, 1110449663, 'CA', 'CAN', 'كندا'),
(10487, 1110449664, 1110450687, 'US', 'USA', 'الولايات المتحدة'),
(10488, 1110450688, 1110450943, 'CA', 'CAN', 'كندا'),
(10489, 1110450944, 1110452223, 'US', 'USA', 'الولايات المتحدة'),
(10490, 1110452224, 1110453247, 'CA', 'CAN', 'كندا'),
(10491, 1110453248, 1110454271, 'US', 'USA', 'الولايات المتحدة'),
(10492, 1110454272, 1110455295, 'CA', 'CAN', 'كندا'),
(10493, 1110455296, 1110459551, 'US', 'USA', 'الولايات المتحدة'),
(10494, 1110459552, 1110459583, 'CA', 'CAN', 'كندا'),
(10495, 1110459584, 1110461759, 'US', 'USA', 'الولايات المتحدة'),
(10496, 1110461760, 1110461823, 'CA', 'CAN', 'كندا'),
(10497, 1110461824, 1110462463, 'US', 'USA', 'الولايات المتحدة'),
(10498, 1110462464, 1110462719, 'CA', 'CAN', 'كندا'),
(10499, 1110462720, 1110472447, 'US', 'USA', 'الولايات المتحدة'),
(10500, 1110472448, 1110472703, 'CA', 'CAN', 'كندا'),
(10501, 1110472704, 1110540287, 'US', 'USA', 'الولايات المتحدة'),
(10502, 1110540288, 1110573055, 'CA', 'CAN', 'كندا'),
(10503, 1110573056, 1110638591, 'PR', 'PRI', 'بورتو ريكو'),
(10504, 1110638592, 1110663167, 'US', 'USA', 'الولايات المتحدة'),
(10505, 1110663168, 1110675455, 'CA', 'CAN', 'كندا'),
(10506, 1110675456, 1110679551, 'US', 'USA', 'الولايات المتحدة'),
(10507, 1110679552, 1110683647, 'CA', 'CAN', 'كندا'),
(10508, 1110683648, 1110700031, 'US', 'USA', 'الولايات المتحدة'),
(10509, 1110700032, 1110704127, 'CA', 'CAN', 'كندا'),
(10510, 1110704128, 1110863871, 'US', 'USA', 'الولايات المتحدة'),
(10511, 1110863872, 1110867967, 'JM', 'JAM', 'جامايكا'),
(10512, 1110867968, 1110921215, 'US', 'USA', 'الولايات المتحدة'),
(10513, 1110925312, 1110929407, 'US', 'USA', 'الولايات المتحدة'),
(10514, 1110929408, 1110933503, 'BM', 'BMU', 'برمودا'),
(10515, 1110933504, 1111195647, 'US', 'USA', 'الولايات المتحدة'),
(10516, 1111195648, 1111212031, 'CA', 'CAN', 'كندا'),
(10517, 1111212032, 1111228415, 'US', 'USA', 'الولايات المتحدة'),
(10518, 1111228416, 1111244799, 'AR', 'ARG', 'الأرجنتين'),
(10519, 1111244800, 1112432639, 'US', 'USA', 'الولايات المتحدة'),
(10520, 1112432640, 1112440831, 'CA', 'CAN', 'كندا'),
(10521, 1112440832, 1112530943, 'US', 'USA', 'الولايات المتحدة'),
(10522, 1112530944, 1112539135, 'CA', 'CAN', 'كندا'),
(10523, 1112539136, 1113212479, 'US', 'USA', 'الولايات المتحدة'),
(10524, 1113212480, 1113212495, 'CA', 'CAN', 'كندا'),
(10525, 1113212496, 1113591807, 'US', 'USA', 'الولايات المتحدة'),
(10526, 1113591808, 1113595903, 'CA', 'CAN', 'كندا'),
(10527, 1113595904, 1113596159, 'CL', 'CHL', 'تشيلي'),
(10528, 1113596160, 1113602047, 'US', 'USA', 'الولايات المتحدة'),
(10529, 1113602048, 1113603071, 'VE', 'VEN', 'فنزويلا'),
(10530, 1113603072, 1113657343, 'US', 'USA', 'الولايات المتحدة'),
(10531, 1113657344, 1113661439, 'CA', 'CAN', 'كندا'),
(10532, 1113661440, 1113696575, 'US', 'USA', 'الولايات المتحدة'),
(10533, 1113696576, 1113696639, 'CA', 'CAN', 'كندا'),
(10534, 1113696640, 1113696831, 'US', 'USA', 'الولايات المتحدة'),
(10535, 1113696832, 1113696895, 'CA', 'CAN', 'كندا'),
(10536, 1113696896, 1113718783, 'US', 'USA', 'الولايات المتحدة'),
(10537, 1113718784, 1113743359, 'DO', 'DOM', 'الدومينيكان'),
(10538, 1113743360, 1113854207, 'US', 'USA', 'الولايات المتحدة'),
(10539, 1113854208, 1113854463, 'CA', 'CAN', 'كندا'),
(10540, 1113854464, 1113857023, 'US', 'USA', 'الولايات المتحدة'),
(10541, 1113857024, 1113857031, 'CA', 'CAN', 'كندا'),
(10542, 1113857032, 1113862247, 'US', 'USA', 'الولايات المتحدة'),
(10543, 1113862248, 1113862255, 'MX', 'MEX', 'المكسيك'),
(10544, 1113862256, 1113864735, 'US', 'USA', 'الولايات المتحدة'),
(10545, 1113864736, 1113864743, 'BR', 'BRA', 'البرازيل'),
(10546, 1113864744, 1113864767, 'US', 'USA', 'الولايات المتحدة'),
(10547, 1113864768, 1113864783, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10548, 1113864784, 1113881871, 'US', 'USA', 'الولايات المتحدة'),
(10549, 1113881872, 1113881879, 'GB', 'GBR', 'المملكة المتحدة'),
(10550, 1113881880, 1113882351, 'US', 'USA', 'الولايات المتحدة'),
(10551, 1113882352, 1113882359, 'CA', 'CAN', 'كندا'),
(10552, 1113882360, 1113888599, 'US', 'USA', 'الولايات المتحدة'),
(10553, 1113888600, 1113888607, 'CA', 'CAN', 'كندا'),
(10554, 1113888608, 1113903295, 'US', 'USA', 'الولايات المتحدة'),
(10555, 1113903296, 1113903359, 'CA', 'CAN', 'كندا'),
(10556, 1113903360, 1113905791, 'US', 'USA', 'الولايات المتحدة'),
(10557, 1113905792, 1113905807, 'CA', 'CAN', 'كندا'),
(10558, 1113905808, 1113916831, 'US', 'USA', 'الولايات المتحدة'),
(10559, 1113916832, 1113916839, 'GB', 'GBR', 'المملكة المتحدة'),
(10560, 1113916840, 1113919383, 'US', 'USA', 'الولايات المتحدة'),
(10561, 1113919384, 1113919391, 'CA', 'CAN', 'كندا'),
(10562, 1113919392, 1113923839, 'US', 'USA', 'الولايات المتحدة'),
(10563, 1113923840, 1113923903, 'BR', 'BRA', 'البرازيل'),
(10564, 1113923904, 1113932815, 'US', 'USA', 'الولايات المتحدة'),
(10565, 1113932816, 1113932823, 'CA', 'CAN', 'كندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(10566, 1113932824, 1113997311, 'US', 'USA', 'الولايات المتحدة'),
(10567, 1113997312, 1114005503, 'CA', 'CAN', 'كندا'),
(10568, 1114005504, 1114054655, 'US', 'USA', 'الولايات المتحدة'),
(10569, 1114054656, 1114062847, 'CA', 'CAN', 'كندا'),
(10570, 1114062848, 1114095615, 'US', 'USA', 'الولايات المتحدة'),
(10571, 1114095616, 1114103807, 'CA', 'CAN', 'كندا'),
(10572, 1114103808, 1114170095, 'US', 'USA', 'الولايات المتحدة'),
(10573, 1114170096, 1114170111, 'CA', 'CAN', 'كندا'),
(10574, 1114170112, 1114505215, 'US', 'USA', 'الولايات المتحدة'),
(10575, 1114505216, 1114507263, 'CA', 'CAN', 'كندا'),
(10576, 1114507264, 1114507295, 'US', 'USA', 'الولايات المتحدة'),
(10577, 1114507296, 1114507423, 'CA', 'CAN', 'كندا'),
(10578, 1114507424, 1114507431, 'GB', 'GBR', 'المملكة المتحدة'),
(10579, 1114507432, 1114511359, 'CA', 'CAN', 'كندا'),
(10580, 1114511360, 1114511871, 'US', 'USA', 'الولايات المتحدة'),
(10581, 1114511872, 1114513407, 'CA', 'CAN', 'كندا'),
(10582, 1114513408, 1114515455, 'SA', 'SAU', 'السعودية'),
(10583, 1114515456, 1114517503, 'GU', 'GUM', 'غوام'),
(10584, 1114517504, 1114524159, 'CA', 'CAN', 'كندا'),
(10585, 1114524160, 1114524671, 'SA', 'SAU', 'السعودية'),
(10586, 1114524672, 1114533375, 'CA', 'CAN', 'كندا'),
(10587, 1114533376, 1114533887, 'SA', 'SAU', 'السعودية'),
(10588, 1114533888, 1114550271, 'CA', 'CAN', 'كندا'),
(10589, 1114554368, 1114681343, 'US', 'USA', 'الولايات المتحدة'),
(10590, 1114681344, 1114685439, 'CA', 'CAN', 'كندا'),
(10591, 1114685440, 1114730495, 'US', 'USA', 'الولايات المتحدة'),
(10592, 1114730496, 1114734591, 'CA', 'CAN', 'كندا'),
(10593, 1114734592, 1114877183, 'US', 'USA', 'الولايات المتحدة'),
(10594, 1114877184, 1114877439, 'CY', 'CYP', 'قبرص'),
(10595, 1114877440, 1114877951, 'US', 'USA', 'الولايات المتحدة'),
(10596, 1114877952, 1114878207, 'PA', 'PAN', 'بنما'),
(10597, 1114878208, 1114878849, 'US', 'USA', 'الولايات المتحدة'),
(10598, 1114878850, 1114878977, 'LT', 'LTU', 'ليتوانيا'),
(10599, 1114878978, 1115104511, 'US', 'USA', 'الولايات المتحدة'),
(10600, 1115104512, 1115104639, 'CA', 'CAN', 'كندا'),
(10601, 1115104640, 1115113471, 'US', 'USA', 'الولايات المتحدة'),
(10602, 1115113472, 1115114495, 'HN', 'HND', 'هندوراس'),
(10603, 1115114496, 1115114751, 'MX', 'MEX', 'المكسيك'),
(10604, 1115114752, 1115115007, 'GT', 'GTM', 'غواتيمالا'),
(10605, 1115115008, 1115115519, 'US', 'USA', 'الولايات المتحدة'),
(10606, 1115115520, 1115116543, 'HN', 'HND', 'هندوراس'),
(10607, 1115116544, 1115117055, 'US', 'USA', 'الولايات المتحدة'),
(10608, 1115117056, 1115117311, 'GB', 'GBR', 'المملكة المتحدة'),
(10609, 1115117312, 1115117567, 'US', 'USA', 'الولايات المتحدة'),
(10610, 1115117568, 1115118591, 'HN', 'HND', 'هندوراس'),
(10611, 1115118592, 1115119615, 'SV', 'SLV', 'السلفادور'),
(10612, 1115119616, 1115127807, 'US', 'USA', 'الولايات المتحدة'),
(10613, 1115131904, 1115135999, 'US', 'USA', 'الولايات المتحدة'),
(10614, 1115136000, 1115144191, 'CA', 'CAN', 'كندا'),
(10615, 1115144192, 1115693055, 'US', 'USA', 'الولايات المتحدة'),
(10616, 1115697152, 1115705343, 'US', 'USA', 'الولايات المتحدة'),
(10617, 1115705344, 1115709439, 'CA', 'CAN', 'كندا'),
(10618, 1115709440, 1115783167, 'US', 'USA', 'الولايات المتحدة'),
(10619, 1115783168, 1115791359, 'CA', 'CAN', 'كندا'),
(10620, 1115791360, 1115795455, 'PR', 'PRI', 'بورتو ريكو'),
(10621, 1115795456, 1115799551, 'CA', 'CAN', 'كندا'),
(10622, 1115799552, 1115815935, 'US', 'USA', 'الولايات المتحدة'),
(10623, 1115815936, 1115947007, 'CA', 'CAN', 'كندا'),
(10624, 1115947008, 1116168191, 'US', 'USA', 'الولايات المتحدة'),
(10625, 1116168192, 1116176383, 'CA', 'CAN', 'كندا'),
(10626, 1116176384, 1116897279, 'US', 'USA', 'الولايات المتحدة'),
(10627, 1116897280, 1116905471, 'CA', 'CAN', 'كندا'),
(10628, 1116905472, 1117274111, 'US', 'USA', 'الولايات المتحدة'),
(10629, 1117274112, 1117282303, 'CA', 'CAN', 'كندا'),
(10630, 1117282304, 1117413375, 'US', 'USA', 'الولايات المتحدة'),
(10631, 1117413376, 1117415423, 'CA', 'CAN', 'كندا'),
(10632, 1117415424, 1117416191, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(10633, 1117416192, 1117418655, 'CA', 'CAN', 'كندا'),
(10634, 1117418656, 1117418671, 'US', 'USA', 'الولايات المتحدة'),
(10635, 1117418672, 1117419775, 'CA', 'CAN', 'كندا'),
(10636, 1117419776, 1117420031, 'US', 'USA', 'الولايات المتحدة'),
(10637, 1117420032, 1117421567, 'CA', 'CAN', 'كندا'),
(10638, 1117421568, 1117683711, 'US', 'USA', 'الولايات المتحدة'),
(10639, 1117683712, 1117691903, 'CA', 'CAN', 'كندا'),
(10640, 1117691904, 1117724671, 'US', 'USA', 'الولايات المتحدة'),
(10641, 1117724672, 1117728767, 'CA', 'CAN', 'كندا'),
(10642, 1117728768, 1117745151, 'US', 'USA', 'الولايات المتحدة'),
(10643, 1117745152, 1117749247, 'CA', 'CAN', 'كندا'),
(10644, 1117749248, 1117978623, 'US', 'USA', 'الولايات المتحدة'),
(10645, 1117978624, 1117986815, 'CA', 'CAN', 'كندا'),
(10646, 1117986816, 1117995007, 'US', 'USA', 'الولايات المتحدة'),
(10647, 1117995008, 1117999103, 'CA', 'CAN', 'كندا'),
(10648, 1117999104, 1118027775, 'US', 'USA', 'الولايات المتحدة'),
(10649, 1118027776, 1118031871, 'CA', 'CAN', 'كندا'),
(10650, 1118031872, 1118158847, 'US', 'USA', 'الولايات المتحدة'),
(10651, 1118158848, 1118167039, 'CA', 'CAN', 'كندا'),
(10652, 1118167040, 1118474239, 'US', 'USA', 'الولايات المتحدة'),
(10653, 1118474240, 1118478335, 'CA', 'CAN', 'كندا'),
(10654, 1118478336, 1118483455, 'US', 'USA', 'الولايات المتحدة'),
(10655, 1118486528, 1118796543, 'US', 'USA', 'الولايات المتحدة'),
(10656, 1118796544, 1118796799, 'CY', 'CYP', 'قبرص'),
(10657, 1118796800, 1118824447, 'US', 'USA', 'الولايات المتحدة'),
(10658, 1118826496, 1118962839, 'US', 'USA', 'الولايات المتحدة'),
(10659, 1118962840, 1118962847, 'NI', 'NIC', 'نيكاراغوا'),
(10660, 1118962848, 1118962943, 'US', 'USA', 'الولايات المتحدة'),
(10661, 1118962944, 1118963199, 'TR', 'TUR', 'تركيا'),
(10662, 1118963200, 1118963455, 'US', 'USA', 'الولايات المتحدة'),
(10663, 1118963456, 1118963463, 'TZ', 'TZA', 'تانزانيا'),
(10664, 1118963464, 1118963471, 'US', 'USA', 'الولايات المتحدة'),
(10665, 1118963472, 1118963479, 'NG', 'NGA', 'نيجيريا'),
(10666, 1118963480, 1118963487, 'GB', 'GBR', 'المملكة المتحدة'),
(10667, 1118963488, 1118963495, 'AO', 'AGO', 'أنغولا'),
(10668, 1118963496, 1118963583, 'US', 'USA', 'الولايات المتحدة'),
(10669, 1118963584, 1118963647, 'KE', 'KEN', 'كينيا'),
(10670, 1118963648, 1118964863, 'US', 'USA', 'الولايات المتحدة'),
(10671, 1118964864, 1118964879, 'LB', 'LBN', 'لبنان'),
(10672, 1118964880, 1118964991, 'US', 'USA', 'الولايات المتحدة'),
(10673, 1118964992, 1118965503, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(10674, 1118965504, 1118965839, 'US', 'USA', 'الولايات المتحدة'),
(10675, 1118965840, 1118965847, 'EC', 'ECU', 'الإكوادور'),
(10676, 1118965848, 1118965903, 'US', 'USA', 'الولايات المتحدة'),
(10677, 1118965904, 1118965911, 'NG', 'NGA', 'نيجيريا'),
(10678, 1118965912, 1118965919, 'MA', 'MAR', 'المغرب'),
(10679, 1118965920, 1118965991, 'US', 'USA', 'الولايات المتحدة'),
(10680, 1118965992, 1118966007, 'NG', 'NGA', 'نيجيريا'),
(10681, 1118966008, 1118966039, 'US', 'USA', 'الولايات المتحدة'),
(10682, 1118966040, 1118966063, 'EC', 'ECU', 'الإكوادور'),
(10683, 1118966064, 1118966079, 'US', 'USA', 'الولايات المتحدة'),
(10684, 1118966080, 1118966087, 'NG', 'NGA', 'نيجيريا'),
(10685, 1118966088, 1118966111, 'US', 'USA', 'الولايات المتحدة'),
(10686, 1118966112, 1118966119, 'SV', 'SLV', 'السلفادور'),
(10687, 1118966120, 1118966143, 'VE', 'VEN', 'فنزويلا'),
(10688, 1118966144, 1118966151, 'BB', 'BRB', 'باربادوس'),
(10689, 1118966152, 1118966215, 'US', 'USA', 'الولايات المتحدة'),
(10690, 1118966216, 1118966223, 'EC', 'ECU', 'الإكوادور'),
(10691, 1118966224, 1118966271, 'US', 'USA', 'الولايات المتحدة'),
(10692, 1118966272, 1118966351, 'SV', 'SLV', 'السلفادور'),
(10693, 1118966352, 1118966367, 'US', 'USA', 'الولايات المتحدة'),
(10694, 1118966368, 1118966399, 'SV', 'SLV', 'السلفادور'),
(10695, 1118966400, 1118966407, 'US', 'USA', 'الولايات المتحدة'),
(10696, 1118966408, 1118966415, 'SV', 'SLV', 'السلفادور'),
(10697, 1118966416, 1118966655, 'US', 'USA', 'الولايات المتحدة'),
(10698, 1118966656, 1118966687, 'SV', 'SLV', 'السلفادور'),
(10699, 1118966688, 1118966719, 'US', 'USA', 'الولايات المتحدة'),
(10700, 1118966720, 1118966783, 'EC', 'ECU', 'الإكوادور'),
(10701, 1118966784, 1118966847, 'US', 'USA', 'الولايات المتحدة'),
(10702, 1118966848, 1118966911, 'PY', 'PRY', 'باراغواي'),
(10703, 1118966912, 1118966959, 'US', 'USA', 'الولايات المتحدة'),
(10704, 1118966960, 1118966975, 'SA', 'SAU', 'السعودية'),
(10705, 1118966976, 1118967391, 'US', 'USA', 'الولايات المتحدة'),
(10706, 1118967392, 1118967399, 'MA', 'MAR', 'المغرب'),
(10707, 1118967400, 1118967559, 'US', 'USA', 'الولايات المتحدة'),
(10708, 1118967560, 1118967567, 'LB', 'LBN', 'لبنان'),
(10709, 1118967568, 1118967799, 'US', 'USA', 'الولايات المتحدة'),
(10710, 1118967800, 1118967807, 'RW', 'RWA', 'رواندا'),
(10711, 1118967808, 1118968175, 'US', 'USA', 'الولايات المتحدة'),
(10712, 1118968176, 1118968183, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(10713, 1118968184, 1118968207, 'US', 'USA', 'الولايات المتحدة'),
(10714, 1118968208, 1118968223, 'IQ', 'IRQ', 'العراق'),
(10715, 1118968224, 1118968255, 'US', 'USA', 'الولايات المتحدة'),
(10716, 1118968256, 1118968287, 'IQ', 'IRQ', 'العراق'),
(10717, 1118968288, 1118968295, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(10718, 1118968296, 1118968303, 'US', 'USA', 'الولايات المتحدة'),
(10719, 1118968304, 1118968319, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(10720, 1118968320, 1118968575, 'SR', 'SUR', 'سورينام'),
(10721, 1118968576, 1118969471, 'US', 'USA', 'الولايات المتحدة'),
(10722, 1118969472, 1118969599, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(10723, 1118969600, 1118969727, 'GY', 'GUY', 'غيانا'),
(10724, 1118969728, 1118969855, 'US', 'USA', 'الولايات المتحدة'),
(10725, 1118969856, 1118970111, 'LB', 'LBN', 'لبنان'),
(10726, 1118970112, 1118970119, 'KE', 'KEN', 'كينيا'),
(10727, 1118970120, 1118970239, 'US', 'USA', 'الولايات المتحدة'),
(10728, 1118970240, 1118970367, 'NG', 'NGA', 'نيجيريا'),
(10729, 1118970368, 1118970623, 'GY', 'GUY', 'غيانا'),
(10730, 1118970624, 1118970751, 'US', 'USA', 'الولايات المتحدة'),
(10731, 1118970752, 1118970879, 'GY', 'GUY', 'غيانا'),
(10732, 1118970880, 1118971520, 'SR', 'SUR', 'سورينام'),
(10733, 1118971521, 1118971647, 'US', 'USA', 'الولايات المتحدة'),
(10734, 1118971648, 1118971903, 'GY', 'GUY', 'غيانا'),
(10735, 1118971904, 1118972159, 'CA', 'CAN', 'كندا'),
(10736, 1118972160, 1118972415, 'VE', 'VEN', 'فنزويلا'),
(10737, 1118972416, 1118972671, 'EC', 'ECU', 'الإكوادور'),
(10738, 1118972672, 1118972943, 'US', 'USA', 'الولايات المتحدة'),
(10739, 1118972944, 1118972959, 'VE', 'VEN', 'فنزويلا'),
(10740, 1118972960, 1118972999, 'US', 'USA', 'الولايات المتحدة'),
(10741, 1118973000, 1118973007, 'SV', 'SLV', 'السلفادور'),
(10742, 1118973008, 1118973063, 'US', 'USA', 'الولايات المتحدة'),
(10743, 1118973064, 1118973071, 'EC', 'ECU', 'الإكوادور'),
(10744, 1118973072, 1118973079, 'SV', 'SLV', 'السلفادور'),
(10745, 1118973080, 1118973111, 'VE', 'VEN', 'فنزويلا'),
(10746, 1118973112, 1118973119, 'SV', 'SLV', 'السلفادور'),
(10747, 1118973120, 1118973183, 'US', 'USA', 'الولايات المتحدة'),
(10748, 1118973184, 1118973439, 'VE', 'VEN', 'فنزويلا'),
(10749, 1118973440, 1118973695, 'GY', 'GUY', 'غيانا'),
(10750, 1118973696, 1118973951, 'LB', 'LBN', 'لبنان'),
(10751, 1118973952, 1118974015, 'GY', 'GUY', 'غيانا'),
(10752, 1118974016, 1118974047, 'US', 'USA', 'الولايات المتحدة'),
(10753, 1118974048, 1118974055, 'SV', 'SLV', 'السلفادور'),
(10754, 1118974056, 1118974095, 'US', 'USA', 'الولايات المتحدة'),
(10755, 1118974096, 1118974103, 'EC', 'ECU', 'الإكوادور'),
(10756, 1118974104, 1118974111, 'SV', 'SLV', 'السلفادور'),
(10757, 1118974112, 1118974135, 'US', 'USA', 'الولايات المتحدة'),
(10758, 1118974136, 1118974207, 'EC', 'ECU', 'الإكوادور'),
(10759, 1118974208, 1118975231, 'US', 'USA', 'الولايات المتحدة'),
(10760, 1118975232, 1118975487, 'NI', 'NIC', 'نيكاراغوا'),
(10761, 1118975488, 1118975743, 'KE', 'KEN', 'كينيا'),
(10762, 1118975744, 1118975999, 'US', 'USA', 'الولايات المتحدة'),
(10763, 1118976000, 1118976255, 'GB', 'GBR', 'المملكة المتحدة'),
(10764, 1118976256, 1118976511, 'US', 'USA', 'الولايات المتحدة'),
(10765, 1118976512, 1118976575, 'NG', 'NGA', 'نيجيريا'),
(10766, 1118976576, 1118976599, 'US', 'USA', 'الولايات المتحدة'),
(10767, 1118976600, 1118976607, 'NI', 'NIC', 'نيكاراغوا'),
(10768, 1118976608, 1118976687, 'US', 'USA', 'الولايات المتحدة'),
(10769, 1118976688, 1118976695, 'NG', 'NGA', 'نيجيريا'),
(10770, 1118976696, 1118976703, 'NI', 'NIC', 'نيكاراغوا'),
(10771, 1118976704, 1118976727, 'US', 'USA', 'الولايات المتحدة'),
(10772, 1118976728, 1118976735, 'NI', 'NIC', 'نيكاراغوا'),
(10773, 1118976736, 1118976767, 'US', 'USA', 'الولايات المتحدة'),
(10774, 1118976768, 1118976791, 'NI', 'NIC', 'نيكاراغوا'),
(10775, 1118976792, 1118976831, 'US', 'USA', 'الولايات المتحدة'),
(10776, 1118976832, 1118976863, 'NI', 'NIC', 'نيكاراغوا'),
(10777, 1118976864, 1118976895, 'US', 'USA', 'الولايات المتحدة'),
(10778, 1118976896, 1118977023, 'NI', 'NIC', 'نيكاراغوا'),
(10779, 1118977024, 1118977311, 'US', 'USA', 'الولايات المتحدة'),
(10780, 1118977312, 1118977343, 'LB', 'LBN', 'لبنان'),
(10781, 1118977344, 1118977351, 'KE', 'KEN', 'كينيا'),
(10782, 1118977352, 1118977631, 'US', 'USA', 'الولايات المتحدة'),
(10783, 1118977632, 1118977663, 'LB', 'LBN', 'لبنان'),
(10784, 1118977664, 1118978447, 'US', 'USA', 'الولايات المتحدة'),
(10785, 1118978448, 1118978463, 'LB', 'LBN', 'لبنان'),
(10786, 1118978464, 1118979311, 'US', 'USA', 'الولايات المتحدة'),
(10787, 1118979312, 1118979319, 'LB', 'LBN', 'لبنان'),
(10788, 1118979320, 1118979455, 'US', 'USA', 'الولايات المتحدة'),
(10789, 1118979456, 1118979471, 'LB', 'LBN', 'لبنان'),
(10790, 1118979472, 1118979495, 'US', 'USA', 'الولايات المتحدة'),
(10791, 1118979496, 1118979503, 'LB', 'LBN', 'لبنان'),
(10792, 1118979504, 1118979535, 'US', 'USA', 'الولايات المتحدة'),
(10793, 1118979536, 1118979551, 'LB', 'LBN', 'لبنان'),
(10794, 1118979552, 1118979567, 'US', 'USA', 'الولايات المتحدة'),
(10795, 1118979568, 1118979575, 'LB', 'LBN', 'لبنان'),
(10796, 1118979576, 1118979711, 'US', 'USA', 'الولايات المتحدة'),
(10797, 1118979712, 1118979775, 'LB', 'LBN', 'لبنان'),
(10798, 1118979776, 1118980095, 'US', 'USA', 'الولايات المتحدة'),
(10799, 1118980096, 1118980351, 'NG', 'NGA', 'نيجيريا'),
(10800, 1118980352, 1118980607, 'US', 'USA', 'الولايات المتحدة'),
(10801, 1118980608, 1118980863, 'TZ', 'TZA', 'تانزانيا'),
(10802, 1118980864, 1118981119, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(10803, 1118981120, 1118981375, 'US', 'USA', 'الولايات المتحدة'),
(10804, 1118981376, 1118981631, 'IQ', 'IRQ', 'العراق'),
(10805, 1118981632, 1118981687, 'EC', 'ECU', 'الإكوادور'),
(10806, 1118981688, 1118981695, 'US', 'USA', 'الولايات المتحدة'),
(10807, 1118981696, 1118981735, 'SV', 'SLV', 'السلفادور'),
(10808, 1118981736, 1118981743, 'EC', 'ECU', 'الإكوادور'),
(10809, 1118981744, 1118981751, 'SV', 'SLV', 'السلفادور'),
(10810, 1118981752, 1118981759, 'NG', 'NGA', 'نيجيريا'),
(10811, 1118981760, 1118981791, 'US', 'USA', 'الولايات المتحدة'),
(10812, 1118981792, 1118981823, 'NG', 'NGA', 'نيجيريا'),
(10813, 1118981824, 1118981831, 'EC', 'ECU', 'الإكوادور'),
(10814, 1118981832, 1118981855, 'US', 'USA', 'الولايات المتحدة'),
(10815, 1118981856, 1118981863, 'EC', 'ECU', 'الإكوادور'),
(10816, 1118981864, 1118982175, 'US', 'USA', 'الولايات المتحدة'),
(10817, 1118982176, 1118982183, 'NI', 'NIC', 'نيكاراغوا'),
(10818, 1118982184, 1118982191, 'US', 'USA', 'الولايات المتحدة'),
(10819, 1118982192, 1118982199, 'KE', 'KEN', 'كينيا'),
(10820, 1118982200, 1118982215, 'US', 'USA', 'الولايات المتحدة'),
(10821, 1118982216, 1118982231, 'NG', 'NGA', 'نيجيريا'),
(10822, 1118982232, 1118982239, 'NI', 'NIC', 'نيكاراغوا'),
(10823, 1118982240, 1118982271, 'NG', 'NGA', 'نيجيريا'),
(10824, 1118982272, 1118982279, 'NI', 'NIC', 'نيكاراغوا'),
(10825, 1118982280, 1118982287, 'US', 'USA', 'الولايات المتحدة'),
(10826, 1118982288, 1118982295, 'NG', 'NGA', 'نيجيريا'),
(10827, 1118982296, 1118982303, 'US', 'USA', 'الولايات المتحدة'),
(10828, 1118982304, 1118982311, 'KE', 'KEN', 'كينيا'),
(10829, 1118982312, 1118982327, 'NG', 'NGA', 'نيجيريا'),
(10830, 1118982328, 1118982335, 'US', 'USA', 'الولايات المتحدة'),
(10831, 1118982336, 1118982367, 'NG', 'NGA', 'نيجيريا'),
(10832, 1118982368, 1118982383, 'US', 'USA', 'الولايات المتحدة'),
(10833, 1118982384, 1118982391, 'NI', 'NIC', 'نيكاراغوا'),
(10834, 1118982392, 1118982399, 'US', 'USA', 'الولايات المتحدة'),
(10835, 1118982400, 1118982407, 'NI', 'NIC', 'نيكاراغوا'),
(10836, 1118982408, 1118982415, 'NG', 'NGA', 'نيجيريا'),
(10837, 1118982416, 1118982431, 'SV', 'SLV', 'السلفادور'),
(10838, 1118982432, 1118982439, 'NI', 'NIC', 'نيكاراغوا'),
(10839, 1118982440, 1118982447, 'NG', 'NGA', 'نيجيريا'),
(10840, 1118982448, 1118982463, 'US', 'USA', 'الولايات المتحدة'),
(10841, 1118982464, 1118982471, 'NI', 'NIC', 'نيكاراغوا'),
(10842, 1118982472, 1118982479, 'NG', 'NGA', 'نيجيريا'),
(10843, 1118982480, 1118982487, 'US', 'USA', 'الولايات المتحدة'),
(10844, 1118982488, 1118982495, 'NI', 'NIC', 'نيكاراغوا'),
(10845, 1118982496, 1118982543, 'NG', 'NGA', 'نيجيريا'),
(10846, 1118982544, 1118982551, 'NI', 'NIC', 'نيكاراغوا'),
(10847, 1118982552, 1118982559, 'US', 'USA', 'الولايات المتحدة'),
(10848, 1118982560, 1118982567, 'NI', 'NIC', 'نيكاراغوا'),
(10849, 1118982568, 1118982575, 'US', 'USA', 'الولايات المتحدة'),
(10850, 1118982576, 1118982583, 'NI', 'NIC', 'نيكاراغوا'),
(10851, 1118982584, 1118982591, 'CM', 'CMR', 'الكاميرون'),
(10852, 1118982592, 1118982599, 'NG', 'NGA', 'نيجيريا'),
(10853, 1118982600, 1118982607, 'US', 'USA', 'الولايات المتحدة'),
(10854, 1118982608, 1118982615, 'NI', 'NIC', 'نيكاراغوا'),
(10855, 1118982616, 1118982655, 'NG', 'NGA', 'نيجيريا'),
(10856, 1118982656, 1118982783, 'US', 'USA', 'الولايات المتحدة'),
(10857, 1118982784, 1118982911, 'NG', 'NGA', 'نيجيريا'),
(10858, 1118982912, 1118982919, 'LB', 'LBN', 'لبنان'),
(10859, 1118982920, 1118982927, 'US', 'USA', 'الولايات المتحدة'),
(10860, 1118982928, 1118982935, 'NI', 'NIC', 'نيكاراغوا'),
(10861, 1118982936, 1118983039, 'US', 'USA', 'الولايات المتحدة'),
(10862, 1118983040, 1118983047, 'NG', 'NGA', 'نيجيريا'),
(10863, 1118983048, 1118983079, 'US', 'USA', 'الولايات المتحدة'),
(10864, 1118983080, 1118983087, 'NG', 'NGA', 'نيجيريا'),
(10865, 1118983088, 1118983167, 'US', 'USA', 'الولايات المتحدة'),
(10866, 1118983168, 1118983199, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(10867, 1118983200, 1118983295, 'US', 'USA', 'الولايات المتحدة'),
(10868, 1118983296, 1118983359, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(10869, 1118983360, 1118983423, 'US', 'USA', 'الولايات المتحدة'),
(10870, 1118983424, 1118983679, 'NI', 'NIC', 'نيكاراغوا'),
(10871, 1118983680, 1118983743, 'TZ', 'TZA', 'تانزانيا'),
(10872, 1118983744, 1118983759, 'VE', 'VEN', 'فنزويلا'),
(10873, 1118983760, 1118983871, 'US', 'USA', 'الولايات المتحدة'),
(10874, 1118983872, 1118983879, 'TZ', 'TZA', 'تانزانيا'),
(10875, 1118983880, 1118984703, 'US', 'USA', 'الولايات المتحدة'),
(10876, 1118984704, 1118984775, 'TZ', 'TZA', 'تانزانيا'),
(10877, 1118984776, 1118984783, 'IQ', 'IRQ', 'العراق'),
(10878, 1118984784, 1118984791, 'US', 'USA', 'الولايات المتحدة'),
(10879, 1118984792, 1118984799, 'NG', 'NGA', 'نيجيريا'),
(10880, 1118984800, 1118984831, 'US', 'USA', 'الولايات المتحدة'),
(10881, 1118984832, 1118984839, 'LB', 'LBN', 'لبنان'),
(10882, 1118984840, 1118984855, 'US', 'USA', 'الولايات المتحدة'),
(10883, 1118984856, 1118984863, 'IQ', 'IRQ', 'العراق'),
(10884, 1118984864, 1118984887, 'TZ', 'TZA', 'تانزانيا'),
(10885, 1118984888, 1118984959, 'US', 'USA', 'الولايات المتحدة'),
(10886, 1118984960, 1118985215, 'VE', 'VEN', 'فنزويلا'),
(10887, 1118985216, 1118985983, 'US', 'USA', 'الولايات المتحدة'),
(10888, 1118985984, 1118986111, 'NG', 'NGA', 'نيجيريا'),
(10889, 1118986112, 1118986239, 'US', 'USA', 'الولايات المتحدة'),
(10890, 1118986240, 1118987007, 'GB', 'GBR', 'المملكة المتحدة'),
(10891, 1118987008, 1118987263, 'US', 'USA', 'الولايات المتحدة'),
(10892, 1118987264, 1118988287, 'KE', 'KEN', 'كينيا'),
(10893, 1118988288, 1118988543, 'CA', 'CAN', 'كندا'),
(10894, 1118988544, 1118988575, 'NG', 'NGA', 'نيجيريا'),
(10895, 1118988576, 1118988615, 'US', 'USA', 'الولايات المتحدة'),
(10896, 1118988616, 1118988623, 'GB', 'GBR', 'المملكة المتحدة'),
(10897, 1118988624, 1118988735, 'US', 'USA', 'الولايات المتحدة'),
(10898, 1118988736, 1118988751, 'GB', 'GBR', 'المملكة المتحدة'),
(10899, 1118988752, 1118988799, 'US', 'USA', 'الولايات المتحدة'),
(10900, 1118988800, 1118989055, 'VE', 'VEN', 'فنزويلا'),
(10901, 1118989056, 1118989183, 'KE', 'KEN', 'كينيا'),
(10902, 1118989184, 1118989311, 'GB', 'GBR', 'المملكة المتحدة'),
(10903, 1118989312, 1118989823, 'KE', 'KEN', 'كينيا'),
(10904, 1118989824, 1118989951, 'US', 'USA', 'الولايات المتحدة'),
(10905, 1118989952, 1118990079, 'FR', 'FRA', 'فرنسا'),
(10906, 1118990080, 1118990719, 'US', 'USA', 'الولايات المتحدة'),
(10907, 1118990720, 1118990727, 'KE', 'KEN', 'كينيا'),
(10908, 1118990728, 1118991487, 'US', 'USA', 'الولايات المتحدة'),
(10909, 1118991488, 1118991615, 'LR', 'LBR', 'ليبيريا'),
(10910, 1118991616, 1118992639, 'US', 'USA', 'الولايات المتحدة'),
(10911, 1118992640, 1118992655, 'KE', 'KEN', 'كينيا'),
(10912, 1118992656, 1118993919, 'US', 'USA', 'الولايات المتحدة'),
(10913, 1118993920, 1118994431, 'GY', 'GUY', 'غيانا'),
(10914, 1118994432, 1119109119, 'US', 'USA', 'الولايات المتحدة'),
(10915, 1119109120, 1119111167, 'CA', 'CAN', 'كندا'),
(10916, 1119113216, 1119150079, 'US', 'USA', 'الولايات المتحدة'),
(10917, 1119158272, 1119211519, 'US', 'USA', 'الولايات المتحدة'),
(10918, 1119211520, 1119215615, 'CA', 'CAN', 'كندا'),
(10919, 1119215616, 1119289343, 'US', 'USA', 'الولايات المتحدة'),
(10920, 1119289344, 1119354879, 'CA', 'CAN', 'كندا'),
(10921, 1119354880, 1119428607, 'US', 'USA', 'الولايات المتحدة'),
(10922, 1119428608, 1119432703, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(10923, 1119432704, 1119436799, 'CA', 'CAN', 'كندا'),
(10924, 1119436800, 1119440895, 'US', 'USA', 'الولايات المتحدة'),
(10925, 1119440896, 1119444991, 'CA', 'CAN', 'كندا'),
(10926, 1119444992, 1119469567, 'US', 'USA', 'الولايات المتحدة'),
(10927, 1119469568, 1119477759, 'CA', 'CAN', 'كندا'),
(10928, 1119477760, 1119502335, 'US', 'USA', 'الولايات المتحدة'),
(10929, 1119502336, 1119510527, 'CA', 'CAN', 'كندا'),
(10930, 1119510528, 1119567871, 'US', 'USA', 'الولايات المتحدة'),
(10931, 1119571968, 1119580159, 'US', 'USA', 'الولايات المتحدة'),
(10932, 1119580160, 1119584255, 'CA', 'CAN', 'كندا'),
(10933, 1119584256, 1120041983, 'US', 'USA', 'الولايات المتحدة'),
(10934, 1120041984, 1120042495, 'AR', 'ARG', 'الأرجنتين'),
(10935, 1120042496, 1120064511, 'US', 'USA', 'الولايات المتحدة'),
(10936, 1120064512, 1120064767, 'AR', 'ARG', 'الأرجنتين'),
(10937, 1120064768, 1120149503, 'US', 'USA', 'الولايات المتحدة'),
(10938, 1120149504, 1120149599, 'CA', 'CAN', 'كندا'),
(10939, 1120149600, 1120149631, 'US', 'USA', 'الولايات المتحدة'),
(10940, 1120149632, 1120150031, 'CA', 'CAN', 'كندا'),
(10941, 1120150032, 1120150039, 'TW', 'TWN', 'تايوان'),
(10942, 1120150040, 1120150047, 'CA', 'CAN', 'كندا'),
(10943, 1120150048, 1120150055, 'US', 'USA', 'الولايات المتحدة'),
(10944, 1120150056, 1120151695, 'CA', 'CAN', 'كندا'),
(10945, 1120151696, 1120151711, 'TW', 'TWN', 'تايوان'),
(10946, 1120151712, 1120152159, 'CA', 'CAN', 'كندا'),
(10947, 1120152160, 1120152191, 'US', 'USA', 'الولايات المتحدة'),
(10948, 1120152192, 1120152319, 'CA', 'CAN', 'كندا'),
(10949, 1120152320, 1120152575, 'US', 'USA', 'الولايات المتحدة'),
(10950, 1120152576, 1120153599, 'CA', 'CAN', 'كندا'),
(10951, 1120153600, 1120272383, 'US', 'USA', 'الولايات المتحدة'),
(10952, 1120272384, 1120281087, 'CA', 'CAN', 'كندا'),
(10953, 1120281088, 1120281095, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(10954, 1120281096, 1120281103, 'US', 'USA', 'الولايات المتحدة'),
(10955, 1120281104, 1120281111, 'CA', 'CAN', 'كندا'),
(10956, 1120281112, 1120281119, 'US', 'USA', 'الولايات المتحدة'),
(10957, 1120281120, 1120281135, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(10958, 1120281136, 1120281375, 'CA', 'CAN', 'كندا'),
(10959, 1120281376, 1120281383, 'AR', 'ARG', 'الأرجنتين'),
(10960, 1120281384, 1120281391, 'US', 'USA', 'الولايات المتحدة'),
(10961, 1120281392, 1120281407, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(10962, 1120281408, 1120281599, 'CA', 'CAN', 'كندا'),
(10963, 1120281600, 1120282111, 'US', 'USA', 'الولايات المتحدة'),
(10964, 1120282112, 1120286719, 'CA', 'CAN', 'كندا'),
(10965, 1120286720, 1120288767, 'US', 'USA', 'الولايات المتحدة'),
(10966, 1120288768, 1120299007, 'CA', 'CAN', 'كندا'),
(10967, 1120299008, 1120299263, 'PK', 'PAK', 'باكستان'),
(10968, 1120299264, 1120299519, 'CA', 'CAN', 'كندا'),
(10969, 1120299520, 1120300799, 'PK', 'PAK', 'باكستان'),
(10970, 1120300800, 1120306687, 'CA', 'CAN', 'كندا'),
(10971, 1120306688, 1120306943, 'PH', 'PHL', 'الفلبين'),
(10972, 1120306944, 1120310015, 'CA', 'CAN', 'كندا'),
(10973, 1120310016, 1120310271, 'PH', 'PHL', 'الفلبين'),
(10974, 1120310272, 1120312063, 'CA', 'CAN', 'كندا'),
(10975, 1120312064, 1120312447, 'PH', 'PHL', 'الفلبين'),
(10976, 1120312448, 1120312575, 'CA', 'CAN', 'كندا'),
(10977, 1120312576, 1120312831, 'PH', 'PHL', 'الفلبين'),
(10978, 1120312832, 1120321535, 'CA', 'CAN', 'كندا'),
(10979, 1120321536, 1120346111, 'US', 'USA', 'الولايات المتحدة'),
(10980, 1120346112, 1120350207, 'CA', 'CAN', 'كندا'),
(10981, 1120350208, 1120370943, 'US', 'USA', 'الولايات المتحدة'),
(10982, 1120370944, 1120371199, 'CA', 'CAN', 'كندا'),
(10983, 1120371200, 1120372223, 'US', 'USA', 'الولايات المتحدة'),
(10984, 1120372224, 1120372479, 'CA', 'CAN', 'كندا'),
(10985, 1120372480, 1120372735, 'US', 'USA', 'الولايات المتحدة'),
(10986, 1120372736, 1120373247, 'CA', 'CAN', 'كندا'),
(10987, 1120373248, 1120373503, 'US', 'USA', 'الولايات المتحدة'),
(10988, 1120373504, 1120373759, 'CA', 'CAN', 'كندا'),
(10989, 1120373760, 1120376831, 'US', 'USA', 'الولايات المتحدة'),
(10990, 1120376832, 1120377087, 'CA', 'CAN', 'كندا'),
(10991, 1120377088, 1120377855, 'US', 'USA', 'الولايات المتحدة'),
(10992, 1120377856, 1120378367, 'CA', 'CAN', 'كندا'),
(10993, 1120378368, 1120378623, 'US', 'USA', 'الولايات المتحدة'),
(10994, 1120378624, 1120378879, 'CA', 'CAN', 'كندا'),
(10995, 1120378880, 1120379391, 'US', 'USA', 'الولايات المتحدة'),
(10996, 1120379392, 1120379647, 'CA', 'CAN', 'كندا'),
(10997, 1120379648, 1120379999, 'US', 'USA', 'الولايات المتحدة'),
(10998, 1120380000, 1120380015, 'CA', 'CAN', 'كندا'),
(10999, 1120380016, 1120380415, 'US', 'USA', 'الولايات المتحدة'),
(11000, 1120380416, 1120380431, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11001, 1120380432, 1120381439, 'US', 'USA', 'الولايات المتحدة'),
(11002, 1120381440, 1120381951, 'CA', 'CAN', 'كندا'),
(11003, 1120381952, 1120382463, 'US', 'USA', 'الولايات المتحدة'),
(11004, 1120382464, 1120382719, 'CA', 'CAN', 'كندا'),
(11005, 1120382720, 1120383999, 'US', 'USA', 'الولايات المتحدة'),
(11006, 1120384000, 1120385023, 'CA', 'CAN', 'كندا'),
(11007, 1120385024, 1120509951, 'US', 'USA', 'الولايات المتحدة'),
(11008, 1120509952, 1120516095, 'SV', 'SLV', 'السلفادور'),
(11009, 1120516096, 1120517375, 'US', 'USA', 'الولايات المتحدة'),
(11010, 1120517376, 1120517631, 'AR', 'ARG', 'الأرجنتين'),
(11011, 1120517632, 1120517887, 'US', 'USA', 'الولايات المتحدة'),
(11012, 1120517888, 1120518143, 'CL', 'CHL', 'تشيلي'),
(11013, 1120518144, 1120534527, 'CA', 'CAN', 'كندا'),
(11014, 1120534528, 1120641023, 'US', 'USA', 'الولايات المتحدة'),
(11015, 1120641024, 1120657407, 'CA', 'CAN', 'كندا'),
(11016, 1120657408, 1120733183, 'US', 'USA', 'الولايات المتحدة'),
(11017, 1120733184, 1120735231, 'BB', 'BRB', 'باربادوس'),
(11018, 1120735232, 1120735487, 'US', 'USA', 'الولايات المتحدة'),
(11019, 1120735488, 1120735743, 'BB', 'BRB', 'باربادوس'),
(11020, 1120735744, 1120736207, 'US', 'USA', 'الولايات المتحدة'),
(11021, 1120736208, 1120736223, 'PY', 'PRY', 'باراغواي'),
(11022, 1120736224, 1120736991, 'US', 'USA', 'الولايات المتحدة'),
(11023, 1120736992, 1120737007, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11024, 1120737008, 1120737023, 'US', 'USA', 'الولايات المتحدة'),
(11025, 1120737024, 1120737279, 'BS', 'BHS', 'جزر البهاما'),
(11026, 1120737280, 1120739951, 'US', 'USA', 'الولايات المتحدة'),
(11027, 1120739952, 1120739983, 'MX', 'MEX', 'المكسيك'),
(11028, 1120739984, 1120739991, 'US', 'USA', 'الولايات المتحدة'),
(11029, 1120739992, 1120740079, 'MX', 'MEX', 'المكسيك'),
(11030, 1120740080, 1120740095, 'US', 'USA', 'الولايات المتحدة'),
(11031, 1120740096, 1120740351, 'MX', 'MEX', 'المكسيك'),
(11032, 1120740352, 1120741375, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(11033, 1120741376, 1120741631, 'US', 'USA', 'الولايات المتحدة'),
(11034, 1120741632, 1120741887, 'MX', 'MEX', 'المكسيك'),
(11035, 1120741888, 1120743423, 'US', 'USA', 'الولايات المتحدة'),
(11036, 1120743424, 1120743679, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11037, 1120743680, 1120744447, 'US', 'USA', 'الولايات المتحدة'),
(11038, 1120744448, 1120744703, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11039, 1120744704, 1120804863, 'US', 'USA', 'الولايات المتحدة'),
(11040, 1120808960, 1120854015, 'US', 'USA', 'الولايات المتحدة'),
(11041, 1120854016, 1120862207, 'CA', 'CAN', 'كندا'),
(11042, 1120862208, 1120870399, 'US', 'USA', 'الولايات المتحدة'),
(11043, 1120874496, 1120886783, 'US', 'USA', 'الولايات المتحدة'),
(11044, 1120886784, 1120894975, 'CA', 'CAN', 'كندا'),
(11045, 1120894976, 1120911359, 'US', 'USA', 'الولايات المتحدة'),
(11046, 1120911360, 1120914415, 'CA', 'CAN', 'كندا'),
(11047, 1120914416, 1120914431, 'AT', 'AUT', 'النمسا'),
(11048, 1120914432, 1120914687, 'CA', 'CAN', 'كندا'),
(11049, 1120914688, 1120914719, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11050, 1120914720, 1120918623, 'CA', 'CAN', 'كندا'),
(11051, 1120918624, 1120918639, 'US', 'USA', 'الولايات المتحدة'),
(11052, 1120918640, 1120919551, 'CA', 'CAN', 'كندا'),
(11053, 1120919552, 1121005567, 'US', 'USA', 'الولايات المتحدة'),
(11054, 1121005568, 1121009663, 'CA', 'CAN', 'كندا'),
(11055, 1121009664, 1121038335, 'US', 'USA', 'الولايات المتحدة'),
(11056, 1121038336, 1121042431, 'CA', 'CAN', 'كندا'),
(11057, 1121042432, 1121230847, 'US', 'USA', 'الولايات المتحدة'),
(11058, 1121230848, 1121239039, 'CA', 'CAN', 'كندا'),
(11059, 1121239040, 1121247231, 'US', 'USA', 'الولايات المتحدة'),
(11060, 1121247232, 1121247519, 'CA', 'CAN', 'كندا'),
(11061, 1121247520, 1121247527, 'BZ', 'BLZ', 'بليز'),
(11062, 1121247528, 1121247535, 'CA', 'CAN', 'كندا'),
(11063, 1121247536, 1121247543, 'BZ', 'BLZ', 'بليز'),
(11064, 1121247544, 1121247663, 'CA', 'CAN', 'كندا'),
(11065, 1121247664, 1121247679, 'BZ', 'BLZ', 'بليز'),
(11066, 1121247680, 1121248127, 'CA', 'CAN', 'كندا'),
(11067, 1121248128, 1121248135, 'MT', 'MLT', 'مالطا'),
(11068, 1121248136, 1121248311, 'CA', 'CAN', 'كندا'),
(11069, 1121248312, 1121248319, 'MT', 'MLT', 'مالطا'),
(11070, 1121248320, 1121248343, 'CA', 'CAN', 'كندا'),
(11071, 1121248344, 1121248351, 'BZ', 'BLZ', 'بليز'),
(11072, 1121248352, 1121248407, 'CA', 'CAN', 'كندا'),
(11073, 1121248408, 1121248431, 'GB', 'GBR', 'المملكة المتحدة'),
(11074, 1121248432, 1121248447, 'CA', 'CAN', 'كندا'),
(11075, 1121248448, 1121248495, 'BZ', 'BLZ', 'بليز'),
(11076, 1121248496, 1121248911, 'CA', 'CAN', 'كندا'),
(11077, 1121248912, 1121248919, 'BZ', 'BLZ', 'بليز'),
(11078, 1121248920, 1121250183, 'CA', 'CAN', 'كندا'),
(11079, 1121250184, 1121250191, 'BZ', 'BLZ', 'بليز'),
(11080, 1121250192, 1121250303, 'CA', 'CAN', 'كندا'),
(11081, 1121250304, 1121250815, 'BZ', 'BLZ', 'بليز'),
(11082, 1121250816, 1121251071, 'CA', 'CAN', 'كندا'),
(11083, 1121251072, 1121251079, 'GB', 'GBR', 'المملكة المتحدة'),
(11084, 1121251080, 1121251607, 'CA', 'CAN', 'كندا'),
(11085, 1121251608, 1121251615, 'BZ', 'BLZ', 'بليز'),
(11086, 1121251616, 1121251663, 'CA', 'CAN', 'كندا'),
(11087, 1121251664, 1121251671, 'MT', 'MLT', 'مالطا'),
(11088, 1121251672, 1121251727, 'CA', 'CAN', 'كندا'),
(11089, 1121251728, 1121251775, 'BZ', 'BLZ', 'بليز'),
(11090, 1121251776, 1121251839, 'CA', 'CAN', 'كندا'),
(11091, 1121251840, 1121251847, 'BZ', 'BLZ', 'بليز'),
(11092, 1121251848, 1121252863, 'CA', 'CAN', 'كندا'),
(11093, 1121252864, 1121253119, 'BZ', 'BLZ', 'بليز'),
(11094, 1121253120, 1121255423, 'CA', 'CAN', 'كندا'),
(11095, 1121255424, 1121655439, 'US', 'USA', 'الولايات المتحدة'),
(11096, 1121655440, 1121655447, 'VE', 'VEN', 'فنزويلا'),
(11097, 1121655448, 1121878015, 'US', 'USA', 'الولايات المتحدة'),
(11098, 1121878016, 1121910783, 'CA', 'CAN', 'كندا'),
(11099, 1121910784, 1122074623, 'US', 'USA', 'الولايات المتحدة'),
(11100, 1122074624, 1122087935, 'CA', 'CAN', 'كندا'),
(11101, 1122087936, 1122088191, 'US', 'USA', 'الولايات المتحدة'),
(11102, 1122088192, 1122091007, 'CA', 'CAN', 'كندا'),
(11103, 1122091008, 1122092799, 'US', 'USA', 'الولايات المتحدة'),
(11104, 1122092800, 1122093055, 'CA', 'CAN', 'كندا'),
(11105, 1122093056, 1122140159, 'US', 'USA', 'الولايات المتحدة'),
(11106, 1122140160, 1122148351, 'CA', 'CAN', 'كندا'),
(11107, 1122148352, 1122270207, 'US', 'USA', 'الولايات المتحدة'),
(11108, 1122270208, 1122270215, 'EG', 'EGY', 'مصر'),
(11109, 1122270216, 1122320959, 'US', 'USA', 'الولايات المتحدة'),
(11110, 1122320960, 1122320995, 'PT', 'PRT', 'البورتوغال'),
(11111, 1122320996, 1122411551, 'US', 'USA', 'الولايات المتحدة'),
(11112, 1122411552, 1122411583, 'AU', 'AUS', 'أستراليا'),
(11113, 1122411584, 1122412287, 'US', 'USA', 'الولايات المتحدة'),
(11114, 1122412288, 1122412543, 'AU', 'AUS', 'أستراليا'),
(11115, 1122412544, 1122414335, 'US', 'USA', 'الولايات المتحدة'),
(11116, 1122414336, 1122414591, 'AU', 'AUS', 'أستراليا'),
(11117, 1122414592, 1122416383, 'US', 'USA', 'الولايات المتحدة'),
(11118, 1122416384, 1122416639, 'DM', 'DMA', 'دومينيكا'),
(11119, 1122416640, 1122417919, 'US', 'USA', 'الولايات المتحدة'),
(11120, 1122417920, 1122418175, 'AU', 'AUS', 'أستراليا'),
(11121, 1122418176, 1122430975, 'US', 'USA', 'الولايات المتحدة'),
(11122, 1122435072, 1122451455, 'US', 'USA', 'الولايات المتحدة'),
(11123, 1122451456, 1122455551, 'CO', 'COL', 'كولومبيا'),
(11124, 1122455552, 1122476031, 'US', 'USA', 'الولايات المتحدة'),
(11125, 1122476032, 1122480127, 'PR', 'PRI', 'بورتو ريكو'),
(11126, 1122480128, 1122480223, 'US', 'USA', 'الولايات المتحدة'),
(11127, 1122480224, 1122480231, 'PL', 'POL', 'بولندا'),
(11128, 1122480232, 1122480343, 'US', 'USA', 'الولايات المتحدة'),
(11129, 1122480344, 1122480351, 'PR', 'PRI', 'بورتو ريكو'),
(11130, 1122480352, 1122480415, 'US', 'USA', 'الولايات المتحدة'),
(11131, 1122480416, 1122480423, 'CL', 'CHL', 'تشيلي'),
(11132, 1122480424, 1122480447, 'US', 'USA', 'الولايات المتحدة'),
(11133, 1122480448, 1122480455, 'PR', 'PRI', 'بورتو ريكو'),
(11134, 1122480456, 1122535423, 'US', 'USA', 'الولايات المتحدة'),
(11135, 1122535424, 1122538495, 'KR', 'KOR', 'جمهورية كوريا'),
(11136, 1122538496, 1122635775, 'US', 'USA', 'الولايات المتحدة'),
(11137, 1122635776, 1122639871, 'CA', 'CAN', 'كندا'),
(11138, 1122639872, 1123057663, 'US', 'USA', 'الولايات المتحدة'),
(11139, 1123057664, 1123074047, 'CA', 'CAN', 'كندا'),
(11140, 1123074048, 1123119103, 'US', 'USA', 'الولايات المتحدة'),
(11141, 1123123200, 1123127295, 'CA', 'CAN', 'كندا'),
(11142, 1123127296, 1123180543, 'US', 'USA', 'الولايات المتحدة'),
(11143, 1123180544, 1123184639, 'CA', 'CAN', 'كندا'),
(11144, 1123184640, 1123319807, 'US', 'USA', 'الولايات المتحدة'),
(11145, 1123319808, 1123323903, 'CA', 'CAN', 'كندا'),
(11146, 1123323904, 1123336191, 'US', 'USA', 'الولايات المتحدة'),
(11147, 1123336192, 1123352575, 'CA', 'CAN', 'كندا'),
(11148, 1123352576, 1123397631, 'US', 'USA', 'الولايات المتحدة'),
(11149, 1123398656, 1123399679, 'US', 'USA', 'الولايات المتحدة'),
(11150, 1123401728, 1123534847, 'US', 'USA', 'الولايات المتحدة'),
(11151, 1123534848, 1123536895, 'AW', 'ABW', 'أروبا'),
(11152, 1123536896, 1123582239, 'US', 'USA', 'الولايات المتحدة'),
(11153, 1123582240, 1123582271, 'CY', 'CYP', 'قبرص'),
(11154, 1123582272, 1123582431, 'US', 'USA', 'الولايات المتحدة'),
(11155, 1123582432, 1123582463, 'CA', 'CAN', 'كندا'),
(11156, 1123582464, 1123583455, 'US', 'USA', 'الولايات المتحدة'),
(11157, 1123583456, 1123583519, 'CY', 'CYP', 'قبرص'),
(11158, 1123583520, 1123588063, 'US', 'USA', 'الولايات المتحدة'),
(11159, 1123588064, 1123588095, 'CY', 'CYP', 'قبرص'),
(11160, 1123588096, 1123590143, 'US', 'USA', 'الولايات المتحدة'),
(11161, 1123590144, 1123598335, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(11162, 1123598336, 1123651583, 'US', 'USA', 'الولايات المتحدة'),
(11163, 1123651584, 1123655679, 'JM', 'JAM', 'جامايكا'),
(11164, 1123655680, 1123663871, 'US', 'USA', 'الولايات المتحدة'),
(11165, 1123663872, 1123667967, 'SV', 'SLV', 'السلفادور'),
(11166, 1123667968, 1123670015, 'PR', 'PRI', 'بورتو ريكو'),
(11167, 1123670016, 1123671039, 'US', 'USA', 'الولايات المتحدة'),
(11168, 1123671040, 1123672063, 'PY', 'PRY', 'باراغواي'),
(11169, 1123672064, 1123794943, 'US', 'USA', 'الولايات المتحدة'),
(11170, 1123794944, 1123795199, 'DO', 'DOM', 'الدومينيكان'),
(11171, 1123795200, 1123801087, 'US', 'USA', 'الولايات المتحدة'),
(11172, 1123801088, 1123801343, 'RU', 'RUS', 'الإتحاد الروسي'),
(11173, 1123801344, 1123848191, 'US', 'USA', 'الولايات المتحدة'),
(11174, 1123848192, 1123852287, 'CA', 'CAN', 'كندا'),
(11175, 1123852288, 1123950591, 'US', 'USA', 'الولايات المتحدة'),
(11176, 1123950592, 1123958783, 'CA', 'CAN', 'كندا'),
(11177, 1123958784, 1125064703, 'US', 'USA', 'الولايات المتحدة'),
(11178, 1125064704, 1125065215, 'GB', 'GBR', 'المملكة المتحدة'),
(11179, 1125065216, 1125081087, 'US', 'USA', 'الولايات المتحدة'),
(11180, 1125081088, 1125081151, 'CL', 'CHL', 'تشيلي'),
(11181, 1125081152, 1125081183, 'CA', 'CAN', 'كندا'),
(11182, 1125081184, 1125081215, 'US', 'USA', 'الولايات المتحدة'),
(11183, 1125081216, 1125081279, 'GB', 'GBR', 'المملكة المتحدة'),
(11184, 1125081280, 1125081855, 'US', 'USA', 'الولايات المتحدة'),
(11185, 1125081856, 1125082111, 'DE', 'DEU', 'ألمانيا'),
(11186, 1125082112, 1125082367, 'US', 'USA', 'الولايات المتحدة'),
(11187, 1125082368, 1125082623, 'DE', 'DEU', 'ألمانيا'),
(11188, 1125082624, 1125082655, 'US', 'USA', 'الولايات المتحدة'),
(11189, 1125082656, 1125082687, 'UY', 'URY', 'الأوروغواي'),
(11190, 1125082688, 1125082783, 'US', 'USA', 'الولايات المتحدة'),
(11191, 1125082784, 1125082799, 'UY', 'URY', 'الأوروغواي'),
(11192, 1125082800, 1125083007, 'US', 'USA', 'الولايات المتحدة'),
(11193, 1125083008, 1125083023, 'RU', 'RUS', 'الإتحاد الروسي'),
(11194, 1125083024, 1125083967, 'US', 'USA', 'الولايات المتحدة'),
(11195, 1125083968, 1125084031, 'UY', 'URY', 'الأوروغواي'),
(11196, 1125084032, 1125084063, 'US', 'USA', 'الولايات المتحدة'),
(11197, 1125084064, 1125084095, 'SE', 'SWE', 'السويد'),
(11198, 1125084096, 1125085135, 'US', 'USA', 'الولايات المتحدة'),
(11199, 1125085136, 1125085151, 'DE', 'DEU', 'ألمانيا'),
(11200, 1125085152, 1125086079, 'US', 'USA', 'الولايات المتحدة'),
(11201, 1125086080, 1125086143, 'AU', 'AUS', 'أستراليا'),
(11202, 1125086144, 1125087999, 'US', 'USA', 'الولايات المتحدة'),
(11203, 1125088000, 1125088255, 'CA', 'CAN', 'كندا'),
(11204, 1125088256, 1125090303, 'US', 'USA', 'الولايات المتحدة'),
(11205, 1125090304, 1125090335, 'AU', 'AUS', 'أستراليا'),
(11206, 1125090336, 1125090367, 'US', 'USA', 'الولايات المتحدة'),
(11207, 1125090368, 1125090431, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(11208, 1125090432, 1125090479, 'US', 'USA', 'الولايات المتحدة'),
(11209, 1125090480, 1125090495, 'DE', 'DEU', 'ألمانيا'),
(11210, 1125090496, 1125091087, 'US', 'USA', 'الولايات المتحدة'),
(11211, 1125091088, 1125091103, 'CA', 'CAN', 'كندا'),
(11212, 1125091104, 1125091135, 'US', 'USA', 'الولايات المتحدة'),
(11213, 1125091136, 1125091167, 'SK', 'SVK', 'سلوفاكيا'),
(11214, 1125091168, 1125091183, 'US', 'USA', 'الولايات المتحدة'),
(11215, 1125091184, 1125091199, 'UY', 'URY', 'الأوروغواي'),
(11216, 1125091200, 1125091455, 'US', 'USA', 'الولايات المتحدة'),
(11217, 1125091456, 1125091519, 'ES', 'ESP', 'إسبانيا'),
(11218, 1125091520, 1125091583, 'US', 'USA', 'الولايات المتحدة'),
(11219, 1125091584, 1125091647, 'GB', 'GBR', 'المملكة المتحدة'),
(11220, 1125091648, 1125091663, 'US', 'USA', 'الولايات المتحدة'),
(11221, 1125091664, 1125091679, 'HU', 'HUN', 'هنغاريا'),
(11222, 1125091680, 1125091711, 'SE', 'SWE', 'السويد'),
(11223, 1125091712, 1125091743, 'CA', 'CAN', 'كندا'),
(11224, 1125091744, 1125091759, 'US', 'USA', 'الولايات المتحدة'),
(11225, 1125091760, 1125091775, 'UY', 'URY', 'الأوروغواي'),
(11226, 1125091776, 1125091839, 'CA', 'CAN', 'كندا'),
(11227, 1125091840, 1125093471, 'US', 'USA', 'الولايات المتحدة'),
(11228, 1125093472, 1125093503, 'IL', 'ISR', 'إسرائيل'),
(11229, 1125093504, 1125093567, 'SK', 'SVK', 'سلوفاكيا'),
(11230, 1125093568, 1125093631, 'AU', 'AUS', 'أستراليا'),
(11231, 1125093632, 1125094463, 'US', 'USA', 'الولايات المتحدة'),
(11232, 1125094464, 1125094527, 'BR', 'BRA', 'البرازيل'),
(11233, 1125094528, 1125094655, 'US', 'USA', 'الولايات المتحدة'),
(11234, 1125094656, 1125094671, 'GB', 'GBR', 'المملكة المتحدة'),
(11235, 1125094672, 1125094783, 'US', 'USA', 'الولايات المتحدة'),
(11236, 1125094784, 1125094799, 'GB', 'GBR', 'المملكة المتحدة'),
(11237, 1125094800, 1125094847, 'CA', 'CAN', 'كندا'),
(11238, 1125094848, 1125094911, 'BR', 'BRA', 'البرازيل'),
(11239, 1125094912, 1125095039, 'AU', 'AUS', 'أستراليا'),
(11240, 1125095040, 1125095167, 'GB', 'GBR', 'المملكة المتحدة'),
(11241, 1125095168, 1125095183, 'BE', 'BEL', 'بلجيكا'),
(11242, 1125095184, 1125095295, 'US', 'USA', 'الولايات المتحدة'),
(11243, 1125095296, 1125095327, 'AU', 'AUS', 'أستراليا'),
(11244, 1125095328, 1125096959, 'US', 'USA', 'الولايات المتحدة'),
(11245, 1125096960, 1125097087, 'AR', 'ARG', 'الأرجنتين'),
(11246, 1125097088, 1125097119, 'US', 'USA', 'الولايات المتحدة'),
(11247, 1125097120, 1125097151, 'TH', 'THA', 'تايلند'),
(11248, 1125097152, 1125097215, 'US', 'USA', 'الولايات المتحدة'),
(11249, 1125097216, 1125097279, 'AU', 'AUS', 'أستراليا'),
(11250, 1125097280, 1125097343, 'BR', 'BRA', 'البرازيل'),
(11251, 1125097344, 1125097407, 'US', 'USA', 'الولايات المتحدة'),
(11252, 1125097408, 1125097439, 'IL', 'ISR', 'إسرائيل'),
(11253, 1125097440, 1125097455, 'US', 'USA', 'الولايات المتحدة'),
(11254, 1125097456, 1125097471, 'GB', 'GBR', 'المملكة المتحدة'),
(11255, 1125097472, 1125097791, 'US', 'USA', 'الولايات المتحدة'),
(11256, 1125097792, 1125097823, 'ES', 'ESP', 'إسبانيا'),
(11257, 1125097824, 1125097855, 'AU', 'AUS', 'أستراليا'),
(11258, 1125097856, 1125097871, 'JO', 'JOR', 'الأردن'),
(11259, 1125097872, 1125097887, 'UY', 'URY', 'الأوروغواي'),
(11260, 1125097888, 1125097919, 'US', 'USA', 'الولايات المتحدة'),
(11261, 1125097920, 1125097983, 'IL', 'ISR', 'إسرائيل'),
(11262, 1125097984, 1125099775, 'US', 'USA', 'الولايات المتحدة'),
(11263, 1125099776, 1125100031, 'GB', 'GBR', 'المملكة المتحدة'),
(11264, 1125100032, 1125103487, 'US', 'USA', 'الولايات المتحدة'),
(11265, 1125103488, 1125103519, 'UY', 'URY', 'الأوروغواي'),
(11266, 1125103520, 1125106063, 'US', 'USA', 'الولايات المتحدة'),
(11267, 1125106064, 1125106111, 'CA', 'CAN', 'كندا'),
(11268, 1125106112, 1125106175, 'GB', 'GBR', 'المملكة المتحدة'),
(11269, 1125106176, 1125106207, 'AU', 'AUS', 'أستراليا'),
(11270, 1125106208, 1125106223, 'TR', 'TUR', 'تركيا'),
(11271, 1125106224, 1125106239, 'FR', 'FRA', 'فرنسا'),
(11272, 1125106240, 1125106255, 'UY', 'URY', 'الأوروغواي'),
(11273, 1125106256, 1125106271, 'FR', 'FRA', 'فرنسا'),
(11274, 1125106272, 1125106303, 'US', 'USA', 'الولايات المتحدة'),
(11275, 1125106304, 1125106367, 'DE', 'DEU', 'ألمانيا'),
(11276, 1125106368, 1125110271, 'US', 'USA', 'الولايات المتحدة'),
(11277, 1125110272, 1125110335, 'GB', 'GBR', 'المملكة المتحدة'),
(11278, 1125110336, 1125110399, 'US', 'USA', 'الولايات المتحدة'),
(11279, 1125110400, 1125110463, 'KW', 'KWT', 'الكويت'),
(11280, 1125110464, 1125110783, 'US', 'USA', 'الولايات المتحدة'),
(11281, 1125110784, 1125110911, 'MA', 'MAR', 'المغرب'),
(11282, 1125110912, 1125110927, 'UY', 'URY', 'الأوروغواي'),
(11283, 1125110928, 1125110943, 'TW', 'TWN', 'تايوان'),
(11284, 1125110944, 1125110959, 'CA', 'CAN', 'كندا'),
(11285, 1125110960, 1125110975, 'US', 'USA', 'الولايات المتحدة'),
(11286, 1125110976, 1125111039, 'MA', 'MAR', 'المغرب'),
(11287, 1125111040, 1125111423, 'US', 'USA', 'الولايات المتحدة'),
(11288, 1125111424, 1125111439, 'BR', 'BRA', 'البرازيل'),
(11289, 1125111440, 1125111455, 'US', 'USA', 'الولايات المتحدة'),
(11290, 1125111456, 1125111471, 'CA', 'CAN', 'كندا'),
(11291, 1125111472, 1125111487, 'US', 'USA', 'الولايات المتحدة'),
(11292, 1125111488, 1125111519, 'GB', 'GBR', 'المملكة المتحدة'),
(11293, 1125111520, 1125111535, 'IL', 'ISR', 'إسرائيل'),
(11294, 1125111536, 1125111743, 'US', 'USA', 'الولايات المتحدة'),
(11295, 1125111744, 1125111775, 'DE', 'DEU', 'ألمانيا'),
(11296, 1125111776, 1125112447, 'US', 'USA', 'الولايات المتحدة'),
(11297, 1125112448, 1125112511, 'PL', 'POL', 'بولندا'),
(11298, 1125112512, 1125112767, 'US', 'USA', 'الولايات المتحدة'),
(11299, 1125112768, 1125112783, 'GB', 'GBR', 'المملكة المتحدة'),
(11300, 1125112784, 1125112831, 'US', 'USA', 'الولايات المتحدة'),
(11301, 1125112832, 1125113087, 'MA', 'MAR', 'المغرب'),
(11302, 1125113088, 1125115647, 'US', 'USA', 'الولايات المتحدة'),
(11303, 1125115648, 1125115663, 'ES', 'ESP', 'إسبانيا'),
(11304, 1125115664, 1125115727, 'US', 'USA', 'الولايات المتحدة'),
(11305, 1125115728, 1125115743, 'ES', 'ESP', 'إسبانيا'),
(11306, 1125115744, 1125116159, 'US', 'USA', 'الولايات المتحدة'),
(11307, 1125116160, 1125116191, 'BR', 'BRA', 'البرازيل'),
(11308, 1125116192, 1125116223, 'TR', 'TUR', 'تركيا'),
(11309, 1125116224, 1125116415, 'US', 'USA', 'الولايات المتحدة'),
(11310, 1125116416, 1125116671, 'MA', 'MAR', 'المغرب'),
(11311, 1125116672, 1125116959, 'US', 'USA', 'الولايات المتحدة'),
(11312, 1125116960, 1125116991, 'JP', 'JPN', 'اليابان'),
(11313, 1125116992, 1125117023, 'US', 'USA', 'الولايات المتحدة'),
(11314, 1125117024, 1125117055, 'BR', 'BRA', 'البرازيل'),
(11315, 1125117056, 1125117151, 'US', 'USA', 'الولايات المتحدة'),
(11316, 1125117152, 1125117167, 'UY', 'URY', 'الأوروغواي'),
(11317, 1125117168, 1125117183, 'US', 'USA', 'الولايات المتحدة'),
(11318, 1125117184, 1125117439, 'MA', 'MAR', 'المغرب'),
(11319, 1125117440, 1125118495, 'US', 'USA', 'الولايات المتحدة'),
(11320, 1125118496, 1125118511, 'BR', 'BRA', 'البرازيل'),
(11321, 1125118512, 1125118527, 'US', 'USA', 'الولايات المتحدة'),
(11322, 1125118528, 1125118559, 'UY', 'URY', 'الأوروغواي'),
(11323, 1125118560, 1125118591, 'TR', 'TUR', 'تركيا'),
(11324, 1125118592, 1125118655, 'US', 'USA', 'الولايات المتحدة'),
(11325, 1125118656, 1125118687, 'IL', 'ISR', 'إسرائيل'),
(11326, 1125118688, 1125118719, 'BR', 'BRA', 'البرازيل'),
(11327, 1125118720, 1125119199, 'US', 'USA', 'الولايات المتحدة'),
(11328, 1125119200, 1125119231, 'TR', 'TUR', 'تركيا'),
(11329, 1125119232, 1125119743, 'US', 'USA', 'الولايات المتحدة'),
(11330, 1125119744, 1125119871, 'RO', 'ROM', 'رومانيا'),
(11331, 1125119872, 1125119903, 'US', 'USA', 'الولايات المتحدة'),
(11332, 1125119904, 1125119935, 'IL', 'ISR', 'إسرائيل'),
(11333, 1125119936, 1125119967, 'JP', 'JPN', 'اليابان'),
(11334, 1125119968, 1125120255, 'US', 'USA', 'الولايات المتحدة'),
(11335, 1125120256, 1125120511, 'MA', 'MAR', 'المغرب'),
(11336, 1125120512, 1125120767, 'US', 'USA', 'الولايات المتحدة'),
(11337, 1125120768, 1125120799, 'UY', 'URY', 'الأوروغواي'),
(11338, 1125120800, 1125120831, 'IL', 'ISR', 'إسرائيل'),
(11339, 1125120832, 1125120847, 'TH', 'THA', 'تايلند'),
(11340, 1125120848, 1125120863, 'US', 'USA', 'الولايات المتحدة'),
(11341, 1125120864, 1125120895, 'GB', 'GBR', 'المملكة المتحدة'),
(11342, 1125120896, 1125121023, 'RO', 'ROM', 'رومانيا'),
(11343, 1125121024, 1125457919, 'US', 'USA', 'الولايات المتحدة'),
(11344, 1125458944, 1125459455, 'US', 'USA', 'الولايات المتحدة'),
(11345, 1125462016, 1125474303, 'US', 'USA', 'الولايات المتحدة'),
(11346, 1125474304, 1125478399, 'CA', 'CAN', 'كندا'),
(11347, 1125478400, 1125498879, 'US', 'USA', 'الولايات المتحدة'),
(11348, 1125498880, 1125515263, 'CA', 'CAN', 'كندا'),
(11349, 1125515264, 1125531647, 'US', 'USA', 'الولايات المتحدة'),
(11350, 1125531648, 1125543935, 'CA', 'CAN', 'كندا'),
(11351, 1125543936, 1125545983, 'US', 'USA', 'الولايات المتحدة'),
(11352, 1125548032, 1125552127, 'CA', 'CAN', 'كندا'),
(11353, 1125552128, 1125560319, 'US', 'USA', 'الولايات المتحدة'),
(11354, 1125564416, 1125572607, 'US', 'USA', 'الولايات المتحدة'),
(11355, 1125572608, 1125576703, 'CA', 'CAN', 'كندا'),
(11356, 1125576704, 1125593087, 'US', 'USA', 'الولايات المتحدة'),
(11357, 1125597184, 1125613567, 'US', 'USA', 'الولايات المتحدة'),
(11358, 1125613568, 1125617663, 'CA', 'CAN', 'كندا'),
(11359, 1125617664, 1125626623, 'US', 'USA', 'الولايات المتحدة'),
(11360, 1125626624, 1125626879, 'IN', 'IND', 'الهند'),
(11361, 1125626880, 1125642239, 'US', 'USA', 'الولايات المتحدة'),
(11362, 1125646336, 1126009343, 'US', 'USA', 'الولايات المتحدة'),
(11363, 1126009344, 1126009599, 'AR', 'ARG', 'الأرجنتين'),
(11364, 1126009600, 1126924287, 'US', 'USA', 'الولايات المتحدة'),
(11365, 1126924288, 1126928383, 'CA', 'CAN', 'كندا'),
(11366, 1126928384, 1126948863, 'US', 'USA', 'الولايات المتحدة'),
(11367, 1126948864, 1126952959, 'CA', 'CAN', 'كندا'),
(11368, 1126952960, 1127677951, 'US', 'USA', 'الولايات المتحدة'),
(11369, 1127677952, 1127694335, 'CA', 'CAN', 'كندا'),
(11370, 1127694336, 1127874559, 'US', 'USA', 'الولايات المتحدة'),
(11371, 1127882752, 1127923711, 'US', 'USA', 'الولايات المتحدة'),
(11372, 1127923712, 1127931903, 'CA', 'CAN', 'كندا'),
(11373, 1127931904, 1128529919, 'US', 'USA', 'الولايات المتحدة'),
(11374, 1128529920, 1128641023, 'CA', 'CAN', 'كندا'),
(11375, 1128641024, 1128641535, 'US', 'USA', 'الولايات المتحدة'),
(11376, 1128641536, 1128792063, 'CA', 'CAN', 'كندا'),
(11377, 1128792064, 1128818687, 'US', 'USA', 'الولايات المتحدة'),
(11378, 1128818688, 1128818719, 'CA', 'CAN', 'كندا'),
(11379, 1128818720, 1130536959, 'US', 'USA', 'الولايات المتحدة'),
(11380, 1130536960, 1130539007, 'GU', 'GUM', 'غوام'),
(11381, 1130539008, 1132764423, 'US', 'USA', 'الولايات المتحدة'),
(11382, 1132764424, 1132764431, 'MX', 'MEX', 'المكسيك'),
(11383, 1132764432, 1132947431, 'US', 'USA', 'الولايات المتحدة'),
(11384, 1132947432, 1132947439, 'CA', 'CAN', 'كندا'),
(11385, 1132947440, 1133785375, 'US', 'USA', 'الولايات المتحدة'),
(11386, 1133785376, 1133785383, 'NE', 'NER', 'النيجر'),
(11387, 1133785384, 1133785471, 'US', 'USA', 'الولايات المتحدة'),
(11388, 1133785472, 1133785503, 'GB', 'GBR', 'المملكة المتحدة'),
(11389, 1133785504, 1134444543, 'US', 'USA', 'الولايات المتحدة'),
(11390, 1134444544, 1134448639, 'CA', 'CAN', 'كندا'),
(11391, 1134448640, 1134546943, 'US', 'USA', 'الولايات المتحدة'),
(11392, 1134546944, 1134551039, 'CA', 'CAN', 'كندا'),
(11393, 1134551040, 1136517007, 'US', 'USA', 'الولايات المتحدة'),
(11394, 1136517008, 1136517023, 'GB', 'GBR', 'المملكة المتحدة'),
(11395, 1136517024, 1136517039, 'US', 'USA', 'الولايات المتحدة'),
(11396, 1136517040, 1136517055, 'GB', 'GBR', 'المملكة المتحدة'),
(11397, 1136517056, 1136721919, 'US', 'USA', 'الولايات المتحدة'),
(11398, 1136721920, 1136787455, 'CA', 'CAN', 'كندا'),
(11399, 1136787456, 1137195519, 'US', 'USA', 'الولايات المتحدة'),
(11400, 1137195520, 1137195775, 'JP', 'JPN', 'اليابان'),
(11401, 1137195776, 1137278975, 'US', 'USA', 'الولايات المتحدة'),
(11402, 1137278976, 1137283071, 'CA', 'CAN', 'كندا'),
(11403, 1137283072, 1137287167, 'US', 'USA', 'الولايات المتحدة'),
(11404, 1137287168, 1137295359, 'CA', 'CAN', 'كندا'),
(11405, 1137295360, 1137426431, 'US', 'USA', 'الولايات المتحدة'),
(11406, 1137426432, 1137442815, 'PR', 'PRI', 'بورتو ريكو'),
(11407, 1137442816, 1137459199, 'CA', 'CAN', 'كندا'),
(11408, 1137459200, 1137491967, 'US', 'USA', 'الولايات المتحدة'),
(11409, 1137491968, 1137508351, 'CA', 'CAN', 'كندا'),
(11410, 1137508352, 1137524735, 'US', 'USA', 'الولايات المتحدة'),
(11411, 1137524736, 1137541119, 'CA', 'CAN', 'كندا'),
(11412, 1137541120, 1137598463, 'US', 'USA', 'الولايات المتحدة'),
(11413, 1137606656, 1137623039, 'US', 'USA', 'الولايات المتحدة'),
(11414, 1137623040, 1137639423, 'PR', 'PRI', 'بورتو ريكو'),
(11415, 1137639424, 1137704959, 'US', 'USA', 'الولايات المتحدة'),
(11416, 1137704960, 1137713151, 'CA', 'CAN', 'كندا'),
(11417, 1137713152, 1137785855, 'US', 'USA', 'الولايات المتحدة'),
(11418, 1137785856, 1137786111, 'HU', 'HUN', 'هنغاريا'),
(11419, 1137786112, 1137843711, 'US', 'USA', 'الولايات المتحدة'),
(11420, 1137843712, 1137843775, 'NO', 'NOR', 'النرويج'),
(11421, 1137843776, 1137868799, 'US', 'USA', 'الولايات المتحدة'),
(11422, 1137868800, 1137872895, 'CA', 'CAN', 'كندا'),
(11423, 1137872896, 1137876991, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(11424, 1137876992, 1137881087, 'CA', 'CAN', 'كندا'),
(11425, 1137881088, 1137889279, 'US', 'USA', 'الولايات المتحدة'),
(11426, 1137889280, 1137893375, 'CA', 'CAN', 'كندا'),
(11427, 1137893376, 1137917951, 'US', 'USA', 'الولايات المتحدة'),
(11428, 1137917952, 1137922047, 'CA', 'CAN', 'كندا'),
(11429, 1137922048, 1137926143, 'US', 'USA', 'الولايات المتحدة'),
(11430, 1137926144, 1137934335, 'CA', 'CAN', 'كندا'),
(11431, 1137934336, 1137953023, 'US', 'USA', 'الولايات المتحدة'),
(11432, 1137953024, 1137954815, 'CA', 'CAN', 'كندا'),
(11433, 1137954816, 1137963007, 'US', 'USA', 'الولايات المتحدة'),
(11434, 1137963008, 1137967103, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(11435, 1137967104, 1137975295, 'CA', 'CAN', 'كندا'),
(11436, 1137975296, 1137983487, 'US', 'USA', 'الولايات المتحدة'),
(11437, 1137983488, 1137983839, 'CA', 'CAN', 'كندا'),
(11438, 1137983840, 1137983863, 'RU', 'RUS', 'الإتحاد الروسي'),
(11439, 1137983864, 1137991679, 'CA', 'CAN', 'كندا'),
(11440, 1137991680, 1138049023, 'US', 'USA', 'الولايات المتحدة'),
(11441, 1138049024, 1138049919, 'CA', 'CAN', 'كندا'),
(11442, 1138049920, 1138050047, 'US', 'USA', 'الولايات المتحدة'),
(11443, 1138050048, 1138050175, 'CA', 'CAN', 'كندا'),
(11444, 1138050176, 1138050303, 'US', 'USA', 'الولايات المتحدة'),
(11445, 1138050304, 1138061311, 'CA', 'CAN', 'كندا'),
(11446, 1138061312, 1138163711, 'US', 'USA', 'الولايات المتحدة'),
(11447, 1138163712, 1138167039, 'CA', 'CAN', 'كندا'),
(11448, 1138167040, 1138167199, 'MA', 'MAR', 'المغرب'),
(11449, 1138167200, 1138167807, 'CA', 'CAN', 'كندا'),
(11450, 1138167808, 1138175999, 'US', 'USA', 'الولايات المتحدة'),
(11451, 1138176000, 1138180095, 'CA', 'CAN', 'كندا'),
(11452, 1138180096, 1138188287, 'US', 'USA', 'الولايات المتحدة'),
(11453, 1138188288, 1138192383, 'PR', 'PRI', 'بورتو ريكو'),
(11454, 1138192384, 1138196479, 'US', 'USA', 'الولايات المتحدة'),
(11455, 1138196480, 1138204671, 'CA', 'CAN', 'كندا'),
(11456, 1138204672, 1138212863, 'US', 'USA', 'الولايات المتحدة'),
(11457, 1138212864, 1138216959, 'CA', 'CAN', 'كندا'),
(11458, 1138216960, 1138417663, 'US', 'USA', 'الولايات المتحدة'),
(11459, 1138417664, 1138417695, 'CA', 'CAN', 'كندا'),
(11460, 1138417696, 1138480127, 'US', 'USA', 'الولايات المتحدة'),
(11461, 1138480128, 1138482687, 'AU', 'AUS', 'أستراليا'),
(11462, 1138482688, 1138499583, 'US', 'USA', 'الولايات المتحدة'),
(11463, 1138499584, 1138503679, 'CA', 'CAN', 'كندا'),
(11464, 1138503680, 1138544895, 'US', 'USA', 'الولايات المتحدة'),
(11465, 1138544896, 1138545151, 'GB', 'GBR', 'المملكة المتحدة'),
(11466, 1138545152, 1138548735, 'US', 'USA', 'الولايات المتحدة'),
(11467, 1138548736, 1138556927, 'CA', 'CAN', 'كندا'),
(11468, 1138556928, 1138593791, 'US', 'USA', 'الولايات المتحدة'),
(11469, 1138593792, 1138597887, 'CA', 'CAN', 'كندا'),
(11470, 1138597888, 1138704383, 'US', 'USA', 'الولايات المتحدة'),
(11471, 1138704384, 1138716671, 'CA', 'CAN', 'كندا'),
(11472, 1138716672, 1138720767, 'US', 'USA', 'الولايات المتحدة'),
(11473, 1138720768, 1138728959, 'CA', 'CAN', 'كندا'),
(11474, 1138728960, 1138774015, 'US', 'USA', 'الولايات المتحدة'),
(11475, 1138774016, 1138778111, 'CA', 'CAN', 'كندا'),
(11476, 1138778112, 1138786303, 'US', 'USA', 'الولايات المتحدة'),
(11477, 1138786304, 1138819071, 'PR', 'PRI', 'بورتو ريكو'),
(11478, 1138819072, 1138851839, 'CA', 'CAN', 'كندا'),
(11479, 1138851840, 1138917375, 'US', 'USA', 'الولايات المتحدة'),
(11480, 1138917376, 1138937855, 'CA', 'CAN', 'كندا'),
(11481, 1138941952, 1138950143, 'CA', 'CAN', 'كندا'),
(11482, 1138950144, 1139146751, 'US', 'USA', 'الولايات المتحدة'),
(11483, 1139146752, 1139154943, 'GT', 'GTM', 'غواتيمالا'),
(11484, 1139154944, 1139167231, 'JM', 'JAM', 'جامايكا'),
(11485, 1139167232, 1139179519, 'US', 'USA', 'الولايات المتحدة'),
(11486, 1139179520, 1139195903, 'CA', 'CAN', 'كندا'),
(11487, 1139195904, 1139204095, 'US', 'USA', 'الولايات المتحدة'),
(11488, 1139212288, 1139261439, 'US', 'USA', 'الولايات المتحدة'),
(11489, 1139261440, 1139265023, 'CA', 'CAN', 'كندا'),
(11490, 1139265024, 1139265535, 'US', 'USA', 'الولايات المتحدة'),
(11491, 1139265536, 1139269631, 'CA', 'CAN', 'كندا'),
(11492, 1139269632, 1140793343, 'US', 'USA', 'الولايات المتحدة'),
(11493, 1140850688, 1145141247, 'US', 'USA', 'الولايات المتحدة'),
(11494, 1145142784, 1145188351, 'US', 'USA', 'الولايات المتحدة'),
(11495, 1145188352, 1145192447, 'CA', 'CAN', 'كندا'),
(11496, 1145192448, 1145249791, 'US', 'USA', 'الولايات المتحدة'),
(11497, 1145249792, 1145257983, 'CA', 'CAN', 'كندا'),
(11498, 1145257984, 1145262079, 'US', 'USA', 'الولايات المتحدة'),
(11499, 1145262080, 1145266175, 'CA', 'CAN', 'كندا'),
(11500, 1145266176, 1145307135, 'US', 'USA', 'الولايات المتحدة'),
(11501, 1145307136, 1145311231, 'CA', 'CAN', 'كندا'),
(11502, 1145315328, 1145376767, 'US', 'USA', 'الولايات المتحدة'),
(11503, 1145376768, 1145380863, 'CA', 'CAN', 'كندا'),
(11504, 1145380864, 1145405439, 'US', 'USA', 'الولايات المتحدة'),
(11505, 1145405440, 1145409535, 'CA', 'CAN', 'كندا'),
(11506, 1145413632, 1145421823, 'US', 'USA', 'الولايات المتحدة'),
(11507, 1145421824, 1145430015, 'CA', 'CAN', 'كندا'),
(11508, 1145430016, 1145434111, 'US', 'USA', 'الولايات المتحدة'),
(11509, 1145438208, 1145475071, 'US', 'USA', 'الولايات المتحدة'),
(11510, 1145479168, 1145491455, 'US', 'USA', 'الولايات المتحدة'),
(11511, 1145503744, 1145520127, 'CA', 'CAN', 'كندا'),
(11512, 1145520128, 1145552895, 'US', 'USA', 'الولايات المتحدة'),
(11513, 1145552896, 1145556991, 'CA', 'CAN', 'كندا'),
(11514, 1145556992, 1150287871, 'US', 'USA', 'الولايات المتحدة'),
(11515, 1150287872, 1150812159, 'CA', 'CAN', 'كندا'),
(11516, 1150812160, 1151889407, 'US', 'USA', 'الولايات المتحدة'),
(11517, 1151889408, 1151897599, 'CA', 'CAN', 'كندا'),
(11518, 1151897600, 1151950847, 'US', 'USA', 'الولايات المتحدة'),
(11519, 1151959040, 1152020479, 'US', 'USA', 'الولايات المتحدة'),
(11520, 1152024576, 1152028671, 'US', 'USA', 'الولايات المتحدة'),
(11521, 1152032768, 1152045055, 'US', 'USA', 'الولايات المتحدة'),
(11522, 1152049152, 1152057343, 'US', 'USA', 'الولايات المتحدة'),
(11523, 1152057344, 1152061439, 'CA', 'CAN', 'كندا'),
(11524, 1152061440, 1152073727, 'US', 'USA', 'الولايات المتحدة'),
(11525, 1152073728, 1152077823, 'CA', 'CAN', 'كندا'),
(11526, 1152077824, 1152094207, 'US', 'USA', 'الولايات المتحدة'),
(11527, 1152098304, 1152102399, 'US', 'USA', 'الولايات المتحدة'),
(11528, 1152106496, 1152114687, 'US', 'USA', 'الولايات المتحدة'),
(11529, 1152114688, 1152122879, 'CA', 'CAN', 'كندا'),
(11530, 1152122880, 1152581631, 'US', 'USA', 'الولايات المتحدة'),
(11531, 1152581632, 1152614399, 'CA', 'CAN', 'كندا'),
(11532, 1152614400, 1152778239, 'US', 'USA', 'الولايات المتحدة'),
(11533, 1152778240, 1152843775, 'CA', 'CAN', 'كندا'),
(11534, 1152843776, 1156071423, 'US', 'USA', 'الولايات المتحدة'),
(11535, 1156071424, 1156079615, 'CA', 'CAN', 'كندا'),
(11536, 1156079616, 1156157439, 'US', 'USA', 'الولايات المتحدة'),
(11537, 1156161536, 1156169727, 'US', 'USA', 'الولايات المتحدة'),
(11538, 1156177920, 1156276223, 'US', 'USA', 'الولايات المتحدة'),
(11539, 1156284416, 1156296703, 'US', 'USA', 'الولايات المتحدة'),
(11540, 1156296704, 1156300799, 'CA', 'CAN', 'كندا'),
(11541, 1156300800, 1157713663, 'US', 'USA', 'الولايات المتحدة'),
(11542, 1157713664, 1157713791, 'CA', 'CAN', 'كندا'),
(11543, 1157713792, 1157931007, 'US', 'USA', 'الولايات المتحدة'),
(11544, 1157931008, 1157935103, 'BS', 'BHS', 'جزر البهاما'),
(11545, 1157935104, 1157943295, 'US', 'USA', 'الولايات المتحدة'),
(11546, 1157943296, 1157947391, 'CA', 'CAN', 'كندا'),
(11547, 1157947392, 1157950919, 'US', 'USA', 'الولايات المتحدة'),
(11548, 1157950920, 1157950975, 'HK', 'HKG', 'هونغ كونغ'),
(11549, 1157950976, 1158027263, 'US', 'USA', 'الولايات المتحدة'),
(11550, 1158027264, 1158027519, 'CA', 'CAN', 'كندا'),
(11551, 1158027520, 1158028287, 'US', 'USA', 'الولايات المتحدة'),
(11552, 1158028288, 1158028543, 'CA', 'CAN', 'كندا'),
(11553, 1158028544, 1158041599, 'US', 'USA', 'الولايات المتحدة'),
(11554, 1158045696, 1158148095, 'US', 'USA', 'الولايات المتحدة'),
(11555, 1158148096, 1158152191, 'CA', 'CAN', 'كندا'),
(11556, 1158152192, 1158193151, 'US', 'USA', 'الولايات المتحدة'),
(11557, 1158197248, 1158294719, 'US', 'USA', 'الولايات المتحدة'),
(11558, 1158294720, 1158294751, 'GB', 'GBR', 'المملكة المتحدة'),
(11559, 1158294752, 1158295807, 'US', 'USA', 'الولايات المتحدة'),
(11560, 1158295808, 1158296063, 'GB', 'GBR', 'المملكة المتحدة'),
(11561, 1158296064, 1158316031, 'US', 'USA', 'الولايات المتحدة'),
(11562, 1158316032, 1158320031, 'CA', 'CAN', 'كندا'),
(11563, 1158320032, 1158320047, 'SY', 'SYR', 'سوريا'),
(11564, 1158320048, 1158322671, 'CA', 'CAN', 'كندا'),
(11565, 1158322672, 1158322687, 'SY', 'SYR', 'سوريا'),
(11566, 1158322688, 1158324223, 'CA', 'CAN', 'كندا'),
(11567, 1158324224, 1158340607, 'US', 'USA', 'الولايات المتحدة'),
(11568, 1158340608, 1158343199, 'CA', 'CAN', 'كندا'),
(11569, 1158343200, 1158343231, 'US', 'USA', 'الولايات المتحدة'),
(11570, 1158343232, 1158344703, 'CA', 'CAN', 'كندا'),
(11571, 1158344704, 1158348799, 'US', 'USA', 'الولايات المتحدة'),
(11572, 1158348800, 1158381567, 'CA', 'CAN', 'كندا'),
(11573, 1158381568, 1158774783, 'US', 'USA', 'الولايات المتحدة'),
(11574, 1158774784, 1158791167, 'CA', 'CAN', 'كندا'),
(11575, 1158791168, 1158794239, 'BM', 'BMU', 'برمودا'),
(11576, 1158794240, 1158794495, 'US', 'USA', 'الولايات المتحدة'),
(11577, 1158794496, 1158799359, 'BM', 'BMU', 'برمودا'),
(11578, 1158799360, 1158807551, 'CA', 'CAN', 'كندا'),
(11579, 1158807552, 1158995967, 'US', 'USA', 'الولايات المتحدة'),
(11580, 1158995968, 1159004159, 'CA', 'CAN', 'كندا'),
(11581, 1159004160, 1159213055, 'US', 'USA', 'الولايات المتحدة'),
(11582, 1159213056, 1159217151, 'CA', 'CAN', 'كندا'),
(11583, 1159217152, 1159314367, 'US', 'USA', 'الولايات المتحدة'),
(11584, 1159314368, 1159314383, 'BR', 'BRA', 'البرازيل'),
(11585, 1159314384, 1159348223, 'US', 'USA', 'الولايات المتحدة'),
(11586, 1159348224, 1159356415, 'CA', 'CAN', 'كندا'),
(11587, 1159356416, 1159421951, 'US', 'USA', 'الولايات المتحدة'),
(11588, 1159421952, 1159430143, 'CA', 'CAN', 'كندا'),
(11589, 1159430144, 1159512575, 'US', 'USA', 'الولايات المتحدة'),
(11590, 1159512576, 1159512831, 'CA', 'CAN', 'كندا'),
(11591, 1159512832, 1159514111, 'US', 'USA', 'الولايات المتحدة'),
(11592, 1159514112, 1159514367, 'CA', 'CAN', 'كندا'),
(11593, 1159514368, 1159515391, 'US', 'USA', 'الولايات المتحدة'),
(11594, 1159515392, 1159515647, 'CA', 'CAN', 'كندا'),
(11595, 1159515648, 1159515807, 'US', 'USA', 'الولايات المتحدة'),
(11596, 1159515808, 1159515839, 'CA', 'CAN', 'كندا'),
(11597, 1159515840, 1159515903, 'US', 'USA', 'الولايات المتحدة'),
(11598, 1159515904, 1159516159, 'CA', 'CAN', 'كندا'),
(11599, 1159516160, 1159519743, 'US', 'USA', 'الولايات المتحدة'),
(11600, 1159519744, 1159520255, 'CA', 'CAN', 'كندا'),
(11601, 1159520256, 1159521535, 'US', 'USA', 'الولايات المتحدة'),
(11602, 1159521536, 1159521791, 'CA', 'CAN', 'كندا'),
(11603, 1159521792, 1159522287, 'US', 'USA', 'الولايات المتحدة'),
(11604, 1159522288, 1159522303, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11605, 1159522304, 1159522815, 'CA', 'CAN', 'كندا'),
(11606, 1159522816, 1159523583, 'US', 'USA', 'الولايات المتحدة'),
(11607, 1159523584, 1159523839, 'CA', 'CAN', 'كندا'),
(11608, 1159523840, 1159524095, 'US', 'USA', 'الولايات المتحدة'),
(11609, 1159524096, 1159524351, 'CA', 'CAN', 'كندا'),
(11610, 1159524352, 1159525375, 'US', 'USA', 'الولايات المتحدة'),
(11611, 1159525376, 1159526399, 'CA', 'CAN', 'كندا'),
(11612, 1159526400, 1159527935, 'US', 'USA', 'الولايات المتحدة'),
(11613, 1159527936, 1159528191, 'CA', 'CAN', 'كندا'),
(11614, 1159528192, 1159700479, 'US', 'USA', 'الولايات المتحدة'),
(11615, 1159700480, 1159725055, 'CA', 'CAN', 'كندا'),
(11616, 1159725056, 1160011775, 'US', 'USA', 'الولايات المتحدة'),
(11617, 1160011776, 1160019967, 'CA', 'CAN', 'كندا'),
(11618, 1160019968, 1160245247, 'US', 'USA', 'الولايات المتحدة'),
(11619, 1160249344, 1160364031, 'US', 'USA', 'الولايات المتحدة'),
(11620, 1160364032, 1160368127, 'CA', 'CAN', 'كندا'),
(11621, 1160368128, 1160392703, 'US', 'USA', 'الولايات المتحدة'),
(11622, 1160392704, 1160395519, 'CA', 'CAN', 'كندا'),
(11623, 1160395520, 1160395775, 'US', 'USA', 'الولايات المتحدة'),
(11624, 1160395776, 1160396799, 'CA', 'CAN', 'كندا'),
(11625, 1160396800, 1160397007, 'US', 'USA', 'الولايات المتحدة'),
(11626, 1160397008, 1160397023, 'GB', 'GBR', 'المملكة المتحدة'),
(11627, 1160397024, 1160415637, 'US', 'USA', 'الولايات المتحدة'),
(11628, 1160415638, 1160415733, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11629, 1160415734, 1160425471, 'US', 'USA', 'الولايات المتحدة'),
(11630, 1160425472, 1160429567, 'CA', 'CAN', 'كندا'),
(11631, 1160429568, 1160543327, 'US', 'USA', 'الولايات المتحدة'),
(11632, 1160543328, 1160543359, 'MX', 'MEX', 'المكسيك'),
(11633, 1160543360, 1160544055, 'US', 'USA', 'الولايات المتحدة'),
(11634, 1160544056, 1160544071, 'CA', 'CAN', 'كندا'),
(11635, 1160544072, 1160547839, 'US', 'USA', 'الولايات المتحدة'),
(11636, 1160547840, 1160548351, 'MX', 'MEX', 'المكسيك'),
(11637, 1160548352, 1160563199, 'US', 'USA', 'الولايات المتحدة'),
(11638, 1160563200, 1160563711, 'MP', 'MNP', 'جزر ماريانا الشمالية'),
(11639, 1160563712, 1160609791, 'US', 'USA', 'الولايات المتحدة'),
(11640, 1160609792, 1160610815, 'MX', 'MEX', 'المكسيك'),
(11641, 1160610816, 1160658943, 'US', 'USA', 'الولايات المتحدة'),
(11642, 1160667136, 1160675327, 'CA', 'CAN', 'كندا'),
(11643, 1160675328, 1160677015, 'US', 'USA', 'الولايات المتحدة'),
(11644, 1160677016, 1160677023, 'AR', 'ARG', 'الأرجنتين'),
(11645, 1160677024, 1160677247, 'US', 'USA', 'الولايات المتحدة'),
(11646, 1160677248, 1160677279, 'GB', 'GBR', 'المملكة المتحدة'),
(11647, 1160677280, 1160677375, 'US', 'USA', 'الولايات المتحدة'),
(11648, 1160677376, 1160677439, 'GB', 'GBR', 'المملكة المتحدة'),
(11649, 1160677440, 1160678399, 'US', 'USA', 'الولايات المتحدة'),
(11650, 1160678400, 1160678655, 'MX', 'MEX', 'المكسيك'),
(11651, 1160678656, 1160683519, 'US', 'USA', 'الولايات المتحدة'),
(11652, 1160683520, 1160691711, 'CA', 'CAN', 'كندا'),
(11653, 1160691712, 1160701439, 'US', 'USA', 'الولايات المتحدة'),
(11654, 1160701440, 1160701567, 'KY', 'CYM', 'جزر كايمان'),
(11655, 1160701568, 1160702447, 'US', 'USA', 'الولايات المتحدة'),
(11656, 1160702448, 1160702455, 'KY', 'CYM', 'جزر كايمان'),
(11657, 1160702456, 1160702703, 'US', 'USA', 'الولايات المتحدة'),
(11658, 1160702704, 1160702711, 'KY', 'CYM', 'جزر كايمان'),
(11659, 1160702712, 1160702783, 'US', 'USA', 'الولايات المتحدة'),
(11660, 1160702784, 1160702847, 'KY', 'CYM', 'جزر كايمان'),
(11661, 1160702848, 1160808255, 'US', 'USA', 'الولايات المتحدة'),
(11662, 1160808256, 1160808287, 'CA', 'CAN', 'كندا'),
(11663, 1160808288, 1160811551, 'US', 'USA', 'الولايات المتحدة'),
(11664, 1160811552, 1160811559, 'BE', 'BEL', 'بلجيكا'),
(11665, 1160811560, 1160847359, 'US', 'USA', 'الولايات المتحدة'),
(11666, 1160847360, 1160855551, 'CA', 'CAN', 'كندا'),
(11667, 1160855552, 1160863999, 'US', 'USA', 'الولايات المتحدة'),
(11668, 1160864000, 1160864255, 'CA', 'CAN', 'كندا'),
(11669, 1160864256, 1160921087, 'US', 'USA', 'الولايات المتحدة'),
(11670, 1160921088, 1160925183, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11671, 1160925184, 1160941535, 'US', 'USA', 'الولايات المتحدة'),
(11672, 1160941536, 1160941567, 'CA', 'CAN', 'كندا'),
(11673, 1160941568, 1160945663, 'US', 'USA', 'الولايات المتحدة'),
(11674, 1160953856, 1161019391, 'US', 'USA', 'الولايات المتحدة'),
(11675, 1161019392, 1161035775, 'CA', 'CAN', 'كندا'),
(11676, 1161035776, 1161285631, 'US', 'USA', 'الولايات المتحدة'),
(11677, 1161289728, 1161293823, 'US', 'USA', 'الولايات المتحدة'),
(11678, 1161293824, 1161297919, 'CA', 'CAN', 'كندا'),
(11679, 1161297920, 1161298303, 'US', 'USA', 'الولايات المتحدة'),
(11680, 1161298304, 1161298311, 'IL', 'ISR', 'إسرائيل'),
(11681, 1161298312, 1161304591, 'US', 'USA', 'الولايات المتحدة'),
(11682, 1161304592, 1161304599, 'AU', 'AUS', 'أستراليا'),
(11683, 1161304600, 1161311743, 'US', 'USA', 'الولايات المتحدة'),
(11684, 1161311744, 1161311759, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11685, 1161311760, 1161311991, 'US', 'USA', 'الولايات المتحدة'),
(11686, 1161311992, 1161311999, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11687, 1161312000, 1161312839, 'US', 'USA', 'الولايات المتحدة'),
(11688, 1161312840, 1161312855, 'BS', 'BHS', 'جزر البهاما'),
(11689, 1161312856, 1161312863, 'US', 'USA', 'الولايات المتحدة'),
(11690, 1161312864, 1161312871, 'BS', 'BHS', 'جزر البهاما'),
(11691, 1161312872, 1161312991, 'US', 'USA', 'الولايات المتحدة'),
(11692, 1161312992, 1161312999, 'IL', 'ISR', 'إسرائيل'),
(11693, 1161313000, 1161313127, 'US', 'USA', 'الولايات المتحدة'),
(11694, 1161313128, 1161313135, 'BS', 'BHS', 'جزر البهاما'),
(11695, 1161313136, 1161314151, 'US', 'USA', 'الولايات المتحدة'),
(11696, 1161314152, 1161314159, 'CA', 'CAN', 'كندا'),
(11697, 1161314160, 1161363455, 'US', 'USA', 'الولايات المتحدة'),
(11698, 1161363456, 1161367551, 'CA', 'CAN', 'كندا'),
(11699, 1161367552, 1161416703, 'US', 'USA', 'الولايات المتحدة'),
(11700, 1161420800, 1161422079, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11701, 1161422080, 1161422335, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11702, 1161422336, 1161422591, 'LC', 'LCA', 'سانت لوسيا'),
(11703, 1161422592, 1161422847, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11704, 1161422848, 1161423103, 'LC', 'LCA', 'سانت لوسيا'),
(11705, 1161423104, 1161423359, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11706, 1161423360, 1161423871, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11707, 1161423872, 1161424127, 'LC', 'LCA', 'سانت لوسيا'),
(11708, 1161424128, 1161424383, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11709, 1161424384, 1161424639, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11710, 1161424640, 1161424895, 'LC', 'LCA', 'سانت لوسيا'),
(11711, 1161424896, 1161425151, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11712, 1161425152, 1161425407, 'DM', 'DMA', 'دومينيكا'),
(11713, 1161425408, 1161427199, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11714, 1161427200, 1161427455, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11715, 1161427456, 1161428223, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11716, 1161428224, 1161428991, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(11717, 1161428992, 1161453567, 'US', 'USA', 'الولايات المتحدة'),
(11718, 1161453568, 1161457663, 'CA', 'CAN', 'كندا'),
(11719, 1161457664, 1161576447, 'US', 'USA', 'الولايات المتحدة'),
(11720, 1161576448, 1161580543, 'CA', 'CAN', 'كندا'),
(11721, 1161580544, 1161617407, 'US', 'USA', 'الولايات المتحدة'),
(11722, 1161617408, 1161625599, 'CA', 'CAN', 'كندا'),
(11723, 1161625600, 1161653503, 'US', 'USA', 'الولايات المتحدة'),
(11724, 1161653504, 1161653759, 'CA', 'CAN', 'كندا'),
(11725, 1161653760, 1161764863, 'US', 'USA', 'الولايات المتحدة'),
(11726, 1161764864, 1161773055, 'CA', 'CAN', 'كندا'),
(11727, 1161777152, 1161818111, 'US', 'USA', 'الولايات المتحدة'),
(11728, 1161818112, 1161822207, 'CA', 'CAN', 'كندا'),
(11729, 1161822208, 1161837567, 'US', 'USA', 'الولايات المتحدة'),
(11730, 1161837568, 1161837823, 'JP', 'JPN', 'اليابان'),
(11731, 1161837824, 1162018815, 'US', 'USA', 'الولايات المتحدة'),
(11732, 1162018816, 1162022911, 'CA', 'CAN', 'كندا'),
(11733, 1162022912, 1162027007, 'US', 'USA', 'الولايات المتحدة'),
(11734, 1162031104, 1162059775, 'US', 'USA', 'الولايات المتحدة'),
(11735, 1162059776, 1162067967, 'CA', 'CAN', 'كندا'),
(11736, 1162067968, 1162215423, 'US', 'USA', 'الولايات المتحدة'),
(11737, 1162215424, 1162280959, 'CA', 'CAN', 'كندا'),
(11738, 1162280960, 1162297343, 'US', 'USA', 'الولايات المتحدة'),
(11739, 1162297344, 1162305535, 'CA', 'CAN', 'كندا'),
(11740, 1162305536, 1162394463, 'US', 'USA', 'الولايات المتحدة'),
(11741, 1162394464, 1162394471, 'GB', 'GBR', 'المملكة المتحدة'),
(11742, 1162394472, 1162461183, 'US', 'USA', 'الولايات المتحدة'),
(11743, 1162461184, 1162461695, 'BB', 'BRB', 'باربادوس'),
(11744, 1162461696, 1162462207, 'GD', 'GRD', 'غرينادا'),
(11745, 1162462208, 1162462975, 'BB', 'BRB', 'باربادوس'),
(11746, 1162462976, 1162463999, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(11747, 1162464000, 1162465279, 'BB', 'BRB', 'باربادوس'),
(11748, 1162465280, 1162465535, 'GD', 'GRD', 'غرينادا'),
(11749, 1162465536, 1162470911, 'BB', 'BRB', 'باربادوس'),
(11750, 1162470912, 1162471423, 'GD', 'GRD', 'غرينادا'),
(11751, 1162471424, 1162472703, 'BB', 'BRB', 'باربادوس'),
(11752, 1162472704, 1162473471, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(11753, 1162473472, 1162475007, 'GD', 'GRD', 'غرينادا'),
(11754, 1162475008, 1162477567, 'BB', 'BRB', 'باربادوس'),
(11755, 1162477568, 1162715135, 'US', 'USA', 'الولايات المتحدة'),
(11756, 1162715136, 1162723327, 'CA', 'CAN', 'كندا'),
(11757, 1162723328, 1162805247, 'US', 'USA', 'الولايات المتحدة'),
(11758, 1162805248, 1162811391, 'PR', 'PRI', 'بورتو ريكو'),
(11759, 1162811392, 1162811647, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(11760, 1162811648, 1162812159, 'US', 'USA', 'الولايات المتحدة'),
(11761, 1162812160, 1162812415, 'DO', 'DOM', 'الدومينيكان'),
(11762, 1162812416, 1162813439, 'BS', 'BHS', 'جزر البهاما'),
(11763, 1162813440, 1162821631, 'CO', 'COL', 'كولومبيا'),
(11764, 1162821632, 1162823679, 'PR', 'PRI', 'بورتو ريكو'),
(11765, 1162823680, 1162825727, 'GT', 'GTM', 'غواتيمالا'),
(11766, 1162825728, 1162827775, 'US', 'USA', 'الولايات المتحدة'),
(11767, 1162827776, 1162833919, 'PR', 'PRI', 'بورتو ريكو'),
(11768, 1162833920, 1162835967, 'GT', 'GTM', 'غواتيمالا'),
(11769, 1162835968, 1162836223, 'BS', 'BHS', 'جزر البهاما'),
(11770, 1162836224, 1162836735, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(11771, 1162836736, 1162836991, 'US', 'USA', 'الولايات المتحدة'),
(11772, 1162836992, 1162838015, 'BS', 'BHS', 'جزر البهاما'),
(11773, 1162838016, 1162870783, 'CO', 'COL', 'كولومبيا'),
(11774, 1162870784, 1162887167, 'BB', 'BRB', 'باربادوس'),
(11775, 1162903552, 1162932223, 'US', 'USA', 'الولايات المتحدة'),
(11776, 1162936320, 1163407359, 'US', 'USA', 'الولايات المتحدة'),
(11777, 1163407360, 1163411455, 'CA', 'CAN', 'كندا'),
(11778, 1163411456, 1163527023, 'US', 'USA', 'الولايات المتحدة'),
(11779, 1163527024, 1163527039, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11780, 1163527040, 1163528703, 'US', 'USA', 'الولايات المتحدة'),
(11781, 1163528704, 1163528959, 'CA', 'CAN', 'كندا'),
(11782, 1163528960, 1163531007, 'US', 'USA', 'الولايات المتحدة'),
(11783, 1163531008, 1163532287, 'CA', 'CAN', 'كندا'),
(11784, 1163532288, 1163533055, 'US', 'USA', 'الولايات المتحدة'),
(11785, 1163533056, 1163533311, 'CA', 'CAN', 'كندا'),
(11786, 1163533312, 1163533567, 'US', 'USA', 'الولايات المتحدة'),
(11787, 1163533568, 1163533631, 'CA', 'CAN', 'كندا'),
(11788, 1163533632, 1163536127, 'US', 'USA', 'الولايات المتحدة'),
(11789, 1163536128, 1163536383, 'CA', 'CAN', 'كندا'),
(11790, 1163536384, 1163537663, 'US', 'USA', 'الولايات المتحدة'),
(11791, 1163537664, 1163537919, 'CA', 'CAN', 'كندا'),
(11792, 1163537920, 1163538175, 'US', 'USA', 'الولايات المتحدة'),
(11793, 1163538176, 1163540479, 'CA', 'CAN', 'كندا'),
(11794, 1163540480, 1163540735, 'US', 'USA', 'الولايات المتحدة'),
(11795, 1163540736, 1163541503, 'CA', 'CAN', 'كندا'),
(11796, 1163541504, 1163542527, 'US', 'USA', 'الولايات المتحدة'),
(11797, 1163542528, 1163542783, 'CA', 'CAN', 'كندا'),
(11798, 1163542784, 1163543295, 'US', 'USA', 'الولايات المتحدة'),
(11799, 1163543296, 1163543551, 'CA', 'CAN', 'كندا'),
(11800, 1163543552, 1163544063, 'US', 'USA', 'الولايات المتحدة'),
(11801, 1163544064, 1163544319, 'CA', 'CAN', 'كندا'),
(11802, 1163544320, 1163544511, 'US', 'USA', 'الولايات المتحدة'),
(11803, 1163544512, 1163544575, 'CA', 'CAN', 'كندا'),
(11804, 1163544576, 1163544831, 'US', 'USA', 'الولايات المتحدة'),
(11805, 1163544832, 1163545087, 'CA', 'CAN', 'كندا'),
(11806, 1163545088, 1163546623, 'US', 'USA', 'الولايات المتحدة'),
(11807, 1163546624, 1163546879, 'CA', 'CAN', 'كندا'),
(11808, 1163546880, 1163547135, 'US', 'USA', 'الولايات المتحدة'),
(11809, 1163547136, 1163547391, 'CA', 'CAN', 'كندا'),
(11810, 1163547392, 1163547567, 'US', 'USA', 'الولايات المتحدة'),
(11811, 1163547568, 1163547583, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(11812, 1163547584, 1163547647, 'US', 'USA', 'الولايات المتحدة'),
(11813, 1163547648, 1163547903, 'CA', 'CAN', 'كندا'),
(11814, 1163547904, 1163548159, 'US', 'USA', 'الولايات المتحدة'),
(11815, 1163548160, 1163548927, 'CA', 'CAN', 'كندا'),
(11816, 1163548928, 1163549695, 'US', 'USA', 'الولايات المتحدة'),
(11817, 1163549696, 1163550207, 'CA', 'CAN', 'كندا'),
(11818, 1163550208, 1163551455, 'US', 'USA', 'الولايات المتحدة'),
(11819, 1163551456, 1163551487, 'CR', 'CRI', 'كوستا ريكا'),
(11820, 1163551488, 1163551743, 'US', 'USA', 'الولايات المتحدة'),
(11821, 1163551744, 1163552255, 'CA', 'CAN', 'كندا'),
(11822, 1163552256, 1163553023, 'US', 'USA', 'الولايات المتحدة'),
(11823, 1163553024, 1163553535, 'CA', 'CAN', 'كندا'),
(11824, 1163553536, 1163556095, 'US', 'USA', 'الولايات المتحدة'),
(11825, 1163556096, 1163556607, 'CA', 'CAN', 'كندا'),
(11826, 1163556608, 1163560959, 'US', 'USA', 'الولايات المتحدة'),
(11827, 1163560960, 1163561215, 'CA', 'CAN', 'كندا'),
(11828, 1163561216, 1163561471, 'US', 'USA', 'الولايات المتحدة'),
(11829, 1163561472, 1163561727, 'CA', 'CAN', 'كندا'),
(11830, 1163561728, 1163561983, 'FI', 'FIN', 'فنلندا'),
(11831, 1163561984, 1163562239, 'US', 'USA', 'الولايات المتحدة'),
(11832, 1163562240, 1163563007, 'CA', 'CAN', 'كندا'),
(11833, 1163563008, 1163567103, 'US', 'USA', 'الولايات المتحدة'),
(11834, 1163567104, 1163568127, 'CA', 'CAN', 'كندا'),
(11835, 1163568128, 1163571199, 'US', 'USA', 'الولايات المتحدة'),
(11836, 1163571200, 1163571711, 'CA', 'CAN', 'كندا'),
(11837, 1163571712, 1163575295, 'US', 'USA', 'الولايات المتحدة'),
(11838, 1163575296, 1163575551, 'CA', 'CAN', 'كندا'),
(11839, 1163575552, 1163576639, 'US', 'USA', 'الولايات المتحدة'),
(11840, 1163576640, 1163576703, 'CA', 'CAN', 'كندا'),
(11841, 1163576704, 1163577151, 'US', 'USA', 'الولايات المتحدة'),
(11842, 1163577152, 1163577215, 'CA', 'CAN', 'كندا'),
(11843, 1163577216, 1163578367, 'US', 'USA', 'الولايات المتحدة'),
(11844, 1163578368, 1163578495, 'CA', 'CAN', 'كندا'),
(11845, 1163578496, 1163579135, 'US', 'USA', 'الولايات المتحدة'),
(11846, 1163579136, 1163579391, 'CA', 'CAN', 'كندا'),
(11847, 1163579392, 1163581695, 'US', 'USA', 'الولايات المتحدة'),
(11848, 1163581696, 1163581951, 'CA', 'CAN', 'كندا'),
(11849, 1163581952, 1163582207, 'US', 'USA', 'الولايات المتحدة'),
(11850, 1163582208, 1163583487, 'CA', 'CAN', 'كندا'),
(11851, 1163583488, 1163588863, 'US', 'USA', 'الولايات المتحدة'),
(11852, 1163588864, 1163589631, 'CA', 'CAN', 'كندا'),
(11853, 1163589632, 1167320679, 'US', 'USA', 'الولايات المتحدة'),
(11854, 1167320680, 1167320687, 'IN', 'IND', 'الهند'),
(11855, 1167320688, 1167321959, 'US', 'USA', 'الولايات المتحدة'),
(11856, 1167321960, 1167321967, 'GB', 'GBR', 'المملكة المتحدة'),
(11857, 1167321968, 1167322695, 'US', 'USA', 'الولايات المتحدة'),
(11858, 1167322696, 1167322703, 'IN', 'IND', 'الهند'),
(11859, 1167322704, 1167323799, 'US', 'USA', 'الولايات المتحدة'),
(11860, 1167323800, 1167323807, 'IN', 'IND', 'الهند'),
(11861, 1167323808, 1167323823, 'US', 'USA', 'الولايات المتحدة'),
(11862, 1167323824, 1167323831, 'IN', 'IND', 'الهند'),
(11863, 1167323832, 1167325935, 'US', 'USA', 'الولايات المتحدة'),
(11864, 1167325936, 1167325951, 'CA', 'CAN', 'كندا'),
(11865, 1167325952, 1167326207, 'US', 'USA', 'الولايات المتحدة'),
(11866, 1167326208, 1167326271, 'IN', 'IND', 'الهند'),
(11867, 1167326272, 1167326303, 'US', 'USA', 'الولايات المتحدة'),
(11868, 1167326304, 1167326335, 'IN', 'IND', 'الهند'),
(11869, 1167326336, 1167326367, 'SI', 'SVN', 'سلوفينيا'),
(11870, 1167326368, 1167326399, 'US', 'USA', 'الولايات المتحدة'),
(11871, 1167326400, 1167326431, 'IN', 'IND', 'الهند'),
(11872, 1167326432, 1167326439, 'US', 'USA', 'الولايات المتحدة'),
(11873, 1167326440, 1167326447, 'IN', 'IND', 'الهند'),
(11874, 1167326448, 1167326463, 'US', 'USA', 'الولايات المتحدة'),
(11875, 1167326464, 1167326719, 'IN', 'IND', 'الهند'),
(11876, 1167326720, 1167326983, 'US', 'USA', 'الولايات المتحدة'),
(11877, 1167326984, 1167326991, 'IN', 'IND', 'الهند'),
(11878, 1167326992, 1167327111, 'US', 'USA', 'الولايات المتحدة'),
(11879, 1167327112, 1167327119, 'IN', 'IND', 'الهند'),
(11880, 1167327120, 1167327207, 'US', 'USA', 'الولايات المتحدة'),
(11881, 1167327208, 1167327215, 'IN', 'IND', 'الهند'),
(11882, 1167327216, 1167851519, 'US', 'USA', 'الولايات المتحدة'),
(11883, 1167851520, 1168113663, 'CA', 'CAN', 'كندا'),
(11884, 1168113664, 1168121855, 'US', 'USA', 'الولايات المتحدة'),
(11885, 1168130048, 1168138239, 'US', 'USA', 'الولايات المتحدة'),
(11886, 1168146432, 1168211967, 'US', 'USA', 'الولايات المتحدة'),
(11887, 1168211968, 1168220159, 'CA', 'CAN', 'كندا'),
(11888, 1168228352, 1168262767, 'US', 'USA', 'الولايات المتحدة'),
(11889, 1168262768, 1168262775, 'PK', 'PAK', 'باكستان'),
(11890, 1168262776, 1168318719, 'US', 'USA', 'الولايات المتحدة'),
(11891, 1168318720, 1168318975, 'CA', 'CAN', 'كندا'),
(11892, 1168318976, 1168321535, 'US', 'USA', 'الولايات المتحدة'),
(11893, 1168321536, 1168321791, 'CA', 'CAN', 'كندا'),
(11894, 1168321792, 1168330751, 'US', 'USA', 'الولايات المتحدة'),
(11895, 1168343040, 1168412671, 'US', 'USA', 'الولايات المتحدة'),
(11896, 1168416768, 1168420863, 'US', 'USA', 'الولايات المتحدة'),
(11897, 1168424960, 1168474111, 'US', 'USA', 'الولايات المتحدة'),
(11898, 1168474112, 1168506879, 'CA', 'CAN', 'كندا'),
(11899, 1168509440, 1168510975, 'US', 'USA', 'الولايات المتحدة'),
(11900, 1168510976, 1168515071, 'CA', 'CAN', 'كندا'),
(11901, 1168515072, 1168535551, 'US', 'USA', 'الولايات المتحدة'),
(11902, 1168539648, 1168584703, 'US', 'USA', 'الولايات المتحدة'),
(11903, 1168588800, 1168633855, 'US', 'USA', 'الولايات المتحدة'),
(11904, 1168637952, 1168642047, 'US', 'USA', 'الولايات المتحدة'),
(11905, 1168646144, 1168670719, 'US', 'USA', 'الولايات المتحدة'),
(11906, 1168670720, 1168687103, 'CA', 'CAN', 'كندا'),
(11907, 1168687104, 1168785407, 'US', 'USA', 'الولايات المتحدة'),
(11908, 1168801792, 1168859135, 'US', 'USA', 'الولايات المتحدة'),
(11909, 1168859136, 1168863231, 'CA', 'CAN', 'كندا'),
(11910, 1168863232, 1168867327, 'US', 'USA', 'الولايات المتحدة'),
(11911, 1168867328, 1168875519, 'CA', 'CAN', 'كندا'),
(11912, 1168875520, 1168887807, 'US', 'USA', 'الولايات المتحدة'),
(11913, 1168900096, 1168916479, 'US', 'USA', 'الولايات المتحدة'),
(11914, 1168916480, 1168932863, 'CA', 'CAN', 'كندا'),
(11915, 1168932864, 1168936959, 'US', 'USA', 'الولايات المتحدة'),
(11916, 1168949248, 1168955647, 'US', 'USA', 'الولايات المتحدة'),
(11917, 1168955648, 1168955903, 'CA', 'CAN', 'كندا'),
(11918, 1168955904, 1168956159, 'US', 'USA', 'الولايات المتحدة'),
(11919, 1168956160, 1168956415, 'CA', 'CAN', 'كندا'),
(11920, 1168956416, 1168957695, 'US', 'USA', 'الولايات المتحدة'),
(11921, 1168957696, 1168957951, 'CA', 'CAN', 'كندا'),
(11922, 1168957952, 1168963583, 'US', 'USA', 'الولايات المتحدة'),
(11923, 1168963584, 1168965119, 'CA', 'CAN', 'كندا'),
(11924, 1168965120, 1168973823, 'US', 'USA', 'الولايات المتحدة'),
(11925, 1168973824, 1168982015, 'CA', 'CAN', 'كندا'),
(11926, 1168982016, 1169076223, 'US', 'USA', 'الولايات المتحدة'),
(11927, 1169080320, 1169182975, 'US', 'USA', 'الولايات المتحدة'),
(11928, 1169182976, 1169183487, 'CA', 'CAN', 'كندا'),
(11929, 1169183488, 1169184767, 'US', 'USA', 'الولايات المتحدة'),
(11930, 1169184768, 1169185023, 'CA', 'CAN', 'كندا'),
(11931, 1169185024, 1169185535, 'US', 'USA', 'الولايات المتحدة'),
(11932, 1169185536, 1169186047, 'CA', 'CAN', 'كندا'),
(11933, 1169186048, 1169186303, 'SG', 'SGP', 'سنغافورة'),
(11934, 1169186304, 1169203199, 'US', 'USA', 'الولايات المتحدة'),
(11935, 1169203200, 1169211391, 'CA', 'CAN', 'كندا'),
(11936, 1169211392, 1170374655, 'US', 'USA', 'الولايات المتحدة'),
(11937, 1170407424, 1170411519, 'US', 'USA', 'الولايات المتحدة'),
(11938, 1170472960, 1170481151, 'CA', 'CAN', 'كندا'),
(11939, 1170481152, 1170489343, 'US', 'USA', 'الولايات المتحدة'),
(11940, 1170489344, 1170497535, 'CA', 'CAN', 'كندا'),
(11941, 1170497536, 1170505727, 'US', 'USA', 'الولايات المتحدة'),
(11942, 1170505728, 1170522111, 'CA', 'CAN', 'كندا'),
(11943, 1170522112, 1175977983, 'US', 'USA', 'الولايات المتحدة'),
(11944, 1175977984, 1176502271, 'CA', 'CAN', 'كندا'),
(11945, 1176502272, 1176511831, 'US', 'USA', 'الولايات المتحدة'),
(11946, 1176511832, 1176511839, 'CA', 'CAN', 'كندا'),
(11947, 1176511840, 1176513471, 'US', 'USA', 'الولايات المتحدة'),
(11948, 1176513472, 1176513503, 'IN', 'IND', 'الهند'),
(11949, 1176513504, 1176513879, 'US', 'USA', 'الولايات المتحدة'),
(11950, 1176513880, 1176513887, 'GB', 'GBR', 'المملكة المتحدة'),
(11951, 1176513888, 1176514271, 'US', 'USA', 'الولايات المتحدة'),
(11952, 1176514272, 1176514303, 'IN', 'IND', 'الهند'),
(11953, 1176514304, 1176559615, 'US', 'USA', 'الولايات المتحدة'),
(11954, 1176567808, 1176613927, 'US', 'USA', 'الولايات المتحدة'),
(11955, 1176613928, 1176613935, 'CA', 'CAN', 'كندا'),
(11956, 1176613936, 1176619007, 'US', 'USA', 'الولايات المتحدة'),
(11957, 1176619008, 1176620031, 'CY', 'CYP', 'قبرص'),
(11958, 1176620032, 1176621055, 'US', 'USA', 'الولايات المتحدة'),
(11959, 1176621056, 1176623103, 'CA', 'CAN', 'كندا'),
(11960, 1176623104, 1176625151, 'US', 'USA', 'الولايات المتحدة'),
(11961, 1176625152, 1176629247, 'CA', 'CAN', 'كندا'),
(11962, 1176629248, 1176629759, 'US', 'USA', 'الولايات المتحدة'),
(11963, 1176629760, 1176631039, 'CA', 'CAN', 'كندا'),
(11964, 1176631040, 1176662015, 'US', 'USA', 'الولايات المتحدة'),
(11965, 1176662016, 1176666111, 'CA', 'CAN', 'كندا'),
(11966, 1176666112, 1176702975, 'US', 'USA', 'الولايات المتحدة'),
(11967, 1176702976, 1176707071, 'CA', 'CAN', 'كندا'),
(11968, 1176707072, 1176731647, 'US', 'USA', 'الولايات المتحدة'),
(11969, 1176731648, 1176735743, 'PR', 'PRI', 'بورتو ريكو'),
(11970, 1176739840, 1176743935, 'CA', 'CAN', 'كندا'),
(11971, 1176748032, 1176752127, 'US', 'USA', 'الولايات المتحدة'),
(11972, 1176756224, 1176764415, 'US', 'USA', 'الولايات المتحدة'),
(11973, 1176764416, 1176768511, 'PM', 'SPM', 'سان بيار وميكلون'),
(11974, 1176768512, 1176776703, 'US', 'USA', 'الولايات المتحدة'),
(11975, 1176780800, 1176784895, 'US', 'USA', 'الولايات المتحدة'),
(11976, 1176788992, 1176883199, 'US', 'USA', 'الولايات المتحدة'),
(11977, 1176887296, 1176895487, 'US', 'USA', 'الولايات المتحدة'),
(11978, 1176895488, 1176928255, 'CA', 'CAN', 'كندا'),
(11979, 1176928256, 1177030655, 'US', 'USA', 'الولايات المتحدة'),
(11980, 1177030656, 1177033727, 'AG', 'ATG', 'انتيغوا وبربودا'),
(11981, 1177033728, 1177053695, 'US', 'USA', 'الولايات المتحدة'),
(11982, 1177053696, 1177053951, 'GB', 'GBR', 'المملكة المتحدة'),
(11983, 1177053952, 1177354239, 'US', 'USA', 'الولايات المتحدة'),
(11984, 1177354240, 1177419775, 'PR', 'PRI', 'بورتو ريكو'),
(11985, 1177419776, 1177550847, 'US', 'USA', 'الولايات المتحدة'),
(11986, 1177550848, 1178000911, 'CA', 'CAN', 'كندا'),
(11987, 1178000912, 1178000919, 'US', 'USA', 'الولايات المتحدة'),
(11988, 1178000920, 1178075135, 'CA', 'CAN', 'كندا'),
(11989, 1178075136, 1178599423, 'US', 'USA', 'الولايات المتحدة'),
(11990, 1178599424, 1179910143, 'CA', 'CAN', 'كندا'),
(11991, 1179910144, 1191673855, 'US', 'USA', 'الولايات المتحدة'),
(11992, 1191673856, 1191706623, 'CA', 'CAN', 'كندا'),
(11993, 1191706624, 1192296447, 'US', 'USA', 'الولايات المتحدة'),
(11994, 1192296448, 1192361983, 'CA', 'CAN', 'كندا'),
(11995, 1192361984, 1192427519, 'US', 'USA', 'الولايات المتحدة'),
(11996, 1192427520, 1192460287, 'CA', 'CAN', 'كندا'),
(11997, 1192493056, 1207975935, 'US', 'USA', 'الولايات المتحدة'),
(11998, 1207975936, 1207980031, 'CA', 'CAN', 'كندا'),
(11999, 1207980032, 1208008703, 'US', 'USA', 'الولايات المتحدة'),
(12000, 1208008704, 1208016895, 'CA', 'CAN', 'كندا'),
(12001, 1208016896, 1208020991, 'US', 'USA', 'الولايات المتحدة'),
(12002, 1208020992, 1208025087, 'CA', 'CAN', 'كندا'),
(12003, 1208025088, 1208050943, 'US', 'USA', 'الولايات المتحدة'),
(12004, 1208050944, 1208051199, 'CA', 'CAN', 'كندا'),
(12005, 1208051200, 1208074239, 'US', 'USA', 'الولايات المتحدة'),
(12006, 1208074240, 1208082431, 'CA', 'CAN', 'كندا'),
(12007, 1208082432, 1208090623, 'US', 'USA', 'الولايات المتحدة'),
(12008, 1208090624, 1208107007, 'CA', 'CAN', 'كندا'),
(12009, 1208107008, 1208590335, 'US', 'USA', 'الولايات المتحدة'),
(12010, 1208590336, 1208598527, 'CA', 'CAN', 'كندا'),
(12011, 1208598528, 1208647679, 'US', 'USA', 'الولايات المتحدة'),
(12012, 1208647680, 1208659967, 'CA', 'CAN', 'كندا'),
(12013, 1208659968, 1208721407, 'US', 'USA', 'الولايات المتحدة'),
(12014, 1208721408, 1208729599, 'CA', 'CAN', 'كندا'),
(12015, 1208729600, 1208770559, 'US', 'USA', 'الولايات المتحدة'),
(12016, 1208770560, 1208774655, 'CA', 'CAN', 'كندا'),
(12017, 1208774656, 1208778751, 'US', 'USA', 'الولايات المتحدة'),
(12018, 1208778752, 1208795135, 'CA', 'CAN', 'كندا'),
(12019, 1208795136, 1208832607, 'US', 'USA', 'الولايات المتحدة'),
(12020, 1208832608, 1208832623, 'IT', 'ITA', 'إيطاليا'),
(12021, 1208832624, 1208852479, 'US', 'USA', 'الولايات المتحدة'),
(12022, 1208852480, 1208860671, 'CA', 'CAN', 'كندا'),
(12023, 1208860672, 1208918015, 'US', 'USA', 'الولايات المتحدة'),
(12024, 1208918016, 1208922111, 'CA', 'CAN', 'كندا'),
(12025, 1208922112, 1208954879, 'US', 'USA', 'الولايات المتحدة'),
(12026, 1208954880, 1208958975, 'CA', 'CAN', 'كندا'),
(12027, 1208958976, 1208975359, 'US', 'USA', 'الولايات المتحدة'),
(12028, 1208975360, 1208983551, 'CA', 'CAN', 'كندا'),
(12029, 1208983552, 1209347839, 'US', 'USA', 'الولايات المتحدة'),
(12030, 1209347840, 1209348095, 'GB', 'GBR', 'المملكة المتحدة'),
(12031, 1209348096, 1209434111, 'US', 'USA', 'الولايات المتحدة'),
(12032, 1209434112, 1209436671, 'BB', 'BRB', 'باربادوس'),
(12033, 1209436672, 1209437183, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(12034, 1209437184, 1209440767, 'BB', 'BRB', 'باربادوس'),
(12035, 1209440768, 1209441279, 'GD', 'GRD', 'غرينادا'),
(12036, 1209441280, 1209442303, 'BB', 'BRB', 'باربادوس'),
(12037, 1209442304, 1209647103, 'US', 'USA', 'الولايات المتحدة'),
(12038, 1209647104, 1209663487, 'CA', 'CAN', 'كندا'),
(12039, 1209663488, 1209729023, 'US', 'USA', 'الولايات المتحدة'),
(12040, 1209729024, 1209786367, 'JM', 'JAM', 'جامايكا'),
(12041, 1209786368, 1209810943, 'US', 'USA', 'الولايات المتحدة'),
(12042, 1209810944, 1209819135, 'CA', 'CAN', 'كندا'),
(12043, 1209827328, 1209885127, 'US', 'USA', 'الولايات المتحدة'),
(12044, 1209885128, 1209885143, 'IT', 'ITA', 'إيطاليا'),
(12045, 1209885144, 1209885167, 'US', 'USA', 'الولايات المتحدة'),
(12046, 1209885168, 1209885175, 'IT', 'ITA', 'إيطاليا'),
(12047, 1209885176, 1209917439, 'US', 'USA', 'الولايات المتحدة'),
(12048, 1209917440, 1209925631, 'CA', 'CAN', 'كندا'),
(12049, 1209925632, 1210253311, 'US', 'USA', 'الولايات المتحدة'),
(12050, 1210253312, 1210254703, 'CA', 'CAN', 'كندا'),
(12051, 1210254704, 1210254719, 'NZ', 'NZL', 'نيوزيلاندا'),
(12052, 1210254720, 1210261503, 'CA', 'CAN', 'كندا'),
(12053, 1210261504, 1210366655, 'US', 'USA', 'الولايات المتحدة'),
(12054, 1210366656, 1210366719, 'GB', 'GBR', 'المملكة المتحدة'),
(12055, 1210366720, 1210449919, 'US', 'USA', 'الولايات المتحدة'),
(12056, 1210449920, 1210580991, 'CA', 'CAN', 'كندا'),
(12057, 1210580992, 1210925055, 'US', 'USA', 'الولايات المتحدة'),
(12058, 1210925056, 1210941439, 'CA', 'CAN', 'كندا'),
(12059, 1210941440, 1211236351, 'US', 'USA', 'الولايات المتحدة'),
(12060, 1211236352, 1211269119, 'PR', 'PRI', 'بورتو ريكو'),
(12061, 1211269120, 1211304447, 'US', 'USA', 'الولايات المتحدة'),
(12062, 1211304448, 1211304703, 'CA', 'CAN', 'كندا'),
(12063, 1211304704, 1211308175, 'US', 'USA', 'الولايات المتحدة'),
(12064, 1211308176, 1211308191, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12065, 1211308192, 1211308223, 'US', 'USA', 'الولايات المتحدة'),
(12066, 1211308224, 1211308543, 'CA', 'CAN', 'كندا'),
(12067, 1211308544, 1211308703, 'US', 'USA', 'الولايات المتحدة'),
(12068, 1211308704, 1211308719, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12069, 1211308720, 1211308735, 'US', 'USA', 'الولايات المتحدة'),
(12070, 1211308736, 1211308751, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12071, 1211308752, 1211317503, 'US', 'USA', 'الولايات المتحدة'),
(12072, 1211317504, 1211317759, 'CA', 'CAN', 'كندا'),
(12073, 1211317760, 1211318271, 'US', 'USA', 'الولايات المتحدة'),
(12074, 1211318272, 1211321343, 'BB', 'BRB', 'باربادوس'),
(12075, 1211321344, 1211322367, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(12076, 1211322368, 1211322623, 'BB', 'BRB', 'باربادوس'),
(12077, 1211322624, 1211324159, 'GD', 'GRD', 'غرينادا'),
(12078, 1211324160, 1211324927, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(12079, 1211324928, 1211333119, 'BB', 'BRB', 'باربادوس'),
(12080, 1211333120, 1211333631, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(12081, 1211333632, 1211333887, 'GD', 'GRD', 'غرينادا'),
(12082, 1211333888, 1211334655, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12083, 1211334656, 1211367503, 'US', 'USA', 'الولايات المتحدة'),
(12084, 1211367504, 1211367519, 'CH', 'CHE', 'سويسرا'),
(12085, 1211367520, 1211413247, 'US', 'USA', 'الولايات المتحدة'),
(12086, 1211413248, 1211413503, 'CA', 'CAN', 'كندا'),
(12087, 1211413504, 1211432959, 'US', 'USA', 'الولايات المتحدة'),
(12088, 1211432960, 1211473919, 'CA', 'CAN', 'كندا'),
(12089, 1211473920, 1211596799, 'US', 'USA', 'الولايات المتحدة'),
(12090, 1211596800, 1211605247, 'CA', 'CAN', 'كندا'),
(12091, 1211605248, 1211605311, 'BS', 'BHS', 'جزر البهاما'),
(12092, 1211605312, 1211610499, 'CA', 'CAN', 'كندا'),
(12093, 1211610500, 1211610503, 'US', 'USA', 'الولايات المتحدة'),
(12094, 1211610504, 1211613183, 'CA', 'CAN', 'كندا'),
(12095, 1211613184, 1216872447, 'US', 'USA', 'الولايات المتحدة'),
(12096, 1216872448, 1217396735, 'CA', 'CAN', 'كندا'),
(12097, 1217396736, 1218778111, 'US', 'USA', 'الولايات المتحدة'),
(12098, 1218778112, 1218778367, 'SG', 'SGP', 'سنغافورة'),
(12099, 1218778368, 1219256319, 'US', 'USA', 'الولايات المتحدة'),
(12100, 1219256320, 1219264511, 'CA', 'CAN', 'كندا'),
(12101, 1219264512, 1219272703, 'US', 'USA', 'الولايات المتحدة'),
(12102, 1219272704, 1219276799, 'CA', 'CAN', 'كندا'),
(12103, 1219276800, 1223199743, 'US', 'USA', 'الولايات المتحدة'),
(12104, 1223199744, 1223199999, 'GB', 'GBR', 'المملكة المتحدة'),
(12105, 1223200000, 1223208831, 'US', 'USA', 'الولايات المتحدة'),
(12106, 1223208832, 1223208959, 'ES', 'ESP', 'إسبانيا'),
(12107, 1223208960, 1224278111, 'US', 'USA', 'الولايات المتحدة'),
(12108, 1224278112, 1224278143, 'MY', 'MYS', 'ماليزيا'),
(12109, 1224278144, 1224286719, 'US', 'USA', 'الولايات المتحدة'),
(12110, 1224286720, 1224286975, 'CA', 'CAN', 'كندا'),
(12111, 1224286976, 1224290815, 'US', 'USA', 'الولايات المتحدة'),
(12112, 1224290816, 1224291071, 'CA', 'CAN', 'كندا'),
(12113, 1224291072, 1224296447, 'US', 'USA', 'الولايات المتحدة'),
(12114, 1224296448, 1224296959, 'CA', 'CAN', 'كندا'),
(12115, 1224296960, 1224299519, 'US', 'USA', 'الولايات المتحدة'),
(12116, 1224299520, 1224299775, 'CA', 'CAN', 'كندا'),
(12117, 1224299776, 1224311247, 'US', 'USA', 'الولايات المتحدة'),
(12118, 1224311248, 1224311255, 'CA', 'CAN', 'كندا'),
(12119, 1224311256, 1224311807, 'US', 'USA', 'الولايات المتحدة'),
(12120, 1224311808, 1224312319, 'CA', 'CAN', 'كندا'),
(12121, 1224312320, 1224317439, 'US', 'USA', 'الولايات المتحدة'),
(12122, 1224317440, 1224317695, 'CA', 'CAN', 'كندا'),
(12123, 1224317696, 1224318207, 'US', 'USA', 'الولايات المتحدة'),
(12124, 1224318208, 1224318463, 'CA', 'CAN', 'كندا'),
(12125, 1224318464, 1224321023, 'US', 'USA', 'الولايات المتحدة'),
(12126, 1224321024, 1224321535, 'CA', 'CAN', 'كندا'),
(12127, 1224321536, 1224474623, 'US', 'USA', 'الولايات المتحدة'),
(12128, 1224474624, 1224475647, 'GT', 'GTM', 'غواتيمالا'),
(12129, 1224475648, 1224476671, 'US', 'USA', 'الولايات المتحدة'),
(12130, 1224476672, 1224478719, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(12131, 1224478720, 1224480767, 'US', 'USA', 'الولايات المتحدة'),
(12132, 1224480768, 1224484863, 'JM', 'JAM', 'جامايكا'),
(12133, 1224484864, 1224493055, 'GT', 'GTM', 'غواتيمالا'),
(12134, 1224493056, 1224497151, 'US', 'USA', 'الولايات المتحدة'),
(12135, 1224497152, 1224501247, 'GT', 'GTM', 'غواتيمالا'),
(12136, 1224501248, 1224503551, 'JM', 'JAM', 'جامايكا'),
(12137, 1224503552, 1224503807, 'BS', 'BHS', 'جزر البهاما'),
(12138, 1224503808, 1224523520, 'JM', 'JAM', 'جامايكا'),
(12139, 1224523521, 1224523775, 'US', 'USA', 'الولايات المتحدة'),
(12140, 1224523776, 1224525568, 'JM', 'JAM', 'جامايكا'),
(12141, 1224525569, 1224525823, 'US', 'USA', 'الولايات المتحدة'),
(12142, 1224525824, 1224527616, 'JM', 'JAM', 'جامايكا'),
(12143, 1224527617, 1224527871, 'US', 'USA', 'الولايات المتحدة'),
(12144, 1224527872, 1224529664, 'JM', 'JAM', 'جامايكا'),
(12145, 1224529665, 1224529919, 'US', 'USA', 'الولايات المتحدة'),
(12146, 1224529920, 1224539904, 'JM', 'JAM', 'جامايكا'),
(12147, 1224539905, 1241743359, 'US', 'USA', 'الولايات المتحدة'),
(12148, 1241743360, 1241759743, 'CA', 'CAN', 'كندا'),
(12149, 1241759744, 1242300415, 'US', 'USA', 'الولايات المتحدة'),
(12150, 1242300416, 1242562559, 'CA', 'CAN', 'كندا'),
(12151, 1242562560, 1244659711, 'US', 'USA', 'الولايات المتحدة'),
(12152, 1244659712, 1244790783, 'CA', 'CAN', 'كندا'),
(12153, 1244790784, 1244831743, 'US', 'USA', 'الولايات المتحدة'),
(12154, 1244831744, 1244839935, 'CA', 'CAN', 'كندا'),
(12155, 1244839936, 1244848127, 'US', 'USA', 'الولايات المتحدة'),
(12156, 1244848128, 1244852223, 'CA', 'CAN', 'كندا'),
(12157, 1244852224, 1244864511, 'US', 'USA', 'الولايات المتحدة'),
(12158, 1244864512, 1244872703, 'CA', 'CAN', 'كندا'),
(12159, 1244872704, 1245183999, 'US', 'USA', 'الولايات المتحدة'),
(12160, 1245184000, 1245446143, 'CA', 'CAN', 'كندا'),
(12161, 1245446144, 1246904319, 'US', 'USA', 'الولايات المتحدة'),
(12162, 1246904320, 1246912511, 'CA', 'CAN', 'كندا'),
(12163, 1246912512, 1246924799, 'US', 'USA', 'الولايات المتحدة'),
(12164, 1246928896, 1246932991, 'US', 'USA', 'الولايات المتحدة'),
(12165, 1246937088, 1246945279, 'CA', 'CAN', 'كندا'),
(12166, 1246945280, 1246949375, 'US', 'USA', 'الولايات المتحدة'),
(12167, 1246953472, 1247170743, 'US', 'USA', 'الولايات المتحدة'),
(12168, 1247170744, 1247170751, 'GB', 'GBR', 'المملكة المتحدة'),
(12169, 1247170752, 1247170927, 'US', 'USA', 'الولايات المتحدة'),
(12170, 1247170928, 1247170935, 'GB', 'GBR', 'المملكة المتحدة'),
(12171, 1247170936, 1247173319, 'US', 'USA', 'الولايات المتحدة'),
(12172, 1247173320, 1247173327, 'IE', 'IRL', 'إيرلندا'),
(12173, 1247173328, 1247178703, 'US', 'USA', 'الولايات المتحدة'),
(12174, 1247178704, 1247178711, 'IE', 'IRL', 'إيرلندا'),
(12175, 1247178712, 1247180399, 'US', 'USA', 'الولايات المتحدة'),
(12176, 1247180400, 1247180407, 'NO', 'NOR', 'النرويج'),
(12177, 1247180408, 1247182343, 'US', 'USA', 'الولايات المتحدة'),
(12178, 1247182344, 1247182351, 'IE', 'IRL', 'إيرلندا'),
(12179, 1247182352, 1247184559, 'US', 'USA', 'الولايات المتحدة'),
(12180, 1247184560, 1247184567, 'IE', 'IRL', 'إيرلندا'),
(12181, 1247184568, 1247186703, 'US', 'USA', 'الولايات المتحدة'),
(12182, 1247186704, 1247186711, 'EG', 'EGY', 'مصر'),
(12183, 1247186712, 1247187199, 'US', 'USA', 'الولايات المتحدة'),
(12184, 1247187200, 1247187207, 'LB', 'LBN', 'لبنان'),
(12185, 1247187208, 1247191127, 'US', 'USA', 'الولايات المتحدة'),
(12186, 1247191128, 1247191135, 'IE', 'IRL', 'إيرلندا'),
(12187, 1247191136, 1247191199, 'US', 'USA', 'الولايات المتحدة'),
(12188, 1247191200, 1247191207, 'IE', 'IRL', 'إيرلندا'),
(12189, 1247191208, 1247412223, 'US', 'USA', 'الولايات المتحدة'),
(12190, 1247543296, 1248864255, 'US', 'USA', 'الولايات المتحدة'),
(12191, 1248864256, 1248866303, 'CA', 'CAN', 'كندا'),
(12192, 1248866304, 1248885759, 'US', 'USA', 'الولايات المتحدة'),
(12193, 1248885760, 1248886783, 'CA', 'CAN', 'كندا'),
(12194, 1248886784, 1248899071, 'US', 'USA', 'الولايات المتحدة'),
(12195, 1248899072, 1248900095, 'CA', 'CAN', 'كندا'),
(12196, 1248900096, 1248901119, 'US', 'USA', 'الولايات المتحدة'),
(12197, 1248902144, 1248913407, 'US', 'USA', 'الولايات المتحدة'),
(12198, 1248913408, 1248915455, 'MF', 'MAF', 'سانت مارتن'),
(12199, 1248915456, 1248919551, 'US', 'USA', 'الولايات المتحدة'),
(12200, 1248919552, 1248920575, 'CA', 'CAN', 'كندا'),
(12201, 1248920576, 1248921599, 'US', 'USA', 'الولايات المتحدة'),
(12202, 1248921600, 1248923647, 'CA', 'CAN', 'كندا'),
(12203, 1248923648, 1248931839, 'US', 'USA', 'الولايات المتحدة'),
(12204, 1248933888, 1248936959, 'US', 'USA', 'الولايات المتحدة'),
(12205, 1248936960, 1248939007, 'CA', 'CAN', 'كندا'),
(12206, 1248939008, 1248946175, 'US', 'USA', 'الولايات المتحدة'),
(12207, 1248946176, 1248947199, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12208, 1248947200, 1248958463, 'US', 'USA', 'الولايات المتحدة'),
(12209, 1248958464, 1248959487, 'CA', 'CAN', 'كندا'),
(12210, 1248959488, 1248964607, 'US', 'USA', 'الولايات المتحدة'),
(12211, 1248964608, 1248966655, 'CA', 'CAN', 'كندا'),
(12212, 1248966656, 1249003519, 'US', 'USA', 'الولايات المتحدة'),
(12213, 1249003520, 1249005567, 'CA', 'CAN', 'كندا'),
(12214, 1249005568, 1249010687, 'US', 'USA', 'الولايات المتحدة'),
(12215, 1249010688, 1249011711, 'CA', 'CAN', 'كندا'),
(12216, 1249011712, 1249019903, 'US', 'USA', 'الولايات المتحدة'),
(12217, 1249019904, 1249020927, 'CA', 'CAN', 'كندا'),
(12218, 1249020928, 1249029119, 'US', 'USA', 'الولايات المتحدة'),
(12219, 1249029120, 1249030143, 'CA', 'CAN', 'كندا'),
(12220, 1249030144, 1249036287, 'US', 'USA', 'الولايات المتحدة'),
(12221, 1249036288, 1249037311, 'TC', 'TCA', 'جزر تركس وكايكوس'),
(12222, 1249037312, 1249040383, 'CA', 'CAN', 'كندا'),
(12223, 1249040384, 1249046527, 'US', 'USA', 'الولايات المتحدة'),
(12224, 1249046528, 1249047551, 'BM', 'BMU', 'برمودا'),
(12225, 1249047552, 1249063935, 'US', 'USA', 'الولايات المتحدة'),
(12226, 1249064960, 1249082367, 'US', 'USA', 'الولايات المتحدة'),
(12227, 1249082368, 1249083391, 'CA', 'CAN', 'كندا'),
(12228, 1249083392, 1249099775, 'US', 'USA', 'الولايات المتحدة'),
(12229, 1249099776, 1249101823, 'CA', 'CAN', 'كندا'),
(12230, 1249101824, 1249102847, 'PR', 'PRI', 'بورتو ريكو'),
(12231, 1249102848, 1249103103, 'US', 'USA', 'الولايات المتحدة'),
(12232, 1249103104, 1249103871, 'CA', 'CAN', 'كندا'),
(12233, 1249103872, 1249106943, 'US', 'USA', 'الولايات المتحدة'),
(12234, 1249106944, 1249107967, 'CA', 'CAN', 'كندا'),
(12235, 1249107968, 1249130495, 'US', 'USA', 'الولايات المتحدة'),
(12236, 1249130496, 1249131519, 'JM', 'JAM', 'جامايكا'),
(12237, 1249131520, 1249139711, 'US', 'USA', 'الولايات المتحدة'),
(12238, 1249139712, 1249140735, 'MF', 'MAF', 'سانت مارتن'),
(12239, 1249140736, 1249163263, 'US', 'USA', 'الولايات المتحدة'),
(12240, 1249163264, 1249167359, 'CA', 'CAN', 'كندا'),
(12241, 1249167360, 1249171455, 'US', 'USA', 'الولايات المتحدة'),
(12242, 1249171456, 1249173503, 'CA', 'CAN', 'كندا'),
(12243, 1249173504, 1249191935, 'US', 'USA', 'الولايات المتحدة'),
(12244, 1249191936, 1249193983, 'CA', 'CAN', 'كندا'),
(12245, 1249193984, 1249203199, 'US', 'USA', 'الولايات المتحدة'),
(12246, 1249203200, 1249204223, 'GD', 'GRD', 'غرينادا'),
(12247, 1249204224, 1249210367, 'US', 'USA', 'الولايات المتحدة'),
(12248, 1249210368, 1249212415, 'KY', 'CYM', 'جزر كايمان'),
(12249, 1249212416, 1249217535, 'US', 'USA', 'الولايات المتحدة'),
(12250, 1249217536, 1249218559, 'CA', 'CAN', 'كندا'),
(12251, 1249218560, 1249236991, 'US', 'USA', 'الولايات المتحدة'),
(12252, 1249236992, 1249239039, 'KY', 'CYM', 'جزر كايمان'),
(12253, 1249239040, 1249245183, 'US', 'USA', 'الولايات المتحدة'),
(12254, 1249245184, 1249247231, 'CA', 'CAN', 'كندا'),
(12255, 1249247232, 1249256447, 'US', 'USA', 'الولايات المتحدة'),
(12256, 1249256448, 1249257471, 'CA', 'CAN', 'كندا'),
(12257, 1249257472, 1249260543, 'US', 'USA', 'الولايات المتحدة'),
(12258, 1249260544, 1249261567, 'CA', 'CAN', 'كندا'),
(12259, 1249261568, 1249272831, 'US', 'USA', 'الولايات المتحدة'),
(12260, 1249272832, 1249273855, 'CA', 'CAN', 'كندا'),
(12261, 1249273856, 1249310719, 'US', 'USA', 'الولايات المتحدة'),
(12262, 1249310720, 1249311743, 'CA', 'CAN', 'كندا'),
(12263, 1249311744, 1249312767, 'US', 'USA', 'الولايات المتحدة'),
(12264, 1249312768, 1249313791, 'CA', 'CAN', 'كندا'),
(12265, 1249313792, 1249335295, 'US', 'USA', 'الولايات المتحدة'),
(12266, 1249335296, 1249337343, 'CA', 'CAN', 'كندا'),
(12267, 1249337344, 1249349631, 'US', 'USA', 'الولايات المتحدة'),
(12268, 1249350656, 1249359871, 'US', 'USA', 'الولايات المتحدة'),
(12269, 1249359872, 1249361919, 'CA', 'CAN', 'كندا'),
(12270, 1249361920, 1249384447, 'US', 'USA', 'الولايات المتحدة'),
(12271, 1249384448, 1249386495, 'PR', 'PRI', 'بورتو ريكو'),
(12272, 1249386496, 1249391615, 'US', 'USA', 'الولايات المتحدة'),
(12273, 1249391616, 1249392639, 'CA', 'CAN', 'كندا'),
(12274, 1249392640, 1249396735, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(12275, 1249396736, 1249397759, 'CA', 'CAN', 'كندا'),
(12276, 1249397760, 1249409023, 'US', 'USA', 'الولايات المتحدة'),
(12277, 1249409024, 1249410047, 'CA', 'CAN', 'كندا'),
(12278, 1249410048, 1249452031, 'US', 'USA', 'الولايات المتحدة'),
(12279, 1249452032, 1249453055, 'CA', 'CAN', 'كندا'),
(12280, 1249453056, 1249474559, 'US', 'USA', 'الولايات المتحدة'),
(12281, 1249474560, 1249475583, 'CA', 'CAN', 'كندا'),
(12282, 1249475584, 1249484799, 'US', 'USA', 'الولايات المتحدة'),
(12283, 1249484800, 1249486847, 'CA', 'CAN', 'كندا'),
(12284, 1249486848, 1249506303, 'US', 'USA', 'الولايات المتحدة'),
(12285, 1249506304, 1249507327, 'CA', 'CAN', 'كندا'),
(12286, 1249507328, 1249522687, 'US', 'USA', 'الولايات المتحدة'),
(12287, 1249522688, 1249523711, 'CA', 'CAN', 'كندا'),
(12288, 1249523712, 1249531903, 'US', 'USA', 'الولايات المتحدة'),
(12289, 1249531904, 1249533951, 'GD', 'GRD', 'غرينادا'),
(12290, 1249533952, 1249542143, 'US', 'USA', 'الولايات المتحدة'),
(12291, 1249542144, 1249544191, 'CA', 'CAN', 'كندا'),
(12292, 1249544192, 1249562623, 'US', 'USA', 'الولايات المتحدة'),
(12293, 1249562624, 1249564671, 'CA', 'CAN', 'كندا'),
(12294, 1249564672, 1249571839, 'US', 'USA', 'الولايات المتحدة'),
(12295, 1249571840, 1249572863, 'CA', 'CAN', 'كندا'),
(12296, 1249572864, 1249576959, 'US', 'USA', 'الولايات المتحدة'),
(12297, 1249576960, 1249577983, 'CA', 'CAN', 'كندا'),
(12298, 1249577984, 1249592319, 'US', 'USA', 'الولايات المتحدة'),
(12299, 1249592320, 1249593343, 'CA', 'CAN', 'كندا'),
(12300, 1249593344, 1249598463, 'US', 'USA', 'الولايات المتحدة'),
(12301, 1249598464, 1249599487, 'CA', 'CAN', 'كندا'),
(12302, 1249599488, 1249677311, 'US', 'USA', 'الولايات المتحدة'),
(12303, 1249681408, 1249796095, 'US', 'USA', 'الولايات المتحدة'),
(12304, 1249796096, 1249804287, 'CA', 'CAN', 'كندا'),
(12305, 1249804288, 1249886207, 'US', 'USA', 'الولايات المتحدة'),
(12306, 1249886208, 1249902591, 'CA', 'CAN', 'كندا'),
(12307, 1249902592, 1254490111, 'US', 'USA', 'الولايات المتحدة'),
(12308, 1254490112, 1254555647, 'CA', 'CAN', 'كندا'),
(12309, 1254555648, 1254621183, 'US', 'USA', 'الولايات المتحدة'),
(12310, 1254621184, 1254629375, 'CA', 'CAN', 'كندا'),
(12311, 1254629376, 1254989823, 'US', 'USA', 'الولايات المتحدة'),
(12312, 1254989824, 1254998015, 'CA', 'CAN', 'كندا'),
(12313, 1254998016, 1255002111, 'US', 'USA', 'الولايات المتحدة'),
(12314, 1255002112, 1255006207, 'CA', 'CAN', 'كندا'),
(12315, 1255006208, 1255047167, 'US', 'USA', 'الولايات المتحدة'),
(12316, 1255047168, 1255055359, 'CA', 'CAN', 'كندا'),
(12317, 1255055360, 1255062463, 'US', 'USA', 'الولايات المتحدة'),
(12318, 1255062464, 1255062527, 'PA', 'PAN', 'بنما'),
(12319, 1255062528, 1255063551, 'US', 'USA', 'الولايات المتحدة'),
(12320, 1255063552, 1255071743, 'PR', 'PRI', 'بورتو ريكو'),
(12321, 1255071744, 1255276543, 'US', 'USA', 'الولايات المتحدة'),
(12322, 1255276544, 1255342079, 'CA', 'CAN', 'كندا'),
(12323, 1255342080, 1255489535, 'US', 'USA', 'الولايات المتحدة'),
(12324, 1255489536, 1255505919, 'PR', 'PRI', 'بورتو ريكو'),
(12325, 1255505920, 1255514111, 'US', 'USA', 'الولايات المتحدة'),
(12326, 1255514112, 1255522303, 'CA', 'CAN', 'كندا'),
(12327, 1255522304, 1255571455, 'US', 'USA', 'الولايات المتحدة'),
(12328, 1255571456, 1255579647, 'CA', 'CAN', 'كندا'),
(12329, 1255579648, 1255669759, 'US', 'USA', 'الولايات المتحدة'),
(12330, 1255669760, 1255735295, 'CA', 'CAN', 'كندا'),
(12331, 1255735296, 1255771135, 'US', 'USA', 'الولايات المتحدة'),
(12332, 1255771136, 1255772159, 'CA', 'CAN', 'كندا'),
(12333, 1255772160, 1255972863, 'US', 'USA', 'الولايات المتحدة'),
(12334, 1255972864, 1255981055, 'CA', 'CAN', 'كندا'),
(12335, 1255981056, 1256001535, 'US', 'USA', 'الولايات المتحدة'),
(12336, 1256001536, 1256005631, 'CA', 'CAN', 'كندا'),
(12337, 1256005632, 1256079359, 'US', 'USA', 'الولايات المتحدة'),
(12338, 1256079360, 1256087551, 'KY', 'CYM', 'جزر كايمان'),
(12339, 1256087552, 1263264273, 'US', 'USA', 'الولايات المتحدة'),
(12340, 1263264274, 1263264289, 'PK', 'PAK', 'باكستان'),
(12341, 1263264290, 1263264305, 'US', 'USA', 'الولايات المتحدة'),
(12342, 1263264306, 1263264354, 'PK', 'PAK', 'باكستان'),
(12343, 1263264355, 1263266623, 'US', 'USA', 'الولايات المتحدة'),
(12344, 1263266624, 1263266655, 'CA', 'CAN', 'كندا'),
(12345, 1263266656, 1263267327, 'US', 'USA', 'الولايات المتحدة'),
(12346, 1263267328, 1263267583, 'CA', 'CAN', 'كندا'),
(12347, 1263267584, 1263267647, 'US', 'USA', 'الولايات المتحدة'),
(12348, 1263267648, 1263267679, 'CA', 'CAN', 'كندا'),
(12349, 1263267680, 1263268095, 'US', 'USA', 'الولايات المتحدة'),
(12350, 1263268096, 1263268191, 'CA', 'CAN', 'كندا'),
(12351, 1263268192, 1263268275, 'US', 'USA', 'الولايات المتحدة'),
(12352, 1263268276, 1263268340, 'CA', 'CAN', 'كندا'),
(12353, 1263268341, 1263268343, 'US', 'USA', 'الولايات المتحدة'),
(12354, 1263268344, 1263268351, 'CA', 'CAN', 'كندا'),
(12355, 1263268352, 1263268607, 'US', 'USA', 'الولايات المتحدة'),
(12356, 1263268608, 1263268672, 'CA', 'CAN', 'كندا'),
(12357, 1263268673, 1263268769, 'US', 'USA', 'الولايات المتحدة'),
(12358, 1263268770, 1263268863, 'CA', 'CAN', 'كندا'),
(12359, 1263268864, 1263271423, 'US', 'USA', 'الولايات المتحدة'),
(12360, 1263271424, 1263271679, 'CA', 'CAN', 'كندا'),
(12361, 1263271680, 1264738303, 'US', 'USA', 'الولايات المتحدة'),
(12362, 1264779264, 1265102847, 'US', 'USA', 'الولايات المتحدة'),
(12363, 1265106944, 1266147327, 'US', 'USA', 'الولايات المتحدة'),
(12364, 1266147328, 1266155519, 'CA', 'CAN', 'كندا'),
(12365, 1266155520, 1266489663, 'US', 'USA', 'الولايات المتحدة'),
(12366, 1266489664, 1266489695, 'CA', 'CAN', 'كندا'),
(12367, 1266489696, 1266498175, 'US', 'USA', 'الولايات المتحدة'),
(12368, 1266498176, 1266498303, 'MA', 'MAR', 'المغرب'),
(12369, 1266498304, 1266514815, 'US', 'USA', 'الولايات المتحدة'),
(12370, 1266514816, 1266514879, 'CA', 'CAN', 'كندا'),
(12371, 1266514880, 1266551519, 'US', 'USA', 'الولايات المتحدة'),
(12372, 1266551520, 1266551527, 'PH', 'PHL', 'الفلبين'),
(12373, 1266551528, 1266554207, 'US', 'USA', 'الولايات المتحدة'),
(12374, 1266554208, 1266554215, 'SA', 'SAU', 'السعودية'),
(12375, 1266554216, 1266559095, 'US', 'USA', 'الولايات المتحدة'),
(12376, 1266559096, 1266559103, 'SA', 'SAU', 'السعودية'),
(12377, 1266559104, 1266559415, 'US', 'USA', 'الولايات المتحدة'),
(12378, 1266559416, 1266559423, 'CA', 'CAN', 'كندا'),
(12379, 1266559424, 1266565031, 'US', 'USA', 'الولايات المتحدة'),
(12380, 1266565032, 1266565039, 'SA', 'SAU', 'السعودية'),
(12381, 1266565040, 1266569567, 'US', 'USA', 'الولايات المتحدة'),
(12382, 1266569568, 1266569575, 'NO', 'NOR', 'النرويج'),
(12383, 1266569576, 1266574631, 'US', 'USA', 'الولايات المتحدة'),
(12384, 1266574632, 1266574639, 'TR', 'TUR', 'تركيا'),
(12385, 1266574640, 1266581535, 'US', 'USA', 'الولايات المتحدة'),
(12386, 1266581536, 1266581543, 'IE', 'IRL', 'إيرلندا'),
(12387, 1266581544, 1266581551, 'US', 'USA', 'الولايات المتحدة'),
(12388, 1266581552, 1266581559, 'IE', 'IRL', 'إيرلندا'),
(12389, 1266581560, 1266583679, 'US', 'USA', 'الولايات المتحدة'),
(12390, 1266583680, 1266583687, 'ID', 'IDN', 'إندونيسيا'),
(12391, 1266583688, 1266587511, 'US', 'USA', 'الولايات المتحدة'),
(12392, 1266587512, 1266587519, 'EG', 'EGY', 'مصر'),
(12393, 1266587520, 1266587631, 'US', 'USA', 'الولايات المتحدة'),
(12394, 1266587632, 1266587639, 'GB', 'GBR', 'المملكة المتحدة'),
(12395, 1266587640, 1266589295, 'US', 'USA', 'الولايات المتحدة'),
(12396, 1266589296, 1266589303, 'IE', 'IRL', 'إيرلندا'),
(12397, 1266589304, 1266599295, 'US', 'USA', 'الولايات المتحدة'),
(12398, 1266599296, 1266599303, 'IE', 'IRL', 'إيرلندا'),
(12399, 1266599304, 1266599559, 'US', 'USA', 'الولايات المتحدة'),
(12400, 1266599560, 1266599567, 'SA', 'SAU', 'السعودية'),
(12401, 1266599568, 1266606527, 'US', 'USA', 'الولايات المتحدة'),
(12402, 1266606528, 1266606559, 'AR', 'ARG', 'الأرجنتين'),
(12403, 1266606560, 1268252671, 'US', 'USA', 'الولايات المتحدة'),
(12404, 1268252672, 1268776959, 'CA', 'CAN', 'كندا'),
(12405, 1268776960, 1275600895, 'US', 'USA', 'الولايات المتحدة'),
(12406, 1275600896, 1275604991, 'BM', 'BMU', 'برمودا'),
(12407, 1275604992, 1275621375, 'US', 'USA', 'الولايات المتحدة'),
(12408, 1275621376, 1275625471, 'CA', 'CAN', 'كندا'),
(12409, 1275625472, 1275658239, 'US', 'USA', 'الولايات المتحدة'),
(12410, 1275658240, 1275658495, 'GB', 'GBR', 'المملكة المتحدة'),
(12411, 1275658496, 1275659007, 'US', 'USA', 'الولايات المتحدة'),
(12412, 1275659008, 1275659263, 'GB', 'GBR', 'المملكة المتحدة'),
(12413, 1275659264, 1275665151, 'US', 'USA', 'الولايات المتحدة'),
(12414, 1275665152, 1275665407, 'UA', 'UKR', 'أوكرانيا'),
(12415, 1275665408, 1275666431, 'US', 'USA', 'الولايات المتحدة'),
(12416, 1275666432, 1275674623, 'CA', 'CAN', 'كندا'),
(12417, 1275674624, 1275707391, 'US', 'USA', 'الولايات المتحدة'),
(12418, 1275707392, 1275708927, 'CA', 'CAN', 'كندا'),
(12419, 1275708928, 1275709183, 'US', 'USA', 'الولايات المتحدة'),
(12420, 1275709184, 1275711487, 'CA', 'CAN', 'كندا'),
(12421, 1275711488, 1275712511, 'US', 'USA', 'الولايات المتحدة'),
(12422, 1275712512, 1275714047, 'CA', 'CAN', 'كندا'),
(12423, 1275714048, 1275714559, 'US', 'USA', 'الولايات المتحدة'),
(12424, 1275714560, 1275715583, 'CA', 'CAN', 'كندا'),
(12425, 1275715584, 1275756543, 'US', 'USA', 'الولايات المتحدة'),
(12426, 1275756544, 1275772927, 'CA', 'CAN', 'كندا'),
(12427, 1275772928, 1275785215, 'US', 'USA', 'الولايات المتحدة'),
(12428, 1275789312, 1275822079, 'CA', 'CAN', 'كندا'),
(12429, 1275822080, 1279262719, 'US', 'USA', 'الولايات المتحدة'),
(12430, 1279262720, 1279787007, 'CA', 'CAN', 'كندا'),
(12431, 1279787008, 1279819775, 'US', 'USA', 'الولايات المتحدة'),
(12432, 1279852544, 1279950847, 'US', 'USA', 'الولايات المتحدة'),
(12433, 1279950848, 1279951103, 'FI', 'FIN', 'فنلندا'),
(12434, 1279951104, 1279951359, 'US', 'USA', 'الولايات المتحدة'),
(12435, 1279951360, 1279952127, 'CA', 'CAN', 'كندا'),
(12436, 1279952128, 1279952383, 'US', 'USA', 'الولايات المتحدة'),
(12437, 1279952384, 1279952895, 'CA', 'CAN', 'كندا'),
(12438, 1279952896, 1279952919, 'US', 'USA', 'الولايات المتحدة'),
(12439, 1279952920, 1279952927, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12440, 1279952928, 1279953023, 'US', 'USA', 'الولايات المتحدة'),
(12441, 1279953024, 1279953055, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(12442, 1279953056, 1279959551, 'US', 'USA', 'الولايات المتحدة'),
(12443, 1279959552, 1279959807, 'CA', 'CAN', 'كندا'),
(12444, 1279959808, 1279960511, 'US', 'USA', 'الولايات المتحدة'),
(12445, 1279960512, 1279960527, 'CA', 'CAN', 'كندا'),
(12446, 1279960528, 1279967231, 'US', 'USA', 'الولايات المتحدة'),
(12447, 1279967232, 1279971327, 'CA', 'CAN', 'كندا'),
(12448, 1279971328, 1279971839, 'US', 'USA', 'الولايات المتحدة'),
(12449, 1279971840, 1279972095, 'CA', 'CAN', 'كندا'),
(12450, 1279972096, 1279977471, 'US', 'USA', 'الولايات المتحدة'),
(12451, 1279977472, 1279977983, 'CA', 'CAN', 'كندا'),
(12452, 1279977984, 1279980159, 'US', 'USA', 'الولايات المتحدة'),
(12453, 1279980160, 1279980287, 'CA', 'CAN', 'كندا'),
(12454, 1279980288, 1279999999, 'US', 'USA', 'الولايات المتحدة'),
(12455, 1280000000, 1280032767, 'CA', 'CAN', 'كندا'),
(12456, 1280032768, 1280040959, 'US', 'USA', 'الولايات المتحدة'),
(12457, 1280040960, 1280049151, 'CA', 'CAN', 'كندا'),
(12458, 1280049152, 1280073727, 'US', 'USA', 'الولايات المتحدة'),
(12459, 1280073728, 1280075295, 'CA', 'CAN', 'كندا'),
(12460, 1280075296, 1280075303, 'US', 'USA', 'الولايات المتحدة'),
(12461, 1280075304, 1280075487, 'CA', 'CAN', 'كندا'),
(12462, 1280075488, 1280075495, 'US', 'USA', 'الولايات المتحدة'),
(12463, 1280075496, 1280075759, 'CA', 'CAN', 'كندا'),
(12464, 1280075760, 1280075767, 'US', 'USA', 'الولايات المتحدة'),
(12465, 1280075768, 1280078711, 'CA', 'CAN', 'كندا'),
(12466, 1280078712, 1280078719, 'US', 'USA', 'الولايات المتحدة'),
(12467, 1280078720, 1280078743, 'CA', 'CAN', 'كندا'),
(12468, 1280078744, 1280078751, 'US', 'USA', 'الولايات المتحدة'),
(12469, 1280078752, 1280081919, 'CA', 'CAN', 'كندا'),
(12470, 1280081920, 1280090111, 'US', 'USA', 'الولايات المتحدة'),
(12471, 1280090112, 1280092159, 'AG', 'ATG', 'انتيغوا وبربودا'),
(12472, 1280092160, 1280093183, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(12473, 1280093184, 1280095231, 'AG', 'ATG', 'انتيغوا وبربودا'),
(12474, 1280095232, 1280095487, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(12475, 1280095488, 1280097279, 'AG', 'ATG', 'انتيغوا وبربودا'),
(12476, 1280097280, 1280097791, 'LC', 'LCA', 'سانت لوسيا'),
(12477, 1280097792, 1280098303, 'AG', 'ATG', 'انتيغوا وبربودا'),
(12478, 1280098304, 1280102399, 'PR', 'PRI', 'بورتو ريكو'),
(12479, 1280102400, 1280131071, 'US', 'USA', 'الولايات المتحدة'),
(12480, 1280131072, 1280139263, 'CA', 'CAN', 'كندا'),
(12481, 1280139264, 1291845631, 'US', 'USA', 'الولايات المتحدة'),
(12482, 1291845632, 1292894207, 'DE', 'DEU', 'ألمانيا'),
(12483, 1292894208, 1293156351, 'NO', 'NOR', 'النرويج'),
(12484, 1293156352, 1293549567, 'DE', 'DEU', 'ألمانيا'),
(12485, 1293549568, 1293680639, 'ES', 'ESP', 'إسبانيا'),
(12486, 1293680640, 1293811711, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(12487, 1293811712, 1293942783, 'SA', 'SAU', 'السعودية'),
(12488, 1293942784, 1294073855, 'PL', 'POL', 'بولندا'),
(12489, 1294073856, 1294204927, 'RU', 'RUS', 'الإتحاد الروسي'),
(12490, 1294204928, 1294237695, 'RO', 'ROM', 'رومانيا'),
(12491, 1294237696, 1294270463, 'IR', 'IRN', 'إيران'),
(12492, 1294270464, 1294278463, 'DE', 'DEU', 'ألمانيا'),
(12493, 1294278464, 1294278495, 'CA', 'CAN', 'كندا'),
(12494, 1294278496, 1294303231, 'DE', 'DEU', 'ألمانيا'),
(12495, 1294303232, 1294335999, 'RU', 'RUS', 'الإتحاد الروسي'),
(12496, 1294336000, 1294368767, 'SI', 'SVN', 'سلوفينيا'),
(12497, 1294368768, 1294401535, 'LV', 'LVA', 'لاتفيا'),
(12498, 1294401536, 1294434303, 'RU', 'RUS', 'الإتحاد الروسي'),
(12499, 1294434304, 1294467071, 'IT', 'ITA', 'إيطاليا'),
(12500, 1294467072, 1294499839, 'RU', 'RUS', 'الإتحاد الروسي'),
(12501, 1294499840, 1294532607, 'NO', 'NOR', 'النرويج'),
(12502, 1294532608, 1294598143, 'RU', 'RUS', 'الإتحاد الروسي'),
(12503, 1294598144, 1294630911, 'IT', 'ITA', 'إيطاليا'),
(12504, 1294630912, 1294663679, 'LB', 'LBN', 'لبنان'),
(12505, 1294663680, 1294696447, 'IT', 'ITA', 'إيطاليا'),
(12506, 1294696448, 1294729215, 'RU', 'RUS', 'الإتحاد الروسي'),
(12507, 1294729216, 1294761983, 'GB', 'GBR', 'المملكة المتحدة'),
(12508, 1294761984, 1294794751, 'SY', 'SYR', 'سوريا'),
(12509, 1294794752, 1294827519, 'PL', 'POL', 'بولندا'),
(12510, 1294827520, 1294860287, 'RU', 'RUS', 'الإتحاد الروسي'),
(12511, 1294860288, 1294893055, 'PL', 'POL', 'بولندا'),
(12512, 1294893056, 1294895103, 'RS', 'SRB', 'صربيا'),
(12513, 1294895104, 1294895135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12514, 1294895136, 1294895151, 'RS', 'SRB', 'صربيا'),
(12515, 1294895152, 1294895167, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12516, 1294895168, 1294895199, 'RS', 'SRB', 'صربيا'),
(12517, 1294895200, 1294895279, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12518, 1294895280, 1294895287, 'RS', 'SRB', 'صربيا'),
(12519, 1294895288, 1294895303, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12520, 1294895304, 1294895311, 'RS', 'SRB', 'صربيا'),
(12521, 1294895312, 1294895495, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12522, 1294895496, 1294896127, 'RS', 'SRB', 'صربيا'),
(12523, 1294896128, 1294899455, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12524, 1294899456, 1294901247, 'RS', 'SRB', 'صربيا'),
(12525, 1294901248, 1294902015, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12526, 1294902016, 1294902271, 'RS', 'SRB', 'صربيا'),
(12527, 1294902272, 1294925823, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(12528, 1294925824, 1294958591, 'DE', 'DEU', 'ألمانيا'),
(12529, 1294958592, 1294991359, 'UA', 'UKR', 'أوكرانيا'),
(12530, 1294991360, 1294998527, 'CZ', 'CZE', 'التشيك'),
(12531, 1294998528, 1294998591, 'SK', 'SVK', 'سلوفاكيا'),
(12532, 1294998592, 1295009023, 'CZ', 'CZE', 'التشيك'),
(12533, 1295009024, 1295009407, 'SK', 'SVK', 'سلوفاكيا'),
(12534, 1295009408, 1295047679, 'CZ', 'CZE', 'التشيك'),
(12535, 1295047680, 1295048191, 'SK', 'SVK', 'سلوفاكيا'),
(12536, 1295048192, 1295056895, 'CZ', 'CZE', 'التشيك'),
(12537, 1295056896, 1295122431, 'GR', 'GRC', 'اليونان'),
(12538, 1295122432, 1295253503, 'RU', 'RUS', 'الإتحاد الروسي'),
(12539, 1295253504, 1295319039, 'UA', 'UKR', 'أوكرانيا'),
(12540, 1295319040, 1295384575, 'SE', 'SWE', 'السويد'),
(12541, 1295384576, 1295450111, 'PT', 'PRT', 'البورتوغال'),
(12542, 1295450112, 1295515647, 'PL', 'POL', 'بولندا'),
(12543, 1295515648, 1295777791, 'CH', 'CHE', 'سويسرا'),
(12544, 1295777792, 1296039935, 'NL', 'NLD', 'هولندا'),
(12545, 1296039936, 1296072703, 'SA', 'SAU', 'السعودية'),
(12546, 1296072704, 1296105471, 'DE', 'DEU', 'ألمانيا'),
(12547, 1296105472, 1296171007, 'PL', 'POL', 'بولندا'),
(12548, 1296171008, 1296171599, 'DK', 'DNK', 'الدنيمارك'),
(12549, 1296171600, 1296171600, 'DE', 'DEU', 'ألمانيا'),
(12550, 1296171601, 1296171601, 'GB', 'GBR', 'المملكة المتحدة'),
(12551, 1296171602, 1296181743, 'DK', 'DNK', 'الدنيمارك'),
(12552, 1296181744, 1296181751, 'GB', 'GBR', 'المملكة المتحدة'),
(12553, 1296181752, 1296203775, 'DK', 'DNK', 'الدنيمارك'),
(12554, 1296203776, 1296236543, 'RU', 'RUS', 'الإتحاد الروسي'),
(12555, 1296236544, 1296236671, 'FR', 'FRA', 'فرنسا'),
(12556, 1296236672, 1296236799, 'US', 'USA', 'الولايات المتحدة'),
(12557, 1296236800, 1296237055, 'GB', 'GBR', 'المملكة المتحدة'),
(12558, 1296237056, 1296237311, 'FR', 'FRA', 'فرنسا'),
(12559, 1296237312, 1296237567, 'US', 'USA', 'الولايات المتحدة'),
(12560, 1296237568, 1296237823, 'NL', 'NLD', 'هولندا'),
(12561, 1296237824, 1296238079, 'ES', 'ESP', 'إسبانيا'),
(12562, 1296238080, 1296238591, 'IL', 'ISR', 'إسرائيل'),
(12563, 1296238592, 1296239103, 'NL', 'NLD', 'هولندا'),
(12564, 1296239104, 1296239231, 'FR', 'FRA', 'فرنسا'),
(12565, 1296239232, 1296239359, 'NL', 'NLD', 'هولندا'),
(12566, 1296239360, 1296239615, 'ES', 'ESP', 'إسبانيا'),
(12567, 1296239616, 1296240127, 'IE', 'IRL', 'إيرلندا'),
(12568, 1296240128, 1296241151, 'BE', 'BEL', 'بلجيكا'),
(12569, 1296241152, 1296241407, 'IT', 'ITA', 'إيطاليا'),
(12570, 1296241408, 1296242175, 'NL', 'NLD', 'هولندا'),
(12571, 1296242176, 1296242303, 'DE', 'DEU', 'ألمانيا'),
(12572, 1296242304, 1296242431, 'NL', 'NLD', 'هولندا'),
(12573, 1296242432, 1296242687, 'BE', 'BEL', 'بلجيكا'),
(12574, 1296242688, 1296243199, 'IE', 'IRL', 'إيرلندا'),
(12575, 1296243200, 1296243455, 'GB', 'GBR', 'المملكة المتحدة'),
(12576, 1296243456, 1296244223, 'US', 'USA', 'الولايات المتحدة'),
(12577, 1296244224, 1296244479, 'NL', 'NLD', 'هولندا'),
(12578, 1296244480, 1296244735, 'GB', 'GBR', 'المملكة المتحدة'),
(12579, 1296244736, 1296244991, 'IR', 'IRN', 'إيران'),
(12580, 1296244992, 1296245247, 'CH', 'CHE', 'سويسرا'),
(12581, 1296245248, 1296245503, 'CA', 'CAN', 'كندا'),
(12582, 1296245504, 1296245759, 'NL', 'NLD', 'هولندا'),
(12583, 1296245760, 1296246783, 'ES', 'ESP', 'إسبانيا'),
(12584, 1296246784, 1296247295, 'NL', 'NLD', 'هولندا'),
(12585, 1296247296, 1296247807, 'FR', 'FRA', 'فرنسا'),
(12586, 1296247808, 1296247871, 'US', 'USA', 'الولايات المتحدة'),
(12587, 1296247872, 1296247935, 'FR', 'FRA', 'فرنسا'),
(12588, 1296247936, 1296248255, 'IE', 'IRL', 'إيرلندا'),
(12589, 1296248256, 1296248318, 'BE', 'BEL', 'بلجيكا'),
(12590, 1296248319, 1296248319, 'IE', 'IRL', 'إيرلندا'),
(12591, 1296248320, 1296248383, 'BE', 'BEL', 'بلجيكا'),
(12592, 1296248384, 1296248447, 'IE', 'IRL', 'إيرلندا'),
(12593, 1296248448, 1296248575, 'US', 'USA', 'الولايات المتحدة'),
(12594, 1296248576, 1296249855, 'IE', 'IRL', 'إيرلندا'),
(12595, 1296249856, 1296249887, 'US', 'USA', 'الولايات المتحدة'),
(12596, 1296249888, 1296249919, 'FR', 'FRA', 'فرنسا'),
(12597, 1296249920, 1296249951, 'IE', 'IRL', 'إيرلندا'),
(12598, 1296249952, 1296250015, 'DE', 'DEU', 'ألمانيا'),
(12599, 1296250016, 1296250047, 'IL', 'ISR', 'إسرائيل'),
(12600, 1296250048, 1296250079, 'IE', 'IRL', 'إيرلندا'),
(12601, 1296250080, 1296250111, 'IL', 'ISR', 'إسرائيل'),
(12602, 1296250112, 1296250143, 'IE', 'IRL', 'إيرلندا'),
(12603, 1296250144, 1296250175, 'GB', 'GBR', 'المملكة المتحدة'),
(12604, 1296250176, 1296250207, 'BE', 'BEL', 'بلجيكا'),
(12605, 1296250208, 1296250239, 'ES', 'ESP', 'إسبانيا'),
(12606, 1296250240, 1296250271, 'BE', 'BEL', 'بلجيكا'),
(12607, 1296250272, 1296250303, 'DE', 'DEU', 'ألمانيا'),
(12608, 1296250304, 1296250335, 'FR', 'FRA', 'فرنسا'),
(12609, 1296250336, 1296251135, 'IE', 'IRL', 'إيرلندا'),
(12610, 1296251136, 1296251167, 'GB', 'GBR', 'المملكة المتحدة'),
(12611, 1296251168, 1296251199, 'HR', 'HRV', 'كرواتيا'),
(12612, 1296251200, 1296251295, 'DE', 'DEU', 'ألمانيا'),
(12613, 1296251296, 1296251327, 'BE', 'BEL', 'بلجيكا'),
(12614, 1296251328, 1296251359, 'IE', 'IRL', 'إيرلندا'),
(12615, 1296251360, 1296251391, 'DE', 'DEU', 'ألمانيا'),
(12616, 1296251392, 1296251775, 'NL', 'NLD', 'هولندا'),
(12617, 1296251776, 1296252143, 'IE', 'IRL', 'إيرلندا'),
(12618, 1296252144, 1296252159, 'US', 'USA', 'الولايات المتحدة'),
(12619, 1296252160, 1296252175, 'GB', 'GBR', 'المملكة المتحدة'),
(12620, 1296252176, 1296252191, 'PL', 'POL', 'بولندا'),
(12621, 1296252192, 1296252207, 'RO', 'ROM', 'رومانيا'),
(12622, 1296252208, 1296252223, 'BG', 'BGR', 'بلغاريا'),
(12623, 1296252224, 1296252239, 'GB', 'GBR', 'المملكة المتحدة'),
(12624, 1296252240, 1296252255, 'IT', 'ITA', 'إيطاليا'),
(12625, 1296252256, 1296252271, 'GB', 'GBR', 'المملكة المتحدة'),
(12626, 1296252272, 1296252303, 'FR', 'FRA', 'فرنسا'),
(12627, 1296252304, 1296252319, 'IL', 'ISR', 'إسرائيل'),
(12628, 1296252320, 1296252335, 'IE', 'IRL', 'إيرلندا'),
(12629, 1296252336, 1296252351, 'FR', 'FRA', 'فرنسا'),
(12630, 1296252352, 1296252367, 'IE', 'IRL', 'إيرلندا'),
(12631, 1296252368, 1296252383, 'DE', 'DEU', 'ألمانيا'),
(12632, 1296252384, 1296252727, 'IE', 'IRL', 'إيرلندا'),
(12633, 1296252728, 1296252735, 'IL', 'ISR', 'إسرائيل'),
(12634, 1296252736, 1296252739, 'IE', 'IRL', 'إيرلندا'),
(12635, 1296252740, 1296252743, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(12636, 1296252744, 1296252759, 'FR', 'FRA', 'فرنسا'),
(12637, 1296252760, 1296252791, 'DE', 'DEU', 'ألمانيا'),
(12638, 1296252792, 1296252799, 'IE', 'IRL', 'إيرلندا'),
(12639, 1296252800, 1296252839, 'GB', 'GBR', 'المملكة المتحدة'),
(12640, 1296252840, 1296252847, 'DE', 'DEU', 'ألمانيا'),
(12641, 1296252848, 1296252855, 'GB', 'GBR', 'المملكة المتحدة'),
(12642, 1296252856, 1296252871, 'IE', 'IRL', 'إيرلندا'),
(12643, 1296252872, 1296252879, 'BE', 'BEL', 'بلجيكا'),
(12644, 1296252880, 1296252887, 'DE', 'DEU', 'ألمانيا'),
(12645, 1296252888, 1296252895, 'IE', 'IRL', 'إيرلندا'),
(12646, 1296252896, 1296252911, 'BE', 'BEL', 'بلجيكا'),
(12647, 1296252912, 1296252919, 'IE', 'IRL', 'إيرلندا'),
(12648, 1296252920, 1296252927, 'PL', 'POL', 'بولندا'),
(12649, 1296252928, 1296255743, 'DE', 'DEU', 'ألمانيا'),
(12650, 1296255744, 1296255999, 'IE', 'IRL', 'إيرلندا'),
(12651, 1296256000, 1296257023, 'DE', 'DEU', 'ألمانيا'),
(12652, 1296257024, 1296257535, 'US', 'USA', 'الولايات المتحدة'),
(12653, 1296257536, 1296257791, 'IE', 'IRL', 'إيرلندا'),
(12654, 1296257792, 1296258047, 'US', 'USA', 'الولايات المتحدة'),
(12655, 1296258048, 1296258303, 'TW', 'TWN', 'تايوان'),
(12656, 1296258304, 1296259071, 'NL', 'NLD', 'هولندا'),
(12657, 1296259072, 1296259583, 'US', 'USA', 'الولايات المتحدة'),
(12658, 1296259584, 1296259839, 'IE', 'IRL', 'إيرلندا'),
(12659, 1296259840, 1296260351, 'NL', 'NLD', 'هولندا'),
(12660, 1296260352, 1296260607, 'US', 'USA', 'الولايات المتحدة'),
(12661, 1296260608, 1296262143, 'IE', 'IRL', 'إيرلندا'),
(12662, 1296262144, 1296262655, 'US', 'USA', 'الولايات المتحدة'),
(12663, 1296262656, 1296262911, 'CA', 'CAN', 'كندا'),
(12664, 1296262912, 1296263935, 'US', 'USA', 'الولايات المتحدة'),
(12665, 1296263936, 1296263943, 'IE', 'IRL', 'إيرلندا'),
(12666, 1296263944, 1296263999, 'US', 'USA', 'الولايات المتحدة'),
(12667, 1296264000, 1296264015, 'IE', 'IRL', 'إيرلندا'),
(12668, 1296264016, 1296264023, 'US', 'USA', 'الولايات المتحدة'),
(12669, 1296264024, 1296264027, 'DE', 'DEU', 'ألمانيا'),
(12670, 1296264028, 1296264031, 'IE', 'IRL', 'إيرلندا'),
(12671, 1296264032, 1296264035, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(12672, 1296264036, 1296264039, 'IE', 'IRL', 'إيرلندا'),
(12673, 1296264040, 1296264047, 'US', 'USA', 'الولايات المتحدة'),
(12674, 1296264048, 1296264063, 'IE', 'IRL', 'إيرلندا'),
(12675, 1296264064, 1296264151, 'GB', 'GBR', 'المملكة المتحدة'),
(12676, 1296264152, 1296264191, 'IE', 'IRL', 'إيرلندا'),
(12677, 1296264192, 1296264223, 'US', 'USA', 'الولايات المتحدة'),
(12678, 1296264224, 1296264271, 'IE', 'IRL', 'إيرلندا'),
(12679, 1296264272, 1296264303, 'US', 'USA', 'الولايات المتحدة'),
(12680, 1296264304, 1296264319, 'CA', 'CAN', 'كندا'),
(12681, 1296264320, 1296264399, 'US', 'USA', 'الولايات المتحدة'),
(12682, 1296264400, 1296264447, 'IE', 'IRL', 'إيرلندا'),
(12683, 1296264448, 1296264543, 'US', 'USA', 'الولايات المتحدة'),
(12684, 1296264544, 1296264639, 'CA', 'CAN', 'كندا'),
(12685, 1296264640, 1296264671, 'US', 'USA', 'الولايات المتحدة'),
(12686, 1296264672, 1296264703, 'IE', 'IRL', 'إيرلندا'),
(12687, 1296264704, 1296265023, 'US', 'USA', 'الولايات المتحدة'),
(12688, 1296265024, 1296265087, 'IE', 'IRL', 'إيرلندا'),
(12689, 1296265088, 1296265151, 'CA', 'CAN', 'كندا'),
(12690, 1296265152, 1296265215, 'FR', 'FRA', 'فرنسا'),
(12691, 1296265216, 1296267263, 'US', 'USA', 'الولايات المتحدة'),
(12692, 1296267264, 1296267519, 'IE', 'IRL', 'إيرلندا'),
(12693, 1296267520, 1296267775, 'CA', 'CAN', 'كندا'),
(12694, 1296267776, 1296268799, 'US', 'USA', 'الولايات المتحدة'),
(12695, 1296268800, 1296269055, 'FR', 'FRA', 'فرنسا'),
(12696, 1296269056, 1296269311, 'US', 'USA', 'الولايات المتحدة'),
(12697, 1296269312, 1296302079, 'TR', 'TUR', 'تركيا'),
(12698, 1296302080, 1296334847, 'GB', 'GBR', 'المملكة المتحدة'),
(12699, 1296334848, 1296367615, 'DK', 'DNK', 'الدنيمارك'),
(12700, 1296367616, 1296400383, 'GR', 'GRC', 'اليونان'),
(12701, 1296400384, 1296433151, 'BH', 'BHR', 'البحرين'),
(12702, 1296433152, 1296465919, 'BG', 'BGR', 'بلغاريا'),
(12703, 1296465920, 1296466239, 'NG', 'NGA', 'نيجيريا'),
(12704, 1296466240, 1296466303, 'NO', 'NOR', 'النرويج'),
(12705, 1296466304, 1296466335, 'BF', 'BFA', 'بوركينا فاسو'),
(12706, 1296466336, 1296466367, 'NO', 'NOR', 'النرويج'),
(12707, 1296466368, 1296466383, 'AO', 'AGO', 'أنغولا'),
(12708, 1296466384, 1296466415, 'NO', 'NOR', 'النرويج'),
(12709, 1296466416, 1296466431, 'NG', 'NGA', 'نيجيريا'),
(12710, 1296466432, 1296466559, 'NO', 'NOR', 'النرويج'),
(12711, 1296466560, 1296466575, 'NG', 'NGA', 'نيجيريا'),
(12712, 1296466576, 1296466591, 'NO', 'NOR', 'النرويج'),
(12713, 1296466592, 1296466607, 'NG', 'NGA', 'نيجيريا'),
(12714, 1296466608, 1296466623, 'NO', 'NOR', 'النرويج'),
(12715, 1296466624, 1296466639, 'NG', 'NGA', 'نيجيريا'),
(12716, 1296466640, 1296466655, 'NO', 'NOR', 'النرويج'),
(12717, 1296466656, 1296466671, 'BJ', 'BEN', 'بنين'),
(12718, 1296466672, 1296466679, 'NG', 'NGA', 'نيجيريا'),
(12719, 1296466680, 1296466687, 'NO', 'NOR', 'النرويج'),
(12720, 1296466688, 1296466719, 'BJ', 'BEN', 'بنين'),
(12721, 1296466720, 1296468479, 'NO', 'NOR', 'النرويج'),
(12722, 1296468480, 1296469247, 'NG', 'NGA', 'نيجيريا'),
(12723, 1296469248, 1296469503, 'NO', 'NOR', 'النرويج'),
(12724, 1296469504, 1296469759, 'ZM', 'ZMB', 'زامبيا'),
(12725, 1296469760, 1296472351, 'NO', 'NOR', 'النرويج'),
(12726, 1296472352, 1296472383, 'NG', 'NGA', 'نيجيريا'),
(12727, 1296472384, 1296472415, 'BI', 'BDI', 'بوروندي'),
(12728, 1296472416, 1296473087, 'NO', 'NOR', 'النرويج'),
(12729, 1296473088, 1296474623, 'LT', 'LTU', 'ليتوانيا'),
(12730, 1296474624, 1296476159, 'US', 'USA', 'الولايات المتحدة'),
(12731, 1296476160, 1296498687, 'LT', 'LTU', 'ليتوانيا'),
(12732, 1296498688, 1296531455, 'BG', 'BGR', 'بلغاريا'),
(12733, 1296531456, 1296564223, 'MT', 'MLT', 'مالطا'),
(12734, 1296564224, 1296566271, 'GB', 'GBR', 'المملكة المتحدة'),
(12735, 1296566272, 1296568319, 'DE', 'DEU', 'ألمانيا'),
(12736, 1296568320, 1296570367, 'RU', 'RUS', 'الإتحاد الروسي'),
(12737, 1296570368, 1296574463, 'IT', 'ITA', 'إيطاليا'),
(12738, 1296574464, 1296576511, 'FR', 'FRA', 'فرنسا'),
(12739, 1296576512, 1296578559, 'DK', 'DNK', 'الدنيمارك'),
(12740, 1296578560, 1296580607, 'FI', 'FIN', 'فنلندا'),
(12741, 1296580608, 1296582655, 'CH', 'CHE', 'سويسرا'),
(12742, 1296582656, 1296584703, 'IE', 'IRL', 'إيرلندا'),
(12743, 1296584704, 1296586751, 'RU', 'RUS', 'الإتحاد الروسي'),
(12744, 1296586752, 1296588799, 'FR', 'FRA', 'فرنسا'),
(12745, 1296588800, 1296590847, 'SE', 'SWE', 'السويد'),
(12746, 1296590848, 1296592895, 'ES', 'ESP', 'إسبانيا'),
(12747, 1296592896, 1296594943, 'NL', 'NLD', 'هولندا'),
(12748, 1296594944, 1296596991, 'RU', 'RUS', 'الإتحاد الروسي'),
(12749, 1296596992, 1296599039, 'CH', 'CHE', 'سويسرا'),
(12750, 1296599040, 1296601087, 'RU', 'RUS', 'الإتحاد الروسي'),
(12751, 1296601088, 1296603135, 'DE', 'DEU', 'ألمانيا'),
(12752, 1296603136, 1296605183, 'NL', 'NLD', 'هولندا'),
(12753, 1296605184, 1296606271, 'AT', 'AUT', 'النمسا'),
(12754, 1296606272, 1296606335, 'DE', 'DEU', 'ألمانيا'),
(12755, 1296606336, 1296606367, 'AT', 'AUT', 'النمسا'),
(12756, 1296606368, 1296606399, 'CH', 'CHE', 'سويسرا'),
(12757, 1296606400, 1296607231, 'AT', 'AUT', 'النمسا'),
(12758, 1296607232, 1296607759, 'DE', 'DEU', 'ألمانيا'),
(12759, 1296607760, 1296607999, 'NL', 'NLD', 'هولندا'),
(12760, 1296608000, 1296609023, 'CH', 'CHE', 'سويسرا'),
(12761, 1296609024, 1296609279, 'NL', 'NLD', 'هولندا'),
(12762, 1296609280, 1296611327, 'CH', 'CHE', 'سويسرا'),
(12763, 1296611328, 1296613375, 'TR', 'TUR', 'تركيا'),
(12764, 1296613376, 1296615423, 'IT', 'ITA', 'إيطاليا'),
(12765, 1296615424, 1296617471, 'GB', 'GBR', 'المملكة المتحدة'),
(12766, 1296617472, 1296619519, 'ES', 'ESP', 'إسبانيا'),
(12767, 1296619520, 1296621567, 'IT', 'ITA', 'إيطاليا'),
(12768, 1296621568, 1296623615, 'SE', 'SWE', 'السويد'),
(12769, 1296623616, 1296625663, 'BE', 'BEL', 'بلجيكا'),
(12770, 1296625664, 1296629759, 'RU', 'RUS', 'الإتحاد الروسي'),
(12771, 1296631808, 1296633855, 'GB', 'GBR', 'المملكة المتحدة'),
(12772, 1296633856, 1296635903, 'NL', 'NLD', 'هولندا'),
(12773, 1296635904, 1296637951, 'RU', 'RUS', 'الإتحاد الروسي'),
(12774, 1296637952, 1296639999, 'CH', 'CHE', 'سويسرا'),
(12775, 1296640000, 1296642047, 'ES', 'ESP', 'إسبانيا'),
(12776, 1296642048, 1296644095, 'RU', 'RUS', 'الإتحاد الروسي'),
(12777, 1296644096, 1296646143, 'IT', 'ITA', 'إيطاليا'),
(12778, 1296646144, 1296648191, 'RU', 'RUS', 'الإتحاد الروسي'),
(12779, 1296648192, 1296650239, 'GB', 'GBR', 'المملكة المتحدة'),
(12780, 1296650240, 1296652287, 'ES', 'ESP', 'إسبانيا'),
(12781, 1296652288, 1296654335, 'RU', 'RUS', 'الإتحاد الروسي'),
(12782, 1296654336, 1296656383, 'BE', 'BEL', 'بلجيكا'),
(12783, 1296656384, 1296658431, 'RU', 'RUS', 'الإتحاد الروسي'),
(12784, 1296658432, 1296662527, 'GB', 'GBR', 'المملكة المتحدة'),
(12785, 1296662528, 1296664575, 'KZ', 'KAZ', 'كازاخستان'),
(12786, 1296664576, 1296666623, 'RU', 'RUS', 'الإتحاد الروسي'),
(12787, 1296666624, 1296670719, 'GB', 'GBR', 'المملكة المتحدة'),
(12788, 1296670720, 1296672767, 'ES', 'ESP', 'إسبانيا'),
(12789, 1296672768, 1296674815, 'GB', 'GBR', 'المملكة المتحدة'),
(12790, 1296674816, 1296676863, 'BE', 'BEL', 'بلجيكا'),
(12791, 1296676864, 1296677271, 'NG', 'NGA', 'نيجيريا'),
(12792, 1296677272, 1296677287, 'JE', 'JEY', 'جيرسي'),
(12793, 1296677288, 1296677311, 'NG', 'NGA', 'نيجيريا'),
(12794, 1296677312, 1296677319, 'JE', 'JEY', 'جيرسي'),
(12795, 1296677320, 1296677343, 'NG', 'NGA', 'نيجيريا'),
(12796, 1296677344, 1296677351, 'JE', 'JEY', 'جيرسي'),
(12797, 1296677352, 1296677367, 'NG', 'NGA', 'نيجيريا'),
(12798, 1296677368, 1296677375, 'US', 'USA', 'الولايات المتحدة'),
(12799, 1296677376, 1296677511, 'NG', 'NGA', 'نيجيريا'),
(12800, 1296677512, 1296677519, 'JE', 'JEY', 'جيرسي'),
(12801, 1296677520, 1296677591, 'NG', 'NGA', 'نيجيريا'),
(12802, 1296677592, 1296677599, 'JE', 'JEY', 'جيرسي'),
(12803, 1296677600, 1296677703, 'NG', 'NGA', 'نيجيريا'),
(12804, 1296677704, 1296677719, 'JE', 'JEY', 'جيرسي'),
(12805, 1296677720, 1296677735, 'NG', 'NGA', 'نيجيريا'),
(12806, 1296677736, 1296677751, 'JE', 'JEY', 'جيرسي'),
(12807, 1296677752, 1296677767, 'NG', 'NGA', 'نيجيريا'),
(12808, 1296677768, 1296677775, 'JE', 'JEY', 'جيرسي'),
(12809, 1296677776, 1296677959, 'NG', 'NGA', 'نيجيريا'),
(12810, 1296677960, 1296677967, 'JE', 'JEY', 'جيرسي'),
(12811, 1296677968, 1296677991, 'NG', 'NGA', 'نيجيريا'),
(12812, 1296677992, 1296678015, 'JE', 'JEY', 'جيرسي'),
(12813, 1296678016, 1296678047, 'NG', 'NGA', 'نيجيريا'),
(12814, 1296678048, 1296678079, 'JE', 'JEY', 'جيرسي'),
(12815, 1296678080, 1296678119, 'NG', 'NGA', 'نيجيريا'),
(12816, 1296678120, 1296678143, 'JE', 'JEY', 'جيرسي'),
(12817, 1296678144, 1296678151, 'NG', 'NGA', 'نيجيريا'),
(12818, 1296678152, 1296678159, 'JE', 'JEY', 'جيرسي'),
(12819, 1296678160, 1296678215, 'NG', 'NGA', 'نيجيريا'),
(12820, 1296678216, 1296678223, 'JE', 'JEY', 'جيرسي'),
(12821, 1296678224, 1296678319, 'NG', 'NGA', 'نيجيريا'),
(12822, 1296678320, 1296678327, 'JE', 'JEY', 'جيرسي'),
(12823, 1296678328, 1296678351, 'NG', 'NGA', 'نيجيريا'),
(12824, 1296678352, 1296678367, 'JE', 'JEY', 'جيرسي'),
(12825, 1296678368, 1296678415, 'NG', 'NGA', 'نيجيريا'),
(12826, 1296678416, 1296678431, 'US', 'USA', 'الولايات المتحدة'),
(12827, 1296678432, 1296678447, 'NG', 'NGA', 'نيجيريا'),
(12828, 1296678448, 1296678463, 'JE', 'JEY', 'جيرسي'),
(12829, 1296678464, 1296678471, 'NG', 'NGA', 'نيجيريا'),
(12830, 1296678472, 1296678479, 'JE', 'JEY', 'جيرسي'),
(12831, 1296678480, 1296678775, 'NG', 'NGA', 'نيجيريا'),
(12832, 1296678776, 1296678791, 'JE', 'JEY', 'جيرسي'),
(12833, 1296678792, 1296678831, 'NG', 'NGA', 'نيجيريا'),
(12834, 1296678832, 1296678839, 'JE', 'JEY', 'جيرسي'),
(12835, 1296678840, 1296678911, 'NG', 'NGA', 'نيجيريا'),
(12836, 1296678912, 1296680959, 'SA', 'SAU', 'السعودية'),
(12837, 1296680960, 1296683007, 'ES', 'ESP', 'إسبانيا'),
(12838, 1296683008, 1296685055, 'IE', 'IRL', 'إيرلندا'),
(12839, 1296685056, 1296687103, 'TR', 'TUR', 'تركيا'),
(12840, 1296687104, 1296689151, 'NL', 'NLD', 'هولندا'),
(12841, 1296689152, 1296691199, 'RU', 'RUS', 'الإتحاد الروسي'),
(12842, 1296691200, 1296693247, 'CH', 'CHE', 'سويسرا'),
(12843, 1296693248, 1296695295, 'DE', 'DEU', 'ألمانيا'),
(12844, 1296695296, 1296697343, 'CH', 'CHE', 'سويسرا'),
(12845, 1296697344, 1296699391, 'RU', 'RUS', 'الإتحاد الروسي'),
(12846, 1296699392, 1296701439, 'IT', 'ITA', 'إيطاليا'),
(12847, 1296701440, 1296703487, 'RU', 'RUS', 'الإتحاد الروسي'),
(12848, 1296703488, 1296705535, 'BY', 'BLR', 'روسيا البيضاء'),
(12849, 1296705536, 1296707583, 'GE', 'GEO', 'جورجيا'),
(12850, 1296707584, 1296708039, 'NL', 'NLD', 'هولندا'),
(12851, 1296708040, 1296708047, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(12852, 1296708048, 1296709631, 'NL', 'NLD', 'هولندا'),
(12853, 1296709632, 1296711679, 'CY', 'CYP', 'قبرص'),
(12854, 1296711680, 1296713727, 'KZ', 'KAZ', 'كازاخستان'),
(12855, 1296713728, 1296715775, 'RU', 'RUS', 'الإتحاد الروسي'),
(12856, 1296715776, 1296717823, 'CH', 'CHE', 'سويسرا'),
(12857, 1296717824, 1296719871, 'BE', 'BEL', 'بلجيكا'),
(12858, 1296719872, 1296721919, 'CH', 'CHE', 'سويسرا'),
(12859, 1296721920, 1296723967, 'GB', 'GBR', 'المملكة المتحدة'),
(12860, 1296723968, 1296726015, 'AT', 'AUT', 'النمسا'),
(12861, 1296726016, 1296728063, 'GB', 'GBR', 'المملكة المتحدة'),
(12862, 1296728064, 1296730111, 'SE', 'SWE', 'السويد'),
(12863, 1296730112, 1296732159, 'DE', 'DEU', 'ألمانيا'),
(12864, 1296732160, 1296734207, 'IT', 'ITA', 'إيطاليا'),
(12865, 1296734208, 1296736255, 'FR', 'FRA', 'فرنسا'),
(12866, 1296736256, 1296738303, 'NO', 'NOR', 'النرويج'),
(12867, 1296738304, 1296738815, 'CH', 'CHE', 'سويسرا'),
(12868, 1296738816, 1296739327, 'FI', 'FIN', 'فنلندا'),
(12869, 1296739328, 1296740351, 'CH', 'CHE', 'سويسرا'),
(12870, 1296740352, 1296744447, 'RU', 'RUS', 'الإتحاد الروسي'),
(12871, 1296744448, 1296746495, 'GB', 'GBR', 'المملكة المتحدة'),
(12872, 1296746496, 1296748543, 'SI', 'SVN', 'سلوفينيا'),
(12873, 1296748544, 1296750591, 'FR', 'FRA', 'فرنسا'),
(12874, 1296750592, 1296752639, 'NO', 'NOR', 'النرويج'),
(12875, 1296752640, 1296754687, 'BA', 'BIH', 'البوسنه والهرسك'),
(12876, 1296754688, 1296754911, 'DE', 'DEU', 'ألمانيا'),
(12877, 1296754912, 1296754927, 'AT', 'AUT', 'النمسا'),
(12878, 1296754928, 1296756735, 'DE', 'DEU', 'ألمانيا'),
(12879, 1296756736, 1296758783, 'FR', 'FRA', 'فرنسا'),
(12880, 1296758784, 1296760831, 'RS', 'SRB', 'صربيا'),
(12881, 1296760832, 1296762879, 'GB', 'GBR', 'المملكة المتحدة'),
(12882, 1296762880, 1296764927, 'RU', 'RUS', 'الإتحاد الروسي'),
(12883, 1296764928, 1296769023, 'AT', 'AUT', 'النمسا'),
(12884, 1296769024, 1296771071, 'TR', 'TUR', 'تركيا'),
(12885, 1296771072, 1296773119, 'LT', 'LTU', 'ليتوانيا'),
(12886, 1296773120, 1296774367, 'FR', 'FRA', 'فرنسا'),
(12887, 1296775168, 1296779263, 'FR', 'FRA', 'فرنسا'),
(12888, 1296779264, 1296781311, 'CZ', 'CZE', 'التشيك'),
(12889, 1296781312, 1296783359, 'DK', 'DNK', 'الدنيمارك'),
(12890, 1296783360, 1296785407, 'LB', 'LBN', 'لبنان'),
(12891, 1296785408, 1296787455, 'IE', 'IRL', 'إيرلندا'),
(12892, 1296787456, 1296789503, 'GB', 'GBR', 'المملكة المتحدة'),
(12893, 1296789504, 1296791551, 'CH', 'CHE', 'سويسرا'),
(12894, 1296791552, 1296793599, 'NL', 'NLD', 'هولندا'),
(12895, 1296793600, 1296795647, 'RU', 'RUS', 'الإتحاد الروسي'),
(12896, 1296795648, 1296795903, 'NL', 'NLD', 'هولندا'),
(12897, 1296795904, 1296797695, 'GB', 'GBR', 'المملكة المتحدة'),
(12898, 1296797696, 1296799743, 'UA', 'UKR', 'أوكرانيا'),
(12899, 1296799744, 1296801791, 'RU', 'RUS', 'الإتحاد الروسي'),
(12900, 1296801792, 1296803839, 'DK', 'DNK', 'الدنيمارك'),
(12901, 1296803840, 1296805887, 'RU', 'RUS', 'الإتحاد الروسي'),
(12902, 1296805888, 1296807935, 'ES', 'ESP', 'إسبانيا'),
(12903, 1296807936, 1296812031, 'GB', 'GBR', 'المملكة المتحدة'),
(12904, 1296812032, 1296814079, 'DE', 'DEU', 'ألمانيا'),
(12905, 1296814080, 1296816127, 'NO', 'NOR', 'النرويج'),
(12906, 1296816128, 1296818175, 'TR', 'TUR', 'تركيا'),
(12907, 1296818176, 1296820223, 'ES', 'ESP', 'إسبانيا'),
(12908, 1296820224, 1296822271, 'GB', 'GBR', 'المملكة المتحدة'),
(12909, 1296822272, 1296824319, 'IE', 'IRL', 'إيرلندا'),
(12910, 1296824320, 1296826367, 'DE', 'DEU', 'ألمانيا'),
(12911, 1296826368, 1296842751, 'BG', 'BGR', 'بلغاريا'),
(12912, 1296842752, 1296859135, 'GB', 'GBR', 'المملكة المتحدة'),
(12913, 1296859136, 1296875519, 'BG', 'BGR', 'بلغاريا'),
(12914, 1296875520, 1296891903, 'DE', 'DEU', 'ألمانيا'),
(12915, 1296891904, 1296908287, 'BG', 'BGR', 'بلغاريا'),
(12916, 1296908288, 1296924671, 'IR', 'IRN', 'إيران'),
(12917, 1296924672, 1296941055, 'BG', 'BGR', 'بلغاريا'),
(12918, 1296941056, 1296957439, 'BA', 'BIH', 'البوسنه والهرسك'),
(12919, 1296957440, 1296973823, 'BG', 'BGR', 'بلغاريا'),
(12920, 1296973824, 1296990207, 'CZ', 'CZE', 'التشيك'),
(12921, 1296990208, 1297006591, 'BG', 'BGR', 'بلغاريا'),
(12922, 1297006592, 1297017631, 'BA', 'BIH', 'البوسنه والهرسك'),
(12923, 1297017632, 1297017647, 'US', 'USA', 'الولايات المتحدة'),
(12924, 1297017648, 1297017727, 'BA', 'BIH', 'البوسنه والهرسك'),
(12925, 1297017728, 1297017855, 'US', 'USA', 'الولايات المتحدة'),
(12926, 1297017856, 1297022975, 'BA', 'BIH', 'البوسنه والهرسك'),
(12927, 1297022976, 1297039359, 'LT', 'LTU', 'ليتوانيا'),
(12928, 1297039360, 1297055743, 'TR', 'TUR', 'تركيا'),
(12929, 1297055744, 1297072127, 'RU', 'RUS', 'الإتحاد الروسي'),
(12930, 1297072128, 1297074743, 'PL', 'POL', 'بولندا'),
(12931, 1297074744, 1297074751, 'SE', 'SWE', 'السويد'),
(12932, 1297074752, 1297083375, 'PL', 'POL', 'بولندا'),
(12933, 1297083376, 1297083391, 'SE', 'SWE', 'السويد'),
(12934, 1297083392, 1297088511, 'PL', 'POL', 'بولندا'),
(12935, 1297088512, 1297121279, 'AT', 'AUT', 'النمسا'),
(12936, 1297121280, 1297154047, 'SE', 'SWE', 'السويد'),
(12937, 1297154048, 1297219583, 'RO', 'ROM', 'رومانيا'),
(12938, 1297219584, 1297285119, 'RU', 'RUS', 'الإتحاد الروسي'),
(12939, 1297285120, 1297350655, 'GR', 'GRC', 'اليونان'),
(12940, 1297350656, 1297416191, 'FR', 'FRA', 'فرنسا'),
(12941, 1297416192, 1297481727, 'BG', 'BGR', 'بلغاريا'),
(12942, 1297481728, 1297514495, 'GB', 'GBR', 'المملكة المتحدة'),
(12943, 1297514496, 1297547263, 'FI', 'FIN', 'فنلندا'),
(12944, 1297547264, 1297549311, 'PL', 'POL', 'بولندا'),
(12945, 1297549312, 1297551359, 'LT', 'LTU', 'ليتوانيا'),
(12946, 1297551360, 1297553407, 'SA', 'SAU', 'السعودية'),
(12947, 1297553408, 1297555455, 'IE', 'IRL', 'إيرلندا'),
(12948, 1297555456, 1297559551, 'UA', 'UKR', 'أوكرانيا'),
(12949, 1297559552, 1297561599, 'DE', 'DEU', 'ألمانيا'),
(12950, 1297561600, 1297563647, 'NL', 'NLD', 'هولندا'),
(12951, 1297563648, 1297565695, 'RU', 'RUS', 'الإتحاد الروسي'),
(12952, 1297565696, 1297567743, 'PL', 'POL', 'بولندا'),
(12953, 1297567744, 1297569791, 'RU', 'RUS', 'الإتحاد الروسي'),
(12954, 1297569792, 1297571839, 'RO', 'ROM', 'رومانيا'),
(12955, 1297571840, 1297573887, 'RU', 'RUS', 'الإتحاد الروسي'),
(12956, 1297573888, 1297575935, 'FR', 'FRA', 'فرنسا'),
(12957, 1297577984, 1297580031, 'PL', 'POL', 'بولندا'),
(12958, 1297580032, 1297582079, 'GB', 'GBR', 'المملكة المتحدة'),
(12959, 1297582080, 1297584127, 'PL', 'POL', 'بولندا'),
(12960, 1297584128, 1297588223, 'UA', 'UKR', 'أوكرانيا'),
(12961, 1297588224, 1297590271, 'NL', 'NLD', 'هولندا'),
(12962, 1297590272, 1297592319, 'RU', 'RUS', 'الإتحاد الروسي'),
(12963, 1297592320, 1297594367, 'GB', 'GBR', 'المملكة المتحدة'),
(12964, 1297594368, 1297596415, 'DE', 'DEU', 'ألمانيا'),
(12965, 1297596416, 1297598463, 'UA', 'UKR', 'أوكرانيا'),
(12966, 1297598464, 1297602559, 'RU', 'RUS', 'الإتحاد الروسي'),
(12967, 1297602560, 1297604607, 'PL', 'POL', 'بولندا'),
(12968, 1297604608, 1297606655, 'DE', 'DEU', 'ألمانيا'),
(12969, 1297606656, 1297608703, 'CZ', 'CZE', 'التشيك'),
(12970, 1297610752, 1297612799, 'DE', 'DEU', 'ألمانيا'),
(12971, 1297612800, 1297629183, 'RU', 'RUS', 'الإتحاد الروسي'),
(12972, 1297629184, 1297645567, 'NO', 'NOR', 'النرويج'),
(12973, 1297645568, 1297661951, 'PL', 'POL', 'بولندا'),
(12974, 1297661952, 1297678335, 'UA', 'UKR', 'أوكرانيا'),
(12975, 1297678336, 1297694719, 'IT', 'ITA', 'إيطاليا'),
(12976, 1297694720, 1297711103, 'PL', 'POL', 'بولندا'),
(12977, 1297711104, 1297727487, 'GB', 'GBR', 'المملكة المتحدة'),
(12978, 1297727488, 1297743871, 'MD', 'MDA', 'مولدوفا'),
(12979, 1297743872, 1297760255, 'DE', 'DEU', 'ألمانيا'),
(12980, 1297760256, 1297776639, 'LT', 'LTU', 'ليتوانيا'),
(12981, 1297776640, 1297793023, 'DE', 'DEU', 'ألمانيا'),
(12982, 1297793024, 1297809407, 'UA', 'UKR', 'أوكرانيا'),
(12983, 1297809408, 1297825791, 'PL', 'POL', 'بولندا'),
(12984, 1297825792, 1297842175, 'RU', 'RUS', 'الإتحاد الروسي'),
(12985, 1297842176, 1297858559, 'UA', 'UKR', 'أوكرانيا'),
(12986, 1297858560, 1297860607, 'RU', 'RUS', 'الإتحاد الروسي'),
(12987, 1297860608, 1297862655, 'PT', 'PRT', 'البورتوغال'),
(12988, 1297862656, 1297864703, 'FI', 'FIN', 'فنلندا'),
(12989, 1297864704, 1297866751, 'SE', 'SWE', 'السويد'),
(12990, 1297866752, 1297867583, 'RU', 'RUS', 'الإتحاد الروسي'),
(12991, 1297867584, 1297867647, 'SC', 'SYC', 'سيشيل'),
(12992, 1297867648, 1297867687, 'RU', 'RUS', 'الإتحاد الروسي'),
(12993, 1297867688, 1297867695, 'CY', 'CYP', 'قبرص'),
(12994, 1297867696, 1297867871, 'RU', 'RUS', 'الإتحاد الروسي'),
(12995, 1297867872, 1297867879, 'ES', 'ESP', 'إسبانيا'),
(12996, 1297867880, 1297868607, 'RU', 'RUS', 'الإتحاد الروسي'),
(12997, 1297868608, 1297868671, 'CY', 'CYP', 'قبرص'),
(12998, 1297868672, 1297868799, 'RU', 'RUS', 'الإتحاد الروسي'),
(12999, 1297868800, 1297870847, 'DE', 'DEU', 'ألمانيا'),
(13000, 1297870848, 1297872895, 'FR', 'FRA', 'فرنسا'),
(13001, 1297872896, 1297874943, 'GB', 'GBR', 'المملكة المتحدة'),
(13002, 1297874944, 1297875487, 'CY', 'CYP', 'قبرص'),
(13003, 1297875488, 1297875503, 'TR', 'TUR', 'تركيا'),
(13004, 1297875504, 1297875536, 'CY', 'CYP', 'قبرص'),
(13005, 1297875537, 1297875551, 'TR', 'TUR', 'تركيا'),
(13006, 1297875552, 1297879040, 'CY', 'CYP', 'قبرص'),
(13007, 1297879041, 1297883135, 'TR', 'TUR', 'تركيا'),
(13008, 1297883136, 1297891327, 'PL', 'POL', 'بولندا'),
(13009, 1297891328, 1297899519, 'GB', 'GBR', 'المملكة المتحدة'),
(13010, 1297899520, 1297910527, 'TR', 'TUR', 'تركيا'),
(13011, 1297910528, 1297910783, 'CZ', 'CZE', 'التشيك'),
(13012, 1297910784, 1297915903, 'TR', 'TUR', 'تركيا'),
(13013, 1297915904, 1297924095, 'BH', 'BHR', 'البحرين'),
(13014, 1297924096, 1297932287, 'CZ', 'CZE', 'التشيك'),
(13015, 1297932288, 1297940479, 'GE', 'GEO', 'جورجيا'),
(13016, 1297940480, 1297948671, 'LV', 'LVA', 'لاتفيا'),
(13017, 1297948672, 1297956863, 'UA', 'UKR', 'أوكرانيا'),
(13018, 1297956864, 1297965055, 'NL', 'NLD', 'هولندا'),
(13019, 1297965056, 1297973247, 'RU', 'RUS', 'الإتحاد الروسي'),
(13020, 1297973248, 1297981439, 'GB', 'GBR', 'المملكة المتحدة'),
(13021, 1297981440, 1297989631, 'RO', 'ROM', 'رومانيا'),
(13022, 1297989632, 1297993295, 'CZ', 'CZE', 'التشيك'),
(13023, 1297993296, 1297993311, 'SK', 'SVK', 'سلوفاكيا'),
(13024, 1297993312, 1297997823, 'CZ', 'CZE', 'التشيك'),
(13025, 1297997824, 1298006015, 'IT', 'ITA', 'إيطاليا'),
(13026, 1298006016, 1298014207, 'RU', 'RUS', 'الإتحاد الروسي'),
(13027, 1298014208, 1298014719, 'LB', 'LBN', 'لبنان'),
(13028, 1298014720, 1298014975, 'RU', 'RUS', 'الإتحاد الروسي'),
(13029, 1298014976, 1298015231, 'LT', 'LTU', 'ليتوانيا'),
(13030, 1298015232, 1298015487, 'RU', 'RUS', 'الإتحاد الروسي'),
(13031, 1298015488, 1298015743, 'LB', 'LBN', 'لبنان'),
(13032, 1298015744, 1298015999, 'IQ', 'IRQ', 'العراق'),
(13033, 1298016000, 1298016511, 'LB', 'LBN', 'لبنان'),
(13034, 1298016512, 1298017279, 'RU', 'RUS', 'الإتحاد الروسي'),
(13035, 1298017280, 1298018303, 'KG', 'KGZ', 'قيرغيزستان'),
(13036, 1298018304, 1298018559, 'TM', 'TKM', 'تركمينيستان'),
(13037, 1298018560, 1298019327, 'RU', 'RUS', 'الإتحاد الروسي'),
(13038, 1298019328, 1298019839, 'LT', 'LTU', 'ليتوانيا'),
(13039, 1298019840, 1298022399, 'RU', 'RUS', 'الإتحاد الروسي'),
(13040, 1298022400, 1298030591, 'IT', 'ITA', 'إيطاليا'),
(13041, 1298030592, 1298038783, 'RU', 'RUS', 'الإتحاد الروسي'),
(13042, 1298038784, 1298046975, 'SI', 'SVN', 'سلوفينيا'),
(13043, 1298046976, 1298063359, 'RU', 'RUS', 'الإتحاد الروسي'),
(13044, 1298063360, 1298065407, 'FR', 'FRA', 'فرنسا'),
(13045, 1298065408, 1298067455, 'NO', 'NOR', 'النرويج'),
(13046, 1298067456, 1298071551, 'NL', 'NLD', 'هولندا'),
(13047, 1298071552, 1298073599, 'TJ', 'TJK', 'طاجيكيستان'),
(13048, 1298073600, 1298075647, 'RU', 'RUS', 'الإتحاد الروسي'),
(13049, 1298075648, 1298076671, 'CY', 'CYP', 'قبرص'),
(13050, 1298076672, 1298077695, 'US', 'USA', 'الولايات المتحدة'),
(13051, 1298077696, 1298079743, 'DE', 'DEU', 'ألمانيا'),
(13052, 1298079744, 1298081791, 'GB', 'GBR', 'المملكة المتحدة'),
(13053, 1298081792, 1298083839, 'CZ', 'CZE', 'التشيك'),
(13054, 1298083840, 1298085887, 'PL', 'POL', 'بولندا'),
(13055, 1298085888, 1298087935, 'KG', 'KGZ', 'قيرغيزستان'),
(13056, 1298087936, 1298089983, 'FR', 'FRA', 'فرنسا'),
(13057, 1298089984, 1298092031, 'NO', 'NOR', 'النرويج'),
(13058, 1298092032, 1298094079, 'GB', 'GBR', 'المملكة المتحدة'),
(13059, 1298094080, 1298096127, 'RU', 'RUS', 'الإتحاد الروسي'),
(13060, 1298096128, 1298098175, 'NL', 'NLD', 'هولندا'),
(13061, 1298098176, 1298100223, 'SE', 'SWE', 'السويد'),
(13062, 1298100224, 1298102271, 'GB', 'GBR', 'المملكة المتحدة'),
(13063, 1298102272, 1298102687, 'CH', 'CHE', 'سويسرا'),
(13064, 1298102688, 1298102703, 'LV', 'LVA', 'لاتفيا'),
(13065, 1298102704, 1298104319, 'CH', 'CHE', 'سويسرا'),
(13066, 1298104320, 1298106367, 'RU', 'RUS', 'الإتحاد الروسي'),
(13067, 1298106368, 1298108415, 'IT', 'ITA', 'إيطاليا'),
(13068, 1298108416, 1298110463, 'FI', 'FIN', 'فنلندا'),
(13069, 1298110464, 1298112511, 'ES', 'ESP', 'إسبانيا'),
(13070, 1298112512, 1298114559, 'IE', 'IRL', 'إيرلندا'),
(13071, 1298114560, 1298116607, 'IT', 'ITA', 'إيطاليا'),
(13072, 1298116608, 1298118655, 'RU', 'RUS', 'الإتحاد الروسي'),
(13073, 1298118656, 1298120703, 'AM', 'ARM', 'أرمينيا'),
(13074, 1298120704, 1298122751, 'CZ', 'CZE', 'التشيك'),
(13075, 1298122752, 1298124799, 'RU', 'RUS', 'الإتحاد الروسي'),
(13076, 1298124800, 1298126847, 'IT', 'ITA', 'إيطاليا'),
(13077, 1298126848, 1298127615, 'SA', 'SAU', 'السعودية'),
(13078, 1298127616, 1298128127, 'IR', 'IRN', 'إيران'),
(13079, 1298128128, 1298128895, 'SA', 'SAU', 'السعودية'),
(13080, 1298128896, 1298130943, 'FR', 'FRA', 'فرنسا'),
(13081, 1298130944, 1298132991, 'BG', 'BGR', 'بلغاريا'),
(13082, 1298132992, 1298135039, 'FI', 'FIN', 'فنلندا'),
(13083, 1298135040, 1298137087, 'NL', 'NLD', 'هولندا'),
(13084, 1298137088, 1298661375, 'GB', 'GBR', 'المملكة المتحدة'),
(13085, 1298661376, 1298677759, 'FR', 'FRA', 'فرنسا'),
(13086, 1298677760, 1298694143, 'IR', 'IRN', 'إيران'),
(13087, 1298710528, 1298726911, 'CZ', 'CZE', 'التشيك'),
(13088, 1298726912, 1298743295, 'RS', 'SRB', 'صربيا'),
(13089, 1298743296, 1298759679, 'FI', 'FIN', 'فنلندا'),
(13090, 1298759680, 1298776063, 'RU', 'RUS', 'الإتحاد الروسي'),
(13091, 1298776064, 1298792447, 'SE', 'SWE', 'السويد'),
(13092, 1298792448, 1298825215, 'RU', 'RUS', 'الإتحاد الروسي'),
(13093, 1298825216, 1298841599, 'NO', 'NOR', 'النرويج'),
(13094, 1298841600, 1298857983, 'RU', 'RUS', 'الإتحاد الروسي'),
(13095, 1298857984, 1298874367, 'SE', 'SWE', 'السويد'),
(13096, 1298874368, 1298907135, 'GB', 'GBR', 'المملكة المتحدة'),
(13097, 1298907136, 1298923519, 'IE', 'IRL', 'إيرلندا'),
(13098, 1298923520, 1298939903, 'IT', 'ITA', 'إيطاليا'),
(13099, 1298939904, 1298956287, 'RU', 'RUS', 'الإتحاد الروسي'),
(13100, 1298956288, 1298972671, 'GB', 'GBR', 'المملكة المتحدة'),
(13101, 1298972672, 1298989055, 'RU', 'RUS', 'الإتحاد الروسي'),
(13102, 1298989056, 1299005439, 'UA', 'UKR', 'أوكرانيا'),
(13103, 1299005440, 1299005951, 'BE', 'BEL', 'بلجيكا'),
(13104, 1299005952, 1299008511, 'NL', 'NLD', 'هولندا'),
(13105, 1299008512, 1299009791, 'BE', 'BEL', 'بلجيكا'),
(13106, 1299009792, 1299010047, 'NL', 'NLD', 'هولندا'),
(13107, 1299010048, 1299010815, 'BE', 'BEL', 'بلجيكا'),
(13108, 1299010816, 1299011071, 'RU', 'RUS', 'الإتحاد الروسي'),
(13109, 1299011072, 1299011327, 'BE', 'BEL', 'بلجيكا'),
(13110, 1299011328, 1299011583, 'RU', 'RUS', 'الإتحاد الروسي'),
(13111, 1299011584, 1299011839, 'FR', 'FRA', 'فرنسا'),
(13112, 1299011840, 1299012095, 'DE', 'DEU', 'ألمانيا'),
(13113, 1299012096, 1299012607, 'BE', 'BEL', 'بلجيكا'),
(13114, 1299012608, 1299013119, 'GB', 'GBR', 'المملكة المتحدة'),
(13115, 1299013120, 1299013375, 'FR', 'FRA', 'فرنسا'),
(13116, 1299013376, 1299013631, 'DE', 'DEU', 'ألمانيا'),
(13117, 1299013632, 1299021823, 'BE', 'BEL', 'بلجيكا'),
(13118, 1299021824, 1299026111, 'CH', 'CHE', 'سويسرا'),
(13119, 1299026112, 1299026127, 'ES', 'ESP', 'إسبانيا'),
(13120, 1299026128, 1299031039, 'CH', 'CHE', 'سويسرا'),
(13121, 1299031040, 1299031167, 'US', 'USA', 'الولايات المتحدة'),
(13122, 1299031168, 1299031807, 'CH', 'CHE', 'سويسرا'),
(13123, 1299031808, 1299032063, 'US', 'USA', 'الولايات المتحدة'),
(13124, 1299032064, 1299032319, 'NL', 'NLD', 'هولندا'),
(13125, 1299032320, 1299038207, 'CH', 'CHE', 'سويسرا'),
(13126, 1299038208, 1299054591, 'FI', 'FIN', 'فنلندا'),
(13127, 1299054592, 1299070975, 'SE', 'SWE', 'السويد'),
(13128, 1299070976, 1299075071, 'SA', 'SAU', 'السعودية'),
(13129, 1299075072, 1299087359, 'LB', 'LBN', 'لبنان'),
(13130, 1299087360, 1299103743, 'HU', 'HUN', 'هنغاريا'),
(13131, 1299103744, 1299120127, 'NO', 'NOR', 'النرويج'),
(13132, 1299120128, 1299136511, 'SI', 'SVN', 'سلوفينيا'),
(13133, 1299136512, 1299169279, 'HU', 'HUN', 'هنغاريا'),
(13134, 1299169280, 1299174399, 'FR', 'FRA', 'فرنسا'),
(13135, 1299174400, 1299176959, 'GB', 'GBR', 'المملكة المتحدة'),
(13136, 1299176960, 1299177471, 'FR', 'FRA', 'فرنسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(13137, 1299177472, 1299180031, 'DE', 'DEU', 'ألمانيا'),
(13138, 1299180032, 1299185663, 'FR', 'FRA', 'فرنسا'),
(13139, 1299185664, 1299447807, 'PL', 'POL', 'بولندا'),
(13140, 1299447808, 1299709951, 'AT', 'AUT', 'النمسا'),
(13141, 1299709952, 1299972095, 'UA', 'UKR', 'أوكرانيا'),
(13142, 1299972096, 1300234239, 'IL', 'ISR', 'إسرائيل'),
(13143, 1302331392, 1303379967, 'NL', 'NLD', 'هولندا'),
(13144, 1303379968, 1304428543, 'DE', 'DEU', 'ألمانيا'),
(13145, 1304428544, 1305477119, 'FR', 'FRA', 'فرنسا'),
(13146, 1305477120, 1305739263, 'ES', 'ESP', 'إسبانيا'),
(13147, 1305739264, 1306001407, 'DK', 'DNK', 'الدنيمارك'),
(13148, 1306001408, 1306132479, 'RU', 'RUS', 'الإتحاد الروسي'),
(13149, 1306132480, 1306263551, 'SE', 'SWE', 'السويد'),
(13150, 1306271744, 1306279935, 'RU', 'RUS', 'الإتحاد الروسي'),
(13151, 1306279936, 1306286079, 'IT', 'ITA', 'إيطاليا'),
(13152, 1306286080, 1306288127, 'CH', 'CHE', 'سويسرا'),
(13153, 1306288128, 1306296319, 'AT', 'AUT', 'النمسا'),
(13154, 1306296320, 1306311143, 'RU', 'RUS', 'الإتحاد الروسي'),
(13155, 1306311144, 1306311151, 'CH', 'CHE', 'سويسرا'),
(13156, 1306311152, 1306312703, 'RU', 'RUS', 'الإتحاد الروسي'),
(13157, 1306312704, 1306320895, 'UZ', 'UZB', 'أوزباكستان'),
(13158, 1306320896, 1306329087, 'DE', 'DEU', 'ألمانيا'),
(13159, 1306329088, 1306337279, 'BA', 'BIH', 'البوسنه والهرسك'),
(13160, 1306337280, 1306345471, 'HU', 'HUN', 'هنغاريا'),
(13161, 1306345472, 1306353663, 'LT', 'LTU', 'ليتوانيا'),
(13162, 1306353664, 1306361855, 'SA', 'SAU', 'السعودية'),
(13163, 1306361856, 1306370047, 'RU', 'RUS', 'الإتحاد الروسي'),
(13164, 1306370048, 1306378239, 'GB', 'GBR', 'المملكة المتحدة'),
(13165, 1306378240, 1306386431, 'RU', 'RUS', 'الإتحاد الروسي'),
(13166, 1306386432, 1306394623, 'DK', 'DNK', 'الدنيمارك'),
(13167, 1306394624, 1306402815, 'ME', 'MNE', 'الجبل الأسود'),
(13168, 1306402816, 1306411007, 'RU', 'RUS', 'الإتحاد الروسي'),
(13169, 1306411008, 1306413199, 'NL', 'NLD', 'هولندا'),
(13170, 1306413200, 1306413215, 'BE', 'BEL', 'بلجيكا'),
(13171, 1306413216, 1306419199, 'NL', 'NLD', 'هولندا'),
(13172, 1306419200, 1306427391, 'RU', 'RUS', 'الإتحاد الروسي'),
(13173, 1306427392, 1306435583, 'UA', 'UKR', 'أوكرانيا'),
(13174, 1306435584, 1306451967, 'NO', 'NOR', 'النرويج'),
(13175, 1306451968, 1306460159, 'PL', 'POL', 'بولندا'),
(13176, 1306460160, 1306468351, 'IT', 'ITA', 'إيطاليا'),
(13177, 1306468352, 1306476543, 'FI', 'FIN', 'فنلندا'),
(13178, 1306476544, 1306492927, 'RU', 'RUS', 'الإتحاد الروسي'),
(13179, 1306492928, 1306501119, 'TR', 'TUR', 'تركيا'),
(13180, 1306501120, 1306509311, 'NO', 'NOR', 'النرويج'),
(13181, 1306509312, 1306525695, 'PL', 'POL', 'بولندا'),
(13182, 1306525696, 1307049983, 'ES', 'ESP', 'إسبانيا'),
(13183, 1307049984, 1307066367, 'RU', 'RUS', 'الإتحاد الروسي'),
(13184, 1307069696, 1307069823, 'DE', 'DEU', 'ألمانيا'),
(13185, 1307069856, 1307069887, 'DE', 'DEU', 'ألمانيا'),
(13186, 1307074560, 1307082751, 'SA', 'SAU', 'السعودية'),
(13187, 1307082752, 1307090943, 'RU', 'RUS', 'الإتحاد الروسي'),
(13188, 1307090944, 1307099135, 'GB', 'GBR', 'المملكة المتحدة'),
(13189, 1307099136, 1307107327, 'RO', 'ROM', 'رومانيا'),
(13190, 1307107328, 1307115519, 'DE', 'DEU', 'ألمانيا'),
(13191, 1307115520, 1307123711, 'RU', 'RUS', 'الإتحاد الروسي'),
(13192, 1307123712, 1307131903, 'NL', 'NLD', 'هولندا'),
(13193, 1307131904, 1307140095, 'EE', 'EST', 'إستونيا'),
(13194, 1307140096, 1307148287, 'FR', 'FRA', 'فرنسا'),
(13195, 1307148288, 1307156479, 'GB', 'GBR', 'المملكة المتحدة'),
(13196, 1307156480, 1307172863, 'RU', 'RUS', 'الإتحاد الروسي'),
(13197, 1307172864, 1307181055, 'DK', 'DNK', 'الدنيمارك'),
(13198, 1307181056, 1307189247, 'RU', 'RUS', 'الإتحاد الروسي'),
(13199, 1307189248, 1307197439, 'DE', 'DEU', 'ألمانيا'),
(13200, 1307197440, 1307205631, 'HU', 'HUN', 'هنغاريا'),
(13201, 1307205632, 1307213823, 'FI', 'FIN', 'فنلندا'),
(13202, 1307213824, 1307222015, 'SI', 'SVN', 'سلوفينيا'),
(13203, 1307222016, 1307230207, 'DK', 'DNK', 'الدنيمارك'),
(13204, 1307230208, 1307238399, 'RU', 'RUS', 'الإتحاد الروسي'),
(13205, 1307238400, 1307246591, 'SK', 'SVK', 'سلوفاكيا'),
(13206, 1307246592, 1307254783, 'KG', 'KGZ', 'قيرغيزستان'),
(13207, 1307254784, 1307255551, 'NL', 'NLD', 'هولندا'),
(13208, 1307255552, 1307255807, 'GR', 'GRC', 'اليونان'),
(13209, 1307255808, 1307262975, 'NL', 'NLD', 'هولندا'),
(13210, 1307262976, 1307271167, 'AT', 'AUT', 'النمسا'),
(13211, 1307271168, 1307279359, 'MD', 'MDA', 'مولدوفا'),
(13212, 1307279360, 1307287551, 'LB', 'LBN', 'لبنان'),
(13213, 1307287552, 1307295743, 'DE', 'DEU', 'ألمانيا'),
(13214, 1307295744, 1307303935, 'RU', 'RUS', 'الإتحاد الروسي'),
(13215, 1307303936, 1307312127, 'SE', 'SWE', 'السويد'),
(13216, 1307312128, 1307320319, 'PL', 'POL', 'بولندا'),
(13217, 1307320320, 1307336703, 'RU', 'RUS', 'الإتحاد الروسي'),
(13218, 1307336704, 1307344895, 'DE', 'DEU', 'ألمانيا'),
(13219, 1307344896, 1307353087, 'RU', 'RUS', 'الإتحاد الروسي'),
(13220, 1307353088, 1307361279, 'BG', 'BGR', 'بلغاريا'),
(13221, 1307361280, 1307369471, 'CZ', 'CZE', 'التشيك'),
(13222, 1307369472, 1307377663, 'RU', 'RUS', 'الإتحاد الروسي'),
(13223, 1307377664, 1307385855, 'PL', 'POL', 'بولندا'),
(13224, 1307385856, 1307394047, 'AT', 'AUT', 'النمسا'),
(13225, 1307394048, 1307402239, 'IR', 'IRN', 'إيران'),
(13226, 1307402240, 1307410431, 'HR', 'HRV', 'كرواتيا'),
(13227, 1307410432, 1307418623, 'CZ', 'CZE', 'التشيك'),
(13228, 1307418624, 1307426815, 'IR', 'IRN', 'إيران'),
(13229, 1307426816, 1307435007, 'CH', 'CHE', 'سويسرا'),
(13230, 1307435008, 1307443199, 'DE', 'DEU', 'ألمانيا'),
(13231, 1307443200, 1307451391, 'IT', 'ITA', 'إيطاليا'),
(13232, 1307451392, 1307459583, 'SE', 'SWE', 'السويد'),
(13233, 1307459584, 1307484159, 'RU', 'RUS', 'الإتحاد الروسي'),
(13234, 1307484160, 1307488767, 'GB', 'GBR', 'المملكة المتحدة'),
(13235, 1307488768, 1307489023, 'IE', 'IRL', 'إيرلندا'),
(13236, 1307489024, 1307491327, 'GB', 'GBR', 'المملكة المتحدة'),
(13237, 1307491328, 1307491839, 'IE', 'IRL', 'إيرلندا'),
(13238, 1307491840, 1307492351, 'GB', 'GBR', 'المملكة المتحدة'),
(13239, 1307492352, 1307500543, 'BA', 'BIH', 'البوسنه والهرسك'),
(13240, 1307500544, 1307508735, 'RU', 'RUS', 'الإتحاد الروسي'),
(13241, 1307508736, 1307516927, 'BA', 'BIH', 'البوسنه والهرسك'),
(13242, 1307516928, 1307525119, 'CH', 'CHE', 'سويسرا'),
(13243, 1307525120, 1307533311, 'BA', 'BIH', 'البوسنه والهرسك'),
(13244, 1307533312, 1307541503, 'GB', 'GBR', 'المملكة المتحدة'),
(13245, 1307541504, 1307549695, 'IT', 'ITA', 'إيطاليا'),
(13246, 1307549696, 1307557887, 'UA', 'UKR', 'أوكرانيا'),
(13247, 1307557888, 1307574271, 'RU', 'RUS', 'الإتحاد الروسي'),
(13248, 1307574272, 1307578367, 'GB', 'GBR', 'المملكة المتحدة'),
(13249, 1307578368, 1307582463, 'FI', 'FIN', 'فنلندا'),
(13250, 1307582464, 1307586559, 'KZ', 'KAZ', 'كازاخستان'),
(13251, 1307586560, 1307590655, 'GB', 'GBR', 'المملكة المتحدة'),
(13252, 1307590656, 1307594751, 'SE', 'SWE', 'السويد'),
(13253, 1307594752, 1307598847, 'SA', 'SAU', 'السعودية'),
(13254, 1307598848, 1307602943, 'CZ', 'CZE', 'التشيك'),
(13255, 1307602944, 1307607039, 'ES', 'ESP', 'إسبانيا'),
(13256, 1307607040, 1307611135, 'SA', 'SAU', 'السعودية'),
(13257, 1307611136, 1307619327, 'RU', 'RUS', 'الإتحاد الروسي'),
(13258, 1307619328, 1307623423, 'CZ', 'CZE', 'التشيك'),
(13259, 1307623424, 1307627519, 'FR', 'FRA', 'فرنسا'),
(13260, 1307627520, 1307631615, 'SE', 'SWE', 'السويد'),
(13261, 1307631616, 1307635711, 'IT', 'ITA', 'إيطاليا'),
(13262, 1307635712, 1307636991, 'EE', 'EST', 'إستونيا'),
(13263, 1307636992, 1307637031, 'LV', 'LVA', 'لاتفيا'),
(13264, 1307637032, 1307638015, 'EE', 'EST', 'إستونيا'),
(13265, 1307638016, 1307638095, 'LT', 'LTU', 'ليتوانيا'),
(13266, 1307638096, 1307638375, 'EE', 'EST', 'إستونيا'),
(13267, 1307638376, 1307638383, 'LT', 'LTU', 'ليتوانيا'),
(13268, 1307638384, 1307638447, 'EE', 'EST', 'إستونيا'),
(13269, 1307638448, 1307638463, 'LT', 'LTU', 'ليتوانيا'),
(13270, 1307638464, 1307638575, 'EE', 'EST', 'إستونيا'),
(13271, 1307638576, 1307638607, 'LT', 'LTU', 'ليتوانيا'),
(13272, 1307638608, 1307638783, 'EE', 'EST', 'إستونيا'),
(13273, 1307638784, 1307639295, 'LT', 'LTU', 'ليتوانيا'),
(13274, 1307639296, 1307639495, 'EE', 'EST', 'إستونيا'),
(13275, 1307639496, 1307639503, 'LT', 'LTU', 'ليتوانيا'),
(13276, 1307639504, 1307639807, 'EE', 'EST', 'إستونيا'),
(13277, 1307639808, 1307643903, 'IT', 'ITA', 'إيطاليا'),
(13278, 1307643904, 1307652095, 'RU', 'RUS', 'الإتحاد الروسي'),
(13279, 1307652096, 1307656191, 'ES', 'ESP', 'إسبانيا'),
(13280, 1307656192, 1307660287, 'JO', 'JOR', 'الأردن'),
(13281, 1307660288, 1307662335, 'BE', 'BEL', 'بلجيكا'),
(13282, 1307662336, 1307662351, 'NL', 'NLD', 'هولندا'),
(13283, 1307662352, 1307662359, 'GB', 'GBR', 'المملكة المتحدة'),
(13284, 1307662360, 1307662367, 'FR', 'FRA', 'فرنسا'),
(13285, 1307662368, 1307664383, 'BE', 'BEL', 'بلجيكا'),
(13286, 1307664384, 1307668479, 'NO', 'NOR', 'النرويج'),
(13287, 1307668480, 1307672575, 'ES', 'ESP', 'إسبانيا'),
(13288, 1307672576, 1307674623, 'SE', 'SWE', 'السويد'),
(13289, 1307674624, 1307676671, 'DK', 'DNK', 'الدنيمارك'),
(13290, 1307676672, 1307680767, 'RU', 'RUS', 'الإتحاد الروسي'),
(13291, 1307680768, 1307684863, 'LV', 'LVA', 'لاتفيا'),
(13292, 1307684864, 1307688959, 'GB', 'GBR', 'المملكة المتحدة'),
(13293, 1307688960, 1307693055, 'LT', 'LTU', 'ليتوانيا'),
(13294, 1307693056, 1307697151, 'IT', 'ITA', 'إيطاليا'),
(13295, 1307697152, 1307701247, 'NL', 'NLD', 'هولندا'),
(13296, 1307701248, 1307709439, 'RU', 'RUS', 'الإتحاد الروسي'),
(13297, 1307709440, 1307713535, 'AL', 'ALB', 'ألبانيا'),
(13298, 1307713536, 1307717631, 'IT', 'ITA', 'إيطاليا'),
(13299, 1307717632, 1307721727, 'DK', 'DNK', 'الدنيمارك'),
(13300, 1307721728, 1307725823, 'AT', 'AUT', 'النمسا'),
(13301, 1307725824, 1307729919, 'CZ', 'CZE', 'التشيك'),
(13302, 1307729920, 1307734015, 'RU', 'RUS', 'الإتحاد الروسي'),
(13303, 1307734016, 1307738111, 'NL', 'NLD', 'هولندا'),
(13304, 1307738112, 1307742207, 'IT', 'ITA', 'إيطاليا'),
(13305, 1307742208, 1307746303, 'HU', 'HUN', 'هنغاريا'),
(13306, 1307746304, 1307750399, 'UA', 'UKR', 'أوكرانيا'),
(13307, 1307750400, 1307754495, 'IT', 'ITA', 'إيطاليا'),
(13308, 1307754496, 1307755519, 'US', 'USA', 'الولايات المتحدة'),
(13309, 1307755520, 1307756031, 'GB', 'GBR', 'المملكة المتحدة'),
(13310, 1307756032, 1307756287, 'US', 'USA', 'الولايات المتحدة'),
(13311, 1307756288, 1307756431, 'GB', 'GBR', 'المملكة المتحدة'),
(13312, 1307756432, 1307756447, 'FR', 'FRA', 'فرنسا'),
(13313, 1307756448, 1307756543, 'GB', 'GBR', 'المملكة المتحدة'),
(13314, 1307756544, 1307756847, 'FR', 'FRA', 'فرنسا'),
(13315, 1307756848, 1307756863, 'US', 'USA', 'الولايات المتحدة'),
(13316, 1307756864, 1307757567, 'FR', 'FRA', 'فرنسا'),
(13317, 1307757568, 1307758591, 'GB', 'GBR', 'المملكة المتحدة'),
(13318, 1307758592, 1307762687, 'SM', 'SMR', 'سان مارينو'),
(13319, 1307762688, 1307766783, 'PL', 'POL', 'بولندا'),
(13320, 1307766784, 1307770879, 'GB', 'GBR', 'المملكة المتحدة'),
(13321, 1307770880, 1307774975, 'RU', 'RUS', 'الإتحاد الروسي'),
(13322, 1307774976, 1307777023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(13323, 1307777024, 1307778047, 'RS', 'SRB', 'صربيا'),
(13324, 1307778048, 1307779071, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(13325, 1307779072, 1307787263, 'DK', 'DNK', 'الدنيمارك'),
(13326, 1307787264, 1307791359, 'MT', 'MLT', 'مالطا'),
(13327, 1307791360, 1307795455, 'KZ', 'KAZ', 'كازاخستان'),
(13328, 1307795456, 1307803647, 'RU', 'RUS', 'الإتحاد الروسي'),
(13329, 1307803648, 1307807743, 'DK', 'DNK', 'الدنيمارك'),
(13330, 1307807744, 1307811839, 'SE', 'SWE', 'السويد'),
(13331, 1307811840, 1307815935, 'NL', 'NLD', 'هولندا'),
(13332, 1307815936, 1307819791, 'BE', 'BEL', 'بلجيكا'),
(13333, 1307820032, 1307824127, 'ES', 'ESP', 'إسبانيا'),
(13334, 1307824128, 1307828223, 'HU', 'HUN', 'هنغاريا'),
(13335, 1307828224, 1307832319, 'NL', 'NLD', 'هولندا'),
(13336, 1307832320, 1307836415, 'RU', 'RUS', 'الإتحاد الروسي'),
(13337, 1307836416, 1307840511, 'SE', 'SWE', 'السويد'),
(13338, 1307840512, 1307844607, 'RU', 'RUS', 'الإتحاد الروسي'),
(13339, 1307844608, 1307848703, 'UA', 'UKR', 'أوكرانيا'),
(13340, 1307848704, 1307852799, 'CH', 'CHE', 'سويسرا'),
(13341, 1307852800, 1307856895, 'RU', 'RUS', 'الإتحاد الروسي'),
(13342, 1307856896, 1307860991, 'IT', 'ITA', 'إيطاليا'),
(13343, 1307860992, 1307861119, 'DE', 'DEU', 'ألمانيا'),
(13344, 1307861120, 1307861123, 'LU', 'LUX', 'لوكسيمبورغ'),
(13345, 1307861124, 1307861151, 'DE', 'DEU', 'ألمانيا'),
(13346, 1307861152, 1307861155, 'LU', 'LUX', 'لوكسيمبورغ'),
(13347, 1307861156, 1307861919, 'DE', 'DEU', 'ألمانيا'),
(13348, 1307861920, 1307861935, 'LU', 'LUX', 'لوكسيمبورغ'),
(13349, 1307861936, 1307864127, 'DE', 'DEU', 'ألمانيا'),
(13350, 1307864128, 1307864135, 'LU', 'LUX', 'لوكسيمبورغ'),
(13351, 1307864136, 1307864467, 'DE', 'DEU', 'ألمانيا'),
(13352, 1307864468, 1307864471, 'LU', 'LUX', 'لوكسيمبورغ'),
(13353, 1307864472, 1307864479, 'DE', 'DEU', 'ألمانيا'),
(13354, 1307864480, 1307864495, 'LU', 'LUX', 'لوكسيمبورغ'),
(13355, 1307864496, 1307865087, 'DE', 'DEU', 'ألمانيا'),
(13356, 1307865088, 1307869183, 'AZ', 'AZE', 'أذربيجان'),
(13357, 1307869184, 1307873279, 'GB', 'GBR', 'المملكة المتحدة'),
(13358, 1307873280, 1307877375, 'TJ', 'TJK', 'طاجيكيستان'),
(13359, 1307877376, 1307881471, 'RU', 'RUS', 'الإتحاد الروسي'),
(13360, 1307881472, 1307885567, 'IT', 'ITA', 'إيطاليا'),
(13361, 1307885568, 1307886975, 'DK', 'DNK', 'الدنيمارك'),
(13362, 1307886976, 1307887103, 'SE', 'SWE', 'السويد'),
(13363, 1307887104, 1307889663, 'DK', 'DNK', 'الدنيمارك'),
(13364, 1307889664, 1307893759, 'RU', 'RUS', 'الإتحاد الروسي'),
(13365, 1307893760, 1307897855, 'SE', 'SWE', 'السويد'),
(13366, 1307897856, 1307901951, 'AT', 'AUT', 'النمسا'),
(13367, 1307901952, 1307906047, 'JO', 'JOR', 'الأردن'),
(13368, 1307906048, 1307906599, 'CH', 'CHE', 'سويسرا'),
(13369, 1307906600, 1307906607, 'DK', 'DNK', 'الدنيمارك'),
(13370, 1307906608, 1307906943, 'CH', 'CHE', 'سويسرا'),
(13371, 1307906944, 1307907071, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(13372, 1307907072, 1307907199, 'CH', 'CHE', 'سويسرا'),
(13373, 1307907200, 1307907327, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(13374, 1307907328, 1307910143, 'CH', 'CHE', 'سويسرا'),
(13375, 1307910144, 1307914239, 'DE', 'DEU', 'ألمانيا'),
(13376, 1307914240, 1307918335, 'NL', 'NLD', 'هولندا'),
(13377, 1307918336, 1307919439, 'GB', 'GBR', 'المملكة المتحدة'),
(13378, 1307919440, 1307919447, 'ES', 'ESP', 'إسبانيا'),
(13379, 1307919448, 1307919503, 'GB', 'GBR', 'المملكة المتحدة'),
(13380, 1307919504, 1307919511, 'ES', 'ESP', 'إسبانيا'),
(13381, 1307919512, 1307919699, 'GB', 'GBR', 'المملكة المتحدة'),
(13382, 1307919700, 1307919703, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(13383, 1307919704, 1307920575, 'GB', 'GBR', 'المملكة المتحدة'),
(13384, 1307920576, 1307920583, 'AU', 'AUS', 'أستراليا'),
(13385, 1307920584, 1307921471, 'GB', 'GBR', 'المملكة المتحدة'),
(13386, 1307921472, 1307921535, 'ES', 'ESP', 'إسبانيا'),
(13387, 1307921536, 1307922431, 'GB', 'GBR', 'المملكة المتحدة'),
(13388, 1307922432, 1307926527, 'NL', 'NLD', 'هولندا'),
(13389, 1307926528, 1307930623, 'KZ', 'KAZ', 'كازاخستان'),
(13390, 1307930624, 1307934719, 'RU', 'RUS', 'الإتحاد الروسي'),
(13391, 1307934720, 1307938815, 'FR', 'FRA', 'فرنسا'),
(13392, 1307938816, 1307942911, 'TR', 'TUR', 'تركيا'),
(13393, 1307942912, 1307947007, 'RU', 'RUS', 'الإتحاد الروسي'),
(13394, 1307947008, 1307951103, 'CH', 'CHE', 'سويسرا'),
(13395, 1307951104, 1307959295, 'RU', 'RUS', 'الإتحاد الروسي'),
(13396, 1307959296, 1307963391, 'IR', 'IRN', 'إيران'),
(13397, 1307963392, 1307967487, 'PL', 'POL', 'بولندا'),
(13398, 1307967488, 1307971583, 'IT', 'ITA', 'إيطاليا'),
(13399, 1307971584, 1307980799, 'GB', 'GBR', 'المملكة المتحدة'),
(13400, 1307980800, 1307981823, 'ZW', 'ZWE', 'زمبابواي'),
(13401, 1307981824, 1307982847, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(13402, 1307982848, 1307983871, 'GB', 'GBR', 'المملكة المتحدة'),
(13403, 1307983872, 1307987967, 'LB', 'LBN', 'لبنان'),
(13404, 1307987968, 1307992063, 'FR', 'FRA', 'فرنسا'),
(13405, 1307992064, 1307996159, 'RU', 'RUS', 'الإتحاد الروسي'),
(13406, 1307996160, 1308000255, 'DE', 'DEU', 'ألمانيا'),
(13407, 1308000256, 1308004351, 'CH', 'CHE', 'سويسرا'),
(13408, 1308004352, 1308008447, 'RU', 'RUS', 'الإتحاد الروسي'),
(13409, 1308008448, 1308012543, 'GB', 'GBR', 'المملكة المتحدة'),
(13410, 1308012544, 1308016639, 'ES', 'ESP', 'إسبانيا'),
(13411, 1308016640, 1308020735, 'FI', 'FIN', 'فنلندا'),
(13412, 1308020736, 1308024831, 'BG', 'BGR', 'بلغاريا'),
(13413, 1308024832, 1308033023, 'RU', 'RUS', 'الإتحاد الروسي'),
(13414, 1308033024, 1308033279, 'NL', 'NLD', 'هولندا'),
(13415, 1308033280, 1308033535, 'FR', 'FRA', 'فرنسا'),
(13416, 1308033536, 1308033791, 'DE', 'DEU', 'ألمانيا'),
(13417, 1308033792, 1308034047, 'IT', 'ITA', 'إيطاليا'),
(13418, 1308034048, 1308034559, 'DE', 'DEU', 'ألمانيا'),
(13419, 1308034560, 1308034815, 'CZ', 'CZE', 'التشيك'),
(13420, 1308034816, 1308035327, 'DE', 'DEU', 'ألمانيا'),
(13421, 1308035328, 1308035583, 'GB', 'GBR', 'المملكة المتحدة'),
(13422, 1308035584, 1308035839, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13423, 1308035840, 1308036095, 'GB', 'GBR', 'المملكة المتحدة'),
(13424, 1308036096, 1308037119, 'DE', 'DEU', 'ألمانيا'),
(13425, 1308037120, 1308041215, 'UA', 'UKR', 'أوكرانيا'),
(13426, 1308041216, 1308049407, 'RU', 'RUS', 'الإتحاد الروسي'),
(13427, 1308049408, 1308053503, 'DK', 'DNK', 'الدنيمارك'),
(13428, 1308053504, 1308057599, 'RU', 'RUS', 'الإتحاد الروسي'),
(13429, 1308057600, 1308061695, 'GR', 'GRC', 'اليونان'),
(13430, 1308061696, 1308069887, 'RU', 'RUS', 'الإتحاد الروسي'),
(13431, 1308069888, 1308073983, 'NO', 'NOR', 'النرويج'),
(13432, 1308073984, 1308078079, 'RU', 'RUS', 'الإتحاد الروسي'),
(13433, 1308078080, 1308078263, 'NL', 'NLD', 'هولندا'),
(13434, 1308078264, 1308078267, 'SE', 'SWE', 'السويد'),
(13435, 1308078268, 1308078879, 'NL', 'NLD', 'هولندا'),
(13436, 1308078880, 1308078911, 'FR', 'FRA', 'فرنسا'),
(13437, 1308078912, 1308080127, 'NL', 'NLD', 'هولندا'),
(13438, 1308080128, 1308082175, 'RU', 'RUS', 'الإتحاد الروسي'),
(13439, 1308082176, 1308084223, 'GB', 'GBR', 'المملكة المتحدة'),
(13440, 1308084224, 1308086271, 'RS', 'SRB', 'صربيا'),
(13441, 1308086272, 1308088319, 'RU', 'RUS', 'الإتحاد الروسي'),
(13442, 1308088320, 1308090367, 'UA', 'UKR', 'أوكرانيا'),
(13443, 1308090368, 1308092415, 'SK', 'SVK', 'سلوفاكيا'),
(13444, 1308092416, 1308094463, 'RU', 'RUS', 'الإتحاد الروسي'),
(13445, 1308094464, 1308096511, 'KW', 'KWT', 'الكويت'),
(13446, 1308096512, 1308098559, 'RS', 'SRB', 'صربيا'),
(13447, 1308098560, 1308360703, 'NL', 'NLD', 'هولندا'),
(13448, 1308360704, 1308622847, 'PL', 'POL', 'بولندا'),
(13449, 1308622848, 1308884991, 'HR', 'HRV', 'كرواتيا'),
(13450, 1308884992, 1309147135, 'IT', 'ITA', 'إيطاليا'),
(13451, 1309147136, 1309409279, 'PL', 'POL', 'بولندا'),
(13452, 1309409280, 1309671423, 'IT', 'ITA', 'إيطاليا'),
(13453, 1309671424, 1309933567, 'IE', 'IRL', 'إيرلندا'),
(13454, 1309933568, 1310195711, 'BE', 'BEL', 'بلجيكا'),
(13455, 1310195712, 1310197759, 'RU', 'RUS', 'الإتحاد الروسي'),
(13456, 1310197760, 1310199807, 'CZ', 'CZE', 'التشيك'),
(13457, 1310199808, 1310201855, 'IE', 'IRL', 'إيرلندا'),
(13458, 1310201856, 1310203903, 'RU', 'RUS', 'الإتحاد الروسي'),
(13459, 1310203904, 1310204159, 'BE', 'BEL', 'بلجيكا'),
(13460, 1310204160, 1310204191, 'FR', 'FRA', 'فرنسا'),
(13461, 1310204192, 1310204255, 'BE', 'BEL', 'بلجيكا'),
(13462, 1310204256, 1310204271, 'FR', 'FRA', 'فرنسا'),
(13463, 1310204272, 1310204695, 'BE', 'BEL', 'بلجيكا'),
(13464, 1310204696, 1310204707, 'FR', 'FRA', 'فرنسا'),
(13465, 1310204708, 1310205951, 'BE', 'BEL', 'بلجيكا'),
(13466, 1310205952, 1310207999, 'RU', 'RUS', 'الإتحاد الروسي'),
(13467, 1310208000, 1310210047, 'MD', 'MDA', 'مولدوفا'),
(13468, 1310210048, 1310212095, 'RU', 'RUS', 'الإتحاد الروسي'),
(13469, 1310212096, 1310214143, 'HU', 'HUN', 'هنغاريا'),
(13470, 1310214144, 1310216191, 'UA', 'UKR', 'أوكرانيا'),
(13471, 1310216192, 1310218239, 'IT', 'ITA', 'إيطاليا'),
(13472, 1310218240, 1310220287, 'NO', 'NOR', 'النرويج'),
(13473, 1310220288, 1310222335, 'NL', 'NLD', 'هولندا'),
(13474, 1310222336, 1310224383, 'RS', 'SRB', 'صربيا'),
(13475, 1310224384, 1310226431, 'GB', 'GBR', 'المملكة المتحدة'),
(13476, 1310226432, 1310228479, 'BE', 'BEL', 'بلجيكا'),
(13477, 1310228480, 1310230527, 'FR', 'FRA', 'فرنسا'),
(13478, 1310230528, 1310232575, 'ES', 'ESP', 'إسبانيا'),
(13479, 1310232576, 1310234623, 'NO', 'NOR', 'النرويج'),
(13480, 1310234624, 1310236671, 'RU', 'RUS', 'الإتحاد الروسي'),
(13481, 1310236672, 1310238719, 'PL', 'POL', 'بولندا'),
(13482, 1310238720, 1310240767, 'BE', 'BEL', 'بلجيكا'),
(13483, 1310240768, 1310242815, 'RU', 'RUS', 'الإتحاد الروسي'),
(13484, 1310242816, 1310244863, 'HU', 'HUN', 'هنغاريا'),
(13485, 1310244864, 1310246911, 'EE', 'EST', 'إستونيا'),
(13486, 1310246912, 1310246927, 'FR', 'FRA', 'فرنسا'),
(13487, 1310246928, 1310246943, 'ES', 'ESP', 'إسبانيا'),
(13488, 1310246944, 1310246959, 'IT', 'ITA', 'إيطاليا'),
(13489, 1310246960, 1310246975, 'AT', 'AUT', 'النمسا'),
(13490, 1310246976, 1310246991, 'PT', 'PRT', 'البورتوغال'),
(13491, 1310246992, 1310247007, 'NL', 'NLD', 'هولندا'),
(13492, 1310247008, 1310247023, 'GB', 'GBR', 'المملكة المتحدة'),
(13493, 1310247024, 1310247039, 'GR', 'GRC', 'اليونان'),
(13494, 1310247040, 1310247055, 'CL', 'CHL', 'تشيلي'),
(13495, 1310247056, 1310247071, 'BE', 'BEL', 'بلجيكا'),
(13496, 1310247072, 1310247087, 'MX', 'MEX', 'المكسيك'),
(13497, 1310247088, 1310247103, 'AR', 'ARG', 'الأرجنتين'),
(13498, 1310247104, 1310247119, 'PL', 'POL', 'بولندا'),
(13499, 1310247120, 1310247135, 'IE', 'IRL', 'إيرلندا'),
(13500, 1310247136, 1310247151, 'CH', 'CHE', 'سويسرا'),
(13501, 1310247152, 1310247167, 'RU', 'RUS', 'الإتحاد الروسي'),
(13502, 1310247168, 1310247183, 'BE', 'BEL', 'بلجيكا'),
(13503, 1310247184, 1310247199, 'BR', 'BRA', 'البرازيل'),
(13504, 1310247200, 1310247215, 'CZ', 'CZE', 'التشيك'),
(13505, 1310247216, 1310247231, 'HK', 'HKG', 'هونغ كونغ'),
(13506, 1310247232, 1310247247, 'LU', 'LUX', 'لوكسيمبورغ'),
(13507, 1310247248, 1310247263, 'CN', 'CHN', 'الصين'),
(13508, 1310247264, 1310247279, 'PH', 'PHL', 'الفلبين'),
(13509, 1310247280, 1310247295, 'CH', 'CHE', 'سويسرا'),
(13510, 1310247296, 1310247311, 'JP', 'JPN', 'اليابان'),
(13511, 1310247312, 1310247327, 'PE', 'PER', 'بيرو'),
(13512, 1310247328, 1310247343, 'DE', 'DEU', 'ألمانيا'),
(13513, 1310247344, 1310247359, 'CA', 'CAN', 'كندا'),
(13514, 1310247360, 1310247375, 'CR', 'CRI', 'كوستا ريكا'),
(13515, 1310247376, 1310247391, 'IN', 'IND', 'الهند'),
(13516, 1310247392, 1310247407, 'US', 'USA', 'الولايات المتحدة'),
(13517, 1310247408, 1310247423, 'CA', 'CAN', 'كندا'),
(13518, 1310247424, 1310247431, 'BE', 'BEL', 'بلجيكا'),
(13519, 1310247432, 1310247439, 'BR', 'BRA', 'البرازيل'),
(13520, 1310247440, 1310247447, 'CZ', 'CZE', 'التشيك'),
(13521, 1310247448, 1310247455, 'HK', 'HKG', 'هونغ كونغ'),
(13522, 1310247456, 1310247463, 'LU', 'LUX', 'لوكسيمبورغ'),
(13523, 1310247464, 1310247471, 'CN', 'CHN', 'الصين'),
(13524, 1310247472, 1310247479, 'PH', 'PHL', 'الفلبين'),
(13525, 1310247480, 1310247487, 'CH', 'CHE', 'سويسرا'),
(13526, 1310247488, 1310247495, 'JP', 'JPN', 'اليابان'),
(13527, 1310247496, 1310247503, 'PE', 'PER', 'بيرو'),
(13528, 1310247504, 1310247511, 'DE', 'DEU', 'ألمانيا'),
(13529, 1310247512, 1310247519, 'CA', 'CAN', 'كندا'),
(13530, 1310247520, 1310247527, 'CR', 'CRI', 'كوستا ريكا'),
(13531, 1310247528, 1310247535, 'IN', 'IND', 'الهند'),
(13532, 1310247536, 1310247543, 'US', 'USA', 'الولايات المتحدة'),
(13533, 1310247544, 1310247551, 'CA', 'CAN', 'كندا'),
(13534, 1310247552, 1310247559, 'FR', 'FRA', 'فرنسا'),
(13535, 1310247560, 1310247567, 'ES', 'ESP', 'إسبانيا'),
(13536, 1310247568, 1310247575, 'IT', 'ITA', 'إيطاليا'),
(13537, 1310247576, 1310247583, 'AT', 'AUT', 'النمسا'),
(13538, 1310247584, 1310247591, 'PT', 'PRT', 'البورتوغال'),
(13539, 1310247592, 1310247599, 'NL', 'NLD', 'هولندا'),
(13540, 1310247600, 1310247607, 'GB', 'GBR', 'المملكة المتحدة'),
(13541, 1310247608, 1310247615, 'GR', 'GRC', 'اليونان'),
(13542, 1310247616, 1310247623, 'CL', 'CHL', 'تشيلي'),
(13543, 1310247624, 1310247631, 'BE', 'BEL', 'بلجيكا'),
(13544, 1310247632, 1310247639, 'MX', 'MEX', 'المكسيك'),
(13545, 1310247640, 1310247647, 'AR', 'ARG', 'الأرجنتين'),
(13546, 1310247648, 1310247655, 'PL', 'POL', 'بولندا'),
(13547, 1310247656, 1310247663, 'IE', 'IRL', 'إيرلندا'),
(13548, 1310247664, 1310247671, 'CH', 'CHE', 'سويسرا'),
(13549, 1310247672, 1310247679, 'RU', 'RUS', 'الإتحاد الروسي'),
(13550, 1310247680, 1310247687, 'BE', 'BEL', 'بلجيكا'),
(13551, 1310247688, 1310247695, 'BR', 'BRA', 'البرازيل'),
(13552, 1310247696, 1310247703, 'CZ', 'CZE', 'التشيك'),
(13553, 1310247704, 1310247711, 'HK', 'HKG', 'هونغ كونغ'),
(13554, 1310247712, 1310247719, 'LU', 'LUX', 'لوكسيمبورغ'),
(13555, 1310247720, 1310247727, 'CN', 'CHN', 'الصين'),
(13556, 1310247728, 1310247735, 'PH', 'PHL', 'الفلبين'),
(13557, 1310247736, 1310247743, 'CH', 'CHE', 'سويسرا'),
(13558, 1310247744, 1310247751, 'JP', 'JPN', 'اليابان'),
(13559, 1310247752, 1310247759, 'PE', 'PER', 'بيرو'),
(13560, 1310247760, 1310247767, 'DE', 'DEU', 'ألمانيا'),
(13561, 1310247768, 1310247775, 'CA', 'CAN', 'كندا'),
(13562, 1310247776, 1310247783, 'CR', 'CRI', 'كوستا ريكا'),
(13563, 1310247784, 1310247791, 'IN', 'IND', 'الهند'),
(13564, 1310247792, 1310247799, 'US', 'USA', 'الولايات المتحدة'),
(13565, 1310247800, 1310247807, 'CA', 'CAN', 'كندا'),
(13566, 1310247808, 1310247815, 'FR', 'FRA', 'فرنسا'),
(13567, 1310247816, 1310247823, 'ES', 'ESP', 'إسبانيا'),
(13568, 1310247824, 1310247831, 'IT', 'ITA', 'إيطاليا'),
(13569, 1310247832, 1310247839, 'AT', 'AUT', 'النمسا'),
(13570, 1310247840, 1310247847, 'PT', 'PRT', 'البورتوغال'),
(13571, 1310247848, 1310247855, 'NL', 'NLD', 'هولندا'),
(13572, 1310247856, 1310247863, 'GB', 'GBR', 'المملكة المتحدة'),
(13573, 1310247864, 1310247871, 'GR', 'GRC', 'اليونان'),
(13574, 1310247872, 1310247879, 'CL', 'CHL', 'تشيلي'),
(13575, 1310247880, 1310247887, 'BE', 'BEL', 'بلجيكا'),
(13576, 1310247888, 1310247895, 'MX', 'MEX', 'المكسيك'),
(13577, 1310247896, 1310247903, 'AR', 'ARG', 'الأرجنتين'),
(13578, 1310247904, 1310247911, 'PL', 'POL', 'بولندا'),
(13579, 1310247912, 1310247919, 'IE', 'IRL', 'إيرلندا'),
(13580, 1310247920, 1310247927, 'CH', 'CHE', 'سويسرا'),
(13581, 1310247928, 1310247935, 'RU', 'RUS', 'الإتحاد الروسي'),
(13582, 1310247936, 1310247951, 'TR', 'TUR', 'تركيا'),
(13583, 1310247952, 1310247967, 'SE', 'SWE', 'السويد'),
(13584, 1310247968, 1310247983, 'NO', 'NOR', 'النرويج'),
(13585, 1310247984, 1310247999, 'DK', 'DNK', 'الدنيمارك'),
(13586, 1310248000, 1310248015, 'LV', 'LVA', 'لاتفيا'),
(13587, 1310248016, 1310248031, 'BG', 'BGR', 'بلغاريا'),
(13588, 1310248032, 1310248047, 'UA', 'UKR', 'أوكرانيا'),
(13589, 1310248048, 1310248063, 'CH', 'CHE', 'سويسرا'),
(13590, 1310248064, 1310248079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(13591, 1310248080, 1310248095, 'LU', 'LUX', 'لوكسيمبورغ'),
(13592, 1310248096, 1310248111, 'UY', 'URY', 'الأوروغواي'),
(13593, 1310248112, 1310248127, 'PA', 'PAN', 'بنما'),
(13594, 1310248128, 1310248143, 'MY', 'MYS', 'ماليزيا'),
(13595, 1310248144, 1310248159, 'CO', 'COL', 'كولومبيا'),
(13596, 1310248160, 1310248175, 'SG', 'SGP', 'سنغافورة'),
(13597, 1310248176, 1310248191, 'US', 'USA', 'الولايات المتحدة'),
(13598, 1310248192, 1310248207, 'RO', 'ROM', 'رومانيا'),
(13599, 1310248208, 1310248223, 'LT', 'LTU', 'ليتوانيا'),
(13600, 1310248224, 1310248239, 'BO', 'BOL', 'بوليفيا'),
(13601, 1310248240, 1310248255, 'HU', 'HUN', 'هنغاريا'),
(13602, 1310248256, 1310248271, 'FI', 'FIN', 'فنلندا'),
(13603, 1310248272, 1310248287, 'IL', 'ISR', 'إسرائيل'),
(13604, 1310248288, 1310248303, 'AU', 'AUS', 'أستراليا'),
(13605, 1310248304, 1310248319, 'NZ', 'NZL', 'نيوزيلاندا'),
(13606, 1310248320, 1310248335, 'VE', 'VEN', 'فنزويلا'),
(13607, 1310248336, 1310248351, 'CR', 'CRI', 'كوستا ريكا'),
(13608, 1310248352, 1310248367, 'MA', 'MAR', 'المغرب'),
(13609, 1310248368, 1310248383, 'ID', 'IDN', 'إندونيسيا'),
(13610, 1310248384, 1310248399, 'SK', 'SVK', 'سلوفاكيا'),
(13611, 1310248400, 1310248415, 'TW', 'TWN', 'تايوان'),
(13612, 1310248416, 1310248431, 'PA', 'PAN', 'بنما'),
(13613, 1310248432, 1310248447, 'US', 'USA', 'الولايات المتحدة'),
(13614, 1310248448, 1310248455, 'BE', 'BEL', 'بلجيكا'),
(13615, 1310248456, 1310248463, 'BR', 'BRA', 'البرازيل'),
(13616, 1310248464, 1310248487, 'FR', 'FRA', 'فرنسا'),
(13617, 1310248488, 1310248495, 'CN', 'CHN', 'الصين'),
(13618, 1310248496, 1310248503, 'FR', 'FRA', 'فرنسا'),
(13619, 1310248504, 1310248511, 'CH', 'CHE', 'سويسرا'),
(13620, 1310248512, 1310248519, 'JP', 'JPN', 'اليابان'),
(13621, 1310248520, 1310248527, 'PE', 'PER', 'بيرو'),
(13622, 1310248528, 1310248535, 'DE', 'DEU', 'ألمانيا'),
(13623, 1310248536, 1310248543, 'CA', 'CAN', 'كندا'),
(13624, 1310248544, 1310248551, 'CR', 'CRI', 'كوستا ريكا'),
(13625, 1310248552, 1310248559, 'IN', 'IND', 'الهند'),
(13626, 1310248560, 1310248567, 'US', 'USA', 'الولايات المتحدة'),
(13627, 1310248568, 1310248575, 'CA', 'CAN', 'كندا'),
(13628, 1310248576, 1310248583, 'FR', 'FRA', 'فرنسا'),
(13629, 1310248584, 1310248591, 'ES', 'ESP', 'إسبانيا'),
(13630, 1310248592, 1310248599, 'IT', 'ITA', 'إيطاليا'),
(13631, 1310248600, 1310248607, 'AT', 'AUT', 'النمسا'),
(13632, 1310248608, 1310248615, 'PT', 'PRT', 'البورتوغال'),
(13633, 1310248616, 1310248623, 'NL', 'NLD', 'هولندا'),
(13634, 1310248624, 1310248631, 'GB', 'GBR', 'المملكة المتحدة'),
(13635, 1310248632, 1310248639, 'GR', 'GRC', 'اليونان'),
(13636, 1310248640, 1310248647, 'CL', 'CHL', 'تشيلي'),
(13637, 1310248648, 1310248655, 'BE', 'BEL', 'بلجيكا'),
(13638, 1310248656, 1310248663, 'MX', 'MEX', 'المكسيك'),
(13639, 1310248664, 1310248671, 'AR', 'ARG', 'الأرجنتين'),
(13640, 1310248672, 1310248679, 'PL', 'POL', 'بولندا'),
(13641, 1310248680, 1310248687, 'IE', 'IRL', 'إيرلندا'),
(13642, 1310248688, 1310248695, 'CH', 'CHE', 'سويسرا'),
(13643, 1310248696, 1310248703, 'RU', 'RUS', 'الإتحاد الروسي'),
(13644, 1310248704, 1310248959, 'CH', 'CHE', 'سويسرا'),
(13645, 1310248960, 1310249215, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(13646, 1310249216, 1310249279, 'GB', 'GBR', 'المملكة المتحدة'),
(13647, 1310249280, 1310249775, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(13648, 1310249776, 1310249801, 'GG', 'GGY', 'غيرنسي'),
(13649, 1310249802, 1310250111, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(13650, 1310250112, 1310250143, 'GG', 'GGY', 'غيرنسي'),
(13651, 1310250144, 1310250495, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(13652, 1310250496, 1310251007, 'MT', 'MLT', 'مالطا'),
(13653, 1310251008, 1310253055, 'LU', 'LUX', 'لوكسيمبورغ'),
(13654, 1310253056, 1310255103, 'RU', 'RUS', 'الإتحاد الروسي'),
(13655, 1310255104, 1310257151, 'CZ', 'CZE', 'التشيك'),
(13656, 1310257152, 1310259199, 'FR', 'FRA', 'فرنسا'),
(13657, 1310259200, 1310261247, 'DE', 'DEU', 'ألمانيا'),
(13658, 1310261248, 1310277631, 'UA', 'UKR', 'أوكرانيا'),
(13659, 1310277632, 1310310399, 'RU', 'RUS', 'الإتحاد الروسي'),
(13660, 1310310400, 1310326783, 'GB', 'GBR', 'المملكة المتحدة'),
(13661, 1310326784, 1310343167, 'NO', 'NOR', 'النرويج'),
(13662, 1310343168, 1310359551, 'IT', 'ITA', 'إيطاليا'),
(13663, 1310359552, 1310392319, 'UA', 'UKR', 'أوكرانيا'),
(13664, 1310392320, 1310408703, 'NL', 'NLD', 'هولندا'),
(13665, 1310408704, 1310425087, 'FI', 'FIN', 'فنلندا'),
(13666, 1310441472, 1310457855, 'UA', 'UKR', 'أوكرانيا'),
(13667, 1310457856, 1310474239, 'PL', 'POL', 'بولندا'),
(13668, 1310474240, 1310490623, 'EE', 'EST', 'إستونيا'),
(13669, 1310490624, 1310507007, 'BA', 'BIH', 'البوسنه والهرسك'),
(13670, 1310507008, 1310523391, 'LV', 'LVA', 'لاتفيا'),
(13671, 1310523392, 1310556159, 'RU', 'RUS', 'الإتحاد الروسي'),
(13672, 1310556160, 1310572543, 'PT', 'PRT', 'البورتوغال'),
(13673, 1310572544, 1310588927, 'BE', 'BEL', 'بلجيكا'),
(13674, 1310588928, 1310605311, 'RU', 'RUS', 'الإتحاد الروسي'),
(13675, 1310605312, 1310621695, 'PL', 'POL', 'بولندا'),
(13676, 1310621696, 1310638079, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(13677, 1310638080, 1310654463, 'UA', 'UKR', 'أوكرانيا'),
(13678, 1310654464, 1310656511, 'RU', 'RUS', 'الإتحاد الروسي'),
(13679, 1310656512, 1310658559, 'LU', 'LUX', 'لوكسيمبورغ'),
(13680, 1310658560, 1310660607, 'RU', 'RUS', 'الإتحاد الروسي'),
(13681, 1310660608, 1310662655, 'CZ', 'CZE', 'التشيك'),
(13682, 1310662656, 1310664703, 'DK', 'DNK', 'الدنيمارك'),
(13683, 1310664704, 1310666751, 'FR', 'FRA', 'فرنسا'),
(13684, 1310666752, 1310668799, 'NL', 'NLD', 'هولندا'),
(13685, 1310668800, 1310670847, 'RO', 'ROM', 'رومانيا'),
(13686, 1310670848, 1310672895, 'DE', 'DEU', 'ألمانيا'),
(13687, 1310672896, 1310674943, 'RU', 'RUS', 'الإتحاد الروسي'),
(13688, 1310674944, 1310676991, 'NO', 'NOR', 'النرويج'),
(13689, 1310676992, 1310679039, 'PL', 'POL', 'بولندا'),
(13690, 1310679040, 1310681087, 'RU', 'RUS', 'الإتحاد الروسي'),
(13691, 1310681088, 1310683135, 'GB', 'GBR', 'المملكة المتحدة'),
(13692, 1310683136, 1310685183, 'NL', 'NLD', 'هولندا'),
(13693, 1310685184, 1310687231, 'PL', 'POL', 'بولندا'),
(13694, 1310687232, 1310689279, 'RO', 'ROM', 'رومانيا'),
(13695, 1310689280, 1310695423, 'PL', 'POL', 'بولندا'),
(13696, 1310695424, 1310697471, 'RO', 'ROM', 'رومانيا'),
(13697, 1310697472, 1310699519, 'DE', 'DEU', 'ألمانيا'),
(13698, 1310699520, 1310705663, 'UA', 'UKR', 'أوكرانيا'),
(13699, 1310705664, 1310711807, 'RU', 'RUS', 'الإتحاد الروسي'),
(13700, 1310711808, 1310713855, 'LT', 'LTU', 'ليتوانيا'),
(13701, 1310713856, 1310715903, 'UA', 'UKR', 'أوكرانيا'),
(13702, 1310715904, 1310717951, 'RU', 'RUS', 'الإتحاد الروسي'),
(13703, 1310717952, 1310719999, 'UA', 'UKR', 'أوكرانيا'),
(13704, 1310720000, 1310851071, 'GB', 'GBR', 'المملكة المتحدة'),
(13705, 1310851072, 1310982143, 'DE', 'DEU', 'ألمانيا'),
(13706, 1310982144, 1311113215, 'RU', 'RUS', 'الإتحاد الروسي'),
(13707, 1311113216, 1311244287, 'IR', 'IRN', 'إيران'),
(13708, 1311244288, 1311246335, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(13709, 1311246336, 1311248383, 'IT', 'ITA', 'إيطاليا'),
(13710, 1311248384, 1311250431, 'GB', 'GBR', 'المملكة المتحدة'),
(13711, 1311250432, 1311252479, 'RU', 'RUS', 'الإتحاد الروسي'),
(13712, 1311252480, 1311254527, 'GB', 'GBR', 'المملكة المتحدة'),
(13713, 1311254528, 1311256575, 'SE', 'SWE', 'السويد'),
(13714, 1311256576, 1311258623, 'FR', 'FRA', 'فرنسا'),
(13715, 1311258624, 1311262719, 'GB', 'GBR', 'المملكة المتحدة'),
(13716, 1311262720, 1311262975, 'FR', 'FRA', 'فرنسا'),
(13717, 1311262976, 1311263407, 'CH', 'CHE', 'سويسرا'),
(13718, 1311263408, 1311263423, 'BE', 'BEL', 'بلجيكا'),
(13719, 1311263424, 1311264767, 'CH', 'CHE', 'سويسرا'),
(13720, 1311264768, 1311266815, 'RU', 'RUS', 'الإتحاد الروسي'),
(13721, 1311266816, 1311268863, 'FR', 'FRA', 'فرنسا'),
(13722, 1311268864, 1311270911, 'BE', 'BEL', 'بلجيكا'),
(13723, 1311270912, 1311272959, 'RU', 'RUS', 'الإتحاد الروسي'),
(13724, 1311272960, 1311275007, 'GB', 'GBR', 'المملكة المتحدة'),
(13725, 1311275008, 1311277055, 'FR', 'FRA', 'فرنسا'),
(13726, 1311277056, 1311279103, 'IT', 'ITA', 'إيطاليا'),
(13727, 1311279104, 1311281151, 'BG', 'BGR', 'بلغاريا'),
(13728, 1311281152, 1311285247, 'GB', 'GBR', 'المملكة المتحدة'),
(13729, 1311285248, 1311289343, 'IT', 'ITA', 'إيطاليا'),
(13730, 1311289344, 1311291391, 'LB', 'LBN', 'لبنان'),
(13731, 1311291392, 1311293439, 'RU', 'RUS', 'الإتحاد الروسي'),
(13732, 1311293440, 1311295487, 'NL', 'NLD', 'هولندا'),
(13733, 1311295488, 1311297535, 'IT', 'ITA', 'إيطاليا'),
(13734, 1311297536, 1311299583, 'AT', 'AUT', 'النمسا'),
(13735, 1311299584, 1311301631, 'RU', 'RUS', 'الإتحاد الروسي'),
(13736, 1311301632, 1311303679, 'TR', 'TUR', 'تركيا'),
(13737, 1311303680, 1311307775, 'GB', 'GBR', 'المملكة المتحدة'),
(13738, 1311307776, 1311309823, 'IS', 'ISL', 'أيسلندا'),
(13739, 1311309824, 1311311871, 'GB', 'GBR', 'المملكة المتحدة'),
(13740, 1311311872, 1311315967, 'CZ', 'CZE', 'التشيك'),
(13741, 1311315968, 1311316423, 'PL', 'POL', 'بولندا'),
(13742, 1311316424, 1311316439, 'GB', 'GBR', 'المملكة المتحدة'),
(13743, 1311316440, 1311316447, 'PL', 'POL', 'بولندا'),
(13744, 1311316448, 1311316455, 'HR', 'HRV', 'كرواتيا'),
(13745, 1311316456, 1311318015, 'PL', 'POL', 'بولندا'),
(13746, 1311318016, 1311320063, 'RU', 'RUS', 'الإتحاد الروسي'),
(13747, 1311320064, 1311322111, 'FR', 'FRA', 'فرنسا'),
(13748, 1311322112, 1311324159, 'IT', 'ITA', 'إيطاليا'),
(13749, 1311324160, 1311326207, 'LB', 'LBN', 'لبنان'),
(13750, 1311326208, 1311328255, 'BE', 'BEL', 'بلجيكا'),
(13751, 1311328256, 1311330303, 'NL', 'NLD', 'هولندا'),
(13752, 1311332352, 1311338495, 'RU', 'RUS', 'الإتحاد الروسي'),
(13753, 1311338496, 1311340543, 'AT', 'AUT', 'النمسا'),
(13754, 1311340544, 1311342591, 'NO', 'NOR', 'النرويج'),
(13755, 1311342592, 1311344639, 'FR', 'FRA', 'فرنسا'),
(13756, 1311344640, 1311346687, 'NO', 'NOR', 'النرويج'),
(13757, 1311346688, 1311348735, 'AT', 'AUT', 'النمسا'),
(13758, 1311348736, 1311350783, 'GB', 'GBR', 'المملكة المتحدة'),
(13759, 1311350784, 1311352831, 'RU', 'RUS', 'الإتحاد الروسي'),
(13760, 1311352832, 1311354879, 'SK', 'SVK', 'سلوفاكيا'),
(13761, 1311354880, 1311356927, 'RU', 'RUS', 'الإتحاد الروسي'),
(13762, 1311356928, 1311358263, 'FR', 'FRA', 'فرنسا'),
(13763, 1311358264, 1311358271, 'ES', 'ESP', 'إسبانيا'),
(13764, 1311358272, 1311358975, 'FR', 'FRA', 'فرنسا'),
(13765, 1311358976, 1311361023, 'RU', 'RUS', 'الإتحاد الروسي'),
(13766, 1311361024, 1311363071, 'NL', 'NLD', 'هولندا'),
(13767, 1311363072, 1311365119, 'GB', 'GBR', 'المملكة المتحدة'),
(13768, 1311365120, 1311367167, 'DE', 'DEU', 'ألمانيا'),
(13769, 1311367168, 1311367295, 'GN', 'GIN', 'غينيا'),
(13770, 1311367296, 1311367423, 'GA', 'GAB', 'الغابون'),
(13771, 1311367424, 1311367679, 'MM', 'MMR', 'ميانمار'),
(13772, 1311367680, 1311367711, 'UG', 'UGA', 'أوغاندا'),
(13773, 1311367712, 1311367743, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(13774, 1311367744, 1311367775, 'SL', 'SLE', 'سيراليون'),
(13775, 1311367776, 1311367807, 'LR', 'LBR', 'ليبيريا'),
(13776, 1311367808, 1311367839, 'US', 'USA', 'الولايات المتحدة'),
(13777, 1311367840, 1311367871, 'DK', 'DNK', 'الدنيمارك'),
(13778, 1311367872, 1311367887, 'LR', 'LBR', 'ليبيريا'),
(13779, 1311367888, 1311367895, 'DE', 'DEU', 'ألمانيا'),
(13780, 1311367896, 1311367935, 'DK', 'DNK', 'الدنيمارك'),
(13781, 1311367936, 1311367967, 'BJ', 'BEN', 'بنين'),
(13782, 1311367968, 1311368191, 'DE', 'DEU', 'ألمانيا'),
(13783, 1311368192, 1311368319, 'BD', 'BGD', 'بنغالاديش'),
(13784, 1311368320, 1311368447, 'CF', 'CAF', 'جمهورية أفريقيا الوسطى'),
(13785, 1311368448, 1311368575, 'TZ', 'TZA', 'تانزانيا'),
(13786, 1311368576, 1311368703, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(13787, 1311368704, 1311368831, 'NP', 'NPL', 'نيبال'),
(13788, 1311368832, 1311368959, 'GM', 'GMB', 'غامبيا'),
(13789, 1311368960, 1311369087, 'PT', 'PRT', 'البورتوغال'),
(13790, 1311369088, 1311369215, 'BT', 'BTN', 'بوتان'),
(13791, 1311369216, 1311371263, 'FR', 'FRA', 'فرنسا'),
(13792, 1311371264, 1311373311, 'SE', 'SWE', 'السويد'),
(13793, 1311373312, 1311375359, 'FR', 'FRA', 'فرنسا'),
(13794, 1311375360, 1311506431, 'DE', 'DEU', 'ألمانيا'),
(13795, 1311506432, 1311637503, 'CZ', 'CZE', 'التشيك'),
(13796, 1311637504, 1311707655, 'DE', 'DEU', 'ألمانيا'),
(13797, 1311707656, 1311707663, 'NL', 'NLD', 'هولندا'),
(13798, 1311707664, 1312292863, 'DE', 'DEU', 'ألمانيا'),
(13799, 1312292864, 1312817151, 'LT', 'LTU', 'ليتوانيا'),
(13800, 1312817152, 1313865727, 'SE', 'SWE', 'السويد'),
(13801, 1313865728, 1313931263, 'CZ', 'CZE', 'التشيك'),
(13802, 1313931264, 1313996799, 'RU', 'RUS', 'الإتحاد الروسي'),
(13803, 1313996800, 1314062335, 'SE', 'SWE', 'السويد'),
(13804, 1314062336, 1314127871, 'BG', 'BGR', 'بلغاريا'),
(13805, 1314127872, 1314193407, 'LV', 'LVA', 'لاتفيا'),
(13806, 1314193408, 1314258943, 'RU', 'RUS', 'الإتحاد الروسي'),
(13807, 1314258944, 1314324479, 'GB', 'GBR', 'المملكة المتحدة'),
(13808, 1314324480, 1314390015, 'GR', 'GRC', 'اليونان'),
(13809, 1314390016, 1314455551, 'PL', 'POL', 'بولندا'),
(13810, 1314455552, 1314521087, 'KW', 'KWT', 'الكويت'),
(13811, 1314521088, 1314586623, 'BG', 'BGR', 'بلغاريا'),
(13812, 1314586624, 1314652159, 'NO', 'NOR', 'النرويج'),
(13813, 1314652160, 1314717695, 'HU', 'HUN', 'هنغاريا'),
(13814, 1314717696, 1314783231, 'SA', 'SAU', 'السعودية'),
(13815, 1314783232, 1314848767, 'DE', 'DEU', 'ألمانيا'),
(13816, 1314848768, 1315045375, 'RO', 'ROM', 'رومانيا'),
(13817, 1315045376, 1315176447, 'SK', 'SVK', 'سلوفاكيا'),
(13818, 1315176448, 1315307519, 'QA', 'QAT', 'قطر'),
(13819, 1315307520, 1315438591, 'CZ', 'CZE', 'التشيك'),
(13820, 1315438592, 1315504127, 'AT', 'AUT', 'النمسا'),
(13821, 1315504128, 1315569663, 'GB', 'GBR', 'المملكة المتحدة'),
(13822, 1315569664, 1315700735, 'RU', 'RUS', 'الإتحاد الروسي'),
(13823, 1315700736, 1315704831, 'SE', 'SWE', 'السويد'),
(13824, 1315704832, 1315708927, 'HU', 'HUN', 'هنغاريا'),
(13825, 1315708928, 1315713023, 'GR', 'GRC', 'اليونان'),
(13826, 1315713024, 1315717119, 'SE', 'SWE', 'السويد'),
(13827, 1315717120, 1315725311, 'RU', 'RUS', 'الإتحاد الروسي'),
(13828, 1315725312, 1315729407, 'CZ', 'CZE', 'التشيك'),
(13829, 1315733504, 1315737599, 'NL', 'NLD', 'هولندا'),
(13830, 1315737600, 1315741695, 'CZ', 'CZE', 'التشيك'),
(13831, 1315741696, 1315745791, 'LB', 'LBN', 'لبنان'),
(13832, 1315745792, 1315749375, 'CZ', 'CZE', 'التشيك'),
(13833, 1315749376, 1315749503, 'ES', 'ESP', 'إسبانيا'),
(13834, 1315749504, 1315749887, 'CZ', 'CZE', 'التشيك'),
(13835, 1315749888, 1315753983, 'RU', 'RUS', 'الإتحاد الروسي'),
(13836, 1315753984, 1315758079, 'KZ', 'KAZ', 'كازاخستان'),
(13837, 1315758080, 1315762175, 'FR', 'FRA', 'فرنسا'),
(13838, 1315762176, 1315766271, 'BG', 'BGR', 'بلغاريا'),
(13839, 1315766272, 1315770367, 'NL', 'NLD', 'هولندا'),
(13840, 1315770368, 1315770383, 'UA', 'UKR', 'أوكرانيا'),
(13841, 1315770384, 1315770399, 'NA', 'NAM', 'ناميبيا'),
(13842, 1315770400, 1315770503, 'UA', 'UKR', 'أوكرانيا'),
(13843, 1315770504, 1315770511, 'NA', 'NAM', 'ناميبيا'),
(13844, 1315770512, 1315770575, 'UA', 'UKR', 'أوكرانيا'),
(13845, 1315770576, 1315770583, 'NA', 'NAM', 'ناميبيا'),
(13846, 1315770584, 1315770591, 'UA', 'UKR', 'أوكرانيا'),
(13847, 1315770592, 1315770599, 'NA', 'NAM', 'ناميبيا'),
(13848, 1315770600, 1315770639, 'UA', 'UKR', 'أوكرانيا'),
(13849, 1315770640, 1315770647, 'NA', 'NAM', 'ناميبيا'),
(13850, 1315770648, 1315770719, 'UA', 'UKR', 'أوكرانيا'),
(13851, 1315770720, 1315770727, 'NA', 'NAM', 'ناميبيا'),
(13852, 1315770728, 1315770975, 'UA', 'UKR', 'أوكرانيا'),
(13853, 1315770976, 1315770983, 'NA', 'NAM', 'ناميبيا'),
(13854, 1315770984, 1315770991, 'UA', 'UKR', 'أوكرانيا'),
(13855, 1315770992, 1315770999, 'NA', 'NAM', 'ناميبيا'),
(13856, 1315771000, 1315771199, 'UA', 'UKR', 'أوكرانيا'),
(13857, 1315771200, 1315771207, 'NA', 'NAM', 'ناميبيا'),
(13858, 1315771208, 1315771223, 'UA', 'UKR', 'أوكرانيا'),
(13859, 1315771224, 1315771231, 'NA', 'NAM', 'ناميبيا'),
(13860, 1315771232, 1315771247, 'UA', 'UKR', 'أوكرانيا'),
(13861, 1315771248, 1315771263, 'NA', 'NAM', 'ناميبيا'),
(13862, 1315771264, 1315771271, 'UA', 'UKR', 'أوكرانيا'),
(13863, 1315771272, 1315771279, 'NA', 'NAM', 'ناميبيا'),
(13864, 1315771280, 1315771415, 'UA', 'UKR', 'أوكرانيا'),
(13865, 1315771416, 1315771423, 'NA', 'NAM', 'ناميبيا'),
(13866, 1315771424, 1315771639, 'UA', 'UKR', 'أوكرانيا'),
(13867, 1315771640, 1315771647, 'NA', 'NAM', 'ناميبيا'),
(13868, 1315771648, 1315771759, 'UA', 'UKR', 'أوكرانيا'),
(13869, 1315771760, 1315771767, 'NA', 'NAM', 'ناميبيا'),
(13870, 1315771768, 1315771815, 'UA', 'UKR', 'أوكرانيا'),
(13871, 1315771816, 1315771823, 'NA', 'NAM', 'ناميبيا'),
(13872, 1315771824, 1315771871, 'UA', 'UKR', 'أوكرانيا'),
(13873, 1315771872, 1315771879, 'NA', 'NAM', 'ناميبيا'),
(13874, 1315771880, 1315771935, 'UA', 'UKR', 'أوكرانيا'),
(13875, 1315771936, 1315771951, 'NA', 'NAM', 'ناميبيا'),
(13876, 1315771952, 1315771959, 'UA', 'UKR', 'أوكرانيا'),
(13877, 1315771960, 1315771967, 'NA', 'NAM', 'ناميبيا'),
(13878, 1315771968, 1315771975, 'UA', 'UKR', 'أوكرانيا'),
(13879, 1315771976, 1315771983, 'NA', 'NAM', 'ناميبيا'),
(13880, 1315771984, 1315772031, 'UA', 'UKR', 'أوكرانيا'),
(13881, 1315772032, 1315772039, 'NA', 'NAM', 'ناميبيا'),
(13882, 1315772040, 1315772167, 'UA', 'UKR', 'أوكرانيا'),
(13883, 1315772168, 1315772175, 'NA', 'NAM', 'ناميبيا'),
(13884, 1315772176, 1315772191, 'UA', 'UKR', 'أوكرانيا'),
(13885, 1315772192, 1315772199, 'NA', 'NAM', 'ناميبيا'),
(13886, 1315772200, 1315772223, 'UA', 'UKR', 'أوكرانيا'),
(13887, 1315772224, 1315772231, 'NA', 'NAM', 'ناميبيا'),
(13888, 1315772232, 1315772303, 'UA', 'UKR', 'أوكرانيا'),
(13889, 1315772304, 1315772311, 'NA', 'NAM', 'ناميبيا'),
(13890, 1315772312, 1315772319, 'UA', 'UKR', 'أوكرانيا'),
(13891, 1315772320, 1315772327, 'NA', 'NAM', 'ناميبيا'),
(13892, 1315772328, 1315772399, 'UA', 'UKR', 'أوكرانيا'),
(13893, 1315772400, 1315772407, 'NA', 'NAM', 'ناميبيا'),
(13894, 1315772408, 1315772463, 'UA', 'UKR', 'أوكرانيا'),
(13895, 1315772464, 1315772479, 'NA', 'NAM', 'ناميبيا'),
(13896, 1315772480, 1315772503, 'UA', 'UKR', 'أوكرانيا'),
(13897, 1315772504, 1315772511, 'NA', 'NAM', 'ناميبيا'),
(13898, 1315772512, 1315772583, 'UA', 'UKR', 'أوكرانيا'),
(13899, 1315772584, 1315772599, 'NA', 'NAM', 'ناميبيا'),
(13900, 1315772600, 1315772703, 'UA', 'UKR', 'أوكرانيا'),
(13901, 1315772704, 1315772711, 'NA', 'NAM', 'ناميبيا'),
(13902, 1315772712, 1315772887, 'UA', 'UKR', 'أوكرانيا'),
(13903, 1315772888, 1315772895, 'NA', 'NAM', 'ناميبيا'),
(13904, 1315772896, 1315772919, 'UA', 'UKR', 'أوكرانيا'),
(13905, 1315772920, 1315772927, 'NA', 'NAM', 'ناميبيا'),
(13906, 1315772928, 1315773463, 'UA', 'UKR', 'أوكرانيا'),
(13907, 1315773464, 1315773471, 'NA', 'NAM', 'ناميبيا'),
(13908, 1315773472, 1315773487, 'UA', 'UKR', 'أوكرانيا'),
(13909, 1315773488, 1315773495, 'NA', 'NAM', 'ناميبيا'),
(13910, 1315773496, 1315773511, 'UA', 'UKR', 'أوكرانيا'),
(13911, 1315773512, 1315773519, 'NA', 'NAM', 'ناميبيا'),
(13912, 1315773520, 1315773535, 'UA', 'UKR', 'أوكرانيا'),
(13913, 1315773536, 1315773543, 'NA', 'NAM', 'ناميبيا'),
(13914, 1315773544, 1315773551, 'UA', 'UKR', 'أوكرانيا'),
(13915, 1315773552, 1315773559, 'NA', 'NAM', 'ناميبيا'),
(13916, 1315773560, 1315773575, 'UA', 'UKR', 'أوكرانيا'),
(13917, 1315773576, 1315773583, 'NA', 'NAM', 'ناميبيا'),
(13918, 1315773584, 1315773655, 'UA', 'UKR', 'أوكرانيا'),
(13919, 1315773656, 1315773663, 'NA', 'NAM', 'ناميبيا'),
(13920, 1315773664, 1315773679, 'UA', 'UKR', 'أوكرانيا'),
(13921, 1315773680, 1315773687, 'NA', 'NAM', 'ناميبيا'),
(13922, 1315773688, 1315773703, 'UA', 'UKR', 'أوكرانيا'),
(13923, 1315773704, 1315773711, 'NA', 'NAM', 'ناميبيا'),
(13924, 1315773712, 1315773719, 'UA', 'UKR', 'أوكرانيا'),
(13925, 1315773720, 1315773751, 'NA', 'NAM', 'ناميبيا'),
(13926, 1315773752, 1315773895, 'UA', 'UKR', 'أوكرانيا'),
(13927, 1315773896, 1315773903, 'NA', 'NAM', 'ناميبيا'),
(13928, 1315773904, 1315773955, 'UA', 'UKR', 'أوكرانيا'),
(13929, 1315773956, 1315773959, 'NA', 'NAM', 'ناميبيا'),
(13930, 1315773960, 1315773983, 'UA', 'UKR', 'أوكرانيا'),
(13931, 1315773984, 1315773991, 'BY', 'BLR', 'روسيا البيضاء'),
(13932, 1315773992, 1315774015, 'UA', 'UKR', 'أوكرانيا'),
(13933, 1315774016, 1315774031, 'NA', 'NAM', 'ناميبيا'),
(13934, 1315774032, 1315774039, 'UA', 'UKR', 'أوكرانيا'),
(13935, 1315774040, 1315774071, 'NA', 'NAM', 'ناميبيا'),
(13936, 1315774072, 1315774095, 'UA', 'UKR', 'أوكرانيا'),
(13937, 1315774096, 1315774111, 'NA', 'NAM', 'ناميبيا'),
(13938, 1315774112, 1315774135, 'UA', 'UKR', 'أوكرانيا'),
(13939, 1315774136, 1315774143, 'US', 'USA', 'الولايات المتحدة'),
(13940, 1315774144, 1315774191, 'UA', 'UKR', 'أوكرانيا'),
(13941, 1315774192, 1315774207, 'NA', 'NAM', 'ناميبيا'),
(13942, 1315774208, 1315774239, 'UA', 'UKR', 'أوكرانيا'),
(13943, 1315774240, 1315774255, 'RU', 'RUS', 'الإتحاد الروسي'),
(13944, 1315774256, 1315774263, 'NA', 'NAM', 'ناميبيا'),
(13945, 1315774264, 1315774423, 'UA', 'UKR', 'أوكرانيا'),
(13946, 1315774424, 1315774431, 'NA', 'NAM', 'ناميبيا'),
(13947, 1315774432, 1315774463, 'UA', 'UKR', 'أوكرانيا'),
(13948, 1315774464, 1315782655, 'RU', 'RUS', 'الإتحاد الروسي'),
(13949, 1315782656, 1315786751, 'AM', 'ARM', 'أرمينيا'),
(13950, 1315786752, 1315790847, 'FR', 'FRA', 'فرنسا'),
(13951, 1315790848, 1315794943, 'RS', 'SRB', 'صربيا'),
(13952, 1315794944, 1315803135, 'RU', 'RUS', 'الإتحاد الروسي'),
(13953, 1315803136, 1315807231, 'KZ', 'KAZ', 'كازاخستان'),
(13954, 1315807232, 1315815423, 'GB', 'GBR', 'المملكة المتحدة'),
(13955, 1315815424, 1315819519, 'IR', 'IRN', 'إيران'),
(13956, 1315819520, 1315823615, 'DK', 'DNK', 'الدنيمارك'),
(13957, 1315823616, 1315827711, 'IQ', 'IRQ', 'العراق'),
(13958, 1315827712, 1315831807, 'RU', 'RUS', 'الإتحاد الروسي'),
(13959, 1315831808, 1315835903, 'SA', 'SAU', 'السعودية'),
(13960, 1315835904, 1315836159, 'CY', 'CYP', 'قبرص'),
(13961, 1315836160, 1315839487, 'MT', 'MLT', 'مالطا'),
(13962, 1315839488, 1315839743, 'CY', 'CYP', 'قبرص'),
(13963, 1315839744, 1315839999, 'MT', 'MLT', 'مالطا'),
(13964, 1315840000, 1315844095, 'EE', 'EST', 'إستونيا'),
(13965, 1315844096, 1315848191, 'RU', 'RUS', 'الإتحاد الروسي'),
(13966, 1315848192, 1315852287, 'BH', 'BHR', 'البحرين'),
(13967, 1315852288, 1315856383, 'SE', 'SWE', 'السويد'),
(13968, 1315856384, 1315860479, 'SY', 'SYR', 'سوريا'),
(13969, 1315860480, 1315864575, 'IR', 'IRN', 'إيران'),
(13970, 1315864576, 1315868671, 'CH', 'CHE', 'سويسرا'),
(13971, 1315868672, 1315872767, 'RU', 'RUS', 'الإتحاد الروسي'),
(13972, 1315872768, 1315875183, 'GB', 'GBR', 'المملكة المتحدة'),
(13973, 1315875184, 1315875199, 'ES', 'ESP', 'إسبانيا'),
(13974, 1315875200, 1315876863, 'GB', 'GBR', 'المملكة المتحدة'),
(13975, 1315876864, 1315880959, 'IT', 'ITA', 'إيطاليا'),
(13976, 1315880960, 1315885055, 'BE', 'BEL', 'بلجيكا'),
(13977, 1315885056, 1315889151, 'CZ', 'CZE', 'التشيك'),
(13978, 1315889152, 1315893247, 'DE', 'DEU', 'ألمانيا'),
(13979, 1315893248, 1315897343, 'RU', 'RUS', 'الإتحاد الروسي'),
(13980, 1315897344, 1315897855, 'IR', 'IRN', 'إيران'),
(13981, 1315897856, 1315897863, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13982, 1315897864, 1315897879, 'IR', 'IRN', 'إيران'),
(13983, 1315897880, 1315897887, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13984, 1315897888, 1315897951, 'IR', 'IRN', 'إيران'),
(13985, 1315897952, 1315897991, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13986, 1315897992, 1315897999, 'IR', 'IRN', 'إيران'),
(13987, 1315898000, 1315898015, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13988, 1315898016, 1315898031, 'IR', 'IRN', 'إيران'),
(13989, 1315898032, 1315898111, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13990, 1315898112, 1315900799, 'IR', 'IRN', 'إيران'),
(13991, 1315900800, 1315900927, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13992, 1315900928, 1315901183, 'IR', 'IRN', 'إيران'),
(13993, 1315901184, 1315901439, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(13994, 1315901440, 1315905535, 'UA', 'UKR', 'أوكرانيا'),
(13995, 1315905536, 1315907583, 'BA', 'BIH', 'البوسنه والهرسك'),
(13996, 1315907584, 1315908095, 'SI', 'SVN', 'سلوفينيا'),
(13997, 1315908096, 1315909631, 'BA', 'BIH', 'البوسنه والهرسك'),
(13998, 1315909632, 1315913727, 'AZ', 'AZE', 'أذربيجان'),
(13999, 1315913728, 1315917823, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(14000, 1315917824, 1315921919, 'RU', 'RUS', 'الإتحاد الروسي'),
(14001, 1315921920, 1315926015, 'TR', 'TUR', 'تركيا'),
(14002, 1315926016, 1315930111, 'CZ', 'CZE', 'التشيك'),
(14003, 1315930112, 1315934207, 'DE', 'DEU', 'ألمانيا'),
(14004, 1315934208, 1315938303, 'RU', 'RUS', 'الإتحاد الروسي'),
(14005, 1315938304, 1315942399, 'DK', 'DNK', 'الدنيمارك'),
(14006, 1315942400, 1315946495, 'UA', 'UKR', 'أوكرانيا'),
(14007, 1315946496, 1315950591, 'GB', 'GBR', 'المملكة المتحدة'),
(14008, 1315950592, 1315954687, 'UA', 'UKR', 'أوكرانيا'),
(14009, 1315954688, 1315958783, 'DE', 'DEU', 'ألمانيا'),
(14010, 1315958784, 1315962879, 'RU', 'RUS', 'الإتحاد الروسي'),
(14011, 1315962880, 1317011455, 'FR', 'FRA', 'فرنسا'),
(14012, 1317011456, 1317044223, 'BG', 'BGR', 'بلغاريا'),
(14013, 1317044224, 1317076991, 'CZ', 'CZE', 'التشيك'),
(14014, 1317076992, 1317109759, 'BE', 'BEL', 'بلجيكا'),
(14015, 1317109760, 1317113855, 'GB', 'GBR', 'المملكة المتحدة'),
(14016, 1317113856, 1317114111, 'US', 'USA', 'الولايات المتحدة'),
(14017, 1317114112, 1317115135, 'GB', 'GBR', 'المملكة المتحدة'),
(14018, 1317115136, 1317115391, 'IE', 'IRL', 'إيرلندا'),
(14019, 1317115392, 1317118207, 'GB', 'GBR', 'المملكة المتحدة'),
(14020, 1317118208, 1317118463, 'IN', 'IND', 'الهند'),
(14021, 1317118464, 1317119103, 'GB', 'GBR', 'المملكة المتحدة'),
(14022, 1317119104, 1317119167, 'IT', 'ITA', 'إيطاليا'),
(14023, 1317119168, 1317119487, 'GB', 'GBR', 'المملكة المتحدة'),
(14024, 1317119488, 1317119743, 'KY', 'CYM', 'جزر كايمان'),
(14025, 1317119744, 1317126399, 'GB', 'GBR', 'المملكة المتحدة'),
(14026, 1317126400, 1317126655, 'US', 'USA', 'الولايات المتحدة'),
(14027, 1317126656, 1317129279, 'GB', 'GBR', 'المملكة المتحدة'),
(14028, 1317129280, 1317129343, 'CA', 'CAN', 'كندا'),
(14029, 1317129344, 1317129471, 'GB', 'GBR', 'المملكة المتحدة'),
(14030, 1317129472, 1317129727, 'IT', 'ITA', 'إيطاليا'),
(14031, 1317129728, 1317137279, 'GB', 'GBR', 'المملكة المتحدة'),
(14032, 1317137280, 1317137343, 'CN', 'CHN', 'الصين'),
(14033, 1317137344, 1317137663, 'GB', 'GBR', 'المملكة المتحدة'),
(14034, 1317137664, 1317137919, 'SE', 'SWE', 'السويد'),
(14035, 1317137920, 1317142143, 'GB', 'GBR', 'المملكة المتحدة'),
(14036, 1317142144, 1317142271, 'CA', 'CAN', 'كندا'),
(14037, 1317142272, 1317142527, 'GB', 'GBR', 'المملكة المتحدة'),
(14038, 1317142528, 1317175295, 'PT', 'PRT', 'البورتوغال'),
(14039, 1317175296, 1317208063, 'BG', 'BGR', 'بلغاريا'),
(14040, 1317208064, 1317240831, 'HU', 'HUN', 'هنغاريا'),
(14041, 1317240832, 1317273599, 'PL', 'POL', 'بولندا'),
(14042, 1317273600, 1317306367, 'AT', 'AUT', 'النمسا'),
(14043, 1317306368, 1317339135, 'RU', 'RUS', 'الإتحاد الروسي'),
(14044, 1317339136, 1317371903, 'MT', 'MLT', 'مالطا'),
(14045, 1317371904, 1317404671, 'PL', 'POL', 'بولندا'),
(14046, 1317404672, 1317437439, 'IT', 'ITA', 'إيطاليا'),
(14047, 1317437440, 1317470207, 'HR', 'HRV', 'كرواتيا'),
(14048, 1317470208, 1317502975, 'TR', 'TUR', 'تركيا'),
(14049, 1317502976, 1317535743, 'IE', 'IRL', 'إيرلندا'),
(14050, 1317535744, 1317552127, 'GB', 'GBR', 'المملكة المتحدة'),
(14051, 1317552128, 1317568511, 'ES', 'ESP', 'إسبانيا'),
(14052, 1317568512, 1317584895, 'CZ', 'CZE', 'التشيك'),
(14053, 1317584896, 1317601279, 'RU', 'RUS', 'الإتحاد الروسي'),
(14054, 1317601280, 1317617663, 'UA', 'UKR', 'أوكرانيا'),
(14055, 1317617664, 1317634047, 'RU', 'RUS', 'الإتحاد الروسي'),
(14056, 1317634048, 1317646895, 'IE', 'IRL', 'إيرلندا'),
(14057, 1317646896, 1317646911, 'GB', 'GBR', 'المملكة المتحدة'),
(14058, 1317646912, 1317646991, 'IE', 'IRL', 'إيرلندا'),
(14059, 1317646992, 1317646999, 'GB', 'GBR', 'المملكة المتحدة'),
(14060, 1317647000, 1317649407, 'IE', 'IRL', 'إيرلندا'),
(14061, 1317649408, 1317649919, 'GB', 'GBR', 'المملكة المتحدة'),
(14062, 1317649920, 1317650431, 'IE', 'IRL', 'إيرلندا'),
(14063, 1317650432, 1317666815, 'RU', 'RUS', 'الإتحاد الروسي'),
(14064, 1317666816, 1317666823, 'IQ', 'IRQ', 'العراق'),
(14065, 1317666824, 1317666831, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14066, 1317666832, 1317666839, 'NG', 'NGA', 'نيجيريا'),
(14067, 1317666840, 1317666855, 'GH', 'GHA', 'غانا'),
(14068, 1317666856, 1317666863, 'GB', 'GBR', 'المملكة المتحدة'),
(14069, 1317666864, 1317666871, 'GH', 'GHA', 'غانا'),
(14070, 1317666872, 1317666879, 'NG', 'NGA', 'نيجيريا'),
(14071, 1317666880, 1317666887, 'LR', 'LBR', 'ليبيريا'),
(14072, 1317666888, 1317666911, 'NG', 'NGA', 'نيجيريا'),
(14073, 1317666912, 1317666919, 'GB', 'GBR', 'المملكة المتحدة'),
(14074, 1317666920, 1317666927, 'NG', 'NGA', 'نيجيريا'),
(14075, 1317666928, 1317666959, 'GB', 'GBR', 'المملكة المتحدة'),
(14076, 1317666960, 1317666967, 'NG', 'NGA', 'نيجيريا'),
(14077, 1317666968, 1317666983, 'GB', 'GBR', 'المملكة المتحدة'),
(14078, 1317666984, 1317666991, 'CM', 'CMR', 'الكاميرون'),
(14079, 1317666992, 1317666999, 'GB', 'GBR', 'المملكة المتحدة'),
(14080, 1317667000, 1317667007, 'AO', 'AGO', 'أنغولا'),
(14081, 1317667008, 1317667015, 'GH', 'GHA', 'غانا'),
(14082, 1317667016, 1317667023, 'GB', 'GBR', 'المملكة المتحدة'),
(14083, 1317667024, 1317667031, 'LR', 'LBR', 'ليبيريا'),
(14084, 1317667032, 1317667039, 'NG', 'NGA', 'نيجيريا'),
(14085, 1317667040, 1317667047, 'GH', 'GHA', 'غانا'),
(14086, 1317667048, 1317667055, 'NG', 'NGA', 'نيجيريا'),
(14087, 1317667056, 1317667063, 'LR', 'LBR', 'ليبيريا'),
(14088, 1317667064, 1317667087, 'AO', 'AGO', 'أنغولا'),
(14089, 1317667088, 1317667095, 'GB', 'GBR', 'المملكة المتحدة'),
(14090, 1317667096, 1317667103, 'GH', 'GHA', 'غانا'),
(14091, 1317667104, 1317667111, 'NG', 'NGA', 'نيجيريا'),
(14092, 1317667112, 1317667119, 'GH', 'GHA', 'غانا'),
(14093, 1317667120, 1317667135, 'GB', 'GBR', 'المملكة المتحدة'),
(14094, 1317667136, 1317667143, 'AO', 'AGO', 'أنغولا'),
(14095, 1317667144, 1317667151, 'GB', 'GBR', 'المملكة المتحدة'),
(14096, 1317667152, 1317667159, 'NG', 'NGA', 'نيجيريا'),
(14097, 1317667160, 1317667167, 'AO', 'AGO', 'أنغولا'),
(14098, 1317667168, 1317667175, 'NG', 'NGA', 'نيجيريا'),
(14099, 1317667176, 1317667183, 'GH', 'GHA', 'غانا'),
(14100, 1317667184, 1317667191, 'GB', 'GBR', 'المملكة المتحدة'),
(14101, 1317667192, 1317667231, 'NG', 'NGA', 'نيجيريا'),
(14102, 1317667232, 1317667239, 'GH', 'GHA', 'غانا'),
(14103, 1317667240, 1317667247, 'NG', 'NGA', 'نيجيريا'),
(14104, 1317667248, 1317667255, 'GB', 'GBR', 'المملكة المتحدة'),
(14105, 1317667256, 1317667263, 'NG', 'NGA', 'نيجيريا'),
(14106, 1317667264, 1317667271, 'GB', 'GBR', 'المملكة المتحدة'),
(14107, 1317667272, 1317667295, 'NG', 'NGA', 'نيجيريا'),
(14108, 1317667296, 1317667303, 'GB', 'GBR', 'المملكة المتحدة'),
(14109, 1317667304, 1317667335, 'NG', 'NGA', 'نيجيريا'),
(14110, 1317667336, 1317667343, 'GB', 'GBR', 'المملكة المتحدة'),
(14111, 1317667344, 1317667351, 'NG', 'NGA', 'نيجيريا'),
(14112, 1317667352, 1317667367, 'AO', 'AGO', 'أنغولا'),
(14113, 1317667368, 1317667375, 'NG', 'NGA', 'نيجيريا'),
(14114, 1317667376, 1317667391, 'AO', 'AGO', 'أنغولا'),
(14115, 1317667392, 1317667407, 'GB', 'GBR', 'المملكة المتحدة'),
(14116, 1317667408, 1317667423, 'NG', 'NGA', 'نيجيريا'),
(14117, 1317667424, 1317667431, 'TD', 'TCD', 'تشاد'),
(14118, 1317667432, 1317667439, 'GH', 'GHA', 'غانا'),
(14119, 1317667440, 1317667447, 'GB', 'GBR', 'المملكة المتحدة'),
(14120, 1317667448, 1317667471, 'NG', 'NGA', 'نيجيريا'),
(14121, 1317667472, 1317667479, 'GB', 'GBR', 'المملكة المتحدة'),
(14122, 1317667480, 1317667487, 'NG', 'NGA', 'نيجيريا'),
(14123, 1317667488, 1317667495, 'GH', 'GHA', 'غانا'),
(14124, 1317667496, 1317667503, 'NG', 'NGA', 'نيجيريا'),
(14125, 1317667504, 1317667527, 'GB', 'GBR', 'المملكة المتحدة'),
(14126, 1317667528, 1317667535, 'AO', 'AGO', 'أنغولا'),
(14127, 1317667536, 1317667543, 'GB', 'GBR', 'المملكة المتحدة'),
(14128, 1317667544, 1317667551, 'AO', 'AGO', 'أنغولا'),
(14129, 1317667552, 1317667567, 'NG', 'NGA', 'نيجيريا'),
(14130, 1317667568, 1317667583, 'GH', 'GHA', 'غانا'),
(14131, 1317667584, 1317667759, 'NG', 'NGA', 'نيجيريا'),
(14132, 1317667760, 1317667767, 'FR', 'FRA', 'فرنسا'),
(14133, 1317667768, 1317667775, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(14134, 1317667776, 1317667783, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14135, 1317667784, 1317667823, 'NG', 'NGA', 'نيجيريا'),
(14136, 1317667824, 1317668095, 'GB', 'GBR', 'المملكة المتحدة'),
(14137, 1317668096, 1317668103, 'GH', 'GHA', 'غانا'),
(14138, 1317668104, 1317668111, 'ZM', 'ZMB', 'زامبيا'),
(14139, 1317668112, 1317668127, 'AO', 'AGO', 'أنغولا'),
(14140, 1317668128, 1317668143, 'GB', 'GBR', 'المملكة المتحدة'),
(14141, 1317668144, 1317668151, 'AO', 'AGO', 'أنغولا'),
(14142, 1317668152, 1317668167, 'NG', 'NGA', 'نيجيريا'),
(14143, 1317668168, 1317668183, 'GB', 'GBR', 'المملكة المتحدة'),
(14144, 1317668184, 1317668191, 'CI', 'CIV', 'كوت ديفوار'),
(14145, 1317668192, 1317668199, 'NG', 'NGA', 'نيجيريا'),
(14146, 1317668200, 1317668207, 'BW', 'BWA', 'بوتسوانا'),
(14147, 1317668208, 1317668215, 'LR', 'LBR', 'ليبيريا'),
(14148, 1317668216, 1317668223, 'CM', 'CMR', 'الكاميرون'),
(14149, 1317668224, 1317668239, 'NG', 'NGA', 'نيجيريا'),
(14150, 1317668240, 1317668247, 'GB', 'GBR', 'المملكة المتحدة'),
(14151, 1317668248, 1317668255, 'NG', 'NGA', 'نيجيريا'),
(14152, 1317668256, 1317668263, 'GB', 'GBR', 'المملكة المتحدة'),
(14153, 1317668264, 1317668271, 'AO', 'AGO', 'أنغولا'),
(14154, 1317668272, 1317668279, 'SL', 'SLE', 'سيراليون'),
(14155, 1317668280, 1317668295, 'GB', 'GBR', 'المملكة المتحدة'),
(14156, 1317668296, 1317668303, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14157, 1317668304, 1317668311, 'NG', 'NGA', 'نيجيريا'),
(14158, 1317668312, 1317668319, 'IQ', 'IRQ', 'العراق'),
(14159, 1317668320, 1317668327, 'GB', 'GBR', 'المملكة المتحدة'),
(14160, 1317668328, 1317668343, 'NG', 'NGA', 'نيجيريا'),
(14161, 1317668344, 1317668351, 'AO', 'AGO', 'أنغولا'),
(14162, 1317668352, 1317668359, 'NG', 'NGA', 'نيجيريا'),
(14163, 1317668360, 1317668367, 'SL', 'SLE', 'سيراليون'),
(14164, 1317668368, 1317668383, 'NG', 'NGA', 'نيجيريا'),
(14165, 1317668384, 1317668391, 'GB', 'GBR', 'المملكة المتحدة'),
(14166, 1317668392, 1317668399, 'NG', 'NGA', 'نيجيريا'),
(14167, 1317668400, 1317668407, 'GB', 'GBR', 'المملكة المتحدة'),
(14168, 1317668408, 1317668415, 'GH', 'GHA', 'غانا'),
(14169, 1317668416, 1317668447, 'NG', 'NGA', 'نيجيريا'),
(14170, 1317668448, 1317668455, 'SL', 'SLE', 'سيراليون'),
(14171, 1317668456, 1317668463, 'NG', 'NGA', 'نيجيريا'),
(14172, 1317668464, 1317668471, 'AO', 'AGO', 'أنغولا'),
(14173, 1317668472, 1317668479, 'NG', 'NGA', 'نيجيريا'),
(14174, 1317668480, 1317668487, 'GH', 'GHA', 'غانا'),
(14175, 1317668488, 1317668495, 'NG', 'NGA', 'نيجيريا'),
(14176, 1317668496, 1317668503, 'GH', 'GHA', 'غانا'),
(14177, 1317668504, 1317668511, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14178, 1317668512, 1317668519, 'IQ', 'IRQ', 'العراق'),
(14179, 1317668520, 1317668527, 'MZ', 'MOZ', 'موزامبيق'),
(14180, 1317668528, 1317668535, 'AO', 'AGO', 'أنغولا'),
(14181, 1317668536, 1317668543, 'BJ', 'BEN', 'بنين'),
(14182, 1317668544, 1317668551, 'UG', 'UGA', 'أوغاندا'),
(14183, 1317668552, 1317668559, 'AO', 'AGO', 'أنغولا'),
(14184, 1317668560, 1317668575, 'NG', 'NGA', 'نيجيريا'),
(14185, 1317668576, 1317668583, 'IQ', 'IRQ', 'العراق'),
(14186, 1317668584, 1317668591, 'LR', 'LBR', 'ليبيريا'),
(14187, 1317668592, 1317668599, 'NG', 'NGA', 'نيجيريا'),
(14188, 1317668600, 1317668615, 'GB', 'GBR', 'المملكة المتحدة'),
(14189, 1317668616, 1317668623, 'NG', 'NGA', 'نيجيريا'),
(14190, 1317668624, 1317668631, 'IQ', 'IRQ', 'العراق'),
(14191, 1317668632, 1317668639, 'GB', 'GBR', 'المملكة المتحدة'),
(14192, 1317668640, 1317668655, 'NG', 'NGA', 'نيجيريا'),
(14193, 1317668656, 1317668671, 'GB', 'GBR', 'المملكة المتحدة'),
(14194, 1317668672, 1317668735, 'NG', 'NGA', 'نيجيريا'),
(14195, 1317668736, 1317668743, 'GB', 'GBR', 'المملكة المتحدة'),
(14196, 1317668744, 1317668751, 'AO', 'AGO', 'أنغولا'),
(14197, 1317668752, 1317668759, 'GB', 'GBR', 'المملكة المتحدة'),
(14198, 1317668760, 1317668767, 'IQ', 'IRQ', 'العراق'),
(14199, 1317668768, 1317668775, 'LR', 'LBR', 'ليبيريا'),
(14200, 1317668776, 1317668791, 'NG', 'NGA', 'نيجيريا'),
(14201, 1317668792, 1317668799, 'GB', 'GBR', 'المملكة المتحدة'),
(14202, 1317668800, 1317668807, 'AO', 'AGO', 'أنغولا'),
(14203, 1317668808, 1317668815, 'NG', 'NGA', 'نيجيريا'),
(14204, 1317668816, 1317668823, 'GB', 'GBR', 'المملكة المتحدة'),
(14205, 1317668824, 1317668831, 'AO', 'AGO', 'أنغولا'),
(14206, 1317668832, 1317668855, 'NG', 'NGA', 'نيجيريا'),
(14207, 1317668856, 1317668863, 'GB', 'GBR', 'المملكة المتحدة'),
(14208, 1317668864, 1317668871, 'LR', 'LBR', 'ليبيريا'),
(14209, 1317668872, 1317668887, 'NG', 'NGA', 'نيجيريا'),
(14210, 1317668888, 1317668895, 'GB', 'GBR', 'المملكة المتحدة'),
(14211, 1317668896, 1317668903, 'NG', 'NGA', 'نيجيريا'),
(14212, 1317668904, 1317668911, 'GB', 'GBR', 'المملكة المتحدة'),
(14213, 1317668912, 1317668927, 'NG', 'NGA', 'نيجيريا'),
(14214, 1317668928, 1317668935, 'GB', 'GBR', 'المملكة المتحدة'),
(14215, 1317668936, 1317668983, 'NG', 'NGA', 'نيجيريا'),
(14216, 1317668984, 1317668991, 'GB', 'GBR', 'المملكة المتحدة'),
(14217, 1317668992, 1317668999, 'NG', 'NGA', 'نيجيريا'),
(14218, 1317669000, 1317669007, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14219, 1317669008, 1317669031, 'NG', 'NGA', 'نيجيريا'),
(14220, 1317669032, 1317669055, 'GB', 'GBR', 'المملكة المتحدة'),
(14221, 1317669056, 1317669103, 'NG', 'NGA', 'نيجيريا'),
(14222, 1317669104, 1317669111, 'GB', 'GBR', 'المملكة المتحدة'),
(14223, 1317669112, 1317669119, 'NG', 'NGA', 'نيجيريا'),
(14224, 1317669120, 1317669375, 'GE', 'GEO', 'جورجيا'),
(14225, 1317669376, 1317669631, 'CG', 'COG', 'الكونغو'),
(14226, 1317669632, 1317669887, 'GB', 'GBR', 'المملكة المتحدة'),
(14227, 1317669888, 1317669895, 'AO', 'AGO', 'أنغولا'),
(14228, 1317669896, 1317669911, 'NG', 'NGA', 'نيجيريا'),
(14229, 1317669912, 1317669919, 'GH', 'GHA', 'غانا'),
(14230, 1317669920, 1317669959, 'NG', 'NGA', 'نيجيريا'),
(14231, 1317669960, 1317669983, 'GB', 'GBR', 'المملكة المتحدة'),
(14232, 1317669984, 1317669991, 'LR', 'LBR', 'ليبيريا'),
(14233, 1317669992, 1317670015, 'NG', 'NGA', 'نيجيريا'),
(14234, 1317670016, 1317670031, 'GB', 'GBR', 'المملكة المتحدة'),
(14235, 1317670032, 1317670103, 'NG', 'NGA', 'نيجيريا'),
(14236, 1317670104, 1317670111, 'GB', 'GBR', 'المملكة المتحدة'),
(14237, 1317670112, 1317670143, 'NG', 'NGA', 'نيجيريا'),
(14238, 1317670144, 1317670175, 'SL', 'SLE', 'سيراليون'),
(14239, 1317670176, 1317670215, 'GB', 'GBR', 'المملكة المتحدة'),
(14240, 1317670216, 1317670223, 'NG', 'NGA', 'نيجيريا'),
(14241, 1317670224, 1317670231, 'AO', 'AGO', 'أنغولا'),
(14242, 1317670232, 1317670239, 'GB', 'GBR', 'المملكة المتحدة'),
(14243, 1317670240, 1317670247, 'NG', 'NGA', 'نيجيريا'),
(14244, 1317670248, 1317670255, 'GB', 'GBR', 'المملكة المتحدة'),
(14245, 1317670256, 1317670263, 'NG', 'NGA', 'نيجيريا'),
(14246, 1317670264, 1317670271, 'GB', 'GBR', 'المملكة المتحدة'),
(14247, 1317670272, 1317670399, 'SD', 'SDN', 'السودان'),
(14248, 1317670400, 1317670415, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14249, 1317670416, 1317670447, 'NG', 'NGA', 'نيجيريا'),
(14250, 1317670448, 1317670455, 'IQ', 'IRQ', 'العراق'),
(14251, 1317670456, 1317670471, 'NG', 'NGA', 'نيجيريا'),
(14252, 1317670472, 1317670479, 'CO', 'COL', 'كولومبيا'),
(14253, 1317670480, 1317670495, 'GB', 'GBR', 'المملكة المتحدة'),
(14254, 1317670496, 1317670503, 'NG', 'NGA', 'نيجيريا'),
(14255, 1317670504, 1317670511, 'GB', 'GBR', 'المملكة المتحدة'),
(14256, 1317670512, 1317670519, 'CI', 'CIV', 'كوت ديفوار'),
(14257, 1317670520, 1317670543, 'NG', 'NGA', 'نيجيريا'),
(14258, 1317670544, 1317670551, 'IQ', 'IRQ', 'العراق'),
(14259, 1317670552, 1317670567, 'NG', 'NGA', 'نيجيريا'),
(14260, 1317670568, 1317670575, 'GB', 'GBR', 'المملكة المتحدة'),
(14261, 1317670576, 1317670583, 'NG', 'NGA', 'نيجيريا'),
(14262, 1317670584, 1317670599, 'GH', 'GHA', 'غانا'),
(14263, 1317670600, 1317670607, 'AO', 'AGO', 'أنغولا'),
(14264, 1317670608, 1317670639, 'NG', 'NGA', 'نيجيريا'),
(14265, 1317670640, 1317670647, 'GB', 'GBR', 'المملكة المتحدة'),
(14266, 1317670648, 1317670655, 'NG', 'NGA', 'نيجيريا'),
(14267, 1317670656, 1317670663, 'AO', 'AGO', 'أنغولا'),
(14268, 1317670664, 1317670671, 'GB', 'GBR', 'المملكة المتحدة'),
(14269, 1317670672, 1317670679, 'CM', 'CMR', 'الكاميرون'),
(14270, 1317670680, 1317670703, 'NG', 'NGA', 'نيجيريا'),
(14271, 1317670704, 1317670711, 'GB', 'GBR', 'المملكة المتحدة'),
(14272, 1317670712, 1317670719, 'GH', 'GHA', 'غانا'),
(14273, 1317670720, 1317670727, 'GB', 'GBR', 'المملكة المتحدة'),
(14274, 1317670728, 1317670735, 'GH', 'GHA', 'غانا'),
(14275, 1317670736, 1317670743, 'AO', 'AGO', 'أنغولا'),
(14276, 1317670744, 1317670751, 'NG', 'NGA', 'نيجيريا'),
(14277, 1317670752, 1317670759, 'GB', 'GBR', 'المملكة المتحدة'),
(14278, 1317670760, 1317670767, 'NG', 'NGA', 'نيجيريا'),
(14279, 1317670768, 1317670775, 'GH', 'GHA', 'غانا'),
(14280, 1317670776, 1317670783, 'GB', 'GBR', 'المملكة المتحدة'),
(14281, 1317670784, 1317670791, 'GH', 'GHA', 'غانا'),
(14282, 1317670792, 1317670807, 'NG', 'NGA', 'نيجيريا'),
(14283, 1317670808, 1317670815, 'AO', 'AGO', 'أنغولا'),
(14284, 1317670816, 1317670823, 'NG', 'NGA', 'نيجيريا'),
(14285, 1317670824, 1317670831, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14286, 1317670832, 1317670839, 'NG', 'NGA', 'نيجيريا'),
(14287, 1317670840, 1317670847, 'GB', 'GBR', 'المملكة المتحدة'),
(14288, 1317670848, 1317670855, 'NG', 'NGA', 'نيجيريا'),
(14289, 1317670856, 1317670863, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14290, 1317670864, 1317670871, 'GB', 'GBR', 'المملكة المتحدة'),
(14291, 1317670872, 1317670887, 'NG', 'NGA', 'نيجيريا'),
(14292, 1317670888, 1317670895, 'AO', 'AGO', 'أنغولا'),
(14293, 1317670896, 1317670896, 'GB', 'GBR', 'المملكة المتحدة'),
(14294, 1317670897, 1317670911, 'NG', 'NGA', 'نيجيريا'),
(14295, 1317670912, 1317671167, 'GB', 'GBR', 'المملكة المتحدة'),
(14296, 1317671168, 1317671175, 'AO', 'AGO', 'أنغولا'),
(14297, 1317671176, 1317671191, 'NG', 'NGA', 'نيجيريا'),
(14298, 1317671192, 1317671199, 'GB', 'GBR', 'المملكة المتحدة'),
(14299, 1317671200, 1317671207, 'CI', 'CIV', 'كوت ديفوار'),
(14300, 1317671208, 1317671231, 'GB', 'GBR', 'المملكة المتحدة'),
(14301, 1317671232, 1317671239, 'NG', 'NGA', 'نيجيريا'),
(14302, 1317671240, 1317671247, 'CI', 'CIV', 'كوت ديفوار'),
(14303, 1317671248, 1317671255, 'NG', 'NGA', 'نيجيريا'),
(14304, 1317671256, 1317671263, 'CI', 'CIV', 'كوت ديفوار'),
(14305, 1317671264, 1317671271, 'NG', 'NGA', 'نيجيريا'),
(14306, 1317671272, 1317671279, 'GB', 'GBR', 'المملكة المتحدة'),
(14307, 1317671280, 1317671335, 'NG', 'NGA', 'نيجيريا'),
(14308, 1317671336, 1317671343, 'BW', 'BWA', 'بوتسوانا'),
(14309, 1317671344, 1317671351, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14310, 1317671352, 1317671359, 'GB', 'GBR', 'المملكة المتحدة'),
(14311, 1317671360, 1317671367, 'NG', 'NGA', 'نيجيريا'),
(14312, 1317671368, 1317671375, 'GB', 'GBR', 'المملكة المتحدة'),
(14313, 1317671376, 1317671383, 'NG', 'NGA', 'نيجيريا'),
(14314, 1317671384, 1317671391, 'CI', 'CIV', 'كوت ديفوار'),
(14315, 1317671392, 1317671399, 'NG', 'NGA', 'نيجيريا'),
(14316, 1317671400, 1317671407, 'IQ', 'IRQ', 'العراق'),
(14317, 1317671408, 1317671423, 'NG', 'NGA', 'نيجيريا'),
(14318, 1317671424, 1317671439, 'GB', 'GBR', 'المملكة المتحدة'),
(14319, 1317671440, 1317671487, 'NG', 'NGA', 'نيجيريا'),
(14320, 1317671488, 1317671511, 'AO', 'AGO', 'أنغولا'),
(14321, 1317671512, 1317671519, 'GB', 'GBR', 'المملكة المتحدة'),
(14322, 1317671520, 1317671527, 'AO', 'AGO', 'أنغولا'),
(14323, 1317671528, 1317671543, 'NG', 'NGA', 'نيجيريا'),
(14324, 1317671544, 1317671551, 'GH', 'GHA', 'غانا'),
(14325, 1317671552, 1317671567, 'NG', 'NGA', 'نيجيريا'),
(14326, 1317671568, 1317671583, 'GB', 'GBR', 'المملكة المتحدة'),
(14327, 1317671584, 1317671591, 'NG', 'NGA', 'نيجيريا'),
(14328, 1317671592, 1317671599, 'GB', 'GBR', 'المملكة المتحدة'),
(14329, 1317671600, 1317671607, 'NG', 'NGA', 'نيجيريا'),
(14330, 1317671608, 1317671615, 'GH', 'GHA', 'غانا'),
(14331, 1317671616, 1317671647, 'GB', 'GBR', 'المملكة المتحدة'),
(14332, 1317671648, 1317671679, 'NG', 'NGA', 'نيجيريا'),
(14333, 1317671680, 1317671687, 'LR', 'LBR', 'ليبيريا'),
(14334, 1317671688, 1317671703, 'GB', 'GBR', 'المملكة المتحدة'),
(14335, 1317671704, 1317671727, 'NG', 'NGA', 'نيجيريا'),
(14336, 1317671728, 1317671735, 'GB', 'GBR', 'المملكة المتحدة'),
(14337, 1317671736, 1317671743, 'NG', 'NGA', 'نيجيريا'),
(14338, 1317671744, 1317671759, 'GB', 'GBR', 'المملكة المتحدة'),
(14339, 1317671760, 1317671767, 'IQ', 'IRQ', 'العراق'),
(14340, 1317671768, 1317671775, 'GB', 'GBR', 'المملكة المتحدة'),
(14341, 1317671776, 1317671807, 'NG', 'NGA', 'نيجيريا'),
(14342, 1317671808, 1317671823, 'CI', 'CIV', 'كوت ديفوار'),
(14343, 1317671824, 1317671831, 'NG', 'NGA', 'نيجيريا'),
(14344, 1317671832, 1317671839, 'GH', 'GHA', 'غانا'),
(14345, 1317671840, 1317671847, 'AO', 'AGO', 'أنغولا'),
(14346, 1317671848, 1317671871, 'NG', 'NGA', 'نيجيريا'),
(14347, 1317671872, 1317671879, 'GB', 'GBR', 'المملكة المتحدة'),
(14348, 1317671880, 1317671895, 'NG', 'NGA', 'نيجيريا'),
(14349, 1317671896, 1317671903, 'CM', 'CMR', 'الكاميرون'),
(14350, 1317671904, 1317671911, 'NG', 'NGA', 'نيجيريا'),
(14351, 1317671912, 1317671919, 'AO', 'AGO', 'أنغولا'),
(14352, 1317671920, 1317671927, 'NG', 'NGA', 'نيجيريا'),
(14353, 1317671928, 1317671935, 'GB', 'GBR', 'المملكة المتحدة'),
(14354, 1317671936, 1317672447, 'GA', 'GAB', 'الغابون'),
(14355, 1317672448, 1317672455, 'NG', 'NGA', 'نيجيريا'),
(14356, 1317672456, 1317672463, 'GB', 'GBR', 'المملكة المتحدة'),
(14357, 1317672464, 1317672471, 'NG', 'NGA', 'نيجيريا'),
(14358, 1317672472, 1317672479, 'GB', 'GBR', 'المملكة المتحدة'),
(14359, 1317672480, 1317672487, 'ZM', 'ZMB', 'زامبيا'),
(14360, 1317672488, 1317672511, 'NG', 'NGA', 'نيجيريا'),
(14361, 1317672512, 1317672519, 'GB', 'GBR', 'المملكة المتحدة'),
(14362, 1317672520, 1317672527, 'NG', 'NGA', 'نيجيريا'),
(14363, 1317672528, 1317672543, 'GB', 'GBR', 'المملكة المتحدة'),
(14364, 1317672544, 1317672551, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14365, 1317672552, 1317672583, 'GB', 'GBR', 'المملكة المتحدة'),
(14366, 1317672584, 1317672591, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14367, 1317672592, 1317672599, 'NG', 'NGA', 'نيجيريا'),
(14368, 1317672600, 1317672607, 'GB', 'GBR', 'المملكة المتحدة'),
(14369, 1317672608, 1317672615, 'CM', 'CMR', 'الكاميرون'),
(14370, 1317672616, 1317672631, 'NG', 'NGA', 'نيجيريا'),
(14371, 1317672632, 1317672639, 'GB', 'GBR', 'المملكة المتحدة'),
(14372, 1317672640, 1317672655, 'NG', 'NGA', 'نيجيريا'),
(14373, 1317672656, 1317672663, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14374, 1317672664, 1317672695, 'NG', 'NGA', 'نيجيريا'),
(14375, 1317672696, 1317672703, 'GB', 'GBR', 'المملكة المتحدة'),
(14376, 1317672704, 1317672711, 'NG', 'NGA', 'نيجيريا'),
(14377, 1317672712, 1317672719, 'GB', 'GBR', 'المملكة المتحدة'),
(14378, 1317672720, 1317672727, 'LR', 'LBR', 'ليبيريا'),
(14379, 1317672728, 1317672735, 'NG', 'NGA', 'نيجيريا'),
(14380, 1317672736, 1317672743, 'LR', 'LBR', 'ليبيريا'),
(14381, 1317672744, 1317672759, 'GB', 'GBR', 'المملكة المتحدة'),
(14382, 1317672760, 1317672767, 'NG', 'NGA', 'نيجيريا'),
(14383, 1317672768, 1317672775, 'GB', 'GBR', 'المملكة المتحدة'),
(14384, 1317672776, 1317672783, 'NG', 'NGA', 'نيجيريا'),
(14385, 1317672784, 1317672791, 'AO', 'AGO', 'أنغولا'),
(14386, 1317672792, 1317672815, 'GB', 'GBR', 'المملكة المتحدة'),
(14387, 1317672816, 1317672823, 'BW', 'BWA', 'بوتسوانا'),
(14388, 1317672824, 1317672831, 'NG', 'NGA', 'نيجيريا'),
(14389, 1317672832, 1317672839, 'GB', 'GBR', 'المملكة المتحدة'),
(14390, 1317672840, 1317672895, 'NG', 'NGA', 'نيجيريا'),
(14391, 1317672896, 1317672903, 'GB', 'GBR', 'المملكة المتحدة'),
(14392, 1317672904, 1317672919, 'CI', 'CIV', 'كوت ديفوار'),
(14393, 1317672920, 1317672927, 'GH', 'GHA', 'غانا'),
(14394, 1317672928, 1317672951, 'NG', 'NGA', 'نيجيريا'),
(14395, 1317672952, 1317672959, 'AO', 'AGO', 'أنغولا'),
(14396, 1317672960, 1317673239, 'NG', 'NGA', 'نيجيريا'),
(14397, 1317673240, 1317673255, 'GB', 'GBR', 'المملكة المتحدة'),
(14398, 1317673256, 1317673287, 'NG', 'NGA', 'نيجيريا'),
(14399, 1317673288, 1317673295, 'LR', 'LBR', 'ليبيريا'),
(14400, 1317673296, 1317673303, 'NG', 'NGA', 'نيجيريا'),
(14401, 1317673304, 1317673311, 'GB', 'GBR', 'المملكة المتحدة'),
(14402, 1317673312, 1317673319, 'NG', 'NGA', 'نيجيريا'),
(14403, 1317673320, 1317673327, 'LR', 'LBR', 'ليبيريا'),
(14404, 1317673328, 1317673335, 'NG', 'NGA', 'نيجيريا'),
(14405, 1317673336, 1317673343, 'GH', 'GHA', 'غانا'),
(14406, 1317673344, 1317673351, 'GB', 'GBR', 'المملكة المتحدة'),
(14407, 1317673352, 1317673375, 'NG', 'NGA', 'نيجيريا'),
(14408, 1317673376, 1317673383, 'AO', 'AGO', 'أنغولا'),
(14409, 1317673384, 1317673415, 'NG', 'NGA', 'نيجيريا'),
(14410, 1317673416, 1317673423, 'GB', 'GBR', 'المملكة المتحدة'),
(14411, 1317673424, 1317673431, 'NG', 'NGA', 'نيجيريا'),
(14412, 1317673432, 1317673439, 'AO', 'AGO', 'أنغولا'),
(14413, 1317673440, 1317673447, 'GB', 'GBR', 'المملكة المتحدة'),
(14414, 1317673448, 1317673463, 'AO', 'AGO', 'أنغولا'),
(14415, 1317673464, 1317673471, 'GB', 'GBR', 'المملكة المتحدة'),
(14416, 1317673472, 1317673479, 'NG', 'NGA', 'نيجيريا'),
(14417, 1317673480, 1317673487, 'GB', 'GBR', 'المملكة المتحدة'),
(14418, 1317673488, 1317673495, 'HK', 'HKG', 'هونغ كونغ'),
(14419, 1317673496, 1317673527, 'NG', 'NGA', 'نيجيريا'),
(14420, 1317673528, 1317673535, 'GB', 'GBR', 'المملكة المتحدة'),
(14421, 1317673536, 1317673575, 'NG', 'NGA', 'نيجيريا'),
(14422, 1317673576, 1317673583, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14423, 1317673584, 1317673591, 'GB', 'GBR', 'المملكة المتحدة'),
(14424, 1317673592, 1317673615, 'NG', 'NGA', 'نيجيريا'),
(14425, 1317673616, 1317673623, 'GB', 'GBR', 'المملكة المتحدة'),
(14426, 1317673624, 1317673631, 'NG', 'NGA', 'نيجيريا'),
(14427, 1317673632, 1317673639, 'GB', 'GBR', 'المملكة المتحدة'),
(14428, 1317673640, 1317673647, 'AO', 'AGO', 'أنغولا'),
(14429, 1317673648, 1317673671, 'NG', 'NGA', 'نيجيريا'),
(14430, 1317673672, 1317673679, 'CM', 'CMR', 'الكاميرون'),
(14431, 1317673680, 1317673687, 'IQ', 'IRQ', 'العراق'),
(14432, 1317673688, 1317673711, 'NG', 'NGA', 'نيجيريا'),
(14433, 1317673712, 1317673719, 'CO', 'COL', 'كولومبيا'),
(14434, 1317673720, 1317673727, 'NG', 'NGA', 'نيجيريا'),
(14435, 1317673728, 1317673743, 'AO', 'AGO', 'أنغولا'),
(14436, 1317673744, 1317673751, 'IQ', 'IRQ', 'العراق'),
(14437, 1317673752, 1317673759, 'GB', 'GBR', 'المملكة المتحدة'),
(14438, 1317673760, 1317673767, 'NG', 'NGA', 'نيجيريا'),
(14439, 1317673768, 1317673775, 'AO', 'AGO', 'أنغولا'),
(14440, 1317673776, 1317673783, 'NG', 'NGA', 'نيجيريا'),
(14441, 1317673784, 1317673791, 'AO', 'AGO', 'أنغولا'),
(14442, 1317673792, 1317673799, 'NG', 'NGA', 'نيجيريا'),
(14443, 1317673800, 1317673807, 'GB', 'GBR', 'المملكة المتحدة'),
(14444, 1317673808, 1317673815, 'NG', 'NGA', 'نيجيريا'),
(14445, 1317673816, 1317673823, 'LR', 'LBR', 'ليبيريا'),
(14446, 1317673824, 1317673831, 'NG', 'NGA', 'نيجيريا'),
(14447, 1317673832, 1317673839, 'AO', 'AGO', 'أنغولا'),
(14448, 1317673840, 1317673847, 'NG', 'NGA', 'نيجيريا'),
(14449, 1317673848, 1317673855, 'GB', 'GBR', 'المملكة المتحدة'),
(14450, 1317673856, 1317673871, 'NG', 'NGA', 'نيجيريا'),
(14451, 1317673872, 1317673895, 'GB', 'GBR', 'المملكة المتحدة'),
(14452, 1317673896, 1317673911, 'NG', 'NGA', 'نيجيريا'),
(14453, 1317673912, 1317673919, 'AO', 'AGO', 'أنغولا'),
(14454, 1317673920, 1317673927, 'CI', 'CIV', 'كوت ديفوار'),
(14455, 1317673928, 1317673943, 'NG', 'NGA', 'نيجيريا'),
(14456, 1317673944, 1317673951, 'AO', 'AGO', 'أنغولا'),
(14457, 1317673952, 1317673967, 'NG', 'NGA', 'نيجيريا'),
(14458, 1317673968, 1317673975, 'GB', 'GBR', 'المملكة المتحدة'),
(14459, 1317673976, 1317674239, 'NG', 'NGA', 'نيجيريا'),
(14460, 1317674240, 1317674247, 'GB', 'GBR', 'المملكة المتحدة'),
(14461, 1317674248, 1317674255, 'NG', 'NGA', 'نيجيريا'),
(14462, 1317674256, 1317674263, 'CM', 'CMR', 'الكاميرون'),
(14463, 1317674264, 1317674271, 'AO', 'AGO', 'أنغولا'),
(14464, 1317674272, 1317674279, 'NG', 'NGA', 'نيجيريا'),
(14465, 1317674280, 1317674287, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14466, 1317674288, 1317674295, 'GH', 'GHA', 'غانا'),
(14467, 1317674296, 1317674303, 'AO', 'AGO', 'أنغولا'),
(14468, 1317674304, 1317674319, 'NG', 'NGA', 'نيجيريا'),
(14469, 1317674320, 1317674351, 'GB', 'GBR', 'المملكة المتحدة'),
(14470, 1317674352, 1317674359, 'NG', 'NGA', 'نيجيريا'),
(14471, 1317674360, 1317674367, 'AO', 'AGO', 'أنغولا'),
(14472, 1317674368, 1317674375, 'NG', 'NGA', 'نيجيريا'),
(14473, 1317674376, 1317674383, 'GB', 'GBR', 'المملكة المتحدة'),
(14474, 1317674384, 1317674399, 'NG', 'NGA', 'نيجيريا'),
(14475, 1317674400, 1317674407, 'GB', 'GBR', 'المملكة المتحدة'),
(14476, 1317674408, 1317674415, 'NG', 'NGA', 'نيجيريا'),
(14477, 1317674416, 1317674423, 'AO', 'AGO', 'أنغولا'),
(14478, 1317674424, 1317674431, 'NG', 'NGA', 'نيجيريا'),
(14479, 1317674432, 1317674440, 'AO', 'AGO', 'أنغولا'),
(14480, 1317674441, 1317674447, 'GB', 'GBR', 'المملكة المتحدة'),
(14481, 1317674448, 1317674455, 'AO', 'AGO', 'أنغولا'),
(14482, 1317674456, 1317674471, 'NG', 'NGA', 'نيجيريا'),
(14483, 1317674472, 1317674479, 'GB', 'GBR', 'المملكة المتحدة'),
(14484, 1317674480, 1317674487, 'AO', 'AGO', 'أنغولا'),
(14485, 1317674488, 1317674495, 'NG', 'NGA', 'نيجيريا'),
(14486, 1317674496, 1317674503, 'GB', 'GBR', 'المملكة المتحدة'),
(14487, 1317674504, 1317674511, 'AO', 'AGO', 'أنغولا'),
(14488, 1317674512, 1317674519, 'NG', 'NGA', 'نيجيريا'),
(14489, 1317674520, 1317674527, 'GB', 'GBR', 'المملكة المتحدة'),
(14490, 1317674528, 1317674535, 'NG', 'NGA', 'نيجيريا'),
(14491, 1317674536, 1317674543, 'IQ', 'IRQ', 'العراق'),
(14492, 1317674544, 1317674599, 'NG', 'NGA', 'نيجيريا'),
(14493, 1317674600, 1317674607, 'GB', 'GBR', 'المملكة المتحدة'),
(14494, 1317674608, 1317674615, 'NG', 'NGA', 'نيجيريا'),
(14495, 1317674616, 1317674623, 'IQ', 'IRQ', 'العراق'),
(14496, 1317674624, 1317674631, 'NG', 'NGA', 'نيجيريا'),
(14497, 1317674632, 1317674639, 'GB', 'GBR', 'المملكة المتحدة'),
(14498, 1317674640, 1317674647, 'NG', 'NGA', 'نيجيريا'),
(14499, 1317674648, 1317674655, 'GB', 'GBR', 'المملكة المتحدة'),
(14500, 1317674656, 1317674671, 'NG', 'NGA', 'نيجيريا'),
(14501, 1317674672, 1317674679, 'GB', 'GBR', 'المملكة المتحدة'),
(14502, 1317674680, 1317674687, 'AO', 'AGO', 'أنغولا'),
(14503, 1317674688, 1317674735, 'NG', 'NGA', 'نيجيريا'),
(14504, 1317674736, 1317674743, 'AO', 'AGO', 'أنغولا'),
(14505, 1317674744, 1317674751, 'IQ', 'IRQ', 'العراق'),
(14506, 1317674752, 1317674791, 'NG', 'NGA', 'نيجيريا'),
(14507, 1317674792, 1317674799, 'GB', 'GBR', 'المملكة المتحدة'),
(14508, 1317674800, 1317674807, 'NG', 'NGA', 'نيجيريا'),
(14509, 1317674808, 1317674823, 'GB', 'GBR', 'المملكة المتحدة'),
(14510, 1317674824, 1317674871, 'NG', 'NGA', 'نيجيريا'),
(14511, 1317674872, 1317674879, 'GB', 'GBR', 'المملكة المتحدة'),
(14512, 1317674880, 1317674887, 'NG', 'NGA', 'نيجيريا'),
(14513, 1317674888, 1317674911, 'AO', 'AGO', 'أنغولا'),
(14514, 1317674912, 1317674927, 'NG', 'NGA', 'نيجيريا'),
(14515, 1317674928, 1317674935, 'AO', 'AGO', 'أنغولا'),
(14516, 1317674936, 1317674943, 'NG', 'NGA', 'نيجيريا'),
(14517, 1317674944, 1317674951, 'GA', 'GAB', 'الغابون'),
(14518, 1317674952, 1317674959, 'NG', 'NGA', 'نيجيريا'),
(14519, 1317674960, 1317674967, 'GH', 'GHA', 'غانا'),
(14520, 1317674968, 1317674975, 'NG', 'NGA', 'نيجيريا'),
(14521, 1317674976, 1317674991, 'GB', 'GBR', 'المملكة المتحدة'),
(14522, 1317674992, 1317675007, 'NG', 'NGA', 'نيجيريا'),
(14523, 1317675008, 1317675023, 'GB', 'GBR', 'المملكة المتحدة'),
(14524, 1317675024, 1317675047, 'NG', 'NGA', 'نيجيريا'),
(14525, 1317675048, 1317675055, 'GB', 'GBR', 'المملكة المتحدة'),
(14526, 1317675056, 1317675063, 'NG', 'NGA', 'نيجيريا'),
(14527, 1317675064, 1317675071, 'AO', 'AGO', 'أنغولا'),
(14528, 1317675072, 1317675095, 'NG', 'NGA', 'نيجيريا'),
(14529, 1317675096, 1317675111, 'GB', 'GBR', 'المملكة المتحدة'),
(14530, 1317675112, 1317675127, 'NG', 'NGA', 'نيجيريا'),
(14531, 1317675128, 1317675135, 'HK', 'HKG', 'هونغ كونغ'),
(14532, 1317675136, 1317675143, 'NG', 'NGA', 'نيجيريا'),
(14533, 1317675144, 1317675159, 'GB', 'GBR', 'المملكة المتحدة'),
(14534, 1317675160, 1317675167, 'AO', 'AGO', 'أنغولا'),
(14535, 1317675168, 1317675175, 'NG', 'NGA', 'نيجيريا'),
(14536, 1317675176, 1317675183, 'GB', 'GBR', 'المملكة المتحدة'),
(14537, 1317675184, 1317675199, 'CM', 'CMR', 'الكاميرون'),
(14538, 1317675200, 1317675231, 'NG', 'NGA', 'نيجيريا'),
(14539, 1317675232, 1317675239, 'LR', 'LBR', 'ليبيريا'),
(14540, 1317675240, 1317675255, 'AO', 'AGO', 'أنغولا'),
(14541, 1317675256, 1317675263, 'GB', 'GBR', 'المملكة المتحدة'),
(14542, 1317675264, 1317675279, 'NG', 'NGA', 'نيجيريا'),
(14543, 1317675280, 1317675287, 'CM', 'CMR', 'الكاميرون'),
(14544, 1317675288, 1317675319, 'NG', 'NGA', 'نيجيريا'),
(14545, 1317675320, 1317675343, 'CM', 'CMR', 'الكاميرون'),
(14546, 1317675344, 1317675351, 'AO', 'AGO', 'أنغولا'),
(14547, 1317675352, 1317675359, 'IQ', 'IRQ', 'العراق'),
(14548, 1317675360, 1317675375, 'NG', 'NGA', 'نيجيريا'),
(14549, 1317675376, 1317675383, 'CM', 'CMR', 'الكاميرون'),
(14550, 1317675384, 1317675391, 'NG', 'NGA', 'نيجيريا'),
(14551, 1317675392, 1317675407, 'GB', 'GBR', 'المملكة المتحدة'),
(14552, 1317675408, 1317675415, 'NG', 'NGA', 'نيجيريا'),
(14553, 1317675416, 1317675423, 'GB', 'GBR', 'المملكة المتحدة'),
(14554, 1317675424, 1317675439, 'NG', 'NGA', 'نيجيريا'),
(14555, 1317675440, 1317675447, 'GB', 'GBR', 'المملكة المتحدة'),
(14556, 1317675448, 1317675455, 'NG', 'NGA', 'نيجيريا'),
(14557, 1317675456, 1317675463, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14558, 1317675464, 1317675471, 'CI', 'CIV', 'كوت ديفوار'),
(14559, 1317675472, 1317675479, 'GB', 'GBR', 'المملكة المتحدة'),
(14560, 1317675480, 1317675511, 'NG', 'NGA', 'نيجيريا'),
(14561, 1317675512, 1317675519, 'GB', 'GBR', 'المملكة المتحدة'),
(14562, 1317675520, 1317675527, 'NG', 'NGA', 'نيجيريا'),
(14563, 1317675528, 1317675535, 'AO', 'AGO', 'أنغولا'),
(14564, 1317675536, 1317675543, 'NG', 'NGA', 'نيجيريا'),
(14565, 1317675544, 1317675551, 'IQ', 'IRQ', 'العراق'),
(14566, 1317675552, 1317675559, 'NG', 'NGA', 'نيجيريا'),
(14567, 1317675560, 1317675567, 'NA', 'NAM', 'ناميبيا'),
(14568, 1317675568, 1317675575, 'AO', 'AGO', 'أنغولا'),
(14569, 1317675576, 1317675583, 'GB', 'GBR', 'المملكة المتحدة'),
(14570, 1317675584, 1317675591, 'LR', 'LBR', 'ليبيريا'),
(14571, 1317675592, 1317675607, 'NG', 'NGA', 'نيجيريا'),
(14572, 1317675608, 1317675615, 'GB', 'GBR', 'المملكة المتحدة'),
(14573, 1317675616, 1317675639, 'NG', 'NGA', 'نيجيريا'),
(14574, 1317675640, 1317675647, 'FR', 'FRA', 'فرنسا'),
(14575, 1317675648, 1317675655, 'LR', 'LBR', 'ليبيريا'),
(14576, 1317675656, 1317675663, 'NG', 'NGA', 'نيجيريا'),
(14577, 1317675664, 1317675671, 'GB', 'GBR', 'المملكة المتحدة'),
(14578, 1317675672, 1317675687, 'NG', 'NGA', 'نيجيريا'),
(14579, 1317675688, 1317675695, 'CM', 'CMR', 'الكاميرون'),
(14580, 1317675696, 1317675703, 'NG', 'NGA', 'نيجيريا'),
(14581, 1317675704, 1317675711, 'GB', 'GBR', 'المملكة المتحدة'),
(14582, 1317675712, 1317675719, 'CM', 'CMR', 'الكاميرون'),
(14583, 1317675720, 1317675735, 'NG', 'NGA', 'نيجيريا'),
(14584, 1317675736, 1317675743, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(14585, 1317675744, 1317675751, 'GH', 'GHA', 'غانا'),
(14586, 1317675752, 1317675759, 'NG', 'NGA', 'نيجيريا'),
(14587, 1317675760, 1317675775, 'GH', 'GHA', 'غانا'),
(14588, 1317675776, 1317675783, 'NG', 'NGA', 'نيجيريا'),
(14589, 1317675784, 1317675815, 'GB', 'GBR', 'المملكة المتحدة'),
(14590, 1317675816, 1317675831, 'NG', 'NGA', 'نيجيريا'),
(14591, 1317675832, 1317675855, 'GB', 'GBR', 'المملكة المتحدة'),
(14592, 1317675856, 1317675863, 'CM', 'CMR', 'الكاميرون'),
(14593, 1317675864, 1317675903, 'GB', 'GBR', 'المملكة المتحدة'),
(14594, 1317675904, 1317675911, 'GN', 'GIN', 'غينيا'),
(14595, 1317675912, 1317675919, 'GB', 'GBR', 'المملكة المتحدة'),
(14596, 1317675920, 1317675927, 'NG', 'NGA', 'نيجيريا'),
(14597, 1317675928, 1317675935, 'GB', 'GBR', 'المملكة المتحدة'),
(14598, 1317675936, 1317675943, 'NG', 'NGA', 'نيجيريا'),
(14599, 1317675944, 1317676287, 'GB', 'GBR', 'المملكة المتحدة'),
(14600, 1317676288, 1317676543, 'LR', 'LBR', 'ليبيريا'),
(14601, 1317676544, 1317676807, 'GB', 'GBR', 'المملكة المتحدة'),
(14602, 1317676808, 1317676815, 'NG', 'NGA', 'نيجيريا'),
(14603, 1317676816, 1317676823, 'GB', 'GBR', 'المملكة المتحدة'),
(14604, 1317676824, 1317676831, 'NG', 'NGA', 'نيجيريا'),
(14605, 1317676832, 1317676847, 'GB', 'GBR', 'المملكة المتحدة'),
(14606, 1317676848, 1317676855, 'NG', 'NGA', 'نيجيريا'),
(14607, 1317676856, 1317676895, 'GB', 'GBR', 'المملكة المتحدة'),
(14608, 1317676896, 1317676935, 'NG', 'NGA', 'نيجيريا'),
(14609, 1317676936, 1317676991, 'GB', 'GBR', 'المملكة المتحدة'),
(14610, 1317676992, 1317676999, 'LR', 'LBR', 'ليبيريا'),
(14611, 1317677000, 1317677007, 'IQ', 'IRQ', 'العراق'),
(14612, 1317677008, 1317677015, 'IT', 'ITA', 'إيطاليا'),
(14613, 1317677016, 1317683199, 'GB', 'GBR', 'المملكة المتحدة'),
(14614, 1317683200, 1317683839, 'DE', 'DEU', 'ألمانيا'),
(14615, 1317683840, 1317683855, 'CH', 'CHE', 'سويسرا'),
(14616, 1317683856, 1317683863, 'DE', 'DEU', 'ألمانيا'),
(14617, 1317683864, 1317683871, 'FR', 'FRA', 'فرنسا'),
(14618, 1317683872, 1317685503, 'DE', 'DEU', 'ألمانيا'),
(14619, 1317685504, 1317685631, 'BE', 'BEL', 'بلجيكا'),
(14620, 1317685632, 1317686271, 'DE', 'DEU', 'ألمانيا'),
(14621, 1317686272, 1317686287, 'NL', 'NLD', 'هولندا'),
(14622, 1317686288, 1317686303, 'DE', 'DEU', 'ألمانيا'),
(14623, 1317686304, 1317686319, 'NL', 'NLD', 'هولندا'),
(14624, 1317686320, 1317695743, 'DE', 'DEU', 'ألمانيا'),
(14625, 1317695744, 1317695999, 'CH', 'CHE', 'سويسرا'),
(14626, 1317696000, 1317699583, 'DE', 'DEU', 'ألمانيا'),
(14627, 1317699584, 1317715967, 'RU', 'RUS', 'الإتحاد الروسي'),
(14628, 1317715968, 1317732351, 'SA', 'SAU', 'السعودية'),
(14629, 1317732352, 1317748735, 'HU', 'HUN', 'هنغاريا'),
(14630, 1317748736, 1317765119, 'RU', 'RUS', 'الإتحاد الروسي'),
(14631, 1317765120, 1317781503, 'GE', 'GEO', 'جورجيا'),
(14632, 1317781504, 1317814271, 'RU', 'RUS', 'الإتحاد الروسي'),
(14633, 1317814272, 1317830655, 'DE', 'DEU', 'ألمانيا'),
(14634, 1317830656, 1317832191, 'NL', 'NLD', 'هولندا'),
(14635, 1317832192, 1317832447, 'GB', 'GBR', 'المملكة المتحدة'),
(14636, 1317832448, 1317832511, 'CY', 'CYP', 'قبرص'),
(14637, 1317832512, 1317832959, 'NL', 'NLD', 'هولندا'),
(14638, 1317832960, 1317833215, 'IT', 'ITA', 'إيطاليا'),
(14639, 1317833216, 1317835615, 'NL', 'NLD', 'هولندا'),
(14640, 1317835616, 1317835647, 'RU', 'RUS', 'الإتحاد الروسي'),
(14641, 1317835648, 1317836863, 'NL', 'NLD', 'هولندا'),
(14642, 1317836864, 1317836927, 'CY', 'CYP', 'قبرص'),
(14643, 1317836928, 1317839359, 'NL', 'NLD', 'هولندا'),
(14644, 1317839360, 1317839615, 'BZ', 'BLZ', 'بليز'),
(14645, 1317839616, 1317841407, 'NL', 'NLD', 'هولندا'),
(14646, 1317841408, 1317841439, 'SC', 'SYC', 'سيشيل'),
(14647, 1317841440, 1317841727, 'NL', 'NLD', 'هولندا'),
(14648, 1317841728, 1317841855, 'CY', 'CYP', 'قبرص'),
(14649, 1317841856, 1317847039, 'NL', 'NLD', 'هولندا'),
(14650, 1317847040, 1317863423, 'RU', 'RUS', 'الإتحاد الروسي'),
(14651, 1317863424, 1317879807, 'GB', 'GBR', 'المملكة المتحدة'),
(14652, 1317879808, 1317896191, 'SK', 'SVK', 'سلوفاكيا'),
(14653, 1317896192, 1317912575, 'LU', 'LUX', 'لوكسيمبورغ'),
(14654, 1317912576, 1317920767, 'GB', 'GBR', 'المملكة المتحدة'),
(14655, 1317920768, 1317928959, 'ES', 'ESP', 'إسبانيا'),
(14656, 1317928960, 1317945343, 'BG', 'BGR', 'بلغاريا'),
(14657, 1317945344, 1317965047, 'AT', 'AUT', 'النمسا'),
(14658, 1317965048, 1317965055, 'DE', 'DEU', 'ألمانيا'),
(14659, 1317965056, 1317978111, 'AT', 'AUT', 'النمسا'),
(14660, 1317978112, 1317994495, 'RU', 'RUS', 'الإتحاد الروسي'),
(14661, 1317994496, 1318000383, 'DE', 'DEU', 'ألمانيا'),
(14662, 1318000384, 1318000447, 'NL', 'NLD', 'هولندا'),
(14663, 1318000448, 1318002175, 'DE', 'DEU', 'ألمانيا'),
(14664, 1318002176, 1318002431, 'NL', 'NLD', 'هولندا'),
(14665, 1318002432, 1318005631, 'DE', 'DEU', 'ألمانيا'),
(14666, 1318005632, 1318005759, 'NL', 'NLD', 'هولندا'),
(14667, 1318005760, 1318006271, 'DE', 'DEU', 'ألمانيا'),
(14668, 1318006272, 1318006783, 'NL', 'NLD', 'هولندا'),
(14669, 1318006784, 1318010879, 'DE', 'DEU', 'ألمانيا'),
(14670, 1318010880, 1318027263, 'DK', 'DNK', 'الدنيمارك'),
(14671, 1318027264, 1318043647, 'IE', 'IRL', 'إيرلندا'),
(14672, 1318043648, 1318584319, 'GB', 'GBR', 'المملكة المتحدة'),
(14673, 1318584320, 1318592511, 'PL', 'POL', 'بولندا'),
(14674, 1318592512, 1318599935, 'NL', 'NLD', 'هولندا'),
(14675, 1318599936, 1318600191, 'DE', 'DEU', 'ألمانيا'),
(14676, 1318600192, 1318600703, 'NL', 'NLD', 'هولندا'),
(14677, 1318600704, 1318608895, 'AT', 'AUT', 'النمسا'),
(14678, 1318608896, 1318617087, 'IT', 'ITA', 'إيطاليا'),
(14679, 1318617088, 1318625279, 'FR', 'FRA', 'فرنسا'),
(14680, 1318625280, 1318633471, 'UA', 'UKR', 'أوكرانيا'),
(14681, 1318633472, 1318649855, 'IE', 'IRL', 'إيرلندا'),
(14682, 1318649856, 1318658047, 'RU', 'RUS', 'الإتحاد الروسي'),
(14683, 1318658048, 1318666239, 'SI', 'SVN', 'سلوفينيا'),
(14684, 1318666240, 1318674431, 'DE', 'DEU', 'ألمانيا'),
(14685, 1318674432, 1318682623, 'HU', 'HUN', 'هنغاريا'),
(14686, 1318682624, 1318690815, 'RU', 'RUS', 'الإتحاد الروسي'),
(14687, 1318690816, 1318699007, 'DK', 'DNK', 'الدنيمارك'),
(14688, 1318699008, 1318702303, 'IE', 'IRL', 'إيرلندا'),
(14689, 1318702304, 1318702335, 'US', 'USA', 'الولايات المتحدة'),
(14690, 1318702336, 1318707199, 'IE', 'IRL', 'إيرلندا'),
(14691, 1318707200, 1318708511, 'FR', 'FRA', 'فرنسا'),
(14692, 1318708512, 1318708527, 'SE', 'SWE', 'السويد'),
(14693, 1318708528, 1318708543, 'FR', 'FRA', 'فرنسا'),
(14694, 1318708544, 1318708547, 'SE', 'SWE', 'السويد'),
(14695, 1318708548, 1318708559, 'FR', 'FRA', 'فرنسا'),
(14696, 1318708560, 1318708991, 'SE', 'SWE', 'السويد'),
(14697, 1318708992, 1318711647, 'FR', 'FRA', 'فرنسا'),
(14698, 1318711648, 1318711663, 'IT', 'ITA', 'إيطاليا'),
(14699, 1318711664, 1318712287, 'FR', 'FRA', 'فرنسا'),
(14700, 1318712288, 1318712319, 'SE', 'SWE', 'السويد'),
(14701, 1318712320, 1318712991, 'FR', 'FRA', 'فرنسا'),
(14702, 1318712992, 1318713023, 'SE', 'SWE', 'السويد'),
(14703, 1318713024, 1318713855, 'FR', 'FRA', 'فرنسا'),
(14704, 1318713856, 1318714111, 'CH', 'CHE', 'سويسرا'),
(14705, 1318714112, 1318715390, 'FR', 'FRA', 'فرنسا'),
(14706, 1318715392, 1318723583, 'BG', 'BGR', 'بلغاريا'),
(14707, 1318723584, 1318731775, 'IR', 'IRN', 'إيران'),
(14708, 1318731776, 1318739967, 'PL', 'POL', 'بولندا'),
(14709, 1318739968, 1318748159, 'GB', 'GBR', 'المملكة المتحدة'),
(14710, 1318748160, 1318756351, 'LV', 'LVA', 'لاتفيا'),
(14711, 1318756352, 1318764543, 'UA', 'UKR', 'أوكرانيا'),
(14712, 1318764544, 1318780927, 'KW', 'KWT', 'الكويت'),
(14713, 1318780928, 1318789119, 'CH', 'CHE', 'سويسرا'),
(14714, 1318789120, 1318797311, 'ME', 'MNE', 'الجبل الأسود'),
(14715, 1318797312, 1318805503, 'SY', 'SYR', 'سوريا'),
(14716, 1318805504, 1318813695, 'PL', 'POL', 'بولندا'),
(14717, 1318813696, 1318821887, 'FR', 'FRA', 'فرنسا'),
(14718, 1318821888, 1318838271, 'RU', 'RUS', 'الإتحاد الروسي'),
(14719, 1318838272, 1318846463, 'GB', 'GBR', 'المملكة المتحدة'),
(14720, 1318846464, 1318854655, 'NO', 'NOR', 'النرويج'),
(14721, 1318854656, 1318862847, 'CZ', 'CZE', 'التشيك'),
(14722, 1318862848, 1318871039, 'GB', 'GBR', 'المملكة المتحدة'),
(14723, 1318871040, 1318879231, 'DK', 'DNK', 'الدنيمارك'),
(14724, 1318879232, 1318887423, 'CZ', 'CZE', 'التشيك'),
(14725, 1318887424, 1318895615, 'PL', 'POL', 'بولندا'),
(14726, 1318895616, 1318899711, 'SE', 'SWE', 'السويد'),
(14727, 1318899712, 1318903807, 'DK', 'DNK', 'الدنيمارك'),
(14728, 1318903808, 1318911999, 'RU', 'RUS', 'الإتحاد الروسي'),
(14729, 1318912000, 1318920191, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(14730, 1318920192, 1318928383, 'IR', 'IRN', 'إيران'),
(14731, 1318928384, 1318936575, 'LT', 'LTU', 'ليتوانيا'),
(14732, 1318936576, 1318944767, 'DK', 'DNK', 'الدنيمارك'),
(14733, 1318952960, 1318956287, 'CZ', 'CZE', 'التشيك'),
(14734, 1318956288, 1318957055, 'PL', 'POL', 'بولندا'),
(14735, 1318957056, 1318958847, 'CZ', 'CZE', 'التشيك'),
(14736, 1318958848, 1318961151, 'PL', 'POL', 'بولندا'),
(14737, 1318961152, 1318969343, 'NL', 'NLD', 'هولندا'),
(14738, 1318969344, 1318977535, 'RU', 'RUS', 'الإتحاد الروسي'),
(14739, 1318977536, 1318985727, 'LT', 'LTU', 'ليتوانيا'),
(14740, 1318985728, 1319001087, 'GB', 'GBR', 'المملكة المتحدة'),
(14741, 1319001088, 1319002111, 'US', 'USA', 'الولايات المتحدة'),
(14742, 1319002112, 1319010303, 'IE', 'IRL', 'إيرلندا'),
(14743, 1319010304, 1319017215, 'CY', 'CYP', 'قبرص'),
(14744, 1319017216, 1319017279, 'DE', 'DEU', 'ألمانيا'),
(14745, 1319017280, 1319017295, 'CY', 'CYP', 'قبرص'),
(14746, 1319017296, 1319017303, 'DE', 'DEU', 'ألمانيا'),
(14747, 1319017304, 1319018495, 'CY', 'CYP', 'قبرص'),
(14748, 1319018496, 1319026687, 'IR', 'IRN', 'إيران'),
(14749, 1319026688, 1319034879, 'RU', 'RUS', 'الإتحاد الروسي'),
(14750, 1319034880, 1319035903, 'NO', 'NOR', 'النرويج'),
(14751, 1319035904, 1319036927, 'DK', 'DNK', 'الدنيمارك'),
(14752, 1319036928, 1319038975, 'SE', 'SWE', 'السويد'),
(14753, 1319038976, 1319043071, 'NO', 'NOR', 'النرويج'),
(14754, 1319043072, 1319051263, 'FR', 'FRA', 'فرنسا'),
(14755, 1319051264, 1319059455, 'UA', 'UKR', 'أوكرانيا'),
(14756, 1319059456, 1319067647, 'PL', 'POL', 'بولندا'),
(14757, 1319067648, 1319069776, 'DE', 'DEU', 'ألمانيا'),
(14758, 1319069777, 1319069823, 'CN', 'CHN', 'الصين'),
(14759, 1319069824, 1319070217, 'DE', 'DEU', 'ألمانيا'),
(14760, 1319070218, 1319070254, 'CN', 'CHN', 'الصين'),
(14761, 1319070255, 1319070271, 'GB', 'GBR', 'المملكة المتحدة'),
(14762, 1319070272, 1319070335, 'PT', 'PRT', 'البورتوغال'),
(14763, 1319070336, 1319070463, 'RU', 'RUS', 'الإتحاد الروسي'),
(14764, 1319070464, 1319070975, 'DE', 'DEU', 'ألمانيا'),
(14765, 1319070976, 1319071103, 'PL', 'POL', 'بولندا'),
(14766, 1319071104, 1319071231, 'RU', 'RUS', 'الإتحاد الروسي'),
(14767, 1319071232, 1319071487, 'PL', 'POL', 'بولندا'),
(14768, 1319071488, 1319072767, 'DE', 'DEU', 'ألمانيا'),
(14769, 1319072768, 1319073023, 'IT', 'ITA', 'إيطاليا'),
(14770, 1319073024, 1319073279, 'TR', 'TUR', 'تركيا'),
(14771, 1319073280, 1319074303, 'DE', 'DEU', 'ألمانيا'),
(14772, 1319074304, 1319074559, 'HK', 'HKG', 'هونغ كونغ'),
(14773, 1319074560, 1319074815, 'DE', 'DEU', 'ألمانيا'),
(14774, 1319074816, 1319074943, 'PL', 'POL', 'بولندا'),
(14775, 1319074944, 1319075071, 'RU', 'RUS', 'الإتحاد الروسي'),
(14776, 1319075072, 1319075199, 'PL', 'POL', 'بولندا'),
(14777, 1319075200, 1319075327, 'RU', 'RUS', 'الإتحاد الروسي'),
(14778, 1319075328, 1319075455, 'DE', 'DEU', 'ألمانيا'),
(14779, 1319075456, 1319075583, 'RU', 'RUS', 'الإتحاد الروسي'),
(14780, 1319075584, 1319075664, 'DE', 'DEU', 'ألمانيا'),
(14781, 1319075665, 1319075711, 'CN', 'CHN', 'الصين'),
(14782, 1319075712, 1319075839, 'RU', 'RUS', 'الإتحاد الروسي'),
(14783, 1319075840, 1319084031, 'BG', 'BGR', 'بلغاريا'),
(14784, 1319084032, 1319092223, 'KW', 'KWT', 'الكويت'),
(14785, 1319092224, 1319100415, 'IT', 'ITA', 'إيطاليا'),
(14786, 1319100416, 1319108607, 'RU', 'RUS', 'الإتحاد الروسي'),
(14787, 1319108608, 1321205759, 'TR', 'TUR', 'تركيا'),
(14788, 1321205760, 1325400063, 'FR', 'FRA', 'فرنسا'),
(14789, 1325400064, 1329594367, 'IT', 'ITA', 'إيطاليا'),
(14790, 1329594368, 1330642943, 'GB', 'GBR', 'المملكة المتحدة'),
(14791, 1330642944, 1331691519, 'FR', 'FRA', 'فرنسا'),
(14792, 1331691520, 1331757055, 'PL', 'POL', 'بولندا'),
(14793, 1331757056, 1331822591, 'IE', 'IRL', 'إيرلندا'),
(14794, 1331822592, 1331824639, 'IT', 'ITA', 'إيطاليا'),
(14795, 1331824640, 1331826687, 'RU', 'RUS', 'الإتحاد الروسي'),
(14796, 1331826688, 1331828735, 'FR', 'FRA', 'فرنسا'),
(14797, 1331828736, 1331830783, 'LT', 'LTU', 'ليتوانيا'),
(14798, 1331830784, 1331831335, 'GB', 'GBR', 'المملكة المتحدة'),
(14799, 1331831336, 1331831343, 'IE', 'IRL', 'إيرلندا'),
(14800, 1331831344, 1331831351, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(14801, 1331831352, 1331832831, 'GB', 'GBR', 'المملكة المتحدة'),
(14802, 1331832832, 1331834879, 'IT', 'ITA', 'إيطاليا'),
(14803, 1331834880, 1331836927, 'BY', 'BLR', 'روسيا البيضاء'),
(14804, 1331836928, 1331838975, 'FR', 'FRA', 'فرنسا'),
(14805, 1331838976, 1331841023, 'GR', 'GRC', 'اليونان'),
(14806, 1331841024, 1331843071, 'CZ', 'CZE', 'التشيك'),
(14807, 1331843072, 1331845119, 'GB', 'GBR', 'المملكة المتحدة'),
(14808, 1331845120, 1331847167, 'RU', 'RUS', 'الإتحاد الروسي'),
(14809, 1331849216, 1331851263, 'RU', 'RUS', 'الإتحاد الروسي'),
(14810, 1331851264, 1331853311, 'AL', 'ALB', 'ألبانيا'),
(14811, 1331853312, 1331855359, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(14812, 1331855360, 1331857407, 'TR', 'TUR', 'تركيا'),
(14813, 1331857408, 1331859455, 'RU', 'RUS', 'الإتحاد الروسي'),
(14814, 1331859456, 1331861503, 'PL', 'POL', 'بولندا'),
(14815, 1331861504, 1331863551, 'CZ', 'CZE', 'التشيك'),
(14816, 1331863552, 1331865599, 'GB', 'GBR', 'المملكة المتحدة'),
(14817, 1331865600, 1331869695, 'NL', 'NLD', 'هولندا'),
(14818, 1331869696, 1331871743, 'SA', 'SAU', 'السعودية'),
(14819, 1331871744, 1331873791, 'DK', 'DNK', 'الدنيمارك'),
(14820, 1331873792, 1331879935, 'RU', 'RUS', 'الإتحاد الروسي'),
(14821, 1331879936, 1331881983, 'DE', 'DEU', 'ألمانيا'),
(14822, 1331881984, 1331883007, 'GB', 'GBR', 'المملكة المتحدة'),
(14823, 1331883008, 1331883263, 'SE', 'SWE', 'السويد'),
(14824, 1331883264, 1331886079, 'GB', 'GBR', 'المملكة المتحدة'),
(14825, 1331886080, 1331888127, 'ES', 'ESP', 'إسبانيا'),
(14826, 1331888128, 1331890175, 'SE', 'SWE', 'السويد'),
(14827, 1331890176, 1331892223, 'IT', 'ITA', 'إيطاليا'),
(14828, 1331892224, 1331894271, 'RU', 'RUS', 'الإتحاد الروسي'),
(14829, 1331894272, 1331896319, 'NL', 'NLD', 'هولندا'),
(14830, 1331896320, 1331898367, 'FR', 'FRA', 'فرنسا'),
(14831, 1331898368, 1331900415, 'GB', 'GBR', 'المملكة المتحدة'),
(14832, 1331900416, 1331902463, 'RU', 'RUS', 'الإتحاد الروسي'),
(14833, 1331902464, 1331904511, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(14834, 1331904512, 1331908607, 'GB', 'GBR', 'المملكة المتحدة'),
(14835, 1331908608, 1331910655, 'DE', 'DEU', 'ألمانيا'),
(14836, 1331910656, 1331912703, 'BH', 'BHR', 'البحرين'),
(14837, 1331912704, 1331914751, 'DE', 'DEU', 'ألمانيا'),
(14838, 1331914752, 1331916799, 'RU', 'RUS', 'الإتحاد الروسي'),
(14839, 1331916800, 1331918847, 'IT', 'ITA', 'إيطاليا'),
(14840, 1331918848, 1331920895, 'BE', 'BEL', 'بلجيكا'),
(14841, 1331920896, 1331922943, 'NL', 'NLD', 'هولندا'),
(14842, 1331922944, 1331924991, 'DE', 'DEU', 'ألمانيا'),
(14843, 1331924992, 1331927039, 'GB', 'GBR', 'المملكة المتحدة'),
(14844, 1331927040, 1331929087, 'FI', 'FIN', 'فنلندا'),
(14845, 1331929088, 1331931135, 'FR', 'FRA', 'فرنسا'),
(14846, 1331931136, 1331933183, 'SE', 'SWE', 'السويد'),
(14847, 1331933184, 1331935231, 'TR', 'TUR', 'تركيا'),
(14848, 1331935232, 1331937535, 'GB', 'GBR', 'المملكة المتحدة'),
(14849, 1331937536, 1331937567, 'SM', 'SMR', 'سان مارينو'),
(14850, 1331937568, 1331937583, 'US', 'USA', 'الولايات المتحدة'),
(14851, 1331937584, 1331937599, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(14852, 1331937600, 1331938191, 'GB', 'GBR', 'المملكة المتحدة'),
(14853, 1331938192, 1331938207, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(14854, 1331938208, 1331939327, 'GB', 'GBR', 'المملكة المتحدة'),
(14855, 1331939328, 1331941375, 'BE', 'BEL', 'بلجيكا'),
(14856, 1331941376, 1331943423, 'ES', 'ESP', 'إسبانيا'),
(14857, 1331943424, 1331945471, 'RU', 'RUS', 'الإتحاد الروسي'),
(14858, 1331945472, 1331947519, 'SE', 'SWE', 'السويد'),
(14859, 1331947520, 1331948543, 'CH', 'CHE', 'سويسرا'),
(14860, 1331948544, 1331948547, 'NL', 'NLD', 'هولندا'),
(14861, 1331948548, 1331948551, 'CH', 'CHE', 'سويسرا'),
(14862, 1331948552, 1331948559, 'FR', 'FRA', 'فرنسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(14863, 1331948560, 1331948567, 'GB', 'GBR', 'المملكة المتحدة'),
(14864, 1331948568, 1331948575, 'DE', 'DEU', 'ألمانيا'),
(14865, 1331948576, 1331948583, 'CZ', 'CZE', 'التشيك'),
(14866, 1331948584, 1331948591, 'CY', 'CYP', 'قبرص'),
(14867, 1331948592, 1331948607, 'BG', 'BGR', 'بلغاريا'),
(14868, 1331948608, 1331948615, 'US', 'USA', 'الولايات المتحدة'),
(14869, 1331948616, 1331949567, 'CH', 'CHE', 'سويسرا'),
(14870, 1331949568, 1331951615, 'RU', 'RUS', 'الإتحاد الروسي'),
(14871, 1331951616, 1331953663, 'GE', 'GEO', 'جورجيا'),
(14872, 1331953664, 1332019199, 'BG', 'BGR', 'بلغاريا'),
(14873, 1332019200, 1332021247, 'RS', 'SRB', 'صربيا'),
(14874, 1332021248, 1332027135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14875, 1332027136, 1332027391, 'RS', 'SRB', 'صربيا'),
(14876, 1332027392, 1332027903, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14877, 1332027904, 1332028159, 'RS', 'SRB', 'صربيا'),
(14878, 1332028160, 1332028543, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14879, 1332028544, 1332028735, 'RS', 'SRB', 'صربيا'),
(14880, 1332028736, 1332028895, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14881, 1332028896, 1332028903, 'RS', 'SRB', 'صربيا'),
(14882, 1332028904, 1332028923, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14883, 1332028924, 1332028927, 'RS', 'SRB', 'صربيا'),
(14884, 1332028928, 1332028951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14885, 1332028952, 1332028959, 'RS', 'SRB', 'صربيا'),
(14886, 1332028960, 1332029015, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14887, 1332029016, 1332029023, 'RS', 'SRB', 'صربيا'),
(14888, 1332029024, 1332029039, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14889, 1332029040, 1332029047, 'RS', 'SRB', 'صربيا'),
(14890, 1332029048, 1332029051, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14891, 1332029052, 1332029055, 'RS', 'SRB', 'صربيا'),
(14892, 1332029056, 1332029183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14893, 1332029184, 1332029191, 'RS', 'SRB', 'صربيا'),
(14894, 1332029192, 1332029263, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14895, 1332029264, 1332029279, 'RS', 'SRB', 'صربيا'),
(14896, 1332029280, 1332029295, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14897, 1332029296, 1332029311, 'RS', 'SRB', 'صربيا'),
(14898, 1332029312, 1332029319, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14899, 1332029320, 1332029327, 'RS', 'SRB', 'صربيا'),
(14900, 1332029328, 1332029503, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14901, 1332029504, 1332029511, 'RS', 'SRB', 'صربيا'),
(14902, 1332029512, 1332029535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14903, 1332029536, 1332029551, 'RS', 'SRB', 'صربيا'),
(14904, 1332029552, 1332029591, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14905, 1332029592, 1332029631, 'RS', 'SRB', 'صربيا'),
(14906, 1332029632, 1332029663, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14907, 1332029664, 1332029711, 'RS', 'SRB', 'صربيا'),
(14908, 1332029712, 1332029719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14909, 1332029720, 1332029743, 'RS', 'SRB', 'صربيا'),
(14910, 1332029744, 1332029751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14911, 1332029752, 1332029943, 'RS', 'SRB', 'صربيا'),
(14912, 1332029944, 1332029951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14913, 1332029952, 1332030463, 'RS', 'SRB', 'صربيا'),
(14914, 1332030464, 1332033535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14915, 1332033536, 1332035071, 'RS', 'SRB', 'صربيا'),
(14916, 1332035072, 1332044287, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14917, 1332044288, 1332044799, 'RS', 'SRB', 'صربيا'),
(14918, 1332044800, 1332045823, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14919, 1332045824, 1332051967, 'RS', 'SRB', 'صربيا'),
(14920, 1332051968, 1332084735, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(14921, 1332084736, 1332150271, 'SE', 'SWE', 'السويد'),
(14922, 1332150272, 1332215807, 'GR', 'GRC', 'اليونان'),
(14923, 1332215808, 1332346879, 'RU', 'RUS', 'الإتحاد الروسي'),
(14924, 1332346880, 1332412415, 'AL', 'ALB', 'ألبانيا'),
(14925, 1332412416, 1332477951, 'GR', 'GRC', 'اليونان'),
(14926, 1332477952, 1332609023, 'ES', 'ESP', 'إسبانيا'),
(14927, 1332609024, 1332613119, 'PL', 'POL', 'بولندا'),
(14928, 1332613120, 1332621311, 'UA', 'UKR', 'أوكرانيا'),
(14929, 1332621312, 1332625407, 'KZ', 'KAZ', 'كازاخستان'),
(14930, 1332625408, 1332629503, 'UA', 'UKR', 'أوكرانيا'),
(14931, 1332629504, 1332633599, 'DE', 'DEU', 'ألمانيا'),
(14932, 1332633600, 1332637695, 'UA', 'UKR', 'أوكرانيا'),
(14933, 1332637696, 1332641791, 'BG', 'BGR', 'بلغاريا'),
(14934, 1332641792, 1332658175, 'UA', 'UKR', 'أوكرانيا'),
(14935, 1332658176, 1332662271, 'PL', 'POL', 'بولندا'),
(14936, 1332662272, 1332670463, 'UA', 'UKR', 'أوكرانيا'),
(14937, 1332670464, 1332740095, 'RU', 'RUS', 'الإتحاد الروسي'),
(14938, 1332740096, 1333264383, 'RO', 'ROM', 'رومانيا'),
(14939, 1333264384, 1333297151, 'RU', 'RUS', 'الإتحاد الروسي'),
(14940, 1333297152, 1333317887, 'HU', 'HUN', 'هنغاريا'),
(14941, 1333317888, 1333318143, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(14942, 1333318144, 1333362687, 'HU', 'HUN', 'هنغاريا'),
(14943, 1333362688, 1333395455, 'GB', 'GBR', 'المملكة المتحدة'),
(14944, 1333395456, 1333428223, 'HU', 'HUN', 'هنغاريا'),
(14945, 1333428224, 1333460991, 'RU', 'RUS', 'الإتحاد الروسي'),
(14946, 1333460992, 1333493759, 'GB', 'GBR', 'المملكة المتحدة'),
(14947, 1333493760, 1333526527, 'TR', 'TUR', 'تركيا'),
(14948, 1333526528, 1333542911, 'BG', 'BGR', 'بلغاريا'),
(14949, 1333542912, 1333551103, 'RO', 'ROM', 'رومانيا'),
(14950, 1333551104, 1333555199, 'UA', 'UKR', 'أوكرانيا'),
(14951, 1333555200, 1333559295, 'RO', 'ROM', 'رومانيا'),
(14952, 1333559296, 1333592063, 'UA', 'UKR', 'أوكرانيا'),
(14953, 1333592064, 1333624831, 'IE', 'IRL', 'إيرلندا'),
(14954, 1333624832, 1333657599, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(14955, 1333657600, 1333690367, 'RU', 'RUS', 'الإتحاد الروسي'),
(14956, 1333690368, 1333723135, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(14957, 1333723136, 1333755903, 'IR', 'IRN', 'إيران'),
(14958, 1333755904, 1333788671, 'CZ', 'CZE', 'التشيك'),
(14959, 1333788672, 1334050815, 'GR', 'GRC', 'اليونان'),
(14960, 1334050816, 1334059007, 'BG', 'BGR', 'بلغاريا'),
(14961, 1334059008, 1334067199, 'FR', 'FRA', 'فرنسا'),
(14962, 1334067200, 1334075391, 'LV', 'LVA', 'لاتفيا'),
(14963, 1334075392, 1334083583, 'RU', 'RUS', 'الإتحاد الروسي'),
(14964, 1334083584, 1334091775, 'DE', 'DEU', 'ألمانيا'),
(14965, 1334091776, 1334099967, 'LT', 'LTU', 'ليتوانيا'),
(14966, 1334099968, 1334108159, 'IR', 'IRN', 'إيران'),
(14967, 1334108160, 1334109807, 'BE', 'BEL', 'بلجيكا'),
(14968, 1334109808, 1334109811, 'NL', 'NLD', 'هولندا'),
(14969, 1334109812, 1334113527, 'BE', 'BEL', 'بلجيكا'),
(14970, 1334113528, 1334113535, 'NL', 'NLD', 'هولندا'),
(14971, 1334113536, 1334116351, 'BE', 'BEL', 'بلجيكا'),
(14972, 1334116352, 1334124543, 'AX', 'FIN', 'فنلندا'),
(14973, 1334124544, 1334132735, 'DE', 'DEU', 'ألمانيا'),
(14974, 1334132736, 1334165503, 'RU', 'RUS', 'الإتحاد الروسي'),
(14975, 1334165504, 1334173695, 'PL', 'POL', 'بولندا'),
(14976, 1334173696, 1334181887, 'LT', 'LTU', 'ليتوانيا'),
(14977, 1334181888, 1334190079, 'RU', 'RUS', 'الإتحاد الروسي'),
(14978, 1334190080, 1334198271, 'RO', 'ROM', 'رومانيا'),
(14979, 1334198272, 1334206463, 'RU', 'RUS', 'الإتحاد الروسي'),
(14980, 1334206464, 1334214655, 'FI', 'FIN', 'فنلندا'),
(14981, 1334214656, 1334222847, 'JO', 'JOR', 'الأردن'),
(14982, 1334222848, 1334231039, 'BG', 'BGR', 'بلغاريا'),
(14983, 1334231040, 1334239231, 'EE', 'EST', 'إستونيا'),
(14984, 1334239232, 1334247423, 'IS', 'ISL', 'أيسلندا'),
(14985, 1334247424, 1334255615, 'NO', 'NOR', 'النرويج'),
(14986, 1334255616, 1334263807, 'IT', 'ITA', 'إيطاليا'),
(14987, 1334263808, 1334271999, 'RU', 'RUS', 'الإتحاد الروسي'),
(14988, 1334272000, 1334280191, 'GB', 'GBR', 'المملكة المتحدة'),
(14989, 1334280192, 1334288383, 'LV', 'LVA', 'لاتفيا'),
(14990, 1334288384, 1334296575, 'PL', 'POL', 'بولندا'),
(14991, 1334296576, 1334304767, 'UA', 'UKR', 'أوكرانيا'),
(14992, 1334304768, 1334312959, 'RU', 'RUS', 'الإتحاد الروسي'),
(14993, 1334312960, 1334316031, 'SE', 'SWE', 'السويد'),
(14994, 1334316032, 1334316543, 'NO', 'NOR', 'النرويج'),
(14995, 1334316544, 1334345727, 'SE', 'SWE', 'السويد'),
(14996, 1334345728, 1334378495, 'RU', 'RUS', 'الإتحاد الروسي'),
(14997, 1334378496, 1334411263, 'IT', 'ITA', 'إيطاليا'),
(14998, 1334411264, 1334444031, 'RU', 'RUS', 'الإتحاد الروسي'),
(14999, 1334444032, 1334478847, 'SE', 'SWE', 'السويد'),
(15000, 1334478848, 1334480895, 'DK', 'DNK', 'الدنيمارك'),
(15001, 1334480896, 1334484991, 'SE', 'SWE', 'السويد'),
(15002, 1334484992, 1334489087, 'DK', 'DNK', 'الدنيمارك'),
(15003, 1334489088, 1334501375, 'SE', 'SWE', 'السويد'),
(15004, 1334501376, 1334509567, 'DK', 'DNK', 'الدنيمارك'),
(15005, 1334509568, 1334542335, 'PL', 'POL', 'بولندا'),
(15006, 1334542336, 1334575103, 'RU', 'RUS', 'الإتحاد الروسي'),
(15007, 1334575104, 1334579199, 'UA', 'UKR', 'أوكرانيا'),
(15008, 1334579200, 1334583295, 'RU', 'RUS', 'الإتحاد الروسي'),
(15009, 1334583296, 1334583311, 'DE', 'DEU', 'ألمانيا'),
(15010, 1334583312, 1334583319, 'US', 'USA', 'الولايات المتحدة'),
(15011, 1334583320, 1334583535, 'DE', 'DEU', 'ألمانيا'),
(15012, 1334583536, 1334583543, 'US', 'USA', 'الولايات المتحدة'),
(15013, 1334583544, 1334583807, 'DE', 'DEU', 'ألمانيا'),
(15014, 1334583808, 1334584063, 'CH', 'CHE', 'سويسرا'),
(15015, 1334584064, 1334584255, 'DE', 'DEU', 'ألمانيا'),
(15016, 1334584256, 1334584287, 'AT', 'AUT', 'النمسا'),
(15017, 1334584288, 1334584351, 'DE', 'DEU', 'ألمانيا'),
(15018, 1334584352, 1334584383, 'LU', 'LUX', 'لوكسيمبورغ'),
(15019, 1334584384, 1334584903, 'DE', 'DEU', 'ألمانيا'),
(15020, 1334584904, 1334584911, 'AT', 'AUT', 'النمسا'),
(15021, 1334584912, 1334584999, 'DE', 'DEU', 'ألمانيا'),
(15022, 1334585000, 1334585007, 'US', 'USA', 'الولايات المتحدة'),
(15023, 1334585008, 1334585055, 'DE', 'DEU', 'ألمانيا'),
(15024, 1334585056, 1334585087, 'US', 'USA', 'الولايات المتحدة'),
(15025, 1334585088, 1334585111, 'DE', 'DEU', 'ألمانيا'),
(15026, 1334585112, 1334585119, 'AT', 'AUT', 'النمسا'),
(15027, 1334585120, 1334591487, 'DE', 'DEU', 'ألمانيا'),
(15028, 1334591488, 1334595583, 'RU', 'RUS', 'الإتحاد الروسي'),
(15029, 1334595584, 1334596351, 'IT', 'ITA', 'إيطاليا'),
(15030, 1334596352, 1334596607, 'GR', 'GRC', 'اليونان'),
(15031, 1334596608, 1334597887, 'IT', 'ITA', 'إيطاليا'),
(15032, 1334597888, 1334598143, 'GR', 'GRC', 'اليونان'),
(15033, 1334598144, 1334598271, 'SK', 'SVK', 'سلوفاكيا'),
(15034, 1334598272, 1334598399, 'CZ', 'CZE', 'التشيك'),
(15035, 1334598400, 1334598463, 'GR', 'GRC', 'اليونان'),
(15036, 1334598464, 1334598527, 'IT', 'ITA', 'إيطاليا'),
(15037, 1334598528, 1334598655, 'GR', 'GRC', 'اليونان'),
(15038, 1334598656, 1334599039, 'IT', 'ITA', 'إيطاليا'),
(15039, 1334599040, 1334599167, 'FR', 'FRA', 'فرنسا'),
(15040, 1334599168, 1334599679, 'IT', 'ITA', 'إيطاليا'),
(15041, 1334599680, 1334603775, 'RU', 'RUS', 'الإتحاد الروسي'),
(15042, 1334603776, 1334607871, 'DE', 'DEU', 'ألمانيا'),
(15043, 1334607872, 1334609994, 'IE', 'IRL', 'إيرلندا'),
(15044, 1334609995, 1334609995, 'GB', 'GBR', 'المملكة المتحدة'),
(15045, 1334609996, 1334610020, 'IE', 'IRL', 'إيرلندا'),
(15046, 1334610021, 1334610021, 'GB', 'GBR', 'المملكة المتحدة'),
(15047, 1334610022, 1334611967, 'IE', 'IRL', 'إيرلندا'),
(15048, 1334611968, 1334616063, 'ME', 'MNE', 'الجبل الأسود'),
(15049, 1334616064, 1334620159, 'MD', 'MDA', 'مولدوفا'),
(15050, 1334620160, 1334624255, 'DE', 'DEU', 'ألمانيا'),
(15051, 1334624256, 1334628351, 'GB', 'GBR', 'المملكة المتحدة'),
(15052, 1334628352, 1334632447, 'IE', 'IRL', 'إيرلندا'),
(15053, 1334632448, 1334636543, 'KZ', 'KAZ', 'كازاخستان'),
(15054, 1334636544, 1334640639, 'RU', 'RUS', 'الإتحاد الروسي'),
(15055, 1334640640, 1334644735, 'FR', 'FRA', 'فرنسا'),
(15056, 1334644736, 1334644991, 'IQ', 'IRQ', 'العراق'),
(15057, 1334644992, 1334645247, 'DE', 'DEU', 'ألمانيا'),
(15058, 1334645248, 1334648319, 'IQ', 'IRQ', 'العراق'),
(15059, 1334648320, 1334648831, 'DE', 'DEU', 'ألمانيا'),
(15060, 1334648832, 1334650959, 'GB', 'GBR', 'المملكة المتحدة'),
(15061, 1334650960, 1334650975, 'NL', 'NLD', 'هولندا'),
(15062, 1334650976, 1334651391, 'GB', 'GBR', 'المملكة المتحدة'),
(15063, 1334651392, 1334651647, 'NL', 'NLD', 'هولندا'),
(15064, 1334651648, 1334651903, 'FR', 'FRA', 'فرنسا'),
(15065, 1334651904, 1334652159, 'DE', 'DEU', 'ألمانيا'),
(15066, 1334652160, 1334652543, 'GB', 'GBR', 'المملكة المتحدة'),
(15067, 1334652544, 1334652559, 'NL', 'NLD', 'هولندا'),
(15068, 1334652560, 1334652927, 'GB', 'GBR', 'المملكة المتحدة'),
(15069, 1334652928, 1334661119, 'RU', 'RUS', 'الإتحاد الروسي'),
(15070, 1334661120, 1334665215, 'CH', 'CHE', 'سويسرا'),
(15071, 1334665216, 1334669311, 'NO', 'NOR', 'النرويج'),
(15072, 1334669312, 1334673407, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(15073, 1334673408, 1334677503, 'GB', 'GBR', 'المملكة المتحدة'),
(15074, 1334677504, 1334681599, 'FI', 'FIN', 'فنلندا'),
(15075, 1334681600, 1334681855, 'PL', 'POL', 'بولندا'),
(15076, 1334681856, 1334682111, 'GB', 'GBR', 'المملكة المتحدة'),
(15077, 1334682112, 1334682367, 'IE', 'IRL', 'إيرلندا'),
(15078, 1334682368, 1334682623, 'FR', 'FRA', 'فرنسا'),
(15079, 1334682624, 1334682879, 'NO', 'NOR', 'النرويج'),
(15080, 1334682880, 1334683135, 'DK', 'DNK', 'الدنيمارك'),
(15081, 1334683136, 1334683391, 'CZ', 'CZE', 'التشيك'),
(15082, 1334683392, 1334683647, 'CH', 'CHE', 'سويسرا'),
(15083, 1334683648, 1334684159, 'DE', 'DEU', 'ألمانيا'),
(15084, 1334684160, 1334684415, 'SE', 'SWE', 'السويد'),
(15085, 1334684416, 1334684671, 'DE', 'DEU', 'ألمانيا'),
(15086, 1334684672, 1334684927, 'FI', 'FIN', 'فنلندا'),
(15087, 1334684928, 1334685183, 'NL', 'NLD', 'هولندا'),
(15088, 1334685184, 1334685695, 'DE', 'DEU', 'ألمانيا'),
(15089, 1334685696, 1334689791, 'IT', 'ITA', 'إيطاليا'),
(15090, 1334689792, 1334693887, 'FR', 'FRA', 'فرنسا'),
(15091, 1334693888, 1334702079, 'RU', 'RUS', 'الإتحاد الروسي'),
(15092, 1334702080, 1334706175, 'CZ', 'CZE', 'التشيك'),
(15093, 1334706176, 1334710271, 'BA', 'BIH', 'البوسنه والهرسك'),
(15094, 1334710272, 1334714367, 'RU', 'RUS', 'الإتحاد الروسي'),
(15095, 1334714368, 1334718463, 'DE', 'DEU', 'ألمانيا'),
(15096, 1334718464, 1334722559, 'KZ', 'KAZ', 'كازاخستان'),
(15097, 1334722560, 1334726655, 'IT', 'ITA', 'إيطاليا'),
(15098, 1334726656, 1334729983, 'RU', 'RUS', 'الإتحاد الروسي'),
(15099, 1334729984, 1334730431, 'KZ', 'KAZ', 'كازاخستان'),
(15100, 1334730432, 1334730439, 'RU', 'RUS', 'الإتحاد الروسي'),
(15101, 1334730440, 1334730443, 'KZ', 'KAZ', 'كازاخستان'),
(15102, 1334730444, 1334730447, 'RU', 'RUS', 'الإتحاد الروسي'),
(15103, 1334730448, 1334730463, 'KZ', 'KAZ', 'كازاخستان'),
(15104, 1334730464, 1334730495, 'RU', 'RUS', 'الإتحاد الروسي'),
(15105, 1334730496, 1334730499, 'KZ', 'KAZ', 'كازاخستان'),
(15106, 1334730500, 1334730503, 'RU', 'RUS', 'الإتحاد الروسي'),
(15107, 1334730504, 1334730539, 'KZ', 'KAZ', 'كازاخستان'),
(15108, 1334730540, 1334730543, 'RU', 'RUS', 'الإتحاد الروسي'),
(15109, 1334730544, 1334730599, 'KZ', 'KAZ', 'كازاخستان'),
(15110, 1334730600, 1334730603, 'RU', 'RUS', 'الإتحاد الروسي'),
(15111, 1334730604, 1334730655, 'KZ', 'KAZ', 'كازاخستان'),
(15112, 1334730656, 1334730659, 'RU', 'RUS', 'الإتحاد الروسي'),
(15113, 1334730660, 1334730667, 'KZ', 'KAZ', 'كازاخستان'),
(15114, 1334730668, 1334730687, 'RU', 'RUS', 'الإتحاد الروسي'),
(15115, 1334730688, 1334730699, 'KZ', 'KAZ', 'كازاخستان'),
(15116, 1334730700, 1334730703, 'RU', 'RUS', 'الإتحاد الروسي'),
(15117, 1334730704, 1334730719, 'KZ', 'KAZ', 'كازاخستان'),
(15118, 1334730720, 1334730735, 'RU', 'RUS', 'الإتحاد الروسي'),
(15119, 1334730736, 1334730739, 'KZ', 'KAZ', 'كازاخستان'),
(15120, 1334730740, 1334734847, 'RU', 'RUS', 'الإتحاد الروسي'),
(15121, 1334734848, 1334738943, 'LT', 'LTU', 'ليتوانيا'),
(15122, 1334738944, 1334743039, 'CH', 'CHE', 'سويسرا'),
(15123, 1334743040, 1334747135, 'UA', 'UKR', 'أوكرانيا'),
(15124, 1334747136, 1334751231, 'RU', 'RUS', 'الإتحاد الروسي'),
(15125, 1334751232, 1334755327, 'BH', 'BHR', 'البحرين'),
(15126, 1334755328, 1334759423, 'UA', 'UKR', 'أوكرانيا'),
(15127, 1334759424, 1334763519, 'SE', 'SWE', 'السويد'),
(15128, 1334763520, 1334767615, 'DK', 'DNK', 'الدنيمارك'),
(15129, 1334767616, 1334771711, 'SE', 'SWE', 'السويد'),
(15130, 1334771712, 1334779903, 'RU', 'RUS', 'الإتحاد الروسي'),
(15131, 1334779904, 1334783999, 'UA', 'UKR', 'أوكرانيا'),
(15132, 1334784000, 1334788095, 'AT', 'AUT', 'النمسا'),
(15133, 1334788096, 1334796287, 'RU', 'RUS', 'الإتحاد الروسي'),
(15134, 1334796288, 1334800383, 'ME', 'MNE', 'الجبل الأسود'),
(15135, 1334800384, 1334804479, 'IT', 'ITA', 'إيطاليا'),
(15136, 1334804480, 1334808575, 'FR', 'FRA', 'فرنسا'),
(15137, 1334808576, 1334812671, 'GB', 'GBR', 'المملكة المتحدة'),
(15138, 1334812672, 1334816767, 'BA', 'BIH', 'البوسنه والهرسك'),
(15139, 1334816768, 1334820863, 'DE', 'DEU', 'ألمانيا'),
(15140, 1334820864, 1334824959, 'IE', 'IRL', 'إيرلندا'),
(15141, 1334824960, 1334829055, 'NL', 'NLD', 'هولندا'),
(15142, 1334829056, 1334833151, 'RU', 'RUS', 'الإتحاد الروسي'),
(15143, 1334833152, 1334837247, 'FR', 'FRA', 'فرنسا'),
(15144, 1334837248, 1335885823, 'ES', 'ESP', 'إسبانيا'),
(15145, 1335885824, 1336016895, 'NO', 'NOR', 'النرويج'),
(15146, 1336016896, 1336147967, 'PL', 'POL', 'بولندا'),
(15147, 1336147968, 1336279039, 'RU', 'RUS', 'الإتحاد الروسي'),
(15148, 1336279040, 1336410111, 'GR', 'GRC', 'اليونان'),
(15149, 1336410112, 1336541183, 'PT', 'PRT', 'البورتوغال'),
(15150, 1336541184, 1336543231, 'SA', 'SAU', 'السعودية'),
(15151, 1336543232, 1336545279, 'ES', 'ESP', 'إسبانيا'),
(15152, 1336545280, 1336547327, 'SE', 'SWE', 'السويد'),
(15153, 1336547328, 1336549375, 'RU', 'RUS', 'الإتحاد الروسي'),
(15154, 1336549376, 1336551423, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(15155, 1336551424, 1336553471, 'GB', 'GBR', 'المملكة المتحدة'),
(15156, 1336553472, 1336555519, 'SA', 'SAU', 'السعودية'),
(15157, 1336555520, 1336557567, 'BE', 'BEL', 'بلجيكا'),
(15158, 1336557568, 1336558591, 'ES', 'ESP', 'إسبانيا'),
(15159, 1336558592, 1336559328, 'US', 'USA', 'الولايات المتحدة'),
(15160, 1336559329, 1336559615, 'ES', 'ESP', 'إسبانيا'),
(15161, 1336559616, 1336561663, 'GB', 'GBR', 'المملكة المتحدة'),
(15162, 1336561664, 1336563711, 'NO', 'NOR', 'النرويج'),
(15163, 1336563712, 1336567807, 'NL', 'NLD', 'هولندا'),
(15164, 1336567808, 1336569855, 'BY', 'BLR', 'روسيا البيضاء'),
(15165, 1336571904, 1336573951, 'PL', 'POL', 'بولندا'),
(15166, 1336573952, 1336575999, 'DK', 'DNK', 'الدنيمارك'),
(15167, 1336576000, 1336578047, 'RU', 'RUS', 'الإتحاد الروسي'),
(15168, 1336578048, 1336580095, 'IR', 'IRN', 'إيران'),
(15169, 1336580096, 1336584191, 'RU', 'RUS', 'الإتحاد الروسي'),
(15170, 1336584192, 1336586239, 'TR', 'TUR', 'تركيا'),
(15171, 1336586240, 1336588287, 'GB', 'GBR', 'المملكة المتحدة'),
(15172, 1336588288, 1336590335, 'TJ', 'TJK', 'طاجيكيستان'),
(15173, 1336590336, 1336592383, 'GB', 'GBR', 'المملكة المتحدة'),
(15174, 1336592384, 1336594431, 'AM', 'ARM', 'أرمينيا'),
(15175, 1336594432, 1336596479, 'AT', 'AUT', 'النمسا'),
(15176, 1336596480, 1336598527, 'FR', 'FRA', 'فرنسا'),
(15177, 1336598528, 1336600575, 'MD', 'MDA', 'مولدوفا'),
(15178, 1336600576, 1336602623, 'FR', 'FRA', 'فرنسا'),
(15179, 1336602624, 1336604671, 'IE', 'IRL', 'إيرلندا'),
(15180, 1336604672, 1336606719, 'CZ', 'CZE', 'التشيك'),
(15181, 1336606720, 1336608767, 'PL', 'POL', 'بولندا'),
(15182, 1336608768, 1336610815, 'RU', 'RUS', 'الإتحاد الروسي'),
(15183, 1336610816, 1336612863, 'TR', 'TUR', 'تركيا'),
(15184, 1336612864, 1336614911, 'ES', 'ESP', 'إسبانيا'),
(15185, 1336614912, 1336616959, 'GB', 'GBR', 'المملكة المتحدة'),
(15186, 1336616960, 1336619007, 'ES', 'ESP', 'إسبانيا'),
(15187, 1336619008, 1336621055, 'AL', 'ALB', 'ألبانيا'),
(15188, 1336621056, 1336623103, 'IT', 'ITA', 'إيطاليا'),
(15189, 1336623104, 1336625151, 'BE', 'BEL', 'بلجيكا'),
(15190, 1336625152, 1336625823, 'IE', 'IRL', 'إيرلندا'),
(15191, 1336625824, 1336625839, 'GB', 'GBR', 'المملكة المتحدة'),
(15192, 1336625840, 1336626207, 'IE', 'IRL', 'إيرلندا'),
(15193, 1336626208, 1336626239, 'GB', 'GBR', 'المملكة المتحدة'),
(15194, 1336626240, 1336626303, 'IE', 'IRL', 'إيرلندا'),
(15195, 1336626304, 1336626319, 'GB', 'GBR', 'المملكة المتحدة'),
(15196, 1336626320, 1336626447, 'IE', 'IRL', 'إيرلندا'),
(15197, 1336626448, 1336626463, 'GB', 'GBR', 'المملكة المتحدة'),
(15198, 1336626464, 1336627199, 'IE', 'IRL', 'إيرلندا'),
(15199, 1336627200, 1336629247, 'NO', 'NOR', 'النرويج'),
(15200, 1336629248, 1336631295, 'DE', 'DEU', 'ألمانيا'),
(15201, 1336631296, 1336633343, 'IS', 'ISL', 'أيسلندا'),
(15202, 1336633344, 1336635391, 'ES', 'ESP', 'إسبانيا'),
(15203, 1336635392, 1336637439, 'RU', 'RUS', 'الإتحاد الروسي'),
(15204, 1336637440, 1336639487, 'UA', 'UKR', 'أوكرانيا'),
(15205, 1336639488, 1336643583, 'HU', 'HUN', 'هنغاريا'),
(15206, 1336643584, 1336645631, 'DK', 'DNK', 'الدنيمارك'),
(15207, 1336645632, 1336647679, 'GB', 'GBR', 'المملكة المتحدة'),
(15208, 1336647680, 1336649727, 'IT', 'ITA', 'إيطاليا'),
(15209, 1336649728, 1336651775, 'RU', 'RUS', 'الإتحاد الروسي'),
(15210, 1336651776, 1336653823, 'DE', 'DEU', 'ألمانيا'),
(15211, 1336653824, 1336655871, 'CZ', 'CZE', 'التشيك'),
(15212, 1336655872, 1336657919, 'NL', 'NLD', 'هولندا'),
(15213, 1336657920, 1336659967, 'DE', 'DEU', 'ألمانيا'),
(15214, 1336659968, 1336662015, 'RU', 'RUS', 'الإتحاد الروسي'),
(15215, 1336662016, 1336663039, 'ES', 'ESP', 'إسبانيا'),
(15216, 1336663040, 1336663071, 'FR', 'FRA', 'فرنسا'),
(15217, 1336663072, 1336664063, 'ES', 'ESP', 'إسبانيا'),
(15218, 1336664064, 1336668159, 'FI', 'FIN', 'فنلندا'),
(15219, 1336668160, 1336670207, 'BH', 'BHR', 'البحرين'),
(15220, 1336670208, 1336672255, 'SE', 'SWE', 'السويد'),
(15221, 1336672256, 1336705023, 'RU', 'RUS', 'الإتحاد الروسي'),
(15222, 1336705024, 1336721407, 'SA', 'SAU', 'السعودية'),
(15223, 1336721408, 1336737791, 'HU', 'HUN', 'هنغاريا'),
(15224, 1336737792, 1336754175, 'PL', 'POL', 'بولندا'),
(15225, 1336754176, 1336770559, 'RU', 'RUS', 'الإتحاد الروسي'),
(15226, 1336770560, 1336786943, 'GB', 'GBR', 'المملكة المتحدة'),
(15227, 1336786944, 1336803327, 'JO', 'JOR', 'الأردن'),
(15228, 1336803328, 1336811519, 'UA', 'UKR', 'أوكرانيا'),
(15229, 1336811520, 1336827903, 'RU', 'RUS', 'الإتحاد الروسي'),
(15230, 1336827904, 1336836095, 'AT', 'AUT', 'النمسا'),
(15231, 1336836096, 1336852479, 'RU', 'RUS', 'الإتحاد الروسي'),
(15232, 1336852480, 1336868863, 'FR', 'FRA', 'فرنسا'),
(15233, 1336868864, 1336885247, 'RU', 'RUS', 'الإتحاد الروسي'),
(15234, 1336885248, 1336901631, 'RS', 'SRB', 'صربيا'),
(15235, 1336901632, 1336911103, 'IR', 'IRN', 'إيران'),
(15236, 1336911104, 1336911359, 'SE', 'SWE', 'السويد'),
(15237, 1336911360, 1336918015, 'IR', 'IRN', 'إيران'),
(15238, 1336918016, 1336934399, 'PL', 'POL', 'بولندا'),
(15239, 1336934400, 1337458687, 'IL', 'ISR', 'إسرائيل'),
(15240, 1337458688, 1337982975, 'PL', 'POL', 'بولندا'),
(15241, 1337982976, 1342177279, 'DE', 'DEU', 'ألمانيا'),
(15242, 1342177280, 1342628031, 'GB', 'GBR', 'المملكة المتحدة'),
(15243, 1342628032, 1342628095, 'IE', 'IRL', 'إيرلندا'),
(15244, 1342628096, 1342628159, 'GB', 'GBR', 'المملكة المتحدة'),
(15245, 1342628160, 1342628175, 'IE', 'IRL', 'إيرلندا'),
(15246, 1342628176, 1342628207, 'GB', 'GBR', 'المملكة المتحدة'),
(15247, 1342628208, 1342628223, 'IE', 'IRL', 'إيرلندا'),
(15248, 1342628224, 1342628319, 'GB', 'GBR', 'المملكة المتحدة'),
(15249, 1342628320, 1342628335, 'IE', 'IRL', 'إيرلندا'),
(15250, 1342628336, 1342628351, 'GB', 'GBR', 'المملكة المتحدة'),
(15251, 1342628352, 1342628367, 'IE', 'IRL', 'إيرلندا'),
(15252, 1342628368, 1342628431, 'GB', 'GBR', 'المملكة المتحدة'),
(15253, 1342628432, 1342628463, 'IE', 'IRL', 'إيرلندا'),
(15254, 1342628464, 1342628663, 'GB', 'GBR', 'المملكة المتحدة'),
(15255, 1342628664, 1342628671, 'IE', 'IRL', 'إيرلندا'),
(15256, 1342628672, 1342701567, 'GB', 'GBR', 'المملكة المتحدة'),
(15257, 1342701568, 1342981887, 'FR', 'FRA', 'فرنسا'),
(15258, 1342981888, 1342981935, 'GB', 'GBR', 'المملكة المتحدة'),
(15259, 1342981936, 1342982143, 'FR', 'FRA', 'فرنسا'),
(15260, 1342982144, 1342982399, 'MG', 'MDG', 'مدغشقر'),
(15261, 1342982400, 1342988287, 'FR', 'FRA', 'فرنسا'),
(15262, 1342988288, 1342989055, 'US', 'USA', 'الولايات المتحدة'),
(15263, 1342989056, 1343013119, 'FR', 'FRA', 'فرنسا'),
(15264, 1343013120, 1343013375, 'US', 'USA', 'الولايات المتحدة'),
(15265, 1343013376, 1343017983, 'FR', 'FRA', 'فرنسا'),
(15266, 1343017984, 1343018367, 'RE', 'REU', 'ريونيون'),
(15267, 1343018368, 1343025151, 'FR', 'FRA', 'فرنسا'),
(15268, 1343025152, 1343025663, 'RE', 'REU', 'ريونيون'),
(15269, 1343025664, 1343217663, 'FR', 'FRA', 'فرنسا'),
(15270, 1343217664, 1343218687, 'MU', 'MUS', 'موريشيوس'),
(15271, 1343218688, 1343219711, 'FR', 'FRA', 'فرنسا'),
(15272, 1343219712, 1343219967, 'KR', 'KOR', 'جمهورية كوريا'),
(15273, 1343219968, 1343220479, 'FR', 'FRA', 'فرنسا'),
(15274, 1343220480, 1343220607, 'DE', 'DEU', 'ألمانيا'),
(15275, 1343220608, 1343220735, 'FR', 'FRA', 'فرنسا'),
(15276, 1343220736, 1343220863, 'GB', 'GBR', 'المملكة المتحدة'),
(15277, 1343220864, 1343221023, 'FR', 'FRA', 'فرنسا'),
(15278, 1343221024, 1343221027, 'DE', 'DEU', 'ألمانيا'),
(15279, 1343221028, 1343221503, 'FR', 'FRA', 'فرنسا'),
(15280, 1343221504, 1343221759, 'GB', 'GBR', 'المملكة المتحدة'),
(15281, 1343221760, 1343221823, 'LB', 'LBN', 'لبنان'),
(15282, 1343221824, 1343221855, 'FR', 'FRA', 'فرنسا'),
(15283, 1343221856, 1343222271, 'LB', 'LBN', 'لبنان'),
(15284, 1343222272, 1343222287, 'CI', 'CIV', 'كوت ديفوار'),
(15285, 1343222288, 1343222527, 'FR', 'FRA', 'فرنسا'),
(15286, 1343222528, 1343222575, 'TD', 'TCD', 'تشاد'),
(15287, 1343222576, 1343222783, 'FR', 'FRA', 'فرنسا'),
(15288, 1343222784, 1343222911, 'TD', 'TCD', 'تشاد'),
(15289, 1343222912, 1343223551, 'FR', 'FRA', 'فرنسا'),
(15290, 1343223552, 1343223807, 'LB', 'LBN', 'لبنان'),
(15291, 1343223808, 1343224063, 'FR', 'FRA', 'فرنسا'),
(15292, 1343224064, 1343224303, 'US', 'USA', 'الولايات المتحدة'),
(15293, 1343224304, 1343224319, 'FR', 'FRA', 'فرنسا'),
(15294, 1343224320, 1343224535, 'LB', 'LBN', 'لبنان'),
(15295, 1343224536, 1343224543, 'FR', 'FRA', 'فرنسا'),
(15296, 1343224544, 1343224575, 'LB', 'LBN', 'لبنان'),
(15297, 1343224576, 1343225855, 'FR', 'FRA', 'فرنسا'),
(15298, 1343225856, 1343750143, 'IT', 'ITA', 'إيطاليا'),
(15299, 1343750144, 1344798719, 'ES', 'ESP', 'إسبانيا'),
(15300, 1344798720, 1345323007, 'GB', 'GBR', 'المملكة المتحدة'),
(15301, 1345323008, 1345847295, 'PL', 'POL', 'بولندا'),
(15302, 1345847296, 1345978367, 'NL', 'NLD', 'هولندا'),
(15303, 1345978368, 1346109439, 'ES', 'ESP', 'إسبانيا'),
(15304, 1346109440, 1346240511, 'NL', 'NLD', 'هولندا'),
(15305, 1346240512, 1346371583, 'DK', 'DNK', 'الدنيمارك'),
(15306, 1346371584, 1346375679, 'FI', 'FIN', 'فنلندا'),
(15307, 1346375680, 1346379775, 'RU', 'RUS', 'الإتحاد الروسي'),
(15308, 1346379776, 1346383871, 'ES', 'ESP', 'إسبانيا'),
(15309, 1346383872, 1346387967, 'GB', 'GBR', 'المملكة المتحدة'),
(15310, 1346387968, 1346392063, 'HU', 'HUN', 'هنغاريا'),
(15311, 1346396160, 1346400255, 'RU', 'RUS', 'الإتحاد الروسي'),
(15312, 1346400256, 1346404351, 'IT', 'ITA', 'إيطاليا'),
(15313, 1346404352, 1346408447, 'AT', 'AUT', 'النمسا'),
(15314, 1346408448, 1346412543, 'LU', 'LUX', 'لوكسيمبورغ'),
(15315, 1346412544, 1346416639, 'RU', 'RUS', 'الإتحاد الروسي'),
(15316, 1346416640, 1346420735, 'DE', 'DEU', 'ألمانيا'),
(15317, 1346420736, 1346424831, 'NO', 'NOR', 'النرويج'),
(15318, 1346424832, 1346428927, 'JO', 'JOR', 'الأردن'),
(15319, 1346428928, 1346431743, 'FR', 'FRA', 'فرنسا'),
(15320, 1346431744, 1346431999, 'KZ', 'KAZ', 'كازاخستان'),
(15321, 1346432000, 1346433023, 'FR', 'FRA', 'فرنسا'),
(15322, 1346433024, 1346439167, 'NL', 'NLD', 'هولندا'),
(15323, 1346439168, 1346440447, 'ES', 'ESP', 'إسبانيا'),
(15324, 1346440448, 1346440463, 'NL', 'NLD', 'هولندا'),
(15325, 1346440464, 1346440479, 'ES', 'ESP', 'إسبانيا'),
(15326, 1346440480, 1346441215, 'NL', 'NLD', 'هولندا'),
(15327, 1346441216, 1346445311, 'RU', 'RUS', 'الإتحاد الروسي'),
(15328, 1346445312, 1346449407, 'DE', 'DEU', 'ألمانيا'),
(15329, 1346449408, 1346453503, 'NO', 'NOR', 'النرويج'),
(15330, 1346453504, 1346461695, 'BA', 'BIH', 'البوسنه والهرسك'),
(15331, 1346461696, 1346469887, 'NL', 'NLD', 'هولندا'),
(15332, 1346469888, 1346473983, 'BE', 'BEL', 'بلجيكا'),
(15333, 1346473984, 1346477823, 'IT', 'ITA', 'إيطاليا'),
(15334, 1346477824, 1346477855, 'HU', 'HUN', 'هنغاريا'),
(15335, 1346477856, 1346478079, 'IT', 'ITA', 'إيطاليا'),
(15336, 1346478080, 1346482175, 'BA', 'BIH', 'البوسنه والهرسك'),
(15337, 1346482176, 1346486271, 'CZ', 'CZE', 'التشيك'),
(15338, 1346486272, 1346490367, 'SE', 'SWE', 'السويد'),
(15339, 1346490368, 1346494463, 'GB', 'GBR', 'المملكة المتحدة'),
(15340, 1346494464, 1346498559, 'FR', 'FRA', 'فرنسا'),
(15341, 1346498560, 1346502655, 'GB', 'GBR', 'المملكة المتحدة'),
(15342, 1346502656, 1346510847, 'DE', 'DEU', 'ألمانيا'),
(15343, 1346510848, 1346519039, 'AT', 'AUT', 'النمسا'),
(15344, 1346519040, 1346527231, 'RU', 'RUS', 'الإتحاد الروسي'),
(15345, 1346527232, 1346531327, 'DE', 'DEU', 'ألمانيا'),
(15346, 1346531328, 1346535423, 'ES', 'ESP', 'إسبانيا'),
(15347, 1346535424, 1346537983, 'BE', 'BEL', 'بلجيكا'),
(15348, 1346537984, 1346537988, 'AT', 'AUT', 'النمسا'),
(15349, 1346537989, 1346537991, 'BE', 'BEL', 'بلجيكا'),
(15350, 1346537992, 1346537999, 'AT', 'AUT', 'النمسا'),
(15351, 1346538000, 1346538007, 'CZ', 'CZE', 'التشيك'),
(15352, 1346538008, 1346538015, 'BE', 'BEL', 'بلجيكا'),
(15353, 1346538016, 1346538031, 'CH', 'CHE', 'سويسرا'),
(15354, 1346538032, 1346538143, 'BE', 'BEL', 'بلجيكا'),
(15355, 1346538144, 1346538175, 'HR', 'HRV', 'كرواتيا'),
(15356, 1346538176, 1346539519, 'BE', 'BEL', 'بلجيكا'),
(15357, 1346539520, 1346543615, 'RU', 'RUS', 'الإتحاد الروسي'),
(15358, 1346543616, 1346547711, 'FI', 'FIN', 'فنلندا'),
(15359, 1346547712, 1346551807, 'IR', 'IRN', 'إيران'),
(15360, 1346551808, 1346555903, 'DE', 'DEU', 'ألمانيا'),
(15361, 1346555904, 1346559999, 'IT', 'ITA', 'إيطاليا'),
(15362, 1346560000, 1346563071, 'LI', 'LIE', 'ليختنشتاين'),
(15363, 1346563072, 1346563327, 'CH', 'CHE', 'سويسرا'),
(15364, 1346563328, 1346564095, 'LI', 'LIE', 'ليختنشتاين'),
(15365, 1346564096, 1346568191, 'EE', 'EST', 'إستونيا'),
(15366, 1346568192, 1346572287, 'SE', 'SWE', 'السويد'),
(15367, 1346572288, 1346576383, 'DE', 'DEU', 'ألمانيا'),
(15368, 1346576384, 1346580479, 'DK', 'DNK', 'الدنيمارك'),
(15369, 1346580480, 1346584575, 'RU', 'RUS', 'الإتحاد الروسي'),
(15370, 1346584576, 1346588159, 'US', 'USA', 'الولايات المتحدة'),
(15371, 1346588160, 1346588671, 'KR', 'KOR', 'جمهورية كوريا'),
(15372, 1346588672, 1346589439, 'US', 'USA', 'الولايات المتحدة'),
(15373, 1346589440, 1346589695, 'DE', 'DEU', 'ألمانيا'),
(15374, 1346589696, 1346592767, 'US', 'USA', 'الولايات المتحدة'),
(15375, 1346592768, 1346596863, 'ES', 'ESP', 'إسبانيا'),
(15376, 1346596864, 1346600959, 'IT', 'ITA', 'إيطاليا'),
(15377, 1346605056, 1346609151, 'CH', 'CHE', 'سويسرا'),
(15378, 1346609152, 1346617343, 'FR', 'FRA', 'فرنسا'),
(15379, 1346617344, 1346620415, 'SE', 'SWE', 'السويد'),
(15380, 1346620416, 1346620927, 'DK', 'DNK', 'الدنيمارك'),
(15381, 1346620928, 1346621439, 'SE', 'SWE', 'السويد'),
(15382, 1346621440, 1346625535, 'RU', 'RUS', 'الإتحاد الروسي'),
(15383, 1346625536, 1346629631, 'DE', 'DEU', 'ألمانيا'),
(15384, 1346629632, 1346637823, 'RU', 'RUS', 'الإتحاد الروسي'),
(15385, 1346637824, 1346650111, 'GB', 'GBR', 'المملكة المتحدة'),
(15386, 1346650112, 1346654207, 'RU', 'RUS', 'الإتحاد الروسي'),
(15387, 1346654208, 1346658303, 'GB', 'GBR', 'المملكة المتحدة'),
(15388, 1346658304, 1346666495, 'SE', 'SWE', 'السويد'),
(15389, 1346666496, 1346670591, 'ES', 'ESP', 'إسبانيا'),
(15390, 1346670592, 1346674687, 'IT', 'ITA', 'إيطاليا'),
(15391, 1346674688, 1346678783, 'DE', 'DEU', 'ألمانيا'),
(15392, 1346678784, 1346686975, 'IT', 'ITA', 'إيطاليا'),
(15393, 1346686976, 1346691071, 'GB', 'GBR', 'المملكة المتحدة'),
(15394, 1346691072, 1346695167, 'PL', 'POL', 'بولندا'),
(15395, 1346695168, 1346699263, 'RU', 'RUS', 'الإتحاد الروسي'),
(15396, 1346699264, 1346700575, 'GB', 'GBR', 'المملكة المتحدة'),
(15397, 1346700576, 1346700591, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(15398, 1346700592, 1346700608, 'GB', 'GBR', 'المملكة المتحدة'),
(15399, 1346700609, 1346700623, 'US', 'USA', 'الولايات المتحدة'),
(15400, 1346700624, 1346700847, 'GB', 'GBR', 'المملكة المتحدة'),
(15401, 1346700848, 1346700855, 'US', 'USA', 'الولايات المتحدة'),
(15402, 1346700856, 1346701184, 'GB', 'GBR', 'المملكة المتحدة'),
(15403, 1346701185, 1346701215, 'GR', 'GRC', 'اليونان'),
(15404, 1346701216, 1346703871, 'GB', 'GBR', 'المملكة المتحدة'),
(15405, 1346703872, 1346704127, 'LI', 'LIE', 'ليختنشتاين'),
(15406, 1346704128, 1346704479, 'GB', 'GBR', 'المملكة المتحدة'),
(15407, 1346704480, 1346704511, 'US', 'USA', 'الولايات المتحدة'),
(15408, 1346704512, 1346704639, 'GB', 'GBR', 'المملكة المتحدة'),
(15409, 1346704640, 1346704767, 'LI', 'LIE', 'ليختنشتاين'),
(15410, 1346704768, 1346707455, 'GB', 'GBR', 'المملكة المتحدة'),
(15411, 1346707456, 1346711551, 'DE', 'DEU', 'ألمانيا'),
(15412, 1346711552, 1346715647, 'AZ', 'AZE', 'أذربيجان'),
(15413, 1346715648, 1346723839, 'NL', 'NLD', 'هولندا'),
(15414, 1346723840, 1346732031, 'DE', 'DEU', 'ألمانيا'),
(15415, 1346732032, 1346736127, 'GB', 'GBR', 'المملكة المتحدة'),
(15416, 1346736128, 1346740223, 'RU', 'RUS', 'الإتحاد الروسي'),
(15417, 1346740224, 1346744319, 'FI', 'FIN', 'فنلندا'),
(15418, 1346744320, 1346748415, 'RU', 'RUS', 'الإتحاد الروسي'),
(15419, 1346748416, 1346752511, 'DE', 'DEU', 'ألمانيا'),
(15420, 1346752512, 1346756607, 'FR', 'FRA', 'فرنسا'),
(15421, 1346756608, 1346760703, 'SE', 'SWE', 'السويد'),
(15422, 1346760704, 1346764799, 'IR', 'IRN', 'إيران'),
(15423, 1346764800, 1346768895, 'DK', 'DNK', 'الدنيمارك'),
(15424, 1346768896, 1346772991, 'LV', 'LVA', 'لاتفيا'),
(15425, 1346772992, 1346777087, 'FR', 'FRA', 'فرنسا'),
(15426, 1346777088, 1346781183, 'GB', 'GBR', 'المملكة المتحدة'),
(15427, 1346781184, 1346789375, 'UA', 'UKR', 'أوكرانيا'),
(15428, 1346789376, 1346793471, 'RU', 'RUS', 'الإتحاد الروسي'),
(15429, 1346793472, 1346797567, 'IT', 'ITA', 'إيطاليا'),
(15430, 1346797568, 1346801663, 'IL', 'ISR', 'إسرائيل'),
(15431, 1346801664, 1346805759, 'SE', 'SWE', 'السويد'),
(15432, 1346805760, 1346806079, 'DE', 'DEU', 'ألمانيا'),
(15433, 1346806080, 1346806111, 'GB', 'GBR', 'المملكة المتحدة'),
(15434, 1346806112, 1346806167, 'DE', 'DEU', 'ألمانيا'),
(15435, 1346806168, 1346806207, 'SE', 'SWE', 'السويد'),
(15436, 1346806208, 1346818047, 'DE', 'DEU', 'ألمانيا'),
(15437, 1346818048, 1346822143, 'FR', 'FRA', 'فرنسا'),
(15438, 1346822144, 1346826239, 'RU', 'RUS', 'الإتحاد الروسي'),
(15439, 1346826240, 1346830335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15440, 1346830336, 1346838527, 'GB', 'GBR', 'المملكة المتحدة'),
(15441, 1346838528, 1346842623, 'RU', 'RUS', 'الإتحاد الروسي'),
(15442, 1346842624, 1346846719, 'MT', 'MLT', 'مالطا'),
(15443, 1346846720, 1346854911, 'DK', 'DNK', 'الدنيمارك'),
(15444, 1346854912, 1346859007, 'MT', 'MLT', 'مالطا'),
(15445, 1346859008, 1346863103, 'IR', 'IRN', 'إيران'),
(15446, 1346863104, 1346867199, 'TR', 'TUR', 'تركيا'),
(15447, 1346867200, 1346871295, 'BA', 'BIH', 'البوسنه والهرسك'),
(15448, 1346871296, 1346879487, 'RU', 'RUS', 'الإتحاد الروسي'),
(15449, 1346879488, 1346883583, 'FI', 'FIN', 'فنلندا'),
(15450, 1346883584, 1346887679, 'RU', 'RUS', 'الإتحاد الروسي'),
(15451, 1346887680, 1346891775, 'IT', 'ITA', 'إيطاليا'),
(15452, 1346891776, 1346895871, 'RU', 'RUS', 'الإتحاد الروسي'),
(15453, 1346895872, 1346899967, 'SE', 'SWE', 'السويد'),
(15454, 1346899968, 1346904063, 'RU', 'RUS', 'الإتحاد الروسي'),
(15455, 1346904064, 1346908159, 'PL', 'POL', 'بولندا'),
(15456, 1346908160, 1346912255, 'LI', 'LIE', 'ليختنشتاين'),
(15457, 1346912256, 1346920447, 'BG', 'BGR', 'بلغاريا'),
(15458, 1346924544, 1346928639, 'RU', 'RUS', 'الإتحاد الروسي'),
(15459, 1346928640, 1346932735, 'DE', 'DEU', 'ألمانيا'),
(15460, 1346932736, 1346936831, 'DK', 'DNK', 'الدنيمارك'),
(15461, 1346936832, 1346940927, 'IT', 'ITA', 'إيطاليا'),
(15462, 1346940928, 1346945023, 'DE', 'DEU', 'ألمانيا'),
(15463, 1346945024, 1346949119, 'PL', 'POL', 'بولندا'),
(15464, 1346949120, 1346957311, 'RU', 'RUS', 'الإتحاد الروسي'),
(15465, 1346957312, 1346961407, 'DE', 'DEU', 'ألمانيا'),
(15466, 1346961408, 1346965503, 'UA', 'UKR', 'أوكرانيا'),
(15467, 1346965504, 1346969599, 'RU', 'RUS', 'الإتحاد الروسي'),
(15468, 1346969600, 1346973695, 'DE', 'DEU', 'ألمانيا'),
(15469, 1346973696, 1346977791, 'SE', 'SWE', 'السويد'),
(15470, 1346977792, 1346985983, 'RU', 'RUS', 'الإتحاد الروسي'),
(15471, 1346985984, 1346986975, 'DE', 'DEU', 'ألمانيا'),
(15472, 1346986976, 1346987007, 'ES', 'ESP', 'إسبانيا'),
(15473, 1346987008, 1346991231, 'DE', 'DEU', 'ألمانيا'),
(15474, 1346991232, 1346991247, 'CH', 'CHE', 'سويسرا'),
(15475, 1346991248, 1346994175, 'DE', 'DEU', 'ألمانيا'),
(15476, 1346994176, 1346998271, 'NL', 'NLD', 'هولندا'),
(15477, 1346998272, 1347002367, 'ES', 'ESP', 'إسبانيا'),
(15478, 1347002368, 1347006463, 'RU', 'RUS', 'الإتحاد الروسي'),
(15479, 1347006464, 1347010559, 'SE', 'SWE', 'السويد'),
(15480, 1347010560, 1347014655, 'RU', 'RUS', 'الإتحاد الروسي'),
(15481, 1347014656, 1347018751, 'GB', 'GBR', 'المملكة المتحدة'),
(15482, 1347018752, 1347022847, 'IT', 'ITA', 'إيطاليا'),
(15483, 1347022848, 1347024895, 'AT', 'AUT', 'النمسا'),
(15484, 1347024896, 1347025071, 'GB', 'GBR', 'المملكة المتحدة'),
(15485, 1347025072, 1347025079, 'FR', 'FRA', 'فرنسا'),
(15486, 1347025080, 1347025103, 'GB', 'GBR', 'المملكة المتحدة'),
(15487, 1347025104, 1347025111, 'FR', 'FRA', 'فرنسا'),
(15488, 1347025112, 1347025151, 'GB', 'GBR', 'المملكة المتحدة'),
(15489, 1347025152, 1347025215, 'US', 'USA', 'الولايات المتحدة'),
(15490, 1347025216, 1347025279, 'GB', 'GBR', 'المملكة المتحدة'),
(15491, 1347025280, 1347025343, 'ES', 'ESP', 'إسبانيا'),
(15492, 1347025344, 1347025407, 'DE', 'DEU', 'ألمانيا'),
(15493, 1347025408, 1347026943, 'AT', 'AUT', 'النمسا'),
(15494, 1347026944, 1347035135, 'GB', 'GBR', 'المملكة المتحدة'),
(15495, 1347035136, 1347039231, 'CZ', 'CZE', 'التشيك'),
(15496, 1347039232, 1347043327, 'RO', 'ROM', 'رومانيا'),
(15497, 1347043328, 1347047423, 'FR', 'FRA', 'فرنسا'),
(15498, 1347047424, 1347051519, 'SA', 'SAU', 'السعودية'),
(15499, 1347051520, 1347059711, 'IL', 'ISR', 'إسرائيل'),
(15500, 1347059712, 1347067903, 'CH', 'CHE', 'سويسرا'),
(15501, 1347067904, 1347071743, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15502, 1347071744, 1347071751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15503, 1347071752, 1347071759, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15504, 1347071760, 1347071767, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15505, 1347071768, 1347071775, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15506, 1347071776, 1347071791, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15507, 1347071792, 1347071999, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15508, 1347072000, 1347076095, 'IT', 'ITA', 'إيطاليا'),
(15509, 1347076096, 1347084287, 'FI', 'FIN', 'فنلندا'),
(15510, 1347084288, 1347092479, 'GB', 'GBR', 'المملكة المتحدة'),
(15511, 1347092480, 1347096575, 'IR', 'IRN', 'إيران'),
(15512, 1347096576, 1347100671, 'SE', 'SWE', 'السويد'),
(15513, 1347100672, 1347108863, 'AT', 'AUT', 'النمسا'),
(15514, 1347108864, 1347112959, 'GB', 'GBR', 'المملكة المتحدة'),
(15515, 1347112960, 1347117055, 'RU', 'RUS', 'الإتحاد الروسي'),
(15516, 1347117056, 1347121151, 'FI', 'FIN', 'فنلندا'),
(15517, 1347121152, 1347125247, 'CH', 'CHE', 'سويسرا'),
(15518, 1347125248, 1347129343, 'RU', 'RUS', 'الإتحاد الروسي'),
(15519, 1347129344, 1347133439, 'GB', 'GBR', 'المملكة المتحدة'),
(15520, 1347141632, 1347145727, 'CH', 'CHE', 'سويسرا'),
(15521, 1347145728, 1347146239, 'GB', 'GBR', 'المملكة المتحدة'),
(15522, 1347146240, 1347146751, 'FR', 'FRA', 'فرنسا'),
(15523, 1347146752, 1347149823, 'GB', 'GBR', 'المملكة المتحدة'),
(15524, 1347149824, 1347153919, 'HU', 'HUN', 'هنغاريا'),
(15525, 1347153920, 1347158015, 'AT', 'AUT', 'النمسا'),
(15526, 1347158016, 1347162111, 'CH', 'CHE', 'سويسرا'),
(15527, 1347162112, 1347166207, 'IT', 'ITA', 'إيطاليا'),
(15528, 1347166208, 1347174399, 'GR', 'GRC', 'اليونان'),
(15529, 1347174400, 1347186687, 'IT', 'ITA', 'إيطاليا'),
(15530, 1347186688, 1347190783, 'GB', 'GBR', 'المملكة المتحدة'),
(15531, 1347190784, 1347194879, 'RU', 'RUS', 'الإتحاد الروسي'),
(15532, 1347194880, 1347198975, 'SE', 'SWE', 'السويد'),
(15533, 1347198976, 1347203071, 'QA', 'QAT', 'قطر'),
(15534, 1347203072, 1347207167, 'RU', 'RUS', 'الإتحاد الروسي'),
(15535, 1347207168, 1347210735, 'GB', 'GBR', 'المملكة المتحدة'),
(15536, 1347210736, 1347210743, 'IE', 'IRL', 'إيرلندا'),
(15537, 1347210744, 1347210911, 'GB', 'GBR', 'المملكة المتحدة'),
(15538, 1347210912, 1347210919, 'IE', 'IRL', 'إيرلندا'),
(15539, 1347210920, 1347210927, 'GB', 'GBR', 'المملكة المتحدة'),
(15540, 1347210928, 1347210935, 'IE', 'IRL', 'إيرلندا'),
(15541, 1347210936, 1347211111, 'GB', 'GBR', 'المملكة المتحدة'),
(15542, 1347211112, 1347211119, 'IE', 'IRL', 'إيرلندا'),
(15543, 1347211120, 1347215359, 'GB', 'GBR', 'المملكة المتحدة'),
(15544, 1347215360, 1347219455, 'RU', 'RUS', 'الإتحاد الروسي'),
(15545, 1347219456, 1347223551, 'KW', 'KWT', 'الكويت'),
(15546, 1347223552, 1347223807, 'EG', 'EGY', 'مصر'),
(15547, 1347223808, 1347224063, 'HK', 'HKG', 'هونغ كونغ'),
(15548, 1347224064, 1347224319, 'US', 'USA', 'الولايات المتحدة'),
(15549, 1347224320, 1347224575, 'EG', 'EGY', 'مصر'),
(15550, 1347224576, 1347224831, 'US', 'USA', 'الولايات المتحدة'),
(15551, 1347224832, 1347225599, 'EG', 'EGY', 'مصر'),
(15552, 1347225600, 1347226623, 'PK', 'PAK', 'باكستان'),
(15553, 1347226624, 1347227135, 'EG', 'EGY', 'مصر'),
(15554, 1347227136, 1347227391, 'HK', 'HKG', 'هونغ كونغ'),
(15555, 1347227392, 1347227647, 'EG', 'EGY', 'مصر'),
(15556, 1347227648, 1347229311, 'DE', 'DEU', 'ألمانيا'),
(15557, 1347229312, 1347229343, 'AT', 'AUT', 'النمسا'),
(15558, 1347229344, 1347231071, 'DE', 'DEU', 'ألمانيا'),
(15559, 1347231072, 1347231087, 'AT', 'AUT', 'النمسا'),
(15560, 1347231088, 1347231095, 'GR', 'GRC', 'اليونان'),
(15561, 1347231096, 1347231743, 'DE', 'DEU', 'ألمانيا'),
(15562, 1347231744, 1347235839, 'UA', 'UKR', 'أوكرانيا'),
(15563, 1347235840, 1347239935, 'GE', 'GEO', 'جورجيا'),
(15564, 1347239936, 1347244031, 'DK', 'DNK', 'الدنيمارك'),
(15565, 1347244032, 1347247359, 'GB', 'GBR', 'المملكة المتحدة'),
(15566, 1347247360, 1347247871, 'RU', 'RUS', 'الإتحاد الروسي'),
(15567, 1347247872, 1347247872, 'GB', 'GBR', 'المملكة المتحدة'),
(15568, 1347247873, 1347248127, 'US', 'USA', 'الولايات المتحدة'),
(15569, 1347248128, 1347248863, 'SE', 'SWE', 'السويد'),
(15570, 1347248864, 1347248864, 'FI', 'FIN', 'فنلندا'),
(15571, 1347248865, 1347249343, 'SE', 'SWE', 'السويد'),
(15572, 1347249344, 1347249375, 'FI', 'FIN', 'فنلندا'),
(15573, 1347249376, 1347249631, 'SE', 'SWE', 'السويد'),
(15574, 1347249632, 1347249639, 'RU', 'RUS', 'الإتحاد الروسي'),
(15575, 1347249640, 1347250687, 'SE', 'SWE', 'السويد'),
(15576, 1347250688, 1347250691, 'NO', 'NOR', 'النرويج'),
(15577, 1347250692, 1347250695, 'SE', 'SWE', 'السويد'),
(15578, 1347250696, 1347250735, 'NO', 'NOR', 'النرويج'),
(15579, 1347250736, 1347250767, 'SE', 'SWE', 'السويد'),
(15580, 1347250768, 1347250783, 'FI', 'FIN', 'فنلندا'),
(15581, 1347250784, 1347252223, 'SE', 'SWE', 'السويد'),
(15582, 1347252224, 1347255903, 'HU', 'HUN', 'هنغاريا'),
(15583, 1347255904, 1347255919, 'SC', 'SYC', 'سيشيل'),
(15584, 1347255920, 1347256319, 'HU', 'HUN', 'هنغاريا'),
(15585, 1347256320, 1347260415, 'FO', 'FRO', 'جزر فارو'),
(15586, 1347260416, 1347264511, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(15587, 1347264512, 1347268607, 'RU', 'RUS', 'الإتحاد الروسي'),
(15588, 1347268608, 1347271935, 'LB', 'LBN', 'لبنان'),
(15589, 1347271936, 1347272447, 'IQ', 'IRQ', 'العراق'),
(15590, 1347272448, 1347272703, 'LB', 'LBN', 'لبنان'),
(15591, 1347272704, 1347276799, 'MT', 'MLT', 'مالطا'),
(15592, 1347276800, 1347278831, 'DE', 'DEU', 'ألمانيا'),
(15593, 1347278832, 1347278847, 'BR', 'BRA', 'البرازيل'),
(15594, 1347278848, 1347280895, 'DE', 'DEU', 'ألمانيا'),
(15595, 1347280896, 1347284991, 'FR', 'FRA', 'فرنسا'),
(15596, 1347284992, 1347286271, 'GB', 'GBR', 'المملكة المتحدة'),
(15597, 1347286272, 1347286335, 'BN', 'BRN', 'بروناي دار السلام'),
(15598, 1347286336, 1347286527, 'GB', 'GBR', 'المملكة المتحدة'),
(15599, 1347286528, 1347286535, 'BG', 'BGR', 'بلغاريا'),
(15600, 1347286536, 1347289087, 'GB', 'GBR', 'المملكة المتحدة'),
(15601, 1347289088, 1347293183, 'FR', 'FRA', 'فرنسا'),
(15602, 1347293184, 1347293311, 'SE', 'SWE', 'السويد'),
(15603, 1347293312, 1347293319, 'LR', 'LBR', 'ليبيريا'),
(15604, 1347293320, 1347293327, 'GA', 'GAB', 'الغابون'),
(15605, 1347293328, 1347293335, 'NG', 'NGA', 'نيجيريا'),
(15606, 1347293336, 1347293339, 'SE', 'SWE', 'السويد'),
(15607, 1347293340, 1347293343, 'SO', 'SOM', 'الصومال'),
(15608, 1347293344, 1347293351, 'SE', 'SWE', 'السويد'),
(15609, 1347293352, 1347293391, 'NG', 'NGA', 'نيجيريا'),
(15610, 1347293392, 1347293399, 'CY', 'CYP', 'قبرص'),
(15611, 1347293400, 1347293407, 'IQ', 'IRQ', 'العراق'),
(15612, 1347293408, 1347293415, 'NG', 'NGA', 'نيجيريا'),
(15613, 1347293416, 1347293423, 'SE', 'SWE', 'السويد'),
(15614, 1347293424, 1347293431, 'GN', 'GIN', 'غينيا'),
(15615, 1347293432, 1347293439, 'NG', 'NGA', 'نيجيريا'),
(15616, 1347293440, 1347293447, 'SE', 'SWE', 'السويد'),
(15617, 1347293448, 1347293455, 'GB', 'GBR', 'المملكة المتحدة'),
(15618, 1347293456, 1347293463, 'NG', 'NGA', 'نيجيريا'),
(15619, 1347293464, 1347293471, 'SE', 'SWE', 'السويد'),
(15620, 1347293472, 1347293479, 'IQ', 'IRQ', 'العراق'),
(15621, 1347293480, 1347293487, 'LR', 'LBR', 'ليبيريا'),
(15622, 1347293488, 1347293495, 'TD', 'TCD', 'تشاد'),
(15623, 1347293496, 1347293503, 'GH', 'GHA', 'غانا'),
(15624, 1347293504, 1347293511, 'US', 'USA', 'الولايات المتحدة'),
(15625, 1347293512, 1347293519, 'GN', 'GIN', 'غينيا'),
(15626, 1347293520, 1347293527, 'PS', 'PSE', 'فلسطين المحتلة'),
(15627, 1347293528, 1347293535, 'NG', 'NGA', 'نيجيريا'),
(15628, 1347293536, 1347293543, 'GH', 'GHA', 'غانا'),
(15629, 1347293544, 1347293551, 'US', 'USA', 'الولايات المتحدة'),
(15630, 1347293552, 1347293559, 'SE', 'SWE', 'السويد'),
(15631, 1347293560, 1347293567, 'GN', 'GIN', 'غينيا'),
(15632, 1347293568, 1347293575, 'GH', 'GHA', 'غانا'),
(15633, 1347293576, 1347293583, 'IQ', 'IRQ', 'العراق'),
(15634, 1347293584, 1347293591, 'AF', 'AFG', 'أفغانستان'),
(15635, 1347293592, 1347293599, 'SE', 'SWE', 'السويد'),
(15636, 1347293600, 1347293607, 'NG', 'NGA', 'نيجيريا'),
(15637, 1347293608, 1347293615, 'SE', 'SWE', 'السويد'),
(15638, 1347293616, 1347293639, 'US', 'USA', 'الولايات المتحدة'),
(15639, 1347293640, 1347293647, 'IQ', 'IRQ', 'العراق'),
(15640, 1347293648, 1347293655, 'US', 'USA', 'الولايات المتحدة'),
(15641, 1347293656, 1347293675, 'GN', 'GIN', 'غينيا'),
(15642, 1347293676, 1347293679, 'BH', 'BHR', 'البحرين'),
(15643, 1347293680, 1347293687, 'GN', 'GIN', 'غينيا'),
(15644, 1347293688, 1347293723, 'NG', 'NGA', 'نيجيريا'),
(15645, 1347293724, 1347293727, 'IQ', 'IRQ', 'العراق'),
(15646, 1347293728, 1347293735, 'SE', 'SWE', 'السويد'),
(15647, 1347293736, 1347293759, 'GN', 'GIN', 'غينيا'),
(15648, 1347293760, 1347293767, 'NG', 'NGA', 'نيجيريا'),
(15649, 1347293768, 1347293775, 'CM', 'CMR', 'الكاميرون'),
(15650, 1347293776, 1347293799, 'NG', 'NGA', 'نيجيريا'),
(15651, 1347293800, 1347293807, 'IQ', 'IRQ', 'العراق'),
(15652, 1347293808, 1347293815, 'NG', 'NGA', 'نيجيريا'),
(15653, 1347293816, 1347293823, 'SO', 'SOM', 'الصومال'),
(15654, 1347293824, 1347293831, 'CM', 'CMR', 'الكاميرون'),
(15655, 1347293832, 1347293839, 'NG', 'NGA', 'نيجيريا'),
(15656, 1347293840, 1347293847, 'CA', 'CAN', 'كندا'),
(15657, 1347293848, 1347293855, 'BH', 'BHR', 'البحرين'),
(15658, 1347293856, 1347293863, 'GN', 'GIN', 'غينيا'),
(15659, 1347293864, 1347293871, 'GB', 'GBR', 'المملكة المتحدة'),
(15660, 1347293872, 1347293879, 'SE', 'SWE', 'السويد'),
(15661, 1347293880, 1347293887, 'NG', 'NGA', 'نيجيريا'),
(15662, 1347293888, 1347293903, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(15663, 1347293904, 1347293911, 'NG', 'NGA', 'نيجيريا'),
(15664, 1347293912, 1347293919, 'GA', 'GAB', 'الغابون'),
(15665, 1347293920, 1347293927, 'GB', 'GBR', 'المملكة المتحدة'),
(15666, 1347293928, 1347293935, 'US', 'USA', 'الولايات المتحدة'),
(15667, 1347293936, 1347293943, 'NG', 'NGA', 'نيجيريا'),
(15668, 1347293944, 1347293951, 'SE', 'SWE', 'السويد'),
(15669, 1347293952, 1347293959, 'NG', 'NGA', 'نيجيريا'),
(15670, 1347293960, 1347293967, 'GN', 'GIN', 'غينيا'),
(15671, 1347293968, 1347293975, 'NG', 'NGA', 'نيجيريا'),
(15672, 1347293976, 1347293983, 'GN', 'GIN', 'غينيا'),
(15673, 1347293984, 1347293991, 'US', 'USA', 'الولايات المتحدة'),
(15674, 1347293992, 1347293999, 'NG', 'NGA', 'نيجيريا'),
(15675, 1347294000, 1347294007, 'US', 'USA', 'الولايات المتحدة'),
(15676, 1347294008, 1347294015, 'SE', 'SWE', 'السويد'),
(15677, 1347294016, 1347294023, 'US', 'USA', 'الولايات المتحدة'),
(15678, 1347294024, 1347294039, 'GN', 'GIN', 'غينيا'),
(15679, 1347294040, 1347294047, 'GB', 'GBR', 'المملكة المتحدة'),
(15680, 1347294048, 1347294055, 'TH', 'THA', 'تايلند'),
(15681, 1347294056, 1347294063, 'NG', 'NGA', 'نيجيريا'),
(15682, 1347294064, 1347294071, 'GH', 'GHA', 'غانا'),
(15683, 1347294072, 1347294079, 'NG', 'NGA', 'نيجيريا'),
(15684, 1347294080, 1347294087, 'SE', 'SWE', 'السويد'),
(15685, 1347294088, 1347294095, 'US', 'USA', 'الولايات المتحدة'),
(15686, 1347294096, 1347294111, 'CM', 'CMR', 'الكاميرون'),
(15687, 1347294112, 1347294119, 'GN', 'GIN', 'غينيا'),
(15688, 1347294120, 1347294127, 'SE', 'SWE', 'السويد'),
(15689, 1347294128, 1347294135, 'NG', 'NGA', 'نيجيريا'),
(15690, 1347294136, 1347294143, 'LR', 'LBR', 'ليبيريا'),
(15691, 1347294144, 1347294151, 'NG', 'NGA', 'نيجيريا'),
(15692, 1347294152, 1347294159, 'GB', 'GBR', 'المملكة المتحدة'),
(15693, 1347294160, 1347294167, 'CM', 'CMR', 'الكاميرون'),
(15694, 1347294168, 1347294175, 'GB', 'GBR', 'المملكة المتحدة'),
(15695, 1347294176, 1347294183, 'NG', 'NGA', 'نيجيريا'),
(15696, 1347294184, 1347294191, 'SE', 'SWE', 'السويد'),
(15697, 1347294192, 1347294199, 'GB', 'GBR', 'المملكة المتحدة'),
(15698, 1347294200, 1347294207, 'NG', 'NGA', 'نيجيريا'),
(15699, 1347294208, 1347294215, 'SE', 'SWE', 'السويد'),
(15700, 1347294216, 1347294223, 'IQ', 'IRQ', 'العراق'),
(15701, 1347294224, 1347294231, 'SE', 'SWE', 'السويد'),
(15702, 1347294232, 1347294239, 'US', 'USA', 'الولايات المتحدة'),
(15703, 1347294240, 1347294271, 'SE', 'SWE', 'السويد'),
(15704, 1347294272, 1347294279, 'BH', 'BHR', 'البحرين'),
(15705, 1347294280, 1347294287, 'BD', 'BGD', 'بنغالاديش'),
(15706, 1347294288, 1347294303, 'UG', 'UGA', 'أوغاندا'),
(15707, 1347294304, 1347294311, 'US', 'USA', 'الولايات المتحدة'),
(15708, 1347294312, 1347294319, 'SE', 'SWE', 'السويد'),
(15709, 1347294320, 1347294327, 'NG', 'NGA', 'نيجيريا'),
(15710, 1347294328, 1347294343, 'SE', 'SWE', 'السويد'),
(15711, 1347294344, 1347294351, 'CM', 'CMR', 'الكاميرون'),
(15712, 1347294352, 1347294367, 'LR', 'LBR', 'ليبيريا'),
(15713, 1347294368, 1347294375, 'NG', 'NGA', 'نيجيريا'),
(15714, 1347294376, 1347294383, 'SE', 'SWE', 'السويد'),
(15715, 1347294384, 1347294399, 'NG', 'NGA', 'نيجيريا'),
(15716, 1347294400, 1347294407, 'SE', 'SWE', 'السويد'),
(15717, 1347294408, 1347294415, 'GN', 'GIN', 'غينيا'),
(15718, 1347294416, 1347294423, 'SE', 'SWE', 'السويد'),
(15719, 1347294424, 1347294431, 'KW', 'KWT', 'الكويت'),
(15720, 1347294432, 1347294435, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(15721, 1347294436, 1347294439, 'SE', 'SWE', 'السويد'),
(15722, 1347294440, 1347294447, 'SO', 'SOM', 'الصومال'),
(15723, 1347294448, 1347294975, 'US', 'USA', 'الولايات المتحدة'),
(15724, 1347294976, 1347294991, 'SE', 'SWE', 'السويد'),
(15725, 1347294992, 1347295007, 'NG', 'NGA', 'نيجيريا'),
(15726, 1347295008, 1347295039, 'SE', 'SWE', 'السويد'),
(15727, 1347295040, 1347295047, 'GB', 'GBR', 'المملكة المتحدة'),
(15728, 1347295048, 1347295055, 'IQ', 'IRQ', 'العراق'),
(15729, 1347295056, 1347295063, 'AF', 'AFG', 'أفغانستان'),
(15730, 1347295064, 1347295071, 'SE', 'SWE', 'السويد'),
(15731, 1347295072, 1347295079, 'US', 'USA', 'الولايات المتحدة'),
(15732, 1347295080, 1347295087, 'NG', 'NGA', 'نيجيريا'),
(15733, 1347295088, 1347295095, 'SE', 'SWE', 'السويد'),
(15734, 1347295096, 1347295103, 'NG', 'NGA', 'نيجيريا'),
(15735, 1347295104, 1347295143, 'SE', 'SWE', 'السويد'),
(15736, 1347295144, 1347295151, 'IQ', 'IRQ', 'العراق'),
(15737, 1347295152, 1347295159, 'US', 'USA', 'الولايات المتحدة'),
(15738, 1347295160, 1347295199, 'SE', 'SWE', 'السويد'),
(15739, 1347295200, 1347295215, 'GB', 'GBR', 'المملكة المتحدة'),
(15740, 1347295216, 1347295223, 'SE', 'SWE', 'السويد'),
(15741, 1347295224, 1347295231, 'CH', 'CHE', 'سويسرا'),
(15742, 1347295232, 1347295743, 'SE', 'SWE', 'السويد'),
(15743, 1347295744, 1347295755, 'US', 'USA', 'الولايات المتحدة'),
(15744, 1347295756, 1347295759, 'SE', 'SWE', 'السويد'),
(15745, 1347295760, 1347295775, 'US', 'USA', 'الولايات المتحدة'),
(15746, 1347295776, 1347295783, 'IQ', 'IRQ', 'العراق'),
(15747, 1347295784, 1347295999, 'SE', 'SWE', 'السويد'),
(15748, 1347296000, 1347296015, 'US', 'USA', 'الولايات المتحدة'),
(15749, 1347296016, 1347297279, 'SE', 'SWE', 'السويد'),
(15750, 1347297280, 1347305471, 'UA', 'UKR', 'أوكرانيا'),
(15751, 1347305472, 1347309567, 'AL', 'ALB', 'ألبانيا'),
(15752, 1347309568, 1347309839, 'DE', 'DEU', 'ألمانيا'),
(15753, 1347309840, 1347309855, 'CH', 'CHE', 'سويسرا'),
(15754, 1347309856, 1347313663, 'DE', 'DEU', 'ألمانيا'),
(15755, 1347313664, 1347321855, 'RU', 'RUS', 'الإتحاد الروسي'),
(15756, 1347321856, 1347323775, 'KW', 'KWT', 'الكويت'),
(15757, 1347323776, 1347323903, 'IR', 'IRN', 'إيران'),
(15758, 1347323904, 1347325183, 'KW', 'KWT', 'الكويت'),
(15759, 1347325184, 1347325439, 'SA', 'SAU', 'السعودية'),
(15760, 1347325440, 1347325951, 'KW', 'KWT', 'الكويت'),
(15761, 1347325952, 1347327231, 'CZ', 'CZE', 'التشيك'),
(15762, 1347327232, 1347327487, 'SK', 'SVK', 'سلوفاكيا'),
(15763, 1347327488, 1347327743, 'CZ', 'CZE', 'التشيك'),
(15764, 1347327744, 1347327999, 'SK', 'SVK', 'سلوفاكيا'),
(15765, 1347328000, 1347329535, 'CZ', 'CZE', 'التشيك'),
(15766, 1347329536, 1347329599, 'SK', 'SVK', 'سلوفاكيا'),
(15767, 1347329600, 1347330047, 'CZ', 'CZE', 'التشيك'),
(15768, 1347330048, 1347338239, 'DE', 'DEU', 'ألمانيا'),
(15769, 1347338240, 1347342335, 'RU', 'RUS', 'الإتحاد الروسي'),
(15770, 1347342336, 1347346431, 'SE', 'SWE', 'السويد'),
(15771, 1347354624, 1347358719, 'PT', 'PRT', 'البورتوغال'),
(15772, 1347358720, 1347362815, 'CZ', 'CZE', 'التشيك'),
(15773, 1347362816, 1347366911, 'NL', 'NLD', 'هولندا'),
(15774, 1347366912, 1347371007, 'IT', 'ITA', 'إيطاليا'),
(15775, 1347371008, 1347375103, 'RU', 'RUS', 'الإتحاد الروسي'),
(15776, 1347375104, 1347379199, 'GB', 'GBR', 'المملكة المتحدة'),
(15777, 1347379200, 1347383295, 'NL', 'NLD', 'هولندا'),
(15778, 1347383296, 1347383695, 'EE', 'EST', 'إستونيا'),
(15779, 1347383696, 1347383699, 'IL', 'ISR', 'إسرائيل'),
(15780, 1347383700, 1347384231, 'EE', 'EST', 'إستونيا'),
(15781, 1347384232, 1347384235, 'IL', 'ISR', 'إسرائيل'),
(15782, 1347384236, 1347385031, 'EE', 'EST', 'إستونيا'),
(15783, 1347385032, 1347385035, 'IL', 'ISR', 'إسرائيل'),
(15784, 1347385036, 1347385171, 'EE', 'EST', 'إستونيا'),
(15785, 1347385172, 1347385175, 'IL', 'ISR', 'إسرائيل'),
(15786, 1347385176, 1347387391, 'EE', 'EST', 'إستونيا'),
(15787, 1347387392, 1347391487, 'GB', 'GBR', 'المملكة المتحدة'),
(15788, 1347391488, 1347395583, 'LB', 'LBN', 'لبنان'),
(15789, 1347395584, 1347399679, 'SE', 'SWE', 'السويد'),
(15790, 1347399680, 1347403775, 'RU', 'RUS', 'الإتحاد الروسي'),
(15791, 1347403776, 1347407871, 'NL', 'NLD', 'هولندا'),
(15792, 1347407872, 1347411967, 'GB', 'GBR', 'المملكة المتحدة'),
(15793, 1347411968, 1347416063, 'DE', 'DEU', 'ألمانيا'),
(15794, 1347416064, 1347420159, 'RU', 'RUS', 'الإتحاد الروسي'),
(15795, 1347420160, 1347420671, 'DK', 'DNK', 'الدنيمارك'),
(15796, 1347420672, 1347420679, 'SE', 'SWE', 'السويد'),
(15797, 1347420680, 1347420791, 'DK', 'DNK', 'الدنيمارك'),
(15798, 1347420792, 1347420799, 'US', 'USA', 'الولايات المتحدة'),
(15799, 1347420800, 1347420831, 'DK', 'DNK', 'الدنيمارك'),
(15800, 1347420832, 1347420847, 'US', 'USA', 'الولايات المتحدة'),
(15801, 1347420848, 1347420991, 'DK', 'DNK', 'الدنيمارك'),
(15802, 1347420992, 1347421007, 'CH', 'CHE', 'سويسرا'),
(15803, 1347421008, 1347423775, 'DK', 'DNK', 'الدنيمارك'),
(15804, 1347423776, 1347423807, 'NO', 'NOR', 'النرويج'),
(15805, 1347423808, 1347424339, 'DK', 'DNK', 'الدنيمارك'),
(15806, 1347424340, 1347424351, 'NO', 'NOR', 'النرويج'),
(15807, 1347424352, 1347427135, 'DK', 'DNK', 'الدنيمارك'),
(15808, 1347427136, 1347427327, 'NO', 'NOR', 'النرويج'),
(15809, 1347427328, 1347428351, 'DK', 'DNK', 'الدنيمارك'),
(15810, 1347428352, 1347432447, 'IT', 'ITA', 'إيطاليا'),
(15811, 1347432448, 1347436543, 'HR', 'HRV', 'كرواتيا'),
(15812, 1347436544, 1347440639, 'SE', 'SWE', 'السويد'),
(15813, 1347440640, 1347444735, 'ES', 'ESP', 'إسبانيا'),
(15814, 1347444736, 1347452927, 'RU', 'RUS', 'الإتحاد الروسي'),
(15815, 1347452928, 1347461119, 'BG', 'BGR', 'بلغاريا'),
(15816, 1347461120, 1347465215, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(15817, 1347465216, 1347469311, 'GB', 'GBR', 'المملكة المتحدة'),
(15818, 1347469312, 1347473407, 'RU', 'RUS', 'الإتحاد الروسي'),
(15819, 1347473408, 1347477503, 'UZ', 'UZB', 'أوزباكستان'),
(15820, 1347477504, 1347481599, 'CH', 'CHE', 'سويسرا'),
(15821, 1347481600, 1347485695, 'AT', 'AUT', 'النمسا'),
(15822, 1347485696, 1347493887, 'DE', 'DEU', 'ألمانيا'),
(15823, 1347493888, 1347502079, 'LV', 'LVA', 'لاتفيا'),
(15824, 1347502080, 1347503103, 'ES', 'ESP', 'إسبانيا'),
(15825, 1347503104, 1347503359, 'GB', 'GBR', 'المملكة المتحدة'),
(15826, 1347503360, 1347504383, 'ES', 'ESP', 'إسبانيا'),
(15827, 1347504384, 1347504639, 'GB', 'GBR', 'المملكة المتحدة'),
(15828, 1347504640, 1347504959, 'ES', 'ESP', 'إسبانيا'),
(15829, 1347504960, 1347505023, 'GB', 'GBR', 'المملكة المتحدة'),
(15830, 1347505024, 1347506175, 'ES', 'ESP', 'إسبانيا'),
(15831, 1347506176, 1347510271, 'FR', 'FRA', 'فرنسا'),
(15832, 1347510272, 1347518463, 'ES', 'ESP', 'إسبانيا'),
(15833, 1347518464, 1347522559, 'AT', 'AUT', 'النمسا'),
(15834, 1347522560, 1347526655, 'LB', 'LBN', 'لبنان'),
(15835, 1347526656, 1347527967, 'FI', 'FIN', 'فنلندا'),
(15836, 1347527968, 1347527999, 'SE', 'SWE', 'السويد'),
(15837, 1347528000, 1347534847, 'FI', 'FIN', 'فنلندا'),
(15838, 1347534848, 1347538943, 'DE', 'DEU', 'ألمانيا'),
(15839, 1347538944, 1347543039, 'RU', 'RUS', 'الإتحاد الروسي'),
(15840, 1347543040, 1347544063, 'SK', 'SVK', 'سلوفاكيا'),
(15841, 1347544064, 1347544319, 'SL', 'SLE', 'سيراليون'),
(15842, 1347544320, 1347547135, 'SK', 'SVK', 'سلوفاكيا'),
(15843, 1347547136, 1347550303, 'DE', 'DEU', 'ألمانيا'),
(15844, 1347550304, 1347550335, 'AT', 'AUT', 'النمسا'),
(15845, 1347550336, 1347551167, 'DE', 'DEU', 'ألمانيا'),
(15846, 1347551168, 1347551231, 'PL', 'POL', 'بولندا'),
(15847, 1347551232, 1347555327, 'IT', 'ITA', 'إيطاليا'),
(15848, 1347555328, 1347559423, 'PL', 'POL', 'بولندا'),
(15849, 1347559424, 1347567615, 'RU', 'RUS', 'الإتحاد الروسي'),
(15850, 1347567616, 1347571711, 'CH', 'CHE', 'سويسرا'),
(15851, 1347571712, 1347575807, 'RU', 'RUS', 'الإتحاد الروسي'),
(15852, 1347575808, 1347579903, 'DK', 'DNK', 'الدنيمارك'),
(15853, 1347579904, 1347588095, 'GB', 'GBR', 'المملكة المتحدة'),
(15854, 1347588096, 1347592191, 'CZ', 'CZE', 'التشيك'),
(15855, 1347592192, 1347600383, 'RU', 'RUS', 'الإتحاد الروسي'),
(15856, 1347600384, 1347604479, 'IT', 'ITA', 'إيطاليا'),
(15857, 1347604480, 1347608575, 'DE', 'DEU', 'ألمانيا'),
(15858, 1347608576, 1347612671, 'FR', 'FRA', 'فرنسا'),
(15859, 1347612672, 1347616767, 'GB', 'GBR', 'المملكة المتحدة'),
(15860, 1347616768, 1347620863, 'FI', 'FIN', 'فنلندا'),
(15861, 1347620864, 1347624959, 'LB', 'LBN', 'لبنان'),
(15862, 1347624960, 1347633151, 'CH', 'CHE', 'سويسرا'),
(15863, 1347633152, 1347637247, 'CZ', 'CZE', 'التشيك'),
(15864, 1347637248, 1347641343, 'SE', 'SWE', 'السويد'),
(15865, 1347641344, 1347646194, 'DE', 'DEU', 'ألمانيا'),
(15866, 1347646195, 1347646207, 'TR', 'TUR', 'تركيا'),
(15867, 1347646208, 1347649535, 'DE', 'DEU', 'ألمانيا'),
(15868, 1347649536, 1347653631, 'GE', 'GEO', 'جورجيا'),
(15869, 1347653632, 1347654615, 'GB', 'GBR', 'المملكة المتحدة'),
(15870, 1347654616, 1347654623, 'EG', 'EGY', 'مصر'),
(15871, 1347654624, 1347655175, 'GB', 'GBR', 'المملكة المتحدة'),
(15872, 1347655176, 1347655183, 'EG', 'EGY', 'مصر'),
(15873, 1347655184, 1347657727, 'GB', 'GBR', 'المملكة المتحدة'),
(15874, 1347657728, 1347661823, 'IT', 'ITA', 'إيطاليا'),
(15875, 1347661824, 1347663119, 'DE', 'DEU', 'ألمانيا'),
(15876, 1347663120, 1347663127, 'GB', 'GBR', 'المملكة المتحدة'),
(15877, 1347663128, 1347665919, 'DE', 'DEU', 'ألمانيا'),
(15878, 1347665920, 1347670015, 'RU', 'RUS', 'الإتحاد الروسي'),
(15879, 1347670016, 1347674111, 'SE', 'SWE', 'السويد'),
(15880, 1347674112, 1347682303, 'RU', 'RUS', 'الإتحاد الروسي'),
(15881, 1347682304, 1347686399, 'DE', 'DEU', 'ألمانيا'),
(15882, 1347688736, 1347688743, 'BE', 'BEL', 'بلجيكا'),
(15883, 1347688744, 1347688751, 'ET', 'ETH', 'إثيوبيا'),
(15884, 1347688752, 1347688767, 'SN', 'SEN', 'السنغال'),
(15885, 1347688960, 1347689343, 'BE', 'BEL', 'بلجيكا'),
(15886, 1347690496, 1347694591, 'SE', 'SWE', 'السويد'),
(15887, 1347694592, 1347706879, 'GB', 'GBR', 'المملكة المتحدة'),
(15888, 1347706880, 1347710975, 'IT', 'ITA', 'إيطاليا'),
(15889, 1347710976, 1347715071, 'RU', 'RUS', 'الإتحاد الروسي'),
(15890, 1347715072, 1347715519, 'ES', 'ESP', 'إسبانيا'),
(15891, 1347715520, 1347715527, 'SA', 'SAU', 'السعودية'),
(15892, 1347715528, 1347716151, 'ES', 'ESP', 'إسبانيا'),
(15893, 1347716152, 1347716159, 'LB', 'LBN', 'لبنان'),
(15894, 1347716160, 1347716207, 'ES', 'ESP', 'إسبانيا'),
(15895, 1347716208, 1347716223, 'CY', 'CYP', 'قبرص'),
(15896, 1347716224, 1347718367, 'ES', 'ESP', 'إسبانيا'),
(15897, 1347718368, 1347718399, 'IR', 'IRN', 'إيران'),
(15898, 1347718400, 1347719711, 'ES', 'ESP', 'إسبانيا'),
(15899, 1347719712, 1347719719, 'SO', 'SOM', 'الصومال'),
(15900, 1347719720, 1347722495, 'ES', 'ESP', 'إسبانيا'),
(15901, 1347722496, 1347722751, 'LB', 'LBN', 'لبنان'),
(15902, 1347722752, 1347723263, 'ES', 'ESP', 'إسبانيا'),
(15903, 1347723264, 1347727359, 'GB', 'GBR', 'المملكة المتحدة'),
(15904, 1347727360, 1347731455, 'UA', 'UKR', 'أوكرانيا'),
(15905, 1347731456, 1347739647, 'DE', 'DEU', 'ألمانيا'),
(15906, 1347739648, 1347747839, 'NL', 'NLD', 'هولندا'),
(15907, 1347747840, 1347751935, 'DE', 'DEU', 'ألمانيا'),
(15908, 1347751936, 1347754751, 'CY', 'CYP', 'قبرص'),
(15909, 1347754752, 1347754775, 'GR', 'GRC', 'اليونان'),
(15910, 1347754776, 1347754791, 'CY', 'CYP', 'قبرص'),
(15911, 1347754792, 1347754887, 'GR', 'GRC', 'اليونان'),
(15912, 1347754888, 1347754888, 'CY', 'CYP', 'قبرص'),
(15913, 1347754889, 1347754894, 'GR', 'GRC', 'اليونان'),
(15914, 1347754895, 1347754895, 'CY', 'CYP', 'قبرص'),
(15915, 1347754896, 1347754919, 'GR', 'GRC', 'اليونان'),
(15916, 1347754920, 1347754927, 'CY', 'CYP', 'قبرص'),
(15917, 1347754928, 1347754935, 'GR', 'GRC', 'اليونان'),
(15918, 1347754936, 1347754943, 'RS', 'SRB', 'صربيا'),
(15919, 1347754944, 1347754951, 'CY', 'CYP', 'قبرص'),
(15920, 1347754952, 1347754959, 'TN', 'TUN', 'تونس'),
(15921, 1347754960, 1347754967, 'MA', 'MAR', 'المغرب'),
(15922, 1347754968, 1347754983, 'GR', 'GRC', 'اليونان'),
(15923, 1347754984, 1347754991, 'CY', 'CYP', 'قبرص'),
(15924, 1347754992, 1347755112, 'GR', 'GRC', 'اليونان'),
(15925, 1347755113, 1347755119, 'CY', 'CYP', 'قبرص'),
(15926, 1347755120, 1347755191, 'GR', 'GRC', 'اليونان'),
(15927, 1347755192, 1347755223, 'CY', 'CYP', 'قبرص'),
(15928, 1347755224, 1347755231, 'GR', 'GRC', 'اليونان'),
(15929, 1347755232, 1347755263, 'CY', 'CYP', 'قبرص'),
(15930, 1347755264, 1347755519, 'GR', 'GRC', 'اليونان'),
(15931, 1347755520, 1347755775, 'CY', 'CYP', 'قبرص'),
(15932, 1347755776, 1347756031, 'GR', 'GRC', 'اليونان'),
(15933, 1347756032, 1347760127, 'NL', 'NLD', 'هولندا'),
(15934, 1347760128, 1347764223, 'HU', 'HUN', 'هنغاريا'),
(15935, 1347764224, 1347772415, 'GB', 'GBR', 'المملكة المتحدة'),
(15936, 1347772416, 1347776511, 'MT', 'MLT', 'مالطا'),
(15937, 1347776512, 1347780607, 'SE', 'SWE', 'السويد'),
(15938, 1347780608, 1347784703, 'NL', 'NLD', 'هولندا'),
(15939, 1347784704, 1347788799, 'RU', 'RUS', 'الإتحاد الروسي'),
(15940, 1347788800, 1347792895, 'NL', 'NLD', 'هولندا'),
(15941, 1347792896, 1347796991, 'RU', 'RUS', 'الإتحاد الروسي'),
(15942, 1347796992, 1347801087, 'DE', 'DEU', 'ألمانيا'),
(15943, 1347801088, 1347805183, 'GB', 'GBR', 'المملكة المتحدة'),
(15944, 1347805184, 1347809279, 'PL', 'POL', 'بولندا'),
(15945, 1347809280, 1347813375, 'RU', 'RUS', 'الإتحاد الروسي'),
(15946, 1347813376, 1347817471, 'DE', 'DEU', 'ألمانيا'),
(15947, 1347817472, 1347821567, 'IT', 'ITA', 'إيطاليا'),
(15948, 1347821568, 1347822343, 'GB', 'GBR', 'المملكة المتحدة'),
(15949, 1347822344, 1347822351, 'NL', 'NLD', 'هولندا'),
(15950, 1347822352, 1347825663, 'GB', 'GBR', 'المملكة المتحدة'),
(15951, 1347825664, 1347829759, 'IT', 'ITA', 'إيطاليا'),
(15952, 1347829760, 1347833855, 'SE', 'SWE', 'السويد'),
(15953, 1347833856, 1347836223, 'DE', 'DEU', 'ألمانيا'),
(15954, 1347836224, 1347836255, 'SE', 'SWE', 'السويد'),
(15955, 1347836256, 1347837951, 'DE', 'DEU', 'ألمانيا'),
(15956, 1347837952, 1347846143, 'RO', 'ROM', 'رومانيا'),
(15957, 1347846144, 1347850239, 'NO', 'NOR', 'النرويج'),
(15958, 1347850240, 1347854335, 'IT', 'ITA', 'إيطاليا'),
(15959, 1347854336, 1347854871, 'DE', 'DEU', 'ألمانيا'),
(15960, 1347854880, 1347854887, 'DE', 'DEU', 'ألمانيا'),
(15961, 1347854912, 1347855071, 'DE', 'DEU', 'ألمانيا'),
(15962, 1347855080, 1347855103, 'DE', 'DEU', 'ألمانيا'),
(15963, 1347855104, 1347855359, 'CH', 'CHE', 'سويسرا'),
(15964, 1347855360, 1347855935, 'DE', 'DEU', 'ألمانيا'),
(15965, 1347855944, 1347855951, 'DE', 'DEU', 'ألمانيا'),
(15966, 1347855960, 1347855967, 'DE', 'DEU', 'ألمانيا'),
(15967, 1347856000, 1347856063, 'DE', 'DEU', 'ألمانيا'),
(15968, 1347856080, 1347856243, 'DE', 'DEU', 'ألمانيا'),
(15969, 1347856256, 1347856383, 'DE', 'DEU', 'ألمانيا'),
(15970, 1347856392, 1347856431, 'DE', 'DEU', 'ألمانيا'),
(15971, 1347856448, 1347856639, 'DE', 'DEU', 'ألمانيا'),
(15972, 1347856640, 1347856895, 'AT', 'AUT', 'النمسا'),
(15973, 1347856896, 1347858495, 'DE', 'DEU', 'ألمانيا'),
(15974, 1347858504, 1347858527, 'DE', 'DEU', 'ألمانيا'),
(15975, 1347858560, 1347858575, 'DE', 'DEU', 'ألمانيا'),
(15976, 1347858592, 1347858631, 'DE', 'DEU', 'ألمانيا'),
(15977, 1347858640, 1347859351, 'DE', 'DEU', 'ألمانيا'),
(15978, 1347859360, 1347859383, 'DE', 'DEU', 'ألمانيا'),
(15979, 1347859408, 1347859439, 'DE', 'DEU', 'ألمانيا'),
(15980, 1347859456, 1347860863, 'DE', 'DEU', 'ألمانيا'),
(15981, 1347860880, 1347860895, 'DE', 'DEU', 'ألمانيا'),
(15982, 1347860912, 1347861395, 'DE', 'DEU', 'ألمانيا'),
(15983, 1347861400, 1347861471, 'DE', 'DEU', 'ألمانيا'),
(15984, 1347861504, 1347861759, 'DE', 'DEU', 'ألمانيا'),
(15985, 1347861800, 1347861823, 'DE', 'DEU', 'ألمانيا'),
(15986, 1347861944, 1347861951, 'DE', 'DEU', 'ألمانيا'),
(15987, 1347862112, 1347862143, 'DE', 'DEU', 'ألمانيا'),
(15988, 1347862280, 1347862431, 'DE', 'DEU', 'ألمانيا'),
(15989, 1347862464, 1347862527, 'DE', 'DEU', 'ألمانيا'),
(15990, 1347862528, 1347866623, 'CH', 'CHE', 'سويسرا'),
(15991, 1347866624, 1347870719, 'NO', 'NOR', 'النرويج'),
(15992, 1347870720, 1347874815, 'AM', 'ARM', 'أرمينيا'),
(15993, 1347874816, 1347878911, 'SK', 'SVK', 'سلوفاكيا'),
(15994, 1347878912, 1347887103, 'GB', 'GBR', 'المملكة المتحدة'),
(15995, 1347887104, 1347891199, 'PL', 'POL', 'بولندا'),
(15996, 1347891200, 1347895295, 'SE', 'SWE', 'السويد'),
(15997, 1347903488, 1347907583, 'RU', 'RUS', 'الإتحاد الروسي'),
(15998, 1347907584, 1347911679, 'DE', 'DEU', 'ألمانيا'),
(15999, 1347911680, 1347915775, 'GB', 'GBR', 'المملكة المتحدة'),
(16000, 1347915776, 1347919871, 'RU', 'RUS', 'الإتحاد الروسي'),
(16001, 1347919872, 1347923967, 'DE', 'DEU', 'ألمانيا'),
(16002, 1347923968, 1347928063, 'CZ', 'CZE', 'التشيك'),
(16003, 1347928064, 1347932159, 'RU', 'RUS', 'الإتحاد الروسي'),
(16004, 1347932160, 1347936255, 'SK', 'SVK', 'سلوفاكيا'),
(16005, 1347936256, 1347940351, 'FR', 'FRA', 'فرنسا'),
(16006, 1347940352, 1347944447, 'BA', 'BIH', 'البوسنه والهرسك'),
(16007, 1347948544, 1347952639, 'DE', 'DEU', 'ألمانيا'),
(16008, 1347952640, 1347956735, 'BE', 'BEL', 'بلجيكا'),
(16009, 1347956736, 1347960831, 'RU', 'RUS', 'الإتحاد الروسي'),
(16010, 1347960832, 1347964927, 'DE', 'DEU', 'ألمانيا'),
(16011, 1347964928, 1347969023, 'IT', 'ITA', 'إيطاليا'),
(16012, 1347969024, 1347977215, 'SE', 'SWE', 'السويد'),
(16013, 1347977216, 1347977471, 'DK', 'DNK', 'الدنيمارك'),
(16014, 1347977472, 1347977487, 'NG', 'NGA', 'نيجيريا'),
(16015, 1347977488, 1347977503, 'DK', 'DNK', 'الدنيمارك'),
(16016, 1347977504, 1347977519, 'NG', 'NGA', 'نيجيريا'),
(16017, 1347977520, 1347977599, 'MZ', 'MOZ', 'موزامبيق'),
(16018, 1347977600, 1347977623, 'NG', 'NGA', 'نيجيريا'),
(16019, 1347977624, 1347977631, 'KE', 'KEN', 'كينيا'),
(16020, 1347977632, 1347977855, 'DK', 'DNK', 'الدنيمارك'),
(16021, 1347977856, 1347977863, 'NG', 'NGA', 'نيجيريا'),
(16022, 1347977864, 1347977871, 'DK', 'DNK', 'الدنيمارك'),
(16023, 1347977872, 1347977919, 'NG', 'NGA', 'نيجيريا'),
(16024, 1347977920, 1347977999, 'DK', 'DNK', 'الدنيمارك'),
(16025, 1347978000, 1347978007, 'SO', 'SOM', 'الصومال'),
(16026, 1347978008, 1347978047, 'NG', 'NGA', 'نيجيريا'),
(16027, 1347978048, 1347978055, 'ZW', 'ZWE', 'زمبابواي'),
(16028, 1347978056, 1347978063, 'SD', 'SDN', 'السودان'),
(16029, 1347978064, 1347978135, 'MZ', 'MOZ', 'موزامبيق'),
(16030, 1347978136, 1347978143, 'ZW', 'ZWE', 'زمبابواي'),
(16031, 1347978144, 1347978183, 'NG', 'NGA', 'نيجيريا'),
(16032, 1347978184, 1347978191, 'DK', 'DNK', 'الدنيمارك'),
(16033, 1347978192, 1347978207, 'NG', 'NGA', 'نيجيريا'),
(16034, 1347978208, 1347978215, 'MZ', 'MOZ', 'موزامبيق'),
(16035, 1347978216, 1347978223, 'NG', 'NGA', 'نيجيريا'),
(16036, 1347978224, 1347978239, 'DK', 'DNK', 'الدنيمارك'),
(16037, 1347978240, 1347978271, 'NG', 'NGA', 'نيجيريا'),
(16038, 1347978272, 1347978287, 'DK', 'DNK', 'الدنيمارك'),
(16039, 1347978288, 1347978359, 'NG', 'NGA', 'نيجيريا'),
(16040, 1347978360, 1347978367, 'DK', 'DNK', 'الدنيمارك'),
(16041, 1347978368, 1347978407, 'NG', 'NGA', 'نيجيريا'),
(16042, 1347978408, 1347978415, 'MZ', 'MOZ', 'موزامبيق'),
(16043, 1347978416, 1347978423, 'ET', 'ETH', 'إثيوبيا'),
(16044, 1347978424, 1347978431, 'RW', 'RWA', 'رواندا'),
(16045, 1347978432, 1347978439, 'DK', 'DNK', 'الدنيمارك'),
(16046, 1347978440, 1347978463, 'NG', 'NGA', 'نيجيريا'),
(16047, 1347978464, 1347978487, 'DK', 'DNK', 'الدنيمارك'),
(16048, 1347978488, 1347978495, 'YE', 'YEM', 'اليمن'),
(16049, 1347978496, 1347978503, 'UG', 'UGA', 'أوغاندا'),
(16050, 1347978504, 1347978559, 'NG', 'NGA', 'نيجيريا'),
(16051, 1347978560, 1347978575, 'DK', 'DNK', 'الدنيمارك'),
(16052, 1347978576, 1347978663, 'NG', 'NGA', 'نيجيريا'),
(16053, 1347978664, 1347978671, 'DK', 'DNK', 'الدنيمارك'),
(16054, 1347978672, 1347978679, 'NG', 'NGA', 'نيجيريا'),
(16055, 1347978680, 1347978687, 'AO', 'AGO', 'أنغولا'),
(16056, 1347978688, 1347978695, 'NG', 'NGA', 'نيجيريا'),
(16057, 1347978696, 1347978711, 'AO', 'AGO', 'أنغولا'),
(16058, 1347978712, 1347978719, 'DK', 'DNK', 'الدنيمارك'),
(16059, 1347978720, 1347978735, 'NG', 'NGA', 'نيجيريا'),
(16060, 1347978736, 1347978759, 'DK', 'DNK', 'الدنيمارك'),
(16061, 1347978760, 1347978807, 'NG', 'NGA', 'نيجيريا'),
(16062, 1347978808, 1347978847, 'DK', 'DNK', 'الدنيمارك'),
(16063, 1347978848, 1347978855, 'NG', 'NGA', 'نيجيريا'),
(16064, 1347978856, 1347978879, 'IQ', 'IRQ', 'العراق'),
(16065, 1347978880, 1347978895, 'DK', 'DNK', 'الدنيمارك'),
(16066, 1347978896, 1347978919, 'NG', 'NGA', 'نيجيريا'),
(16067, 1347978920, 1347978927, 'DK', 'DNK', 'الدنيمارك'),
(16068, 1347978928, 1347978935, 'CG', 'COG', 'الكونغو'),
(16069, 1347978936, 1347978943, 'NG', 'NGA', 'نيجيريا'),
(16070, 1347978944, 1347978959, 'AO', 'AGO', 'أنغولا'),
(16071, 1347978960, 1347978967, 'DK', 'DNK', 'الدنيمارك'),
(16072, 1347978968, 1347979007, 'AO', 'AGO', 'أنغولا'),
(16073, 1347979008, 1347979015, 'NG', 'NGA', 'نيجيريا'),
(16074, 1347979016, 1347979023, 'DK', 'DNK', 'الدنيمارك'),
(16075, 1347979024, 1347979039, 'NG', 'NGA', 'نيجيريا'),
(16076, 1347979040, 1347979047, 'AO', 'AGO', 'أنغولا'),
(16077, 1347979048, 1347979055, 'DK', 'DNK', 'الدنيمارك'),
(16078, 1347979056, 1347979071, 'NG', 'NGA', 'نيجيريا'),
(16079, 1347979072, 1347979135, 'DK', 'DNK', 'الدنيمارك'),
(16080, 1347979136, 1347979143, 'NG', 'NGA', 'نيجيريا'),
(16081, 1347979144, 1347979159, 'DK', 'DNK', 'الدنيمارك'),
(16082, 1347979160, 1347979167, 'NG', 'NGA', 'نيجيريا'),
(16083, 1347979168, 1347979183, 'DK', 'DNK', 'الدنيمارك'),
(16084, 1347979184, 1347979199, 'NG', 'NGA', 'نيجيريا'),
(16085, 1347979200, 1347979215, 'DK', 'DNK', 'الدنيمارك'),
(16086, 1347979216, 1347979247, 'NG', 'NGA', 'نيجيريا'),
(16087, 1347979248, 1347979263, 'DK', 'DNK', 'الدنيمارك'),
(16088, 1347979264, 1347979279, 'IQ', 'IRQ', 'العراق'),
(16089, 1347979280, 1347979287, 'UG', 'UGA', 'أوغاندا'),
(16090, 1347979288, 1347979311, 'NG', 'NGA', 'نيجيريا'),
(16091, 1347979312, 1347979319, 'CG', 'COG', 'الكونغو'),
(16092, 1347979320, 1347979327, 'DK', 'DNK', 'الدنيمارك'),
(16093, 1347979328, 1347979335, 'AO', 'AGO', 'أنغولا'),
(16094, 1347979336, 1347979375, 'DK', 'DNK', 'الدنيمارك'),
(16095, 1347979376, 1347979399, 'NG', 'NGA', 'نيجيريا'),
(16096, 1347979400, 1347979407, 'KM', 'COM', 'جزر القمر'),
(16097, 1347979408, 1347979431, 'DK', 'DNK', 'الدنيمارك'),
(16098, 1347979432, 1347979439, 'NG', 'NGA', 'نيجيريا'),
(16099, 1347979440, 1347979447, 'DK', 'DNK', 'الدنيمارك'),
(16100, 1347979448, 1347979471, 'NG', 'NGA', 'نيجيريا'),
(16101, 1347979472, 1347979479, 'DK', 'DNK', 'الدنيمارك'),
(16102, 1347979480, 1347979503, 'NG', 'NGA', 'نيجيريا'),
(16103, 1347979504, 1347979527, 'DK', 'DNK', 'الدنيمارك'),
(16104, 1347979528, 1347979535, 'NG', 'NGA', 'نيجيريا'),
(16105, 1347979536, 1347979543, 'UG', 'UGA', 'أوغاندا'),
(16106, 1347979544, 1347979559, 'DK', 'DNK', 'الدنيمارك'),
(16107, 1347979560, 1347979567, 'SO', 'SOM', 'الصومال'),
(16108, 1347979568, 1347979591, 'NG', 'NGA', 'نيجيريا'),
(16109, 1347979592, 1347979607, 'IQ', 'IRQ', 'العراق'),
(16110, 1347979608, 1347979623, 'NG', 'NGA', 'نيجيريا'),
(16111, 1347979624, 1347979655, 'DK', 'DNK', 'الدنيمارك'),
(16112, 1347979656, 1347979663, 'NG', 'NGA', 'نيجيريا'),
(16113, 1347979664, 1347979671, 'GB', 'GBR', 'المملكة المتحدة'),
(16114, 1347979672, 1347979751, 'NG', 'NGA', 'نيجيريا'),
(16115, 1347979752, 1347979759, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16116, 1347979760, 1347979767, 'NG', 'NGA', 'نيجيريا'),
(16117, 1347979768, 1347979775, 'DK', 'DNK', 'الدنيمارك'),
(16118, 1347979776, 1347979783, 'NG', 'NGA', 'نيجيريا'),
(16119, 1347979784, 1347979791, 'DK', 'DNK', 'الدنيمارك'),
(16120, 1347979792, 1347979807, 'NG', 'NGA', 'نيجيريا'),
(16121, 1347979808, 1347979839, 'DK', 'DNK', 'الدنيمارك'),
(16122, 1347979840, 1347979847, 'BI', 'BDI', 'بوروندي'),
(16123, 1347979848, 1347979863, 'NG', 'NGA', 'نيجيريا'),
(16124, 1347979864, 1347979935, 'DK', 'DNK', 'الدنيمارك'),
(16125, 1347979936, 1347979967, 'NG', 'NGA', 'نيجيريا'),
(16126, 1347979968, 1347980063, 'DK', 'DNK', 'الدنيمارك'),
(16127, 1347980064, 1347980071, 'UG', 'UGA', 'أوغاندا'),
(16128, 1347980072, 1347980079, 'DK', 'DNK', 'الدنيمارك'),
(16129, 1347980080, 1347980095, 'GH', 'GHA', 'غانا'),
(16130, 1347980096, 1347980111, 'NG', 'NGA', 'نيجيريا'),
(16131, 1347980112, 1347980127, 'GN', 'GIN', 'غينيا'),
(16132, 1347980128, 1347980143, 'NG', 'NGA', 'نيجيريا'),
(16133, 1347980144, 1347980151, 'DK', 'DNK', 'الدنيمارك'),
(16134, 1347980152, 1347980159, 'UG', 'UGA', 'أوغاندا'),
(16135, 1347980160, 1347980167, 'DK', 'DNK', 'الدنيمارك'),
(16136, 1347980168, 1347980175, 'NG', 'NGA', 'نيجيريا'),
(16137, 1347980176, 1347980183, 'TZ', 'TZA', 'تانزانيا'),
(16138, 1347980184, 1347980191, 'DK', 'DNK', 'الدنيمارك'),
(16139, 1347980192, 1347980271, 'NG', 'NGA', 'نيجيريا'),
(16140, 1347980272, 1347980415, 'DK', 'DNK', 'الدنيمارك'),
(16141, 1347980416, 1347980543, 'NG', 'NGA', 'نيجيريا'),
(16142, 1347980544, 1347980559, 'DK', 'DNK', 'الدنيمارك'),
(16143, 1347980560, 1347980607, 'NG', 'NGA', 'نيجيريا'),
(16144, 1347980608, 1347980623, 'DK', 'DNK', 'الدنيمارك'),
(16145, 1347980624, 1347980631, 'NG', 'NGA', 'نيجيريا'),
(16146, 1347980632, 1347980639, 'DK', 'DNK', 'الدنيمارك'),
(16147, 1347980640, 1347980647, 'NG', 'NGA', 'نيجيريا'),
(16148, 1347980648, 1347980671, 'DK', 'DNK', 'الدنيمارك'),
(16149, 1347980672, 1347980703, 'NG', 'NGA', 'نيجيريا'),
(16150, 1347980704, 1347980735, 'TR', 'TUR', 'تركيا'),
(16151, 1347980736, 1347980799, 'NG', 'NGA', 'نيجيريا'),
(16152, 1347980800, 1347980999, 'DK', 'DNK', 'الدنيمارك'),
(16153, 1347981000, 1347981031, 'NG', 'NGA', 'نيجيريا'),
(16154, 1347981032, 1347981039, 'IQ', 'IRQ', 'العراق'),
(16155, 1347981040, 1347981055, 'NG', 'NGA', 'نيجيريا'),
(16156, 1347981056, 1347981183, 'DK', 'DNK', 'الدنيمارك'),
(16157, 1347981184, 1347981191, 'NG', 'NGA', 'نيجيريا'),
(16158, 1347981192, 1347981199, 'DK', 'DNK', 'الدنيمارك'),
(16159, 1347981200, 1347981207, 'NG', 'NGA', 'نيجيريا'),
(16160, 1347981208, 1347981215, 'DK', 'DNK', 'الدنيمارك'),
(16161, 1347981216, 1347981247, 'NG', 'NGA', 'نيجيريا'),
(16162, 1347981248, 1347981255, 'UG', 'UGA', 'أوغاندا'),
(16163, 1347981256, 1347981263, 'DK', 'DNK', 'الدنيمارك'),
(16164, 1347981264, 1347981271, 'UG', 'UGA', 'أوغاندا'),
(16165, 1347981272, 1347981279, 'DK', 'DNK', 'الدنيمارك'),
(16166, 1347981280, 1347981311, 'AO', 'AGO', 'أنغولا'),
(16167, 1347981312, 1347981887, 'NG', 'NGA', 'نيجيريا'),
(16168, 1347981888, 1347981903, 'UG', 'UGA', 'أوغاندا'),
(16169, 1347981904, 1347981911, 'DK', 'DNK', 'الدنيمارك'),
(16170, 1347981912, 1347981919, 'AO', 'AGO', 'أنغولا'),
(16171, 1347981920, 1347981927, 'DK', 'DNK', 'الدنيمارك'),
(16172, 1347981928, 1347981935, 'NG', 'NGA', 'نيجيريا'),
(16173, 1347981936, 1347981943, 'CG', 'COG', 'الكونغو'),
(16174, 1347981944, 1347981959, 'IQ', 'IRQ', 'العراق'),
(16175, 1347981960, 1347981983, 'DK', 'DNK', 'الدنيمارك'),
(16176, 1347981984, 1347981999, 'AO', 'AGO', 'أنغولا'),
(16177, 1347982000, 1347982015, 'DK', 'DNK', 'الدنيمارك'),
(16178, 1347982016, 1347982055, 'NG', 'NGA', 'نيجيريا'),
(16179, 1347982056, 1347982063, 'DK', 'DNK', 'الدنيمارك'),
(16180, 1347982064, 1347982079, 'IQ', 'IRQ', 'العراق'),
(16181, 1347982080, 1347982087, 'NG', 'NGA', 'نيجيريا'),
(16182, 1347982088, 1347982103, 'DK', 'DNK', 'الدنيمارك'),
(16183, 1347982104, 1347982111, 'AO', 'AGO', 'أنغولا'),
(16184, 1347982112, 1347982143, 'DK', 'DNK', 'الدنيمارك'),
(16185, 1347982144, 1347982207, 'NG', 'NGA', 'نيجيريا'),
(16186, 1347982208, 1347982223, 'DK', 'DNK', 'الدنيمارك'),
(16187, 1347982224, 1347982239, 'NG', 'NGA', 'نيجيريا'),
(16188, 1347982240, 1347982263, 'AO', 'AGO', 'أنغولا'),
(16189, 1347982264, 1347982287, 'DK', 'DNK', 'الدنيمارك'),
(16190, 1347982288, 1347982303, 'NG', 'NGA', 'نيجيريا'),
(16191, 1347982304, 1347982335, 'AO', 'AGO', 'أنغولا'),
(16192, 1347982336, 1347982847, 'NG', 'NGA', 'نيجيريا'),
(16193, 1347982848, 1347982879, 'DK', 'DNK', 'الدنيمارك'),
(16194, 1347982880, 1347982887, 'IQ', 'IRQ', 'العراق'),
(16195, 1347982888, 1347982991, 'NG', 'NGA', 'نيجيريا'),
(16196, 1347982992, 1347983007, 'DK', 'DNK', 'الدنيمارك'),
(16197, 1347983008, 1347983055, 'NG', 'NGA', 'نيجيريا'),
(16198, 1347983056, 1347983063, 'SE', 'SWE', 'السويد'),
(16199, 1347983064, 1347983071, 'NG', 'NGA', 'نيجيريا'),
(16200, 1347983072, 1347983087, 'BJ', 'BEN', 'بنين'),
(16201, 1347983088, 1347983103, 'DK', 'DNK', 'الدنيمارك'),
(16202, 1347983104, 1347983119, 'NG', 'NGA', 'نيجيريا'),
(16203, 1347983120, 1347983271, 'DK', 'DNK', 'الدنيمارك'),
(16204, 1347983272, 1347983279, 'IQ', 'IRQ', 'العراق'),
(16205, 1347983280, 1347983287, 'UG', 'UGA', 'أوغاندا'),
(16206, 1347983288, 1347983303, 'DK', 'DNK', 'الدنيمارك'),
(16207, 1347983304, 1347983311, 'NG', 'NGA', 'نيجيريا'),
(16208, 1347983312, 1347983319, 'IQ', 'IRQ', 'العراق'),
(16209, 1347983320, 1347983327, 'NG', 'NGA', 'نيجيريا'),
(16210, 1347983328, 1347983335, 'ZM', 'ZMB', 'زامبيا'),
(16211, 1347983336, 1347983343, 'MU', 'MUS', 'موريشيوس'),
(16212, 1347983344, 1347983359, 'DK', 'DNK', 'الدنيمارك'),
(16213, 1347983360, 1347983519, 'NG', 'NGA', 'نيجيريا'),
(16214, 1347983520, 1347983527, 'DK', 'DNK', 'الدنيمارك'),
(16215, 1347983528, 1347983535, 'NG', 'NGA', 'نيجيريا'),
(16216, 1347983536, 1347983543, 'DK', 'DNK', 'الدنيمارك'),
(16217, 1347983544, 1347983551, 'NG', 'NGA', 'نيجيريا'),
(16218, 1347983552, 1347983559, 'DK', 'DNK', 'الدنيمارك'),
(16219, 1347983560, 1347983575, 'NG', 'NGA', 'نيجيريا'),
(16220, 1347983576, 1347983591, 'DK', 'DNK', 'الدنيمارك'),
(16221, 1347983592, 1347983599, 'NG', 'NGA', 'نيجيريا'),
(16222, 1347983600, 1347983615, 'BJ', 'BEN', 'بنين'),
(16223, 1347983616, 1347983903, 'DK', 'DNK', 'الدنيمارك'),
(16224, 1347983904, 1347983911, 'NG', 'NGA', 'نيجيريا'),
(16225, 1347983912, 1347983919, 'DK', 'DNK', 'الدنيمارك'),
(16226, 1347983920, 1347983935, 'NG', 'NGA', 'نيجيريا'),
(16227, 1347983936, 1347983943, 'UG', 'UGA', 'أوغاندا'),
(16228, 1347983944, 1347983951, 'NG', 'NGA', 'نيجيريا'),
(16229, 1347983952, 1347983967, 'DK', 'DNK', 'الدنيمارك'),
(16230, 1347983968, 1347983975, 'NG', 'NGA', 'نيجيريا'),
(16231, 1347983976, 1347983983, 'NA', 'NAM', 'ناميبيا'),
(16232, 1347983984, 1347984303, 'NG', 'NGA', 'نيجيريا'),
(16233, 1347984304, 1347984311, 'TZ', 'TZA', 'تانزانيا'),
(16234, 1347984312, 1347984335, 'NG', 'NGA', 'نيجيريا'),
(16235, 1347984336, 1347984343, 'DK', 'DNK', 'الدنيمارك'),
(16236, 1347984344, 1347984351, 'NG', 'NGA', 'نيجيريا'),
(16237, 1347984352, 1347984367, 'DK', 'DNK', 'الدنيمارك'),
(16238, 1347984368, 1347984375, 'CI', 'CIV', 'كوت ديفوار'),
(16239, 1347984376, 1347984383, 'DK', 'DNK', 'الدنيمارك'),
(16240, 1347984384, 1347984399, 'NG', 'NGA', 'نيجيريا'),
(16241, 1347984400, 1347984407, 'DK', 'DNK', 'الدنيمارك'),
(16242, 1347984408, 1347984415, 'IQ', 'IRQ', 'العراق'),
(16243, 1347984416, 1347984423, 'NG', 'NGA', 'نيجيريا'),
(16244, 1347984424, 1347984447, 'DK', 'DNK', 'الدنيمارك'),
(16245, 1347984448, 1347984575, 'IQ', 'IRQ', 'العراق'),
(16246, 1347984576, 1347984607, 'NG', 'NGA', 'نيجيريا'),
(16247, 1347984608, 1347984639, 'IQ', 'IRQ', 'العراق'),
(16248, 1347984640, 1347984647, 'MW', 'MWI', 'ملاوي'),
(16249, 1347984648, 1347984671, 'NG', 'NGA', 'نيجيريا'),
(16250, 1347984672, 1347984703, 'IQ', 'IRQ', 'العراق'),
(16251, 1347984704, 1347984719, 'DK', 'DNK', 'الدنيمارك'),
(16252, 1347984720, 1347984735, 'NG', 'NGA', 'نيجيريا'),
(16253, 1347984736, 1347984743, 'DK', 'DNK', 'الدنيمارك'),
(16254, 1347984744, 1347984751, 'NG', 'NGA', 'نيجيريا'),
(16255, 1347984752, 1347984799, 'DK', 'DNK', 'الدنيمارك'),
(16256, 1347984800, 1347984807, 'CM', 'CMR', 'الكاميرون'),
(16257, 1347984808, 1347984815, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(16258, 1347984816, 1347984823, 'KE', 'KEN', 'كينيا'),
(16259, 1347984824, 1347984831, 'DK', 'DNK', 'الدنيمارك'),
(16260, 1347984832, 1347984839, 'ZW', 'ZWE', 'زمبابواي'),
(16261, 1347984840, 1347984847, 'BJ', 'BEN', 'بنين'),
(16262, 1347984848, 1347984855, 'MR', 'MRT', 'موريتانيا'),
(16263, 1347984856, 1347984863, 'KE', 'KEN', 'كينيا'),
(16264, 1347984864, 1347984871, 'UG', 'UGA', 'أوغاندا'),
(16265, 1347984872, 1347984903, 'NG', 'NGA', 'نيجيريا'),
(16266, 1347984904, 1347984927, 'DK', 'DNK', 'الدنيمارك'),
(16267, 1347984928, 1347984943, 'NG', 'NGA', 'نيجيريا'),
(16268, 1347984944, 1347984959, 'DK', 'DNK', 'الدنيمارك'),
(16269, 1347984960, 1347984999, 'NG', 'NGA', 'نيجيريا'),
(16270, 1347985000, 1347985007, 'UG', 'UGA', 'أوغاندا'),
(16271, 1347985008, 1347985015, 'NG', 'NGA', 'نيجيريا'),
(16272, 1347985016, 1347985023, 'DK', 'DNK', 'الدنيمارك'),
(16273, 1347985024, 1347985039, 'NG', 'NGA', 'نيجيريا'),
(16274, 1347985040, 1347985047, 'UG', 'UGA', 'أوغاندا'),
(16275, 1347985048, 1347985095, 'DK', 'DNK', 'الدنيمارك'),
(16276, 1347985096, 1347985119, 'NG', 'NGA', 'نيجيريا'),
(16277, 1347985120, 1347985407, 'DK', 'DNK', 'الدنيمارك'),
(16278, 1347985408, 1347989503, 'IT', 'ITA', 'إيطاليا'),
(16279, 1347989504, 1347993599, 'FI', 'FIN', 'فنلندا'),
(16280, 1347993600, 1348001791, 'GB', 'GBR', 'المملكة المتحدة'),
(16281, 1348001792, 1348005887, 'ES', 'ESP', 'إسبانيا'),
(16282, 1348005888, 1348009983, 'BH', 'BHR', 'البحرين'),
(16283, 1348009984, 1348014079, 'RU', 'RUS', 'الإتحاد الروسي'),
(16284, 1348014080, 1348018175, 'DK', 'DNK', 'الدنيمارك'),
(16285, 1348018176, 1348026367, 'NO', 'NOR', 'النرويج'),
(16286, 1348026368, 1348030463, 'DE', 'DEU', 'ألمانيا'),
(16287, 1348030464, 1348034559, 'GB', 'GBR', 'المملكة المتحدة'),
(16288, 1348034560, 1348038655, 'AT', 'AUT', 'النمسا'),
(16289, 1348038656, 1348042751, 'FR', 'FRA', 'فرنسا'),
(16290, 1348042752, 1348050943, 'RU', 'RUS', 'الإتحاد الروسي'),
(16291, 1348050944, 1348055039, 'SE', 'SWE', 'السويد'),
(16292, 1348055040, 1348059135, 'LB', 'LBN', 'لبنان'),
(16293, 1348059136, 1348063231, 'RU', 'RUS', 'الإتحاد الروسي'),
(16294, 1348063232, 1348067327, 'CH', 'CHE', 'سويسرا'),
(16295, 1348067328, 1348071423, 'NL', 'NLD', 'هولندا'),
(16296, 1348071424, 1348075519, 'DE', 'DEU', 'ألمانيا'),
(16297, 1348075520, 1348075967, 'LV', 'LVA', 'لاتفيا'),
(16298, 1348075968, 1348076031, 'PA', 'PAN', 'بنما'),
(16299, 1348076032, 1348076287, 'LV', 'LVA', 'لاتفيا'),
(16300, 1348076288, 1348076543, 'RU', 'RUS', 'الإتحاد الروسي'),
(16301, 1348076544, 1348083711, 'LV', 'LVA', 'لاتفيا'),
(16302, 1348083712, 1348086535, 'LU', 'LUX', 'لوكسيمبورغ'),
(16303, 1348086536, 1348086543, 'NL', 'NLD', 'هولندا'),
(16304, 1348086544, 1348091903, 'LU', 'LUX', 'لوكسيمبورغ'),
(16305, 1348091904, 1348095999, 'RU', 'RUS', 'الإتحاد الروسي'),
(16306, 1348096000, 1348100095, 'AL', 'ALB', 'ألبانيا'),
(16307, 1348100096, 1348104191, 'DE', 'DEU', 'ألمانيا'),
(16308, 1348104192, 1348108287, 'RU', 'RUS', 'الإتحاد الروسي'),
(16309, 1348108288, 1348112383, 'CZ', 'CZE', 'التشيك'),
(16310, 1348112384, 1348116479, 'DE', 'DEU', 'ألمانيا'),
(16311, 1348116480, 1348120575, 'JO', 'JOR', 'الأردن'),
(16312, 1348120576, 1348124671, 'RU', 'RUS', 'الإتحاد الروسي'),
(16313, 1348124672, 1348128767, 'GB', 'GBR', 'المملكة المتحدة'),
(16314, 1348128768, 1348132863, 'SI', 'SVN', 'سلوفينيا'),
(16315, 1348132864, 1348136959, 'UA', 'UKR', 'أوكرانيا'),
(16316, 1348136960, 1348141055, 'RU', 'RUS', 'الإتحاد الروسي'),
(16317, 1348141056, 1348145151, 'DK', 'DNK', 'الدنيمارك'),
(16318, 1348145152, 1348149247, 'RU', 'RUS', 'الإتحاد الروسي'),
(16319, 1348149248, 1348153343, 'NO', 'NOR', 'النرويج'),
(16320, 1348153344, 1348157439, 'IT', 'ITA', 'إيطاليا'),
(16321, 1348157440, 1348165631, 'ES', 'ESP', 'إسبانيا'),
(16322, 1348165632, 1348169727, 'DE', 'DEU', 'ألمانيا'),
(16323, 1348169728, 1348173823, 'AL', 'ALB', 'ألبانيا'),
(16324, 1348173824, 1348174591, 'FI', 'FIN', 'فنلندا'),
(16325, 1348174592, 1348177919, 'DK', 'DNK', 'الدنيمارك'),
(16326, 1348177920, 1348182015, 'BE', 'BEL', 'بلجيكا'),
(16327, 1348182016, 1348190207, 'UA', 'UKR', 'أوكرانيا'),
(16328, 1348190208, 1348194303, 'RU', 'RUS', 'الإتحاد الروسي'),
(16329, 1348194304, 1348198399, 'GR', 'GRC', 'اليونان'),
(16330, 1348198400, 1348202495, 'NO', 'NOR', 'النرويج'),
(16331, 1348206592, 1348218879, 'RU', 'RUS', 'الإتحاد الروسي'),
(16332, 1348218880, 1348220415, 'DE', 'DEU', 'ألمانيا'),
(16333, 1348220416, 1348220479, 'SA', 'SAU', 'السعودية'),
(16334, 1348220480, 1348220511, 'DE', 'DEU', 'ألمانيا'),
(16335, 1348220512, 1348220543, 'SA', 'SAU', 'السعودية'),
(16336, 1348220544, 1348220687, 'DE', 'DEU', 'ألمانيا'),
(16337, 1348220688, 1348220703, 'SA', 'SAU', 'السعودية'),
(16338, 1348220704, 1348220711, 'DE', 'DEU', 'ألمانيا'),
(16339, 1348220712, 1348220735, 'SA', 'SAU', 'السعودية'),
(16340, 1348220736, 1348220799, 'BH', 'BHR', 'البحرين'),
(16341, 1348220800, 1348220863, 'DE', 'DEU', 'ألمانيا'),
(16342, 1348220864, 1348220895, 'BH', 'BHR', 'البحرين'),
(16343, 1348220896, 1348222975, 'DE', 'DEU', 'ألمانيا'),
(16344, 1348222976, 1348231167, 'LU', 'LUX', 'لوكسيمبورغ'),
(16345, 1348231168, 1348235263, 'RU', 'RUS', 'الإتحاد الروسي'),
(16346, 1348235264, 1348239359, 'AT', 'AUT', 'النمسا'),
(16347, 1348239360, 1348241407, 'SE', 'SWE', 'السويد'),
(16348, 1348241408, 1348242687, 'GB', 'GBR', 'المملكة المتحدة'),
(16349, 1348242688, 1348243455, 'SE', 'SWE', 'السويد'),
(16350, 1348243456, 1348247551, 'GB', 'GBR', 'المملكة المتحدة'),
(16351, 1348247552, 1348251647, 'RU', 'RUS', 'الإتحاد الروسي'),
(16352, 1348251648, 1348255743, 'GE', 'GEO', 'جورجيا'),
(16353, 1348255744, 1348263935, 'RU', 'RUS', 'الإتحاد الروسي'),
(16354, 1348263936, 1348268031, 'UA', 'UKR', 'أوكرانيا'),
(16355, 1348272128, 1348274695, 'IE', 'IRL', 'إيرلندا'),
(16356, 1348274696, 1348274771, 'CH', 'CHE', 'سويسرا'),
(16357, 1348274772, 1348274775, 'IE', 'IRL', 'إيرلندا'),
(16358, 1348274776, 1348274791, 'CH', 'CHE', 'سويسرا'),
(16359, 1348274792, 1348274799, 'IE', 'IRL', 'إيرلندا'),
(16360, 1348274800, 1348274815, 'IL', 'ISR', 'إسرائيل'),
(16361, 1348274816, 1348274927, 'IE', 'IRL', 'إيرلندا'),
(16362, 1348274928, 1348274935, 'IL', 'ISR', 'إسرائيل'),
(16363, 1348274936, 1348274943, 'IE', 'IRL', 'إيرلندا'),
(16364, 1348274944, 1348275199, 'CH', 'CHE', 'سويسرا'),
(16365, 1348275200, 1348275711, 'GB', 'GBR', 'المملكة المتحدة'),
(16366, 1348275712, 1348275967, 'CH', 'CHE', 'سويسرا'),
(16367, 1348275968, 1348280319, 'IE', 'IRL', 'إيرلندا'),
(16368, 1348280320, 1348284415, 'AT', 'AUT', 'النمسا'),
(16369, 1348284416, 1348288511, 'RU', 'RUS', 'الإتحاد الروسي'),
(16370, 1348288512, 1348292607, 'IT', 'ITA', 'إيطاليا'),
(16371, 1348292608, 1348296703, 'FR', 'FRA', 'فرنسا'),
(16372, 1348296704, 1348300799, 'RU', 'RUS', 'الإتحاد الروسي'),
(16373, 1348300800, 1348304895, 'UA', 'UKR', 'أوكرانيا'),
(16374, 1348304896, 1348308991, 'IT', 'ITA', 'إيطاليا'),
(16375, 1348308992, 1348313087, 'MT', 'MLT', 'مالطا'),
(16376, 1348313088, 1348317183, 'GB', 'GBR', 'المملكة المتحدة'),
(16377, 1348317184, 1348321279, 'RU', 'RUS', 'الإتحاد الروسي'),
(16378, 1348321280, 1348325375, 'GB', 'GBR', 'المملكة المتحدة'),
(16379, 1348325376, 1348329471, 'TR', 'TUR', 'تركيا'),
(16380, 1348329472, 1348331871, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16381, 1348331872, 1348331903, 'RS', 'SRB', 'صربيا'),
(16382, 1348331904, 1348332351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16383, 1348332352, 1348332352, 'RS', 'SRB', 'صربيا'),
(16384, 1348332353, 1348332503, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16385, 1348332504, 1348332511, 'RS', 'SRB', 'صربيا'),
(16386, 1348332512, 1348333215, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16387, 1348333216, 1348333231, 'RS', 'SRB', 'صربيا'),
(16388, 1348333232, 1348333583, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16389, 1348333584, 1348333599, 'RS', 'SRB', 'صربيا'),
(16390, 1348333600, 1348333607, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16391, 1348333608, 1348333631, 'RS', 'SRB', 'صربيا'),
(16392, 1348333632, 1348333935, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16393, 1348333936, 1348333945, 'RS', 'SRB', 'صربيا'),
(16394, 1348333946, 1348336383, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16395, 1348336384, 1348336639, 'RS', 'SRB', 'صربيا'),
(16396, 1348336640, 1348337663, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(16397, 1348337664, 1348341759, 'ES', 'ESP', 'إسبانيا'),
(16398, 1348341760, 1348345855, 'PL', 'POL', 'بولندا'),
(16399, 1348345856, 1348349951, 'GB', 'GBR', 'المملكة المتحدة'),
(16400, 1348349952, 1348354047, 'SK', 'SVK', 'سلوفاكيا'),
(16401, 1348354048, 1348358143, 'NL', 'NLD', 'هولندا'),
(16402, 1348358144, 1348362239, 'DE', 'DEU', 'ألمانيا'),
(16403, 1348362240, 1348366335, 'MC', 'MCO', 'موناكو'),
(16404, 1348366336, 1348370431, 'IT', 'ITA', 'إيطاليا'),
(16405, 1348370432, 1348374527, 'DE', 'DEU', 'ألمانيا'),
(16406, 1348374528, 1348378623, 'CH', 'CHE', 'سويسرا'),
(16407, 1348378624, 1348382719, 'BY', 'BLR', 'روسيا البيضاء'),
(16408, 1348382720, 1348386815, 'FR', 'FRA', 'فرنسا'),
(16409, 1348386816, 1348390911, 'GB', 'GBR', 'المملكة المتحدة'),
(16410, 1348390912, 1348395007, 'SE', 'SWE', 'السويد'),
(16411, 1348395008, 1348399103, 'BY', 'BLR', 'روسيا البيضاء'),
(16412, 1348399104, 1348403199, 'MD', 'MDA', 'مولدوفا'),
(16413, 1348407296, 1348411391, 'BG', 'BGR', 'بلغاريا'),
(16414, 1348411392, 1348415487, 'RU', 'RUS', 'الإتحاد الروسي'),
(16415, 1348415488, 1348419583, 'GB', 'GBR', 'المملكة المتحدة'),
(16416, 1348419584, 1348427775, 'HU', 'HUN', 'هنغاريا'),
(16417, 1348427776, 1348435967, 'CZ', 'CZE', 'التشيك'),
(16418, 1348435968, 1348440063, 'FI', 'FIN', 'فنلندا'),
(16419, 1348440064, 1348444159, 'DE', 'DEU', 'ألمانيا'),
(16420, 1348444160, 1348448255, 'NL', 'NLD', 'هولندا'),
(16421, 1348448256, 1348456447, 'GB', 'GBR', 'المملكة المتحدة'),
(16422, 1348456448, 1348460543, 'BH', 'BHR', 'البحرين'),
(16423, 1348460544, 1348464639, 'SI', 'SVN', 'سلوفينيا'),
(16424, 1348464640, 1348468735, 'CZ', 'CZE', 'التشيك'),
(16425, 1348468736, 1348548607, 'RO', 'ROM', 'رومانيا'),
(16426, 1348548608, 1348549631, 'MD', 'MDA', 'مولدوفا'),
(16427, 1348549632, 1348599807, 'RO', 'ROM', 'رومانيا'),
(16428, 1348599808, 1348730879, 'HU', 'HUN', 'هنغاريا'),
(16429, 1348730880, 1348861951, 'NL', 'NLD', 'هولندا'),
(16430, 1348861952, 1348993023, 'ES', 'ESP', 'إسبانيا'),
(16431, 1348993024, 1349124095, 'IT', 'ITA', 'إيطاليا'),
(16432, 1349124096, 1349255167, 'GR', 'GRC', 'اليونان'),
(16433, 1349255168, 1349517311, 'AT', 'AUT', 'النمسا'),
(16434, 1349517312, 1349763071, 'NL', 'NLD', 'هولندا'),
(16435, 1349763072, 1349771263, 'RU', 'RUS', 'الإتحاد الروسي'),
(16436, 1349771264, 1349779455, 'NL', 'NLD', 'هولندا'),
(16437, 1349779456, 1349910527, 'IT', 'ITA', 'إيطاليا'),
(16438, 1349910528, 1350041599, 'FR', 'FRA', 'فرنسا'),
(16439, 1350041600, 1350091135, 'AT', 'AUT', 'النمسا'),
(16440, 1350091136, 1350091199, 'SA', 'SAU', 'السعودية'),
(16441, 1350091200, 1350091991, 'AT', 'AUT', 'النمسا'),
(16442, 1350091992, 1350091999, 'SA', 'SAU', 'السعودية'),
(16443, 1350092000, 1350092375, 'AT', 'AUT', 'النمسا'),
(16444, 1350092376, 1350092391, 'IQ', 'IRQ', 'العراق'),
(16445, 1350092392, 1350092467, 'AT', 'AUT', 'النمسا'),
(16446, 1350092468, 1350092471, 'DE', 'DEU', 'ألمانيا'),
(16447, 1350092472, 1350092495, 'AT', 'AUT', 'النمسا'),
(16448, 1350092496, 1350092503, 'IQ', 'IRQ', 'العراق'),
(16449, 1350092504, 1350215167, 'AT', 'AUT', 'النمسا'),
(16450, 1350215168, 1350215191, 'IQ', 'IRQ', 'العراق'),
(16451, 1350215192, 1350215679, 'AT', 'AUT', 'النمسا'),
(16452, 1350215680, 1350215683, 'SA', 'SAU', 'السعودية'),
(16453, 1350215684, 1350215699, 'AT', 'AUT', 'النمسا'),
(16454, 1350215700, 1350215703, 'IQ', 'IRQ', 'العراق'),
(16455, 1350215704, 1350215743, 'AT', 'AUT', 'النمسا'),
(16456, 1350215744, 1350215751, 'IQ', 'IRQ', 'العراق'),
(16457, 1350215752, 1350215763, 'AT', 'AUT', 'النمسا'),
(16458, 1350215764, 1350215767, 'IQ', 'IRQ', 'العراق'),
(16459, 1350215768, 1350215783, 'AT', 'AUT', 'النمسا'),
(16460, 1350215784, 1350215787, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16461, 1350215788, 1350215791, 'IQ', 'IRQ', 'العراق'),
(16462, 1350215792, 1350215903, 'AT', 'AUT', 'النمسا'),
(16463, 1350215904, 1350215911, 'IQ', 'IRQ', 'العراق'),
(16464, 1350215912, 1350215971, 'AT', 'AUT', 'النمسا'),
(16465, 1350215972, 1350215975, 'IQ', 'IRQ', 'العراق'),
(16466, 1350215976, 1350215987, 'AT', 'AUT', 'النمسا'),
(16467, 1350215988, 1350215991, 'DE', 'DEU', 'ألمانيا'),
(16468, 1350215992, 1350216023, 'AT', 'AUT', 'النمسا'),
(16469, 1350216024, 1350216031, 'IQ', 'IRQ', 'العراق'),
(16470, 1350216032, 1350216047, 'AT', 'AUT', 'النمسا'),
(16471, 1350216048, 1350216055, 'SA', 'SAU', 'السعودية'),
(16472, 1350216056, 1350216075, 'AT', 'AUT', 'النمسا'),
(16473, 1350216076, 1350216079, 'SA', 'SAU', 'السعودية'),
(16474, 1350216080, 1350216095, 'AT', 'AUT', 'النمسا'),
(16475, 1350216096, 1350216107, 'SA', 'SAU', 'السعودية'),
(16476, 1350216108, 1350216111, 'AT', 'AUT', 'النمسا'),
(16477, 1350216112, 1350216123, 'SA', 'SAU', 'السعودية'),
(16478, 1350216124, 1350216127, 'IQ', 'IRQ', 'العراق'),
(16479, 1350216128, 1350216151, 'AT', 'AUT', 'النمسا'),
(16480, 1350216152, 1350216159, 'SA', 'SAU', 'السعودية'),
(16481, 1350216160, 1350216175, 'AT', 'AUT', 'النمسا'),
(16482, 1350216176, 1350216183, 'SA', 'SAU', 'السعودية'),
(16483, 1350216184, 1350216203, 'AT', 'AUT', 'النمسا'),
(16484, 1350216204, 1350216207, 'SA', 'SAU', 'السعودية'),
(16485, 1350216208, 1350216211, 'AT', 'AUT', 'النمسا'),
(16486, 1350216212, 1350216219, 'SA', 'SAU', 'السعودية'),
(16487, 1350216220, 1350216223, 'AT', 'AUT', 'النمسا'),
(16488, 1350216224, 1350216227, 'SA', 'SAU', 'السعودية'),
(16489, 1350216228, 1350216231, 'AT', 'AUT', 'النمسا'),
(16490, 1350216232, 1350216235, 'SA', 'SAU', 'السعودية'),
(16491, 1350216236, 1350216239, 'AT', 'AUT', 'النمسا'),
(16492, 1350216240, 1350216243, 'SA', 'SAU', 'السعودية'),
(16493, 1350216244, 1350216247, 'AT', 'AUT', 'النمسا'),
(16494, 1350216248, 1350216251, 'SA', 'SAU', 'السعودية'),
(16495, 1350216252, 1350216275, 'AT', 'AUT', 'النمسا'),
(16496, 1350216276, 1350216287, 'SA', 'SAU', 'السعودية'),
(16497, 1350216288, 1350216295, 'AT', 'AUT', 'النمسا'),
(16498, 1350216296, 1350216299, 'SA', 'SAU', 'السعودية'),
(16499, 1350216300, 1350216311, 'AT', 'AUT', 'النمسا'),
(16500, 1350216312, 1350216315, 'SA', 'SAU', 'السعودية'),
(16501, 1350216316, 1350216431, 'AT', 'AUT', 'النمسا'),
(16502, 1350216432, 1350216451, 'SA', 'SAU', 'السعودية'),
(16503, 1350216452, 1350216455, 'AT', 'AUT', 'النمسا'),
(16504, 1350216456, 1350216459, 'SA', 'SAU', 'السعودية'),
(16505, 1350216460, 1350216467, 'AT', 'AUT', 'النمسا'),
(16506, 1350216468, 1350216471, 'SA', 'SAU', 'السعودية'),
(16507, 1350216472, 1350216475, 'IQ', 'IRQ', 'العراق'),
(16508, 1350216476, 1350216479, 'SA', 'SAU', 'السعودية'),
(16509, 1350216480, 1350216487, 'DE', 'DEU', 'ألمانيا'),
(16510, 1350216488, 1350216551, 'AT', 'AUT', 'النمسا'),
(16511, 1350216552, 1350216555, 'SA', 'SAU', 'السعودية'),
(16512, 1350216556, 1350216711, 'AT', 'AUT', 'النمسا'),
(16513, 1350216712, 1350216719, 'SA', 'SAU', 'السعودية'),
(16514, 1350216720, 1350216723, 'AT', 'AUT', 'النمسا'),
(16515, 1350216724, 1350216727, 'SA', 'SAU', 'السعودية'),
(16516, 1350216728, 1350216731, 'AT', 'AUT', 'النمسا'),
(16517, 1350216732, 1350216735, 'IQ', 'IRQ', 'العراق'),
(16518, 1350216736, 1350216743, 'AT', 'AUT', 'النمسا'),
(16519, 1350216744, 1350216759, 'IQ', 'IRQ', 'العراق'),
(16520, 1350216760, 1350216983, 'AT', 'AUT', 'النمسا'),
(16521, 1350216984, 1350216987, 'IQ', 'IRQ', 'العراق'),
(16522, 1350216988, 1350217011, 'AT', 'AUT', 'النمسا'),
(16523, 1350217012, 1350217015, 'IQ', 'IRQ', 'العراق'),
(16524, 1350217016, 1350217027, 'AT', 'AUT', 'النمسا'),
(16525, 1350217028, 1350217031, 'SA', 'SAU', 'السعودية'),
(16526, 1350217032, 1350217043, 'AT', 'AUT', 'النمسا'),
(16527, 1350217044, 1350217047, 'IQ', 'IRQ', 'العراق'),
(16528, 1350217048, 1350217051, 'SA', 'SAU', 'السعودية'),
(16529, 1350217052, 1350217079, 'AT', 'AUT', 'النمسا'),
(16530, 1350217080, 1350217083, 'SA', 'SAU', 'السعودية'),
(16531, 1350217084, 1350217115, 'AT', 'AUT', 'النمسا'),
(16532, 1350217116, 1350217119, 'SA', 'SAU', 'السعودية'),
(16533, 1350217120, 1350217135, 'AT', 'AUT', 'النمسا'),
(16534, 1350217136, 1350217139, 'SA', 'SAU', 'السعودية'),
(16535, 1350217140, 1350217343, 'AT', 'AUT', 'النمسا'),
(16536, 1350217344, 1350217347, 'IQ', 'IRQ', 'العراق'),
(16537, 1350217348, 1350217351, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16538, 1350217352, 1350217403, 'AT', 'AUT', 'النمسا'),
(16539, 1350217404, 1350217407, 'SA', 'SAU', 'السعودية'),
(16540, 1350217408, 1350217423, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16541, 1350217424, 1350217455, 'AT', 'AUT', 'النمسا'),
(16542, 1350217456, 1350217471, 'IT', 'ITA', 'إيطاليا'),
(16543, 1350217472, 1350217635, 'AT', 'AUT', 'النمسا'),
(16544, 1350217636, 1350217639, 'DE', 'DEU', 'ألمانيا'),
(16545, 1350217640, 1350217695, 'AT', 'AUT', 'النمسا'),
(16546, 1350217696, 1350217711, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16547, 1350217712, 1350220287, 'AT', 'AUT', 'النمسا'),
(16548, 1350220288, 1350220543, 'DE', 'DEU', 'ألمانيا'),
(16549, 1350220544, 1350295823, 'AT', 'AUT', 'النمسا'),
(16550, 1350295824, 1350295831, 'SA', 'SAU', 'السعودية'),
(16551, 1350295832, 1350295847, 'AT', 'AUT', 'النمسا'),
(16552, 1350295848, 1350295855, 'SA', 'SAU', 'السعودية'),
(16553, 1350295856, 1350296071, 'AT', 'AUT', 'النمسا'),
(16554, 1350296072, 1350296079, 'IQ', 'IRQ', 'العراق'),
(16555, 1350296080, 1350296099, 'AT', 'AUT', 'النمسا'),
(16556, 1350296100, 1350296103, 'SA', 'SAU', 'السعودية'),
(16557, 1350296104, 1350296111, 'IQ', 'IRQ', 'العراق'),
(16558, 1350296112, 1350296119, 'AT', 'AUT', 'النمسا'),
(16559, 1350296120, 1350296127, 'IQ', 'IRQ', 'العراق'),
(16560, 1350296128, 1350296199, 'AT', 'AUT', 'النمسا'),
(16561, 1350296200, 1350296207, 'SA', 'SAU', 'السعودية'),
(16562, 1350296208, 1350296243, 'IQ', 'IRQ', 'العراق'),
(16563, 1350296244, 1350296247, 'AT', 'AUT', 'النمسا'),
(16564, 1350296248, 1350296255, 'IQ', 'IRQ', 'العراق'),
(16565, 1350296256, 1350296303, 'AT', 'AUT', 'النمسا'),
(16566, 1350296304, 1350296319, 'IQ', 'IRQ', 'العراق'),
(16567, 1350296320, 1350296327, 'AT', 'AUT', 'النمسا'),
(16568, 1350296328, 1350296343, 'IQ', 'IRQ', 'العراق'),
(16569, 1350296344, 1350296351, 'AT', 'AUT', 'النمسا'),
(16570, 1350296352, 1350296359, 'IQ', 'IRQ', 'العراق'),
(16571, 1350296360, 1350296367, 'AT', 'AUT', 'النمسا'),
(16572, 1350296368, 1350296387, 'IQ', 'IRQ', 'العراق'),
(16573, 1350296388, 1350296391, 'AT', 'AUT', 'النمسا'),
(16574, 1350296392, 1350296395, 'IQ', 'IRQ', 'العراق'),
(16575, 1350296396, 1350296399, 'AT', 'AUT', 'النمسا'),
(16576, 1350296400, 1350296403, 'SA', 'SAU', 'السعودية'),
(16577, 1350296404, 1350296419, 'IQ', 'IRQ', 'العراق'),
(16578, 1350296420, 1350296431, 'SA', 'SAU', 'السعودية'),
(16579, 1350296432, 1350296439, 'DE', 'DEU', 'ألمانيا'),
(16580, 1350296440, 1350296511, 'AT', 'AUT', 'النمسا'),
(16581, 1350296512, 1350296519, 'IQ', 'IRQ', 'العراق'),
(16582, 1350296520, 1350296539, 'AT', 'AUT', 'النمسا'),
(16583, 1350296540, 1350296543, 'SA', 'SAU', 'السعودية'),
(16584, 1350296544, 1350303743, 'AT', 'AUT', 'النمسا'),
(16585, 1350303744, 1350434815, 'FR', 'FRA', 'فرنسا'),
(16586, 1350434816, 1350565887, 'NL', 'NLD', 'هولندا'),
(16587, 1350565888, 1351793791, 'DE', 'DEU', 'ألمانيا'),
(16588, 1351793792, 1351793855, 'GB', 'GBR', 'المملكة المتحدة'),
(16589, 1351793856, 1351797231, 'DE', 'DEU', 'ألمانيا'),
(16590, 1351797232, 1351797239, 'PL', 'POL', 'بولندا'),
(16591, 1351797240, 1351801327, 'DE', 'DEU', 'ألمانيا'),
(16592, 1351801328, 1351801335, 'HU', 'HUN', 'هنغاريا'),
(16593, 1351801336, 1351806975, 'DE', 'DEU', 'ألمانيا'),
(16594, 1351806976, 1351807231, 'IT', 'ITA', 'إيطاليا'),
(16595, 1351807232, 1351879631, 'DE', 'DEU', 'ألمانيا'),
(16596, 1351879632, 1351879639, 'IT', 'ITA', 'إيطاليا'),
(16597, 1351879640, 1351879999, 'DE', 'DEU', 'ألمانيا'),
(16598, 1351880000, 1351880031, 'IT', 'ITA', 'إيطاليا'),
(16599, 1351880032, 1351965183, 'DE', 'DEU', 'ألمانيا'),
(16600, 1351965184, 1351965439, 'US', 'USA', 'الولايات المتحدة'),
(16601, 1351965440, 1352010239, 'DE', 'DEU', 'ألمانيا'),
(16602, 1352010240, 1352010495, 'US', 'USA', 'الولايات المتحدة'),
(16603, 1352010496, 1352011447, 'DE', 'DEU', 'ألمانيا'),
(16604, 1352011448, 1352011455, 'IT', 'ITA', 'إيطاليا'),
(16605, 1352011456, 1352038695, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(16606, 1352038696, 1352038699, 'US', 'USA', 'الولايات المتحدة'),
(16607, 1352038700, 1352139671, 'DE', 'DEU', 'ألمانيا'),
(16608, 1352139672, 1352139679, 'IT', 'ITA', 'إيطاليا'),
(16609, 1352139680, 1352144519, 'DE', 'DEU', 'ألمانيا'),
(16610, 1352144520, 1352144527, 'IT', 'ITA', 'إيطاليا'),
(16611, 1352144528, 1352144535, 'US', 'USA', 'الولايات المتحدة'),
(16612, 1352144536, 1352147007, 'DE', 'DEU', 'ألمانيا'),
(16613, 1352147008, 1352147015, 'SE', 'SWE', 'السويد'),
(16614, 1352147016, 1352147107, 'DE', 'DEU', 'ألمانيا'),
(16615, 1352147108, 1352147111, 'SE', 'SWE', 'السويد'),
(16616, 1352147112, 1352147263, 'DE', 'DEU', 'ألمانيا'),
(16617, 1352147264, 1352147271, 'ES', 'ESP', 'إسبانيا'),
(16618, 1352147272, 1352147391, 'DE', 'DEU', 'ألمانيا'),
(16619, 1352147392, 1352147399, 'CZ', 'CZE', 'التشيك'),
(16620, 1352147400, 1352147423, 'DE', 'DEU', 'ألمانيا'),
(16621, 1352147424, 1352147431, 'ES', 'ESP', 'إسبانيا'),
(16622, 1352147432, 1352147439, 'DE', 'DEU', 'ألمانيا'),
(16623, 1352147440, 1352147447, 'SZ', 'SWZ', 'سوازيلند'),
(16624, 1352147448, 1352148151, 'DE', 'DEU', 'ألمانيا'),
(16625, 1352148152, 1352148159, 'IT', 'ITA', 'إيطاليا'),
(16626, 1352148160, 1352148751, 'DE', 'DEU', 'ألمانيا'),
(16627, 1352148752, 1352148759, 'US', 'USA', 'الولايات المتحدة'),
(16628, 1352148760, 1352277535, 'DE', 'DEU', 'ألمانيا'),
(16629, 1352277536, 1352277567, 'IT', 'ITA', 'إيطاليا'),
(16630, 1352277568, 1352402791, 'DE', 'DEU', 'ألمانيا'),
(16631, 1352402792, 1352402799, 'BE', 'BEL', 'بلجيكا'),
(16632, 1352402800, 1352404599, 'DE', 'DEU', 'ألمانيا'),
(16633, 1352404600, 1352404607, 'NL', 'NLD', 'هولندا'),
(16634, 1352404608, 1352445687, 'DE', 'DEU', 'ألمانيا'),
(16635, 1352445688, 1352445703, 'NL', 'NLD', 'هولندا'),
(16636, 1352445704, 1352663039, 'DE', 'DEU', 'ألمانيا'),
(16637, 1352663040, 1353187327, 'DK', 'DNK', 'الدنيمارك'),
(16638, 1353187328, 1353255071, 'GB', 'GBR', 'المملكة المتحدة'),
(16639, 1353255072, 1353255087, 'CA', 'CAN', 'كندا'),
(16640, 1353255088, 1353255839, 'GB', 'GBR', 'المملكة المتحدة'),
(16641, 1353255840, 1353255855, 'FR', 'FRA', 'فرنسا'),
(16642, 1353255856, 1353257111, 'GB', 'GBR', 'المملكة المتحدة'),
(16643, 1353257112, 1353257119, 'ES', 'ESP', 'إسبانيا'),
(16644, 1353257120, 1353257983, 'GB', 'GBR', 'المملكة المتحدة'),
(16645, 1353257984, 1353258247, 'SE', 'SWE', 'السويد'),
(16646, 1353258248, 1353258255, 'GB', 'GBR', 'المملكة المتحدة'),
(16647, 1353258256, 1353258263, 'SE', 'SWE', 'السويد'),
(16648, 1353258264, 1353258271, 'DK', 'DNK', 'الدنيمارك'),
(16649, 1353258272, 1353258303, 'SE', 'SWE', 'السويد'),
(16650, 1353258304, 1353258367, 'FI', 'FIN', 'فنلندا'),
(16651, 1353258368, 1353258415, 'SE', 'SWE', 'السويد'),
(16652, 1353258416, 1353258423, 'DK', 'DNK', 'الدنيمارك'),
(16653, 1353258424, 1353258495, 'SE', 'SWE', 'السويد'),
(16654, 1353258496, 1353258503, 'GB', 'GBR', 'المملكة المتحدة'),
(16655, 1353258504, 1353258647, 'SE', 'SWE', 'السويد'),
(16656, 1353258648, 1353258783, 'GB', 'GBR', 'المملكة المتحدة'),
(16657, 1353258784, 1353258807, 'SE', 'SWE', 'السويد'),
(16658, 1353258808, 1353265943, 'GB', 'GBR', 'المملكة المتحدة'),
(16659, 1353265944, 1353265951, 'IE', 'IRL', 'إيرلندا'),
(16660, 1353265952, 1353266959, 'GB', 'GBR', 'المملكة المتحدة'),
(16661, 1353266960, 1353266975, 'IE', 'IRL', 'إيرلندا'),
(16662, 1353266976, 1353267455, 'GB', 'GBR', 'المملكة المتحدة'),
(16663, 1353267456, 1353267839, 'IE', 'IRL', 'إيرلندا'),
(16664, 1353267840, 1353267967, 'DE', 'DEU', 'ألمانيا'),
(16665, 1353267968, 1353268223, 'IE', 'IRL', 'إيرلندا'),
(16666, 1353268224, 1353268479, 'GB', 'GBR', 'المملكة المتحدة'),
(16667, 1353268480, 1353269247, 'BE', 'BEL', 'بلجيكا'),
(16668, 1353269248, 1353271807, 'GB', 'GBR', 'المملكة المتحدة'),
(16669, 1353271808, 1353271831, 'ES', 'ESP', 'إسبانيا'),
(16670, 1353271832, 1353271839, 'GB', 'GBR', 'المملكة المتحدة'),
(16671, 1353271840, 1353271847, 'ES', 'ESP', 'إسبانيا'),
(16672, 1353271848, 1353271895, 'GB', 'GBR', 'المملكة المتحدة'),
(16673, 1353271896, 1353271919, 'ES', 'ESP', 'إسبانيا'),
(16674, 1353271920, 1353271927, 'GB', 'GBR', 'المملكة المتحدة'),
(16675, 1353271928, 1353272031, 'ES', 'ESP', 'إسبانيا'),
(16676, 1353272032, 1353272039, 'FR', 'FRA', 'فرنسا'),
(16677, 1353272040, 1353272055, 'ES', 'ESP', 'إسبانيا'),
(16678, 1353272056, 1353272063, 'GB', 'GBR', 'المملكة المتحدة'),
(16679, 1353272064, 1353272095, 'ES', 'ESP', 'إسبانيا'),
(16680, 1353272096, 1353272103, 'GB', 'GBR', 'المملكة المتحدة'),
(16681, 1353272104, 1353272245, 'ES', 'ESP', 'إسبانيا'),
(16682, 1353272246, 1353272255, 'GB', 'GBR', 'المملكة المتحدة'),
(16683, 1353272256, 1353272647, 'ES', 'ESP', 'إسبانيا'),
(16684, 1353272648, 1353272655, 'GB', 'GBR', 'المملكة المتحدة'),
(16685, 1353272656, 1353272691, 'ES', 'ESP', 'إسبانيا'),
(16686, 1353272692, 1353272695, 'GB', 'GBR', 'المملكة المتحدة'),
(16687, 1353272696, 1353272727, 'ES', 'ESP', 'إسبانيا'),
(16688, 1353272728, 1353272735, 'GB', 'GBR', 'المملكة المتحدة'),
(16689, 1353272736, 1353272783, 'ES', 'ESP', 'إسبانيا'),
(16690, 1353272784, 1353272799, 'GB', 'GBR', 'المملكة المتحدة'),
(16691, 1353272800, 1353272807, 'ES', 'ESP', 'إسبانيا'),
(16692, 1353272808, 1353272815, 'GB', 'GBR', 'المملكة المتحدة'),
(16693, 1353272816, 1353272847, 'ES', 'ESP', 'إسبانيا'),
(16694, 1353272848, 1353272879, 'GB', 'GBR', 'المملكة المتحدة'),
(16695, 1353272880, 1353272927, 'ES', 'ESP', 'إسبانيا'),
(16696, 1353272928, 1353272959, 'GB', 'GBR', 'المملكة المتحدة'),
(16697, 1353272960, 1353273007, 'ES', 'ESP', 'إسبانيا'),
(16698, 1353273008, 1353273023, 'GB', 'GBR', 'المملكة المتحدة'),
(16699, 1353273024, 1353273047, 'ES', 'ESP', 'إسبانيا'),
(16700, 1353273048, 1353273055, 'GB', 'GBR', 'المملكة المتحدة'),
(16701, 1353273056, 1353273343, 'ES', 'ESP', 'إسبانيا'),
(16702, 1353273344, 1353273631, 'BE', 'BEL', 'بلجيكا'),
(16703, 1353273632, 1353273639, 'ES', 'ESP', 'إسبانيا'),
(16704, 1353273640, 1353273711, 'BE', 'BEL', 'بلجيكا'),
(16705, 1353273712, 1353273719, 'GB', 'GBR', 'المملكة المتحدة'),
(16706, 1353273720, 1353274367, 'BE', 'BEL', 'بلجيكا'),
(16707, 1353274368, 1353274655, 'ES', 'ESP', 'إسبانيا'),
(16708, 1353274656, 1353274663, 'GB', 'GBR', 'المملكة المتحدة'),
(16709, 1353274664, 1353274671, 'ES', 'ESP', 'إسبانيا'),
(16710, 1353274672, 1353274679, 'GB', 'GBR', 'المملكة المتحدة'),
(16711, 1353274680, 1353274687, 'ES', 'ESP', 'إسبانيا'),
(16712, 1353274688, 1353274703, 'GB', 'GBR', 'المملكة المتحدة'),
(16713, 1353274704, 1353274759, 'ES', 'ESP', 'إسبانيا'),
(16714, 1353274760, 1353274767, 'GB', 'GBR', 'المملكة المتحدة'),
(16715, 1353274768, 1353274831, 'ES', 'ESP', 'إسبانيا'),
(16716, 1353274832, 1353274839, 'GB', 'GBR', 'المملكة المتحدة'),
(16717, 1353274840, 1353274863, 'ES', 'ESP', 'إسبانيا'),
(16718, 1353274864, 1353274879, 'GB', 'GBR', 'المملكة المتحدة'),
(16719, 1353274880, 1353274895, 'ES', 'ESP', 'إسبانيا'),
(16720, 1353274896, 1353274911, 'GB', 'GBR', 'المملكة المتحدة'),
(16721, 1353274912, 1353274919, 'ES', 'ESP', 'إسبانيا'),
(16722, 1353274920, 1353274927, 'GB', 'GBR', 'المملكة المتحدة'),
(16723, 1353274928, 1353275023, 'ES', 'ESP', 'إسبانيا'),
(16724, 1353275024, 1353275039, 'GB', 'GBR', 'المملكة المتحدة'),
(16725, 1353275040, 1353275087, 'ES', 'ESP', 'إسبانيا'),
(16726, 1353275088, 1353275103, 'GB', 'GBR', 'المملكة المتحدة'),
(16727, 1353275104, 1353275231, 'ES', 'ESP', 'إسبانيا'),
(16728, 1353275232, 1353275255, 'GB', 'GBR', 'المملكة المتحدة'),
(16729, 1353275256, 1353275263, 'ES', 'ESP', 'إسبانيا'),
(16730, 1353275264, 1353275279, 'GB', 'GBR', 'المملكة المتحدة'),
(16731, 1353275280, 1353275335, 'ES', 'ESP', 'إسبانيا'),
(16732, 1353275336, 1353275343, 'GB', 'GBR', 'المملكة المتحدة'),
(16733, 1353275344, 1353275391, 'ES', 'ESP', 'إسبانيا'),
(16734, 1353275392, 1353277439, 'GB', 'GBR', 'المملكة المتحدة'),
(16735, 1353277440, 1353279487, 'CH', 'CHE', 'سويسرا'),
(16736, 1353279488, 1353279695, 'IT', 'ITA', 'إيطاليا'),
(16737, 1353279696, 1353279711, 'GB', 'GBR', 'المملكة المتحدة'),
(16738, 1353279712, 1353279743, 'IT', 'ITA', 'إيطاليا'),
(16739, 1353279744, 1353279751, 'GB', 'GBR', 'المملكة المتحدة'),
(16740, 1353279752, 1353279759, 'IT', 'ITA', 'إيطاليا'),
(16741, 1353279760, 1353279767, 'GB', 'GBR', 'المملكة المتحدة'),
(16742, 1353279768, 1353279783, 'IT', 'ITA', 'إيطاليا'),
(16743, 1353279784, 1353279791, 'GB', 'GBR', 'المملكة المتحدة'),
(16744, 1353279792, 1353279855, 'IT', 'ITA', 'إيطاليا'),
(16745, 1353279856, 1353279863, 'GB', 'GBR', 'المملكة المتحدة'),
(16746, 1353279864, 1353280031, 'IT', 'ITA', 'إيطاليا'),
(16747, 1353280032, 1353280039, 'GB', 'GBR', 'المملكة المتحدة'),
(16748, 1353280040, 1353280111, 'IT', 'ITA', 'إيطاليا'),
(16749, 1353280112, 1353280119, 'GB', 'GBR', 'المملكة المتحدة'),
(16750, 1353280120, 1353280591, 'IT', 'ITA', 'إيطاليا'),
(16751, 1353280592, 1353280607, 'GB', 'GBR', 'المملكة المتحدة'),
(16752, 1353280608, 1353280655, 'IT', 'ITA', 'إيطاليا'),
(16753, 1353280656, 1353280663, 'GB', 'GBR', 'المملكة المتحدة'),
(16754, 1353280664, 1353280671, 'IT', 'ITA', 'إيطاليا'),
(16755, 1353280672, 1353280679, 'GB', 'GBR', 'المملكة المتحدة'),
(16756, 1353280680, 1353280767, 'IT', 'ITA', 'إيطاليا'),
(16757, 1353280768, 1353281023, 'GB', 'GBR', 'المملكة المتحدة'),
(16758, 1353281024, 1353281535, 'BE', 'BEL', 'بلجيكا'),
(16759, 1353281536, 1353282047, 'GB', 'GBR', 'المملكة المتحدة'),
(16760, 1353282048, 1353282559, 'IT', 'ITA', 'إيطاليا'),
(16761, 1353282560, 1353283071, 'GB', 'GBR', 'المملكة المتحدة'),
(16762, 1353283072, 1353283327, 'IT', 'ITA', 'إيطاليا'),
(16763, 1353283328, 1353287327, 'GB', 'GBR', 'المملكة المتحدة'),
(16764, 1353287328, 1353287359, 'IE', 'IRL', 'إيرلندا'),
(16765, 1353287360, 1353287679, 'GB', 'GBR', 'المملكة المتحدة'),
(16766, 1353287680, 1353287935, 'DE', 'DEU', 'ألمانيا'),
(16767, 1353287936, 1353288031, 'IE', 'IRL', 'إيرلندا'),
(16768, 1353288032, 1353288063, 'GB', 'GBR', 'المملكة المتحدة'),
(16769, 1353288064, 1353288151, 'IE', 'IRL', 'إيرلندا'),
(16770, 1353288152, 1353288159, 'GB', 'GBR', 'المملكة المتحدة'),
(16771, 1353288160, 1353288167, 'IE', 'IRL', 'إيرلندا'),
(16772, 1353288168, 1353288191, 'GB', 'GBR', 'المملكة المتحدة'),
(16773, 1353288192, 1353288319, 'IE', 'IRL', 'إيرلندا'),
(16774, 1353288320, 1353288327, 'GB', 'GBR', 'المملكة المتحدة'),
(16775, 1353288328, 1353288351, 'IE', 'IRL', 'إيرلندا'),
(16776, 1353288352, 1353288383, 'GB', 'GBR', 'المملكة المتحدة'),
(16777, 1353288384, 1353288399, 'IE', 'IRL', 'إيرلندا'),
(16778, 1353288400, 1353288407, 'GB', 'GBR', 'المملكة المتحدة'),
(16779, 1353288408, 1353288519, 'IE', 'IRL', 'إيرلندا'),
(16780, 1353288520, 1353288527, 'GB', 'GBR', 'المملكة المتحدة'),
(16781, 1353288528, 1353288607, 'IE', 'IRL', 'إيرلندا'),
(16782, 1353288608, 1353288639, 'GB', 'GBR', 'المملكة المتحدة'),
(16783, 1353288640, 1353288863, 'IE', 'IRL', 'إيرلندا'),
(16784, 1353288864, 1353288895, 'GB', 'GBR', 'المملكة المتحدة'),
(16785, 1353288896, 1353289247, 'IE', 'IRL', 'إيرلندا'),
(16786, 1353289248, 1353289255, 'GB', 'GBR', 'المملكة المتحدة'),
(16787, 1353289256, 1353289359, 'IE', 'IRL', 'إيرلندا'),
(16788, 1353289360, 1353289367, 'GB', 'GBR', 'المملكة المتحدة'),
(16789, 1353289368, 1353289391, 'IE', 'IRL', 'إيرلندا'),
(16790, 1353289392, 1353289407, 'GB', 'GBR', 'المملكة المتحدة'),
(16791, 1353289408, 1353289623, 'IE', 'IRL', 'إيرلندا'),
(16792, 1353289624, 1353289631, 'GB', 'GBR', 'المملكة المتحدة'),
(16793, 1353289632, 1353289647, 'IE', 'IRL', 'إيرلندا'),
(16794, 1353289648, 1353290751, 'GB', 'GBR', 'المملكة المتحدة'),
(16795, 1353290752, 1353290815, 'DE', 'DEU', 'ألمانيا'),
(16796, 1353290816, 1353290927, 'GB', 'GBR', 'المملكة المتحدة'),
(16797, 1353290928, 1353290935, 'IE', 'IRL', 'إيرلندا'),
(16798, 1353290936, 1353297151, 'GB', 'GBR', 'المملكة المتحدة'),
(16799, 1353297152, 1353297183, 'IE', 'IRL', 'إيرلندا'),
(16800, 1353297184, 1353298687, 'GB', 'GBR', 'المملكة المتحدة'),
(16801, 1353298688, 1353298695, 'SE', 'SWE', 'السويد'),
(16802, 1353298696, 1353298703, 'DE', 'DEU', 'ألمانيا'),
(16803, 1353298704, 1353298711, 'SE', 'SWE', 'السويد'),
(16804, 1353298712, 1353298719, 'GB', 'GBR', 'المملكة المتحدة'),
(16805, 1353298720, 1353298751, 'DE', 'DEU', 'ألمانيا'),
(16806, 1353298752, 1353298879, 'SE', 'SWE', 'السويد'),
(16807, 1353298880, 1353298887, 'GB', 'GBR', 'المملكة المتحدة'),
(16808, 1353298888, 1353299711, 'SE', 'SWE', 'السويد'),
(16809, 1353299712, 1353299839, 'GB', 'GBR', 'المملكة المتحدة'),
(16810, 1353299840, 1353299855, 'SE', 'SWE', 'السويد'),
(16811, 1353299856, 1353299863, 'GB', 'GBR', 'المملكة المتحدة'),
(16812, 1353299864, 1353300063, 'SE', 'SWE', 'السويد'),
(16813, 1353300064, 1353300071, 'GB', 'GBR', 'المملكة المتحدة'),
(16814, 1353300072, 1353300079, 'SE', 'SWE', 'السويد'),
(16815, 1353300080, 1353300103, 'GB', 'GBR', 'المملكة المتحدة'),
(16816, 1353300104, 1353300111, 'SE', 'SWE', 'السويد'),
(16817, 1353300112, 1353300159, 'GB', 'GBR', 'المملكة المتحدة'),
(16818, 1353300160, 1353300167, 'SE', 'SWE', 'السويد'),
(16819, 1353300168, 1353300175, 'GB', 'GBR', 'المملكة المتحدة'),
(16820, 1353300176, 1353300191, 'SE', 'SWE', 'السويد'),
(16821, 1353300192, 1353300239, 'GB', 'GBR', 'المملكة المتحدة'),
(16822, 1353300240, 1353300247, 'SE', 'SWE', 'السويد'),
(16823, 1353300248, 1353300255, 'GB', 'GBR', 'المملكة المتحدة'),
(16824, 1353300256, 1353300271, 'SE', 'SWE', 'السويد'),
(16825, 1353300272, 1353300279, 'GB', 'GBR', 'المملكة المتحدة'),
(16826, 1353300280, 1353300351, 'SE', 'SWE', 'السويد'),
(16827, 1353300352, 1353300359, 'GB', 'GBR', 'المملكة المتحدة'),
(16828, 1353300360, 1353300383, 'SE', 'SWE', 'السويد'),
(16829, 1353300384, 1353300479, 'GB', 'GBR', 'المملكة المتحدة'),
(16830, 1353300480, 1353300735, 'SE', 'SWE', 'السويد'),
(16831, 1353300736, 1353301095, 'GB', 'GBR', 'المملكة المتحدة'),
(16832, 1353301096, 1353301103, 'US', 'USA', 'الولايات المتحدة'),
(16833, 1353301104, 1353304879, 'GB', 'GBR', 'المملكة المتحدة'),
(16834, 1353304880, 1353304895, 'ES', 'ESP', 'إسبانيا'),
(16835, 1353304896, 1353305599, 'GB', 'GBR', 'المملكة المتحدة'),
(16836, 1353305600, 1353305607, 'IE', 'IRL', 'إيرلندا'),
(16837, 1353305608, 1353306111, 'GB', 'GBR', 'المملكة المتحدة'),
(16838, 1353306112, 1353306623, 'ES', 'ESP', 'إسبانيا'),
(16839, 1353306624, 1353306880, 'BE', 'BEL', 'بلجيكا'),
(16840, 1353306881, 1353308159, 'GB', 'GBR', 'المملكة المتحدة'),
(16841, 1353308160, 1353309183, 'FR', 'FRA', 'فرنسا'),
(16842, 1353309184, 1353310463, 'GB', 'GBR', 'المملكة المتحدة'),
(16843, 1353310464, 1353310599, 'ES', 'ESP', 'إسبانيا'),
(16844, 1353310600, 1353310607, 'DE', 'DEU', 'ألمانيا'),
(16845, 1353310608, 1353310719, 'ES', 'ESP', 'إسبانيا'),
(16846, 1353310720, 1353311175, 'IT', 'ITA', 'إيطاليا'),
(16847, 1353311176, 1353311183, 'ES', 'ESP', 'إسبانيا'),
(16848, 1353311184, 1353311231, 'IT', 'ITA', 'إيطاليا'),
(16849, 1353311232, 1353312255, 'GB', 'GBR', 'المملكة المتحدة'),
(16850, 1353312256, 1353312767, 'CH', 'CHE', 'سويسرا'),
(16851, 1353312768, 1353313135, 'IT', 'ITA', 'إيطاليا'),
(16852, 1353313136, 1353313143, 'GB', 'GBR', 'المملكة المتحدة'),
(16853, 1353313144, 1353313191, 'IT', 'ITA', 'إيطاليا'),
(16854, 1353313192, 1353313207, 'GB', 'GBR', 'المملكة المتحدة'),
(16855, 1353313208, 1353313279, 'IT', 'ITA', 'إيطاليا'),
(16856, 1353313280, 1353313535, 'IE', 'IRL', 'إيرلندا'),
(16857, 1353313536, 1353314303, 'GB', 'GBR', 'المملكة المتحدة'),
(16858, 1353314304, 1353314815, 'CH', 'CHE', 'سويسرا'),
(16859, 1353314816, 1353315327, 'GB', 'GBR', 'المملكة المتحدة'),
(16860, 1353315328, 1353315415, 'ES', 'ESP', 'إسبانيا'),
(16861, 1353315416, 1353315423, 'FR', 'FRA', 'فرنسا'),
(16862, 1353315424, 1353316351, 'ES', 'ESP', 'إسبانيا'),
(16863, 1353316352, 1353317375, 'GB', 'GBR', 'المملكة المتحدة'),
(16864, 1353317376, 1353317631, 'FR', 'FRA', 'فرنسا'),
(16865, 1353317632, 1353318143, 'GB', 'GBR', 'المملكة المتحدة'),
(16866, 1353318144, 1353318399, 'IE', 'IRL', 'إيرلندا'),
(16867, 1353318400, 1353383935, 'SE', 'SWE', 'السويد'),
(16868, 1353383936, 1353449471, 'DE', 'DEU', 'ألمانيا'),
(16869, 1353449472, 1353515007, 'PT', 'PRT', 'البورتوغال'),
(16870, 1353515008, 1353646079, 'ES', 'ESP', 'إسبانيا'),
(16871, 1353646080, 1353842687, 'GB', 'GBR', 'المملكة المتحدة'),
(16872, 1353842688, 1353956607, 'IL', 'ISR', 'إسرائيل'),
(16873, 1353956608, 1353956863, 'GB', 'GBR', 'المملكة المتحدة'),
(16874, 1353956864, 1353973759, 'IL', 'ISR', 'إسرائيل'),
(16875, 1353973760, 1354235903, 'IT', 'ITA', 'إيطاليا'),
(16876, 1354235904, 1354301439, 'KW', 'KWT', 'الكويت'),
(16877, 1354301440, 1354366975, 'FR', 'FRA', 'فرنسا'),
(16878, 1354366976, 1354432511, 'FI', 'FIN', 'فنلندا'),
(16879, 1354432512, 1354498047, 'DE', 'DEU', 'ألمانيا'),
(16880, 1354498048, 1354563583, 'CZ', 'CZE', 'التشيك'),
(16881, 1354563584, 1354629119, 'GB', 'GBR', 'المملكة المتحدة'),
(16882, 1354629120, 1354662143, 'DE', 'DEU', 'ألمانيا'),
(16883, 1354662144, 1354662151, 'AT', 'AUT', 'النمسا'),
(16884, 1354662152, 1354662463, 'DE', 'DEU', 'ألمانيا'),
(16885, 1354662464, 1354662527, 'AT', 'AUT', 'النمسا'),
(16886, 1354662528, 1354662591, 'ES', 'ESP', 'إسبانيا'),
(16887, 1354662592, 1354663807, 'DE', 'DEU', 'ألمانيا'),
(16888, 1354663808, 1354663808, 'AT', 'AUT', 'النمسا'),
(16889, 1354663809, 1354664743, 'DE', 'DEU', 'ألمانيا'),
(16890, 1354664744, 1354664751, 'IT', 'ITA', 'إيطاليا'),
(16891, 1354664752, 1354664759, 'DE', 'DEU', 'ألمانيا'),
(16892, 1354664760, 1354664767, 'IT', 'ITA', 'إيطاليا'),
(16893, 1354664768, 1354665215, 'DE', 'DEU', 'ألمانيا'),
(16894, 1354665216, 1354665247, 'ES', 'ESP', 'إسبانيا'),
(16895, 1354665248, 1354665943, 'DE', 'DEU', 'ألمانيا'),
(16896, 1354665944, 1354665951, 'IT', 'ITA', 'إيطاليا'),
(16897, 1354665952, 1354666639, 'DE', 'DEU', 'ألمانيا'),
(16898, 1354666640, 1354666650, 'FI', 'FIN', 'فنلندا'),
(16899, 1354666651, 1354666687, 'DE', 'DEU', 'ألمانيا'),
(16900, 1354666688, 1354666688, 'FI', 'FIN', 'فنلندا'),
(16901, 1354666689, 1354668031, 'DE', 'DEU', 'ألمانيا'),
(16902, 1354668032, 1354668159, 'AT', 'AUT', 'النمسا'),
(16903, 1354668160, 1354673919, 'DE', 'DEU', 'ألمانيا'),
(16904, 1354673920, 1354674175, 'PL', 'POL', 'بولندا'),
(16905, 1354674176, 1354674719, 'DE', 'DEU', 'ألمانيا'),
(16906, 1354674720, 1354674751, 'CH', 'CHE', 'سويسرا'),
(16907, 1354674752, 1354674783, 'DK', 'DNK', 'الدنيمارك'),
(16908, 1354674784, 1354674815, 'DE', 'DEU', 'ألمانيا'),
(16909, 1354674816, 1354674943, 'IT', 'ITA', 'إيطاليا'),
(16910, 1354674944, 1354675199, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16911, 1354675200, 1354675327, 'DE', 'DEU', 'ألمانيا'),
(16912, 1354675328, 1354675359, 'DK', 'DNK', 'الدنيمارك'),
(16913, 1354675360, 1354676479, 'DE', 'DEU', 'ألمانيا'),
(16914, 1354676480, 1354676767, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16915, 1354676768, 1354676783, 'DE', 'DEU', 'ألمانيا'),
(16916, 1354676784, 1354676791, 'PL', 'POL', 'بولندا'),
(16917, 1354676792, 1354676991, 'DE', 'DEU', 'ألمانيا'),
(16918, 1354676992, 1354677023, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16919, 1354677024, 1354677247, 'DE', 'DEU', 'ألمانيا'),
(16920, 1354677248, 1354677279, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16921, 1354677280, 1354678015, 'DE', 'DEU', 'ألمانيا'),
(16922, 1354678016, 1354678031, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16923, 1354678032, 1354678159, 'DE', 'DEU', 'ألمانيا'),
(16924, 1354678160, 1354678163, 'PL', 'POL', 'بولندا'),
(16925, 1354678164, 1354678559, 'DE', 'DEU', 'ألمانيا'),
(16926, 1354678560, 1354678575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16927, 1354678576, 1354678743, 'DE', 'DEU', 'ألمانيا'),
(16928, 1354678744, 1354678751, 'CH', 'CHE', 'سويسرا'),
(16929, 1354678752, 1354678759, 'IT', 'ITA', 'إيطاليا'),
(16930, 1354678760, 1354679295, 'DE', 'DEU', 'ألمانيا'),
(16931, 1354679296, 1354679807, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16932, 1354679808, 1354679839, 'DE', 'DEU', 'ألمانيا'),
(16933, 1354679840, 1354679871, 'DK', 'DNK', 'الدنيمارك'),
(16934, 1354679872, 1354680063, 'DE', 'DEU', 'ألمانيا'),
(16935, 1354680064, 1354680079, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16936, 1354680080, 1354680175, 'DE', 'DEU', 'ألمانيا'),
(16937, 1354680176, 1354680179, 'PL', 'POL', 'بولندا'),
(16938, 1354680180, 1354681247, 'DE', 'DEU', 'ألمانيا'),
(16939, 1354681248, 1354681279, 'DK', 'DNK', 'الدنيمارك'),
(16940, 1354681280, 1354681471, 'DE', 'DEU', 'ألمانيا'),
(16941, 1354681472, 1354681487, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16942, 1354681488, 1354681815, 'DE', 'DEU', 'ألمانيا'),
(16943, 1354681816, 1354681823, 'CH', 'CHE', 'سويسرا'),
(16944, 1354681824, 1354682111, 'DE', 'DEU', 'ألمانيا'),
(16945, 1354682112, 1354682143, 'DK', 'DNK', 'الدنيمارك'),
(16946, 1354682144, 1354682175, 'CH', 'CHE', 'سويسرا'),
(16947, 1354682176, 1354682287, 'DE', 'DEU', 'ألمانيا'),
(16948, 1354682288, 1354682303, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16949, 1354682304, 1354682771, 'DE', 'DEU', 'ألمانيا'),
(16950, 1354682772, 1354682775, 'RS', 'SRB', 'صربيا'),
(16951, 1354682776, 1354682895, 'DE', 'DEU', 'ألمانيا'),
(16952, 1354682896, 1354682911, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16953, 1354682912, 1354682939, 'DE', 'DEU', 'ألمانيا'),
(16954, 1354682940, 1354682943, 'MC', 'MCO', 'موناكو'),
(16955, 1354682944, 1354683095, 'DE', 'DEU', 'ألمانيا'),
(16956, 1354683096, 1354683103, 'IT', 'ITA', 'إيطاليا'),
(16957, 1354683104, 1354683391, 'DE', 'DEU', 'ألمانيا'),
(16958, 1354683392, 1354683903, 'PL', 'POL', 'بولندا'),
(16959, 1354683904, 1354684415, 'DE', 'DEU', 'ألمانيا'),
(16960, 1354684416, 1354684431, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16961, 1354684432, 1354684671, 'DE', 'DEU', 'ألمانيا'),
(16962, 1354684672, 1354684927, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16963, 1354684928, 1354687023, 'DE', 'DEU', 'ألمانيا'),
(16964, 1354687024, 1354687031, 'LU', 'LUX', 'لوكسيمبورغ'),
(16965, 1354687032, 1354687359, 'DE', 'DEU', 'ألمانيا'),
(16966, 1354687360, 1354687375, 'NZ', 'NZL', 'نيوزيلاندا'),
(16967, 1354687376, 1354687383, 'DE', 'DEU', 'ألمانيا'),
(16968, 1354687384, 1354687391, 'NZ', 'NZL', 'نيوزيلاندا'),
(16969, 1354687392, 1354687399, 'DE', 'DEU', 'ألمانيا'),
(16970, 1354687400, 1354687407, 'IT', 'ITA', 'إيطاليا'),
(16971, 1354687408, 1354687455, 'DE', 'DEU', 'ألمانيا'),
(16972, 1354687456, 1354687487, 'IT', 'ITA', 'إيطاليا'),
(16973, 1354687488, 1354687759, 'DE', 'DEU', 'ألمانيا'),
(16974, 1354687760, 1354687763, 'CH', 'CHE', 'سويسرا'),
(16975, 1354687764, 1354688362, 'DE', 'DEU', 'ألمانيا'),
(16976, 1354688363, 1354688363, 'CH', 'CHE', 'سويسرا'),
(16977, 1354688364, 1354694655, 'DE', 'DEU', 'ألمانيا'),
(16978, 1354694656, 1354760191, 'IR', 'IRN', 'إيران'),
(16979, 1354760192, 1355022335, 'GB', 'GBR', 'المملكة المتحدة'),
(16980, 1355022336, 1355284479, 'DK', 'DNK', 'الدنيمارك'),
(16981, 1355284480, 1355415551, 'BE', 'BEL', 'بلجيكا'),
(16982, 1355415552, 1355546623, 'NO', 'NOR', 'النرويج'),
(16983, 1355546624, 1355808767, 'IT', 'ITA', 'إيطاليا'),
(16984, 1355808768, 1356070911, 'DK', 'DNK', 'الدنيمارك'),
(16985, 1356070912, 1356201983, 'NO', 'NOR', 'النرويج'),
(16986, 1356201984, 1356333055, 'FR', 'FRA', 'فرنسا'),
(16987, 1356333056, 1356464127, 'SE', 'SWE', 'السويد'),
(16988, 1356464128, 1356595199, 'CH', 'CHE', 'سويسرا'),
(16989, 1356595200, 1356857343, 'FI', 'FIN', 'فنلندا'),
(16990, 1356857344, 1356922879, 'ES', 'ESP', 'إسبانيا'),
(16991, 1356922880, 1356988415, 'GB', 'GBR', 'المملكة المتحدة'),
(16992, 1356988416, 1357053951, 'DE', 'DEU', 'ألمانيا'),
(16993, 1357053952, 1357119487, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(16994, 1357119488, 1357126807, 'DE', 'DEU', 'ألمانيا'),
(16995, 1357126808, 1357126815, 'NL', 'NLD', 'هولندا'),
(16996, 1357126816, 1357127063, 'DE', 'DEU', 'ألمانيا'),
(16997, 1357127064, 1357127079, 'NL', 'NLD', 'هولندا'),
(16998, 1357127080, 1357127471, 'DE', 'DEU', 'ألمانيا'),
(16999, 1357127472, 1357127487, 'CH', 'CHE', 'سويسرا'),
(17000, 1357127488, 1357177943, 'DE', 'DEU', 'ألمانيا'),
(17001, 1357177944, 1357177951, 'NL', 'NLD', 'هولندا'),
(17002, 1357177952, 1357185023, 'DE', 'DEU', 'ألمانيا'),
(17003, 1357185024, 1357250559, 'GB', 'GBR', 'المملكة المتحدة'),
(17004, 1357250560, 1357316095, 'IL', 'ISR', 'إسرائيل'),
(17005, 1357316608, 1357317119, 'LU', 'LUX', 'لوكسيمبورغ'),
(17006, 1357317632, 1357318143, 'LY', 'LBY', 'ليبيا'),
(17007, 1357318144, 1357320191, 'QA', 'QAT', 'قطر'),
(17008, 1357320192, 1357320703, 'FR', 'FRA', 'فرنسا'),
(17009, 1357320704, 1357320959, 'RO', 'ROM', 'رومانيا'),
(17010, 1357320960, 1357320991, 'ES', 'ESP', 'إسبانيا'),
(17011, 1357320992, 1357320999, 'GB', 'GBR', 'المملكة المتحدة'),
(17012, 1357321000, 1357321007, 'FR', 'FRA', 'فرنسا'),
(17013, 1357321008, 1357321015, 'GB', 'GBR', 'المملكة المتحدة'),
(17014, 1357321016, 1357321023, 'DK', 'DNK', 'الدنيمارك'),
(17015, 1357321024, 1357321087, 'KE', 'KEN', 'كينيا'),
(17016, 1357321216, 1357321471, 'GB', 'GBR', 'المملكة المتحدة'),
(17017, 1357321472, 1357321503, 'ES', 'ESP', 'إسبانيا'),
(17018, 1357321728, 1357321983, 'CY', 'CYP', 'قبرص'),
(17019, 1357321984, 1357322239, 'SO', 'SOM', 'الصومال'),
(17020, 1357322240, 1357322751, 'DE', 'DEU', 'ألمانيا'),
(17021, 1357322752, 1357323263, 'BH', 'BHR', 'البحرين'),
(17022, 1357323264, 1357323519, 'ES', 'ESP', 'إسبانيا'),
(17023, 1357323520, 1357323775, 'GB', 'GBR', 'المملكة المتحدة'),
(17024, 1357323776, 1357324287, 'DE', 'DEU', 'ألمانيا'),
(17025, 1357324288, 1357326335, 'GB', 'GBR', 'المملكة المتحدة'),
(17026, 1357326336, 1357326591, 'NL', 'NLD', 'هولندا'),
(17027, 1357326592, 1357326847, 'DE', 'DEU', 'ألمانيا'),
(17028, 1357326848, 1357327359, 'GB', 'GBR', 'المملكة المتحدة'),
(17029, 1357327360, 1357328383, 'DE', 'DEU', 'ألمانيا'),
(17030, 1357330432, 1357330943, 'DE', 'DEU', 'ألمانيا'),
(17031, 1357330944, 1357331455, 'ES', 'ESP', 'إسبانيا'),
(17032, 1357332480, 1357333247, 'DE', 'DEU', 'ألمانيا'),
(17033, 1357333248, 1357333503, 'GB', 'GBR', 'المملكة المتحدة'),
(17034, 1357333504, 1357333759, 'IR', 'IRN', 'إيران'),
(17035, 1357333824, 1357333855, 'GB', 'GBR', 'المملكة المتحدة'),
(17036, 1357333856, 1357334015, 'ES', 'ESP', 'إسبانيا'),
(17037, 1357334016, 1357334271, 'TZ', 'TZA', 'تانزانيا'),
(17038, 1357334272, 1357334527, 'CA', 'CAN', 'كندا'),
(17039, 1357334528, 1357335039, 'FR', 'FRA', 'فرنسا'),
(17040, 1357335040, 1357335295, 'LB', 'LBN', 'لبنان'),
(17041, 1357335296, 1357335551, 'FR', 'FRA', 'فرنسا'),
(17042, 1357335552, 1357335807, 'GB', 'GBR', 'المملكة المتحدة'),
(17043, 1357335808, 1357336063, 'KE', 'KEN', 'كينيا'),
(17044, 1357336064, 1357336319, 'GB', 'GBR', 'المملكة المتحدة'),
(17045, 1357336320, 1357336575, 'FR', 'FRA', 'فرنسا'),
(17046, 1357336576, 1357337599, 'NL', 'NLD', 'هولندا'),
(17047, 1357337600, 1357337855, 'ES', 'ESP', 'إسبانيا'),
(17048, 1357337856, 1357338111, 'SA', 'SAU', 'السعودية'),
(17049, 1357338112, 1357338879, 'FR', 'FRA', 'فرنسا'),
(17050, 1357338880, 1357339391, 'NO', 'NOR', 'النرويج'),
(17051, 1357339392, 1357339647, 'AT', 'AUT', 'النمسا'),
(17052, 1357339648, 1357339903, 'DZ', 'DZA', 'الجزائر'),
(17053, 1357340416, 1357340671, 'LB', 'LBN', 'لبنان'),
(17054, 1357340672, 1357342719, 'GB', 'GBR', 'المملكة المتحدة'),
(17055, 1357348864, 1357349119, 'DE', 'DEU', 'ألمانيا'),
(17056, 1357349120, 1357349375, 'LU', 'LUX', 'لوكسيمبورغ'),
(17057, 1357349888, 1357350399, 'ES', 'ESP', 'إسبانيا'),
(17058, 1357350400, 1357350911, 'QA', 'QAT', 'قطر'),
(17059, 1357350912, 1357351167, 'GB', 'GBR', 'المملكة المتحدة'),
(17060, 1357351168, 1357351423, 'PL', 'POL', 'بولندا'),
(17061, 1357351936, 1357352959, 'GB', 'GBR', 'المملكة المتحدة'),
(17062, 1357356032, 1357356543, 'ES', 'ESP', 'إسبانيا'),
(17063, 1357357056, 1357357567, 'ES', 'ESP', 'إسبانيا'),
(17064, 1357357568, 1357358079, 'DE', 'DEU', 'ألمانيا'),
(17065, 1357358080, 1357358335, 'ES', 'ESP', 'إسبانيا'),
(17066, 1357358336, 1357358591, 'FR', 'FRA', 'فرنسا'),
(17067, 1357358592, 1357358847, 'DE', 'DEU', 'ألمانيا'),
(17068, 1357358848, 1357359103, 'PL', 'POL', 'بولندا'),
(17069, 1357359104, 1357359615, 'ES', 'ESP', 'إسبانيا'),
(17070, 1357359872, 1357359999, 'ES', 'ESP', 'إسبانيا'),
(17071, 1357360128, 1357360255, 'GB', 'GBR', 'المملكة المتحدة'),
(17072, 1357360384, 1357360639, 'ES', 'ESP', 'إسبانيا'),
(17073, 1357360640, 1357360895, 'GB', 'GBR', 'المملكة المتحدة'),
(17074, 1357360896, 1357361151, 'DE', 'DEU', 'ألمانيا'),
(17075, 1357363200, 1357364223, 'QA', 'QAT', 'قطر'),
(17076, 1357364224, 1357365247, 'ES', 'ESP', 'إسبانيا'),
(17077, 1357365248, 1357365759, 'DZ', 'DZA', 'الجزائر'),
(17078, 1357365760, 1357365791, 'ES', 'ESP', 'إسبانيا'),
(17079, 1357365792, 1357365823, 'BH', 'BHR', 'البحرين'),
(17080, 1357365824, 1357365887, 'GB', 'GBR', 'المملكة المتحدة'),
(17081, 1357365888, 1357366015, 'DE', 'DEU', 'ألمانيا'),
(17082, 1357366016, 1357366271, 'KM', 'COM', 'جزر القمر'),
(17083, 1357366272, 1357366527, 'FR', 'FRA', 'فرنسا'),
(17084, 1357366528, 1357366591, 'BE', 'BEL', 'بلجيكا'),
(17085, 1357366592, 1357366655, 'FR', 'FRA', 'فرنسا'),
(17086, 1357366656, 1357366719, 'PT', 'PRT', 'البورتوغال'),
(17087, 1357366784, 1357366799, 'MD', 'MDA', 'مولدوفا'),
(17088, 1357366800, 1357366815, 'ES', 'ESP', 'إسبانيا'),
(17089, 1357366816, 1357366847, 'FR', 'FRA', 'فرنسا'),
(17090, 1357366848, 1357366863, 'GB', 'GBR', 'المملكة المتحدة'),
(17091, 1357366864, 1357366879, 'ES', 'ESP', 'إسبانيا'),
(17092, 1357366880, 1357366911, 'GB', 'GBR', 'المملكة المتحدة'),
(17093, 1357367040, 1357367295, 'GB', 'GBR', 'المملكة المتحدة'),
(17094, 1357367808, 1357368063, 'GB', 'GBR', 'المملكة المتحدة'),
(17095, 1357368064, 1357368831, 'GN', 'GIN', 'غينيا'),
(17096, 1357368832, 1357369343, 'ES', 'ESP', 'إسبانيا'),
(17097, 1357369344, 1357369599, 'PL', 'POL', 'بولندا'),
(17098, 1357369600, 1357369855, 'GB', 'GBR', 'المملكة المتحدة'),
(17099, 1357369856, 1357370111, 'KE', 'KEN', 'كينيا'),
(17100, 1357370112, 1357370367, 'DE', 'DEU', 'ألمانيا'),
(17101, 1357370880, 1357371391, 'LY', 'LBY', 'ليبيا'),
(17102, 1357371904, 1357372159, 'RU', 'RUS', 'الإتحاد الروسي'),
(17103, 1357372160, 1357372415, 'GB', 'GBR', 'المملكة المتحدة'),
(17104, 1357372928, 1357373183, 'AM', 'ARM', 'أرمينيا'),
(17105, 1357373184, 1357373439, 'GB', 'GBR', 'المملكة المتحدة'),
(17106, 1357381632, 1357391615, 'NO', 'NOR', 'النرويج'),
(17107, 1357391616, 1357391871, 'SE', 'SWE', 'السويد'),
(17108, 1357391872, 1357414399, 'NO', 'NOR', 'النرويج'),
(17109, 1357414400, 1357447167, 'LV', 'LVA', 'لاتفيا'),
(17110, 1357447168, 1357479935, 'IE', 'IRL', 'إيرلندا'),
(17111, 1357479936, 1357512703, 'LV', 'LVA', 'لاتفيا'),
(17112, 1357512704, 1357545471, 'RU', 'RUS', 'الإتحاد الروسي'),
(17113, 1357545472, 1357578239, 'GB', 'GBR', 'المملكة المتحدة'),
(17114, 1357578240, 1357611007, 'EE', 'EST', 'إستونيا'),
(17115, 1357611008, 1357643775, 'GB', 'GBR', 'المملكة المتحدة'),
(17116, 1357643776, 1357676543, 'FR', 'FRA', 'فرنسا'),
(17117, 1357676544, 1357709311, 'BE', 'BEL', 'بلجيكا'),
(17118, 1357709312, 1357742079, 'RU', 'RUS', 'الإتحاد الروسي'),
(17119, 1357742080, 1357759183, 'DE', 'DEU', 'ألمانيا'),
(17120, 1357759184, 1357759191, 'AT', 'AUT', 'النمسا'),
(17121, 1357759192, 1357765823, 'DE', 'DEU', 'ألمانيا'),
(17122, 1357765824, 1357765831, 'AT', 'AUT', 'النمسا'),
(17123, 1357765832, 1357773111, 'DE', 'DEU', 'ألمانيا'),
(17124, 1357773112, 1357773119, 'PL', 'POL', 'بولندا'),
(17125, 1357773120, 1357774847, 'DE', 'DEU', 'ألمانيا'),
(17126, 1357774848, 1357791231, 'GB', 'GBR', 'المملكة المتحدة'),
(17127, 1357791232, 1357807615, 'PL', 'POL', 'بولندا'),
(17128, 1357807616, 1357840383, 'CH', 'CHE', 'سويسرا'),
(17129, 1357840384, 1357867735, 'NO', 'NOR', 'النرويج'),
(17130, 1357867736, 1357867743, 'SE', 'SWE', 'السويد'),
(17131, 1357867744, 1357873151, 'NO', 'NOR', 'النرويج'),
(17132, 1357873152, 1357875199, 'DE', 'DEU', 'ألمانيا'),
(17133, 1357875200, 1357875215, 'AT', 'AUT', 'النمسا'),
(17134, 1357875216, 1357875247, 'DE', 'DEU', 'ألمانيا'),
(17135, 1357875248, 1357875263, 'US', 'USA', 'الولايات المتحدة'),
(17136, 1357875264, 1357875279, 'AT', 'AUT', 'النمسا'),
(17137, 1357875280, 1357875423, 'DE', 'DEU', 'ألمانيا'),
(17138, 1357875424, 1357875439, 'GB', 'GBR', 'المملكة المتحدة'),
(17139, 1357875440, 1357875711, 'DE', 'DEU', 'ألمانيا'),
(17140, 1357875712, 1357875967, 'PL', 'POL', 'بولندا'),
(17141, 1357875968, 1357876143, 'DE', 'DEU', 'ألمانيا'),
(17142, 1357876152, 1357876191, 'DE', 'DEU', 'ألمانيا'),
(17143, 1357876208, 1357876215, 'DE', 'DEU', 'ألمانيا'),
(17144, 1357876288, 1357876303, 'PL', 'POL', 'بولندا'),
(17145, 1357876336, 1357876339, 'PL', 'POL', 'بولندا'),
(17146, 1357876340, 1357876343, 'RU', 'RUS', 'الإتحاد الروسي'),
(17147, 1357876392, 1357876399, 'PL', 'POL', 'بولندا'),
(17148, 1357876416, 1357876479, 'PL', 'POL', 'بولندا'),
(17149, 1357876480, 1357876495, 'SE', 'SWE', 'السويد'),
(17150, 1357876544, 1357876863, 'DE', 'DEU', 'ألمانيا'),
(17151, 1357876864, 1357876927, 'SE', 'SWE', 'السويد'),
(17152, 1357876928, 1357877759, 'DE', 'DEU', 'ألمانيا'),
(17153, 1357878272, 1357879807, 'DE', 'DEU', 'ألمانيا'),
(17154, 1357879808, 1357879871, 'RU', 'RUS', 'الإتحاد الروسي'),
(17155, 1357879872, 1357879935, 'DE', 'DEU', 'ألمانيا'),
(17156, 1357879936, 1357880063, 'GB', 'GBR', 'المملكة المتحدة'),
(17157, 1357880064, 1357880319, 'NL', 'NLD', 'هولندا'),
(17158, 1357880320, 1357880447, 'DE', 'DEU', 'ألمانيا'),
(17159, 1357880448, 1357880511, 'CH', 'CHE', 'سويسرا'),
(17160, 1357880512, 1357880543, 'DE', 'DEU', 'ألمانيا'),
(17161, 1357880544, 1357880559, 'AT', 'AUT', 'النمسا'),
(17162, 1357880560, 1357880831, 'DE', 'DEU', 'ألمانيا'),
(17163, 1357880832, 1357881087, 'AT', 'AUT', 'النمسا'),
(17164, 1357881088, 1357881343, 'DE', 'DEU', 'ألمانيا'),
(17165, 1357881344, 1357883391, 'FR', 'FRA', 'فرنسا'),
(17166, 1357883392, 1357883407, 'ES', 'ESP', 'إسبانيا'),
(17167, 1357883424, 1357883519, 'FR', 'FRA', 'فرنسا'),
(17168, 1357883536, 1357883551, 'FR', 'FRA', 'فرنسا'),
(17169, 1357883584, 1357883719, 'FR', 'FRA', 'فرنسا'),
(17170, 1357883760, 1357883935, 'FR', 'FRA', 'فرنسا'),
(17171, 1357884000, 1357884031, 'FR', 'FRA', 'فرنسا'),
(17172, 1357884160, 1357884423, 'FR', 'FRA', 'فرنسا'),
(17173, 1357884440, 1357884447, 'FR', 'FRA', 'فرنسا'),
(17174, 1357884512, 1357884935, 'FR', 'FRA', 'فرنسا'),
(17175, 1357884992, 1357885055, 'FR', 'FRA', 'فرنسا'),
(17176, 1357885120, 1357885183, 'FR', 'FRA', 'فرنسا'),
(17177, 1357885200, 1357885215, 'ES', 'ESP', 'إسبانيا'),
(17178, 1357885248, 1357885439, 'DE', 'DEU', 'ألمانيا'),
(17179, 1357885440, 1357885695, 'FR', 'FRA', 'فرنسا'),
(17180, 1357885696, 1357885951, 'DE', 'DEU', 'ألمانيا'),
(17181, 1357885952, 1357886463, 'FR', 'FRA', 'فرنسا'),
(17182, 1357886464, 1357887487, 'US', 'USA', 'الولايات المتحدة'),
(17183, 1357887488, 1357888511, 'FR', 'FRA', 'فرنسا'),
(17184, 1357888640, 1357888703, 'DE', 'DEU', 'ألمانيا'),
(17185, 1357888768, 1357889023, 'DE', 'DEU', 'ألمانيا'),
(17186, 1357889536, 1357890815, 'PL', 'POL', 'بولندا'),
(17187, 1357890816, 1357890827, 'NL', 'NLD', 'هولندا'),
(17188, 1357890848, 1357890895, 'NL', 'NLD', 'هولندا'),
(17189, 1357890912, 1357890943, 'DE', 'DEU', 'ألمانيا'),
(17190, 1357890944, 1357891407, 'NL', 'NLD', 'هولندا'),
(17191, 1357891408, 1357891423, 'CA', 'CAN', 'كندا'),
(17192, 1357891424, 1357891455, 'NL', 'NLD', 'هولندا'),
(17193, 1357891456, 1357891583, 'SE', 'SWE', 'السويد'),
(17194, 1357891584, 1357891679, 'NL', 'NLD', 'هولندا'),
(17195, 1357891712, 1357891839, 'NL', 'NLD', 'هولندا'),
(17196, 1357891840, 1357892095, 'GB', 'GBR', 'المملكة المتحدة'),
(17197, 1357892352, 1357893119, 'NL', 'NLD', 'هولندا'),
(17198, 1357893120, 1357893375, 'SE', 'SWE', 'السويد'),
(17199, 1357893408, 1357893439, 'SE', 'SWE', 'السويد'),
(17200, 1357893504, 1357893631, 'DE', 'DEU', 'ألمانيا'),
(17201, 1357897856, 1357898495, 'DE', 'DEU', 'ألمانيا'),
(17202, 1357898752, 1357899015, 'DE', 'DEU', 'ألمانيا'),
(17203, 1357899024, 1357899055, 'DE', 'DEU', 'ألمانيا'),
(17204, 1357899072, 1357899199, 'DE', 'DEU', 'ألمانيا'),
(17205, 1357899328, 1357899391, 'PL', 'POL', 'بولندا'),
(17206, 1357899552, 1357899567, 'AT', 'AUT', 'النمسا'),
(17207, 1357899776, 1357900287, 'DE', 'DEU', 'ألمانيا'),
(17208, 1357900352, 1357900415, 'CH', 'CHE', 'سويسرا'),
(17209, 1357900416, 1357900543, 'SE', 'SWE', 'السويد'),
(17210, 1357900544, 1357900799, 'NL', 'NLD', 'هولندا'),
(17211, 1357900800, 1357901823, 'DE', 'DEU', 'ألمانيا'),
(17212, 1357901824, 1357902335, 'ES', 'ESP', 'إسبانيا'),
(17213, 1357902336, 1357902847, 'PL', 'POL', 'بولندا'),
(17214, 1357902848, 1357903359, 'GB', 'GBR', 'المملكة المتحدة'),
(17215, 1357903360, 1357903615, 'DE', 'DEU', 'ألمانيا'),
(17216, 1357903616, 1357903871, 'SE', 'SWE', 'السويد'),
(17217, 1357904384, 1357904895, 'DE', 'DEU', 'ألمانيا'),
(17218, 1357905920, 1357910015, 'LT', 'LTU', 'ليتوانيا'),
(17219, 1357910016, 1357914111, 'GR', 'GRC', 'اليونان'),
(17220, 1357914112, 1357922303, 'RU', 'RUS', 'الإتحاد الروسي'),
(17221, 1357922304, 1357926399, 'SA', 'SAU', 'السعودية'),
(17222, 1357926400, 1357930495, 'GB', 'GBR', 'المملكة المتحدة'),
(17223, 1357930496, 1357942783, 'RU', 'RUS', 'الإتحاد الروسي'),
(17224, 1357942784, 1357943039, 'RS', 'SRB', 'صربيا'),
(17225, 1357943040, 1357946879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(17226, 1357946880, 1357955071, 'PL', 'POL', 'بولندا'),
(17227, 1357959168, 1357963263, 'RU', 'RUS', 'الإتحاد الروسي'),
(17228, 1357963264, 1357964199, 'AT', 'AUT', 'النمسا'),
(17229, 1357964200, 1357964207, 'DE', 'DEU', 'ألمانيا'),
(17230, 1357964208, 1357967359, 'AT', 'AUT', 'النمسا'),
(17231, 1357967360, 1357971455, 'RU', 'RUS', 'الإتحاد الروسي'),
(17232, 1357971456, 1357975551, 'KZ', 'KAZ', 'كازاخستان'),
(17233, 1357975552, 1357979647, 'AT', 'AUT', 'النمسا'),
(17234, 1357979648, 1357983743, 'KZ', 'KAZ', 'كازاخستان'),
(17235, 1357983744, 1357987839, 'RU', 'RUS', 'الإتحاد الروسي'),
(17236, 1357987840, 1357988495, 'GB', 'GBR', 'المملكة المتحدة'),
(17237, 1357988496, 1357988543, 'DE', 'DEU', 'ألمانيا'),
(17238, 1357988544, 1357988551, 'NL', 'NLD', 'هولندا'),
(17239, 1357988552, 1357988559, 'DE', 'DEU', 'ألمانيا'),
(17240, 1357988560, 1357988567, 'GB', 'GBR', 'المملكة المتحدة'),
(17241, 1357988568, 1357988607, 'DE', 'DEU', 'ألمانيا'),
(17242, 1357988608, 1357988751, 'GB', 'GBR', 'المملكة المتحدة'),
(17243, 1357988752, 1357988775, 'DE', 'DEU', 'ألمانيا'),
(17244, 1357988776, 1357988783, 'GB', 'GBR', 'المملكة المتحدة'),
(17245, 1357988784, 1357988863, 'DE', 'DEU', 'ألمانيا'),
(17246, 1357988864, 1357989647, 'GB', 'GBR', 'المملكة المتحدة'),
(17247, 1357989648, 1357989655, 'FR', 'FRA', 'فرنسا'),
(17248, 1357989656, 1357989663, 'GB', 'GBR', 'المملكة المتحدة'),
(17249, 1357989664, 1357989703, 'FR', 'FRA', 'فرنسا'),
(17250, 1357989704, 1357989711, 'GB', 'GBR', 'المملكة المتحدة'),
(17251, 1357989712, 1357989727, 'FR', 'FRA', 'فرنسا'),
(17252, 1357989728, 1357989759, 'GB', 'GBR', 'المملكة المتحدة'),
(17253, 1357989760, 1357989783, 'FR', 'FRA', 'فرنسا'),
(17254, 1357989784, 1357989791, 'GB', 'GBR', 'المملكة المتحدة'),
(17255, 1357989792, 1357989807, 'FR', 'FRA', 'فرنسا'),
(17256, 1357989808, 1357989823, 'GB', 'GBR', 'المملكة المتحدة'),
(17257, 1357989824, 1357989839, 'FR', 'FRA', 'فرنسا'),
(17258, 1357989840, 1357989847, 'GB', 'GBR', 'المملكة المتحدة'),
(17259, 1357989848, 1357989887, 'FR', 'FRA', 'فرنسا'),
(17260, 1357989888, 1357991679, 'GB', 'GBR', 'المملكة المتحدة'),
(17261, 1357991680, 1357991711, 'DE', 'DEU', 'ألمانيا'),
(17262, 1357991712, 1357991719, 'GB', 'GBR', 'المملكة المتحدة'),
(17263, 1357991720, 1357991735, 'DE', 'DEU', 'ألمانيا'),
(17264, 1357991736, 1357991759, 'GB', 'GBR', 'المملكة المتحدة'),
(17265, 1357991760, 1357991783, 'DE', 'DEU', 'ألمانيا'),
(17266, 1357991784, 1357991791, 'GB', 'GBR', 'المملكة المتحدة'),
(17267, 1357991792, 1357991799, 'DE', 'DEU', 'ألمانيا'),
(17268, 1357991800, 1357991823, 'GB', 'GBR', 'المملكة المتحدة'),
(17269, 1357991824, 1357991839, 'DE', 'DEU', 'ألمانيا'),
(17270, 1357991840, 1357991855, 'GB', 'GBR', 'المملكة المتحدة'),
(17271, 1357991856, 1357991895, 'DE', 'DEU', 'ألمانيا'),
(17272, 1357991896, 1357991903, 'GB', 'GBR', 'المملكة المتحدة'),
(17273, 1357991904, 1357991927, 'DE', 'DEU', 'ألمانيا'),
(17274, 1357991928, 1357991935, 'GB', 'GBR', 'المملكة المتحدة'),
(17275, 1357991936, 1357996031, 'NO', 'NOR', 'النرويج'),
(17276, 1357996032, 1358000127, 'CH', 'CHE', 'سويسرا'),
(17277, 1358000128, 1358004223, 'LI', 'LIE', 'ليختنشتاين'),
(17278, 1358004224, 1358008319, 'PL', 'POL', 'بولندا'),
(17279, 1358008320, 1358012415, 'BH', 'BHR', 'البحرين'),
(17280, 1358012416, 1358016511, 'IT', 'ITA', 'إيطاليا'),
(17281, 1358016512, 1358020607, 'GE', 'GEO', 'جورجيا'),
(17282, 1358020608, 1358024703, 'DE', 'DEU', 'ألمانيا'),
(17283, 1358024704, 1358028799, 'EE', 'EST', 'إستونيا'),
(17284, 1358028800, 1358032895, 'IT', 'ITA', 'إيطاليا'),
(17285, 1358032896, 1358036991, 'GE', 'GEO', 'جورجيا'),
(17286, 1358036992, 1358041087, 'IR', 'IRN', 'إيران'),
(17287, 1358041088, 1358045183, 'FI', 'FIN', 'فنلندا'),
(17288, 1358045184, 1358049279, 'SK', 'SVK', 'سلوفاكيا'),
(17289, 1358049280, 1358061567, 'RU', 'RUS', 'الإتحاد الروسي'),
(17290, 1358061568, 1358065663, 'UA', 'UKR', 'أوكرانيا'),
(17291, 1358065664, 1358069759, 'BA', 'BIH', 'البوسنه والهرسك'),
(17292, 1358069760, 1358074719, 'DE', 'DEU', 'ألمانيا'),
(17293, 1358074720, 1358074751, 'CH', 'CHE', 'سويسرا'),
(17294, 1358074752, 1358082815, 'DE', 'DEU', 'ألمانيا'),
(17295, 1358082816, 1358083071, 'CH', 'CHE', 'سويسرا'),
(17296, 1358083072, 1358086143, 'DE', 'DEU', 'ألمانيا'),
(17297, 1358086144, 1358090239, 'CH', 'CHE', 'سويسرا'),
(17298, 1358090240, 1358094335, 'KZ', 'KAZ', 'كازاخستان'),
(17299, 1358094336, 1358102527, 'NL', 'NLD', 'هولندا'),
(17300, 1358102528, 1358106623, 'RU', 'RUS', 'الإتحاد الروسي'),
(17301, 1358106624, 1358110719, 'LT', 'LTU', 'ليتوانيا'),
(17302, 1358110720, 1358116895, 'DE', 'DEU', 'ألمانيا'),
(17303, 1358116896, 1358116911, 'IT', 'ITA', 'إيطاليا'),
(17304, 1358116912, 1358118911, 'DE', 'DEU', 'ألمانيا'),
(17305, 1358118912, 1358123007, 'RU', 'RUS', 'الإتحاد الروسي'),
(17306, 1358123008, 1358127103, 'PT', 'PRT', 'البورتوغال'),
(17307, 1358127104, 1358131199, 'CZ', 'CZE', 'التشيك'),
(17308, 1358131200, 1358135295, 'DK', 'DNK', 'الدنيمارك'),
(17309, 1358135296, 1358139391, 'RU', 'RUS', 'الإتحاد الروسي'),
(17310, 1358139392, 1358143487, 'UA', 'UKR', 'أوكرانيا'),
(17311, 1358143488, 1358144159, 'AT', 'AUT', 'النمسا'),
(17312, 1358144160, 1358144191, 'MT', 'MLT', 'مالطا'),
(17313, 1358144192, 1358147519, 'AT', 'AUT', 'النمسا'),
(17314, 1358147520, 1358147583, 'MT', 'MLT', 'مالطا'),
(17315, 1358147584, 1358151679, 'GB', 'GBR', 'المملكة المتحدة'),
(17316, 1358151680, 1358155775, 'DE', 'DEU', 'ألمانيا'),
(17317, 1358155776, 1358159871, 'CH', 'CHE', 'سويسرا'),
(17318, 1358159872, 1358163967, 'ES', 'ESP', 'إسبانيا'),
(17319, 1358163968, 1358168063, 'FR', 'FRA', 'فرنسا'),
(17320, 1358168064, 1358172159, 'GB', 'GBR', 'المملكة المتحدة'),
(17321, 1358172160, 1358173183, 'CY', 'CYP', 'قبرص'),
(17322, 1358173184, 1358173951, 'GR', 'GRC', 'اليونان'),
(17323, 1358173952, 1358174207, 'DE', 'DEU', 'ألمانيا'),
(17324, 1358174208, 1358176255, 'GR', 'GRC', 'اليونان'),
(17325, 1358176256, 1358180351, 'RU', 'RUS', 'الإتحاد الروسي'),
(17326, 1358180352, 1358184447, 'ES', 'ESP', 'إسبانيا'),
(17327, 1358184448, 1358192639, 'SE', 'SWE', 'السويد'),
(17328, 1358192640, 1358196735, 'HU', 'HUN', 'هنغاريا'),
(17329, 1358196736, 1358200831, 'IT', 'ITA', 'إيطاليا'),
(17330, 1358200832, 1358209023, 'PL', 'POL', 'بولندا'),
(17331, 1358209024, 1358213119, 'IL', 'ISR', 'إسرائيل'),
(17332, 1358213120, 1358217215, 'GB', 'GBR', 'المملكة المتحدة'),
(17333, 1358217216, 1358221311, 'SE', 'SWE', 'السويد'),
(17334, 1358221312, 1358223359, 'DE', 'DEU', 'ألمانيا'),
(17335, 1358223360, 1358223631, 'GB', 'GBR', 'المملكة المتحدة'),
(17336, 1358223632, 1358223663, 'DE', 'DEU', 'ألمانيا'),
(17337, 1358223664, 1358223671, 'GB', 'GBR', 'المملكة المتحدة'),
(17338, 1358223672, 1358223727, 'DE', 'DEU', 'ألمانيا'),
(17339, 1358223728, 1358223775, 'GB', 'GBR', 'المملكة المتحدة'),
(17340, 1358223776, 1358223843, 'DE', 'DEU', 'ألمانيا'),
(17341, 1358223844, 1358223871, 'GB', 'GBR', 'المملكة المتحدة'),
(17342, 1358223872, 1358223911, 'DE', 'DEU', 'ألمانيا'),
(17343, 1358223912, 1358223927, 'NL', 'NLD', 'هولندا'),
(17344, 1358223928, 1358223967, 'DE', 'DEU', 'ألمانيا'),
(17345, 1358223968, 1358224063, 'NL', 'NLD', 'هولندا'),
(17346, 1358224064, 1358224511, 'DE', 'DEU', 'ألمانيا'),
(17347, 1358224512, 1358224519, 'BE', 'BEL', 'بلجيكا'),
(17348, 1358224520, 1358224611, 'DE', 'DEU', 'ألمانيا'),
(17349, 1358224612, 1358224651, 'BE', 'BEL', 'بلجيكا'),
(17350, 1358224652, 1358224655, 'DE', 'DEU', 'ألمانيا'),
(17351, 1358224656, 1358224719, 'BE', 'BEL', 'بلجيكا'),
(17352, 1358224720, 1358224927, 'DE', 'DEU', 'ألمانيا'),
(17353, 1358224928, 1358225111, 'IT', 'ITA', 'إيطاليا'),
(17354, 1358225112, 1358225407, 'DE', 'DEU', 'ألمانيا'),
(17355, 1358225408, 1358229503, 'RU', 'RUS', 'الإتحاد الروسي'),
(17356, 1358229504, 1358229631, 'DE', 'DEU', 'ألمانيا'),
(17357, 1358229632, 1358229639, 'LU', 'LUX', 'لوكسيمبورغ'),
(17358, 1358229640, 1358230111, 'DE', 'DEU', 'ألمانيا'),
(17359, 1358230112, 1358230115, 'AT', 'AUT', 'النمسا'),
(17360, 1358230116, 1358230383, 'DE', 'DEU', 'ألمانيا'),
(17361, 1358230384, 1358230391, 'TR', 'TUR', 'تركيا'),
(17362, 1358230392, 1358230399, 'CH', 'CHE', 'سويسرا'),
(17363, 1358230400, 1358232863, 'DE', 'DEU', 'ألمانيا'),
(17364, 1358232864, 1358232879, 'IT', 'ITA', 'إيطاليا'),
(17365, 1358232880, 1358233599, 'DE', 'DEU', 'ألمانيا'),
(17366, 1358233600, 1358237695, 'ES', 'ESP', 'إسبانيا'),
(17367, 1358237696, 1358241791, 'FR', 'FRA', 'فرنسا'),
(17368, 1358241792, 1358241807, 'BE', 'BEL', 'بلجيكا'),
(17369, 1358241808, 1358241951, 'FR', 'FRA', 'فرنسا'),
(17370, 1358241952, 1358241983, 'BE', 'BEL', 'بلجيكا'),
(17371, 1358241984, 1358242591, 'FR', 'FRA', 'فرنسا'),
(17372, 1358242592, 1358242623, 'BE', 'BEL', 'بلجيكا'),
(17373, 1358242624, 1358245695, 'FR', 'FRA', 'فرنسا'),
(17374, 1358245696, 1358245727, 'BE', 'BEL', 'بلجيكا'),
(17375, 1358245728, 1358249215, 'FR', 'FRA', 'فرنسا'),
(17376, 1358249216, 1358249471, 'IT', 'ITA', 'إيطاليا'),
(17377, 1358249472, 1358249983, 'FR', 'FRA', 'فرنسا'),
(17378, 1358249984, 1358251815, 'DE', 'DEU', 'ألمانيا'),
(17379, 1358251816, 1358251823, 'NL', 'NLD', 'هولندا'),
(17380, 1358251824, 1358254079, 'DE', 'DEU', 'ألمانيا'),
(17381, 1358254080, 1358258175, 'MD', 'MDA', 'مولدوفا'),
(17382, 1358258176, 1358262271, 'GB', 'GBR', 'المملكة المتحدة'),
(17383, 1358262272, 1358266367, 'UA', 'UKR', 'أوكرانيا'),
(17384, 1358266368, 1358274559, 'DE', 'DEU', 'ألمانيا'),
(17385, 1358274560, 1358278655, 'GR', 'GRC', 'اليونان'),
(17386, 1358278656, 1358282751, 'PL', 'POL', 'بولندا'),
(17387, 1358282752, 1358286847, 'AT', 'AUT', 'النمسا'),
(17388, 1358286848, 1358290943, 'MT', 'MLT', 'مالطا'),
(17389, 1358290944, 1358295039, 'SE', 'SWE', 'السويد'),
(17390, 1358295040, 1358299135, 'RU', 'RUS', 'الإتحاد الروسي'),
(17391, 1358303232, 1358307327, 'RU', 'RUS', 'الإتحاد الروسي'),
(17392, 1358307328, 1358313215, 'DE', 'DEU', 'ألمانيا'),
(17393, 1358313216, 1358313727, 'ES', 'ESP', 'إسبانيا'),
(17394, 1358313728, 1358315519, 'DE', 'DEU', 'ألمانيا'),
(17395, 1358315520, 1358323711, 'RU', 'RUS', 'الإتحاد الروسي'),
(17396, 1358323712, 1358327807, 'LU', 'LUX', 'لوكسيمبورغ'),
(17397, 1358327808, 1358328671, 'DE', 'DEU', 'ألمانيا'),
(17398, 1358328672, 1358328727, 'AT', 'AUT', 'النمسا'),
(17399, 1358328728, 1358331903, 'DE', 'DEU', 'ألمانيا'),
(17400, 1358331904, 1358335999, 'IL', 'ISR', 'إسرائيل'),
(17401, 1358336000, 1358344191, 'FI', 'FIN', 'فنلندا'),
(17402, 1358344192, 1358352383, 'NL', 'NLD', 'هولندا'),
(17403, 1358352384, 1358356479, 'RU', 'RUS', 'الإتحاد الروسي'),
(17404, 1358356480, 1358360575, 'SI', 'SVN', 'سلوفينيا'),
(17405, 1358360576, 1358364671, 'RU', 'RUS', 'الإتحاد الروسي'),
(17406, 1358364672, 1358372863, 'GB', 'GBR', 'المملكة المتحدة'),
(17407, 1358372864, 1358376959, 'RU', 'RUS', 'الإتحاد الروسي'),
(17408, 1358376960, 1358381055, 'GB', 'GBR', 'المملكة المتحدة'),
(17409, 1358381056, 1358383311, 'IT', 'ITA', 'إيطاليا'),
(17410, 1358383312, 1358383327, 'FR', 'FRA', 'فرنسا'),
(17411, 1358383328, 1358384127, 'IT', 'ITA', 'إيطاليا'),
(17412, 1358384128, 1358384143, 'FR', 'FRA', 'فرنسا'),
(17413, 1358384144, 1358384191, 'IT', 'ITA', 'إيطاليا'),
(17414, 1358384192, 1358384199, 'FR', 'FRA', 'فرنسا'),
(17415, 1358384200, 1358385151, 'IT', 'ITA', 'إيطاليا'),
(17416, 1358385152, 1358389247, 'GB', 'GBR', 'المملكة المتحدة'),
(17417, 1358389248, 1358397439, 'RU', 'RUS', 'الإتحاد الروسي'),
(17418, 1358397440, 1358397951, 'GB', 'GBR', 'المملكة المتحدة'),
(17419, 1358397952, 1358398463, 'TZ', 'TZA', 'تانزانيا'),
(17420, 1358398464, 1358399487, 'GB', 'GBR', 'المملكة المتحدة'),
(17421, 1358399488, 1358399999, 'NG', 'NGA', 'نيجيريا'),
(17422, 1358400000, 1358400007, 'PK', 'PAK', 'باكستان'),
(17423, 1358400008, 1358400015, 'GB', 'GBR', 'المملكة المتحدة'),
(17424, 1358400016, 1358400071, 'IN', 'IND', 'الهند'),
(17425, 1358400072, 1358400255, 'GB', 'GBR', 'المملكة المتحدة'),
(17426, 1358400256, 1358400511, 'AF', 'AFG', 'أفغانستان'),
(17427, 1358400512, 1358400519, 'GA', 'GAB', 'الغابون'),
(17428, 1358400520, 1358400527, 'GB', 'GBR', 'المملكة المتحدة'),
(17429, 1358400528, 1358400535, 'TZ', 'TZA', 'تانزانيا'),
(17430, 1358400536, 1358400543, 'GB', 'GBR', 'المملكة المتحدة'),
(17431, 1358400544, 1358400551, 'GA', 'GAB', 'الغابون'),
(17432, 1358400552, 1358400575, 'GB', 'GBR', 'المملكة المتحدة'),
(17433, 1358400576, 1358400591, 'KE', 'KEN', 'كينيا'),
(17434, 1358400592, 1358400639, 'GB', 'GBR', 'المملكة المتحدة'),
(17435, 1358400640, 1358400775, 'KE', 'KEN', 'كينيا'),
(17436, 1358400776, 1358400783, 'GB', 'GBR', 'المملكة المتحدة'),
(17437, 1358400784, 1358400799, 'KE', 'KEN', 'كينيا'),
(17438, 1358400800, 1358400863, 'NG', 'NGA', 'نيجيريا'),
(17439, 1358400864, 1358400895, 'GA', 'GAB', 'الغابون'),
(17440, 1358400896, 1358401279, 'NG', 'NGA', 'نيجيريا'),
(17441, 1358401280, 1358401391, 'KE', 'KEN', 'كينيا'),
(17442, 1358401392, 1358401407, 'GB', 'GBR', 'المملكة المتحدة'),
(17443, 1358401408, 1358401439, 'KE', 'KEN', 'كينيا'),
(17444, 1358401440, 1358402175, 'GB', 'GBR', 'المملكة المتحدة'),
(17445, 1358402176, 1358402303, 'TZ', 'TZA', 'تانزانيا'),
(17446, 1358402304, 1358402319, 'GB', 'GBR', 'المملكة المتحدة'),
(17447, 1358402320, 1358402343, 'NG', 'NGA', 'نيجيريا'),
(17448, 1358402344, 1358402351, 'KE', 'KEN', 'كينيا'),
(17449, 1358402352, 1358402359, 'GB', 'GBR', 'المملكة المتحدة'),
(17450, 1358402360, 1358402363, 'ID', 'IDN', 'إندونيسيا'),
(17451, 1358402364, 1358402367, 'GB', 'GBR', 'المملكة المتحدة'),
(17452, 1358402368, 1358402399, 'NG', 'NGA', 'نيجيريا'),
(17453, 1358402400, 1358402415, 'CG', 'COG', 'الكونغو'),
(17454, 1358402416, 1358402419, 'ID', 'IDN', 'إندونيسيا'),
(17455, 1358402420, 1358402447, 'GB', 'GBR', 'المملكة المتحدة'),
(17456, 1358402448, 1358402463, 'KE', 'KEN', 'كينيا'),
(17457, 1358402464, 1358402495, 'GB', 'GBR', 'المملكة المتحدة'),
(17458, 1358402496, 1358402543, 'KE', 'KEN', 'كينيا'),
(17459, 1358402544, 1358403103, 'GB', 'GBR', 'المملكة المتحدة'),
(17460, 1358403104, 1358403135, 'ID', 'IDN', 'إندونيسيا'),
(17461, 1358403136, 1358403151, 'GB', 'GBR', 'المملكة المتحدة'),
(17462, 1358403152, 1358403167, 'ID', 'IDN', 'إندونيسيا'),
(17463, 1358403168, 1358403183, 'GB', 'GBR', 'المملكة المتحدة'),
(17464, 1358403184, 1358403273, 'ID', 'IDN', 'إندونيسيا'),
(17465, 1358403274, 1358403327, 'GB', 'GBR', 'المملكة المتحدة'),
(17466, 1358403328, 1358403583, 'NG', 'NGA', 'نيجيريا'),
(17467, 1358403584, 1358403591, 'PK', 'PAK', 'باكستان'),
(17468, 1358403592, 1358403631, 'GB', 'GBR', 'المملكة المتحدة'),
(17469, 1358403632, 1358403679, 'PK', 'PAK', 'باكستان'),
(17470, 1358403680, 1358403687, 'GB', 'GBR', 'المملكة المتحدة'),
(17471, 1358403688, 1358403711, 'PK', 'PAK', 'باكستان'),
(17472, 1358403712, 1358403839, 'GB', 'GBR', 'المملكة المتحدة'),
(17473, 1358403840, 1358404095, 'NG', 'NGA', 'نيجيريا'),
(17474, 1358404096, 1358404607, 'GB', 'GBR', 'المملكة المتحدة'),
(17475, 1358404608, 1358404611, 'NG', 'NGA', 'نيجيريا'),
(17476, 1358404612, 1358404615, 'TZ', 'TZA', 'تانزانيا'),
(17477, 1358404616, 1358404623, 'NG', 'NGA', 'نيجيريا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(17478, 1358404624, 1358404655, 'TZ', 'TZA', 'تانزانيا'),
(17479, 1358404656, 1358404671, 'NG', 'NGA', 'نيجيريا'),
(17480, 1358404672, 1358404695, 'GB', 'GBR', 'المملكة المتحدة'),
(17481, 1358404696, 1358404703, 'TZ', 'TZA', 'تانزانيا'),
(17482, 1358404704, 1358404735, 'GB', 'GBR', 'المملكة المتحدة'),
(17483, 1358404736, 1358404751, 'NG', 'NGA', 'نيجيريا'),
(17484, 1358404752, 1358404767, 'GB', 'GBR', 'المملكة المتحدة'),
(17485, 1358404768, 1358404783, 'NG', 'NGA', 'نيجيريا'),
(17486, 1358404784, 1358404863, 'GB', 'GBR', 'المملكة المتحدة'),
(17487, 1358404864, 1358405119, 'NG', 'NGA', 'نيجيريا'),
(17488, 1358405120, 1358405375, 'TZ', 'TZA', 'تانزانيا'),
(17489, 1358405376, 1358405631, 'NG', 'NGA', 'نيجيريا'),
(17490, 1358405632, 1358409727, 'NL', 'NLD', 'هولندا'),
(17491, 1358409728, 1358413823, 'RU', 'RUS', 'الإتحاد الروسي'),
(17492, 1358413824, 1358422015, 'NL', 'NLD', 'هولندا'),
(17493, 1358422016, 1358426111, 'FR', 'FRA', 'فرنسا'),
(17494, 1358426112, 1358430207, 'FI', 'FIN', 'فنلندا'),
(17495, 1358434304, 1358438399, 'IS', 'ISL', 'أيسلندا'),
(17496, 1358438400, 1358442495, 'NL', 'NLD', 'هولندا'),
(17497, 1358442496, 1358446591, 'RU', 'RUS', 'الإتحاد الروسي'),
(17498, 1358450688, 1358454783, 'RU', 'RUS', 'الإتحاد الروسي'),
(17499, 1358454784, 1358462975, 'FI', 'FIN', 'فنلندا'),
(17500, 1358462976, 1358467071, 'SE', 'SWE', 'السويد'),
(17501, 1358467072, 1358471167, 'RU', 'RUS', 'الإتحاد الروسي'),
(17502, 1358471168, 1358475263, 'FI', 'FIN', 'فنلندا'),
(17503, 1358475264, 1358479359, 'GB', 'GBR', 'المملكة المتحدة'),
(17504, 1358479360, 1358483455, 'LI', 'LIE', 'ليختنشتاين'),
(17505, 1358483456, 1358487551, 'FR', 'FRA', 'فرنسا'),
(17506, 1358487552, 1358491647, 'SE', 'SWE', 'السويد'),
(17507, 1358491648, 1358495743, 'FI', 'FIN', 'فنلندا'),
(17508, 1358495744, 1358499839, 'PL', 'POL', 'بولندا'),
(17509, 1358499840, 1358503935, 'KZ', 'KAZ', 'كازاخستان'),
(17510, 1358503936, 1358508031, 'IT', 'ITA', 'إيطاليا'),
(17511, 1358508032, 1358512127, 'GB', 'GBR', 'المملكة المتحدة'),
(17512, 1358516224, 1358520319, 'BY', 'BLR', 'روسيا البيضاء'),
(17513, 1358520320, 1358524415, 'GB', 'GBR', 'المملكة المتحدة'),
(17514, 1358524416, 1358528511, 'DE', 'DEU', 'ألمانيا'),
(17515, 1358528512, 1358536703, 'RU', 'RUS', 'الإتحاد الروسي'),
(17516, 1358536704, 1358540799, 'HU', 'HUN', 'هنغاريا'),
(17517, 1358540800, 1358544895, 'RU', 'RUS', 'الإتحاد الروسي'),
(17518, 1358544896, 1358548991, 'LV', 'LVA', 'لاتفيا'),
(17519, 1358548992, 1358553087, 'JO', 'JOR', 'الأردن'),
(17520, 1358553088, 1358557183, 'UA', 'UKR', 'أوكرانيا'),
(17521, 1358557184, 1358559503, 'IE', 'IRL', 'إيرلندا'),
(17522, 1358559504, 1358559519, 'GB', 'GBR', 'المملكة المتحدة'),
(17523, 1358559520, 1358561279, 'IE', 'IRL', 'إيرلندا'),
(17524, 1358561280, 1358569471, 'CZ', 'CZE', 'التشيك'),
(17525, 1358573568, 1358577663, 'LV', 'LVA', 'لاتفيا'),
(17526, 1358577664, 1358585855, 'RU', 'RUS', 'الإتحاد الروسي'),
(17527, 1358585856, 1358589951, 'GB', 'GBR', 'المملكة المتحدة'),
(17528, 1358589952, 1358594047, 'EE', 'EST', 'إستونيا'),
(17529, 1358594048, 1358598143, 'DE', 'DEU', 'ألمانيا'),
(17530, 1358598144, 1358602239, 'IL', 'ISR', 'إسرائيل'),
(17531, 1358602240, 1358622719, 'RU', 'RUS', 'الإتحاد الروسي'),
(17532, 1358622720, 1358626815, 'SK', 'SVK', 'سلوفاكيا'),
(17533, 1358626816, 1358630911, 'GB', 'GBR', 'المملكة المتحدة'),
(17534, 1358630912, 1358634495, 'US', 'USA', 'الولايات المتحدة'),
(17535, 1358634496, 1358635007, 'GB', 'GBR', 'المملكة المتحدة'),
(17536, 1358635008, 1358639103, 'TR', 'TUR', 'تركيا'),
(17537, 1358639104, 1358643199, 'RU', 'RUS', 'الإتحاد الروسي'),
(17538, 1358643200, 1358647295, 'ES', 'ESP', 'إسبانيا'),
(17539, 1358647296, 1358651391, 'DE', 'DEU', 'ألمانيا'),
(17540, 1358651392, 1358655487, 'FR', 'FRA', 'فرنسا'),
(17541, 1358655488, 1358667775, 'RU', 'RUS', 'الإتحاد الروسي'),
(17542, 1358667776, 1358668067, 'PT', 'PRT', 'البورتوغال'),
(17543, 1358668068, 1358668071, 'GB', 'GBR', 'المملكة المتحدة'),
(17544, 1358668072, 1358668231, 'PT', 'PRT', 'البورتوغال'),
(17545, 1358668232, 1358668239, 'GB', 'GBR', 'المملكة المتحدة'),
(17546, 1358668240, 1358668263, 'PT', 'PRT', 'البورتوغال'),
(17547, 1358668264, 1358668279, 'GB', 'GBR', 'المملكة المتحدة'),
(17548, 1358668280, 1358668359, 'PT', 'PRT', 'البورتوغال'),
(17549, 1358668360, 1358668367, 'GB', 'GBR', 'المملكة المتحدة'),
(17550, 1358668368, 1358668463, 'PT', 'PRT', 'البورتوغال'),
(17551, 1358668464, 1358668479, 'ES', 'ESP', 'إسبانيا'),
(17552, 1358668480, 1358668487, 'PT', 'PRT', 'البورتوغال'),
(17553, 1358668488, 1358668495, 'GB', 'GBR', 'المملكة المتحدة'),
(17554, 1358668496, 1358668551, 'PT', 'PRT', 'البورتوغال'),
(17555, 1358668552, 1358668575, 'GB', 'GBR', 'المملكة المتحدة'),
(17556, 1358668576, 1358668799, 'PT', 'PRT', 'البورتوغال'),
(17557, 1358668800, 1358668807, 'GB', 'GBR', 'المملكة المتحدة'),
(17558, 1358668808, 1358668927, 'PT', 'PRT', 'البورتوغال'),
(17559, 1358668928, 1358668959, 'ES', 'ESP', 'إسبانيا'),
(17560, 1358668960, 1358668983, 'PT', 'PRT', 'البورتوغال'),
(17561, 1358668984, 1358668991, 'GB', 'GBR', 'المملكة المتحدة'),
(17562, 1358668992, 1358669351, 'PT', 'PRT', 'البورتوغال'),
(17563, 1358669352, 1358669359, 'GB', 'GBR', 'المملكة المتحدة'),
(17564, 1358669360, 1358669367, 'PT', 'PRT', 'البورتوغال'),
(17565, 1358669368, 1358669375, 'GB', 'GBR', 'المملكة المتحدة'),
(17566, 1358669376, 1358669423, 'PT', 'PRT', 'البورتوغال'),
(17567, 1358669424, 1358669439, 'GB', 'GBR', 'المملكة المتحدة'),
(17568, 1358669440, 1358669455, 'PT', 'PRT', 'البورتوغال'),
(17569, 1358669456, 1358669471, 'GB', 'GBR', 'المملكة المتحدة'),
(17570, 1358669472, 1358669503, 'PT', 'PRT', 'البورتوغال'),
(17571, 1358669504, 1358669519, 'GB', 'GBR', 'المملكة المتحدة'),
(17572, 1358669520, 1358669543, 'PT', 'PRT', 'البورتوغال'),
(17573, 1358669544, 1358669551, 'GB', 'GBR', 'المملكة المتحدة'),
(17574, 1358669552, 1358670015, 'PT', 'PRT', 'البورتوغال'),
(17575, 1358670016, 1358670023, 'GB', 'GBR', 'المملكة المتحدة'),
(17576, 1358670024, 1358670071, 'PT', 'PRT', 'البورتوغال'),
(17577, 1358670072, 1358670079, 'GB', 'GBR', 'المملكة المتحدة'),
(17578, 1358670080, 1358670127, 'PT', 'PRT', 'البورتوغال'),
(17579, 1358670128, 1358670335, 'GB', 'GBR', 'المملكة المتحدة'),
(17580, 1358670336, 1358671415, 'PT', 'PRT', 'البورتوغال'),
(17581, 1358671416, 1358671439, 'GB', 'GBR', 'المملكة المتحدة'),
(17582, 1358671440, 1358671871, 'PT', 'PRT', 'البورتوغال'),
(17583, 1358671872, 1358675967, 'GB', 'GBR', 'المملكة المتحدة'),
(17584, 1358675968, 1358676735, 'SE', 'SWE', 'السويد'),
(17585, 1358676736, 1358677759, 'DK', 'DNK', 'الدنيمارك'),
(17586, 1358677760, 1358679295, 'SE', 'SWE', 'السويد'),
(17587, 1358679296, 1358679807, 'DK', 'DNK', 'الدنيمارك'),
(17588, 1358679808, 1358680063, 'SE', 'SWE', 'السويد'),
(17589, 1358680064, 1358688255, 'RU', 'RUS', 'الإتحاد الروسي'),
(17590, 1358688256, 1358692351, 'CZ', 'CZE', 'التشيك'),
(17591, 1358692352, 1358696447, 'PL', 'POL', 'بولندا'),
(17592, 1358696448, 1358700543, 'RU', 'RUS', 'الإتحاد الروسي'),
(17593, 1358700544, 1358704639, 'AT', 'AUT', 'النمسا'),
(17594, 1358704640, 1358708735, 'HU', 'HUN', 'هنغاريا'),
(17595, 1358708736, 1358712831, 'GB', 'GBR', 'المملكة المتحدة'),
(17596, 1358712832, 1358716927, 'NL', 'NLD', 'هولندا'),
(17597, 1358716928, 1358721023, 'DE', 'DEU', 'ألمانيا'),
(17598, 1358721024, 1358725119, 'GB', 'GBR', 'المملكة المتحدة'),
(17599, 1358725120, 1358733311, 'RU', 'RUS', 'الإتحاد الروسي'),
(17600, 1358733312, 1358733639, 'SE', 'SWE', 'السويد'),
(17601, 1358733640, 1358733643, 'DE', 'DEU', 'ألمانيا'),
(17602, 1358733644, 1358734003, 'SE', 'SWE', 'السويد'),
(17603, 1358734004, 1358734007, 'NO', 'NOR', 'النرويج'),
(17604, 1358734008, 1358734123, 'SE', 'SWE', 'السويد'),
(17605, 1358734124, 1358734127, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(17606, 1358734128, 1358734343, 'SE', 'SWE', 'السويد'),
(17607, 1358734344, 1358734347, 'NL', 'NLD', 'هولندا'),
(17608, 1358734348, 1358734715, 'SE', 'SWE', 'السويد'),
(17609, 1358734716, 1358734719, 'NL', 'NLD', 'هولندا'),
(17610, 1358734720, 1358734975, 'SE', 'SWE', 'السويد'),
(17611, 1358734976, 1358734979, 'NL', 'NLD', 'هولندا'),
(17612, 1358734980, 1358735139, 'SE', 'SWE', 'السويد'),
(17613, 1358735140, 1358735143, 'NL', 'NLD', 'هولندا'),
(17614, 1358735144, 1358735319, 'SE', 'SWE', 'السويد'),
(17615, 1358735320, 1358735327, 'DE', 'DEU', 'ألمانيا'),
(17616, 1358735328, 1358735491, 'SE', 'SWE', 'السويد'),
(17617, 1358735492, 1358735495, 'NL', 'NLD', 'هولندا'),
(17618, 1358735496, 1358735711, 'SE', 'SWE', 'السويد'),
(17619, 1358735712, 1358735715, 'FR', 'FRA', 'فرنسا'),
(17620, 1358735716, 1358735743, 'SE', 'SWE', 'السويد'),
(17621, 1358735744, 1358735751, 'FR', 'FRA', 'فرنسا'),
(17622, 1358735752, 1358736927, 'SE', 'SWE', 'السويد'),
(17623, 1358736928, 1358736943, 'NL', 'NLD', 'هولندا'),
(17624, 1358736944, 1358737383, 'SE', 'SWE', 'السويد'),
(17625, 1358737384, 1358737387, 'NL', 'NLD', 'هولندا'),
(17626, 1358737388, 1358738103, 'SE', 'SWE', 'السويد'),
(17627, 1358738104, 1358738111, 'FR', 'FRA', 'فرنسا'),
(17628, 1358738112, 1358738303, 'SE', 'SWE', 'السويد'),
(17629, 1358738304, 1358738307, 'FR', 'FRA', 'فرنسا'),
(17630, 1358738308, 1358738431, 'SE', 'SWE', 'السويد'),
(17631, 1358738432, 1358738447, 'NL', 'NLD', 'هولندا'),
(17632, 1358738448, 1358738687, 'SE', 'SWE', 'السويد'),
(17633, 1358738688, 1358738691, 'DE', 'DEU', 'ألمانيا'),
(17634, 1358738692, 1358739135, 'SE', 'SWE', 'السويد'),
(17635, 1358739136, 1358739151, 'NL', 'NLD', 'هولندا'),
(17636, 1358739152, 1358739503, 'SE', 'SWE', 'السويد'),
(17637, 1358739504, 1358739519, 'FR', 'FRA', 'فرنسا'),
(17638, 1358739520, 1358740159, 'SE', 'SWE', 'السويد'),
(17639, 1358740160, 1358740175, 'FR', 'FRA', 'فرنسا'),
(17640, 1358740176, 1358740335, 'SE', 'SWE', 'السويد'),
(17641, 1358740336, 1358740351, 'GB', 'GBR', 'المملكة المتحدة'),
(17642, 1358740352, 1358740671, 'SE', 'SWE', 'السويد'),
(17643, 1358740672, 1358740687, 'GB', 'GBR', 'المملكة المتحدة'),
(17644, 1358740688, 1358740883, 'SE', 'SWE', 'السويد'),
(17645, 1358740884, 1358740887, 'NL', 'NLD', 'هولندا'),
(17646, 1358740888, 1358741055, 'SE', 'SWE', 'السويد'),
(17647, 1358741056, 1358741071, 'GB', 'GBR', 'المملكة المتحدة'),
(17648, 1358741072, 1358741503, 'SE', 'SWE', 'السويد'),
(17649, 1358741504, 1358745599, 'IT', 'ITA', 'إيطاليا'),
(17650, 1358745600, 1358749695, 'SE', 'SWE', 'السويد'),
(17651, 1358749696, 1358753791, 'IT', 'ITA', 'إيطاليا'),
(17652, 1358753792, 1358757887, 'UA', 'UKR', 'أوكرانيا'),
(17653, 1358757888, 1358766079, 'RU', 'RUS', 'الإتحاد الروسي'),
(17654, 1358766080, 1358770175, 'IT', 'ITA', 'إيطاليا'),
(17655, 1358770176, 1358774271, 'BG', 'BGR', 'بلغاريا'),
(17656, 1358774272, 1358778367, 'ES', 'ESP', 'إسبانيا'),
(17657, 1358778368, 1358782463, 'CH', 'CHE', 'سويسرا'),
(17658, 1358782464, 1358784015, 'GB', 'GBR', 'المملكة المتحدة'),
(17659, 1358784016, 1358784039, 'NL', 'NLD', 'هولندا'),
(17660, 1358784040, 1358784063, 'DE', 'DEU', 'ألمانيا'),
(17661, 1358784064, 1358784831, 'GB', 'GBR', 'المملكة المتحدة'),
(17662, 1358784832, 1358784863, 'NL', 'NLD', 'هولندا'),
(17663, 1358784864, 1358784895, 'DE', 'DEU', 'ألمانيا'),
(17664, 1358784896, 1358785087, 'GB', 'GBR', 'المملكة المتحدة'),
(17665, 1358785088, 1358785151, 'NL', 'NLD', 'هولندا'),
(17666, 1358785152, 1358786559, 'GB', 'GBR', 'المملكة المتحدة'),
(17667, 1358786560, 1358787071, 'NL', 'NLD', 'هولندا'),
(17668, 1358787072, 1358789167, 'GB', 'GBR', 'المملكة المتحدة'),
(17669, 1358789168, 1358789183, 'IE', 'IRL', 'إيرلندا'),
(17670, 1358789184, 1358790655, 'GB', 'GBR', 'المملكة المتحدة'),
(17671, 1358790656, 1358798847, 'IR', 'IRN', 'إيران'),
(17672, 1358798848, 1358799359, 'DE', 'DEU', 'ألمانيا'),
(17673, 1358799360, 1358802943, 'HR', 'HRV', 'كرواتيا'),
(17674, 1358802944, 1358807039, 'HU', 'HUN', 'هنغاريا'),
(17675, 1358807040, 1358811135, 'RU', 'RUS', 'الإتحاد الروسي'),
(17676, 1358811136, 1358815231, 'DE', 'DEU', 'ألمانيا'),
(17677, 1358815232, 1358819327, 'RU', 'RUS', 'الإتحاد الروسي'),
(17678, 1358819328, 1358823423, 'TR', 'TUR', 'تركيا'),
(17679, 1358823424, 1358827519, 'UA', 'UKR', 'أوكرانيا'),
(17680, 1358827520, 1358831615, 'RU', 'RUS', 'الإتحاد الروسي'),
(17681, 1358831616, 1358835711, 'NO', 'NOR', 'النرويج'),
(17682, 1358835712, 1358839807, 'RU', 'RUS', 'الإتحاد الروسي'),
(17683, 1358839808, 1358843903, 'CH', 'CHE', 'سويسرا'),
(17684, 1358843904, 1358847999, 'MT', 'MLT', 'مالطا'),
(17685, 1358848000, 1358856191, 'RU', 'RUS', 'الإتحاد الروسي'),
(17686, 1358856192, 1358860287, 'DE', 'DEU', 'ألمانيا'),
(17687, 1358860288, 1358861311, 'GB', 'GBR', 'المملكة المتحدة'),
(17688, 1358861312, 1358861823, 'DE', 'DEU', 'ألمانيا'),
(17689, 1358861824, 1358862335, 'FR', 'FRA', 'فرنسا'),
(17690, 1358862336, 1358862591, 'US', 'USA', 'الولايات المتحدة'),
(17691, 1358862592, 1358862847, 'GB', 'GBR', 'المملكة المتحدة'),
(17692, 1358862848, 1358863103, 'DK', 'DNK', 'الدنيمارك'),
(17693, 1358863104, 1358863359, 'GB', 'GBR', 'المملكة المتحدة'),
(17694, 1358863360, 1358863615, 'US', 'USA', 'الولايات المتحدة'),
(17695, 1358863616, 1358864383, 'GB', 'GBR', 'المملكة المتحدة'),
(17696, 1358864384, 1358864399, 'CH', 'CHE', 'سويسرا'),
(17697, 1358864400, 1358864407, 'IN', 'IND', 'الهند'),
(17698, 1358864408, 1358864535, 'CH', 'CHE', 'سويسرا'),
(17699, 1358864536, 1358864543, 'LI', 'LIE', 'ليختنشتاين'),
(17700, 1358864544, 1358872575, 'CH', 'CHE', 'سويسرا'),
(17701, 1358872576, 1358876671, 'IT', 'ITA', 'إيطاليا'),
(17702, 1358876672, 1358880767, 'LV', 'LVA', 'لاتفيا'),
(17703, 1358880768, 1358884863, 'GB', 'GBR', 'المملكة المتحدة'),
(17704, 1358884864, 1358888959, 'SE', 'SWE', 'السويد'),
(17705, 1358888960, 1358890943, 'DE', 'DEU', 'ألمانيا'),
(17706, 1358890944, 1358891007, 'AT', 'AUT', 'النمسا'),
(17707, 1358891008, 1358893055, 'DE', 'DEU', 'ألمانيا'),
(17708, 1358893056, 1358897151, 'RU', 'RUS', 'الإتحاد الروسي'),
(17709, 1358897152, 1358897183, 'US', 'USA', 'الولايات المتحدة'),
(17710, 1358897184, 1358897199, 'DE', 'DEU', 'ألمانيا'),
(17711, 1358897200, 1358897215, 'GB', 'GBR', 'المملكة المتحدة'),
(17712, 1358897216, 1358897343, 'US', 'USA', 'الولايات المتحدة'),
(17713, 1358897344, 1358897407, 'DE', 'DEU', 'ألمانيا'),
(17714, 1358897408, 1358897919, 'US', 'USA', 'الولايات المتحدة'),
(17715, 1358897920, 1358898175, 'GB', 'GBR', 'المملكة المتحدة'),
(17716, 1358898176, 1358898239, 'CA', 'CAN', 'كندا'),
(17717, 1358898240, 1358898335, 'US', 'USA', 'الولايات المتحدة'),
(17718, 1358898336, 1358898351, 'DK', 'DNK', 'الدنيمارك'),
(17719, 1358898352, 1358898687, 'US', 'USA', 'الولايات المتحدة'),
(17720, 1358898688, 1358898816, 'DE', 'DEU', 'ألمانيا'),
(17721, 1358898817, 1358898943, 'CG', 'COG', 'الكونغو'),
(17722, 1358898944, 1358898975, 'DE', 'DEU', 'ألمانيا'),
(17723, 1358898976, 1358898991, 'US', 'USA', 'الولايات المتحدة'),
(17724, 1358898992, 1358899079, 'DE', 'DEU', 'ألمانيا'),
(17725, 1358899080, 1358899087, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17726, 1358899088, 1358899095, 'DE', 'DEU', 'ألمانيا'),
(17727, 1358899096, 1358899103, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17728, 1358899104, 1358899111, 'DE', 'DEU', 'ألمانيا'),
(17729, 1358899112, 1358899119, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(17730, 1358899120, 1358899127, 'DE', 'DEU', 'ألمانيا'),
(17731, 1358899128, 1358899135, 'NG', 'NGA', 'نيجيريا'),
(17732, 1358899136, 1358899199, 'DE', 'DEU', 'ألمانيا'),
(17733, 1358899200, 1358899207, 'UG', 'UGA', 'أوغاندا'),
(17734, 1358899208, 1358899215, 'LA', 'LAO', 'لاو'),
(17735, 1358899216, 1358899239, 'US', 'USA', 'الولايات المتحدة'),
(17736, 1358899240, 1358899247, 'LK', 'LKA', 'سيريلانكا'),
(17737, 1358899248, 1358899263, 'GB', 'GBR', 'المملكة المتحدة'),
(17738, 1358899264, 1358899295, 'PK', 'PAK', 'باكستان'),
(17739, 1358899296, 1358899303, 'NG', 'NGA', 'نيجيريا'),
(17740, 1358899304, 1358899311, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(17741, 1358899312, 1358899327, 'NG', 'NGA', 'نيجيريا'),
(17742, 1358899328, 1358899335, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17743, 1358899336, 1358899343, 'NG', 'NGA', 'نيجيريا'),
(17744, 1358899344, 1358899359, 'MR', 'MRT', 'موريتانيا'),
(17745, 1358899360, 1358899375, 'US', 'USA', 'الولايات المتحدة'),
(17746, 1358899376, 1358899383, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17747, 1358899384, 1358899391, 'UG', 'UGA', 'أوغاندا'),
(17748, 1358899392, 1358899407, 'GB', 'GBR', 'المملكة المتحدة'),
(17749, 1358899408, 1358899415, 'DE', 'DEU', 'ألمانيا'),
(17750, 1358899416, 1358899423, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17751, 1358899424, 1358899431, 'US', 'USA', 'الولايات المتحدة'),
(17752, 1358899432, 1358899455, 'NG', 'NGA', 'نيجيريا'),
(17753, 1358899456, 1358899463, 'GB', 'GBR', 'المملكة المتحدة'),
(17754, 1358899464, 1358899471, 'US', 'USA', 'الولايات المتحدة'),
(17755, 1358899472, 1358899479, 'SV', 'SLV', 'السلفادور'),
(17756, 1358899480, 1358899583, 'GB', 'GBR', 'المملكة المتحدة'),
(17757, 1358899584, 1358899591, 'IN', 'IND', 'الهند'),
(17758, 1358899592, 1358899599, 'NG', 'NGA', 'نيجيريا'),
(17759, 1358899600, 1358899607, 'LK', 'LKA', 'سيريلانكا'),
(17760, 1358899608, 1358899615, 'GB', 'GBR', 'المملكة المتحدة'),
(17761, 1358899616, 1358899631, 'NG', 'NGA', 'نيجيريا'),
(17762, 1358899632, 1358899647, 'NP', 'NPL', 'نيبال'),
(17763, 1358899648, 1358899654, 'NG', 'NGA', 'نيجيريا'),
(17764, 1358899655, 1358899711, 'DE', 'DEU', 'ألمانيا'),
(17765, 1358899712, 1358899967, 'US', 'USA', 'الولايات المتحدة'),
(17766, 1358899968, 1358899983, 'GB', 'GBR', 'المملكة المتحدة'),
(17767, 1358899984, 1358899991, 'KY', 'CYM', 'جزر كايمان'),
(17768, 1358899992, 1358900223, 'GB', 'GBR', 'المملكة المتحدة'),
(17769, 1358900224, 1358900479, 'US', 'USA', 'الولايات المتحدة'),
(17770, 1358900480, 1358900543, 'DE', 'DEU', 'ألمانيا'),
(17771, 1358900544, 1358900671, 'US', 'USA', 'الولايات المتحدة'),
(17772, 1358900672, 1358900735, 'CN', 'CHN', 'الصين'),
(17773, 1358900736, 1358900767, 'GB', 'GBR', 'المملكة المتحدة'),
(17774, 1358900768, 1358900783, 'BI', 'BDI', 'بوروندي'),
(17775, 1358900784, 1358900959, 'GB', 'GBR', 'المملكة المتحدة'),
(17776, 1358900960, 1358900975, 'SL', 'SLE', 'سيراليون'),
(17777, 1358900976, 1358901247, 'GB', 'GBR', 'المملكة المتحدة'),
(17778, 1358901248, 1358901503, 'DE', 'DEU', 'ألمانيا'),
(17779, 1358901504, 1358901543, 'US', 'USA', 'الولايات المتحدة'),
(17780, 1358901544, 1358901551, 'DE', 'DEU', 'ألمانيا'),
(17781, 1358901552, 1358901615, 'US', 'USA', 'الولايات المتحدة'),
(17782, 1358901616, 1358901729, 'DE', 'DEU', 'ألمانيا'),
(17783, 1358901730, 1358901759, 'US', 'USA', 'الولايات المتحدة'),
(17784, 1358901760, 1358901807, 'DE', 'DEU', 'ألمانيا'),
(17785, 1358901808, 1358901815, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17786, 1358901816, 1358901935, 'DE', 'DEU', 'ألمانيا'),
(17787, 1358901936, 1358901951, 'NG', 'NGA', 'نيجيريا'),
(17788, 1358901952, 1358901999, 'DE', 'DEU', 'ألمانيا'),
(17789, 1358902000, 1358902039, 'NG', 'NGA', 'نيجيريا'),
(17790, 1358902040, 1358902063, 'GB', 'GBR', 'المملكة المتحدة'),
(17791, 1358902064, 1358902079, 'TZ', 'TZA', 'تانزانيا'),
(17792, 1358902080, 1358902087, 'NG', 'NGA', 'نيجيريا'),
(17793, 1358902088, 1358902103, 'MG', 'MDG', 'مدغشقر'),
(17794, 1358902104, 1358902143, 'NG', 'NGA', 'نيجيريا'),
(17795, 1358902144, 1358902151, 'GB', 'GBR', 'المملكة المتحدة'),
(17796, 1358902152, 1358902167, 'NG', 'NGA', 'نيجيريا'),
(17797, 1358902168, 1358902175, 'AU', 'AUS', 'أستراليا'),
(17798, 1358902176, 1358902207, 'GB', 'GBR', 'المملكة المتحدة'),
(17799, 1358902208, 1358902215, 'US', 'USA', 'الولايات المتحدة'),
(17800, 1358902216, 1358902233, 'NG', 'NGA', 'نيجيريا'),
(17801, 1358902234, 1358902263, 'GB', 'GBR', 'المملكة المتحدة'),
(17802, 1358902264, 1358902271, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(17803, 1358902272, 1358903807, 'US', 'USA', 'الولايات المتحدة'),
(17804, 1358903808, 1358903951, 'NG', 'NGA', 'نيجيريا'),
(17805, 1358903952, 1358903967, 'GB', 'GBR', 'المملكة المتحدة'),
(17806, 1358903968, 1358903983, 'CA', 'CAN', 'كندا'),
(17807, 1358903984, 1358903999, 'NG', 'NGA', 'نيجيريا'),
(17808, 1358904000, 1358904032, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(17809, 1358904033, 1358904063, 'NG', 'NGA', 'نيجيريا'),
(17810, 1358904064, 1358904071, 'DE', 'DEU', 'ألمانيا'),
(17811, 1358904072, 1358904095, 'US', 'USA', 'الولايات المتحدة'),
(17812, 1358904096, 1358904103, 'DE', 'DEU', 'ألمانيا'),
(17813, 1358904104, 1358904119, 'US', 'USA', 'الولايات المتحدة'),
(17814, 1358904120, 1358904127, 'DE', 'DEU', 'ألمانيا'),
(17815, 1358904128, 1358904135, 'US', 'USA', 'الولايات المتحدة'),
(17816, 1358904136, 1358904143, 'DE', 'DEU', 'ألمانيا'),
(17817, 1358904144, 1358904151, 'NG', 'NGA', 'نيجيريا'),
(17818, 1358904152, 1358904167, 'DE', 'DEU', 'ألمانيا'),
(17819, 1358904168, 1358904175, 'US', 'USA', 'الولايات المتحدة'),
(17820, 1358904176, 1358904191, 'DE', 'DEU', 'ألمانيا'),
(17821, 1358904192, 1358904199, 'NG', 'NGA', 'نيجيريا'),
(17822, 1358904200, 1358904262, 'US', 'USA', 'الولايات المتحدة'),
(17823, 1358904263, 1358904295, 'DE', 'DEU', 'ألمانيا'),
(17824, 1358904296, 1358904311, 'NG', 'NGA', 'نيجيريا'),
(17825, 1358904312, 1358904319, 'DE', 'DEU', 'ألمانيا'),
(17826, 1358904320, 1358904551, 'US', 'USA', 'الولايات المتحدة'),
(17827, 1358904552, 1358904559, 'IL', 'ISR', 'إسرائيل'),
(17828, 1358904560, 1358904575, 'US', 'USA', 'الولايات المتحدة'),
(17829, 1358904576, 1358904701, 'NG', 'NGA', 'نيجيريا'),
(17830, 1358904702, 1358904703, 'GB', 'GBR', 'المملكة المتحدة'),
(17831, 1358904704, 1358904719, 'MU', 'MUS', 'موريشيوس'),
(17832, 1358904720, 1358904735, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(17833, 1358904736, 1358904767, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(17834, 1358904768, 1358904831, 'NG', 'NGA', 'نيجيريا'),
(17835, 1358904832, 1358905087, 'US', 'USA', 'الولايات المتحدة'),
(17836, 1358905088, 1358905095, 'GB', 'GBR', 'المملكة المتحدة'),
(17837, 1358905096, 1358905103, 'GH', 'GHA', 'غانا'),
(17838, 1358905104, 1358905111, 'GB', 'GBR', 'المملكة المتحدة'),
(17839, 1358905112, 1358905119, 'TZ', 'TZA', 'تانزانيا'),
(17840, 1358905120, 1358905127, 'GY', 'GUY', 'غيانا'),
(17841, 1358905128, 1358905151, 'GB', 'GBR', 'المملكة المتحدة'),
(17842, 1358905152, 1358905159, 'MG', 'MDG', 'مدغشقر'),
(17843, 1358905160, 1358905167, 'GB', 'GBR', 'المملكة المتحدة'),
(17844, 1358905168, 1358905183, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(17845, 1358905184, 1358905215, 'GH', 'GHA', 'غانا'),
(17846, 1358905216, 1358905223, 'US', 'USA', 'الولايات المتحدة'),
(17847, 1358905224, 1358905231, 'GB', 'GBR', 'المملكة المتحدة'),
(17848, 1358905232, 1358905247, 'GN', 'GIN', 'غينيا'),
(17849, 1358905248, 1358905279, 'US', 'USA', 'الولايات المتحدة'),
(17850, 1358905280, 1358905295, 'GB', 'GBR', 'المملكة المتحدة'),
(17851, 1358905296, 1358905311, 'LR', 'LBR', 'ليبيريا'),
(17852, 1358905312, 1358905327, 'US', 'USA', 'الولايات المتحدة'),
(17853, 1358905328, 1358905343, 'GB', 'GBR', 'المملكة المتحدة'),
(17854, 1358905344, 1358909439, 'UA', 'UKR', 'أوكرانيا'),
(17855, 1358909440, 1358913535, 'RU', 'RUS', 'الإتحاد الروسي'),
(17856, 1358913536, 1358917631, 'CH', 'CHE', 'سويسرا'),
(17857, 1358917632, 1358921727, 'ES', 'ESP', 'إسبانيا'),
(17858, 1358921728, 1358929919, 'RU', 'RUS', 'الإتحاد الروسي'),
(17859, 1358929920, 1358934015, 'LU', 'LUX', 'لوكسيمبورغ'),
(17860, 1358934016, 1358938111, 'RU', 'RUS', 'الإتحاد الروسي'),
(17861, 1358938112, 1358946303, 'GB', 'GBR', 'المملكة المتحدة'),
(17862, 1358946304, 1358950399, 'LV', 'LVA', 'لاتفيا'),
(17863, 1358950400, 1358954495, 'NL', 'NLD', 'هولندا'),
(17864, 1358954496, 1358970879, 'ES', 'ESP', 'إسبانيا'),
(17865, 1358970880, 1358984191, 'HU', 'HUN', 'هنغاريا'),
(17866, 1358984192, 1358984703, 'SK', 'SVK', 'سلوفاكيا'),
(17867, 1358984704, 1358986239, 'HU', 'HUN', 'هنغاريا'),
(17868, 1358986240, 1358986495, 'SK', 'SVK', 'سلوفاكيا'),
(17869, 1358986496, 1358987263, 'HU', 'HUN', 'هنغاريا'),
(17870, 1358987264, 1359003647, 'NO', 'NOR', 'النرويج'),
(17871, 1359003648, 1359020031, 'CZ', 'CZE', 'التشيك'),
(17872, 1359020032, 1359036415, 'FR', 'FRA', 'فرنسا'),
(17873, 1359036416, 1359052799, 'GB', 'GBR', 'المملكة المتحدة'),
(17874, 1359052800, 1359069183, 'SE', 'SWE', 'السويد'),
(17875, 1359069184, 1359101951, 'RU', 'RUS', 'الإتحاد الروسي'),
(17876, 1359101952, 1359118335, 'GB', 'GBR', 'المملكة المتحدة'),
(17877, 1359118336, 1359118655, 'DE', 'DEU', 'ألمانيا'),
(17878, 1359118656, 1359118719, 'NL', 'NLD', 'هولندا'),
(17879, 1359118720, 1359118815, 'DE', 'DEU', 'ألمانيا'),
(17880, 1359118816, 1359118831, 'NL', 'NLD', 'هولندا'),
(17881, 1359118832, 1359120383, 'DE', 'DEU', 'ألمانيا'),
(17882, 1359120384, 1359121407, 'DK', 'DNK', 'الدنيمارك'),
(17883, 1359121408, 1359123583, 'DE', 'DEU', 'ألمانيا'),
(17884, 1359123584, 1359123711, 'SE', 'SWE', 'السويد'),
(17885, 1359123712, 1359134719, 'DE', 'DEU', 'ألمانيا'),
(17886, 1359134720, 1359150079, 'CZ', 'CZE', 'التشيك'),
(17887, 1359150080, 1359150591, 'HU', 'HUN', 'هنغاريا'),
(17888, 1359150592, 1359151103, 'CZ', 'CZE', 'التشيك'),
(17889, 1359151104, 1359158207, 'DE', 'DEU', 'ألمانيا'),
(17890, 1359158208, 1359158215, 'CH', 'CHE', 'سويسرا'),
(17891, 1359158216, 1359166175, 'DE', 'DEU', 'ألمانيا'),
(17892, 1359166176, 1359166191, 'HK', 'HKG', 'هونغ كونغ'),
(17893, 1359166192, 1359167487, 'DE', 'DEU', 'ألمانيا'),
(17894, 1359167488, 1359183871, 'GB', 'GBR', 'المملكة المتحدة'),
(17895, 1359183872, 1359200255, 'RU', 'RUS', 'الإتحاد الروسي'),
(17896, 1359200256, 1359216639, 'AT', 'AUT', 'النمسا'),
(17897, 1359233024, 1359249407, 'NL', 'NLD', 'هولندا'),
(17898, 1359249408, 1359263743, 'CY', 'CYP', 'قبرص'),
(17899, 1359263744, 1359263999, 'LB', 'LBN', 'لبنان'),
(17900, 1359264000, 1359265791, 'CY', 'CYP', 'قبرص'),
(17901, 1359265792, 1359282175, 'RU', 'RUS', 'الإتحاد الروسي'),
(17902, 1359282176, 1359298559, 'IL', 'ISR', 'إسرائيل'),
(17903, 1359298560, 1359314943, 'RU', 'RUS', 'الإتحاد الروسي'),
(17904, 1359314944, 1359331327, 'GB', 'GBR', 'المملكة المتحدة'),
(17905, 1359331328, 1359347711, 'AT', 'AUT', 'النمسا'),
(17906, 1359347712, 1359349351, 'CH', 'CHE', 'سويسرا'),
(17907, 1359349352, 1359349359, 'LB', 'LBN', 'لبنان'),
(17908, 1359349360, 1359364095, 'CH', 'CHE', 'سويسرا'),
(17909, 1359364096, 1359380479, 'TR', 'TUR', 'تركيا'),
(17910, 1359380480, 1359396863, 'PL', 'POL', 'بولندا'),
(17911, 1359396864, 1359413247, 'GB', 'GBR', 'المملكة المتحدة'),
(17912, 1359413248, 1359413503, 'DE', 'DEU', 'ألمانيا'),
(17913, 1359413504, 1359413759, 'FR', 'FRA', 'فرنسا'),
(17914, 1359413760, 1359429631, 'DE', 'DEU', 'ألمانيا'),
(17915, 1359429632, 1359446015, 'LT', 'LTU', 'ليتوانيا'),
(17916, 1359446016, 1359451727, 'DK', 'DNK', 'الدنيمارك'),
(17917, 1359451728, 1359451731, 'US', 'USA', 'الولايات المتحدة'),
(17918, 1359451732, 1359462399, 'DK', 'DNK', 'الدنيمارك'),
(17919, 1359462400, 1359467007, 'DE', 'DEU', 'ألمانيا'),
(17920, 1359467008, 1359467015, 'US', 'USA', 'الولايات المتحدة'),
(17921, 1359467016, 1359467063, 'DE', 'DEU', 'ألمانيا'),
(17922, 1359467064, 1359467079, 'US', 'USA', 'الولايات المتحدة'),
(17923, 1359467080, 1359467087, 'DE', 'DEU', 'ألمانيا'),
(17924, 1359467088, 1359467095, 'US', 'USA', 'الولايات المتحدة'),
(17925, 1359467096, 1359467103, 'BR', 'BRA', 'البرازيل'),
(17926, 1359467104, 1359467135, 'US', 'USA', 'الولايات المتحدة'),
(17927, 1359467136, 1359467143, 'MX', 'MEX', 'المكسيك'),
(17928, 1359467144, 1359467215, 'US', 'USA', 'الولايات المتحدة'),
(17929, 1359467216, 1359467239, 'DE', 'DEU', 'ألمانيا'),
(17930, 1359467240, 1359467255, 'US', 'USA', 'الولايات المتحدة'),
(17931, 1359467256, 1359467263, 'MX', 'MEX', 'المكسيك'),
(17932, 1359467264, 1359467455, 'US', 'USA', 'الولايات المتحدة'),
(17933, 1359467456, 1359467487, 'CA', 'CAN', 'كندا'),
(17934, 1359467488, 1359467495, 'DE', 'DEU', 'ألمانيا'),
(17935, 1359467496, 1359467647, 'US', 'USA', 'الولايات المتحدة'),
(17936, 1359467648, 1359467775, 'DE', 'DEU', 'ألمانيا'),
(17937, 1359467776, 1359467807, 'US', 'USA', 'الولايات المتحدة'),
(17938, 1359467808, 1359467903, 'DE', 'DEU', 'ألمانيا'),
(17939, 1359467904, 1359468031, 'US', 'USA', 'الولايات المتحدة'),
(17940, 1359468032, 1359468639, 'DE', 'DEU', 'ألمانيا'),
(17941, 1359468640, 1359468655, 'SG', 'SGP', 'سنغافورة'),
(17942, 1359468656, 1359468671, 'JP', 'JPN', 'اليابان'),
(17943, 1359468672, 1359468695, 'SG', 'SGP', 'سنغافورة'),
(17944, 1359468696, 1359468711, 'DE', 'DEU', 'ألمانيا'),
(17945, 1359468712, 1359468735, 'SG', 'SGP', 'سنغافورة'),
(17946, 1359468736, 1359468863, 'DE', 'DEU', 'ألمانيا'),
(17947, 1359468864, 1359468879, 'SG', 'SGP', 'سنغافورة'),
(17948, 1359468880, 1359468927, 'DE', 'DEU', 'ألمانيا'),
(17949, 1359468928, 1359469055, 'SG', 'SGP', 'سنغافورة'),
(17950, 1359469056, 1359469311, 'DE', 'DEU', 'ألمانيا'),
(17951, 1359469312, 1359469567, 'SG', 'SGP', 'سنغافورة'),
(17952, 1359469568, 1359469943, 'DE', 'DEU', 'ألمانيا'),
(17953, 1359469944, 1359469983, 'AT', 'AUT', 'النمسا'),
(17954, 1359469984, 1359470591, 'DE', 'DEU', 'ألمانيا'),
(17955, 1359470592, 1359478783, 'CH', 'CHE', 'سويسرا'),
(17956, 1359478784, 1359511551, 'TR', 'TUR', 'تركيا'),
(17957, 1359511552, 1359544319, 'SE', 'SWE', 'السويد'),
(17958, 1359544320, 1359547391, 'RU', 'RUS', 'الإتحاد الروسي'),
(17959, 1359547392, 1359547903, 'US', 'USA', 'الولايات المتحدة'),
(17960, 1359547904, 1359548159, 'RU', 'RUS', 'الإتحاد الروسي'),
(17961, 1359548160, 1359548415, 'US', 'USA', 'الولايات المتحدة'),
(17962, 1359548416, 1359552511, 'RU', 'RUS', 'الإتحاد الروسي'),
(17963, 1359552512, 1359552767, 'US', 'USA', 'الولايات المتحدة'),
(17964, 1359552768, 1359553599, 'RU', 'RUS', 'الإتحاد الروسي'),
(17965, 1359553600, 1359553631, 'US', 'USA', 'الولايات المتحدة'),
(17966, 1359553632, 1359577087, 'RU', 'RUS', 'الإتحاد الروسي'),
(17967, 1359577088, 1359609855, 'ES', 'ESP', 'إسبانيا'),
(17968, 1359642624, 1359675391, 'AT', 'AUT', 'النمسا'),
(17969, 1359675392, 1359708159, 'DE', 'DEU', 'ألمانيا'),
(17970, 1359708160, 1359740927, 'BE', 'BEL', 'بلجيكا'),
(17971, 1359740928, 1359773695, 'IR', 'IRN', 'إيران'),
(17972, 1359773696, 1359806463, 'RO', 'ROM', 'رومانيا'),
(17973, 1359806464, 1359839231, 'RU', 'RUS', 'الإتحاد الروسي'),
(17974, 1359839232, 1359871999, 'CH', 'CHE', 'سويسرا'),
(17975, 1359904768, 1359937535, 'DE', 'DEU', 'ألمانيا'),
(17976, 1359937536, 1359970303, 'IS', 'ISL', 'أيسلندا'),
(17977, 1359970304, 1360003071, 'PL', 'POL', 'بولندا'),
(17978, 1360003072, 1360007167, 'AM', 'ARM', 'أرمينيا'),
(17979, 1360007168, 1360011263, 'GB', 'GBR', 'المملكة المتحدة'),
(17980, 1360011264, 1360015359, 'AT', 'AUT', 'النمسا'),
(17981, 1360015360, 1360019455, 'DE', 'DEU', 'ألمانيا'),
(17982, 1360019456, 1360023551, 'FI', 'FIN', 'فنلندا'),
(17983, 1360023552, 1360027647, 'RU', 'RUS', 'الإتحاد الروسي'),
(17984, 1360027648, 1360031743, 'AT', 'AUT', 'النمسا'),
(17985, 1360031744, 1360039935, 'RU', 'RUS', 'الإتحاد الروسي'),
(17986, 1360039936, 1360041439, 'AT', 'AUT', 'النمسا'),
(17987, 1360041440, 1360041447, 'CZ', 'CZE', 'التشيك'),
(17988, 1360041448, 1360043671, 'AT', 'AUT', 'النمسا'),
(17989, 1360043672, 1360043679, 'CZ', 'CZE', 'التشيك'),
(17990, 1360043680, 1360044031, 'AT', 'AUT', 'النمسا'),
(17991, 1360044032, 1360048127, 'SE', 'SWE', 'السويد'),
(17992, 1360048128, 1360049167, 'DE', 'DEU', 'ألمانيا'),
(17993, 1360049168, 1360049183, 'GB', 'GBR', 'المملكة المتحدة'),
(17994, 1360049184, 1360049199, 'DE', 'DEU', 'ألمانيا'),
(17995, 1360049200, 1360049207, 'SE', 'SWE', 'السويد'),
(17996, 1360049208, 1360049215, 'IT', 'ITA', 'إيطاليا'),
(17997, 1360049216, 1360049223, 'ES', 'ESP', 'إسبانيا'),
(17998, 1360049224, 1360049231, 'JP', 'JPN', 'اليابان'),
(17999, 1360049232, 1360049239, 'US', 'USA', 'الولايات المتحدة'),
(18000, 1360049240, 1360049247, 'GB', 'GBR', 'المملكة المتحدة'),
(18001, 1360049248, 1360050959, 'DE', 'DEU', 'ألمانيا'),
(18002, 1360050960, 1360050975, 'US', 'USA', 'الولايات المتحدة'),
(18003, 1360050976, 1360052223, 'DE', 'DEU', 'ألمانيا'),
(18004, 1360052224, 1360056319, 'HU', 'HUN', 'هنغاريا'),
(18005, 1360056320, 1360060415, 'SA', 'SAU', 'السعودية'),
(18006, 1360060416, 1360064511, 'LT', 'LTU', 'ليتوانيا'),
(18007, 1360064512, 1360068607, 'GE', 'GEO', 'جورجيا'),
(18008, 1360068608, 1360076799, 'RU', 'RUS', 'الإتحاد الروسي'),
(18009, 1360076800, 1360084991, 'NL', 'NLD', 'هولندا'),
(18010, 1360084992, 1360089087, 'GB', 'GBR', 'المملكة المتحدة'),
(18011, 1360089088, 1360093183, 'AZ', 'AZE', 'أذربيجان'),
(18012, 1360093184, 1360101375, 'DE', 'DEU', 'ألمانيا'),
(18013, 1360101376, 1360105471, 'UA', 'UKR', 'أوكرانيا'),
(18014, 1360105472, 1360109567, 'RU', 'RUS', 'الإتحاد الروسي'),
(18015, 1360109568, 1360113663, 'KZ', 'KAZ', 'كازاخستان'),
(18016, 1360113664, 1360117759, 'HU', 'HUN', 'هنغاريا'),
(18017, 1360117760, 1360121855, 'FI', 'FIN', 'فنلندا'),
(18018, 1360121856, 1360125951, 'DE', 'DEU', 'ألمانيا'),
(18019, 1360125952, 1360126975, 'SI', 'SVN', 'سلوفينيا'),
(18020, 1360126976, 1360127487, 'HR', 'HRV', 'كرواتيا'),
(18021, 1360127488, 1360127999, 'RS', 'SRB', 'صربيا'),
(18022, 1360128000, 1360128511, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(18023, 1360128512, 1360129023, 'SI', 'SVN', 'سلوفينيا'),
(18024, 1360129024, 1360130047, 'BA', 'BIH', 'البوسنه والهرسك'),
(18025, 1360130048, 1360130575, 'IE', 'IRL', 'إيرلندا'),
(18026, 1360130576, 1360130583, 'GB', 'GBR', 'المملكة المتحدة'),
(18027, 1360130584, 1360130815, 'IE', 'IRL', 'إيرلندا'),
(18028, 1360130816, 1360130879, 'GB', 'GBR', 'المملكة المتحدة'),
(18029, 1360130880, 1360131520, 'IE', 'IRL', 'إيرلندا'),
(18030, 1360131521, 1360131583, 'GB', 'GBR', 'المملكة المتحدة'),
(18031, 1360131584, 1360131903, 'IE', 'IRL', 'إيرلندا'),
(18032, 1360131904, 1360131919, 'US', 'USA', 'الولايات المتحدة'),
(18033, 1360131920, 1360131935, 'AU', 'AUS', 'أستراليا'),
(18034, 1360131936, 1360131951, 'GB', 'GBR', 'المملكة المتحدة'),
(18035, 1360131952, 1360134143, 'IE', 'IRL', 'إيرلندا'),
(18036, 1360134144, 1360138239, 'NL', 'NLD', 'هولندا'),
(18037, 1360138240, 1360142335, 'CH', 'CHE', 'سويسرا'),
(18038, 1360142336, 1360146431, 'KZ', 'KAZ', 'كازاخستان'),
(18039, 1360146432, 1360148479, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(18040, 1360148480, 1360150527, 'RS', 'SRB', 'صربيا'),
(18041, 1360150528, 1360158719, 'RO', 'ROM', 'رومانيا'),
(18042, 1360158720, 1360162815, 'DE', 'DEU', 'ألمانيا'),
(18043, 1360162816, 1360175103, 'RU', 'RUS', 'الإتحاد الروسي'),
(18044, 1360175104, 1360179199, 'NL', 'NLD', 'هولندا'),
(18045, 1360179200, 1360183295, 'FR', 'FRA', 'فرنسا'),
(18046, 1360183296, 1360191487, 'PL', 'POL', 'بولندا'),
(18047, 1360191488, 1360195583, 'FO', 'FRO', 'جزر فارو'),
(18048, 1360195584, 1360199679, 'NL', 'NLD', 'هولندا'),
(18049, 1360199680, 1360203775, 'CZ', 'CZE', 'التشيك'),
(18050, 1360203776, 1360207871, 'FR', 'FRA', 'فرنسا'),
(18051, 1360207872, 1360211967, 'CZ', 'CZE', 'التشيك'),
(18052, 1360211968, 1360216063, 'GB', 'GBR', 'المملكة المتحدة'),
(18053, 1360216064, 1360224255, 'RU', 'RUS', 'الإتحاد الروسي'),
(18054, 1360224256, 1360225663, 'ES', 'ESP', 'إسبانيا'),
(18055, 1360225664, 1360225695, 'GB', 'GBR', 'المملكة المتحدة'),
(18056, 1360225696, 1360226079, 'ES', 'ESP', 'إسبانيا'),
(18057, 1360226080, 1360226111, 'IT', 'ITA', 'إيطاليا'),
(18058, 1360226112, 1360226191, 'ES', 'ESP', 'إسبانيا'),
(18059, 1360226192, 1360226199, 'IT', 'ITA', 'إيطاليا'),
(18060, 1360226200, 1360228351, 'ES', 'ESP', 'إسبانيا'),
(18061, 1360228352, 1360232447, 'FI', 'FIN', 'فنلندا'),
(18062, 1360232448, 1360236543, 'RU', 'RUS', 'الإتحاد الروسي'),
(18063, 1360236544, 1360239135, 'AT', 'AUT', 'النمسا'),
(18064, 1360239136, 1360239167, 'DE', 'DEU', 'ألمانيا'),
(18065, 1360239168, 1360240639, 'AT', 'AUT', 'النمسا'),
(18066, 1360240640, 1360244735, 'ES', 'ESP', 'إسبانيا'),
(18067, 1360244736, 1360257023, 'GB', 'GBR', 'المملكة المتحدة'),
(18068, 1360257024, 1360259447, 'DK', 'DNK', 'الدنيمارك'),
(18069, 1360259448, 1360259451, 'US', 'USA', 'الولايات المتحدة'),
(18070, 1360259452, 1360265215, 'DK', 'DNK', 'الدنيمارك'),
(18071, 1360265216, 1360269311, 'GB', 'GBR', 'المملكة المتحدة'),
(18072, 1360269312, 1360273407, 'KG', 'KGZ', 'قيرغيزستان'),
(18073, 1360273408, 1360281599, 'GB', 'GBR', 'المملكة المتحدة'),
(18074, 1360281600, 1360285695, 'NL', 'NLD', 'هولندا'),
(18075, 1360285696, 1360289791, 'DE', 'DEU', 'ألمانيا'),
(18076, 1360289792, 1360293887, 'RU', 'RUS', 'الإتحاد الروسي'),
(18077, 1360293888, 1360302079, 'DE', 'DEU', 'ألمانيا'),
(18078, 1360302080, 1360306175, 'EE', 'EST', 'إستونيا'),
(18079, 1360306176, 1360310271, 'RU', 'RUS', 'الإتحاد الروسي'),
(18080, 1360310272, 1360314367, 'GB', 'GBR', 'المملكة المتحدة'),
(18081, 1360314368, 1360318463, 'RU', 'RUS', 'الإتحاد الروسي'),
(18082, 1360318464, 1360322559, 'FR', 'FRA', 'فرنسا'),
(18083, 1360322560, 1360326655, 'FI', 'FIN', 'فنلندا'),
(18084, 1360326656, 1360330751, 'PT', 'PRT', 'البورتوغال'),
(18085, 1360330752, 1360334847, 'UA', 'UKR', 'أوكرانيا'),
(18086, 1360334848, 1360338943, 'AT', 'AUT', 'النمسا'),
(18087, 1360338944, 1360343039, 'CY', 'CYP', 'قبرص'),
(18088, 1360343040, 1360347135, 'SA', 'SAU', 'السعودية'),
(18089, 1360347136, 1360351231, 'GB', 'GBR', 'المملكة المتحدة'),
(18090, 1360351232, 1360355327, 'AZ', 'AZE', 'أذربيجان'),
(18091, 1360359424, 1360363519, 'AT', 'AUT', 'النمسا'),
(18092, 1360363520, 1360367615, 'IT', 'ITA', 'إيطاليا'),
(18093, 1360367616, 1360371711, 'IE', 'IRL', 'إيرلندا'),
(18094, 1360371712, 1360375807, 'TR', 'TUR', 'تركيا'),
(18095, 1360375808, 1360379903, 'NL', 'NLD', 'هولندا'),
(18096, 1360379904, 1360383999, 'PL', 'POL', 'بولندا'),
(18097, 1360384000, 1360388095, 'SE', 'SWE', 'السويد'),
(18098, 1360388096, 1360392191, 'RU', 'RUS', 'الإتحاد الروسي'),
(18099, 1360392192, 1360396287, 'EE', 'EST', 'إستونيا'),
(18100, 1360396288, 1360400383, 'RU', 'RUS', 'الإتحاد الروسي'),
(18101, 1360400384, 1360404479, 'BH', 'BHR', 'البحرين'),
(18102, 1360404480, 1360404735, 'GB', 'GBR', 'المملكة المتحدة'),
(18103, 1360404736, 1360404991, 'DE', 'DEU', 'ألمانيا'),
(18104, 1360404992, 1360405247, 'FR', 'FRA', 'فرنسا'),
(18105, 1360405248, 1360405503, 'SE', 'SWE', 'السويد'),
(18106, 1360405504, 1360408575, 'GB', 'GBR', 'المملكة المتحدة'),
(18107, 1360408576, 1360412671, 'RU', 'RUS', 'الإتحاد الروسي'),
(18108, 1360420864, 1360424959, 'TR', 'TUR', 'تركيا'),
(18109, 1360424960, 1360429055, 'RU', 'RUS', 'الإتحاد الروسي'),
(18110, 1360429056, 1360433151, 'UA', 'UKR', 'أوكرانيا'),
(18111, 1360433152, 1360437247, 'RO', 'ROM', 'رومانيا'),
(18112, 1360437248, 1360441343, 'FI', 'FIN', 'فنلندا'),
(18113, 1360441344, 1360445439, 'HU', 'HUN', 'هنغاريا'),
(18114, 1360445440, 1360453631, 'RU', 'RUS', 'الإتحاد الروسي'),
(18115, 1360453632, 1360457727, 'DE', 'DEU', 'ألمانيا'),
(18116, 1360457728, 1360459103, 'FI', 'FIN', 'فنلندا'),
(18117, 1360459104, 1360459135, 'IL', 'ISR', 'إسرائيل'),
(18118, 1360459136, 1360461823, 'FI', 'FIN', 'فنلندا'),
(18119, 1360461824, 1360465919, 'LT', 'LTU', 'ليتوانيا'),
(18120, 1360465920, 1360470015, 'UA', 'UKR', 'أوكرانيا'),
(18121, 1360470016, 1360474111, 'FR', 'FRA', 'فرنسا'),
(18122, 1360474112, 1360478207, 'GB', 'GBR', 'المملكة المتحدة'),
(18123, 1360478208, 1360482303, 'CH', 'CHE', 'سويسرا'),
(18124, 1360482304, 1360486399, 'IT', 'ITA', 'إيطاليا'),
(18125, 1360486400, 1360515071, 'RU', 'RUS', 'الإتحاد الروسي'),
(18126, 1360515072, 1360519167, 'GB', 'GBR', 'المملكة المتحدة'),
(18127, 1360519168, 1360524031, 'NL', 'NLD', 'هولندا'),
(18128, 1360524032, 1360524287, 'US', 'USA', 'الولايات المتحدة'),
(18129, 1360524288, 1360531455, 'NL', 'NLD', 'هولندا'),
(18130, 1360531456, 1360535551, 'RO', 'ROM', 'رومانيا'),
(18131, 1360535552, 1360539647, 'DE', 'DEU', 'ألمانيا'),
(18132, 1360539648, 1360543743, 'NL', 'NLD', 'هولندا'),
(18133, 1360543744, 1360547839, 'DE', 'DEU', 'ألمانيا'),
(18134, 1360547840, 1360551935, 'RU', 'RUS', 'الإتحاد الروسي'),
(18135, 1360551936, 1360556031, 'SI', 'SVN', 'سلوفينيا'),
(18136, 1360556032, 1360564223, 'RU', 'RUS', 'الإتحاد الروسي'),
(18137, 1360564224, 1360568319, 'AT', 'AUT', 'النمسا'),
(18138, 1360568320, 1360572415, 'ES', 'ESP', 'إسبانيا'),
(18139, 1360572416, 1360576511, 'GR', 'GRC', 'اليونان'),
(18140, 1360576512, 1360580607, 'GB', 'GBR', 'المملكة المتحدة'),
(18141, 1360580608, 1360584703, 'UA', 'UKR', 'أوكرانيا'),
(18142, 1360584704, 1360588799, 'IT', 'ITA', 'إيطاليا'),
(18143, 1360588800, 1360592895, 'GB', 'GBR', 'المملكة المتحدة'),
(18144, 1360592896, 1360596991, 'RU', 'RUS', 'الإتحاد الروسي'),
(18145, 1360596992, 1360601087, 'CZ', 'CZE', 'التشيك'),
(18146, 1360601088, 1360605183, 'BY', 'BLR', 'روسيا البيضاء'),
(18147, 1360605184, 1360613375, 'RU', 'RUS', 'الإتحاد الروسي'),
(18148, 1360613376, 1360617471, 'SE', 'SWE', 'السويد'),
(18149, 1360617472, 1360621567, 'IT', 'ITA', 'إيطاليا'),
(18150, 1360621568, 1360625663, 'ES', 'ESP', 'إسبانيا'),
(18151, 1360625664, 1360627967, 'DE', 'DEU', 'ألمانيا'),
(18152, 1360627968, 1360628095, 'IQ', 'IRQ', 'العراق'),
(18153, 1360628096, 1360628223, 'LU', 'LUX', 'لوكسيمبورغ'),
(18154, 1360628224, 1360628735, 'LB', 'LBN', 'لبنان'),
(18155, 1360628736, 1360628991, 'IQ', 'IRQ', 'العراق'),
(18156, 1360628992, 1360629503, 'DE', 'DEU', 'ألمانيا'),
(18157, 1360629504, 1360629759, 'IQ', 'IRQ', 'العراق'),
(18158, 1360629760, 1360633855, 'SE', 'SWE', 'السويد'),
(18159, 1360633856, 1360637951, 'RU', 'RUS', 'الإتحاد الروسي'),
(18160, 1360637952, 1360642047, 'FO', 'FRO', 'جزر فارو'),
(18161, 1360642048, 1360645711, 'FR', 'FRA', 'فرنسا'),
(18162, 1360645712, 1360645719, 'GB', 'GBR', 'المملكة المتحدة'),
(18163, 1360645720, 1360646143, 'FR', 'FRA', 'فرنسا'),
(18164, 1360646144, 1360650239, 'AT', 'AUT', 'النمسا'),
(18165, 1360650240, 1360654335, 'UA', 'UKR', 'أوكرانيا'),
(18166, 1360654336, 1360658431, 'EE', 'EST', 'إستونيا'),
(18167, 1360658432, 1360666623, 'PL', 'POL', 'بولندا'),
(18168, 1360666624, 1360674815, 'NO', 'NOR', 'النرويج'),
(18169, 1360678912, 1360683007, 'RU', 'RUS', 'الإتحاد الروسي'),
(18170, 1360683008, 1360691199, 'GB', 'GBR', 'المملكة المتحدة'),
(18171, 1360691200, 1360699391, 'RU', 'RUS', 'الإتحاد الروسي'),
(18172, 1360699392, 1360703487, 'DE', 'DEU', 'ألمانيا'),
(18173, 1360703488, 1360707583, 'RU', 'RUS', 'الإتحاد الروسي'),
(18174, 1360707584, 1360711679, 'IT', 'ITA', 'إيطاليا'),
(18175, 1360711680, 1360715775, 'NL', 'NLD', 'هولندا'),
(18176, 1360715776, 1360728063, 'SE', 'SWE', 'السويد'),
(18177, 1360728064, 1360732159, 'FR', 'FRA', 'فرنسا'),
(18178, 1360732160, 1360736255, 'NO', 'NOR', 'النرويج'),
(18179, 1360736256, 1360740351, 'RU', 'RUS', 'الإتحاد الروسي'),
(18180, 1360740352, 1360743679, 'GB', 'GBR', 'المملكة المتحدة'),
(18181, 1360743680, 1360743935, 'FR', 'FRA', 'فرنسا'),
(18182, 1360743936, 1360752639, 'GB', 'GBR', 'المملكة المتحدة'),
(18183, 1360752640, 1360756735, 'DE', 'DEU', 'ألمانيا'),
(18184, 1360756736, 1360760831, 'IT', 'ITA', 'إيطاليا'),
(18185, 1360760832, 1360764927, 'RU', 'RUS', 'الإتحاد الروسي'),
(18186, 1360764928, 1360769023, 'DE', 'DEU', 'ألمانيا'),
(18187, 1360769024, 1360773119, 'IT', 'ITA', 'إيطاليا'),
(18188, 1360773120, 1360777215, 'CZ', 'CZE', 'التشيك'),
(18189, 1360777216, 1360781311, 'DK', 'DNK', 'الدنيمارك'),
(18190, 1360781312, 1360785407, 'DE', 'DEU', 'ألمانيا'),
(18191, 1360785408, 1360793599, 'RU', 'RUS', 'الإتحاد الروسي'),
(18192, 1360793600, 1360797695, 'CZ', 'CZE', 'التشيك'),
(18193, 1360797696, 1360805887, 'IR', 'IRN', 'إيران'),
(18194, 1360805888, 1360809983, 'DE', 'DEU', 'ألمانيا'),
(18195, 1360809984, 1360814079, 'NL', 'NLD', 'هولندا'),
(18196, 1360814080, 1360818175, 'FR', 'FRA', 'فرنسا'),
(18197, 1360818176, 1360822271, 'JO', 'JOR', 'الأردن'),
(18198, 1360822272, 1360826367, 'AT', 'AUT', 'النمسا'),
(18199, 1360826368, 1360830463, 'GB', 'GBR', 'المملكة المتحدة'),
(18200, 1360830464, 1360838655, 'RU', 'RUS', 'الإتحاد الروسي'),
(18201, 1360838656, 1360842751, 'FR', 'FRA', 'فرنسا'),
(18202, 1360842752, 1360846847, 'RU', 'RUS', 'الإتحاد الروسي'),
(18203, 1360846848, 1360850943, 'DE', 'DEU', 'ألمانيا'),
(18204, 1360850944, 1360855039, 'IT', 'ITA', 'إيطاليا'),
(18205, 1360855040, 1360855841, 'NL', 'NLD', 'هولندا'),
(18206, 1360855842, 1360855851, 'MX', 'MEX', 'المكسيك'),
(18207, 1360855852, 1360856075, 'NL', 'NLD', 'هولندا'),
(18208, 1360856076, 1360856079, 'AU', 'AUS', 'أستراليا'),
(18209, 1360856080, 1360856109, 'NL', 'NLD', 'هولندا'),
(18210, 1360856110, 1360856113, 'AU', 'AUS', 'أستراليا'),
(18211, 1360856114, 1360856133, 'NL', 'NLD', 'هولندا'),
(18212, 1360856134, 1360856144, 'MX', 'MEX', 'المكسيك'),
(18213, 1360856145, 1360859135, 'NL', 'NLD', 'هولندا'),
(18214, 1360859136, 1360863231, 'LT', 'LTU', 'ليتوانيا'),
(18215, 1360863232, 1360867327, 'NO', 'NOR', 'النرويج'),
(18216, 1360867328, 1360879615, 'GB', 'GBR', 'المملكة المتحدة'),
(18217, 1360883712, 1360887807, 'RU', 'RUS', 'الإتحاد الروسي'),
(18218, 1360887808, 1360890367, 'FI', 'FIN', 'فنلندا'),
(18219, 1360890368, 1360890623, 'RU', 'RUS', 'الإتحاد الروسي'),
(18220, 1360890624, 1360890879, 'FI', 'FIN', 'فنلندا'),
(18221, 1360890880, 1360891391, 'RU', 'RUS', 'الإتحاد الروسي'),
(18222, 1360891392, 1360891647, 'FI', 'FIN', 'فنلندا'),
(18223, 1360891648, 1360891903, 'RU', 'RUS', 'الإتحاد الروسي'),
(18224, 1360891904, 1360892159, 'IT', 'ITA', 'إيطاليا'),
(18225, 1360892160, 1360892427, 'CH', 'CHE', 'سويسرا'),
(18226, 1360892428, 1360892431, 'IT', 'ITA', 'إيطاليا'),
(18227, 1360892432, 1360892479, 'CH', 'CHE', 'سويسرا'),
(18228, 1360892480, 1360892487, 'FR', 'FRA', 'فرنسا'),
(18229, 1360892488, 1360892671, 'CH', 'CHE', 'سويسرا'),
(18230, 1360892672, 1360892703, 'IT', 'ITA', 'إيطاليا'),
(18231, 1360892704, 1360892735, 'CH', 'CHE', 'سويسرا'),
(18232, 1360892736, 1360892739, 'EE', 'EST', 'إستونيا'),
(18233, 1360892740, 1360892743, 'GB', 'GBR', 'المملكة المتحدة'),
(18234, 1360892744, 1360892763, 'CH', 'CHE', 'سويسرا'),
(18235, 1360892764, 1360892771, 'IT', 'ITA', 'إيطاليا'),
(18236, 1360892772, 1360892791, 'CH', 'CHE', 'سويسرا'),
(18237, 1360892792, 1360892799, 'IT', 'ITA', 'إيطاليا'),
(18238, 1360892800, 1360892807, 'CH', 'CHE', 'سويسرا'),
(18239, 1360892808, 1360892823, 'IT', 'ITA', 'إيطاليا'),
(18240, 1360892824, 1360892927, 'CH', 'CHE', 'سويسرا'),
(18241, 1360892928, 1360893055, 'IT', 'ITA', 'إيطاليا'),
(18242, 1360893056, 1360893191, 'CH', 'CHE', 'سويسرا'),
(18243, 1360893192, 1360893195, 'IT', 'ITA', 'إيطاليا'),
(18244, 1360893196, 1360893831, 'CH', 'CHE', 'سويسرا'),
(18245, 1360893832, 1360893835, 'IT', 'ITA', 'إيطاليا'),
(18246, 1360893836, 1360893951, 'CH', 'CHE', 'سويسرا'),
(18247, 1360893952, 1360894207, 'IT', 'ITA', 'إيطاليا'),
(18248, 1360894208, 1360894975, 'CH', 'CHE', 'سويسرا'),
(18249, 1360894976, 1360895007, 'IT', 'ITA', 'إيطاليا'),
(18250, 1360895008, 1360895751, 'CH', 'CHE', 'سويسرا'),
(18251, 1360895752, 1360895755, 'IT', 'ITA', 'إيطاليا'),
(18252, 1360895756, 1360895999, 'CH', 'CHE', 'سويسرا'),
(18253, 1360896000, 1360900095, 'QA', 'QAT', 'قطر'),
(18254, 1360900096, 1360904335, 'IT', 'ITA', 'إيطاليا'),
(18255, 1360904336, 1360904343, 'GB', 'GBR', 'المملكة المتحدة'),
(18256, 1360904344, 1360905039, 'IT', 'ITA', 'إيطاليا'),
(18257, 1360905040, 1360905055, 'GB', 'GBR', 'المملكة المتحدة'),
(18258, 1360905056, 1360905391, 'IT', 'ITA', 'إيطاليا'),
(18259, 1360905392, 1360905407, 'GB', 'GBR', 'المملكة المتحدة'),
(18260, 1360905408, 1360906687, 'IT', 'ITA', 'إيطاليا'),
(18261, 1360906688, 1360906719, 'GB', 'GBR', 'المملكة المتحدة'),
(18262, 1360906720, 1360907679, 'IT', 'ITA', 'إيطاليا'),
(18263, 1360907680, 1360907711, 'GB', 'GBR', 'المملكة المتحدة'),
(18264, 1360907712, 1360909391, 'IT', 'ITA', 'إيطاليا'),
(18265, 1360909392, 1360909407, 'GB', 'GBR', 'المملكة المتحدة'),
(18266, 1360909408, 1360910495, 'IT', 'ITA', 'إيطاليا'),
(18267, 1360910496, 1360910511, 'GB', 'GBR', 'المملكة المتحدة'),
(18268, 1360910512, 1360910527, 'IT', 'ITA', 'إيطاليا'),
(18269, 1360910528, 1360910559, 'GB', 'GBR', 'المملكة المتحدة'),
(18270, 1360910560, 1360916479, 'IT', 'ITA', 'إيطاليا'),
(18271, 1360916480, 1360920575, 'IR', 'IRN', 'إيران'),
(18272, 1360920576, 1360928767, 'IT', 'ITA', 'إيطاليا'),
(18273, 1360932864, 1360936959, 'RU', 'RUS', 'الإتحاد الروسي'),
(18274, 1360936960, 1360941055, 'NL', 'NLD', 'هولندا'),
(18275, 1360941056, 1360945151, 'BY', 'BLR', 'روسيا البيضاء'),
(18276, 1360945152, 1360949247, 'DE', 'DEU', 'ألمانيا'),
(18277, 1360949248, 1360953343, 'RU', 'RUS', 'الإتحاد الروسي'),
(18278, 1360953344, 1360957439, 'PL', 'POL', 'بولندا'),
(18279, 1360957440, 1360961535, 'DE', 'DEU', 'ألمانيا'),
(18280, 1360961536, 1360965631, 'UA', 'UKR', 'أوكرانيا'),
(18281, 1360965632, 1360977919, 'RU', 'RUS', 'الإتحاد الروسي'),
(18282, 1360977920, 1360986111, 'CZ', 'CZE', 'التشيك'),
(18283, 1360986112, 1360987135, 'GB', 'GBR', 'المملكة المتحدة'),
(18284, 1360987136, 1360987535, 'CZ', 'CZE', 'التشيك'),
(18285, 1360987536, 1360987903, 'GB', 'GBR', 'المملكة المتحدة'),
(18286, 1360987904, 1360987935, 'CZ', 'CZE', 'التشيك'),
(18287, 1360987936, 1360987983, 'SK', 'SVK', 'سلوفاكيا'),
(18288, 1360987984, 1360987999, 'CZ', 'CZE', 'التشيك'),
(18289, 1360988000, 1360988015, 'GB', 'GBR', 'المملكة المتحدة'),
(18290, 1360988016, 1360988031, 'CZ', 'CZE', 'التشيك'),
(18291, 1360988032, 1360988039, 'GB', 'GBR', 'المملكة المتحدة'),
(18292, 1360988040, 1360988047, 'CZ', 'CZE', 'التشيك'),
(18293, 1360988048, 1360988055, 'GB', 'GBR', 'المملكة المتحدة'),
(18294, 1360988056, 1360988063, 'SK', 'SVK', 'سلوفاكيا'),
(18295, 1360988064, 1360988079, 'CZ', 'CZE', 'التشيك'),
(18296, 1360988080, 1360988159, 'GB', 'GBR', 'المملكة المتحدة'),
(18297, 1360988160, 1360988415, 'SK', 'SVK', 'سلوفاكيا'),
(18298, 1360988416, 1360988927, 'CZ', 'CZE', 'التشيك'),
(18299, 1360988928, 1360989183, 'GB', 'GBR', 'المملكة المتحدة'),
(18300, 1360989184, 1360989439, 'SK', 'SVK', 'سلوفاكيا'),
(18301, 1360989440, 1360989695, 'GB', 'GBR', 'المملكة المتحدة'),
(18302, 1360989696, 1360990079, 'CZ', 'CZE', 'التشيك'),
(18303, 1360990080, 1360990207, 'GB', 'GBR', 'المملكة المتحدة'),
(18304, 1360990208, 1360990463, 'CZ', 'CZE', 'التشيك'),
(18305, 1360990464, 1360990719, 'GB', 'GBR', 'المملكة المتحدة'),
(18306, 1360990720, 1360990975, 'CZ', 'CZE', 'التشيك'),
(18307, 1360990976, 1360991231, 'GB', 'GBR', 'المملكة المتحدة'),
(18308, 1360991232, 1360991743, 'CZ', 'CZE', 'التشيك'),
(18309, 1360991744, 1360991999, 'GB', 'GBR', 'المملكة المتحدة'),
(18310, 1360992000, 1360992255, 'SK', 'SVK', 'سلوفاكيا'),
(18311, 1360992256, 1360992767, 'CZ', 'CZE', 'التشيك'),
(18312, 1360992768, 1360994303, 'GB', 'GBR', 'المملكة المتحدة'),
(18313, 1360994304, 1360998399, 'CZ', 'CZE', 'التشيك'),
(18314, 1360998400, 1361002495, 'FI', 'FIN', 'فنلندا'),
(18315, 1361002496, 1361006591, 'GB', 'GBR', 'المملكة المتحدة'),
(18316, 1361006592, 1361010687, 'DK', 'DNK', 'الدنيمارك'),
(18317, 1361010688, 1361018879, 'GB', 'GBR', 'المملكة المتحدة'),
(18318, 1361018880, 1361022975, 'AT', 'AUT', 'النمسا'),
(18319, 1361022976, 1361027071, 'IT', 'ITA', 'إيطاليا'),
(18320, 1361027072, 1361035263, 'IR', 'IRN', 'إيران'),
(18321, 1361035264, 1361035527, 'NL', 'NLD', 'هولندا'),
(18322, 1361035528, 1361035535, 'IT', 'ITA', 'إيطاليا'),
(18323, 1361035536, 1361035543, 'IQ', 'IRQ', 'العراق'),
(18324, 1361035544, 1361035547, 'ES', 'ESP', 'إسبانيا'),
(18325, 1361035548, 1361035551, 'DE', 'DEU', 'ألمانيا'),
(18326, 1361035552, 1361035555, 'IQ', 'IRQ', 'العراق'),
(18327, 1361035556, 1361035559, 'GI', 'GIB', 'جبل طارق'),
(18328, 1361035560, 1361035563, 'IQ', 'IRQ', 'العراق'),
(18329, 1361035564, 1361035567, 'DE', 'DEU', 'ألمانيا'),
(18330, 1361035568, 1361035575, 'ES', 'ESP', 'إسبانيا'),
(18331, 1361035576, 1361035583, 'DE', 'DEU', 'ألمانيا'),
(18332, 1361035584, 1361035587, 'IT', 'ITA', 'إيطاليا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(18333, 1361035588, 1361035599, 'IQ', 'IRQ', 'العراق'),
(18334, 1361035600, 1361035607, 'NL', 'NLD', 'هولندا'),
(18335, 1361035608, 1361035615, 'IT', 'ITA', 'إيطاليا'),
(18336, 1361035616, 1361035619, 'GB', 'GBR', 'المملكة المتحدة'),
(18337, 1361035620, 1361035623, 'IT', 'ITA', 'إيطاليا'),
(18338, 1361035624, 1361035627, 'DE', 'DEU', 'ألمانيا'),
(18339, 1361035628, 1361035631, 'DZ', 'DZA', 'الجزائر'),
(18340, 1361035632, 1361035635, 'IT', 'ITA', 'إيطاليا'),
(18341, 1361035636, 1361035655, 'IQ', 'IRQ', 'العراق'),
(18342, 1361035656, 1361035663, 'TR', 'TUR', 'تركيا'),
(18343, 1361035664, 1361035671, 'IQ', 'IRQ', 'العراق'),
(18344, 1361035672, 1361035675, 'IT', 'ITA', 'إيطاليا'),
(18345, 1361035676, 1361035679, 'IQ', 'IRQ', 'العراق'),
(18346, 1361035680, 1361035683, 'IE', 'IRL', 'إيرلندا'),
(18347, 1361035684, 1361035687, 'IQ', 'IRQ', 'العراق'),
(18348, 1361035688, 1361035691, 'GB', 'GBR', 'المملكة المتحدة'),
(18349, 1361035692, 1361035715, 'IQ', 'IRQ', 'العراق'),
(18350, 1361035716, 1361035723, 'GB', 'GBR', 'المملكة المتحدة'),
(18351, 1361035724, 1361035739, 'IQ', 'IRQ', 'العراق'),
(18352, 1361035740, 1361035743, 'IT', 'ITA', 'إيطاليا'),
(18353, 1361035744, 1361035751, 'IQ', 'IRQ', 'العراق'),
(18354, 1361035752, 1361035755, 'GB', 'GBR', 'المملكة المتحدة'),
(18355, 1361035756, 1361035759, 'IQ', 'IRQ', 'العراق'),
(18356, 1361035760, 1361035763, 'ES', 'ESP', 'إسبانيا'),
(18357, 1361035764, 1361035767, 'IE', 'IRL', 'إيرلندا'),
(18358, 1361035768, 1361035775, 'IQ', 'IRQ', 'العراق'),
(18359, 1361035776, 1361035779, 'GB', 'GBR', 'المملكة المتحدة'),
(18360, 1361035780, 1361035783, 'PL', 'POL', 'بولندا'),
(18361, 1361035784, 1361035799, 'IQ', 'IRQ', 'العراق'),
(18362, 1361035800, 1361035807, 'TR', 'TUR', 'تركيا'),
(18363, 1361035808, 1361035811, 'NL', 'NLD', 'هولندا'),
(18364, 1361035812, 1361035815, 'BA', 'BIH', 'البوسنه والهرسك'),
(18365, 1361035816, 1361035823, 'TR', 'TUR', 'تركيا'),
(18366, 1361035824, 1361035831, 'DE', 'DEU', 'ألمانيا'),
(18367, 1361035832, 1361035839, 'BE', 'BEL', 'بلجيكا'),
(18368, 1361035840, 1361035847, 'ES', 'ESP', 'إسبانيا'),
(18369, 1361035848, 1361035851, 'GB', 'GBR', 'المملكة المتحدة'),
(18370, 1361035852, 1361035855, 'IQ', 'IRQ', 'العراق'),
(18371, 1361035856, 1361035863, 'ES', 'ESP', 'إسبانيا'),
(18372, 1361035864, 1361035871, 'BE', 'BEL', 'بلجيكا'),
(18373, 1361035872, 1361035875, 'GB', 'GBR', 'المملكة المتحدة'),
(18374, 1361035876, 1361035879, 'NL', 'NLD', 'هولندا'),
(18375, 1361035880, 1361035899, 'IQ', 'IRQ', 'العراق'),
(18376, 1361035900, 1361035903, 'NL', 'NLD', 'هولندا'),
(18377, 1361035904, 1361035907, 'KW', 'KWT', 'الكويت'),
(18378, 1361035908, 1361035911, 'ES', 'ESP', 'إسبانيا'),
(18379, 1361035912, 1361035915, 'IQ', 'IRQ', 'العراق'),
(18380, 1361035916, 1361035919, 'IT', 'ITA', 'إيطاليا'),
(18381, 1361035920, 1361035923, 'CH', 'CHE', 'سويسرا'),
(18382, 1361035924, 1361035927, 'IQ', 'IRQ', 'العراق'),
(18383, 1361035928, 1361035931, 'DE', 'DEU', 'ألمانيا'),
(18384, 1361035932, 1361035935, 'TR', 'TUR', 'تركيا'),
(18385, 1361035936, 1361035943, 'GB', 'GBR', 'المملكة المتحدة'),
(18386, 1361035944, 1361035959, 'IQ', 'IRQ', 'العراق'),
(18387, 1361035960, 1361035963, 'GB', 'GBR', 'المملكة المتحدة'),
(18388, 1361035964, 1361035967, 'CH', 'CHE', 'سويسرا'),
(18389, 1361035968, 1361035975, 'GB', 'GBR', 'المملكة المتحدة'),
(18390, 1361035976, 1361035979, 'US', 'USA', 'الولايات المتحدة'),
(18391, 1361035980, 1361035983, 'IQ', 'IRQ', 'العراق'),
(18392, 1361035984, 1361035995, 'DE', 'DEU', 'ألمانيا'),
(18393, 1361035996, 1361035999, 'IE', 'IRL', 'إيرلندا'),
(18394, 1361036000, 1361036015, 'GB', 'GBR', 'المملكة المتحدة'),
(18395, 1361036016, 1361036019, 'IQ', 'IRQ', 'العراق'),
(18396, 1361036020, 1361036023, 'NL', 'NLD', 'هولندا'),
(18397, 1361036024, 1361036031, 'IQ', 'IRQ', 'العراق'),
(18398, 1361036032, 1361036039, 'IE', 'IRL', 'إيرلندا'),
(18399, 1361036040, 1361036043, 'IT', 'ITA', 'إيطاليا'),
(18400, 1361036044, 1361036055, 'IQ', 'IRQ', 'العراق'),
(18401, 1361036056, 1361036063, 'NL', 'NLD', 'هولندا'),
(18402, 1361036064, 1361036071, 'DE', 'DEU', 'ألمانيا'),
(18403, 1361036072, 1361036079, 'BE', 'BEL', 'بلجيكا'),
(18404, 1361036080, 1361036087, 'FR', 'FRA', 'فرنسا'),
(18405, 1361036088, 1361036095, 'IT', 'ITA', 'إيطاليا'),
(18406, 1361036096, 1361036103, 'IQ', 'IRQ', 'العراق'),
(18407, 1361036104, 1361036111, 'NO', 'NOR', 'النرويج'),
(18408, 1361036112, 1361036119, 'RO', 'ROM', 'رومانيا'),
(18409, 1361036120, 1361036127, 'HU', 'HUN', 'هنغاريا'),
(18410, 1361036128, 1361036135, 'CZ', 'CZE', 'التشيك'),
(18411, 1361036136, 1361036143, 'IQ', 'IRQ', 'العراق'),
(18412, 1361036144, 1361036151, 'TR', 'TUR', 'تركيا'),
(18413, 1361036152, 1361036167, 'ES', 'ESP', 'إسبانيا'),
(18414, 1361036168, 1361036175, 'IQ', 'IRQ', 'العراق'),
(18415, 1361036176, 1361036191, 'GB', 'GBR', 'المملكة المتحدة'),
(18416, 1361036192, 1361036199, 'IQ', 'IRQ', 'العراق'),
(18417, 1361036200, 1361036207, 'TR', 'TUR', 'تركيا'),
(18418, 1361036208, 1361036215, 'IQ', 'IRQ', 'العراق'),
(18419, 1361036216, 1361036223, 'DE', 'DEU', 'ألمانيا'),
(18420, 1361036224, 1361036239, 'IQ', 'IRQ', 'العراق'),
(18421, 1361036240, 1361036243, 'NL', 'NLD', 'هولندا'),
(18422, 1361036244, 1361036247, 'IT', 'ITA', 'إيطاليا'),
(18423, 1361036248, 1361036251, 'TN', 'TUN', 'تونس'),
(18424, 1361036252, 1361036255, 'NL', 'NLD', 'هولندا'),
(18425, 1361036256, 1361036259, 'GB', 'GBR', 'المملكة المتحدة'),
(18426, 1361036260, 1361036287, 'IQ', 'IRQ', 'العراق'),
(18427, 1361036288, 1361036295, 'IT', 'ITA', 'إيطاليا'),
(18428, 1361036296, 1361036299, 'IQ', 'IRQ', 'العراق'),
(18429, 1361036300, 1361036303, 'GB', 'GBR', 'المملكة المتحدة'),
(18430, 1361036304, 1361036307, 'ES', 'ESP', 'إسبانيا'),
(18431, 1361036308, 1361036311, 'NL', 'NLD', 'هولندا'),
(18432, 1361036312, 1361036315, 'IQ', 'IRQ', 'العراق'),
(18433, 1361036316, 1361036319, 'DZ', 'DZA', 'الجزائر'),
(18434, 1361036320, 1361036327, 'IQ', 'IRQ', 'العراق'),
(18435, 1361036328, 1361036331, 'DZ', 'DZA', 'الجزائر'),
(18436, 1361036332, 1361036335, 'IT', 'ITA', 'إيطاليا'),
(18437, 1361036336, 1361036359, 'IQ', 'IRQ', 'العراق'),
(18438, 1361036360, 1361036367, 'DZ', 'DZA', 'الجزائر'),
(18439, 1361036368, 1361036371, 'TR', 'TUR', 'تركيا'),
(18440, 1361036372, 1361036375, 'GB', 'GBR', 'المملكة المتحدة'),
(18441, 1361036376, 1361036379, 'NL', 'NLD', 'هولندا'),
(18442, 1361036380, 1361036383, 'GB', 'GBR', 'المملكة المتحدة'),
(18443, 1361036384, 1361036387, 'DZ', 'DZA', 'الجزائر'),
(18444, 1361036388, 1361036403, 'IQ', 'IRQ', 'العراق'),
(18445, 1361036404, 1361036411, 'IT', 'ITA', 'إيطاليا'),
(18446, 1361036412, 1361036415, 'NL', 'NLD', 'هولندا'),
(18447, 1361036416, 1361036419, 'US', 'USA', 'الولايات المتحدة'),
(18448, 1361036420, 1361036423, 'ES', 'ESP', 'إسبانيا'),
(18449, 1361036424, 1361036431, 'GB', 'GBR', 'المملكة المتحدة'),
(18450, 1361036432, 1361036435, 'EG', 'EGY', 'مصر'),
(18451, 1361036436, 1361036459, 'IQ', 'IRQ', 'العراق'),
(18452, 1361036460, 1361036471, 'TR', 'TUR', 'تركيا'),
(18453, 1361036472, 1361036475, 'GB', 'GBR', 'المملكة المتحدة'),
(18454, 1361036476, 1361036491, 'IQ', 'IRQ', 'العراق'),
(18455, 1361036492, 1361036495, 'GB', 'GBR', 'المملكة المتحدة'),
(18456, 1361036496, 1361036515, 'IQ', 'IRQ', 'العراق'),
(18457, 1361036516, 1361036519, 'IT', 'ITA', 'إيطاليا'),
(18458, 1361036520, 1361036523, 'GB', 'GBR', 'المملكة المتحدة'),
(18459, 1361036524, 1361036527, 'IQ', 'IRQ', 'العراق'),
(18460, 1361036528, 1361036531, 'IT', 'ITA', 'إيطاليا'),
(18461, 1361036532, 1361036535, 'IQ', 'IRQ', 'العراق'),
(18462, 1361036536, 1361036551, 'TR', 'TUR', 'تركيا'),
(18463, 1361036552, 1361036559, 'GB', 'GBR', 'المملكة المتحدة'),
(18464, 1361036560, 1361036567, 'IQ', 'IRQ', 'العراق'),
(18465, 1361036568, 1361036575, 'NL', 'NLD', 'هولندا'),
(18466, 1361036576, 1361036579, 'IQ', 'IRQ', 'العراق'),
(18467, 1361036580, 1361036583, 'IT', 'ITA', 'إيطاليا'),
(18468, 1361036584, 1361036595, 'IQ', 'IRQ', 'العراق'),
(18469, 1361036596, 1361036599, 'GI', 'GIB', 'جبل طارق'),
(18470, 1361036600, 1361036607, 'IQ', 'IRQ', 'العراق'),
(18471, 1361036608, 1361036611, 'GI', 'GIB', 'جبل طارق'),
(18472, 1361036612, 1361036615, 'IQ', 'IRQ', 'العراق'),
(18473, 1361036616, 1361036623, 'GB', 'GBR', 'المملكة المتحدة'),
(18474, 1361036624, 1361036631, 'IQ', 'IRQ', 'العراق'),
(18475, 1361036632, 1361036635, 'GR', 'GRC', 'اليونان'),
(18476, 1361036636, 1361036639, 'GB', 'GBR', 'المملكة المتحدة'),
(18477, 1361036640, 1361036655, 'IQ', 'IRQ', 'العراق'),
(18478, 1361036656, 1361036663, 'NL', 'NLD', 'هولندا'),
(18479, 1361036664, 1361036667, 'DZ', 'DZA', 'الجزائر'),
(18480, 1361036668, 1361036671, 'CH', 'CHE', 'سويسرا'),
(18481, 1361036672, 1361036675, 'TR', 'TUR', 'تركيا'),
(18482, 1361036676, 1361036679, 'NL', 'NLD', 'هولندا'),
(18483, 1361036680, 1361036687, 'IQ', 'IRQ', 'العراق'),
(18484, 1361036688, 1361036695, 'NL', 'NLD', 'هولندا'),
(18485, 1361036696, 1361036703, 'TR', 'TUR', 'تركيا'),
(18486, 1361036704, 1361036711, 'IQ', 'IRQ', 'العراق'),
(18487, 1361036712, 1361036719, 'GB', 'GBR', 'المملكة المتحدة'),
(18488, 1361036720, 1361036727, 'IQ', 'IRQ', 'العراق'),
(18489, 1361036728, 1361036735, 'US', 'USA', 'الولايات المتحدة'),
(18490, 1361036736, 1361036763, 'IQ', 'IRQ', 'العراق'),
(18491, 1361036764, 1361036767, 'KW', 'KWT', 'الكويت'),
(18492, 1361036768, 1361036783, 'US', 'USA', 'الولايات المتحدة'),
(18493, 1361036784, 1361036787, 'GB', 'GBR', 'المملكة المتحدة'),
(18494, 1361036788, 1361036791, 'IQ', 'IRQ', 'العراق'),
(18495, 1361036792, 1361036795, 'KW', 'KWT', 'الكويت'),
(18496, 1361036796, 1361036799, 'NL', 'NLD', 'هولندا'),
(18497, 1361036800, 1361036823, 'IQ', 'IRQ', 'العراق'),
(18498, 1361036824, 1361036827, 'GB', 'GBR', 'المملكة المتحدة'),
(18499, 1361036828, 1361036831, 'DZ', 'DZA', 'الجزائر'),
(18500, 1361036832, 1361036847, 'IQ', 'IRQ', 'العراق'),
(18501, 1361036848, 1361036851, 'DZ', 'DZA', 'الجزائر'),
(18502, 1361036852, 1361036855, 'IQ', 'IRQ', 'العراق'),
(18503, 1361036856, 1361036863, 'NL', 'NLD', 'هولندا'),
(18504, 1361036864, 1361036867, 'IQ', 'IRQ', 'العراق'),
(18505, 1361036868, 1361036871, 'DE', 'DEU', 'ألمانيا'),
(18506, 1361036872, 1361036879, 'TR', 'TUR', 'تركيا'),
(18507, 1361036880, 1361036887, 'US', 'USA', 'الولايات المتحدة'),
(18508, 1361036888, 1361036891, 'GB', 'GBR', 'المملكة المتحدة'),
(18509, 1361036892, 1361036899, 'NL', 'NLD', 'هولندا'),
(18510, 1361036900, 1361036919, 'IQ', 'IRQ', 'العراق'),
(18511, 1361036920, 1361036923, 'IT', 'ITA', 'إيطاليا'),
(18512, 1361036924, 1361036927, 'DZ', 'DZA', 'الجزائر'),
(18513, 1361036928, 1361036935, 'TR', 'TUR', 'تركيا'),
(18514, 1361036936, 1361036943, 'NL', 'NLD', 'هولندا'),
(18515, 1361036944, 1361036991, 'IQ', 'IRQ', 'العراق'),
(18516, 1361036992, 1361037007, 'TR', 'TUR', 'تركيا'),
(18517, 1361037008, 1361037067, 'IQ', 'IRQ', 'العراق'),
(18518, 1361037068, 1361037075, 'TR', 'TUR', 'تركيا'),
(18519, 1361037076, 1361037079, 'HU', 'HUN', 'هنغاريا'),
(18520, 1361037080, 1361037087, 'IQ', 'IRQ', 'العراق'),
(18521, 1361037088, 1361037091, 'AF', 'AFG', 'أفغانستان'),
(18522, 1361037092, 1361037095, 'IQ', 'IRQ', 'العراق'),
(18523, 1361037096, 1361037099, 'IT', 'ITA', 'إيطاليا'),
(18524, 1361037100, 1361037103, 'TR', 'TUR', 'تركيا'),
(18525, 1361037104, 1361037111, 'NL', 'NLD', 'هولندا'),
(18526, 1361037112, 1361037115, 'US', 'USA', 'الولايات المتحدة'),
(18527, 1361037116, 1361037119, 'IQ', 'IRQ', 'العراق'),
(18528, 1361037120, 1361037123, 'US', 'USA', 'الولايات المتحدة'),
(18529, 1361037124, 1361037127, 'IQ', 'IRQ', 'العراق'),
(18530, 1361037128, 1361037135, 'NL', 'NLD', 'هولندا'),
(18531, 1361037136, 1361037151, 'IQ', 'IRQ', 'العراق'),
(18532, 1361037152, 1361037159, 'US', 'USA', 'الولايات المتحدة'),
(18533, 1361037160, 1361037171, 'IQ', 'IRQ', 'العراق'),
(18534, 1361037172, 1361037175, 'TR', 'TUR', 'تركيا'),
(18535, 1361037176, 1361037179, 'IQ', 'IRQ', 'العراق'),
(18536, 1361037180, 1361037183, 'GB', 'GBR', 'المملكة المتحدة'),
(18537, 1361037184, 1361037203, 'IQ', 'IRQ', 'العراق'),
(18538, 1361037204, 1361037207, 'FR', 'FRA', 'فرنسا'),
(18539, 1361037208, 1361037215, 'DE', 'DEU', 'ألمانيا'),
(18540, 1361037216, 1361037255, 'IQ', 'IRQ', 'العراق'),
(18541, 1361037256, 1361037263, 'NL', 'NLD', 'هولندا'),
(18542, 1361037264, 1361037271, 'IQ', 'IRQ', 'العراق'),
(18543, 1361037272, 1361037279, 'NL', 'NLD', 'هولندا'),
(18544, 1361037280, 1361037295, 'IQ', 'IRQ', 'العراق'),
(18545, 1361037296, 1361037311, 'DZ', 'DZA', 'الجزائر'),
(18546, 1361037312, 1361037319, 'IQ', 'IRQ', 'العراق'),
(18547, 1361037320, 1361037327, 'GB', 'GBR', 'المملكة المتحدة'),
(18548, 1361037328, 1361037351, 'IQ', 'IRQ', 'العراق'),
(18549, 1361037352, 1361037359, 'NL', 'NLD', 'هولندا'),
(18550, 1361037360, 1361037367, 'IQ', 'IRQ', 'العراق'),
(18551, 1361037368, 1361037375, 'TR', 'TUR', 'تركيا'),
(18552, 1361037376, 1361037391, 'IQ', 'IRQ', 'العراق'),
(18553, 1361037392, 1361037395, 'IT', 'ITA', 'إيطاليا'),
(18554, 1361037396, 1361037399, 'US', 'USA', 'الولايات المتحدة'),
(18555, 1361037400, 1361037407, 'DZ', 'DZA', 'الجزائر'),
(18556, 1361037408, 1361037415, 'TR', 'TUR', 'تركيا'),
(18557, 1361037416, 1361037439, 'IQ', 'IRQ', 'العراق'),
(18558, 1361037440, 1361037447, 'TR', 'TUR', 'تركيا'),
(18559, 1361037448, 1361037455, 'IQ', 'IRQ', 'العراق'),
(18560, 1361037456, 1361037463, 'DZ', 'DZA', 'الجزائر'),
(18561, 1361037464, 1361037471, 'CH', 'CHE', 'سويسرا'),
(18562, 1361037472, 1361037479, 'NL', 'NLD', 'هولندا'),
(18563, 1361037480, 1361037487, 'DZ', 'DZA', 'الجزائر'),
(18564, 1361037488, 1361037503, 'IQ', 'IRQ', 'العراق'),
(18565, 1361037504, 1361037511, 'DE', 'DEU', 'ألمانيا'),
(18566, 1361037512, 1361037527, 'IQ', 'IRQ', 'العراق'),
(18567, 1361037528, 1361037531, 'NL', 'NLD', 'هولندا'),
(18568, 1361037532, 1361037535, 'DZ', 'DZA', 'الجزائر'),
(18569, 1361037536, 1361037551, 'TR', 'TUR', 'تركيا'),
(18570, 1361037552, 1361037567, 'IQ', 'IRQ', 'العراق'),
(18571, 1361037568, 1361037575, 'TR', 'TUR', 'تركيا'),
(18572, 1361037576, 1361037583, 'IQ', 'IRQ', 'العراق'),
(18573, 1361037584, 1361037587, 'GB', 'GBR', 'المملكة المتحدة'),
(18574, 1361037588, 1361037591, 'NL', 'NLD', 'هولندا'),
(18575, 1361037592, 1361037607, 'IQ', 'IRQ', 'العراق'),
(18576, 1361037608, 1361037611, 'NL', 'NLD', 'هولندا'),
(18577, 1361037612, 1361037615, 'ES', 'ESP', 'إسبانيا'),
(18578, 1361037616, 1361037619, 'NL', 'NLD', 'هولندا'),
(18579, 1361037620, 1361037627, 'ES', 'ESP', 'إسبانيا'),
(18580, 1361037628, 1361037631, 'IT', 'ITA', 'إيطاليا'),
(18581, 1361037632, 1361037639, 'DZ', 'DZA', 'الجزائر'),
(18582, 1361037640, 1361037667, 'IQ', 'IRQ', 'العراق'),
(18583, 1361037668, 1361037671, 'DZ', 'DZA', 'الجزائر'),
(18584, 1361037672, 1361037679, 'TR', 'TUR', 'تركيا'),
(18585, 1361037680, 1361037683, 'IQ', 'IRQ', 'العراق'),
(18586, 1361037684, 1361037687, 'TR', 'TUR', 'تركيا'),
(18587, 1361037688, 1361037695, 'IQ', 'IRQ', 'العراق'),
(18588, 1361037696, 1361037703, 'TR', 'TUR', 'تركيا'),
(18589, 1361037704, 1361037771, 'IQ', 'IRQ', 'العراق'),
(18590, 1361037772, 1361037775, 'GB', 'GBR', 'المملكة المتحدة'),
(18591, 1361037776, 1361037783, 'NL', 'NLD', 'هولندا'),
(18592, 1361037784, 1361037819, 'IQ', 'IRQ', 'العراق'),
(18593, 1361037820, 1361037823, 'NL', 'NLD', 'هولندا'),
(18594, 1361037824, 1361037835, 'IQ', 'IRQ', 'العراق'),
(18595, 1361037836, 1361037839, 'ES', 'ESP', 'إسبانيا'),
(18596, 1361037840, 1361037847, 'IQ', 'IRQ', 'العراق'),
(18597, 1361037848, 1361037851, 'NL', 'NLD', 'هولندا'),
(18598, 1361037852, 1361037855, 'ES', 'ESP', 'إسبانيا'),
(18599, 1361037856, 1361037871, 'IQ', 'IRQ', 'العراق'),
(18600, 1361037872, 1361037875, 'ES', 'ESP', 'إسبانيا'),
(18601, 1361037876, 1361037879, 'NL', 'NLD', 'هولندا'),
(18602, 1361037880, 1361037883, 'PT', 'PRT', 'البورتوغال'),
(18603, 1361037884, 1361037891, 'IQ', 'IRQ', 'العراق'),
(18604, 1361037892, 1361037895, 'ES', 'ESP', 'إسبانيا'),
(18605, 1361037896, 1361037899, 'NL', 'NLD', 'هولندا'),
(18606, 1361037900, 1361037903, 'IQ', 'IRQ', 'العراق'),
(18607, 1361037904, 1361037907, 'NL', 'NLD', 'هولندا'),
(18608, 1361037908, 1361037911, 'US', 'USA', 'الولايات المتحدة'),
(18609, 1361037912, 1361038007, 'IQ', 'IRQ', 'العراق'),
(18610, 1361038008, 1361038015, 'NL', 'NLD', 'هولندا'),
(18611, 1361038016, 1361038023, 'IQ', 'IRQ', 'العراق'),
(18612, 1361038024, 1361038031, 'IT', 'ITA', 'إيطاليا'),
(18613, 1361038032, 1361038039, 'IQ', 'IRQ', 'العراق'),
(18614, 1361038040, 1361038047, 'US', 'USA', 'الولايات المتحدة'),
(18615, 1361038048, 1361038055, 'IQ', 'IRQ', 'العراق'),
(18616, 1361038056, 1361038071, 'NL', 'NLD', 'هولندا'),
(18617, 1361038072, 1361038087, 'IQ', 'IRQ', 'العراق'),
(18618, 1361038088, 1361038095, 'NL', 'NLD', 'هولندا'),
(18619, 1361038096, 1361038103, 'US', 'USA', 'الولايات المتحدة'),
(18620, 1361038104, 1361038119, 'IQ', 'IRQ', 'العراق'),
(18621, 1361038120, 1361038127, 'NL', 'NLD', 'هولندا'),
(18622, 1361038128, 1361038135, 'MA', 'MAR', 'المغرب'),
(18623, 1361038136, 1361038143, 'IQ', 'IRQ', 'العراق'),
(18624, 1361038144, 1361038147, 'NL', 'NLD', 'هولندا'),
(18625, 1361038148, 1361038159, 'GB', 'GBR', 'المملكة المتحدة'),
(18626, 1361038160, 1361038163, 'NL', 'NLD', 'هولندا'),
(18627, 1361038164, 1361038175, 'GB', 'GBR', 'المملكة المتحدة'),
(18628, 1361038176, 1361038179, 'NL', 'NLD', 'هولندا'),
(18629, 1361038180, 1361038191, 'GB', 'GBR', 'المملكة المتحدة'),
(18630, 1361038192, 1361038195, 'NL', 'NLD', 'هولندا'),
(18631, 1361038196, 1361038199, 'IQ', 'IRQ', 'العراق'),
(18632, 1361038200, 1361038211, 'GB', 'GBR', 'المملكة المتحدة'),
(18633, 1361038212, 1361038215, 'NL', 'NLD', 'هولندا'),
(18634, 1361038216, 1361038223, 'GB', 'GBR', 'المملكة المتحدة'),
(18635, 1361038224, 1361038231, 'IQ', 'IRQ', 'العراق'),
(18636, 1361038232, 1361038239, 'DE', 'DEU', 'ألمانيا'),
(18637, 1361038240, 1361038247, 'IQ', 'IRQ', 'العراق'),
(18638, 1361038248, 1361038271, 'US', 'USA', 'الولايات المتحدة'),
(18639, 1361038272, 1361038275, 'GB', 'GBR', 'المملكة المتحدة'),
(18640, 1361038276, 1361038279, 'NL', 'NLD', 'هولندا'),
(18641, 1361038280, 1361038287, 'GB', 'GBR', 'المملكة المتحدة'),
(18642, 1361038288, 1361038295, 'NL', 'NLD', 'هولندا'),
(18643, 1361038296, 1361038303, 'DE', 'DEU', 'ألمانيا'),
(18644, 1361038304, 1361038311, 'IQ', 'IRQ', 'العراق'),
(18645, 1361038312, 1361038319, 'NL', 'NLD', 'هولندا'),
(18646, 1361038320, 1361038335, 'US', 'USA', 'الولايات المتحدة'),
(18647, 1361038336, 1361039359, 'NL', 'NLD', 'هولندا'),
(18648, 1361039360, 1361043455, 'IT', 'ITA', 'إيطاليا'),
(18649, 1361043456, 1361051647, 'NO', 'NOR', 'النرويج'),
(18650, 1361051648, 1362100223, 'ES', 'ESP', 'إسبانيا'),
(18651, 1362100224, 1362395135, 'FR', 'FRA', 'فرنسا'),
(18652, 1362395136, 1362395183, 'CH', 'CHE', 'سويسرا'),
(18653, 1362395184, 1362395391, 'FR', 'FRA', 'فرنسا'),
(18654, 1362395392, 1362395519, 'SG', 'SGP', 'سنغافورة'),
(18655, 1362395520, 1362395647, 'FR', 'FRA', 'فرنسا'),
(18656, 1362395648, 1362396159, 'US', 'USA', 'الولايات المتحدة'),
(18657, 1362396160, 1362396415, 'FR', 'FRA', 'فرنسا'),
(18658, 1362396416, 1362396927, 'US', 'USA', 'الولايات المتحدة'),
(18659, 1362396928, 1362397183, 'CM', 'CMR', 'الكاميرون'),
(18660, 1362397184, 1362397255, 'GB', 'GBR', 'المملكة المتحدة'),
(18661, 1362397256, 1362398463, 'FR', 'FRA', 'فرنسا'),
(18662, 1362398464, 1362398719, 'DE', 'DEU', 'ألمانيا'),
(18663, 1362398720, 1362399231, 'FR', 'FRA', 'فرنسا'),
(18664, 1362399232, 1362399263, 'GB', 'GBR', 'المملكة المتحدة'),
(18665, 1362399264, 1362399487, 'FR', 'FRA', 'فرنسا'),
(18666, 1362399488, 1362400767, 'GB', 'GBR', 'المملكة المتحدة'),
(18667, 1362400768, 1362403583, 'FR', 'FRA', 'فرنسا'),
(18668, 1362403584, 1362405887, 'DZ', 'DZA', 'الجزائر'),
(18669, 1362405888, 1362406143, 'FR', 'FRA', 'فرنسا'),
(18670, 1362406144, 1362407167, 'SV', 'SLV', 'السلفادور'),
(18671, 1362407168, 1362411519, 'FR', 'FRA', 'فرنسا'),
(18672, 1362411520, 1362413273, 'MQ', 'MTQ', 'مارتينيك'),
(18673, 1362413274, 1362413567, 'FR', 'FRA', 'فرنسا'),
(18674, 1362413568, 1362413587, 'CM', 'CMR', 'الكاميرون'),
(18675, 1362413588, 1362414079, 'FR', 'FRA', 'فرنسا'),
(18676, 1362414080, 1362414847, 'US', 'USA', 'الولايات المتحدة'),
(18677, 1362414848, 1362415103, 'GB', 'GBR', 'المملكة المتحدة'),
(18678, 1362415104, 1362415359, 'FR', 'FRA', 'فرنسا'),
(18679, 1362415360, 1362415615, 'DE', 'DEU', 'ألمانيا'),
(18680, 1362415616, 1362417663, 'GP', 'GLP', 'جوادلوب'),
(18681, 1362417664, 1362419711, 'SG', 'SGP', 'سنغافورة'),
(18682, 1362419712, 1362423039, 'FR', 'FRA', 'فرنسا'),
(18683, 1362423040, 1362423167, 'SG', 'SGP', 'سنغافورة'),
(18684, 1362423168, 1362423263, 'FR', 'FRA', 'فرنسا'),
(18685, 1362423264, 1362423295, 'SG', 'SGP', 'سنغافورة'),
(18686, 1362423296, 1362423807, 'VE', 'VEN', 'فنزويلا'),
(18687, 1362423808, 1362425855, 'SG', 'SGP', 'سنغافورة'),
(18688, 1362425856, 1362426623, 'US', 'USA', 'الولايات المتحدة'),
(18689, 1362426624, 1362426879, 'FR', 'FRA', 'فرنسا'),
(18690, 1362426880, 1362427903, 'MQ', 'MTQ', 'مارتينيك'),
(18691, 1362427904, 1362755583, 'FR', 'FRA', 'فرنسا'),
(18692, 1362755584, 1362817055, 'NL', 'NLD', 'هولندا'),
(18693, 1362817056, 1362817063, 'BE', 'BEL', 'بلجيكا'),
(18694, 1362817064, 1362817071, 'NL', 'NLD', 'هولندا'),
(18695, 1362817072, 1362817087, 'BE', 'BEL', 'بلجيكا'),
(18696, 1362817088, 1362817111, 'NL', 'NLD', 'هولندا'),
(18697, 1362817112, 1362817119, 'BE', 'BEL', 'بلجيكا'),
(18698, 1362817120, 1362817127, 'NL', 'NLD', 'هولندا'),
(18699, 1362817128, 1362817135, 'BE', 'BEL', 'بلجيكا'),
(18700, 1362817136, 1362817311, 'NL', 'NLD', 'هولندا'),
(18701, 1362817312, 1362817343, 'BE', 'BEL', 'بلجيكا'),
(18702, 1362817344, 1362817563, 'NL', 'NLD', 'هولندا'),
(18703, 1362817564, 1362817567, 'BE', 'BEL', 'بلجيكا'),
(18704, 1362817568, 1362817743, 'NL', 'NLD', 'هولندا'),
(18705, 1362817744, 1362817791, 'BE', 'BEL', 'بلجيكا'),
(18706, 1362817792, 1362837503, 'NL', 'NLD', 'هولندا'),
(18707, 1362837504, 1362845695, 'BE', 'BEL', 'بلجيكا'),
(18708, 1362845696, 1362870271, 'NL', 'NLD', 'هولندا'),
(18709, 1362870272, 1362872319, 'BE', 'BEL', 'بلجيكا'),
(18710, 1362872320, 1362872335, 'NL', 'NLD', 'هولندا'),
(18711, 1362872336, 1362872343, 'BE', 'BEL', 'بلجيكا'),
(18712, 1362872344, 1362872351, 'NL', 'NLD', 'هولندا'),
(18713, 1362872352, 1362873855, 'BE', 'BEL', 'بلجيكا'),
(18714, 1362873856, 1362873863, 'NL', 'NLD', 'هولندا'),
(18715, 1362873864, 1362874367, 'BE', 'BEL', 'بلجيكا'),
(18716, 1362874368, 1362874375, 'NL', 'NLD', 'هولندا'),
(18717, 1362874376, 1362875903, 'BE', 'BEL', 'بلجيكا'),
(18718, 1362875904, 1362875907, 'NL', 'NLD', 'هولندا'),
(18719, 1362875908, 1362876423, 'BE', 'BEL', 'بلجيكا'),
(18720, 1362876424, 1362876591, 'NL', 'NLD', 'هولندا'),
(18721, 1362876592, 1362876607, 'BE', 'BEL', 'بلجيكا'),
(18722, 1362876608, 1362876639, 'NL', 'NLD', 'هولندا'),
(18723, 1362876640, 1362877955, 'BE', 'BEL', 'بلجيكا'),
(18724, 1362877956, 1362878019, 'NL', 'NLD', 'هولندا'),
(18725, 1362878020, 1362878463, 'BE', 'BEL', 'بلجيكا'),
(18726, 1362878464, 1362878479, 'NL', 'NLD', 'هولندا'),
(18727, 1362878480, 1362879999, 'BE', 'BEL', 'بلجيكا'),
(18728, 1362880000, 1362880007, 'NL', 'NLD', 'هولندا'),
(18729, 1362880008, 1362880511, 'BE', 'BEL', 'بلجيكا'),
(18730, 1362880512, 1362880727, 'NL', 'NLD', 'هولندا'),
(18731, 1362880728, 1362880735, 'BE', 'BEL', 'بلجيكا'),
(18732, 1362880736, 1362880895, 'NL', 'NLD', 'هولندا'),
(18733, 1362880896, 1362880959, 'BE', 'BEL', 'بلجيكا'),
(18734, 1362880960, 1362880967, 'NL', 'NLD', 'هولندا'),
(18735, 1362880968, 1362880975, 'BE', 'BEL', 'بلجيكا'),
(18736, 1362880976, 1362881023, 'NL', 'NLD', 'هولندا'),
(18737, 1362881024, 1362881055, 'BE', 'BEL', 'بلجيكا'),
(18738, 1362881056, 1362881111, 'NL', 'NLD', 'هولندا'),
(18739, 1362881112, 1362882047, 'BE', 'BEL', 'بلجيكا'),
(18740, 1362882048, 1362882143, 'NL', 'NLD', 'هولندا'),
(18741, 1362882144, 1362882147, 'BE', 'BEL', 'بلجيكا'),
(18742, 1362882148, 1362882207, 'NL', 'NLD', 'هولندا'),
(18743, 1362882208, 1362882211, 'BE', 'BEL', 'بلجيكا'),
(18744, 1362882212, 1362882231, 'NL', 'NLD', 'هولندا'),
(18745, 1362882232, 1362884095, 'BE', 'BEL', 'بلجيكا'),
(18746, 1362884096, 1362884099, 'NL', 'NLD', 'هولندا'),
(18747, 1362884100, 1362885119, 'BE', 'BEL', 'بلجيكا'),
(18748, 1362885120, 1362886399, 'NL', 'NLD', 'هولندا'),
(18749, 1362886400, 1362886400, 'BE', 'BEL', 'بلجيكا'),
(18750, 1362886401, 1362886409, 'NL', 'NLD', 'هولندا'),
(18751, 1362886410, 1362886413, 'BE', 'BEL', 'بلجيكا'),
(18752, 1362886414, 1362886416, 'NL', 'NLD', 'هولندا'),
(18753, 1362886417, 1362886419, 'BE', 'BEL', 'بلجيكا'),
(18754, 1362886420, 1362886421, 'NL', 'NLD', 'هولندا'),
(18755, 1362886422, 1362886422, 'BE', 'BEL', 'بلجيكا'),
(18756, 1362886423, 1362886423, 'NL', 'NLD', 'هولندا'),
(18757, 1362886424, 1362886655, 'BE', 'BEL', 'بلجيكا'),
(18758, 1362886656, 1363017727, 'ES', 'ESP', 'إسبانيا'),
(18759, 1363017728, 1363148799, 'CH', 'CHE', 'سويسرا'),
(18760, 1363148800, 1363410943, 'FR', 'FRA', 'فرنسا'),
(18761, 1363410944, 1363673087, 'NL', 'NLD', 'هولندا'),
(18762, 1363673088, 1363935231, 'IT', 'ITA', 'إيطاليا'),
(18763, 1363935232, 1364197375, 'GB', 'GBR', 'المملكة المتحدة'),
(18764, 1364197376, 1364204034, 'FR', 'FRA', 'فرنسا'),
(18765, 1364204035, 1364204035, 'GB', 'GBR', 'المملكة المتحدة'),
(18766, 1364204036, 1364262911, 'FR', 'FRA', 'فرنسا'),
(18767, 1364262912, 1364328447, 'IT', 'ITA', 'إيطاليا'),
(18768, 1364328448, 1364459519, 'BE', 'BEL', 'بلجيكا'),
(18769, 1364459520, 1364525055, 'PT', 'PRT', 'البورتوغال'),
(18770, 1364525056, 1364526335, 'NL', 'NLD', 'هولندا'),
(18771, 1364526336, 1364526591, 'US', 'USA', 'الولايات المتحدة'),
(18772, 1364526592, 1364528639, 'GB', 'GBR', 'المملكة المتحدة'),
(18773, 1364528640, 1364528895, 'UA', 'UKR', 'أوكرانيا'),
(18774, 1364528896, 1364530175, 'GB', 'GBR', 'المملكة المتحدة'),
(18775, 1364530176, 1364539903, 'NL', 'NLD', 'هولندا'),
(18776, 1364539904, 1364540159, 'US', 'USA', 'الولايات المتحدة'),
(18777, 1364540160, 1364540671, 'NL', 'NLD', 'هولندا'),
(18778, 1364540672, 1364540927, 'US', 'USA', 'الولايات المتحدة'),
(18779, 1364540928, 1364577023, 'NL', 'NLD', 'هولندا'),
(18780, 1364577024, 1364577279, 'GB', 'GBR', 'المملكة المتحدة'),
(18781, 1364577280, 1364577791, 'NL', 'NLD', 'هولندا'),
(18782, 1364577792, 1364578303, 'GB', 'GBR', 'المملكة المتحدة'),
(18783, 1364578304, 1364581375, 'NL', 'NLD', 'هولندا'),
(18784, 1364581376, 1364582399, 'LY', 'LBY', 'ليبيا'),
(18785, 1364582400, 1364582415, 'NL', 'NLD', 'هولندا'),
(18786, 1364582416, 1364582431, 'LB', 'LBN', 'لبنان'),
(18787, 1364582432, 1364585983, 'NL', 'NLD', 'هولندا'),
(18788, 1364585984, 1364586240, 'LB', 'LBN', 'لبنان'),
(18789, 1364586241, 1364586495, 'NL', 'NLD', 'هولندا'),
(18790, 1364586496, 1364586752, 'LB', 'LBN', 'لبنان'),
(18791, 1364586753, 1364590591, 'NL', 'NLD', 'هولندا'),
(18792, 1364590592, 1364721663, 'GB', 'GBR', 'المملكة المتحدة'),
(18793, 1364721664, 1364725759, 'SE', 'SWE', 'السويد'),
(18794, 1364725760, 1364733951, 'DE', 'DEU', 'ألمانيا'),
(18795, 1364733952, 1364738047, 'IT', 'ITA', 'إيطاليا'),
(18796, 1364738048, 1364742143, 'NO', 'NOR', 'النرويج'),
(18797, 1364742144, 1364746239, 'RU', 'RUS', 'الإتحاد الروسي'),
(18798, 1364746240, 1364749311, 'FR', 'FRA', 'فرنسا'),
(18799, 1364749312, 1364749374, 'BE', 'BEL', 'بلجيكا'),
(18800, 1364749375, 1364749455, 'FR', 'FRA', 'فرنسا'),
(18801, 1364749456, 1364749463, 'BE', 'BEL', 'بلجيكا'),
(18802, 1364749464, 1364749471, 'FR', 'FRA', 'فرنسا'),
(18803, 1364749472, 1364749583, 'BE', 'BEL', 'بلجيكا'),
(18804, 1364749584, 1364749599, 'FR', 'FRA', 'فرنسا'),
(18805, 1364749600, 1364749696, 'BE', 'BEL', 'بلجيكا'),
(18806, 1364749697, 1364749823, 'FR', 'FRA', 'فرنسا'),
(18807, 1364749824, 1364750079, 'BE', 'BEL', 'بلجيكا'),
(18808, 1364750080, 1364750335, 'FR', 'FRA', 'فرنسا'),
(18809, 1364750336, 1364754431, 'RU', 'RUS', 'الإتحاد الروسي'),
(18810, 1364754432, 1364758527, 'SK', 'SVK', 'سلوفاكيا'),
(18811, 1364758528, 1364762623, 'KZ', 'KAZ', 'كازاخستان'),
(18812, 1364762624, 1364766719, 'GB', 'GBR', 'المملكة المتحدة'),
(18813, 1364766720, 1364770815, 'CH', 'CHE', 'سويسرا'),
(18814, 1364770816, 1364774911, 'KG', 'KGZ', 'قيرغيزستان'),
(18815, 1364774912, 1364779007, 'RU', 'RUS', 'الإتحاد الروسي'),
(18816, 1364779008, 1364787199, 'IT', 'ITA', 'إيطاليا'),
(18817, 1364787200, 1364795391, 'RO', 'ROM', 'رومانيا'),
(18818, 1364795392, 1364799487, 'ES', 'ESP', 'إسبانيا'),
(18819, 1364799488, 1364803583, 'SK', 'SVK', 'سلوفاكيا'),
(18820, 1364803584, 1364811775, 'RU', 'RUS', 'الإتحاد الروسي'),
(18821, 1364811776, 1364811807, 'LU', 'LUX', 'لوكسيمبورغ'),
(18822, 1364811808, 1364815871, 'DE', 'DEU', 'ألمانيا'),
(18823, 1364815872, 1364819967, 'RU', 'RUS', 'الإتحاد الروسي'),
(18824, 1364819968, 1364824063, 'GB', 'GBR', 'المملكة المتحدة'),
(18825, 1364824064, 1364828159, 'SE', 'SWE', 'السويد'),
(18826, 1364828160, 1364829439, 'GB', 'GBR', 'المملكة المتحدة'),
(18827, 1364829440, 1364829487, 'FR', 'FRA', 'فرنسا'),
(18828, 1364829488, 1364829503, 'GB', 'GBR', 'المملكة المتحدة'),
(18829, 1364829504, 1364829527, 'FR', 'FRA', 'فرنسا'),
(18830, 1364829528, 1364832255, 'GB', 'GBR', 'المملكة المتحدة'),
(18831, 1364832256, 1364836351, 'RU', 'RUS', 'الإتحاد الروسي'),
(18832, 1364836352, 1364840447, 'DE', 'DEU', 'ألمانيا'),
(18833, 1364840448, 1364844543, 'AM', 'ARM', 'أرمينيا'),
(18834, 1364844544, 1364852111, 'DE', 'DEU', 'ألمانيا'),
(18835, 1364852112, 1364852127, 'GB', 'GBR', 'المملكة المتحدة'),
(18836, 1364852128, 1364852479, 'DE', 'DEU', 'ألمانيا'),
(18837, 1364852480, 1364852735, 'GB', 'GBR', 'المملكة المتحدة'),
(18838, 1364852736, 1364856831, 'RU', 'RUS', 'الإتحاد الروسي'),
(18839, 1364856832, 1364860927, 'IQ', 'IRQ', 'العراق'),
(18840, 1364860928, 1364865023, 'DE', 'DEU', 'ألمانيا'),
(18841, 1364865024, 1364869119, 'PT', 'PRT', 'البورتوغال'),
(18842, 1364869120, 1364873215, 'FI', 'FIN', 'فنلندا'),
(18843, 1364873216, 1364877311, 'GB', 'GBR', 'المملكة المتحدة'),
(18844, 1364877312, 1364881407, 'ES', 'ESP', 'إسبانيا'),
(18845, 1364881408, 1364885503, 'EE', 'EST', 'إستونيا'),
(18846, 1364885504, 1364889599, 'GB', 'GBR', 'المملكة المتحدة'),
(18847, 1364889600, 1364893695, 'IR', 'IRN', 'إيران'),
(18848, 1364893696, 1364897791, 'CZ', 'CZE', 'التشيك'),
(18849, 1364897792, 1364901887, 'SI', 'SVN', 'سلوفينيا'),
(18850, 1364901888, 1364905983, 'DE', 'DEU', 'ألمانيا'),
(18851, 1364905984, 1364910079, 'RU', 'RUS', 'الإتحاد الروسي'),
(18852, 1364910080, 1364914175, 'UA', 'UKR', 'أوكرانيا'),
(18853, 1364914176, 1364918271, 'CZ', 'CZE', 'التشيك'),
(18854, 1364922368, 1364926463, 'TR', 'TUR', 'تركيا'),
(18855, 1364926464, 1364934655, 'RU', 'RUS', 'الإتحاد الروسي'),
(18856, 1364934656, 1364938751, 'FR', 'FRA', 'فرنسا'),
(18857, 1364938752, 1364942847, 'CZ', 'CZE', 'التشيك'),
(18858, 1364942848, 1364946943, 'GB', 'GBR', 'المملكة المتحدة'),
(18859, 1364946944, 1364947167, 'TR', 'TUR', 'تركيا'),
(18860, 1364947168, 1364947199, 'US', 'USA', 'الولايات المتحدة'),
(18861, 1364947200, 1364948479, 'GB', 'GBR', 'المملكة المتحدة'),
(18862, 1364948480, 1364949247, 'TR', 'TUR', 'تركيا'),
(18863, 1364949248, 1364949503, 'CY', 'CYP', 'قبرص'),
(18864, 1364949504, 1364949759, 'TR', 'TUR', 'تركيا'),
(18865, 1364949760, 1364950015, 'CY', 'CYP', 'قبرص'),
(18866, 1364950016, 1364950527, 'TR', 'TUR', 'تركيا'),
(18867, 1364950528, 1364950783, 'CY', 'CYP', 'قبرص'),
(18868, 1364950784, 1364950847, 'TR', 'TUR', 'تركيا'),
(18869, 1364950848, 1364950911, 'GB', 'GBR', 'المملكة المتحدة'),
(18870, 1364950912, 1364951039, 'TR', 'TUR', 'تركيا'),
(18871, 1364951040, 1364959231, 'IR', 'IRN', 'إيران'),
(18872, 1364959232, 1364963327, 'DE', 'DEU', 'ألمانيا'),
(18873, 1364963328, 1364967423, 'RU', 'RUS', 'الإتحاد الروسي'),
(18874, 1364967424, 1364969983, 'GB', 'GBR', 'المملكة المتحدة'),
(18875, 1364969984, 1364970239, 'FR', 'FRA', 'فرنسا'),
(18876, 1364970240, 1364971519, 'GB', 'GBR', 'المملكة المتحدة'),
(18877, 1364971520, 1364975615, 'CZ', 'CZE', 'التشيك'),
(18878, 1364979712, 1364983807, 'GB', 'GBR', 'المملكة المتحدة'),
(18879, 1364983808, 1364991999, 'DE', 'DEU', 'ألمانيا'),
(18880, 1364992000, 1364996095, 'IT', 'ITA', 'إيطاليا'),
(18881, 1364996096, 1365000191, 'GR', 'GRC', 'اليونان'),
(18882, 1365000192, 1365002431, 'SE', 'SWE', 'السويد'),
(18883, 1365002432, 1365002447, 'GB', 'GBR', 'المملكة المتحدة'),
(18884, 1365002448, 1365002751, 'SE', 'SWE', 'السويد'),
(18885, 1365002752, 1365003263, 'GB', 'GBR', 'المملكة المتحدة'),
(18886, 1365003264, 1365003903, 'SE', 'SWE', 'السويد'),
(18887, 1365003904, 1365004035, 'GB', 'GBR', 'المملكة المتحدة'),
(18888, 1365004036, 1365004039, 'SE', 'SWE', 'السويد'),
(18889, 1365004040, 1365004047, 'GB', 'GBR', 'المملكة المتحدة'),
(18890, 1365004048, 1365004063, 'SE', 'SWE', 'السويد'),
(18891, 1365004064, 1365004287, 'GB', 'GBR', 'المملكة المتحدة'),
(18892, 1365004288, 1365008383, 'FR', 'FRA', 'فرنسا'),
(18893, 1365008384, 1365012479, 'CH', 'CHE', 'سويسرا'),
(18894, 1365012480, 1365016575, 'FR', 'FRA', 'فرنسا'),
(18895, 1365016576, 1365020671, 'ES', 'ESP', 'إسبانيا'),
(18896, 1365020672, 1365024767, 'CZ', 'CZE', 'التشيك'),
(18897, 1365024768, 1365027839, 'DE', 'DEU', 'ألمانيا'),
(18898, 1365027840, 1365027871, 'US', 'USA', 'الولايات المتحدة'),
(18899, 1365027872, 1365028863, 'DE', 'DEU', 'ألمانيا'),
(18900, 1365028864, 1365032959, 'NL', 'NLD', 'هولندا'),
(18901, 1365032960, 1365041151, 'PT', 'PRT', 'البورتوغال'),
(18902, 1365041152, 1365041407, 'IQ', 'IRQ', 'العراق'),
(18903, 1365041408, 1365041663, 'LU', 'LUX', 'لوكسيمبورغ'),
(18904, 1365041664, 1365041695, 'FR', 'FRA', 'فرنسا'),
(18905, 1365041696, 1365041727, 'GB', 'GBR', 'المملكة المتحدة'),
(18906, 1365041728, 1365042047, 'LU', 'LUX', 'لوكسيمبورغ'),
(18907, 1365042048, 1365042055, 'GB', 'GBR', 'المملكة المتحدة'),
(18908, 1365042056, 1365044895, 'LU', 'LUX', 'لوكسيمبورغ'),
(18909, 1365044896, 1365044903, 'FR', 'FRA', 'فرنسا'),
(18910, 1365044904, 1365045247, 'LU', 'LUX', 'لوكسيمبورغ'),
(18911, 1365045248, 1365045535, 'AT', 'AUT', 'النمسا'),
(18912, 1365045536, 1365045543, 'BA', 'BIH', 'البوسنه والهرسك'),
(18913, 1365045544, 1365045551, 'BG', 'BGR', 'بلغاريا'),
(18914, 1365045552, 1365045559, 'DE', 'DEU', 'ألمانيا'),
(18915, 1365045560, 1365045567, 'GB', 'GBR', 'المملكة المتحدة'),
(18916, 1365045568, 1365045575, 'HR', 'HRV', 'كرواتيا'),
(18917, 1365045576, 1365045583, 'AT', 'AUT', 'النمسا'),
(18918, 1365045584, 1365045591, 'PL', 'POL', 'بولندا'),
(18919, 1365045592, 1365045599, 'RO', 'ROM', 'رومانيا'),
(18920, 1365045600, 1365045607, 'RU', 'RUS', 'الإتحاد الروسي'),
(18921, 1365045608, 1365045615, 'RS', 'SRB', 'صربيا'),
(18922, 1365045616, 1365045623, 'SI', 'SVN', 'سلوفينيا'),
(18923, 1365045624, 1365045631, 'SK', 'SVK', 'سلوفاكيا'),
(18924, 1365045632, 1365045639, 'CZ', 'CZE', 'التشيك'),
(18925, 1365045640, 1365045647, 'UA', 'UKR', 'أوكرانيا'),
(18926, 1365045648, 1365045663, 'HU', 'HUN', 'هنغاريا'),
(18927, 1365045664, 1365047295, 'AT', 'AUT', 'النمسا'),
(18928, 1365047296, 1365047423, 'SK', 'SVK', 'سلوفاكيا'),
(18929, 1365047424, 1365047551, 'AT', 'AUT', 'النمسا'),
(18930, 1365047552, 1365047647, 'SK', 'SVK', 'سلوفاكيا'),
(18931, 1365047648, 1365047679, 'AT', 'AUT', 'النمسا'),
(18932, 1365047680, 1365047807, 'SK', 'SVK', 'سلوفاكيا'),
(18933, 1365047808, 1365047871, 'AT', 'AUT', 'النمسا'),
(18934, 1365047872, 1365047903, 'SK', 'SVK', 'سلوفاكيا'),
(18935, 1365047904, 1365047999, 'AT', 'AUT', 'النمسا'),
(18936, 1365048000, 1365048191, 'SK', 'SVK', 'سلوفاكيا'),
(18937, 1365048192, 1365048255, 'AT', 'AUT', 'النمسا'),
(18938, 1365048256, 1365048383, 'SK', 'SVK', 'سلوفاكيا'),
(18939, 1365048384, 1365048511, 'AT', 'AUT', 'النمسا'),
(18940, 1365048512, 1365048607, 'SK', 'SVK', 'سلوفاكيا'),
(18941, 1365048608, 1365048703, 'AT', 'AUT', 'النمسا'),
(18942, 1365048704, 1365048887, 'SK', 'SVK', 'سلوفاكيا'),
(18943, 1365048888, 1365048895, 'AT', 'AUT', 'النمسا'),
(18944, 1365048896, 1365048927, 'SK', 'SVK', 'سلوفاكيا'),
(18945, 1365048928, 1365049343, 'AT', 'AUT', 'النمسا'),
(18946, 1365049344, 1365057535, 'FR', 'FRA', 'فرنسا'),
(18947, 1365057536, 1365061631, 'IT', 'ITA', 'إيطاليا'),
(18948, 1365061632, 1365065727, 'NL', 'NLD', 'هولندا'),
(18949, 1365065728, 1365073919, 'BA', 'BIH', 'البوسنه والهرسك'),
(18950, 1365073920, 1365078015, 'NO', 'NOR', 'النرويج'),
(18951, 1365078016, 1365082111, 'DE', 'DEU', 'ألمانيا'),
(18952, 1365082112, 1365090303, 'SE', 'SWE', 'السويد'),
(18953, 1365090304, 1365094399, 'NO', 'NOR', 'النرويج'),
(18954, 1365094400, 1365095087, 'FR', 'FRA', 'فرنسا'),
(18955, 1365095088, 1365095095, 'GB', 'GBR', 'المملكة المتحدة'),
(18956, 1365095096, 1365095575, 'FR', 'FRA', 'فرنسا'),
(18957, 1365095576, 1365095583, 'GB', 'GBR', 'المملكة المتحدة'),
(18958, 1365095584, 1365096703, 'FR', 'FRA', 'فرنسا'),
(18959, 1365096704, 1365096711, 'GB', 'GBR', 'المملكة المتحدة'),
(18960, 1365096712, 1365096735, 'FR', 'FRA', 'فرنسا'),
(18961, 1365096736, 1365096767, 'IT', 'ITA', 'إيطاليا'),
(18962, 1365096768, 1365097215, 'FR', 'FRA', 'فرنسا'),
(18963, 1365097216, 1365097471, 'ES', 'ESP', 'إسبانيا'),
(18964, 1365097472, 1365097727, 'FR', 'FRA', 'فرنسا'),
(18965, 1365097728, 1365097983, 'CH', 'CHE', 'سويسرا'),
(18966, 1365097984, 1365098495, 'FR', 'FRA', 'فرنسا'),
(18967, 1365098496, 1365102591, 'HU', 'HUN', 'هنغاريا'),
(18968, 1365102592, 1365102911, 'ES', 'ESP', 'إسبانيا'),
(18969, 1365102912, 1365102919, 'GB', 'GBR', 'المملكة المتحدة'),
(18970, 1365102920, 1365103383, 'ES', 'ESP', 'إسبانيا'),
(18971, 1365103384, 1365103391, 'GB', 'GBR', 'المملكة المتحدة'),
(18972, 1365103392, 1365103479, 'ES', 'ESP', 'إسبانيا'),
(18973, 1365103480, 1365103487, 'GB', 'GBR', 'المملكة المتحدة'),
(18974, 1365103488, 1365103519, 'ES', 'ESP', 'إسبانيا'),
(18975, 1365103520, 1365103551, 'GB', 'GBR', 'المملكة المتحدة'),
(18976, 1365103552, 1365103679, 'ES', 'ESP', 'إسبانيا'),
(18977, 1365103680, 1365103743, 'GB', 'GBR', 'المملكة المتحدة'),
(18978, 1365103744, 1365103775, 'ES', 'ESP', 'إسبانيا'),
(18979, 1365103776, 1365103791, 'GB', 'GBR', 'المملكة المتحدة'),
(18980, 1365103792, 1365103871, 'ES', 'ESP', 'إسبانيا'),
(18981, 1365103872, 1365104135, 'GB', 'GBR', 'المملكة المتحدة'),
(18982, 1365104136, 1365104199, 'ES', 'ESP', 'إسبانيا'),
(18983, 1365104200, 1365104207, 'GB', 'GBR', 'المملكة المتحدة'),
(18984, 1365104208, 1365106687, 'ES', 'ESP', 'إسبانيا'),
(18985, 1365106688, 1365110783, 'GB', 'GBR', 'المملكة المتحدة'),
(18986, 1365110784, 1365114879, 'FR', 'FRA', 'فرنسا'),
(18987, 1365114880, 1365118975, 'BA', 'BIH', 'البوسنه والهرسك'),
(18988, 1365118976, 1365127167, 'RU', 'RUS', 'الإتحاد الروسي'),
(18989, 1365127168, 1365130271, 'AT', 'AUT', 'النمسا'),
(18990, 1365130272, 1365130303, 'IT', 'ITA', 'إيطاليا'),
(18991, 1365130304, 1365130495, 'AT', 'AUT', 'النمسا'),
(18992, 1365130496, 1365131007, 'IT', 'ITA', 'إيطاليا'),
(18993, 1365131008, 1365131263, 'AT', 'AUT', 'النمسا'),
(18994, 1365131264, 1365139455, 'SE', 'SWE', 'السويد'),
(18995, 1365139456, 1365147647, 'CH', 'CHE', 'سويسرا'),
(18996, 1365147648, 1365155839, 'RU', 'RUS', 'الإتحاد الروسي'),
(18997, 1365155840, 1365159935, 'SE', 'SWE', 'السويد'),
(18998, 1365159936, 1365164031, 'HU', 'HUN', 'هنغاريا'),
(18999, 1365164032, 1365166255, 'GB', 'GBR', 'المملكة المتحدة'),
(19000, 1365166256, 1365166271, 'IE', 'IRL', 'إيرلندا'),
(19001, 1365166272, 1365172223, 'GB', 'GBR', 'المملكة المتحدة'),
(19002, 1365172224, 1365176319, 'LV', 'LVA', 'لاتفيا'),
(19003, 1365176320, 1365180415, 'HU', 'HUN', 'هنغاريا'),
(19004, 1365180416, 1365183231, 'DE', 'DEU', 'ألمانيا'),
(19005, 1365183232, 1365183295, 'SC', 'SYC', 'سيشيل'),
(19006, 1365183296, 1365184511, 'DE', 'DEU', 'ألمانيا'),
(19007, 1365184512, 1365192703, 'RU', 'RUS', 'الإتحاد الروسي'),
(19008, 1365192704, 1365196799, 'GB', 'GBR', 'المملكة المتحدة'),
(19009, 1365196800, 1365200895, 'ES', 'ESP', 'إسبانيا'),
(19010, 1365200896, 1365204991, 'IQ', 'IRQ', 'العراق'),
(19011, 1365204992, 1365209087, 'CZ', 'CZE', 'التشيك'),
(19012, 1365209088, 1365213183, 'BE', 'BEL', 'بلجيكا'),
(19013, 1365213184, 1365217279, 'RU', 'RUS', 'الإتحاد الروسي'),
(19014, 1365217280, 1365220391, 'GB', 'GBR', 'المملكة المتحدة'),
(19015, 1365220392, 1365220399, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(19016, 1365220400, 1365220471, 'GB', 'GBR', 'المملكة المتحدة'),
(19017, 1365220472, 1365220479, 'US', 'USA', 'الولايات المتحدة'),
(19018, 1365220480, 1365220487, 'AU', 'AUS', 'أستراليا'),
(19019, 1365220488, 1365220495, 'GB', 'GBR', 'المملكة المتحدة'),
(19020, 1365220496, 1365220503, 'US', 'USA', 'الولايات المتحدة'),
(19021, 1365220504, 1365220511, 'GB', 'GBR', 'المملكة المتحدة'),
(19022, 1365220512, 1365220519, 'US', 'USA', 'الولايات المتحدة'),
(19023, 1365220520, 1365220527, 'GB', 'GBR', 'المملكة المتحدة'),
(19024, 1365220528, 1365220535, 'IS', 'ISL', 'أيسلندا'),
(19025, 1365220536, 1365220551, 'GB', 'GBR', 'المملكة المتحدة'),
(19026, 1365220552, 1365220567, 'IS', 'ISL', 'أيسلندا'),
(19027, 1365220568, 1365220575, 'GB', 'GBR', 'المملكة المتحدة'),
(19028, 1365220576, 1365220583, 'CH', 'CHE', 'سويسرا'),
(19029, 1365220584, 1365220599, 'TR', 'TUR', 'تركيا'),
(19030, 1365220600, 1365220607, 'GR', 'GRC', 'اليونان'),
(19031, 1365220608, 1365220615, 'TR', 'TUR', 'تركيا'),
(19032, 1365220616, 1365220623, 'GB', 'GBR', 'المملكة المتحدة'),
(19033, 1365220624, 1365220631, 'US', 'USA', 'الولايات المتحدة'),
(19034, 1365220632, 1365220663, 'GB', 'GBR', 'المملكة المتحدة'),
(19035, 1365220664, 1365220679, 'US', 'USA', 'الولايات المتحدة'),
(19036, 1365220680, 1365220687, 'IT', 'ITA', 'إيطاليا'),
(19037, 1365220688, 1365220703, 'US', 'USA', 'الولايات المتحدة'),
(19038, 1365220704, 1365220719, 'GB', 'GBR', 'المملكة المتحدة'),
(19039, 1365220720, 1365220727, 'US', 'USA', 'الولايات المتحدة'),
(19040, 1365220728, 1365220735, 'GB', 'GBR', 'المملكة المتحدة'),
(19041, 1365220736, 1365220743, 'US', 'USA', 'الولايات المتحدة'),
(19042, 1365220744, 1365220767, 'GB', 'GBR', 'المملكة المتحدة'),
(19043, 1365220768, 1365220775, 'GR', 'GRC', 'اليونان'),
(19044, 1365220776, 1365220783, 'JO', 'JOR', 'الأردن'),
(19045, 1365220784, 1365220791, 'IN', 'IND', 'الهند'),
(19046, 1365220792, 1365220799, 'KW', 'KWT', 'الكويت'),
(19047, 1365220800, 1365220807, 'RU', 'RUS', 'الإتحاد الروسي'),
(19048, 1365220808, 1365220815, 'GB', 'GBR', 'المملكة المتحدة'),
(19049, 1365220816, 1365220823, 'IN', 'IND', 'الهند'),
(19050, 1365220824, 1365220831, 'GB', 'GBR', 'المملكة المتحدة'),
(19051, 1365220832, 1365220839, 'IT', 'ITA', 'إيطاليا'),
(19052, 1365220840, 1365220847, 'GB', 'GBR', 'المملكة المتحدة'),
(19053, 1365220848, 1365220855, 'AU', 'AUS', 'أستراليا'),
(19054, 1365220856, 1365220863, 'US', 'USA', 'الولايات المتحدة'),
(19055, 1365220864, 1365220895, 'GB', 'GBR', 'المملكة المتحدة'),
(19056, 1365220896, 1365220903, 'GR', 'GRC', 'اليونان'),
(19057, 1365220904, 1365221375, 'GB', 'GBR', 'المملكة المتحدة'),
(19058, 1365221376, 1365225471, 'GE', 'GEO', 'جورجيا'),
(19059, 1365225472, 1365229567, 'UA', 'UKR', 'أوكرانيا'),
(19060, 1365229568, 1365231103, 'PL', 'POL', 'بولندا'),
(19061, 1365231104, 1365231359, 'NL', 'NLD', 'هولندا'),
(19062, 1365231360, 1365233151, 'PL', 'POL', 'بولندا'),
(19063, 1365233152, 1365233279, 'NL', 'NLD', 'هولندا'),
(19064, 1365233280, 1365233375, 'PL', 'POL', 'بولندا'),
(19065, 1365233376, 1365233391, 'NL', 'NLD', 'هولندا'),
(19066, 1365233392, 1365233631, 'PL', 'POL', 'بولندا'),
(19067, 1365233632, 1365233647, 'NL', 'NLD', 'هولندا'),
(19068, 1365233648, 1365233663, 'PL', 'POL', 'بولندا'),
(19069, 1365233664, 1365237759, 'RU', 'RUS', 'الإتحاد الروسي'),
(19070, 1365237760, 1365241855, 'UZ', 'UZB', 'أوزباكستان'),
(19071, 1365241856, 1365245951, 'DK', 'DNK', 'الدنيمارك'),
(19072, 1365245952, 1366294527, 'GB', 'GBR', 'المملكة المتحدة'),
(19073, 1366294528, 1367343103, 'IT', 'ITA', 'إيطاليا'),
(19074, 1367343104, 1369440255, 'GB', 'GBR', 'المملكة المتحدة'),
(19075, 1369440256, 1369473023, 'DE', 'DEU', 'ألمانيا'),
(19076, 1369473024, 1369505791, 'HU', 'HUN', 'هنغاريا'),
(19077, 1369505792, 1369538559, 'DE', 'DEU', 'ألمانيا'),
(19078, 1369538560, 1369554943, 'DK', 'DNK', 'الدنيمارك'),
(19079, 1369554944, 1369559039, 'PL', 'POL', 'بولندا'),
(19080, 1369559040, 1369563135, 'RU', 'RUS', 'الإتحاد الروسي'),
(19081, 1369563136, 1369567231, 'PL', 'POL', 'بولندا'),
(19082, 1369567232, 1369571327, 'BG', 'BGR', 'بلغاريا'),
(19083, 1369702400, 1369833471, 'BE', 'BEL', 'بلجيكا'),
(19084, 1369833472, 1369964543, 'NO', 'NOR', 'النرويج'),
(19085, 1369964544, 1369997311, 'GB', 'GBR', 'المملكة المتحدة'),
(19086, 1369997312, 1370030079, 'PL', 'POL', 'بولندا'),
(19087, 1370030080, 1370062847, 'BE', 'BEL', 'بلجيكا'),
(19088, 1370062848, 1370095615, 'DE', 'DEU', 'ألمانيا'),
(19089, 1370095616, 1370128383, 'GB', 'GBR', 'المملكة المتحدة'),
(19090, 1370128384, 1370161151, 'SE', 'SWE', 'السويد'),
(19091, 1370161152, 1370187775, 'NL', 'NLD', 'هولندا'),
(19092, 1370187776, 1370188031, 'GR', 'GRC', 'اليونان'),
(19093, 1370188032, 1370193919, 'NL', 'NLD', 'هولندا'),
(19094, 1370193920, 1370226687, 'GB', 'GBR', 'المملكة المتحدة'),
(19095, 1370226688, 1370259455, 'ES', 'ESP', 'إسبانيا'),
(19096, 1370259456, 1370292223, 'SE', 'SWE', 'السويد'),
(19097, 1370292224, 1370299903, 'NL', 'NLD', 'هولندا'),
(19098, 1370299904, 1370300159, 'US', 'USA', 'الولايات المتحدة'),
(19099, 1370300160, 1370324991, 'NL', 'NLD', 'هولندا'),
(19100, 1370324992, 1370357759, 'DE', 'DEU', 'ألمانيا'),
(19101, 1370357760, 1370390527, 'IT', 'ITA', 'إيطاليا'),
(19102, 1370390528, 1370423295, 'GB', 'GBR', 'المملكة المتحدة'),
(19103, 1370423296, 1370439679, 'NO', 'NOR', 'النرويج'),
(19104, 1370439680, 1370456063, 'NL', 'NLD', 'هولندا'),
(19105, 1370456064, 1370488831, 'FI', 'FIN', 'فنلندا'),
(19106, 1370488832, 1370505855, 'RU', 'RUS', 'الإتحاد الروسي'),
(19107, 1370505856, 1370505871, 'CY', 'CYP', 'قبرص'),
(19108, 1370505872, 1370508895, 'RU', 'RUS', 'الإتحاد الروسي'),
(19109, 1370508896, 1370508911, 'CY', 'CYP', 'قبرص'),
(19110, 1370508912, 1370555887, 'RU', 'RUS', 'الإتحاد الروسي'),
(19111, 1370555888, 1370555903, 'CY', 'CYP', 'قبرص'),
(19112, 1370555904, 1370563967, 'RU', 'RUS', 'الإتحاد الروسي'),
(19113, 1370563968, 1370564031, 'US', 'USA', 'الولايات المتحدة'),
(19114, 1370564032, 1370619903, 'RU', 'RUS', 'الإتحاد الروسي'),
(19115, 1370619904, 1370750975, 'GB', 'GBR', 'المملكة المتحدة'),
(19116, 1370750976, 1370767359, 'RO', 'ROM', 'رومانيا'),
(19117, 1370767360, 1370771455, 'MD', 'MDA', 'مولدوفا'),
(19118, 1370771456, 1370772479, 'RO', 'ROM', 'رومانيا'),
(19119, 1370772480, 1370772991, 'MD', 'MDA', 'مولدوفا'),
(19120, 1370772992, 1370882047, 'RO', 'ROM', 'رومانيا'),
(19121, 1370882048, 1371013119, 'HU', 'HUN', 'هنغاريا'),
(19122, 1371013120, 1371078655, 'ES', 'ESP', 'إسبانيا'),
(19123, 1371078656, 1371144191, 'FR', 'FRA', 'فرنسا'),
(19124, 1371144192, 1371201535, 'GR', 'GRC', 'اليونان'),
(19125, 1371201536, 1371205631, 'PL', 'POL', 'بولندا'),
(19126, 1371205632, 1371209727, 'SE', 'SWE', 'السويد'),
(19127, 1371209728, 1371275263, 'GB', 'GBR', 'المملكة المتحدة'),
(19128, 1371275264, 1371340799, 'BE', 'BEL', 'بلجيكا'),
(19129, 1371340800, 1371374740, 'AT', 'AUT', 'النمسا'),
(19130, 1371374741, 1371374741, 'SK', 'SVK', 'سلوفاكيا'),
(19131, 1371374742, 1371406335, 'AT', 'AUT', 'النمسا'),
(19132, 1371406336, 1371471871, 'PL', 'POL', 'بولندا'),
(19133, 1371471872, 1371537407, 'NO', 'NOR', 'النرويج'),
(19134, 1371602944, 1371668479, 'PT', 'PRT', 'البورتوغال'),
(19135, 1371668480, 1371734015, 'FR', 'FRA', 'فرنسا'),
(19136, 1371734016, 1371799551, 'RU', 'RUS', 'الإتحاد الروسي'),
(19137, 1371799552, 1371865087, 'RO', 'ROM', 'رومانيا'),
(19138, 1371865088, 1371930623, 'FI', 'FIN', 'فنلندا'),
(19139, 1371930624, 1371996159, 'LV', 'LVA', 'لاتفيا'),
(19140, 1371996160, 1371997183, 'GB', 'GBR', 'المملكة المتحدة'),
(19141, 1371997184, 1371997439, 'KE', 'KEN', 'كينيا'),
(19142, 1371997440, 1371998207, 'NG', 'NGA', 'نيجيريا'),
(19143, 1371998208, 1371998463, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(19144, 1371998464, 1371998719, 'NG', 'NGA', 'نيجيريا'),
(19145, 1371998720, 1372000255, 'GB', 'GBR', 'المملكة المتحدة'),
(19146, 1372000256, 1372004351, 'UG', 'UGA', 'أوغاندا'),
(19147, 1372004352, 1372006399, 'GB', 'GBR', 'المملكة المتحدة'),
(19148, 1372006400, 1372006407, 'NG', 'NGA', 'نيجيريا'),
(19149, 1372006408, 1372006463, 'GB', 'GBR', 'المملكة المتحدة'),
(19150, 1372006464, 1372006495, 'NG', 'NGA', 'نيجيريا'),
(19151, 1372006496, 1372007039, 'GB', 'GBR', 'المملكة المتحدة'),
(19152, 1372007040, 1372007455, 'NG', 'NGA', 'نيجيريا'),
(19153, 1372007456, 1372008095, 'GB', 'GBR', 'المملكة المتحدة'),
(19154, 1372008096, 1372008127, 'NG', 'NGA', 'نيجيريا'),
(19155, 1372008128, 1372008159, 'GB', 'GBR', 'المملكة المتحدة'),
(19156, 1372008160, 1372008191, 'NG', 'NGA', 'نيجيريا'),
(19157, 1372008192, 1372008927, 'GB', 'GBR', 'المملكة المتحدة'),
(19158, 1372008928, 1372008959, 'MW', 'MWI', 'ملاوي'),
(19159, 1372008960, 1372010239, 'GB', 'GBR', 'المملكة المتحدة'),
(19160, 1372010240, 1372010272, 'NG', 'NGA', 'نيجيريا'),
(19161, 1372010273, 1372010967, 'GB', 'GBR', 'المملكة المتحدة'),
(19162, 1372010968, 1372011007, 'TZ', 'TZA', 'تانزانيا'),
(19163, 1372011008, 1372011775, 'GB', 'GBR', 'المملكة المتحدة'),
(19164, 1372011776, 1372012031, 'ZM', 'ZMB', 'زامبيا'),
(19165, 1372012032, 1372012543, 'GB', 'GBR', 'المملكة المتحدة'),
(19166, 1372012544, 1372014591, 'ZM', 'ZMB', 'زامبيا'),
(19167, 1372014592, 1372015615, 'GB', 'GBR', 'المملكة المتحدة'),
(19168, 1372015616, 1372015871, 'NG', 'NGA', 'نيجيريا'),
(19169, 1372015872, 1372016127, 'GB', 'GBR', 'المملكة المتحدة'),
(19170, 1372016128, 1372016383, 'GH', 'GHA', 'غانا'),
(19171, 1372016384, 1372019199, 'GB', 'GBR', 'المملكة المتحدة'),
(19172, 1372019200, 1372019455, 'GA', 'GAB', 'الغابون'),
(19173, 1372019456, 1372020735, 'GB', 'GBR', 'المملكة المتحدة'),
(19174, 1372020736, 1372022783, 'ZM', 'ZMB', 'زامبيا'),
(19175, 1372022784, 1372024831, 'GB', 'GBR', 'المملكة المتحدة'),
(19176, 1372024832, 1372025087, 'ZM', 'ZMB', 'زامبيا'),
(19177, 1372025088, 1372025631, 'GB', 'GBR', 'المملكة المتحدة'),
(19178, 1372025632, 1372025663, 'ZM', 'ZMB', 'زامبيا'),
(19179, 1372025664, 1372025695, 'KE', 'KEN', 'كينيا'),
(19180, 1372025696, 1372025727, 'TZ', 'TZA', 'تانزانيا'),
(19181, 1372025728, 1372025855, 'GB', 'GBR', 'المملكة المتحدة'),
(19182, 1372025856, 1372026367, 'IL', 'ISR', 'إسرائيل'),
(19183, 1372026368, 1372026879, 'GB', 'GBR', 'المملكة المتحدة'),
(19184, 1372026880, 1372027903, 'IL', 'ISR', 'إسرائيل'),
(19185, 1372027904, 1372029439, 'GB', 'GBR', 'المملكة المتحدة'),
(19186, 1372029440, 1372029695, 'NG', 'NGA', 'نيجيريا'),
(19187, 1372029696, 1372029951, 'NE', 'NER', 'النيجر'),
(19188, 1372029952, 1372031999, 'GB', 'GBR', 'المملكة المتحدة'),
(19189, 1372032000, 1372032255, 'CM', 'CMR', 'الكاميرون'),
(19190, 1372032256, 1372041343, 'GB', 'GBR', 'المملكة المتحدة'),
(19191, 1372041344, 1372041471, 'NG', 'NGA', 'نيجيريا'),
(19192, 1372041472, 1372042239, 'GB', 'GBR', 'المملكة المتحدة'),
(19193, 1372042240, 1372042495, 'LR', 'LBR', 'ليبيريا'),
(19194, 1372042496, 1372043519, 'GB', 'GBR', 'المملكة المتحدة'),
(19195, 1372043520, 1372043775, 'NG', 'NGA', 'نيجيريا'),
(19196, 1372043776, 1372044415, 'GB', 'GBR', 'المملكة المتحدة'),
(19197, 1372044416, 1372044447, 'NG', 'NGA', 'نيجيريا'),
(19198, 1372044448, 1372044799, 'GB', 'GBR', 'المملكة المتحدة'),
(19199, 1372044800, 1372044863, 'CM', 'CMR', 'الكاميرون'),
(19200, 1372044864, 1372044927, 'NG', 'NGA', 'نيجيريا'),
(19201, 1372044928, 1372045055, 'GB', 'GBR', 'المملكة المتحدة'),
(19202, 1372045056, 1372045087, 'CM', 'CMR', 'الكاميرون'),
(19203, 1372045088, 1372045119, 'GB', 'GBR', 'المملكة المتحدة'),
(19204, 1372045120, 1372045151, 'NG', 'NGA', 'نيجيريا'),
(19205, 1372045152, 1372045567, 'GB', 'GBR', 'المملكة المتحدة'),
(19206, 1372045568, 1372045887, 'NG', 'NGA', 'نيجيريا'),
(19207, 1372045888, 1372046559, 'GB', 'GBR', 'المملكة المتحدة'),
(19208, 1372046560, 1372046591, 'NG', 'NGA', 'نيجيريا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(19209, 1372046592, 1372047231, 'GB', 'GBR', 'المملكة المتحدة'),
(19210, 1372047232, 1372047295, 'NG', 'NGA', 'نيجيريا'),
(19211, 1372047296, 1372047359, 'GB', 'GBR', 'المملكة المتحدة'),
(19212, 1372047360, 1372047615, 'CM', 'CMR', 'الكاميرون'),
(19213, 1372047616, 1372049919, 'GB', 'GBR', 'المملكة المتحدة'),
(19214, 1372049920, 1372050175, 'NG', 'NGA', 'نيجيريا'),
(19215, 1372050176, 1372060159, 'GB', 'GBR', 'المملكة المتحدة'),
(19216, 1372060160, 1372061695, 'IL', 'ISR', 'إسرائيل'),
(19217, 1372061696, 1372069887, 'RU', 'RUS', 'الإتحاد الروسي'),
(19218, 1372069888, 1372073983, 'FR', 'FRA', 'فرنسا'),
(19219, 1372073984, 1372078079, 'CZ', 'CZE', 'التشيك'),
(19220, 1372078080, 1372082175, 'GB', 'GBR', 'المملكة المتحدة'),
(19221, 1372082176, 1372086271, 'RU', 'RUS', 'الإتحاد الروسي'),
(19222, 1372086272, 1372090367, 'DE', 'DEU', 'ألمانيا'),
(19223, 1372090368, 1372094463, 'RU', 'RUS', 'الإتحاد الروسي'),
(19224, 1372094464, 1372098559, 'IT', 'ITA', 'إيطاليا'),
(19225, 1372098560, 1372102655, 'RU', 'RUS', 'الإتحاد الروسي'),
(19226, 1372102656, 1372106751, 'SE', 'SWE', 'السويد'),
(19227, 1372106752, 1372110591, 'FR', 'FRA', 'فرنسا'),
(19228, 1372110592, 1372110623, 'GB', 'GBR', 'المملكة المتحدة'),
(19229, 1372110624, 1372110655, 'DE', 'DEU', 'ألمانيا'),
(19230, 1372110656, 1372110687, 'IT', 'ITA', 'إيطاليا'),
(19231, 1372110688, 1372110719, 'ES', 'ESP', 'إسبانيا'),
(19232, 1372110720, 1372110751, 'FR', 'FRA', 'فرنسا'),
(19233, 1372110752, 1372110783, 'NL', 'NLD', 'هولندا'),
(19234, 1372110784, 1372110847, 'FR', 'FRA', 'فرنسا'),
(19235, 1372110848, 1372114943, 'DE', 'DEU', 'ألمانيا'),
(19236, 1372114944, 1372119039, 'RU', 'RUS', 'الإتحاد الروسي'),
(19237, 1372119040, 1372123135, 'IT', 'ITA', 'إيطاليا'),
(19238, 1372123136, 1372127231, 'RU', 'RUS', 'الإتحاد الروسي'),
(19239, 1372127232, 1372131327, 'IT', 'ITA', 'إيطاليا'),
(19240, 1372131328, 1372135423, 'RU', 'RUS', 'الإتحاد الروسي'),
(19241, 1372135424, 1372138255, 'DE', 'DEU', 'ألمانيا'),
(19242, 1372138256, 1372138263, 'GB', 'GBR', 'المملكة المتحدة'),
(19243, 1372138264, 1372139519, 'DE', 'DEU', 'ألمانيا'),
(19244, 1372139520, 1372143615, 'CZ', 'CZE', 'التشيك'),
(19245, 1372143616, 1372147711, 'RU', 'RUS', 'الإتحاد الروسي'),
(19246, 1372147712, 1372151807, 'BE', 'BEL', 'بلجيكا'),
(19247, 1372151808, 1372152823, 'DE', 'DEU', 'ألمانيا'),
(19248, 1372152824, 1372152831, 'GB', 'GBR', 'المملكة المتحدة'),
(19249, 1372152832, 1372159999, 'DE', 'DEU', 'ألمانيا'),
(19250, 1372160000, 1372164095, 'GB', 'GBR', 'المملكة المتحدة'),
(19251, 1372164096, 1372168191, 'DE', 'DEU', 'ألمانيا'),
(19252, 1372168192, 1372172287, 'GB', 'GBR', 'المملكة المتحدة'),
(19253, 1372172288, 1372176383, 'FR', 'FRA', 'فرنسا'),
(19254, 1372176384, 1372180479, 'CH', 'CHE', 'سويسرا'),
(19255, 1372180480, 1372184071, 'SE', 'SWE', 'السويد'),
(19256, 1372184072, 1372184079, 'ES', 'ESP', 'إسبانيا'),
(19257, 1372184080, 1372184575, 'SE', 'SWE', 'السويد'),
(19258, 1372184576, 1372188671, 'DE', 'DEU', 'ألمانيا'),
(19259, 1372188672, 1372192767, 'RU', 'RUS', 'الإتحاد الروسي'),
(19260, 1372192768, 1372323839, 'ES', 'ESP', 'إسبانيا'),
(19261, 1372323840, 1372585983, 'NL', 'NLD', 'هولندا'),
(19262, 1372585984, 1372610047, 'IT', 'ITA', 'إيطاليا'),
(19263, 1372610048, 1372610303, 'VA', 'VAT', 'دولة الفاتيكان'),
(19264, 1372610304, 1372618751, 'IT', 'ITA', 'إيطاليا'),
(19265, 1372618752, 1372651519, 'GB', 'GBR', 'المملكة المتحدة'),
(19266, 1372651520, 1372684287, 'FI', 'FIN', 'فنلندا'),
(19267, 1372684288, 1372684415, 'DE', 'DEU', 'ألمانيا'),
(19268, 1372684544, 1372685631, 'DE', 'DEU', 'ألمانيا'),
(19269, 1372685656, 1372685663, 'DE', 'DEU', 'ألمانيا'),
(19270, 1372685696, 1372685823, 'DE', 'DEU', 'ألمانيا'),
(19271, 1372685888, 1372686335, 'DE', 'DEU', 'ألمانيا'),
(19272, 1372687360, 1372687711, 'DE', 'DEU', 'ألمانيا'),
(19273, 1372687720, 1372687727, 'DE', 'DEU', 'ألمانيا'),
(19274, 1372687736, 1372688199, 'DE', 'DEU', 'ألمانيا'),
(19275, 1372688224, 1372689839, 'DE', 'DEU', 'ألمانيا'),
(19276, 1372689856, 1372691455, 'DE', 'DEU', 'ألمانيا'),
(19277, 1372691456, 1372691711, 'US', 'USA', 'الولايات المتحدة'),
(19278, 1372691968, 1372694271, 'DE', 'DEU', 'ألمانيا'),
(19279, 1372694336, 1372694367, 'DE', 'DEU', 'ألمانيا'),
(19280, 1372694384, 1372694399, 'DE', 'DEU', 'ألمانيا'),
(19281, 1372694560, 1372694591, 'DE', 'DEU', 'ألمانيا'),
(19282, 1372694624, 1372694719, 'DE', 'DEU', 'ألمانيا'),
(19283, 1372694784, 1372694815, 'DE', 'DEU', 'ألمانيا'),
(19284, 1372694832, 1372695039, 'DE', 'DEU', 'ألمانيا'),
(19285, 1372695168, 1372695295, 'DE', 'DEU', 'ألمانيا'),
(19286, 1372695424, 1372695551, 'DE', 'DEU', 'ألمانيا'),
(19287, 1372695552, 1372695807, 'CZ', 'CZE', 'التشيك'),
(19288, 1372695808, 1372696007, 'DK', 'DNK', 'الدنيمارك'),
(19289, 1372696064, 1372697215, 'DE', 'DEU', 'ألمانيا'),
(19290, 1372697232, 1372697239, 'DE', 'DEU', 'ألمانيا'),
(19291, 1372697248, 1372697279, 'DE', 'DEU', 'ألمانيا'),
(19292, 1372697344, 1372698471, 'DE', 'DEU', 'ألمانيا'),
(19293, 1372698560, 1372700159, 'DE', 'DEU', 'ألمانيا'),
(19294, 1372700160, 1372700415, 'SE', 'SWE', 'السويد'),
(19295, 1372700672, 1372702463, 'DE', 'DEU', 'ألمانيا'),
(19296, 1372702720, 1372702735, 'DE', 'DEU', 'ألمانيا'),
(19297, 1372702752, 1372702991, 'DE', 'DEU', 'ألمانيا'),
(19298, 1372703232, 1372703263, 'DE', 'DEU', 'ألمانيا'),
(19299, 1372703272, 1372703323, 'DE', 'DEU', 'ألمانيا'),
(19300, 1372703328, 1372703407, 'DE', 'DEU', 'ألمانيا'),
(19301, 1372703424, 1372703487, 'DE', 'DEU', 'ألمانيا'),
(19302, 1372703744, 1372713327, 'DE', 'DEU', 'ألمانيا'),
(19303, 1372713344, 1372713375, 'DE', 'DEU', 'ألمانيا'),
(19304, 1372713472, 1372714239, 'DE', 'DEU', 'ألمانيا'),
(19305, 1372714496, 1372717055, 'DE', 'DEU', 'ألمانيا'),
(19306, 1372717056, 1372749823, 'PL', 'POL', 'بولندا'),
(19307, 1372749824, 1372782591, 'DE', 'DEU', 'ألمانيا'),
(19308, 1372782592, 1372815359, 'RU', 'RUS', 'الإتحاد الروسي'),
(19309, 1372815360, 1372848127, 'IT', 'ITA', 'إيطاليا'),
(19310, 1372848128, 1373110271, 'TR', 'TUR', 'تركيا'),
(19311, 1373110272, 1373175807, 'SE', 'SWE', 'السويد'),
(19312, 1373175808, 1373241343, 'AT', 'AUT', 'النمسا'),
(19313, 1373241344, 1373299967, 'IL', 'ISR', 'إسرائيل'),
(19314, 1373299968, 1373300223, 'NL', 'NLD', 'هولندا'),
(19315, 1373300224, 1373306879, 'IL', 'ISR', 'إسرائيل'),
(19316, 1373306880, 1373372415, 'PL', 'POL', 'بولندا'),
(19317, 1373372416, 1373437951, 'FR', 'FRA', 'فرنسا'),
(19318, 1373437952, 1373503487, 'CH', 'CHE', 'سويسرا'),
(19319, 1373503488, 1373519871, 'RU', 'RUS', 'الإتحاد الروسي'),
(19320, 1373519872, 1373520895, 'GB', 'GBR', 'المملكة المتحدة'),
(19321, 1373520896, 1373569023, 'RU', 'RUS', 'الإتحاد الروسي'),
(19322, 1373569024, 1373634559, 'AT', 'AUT', 'النمسا'),
(19323, 1373634560, 1374683135, 'SE', 'SWE', 'السويد'),
(19324, 1374683136, 1375207423, 'BE', 'BEL', 'بلجيكا'),
(19325, 1375207424, 1375731711, 'FR', 'FRA', 'فرنسا'),
(19326, 1375731712, 1375798335, 'GB', 'GBR', 'المملكة المتحدة'),
(19327, 1375798336, 1375798351, 'IE', 'IRL', 'إيرلندا'),
(19328, 1375798352, 1375852543, 'GB', 'GBR', 'المملكة المتحدة'),
(19329, 1375852544, 1375852799, 'IE', 'IRL', 'إيرلندا'),
(19330, 1375852800, 1378877439, 'GB', 'GBR', 'المملكة المتحدة'),
(19331, 1378877440, 1379926015, 'IT', 'ITA', 'إيطاليا'),
(19332, 1379926016, 1380188159, 'FR', 'FRA', 'فرنسا'),
(19333, 1380188160, 1380450303, 'GB', 'GBR', 'المملكة المتحدة'),
(19334, 1380450304, 1380712447, 'NL', 'NLD', 'هولندا'),
(19335, 1380712448, 1380903935, 'RO', 'ROM', 'رومانيا'),
(19336, 1380903936, 1380904447, 'SK', 'SVK', 'سلوفاكيا'),
(19337, 1380904448, 1380974591, 'RO', 'ROM', 'رومانيا'),
(19338, 1380974592, 1381105663, 'IL', 'ISR', 'إسرائيل'),
(19339, 1381105664, 1381236735, 'DE', 'DEU', 'ألمانيا'),
(19340, 1381236736, 1381367807, 'IT', 'ITA', 'إيطاليا'),
(19341, 1381367808, 1381498879, 'ES', 'ESP', 'إسبانيا'),
(19342, 1381498880, 1381761023, 'IT', 'ITA', 'إيطاليا'),
(19343, 1381761024, 1382023167, 'NL', 'NLD', 'هولندا'),
(19344, 1382023168, 1382024959, 'SE', 'SWE', 'السويد'),
(19345, 1382024960, 1382025215, 'DK', 'DNK', 'الدنيمارك'),
(19346, 1382025216, 1382033583, 'SE', 'SWE', 'السويد'),
(19347, 1382033584, 1382033599, 'NL', 'NLD', 'هولندا'),
(19348, 1382033600, 1382035359, 'SE', 'SWE', 'السويد'),
(19349, 1382035360, 1382035375, 'NO', 'NOR', 'النرويج'),
(19350, 1382035376, 1382039007, 'SE', 'SWE', 'السويد'),
(19351, 1382039008, 1382039023, 'FR', 'FRA', 'فرنسا'),
(19352, 1382039024, 1382039055, 'SE', 'SWE', 'السويد'),
(19353, 1382039056, 1382039071, 'DE', 'DEU', 'ألمانيا'),
(19354, 1382039072, 1382039175, 'SE', 'SWE', 'السويد'),
(19355, 1382039176, 1382039191, 'GB', 'GBR', 'المملكة المتحدة'),
(19356, 1382039192, 1382039551, 'SE', 'SWE', 'السويد'),
(19357, 1382039552, 1382055935, 'DE', 'DEU', 'ألمانيا'),
(19358, 1382055936, 1382072319, 'FR', 'FRA', 'فرنسا'),
(19359, 1382072320, 1382088703, 'RU', 'RUS', 'الإتحاد الروسي'),
(19360, 1382088704, 1382091311, 'FR', 'FRA', 'فرنسا'),
(19361, 1382091312, 1382091327, 'MC', 'MCO', 'موناكو'),
(19362, 1382091328, 1382091375, 'FR', 'FRA', 'فرنسا'),
(19363, 1382091376, 1382091391, 'MC', 'MCO', 'موناكو'),
(19364, 1382091392, 1382091775, 'FR', 'FRA', 'فرنسا'),
(19365, 1382091776, 1382092031, 'MC', 'MCO', 'موناكو'),
(19366, 1382092032, 1382092367, 'FR', 'FRA', 'فرنسا'),
(19367, 1382092368, 1382092399, 'MC', 'MCO', 'موناكو'),
(19368, 1382092400, 1382092815, 'FR', 'FRA', 'فرنسا'),
(19369, 1382092816, 1382092831, 'MC', 'MCO', 'موناكو'),
(19370, 1382092832, 1382092927, 'FR', 'FRA', 'فرنسا'),
(19371, 1382092928, 1382092943, 'MC', 'MCO', 'موناكو'),
(19372, 1382092944, 1382093055, 'FR', 'FRA', 'فرنسا'),
(19373, 1382093056, 1382093087, 'GB', 'GBR', 'المملكة المتحدة'),
(19374, 1382093088, 1382093119, 'FR', 'FRA', 'فرنسا'),
(19375, 1382093120, 1382093151, 'MC', 'MCO', 'موناكو'),
(19376, 1382093152, 1382093503, 'FR', 'FRA', 'فرنسا'),
(19377, 1382093504, 1382093583, 'MC', 'MCO', 'موناكو'),
(19378, 1382093584, 1382093823, 'FR', 'FRA', 'فرنسا'),
(19379, 1382093824, 1382093887, 'MC', 'MCO', 'موناكو'),
(19380, 1382093888, 1382094079, 'FR', 'FRA', 'فرنسا'),
(19381, 1382094080, 1382094143, 'MC', 'MCO', 'موناكو'),
(19382, 1382094144, 1382094335, 'FR', 'FRA', 'فرنسا'),
(19383, 1382094336, 1382094351, 'MC', 'MCO', 'موناكو'),
(19384, 1382094352, 1382094591, 'FR', 'FRA', 'فرنسا'),
(19385, 1382094592, 1382094623, 'MC', 'MCO', 'موناكو'),
(19386, 1382094624, 1382105087, 'FR', 'FRA', 'فرنسا'),
(19387, 1382105088, 1382137855, 'DE', 'DEU', 'ألمانيا'),
(19388, 1382137856, 1382154239, 'RU', 'RUS', 'الإتحاد الروسي'),
(19389, 1382154240, 1382170623, 'FR', 'FRA', 'فرنسا'),
(19390, 1382170624, 1382171776, 'DE', 'DEU', 'ألمانيا'),
(19391, 1382171777, 1382171791, 'CH', 'CHE', 'سويسرا'),
(19392, 1382171792, 1382177983, 'DE', 'DEU', 'ألمانيا'),
(19393, 1382177984, 1382178303, 'LI', 'LIE', 'ليختنشتاين'),
(19394, 1382178304, 1382179247, 'DE', 'DEU', 'ألمانيا'),
(19395, 1382179248, 1382179279, 'GB', 'GBR', 'المملكة المتحدة'),
(19396, 1382179280, 1382179839, 'DE', 'DEU', 'ألمانيا'),
(19397, 1382179840, 1382180863, 'CN', 'CHN', 'الصين'),
(19398, 1382180864, 1382182327, 'DE', 'DEU', 'ألمانيا'),
(19399, 1382182328, 1382182335, 'GB', 'GBR', 'المملكة المتحدة'),
(19400, 1382182336, 1382182799, 'DE', 'DEU', 'ألمانيا'),
(19401, 1382182800, 1382182831, 'GB', 'GBR', 'المملكة المتحدة'),
(19402, 1382182832, 1382182895, 'DE', 'DEU', 'ألمانيا'),
(19403, 1382182896, 1382182911, 'GB', 'GBR', 'المملكة المتحدة'),
(19404, 1382182912, 1382187007, 'DE', 'DEU', 'ألمانيا'),
(19405, 1382187008, 1382191871, 'ES', 'ESP', 'إسبانيا'),
(19406, 1382191872, 1382192127, 'VE', 'VEN', 'فنزويلا'),
(19407, 1382192128, 1382203391, 'ES', 'ESP', 'إسبانيا'),
(19408, 1382203392, 1382204479, 'NL', 'NLD', 'هولندا'),
(19409, 1382204480, 1382205439, 'GB', 'GBR', 'المملكة المتحدة'),
(19410, 1382205696, 1382206463, 'DE', 'DEU', 'ألمانيا'),
(19411, 1382207744, 1382207999, 'DE', 'DEU', 'ألمانيا'),
(19412, 1382208256, 1382208319, 'DE', 'DEU', 'ألمانيا'),
(19413, 1382209536, 1382209791, 'DE', 'DEU', 'ألمانيا'),
(19414, 1382211072, 1382211199, 'DE', 'DEU', 'ألمانيا'),
(19415, 1382211328, 1382211583, 'NL', 'NLD', 'هولندا'),
(19416, 1382211584, 1382211711, 'FR', 'FRA', 'فرنسا'),
(19417, 1382211840, 1382212095, 'FR', 'FRA', 'فرنسا'),
(19418, 1382212224, 1382212239, 'FR', 'FRA', 'فرنسا'),
(19419, 1382212288, 1382212351, 'NL', 'NLD', 'هولندا'),
(19420, 1382212352, 1382212479, 'FR', 'FRA', 'فرنسا'),
(19421, 1382212608, 1382212863, 'FR', 'FRA', 'فرنسا'),
(19422, 1382212864, 1382213183, 'NL', 'NLD', 'هولندا'),
(19423, 1382213200, 1382214079, 'NL', 'NLD', 'هولندا'),
(19424, 1382214080, 1382214111, 'GB', 'GBR', 'المملكة المتحدة'),
(19425, 1382214112, 1382214879, 'NL', 'NLD', 'هولندا'),
(19426, 1382214880, 1382214895, 'GB', 'GBR', 'المملكة المتحدة'),
(19427, 1382214896, 1382216831, 'NL', 'NLD', 'هولندا'),
(19428, 1382216832, 1382216895, 'GB', 'GBR', 'المملكة المتحدة'),
(19429, 1382216896, 1382216959, 'NL', 'NLD', 'هولندا'),
(19430, 1382216960, 1382217215, 'FR', 'FRA', 'فرنسا'),
(19431, 1382217216, 1382217727, 'NL', 'NLD', 'هولندا'),
(19432, 1382217728, 1382217983, 'GB', 'GBR', 'المملكة المتحدة'),
(19433, 1382217984, 1382218399, 'NL', 'NLD', 'هولندا'),
(19434, 1382218400, 1382218447, 'GB', 'GBR', 'المملكة المتحدة'),
(19435, 1382218448, 1382218455, 'NL', 'NLD', 'هولندا'),
(19436, 1382218456, 1382218495, 'GB', 'GBR', 'المملكة المتحدة'),
(19437, 1382218496, 1382218623, 'NL', 'NLD', 'هولندا'),
(19438, 1382218624, 1382218751, 'GB', 'GBR', 'المملكة المتحدة'),
(19439, 1382218752, 1382218815, 'NL', 'NLD', 'هولندا'),
(19440, 1382218816, 1382218911, 'GB', 'GBR', 'المملكة المتحدة'),
(19441, 1382218912, 1382218959, 'NL', 'NLD', 'هولندا'),
(19442, 1382218960, 1382218991, 'GB', 'GBR', 'المملكة المتحدة'),
(19443, 1382218992, 1382219775, 'NL', 'NLD', 'هولندا'),
(19444, 1382219776, 1382224287, 'SE', 'SWE', 'السويد'),
(19445, 1382224288, 1382224319, 'NO', 'NOR', 'النرويج'),
(19446, 1382224320, 1382226271, 'SE', 'SWE', 'السويد'),
(19447, 1382226272, 1382226303, 'NO', 'NOR', 'النرويج'),
(19448, 1382226304, 1382227327, 'SE', 'SWE', 'السويد'),
(19449, 1382227328, 1382227455, 'NO', 'NOR', 'النرويج'),
(19450, 1382227456, 1382227583, 'SE', 'SWE', 'السويد'),
(19451, 1382227584, 1382227711, 'DK', 'DNK', 'الدنيمارك'),
(19452, 1382227712, 1382229503, 'SE', 'SWE', 'السويد'),
(19453, 1382229504, 1382229511, 'NO', 'NOR', 'النرويج'),
(19454, 1382229512, 1382232575, 'SE', 'SWE', 'السويد'),
(19455, 1382232576, 1382232639, 'NO', 'NOR', 'النرويج'),
(19456, 1382232640, 1382232703, 'DK', 'DNK', 'الدنيمارك'),
(19457, 1382232704, 1382233407, 'SE', 'SWE', 'السويد'),
(19458, 1382233408, 1382233423, 'NO', 'NOR', 'النرويج'),
(19459, 1382233424, 1382252543, 'SE', 'SWE', 'السويد'),
(19460, 1382252544, 1382268927, 'CZ', 'CZE', 'التشيك'),
(19461, 1382268928, 1382285311, 'IR', 'IRN', 'إيران'),
(19462, 1382285312, 1382301391, 'CZ', 'CZE', 'التشيك'),
(19463, 1382301392, 1382301407, 'SK', 'SVK', 'سلوفاكيا'),
(19464, 1382301408, 1382301695, 'CZ', 'CZE', 'التشيك'),
(19465, 1382301696, 1382318079, 'SE', 'SWE', 'السويد'),
(19466, 1382318080, 1382334463, 'RU', 'RUS', 'الإتحاد الروسي'),
(19467, 1382334464, 1382350847, 'DE', 'DEU', 'ألمانيا'),
(19468, 1382350848, 1382367231, 'FR', 'FRA', 'فرنسا'),
(19469, 1382367232, 1382383615, 'BG', 'BGR', 'بلغاريا'),
(19470, 1382400000, 1382416383, 'NL', 'NLD', 'هولندا'),
(19471, 1382416384, 1382432767, 'PT', 'PRT', 'البورتوغال'),
(19472, 1382432768, 1382449151, 'CY', 'CYP', 'قبرص'),
(19473, 1382449152, 1382465535, 'IL', 'ISR', 'إسرائيل'),
(19474, 1382465536, 1382481919, 'PS', 'PSE', 'فلسطين المحتلة'),
(19475, 1382481920, 1382498303, 'AT', 'AUT', 'النمسا'),
(19476, 1382498304, 1382514687, 'BG', 'BGR', 'بلغاريا'),
(19477, 1382514688, 1382531071, 'DK', 'DNK', 'الدنيمارك'),
(19478, 1382531072, 1382547455, 'FI', 'FIN', 'فنلندا'),
(19479, 1382547456, 1382809599, 'IT', 'ITA', 'إيطاليا'),
(19480, 1382809600, 1383025663, 'GB', 'GBR', 'المملكة المتحدة'),
(19481, 1383025664, 1383025672, 'DE', 'DEU', 'ألمانيا'),
(19482, 1383025673, 1383025679, 'GB', 'GBR', 'المملكة المتحدة'),
(19483, 1383025680, 1383025711, 'DE', 'DEU', 'ألمانيا'),
(19484, 1383025712, 1383025727, 'GB', 'GBR', 'المملكة المتحدة'),
(19485, 1383025728, 1383025759, 'DE', 'DEU', 'ألمانيا'),
(19486, 1383025760, 1383071743, 'GB', 'GBR', 'المملكة المتحدة'),
(19487, 1383071744, 1383073279, 'RU', 'RUS', 'الإتحاد الروسي'),
(19488, 1383073280, 1383073535, 'KZ', 'KAZ', 'كازاخستان'),
(19489, 1383073536, 1383088127, 'RU', 'RUS', 'الإتحاد الروسي'),
(19490, 1383088128, 1383096319, 'IS', 'ISL', 'أيسلندا'),
(19491, 1383096320, 1383103271, 'GB', 'GBR', 'المملكة المتحدة'),
(19492, 1383103272, 1383103279, 'ES', 'ESP', 'إسبانيا'),
(19493, 1383103280, 1383103471, 'GB', 'GBR', 'المملكة المتحدة'),
(19494, 1383103472, 1383103487, 'NL', 'NLD', 'هولندا'),
(19495, 1383103488, 1383104015, 'GB', 'GBR', 'المملكة المتحدة'),
(19496, 1383104016, 1383104023, 'ES', 'ESP', 'إسبانيا'),
(19497, 1383104024, 1383104255, 'GB', 'GBR', 'المملكة المتحدة'),
(19498, 1383104256, 1383104511, 'FR', 'FRA', 'فرنسا'),
(19499, 1383104512, 1383111935, 'GB', 'GBR', 'المملكة المتحدة'),
(19500, 1383111936, 1383112191, 'JE', 'JEY', 'جيرسي'),
(19501, 1383112192, 1383112447, 'GB', 'GBR', 'المملكة المتحدة'),
(19502, 1383112448, 1383112703, 'JE', 'JEY', 'جيرسي'),
(19503, 1383112704, 1383120895, 'GE', 'GEO', 'جورجيا'),
(19504, 1383120896, 1383129031, 'IT', 'ITA', 'إيطاليا'),
(19505, 1383129032, 1383129039, 'ES', 'ESP', 'إسبانيا'),
(19506, 1383129040, 1383129087, 'IT', 'ITA', 'إيطاليا'),
(19507, 1383129088, 1383137279, 'GB', 'GBR', 'المملكة المتحدة'),
(19508, 1383137280, 1383145471, 'MC', 'MCO', 'موناكو'),
(19509, 1383145472, 1383153663, 'CZ', 'CZE', 'التشيك'),
(19510, 1383153664, 1383161855, 'GB', 'GBR', 'المملكة المتحدة'),
(19511, 1383161856, 1383170047, 'DE', 'DEU', 'ألمانيا'),
(19512, 1383170048, 1383171743, 'GB', 'GBR', 'المملكة المتحدة'),
(19513, 1383171744, 1383171775, 'NZ', 'NZL', 'نيوزيلاندا'),
(19514, 1383171776, 1383172559, 'GB', 'GBR', 'المملكة المتحدة'),
(19515, 1383172560, 1383172567, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(19516, 1383172568, 1383186431, 'GB', 'GBR', 'المملكة المتحدة'),
(19517, 1383186432, 1383194623, 'IT', 'ITA', 'إيطاليا'),
(19518, 1383194624, 1383202815, 'GB', 'GBR', 'المملكة المتحدة'),
(19519, 1383202816, 1383211007, 'RU', 'RUS', 'الإتحاد الروسي'),
(19520, 1383211008, 1383219199, 'CY', 'CYP', 'قبرص'),
(19521, 1383219200, 1383221247, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19522, 1383221248, 1383221502, 'RS', 'SRB', 'صربيا'),
(19523, 1383221503, 1383221759, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19524, 1383221760, 1383222015, 'RS', 'SRB', 'صربيا'),
(19525, 1383222016, 1383222527, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(19526, 1383222528, 1383222783, 'RS', 'SRB', 'صربيا'),
(19527, 1383222784, 1383223039, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(19528, 1383223040, 1383223551, 'RS', 'SRB', 'صربيا'),
(19529, 1383223552, 1383223807, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19530, 1383223808, 1383224062, 'RS', 'SRB', 'صربيا'),
(19531, 1383224063, 1383224063, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19532, 1383224064, 1383224318, 'RS', 'SRB', 'صربيا'),
(19533, 1383224319, 1383224863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19534, 1383224864, 1383224895, 'RS', 'SRB', 'صربيا'),
(19535, 1383224896, 1383225087, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19536, 1383225088, 1383227391, 'RS', 'SRB', 'صربيا'),
(19537, 1383227392, 1383239295, 'RU', 'RUS', 'الإتحاد الروسي'),
(19538, 1383239296, 1383239423, 'AR', 'ARG', 'الأرجنتين'),
(19539, 1383239424, 1383243775, 'RU', 'RUS', 'الإتحاد الروسي'),
(19540, 1383243776, 1383251967, 'YE', 'YEM', 'اليمن'),
(19541, 1383251968, 1383260159, 'CZ', 'CZE', 'التشيك'),
(19542, 1383260160, 1383268351, 'RU', 'RUS', 'الإتحاد الروسي'),
(19543, 1383268352, 1383273983, 'IR', 'IRN', 'إيران'),
(19544, 1383273984, 1383276543, 'KW', 'KWT', 'الكويت'),
(19545, 1383276544, 1383284735, 'KZ', 'KAZ', 'كازاخستان'),
(19546, 1383284736, 1383292927, 'PL', 'POL', 'بولندا'),
(19547, 1383292928, 1383301119, 'DE', 'DEU', 'ألمانيا'),
(19548, 1383301120, 1383309311, 'SE', 'SWE', 'السويد'),
(19549, 1383309312, 1383317503, 'IT', 'ITA', 'إيطاليا'),
(19550, 1383317504, 1383321599, 'SE', 'SWE', 'السويد'),
(19551, 1383321600, 1383325695, 'RU', 'RUS', 'الإتحاد الروسي'),
(19552, 1383325696, 1383333887, 'GB', 'GBR', 'المملكة المتحدة'),
(19553, 1383333888, 1383350271, 'RU', 'RUS', 'الإتحاد الروسي'),
(19554, 1383350272, 1383358463, 'NO', 'NOR', 'النرويج'),
(19555, 1383358464, 1383366911, 'DE', 'DEU', 'ألمانيا'),
(19556, 1383366912, 1383367167, 'SY', 'SYR', 'سوريا'),
(19557, 1383367168, 1383368703, 'KW', 'KWT', 'الكويت'),
(19558, 1383368704, 1383368831, 'DE', 'DEU', 'ألمانيا'),
(19559, 1383368832, 1383368847, 'GB', 'GBR', 'المملكة المتحدة'),
(19560, 1383368848, 1383368895, 'KW', 'KWT', 'الكويت'),
(19561, 1383368896, 1383369087, 'DE', 'DEU', 'ألمانيا'),
(19562, 1383369088, 1383369119, 'GB', 'GBR', 'المملكة المتحدة'),
(19563, 1383369120, 1383369231, 'KW', 'KWT', 'الكويت'),
(19564, 1383369232, 1383369247, 'GB', 'GBR', 'المملكة المتحدة'),
(19565, 1383369248, 1383369535, 'KW', 'KWT', 'الكويت'),
(19566, 1383369536, 1383369567, 'GB', 'GBR', 'المملكة المتحدة'),
(19567, 1383369568, 1383369599, 'DE', 'DEU', 'ألمانيا'),
(19568, 1383369600, 1383370751, 'KW', 'KWT', 'الكويت'),
(19569, 1383370752, 1383371775, 'DE', 'DEU', 'ألمانيا'),
(19570, 1383371776, 1383374591, 'KW', 'KWT', 'الكويت'),
(19571, 1383374592, 1383374847, 'US', 'USA', 'الولايات المتحدة'),
(19572, 1383374848, 1383383039, 'ES', 'ESP', 'إسبانيا'),
(19573, 1383383040, 1383391231, 'CY', 'CYP', 'قبرص'),
(19574, 1383391232, 1383399423, 'FI', 'FIN', 'فنلندا'),
(19575, 1383399424, 1383402015, 'LI', 'LIE', 'ليختنشتاين'),
(19576, 1383402016, 1383402023, 'CH', 'CHE', 'سويسرا'),
(19577, 1383402024, 1383407615, 'LI', 'LIE', 'ليختنشتاين'),
(19578, 1383407616, 1383415807, 'NO', 'NOR', 'النرويج'),
(19579, 1383415808, 1383423999, 'RU', 'RUS', 'الإتحاد الروسي'),
(19580, 1383424000, 1383432191, 'SE', 'SWE', 'السويد'),
(19581, 1383432192, 1383440383, 'CZ', 'CZE', 'التشيك'),
(19582, 1383440384, 1383448575, 'RU', 'RUS', 'الإتحاد الروسي'),
(19583, 1383448576, 1383449551, 'RS', 'SRB', 'صربيا'),
(19584, 1383449552, 1383449567, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(19585, 1383449568, 1383456767, 'RS', 'SRB', 'صربيا'),
(19586, 1383456768, 1383464959, 'UA', 'UKR', 'أوكرانيا'),
(19587, 1383464960, 1383473151, 'US', 'USA', 'الولايات المتحدة'),
(19588, 1383473152, 1383481343, 'DE', 'DEU', 'ألمانيا'),
(19589, 1383481344, 1383481599, 'GB', 'GBR', 'المملكة المتحدة'),
(19590, 1383481600, 1383481615, 'US', 'USA', 'الولايات المتحدة'),
(19591, 1383481616, 1383481663, 'GB', 'GBR', 'المملكة المتحدة'),
(19592, 1383481664, 1383481695, 'US', 'USA', 'الولايات المتحدة'),
(19593, 1383481696, 1383481703, 'GB', 'GBR', 'المملكة المتحدة'),
(19594, 1383481704, 1383481711, 'US', 'USA', 'الولايات المتحدة'),
(19595, 1383481712, 1383481775, 'GB', 'GBR', 'المملكة المتحدة'),
(19596, 1383481776, 1383481791, 'SA', 'SAU', 'السعودية'),
(19597, 1383481792, 1383482367, 'GB', 'GBR', 'المملكة المتحدة'),
(19598, 1383482368, 1383482879, 'NL', 'NLD', 'هولندا'),
(19599, 1383482880, 1383483375, 'GB', 'GBR', 'المملكة المتحدة'),
(19600, 1383483376, 1383483383, 'US', 'USA', 'الولايات المتحدة'),
(19601, 1383483384, 1383483887, 'GB', 'GBR', 'المملكة المتحدة'),
(19602, 1383483888, 1383483903, 'JP', 'JPN', 'اليابان'),
(19603, 1383483904, 1383485375, 'GB', 'GBR', 'المملكة المتحدة'),
(19604, 1383485376, 1383485407, 'US', 'USA', 'الولايات المتحدة'),
(19605, 1383485408, 1383497727, 'GB', 'GBR', 'المملكة المتحدة'),
(19606, 1383497728, 1383499039, 'RU', 'RUS', 'الإتحاد الروسي'),
(19607, 1383499040, 1383499047, 'UA', 'UKR', 'أوكرانيا'),
(19608, 1383499048, 1383502335, 'RU', 'RUS', 'الإتحاد الروسي'),
(19609, 1383502336, 1383502847, 'CH', 'CHE', 'سويسرا'),
(19610, 1383502848, 1383503615, 'RU', 'RUS', 'الإتحاد الروسي'),
(19611, 1383503616, 1383503616, 'CZ', 'CZE', 'التشيك'),
(19612, 1383503617, 1383505919, 'RU', 'RUS', 'الإتحاد الروسي'),
(19613, 1383505920, 1383514111, 'SA', 'SAU', 'السعودية'),
(19614, 1383514112, 1383522303, 'FI', 'FIN', 'فنلندا'),
(19615, 1383522304, 1383530495, 'BG', 'BGR', 'بلغاريا'),
(19616, 1383530496, 1383538687, 'DE', 'DEU', 'ألمانيا'),
(19617, 1383538688, 1383546879, 'IT', 'ITA', 'إيطاليا'),
(19618, 1383546880, 1383555071, 'BG', 'BGR', 'بلغاريا'),
(19619, 1383555072, 1383563263, 'SK', 'SVK', 'سلوفاكيا'),
(19620, 1383563264, 1383571455, 'RU', 'RUS', 'الإتحاد الروسي'),
(19621, 1383571456, 1383579647, 'DE', 'DEU', 'ألمانيا'),
(19622, 1383579648, 1383587839, 'IT', 'ITA', 'إيطاليا'),
(19623, 1383587840, 1383591935, 'SK', 'SVK', 'سلوفاكيا'),
(19624, 1383591936, 1383592607, 'CZ', 'CZE', 'التشيك'),
(19625, 1383592608, 1383592623, 'SK', 'SVK', 'سلوفاكيا'),
(19626, 1383592624, 1383592887, 'CZ', 'CZE', 'التشيك'),
(19627, 1383592888, 1383592895, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(19628, 1383592896, 1383593471, 'CZ', 'CZE', 'التشيك'),
(19629, 1383593472, 1383593727, 'SK', 'SVK', 'سلوفاكيا'),
(19630, 1383593728, 1383594367, 'CZ', 'CZE', 'التشيك'),
(19631, 1383594368, 1383594495, 'SK', 'SVK', 'سلوفاكيا'),
(19632, 1383594496, 1383595279, 'CZ', 'CZE', 'التشيك'),
(19633, 1383595280, 1383595295, 'SK', 'SVK', 'سلوفاكيا'),
(19634, 1383595296, 1383595467, 'CZ', 'CZE', 'التشيك'),
(19635, 1383595468, 1383595471, 'SK', 'SVK', 'سلوفاكيا'),
(19636, 1383595472, 1383596031, 'CZ', 'CZE', 'التشيك'),
(19637, 1383596032, 1384120319, 'FR', 'FRA', 'فرنسا'),
(19638, 1384153088, 1384185855, 'FI', 'FIN', 'فنلندا'),
(19639, 1384185856, 1384187903, 'DE', 'DEU', 'ألمانيا'),
(19640, 1384187904, 1384188031, 'CH', 'CHE', 'سويسرا'),
(19641, 1384188032, 1384188095, 'DE', 'DEU', 'ألمانيا'),
(19642, 1384188096, 1384188127, 'NL', 'NLD', 'هولندا'),
(19643, 1384188128, 1384189055, 'DE', 'DEU', 'ألمانيا'),
(19644, 1384189056, 1384189183, 'CH', 'CHE', 'سويسرا'),
(19645, 1384189184, 1384189439, 'AT', 'AUT', 'النمسا'),
(19646, 1384189440, 1384190463, 'DE', 'DEU', 'ألمانيا'),
(19647, 1384190464, 1384190719, 'NL', 'NLD', 'هولندا'),
(19648, 1384190720, 1384190975, 'DE', 'DEU', 'ألمانيا'),
(19649, 1384190976, 1384191231, 'DK', 'DNK', 'الدنيمارك'),
(19650, 1384191232, 1384191359, 'DE', 'DEU', 'ألمانيا'),
(19651, 1384191360, 1384191423, 'AT', 'AUT', 'النمسا'),
(19652, 1384191424, 1384191999, 'DE', 'DEU', 'ألمانيا'),
(19653, 1384192000, 1384192191, 'NL', 'NLD', 'هولندا'),
(19654, 1384192192, 1384192255, 'DE', 'DEU', 'ألمانيا'),
(19655, 1384192256, 1384192511, 'NL', 'NLD', 'هولندا'),
(19656, 1384192512, 1384192575, 'DE', 'DEU', 'ألمانيا'),
(19657, 1384192576, 1384192639, 'SE', 'SWE', 'السويد'),
(19658, 1384192640, 1384192767, 'DE', 'DEU', 'ألمانيا'),
(19659, 1384192768, 1384193023, 'BG', 'BGR', 'بلغاريا'),
(19660, 1384193024, 1384194047, 'NL', 'NLD', 'هولندا'),
(19661, 1384194048, 1384194191, 'DE', 'DEU', 'ألمانيا'),
(19662, 1384194192, 1384194207, 'AT', 'AUT', 'النمسا'),
(19663, 1384194208, 1384194271, 'DE', 'DEU', 'ألمانيا'),
(19664, 1384194272, 1384194303, 'NL', 'NLD', 'هولندا'),
(19665, 1384194304, 1384194559, 'DE', 'DEU', 'ألمانيا'),
(19666, 1384194560, 1384194815, 'NL', 'NLD', 'هولندا'),
(19667, 1384194816, 1384195711, 'DE', 'DEU', 'ألمانيا'),
(19668, 1384195712, 1384195743, 'NL', 'NLD', 'هولندا'),
(19669, 1384195744, 1384195751, 'CH', 'CHE', 'سويسرا'),
(19670, 1384195752, 1384195775, 'DE', 'DEU', 'ألمانيا'),
(19671, 1384195776, 1384195839, 'SE', 'SWE', 'السويد'),
(19672, 1384195840, 1384196095, 'DE', 'DEU', 'ألمانيا'),
(19673, 1384196096, 1384197119, 'CZ', 'CZE', 'التشيك'),
(19674, 1384197120, 1384218623, 'DE', 'DEU', 'ألمانيا'),
(19675, 1384251392, 1384267775, 'FI', 'FIN', 'فنلندا'),
(19676, 1384267776, 1384284159, 'CH', 'CHE', 'سويسرا'),
(19677, 1384284160, 1384316927, 'ES', 'ESP', 'إسبانيا'),
(19678, 1384316928, 1384349695, 'EE', 'EST', 'إستونيا'),
(19679, 1384349696, 1384382463, 'HU', 'HUN', 'هنغاريا'),
(19680, 1384382464, 1384415231, 'HR', 'HRV', 'كرواتيا'),
(19681, 1384415232, 1384480767, 'GB', 'GBR', 'المملكة المتحدة'),
(19682, 1384480768, 1384513535, 'FI', 'FIN', 'فنلندا'),
(19683, 1384513536, 1384546303, 'NO', 'NOR', 'النرويج'),
(19684, 1384546304, 1384579071, 'NL', 'NLD', 'هولندا'),
(19685, 1384579072, 1384611839, 'DE', 'DEU', 'ألمانيا'),
(19686, 1384611840, 1384644607, 'LT', 'LTU', 'ليتوانيا'),
(19687, 1384644608, 1384660991, 'GB', 'GBR', 'المملكة المتحدة'),
(19688, 1384660992, 1384677375, 'CH', 'CHE', 'سويسرا'),
(19689, 1384677376, 1384693759, 'SE', 'SWE', 'السويد'),
(19690, 1384693760, 1384710143, 'NL', 'NLD', 'هولندا'),
(19691, 1384710144, 1384726527, 'RO', 'ROM', 'رومانيا'),
(19692, 1384726528, 1384742911, 'BG', 'BGR', 'بلغاريا'),
(19693, 1384742912, 1384759295, 'RU', 'RUS', 'الإتحاد الروسي'),
(19694, 1384759296, 1384775679, 'SY', 'SYR', 'سوريا'),
(19695, 1384775680, 1384792063, 'RU', 'RUS', 'الإتحاد الروسي'),
(19696, 1384792064, 1384792575, 'FR', 'FRA', 'فرنسا'),
(19697, 1384792576, 1384792607, 'CH', 'CHE', 'سويسرا'),
(19698, 1384792608, 1384792623, 'FR', 'FRA', 'فرنسا'),
(19699, 1384792624, 1384792639, 'BE', 'BEL', 'بلجيكا'),
(19700, 1384792640, 1384793679, 'FR', 'FRA', 'فرنسا'),
(19701, 1384793680, 1384793695, 'BE', 'BEL', 'بلجيكا'),
(19702, 1384793696, 1384793791, 'FR', 'FRA', 'فرنسا'),
(19703, 1384793792, 1384793823, 'BE', 'BEL', 'بلجيكا'),
(19704, 1384793824, 1384794127, 'FR', 'FRA', 'فرنسا'),
(19705, 1384794128, 1384794143, 'CH', 'CHE', 'سويسرا'),
(19706, 1384794144, 1384794271, 'FR', 'FRA', 'فرنسا'),
(19707, 1384794272, 1384794287, 'CH', 'CHE', 'سويسرا'),
(19708, 1384794288, 1384794815, 'FR', 'FRA', 'فرنسا'),
(19709, 1384794816, 1384794847, 'BE', 'BEL', 'بلجيكا'),
(19710, 1384794848, 1384794879, 'FR', 'FRA', 'فرنسا'),
(19711, 1384794880, 1384795135, 'CH', 'CHE', 'سويسرا'),
(19712, 1384795136, 1384795279, 'FR', 'FRA', 'فرنسا'),
(19713, 1384795280, 1384795327, 'BE', 'BEL', 'بلجيكا'),
(19714, 1384795328, 1384796351, 'FR', 'FRA', 'فرنسا'),
(19715, 1384796352, 1384796415, 'IT', 'ITA', 'إيطاليا'),
(19716, 1384796416, 1384799807, 'FR', 'FRA', 'فرنسا'),
(19717, 1384799808, 1384799871, 'CH', 'CHE', 'سويسرا'),
(19718, 1384799872, 1384801023, 'FR', 'FRA', 'فرنسا'),
(19719, 1384801024, 1384801087, 'SM', 'SMR', 'سان مارينو'),
(19720, 1384801088, 1384802495, 'FR', 'FRA', 'فرنسا'),
(19721, 1384802496, 1384802559, 'IT', 'ITA', 'إيطاليا'),
(19722, 1384802560, 1384808447, 'FR', 'FRA', 'فرنسا'),
(19723, 1384808960, 1384808967, 'DE', 'DEU', 'ألمانيا'),
(19724, 1384808968, 1384808975, 'SE', 'SWE', 'السويد'),
(19725, 1384808976, 1384808991, 'DE', 'DEU', 'ألمانيا'),
(19726, 1384808992, 1384809007, 'FI', 'FIN', 'فنلندا'),
(19727, 1384809008, 1384809015, 'PT', 'PRT', 'البورتوغال'),
(19728, 1384809016, 1384809023, 'GB', 'GBR', 'المملكة المتحدة'),
(19729, 1384809040, 1384809055, 'FR', 'FRA', 'فرنسا'),
(19730, 1384809056, 1384809063, 'GE', 'GEO', 'جورجيا'),
(19731, 1384809064, 1384809071, 'GB', 'GBR', 'المملكة المتحدة'),
(19732, 1384809088, 1384809103, 'FR', 'FRA', 'فرنسا'),
(19733, 1384811008, 1384811519, 'GB', 'GBR', 'المملكة المتحدة'),
(19734, 1384811520, 1384811647, 'IR', 'IRN', 'إيران'),
(19735, 1384812800, 1384813311, 'GB', 'GBR', 'المملكة المتحدة'),
(19736, 1384818464, 1384818495, 'BE', 'BEL', 'بلجيكا'),
(19737, 1384824832, 1384841215, 'GB', 'GBR', 'المملكة المتحدة'),
(19738, 1384841216, 1384857599, 'PL', 'POL', 'بولندا'),
(19739, 1384857600, 1384873983, 'NL', 'NLD', 'هولندا'),
(19740, 1384873984, 1384890367, 'PL', 'POL', 'بولندا'),
(19741, 1384890368, 1384923135, 'DE', 'DEU', 'ألمانيا'),
(19742, 1384923136, 1384939519, 'RU', 'RUS', 'الإتحاد الروسي'),
(19743, 1384939520, 1384955903, 'LT', 'LTU', 'ليتوانيا'),
(19744, 1384955904, 1384972287, 'RU', 'RUS', 'الإتحاد الروسي'),
(19745, 1384972288, 1384978975, 'DE', 'DEU', 'ألمانيا'),
(19746, 1384978976, 1384978991, 'NL', 'NLD', 'هولندا'),
(19747, 1384978992, 1384988671, 'DE', 'DEU', 'ألمانيا'),
(19748, 1384988672, 1385005055, 'FI', 'FIN', 'فنلندا'),
(19749, 1385005056, 1385021439, 'HU', 'HUN', 'هنغاريا'),
(19750, 1385021440, 1385037823, 'IE', 'IRL', 'إيرلندا'),
(19751, 1385037824, 1385054207, 'FR', 'FRA', 'فرنسا'),
(19752, 1385054208, 1385070591, 'CZ', 'CZE', 'التشيك'),
(19753, 1385070592, 1385086975, 'RU', 'RUS', 'الإتحاد الروسي'),
(19754, 1385086976, 1385103359, 'GB', 'GBR', 'المملكة المتحدة'),
(19755, 1385103360, 1385119743, 'IT', 'ITA', 'إيطاليا'),
(19756, 1385119744, 1385136127, 'BE', 'BEL', 'بلجيكا'),
(19757, 1385136128, 1385152511, 'PL', 'POL', 'بولندا'),
(19758, 1385152512, 1385168895, 'DK', 'DNK', 'الدنيمارك'),
(19759, 1385168896, 1385177087, 'ES', 'ESP', 'إسبانيا'),
(19760, 1385177088, 1385185279, 'DE', 'DEU', 'ألمانيا'),
(19761, 1385185280, 1385193471, 'RU', 'RUS', 'الإتحاد الروسي'),
(19762, 1385193472, 1385201663, 'ES', 'ESP', 'إسبانيا'),
(19763, 1385201664, 1385209855, 'CZ', 'CZE', 'التشيك'),
(19764, 1385209856, 1385218047, 'HU', 'HUN', 'هنغاريا'),
(19765, 1385218048, 1385226239, 'UA', 'UKR', 'أوكرانيا'),
(19766, 1385226240, 1385234431, 'GB', 'GBR', 'المملكة المتحدة'),
(19767, 1385234432, 1385242623, 'DE', 'DEU', 'ألمانيا'),
(19768, 1385242624, 1385250815, 'GB', 'GBR', 'المملكة المتحدة'),
(19769, 1385250816, 1385259007, 'PL', 'POL', 'بولندا'),
(19770, 1385259008, 1385267199, 'IT', 'ITA', 'إيطاليا'),
(19771, 1385267200, 1385275391, 'SE', 'SWE', 'السويد'),
(19772, 1385275392, 1385283583, 'IT', 'ITA', 'إيطاليا'),
(19773, 1385283584, 1385291775, 'KW', 'KWT', 'الكويت'),
(19774, 1385291776, 1385299967, 'TR', 'TUR', 'تركيا'),
(19775, 1385299968, 1385308159, 'BG', 'BGR', 'بلغاريا'),
(19776, 1385308160, 1385310207, 'BE', 'BEL', 'بلجيكا'),
(19777, 1385310208, 1385312255, 'RU', 'RUS', 'الإتحاد الروسي'),
(19778, 1385312256, 1385314303, 'US', 'USA', 'الولايات المتحدة'),
(19779, 1385314304, 1385316351, 'RU', 'RUS', 'الإتحاد الروسي'),
(19780, 1385316352, 1385324543, 'NO', 'NOR', 'النرويج'),
(19781, 1385324544, 1385332735, 'BE', 'BEL', 'بلجيكا'),
(19782, 1385332736, 1385340927, 'GB', 'GBR', 'المملكة المتحدة'),
(19783, 1385340928, 1385349119, 'LB', 'LBN', 'لبنان'),
(19784, 1385349120, 1385357311, 'CH', 'CHE', 'سويسرا'),
(19785, 1385357312, 1385365503, 'PL', 'POL', 'بولندا'),
(19786, 1385365504, 1385373695, 'GB', 'GBR', 'المملكة المتحدة'),
(19787, 1385373696, 1385381887, 'NO', 'NOR', 'النرويج'),
(19788, 1385381888, 1385398271, 'RU', 'RUS', 'الإتحاد الروسي'),
(19789, 1385398272, 1385406463, 'BG', 'BGR', 'بلغاريا'),
(19790, 1385406464, 1385414655, 'EE', 'EST', 'إستونيا'),
(19791, 1385414656, 1385422847, 'SA', 'SAU', 'السعودية'),
(19792, 1385422848, 1385431039, 'DK', 'DNK', 'الدنيمارك'),
(19793, 1385431040, 1385439231, 'RU', 'RUS', 'الإتحاد الروسي'),
(19794, 1385439232, 1385447423, 'GB', 'GBR', 'المملكة المتحدة'),
(19795, 1385447424, 1385455615, 'IS', 'ISL', 'أيسلندا'),
(19796, 1385455616, 1385463807, 'QA', 'QAT', 'قطر'),
(19797, 1385463808, 1385480191, 'NO', 'NOR', 'النرويج'),
(19798, 1385480192, 1385488383, 'NL', 'NLD', 'هولندا'),
(19799, 1385488384, 1385496575, 'GB', 'GBR', 'المملكة المتحدة'),
(19800, 1385496576, 1385504767, 'SI', 'SVN', 'سلوفينيا'),
(19801, 1385504768, 1385512959, 'GB', 'GBR', 'المملكة المتحدة'),
(19802, 1385512960, 1385521151, 'DE', 'DEU', 'ألمانيا'),
(19803, 1385521152, 1385529343, 'AT', 'AUT', 'النمسا'),
(19804, 1385529344, 1385537535, 'RU', 'RUS', 'الإتحاد الروسي'),
(19805, 1385537536, 1385545727, 'DE', 'DEU', 'ألمانيا'),
(19806, 1385545728, 1385553919, 'RU', 'RUS', 'الإتحاد الروسي'),
(19807, 1385553920, 1385554515, 'DE', 'DEU', 'ألمانيا'),
(19808, 1385554516, 1385554519, 'CH', 'CHE', 'سويسرا'),
(19809, 1385554520, 1385554527, 'DE', 'DEU', 'ألمانيا'),
(19810, 1385554528, 1385554531, 'AT', 'AUT', 'النمسا'),
(19811, 1385554532, 1385554719, 'DE', 'DEU', 'ألمانيا'),
(19812, 1385554720, 1385554735, 'AT', 'AUT', 'النمسا'),
(19813, 1385554736, 1385557503, 'DE', 'DEU', 'ألمانيا'),
(19814, 1385557504, 1385557759, 'AT', 'AUT', 'النمسا'),
(19815, 1385557760, 1385559039, 'DE', 'DEU', 'ألمانيا'),
(19816, 1385559040, 1385559295, 'SK', 'SVK', 'سلوفاكيا'),
(19817, 1385559296, 1385560831, 'DE', 'DEU', 'ألمانيا'),
(19818, 1385560832, 1385561087, 'SK', 'SVK', 'سلوفاكيا'),
(19819, 1385561088, 1385562111, 'DE', 'DEU', 'ألمانيا'),
(19820, 1385562112, 1385563135, 'ES', 'ESP', 'إسبانيا'),
(19821, 1385563136, 1385563391, 'IE', 'IRL', 'إيرلندا'),
(19822, 1385563648, 1385563935, 'IE', 'IRL', 'إيرلندا'),
(19823, 1385564032, 1385564095, 'IE', 'IRL', 'إيرلندا'),
(19824, 1385564104, 1385564127, 'IE', 'IRL', 'إيرلندا'),
(19825, 1385564160, 1385564231, 'HU', 'HUN', 'هنغاريا'),
(19826, 1385564384, 1385564671, 'HU', 'HUN', 'هنغاريا'),
(19827, 1385565184, 1385565439, 'ES', 'ESP', 'إسبانيا'),
(19828, 1385566208, 1385566399, 'FR', 'FRA', 'فرنسا'),
(19829, 1385566432, 1385566847, 'FR', 'FRA', 'فرنسا'),
(19830, 1385566928, 1385566935, 'FR', 'FRA', 'فرنسا'),
(19831, 1385566944, 1385566991, 'FR', 'FRA', 'فرنسا'),
(19832, 1385567000, 1385567023, 'FR', 'FRA', 'فرنسا'),
(19833, 1385567088, 1385567103, 'FR', 'FRA', 'فرنسا'),
(19834, 1385567136, 1385567155, 'FR', 'FRA', 'فرنسا'),
(19835, 1385567160, 1385567215, 'FR', 'FRA', 'فرنسا'),
(19836, 1385567224, 1385567227, 'FR', 'FRA', 'فرنسا'),
(19837, 1385567232, 1385568255, 'IE', 'IRL', 'إيرلندا'),
(19838, 1385568256, 1385568767, 'FR', 'FRA', 'فرنسا'),
(19839, 1385569280, 1385569407, 'FR', 'FRA', 'فرنسا'),
(19840, 1385569408, 1385569487, 'CZ', 'CZE', 'التشيك'),
(19841, 1385569528, 1385569535, 'GB', 'GBR', 'المملكة المتحدة'),
(19842, 1385569792, 1385570303, 'FR', 'FRA', 'فرنسا'),
(19843, 1385570304, 1385578495, 'HU', 'HUN', 'هنغاريا'),
(19844, 1385578496, 1385586687, 'TR', 'TUR', 'تركيا'),
(19845, 1385586688, 1385587967, 'GB', 'GBR', 'المملكة المتحدة'),
(19846, 1385587968, 1385588735, 'US', 'USA', 'الولايات المتحدة'),
(19847, 1385588736, 1385589247, 'HK', 'HKG', 'هونغ كونغ'),
(19848, 1385589248, 1385589503, 'JP', 'JPN', 'اليابان'),
(19849, 1385589504, 1385589759, 'SG', 'SGP', 'سنغافورة'),
(19850, 1385589760, 1385590015, 'JP', 'JPN', 'اليابان'),
(19851, 1385590016, 1385590783, 'GB', 'GBR', 'المملكة المتحدة'),
(19852, 1385590784, 1385591295, 'US', 'USA', 'الولايات المتحدة'),
(19853, 1385591296, 1385591807, 'HK', 'HKG', 'هونغ كونغ'),
(19854, 1385591808, 1385592063, 'SG', 'SGP', 'سنغافورة'),
(19855, 1385592064, 1385594879, 'GB', 'GBR', 'المملكة المتحدة'),
(19856, 1385594880, 1385603071, 'NL', 'NLD', 'هولندا'),
(19857, 1385603072, 1385611263, 'CZ', 'CZE', 'التشيك'),
(19858, 1385611264, 1385619455, 'AT', 'AUT', 'النمسا'),
(19859, 1385619456, 1385625599, 'DE', 'DEU', 'ألمانيا'),
(19860, 1385625600, 1385626111, 'FR', 'FRA', 'فرنسا'),
(19861, 1385626112, 1385627647, 'DE', 'DEU', 'ألمانيا'),
(19862, 1385635840, 1385644031, 'NL', 'NLD', 'هولندا'),
(19863, 1385652224, 1385660415, 'RU', 'RUS', 'الإتحاد الروسي'),
(19864, 1385660416, 1385668607, 'TR', 'TUR', 'تركيا'),
(19865, 1385668608, 1385676799, 'NL', 'NLD', 'هولندا'),
(19866, 1385676800, 1385684991, 'RU', 'RUS', 'الإتحاد الروسي'),
(19867, 1385684992, 1385824255, 'GB', 'GBR', 'المملكة المتحدة'),
(19868, 1385824256, 1385955327, 'PT', 'PRT', 'البورتوغال'),
(19869, 1385955328, 1386086399, 'NL', 'NLD', 'هولندا'),
(19870, 1386086400, 1386217471, 'ES', 'ESP', 'إسبانيا'),
(19871, 1386217472, 1386283007, 'PL', 'POL', 'بولندا'),
(19872, 1386283008, 1386348543, 'NL', 'NLD', 'هولندا'),
(19873, 1386348544, 1386414079, 'RU', 'RUS', 'الإتحاد الروسي'),
(19874, 1386414080, 1386479615, 'GB', 'GBR', 'المملكة المتحدة'),
(19875, 1386479616, 1386545151, 'NO', 'NOR', 'النرويج'),
(19876, 1386545152, 1386577919, 'DE', 'DEU', 'ألمانيا'),
(19877, 1386577920, 1386594303, 'US', 'USA', 'الولايات المتحدة'),
(19878, 1386594304, 1386602495, 'DE', 'DEU', 'ألمانيا'),
(19879, 1386602496, 1386610687, 'US', 'USA', 'الولايات المتحدة'),
(19880, 1386610688, 1386676223, 'IL', 'ISR', 'إسرائيل'),
(19881, 1386676224, 1386741759, 'SA', 'SAU', 'السعودية'),
(19882, 1386741760, 1387233623, 'NL', 'NLD', 'هولندا'),
(19883, 1387233624, 1387233627, 'BE', 'BEL', 'بلجيكا'),
(19884, 1387233628, 1387233663, 'NL', 'NLD', 'هولندا'),
(19885, 1387233664, 1387233727, 'BE', 'BEL', 'بلجيكا'),
(19886, 1387233728, 1387233791, 'NL', 'NLD', 'هولندا'),
(19887, 1387233792, 1387233919, 'BE', 'BEL', 'بلجيكا'),
(19888, 1387233920, 1387249663, 'NL', 'NLD', 'هولندا'),
(19889, 1387249664, 1387251231, 'BE', 'BEL', 'بلجيكا'),
(19890, 1387251232, 1387251263, 'NL', 'NLD', 'هولندا'),
(19891, 1387251264, 1387251615, 'BE', 'BEL', 'بلجيكا'),
(19892, 1387251616, 1387251647, 'NL', 'NLD', 'هولندا'),
(19893, 1387251648, 1387251727, 'BE', 'BEL', 'بلجيكا'),
(19894, 1387251728, 1387251751, 'NL', 'NLD', 'هولندا'),
(19895, 1387251752, 1387251759, 'BE', 'BEL', 'بلجيكا'),
(19896, 1387251760, 1387252223, 'NL', 'NLD', 'هولندا'),
(19897, 1387252224, 1387252479, 'BE', 'BEL', 'بلجيكا'),
(19898, 1387252480, 1387331583, 'NL', 'NLD', 'هولندا'),
(19899, 1387331584, 1387397119, 'PL', 'POL', 'بولندا'),
(19900, 1387397120, 1387462655, 'OM', 'OMN', 'عمان'),
(19901, 1387462656, 1387528191, 'RU', 'RUS', 'الإتحاد الروسي'),
(19902, 1387528192, 1387593727, 'DK', 'DNK', 'الدنيمارك'),
(19903, 1387593728, 1387659263, 'FI', 'FIN', 'فنلندا'),
(19904, 1387659264, 1387790335, 'SE', 'SWE', 'السويد'),
(19905, 1387790336, 1388314623, 'IT', 'ITA', 'إيطاليا'),
(19906, 1388314624, 1388322815, 'AT', 'AUT', 'النمسا'),
(19907, 1388322816, 1388331007, 'SI', 'SVN', 'سلوفينيا'),
(19908, 1388331008, 1388339199, 'NL', 'NLD', 'هولندا'),
(19909, 1388339200, 1388347391, 'GB', 'GBR', 'المملكة المتحدة'),
(19910, 1388347392, 1388363775, 'DK', 'DNK', 'الدنيمارك'),
(19911, 1388363776, 1388371967, 'DE', 'DEU', 'ألمانيا'),
(19912, 1388371968, 1388380159, 'CH', 'CHE', 'سويسرا'),
(19913, 1388380160, 1388396543, 'IT', 'ITA', 'إيطاليا'),
(19914, 1388396544, 1388404735, 'LV', 'LVA', 'لاتفيا'),
(19915, 1388404736, 1388412927, 'UA', 'UKR', 'أوكرانيا'),
(19916, 1388412928, 1388421119, 'RU', 'RUS', 'الإتحاد الروسي'),
(19917, 1388421120, 1388429311, 'SE', 'SWE', 'السويد'),
(19918, 1388429312, 1388437503, 'HR', 'HRV', 'كرواتيا'),
(19919, 1388437504, 1388445695, 'DE', 'DEU', 'ألمانيا'),
(19920, 1388445696, 1388453887, 'AZ', 'AZE', 'أذربيجان'),
(19921, 1388453888, 1388462079, 'BH', 'BHR', 'البحرين'),
(19922, 1388462080, 1388470271, 'ES', 'ESP', 'إسبانيا'),
(19923, 1388470272, 1388478463, 'DE', 'DEU', 'ألمانيا'),
(19924, 1388478464, 1388486655, 'AT', 'AUT', 'النمسا'),
(19925, 1388486656, 1388494847, 'RU', 'RUS', 'الإتحاد الروسي'),
(19926, 1388494848, 1388503039, 'NO', 'NOR', 'النرويج'),
(19927, 1388503040, 1388519423, 'RU', 'RUS', 'الإتحاد الروسي'),
(19928, 1388519424, 1388527615, 'NL', 'NLD', 'هولندا'),
(19929, 1388527616, 1388535807, 'DE', 'DEU', 'ألمانيا'),
(19930, 1388535808, 1388543999, 'GB', 'GBR', 'المملكة المتحدة'),
(19931, 1388544000, 1388546191, 'IE', 'IRL', 'إيرلندا'),
(19932, 1388546192, 1388546201, 'GB', 'GBR', 'المملكة المتحدة'),
(19933, 1388546202, 1388547583, 'IE', 'IRL', 'إيرلندا'),
(19934, 1388547584, 1388547775, 'GB', 'GBR', 'المملكة المتحدة'),
(19935, 1388547776, 1388547871, 'IE', 'IRL', 'إيرلندا'),
(19936, 1388547872, 1388547903, 'GB', 'GBR', 'المملكة المتحدة'),
(19937, 1388547904, 1388547935, 'IE', 'IRL', 'إيرلندا'),
(19938, 1388547936, 1388547951, 'GB', 'GBR', 'المملكة المتحدة'),
(19939, 1388547952, 1388552191, 'IE', 'IRL', 'إيرلندا'),
(19940, 1388552192, 1388560383, 'GB', 'GBR', 'المملكة المتحدة'),
(19941, 1388560384, 1388568575, 'FI', 'FIN', 'فنلندا'),
(19942, 1388568576, 1388576767, 'CH', 'CHE', 'سويسرا'),
(19943, 1388576768, 1388584959, 'FR', 'FRA', 'فرنسا'),
(19944, 1388584960, 1388586303, 'GB', 'GBR', 'المملكة المتحدة'),
(19945, 1388586368, 1388586391, 'GB', 'GBR', 'المملكة المتحدة'),
(19946, 1388586400, 1388586447, 'GB', 'GBR', 'المملكة المتحدة'),
(19947, 1388586456, 1388586495, 'GB', 'GBR', 'المملكة المتحدة'),
(19948, 1388587264, 1388587391, 'GB', 'GBR', 'المملكة المتحدة'),
(19949, 1388587408, 1388587423, 'GB', 'GBR', 'المملكة المتحدة'),
(19950, 1388587440, 1388587471, 'GB', 'GBR', 'المملكة المتحدة'),
(19951, 1388587488, 1388587503, 'FR', 'FRA', 'فرنسا'),
(19952, 1388587504, 1388587511, 'GB', 'GBR', 'المملكة المتحدة'),
(19953, 1388587520, 1388587615, 'GB', 'GBR', 'المملكة المتحدة'),
(19954, 1388587632, 1388588415, 'GB', 'GBR', 'المملكة المتحدة'),
(19955, 1388588544, 1388588575, 'US', 'USA', 'الولايات المتحدة'),
(19956, 1388588784, 1388588799, 'US', 'USA', 'الولايات المتحدة'),
(19957, 1388588800, 1388589823, 'GB', 'GBR', 'المملكة المتحدة'),
(19958, 1388590080, 1388590127, 'FR', 'FRA', 'فرنسا'),
(19959, 1388590328, 1388590335, 'FR', 'FRA', 'فرنسا'),
(19960, 1388591104, 1388591151, 'SG', 'SGP', 'سنغافورة'),
(19961, 1388591168, 1388591187, 'SG', 'SGP', 'سنغافورة'),
(19962, 1388591200, 1388591231, 'SG', 'SGP', 'سنغافورة'),
(19963, 1388591304, 1388591311, 'SG', 'SGP', 'سنغافورة'),
(19964, 1388591356, 1388591359, 'SG', 'SGP', 'سنغافورة'),
(19965, 1388591616, 1388591631, 'US', 'USA', 'الولايات المتحدة'),
(19966, 1388591648, 1388591663, 'US', 'USA', 'الولايات المتحدة'),
(19967, 1388593152, 1388601343, 'RU', 'RUS', 'الإتحاد الروسي'),
(19968, 1388601344, 1388609535, 'SE', 'SWE', 'السويد'),
(19969, 1388609536, 1388617727, 'RU', 'RUS', 'الإتحاد الروسي'),
(19970, 1388617728, 1388625919, 'SE', 'SWE', 'السويد'),
(19971, 1388625920, 1388634111, 'NO', 'NOR', 'النرويج'),
(19972, 1388634112, 1388642303, 'GB', 'GBR', 'المملكة المتحدة'),
(19973, 1388642304, 1388650495, 'FI', 'FIN', 'فنلندا'),
(19974, 1388650496, 1388658687, 'PL', 'POL', 'بولندا'),
(19975, 1388658688, 1388666879, 'GB', 'GBR', 'المملكة المتحدة'),
(19976, 1388666880, 1388675071, 'GR', 'GRC', 'اليونان'),
(19977, 1388675072, 1388675327, 'NL', 'NLD', 'هولندا'),
(19978, 1388675584, 1388676095, 'DE', 'DEU', 'ألمانيا'),
(19979, 1388677120, 1388677375, 'GB', 'GBR', 'المملكة المتحدة'),
(19980, 1388677632, 1388677663, 'AT', 'AUT', 'النمسا'),
(19981, 1388677888, 1388679167, 'DE', 'DEU', 'ألمانيا'),
(19982, 1388679168, 1388679423, 'FR', 'FRA', 'فرنسا'),
(19983, 1388679424, 1388679455, 'DE', 'DEU', 'ألمانيا'),
(19984, 1388679680, 1388680703, 'DE', 'DEU', 'ألمانيا'),
(19985, 1388680960, 1388682239, 'DE', 'DEU', 'ألمانيا'),
(19986, 1388682752, 1388683263, 'DE', 'DEU', 'ألمانيا'),
(19987, 1388683264, 1388689639, 'CH', 'CHE', 'سويسرا'),
(19988, 1388689640, 1388689647, 'DE', 'DEU', 'ألمانيا'),
(19989, 1388689648, 1388691455, 'CH', 'CHE', 'سويسرا'),
(19990, 1388691456, 1388699647, 'NL', 'NLD', 'هولندا'),
(19991, 1388699648, 1388707839, 'SE', 'SWE', 'السويد'),
(19992, 1388707840, 1388708863, 'RU', 'RUS', 'الإتحاد الروسي'),
(19993, 1388708864, 1388709119, 'LB', 'LBN', 'لبنان'),
(19994, 1388709120, 1388712191, 'RU', 'RUS', 'الإتحاد الروسي'),
(19995, 1388712192, 1388712703, 'LT', 'LTU', 'ليتوانيا'),
(19996, 1388712704, 1388713215, 'LB', 'LBN', 'لبنان'),
(19997, 1388713216, 1388713727, 'TJ', 'TJK', 'طاجيكيستان'),
(19998, 1388713728, 1388714239, 'LB', 'LBN', 'لبنان'),
(19999, 1388714240, 1388714495, 'LT', 'LTU', 'ليتوانيا'),
(20000, 1388714496, 1388714751, 'RU', 'RUS', 'الإتحاد الروسي'),
(20001, 1388714752, 1388715007, 'IQ', 'IRQ', 'العراق'),
(20002, 1388715008, 1388715263, 'LT', 'LTU', 'ليتوانيا'),
(20003, 1388715264, 1388715519, 'LB', 'LBN', 'لبنان'),
(20004, 1388715520, 1388715775, 'LV', 'LVA', 'لاتفيا'),
(20005, 1388715776, 1388716031, 'LT', 'LTU', 'ليتوانيا'),
(20006, 1388716032, 1388724223, 'ES', 'ESP', 'إسبانيا'),
(20007, 1388724224, 1388728600, 'DE', 'DEU', 'ألمانيا'),
(20008, 1388728601, 1388728608, 'CZ', 'CZE', 'التشيك'),
(20009, 1388728609, 1388728640, 'DE', 'DEU', 'ألمانيا'),
(20010, 1388728641, 1388728673, 'AT', 'AUT', 'النمسا'),
(20011, 1388728674, 1388728734, 'DE', 'DEU', 'ألمانيا'),
(20012, 1388728735, 1388728762, 'AT', 'AUT', 'النمسا'),
(20013, 1388728763, 1388728783, 'DE', 'DEU', 'ألمانيا'),
(20014, 1388728784, 1388728799, 'AT', 'AUT', 'النمسا'),
(20015, 1388728800, 1388728815, 'DE', 'DEU', 'ألمانيا'),
(20016, 1388728816, 1388728820, 'AT', 'AUT', 'النمسا'),
(20017, 1388728821, 1388729208, 'DE', 'DEU', 'ألمانيا'),
(20018, 1388729209, 1388729240, 'AT', 'AUT', 'النمسا'),
(20019, 1388729241, 1388729280, 'DE', 'DEU', 'ألمانيا'),
(20020, 1388729281, 1388729296, 'AT', 'AUT', 'النمسا'),
(20021, 1388729297, 1388729304, 'DE', 'DEU', 'ألمانيا'),
(20022, 1388729305, 1388729320, 'AT', 'AUT', 'النمسا'),
(20023, 1388729321, 1388729856, 'DE', 'DEU', 'ألمانيا'),
(20024, 1388729857, 1388729888, 'AT', 'AUT', 'النمسا'),
(20025, 1388729889, 1388731136, 'DE', 'DEU', 'ألمانيا'),
(20026, 1388731137, 1388731391, 'AT', 'AUT', 'النمسا'),
(20027, 1388731392, 1388732415, 'DE', 'DEU', 'ألمانيا'),
(20028, 1388732416, 1388740607, 'ES', 'ESP', 'إسبانيا'),
(20029, 1388740608, 1388746967, 'IE', 'IRL', 'إيرلندا'),
(20030, 1388746968, 1388746975, 'GB', 'GBR', 'المملكة المتحدة'),
(20031, 1388746976, 1388748799, 'IE', 'IRL', 'إيرلندا'),
(20032, 1388748800, 1388756991, 'RU', 'RUS', 'الإتحاد الروسي'),
(20033, 1388756992, 1388765183, 'DE', 'DEU', 'ألمانيا'),
(20034, 1388765184, 1388773375, 'GB', 'GBR', 'المملكة المتحدة'),
(20035, 1388773376, 1388781567, 'NO', 'NOR', 'النرويج'),
(20036, 1388781568, 1388789759, 'ES', 'ESP', 'إسبانيا'),
(20037, 1388789760, 1388797951, 'NL', 'NLD', 'هولندا'),
(20038, 1388797952, 1388806143, 'RU', 'RUS', 'الإتحاد الروسي'),
(20039, 1388814336, 1388815103, 'AX', 'FIN', 'فنلندا'),
(20040, 1388815104, 1388815231, 'FI', 'FIN', 'فنلندا'),
(20041, 1388815232, 1388818687, 'AX', 'FIN', 'فنلندا'),
(20042, 1388818688, 1388818815, 'FI', 'FIN', 'فنلندا'),
(20043, 1388818816, 1388821119, 'AX', 'FIN', 'فنلندا'),
(20044, 1388821120, 1388821150, 'SE', 'SWE', 'السويد'),
(20045, 1388821151, 1388821247, 'AX', 'FIN', 'فنلندا'),
(20046, 1388821248, 1388822527, 'SE', 'SWE', 'السويد'),
(20047, 1388822528, 1388830719, 'BG', 'BGR', 'بلغاريا'),
(20048, 1388830720, 1388838911, 'FI', 'FIN', 'فنلندا'),
(20049, 1388838912, 1388871679, 'RU', 'RUS', 'الإتحاد الروسي'),
(20050, 1388871680, 1388904447, 'KZ', 'KAZ', 'كازاخستان'),
(20051, 1388904448, 1388937215, 'NL', 'NLD', 'هولندا'),
(20052, 1388969984, 1389002751, 'CZ', 'CZE', 'التشيك'),
(20053, 1389002752, 1389035519, 'RU', 'RUS', 'الإتحاد الروسي'),
(20054, 1389035520, 1389068287, 'GB', 'GBR', 'المملكة المتحدة'),
(20055, 1389068288, 1389101055, 'FI', 'FIN', 'فنلندا'),
(20056, 1389101056, 1389133823, 'NL', 'NLD', 'هولندا'),
(20057, 1389133824, 1389166591, 'RU', 'RUS', 'الإتحاد الروسي'),
(20058, 1389166592, 1389199359, 'PS', 'PSE', 'فلسطين المحتلة'),
(20059, 1389199360, 1389199615, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20060, 1389199616, 1389199647, 'IR', 'IRN', 'إيران'),
(20061, 1389199648, 1389203391, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20062, 1389203392, 1389203455, 'IR', 'IRN', 'إيران'),
(20063, 1389203456, 1389203487, 'IQ', 'IRQ', 'العراق'),
(20064, 1389203488, 1389203519, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20065, 1389203520, 1389203551, 'IQ', 'IRQ', 'العراق'),
(20066, 1389203552, 1389203567, 'LB', 'LBN', 'لبنان'),
(20067, 1389203568, 1389203583, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20068, 1389203584, 1389203615, 'IQ', 'IRQ', 'العراق'),
(20069, 1389203616, 1389203743, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20070, 1389203744, 1389203775, 'IQ', 'IRQ', 'العراق'),
(20071, 1389203776, 1389203967, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20072, 1389203968, 1389203999, 'LY', 'LBY', 'ليبيا'),
(20073, 1389204000, 1389204223, 'AE', 'ARE', 'الإمارات العربية المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(20074, 1389204224, 1389204255, 'IQ', 'IRQ', 'العراق'),
(20075, 1389204256, 1389204287, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20076, 1389204288, 1389204303, 'SA', 'SAU', 'السعودية'),
(20077, 1389204304, 1389204799, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20078, 1389204800, 1389204863, 'IQ', 'IRQ', 'العراق'),
(20079, 1389204864, 1389204879, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20080, 1389204880, 1389204895, 'IQ', 'IRQ', 'العراق'),
(20081, 1389204896, 1389205631, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20082, 1389205632, 1389205759, 'IR', 'IRN', 'إيران'),
(20083, 1389205760, 1389205791, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20084, 1389205792, 1389205935, 'IR', 'IRN', 'إيران'),
(20085, 1389205936, 1389205999, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20086, 1389206000, 1389206015, 'IR', 'IRN', 'إيران'),
(20087, 1389206016, 1389206047, 'IQ', 'IRQ', 'العراق'),
(20088, 1389206048, 1389206143, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20089, 1389206144, 1389206175, 'LY', 'LBY', 'ليبيا'),
(20090, 1389206176, 1389206271, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20091, 1389206272, 1389206656, 'IR', 'IRN', 'إيران'),
(20092, 1389206657, 1389206719, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20093, 1389206720, 1389207039, 'IR', 'IRN', 'إيران'),
(20094, 1389207040, 1389207295, 'LB', 'LBN', 'لبنان'),
(20095, 1389207296, 1389207359, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20096, 1389207360, 1389207391, 'SA', 'SAU', 'السعودية'),
(20097, 1389207392, 1389207487, 'IR', 'IRN', 'إيران'),
(20098, 1389207488, 1389207519, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20099, 1389207520, 1389207551, 'IR', 'IRN', 'إيران'),
(20100, 1389207552, 1389209087, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20101, 1389209088, 1389209343, 'IR', 'IRN', 'إيران'),
(20102, 1389209344, 1389209887, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20103, 1389209888, 1389209903, 'IQ', 'IRQ', 'العراق'),
(20104, 1389209904, 1389210127, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20105, 1389210128, 1389210207, 'IQ', 'IRQ', 'العراق'),
(20106, 1389210208, 1389210223, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20107, 1389210224, 1389210255, 'IR', 'IRN', 'إيران'),
(20108, 1389210256, 1389210271, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20109, 1389210272, 1389210303, 'IQ', 'IRQ', 'العراق'),
(20110, 1389210304, 1389210335, 'IR', 'IRN', 'إيران'),
(20111, 1389210336, 1389210623, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20112, 1389210624, 1389210655, 'IQ', 'IRQ', 'العراق'),
(20113, 1389210656, 1389210687, 'IR', 'IRN', 'إيران'),
(20114, 1389210688, 1389210719, 'IQ', 'IRQ', 'العراق'),
(20115, 1389210720, 1389210767, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20116, 1389210768, 1389210783, 'IQ', 'IRQ', 'العراق'),
(20117, 1389210784, 1389210815, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20118, 1389210816, 1389210879, 'IQ', 'IRQ', 'العراق'),
(20119, 1389210880, 1389211135, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20120, 1389211136, 1389211183, 'IQ', 'IRQ', 'العراق'),
(20121, 1389211184, 1389211199, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20122, 1389211200, 1389211263, 'IQ', 'IRQ', 'العراق'),
(20123, 1389211264, 1389211343, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20124, 1389211344, 1389211359, 'LY', 'LBY', 'ليبيا'),
(20125, 1389211360, 1389211391, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20126, 1389211392, 1389211423, 'IQ', 'IRQ', 'العراق'),
(20127, 1389211424, 1389211439, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20128, 1389211440, 1389211455, 'IQ', 'IRQ', 'العراق'),
(20129, 1389211456, 1389211519, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20130, 1389211520, 1389211535, 'IQ', 'IRQ', 'العراق'),
(20131, 1389211536, 1389211567, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20132, 1389211568, 1389211647, 'IQ', 'IRQ', 'العراق'),
(20133, 1389211648, 1389211719, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20134, 1389211720, 1389211727, 'IR', 'IRN', 'إيران'),
(20135, 1389211728, 1389212671, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20136, 1389212672, 1389212767, 'IQ', 'IRQ', 'العراق'),
(20137, 1389212768, 1389212927, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20138, 1389212928, 1389212991, 'IR', 'IRN', 'إيران'),
(20139, 1389212992, 1389213055, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20140, 1389213056, 1389213087, 'IR', 'IRN', 'إيران'),
(20141, 1389213088, 1389213119, 'IQ', 'IRQ', 'العراق'),
(20142, 1389213120, 1389213183, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20143, 1389213184, 1389213199, 'IQ', 'IRQ', 'العراق'),
(20144, 1389213200, 1389213207, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20145, 1389213208, 1389213215, 'LY', 'LBY', 'ليبيا'),
(20146, 1389213216, 1389213311, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20147, 1389213312, 1389213343, 'LY', 'LBY', 'ليبيا'),
(20148, 1389213344, 1389215231, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20149, 1389215232, 1389217791, 'AF', 'AFG', 'أفغانستان'),
(20150, 1389217792, 1389218303, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20151, 1389218304, 1389219839, 'AF', 'AFG', 'أفغانستان'),
(20152, 1389219840, 1389220095, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20153, 1389220096, 1389220143, 'SA', 'SAU', 'السعودية'),
(20154, 1389220144, 1389220191, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20155, 1389220192, 1389220207, 'IQ', 'IRQ', 'العراق'),
(20156, 1389220208, 1389220223, 'IR', 'IRN', 'إيران'),
(20157, 1389220224, 1389220479, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20158, 1389220480, 1389220495, 'IQ', 'IRQ', 'العراق'),
(20159, 1389220496, 1389220575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20160, 1389220576, 1389220591, 'IQ', 'IRQ', 'العراق'),
(20161, 1389220592, 1389220607, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20162, 1389220608, 1389220639, 'SA', 'SAU', 'السعودية'),
(20163, 1389220640, 1389220671, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20164, 1389220672, 1389220687, 'IQ', 'IRQ', 'العراق'),
(20165, 1389220688, 1389220703, 'SA', 'SAU', 'السعودية'),
(20166, 1389220704, 1389220735, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20167, 1389220736, 1389220751, 'IQ', 'IRQ', 'العراق'),
(20168, 1389220752, 1389220767, 'SA', 'SAU', 'السعودية'),
(20169, 1389220768, 1389220895, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20170, 1389220896, 1389220927, 'SA', 'SAU', 'السعودية'),
(20171, 1389220928, 1389220959, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20172, 1389220960, 1389220975, 'IQ', 'IRQ', 'العراق'),
(20173, 1389220976, 1389221119, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20174, 1389221120, 1389221631, 'LY', 'LBY', 'ليبيا'),
(20175, 1389221632, 1389221887, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20176, 1389221888, 1389222399, 'SA', 'SAU', 'السعودية'),
(20177, 1389222400, 1389222495, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20178, 1389222496, 1389222511, 'SA', 'SAU', 'السعودية'),
(20179, 1389222512, 1389222543, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20180, 1389222544, 1389222559, 'LY', 'LBY', 'ليبيا'),
(20181, 1389222560, 1389222591, 'SA', 'SAU', 'السعودية'),
(20182, 1389222592, 1389222607, 'IQ', 'IRQ', 'العراق'),
(20183, 1389222608, 1389222687, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20184, 1389222688, 1389222703, 'IR', 'IRN', 'إيران'),
(20185, 1389222704, 1389222719, 'SA', 'SAU', 'السعودية'),
(20186, 1389222720, 1389222751, 'IQ', 'IRQ', 'العراق'),
(20187, 1389222752, 1389222799, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20188, 1389222800, 1389222815, 'SA', 'SAU', 'السعودية'),
(20189, 1389222816, 1389222847, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20190, 1389222848, 1389222879, 'SA', 'SAU', 'السعودية'),
(20191, 1389222880, 1389222911, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20192, 1389222912, 1389223167, 'SA', 'SAU', 'السعودية'),
(20193, 1389223168, 1389223175, 'LY', 'LBY', 'ليبيا'),
(20194, 1389223176, 1389223183, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20195, 1389223184, 1389223215, 'SA', 'SAU', 'السعودية'),
(20196, 1389223216, 1389223231, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20197, 1389223232, 1389223263, 'SA', 'SAU', 'السعودية'),
(20198, 1389223264, 1389223327, 'IQ', 'IRQ', 'العراق'),
(20199, 1389223328, 1389223423, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20200, 1389223424, 1389223471, 'SA', 'SAU', 'السعودية'),
(20201, 1389223472, 1389223487, 'IQ', 'IRQ', 'العراق'),
(20202, 1389223488, 1389223519, 'LY', 'LBY', 'ليبيا'),
(20203, 1389223520, 1389223679, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20204, 1389223680, 1389224191, 'DE', 'DEU', 'ألمانيا'),
(20205, 1389224192, 1389224447, 'SA', 'SAU', 'السعودية'),
(20206, 1389224448, 1389224511, 'IR', 'IRN', 'إيران'),
(20207, 1389224512, 1389224543, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20208, 1389224544, 1389224559, 'IR', 'IRN', 'إيران'),
(20209, 1389224560, 1389224575, 'SA', 'SAU', 'السعودية'),
(20210, 1389224576, 1389224703, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20211, 1389224704, 1389224959, 'LY', 'LBY', 'ليبيا'),
(20212, 1389224960, 1389225215, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20213, 1389225216, 1389225471, 'SA', 'SAU', 'السعودية'),
(20214, 1389225472, 1389225535, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20215, 1389225536, 1389225599, 'IQ', 'IRQ', 'العراق'),
(20216, 1389225600, 1389227775, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20217, 1389227776, 1389227791, 'IQ', 'IRQ', 'العراق'),
(20218, 1389227792, 1389227839, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20219, 1389227840, 1389227855, 'SA', 'SAU', 'السعودية'),
(20220, 1389227856, 1389228031, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20221, 1389228032, 1389228047, 'IQ', 'IRQ', 'العراق'),
(20222, 1389228048, 1389228063, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20223, 1389228064, 1389228079, 'IQ', 'IRQ', 'العراق'),
(20224, 1389228080, 1389228303, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20225, 1389228304, 1389228319, 'IQ', 'IRQ', 'العراق'),
(20226, 1389228320, 1389228415, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20227, 1389228416, 1389228479, 'LB', 'LBN', 'لبنان'),
(20228, 1389228480, 1389228799, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20229, 1389228800, 1389229055, 'LI', 'LIE', 'ليختنشتاين'),
(20230, 1389229056, 1389231871, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20231, 1389231872, 1389232127, 'SA', 'SAU', 'السعودية'),
(20232, 1389232128, 1389232319, 'DE', 'DEU', 'ألمانيا'),
(20233, 1389232320, 1389232327, 'LT', 'LTU', 'ليتوانيا'),
(20234, 1389232328, 1389264031, 'DE', 'DEU', 'ألمانيا'),
(20235, 1389264032, 1389264063, 'ES', 'ESP', 'إسبانيا'),
(20236, 1389264064, 1389264127, 'DE', 'DEU', 'ألمانيا'),
(20237, 1389264128, 1389264639, 'ES', 'ESP', 'إسبانيا'),
(20238, 1389264640, 1389264911, 'US', 'USA', 'الولايات المتحدة'),
(20239, 1389264912, 1389264927, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20240, 1389264928, 1389264943, 'GB', 'GBR', 'المملكة المتحدة'),
(20241, 1389264944, 1389264959, 'GH', 'GHA', 'غانا'),
(20242, 1389264960, 1389265039, 'TZ', 'TZA', 'تانزانيا'),
(20243, 1389265040, 1389265055, 'GB', 'GBR', 'المملكة المتحدة'),
(20244, 1389265056, 1389265071, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20245, 1389265072, 1389265079, 'GB', 'GBR', 'المملكة المتحدة'),
(20246, 1389265080, 1389265087, 'NG', 'NGA', 'نيجيريا'),
(20247, 1389265088, 1389265127, 'GB', 'GBR', 'المملكة المتحدة'),
(20248, 1389265128, 1389265135, 'BH', 'BHR', 'البحرين'),
(20249, 1389265136, 1389265151, 'GB', 'GBR', 'المملكة المتحدة'),
(20250, 1389265152, 1389265167, 'NG', 'NGA', 'نيجيريا'),
(20251, 1389265168, 1389265183, 'US', 'USA', 'الولايات المتحدة'),
(20252, 1389265184, 1389265199, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20253, 1389265200, 1389265231, 'ET', 'ETH', 'إثيوبيا'),
(20254, 1389265232, 1389265239, 'TZ', 'TZA', 'تانزانيا'),
(20255, 1389265240, 1389265263, 'GB', 'GBR', 'المملكة المتحدة'),
(20256, 1389265264, 1389265279, 'NG', 'NGA', 'نيجيريا'),
(20257, 1389265280, 1389265407, 'TD', 'TCD', 'تشاد'),
(20258, 1389265408, 1389265535, 'US', 'USA', 'الولايات المتحدة'),
(20259, 1389265536, 1389265536, 'GB', 'GBR', 'المملكة المتحدة'),
(20260, 1389265537, 1389265551, 'US', 'USA', 'الولايات المتحدة'),
(20261, 1389265552, 1389265559, 'CA', 'CAN', 'كندا'),
(20262, 1389265560, 1389265567, 'LR', 'LBR', 'ليبيريا'),
(20263, 1389265568, 1389265574, 'GM', 'GMB', 'غامبيا'),
(20264, 1389265575, 1389265575, 'GB', 'GBR', 'المملكة المتحدة'),
(20265, 1389265576, 1389265591, 'SC', 'SYC', 'سيشيل'),
(20266, 1389265592, 1389265598, 'CG', 'COG', 'الكونغو'),
(20267, 1389265599, 1389265599, 'GB', 'GBR', 'المملكة المتحدة'),
(20268, 1389265600, 1389265663, 'SO', 'SOM', 'الصومال'),
(20269, 1389265664, 1389265791, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20270, 1389265792, 1389265807, 'GB', 'GBR', 'المملكة المتحدة'),
(20271, 1389265808, 1389265823, 'CA', 'CAN', 'كندا'),
(20272, 1389265824, 1389265855, 'NG', 'NGA', 'نيجيريا'),
(20273, 1389265856, 1389265863, 'US', 'USA', 'الولايات المتحدة'),
(20274, 1389265864, 1389265919, 'GB', 'GBR', 'المملكة المتحدة'),
(20275, 1389265920, 1389266463, 'US', 'USA', 'الولايات المتحدة'),
(20276, 1389266464, 1389266471, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20277, 1389266472, 1389266543, 'US', 'USA', 'الولايات المتحدة'),
(20278, 1389266544, 1389266551, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20279, 1389266552, 1389266559, 'US', 'USA', 'الولايات المتحدة'),
(20280, 1389266560, 1389266569, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20281, 1389266570, 1389266575, 'US', 'USA', 'الولايات المتحدة'),
(20282, 1389266576, 1389266591, 'NG', 'NGA', 'نيجيريا'),
(20283, 1389266592, 1389266599, 'US', 'USA', 'الولايات المتحدة'),
(20284, 1389266600, 1389266607, 'NG', 'NGA', 'نيجيريا'),
(20285, 1389266608, 1389266663, 'US', 'USA', 'الولايات المتحدة'),
(20286, 1389266664, 1389266687, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20287, 1389266688, 1389266695, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20288, 1389266696, 1389266943, 'US', 'USA', 'الولايات المتحدة'),
(20289, 1389266944, 1389267199, 'KE', 'KEN', 'كينيا'),
(20290, 1389267200, 1389267455, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20291, 1389267456, 1389267967, 'GB', 'GBR', 'المملكة المتحدة'),
(20292, 1389267968, 1389268223, 'BI', 'BDI', 'بوروندي'),
(20293, 1389268224, 1389268735, 'US', 'USA', 'الولايات المتحدة'),
(20294, 1389268736, 1389268863, 'GB', 'GBR', 'المملكة المتحدة'),
(20295, 1389268864, 1389268871, 'KE', 'KEN', 'كينيا'),
(20296, 1389268872, 1389268991, 'GB', 'GBR', 'المملكة المتحدة'),
(20297, 1389268992, 1389269023, 'DE', 'DEU', 'ألمانيا'),
(20298, 1389269024, 1389269031, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20299, 1389269032, 1389269055, 'DE', 'DEU', 'ألمانيا'),
(20300, 1389269056, 1389269063, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20301, 1389269064, 1389269151, 'DE', 'DEU', 'ألمانيا'),
(20302, 1389269152, 1389269159, 'NG', 'NGA', 'نيجيريا'),
(20303, 1389269160, 1389269183, 'DE', 'DEU', 'ألمانيا'),
(20304, 1389269184, 1389269215, 'NG', 'NGA', 'نيجيريا'),
(20305, 1389269216, 1389269247, 'DE', 'DEU', 'ألمانيا'),
(20306, 1389269248, 1389269376, 'NG', 'NGA', 'نيجيريا'),
(20307, 1389269377, 1389269759, 'GB', 'GBR', 'المملكة المتحدة'),
(20308, 1389269760, 1389269887, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20309, 1389269888, 1389270015, 'GB', 'GBR', 'المملكة المتحدة'),
(20310, 1389270016, 1389270271, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20311, 1389270272, 1389270783, 'GB', 'GBR', 'المملكة المتحدة'),
(20312, 1389270784, 1389271039, 'US', 'USA', 'الولايات المتحدة'),
(20313, 1389271040, 1389271295, 'CA', 'CAN', 'كندا'),
(20314, 1389271296, 1389272063, 'GB', 'GBR', 'المملكة المتحدة'),
(20315, 1389272064, 1389272191, 'NO', 'NOR', 'النرويج'),
(20316, 1389272192, 1389272319, 'GB', 'GBR', 'المملكة المتحدة'),
(20317, 1389272320, 1389272575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20318, 1389272576, 1389272831, 'GB', 'GBR', 'المملكة المتحدة'),
(20319, 1389272832, 1389272959, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20320, 1389272960, 1389273087, 'FR', 'FRA', 'فرنسا'),
(20321, 1389273088, 1389273343, 'LB', 'LBN', 'لبنان'),
(20322, 1389273344, 1389273599, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20323, 1389273600, 1389273855, 'MG', 'MDG', 'مدغشقر'),
(20324, 1389273856, 1389274111, 'NG', 'NGA', 'نيجيريا'),
(20325, 1389274112, 1389274367, 'GB', 'GBR', 'المملكة المتحدة'),
(20326, 1389274368, 1389274383, 'US', 'USA', 'الولايات المتحدة'),
(20327, 1389274384, 1389274399, 'SA', 'SAU', 'السعودية'),
(20328, 1389274400, 1389274431, 'GH', 'GHA', 'غانا'),
(20329, 1389274432, 1389274494, 'US', 'USA', 'الولايات المتحدة'),
(20330, 1389274495, 1389274495, 'GB', 'GBR', 'المملكة المتحدة'),
(20331, 1389274496, 1389274751, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20332, 1389274752, 1389274815, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(20333, 1389274816, 1389274839, 'LR', 'LBR', 'ليبيريا'),
(20334, 1389274840, 1389274847, 'GB', 'GBR', 'المملكة المتحدة'),
(20335, 1389274848, 1389274879, 'LR', 'LBR', 'ليبيريا'),
(20336, 1389274880, 1389275135, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20337, 1389275136, 1389275391, 'GB', 'GBR', 'المملكة المتحدة'),
(20338, 1389275392, 1389275471, 'BD', 'BGD', 'بنغالاديش'),
(20339, 1389275472, 1389275503, 'GB', 'GBR', 'المملكة المتحدة'),
(20340, 1389275504, 1389275511, 'DE', 'DEU', 'ألمانيا'),
(20341, 1389275512, 1389275839, 'GB', 'GBR', 'المملكة المتحدة'),
(20342, 1389275840, 1389275902, 'SA', 'SAU', 'السعودية'),
(20343, 1389275903, 1389275903, 'GB', 'GBR', 'المملكة المتحدة'),
(20344, 1389275904, 1389276415, 'US', 'USA', 'الولايات المتحدة'),
(20345, 1389276416, 1389276671, 'MX', 'MEX', 'المكسيك'),
(20346, 1389276672, 1389277055, 'GB', 'GBR', 'المملكة المتحدة'),
(20347, 1389277056, 1389277183, 'MX', 'MEX', 'المكسيك'),
(20348, 1389277184, 1389277439, 'GB', 'GBR', 'المملكة المتحدة'),
(20349, 1389277440, 1389277695, 'US', 'USA', 'الولايات المتحدة'),
(20350, 1389277696, 1389277951, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20351, 1389277952, 1389278207, 'GB', 'GBR', 'المملكة المتحدة'),
(20352, 1389278208, 1389278463, 'SN', 'SEN', 'السنغال'),
(20353, 1389278464, 1389278719, 'MX', 'MEX', 'المكسيك'),
(20354, 1389278720, 1389278847, 'DE', 'DEU', 'ألمانيا'),
(20355, 1389278848, 1389278975, 'NG', 'NGA', 'نيجيريا'),
(20356, 1389278976, 1389279103, 'MX', 'MEX', 'المكسيك'),
(20357, 1389279104, 1389279231, 'NG', 'NGA', 'نيجيريا'),
(20358, 1389279232, 1389279487, 'US', 'USA', 'الولايات المتحدة'),
(20359, 1389279488, 1389279615, 'TZ', 'TZA', 'تانزانيا'),
(20360, 1389279616, 1389279743, 'US', 'USA', 'الولايات المتحدة'),
(20361, 1389279744, 1389279999, 'LR', 'LBR', 'ليبيريا'),
(20362, 1389280000, 1389280255, 'CI', 'CIV', 'كوت ديفوار'),
(20363, 1389280256, 1389280511, 'GB', 'GBR', 'المملكة المتحدة'),
(20364, 1389280512, 1389280767, 'FR', 'FRA', 'فرنسا'),
(20365, 1389280768, 1389281023, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(20366, 1389281024, 1389281279, 'GB', 'GBR', 'المملكة المتحدة'),
(20367, 1389281280, 1389282047, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20368, 1389282048, 1389282815, 'GB', 'GBR', 'المملكة المتحدة'),
(20369, 1389282816, 1389282943, 'LR', 'LBR', 'ليبيريا'),
(20370, 1389282944, 1389283071, 'SN', 'SEN', 'السنغال'),
(20371, 1389283072, 1389283327, 'GB', 'GBR', 'المملكة المتحدة'),
(20372, 1389283328, 1389283583, 'LR', 'LBR', 'ليبيريا'),
(20373, 1389283584, 1389283711, 'GB', 'GBR', 'المملكة المتحدة'),
(20374, 1389283712, 1389283839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20375, 1389283840, 1389284351, 'GB', 'GBR', 'المملكة المتحدة'),
(20376, 1389284352, 1389286399, 'TZ', 'TZA', 'تانزانيا'),
(20377, 1389286400, 1389287423, 'GB', 'GBR', 'المملكة المتحدة'),
(20378, 1389287424, 1389287551, 'US', 'USA', 'الولايات المتحدة'),
(20379, 1389287552, 1389287679, 'GB', 'GBR', 'المملكة المتحدة'),
(20380, 1389287680, 1389287935, 'DK', 'DNK', 'الدنيمارك'),
(20381, 1389287936, 1389288447, 'US', 'USA', 'الولايات المتحدة'),
(20382, 1389288448, 1389289471, 'GN', 'GIN', 'غينيا'),
(20383, 1389289472, 1389290495, 'GB', 'GBR', 'المملكة المتحدة'),
(20384, 1389290496, 1389290751, 'US', 'USA', 'الولايات المتحدة'),
(20385, 1389290752, 1389291007, 'FR', 'FRA', 'فرنسا'),
(20386, 1389291008, 1389291519, 'GB', 'GBR', 'المملكة المتحدة'),
(20387, 1389291520, 1389291855, 'US', 'USA', 'الولايات المتحدة'),
(20388, 1389291856, 1389292031, 'GB', 'GBR', 'المملكة المتحدة'),
(20389, 1389292032, 1389292799, 'GH', 'GHA', 'غانا'),
(20390, 1389292800, 1389293055, 'MG', 'MDG', 'مدغشقر'),
(20391, 1389293056, 1389293311, 'US', 'USA', 'الولايات المتحدة'),
(20392, 1389293312, 1389293567, 'KE', 'KEN', 'كينيا'),
(20393, 1389293568, 1389294335, 'GB', 'GBR', 'المملكة المتحدة'),
(20394, 1389294336, 1389295615, 'US', 'USA', 'الولايات المتحدة'),
(20395, 1389295616, 1389295887, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(20396, 1389295888, 1389295935, 'US', 'USA', 'الولايات المتحدة'),
(20397, 1389295936, 1389295967, 'SN', 'SEN', 'السنغال'),
(20398, 1389295968, 1389296383, 'US', 'USA', 'الولايات المتحدة'),
(20399, 1389296384, 1389296447, 'AD', 'AND', 'أندورا'),
(20400, 1389296448, 1389296639, 'US', 'USA', 'الولايات المتحدة'),
(20401, 1389296640, 1389297151, 'TZ', 'TZA', 'تانزانيا'),
(20402, 1389297152, 1389297408, 'US', 'USA', 'الولايات المتحدة'),
(20403, 1389297409, 1389297663, 'GB', 'GBR', 'المملكة المتحدة'),
(20404, 1389297664, 1389330431, 'UA', 'UKR', 'أوكرانيا'),
(20405, 1389330432, 1389363199, 'DE', 'DEU', 'ألمانيا'),
(20406, 1389363200, 1389379583, 'CZ', 'CZE', 'التشيك'),
(20407, 1389379584, 1389395967, 'RU', 'RUS', 'الإتحاد الروسي'),
(20408, 1389395968, 1389412351, 'RO', 'ROM', 'رومانيا'),
(20409, 1389412352, 1389428735, 'RS', 'SRB', 'صربيا'),
(20410, 1389428736, 1389445119, 'CZ', 'CZE', 'التشيك'),
(20411, 1389445120, 1389461503, 'RU', 'RUS', 'الإتحاد الروسي'),
(20412, 1389461504, 1389477887, 'SE', 'SWE', 'السويد'),
(20413, 1389477888, 1389494271, 'BY', 'BLR', 'روسيا البيضاء'),
(20414, 1389494272, 1389495615, 'DE', 'DEU', 'ألمانيا'),
(20415, 1389495616, 1389495645, 'CH', 'CHE', 'سويسرا'),
(20416, 1389495646, 1389502239, 'DE', 'DEU', 'ألمانيا'),
(20417, 1389502240, 1389502271, 'CH', 'CHE', 'سويسرا'),
(20418, 1389502272, 1389504511, 'DE', 'DEU', 'ألمانيا'),
(20419, 1389504512, 1389504772, 'FR', 'FRA', 'فرنسا'),
(20420, 1389504773, 1389504780, 'CH', 'CHE', 'سويسرا'),
(20421, 1389504781, 1389505023, 'FR', 'FRA', 'فرنسا'),
(20422, 1389505024, 1389510655, 'DE', 'DEU', 'ألمانيا'),
(20423, 1389510656, 1389527039, 'NL', 'NLD', 'هولندا'),
(20424, 1389527040, 1389543423, 'PL', 'POL', 'بولندا'),
(20425, 1389543424, 1389548991, 'DE', 'DEU', 'ألمانيا'),
(20426, 1389548992, 1389549055, 'BE', 'BEL', 'بلجيكا'),
(20427, 1389549056, 1389554023, 'DE', 'DEU', 'ألمانيا'),
(20428, 1389554024, 1389554039, 'FR', 'FRA', 'فرنسا'),
(20429, 1389554040, 1389554047, 'TR', 'TUR', 'تركيا'),
(20430, 1389554048, 1389554087, 'DE', 'DEU', 'ألمانيا'),
(20431, 1389554088, 1389554095, 'ES', 'ESP', 'إسبانيا'),
(20432, 1389554096, 1389554103, 'DE', 'DEU', 'ألمانيا'),
(20433, 1389554104, 1389554111, 'FR', 'FRA', 'فرنسا'),
(20434, 1389554112, 1389554135, 'IT', 'ITA', 'إيطاليا'),
(20435, 1389554136, 1389555263, 'DE', 'DEU', 'ألمانيا'),
(20436, 1389555264, 1389555327, 'AT', 'AUT', 'النمسا'),
(20437, 1389555328, 1389556751, 'DE', 'DEU', 'ألمانيا'),
(20438, 1389556752, 1389556759, 'CH', 'CHE', 'سويسرا'),
(20439, 1389556760, 1389559039, 'DE', 'DEU', 'ألمانيا'),
(20440, 1389559040, 1389559103, 'CH', 'CHE', 'سويسرا'),
(20441, 1389559104, 1389559743, 'DE', 'DEU', 'ألمانيا'),
(20442, 1389559744, 1389559807, 'CH', 'CHE', 'سويسرا'),
(20443, 1389559808, 1389562879, 'DE', 'DEU', 'ألمانيا'),
(20444, 1389562880, 1389563135, 'IT', 'ITA', 'إيطاليا'),
(20445, 1389563136, 1389563391, 'DE', 'DEU', 'ألمانيا'),
(20446, 1389563392, 1389563647, 'IT', 'ITA', 'إيطاليا'),
(20447, 1389563648, 1389576191, 'DE', 'DEU', 'ألمانيا'),
(20448, 1389576192, 1389592575, 'GB', 'GBR', 'المملكة المتحدة'),
(20449, 1389592576, 1389608959, 'CY', 'CYP', 'قبرص'),
(20450, 1389608960, 1389625343, 'DK', 'DNK', 'الدنيمارك'),
(20451, 1389625344, 1389641727, 'DE', 'DEU', 'ألمانيا'),
(20452, 1389641728, 1389658111, 'JO', 'JOR', 'الأردن'),
(20453, 1389658112, 1389674495, 'BE', 'BEL', 'بلجيكا'),
(20454, 1389674496, 1389690879, 'DE', 'DEU', 'ألمانيا'),
(20455, 1389690880, 1389707263, 'PS', 'PSE', 'فلسطين المحتلة'),
(20456, 1389707264, 1389723647, 'IT', 'ITA', 'إيطاليا'),
(20457, 1389723648, 1389756415, 'ES', 'ESP', 'إسبانيا'),
(20458, 1389756416, 1389772799, 'SE', 'SWE', 'السويد'),
(20459, 1389772800, 1389780991, 'SI', 'SVN', 'سلوفينيا'),
(20460, 1389780992, 1389782527, 'HR', 'HRV', 'كرواتيا'),
(20461, 1389782528, 1389783039, 'SI', 'SVN', 'سلوفينيا'),
(20462, 1389783040, 1389784063, 'BA', 'BIH', 'البوسنه والهرسك'),
(20463, 1389784064, 1389788671, 'SI', 'SVN', 'سلوفينيا'),
(20464, 1389788672, 1389789183, 'RS', 'SRB', 'صربيا'),
(20465, 1389789184, 1389805567, 'PL', 'POL', 'بولندا'),
(20466, 1389805568, 1389821951, 'DE', 'DEU', 'ألمانيا'),
(20467, 1389821952, 1389838335, 'NL', 'NLD', 'هولندا'),
(20468, 1389838336, 1389854719, 'UZ', 'UZB', 'أوزباكستان'),
(20469, 1389854720, 1389871103, 'IT', 'ITA', 'إيطاليا'),
(20470, 1389871104, 1389887487, 'FI', 'FIN', 'فنلندا'),
(20471, 1389887488, 1389953023, 'FR', 'FRA', 'فرنسا'),
(20472, 1389953024, 1390018559, 'NL', 'NLD', 'هولندا'),
(20473, 1390018560, 1390084095, 'AT', 'AUT', 'النمسا'),
(20474, 1390084096, 1390149631, 'GB', 'GBR', 'المملكة المتحدة'),
(20475, 1390149632, 1390215167, 'CH', 'CHE', 'سويسرا'),
(20476, 1390215168, 1390280703, 'IS', 'ISL', 'أيسلندا'),
(20477, 1390280704, 1390346239, 'TR', 'TUR', 'تركيا'),
(20478, 1390346240, 1390394367, 'ES', 'ESP', 'إسبانيا'),
(20479, 1390394368, 1390394879, 'PT', 'PRT', 'البورتوغال'),
(20480, 1390394880, 1390395391, 'ES', 'ESP', 'إسبانيا'),
(20481, 1390395392, 1390396415, 'FR', 'FRA', 'فرنسا'),
(20482, 1390396416, 1390397183, 'PT', 'PRT', 'البورتوغال'),
(20483, 1390397184, 1390411775, 'ES', 'ESP', 'إسبانيا'),
(20484, 1390411776, 1392508927, 'FR', 'FRA', 'فرنسا'),
(20485, 1392508928, 1394606079, 'PL', 'POL', 'بولندا'),
(20486, 1394606080, 1396703231, 'ES', 'ESP', 'إسبانيا'),
(20487, 1396703232, 1396834303, 'AT', 'AUT', 'النمسا'),
(20488, 1396834304, 1396899839, 'TR', 'TUR', 'تركيا'),
(20489, 1396899840, 1396965375, 'GB', 'GBR', 'المملكة المتحدة'),
(20490, 1396965376, 1396973567, 'NL', 'NLD', 'هولندا'),
(20491, 1396973568, 1396981759, 'RU', 'RUS', 'الإتحاد الروسي'),
(20492, 1396981760, 1396989951, 'PL', 'POL', 'بولندا'),
(20493, 1396989952, 1396998143, 'FR', 'FRA', 'فرنسا'),
(20494, 1396998144, 1397006335, 'AT', 'AUT', 'النمسا'),
(20495, 1397006336, 1397014527, 'KW', 'KWT', 'الكويت'),
(20496, 1397014528, 1397022719, 'CH', 'CHE', 'سويسرا'),
(20497, 1397022720, 1397030911, 'SE', 'SWE', 'السويد'),
(20498, 1397030912, 1397039103, 'RU', 'RUS', 'الإتحاد الروسي'),
(20499, 1397039104, 1397047295, 'CZ', 'CZE', 'التشيك'),
(20500, 1397047296, 1397063679, 'RU', 'RUS', 'الإتحاد الروسي'),
(20501, 1397063680, 1397071871, 'UZ', 'UZB', 'أوزباكستان'),
(20502, 1397071872, 1397096447, 'RU', 'RUS', 'الإتحاد الروسي'),
(20503, 1397096448, 1397227519, 'IE', 'IRL', 'إيرلندا'),
(20504, 1397227520, 1397489663, 'DK', 'DNK', 'الدنيمارك'),
(20505, 1397489664, 1397751807, 'CH', 'CHE', 'سويسرا'),
(20506, 1397751808, 1398276095, 'NL', 'NLD', 'هولندا'),
(20507, 1398276096, 1398800383, 'DK', 'DNK', 'الدنيمارك'),
(20508, 1398800384, 1398833151, 'KW', 'KWT', 'الكويت'),
(20509, 1398833152, 1398840447, 'NL', 'NLD', 'هولندا'),
(20510, 1398840448, 1398840575, 'GB', 'GBR', 'المملكة المتحدة'),
(20511, 1398840576, 1398865919, 'NL', 'NLD', 'هولندا'),
(20512, 1398865920, 1398867967, 'DE', 'DEU', 'ألمانيا'),
(20513, 1398867968, 1398870015, 'NL', 'NLD', 'هولندا'),
(20514, 1398870016, 1398872063, 'PL', 'POL', 'بولندا'),
(20515, 1398872064, 1398874111, 'BG', 'BGR', 'بلغاريا'),
(20516, 1398874112, 1398876159, 'GB', 'GBR', 'المملكة المتحدة'),
(20517, 1398876160, 1398880255, 'DE', 'DEU', 'ألمانيا'),
(20518, 1398880256, 1398882303, 'FR', 'FRA', 'فرنسا'),
(20519, 1398882304, 1398884351, 'BG', 'BGR', 'بلغاريا'),
(20520, 1398884352, 1398886399, 'DE', 'DEU', 'ألمانيا'),
(20521, 1398886400, 1398888447, 'CH', 'CHE', 'سويسرا'),
(20522, 1398888448, 1398890495, 'GB', 'GBR', 'المملكة المتحدة'),
(20523, 1398890496, 1398892543, 'DK', 'DNK', 'الدنيمارك'),
(20524, 1398892544, 1398894591, 'UA', 'UKR', 'أوكرانيا'),
(20525, 1398894592, 1398896639, 'DE', 'DEU', 'ألمانيا'),
(20526, 1398896640, 1398898687, 'CH', 'CHE', 'سويسرا'),
(20527, 1398898688, 1398931455, 'ES', 'ESP', 'إسبانيا'),
(20528, 1398931456, 1398964223, 'GB', 'GBR', 'المملكة المتحدة'),
(20529, 1398964224, 1398965503, 'NL', 'NLD', 'هولندا'),
(20530, 1398965504, 1398965759, 'US', 'USA', 'الولايات المتحدة'),
(20531, 1398965760, 1398966015, 'DE', 'DEU', 'ألمانيا'),
(20532, 1398966016, 1398966839, 'NL', 'NLD', 'هولندا'),
(20533, 1398966840, 1398966847, 'PL', 'POL', 'بولندا'),
(20534, 1398966848, 1398967871, 'NL', 'NLD', 'هولندا'),
(20535, 1398967872, 1398967903, 'IE', 'IRL', 'إيرلندا'),
(20536, 1398967904, 1398968063, 'NL', 'NLD', 'هولندا'),
(20537, 1398968064, 1398968319, 'DE', 'DEU', 'ألمانيا'),
(20538, 1398968320, 1398972415, 'NL', 'NLD', 'هولندا'),
(20539, 1398972416, 1398972671, 'IE', 'IRL', 'إيرلندا'),
(20540, 1398972672, 1398973695, 'NL', 'NLD', 'هولندا'),
(20541, 1398973696, 1398973951, 'AT', 'AUT', 'النمسا'),
(20542, 1398973952, 1398974207, 'IE', 'IRL', 'إيرلندا'),
(20543, 1398974208, 1398979327, 'NL', 'NLD', 'هولندا'),
(20544, 1398979328, 1398979583, 'US', 'USA', 'الولايات المتحدة'),
(20545, 1398979584, 1398979839, 'GB', 'GBR', 'المملكة المتحدة'),
(20546, 1398979840, 1398980873, 'NL', 'NLD', 'هولندا'),
(20547, 1398980874, 1398980881, 'US', 'USA', 'الولايات المتحدة'),
(20548, 1398980882, 1398980956, 'NL', 'NLD', 'هولندا'),
(20549, 1398980957, 1398980975, 'US', 'USA', 'الولايات المتحدة'),
(20550, 1398980976, 1398982143, 'NL', 'NLD', 'هولندا'),
(20551, 1398982144, 1398982399, 'US', 'USA', 'الولايات المتحدة'),
(20552, 1398982400, 1398983423, 'NL', 'NLD', 'هولندا'),
(20553, 1398983424, 1398983487, 'GB', 'GBR', 'المملكة المتحدة'),
(20554, 1398983488, 1398983519, 'JE', 'JEY', 'جيرسي'),
(20555, 1398983520, 1398983551, 'GB', 'GBR', 'المملكة المتحدة'),
(20556, 1398983552, 1398983679, 'NL', 'NLD', 'هولندا'),
(20557, 1398983680, 1398984191, 'US', 'USA', 'الولايات المتحدة'),
(20558, 1398984192, 1398996991, 'NL', 'NLD', 'هولندا'),
(20559, 1398996992, 1399029759, 'LU', 'LUX', 'لوكسيمبورغ'),
(20560, 1399029760, 1399062527, 'LV', 'LVA', 'لاتفيا'),
(20561, 1399062528, 1399095295, 'FI', 'FIN', 'فنلندا'),
(20562, 1399095296, 1399128063, 'GB', 'GBR', 'المملكة المتحدة'),
(20563, 1399128064, 1399160831, 'BE', 'BEL', 'بلجيكا'),
(20564, 1399160832, 1399193599, 'SA', 'SAU', 'السعودية'),
(20565, 1399193600, 1399226367, 'FI', 'FIN', 'فنلندا'),
(20566, 1399226368, 1399259135, 'RU', 'RUS', 'الإتحاد الروسي'),
(20567, 1399259136, 1399291903, 'IT', 'ITA', 'إيطاليا'),
(20568, 1399291904, 1399324671, 'RO', 'ROM', 'رومانيا'),
(20569, 1399324672, 1399586815, 'GB', 'GBR', 'المملكة المتحدة'),
(20570, 1399586816, 1399717887, 'NO', 'NOR', 'النرويج'),
(20571, 1399717888, 1399848959, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20572, 1399848960, 1400111103, 'FR', 'FRA', 'فرنسا'),
(20573, 1400111104, 1400373247, 'NL', 'NLD', 'هولندا'),
(20574, 1400373248, 1400705279, 'DE', 'DEU', 'ألمانيا'),
(20575, 1400709120, 1400710143, 'DE', 'DEU', 'ألمانيا'),
(20576, 1400710400, 1400716287, 'DE', 'DEU', 'ألمانيا'),
(20577, 1400717312, 1400718335, 'DE', 'DEU', 'ألمانيا'),
(20578, 1400718848, 1400722431, 'DE', 'DEU', 'ألمانيا'),
(20579, 1400729600, 1400730639, 'DE', 'DEU', 'ألمانيا'),
(20580, 1400731136, 1400733695, 'DE', 'DEU', 'ألمانيا'),
(20581, 1400897536, 1400963071, 'NL', 'NLD', 'هولندا'),
(20582, 1400963072, 1401028607, 'DE', 'DEU', 'ألمانيا'),
(20583, 1401028608, 1401094143, 'IL', 'ISR', 'إسرائيل'),
(20584, 1401094144, 1401159679, 'HR', 'HRV', 'كرواتيا'),
(20585, 1401159680, 1401225215, 'PT', 'PRT', 'البورتوغال'),
(20586, 1401225216, 1401241599, 'DE', 'DEU', 'ألمانيا'),
(20587, 1401241600, 1401242623, 'DK', 'DNK', 'الدنيمارك'),
(20588, 1401242624, 1401244159, 'DE', 'DEU', 'ألمانيا'),
(20589, 1401246720, 1401264903, 'DE', 'DEU', 'ألمانيا'),
(20590, 1401265152, 1401265919, 'DE', 'DEU', 'ألمانيا'),
(20591, 1401266176, 1401273599, 'DE', 'DEU', 'ألمانيا'),
(20592, 1401273728, 1401274367, 'DE', 'DEU', 'ألمانيا'),
(20593, 1401278464, 1401283583, 'DE', 'DEU', 'ألمانيا'),
(20594, 1401286656, 1401290751, 'DE', 'DEU', 'ألمانيا'),
(20595, 1401290752, 1401356287, 'BE', 'BEL', 'بلجيكا'),
(20596, 1401356288, 1401421823, 'DE', 'DEU', 'ألمانيا'),
(20597, 1401421824, 1401423135, 'GB', 'GBR', 'المملكة المتحدة'),
(20598, 1401423136, 1401423167, 'IN', 'IND', 'الهند'),
(20599, 1401423168, 1401423199, 'GB', 'GBR', 'المملكة المتحدة'),
(20600, 1401423200, 1401423231, 'US', 'USA', 'الولايات المتحدة'),
(20601, 1401423232, 1401423871, 'GB', 'GBR', 'المملكة المتحدة'),
(20602, 1401423872, 1401423903, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20603, 1401423904, 1401423967, 'GR', 'GRC', 'اليونان'),
(20604, 1401423968, 1401423999, 'SA', 'SAU', 'السعودية'),
(20605, 1401424000, 1401425151, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20606, 1401425152, 1401425407, 'GR', 'GRC', 'اليونان'),
(20607, 1401425408, 1401425919, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20608, 1401425920, 1401427967, 'NL', 'NLD', 'هولندا'),
(20609, 1401427968, 1401430015, 'RU', 'RUS', 'الإتحاد الروسي'),
(20610, 1401430016, 1401432063, 'AT', 'AUT', 'النمسا'),
(20611, 1401432064, 1401434111, 'IE', 'IRL', 'إيرلندا'),
(20612, 1401434112, 1401436159, 'RU', 'RUS', 'الإتحاد الروسي'),
(20613, 1401436160, 1401438207, 'BH', 'BHR', 'البحرين'),
(20614, 1401438208, 1401440255, 'GB', 'GBR', 'المملكة المتحدة'),
(20615, 1401440256, 1401443487, 'DE', 'DEU', 'ألمانيا'),
(20616, 1401443488, 1401443519, 'GI', 'GIB', 'جبل طارق'),
(20617, 1401443520, 1401444351, 'DE', 'DEU', 'ألمانيا'),
(20618, 1401444352, 1401446399, 'DK', 'DNK', 'الدنيمارك'),
(20619, 1401446400, 1401448447, 'DE', 'DEU', 'ألمانيا'),
(20620, 1401448448, 1401450495, 'IT', 'ITA', 'إيطاليا'),
(20621, 1401450496, 1401452543, 'RU', 'RUS', 'الإتحاد الروسي'),
(20622, 1401452544, 1401454591, 'GB', 'GBR', 'المملكة المتحدة'),
(20623, 1401454592, 1401456639, 'DE', 'DEU', 'ألمانيا'),
(20624, 1401456640, 1401458687, 'LV', 'LVA', 'لاتفيا'),
(20625, 1401458688, 1401460735, 'IT', 'ITA', 'إيطاليا'),
(20626, 1401460736, 1401462783, 'PL', 'POL', 'بولندا'),
(20627, 1401462784, 1401464831, 'FR', 'FRA', 'فرنسا'),
(20628, 1401464832, 1401466879, 'IE', 'IRL', 'إيرلندا'),
(20629, 1401466880, 1401468927, 'RS', 'SRB', 'صربيا'),
(20630, 1401468928, 1401470975, 'ES', 'ESP', 'إسبانيا'),
(20631, 1401470976, 1401473023, 'NL', 'NLD', 'هولندا'),
(20632, 1401473024, 1401475071, 'CZ', 'CZE', 'التشيك'),
(20633, 1401475072, 1401477119, 'FR', 'FRA', 'فرنسا'),
(20634, 1401477120, 1401479167, 'BE', 'BEL', 'بلجيكا'),
(20635, 1401479168, 1401481215, 'PL', 'POL', 'بولندا'),
(20636, 1401481216, 1401485311, 'RU', 'RUS', 'الإتحاد الروسي'),
(20637, 1401485312, 1401487359, 'IT', 'ITA', 'إيطاليا'),
(20638, 1401487360, 1401489407, 'GB', 'GBR', 'المملكة المتحدة'),
(20639, 1401489408, 1401491455, 'SE', 'SWE', 'السويد'),
(20640, 1401491456, 1401493503, 'NL', 'NLD', 'هولندا'),
(20641, 1401493504, 1401495551, 'CH', 'CHE', 'سويسرا'),
(20642, 1401495552, 1401497599, 'DK', 'DNK', 'الدنيمارك'),
(20643, 1401497600, 1401499647, 'AT', 'AUT', 'النمسا'),
(20644, 1401499648, 1401501695, 'RU', 'RUS', 'الإتحاد الروسي'),
(20645, 1401501696, 1401503743, 'IT', 'ITA', 'إيطاليا'),
(20646, 1401503744, 1401505791, 'DE', 'DEU', 'ألمانيا'),
(20647, 1401505792, 1401509887, 'CH', 'CHE', 'سويسرا'),
(20648, 1401509888, 1401511935, 'UA', 'UKR', 'أوكرانيا'),
(20649, 1401511936, 1401513983, 'DE', 'DEU', 'ألمانيا'),
(20650, 1401513984, 1401516031, 'IT', 'ITA', 'إيطاليا'),
(20651, 1401516032, 1401516439, 'AT', 'AUT', 'النمسا'),
(20652, 1401516440, 1401516447, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20653, 1401516448, 1401518079, 'AT', 'AUT', 'النمسا'),
(20654, 1401518080, 1401520127, 'IT', 'ITA', 'إيطاليا'),
(20655, 1401520128, 1401522175, 'GB', 'GBR', 'المملكة المتحدة'),
(20656, 1401522176, 1401526271, 'NL', 'NLD', 'هولندا'),
(20657, 1401528320, 1401530367, 'IT', 'ITA', 'إيطاليا'),
(20658, 1401530368, 1401532415, 'DE', 'DEU', 'ألمانيا'),
(20659, 1401532416, 1401534463, 'GB', 'GBR', 'المملكة المتحدة'),
(20660, 1401534464, 1401536511, 'DE', 'DEU', 'ألمانيا'),
(20661, 1401536512, 1401538559, 'NL', 'NLD', 'هولندا'),
(20662, 1401538560, 1401540607, 'NO', 'NOR', 'النرويج'),
(20663, 1401540608, 1401542655, 'GB', 'GBR', 'المملكة المتحدة'),
(20664, 1401542656, 1401544703, 'RU', 'RUS', 'الإتحاد الروسي'),
(20665, 1401544704, 1401546751, 'GB', 'GBR', 'المملكة المتحدة'),
(20666, 1401546752, 1401548799, 'IT', 'ITA', 'إيطاليا'),
(20667, 1401548800, 1401550847, 'FR', 'FRA', 'فرنسا'),
(20668, 1401550848, 1401552895, 'GB', 'GBR', 'المملكة المتحدة'),
(20669, 1401552896, 1401554943, 'NL', 'NLD', 'هولندا'),
(20670, 1401554944, 1401556991, 'IE', 'IRL', 'إيرلندا'),
(20671, 1401556992, 1401563135, 'GB', 'GBR', 'المملكة المتحدة'),
(20672, 1401563136, 1401565183, 'ES', 'ESP', 'إسبانيا'),
(20673, 1401565184, 1401567231, 'RU', 'RUS', 'الإتحاد الروسي'),
(20674, 1401567232, 1401569279, 'GB', 'GBR', 'المملكة المتحدة'),
(20675, 1401569280, 1401585663, 'DE', 'DEU', 'ألمانيا'),
(20676, 1401585664, 1401599167, 'GB', 'GBR', 'المملكة المتحدة'),
(20677, 1401599168, 1401599231, 'IE', 'IRL', 'إيرلندا'),
(20678, 1401599232, 1401602047, 'GB', 'GBR', 'المملكة المتحدة'),
(20679, 1401602048, 1401618431, 'ES', 'ESP', 'إسبانيا'),
(20680, 1401618432, 1401634815, 'AM', 'ARM', 'أرمينيا'),
(20681, 1401634816, 1401651199, 'HR', 'HRV', 'كرواتيا'),
(20682, 1401651200, 1401667583, 'RU', 'RUS', 'الإتحاد الروسي'),
(20683, 1401667584, 1401683967, 'IT', 'ITA', 'إيطاليا'),
(20684, 1401683968, 1401684479, 'SE', 'SWE', 'السويد'),
(20685, 1401684480, 1401684511, 'DK', 'DNK', 'الدنيمارك'),
(20686, 1401684512, 1401684543, 'SE', 'SWE', 'السويد'),
(20687, 1401684544, 1401684607, 'DK', 'DNK', 'الدنيمارك'),
(20688, 1401684608, 1401684671, 'SE', 'SWE', 'السويد'),
(20689, 1401684672, 1401684703, 'DK', 'DNK', 'الدنيمارك'),
(20690, 1401684704, 1401684731, 'SE', 'SWE', 'السويد'),
(20691, 1401684732, 1401684735, 'DK', 'DNK', 'الدنيمارك'),
(20692, 1401684736, 1401684755, 'NO', 'NOR', 'النرويج'),
(20693, 1401684756, 1401684767, 'SE', 'SWE', 'السويد'),
(20694, 1401684768, 1401684895, 'NO', 'NOR', 'النرويج'),
(20695, 1401684896, 1401686015, 'SE', 'SWE', 'السويد'),
(20696, 1401686016, 1401686059, 'GB', 'GBR', 'المملكة المتحدة'),
(20697, 1401686060, 1401686063, 'SE', 'SWE', 'السويد'),
(20698, 1401686064, 1401686143, 'GB', 'GBR', 'المملكة المتحدة'),
(20699, 1401686144, 1401686223, 'SE', 'SWE', 'السويد'),
(20700, 1401686224, 1401686271, 'GB', 'GBR', 'المملكة المتحدة'),
(20701, 1401686272, 1401686287, 'NL', 'NLD', 'هولندا'),
(20702, 1401686288, 1401686335, 'SE', 'SWE', 'السويد'),
(20703, 1401686336, 1401686399, 'NL', 'NLD', 'هولندا'),
(20704, 1401686400, 1401686911, 'SE', 'SWE', 'السويد'),
(20705, 1401686912, 1401686927, 'DE', 'DEU', 'ألمانيا'),
(20706, 1401686928, 1401691519, 'SE', 'SWE', 'السويد'),
(20707, 1401691520, 1401691535, 'DE', 'DEU', 'ألمانيا'),
(20708, 1401691536, 1401697815, 'SE', 'SWE', 'السويد'),
(20709, 1401697816, 1401697823, 'DE', 'DEU', 'ألمانيا'),
(20710, 1401697824, 1401708543, 'SE', 'SWE', 'السويد'),
(20711, 1401708544, 1401709055, 'FR', 'FRA', 'فرنسا'),
(20712, 1401709056, 1401714047, 'SE', 'SWE', 'السويد'),
(20713, 1401714048, 1401714063, 'FR', 'FRA', 'فرنسا'),
(20714, 1401714064, 1401717759, 'SE', 'SWE', 'السويد'),
(20715, 1401717760, 1401718015, 'NL', 'NLD', 'هولندا'),
(20716, 1401718016, 1401719935, 'SE', 'SWE', 'السويد'),
(20717, 1401719936, 1401719951, 'DK', 'DNK', 'الدنيمارك'),
(20718, 1401719952, 1401727743, 'SE', 'SWE', 'السويد'),
(20719, 1401727744, 1401727999, 'GB', 'GBR', 'المملكة المتحدة'),
(20720, 1401728000, 1401728335, 'SE', 'SWE', 'السويد'),
(20721, 1401728336, 1401728351, 'NL', 'NLD', 'هولندا'),
(20722, 1401728352, 1401728431, 'SE', 'SWE', 'السويد'),
(20723, 1401728432, 1401728447, 'NL', 'NLD', 'هولندا'),
(20724, 1401728448, 1401740543, 'SE', 'SWE', 'السويد'),
(20725, 1401740544, 1401740799, 'DE', 'DEU', 'ألمانيا'),
(20726, 1401740800, 1401742847, 'SE', 'SWE', 'السويد'),
(20727, 1401742848, 1401742879, 'GB', 'GBR', 'المملكة المتحدة'),
(20728, 1401742880, 1401742895, 'SE', 'SWE', 'السويد'),
(20729, 1401742896, 1401742911, 'GB', 'GBR', 'المملكة المتحدة'),
(20730, 1401742912, 1401743055, 'SE', 'SWE', 'السويد'),
(20731, 1401743056, 1401743071, 'GB', 'GBR', 'المملكة المتحدة'),
(20732, 1401743072, 1401743087, 'SE', 'SWE', 'السويد'),
(20733, 1401743088, 1401743119, 'GB', 'GBR', 'المملكة المتحدة'),
(20734, 1401743120, 1401743151, 'SE', 'SWE', 'السويد'),
(20735, 1401743152, 1401743167, 'GB', 'GBR', 'المملكة المتحدة'),
(20736, 1401743168, 1401743311, 'SE', 'SWE', 'السويد'),
(20737, 1401743312, 1401743327, 'GB', 'GBR', 'المملكة المتحدة'),
(20738, 1401743328, 1401743343, 'SE', 'SWE', 'السويد'),
(20739, 1401743344, 1401743359, 'GB', 'GBR', 'المملكة المتحدة'),
(20740, 1401743360, 1401745487, 'SE', 'SWE', 'السويد'),
(20741, 1401745488, 1401745503, 'ES', 'ESP', 'إسبانيا'),
(20742, 1401745504, 1401745919, 'SE', 'SWE', 'السويد'),
(20743, 1401745920, 1401745935, 'IT', 'ITA', 'إيطاليا'),
(20744, 1401745936, 1401745983, 'SE', 'SWE', 'السويد'),
(20745, 1401745984, 1401745999, 'NL', 'NLD', 'هولندا'),
(20746, 1401746000, 1401746015, 'ES', 'ESP', 'إسبانيا'),
(20747, 1401746016, 1401746175, 'SE', 'SWE', 'السويد'),
(20748, 1401746176, 1401746191, 'DK', 'DNK', 'الدنيمارك'),
(20749, 1401746192, 1401746215, 'SE', 'SWE', 'السويد'),
(20750, 1401746216, 1401746223, 'GB', 'GBR', 'المملكة المتحدة'),
(20751, 1401746224, 1401746239, 'SE', 'SWE', 'السويد'),
(20752, 1401746240, 1401746255, 'NL', 'NLD', 'هولندا'),
(20753, 1401746256, 1401746271, 'ES', 'ESP', 'إسبانيا'),
(20754, 1401746272, 1401746431, 'SE', 'SWE', 'السويد'),
(20755, 1401746432, 1401746447, 'NL', 'NLD', 'هولندا'),
(20756, 1401746448, 1401746467, 'SE', 'SWE', 'السويد'),
(20757, 1401746468, 1401746471, 'NL', 'NLD', 'هولندا'),
(20758, 1401746472, 1401746487, 'GB', 'GBR', 'المملكة المتحدة'),
(20759, 1401746488, 1401746495, 'SE', 'SWE', 'السويد'),
(20760, 1401746496, 1401746511, 'NL', 'NLD', 'هولندا'),
(20761, 1401746512, 1401746527, 'ES', 'ESP', 'إسبانيا'),
(20762, 1401746528, 1401746623, 'SE', 'SWE', 'السويد'),
(20763, 1401746624, 1401746639, 'DE', 'DEU', 'ألمانيا'),
(20764, 1401746640, 1401746687, 'SE', 'SWE', 'السويد'),
(20765, 1401746688, 1401746703, 'NO', 'NOR', 'النرويج'),
(20766, 1401746704, 1401746751, 'SE', 'SWE', 'السويد'),
(20767, 1401746752, 1401746767, 'NL', 'NLD', 'هولندا'),
(20768, 1401746768, 1401746783, 'ES', 'ESP', 'إسبانيا'),
(20769, 1401746784, 1401746879, 'SE', 'SWE', 'السويد'),
(20770, 1401746880, 1401746895, 'DE', 'DEU', 'ألمانيا'),
(20771, 1401746896, 1401746943, 'SE', 'SWE', 'السويد'),
(20772, 1401746944, 1401746959, 'FR', 'FRA', 'فرنسا'),
(20773, 1401746960, 1401747007, 'SE', 'SWE', 'السويد'),
(20774, 1401747008, 1401747023, 'NL', 'NLD', 'هولندا'),
(20775, 1401747024, 1401747039, 'ES', 'ESP', 'إسبانيا'),
(20776, 1401747040, 1401747135, 'SE', 'SWE', 'السويد'),
(20777, 1401747136, 1401747151, 'DE', 'DEU', 'ألمانيا'),
(20778, 1401747152, 1401747199, 'SE', 'SWE', 'السويد'),
(20779, 1401747200, 1401747215, 'IT', 'ITA', 'إيطاليا'),
(20780, 1401747216, 1401747279, 'SE', 'SWE', 'السويد'),
(20781, 1401747280, 1401747295, 'ES', 'ESP', 'إسبانيا'),
(20782, 1401747296, 1401747391, 'SE', 'SWE', 'السويد'),
(20783, 1401747392, 1401747407, 'DE', 'DEU', 'ألمانيا'),
(20784, 1401747408, 1401747647, 'SE', 'SWE', 'السويد'),
(20785, 1401747648, 1401747663, 'DE', 'DEU', 'ألمانيا'),
(20786, 1401747664, 1401749135, 'SE', 'SWE', 'السويد'),
(20787, 1401749136, 1401749151, 'DE', 'DEU', 'ألمانيا'),
(20788, 1401749152, 1401749503, 'SE', 'SWE', 'السويد'),
(20789, 1401749504, 1401753087, 'DE', 'DEU', 'ألمانيا'),
(20790, 1401753088, 1401753343, 'AT', 'AUT', 'النمسا'),
(20791, 1401753344, 1401759231, 'DE', 'DEU', 'ألمانيا'),
(20792, 1401759232, 1401759487, 'GB', 'GBR', 'المملكة المتحدة'),
(20793, 1401759488, 1401760255, 'DE', 'DEU', 'ألمانيا'),
(20794, 1401760256, 1401760767, 'SK', 'SVK', 'سلوفاكيا'),
(20795, 1401760768, 1401765887, 'DE', 'DEU', 'ألمانيا'),
(20796, 1401765888, 1401782271, 'IE', 'IRL', 'إيرلندا'),
(20797, 1401782272, 1401815039, 'FR', 'FRA', 'فرنسا'),
(20798, 1401815040, 1401817087, 'SE', 'SWE', 'السويد'),
(20799, 1401817088, 1401819135, 'RU', 'RUS', 'الإتحاد الروسي'),
(20800, 1401819136, 1401821183, 'BG', 'BGR', 'بلغاريا'),
(20801, 1401821184, 1401825279, 'GB', 'GBR', 'المملكة المتحدة'),
(20802, 1401825280, 1401827327, 'PL', 'POL', 'بولندا'),
(20803, 1401827328, 1401829375, 'GB', 'GBR', 'المملكة المتحدة'),
(20804, 1401829376, 1401831423, 'PL', 'POL', 'بولندا'),
(20805, 1401831424, 1401833471, 'GB', 'GBR', 'المملكة المتحدة'),
(20806, 1401833472, 1401835519, 'FI', 'FIN', 'فنلندا'),
(20807, 1401835520, 1401837567, 'DE', 'DEU', 'ألمانيا'),
(20808, 1401837568, 1401839615, 'CH', 'CHE', 'سويسرا'),
(20809, 1401839616, 1401841663, 'NO', 'NOR', 'النرويج'),
(20810, 1401841664, 1401843711, 'UA', 'UKR', 'أوكرانيا'),
(20811, 1401843712, 1401847807, 'PL', 'POL', 'بولندا'),
(20812, 1401847808, 1401849855, 'DE', 'DEU', 'ألمانيا'),
(20813, 1401849856, 1401851903, 'PL', 'POL', 'بولندا'),
(20814, 1401851904, 1401853951, 'FR', 'FRA', 'فرنسا'),
(20815, 1401853952, 1401855999, 'PL', 'POL', 'بولندا'),
(20816, 1401856000, 1401858047, 'RU', 'RUS', 'الإتحاد الروسي'),
(20817, 1401858048, 1401868287, 'PL', 'POL', 'بولندا'),
(20818, 1401868288, 1401870335, 'UA', 'UKR', 'أوكرانيا'),
(20819, 1401870336, 1401872383, 'PL', 'POL', 'بولندا'),
(20820, 1401872384, 1401874431, 'GB', 'GBR', 'المملكة المتحدة'),
(20821, 1401874432, 1401876479, 'UA', 'UKR', 'أوكرانيا'),
(20822, 1401876480, 1401878527, 'ES', 'ESP', 'إسبانيا'),
(20823, 1401878528, 1401880575, 'MT', 'MLT', 'مالطا'),
(20824, 1401880576, 1401882623, 'DE', 'DEU', 'ألمانيا'),
(20825, 1401882624, 1401884671, 'NG', 'NGA', 'نيجيريا'),
(20826, 1401884672, 1401886719, 'FR', 'FRA', 'فرنسا'),
(20827, 1401888768, 1401890815, 'RU', 'RUS', 'الإتحاد الروسي'),
(20828, 1401890816, 1401892863, 'PL', 'POL', 'بولندا'),
(20829, 1401892864, 1401894911, 'RU', 'RUS', 'الإتحاد الروسي'),
(20830, 1401894912, 1401896959, 'FI', 'FIN', 'فنلندا'),
(20831, 1401896960, 1401899007, 'RU', 'RUS', 'الإتحاد الروسي'),
(20832, 1401899008, 1401901055, 'PL', 'POL', 'بولندا'),
(20833, 1401901056, 1401903103, 'NO', 'NOR', 'النرويج'),
(20834, 1401903104, 1401905151, 'FI', 'FIN', 'فنلندا'),
(20835, 1401905152, 1401907199, 'PL', 'POL', 'بولندا'),
(20836, 1401907200, 1401909247, 'GR', 'GRC', 'اليونان'),
(20837, 1401909248, 1401911295, 'NO', 'NOR', 'النرويج'),
(20838, 1401911296, 1401913343, 'DK', 'DNK', 'الدنيمارك'),
(20839, 1401913344, 1401917439, 'PL', 'POL', 'بولندا'),
(20840, 1401917440, 1401919487, 'BG', 'BGR', 'بلغاريا'),
(20841, 1401919488, 1401921535, 'RU', 'RUS', 'الإتحاد الروسي'),
(20842, 1401921536, 1401923583, 'PL', 'POL', 'بولندا'),
(20843, 1401923584, 1401925631, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(20844, 1401925632, 1401927679, 'BG', 'BGR', 'بلغاريا'),
(20845, 1401927680, 1401929727, 'NL', 'NLD', 'هولندا'),
(20846, 1401929728, 1401931775, 'RU', 'RUS', 'الإتحاد الروسي'),
(20847, 1401931776, 1401933823, 'UA', 'UKR', 'أوكرانيا'),
(20848, 1401933824, 1401935871, 'PL', 'POL', 'بولندا'),
(20849, 1401935872, 1401937919, 'FI', 'FIN', 'فنلندا'),
(20850, 1401937920, 1401939967, 'GB', 'GBR', 'المملكة المتحدة'),
(20851, 1401939968, 1401942015, 'UA', 'UKR', 'أوكرانيا'),
(20852, 1401944064, 1401946111, 'BG', 'BGR', 'بلغاريا'),
(20853, 1401946112, 1401962495, 'FR', 'FRA', 'فرنسا'),
(20854, 1401962496, 1401978879, 'PL', 'POL', 'بولندا'),
(20855, 1401978880, 1401995263, 'PT', 'PRT', 'البورتوغال'),
(20856, 1401995264, 1402011647, 'CH', 'CHE', 'سويسرا'),
(20857, 1402011648, 1402025951, 'SE', 'SWE', 'السويد'),
(20858, 1402025952, 1402025983, 'DK', 'DNK', 'الدنيمارك'),
(20859, 1402025984, 1402028031, 'SE', 'SWE', 'السويد'),
(20860, 1402028032, 1402044415, 'FR', 'FRA', 'فرنسا'),
(20861, 1402044416, 1402060799, 'PL', 'POL', 'بولندا'),
(20862, 1402060800, 1402077183, 'FI', 'FIN', 'فنلندا'),
(20863, 1402077184, 1402093567, 'GB', 'GBR', 'المملكة المتحدة'),
(20864, 1402093568, 1402109951, 'RU', 'RUS', 'الإتحاد الروسي'),
(20865, 1402109952, 1402142719, 'FI', 'FIN', 'فنلندا'),
(20866, 1402142720, 1402159103, 'ES', 'ESP', 'إسبانيا'),
(20867, 1402159104, 1402175487, 'IT', 'ITA', 'إيطاليا'),
(20868, 1402175488, 1402191871, 'IE', 'IRL', 'إيرلندا'),
(20869, 1402191872, 1402208255, 'IR', 'IRN', 'إيران'),
(20870, 1402208256, 1402224639, 'CZ', 'CZE', 'التشيك'),
(20871, 1402224640, 1402241023, 'BG', 'BGR', 'بلغاريا'),
(20872, 1402241024, 1402257407, 'GB', 'GBR', 'المملكة المتحدة'),
(20873, 1402257408, 1402273791, 'FI', 'FIN', 'فنلندا'),
(20874, 1402273792, 1402277119, 'RU', 'RUS', 'الإتحاد الروسي'),
(20875, 1402277120, 1402277375, 'MD', 'MDA', 'مولدوفا'),
(20876, 1402277376, 1402277631, 'KG', 'KGZ', 'قيرغيزستان'),
(20877, 1402277632, 1402277887, 'TJ', 'TJK', 'طاجيكيستان'),
(20878, 1402277888, 1402290175, 'RU', 'RUS', 'الإتحاد الروسي'),
(20879, 1402290176, 1402306559, 'NL', 'NLD', 'هولندا'),
(20880, 1402306560, 1402322943, 'IT', 'ITA', 'إيطاليا'),
(20881, 1402322944, 1402339327, 'RU', 'RUS', 'الإتحاد الروسي'),
(20882, 1402339328, 1402355711, 'CH', 'CHE', 'سويسرا'),
(20883, 1402355712, 1402372095, 'FI', 'FIN', 'فنلندا'),
(20884, 1402372096, 1402388479, 'SE', 'SWE', 'السويد'),
(20885, 1402388480, 1402404863, 'ES', 'ESP', 'إسبانيا'),
(20886, 1402404864, 1402408959, 'RU', 'RUS', 'الإتحاد الروسي'),
(20887, 1402408960, 1402413055, 'DE', 'DEU', 'ألمانيا'),
(20888, 1402413056, 1402417151, 'PL', 'POL', 'بولندا'),
(20889, 1402417152, 1402421247, 'DE', 'DEU', 'ألمانيا'),
(20890, 1402421248, 1402422783, 'FR', 'FRA', 'فرنسا'),
(20891, 1402422784, 1402423039, 'LU', 'LUX', 'لوكسيمبورغ'),
(20892, 1402423040, 1402423295, 'FR', 'FRA', 'فرنسا'),
(20893, 1402423296, 1402423807, 'BE', 'BEL', 'بلجيكا'),
(20894, 1402423808, 1402424319, 'FR', 'FRA', 'فرنسا'),
(20895, 1402424320, 1402424575, 'BE', 'BEL', 'بلجيكا'),
(20896, 1402424576, 1402424831, 'FR', 'FRA', 'فرنسا'),
(20897, 1402424832, 1402425343, 'GB', 'GBR', 'المملكة المتحدة'),
(20898, 1402425344, 1402425599, 'DE', 'DEU', 'ألمانيا'),
(20899, 1402425600, 1402425855, 'LU', 'LUX', 'لوكسيمبورغ'),
(20900, 1402425856, 1402426367, 'FR', 'FRA', 'فرنسا'),
(20901, 1402426368, 1402426623, 'DE', 'DEU', 'ألمانيا'),
(20902, 1402426624, 1402427135, 'CH', 'CHE', 'سويسرا'),
(20903, 1402427136, 1402429439, 'GB', 'GBR', 'المملكة المتحدة'),
(20904, 1402429440, 1402431487, 'US', 'USA', 'الولايات المتحدة'),
(20905, 1402431488, 1402433535, 'GB', 'GBR', 'المملكة المتحدة'),
(20906, 1402433536, 1402434047, 'FR', 'FRA', 'فرنسا'),
(20907, 1402434048, 1402434559, 'GB', 'GBR', 'المملكة المتحدة'),
(20908, 1402434560, 1402434815, 'US', 'USA', 'الولايات المتحدة'),
(20909, 1402434816, 1402437631, 'GB', 'GBR', 'المملكة المتحدة'),
(20910, 1402437632, 1402454015, 'DK', 'DNK', 'الدنيمارك'),
(20911, 1402454016, 1402470399, 'GB', 'GBR', 'المملكة المتحدة'),
(20912, 1402470400, 1402994687, 'FR', 'FRA', 'فرنسا'),
(20913, 1402994688, 1403256831, 'NL', 'NLD', 'هولندا'),
(20914, 1403256832, 1403322367, 'AT', 'AUT', 'النمسا'),
(20915, 1403322368, 1403387903, 'ES', 'ESP', 'إسبانيا'),
(20916, 1403387904, 1403396095, 'SE', 'SWE', 'السويد'),
(20917, 1403396096, 1403400191, 'EE', 'EST', 'إستونيا'),
(20918, 1403400192, 1403400207, 'TR', 'TUR', 'تركيا'),
(20919, 1403400208, 1403400215, 'EE', 'EST', 'إستونيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(20920, 1403400216, 1403400219, 'US', 'USA', 'الولايات المتحدة'),
(20921, 1403400220, 1403400239, 'EE', 'EST', 'إستونيا'),
(20922, 1403400240, 1403400255, 'BG', 'BGR', 'بلغاريا'),
(20923, 1403400256, 1403400263, 'EE', 'EST', 'إستونيا'),
(20924, 1403400264, 1403400271, 'US', 'USA', 'الولايات المتحدة'),
(20925, 1403400272, 1403404287, 'EE', 'EST', 'إستونيا'),
(20926, 1403404288, 1403412479, 'GB', 'GBR', 'المملكة المتحدة'),
(20927, 1403420672, 1403428863, 'NL', 'NLD', 'هولندا'),
(20928, 1403428864, 1403437055, 'GB', 'GBR', 'المملكة المتحدة'),
(20929, 1403437056, 1403445247, 'RO', 'ROM', 'رومانيا'),
(20930, 1403445248, 1403461631, 'RU', 'RUS', 'الإتحاد الروسي'),
(20931, 1403461632, 1403464663, 'FR', 'FRA', 'فرنسا'),
(20932, 1403464664, 1403464671, 'BE', 'BEL', 'بلجيكا'),
(20933, 1403464672, 1403469423, 'FR', 'FRA', 'فرنسا'),
(20934, 1403469424, 1403469431, 'US', 'USA', 'الولايات المتحدة'),
(20935, 1403469432, 1403469823, 'FR', 'FRA', 'فرنسا'),
(20936, 1403469824, 1403486207, 'RU', 'RUS', 'الإتحاد الروسي'),
(20937, 1403486208, 1403494399, 'FR', 'FRA', 'فرنسا'),
(20938, 1403494400, 1403502591, 'GB', 'GBR', 'المملكة المتحدة'),
(20939, 1403502592, 1403510783, 'NL', 'NLD', 'هولندا'),
(20940, 1403510784, 1403518975, 'CZ', 'CZE', 'التشيك'),
(20941, 1403518976, 1403535359, 'CY', 'CYP', 'قبرص'),
(20942, 1403535360, 1403551743, 'PL', 'POL', 'بولندا'),
(20943, 1403551744, 1403568127, 'SK', 'SVK', 'سلوفاكيا'),
(20944, 1403568128, 1403584511, 'SE', 'SWE', 'السويد'),
(20945, 1403584512, 1403600895, 'DE', 'DEU', 'ألمانيا'),
(20946, 1403600896, 1403617279, 'FR', 'FRA', 'فرنسا'),
(20947, 1403617280, 1403633663, 'DE', 'DEU', 'ألمانيا'),
(20948, 1403633664, 1403650047, 'RU', 'RUS', 'الإتحاد الروسي'),
(20949, 1403650048, 1403655935, 'DE', 'DEU', 'ألمانيا'),
(20950, 1403655936, 1403655943, 'IR', 'IRN', 'إيران'),
(20951, 1403655944, 1403656703, 'DE', 'DEU', 'ألمانيا'),
(20952, 1403656704, 1403656959, 'IR', 'IRN', 'إيران'),
(20953, 1403656960, 1403658495, 'DE', 'DEU', 'ألمانيا'),
(20954, 1403658496, 1403658527, 'IR', 'IRN', 'إيران'),
(20955, 1403658528, 1403658559, 'KW', 'KWT', 'الكويت'),
(20956, 1403658560, 1403658847, 'DE', 'DEU', 'ألمانيا'),
(20957, 1403658848, 1403658879, 'IR', 'IRN', 'إيران'),
(20958, 1403658880, 1403658911, 'DE', 'DEU', 'ألمانيا'),
(20959, 1403658912, 1403658975, 'IR', 'IRN', 'إيران'),
(20960, 1403658976, 1403660735, 'DE', 'DEU', 'ألمانيا'),
(20961, 1403660736, 1403660799, 'IR', 'IRN', 'إيران'),
(20962, 1403660800, 1403661183, 'DE', 'DEU', 'ألمانيا'),
(20963, 1403661184, 1403661215, 'IR', 'IRN', 'إيران'),
(20964, 1403661216, 1403661279, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20965, 1403661280, 1403661310, 'IR', 'IRN', 'إيران'),
(20966, 1403661311, 1403661631, 'DE', 'DEU', 'ألمانيا'),
(20967, 1403661632, 1403661663, 'IR', 'IRN', 'إيران'),
(20968, 1403661664, 1403661727, 'DE', 'DEU', 'ألمانيا'),
(20969, 1403661728, 1403661759, 'IR', 'IRN', 'إيران'),
(20970, 1403661760, 1403661887, 'DE', 'DEU', 'ألمانيا'),
(20971, 1403661888, 1403661919, 'IR', 'IRN', 'إيران'),
(20972, 1403661920, 1403661951, 'DE', 'DEU', 'ألمانيا'),
(20973, 1403661952, 1403661983, 'IR', 'IRN', 'إيران'),
(20974, 1403661984, 1403662015, 'DE', 'DEU', 'ألمانيا'),
(20975, 1403662016, 1403662047, 'IR', 'IRN', 'إيران'),
(20976, 1403662048, 1403662111, 'DE', 'DEU', 'ألمانيا'),
(20977, 1403662112, 1403662143, 'IR', 'IRN', 'إيران'),
(20978, 1403662144, 1403662175, 'DE', 'DEU', 'ألمانيا'),
(20979, 1403662176, 1403662207, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20980, 1403662208, 1403662271, 'DE', 'DEU', 'ألمانيا'),
(20981, 1403662272, 1403662303, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20982, 1403662304, 1403662495, 'DE', 'DEU', 'ألمانيا'),
(20983, 1403662496, 1403662527, 'IR', 'IRN', 'إيران'),
(20984, 1403662528, 1403662655, 'DE', 'DEU', 'ألمانيا'),
(20985, 1403662656, 1403662687, 'IR', 'IRN', 'إيران'),
(20986, 1403662688, 1403662815, 'DE', 'DEU', 'ألمانيا'),
(20987, 1403662816, 1403662911, 'IR', 'IRN', 'إيران'),
(20988, 1403662912, 1403662943, 'DE', 'DEU', 'ألمانيا'),
(20989, 1403662944, 1403662975, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20990, 1403662976, 1403663039, 'IR', 'IRN', 'إيران'),
(20991, 1403663040, 1403663135, 'DE', 'DEU', 'ألمانيا'),
(20992, 1403663136, 1403663199, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(20993, 1403663200, 1403663359, 'DE', 'DEU', 'ألمانيا'),
(20994, 1403663360, 1403663487, 'IR', 'IRN', 'إيران'),
(20995, 1403663488, 1403663511, 'DE', 'DEU', 'ألمانيا'),
(20996, 1403663512, 1403663519, 'IR', 'IRN', 'إيران'),
(20997, 1403663520, 1403663527, 'DE', 'DEU', 'ألمانيا'),
(20998, 1403663528, 1403663535, 'IQ', 'IRQ', 'العراق'),
(20999, 1403663536, 1403663567, 'DE', 'DEU', 'ألمانيا'),
(21000, 1403663568, 1403663575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21001, 1403663576, 1403663589, 'DE', 'DEU', 'ألمانيا'),
(21002, 1403663590, 1403663590, 'IR', 'IRN', 'إيران'),
(21003, 1403663591, 1403664895, 'DE', 'DEU', 'ألمانيا'),
(21004, 1403664896, 1403664927, 'TZ', 'TZA', 'تانزانيا'),
(21005, 1403664928, 1403666431, 'DE', 'DEU', 'ألمانيا'),
(21006, 1403666432, 1403699199, 'GB', 'GBR', 'المملكة المتحدة'),
(21007, 1403699200, 1403715583, 'UA', 'UKR', 'أوكرانيا'),
(21008, 1403715584, 1403731967, 'LT', 'LTU', 'ليتوانيا'),
(21009, 1403731968, 1403748351, 'RU', 'RUS', 'الإتحاد الروسي'),
(21010, 1403748352, 1403764735, 'DE', 'DEU', 'ألمانيا'),
(21011, 1403764736, 1403781119, 'GR', 'GRC', 'اليونان'),
(21012, 1403781120, 1403797503, 'RU', 'RUS', 'الإتحاد الروسي'),
(21013, 1403797504, 1403813887, 'SE', 'SWE', 'السويد'),
(21014, 1403813888, 1403830271, 'NL', 'NLD', 'هولندا'),
(21015, 1403830272, 1403846655, 'CH', 'CHE', 'سويسرا'),
(21016, 1403846656, 1403863039, 'IS', 'ISL', 'أيسلندا'),
(21017, 1403863040, 1403879423, 'FR', 'FRA', 'فرنسا'),
(21018, 1403879424, 1403895807, 'ES', 'ESP', 'إسبانيا'),
(21019, 1403895808, 1403912191, 'CH', 'CHE', 'سويسرا'),
(21020, 1403912192, 1403928575, 'PT', 'PRT', 'البورتوغال'),
(21021, 1403928576, 1403944959, 'SE', 'SWE', 'السويد'),
(21022, 1403944960, 1403961343, 'GR', 'GRC', 'اليونان'),
(21023, 1403961344, 1403977727, 'RU', 'RUS', 'الإتحاد الروسي'),
(21024, 1403977728, 1403994111, 'IT', 'ITA', 'إيطاليا'),
(21025, 1403994112, 1404010495, 'AT', 'AUT', 'النمسا'),
(21026, 1404010496, 1404026879, 'PL', 'POL', 'بولندا'),
(21027, 1404026880, 1404043263, 'ES', 'ESP', 'إسبانيا'),
(21028, 1404043264, 1404076031, 'SE', 'SWE', 'السويد'),
(21029, 1404076032, 1404084223, 'DE', 'DEU', 'ألمانيا'),
(21030, 1404084224, 1404088319, 'BE', 'BEL', 'بلجيكا'),
(21031, 1404088320, 1404184063, 'SE', 'SWE', 'السويد'),
(21032, 1404184064, 1404184575, 'NO', 'NOR', 'النرويج'),
(21033, 1404184576, 1404186623, 'SE', 'SWE', 'السويد'),
(21034, 1404186624, 1404187647, 'NO', 'NOR', 'النرويج'),
(21035, 1404187648, 1404188671, 'SE', 'SWE', 'السويد'),
(21036, 1404188672, 1404189183, 'LT', 'LTU', 'ليتوانيا'),
(21037, 1404189184, 1404189695, 'EE', 'EST', 'إستونيا'),
(21038, 1404189696, 1404192767, 'SE', 'SWE', 'السويد'),
(21039, 1404192768, 1404194815, 'LV', 'LVA', 'لاتفيا'),
(21040, 1404194816, 1404195839, 'LT', 'LTU', 'ليتوانيا'),
(21041, 1404195840, 1404196351, 'SE', 'SWE', 'السويد'),
(21042, 1404196352, 1404197375, 'LT', 'LTU', 'ليتوانيا'),
(21043, 1404197376, 1404197887, 'SE', 'SWE', 'السويد'),
(21044, 1404197888, 1404198911, 'LT', 'LTU', 'ليتوانيا'),
(21045, 1404198912, 1404200959, 'SE', 'SWE', 'السويد'),
(21046, 1404200960, 1404203007, 'NL', 'NLD', 'هولندا'),
(21047, 1404203008, 1404204031, 'HR', 'HRV', 'كرواتيا'),
(21048, 1404204032, 1404210175, 'SE', 'SWE', 'السويد'),
(21049, 1404210176, 1404212223, 'LV', 'LVA', 'لاتفيا'),
(21050, 1404212224, 1404215295, 'SE', 'SWE', 'السويد'),
(21051, 1404215296, 1404219391, 'LV', 'LVA', 'لاتفيا'),
(21052, 1404219392, 1404220415, 'SE', 'SWE', 'السويد'),
(21053, 1404220416, 1404221439, 'EE', 'EST', 'إستونيا'),
(21054, 1404221440, 1404222463, 'RU', 'RUS', 'الإتحاد الروسي'),
(21055, 1404222464, 1404222975, 'LV', 'LVA', 'لاتفيا'),
(21056, 1404222976, 1404225535, 'SE', 'SWE', 'السويد'),
(21057, 1404225536, 1404227071, 'RU', 'RUS', 'الإتحاد الروسي'),
(21058, 1404227072, 1404227583, 'HR', 'HRV', 'كرواتيا'),
(21059, 1404227584, 1404231679, 'LV', 'LVA', 'لاتفيا'),
(21060, 1404231680, 1404232703, 'SE', 'SWE', 'السويد'),
(21061, 1404232704, 1404233215, 'CH', 'CHE', 'سويسرا'),
(21062, 1404233216, 1404234239, 'SE', 'SWE', 'السويد'),
(21063, 1404234240, 1404235775, 'HR', 'HRV', 'كرواتيا'),
(21064, 1404235776, 1404305407, 'SE', 'SWE', 'السويد'),
(21065, 1404305408, 1404321791, 'NL', 'NLD', 'هولندا'),
(21066, 1404321792, 1404379135, 'SE', 'SWE', 'السويد'),
(21067, 1404379136, 1404383231, 'AT', 'AUT', 'النمسا'),
(21068, 1404383232, 1404387327, 'SE', 'SWE', 'السويد'),
(21069, 1404387328, 1404395519, 'DE', 'DEU', 'ألمانيا'),
(21070, 1404395520, 1404403711, 'SE', 'SWE', 'السويد'),
(21071, 1404403712, 1404411903, 'NL', 'NLD', 'هولندا'),
(21072, 1404411904, 1404436479, 'SE', 'SWE', 'السويد'),
(21073, 1404436480, 1404502015, 'BE', 'BEL', 'بلجيكا'),
(21074, 1404502016, 1404645375, 'SE', 'SWE', 'السويد'),
(21075, 1404645376, 1404645887, 'HR', 'HRV', 'كرواتيا'),
(21076, 1404645888, 1404698623, 'SE', 'SWE', 'السويد'),
(21077, 1404698624, 1404764159, 'BE', 'BEL', 'بلجيكا'),
(21078, 1404764160, 1404768255, 'NL', 'NLD', 'هولندا'),
(21079, 1404768256, 1404802047, 'SE', 'SWE', 'السويد'),
(21080, 1404802048, 1404802559, 'EE', 'EST', 'إستونيا'),
(21081, 1404802560, 1404803071, 'SE', 'SWE', 'السويد'),
(21082, 1404803072, 1404803583, 'LV', 'LVA', 'لاتفيا'),
(21083, 1404803584, 1404805119, 'SE', 'SWE', 'السويد'),
(21084, 1404805120, 1404813311, 'AT', 'AUT', 'النمسا'),
(21085, 1404813312, 1404829695, 'SE', 'SWE', 'السويد'),
(21086, 1404829696, 1404870655, 'RU', 'RUS', 'الإتحاد الروسي'),
(21087, 1404870656, 1404872703, 'LT', 'LTU', 'ليتوانيا'),
(21088, 1404872704, 1404874751, 'SE', 'SWE', 'السويد'),
(21089, 1404874752, 1404875775, 'LV', 'LVA', 'لاتفيا'),
(21090, 1404875776, 1404876799, 'LT', 'LTU', 'ليتوانيا'),
(21091, 1404876800, 1404895231, 'SE', 'SWE', 'السويد'),
(21092, 1404895232, 1404927999, 'DE', 'DEU', 'ألمانيا'),
(21093, 1404928000, 1404952575, 'SE', 'SWE', 'السويد'),
(21094, 1404952576, 1404960767, 'NL', 'NLD', 'هولندا'),
(21095, 1404960768, 1405050879, 'SE', 'SWE', 'السويد'),
(21096, 1405050880, 1405059071, 'AT', 'AUT', 'النمسا'),
(21097, 1405059072, 1405063167, 'SE', 'SWE', 'السويد'),
(21098, 1405063168, 1405065215, 'NO', 'NOR', 'النرويج'),
(21099, 1405065216, 1405067263, 'SE', 'SWE', 'السويد'),
(21100, 1405067264, 1405075455, 'DE', 'DEU', 'ألمانيا'),
(21101, 1405075456, 1405083647, 'FR', 'FRA', 'فرنسا'),
(21102, 1405083648, 1405091839, 'SE', 'SWE', 'السويد'),
(21103, 1405091840, 1406140415, 'FR', 'FRA', 'فرنسا'),
(21104, 1406140416, 1406205951, 'CZ', 'CZE', 'التشيك'),
(21105, 1406205952, 1406271487, 'SE', 'SWE', 'السويد'),
(21106, 1406271488, 1406337023, 'IE', 'IRL', 'إيرلندا'),
(21107, 1406337024, 1406402559, 'IT', 'ITA', 'إيطاليا'),
(21108, 1406402560, 1406468095, 'GR', 'GRC', 'اليونان'),
(21109, 1406468096, 1406533631, 'ES', 'ESP', 'إسبانيا'),
(21110, 1406533632, 1406599167, 'FR', 'FRA', 'فرنسا'),
(21111, 1406599168, 1406664703, 'AT', 'AUT', 'النمسا'),
(21112, 1406664704, 1406672895, 'FI', 'FIN', 'فنلندا'),
(21113, 1406672896, 1406681087, 'HU', 'HUN', 'هنغاريا'),
(21114, 1406681088, 1406689279, 'GB', 'GBR', 'المملكة المتحدة'),
(21115, 1406689280, 1406697471, 'SE', 'SWE', 'السويد'),
(21116, 1406697472, 1406705663, 'GB', 'GBR', 'المملكة المتحدة'),
(21117, 1406705664, 1406713855, 'IT', 'ITA', 'إيطاليا'),
(21118, 1406713856, 1406717695, 'AT', 'AUT', 'النمسا'),
(21119, 1406717696, 1406717951, 'DE', 'DEU', 'ألمانيا'),
(21120, 1406717952, 1406722047, 'AT', 'AUT', 'النمسا'),
(21121, 1406722048, 1406730239, 'DE', 'DEU', 'ألمانيا'),
(21122, 1406730240, 1406746623, 'RU', 'RUS', 'الإتحاد الروسي'),
(21123, 1406746624, 1406754815, 'BE', 'BEL', 'بلجيكا'),
(21124, 1406754816, 1406763007, 'GB', 'GBR', 'المملكة المتحدة'),
(21125, 1406763008, 1406771199, 'BE', 'BEL', 'بلجيكا'),
(21126, 1406771200, 1406779391, 'GB', 'GBR', 'المملكة المتحدة'),
(21127, 1406779392, 1406787583, 'RU', 'RUS', 'الإتحاد الروسي'),
(21128, 1406787584, 1406795775, 'AM', 'ARM', 'أرمينيا'),
(21129, 1406795776, 1406803967, 'GB', 'GBR', 'المملكة المتحدة'),
(21130, 1406803968, 1406812159, 'DE', 'DEU', 'ألمانيا'),
(21131, 1406812160, 1406820351, 'SE', 'SWE', 'السويد'),
(21132, 1406820352, 1406828543, 'PL', 'POL', 'بولندا'),
(21133, 1406828544, 1406836735, 'GB', 'GBR', 'المملكة المتحدة'),
(21134, 1406836736, 1406844927, 'AT', 'AUT', 'النمسا'),
(21135, 1406844928, 1406853119, 'MD', 'MDA', 'مولدوفا'),
(21136, 1406853120, 1406861311, 'UA', 'UKR', 'أوكرانيا'),
(21137, 1406861312, 1406869503, 'RU', 'RUS', 'الإتحاد الروسي'),
(21138, 1406869504, 1406877695, 'GB', 'GBR', 'المملكة المتحدة'),
(21139, 1406877696, 1406885887, 'NL', 'NLD', 'هولندا'),
(21140, 1406885888, 1406894079, 'CH', 'CHE', 'سويسرا'),
(21141, 1406894080, 1406902271, 'RU', 'RUS', 'الإتحاد الروسي'),
(21142, 1406902272, 1406910463, 'AT', 'AUT', 'النمسا'),
(21143, 1406910464, 1406918655, 'SE', 'SWE', 'السويد'),
(21144, 1406918656, 1406926335, 'RU', 'RUS', 'الإتحاد الروسي'),
(21145, 1406926336, 1406926847, 'DE', 'DEU', 'ألمانيا'),
(21146, 1406926848, 1406935039, 'IT', 'ITA', 'إيطاليا'),
(21147, 1406935040, 1406951423, 'RU', 'RUS', 'الإتحاد الروسي'),
(21148, 1406951424, 1406959615, 'PL', 'POL', 'بولندا'),
(21149, 1406959616, 1406964287, 'DE', 'DEU', 'ألمانيا'),
(21150, 1406964288, 1406964319, 'CH', 'CHE', 'سويسرا'),
(21151, 1406964320, 1406964327, 'BG', 'BGR', 'بلغاريا'),
(21152, 1406964328, 1406964735, 'DE', 'DEU', 'ألمانيا'),
(21153, 1406964736, 1406964927, 'US', 'USA', 'الولايات المتحدة'),
(21154, 1406964928, 1406967295, 'DE', 'DEU', 'ألمانيا'),
(21155, 1406967296, 1406967327, 'GB', 'GBR', 'المملكة المتحدة'),
(21156, 1406967328, 1406967343, 'NL', 'NLD', 'هولندا'),
(21157, 1406967344, 1406967807, 'DE', 'DEU', 'ألمانيا'),
(21158, 1406967808, 1406975999, 'RU', 'RUS', 'الإتحاد الروسي'),
(21159, 1406976000, 1406984191, 'IE', 'IRL', 'إيرلندا'),
(21160, 1406984192, 1407000575, 'RU', 'RUS', 'الإتحاد الروسي'),
(21161, 1407000576, 1407016959, 'DE', 'DEU', 'ألمانيا'),
(21162, 1407016960, 1407025151, 'IT', 'ITA', 'إيطاليا'),
(21163, 1407025152, 1407025663, 'DK', 'DNK', 'الدنيمارك'),
(21164, 1407025664, 1407025919, 'US', 'USA', 'الولايات المتحدة'),
(21165, 1407025920, 1407033343, 'DK', 'DNK', 'الدنيمارك'),
(21166, 1407033344, 1407033855, 'UZ', 'UZB', 'أوزباكستان'),
(21167, 1407033856, 1407034111, 'RU', 'RUS', 'الإتحاد الروسي'),
(21168, 1407034112, 1407034367, 'UZ', 'UZB', 'أوزباكستان'),
(21169, 1407034368, 1407035391, 'RU', 'RUS', 'الإتحاد الروسي'),
(21170, 1407035392, 1407041535, 'UZ', 'UZB', 'أوزباكستان'),
(21171, 1407041536, 1407049727, 'RU', 'RUS', 'الإتحاد الروسي'),
(21172, 1407049728, 1407057919, 'DE', 'DEU', 'ألمانيا'),
(21173, 1407057920, 1407066111, 'RU', 'RUS', 'الإتحاد الروسي'),
(21174, 1407066112, 1407074303, 'LU', 'LUX', 'لوكسيمبورغ'),
(21175, 1407074304, 1407082623, 'RU', 'RUS', 'الإتحاد الروسي'),
(21176, 1407082624, 1407082639, 'DE', 'DEU', 'ألمانيا'),
(21177, 1407082640, 1407089663, 'RU', 'RUS', 'الإتحاد الروسي'),
(21178, 1407089664, 1407090559, 'ES', 'ESP', 'إسبانيا'),
(21179, 1407090560, 1407090687, 'US', 'USA', 'الولايات المتحدة'),
(21180, 1407090688, 1407098879, 'CH', 'CHE', 'سويسرا'),
(21181, 1407098880, 1407107071, 'BG', 'BGR', 'بلغاريا'),
(21182, 1407107072, 1407115263, 'RU', 'RUS', 'الإتحاد الروسي'),
(21183, 1407115264, 1407123455, 'GB', 'GBR', 'المملكة المتحدة'),
(21184, 1407123456, 1407131647, 'SE', 'SWE', 'السويد'),
(21185, 1407131648, 1407139839, 'NL', 'NLD', 'هولندا'),
(21186, 1407139840, 1407148031, 'DE', 'DEU', 'ألمانيا'),
(21187, 1407148032, 1407156223, 'GB', 'GBR', 'المملكة المتحدة'),
(21188, 1407156224, 1407164415, 'LV', 'LVA', 'لاتفيا'),
(21189, 1407164416, 1407172607, 'PT', 'PRT', 'البورتوغال'),
(21190, 1407172608, 1407180799, 'GB', 'GBR', 'المملكة المتحدة'),
(21191, 1407180800, 1407188991, 'RU', 'RUS', 'الإتحاد الروسي'),
(21192, 1407188992, 1407320063, 'IT', 'ITA', 'إيطاليا'),
(21193, 1407320064, 1407451135, 'SE', 'SWE', 'السويد'),
(21194, 1407451136, 1407483903, 'BG', 'BGR', 'بلغاريا'),
(21195, 1407483904, 1407516671, 'CH', 'CHE', 'سويسرا'),
(21196, 1407516672, 1407516679, 'GB', 'GBR', 'المملكة المتحدة'),
(21197, 1407516680, 1407516687, 'NG', 'NGA', 'نيجيريا'),
(21198, 1407516688, 1407516703, 'GB', 'GBR', 'المملكة المتحدة'),
(21199, 1407516704, 1407516735, 'NG', 'NGA', 'نيجيريا'),
(21200, 1407516736, 1407516743, 'UG', 'UGA', 'أوغاندا'),
(21201, 1407516744, 1407516751, 'LR', 'LBR', 'ليبيريا'),
(21202, 1407516752, 1407516759, 'SL', 'SLE', 'سيراليون'),
(21203, 1407516760, 1407516767, 'GB', 'GBR', 'المملكة المتحدة'),
(21204, 1407516768, 1407516775, 'AO', 'AGO', 'أنغولا'),
(21205, 1407516776, 1407516783, 'GB', 'GBR', 'المملكة المتحدة'),
(21206, 1407516784, 1407516791, 'NG', 'NGA', 'نيجيريا'),
(21207, 1407516792, 1407516799, 'AO', 'AGO', 'أنغولا'),
(21208, 1407516800, 1407516807, 'GH', 'GHA', 'غانا'),
(21209, 1407516808, 1407516815, 'NG', 'NGA', 'نيجيريا'),
(21210, 1407516816, 1407516831, 'GB', 'GBR', 'المملكة المتحدة'),
(21211, 1407516832, 1407516839, 'NG', 'NGA', 'نيجيريا'),
(21212, 1407516840, 1407516847, 'GB', 'GBR', 'المملكة المتحدة'),
(21213, 1407516848, 1407516855, 'NG', 'NGA', 'نيجيريا'),
(21214, 1407516856, 1407516863, 'GB', 'GBR', 'المملكة المتحدة'),
(21215, 1407516864, 1407516895, 'NG', 'NGA', 'نيجيريا'),
(21216, 1407516896, 1407516911, 'GB', 'GBR', 'المملكة المتحدة'),
(21217, 1407516912, 1407516927, 'NG', 'NGA', 'نيجيريا'),
(21218, 1407516928, 1407517183, 'ZW', 'ZWE', 'زمبابواي'),
(21219, 1407517184, 1407517383, 'GB', 'GBR', 'المملكة المتحدة'),
(21220, 1407517384, 1407517391, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21221, 1407517392, 1407517415, 'GB', 'GBR', 'المملكة المتحدة'),
(21222, 1407517416, 1407517439, 'NG', 'NGA', 'نيجيريا'),
(21223, 1407517440, 1407517823, 'GB', 'GBR', 'المملكة المتحدة'),
(21224, 1407517824, 1407517887, 'NG', 'NGA', 'نيجيريا'),
(21225, 1407517888, 1407517919, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21226, 1407517920, 1407517951, 'ZW', 'ZWE', 'زمبابواي'),
(21227, 1407517952, 1407518015, 'SL', 'SLE', 'سيراليون'),
(21228, 1407518016, 1407518031, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(21229, 1407518032, 1407518039, 'GB', 'GBR', 'المملكة المتحدة'),
(21230, 1407518040, 1407518047, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21231, 1407518048, 1407518063, 'NG', 'NGA', 'نيجيريا'),
(21232, 1407518064, 1407518079, 'GB', 'GBR', 'المملكة المتحدة'),
(21233, 1407518080, 1407518111, 'FR', 'FRA', 'فرنسا'),
(21234, 1407518112, 1407518127, 'NG', 'NGA', 'نيجيريا'),
(21235, 1407518128, 1407518135, 'KE', 'KEN', 'كينيا'),
(21236, 1407518136, 1407518143, 'GH', 'GHA', 'غانا'),
(21237, 1407518144, 1407518159, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(21238, 1407518160, 1407518167, 'NG', 'NGA', 'نيجيريا'),
(21239, 1407518168, 1407518175, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21240, 1407518176, 1407518183, 'GH', 'GHA', 'غانا'),
(21241, 1407518184, 1407518199, 'NG', 'NGA', 'نيجيريا'),
(21242, 1407518200, 1407518207, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21243, 1407518208, 1407518215, 'ZW', 'ZWE', 'زمبابواي'),
(21244, 1407518216, 1407518223, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(21245, 1407518224, 1407518231, 'GB', 'GBR', 'المملكة المتحدة'),
(21246, 1407518232, 1407518255, 'NG', 'NGA', 'نيجيريا'),
(21247, 1407518256, 1407518269, 'GH', 'GHA', 'غانا'),
(21248, 1407518270, 1407518335, 'GB', 'GBR', 'المملكة المتحدة'),
(21249, 1407518336, 1407518343, 'CG', 'COG', 'الكونغو'),
(21250, 1407518344, 1407518351, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(21251, 1407518352, 1407518359, 'GH', 'GHA', 'غانا'),
(21252, 1407518360, 1407518367, 'NG', 'NGA', 'نيجيريا'),
(21253, 1407518368, 1407518375, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(21254, 1407518376, 1407518391, 'NG', 'NGA', 'نيجيريا'),
(21255, 1407518392, 1407518399, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21256, 1407518400, 1407518719, 'GB', 'GBR', 'المملكة المتحدة'),
(21257, 1407518720, 1407518783, 'AO', 'AGO', 'أنغولا'),
(21258, 1407518784, 1407518815, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21259, 1407518816, 1407518831, 'GB', 'GBR', 'المملكة المتحدة'),
(21260, 1407518832, 1407518847, 'NG', 'NGA', 'نيجيريا'),
(21261, 1407518848, 1407518911, 'GB', 'GBR', 'المملكة المتحدة'),
(21262, 1407518912, 1407518943, 'NG', 'NGA', 'نيجيريا'),
(21263, 1407518944, 1407518975, 'GB', 'GBR', 'المملكة المتحدة'),
(21264, 1407518976, 1407518983, 'NG', 'NGA', 'نيجيريا'),
(21265, 1407518984, 1407518991, 'GB', 'GBR', 'المملكة المتحدة'),
(21266, 1407518992, 1407518999, 'NG', 'NGA', 'نيجيريا'),
(21267, 1407519000, 1407519007, 'GB', 'GBR', 'المملكة المتحدة'),
(21268, 1407519008, 1407519015, 'NG', 'NGA', 'نيجيريا'),
(21269, 1407519016, 1407519023, 'AO', 'AGO', 'أنغولا'),
(21270, 1407519024, 1407519031, 'NG', 'NGA', 'نيجيريا'),
(21271, 1407519032, 1407519039, 'AO', 'AGO', 'أنغولا'),
(21272, 1407519040, 1407519047, 'NG', 'NGA', 'نيجيريا'),
(21273, 1407519048, 1407519055, 'GB', 'GBR', 'المملكة المتحدة'),
(21274, 1407519056, 1407519063, 'NG', 'NGA', 'نيجيريا'),
(21275, 1407519064, 1407519071, 'BJ', 'BEN', 'بنين'),
(21276, 1407519072, 1407519079, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21277, 1407519080, 1407519095, 'NG', 'NGA', 'نيجيريا'),
(21278, 1407519096, 1407519103, 'CM', 'CMR', 'الكاميرون'),
(21279, 1407519104, 1407519111, 'NG', 'NGA', 'نيجيريا'),
(21280, 1407519112, 1407519135, 'SL', 'SLE', 'سيراليون'),
(21281, 1407519136, 1407519143, 'GB', 'GBR', 'المملكة المتحدة'),
(21282, 1407519144, 1407519151, 'AO', 'AGO', 'أنغولا'),
(21283, 1407519152, 1407519159, 'GB', 'GBR', 'المملكة المتحدة'),
(21284, 1407519160, 1407519167, 'AO', 'AGO', 'أنغولا'),
(21285, 1407519168, 1407519175, 'NG', 'NGA', 'نيجيريا'),
(21286, 1407519176, 1407519183, 'SL', 'SLE', 'سيراليون'),
(21287, 1407519184, 1407519191, 'NG', 'NGA', 'نيجيريا'),
(21288, 1407519192, 1407519199, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21289, 1407519200, 1407519207, 'AO', 'AGO', 'أنغولا'),
(21290, 1407519208, 1407519215, 'TG', 'TGO', 'توغو'),
(21291, 1407519216, 1407519223, 'NG', 'NGA', 'نيجيريا'),
(21292, 1407519224, 1407519231, 'GB', 'GBR', 'المملكة المتحدة'),
(21293, 1407519232, 1407519615, 'NG', 'NGA', 'نيجيريا'),
(21294, 1407519616, 1407519743, 'GB', 'GBR', 'المملكة المتحدة'),
(21295, 1407519744, 1407519751, 'NG', 'NGA', 'نيجيريا'),
(21296, 1407519752, 1407519759, 'GB', 'GBR', 'المملكة المتحدة'),
(21297, 1407519760, 1407519775, 'NG', 'NGA', 'نيجيريا'),
(21298, 1407519776, 1407519783, 'GB', 'GBR', 'المملكة المتحدة'),
(21299, 1407519784, 1407519791, 'NG', 'NGA', 'نيجيريا'),
(21300, 1407519792, 1407519799, 'IQ', 'IRQ', 'العراق'),
(21301, 1407519800, 1407519839, 'GB', 'GBR', 'المملكة المتحدة'),
(21302, 1407519840, 1407519855, 'NG', 'NGA', 'نيجيريا'),
(21303, 1407519856, 1407520271, 'GB', 'GBR', 'المملكة المتحدة'),
(21304, 1407520272, 1407520279, 'NG', 'NGA', 'نيجيريا'),
(21305, 1407520280, 1407520303, 'GB', 'GBR', 'المملكة المتحدة'),
(21306, 1407520304, 1407520327, 'NG', 'NGA', 'نيجيريا'),
(21307, 1407520328, 1407520335, 'SL', 'SLE', 'سيراليون'),
(21308, 1407520336, 1407520343, 'GB', 'GBR', 'المملكة المتحدة'),
(21309, 1407520344, 1407520359, 'NG', 'NGA', 'نيجيريا'),
(21310, 1407520360, 1407520367, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21311, 1407520368, 1407520375, 'GB', 'GBR', 'المملكة المتحدة'),
(21312, 1407520376, 1407520397, 'NG', 'NGA', 'نيجيريا'),
(21313, 1407520398, 1407520399, 'GB', 'GBR', 'المملكة المتحدة'),
(21314, 1407520400, 1407520423, 'NG', 'NGA', 'نيجيريا'),
(21315, 1407520424, 1407520439, 'GB', 'GBR', 'المملكة المتحدة'),
(21316, 1407520440, 1407520447, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21317, 1407520448, 1407520463, 'NG', 'NGA', 'نيجيريا'),
(21318, 1407520464, 1407520511, 'GB', 'GBR', 'المملكة المتحدة'),
(21319, 1407520512, 1407520519, 'NG', 'NGA', 'نيجيريا'),
(21320, 1407520520, 1407520527, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21321, 1407520528, 1407520543, 'NG', 'NGA', 'نيجيريا'),
(21322, 1407520544, 1407520551, 'GB', 'GBR', 'المملكة المتحدة'),
(21323, 1407520552, 1407520559, 'NG', 'NGA', 'نيجيريا'),
(21324, 1407520560, 1407520567, 'SL', 'SLE', 'سيراليون'),
(21325, 1407520568, 1407520575, 'NG', 'NGA', 'نيجيريا'),
(21326, 1407520576, 1407520607, 'GB', 'GBR', 'المملكة المتحدة'),
(21327, 1407520608, 1407520615, 'AO', 'AGO', 'أنغولا'),
(21328, 1407520616, 1407520623, 'GB', 'GBR', 'المملكة المتحدة'),
(21329, 1407520624, 1407520631, 'NG', 'NGA', 'نيجيريا'),
(21330, 1407520632, 1407520639, 'GB', 'GBR', 'المملكة المتحدة'),
(21331, 1407520640, 1407520655, 'NG', 'NGA', 'نيجيريا'),
(21332, 1407520656, 1407520663, 'GA', 'GAB', 'الغابون'),
(21333, 1407520664, 1407520671, 'GB', 'GBR', 'المملكة المتحدة'),
(21334, 1407520672, 1407520679, 'CM', 'CMR', 'الكاميرون'),
(21335, 1407520680, 1407520687, 'GB', 'GBR', 'المملكة المتحدة'),
(21336, 1407520688, 1407520695, 'NG', 'NGA', 'نيجيريا'),
(21337, 1407520696, 1407520711, 'GB', 'GBR', 'المملكة المتحدة'),
(21338, 1407520712, 1407520719, 'NG', 'NGA', 'نيجيريا'),
(21339, 1407520720, 1407520727, 'GB', 'GBR', 'المملكة المتحدة'),
(21340, 1407520728, 1407520735, 'AO', 'AGO', 'أنغولا'),
(21341, 1407520736, 1407520759, 'GB', 'GBR', 'المملكة المتحدة'),
(21342, 1407520760, 1407520767, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21343, 1407520768, 1407520775, 'ZW', 'ZWE', 'زمبابواي'),
(21344, 1407520776, 1407520839, 'GB', 'GBR', 'المملكة المتحدة'),
(21345, 1407520840, 1407520847, 'NG', 'NGA', 'نيجيريا'),
(21346, 1407520848, 1407520855, 'ZM', 'ZMB', 'زامبيا'),
(21347, 1407520856, 1407520863, 'GB', 'GBR', 'المملكة المتحدة'),
(21348, 1407520864, 1407520871, 'NG', 'NGA', 'نيجيريا'),
(21349, 1407520872, 1407520895, 'GB', 'GBR', 'المملكة المتحدة'),
(21350, 1407520896, 1407520903, 'AO', 'AGO', 'أنغولا'),
(21351, 1407520904, 1407520911, 'NG', 'NGA', 'نيجيريا'),
(21352, 1407520912, 1407520919, 'ZW', 'ZWE', 'زمبابواي'),
(21353, 1407520920, 1407520927, 'IQ', 'IRQ', 'العراق'),
(21354, 1407520928, 1407520935, 'GB', 'GBR', 'المملكة المتحدة'),
(21355, 1407520936, 1407520943, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21356, 1407520944, 1407520951, 'IQ', 'IRQ', 'العراق'),
(21357, 1407520952, 1407520959, 'ZW', 'ZWE', 'زمبابواي'),
(21358, 1407520960, 1407520967, 'TZ', 'TZA', 'تانزانيا'),
(21359, 1407520968, 1407520975, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21360, 1407520976, 1407520983, 'GB', 'GBR', 'المملكة المتحدة'),
(21361, 1407520984, 1407520991, 'ZM', 'ZMB', 'زامبيا'),
(21362, 1407520992, 1407520999, 'AO', 'AGO', 'أنغولا'),
(21363, 1407521000, 1407521023, 'GB', 'GBR', 'المملكة المتحدة'),
(21364, 1407521024, 1407521031, 'ZW', 'ZWE', 'زمبابواي'),
(21365, 1407521032, 1407521055, 'GB', 'GBR', 'المملكة المتحدة'),
(21366, 1407521056, 1407521063, 'KE', 'KEN', 'كينيا'),
(21367, 1407521064, 1407521127, 'GB', 'GBR', 'المملكة المتحدة'),
(21368, 1407521128, 1407521135, 'NG', 'NGA', 'نيجيريا'),
(21369, 1407521136, 1407521415, 'GB', 'GBR', 'المملكة المتحدة'),
(21370, 1407521416, 1407521423, 'LR', 'LBR', 'ليبيريا'),
(21371, 1407521424, 1407522047, 'GB', 'GBR', 'المملكة المتحدة'),
(21372, 1407522048, 1407522303, 'TZ', 'TZA', 'تانزانيا'),
(21373, 1407522304, 1407522319, 'GB', 'GBR', 'المملكة المتحدة'),
(21374, 1407522320, 1407522327, 'BF', 'BFA', 'بوركينا فاسو'),
(21375, 1407522328, 1407522335, 'NG', 'NGA', 'نيجيريا'),
(21376, 1407522336, 1407522351, 'SO', 'SOM', 'الصومال'),
(21377, 1407522352, 1407522359, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21378, 1407522360, 1407522367, 'NG', 'NGA', 'نيجيريا'),
(21379, 1407522368, 1407522375, 'GB', 'GBR', 'المملكة المتحدة'),
(21380, 1407522376, 1407522383, 'LR', 'LBR', 'ليبيريا'),
(21381, 1407522384, 1407522399, 'GB', 'GBR', 'المملكة المتحدة'),
(21382, 1407522400, 1407522407, 'NG', 'NGA', 'نيجيريا'),
(21383, 1407522408, 1407522415, 'LR', 'LBR', 'ليبيريا'),
(21384, 1407522416, 1407522431, 'NG', 'NGA', 'نيجيريا'),
(21385, 1407522432, 1407522439, 'IQ', 'IRQ', 'العراق'),
(21386, 1407522440, 1407522440, 'NG', 'NGA', 'نيجيريا'),
(21387, 1407522441, 1407522463, 'GB', 'GBR', 'المملكة المتحدة'),
(21388, 1407522464, 1407522479, 'NG', 'NGA', 'نيجيريا'),
(21389, 1407522480, 1407522487, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21390, 1407522488, 1407522495, 'GB', 'GBR', 'المملكة المتحدة'),
(21391, 1407522496, 1407522503, 'NG', 'NGA', 'نيجيريا'),
(21392, 1407522504, 1407522527, 'GB', 'GBR', 'المملكة المتحدة'),
(21393, 1407522528, 1407522559, 'NG', 'NGA', 'نيجيريا'),
(21394, 1407522560, 1407522567, 'GB', 'GBR', 'المملكة المتحدة'),
(21395, 1407522568, 1407522575, 'NG', 'NGA', 'نيجيريا'),
(21396, 1407522576, 1407522583, 'GB', 'GBR', 'المملكة المتحدة'),
(21397, 1407522584, 1407522591, 'NG', 'NGA', 'نيجيريا'),
(21398, 1407522592, 1407522615, 'GB', 'GBR', 'المملكة المتحدة'),
(21399, 1407522616, 1407522623, 'NG', 'NGA', 'نيجيريا'),
(21400, 1407522624, 1407522639, 'GB', 'GBR', 'المملكة المتحدة'),
(21401, 1407522640, 1407522647, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(21402, 1407522648, 1407522655, 'NG', 'NGA', 'نيجيريا'),
(21403, 1407522656, 1407522671, 'GB', 'GBR', 'المملكة المتحدة'),
(21404, 1407522672, 1407522679, 'ZM', 'ZMB', 'زامبيا'),
(21405, 1407522680, 1407522687, 'IQ', 'IRQ', 'العراق'),
(21406, 1407522688, 1407522695, 'LR', 'LBR', 'ليبيريا'),
(21407, 1407522696, 1407522703, 'GB', 'GBR', 'المملكة المتحدة'),
(21408, 1407522704, 1407522711, 'NG', 'NGA', 'نيجيريا'),
(21409, 1407522712, 1407522727, 'GB', 'GBR', 'المملكة المتحدة'),
(21410, 1407522728, 1407522735, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21411, 1407522736, 1407522775, 'GB', 'GBR', 'المملكة المتحدة'),
(21412, 1407522776, 1407522799, 'NG', 'NGA', 'نيجيريا'),
(21413, 1407522800, 1407522807, 'ZM', 'ZMB', 'زامبيا'),
(21414, 1407522808, 1407522815, 'IQ', 'IRQ', 'العراق'),
(21415, 1407522816, 1407523071, 'ZW', 'ZWE', 'زمبابواي'),
(21416, 1407523072, 1407523327, 'TZ', 'TZA', 'تانزانيا'),
(21417, 1407523328, 1407523343, 'MW', 'MWI', 'ملاوي'),
(21418, 1407523344, 1407523351, 'NG', 'NGA', 'نيجيريا'),
(21419, 1407523352, 1407523359, 'LU', 'LUX', 'لوكسيمبورغ'),
(21420, 1407523360, 1407523367, 'ZW', 'ZWE', 'زمبابواي'),
(21421, 1407523368, 1407523375, 'NG', 'NGA', 'نيجيريا'),
(21422, 1407523376, 1407523391, 'GB', 'GBR', 'المملكة المتحدة'),
(21423, 1407523392, 1407523455, 'ZW', 'ZWE', 'زمبابواي'),
(21424, 1407523456, 1407523519, 'MW', 'MWI', 'ملاوي'),
(21425, 1407523520, 1407523535, 'GB', 'GBR', 'المملكة المتحدة'),
(21426, 1407523536, 1407523551, 'NG', 'NGA', 'نيجيريا'),
(21427, 1407523552, 1407523559, 'CM', 'CMR', 'الكاميرون'),
(21428, 1407523560, 1407523567, 'KE', 'KEN', 'كينيا'),
(21429, 1407523568, 1407523575, 'GB', 'GBR', 'المملكة المتحدة'),
(21430, 1407523576, 1407523583, 'MW', 'MWI', 'ملاوي'),
(21431, 1407523584, 1407523839, 'SO', 'SOM', 'الصومال'),
(21432, 1407523840, 1407524351, 'MW', 'MWI', 'ملاوي'),
(21433, 1407524352, 1407524615, 'GB', 'GBR', 'المملكة المتحدة'),
(21434, 1407524616, 1407524623, 'CM', 'CMR', 'الكاميرون'),
(21435, 1407524624, 1407524631, 'NG', 'NGA', 'نيجيريا'),
(21436, 1407524632, 1407526911, 'GB', 'GBR', 'المملكة المتحدة'),
(21437, 1407526912, 1407527935, 'MZ', 'MOZ', 'موزامبيق'),
(21438, 1407527936, 1407529023, 'GB', 'GBR', 'المملكة المتحدة'),
(21439, 1407529024, 1407529087, 'NG', 'NGA', 'نيجيريا'),
(21440, 1407529088, 1407529095, 'TZ', 'TZA', 'تانزانيا'),
(21441, 1407529096, 1407529103, 'ZW', 'ZWE', 'زمبابواي'),
(21442, 1407529104, 1407529111, 'NG', 'NGA', 'نيجيريا'),
(21443, 1407529112, 1407529127, 'GB', 'GBR', 'المملكة المتحدة'),
(21444, 1407529128, 1407529135, 'ZW', 'ZWE', 'زمبابواي'),
(21445, 1407529136, 1407529143, 'MW', 'MWI', 'ملاوي'),
(21446, 1407529144, 1407529151, 'ZW', 'ZWE', 'زمبابواي'),
(21447, 1407529152, 1407529183, 'GB', 'GBR', 'المملكة المتحدة'),
(21448, 1407529184, 1407529191, 'NG', 'NGA', 'نيجيريا'),
(21449, 1407529192, 1407529199, 'MZ', 'MOZ', 'موزامبيق'),
(21450, 1407529200, 1407529207, 'GB', 'GBR', 'المملكة المتحدة'),
(21451, 1407529208, 1407529215, 'NG', 'NGA', 'نيجيريا'),
(21452, 1407529216, 1407531007, 'GB', 'GBR', 'المملكة المتحدة'),
(21453, 1407531008, 1407531775, 'NG', 'NGA', 'نيجيريا'),
(21454, 1407531776, 1407532543, 'GB', 'GBR', 'المملكة المتحدة'),
(21455, 1407532544, 1407532551, 'UG', 'UGA', 'أوغاندا'),
(21456, 1407532552, 1407532559, 'AO', 'AGO', 'أنغولا'),
(21457, 1407532560, 1407532583, 'GB', 'GBR', 'المملكة المتحدة'),
(21458, 1407532584, 1407532591, 'ZW', 'ZWE', 'زمبابواي'),
(21459, 1407532592, 1407532607, 'GB', 'GBR', 'المملكة المتحدة'),
(21460, 1407532608, 1407532615, 'ZW', 'ZWE', 'زمبابواي'),
(21461, 1407532616, 1407532623, 'KG', 'KGZ', 'قيرغيزستان'),
(21462, 1407532624, 1407532631, 'GB', 'GBR', 'المملكة المتحدة'),
(21463, 1407532632, 1407532639, 'MW', 'MWI', 'ملاوي'),
(21464, 1407532640, 1407532647, 'TZ', 'TZA', 'تانزانيا'),
(21465, 1407532648, 1407532663, 'GB', 'GBR', 'المملكة المتحدة'),
(21466, 1407532664, 1407532671, 'TZ', 'TZA', 'تانزانيا'),
(21467, 1407532672, 1407532799, 'ZW', 'ZWE', 'زمبابواي'),
(21468, 1407532800, 1407532927, 'SO', 'SOM', 'الصومال'),
(21469, 1407532928, 1407533055, 'GB', 'GBR', 'المملكة المتحدة'),
(21470, 1407533056, 1407533311, 'NG', 'NGA', 'نيجيريا'),
(21471, 1407533312, 1407533327, 'AO', 'AGO', 'أنغولا'),
(21472, 1407533328, 1407533343, 'GB', 'GBR', 'المملكة المتحدة'),
(21473, 1407533344, 1407533359, 'NG', 'NGA', 'نيجيريا'),
(21474, 1407533360, 1407533375, 'GB', 'GBR', 'المملكة المتحدة'),
(21475, 1407533376, 1407533407, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21476, 1407533408, 1407533423, 'GB', 'GBR', 'المملكة المتحدة'),
(21477, 1407533424, 1407533567, 'GH', 'GHA', 'غانا'),
(21478, 1407533568, 1407533591, 'NG', 'NGA', 'نيجيريا'),
(21479, 1407533592, 1407533607, 'GB', 'GBR', 'المملكة المتحدة'),
(21480, 1407533608, 1407533631, 'NG', 'NGA', 'نيجيريا'),
(21481, 1407533632, 1407533663, 'IQ', 'IRQ', 'العراق'),
(21482, 1407533664, 1407533679, 'GB', 'GBR', 'المملكة المتحدة'),
(21483, 1407533680, 1407533695, 'NG', 'NGA', 'نيجيريا'),
(21484, 1407533696, 1407533711, 'GB', 'GBR', 'المملكة المتحدة'),
(21485, 1407533712, 1407533719, 'ZW', 'ZWE', 'زمبابواي'),
(21486, 1407533720, 1407533727, 'SL', 'SLE', 'سيراليون'),
(21487, 1407533728, 1407533735, 'GB', 'GBR', 'المملكة المتحدة'),
(21488, 1407533736, 1407533743, 'GN', 'GIN', 'غينيا'),
(21489, 1407533744, 1407533751, 'NG', 'NGA', 'نيجيريا'),
(21490, 1407533752, 1407533759, 'GB', 'GBR', 'المملكة المتحدة'),
(21491, 1407533760, 1407533783, 'NG', 'NGA', 'نيجيريا'),
(21492, 1407533784, 1407533815, 'GB', 'GBR', 'المملكة المتحدة'),
(21493, 1407533816, 1407533823, 'NG', 'NGA', 'نيجيريا'),
(21494, 1407533824, 1407534079, 'GB', 'GBR', 'المملكة المتحدة'),
(21495, 1407534080, 1407534335, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21496, 1407534336, 1407534359, 'GB', 'GBR', 'المملكة المتحدة'),
(21497, 1407534360, 1407534383, 'NG', 'NGA', 'نيجيريا'),
(21498, 1407534384, 1407534391, 'GB', 'GBR', 'المملكة المتحدة'),
(21499, 1407534392, 1407534399, 'AO', 'AGO', 'أنغولا'),
(21500, 1407534400, 1407534407, 'NG', 'NGA', 'نيجيريا'),
(21501, 1407534408, 1407534415, 'CI', 'CIV', 'كوت ديفوار'),
(21502, 1407534416, 1407534447, 'GB', 'GBR', 'المملكة المتحدة'),
(21503, 1407534448, 1407534463, 'NG', 'NGA', 'نيجيريا'),
(21504, 1407534464, 1407534543, 'GB', 'GBR', 'المملكة المتحدة'),
(21505, 1407534544, 1407534559, 'GH', 'GHA', 'غانا'),
(21506, 1407534560, 1407534567, 'NG', 'NGA', 'نيجيريا'),
(21507, 1407534568, 1407534575, 'GB', 'GBR', 'المملكة المتحدة'),
(21508, 1407534576, 1407534583, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21509, 1407534584, 1407534591, 'GB', 'GBR', 'المملكة المتحدة'),
(21510, 1407534592, 1407534727, 'NG', 'NGA', 'نيجيريا'),
(21511, 1407534728, 1407534735, 'GB', 'GBR', 'المملكة المتحدة'),
(21512, 1407534736, 1407534775, 'NG', 'NGA', 'نيجيريا'),
(21513, 1407534776, 1407534783, 'ML', 'MLI', 'مالي'),
(21514, 1407534784, 1407534791, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21515, 1407534792, 1407534847, 'GB', 'GBR', 'المملكة المتحدة'),
(21516, 1407534848, 1407535103, 'CM', 'CMR', 'الكاميرون'),
(21517, 1407535104, 1407535615, 'GA', 'GAB', 'الغابون'),
(21518, 1407535616, 1407536127, 'GB', 'GBR', 'المملكة المتحدة'),
(21519, 1407536128, 1407536639, 'GA', 'GAB', 'الغابون'),
(21520, 1407536640, 1407536895, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21521, 1407536896, 1407536903, 'GB', 'GBR', 'المملكة المتحدة'),
(21522, 1407536904, 1407536919, 'ZW', 'ZWE', 'زمبابواي'),
(21523, 1407536920, 1407536935, 'GB', 'GBR', 'المملكة المتحدة'),
(21524, 1407536936, 1407536943, 'NG', 'NGA', 'نيجيريا'),
(21525, 1407536944, 1407536951, 'AO', 'AGO', 'أنغولا'),
(21526, 1407536952, 1407536983, 'GB', 'GBR', 'المملكة المتحدة'),
(21527, 1407536984, 1407536991, 'IQ', 'IRQ', 'العراق'),
(21528, 1407536992, 1407537031, 'GB', 'GBR', 'المملكة المتحدة'),
(21529, 1407537032, 1407537039, 'NG', 'NGA', 'نيجيريا'),
(21530, 1407537040, 1407537047, 'GB', 'GBR', 'المملكة المتحدة'),
(21531, 1407537048, 1407537055, 'NG', 'NGA', 'نيجيريا'),
(21532, 1407537056, 1407537071, 'GH', 'GHA', 'غانا'),
(21533, 1407537072, 1407537087, 'NG', 'NGA', 'نيجيريا'),
(21534, 1407537088, 1407537095, 'GH', 'GHA', 'غانا'),
(21535, 1407537096, 1407537103, 'GB', 'GBR', 'المملكة المتحدة'),
(21536, 1407537104, 1407537111, 'NG', 'NGA', 'نيجيريا'),
(21537, 1407537112, 1407537119, 'LR', 'LBR', 'ليبيريا'),
(21538, 1407537120, 1407537135, 'GB', 'GBR', 'المملكة المتحدة'),
(21539, 1407537136, 1407537143, 'NG', 'NGA', 'نيجيريا'),
(21540, 1407537144, 1407537167, 'GB', 'GBR', 'المملكة المتحدة'),
(21541, 1407537168, 1407537175, 'ZM', 'ZMB', 'زامبيا'),
(21542, 1407537176, 1407537191, 'NG', 'NGA', 'نيجيريا'),
(21543, 1407537192, 1407537199, 'GB', 'GBR', 'المملكة المتحدة'),
(21544, 1407537200, 1407537207, 'NG', 'NGA', 'نيجيريا'),
(21545, 1407537208, 1407537215, 'GB', 'GBR', 'المملكة المتحدة'),
(21546, 1407537216, 1407537255, 'NG', 'NGA', 'نيجيريا'),
(21547, 1407537256, 1407537263, 'GB', 'GBR', 'المملكة المتحدة'),
(21548, 1407537264, 1407537279, 'NG', 'NGA', 'نيجيريا'),
(21549, 1407537280, 1407537287, 'LR', 'LBR', 'ليبيريا'),
(21550, 1407537288, 1407537311, 'NG', 'NGA', 'نيجيريا'),
(21551, 1407537312, 1407537327, 'GB', 'GBR', 'المملكة المتحدة'),
(21552, 1407537328, 1407537351, 'NG', 'NGA', 'نيجيريا'),
(21553, 1407537352, 1407537359, 'GB', 'GBR', 'المملكة المتحدة'),
(21554, 1407537360, 1407537367, 'LR', 'LBR', 'ليبيريا'),
(21555, 1407537368, 1407537391, 'NG', 'NGA', 'نيجيريا'),
(21556, 1407537392, 1407537399, 'LR', 'LBR', 'ليبيريا'),
(21557, 1407537400, 1407537407, 'GB', 'GBR', 'المملكة المتحدة'),
(21558, 1407537408, 1407537415, 'NG', 'NGA', 'نيجيريا'),
(21559, 1407537416, 1407537423, 'GB', 'GBR', 'المملكة المتحدة'),
(21560, 1407537424, 1407537455, 'NG', 'NGA', 'نيجيريا'),
(21561, 1407537456, 1407537479, 'GB', 'GBR', 'المملكة المتحدة'),
(21562, 1407537480, 1407537487, 'CM', 'CMR', 'الكاميرون'),
(21563, 1407537488, 1407537495, 'GH', 'GHA', 'غانا'),
(21564, 1407537496, 1407537511, 'NG', 'NGA', 'نيجيريا'),
(21565, 1407537512, 1407537519, 'LR', 'LBR', 'ليبيريا'),
(21566, 1407537520, 1407537527, 'GB', 'GBR', 'المملكة المتحدة'),
(21567, 1407537528, 1407537535, 'NG', 'NGA', 'نيجيريا'),
(21568, 1407537536, 1407537543, 'LR', 'LBR', 'ليبيريا'),
(21569, 1407537544, 1407537559, 'GB', 'GBR', 'المملكة المتحدة'),
(21570, 1407537560, 1407537567, 'NG', 'NGA', 'نيجيريا'),
(21571, 1407537568, 1407537575, 'GB', 'GBR', 'المملكة المتحدة'),
(21572, 1407537576, 1407537639, 'NG', 'NGA', 'نيجيريا'),
(21573, 1407537640, 1407537647, 'GB', 'GBR', 'المملكة المتحدة'),
(21574, 1407537648, 1407537663, 'NG', 'NGA', 'نيجيريا'),
(21575, 1407537664, 1407537671, 'AO', 'AGO', 'أنغولا'),
(21576, 1407537672, 1407537679, 'NG', 'NGA', 'نيجيريا'),
(21577, 1407537680, 1407537687, 'IQ', 'IRQ', 'العراق'),
(21578, 1407537688, 1407537703, 'GB', 'GBR', 'المملكة المتحدة'),
(21579, 1407537704, 1407537735, 'NG', 'NGA', 'نيجيريا'),
(21580, 1407537736, 1407537743, 'GB', 'GBR', 'المملكة المتحدة'),
(21581, 1407537744, 1407537751, 'IQ', 'IRQ', 'العراق'),
(21582, 1407537752, 1407537847, 'NG', 'NGA', 'نيجيريا'),
(21583, 1407537848, 1407537855, 'GB', 'GBR', 'المملكة المتحدة'),
(21584, 1407537856, 1407537863, 'NG', 'NGA', 'نيجيريا'),
(21585, 1407537864, 1407537871, 'GB', 'GBR', 'المملكة المتحدة'),
(21586, 1407537872, 1407537879, 'IQ', 'IRQ', 'العراق'),
(21587, 1407537880, 1407537887, 'GB', 'GBR', 'المملكة المتحدة'),
(21588, 1407537888, 1407537895, 'NG', 'NGA', 'نيجيريا'),
(21589, 1407537896, 1407537903, 'IQ', 'IRQ', 'العراق'),
(21590, 1407537904, 1407537911, 'GB', 'GBR', 'المملكة المتحدة'),
(21591, 1407537912, 1407537927, 'NG', 'NGA', 'نيجيريا'),
(21592, 1407537928, 1407537935, 'GB', 'GBR', 'المملكة المتحدة'),
(21593, 1407537936, 1407537943, 'GH', 'GHA', 'غانا'),
(21594, 1407537944, 1407537959, 'NG', 'NGA', 'نيجيريا'),
(21595, 1407537960, 1407537967, 'GB', 'GBR', 'المملكة المتحدة'),
(21596, 1407537968, 1407537991, 'NG', 'NGA', 'نيجيريا'),
(21597, 1407537992, 1407537999, 'IQ', 'IRQ', 'العراق'),
(21598, 1407538000, 1407538023, 'NG', 'NGA', 'نيجيريا'),
(21599, 1407538024, 1407538039, 'GB', 'GBR', 'المملكة المتحدة'),
(21600, 1407538040, 1407538047, 'IQ', 'IRQ', 'العراق'),
(21601, 1407538048, 1407538055, 'NG', 'NGA', 'نيجيريا'),
(21602, 1407538056, 1407538071, 'LU', 'LUX', 'لوكسيمبورغ'),
(21603, 1407538072, 1407538079, 'NG', 'NGA', 'نيجيريا'),
(21604, 1407538080, 1407538087, 'GB', 'GBR', 'المملكة المتحدة'),
(21605, 1407538088, 1407538095, 'AO', 'AGO', 'أنغولا'),
(21606, 1407538096, 1407538111, 'GB', 'GBR', 'المملكة المتحدة'),
(21607, 1407538112, 1407538119, 'LR', 'LBR', 'ليبيريا'),
(21608, 1407538120, 1407538135, 'NG', 'NGA', 'نيجيريا'),
(21609, 1407538136, 1407538143, 'GB', 'GBR', 'المملكة المتحدة'),
(21610, 1407538144, 1407538151, 'GN', 'GIN', 'غينيا'),
(21611, 1407538152, 1407538167, 'GB', 'GBR', 'المملكة المتحدة'),
(21612, 1407538168, 1407538175, 'IQ', 'IRQ', 'العراق'),
(21613, 1407538176, 1407538431, 'AT', 'AUT', 'النمسا'),
(21614, 1407538432, 1407538439, 'GB', 'GBR', 'المملكة المتحدة'),
(21615, 1407538440, 1407538447, 'NG', 'NGA', 'نيجيريا'),
(21616, 1407538448, 1407538463, 'GB', 'GBR', 'المملكة المتحدة'),
(21617, 1407538464, 1407538471, 'ZM', 'ZMB', 'زامبيا'),
(21618, 1407538472, 1407538479, 'NG', 'NGA', 'نيجيريا'),
(21619, 1407538480, 1407538495, 'GB', 'GBR', 'المملكة المتحدة'),
(21620, 1407538496, 1407538503, 'NG', 'NGA', 'نيجيريا'),
(21621, 1407538504, 1407538559, 'GB', 'GBR', 'المملكة المتحدة'),
(21622, 1407538560, 1407538623, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21623, 1407538624, 1407538663, 'GB', 'GBR', 'المملكة المتحدة'),
(21624, 1407538664, 1407538687, 'NG', 'NGA', 'نيجيريا'),
(21625, 1407538688, 1407538751, 'GB', 'GBR', 'المملكة المتحدة'),
(21626, 1407538752, 1407538783, 'NG', 'NGA', 'نيجيريا'),
(21627, 1407538784, 1407538847, 'GB', 'GBR', 'المملكة المتحدة'),
(21628, 1407538848, 1407538863, 'NG', 'NGA', 'نيجيريا'),
(21629, 1407538864, 1407538879, 'GE', 'GEO', 'جورجيا'),
(21630, 1407538880, 1407538887, 'GB', 'GBR', 'المملكة المتحدة'),
(21631, 1407538888, 1407538895, 'NG', 'NGA', 'نيجيريا'),
(21632, 1407538896, 1407538911, 'GB', 'GBR', 'المملكة المتحدة'),
(21633, 1407538912, 1407538919, 'GH', 'GHA', 'غانا'),
(21634, 1407538920, 1407538927, 'GB', 'GBR', 'المملكة المتحدة'),
(21635, 1407538928, 1407538935, 'NG', 'NGA', 'نيجيريا'),
(21636, 1407538936, 1407538943, 'GH', 'GHA', 'غانا'),
(21637, 1407538944, 1407538967, 'GB', 'GBR', 'المملكة المتحدة'),
(21638, 1407538968, 1407538975, 'CM', 'CMR', 'الكاميرون'),
(21639, 1407538976, 1407538983, 'NG', 'NGA', 'نيجيريا'),
(21640, 1407538984, 1407538991, 'SL', 'SLE', 'سيراليون'),
(21641, 1407538992, 1407538999, 'GB', 'GBR', 'المملكة المتحدة'),
(21642, 1407539000, 1407539007, 'NG', 'NGA', 'نيجيريا'),
(21643, 1407539008, 1407539055, 'GB', 'GBR', 'المملكة المتحدة'),
(21644, 1407539056, 1407539063, 'NG', 'NGA', 'نيجيريا'),
(21645, 1407539064, 1407539071, 'GB', 'GBR', 'المملكة المتحدة'),
(21646, 1407539072, 1407539079, 'NG', 'NGA', 'نيجيريا'),
(21647, 1407539080, 1407539087, 'GB', 'GBR', 'المملكة المتحدة'),
(21648, 1407539088, 1407539095, 'AO', 'AGO', 'أنغولا'),
(21649, 1407539096, 1407539103, 'GB', 'GBR', 'المملكة المتحدة'),
(21650, 1407539104, 1407539111, 'NG', 'NGA', 'نيجيريا'),
(21651, 1407539112, 1407539143, 'GB', 'GBR', 'المملكة المتحدة'),
(21652, 1407539144, 1407539151, 'NG', 'NGA', 'نيجيريا'),
(21653, 1407539152, 1407539167, 'GB', 'GBR', 'المملكة المتحدة'),
(21654, 1407539168, 1407539175, 'TD', 'TCD', 'تشاد'),
(21655, 1407539176, 1407539183, 'GH', 'GHA', 'غانا'),
(21656, 1407539184, 1407539199, 'NG', 'NGA', 'نيجيريا'),
(21657, 1407539200, 1407539455, 'GE', 'GEO', 'جورجيا'),
(21658, 1407539456, 1407539967, 'NG', 'NGA', 'نيجيريا'),
(21659, 1407539968, 1407541471, 'GB', 'GBR', 'المملكة المتحدة'),
(21660, 1407541472, 1407541495, 'NG', 'NGA', 'نيجيريا'),
(21661, 1407541496, 1407541535, 'GB', 'GBR', 'المملكة المتحدة'),
(21662, 1407541536, 1407541543, 'CM', 'CMR', 'الكاميرون'),
(21663, 1407541544, 1407541551, 'GB', 'GBR', 'المملكة المتحدة'),
(21664, 1407541552, 1407541559, 'NG', 'NGA', 'نيجيريا'),
(21665, 1407541560, 1407541567, 'GH', 'GHA', 'غانا'),
(21666, 1407541568, 1407541703, 'GB', 'GBR', 'المملكة المتحدة'),
(21667, 1407541704, 1407541719, 'NG', 'NGA', 'نيجيريا'),
(21668, 1407541720, 1407541727, 'GB', 'GBR', 'المملكة المتحدة'),
(21669, 1407541728, 1407541735, 'NG', 'NGA', 'نيجيريا'),
(21670, 1407541736, 1407541751, 'GB', 'GBR', 'المملكة المتحدة'),
(21671, 1407541752, 1407541759, 'NG', 'NGA', 'نيجيريا'),
(21672, 1407541760, 1407541887, 'GB', 'GBR', 'المملكة المتحدة'),
(21673, 1407541888, 1407542143, 'NG', 'NGA', 'نيجيريا'),
(21674, 1407542144, 1407542543, 'GB', 'GBR', 'المملكة المتحدة'),
(21675, 1407542544, 1407542551, 'LR', 'LBR', 'ليبيريا'),
(21676, 1407542552, 1407542575, 'GB', 'GBR', 'المملكة المتحدة'),
(21677, 1407542576, 1407542583, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21678, 1407542584, 1407542591, 'GB', 'GBR', 'المملكة المتحدة'),
(21679, 1407542592, 1407542599, 'NG', 'NGA', 'نيجيريا'),
(21680, 1407542600, 1407542607, 'TG', 'TGO', 'توغو'),
(21681, 1407542608, 1407542623, 'GB', 'GBR', 'المملكة المتحدة'),
(21682, 1407542624, 1407542631, 'BJ', 'BEN', 'بنين'),
(21683, 1407542632, 1407542639, 'NG', 'NGA', 'نيجيريا'),
(21684, 1407542640, 1407542655, 'GB', 'GBR', 'المملكة المتحدة'),
(21685, 1407542656, 1407542663, 'SL', 'SLE', 'سيراليون'),
(21686, 1407542664, 1407542671, 'GB', 'GBR', 'المملكة المتحدة'),
(21687, 1407542672, 1407542679, 'CM', 'CMR', 'الكاميرون'),
(21688, 1407542680, 1407542687, 'NG', 'NGA', 'نيجيريا'),
(21689, 1407542688, 1407542695, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21690, 1407542696, 1407542703, 'NG', 'NGA', 'نيجيريا'),
(21691, 1407542704, 1407542719, 'GB', 'GBR', 'المملكة المتحدة'),
(21692, 1407542720, 1407542735, 'NG', 'NGA', 'نيجيريا'),
(21693, 1407542736, 1407542767, 'GB', 'GBR', 'المملكة المتحدة'),
(21694, 1407542768, 1407542775, 'GA', 'GAB', 'الغابون'),
(21695, 1407542776, 1407542783, 'NG', 'NGA', 'نيجيريا'),
(21696, 1407542784, 1407542791, 'GB', 'GBR', 'المملكة المتحدة'),
(21697, 1407542792, 1407542799, 'NG', 'NGA', 'نيجيريا'),
(21698, 1407542800, 1407542831, 'GB', 'GBR', 'المملكة المتحدة'),
(21699, 1407542832, 1407542863, 'NG', 'NGA', 'نيجيريا'),
(21700, 1407542864, 1407542903, 'GB', 'GBR', 'المملكة المتحدة'),
(21701, 1407542904, 1407542911, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(21702, 1407542912, 1407543039, 'AT', 'AUT', 'النمسا'),
(21703, 1407543040, 1407543167, 'GB', 'GBR', 'المملكة المتحدة'),
(21704, 1407543168, 1407543183, 'GH', 'GHA', 'غانا'),
(21705, 1407543184, 1407543239, 'NG', 'NGA', 'نيجيريا'),
(21706, 1407543240, 1407543255, 'GB', 'GBR', 'المملكة المتحدة'),
(21707, 1407543256, 1407543263, 'NG', 'NGA', 'نيجيريا'),
(21708, 1407543264, 1407543279, 'GB', 'GBR', 'المملكة المتحدة'),
(21709, 1407543280, 1407543287, 'NG', 'NGA', 'نيجيريا'),
(21710, 1407543288, 1407545343, 'GB', 'GBR', 'المملكة المتحدة'),
(21711, 1407545344, 1407546367, 'SL', 'SLE', 'سيراليون'),
(21712, 1407546368, 1407546495, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21713, 1407546496, 1407546879, 'GB', 'GBR', 'المملكة المتحدة'),
(21714, 1407546880, 1407547135, 'ZW', 'ZWE', 'زمبابواي'),
(21715, 1407547136, 1407547143, 'GB', 'GBR', 'المملكة المتحدة'),
(21716, 1407547144, 1407547151, 'GH', 'GHA', 'غانا'),
(21717, 1407547152, 1407547167, 'GB', 'GBR', 'المملكة المتحدة'),
(21718, 1407547168, 1407547175, 'NG', 'NGA', 'نيجيريا'),
(21719, 1407547176, 1407547183, 'GH', 'GHA', 'غانا'),
(21720, 1407547184, 1407547199, 'NG', 'NGA', 'نيجيريا'),
(21721, 1407547200, 1407547207, 'AO', 'AGO', 'أنغولا'),
(21722, 1407547208, 1407547215, 'TD', 'TCD', 'تشاد'),
(21723, 1407547216, 1407547223, 'SL', 'SLE', 'سيراليون'),
(21724, 1407547224, 1407547231, 'GB', 'GBR', 'المملكة المتحدة'),
(21725, 1407547232, 1407547255, 'SL', 'SLE', 'سيراليون'),
(21726, 1407547256, 1407547263, 'GB', 'GBR', 'المملكة المتحدة'),
(21727, 1407547264, 1407547271, 'SL', 'SLE', 'سيراليون'),
(21728, 1407547272, 1407547295, 'NG', 'NGA', 'نيجيريا'),
(21729, 1407547296, 1407547303, 'GB', 'GBR', 'المملكة المتحدة'),
(21730, 1407547304, 1407547311, 'SL', 'SLE', 'سيراليون'),
(21731, 1407547312, 1407547327, 'NG', 'NGA', 'نيجيريا'),
(21732, 1407547328, 1407547335, 'GB', 'GBR', 'المملكة المتحدة'),
(21733, 1407547336, 1407547343, 'CI', 'CIV', 'كوت ديفوار'),
(21734, 1407547344, 1407547911, 'NG', 'NGA', 'نيجيريا'),
(21735, 1407547912, 1407547919, 'GB', 'GBR', 'المملكة المتحدة'),
(21736, 1407547920, 1407547927, 'CG', 'COG', 'الكونغو'),
(21737, 1407547928, 1407547943, 'GB', 'GBR', 'المملكة المتحدة'),
(21738, 1407547944, 1407547951, 'BJ', 'BEN', 'بنين'),
(21739, 1407547952, 1407547983, 'GB', 'GBR', 'المملكة المتحدة'),
(21740, 1407547984, 1407547999, 'BJ', 'BEN', 'بنين'),
(21741, 1407548000, 1407548023, 'GB', 'GBR', 'المملكة المتحدة'),
(21742, 1407548024, 1407548031, 'NG', 'NGA', 'نيجيريا'),
(21743, 1407548032, 1407548047, 'GB', 'GBR', 'المملكة المتحدة'),
(21744, 1407548048, 1407548055, 'GA', 'GAB', 'الغابون'),
(21745, 1407548056, 1407548063, 'NG', 'NGA', 'نيجيريا'),
(21746, 1407548064, 1407548111, 'GB', 'GBR', 'المملكة المتحدة'),
(21747, 1407548112, 1407548119, 'CI', 'CIV', 'كوت ديفوار'),
(21748, 1407548120, 1407548127, 'GB', 'GBR', 'المملكة المتحدة'),
(21749, 1407548128, 1407548143, 'CM', 'CMR', 'الكاميرون'),
(21750, 1407548144, 1407548151, 'GB', 'GBR', 'المملكة المتحدة'),
(21751, 1407548152, 1407548415, 'NG', 'NGA', 'نيجيريا'),
(21752, 1407548416, 1407548543, 'GE', 'GEO', 'جورجيا'),
(21753, 1407548544, 1407549183, 'GB', 'GBR', 'المملكة المتحدة'),
(21754, 1407549184, 1407549439, 'GE', 'GEO', 'جورجيا'),
(21755, 1407549440, 1407582207, 'RU', 'RUS', 'الإتحاد الروسي'),
(21756, 1407582208, 1407614975, 'PL', 'POL', 'بولندا'),
(21757, 1407614976, 1407680511, 'ES', 'ESP', 'إسبانيا'),
(21758, 1407680512, 1407681535, 'GB', 'GBR', 'المملكة المتحدة'),
(21759, 1407681536, 1407681639, 'FR', 'FRA', 'فرنسا'),
(21760, 1407681640, 1407681983, 'GB', 'GBR', 'المملكة المتحدة'),
(21761, 1407681984, 1407681999, 'ES', 'ESP', 'إسبانيا'),
(21762, 1407682000, 1407682303, 'GB', 'GBR', 'المملكة المتحدة'),
(21763, 1407682304, 1407682559, 'FR', 'FRA', 'فرنسا'),
(21764, 1407682560, 1407682879, 'GB', 'GBR', 'المملكة المتحدة'),
(21765, 1407682880, 1407682911, 'FI', 'FIN', 'فنلندا'),
(21766, 1407682912, 1407687423, 'GB', 'GBR', 'المملكة المتحدة'),
(21767, 1407687424, 1407687679, 'ES', 'ESP', 'إسبانيا'),
(21768, 1407687680, 1407695215, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(21769, 1407695216, 1407695223, 'ES', 'ESP', 'إسبانيا'),
(21770, 1407695224, 1407700271, 'GB', 'GBR', 'المملكة المتحدة'),
(21771, 1407700272, 1407700287, 'DE', 'DEU', 'ألمانيا'),
(21772, 1407700288, 1407702015, 'GB', 'GBR', 'المملكة المتحدة'),
(21773, 1407702016, 1407702271, 'FR', 'FRA', 'فرنسا'),
(21774, 1407702272, 1407702783, 'GB', 'GBR', 'المملكة المتحدة'),
(21775, 1407702784, 1407702911, 'FR', 'FRA', 'فرنسا'),
(21776, 1407702912, 1407703039, 'GB', 'GBR', 'المملكة المتحدة'),
(21777, 1407703040, 1407703407, 'FR', 'FRA', 'فرنسا'),
(21778, 1407703408, 1407703415, 'GB', 'GBR', 'المملكة المتحدة'),
(21779, 1407703416, 1407703455, 'FR', 'FRA', 'فرنسا'),
(21780, 1407703456, 1407703535, 'GB', 'GBR', 'المملكة المتحدة'),
(21781, 1407703536, 1407703871, 'FR', 'FRA', 'فرنسا'),
(21782, 1407703872, 1407703935, 'GB', 'GBR', 'المملكة المتحدة'),
(21783, 1407703936, 1407704039, 'FR', 'FRA', 'فرنسا'),
(21784, 1407704040, 1407704063, 'GB', 'GBR', 'المملكة المتحدة'),
(21785, 1407704064, 1407704127, 'FR', 'FRA', 'فرنسا'),
(21786, 1407704128, 1407704191, 'GB', 'GBR', 'المملكة المتحدة'),
(21787, 1407704192, 1407704319, 'FR', 'FRA', 'فرنسا'),
(21788, 1407704320, 1407705207, 'GB', 'GBR', 'المملكة المتحدة'),
(21789, 1407705208, 1407705215, 'ES', 'ESP', 'إسبانيا'),
(21790, 1407705216, 1407705247, 'GB', 'GBR', 'المملكة المتحدة'),
(21791, 1407705248, 1407705295, 'ES', 'ESP', 'إسبانيا'),
(21792, 1407705296, 1407705599, 'GB', 'GBR', 'المملكة المتحدة'),
(21793, 1407705600, 1407705727, 'FR', 'FRA', 'فرنسا'),
(21794, 1407705728, 1407705759, 'GB', 'GBR', 'المملكة المتحدة'),
(21795, 1407705760, 1407705791, 'FR', 'FRA', 'فرنسا'),
(21796, 1407705792, 1407706367, 'GB', 'GBR', 'المملكة المتحدة'),
(21797, 1407706368, 1407706415, 'FR', 'FRA', 'فرنسا'),
(21798, 1407706416, 1407707703, 'GB', 'GBR', 'المملكة المتحدة'),
(21799, 1407707704, 1407707831, 'CH', 'CHE', 'سويسرا'),
(21800, 1407707832, 1407707903, 'GB', 'GBR', 'المملكة المتحدة'),
(21801, 1407707904, 1407707935, 'CH', 'CHE', 'سويسرا'),
(21802, 1407707936, 1407709183, 'GB', 'GBR', 'المملكة المتحدة'),
(21803, 1407709184, 1407709455, 'DE', 'DEU', 'ألمانيا'),
(21804, 1407709456, 1407709471, 'GB', 'GBR', 'المملكة المتحدة'),
(21805, 1407709472, 1407709503, 'DE', 'DEU', 'ألمانيا'),
(21806, 1407709504, 1407710207, 'GB', 'GBR', 'المملكة المتحدة'),
(21807, 1407710208, 1407710239, 'ES', 'ESP', 'إسبانيا'),
(21808, 1407710240, 1407710975, 'GB', 'GBR', 'المملكة المتحدة'),
(21809, 1407710976, 1407711319, 'FR', 'FRA', 'فرنسا'),
(21810, 1407711320, 1407711327, 'GB', 'GBR', 'المملكة المتحدة'),
(21811, 1407711328, 1407711543, 'FR', 'FRA', 'فرنسا'),
(21812, 1407711544, 1407711551, 'GB', 'GBR', 'المملكة المتحدة'),
(21813, 1407711552, 1407711583, 'FR', 'FRA', 'فرنسا'),
(21814, 1407711584, 1407712207, 'GB', 'GBR', 'المملكة المتحدة'),
(21815, 1407712208, 1407712223, 'FR', 'FRA', 'فرنسا'),
(21816, 1407712224, 1407712767, 'GB', 'GBR', 'المملكة المتحدة'),
(21817, 1407712768, 1407712831, 'DE', 'DEU', 'ألمانيا'),
(21818, 1407712832, 1407712887, 'GB', 'GBR', 'المملكة المتحدة'),
(21819, 1407712888, 1407713103, 'DE', 'DEU', 'ألمانيا'),
(21820, 1407713104, 1407713279, 'GB', 'GBR', 'المملكة المتحدة'),
(21821, 1407713280, 1407778815, 'NL', 'NLD', 'هولندا'),
(21822, 1407778816, 1407842303, 'SE', 'SWE', 'السويد'),
(21823, 1407842304, 1407842367, 'NO', 'NOR', 'النرويج'),
(21824, 1407842368, 1407844351, 'SE', 'SWE', 'السويد'),
(21825, 1407844352, 1407909887, 'RU', 'RUS', 'الإتحاد الروسي'),
(21826, 1407909888, 1407975423, 'GR', 'GRC', 'اليونان'),
(21827, 1407975424, 1408040959, 'DE', 'DEU', 'ألمانيا'),
(21828, 1408040960, 1408106495, 'RU', 'RUS', 'الإتحاد الروسي'),
(21829, 1408106496, 1408172031, 'PL', 'POL', 'بولندا'),
(21830, 1408172032, 1408237567, 'RU', 'RUS', 'الإتحاد الروسي'),
(21831, 1408237568, 1408270335, 'CZ', 'CZE', 'التشيك'),
(21832, 1408270336, 1408303103, 'PT', 'PRT', 'البورتوغال'),
(21833, 1408303104, 1408335871, 'LV', 'LVA', 'لاتفيا'),
(21834, 1408335872, 1408336879, 'SE', 'SWE', 'السويد'),
(21835, 1408336880, 1408336887, 'FI', 'FIN', 'فنلندا'),
(21836, 1408336888, 1408340047, 'SE', 'SWE', 'السويد'),
(21837, 1408340048, 1408340055, 'NO', 'NOR', 'النرويج'),
(21838, 1408340056, 1408360935, 'SE', 'SWE', 'السويد'),
(21839, 1408360936, 1408360943, 'DK', 'DNK', 'الدنيمارك'),
(21840, 1408360944, 1408368639, 'SE', 'SWE', 'السويد'),
(21841, 1408368640, 1408376831, 'NO', 'NOR', 'النرويج'),
(21842, 1408376832, 1408385023, 'DE', 'DEU', 'ألمانيا'),
(21843, 1408385024, 1408393215, 'PL', 'POL', 'بولندا'),
(21844, 1408393216, 1408401407, 'NL', 'NLD', 'هولندا'),
(21845, 1408401408, 1408434175, 'RU', 'RUS', 'الإتحاد الروسي'),
(21846, 1408434176, 1408436223, 'DE', 'DEU', 'ألمانيا'),
(21847, 1408436224, 1408438271, 'LU', 'LUX', 'لوكسيمبورغ'),
(21848, 1408438272, 1408440319, 'FR', 'FRA', 'فرنسا'),
(21849, 1408440320, 1408442367, 'SE', 'SWE', 'السويد'),
(21850, 1408442368, 1408444415, 'PL', 'POL', 'بولندا'),
(21851, 1408444416, 1408450559, 'DE', 'DEU', 'ألمانيا'),
(21852, 1408450560, 1408454655, 'RU', 'RUS', 'الإتحاد الروسي'),
(21853, 1408454656, 1408456703, 'DE', 'DEU', 'ألمانيا'),
(21854, 1408456704, 1408458751, 'LV', 'LVA', 'لاتفيا'),
(21855, 1408458752, 1408460799, 'GB', 'GBR', 'المملكة المتحدة'),
(21856, 1408460800, 1408462847, 'PL', 'POL', 'بولندا'),
(21857, 1408462848, 1408464895, 'DE', 'DEU', 'ألمانيا'),
(21858, 1408464896, 1408466943, 'RO', 'ROM', 'رومانيا'),
(21859, 1408466944, 1408499711, 'NO', 'NOR', 'النرويج'),
(21860, 1408499712, 1408532479, 'PS', 'PSE', 'فلسطين المحتلة'),
(21861, 1408532480, 1408567919, 'GB', 'GBR', 'المملكة المتحدة'),
(21862, 1408567920, 1408567927, 'IE', 'IRL', 'إيرلندا'),
(21863, 1408567928, 1408574847, 'GB', 'GBR', 'المملكة المتحدة'),
(21864, 1408574848, 1408574911, 'IE', 'IRL', 'إيرلندا'),
(21865, 1408574912, 1408575231, 'GB', 'GBR', 'المملكة المتحدة'),
(21866, 1408575232, 1408575239, 'IE', 'IRL', 'إيرلندا'),
(21867, 1408575240, 1408584191, 'GB', 'GBR', 'المملكة المتحدة'),
(21868, 1408584192, 1408584703, 'IE', 'IRL', 'إيرلندا'),
(21869, 1408584704, 1408585407, 'GB', 'GBR', 'المملكة المتحدة'),
(21870, 1408585408, 1408585471, 'IE', 'IRL', 'إيرلندا'),
(21871, 1408585472, 1408590847, 'GB', 'GBR', 'المملكة المتحدة'),
(21872, 1408590848, 1408591103, 'BE', 'BEL', 'بلجيكا'),
(21873, 1408591104, 1408598015, 'GB', 'GBR', 'المملكة المتحدة'),
(21874, 1408598016, 1408630783, 'FI', 'FIN', 'فنلندا'),
(21875, 1408630784, 1408634879, 'RO', 'ROM', 'رومانيا'),
(21876, 1408634880, 1408663551, 'DE', 'DEU', 'ألمانيا'),
(21877, 1408663552, 1408696319, 'RU', 'RUS', 'الإتحاد الروسي'),
(21878, 1408696320, 1408729087, 'NL', 'NLD', 'هولندا'),
(21879, 1408729088, 1408761855, 'ES', 'ESP', 'إسبانيا'),
(21880, 1408761856, 1409286143, 'SE', 'SWE', 'السويد'),
(21881, 1409286144, 1409362431, 'HU', 'HUN', 'هنغاريا'),
(21882, 1409362432, 1409363967, 'BG', 'BGR', 'بلغاريا'),
(21883, 1409363968, 1409413119, 'HU', 'HUN', 'هنغاريا'),
(21884, 1409413120, 1409415167, 'BG', 'BGR', 'بلغاريا'),
(21885, 1409415168, 1409430271, 'HU', 'HUN', 'هنغاريا'),
(21886, 1409430272, 1409430783, 'RO', 'ROM', 'رومانيا'),
(21887, 1409430784, 1409548287, 'HU', 'HUN', 'هنغاريا'),
(21888, 1409548288, 1409810431, 'FR', 'FRA', 'فرنسا'),
(21889, 1409810432, 1409941503, 'GB', 'GBR', 'المملكة المتحدة'),
(21890, 1409941504, 1410007039, 'PL', 'POL', 'بولندا'),
(21891, 1410007040, 1410007551, 'DE', 'DEU', 'ألمانيا'),
(21892, 1410007552, 1410007807, 'IR', 'IRN', 'إيران'),
(21893, 1410007808, 1410008575, 'DE', 'DEU', 'ألمانيا'),
(21894, 1410008576, 1410008607, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21895, 1410008608, 1410008831, 'DE', 'DEU', 'ألمانيا'),
(21896, 1410008832, 1410008911, 'US', 'USA', 'الولايات المتحدة'),
(21897, 1410008912, 1410009343, 'DE', 'DEU', 'ألمانيا'),
(21898, 1410009344, 1410009479, 'US', 'USA', 'الولايات المتحدة'),
(21899, 1410009480, 1410009487, 'DE', 'DEU', 'ألمانيا'),
(21900, 1410009488, 1410009535, 'GI', 'GIB', 'جبل طارق'),
(21901, 1410009536, 1410010367, 'DE', 'DEU', 'ألمانيا'),
(21902, 1410010368, 1410010399, 'IR', 'IRN', 'إيران'),
(21903, 1410010400, 1410010431, 'LY', 'LBY', 'ليبيا'),
(21904, 1410010432, 1410010543, 'DE', 'DEU', 'ألمانيا'),
(21905, 1410010544, 1410010575, 'LY', 'LBY', 'ليبيا'),
(21906, 1410010576, 1410010591, 'DE', 'DEU', 'ألمانيا'),
(21907, 1410010592, 1410010599, 'LY', 'LBY', 'ليبيا'),
(21908, 1410010600, 1410010607, 'IR', 'IRN', 'إيران'),
(21909, 1410010608, 1410010623, 'LY', 'LBY', 'ليبيا'),
(21910, 1410010624, 1410010687, 'DE', 'DEU', 'ألمانيا'),
(21911, 1410010688, 1410010703, 'IR', 'IRN', 'إيران'),
(21912, 1410010704, 1410010719, 'DE', 'DEU', 'ألمانيا'),
(21913, 1410010720, 1410010751, 'LY', 'LBY', 'ليبيا'),
(21914, 1410010752, 1410010823, 'DE', 'DEU', 'ألمانيا'),
(21915, 1410010824, 1410010831, 'IR', 'IRN', 'إيران'),
(21916, 1410010832, 1410010879, 'DE', 'DEU', 'ألمانيا'),
(21917, 1410010880, 1410011135, 'IR', 'IRN', 'إيران'),
(21918, 1410011136, 1410011903, 'DE', 'DEU', 'ألمانيا'),
(21919, 1410011904, 1410011919, 'US', 'USA', 'الولايات المتحدة'),
(21920, 1410011920, 1410012159, 'DE', 'DEU', 'ألمانيا'),
(21921, 1410012160, 1410012415, 'IQ', 'IRQ', 'العراق'),
(21922, 1410012416, 1410013183, 'DE', 'DEU', 'ألمانيا'),
(21923, 1410013184, 1410013439, 'ES', 'ESP', 'إسبانيا'),
(21924, 1410013440, 1410013471, 'IR', 'IRN', 'إيران'),
(21925, 1410013472, 1410013535, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21926, 1410013536, 1410013567, 'IR', 'IRN', 'إيران'),
(21927, 1410013568, 1410013631, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21928, 1410013632, 1410013663, 'IR', 'IRN', 'إيران'),
(21929, 1410013664, 1410013695, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21930, 1410013696, 1410013727, 'KW', 'KWT', 'الكويت'),
(21931, 1410013728, 1410013759, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21932, 1410013760, 1410013823, 'IR', 'IRN', 'إيران'),
(21933, 1410013824, 1410013887, 'AF', 'AFG', 'أفغانستان'),
(21934, 1410013888, 1410013919, 'DE', 'DEU', 'ألمانيا'),
(21935, 1410013920, 1410013951, 'KW', 'KWT', 'الكويت'),
(21936, 1410013952, 1410013983, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21937, 1410013984, 1410014015, 'IR', 'IRN', 'إيران'),
(21938, 1410014016, 1410014047, 'KW', 'KWT', 'الكويت'),
(21939, 1410014048, 1410014079, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21940, 1410014080, 1410014207, 'DE', 'DEU', 'ألمانيا'),
(21941, 1410014208, 1410014239, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21942, 1410014240, 1410014335, 'IR', 'IRN', 'إيران'),
(21943, 1410014336, 1410014399, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21944, 1410014400, 1410014463, 'ES', 'ESP', 'إسبانيا'),
(21945, 1410014464, 1410014495, 'KW', 'KWT', 'الكويت'),
(21946, 1410014496, 1410014591, 'IR', 'IRN', 'إيران'),
(21947, 1410014592, 1410014885, 'DE', 'DEU', 'ألمانيا'),
(21948, 1410014886, 1410014886, 'ES', 'ESP', 'إسبانيا'),
(21949, 1410014887, 1410014895, 'DE', 'DEU', 'ألمانيا'),
(21950, 1410014896, 1410014927, 'IR', 'IRN', 'إيران'),
(21951, 1410014928, 1410014935, 'PA', 'PAN', 'بنما'),
(21952, 1410014936, 1410014943, 'IR', 'IRN', 'إيران'),
(21953, 1410014944, 1410014951, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21954, 1410014952, 1410014966, 'DE', 'DEU', 'ألمانيا'),
(21955, 1410014967, 1410014967, 'IR', 'IRN', 'إيران'),
(21956, 1410014968, 1410014968, 'DE', 'DEU', 'ألمانيا'),
(21957, 1410014969, 1410014969, 'IR', 'IRN', 'إيران'),
(21958, 1410014970, 1410014972, 'DE', 'DEU', 'ألمانيا'),
(21959, 1410014973, 1410014974, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21960, 1410014975, 1410015007, 'DE', 'DEU', 'ألمانيا'),
(21961, 1410015008, 1410015103, 'IR', 'IRN', 'إيران'),
(21962, 1410015104, 1410015135, 'ES', 'ESP', 'إسبانيا'),
(21963, 1410015136, 1410015423, 'IR', 'IRN', 'إيران'),
(21964, 1410015424, 1410015487, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21965, 1410015488, 1410015743, 'AF', 'AFG', 'أفغانستان'),
(21966, 1410015744, 1410015871, 'IR', 'IRN', 'إيران'),
(21967, 1410015872, 1410015935, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21968, 1410015936, 1410016255, 'IR', 'IRN', 'إيران'),
(21969, 1410016256, 1410016319, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21970, 1410016320, 1410016383, 'ES', 'ESP', 'إسبانيا'),
(21971, 1410016384, 1410016415, 'IR', 'IRN', 'إيران'),
(21972, 1410016416, 1410016447, 'PA', 'PAN', 'بنما'),
(21973, 1410016448, 1410016543, 'IR', 'IRN', 'إيران'),
(21974, 1410016544, 1410016575, 'DE', 'DEU', 'ألمانيا'),
(21975, 1410016576, 1410016607, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21976, 1410016608, 1410016639, 'PA', 'PAN', 'بنما'),
(21977, 1410016640, 1410016671, 'IR', 'IRN', 'إيران'),
(21978, 1410016672, 1410016703, 'PA', 'PAN', 'بنما'),
(21979, 1410016704, 1410016767, 'DE', 'DEU', 'ألمانيا'),
(21980, 1410016768, 1410016831, 'IR', 'IRN', 'إيران'),
(21981, 1410016832, 1410016863, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21982, 1410016864, 1410016895, 'IR', 'IRN', 'إيران'),
(21983, 1410016896, 1410017023, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21984, 1410017024, 1410017055, 'PA', 'PAN', 'بنما'),
(21985, 1410017056, 1410017119, 'IR', 'IRN', 'إيران'),
(21986, 1410017120, 1410017279, 'DE', 'DEU', 'ألمانيا'),
(21987, 1410017280, 1410017407, 'IR', 'IRN', 'إيران'),
(21988, 1410017408, 1410017791, 'DE', 'DEU', 'ألمانيا'),
(21989, 1410017792, 1410018079, 'IR', 'IRN', 'إيران'),
(21990, 1410018080, 1410018303, 'DE', 'DEU', 'ألمانيا'),
(21991, 1410018304, 1410018559, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(21992, 1410018560, 1410018591, 'DE', 'DEU', 'ألمانيا'),
(21993, 1410018592, 1410018607, 'IR', 'IRN', 'إيران'),
(21994, 1410018608, 1410018623, 'LY', 'LBY', 'ليبيا'),
(21995, 1410018624, 1410020103, 'DE', 'DEU', 'ألمانيا'),
(21996, 1410020104, 1410020111, 'US', 'USA', 'الولايات المتحدة'),
(21997, 1410020112, 1410020351, 'DE', 'DEU', 'ألمانيا'),
(21998, 1410020352, 1410020863, 'US', 'USA', 'الولايات المتحدة'),
(21999, 1410020864, 1410021375, 'DE', 'DEU', 'ألمانيا'),
(22000, 1410021376, 1410021407, 'IR', 'IRN', 'إيران'),
(22001, 1410021408, 1410021631, 'DE', 'DEU', 'ألمانيا'),
(22002, 1410021632, 1410021663, 'IR', 'IRN', 'إيران'),
(22003, 1410021664, 1410021791, 'DE', 'DEU', 'ألمانيا'),
(22004, 1410021792, 1410021823, 'IR', 'IRN', 'إيران'),
(22005, 1410021824, 1410022527, 'DE', 'DEU', 'ألمانيا'),
(22006, 1410022528, 1410022591, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22007, 1410022592, 1410022655, 'IR', 'IRN', 'إيران'),
(22008, 1410022656, 1410022911, 'DE', 'DEU', 'ألمانيا'),
(22009, 1410022912, 1410023423, 'IR', 'IRN', 'إيران'),
(22010, 1410023424, 1410024191, 'DE', 'DEU', 'ألمانيا'),
(22011, 1410024192, 1410024223, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22012, 1410024224, 1410024287, 'DE', 'DEU', 'ألمانيا'),
(22013, 1410024288, 1410024319, 'IR', 'IRN', 'إيران'),
(22014, 1410024320, 1410024447, 'DE', 'DEU', 'ألمانيا'),
(22015, 1410024448, 1410025087, 'IR', 'IRN', 'إيران'),
(22016, 1410025088, 1410025215, 'DE', 'DEU', 'ألمانيا'),
(22017, 1410025216, 1410025247, 'ES', 'ESP', 'إسبانيا'),
(22018, 1410025248, 1410025279, 'DE', 'DEU', 'ألمانيا'),
(22019, 1410025280, 1410025311, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22020, 1410025312, 1410025343, 'ES', 'ESP', 'إسبانيا'),
(22021, 1410025344, 1410025407, 'IR', 'IRN', 'إيران'),
(22022, 1410025408, 1410025439, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22023, 1410025440, 1410025503, 'DE', 'DEU', 'ألمانيا'),
(22024, 1410025504, 1410025519, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22025, 1410025520, 1410025535, 'IR', 'IRN', 'إيران'),
(22026, 1410025536, 1410025567, 'ES', 'ESP', 'إسبانيا'),
(22027, 1410025568, 1410025599, 'DE', 'DEU', 'ألمانيا'),
(22028, 1410025600, 1410025727, 'IR', 'IRN', 'إيران'),
(22029, 1410025728, 1410025759, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22030, 1410025760, 1410025791, 'DE', 'DEU', 'ألمانيا'),
(22031, 1410025792, 1410025823, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22032, 1410025824, 1410025855, 'IR', 'IRN', 'إيران'),
(22033, 1410025856, 1410025983, 'DE', 'DEU', 'ألمانيا'),
(22034, 1410025984, 1410026015, 'IR', 'IRN', 'إيران'),
(22035, 1410026016, 1410026047, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22036, 1410026048, 1410026111, 'ES', 'ESP', 'إسبانيا'),
(22037, 1410026112, 1410026143, 'DE', 'DEU', 'ألمانيا'),
(22038, 1410026144, 1410026175, 'IR', 'IRN', 'إيران'),
(22039, 1410026176, 1410026207, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22040, 1410026208, 1410026239, 'IR', 'IRN', 'إيران'),
(22041, 1410026240, 1410026367, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22042, 1410026368, 1410026431, 'IR', 'IRN', 'إيران'),
(22043, 1410026432, 1410026463, 'DE', 'DEU', 'ألمانيا'),
(22044, 1410026464, 1410026751, 'IR', 'IRN', 'إيران'),
(22045, 1410026752, 1410026815, 'CA', 'CAN', 'كندا'),
(22046, 1410026816, 1410026847, 'DE', 'DEU', 'ألمانيا'),
(22047, 1410026848, 1410026911, 'IR', 'IRN', 'إيران'),
(22048, 1410026912, 1410026943, 'DE', 'DEU', 'ألمانيا'),
(22049, 1410026944, 1410027006, 'IR', 'IRN', 'إيران'),
(22050, 1410027007, 1410027007, 'DE', 'DEU', 'ألمانيا'),
(22051, 1410027008, 1410027263, 'KW', 'KWT', 'الكويت'),
(22052, 1410027264, 1410027519, 'AF', 'AFG', 'أفغانستان'),
(22053, 1410027520, 1410027711, 'DE', 'DEU', 'ألمانيا'),
(22054, 1410027712, 1410027775, 'IR', 'IRN', 'إيران'),
(22055, 1410027776, 1410028799, 'DE', 'DEU', 'ألمانيا'),
(22056, 1410028800, 1410028831, 'IR', 'IRN', 'إيران'),
(22057, 1410028832, 1410032127, 'DE', 'DEU', 'ألمانيا'),
(22058, 1410032128, 1410033151, 'IQ', 'IRQ', 'العراق'),
(22059, 1410033152, 1410035199, 'DE', 'DEU', 'ألمانيا'),
(22060, 1410035200, 1410035231, 'KW', 'KWT', 'الكويت'),
(22061, 1410035232, 1410035263, 'DE', 'DEU', 'ألمانيا'),
(22062, 1410035264, 1410035295, 'KW', 'KWT', 'الكويت'),
(22063, 1410035296, 1410035367, 'IR', 'IRN', 'إيران'),
(22064, 1410035368, 1410035967, 'DE', 'DEU', 'ألمانيا'),
(22065, 1410035968, 1410036063, 'PA', 'PAN', 'بنما'),
(22066, 1410036064, 1410036079, 'IQ', 'IRQ', 'العراق'),
(22067, 1410036080, 1410036095, 'IR', 'IRN', 'إيران'),
(22068, 1410036096, 1410036111, 'IQ', 'IRQ', 'العراق'),
(22069, 1410036112, 1410036127, 'PA', 'PAN', 'بنما'),
(22070, 1410036128, 1410036143, 'DE', 'DEU', 'ألمانيا'),
(22071, 1410036144, 1410036175, 'PA', 'PAN', 'بنما'),
(22072, 1410036176, 1410036191, 'DE', 'DEU', 'ألمانيا'),
(22073, 1410036192, 1410036223, 'PA', 'PAN', 'بنما'),
(22074, 1410036224, 1410036735, 'DE', 'DEU', 'ألمانيا'),
(22075, 1410036736, 1410036751, 'PA', 'PAN', 'بنما'),
(22076, 1410036752, 1410037759, 'DE', 'DEU', 'ألمانيا'),
(22077, 1410037760, 1410038015, 'US', 'USA', 'الولايات المتحدة'),
(22078, 1410038016, 1410039807, 'DE', 'DEU', 'ألمانيا'),
(22079, 1410039808, 1410041855, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22080, 1410041856, 1410042815, 'DE', 'DEU', 'ألمانيا'),
(22081, 1410042816, 1410042831, 'US', 'USA', 'الولايات المتحدة'),
(22082, 1410042832, 1410043903, 'DE', 'DEU', 'ألمانيا'),
(22083, 1410043904, 1410044415, 'JO', 'JOR', 'الأردن'),
(22084, 1410044416, 1410072319, 'DE', 'DEU', 'ألمانيا'),
(22085, 1410072320, 1410072575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22086, 1410072576, 1410203647, 'GB', 'GBR', 'المملكة المتحدة'),
(22087, 1410203648, 1410206543, 'FR', 'FRA', 'فرنسا'),
(22088, 1410206544, 1410206551, 'ES', 'ESP', 'إسبانيا'),
(22089, 1410206552, 1410212863, 'FR', 'FRA', 'فرنسا'),
(22090, 1410212864, 1410213119, 'GB', 'GBR', 'المملكة المتحدة'),
(22091, 1410213120, 1410214495, 'FR', 'FRA', 'فرنسا'),
(22092, 1410214496, 1410214503, 'PT', 'PRT', 'البورتوغال'),
(22093, 1410214504, 1410240423, 'FR', 'FRA', 'فرنسا'),
(22094, 1410240424, 1410240431, 'IT', 'ITA', 'إيطاليا'),
(22095, 1410240432, 1410250551, 'FR', 'FRA', 'فرنسا'),
(22096, 1410250552, 1410250559, 'GB', 'GBR', 'المملكة المتحدة'),
(22097, 1410250560, 1410261007, 'FR', 'FRA', 'فرنسا'),
(22098, 1410261008, 1410261015, 'GB', 'GBR', 'المملكة المتحدة'),
(22099, 1410261016, 1410262799, 'FR', 'FRA', 'فرنسا'),
(22100, 1410262800, 1410262815, 'DE', 'DEU', 'ألمانيا'),
(22101, 1410262816, 1410267039, 'FR', 'FRA', 'فرنسا'),
(22102, 1410267040, 1410267055, 'ES', 'ESP', 'إسبانيا'),
(22103, 1410267056, 1410267071, 'GB', 'GBR', 'المملكة المتحدة'),
(22104, 1410267072, 1410267087, 'IT', 'ITA', 'إيطاليا'),
(22105, 1410267088, 1410269183, 'FR', 'FRA', 'فرنسا'),
(22106, 1410269184, 1410318335, 'LT', 'LTU', 'ليتوانيا'),
(22107, 1410318336, 1410319359, 'LV', 'LVA', 'لاتفيا'),
(22108, 1410319360, 1410334719, 'LT', 'LTU', 'ليتوانيا'),
(22109, 1410334720, 1410341887, 'ES', 'ESP', 'إسبانيا'),
(22110, 1410341888, 1410342911, 'MA', 'MAR', 'المغرب'),
(22111, 1410342912, 1410351103, 'SK', 'SVK', 'سلوفاكيا'),
(22112, 1410351104, 1410353039, 'CH', 'CHE', 'سويسرا'),
(22113, 1410353040, 1410353047, 'NI', 'NIC', 'نيكاراغوا'),
(22114, 1410353048, 1410353143, 'CH', 'CHE', 'سويسرا'),
(22115, 1410353144, 1410353151, 'NI', 'NIC', 'نيكاراغوا'),
(22116, 1410353152, 1410354175, 'CH', 'CHE', 'سويسرا'),
(22117, 1410354176, 1410354431, 'FR', 'FRA', 'فرنسا'),
(22118, 1410354432, 1410359295, 'CH', 'CHE', 'سويسرا'),
(22119, 1410359296, 1410367487, 'CZ', 'CZE', 'التشيك'),
(22120, 1410367488, 1410375679, 'RU', 'RUS', 'الإتحاد الروسي'),
(22121, 1410375680, 1410375935, 'DK', 'DNK', 'الدنيمارك'),
(22122, 1410375936, 1410376191, 'CH', 'CHE', 'سويسرا'),
(22123, 1410376192, 1410383871, 'DK', 'DNK', 'الدنيمارك'),
(22124, 1410383872, 1410392063, 'NO', 'NOR', 'النرويج'),
(22125, 1410392064, 1410397183, 'DE', 'DEU', 'ألمانيا'),
(22126, 1410397184, 1410397439, 'PL', 'POL', 'بولندا'),
(22127, 1410397440, 1410399487, 'DE', 'DEU', 'ألمانيا'),
(22128, 1410399488, 1410399743, 'TR', 'TUR', 'تركيا'),
(22129, 1410399744, 1410400063, 'DE', 'DEU', 'ألمانيا'),
(22130, 1410400064, 1410400127, 'TR', 'TUR', 'تركيا'),
(22131, 1410400128, 1410400255, 'DE', 'DEU', 'ألمانيا'),
(22132, 1410400256, 1410408447, 'RU', 'RUS', 'الإتحاد الروسي'),
(22133, 1410408448, 1410416639, 'IT', 'ITA', 'إيطاليا'),
(22134, 1410416640, 1410424831, 'TR', 'TUR', 'تركيا'),
(22135, 1410424832, 1410433023, 'DE', 'DEU', 'ألمانيا'),
(22136, 1410433024, 1410441215, 'BE', 'BEL', 'بلجيكا'),
(22137, 1410441216, 1410449407, 'DE', 'DEU', 'ألمانيا'),
(22138, 1410449408, 1410457599, 'SE', 'SWE', 'السويد'),
(22139, 1410457600, 1410465791, 'RU', 'RUS', 'الإتحاد الروسي'),
(22140, 1410465792, 1410473983, 'ES', 'ESP', 'إسبانيا'),
(22141, 1410473984, 1410490367, 'JO', 'JOR', 'الأردن'),
(22142, 1410490368, 1410498559, 'RU', 'RUS', 'الإتحاد الروسي'),
(22143, 1410498560, 1410502803, 'IT', 'ITA', 'إيطاليا'),
(22144, 1410502804, 1410502807, 'US', 'USA', 'الولايات المتحدة'),
(22145, 1410502808, 1410506751, 'IT', 'ITA', 'إيطاليا'),
(22146, 1410506752, 1410514943, 'IE', 'IRL', 'إيرلندا'),
(22147, 1410514944, 1410523135, 'GB', 'GBR', 'المملكة المتحدة'),
(22148, 1410523136, 1410531327, 'PT', 'PRT', 'البورتوغال'),
(22149, 1410531328, 1410539519, 'DE', 'DEU', 'ألمانيا'),
(22150, 1410539520, 1410542591, 'GB', 'GBR', 'المملكة المتحدة'),
(22151, 1410542592, 1410543103, 'IE', 'IRL', 'إيرلندا'),
(22152, 1410543104, 1410544415, 'GB', 'GBR', 'المملكة المتحدة'),
(22153, 1410544416, 1410544431, 'DE', 'DEU', 'ألمانيا'),
(22154, 1410544432, 1410544447, 'FR', 'FRA', 'فرنسا'),
(22155, 1410544448, 1410547711, 'GB', 'GBR', 'المملكة المتحدة'),
(22156, 1410547712, 1410555903, 'CZ', 'CZE', 'التشيك'),
(22157, 1410555904, 1410564095, 'GB', 'GBR', 'المملكة المتحدة'),
(22158, 1410564096, 1410572287, 'SE', 'SWE', 'السويد'),
(22159, 1410572288, 1410572863, 'DE', 'DEU', 'ألمانيا'),
(22160, 1410572864, 1410572895, 'RU', 'RUS', 'الإتحاد الروسي'),
(22161, 1410572896, 1410573407, 'DE', 'DEU', 'ألمانيا'),
(22162, 1410573408, 1410573439, 'RU', 'RUS', 'الإتحاد الروسي'),
(22163, 1410573440, 1410573695, 'DE', 'DEU', 'ألمانيا'),
(22164, 1410573696, 1410573711, 'RU', 'RUS', 'الإتحاد الروسي'),
(22165, 1410573712, 1410573815, 'DE', 'DEU', 'ألمانيا'),
(22166, 1410573816, 1410573823, 'RU', 'RUS', 'الإتحاد الروسي'),
(22167, 1410573824, 1410574527, 'DE', 'DEU', 'ألمانيا'),
(22168, 1410574528, 1410574559, 'CH', 'CHE', 'سويسرا'),
(22169, 1410574560, 1410574583, 'DE', 'DEU', 'ألمانيا'),
(22170, 1410574584, 1410574591, 'RU', 'RUS', 'الإتحاد الروسي'),
(22171, 1410574592, 1410574719, 'DE', 'DEU', 'ألمانيا'),
(22172, 1410574720, 1410574727, 'RU', 'RUS', 'الإتحاد الروسي'),
(22173, 1410574728, 1410574847, 'DE', 'DEU', 'ألمانيا'),
(22174, 1410574848, 1410575103, 'GB', 'GBR', 'المملكة المتحدة'),
(22175, 1410575104, 1410575111, 'US', 'USA', 'الولايات المتحدة'),
(22176, 1410575112, 1410575119, 'IT', 'ITA', 'إيطاليا'),
(22177, 1410575120, 1410575135, 'DE', 'DEU', 'ألمانيا'),
(22178, 1410575136, 1410575167, 'RU', 'RUS', 'الإتحاد الروسي'),
(22179, 1410575168, 1410575231, 'DE', 'DEU', 'ألمانيا'),
(22180, 1410575232, 1410575263, 'CH', 'CHE', 'سويسرا'),
(22181, 1410575264, 1410575279, 'DE', 'DEU', 'ألمانيا'),
(22182, 1410575280, 1410575295, 'IL', 'ISR', 'إسرائيل'),
(22183, 1410575296, 1410575327, 'IT', 'ITA', 'إيطاليا'),
(22184, 1410575328, 1410575359, 'SI', 'SVN', 'سلوفينيا'),
(22185, 1410575360, 1410575551, 'DE', 'DEU', 'ألمانيا'),
(22186, 1410575552, 1410575615, 'IT', 'ITA', 'إيطاليا'),
(22187, 1410575616, 1410575775, 'DE', 'DEU', 'ألمانيا'),
(22188, 1410575776, 1410575791, 'RU', 'RUS', 'الإتحاد الروسي'),
(22189, 1410575792, 1410575807, 'DE', 'DEU', 'ألمانيا'),
(22190, 1410575808, 1410575823, 'IL', 'ISR', 'إسرائيل'),
(22191, 1410575824, 1410575839, 'BG', 'BGR', 'بلغاريا'),
(22192, 1410575840, 1410575855, 'IT', 'ITA', 'إيطاليا'),
(22193, 1410575856, 1410575871, 'DE', 'DEU', 'ألمانيا'),
(22194, 1410575872, 1410575999, 'DK', 'DNK', 'الدنيمارك'),
(22195, 1410576000, 1410576063, 'DE', 'DEU', 'ألمانيا'),
(22196, 1410576064, 1410576127, 'IT', 'ITA', 'إيطاليا'),
(22197, 1410576128, 1410576255, 'DE', 'DEU', 'ألمانيا'),
(22198, 1410576256, 1410576383, 'IT', 'ITA', 'إيطاليا'),
(22199, 1410576384, 1410588671, 'DE', 'DEU', 'ألمانيا'),
(22200, 1410588672, 1410596863, 'GB', 'GBR', 'المملكة المتحدة'),
(22201, 1410596864, 1410597839, 'ES', 'ESP', 'إسبانيا'),
(22202, 1410597840, 1410597855, 'FR', 'FRA', 'فرنسا'),
(22203, 1410597856, 1410605055, 'ES', 'ESP', 'إسبانيا'),
(22204, 1410605056, 1410613247, 'CH', 'CHE', 'سويسرا'),
(22205, 1410613248, 1410621439, 'AL', 'ALB', 'ألبانيا'),
(22206, 1410621440, 1410629631, 'NO', 'NOR', 'النرويج'),
(22207, 1410629632, 1410637823, 'FI', 'FIN', 'فنلندا'),
(22208, 1410637824, 1410646015, 'AT', 'AUT', 'النمسا'),
(22209, 1410646016, 1410654207, 'GB', 'GBR', 'المملكة المتحدة'),
(22210, 1410654208, 1410662399, 'SI', 'SVN', 'سلوفينيا'),
(22211, 1410662400, 1410670591, 'HU', 'HUN', 'هنغاريا'),
(22212, 1410670592, 1410678783, 'DE', 'DEU', 'ألمانيا'),
(22213, 1410678784, 1410686975, 'RU', 'RUS', 'الإتحاد الروسي'),
(22214, 1410686976, 1410695167, 'CZ', 'CZE', 'التشيك'),
(22215, 1410695168, 1410703359, 'GB', 'GBR', 'المملكة المتحدة'),
(22216, 1410703360, 1410711551, 'ES', 'ESP', 'إسبانيا'),
(22217, 1410711552, 1410719743, 'BG', 'BGR', 'بلغاريا'),
(22218, 1410719744, 1410727935, 'RU', 'RUS', 'الإتحاد الروسي'),
(22219, 1410727936, 1410736127, 'BG', 'BGR', 'بلغاريا'),
(22220, 1410736128, 1410744319, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(22221, 1410744320, 1410745223, 'FR', 'FRA', 'فرنسا'),
(22222, 1410745224, 1410745231, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22223, 1410745232, 1410745247, 'FR', 'FRA', 'فرنسا'),
(22224, 1410745248, 1410745279, 'US', 'USA', 'الولايات المتحدة'),
(22225, 1410745280, 1410745855, 'FR', 'FRA', 'فرنسا'),
(22226, 1410745856, 1410746111, 'CH', 'CHE', 'سويسرا'),
(22227, 1410746112, 1410746623, 'AO', 'AGO', 'أنغولا'),
(22228, 1410746624, 1410752511, 'FR', 'FRA', 'فرنسا'),
(22229, 1410752512, 1410752639, 'AQ', 'ATA', 'أنتاركتيكا'),
(22230, 1410752640, 1410752759, 'DE', 'DEU', 'ألمانيا'),
(22231, 1410752760, 1410752785, 'AQ', 'ATA', 'أنتاركتيكا'),
(22232, 1410752786, 1410752799, 'DE', 'DEU', 'ألمانيا'),
(22233, 1410752800, 1410752827, 'AQ', 'ATA', 'أنتاركتيكا'),
(22234, 1410752828, 1410753023, 'DE', 'DEU', 'ألمانيا'),
(22235, 1410753024, 1410753135, 'AQ', 'ATA', 'أنتاركتيكا'),
(22236, 1410753136, 1410753303, 'DE', 'DEU', 'ألمانيا'),
(22237, 1410753304, 1410753327, 'AQ', 'ATA', 'أنتاركتيكا'),
(22238, 1410753328, 1410753335, 'DE', 'DEU', 'ألمانيا'),
(22239, 1410753336, 1410753343, 'AQ', 'ATA', 'أنتاركتيكا'),
(22240, 1410753344, 1410753351, 'DE', 'DEU', 'ألمانيا'),
(22241, 1410753352, 1410753367, 'AQ', 'ATA', 'أنتاركتيكا'),
(22242, 1410753368, 1410753391, 'DE', 'DEU', 'ألمانيا'),
(22243, 1410753392, 1410753533, 'AQ', 'ATA', 'أنتاركتيكا'),
(22244, 1410753534, 1410753535, 'DE', 'DEU', 'ألمانيا'),
(22245, 1410753536, 1410754559, 'AQ', 'ATA', 'أنتاركتيكا'),
(22246, 1410754560, 1410754815, 'DE', 'DEU', 'ألمانيا'),
(22247, 1410754816, 1410754821, 'AQ', 'ATA', 'أنتاركتيكا'),
(22248, 1410754822, 1410754827, 'DE', 'DEU', 'ألمانيا'),
(22249, 1410754828, 1410754831, 'AQ', 'ATA', 'أنتاركتيكا'),
(22250, 1410754832, 1410754855, 'DE', 'DEU', 'ألمانيا'),
(22251, 1410754856, 1410754861, 'AQ', 'ATA', 'أنتاركتيكا'),
(22252, 1410754862, 1410754867, 'DE', 'DEU', 'ألمانيا'),
(22253, 1410754868, 1410754873, 'AQ', 'ATA', 'أنتاركتيكا'),
(22254, 1410754874, 1410755063, 'DE', 'DEU', 'ألمانيا'),
(22255, 1410755064, 1410755069, 'AQ', 'ATA', 'أنتاركتيكا'),
(22256, 1410755070, 1410755071, 'DE', 'DEU', 'ألمانيا'),
(22257, 1410755072, 1410755327, 'AQ', 'ATA', 'أنتاركتيكا'),
(22258, 1410755328, 1410756607, 'DE', 'DEU', 'ألمانيا'),
(22259, 1410756608, 1410756735, 'AQ', 'ATA', 'أنتاركتيكا'),
(22260, 1410756736, 1410756863, 'DE', 'DEU', 'ألمانيا'),
(22261, 1410756864, 1410757119, 'AQ', 'ATA', 'أنتاركتيكا'),
(22262, 1410757120, 1410758655, 'DE', 'DEU', 'ألمانيا'),
(22263, 1410758656, 1410760191, 'AQ', 'ATA', 'أنتاركتيكا'),
(22264, 1410760192, 1410760455, 'DE', 'DEU', 'ألمانيا'),
(22265, 1410760456, 1410760479, 'AQ', 'ATA', 'أنتاركتيكا'),
(22266, 1410760480, 1410760487, 'DE', 'DEU', 'ألمانيا'),
(22267, 1410760488, 1410760511, 'AQ', 'ATA', 'أنتاركتيكا'),
(22268, 1410760512, 1410760683, 'DE', 'DEU', 'ألمانيا'),
(22269, 1410760684, 1410760687, 'AQ', 'ATA', 'أنتاركتيكا'),
(22270, 1410760688, 1410760699, 'DE', 'DEU', 'ألمانيا'),
(22271, 1410760700, 1410760703, 'AQ', 'ATA', 'أنتاركتيكا'),
(22272, 1410760704, 1410768895, 'RU', 'RUS', 'الإتحاد الروسي'),
(22273, 1410768896, 1410777087, 'GB', 'GBR', 'المملكة المتحدة'),
(22274, 1410777088, 1410785279, 'RU', 'RUS', 'الإتحاد الروسي'),
(22275, 1410785280, 1410793471, 'SA', 'SAU', 'السعودية'),
(22276, 1410793472, 1410801663, 'GB', 'GBR', 'المملكة المتحدة'),
(22277, 1410801664, 1410809855, 'RU', 'RUS', 'الإتحاد الروسي'),
(22278, 1410809856, 1410818047, 'DE', 'DEU', 'ألمانيا'),
(22279, 1410818048, 1410826239, 'SA', 'SAU', 'السعودية'),
(22280, 1410826240, 1410834431, 'SE', 'SWE', 'السويد'),
(22281, 1410834432, 1410842623, 'PL', 'POL', 'بولندا'),
(22282, 1410842624, 1410850815, 'PT', 'PRT', 'البورتوغال'),
(22283, 1410850816, 1410859007, 'DE', 'DEU', 'ألمانيا'),
(22284, 1410859008, 1411383295, 'NL', 'NLD', 'هولندا'),
(22285, 1411383296, 1411448831, 'LT', 'LTU', 'ليتوانيا'),
(22286, 1411448832, 1411451391, 'IT', 'ITA', 'إيطاليا'),
(22287, 1411451392, 1411451903, 'DE', 'DEU', 'ألمانيا'),
(22288, 1411451904, 1411452159, 'IT', 'ITA', 'إيطاليا'),
(22289, 1411452160, 1411452415, 'DE', 'DEU', 'ألمانيا'),
(22290, 1411452416, 1411453439, 'IT', 'ITA', 'إيطاليا'),
(22291, 1411453440, 1411453695, 'DE', 'DEU', 'ألمانيا'),
(22292, 1411453696, 1411454975, 'IT', 'ITA', 'إيطاليا'),
(22293, 1411454976, 1411455743, 'DE', 'DEU', 'ألمانيا'),
(22294, 1411455744, 1411456255, 'IT', 'ITA', 'إيطاليا'),
(22295, 1411456256, 1411456511, 'DE', 'DEU', 'ألمانيا'),
(22296, 1411456512, 1411457279, 'IT', 'ITA', 'إيطاليا'),
(22297, 1411457280, 1411457535, 'DE', 'DEU', 'ألمانيا'),
(22298, 1411457536, 1411465215, 'IT', 'ITA', 'إيطاليا'),
(22299, 1411465216, 1411465471, 'GB', 'GBR', 'المملكة المتحدة'),
(22300, 1411465472, 1411465727, 'US', 'USA', 'الولايات المتحدة'),
(22301, 1411465728, 1411481855, 'IT', 'ITA', 'إيطاليا'),
(22302, 1411481856, 1411483903, 'DE', 'DEU', 'ألمانيا'),
(22303, 1411483904, 1411500799, 'IT', 'ITA', 'إيطاليا'),
(22304, 1411500800, 1411501055, 'DE', 'DEU', 'ألمانيا'),
(22305, 1411501056, 1411505407, 'IT', 'ITA', 'إيطاليا'),
(22306, 1411505408, 1411505663, 'US', 'USA', 'الولايات المتحدة'),
(22307, 1411505664, 1411514367, 'IT', 'ITA', 'إيطاليا'),
(22308, 1411514368, 1411579903, 'FI', 'FIN', 'فنلندا'),
(22309, 1411579904, 1411645439, 'NL', 'NLD', 'هولندا'),
(22310, 1411710976, 1411776511, 'FR', 'FRA', 'فرنسا'),
(22311, 1411776512, 1411780607, 'GR', 'GRC', 'اليونان'),
(22312, 1411780608, 1411784703, 'PL', 'POL', 'بولندا'),
(22313, 1411784704, 1411788799, 'GB', 'GBR', 'المملكة المتحدة'),
(22314, 1411788800, 1411792895, 'IT', 'ITA', 'إيطاليا'),
(22315, 1411792896, 1411796991, 'DE', 'DEU', 'ألمانيا'),
(22316, 1411796992, 1411805183, 'PL', 'POL', 'بولندا'),
(22317, 1411805184, 1411809279, 'AT', 'AUT', 'النمسا'),
(22318, 1411809280, 1411813375, 'LV', 'LVA', 'لاتفيا'),
(22319, 1411813376, 1411817471, 'NO', 'NOR', 'النرويج'),
(22320, 1411817472, 1411821567, 'PL', 'POL', 'بولندا'),
(22321, 1411825664, 1411829759, 'DE', 'DEU', 'ألمانيا'),
(22322, 1411829760, 1411833855, 'PL', 'POL', 'بولندا'),
(22323, 1411833856, 1411837951, 'NL', 'NLD', 'هولندا'),
(22324, 1411837952, 1411842047, 'BG', 'BGR', 'بلغاريا'),
(22325, 1411842048, 1411907583, 'PT', 'PRT', 'البورتوغال'),
(22326, 1411907840, 1411908351, 'GB', 'GBR', 'المملكة المتحدة'),
(22327, 1411908400, 1411908479, 'GB', 'GBR', 'المملكة المتحدة'),
(22328, 1411908536, 1411908559, 'GB', 'GBR', 'المملكة المتحدة'),
(22329, 1411908560, 1411908563, 'AU', 'AUS', 'أستراليا'),
(22330, 1411908608, 1411909375, 'GB', 'GBR', 'المملكة المتحدة'),
(22331, 1411909632, 1411909759, 'GB', 'GBR', 'المملكة المتحدة'),
(22332, 1411909888, 1411910143, 'GB', 'GBR', 'المملكة المتحدة'),
(22333, 1411910400, 1411910655, 'GB', 'GBR', 'المملكة المتحدة'),
(22334, 1411910912, 1411911167, 'GB', 'GBR', 'المملكة المتحدة'),
(22335, 1411911424, 1411911439, 'GB', 'GBR', 'المملكة المتحدة'),
(22336, 1411911616, 1411911647, 'GB', 'GBR', 'المملكة المتحدة'),
(22337, 1411911680, 1411915775, 'US', 'USA', 'الولايات المتحدة'),
(22338, 1411915776, 1411915839, 'GB', 'GBR', 'المملكة المتحدة'),
(22339, 1411915904, 1411915911, 'GB', 'GBR', 'المملكة المتحدة'),
(22340, 1411915936, 1411915967, 'GB', 'GBR', 'المملكة المتحدة'),
(22341, 1411916032, 1411916095, 'GB', 'GBR', 'المملكة المتحدة'),
(22342, 1411916296, 1411916303, 'GB', 'GBR', 'المملكة المتحدة'),
(22343, 1411916800, 1411916863, 'GB', 'GBR', 'المملكة المتحدة'),
(22344, 1411917568, 1411917639, 'GB', 'GBR', 'المملكة المتحدة'),
(22345, 1411917664, 1411917695, 'GB', 'GBR', 'المملكة المتحدة'),
(22346, 1411919872, 1411923967, 'DE', 'DEU', 'ألمانيا'),
(22347, 1411923968, 1411940351, 'BG', 'BGR', 'بلغاريا'),
(22348, 1411940352, 1411973119, 'PL', 'POL', 'بولندا'),
(22349, 1411973120, 1411999759, 'SI', 'SVN', 'سلوفينيا'),
(22350, 1411999760, 1411999783, 'BA', 'BIH', 'البوسنه والهرسك'),
(22351, 1411999784, 1411999791, 'SI', 'SVN', 'سلوفينيا'),
(22352, 1411999792, 1411999799, 'BA', 'BIH', 'البوسنه والهرسك'),
(22353, 1411999800, 1411999807, 'SI', 'SVN', 'سلوفينيا'),
(22354, 1411999808, 1411999823, 'BA', 'BIH', 'البوسنه والهرسك'),
(22355, 1411999824, 1411999831, 'SI', 'SVN', 'سلوفينيا'),
(22356, 1411999832, 1411999839, 'BA', 'BIH', 'البوسنه والهرسك'),
(22357, 1411999840, 1411999871, 'SI', 'SVN', 'سلوفينيا'),
(22358, 1411999872, 1412000767, 'BA', 'BIH', 'البوسنه والهرسك'),
(22359, 1412000768, 1412000783, 'SI', 'SVN', 'سلوفينيا'),
(22360, 1412000784, 1412000791, 'BA', 'BIH', 'البوسنه والهرسك'),
(22361, 1412000792, 1412000863, 'SI', 'SVN', 'سلوفينيا'),
(22362, 1412000864, 1412000879, 'BA', 'BIH', 'البوسنه والهرسك'),
(22363, 1412000880, 1412001791, 'SI', 'SVN', 'سلوفينيا'),
(22364, 1412001792, 1412002303, 'RO', 'ROM', 'رومانيا'),
(22365, 1412002304, 1412002559, 'SI', 'SVN', 'سلوفينيا'),
(22366, 1412002560, 1412002815, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(22367, 1412002816, 1412003391, 'BA', 'BIH', 'البوسنه والهرسك'),
(22368, 1412003392, 1412003399, 'HR', 'HRV', 'كرواتيا'),
(22369, 1412003400, 1412003839, 'BA', 'BIH', 'البوسنه والهرسك'),
(22370, 1412003840, 1412004607, 'BG', 'BGR', 'بلغاريا'),
(22371, 1412004608, 1412005887, 'SI', 'SVN', 'سلوفينيا'),
(22372, 1412005888, 1412038655, 'NL', 'NLD', 'هولندا'),
(22373, 1412038656, 1412071423, 'RU', 'RUS', 'الإتحاد الروسي'),
(22374, 1412071424, 1412104191, 'CZ', 'CZE', 'التشيك'),
(22375, 1412104192, 1412136959, 'GB', 'GBR', 'المملكة المتحدة'),
(22376, 1412136960, 1412169727, 'BG', 'BGR', 'بلغاريا'),
(22377, 1412169728, 1412202495, 'TR', 'TUR', 'تركيا'),
(22378, 1412202496, 1412235263, 'DE', 'DEU', 'ألمانيا'),
(22379, 1412235264, 1412241111, 'GB', 'GBR', 'المملكة المتحدة'),
(22380, 1412241112, 1412241119, 'NL', 'NLD', 'هولندا'),
(22381, 1412241120, 1412257535, 'GB', 'GBR', 'المملكة المتحدة'),
(22382, 1412257536, 1412257615, 'NL', 'NLD', 'هولندا'),
(22383, 1412257616, 1412258559, 'GB', 'GBR', 'المملكة المتحدة'),
(22384, 1412258560, 1412258815, 'DE', 'DEU', 'ألمانيا'),
(22385, 1412258816, 1412300799, 'GB', 'GBR', 'المملكة المتحدة'),
(22386, 1412300800, 1412333567, 'DE', 'DEU', 'ألمانيا'),
(22387, 1412333568, 1412366335, 'LT', 'LTU', 'ليتوانيا'),
(22388, 1412366336, 1412399103, 'SK', 'SVK', 'سلوفاكيا'),
(22389, 1412399104, 1412415487, 'RU', 'RUS', 'الإتحاد الروسي'),
(22390, 1412415488, 1412415743, 'IR', 'IRN', 'إيران'),
(22391, 1412415744, 1412415999, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22392, 1412416000, 1412420351, 'IR', 'IRN', 'إيران'),
(22393, 1412420352, 1412420607, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22394, 1412420608, 1412431871, 'IR', 'IRN', 'إيران'),
(22395, 1412431872, 1412562943, 'NO', 'NOR', 'النرويج'),
(22396, 1412562944, 1412628479, 'EE', 'EST', 'إستونيا'),
(22397, 1412628480, 1412641791, 'TR', 'TUR', 'تركيا'),
(22398, 1412641792, 1412642815, 'DE', 'DEU', 'ألمانيا'),
(22399, 1412642816, 1412644863, 'TR', 'TUR', 'تركيا'),
(22400, 1412644864, 1412661247, 'RU', 'RUS', 'الإتحاد الروسي'),
(22401, 1412661248, 1412677631, 'GB', 'GBR', 'المملكة المتحدة'),
(22402, 1412677632, 1412685823, 'RU', 'RUS', 'الإتحاد الروسي'),
(22403, 1412685824, 1412686239, 'IE', 'IRL', 'إيرلندا'),
(22404, 1412686240, 1412686335, 'BB', 'BRB', 'باربادوس'),
(22405, 1412686336, 1412686591, 'IE', 'IRL', 'إيرلندا'),
(22406, 1412686592, 1412686847, 'GB', 'GBR', 'المملكة المتحدة'),
(22407, 1412686848, 1412690191, 'IE', 'IRL', 'إيرلندا'),
(22408, 1412690192, 1412690199, 'GB', 'GBR', 'المملكة المتحدة'),
(22409, 1412690200, 1412694015, 'IE', 'IRL', 'إيرلندا'),
(22410, 1412694016, 1412710399, 'EE', 'EST', 'إستونيا'),
(22411, 1412710400, 1412726783, 'RU', 'RUS', 'الإتحاد الروسي'),
(22412, 1412726784, 1412743167, 'SI', 'SVN', 'سلوفينيا'),
(22413, 1412743168, 1412775935, 'NO', 'NOR', 'النرويج'),
(22414, 1412775936, 1412792319, 'NL', 'NLD', 'هولندا'),
(22415, 1412792320, 1412793343, 'US', 'USA', 'الولايات المتحدة'),
(22416, 1412793856, 1412804607, 'US', 'USA', 'الولايات المتحدة'),
(22417, 1412804864, 1412805631, 'US', 'USA', 'الولايات المتحدة'),
(22418, 1412806144, 1412808703, 'US', 'USA', 'الولايات المتحدة'),
(22419, 1412808704, 1412825087, 'RU', 'RUS', 'الإتحاد الروسي'),
(22420, 1412825088, 1412830463, 'IQ', 'IRQ', 'العراق'),
(22421, 1412830464, 1412833279, 'LB', 'LBN', 'لبنان'),
(22422, 1412833280, 1412833535, 'CI', 'CIV', 'كوت ديفوار'),
(22423, 1412833536, 1412841471, 'LB', 'LBN', 'لبنان'),
(22424, 1412841472, 1412857855, 'UZ', 'UZB', 'أوزباكستان'),
(22425, 1412857856, 1412874239, 'BG', 'BGR', 'بلغاريا'),
(22426, 1412874240, 1412890623, 'RU', 'RUS', 'الإتحاد الروسي'),
(22427, 1412890624, 1412907007, 'LT', 'LTU', 'ليتوانيا'),
(22428, 1412907008, 1412923391, 'SE', 'SWE', 'السويد'),
(22429, 1412923392, 1412939775, 'FR', 'FRA', 'فرنسا'),
(22430, 1412939776, 1412956159, 'CH', 'CHE', 'سويسرا'),
(22431, 1412956160, 1413480447, 'DE', 'DEU', 'ألمانيا'),
(22432, 1413480448, 1414004735, 'GB', 'GBR', 'المملكة المتحدة'),
(22433, 1414004736, 1414266879, 'CH', 'CHE', 'سويسرا'),
(22434, 1414266880, 1414529023, 'ES', 'ESP', 'إسبانيا'),
(22435, 1414529024, 1415053311, 'NL', 'NLD', 'هولندا'),
(22436, 1415053312, 1415184383, 'ES', 'ESP', 'إسبانيا'),
(22437, 1415184384, 1415315455, 'PT', 'PRT', 'البورتوغال'),
(22438, 1415315456, 1415446527, 'GB', 'GBR', 'المملكة المتحدة'),
(22439, 1415446528, 1415577599, 'IL', 'ISR', 'إسرائيل'),
(22440, 1415577600, 1416101887, 'FR', 'FRA', 'فرنسا'),
(22441, 1416101888, 1416364031, 'NL', 'NLD', 'هولندا'),
(22442, 1416364032, 1416626175, 'IL', 'ISR', 'إسرائيل'),
(22443, 1416626176, 1417150463, 'AT', 'AUT', 'النمسا'),
(22444, 1417150464, 1417674751, 'ES', 'ESP', 'إسبانيا'),
(22445, 1417674752, 1421869055, 'DE', 'DEU', 'ألمانيا'),
(22446, 1421869056, 1422393343, 'BE', 'BEL', 'بلجيكا'),
(22447, 1422393344, 1422393599, 'DE', 'DEU', 'ألمانيا'),
(22448, 1422393600, 1422393855, 'IT', 'ITA', 'إيطاليا'),
(22449, 1422393856, 1422399103, 'DE', 'DEU', 'ألمانيا'),
(22450, 1422399104, 1422399231, 'IT', 'ITA', 'إيطاليا'),
(22451, 1422399232, 1422399999, 'DE', 'DEU', 'ألمانيا'),
(22452, 1422400000, 1422400255, 'IT', 'ITA', 'إيطاليا'),
(22453, 1422400256, 1422401023, 'DE', 'DEU', 'ألمانيا'),
(22454, 1422401024, 1422401087, 'RO', 'ROM', 'رومانيا'),
(22455, 1422401088, 1422401151, 'GB', 'GBR', 'المملكة المتحدة'),
(22456, 1422401152, 1422401279, 'DE', 'DEU', 'ألمانيا'),
(22457, 1422401280, 1422401283, 'RO', 'ROM', 'رومانيا'),
(22458, 1422401284, 1422462207, 'DE', 'DEU', 'ألمانيا'),
(22459, 1422462208, 1422462463, 'TR', 'TUR', 'تركيا'),
(22460, 1422462464, 1422468671, 'DE', 'DEU', 'ألمانيا'),
(22461, 1422468672, 1422468735, 'IT', 'ITA', 'إيطاليا'),
(22462, 1422468736, 1422479615, 'DE', 'DEU', 'ألمانيا'),
(22463, 1422479616, 1422479871, 'BE', 'BEL', 'بلجيكا'),
(22464, 1422479872, 1422491647, 'DE', 'DEU', 'ألمانيا'),
(22465, 1422491648, 1422508031, 'GB', 'GBR', 'المملكة المتحدة'),
(22466, 1422508032, 1422512127, 'BG', 'BGR', 'بلغاريا'),
(22467, 1422512128, 1422516223, 'PL', 'POL', 'بولندا'),
(22468, 1422516224, 1422520319, 'BY', 'BLR', 'روسيا البيضاء'),
(22469, 1422520320, 1422524415, 'RU', 'RUS', 'الإتحاد الروسي'),
(22470, 1422524416, 1422589951, 'NO', 'NOR', 'النرويج'),
(22471, 1422589952, 1422655487, 'IE', 'IRL', 'إيرلندا'),
(22472, 1422655488, 1422721023, 'RU', 'RUS', 'الإتحاد الروسي'),
(22473, 1422721024, 1422729215, 'PL', 'POL', 'بولندا'),
(22474, 1422729216, 1422737407, 'NO', 'NOR', 'النرويج'),
(22475, 1422753792, 1422761983, 'FR', 'FRA', 'فرنسا'),
(22476, 1422761984, 1422770175, 'PL', 'POL', 'بولندا'),
(22477, 1422770176, 1422786559, 'GR', 'GRC', 'اليونان'),
(22478, 1422786560, 1422852095, 'HU', 'HUN', 'هنغاريا'),
(22479, 1422852096, 1422853119, 'FR', 'FRA', 'فرنسا'),
(22480, 1422853632, 1422853919, 'FR', 'FRA', 'فرنسا'),
(22481, 1422854144, 1422854151, 'FR', 'FRA', 'فرنسا'),
(22482, 1422856320, 1422856575, 'FR', 'FRA', 'فرنسا'),
(22483, 1422856704, 1422857855, 'FR', 'FRA', 'فرنسا'),
(22484, 1422857920, 1422858143, 'FR', 'FRA', 'فرنسا'),
(22485, 1422858240, 1422858623, 'FR', 'FRA', 'فرنسا'),
(22486, 1422909440, 1422909695, 'NL', 'NLD', 'هولندا'),
(22487, 1422917376, 1422917631, 'GB', 'GBR', 'المملكة المتحدة'),
(22488, 1422917632, 1423441919, 'NO', 'NOR', 'النرويج'),
(22489, 1423441920, 1423704063, 'SE', 'SWE', 'السويد'),
(22490, 1423704064, 1423966207, 'IT', 'ITA', 'إيطاليا'),
(22491, 1423966208, 1424097279, 'HU', 'HUN', 'هنغاريا'),
(22492, 1424097280, 1424228351, 'CH', 'CHE', 'سويسرا'),
(22493, 1424228352, 1424359423, 'IL', 'ISR', 'إسرائيل'),
(22494, 1424359424, 1424490495, 'FI', 'FIN', 'فنلندا'),
(22495, 1424490496, 1424523263, 'ES', 'ESP', 'إسبانيا'),
(22496, 1424523264, 1424556031, 'RO', 'ROM', 'رومانيا'),
(22497, 1424588800, 1424588839, 'DE', 'DEU', 'ألمانيا'),
(22498, 1424588840, 1424588847, 'GB', 'GBR', 'المملكة المتحدة'),
(22499, 1424588848, 1424588959, 'DE', 'DEU', 'ألمانيا'),
(22500, 1424588960, 1424588963, 'GB', 'GBR', 'المملكة المتحدة'),
(22501, 1424588964, 1424589311, 'DE', 'DEU', 'ألمانيا'),
(22502, 1424589312, 1424589567, 'FR', 'FRA', 'فرنسا'),
(22503, 1424589568, 1424590719, 'GB', 'GBR', 'المملكة المتحدة'),
(22504, 1424590720, 1424590767, 'SE', 'SWE', 'السويد'),
(22505, 1424590768, 1424590775, 'GB', 'GBR', 'المملكة المتحدة'),
(22506, 1424590776, 1424590783, 'SE', 'SWE', 'السويد'),
(22507, 1424590784, 1424590847, 'CH', 'CHE', 'سويسرا'),
(22508, 1424590848, 1424591406, 'SE', 'SWE', 'السويد'),
(22509, 1424591407, 1424591407, 'GB', 'GBR', 'المملكة المتحدة'),
(22510, 1424591408, 1424591423, 'SE', 'SWE', 'السويد'),
(22511, 1424591424, 1424591439, 'GB', 'GBR', 'المملكة المتحدة'),
(22512, 1424591440, 1424591463, 'SE', 'SWE', 'السويد'),
(22513, 1424591464, 1424591471, 'GB', 'GBR', 'المملكة المتحدة'),
(22514, 1424591472, 1424591551, 'SE', 'SWE', 'السويد'),
(22515, 1424591552, 1424591615, 'CZ', 'CZE', 'التشيك'),
(22516, 1424591616, 1424591839, 'GB', 'GBR', 'المملكة المتحدة'),
(22517, 1424591840, 1424591871, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(22518, 1424591872, 1424592639, 'GB', 'GBR', 'المملكة المتحدة'),
(22519, 1424592640, 1424592831, 'FR', 'FRA', 'فرنسا'),
(22520, 1424592832, 1424593151, 'GB', 'GBR', 'المملكة المتحدة'),
(22521, 1424593152, 1424593407, 'NL', 'NLD', 'هولندا'),
(22522, 1424593408, 1424593663, 'DE', 'DEU', 'ألمانيا'),
(22523, 1424593664, 1424593727, 'SK', 'SVK', 'سلوفاكيا'),
(22524, 1424593728, 1424593791, 'HU', 'HUN', 'هنغاريا'),
(22525, 1424593792, 1424593919, 'DE', 'DEU', 'ألمانيا'),
(22526, 1424593920, 1424593967, 'FR', 'FRA', 'فرنسا'),
(22527, 1424593968, 1424593983, 'GB', 'GBR', 'المملكة المتحدة'),
(22528, 1424593984, 1424594055, 'FR', 'FRA', 'فرنسا'),
(22529, 1424594056, 1424594063, 'IT', 'ITA', 'إيطاليا'),
(22530, 1424594064, 1424594175, 'FR', 'FRA', 'فرنسا'),
(22531, 1424594176, 1424594431, 'GB', 'GBR', 'المملكة المتحدة'),
(22532, 1424594432, 1424594495, 'IE', 'IRL', 'إيرلندا'),
(22533, 1424594496, 1424595455, 'GB', 'GBR', 'المملكة المتحدة'),
(22534, 1424595456, 1424595527, 'IT', 'ITA', 'إيطاليا'),
(22535, 1424595528, 1424595535, 'GB', 'GBR', 'المملكة المتحدة'),
(22536, 1424595536, 1424595575, 'IT', 'ITA', 'إيطاليا'),
(22537, 1424595576, 1424595583, 'ES', 'ESP', 'إسبانيا'),
(22538, 1424595584, 1424596479, 'IT', 'ITA', 'إيطاليا'),
(22539, 1424596480, 1424596991, 'FR', 'FRA', 'فرنسا'),
(22540, 1424596992, 1424597255, 'CZ', 'CZE', 'التشيك'),
(22541, 1424597256, 1424597263, 'GB', 'GBR', 'المملكة المتحدة'),
(22542, 1424597264, 1424597311, 'CZ', 'CZE', 'التشيك'),
(22543, 1424597312, 1424597343, 'GB', 'GBR', 'المملكة المتحدة'),
(22544, 1424597344, 1424597351, 'CH', 'CHE', 'سويسرا'),
(22545, 1424597352, 1424597503, 'GB', 'GBR', 'المملكة المتحدة'),
(22546, 1424597504, 1424597759, 'FR', 'FRA', 'فرنسا'),
(22547, 1424597760, 1424598015, 'IT', 'ITA', 'إيطاليا'),
(22548, 1424598016, 1424599039, 'GB', 'GBR', 'المملكة المتحدة'),
(22549, 1424599040, 1424599279, 'DK', 'DNK', 'الدنيمارك'),
(22550, 1424599280, 1424599295, 'GB', 'GBR', 'المملكة المتحدة'),
(22551, 1424599296, 1424599551, 'DK', 'DNK', 'الدنيمارك'),
(22552, 1424599552, 1424599839, 'HU', 'HUN', 'هنغاريا'),
(22553, 1424599840, 1424599847, 'GB', 'GBR', 'المملكة المتحدة'),
(22554, 1424599848, 1424599855, 'HU', 'HUN', 'هنغاريا'),
(22555, 1424599856, 1424599871, 'GB', 'GBR', 'المملكة المتحدة'),
(22556, 1424599872, 1424599875, 'HU', 'HUN', 'هنغاريا'),
(22557, 1424599876, 1424599879, 'GB', 'GBR', 'المملكة المتحدة'),
(22558, 1424599880, 1424599887, 'HU', 'HUN', 'هنغاريا'),
(22559, 1424599888, 1424599903, 'GB', 'GBR', 'المملكة المتحدة'),
(22560, 1424599904, 1424599951, 'HU', 'HUN', 'هنغاريا'),
(22561, 1424599952, 1424599999, 'GB', 'GBR', 'المملكة المتحدة'),
(22562, 1424600000, 1424600031, 'HU', 'HUN', 'هنغاريا'),
(22563, 1424600032, 1424600063, 'GB', 'GBR', 'المملكة المتحدة'),
(22564, 1424600064, 1424600319, 'CH', 'CHE', 'سويسرا'),
(22565, 1424600320, 1424600575, 'GB', 'GBR', 'المملكة المتحدة'),
(22566, 1424600576, 1424600831, 'FR', 'FRA', 'فرنسا'),
(22567, 1424600832, 1424601087, 'BE', 'BEL', 'بلجيكا'),
(22568, 1424601088, 1424601343, 'GB', 'GBR', 'المملكة المتحدة'),
(22569, 1424601344, 1424601599, 'ES', 'ESP', 'إسبانيا'),
(22570, 1424601600, 1424601855, 'CH', 'CHE', 'سويسرا'),
(22571, 1424601856, 1424602111, 'GB', 'GBR', 'المملكة المتحدة'),
(22572, 1424602112, 1424602623, 'DE', 'DEU', 'ألمانيا'),
(22573, 1424602624, 1424602879, 'GB', 'GBR', 'المملكة المتحدة'),
(22574, 1424602880, 1424602911, 'US', 'USA', 'الولايات المتحدة'),
(22575, 1424602912, 1424602927, 'FR', 'FRA', 'فرنسا'),
(22576, 1424602928, 1424603007, 'US', 'USA', 'الولايات المتحدة'),
(22577, 1424603008, 1424603023, 'GB', 'GBR', 'المملكة المتحدة'),
(22578, 1424603024, 1424603055, 'US', 'USA', 'الولايات المتحدة'),
(22579, 1424603056, 1424603063, 'NL', 'NLD', 'هولندا'),
(22580, 1424603064, 1424603087, 'US', 'USA', 'الولايات المتحدة'),
(22581, 1424603088, 1424603095, 'GB', 'GBR', 'المملكة المتحدة'),
(22582, 1424603096, 1424603135, 'US', 'USA', 'الولايات المتحدة'),
(22583, 1424603136, 1424603391, 'SK', 'SVK', 'سلوفاكيا'),
(22584, 1424603392, 1424603647, 'DE', 'DEU', 'ألمانيا'),
(22585, 1424603648, 1424603903, 'GB', 'GBR', 'المملكة المتحدة'),
(22586, 1424603904, 1424604159, 'ES', 'ESP', 'إسبانيا'),
(22587, 1424604160, 1424604463, 'NL', 'NLD', 'هولندا'),
(22588, 1424604464, 1424604479, 'GB', 'GBR', 'المملكة المتحدة'),
(22589, 1424604480, 1424604543, 'NL', 'NLD', 'هولندا'),
(22590, 1424604544, 1424604671, 'GB', 'GBR', 'المملكة المتحدة'),
(22591, 1424604672, 1424604799, 'NL', 'NLD', 'هولندا'),
(22592, 1424604800, 1424604927, 'GB', 'GBR', 'المملكة المتحدة'),
(22593, 1424604928, 1424605119, 'NL', 'NLD', 'هولندا'),
(22594, 1424605120, 1424605151, 'GB', 'GBR', 'المملكة المتحدة'),
(22595, 1424605152, 1424605183, 'NL', 'NLD', 'هولندا'),
(22596, 1424605184, 1424605439, 'GB', 'GBR', 'المملكة المتحدة'),
(22597, 1424605440, 1424605583, 'BG', 'BGR', 'بلغاريا'),
(22598, 1424605584, 1424605607, 'GB', 'GBR', 'المملكة المتحدة'),
(22599, 1424605608, 1424605623, 'BG', 'BGR', 'بلغاريا'),
(22600, 1424605624, 1424605631, 'GB', 'GBR', 'المملكة المتحدة'),
(22601, 1424605632, 1424605695, 'BG', 'BGR', 'بلغاريا'),
(22602, 1424605696, 1424605951, 'NL', 'NLD', 'هولندا'),
(22603, 1424605952, 1424605959, 'CH', 'CHE', 'سويسرا'),
(22604, 1424605960, 1424606023, 'AT', 'AUT', 'النمسا'),
(22605, 1424606024, 1424606199, 'GB', 'GBR', 'المملكة المتحدة'),
(22606, 1424606200, 1424606207, 'AT', 'AUT', 'النمسا'),
(22607, 1424606208, 1424606455, 'GB', 'GBR', 'المملكة المتحدة'),
(22608, 1424606456, 1424606463, 'AT', 'AUT', 'النمسا'),
(22609, 1424606464, 1424606711, 'GB', 'GBR', 'المملكة المتحدة'),
(22610, 1424606712, 1424606719, 'AT', 'AUT', 'النمسا'),
(22611, 1424606720, 1424606967, 'GB', 'GBR', 'المملكة المتحدة'),
(22612, 1424606968, 1424606975, 'AT', 'AUT', 'النمسا'),
(22613, 1424606976, 1424607103, 'GB', 'GBR', 'المملكة المتحدة'),
(22614, 1424607104, 1424607119, 'SK', 'SVK', 'سلوفاكيا'),
(22615, 1424607120, 1424607167, 'GB', 'GBR', 'المملكة المتحدة'),
(22616, 1424607168, 1424607199, 'SK', 'SVK', 'سلوفاكيا'),
(22617, 1424607200, 1424607215, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(22618, 1424607216, 1424607231, 'SK', 'SVK', 'سلوفاكيا'),
(22619, 1424607232, 1424607487, 'GB', 'GBR', 'المملكة المتحدة'),
(22620, 1424607488, 1424607871, 'DE', 'DEU', 'ألمانيا'),
(22621, 1424607872, 1424608031, 'GB', 'GBR', 'المملكة المتحدة'),
(22622, 1424608032, 1424608083, 'FR', 'FRA', 'فرنسا'),
(22623, 1424608084, 1424608095, 'GB', 'GBR', 'المملكة المتحدة'),
(22624, 1424608096, 1424608127, 'FR', 'FRA', 'فرنسا'),
(22625, 1424608128, 1424608279, 'GB', 'GBR', 'المملكة المتحدة'),
(22626, 1424608280, 1424608383, 'FR', 'FRA', 'فرنسا'),
(22627, 1424608384, 1424608399, 'ES', 'ESP', 'إسبانيا'),
(22628, 1424608400, 1424608511, 'FR', 'FRA', 'فرنسا'),
(22629, 1424608512, 1424608562, 'ES', 'ESP', 'إسبانيا'),
(22630, 1424608563, 1424608639, 'GB', 'GBR', 'المملكة المتحدة'),
(22631, 1424608640, 1424608687, 'ES', 'ESP', 'إسبانيا'),
(22632, 1424608688, 1424608695, 'GB', 'GBR', 'المملكة المتحدة'),
(22633, 1424608696, 1424608703, 'ES', 'ESP', 'إسبانيا'),
(22634, 1424608704, 1424608719, 'GB', 'GBR', 'المملكة المتحدة'),
(22635, 1424608720, 1424609023, 'ES', 'ESP', 'إسبانيا'),
(22636, 1424609024, 1424609259, 'DE', 'DEU', 'ألمانيا'),
(22637, 1424609260, 1424609271, 'GB', 'GBR', 'المملكة المتحدة'),
(22638, 1424609272, 1424609279, 'DE', 'DEU', 'ألمانيا'),
(22639, 1424609280, 1424609395, 'CH', 'CHE', 'سويسرا'),
(22640, 1424609396, 1424609399, 'GB', 'GBR', 'المملكة المتحدة'),
(22641, 1424609400, 1424609791, 'CH', 'CHE', 'سويسرا'),
(22642, 1424609792, 1424610303, 'GB', 'GBR', 'المملكة المتحدة'),
(22643, 1424610304, 1424610559, 'TZ', 'TZA', 'تانزانيا'),
(22644, 1424610560, 1424610815, 'PL', 'POL', 'بولندا'),
(22645, 1424610816, 1424611071, 'FR', 'FRA', 'فرنسا'),
(22646, 1424611072, 1424611143, 'BE', 'BEL', 'بلجيكا'),
(22647, 1424611144, 1424611151, 'GB', 'GBR', 'المملكة المتحدة'),
(22648, 1424611152, 1424611327, 'BE', 'BEL', 'بلجيكا'),
(22649, 1424611328, 1424611583, 'PL', 'POL', 'بولندا'),
(22650, 1424611584, 1424612095, 'GB', 'GBR', 'المملكة المتحدة'),
(22651, 1424612096, 1424612231, 'CZ', 'CZE', 'التشيك'),
(22652, 1424612232, 1424612239, 'CH', 'CHE', 'سويسرا'),
(22653, 1424612240, 1424612319, 'CZ', 'CZE', 'التشيك'),
(22654, 1424612320, 1424612607, 'GB', 'GBR', 'المملكة المتحدة'),
(22655, 1424612608, 1424612671, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22656, 1424612672, 1424612863, 'GB', 'GBR', 'المملكة المتحدة'),
(22657, 1424612864, 1424613119, 'FR', 'FRA', 'فرنسا'),
(22658, 1424613120, 1424613375, 'GB', 'GBR', 'المملكة المتحدة'),
(22659, 1424613376, 1424613631, 'ES', 'ESP', 'إسبانيا'),
(22660, 1424613632, 1424614103, 'IT', 'ITA', 'إيطاليا'),
(22661, 1424614104, 1424614111, 'GB', 'GBR', 'المملكة المتحدة'),
(22662, 1424614112, 1424614127, 'IT', 'ITA', 'إيطاليا'),
(22663, 1424614128, 1424614399, 'GB', 'GBR', 'المملكة المتحدة'),
(22664, 1424614400, 1424614415, 'FR', 'FRA', 'فرنسا'),
(22665, 1424614416, 1424614439, 'IT', 'ITA', 'إيطاليا'),
(22666, 1424614440, 1424614447, 'GB', 'GBR', 'المملكة المتحدة'),
(22667, 1424614448, 1424614655, 'IT', 'ITA', 'إيطاليا'),
(22668, 1424614656, 1424614911, 'FR', 'FRA', 'فرنسا'),
(22669, 1424614912, 1424615167, 'RO', 'ROM', 'رومانيا'),
(22670, 1424615168, 1424615679, 'GB', 'GBR', 'المملكة المتحدة'),
(22671, 1424615680, 1424615803, 'IT', 'ITA', 'إيطاليا'),
(22672, 1424615804, 1424615807, 'GB', 'GBR', 'المملكة المتحدة'),
(22673, 1424615808, 1424615935, 'IT', 'ITA', 'إيطاليا'),
(22674, 1424615936, 1424616191, 'FR', 'FRA', 'فرنسا'),
(22675, 1424616192, 1424616447, 'IT', 'ITA', 'إيطاليا'),
(22676, 1424616448, 1424616483, 'ES', 'ESP', 'إسبانيا'),
(22677, 1424616484, 1424616487, 'GB', 'GBR', 'المملكة المتحدة'),
(22678, 1424616488, 1424616607, 'ES', 'ESP', 'إسبانيا'),
(22679, 1424616608, 1424616615, 'PT', 'PRT', 'البورتوغال'),
(22680, 1424616616, 1424616623, 'GB', 'GBR', 'المملكة المتحدة'),
(22681, 1424616624, 1424616687, 'ES', 'ESP', 'إسبانيا'),
(22682, 1424616688, 1424616695, 'PT', 'PRT', 'البورتوغال'),
(22683, 1424616696, 1424616703, 'GB', 'GBR', 'المملكة المتحدة'),
(22684, 1424616704, 1424616959, 'US', 'USA', 'الولايات المتحدة'),
(22685, 1424616960, 1424617215, 'FR', 'FRA', 'فرنسا'),
(22686, 1424617216, 1424617343, 'IT', 'ITA', 'إيطاليا'),
(22687, 1424617344, 1424617391, 'GB', 'GBR', 'المملكة المتحدة'),
(22688, 1424617392, 1424617395, 'IT', 'ITA', 'إيطاليا'),
(22689, 1424617396, 1424617399, 'GB', 'GBR', 'المملكة المتحدة'),
(22690, 1424617400, 1424617407, 'IT', 'ITA', 'إيطاليا'),
(22691, 1424617408, 1424617423, 'ES', 'ESP', 'إسبانيا'),
(22692, 1424617424, 1424617431, 'GB', 'GBR', 'المملكة المتحدة'),
(22693, 1424617432, 1424617439, 'ES', 'ESP', 'إسبانيا'),
(22694, 1424617440, 1424617463, 'IT', 'ITA', 'إيطاليا'),
(22695, 1424617464, 1424617471, 'GB', 'GBR', 'المملكة المتحدة'),
(22696, 1424617472, 1424617727, 'US', 'USA', 'الولايات المتحدة'),
(22697, 1424617728, 1424618239, 'IT', 'ITA', 'إيطاليا'),
(22698, 1424618240, 1424618495, 'NL', 'NLD', 'هولندا'),
(22699, 1424618496, 1424618751, 'GB', 'GBR', 'المملكة المتحدة'),
(22700, 1424618752, 1424618983, 'FR', 'FRA', 'فرنسا'),
(22701, 1424618984, 1424618991, 'GB', 'GBR', 'المملكة المتحدة'),
(22702, 1424618992, 1424619007, 'FR', 'FRA', 'فرنسا'),
(22703, 1424619008, 1424619775, 'IT', 'ITA', 'إيطاليا'),
(22704, 1424619776, 1424619807, 'BE', 'BEL', 'بلجيكا'),
(22705, 1424619808, 1424619815, 'GB', 'GBR', 'المملكة المتحدة'),
(22706, 1424619816, 1424619823, 'BE', 'BEL', 'بلجيكا'),
(22707, 1424619824, 1424619839, 'GB', 'GBR', 'المملكة المتحدة'),
(22708, 1424619840, 1424619915, 'BE', 'BEL', 'بلجيكا'),
(22709, 1424619916, 1424619919, 'GB', 'GBR', 'المملكة المتحدة'),
(22710, 1424619920, 1424620031, 'BE', 'BEL', 'بلجيكا'),
(22711, 1424620032, 1424621055, 'GB', 'GBR', 'المملكة المتحدة'),
(22712, 1424621056, 1424621567, 'IT', 'ITA', 'إيطاليا'),
(22713, 1424621568, 1424625663, 'PL', 'POL', 'بولندا'),
(22714, 1424625664, 1424629759, 'GB', 'GBR', 'المملكة المتحدة'),
(22715, 1424629760, 1424633855, 'PL', 'POL', 'بولندا'),
(22716, 1424633856, 1424637951, 'MD', 'MDA', 'مولدوفا'),
(22717, 1424637952, 1424642047, 'FI', 'FIN', 'فنلندا'),
(22718, 1424642048, 1424646143, 'DK', 'DNK', 'الدنيمارك'),
(22719, 1424646144, 1424650239, 'RO', 'ROM', 'رومانيا'),
(22720, 1424650240, 1424654335, 'PL', 'POL', 'بولندا'),
(22721, 1424654336, 1424687103, 'NO', 'NOR', 'النرويج'),
(22722, 1424687104, 1424711679, 'SA', 'SAU', 'السعودية'),
(22723, 1424711680, 1424713727, 'BH', 'BHR', 'البحرين'),
(22724, 1424713728, 1424719871, 'SA', 'SAU', 'السعودية'),
(22725, 1424719872, 1424722431, 'IE', 'IRL', 'إيرلندا'),
(22726, 1424722432, 1424723199, 'CZ', 'CZE', 'التشيك'),
(22727, 1424723200, 1424724735, 'DE', 'DEU', 'ألمانيا'),
(22728, 1424724736, 1424724991, 'IE', 'IRL', 'إيرلندا'),
(22729, 1424724992, 1424727039, 'GB', 'GBR', 'المملكة المتحدة'),
(22730, 1424727040, 1424727295, 'IE', 'IRL', 'إيرلندا'),
(22731, 1424727296, 1424727551, 'SL', 'SLE', 'سيراليون'),
(22732, 1424727552, 1424728063, 'PL', 'POL', 'بولندا'),
(22733, 1424728064, 1424728319, 'IE', 'IRL', 'إيرلندا'),
(22734, 1424728320, 1424729855, 'FR', 'FRA', 'فرنسا'),
(22735, 1424729856, 1424730367, 'DE', 'DEU', 'ألمانيا'),
(22736, 1424730368, 1424730623, 'ES', 'ESP', 'إسبانيا'),
(22737, 1424730624, 1424730879, 'GB', 'GBR', 'المملكة المتحدة'),
(22738, 1424730880, 1424733183, 'IE', 'IRL', 'إيرلندا'),
(22739, 1424733184, 1424733951, 'NL', 'NLD', 'هولندا'),
(22740, 1424733952, 1424735103, 'SE', 'SWE', 'السويد'),
(22741, 1424735104, 1424736127, 'DE', 'DEU', 'ألمانيا'),
(22742, 1424736128, 1424736383, 'AT', 'AUT', 'النمسا'),
(22743, 1424736384, 1424736895, 'FR', 'FRA', 'فرنسا'),
(22744, 1424736896, 1424737151, 'DE', 'DEU', 'ألمانيا'),
(22745, 1424737152, 1424737279, 'GB', 'GBR', 'المملكة المتحدة'),
(22746, 1424737280, 1424737407, 'DK', 'DNK', 'الدنيمارك'),
(22747, 1424737408, 1424737535, 'AT', 'AUT', 'النمسا'),
(22748, 1424737536, 1424738815, 'DE', 'DEU', 'ألمانيا'),
(22749, 1424738816, 1424739583, 'SE', 'SWE', 'السويد'),
(22750, 1424739584, 1424739839, 'GB', 'GBR', 'المملكة المتحدة'),
(22751, 1424739840, 1424740511, 'DE', 'DEU', 'ألمانيا'),
(22752, 1424740512, 1424740551, 'GB', 'GBR', 'المملكة المتحدة'),
(22753, 1424740552, 1424741119, 'DE', 'DEU', 'ألمانيا'),
(22754, 1424741120, 1424741375, 'IE', 'IRL', 'إيرلندا'),
(22755, 1424741376, 1424742911, 'DE', 'DEU', 'ألمانيا'),
(22756, 1424742912, 1424743167, 'IE', 'IRL', 'إيرلندا'),
(22757, 1424743168, 1424743423, 'IT', 'ITA', 'إيطاليا'),
(22758, 1424743424, 1424743935, 'DE', 'DEU', 'ألمانيا'),
(22759, 1424743936, 1424744191, 'GB', 'GBR', 'المملكة المتحدة'),
(22760, 1424744192, 1424744703, 'DE', 'DEU', 'ألمانيا'),
(22761, 1424744704, 1424744959, 'GB', 'GBR', 'المملكة المتحدة'),
(22762, 1424744960, 1424746495, 'DE', 'DEU', 'ألمانيا'),
(22763, 1424746496, 1424749055, 'IE', 'IRL', 'إيرلندا'),
(22764, 1424749056, 1424749311, 'SL', 'SLE', 'سيراليون'),
(22765, 1424749312, 1424750079, 'DE', 'DEU', 'ألمانيا'),
(22766, 1424750080, 1424750335, 'FR', 'FRA', 'فرنسا'),
(22767, 1424750336, 1424750591, 'GB', 'GBR', 'المملكة المتحدة'),
(22768, 1424750592, 1424750847, 'FR', 'FRA', 'فرنسا'),
(22769, 1424750848, 1424751103, 'IE', 'IRL', 'إيرلندا'),
(22770, 1424751104, 1424751359, 'DE', 'DEU', 'ألمانيا'),
(22771, 1424751360, 1424751615, 'AT', 'AUT', 'النمسا'),
(22772, 1424751616, 1424752127, 'IE', 'IRL', 'إيرلندا'),
(22773, 1424752128, 1424752383, 'DE', 'DEU', 'ألمانيا'),
(22774, 1424752384, 1424752639, 'NL', 'NLD', 'هولندا'),
(22775, 1424752640, 1424784383, 'HU', 'HUN', 'هنغاريا'),
(22776, 1424784384, 1424785407, 'RS', 'SRB', 'صربيا'),
(22777, 1424785408, 1424818175, 'ES', 'ESP', 'إسبانيا'),
(22778, 1424818176, 1424850943, 'RU', 'RUS', 'الإتحاد الروسي'),
(22779, 1424850944, 1424883711, 'LV', 'LVA', 'لاتفيا'),
(22780, 1424883712, 1424916479, 'DK', 'DNK', 'الدنيمارك'),
(22781, 1424916480, 1424949247, 'BG', 'BGR', 'بلغاريا'),
(22782, 1424949248, 1424982015, 'GB', 'GBR', 'المملكة المتحدة'),
(22783, 1424982016, 1425014783, 'FI', 'FIN', 'فنلندا'),
(22784, 1425014784, 1425031167, 'LT', 'LTU', 'ليتوانيا'),
(22785, 1425031168, 1425047551, 'FI', 'FIN', 'فنلندا'),
(22786, 1425047552, 1425063935, 'IT', 'ITA', 'إيطاليا'),
(22787, 1425063936, 1425080319, 'KZ', 'KAZ', 'كازاخستان'),
(22788, 1425080320, 1425096703, 'IR', 'IRN', 'إيران'),
(22789, 1425096704, 1425113087, 'CH', 'CHE', 'سويسرا'),
(22790, 1425113088, 1425145855, 'NL', 'NLD', 'هولندا'),
(22791, 1425145856, 1425162239, 'RU', 'RUS', 'الإتحاد الروسي'),
(22792, 1425162240, 1425178623, 'CZ', 'CZE', 'التشيك'),
(22793, 1425178624, 1425195007, 'BG', 'BGR', 'بلغاريا'),
(22794, 1425195008, 1425211391, 'RU', 'RUS', 'الإتحاد الروسي'),
(22795, 1425211392, 1425227775, 'SE', 'SWE', 'السويد'),
(22796, 1425227776, 1425244159, 'RO', 'ROM', 'رومانيا'),
(22797, 1425244160, 1425260543, 'NO', 'NOR', 'النرويج'),
(22798, 1425260544, 1425276927, 'NL', 'NLD', 'هولندا'),
(22799, 1425293312, 1425309695, 'CZ', 'CZE', 'التشيك'),
(22800, 1425309696, 1425326079, 'NL', 'NLD', 'هولندا'),
(22801, 1425326080, 1425342463, 'SE', 'SWE', 'السويد'),
(22802, 1425342464, 1425358847, 'NL', 'NLD', 'هولندا'),
(22803, 1425358848, 1425375231, 'SK', 'SVK', 'سلوفاكيا'),
(22804, 1425375232, 1425391615, 'DE', 'DEU', 'ألمانيا'),
(22805, 1425391616, 1425407999, 'LV', 'LVA', 'لاتفيا'),
(22806, 1425408000, 1425424383, 'NL', 'NLD', 'هولندا'),
(22807, 1425424384, 1425424639, 'DE', 'DEU', 'ألمانيا'),
(22808, 1425424640, 1425424895, 'IR', 'IRN', 'إيران'),
(22809, 1425424896, 1425425151, 'NE', 'NER', 'النيجر'),
(22810, 1425425152, 1425425663, 'DE', 'DEU', 'ألمانيا'),
(22811, 1425425664, 1425425919, 'NE', 'NER', 'النيجر'),
(22812, 1425425920, 1425426303, 'DE', 'DEU', 'ألمانيا'),
(22813, 1425426304, 1425426319, 'IR', 'IRN', 'إيران'),
(22814, 1425426320, 1425426343, 'DE', 'DEU', 'ألمانيا'),
(22815, 1425426344, 1425426352, 'IR', 'IRN', 'إيران'),
(22816, 1425426353, 1425426431, 'DE', 'DEU', 'ألمانيا'),
(22817, 1425426432, 1425428479, 'KW', 'KWT', 'الكويت'),
(22818, 1425428480, 1425430527, 'GB', 'GBR', 'المملكة المتحدة'),
(22819, 1425430528, 1425432575, 'SE', 'SWE', 'السويد'),
(22820, 1425432576, 1425434623, 'IT', 'ITA', 'إيطاليا'),
(22821, 1425434624, 1425436671, 'FR', 'FRA', 'فرنسا'),
(22822, 1425436672, 1425438719, 'GB', 'GBR', 'المملكة المتحدة'),
(22823, 1425438720, 1425439271, 'DE', 'DEU', 'ألمانيا'),
(22824, 1425439272, 1425439279, 'CZ', 'CZE', 'التشيك'),
(22825, 1425439280, 1425439535, 'DE', 'DEU', 'ألمانيا'),
(22826, 1425439536, 1425439543, 'CZ', 'CZE', 'التشيك'),
(22827, 1425439544, 1425439711, 'DE', 'DEU', 'ألمانيا'),
(22828, 1425439712, 1425439727, 'CZ', 'CZE', 'التشيك'),
(22829, 1425439728, 1425440767, 'DE', 'DEU', 'ألمانيا'),
(22830, 1425440768, 1425442815, 'SE', 'SWE', 'السويد'),
(22831, 1425442816, 1425444863, 'GB', 'GBR', 'المملكة المتحدة'),
(22832, 1425444864, 1425445126, 'IT', 'ITA', 'إيطاليا'),
(22833, 1425445127, 1425445127, 'FR', 'FRA', 'فرنسا'),
(22834, 1425445128, 1425445139, 'IT', 'ITA', 'إيطاليا'),
(22835, 1425445140, 1425445141, 'GB', 'GBR', 'المملكة المتحدة'),
(22836, 1425445142, 1425446911, 'IT', 'ITA', 'إيطاليا'),
(22837, 1425446912, 1425448959, 'GB', 'GBR', 'المملكة المتحدة'),
(22838, 1425448960, 1425451007, 'CZ', 'CZE', 'التشيك'),
(22839, 1425451008, 1425457855, 'GB', 'GBR', 'المملكة المتحدة'),
(22840, 1425457856, 1425457919, 'US', 'USA', 'الولايات المتحدة'),
(22841, 1425457920, 1425458271, 'GB', 'GBR', 'المملكة المتحدة'),
(22842, 1425458272, 1425458303, 'US', 'USA', 'الولايات المتحدة'),
(22843, 1425458304, 1425461247, 'GB', 'GBR', 'المملكة المتحدة'),
(22844, 1425461248, 1425463295, 'ES', 'ESP', 'إسبانيا'),
(22845, 1425463296, 1425467135, 'FR', 'FRA', 'فرنسا'),
(22846, 1425467136, 1425467391, 'ES', 'ESP', 'إسبانيا'),
(22847, 1425467392, 1425469439, 'CH', 'CHE', 'سويسرا'),
(22848, 1425469440, 1425471487, 'DK', 'DNK', 'الدنيمارك'),
(22849, 1425471488, 1425473535, 'DE', 'DEU', 'ألمانيا'),
(22850, 1425473536, 1425506303, 'RO', 'ROM', 'رومانيا'),
(22851, 1425506304, 1425522687, 'NO', 'NOR', 'النرويج'),
(22852, 1425522688, 1425539071, 'IT', 'ITA', 'إيطاليا'),
(22853, 1425539072, 1425801215, 'FI', 'FIN', 'فنلندا'),
(22854, 1425801216, 1425817599, 'BG', 'BGR', 'بلغاريا'),
(22855, 1425817600, 1425833983, 'DE', 'DEU', 'ألمانيا'),
(22856, 1425833984, 1425850367, 'RU', 'RUS', 'الإتحاد الروسي'),
(22857, 1425850368, 1425866751, 'GB', 'GBR', 'المملكة المتحدة'),
(22858, 1425866752, 1425883135, 'CH', 'CHE', 'سويسرا'),
(22859, 1425883136, 1425899519, 'RU', 'RUS', 'الإتحاد الروسي'),
(22860, 1425899520, 1425915903, 'IT', 'ITA', 'إيطاليا'),
(22861, 1425915904, 1425932287, 'FI', 'FIN', 'فنلندا'),
(22862, 1425932288, 1425948671, 'GR', 'GRC', 'اليونان'),
(22863, 1425948672, 1425965055, 'DE', 'DEU', 'ألمانيا'),
(22864, 1425965056, 1425965100, 'ES', 'ESP', 'إسبانيا'),
(22865, 1425965101, 1425965112, 'FR', 'FRA', 'فرنسا'),
(22866, 1425965113, 1425965116, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(22867, 1425965117, 1425965120, 'FR', 'FRA', 'فرنسا'),
(22868, 1425965121, 1425965503, 'IT', 'ITA', 'إيطاليا'),
(22869, 1425965504, 1425965567, 'FR', 'FRA', 'فرنسا'),
(22870, 1425965568, 1425965568, 'IT', 'ITA', 'إيطاليا'),
(22871, 1425965569, 1425965572, 'NG', 'NGA', 'نيجيريا'),
(22872, 1425965573, 1425965576, 'US', 'USA', 'الولايات المتحدة'),
(22873, 1425965577, 1425965580, 'FR', 'FRA', 'فرنسا'),
(22874, 1425965581, 1425965584, 'BJ', 'BEN', 'بنين'),
(22875, 1425965585, 1425965588, 'ES', 'ESP', 'إسبانيا'),
(22876, 1425965589, 1425965592, 'IT', 'ITA', 'إيطاليا'),
(22877, 1425965593, 1425965631, 'FR', 'FRA', 'فرنسا'),
(22878, 1425965632, 1425965952, 'IT', 'ITA', 'إيطاليا'),
(22879, 1425965953, 1425965992, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(22880, 1425965993, 1425966015, 'IT', 'ITA', 'إيطاليا'),
(22881, 1425966016, 1425966079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(22882, 1425966080, 1425966080, 'IT', 'ITA', 'إيطاليا'),
(22883, 1425966081, 1425966088, 'DE', 'DEU', 'ألمانيا'),
(22884, 1425966089, 1425966104, 'IT', 'ITA', 'إيطاليا'),
(22885, 1425966105, 1425966128, 'DE', 'DEU', 'ألمانيا'),
(22886, 1425966129, 1425966144, 'IT', 'ITA', 'إيطاليا'),
(22887, 1425966145, 1425966152, 'DE', 'DEU', 'ألمانيا'),
(22888, 1425966153, 1425966208, 'IT', 'ITA', 'إيطاليا'),
(22889, 1425966209, 1425966224, 'DE', 'DEU', 'ألمانيا'),
(22890, 1425966225, 1425966271, 'IT', 'ITA', 'إيطاليا'),
(22891, 1425966272, 1425966335, 'DE', 'DEU', 'ألمانيا'),
(22892, 1425966336, 1425966592, 'IT', 'ITA', 'إيطاليا'),
(22893, 1425966593, 1425966608, 'FR', 'FRA', 'فرنسا'),
(22894, 1425966609, 1425966720, 'IT', 'ITA', 'إيطاليا'),
(22895, 1425966721, 1425966728, 'BJ', 'BEN', 'بنين'),
(22896, 1425966729, 1425966735, 'IT', 'ITA', 'إيطاليا'),
(22897, 1425966736, 1425966751, 'BJ', 'BEN', 'بنين'),
(22898, 1425966752, 1425966784, 'IT', 'ITA', 'إيطاليا'),
(22899, 1425966785, 1425966808, 'BJ', 'BEN', 'بنين'),
(22900, 1425966809, 1425966815, 'IT', 'ITA', 'إيطاليا'),
(22901, 1425966816, 1425966847, 'BJ', 'BEN', 'بنين'),
(22902, 1425966848, 1425966852, 'IT', 'ITA', 'إيطاليا'),
(22903, 1425966853, 1425966896, 'DE', 'DEU', 'ألمانيا'),
(22904, 1425966897, 1425966911, 'IT', 'ITA', 'إيطاليا'),
(22905, 1425966912, 1425966975, 'DE', 'DEU', 'ألمانيا'),
(22906, 1425966976, 1425967039, 'IT', 'ITA', 'إيطاليا'),
(22907, 1425967040, 1425967103, 'DE', 'DEU', 'ألمانيا'),
(22908, 1425967104, 1425967104, 'IT', 'ITA', 'إيطاليا'),
(22909, 1425967105, 1425967120, 'TR', 'TUR', 'تركيا'),
(22910, 1425967121, 1425967876, 'IT', 'ITA', 'إيطاليا'),
(22911, 1425967877, 1425967892, 'DE', 'DEU', 'ألمانيا'),
(22912, 1425967893, 1425967896, 'IT', 'ITA', 'إيطاليا'),
(22913, 1425967897, 1425967904, 'DE', 'DEU', 'ألمانيا'),
(22914, 1425967905, 1425967912, 'IT', 'ITA', 'إيطاليا'),
(22915, 1425967913, 1425967924, 'DE', 'DEU', 'ألمانيا'),
(22916, 1425967925, 1425967928, 'IT', 'ITA', 'إيطاليا'),
(22917, 1425967929, 1425967940, 'DE', 'DEU', 'ألمانيا'),
(22918, 1425967941, 1425967999, 'IT', 'ITA', 'إيطاليا'),
(22919, 1425968000, 1425968127, 'DE', 'DEU', 'ألمانيا'),
(22920, 1425968128, 1425968383, 'IT', 'ITA', 'إيطاليا'),
(22921, 1425968384, 1425968638, 'GB', 'GBR', 'المملكة المتحدة'),
(22922, 1425968639, 1425969663, 'IT', 'ITA', 'إيطاليا'),
(22923, 1425969664, 1425969727, 'FR', 'FRA', 'فرنسا'),
(22924, 1425969728, 1425969791, 'IT', 'ITA', 'إيطاليا'),
(22925, 1425969792, 1425969855, 'FR', 'FRA', 'فرنسا'),
(22926, 1425969856, 1425969919, 'IT', 'ITA', 'إيطاليا'),
(22927, 1425969920, 1425969983, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(22928, 1425969984, 1425970047, 'IT', 'ITA', 'إيطاليا'),
(22929, 1425970048, 1425970111, 'DE', 'DEU', 'ألمانيا'),
(22930, 1425970112, 1425970176, 'IT', 'ITA', 'إيطاليا'),
(22931, 1425970177, 1425970180, 'DE', 'DEU', 'ألمانيا'),
(22932, 1425970181, 1425970184, 'IT', 'ITA', 'إيطاليا'),
(22933, 1425970185, 1425970188, 'GB', 'GBR', 'المملكة المتحدة'),
(22934, 1425970189, 1425970192, 'DE', 'DEU', 'ألمانيا'),
(22935, 1425970193, 1425970239, 'GB', 'GBR', 'المملكة المتحدة'),
(22936, 1425970240, 1425970688, 'IT', 'ITA', 'إيطاليا'),
(22937, 1425970689, 1425970751, 'DE', 'DEU', 'ألمانيا'),
(22938, 1425970752, 1425971007, 'IT', 'ITA', 'إيطاليا'),
(22939, 1425971008, 1425971071, 'NL', 'NLD', 'هولندا'),
(22940, 1425971072, 1425971199, 'IT', 'ITA', 'إيطاليا'),
(22941, 1425971200, 1425971455, 'NL', 'NLD', 'هولندا'),
(22942, 1425971456, 1425971711, 'IT', 'ITA', 'إيطاليا'),
(22943, 1425971712, 1425971727, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(22944, 1425971728, 1425971743, 'US', 'USA', 'الولايات المتحدة'),
(22945, 1425971744, 1425971775, 'IT', 'ITA', 'إيطاليا'),
(22946, 1425971776, 1425971839, 'DE', 'DEU', 'ألمانيا'),
(22947, 1425971840, 1425971903, 'SE', 'SWE', 'السويد'),
(22948, 1425971904, 1425972351, 'IT', 'ITA', 'إيطاليا'),
(22949, 1425972352, 1425972415, 'FR', 'FRA', 'فرنسا'),
(22950, 1425972416, 1425972607, 'IT', 'ITA', 'إيطاليا'),
(22951, 1425972608, 1425972671, 'FR', 'FRA', 'فرنسا'),
(22952, 1425972672, 1425972863, 'IT', 'ITA', 'إيطاليا'),
(22953, 1425972864, 1425972927, 'FR', 'FRA', 'فرنسا'),
(22954, 1425972928, 1425973119, 'IT', 'ITA', 'إيطاليا'),
(22955, 1425973120, 1425973183, 'FR', 'FRA', 'فرنسا'),
(22956, 1425973184, 1425973248, 'IT', 'ITA', 'إيطاليا'),
(22957, 1425973249, 1425973260, 'PL', 'POL', 'بولندا'),
(22958, 1425973261, 1425973264, 'IT', 'ITA', 'إيطاليا'),
(22959, 1425973265, 1425973268, 'DE', 'DEU', 'ألمانيا'),
(22960, 1425973269, 1425973272, 'FR', 'FRA', 'فرنسا'),
(22961, 1425973273, 1425973276, 'PL', 'POL', 'بولندا'),
(22962, 1425973277, 1425973280, 'IT', 'ITA', 'إيطاليا'),
(22963, 1425973281, 1425973300, 'PL', 'POL', 'بولندا'),
(22964, 1425973301, 1425973308, 'DE', 'DEU', 'ألمانيا'),
(22965, 1425973309, 1425973332, 'PL', 'POL', 'بولندا'),
(22966, 1425973333, 1425973336, 'DE', 'DEU', 'ألمانيا'),
(22967, 1425973337, 1425973439, 'IT', 'ITA', 'إيطاليا'),
(22968, 1425973440, 1425973503, 'PL', 'POL', 'بولندا'),
(22969, 1425973504, 1425973759, 'IT', 'ITA', 'إيطاليا'),
(22970, 1425973760, 1425973823, 'PL', 'POL', 'بولندا'),
(22971, 1425973824, 1425974847, 'IT', 'ITA', 'إيطاليا'),
(22972, 1425974848, 1425974911, 'SE', 'SWE', 'السويد'),
(22973, 1425974912, 1425975039, 'IT', 'ITA', 'إيطاليا'),
(22974, 1425975040, 1425975103, 'FR', 'FRA', 'فرنسا'),
(22975, 1425975104, 1425975167, 'IT', 'ITA', 'إيطاليا'),
(22976, 1425975168, 1425975231, 'FR', 'FRA', 'فرنسا'),
(22977, 1425975232, 1425975296, 'IT', 'ITA', 'إيطاليا'),
(22978, 1425975297, 1425975360, 'PE', 'PER', 'بيرو'),
(22979, 1425975361, 1425975551, 'IT', 'ITA', 'إيطاليا'),
(22980, 1425975552, 1425975679, 'FR', 'FRA', 'فرنسا'),
(22981, 1425975680, 1425976064, 'IT', 'ITA', 'إيطاليا'),
(22982, 1425976065, 1425976126, 'FR', 'FRA', 'فرنسا'),
(22983, 1425976127, 1425976191, 'IT', 'ITA', 'إيطاليا'),
(22984, 1425976192, 1425976255, 'FR', 'FRA', 'فرنسا'),
(22985, 1425976256, 1425976320, 'IT', 'ITA', 'إيطاليا'),
(22986, 1425976321, 1425976328, 'FR', 'FRA', 'فرنسا'),
(22987, 1425976329, 1425976336, 'GB', 'GBR', 'المملكة المتحدة'),
(22988, 1425976337, 1425976344, 'IT', 'ITA', 'إيطاليا'),
(22989, 1425976345, 1425976352, 'FR', 'FRA', 'فرنسا'),
(22990, 1425976353, 1425976368, 'GB', 'GBR', 'المملكة المتحدة'),
(22991, 1425976369, 1425976372, 'FR', 'FRA', 'فرنسا'),
(22992, 1425976373, 1425976380, 'GB', 'GBR', 'المملكة المتحدة'),
(22993, 1425976381, 1425976388, 'FR', 'FRA', 'فرنسا'),
(22994, 1425976389, 1425976392, 'IT', 'ITA', 'إيطاليا'),
(22995, 1425976393, 1425976432, 'FR', 'FRA', 'فرنسا'),
(22996, 1425976433, 1425976440, 'GB', 'GBR', 'المملكة المتحدة'),
(22997, 1425976441, 1425976448, 'FR', 'FRA', 'فرنسا'),
(22998, 1425976449, 1425976464, 'GB', 'GBR', 'المملكة المتحدة'),
(22999, 1425976465, 1425976575, 'IT', 'ITA', 'إيطاليا'),
(23000, 1425976576, 1425976830, 'GB', 'GBR', 'المملكة المتحدة'),
(23001, 1425976831, 1425976831, 'IT', 'ITA', 'إيطاليا'),
(23002, 1425976832, 1425977342, 'GB', 'GBR', 'المملكة المتحدة'),
(23003, 1425977343, 1425977855, 'IT', 'ITA', 'إيطاليا'),
(23004, 1425977856, 1425978111, 'DE', 'DEU', 'ألمانيا'),
(23005, 1425978112, 1425978367, 'BG', 'BGR', 'بلغاريا'),
(23006, 1425978368, 1425979392, 'IT', 'ITA', 'إيطاليا'),
(23007, 1425979393, 1425979400, 'DE', 'DEU', 'ألمانيا'),
(23008, 1425979401, 1425979412, 'IT', 'ITA', 'إيطاليا'),
(23009, 1425979413, 1425979416, 'DE', 'DEU', 'ألمانيا'),
(23010, 1425979417, 1425979436, 'IT', 'ITA', 'إيطاليا'),
(23011, 1425979437, 1425979456, 'DE', 'DEU', 'ألمانيا'),
(23012, 1425979457, 1425979460, 'IT', 'ITA', 'إيطاليا'),
(23013, 1425979461, 1425979464, 'DE', 'DEU', 'ألمانيا'),
(23014, 1425979465, 1425979472, 'IT', 'ITA', 'إيطاليا'),
(23015, 1425979473, 1425979476, 'DE', 'DEU', 'ألمانيا'),
(23016, 1425979477, 1425979480, 'IT', 'ITA', 'إيطاليا'),
(23017, 1425979481, 1425979488, 'DE', 'DEU', 'ألمانيا'),
(23018, 1425979489, 1425979519, 'IT', 'ITA', 'إيطاليا'),
(23019, 1425979520, 1425979583, 'DE', 'DEU', 'ألمانيا'),
(23020, 1425979584, 1425979652, 'IT', 'ITA', 'إيطاليا'),
(23021, 1425979653, 1425979656, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(23022, 1425979657, 1425979660, 'IT', 'ITA', 'إيطاليا'),
(23023, 1425979661, 1425979692, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(23024, 1425979693, 1425979704, 'IT', 'ITA', 'إيطاليا'),
(23025, 1425979705, 1425979708, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(23026, 1425979709, 1425979711, 'IT', 'ITA', 'إيطاليا'),
(23027, 1425979712, 1425979775, 'DE', 'DEU', 'ألمانيا'),
(23028, 1425979776, 1425979839, 'US', 'USA', 'الولايات المتحدة'),
(23029, 1425979840, 1425979904, 'IT', 'ITA', 'إيطاليا'),
(23030, 1425979905, 1425979968, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(23031, 1425979969, 1425979976, 'IT', 'ITA', 'إيطاليا'),
(23032, 1425979977, 1425979984, 'FR', 'FRA', 'فرنسا'),
(23033, 1425979985, 1425979999, 'IT', 'ITA', 'إيطاليا'),
(23034, 1425980000, 1425980031, 'US', 'USA', 'الولايات المتحدة'),
(23035, 1425980032, 1425980095, 'DE', 'DEU', 'ألمانيا'),
(23036, 1425980096, 1425980159, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(23037, 1425980160, 1425980415, 'IT', 'ITA', 'إيطاليا'),
(23038, 1425980416, 1425980543, 'GB', 'GBR', 'المملكة المتحدة'),
(23039, 1425980544, 1425980607, 'GR', 'GRC', 'اليونان'),
(23040, 1425980608, 1425980927, 'GB', 'GBR', 'المملكة المتحدة'),
(23041, 1425980928, 1425981439, 'IT', 'ITA', 'إيطاليا'),
(23042, 1425981440, 1425997823, 'RU', 'RUS', 'الإتحاد الروسي'),
(23043, 1425997824, 1426014207, 'MT', 'MLT', 'مالطا'),
(23044, 1426014208, 1426030591, 'DK', 'DNK', 'الدنيمارك'),
(23045, 1426030592, 1426046975, 'BH', 'BHR', 'البحرين'),
(23046, 1426046976, 1426063359, 'SI', 'SVN', 'سلوفينيا'),
(23047, 1426063360, 1426587647, 'CH', 'CHE', 'سويسرا'),
(23048, 1426587648, 1426604031, 'SE', 'SWE', 'السويد'),
(23049, 1426604032, 1426620415, 'DE', 'DEU', 'ألمانيا'),
(23050, 1426620416, 1426653183, 'GB', 'GBR', 'المملكة المتحدة'),
(23051, 1426653184, 1426669567, 'RO', 'ROM', 'رومانيا'),
(23052, 1426669568, 1426685951, 'IR', 'IRN', 'إيران'),
(23053, 1426685952, 1426702335, 'TJ', 'TJK', 'طاجيكيستان'),
(23054, 1426702336, 1426703103, 'LV', 'LVA', 'لاتفيا'),
(23055, 1426703104, 1426703167, 'RU', 'RUS', 'الإتحاد الروسي'),
(23056, 1426703168, 1426718719, 'LV', 'LVA', 'لاتفيا'),
(23057, 1426718720, 1426731007, 'SI', 'SVN', 'سلوفينيا'),
(23058, 1426731008, 1426735103, 'HR', 'HRV', 'كرواتيا'),
(23059, 1426735104, 1426751487, 'BE', 'BEL', 'بلجيكا'),
(23060, 1426751488, 1426767871, 'FR', 'FRA', 'فرنسا'),
(23061, 1426767872, 1426784255, 'DE', 'DEU', 'ألمانيا'),
(23062, 1426784256, 1426800639, 'SE', 'SWE', 'السويد'),
(23063, 1426800640, 1426817023, 'PL', 'POL', 'بولندا'),
(23064, 1426817024, 1426833407, 'BG', 'BGR', 'بلغاريا'),
(23065, 1426833408, 1426849791, 'SE', 'SWE', 'السويد'),
(23066, 1426849792, 1426850303, 'NL', 'NLD', 'هولندا'),
(23067, 1426850304, 1426850335, 'SE', 'SWE', 'السويد'),
(23068, 1426850336, 1426850367, 'GB', 'GBR', 'المملكة المتحدة'),
(23069, 1426850368, 1426850463, 'NL', 'NLD', 'هولندا'),
(23070, 1426850464, 1426850495, 'GB', 'GBR', 'المملكة المتحدة'),
(23071, 1426850496, 1426851519, 'NL', 'NLD', 'هولندا'),
(23072, 1426851520, 1426851583, 'PA', 'PAN', 'بنما'),
(23073, 1426851584, 1426851839, 'NL', 'NLD', 'هولندا'),
(23074, 1426851840, 1426852095, 'SE', 'SWE', 'السويد'),
(23075, 1426852096, 1426852352, 'NL', 'NLD', 'هولندا'),
(23076, 1426852353, 1426852359, 'RU', 'RUS', 'الإتحاد الروسي'),
(23077, 1426852360, 1426852367, 'SE', 'SWE', 'السويد'),
(23078, 1426852368, 1426852383, 'US', 'USA', 'الولايات المتحدة'),
(23079, 1426852384, 1426852543, 'GB', 'GBR', 'المملكة المتحدة'),
(23080, 1426852544, 1426856447, 'NL', 'NLD', 'هولندا'),
(23081, 1426856448, 1426856703, 'ES', 'ESP', 'إسبانيا'),
(23082, 1426856704, 1426857472, 'NL', 'NLD', 'هولندا'),
(23083, 1426857473, 1426857500, 'ES', 'ESP', 'إسبانيا'),
(23084, 1426857501, 1426859263, 'NL', 'NLD', 'هولندا'),
(23085, 1426859264, 1426859519, 'RU', 'RUS', 'الإتحاد الروسي'),
(23086, 1426859520, 1426864511, 'NL', 'NLD', 'هولندا'),
(23087, 1426864512, 1426864639, 'PA', 'PAN', 'بنما'),
(23088, 1426864640, 1426864895, 'FR', 'FRA', 'فرنسا'),
(23089, 1426864896, 1426865151, 'NL', 'NLD', 'هولندا'),
(23090, 1426865152, 1426865407, 'BE', 'BEL', 'بلجيكا'),
(23091, 1426865408, 1426865663, 'NL', 'NLD', 'هولندا'),
(23092, 1426865664, 1426865919, 'BE', 'BEL', 'بلجيكا'),
(23093, 1426865920, 1426866175, 'ES', 'ESP', 'إسبانيا'),
(23094, 1426866176, 1426882559, 'GB', 'GBR', 'المملكة المتحدة'),
(23095, 1426882560, 1426898943, 'FR', 'FRA', 'فرنسا'),
(23096, 1426898944, 1426915327, 'RU', 'RUS', 'الإتحاد الروسي'),
(23097, 1426915328, 1426931711, 'AT', 'AUT', 'النمسا'),
(23098, 1426931712, 1426948095, 'CZ', 'CZE', 'التشيك'),
(23099, 1426948096, 1426964479, 'DE', 'DEU', 'ألمانيا'),
(23100, 1426964480, 1426967455, 'GB', 'GBR', 'المملكة المتحدة'),
(23101, 1426967456, 1426967463, 'ES', 'ESP', 'إسبانيا'),
(23102, 1426967464, 1426967567, 'GB', 'GBR', 'المملكة المتحدة'),
(23103, 1426967568, 1426967575, 'ES', 'ESP', 'إسبانيا'),
(23104, 1426967576, 1426967671, 'GB', 'GBR', 'المملكة المتحدة'),
(23105, 1426967672, 1426967679, 'ES', 'ESP', 'إسبانيا'),
(23106, 1426967680, 1426968447, 'GB', 'GBR', 'المملكة المتحدة'),
(23107, 1426968448, 1426968455, 'ES', 'ESP', 'إسبانيا'),
(23108, 1426968456, 1426968591, 'GB', 'GBR', 'المملكة المتحدة'),
(23109, 1426968592, 1426968600, 'ES', 'ESP', 'إسبانيا'),
(23110, 1426968601, 1426968791, 'GB', 'GBR', 'المملكة المتحدة'),
(23111, 1426968792, 1426968800, 'ES', 'ESP', 'إسبانيا'),
(23112, 1426968801, 1426969135, 'GB', 'GBR', 'المملكة المتحدة'),
(23113, 1426969136, 1426969151, 'ES', 'ESP', 'إسبانيا'),
(23114, 1426969152, 1426972319, 'GB', 'GBR', 'المملكة المتحدة'),
(23115, 1426972320, 1426972326, 'FR', 'FRA', 'فرنسا'),
(23116, 1426972327, 1426973335, 'GB', 'GBR', 'المملكة المتحدة'),
(23117, 1426973336, 1426973343, 'ES', 'ESP', 'إسبانيا'),
(23118, 1426973344, 1426976031, 'GB', 'GBR', 'المملكة المتحدة'),
(23119, 1426976032, 1426976047, 'ES', 'ESP', 'إسبانيا'),
(23120, 1426976048, 1426976111, 'GB', 'GBR', 'المملكة المتحدة'),
(23121, 1426976112, 1426976119, 'ES', 'ESP', 'إسبانيا'),
(23122, 1426976120, 1426978999, 'GB', 'GBR', 'المملكة المتحدة'),
(23123, 1426979000, 1426979007, 'ES', 'ESP', 'إسبانيا'),
(23124, 1426979008, 1426980863, 'GB', 'GBR', 'المملكة المتحدة'),
(23125, 1426980864, 1426997247, 'BG', 'BGR', 'بلغاريا'),
(23126, 1426997248, 1427013631, 'PL', 'POL', 'بولندا'),
(23127, 1427013632, 1427030015, 'FR', 'FRA', 'فرنسا'),
(23128, 1427030016, 1427031679, 'DE', 'DEU', 'ألمانيا'),
(23129, 1427031680, 1427031743, 'AT', 'AUT', 'النمسا'),
(23130, 1427031744, 1427031807, 'DE', 'DEU', 'ألمانيا'),
(23131, 1427031808, 1427032063, 'AT', 'AUT', 'النمسا'),
(23132, 1427032064, 1427032143, 'DE', 'DEU', 'ألمانيا'),
(23133, 1427032144, 1427032151, 'AT', 'AUT', 'النمسا'),
(23134, 1427032152, 1427032183, 'DE', 'DEU', 'ألمانيا'),
(23135, 1427032184, 1427032191, 'PL', 'POL', 'بولندا'),
(23136, 1427032192, 1427032223, 'DE', 'DEU', 'ألمانيا'),
(23137, 1427032224, 1427032231, 'GR', 'GRC', 'اليونان'),
(23138, 1427032232, 1427032735, 'DE', 'DEU', 'ألمانيا'),
(23139, 1427032736, 1427032743, 'AT', 'AUT', 'النمسا'),
(23140, 1427032744, 1427032959, 'DE', 'DEU', 'ألمانيا'),
(23141, 1427032960, 1427032967, 'NL', 'NLD', 'هولندا'),
(23142, 1427032968, 1427032991, 'DE', 'DEU', 'ألمانيا'),
(23143, 1427032992, 1427032999, 'CH', 'CHE', 'سويسرا'),
(23144, 1427033000, 1427033007, 'GR', 'GRC', 'اليونان'),
(23145, 1427033008, 1427033247, 'DE', 'DEU', 'ألمانيا'),
(23146, 1427033248, 1427033263, 'MZ', 'MOZ', 'موزامبيق'),
(23147, 1427033264, 1427033287, 'DE', 'DEU', 'ألمانيا'),
(23148, 1427033288, 1427033295, 'SE', 'SWE', 'السويد'),
(23149, 1427033296, 1427033335, 'DE', 'DEU', 'ألمانيا'),
(23150, 1427033336, 1427033343, 'TR', 'TUR', 'تركيا'),
(23151, 1427033344, 1427035391, 'DE', 'DEU', 'ألمانيا'),
(23152, 1427035392, 1427035519, 'GB', 'GBR', 'المملكة المتحدة'),
(23153, 1427035520, 1427046399, 'DE', 'DEU', 'ألمانيا'),
(23154, 1427046400, 1427062783, 'IR', 'IRN', 'إيران'),
(23155, 1427062784, 1427095551, 'RU', 'RUS', 'الإتحاد الروسي'),
(23156, 1427095552, 1427111935, 'LV', 'LVA', 'لاتفيا'),
(23157, 1427111936, 1427177471, 'DE', 'DEU', 'ألمانيا'),
(23158, 1427177472, 1427186367, 'NL', 'NLD', 'هولندا'),
(23159, 1427186368, 1427186431, 'BE', 'BEL', 'بلجيكا'),
(23160, 1427186432, 1427227135, 'NL', 'NLD', 'هولندا'),
(23161, 1427227136, 1427227647, 'US', 'USA', 'الولايات المتحدة'),
(23162, 1427227648, 1427227967, 'NL', 'NLD', 'هولندا'),
(23163, 1427227968, 1427227975, 'GB', 'GBR', 'المملكة المتحدة'),
(23164, 1427227976, 1427227983, 'DE', 'DEU', 'ألمانيا'),
(23165, 1427227984, 1427227991, 'IT', 'ITA', 'إيطاليا'),
(23166, 1427227992, 1427227999, 'ES', 'ESP', 'إسبانيا'),
(23167, 1427228000, 1427228007, 'PL', 'POL', 'بولندا'),
(23168, 1427228008, 1427228015, 'RU', 'RUS', 'الإتحاد الروسي'),
(23169, 1427228016, 1427228023, 'FR', 'FRA', 'فرنسا'),
(23170, 1427228024, 1427243007, 'NL', 'NLD', 'هولندا'),
(23171, 1427243008, 1427308543, 'IT', 'ITA', 'إيطاليا'),
(23172, 1427308544, 1427374079, 'NO', 'NOR', 'النرويج'),
(23173, 1427374080, 1427439615, 'IT', 'ITA', 'إيطاليا'),
(23174, 1427439616, 1427505151, 'RU', 'RUS', 'الإتحاد الروسي'),
(23175, 1427505152, 1427570687, 'DE', 'DEU', 'ألمانيا'),
(23176, 1427570688, 1427636223, 'FI', 'FIN', 'فنلندا'),
(23177, 1427636224, 1427668991, 'DK', 'DNK', 'الدنيمارك'),
(23178, 1427668992, 1427701759, 'SE', 'SWE', 'السويد'),
(23179, 1427701760, 1427723391, 'DE', 'DEU', 'ألمانيا'),
(23180, 1427723392, 1427723519, 'LI', 'LIE', 'ليختنشتاين'),
(23181, 1427723520, 1427728383, 'DE', 'DEU', 'ألمانيا'),
(23182, 1427728384, 1427728415, 'US', 'USA', 'الولايات المتحدة'),
(23183, 1427728416, 1427728479, 'DE', 'DEU', 'ألمانيا'),
(23184, 1427728480, 1427728511, 'CY', 'CYP', 'قبرص'),
(23185, 1427728512, 1427728543, 'BR', 'BRA', 'البرازيل'),
(23186, 1427728544, 1427728575, 'MD', 'MDA', 'مولدوفا'),
(23187, 1427728576, 1427728799, 'DE', 'DEU', 'ألمانيا'),
(23188, 1427728800, 1427728831, 'RU', 'RUS', 'الإتحاد الروسي'),
(23189, 1427728832, 1427728959, 'DE', 'DEU', 'ألمانيا'),
(23190, 1427728960, 1427728991, 'RU', 'RUS', 'الإتحاد الروسي'),
(23191, 1427728992, 1427729311, 'DE', 'DEU', 'ألمانيا'),
(23192, 1427729312, 1427729343, 'GR', 'GRC', 'اليونان'),
(23193, 1427729344, 1427742719, 'DE', 'DEU', 'ألمانيا'),
(23194, 1427742720, 1427742751, 'IO', 'IOT', 'إقليم المحيط الهندي البريطاني'),
(23195, 1427742752, 1427742847, 'DE', 'DEU', 'ألمانيا'),
(23196, 1427742848, 1427742879, 'CZ', 'CZE', 'التشيك'),
(23197, 1427742880, 1427743231, 'DE', 'DEU', 'ألمانيا'),
(23198, 1427743232, 1427743263, 'GR', 'GRC', 'اليونان'),
(23199, 1427743264, 1427743455, 'DE', 'DEU', 'ألمانيا'),
(23200, 1427743456, 1427743487, 'CY', 'CYP', 'قبرص'),
(23201, 1427743488, 1427743615, 'DE', 'DEU', 'ألمانيا'),
(23202, 1427743616, 1427743647, 'DK', 'DNK', 'الدنيمارك'),
(23203, 1427743648, 1427743839, 'DE', 'DEU', 'ألمانيا'),
(23204, 1427743840, 1427743871, 'IT', 'ITA', 'إيطاليا'),
(23205, 1427743872, 1427744159, 'DE', 'DEU', 'ألمانيا'),
(23206, 1427744160, 1427744191, 'RU', 'RUS', 'الإتحاد الروسي'),
(23207, 1427744192, 1427744255, 'DE', 'DEU', 'ألمانيا'),
(23208, 1427744256, 1427744287, 'US', 'USA', 'الولايات المتحدة'),
(23209, 1427744288, 1427744735, 'DE', 'DEU', 'ألمانيا'),
(23210, 1427744736, 1427744767, 'DK', 'DNK', 'الدنيمارك'),
(23211, 1427744768, 1427744863, 'DE', 'DEU', 'ألمانيا'),
(23212, 1427744864, 1427744895, 'TR', 'TUR', 'تركيا'),
(23213, 1427744896, 1427744991, 'DE', 'DEU', 'ألمانيا'),
(23214, 1427744992, 1427745023, 'DK', 'DNK', 'الدنيمارك'),
(23215, 1427745024, 1427745151, 'DE', 'DEU', 'ألمانيا'),
(23216, 1427745152, 1427745183, 'RO', 'ROM', 'رومانيا'),
(23217, 1427745184, 1427745535, 'DE', 'DEU', 'ألمانيا'),
(23218, 1427745536, 1427745567, 'CN', 'CHN', 'الصين'),
(23219, 1427745568, 1427745663, 'DE', 'DEU', 'ألمانيا'),
(23220, 1427745664, 1427745695, 'CY', 'CYP', 'قبرص'),
(23221, 1427745696, 1427746079, 'DE', 'DEU', 'ألمانيا'),
(23222, 1427746080, 1427746111, 'GB', 'GBR', 'المملكة المتحدة'),
(23223, 1427746112, 1427746239, 'DE', 'DEU', 'ألمانيا'),
(23224, 1427746240, 1427746271, 'TR', 'TUR', 'تركيا'),
(23225, 1427746272, 1427748447, 'DE', 'DEU', 'ألمانيا'),
(23226, 1427748448, 1427748479, 'TR', 'TUR', 'تركيا'),
(23227, 1427748480, 1427749567, 'DE', 'DEU', 'ألمانيا'),
(23228, 1427749568, 1427749599, 'CY', 'CYP', 'قبرص'),
(23229, 1427749600, 1427750303, 'DE', 'DEU', 'ألمانيا'),
(23230, 1427750304, 1427750335, 'BR', 'BRA', 'البرازيل'),
(23231, 1427750336, 1427751167, 'DE', 'DEU', 'ألمانيا'),
(23232, 1427751168, 1427751423, 'NL', 'NLD', 'هولندا'),
(23233, 1427751424, 1427759935, 'DE', 'DEU', 'ألمانيا'),
(23234, 1427759936, 1427759967, 'HR', 'HRV', 'كرواتيا'),
(23235, 1427759968, 1427760191, 'DE', 'DEU', 'ألمانيا'),
(23236, 1427760192, 1427760223, 'TR', 'TUR', 'تركيا'),
(23237, 1427760224, 1427760255, 'DE', 'DEU', 'ألمانيا'),
(23238, 1427760256, 1427760319, 'BR', 'BRA', 'البرازيل'),
(23239, 1427760320, 1427760351, 'DE', 'DEU', 'ألمانيا'),
(23240, 1427760352, 1427760383, 'DK', 'DNK', 'الدنيمارك'),
(23241, 1427760384, 1427760415, 'TR', 'TUR', 'تركيا'),
(23242, 1427760416, 1427760799, 'DE', 'DEU', 'ألمانيا'),
(23243, 1427760800, 1427760831, 'NL', 'NLD', 'هولندا'),
(23244, 1427760832, 1427760959, 'DE', 'DEU', 'ألمانيا'),
(23245, 1427760960, 1427760991, 'CZ', 'CZE', 'التشيك'),
(23246, 1427760992, 1427761023, 'DE', 'DEU', 'ألمانيا'),
(23247, 1427761024, 1427761055, 'CR', 'CRI', 'كوستا ريكا'),
(23248, 1427761056, 1427767295, 'DE', 'DEU', 'ألمانيا'),
(23249, 1427767296, 1427800063, 'BE', 'BEL', 'بلجيكا'),
(23250, 1427800064, 1427823615, 'RU', 'RUS', 'الإتحاد الروسي'),
(23251, 1427823616, 1427824639, 'KG', 'KGZ', 'قيرغيزستان'),
(23252, 1427824640, 1427831807, 'RU', 'RUS', 'الإتحاد الروسي'),
(23253, 1427831808, 1427832831, 'MD', 'MDA', 'مولدوفا'),
(23254, 1427832832, 1427865599, 'BE', 'BEL', 'بلجيكا'),
(23255, 1427865600, 1427898367, 'DK', 'DNK', 'الدنيمارك'),
(23256, 1427898368, 1427914751, 'RU', 'RUS', 'الإتحاد الروسي'),
(23257, 1427914752, 1427931135, 'BE', 'BEL', 'بلجيكا'),
(23258, 1427931136, 1427947519, 'PL', 'POL', 'بولندا'),
(23259, 1427947520, 1427963903, 'RU', 'RUS', 'الإتحاد الروسي'),
(23260, 1427963904, 1427980287, 'TR', 'TUR', 'تركيا'),
(23261, 1427980288, 1427996671, 'FI', 'FIN', 'فنلندا'),
(23262, 1427996672, 1428013055, 'KZ', 'KAZ', 'كازاخستان'),
(23263, 1428013056, 1428029439, 'EE', 'EST', 'إستونيا'),
(23264, 1428029440, 1428045823, 'GR', 'GRC', 'اليونان'),
(23265, 1428045824, 1428062207, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(23266, 1428062208, 1428078591, 'SE', 'SWE', 'السويد'),
(23267, 1428078592, 1428094975, 'RU', 'RUS', 'الإتحاد الروسي'),
(23268, 1428094976, 1428096031, 'AT', 'AUT', 'النمسا'),
(23269, 1428096032, 1428096039, 'CH', 'CHE', 'سويسرا'),
(23270, 1428096040, 1428103167, 'AT', 'AUT', 'النمسا'),
(23271, 1428103168, 1428119551, 'GB', 'GBR', 'المملكة المتحدة'),
(23272, 1428119552, 1428121599, 'LV', 'LVA', 'لاتفيا'),
(23273, 1428121600, 1428123647, 'FR', 'FRA', 'فرنسا'),
(23274, 1428123648, 1428126975, 'RU', 'RUS', 'الإتحاد الروسي'),
(23275, 1428126976, 1428127231, 'TR', 'TUR', 'تركيا'),
(23276, 1428127232, 1428127743, 'RU', 'RUS', 'الإتحاد الروسي'),
(23277, 1428127744, 1428129791, 'ES', 'ESP', 'إسبانيا'),
(23278, 1428129792, 1428131839, 'GB', 'GBR', 'المملكة المتحدة'),
(23279, 1428131840, 1428133887, 'FR', 'FRA', 'فرنسا'),
(23280, 1428133888, 1428135935, 'LI', 'LIE', 'ليختنشتاين'),
(23281, 1428135936, 1428137983, 'IT', 'ITA', 'إيطاليا'),
(23282, 1428137984, 1428140031, 'GB', 'GBR', 'المملكة المتحدة'),
(23283, 1428140032, 1428142079, 'RU', 'RUS', 'الإتحاد الروسي'),
(23284, 1428142080, 1428143263, 'DE', 'DEU', 'ألمانيا'),
(23285, 1428143264, 1428143279, 'CH', 'CHE', 'سويسرا'),
(23286, 1428143280, 1428144127, 'DE', 'DEU', 'ألمانيا'),
(23287, 1428144128, 1428147103, 'FR', 'FRA', 'فرنسا'),
(23288, 1428147104, 1428147119, 'SE', 'SWE', 'السويد'),
(23289, 1428147120, 1428147127, 'FR', 'FRA', 'فرنسا'),
(23290, 1428147128, 1428147135, 'SE', 'SWE', 'السويد'),
(23291, 1428147136, 1428147359, 'FR', 'FRA', 'فرنسا'),
(23292, 1428147360, 1428147375, 'IT', 'ITA', 'إيطاليا'),
(23293, 1428147376, 1428147391, 'ES', 'ESP', 'إسبانيا'),
(23294, 1428147392, 1428147855, 'FR', 'FRA', 'فرنسا'),
(23295, 1428147856, 1428147871, 'US', 'USA', 'الولايات المتحدة'),
(23296, 1428147872, 1428147903, 'GB', 'GBR', 'المملكة المتحدة'),
(23297, 1428147904, 1428148031, 'FR', 'FRA', 'فرنسا'),
(23298, 1428148032, 1428148063, 'SE', 'SWE', 'السويد'),
(23299, 1428148064, 1428148143, 'FR', 'FRA', 'فرنسا'),
(23300, 1428148144, 1428148151, 'DE', 'DEU', 'ألمانيا'),
(23301, 1428148152, 1428148159, 'NL', 'NLD', 'هولندا'),
(23302, 1428148160, 1428148175, 'FR', 'FRA', 'فرنسا'),
(23303, 1428148176, 1428148191, 'CH', 'CHE', 'سويسرا'),
(23304, 1428148192, 1428148223, 'SE', 'SWE', 'السويد'),
(23305, 1428148224, 1428150495, 'FR', 'FRA', 'فرنسا'),
(23306, 1428150496, 1428150511, 'SE', 'SWE', 'السويد'),
(23307, 1428150512, 1428150735, 'FR', 'FRA', 'فرنسا'),
(23308, 1428150736, 1428150751, 'SE', 'SWE', 'السويد'),
(23309, 1428150752, 1428151007, 'FR', 'FRA', 'فرنسا'),
(23310, 1428151008, 1428151039, 'SE', 'SWE', 'السويد'),
(23311, 1428151040, 1428152127, 'FR', 'FRA', 'فرنسا'),
(23312, 1428152128, 1428152319, 'SE', 'SWE', 'السويد'),
(23313, 1428152320, 1428160511, 'PL', 'POL', 'بولندا'),
(23314, 1428160512, 1429209087, 'IT', 'ITA', 'إيطاليا'),
(23315, 1429209088, 1430257663, 'ES', 'ESP', 'إسبانيا'),
(23316, 1430257664, 1430388735, 'IL', 'ISR', 'إسرائيل'),
(23317, 1430388736, 1430519807, 'HU', 'HUN', 'هنغاريا'),
(23318, 1430519808, 1430650879, 'FR', 'FRA', 'فرنسا'),
(23319, 1430650880, 1430781951, 'CZ', 'CZE', 'التشيك'),
(23320, 1430781952, 1431044095, 'GR', 'GRC', 'اليونان'),
(23321, 1431044096, 1431306239, 'FI', 'FIN', 'فنلندا'),
(23322, 1431306240, 1431568383, 'DK', 'DNK', 'الدنيمارك'),
(23323, 1431568384, 1431830527, 'ES', 'ESP', 'إسبانيا'),
(23324, 1431830528, 1431832832, 'DE', 'DEU', 'ألمانيا'),
(23325, 1431832833, 1431832846, 'AT', 'AUT', 'النمسا'),
(23326, 1431832847, 1431837680, 'DE', 'DEU', 'ألمانيا'),
(23327, 1431837681, 1431837694, 'AT', 'AUT', 'النمسا'),
(23328, 1431837695, 1431838719, 'DE', 'DEU', 'ألمانيا'),
(23329, 1431838720, 1431839007, 'BE', 'BEL', 'بلجيكا'),
(23330, 1431839008, 1431839039, 'DE', 'DEU', 'ألمانيا'),
(23331, 1431839040, 1431846911, 'BE', 'BEL', 'بلجيكا'),
(23332, 1431846912, 1431855103, 'NO', 'NOR', 'النرويج'),
(23333, 1431855104, 1431863295, 'NL', 'NLD', 'هولندا'),
(23334, 1431863296, 1431864263, 'PT', 'PRT', 'البورتوغال'),
(23335, 1431864264, 1431864271, 'ES', 'ESP', 'إسبانيا'),
(23336, 1431864272, 1431864935, 'PT', 'PRT', 'البورتوغال'),
(23337, 1431864936, 1431864943, 'ES', 'ESP', 'إسبانيا'),
(23338, 1431864944, 1431865335, 'PT', 'PRT', 'البورتوغال'),
(23339, 1431865336, 1431865343, 'ES', 'ESP', 'إسبانيا'),
(23340, 1431865344, 1431865631, 'PT', 'PRT', 'البورتوغال'),
(23341, 1431865632, 1431865647, 'ES', 'ESP', 'إسبانيا'),
(23342, 1431865648, 1431865663, 'PT', 'PRT', 'البورتوغال'),
(23343, 1431865664, 1431865679, 'ES', 'ESP', 'إسبانيا'),
(23344, 1431865680, 1431865711, 'PT', 'PRT', 'البورتوغال'),
(23345, 1431865712, 1431865719, 'ES', 'ESP', 'إسبانيا'),
(23346, 1431865720, 1431866447, 'PT', 'PRT', 'البورتوغال'),
(23347, 1431866448, 1431866455, 'NL', 'NLD', 'هولندا'),
(23348, 1431866456, 1431871487, 'PT', 'PRT', 'البورتوغال'),
(23349, 1431871488, 1431879679, 'RU', 'RUS', 'الإتحاد الروسي'),
(23350, 1431879680, 1431887871, 'IT', 'ITA', 'إيطاليا'),
(23351, 1431887872, 1431896063, 'GB', 'GBR', 'المملكة المتحدة'),
(23352, 1431896064, 1431904255, 'NO', 'NOR', 'النرويج'),
(23353, 1431904256, 1431912447, 'EE', 'EST', 'إستونيا'),
(23354, 1431912448, 1431920639, 'SE', 'SWE', 'السويد'),
(23355, 1431920640, 1431928831, 'RU', 'RUS', 'الإتحاد الروسي'),
(23356, 1431928832, 1431937023, 'IT', 'ITA', 'إيطاليا'),
(23357, 1431937024, 1431945215, 'PL', 'POL', 'بولندا'),
(23358, 1431945216, 1431953407, 'NO', 'NOR', 'النرويج'),
(23359, 1431953408, 1431961599, 'DK', 'DNK', 'الدنيمارك'),
(23360, 1431961600, 1431969791, 'CH', 'CHE', 'سويسرا'),
(23361, 1431969792, 1431977983, 'GB', 'GBR', 'المملكة المتحدة'),
(23362, 1431977984, 1431980151, 'NL', 'NLD', 'هولندا'),
(23363, 1431980152, 1431980159, 'US', 'USA', 'الولايات المتحدة'),
(23364, 1431980160, 1431986175, 'NL', 'NLD', 'هولندا'),
(23365, 1431986176, 1431994367, 'RU', 'RUS', 'الإتحاد الروسي'),
(23366, 1431994368, 1432002559, 'AT', 'AUT', 'النمسا'),
(23367, 1432002560, 1432010751, 'HU', 'HUN', 'هنغاريا'),
(23368, 1432010752, 1432018943, 'UA', 'UKR', 'أوكرانيا'),
(23369, 1432018944, 1432023551, 'GB', 'GBR', 'المملكة المتحدة'),
(23370, 1432023552, 1432023567, 'BG', 'BGR', 'بلغاريا'),
(23371, 1432023568, 1432027135, 'GB', 'GBR', 'المملكة المتحدة'),
(23372, 1432027136, 1432035327, 'IE', 'IRL', 'إيرلندا'),
(23373, 1432035328, 1432043519, 'GB', 'GBR', 'المملكة المتحدة'),
(23374, 1432043520, 1432051711, 'ES', 'ESP', 'إسبانيا'),
(23375, 1432051712, 1432059903, 'RU', 'RUS', 'الإتحاد الروسي'),
(23376, 1432059904, 1432068095, 'BG', 'BGR', 'بلغاريا'),
(23377, 1432068096, 1432076287, 'BE', 'BEL', 'بلجيكا'),
(23378, 1432076288, 1432084479, 'RU', 'RUS', 'الإتحاد الروسي'),
(23379, 1432084480, 1432092671, 'GB', 'GBR', 'المملكة المتحدة'),
(23380, 1432092672, 1432100863, 'RU', 'RUS', 'الإتحاد الروسي'),
(23381, 1432100864, 1432109055, 'CZ', 'CZE', 'التشيك'),
(23382, 1432109056, 1432117247, 'GB', 'GBR', 'المملكة المتحدة'),
(23383, 1432117248, 1432125439, 'CY', 'CYP', 'قبرص'),
(23384, 1432125440, 1432131583, 'NL', 'NLD', 'هولندا'),
(23385, 1432131584, 1432133631, 'PH', 'PHL', 'الفلبين'),
(23386, 1432133632, 1432150015, 'GB', 'GBR', 'المملكة المتحدة'),
(23387, 1432150016, 1432158207, 'BA', 'BIH', 'البوسنه والهرسك'),
(23388, 1432158208, 1432158463, 'CH', 'CHE', 'سويسرا'),
(23389, 1432158464, 1432159743, 'DE', 'DEU', 'ألمانيا'),
(23390, 1432159744, 1432159871, 'PL', 'POL', 'بولندا'),
(23391, 1432159872, 1432160255, 'DE', 'DEU', 'ألمانيا'),
(23392, 1432160256, 1432160511, 'CH', 'CHE', 'سويسرا'),
(23393, 1432160512, 1432165247, 'DE', 'DEU', 'ألمانيا'),
(23394, 1432165248, 1432165375, 'PL', 'POL', 'بولندا'),
(23395, 1432165376, 1432166143, 'DE', 'DEU', 'ألمانيا'),
(23396, 1432166144, 1432166399, 'CH', 'CHE', 'سويسرا'),
(23397, 1432166400, 1432174591, 'RU', 'RUS', 'الإتحاد الروسي'),
(23398, 1432174592, 1432182783, 'DE', 'DEU', 'ألمانيا'),
(23399, 1432182784, 1432190975, 'CZ', 'CZE', 'التشيك'),
(23400, 1432190976, 1432199167, 'RU', 'RUS', 'الإتحاد الروسي'),
(23401, 1432199168, 1432207359, 'CZ', 'CZE', 'التشيك'),
(23402, 1432207360, 1432215551, 'LU', 'LUX', 'لوكسيمبورغ'),
(23403, 1432215552, 1432223743, 'NO', 'NOR', 'النرويج'),
(23404, 1432223744, 1432240127, 'RU', 'RUS', 'الإتحاد الروسي'),
(23405, 1432240128, 1432248319, 'HR', 'HRV', 'كرواتيا'),
(23406, 1432248320, 1432256511, 'ME', 'MNE', 'الجبل الأسود'),
(23407, 1432256512, 1432264703, 'BA', 'BIH', 'البوسنه والهرسك'),
(23408, 1432264704, 1432272895, 'AD', 'AND', 'أندورا'),
(23409, 1432272896, 1432281087, 'IT', 'ITA', 'إيطاليا'),
(23410, 1432281088, 1432289279, 'LU', 'LUX', 'لوكسيمبورغ'),
(23411, 1432289280, 1432297471, 'GB', 'GBR', 'المملكة المتحدة'),
(23412, 1432297472, 1432305663, 'NO', 'NOR', 'النرويج'),
(23413, 1432305664, 1432313855, 'BG', 'BGR', 'بلغاريا'),
(23414, 1432313856, 1432322047, 'GB', 'GBR', 'المملكة المتحدة'),
(23415, 1432322048, 1432338431, 'RU', 'RUS', 'الإتحاد الروسي'),
(23416, 1432338432, 1432346623, 'FR', 'FRA', 'فرنسا'),
(23417, 1432346624, 1433403391, 'TR', 'TUR', 'تركيا'),
(23418, 1433403392, 1433407711, 'ES', 'ESP', 'إسبانيا'),
(23419, 1433407712, 1433408767, 'NL', 'NLD', 'هولندا'),
(23420, 1433408768, 1433409023, 'ES', 'ESP', 'إسبانيا'),
(23421, 1433409024, 1433409279, 'NL', 'NLD', 'هولندا'),
(23422, 1433409280, 1433409535, 'ES', 'ESP', 'إسبانيا'),
(23423, 1433409536, 1433409791, 'NL', 'NLD', 'هولندا'),
(23424, 1433409792, 1433410047, 'ES', 'ESP', 'إسبانيا'),
(23425, 1433410048, 1433411071, 'NL', 'NLD', 'هولندا'),
(23426, 1433411072, 1433411583, 'ES', 'ESP', 'إسبانيا'),
(23427, 1433411584, 1433419775, 'RU', 'RUS', 'الإتحاد الروسي'),
(23428, 1433419776, 1433427967, 'LB', 'LBN', 'لبنان'),
(23429, 1433427968, 1433436159, 'RU', 'RUS', 'الإتحاد الروسي'),
(23430, 1433436160, 1433444351, 'NO', 'NOR', 'النرويج'),
(23431, 1433444352, 1433452543, 'SE', 'SWE', 'السويد'),
(23432, 1433452544, 1433460735, 'PL', 'POL', 'بولندا'),
(23433, 1433460736, 1433468927, 'DE', 'DEU', 'ألمانيا'),
(23434, 1433468928, 1433477119, 'KG', 'KGZ', 'قيرغيزستان'),
(23435, 1433477120, 1433485311, 'RU', 'RUS', 'الإتحاد الروسي'),
(23436, 1433485312, 1433493503, 'GB', 'GBR', 'المملكة المتحدة'),
(23437, 1433493504, 1433501695, 'PS', 'PSE', 'فلسطين المحتلة'),
(23438, 1433501696, 1433509887, 'RU', 'RUS', 'الإتحاد الروسي'),
(23439, 1433509888, 1433518079, 'NO', 'NOR', 'النرويج'),
(23440, 1433518080, 1433526271, 'RU', 'RUS', 'الإتحاد الروسي'),
(23441, 1433526272, 1433534463, 'NL', 'NLD', 'هولندا'),
(23442, 1433534464, 1433542655, 'RU', 'RUS', 'الإتحاد الروسي'),
(23443, 1433542656, 1433550847, 'HR', 'HRV', 'كرواتيا'),
(23444, 1433550848, 1433559039, 'RU', 'RUS', 'الإتحاد الروسي'),
(23445, 1433559040, 1433567231, 'PS', 'PSE', 'فلسطين المحتلة'),
(23446, 1433567232, 1433575423, 'DE', 'DEU', 'ألمانيا'),
(23447, 1433575424, 1433583615, 'RU', 'RUS', 'الإتحاد الروسي'),
(23448, 1433583616, 1433591807, 'UA', 'UKR', 'أوكرانيا'),
(23449, 1433591808, 1433599999, 'GE', 'GEO', 'جورجيا'),
(23450, 1433600000, 1433602303, 'DE', 'DEU', 'ألمانيا'),
(23451, 1433602304, 1433602319, 'LU', 'LUX', 'لوكسيمبورغ'),
(23452, 1433602320, 1433608191, 'DE', 'DEU', 'ألمانيا'),
(23453, 1433608192, 1433608959, 'GB', 'GBR', 'المملكة المتحدة'),
(23454, 1433608960, 1433609215, 'DE', 'DEU', 'ألمانيا'),
(23455, 1433609216, 1433609727, 'GB', 'GBR', 'المملكة المتحدة'),
(23456, 1433609728, 1433610239, 'CH', 'CHE', 'سويسرا'),
(23457, 1433610240, 1433612287, 'US', 'USA', 'الولايات المتحدة'),
(23458, 1433612288, 1433614335, 'GB', 'GBR', 'المملكة المتحدة'),
(23459, 1433614336, 1433615359, 'DE', 'DEU', 'ألمانيا'),
(23460, 1433615360, 1433615871, 'FR', 'FRA', 'فرنسا'),
(23461, 1433615872, 1433616383, 'GB', 'GBR', 'المملكة المتحدة'),
(23462, 1433616384, 1433624575, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(23463, 1433624576, 1433632767, 'LV', 'LVA', 'لاتفيا'),
(23464, 1433632768, 1433640959, 'GI', 'GIB', 'جبل طارق'),
(23465, 1433640960, 1433649151, 'RU', 'RUS', 'الإتحاد الروسي'),
(23466, 1433649152, 1433657343, 'KG', 'KGZ', 'قيرغيزستان'),
(23467, 1433657344, 1433665535, 'RU', 'RUS', 'الإتحاد الروسي'),
(23468, 1433665536, 1433673727, 'GB', 'GBR', 'المملكة المتحدة'),
(23469, 1433673728, 1433681919, 'FR', 'FRA', 'فرنسا'),
(23470, 1433681920, 1433690111, 'IS', 'ISL', 'أيسلندا'),
(23471, 1433690112, 1433698303, 'RU', 'RUS', 'الإتحاد الروسي'),
(23472, 1433698304, 1433706495, 'IT', 'ITA', 'إيطاليا'),
(23473, 1433706496, 1433714687, 'GB', 'GBR', 'المملكة المتحدة'),
(23474, 1433714688, 1433722879, 'DE', 'DEU', 'ألمانيا'),
(23475, 1433722880, 1433731071, 'IT', 'ITA', 'إيطاليا'),
(23476, 1433731072, 1433739263, 'PL', 'POL', 'بولندا'),
(23477, 1433739264, 1433747455, 'GE', 'GEO', 'جورجيا'),
(23478, 1433747456, 1433755647, 'RU', 'RUS', 'الإتحاد الروسي'),
(23479, 1433755648, 1433763839, 'EE', 'EST', 'إستونيا'),
(23480, 1433763840, 1433765887, 'CZ', 'CZE', 'التشيك'),
(23481, 1433765888, 1433766911, 'DE', 'DEU', 'ألمانيا'),
(23482, 1433766912, 1433767935, 'RU', 'RUS', 'الإتحاد الروسي'),
(23483, 1433767936, 1433769983, 'CZ', 'CZE', 'التشيك'),
(23484, 1433769984, 1433771007, 'SK', 'SVK', 'سلوفاكيا'),
(23485, 1433771008, 1433772031, 'RU', 'RUS', 'الإتحاد الروسي'),
(23486, 1433772032, 1433788415, 'SE', 'SWE', 'السويد'),
(23487, 1433788416, 1433796607, 'UZ', 'UZB', 'أوزباكستان'),
(23488, 1433796608, 1433804799, 'GB', 'GBR', 'المملكة المتحدة'),
(23489, 1433804800, 1433812991, 'FR', 'FRA', 'فرنسا'),
(23490, 1433812992, 1433820159, 'BG', 'BGR', 'بلغاريا'),
(23491, 1433820160, 1433821183, 'HR', 'HRV', 'كرواتيا'),
(23492, 1433821184, 1433829375, 'GE', 'GEO', 'جورجيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(23493, 1433829376, 1433833471, 'RU', 'RUS', 'الإتحاد الروسي'),
(23494, 1433833472, 1433835519, 'IT', 'ITA', 'إيطاليا'),
(23495, 1433835520, 1433837567, 'GB', 'GBR', 'المملكة المتحدة'),
(23496, 1433837568, 1433839615, 'DE', 'DEU', 'ألمانيا'),
(23497, 1433839616, 1433841663, 'GB', 'GBR', 'المملكة المتحدة'),
(23498, 1433841664, 1433843711, 'RU', 'RUS', 'الإتحاد الروسي'),
(23499, 1433843712, 1433843839, 'SE', 'SWE', 'السويد'),
(23500, 1433843840, 1433843967, 'NL', 'NLD', 'هولندا'),
(23501, 1433843968, 1433843983, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(23502, 1433843984, 1433845759, 'NL', 'NLD', 'هولندا'),
(23503, 1433845760, 1433847807, 'BG', 'BGR', 'بلغاريا'),
(23504, 1433847808, 1433849855, 'SE', 'SWE', 'السويد'),
(23505, 1433849856, 1433851903, 'BE', 'BEL', 'بلجيكا'),
(23506, 1433851904, 1433853951, 'CH', 'CHE', 'سويسرا'),
(23507, 1433853952, 1433855999, 'RU', 'RUS', 'الإتحاد الروسي'),
(23508, 1433856000, 1433858047, 'GB', 'GBR', 'المملكة المتحدة'),
(23509, 1433858048, 1433860095, 'ES', 'ESP', 'إسبانيا'),
(23510, 1433860096, 1433862143, 'DE', 'DEU', 'ألمانيا'),
(23511, 1433862144, 1433862751, 'CH', 'CHE', 'سويسرا'),
(23512, 1433862752, 1433862783, 'MC', 'MCO', 'موناكو'),
(23513, 1433862784, 1433863423, 'CH', 'CHE', 'سويسرا'),
(23514, 1433863424, 1433863487, 'US', 'USA', 'الولايات المتحدة'),
(23515, 1433863488, 1433864191, 'CH', 'CHE', 'سويسرا'),
(23516, 1433864192, 1433866239, 'HU', 'HUN', 'هنغاريا'),
(23517, 1433866240, 1433866623, 'NL', 'NLD', 'هولندا'),
(23518, 1433866624, 1433870335, 'GB', 'GBR', 'المملكة المتحدة'),
(23519, 1433870336, 1433872383, 'TR', 'TUR', 'تركيا'),
(23520, 1433872384, 1433874431, 'IT', 'ITA', 'إيطاليا'),
(23521, 1433874432, 1433876479, 'NL', 'NLD', 'هولندا'),
(23522, 1433876480, 1433878527, 'GB', 'GBR', 'المملكة المتحدة'),
(23523, 1433878528, 1433880575, 'TR', 'TUR', 'تركيا'),
(23524, 1433880576, 1433882623, 'RU', 'RUS', 'الإتحاد الروسي'),
(23525, 1433882624, 1433884671, 'GB', 'GBR', 'المملكة المتحدة'),
(23526, 1433884672, 1433886719, 'CZ', 'CZE', 'التشيك'),
(23527, 1433886720, 1433888767, 'GB', 'GBR', 'المملكة المتحدة'),
(23528, 1433888768, 1433890815, 'SA', 'SAU', 'السعودية'),
(23529, 1433890816, 1433892863, 'GB', 'GBR', 'المملكة المتحدة'),
(23530, 1433892864, 1433894911, 'MT', 'MLT', 'مالطا'),
(23531, 1433894912, 1433896959, 'SE', 'SWE', 'السويد'),
(23532, 1433896960, 1433897471, 'NO', 'NOR', 'النرويج'),
(23533, 1433897472, 1433897727, 'NL', 'NLD', 'هولندا'),
(23534, 1433897728, 1433899007, 'NO', 'NOR', 'النرويج'),
(23535, 1433899008, 1433901055, 'RU', 'RUS', 'الإتحاد الروسي'),
(23536, 1433901056, 1433905151, 'DE', 'DEU', 'ألمانيا'),
(23537, 1433905152, 1433907199, 'FR', 'FRA', 'فرنسا'),
(23538, 1433907200, 1433909247, 'IT', 'ITA', 'إيطاليا'),
(23539, 1433909248, 1433911295, 'BE', 'BEL', 'بلجيكا'),
(23540, 1433911296, 1433913343, 'ES', 'ESP', 'إسبانيا'),
(23541, 1433913344, 1433913875, 'NL', 'NLD', 'هولندا'),
(23542, 1433913876, 1433913879, 'DE', 'DEU', 'ألمانيا'),
(23543, 1433913880, 1433914111, 'NL', 'NLD', 'هولندا'),
(23544, 1433914112, 1433915135, 'DE', 'DEU', 'ألمانيا'),
(23545, 1433915136, 1433915391, 'NL', 'NLD', 'هولندا'),
(23546, 1433915392, 1433917439, 'DE', 'DEU', 'ألمانيا'),
(23547, 1433917440, 1433919487, 'BE', 'BEL', 'بلجيكا'),
(23548, 1433919488, 1433921535, 'GB', 'GBR', 'المملكة المتحدة'),
(23549, 1433921536, 1433923583, 'CH', 'CHE', 'سويسرا'),
(23550, 1433923584, 1433923711, 'BE', 'BEL', 'بلجيكا'),
(23551, 1433923712, 1433924479, 'NL', 'NLD', 'هولندا'),
(23552, 1433924480, 1433925631, 'BE', 'BEL', 'بلجيكا'),
(23553, 1433925632, 1433927679, 'GB', 'GBR', 'المملكة المتحدة'),
(23554, 1433927680, 1434189823, 'RO', 'ROM', 'رومانيا'),
(23555, 1434189824, 1434451967, 'AT', 'AUT', 'النمسا'),
(23556, 1434451968, 1434517503, 'PL', 'POL', 'بولندا'),
(23557, 1434517504, 1434550271, 'DK', 'DNK', 'الدنيمارك'),
(23558, 1434550272, 1434583039, 'SA', 'SAU', 'السعودية'),
(23559, 1434583040, 1434615807, 'BG', 'BGR', 'بلغاريا'),
(23560, 1434615808, 1434648575, 'IL', 'ISR', 'إسرائيل'),
(23561, 1434648576, 1434681343, 'FI', 'FIN', 'فنلندا'),
(23562, 1434681344, 1434681855, 'DE', 'DEU', 'ألمانيا'),
(23563, 1434681856, 1434682111, 'MY', 'MYS', 'ماليزيا'),
(23564, 1434682112, 1434705791, 'DE', 'DEU', 'ألمانيا'),
(23565, 1434705792, 1434705919, 'NL', 'NLD', 'هولندا'),
(23566, 1434705920, 1434714111, 'DE', 'DEU', 'ألمانيا'),
(23567, 1434714112, 1434746879, 'AZ', 'AZE', 'أذربيجان'),
(23568, 1434746880, 1434779647, 'CZ', 'CZE', 'التشيك'),
(23569, 1434779648, 1434812415, 'GB', 'GBR', 'المملكة المتحدة'),
(23570, 1434812416, 1434845183, 'IR', 'IRN', 'إيران'),
(23571, 1434845184, 1434877951, 'FI', 'FIN', 'فنلندا'),
(23572, 1434877952, 1434910719, 'IE', 'IRL', 'إيرلندا'),
(23573, 1434910720, 1434943487, 'CZ', 'CZE', 'التشيك'),
(23574, 1434943488, 1434976255, 'SK', 'SVK', 'سلوفاكيا'),
(23575, 1434976256, 1435107327, 'ES', 'ESP', 'إسبانيا'),
(23576, 1435107328, 1435238399, 'PT', 'PRT', 'البورتوغال'),
(23577, 1435238400, 1435500543, 'RU', 'RUS', 'الإتحاد الروسي'),
(23578, 1435500544, 1436024831, 'NL', 'NLD', 'هولندا'),
(23579, 1436024832, 1436090367, 'ES', 'ESP', 'إسبانيا'),
(23580, 1436090368, 1436155903, 'TR', 'TUR', 'تركيا'),
(23581, 1436155904, 1436221439, 'OM', 'OMN', 'عمان'),
(23582, 1436221440, 1436286975, 'ES', 'ESP', 'إسبانيا'),
(23583, 1436286976, 1436418047, 'FI', 'FIN', 'فنلندا'),
(23584, 1436418048, 1436420095, 'DE', 'DEU', 'ألمانيا'),
(23585, 1436420096, 1436422143, 'GB', 'GBR', 'المملكة المتحدة'),
(23586, 1436422144, 1436424191, 'FR', 'FRA', 'فرنسا'),
(23587, 1436424192, 1436426239, 'CH', 'CHE', 'سويسرا'),
(23588, 1436426240, 1436428287, 'BA', 'BIH', 'البوسنه والهرسك'),
(23589, 1436428288, 1436430335, 'GB', 'GBR', 'المملكة المتحدة'),
(23590, 1436430336, 1436432383, 'RU', 'RUS', 'الإتحاد الروسي'),
(23591, 1436432384, 1436436479, 'GB', 'GBR', 'المملكة المتحدة'),
(23592, 1436436480, 1436438527, 'LV', 'LVA', 'لاتفيا'),
(23593, 1436438528, 1436440575, 'IT', 'ITA', 'إيطاليا'),
(23594, 1436440576, 1436442623, 'RU', 'RUS', 'الإتحاد الروسي'),
(23595, 1436442624, 1436444671, 'TR', 'TUR', 'تركيا'),
(23596, 1436444672, 1436446719, 'BE', 'BEL', 'بلجيكا'),
(23597, 1436446720, 1436450815, 'FR', 'FRA', 'فرنسا'),
(23598, 1436450816, 1436452863, 'BH', 'BHR', 'البحرين'),
(23599, 1436452864, 1436453119, 'NL', 'NLD', 'هولندا'),
(23600, 1436453120, 1436453631, 'DE', 'DEU', 'ألمانيا'),
(23601, 1436453632, 1436453887, 'NL', 'NLD', 'هولندا'),
(23602, 1436453888, 1436454399, 'GB', 'GBR', 'المملكة المتحدة'),
(23603, 1436454400, 1436454655, 'NL', 'NLD', 'هولندا'),
(23604, 1436454656, 1436454911, 'GB', 'GBR', 'المملكة المتحدة'),
(23605, 1436454912, 1436456959, 'AZ', 'AZE', 'أذربيجان'),
(23606, 1436456960, 1436459007, 'GB', 'GBR', 'المملكة المتحدة'),
(23607, 1436459008, 1436461055, 'NL', 'NLD', 'هولندا'),
(23608, 1436461056, 1436463103, 'ES', 'ESP', 'إسبانيا'),
(23609, 1436463104, 1436465151, 'DE', 'DEU', 'ألمانيا'),
(23610, 1436465152, 1436467199, 'RU', 'RUS', 'الإتحاد الروسي'),
(23611, 1436467200, 1436469247, 'DE', 'DEU', 'ألمانيا'),
(23612, 1436469248, 1436471295, 'NL', 'NLD', 'هولندا'),
(23613, 1436471296, 1436471551, 'BE', 'BEL', 'بلجيكا'),
(23614, 1436471552, 1436471615, 'NL', 'NLD', 'هولندا'),
(23615, 1436471616, 1436471679, 'FR', 'FRA', 'فرنسا'),
(23616, 1436471680, 1436471743, 'BE', 'BEL', 'بلجيكا'),
(23617, 1436471744, 1436471807, 'BR', 'BRA', 'البرازيل'),
(23618, 1436471808, 1436473343, 'BE', 'BEL', 'بلجيكا'),
(23619, 1436473344, 1436475391, 'RO', 'ROM', 'رومانيا'),
(23620, 1436475392, 1436477439, 'AT', 'AUT', 'النمسا'),
(23621, 1436477440, 1436481535, 'CH', 'CHE', 'سويسرا'),
(23622, 1436481536, 1436483583, 'NL', 'NLD', 'هولندا'),
(23623, 1436483584, 1436485631, 'UA', 'UKR', 'أوكرانيا'),
(23624, 1436485632, 1436487471, 'DE', 'DEU', 'ألمانيا'),
(23625, 1436487472, 1436487487, 'AT', 'AUT', 'النمسا'),
(23626, 1436487488, 1436487623, 'DE', 'DEU', 'ألمانيا'),
(23627, 1436487624, 1436487631, 'AT', 'AUT', 'النمسا'),
(23628, 1436487632, 1436487679, 'DE', 'DEU', 'ألمانيا'),
(23629, 1436487680, 1436489727, 'IE', 'IRL', 'إيرلندا'),
(23630, 1436489728, 1436491775, 'KZ', 'KAZ', 'كازاخستان'),
(23631, 1436491776, 1436495871, 'RU', 'RUS', 'الإتحاد الروسي'),
(23632, 1436495872, 1436497919, 'HU', 'HUN', 'هنغاريا'),
(23633, 1436497920, 1436499967, 'GB', 'GBR', 'المملكة المتحدة'),
(23634, 1436499968, 1436504063, 'TR', 'TUR', 'تركيا'),
(23635, 1436504064, 1436508159, 'GB', 'GBR', 'المملكة المتحدة'),
(23636, 1436508160, 1436510207, 'NL', 'NLD', 'هولندا'),
(23637, 1436510208, 1436512255, 'SK', 'SVK', 'سلوفاكيا'),
(23638, 1436512256, 1436514303, 'NL', 'NLD', 'هولندا'),
(23639, 1436516352, 1436520447, 'GB', 'GBR', 'المملكة المتحدة'),
(23640, 1436520448, 1436522495, 'IT', 'ITA', 'إيطاليا'),
(23641, 1436522496, 1436524543, 'GB', 'GBR', 'المملكة المتحدة'),
(23642, 1436524544, 1436526591, 'IL', 'ISR', 'إسرائيل'),
(23643, 1436526592, 1436528639, 'GB', 'GBR', 'المملكة المتحدة'),
(23644, 1436528640, 1436530687, 'IT', 'ITA', 'إيطاليا'),
(23645, 1436530688, 1436531243, 'GB', 'GBR', 'المملكة المتحدة'),
(23646, 1436531244, 1436531263, 'FR', 'FRA', 'فرنسا'),
(23647, 1436531264, 1436531327, 'GB', 'GBR', 'المملكة المتحدة'),
(23648, 1436531328, 1436531455, 'FR', 'FRA', 'فرنسا'),
(23649, 1436531456, 1436532207, 'GB', 'GBR', 'المملكة المتحدة'),
(23650, 1436532208, 1436532211, 'FR', 'FRA', 'فرنسا'),
(23651, 1436532212, 1436532219, 'GB', 'GBR', 'المملكة المتحدة'),
(23652, 1436532220, 1436532223, 'FR', 'FRA', 'فرنسا'),
(23653, 1436532224, 1436532235, 'GB', 'GBR', 'المملكة المتحدة'),
(23654, 1436532236, 1436532255, 'FR', 'FRA', 'فرنسا'),
(23655, 1436532256, 1436532287, 'GB', 'GBR', 'المملكة المتحدة'),
(23656, 1436532288, 1436532735, 'FR', 'FRA', 'فرنسا'),
(23657, 1436532736, 1436535839, 'IT', 'ITA', 'إيطاليا'),
(23658, 1436535840, 1436535855, 'ET', 'ETH', 'إثيوبيا'),
(23659, 1436535856, 1436535943, 'IT', 'ITA', 'إيطاليا'),
(23660, 1436535944, 1436535951, 'ET', 'ETH', 'إثيوبيا'),
(23661, 1436535952, 1436535999, 'IT', 'ITA', 'إيطاليا'),
(23662, 1436536000, 1436536007, 'MO', 'MAC', 'ماكاو'),
(23663, 1436536008, 1436536831, 'IT', 'ITA', 'إيطاليا'),
(23664, 1436536832, 1436538879, 'GB', 'GBR', 'المملكة المتحدة'),
(23665, 1436538880, 1436540927, 'JO', 'JOR', 'الأردن'),
(23666, 1436540928, 1436542975, 'RU', 'RUS', 'الإتحاد الروسي'),
(23667, 1436542976, 1436545023, 'NL', 'NLD', 'هولندا'),
(23668, 1436545024, 1436547071, 'DE', 'DEU', 'ألمانيا'),
(23669, 1436547072, 1436549119, 'GB', 'GBR', 'المملكة المتحدة'),
(23670, 1436549120, 1436811263, 'CZ', 'CZE', 'التشيك'),
(23671, 1436811264, 1437073407, 'NO', 'NOR', 'النرويج'),
(23672, 1437073408, 1437335551, 'FR', 'FRA', 'فرنسا'),
(23673, 1437335552, 1437597695, 'RU', 'RUS', 'الإتحاد الروسي'),
(23674, 1437597696, 1438121983, 'DE', 'DEU', 'ألمانيا'),
(23675, 1438121984, 1438127103, 'NL', 'NLD', 'هولندا'),
(23676, 1438127104, 1438127359, 'GB', 'GBR', 'المملكة المتحدة'),
(23677, 1438127360, 1438127615, 'SE', 'SWE', 'السويد'),
(23678, 1438127616, 1438127871, 'BE', 'BEL', 'بلجيكا'),
(23679, 1438127872, 1438142463, 'NL', 'NLD', 'هولندا'),
(23680, 1438142464, 1438142719, 'GB', 'GBR', 'المملكة المتحدة'),
(23681, 1438142720, 1438187519, 'NL', 'NLD', 'هولندا'),
(23682, 1438187520, 1438253055, 'IR', 'IRN', 'إيران'),
(23683, 1438253056, 1438318591, 'RO', 'ROM', 'رومانيا'),
(23684, 1438318592, 1438384127, 'BG', 'BGR', 'بلغاريا'),
(23685, 1438384128, 1438400511, 'FI', 'FIN', 'فنلندا'),
(23686, 1438400512, 1438433279, 'SE', 'SWE', 'السويد'),
(23687, 1438433280, 1438515199, 'GB', 'GBR', 'المملكة المتحدة'),
(23688, 1438515200, 1438519007, 'DE', 'DEU', 'ألمانيا'),
(23689, 1438519008, 1438519039, 'SI', 'SVN', 'سلوفينيا'),
(23690, 1438519040, 1438523391, 'DE', 'DEU', 'ألمانيا'),
(23691, 1438523392, 1438524947, 'NL', 'NLD', 'هولندا'),
(23692, 1438524948, 1438524951, 'DE', 'DEU', 'ألمانيا'),
(23693, 1438524952, 1438525335, 'NL', 'NLD', 'هولندا'),
(23694, 1438525336, 1438525343, 'DE', 'DEU', 'ألمانيا'),
(23695, 1438525344, 1438525607, 'NL', 'NLD', 'هولندا'),
(23696, 1438525608, 1438525695, 'DE', 'DEU', 'ألمانيا'),
(23697, 1438525696, 1438526719, 'NL', 'NLD', 'هولندا'),
(23698, 1438526720, 1438580735, 'DE', 'DEU', 'ألمانيا'),
(23699, 1438580736, 1438646271, 'NL', 'NLD', 'هولندا'),
(23700, 1438646272, 1438662655, 'RU', 'RUS', 'الإتحاد الروسي'),
(23701, 1438662656, 1438679039, 'ES', 'ESP', 'إسبانيا'),
(23702, 1438679040, 1438695423, 'RU', 'RUS', 'الإتحاد الروسي'),
(23703, 1438695424, 1438711807, 'FR', 'FRA', 'فرنسا'),
(23704, 1438711808, 1438728191, 'CZ', 'CZE', 'التشيك'),
(23705, 1438728192, 1438744575, 'RU', 'RUS', 'الإتحاد الروسي'),
(23706, 1438744576, 1438760959, 'AT', 'AUT', 'النمسا'),
(23707, 1438760960, 1438777343, 'PL', 'POL', 'بولندا'),
(23708, 1438777344, 1438793727, 'SE', 'SWE', 'السويد'),
(23709, 1438793728, 1438810111, 'SA', 'SAU', 'السعودية'),
(23710, 1438810112, 1438826495, 'SE', 'SWE', 'السويد'),
(23711, 1438826496, 1438842879, 'FI', 'FIN', 'فنلندا'),
(23712, 1438842880, 1438859263, 'SE', 'SWE', 'السويد'),
(23713, 1438859264, 1438861823, 'DE', 'DEU', 'ألمانيا'),
(23714, 1438861824, 1438862079, 'CH', 'CHE', 'سويسرا'),
(23715, 1438862080, 1438873119, 'DE', 'DEU', 'ألمانيا'),
(23716, 1438873120, 1438873127, 'PA', 'PAN', 'بنما'),
(23717, 1438873128, 1438873671, 'DE', 'DEU', 'ألمانيا'),
(23718, 1438873672, 1438873679, 'PA', 'PAN', 'بنما'),
(23719, 1438873680, 1438874411, 'DE', 'DEU', 'ألمانيا'),
(23720, 1438874412, 1438874413, 'GB', 'GBR', 'المملكة المتحدة'),
(23721, 1438874414, 1438874687, 'DE', 'DEU', 'ألمانيا'),
(23722, 1438874688, 1438874695, 'CH', 'CHE', 'سويسرا'),
(23723, 1438874696, 1438874719, 'DE', 'DEU', 'ألمانيا'),
(23724, 1438874720, 1438874751, 'NL', 'NLD', 'هولندا'),
(23725, 1438874752, 1438874759, 'DE', 'DEU', 'ألمانيا'),
(23726, 1438874760, 1438874767, 'PA', 'PAN', 'بنما'),
(23727, 1438874768, 1438874783, 'DE', 'DEU', 'ألمانيا'),
(23728, 1438874784, 1438874791, 'PA', 'PAN', 'بنما'),
(23729, 1438874792, 1438874799, 'DE', 'DEU', 'ألمانيا'),
(23730, 1438874800, 1438874855, 'PA', 'PAN', 'بنما'),
(23731, 1438874856, 1438874863, 'DE', 'DEU', 'ألمانيا'),
(23732, 1438874864, 1438874879, 'PA', 'PAN', 'بنما'),
(23733, 1438874880, 1438875223, 'DE', 'DEU', 'ألمانيا'),
(23734, 1438875224, 1438875255, 'GB', 'GBR', 'المملكة المتحدة'),
(23735, 1438875256, 1438875257, 'CH', 'CHE', 'سويسرا'),
(23736, 1438875258, 1438875647, 'DE', 'DEU', 'ألمانيا'),
(23737, 1438875648, 1438875903, 'RU', 'RUS', 'الإتحاد الروسي'),
(23738, 1438875904, 1438876159, 'SE', 'SWE', 'السويد'),
(23739, 1438876160, 1438876415, 'LB', 'LBN', 'لبنان'),
(23740, 1438876416, 1438876927, 'RU', 'RUS', 'الإتحاد الروسي'),
(23741, 1438876928, 1438877183, 'IQ', 'IRQ', 'العراق'),
(23742, 1438877184, 1438877439, 'LT', 'LTU', 'ليتوانيا'),
(23743, 1438877440, 1438877695, 'LB', 'LBN', 'لبنان'),
(23744, 1438877696, 1438877951, 'LT', 'LTU', 'ليتوانيا'),
(23745, 1438877952, 1438878719, 'LB', 'LBN', 'لبنان'),
(23746, 1438878720, 1438878975, 'LT', 'LTU', 'ليتوانيا'),
(23747, 1438878976, 1438879231, 'IQ', 'IRQ', 'العراق'),
(23748, 1438879232, 1438880511, 'RU', 'RUS', 'الإتحاد الروسي'),
(23749, 1438880512, 1438880767, 'LT', 'LTU', 'ليتوانيا'),
(23750, 1438880768, 1438881791, 'LB', 'LBN', 'لبنان'),
(23751, 1438881792, 1438882303, 'RU', 'RUS', 'الإتحاد الروسي'),
(23752, 1438882304, 1438882559, 'LT', 'LTU', 'ليتوانيا'),
(23753, 1438882560, 1438883583, 'RU', 'RUS', 'الإتحاد الروسي'),
(23754, 1438883584, 1438883839, 'AM', 'ARM', 'أرمينيا'),
(23755, 1438883840, 1438884351, 'RU', 'RUS', 'الإتحاد الروسي'),
(23756, 1438884352, 1438884607, 'LB', 'LBN', 'لبنان'),
(23757, 1438884608, 1438884863, 'IQ', 'IRQ', 'العراق'),
(23758, 1438884864, 1438885887, 'RU', 'RUS', 'الإتحاد الروسي'),
(23759, 1438885888, 1438889983, 'LT', 'LTU', 'ليتوانيا'),
(23760, 1438889984, 1438890239, 'LB', 'LBN', 'لبنان'),
(23761, 1438890240, 1438890495, 'RU', 'RUS', 'الإتحاد الروسي'),
(23762, 1438890496, 1438890751, 'IQ', 'IRQ', 'العراق'),
(23763, 1438890752, 1438892031, 'RU', 'RUS', 'الإتحاد الروسي'),
(23764, 1438892032, 1438892287, 'AQ', 'ATA', 'أنتاركتيكا'),
(23765, 1438892288, 1438900223, 'CH', 'CHE', 'سويسرا'),
(23766, 1438900224, 1438908415, 'AQ', 'ATA', 'أنتاركتيكا'),
(23767, 1438908416, 1438924799, 'GR', 'GRC', 'اليونان'),
(23768, 1438924800, 1438941183, 'NO', 'NOR', 'النرويج'),
(23769, 1438941184, 1438957567, 'BG', 'BGR', 'بلغاريا'),
(23770, 1438957568, 1438973951, 'EE', 'EST', 'إستونيا'),
(23771, 1438973952, 1438994175, 'DE', 'DEU', 'ألمانيا'),
(23772, 1438994176, 1438994431, 'SE', 'SWE', 'السويد'),
(23773, 1438994432, 1438994619, 'DE', 'DEU', 'ألمانيا'),
(23774, 1438994620, 1438994623, 'SE', 'SWE', 'السويد'),
(23775, 1438994624, 1438994751, 'DE', 'DEU', 'ألمانيا'),
(23776, 1438994752, 1438994759, 'GB', 'GBR', 'المملكة المتحدة'),
(23777, 1438994760, 1438994763, 'SE', 'SWE', 'السويد'),
(23778, 1438994764, 1438995039, 'DE', 'DEU', 'ألمانيا'),
(23779, 1438995040, 1438995047, 'GB', 'GBR', 'المملكة المتحدة'),
(23780, 1438995048, 1438995067, 'DE', 'DEU', 'ألمانيا'),
(23781, 1438995068, 1438995071, 'SE', 'SWE', 'السويد'),
(23782, 1438995072, 1438998781, 'DE', 'DEU', 'ألمانيا'),
(23783, 1438998782, 1438998783, 'CH', 'CHE', 'سويسرا'),
(23784, 1438998784, 1438999098, 'DE', 'DEU', 'ألمانيا'),
(23785, 1438999099, 1438999103, 'CH', 'CHE', 'سويسرا'),
(23786, 1438999104, 1438999261, 'DE', 'DEU', 'ألمانيا'),
(23787, 1438999262, 1438999295, 'NL', 'NLD', 'هولندا'),
(23788, 1438999296, 1438999475, 'DE', 'DEU', 'ألمانيا'),
(23789, 1438999476, 1438999487, 'PT', 'PRT', 'البورتوغال'),
(23790, 1438999488, 1438999517, 'DE', 'DEU', 'ألمانيا'),
(23791, 1438999518, 1438999518, 'CH', 'CHE', 'سويسرا'),
(23792, 1438999519, 1438999533, 'DE', 'DEU', 'ألمانيا'),
(23793, 1438999534, 1438999534, 'CH', 'CHE', 'سويسرا'),
(23794, 1438999535, 1438999791, 'DE', 'DEU', 'ألمانيا'),
(23795, 1438999792, 1438999807, 'GB', 'GBR', 'المملكة المتحدة'),
(23796, 1438999808, 1439000575, 'DE', 'DEU', 'ألمانيا'),
(23797, 1439000576, 1439002623, 'NL', 'NLD', 'هولندا'),
(23798, 1439002624, 1439006567, 'DE', 'DEU', 'ألمانيا'),
(23799, 1439006568, 1439006575, 'AT', 'AUT', 'النمسا'),
(23800, 1439006576, 1439006671, 'DE', 'DEU', 'ألمانيا'),
(23801, 1439006672, 1439006675, 'PL', 'POL', 'بولندا'),
(23802, 1439006676, 1439006719, 'DE', 'DEU', 'ألمانيا'),
(23803, 1439006720, 1439023103, 'SE', 'SWE', 'السويد'),
(23804, 1439023104, 1439039487, 'IS', 'ISL', 'أيسلندا'),
(23805, 1439039488, 1439055871, 'IR', 'IRN', 'إيران'),
(23806, 1439055872, 1439072255, 'RU', 'RUS', 'الإتحاد الروسي'),
(23807, 1439072256, 1439088639, 'UA', 'UKR', 'أوكرانيا'),
(23808, 1439088640, 1439105023, 'PL', 'POL', 'بولندا'),
(23809, 1439105024, 1439121407, 'AT', 'AUT', 'النمسا'),
(23810, 1439121408, 1439154175, 'DE', 'DEU', 'ألمانيا'),
(23811, 1439154176, 1439170559, 'GB', 'GBR', 'المملكة المتحدة'),
(23812, 1439170560, 1439236095, 'NO', 'NOR', 'النرويج'),
(23813, 1439236096, 1439301631, 'BE', 'BEL', 'بلجيكا'),
(23814, 1439301632, 1439305727, 'RU', 'RUS', 'الإتحاد الروسي'),
(23815, 1439305728, 1439309823, 'DK', 'DNK', 'الدنيمارك'),
(23816, 1439309824, 1439318015, 'PL', 'POL', 'بولندا'),
(23817, 1439318016, 1439322111, 'DK', 'DNK', 'الدنيمارك'),
(23818, 1439322112, 1439326207, 'RO', 'ROM', 'رومانيا'),
(23819, 1439326208, 1439330303, 'PL', 'POL', 'بولندا'),
(23820, 1439330304, 1439338495, 'RU', 'RUS', 'الإتحاد الروسي'),
(23821, 1439338496, 1439342591, 'PL', 'POL', 'بولندا'),
(23822, 1439342592, 1439346687, 'UA', 'UKR', 'أوكرانيا'),
(23823, 1439346688, 1439350783, 'RU', 'RUS', 'الإتحاد الروسي'),
(23824, 1439350784, 1439354879, 'UA', 'UKR', 'أوكرانيا'),
(23825, 1439354880, 1439358975, 'PL', 'POL', 'بولندا'),
(23826, 1439358976, 1439367167, 'RU', 'RUS', 'الإتحاد الروسي'),
(23827, 1439367168, 1439432703, 'NL', 'NLD', 'هولندا'),
(23828, 1439432704, 1439498239, 'RO', 'ROM', 'رومانيا'),
(23829, 1439498240, 1439514623, 'DE', 'DEU', 'ألمانيا'),
(23830, 1439514624, 1439516671, 'IT', 'ITA', 'إيطاليا'),
(23831, 1439516672, 1439518207, 'DE', 'DEU', 'ألمانيا'),
(23832, 1439518208, 1439518719, 'IT', 'ITA', 'إيطاليا'),
(23833, 1439518720, 1439529983, 'DE', 'DEU', 'ألمانيا'),
(23834, 1439529984, 1439530239, 'EG', 'EGY', 'مصر'),
(23835, 1439530240, 1439535103, 'DE', 'DEU', 'ألمانيا'),
(23836, 1439535104, 1439538175, 'IT', 'ITA', 'إيطاليا'),
(23837, 1439538176, 1439538687, 'DE', 'DEU', 'ألمانيا'),
(23838, 1439538688, 1439539199, 'IT', 'ITA', 'إيطاليا'),
(23839, 1439539200, 1439549439, 'DE', 'DEU', 'ألمانيا'),
(23840, 1439549440, 1439551487, 'IT', 'ITA', 'إيطاليا'),
(23841, 1439551488, 1439556095, 'DE', 'DEU', 'ألمانيا'),
(23842, 1439556096, 1439556607, 'IT', 'ITA', 'إيطاليا'),
(23843, 1439556608, 1439558143, 'DE', 'DEU', 'ألمانيا'),
(23844, 1439558144, 1439558911, 'IT', 'ITA', 'إيطاليا'),
(23845, 1439558912, 1439560191, 'DE', 'DEU', 'ألمانيا'),
(23846, 1439560192, 1439560447, 'IT', 'ITA', 'إيطاليا'),
(23847, 1439560448, 1439560703, 'DE', 'DEU', 'ألمانيا'),
(23848, 1439560704, 1439561215, 'IT', 'ITA', 'إيطاليا'),
(23849, 1439561216, 1439561727, 'DE', 'DEU', 'ألمانيا'),
(23850, 1439561728, 1439562239, 'GB', 'GBR', 'المملكة المتحدة'),
(23851, 1439562240, 1439562751, 'IE', 'IRL', 'إيرلندا'),
(23852, 1439562752, 1439562879, 'DE', 'DEU', 'ألمانيا'),
(23853, 1439562880, 1439563199, 'GB', 'GBR', 'المملكة المتحدة'),
(23854, 1439563200, 1439563775, 'DE', 'DEU', 'ألمانيا'),
(23855, 1439563776, 1439629311, 'LT', 'LTU', 'ليتوانيا'),
(23856, 1439629312, 1439694847, 'CZ', 'CZE', 'التشيك'),
(23857, 1439694848, 1439825919, 'SA', 'SAU', 'السعودية'),
(23858, 1439825920, 1439956991, 'GB', 'GBR', 'المملكة المتحدة'),
(23859, 1439956992, 1440251903, 'DE', 'DEU', 'ألمانيا'),
(23860, 1440251904, 1440284671, 'SK', 'SVK', 'سلوفاكيا'),
(23861, 1440284672, 1440317439, 'FI', 'FIN', 'فنلندا'),
(23862, 1440317440, 1440350207, 'BG', 'BGR', 'بلغاريا'),
(23863, 1440350208, 1440382975, 'CH', 'CHE', 'سويسرا'),
(23864, 1440382976, 1440415743, 'DK', 'DNK', 'الدنيمارك'),
(23865, 1440415744, 1440448511, 'ES', 'ESP', 'إسبانيا'),
(23866, 1440448512, 1440481279, 'PL', 'POL', 'بولندا'),
(23867, 1440481280, 1440514047, 'IS', 'ISL', 'أيسلندا'),
(23868, 1440514048, 1440546815, 'DE', 'DEU', 'ألمانيا'),
(23869, 1440546816, 1440579583, 'NO', 'NOR', 'النرويج'),
(23870, 1440579584, 1440645119, 'PL', 'POL', 'بولندا'),
(23871, 1440645120, 1440654591, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(23872, 1440654592, 1440659455, 'RS', 'SRB', 'صربيا'),
(23873, 1440659456, 1440661751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(23874, 1440661752, 1440662015, 'RS', 'SRB', 'صربيا'),
(23875, 1440662016, 1440663751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(23876, 1440663752, 1440663799, 'RS', 'SRB', 'صربيا'),
(23877, 1440663800, 1440668671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(23878, 1440668672, 1440669695, 'RS', 'SRB', 'صربيا'),
(23879, 1440669696, 1440677887, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(23880, 1440677888, 1440710655, 'NL', 'NLD', 'هولندا'),
(23881, 1440710656, 1440743423, 'UA', 'UKR', 'أوكرانيا'),
(23882, 1440743424, 1441267711, 'SE', 'SWE', 'السويد'),
(23883, 1441267712, 1441275903, 'DE', 'DEU', 'ألمانيا'),
(23884, 1441275904, 1441284095, 'GB', 'GBR', 'المملكة المتحدة'),
(23885, 1441284096, 1441292287, 'AT', 'AUT', 'النمسا'),
(23886, 1441292288, 1441300479, 'RU', 'RUS', 'الإتحاد الروسي'),
(23887, 1441300480, 1441308671, 'LT', 'LTU', 'ليتوانيا'),
(23888, 1441308672, 1441316863, 'SE', 'SWE', 'السويد'),
(23889, 1441316864, 1441325055, 'MT', 'MLT', 'مالطا'),
(23890, 1441325056, 1441327519, 'PL', 'POL', 'بولندا'),
(23891, 1441327520, 1441327551, 'SE', 'SWE', 'السويد'),
(23892, 1441327552, 1441333247, 'PL', 'POL', 'بولندا'),
(23893, 1441333248, 1441349631, 'DE', 'DEU', 'ألمانيا'),
(23894, 1441349632, 1441357823, 'RU', 'RUS', 'الإتحاد الروسي'),
(23895, 1441357824, 1441366015, 'AT', 'AUT', 'النمسا'),
(23896, 1441366016, 1441374207, 'RU', 'RUS', 'الإتحاد الروسي'),
(23897, 1441374208, 1441382399, 'GB', 'GBR', 'المملكة المتحدة'),
(23898, 1441382400, 1441384511, 'FR', 'FRA', 'فرنسا'),
(23899, 1441384512, 1441384543, 'US', 'USA', 'الولايات المتحدة'),
(23900, 1441384544, 1441384591, 'FR', 'FRA', 'فرنسا'),
(23901, 1441384592, 1441384599, 'AU', 'AUS', 'أستراليا'),
(23902, 1441384600, 1441384607, 'FR', 'FRA', 'فرنسا'),
(23903, 1441384608, 1441384639, 'CN', 'CHN', 'الصين'),
(23904, 1441384640, 1441385103, 'FR', 'FRA', 'فرنسا'),
(23905, 1441385104, 1441385119, 'ES', 'ESP', 'إسبانيا'),
(23906, 1441385120, 1441386111, 'FR', 'FRA', 'فرنسا'),
(23907, 1441386112, 1441386239, 'IL', 'ISR', 'إسرائيل'),
(23908, 1441386240, 1441390591, 'FR', 'FRA', 'فرنسا'),
(23909, 1441390592, 1441398783, 'DK', 'DNK', 'الدنيمارك'),
(23910, 1441398784, 1441415167, 'RU', 'RUS', 'الإتحاد الروسي'),
(23911, 1441415168, 1441423359, 'GB', 'GBR', 'المملكة المتحدة'),
(23912, 1441423360, 1441431551, 'RU', 'RUS', 'الإتحاد الروسي'),
(23913, 1441431552, 1441439743, 'GB', 'GBR', 'المملكة المتحدة'),
(23914, 1441439744, 1441447935, 'LV', 'LVA', 'لاتفيا'),
(23915, 1441447936, 1441456127, 'BE', 'BEL', 'بلجيكا'),
(23916, 1441456128, 1441464319, 'NL', 'NLD', 'هولندا'),
(23917, 1441464320, 1441468671, 'SE', 'SWE', 'السويد'),
(23918, 1441468672, 1441470719, 'DK', 'DNK', 'الدنيمارك'),
(23919, 1441470720, 1441472511, 'SE', 'SWE', 'السويد'),
(23920, 1441472512, 1441480703, 'RU', 'RUS', 'الإتحاد الروسي'),
(23921, 1441480704, 1441488895, 'TR', 'TUR', 'تركيا'),
(23922, 1441488896, 1441492223, 'GB', 'GBR', 'المملكة المتحدة'),
(23923, 1441492224, 1441492479, 'BE', 'BEL', 'بلجيكا'),
(23924, 1441492480, 1441497087, 'GB', 'GBR', 'المملكة المتحدة'),
(23925, 1441497088, 1441505279, 'IT', 'ITA', 'إيطاليا'),
(23926, 1441505280, 1441521663, 'RU', 'RUS', 'الإتحاد الروسي'),
(23927, 1441521664, 1441529855, 'DK', 'DNK', 'الدنيمارك'),
(23928, 1441529856, 1441538047, 'RU', 'RUS', 'الإتحاد الروسي'),
(23929, 1441538048, 1441543151, 'DE', 'DEU', 'ألمانيا'),
(23930, 1441543152, 1441543167, 'LI', 'LIE', 'ليختنشتاين'),
(23931, 1441543168, 1441543567, 'DE', 'DEU', 'ألمانيا'),
(23932, 1441543568, 1441543583, 'CH', 'CHE', 'سويسرا'),
(23933, 1441543584, 1441544063, 'DE', 'DEU', 'ألمانيا'),
(23934, 1441544064, 1441544127, 'TR', 'TUR', 'تركيا'),
(23935, 1441544128, 1441544143, 'DE', 'DEU', 'ألمانيا'),
(23936, 1441544144, 1441544159, 'CH', 'CHE', 'سويسرا'),
(23937, 1441544160, 1441545535, 'DE', 'DEU', 'ألمانيا'),
(23938, 1441545536, 1441545599, 'AT', 'AUT', 'النمسا'),
(23939, 1441545600, 1441546239, 'DE', 'DEU', 'ألمانيا'),
(23940, 1441546240, 1441554431, 'DK', 'DNK', 'الدنيمارك'),
(23941, 1441554432, 1441554687, 'GB', 'GBR', 'المملكة المتحدة'),
(23942, 1441554688, 1441554943, 'NL', 'NLD', 'هولندا'),
(23943, 1441554944, 1441557759, 'GB', 'GBR', 'المملكة المتحدة'),
(23944, 1441557760, 1441558015, 'NL', 'NLD', 'هولندا'),
(23945, 1441558016, 1441562623, 'GB', 'GBR', 'المملكة المتحدة'),
(23946, 1441562624, 1441564671, 'IQ', 'IRQ', 'العراق'),
(23947, 1441564672, 1441566719, 'PK', 'PAK', 'باكستان'),
(23948, 1441566720, 1441570815, 'IR', 'IRN', 'إيران'),
(23949, 1441570816, 1441579007, 'RU', 'RUS', 'الإتحاد الروسي'),
(23950, 1441579008, 1441582975, 'DE', 'DEU', 'ألمانيا'),
(23951, 1441582976, 1441583103, 'US', 'USA', 'الولايات المتحدة'),
(23952, 1441583104, 1441587199, 'DE', 'DEU', 'ألمانيا'),
(23953, 1441587200, 1441594879, 'AT', 'AUT', 'النمسا'),
(23954, 1441594880, 1441595135, 'DE', 'DEU', 'ألمانيا'),
(23955, 1441595136, 1441596415, 'AT', 'AUT', 'النمسا'),
(23956, 1441596416, 1441602815, 'SK', 'SVK', 'سلوفاكيا'),
(23957, 1441602816, 1441603071, 'AT', 'AUT', 'النمسا'),
(23958, 1441603072, 1441603583, 'SK', 'SVK', 'سلوفاكيا'),
(23959, 1441603584, 1441611775, 'RU', 'RUS', 'الإتحاد الروسي'),
(23960, 1441611776, 1441619967, 'DE', 'DEU', 'ألمانيا'),
(23961, 1441619968, 1441620271, 'FR', 'FRA', 'فرنسا'),
(23962, 1441620272, 1441620287, 'ES', 'ESP', 'إسبانيا'),
(23963, 1441620288, 1441620407, 'FR', 'FRA', 'فرنسا'),
(23964, 1441620408, 1441620411, 'ES', 'ESP', 'إسبانيا'),
(23965, 1441620412, 1441620735, 'FR', 'FRA', 'فرنسا'),
(23966, 1441620736, 1441620767, 'ES', 'ESP', 'إسبانيا'),
(23967, 1441620768, 1441620895, 'FR', 'FRA', 'فرنسا'),
(23968, 1441620896, 1441620927, 'PT', 'PRT', 'البورتوغال'),
(23969, 1441620928, 1441628159, 'FR', 'FRA', 'فرنسا'),
(23970, 1441628160, 1441636351, 'SA', 'SAU', 'السعودية'),
(23971, 1441636352, 1441644543, 'PL', 'POL', 'بولندا'),
(23972, 1441644544, 1441652735, 'GB', 'GBR', 'المملكة المتحدة'),
(23973, 1441652736, 1441660927, 'SK', 'SVK', 'سلوفاكيا'),
(23974, 1441660928, 1441669119, 'ES', 'ESP', 'إسبانيا'),
(23975, 1441669120, 1441677311, 'GE', 'GEO', 'جورجيا'),
(23976, 1441677312, 1441685503, 'HU', 'HUN', 'هنغاريا'),
(23977, 1441685504, 1441693695, 'UA', 'UKR', 'أوكرانيا'),
(23978, 1441693696, 1441694719, 'BR', 'BRA', 'البرازيل'),
(23979, 1441694720, 1441695743, 'DE', 'DEU', 'ألمانيا'),
(23980, 1441695744, 1441696767, 'US', 'USA', 'الولايات المتحدة'),
(23981, 1441696768, 1441697791, 'SG', 'SGP', 'سنغافورة'),
(23982, 1441697792, 1441698815, 'US', 'USA', 'الولايات المتحدة'),
(23983, 1441698816, 1441701887, 'DE', 'DEU', 'ألمانيا'),
(23984, 1441701888, 1441710079, 'AT', 'AUT', 'النمسا'),
(23985, 1441710080, 1441718271, 'SE', 'SWE', 'السويد'),
(23986, 1441718272, 1441726463, 'DE', 'DEU', 'ألمانيا'),
(23987, 1441726464, 1441729023, 'KW', 'KWT', 'الكويت'),
(23988, 1441729024, 1441729535, 'SG', 'SGP', 'سنغافورة'),
(23989, 1441729536, 1441734655, 'KW', 'KWT', 'الكويت'),
(23990, 1441734656, 1441742847, 'RU', 'RUS', 'الإتحاد الروسي'),
(23991, 1441742848, 1441751039, 'CZ', 'CZE', 'التشيك'),
(23992, 1441751040, 1441759231, 'DE', 'DEU', 'ألمانيا'),
(23993, 1441759232, 1441767423, 'BG', 'BGR', 'بلغاريا'),
(23994, 1441767424, 1441775615, 'IT', 'ITA', 'إيطاليا'),
(23995, 1441775616, 1441783807, 'ES', 'ESP', 'إسبانيا'),
(23996, 1441783808, 1441791999, 'CZ', 'CZE', 'التشيك'),
(23997, 1441792000, 1442316287, 'PT', 'PRT', 'البورتوغال'),
(23998, 1442316288, 1442316583, 'SK', 'SVK', 'سلوفاكيا'),
(23999, 1442316584, 1442316591, 'DE', 'DEU', 'ألمانيا'),
(24000, 1442316592, 1442321455, 'SK', 'SVK', 'سلوفاكيا'),
(24001, 1442321456, 1442321463, 'DE', 'DEU', 'ألمانيا'),
(24002, 1442321464, 1442332927, 'SK', 'SVK', 'سلوفاكيا'),
(24003, 1442332928, 1442333055, 'BE', 'BEL', 'بلجيكا'),
(24004, 1442333056, 1442381823, 'SK', 'SVK', 'سلوفاكيا'),
(24005, 1442381824, 1442447359, 'RU', 'RUS', 'الإتحاد الروسي'),
(24006, 1442447360, 1442512895, 'IL', 'ISR', 'إسرائيل'),
(24007, 1442512896, 1442578431, 'ES', 'ESP', 'إسبانيا'),
(24008, 1442578432, 1442643967, 'NO', 'NOR', 'النرويج'),
(24009, 1442643968, 1442709503, 'EE', 'EST', 'إستونيا'),
(24010, 1442709504, 1442775039, 'LV', 'LVA', 'لاتفيا'),
(24011, 1442775040, 1442779135, 'PL', 'POL', 'بولندا'),
(24012, 1442779136, 1442783231, 'DE', 'DEU', 'ألمانيا'),
(24013, 1442783232, 1442787327, 'NO', 'NOR', 'النرويج'),
(24014, 1442787328, 1442791423, 'LT', 'LTU', 'ليتوانيا'),
(24015, 1442791424, 1442795519, 'LV', 'LVA', 'لاتفيا'),
(24016, 1442795520, 1442799615, 'DE', 'DEU', 'ألمانيا'),
(24017, 1442799616, 1442803711, 'LT', 'LTU', 'ليتوانيا'),
(24018, 1442803712, 1442807807, 'UA', 'UKR', 'أوكرانيا'),
(24019, 1442807808, 1442811903, 'BG', 'BGR', 'بلغاريا'),
(24020, 1442811904, 1442815999, 'AT', 'AUT', 'النمسا'),
(24021, 1442816000, 1442820095, 'BG', 'BGR', 'بلغاريا'),
(24022, 1442820096, 1442824191, 'PL', 'POL', 'بولندا'),
(24023, 1442824192, 1442828287, 'BE', 'BEL', 'بلجيكا'),
(24024, 1442828288, 1442832383, 'NL', 'NLD', 'هولندا'),
(24025, 1442832384, 1442836479, 'GB', 'GBR', 'المملكة المتحدة'),
(24026, 1442836480, 1442840575, 'PL', 'POL', 'بولندا'),
(24027, 1442840576, 1444937727, 'GB', 'GBR', 'المملكة المتحدة'),
(24028, 1444937728, 1445068799, 'AT', 'AUT', 'النمسا'),
(24029, 1445068800, 1445199871, 'RO', 'ROM', 'رومانيا'),
(24030, 1445199872, 1445330943, 'QA', 'QAT', 'قطر'),
(24031, 1445330944, 1445396479, 'LT', 'LTU', 'ليتوانيا'),
(24032, 1445396480, 1445462015, 'BE', 'BEL', 'بلجيكا'),
(24033, 1445462016, 1445986303, 'IE', 'IRL', 'إيرلندا'),
(24034, 1445986304, 1446051839, 'DK', 'DNK', 'الدنيمارك'),
(24035, 1446051840, 1446117375, 'CZ', 'CZE', 'التشيك'),
(24036, 1446117376, 1446182911, 'FI', 'FIN', 'فنلندا'),
(24037, 1446182912, 1446248447, 'SA', 'SAU', 'السعودية'),
(24038, 1446248448, 1446313983, 'DK', 'DNK', 'الدنيمارك'),
(24039, 1446313984, 1446445055, 'GB', 'GBR', 'المملكة المتحدة'),
(24040, 1446445056, 1446510591, 'RO', 'ROM', 'رومانيا'),
(24041, 1446510592, 1446543359, 'DE', 'DEU', 'ألمانيا'),
(24042, 1446543360, 1446576127, 'AT', 'AUT', 'النمسا'),
(24043, 1446576128, 1446608895, 'IR', 'IRN', 'إيران'),
(24044, 1446608896, 1446641663, 'BY', 'BLR', 'روسيا البيضاء'),
(24045, 1446641664, 1446674431, 'SI', 'SVN', 'سلوفينيا'),
(24046, 1446674432, 1446707175, 'DK', 'DNK', 'الدنيمارك'),
(24047, 1446707176, 1446707179, 'NO', 'NOR', 'النرويج'),
(24048, 1446707180, 1446707183, 'FI', 'FIN', 'فنلندا'),
(24049, 1446707184, 1446707199, 'DK', 'DNK', 'الدنيمارك'),
(24050, 1446707200, 1446710687, 'AT', 'AUT', 'النمسا'),
(24051, 1446710688, 1446710703, 'ES', 'ESP', 'إسبانيا'),
(24052, 1446710704, 1446739967, 'AT', 'AUT', 'النمسا'),
(24053, 1446739968, 1446772735, 'RU', 'RUS', 'الإتحاد الروسي'),
(24054, 1446772736, 1446805503, 'SA', 'SAU', 'السعودية'),
(24055, 1446805504, 1446838271, 'FI', 'FIN', 'فنلندا'),
(24056, 1446838272, 1446862079, 'SI', 'SVN', 'سلوفينيا'),
(24057, 1446862080, 1446862591, 'HR', 'HRV', 'كرواتيا'),
(24058, 1446862592, 1446871039, 'SI', 'SVN', 'سلوفينيا'),
(24059, 1446871040, 1446903807, 'CZ', 'CZE', 'التشيك'),
(24060, 1446903808, 1446904071, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24061, 1446904072, 1446904079, 'CY', 'CYP', 'قبرص'),
(24062, 1446904080, 1446904095, 'BH', 'BHR', 'البحرين'),
(24063, 1446904096, 1446904111, 'SA', 'SAU', 'السعودية'),
(24064, 1446904112, 1446904119, 'BH', 'BHR', 'البحرين'),
(24065, 1446904120, 1446904127, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24066, 1446904128, 1446904135, 'SA', 'SAU', 'السعودية'),
(24067, 1446904136, 1446904143, 'IQ', 'IRQ', 'العراق'),
(24068, 1446904144, 1446904151, 'SA', 'SAU', 'السعودية'),
(24069, 1446904152, 1446904159, 'IR', 'IRN', 'إيران'),
(24070, 1446904160, 1446904167, 'ES', 'ESP', 'إسبانيا'),
(24071, 1446904168, 1446904175, 'IQ', 'IRQ', 'العراق'),
(24072, 1446904176, 1446904831, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24073, 1446904832, 1446904835, 'LY', 'LBY', 'ليبيا'),
(24074, 1446904836, 1446920191, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24075, 1446920192, 1446936575, 'RU', 'RUS', 'الإتحاد الروسي'),
(24076, 1446936576, 1446952959, 'NO', 'NOR', 'النرويج'),
(24077, 1446952960, 1446969343, 'QA', 'QAT', 'قطر'),
(24078, 1446969344, 1446985727, 'GB', 'GBR', 'المملكة المتحدة'),
(24079, 1446985728, 1447010303, 'PL', 'POL', 'بولندا'),
(24080, 1447010304, 1447018495, 'LV', 'LVA', 'لاتفيا'),
(24081, 1447018496, 1447019007, 'CZ', 'CZE', 'التشيك'),
(24082, 1447019008, 1447019023, 'BZ', 'BLZ', 'بليز'),
(24083, 1447019024, 1447026687, 'CZ', 'CZE', 'التشيك'),
(24084, 1447026688, 1447169375, 'FR', 'FRA', 'فرنسا'),
(24085, 1447169376, 1447169391, 'TN', 'TUN', 'تونس'),
(24086, 1447169392, 1448083455, 'FR', 'FRA', 'فرنسا'),
(24087, 1448083456, 1449132031, 'NL', 'NLD', 'هولندا'),
(24088, 1449132032, 1449394175, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24089, 1449394176, 1449459711, 'LT', 'LTU', 'ليتوانيا'),
(24090, 1449459712, 1449525247, 'HU', 'HUN', 'هنغاريا'),
(24091, 1449525248, 1449590783, 'RU', 'RUS', 'الإتحاد الروسي'),
(24092, 1449590784, 1449656319, 'DE', 'DEU', 'ألمانيا'),
(24093, 1449656320, 1449717759, 'RO', 'ROM', 'رومانيا'),
(24094, 1449717760, 1449718783, 'MD', 'MDA', 'مولدوفا'),
(24095, 1449718784, 1449808639, 'RO', 'ROM', 'رومانيا'),
(24096, 1449808640, 1449808895, 'UA', 'UKR', 'أوكرانيا'),
(24097, 1449808896, 1449840639, 'RO', 'ROM', 'رومانيا'),
(24098, 1449840640, 1449852927, 'MD', 'MDA', 'مولدوفا'),
(24099, 1449852928, 1449918463, 'RO', 'ROM', 'رومانيا'),
(24100, 1449918464, 1449951231, 'JO', 'JOR', 'الأردن'),
(24101, 1449951232, 1449983999, 'TR', 'TUR', 'تركيا'),
(24102, 1449984000, 1449992191, 'NL', 'NLD', 'هولندا'),
(24103, 1449992192, 1450000383, 'IR', 'IRN', 'إيران'),
(24104, 1450000384, 1450008575, 'HU', 'HUN', 'هنغاريا'),
(24105, 1450008576, 1450016767, 'ES', 'ESP', 'إسبانيا'),
(24106, 1450016768, 1450024959, 'IT', 'ITA', 'إيطاليا'),
(24107, 1450024960, 1450033151, 'ES', 'ESP', 'إسبانيا'),
(24108, 1450033152, 1450041343, 'RU', 'RUS', 'الإتحاد الروسي'),
(24109, 1450041344, 1450049535, 'DE', 'DEU', 'ألمانيا'),
(24110, 1450049536, 1450057727, 'RU', 'RUS', 'الإتحاد الروسي'),
(24111, 1450057728, 1450065919, 'EE', 'EST', 'إستونيا'),
(24112, 1450065920, 1450074111, 'DE', 'DEU', 'ألمانيا'),
(24113, 1450074112, 1450082303, 'RU', 'RUS', 'الإتحاد الروسي'),
(24114, 1450082304, 1450090495, 'IT', 'ITA', 'إيطاليا'),
(24115, 1450090496, 1450106879, 'RU', 'RUS', 'الإتحاد الروسي'),
(24116, 1450106880, 1450115071, 'SK', 'SVK', 'سلوفاكيا'),
(24117, 1450115072, 1450123263, 'RU', 'RUS', 'الإتحاد الروسي'),
(24118, 1450123264, 1450131455, 'AT', 'AUT', 'النمسا'),
(24119, 1450131456, 1450139647, 'UA', 'UKR', 'أوكرانيا'),
(24120, 1450139648, 1450147839, 'PL', 'POL', 'بولندا'),
(24121, 1450147840, 1450156031, 'RU', 'RUS', 'الإتحاد الروسي'),
(24122, 1450156032, 1450164223, 'GB', 'GBR', 'المملكة المتحدة'),
(24123, 1450164224, 1450166271, 'SA', 'SAU', 'السعودية'),
(24124, 1450166272, 1450168319, 'PL', 'POL', 'بولندا'),
(24125, 1450170368, 1450172415, 'GB', 'GBR', 'المملكة المتحدة'),
(24126, 1450172416, 1450174463, 'UA', 'UKR', 'أوكرانيا'),
(24127, 1450174464, 1450176511, 'DE', 'DEU', 'ألمانيا'),
(24128, 1450176512, 1450178559, 'PL', 'POL', 'بولندا'),
(24129, 1450178560, 1450180607, 'DE', 'DEU', 'ألمانيا'),
(24130, 1450180608, 1450311679, 'GB', 'GBR', 'المملكة المتحدة'),
(24131, 1450311680, 1450442751, 'FI', 'FIN', 'فنلندا'),
(24132, 1450442752, 1450704895, 'CH', 'CHE', 'سويسرا'),
(24133, 1450704896, 1451173887, 'RO', 'ROM', 'رومانيا'),
(24134, 1451173888, 1451175935, 'HU', 'HUN', 'هنغاريا'),
(24135, 1451175936, 1451229183, 'RO', 'ROM', 'رومانيا'),
(24136, 1451229184, 1455423487, 'GB', 'GBR', 'المملكة المتحدة'),
(24137, 1455423488, 1459617791, 'FR', 'FRA', 'فرنسا'),
(24138, 1459617792, 1461714943, 'IT', 'ITA', 'إيطاليا'),
(24139, 1461714944, 1462763519, 'IE', 'IRL', 'إيرلندا'),
(24140, 1462763520, 1463812095, 'DK', 'DNK', 'الدنيمارك'),
(24141, 1463812096, 1464074239, 'BE', 'BEL', 'بلجيكا'),
(24142, 1464074240, 1464336383, 'IL', 'ISR', 'إسرائيل'),
(24143, 1464336384, 1464467455, 'DK', 'DNK', 'الدنيمارك'),
(24144, 1464467456, 1464598527, 'GB', 'GBR', 'المملكة المتحدة'),
(24145, 1464664064, 1464860671, 'DE', 'DEU', 'ألمانيا'),
(24146, 1464860672, 1465384959, 'GB', 'GBR', 'المملكة المتحدة'),
(24147, 1465384960, 1465647103, 'FR', 'FRA', 'فرنسا'),
(24148, 1465647104, 1465909247, 'FI', 'FIN', 'فنلندا'),
(24149, 1465909248, 1465942015, 'PL', 'POL', 'بولندا'),
(24150, 1465942016, 1465974783, 'SE', 'SWE', 'السويد'),
(24151, 1465974784, 1466007551, 'HU', 'HUN', 'هنغاريا'),
(24152, 1466007552, 1466040319, 'BG', 'BGR', 'بلغاريا'),
(24153, 1466040320, 1466073087, 'EE', 'EST', 'إستونيا'),
(24154, 1466073088, 1466097663, 'FR', 'FRA', 'فرنسا'),
(24155, 1466097664, 1466099711, 'ES', 'ESP', 'إسبانيا'),
(24156, 1466099712, 1466101759, 'PL', 'POL', 'بولندا'),
(24157, 1466101760, 1466103807, 'DE', 'DEU', 'ألمانيا'),
(24158, 1466103808, 1466104575, 'GB', 'GBR', 'المملكة المتحدة'),
(24159, 1466104576, 1466104831, 'FR', 'FRA', 'فرنسا'),
(24160, 1466104832, 1466105343, 'BE', 'BEL', 'بلجيكا'),
(24161, 1466105344, 1466105855, 'GB', 'GBR', 'المملكة المتحدة'),
(24162, 1466105856, 1466122239, 'PL', 'POL', 'بولندا'),
(24163, 1466122240, 1466130431, 'LV', 'LVA', 'لاتفيا'),
(24164, 1466130432, 1466138623, 'PL', 'POL', 'بولندا'),
(24165, 1466138624, 1466171391, 'SE', 'SWE', 'السويد'),
(24166, 1466171392, 1466204159, 'FR', 'FRA', 'فرنسا'),
(24167, 1466204160, 1466236927, 'FI', 'FIN', 'فنلندا'),
(24168, 1466236928, 1466241023, 'NL', 'NLD', 'هولندا'),
(24169, 1466241024, 1466249215, 'PL', 'POL', 'بولندا'),
(24170, 1466249216, 1466253311, 'GR', 'GRC', 'اليونان'),
(24171, 1466253312, 1466257407, 'PL', 'POL', 'بولندا'),
(24172, 1466257408, 1466261503, 'GR', 'GRC', 'اليونان'),
(24173, 1466261504, 1466265599, 'GB', 'GBR', 'المملكة المتحدة'),
(24174, 1466265600, 1466269695, 'HU', 'HUN', 'هنغاريا'),
(24175, 1466269696, 1466302463, 'SA', 'SAU', 'السعودية'),
(24176, 1466302464, 1466335231, 'GB', 'GBR', 'المملكة المتحدة'),
(24177, 1466335232, 1466367999, 'CH', 'CHE', 'سويسرا'),
(24178, 1466368000, 1466400767, 'PT', 'PRT', 'البورتوغال'),
(24179, 1466400768, 1466433535, 'RU', 'RUS', 'الإتحاد الروسي'),
(24180, 1466433536, 1466499071, 'DK', 'DNK', 'الدنيمارك'),
(24181, 1466499072, 1466564607, 'PL', 'POL', 'بولندا'),
(24182, 1466564608, 1466589183, 'DE', 'DEU', 'ألمانيا'),
(24183, 1466589184, 1466590207, 'FR', 'FRA', 'فرنسا'),
(24184, 1466590208, 1466592255, 'GB', 'GBR', 'المملكة المتحدة'),
(24185, 1466592256, 1466592511, 'FR', 'FRA', 'فرنسا'),
(24186, 1466592512, 1466592767, 'GB', 'GBR', 'المملكة المتحدة'),
(24187, 1466592768, 1466593279, 'FR', 'FRA', 'فرنسا'),
(24188, 1466593280, 1466606847, 'DE', 'DEU', 'ألمانيا'),
(24189, 1466606848, 1466607103, 'FR', 'FRA', 'فرنسا'),
(24190, 1466607104, 1466613759, 'DE', 'DEU', 'ألمانيا'),
(24191, 1466613760, 1466615807, 'ES', 'ESP', 'إسبانيا'),
(24192, 1466615808, 1466616575, 'GB', 'GBR', 'المملكة المتحدة'),
(24193, 1466616576, 1466617343, 'ES', 'ESP', 'إسبانيا'),
(24194, 1466617344, 1466617471, 'FR', 'FRA', 'فرنسا'),
(24195, 1466617472, 1466617599, 'GB', 'GBR', 'المملكة المتحدة'),
(24196, 1466617600, 1466617855, 'ES', 'ESP', 'إسبانيا'),
(24197, 1466617856, 1466630143, 'DE', 'DEU', 'ألمانيا'),
(24198, 1466630144, 1466695679, 'IR', 'IRN', 'إيران'),
(24199, 1466695680, 1466761215, 'FI', 'FIN', 'فنلندا'),
(24200, 1466761216, 1466826751, 'SA', 'SAU', 'السعودية'),
(24201, 1466826752, 1466886399, 'LV', 'LVA', 'لاتفيا'),
(24202, 1466886400, 1466886655, 'LT', 'LTU', 'ليتوانيا'),
(24203, 1466886656, 1466892287, 'LV', 'LVA', 'لاتفيا'),
(24204, 1466892288, 1466957823, 'ES', 'ESP', 'إسبانيا'),
(24205, 1466957824, 1467219967, 'GB', 'GBR', 'المملكة المتحدة'),
(24206, 1467219968, 1467236351, 'DK', 'DNK', 'الدنيمارك'),
(24207, 1467236352, 1467252735, 'BG', 'BGR', 'بلغاريا'),
(24208, 1467252736, 1467269119, 'RS', 'SRB', 'صربيا'),
(24209, 1467269120, 1467285503, 'PL', 'POL', 'بولندا'),
(24210, 1467285504, 1467301887, 'RU', 'RUS', 'الإتحاد الروسي'),
(24211, 1467301888, 1467318271, 'GB', 'GBR', 'المملكة المتحدة'),
(24212, 1467318272, 1467334655, 'RU', 'RUS', 'الإتحاد الروسي'),
(24213, 1467334656, 1467344127, 'GB', 'GBR', 'المملكة المتحدة'),
(24214, 1467344128, 1467344383, 'CA', 'CAN', 'كندا'),
(24215, 1467344384, 1467347903, 'GB', 'GBR', 'المملكة المتحدة'),
(24216, 1467347904, 1467347935, 'SE', 'SWE', 'السويد'),
(24217, 1467347936, 1467351039, 'GB', 'GBR', 'المملكة المتحدة'),
(24218, 1467351040, 1467367423, 'NO', 'NOR', 'النرويج'),
(24219, 1467367424, 1467367615, 'DE', 'DEU', 'ألمانيا'),
(24220, 1467367616, 1467367647, 'SE', 'SWE', 'السويد'),
(24221, 1467367648, 1467367679, 'DE', 'DEU', 'ألمانيا'),
(24222, 1467367680, 1467367695, 'IT', 'ITA', 'إيطاليا'),
(24223, 1467367696, 1467367871, 'DE', 'DEU', 'ألمانيا'),
(24224, 1467367872, 1467367903, 'SE', 'SWE', 'السويد'),
(24225, 1467367904, 1467367935, 'DE', 'DEU', 'ألمانيا'),
(24226, 1467367936, 1467368191, 'SI', 'SVN', 'سلوفينيا'),
(24227, 1467368192, 1467368319, 'DK', 'DNK', 'الدنيمارك'),
(24228, 1467368320, 1467369519, 'DE', 'DEU', 'ألمانيا'),
(24229, 1467369520, 1467369535, 'RU', 'RUS', 'الإتحاد الروسي'),
(24230, 1467369536, 1467369599, 'DE', 'DEU', 'ألمانيا'),
(24231, 1467369600, 1467369663, 'IT', 'ITA', 'إيطاليا'),
(24232, 1467369664, 1467369727, 'AT', 'AUT', 'النمسا'),
(24233, 1467369728, 1467369759, 'DE', 'DEU', 'ألمانيا'),
(24234, 1467369760, 1467369791, 'HR', 'HRV', 'كرواتيا'),
(24235, 1467369792, 1467369855, 'SE', 'SWE', 'السويد'),
(24236, 1467369856, 1467369887, 'DE', 'DEU', 'ألمانيا'),
(24237, 1467369888, 1467369903, 'RU', 'RUS', 'الإتحاد الروسي'),
(24238, 1467369904, 1467383807, 'DE', 'DEU', 'ألمانيا'),
(24239, 1467383808, 1467400191, 'BG', 'BGR', 'بلغاريا'),
(24240, 1467400192, 1467416575, 'RU', 'RUS', 'الإتحاد الروسي'),
(24241, 1467416576, 1467432959, 'PL', 'POL', 'بولندا'),
(24242, 1467432960, 1467449343, 'BG', 'BGR', 'بلغاريا'),
(24243, 1467449344, 1467457535, 'SI', 'SVN', 'سلوفينيا'),
(24244, 1467457536, 1467465727, 'EE', 'EST', 'إستونيا'),
(24245, 1467465728, 1467465759, 'NL', 'NLD', 'هولندا'),
(24246, 1467465760, 1467465791, 'AT', 'AUT', 'النمسا'),
(24247, 1467465792, 1467465799, 'NL', 'NLD', 'هولندا'),
(24248, 1467465800, 1467465807, 'AT', 'AUT', 'النمسا'),
(24249, 1467465808, 1467465823, 'NL', 'NLD', 'هولندا'),
(24250, 1467465824, 1467465855, 'AT', 'AUT', 'النمسا'),
(24251, 1467465856, 1467466015, 'NL', 'NLD', 'هولندا'),
(24252, 1467466016, 1467466023, 'DE', 'DEU', 'ألمانيا'),
(24253, 1467466024, 1467466031, 'AT', 'AUT', 'النمسا'),
(24254, 1467466032, 1467466111, 'NL', 'NLD', 'هولندا'),
(24255, 1467466112, 1467466143, 'DE', 'DEU', 'ألمانيا'),
(24256, 1467466144, 1467466175, 'NL', 'NLD', 'هولندا'),
(24257, 1467466176, 1467466191, 'DE', 'DEU', 'ألمانيا'),
(24258, 1467466192, 1467466207, 'NL', 'NLD', 'هولندا'),
(24259, 1467466208, 1467466215, 'DE', 'DEU', 'ألمانيا'),
(24260, 1467466216, 1467466223, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(24261, 1467466224, 1467466239, 'NL', 'NLD', 'هولندا'),
(24262, 1467466240, 1467466271, 'DE', 'DEU', 'ألمانيا'),
(24263, 1467466272, 1467466495, 'NL', 'NLD', 'هولندا'),
(24264, 1467466496, 1467467071, 'DE', 'DEU', 'ألمانيا'),
(24265, 1467467072, 1467467103, 'CH', 'CHE', 'سويسرا'),
(24266, 1467467104, 1467467903, 'DE', 'DEU', 'ألمانيا'),
(24267, 1467467904, 1467468031, 'CH', 'CHE', 'سويسرا'),
(24268, 1467468032, 1467468111, 'DE', 'DEU', 'ألمانيا'),
(24269, 1467468112, 1467468119, 'BR', 'BRA', 'البرازيل'),
(24270, 1467468120, 1467473919, 'DE', 'DEU', 'ألمانيا'),
(24271, 1467473920, 1467482111, 'RU', 'RUS', 'الإتحاد الروسي'),
(24272, 1467482112, 1467613183, 'BG', 'BGR', 'بلغاريا'),
(24273, 1467613184, 1467744255, 'DE', 'DEU', 'ألمانيا'),
(24274, 1467744256, 1467875327, 'GB', 'GBR', 'المملكة المتحدة'),
(24275, 1467875328, 1467940863, 'BG', 'BGR', 'بلغاريا'),
(24276, 1467940864, 1468006399, 'GB', 'GBR', 'المملكة المتحدة'),
(24277, 1468006400, 1472200703, 'DE', 'DEU', 'ألمانيا'),
(24278, 1472200704, 1472226463, 'IE', 'IRL', 'إيرلندا'),
(24279, 1472226464, 1472226479, 'GB', 'GBR', 'المملكة المتحدة'),
(24280, 1472226480, 1472259207, 'IE', 'IRL', 'إيرلندا'),
(24281, 1472259208, 1472259231, 'GB', 'GBR', 'المملكة المتحدة'),
(24282, 1472259232, 1472259247, 'IE', 'IRL', 'إيرلندا'),
(24283, 1472259248, 1472259255, 'GB', 'GBR', 'المملكة المتحدة'),
(24284, 1472259256, 1472264799, 'IE', 'IRL', 'إيرلندا'),
(24285, 1472264800, 1472264807, 'GB', 'GBR', 'المملكة المتحدة'),
(24286, 1472264808, 1472266239, 'IE', 'IRL', 'إيرلندا'),
(24287, 1472266240, 1472331775, 'DE', 'DEU', 'ألمانيا'),
(24288, 1472331776, 1472397311, 'GB', 'GBR', 'المملكة المتحدة'),
(24289, 1472397312, 1472462847, 'NL', 'NLD', 'هولندا'),
(24290, 1472462848, 1472528383, 'PT', 'PRT', 'البورتوغال'),
(24291, 1472528384, 1472593919, 'SK', 'SVK', 'سلوفاكيا'),
(24292, 1472593920, 1472659455, 'IE', 'IRL', 'إيرلندا'),
(24293, 1472659456, 1472724991, 'PL', 'POL', 'بولندا'),
(24294, 1472724992, 1472856063, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24295, 1472856064, 1472987135, 'GR', 'GRC', 'اليونان'),
(24296, 1472987136, 1473249279, 'PL', 'POL', 'بولندا'),
(24297, 1473249280, 1473724415, 'NL', 'NLD', 'هولندا'),
(24298, 1473724416, 1473740799, 'BE', 'BEL', 'بلجيكا'),
(24299, 1473740800, 1473773567, 'NL', 'NLD', 'هولندا'),
(24300, 1473773568, 1474297855, 'ES', 'ESP', 'إسبانيا'),
(24301, 1474297856, 1474330623, 'GB', 'GBR', 'المملكة المتحدة'),
(24302, 1474330624, 1474396159, 'RU', 'RUS', 'الإتحاد الروسي'),
(24303, 1474396160, 1474428927, 'DE', 'DEU', 'ألمانيا'),
(24304, 1474428928, 1474461695, 'LV', 'LVA', 'لاتفيا'),
(24305, 1474461696, 1474494463, 'RU', 'RUS', 'الإتحاد الروسي'),
(24306, 1474494464, 1474527231, 'SE', 'SWE', 'السويد'),
(24307, 1474527232, 1474559999, 'BG', 'BGR', 'بلغاريا'),
(24308, 1474560000, 1474592767, 'RU', 'RUS', 'الإتحاد الروسي'),
(24309, 1474592768, 1474625535, 'CY', 'CYP', 'قبرص'),
(24310, 1474625536, 1474658303, 'HU', 'HUN', 'هنغاريا'),
(24311, 1474658304, 1474691071, 'RU', 'RUS', 'الإتحاد الروسي'),
(24312, 1474691072, 1474723839, 'DE', 'DEU', 'ألمانيا'),
(24313, 1474723840, 1474756607, 'SA', 'SAU', 'السعودية'),
(24314, 1474756608, 1474822143, 'FR', 'FRA', 'فرنسا'),
(24315, 1474822144, 1474887679, 'IE', 'IRL', 'إيرلندا'),
(24316, 1474887680, 1474953215, 'NL', 'NLD', 'هولندا'),
(24317, 1474953216, 1475018751, 'DE', 'DEU', 'ألمانيا'),
(24318, 1475018752, 1475084287, 'ES', 'ESP', 'إسبانيا'),
(24319, 1475084288, 1475086335, 'NL', 'NLD', 'هولندا'),
(24320, 1475086336, 1475092479, 'RU', 'RUS', 'الإتحاد الروسي'),
(24321, 1475092480, 1475094527, 'CY', 'CYP', 'قبرص'),
(24322, 1475094528, 1475096575, 'RU', 'RUS', 'الإتحاد الروسي'),
(24323, 1475096576, 1475098623, 'BH', 'BHR', 'البحرين'),
(24324, 1475098624, 1475101695, 'GB', 'GBR', 'المملكة المتحدة'),
(24325, 1475101696, 1475102207, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(24326, 1475102208, 1475102719, 'GB', 'GBR', 'المملكة المتحدة'),
(24327, 1475102720, 1475104767, 'FR', 'FRA', 'فرنسا'),
(24328, 1475104768, 1475106815, 'RU', 'RUS', 'الإتحاد الروسي'),
(24329, 1475106816, 1475108863, 'GB', 'GBR', 'المملكة المتحدة'),
(24330, 1475108864, 1475110911, 'NL', 'NLD', 'هولندا'),
(24331, 1475110912, 1475112959, 'DE', 'DEU', 'ألمانيا'),
(24332, 1475112960, 1475115007, 'AT', 'AUT', 'النمسا'),
(24333, 1475115008, 1475117055, 'KW', 'KWT', 'الكويت'),
(24334, 1475117056, 1475119103, 'GB', 'GBR', 'المملكة المتحدة'),
(24335, 1475119104, 1475121151, 'BH', 'BHR', 'البحرين'),
(24336, 1475121152, 1475121919, 'GB', 'GBR', 'المملكة المتحدة'),
(24337, 1475121920, 1475122175, 'US', 'USA', 'الولايات المتحدة'),
(24338, 1475122176, 1475123199, 'GB', 'GBR', 'المملكة المتحدة'),
(24339, 1475123200, 1475125247, 'FI', 'FIN', 'فنلندا'),
(24340, 1475125248, 1475127295, 'IT', 'ITA', 'إيطاليا'),
(24341, 1475127296, 1475129343, 'FI', 'FIN', 'فنلندا'),
(24342, 1475129344, 1475131391, 'BE', 'BEL', 'بلجيكا'),
(24343, 1475131392, 1475133439, 'RU', 'RUS', 'الإتحاد الروسي'),
(24344, 1475133440, 1475135487, 'CZ', 'CZE', 'التشيك'),
(24345, 1475135488, 1475137535, 'CH', 'CHE', 'سويسرا'),
(24346, 1475137536, 1475139583, 'SE', 'SWE', 'السويد'),
(24347, 1475139584, 1475141631, 'BE', 'BEL', 'بلجيكا'),
(24348, 1475141632, 1475143679, 'FI', 'FIN', 'فنلندا'),
(24349, 1475143680, 1475145727, 'JO', 'JOR', 'الأردن'),
(24350, 1475145728, 1475147775, 'ES', 'ESP', 'إسبانيا'),
(24351, 1475147776, 1475149823, 'GB', 'GBR', 'المملكة المتحدة'),
(24352, 1475149824, 1475151871, 'NL', 'NLD', 'هولندا'),
(24353, 1475151872, 1475153919, 'BE', 'BEL', 'بلجيكا'),
(24354, 1475153920, 1475155967, 'GB', 'GBR', 'المملكة المتحدة'),
(24355, 1475155968, 1475158015, 'NL', 'NLD', 'هولندا'),
(24356, 1475158016, 1475160063, 'IS', 'ISL', 'أيسلندا'),
(24357, 1475160064, 1475162111, 'RU', 'RUS', 'الإتحاد الروسي'),
(24358, 1475162112, 1475170303, 'GB', 'GBR', 'المملكة المتحدة'),
(24359, 1475170304, 1475172351, 'ES', 'ESP', 'إسبانيا'),
(24360, 1475172352, 1475174399, 'DE', 'DEU', 'ألمانيا'),
(24361, 1475174400, 1475175047, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(24362, 1475175048, 1475175055, 'US', 'USA', 'الولايات المتحدة'),
(24363, 1475175056, 1475176447, 'NL', 'NLD', 'هولندا'),
(24364, 1475176448, 1475178495, 'RO', 'ROM', 'رومانيا'),
(24365, 1475178496, 1475180543, 'RU', 'RUS', 'الإتحاد الروسي'),
(24366, 1475180544, 1475184639, 'DE', 'DEU', 'ألمانيا'),
(24367, 1475184640, 1475186687, 'RU', 'RUS', 'الإتحاد الروسي'),
(24368, 1475186688, 1475188735, 'ES', 'ESP', 'إسبانيا'),
(24369, 1475188736, 1475190783, 'SE', 'SWE', 'السويد'),
(24370, 1475190784, 1475192831, 'GB', 'GBR', 'المملكة المتحدة'),
(24371, 1475192832, 1475194879, 'CH', 'CHE', 'سويسرا'),
(24372, 1475194880, 1475196927, 'DE', 'DEU', 'ألمانيا'),
(24373, 1475196928, 1475197071, 'FR', 'FRA', 'فرنسا'),
(24374, 1475197072, 1475197079, 'DZ', 'DZA', 'الجزائر'),
(24375, 1475197080, 1475197791, 'FR', 'FRA', 'فرنسا'),
(24376, 1475197792, 1475197807, 'ES', 'ESP', 'إسبانيا'),
(24377, 1475197808, 1475198975, 'FR', 'FRA', 'فرنسا'),
(24378, 1475198976, 1475201023, 'BH', 'BHR', 'البحرين'),
(24379, 1475201024, 1475203071, 'RS', 'SRB', 'صربيا'),
(24380, 1475203072, 1475205119, 'SE', 'SWE', 'السويد'),
(24381, 1475205120, 1475205887, 'DE', 'DEU', 'ألمانيا'),
(24382, 1475205888, 1475206143, 'US', 'USA', 'الولايات المتحدة'),
(24383, 1475206144, 1475206207, 'JP', 'JPN', 'اليابان'),
(24384, 1475206208, 1475206271, 'US', 'USA', 'الولايات المتحدة'),
(24385, 1475206272, 1475206383, 'DE', 'DEU', 'ألمانيا'),
(24386, 1475206384, 1475206399, 'NL', 'NLD', 'هولندا'),
(24387, 1475206400, 1475206655, 'HK', 'HKG', 'هونغ كونغ'),
(24388, 1475206656, 1475206911, 'DE', 'DEU', 'ألمانيا'),
(24389, 1475206912, 1475206927, 'NL', 'NLD', 'هولندا'),
(24390, 1475206928, 1475206943, 'FR', 'FRA', 'فرنسا'),
(24391, 1475206944, 1475206959, 'PT', 'PRT', 'البورتوغال'),
(24392, 1475206960, 1475206975, 'GB', 'GBR', 'المملكة المتحدة'),
(24393, 1475206976, 1475206991, 'IT', 'ITA', 'إيطاليا'),
(24394, 1475206992, 1475207007, 'SE', 'SWE', 'السويد'),
(24395, 1475207008, 1475207023, 'RU', 'RUS', 'الإتحاد الروسي'),
(24396, 1475207024, 1475207039, 'ES', 'ESP', 'إسبانيا'),
(24397, 1475207040, 1475207055, 'AU', 'AUS', 'أستراليا'),
(24398, 1475207056, 1475207071, 'KR', 'KOR', 'جمهورية كوريا'),
(24399, 1475207072, 1475207087, 'CH', 'CHE', 'سويسرا'),
(24400, 1475207088, 1475207103, 'JP', 'JPN', 'اليابان'),
(24401, 1475207104, 1475207135, 'KR', 'KOR', 'جمهورية كوريا'),
(24402, 1475207136, 1475207147, 'DE', 'DEU', 'ألمانيا'),
(24403, 1475207148, 1475207167, 'US', 'USA', 'الولايات المتحدة'),
(24404, 1475207168, 1475207263, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24405, 1475207264, 1475207295, 'US', 'USA', 'الولايات المتحدة'),
(24406, 1475207296, 1475207423, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24407, 1475207424, 1475207679, 'GR', 'GRC', 'اليونان'),
(24408, 1475207680, 1475208191, 'SA', 'SAU', 'السعودية'),
(24409, 1475208192, 1475209215, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24410, 1475209216, 1475211263, 'UZ', 'UZB', 'أوزباكستان'),
(24411, 1475211264, 1475213311, 'DE', 'DEU', 'ألمانيا'),
(24412, 1475213312, 1475215359, 'FR', 'FRA', 'فرنسا'),
(24413, 1475215360, 1475223551, 'IT', 'ITA', 'إيطاليا'),
(24414, 1475223552, 1475229695, 'NO', 'NOR', 'النرويج'),
(24415, 1475229696, 1475229759, 'SE', 'SWE', 'السويد'),
(24416, 1475229760, 1475229951, 'NO', 'NOR', 'النرويج'),
(24417, 1475229952, 1475229987, 'SE', 'SWE', 'السويد'),
(24418, 1475229988, 1475233791, 'NO', 'NOR', 'النرويج'),
(24419, 1475233792, 1475234303, 'GB', 'GBR', 'المملكة المتحدة'),
(24420, 1475234304, 1475234559, 'IE', 'IRL', 'إيرلندا'),
(24421, 1475234560, 1475235839, 'GB', 'GBR', 'المملكة المتحدة'),
(24422, 1475235840, 1475237887, 'IE', 'IRL', 'إيرلندا'),
(24423, 1475237888, 1475239935, 'ES', 'ESP', 'إسبانيا'),
(24424, 1475239936, 1475241983, 'RU', 'RUS', 'الإتحاد الروسي'),
(24425, 1475241984, 1475244031, 'MC', 'MCO', 'موناكو'),
(24426, 1475244032, 1475244287, 'DE', 'DEU', 'ألمانيا'),
(24427, 1475244288, 1475244543, 'CV', 'CPV', 'الرأس الأخضر'),
(24428, 1475244544, 1475245055, 'DE', 'DEU', 'ألمانيا'),
(24429, 1475245056, 1475245183, 'IE', 'IRL', 'إيرلندا'),
(24430, 1475245184, 1475245311, 'DE', 'DEU', 'ألمانيا'),
(24431, 1475245312, 1475245567, 'CV', 'CPV', 'الرأس الأخضر'),
(24432, 1475245568, 1475246078, 'SA', 'SAU', 'السعودية'),
(24433, 1475246080, 1475248127, 'DE', 'DEU', 'ألمانيا'),
(24434, 1475248128, 1475250175, 'JO', 'JOR', 'الأردن'),
(24435, 1475250176, 1475252223, 'DE', 'DEU', 'ألمانيا'),
(24436, 1475252224, 1475254271, 'FR', 'FRA', 'فرنسا'),
(24437, 1475254272, 1475256319, 'UA', 'UKR', 'أوكرانيا'),
(24438, 1475256320, 1475257120, 'BE', 'BEL', 'بلجيكا'),
(24439, 1475257121, 1475257121, 'NL', 'NLD', 'هولندا'),
(24440, 1475257122, 1475257136, 'BE', 'BEL', 'بلجيكا'),
(24441, 1475257137, 1475257137, 'FR', 'FRA', 'فرنسا'),
(24442, 1475257138, 1475257275, 'BE', 'BEL', 'بلجيكا'),
(24443, 1475257276, 1475257276, 'NL', 'NLD', 'هولندا'),
(24444, 1475257277, 1475257277, 'GB', 'GBR', 'المملكة المتحدة'),
(24445, 1475257278, 1475257278, 'BE', 'BEL', 'بلجيكا'),
(24446, 1475257279, 1475257280, 'GB', 'GBR', 'المملكة المتحدة'),
(24447, 1475257281, 1475257282, 'NL', 'NLD', 'هولندا'),
(24448, 1475257283, 1475257286, 'BE', 'BEL', 'بلجيكا'),
(24449, 1475257287, 1475257287, 'NL', 'NLD', 'هولندا'),
(24450, 1475257288, 1475257290, 'BE', 'BEL', 'بلجيكا'),
(24451, 1475257291, 1475257291, 'DE', 'DEU', 'ألمانيا'),
(24452, 1475257292, 1475257295, 'BE', 'BEL', 'بلجيكا'),
(24453, 1475257296, 1475257296, 'GB', 'GBR', 'المملكة المتحدة'),
(24454, 1475257297, 1475257297, 'NL', 'NLD', 'هولندا'),
(24455, 1475257298, 1475257298, 'BE', 'BEL', 'بلجيكا'),
(24456, 1475257299, 1475257299, 'ES', 'ESP', 'إسبانيا'),
(24457, 1475257300, 1475257300, 'GB', 'GBR', 'المملكة المتحدة'),
(24458, 1475257301, 1475258175, 'BE', 'BEL', 'بلجيكا'),
(24459, 1475258176, 1475258207, 'NL', 'NLD', 'هولندا'),
(24460, 1475258208, 1475258239, 'DE', 'DEU', 'ألمانيا'),
(24461, 1475258240, 1475258367, 'BE', 'BEL', 'بلجيكا'),
(24462, 1475258368, 1475260415, 'NL', 'NLD', 'هولندا'),
(24463, 1475260416, 1475262463, 'FR', 'FRA', 'فرنسا'),
(24464, 1475262464, 1475266559, 'DE', 'DEU', 'ألمانيا'),
(24465, 1475266560, 1475268607, 'GB', 'GBR', 'المملكة المتحدة'),
(24466, 1475268608, 1475270655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24467, 1475270656, 1475272703, 'GB', 'GBR', 'المملكة المتحدة'),
(24468, 1475272704, 1475274751, 'BE', 'BEL', 'بلجيكا'),
(24469, 1475274752, 1475276799, 'RU', 'RUS', 'الإتحاد الروسي'),
(24470, 1475276800, 1475278847, 'ES', 'ESP', 'إسبانيا'),
(24471, 1475278848, 1475280895, 'DK', 'DNK', 'الدنيمارك'),
(24472, 1475280896, 1475282943, 'PL', 'POL', 'بولندا'),
(24473, 1475282944, 1475284991, 'NL', 'NLD', 'هولندا'),
(24474, 1475284992, 1475287039, 'GB', 'GBR', 'المملكة المتحدة'),
(24475, 1475287040, 1475291135, 'RU', 'RUS', 'الإتحاد الروسي'),
(24476, 1475291136, 1475293183, 'PL', 'POL', 'بولندا'),
(24477, 1475293184, 1475295231, 'GB', 'GBR', 'المملكة المتحدة'),
(24478, 1475295232, 1475299327, 'DK', 'DNK', 'الدنيمارك'),
(24479, 1475299328, 1475301375, 'PL', 'POL', 'بولندا'),
(24480, 1475301376, 1475303423, 'LT', 'LTU', 'ليتوانيا'),
(24481, 1475303424, 1475305471, 'PL', 'POL', 'بولندا'),
(24482, 1475305472, 1475307519, 'NL', 'NLD', 'هولندا'),
(24483, 1475307520, 1475309567, 'RU', 'RUS', 'الإتحاد الروسي'),
(24484, 1475309568, 1475311615, 'LT', 'LTU', 'ليتوانيا'),
(24485, 1475311616, 1475313663, 'FI', 'FIN', 'فنلندا'),
(24486, 1475313664, 1475317759, 'DE', 'DEU', 'ألمانيا'),
(24487, 1475317760, 1475319807, 'RU', 'RUS', 'الإتحاد الروسي'),
(24488, 1475319808, 1475321855, 'BG', 'BGR', 'بلغاريا'),
(24489, 1475321856, 1475323903, 'RO', 'ROM', 'رومانيا'),
(24490, 1475323904, 1475327999, 'PL', 'POL', 'بولندا'),
(24491, 1475328000, 1475330047, 'DE', 'DEU', 'ألمانيا'),
(24492, 1475330048, 1475332095, 'PL', 'POL', 'بولندا'),
(24493, 1475332096, 1475334143, 'LI', 'LIE', 'ليختنشتاين'),
(24494, 1475334144, 1475336191, 'CH', 'CHE', 'سويسرا'),
(24495, 1475336192, 1475338239, 'PL', 'POL', 'بولندا'),
(24496, 1475338240, 1475340287, 'RO', 'ROM', 'رومانيا'),
(24497, 1475340288, 1475342335, 'GR', 'GRC', 'اليونان'),
(24498, 1475342336, 1475344383, 'PL', 'POL', 'بولندا'),
(24499, 1475344384, 1475346431, 'RO', 'ROM', 'رومانيا'),
(24500, 1475346432, 1475362815, 'RU', 'RUS', 'الإتحاد الروسي'),
(24501, 1475362816, 1475379199, 'FR', 'FRA', 'فرنسا'),
(24502, 1475379200, 1475395583, 'RU', 'RUS', 'الإتحاد الروسي'),
(24503, 1475395584, 1475411967, 'LU', 'LUX', 'لوكسيمبورغ'),
(24504, 1475411968, 1475412471, 'IT', 'ITA', 'إيطاليا'),
(24505, 1475412472, 1475412479, 'ES', 'ESP', 'إسبانيا'),
(24506, 1475412480, 1475414927, 'IT', 'ITA', 'إيطاليا'),
(24507, 1475414928, 1475414935, 'GB', 'GBR', 'المملكة المتحدة'),
(24508, 1475414936, 1475421239, 'IT', 'ITA', 'إيطاليا'),
(24509, 1475421240, 1475421247, 'FR', 'FRA', 'فرنسا'),
(24510, 1475421248, 1475427207, 'IT', 'ITA', 'إيطاليا'),
(24511, 1475427208, 1475427215, 'FR', 'FRA', 'فرنسا'),
(24512, 1475427216, 1475428351, 'IT', 'ITA', 'إيطاليا'),
(24513, 1475428352, 1475444735, 'SE', 'SWE', 'السويد'),
(24514, 1475444736, 1475461119, 'AM', 'ARM', 'أرمينيا'),
(24515, 1475461120, 1475477503, 'RU', 'RUS', 'الإتحاد الروسي'),
(24516, 1475477504, 1475493887, 'HU', 'HUN', 'هنغاريا'),
(24517, 1475493888, 1475510271, 'RU', 'RUS', 'الإتحاد الروسي'),
(24518, 1475510272, 1475543039, 'GB', 'GBR', 'المملكة المتحدة'),
(24519, 1475559424, 1475575807, 'GR', 'GRC', 'اليونان'),
(24520, 1475575808, 1475592191, 'AT', 'AUT', 'النمسا'),
(24521, 1475592192, 1475608575, 'GB', 'GBR', 'المملكة المتحدة'),
(24522, 1475608576, 1475624959, 'RU', 'RUS', 'الإتحاد الروسي'),
(24523, 1475624960, 1475627662, 'GB', 'GBR', 'المملكة المتحدة'),
(24524, 1475627663, 1475627663, 'JE', 'JEY', 'جيرسي'),
(24525, 1475627664, 1475627688, 'GB', 'GBR', 'المملكة المتحدة'),
(24526, 1475627689, 1475627695, 'JE', 'JEY', 'جيرسي'),
(24527, 1475627696, 1475628287, 'GB', 'GBR', 'المملكة المتحدة'),
(24528, 1475628288, 1475629055, 'JE', 'JEY', 'جيرسي'),
(24529, 1475629056, 1475634175, 'GB', 'GBR', 'المملكة المتحدة'),
(24530, 1475634176, 1475634431, 'JE', 'JEY', 'جيرسي'),
(24531, 1475634432, 1475634495, 'GB', 'GBR', 'المملكة المتحدة'),
(24532, 1475634496, 1475634559, 'JE', 'JEY', 'جيرسي'),
(24533, 1475634560, 1475634719, 'GB', 'GBR', 'المملكة المتحدة'),
(24534, 1475634720, 1475634727, 'JE', 'JEY', 'جيرسي'),
(24535, 1475634728, 1475634735, 'GB', 'GBR', 'المملكة المتحدة'),
(24536, 1475634736, 1475634751, 'JE', 'JEY', 'جيرسي'),
(24537, 1475634752, 1475634759, 'GB', 'GBR', 'المملكة المتحدة'),
(24538, 1475634760, 1475634967, 'JE', 'JEY', 'جيرسي'),
(24539, 1475634968, 1475634975, 'GB', 'GBR', 'المملكة المتحدة'),
(24540, 1475634976, 1475635199, 'JE', 'JEY', 'جيرسي'),
(24541, 1475635200, 1475636399, 'GB', 'GBR', 'المملكة المتحدة'),
(24542, 1475636400, 1475636415, 'JE', 'JEY', 'جيرسي'),
(24543, 1475636416, 1475636431, 'GB', 'GBR', 'المملكة المتحدة'),
(24544, 1475636432, 1475636479, 'JE', 'JEY', 'جيرسي'),
(24545, 1475636480, 1475639182, 'GB', 'GBR', 'المملكة المتحدة'),
(24546, 1475639183, 1475639183, 'JE', 'JEY', 'جيرسي'),
(24547, 1475639184, 1475639199, 'GB', 'GBR', 'المملكة المتحدة'),
(24548, 1475639200, 1475639207, 'JE', 'JEY', 'جيرسي'),
(24549, 1475639208, 1475639216, 'GB', 'GBR', 'المملكة المتحدة'),
(24550, 1475639217, 1475639223, 'JE', 'JEY', 'جيرسي'),
(24551, 1475639224, 1475639263, 'GB', 'GBR', 'المملكة المتحدة'),
(24552, 1475639264, 1475639271, 'BB', 'BRB', 'باربادوس'),
(24553, 1475639272, 1475639279, 'JE', 'JEY', 'جيرسي'),
(24554, 1475639280, 1475639287, 'GB', 'GBR', 'المملكة المتحدة'),
(24555, 1475639288, 1475639295, 'JE', 'JEY', 'جيرسي'),
(24556, 1475639296, 1475639343, 'GB', 'GBR', 'المملكة المتحدة'),
(24557, 1475639344, 1475639351, 'JE', 'JEY', 'جيرسي'),
(24558, 1475639352, 1475639367, 'GB', 'GBR', 'المملكة المتحدة'),
(24559, 1475639368, 1475639383, 'JE', 'JEY', 'جيرسي'),
(24560, 1475639384, 1475639595, 'GB', 'GBR', 'المملكة المتحدة'),
(24561, 1475639596, 1475639599, 'JE', 'JEY', 'جيرسي'),
(24562, 1475639600, 1475639727, 'GB', 'GBR', 'المملكة المتحدة'),
(24563, 1475639728, 1475639735, 'JE', 'JEY', 'جيرسي'),
(24564, 1475639736, 1475639775, 'GB', 'GBR', 'المملكة المتحدة'),
(24565, 1475639776, 1475639783, 'JE', 'JEY', 'جيرسي'),
(24566, 1475639784, 1475641087, 'GB', 'GBR', 'المملكة المتحدة'),
(24567, 1475641088, 1475641343, 'JE', 'JEY', 'جيرسي'),
(24568, 1475641344, 1475657727, 'UA', 'UKR', 'أوكرانيا'),
(24569, 1475657728, 1475664263, 'SK', 'SVK', 'سلوفاكيا'),
(24570, 1475664264, 1475664271, 'UA', 'UKR', 'أوكرانيا'),
(24571, 1475664272, 1475674111, 'SK', 'SVK', 'سلوفاكيا'),
(24572, 1475674112, 1475690495, 'DE', 'DEU', 'ألمانيا'),
(24573, 1475690496, 1475706879, 'CH', 'CHE', 'سويسرا'),
(24574, 1475706880, 1475723263, 'RU', 'RUS', 'الإتحاد الروسي'),
(24575, 1475723264, 1475725311, 'CY', 'CYP', 'قبرص'),
(24576, 1475725312, 1475725951, 'RU', 'RUS', 'الإتحاد الروسي'),
(24577, 1475725952, 1475729407, 'GB', 'GBR', 'المملكة المتحدة'),
(24578, 1475729408, 1475731455, 'UA', 'UKR', 'أوكرانيا'),
(24579, 1475731456, 1475739647, 'GB', 'GBR', 'المملكة المتحدة'),
(24580, 1475739648, 1475756031, 'BG', 'BGR', 'بلغاريا'),
(24581, 1475756032, 1475772415, 'GB', 'GBR', 'المملكة المتحدة'),
(24582, 1475772416, 1475788799, 'LV', 'LVA', 'لاتفيا'),
(24583, 1475788800, 1475805183, 'PL', 'POL', 'بولندا'),
(24584, 1475805184, 1475821567, 'KZ', 'KAZ', 'كازاخستان'),
(24585, 1475821568, 1475837951, 'LT', 'LTU', 'ليتوانيا'),
(24586, 1475837952, 1475846143, 'GB', 'GBR', 'المملكة المتحدة'),
(24587, 1475846144, 1475854335, 'IR', 'IRN', 'إيران'),
(24588, 1475854336, 1475862527, 'AT', 'AUT', 'النمسا'),
(24589, 1475862528, 1475866623, 'IT', 'ITA', 'إيطاليا'),
(24590, 1475866624, 1475868671, 'GB', 'GBR', 'المملكة المتحدة'),
(24591, 1475868672, 1475870719, 'BG', 'BGR', 'بلغاريا'),
(24592, 1475870720, 1475878911, 'NO', 'NOR', 'النرويج'),
(24593, 1475878912, 1475887103, 'IT', 'ITA', 'إيطاليا'),
(24594, 1475887104, 1475895295, 'PL', 'POL', 'بولندا'),
(24595, 1475895296, 1475895551, 'GB', 'GBR', 'المملكة المتحدة'),
(24596, 1475895552, 1475897343, 'IE', 'IRL', 'إيرلندا'),
(24597, 1475897344, 1475899903, 'GB', 'GBR', 'المملكة المتحدة'),
(24598, 1475899904, 1475901439, 'IE', 'IRL', 'إيرلندا'),
(24599, 1475901440, 1475903487, 'CH', 'CHE', 'سويسرا'),
(24600, 1475903488, 1475911679, 'IR', 'IRN', 'إيران'),
(24601, 1475911680, 1475919871, 'MD', 'MDA', 'مولدوفا'),
(24602, 1475919872, 1475928063, 'GB', 'GBR', 'المملكة المتحدة'),
(24603, 1475928064, 1475952639, 'RU', 'RUS', 'الإتحاد الروسي'),
(24604, 1475952640, 1475953151, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24605, 1475953152, 1475955199, 'GB', 'GBR', 'المملكة المتحدة'),
(24606, 1475955200, 1475955839, 'NG', 'NGA', 'نيجيريا'),
(24607, 1475955840, 1475955967, 'GH', 'GHA', 'غانا'),
(24608, 1475955968, 1475956223, 'GB', 'GBR', 'المملكة المتحدة'),
(24609, 1475956224, 1475956607, 'NG', 'NGA', 'نيجيريا'),
(24610, 1475956608, 1475956735, 'GH', 'GHA', 'غانا'),
(24611, 1475956736, 1475957503, 'GB', 'GBR', 'المملكة المتحدة'),
(24612, 1475957504, 1475957759, 'IN', 'IND', 'الهند'),
(24613, 1475957760, 1475958015, 'AF', 'AFG', 'أفغانستان'),
(24614, 1475958016, 1475959039, 'GB', 'GBR', 'المملكة المتحدة'),
(24615, 1475959040, 1475959047, 'US', 'USA', 'الولايات المتحدة'),
(24616, 1475959048, 1475960831, 'GB', 'GBR', 'المملكة المتحدة'),
(24617, 1475960832, 1475969023, 'NL', 'NLD', 'هولندا'),
(24618, 1475969024, 1475977215, 'CZ', 'CZE', 'التشيك'),
(24619, 1475977216, 1475985407, 'SE', 'SWE', 'السويد'),
(24620, 1475985408, 1476009983, 'RU', 'RUS', 'الإتحاد الروسي'),
(24621, 1476009984, 1476010047, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24622, 1476010048, 1476010111, 'RS', 'SRB', 'صربيا'),
(24623, 1476010112, 1476011327, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24624, 1476011328, 1476011391, 'RS', 'SRB', 'صربيا'),
(24625, 1476011392, 1476012095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24626, 1476012096, 1476012287, 'RS', 'SRB', 'صربيا'),
(24627, 1476012288, 1476013375, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24628, 1476013376, 1476013567, 'RS', 'SRB', 'صربيا'),
(24629, 1476013568, 1476014103, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24630, 1476014104, 1476014111, 'RS', 'SRB', 'صربيا'),
(24631, 1476014112, 1476014135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24632, 1476014136, 1476014335, 'RS', 'SRB', 'صربيا'),
(24633, 1476014336, 1476015615, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24634, 1476015616, 1476016639, 'RS', 'SRB', 'صربيا'),
(24635, 1476016640, 1476018175, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24636, 1476018176, 1476026367, 'IT', 'ITA', 'إيطاليا'),
(24637, 1476026368, 1476034559, 'BA', 'BIH', 'البوسنه والهرسك'),
(24638, 1476034560, 1476042751, 'NL', 'NLD', 'هولندا'),
(24639, 1476042752, 1476050943, 'PL', 'POL', 'بولندا'),
(24640, 1476050944, 1476067327, 'RU', 'RUS', 'الإتحاد الروسي'),
(24641, 1476067328, 1476075519, 'TR', 'TUR', 'تركيا'),
(24642, 1476075520, 1476077911, 'NL', 'NLD', 'هولندا'),
(24643, 1476077912, 1476077919, 'DE', 'DEU', 'ألمانيا'),
(24644, 1476077920, 1476079551, 'NL', 'NLD', 'هولندا'),
(24645, 1476079552, 1476079567, 'DE', 'DEU', 'ألمانيا'),
(24646, 1476079568, 1476083711, 'NL', 'NLD', 'هولندا'),
(24647, 1476083712, 1476116479, 'RU', 'RUS', 'الإتحاد الروسي'),
(24648, 1476116480, 1476124671, 'SE', 'SWE', 'السويد'),
(24649, 1476124672, 1476132863, 'PL', 'POL', 'بولندا'),
(24650, 1476132864, 1476134911, 'FR', 'FRA', 'فرنسا'),
(24651, 1476134912, 1476135167, 'GB', 'GBR', 'المملكة المتحدة'),
(24652, 1476135168, 1476141055, 'FR', 'FRA', 'فرنسا'),
(24653, 1476141056, 1476149247, 'GB', 'GBR', 'المملكة المتحدة'),
(24654, 1476149248, 1476157439, 'NO', 'NOR', 'النرويج'),
(24655, 1476157440, 1476165375, 'BH', 'BHR', 'البحرين'),
(24656, 1476165376, 1476165631, 'JO', 'JOR', 'الأردن'),
(24657, 1476165632, 1476173823, 'HR', 'HRV', 'كرواتيا'),
(24658, 1476173824, 1476182015, 'BG', 'BGR', 'بلغاريا'),
(24659, 1476182016, 1476190207, 'IE', 'IRL', 'إيرلندا'),
(24660, 1476190208, 1476198399, 'BY', 'BLR', 'روسيا البيضاء'),
(24661, 1476198400, 1476206591, 'RU', 'RUS', 'الإتحاد الروسي'),
(24662, 1476206592, 1476214783, 'GE', 'GEO', 'جورجيا'),
(24663, 1476214784, 1476222975, 'SE', 'SWE', 'السويد'),
(24664, 1476222976, 1476231167, 'IT', 'ITA', 'إيطاليا'),
(24665, 1476231168, 1476239359, 'NL', 'NLD', 'هولندا'),
(24666, 1476239360, 1476247551, 'DE', 'DEU', 'ألمانيا'),
(24667, 1476247552, 1476263935, 'RU', 'RUS', 'الإتحاد الروسي'),
(24668, 1476263936, 1476272127, 'GB', 'GBR', 'المملكة المتحدة'),
(24669, 1476272128, 1476280319, 'NO', 'NOR', 'النرويج'),
(24670, 1476280320, 1476288511, 'GB', 'GBR', 'المملكة المتحدة'),
(24671, 1476288512, 1476296703, 'LU', 'LUX', 'لوكسيمبورغ'),
(24672, 1476296704, 1476304895, 'RU', 'RUS', 'الإتحاد الروسي'),
(24673, 1476304896, 1476313087, 'BG', 'BGR', 'بلغاريا'),
(24674, 1476313088, 1476315135, 'FI', 'FIN', 'فنلندا'),
(24675, 1476315136, 1476316159, 'US', 'USA', 'الولايات المتحدة'),
(24676, 1476316160, 1476321279, 'FI', 'FIN', 'فنلندا'),
(24677, 1476321280, 1476329471, 'MC', 'MCO', 'موناكو'),
(24678, 1476329472, 1476337663, 'RU', 'RUS', 'الإتحاد الروسي'),
(24679, 1476337664, 1476345855, 'NL', 'NLD', 'هولندا'),
(24680, 1476345856, 1476354047, 'MD', 'MDA', 'مولدوفا'),
(24681, 1476362240, 1476370431, 'FR', 'FRA', 'فرنسا'),
(24682, 1476370432, 1476378623, 'SE', 'SWE', 'السويد'),
(24683, 1476378624, 1476386815, 'KZ', 'KAZ', 'كازاخستان'),
(24684, 1476386816, 1476395007, 'RU', 'RUS', 'الإتحاد الروسي'),
(24685, 1476395008, 1478492159, 'ES', 'ESP', 'إسبانيا'),
(24686, 1478492160, 1480589311, 'IT', 'ITA', 'إيطاليا'),
(24687, 1480589312, 1481637887, 'DE', 'DEU', 'ألمانيا'),
(24688, 1481637888, 1481646079, 'SE', 'SWE', 'السويد'),
(24689, 1481646080, 1481654271, 'RU', 'RUS', 'الإتحاد الروسي'),
(24690, 1481654272, 1481662463, 'IT', 'ITA', 'إيطاليا'),
(24691, 1481662464, 1481678847, 'BG', 'BGR', 'بلغاريا'),
(24692, 1481678848, 1481679743, 'SE', 'SWE', 'السويد'),
(24693, 1481679744, 1481679775, 'GB', 'GBR', 'المملكة المتحدة'),
(24694, 1481679776, 1481680639, 'SE', 'SWE', 'السويد'),
(24695, 1481680640, 1481680643, 'GB', 'GBR', 'المملكة المتحدة'),
(24696, 1481680644, 1481687039, 'SE', 'SWE', 'السويد'),
(24697, 1481687040, 1481691071, 'DE', 'DEU', 'ألمانيا'),
(24698, 1481691072, 1481691135, 'ES', 'ESP', 'إسبانيا'),
(24699, 1481691136, 1481695231, 'DE', 'DEU', 'ألمانيا'),
(24700, 1481695232, 1481703423, 'SK', 'SVK', 'سلوفاكيا'),
(24701, 1481703424, 1481711615, 'SA', 'SAU', 'السعودية'),
(24702, 1481711616, 1481719807, 'RU', 'RUS', 'الإتحاد الروسي'),
(24703, 1481719808, 1481727999, 'CZ', 'CZE', 'التشيك'),
(24704, 1481728000, 1481736191, 'IE', 'IRL', 'إيرلندا'),
(24705, 1481736192, 1481744383, 'GB', 'GBR', 'المملكة المتحدة'),
(24706, 1481744384, 1481752575, 'IT', 'ITA', 'إيطاليا'),
(24707, 1481752576, 1481760767, 'RU', 'RUS', 'الإتحاد الروسي'),
(24708, 1481760768, 1481768959, 'UA', 'UKR', 'أوكرانيا'),
(24709, 1481768960, 1481777151, 'GB', 'GBR', 'المملكة المتحدة'),
(24710, 1481777152, 1481785343, 'BE', 'BEL', 'بلجيكا'),
(24711, 1481785344, 1481793535, 'RU', 'RUS', 'الإتحاد الروسي'),
(24712, 1481793536, 1481801727, 'LI', 'LIE', 'ليختنشتاين'),
(24713, 1481801728, 1481809919, 'GB', 'GBR', 'المملكة المتحدة'),
(24714, 1481809920, 1481818111, 'RU', 'RUS', 'الإتحاد الروسي'),
(24715, 1481818112, 1481826303, 'ES', 'ESP', 'إسبانيا'),
(24716, 1481826304, 1481834495, 'DE', 'DEU', 'ألمانيا'),
(24717, 1481834496, 1481842687, 'GL', 'GRL', 'غرينلاند'),
(24718, 1481842688, 1481850879, 'SE', 'SWE', 'السويد'),
(24719, 1481850880, 1481859071, 'DK', 'DNK', 'الدنيمارك'),
(24720, 1481859072, 1481867263, 'GB', 'GBR', 'المملكة المتحدة'),
(24721, 1481867264, 1481875455, 'SE', 'SWE', 'السويد'),
(24722, 1481875456, 1481883647, 'CZ', 'CZE', 'التشيك'),
(24723, 1481883648, 1481891839, 'RU', 'RUS', 'الإتحاد الروسي'),
(24724, 1481891840, 1481893119, 'CZ', 'CZE', 'التشيك'),
(24725, 1481893120, 1481893375, 'SK', 'SVK', 'سلوفاكيا'),
(24726, 1481893376, 1481893631, 'CZ', 'CZE', 'التشيك'),
(24727, 1481893632, 1481893887, 'SK', 'SVK', 'سلوفاكيا'),
(24728, 1481893888, 1481900031, 'CZ', 'CZE', 'التشيك'),
(24729, 1481900032, 1481908223, 'CH', 'CHE', 'سويسرا'),
(24730, 1481908224, 1481916415, 'NO', 'NOR', 'النرويج'),
(24731, 1481916416, 1481924607, 'ES', 'ESP', 'إسبانيا'),
(24732, 1481924608, 1481932799, 'SA', 'SAU', 'السعودية'),
(24733, 1481932800, 1481940991, 'DE', 'DEU', 'ألمانيا'),
(24734, 1481940992, 1481949183, 'NO', 'NOR', 'النرويج'),
(24735, 1481949184, 1481957375, 'RU', 'RUS', 'الإتحاد الروسي'),
(24736, 1481957376, 1481965567, 'SE', 'SWE', 'السويد'),
(24737, 1481965568, 1481973759, 'CH', 'CHE', 'سويسرا'),
(24738, 1481973760, 1481981951, 'FO', 'FRO', 'جزر فارو'),
(24739, 1481981952, 1481984127, 'NL', 'NLD', 'هولندا'),
(24740, 1481984128, 1481984255, 'PA', 'PAN', 'بنما'),
(24741, 1481984256, 1481984383, 'NL', 'NLD', 'هولندا'),
(24742, 1481984384, 1481984511, 'GI', 'GIB', 'جبل طارق'),
(24743, 1481984512, 1481984639, 'CY', 'CYP', 'قبرص'),
(24744, 1481984640, 1481985023, 'NL', 'NLD', 'هولندا'),
(24745, 1481985024, 1481985279, 'MT', 'MLT', 'مالطا'),
(24746, 1481985280, 1481987967, 'NL', 'NLD', 'هولندا'),
(24747, 1481987968, 1481988031, 'PA', 'PAN', 'بنما'),
(24748, 1481988032, 1481988095, 'NL', 'NLD', 'هولندا'),
(24749, 1481988096, 1481988159, 'GI', 'GIB', 'جبل طارق'),
(24750, 1481988160, 1481988167, 'RU', 'RUS', 'الإتحاد الروسي'),
(24751, 1481988168, 1481988319, 'NL', 'NLD', 'هولندا'),
(24752, 1481988320, 1481988335, 'BZ', 'BLZ', 'بليز'),
(24753, 1481988336, 1481988351, 'NL', 'NLD', 'هولندا'),
(24754, 1481988352, 1481988607, 'GB', 'GBR', 'المملكة المتحدة'),
(24755, 1481988608, 1481990143, 'NL', 'NLD', 'هولندا'),
(24756, 1481990144, 1481998335, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(24757, 1481998336, 1482006527, 'FI', 'FIN', 'فنلندا'),
(24758, 1482006528, 1482022911, 'RU', 'RUS', 'الإتحاد الروسي'),
(24759, 1482022912, 1482031103, 'SA', 'SAU', 'السعودية'),
(24760, 1482031104, 1482039295, 'SY', 'SYR', 'سوريا'),
(24761, 1482039296, 1482047487, 'SE', 'SWE', 'السويد'),
(24762, 1482047488, 1482055679, 'RU', 'RUS', 'الإتحاد الروسي'),
(24763, 1482055680, 1482063871, 'CZ', 'CZE', 'التشيك'),
(24764, 1482063872, 1482072063, 'FI', 'FIN', 'فنلندا'),
(24765, 1482072064, 1482076159, 'IT', 'ITA', 'إيطاليا'),
(24766, 1482076160, 1482076223, 'CH', 'CHE', 'سويسرا'),
(24767, 1482076224, 1482076383, 'IT', 'ITA', 'إيطاليا'),
(24768, 1482076384, 1482076415, 'MT', 'MLT', 'مالطا'),
(24769, 1482076416, 1482080255, 'IT', 'ITA', 'إيطاليا'),
(24770, 1482080256, 1482088447, 'RU', 'RUS', 'الإتحاد الروسي'),
(24771, 1482088448, 1482096639, 'FR', 'FRA', 'فرنسا'),
(24772, 1482096640, 1482104831, 'BG', 'BGR', 'بلغاريا'),
(24773, 1482104832, 1482113023, 'NO', 'NOR', 'النرويج'),
(24774, 1482113024, 1482121215, 'RU', 'RUS', 'الإتحاد الروسي'),
(24775, 1482121216, 1482127123, 'IT', 'ITA', 'إيطاليا'),
(24776, 1482127124, 1482127127, 'TR', 'TUR', 'تركيا'),
(24777, 1482127128, 1482129407, 'IT', 'ITA', 'إيطاليا'),
(24778, 1482129408, 1482137599, 'ES', 'ESP', 'إسبانيا'),
(24779, 1482137600, 1482145791, 'IE', 'IRL', 'إيرلندا'),
(24780, 1482145792, 1482153983, 'ES', 'ESP', 'إسبانيا'),
(24781, 1482153984, 1482162175, 'HU', 'HUN', 'هنغاريا'),
(24782, 1482162176, 1482686463, 'NO', 'NOR', 'النرويج'),
(24783, 1482686464, 1482948607, 'GB', 'GBR', 'المملكة المتحدة'),
(24784, 1482948608, 1483210751, 'CZ', 'CZE', 'التشيك'),
(24785, 1483210752, 1483735039, 'GB', 'GBR', 'المملكة المتحدة'),
(24786, 1483735040, 1483997183, 'FI', 'FIN', 'فنلندا'),
(24787, 1483997184, 1484038223, 'AT', 'AUT', 'النمسا'),
(24788, 1484038224, 1484038227, 'SA', 'SAU', 'السعودية'),
(24789, 1484038228, 1484038243, 'AT', 'AUT', 'النمسا'),
(24790, 1484038244, 1484038247, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(24791, 1484038248, 1484038251, 'AT', 'AUT', 'النمسا'),
(24792, 1484038252, 1484038255, 'IQ', 'IRQ', 'العراق'),
(24793, 1484038256, 1484038391, 'AT', 'AUT', 'النمسا'),
(24794, 1484038392, 1484038399, 'IQ', 'IRQ', 'العراق'),
(24795, 1484038400, 1484128255, 'AT', 'AUT', 'النمسا'),
(24796, 1484128256, 1484259327, 'LT', 'LTU', 'ليتوانيا'),
(24797, 1484259328, 1484783615, 'FR', 'FRA', 'فرنسا'),
(24798, 1484783616, 1484849151, 'DE', 'DEU', 'ألمانيا'),
(24799, 1484849152, 1484914687, 'SE', 'SWE', 'السويد'),
(24800, 1484914688, 1484980223, 'DE', 'DEU', 'ألمانيا'),
(24801, 1484980224, 1485045759, 'SE', 'SWE', 'السويد'),
(24802, 1485045760, 1485111295, 'HU', 'HUN', 'هنغاريا'),
(24803, 1485111296, 1485242367, 'DE', 'DEU', 'ألمانيا'),
(24804, 1485242368, 1485246463, 'RU', 'RUS', 'الإتحاد الروسي'),
(24805, 1485246464, 1485250559, 'UA', 'UKR', 'أوكرانيا'),
(24806, 1485250560, 1485254655, 'IR', 'IRN', 'إيران'),
(24807, 1485254656, 1485258751, 'RU', 'RUS', 'الإتحاد الروسي'),
(24808, 1485258752, 1485266943, 'UA', 'UKR', 'أوكرانيا'),
(24809, 1485266944, 1485271039, 'RO', 'ROM', 'رومانيا'),
(24810, 1485271040, 1485275135, 'UA', 'UKR', 'أوكرانيا'),
(24811, 1485275136, 1485283327, 'LV', 'LVA', 'لاتفيا'),
(24812, 1485283328, 1485291519, 'PL', 'POL', 'بولندا'),
(24813, 1485291520, 1485307903, 'UA', 'UKR', 'أوكرانيا'),
(24814, 1485307904, 1485832191, 'FR', 'FRA', 'فرنسا'),
(24815, 1485832192, 1485963263, 'GB', 'GBR', 'المملكة المتحدة'),
(24816, 1485963264, 1486028799, 'CZ', 'CZE', 'التشيك'),
(24817, 1486028800, 1486061567, 'BE', 'BEL', 'بلجيكا'),
(24818, 1486061568, 1486094335, 'RU', 'RUS', 'الإتحاد الروسي'),
(24819, 1486094336, 1486127103, 'ES', 'ESP', 'إسبانيا'),
(24820, 1486127104, 1486159871, 'FI', 'FIN', 'فنلندا'),
(24821, 1486159872, 1486192639, 'IS', 'ISL', 'أيسلندا'),
(24822, 1486192640, 1486211687, 'IT', 'ITA', 'إيطاليا'),
(24823, 1486211688, 1486211695, 'GB', 'GBR', 'المملكة المتحدة'),
(24824, 1486211696, 1486225407, 'IT', 'ITA', 'إيطاليا'),
(24825, 1486225408, 1486258175, 'DE', 'DEU', 'ألمانيا'),
(24826, 1486258176, 1486290943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(24827, 1486290944, 1486290959, 'IE', 'IRL', 'إيرلندا'),
(24828, 1486290960, 1486291071, 'GB', 'GBR', 'المملكة المتحدة'),
(24829, 1486291072, 1486291103, 'IE', 'IRL', 'إيرلندا'),
(24830, 1486291104, 1486291199, 'GB', 'GBR', 'المملكة المتحدة'),
(24831, 1486291200, 1486291215, 'IE', 'IRL', 'إيرلندا'),
(24832, 1486291216, 1486291455, 'GB', 'GBR', 'المملكة المتحدة'),
(24833, 1486291456, 1486291487, 'IE', 'IRL', 'إيرلندا'),
(24834, 1486291488, 1486292991, 'GB', 'GBR', 'المملكة المتحدة'),
(24835, 1486292992, 1486295039, 'RU', 'RUS', 'الإتحاد الروسي'),
(24836, 1486295040, 1486297087, 'ES', 'ESP', 'إسبانيا'),
(24837, 1486297088, 1486299135, 'IE', 'IRL', 'إيرلندا'),
(24838, 1486299136, 1486301183, 'NL', 'NLD', 'هولندا'),
(24839, 1486301184, 1486301951, 'DK', 'DNK', 'الدنيمارك'),
(24840, 1486301952, 1486302719, 'SE', 'SWE', 'السويد'),
(24841, 1486302720, 1486302863, 'DK', 'DNK', 'الدنيمارك'),
(24842, 1486302864, 1486302879, 'SE', 'SWE', 'السويد'),
(24843, 1486302880, 1486303231, 'DK', 'DNK', 'الدنيمارك'),
(24844, 1486303232, 1486305023, 'IS', 'ISL', 'أيسلندا'),
(24845, 1486305024, 1486305279, 'GB', 'GBR', 'المملكة المتحدة'),
(24846, 1486305280, 1486307327, 'NO', 'NOR', 'النرويج'),
(24847, 1486307328, 1486309375, 'DE', 'DEU', 'ألمانيا'),
(24848, 1486309376, 1486311423, 'AT', 'AUT', 'النمسا'),
(24849, 1486311424, 1486313471, 'IE', 'IRL', 'إيرلندا'),
(24850, 1486313472, 1486315519, 'RU', 'RUS', 'الإتحاد الروسي'),
(24851, 1486315520, 1486317567, 'HU', 'HUN', 'هنغاريا'),
(24852, 1486317568, 1486320383, 'RU', 'RUS', 'الإتحاد الروسي'),
(24853, 1486320384, 1486320639, 'US', 'USA', 'الولايات المتحدة'),
(24854, 1486320640, 1486321663, 'RU', 'RUS', 'الإتحاد الروسي'),
(24855, 1486321824, 1486321855, 'US', 'USA', 'الولايات المتحدة'),
(24856, 1486321856, 1486321887, 'NL', 'NLD', 'هولندا'),
(24857, 1486321888, 1486321919, 'US', 'USA', 'الولايات المتحدة'),
(24858, 1486323200, 1486323215, 'US', 'USA', 'الولايات المتحدة'),
(24859, 1486323216, 1486323231, 'NL', 'NLD', 'هولندا'),
(24860, 1486323232, 1486323239, 'GB', 'GBR', 'المملكة المتحدة'),
(24861, 1486323712, 1486325759, 'GB', 'GBR', 'المملكة المتحدة'),
(24862, 1486325760, 1486327807, 'SA', 'SAU', 'السعودية'),
(24863, 1486327808, 1486329855, 'CH', 'CHE', 'سويسرا'),
(24864, 1486329856, 1486331903, 'FR', 'FRA', 'فرنسا'),
(24865, 1486331904, 1486333951, 'NO', 'NOR', 'النرويج'),
(24866, 1486333952, 1486335999, 'SE', 'SWE', 'السويد'),
(24867, 1486336000, 1486338047, 'KZ', 'KAZ', 'كازاخستان'),
(24868, 1486338048, 1486340095, 'RU', 'RUS', 'الإتحاد الروسي'),
(24869, 1486340096, 1486342143, 'AZ', 'AZE', 'أذربيجان'),
(24870, 1486342144, 1486344191, 'RU', 'RUS', 'الإتحاد الروسي'),
(24871, 1486344192, 1486346239, 'ES', 'ESP', 'إسبانيا'),
(24872, 1486346240, 1486348287, 'GB', 'GBR', 'المملكة المتحدة'),
(24873, 1486348288, 1486349311, 'NL', 'NLD', 'هولندا'),
(24874, 1486349312, 1486350335, 'US', 'USA', 'الولايات المتحدة'),
(24875, 1486350336, 1486352383, 'TR', 'TUR', 'تركيا'),
(24876, 1486352384, 1486354431, 'BE', 'BEL', 'بلجيكا'),
(24877, 1486354432, 1486356479, 'RU', 'RUS', 'الإتحاد الروسي'),
(24878, 1486356480, 1486487551, 'DE', 'DEU', 'ألمانيا'),
(24879, 1486487552, 1486618623, 'UA', 'UKR', 'أوكرانيا'),
(24880, 1486618624, 1486684159, 'PL', 'POL', 'بولندا'),
(24881, 1486684160, 1486749695, 'PT', 'PRT', 'البورتوغال'),
(24882, 1486749696, 1486815231, 'RO', 'ROM', 'رومانيا'),
(24883, 1486815232, 1486880767, 'NL', 'NLD', 'هولندا'),
(24884, 1486880768, 1488977919, 'FR', 'FRA', 'فرنسا'),
(24885, 1488977920, 1489240063, 'FI', 'FIN', 'فنلندا'),
(24886, 1489240064, 1489305599, 'EE', 'EST', 'إستونيا'),
(24887, 1489305600, 1489338367, 'GR', 'GRC', 'اليونان'),
(24888, 1489338368, 1489371135, 'BE', 'BEL', 'بلجيكا'),
(24889, 1489371136, 1489402239, 'DE', 'DEU', 'ألمانيا'),
(24890, 1489402240, 1489402367, 'TR', 'TUR', 'تركيا'),
(24891, 1489402368, 1489436671, 'DE', 'DEU', 'ألمانيا'),
(24892, 1489436672, 1489502207, 'PL', 'POL', 'بولندا'),
(24893, 1489502208, 1489534975, 'SI', 'SVN', 'سلوفينيا'),
(24894, 1489534976, 1489567743, 'RU', 'RUS', 'الإتحاد الروسي'),
(24895, 1489567744, 1489600511, 'BH', 'BHR', 'البحرين'),
(24896, 1489600512, 1489633279, 'RU', 'RUS', 'الإتحاد الروسي'),
(24897, 1489633280, 1489635327, 'IT', 'ITA', 'إيطاليا'),
(24898, 1489635328, 1489635838, 'GB', 'GBR', 'المملكة المتحدة'),
(24899, 1489635839, 1489636863, 'IT', 'ITA', 'إيطاليا'),
(24900, 1489636864, 1489637119, 'FR', 'FRA', 'فرنسا'),
(24901, 1489637120, 1489637887, 'IT', 'ITA', 'إيطاليا'),
(24902, 1489637888, 1489638399, 'GB', 'GBR', 'المملكة المتحدة'),
(24903, 1489638400, 1489638655, 'IT', 'ITA', 'إيطاليا'),
(24904, 1489638656, 1489638911, 'FR', 'FRA', 'فرنسا'),
(24905, 1489638912, 1489640703, 'IT', 'ITA', 'إيطاليا'),
(24906, 1489640704, 1489640959, 'FR', 'FRA', 'فرنسا'),
(24907, 1489640960, 1489642495, 'IT', 'ITA', 'إيطاليا'),
(24908, 1489642496, 1489642751, 'FR', 'FRA', 'فرنسا'),
(24909, 1489642752, 1489644543, 'IT', 'ITA', 'إيطاليا'),
(24910, 1489644544, 1489645055, 'GB', 'GBR', 'المملكة المتحدة'),
(24911, 1489645056, 1489645567, 'IT', 'ITA', 'إيطاليا'),
(24912, 1489645568, 1489646335, 'GB', 'GBR', 'المملكة المتحدة'),
(24913, 1489646336, 1489646591, 'IT', 'ITA', 'إيطاليا'),
(24914, 1489646592, 1489646847, 'GB', 'GBR', 'المملكة المتحدة'),
(24915, 1489646848, 1489647103, 'IT', 'ITA', 'إيطاليا'),
(24916, 1489647104, 1489647359, 'GB', 'GBR', 'المملكة المتحدة'),
(24917, 1489647360, 1489648639, 'IT', 'ITA', 'إيطاليا'),
(24918, 1489648640, 1489649407, 'GB', 'GBR', 'المملكة المتحدة'),
(24919, 1489649408, 1489650687, 'FR', 'FRA', 'فرنسا'),
(24920, 1489650688, 1489661951, 'IT', 'ITA', 'إيطاليا'),
(24921, 1489661952, 1489662719, 'GB', 'GBR', 'المملكة المتحدة'),
(24922, 1489662720, 1489662975, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(24923, 1489662976, 1489663487, 'FR', 'FRA', 'فرنسا'),
(24924, 1489663488, 1489663999, 'ES', 'ESP', 'إسبانيا'),
(24925, 1489664000, 1489664511, 'LY', 'LBY', 'ليبيا'),
(24926, 1489664512, 1489665023, 'IT', 'ITA', 'إيطاليا'),
(24927, 1489665024, 1489665279, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(24928, 1489665280, 1489666047, 'IT', 'ITA', 'إيطاليا'),
(24929, 1489666048, 1489698815, 'GB', 'GBR', 'المملكة المتحدة'),
(24930, 1489698816, 1489731583, 'MT', 'MLT', 'مالطا'),
(24931, 1489731584, 1489764351, 'BG', 'BGR', 'بلغاريا'),
(24932, 1489764352, 1489797119, 'RU', 'RUS', 'الإتحاد الروسي'),
(24933, 1489797120, 1489829887, 'KZ', 'KAZ', 'كازاخستان'),
(24934, 1489829888, 1489862655, 'DE', 'DEU', 'ألمانيا'),
(24935, 1489862656, 1489928191, 'RU', 'RUS', 'الإتحاد الروسي'),
(24936, 1489928192, 1489960959, 'SE', 'SWE', 'السويد'),
(24937, 1489960960, 1489993727, 'HR', 'HRV', 'كرواتيا'),
(24938, 1489993728, 1490026495, 'LU', 'LUX', 'لوكسيمبورغ'),
(24939, 1490026496, 1490028543, 'US', 'USA', 'الولايات المتحدة'),
(24940, 1490028544, 1490029055, 'UA', 'UKR', 'أوكرانيا'),
(24941, 1490029056, 1490041855, 'NL', 'NLD', 'هولندا'),
(24942, 1490041856, 1490049879, 'CZ', 'CZE', 'التشيك'),
(24943, 1490049880, 1490049887, 'AT', 'AUT', 'النمسا'),
(24944, 1490049888, 1490049919, 'CZ', 'CZE', 'التشيك'),
(24945, 1490049920, 1490049983, 'PL', 'POL', 'بولندا'),
(24946, 1490049984, 1490053375, 'CZ', 'CZE', 'التشيك'),
(24947, 1490053376, 1490054143, 'PL', 'POL', 'بولندا'),
(24948, 1490054144, 1490059263, 'CZ', 'CZE', 'التشيك'),
(24949, 1490059264, 1490075647, 'DE', 'DEU', 'ألمانيا'),
(24950, 1490075648, 1490092031, 'GB', 'GBR', 'المملكة المتحدة'),
(24951, 1490092032, 1490108415, 'DE', 'DEU', 'ألمانيا'),
(24952, 1490108416, 1490124799, 'MC', 'MCO', 'موناكو'),
(24953, 1490124800, 1490157567, 'HU', 'HUN', 'هنغاريا'),
(24954, 1490157568, 1490173951, 'RU', 'RUS', 'الإتحاد الروسي'),
(24955, 1490173952, 1490190335, 'PT', 'PRT', 'البورتوغال'),
(24956, 1490190336, 1490196479, 'GB', 'GBR', 'المملكة المتحدة'),
(24957, 1490196480, 1490196511, 'FR', 'FRA', 'فرنسا'),
(24958, 1490196512, 1490196527, 'DE', 'DEU', 'ألمانيا'),
(24959, 1490196528, 1490196543, 'RS', 'SRB', 'صربيا'),
(24960, 1490196544, 1490196735, 'AL', 'ALB', 'ألبانيا'),
(24961, 1490196736, 1490196863, 'CZ', 'CZE', 'التشيك'),
(24962, 1490196864, 1490196895, 'ES', 'ESP', 'إسبانيا'),
(24963, 1490196896, 1490196927, 'HU', 'HUN', 'هنغاريا'),
(24964, 1490196928, 1490196959, 'IT', 'ITA', 'إيطاليا'),
(24965, 1490196960, 1490197247, 'IE', 'IRL', 'إيرلندا'),
(24966, 1490197248, 1490206719, 'GB', 'GBR', 'المملكة المتحدة'),
(24967, 1490206720, 1490223103, 'GE', 'GEO', 'جورجيا'),
(24968, 1490223104, 1490226047, 'GB', 'GBR', 'المملكة المتحدة'),
(24969, 1490226048, 1490226175, 'FR', 'FRA', 'فرنسا'),
(24970, 1490226176, 1490230719, 'GB', 'GBR', 'المملكة المتحدة'),
(24971, 1490230720, 1490230751, 'FR', 'FRA', 'فرنسا'),
(24972, 1490230752, 1490235263, 'GB', 'GBR', 'المملكة المتحدة'),
(24973, 1490235264, 1490235391, 'FR', 'FRA', 'فرنسا'),
(24974, 1490235392, 1490255871, 'GB', 'GBR', 'المملكة المتحدة'),
(24975, 1490255872, 1490272255, 'NL', 'NLD', 'هولندا'),
(24976, 1490272256, 1490288639, 'GB', 'GBR', 'المملكة المتحدة'),
(24977, 1490288640, 1490305023, 'SK', 'SVK', 'سلوفاكيا'),
(24978, 1490305024, 1490321407, 'DK', 'DNK', 'الدنيمارك'),
(24979, 1490321408, 1490337791, 'GB', 'GBR', 'المملكة المتحدة'),
(24980, 1490337792, 1490354175, 'RU', 'RUS', 'الإتحاد الروسي'),
(24981, 1490354176, 1490386943, 'SA', 'SAU', 'السعودية'),
(24982, 1490386944, 1490403327, 'IT', 'ITA', 'إيطاليا'),
(24983, 1490403328, 1490419711, 'BG', 'BGR', 'بلغاريا'),
(24984, 1490419712, 1490436095, 'DE', 'DEU', 'ألمانيا'),
(24985, 1490436096, 1490452479, 'UA', 'UKR', 'أوكرانيا'),
(24986, 1490452480, 1490468863, 'PT', 'PRT', 'البورتوغال'),
(24987, 1490468864, 1490472447, 'GB', 'GBR', 'المملكة المتحدة'),
(24988, 1490472448, 1490472703, 'US', 'USA', 'الولايات المتحدة'),
(24989, 1490472704, 1490473983, 'GB', 'GBR', 'المملكة المتحدة'),
(24990, 1490473984, 1490474239, 'US', 'USA', 'الولايات المتحدة'),
(24991, 1490474240, 1490484223, 'GB', 'GBR', 'المملكة المتحدة'),
(24992, 1490484224, 1490484479, 'US', 'USA', 'الولايات المتحدة'),
(24993, 1490484480, 1490501631, 'GB', 'GBR', 'المملكة المتحدة'),
(24994, 1490501632, 1490518015, 'DE', 'DEU', 'ألمانيا'),
(24995, 1490518016, 1490534399, 'RU', 'RUS', 'الإتحاد الروسي'),
(24996, 1490534400, 1490550783, 'DE', 'DEU', 'ألمانيا'),
(24997, 1490550784, 1490616319, 'LT', 'LTU', 'ليتوانيا'),
(24998, 1490616320, 1490681855, 'DE', 'DEU', 'ألمانيا'),
(24999, 1490681856, 1490747391, 'GR', 'GRC', 'اليونان'),
(25000, 1490747392, 1490812927, 'FR', 'FRA', 'فرنسا'),
(25001, 1490812928, 1490878463, 'PL', 'POL', 'بولندا'),
(25002, 1490878464, 1490879487, 'DE', 'DEU', 'ألمانيا'),
(25003, 1490879488, 1490880511, 'US', 'USA', 'الولايات المتحدة'),
(25004, 1490880512, 1490881535, 'FR', 'FRA', 'فرنسا'),
(25005, 1490882560, 1490883583, 'US', 'USA', 'الولايات المتحدة'),
(25006, 1490885632, 1490886655, 'US', 'USA', 'الولايات المتحدة'),
(25007, 1490904064, 1490905087, 'US', 'USA', 'الولايات المتحدة'),
(25008, 1490909184, 1490910207, 'US', 'USA', 'الولايات المتحدة'),
(25009, 1490913280, 1490915327, 'US', 'USA', 'الولايات المتحدة'),
(25010, 1490915328, 1490917375, 'IT', 'ITA', 'إيطاليا'),
(25011, 1490917376, 1490919423, 'IL', 'ISR', 'إسرائيل'),
(25012, 1490927616, 1490929663, 'FR', 'FRA', 'فرنسا'),
(25013, 1490931712, 1490933759, 'DE', 'DEU', 'ألمانيا'),
(25014, 1490934528, 1490934783, 'IL', 'ISR', 'إسرائيل'),
(25015, 1490944000, 1491075071, 'LT', 'LTU', 'ليتوانيا'),
(25016, 1491075072, 1493172223, 'TR', 'TUR', 'تركيا'),
(25017, 1493172224, 1493303295, 'DE', 'DEU', 'ألمانيا'),
(25018, 1493303296, 1493434367, 'FR', 'FRA', 'فرنسا'),
(25019, 1493434368, 1493565439, 'SA', 'SAU', 'السعودية'),
(25020, 1493565440, 1493696511, 'ES', 'ESP', 'إسبانيا'),
(25021, 1493696512, 1493958655, 'NO', 'NOR', 'النرويج'),
(25022, 1493958656, 1494220799, 'DE', 'DEU', 'ألمانيا'),
(25023, 1494220800, 1494228991, 'FR', 'FRA', 'فرنسا'),
(25024, 1494228992, 1494237183, 'RU', 'RUS', 'الإتحاد الروسي'),
(25025, 1494237184, 1494245375, 'IE', 'IRL', 'إيرلندا'),
(25026, 1494245376, 1494253567, 'RU', 'RUS', 'الإتحاد الروسي'),
(25027, 1494253568, 1494261759, 'DE', 'DEU', 'ألمانيا'),
(25028, 1494261760, 1494269951, 'GB', 'GBR', 'المملكة المتحدة'),
(25029, 1494269952, 1494278143, 'AT', 'AUT', 'النمسا'),
(25030, 1494278144, 1494286335, 'GB', 'GBR', 'المملكة المتحدة'),
(25031, 1494286336, 1494294527, 'HR', 'HRV', 'كرواتيا'),
(25032, 1494294528, 1494302719, 'RU', 'RUS', 'الإتحاد الروسي'),
(25033, 1494302720, 1494310911, 'FI', 'FIN', 'فنلندا'),
(25034, 1494310912, 1494319103, 'GB', 'GBR', 'المملكة المتحدة'),
(25035, 1494319104, 1494327295, 'MT', 'MLT', 'مالطا'),
(25036, 1494327296, 1494335487, 'IT', 'ITA', 'إيطاليا'),
(25037, 1494335488, 1494343679, 'ES', 'ESP', 'إسبانيا'),
(25038, 1494343680, 1494351871, 'PL', 'POL', 'بولندا'),
(25039, 1494351872, 1494360063, 'RO', 'ROM', 'رومانيا'),
(25040, 1494360064, 1494368255, 'HR', 'HRV', 'كرواتيا'),
(25041, 1494368256, 1494376447, 'IE', 'IRL', 'إيرلندا'),
(25042, 1494376448, 1494384639, 'SE', 'SWE', 'السويد'),
(25043, 1494384640, 1494392831, 'RU', 'RUS', 'الإتحاد الروسي'),
(25044, 1494392832, 1494393087, 'US', 'USA', 'الولايات المتحدة'),
(25045, 1494393088, 1494398975, 'NL', 'NLD', 'هولندا'),
(25046, 1494398976, 1494399743, 'US', 'USA', 'الولايات المتحدة'),
(25047, 1494399744, 1494401023, 'NL', 'NLD', 'هولندا'),
(25048, 1494401024, 1494409215, 'LV', 'LVA', 'لاتفيا'),
(25049, 1494409216, 1494417407, 'FI', 'FIN', 'فنلندا'),
(25050, 1494417408, 1494425599, 'TR', 'TUR', 'تركيا'),
(25051, 1494425600, 1494433791, 'RU', 'RUS', 'الإتحاد الروسي'),
(25052, 1494433792, 1494441983, 'IE', 'IRL', 'إيرلندا'),
(25053, 1494441984, 1494450175, 'UA', 'UKR', 'أوكرانيا'),
(25054, 1494450176, 1494458367, 'DK', 'DNK', 'الدنيمارك'),
(25055, 1494458368, 1494474751, 'RU', 'RUS', 'الإتحاد الروسي'),
(25056, 1494474752, 1494477471, 'DE', 'DEU', 'ألمانيا'),
(25057, 1494477472, 1494477503, 'IL', 'ISR', 'إسرائيل'),
(25058, 1494477504, 1494482943, 'DE', 'DEU', 'ألمانيا'),
(25059, 1494482944, 1494499327, 'RU', 'RUS', 'الإتحاد الروسي'),
(25060, 1494499328, 1494507519, 'NL', 'NLD', 'هولندا'),
(25061, 1494507520, 1494523903, 'RU', 'RUS', 'الإتحاد الروسي'),
(25062, 1494523904, 1494532095, 'NL', 'NLD', 'هولندا'),
(25063, 1494532096, 1494540287, 'GB', 'GBR', 'المملكة المتحدة'),
(25064, 1494540288, 1494548479, 'NO', 'NOR', 'النرويج'),
(25065, 1494548480, 1494556671, 'GB', 'GBR', 'المملكة المتحدة'),
(25066, 1494556672, 1494564863, 'DE', 'DEU', 'ألمانيا'),
(25067, 1494564864, 1494573055, 'UA', 'UKR', 'أوكرانيا'),
(25068, 1494573056, 1494581247, 'RO', 'ROM', 'رومانيا'),
(25069, 1494581248, 1494589439, 'RU', 'RUS', 'الإتحاد الروسي'),
(25070, 1494589440, 1494589455, 'NL', 'NLD', 'هولندا'),
(25071, 1494589456, 1494589471, 'US', 'USA', 'الولايات المتحدة'),
(25072, 1494589472, 1494589535, 'NL', 'NLD', 'هولندا'),
(25073, 1494589536, 1494589695, 'US', 'USA', 'الولايات المتحدة'),
(25074, 1494589696, 1494589723, 'IQ', 'IRQ', 'العراق'),
(25075, 1494589724, 1494597631, 'US', 'USA', 'الولايات المتحدة'),
(25076, 1494605824, 1494614015, 'GB', 'GBR', 'المملكة المتحدة'),
(25077, 1494679552, 1494695935, 'RU', 'RUS', 'الإتحاد الروسي'),
(25078, 1494695936, 1494704127, 'RS', 'SRB', 'صربيا'),
(25079, 1494704128, 1494712319, 'RU', 'RUS', 'الإتحاد الروسي'),
(25080, 1494745088, 1494810623, 'CZ', 'CZE', 'التشيك'),
(25081, 1494810624, 1494843391, 'BG', 'BGR', 'بلغاريا'),
(25082, 1494843392, 1494876159, 'PL', 'POL', 'بولندا'),
(25083, 1494876160, 1494908927, 'AT', 'AUT', 'النمسا'),
(25084, 1494908928, 1494941695, 'PT', 'PRT', 'البورتوغال'),
(25085, 1494941696, 1494974463, 'FI', 'FIN', 'فنلندا'),
(25086, 1494974464, 1495007231, 'DE', 'DEU', 'ألمانيا'),
(25087, 1495007232, 1495039999, 'MD', 'MDA', 'مولدوفا'),
(25088, 1495040000, 1495042047, 'KZ', 'KAZ', 'كازاخستان'),
(25089, 1495042048, 1495044095, 'DE', 'DEU', 'ألمانيا'),
(25090, 1495044096, 1495046143, 'FR', 'FRA', 'فرنسا'),
(25091, 1495046144, 1495048191, 'BH', 'BHR', 'البحرين'),
(25092, 1495048192, 1495050239, 'RU', 'RUS', 'الإتحاد الروسي'),
(25093, 1495050240, 1495052287, 'GB', 'GBR', 'المملكة المتحدة'),
(25094, 1495052288, 1495054335, 'IE', 'IRL', 'إيرلندا'),
(25095, 1495054336, 1495056383, 'GB', 'GBR', 'المملكة المتحدة'),
(25096, 1495056384, 1495058431, 'RU', 'RUS', 'الإتحاد الروسي'),
(25097, 1495058432, 1495060479, 'UA', 'UKR', 'أوكرانيا'),
(25098, 1495060480, 1495062527, 'GB', 'GBR', 'المملكة المتحدة'),
(25099, 1495062528, 1495064575, 'JO', 'JOR', 'الأردن'),
(25100, 1495064576, 1495066623, 'PL', 'POL', 'بولندا'),
(25101, 1495066624, 1495068671, 'GB', 'GBR', 'المملكة المتحدة'),
(25102, 1495068672, 1495070719, 'DE', 'DEU', 'ألمانيا'),
(25103, 1495070720, 1495072767, 'RU', 'RUS', 'الإتحاد الروسي'),
(25104, 1495072768, 1495105535, 'CZ', 'CZE', 'التشيك'),
(25105, 1495105536, 1495138303, 'ES', 'ESP', 'إسبانيا'),
(25106, 1495138304, 1495139327, 'FR', 'FRA', 'فرنسا'),
(25107, 1495139584, 1495139591, 'GB', 'GBR', 'المملكة المتحدة'),
(25108, 1495139712, 1495139839, 'GB', 'GBR', 'المملكة المتحدة'),
(25109, 1495139840, 1495139871, 'ES', 'ESP', 'إسبانيا'),
(25110, 1495139872, 1495139903, 'FR', 'FRA', 'فرنسا'),
(25111, 1495140352, 1495142399, 'FR', 'FRA', 'فرنسا'),
(25112, 1495146496, 1495150591, 'FR', 'FRA', 'فرنسا'),
(25113, 1495150592, 1495151103, 'GB', 'GBR', 'المملكة المتحدة'),
(25114, 1495151104, 1495151359, 'NL', 'NLD', 'هولندا'),
(25115, 1495151360, 1495154687, 'FR', 'FRA', 'فرنسا'),
(25116, 1495162368, 1495162879, 'US', 'USA', 'الولايات المتحدة'),
(25117, 1495162880, 1495163903, 'FR', 'FRA', 'فرنسا'),
(25118, 1495164416, 1495164671, 'FR', 'FRA', 'فرنسا'),
(25119, 1495164928, 1495165055, 'FR', 'FRA', 'فرنسا'),
(25120, 1495165184, 1495165199, 'FR', 'FRA', 'فرنسا'),
(25121, 1495165208, 1495165215, 'ES', 'ESP', 'إسبانيا'),
(25122, 1495165440, 1495168383, 'FR', 'FRA', 'فرنسا'),
(25123, 1495168512, 1495168767, 'FR', 'FRA', 'فرنسا'),
(25124, 1495168768, 1495169023, 'GB', 'GBR', 'المملكة المتحدة'),
(25125, 1495169024, 1495169279, 'FR', 'FRA', 'فرنسا'),
(25126, 1495169536, 1495169791, 'FR', 'FRA', 'فرنسا'),
(25127, 1495170048, 1495170079, 'FR', 'FRA', 'فرنسا'),
(25128, 1495170160, 1495170175, 'FR', 'FRA', 'فرنسا'),
(25129, 1495170304, 1495170335, 'FR', 'FRA', 'فرنسا'),
(25130, 1495170560, 1495170815, 'FR', 'FRA', 'فرنسا'),
(25131, 1495170816, 1495171071, 'GB', 'GBR', 'المملكة المتحدة'),
(25132, 1495171072, 1495174399, 'NL', 'NLD', 'هولندا'),
(25133, 1495174400, 1495174655, 'US', 'USA', 'الولايات المتحدة'),
(25134, 1495174656, 1495203839, 'NL', 'NLD', 'هولندا'),
(25135, 1495203840, 1495205887, 'DE', 'DEU', 'ألمانيا'),
(25136, 1495205888, 1495207935, 'CZ', 'CZE', 'التشيك'),
(25137, 1495207936, 1495209983, 'RU', 'RUS', 'الإتحاد الروسي'),
(25138, 1495209984, 1495212031, 'KZ', 'KAZ', 'كازاخستان'),
(25139, 1495214080, 1495216127, 'CZ', 'CZE', 'التشيك'),
(25140, 1495216128, 1495218175, 'GB', 'GBR', 'المملكة المتحدة'),
(25141, 1495218176, 1495220223, 'IT', 'ITA', 'إيطاليا'),
(25142, 1495220224, 1495222271, 'PL', 'POL', 'بولندا'),
(25143, 1495222272, 1495224319, 'IT', 'ITA', 'إيطاليا'),
(25144, 1495224320, 1495228415, 'RU', 'RUS', 'الإتحاد الروسي'),
(25145, 1495228416, 1495230463, 'NL', 'NLD', 'هولندا'),
(25146, 1495230464, 1495234559, 'RU', 'RUS', 'الإتحاد الروسي'),
(25147, 1495234560, 1495236607, 'CH', 'CHE', 'سويسرا'),
(25148, 1495236608, 1495237711, 'AT', 'AUT', 'النمسا'),
(25149, 1495237712, 1495237727, 'NL', 'NLD', 'هولندا'),
(25150, 1495237728, 1495238655, 'AT', 'AUT', 'النمسا'),
(25151, 1495238656, 1495240703, 'DE', 'DEU', 'ألمانيا'),
(25152, 1495240704, 1495240751, 'FR', 'FRA', 'فرنسا'),
(25153, 1495240752, 1495240759, 'BE', 'BEL', 'بلجيكا'),
(25154, 1495240760, 1495240767, 'CH', 'CHE', 'سويسرا'),
(25155, 1495240768, 1495242751, 'FR', 'FRA', 'فرنسا'),
(25156, 1495242752, 1495244799, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(25157, 1495244800, 1495246847, 'CZ', 'CZE', 'التشيك'),
(25158, 1495246848, 1495248895, 'IE', 'IRL', 'إيرلندا'),
(25159, 1495248896, 1495250943, 'GR', 'GRC', 'اليونان'),
(25160, 1495250944, 1495252991, 'RU', 'RUS', 'الإتحاد الروسي'),
(25161, 1495252992, 1495255039, 'BH', 'BHR', 'البحرين'),
(25162, 1495255040, 1495257087, 'IT', 'ITA', 'إيطاليا'),
(25163, 1495257088, 1495259135, 'GB', 'GBR', 'المملكة المتحدة'),
(25164, 1495259136, 1495261183, 'BE', 'BEL', 'بلجيكا'),
(25165, 1495261184, 1495263231, 'PT', 'PRT', 'البورتوغال'),
(25166, 1495263232, 1495265279, 'GB', 'GBR', 'المملكة المتحدة'),
(25167, 1495265280, 1495265791, 'DE', 'DEU', 'ألمانيا'),
(25168, 1495265792, 1495267327, 'RU', 'RUS', 'الإتحاد الروسي'),
(25169, 1495267328, 1495269375, 'SE', 'SWE', 'السويد'),
(25170, 1495269376, 1495326719, 'RO', 'ROM', 'رومانيا'),
(25171, 1495326720, 1495330815, 'MD', 'MDA', 'مولدوفا'),
(25172, 1495330816, 1495334911, 'RO', 'ROM', 'رومانيا'),
(25173, 1495334912, 1495335935, 'MD', 'MDA', 'مولدوفا'),
(25174, 1495335936, 1495399935, 'RO', 'ROM', 'رومانيا'),
(25175, 1495399936, 1495400191, 'MD', 'MDA', 'مولدوفا'),
(25176, 1495400192, 1495623679, 'RO', 'ROM', 'رومانيا'),
(25177, 1495623680, 1495623935, 'MD', 'MDA', 'مولدوفا'),
(25178, 1495623936, 1495647743, 'RO', 'ROM', 'رومانيا'),
(25179, 1495647744, 1495648255, 'MD', 'MDA', 'مولدوفا'),
(25180, 1495648256, 1495752703, 'RO', 'ROM', 'رومانيا'),
(25181, 1495752704, 1495754751, 'ES', 'ESP', 'إسبانيا'),
(25182, 1495754752, 1495801855, 'RO', 'ROM', 'رومانيا'),
(25183, 1495801856, 1495802879, 'GB', 'GBR', 'المملكة المتحدة'),
(25184, 1495802880, 1495875583, 'RO', 'ROM', 'رومانيا'),
(25185, 1495875584, 1495891967, 'MD', 'MDA', 'مولدوفا'),
(25186, 1495891968, 1495927295, 'RO', 'ROM', 'رومانيا'),
(25187, 1495927296, 1495927551, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(25188, 1495927552, 1495937023, 'RO', 'ROM', 'رومانيا'),
(25189, 1495937024, 1495937535, 'ES', 'ESP', 'إسبانيا'),
(25190, 1495937536, 1496078335, 'RO', 'ROM', 'رومانيا'),
(25191, 1496078336, 1496079359, 'MD', 'MDA', 'مولدوفا'),
(25192, 1496079360, 1496121343, 'RO', 'ROM', 'رومانيا'),
(25193, 1496121344, 1496122367, 'MD', 'MDA', 'مولدوفا'),
(25194, 1496122368, 1496178943, 'RO', 'ROM', 'رومانيا'),
(25195, 1496178944, 1496179199, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(25196, 1496179200, 1496317951, 'RO', 'ROM', 'رومانيا'),
(25197, 1496317952, 1497366527, 'DE', 'DEU', 'ألمانيا'),
(25198, 1497366528, 1498415103, 'PL', 'POL', 'بولندا'),
(25199, 1498415104, 1499463679, 'FR', 'FRA', 'فرنسا'),
(25200, 1499463680, 1499594751, 'IT', 'ITA', 'إيطاليا'),
(25201, 1499594752, 1499725823, 'NL', 'NLD', 'هولندا'),
(25202, 1499725824, 1499856895, 'IE', 'IRL', 'إيرلندا'),
(25203, 1499856896, 1499987967, 'CZ', 'CZE', 'التشيك'),
(25204, 1499987968, 1499996159, 'AT', 'AUT', 'النمسا'),
(25205, 1499996160, 1500004351, 'GB', 'GBR', 'المملكة المتحدة'),
(25206, 1500004352, 1500020735, 'RU', 'RUS', 'الإتحاد الروسي'),
(25207, 1500020736, 1500028927, 'IS', 'ISL', 'أيسلندا'),
(25208, 1500028928, 1500037119, 'NL', 'NLD', 'هولندا'),
(25209, 1500037120, 1500045311, 'DK', 'DNK', 'الدنيمارك'),
(25210, 1500045312, 1500061695, 'GB', 'GBR', 'المملكة المتحدة'),
(25211, 1500061696, 1500069887, 'NO', 'NOR', 'النرويج'),
(25212, 1500069888, 1500078079, 'IT', 'ITA', 'إيطاليا'),
(25213, 1500078080, 1500086271, 'GB', 'GBR', 'المملكة المتحدة'),
(25214, 1500086272, 1500094463, 'RU', 'RUS', 'الإتحاد الروسي'),
(25215, 1500094464, 1500102655, 'AT', 'AUT', 'النمسا'),
(25216, 1500102656, 1500104063, 'NL', 'NLD', 'هولندا'),
(25217, 1500104064, 1500104071, 'DE', 'DEU', 'ألمانيا'),
(25218, 1500104072, 1500110847, 'NL', 'NLD', 'هولندا'),
(25219, 1500110848, 1500119039, 'UA', 'UKR', 'أوكرانيا'),
(25220, 1500119040, 1500127231, 'TR', 'TUR', 'تركيا'),
(25221, 1500135424, 1500135555, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(25222, 1500135556, 1500135559, 'CH', 'CHE', 'سويسرا'),
(25223, 1500135560, 1500140560, 'DE', 'DEU', 'ألمانيا'),
(25224, 1500140561, 1500140564, 'AT', 'AUT', 'النمسا'),
(25225, 1500140565, 1500140568, 'CH', 'CHE', 'سويسرا'),
(25226, 1500140569, 1500143615, 'DE', 'DEU', 'ألمانيا'),
(25227, 1500143616, 1500151807, 'BG', 'BGR', 'بلغاريا'),
(25228, 1500151808, 1500153855, 'GB', 'GBR', 'المملكة المتحدة'),
(25229, 1500153856, 1500155903, 'IE', 'IRL', 'إيرلندا'),
(25230, 1500155904, 1500157951, 'GB', 'GBR', 'المملكة المتحدة'),
(25231, 1500157952, 1500159999, 'DE', 'DEU', 'ألمانيا'),
(25232, 1500160000, 1500162047, 'NL', 'NLD', 'هولندا'),
(25233, 1500162048, 1500164095, 'RU', 'RUS', 'الإتحاد الروسي'),
(25234, 1500164096, 1500166143, 'GB', 'GBR', 'المملكة المتحدة'),
(25235, 1500166144, 1500168191, 'FR', 'FRA', 'فرنسا'),
(25236, 1500168192, 1500170239, 'RU', 'RUS', 'الإتحاد الروسي'),
(25237, 1500170240, 1500172287, 'LU', 'LUX', 'لوكسيمبورغ'),
(25238, 1500172288, 1500174335, 'AT', 'AUT', 'النمسا'),
(25239, 1500174336, 1500176383, 'DE', 'DEU', 'ألمانيا'),
(25240, 1500176384, 1500178431, 'GB', 'GBR', 'المملكة المتحدة'),
(25241, 1500178432, 1500180479, 'KZ', 'KAZ', 'كازاخستان'),
(25242, 1500180480, 1500182527, 'BE', 'BEL', 'بلجيكا'),
(25243, 1500182528, 1500184575, 'RU', 'RUS', 'الإتحاد الروسي'),
(25244, 1500184576, 1500186623, 'GB', 'GBR', 'المملكة المتحدة'),
(25245, 1500186624, 1500188671, 'KW', 'KWT', 'الكويت'),
(25246, 1500188672, 1500190719, 'GB', 'GBR', 'المملكة المتحدة'),
(25247, 1500190720, 1500194815, 'RU', 'RUS', 'الإتحاد الروسي'),
(25248, 1500194816, 1500196863, 'GB', 'GBR', 'المملكة المتحدة'),
(25249, 1500196864, 1500198911, 'ES', 'ESP', 'إسبانيا'),
(25250, 1500198912, 1500200959, 'GB', 'GBR', 'المملكة المتحدة'),
(25251, 1500200960, 1500203007, 'DE', 'DEU', 'ألمانيا'),
(25252, 1500203008, 1500205055, 'GB', 'GBR', 'المملكة المتحدة'),
(25253, 1500205056, 1500207103, 'RU', 'RUS', 'الإتحاد الروسي'),
(25254, 1500207104, 1500209151, 'IT', 'ITA', 'إيطاليا'),
(25255, 1500209152, 1500211199, 'KZ', 'KAZ', 'كازاخستان'),
(25256, 1500211200, 1500217343, 'RU', 'RUS', 'الإتحاد الروسي'),
(25257, 1500217344, 1500217599, 'CZ', 'CZE', 'التشيك'),
(25258, 1500217600, 1500218111, 'DE', 'DEU', 'ألمانيا'),
(25259, 1500218112, 1500218367, 'CZ', 'CZE', 'التشيك'),
(25260, 1500218368, 1500219391, 'DE', 'DEU', 'ألمانيا'),
(25261, 1500219392, 1500221439, 'FR', 'FRA', 'فرنسا'),
(25262, 1500221440, 1500223487, 'SK', 'SVK', 'سلوفاكيا'),
(25263, 1500223488, 1500225535, 'PL', 'POL', 'بولندا'),
(25264, 1500225536, 1500227583, 'DE', 'DEU', 'ألمانيا'),
(25265, 1500227584, 1500229631, 'FR', 'FRA', 'فرنسا'),
(25266, 1500229632, 1500231679, 'ES', 'ESP', 'إسبانيا'),
(25267, 1500231680, 1500233727, 'DE', 'DEU', 'ألمانيا'),
(25268, 1500233728, 1500237823, 'RU', 'RUS', 'الإتحاد الروسي'),
(25269, 1500237824, 1500241919, 'SE', 'SWE', 'السويد'),
(25270, 1500241920, 1500242483, 'TR', 'TUR', 'تركيا'),
(25271, 1500242484, 1500242485, 'US', 'USA', 'الولايات المتحدة'),
(25272, 1500242486, 1500242486, 'TR', 'TUR', 'تركيا'),
(25273, 1500242487, 1500242488, 'US', 'USA', 'الولايات المتحدة'),
(25274, 1500242489, 1500242801, 'TR', 'TUR', 'تركيا'),
(25275, 1500242802, 1500242814, 'US', 'USA', 'الولايات المتحدة'),
(25276, 1500242815, 1500243008, 'TR', 'TUR', 'تركيا'),
(25277, 1500243009, 1500243038, 'GB', 'GBR', 'المملكة المتحدة'),
(25278, 1500243039, 1500243967, 'TR', 'TUR', 'تركيا'),
(25279, 1500243968, 1500246015, 'GB', 'GBR', 'المملكة المتحدة'),
(25280, 1500246016, 1500248063, 'ES', 'ESP', 'إسبانيا'),
(25281, 1500248064, 1500250111, 'HU', 'HUN', 'هنغاريا'),
(25282, 1500250112, 1500266495, 'SA', 'SAU', 'السعودية'),
(25283, 1500266496, 1500282879, 'RU', 'RUS', 'الإتحاد الروسي'),
(25284, 1500282880, 1500299263, 'LB', 'LBN', 'لبنان'),
(25285, 1500299264, 1500315647, 'PL', 'POL', 'بولندا'),
(25286, 1500315648, 1500332031, 'RU', 'RUS', 'الإتحاد الروسي'),
(25287, 1500332032, 1500348415, 'PT', 'PRT', 'البورتوغال'),
(25288, 1500348416, 1500397567, 'RU', 'RUS', 'الإتحاد الروسي'),
(25289, 1500397568, 1500399615, 'UA', 'UKR', 'أوكرانيا'),
(25290, 1500399616, 1500413951, 'RU', 'RUS', 'الإتحاد الروسي'),
(25291, 1500413952, 1500430335, 'DE', 'DEU', 'ألمانيا'),
(25292, 1500430336, 1500446719, 'RS', 'SRB', 'صربيا'),
(25293, 1500446720, 1500447743, 'LV', 'LVA', 'لاتفيا'),
(25294, 1500447744, 1500447999, 'LT', 'LTU', 'ليتوانيا'),
(25295, 1500448000, 1500448511, 'LV', 'LVA', 'لاتفيا'),
(25296, 1500448512, 1500448767, 'LT', 'LTU', 'ليتوانيا'),
(25297, 1500448768, 1500463103, 'LV', 'LVA', 'لاتفيا'),
(25298, 1500463104, 1500479487, 'CZ', 'CZE', 'التشيك'),
(25299, 1500479488, 1500495871, 'RU', 'RUS', 'الإتحاد الروسي'),
(25300, 1500495872, 1500512255, 'BA', 'BIH', 'البوسنه والهرسك'),
(25301, 1500512256, 1500643327, 'RU', 'RUS', 'الإتحاد الروسي'),
(25302, 1500643328, 1500774399, 'RO', 'ROM', 'رومانيا'),
(25303, 1500774400, 1500905471, 'LT', 'LTU', 'ليتوانيا'),
(25304, 1500905472, 1501036543, 'IT', 'ITA', 'إيطاليا'),
(25305, 1501036544, 1501298687, 'RO', 'ROM', 'رومانيا'),
(25306, 1501298688, 1501560831, 'IE', 'IRL', 'إيرلندا'),
(25307, 1501560832, 1501822975, 'ES', 'ESP', 'إسبانيا'),
(25308, 1501822976, 1502085119, 'HU', 'HUN', 'هنغاريا'),
(25309, 1502085120, 1502216191, 'RO', 'ROM', 'رومانيا'),
(25310, 1502216192, 1502347263, 'IL', 'ISR', 'إسرائيل'),
(25311, 1502347264, 1502478335, 'ES', 'ESP', 'إسبانيا'),
(25312, 1502478336, 1502605311, 'SI', 'SVN', 'سلوفينيا'),
(25313, 1502605312, 1502606335, 'HR', 'HRV', 'كرواتيا'),
(25314, 1502606336, 1502609407, 'SI', 'SVN', 'سلوفينيا'),
(25315, 1502609408, 1502610175, 'AT', 'AUT', 'النمسا'),
(25316, 1502610176, 1502625791, 'DE', 'DEU', 'ألمانيا'),
(25317, 1502625792, 1502642175, 'SA', 'SAU', 'السعودية'),
(25318, 1502642176, 1502658559, 'IR', 'IRN', 'إيران'),
(25319, 1502658560, 1502674943, 'AT', 'AUT', 'النمسا'),
(25320, 1502674944, 1502691327, 'DE', 'DEU', 'ألمانيا'),
(25321, 1502691328, 1502692415, 'GB', 'GBR', 'المملكة المتحدة'),
(25322, 1502692416, 1502692479, 'ES', 'ESP', 'إسبانيا'),
(25323, 1502692480, 1502707711, 'GB', 'GBR', 'المملكة المتحدة'),
(25324, 1502707712, 1502724095, 'RU', 'RUS', 'الإتحاد الروسي'),
(25325, 1502724096, 1502740479, 'GB', 'GBR', 'المملكة المتحدة'),
(25326, 1502740480, 1502756863, 'NL', 'NLD', 'هولندا'),
(25327, 1502756864, 1502773247, 'UZ', 'UZB', 'أوزباكستان'),
(25328, 1502773248, 1502789631, 'BA', 'BIH', 'البوسنه والهرسك'),
(25329, 1502789632, 1502791551, 'DE', 'DEU', 'ألمانيا'),
(25330, 1502791552, 1502791679, 'PL', 'POL', 'بولندا'),
(25331, 1502791680, 1502793503, 'DE', 'DEU', 'ألمانيا'),
(25332, 1502793504, 1502793511, 'NL', 'NLD', 'هولندا'),
(25333, 1502793512, 1502794239, 'DE', 'DEU', 'ألمانيا'),
(25334, 1502794240, 1502794495, 'NL', 'NLD', 'هولندا'),
(25335, 1502794496, 1502806015, 'DE', 'DEU', 'ألمانيا'),
(25336, 1502806016, 1502822399, 'SA', 'SAU', 'السعودية'),
(25337, 1502822400, 1502838783, 'HU', 'HUN', 'هنغاريا'),
(25338, 1502838784, 1502855167, 'SE', 'SWE', 'السويد'),
(25339, 1502855168, 1502871551, 'AZ', 'AZE', 'أذربيجان'),
(25340, 1502871552, 1502887935, 'BH', 'BHR', 'البحرين'),
(25341, 1502887936, 1502904319, 'HU', 'HUN', 'هنغاريا'),
(25342, 1502904320, 1502920703, 'IT', 'ITA', 'إيطاليا'),
(25343, 1502920704, 1502937087, 'RU', 'RUS', 'الإتحاد الروسي'),
(25344, 1502937088, 1502953471, 'RO', 'ROM', 'رومانيا'),
(25345, 1502953472, 1502969855, 'MD', 'MDA', 'مولدوفا'),
(25346, 1502969856, 1502975231, 'US', 'USA', 'الولايات المتحدة'),
(25347, 1502975232, 1502975383, 'IE', 'IRL', 'إيرلندا'),
(25348, 1502975384, 1502975391, 'ES', 'ESP', 'إسبانيا'),
(25349, 1502975392, 1502975423, 'IE', 'IRL', 'إيرلندا'),
(25350, 1502975424, 1502975455, 'GB', 'GBR', 'المملكة المتحدة'),
(25351, 1502975456, 1502975487, 'IE', 'IRL', 'إيرلندا'),
(25352, 1502975488, 1502975743, 'ES', 'ESP', 'إسبانيا'),
(25353, 1502975744, 1502975999, 'IE', 'IRL', 'إيرلندا'),
(25354, 1502976000, 1502977055, 'US', 'USA', 'الولايات المتحدة'),
(25355, 1502977056, 1502977279, 'IE', 'IRL', 'إيرلندا'),
(25356, 1502977280, 1502979071, 'US', 'USA', 'الولايات المتحدة'),
(25357, 1502979072, 1502979103, 'IE', 'IRL', 'إيرلندا'),
(25358, 1502979104, 1502979111, 'ES', 'ESP', 'إسبانيا'),
(25359, 1502979112, 1502979119, 'IE', 'IRL', 'إيرلندا'),
(25360, 1502979120, 1502979135, 'ES', 'ESP', 'إسبانيا'),
(25361, 1502979136, 1502979199, 'IE', 'IRL', 'إيرلندا'),
(25362, 1502979200, 1502979215, 'ES', 'ESP', 'إسبانيا'),
(25363, 1502979216, 1502979327, 'IE', 'IRL', 'إيرلندا'),
(25364, 1502979328, 1502979583, 'US', 'USA', 'الولايات المتحدة'),
(25365, 1502979584, 1502980095, 'IE', 'IRL', 'إيرلندا'),
(25366, 1502980096, 1502980159, 'US', 'USA', 'الولايات المتحدة'),
(25367, 1502980160, 1502980351, 'IE', 'IRL', 'إيرلندا'),
(25368, 1502980352, 1502980871, 'US', 'USA', 'الولايات المتحدة'),
(25369, 1502980872, 1502981119, 'IE', 'IRL', 'إيرلندا'),
(25370, 1502981120, 1502981887, 'US', 'USA', 'الولايات المتحدة'),
(25371, 1502981888, 1502982143, 'NL', 'NLD', 'هولندا'),
(25372, 1502982144, 1502982911, 'DE', 'DEU', 'ألمانيا'),
(25373, 1502982912, 1502983679, 'IE', 'IRL', 'إيرلندا'),
(25374, 1502983680, 1502986255, 'DE', 'DEU', 'ألمانيا'),
(25375, 1502986256, 1502986495, 'TR', 'TUR', 'تركيا'),
(25376, 1502986496, 1502986511, 'DE', 'DEU', 'ألمانيا'),
(25377, 1502986512, 1502986751, 'PL', 'POL', 'بولندا'),
(25378, 1502986752, 1502987775, 'DE', 'DEU', 'ألمانيا'),
(25379, 1502987776, 1502988031, 'TR', 'TUR', 'تركيا'),
(25380, 1502988032, 1502989055, 'DE', 'DEU', 'ألمانيا'),
(25381, 1502989056, 1502989567, 'TR', 'TUR', 'تركيا'),
(25382, 1502989568, 1502990847, 'DE', 'DEU', 'ألمانيا'),
(25383, 1502990848, 1502991103, 'PL', 'POL', 'بولندا'),
(25384, 1502991104, 1502991359, 'DE', 'DEU', 'ألمانيا'),
(25385, 1502991360, 1502991615, 'PL', 'POL', 'بولندا'),
(25386, 1502991616, 1502994687, 'DE', 'DEU', 'ألمانيا'),
(25387, 1502994688, 1502994943, 'PL', 'POL', 'بولندا'),
(25388, 1502994944, 1502995967, 'DE', 'DEU', 'ألمانيا'),
(25389, 1502995968, 1502996479, 'PL', 'POL', 'بولندا'),
(25390, 1502996480, 1502996735, 'DE', 'DEU', 'ألمانيا'),
(25391, 1502996736, 1502997247, 'PL', 'POL', 'بولندا'),
(25392, 1502997248, 1502997503, 'LT', 'LTU', 'ليتوانيا'),
(25393, 1502997504, 1502997759, 'HK', 'HKG', 'هونغ كونغ'),
(25394, 1502997760, 1503000063, 'DE', 'DEU', 'ألمانيا'),
(25395, 1503000064, 1503000319, 'PL', 'POL', 'بولندا'),
(25396, 1503000320, 1503000831, 'DE', 'DEU', 'ألمانيا'),
(25397, 1503000832, 1503001343, 'PL', 'POL', 'بولندا'),
(25398, 1503001344, 1503002623, 'DE', 'DEU', 'ألمانيا'),
(25399, 1503002624, 1503006719, 'GE', 'GEO', 'جورجيا'),
(25400, 1503006720, 1503010815, 'GB', 'GBR', 'المملكة المتحدة'),
(25401, 1503010816, 1503019007, 'IT', 'ITA', 'إيطاليا'),
(25402, 1503019008, 1503051775, 'DK', 'DNK', 'الدنيمارك'),
(25403, 1503051776, 1503068159, 'SE', 'SWE', 'السويد'),
(25404, 1503068160, 1503084543, 'PL', 'POL', 'بولندا'),
(25405, 1503084544, 1503100927, 'GB', 'GBR', 'المملكة المتحدة'),
(25406, 1503100928, 1503117311, 'RU', 'RUS', 'الإتحاد الروسي'),
(25407, 1503117312, 1503133695, 'NO', 'NOR', 'النرويج'),
(25408, 1503133696, 1503395839, 'PT', 'PRT', 'البورتوغال'),
(25409, 1503395840, 1503657983, 'FR', 'FRA', 'فرنسا'),
(25410, 1503657984, 1503690751, 'SE', 'SWE', 'السويد'),
(25411, 1503690752, 1503723519, 'IS', 'ISL', 'أيسلندا'),
(25412, 1503723520, 1503789055, 'PL', 'POL', 'بولندا'),
(25413, 1503789056, 1503821823, 'NO', 'NOR', 'النرويج'),
(25414, 1503821824, 1503854591, 'UA', 'UKR', 'أوكرانيا'),
(25415, 1503854592, 1503887359, 'RU', 'RUS', 'الإتحاد الروسي'),
(25416, 1503887360, 1503895615, 'DE', 'DEU', 'ألمانيا'),
(25417, 1503895616, 1503895623, 'NL', 'NLD', 'هولندا'),
(25418, 1503895624, 1503895631, 'DE', 'DEU', 'ألمانيا'),
(25419, 1503895632, 1503895639, 'AT', 'AUT', 'النمسا'),
(25420, 1503895640, 1503895671, 'DE', 'DEU', 'ألمانيا'),
(25421, 1503895672, 1503895679, 'PL', 'POL', 'بولندا'),
(25422, 1503895680, 1503895751, 'DE', 'DEU', 'ألمانيا'),
(25423, 1503895752, 1503895759, 'US', 'USA', 'الولايات المتحدة'),
(25424, 1503895760, 1503895767, 'DE', 'DEU', 'ألمانيا'),
(25425, 1503895768, 1503895783, 'IT', 'ITA', 'إيطاليا'),
(25426, 1503895784, 1503895799, 'DE', 'DEU', 'ألمانيا'),
(25427, 1503895800, 1503895807, 'CA', 'CAN', 'كندا'),
(25428, 1503895808, 1503896175, 'DE', 'DEU', 'ألمانيا'),
(25429, 1503896176, 1503896183, 'NL', 'NLD', 'هولندا'),
(25430, 1503896184, 1503896303, 'DE', 'DEU', 'ألمانيا'),
(25431, 1503896304, 1503896311, 'GR', 'GRC', 'اليونان'),
(25432, 1503896312, 1503896319, 'DE', 'DEU', 'ألمانيا'),
(25433, 1503896320, 1503896327, 'GR', 'GRC', 'اليونان'),
(25434, 1503896328, 1503896351, 'DE', 'DEU', 'ألمانيا'),
(25435, 1503896352, 1503896359, 'AT', 'AUT', 'النمسا'),
(25436, 1503896360, 1503896367, 'CH', 'CHE', 'سويسرا'),
(25437, 1503896368, 1503896375, 'DE', 'DEU', 'ألمانيا'),
(25438, 1503896376, 1503896383, 'CH', 'CHE', 'سويسرا'),
(25439, 1503896384, 1503896415, 'DE', 'DEU', 'ألمانيا'),
(25440, 1503896416, 1503896423, 'GR', 'GRC', 'اليونان'),
(25441, 1503896424, 1503896439, 'DE', 'DEU', 'ألمانيا'),
(25442, 1503896440, 1503896447, 'NO', 'NOR', 'النرويج'),
(25443, 1503896448, 1503896519, 'DE', 'DEU', 'ألمانيا'),
(25444, 1503896520, 1503896527, 'AT', 'AUT', 'النمسا'),
(25445, 1503896528, 1503896551, 'DE', 'DEU', 'ألمانيا'),
(25446, 1503896552, 1503896559, 'AT', 'AUT', 'النمسا'),
(25447, 1503896560, 1503897303, 'DE', 'DEU', 'ألمانيا'),
(25448, 1503897304, 1503897311, 'BE', 'BEL', 'بلجيكا'),
(25449, 1503897312, 1503897367, 'DE', 'DEU', 'ألمانيا'),
(25450, 1503897368, 1503897375, 'BE', 'BEL', 'بلجيكا'),
(25451, 1503897376, 1503908351, 'DE', 'DEU', 'ألمانيا'),
(25452, 1503908352, 1503909375, 'IT', 'ITA', 'إيطاليا'),
(25453, 1503909376, 1503920127, 'DE', 'DEU', 'ألمانيا'),
(25454, 1503920128, 1503985663, 'HR', 'HRV', 'كرواتيا'),
(25455, 1503985664, 1504018431, 'IR', 'IRN', 'إيران'),
(25456, 1504018432, 1504051199, 'RO', 'ROM', 'رومانيا'),
(25457, 1504051200, 1504083967, 'FI', 'FIN', 'فنلندا'),
(25458, 1504083968, 1504116735, 'DE', 'DEU', 'ألمانيا'),
(25459, 1504116736, 1504149503, 'PL', 'POL', 'بولندا'),
(25460, 1504149504, 1504152127, 'GB', 'GBR', 'المملكة المتحدة'),
(25461, 1504152128, 1504152191, 'IE', 'IRL', 'إيرلندا'),
(25462, 1504152192, 1504152415, 'GB', 'GBR', 'المملكة المتحدة'),
(25463, 1504152416, 1504152431, 'IE', 'IRL', 'إيرلندا'),
(25464, 1504152432, 1504152447, 'GB', 'GBR', 'المملكة المتحدة'),
(25465, 1504152448, 1504152575, 'IE', 'IRL', 'إيرلندا'),
(25466, 1504152576, 1504154623, 'GB', 'GBR', 'المملكة المتحدة'),
(25467, 1504154624, 1504155647, 'IE', 'IRL', 'إيرلندا'),
(25468, 1504155648, 1504156927, 'GB', 'GBR', 'المملكة المتحدة'),
(25469, 1504156928, 1504157183, 'IE', 'IRL', 'إيرلندا'),
(25470, 1504157184, 1504161279, 'GB', 'GBR', 'المملكة المتحدة'),
(25471, 1504161280, 1504161535, 'IE', 'IRL', 'إيرلندا'),
(25472, 1504161536, 1504164607, 'GB', 'GBR', 'المملكة المتحدة'),
(25473, 1504164608, 1504164863, 'IE', 'IRL', 'إيرلندا'),
(25474, 1504164864, 1504169983, 'GB', 'GBR', 'المملكة المتحدة'),
(25475, 1504169984, 1504170239, 'IE', 'IRL', 'إيرلندا'),
(25476, 1504170240, 1504171007, 'GB', 'GBR', 'المملكة المتحدة'),
(25477, 1504171008, 1504171263, 'PT', 'PRT', 'البورتوغال'),
(25478, 1504171264, 1504171775, 'GB', 'GBR', 'المملكة المتحدة'),
(25479, 1504171776, 1504172031, 'US', 'USA', 'الولايات المتحدة'),
(25480, 1504172032, 1504173055, 'GB', 'GBR', 'المملكة المتحدة'),
(25481, 1504173056, 1504173311, 'IE', 'IRL', 'إيرلندا'),
(25482, 1504173312, 1504174591, 'GB', 'GBR', 'المملكة المتحدة'),
(25483, 1504174592, 1504175103, 'IE', 'IRL', 'إيرلندا'),
(25484, 1504175104, 1504176383, 'GB', 'GBR', 'المملكة المتحدة'),
(25485, 1504176384, 1504176639, 'IE', 'IRL', 'إيرلندا'),
(25486, 1504176640, 1504178431, 'GB', 'GBR', 'المملكة المتحدة'),
(25487, 1504178432, 1504178687, 'IE', 'IRL', 'إيرلندا'),
(25488, 1504178688, 1504247807, 'GB', 'GBR', 'المملكة المتحدة'),
(25489, 1504247808, 1504313343, 'RU', 'RUS', 'الإتحاد الروسي'),
(25490, 1504313344, 1504378879, 'FR', 'FRA', 'فرنسا'),
(25491, 1504378880, 1504444415, 'PL', 'POL', 'بولندا'),
(25492, 1504444416, 1504509951, 'HR', 'HRV', 'كرواتيا'),
(25493, 1504509952, 1504575487, 'SK', 'SVK', 'سلوفاكيا'),
(25494, 1504575488, 1504641023, 'PL', 'POL', 'بولندا'),
(25495, 1504641024, 1504706559, 'RU', 'RUS', 'الإتحاد الروسي'),
(25496, 1504706560, 1504837631, 'CZ', 'CZE', 'التشيك'),
(25497, 1504837632, 1504968703, 'RU', 'RUS', 'الإتحاد الروسي'),
(25498, 1504968704, 1505099775, 'PT', 'PRT', 'البورتوغال'),
(25499, 1505099776, 1505230847, 'DE', 'DEU', 'ألمانيا'),
(25500, 1505230848, 1505239039, 'RU', 'RUS', 'الإتحاد الروسي'),
(25501, 1505239040, 1505247231, 'IE', 'IRL', 'إيرلندا'),
(25502, 1505247232, 1505255423, 'UA', 'UKR', 'أوكرانيا'),
(25503, 1505255424, 1505263615, 'IT', 'ITA', 'إيطاليا'),
(25504, 1505263616, 1505271807, 'DK', 'DNK', 'الدنيمارك'),
(25505, 1505271808, 1505273087, 'NL', 'NLD', 'هولندا'),
(25506, 1505273088, 1505273095, 'NZ', 'NZL', 'نيوزيلاندا'),
(25507, 1505273096, 1505279999, 'NL', 'NLD', 'هولندا'),
(25508, 1505288192, 1505296383, 'RU', 'RUS', 'الإتحاد الروسي'),
(25509, 1505296384, 1505304575, 'UA', 'UKR', 'أوكرانيا'),
(25510, 1505304576, 1505305198, 'FR', 'FRA', 'فرنسا'),
(25511, 1505305199, 1505305199, 'DK', 'DNK', 'الدنيمارك'),
(25512, 1505305200, 1505305200, 'BE', 'BEL', 'بلجيكا'),
(25513, 1505305201, 1505305201, 'NL', 'NLD', 'هولندا'),
(25514, 1505305202, 1505305202, 'GB', 'GBR', 'المملكة المتحدة'),
(25515, 1505305203, 1505305203, 'CA', 'CAN', 'كندا'),
(25516, 1505305204, 1505305204, 'FR', 'FRA', 'فرنسا'),
(25517, 1505305205, 1505305205, 'CH', 'CHE', 'سويسرا'),
(25518, 1505305206, 1505305206, 'DE', 'DEU', 'ألمانيا'),
(25519, 1505305207, 1505305207, 'AT', 'AUT', 'النمسا'),
(25520, 1505305208, 1505305208, 'IT', 'ITA', 'إيطاليا'),
(25521, 1505305209, 1505305209, 'ES', 'ESP', 'إسبانيا'),
(25522, 1505305210, 1505305210, 'SE', 'SWE', 'السويد'),
(25523, 1505305211, 1505305211, 'NO', 'NOR', 'النرويج'),
(25524, 1505305212, 1505305878, 'FR', 'FRA', 'فرنسا'),
(25525, 1505305879, 1505305879, 'US', 'USA', 'الولايات المتحدة'),
(25526, 1505305880, 1505305880, 'ES', 'ESP', 'إسبانيا'),
(25527, 1505305881, 1505305899, 'FR', 'FRA', 'فرنسا'),
(25528, 1505305900, 1505305900, 'GB', 'GBR', 'المملكة المتحدة'),
(25529, 1505305901, 1505305901, 'DE', 'DEU', 'ألمانيا'),
(25530, 1505305902, 1505305902, 'IT', 'ITA', 'إيطاليا'),
(25531, 1505305903, 1505305908, 'FR', 'FRA', 'فرنسا'),
(25532, 1505305909, 1505305909, 'LU', 'LUX', 'لوكسيمبورغ'),
(25533, 1505305910, 1505306303, 'FR', 'FRA', 'فرنسا'),
(25534, 1505306304, 1505306319, 'ES', 'ESP', 'إسبانيا'),
(25535, 1505306320, 1505306335, 'DE', 'DEU', 'ألمانيا'),
(25536, 1505306336, 1505306351, 'GB', 'GBR', 'المملكة المتحدة'),
(25537, 1505306352, 1505306367, 'IT', 'ITA', 'إيطاليا'),
(25538, 1505306368, 1505312767, 'FR', 'FRA', 'فرنسا'),
(25539, 1505312768, 1505320959, 'RU', 'RUS', 'الإتحاد الروسي'),
(25540, 1505320960, 1505329151, 'AT', 'AUT', 'النمسا'),
(25541, 1505329152, 1505329215, 'GB', 'GBR', 'المملكة المتحدة'),
(25542, 1505329216, 1505329375, 'IE', 'IRL', 'إيرلندا'),
(25543, 1505329376, 1505329407, 'GB', 'GBR', 'المملكة المتحدة'),
(25544, 1505329408, 1505332991, 'IE', 'IRL', 'إيرلندا'),
(25545, 1505332992, 1505332999, 'GB', 'GBR', 'المملكة المتحدة'),
(25546, 1505333000, 1505336063, 'IE', 'IRL', 'إيرلندا'),
(25547, 1505336064, 1505336071, 'GB', 'GBR', 'المملكة المتحدة'),
(25548, 1505336072, 1505336831, 'IE', 'IRL', 'إيرلندا'),
(25549, 1505336832, 1505336863, 'GB', 'GBR', 'المملكة المتحدة'),
(25550, 1505336864, 1505336864, 'IE', 'IRL', 'إيرلندا'),
(25551, 1505336865, 1505336879, 'GB', 'GBR', 'المملكة المتحدة'),
(25552, 1505336880, 1505337087, 'IE', 'IRL', 'إيرلندا'),
(25553, 1505337088, 1505337215, 'GB', 'GBR', 'المملكة المتحدة'),
(25554, 1505337216, 1505337343, 'IE', 'IRL', 'إيرلندا'),
(25555, 1505337344, 1505345535, 'FR', 'FRA', 'فرنسا'),
(25556, 1505345536, 1505353727, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(25557, 1505353728, 1505359663, 'CZ', 'CZE', 'التشيك'),
(25558, 1505359664, 1505359671, 'SK', 'SVK', 'سلوفاكيا'),
(25559, 1505359672, 1505359675, 'CZ', 'CZE', 'التشيك'),
(25560, 1505359676, 1505359679, 'SK', 'SVK', 'سلوفاكيا'),
(25561, 1505359680, 1505359759, 'CZ', 'CZE', 'التشيك'),
(25562, 1505359760, 1505359775, 'SK', 'SVK', 'سلوفاكيا'),
(25563, 1505359776, 1505361919, 'CZ', 'CZE', 'التشيك'),
(25564, 1505361920, 1505370111, 'PL', 'POL', 'بولندا'),
(25565, 1505370112, 1505378303, 'SM', 'SMR', 'سان مارينو'),
(25566, 1505378304, 1505386495, 'IT', 'ITA', 'إيطاليا'),
(25567, 1505386496, 1505394687, 'HU', 'HUN', 'هنغاريا'),
(25568, 1505394688, 1505402879, 'DE', 'DEU', 'ألمانيا'),
(25569, 1505402880, 1505411071, 'DK', 'DNK', 'الدنيمارك'),
(25570, 1505411072, 1505419263, 'BG', 'BGR', 'بلغاريا'),
(25571, 1505419264, 1505427455, 'RU', 'RUS', 'الإتحاد الروسي'),
(25572, 1505427456, 1505435647, 'UA', 'UKR', 'أوكرانيا'),
(25573, 1505435648, 1505443839, 'MD', 'MDA', 'مولدوفا'),
(25574, 1505443840, 1505452327, 'GB', 'GBR', 'المملكة المتحدة'),
(25575, 1505452328, 1505452335, 'NO', 'NOR', 'النرويج'),
(25576, 1505452336, 1505454367, 'GB', 'GBR', 'المملكة المتحدة'),
(25577, 1505454368, 1505454375, 'US', 'USA', 'الولايات المتحدة'),
(25578, 1505454376, 1505454383, 'GB', 'GBR', 'المملكة المتحدة'),
(25579, 1505454384, 1505454391, 'US', 'USA', 'الولايات المتحدة'),
(25580, 1505454392, 1505454399, 'SG', 'SGP', 'سنغافورة'),
(25581, 1505454400, 1505454463, 'GB', 'GBR', 'المملكة المتحدة'),
(25582, 1505454464, 1505454495, 'AU', 'AUS', 'أستراليا'),
(25583, 1505454496, 1505454511, 'GB', 'GBR', 'المملكة المتحدة'),
(25584, 1505454512, 1505454527, 'DE', 'DEU', 'ألمانيا'),
(25585, 1505454528, 1505454543, 'NZ', 'NZL', 'نيوزيلاندا'),
(25586, 1505454544, 1505454911, 'GB', 'GBR', 'المملكة المتحدة'),
(25587, 1505454912, 1505454943, 'CZ', 'CZE', 'التشيك'),
(25588, 1505454944, 1505454975, 'GB', 'GBR', 'المملكة المتحدة'),
(25589, 1505454976, 1505455103, 'US', 'USA', 'الولايات المتحدة'),
(25590, 1505455104, 1505456127, 'GB', 'GBR', 'المملكة المتحدة'),
(25591, 1505456128, 1505456255, 'US', 'USA', 'الولايات المتحدة'),
(25592, 1505456256, 1505456639, 'GB', 'GBR', 'المملكة المتحدة'),
(25593, 1505456640, 1505456895, 'US', 'USA', 'الولايات المتحدة'),
(25594, 1505456896, 1505456927, 'GB', 'GBR', 'المملكة المتحدة'),
(25595, 1505456928, 1505456935, 'US', 'USA', 'الولايات المتحدة'),
(25596, 1505456936, 1505458175, 'GB', 'GBR', 'المملكة المتحدة'),
(25597, 1505458176, 1505458431, 'US', 'USA', 'الولايات المتحدة'),
(25598, 1505458432, 1505460223, 'GB', 'GBR', 'المملكة المتحدة'),
(25599, 1505460224, 1505476607, 'CZ', 'CZE', 'التشيك'),
(25600, 1505476608, 1505484799, 'RU', 'RUS', 'الإتحاد الروسي'),
(25601, 1505484800, 1505492991, 'PL', 'POL', 'بولندا'),
(25602, 1505492992, 1505501183, 'NL', 'NLD', 'هولندا'),
(25603, 1505501184, 1505509375, 'ME', 'MNE', 'الجبل الأسود'),
(25604, 1505509376, 1505517567, 'SA', 'SAU', 'السعودية'),
(25605, 1505517568, 1505525759, 'RU', 'RUS', 'الإتحاد الروسي'),
(25606, 1505525760, 1505533951, 'IT', 'ITA', 'إيطاليا'),
(25607, 1505533952, 1505542143, 'RU', 'RUS', 'الإتحاد الروسي'),
(25608, 1505542144, 1505550335, 'PL', 'POL', 'بولندا'),
(25609, 1505550336, 1505566719, 'RU', 'RUS', 'الإتحاد الروسي'),
(25610, 1505566720, 1505574911, 'IT', 'ITA', 'إيطاليا'),
(25611, 1505574912, 1505583103, 'YE', 'YEM', 'اليمن'),
(25612, 1505583104, 1505607679, 'RU', 'RUS', 'الإتحاد الروسي'),
(25613, 1505607680, 1505615871, 'SE', 'SWE', 'السويد'),
(25614, 1505615872, 1505624063, 'SA', 'SAU', 'السعودية'),
(25615, 1505624064, 1505632255, 'FI', 'FIN', 'فنلندا'),
(25616, 1505632256, 1505648639, 'CZ', 'CZE', 'التشيك'),
(25617, 1505648640, 1505656831, 'LT', 'LTU', 'ليتوانيا'),
(25618, 1505656832, 1505665023, 'BH', 'BHR', 'البحرين'),
(25619, 1505665024, 1505668263, 'IT', 'ITA', 'إيطاليا'),
(25620, 1505668264, 1505668267, 'DE', 'DEU', 'ألمانيا'),
(25621, 1505668268, 1505670615, 'IT', 'ITA', 'إيطاليا'),
(25622, 1505670616, 1505670623, 'US', 'USA', 'الولايات المتحدة'),
(25623, 1505670624, 1505673215, 'IT', 'ITA', 'إيطاليا'),
(25624, 1505673216, 1505681407, 'BG', 'BGR', 'بلغاريا'),
(25625, 1505681408, 1505689599, 'RU', 'RUS', 'الإتحاد الروسي'),
(25626, 1505689600, 1505697791, 'NO', 'NOR', 'النرويج'),
(25627, 1505697792, 1505705983, 'IE', 'IRL', 'إيرلندا'),
(25628, 1505705984, 1505707327, 'DE', 'DEU', 'ألمانيا'),
(25629, 1505707328, 1505707519, 'AT', 'AUT', 'النمسا'),
(25630, 1505707520, 1505708543, 'DE', 'DEU', 'ألمانيا'),
(25631, 1505708544, 1505709055, 'AT', 'AUT', 'النمسا'),
(25632, 1505709056, 1505714175, 'DE', 'DEU', 'ألمانيا'),
(25633, 1505714176, 1505722367, 'LV', 'LVA', 'لاتفيا'),
(25634, 1505722368, 1505738751, 'PL', 'POL', 'بولندا'),
(25635, 1505738752, 1505745839, 'GB', 'GBR', 'المملكة المتحدة'),
(25636, 1505745840, 1505745855, 'IL', 'ISR', 'إسرائيل'),
(25637, 1505745856, 1505746943, 'GB', 'GBR', 'المملكة المتحدة'),
(25638, 1505746944, 1505755135, 'RU', 'RUS', 'الإتحاد الروسي'),
(25639, 1505755136, 1506017279, 'GB', 'GBR', 'المملكة المتحدة'),
(25640, 1506017280, 1506279423, 'DE', 'DEU', 'ألمانيا'),
(25641, 1506279424, 1506312191, 'NL', 'NLD', 'هولندا'),
(25642, 1506312192, 1506316287, 'GB', 'GBR', 'المملكة المتحدة'),
(25643, 1506316288, 1506322431, 'PL', 'POL', 'بولندا'),
(25644, 1506322432, 1506324479, 'DE', 'DEU', 'ألمانيا'),
(25645, 1506324480, 1506328575, 'RU', 'RUS', 'الإتحاد الروسي'),
(25646, 1506328576, 1506330623, 'FI', 'FIN', 'فنلندا'),
(25647, 1506330624, 1506332671, 'NL', 'NLD', 'هولندا'),
(25648, 1506332672, 1506334719, 'PL', 'POL', 'بولندا'),
(25649, 1506334720, 1506336767, 'GB', 'GBR', 'المملكة المتحدة'),
(25650, 1506336768, 1506338815, 'PL', 'POL', 'بولندا'),
(25651, 1506338816, 1506340863, 'UA', 'UKR', 'أوكرانيا'),
(25652, 1506340864, 1506342911, 'RO', 'ROM', 'رومانيا'),
(25653, 1506342912, 1506344959, 'UA', 'UKR', 'أوكرانيا'),
(25654, 1506344960, 1506377727, 'LV', 'LVA', 'لاتفيا'),
(25655, 1506377728, 1506410495, 'HR', 'HRV', 'كرواتيا'),
(25656, 1506410496, 1506427663, 'DE', 'DEU', 'ألمانيا'),
(25657, 1506427664, 1506427679, 'GB', 'GBR', 'المملكة المتحدة'),
(25658, 1506427680, 1506428223, 'DE', 'DEU', 'ألمانيا'),
(25659, 1506428224, 1506428239, 'US', 'USA', 'الولايات المتحدة'),
(25660, 1506428240, 1506437631, 'DE', 'DEU', 'ألمانيا'),
(25661, 1506437632, 1506437887, 'MU', 'MUS', 'موريشيوس'),
(25662, 1506437888, 1506437903, 'CA', 'CAN', 'كندا'),
(25663, 1506437904, 1506437919, 'DE', 'DEU', 'ألمانيا'),
(25664, 1506437920, 1506437951, 'IN', 'IND', 'الهند'),
(25665, 1506437952, 1506437983, 'DE', 'DEU', 'ألمانيا'),
(25666, 1506437984, 1506437991, 'US', 'USA', 'الولايات المتحدة'),
(25667, 1506437992, 1506437999, 'DE', 'DEU', 'ألمانيا'),
(25668, 1506438000, 1506438015, 'CA', 'CAN', 'كندا'),
(25669, 1506438016, 1506438143, 'DE', 'DEU', 'ألمانيا'),
(25670, 1506438144, 1506438271, 'HK', 'HKG', 'هونغ كونغ'),
(25671, 1506438272, 1506438399, 'DE', 'DEU', 'ألمانيا'),
(25672, 1506438400, 1506438527, 'US', 'USA', 'الولايات المتحدة'),
(25673, 1506438528, 1506438783, 'DE', 'DEU', 'ألمانيا'),
(25674, 1506438784, 1506438799, 'KR', 'KOR', 'جمهورية كوريا'),
(25675, 1506438800, 1506438847, 'DE', 'DEU', 'ألمانيا'),
(25676, 1506438848, 1506438863, 'US', 'USA', 'الولايات المتحدة'),
(25677, 1506438864, 1506438871, 'DE', 'DEU', 'ألمانيا'),
(25678, 1506438872, 1506438879, 'FR', 'FRA', 'فرنسا'),
(25679, 1506438880, 1506438911, 'DE', 'DEU', 'ألمانيا'),
(25680, 1506438912, 1506439039, 'US', 'USA', 'الولايات المتحدة'),
(25681, 1506439040, 1506439935, 'DE', 'DEU', 'ألمانيا'),
(25682, 1506439936, 1506440191, 'US', 'USA', 'الولايات المتحدة'),
(25683, 1506440192, 1506440447, 'DE', 'DEU', 'ألمانيا'),
(25684, 1506440448, 1506440575, 'US', 'USA', 'الولايات المتحدة'),
(25685, 1506440576, 1506440703, 'DE', 'DEU', 'ألمانيا'),
(25686, 1506440704, 1506440711, 'US', 'USA', 'الولايات المتحدة'),
(25687, 1506440712, 1506440719, 'FR', 'FRA', 'فرنسا'),
(25688, 1506440720, 1506440735, 'US', 'USA', 'الولايات المتحدة'),
(25689, 1506440736, 1506440767, 'GB', 'GBR', 'المملكة المتحدة'),
(25690, 1506440768, 1506440799, 'US', 'USA', 'الولايات المتحدة'),
(25691, 1506440800, 1506440831, 'DE', 'DEU', 'ألمانيا'),
(25692, 1506440832, 1506440959, 'US', 'USA', 'الولايات المتحدة'),
(25693, 1506440960, 1506440991, 'FR', 'FRA', 'فرنسا'),
(25694, 1506440992, 1506440999, 'US', 'USA', 'الولايات المتحدة'),
(25695, 1506441000, 1506441007, 'GB', 'GBR', 'المملكة المتحدة'),
(25696, 1506441008, 1506441023, 'US', 'USA', 'الولايات المتحدة'),
(25697, 1506441024, 1506441087, 'HK', 'HKG', 'هونغ كونغ'),
(25698, 1506441088, 1506441215, 'CA', 'CAN', 'كندا'),
(25699, 1506441216, 1506441343, 'US', 'USA', 'الولايات المتحدة'),
(25700, 1506441344, 1506441407, 'HK', 'HKG', 'هونغ كونغ'),
(25701, 1506441408, 1506441415, 'DE', 'DEU', 'ألمانيا'),
(25702, 1506441416, 1506441423, 'FR', 'FRA', 'فرنسا'),
(25703, 1506441424, 1506441495, 'DE', 'DEU', 'ألمانيا'),
(25704, 1506441496, 1506441503, 'GB', 'GBR', 'المملكة المتحدة'),
(25705, 1506441504, 1506441535, 'US', 'USA', 'الولايات المتحدة'),
(25706, 1506441536, 1506441599, 'DE', 'DEU', 'ألمانيا'),
(25707, 1506441600, 1506441631, 'US', 'USA', 'الولايات المتحدة'),
(25708, 1506441632, 1506441647, 'DE', 'DEU', 'ألمانيا'),
(25709, 1506441648, 1506441663, 'GB', 'GBR', 'المملكة المتحدة'),
(25710, 1506441664, 1506441671, 'NL', 'NLD', 'هولندا'),
(25711, 1506441672, 1506441679, 'CA', 'CAN', 'كندا'),
(25712, 1506441680, 1506441695, 'DE', 'DEU', 'ألمانيا'),
(25713, 1506441696, 1506441727, 'CA', 'CAN', 'كندا'),
(25714, 1506441728, 1506442239, 'MU', 'MUS', 'موريشيوس'),
(25715, 1506442240, 1506442383, 'US', 'USA', 'الولايات المتحدة'),
(25716, 1506442384, 1506442399, 'GB', 'GBR', 'المملكة المتحدة'),
(25717, 1506442400, 1506442415, 'FR', 'FRA', 'فرنسا'),
(25718, 1506442416, 1506442427, 'US', 'USA', 'الولايات المتحدة'),
(25719, 1506442428, 1506442431, 'DE', 'DEU', 'ألمانيا'),
(25720, 1506442432, 1506442463, 'HK', 'HKG', 'هونغ كونغ'),
(25721, 1506442464, 1506442623, 'DE', 'DEU', 'ألمانيا'),
(25722, 1506442624, 1506442655, 'GB', 'GBR', 'المملكة المتحدة'),
(25723, 1506442656, 1506442687, 'US', 'USA', 'الولايات المتحدة'),
(25724, 1506442688, 1506442703, 'GB', 'GBR', 'المملكة المتحدة'),
(25725, 1506442704, 1506442711, 'US', 'USA', 'الولايات المتحدة'),
(25726, 1506442712, 1506442715, 'NL', 'NLD', 'هولندا'),
(25727, 1506442716, 1506442719, 'US', 'USA', 'الولايات المتحدة'),
(25728, 1506442720, 1506442735, 'GB', 'GBR', 'المملكة المتحدة'),
(25729, 1506442736, 1506442743, 'DE', 'DEU', 'ألمانيا'),
(25730, 1506442744, 1506442751, 'US', 'USA', 'الولايات المتحدة'),
(25731, 1506442752, 1506442879, 'DE', 'DEU', 'ألمانيا'),
(25732, 1506442880, 1506442911, 'GB', 'GBR', 'المملكة المتحدة'),
(25733, 1506442912, 1506442919, 'DE', 'DEU', 'ألمانيا'),
(25734, 1506442920, 1506442923, 'GB', 'GBR', 'المملكة المتحدة'),
(25735, 1506442924, 1506442927, 'NL', 'NLD', 'هولندا'),
(25736, 1506442928, 1506442975, 'US', 'USA', 'الولايات المتحدة'),
(25737, 1506442976, 1506442991, 'DE', 'DEU', 'ألمانيا'),
(25738, 1506442992, 1506442999, 'GB', 'GBR', 'المملكة المتحدة'),
(25739, 1506443000, 1506443003, 'IE', 'IRL', 'إيرلندا'),
(25740, 1506443004, 1506443151, 'DE', 'DEU', 'ألمانيا'),
(25741, 1506443152, 1506443159, 'US', 'USA', 'الولايات المتحدة'),
(25742, 1506443160, 1506443167, 'GB', 'GBR', 'المملكة المتحدة'),
(25743, 1506443168, 1506443183, 'NL', 'NLD', 'هولندا'),
(25744, 1506443184, 1506443199, 'DE', 'DEU', 'ألمانيا'),
(25745, 1506443200, 1506443263, 'US', 'USA', 'الولايات المتحدة'),
(25746, 1506443264, 1506444287, 'GB', 'GBR', 'المملكة المتحدة'),
(25747, 1506444288, 1506445311, 'DE', 'DEU', 'ألمانيا'),
(25748, 1506445312, 1506445337, 'FR', 'FRA', 'فرنسا'),
(25749, 1506445338, 1506445343, 'GB', 'GBR', 'المملكة المتحدة'),
(25750, 1506445344, 1506445519, 'FR', 'FRA', 'فرنسا'),
(25751, 1506445520, 1506445527, 'GB', 'GBR', 'المملكة المتحدة'),
(25752, 1506445528, 1506445695, 'FR', 'FRA', 'فرنسا'),
(25753, 1506445696, 1506445719, 'GB', 'GBR', 'المملكة المتحدة'),
(25754, 1506445720, 1506445807, 'FR', 'FRA', 'فرنسا'),
(25755, 1506445808, 1506445823, 'GB', 'GBR', 'المملكة المتحدة'),
(25756, 1506445824, 1506446159, 'FR', 'FRA', 'فرنسا'),
(25757, 1506446160, 1506446175, 'GB', 'GBR', 'المملكة المتحدة'),
(25758, 1506446176, 1506446207, 'FR', 'FRA', 'فرنسا'),
(25759, 1506446208, 1506446335, 'GB', 'GBR', 'المملكة المتحدة'),
(25760, 1506446336, 1506447359, 'NL', 'NLD', 'هولندا'),
(25761, 1506447360, 1506448383, 'IT', 'ITA', 'إيطاليا'),
(25762, 1506448384, 1506448639, 'AT', 'AUT', 'النمسا'),
(25763, 1506448640, 1506448647, 'GB', 'GBR', 'المملكة المتحدة'),
(25764, 1506448648, 1506448663, 'AT', 'AUT', 'النمسا'),
(25765, 1506448664, 1506448671, 'GB', 'GBR', 'المملكة المتحدة'),
(25766, 1506448672, 1506448719, 'AT', 'AUT', 'النمسا'),
(25767, 1506448720, 1506448727, 'GB', 'GBR', 'المملكة المتحدة'),
(25768, 1506448728, 1506448735, 'AT', 'AUT', 'النمسا'),
(25769, 1506448736, 1506448895, 'GB', 'GBR', 'المملكة المتحدة'),
(25770, 1506448896, 1506449167, 'BE', 'BEL', 'بلجيكا'),
(25771, 1506449168, 1506449171, 'GB', 'GBR', 'المملكة المتحدة'),
(25772, 1506449172, 1506449407, 'BE', 'BEL', 'بلجيكا'),
(25773, 1506449408, 1506449663, 'NL', 'NLD', 'هولندا'),
(25774, 1506449664, 1506449919, 'SK', 'SVK', 'سلوفاكيا'),
(25775, 1506449920, 1506449927, 'CH', 'CHE', 'سويسرا'),
(25776, 1506449928, 1506449935, 'GB', 'GBR', 'المملكة المتحدة'),
(25777, 1506449936, 1506450431, 'CH', 'CHE', 'سويسرا'),
(25778, 1506450432, 1506450767, 'CZ', 'CZE', 'التشيك'),
(25779, 1506450768, 1506450847, 'GB', 'GBR', 'المملكة المتحدة'),
(25780, 1506450848, 1506450943, 'CZ', 'CZE', 'التشيك'),
(25781, 1506450944, 1506451007, 'DK', 'DNK', 'الدنيمارك'),
(25782, 1506451008, 1506451199, 'GB', 'GBR', 'المملكة المتحدة'),
(25783, 1506451200, 1506451895, 'ES', 'ESP', 'إسبانيا'),
(25784, 1506451896, 1506451903, 'GB', 'GBR', 'المملكة المتحدة'),
(25785, 1506451904, 1506452223, 'ES', 'ESP', 'إسبانيا'),
(25786, 1506452224, 1506452479, 'GB', 'GBR', 'المملكة المتحدة'),
(25787, 1506452480, 1506452735, 'US', 'USA', 'الولايات المتحدة'),
(25788, 1506452736, 1506452751, 'RO', 'ROM', 'رومانيا'),
(25789, 1506452752, 1506452991, 'GB', 'GBR', 'المملكة المتحدة'),
(25790, 1506452992, 1506453247, 'AT', 'AUT', 'النمسا'),
(25791, 1506453248, 1506453391, 'SE', 'SWE', 'السويد'),
(25792, 1506453392, 1506453399, 'ES', 'ESP', 'إسبانيا'),
(25793, 1506453400, 1506453415, 'SE', 'SWE', 'السويد'),
(25794, 1506453416, 1506453423, 'GB', 'GBR', 'المملكة المتحدة'),
(25795, 1506453424, 1506453439, 'SE', 'SWE', 'السويد'),
(25796, 1506453440, 1506453503, 'GB', 'GBR', 'المملكة المتحدة'),
(25797, 1506453504, 1506453759, 'DE', 'DEU', 'ألمانيا'),
(25798, 1506453760, 1506454015, 'FR', 'FRA', 'فرنسا'),
(25799, 1506454016, 1506454271, 'GB', 'GBR', 'المملكة المتحدة'),
(25800, 1506454272, 1506454527, 'ES', 'ESP', 'إسبانيا'),
(25801, 1506454528, 1506454783, 'GB', 'GBR', 'المملكة المتحدة'),
(25802, 1506454784, 1506455039, 'US', 'USA', 'الولايات المتحدة'),
(25803, 1506455040, 1506455295, 'GB', 'GBR', 'المملكة المتحدة'),
(25804, 1506455296, 1506455551, 'IT', 'ITA', 'إيطاليا'),
(25805, 1506455552, 1506456063, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(25806, 1506456064, 1506456319, 'HU', 'HUN', 'هنغاريا'),
(25807, 1506456320, 1506456575, 'IT', 'ITA', 'إيطاليا'),
(25808, 1506456576, 1506456831, 'IE', 'IRL', 'إيرلندا'),
(25809, 1506456832, 1506456847, 'IT', 'ITA', 'إيطاليا'),
(25810, 1506456848, 1506456863, 'GB', 'GBR', 'المملكة المتحدة'),
(25811, 1506456864, 1506457087, 'IT', 'ITA', 'إيطاليا'),
(25812, 1506457088, 1506458239, 'GB', 'GBR', 'المملكة المتحدة'),
(25813, 1506458240, 1506458623, 'CH', 'CHE', 'سويسرا'),
(25814, 1506458624, 1506459135, 'GB', 'GBR', 'المملكة المتحدة'),
(25815, 1506459136, 1506459247, 'BE', 'BEL', 'بلجيكا'),
(25816, 1506459248, 1506459391, 'GB', 'GBR', 'المملكة المتحدة'),
(25817, 1506459392, 1506459647, 'BE', 'BEL', 'بلجيكا'),
(25818, 1506459648, 1506460047, 'FR', 'FRA', 'فرنسا'),
(25819, 1506460048, 1506460055, 'GB', 'GBR', 'المملكة المتحدة'),
(25820, 1506460056, 1506460339, 'FR', 'FRA', 'فرنسا'),
(25821, 1506460340, 1506460343, 'GB', 'GBR', 'المملكة المتحدة'),
(25822, 1506460344, 1506460671, 'FR', 'FRA', 'فرنسا'),
(25823, 1506460672, 1506460927, 'AT', 'AUT', 'النمسا'),
(25824, 1506460928, 1506461311, 'IT', 'ITA', 'إيطاليا'),
(25825, 1506461312, 1506461315, 'GB', 'GBR', 'المملكة المتحدة'),
(25826, 1506461316, 1506461319, 'IT', 'ITA', 'إيطاليا'),
(25827, 1506461320, 1506461327, 'GB', 'GBR', 'المملكة المتحدة'),
(25828, 1506461328, 1506461351, 'IT', 'ITA', 'إيطاليا'),
(25829, 1506461352, 1506461359, 'FR', 'FRA', 'فرنسا'),
(25830, 1506461360, 1506461695, 'IT', 'ITA', 'إيطاليا'),
(25831, 1506461696, 1506461863, 'FR', 'FRA', 'فرنسا'),
(25832, 1506461864, 1506461887, 'GB', 'GBR', 'المملكة المتحدة'),
(25833, 1506461888, 1506462207, 'FR', 'FRA', 'فرنسا'),
(25834, 1506462208, 1506462463, 'ES', 'ESP', 'إسبانيا'),
(25835, 1506462464, 1506462719, 'FR', 'FRA', 'فرنسا'),
(25836, 1506462720, 1506463231, 'IT', 'ITA', 'إيطاليا'),
(25837, 1506463232, 1506463487, 'SE', 'SWE', 'السويد'),
(25838, 1506463488, 1506463999, 'DE', 'DEU', 'ألمانيا'),
(25839, 1506464000, 1506464767, 'GB', 'GBR', 'المملكة المتحدة'),
(25840, 1506464768, 1506465103, 'NL', 'NLD', 'هولندا'),
(25841, 1506465104, 1506465151, 'GB', 'GBR', 'المملكة المتحدة'),
(25842, 1506465152, 1506465279, 'NL', 'NLD', 'هولندا'),
(25843, 1506465280, 1506465791, 'GB', 'GBR', 'المملكة المتحدة'),
(25844, 1506465792, 1506466047, 'DE', 'DEU', 'ألمانيا'),
(25845, 1506466048, 1506466303, 'BE', 'BEL', 'بلجيكا'),
(25846, 1506466304, 1506466559, 'DE', 'DEU', 'ألمانيا'),
(25847, 1506466560, 1506467071, 'GB', 'GBR', 'المملكة المتحدة'),
(25848, 1506467072, 1506467327, 'DE', 'DEU', 'ألمانيا'),
(25849, 1506467328, 1506467583, 'GB', 'GBR', 'المملكة المتحدة'),
(25850, 1506467584, 1506468351, 'IT', 'ITA', 'إيطاليا'),
(25851, 1506468352, 1506468607, 'GB', 'GBR', 'المملكة المتحدة'),
(25852, 1506468608, 1506468863, 'TZ', 'TZA', 'تانزانيا'),
(25853, 1506468864, 1506469487, 'IT', 'ITA', 'إيطاليا'),
(25854, 1506469488, 1506469503, 'GB', 'GBR', 'المملكة المتحدة'),
(25855, 1506469504, 1506470143, 'IT', 'ITA', 'إيطاليا'),
(25856, 1506470144, 1506470399, 'GB', 'GBR', 'المملكة المتحدة'),
(25857, 1506470400, 1506470655, 'DE', 'DEU', 'ألمانيا'),
(25858, 1506470656, 1506471679, 'IT', 'ITA', 'إيطاليا'),
(25859, 1506471680, 1506471935, 'GB', 'GBR', 'المملكة المتحدة'),
(25860, 1506471936, 1506471975, 'NL', 'NLD', 'هولندا'),
(25861, 1506471976, 1506471983, 'GB', 'GBR', 'المملكة المتحدة'),
(25862, 1506471984, 1506471999, 'NL', 'NLD', 'هولندا'),
(25863, 1506472000, 1506472031, 'BE', 'BEL', 'بلجيكا'),
(25864, 1506472032, 1506472191, 'NL', 'NLD', 'هولندا'),
(25865, 1506472192, 1506472447, 'IT', 'ITA', 'إيطاليا'),
(25866, 1506472448, 1506472703, 'GB', 'GBR', 'المملكة المتحدة'),
(25867, 1506472704, 1506473215, 'IT', 'ITA', 'إيطاليا'),
(25868, 1506473216, 1506473471, 'GB', 'GBR', 'المملكة المتحدة'),
(25869, 1506473472, 1506474271, 'IT', 'ITA', 'إيطاليا'),
(25870, 1506474272, 1506474303, 'SE', 'SWE', 'السويد'),
(25871, 1506474304, 1506474495, 'IT', 'ITA', 'إيطاليا'),
(25872, 1506474496, 1506474751, 'FR', 'FRA', 'فرنسا'),
(25873, 1506474752, 1506475519, 'IT', 'ITA', 'إيطاليا'),
(25874, 1506475520, 1506476031, 'GB', 'GBR', 'المملكة المتحدة'),
(25875, 1506476032, 1506508799, 'KW', 'KWT', 'الكويت'),
(25876, 1506508800, 1506541567, 'CZ', 'CZE', 'التشيك'),
(25877, 1506541568, 1506574335, 'RU', 'RUS', 'الإتحاد الروسي'),
(25878, 1506574336, 1506582527, 'DE', 'DEU', 'ألمانيا'),
(25879, 1506582528, 1506607103, 'IE', 'IRL', 'إيرلندا'),
(25880, 1506607104, 1506639871, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(25881, 1506639872, 1506672639, 'NL', 'NLD', 'هولندا'),
(25882, 1506672640, 1506689023, 'PL', 'POL', 'بولندا'),
(25883, 1506689024, 1506705407, 'CH', 'CHE', 'سويسرا'),
(25884, 1506705408, 1506740223, 'GB', 'GBR', 'المملكة المتحدة'),
(25885, 1506740224, 1506742271, 'FI', 'FIN', 'فنلندا'),
(25886, 1506742272, 1506743167, 'SE', 'SWE', 'السويد'),
(25887, 1506743168, 1506743183, 'DE', 'DEU', 'ألمانيا'),
(25888, 1506743184, 1506743199, 'FR', 'FRA', 'فرنسا'),
(25889, 1506743200, 1506743215, 'IE', 'IRL', 'إيرلندا'),
(25890, 1506743216, 1506743232, 'GB', 'GBR', 'المملكة المتحدة'),
(25891, 1506743233, 1506744319, 'SE', 'SWE', 'السويد'),
(25892, 1506744320, 1506746367, 'NL', 'NLD', 'هولندا'),
(25893, 1506746368, 1506750463, 'RU', 'RUS', 'الإتحاد الروسي'),
(25894, 1506750464, 1506752511, 'GB', 'GBR', 'المملكة المتحدة'),
(25895, 1506752512, 1506754559, 'IE', 'IRL', 'إيرلندا'),
(25896, 1506754560, 1506758655, 'RU', 'RUS', 'الإتحاد الروسي'),
(25897, 1506758656, 1506760703, 'IT', 'ITA', 'إيطاليا'),
(25898, 1506760704, 1506764799, 'RU', 'RUS', 'الإتحاد الروسي'),
(25899, 1506764800, 1506766847, 'IT', 'ITA', 'إيطاليا'),
(25900, 1506766848, 1506766903, 'NO', 'NOR', 'النرويج'),
(25901, 1506766904, 1506768895, 'GE', 'GEO', 'جورجيا'),
(25902, 1506768896, 1506770943, 'AT', 'AUT', 'النمسا'),
(25903, 1506770944, 1506772991, 'NL', 'NLD', 'هولندا'),
(25904, 1506772992, 1506775039, 'GB', 'GBR', 'المملكة المتحدة'),
(25905, 1506775040, 1506777087, 'AT', 'AUT', 'النمسا'),
(25906, 1506777088, 1506781695, 'GB', 'GBR', 'المملكة المتحدة'),
(25907, 1506781696, 1506781951, 'IE', 'IRL', 'إيرلندا'),
(25908, 1506781952, 1506783231, 'GB', 'GBR', 'المملكة المتحدة'),
(25909, 1506783232, 1506785279, 'RU', 'RUS', 'الإتحاد الروسي'),
(25910, 1506785280, 1506787327, 'UA', 'UKR', 'أوكرانيا'),
(25911, 1506787328, 1506789375, 'ME', 'MNE', 'الجبل الأسود'),
(25912, 1506789376, 1506791423, 'DE', 'DEU', 'ألمانيا'),
(25913, 1506791424, 1506793471, 'GB', 'GBR', 'المملكة المتحدة'),
(25914, 1506793472, 1506795519, 'RU', 'RUS', 'الإتحاد الروسي'),
(25915, 1506795520, 1506797567, 'IE', 'IRL', 'إيرلندا'),
(25916, 1506797568, 1506799615, 'ES', 'ESP', 'إسبانيا'),
(25917, 1506799616, 1506801663, 'LV', 'LVA', 'لاتفيا'),
(25918, 1506801664, 1506802767, 'DE', 'DEU', 'ألمانيا'),
(25919, 1506802768, 1506802775, 'DK', 'DNK', 'الدنيمارك'),
(25920, 1506802776, 1506803135, 'DE', 'DEU', 'ألمانيا'),
(25921, 1506803136, 1506803151, 'CH', 'CHE', 'سويسرا'),
(25922, 1506803152, 1506803711, 'DE', 'DEU', 'ألمانيا'),
(25923, 1506803712, 1506869247, 'RU', 'RUS', 'الإتحاد الروسي'),
(25924, 1506869248, 1506934783, 'UA', 'UKR', 'أوكرانيا'),
(25925, 1506934784, 1507000319, 'GR', 'GRC', 'اليونان'),
(25926, 1507000320, 1507065855, 'QA', 'QAT', 'قطر'),
(25927, 1507065856, 1507131391, 'SI', 'SVN', 'سلوفينيا'),
(25928, 1507131392, 1507196927, 'GB', 'GBR', 'المملكة المتحدة'),
(25929, 1507196928, 1507262463, 'PT', 'PRT', 'البورتوغال'),
(25930, 1507262464, 1507327999, 'BG', 'BGR', 'بلغاريا'),
(25931, 1507328000, 1507336447, 'RS', 'SRB', 'صربيا'),
(25932, 1507336448, 1507336511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(25933, 1507336512, 1507341727, 'RS', 'SRB', 'صربيا'),
(25934, 1507341728, 1507341743, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(25935, 1507341744, 1507342959, 'RS', 'SRB', 'صربيا'),
(25936, 1507342960, 1507342967, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(25937, 1507342968, 1507343071, 'RS', 'SRB', 'صربيا'),
(25938, 1507343072, 1507343103, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(25939, 1507343104, 1507360767, 'RS', 'SRB', 'صربيا'),
(25940, 1507360768, 1507377151, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(25941, 1507377152, 1507393535, 'RS', 'SRB', 'صربيا'),
(25942, 1507393536, 1507459071, 'CH', 'CHE', 'سويسرا'),
(25943, 1507459072, 1507524607, 'KZ', 'KAZ', 'كازاخستان'),
(25944, 1507524608, 1507590143, 'EE', 'EST', 'إستونيا'),
(25945, 1507590144, 1507655679, 'NL', 'NLD', 'هولندا'),
(25946, 1507655680, 1507659119, 'DE', 'DEU', 'ألمانيا'),
(25947, 1507659120, 1507659135, 'TR', 'TUR', 'تركيا'),
(25948, 1507659136, 1507659775, 'DE', 'DEU', 'ألمانيا'),
(25949, 1507659776, 1507663871, 'RU', 'RUS', 'الإتحاد الروسي'),
(25950, 1507663872, 1507664127, 'IT', 'ITA', 'إيطاليا'),
(25951, 1507664128, 1507664383, 'GR', 'GRC', 'اليونان'),
(25952, 1507664384, 1507664767, 'DE', 'DEU', 'ألمانيا'),
(25953, 1507664768, 1507664895, 'US', 'USA', 'الولايات المتحدة'),
(25954, 1507664896, 1507665407, 'GR', 'GRC', 'اليونان'),
(25955, 1507665408, 1507665663, 'IT', 'ITA', 'إيطاليا'),
(25956, 1507665664, 1507666431, 'US', 'USA', 'الولايات المتحدة'),
(25957, 1507666432, 1507666559, 'GR', 'GRC', 'اليونان'),
(25958, 1507666560, 1507666591, 'FR', 'FRA', 'فرنسا'),
(25959, 1507666592, 1507666639, 'GR', 'GRC', 'اليونان'),
(25960, 1507666640, 1507666655, 'IL', 'ISR', 'إسرائيل'),
(25961, 1507666656, 1507666687, 'IT', 'ITA', 'إيطاليا'),
(25962, 1507666688, 1507666943, 'GB', 'GBR', 'المملكة المتحدة'),
(25963, 1507666944, 1507667455, 'IT', 'ITA', 'إيطاليا'),
(25964, 1507667456, 1507667711, 'DE', 'DEU', 'ألمانيا'),
(25965, 1507667712, 1507667967, 'US', 'USA', 'الولايات المتحدة'),
(25966, 1507667968, 1507672063, 'RU', 'RUS', 'الإتحاد الروسي'),
(25967, 1507672064, 1507676159, 'EE', 'EST', 'إستونيا'),
(25968, 1507676160, 1507680255, 'IR', 'IRN', 'إيران'),
(25969, 1507680256, 1507684351, 'NO', 'NOR', 'النرويج'),
(25970, 1507684352, 1507688447, 'LV', 'LVA', 'لاتفيا'),
(25971, 1507688448, 1507696639, 'IT', 'ITA', 'إيطاليا'),
(25972, 1507696640, 1507700735, 'DK', 'DNK', 'الدنيمارك'),
(25973, 1507700736, 1507704831, 'NL', 'NLD', 'هولندا'),
(25974, 1507704832, 1507708927, 'RU', 'RUS', 'الإتحاد الروسي'),
(25975, 1507708928, 1507713023, 'CZ', 'CZE', 'التشيك'),
(25976, 1507713024, 1507717119, 'RU', 'RUS', 'الإتحاد الروسي'),
(25977, 1507717120, 1507717631, 'SE', 'SWE', 'السويد'),
(25978, 1507717632, 1507718911, 'NO', 'NOR', 'النرويج'),
(25979, 1507718912, 1507721215, 'SE', 'SWE', 'السويد'),
(25980, 1507721216, 1507753983, 'GB', 'GBR', 'المملكة المتحدة'),
(25981, 1507753984, 1507819519, 'RU', 'RUS', 'الإتحاد الروسي'),
(25982, 1507819520, 1507852287, 'HU', 'HUN', 'هنغاريا'),
(25983, 1507852288, 1508114431, 'FR', 'FRA', 'فرنسا'),
(25984, 1508114432, 1508376575, 'PL', 'POL', 'بولندا'),
(25985, 1508376576, 1508392959, 'GE', 'GEO', 'جورجيا'),
(25986, 1508392960, 1508442111, 'RU', 'RUS', 'الإتحاد الروسي'),
(25987, 1508442112, 1508458495, 'DK', 'DNK', 'الدنيمارك'),
(25988, 1508458496, 1508474879, 'RU', 'RUS', 'الإتحاد الروسي'),
(25989, 1508474880, 1508479263, 'CZ', 'CZE', 'التشيك'),
(25990, 1508479264, 1508479295, 'GB', 'GBR', 'المملكة المتحدة'),
(25991, 1508479296, 1508486463, 'CZ', 'CZE', 'التشيك'),
(25992, 1508486464, 1508486527, 'DE', 'DEU', 'ألمانيا'),
(25993, 1508486528, 1508491263, 'CZ', 'CZE', 'التشيك'),
(25994, 1508491264, 1508507647, 'SE', 'SWE', 'السويد'),
(25995, 1508507648, 1508521535, 'GB', 'GBR', 'المملكة المتحدة'),
(25996, 1508521536, 1508521551, 'IE', 'IRL', 'إيرلندا'),
(25997, 1508521552, 1508524031, 'GB', 'GBR', 'المملكة المتحدة'),
(25998, 1508524032, 1508540415, 'IE', 'IRL', 'إيرلندا'),
(25999, 1508540416, 1508556799, 'FR', 'FRA', 'فرنسا'),
(26000, 1508556800, 1508573183, 'PL', 'POL', 'بولندا'),
(26001, 1508573184, 1508573255, 'CZ', 'CZE', 'التشيك'),
(26002, 1508573256, 1508573259, 'SK', 'SVK', 'سلوفاكيا'),
(26003, 1508573260, 1508589567, 'CZ', 'CZE', 'التشيك'),
(26004, 1508589568, 1508605951, 'IR', 'IRN', 'إيران'),
(26005, 1508605952, 1508622335, 'RU', 'RUS', 'الإتحاد الروسي'),
(26006, 1508622336, 1508638719, 'EE', 'EST', 'إستونيا'),
(26007, 1508638720, 1508639231, 'SE', 'SWE', 'السويد'),
(26008, 1508639232, 1508640767, 'DK', 'DNK', 'الدنيمارك'),
(26009, 1508640768, 1508641279, 'SE', 'SWE', 'السويد'),
(26010, 1508641280, 1508641535, 'DK', 'DNK', 'الدنيمارك'),
(26011, 1508641536, 1508642175, 'SE', 'SWE', 'السويد'),
(26012, 1508642176, 1508642303, 'DK', 'DNK', 'الدنيمارك'),
(26013, 1508642304, 1508642559, 'SE', 'SWE', 'السويد'),
(26014, 1508642560, 1508642815, 'DK', 'DNK', 'الدنيمارك'),
(26015, 1508642816, 1508646911, 'SE', 'SWE', 'السويد'),
(26016, 1508646912, 1508646927, 'DK', 'DNK', 'الدنيمارك'),
(26017, 1508646928, 1508646935, 'SE', 'SWE', 'السويد'),
(26018, 1508646936, 1508646999, 'DK', 'DNK', 'الدنيمارك'),
(26019, 1508647000, 1508648447, 'SE', 'SWE', 'السويد'),
(26020, 1508648448, 1508648703, 'DK', 'DNK', 'الدنيمارك'),
(26021, 1508648704, 1508650751, 'SE', 'SWE', 'السويد'),
(26022, 1508650752, 1508650815, 'DK', 'DNK', 'الدنيمارك'),
(26023, 1508650816, 1508651007, 'SE', 'SWE', 'السويد'),
(26024, 1508651008, 1508651135, 'DK', 'DNK', 'الدنيمارك'),
(26025, 1508651136, 1508652543, 'SE', 'SWE', 'السويد'),
(26026, 1508652544, 1508654079, 'DK', 'DNK', 'الدنيمارك'),
(26027, 1508654080, 1508655103, 'SE', 'SWE', 'السويد'),
(26028, 1508655104, 1508671487, 'FI', 'FIN', 'فنلندا'),
(26029, 1508671488, 1508687871, 'CH', 'CHE', 'سويسرا'),
(26030, 1508687872, 1508704255, 'UZ', 'UZB', 'أوزباكستان'),
(26031, 1508704256, 1508720639, 'RU', 'RUS', 'الإتحاد الروسي'),
(26032, 1508720640, 1508737023, 'FR', 'FRA', 'فرنسا'),
(26033, 1508737024, 1508753407, 'SA', 'SAU', 'السعودية'),
(26034, 1508753408, 1508769791, 'KG', 'KGZ', 'قيرغيزستان'),
(26035, 1508769792, 1508786175, 'PL', 'POL', 'بولندا'),
(26036, 1508786176, 1508787199, 'DE', 'DEU', 'ألمانيا'),
(26037, 1508787200, 1508787455, 'ES', 'ESP', 'إسبانيا'),
(26038, 1508787456, 1508788031, 'DE', 'DEU', 'ألمانيا'),
(26039, 1508788032, 1508788063, 'BE', 'BEL', 'بلجيكا'),
(26040, 1508788064, 1508802559, 'DE', 'DEU', 'ألمانيا'),
(26041, 1508802560, 1508803183, 'GB', 'GBR', 'المملكة المتحدة'),
(26042, 1508803184, 1508803199, 'FR', 'FRA', 'فرنسا'),
(26043, 1508803200, 1508804783, 'GB', 'GBR', 'المملكة المتحدة'),
(26044, 1508804784, 1508804791, 'DE', 'DEU', 'ألمانيا'),
(26045, 1508804792, 1508805119, 'GB', 'GBR', 'المملكة المتحدة'),
(26046, 1508805120, 1508805375, 'NL', 'NLD', 'هولندا'),
(26047, 1508805376, 1508809263, 'GB', 'GBR', 'المملكة المتحدة'),
(26048, 1508809264, 1508809271, 'FR', 'FRA', 'فرنسا'),
(26049, 1508809272, 1508818943, 'GB', 'GBR', 'المملكة المتحدة'),
(26050, 1508818944, 1508835327, 'RO', 'ROM', 'رومانيا'),
(26051, 1508835328, 1508851711, 'CZ', 'CZE', 'التشيك'),
(26052, 1508851712, 1508868095, 'PL', 'POL', 'بولندا'),
(26053, 1508868096, 1508884479, 'RU', 'RUS', 'الإتحاد الروسي'),
(26054, 1508884480, 1508900863, 'DK', 'DNK', 'الدنيمارك'),
(26055, 1508900864, 1509163007, 'GB', 'GBR', 'المملكة المتحدة'),
(26056, 1509163008, 1509425151, 'DE', 'DEU', 'ألمانيا'),
(26057, 1509425152, 1509429247, 'NO', 'NOR', 'النرويج'),
(26058, 1509429248, 1509433343, 'GB', 'GBR', 'المملكة المتحدة'),
(26059, 1509433344, 1509437439, 'CH', 'CHE', 'سويسرا'),
(26060, 1509437440, 1509443583, 'GB', 'GBR', 'المملكة المتحدة'),
(26061, 1509443584, 1509445631, 'FR', 'FRA', 'فرنسا'),
(26062, 1509445632, 1509449727, 'LV', 'LVA', 'لاتفيا'),
(26063, 1509449728, 1509453823, 'ES', 'ESP', 'إسبانيا'),
(26064, 1509453824, 1509457919, 'RU', 'RUS', 'الإتحاد الروسي'),
(26065, 1509462016, 1509465599, 'LI', 'LIE', 'ليختنشتاين'),
(26066, 1509465600, 1509466111, 'CH', 'CHE', 'سويسرا'),
(26067, 1509466112, 1509466879, 'NL', 'NLD', 'هولندا'),
(26068, 1509466880, 1509466911, 'FR', 'FRA', 'فرنسا'),
(26069, 1509466912, 1509467055, 'NL', 'NLD', 'هولندا'),
(26070, 1509467056, 1509467103, 'SE', 'SWE', 'السويد'),
(26071, 1509467104, 1509467399, 'NL', 'NLD', 'هولندا'),
(26072, 1509467400, 1509467407, 'PL', 'POL', 'بولندا'),
(26073, 1509467408, 1509467423, 'NL', 'NLD', 'هولندا'),
(26074, 1509467424, 1509467455, 'PL', 'POL', 'بولندا'),
(26075, 1509467456, 1509467487, 'NL', 'NLD', 'هولندا'),
(26076, 1509467488, 1509467519, 'PL', 'POL', 'بولندا'),
(26077, 1509467520, 1509467583, 'BE', 'BEL', 'بلجيكا'),
(26078, 1509467584, 1509467839, 'NL', 'NLD', 'هولندا'),
(26079, 1509467840, 1509467871, 'PL', 'POL', 'بولندا'),
(26080, 1509467872, 1509469439, 'NL', 'NLD', 'هولندا'),
(26081, 1509469440, 1509469567, 'SE', 'SWE', 'السويد'),
(26082, 1509469568, 1509469887, 'NL', 'NLD', 'هولندا'),
(26083, 1509469888, 1509469919, 'MY', 'MYS', 'ماليزيا'),
(26084, 1509469920, 1509470207, 'NL', 'NLD', 'هولندا'),
(26085, 1509470208, 1509478399, 'RU', 'RUS', 'الإتحاد الروسي');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(26086, 1509478400, 1509482495, 'FR', 'FRA', 'فرنسا'),
(26087, 1509482496, 1509486591, 'RU', 'RUS', 'الإتحاد الروسي'),
(26088, 1509486592, 1509489407, 'CZ', 'CZE', 'التشيك'),
(26089, 1509489408, 1509489535, 'US', 'USA', 'الولايات المتحدة'),
(26090, 1509489536, 1509490687, 'CZ', 'CZE', 'التشيك'),
(26091, 1509490688, 1509494783, 'DK', 'DNK', 'الدنيمارك'),
(26092, 1509494784, 1509498879, 'RU', 'RUS', 'الإتحاد الروسي'),
(26093, 1509498880, 1509501151, 'CH', 'CHE', 'سويسرا'),
(26094, 1509501152, 1509501159, 'GB', 'GBR', 'المملكة المتحدة'),
(26095, 1509501160, 1509502975, 'CH', 'CHE', 'سويسرا'),
(26096, 1509502976, 1509507071, 'RU', 'RUS', 'الإتحاد الروسي'),
(26097, 1509507072, 1509511167, 'GB', 'GBR', 'المملكة المتحدة'),
(26098, 1509511168, 1509515263, 'LT', 'LTU', 'ليتوانيا'),
(26099, 1509515264, 1509519359, 'HR', 'HRV', 'كرواتيا'),
(26100, 1509519360, 1509531647, 'RU', 'RUS', 'الإتحاد الروسي'),
(26101, 1509531648, 1509535743, 'GB', 'GBR', 'المملكة المتحدة'),
(26102, 1509535744, 1509539839, 'RU', 'RUS', 'الإتحاد الروسي'),
(26103, 1509539840, 1509543935, 'AM', 'ARM', 'أرمينيا'),
(26104, 1509543936, 1509548031, 'LB', 'LBN', 'لبنان'),
(26105, 1509548032, 1509564415, 'RU', 'RUS', 'الإتحاد الروسي'),
(26106, 1509564416, 1509568511, 'GB', 'GBR', 'المملكة المتحدة'),
(26107, 1509568512, 1509572607, 'FI', 'FIN', 'فنلندا'),
(26108, 1509572608, 1509576703, 'NL', 'NLD', 'هولندا'),
(26109, 1509576704, 1509580799, 'KZ', 'KAZ', 'كازاخستان'),
(26110, 1509580800, 1509584895, 'CZ', 'CZE', 'التشيك'),
(26111, 1509584896, 1509588479, 'NO', 'NOR', 'النرويج'),
(26112, 1509588480, 1509588607, 'GB', 'GBR', 'المملكة المتحدة'),
(26113, 1509588608, 1509588751, 'NO', 'NOR', 'النرويج'),
(26114, 1509588752, 1509588767, 'GB', 'GBR', 'المملكة المتحدة'),
(26115, 1509588768, 1509588991, 'NO', 'NOR', 'النرويج'),
(26116, 1509588992, 1509593087, 'DE', 'DEU', 'ألمانيا'),
(26117, 1509593088, 1509601279, 'RU', 'RUS', 'الإتحاد الروسي'),
(26118, 1509601280, 1509605375, 'NL', 'NLD', 'هولندا'),
(26119, 1509605376, 1509609471, 'PL', 'POL', 'بولندا'),
(26120, 1509609472, 1509617663, 'RU', 'RUS', 'الإتحاد الروسي'),
(26121, 1509617664, 1509621759, 'CZ', 'CZE', 'التشيك'),
(26122, 1509621760, 1509624319, 'NL', 'NLD', 'هولندا'),
(26123, 1509624320, 1509624831, 'US', 'USA', 'الولايات المتحدة'),
(26124, 1509624832, 1509625855, 'NL', 'NLD', 'هولندا'),
(26125, 1509625856, 1509629951, 'UA', 'UKR', 'أوكرانيا'),
(26126, 1509629952, 1509634047, 'HU', 'HUN', 'هنغاريا'),
(26127, 1509634048, 1509638143, 'FR', 'FRA', 'فرنسا'),
(26128, 1509638144, 1509642239, 'RU', 'RUS', 'الإتحاد الروسي'),
(26129, 1509642240, 1509644351, 'KW', 'KWT', 'الكويت'),
(26130, 1509644352, 1509644383, 'GB', 'GBR', 'المملكة المتحدة'),
(26131, 1509644384, 1509646335, 'KW', 'KWT', 'الكويت'),
(26132, 1509646336, 1509650431, 'RU', 'RUS', 'الإتحاد الروسي'),
(26133, 1509650432, 1509654527, 'GB', 'GBR', 'المملكة المتحدة'),
(26134, 1509654528, 1509658623, 'DE', 'DEU', 'ألمانيا'),
(26135, 1509658624, 1509666815, 'RU', 'RUS', 'الإتحاد الروسي'),
(26136, 1509666816, 1509670911, 'IT', 'ITA', 'إيطاليا'),
(26137, 1509670912, 1509675007, 'GB', 'GBR', 'المملكة المتحدة'),
(26138, 1509675008, 1509677823, 'NO', 'NOR', 'النرويج'),
(26139, 1509677824, 1509678591, 'GB', 'GBR', 'المملكة المتحدة'),
(26140, 1509678592, 1509679103, 'NO', 'NOR', 'النرويج'),
(26141, 1509679104, 1509683199, 'ES', 'ESP', 'إسبانيا'),
(26142, 1509683200, 1509687295, 'CH', 'CHE', 'سويسرا'),
(26143, 1509687296, 1509703679, 'UA', 'UKR', 'أوكرانيا'),
(26144, 1509703680, 1509720063, 'RU', 'RUS', 'الإتحاد الروسي'),
(26145, 1509720064, 1509736447, 'TR', 'TUR', 'تركيا'),
(26146, 1509736448, 1509752831, 'BG', 'BGR', 'بلغاريا'),
(26147, 1509752832, 1509769215, 'RU', 'RUS', 'الإتحاد الروسي'),
(26148, 1509769216, 1509785599, 'SE', 'SWE', 'السويد'),
(26149, 1509785600, 1509801983, 'BG', 'BGR', 'بلغاريا'),
(26150, 1509801984, 1509818367, 'RU', 'RUS', 'الإتحاد الروسي'),
(26151, 1509818368, 1509851135, 'NO', 'NOR', 'النرويج'),
(26152, 1509851136, 1509867519, 'LV', 'LVA', 'لاتفيا'),
(26153, 1509867520, 1509883903, 'RU', 'RUS', 'الإتحاد الروسي'),
(26154, 1509883904, 1509900287, 'NL', 'NLD', 'هولندا'),
(26155, 1509900288, 1509916671, 'RU', 'RUS', 'الإتحاد الروسي'),
(26156, 1509916672, 1509933055, 'GB', 'GBR', 'المملكة المتحدة'),
(26157, 1509933056, 1509949439, 'US', 'USA', 'الولايات المتحدة'),
(26158, 1509949440, 1515467007, 'FR', 'FRA', 'فرنسا'),
(26159, 1515467008, 1515467263, 'ES', 'ESP', 'إسبانيا'),
(26160, 1515467264, 1515486975, 'FR', 'FRA', 'فرنسا'),
(26161, 1515486976, 1515487231, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(26162, 1515487232, 1515487359, 'HK', 'HKG', 'هونغ كونغ'),
(26163, 1515487360, 1515487999, 'FR', 'FRA', 'فرنسا'),
(26164, 1515488000, 1515488255, 'HK', 'HKG', 'هونغ كونغ'),
(26165, 1515488256, 1515519743, 'FR', 'FRA', 'فرنسا'),
(26166, 1515519744, 1515519999, 'ES', 'ESP', 'إسبانيا'),
(26167, 1515520000, 1518338047, 'FR', 'FRA', 'فرنسا'),
(26168, 1518338048, 1518370815, 'DE', 'DEU', 'ألمانيا'),
(26169, 1518370816, 1518403583, 'NL', 'NLD', 'هولندا'),
(26170, 1518403584, 1518436351, 'SE', 'SWE', 'السويد'),
(26171, 1518436352, 1518437375, 'BE', 'BEL', 'بلجيكا'),
(26172, 1518437376, 1518452735, 'SE', 'SWE', 'السويد'),
(26173, 1518452736, 1518460927, 'AT', 'AUT', 'النمسا'),
(26174, 1518460928, 1518501887, 'SE', 'SWE', 'السويد'),
(26175, 1518501888, 1518503935, 'EE', 'EST', 'إستونيا'),
(26176, 1518503936, 1518504959, 'LT', 'LTU', 'ليتوانيا'),
(26177, 1518504960, 1518505983, 'SE', 'SWE', 'السويد'),
(26178, 1518505984, 1518508031, 'LT', 'LTU', 'ليتوانيا'),
(26179, 1518508032, 1518510079, 'SE', 'SWE', 'السويد'),
(26180, 1518510080, 1518514175, 'LV', 'LVA', 'لاتفيا'),
(26181, 1518514176, 1518665727, 'SE', 'SWE', 'السويد'),
(26182, 1518665728, 1518727167, 'RU', 'RUS', 'الإتحاد الروسي'),
(26183, 1518727168, 1518731263, 'SE', 'SWE', 'السويد'),
(26184, 1518731264, 1518927871, 'DE', 'DEU', 'ألمانيا'),
(26185, 1518927872, 1518944255, 'RU', 'RUS', 'الإتحاد الروسي'),
(26186, 1518944256, 1518960639, 'SE', 'SWE', 'السويد'),
(26187, 1518960640, 1518961663, 'LT', 'LTU', 'ليتوانيا'),
(26188, 1518961664, 1518962175, 'EE', 'EST', 'إستونيا'),
(26189, 1518962176, 1518962687, 'LV', 'LVA', 'لاتفيا'),
(26190, 1518962688, 1518964735, 'NO', 'NOR', 'النرويج'),
(26191, 1518964736, 1518966783, 'HR', 'HRV', 'كرواتيا'),
(26192, 1518966784, 1518967807, 'SE', 'SWE', 'السويد'),
(26193, 1518967808, 1518969855, 'HR', 'HRV', 'كرواتيا'),
(26194, 1518969856, 1518993407, 'SE', 'SWE', 'السويد'),
(26195, 1518993408, 1519190015, 'RU', 'RUS', 'الإتحاد الروسي'),
(26196, 1519190016, 1519321087, 'SE', 'SWE', 'السويد'),
(26197, 1519321088, 1519386623, 'RU', 'RUS', 'الإتحاد الروسي'),
(26198, 1519386624, 1519452159, 'SE', 'SWE', 'السويد'),
(26199, 1519452160, 1519517695, 'NL', 'NLD', 'هولندا'),
(26200, 1519517696, 1519583231, 'AT', 'AUT', 'النمسا'),
(26201, 1519583232, 1519648767, 'IT', 'ITA', 'إيطاليا'),
(26202, 1519648768, 1519714303, 'SA', 'SAU', 'السعودية'),
(26203, 1519714304, 1519779839, 'NO', 'NOR', 'النرويج'),
(26204, 1519779840, 1519910911, 'RU', 'RUS', 'الإتحاد الروسي'),
(26205, 1519910912, 1519927295, 'GB', 'GBR', 'المملكة المتحدة'),
(26206, 1519927296, 1519927311, 'FR', 'FRA', 'فرنسا'),
(26207, 1519927312, 1519927319, 'BE', 'BEL', 'بلجيكا'),
(26208, 1519927320, 1519927327, 'FR', 'FRA', 'فرنسا'),
(26209, 1519927328, 1519927335, 'ES', 'ESP', 'إسبانيا'),
(26210, 1519927336, 1519927343, 'CH', 'CHE', 'سويسرا'),
(26211, 1519927344, 1519927351, 'AT', 'AUT', 'النمسا'),
(26212, 1519927352, 1519927375, 'NL', 'NLD', 'هولندا'),
(26213, 1519927376, 1519927383, 'CH', 'CHE', 'سويسرا'),
(26214, 1519927384, 1519927399, 'NL', 'NLD', 'هولندا'),
(26215, 1519927400, 1519927407, 'FR', 'FRA', 'فرنسا'),
(26216, 1519927408, 1519927415, 'AT', 'AUT', 'النمسا'),
(26217, 1519927416, 1519927423, 'BE', 'BEL', 'بلجيكا'),
(26218, 1519927424, 1519927431, 'LU', 'LUX', 'لوكسيمبورغ'),
(26219, 1519927432, 1519927439, 'NL', 'NLD', 'هولندا'),
(26220, 1519927440, 1519927447, 'CH', 'CHE', 'سويسرا'),
(26221, 1519927448, 1519927463, 'FR', 'FRA', 'فرنسا'),
(26222, 1519927464, 1519927471, 'IT', 'ITA', 'إيطاليا'),
(26223, 1519927472, 1519927479, 'NL', 'NLD', 'هولندا'),
(26224, 1519927480, 1519927503, 'FR', 'FRA', 'فرنسا'),
(26225, 1519927504, 1519927511, 'NL', 'NLD', 'هولندا'),
(26226, 1519927512, 1519927527, 'ES', 'ESP', 'إسبانيا'),
(26227, 1519927528, 1519927535, 'NL', 'NLD', 'هولندا'),
(26228, 1519927536, 1519927543, 'FR', 'FRA', 'فرنسا'),
(26229, 1519927544, 1519927551, 'IE', 'IRL', 'إيرلندا'),
(26230, 1519927552, 1519927559, 'SE', 'SWE', 'السويد'),
(26231, 1519927560, 1519927567, 'IT', 'ITA', 'إيطاليا'),
(26232, 1519927568, 1519927575, 'GB', 'GBR', 'المملكة المتحدة'),
(26233, 1519927576, 1519927583, 'FR', 'FRA', 'فرنسا'),
(26234, 1519927584, 1519927591, 'AT', 'AUT', 'النمسا'),
(26235, 1519927592, 1519927607, 'BE', 'BEL', 'بلجيكا'),
(26236, 1519927608, 1519927615, 'FR', 'FRA', 'فرنسا'),
(26237, 1519927616, 1519927631, 'NL', 'NLD', 'هولندا'),
(26238, 1519927632, 1519927639, 'CH', 'CHE', 'سويسرا'),
(26239, 1519927640, 1519927647, 'BE', 'BEL', 'بلجيكا'),
(26240, 1519927648, 1519927655, 'FR', 'FRA', 'فرنسا'),
(26241, 1519927656, 1519927663, 'NL', 'NLD', 'هولندا'),
(26242, 1519927664, 1519927671, 'IT', 'ITA', 'إيطاليا'),
(26243, 1519927672, 1519927679, 'FI', 'FIN', 'فنلندا'),
(26244, 1519927680, 1519927687, 'IE', 'IRL', 'إيرلندا'),
(26245, 1519927688, 1519927695, 'IT', 'ITA', 'إيطاليا'),
(26246, 1519927696, 1519927719, 'NL', 'NLD', 'هولندا'),
(26247, 1519927720, 1519927727, 'ES', 'ESP', 'إسبانيا'),
(26248, 1519927728, 1519927735, 'FR', 'FRA', 'فرنسا'),
(26249, 1519927736, 1519927743, 'NL', 'NLD', 'هولندا'),
(26250, 1519927744, 1519927751, 'ES', 'ESP', 'إسبانيا'),
(26251, 1519927752, 1519927759, 'IT', 'ITA', 'إيطاليا'),
(26252, 1519927760, 1519927767, 'ES', 'ESP', 'إسبانيا'),
(26253, 1519927768, 1519927775, 'NL', 'NLD', 'هولندا'),
(26254, 1519927776, 1519927783, 'FR', 'FRA', 'فرنسا'),
(26255, 1519927784, 1519927823, 'GB', 'GBR', 'المملكة المتحدة'),
(26256, 1519927824, 1519927831, 'BE', 'BEL', 'بلجيكا'),
(26257, 1519927832, 1519927855, 'GB', 'GBR', 'المملكة المتحدة'),
(26258, 1519927856, 1519927863, 'DK', 'DNK', 'الدنيمارك'),
(26259, 1519927864, 1519927871, 'FI', 'FIN', 'فنلندا'),
(26260, 1519927872, 1519927879, 'NL', 'NLD', 'هولندا'),
(26261, 1519927880, 1519927895, 'GB', 'GBR', 'المملكة المتحدة'),
(26262, 1519927896, 1519927903, 'NL', 'NLD', 'هولندا'),
(26263, 1519927904, 1519928119, 'GB', 'GBR', 'المملكة المتحدة'),
(26264, 1519928120, 1519928143, 'NO', 'NOR', 'النرويج'),
(26265, 1519928144, 1519928151, 'NL', 'NLD', 'هولندا'),
(26266, 1519928152, 1519928183, 'DK', 'DNK', 'الدنيمارك'),
(26267, 1519928184, 1519928191, 'GB', 'GBR', 'المملكة المتحدة'),
(26268, 1519928192, 1519928199, 'SE', 'SWE', 'السويد'),
(26269, 1519928200, 1519928247, 'GB', 'GBR', 'المملكة المتحدة'),
(26270, 1519928248, 1519928255, 'DK', 'DNK', 'الدنيمارك'),
(26271, 1519928256, 1519929279, 'GB', 'GBR', 'المملكة المتحدة'),
(26272, 1519929280, 1519929287, 'NL', 'NLD', 'هولندا'),
(26273, 1519929288, 1519929343, 'GB', 'GBR', 'المملكة المتحدة'),
(26274, 1519929344, 1519929471, 'NL', 'NLD', 'هولندا'),
(26275, 1519929472, 1519929503, 'FI', 'FIN', 'فنلندا'),
(26276, 1519929504, 1519929567, 'NL', 'NLD', 'هولندا'),
(26277, 1519929568, 1519929599, 'FI', 'FIN', 'فنلندا'),
(26278, 1519929600, 1519929759, 'NL', 'NLD', 'هولندا'),
(26279, 1519929760, 1519929791, 'CZ', 'CZE', 'التشيك'),
(26280, 1519929792, 1519929792, 'GB', 'GBR', 'المملكة المتحدة'),
(26281, 1519929793, 1519929823, 'SE', 'SWE', 'السويد'),
(26282, 1519929824, 1519929855, 'DK', 'DNK', 'الدنيمارك'),
(26283, 1519929856, 1519929951, 'SE', 'SWE', 'السويد'),
(26284, 1519929952, 1519930111, 'BE', 'BEL', 'بلجيكا'),
(26285, 1519930112, 1519930207, 'NL', 'NLD', 'هولندا'),
(26286, 1519930208, 1519930239, 'BE', 'BEL', 'بلجيكا'),
(26287, 1519930240, 1519930271, 'NL', 'NLD', 'هولندا'),
(26288, 1519930272, 1519930335, 'DK', 'DNK', 'الدنيمارك'),
(26289, 1519930336, 1519930367, 'SE', 'SWE', 'السويد'),
(26290, 1519930368, 1519930399, 'DK', 'DNK', 'الدنيمارك'),
(26291, 1519930400, 1519930527, 'NL', 'NLD', 'هولندا'),
(26292, 1519930528, 1519930559, 'NO', 'NOR', 'النرويج'),
(26293, 1519930560, 1519930591, 'SE', 'SWE', 'السويد'),
(26294, 1519930592, 1519930655, 'NO', 'NOR', 'النرويج'),
(26295, 1519930656, 1519930751, 'NL', 'NLD', 'هولندا'),
(26296, 1519930752, 1519930783, 'BE', 'BEL', 'بلجيكا'),
(26297, 1519930784, 1519930911, 'NL', 'NLD', 'هولندا'),
(26298, 1519930912, 1519930943, 'CZ', 'CZE', 'التشيك'),
(26299, 1519930944, 1519930975, 'BE', 'BEL', 'بلجيكا'),
(26300, 1519930976, 1519931007, 'NL', 'NLD', 'هولندا'),
(26301, 1519931008, 1519931039, 'BE', 'BEL', 'بلجيكا'),
(26302, 1519931040, 1519931071, 'DK', 'DNK', 'الدنيمارك'),
(26303, 1519931072, 1519931103, 'NO', 'NOR', 'النرويج'),
(26304, 1519931104, 1519931135, 'SE', 'SWE', 'السويد'),
(26305, 1519931136, 1519931231, 'NL', 'NLD', 'هولندا'),
(26306, 1519931232, 1519931263, 'NO', 'NOR', 'النرويج'),
(26307, 1519931264, 1519931359, 'GB', 'GBR', 'المملكة المتحدة'),
(26308, 1519931360, 1519931375, 'BE', 'BEL', 'بلجيكا'),
(26309, 1519931376, 1519931391, 'GB', 'GBR', 'المملكة المتحدة'),
(26310, 1519931392, 1519934463, 'NL', 'NLD', 'هولندا'),
(26311, 1519934464, 1519934975, 'GB', 'GBR', 'المملكة المتحدة'),
(26312, 1519934976, 1519935487, 'NL', 'NLD', 'هولندا'),
(26313, 1519935488, 1519935615, 'FR', 'FRA', 'فرنسا'),
(26314, 1519935616, 1519935743, 'NL', 'NLD', 'هولندا'),
(26315, 1519935744, 1519935935, 'FI', 'FIN', 'فنلندا'),
(26316, 1519935936, 1519936191, 'BE', 'BEL', 'بلجيكا'),
(26317, 1519936192, 1519936255, 'DK', 'DNK', 'الدنيمارك'),
(26318, 1519936256, 1519936383, 'NL', 'NLD', 'هولندا'),
(26319, 1519936384, 1519936447, 'BE', 'BEL', 'بلجيكا'),
(26320, 1519936448, 1519936511, 'NO', 'NOR', 'النرويج'),
(26321, 1519936512, 1519936575, 'SK', 'SVK', 'سلوفاكيا'),
(26322, 1519936576, 1519936767, 'DK', 'DNK', 'الدنيمارك'),
(26323, 1519936768, 1519936895, 'SE', 'SWE', 'السويد'),
(26324, 1519936896, 1519937023, 'BE', 'BEL', 'بلجيكا'),
(26325, 1519937024, 1519937279, 'DK', 'DNK', 'الدنيمارك'),
(26326, 1519937280, 1519937343, 'NL', 'NLD', 'هولندا'),
(26327, 1519937344, 1519937407, 'SE', 'SWE', 'السويد'),
(26328, 1519937408, 1519937471, 'NO', 'NOR', 'النرويج'),
(26329, 1519937472, 1519937535, 'GB', 'GBR', 'المملكة المتحدة'),
(26330, 1519937536, 1519937727, 'NL', 'NLD', 'هولندا'),
(26331, 1519937728, 1519938559, 'GB', 'GBR', 'المملكة المتحدة'),
(26332, 1519938560, 1519939583, 'NL', 'NLD', 'هولندا'),
(26333, 1519939584, 1519939615, 'NO', 'NOR', 'النرويج'),
(26334, 1519939616, 1519939647, 'NL', 'NLD', 'هولندا'),
(26335, 1519939648, 1519939679, 'SE', 'SWE', 'السويد'),
(26336, 1519939680, 1519939711, 'SK', 'SVK', 'سلوفاكيا'),
(26337, 1519939712, 1519939743, 'NL', 'NLD', 'هولندا'),
(26338, 1519939744, 1519939807, 'BE', 'BEL', 'بلجيكا'),
(26339, 1519939808, 1519939839, 'NL', 'NLD', 'هولندا'),
(26340, 1519939840, 1519940095, 'GB', 'GBR', 'المملكة المتحدة'),
(26341, 1519940096, 1519940159, 'NL', 'NLD', 'هولندا'),
(26342, 1519940160, 1519940191, 'FI', 'FIN', 'فنلندا'),
(26343, 1519940192, 1519940223, 'SE', 'SWE', 'السويد'),
(26344, 1519940224, 1519943679, 'GB', 'GBR', 'المملكة المتحدة'),
(26345, 1519943680, 1519976447, 'AT', 'AUT', 'النمسا'),
(26346, 1519976448, 1520009215, 'DE', 'DEU', 'ألمانيا'),
(26347, 1520009216, 1520041983, 'SY', 'SYR', 'سوريا'),
(26348, 1520041984, 1520074751, 'RU', 'RUS', 'الإتحاد الروسي'),
(26349, 1520074752, 1520107519, 'BG', 'BGR', 'بلغاريا'),
(26350, 1520107520, 1520140287, 'GB', 'GBR', 'المملكة المتحدة'),
(26351, 1520140288, 1520173055, 'RU', 'RUS', 'الإتحاد الروسي'),
(26352, 1520173056, 1520205823, 'PL', 'POL', 'بولندا'),
(26353, 1520205824, 1520230399, 'RU', 'RUS', 'الإتحاد الروسي'),
(26354, 1520230400, 1520230911, 'NL', 'NLD', 'هولندا'),
(26355, 1520230912, 1520231935, 'RU', 'RUS', 'الإتحاد الروسي'),
(26356, 1520231936, 1520232191, 'NL', 'NLD', 'هولندا'),
(26357, 1520232192, 1520232959, 'RU', 'RUS', 'الإتحاد الروسي'),
(26358, 1520232960, 1520233471, 'NL', 'NLD', 'هولندا'),
(26359, 1520233472, 1520271359, 'RU', 'RUS', 'الإتحاد الروسي'),
(26360, 1520271360, 1520304127, 'SI', 'SVN', 'سلوفينيا'),
(26361, 1520304128, 1520435199, 'TR', 'TUR', 'تركيا'),
(26362, 1520435200, 1521483775, 'ES', 'ESP', 'إسبانيا'),
(26363, 1521483776, 1522008063, 'CZ', 'CZE', 'التشيك'),
(26364, 1522008064, 1522139135, 'DK', 'DNK', 'الدنيمارك'),
(26365, 1522139136, 1522270207, 'DE', 'DEU', 'ألمانيا'),
(26366, 1522270208, 1522401279, 'RU', 'RUS', 'الإتحاد الروسي'),
(26367, 1522401280, 1522532351, 'EE', 'EST', 'إستونيا'),
(26368, 1522532352, 1524629503, 'GB', 'GBR', 'المملكة المتحدة'),
(26369, 1524629504, 1525678079, 'SE', 'SWE', 'السويد'),
(26370, 1525678080, 1526726655, 'GB', 'GBR', 'المملكة المتحدة'),
(26371, 1526726656, 1531183103, 'DE', 'DEU', 'ألمانيا'),
(26372, 1531183104, 1531445247, 'FR', 'FRA', 'فرنسا'),
(26373, 1531445248, 1531707391, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(26374, 1531707392, 1531969535, 'RU', 'RUS', 'الإتحاد الروسي'),
(26375, 1531969536, 1532100607, 'IT', 'ITA', 'إيطاليا'),
(26376, 1532100608, 1532199935, 'HU', 'HUN', 'هنغاريا'),
(26377, 1532199936, 1532200959, 'RS', 'SRB', 'صربيا'),
(26378, 1532200960, 1532231679, 'HU', 'HUN', 'هنغاريا'),
(26379, 1532231680, 1532362751, 'GB', 'GBR', 'المملكة المتحدة'),
(26380, 1532362752, 1532493823, 'BE', 'BEL', 'بلجيكا'),
(26381, 1532493824, 1532559359, 'FR', 'FRA', 'فرنسا'),
(26382, 1532559360, 1532624895, 'DE', 'DEU', 'ألمانيا'),
(26383, 1532624896, 1532626943, 'ES', 'ESP', 'إسبانيا'),
(26384, 1532626944, 1532631039, 'UA', 'UKR', 'أوكرانيا'),
(26385, 1532631040, 1532633087, 'SE', 'SWE', 'السويد'),
(26386, 1532633088, 1532635135, 'RU', 'RUS', 'الإتحاد الروسي'),
(26387, 1532635136, 1532637183, 'NO', 'NOR', 'النرويج'),
(26388, 1532637184, 1532639231, 'FI', 'FIN', 'فنلندا'),
(26389, 1532639232, 1532641279, 'PL', 'POL', 'بولندا'),
(26390, 1532641280, 1532643327, 'NO', 'NOR', 'النرويج'),
(26391, 1532643328, 1532645375, 'PL', 'POL', 'بولندا'),
(26392, 1532645376, 1532647423, 'RU', 'RUS', 'الإتحاد الروسي'),
(26393, 1532647424, 1532649471, 'PL', 'POL', 'بولندا'),
(26394, 1532649472, 1532651519, 'FR', 'FRA', 'فرنسا'),
(26395, 1532651520, 1532653567, 'NO', 'NOR', 'النرويج'),
(26396, 1532653568, 1532655615, 'PL', 'POL', 'بولندا'),
(26397, 1532655616, 1532657663, 'RO', 'ROM', 'رومانيا'),
(26398, 1532657664, 1532661759, 'IL', 'ISR', 'إسرائيل'),
(26399, 1532661760, 1532665855, 'DE', 'DEU', 'ألمانيا'),
(26400, 1532665856, 1532674047, 'PL', 'POL', 'بولندا'),
(26401, 1532674048, 1532682239, 'UA', 'UKR', 'أوكرانيا'),
(26402, 1532682240, 1532690431, 'LV', 'LVA', 'لاتفيا'),
(26403, 1532690432, 1532755967, 'FR', 'FRA', 'فرنسا'),
(26404, 1532755968, 1532821503, 'BG', 'BGR', 'بلغاريا'),
(26405, 1532821504, 1532887039, 'TR', 'TUR', 'تركيا'),
(26406, 1532887040, 1532952575, 'PL', 'POL', 'بولندا'),
(26407, 1532952576, 1533018111, 'SE', 'SWE', 'السويد'),
(26408, 1533018112, 1533149183, 'DE', 'DEU', 'ألمانيا'),
(26409, 1533149184, 1533280255, 'IR', 'IRN', 'إيران'),
(26410, 1533280256, 1533411327, 'DK', 'DNK', 'الدنيمارك'),
(26411, 1533411328, 1533413375, 'GB', 'GBR', 'المملكة المتحدة'),
(26412, 1533413376, 1533415423, 'DE', 'DEU', 'ألمانيا'),
(26413, 1533415424, 1533417471, 'SA', 'SAU', 'السعودية'),
(26414, 1533417472, 1533419519, 'NO', 'NOR', 'النرويج'),
(26415, 1533419520, 1533419775, 'KW', 'KWT', 'الكويت'),
(26416, 1533419776, 1533420031, 'SA', 'SAU', 'السعودية'),
(26417, 1533420032, 1533420287, 'KW', 'KWT', 'الكويت'),
(26418, 1533420288, 1533420543, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(26419, 1533420544, 1533421567, 'KW', 'KWT', 'الكويت'),
(26420, 1533421568, 1533423615, 'NL', 'NLD', 'هولندا'),
(26421, 1533423616, 1533425663, 'IT', 'ITA', 'إيطاليا'),
(26422, 1533425664, 1533428479, 'GB', 'GBR', 'المملكة المتحدة'),
(26423, 1533428480, 1533428735, 'US', 'USA', 'الولايات المتحدة'),
(26424, 1533428736, 1533429759, 'GB', 'GBR', 'المملكة المتحدة'),
(26425, 1533429760, 1533431807, 'IT', 'ITA', 'إيطاليا'),
(26426, 1533431808, 1533433855, 'IE', 'IRL', 'إيرلندا'),
(26427, 1533433856, 1533435903, 'DK', 'DNK', 'الدنيمارك'),
(26428, 1533435904, 1533437951, 'CZ', 'CZE', 'التشيك'),
(26429, 1533437952, 1533439999, 'RU', 'RUS', 'الإتحاد الروسي'),
(26430, 1533440000, 1533441519, 'PL', 'POL', 'بولندا'),
(26431, 1533441520, 1533441535, 'CH', 'CHE', 'سويسرا'),
(26432, 1533441536, 1533442047, 'PL', 'POL', 'بولندا'),
(26433, 1533442048, 1533444095, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(26434, 1533444096, 1533446143, 'IT', 'ITA', 'إيطاليا'),
(26435, 1533446144, 1533448191, 'DE', 'DEU', 'ألمانيا'),
(26436, 1533448192, 1533450239, 'KW', 'KWT', 'الكويت'),
(26437, 1533450240, 1533452287, 'RU', 'RUS', 'الإتحاد الروسي'),
(26438, 1533452288, 1533454335, 'TR', 'TUR', 'تركيا'),
(26439, 1533454336, 1533456383, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(26440, 1533456384, 1533458431, 'UA', 'UKR', 'أوكرانيا'),
(26441, 1533458432, 1533460479, 'GB', 'GBR', 'المملكة المتحدة'),
(26442, 1533460480, 1533462527, 'NL', 'NLD', 'هولندا'),
(26443, 1533462528, 1533464575, 'RU', 'RUS', 'الإتحاد الروسي'),
(26444, 1533464576, 1533466623, 'NL', 'NLD', 'هولندا'),
(26445, 1533466624, 1533468671, 'RU', 'RUS', 'الإتحاد الروسي'),
(26446, 1533468672, 1533470719, 'RS', 'SRB', 'صربيا'),
(26447, 1533470720, 1533472767, 'KW', 'KWT', 'الكويت'),
(26448, 1533472768, 1533474815, 'ES', 'ESP', 'إسبانيا'),
(26449, 1533474816, 1533476863, 'FR', 'FRA', 'فرنسا'),
(26450, 1533476864, 1533478911, 'IE', 'IRL', 'إيرلندا'),
(26451, 1533478912, 1533478943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(26452, 1533478944, 1533480959, 'RS', 'SRB', 'صربيا'),
(26453, 1533480960, 1533483007, 'NL', 'NLD', 'هولندا'),
(26454, 1533483008, 1533485055, 'AM', 'ARM', 'أرمينيا'),
(26455, 1533485056, 1533485567, 'GB', 'GBR', 'المملكة المتحدة'),
(26456, 1533485568, 1533485823, 'DE', 'DEU', 'ألمانيا'),
(26457, 1533485824, 1533486335, 'SE', 'SWE', 'السويد'),
(26458, 1533486336, 1533486591, 'NO', 'NOR', 'النرويج'),
(26459, 1533486592, 1533486847, 'DK', 'DNK', 'الدنيمارك'),
(26460, 1533486848, 1533487103, 'FI', 'FIN', 'فنلندا'),
(26461, 1533487104, 1533487359, 'FR', 'FRA', 'فرنسا'),
(26462, 1533487360, 1533487615, 'US', 'USA', 'الولايات المتحدة'),
(26463, 1533487616, 1533487871, 'JP', 'JPN', 'اليابان'),
(26464, 1533487872, 1533489151, 'FR', 'FRA', 'فرنسا'),
(26465, 1533489152, 1533491199, 'ES', 'ESP', 'إسبانيا'),
(26466, 1533491200, 1533493247, 'AM', 'ARM', 'أرمينيا'),
(26467, 1533493248, 1533499391, 'RU', 'RUS', 'الإتحاد الروسي'),
(26468, 1533499392, 1533501439, 'MT', 'MLT', 'مالطا'),
(26469, 1533501440, 1533503487, 'LT', 'LTU', 'ليتوانيا'),
(26470, 1533503488, 1533505535, 'RU', 'RUS', 'الإتحاد الروسي'),
(26471, 1533505536, 1533507583, 'DE', 'DEU', 'ألمانيا'),
(26472, 1533507584, 1533509631, 'UA', 'UKR', 'أوكرانيا'),
(26473, 1533509632, 1533511679, 'GB', 'GBR', 'المملكة المتحدة'),
(26474, 1533511680, 1533512383, 'FR', 'FRA', 'فرنسا'),
(26475, 1533512384, 1533512447, 'DE', 'DEU', 'ألمانيا'),
(26476, 1533512448, 1533513215, 'FR', 'FRA', 'فرنسا'),
(26477, 1533513216, 1533513471, 'GB', 'GBR', 'المملكة المتحدة'),
(26478, 1533513472, 1533513727, 'DE', 'DEU', 'ألمانيا'),
(26479, 1533513728, 1533515775, 'KW', 'KWT', 'الكويت'),
(26480, 1533515776, 1533517823, 'RU', 'RUS', 'الإتحاد الروسي'),
(26481, 1533517824, 1533519871, 'CZ', 'CZE', 'التشيك'),
(26482, 1533519872, 1533526015, 'GB', 'GBR', 'المملكة المتحدة'),
(26483, 1533526016, 1533532159, 'RU', 'RUS', 'الإتحاد الروسي'),
(26484, 1533532160, 1533534207, 'GB', 'GBR', 'المملكة المتحدة'),
(26485, 1533534208, 1533536255, 'RU', 'RUS', 'الإتحاد الروسي'),
(26486, 1533536256, 1533538303, 'FR', 'FRA', 'فرنسا'),
(26487, 1533538304, 1533540351, 'DE', 'DEU', 'ألمانيا'),
(26488, 1533540352, 1533542399, 'AT', 'AUT', 'النمسا'),
(26489, 1533542400, 1534066687, 'GB', 'GBR', 'المملكة المتحدة'),
(26490, 1534066688, 1534129151, 'AT', 'AUT', 'النمسا'),
(26491, 1534129152, 1534129407, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(26492, 1534129408, 1534328831, 'AT', 'AUT', 'النمسا'),
(26493, 1534328832, 1534459903, 'ES', 'ESP', 'إسبانيا'),
(26494, 1534459904, 1534590975, 'AT', 'AUT', 'النمسا'),
(26495, 1534590976, 1534656511, 'HU', 'HUN', 'هنغاريا'),
(26496, 1534656512, 1534711807, 'FR', 'FRA', 'فرنسا'),
(26497, 1534711808, 1534712831, 'BE', 'BEL', 'بلجيكا'),
(26498, 1534712832, 1534713855, 'FR', 'FRA', 'فرنسا'),
(26499, 1534713856, 1534713887, 'PL', 'POL', 'بولندا'),
(26500, 1534713888, 1534713935, 'FR', 'FRA', 'فرنسا'),
(26501, 1534713936, 1534713951, 'GB', 'GBR', 'المملكة المتحدة'),
(26502, 1534713952, 1534713983, 'FR', 'FRA', 'فرنسا'),
(26503, 1534713984, 1534713999, 'PL', 'POL', 'بولندا'),
(26504, 1534714000, 1534714015, 'FR', 'FRA', 'فرنسا'),
(26505, 1534714016, 1534714031, 'DE', 'DEU', 'ألمانيا'),
(26506, 1534714032, 1534714047, 'BE', 'BEL', 'بلجيكا'),
(26507, 1534714048, 1534714055, 'FR', 'FRA', 'فرنسا'),
(26508, 1534714056, 1534714059, 'DE', 'DEU', 'ألمانيا'),
(26509, 1534714060, 1534714063, 'FR', 'FRA', 'فرنسا'),
(26510, 1534714064, 1534714079, 'ES', 'ESP', 'إسبانيا'),
(26511, 1534714080, 1534714095, 'FR', 'FRA', 'فرنسا'),
(26512, 1534714096, 1534714111, 'BE', 'BEL', 'بلجيكا'),
(26513, 1534714112, 1534714119, 'GB', 'GBR', 'المملكة المتحدة'),
(26514, 1534714120, 1534714123, 'BE', 'BEL', 'بلجيكا'),
(26515, 1534714124, 1534714127, 'NL', 'NLD', 'هولندا'),
(26516, 1534714128, 1534714143, 'BE', 'BEL', 'بلجيكا'),
(26517, 1534714144, 1534714159, 'GB', 'GBR', 'المملكة المتحدة'),
(26518, 1534714160, 1534714259, 'FR', 'FRA', 'فرنسا'),
(26519, 1534714260, 1534714271, 'PL', 'POL', 'بولندا'),
(26520, 1534714272, 1534714287, 'IT', 'ITA', 'إيطاليا'),
(26521, 1534714288, 1534714303, 'ES', 'ESP', 'إسبانيا'),
(26522, 1534714304, 1534714307, 'GB', 'GBR', 'المملكة المتحدة'),
(26523, 1534714308, 1534714311, 'ES', 'ESP', 'إسبانيا'),
(26524, 1534714312, 1534714315, 'FR', 'FRA', 'فرنسا'),
(26525, 1534714316, 1534714319, 'GB', 'GBR', 'المملكة المتحدة'),
(26526, 1534714320, 1534714351, 'FR', 'FRA', 'فرنسا'),
(26527, 1534714352, 1534714367, 'CH', 'CHE', 'سويسرا'),
(26528, 1534714368, 1534714383, 'GB', 'GBR', 'المملكة المتحدة'),
(26529, 1534714384, 1534714399, 'FR', 'FRA', 'فرنسا'),
(26530, 1534714400, 1534714415, 'ES', 'ESP', 'إسبانيا'),
(26531, 1534714416, 1534714431, 'GB', 'GBR', 'المملكة المتحدة'),
(26532, 1534714432, 1534714463, 'FR', 'FRA', 'فرنسا'),
(26533, 1534714464, 1534714495, 'GB', 'GBR', 'المملكة المتحدة'),
(26534, 1534714496, 1534714511, 'FR', 'FRA', 'فرنسا'),
(26535, 1534714512, 1534714527, 'PL', 'POL', 'بولندا'),
(26536, 1534714528, 1534714543, 'GB', 'GBR', 'المملكة المتحدة'),
(26537, 1534714544, 1534714547, 'FR', 'FRA', 'فرنسا'),
(26538, 1534714548, 1534714551, 'ES', 'ESP', 'إسبانيا'),
(26539, 1534714552, 1534714559, 'GB', 'GBR', 'المملكة المتحدة'),
(26540, 1534714560, 1534714575, 'NL', 'NLD', 'هولندا'),
(26541, 1534714576, 1534714703, 'FR', 'FRA', 'فرنسا'),
(26542, 1534714704, 1534714719, 'CH', 'CHE', 'سويسرا'),
(26543, 1534714720, 1534714751, 'BE', 'BEL', 'بلجيكا'),
(26544, 1534714752, 1534714767, 'DE', 'DEU', 'ألمانيا'),
(26545, 1534714768, 1534714783, 'FR', 'FRA', 'فرنسا'),
(26546, 1534714784, 1534714799, 'PL', 'POL', 'بولندا'),
(26547, 1534714800, 1534714831, 'FR', 'FRA', 'فرنسا'),
(26548, 1534714832, 1534714847, 'BE', 'BEL', 'بلجيكا'),
(26549, 1534714848, 1534714863, 'CH', 'CHE', 'سويسرا'),
(26550, 1534714864, 1534714871, 'FR', 'FRA', 'فرنسا'),
(26551, 1534714872, 1534714875, 'DE', 'DEU', 'ألمانيا'),
(26552, 1534714876, 1534714879, 'FR', 'FRA', 'فرنسا'),
(26553, 1534714880, 1534714895, 'IT', 'ITA', 'إيطاليا'),
(26554, 1534714896, 1534714911, 'FR', 'FRA', 'فرنسا'),
(26555, 1534714912, 1534714927, 'DE', 'DEU', 'ألمانيا'),
(26556, 1534714928, 1534715039, 'FR', 'FRA', 'فرنسا'),
(26557, 1534715040, 1534715055, 'GB', 'GBR', 'المملكة المتحدة'),
(26558, 1534715056, 1534715071, 'PL', 'POL', 'بولندا'),
(26559, 1534715072, 1534715135, 'FR', 'FRA', 'فرنسا'),
(26560, 1534715136, 1534715139, 'PL', 'POL', 'بولندا'),
(26561, 1534715140, 1534715143, 'GB', 'GBR', 'المملكة المتحدة'),
(26562, 1534715144, 1534715151, 'NL', 'NLD', 'هولندا'),
(26563, 1534715152, 1534715167, 'FR', 'FRA', 'فرنسا'),
(26564, 1534715168, 1534715183, 'NL', 'NLD', 'هولندا'),
(26565, 1534715184, 1534715199, 'FR', 'FRA', 'فرنسا'),
(26566, 1534715200, 1534715203, 'DE', 'DEU', 'ألمانيا'),
(26567, 1534715204, 1534715207, 'FR', 'FRA', 'فرنسا'),
(26568, 1534715208, 1534715215, 'BE', 'BEL', 'بلجيكا'),
(26569, 1534715216, 1534715263, 'FR', 'FRA', 'فرنسا'),
(26570, 1534715264, 1534715279, 'ES', 'ESP', 'إسبانيا'),
(26571, 1534715280, 1534715295, 'FR', 'FRA', 'فرنسا'),
(26572, 1534715296, 1534715311, 'ES', 'ESP', 'إسبانيا'),
(26573, 1534715312, 1534715315, 'FR', 'FRA', 'فرنسا'),
(26574, 1534715316, 1534715319, 'ES', 'ESP', 'إسبانيا'),
(26575, 1534715320, 1534715327, 'PL', 'POL', 'بولندا'),
(26576, 1534715328, 1534715375, 'FR', 'FRA', 'فرنسا'),
(26577, 1534715376, 1534715391, 'ES', 'ESP', 'إسبانيا'),
(26578, 1534715392, 1534715407, 'PL', 'POL', 'بولندا'),
(26579, 1534715408, 1534715423, 'ES', 'ESP', 'إسبانيا'),
(26580, 1534715424, 1534715439, 'PL', 'POL', 'بولندا'),
(26581, 1534715440, 1534715447, 'DE', 'DEU', 'ألمانيا'),
(26582, 1534715448, 1534715451, 'FR', 'FRA', 'فرنسا'),
(26583, 1534715452, 1534715487, 'PL', 'POL', 'بولندا'),
(26584, 1534715488, 1534715503, 'ES', 'ESP', 'إسبانيا'),
(26585, 1534715504, 1534715519, 'CH', 'CHE', 'سويسرا'),
(26586, 1534715520, 1534715551, 'FR', 'FRA', 'فرنسا'),
(26587, 1534715552, 1534715583, 'ES', 'ESP', 'إسبانيا'),
(26588, 1534715584, 1534715599, 'GB', 'GBR', 'المملكة المتحدة'),
(26589, 1534715600, 1534715615, 'BE', 'BEL', 'بلجيكا'),
(26590, 1534715616, 1534715631, 'FR', 'FRA', 'فرنسا'),
(26591, 1534715632, 1534715647, 'ES', 'ESP', 'إسبانيا'),
(26592, 1534715648, 1534715663, 'PL', 'POL', 'بولندا'),
(26593, 1534715664, 1534715679, 'ES', 'ESP', 'إسبانيا'),
(26594, 1534715680, 1534715695, 'GB', 'GBR', 'المملكة المتحدة'),
(26595, 1534715696, 1534715711, 'FR', 'FRA', 'فرنسا'),
(26596, 1534715712, 1534715727, 'PT', 'PRT', 'البورتوغال'),
(26597, 1534715728, 1534715731, 'FR', 'FRA', 'فرنسا'),
(26598, 1534715732, 1534715735, 'GB', 'GBR', 'المملكة المتحدة'),
(26599, 1534715736, 1534715759, 'PL', 'POL', 'بولندا'),
(26600, 1534715760, 1534715807, 'ES', 'ESP', 'إسبانيا'),
(26601, 1534715808, 1534715871, 'FR', 'FRA', 'فرنسا'),
(26602, 1534715872, 1534715887, 'DE', 'DEU', 'ألمانيا'),
(26603, 1534715888, 1534715919, 'FR', 'FRA', 'فرنسا'),
(26604, 1534715920, 1534715935, 'ES', 'ESP', 'إسبانيا'),
(26605, 1534715936, 1534715999, 'FR', 'FRA', 'فرنسا'),
(26606, 1534716000, 1534716007, 'PL', 'POL', 'بولندا'),
(26607, 1534716008, 1534716015, 'ES', 'ESP', 'إسبانيا'),
(26608, 1534716016, 1534716047, 'FR', 'FRA', 'فرنسا'),
(26609, 1534716048, 1534716063, 'GB', 'GBR', 'المملكة المتحدة'),
(26610, 1534716064, 1534716143, 'FR', 'FRA', 'فرنسا'),
(26611, 1534716144, 1534716159, 'PL', 'POL', 'بولندا'),
(26612, 1534716160, 1534716163, 'IT', 'ITA', 'إيطاليا'),
(26613, 1534716164, 1534716167, 'FR', 'FRA', 'فرنسا'),
(26614, 1534716168, 1534716175, 'IE', 'IRL', 'إيرلندا'),
(26615, 1534716176, 1534716191, 'FR', 'FRA', 'فرنسا'),
(26616, 1534716192, 1534716223, 'DE', 'DEU', 'ألمانيا'),
(26617, 1534716224, 1534716239, 'FR', 'FRA', 'فرنسا'),
(26618, 1534716240, 1534716255, 'GB', 'GBR', 'المملكة المتحدة'),
(26619, 1534716256, 1534716319, 'FR', 'FRA', 'فرنسا'),
(26620, 1534716320, 1534716359, 'PL', 'POL', 'بولندا'),
(26621, 1534716360, 1534716363, 'CZ', 'CZE', 'التشيك'),
(26622, 1534716364, 1534716367, 'GB', 'GBR', 'المملكة المتحدة'),
(26623, 1534716368, 1534716431, 'FR', 'FRA', 'فرنسا'),
(26624, 1534716432, 1534716447, 'PL', 'POL', 'بولندا'),
(26625, 1534716448, 1534716463, 'FR', 'FRA', 'فرنسا'),
(26626, 1534716464, 1534716479, 'GB', 'GBR', 'المملكة المتحدة'),
(26627, 1534716480, 1534716495, 'ES', 'ESP', 'إسبانيا'),
(26628, 1534716496, 1534716511, 'FR', 'FRA', 'فرنسا'),
(26629, 1534716512, 1534716527, 'DE', 'DEU', 'ألمانيا'),
(26630, 1534716528, 1534716591, 'FR', 'FRA', 'فرنسا'),
(26631, 1534716592, 1534716607, 'PL', 'POL', 'بولندا'),
(26632, 1534716608, 1534716639, 'FR', 'FRA', 'فرنسا'),
(26633, 1534716640, 1534716647, 'BE', 'BEL', 'بلجيكا'),
(26634, 1534716648, 1534716655, 'FR', 'FRA', 'فرنسا'),
(26635, 1534716656, 1534716663, 'IE', 'IRL', 'إيرلندا'),
(26636, 1534716664, 1534716671, 'FR', 'FRA', 'فرنسا'),
(26637, 1534716672, 1534716687, 'PL', 'POL', 'بولندا'),
(26638, 1534716688, 1534716703, 'FR', 'FRA', 'فرنسا'),
(26639, 1534716704, 1534716735, 'ES', 'ESP', 'إسبانيا'),
(26640, 1534716736, 1534716751, 'FR', 'FRA', 'فرنسا'),
(26641, 1534716752, 1534716759, 'PL', 'POL', 'بولندا'),
(26642, 1534716760, 1534716763, 'FR', 'FRA', 'فرنسا'),
(26643, 1534716764, 1534716767, 'ES', 'ESP', 'إسبانيا'),
(26644, 1534716768, 1534716879, 'FR', 'FRA', 'فرنسا'),
(26645, 1534716880, 1534716895, 'BE', 'BEL', 'بلجيكا'),
(26646, 1534716896, 1534716927, 'FR', 'FRA', 'فرنسا'),
(26647, 1534716928, 1534716943, 'DE', 'DEU', 'ألمانيا'),
(26648, 1534716944, 1534716991, 'FR', 'FRA', 'فرنسا'),
(26649, 1534716992, 1534717007, 'DE', 'DEU', 'ألمانيا'),
(26650, 1534717008, 1534717023, 'FR', 'FRA', 'فرنسا'),
(26651, 1534717024, 1534717055, 'PL', 'POL', 'بولندا'),
(26652, 1534717056, 1534717103, 'FR', 'FRA', 'فرنسا'),
(26653, 1534717104, 1534717119, 'PL', 'POL', 'بولندا'),
(26654, 1534717120, 1534717135, 'IT', 'ITA', 'إيطاليا'),
(26655, 1534717136, 1534717139, 'CH', 'CHE', 'سويسرا'),
(26656, 1534717140, 1534717143, 'BE', 'BEL', 'بلجيكا'),
(26657, 1534717144, 1534717147, 'FR', 'FRA', 'فرنسا'),
(26658, 1534717148, 1534717151, 'IT', 'ITA', 'إيطاليا'),
(26659, 1534717152, 1534717215, 'FR', 'FRA', 'فرنسا'),
(26660, 1534717216, 1534717231, 'NL', 'NLD', 'هولندا'),
(26661, 1534717232, 1534717263, 'FR', 'FRA', 'فرنسا'),
(26662, 1534717264, 1534717279, 'ES', 'ESP', 'إسبانيا'),
(26663, 1534717280, 1534717315, 'FR', 'FRA', 'فرنسا'),
(26664, 1534717316, 1534717319, 'IE', 'IRL', 'إيرلندا'),
(26665, 1534717320, 1534717323, 'GB', 'GBR', 'المملكة المتحدة'),
(26666, 1534717324, 1534717343, 'FR', 'FRA', 'فرنسا'),
(26667, 1534717344, 1534717359, 'GB', 'GBR', 'المملكة المتحدة'),
(26668, 1534717360, 1534717375, 'PL', 'POL', 'بولندا'),
(26669, 1534717376, 1534717503, 'FR', 'FRA', 'فرنسا'),
(26670, 1534717504, 1534717519, 'DE', 'DEU', 'ألمانيا'),
(26671, 1534717520, 1534717535, 'FR', 'FRA', 'فرنسا'),
(26672, 1534717536, 1534717551, 'DE', 'DEU', 'ألمانيا'),
(26673, 1534717552, 1534717567, 'CZ', 'CZE', 'التشيك'),
(26674, 1534717568, 1534717583, 'PL', 'POL', 'بولندا'),
(26675, 1534717584, 1534717647, 'FR', 'FRA', 'فرنسا'),
(26676, 1534717648, 1534717655, 'BE', 'BEL', 'بلجيكا'),
(26677, 1534717656, 1534717659, 'ES', 'ESP', 'إسبانيا'),
(26678, 1534717660, 1534717663, 'FR', 'FRA', 'فرنسا'),
(26679, 1534717664, 1534717679, 'GB', 'GBR', 'المملكة المتحدة'),
(26680, 1534717680, 1534717695, 'ES', 'ESP', 'إسبانيا'),
(26681, 1534717696, 1534717759, 'PL', 'POL', 'بولندا'),
(26682, 1534717760, 1534717823, 'ES', 'ESP', 'إسبانيا'),
(26683, 1534717824, 1534717855, 'BE', 'BEL', 'بلجيكا'),
(26684, 1534717856, 1534717871, 'NL', 'NLD', 'هولندا'),
(26685, 1534717872, 1534717903, 'FR', 'FRA', 'فرنسا'),
(26686, 1534717904, 1534717919, 'GB', 'GBR', 'المملكة المتحدة'),
(26687, 1534717920, 1534717935, 'ES', 'ESP', 'إسبانيا'),
(26688, 1534717936, 1534717951, 'IT', 'ITA', 'إيطاليا'),
(26689, 1534717952, 1534717967, 'BE', 'BEL', 'بلجيكا'),
(26690, 1534717968, 1534717983, 'IT', 'ITA', 'إيطاليا'),
(26691, 1534717984, 1534718015, 'FR', 'FRA', 'فرنسا'),
(26692, 1534718016, 1534718031, 'BE', 'BEL', 'بلجيكا'),
(26693, 1534718032, 1534718063, 'FR', 'FRA', 'فرنسا'),
(26694, 1534718064, 1534718079, 'IT', 'ITA', 'إيطاليا'),
(26695, 1534718080, 1534718087, 'ES', 'ESP', 'إسبانيا'),
(26696, 1534718088, 1534718095, 'CZ', 'CZE', 'التشيك'),
(26697, 1534718096, 1534718111, 'ES', 'ESP', 'إسبانيا'),
(26698, 1534718112, 1534718127, 'IT', 'ITA', 'إيطاليا'),
(26699, 1534718128, 1534718143, 'ES', 'ESP', 'إسبانيا'),
(26700, 1534718144, 1534718207, 'FR', 'FRA', 'فرنسا'),
(26701, 1534718208, 1534718271, 'ES', 'ESP', 'إسبانيا'),
(26702, 1534718272, 1534718399, 'FR', 'FRA', 'فرنسا'),
(26703, 1534718400, 1534718415, 'DE', 'DEU', 'ألمانيا'),
(26704, 1534718416, 1534718431, 'FR', 'FRA', 'فرنسا'),
(26705, 1534718432, 1534718447, 'PL', 'POL', 'بولندا'),
(26706, 1534718448, 1534718531, 'FR', 'FRA', 'فرنسا'),
(26707, 1534718532, 1534718535, 'PL', 'POL', 'بولندا'),
(26708, 1534718536, 1534718539, 'DE', 'DEU', 'ألمانيا'),
(26709, 1534718540, 1534718543, 'ES', 'ESP', 'إسبانيا'),
(26710, 1534718544, 1534718559, 'FR', 'FRA', 'فرنسا'),
(26711, 1534718560, 1534718575, 'BE', 'BEL', 'بلجيكا'),
(26712, 1534718576, 1534718687, 'FR', 'FRA', 'فرنسا'),
(26713, 1534718688, 1534718703, 'PL', 'POL', 'بولندا'),
(26714, 1534718704, 1534718711, 'FR', 'FRA', 'فرنسا'),
(26715, 1534718712, 1534718735, 'GB', 'GBR', 'المملكة المتحدة'),
(26716, 1534718736, 1534718751, 'FR', 'FRA', 'فرنسا'),
(26717, 1534718752, 1534718767, 'PL', 'POL', 'بولندا'),
(26718, 1534718768, 1534718799, 'FR', 'FRA', 'فرنسا'),
(26719, 1534718800, 1534718815, 'ES', 'ESP', 'إسبانيا'),
(26720, 1534718816, 1534718831, 'GB', 'GBR', 'المملكة المتحدة'),
(26721, 1534718832, 1534718847, 'FR', 'FRA', 'فرنسا'),
(26722, 1534718848, 1534718911, 'BE', 'BEL', 'بلجيكا'),
(26723, 1534718912, 1534718927, 'IT', 'ITA', 'إيطاليا'),
(26724, 1534718928, 1534718943, 'FR', 'FRA', 'فرنسا'),
(26725, 1534718944, 1534718959, 'PL', 'POL', 'بولندا'),
(26726, 1534718960, 1534718975, 'ES', 'ESP', 'إسبانيا'),
(26727, 1534718976, 1534719039, 'FR', 'FRA', 'فرنسا'),
(26728, 1534719040, 1534719167, 'BE', 'BEL', 'بلجيكا'),
(26729, 1534719168, 1534719215, 'PL', 'POL', 'بولندا'),
(26730, 1534719216, 1534719359, 'FR', 'FRA', 'فرنسا'),
(26731, 1534719360, 1534719375, 'PL', 'POL', 'بولندا'),
(26732, 1534719376, 1534719391, 'DE', 'DEU', 'ألمانيا'),
(26733, 1534719392, 1534719395, 'CH', 'CHE', 'سويسرا'),
(26734, 1534719396, 1534719399, 'GB', 'GBR', 'المملكة المتحدة'),
(26735, 1534719400, 1534719403, 'IT', 'ITA', 'إيطاليا'),
(26736, 1534719404, 1534719423, 'FR', 'FRA', 'فرنسا'),
(26737, 1534719424, 1534719439, 'DE', 'DEU', 'ألمانيا'),
(26738, 1534719440, 1534719455, 'PL', 'POL', 'بولندا'),
(26739, 1534719456, 1534719471, 'FR', 'FRA', 'فرنسا'),
(26740, 1534719472, 1534719487, 'GB', 'GBR', 'المملكة المتحدة'),
(26741, 1534719488, 1534719631, 'FR', 'FRA', 'فرنسا'),
(26742, 1534719632, 1534719639, 'ES', 'ESP', 'إسبانيا'),
(26743, 1534719640, 1534719643, 'GB', 'GBR', 'المملكة المتحدة'),
(26744, 1534719644, 1534719647, 'FR', 'FRA', 'فرنسا'),
(26745, 1534719648, 1534719655, 'ES', 'ESP', 'إسبانيا'),
(26746, 1534719656, 1534719663, 'FR', 'FRA', 'فرنسا'),
(26747, 1534719664, 1534719679, 'PL', 'POL', 'بولندا'),
(26748, 1534719680, 1534719695, 'GB', 'GBR', 'المملكة المتحدة'),
(26749, 1534719696, 1534719759, 'FR', 'FRA', 'فرنسا'),
(26750, 1534719760, 1534719775, 'IT', 'ITA', 'إيطاليا'),
(26751, 1534719776, 1534719823, 'FR', 'FRA', 'فرنسا'),
(26752, 1534719824, 1534719839, 'CH', 'CHE', 'سويسرا'),
(26753, 1534719840, 1534719871, 'FR', 'FRA', 'فرنسا'),
(26754, 1534719872, 1534719887, 'PL', 'POL', 'بولندا'),
(26755, 1534719888, 1534719951, 'FR', 'FRA', 'فرنسا'),
(26756, 1534719952, 1534719967, 'DE', 'DEU', 'ألمانيا'),
(26757, 1534719968, 1534719983, 'PL', 'POL', 'بولندا'),
(26758, 1534719984, 1534719999, 'FR', 'FRA', 'فرنسا'),
(26759, 1534720000, 1534720015, 'PL', 'POL', 'بولندا'),
(26760, 1534720016, 1534720031, 'GB', 'GBR', 'المملكة المتحدة'),
(26761, 1534720032, 1534720047, 'DE', 'DEU', 'ألمانيا'),
(26762, 1534720048, 1534720063, 'ES', 'ESP', 'إسبانيا'),
(26763, 1534720064, 1534720079, 'IT', 'ITA', 'إيطاليا'),
(26764, 1534720080, 1534720095, 'GB', 'GBR', 'المملكة المتحدة'),
(26765, 1534720096, 1534720111, 'FR', 'FRA', 'فرنسا'),
(26766, 1534720112, 1534720127, 'ES', 'ESP', 'إسبانيا'),
(26767, 1534720128, 1534720207, 'FR', 'FRA', 'فرنسا'),
(26768, 1534720208, 1534720223, 'GB', 'GBR', 'المملكة المتحدة'),
(26769, 1534720224, 1534720239, 'DE', 'DEU', 'ألمانيا'),
(26770, 1534720240, 1534720255, 'BE', 'BEL', 'بلجيكا'),
(26771, 1534720256, 1534720287, 'PL', 'POL', 'بولندا'),
(26772, 1534720288, 1534720431, 'FR', 'FRA', 'فرنسا'),
(26773, 1534720432, 1534720435, 'DE', 'DEU', 'ألمانيا'),
(26774, 1534720436, 1534720439, 'FR', 'FRA', 'فرنسا'),
(26775, 1534720440, 1534720443, 'GB', 'GBR', 'المملكة المتحدة'),
(26776, 1534720444, 1534720447, 'NL', 'NLD', 'هولندا'),
(26777, 1534720448, 1534720463, 'GB', 'GBR', 'المملكة المتحدة'),
(26778, 1534720464, 1534720479, 'ES', 'ESP', 'إسبانيا'),
(26779, 1534720480, 1534720495, 'GB', 'GBR', 'المملكة المتحدة'),
(26780, 1534720496, 1534720511, 'PL', 'POL', 'بولندا'),
(26781, 1534720512, 1534720527, 'DE', 'DEU', 'ألمانيا'),
(26782, 1534720528, 1534720535, 'FR', 'FRA', 'فرنسا'),
(26783, 1534720536, 1534720539, 'PL', 'POL', 'بولندا'),
(26784, 1534720540, 1534720575, 'FR', 'FRA', 'فرنسا'),
(26785, 1534720576, 1534720591, 'ES', 'ESP', 'إسبانيا'),
(26786, 1534720592, 1534720607, 'FR', 'FRA', 'فرنسا'),
(26787, 1534720608, 1534720623, 'GB', 'GBR', 'المملكة المتحدة'),
(26788, 1534720624, 1534720655, 'FR', 'FRA', 'فرنسا'),
(26789, 1534720656, 1534720671, 'PL', 'POL', 'بولندا'),
(26790, 1534720672, 1534720703, 'FR', 'FRA', 'فرنسا'),
(26791, 1534720704, 1534720735, 'PL', 'POL', 'بولندا'),
(26792, 1534720736, 1534720751, 'FR', 'FRA', 'فرنسا'),
(26793, 1534720752, 1534720767, 'GB', 'GBR', 'المملكة المتحدة'),
(26794, 1534720768, 1534720783, 'ES', 'ESP', 'إسبانيا'),
(26795, 1534720784, 1534720799, 'BE', 'BEL', 'بلجيكا'),
(26796, 1534720800, 1534720815, 'PL', 'POL', 'بولندا'),
(26797, 1534720816, 1534720831, 'FR', 'FRA', 'فرنسا'),
(26798, 1534720832, 1534720863, 'PL', 'POL', 'بولندا'),
(26799, 1534720864, 1534720895, 'FR', 'FRA', 'فرنسا'),
(26800, 1534720896, 1534720899, 'ES', 'ESP', 'إسبانيا'),
(26801, 1534720900, 1534720903, 'GB', 'GBR', 'المملكة المتحدة'),
(26802, 1534720904, 1534720959, 'FR', 'FRA', 'فرنسا'),
(26803, 1534720960, 1534720975, 'ES', 'ESP', 'إسبانيا'),
(26804, 1534720976, 1534720979, 'NL', 'NLD', 'هولندا'),
(26805, 1534720980, 1534720983, 'FR', 'FRA', 'فرنسا'),
(26806, 1534720984, 1534720991, 'PL', 'POL', 'بولندا'),
(26807, 1534720992, 1534721007, 'FR', 'FRA', 'فرنسا'),
(26808, 1534721008, 1534721023, 'ES', 'ESP', 'إسبانيا'),
(26809, 1534721024, 1534721055, 'FR', 'FRA', 'فرنسا'),
(26810, 1534721056, 1534721063, 'ES', 'ESP', 'إسبانيا'),
(26811, 1534721064, 1534721071, 'FR', 'FRA', 'فرنسا'),
(26812, 1534721072, 1534721087, 'GB', 'GBR', 'المملكة المتحدة'),
(26813, 1534721088, 1534721103, 'FR', 'FRA', 'فرنسا'),
(26814, 1534721104, 1534721107, 'PL', 'POL', 'بولندا'),
(26815, 1534721108, 1534721111, 'ES', 'ESP', 'إسبانيا'),
(26816, 1534721112, 1534721115, 'FR', 'FRA', 'فرنسا'),
(26817, 1534721116, 1534721119, 'BE', 'BEL', 'بلجيكا'),
(26818, 1534721120, 1534721135, 'IT', 'ITA', 'إيطاليا'),
(26819, 1534721136, 1534721159, 'FR', 'FRA', 'فرنسا'),
(26820, 1534721160, 1534721163, 'GB', 'GBR', 'المملكة المتحدة'),
(26821, 1534721164, 1534721183, 'FR', 'FRA', 'فرنسا'),
(26822, 1534721184, 1534721191, 'LT', 'LTU', 'ليتوانيا'),
(26823, 1534721192, 1534721195, 'FR', 'FRA', 'فرنسا'),
(26824, 1534721196, 1534721199, 'IT', 'ITA', 'إيطاليا'),
(26825, 1534721200, 1534721215, 'FR', 'FRA', 'فرنسا'),
(26826, 1534721216, 1534721223, 'BE', 'BEL', 'بلجيكا'),
(26827, 1534721224, 1534721231, 'CH', 'CHE', 'سويسرا'),
(26828, 1534721232, 1534721247, 'DE', 'DEU', 'ألمانيا'),
(26829, 1534721248, 1534721263, 'FR', 'FRA', 'فرنسا'),
(26830, 1534721264, 1534721279, 'GB', 'GBR', 'المملكة المتحدة'),
(26831, 1534721280, 1534721311, 'FR', 'FRA', 'فرنسا'),
(26832, 1534721312, 1534721319, 'PL', 'POL', 'بولندا'),
(26833, 1534721320, 1534721327, 'PT', 'PRT', 'البورتوغال'),
(26834, 1534721328, 1534721343, 'NL', 'NLD', 'هولندا'),
(26835, 1534721344, 1534721359, 'ES', 'ESP', 'إسبانيا'),
(26836, 1534721360, 1534721375, 'FR', 'FRA', 'فرنسا'),
(26837, 1534721376, 1534721391, 'ES', 'ESP', 'إسبانيا'),
(26838, 1534721392, 1534721407, 'GB', 'GBR', 'المملكة المتحدة'),
(26839, 1534721408, 1534721439, 'DE', 'DEU', 'ألمانيا'),
(26840, 1534721440, 1534721455, 'BE', 'BEL', 'بلجيكا'),
(26841, 1534721456, 1534721487, 'FR', 'FRA', 'فرنسا'),
(26842, 1534721488, 1534721491, 'GB', 'GBR', 'المملكة المتحدة'),
(26843, 1534721492, 1534721495, 'FR', 'FRA', 'فرنسا'),
(26844, 1534721496, 1534721519, 'PL', 'POL', 'بولندا'),
(26845, 1534721520, 1534721527, 'FR', 'FRA', 'فرنسا'),
(26846, 1534721528, 1534721531, 'ES', 'ESP', 'إسبانيا'),
(26847, 1534721532, 1534721535, 'FR', 'FRA', 'فرنسا'),
(26848, 1534721536, 1534721583, 'GB', 'GBR', 'المملكة المتحدة'),
(26849, 1534721584, 1534721599, 'FR', 'FRA', 'فرنسا'),
(26850, 1534721600, 1534721623, 'ES', 'ESP', 'إسبانيا'),
(26851, 1534721624, 1534721627, 'PL', 'POL', 'بولندا'),
(26852, 1534721628, 1534721631, 'DE', 'DEU', 'ألمانيا'),
(26853, 1534721632, 1534721663, 'FR', 'FRA', 'فرنسا'),
(26854, 1534721664, 1534721679, 'ES', 'ESP', 'إسبانيا'),
(26855, 1534721680, 1534721711, 'FR', 'FRA', 'فرنسا'),
(26856, 1534721712, 1534721727, 'ES', 'ESP', 'إسبانيا'),
(26857, 1534721728, 1534721743, 'FR', 'FRA', 'فرنسا'),
(26858, 1534721744, 1534721747, 'PL', 'POL', 'بولندا'),
(26859, 1534721748, 1534721751, 'IT', 'ITA', 'إيطاليا'),
(26860, 1534721752, 1534721755, 'DE', 'DEU', 'ألمانيا'),
(26861, 1534721756, 1534721775, 'FR', 'FRA', 'فرنسا'),
(26862, 1534721776, 1534721791, 'ES', 'ESP', 'إسبانيا'),
(26863, 1534721792, 1534721823, 'FR', 'FRA', 'فرنسا'),
(26864, 1534721824, 1534721827, 'PL', 'POL', 'بولندا'),
(26865, 1534721828, 1534721831, 'FR', 'FRA', 'فرنسا'),
(26866, 1534721832, 1534721835, 'PL', 'POL', 'بولندا'),
(26867, 1534721836, 1534721839, 'BE', 'BEL', 'بلجيكا'),
(26868, 1534721840, 1534721855, 'PL', 'POL', 'بولندا'),
(26869, 1534721856, 1534721887, 'ES', 'ESP', 'إسبانيا'),
(26870, 1534721888, 1534721903, 'FR', 'FRA', 'فرنسا'),
(26871, 1534721904, 1534721919, 'DE', 'DEU', 'ألمانيا'),
(26872, 1534721920, 1534721935, 'FR', 'FRA', 'فرنسا'),
(26873, 1534721936, 1534721951, 'PL', 'POL', 'بولندا'),
(26874, 1534721952, 1534721955, 'FR', 'FRA', 'فرنسا'),
(26875, 1534721956, 1534721959, 'PL', 'POL', 'بولندا'),
(26876, 1534721960, 1534721963, 'IE', 'IRL', 'إيرلندا'),
(26877, 1534721964, 1534721967, 'CH', 'CHE', 'سويسرا'),
(26878, 1534721968, 1534721975, 'DE', 'DEU', 'ألمانيا'),
(26879, 1534721976, 1534721979, 'ES', 'ESP', 'إسبانيا'),
(26880, 1534721980, 1534721983, 'GB', 'GBR', 'المملكة المتحدة'),
(26881, 1534721984, 1534721999, 'PL', 'POL', 'بولندا'),
(26882, 1534722000, 1534722031, 'FR', 'FRA', 'فرنسا'),
(26883, 1534722032, 1534722047, 'BE', 'BEL', 'بلجيكا'),
(26884, 1534722048, 1534787583, 'RU', 'RUS', 'الإتحاد الروسي'),
(26885, 1534787584, 1534791679, 'RO', 'ROM', 'رومانيا'),
(26886, 1534791680, 1534795775, 'RU', 'RUS', 'الإتحاد الروسي'),
(26887, 1534795776, 1534803967, 'NO', 'NOR', 'النرويج'),
(26888, 1534803968, 1534808063, 'LV', 'LVA', 'لاتفيا'),
(26889, 1534808064, 1534812159, 'RU', 'RUS', 'الإتحاد الروسي'),
(26890, 1534812160, 1534816255, 'CH', 'CHE', 'سويسرا'),
(26891, 1534816256, 1534820351, 'FR', 'FRA', 'فرنسا'),
(26892, 1534820352, 1534824447, 'FI', 'FIN', 'فنلندا'),
(26893, 1534824448, 1534828543, 'UA', 'UKR', 'أوكرانيا'),
(26894, 1534828544, 1534832639, 'PL', 'POL', 'بولندا'),
(26895, 1534836736, 1534840831, 'SE', 'SWE', 'السويد'),
(26896, 1534840832, 1534844927, 'PL', 'POL', 'بولندا'),
(26897, 1534844928, 1534849023, 'IE', 'IRL', 'إيرلندا'),
(26898, 1534849024, 1534853119, 'NL', 'NLD', 'هولندا'),
(26899, 1534853120, 1534918655, 'UA', 'UKR', 'أوكرانيا'),
(26900, 1534918656, 1534984191, 'GB', 'GBR', 'المملكة المتحدة'),
(26901, 1534984192, 1534989855, 'SE', 'SWE', 'السويد'),
(26902, 1534989856, 1534990063, 'ES', 'ESP', 'إسبانيا'),
(26903, 1534990064, 1534990079, 'SE', 'SWE', 'السويد'),
(26904, 1534990080, 1534990335, 'ES', 'ESP', 'إسبانيا'),
(26905, 1534990336, 1534999551, 'SE', 'SWE', 'السويد'),
(26906, 1534999552, 1535004671, 'ES', 'ESP', 'إسبانيا'),
(26907, 1535004672, 1535008767, 'SE', 'SWE', 'السويد'),
(26908, 1535008768, 1535011839, 'ES', 'ESP', 'إسبانيا'),
(26909, 1535011840, 1535017983, 'SE', 'SWE', 'السويد'),
(26910, 1535017984, 1535019519, 'ES', 'ESP', 'إسبانيا'),
(26911, 1535019520, 1535020543, 'SE', 'SWE', 'السويد'),
(26912, 1535020544, 1535021055, 'ES', 'ESP', 'إسبانيا'),
(26913, 1535021056, 1535024127, 'SE', 'SWE', 'السويد'),
(26914, 1535024128, 1535049727, 'ES', 'ESP', 'إسبانيا'),
(26915, 1535049728, 1535115263, 'SK', 'SVK', 'سلوفاكيا'),
(26916, 1535115264, 1535377407, 'AT', 'AUT', 'النمسا'),
(26917, 1535377408, 1535442943, 'GR', 'GRC', 'اليونان'),
(26918, 1535442944, 1535508479, 'FI', 'FIN', 'فنلندا'),
(26919, 1535508480, 1535574015, 'BG', 'BGR', 'بلغاريا'),
(26920, 1535574016, 1535578111, 'GB', 'GBR', 'المملكة المتحدة'),
(26921, 1535578112, 1535582207, 'LV', 'LVA', 'لاتفيا'),
(26922, 1535582208, 1535590399, 'NO', 'NOR', 'النرويج'),
(26923, 1535590400, 1535594495, 'CH', 'CHE', 'سويسرا'),
(26924, 1535594496, 1535598591, 'LV', 'LVA', 'لاتفيا'),
(26925, 1535598592, 1535602687, 'IL', 'ISR', 'إسرائيل'),
(26926, 1535602688, 1535606783, 'HU', 'HUN', 'هنغاريا'),
(26927, 1535606784, 1535610879, 'NO', 'NOR', 'النرويج'),
(26928, 1535610880, 1535614975, 'RU', 'RUS', 'الإتحاد الروسي'),
(26929, 1535614976, 1535619071, 'AT', 'AUT', 'النمسا'),
(26930, 1535619072, 1535623167, 'FR', 'FRA', 'فرنسا'),
(26931, 1535623168, 1535627263, 'KZ', 'KAZ', 'كازاخستان'),
(26932, 1535627264, 1535631359, 'RU', 'RUS', 'الإتحاد الروسي'),
(26933, 1535631360, 1535635455, 'GB', 'GBR', 'المملكة المتحدة'),
(26934, 1535635456, 1535639551, 'AZ', 'AZE', 'أذربيجان'),
(26935, 1535639552, 1535672319, 'GB', 'GBR', 'المملكة المتحدة'),
(26936, 1535672320, 1535705087, 'DE', 'DEU', 'ألمانيا'),
(26937, 1535705088, 1535737855, 'CH', 'CHE', 'سويسرا'),
(26938, 1535737856, 1535769855, 'HU', 'HUN', 'هنغاريا'),
(26939, 1535769856, 1535770623, 'SR', 'SUR', 'سورينام'),
(26940, 1535770624, 1535803391, 'CH', 'CHE', 'سويسرا'),
(26941, 1535803392, 1535836159, 'GR', 'GRC', 'اليونان'),
(26942, 1535836160, 1535868927, 'HU', 'HUN', 'هنغاريا'),
(26943, 1535868928, 1535901695, 'BG', 'BGR', 'بلغاريا'),
(26944, 1535901696, 1535934463, 'GR', 'GRC', 'اليونان'),
(26945, 1535934464, 1535967231, 'KW', 'KWT', 'الكويت'),
(26946, 1535967232, 1535999999, 'AT', 'AUT', 'النمسا'),
(26947, 1536000000, 1536032767, 'NL', 'NLD', 'هولندا'),
(26948, 1536032768, 1536036863, 'LV', 'LVA', 'لاتفيا'),
(26949, 1536036864, 1536040959, 'AT', 'AUT', 'النمسا'),
(26950, 1536040960, 1536045055, 'GB', 'GBR', 'المملكة المتحدة'),
(26951, 1536045056, 1536045567, 'DE', 'DEU', 'ألمانيا'),
(26952, 1536045568, 1536046079, 'IQ', 'IRQ', 'العراق'),
(26953, 1536046080, 1536046591, 'DE', 'DEU', 'ألمانيا'),
(26954, 1536046592, 1536046847, 'IQ', 'IRQ', 'العراق'),
(26955, 1536046848, 1536046975, 'DE', 'DEU', 'ألمانيا'),
(26956, 1536046976, 1536047039, 'SA', 'SAU', 'السعودية'),
(26957, 1536047040, 1536047103, 'IQ', 'IRQ', 'العراق'),
(26958, 1536047104, 1536047679, 'LB', 'LBN', 'لبنان'),
(26959, 1536047680, 1536047999, 'DE', 'DEU', 'ألمانيا'),
(26960, 1536048000, 1536048127, 'SA', 'SAU', 'السعودية'),
(26961, 1536048128, 1536048255, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(26962, 1536048256, 1536048319, 'DE', 'DEU', 'ألمانيا'),
(26963, 1536048320, 1536048383, 'IQ', 'IRQ', 'العراق'),
(26964, 1536048384, 1536048639, 'DE', 'DEU', 'ألمانيا'),
(26965, 1536048640, 1536048671, 'FR', 'FRA', 'فرنسا'),
(26966, 1536048672, 1536048703, 'LU', 'LUX', 'لوكسيمبورغ'),
(26967, 1536048704, 1536048719, 'IQ', 'IRQ', 'العراق'),
(26968, 1536048720, 1536048735, 'NL', 'NLD', 'هولندا'),
(26969, 1536048736, 1536049151, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(26970, 1536049152, 1536053247, 'NL', 'NLD', 'هولندا'),
(26971, 1536053248, 1536057343, 'RU', 'RUS', 'الإتحاد الروسي'),
(26972, 1536057344, 1536061439, 'IE', 'IRL', 'إيرلندا'),
(26973, 1536061440, 1536065535, 'SE', 'SWE', 'السويد'),
(26974, 1536065536, 1536065791, 'GB', 'GBR', 'المملكة المتحدة'),
(26975, 1536065792, 1536066303, 'LU', 'LUX', 'لوكسيمبورغ'),
(26976, 1536066304, 1536066815, 'NL', 'NLD', 'هولندا'),
(26977, 1536066816, 1536067071, 'RU', 'RUS', 'الإتحاد الروسي'),
(26978, 1536067072, 1536067327, 'GB', 'GBR', 'المملكة المتحدة'),
(26979, 1536067328, 1536067583, 'RU', 'RUS', 'الإتحاد الروسي'),
(26980, 1536067584, 1536067839, 'DK', 'DNK', 'الدنيمارك'),
(26981, 1536067840, 1536068095, 'PL', 'POL', 'بولندا'),
(26982, 1536068096, 1536068351, 'RU', 'RUS', 'الإتحاد الروسي'),
(26983, 1536068352, 1536068607, 'HR', 'HRV', 'كرواتيا'),
(26984, 1536068608, 1536069119, 'RU', 'RUS', 'الإتحاد الروسي'),
(26985, 1536069120, 1536069375, 'TR', 'TUR', 'تركيا'),
(26986, 1536069376, 1536069631, 'IT', 'ITA', 'إيطاليا'),
(26987, 1536069632, 1536073727, 'RU', 'RUS', 'الإتحاد الروسي'),
(26988, 1536073728, 1536077823, 'UA', 'UKR', 'أوكرانيا'),
(26989, 1536077824, 1536081919, 'SE', 'SWE', 'السويد'),
(26990, 1536081920, 1536086015, 'PL', 'POL', 'بولندا'),
(26991, 1536086016, 1536090111, 'ES', 'ESP', 'إسبانيا'),
(26992, 1536090112, 1536094207, 'IE', 'IRL', 'إيرلندا'),
(26993, 1536094208, 1536098303, 'NL', 'NLD', 'هولندا'),
(26994, 1536098304, 1536114687, 'RU', 'RUS', 'الإتحاد الروسي'),
(26995, 1536114688, 1536118783, 'GB', 'GBR', 'المملكة المتحدة'),
(26996, 1536118784, 1536122879, 'DE', 'DEU', 'ألمانيا'),
(26997, 1536122880, 1536126975, 'AT', 'AUT', 'النمسا'),
(26998, 1536126976, 1536131071, 'DK', 'DNK', 'الدنيمارك'),
(26999, 1536131072, 1536143359, 'RU', 'RUS', 'الإتحاد الروسي'),
(27000, 1536143360, 1536147455, 'GB', 'GBR', 'المملكة المتحدة'),
(27001, 1536147456, 1536151551, 'IT', 'ITA', 'إيطاليا'),
(27002, 1536151552, 1536151807, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27003, 1536151808, 1536151823, 'RS', 'SRB', 'صربيا'),
(27004, 1536151824, 1536151999, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27005, 1536152000, 1536152015, 'RS', 'SRB', 'صربيا'),
(27006, 1536152016, 1536152655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27007, 1536152656, 1536152719, 'RS', 'SRB', 'صربيا'),
(27008, 1536152720, 1536155647, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27009, 1536155648, 1536159743, 'IL', 'ISR', 'إسرائيل'),
(27010, 1536159744, 1536163839, 'DE', 'DEU', 'ألمانيا'),
(27011, 1536163840, 1536180223, 'SY', 'SYR', 'سوريا'),
(27012, 1536180224, 1536196607, 'HU', 'HUN', 'هنغاريا'),
(27013, 1536196608, 1536212991, 'RU', 'RUS', 'الإتحاد الروسي'),
(27014, 1536212992, 1536229375, 'DK', 'DNK', 'الدنيمارك'),
(27015, 1536229376, 1536245759, 'SE', 'SWE', 'السويد'),
(27016, 1536245760, 1536262143, 'FI', 'FIN', 'فنلندا'),
(27017, 1536262144, 1536278527, 'PL', 'POL', 'بولندا'),
(27018, 1536278528, 1536294911, 'UA', 'UKR', 'أوكرانيا'),
(27019, 1536294912, 1536327679, 'RU', 'RUS', 'الإتحاد الروسي'),
(27020, 1536327680, 1536344063, 'HU', 'HUN', 'هنغاريا'),
(27021, 1536344064, 1536360447, 'PL', 'POL', 'بولندا'),
(27022, 1536360448, 1536376831, 'RU', 'RUS', 'الإتحاد الروسي'),
(27023, 1536376832, 1536393215, 'KZ', 'KAZ', 'كازاخستان'),
(27024, 1536393216, 1536409599, 'SA', 'SAU', 'السعودية'),
(27025, 1536409600, 1536425983, 'HU', 'HUN', 'هنغاريا'),
(27026, 1536425984, 1536442367, 'SK', 'SVK', 'سلوفاكيا'),
(27027, 1536442368, 1536444671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27028, 1536444672, 1536444927, 'RS', 'SRB', 'صربيا'),
(27029, 1536444928, 1536453903, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27030, 1536453904, 1536455679, 'RS', 'SRB', 'صربيا'),
(27031, 1536455680, 1536455935, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27032, 1536455936, 1536456191, 'RS', 'SRB', 'صربيا'),
(27033, 1536456192, 1536456447, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27034, 1536456448, 1536456703, 'RS', 'SRB', 'صربيا'),
(27035, 1536456704, 1536458751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27036, 1536458752, 1536475135, 'BG', 'BGR', 'بلغاريا'),
(27037, 1536475136, 1536491519, 'NL', 'NLD', 'هولندا'),
(27038, 1536491520, 1536499711, 'NO', 'NOR', 'النرويج'),
(27039, 1536499712, 1536503807, 'SE', 'SWE', 'السويد'),
(27040, 1536503808, 1536507903, 'NO', 'NOR', 'النرويج'),
(27041, 1536507904, 1536524287, 'RU', 'RUS', 'الإتحاد الروسي'),
(27042, 1536524288, 1536540671, 'BY', 'BLR', 'روسيا البيضاء'),
(27043, 1536540672, 1536557055, 'PL', 'POL', 'بولندا'),
(27044, 1536557056, 1536573439, 'FI', 'FIN', 'فنلندا'),
(27045, 1536573440, 1536574719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27046, 1536574720, 1536574975, 'RS', 'SRB', 'صربيا'),
(27047, 1536574976, 1536575615, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27048, 1536575616, 1536575727, 'RS', 'SRB', 'صربيا'),
(27049, 1536575728, 1536575743, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27050, 1536575744, 1536576511, 'RS', 'SRB', 'صربيا'),
(27051, 1536576512, 1536578559, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27052, 1536578560, 1536579071, 'RS', 'SRB', 'صربيا'),
(27053, 1536579072, 1536580095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27054, 1536580096, 1536580351, 'RS', 'SRB', 'صربيا'),
(27055, 1536580352, 1536580607, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27056, 1536580608, 1536580807, 'RS', 'SRB', 'صربيا'),
(27057, 1536580808, 1536580815, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27058, 1536580816, 1536580863, 'RS', 'SRB', 'صربيا'),
(27059, 1536580864, 1536580991, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27060, 1536580992, 1536581119, 'RS', 'SRB', 'صربيا'),
(27061, 1536581120, 1536589823, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27062, 1536589824, 1536614399, 'PL', 'POL', 'بولندا'),
(27063, 1536614400, 1536622591, 'DK', 'DNK', 'الدنيمارك'),
(27064, 1536622592, 1536626687, 'GB', 'GBR', 'المملكة المتحدة'),
(27065, 1536626688, 1536630783, 'IT', 'ITA', 'إيطاليا'),
(27066, 1536630784, 1536634879, 'RU', 'RUS', 'الإتحاد الروسي'),
(27067, 1536634880, 1536643071, 'FR', 'FRA', 'فرنسا'),
(27068, 1536643072, 1536647167, 'TR', 'TUR', 'تركيا'),
(27069, 1536647168, 1536647434, 'ES', 'ESP', 'إسبانيا'),
(27070, 1536647435, 1536647435, 'PT', 'PRT', 'البورتوغال'),
(27071, 1536647436, 1536651263, 'ES', 'ESP', 'إسبانيا'),
(27072, 1536651264, 1536655359, 'FR', 'FRA', 'فرنسا'),
(27073, 1536655360, 1536659455, 'GE', 'GEO', 'جورجيا'),
(27074, 1536659456, 1536659759, 'DE', 'DEU', 'ألمانيا'),
(27075, 1536659760, 1536659775, 'BI', 'BDI', 'بوروندي'),
(27076, 1536659776, 1536659791, 'LB', 'LBN', 'لبنان'),
(27077, 1536659792, 1536659823, 'SD', 'SDN', 'السودان'),
(27078, 1536659824, 1536659967, 'DE', 'DEU', 'ألمانيا'),
(27079, 1536659968, 1536659975, 'EG', 'EGY', 'مصر'),
(27080, 1536659976, 1536659991, 'DE', 'DEU', 'ألمانيا'),
(27081, 1536659992, 1536660003, 'EG', 'EGY', 'مصر'),
(27082, 1536660004, 1536660007, 'SO', 'SOM', 'الصومال'),
(27083, 1536660008, 1536660015, 'DE', 'DEU', 'ألمانيا'),
(27084, 1536660016, 1536660019, 'KW', 'KWT', 'الكويت'),
(27085, 1536660020, 1536660023, 'DE', 'DEU', 'ألمانيا'),
(27086, 1536660024, 1536660031, 'IR', 'IRN', 'إيران'),
(27087, 1536660032, 1536660039, 'DJ', 'DJI', 'جيبوتي'),
(27088, 1536660040, 1536660223, 'DE', 'DEU', 'ألمانيا'),
(27089, 1536660224, 1536660479, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(27090, 1536660480, 1536660735, 'IQ', 'IRQ', 'العراق'),
(27091, 1536660736, 1536660991, 'SA', 'SAU', 'السعودية'),
(27092, 1536660992, 1536661247, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(27093, 1536661248, 1536661759, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(27094, 1536661760, 1536662015, 'BJ', 'BEN', 'بنين'),
(27095, 1536662016, 1536662271, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(27096, 1536662272, 1536662303, 'SO', 'SOM', 'الصومال'),
(27097, 1536662304, 1536662311, 'IR', 'IRN', 'إيران'),
(27098, 1536662312, 1536662319, 'DE', 'DEU', 'ألمانيا'),
(27099, 1536662320, 1536662335, 'LB', 'LBN', 'لبنان'),
(27100, 1536662336, 1536662351, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(27101, 1536662352, 1536662359, 'TD', 'TCD', 'تشاد'),
(27102, 1536662360, 1536662367, 'IR', 'IRN', 'إيران'),
(27103, 1536662368, 1536662399, 'IQ', 'IRQ', 'العراق'),
(27104, 1536662400, 1536662415, 'DE', 'DEU', 'ألمانيا'),
(27105, 1536662416, 1536662431, 'GN', 'GIN', 'غينيا'),
(27106, 1536662432, 1536662527, 'IQ', 'IRQ', 'العراق'),
(27107, 1536662528, 1536662783, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(27108, 1536662784, 1536663039, 'SA', 'SAU', 'السعودية'),
(27109, 1536663040, 1536663295, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(27110, 1536663296, 1536663319, 'DE', 'DEU', 'ألمانيا'),
(27111, 1536663320, 1536663327, 'LB', 'LBN', 'لبنان'),
(27112, 1536663328, 1536663335, 'CV', 'CPV', 'الرأس الأخضر'),
(27113, 1536663336, 1536663359, 'DE', 'DEU', 'ألمانيا'),
(27114, 1536663360, 1536663391, 'IQ', 'IRQ', 'العراق'),
(27115, 1536663392, 1536663423, 'DE', 'DEU', 'ألمانيا'),
(27116, 1536663424, 1536663551, 'KW', 'KWT', 'الكويت'),
(27117, 1536663552, 1536667647, 'SA', 'SAU', 'السعودية'),
(27118, 1536667648, 1536675839, 'RU', 'RUS', 'الإتحاد الروسي'),
(27119, 1536675840, 1536679935, 'GB', 'GBR', 'المملكة المتحدة'),
(27120, 1536679936, 1536684031, 'LB', 'LBN', 'لبنان'),
(27121, 1536684032, 1536688127, 'RU', 'RUS', 'الإتحاد الروسي'),
(27122, 1536688128, 1537212415, 'FI', 'FIN', 'فنلندا'),
(27123, 1537212416, 1538260991, 'FR', 'FRA', 'فرنسا'),
(27124, 1538260992, 1538785279, 'BE', 'BEL', 'بلجيكا'),
(27125, 1538785280, 1538793471, 'NL', 'NLD', 'هولندا'),
(27126, 1538793472, 1538797567, 'DE', 'DEU', 'ألمانيا'),
(27127, 1538797568, 1538799551, 'NL', 'NLD', 'هولندا'),
(27128, 1538799552, 1538799615, 'DE', 'DEU', 'ألمانيا'),
(27129, 1538799616, 1538801663, 'NL', 'NLD', 'هولندا'),
(27130, 1538801664, 1538809855, 'IR', 'IRN', 'إيران'),
(27131, 1538809856, 1538818047, 'GE', 'GEO', 'جورجيا'),
(27132, 1538818048, 1538826239, 'NO', 'NOR', 'النرويج'),
(27133, 1538826240, 1538834431, 'DE', 'DEU', 'ألمانيا'),
(27134, 1538834432, 1538842623, 'CY', 'CYP', 'قبرص'),
(27135, 1538842624, 1538850815, 'RU', 'RUS', 'الإتحاد الروسي'),
(27136, 1538850816, 1538859007, 'KZ', 'KAZ', 'كازاخستان'),
(27137, 1538859008, 1538875391, 'RU', 'RUS', 'الإتحاد الروسي'),
(27138, 1538875392, 1538875719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27139, 1538875720, 1538875903, 'RS', 'SRB', 'صربيا'),
(27140, 1538875904, 1538878207, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27141, 1538878208, 1538878463, 'RS', 'SRB', 'صربيا'),
(27142, 1538878464, 1538879487, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27143, 1538879488, 1538883583, 'RS', 'SRB', 'صربيا'),
(27144, 1538883584, 1538891775, 'BE', 'BEL', 'بلجيكا'),
(27145, 1538891776, 1538899967, 'DE', 'DEU', 'ألمانيا'),
(27146, 1538899968, 1538904031, 'SI', 'SVN', 'سلوفينيا'),
(27147, 1538904032, 1538904039, 'BH', 'BHR', 'البحرين'),
(27148, 1538904040, 1538908159, 'SI', 'SVN', 'سلوفينيا'),
(27149, 1538908160, 1538916351, 'RU', 'RUS', 'الإتحاد الروسي'),
(27150, 1538916352, 1538924543, 'GB', 'GBR', 'المملكة المتحدة'),
(27151, 1538924544, 1538932735, 'DE', 'DEU', 'ألمانيا'),
(27152, 1538932736, 1538940927, 'NO', 'NOR', 'النرويج'),
(27153, 1538940928, 1538949119, 'RU', 'RUS', 'الإتحاد الروسي'),
(27154, 1538949120, 1538957311, 'AT', 'AUT', 'النمسا'),
(27155, 1538957312, 1538961535, 'DE', 'DEU', 'ألمانيا'),
(27156, 1538961536, 1538961599, 'IT', 'ITA', 'إيطاليا'),
(27157, 1538961600, 1538962263, 'DE', 'DEU', 'ألمانيا'),
(27158, 1538962264, 1538962271, 'GB', 'GBR', 'المملكة المتحدة'),
(27159, 1538962272, 1538963399, 'DE', 'DEU', 'ألمانيا'),
(27160, 1538963400, 1538963407, 'FR', 'FRA', 'فرنسا'),
(27161, 1538963408, 1538965503, 'DE', 'DEU', 'ألمانيا'),
(27162, 1538965504, 1538973695, 'IR', 'IRN', 'إيران'),
(27163, 1538973696, 1538981887, 'JO', 'JOR', 'الأردن'),
(27164, 1538981888, 1538990079, 'BY', 'BLR', 'روسيا البيضاء'),
(27165, 1538990080, 1538998271, 'CZ', 'CZE', 'التشيك'),
(27166, 1538998272, 1539006463, 'AD', 'AND', 'أندورا'),
(27167, 1539006464, 1539014655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27168, 1539014656, 1539014783, 'RS', 'SRB', 'صربيا'),
(27169, 1539014784, 1539014911, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27170, 1539014912, 1539014912, 'RS', 'SRB', 'صربيا'),
(27171, 1539014913, 1539015039, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27172, 1539015040, 1539015167, 'RS', 'SRB', 'صربيا'),
(27173, 1539015168, 1539015263, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27174, 1539015264, 1539015679, 'RS', 'SRB', 'صربيا'),
(27175, 1539015680, 1539015871, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27176, 1539015872, 1539016191, 'RS', 'SRB', 'صربيا'),
(27177, 1539016192, 1539016319, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27178, 1539016320, 1539016703, 'RS', 'SRB', 'صربيا'),
(27179, 1539016704, 1539016735, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27180, 1539016736, 1539016831, 'RS', 'SRB', 'صربيا'),
(27181, 1539016832, 1539016959, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27182, 1539016960, 1539017215, 'RS', 'SRB', 'صربيا'),
(27183, 1539017216, 1539017343, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27184, 1539017344, 1539017727, 'RS', 'SRB', 'صربيا'),
(27185, 1539017728, 1539017855, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27186, 1539017856, 1539018751, 'RS', 'SRB', 'صربيا'),
(27187, 1539018752, 1539018879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27188, 1539018880, 1539022847, 'RS', 'SRB', 'صربيا'),
(27189, 1539022848, 1539031039, 'LT', 'LTU', 'ليتوانيا'),
(27190, 1539031040, 1539039231, 'IT', 'ITA', 'إيطاليا'),
(27191, 1539039232, 1539047423, 'PL', 'POL', 'بولندا'),
(27192, 1539047424, 1539047583, 'IT', 'ITA', 'إيطاليا'),
(27193, 1539047584, 1539047591, 'US', 'USA', 'الولايات المتحدة'),
(27194, 1539047592, 1539048223, 'IT', 'ITA', 'إيطاليا'),
(27195, 1539048224, 1539048231, 'GB', 'GBR', 'المملكة المتحدة'),
(27196, 1539048232, 1539048247, 'IT', 'ITA', 'إيطاليا'),
(27197, 1539048248, 1539048263, 'GB', 'GBR', 'المملكة المتحدة'),
(27198, 1539048264, 1539048271, 'IT', 'ITA', 'إيطاليا'),
(27199, 1539048272, 1539048287, 'GB', 'GBR', 'المملكة المتحدة'),
(27200, 1539048288, 1539048303, 'IT', 'ITA', 'إيطاليا'),
(27201, 1539048304, 1539048335, 'GB', 'GBR', 'المملكة المتحدة'),
(27202, 1539048336, 1539048383, 'IT', 'ITA', 'إيطاليا'),
(27203, 1539048384, 1539048391, 'GB', 'GBR', 'المملكة المتحدة'),
(27204, 1539048392, 1539048399, 'IT', 'ITA', 'إيطاليا'),
(27205, 1539048400, 1539048447, 'GB', 'GBR', 'المملكة المتحدة'),
(27206, 1539048448, 1539048543, 'IT', 'ITA', 'إيطاليا'),
(27207, 1539048544, 1539048551, 'LY', 'LBY', 'ليبيا'),
(27208, 1539048552, 1539048559, 'IT', 'ITA', 'إيطاليا'),
(27209, 1539048560, 1539048575, 'LY', 'LBY', 'ليبيا'),
(27210, 1539048576, 1539048639, 'IT', 'ITA', 'إيطاليا'),
(27211, 1539048640, 1539048687, 'IQ', 'IRQ', 'العراق'),
(27212, 1539048688, 1539049255, 'IT', 'ITA', 'إيطاليا'),
(27213, 1539049256, 1539049263, 'LY', 'LBY', 'ليبيا'),
(27214, 1539049264, 1539049279, 'IT', 'ITA', 'إيطاليا'),
(27215, 1539049280, 1539049287, 'LY', 'LBY', 'ليبيا'),
(27216, 1539049288, 1539049311, 'IT', 'ITA', 'إيطاليا'),
(27217, 1539049312, 1539049327, 'LY', 'LBY', 'ليبيا'),
(27218, 1539049328, 1539049335, 'IT', 'ITA', 'إيطاليا'),
(27219, 1539049336, 1539049343, 'LY', 'LBY', 'ليبيا'),
(27220, 1539049344, 1539050335, 'IT', 'ITA', 'إيطاليا'),
(27221, 1539050336, 1539050351, 'TR', 'TUR', 'تركيا'),
(27222, 1539050352, 1539050367, 'IT', 'ITA', 'إيطاليا'),
(27223, 1539050368, 1539050375, 'FR', 'FRA', 'فرنسا'),
(27224, 1539050376, 1539050383, 'IT', 'ITA', 'إيطاليا'),
(27225, 1539050384, 1539050399, 'FR', 'FRA', 'فرنسا'),
(27226, 1539050400, 1539050407, 'IT', 'ITA', 'إيطاليا'),
(27227, 1539050408, 1539050415, 'AL', 'ALB', 'ألبانيا'),
(27228, 1539050416, 1539055471, 'IT', 'ITA', 'إيطاليا'),
(27229, 1539055472, 1539055487, 'FR', 'FRA', 'فرنسا'),
(27230, 1539055488, 1539055535, 'IT', 'ITA', 'إيطاليا'),
(27231, 1539055536, 1539055543, 'TR', 'TUR', 'تركيا'),
(27232, 1539055544, 1539055615, 'IT', 'ITA', 'إيطاليا'),
(27233, 1539055616, 1539063807, 'LV', 'LVA', 'لاتفيا'),
(27234, 1539063808, 1539071999, 'FR', 'FRA', 'فرنسا'),
(27235, 1539072000, 1539080191, 'PL', 'POL', 'بولندا'),
(27236, 1539080192, 1539088383, 'UZ', 'UZB', 'أوزباكستان'),
(27237, 1539088384, 1539096575, 'RU', 'RUS', 'الإتحاد الروسي'),
(27238, 1539096576, 1539112959, 'TR', 'TUR', 'تركيا'),
(27239, 1539112960, 1539115007, 'PL', 'POL', 'بولندا'),
(27240, 1539115008, 1539117055, 'CH', 'CHE', 'سويسرا'),
(27241, 1539117056, 1539123199, 'PL', 'POL', 'بولندا'),
(27242, 1539123200, 1539125247, 'SE', 'SWE', 'السويد'),
(27243, 1539125248, 1539127295, 'RU', 'RUS', 'الإتحاد الروسي'),
(27244, 1539127296, 1539129343, 'PL', 'POL', 'بولندا'),
(27245, 1539129344, 1539131391, 'IE', 'IRL', 'إيرلندا'),
(27246, 1539131392, 1539133439, 'PL', 'POL', 'بولندا'),
(27247, 1539133440, 1539135487, 'RU', 'RUS', 'الإتحاد الروسي'),
(27248, 1539135488, 1539137535, 'GB', 'GBR', 'المملكة المتحدة'),
(27249, 1539137536, 1539139583, 'NL', 'NLD', 'هولندا'),
(27250, 1539139584, 1539141631, 'FR', 'FRA', 'فرنسا'),
(27251, 1539141632, 1539143679, 'RU', 'RUS', 'الإتحاد الروسي'),
(27252, 1539143680, 1539145727, 'NO', 'NOR', 'النرويج'),
(27253, 1539145728, 1539147775, 'UA', 'UKR', 'أوكرانيا'),
(27254, 1539147776, 1539149823, 'PL', 'POL', 'بولندا'),
(27255, 1539149824, 1539151871, 'GB', 'GBR', 'المملكة المتحدة'),
(27256, 1539151872, 1539153919, 'UA', 'UKR', 'أوكرانيا'),
(27257, 1539153920, 1539155967, 'RU', 'RUS', 'الإتحاد الروسي'),
(27258, 1539155968, 1539160063, 'NO', 'NOR', 'النرويج'),
(27259, 1539160064, 1539162111, 'RU', 'RUS', 'الإتحاد الروسي'),
(27260, 1539162112, 1539164159, 'DE', 'DEU', 'ألمانيا'),
(27261, 1539164160, 1539166207, 'DK', 'DNK', 'الدنيمارك'),
(27262, 1539166208, 1539168255, 'FI', 'FIN', 'فنلندا'),
(27263, 1539168256, 1539170303, 'PL', 'POL', 'بولندا'),
(27264, 1539170304, 1539172351, 'NL', 'NLD', 'هولندا'),
(27265, 1539172352, 1539176447, 'RU', 'RUS', 'الإتحاد الروسي'),
(27266, 1539176448, 1539178495, 'PL', 'POL', 'بولندا'),
(27267, 1539178496, 1539186687, 'CH', 'CHE', 'سويسرا'),
(27268, 1539186688, 1539194879, 'LV', 'LVA', 'لاتفيا'),
(27269, 1539194880, 1539203071, 'RU', 'RUS', 'الإتحاد الروسي'),
(27270, 1539203072, 1539207167, 'NL', 'NLD', 'هولندا'),
(27271, 1539207168, 1539211263, 'RU', 'RUS', 'الإتحاد الروسي'),
(27272, 1539211264, 1539211527, 'CZ', 'CZE', 'التشيك'),
(27273, 1539211528, 1539211531, 'GB', 'GBR', 'المملكة المتحدة'),
(27274, 1539211532, 1539211775, 'CZ', 'CZE', 'التشيك'),
(27275, 1539211776, 1539212031, 'DE', 'DEU', 'ألمانيا'),
(27276, 1539212032, 1539212287, 'CZ', 'CZE', 'التشيك'),
(27277, 1539212288, 1539212543, 'DE', 'DEU', 'ألمانيا'),
(27278, 1539212544, 1539213311, 'CZ', 'CZE', 'التشيك'),
(27279, 1539213312, 1539215359, 'SE', 'SWE', 'السويد'),
(27280, 1539215360, 1539219455, 'DE', 'DEU', 'ألمانيا'),
(27281, 1539219456, 1539221503, 'DK', 'DNK', 'الدنيمارك'),
(27282, 1539221504, 1539222271, 'FR', 'FRA', 'فرنسا'),
(27283, 1539222272, 1539222303, 'HK', 'HKG', 'هونغ كونغ'),
(27284, 1539222304, 1539223551, 'FR', 'FRA', 'فرنسا'),
(27285, 1539223552, 1539225599, 'DE', 'DEU', 'ألمانيا'),
(27286, 1539225600, 1539227647, 'HU', 'HUN', 'هنغاريا'),
(27287, 1539227648, 1539229695, 'KW', 'KWT', 'الكويت'),
(27288, 1539229696, 1539231743, 'DE', 'DEU', 'ألمانيا'),
(27289, 1539231744, 1539233791, 'BE', 'BEL', 'بلجيكا'),
(27290, 1539233792, 1539235839, 'GR', 'GRC', 'اليونان'),
(27291, 1539235840, 1539237887, 'DE', 'DEU', 'ألمانيا'),
(27292, 1539237888, 1539239935, 'RU', 'RUS', 'الإتحاد الروسي'),
(27293, 1539239936, 1539244031, 'DE', 'DEU', 'ألمانيا'),
(27294, 1539244032, 1539260415, 'BA', 'BIH', 'البوسنه والهرسك'),
(27295, 1539260416, 1539276799, 'SK', 'SVK', 'سلوفاكيا'),
(27296, 1539276800, 1539280135, 'SE', 'SWE', 'السويد'),
(27297, 1539280136, 1539280143, 'FI', 'FIN', 'فنلندا'),
(27298, 1539280144, 1539280895, 'SE', 'SWE', 'السويد'),
(27299, 1539280896, 1539284991, 'FR', 'FRA', 'فرنسا'),
(27300, 1539284992, 1539287039, 'DE', 'DEU', 'ألمانيا'),
(27301, 1539287040, 1539289087, 'TR', 'TUR', 'تركيا'),
(27302, 1539289088, 1539293183, 'RU', 'RUS', 'الإتحاد الروسي'),
(27303, 1539293184, 1539297279, 'AZ', 'AZE', 'أذربيجان'),
(27304, 1539297280, 1539301375, 'BG', 'BGR', 'بلغاريا'),
(27305, 1539301376, 1539309567, 'RU', 'RUS', 'الإتحاد الروسي'),
(27306, 1539309568, 1539310591, 'PL', 'POL', 'بولندا'),
(27307, 1539310592, 1539311615, 'UA', 'UKR', 'أوكرانيا'),
(27308, 1539311616, 1539312639, 'NL', 'NLD', 'هولندا'),
(27309, 1539312640, 1539314687, 'DE', 'DEU', 'ألمانيا'),
(27310, 1539314688, 1539315711, 'RU', 'RUS', 'الإتحاد الروسي'),
(27311, 1539315712, 1539316735, 'UA', 'UKR', 'أوكرانيا'),
(27312, 1539316736, 1539317759, 'SE', 'SWE', 'السويد'),
(27313, 1539317760, 1539318783, 'RU', 'RUS', 'الإتحاد الروسي'),
(27314, 1539318784, 1539319807, 'NL', 'NLD', 'هولندا'),
(27315, 1539319808, 1539320831, 'DE', 'DEU', 'ألمانيا'),
(27316, 1539320832, 1539321855, 'UA', 'UKR', 'أوكرانيا'),
(27317, 1539321856, 1539322879, 'EG', 'EGY', 'مصر'),
(27318, 1539322880, 1539323903, 'DK', 'DNK', 'الدنيمارك'),
(27319, 1539323904, 1539324927, 'PL', 'POL', 'بولندا'),
(27320, 1539324928, 1539325951, 'RU', 'RUS', 'الإتحاد الروسي'),
(27321, 1539325952, 1539326975, 'KG', 'KGZ', 'قيرغيزستان'),
(27322, 1539326976, 1539329023, 'RU', 'RUS', 'الإتحاد الروسي'),
(27323, 1539329024, 1539330047, 'PL', 'POL', 'بولندا'),
(27324, 1539330048, 1539331071, 'RU', 'RUS', 'الإتحاد الروسي'),
(27325, 1539331072, 1539332095, 'UA', 'UKR', 'أوكرانيا'),
(27326, 1539332096, 1539333119, 'PL', 'POL', 'بولندا'),
(27327, 1539333120, 1539335167, 'RU', 'RUS', 'الإتحاد الروسي'),
(27328, 1539335168, 1539336191, 'CH', 'CHE', 'سويسرا'),
(27329, 1539336192, 1539336703, 'UA', 'UKR', 'أوكرانيا'),
(27330, 1539336704, 1539337215, 'EE', 'EST', 'إستونيا'),
(27331, 1539337216, 1539338239, 'ES', 'ESP', 'إسبانيا'),
(27332, 1539339264, 1539340287, 'NL', 'NLD', 'هولندا'),
(27333, 1539340288, 1539341311, 'PL', 'POL', 'بولندا'),
(27334, 1539341312, 1539342335, 'IT', 'ITA', 'إيطاليا'),
(27335, 1539342336, 1539345407, 'UA', 'UKR', 'أوكرانيا'),
(27336, 1539345408, 1539346431, 'RO', 'ROM', 'رومانيا'),
(27337, 1539346432, 1539347455, 'PL', 'POL', 'بولندا'),
(27338, 1539347456, 1539348479, 'RU', 'RUS', 'الإتحاد الروسي'),
(27339, 1539348480, 1539351551, 'UA', 'UKR', 'أوكرانيا'),
(27340, 1539351552, 1539352575, 'PL', 'POL', 'بولندا'),
(27341, 1539352576, 1539354623, 'RU', 'RUS', 'الإتحاد الروسي'),
(27342, 1539354624, 1539355647, 'PL', 'POL', 'بولندا'),
(27343, 1539355648, 1539357695, 'UA', 'UKR', 'أوكرانيا'),
(27344, 1539357696, 1539358719, 'RU', 'RUS', 'الإتحاد الروسي'),
(27345, 1539358720, 1539359743, 'GB', 'GBR', 'المملكة المتحدة'),
(27346, 1539359744, 1539360767, 'PL', 'POL', 'بولندا'),
(27347, 1539360768, 1539361279, 'UA', 'UKR', 'أوكرانيا'),
(27348, 1539361280, 1539361791, 'DE', 'DEU', 'ألمانيا'),
(27349, 1539361792, 1539362815, 'PL', 'POL', 'بولندا'),
(27350, 1539362816, 1539363839, 'GB', 'GBR', 'المملكة المتحدة'),
(27351, 1539363840, 1539364863, 'DK', 'DNK', 'الدنيمارك'),
(27352, 1539364864, 1539365887, 'UA', 'UKR', 'أوكرانيا'),
(27353, 1539365888, 1539366911, 'NO', 'NOR', 'النرويج'),
(27354, 1539366912, 1539368959, 'PL', 'POL', 'بولندا'),
(27355, 1539368960, 1539369983, 'GB', 'GBR', 'المملكة المتحدة'),
(27356, 1539369984, 1539371007, 'BG', 'BGR', 'بلغاريا'),
(27357, 1539371008, 1539373055, 'RU', 'RUS', 'الإتحاد الروسي'),
(27358, 1539373056, 1539374079, 'PL', 'POL', 'بولندا'),
(27359, 1539374080, 1539375103, 'SE', 'SWE', 'السويد'),
(27360, 1539375104, 1539376127, 'NO', 'NOR', 'النرويج'),
(27361, 1539376128, 1539377151, 'IL', 'ISR', 'إسرائيل'),
(27362, 1539377152, 1539378175, 'UA', 'UKR', 'أوكرانيا'),
(27363, 1539378176, 1539379199, 'PL', 'POL', 'بولندا'),
(27364, 1539380224, 1539381247, 'CH', 'CHE', 'سويسرا'),
(27365, 1539381248, 1539382271, 'RS', 'SRB', 'صربيا'),
(27366, 1539383296, 1539384319, 'UA', 'UKR', 'أوكرانيا'),
(27367, 1539384320, 1539385343, 'RU', 'RUS', 'الإتحاد الروسي'),
(27368, 1539385344, 1539385855, 'PL', 'POL', 'بولندا'),
(27369, 1539385856, 1539386367, 'BE', 'BEL', 'بلجيكا'),
(27370, 1539386368, 1539387391, 'IT', 'ITA', 'إيطاليا'),
(27371, 1539387392, 1539388415, 'IL', 'ISR', 'إسرائيل'),
(27372, 1539388416, 1539389439, 'PL', 'POL', 'بولندا'),
(27373, 1539389440, 1539389951, 'FR', 'FRA', 'فرنسا'),
(27374, 1539389952, 1539390463, 'RU', 'RUS', 'الإتحاد الروسي'),
(27375, 1539390464, 1539391487, 'RO', 'ROM', 'رومانيا'),
(27376, 1539391488, 1539392511, 'LV', 'LVA', 'لاتفيا'),
(27377, 1539392512, 1539393535, 'UA', 'UKR', 'أوكرانيا'),
(27378, 1539393536, 1539394559, 'RU', 'RUS', 'الإتحاد الروسي'),
(27379, 1539394560, 1539396607, 'UA', 'UKR', 'أوكرانيا'),
(27380, 1539396608, 1539397631, 'PL', 'POL', 'بولندا'),
(27381, 1539397632, 1539398143, 'RU', 'RUS', 'الإتحاد الروسي'),
(27382, 1539398144, 1539398655, 'PL', 'POL', 'بولندا'),
(27383, 1539398656, 1539399679, 'ES', 'ESP', 'إسبانيا'),
(27384, 1539399680, 1539401727, 'PL', 'POL', 'بولندا'),
(27385, 1539401728, 1539402239, 'GB', 'GBR', 'المملكة المتحدة'),
(27386, 1539402240, 1539402751, 'FR', 'FRA', 'فرنسا'),
(27387, 1539402752, 1539403263, 'GB', 'GBR', 'المملكة المتحدة'),
(27388, 1539403264, 1539403775, 'RU', 'RUS', 'الإتحاد الروسي'),
(27389, 1539403776, 1539404799, 'GR', 'GRC', 'اليونان'),
(27390, 1539404800, 1539405823, 'LV', 'LVA', 'لاتفيا'),
(27391, 1539405824, 1539406847, 'PL', 'POL', 'بولندا'),
(27392, 1539406848, 1539408895, 'UA', 'UKR', 'أوكرانيا'),
(27393, 1539408896, 1539409919, 'CZ', 'CZE', 'التشيك'),
(27394, 1539409920, 1539410943, 'DK', 'DNK', 'الدنيمارك'),
(27395, 1539410944, 1539411967, 'RU', 'RUS', 'الإتحاد الروسي'),
(27396, 1539411968, 1539412991, 'PL', 'POL', 'بولندا'),
(27397, 1539412992, 1539414015, 'RU', 'RUS', 'الإتحاد الروسي'),
(27398, 1539414016, 1539415039, 'UA', 'UKR', 'أوكرانيا'),
(27399, 1539415040, 1539416063, 'BG', 'BGR', 'بلغاريا'),
(27400, 1539416064, 1539417087, 'PL', 'POL', 'بولندا'),
(27401, 1539417088, 1539418111, 'UA', 'UKR', 'أوكرانيا'),
(27402, 1539418112, 1539419135, 'RU', 'RUS', 'الإتحاد الروسي'),
(27403, 1539419136, 1539420159, 'UA', 'UKR', 'أوكرانيا'),
(27404, 1539420160, 1539421183, 'RU', 'RUS', 'الإتحاد الروسي'),
(27405, 1539421184, 1539422207, 'GB', 'GBR', 'المملكة المتحدة'),
(27406, 1539422208, 1539423231, 'PL', 'POL', 'بولندا'),
(27407, 1539423232, 1539424255, 'IE', 'IRL', 'إيرلندا'),
(27408, 1539424256, 1539425279, 'RU', 'RUS', 'الإتحاد الروسي'),
(27409, 1539425280, 1539426303, 'PL', 'POL', 'بولندا'),
(27410, 1539426304, 1539427327, 'BG', 'BGR', 'بلغاريا'),
(27411, 1539427328, 1539428351, 'UA', 'UKR', 'أوكرانيا'),
(27412, 1539428352, 1539429375, 'PL', 'POL', 'بولندا'),
(27413, 1539429376, 1539434495, 'RU', 'RUS', 'الإتحاد الروسي'),
(27414, 1539434496, 1539435519, 'UA', 'UKR', 'أوكرانيا'),
(27415, 1539435520, 1539437567, 'RU', 'RUS', 'الإتحاد الروسي'),
(27416, 1539437568, 1539439615, 'GB', 'GBR', 'المملكة المتحدة'),
(27417, 1539439616, 1539440639, 'UA', 'UKR', 'أوكرانيا'),
(27418, 1539440640, 1539441663, 'RU', 'RUS', 'الإتحاد الروسي'),
(27419, 1539441664, 1539442175, 'IL', 'ISR', 'إسرائيل'),
(27420, 1539442176, 1539442687, 'DE', 'DEU', 'ألمانيا'),
(27421, 1539442688, 1539443199, 'NL', 'NLD', 'هولندا'),
(27422, 1539443200, 1539444223, 'RU', 'RUS', 'الإتحاد الروسي'),
(27423, 1539444224, 1539444735, 'FR', 'FRA', 'فرنسا'),
(27424, 1539444736, 1539445247, 'RU', 'RUS', 'الإتحاد الروسي'),
(27425, 1539445248, 1539445759, 'PL', 'POL', 'بولندا'),
(27426, 1539445760, 1539446271, 'FI', 'FIN', 'فنلندا'),
(27427, 1539446272, 1539446783, 'SE', 'SWE', 'السويد'),
(27428, 1539446784, 1539447295, 'RU', 'RUS', 'الإتحاد الروسي'),
(27429, 1539447296, 1539447807, 'SE', 'SWE', 'السويد'),
(27430, 1539447808, 1539448831, 'RO', 'ROM', 'رومانيا'),
(27431, 1539448832, 1539449343, 'AT', 'AUT', 'النمسا'),
(27432, 1539449344, 1539449855, 'UA', 'UKR', 'أوكرانيا'),
(27433, 1539449856, 1539450367, 'DK', 'DNK', 'الدنيمارك'),
(27434, 1539450368, 1539450879, 'SE', 'SWE', 'السويد'),
(27435, 1539450880, 1539451391, 'UA', 'UKR', 'أوكرانيا'),
(27436, 1539451392, 1539452415, 'RO', 'ROM', 'رومانيا'),
(27437, 1539452416, 1539452927, 'GB', 'GBR', 'المملكة المتحدة'),
(27438, 1539452928, 1539453439, 'CH', 'CHE', 'سويسرا'),
(27439, 1539453440, 1539453951, 'UA', 'UKR', 'أوكرانيا'),
(27440, 1539453952, 1539454463, 'GB', 'GBR', 'المملكة المتحدة'),
(27441, 1539454464, 1539454975, 'RU', 'RUS', 'الإتحاد الروسي'),
(27442, 1539454976, 1539455487, 'UA', 'UKR', 'أوكرانيا'),
(27443, 1539455488, 1539455999, 'RU', 'RUS', 'الإتحاد الروسي'),
(27444, 1539456000, 1539456511, 'FR', 'FRA', 'فرنسا'),
(27445, 1539456512, 1539457023, 'ES', 'ESP', 'إسبانيا'),
(27446, 1539457024, 1539457535, 'RU', 'RUS', 'الإتحاد الروسي'),
(27447, 1539457536, 1539458047, 'SE', 'SWE', 'السويد'),
(27448, 1539458048, 1539459071, 'GB', 'GBR', 'المملكة المتحدة'),
(27449, 1539459072, 1539459583, 'UA', 'UKR', 'أوكرانيا'),
(27450, 1539459584, 1539460095, 'GB', 'GBR', 'المملكة المتحدة'),
(27451, 1539460096, 1539460607, 'LV', 'LVA', 'لاتفيا'),
(27452, 1539460608, 1539461631, 'UA', 'UKR', 'أوكرانيا'),
(27453, 1539461632, 1539462143, 'RS', 'SRB', 'صربيا'),
(27454, 1539462144, 1539462655, 'DE', 'DEU', 'ألمانيا'),
(27455, 1539462656, 1539463167, 'BE', 'BEL', 'بلجيكا'),
(27456, 1539463168, 1539463679, 'UA', 'UKR', 'أوكرانيا'),
(27457, 1539463680, 1539464191, 'DE', 'DEU', 'ألمانيا'),
(27458, 1539464192, 1539464703, 'RO', 'ROM', 'رومانيا'),
(27459, 1539464704, 1539465215, 'DK', 'DNK', 'الدنيمارك'),
(27460, 1539465216, 1539466751, 'FR', 'FRA', 'فرنسا'),
(27461, 1539466752, 1539467263, 'KW', 'KWT', 'الكويت'),
(27462, 1539467264, 1539467775, 'RU', 'RUS', 'الإتحاد الروسي'),
(27463, 1539467776, 1539468287, 'PL', 'POL', 'بولندا'),
(27464, 1539468288, 1539468799, 'DE', 'DEU', 'ألمانيا'),
(27465, 1539468800, 1539469823, 'RU', 'RUS', 'الإتحاد الروسي'),
(27466, 1539469824, 1539470335, 'IL', 'ISR', 'إسرائيل'),
(27467, 1539470336, 1539470847, 'GB', 'GBR', 'المملكة المتحدة'),
(27468, 1539470848, 1539471359, 'SE', 'SWE', 'السويد'),
(27469, 1539471360, 1539471871, 'RU', 'RUS', 'الإتحاد الروسي'),
(27470, 1539471872, 1539472383, 'PL', 'POL', 'بولندا'),
(27471, 1539472384, 1539472895, 'UA', 'UKR', 'أوكرانيا'),
(27472, 1539472896, 1539473407, 'GB', 'GBR', 'المملكة المتحدة'),
(27473, 1539473408, 1539473919, 'FR', 'FRA', 'فرنسا'),
(27474, 1539473920, 1539474431, 'KW', 'KWT', 'الكويت'),
(27475, 1539474432, 1539474943, 'DE', 'DEU', 'ألمانيا'),
(27476, 1539474944, 1539475455, 'UA', 'UKR', 'أوكرانيا'),
(27477, 1539475456, 1539475967, 'NL', 'NLD', 'هولندا'),
(27478, 1539475968, 1539476479, 'PL', 'POL', 'بولندا'),
(27479, 1539476480, 1539476991, 'CZ', 'CZE', 'التشيك'),
(27480, 1539476992, 1539477503, 'IT', 'ITA', 'إيطاليا'),
(27481, 1539477504, 1539478015, 'PL', 'POL', 'بولندا'),
(27482, 1539478016, 1539478527, 'CH', 'CHE', 'سويسرا'),
(27483, 1539478528, 1539479039, 'RO', 'ROM', 'رومانيا'),
(27484, 1539479040, 1539479551, 'DK', 'DNK', 'الدنيمارك'),
(27485, 1539479552, 1539480063, 'GB', 'GBR', 'المملكة المتحدة'),
(27486, 1539480064, 1539480575, 'DK', 'DNK', 'الدنيمارك'),
(27487, 1539480576, 1539481087, 'PL', 'POL', 'بولندا'),
(27488, 1539481088, 1539481599, 'GB', 'GBR', 'المملكة المتحدة'),
(27489, 1539481600, 1539482111, 'RU', 'RUS', 'الإتحاد الروسي'),
(27490, 1539482112, 1539482623, 'UA', 'UKR', 'أوكرانيا'),
(27491, 1539482624, 1539483135, 'RU', 'RUS', 'الإتحاد الروسي'),
(27492, 1539483136, 1539483647, 'ES', 'ESP', 'إسبانيا'),
(27493, 1539483648, 1539484159, 'NL', 'NLD', 'هولندا'),
(27494, 1539484160, 1539484671, 'GB', 'GBR', 'المملكة المتحدة'),
(27495, 1539484672, 1539485695, 'RU', 'RUS', 'الإتحاد الروسي'),
(27496, 1539485696, 1539486207, 'RO', 'ROM', 'رومانيا'),
(27497, 1539486208, 1539486719, 'FR', 'FRA', 'فرنسا'),
(27498, 1539486720, 1539487231, 'DE', 'DEU', 'ألمانيا'),
(27499, 1539487232, 1539488255, 'RU', 'RUS', 'الإتحاد الروسي'),
(27500, 1539488256, 1539488767, 'SE', 'SWE', 'السويد'),
(27501, 1539488768, 1539489279, 'PL', 'POL', 'بولندا'),
(27502, 1539489280, 1539490815, 'RU', 'RUS', 'الإتحاد الروسي'),
(27503, 1539490816, 1539491327, 'CH', 'CHE', 'سويسرا'),
(27504, 1539491328, 1539491839, 'PL', 'POL', 'بولندا'),
(27505, 1539491840, 1539492351, 'RU', 'RUS', 'الإتحاد الروسي'),
(27506, 1539492352, 1539492863, 'BE', 'BEL', 'بلجيكا'),
(27507, 1539492864, 1539493375, 'KR', 'KOR', 'جمهورية كوريا'),
(27508, 1539493376, 1539493887, 'RU', 'RUS', 'الإتحاد الروسي'),
(27509, 1539493888, 1539494399, 'FR', 'FRA', 'فرنسا'),
(27510, 1539494400, 1539494911, 'PL', 'POL', 'بولندا'),
(27511, 1539494912, 1539495423, 'RU', 'RUS', 'الإتحاد الروسي'),
(27512, 1539495424, 1539495935, 'UA', 'UKR', 'أوكرانيا'),
(27513, 1539495936, 1539496447, 'RS', 'SRB', 'صربيا'),
(27514, 1539496448, 1539496959, 'NL', 'NLD', 'هولندا'),
(27515, 1539496960, 1539497471, 'GB', 'GBR', 'المملكة المتحدة'),
(27516, 1539497472, 1539497983, 'DE', 'DEU', 'ألمانيا'),
(27517, 1539497984, 1539498495, 'NL', 'NLD', 'هولندا'),
(27518, 1539498496, 1539499007, 'RU', 'RUS', 'الإتحاد الروسي'),
(27519, 1539499008, 1539499519, 'PL', 'POL', 'بولندا'),
(27520, 1539499520, 1539500543, 'DE', 'DEU', 'ألمانيا'),
(27521, 1539500544, 1539501055, 'RO', 'ROM', 'رومانيا'),
(27522, 1539501056, 1539501567, 'BE', 'BEL', 'بلجيكا'),
(27523, 1539501568, 1539502079, 'UA', 'UKR', 'أوكرانيا'),
(27524, 1539502080, 1539502591, 'PL', 'POL', 'بولندا'),
(27525, 1539502592, 1539503103, 'HR', 'HRV', 'كرواتيا'),
(27526, 1539503104, 1539504127, 'RU', 'RUS', 'الإتحاد الروسي'),
(27527, 1539504128, 1539504639, 'AT', 'AUT', 'النمسا'),
(27528, 1539504640, 1539505151, 'UA', 'UKR', 'أوكرانيا'),
(27529, 1539505152, 1539506175, 'RU', 'RUS', 'الإتحاد الروسي'),
(27530, 1539506176, 1539506687, 'NL', 'NLD', 'هولندا'),
(27531, 1539506688, 1539507199, 'UA', 'UKR', 'أوكرانيا'),
(27532, 1539507200, 1539508223, 'RO', 'ROM', 'رومانيا'),
(27533, 1539508224, 1539508735, 'NO', 'NOR', 'النرويج'),
(27534, 1539508736, 1539509759, 'UA', 'UKR', 'أوكرانيا'),
(27535, 1539509760, 1539510271, 'RO', 'ROM', 'رومانيا'),
(27536, 1539510272, 1539510783, 'RU', 'RUS', 'الإتحاد الروسي'),
(27537, 1539510784, 1539511295, 'LU', 'LUX', 'لوكسيمبورغ'),
(27538, 1539511296, 1539511807, 'UA', 'UKR', 'أوكرانيا'),
(27539, 1539511808, 1539512319, 'RU', 'RUS', 'الإتحاد الروسي'),
(27540, 1539512320, 1539512831, 'BG', 'BGR', 'بلغاريا'),
(27541, 1539512832, 1539513343, 'PL', 'POL', 'بولندا'),
(27542, 1539513344, 1539513855, 'RO', 'ROM', 'رومانيا'),
(27543, 1539513856, 1539514367, 'RU', 'RUS', 'الإتحاد الروسي'),
(27544, 1539514368, 1539514879, 'SE', 'SWE', 'السويد'),
(27545, 1539514880, 1539515391, 'ES', 'ESP', 'إسبانيا'),
(27546, 1539515392, 1539515903, 'FR', 'FRA', 'فرنسا'),
(27547, 1539515904, 1539516415, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(27548, 1539516416, 1539516927, 'AT', 'AUT', 'النمسا'),
(27549, 1539516928, 1539517439, 'PL', 'POL', 'بولندا'),
(27550, 1539517440, 1539517951, 'RO', 'ROM', 'رومانيا'),
(27551, 1539517952, 1539518463, 'GB', 'GBR', 'المملكة المتحدة'),
(27552, 1539518464, 1539518975, 'DE', 'DEU', 'ألمانيا'),
(27553, 1539518976, 1539519487, 'RU', 'RUS', 'الإتحاد الروسي'),
(27554, 1539519488, 1539519999, 'UA', 'UKR', 'أوكرانيا'),
(27555, 1539520000, 1539520511, 'DE', 'DEU', 'ألمانيا'),
(27556, 1539520512, 1539521023, 'PL', 'POL', 'بولندا'),
(27557, 1539521024, 1539521535, 'DK', 'DNK', 'الدنيمارك'),
(27558, 1539521536, 1539522047, 'RU', 'RUS', 'الإتحاد الروسي'),
(27559, 1539522048, 1539522559, 'RO', 'ROM', 'رومانيا'),
(27560, 1539522560, 1539523071, 'RU', 'RUS', 'الإتحاد الروسي'),
(27561, 1539523072, 1539523583, 'RO', 'ROM', 'رومانيا'),
(27562, 1539523584, 1539524095, 'UA', 'UKR', 'أوكرانيا'),
(27563, 1539524096, 1539524607, 'GR', 'GRC', 'اليونان'),
(27564, 1539524608, 1539525119, 'FR', 'FRA', 'فرنسا'),
(27565, 1539525120, 1539525631, 'UA', 'UKR', 'أوكرانيا'),
(27566, 1539525632, 1539526143, 'SE', 'SWE', 'السويد'),
(27567, 1539526144, 1539526655, 'DE', 'DEU', 'ألمانيا'),
(27568, 1539526656, 1539527167, 'NL', 'NLD', 'هولندا'),
(27569, 1539527168, 1539527679, 'GB', 'GBR', 'المملكة المتحدة'),
(27570, 1539527680, 1539528191, 'RO', 'ROM', 'رومانيا'),
(27571, 1539528192, 1539528703, 'UA', 'UKR', 'أوكرانيا'),
(27572, 1539528704, 1539529215, 'SA', 'SAU', 'السعودية'),
(27573, 1539529216, 1539529727, 'UA', 'UKR', 'أوكرانيا'),
(27574, 1539529728, 1539530239, 'PL', 'POL', 'بولندا'),
(27575, 1539530240, 1539530751, 'AT', 'AUT', 'النمسا'),
(27576, 1539530752, 1539531263, 'UA', 'UKR', 'أوكرانيا'),
(27577, 1539531264, 1539531775, 'RO', 'ROM', 'رومانيا'),
(27578, 1539531776, 1539532799, 'RU', 'RUS', 'الإتحاد الروسي'),
(27579, 1539532800, 1539533311, 'DE', 'DEU', 'ألمانيا'),
(27580, 1539533312, 1539533823, 'CZ', 'CZE', 'التشيك'),
(27581, 1539533824, 1539534335, 'PL', 'POL', 'بولندا'),
(27582, 1539534336, 1539534847, 'RU', 'RUS', 'الإتحاد الروسي'),
(27583, 1539534848, 1539535359, 'GB', 'GBR', 'المملكة المتحدة'),
(27584, 1539535360, 1539535871, 'RU', 'RUS', 'الإتحاد الروسي'),
(27585, 1539535872, 1539536383, 'AT', 'AUT', 'النمسا'),
(27586, 1539536384, 1539536895, 'NL', 'NLD', 'هولندا'),
(27587, 1539536896, 1539537407, 'UA', 'UKR', 'أوكرانيا'),
(27588, 1539537408, 1539537919, 'GB', 'GBR', 'المملكة المتحدة'),
(27589, 1539537920, 1539540479, 'RU', 'RUS', 'الإتحاد الروسي'),
(27590, 1539540480, 1539540991, 'PL', 'POL', 'بولندا'),
(27591, 1539540992, 1539541503, 'RU', 'RUS', 'الإتحاد الروسي'),
(27592, 1539541504, 1539542015, 'TR', 'TUR', 'تركيا'),
(27593, 1539542016, 1539542527, 'DE', 'DEU', 'ألمانيا'),
(27594, 1539542528, 1539543039, 'CH', 'CHE', 'سويسرا'),
(27595, 1539543040, 1539543551, 'RO', 'ROM', 'رومانيا'),
(27596, 1539543552, 1539544063, 'SI', 'SVN', 'سلوفينيا'),
(27597, 1539544064, 1539544575, 'RU', 'RUS', 'الإتحاد الروسي'),
(27598, 1539544576, 1539545087, 'CH', 'CHE', 'سويسرا'),
(27599, 1539545088, 1539545599, 'GR', 'GRC', 'اليونان'),
(27600, 1539545600, 1539546111, 'SE', 'SWE', 'السويد'),
(27601, 1539546112, 1539546623, 'UA', 'UKR', 'أوكرانيا'),
(27602, 1539546624, 1539547135, 'PL', 'POL', 'بولندا'),
(27603, 1539547136, 1539547647, 'NL', 'NLD', 'هولندا'),
(27604, 1539547648, 1539548159, 'IL', 'ISR', 'إسرائيل'),
(27605, 1539548160, 1539548671, 'FR', 'FRA', 'فرنسا'),
(27606, 1539549184, 1539549695, 'GB', 'GBR', 'المملكة المتحدة'),
(27607, 1539549696, 1539550207, 'RU', 'RUS', 'الإتحاد الروسي'),
(27608, 1539550208, 1539550719, 'UA', 'UKR', 'أوكرانيا'),
(27609, 1539550720, 1539551231, 'ES', 'ESP', 'إسبانيا'),
(27610, 1539551232, 1539551743, 'RS', 'SRB', 'صربيا'),
(27611, 1539551744, 1539552255, 'RU', 'RUS', 'الإتحاد الروسي'),
(27612, 1539552256, 1539552767, 'RO', 'ROM', 'رومانيا'),
(27613, 1539552768, 1539553279, 'GB', 'GBR', 'المملكة المتحدة'),
(27614, 1539553280, 1539553791, 'UA', 'UKR', 'أوكرانيا'),
(27615, 1539553792, 1539554303, 'GB', 'GBR', 'المملكة المتحدة'),
(27616, 1539554304, 1539554815, 'CH', 'CHE', 'سويسرا'),
(27617, 1539554816, 1539555327, 'PL', 'POL', 'بولندا'),
(27618, 1539555328, 1539555839, 'GB', 'GBR', 'المملكة المتحدة'),
(27619, 1539555840, 1539556863, 'RO', 'ROM', 'رومانيا'),
(27620, 1539556864, 1539557375, 'AT', 'AUT', 'النمسا'),
(27621, 1539557376, 1539557887, 'NL', 'NLD', 'هولندا'),
(27622, 1539557888, 1539558399, 'CZ', 'CZE', 'التشيك'),
(27623, 1539558400, 1539558911, 'RU', 'RUS', 'الإتحاد الروسي'),
(27624, 1539558912, 1539559423, 'FR', 'FRA', 'فرنسا'),
(27625, 1539559424, 1539560447, 'RU', 'RUS', 'الإتحاد الروسي'),
(27626, 1539560448, 1539560959, 'GB', 'GBR', 'المملكة المتحدة'),
(27627, 1539560960, 1539561471, 'UA', 'UKR', 'أوكرانيا'),
(27628, 1539561472, 1539561983, 'RO', 'ROM', 'رومانيا'),
(27629, 1539561984, 1539563007, 'DE', 'DEU', 'ألمانيا'),
(27630, 1539563008, 1539563519, 'RU', 'RUS', 'الإتحاد الروسي'),
(27631, 1539563520, 1539564031, 'SE', 'SWE', 'السويد'),
(27632, 1539564032, 1539564543, 'KZ', 'KAZ', 'كازاخستان'),
(27633, 1539564544, 1539565055, 'GB', 'GBR', 'المملكة المتحدة'),
(27634, 1539565056, 1539565567, 'UA', 'UKR', 'أوكرانيا'),
(27635, 1539565568, 1539566079, 'PL', 'POL', 'بولندا'),
(27636, 1539566080, 1539567103, 'NL', 'NLD', 'هولندا'),
(27637, 1539567104, 1539567615, 'CH', 'CHE', 'سويسرا'),
(27638, 1539567616, 1539568127, 'DE', 'DEU', 'ألمانيا'),
(27639, 1539568128, 1539568639, 'NL', 'NLD', 'هولندا'),
(27640, 1539568640, 1539569151, 'UA', 'UKR', 'أوكرانيا'),
(27641, 1539569152, 1539569663, 'EE', 'EST', 'إستونيا'),
(27642, 1539569664, 1539570175, 'UA', 'UKR', 'أوكرانيا'),
(27643, 1539570176, 1539570687, 'PL', 'POL', 'بولندا'),
(27644, 1539570688, 1539571711, 'RU', 'RUS', 'الإتحاد الروسي'),
(27645, 1539571712, 1539572735, 'UA', 'UKR', 'أوكرانيا'),
(27646, 1539572736, 1539573759, 'RU', 'RUS', 'الإتحاد الروسي'),
(27647, 1539573760, 1539575807, 'PL', 'POL', 'بولندا'),
(27648, 1539575808, 1539576831, 'LV', 'LVA', 'لاتفيا'),
(27649, 1539576832, 1539577855, 'GB', 'GBR', 'المملكة المتحدة'),
(27650, 1539577856, 1539578879, 'RU', 'RUS', 'الإتحاد الروسي'),
(27651, 1539578880, 1539579903, 'PL', 'POL', 'بولندا'),
(27652, 1539579904, 1539580927, 'RU', 'RUS', 'الإتحاد الروسي'),
(27653, 1539580928, 1539581951, 'AM', 'ARM', 'أرمينيا'),
(27654, 1539581952, 1539582975, 'RU', 'RUS', 'الإتحاد الروسي'),
(27655, 1539582976, 1539583999, 'RO', 'ROM', 'رومانيا'),
(27656, 1539584000, 1539585023, 'PL', 'POL', 'بولندا'),
(27657, 1539585024, 1539586047, 'UA', 'UKR', 'أوكرانيا'),
(27658, 1539586048, 1539587071, 'PL', 'POL', 'بولندا'),
(27659, 1539587072, 1539588095, 'UA', 'UKR', 'أوكرانيا'),
(27660, 1539588096, 1539589119, 'BG', 'BGR', 'بلغاريا'),
(27661, 1539589120, 1539590143, 'GB', 'GBR', 'المملكة المتحدة'),
(27662, 1539590144, 1539591167, 'RU', 'RUS', 'الإتحاد الروسي'),
(27663, 1539591168, 1539592191, 'UZ', 'UZB', 'أوزباكستان'),
(27664, 1539592192, 1539593215, 'UA', 'UKR', 'أوكرانيا'),
(27665, 1539593216, 1539594239, 'IL', 'ISR', 'إسرائيل'),
(27666, 1539594240, 1539598335, 'UA', 'UKR', 'أوكرانيا'),
(27667, 1539598336, 1539599359, 'NL', 'NLD', 'هولندا'),
(27668, 1539599360, 1539600383, 'PL', 'POL', 'بولندا'),
(27669, 1539600384, 1539601407, 'HU', 'HUN', 'هنغاريا'),
(27670, 1539601408, 1539602431, 'DE', 'DEU', 'ألمانيا'),
(27671, 1539602432, 1539603455, 'UA', 'UKR', 'أوكرانيا'),
(27672, 1539603456, 1539604479, 'BG', 'BGR', 'بلغاريا'),
(27673, 1539604480, 1539605503, 'ES', 'ESP', 'إسبانيا'),
(27674, 1539605504, 1539606527, 'UA', 'UKR', 'أوكرانيا'),
(27675, 1539606528, 1539607551, 'RU', 'RUS', 'الإتحاد الروسي'),
(27676, 1539607552, 1539609599, 'DE', 'DEU', 'ألمانيا'),
(27677, 1539609600, 1539610623, 'UA', 'UKR', 'أوكرانيا'),
(27678, 1539610624, 1539611647, 'RU', 'RUS', 'الإتحاد الروسي'),
(27679, 1539611648, 1539614719, 'UA', 'UKR', 'أوكرانيا'),
(27680, 1539614720, 1539615743, 'NL', 'NLD', 'هولندا'),
(27681, 1539615744, 1539616767, 'DK', 'DNK', 'الدنيمارك'),
(27682, 1539616768, 1539617791, 'UA', 'UKR', 'أوكرانيا'),
(27683, 1539617792, 1539618815, 'FR', 'FRA', 'فرنسا'),
(27684, 1539618816, 1539619839, 'GB', 'GBR', 'المملكة المتحدة'),
(27685, 1539619840, 1539620863, 'RU', 'RUS', 'الإتحاد الروسي'),
(27686, 1539620864, 1539623935, 'UA', 'UKR', 'أوكرانيا'),
(27687, 1539623936, 1539624959, 'DE', 'DEU', 'ألمانيا'),
(27688, 1539624960, 1539625983, 'RU', 'RUS', 'الإتحاد الروسي'),
(27689, 1539625984, 1539627007, 'PL', 'POL', 'بولندا'),
(27690, 1539627008, 1539628031, 'RU', 'RUS', 'الإتحاد الروسي'),
(27691, 1539628032, 1539629055, 'UA', 'UKR', 'أوكرانيا'),
(27692, 1539629056, 1539630079, 'BG', 'BGR', 'بلغاريا'),
(27693, 1539630080, 1539631103, 'UA', 'UKR', 'أوكرانيا'),
(27694, 1539631104, 1539632127, 'CN', 'CHN', 'الصين'),
(27695, 1539632128, 1539633151, 'RU', 'RUS', 'الإتحاد الروسي'),
(27696, 1539633152, 1539634175, 'SE', 'SWE', 'السويد'),
(27697, 1539634176, 1539638271, 'RU', 'RUS', 'الإتحاد الروسي'),
(27698, 1539638272, 1539639295, 'UA', 'UKR', 'أوكرانيا'),
(27699, 1539639296, 1539640319, 'RU', 'RUS', 'الإتحاد الروسي'),
(27700, 1539640320, 1539641343, 'PL', 'POL', 'بولندا'),
(27701, 1539641344, 1539642367, 'UA', 'UKR', 'أوكرانيا'),
(27702, 1539642368, 1539643391, 'RU', 'RUS', 'الإتحاد الروسي'),
(27703, 1539643392, 1539644415, 'UA', 'UKR', 'أوكرانيا'),
(27704, 1539644416, 1539645439, 'DE', 'DEU', 'ألمانيا'),
(27705, 1539645440, 1539646463, 'GB', 'GBR', 'المملكة المتحدة'),
(27706, 1539646464, 1539647487, 'IE', 'IRL', 'إيرلندا'),
(27707, 1539647488, 1539648511, 'RU', 'RUS', 'الإتحاد الروسي'),
(27708, 1539648512, 1539650559, 'UA', 'UKR', 'أوكرانيا'),
(27709, 1539650560, 1539651583, 'RU', 'RUS', 'الإتحاد الروسي'),
(27710, 1539651584, 1539652607, 'UA', 'UKR', 'أوكرانيا'),
(27711, 1539652608, 1539653631, 'IL', 'ISR', 'إسرائيل'),
(27712, 1539653632, 1539655679, 'RU', 'RUS', 'الإتحاد الروسي'),
(27713, 1539655680, 1539656703, 'NL', 'NLD', 'هولندا'),
(27714, 1539656704, 1539657727, 'RU', 'RUS', 'الإتحاد الروسي'),
(27715, 1539657728, 1539658751, 'UA', 'UKR', 'أوكرانيا'),
(27716, 1539658752, 1539659775, 'FI', 'FIN', 'فنلندا'),
(27717, 1539659776, 1539660799, 'PL', 'POL', 'بولندا'),
(27718, 1539660800, 1539661823, 'GB', 'GBR', 'المملكة المتحدة'),
(27719, 1539661824, 1539662847, 'RU', 'RUS', 'الإتحاد الروسي'),
(27720, 1539662848, 1539663871, 'IL', 'ISR', 'إسرائيل'),
(27721, 1539663872, 1539664895, 'RU', 'RUS', 'الإتحاد الروسي'),
(27722, 1539664896, 1539665919, 'BE', 'BEL', 'بلجيكا'),
(27723, 1539665920, 1539666943, 'RU', 'RUS', 'الإتحاد الروسي'),
(27724, 1539666944, 1539667967, 'CZ', 'CZE', 'التشيك'),
(27725, 1539667968, 1539668991, 'UA', 'UKR', 'أوكرانيا'),
(27726, 1539668992, 1539670015, 'RU', 'RUS', 'الإتحاد الروسي'),
(27727, 1539670016, 1539672063, 'UA', 'UKR', 'أوكرانيا'),
(27728, 1539672064, 1539673087, 'FR', 'FRA', 'فرنسا'),
(27729, 1539673088, 1539674111, 'GB', 'GBR', 'المملكة المتحدة'),
(27730, 1539674112, 1539675135, 'UA', 'UKR', 'أوكرانيا'),
(27731, 1539675136, 1539677183, 'PL', 'POL', 'بولندا'),
(27732, 1539677184, 1539678207, 'UA', 'UKR', 'أوكرانيا'),
(27733, 1539678208, 1539679231, 'RU', 'RUS', 'الإتحاد الروسي'),
(27734, 1539679232, 1539680255, 'FR', 'FRA', 'فرنسا'),
(27735, 1539680256, 1539681279, 'UA', 'UKR', 'أوكرانيا'),
(27736, 1539681280, 1539684351, 'RU', 'RUS', 'الإتحاد الروسي'),
(27737, 1539684352, 1539685375, 'UA', 'UKR', 'أوكرانيا'),
(27738, 1539685376, 1539688447, 'RU', 'RUS', 'الإتحاد الروسي'),
(27739, 1539688448, 1539689471, 'SA', 'SAU', 'السعودية'),
(27740, 1539689472, 1539690495, 'RU', 'RUS', 'الإتحاد الروسي'),
(27741, 1539690496, 1539691519, 'FI', 'FIN', 'فنلندا'),
(27742, 1539691520, 1539692543, 'RU', 'RUS', 'الإتحاد الروسي'),
(27743, 1539692544, 1539694591, 'UA', 'UKR', 'أوكرانيا'),
(27744, 1539694592, 1539695615, 'PL', 'POL', 'بولندا'),
(27745, 1539695616, 1539696639, 'GB', 'GBR', 'المملكة المتحدة'),
(27746, 1539696640, 1539697663, 'RU', 'RUS', 'الإتحاد الروسي'),
(27747, 1539697664, 1539698687, 'UA', 'UKR', 'أوكرانيا'),
(27748, 1539698688, 1539699711, 'GE', 'GEO', 'جورجيا'),
(27749, 1539699712, 1539700735, 'RO', 'ROM', 'رومانيا'),
(27750, 1539700736, 1539701759, 'DK', 'DNK', 'الدنيمارك'),
(27751, 1539701760, 1539702783, 'UA', 'UKR', 'أوكرانيا'),
(27752, 1539702784, 1539703039, 'SI', 'SVN', 'سلوفينيا'),
(27753, 1539703040, 1539703295, 'UA', 'UKR', 'أوكرانيا'),
(27754, 1539703296, 1539703551, 'DE', 'DEU', 'ألمانيا'),
(27755, 1539703552, 1539703807, 'GB', 'GBR', 'المملكة المتحدة'),
(27756, 1539704064, 1539704319, 'IL', 'ISR', 'إسرائيل'),
(27757, 1539704320, 1539704575, 'CH', 'CHE', 'سويسرا'),
(27758, 1539704576, 1539704831, 'HU', 'HUN', 'هنغاريا'),
(27759, 1539704832, 1539705087, 'CH', 'CHE', 'سويسرا'),
(27760, 1539705088, 1539705343, 'GB', 'GBR', 'المملكة المتحدة'),
(27761, 1539705344, 1539705599, 'UA', 'UKR', 'أوكرانيا'),
(27762, 1539705600, 1539706111, 'CH', 'CHE', 'سويسرا'),
(27763, 1539706112, 1539706367, 'GB', 'GBR', 'المملكة المتحدة'),
(27764, 1539706368, 1539706623, 'RU', 'RUS', 'الإتحاد الروسي'),
(27765, 1539706624, 1539707135, 'PL', 'POL', 'بولندا'),
(27766, 1539707136, 1539707391, 'LT', 'LTU', 'ليتوانيا'),
(27767, 1539707392, 1539707647, 'GB', 'GBR', 'المملكة المتحدة'),
(27768, 1539707648, 1539707903, 'RO', 'ROM', 'رومانيا'),
(27769, 1539707904, 1539708159, 'UA', 'UKR', 'أوكرانيا'),
(27770, 1539708160, 1539708415, 'DE', 'DEU', 'ألمانيا'),
(27771, 1539708416, 1539708671, 'GB', 'GBR', 'المملكة المتحدة'),
(27772, 1539708672, 1539708927, 'RO', 'ROM', 'رومانيا'),
(27773, 1539708928, 1539709183, 'IE', 'IRL', 'إيرلندا'),
(27774, 1539709184, 1539709439, 'AT', 'AUT', 'النمسا'),
(27775, 1539709440, 1539709695, 'BE', 'BEL', 'بلجيكا'),
(27776, 1539709696, 1539709951, 'NL', 'NLD', 'هولندا'),
(27777, 1539709952, 1539710207, 'DE', 'DEU', 'ألمانيا'),
(27778, 1539710208, 1539710463, 'GB', 'GBR', 'المملكة المتحدة'),
(27779, 1539710464, 1539710719, 'FR', 'FRA', 'فرنسا'),
(27780, 1539710720, 1539710975, 'UA', 'UKR', 'أوكرانيا'),
(27781, 1539710976, 1539711231, 'DE', 'DEU', 'ألمانيا'),
(27782, 1539711232, 1539711487, 'RU', 'RUS', 'الإتحاد الروسي'),
(27783, 1539711488, 1539711743, 'UA', 'UKR', 'أوكرانيا'),
(27784, 1539711744, 1539711999, 'DE', 'DEU', 'ألمانيا'),
(27785, 1539712000, 1539712255, 'UA', 'UKR', 'أوكرانيا'),
(27786, 1539712256, 1539712511, 'NL', 'NLD', 'هولندا'),
(27787, 1539712512, 1539712767, 'RU', 'RUS', 'الإتحاد الروسي'),
(27788, 1539712768, 1539713023, 'RO', 'ROM', 'رومانيا'),
(27789, 1539713024, 1539713279, 'UA', 'UKR', 'أوكرانيا'),
(27790, 1539713280, 1539713535, 'FR', 'FRA', 'فرنسا'),
(27791, 1539713536, 1539713791, 'DK', 'DNK', 'الدنيمارك'),
(27792, 1539713792, 1539714047, 'DE', 'DEU', 'ألمانيا'),
(27793, 1539714048, 1539714303, 'FR', 'FRA', 'فرنسا'),
(27794, 1539714304, 1539714559, 'AT', 'AUT', 'النمسا'),
(27795, 1539714560, 1539714815, 'RU', 'RUS', 'الإتحاد الروسي'),
(27796, 1539714816, 1539715071, 'PT', 'PRT', 'البورتوغال'),
(27797, 1539715072, 1539715327, 'SE', 'SWE', 'السويد'),
(27798, 1539715328, 1539715583, 'TR', 'TUR', 'تركيا'),
(27799, 1539715584, 1539715839, 'UA', 'UKR', 'أوكرانيا'),
(27800, 1539715840, 1539716095, 'RU', 'RUS', 'الإتحاد الروسي'),
(27801, 1539716096, 1539716351, 'SI', 'SVN', 'سلوفينيا'),
(27802, 1539716352, 1539716607, 'PL', 'POL', 'بولندا'),
(27803, 1539716608, 1539716863, 'RU', 'RUS', 'الإتحاد الروسي'),
(27804, 1539716864, 1539717375, 'PL', 'POL', 'بولندا'),
(27805, 1539717376, 1539717631, 'DE', 'DEU', 'ألمانيا'),
(27806, 1539717632, 1539717887, 'CH', 'CHE', 'سويسرا'),
(27807, 1539717888, 1539718143, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(27808, 1539718144, 1539718399, 'DE', 'DEU', 'ألمانيا'),
(27809, 1539718400, 1539718655, 'TR', 'TUR', 'تركيا'),
(27810, 1539718656, 1539718911, 'SA', 'SAU', 'السعودية'),
(27811, 1539718912, 1539719167, 'KZ', 'KAZ', 'كازاخستان'),
(27812, 1539719168, 1539719423, 'IE', 'IRL', 'إيرلندا'),
(27813, 1539719424, 1539719679, 'PL', 'POL', 'بولندا'),
(27814, 1539719680, 1539719935, 'IE', 'IRL', 'إيرلندا'),
(27815, 1539719936, 1539720191, 'DE', 'DEU', 'ألمانيا'),
(27816, 1539720192, 1539720703, 'RU', 'RUS', 'الإتحاد الروسي'),
(27817, 1539720704, 1539720959, 'IL', 'ISR', 'إسرائيل'),
(27818, 1539720960, 1539721215, 'RU', 'RUS', 'الإتحاد الروسي'),
(27819, 1539721216, 1539721727, 'CH', 'CHE', 'سويسرا'),
(27820, 1539721728, 1539721983, 'PL', 'POL', 'بولندا'),
(27821, 1539721984, 1539722239, 'RU', 'RUS', 'الإتحاد الروسي'),
(27822, 1539722240, 1539722495, 'PL', 'POL', 'بولندا'),
(27823, 1539722496, 1539722751, 'GB', 'GBR', 'المملكة المتحدة'),
(27824, 1539722752, 1539723007, 'DE', 'DEU', 'ألمانيا'),
(27825, 1539723008, 1539723263, 'CH', 'CHE', 'سويسرا'),
(27826, 1539723264, 1539723519, 'PL', 'POL', 'بولندا'),
(27827, 1539723520, 1539723775, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(27828, 1539723776, 1539724031, 'DE', 'DEU', 'ألمانيا'),
(27829, 1539724032, 1539724287, 'UA', 'UKR', 'أوكرانيا'),
(27830, 1539724288, 1539724543, 'IT', 'ITA', 'إيطاليا'),
(27831, 1539724544, 1539724799, 'RU', 'RUS', 'الإتحاد الروسي'),
(27832, 1539724800, 1539725055, 'UA', 'UKR', 'أوكرانيا'),
(27833, 1539725056, 1539725311, 'NL', 'NLD', 'هولندا'),
(27834, 1539725312, 1539725567, 'FR', 'FRA', 'فرنسا'),
(27835, 1539725568, 1539725823, 'PL', 'POL', 'بولندا'),
(27836, 1539725824, 1539726079, 'PT', 'PRT', 'البورتوغال'),
(27837, 1539726080, 1539726335, 'RU', 'RUS', 'الإتحاد الروسي'),
(27838, 1539726336, 1539726591, 'SE', 'SWE', 'السويد'),
(27839, 1539726592, 1539726847, 'AT', 'AUT', 'النمسا'),
(27840, 1539726848, 1539727103, 'PL', 'POL', 'بولندا'),
(27841, 1539727104, 1539727359, 'SE', 'SWE', 'السويد'),
(27842, 1539727360, 1539727615, 'SI', 'SVN', 'سلوفينيا'),
(27843, 1539727616, 1539727871, 'PL', 'POL', 'بولندا'),
(27844, 1539727872, 1539728127, 'RU', 'RUS', 'الإتحاد الروسي'),
(27845, 1539728128, 1539728383, 'GB', 'GBR', 'المملكة المتحدة'),
(27846, 1539728384, 1539728639, 'PL', 'POL', 'بولندا'),
(27847, 1539728640, 1539728895, 'UA', 'UKR', 'أوكرانيا'),
(27848, 1539728896, 1539729151, 'SA', 'SAU', 'السعودية'),
(27849, 1539729152, 1539729407, 'NL', 'NLD', 'هولندا'),
(27850, 1539729408, 1539729663, 'RU', 'RUS', 'الإتحاد الروسي'),
(27851, 1539729664, 1539729919, 'FR', 'FRA', 'فرنسا'),
(27852, 1539729920, 1539730175, 'NL', 'NLD', 'هولندا'),
(27853, 1539730176, 1539730431, 'GB', 'GBR', 'المملكة المتحدة'),
(27854, 1539730432, 1539730687, 'GR', 'GRC', 'اليونان'),
(27855, 1539730688, 1539730943, 'KZ', 'KAZ', 'كازاخستان'),
(27856, 1539730944, 1539731455, 'PL', 'POL', 'بولندا'),
(27857, 1539731456, 1539731711, 'SI', 'SVN', 'سلوفينيا'),
(27858, 1539731712, 1539732223, 'DE', 'DEU', 'ألمانيا'),
(27859, 1539732224, 1539732479, 'FR', 'FRA', 'فرنسا'),
(27860, 1539732480, 1539732735, 'UA', 'UKR', 'أوكرانيا'),
(27861, 1539732736, 1539732991, 'DK', 'DNK', 'الدنيمارك'),
(27862, 1539732992, 1539733247, 'PL', 'POL', 'بولندا'),
(27863, 1539733248, 1539733503, 'BG', 'BGR', 'بلغاريا'),
(27864, 1539733504, 1539733759, 'FI', 'FIN', 'فنلندا'),
(27865, 1539733760, 1539734015, 'PL', 'POL', 'بولندا'),
(27866, 1539734016, 1539734271, 'FR', 'FRA', 'فرنسا'),
(27867, 1539734272, 1539734527, 'NO', 'NOR', 'النرويج'),
(27868, 1539734528, 1539734783, 'TR', 'TUR', 'تركيا'),
(27869, 1539734784, 1539735039, 'DE', 'DEU', 'ألمانيا'),
(27870, 1539735040, 1539735295, 'BE', 'BEL', 'بلجيكا'),
(27871, 1539735296, 1539735551, 'RU', 'RUS', 'الإتحاد الروسي'),
(27872, 1539735552, 1539735807, 'AT', 'AUT', 'النمسا'),
(27873, 1539735808, 1539736063, 'IL', 'ISR', 'إسرائيل'),
(27874, 1539736064, 1539736319, 'RU', 'RUS', 'الإتحاد الروسي'),
(27875, 1539736320, 1539736575, 'HU', 'HUN', 'هنغاريا'),
(27876, 1539736576, 1539736831, 'BG', 'BGR', 'بلغاريا'),
(27877, 1539736832, 1539737087, 'UA', 'UKR', 'أوكرانيا'),
(27878, 1539737088, 1539737343, 'KW', 'KWT', 'الكويت'),
(27879, 1539737344, 1539737599, 'RU', 'RUS', 'الإتحاد الروسي'),
(27880, 1539737600, 1539737855, 'RO', 'ROM', 'رومانيا'),
(27881, 1539737856, 1539738111, 'RU', 'RUS', 'الإتحاد الروسي'),
(27882, 1539738112, 1539738367, 'DK', 'DNK', 'الدنيمارك'),
(27883, 1539738368, 1539738623, 'DE', 'DEU', 'ألمانيا'),
(27884, 1539738624, 1539738879, 'UA', 'UKR', 'أوكرانيا'),
(27885, 1539738880, 1539739135, 'NL', 'NLD', 'هولندا'),
(27886, 1539739136, 1539739391, 'AT', 'AUT', 'النمسا'),
(27887, 1539739392, 1539739647, 'UA', 'UKR', 'أوكرانيا'),
(27888, 1539739648, 1539739903, 'DK', 'DNK', 'الدنيمارك'),
(27889, 1539739904, 1539740415, 'PL', 'POL', 'بولندا'),
(27890, 1539740416, 1539740671, 'RO', 'ROM', 'رومانيا'),
(27891, 1539740672, 1539740927, 'AT', 'AUT', 'النمسا'),
(27892, 1539740928, 1539741183, 'RU', 'RUS', 'الإتحاد الروسي'),
(27893, 1539741184, 1539741439, 'PL', 'POL', 'بولندا'),
(27894, 1539741440, 1539741695, 'NL', 'NLD', 'هولندا'),
(27895, 1539741696, 1539741951, 'DE', 'DEU', 'ألمانيا'),
(27896, 1539741952, 1539742207, 'UA', 'UKR', 'أوكرانيا'),
(27897, 1539742208, 1539742463, 'CH', 'CHE', 'سويسرا'),
(27898, 1539742464, 1539742719, 'RU', 'RUS', 'الإتحاد الروسي'),
(27899, 1539742720, 1539742975, 'LV', 'LVA', 'لاتفيا'),
(27900, 1539742976, 1539743231, 'DE', 'DEU', 'ألمانيا'),
(27901, 1539743232, 1539743487, 'GR', 'GRC', 'اليونان'),
(27902, 1539743488, 1539743743, 'FR', 'FRA', 'فرنسا'),
(27903, 1539743744, 1539743999, 'RO', 'ROM', 'رومانيا'),
(27904, 1539744000, 1539744255, 'HR', 'HRV', 'كرواتيا'),
(27905, 1539744256, 1539744511, 'RO', 'ROM', 'رومانيا'),
(27906, 1539744512, 1539744767, 'DE', 'DEU', 'ألمانيا'),
(27907, 1539744768, 1539745023, 'SE', 'SWE', 'السويد'),
(27908, 1539745024, 1539745535, 'GB', 'GBR', 'المملكة المتحدة'),
(27909, 1539745536, 1539745791, 'CH', 'CHE', 'سويسرا'),
(27910, 1539745792, 1539746303, 'DK', 'DNK', 'الدنيمارك'),
(27911, 1539746304, 1539746815, 'RU', 'RUS', 'الإتحاد الروسي'),
(27912, 1539746816, 1539747071, 'DK', 'DNK', 'الدنيمارك'),
(27913, 1539747072, 1539747327, 'CH', 'CHE', 'سويسرا'),
(27914, 1539747328, 1539747583, 'NL', 'NLD', 'هولندا'),
(27915, 1539747584, 1539747839, 'UA', 'UKR', 'أوكرانيا'),
(27916, 1539747840, 1539748095, 'NO', 'NOR', 'النرويج'),
(27917, 1539748096, 1539748351, 'PL', 'POL', 'بولندا'),
(27918, 1539748352, 1539748607, 'NL', 'NLD', 'هولندا'),
(27919, 1539748608, 1539748863, 'PL', 'POL', 'بولندا'),
(27920, 1539748864, 1539749119, 'GB', 'GBR', 'المملكة المتحدة'),
(27921, 1539749120, 1539749375, 'BG', 'BGR', 'بلغاريا'),
(27922, 1539749376, 1539749631, 'PT', 'PRT', 'البورتوغال'),
(27923, 1539749632, 1539749887, 'GR', 'GRC', 'اليونان'),
(27924, 1539749888, 1539750143, 'RU', 'RUS', 'الإتحاد الروسي'),
(27925, 1539750144, 1539750399, 'TR', 'TUR', 'تركيا'),
(27926, 1539750400, 1539750655, 'PL', 'POL', 'بولندا'),
(27927, 1539750656, 1539750911, 'DE', 'DEU', 'ألمانيا'),
(27928, 1539750912, 1539751167, 'UA', 'UKR', 'أوكرانيا'),
(27929, 1539751168, 1539751423, 'TR', 'TUR', 'تركيا'),
(27930, 1539751424, 1539751679, 'SI', 'SVN', 'سلوفينيا'),
(27931, 1539751680, 1539751935, 'FR', 'FRA', 'فرنسا'),
(27932, 1539751936, 1539752191, 'DE', 'DEU', 'ألمانيا'),
(27933, 1539752192, 1539752447, 'SE', 'SWE', 'السويد'),
(27934, 1539752448, 1539752703, 'PL', 'POL', 'بولندا'),
(27935, 1539752704, 1539752959, 'AT', 'AUT', 'النمسا'),
(27936, 1539752960, 1539753215, 'RO', 'ROM', 'رومانيا'),
(27937, 1539753216, 1539753471, 'DE', 'DEU', 'ألمانيا'),
(27938, 1539753472, 1539753727, 'HU', 'HUN', 'هنغاريا'),
(27939, 1539753728, 1539754239, 'FR', 'FRA', 'فرنسا'),
(27940, 1539754240, 1539754495, 'NO', 'NOR', 'النرويج'),
(27941, 1539754496, 1539754751, 'SE', 'SWE', 'السويد'),
(27942, 1539754752, 1539755007, 'BE', 'BEL', 'بلجيكا'),
(27943, 1539755008, 1539755263, 'DK', 'DNK', 'الدنيمارك'),
(27944, 1539755264, 1539755519, 'IL', 'ISR', 'إسرائيل'),
(27945, 1539755520, 1539755775, 'EE', 'EST', 'إستونيا'),
(27946, 1539755776, 1539756031, 'MT', 'MLT', 'مالطا'),
(27947, 1539756032, 1539756543, 'PL', 'POL', 'بولندا'),
(27948, 1539756544, 1539756799, 'DE', 'DEU', 'ألمانيا'),
(27949, 1539756800, 1539757055, 'BE', 'BEL', 'بلجيكا'),
(27950, 1539757056, 1539757311, 'RU', 'RUS', 'الإتحاد الروسي'),
(27951, 1539757312, 1539757567, 'GB', 'GBR', 'المملكة المتحدة'),
(27952, 1539757568, 1539757823, 'SI', 'SVN', 'سلوفينيا'),
(27953, 1539757824, 1539758079, 'UA', 'UKR', 'أوكرانيا'),
(27954, 1539758080, 1539758335, 'HR', 'HRV', 'كرواتيا'),
(27955, 1539758336, 1539758591, 'DE', 'DEU', 'ألمانيا'),
(27956, 1539758592, 1539758847, 'NL', 'NLD', 'هولندا'),
(27957, 1539758848, 1539759103, 'BA', 'BIH', 'البوسنه والهرسك'),
(27958, 1539759104, 1539759359, 'DK', 'DNK', 'الدنيمارك'),
(27959, 1539759360, 1539759615, 'RU', 'RUS', 'الإتحاد الروسي'),
(27960, 1539759616, 1539759871, 'PL', 'POL', 'بولندا'),
(27961, 1539759872, 1539760127, 'SE', 'SWE', 'السويد'),
(27962, 1539760128, 1539760383, 'DE', 'DEU', 'ألمانيا'),
(27963, 1539760384, 1539760639, 'RU', 'RUS', 'الإتحاد الروسي'),
(27964, 1539760640, 1539760895, 'PL', 'POL', 'بولندا'),
(27965, 1539760896, 1539761151, 'DK', 'DNK', 'الدنيمارك'),
(27966, 1539761152, 1539761407, 'DE', 'DEU', 'ألمانيا'),
(27967, 1539761408, 1539761663, 'CH', 'CHE', 'سويسرا'),
(27968, 1539761664, 1539761919, 'PL', 'POL', 'بولندا'),
(27969, 1539761920, 1539762175, 'RU', 'RUS', 'الإتحاد الروسي'),
(27970, 1539762176, 1539762431, 'PL', 'POL', 'بولندا'),
(27971, 1539762432, 1539762687, 'UA', 'UKR', 'أوكرانيا'),
(27972, 1539762944, 1539763199, 'UA', 'UKR', 'أوكرانيا'),
(27973, 1539763200, 1539763455, 'MD', 'MDA', 'مولدوفا'),
(27974, 1539763456, 1539763711, 'DK', 'DNK', 'الدنيمارك'),
(27975, 1539763712, 1539763967, 'DE', 'DEU', 'ألمانيا'),
(27976, 1539763968, 1539764223, 'PT', 'PRT', 'البورتوغال'),
(27977, 1539764224, 1539764479, 'AT', 'AUT', 'النمسا'),
(27978, 1539764480, 1539764735, 'GB', 'GBR', 'المملكة المتحدة'),
(27979, 1539764736, 1539764991, 'RO', 'ROM', 'رومانيا'),
(27980, 1539764992, 1539765247, 'BE', 'BEL', 'بلجيكا'),
(27981, 1539765248, 1539765503, 'GB', 'GBR', 'المملكة المتحدة'),
(27982, 1539765504, 1539766015, 'PL', 'POL', 'بولندا'),
(27983, 1539766016, 1539766271, 'AM', 'ARM', 'أرمينيا'),
(27984, 1539766272, 1539766527, 'PL', 'POL', 'بولندا'),
(27985, 1539766528, 1539766783, 'UA', 'UKR', 'أوكرانيا'),
(27986, 1539766784, 1539767039, 'DE', 'DEU', 'ألمانيا'),
(27987, 1539767040, 1539767295, 'SA', 'SAU', 'السعودية'),
(27988, 1539767296, 1539767551, 'DK', 'DNK', 'الدنيمارك'),
(27989, 1539767552, 1539767807, 'DE', 'DEU', 'ألمانيا'),
(27990, 1539767808, 1539768063, 'IL', 'ISR', 'إسرائيل'),
(27991, 1539768064, 1539768319, 'GB', 'GBR', 'المملكة المتحدة'),
(27992, 1539768320, 1539768575, 'FR', 'FRA', 'فرنسا'),
(27993, 1539768576, 1539768831, 'GB', 'GBR', 'المملكة المتحدة'),
(27994, 1539768832, 1539769087, 'IT', 'ITA', 'إيطاليا'),
(27995, 1539769088, 1539769599, 'BE', 'BEL', 'بلجيكا'),
(27996, 1539769600, 1539769855, 'AT', 'AUT', 'النمسا'),
(27997, 1539769856, 1539770111, 'FR', 'FRA', 'فرنسا'),
(27998, 1539770112, 1539770367, 'GR', 'GRC', 'اليونان'),
(27999, 1539770368, 1539770623, 'DE', 'DEU', 'ألمانيا'),
(28000, 1539770624, 1539770879, 'FR', 'FRA', 'فرنسا'),
(28001, 1539770880, 1539771135, 'RU', 'RUS', 'الإتحاد الروسي'),
(28002, 1539771136, 1539771391, 'FR', 'FRA', 'فرنسا'),
(28003, 1539771392, 1539771647, 'PL', 'POL', 'بولندا'),
(28004, 1539771648, 1539771903, 'UA', 'UKR', 'أوكرانيا'),
(28005, 1539771904, 1539772159, 'RU', 'RUS', 'الإتحاد الروسي'),
(28006, 1539772160, 1539772415, 'BE', 'BEL', 'بلجيكا'),
(28007, 1539772416, 1539772671, 'RU', 'RUS', 'الإتحاد الروسي'),
(28008, 1539772672, 1539772927, 'RS', 'SRB', 'صربيا'),
(28009, 1539772928, 1539773183, 'RU', 'RUS', 'الإتحاد الروسي'),
(28010, 1539773184, 1539773439, 'GB', 'GBR', 'المملكة المتحدة'),
(28011, 1539773440, 1539773695, 'KZ', 'KAZ', 'كازاخستان'),
(28012, 1539773696, 1539773951, 'DE', 'DEU', 'ألمانيا'),
(28013, 1539773952, 1539774207, 'PL', 'POL', 'بولندا'),
(28014, 1539774208, 1539774463, 'SI', 'SVN', 'سلوفينيا'),
(28015, 1539774464, 1539774719, 'RU', 'RUS', 'الإتحاد الروسي'),
(28016, 1539774720, 1539774975, 'PL', 'POL', 'بولندا'),
(28017, 1539774976, 1539775231, 'RU', 'RUS', 'الإتحاد الروسي'),
(28018, 1539775232, 1539775487, 'CH', 'CHE', 'سويسرا'),
(28019, 1539775488, 1539775743, 'UA', 'UKR', 'أوكرانيا'),
(28020, 1539775744, 1539775999, 'IL', 'ISR', 'إسرائيل'),
(28021, 1539776000, 1539776255, 'PL', 'POL', 'بولندا'),
(28022, 1539776256, 1539776511, 'SK', 'SVK', 'سلوفاكيا'),
(28023, 1539776512, 1539776767, 'HU', 'HUN', 'هنغاريا'),
(28024, 1539776768, 1539777023, 'UA', 'UKR', 'أوكرانيا'),
(28025, 1539777024, 1539777279, 'RU', 'RUS', 'الإتحاد الروسي'),
(28026, 1539777280, 1539777535, 'UA', 'UKR', 'أوكرانيا'),
(28027, 1539777536, 1539777791, 'BG', 'BGR', 'بلغاريا'),
(28028, 1539777792, 1539778047, 'UA', 'UKR', 'أوكرانيا'),
(28029, 1539778048, 1539778303, 'AM', 'ARM', 'أرمينيا'),
(28030, 1539778304, 1539778559, 'LB', 'LBN', 'لبنان'),
(28031, 1539778560, 1539778815, 'RU', 'RUS', 'الإتحاد الروسي'),
(28032, 1539778816, 1539779071, 'RO', 'ROM', 'رومانيا'),
(28033, 1539779072, 1539779327, 'GB', 'GBR', 'المملكة المتحدة'),
(28034, 1539779328, 1539779583, 'CH', 'CHE', 'سويسرا'),
(28035, 1539779584, 1539779839, 'PL', 'POL', 'بولندا'),
(28036, 1539779840, 1539780095, 'NL', 'NLD', 'هولندا'),
(28037, 1539780096, 1539780351, 'RU', 'RUS', 'الإتحاد الروسي'),
(28038, 1539780352, 1539780607, 'AT', 'AUT', 'النمسا'),
(28039, 1539780608, 1539780863, 'PL', 'POL', 'بولندا'),
(28040, 1539780864, 1539781119, 'RO', 'ROM', 'رومانيا'),
(28041, 1539781120, 1539781375, 'NL', 'NLD', 'هولندا'),
(28042, 1539781632, 1539781887, 'HU', 'HUN', 'هنغاريا'),
(28043, 1539781888, 1539782143, 'IL', 'ISR', 'إسرائيل'),
(28044, 1539782144, 1539782399, 'UA', 'UKR', 'أوكرانيا'),
(28045, 1539782400, 1539782655, 'LT', 'LTU', 'ليتوانيا'),
(28046, 1539782656, 1539782911, 'GI', 'GIB', 'جبل طارق'),
(28047, 1539782912, 1539783167, 'PL', 'POL', 'بولندا'),
(28048, 1539783168, 1539783679, 'NL', 'NLD', 'هولندا'),
(28049, 1539783680, 1539783935, 'DE', 'DEU', 'ألمانيا'),
(28050, 1539783936, 1539784191, 'SI', 'SVN', 'سلوفينيا'),
(28051, 1539784192, 1539784447, 'RU', 'RUS', 'الإتحاد الروسي'),
(28052, 1539784448, 1539784703, 'NO', 'NOR', 'النرويج'),
(28053, 1539784704, 1539784959, 'SE', 'SWE', 'السويد'),
(28054, 1539784960, 1539785215, 'DE', 'DEU', 'ألمانيا'),
(28055, 1539785216, 1539785471, 'CH', 'CHE', 'سويسرا'),
(28056, 1539785472, 1539785727, 'RU', 'RUS', 'الإتحاد الروسي'),
(28057, 1539785728, 1539785983, 'SE', 'SWE', 'السويد'),
(28058, 1539785984, 1539786239, 'IL', 'ISR', 'إسرائيل'),
(28059, 1539786240, 1539786495, 'AT', 'AUT', 'النمسا'),
(28060, 1539786496, 1539786751, 'GB', 'GBR', 'المملكة المتحدة'),
(28061, 1539786752, 1539787007, 'HU', 'HUN', 'هنغاريا'),
(28062, 1539787008, 1539787263, 'TR', 'TUR', 'تركيا'),
(28063, 1539787264, 1539787519, 'IE', 'IRL', 'إيرلندا'),
(28064, 1539787520, 1539787775, 'UA', 'UKR', 'أوكرانيا'),
(28065, 1539787776, 1539788031, 'CH', 'CHE', 'سويسرا'),
(28066, 1539788032, 1539788287, 'HR', 'HRV', 'كرواتيا'),
(28067, 1539788288, 1539788543, 'GB', 'GBR', 'المملكة المتحدة'),
(28068, 1539788544, 1539788799, 'HR', 'HRV', 'كرواتيا'),
(28069, 1539788800, 1539789311, 'RU', 'RUS', 'الإتحاد الروسي'),
(28070, 1539789312, 1539789567, 'UA', 'UKR', 'أوكرانيا'),
(28071, 1539789568, 1539789823, 'DE', 'DEU', 'ألمانيا'),
(28072, 1539789824, 1539790079, 'NL', 'NLD', 'هولندا'),
(28073, 1539790080, 1539790335, 'CH', 'CHE', 'سويسرا'),
(28074, 1539790336, 1539790591, 'EE', 'EST', 'إستونيا'),
(28075, 1539790592, 1539790847, 'PL', 'POL', 'بولندا'),
(28076, 1539790848, 1539791103, 'DE', 'DEU', 'ألمانيا'),
(28077, 1539791104, 1539791359, 'PL', 'POL', 'بولندا'),
(28078, 1539791360, 1539791615, 'RU', 'RUS', 'الإتحاد الروسي'),
(28079, 1539791616, 1539792383, 'UA', 'UKR', 'أوكرانيا'),
(28080, 1539792384, 1539792639, 'IL', 'ISR', 'إسرائيل'),
(28081, 1539792640, 1539792895, 'PL', 'POL', 'بولندا'),
(28082, 1539792896, 1539793151, 'GR', 'GRC', 'اليونان'),
(28083, 1539793152, 1539793407, 'PL', 'POL', 'بولندا'),
(28084, 1539793408, 1539793663, 'CH', 'CHE', 'سويسرا'),
(28085, 1539793664, 1539794175, 'IL', 'ISR', 'إسرائيل'),
(28086, 1539794176, 1539794431, 'PL', 'POL', 'بولندا'),
(28087, 1539794432, 1539794687, 'DK', 'DNK', 'الدنيمارك'),
(28088, 1539794688, 1539794943, 'FR', 'FRA', 'فرنسا'),
(28089, 1539794944, 1539795199, 'RO', 'ROM', 'رومانيا'),
(28090, 1539795200, 1539795455, 'PL', 'POL', 'بولندا'),
(28091, 1539795456, 1539795711, 'UA', 'UKR', 'أوكرانيا'),
(28092, 1539795712, 1539795967, 'SA', 'SAU', 'السعودية'),
(28093, 1539795968, 1539796223, 'NL', 'NLD', 'هولندا'),
(28094, 1539796224, 1539796479, 'MC', 'MCO', 'موناكو'),
(28095, 1539796480, 1539796735, 'GB', 'GBR', 'المملكة المتحدة'),
(28096, 1539796736, 1539796991, 'TR', 'TUR', 'تركيا'),
(28097, 1539796992, 1539797247, 'CY', 'CYP', 'قبرص'),
(28098, 1539797248, 1539797503, 'DK', 'DNK', 'الدنيمارك'),
(28099, 1539797504, 1539797759, 'RU', 'RUS', 'الإتحاد الروسي'),
(28100, 1539797760, 1539798015, 'UA', 'UKR', 'أوكرانيا'),
(28101, 1539798016, 1539798271, 'HU', 'HUN', 'هنغاريا'),
(28102, 1539798272, 1539798527, 'PL', 'POL', 'بولندا'),
(28103, 1539798528, 1539798783, 'GB', 'GBR', 'المملكة المتحدة'),
(28104, 1539798784, 1539799039, 'IL', 'ISR', 'إسرائيل'),
(28105, 1539799040, 1539799295, 'ES', 'ESP', 'إسبانيا'),
(28106, 1539799296, 1539799551, 'DK', 'DNK', 'الدنيمارك'),
(28107, 1539799552, 1539799807, 'ES', 'ESP', 'إسبانيا'),
(28108, 1539799808, 1539800063, 'RO', 'ROM', 'رومانيا'),
(28109, 1539800064, 1539800319, 'SI', 'SVN', 'سلوفينيا'),
(28110, 1539800320, 1539800575, 'GB', 'GBR', 'المملكة المتحدة'),
(28111, 1539800576, 1539800831, 'LV', 'LVA', 'لاتفيا'),
(28112, 1539800832, 1539801087, 'PL', 'POL', 'بولندا'),
(28113, 1539801088, 1539801343, 'BG', 'BGR', 'بلغاريا'),
(28114, 1539801344, 1539801855, 'GB', 'GBR', 'المملكة المتحدة'),
(28115, 1539801856, 1539802111, 'SI', 'SVN', 'سلوفينيا'),
(28116, 1539802112, 1539802367, 'PL', 'POL', 'بولندا'),
(28117, 1539802368, 1539802623, 'RO', 'ROM', 'رومانيا'),
(28118, 1539802624, 1539802879, 'IS', 'ISL', 'أيسلندا'),
(28119, 1539802880, 1539803135, 'NL', 'NLD', 'هولندا'),
(28120, 1539803136, 1539803391, 'GB', 'GBR', 'المملكة المتحدة'),
(28121, 1539803392, 1539803647, 'NL', 'NLD', 'هولندا'),
(28122, 1539803648, 1539804159, 'UA', 'UKR', 'أوكرانيا'),
(28123, 1539804160, 1539804671, 'PL', 'POL', 'بولندا'),
(28124, 1539804672, 1539804927, 'SI', 'SVN', 'سلوفينيا'),
(28125, 1539804928, 1539805439, 'UA', 'UKR', 'أوكرانيا'),
(28126, 1539805440, 1539805695, 'AT', 'AUT', 'النمسا'),
(28127, 1539805696, 1539805951, 'CH', 'CHE', 'سويسرا'),
(28128, 1539805952, 1539806207, 'RU', 'RUS', 'الإتحاد الروسي'),
(28129, 1539806208, 1539806463, 'FI', 'FIN', 'فنلندا'),
(28130, 1539806464, 1539806719, 'RU', 'RUS', 'الإتحاد الروسي'),
(28131, 1539806720, 1539806975, 'BG', 'BGR', 'بلغاريا'),
(28132, 1539806976, 1539807231, 'GB', 'GBR', 'المملكة المتحدة'),
(28133, 1539807232, 1539807487, 'FR', 'FRA', 'فرنسا'),
(28134, 1539807744, 1539807999, 'GB', 'GBR', 'المملكة المتحدة'),
(28135, 1539808000, 1539808255, 'HU', 'HUN', 'هنغاريا'),
(28136, 1539808256, 1539808511, 'RU', 'RUS', 'الإتحاد الروسي'),
(28137, 1539808512, 1539808767, 'RO', 'ROM', 'رومانيا'),
(28138, 1539808768, 1539809023, 'DE', 'DEU', 'ألمانيا'),
(28139, 1539809024, 1539809279, 'GB', 'GBR', 'المملكة المتحدة'),
(28140, 1539809536, 1539809791, 'SI', 'SVN', 'سلوفينيا'),
(28141, 1539809792, 1539810047, 'DE', 'DEU', 'ألمانيا'),
(28142, 1539810048, 1539810303, 'UA', 'UKR', 'أوكرانيا'),
(28143, 1539810304, 1539810559, 'CZ', 'CZE', 'التشيك'),
(28144, 1539810560, 1539810815, 'DE', 'DEU', 'ألمانيا'),
(28145, 1539810816, 1539811071, 'TR', 'TUR', 'تركيا'),
(28146, 1539811072, 1539811327, 'NL', 'NLD', 'هولندا'),
(28147, 1539811328, 1539811583, 'CZ', 'CZE', 'التشيك'),
(28148, 1539811584, 1539811839, 'DE', 'DEU', 'ألمانيا'),
(28149, 1539811840, 1539812095, 'SE', 'SWE', 'السويد'),
(28150, 1539812096, 1539812351, 'RU', 'RUS', 'الإتحاد الروسي'),
(28151, 1539812352, 1539812607, 'CH', 'CHE', 'سويسرا'),
(28152, 1539812608, 1539812863, 'IT', 'ITA', 'إيطاليا'),
(28153, 1539812864, 1539813119, 'SI', 'SVN', 'سلوفينيا'),
(28154, 1539813120, 1539813375, 'AT', 'AUT', 'النمسا'),
(28155, 1539813376, 1539813631, 'PL', 'POL', 'بولندا'),
(28156, 1539813632, 1539813887, 'NL', 'NLD', 'هولندا'),
(28157, 1539813888, 1539814143, 'RU', 'RUS', 'الإتحاد الروسي'),
(28158, 1539814144, 1539814399, 'NL', 'NLD', 'هولندا'),
(28159, 1539814400, 1539814911, 'GB', 'GBR', 'المملكة المتحدة'),
(28160, 1539814912, 1539815167, 'UA', 'UKR', 'أوكرانيا'),
(28161, 1539815168, 1539815423, 'GB', 'GBR', 'المملكة المتحدة'),
(28162, 1539815424, 1539815935, 'RU', 'RUS', 'الإتحاد الروسي'),
(28163, 1539815936, 1539816191, 'CH', 'CHE', 'سويسرا'),
(28164, 1539816192, 1539816447, 'SA', 'SAU', 'السعودية'),
(28165, 1539816448, 1539816703, 'UA', 'UKR', 'أوكرانيا'),
(28166, 1539816704, 1539816959, 'RU', 'RUS', 'الإتحاد الروسي'),
(28167, 1539816960, 1539817215, 'DK', 'DNK', 'الدنيمارك'),
(28168, 1539817216, 1539817471, 'TR', 'TUR', 'تركيا'),
(28169, 1539817472, 1539817727, 'DE', 'DEU', 'ألمانيا'),
(28170, 1539817728, 1539817983, 'PL', 'POL', 'بولندا'),
(28171, 1539817984, 1539818239, 'UA', 'UKR', 'أوكرانيا'),
(28172, 1539818240, 1539818495, 'NO', 'NOR', 'النرويج'),
(28173, 1539818496, 1539819007, 'RU', 'RUS', 'الإتحاد الروسي'),
(28174, 1539819008, 1539819263, 'CH', 'CHE', 'سويسرا'),
(28175, 1539819264, 1539819519, 'RO', 'ROM', 'رومانيا'),
(28176, 1539819520, 1539819775, 'AT', 'AUT', 'النمسا'),
(28177, 1539819776, 1539820031, 'SI', 'SVN', 'سلوفينيا'),
(28178, 1539820032, 1539820287, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(28179, 1539820288, 1539820543, 'PL', 'POL', 'بولندا'),
(28180, 1539820544, 1539820799, 'ES', 'ESP', 'إسبانيا'),
(28181, 1539820800, 1539821055, 'RU', 'RUS', 'الإتحاد الروسي'),
(28182, 1539821056, 1539821311, 'UA', 'UKR', 'أوكرانيا'),
(28183, 1539821312, 1539821567, 'CZ', 'CZE', 'التشيك'),
(28184, 1539821568, 1539821823, 'DK', 'DNK', 'الدنيمارك'),
(28185, 1539821824, 1539822079, 'DE', 'DEU', 'ألمانيا'),
(28186, 1539822080, 1539822335, 'RO', 'ROM', 'رومانيا'),
(28187, 1539822336, 1539822591, 'RU', 'RUS', 'الإتحاد الروسي'),
(28188, 1539822592, 1539822847, 'GB', 'GBR', 'المملكة المتحدة'),
(28189, 1539822848, 1539823103, 'IE', 'IRL', 'إيرلندا'),
(28190, 1539823104, 1539823359, 'DE', 'DEU', 'ألمانيا'),
(28191, 1539823360, 1539823615, 'CY', 'CYP', 'قبرص'),
(28192, 1539823616, 1539823871, 'RO', 'ROM', 'رومانيا'),
(28193, 1539823872, 1539824127, 'DK', 'DNK', 'الدنيمارك'),
(28194, 1539824128, 1539824383, 'CH', 'CHE', 'سويسرا'),
(28195, 1539824384, 1539824639, 'NL', 'NLD', 'هولندا'),
(28196, 1539824640, 1539824895, 'HU', 'HUN', 'هنغاريا'),
(28197, 1539825152, 1539825407, 'UA', 'UKR', 'أوكرانيا'),
(28198, 1539825408, 1539825919, 'RU', 'RUS', 'الإتحاد الروسي'),
(28199, 1539825920, 1539826175, 'DE', 'DEU', 'ألمانيا'),
(28200, 1539826176, 1539826431, 'AM', 'ARM', 'أرمينيا'),
(28201, 1539826432, 1539826687, 'BE', 'BEL', 'بلجيكا'),
(28202, 1539826688, 1539826943, 'CH', 'CHE', 'سويسرا'),
(28203, 1539826944, 1539827199, 'DE', 'DEU', 'ألمانيا'),
(28204, 1539827200, 1539827455, 'RU', 'RUS', 'الإتحاد الروسي'),
(28205, 1539827456, 1539827711, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(28206, 1539827712, 1539827967, 'RU', 'RUS', 'الإتحاد الروسي'),
(28207, 1539827968, 1539828479, 'FR', 'FRA', 'فرنسا'),
(28208, 1539828480, 1539828735, 'SI', 'SVN', 'سلوفينيا'),
(28209, 1539828736, 1539828991, 'NL', 'NLD', 'هولندا'),
(28210, 1539828992, 1539829247, 'BG', 'BGR', 'بلغاريا'),
(28211, 1539829248, 1539829503, 'SE', 'SWE', 'السويد'),
(28212, 1539829504, 1539829759, 'DE', 'DEU', 'ألمانيا'),
(28213, 1539829760, 1539830015, 'PL', 'POL', 'بولندا'),
(28214, 1539830016, 1539830271, 'DE', 'DEU', 'ألمانيا'),
(28215, 1539830272, 1539830527, 'FR', 'FRA', 'فرنسا'),
(28216, 1539830528, 1539830783, 'RO', 'ROM', 'رومانيا'),
(28217, 1539830784, 1539831039, 'RU', 'RUS', 'الإتحاد الروسي'),
(28218, 1539831040, 1539831295, 'UA', 'UKR', 'أوكرانيا'),
(28219, 1539831296, 1539831551, 'PL', 'POL', 'بولندا'),
(28220, 1539831552, 1539831807, 'DE', 'DEU', 'ألمانيا'),
(28221, 1539831808, 1539832063, 'RU', 'RUS', 'الإتحاد الروسي'),
(28222, 1539832064, 1539832319, 'GB', 'GBR', 'المملكة المتحدة'),
(28223, 1539832320, 1539832575, 'PL', 'POL', 'بولندا'),
(28224, 1539832576, 1539832831, 'RU', 'RUS', 'الإتحاد الروسي'),
(28225, 1539832832, 1539833087, 'GB', 'GBR', 'المملكة المتحدة'),
(28226, 1539833088, 1539833343, 'RU', 'RUS', 'الإتحاد الروسي'),
(28227, 1539833344, 1539833855, 'FR', 'FRA', 'فرنسا'),
(28228, 1539833856, 1539837951, 'UA', 'UKR', 'أوكرانيا'),
(28229, 1539837952, 1539838975, 'NL', 'NLD', 'هولندا'),
(28230, 1539838976, 1539839999, 'GR', 'GRC', 'اليونان'),
(28231, 1539840000, 1539841023, 'PL', 'POL', 'بولندا'),
(28232, 1539841024, 1539842047, 'RU', 'RUS', 'الإتحاد الروسي'),
(28233, 1539842048, 1539844095, 'PL', 'POL', 'بولندا'),
(28234, 1539844096, 1539846143, 'UA', 'UKR', 'أوكرانيا'),
(28235, 1539846144, 1539847167, 'NL', 'NLD', 'هولندا'),
(28236, 1539847168, 1539849215, 'UA', 'UKR', 'أوكرانيا'),
(28237, 1539849216, 1539850239, 'RU', 'RUS', 'الإتحاد الروسي'),
(28238, 1539850240, 1539851263, 'LV', 'LVA', 'لاتفيا'),
(28239, 1539851264, 1539852287, 'PL', 'POL', 'بولندا'),
(28240, 1539852288, 1539853311, 'UA', 'UKR', 'أوكرانيا'),
(28241, 1539853312, 1539854335, 'PL', 'POL', 'بولندا'),
(28242, 1539854336, 1539855359, 'UA', 'UKR', 'أوكرانيا'),
(28243, 1539855360, 1539856383, 'RU', 'RUS', 'الإتحاد الروسي'),
(28244, 1539856384, 1539857407, 'UA', 'UKR', 'أوكرانيا'),
(28245, 1539857408, 1539858431, 'PL', 'POL', 'بولندا'),
(28246, 1539858432, 1539859455, 'RO', 'ROM', 'رومانيا'),
(28247, 1539859456, 1539860479, 'DE', 'DEU', 'ألمانيا'),
(28248, 1539860480, 1539861503, 'UA', 'UKR', 'أوكرانيا'),
(28249, 1539861504, 1539862527, 'DE', 'DEU', 'ألمانيا'),
(28250, 1539862528, 1539863551, 'UA', 'UKR', 'أوكرانيا'),
(28251, 1539863552, 1539864575, 'MD', 'MDA', 'مولدوفا'),
(28252, 1539864576, 1539865599, 'RO', 'ROM', 'رومانيا'),
(28253, 1539865600, 1539866623, 'UA', 'UKR', 'أوكرانيا'),
(28254, 1539866624, 1539867647, 'IT', 'ITA', 'إيطاليا'),
(28255, 1539867648, 1539869695, 'UA', 'UKR', 'أوكرانيا'),
(28256, 1539869696, 1539870719, 'ES', 'ESP', 'إسبانيا'),
(28257, 1539870720, 1539871743, 'IL', 'ISR', 'إسرائيل'),
(28258, 1539871744, 1539872767, 'ES', 'ESP', 'إسبانيا'),
(28259, 1539872768, 1539873791, 'SE', 'SWE', 'السويد'),
(28260, 1539873792, 1539875839, 'UA', 'UKR', 'أوكرانيا'),
(28261, 1539875840, 1539876863, 'MD', 'MDA', 'مولدوفا'),
(28262, 1539876864, 1539877887, 'ES', 'ESP', 'إسبانيا'),
(28263, 1539877888, 1539878911, 'PL', 'POL', 'بولندا'),
(28264, 1539879936, 1539880959, 'UA', 'UKR', 'أوكرانيا'),
(28265, 1539880960, 1539881983, 'PL', 'POL', 'بولندا'),
(28266, 1539881984, 1539884031, 'UA', 'UKR', 'أوكرانيا'),
(28267, 1539884032, 1539885055, 'MT', 'MLT', 'مالطا'),
(28268, 1539885056, 1539886079, 'UA', 'UKR', 'أوكرانيا'),
(28269, 1539886080, 1539887103, 'FR', 'FRA', 'فرنسا'),
(28270, 1539887104, 1539888127, 'IT', 'ITA', 'إيطاليا'),
(28271, 1539888128, 1539889151, 'UA', 'UKR', 'أوكرانيا'),
(28272, 1539889152, 1539890175, 'RU', 'RUS', 'الإتحاد الروسي'),
(28273, 1539890176, 1539891199, 'UA', 'UKR', 'أوكرانيا'),
(28274, 1539891200, 1539893247, 'RU', 'RUS', 'الإتحاد الروسي'),
(28275, 1539893248, 1539894271, 'UA', 'UKR', 'أوكرانيا'),
(28276, 1539894272, 1539895295, 'PL', 'POL', 'بولندا'),
(28277, 1539895296, 1539899391, 'UA', 'UKR', 'أوكرانيا'),
(28278, 1539899392, 1539900415, 'RU', 'RUS', 'الإتحاد الروسي'),
(28279, 1539900416, 1539901439, 'UA', 'UKR', 'أوكرانيا'),
(28280, 1539901440, 1539902463, 'RU', 'RUS', 'الإتحاد الروسي'),
(28281, 1539902464, 1539903487, 'LV', 'LVA', 'لاتفيا'),
(28282, 1539903488, 1539904511, 'PL', 'POL', 'بولندا'),
(28283, 1539904512, 1539905535, 'CZ', 'CZE', 'التشيك'),
(28284, 1539905536, 1539910655, 'UA', 'UKR', 'أوكرانيا'),
(28285, 1539910656, 1539911679, 'PL', 'POL', 'بولندا'),
(28286, 1539911680, 1539913727, 'RU', 'RUS', 'الإتحاد الروسي'),
(28287, 1539913728, 1539914751, 'CH', 'CHE', 'سويسرا'),
(28288, 1539914752, 1539915775, 'SE', 'SWE', 'السويد'),
(28289, 1539915776, 1539916799, 'RU', 'RUS', 'الإتحاد الروسي'),
(28290, 1539916800, 1539917823, 'UA', 'UKR', 'أوكرانيا'),
(28291, 1539917824, 1539918847, 'RU', 'RUS', 'الإتحاد الروسي'),
(28292, 1539918848, 1539920895, 'RO', 'ROM', 'رومانيا'),
(28293, 1539920896, 1539921919, 'UA', 'UKR', 'أوكرانيا'),
(28294, 1539921920, 1539922943, 'PL', 'POL', 'بولندا'),
(28295, 1539922944, 1539923967, 'SE', 'SWE', 'السويد'),
(28296, 1539923968, 1539924991, 'RU', 'RUS', 'الإتحاد الروسي'),
(28297, 1539924992, 1539926015, 'DE', 'DEU', 'ألمانيا'),
(28298, 1539926016, 1539927039, 'RU', 'RUS', 'الإتحاد الروسي'),
(28299, 1539927040, 1539928063, 'UA', 'UKR', 'أوكرانيا'),
(28300, 1539928064, 1539930111, 'RU', 'RUS', 'الإتحاد الروسي'),
(28301, 1539930112, 1539931135, 'PL', 'POL', 'بولندا'),
(28302, 1539931136, 1539932159, 'UA', 'UKR', 'أوكرانيا'),
(28303, 1539932160, 1539933183, 'DE', 'DEU', 'ألمانيا'),
(28304, 1539933184, 1539934207, 'ES', 'ESP', 'إسبانيا'),
(28305, 1539934208, 1539935231, 'RS', 'SRB', 'صربيا'),
(28306, 1539935232, 1539936255, 'LV', 'LVA', 'لاتفيا'),
(28307, 1539936256, 1539937279, 'UA', 'UKR', 'أوكرانيا'),
(28308, 1539937280, 1539938303, 'CH', 'CHE', 'سويسرا'),
(28309, 1539938304, 1539939327, 'PL', 'POL', 'بولندا'),
(28310, 1539939328, 1539940351, 'UA', 'UKR', 'أوكرانيا'),
(28311, 1539940352, 1539941375, 'GB', 'GBR', 'المملكة المتحدة'),
(28312, 1539941376, 1539942399, 'NL', 'NLD', 'هولندا'),
(28313, 1539942400, 1539943423, 'UA', 'UKR', 'أوكرانيا'),
(28314, 1539943424, 1539944447, 'BG', 'BGR', 'بلغاريا'),
(28315, 1539944448, 1539946495, 'UA', 'UKR', 'أوكرانيا'),
(28316, 1539946496, 1539947519, 'RU', 'RUS', 'الإتحاد الروسي'),
(28317, 1539947520, 1539948543, 'UA', 'UKR', 'أوكرانيا'),
(28318, 1539948544, 1539949567, 'RO', 'ROM', 'رومانيا'),
(28319, 1539949568, 1539950591, 'MD', 'MDA', 'مولدوفا'),
(28320, 1539950592, 1539951615, 'KZ', 'KAZ', 'كازاخستان'),
(28321, 1539951616, 1539953663, 'RU', 'RUS', 'الإتحاد الروسي'),
(28322, 1539953664, 1539954687, 'UA', 'UKR', 'أوكرانيا'),
(28323, 1539954688, 1539956735, 'RO', 'ROM', 'رومانيا'),
(28324, 1539956736, 1539957759, 'UA', 'UKR', 'أوكرانيا'),
(28325, 1539957760, 1539958783, 'RU', 'RUS', 'الإتحاد الروسي'),
(28326, 1539958784, 1539962879, 'UA', 'UKR', 'أوكرانيا'),
(28327, 1539962880, 1539964927, 'RU', 'RUS', 'الإتحاد الروسي'),
(28328, 1539964928, 1539965951, 'UA', 'UKR', 'أوكرانيا'),
(28329, 1539965952, 1539966975, 'RU', 'RUS', 'الإتحاد الروسي'),
(28330, 1539966976, 1539967999, 'UA', 'UKR', 'أوكرانيا'),
(28331, 1539968000, 1539972095, 'RU', 'RUS', 'الإتحاد الروسي'),
(28332, 1539972096, 1539973119, 'GB', 'GBR', 'المملكة المتحدة'),
(28333, 1539973120, 1539975167, 'RU', 'RUS', 'الإتحاد الروسي'),
(28334, 1539975168, 1539976191, 'DE', 'DEU', 'ألمانيا'),
(28335, 1539976192, 1539977215, 'RU', 'RUS', 'الإتحاد الروسي'),
(28336, 1539977216, 1539978239, 'DE', 'DEU', 'ألمانيا'),
(28337, 1539978240, 1539980287, 'UA', 'UKR', 'أوكرانيا'),
(28338, 1539980288, 1539981311, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(28339, 1539981312, 1539982335, 'SI', 'SVN', 'سلوفينيا'),
(28340, 1539982336, 1539983359, 'RU', 'RUS', 'الإتحاد الروسي'),
(28341, 1539983360, 1539984383, 'UA', 'UKR', 'أوكرانيا'),
(28342, 1539984384, 1539985407, 'RU', 'RUS', 'الإتحاد الروسي'),
(28343, 1539985408, 1539986431, 'SE', 'SWE', 'السويد'),
(28344, 1539986432, 1539987455, 'RU', 'RUS', 'الإتحاد الروسي'),
(28345, 1539987456, 1539988479, 'RO', 'ROM', 'رومانيا'),
(28346, 1539988480, 1539990527, 'RU', 'RUS', 'الإتحاد الروسي'),
(28347, 1539990528, 1539991551, 'PL', 'POL', 'بولندا'),
(28348, 1539991552, 1539993599, 'UA', 'UKR', 'أوكرانيا'),
(28349, 1539993600, 1539994623, 'FI', 'FIN', 'فنلندا'),
(28350, 1539994624, 1539995647, 'AT', 'AUT', 'النمسا'),
(28351, 1539995648, 1539996671, 'CH', 'CHE', 'سويسرا'),
(28352, 1539996672, 1539997695, 'PL', 'POL', 'بولندا'),
(28353, 1539997696, 1539999743, 'UA', 'UKR', 'أوكرانيا'),
(28354, 1539999744, 1540000767, 'GB', 'GBR', 'المملكة المتحدة'),
(28355, 1540000768, 1540001791, 'RU', 'RUS', 'الإتحاد الروسي'),
(28356, 1540001792, 1540002815, 'UA', 'UKR', 'أوكرانيا'),
(28357, 1540002816, 1540003839, 'RU', 'RUS', 'الإتحاد الروسي'),
(28358, 1540003840, 1540004863, 'PL', 'POL', 'بولندا'),
(28359, 1540004864, 1540005887, 'SE', 'SWE', 'السويد'),
(28360, 1540005888, 1540006911, 'UA', 'UKR', 'أوكرانيا'),
(28361, 1540006912, 1540007935, 'RU', 'RUS', 'الإتحاد الروسي'),
(28362, 1540007936, 1540008959, 'IL', 'ISR', 'إسرائيل'),
(28363, 1540008960, 1540011007, 'PL', 'POL', 'بولندا'),
(28364, 1540011008, 1540014079, 'RU', 'RUS', 'الإتحاد الروسي'),
(28365, 1540014080, 1540015103, 'PL', 'POL', 'بولندا'),
(28366, 1540015104, 1540016127, 'RU', 'RUS', 'الإتحاد الروسي'),
(28367, 1540016128, 1540017151, 'KR', 'KOR', 'جمهورية كوريا'),
(28368, 1540017152, 1540018175, 'RU', 'RUS', 'الإتحاد الروسي'),
(28369, 1540018176, 1540020223, 'UA', 'UKR', 'أوكرانيا'),
(28370, 1540020224, 1540022271, 'RU', 'RUS', 'الإتحاد الروسي'),
(28371, 1540022272, 1540023295, 'GB', 'GBR', 'المملكة المتحدة'),
(28372, 1540023296, 1540024319, 'PL', 'POL', 'بولندا'),
(28373, 1540024320, 1540025343, 'RU', 'RUS', 'الإتحاد الروسي'),
(28374, 1540025344, 1540026367, 'GB', 'GBR', 'المملكة المتحدة'),
(28375, 1540026368, 1540028415, 'UA', 'UKR', 'أوكرانيا'),
(28376, 1540028416, 1540029439, 'ES', 'ESP', 'إسبانيا'),
(28377, 1540029440, 1540030463, 'RU', 'RUS', 'الإتحاد الروسي'),
(28378, 1540030464, 1540031487, 'DE', 'DEU', 'ألمانيا'),
(28379, 1540031488, 1540032511, 'UA', 'UKR', 'أوكرانيا'),
(28380, 1540032512, 1540033535, 'RU', 'RUS', 'الإتحاد الروسي'),
(28381, 1540033536, 1540034559, 'UA', 'UKR', 'أوكرانيا'),
(28382, 1540034560, 1540035583, 'PL', 'POL', 'بولندا'),
(28383, 1540035584, 1540036607, 'RU', 'RUS', 'الإتحاد الروسي'),
(28384, 1540036608, 1540037631, 'UA', 'UKR', 'أوكرانيا'),
(28385, 1540037632, 1540038655, 'EE', 'EST', 'إستونيا'),
(28386, 1540038656, 1540039679, 'FR', 'FRA', 'فرنسا'),
(28387, 1540039680, 1540040703, 'RU', 'RUS', 'الإتحاد الروسي'),
(28388, 1540040704, 1540041727, 'SE', 'SWE', 'السويد'),
(28389, 1540041728, 1540042751, 'RU', 'RUS', 'الإتحاد الروسي'),
(28390, 1540042752, 1540043775, 'UA', 'UKR', 'أوكرانيا'),
(28391, 1540043776, 1540044799, 'PL', 'POL', 'بولندا'),
(28392, 1540044800, 1540045823, 'GB', 'GBR', 'المملكة المتحدة'),
(28393, 1540045824, 1540046847, 'UA', 'UKR', 'أوكرانيا'),
(28394, 1540046848, 1540047871, 'RU', 'RUS', 'الإتحاد الروسي'),
(28395, 1540047872, 1540048895, 'LV', 'LVA', 'لاتفيا'),
(28396, 1540048896, 1540049919, 'GB', 'GBR', 'المملكة المتحدة'),
(28397, 1540049920, 1540050943, 'UA', 'UKR', 'أوكرانيا'),
(28398, 1540050944, 1540052991, 'RU', 'RUS', 'الإتحاد الروسي'),
(28399, 1540052992, 1540054052, 'UA', 'UKR', 'أوكرانيا'),
(28400, 1540054053, 1540054062, 'MD', 'MDA', 'مولدوفا'),
(28401, 1540054063, 1540055039, 'UA', 'UKR', 'أوكرانيا'),
(28402, 1540055040, 1540056063, 'NO', 'NOR', 'النرويج'),
(28403, 1540056064, 1540057087, 'NL', 'NLD', 'هولندا'),
(28404, 1540058112, 1540059135, 'DE', 'DEU', 'ألمانيا'),
(28405, 1540059136, 1540060159, 'UA', 'UKR', 'أوكرانيا'),
(28406, 1540060160, 1540061183, 'NO', 'NOR', 'النرويج'),
(28407, 1540062208, 1540063231, 'RU', 'RUS', 'الإتحاد الروسي'),
(28408, 1540063232, 1540064255, 'NL', 'NLD', 'هولندا'),
(28409, 1540064256, 1540065279, 'PL', 'POL', 'بولندا'),
(28410, 1540065280, 1540068351, 'UA', 'UKR', 'أوكرانيا'),
(28411, 1540068352, 1540069375, 'FR', 'FRA', 'فرنسا'),
(28412, 1540069376, 1540070399, 'RU', 'RUS', 'الإتحاد الروسي'),
(28413, 1540071424, 1540072447, 'SE', 'SWE', 'السويد'),
(28414, 1540072448, 1540073471, 'UA', 'UKR', 'أوكرانيا'),
(28415, 1540073472, 1540074495, 'RU', 'RUS', 'الإتحاد الروسي'),
(28416, 1540074496, 1540075519, 'UZ', 'UZB', 'أوزباكستان'),
(28417, 1540075520, 1540077567, 'RU', 'RUS', 'الإتحاد الروسي'),
(28418, 1540077568, 1540078591, 'FR', 'FRA', 'فرنسا'),
(28419, 1540078592, 1540081663, 'RU', 'RUS', 'الإتحاد الروسي'),
(28420, 1540081664, 1540082687, 'DE', 'DEU', 'ألمانيا'),
(28421, 1540082688, 1540083711, 'NO', 'NOR', 'النرويج'),
(28422, 1540083712, 1540084735, 'RU', 'RUS', 'الإتحاد الروسي'),
(28423, 1540084736, 1540085759, 'LU', 'LUX', 'لوكسيمبورغ'),
(28424, 1540085760, 1540087807, 'PL', 'POL', 'بولندا'),
(28425, 1540087808, 1540092927, 'RU', 'RUS', 'الإتحاد الروسي'),
(28426, 1540092928, 1540094975, 'PL', 'POL', 'بولندا'),
(28427, 1540096000, 1540097023, 'SE', 'SWE', 'السويد'),
(28428, 1540097024, 1540099071, 'DE', 'DEU', 'ألمانيا'),
(28429, 1540099072, 1540100095, 'UA', 'UKR', 'أوكرانيا'),
(28430, 1540100096, 1540103167, 'RU', 'RUS', 'الإتحاد الروسي'),
(28431, 1540103168, 1540105215, 'DE', 'DEU', 'ألمانيا'),
(28432, 1540105216, 1540110335, 'UA', 'UKR', 'أوكرانيا'),
(28433, 1540110336, 1540111359, 'RU', 'RUS', 'الإتحاد الروسي'),
(28434, 1540111360, 1540112383, 'UA', 'UKR', 'أوكرانيا'),
(28435, 1540112384, 1540113407, 'LV', 'LVA', 'لاتفيا'),
(28436, 1540113408, 1540115455, 'RU', 'RUS', 'الإتحاد الروسي'),
(28437, 1540115456, 1540116479, 'UA', 'UKR', 'أوكرانيا'),
(28438, 1540116480, 1540117503, 'CH', 'CHE', 'سويسرا'),
(28439, 1540117504, 1540118527, 'UA', 'UKR', 'أوكرانيا'),
(28440, 1540118528, 1540119551, 'PL', 'POL', 'بولندا'),
(28441, 1540119552, 1540120575, 'UA', 'UKR', 'أوكرانيا'),
(28442, 1540120576, 1540124671, 'RU', 'RUS', 'الإتحاد الروسي'),
(28443, 1540124672, 1540125695, 'NO', 'NOR', 'النرويج'),
(28444, 1540125696, 1540126719, 'FR', 'FRA', 'فرنسا'),
(28445, 1540126720, 1540127743, 'UA', 'UKR', 'أوكرانيا'),
(28446, 1540127744, 1540128767, 'GB', 'GBR', 'المملكة المتحدة'),
(28447, 1540128768, 1540129791, 'RU', 'RUS', 'الإتحاد الروسي'),
(28448, 1540129792, 1540130815, 'UA', 'UKR', 'أوكرانيا'),
(28449, 1540130816, 1540131839, 'RU', 'RUS', 'الإتحاد الروسي'),
(28450, 1540131840, 1540132863, 'PL', 'POL', 'بولندا'),
(28451, 1540132864, 1540134911, 'RU', 'RUS', 'الإتحاد الروسي'),
(28452, 1540134912, 1540135935, 'PL', 'POL', 'بولندا'),
(28453, 1540135936, 1540136959, 'BG', 'BGR', 'بلغاريا'),
(28454, 1540136960, 1540137983, 'PL', 'POL', 'بولندا'),
(28455, 1540137984, 1540139007, 'RU', 'RUS', 'الإتحاد الروسي'),
(28456, 1540139008, 1540140031, 'DE', 'DEU', 'ألمانيا'),
(28457, 1540140032, 1540141055, 'GB', 'GBR', 'المملكة المتحدة'),
(28458, 1540141056, 1540142079, 'RU', 'RUS', 'الإتحاد الروسي'),
(28459, 1540142080, 1540143103, 'UA', 'UKR', 'أوكرانيا'),
(28460, 1540143104, 1540144127, 'RU', 'RUS', 'الإتحاد الروسي'),
(28461, 1540144128, 1540145151, 'AM', 'ARM', 'أرمينيا'),
(28462, 1540145152, 1540146175, 'AT', 'AUT', 'النمسا'),
(28463, 1540146176, 1540147199, 'UA', 'UKR', 'أوكرانيا'),
(28464, 1540147200, 1540148223, 'RU', 'RUS', 'الإتحاد الروسي'),
(28465, 1540148224, 1540149247, 'PL', 'POL', 'بولندا'),
(28466, 1540149248, 1540150271, 'GB', 'GBR', 'المملكة المتحدة'),
(28467, 1540150272, 1540151295, 'UA', 'UKR', 'أوكرانيا'),
(28468, 1540151296, 1540152319, 'AT', 'AUT', 'النمسا'),
(28469, 1540152320, 1540153343, 'SE', 'SWE', 'السويد'),
(28470, 1540153344, 1540156415, 'RU', 'RUS', 'الإتحاد الروسي'),
(28471, 1540156416, 1540157439, 'UZ', 'UZB', 'أوزباكستان'),
(28472, 1540157440, 1540158463, 'RU', 'RUS', 'الإتحاد الروسي'),
(28473, 1540158464, 1540159487, 'GB', 'GBR', 'المملكة المتحدة'),
(28474, 1540159488, 1540160511, 'UA', 'UKR', 'أوكرانيا'),
(28475, 1540160512, 1540162559, 'RU', 'RUS', 'الإتحاد الروسي'),
(28476, 1540162560, 1540163583, 'UA', 'UKR', 'أوكرانيا'),
(28477, 1540163584, 1540164607, 'RU', 'RUS', 'الإتحاد الروسي'),
(28478, 1540164608, 1540165631, 'DE', 'DEU', 'ألمانيا'),
(28479, 1540165632, 1540166655, 'UA', 'UKR', 'أوكرانيا'),
(28480, 1540166656, 1540167679, 'PL', 'POL', 'بولندا'),
(28481, 1540167680, 1540168703, 'RU', 'RUS', 'الإتحاد الروسي'),
(28482, 1540168704, 1540169727, 'DE', 'DEU', 'ألمانيا'),
(28483, 1540169728, 1540170751, 'NL', 'NLD', 'هولندا'),
(28484, 1540170752, 1540171775, 'DE', 'DEU', 'ألمانيا'),
(28485, 1540171776, 1540172799, 'GB', 'GBR', 'المملكة المتحدة'),
(28486, 1540172800, 1540173823, 'RU', 'RUS', 'الإتحاد الروسي'),
(28487, 1540173824, 1540174847, 'KG', 'KGZ', 'قيرغيزستان'),
(28488, 1540174848, 1540175871, 'RU', 'RUS', 'الإتحاد الروسي'),
(28489, 1540175872, 1540176895, 'DE', 'DEU', 'ألمانيا'),
(28490, 1540176896, 1540177919, 'SE', 'SWE', 'السويد'),
(28491, 1540177920, 1540178943, 'UA', 'UKR', 'أوكرانيا'),
(28492, 1540178944, 1540179967, 'BA', 'BIH', 'البوسنه والهرسك'),
(28493, 1540179968, 1540180991, 'PL', 'POL', 'بولندا'),
(28494, 1540180992, 1540182015, 'DE', 'DEU', 'ألمانيا'),
(28495, 1540182016, 1540183039, 'UA', 'UKR', 'أوكرانيا'),
(28496, 1540183040, 1540184063, 'RU', 'RUS', 'الإتحاد الروسي'),
(28497, 1540184064, 1540185087, 'PL', 'POL', 'بولندا'),
(28498, 1540185088, 1540186111, 'RU', 'RUS', 'الإتحاد الروسي'),
(28499, 1540186112, 1540187135, 'NL', 'NLD', 'هولندا'),
(28500, 1540187136, 1540188159, 'US', 'USA', 'الولايات المتحدة'),
(28501, 1540188160, 1540189183, 'KZ', 'KAZ', 'كازاخستان'),
(28502, 1540189184, 1540190207, 'GB', 'GBR', 'المملكة المتحدة'),
(28503, 1540190208, 1540191231, 'PT', 'PRT', 'البورتوغال'),
(28504, 1540191232, 1540192255, 'FR', 'FRA', 'فرنسا'),
(28505, 1540192256, 1540195327, 'RU', 'RUS', 'الإتحاد الروسي'),
(28506, 1540195328, 1540198399, 'AM', 'ARM', 'أرمينيا'),
(28507, 1540198400, 1540199423, 'RU', 'RUS', 'الإتحاد الروسي'),
(28508, 1540199424, 1540200447, 'CH', 'CHE', 'سويسرا'),
(28509, 1540200448, 1540201471, 'IL', 'ISR', 'إسرائيل'),
(28510, 1540201472, 1540202495, 'UA', 'UKR', 'أوكرانيا'),
(28511, 1540203520, 1540204543, 'UA', 'UKR', 'أوكرانيا'),
(28512, 1540204544, 1540205567, 'RU', 'RUS', 'الإتحاد الروسي'),
(28513, 1540205568, 1540206591, 'DE', 'DEU', 'ألمانيا'),
(28514, 1540206592, 1540207615, 'RU', 'RUS', 'الإتحاد الروسي'),
(28515, 1540208640, 1540209663, 'NO', 'NOR', 'النرويج'),
(28516, 1540209664, 1540211711, 'RU', 'RUS', 'الإتحاد الروسي'),
(28517, 1540211712, 1540212735, 'DE', 'DEU', 'ألمانيا'),
(28518, 1540213760, 1540214783, 'UA', 'UKR', 'أوكرانيا'),
(28519, 1540214784, 1540215807, 'RU', 'RUS', 'الإتحاد الروسي'),
(28520, 1540215808, 1540216831, 'NL', 'NLD', 'هولندا'),
(28521, 1540216832, 1540217855, 'UA', 'UKR', 'أوكرانيا'),
(28522, 1540217856, 1540218879, 'GB', 'GBR', 'المملكة المتحدة'),
(28523, 1540218880, 1540219903, 'RU', 'RUS', 'الإتحاد الروسي'),
(28524, 1540219904, 1540220927, 'PL', 'POL', 'بولندا'),
(28525, 1540220928, 1540221951, 'NL', 'NLD', 'هولندا'),
(28526, 1540221952, 1540223999, 'RU', 'RUS', 'الإتحاد الروسي'),
(28527, 1540224000, 1540225023, 'PL', 'POL', 'بولندا'),
(28528, 1540225024, 1540226047, 'GB', 'GBR', 'المملكة المتحدة'),
(28529, 1540226048, 1540227071, 'RU', 'RUS', 'الإتحاد الروسي'),
(28530, 1540227072, 1540227583, 'GB', 'GBR', 'المملكة المتحدة'),
(28531, 1540227584, 1540228095, 'RU', 'RUS', 'الإتحاد الروسي'),
(28532, 1540228096, 1540228607, 'UA', 'UKR', 'أوكرانيا'),
(28533, 1540228608, 1540229119, 'PL', 'POL', 'بولندا'),
(28534, 1540229120, 1540229631, 'AT', 'AUT', 'النمسا'),
(28535, 1540229632, 1540230143, 'NL', 'NLD', 'هولندا'),
(28536, 1540230144, 1540232191, 'RU', 'RUS', 'الإتحاد الروسي'),
(28537, 1540232192, 1540232703, 'BG', 'BGR', 'بلغاريا'),
(28538, 1540232704, 1540233215, 'RU', 'RUS', 'الإتحاد الروسي'),
(28539, 1540233216, 1540233727, 'CH', 'CHE', 'سويسرا'),
(28540, 1540233728, 1540234239, 'PL', 'POL', 'بولندا'),
(28541, 1540234240, 1540234751, 'DE', 'DEU', 'ألمانيا'),
(28542, 1540234752, 1540235775, 'UA', 'UKR', 'أوكرانيا'),
(28543, 1540235776, 1540236287, 'NO', 'NOR', 'النرويج'),
(28544, 1540236288, 1540236799, 'RO', 'ROM', 'رومانيا'),
(28545, 1540236800, 1540237311, 'PL', 'POL', 'بولندا'),
(28546, 1540237312, 1540238847, 'RO', 'ROM', 'رومانيا'),
(28547, 1540238848, 1540239359, 'DE', 'DEU', 'ألمانيا'),
(28548, 1540239360, 1540239871, 'UA', 'UKR', 'أوكرانيا'),
(28549, 1540240384, 1540240895, 'CH', 'CHE', 'سويسرا'),
(28550, 1540240896, 1540242431, 'RU', 'RUS', 'الإتحاد الروسي'),
(28551, 1540242432, 1540242943, 'DE', 'DEU', 'ألمانيا'),
(28552, 1540242944, 1540243455, 'RU', 'RUS', 'الإتحاد الروسي'),
(28553, 1540243456, 1540243967, 'PL', 'POL', 'بولندا'),
(28554, 1540243968, 1540244479, 'RU', 'RUS', 'الإتحاد الروسي'),
(28555, 1540244480, 1540244991, 'CH', 'CHE', 'سويسرا'),
(28556, 1540244992, 1540245503, 'DE', 'DEU', 'ألمانيا'),
(28557, 1540245504, 1540246015, 'RU', 'RUS', 'الإتحاد الروسي'),
(28558, 1540246016, 1540246527, 'IT', 'ITA', 'إيطاليا'),
(28559, 1540246528, 1540247551, 'RO', 'ROM', 'رومانيا'),
(28560, 1540247552, 1540248063, 'NL', 'NLD', 'هولندا'),
(28561, 1540248064, 1540248575, 'RO', 'ROM', 'رومانيا'),
(28562, 1540248576, 1540249087, 'GB', 'GBR', 'المملكة المتحدة'),
(28563, 1540249088, 1540249599, 'PL', 'POL', 'بولندا'),
(28564, 1540249600, 1540250111, 'KZ', 'KAZ', 'كازاخستان'),
(28565, 1540250112, 1540250623, 'DK', 'DNK', 'الدنيمارك'),
(28566, 1540250624, 1540251135, 'RU', 'RUS', 'الإتحاد الروسي'),
(28567, 1540251136, 1540251647, 'GB', 'GBR', 'المملكة المتحدة'),
(28568, 1540251648, 1540252159, 'PL', 'POL', 'بولندا'),
(28569, 1540252160, 1540252671, 'DE', 'DEU', 'ألمانيا'),
(28570, 1540252672, 1540253183, 'RU', 'RUS', 'الإتحاد الروسي'),
(28571, 1540253184, 1540253695, 'AT', 'AUT', 'النمسا'),
(28572, 1540253696, 1540254207, 'CH', 'CHE', 'سويسرا'),
(28573, 1540254208, 1540254719, 'RU', 'RUS', 'الإتحاد الروسي'),
(28574, 1540254720, 1540255231, 'PL', 'POL', 'بولندا'),
(28575, 1540255232, 1540255743, 'UA', 'UKR', 'أوكرانيا'),
(28576, 1540255744, 1540256255, 'AT', 'AUT', 'النمسا'),
(28577, 1540256256, 1540256767, 'PL', 'POL', 'بولندا'),
(28578, 1540256768, 1540257279, 'RU', 'RUS', 'الإتحاد الروسي'),
(28579, 1540257280, 1540257791, 'GB', 'GBR', 'المملكة المتحدة'),
(28580, 1540257792, 1540258303, 'RU', 'RUS', 'الإتحاد الروسي'),
(28581, 1540258304, 1540258815, 'IR', 'IRN', 'إيران'),
(28582, 1540258816, 1540259327, 'UA', 'UKR', 'أوكرانيا'),
(28583, 1540259328, 1540259839, 'RU', 'RUS', 'الإتحاد الروسي'),
(28584, 1540259840, 1540260351, 'IT', 'ITA', 'إيطاليا'),
(28585, 1540260352, 1540260863, 'RU', 'RUS', 'الإتحاد الروسي'),
(28586, 1540260864, 1540261375, 'LT', 'LTU', 'ليتوانيا'),
(28587, 1540261376, 1540261887, 'SA', 'SAU', 'السعودية'),
(28588, 1540261888, 1540262399, 'NL', 'NLD', 'هولندا'),
(28589, 1540262400, 1540262911, 'BG', 'BGR', 'بلغاريا'),
(28590, 1540262912, 1540263423, 'RO', 'ROM', 'رومانيا'),
(28591, 1540263424, 1540263935, 'DE', 'DEU', 'ألمانيا'),
(28592, 1540263936, 1540264447, 'GB', 'GBR', 'المملكة المتحدة'),
(28593, 1540264448, 1540265983, 'RU', 'RUS', 'الإتحاد الروسي'),
(28594, 1540265984, 1540266495, 'DE', 'DEU', 'ألمانيا'),
(28595, 1540266496, 1540267007, 'PL', 'POL', 'بولندا'),
(28596, 1540267008, 1540267519, 'FR', 'FRA', 'فرنسا'),
(28597, 1540267520, 1540268543, 'RO', 'ROM', 'رومانيا'),
(28598, 1540268544, 1540269055, 'RU', 'RUS', 'الإتحاد الروسي'),
(28599, 1540269056, 1540269567, 'DK', 'DNK', 'الدنيمارك'),
(28600, 1540269568, 1540270079, 'RU', 'RUS', 'الإتحاد الروسي'),
(28601, 1540270080, 1540270591, 'GB', 'GBR', 'المملكة المتحدة'),
(28602, 1540270592, 1540271103, 'IL', 'ISR', 'إسرائيل'),
(28603, 1540271104, 1540271615, 'PL', 'POL', 'بولندا'),
(28604, 1540271616, 1540272127, 'SE', 'SWE', 'السويد'),
(28605, 1540272128, 1540272639, 'GB', 'GBR', 'المملكة المتحدة'),
(28606, 1540272640, 1540273663, 'PL', 'POL', 'بولندا'),
(28607, 1540273664, 1540274175, 'GB', 'GBR', 'المملكة المتحدة'),
(28608, 1540274176, 1540274687, 'DE', 'DEU', 'ألمانيا'),
(28609, 1540274688, 1540275199, 'UA', 'UKR', 'أوكرانيا'),
(28610, 1540275200, 1540275711, 'DE', 'DEU', 'ألمانيا'),
(28611, 1540275712, 1540276223, 'GR', 'GRC', 'اليونان'),
(28612, 1540276224, 1540276735, 'AT', 'AUT', 'النمسا'),
(28613, 1540276736, 1540277247, 'RO', 'ROM', 'رومانيا'),
(28614, 1540277248, 1540277759, 'RU', 'RUS', 'الإتحاد الروسي'),
(28615, 1540277760, 1540278271, 'FR', 'FRA', 'فرنسا'),
(28616, 1540278272, 1540278783, 'UA', 'UKR', 'أوكرانيا'),
(28617, 1540278784, 1540279807, 'RU', 'RUS', 'الإتحاد الروسي'),
(28618, 1540279808, 1540280319, 'RO', 'ROM', 'رومانيا'),
(28619, 1540280320, 1540280831, 'MD', 'MDA', 'مولدوفا'),
(28620, 1540280832, 1540281343, 'PL', 'POL', 'بولندا'),
(28621, 1540281344, 1540281855, 'UA', 'UKR', 'أوكرانيا'),
(28622, 1540281856, 1540282367, 'DE', 'DEU', 'ألمانيا'),
(28623, 1540282368, 1540282879, 'RU', 'RUS', 'الإتحاد الروسي'),
(28624, 1540282880, 1540283391, 'UA', 'UKR', 'أوكرانيا'),
(28625, 1540283392, 1540284415, 'RU', 'RUS', 'الإتحاد الروسي'),
(28626, 1540284416, 1540284927, 'AT', 'AUT', 'النمسا'),
(28627, 1540284928, 1540285439, 'UA', 'UKR', 'أوكرانيا'),
(28628, 1540285440, 1540285951, 'DE', 'DEU', 'ألمانيا'),
(28629, 1540285952, 1540286463, 'RU', 'RUS', 'الإتحاد الروسي'),
(28630, 1540286464, 1540286975, 'NL', 'NLD', 'هولندا'),
(28631, 1540286976, 1540287487, 'GB', 'GBR', 'المملكة المتحدة'),
(28632, 1540287488, 1540288511, 'AT', 'AUT', 'النمسا'),
(28633, 1540288512, 1540289535, 'RU', 'RUS', 'الإتحاد الروسي'),
(28634, 1540289536, 1540290047, 'PL', 'POL', 'بولندا'),
(28635, 1540290048, 1540290559, 'NL', 'NLD', 'هولندا'),
(28636, 1540290560, 1540291071, 'RU', 'RUS', 'الإتحاد الروسي'),
(28637, 1540291072, 1540291583, 'BE', 'BEL', 'بلجيكا'),
(28638, 1540291584, 1540292095, 'UA', 'UKR', 'أوكرانيا'),
(28639, 1540292096, 1540292607, 'RU', 'RUS', 'الإتحاد الروسي'),
(28640, 1540292608, 1540293119, 'FR', 'FRA', 'فرنسا'),
(28641, 1540293120, 1540293631, 'DK', 'DNK', 'الدنيمارك'),
(28642, 1540293632, 1540295167, 'UA', 'UKR', 'أوكرانيا'),
(28643, 1540295168, 1540295679, 'PL', 'POL', 'بولندا'),
(28644, 1540295680, 1540296191, 'SA', 'SAU', 'السعودية'),
(28645, 1540296192, 1540296703, 'PL', 'POL', 'بولندا'),
(28646, 1540296704, 1540297215, 'DE', 'DEU', 'ألمانيا'),
(28647, 1540297216, 1540298239, 'FR', 'FRA', 'فرنسا'),
(28648, 1540298240, 1540298751, 'HR', 'HRV', 'كرواتيا'),
(28649, 1540298752, 1540299263, 'RU', 'RUS', 'الإتحاد الروسي'),
(28650, 1540299264, 1540299775, 'UA', 'UKR', 'أوكرانيا'),
(28651, 1540299776, 1540300287, 'KZ', 'KAZ', 'كازاخستان'),
(28652, 1540300288, 1540300799, 'RU', 'RUS', 'الإتحاد الروسي'),
(28653, 1540300800, 1540301311, 'DK', 'DNK', 'الدنيمارك'),
(28654, 1540301312, 1540301823, 'IL', 'ISR', 'إسرائيل'),
(28655, 1540301824, 1540302847, 'GB', 'GBR', 'المملكة المتحدة'),
(28656, 1540302848, 1540303871, 'RU', 'RUS', 'الإتحاد الروسي'),
(28657, 1540303872, 1540304895, 'UA', 'UKR', 'أوكرانيا'),
(28658, 1540304896, 1540305407, 'PL', 'POL', 'بولندا'),
(28659, 1540305408, 1540305919, 'GB', 'GBR', 'المملكة المتحدة'),
(28660, 1540306432, 1540306943, 'UA', 'UKR', 'أوكرانيا'),
(28661, 1540306944, 1540307455, 'GB', 'GBR', 'المملكة المتحدة'),
(28662, 1540307456, 1540307967, 'RU', 'RUS', 'الإتحاد الروسي'),
(28663, 1540307968, 1540308479, 'UA', 'UKR', 'أوكرانيا'),
(28664, 1540308480, 1540308991, 'RS', 'SRB', 'صربيا'),
(28665, 1540308992, 1540309503, 'PL', 'POL', 'بولندا'),
(28666, 1540309504, 1540310015, 'UA', 'UKR', 'أوكرانيا'),
(28667, 1540310016, 1540310527, 'PL', 'POL', 'بولندا'),
(28668, 1540310528, 1540313087, 'RU', 'RUS', 'الإتحاد الروسي'),
(28669, 1540313088, 1540313599, 'SE', 'SWE', 'السويد'),
(28670, 1540313600, 1540315135, 'RU', 'RUS', 'الإتحاد الروسي'),
(28671, 1540315136, 1540315647, 'UA', 'UKR', 'أوكرانيا'),
(28672, 1540315648, 1540316159, 'IL', 'ISR', 'إسرائيل'),
(28673, 1540316160, 1540316671, 'DE', 'DEU', 'ألمانيا'),
(28674, 1540316672, 1540317183, 'RO', 'ROM', 'رومانيا'),
(28675, 1540317184, 1540317695, 'KG', 'KGZ', 'قيرغيزستان'),
(28676, 1540317696, 1540318207, 'UA', 'UKR', 'أوكرانيا'),
(28677, 1540318208, 1540318719, 'RU', 'RUS', 'الإتحاد الروسي'),
(28678, 1540318720, 1540319231, 'RO', 'ROM', 'رومانيا'),
(28679, 1540319232, 1540320255, 'UA', 'UKR', 'أوكرانيا'),
(28680, 1540320256, 1540320767, 'RU', 'RUS', 'الإتحاد الروسي'),
(28681, 1540320768, 1540321279, 'FR', 'FRA', 'فرنسا'),
(28682, 1540321280, 1540321791, 'SE', 'SWE', 'السويد'),
(28683, 1540321792, 1540322303, 'RU', 'RUS', 'الإتحاد الروسي'),
(28684, 1540322304, 1540322815, 'UA', 'UKR', 'أوكرانيا'),
(28685, 1540322816, 1540323327, 'DE', 'DEU', 'ألمانيا'),
(28686, 1540323328, 1540323839, 'RO', 'ROM', 'رومانيا'),
(28687, 1540323840, 1540324351, 'UA', 'UKR', 'أوكرانيا'),
(28688, 1540324352, 1540324863, 'RO', 'ROM', 'رومانيا'),
(28689, 1540324864, 1540325375, 'PL', 'POL', 'بولندا'),
(28690, 1540325376, 1540325887, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(28691, 1540325888, 1540326399, 'LI', 'LIE', 'ليختنشتاين'),
(28692, 1540326400, 1540326911, 'RU', 'RUS', 'الإتحاد الروسي'),
(28693, 1540326912, 1540327423, 'AT', 'AUT', 'النمسا'),
(28694, 1540327424, 1540327935, 'RU', 'RUS', 'الإتحاد الروسي'),
(28695, 1540328448, 1540329983, 'RU', 'RUS', 'الإتحاد الروسي'),
(28696, 1540329984, 1540330495, 'UA', 'UKR', 'أوكرانيا'),
(28697, 1540330496, 1540331007, 'PL', 'POL', 'بولندا'),
(28698, 1540331008, 1540331519, 'IT', 'ITA', 'إيطاليا'),
(28699, 1540331520, 1540332031, 'GB', 'GBR', 'المملكة المتحدة'),
(28700, 1540332032, 1540332543, 'RU', 'RUS', 'الإتحاد الروسي'),
(28701, 1540332544, 1540333055, 'PL', 'POL', 'بولندا'),
(28702, 1540333056, 1540333567, 'NO', 'NOR', 'النرويج'),
(28703, 1540333568, 1540334079, 'RO', 'ROM', 'رومانيا'),
(28704, 1540334080, 1540334591, 'DE', 'DEU', 'ألمانيا'),
(28705, 1540334592, 1540335103, 'RU', 'RUS', 'الإتحاد الروسي'),
(28706, 1540335104, 1540336127, 'PL', 'POL', 'بولندا'),
(28707, 1540336128, 1540336639, 'RU', 'RUS', 'الإتحاد الروسي'),
(28708, 1540336640, 1540337663, 'MC', 'MCO', 'موناكو'),
(28709, 1540337664, 1540338175, 'FR', 'FRA', 'فرنسا'),
(28710, 1540338176, 1540339199, 'RU', 'RUS', 'الإتحاد الروسي'),
(28711, 1540339200, 1540339711, 'UA', 'UKR', 'أوكرانيا'),
(28712, 1540339712, 1540340735, 'PL', 'POL', 'بولندا'),
(28713, 1540340736, 1540341247, 'CZ', 'CZE', 'التشيك'),
(28714, 1540341248, 1540341759, 'BG', 'BGR', 'بلغاريا'),
(28715, 1540341760, 1540342271, 'GB', 'GBR', 'المملكة المتحدة'),
(28716, 1540342272, 1540342783, 'UA', 'UKR', 'أوكرانيا'),
(28717, 1540342784, 1540343295, 'ES', 'ESP', 'إسبانيا'),
(28718, 1540343296, 1540343807, 'GB', 'GBR', 'المملكة المتحدة'),
(28719, 1540343808, 1540344831, 'PL', 'POL', 'بولندا'),
(28720, 1540344832, 1540345343, 'UA', 'UKR', 'أوكرانيا'),
(28721, 1540345344, 1540345855, 'IL', 'ISR', 'إسرائيل'),
(28722, 1540345856, 1540346367, 'FR', 'FRA', 'فرنسا'),
(28723, 1540346368, 1540346879, 'UA', 'UKR', 'أوكرانيا'),
(28724, 1540346880, 1540347391, 'GB', 'GBR', 'المملكة المتحدة'),
(28725, 1540347392, 1540347903, 'DK', 'DNK', 'الدنيمارك'),
(28726, 1540347904, 1540348415, 'RO', 'ROM', 'رومانيا'),
(28727, 1540348416, 1540348927, 'UA', 'UKR', 'أوكرانيا'),
(28728, 1540348928, 1540349439, 'GB', 'GBR', 'المملكة المتحدة'),
(28729, 1540349440, 1540349951, 'AT', 'AUT', 'النمسا'),
(28730, 1540349952, 1540350463, 'UA', 'UKR', 'أوكرانيا'),
(28731, 1540350464, 1540350975, 'NO', 'NOR', 'النرويج'),
(28732, 1540350976, 1540351487, 'DK', 'DNK', 'الدنيمارك'),
(28733, 1540351488, 1540351999, 'RO', 'ROM', 'رومانيا'),
(28734, 1540352000, 1540352511, 'NL', 'NLD', 'هولندا'),
(28735, 1540352512, 1540353023, 'RU', 'RUS', 'الإتحاد الروسي'),
(28736, 1540353024, 1540353535, 'GR', 'GRC', 'اليونان'),
(28737, 1540353536, 1540354047, 'RU', 'RUS', 'الإتحاد الروسي'),
(28738, 1540354048, 1540354559, 'IL', 'ISR', 'إسرائيل'),
(28739, 1540354560, 1540355071, 'PL', 'POL', 'بولندا'),
(28740, 1540355072, 1540355583, 'UA', 'UKR', 'أوكرانيا'),
(28741, 1540355584, 1540356607, 'RU', 'RUS', 'الإتحاد الروسي'),
(28742, 1540356608, 1540357119, 'DE', 'DEU', 'ألمانيا'),
(28743, 1540357120, 1540357631, 'RU', 'RUS', 'الإتحاد الروسي'),
(28744, 1540357632, 1540358143, 'FR', 'FRA', 'فرنسا'),
(28745, 1540358144, 1540358399, 'RU', 'RUS', 'الإتحاد الروسي'),
(28746, 1540358400, 1540358655, 'GB', 'GBR', 'المملكة المتحدة'),
(28747, 1540358656, 1540358911, 'SE', 'SWE', 'السويد'),
(28748, 1540358912, 1540359167, 'GB', 'GBR', 'المملكة المتحدة'),
(28749, 1540359168, 1540359423, 'SA', 'SAU', 'السعودية'),
(28750, 1540359424, 1540359679, 'DE', 'DEU', 'ألمانيا'),
(28751, 1540359680, 1540359935, 'GB', 'GBR', 'المملكة المتحدة'),
(28752, 1540359936, 1540360191, 'AT', 'AUT', 'النمسا'),
(28753, 1540360192, 1540360447, 'NO', 'NOR', 'النرويج'),
(28754, 1540360448, 1540360703, 'FR', 'FRA', 'فرنسا'),
(28755, 1540360704, 1540360959, 'PL', 'POL', 'بولندا'),
(28756, 1540360960, 1540361215, 'GB', 'GBR', 'المملكة المتحدة'),
(28757, 1540361216, 1540361471, 'BE', 'BEL', 'بلجيكا'),
(28758, 1540361472, 1540361727, 'DE', 'DEU', 'ألمانيا'),
(28759, 1540361728, 1540361983, 'IT', 'ITA', 'إيطاليا'),
(28760, 1540361984, 1540362239, 'EE', 'EST', 'إستونيا'),
(28761, 1540362240, 1540362495, 'DK', 'DNK', 'الدنيمارك'),
(28762, 1540362496, 1540363007, 'DE', 'DEU', 'ألمانيا'),
(28763, 1540363008, 1540363263, 'FR', 'FRA', 'فرنسا'),
(28764, 1540363264, 1540363519, 'RU', 'RUS', 'الإتحاد الروسي'),
(28765, 1540363520, 1540363775, 'GB', 'GBR', 'المملكة المتحدة'),
(28766, 1540363776, 1540364031, 'IS', 'ISL', 'أيسلندا'),
(28767, 1540364032, 1540364287, 'RU', 'RUS', 'الإتحاد الروسي'),
(28768, 1540364288, 1540364543, 'NO', 'NOR', 'النرويج'),
(28769, 1540364544, 1540364799, 'UA', 'UKR', 'أوكرانيا'),
(28770, 1540364800, 1540365055, 'EE', 'EST', 'إستونيا'),
(28771, 1540365056, 1540365311, 'SI', 'SVN', 'سلوفينيا'),
(28772, 1540365312, 1540365567, 'GB', 'GBR', 'المملكة المتحدة'),
(28773, 1540365568, 1540365823, 'RU', 'RUS', 'الإتحاد الروسي'),
(28774, 1540365824, 1540366079, 'CH', 'CHE', 'سويسرا'),
(28775, 1540366080, 1540366335, 'IE', 'IRL', 'إيرلندا'),
(28776, 1540366336, 1540366591, 'PL', 'POL', 'بولندا'),
(28777, 1540366592, 1540366847, 'RU', 'RUS', 'الإتحاد الروسي'),
(28778, 1540366848, 1540367103, 'AT', 'AUT', 'النمسا'),
(28779, 1540367360, 1540367615, 'HU', 'HUN', 'هنغاريا'),
(28780, 1540367616, 1540367871, 'BE', 'BEL', 'بلجيكا'),
(28781, 1540367872, 1540368127, 'DE', 'DEU', 'ألمانيا'),
(28782, 1540368128, 1540368383, 'RU', 'RUS', 'الإتحاد الروسي'),
(28783, 1540368384, 1540368639, 'FR', 'FRA', 'فرنسا'),
(28784, 1540368640, 1540368895, 'SK', 'SVK', 'سلوفاكيا'),
(28785, 1540368896, 1540369407, 'RU', 'RUS', 'الإتحاد الروسي'),
(28786, 1540369408, 1540369663, 'PL', 'POL', 'بولندا'),
(28787, 1540369664, 1540369919, 'DE', 'DEU', 'ألمانيا'),
(28788, 1540369920, 1540370175, 'UA', 'UKR', 'أوكرانيا'),
(28789, 1540370176, 1540370431, 'DE', 'DEU', 'ألمانيا'),
(28790, 1540370432, 1540370687, 'LB', 'LBN', 'لبنان'),
(28791, 1540370688, 1540370943, 'NL', 'NLD', 'هولندا'),
(28792, 1540370944, 1540371199, 'PL', 'POL', 'بولندا'),
(28793, 1540371200, 1540371455, 'BE', 'BEL', 'بلجيكا'),
(28794, 1540371456, 1540371711, 'UA', 'UKR', 'أوكرانيا'),
(28795, 1540371712, 1540371967, 'GB', 'GBR', 'المملكة المتحدة'),
(28796, 1540371968, 1540372223, 'NO', 'NOR', 'النرويج'),
(28797, 1540372224, 1540372479, 'PL', 'POL', 'بولندا'),
(28798, 1540372736, 1540372991, 'GR', 'GRC', 'اليونان'),
(28799, 1540372992, 1540373247, 'DE', 'DEU', 'ألمانيا'),
(28800, 1540373248, 1540373503, 'UA', 'UKR', 'أوكرانيا'),
(28801, 1540373504, 1540373759, 'NL', 'NLD', 'هولندا'),
(28802, 1540373760, 1540374015, 'TR', 'TUR', 'تركيا'),
(28803, 1540374016, 1540374271, 'NL', 'NLD', 'هولندا'),
(28804, 1540374272, 1540374527, 'HU', 'HUN', 'هنغاريا'),
(28805, 1540374528, 1540374783, 'RU', 'RUS', 'الإتحاد الروسي'),
(28806, 1540374784, 1540375039, 'UA', 'UKR', 'أوكرانيا'),
(28807, 1540375040, 1540375295, 'DE', 'DEU', 'ألمانيا'),
(28808, 1540375296, 1540375551, 'GB', 'GBR', 'المملكة المتحدة'),
(28809, 1540375552, 1540375807, 'DE', 'DEU', 'ألمانيا'),
(28810, 1540375808, 1540376063, 'NL', 'NLD', 'هولندا'),
(28811, 1540376064, 1540376319, 'TR', 'TUR', 'تركيا'),
(28812, 1540376320, 1540376575, 'DK', 'DNK', 'الدنيمارك'),
(28813, 1540376576, 1540376831, 'PL', 'POL', 'بولندا'),
(28814, 1540376832, 1540377087, 'RU', 'RUS', 'الإتحاد الروسي'),
(28815, 1540377088, 1540377343, 'DE', 'DEU', 'ألمانيا'),
(28816, 1540377344, 1540377599, 'RO', 'ROM', 'رومانيا'),
(28817, 1540377600, 1540377855, 'AM', 'ARM', 'أرمينيا'),
(28818, 1540377856, 1540378111, 'ES', 'ESP', 'إسبانيا'),
(28819, 1540378368, 1540378623, 'CH', 'CHE', 'سويسرا'),
(28820, 1540378624, 1540378879, 'AT', 'AUT', 'النمسا'),
(28821, 1540378880, 1540379135, 'SE', 'SWE', 'السويد'),
(28822, 1540379136, 1540379391, 'CH', 'CHE', 'سويسرا'),
(28823, 1540379392, 1540379647, 'DE', 'DEU', 'ألمانيا'),
(28824, 1540379648, 1540379903, 'RU', 'RUS', 'الإتحاد الروسي'),
(28825, 1540380160, 1540380415, 'IL', 'ISR', 'إسرائيل'),
(28826, 1540380416, 1540380671, 'NL', 'NLD', 'هولندا'),
(28827, 1540380672, 1540380927, 'SI', 'SVN', 'سلوفينيا'),
(28828, 1540380928, 1540381183, 'RS', 'SRB', 'صربيا'),
(28829, 1540381184, 1540381439, 'RO', 'ROM', 'رومانيا'),
(28830, 1540381440, 1540381695, 'AT', 'AUT', 'النمسا'),
(28831, 1540381696, 1540381951, 'RO', 'ROM', 'رومانيا'),
(28832, 1540381952, 1540382207, 'PL', 'POL', 'بولندا'),
(28833, 1540382208, 1540382463, 'UA', 'UKR', 'أوكرانيا'),
(28834, 1540382464, 1540382719, 'GB', 'GBR', 'المملكة المتحدة'),
(28835, 1540382720, 1540382975, 'LB', 'LBN', 'لبنان'),
(28836, 1540382976, 1540383231, 'UA', 'UKR', 'أوكرانيا'),
(28837, 1540383232, 1540383487, 'AT', 'AUT', 'النمسا'),
(28838, 1540383488, 1540383743, 'GB', 'GBR', 'المملكة المتحدة'),
(28839, 1540383744, 1540383999, 'RO', 'ROM', 'رومانيا'),
(28840, 1540384000, 1540384255, 'SI', 'SVN', 'سلوفينيا'),
(28841, 1540384256, 1540384511, 'FR', 'FRA', 'فرنسا'),
(28842, 1540384512, 1540384767, 'SE', 'SWE', 'السويد'),
(28843, 1540384768, 1540385023, 'HR', 'HRV', 'كرواتيا'),
(28844, 1540385024, 1540385279, 'GB', 'GBR', 'المملكة المتحدة'),
(28845, 1540385280, 1540385535, 'PL', 'POL', 'بولندا'),
(28846, 1540385536, 1540385791, 'DE', 'DEU', 'ألمانيا'),
(28847, 1540385792, 1540386303, 'FR', 'FRA', 'فرنسا'),
(28848, 1540386304, 1540386559, 'NL', 'NLD', 'هولندا'),
(28849, 1540386560, 1540386815, 'GB', 'GBR', 'المملكة المتحدة'),
(28850, 1540386816, 1540387071, 'NL', 'NLD', 'هولندا'),
(28851, 1540387072, 1540387327, 'RU', 'RUS', 'الإتحاد الروسي'),
(28852, 1540387328, 1540387583, 'GB', 'GBR', 'المملكة المتحدة'),
(28853, 1540387584, 1540388095, 'UA', 'UKR', 'أوكرانيا'),
(28854, 1540388096, 1540388351, 'GB', 'GBR', 'المملكة المتحدة'),
(28855, 1540388352, 1540388607, 'IL', 'ISR', 'إسرائيل'),
(28856, 1540388608, 1540388863, 'RU', 'RUS', 'الإتحاد الروسي'),
(28857, 1540388864, 1540389119, 'RO', 'ROM', 'رومانيا'),
(28858, 1540389120, 1540389375, 'RU', 'RUS', 'الإتحاد الروسي'),
(28859, 1540389376, 1540389631, 'GB', 'GBR', 'المملكة المتحدة'),
(28860, 1540389632, 1540389887, 'RO', 'ROM', 'رومانيا'),
(28861, 1540389888, 1540390143, 'GB', 'GBR', 'المملكة المتحدة'),
(28862, 1540390144, 1540390399, 'SI', 'SVN', 'سلوفينيا'),
(28863, 1540390400, 1540390655, 'RU', 'RUS', 'الإتحاد الروسي'),
(28864, 1540390656, 1540390911, 'UA', 'UKR', 'أوكرانيا'),
(28865, 1540390912, 1540391167, 'SA', 'SAU', 'السعودية'),
(28866, 1540391168, 1540391423, 'IL', 'ISR', 'إسرائيل'),
(28867, 1540391424, 1540391679, 'CH', 'CHE', 'سويسرا'),
(28868, 1540391680, 1540391935, 'NL', 'NLD', 'هولندا'),
(28869, 1540391936, 1540392191, 'RU', 'RUS', 'الإتحاد الروسي'),
(28870, 1540392192, 1540392447, 'PL', 'POL', 'بولندا'),
(28871, 1540392448, 1540392703, 'RU', 'RUS', 'الإتحاد الروسي'),
(28872, 1540392704, 1540392959, 'PL', 'POL', 'بولندا'),
(28873, 1540392960, 1540393471, 'GB', 'GBR', 'المملكة المتحدة'),
(28874, 1540393472, 1540393727, 'UA', 'UKR', 'أوكرانيا'),
(28875, 1540393728, 1540394239, 'IL', 'ISR', 'إسرائيل'),
(28876, 1540394240, 1540394495, 'GB', 'GBR', 'المملكة المتحدة'),
(28877, 1540394496, 1540394751, 'RO', 'ROM', 'رومانيا'),
(28878, 1540394752, 1540395007, 'DK', 'DNK', 'الدنيمارك'),
(28879, 1540395008, 1540395263, 'GE', 'GEO', 'جورجيا'),
(28880, 1540395264, 1540395519, 'UA', 'UKR', 'أوكرانيا'),
(28881, 1540395520, 1540395775, 'GB', 'GBR', 'المملكة المتحدة'),
(28882, 1540395776, 1540396031, 'IL', 'ISR', 'إسرائيل'),
(28883, 1540396032, 1540396287, 'NO', 'NOR', 'النرويج'),
(28884, 1540396288, 1540396543, 'AM', 'ARM', 'أرمينيا'),
(28885, 1540396544, 1540396799, 'PL', 'POL', 'بولندا'),
(28886, 1540396800, 1540397055, 'RU', 'RUS', 'الإتحاد الروسي'),
(28887, 1540397056, 1540397311, 'IT', 'ITA', 'إيطاليا'),
(28888, 1540397312, 1540397823, 'UA', 'UKR', 'أوكرانيا'),
(28889, 1540397824, 1540398079, 'DE', 'DEU', 'ألمانيا'),
(28890, 1540398080, 1540398335, 'SA', 'SAU', 'السعودية'),
(28891, 1540398336, 1540398591, 'DK', 'DNK', 'الدنيمارك'),
(28892, 1540398592, 1540398847, 'IT', 'ITA', 'إيطاليا'),
(28893, 1540398848, 1540399359, 'DE', 'DEU', 'ألمانيا'),
(28894, 1540399360, 1540399871, 'RU', 'RUS', 'الإتحاد الروسي'),
(28895, 1540399872, 1540400127, 'GB', 'GBR', 'المملكة المتحدة'),
(28896, 1540400128, 1540400383, 'NL', 'NLD', 'هولندا'),
(28897, 1540400384, 1540400639, 'IR', 'IRN', 'إيران'),
(28898, 1540400640, 1540400895, 'RU', 'RUS', 'الإتحاد الروسي'),
(28899, 1540400896, 1540401151, 'NL', 'NLD', 'هولندا'),
(28900, 1540401152, 1540401407, 'SI', 'SVN', 'سلوفينيا'),
(28901, 1540401408, 1540401663, 'AT', 'AUT', 'النمسا'),
(28902, 1540401664, 1540401919, 'GB', 'GBR', 'المملكة المتحدة'),
(28903, 1540401920, 1540402175, 'RU', 'RUS', 'الإتحاد الروسي'),
(28904, 1540402176, 1540402431, 'FR', 'FRA', 'فرنسا'),
(28905, 1540402432, 1540402687, 'CH', 'CHE', 'سويسرا'),
(28906, 1540402688, 1540402943, 'SE', 'SWE', 'السويد'),
(28907, 1540402944, 1540403199, 'NL', 'NLD', 'هولندا'),
(28908, 1540403200, 1540403455, 'AT', 'AUT', 'النمسا'),
(28909, 1540403456, 1540403711, 'GB', 'GBR', 'المملكة المتحدة'),
(28910, 1540403712, 1540404223, 'RO', 'ROM', 'رومانيا'),
(28911, 1540404224, 1540404479, 'CH', 'CHE', 'سويسرا'),
(28912, 1540404480, 1540404735, 'FR', 'FRA', 'فرنسا'),
(28913, 1540404736, 1540404991, 'PL', 'POL', 'بولندا'),
(28914, 1540404992, 1540405247, 'RU', 'RUS', 'الإتحاد الروسي'),
(28915, 1540405248, 1540405503, 'GB', 'GBR', 'المملكة المتحدة'),
(28916, 1540405504, 1540405759, 'RU', 'RUS', 'الإتحاد الروسي'),
(28917, 1540405760, 1540406015, 'PL', 'POL', 'بولندا'),
(28918, 1540406016, 1540406271, 'RU', 'RUS', 'الإتحاد الروسي'),
(28919, 1540406272, 1540406527, 'SE', 'SWE', 'السويد'),
(28920, 1540406528, 1540407039, 'PL', 'POL', 'بولندا'),
(28921, 1540407040, 1540407807, 'DE', 'DEU', 'ألمانيا'),
(28922, 1540407808, 1540408063, 'UA', 'UKR', 'أوكرانيا'),
(28923, 1540408064, 1540408319, 'IT', 'ITA', 'إيطاليا'),
(28924, 1540408320, 1540408575, 'NL', 'NLD', 'هولندا'),
(28925, 1540408576, 1540408831, 'HR', 'HRV', 'كرواتيا'),
(28926, 1540408832, 1540409087, 'UA', 'UKR', 'أوكرانيا'),
(28927, 1540409088, 1540409343, 'TR', 'TUR', 'تركيا'),
(28928, 1540409344, 1540409599, 'SI', 'SVN', 'سلوفينيا'),
(28929, 1540409600, 1540409855, 'AT', 'AUT', 'النمسا'),
(28930, 1540409856, 1540410111, 'DE', 'DEU', 'ألمانيا'),
(28931, 1540410112, 1540410367, 'KW', 'KWT', 'الكويت'),
(28932, 1540410368, 1540410623, 'CH', 'CHE', 'سويسرا'),
(28933, 1540410624, 1540410879, 'RU', 'RUS', 'الإتحاد الروسي'),
(28934, 1540410880, 1540411135, 'TR', 'TUR', 'تركيا'),
(28935, 1540411136, 1540411391, 'SG', 'SGP', 'سنغافورة'),
(28936, 1540411392, 1540411647, 'RU', 'RUS', 'الإتحاد الروسي'),
(28937, 1540411648, 1540411903, 'FR', 'FRA', 'فرنسا'),
(28938, 1540411904, 1540412159, 'RU', 'RUS', 'الإتحاد الروسي'),
(28939, 1540412160, 1540412415, 'BE', 'BEL', 'بلجيكا'),
(28940, 1540412416, 1540412671, 'DE', 'DEU', 'ألمانيا'),
(28941, 1540412672, 1540412927, 'RO', 'ROM', 'رومانيا'),
(28942, 1540412928, 1540413183, 'FR', 'FRA', 'فرنسا'),
(28943, 1540413184, 1540413439, 'RO', 'ROM', 'رومانيا'),
(28944, 1540413440, 1540413695, 'RU', 'RUS', 'الإتحاد الروسي'),
(28945, 1540413696, 1540413951, 'AT', 'AUT', 'النمسا'),
(28946, 1540413952, 1540414207, 'IL', 'ISR', 'إسرائيل'),
(28947, 1540414208, 1540414463, 'GB', 'GBR', 'المملكة المتحدة'),
(28948, 1540414464, 1540414719, 'BE', 'BEL', 'بلجيكا'),
(28949, 1540414720, 1540414975, 'SE', 'SWE', 'السويد'),
(28950, 1540414976, 1540415231, 'FR', 'FRA', 'فرنسا'),
(28951, 1540415232, 1540415487, 'RO', 'ROM', 'رومانيا'),
(28952, 1540415488, 1540415743, 'FR', 'FRA', 'فرنسا'),
(28953, 1540415744, 1540415999, 'SI', 'SVN', 'سلوفينيا'),
(28954, 1540416000, 1540416255, 'FR', 'FRA', 'فرنسا'),
(28955, 1540416256, 1540416511, 'CH', 'CHE', 'سويسرا'),
(28956, 1540416512, 1540416767, 'RU', 'RUS', 'الإتحاد الروسي'),
(28957, 1540416768, 1540417023, 'NL', 'NLD', 'هولندا'),
(28958, 1540417024, 1540417279, 'RU', 'RUS', 'الإتحاد الروسي'),
(28959, 1540417536, 1540417791, 'RU', 'RUS', 'الإتحاد الروسي'),
(28960, 1540417792, 1540418047, 'HR', 'HRV', 'كرواتيا'),
(28961, 1540418048, 1540418559, 'RO', 'ROM', 'رومانيا'),
(28962, 1540418560, 1540418815, 'AT', 'AUT', 'النمسا'),
(28963, 1540418816, 1540419071, 'FR', 'FRA', 'فرنسا'),
(28964, 1540419072, 1540419327, 'RU', 'RUS', 'الإتحاد الروسي'),
(28965, 1540419328, 1540419839, 'GB', 'GBR', 'المملكة المتحدة'),
(28966, 1540419840, 1540420095, 'NL', 'NLD', 'هولندا'),
(28967, 1540420096, 1540420607, 'GB', 'GBR', 'المملكة المتحدة'),
(28968, 1540420608, 1540420863, 'DE', 'DEU', 'ألمانيا'),
(28969, 1540420864, 1540421119, 'GB', 'GBR', 'المملكة المتحدة'),
(28970, 1540421120, 1540421375, 'RU', 'RUS', 'الإتحاد الروسي'),
(28971, 1540421376, 1540421631, 'PL', 'POL', 'بولندا'),
(28972, 1540421632, 1540422143, 'RU', 'RUS', 'الإتحاد الروسي'),
(28973, 1540422144, 1540422399, 'PL', 'POL', 'بولندا'),
(28974, 1540422400, 1540422655, 'UA', 'UKR', 'أوكرانيا'),
(28975, 1540422656, 1540422911, 'GB', 'GBR', 'المملكة المتحدة'),
(28976, 1540422912, 1540423423, 'RU', 'RUS', 'الإتحاد الروسي'),
(28977, 1540423424, 1540423679, 'BA', 'BIH', 'البوسنه والهرسك'),
(28978, 1540423680, 1540423935, 'SE', 'SWE', 'السويد'),
(28979, 1540423936, 1540424191, 'UA', 'UKR', 'أوكرانيا'),
(28980, 1540424192, 1540424447, 'AT', 'AUT', 'النمسا'),
(28981, 1540424448, 1540424703, 'ES', 'ESP', 'إسبانيا'),
(28982, 1540424704, 1540424959, 'PL', 'POL', 'بولندا'),
(28983, 1540424960, 1540425215, 'RO', 'ROM', 'رومانيا'),
(28984, 1540425216, 1540425471, 'US', 'USA', 'الولايات المتحدة'),
(28985, 1540425472, 1540425727, 'NL', 'NLD', 'هولندا'),
(28986, 1540425728, 1540425983, 'BG', 'BGR', 'بلغاريا'),
(28987, 1540425984, 1540426239, 'DE', 'DEU', 'ألمانيا'),
(28988, 1540426240, 1540426495, 'IE', 'IRL', 'إيرلندا'),
(28989, 1540426496, 1540426751, 'UA', 'UKR', 'أوكرانيا'),
(28990, 1540426752, 1540427263, 'NL', 'NLD', 'هولندا'),
(28991, 1540427264, 1540427519, 'RU', 'RUS', 'الإتحاد الروسي'),
(28992, 1540427520, 1540427775, 'FR', 'FRA', 'فرنسا'),
(28993, 1540427776, 1540428287, 'RU', 'RUS', 'الإتحاد الروسي'),
(28994, 1540428288, 1540428543, 'SI', 'SVN', 'سلوفينيا'),
(28995, 1540428544, 1540428799, 'FR', 'FRA', 'فرنسا'),
(28996, 1540428800, 1540429055, 'PL', 'POL', 'بولندا'),
(28997, 1540429056, 1540429311, 'BG', 'BGR', 'بلغاريا'),
(28998, 1540429312, 1540429823, 'RO', 'ROM', 'رومانيا'),
(28999, 1540429824, 1540430079, 'UA', 'UKR', 'أوكرانيا'),
(29000, 1540430080, 1540430335, 'FR', 'FRA', 'فرنسا'),
(29001, 1540430336, 1540430591, 'DE', 'DEU', 'ألمانيا'),
(29002, 1540430592, 1540430847, 'PL', 'POL', 'بولندا'),
(29003, 1540430848, 1540431103, 'CH', 'CHE', 'سويسرا'),
(29004, 1540431104, 1540431359, 'FI', 'FIN', 'فنلندا'),
(29005, 1540431360, 1540431615, 'NO', 'NOR', 'النرويج'),
(29006, 1540431616, 1540431871, 'GB', 'GBR', 'المملكة المتحدة'),
(29007, 1540431872, 1540432127, 'HR', 'HRV', 'كرواتيا'),
(29008, 1540432128, 1540432383, 'AT', 'AUT', 'النمسا'),
(29009, 1540432384, 1540432639, 'GB', 'GBR', 'المملكة المتحدة'),
(29010, 1540432640, 1540432895, 'FR', 'FRA', 'فرنسا'),
(29011, 1540432896, 1540433151, 'UA', 'UKR', 'أوكرانيا'),
(29012, 1540433152, 1540433407, 'GB', 'GBR', 'المملكة المتحدة'),
(29013, 1540433408, 1540433663, 'AM', 'ARM', 'أرمينيا'),
(29014, 1540433664, 1540433919, 'DK', 'DNK', 'الدنيمارك'),
(29015, 1540433920, 1540434175, 'GB', 'GBR', 'المملكة المتحدة'),
(29016, 1540434176, 1540434431, 'CH', 'CHE', 'سويسرا'),
(29017, 1540434432, 1540434687, 'DE', 'DEU', 'ألمانيا'),
(29018, 1540434688, 1540434943, 'GB', 'GBR', 'المملكة المتحدة'),
(29019, 1540434944, 1540435199, 'FR', 'FRA', 'فرنسا'),
(29020, 1540435200, 1540435455, 'RO', 'ROM', 'رومانيا'),
(29021, 1540435456, 1540435967, 'GR', 'GRC', 'اليونان'),
(29022, 1540435968, 1540436223, 'RU', 'RUS', 'الإتحاد الروسي'),
(29023, 1540436224, 1540436479, 'SI', 'SVN', 'سلوفينيا'),
(29024, 1540436480, 1540436735, 'GB', 'GBR', 'المملكة المتحدة'),
(29025, 1540436736, 1540436991, 'UA', 'UKR', 'أوكرانيا'),
(29026, 1540436992, 1540437247, 'DE', 'DEU', 'ألمانيا'),
(29027, 1540437248, 1540437503, 'CH', 'CHE', 'سويسرا'),
(29028, 1540437504, 1540438015, 'UA', 'UKR', 'أوكرانيا'),
(29029, 1540438016, 1540438271, 'PL', 'POL', 'بولندا'),
(29030, 1540438272, 1540438527, 'LB', 'LBN', 'لبنان'),
(29031, 1540438528, 1540439039, 'RU', 'RUS', 'الإتحاد الروسي'),
(29032, 1540439040, 1540439295, 'NO', 'NOR', 'النرويج'),
(29033, 1540439296, 1540439551, 'RO', 'ROM', 'رومانيا'),
(29034, 1540439552, 1540440063, 'PL', 'POL', 'بولندا'),
(29035, 1540440064, 1540440319, 'UA', 'UKR', 'أوكرانيا'),
(29036, 1540440320, 1540440575, 'RU', 'RUS', 'الإتحاد الروسي'),
(29037, 1540440576, 1540440831, 'MD', 'MDA', 'مولدوفا'),
(29038, 1540440832, 1540441087, 'FR', 'FRA', 'فرنسا'),
(29039, 1540441088, 1540441343, 'PL', 'POL', 'بولندا'),
(29040, 1540441344, 1540441855, 'RU', 'RUS', 'الإتحاد الروسي'),
(29041, 1540441856, 1540442111, 'GB', 'GBR', 'المملكة المتحدة'),
(29042, 1540442112, 1540442367, 'RU', 'RUS', 'الإتحاد الروسي'),
(29043, 1540442368, 1540442623, 'GB', 'GBR', 'المملكة المتحدة'),
(29044, 1540442624, 1540442879, 'IE', 'IRL', 'إيرلندا'),
(29045, 1540442880, 1540443135, 'AT', 'AUT', 'النمسا'),
(29046, 1540443136, 1540443647, 'RU', 'RUS', 'الإتحاد الروسي'),
(29047, 1540443648, 1540443903, 'NL', 'NLD', 'هولندا'),
(29048, 1540443904, 1540444159, 'GB', 'GBR', 'المملكة المتحدة'),
(29049, 1540444160, 1540444415, 'RU', 'RUS', 'الإتحاد الروسي'),
(29050, 1540444416, 1540444671, 'DE', 'DEU', 'ألمانيا'),
(29051, 1540444672, 1540445183, 'GB', 'GBR', 'المملكة المتحدة'),
(29052, 1540445184, 1540445439, 'CH', 'CHE', 'سويسرا'),
(29053, 1540445440, 1540445695, 'RU', 'RUS', 'الإتحاد الروسي'),
(29054, 1540445696, 1540445951, 'GB', 'GBR', 'المملكة المتحدة'),
(29055, 1540445952, 1540446207, 'DE', 'DEU', 'ألمانيا'),
(29056, 1540446208, 1540446463, 'NO', 'NOR', 'النرويج'),
(29057, 1540446464, 1540446719, 'AT', 'AUT', 'النمسا'),
(29058, 1540446720, 1540446975, 'UA', 'UKR', 'أوكرانيا'),
(29059, 1540446976, 1540447231, 'RU', 'RUS', 'الإتحاد الروسي'),
(29060, 1540447232, 1540447487, 'DE', 'DEU', 'ألمانيا'),
(29061, 1540447488, 1540447743, 'PL', 'POL', 'بولندا'),
(29062, 1540447744, 1540447999, 'RU', 'RUS', 'الإتحاد الروسي'),
(29063, 1540448000, 1540448255, 'PL', 'POL', 'بولندا'),
(29064, 1540448256, 1540448511, 'UA', 'UKR', 'أوكرانيا'),
(29065, 1540448512, 1540448767, 'IT', 'ITA', 'إيطاليا'),
(29066, 1540448768, 1540449023, 'CH', 'CHE', 'سويسرا'),
(29067, 1540449024, 1540449279, 'DE', 'DEU', 'ألمانيا'),
(29068, 1540449280, 1540449535, 'UA', 'UKR', 'أوكرانيا'),
(29069, 1540449536, 1540449791, 'CZ', 'CZE', 'التشيك'),
(29070, 1540449792, 1540450047, 'RO', 'ROM', 'رومانيا'),
(29071, 1540450048, 1540450303, 'DE', 'DEU', 'ألمانيا'),
(29072, 1540450304, 1540450559, 'GB', 'GBR', 'المملكة المتحدة'),
(29073, 1540450560, 1540450815, 'AM', 'ARM', 'أرمينيا'),
(29074, 1540450816, 1540451071, 'IE', 'IRL', 'إيرلندا'),
(29075, 1540451072, 1540451327, 'FR', 'FRA', 'فرنسا'),
(29076, 1540451328, 1540451583, 'ES', 'ESP', 'إسبانيا'),
(29077, 1540451584, 1540451839, 'RO', 'ROM', 'رومانيا'),
(29078, 1540451840, 1540452095, 'GB', 'GBR', 'المملكة المتحدة'),
(29079, 1540452096, 1540452351, 'CH', 'CHE', 'سويسرا'),
(29080, 1540452352, 1540452607, 'AT', 'AUT', 'النمسا'),
(29081, 1540452608, 1540452863, 'IL', 'ISR', 'إسرائيل'),
(29082, 1540452864, 1540453119, 'HU', 'HUN', 'هنغاريا'),
(29083, 1540453120, 1540453375, 'RU', 'RUS', 'الإتحاد الروسي'),
(29084, 1540453376, 1540453631, 'PL', 'POL', 'بولندا'),
(29085, 1540453632, 1540453887, 'FR', 'FRA', 'فرنسا'),
(29086, 1540453888, 1540454143, 'UA', 'UKR', 'أوكرانيا'),
(29087, 1540454144, 1540454399, 'RU', 'RUS', 'الإتحاد الروسي'),
(29088, 1540454400, 1540454911, 'DE', 'DEU', 'ألمانيا'),
(29089, 1540454912, 1540455167, 'RU', 'RUS', 'الإتحاد الروسي'),
(29090, 1540455168, 1540455423, 'RO', 'ROM', 'رومانيا'),
(29091, 1540455424, 1540455679, 'RU', 'RUS', 'الإتحاد الروسي'),
(29092, 1540455680, 1540455935, 'GB', 'GBR', 'المملكة المتحدة'),
(29093, 1540455936, 1540456191, 'UA', 'UKR', 'أوكرانيا'),
(29094, 1540456192, 1540457215, 'RU', 'RUS', 'الإتحاد الروسي'),
(29095, 1540457216, 1540457471, 'GE', 'GEO', 'جورجيا'),
(29096, 1540457472, 1540457727, 'SI', 'SVN', 'سلوفينيا'),
(29097, 1540457728, 1540457983, 'BE', 'BEL', 'بلجيكا'),
(29098, 1540457984, 1540458239, 'CH', 'CHE', 'سويسرا'),
(29099, 1540458240, 1540458495, 'ES', 'ESP', 'إسبانيا'),
(29100, 1540458496, 1540458751, 'HR', 'HRV', 'كرواتيا'),
(29101, 1540458752, 1540459007, 'NL', 'NLD', 'هولندا'),
(29102, 1540459008, 1540459519, 'UA', 'UKR', 'أوكرانيا'),
(29103, 1540459520, 1540459775, 'GB', 'GBR', 'المملكة المتحدة'),
(29104, 1540459776, 1540460031, 'PL', 'POL', 'بولندا'),
(29105, 1540460032, 1540460543, 'NL', 'NLD', 'هولندا'),
(29106, 1540460544, 1540460799, 'GB', 'GBR', 'المملكة المتحدة'),
(29107, 1540460800, 1540461055, 'SI', 'SVN', 'سلوفينيا'),
(29108, 1540461056, 1540461311, 'BG', 'BGR', 'بلغاريا'),
(29109, 1540461312, 1540461823, 'RU', 'RUS', 'الإتحاد الروسي'),
(29110, 1540461824, 1540462079, 'RO', 'ROM', 'رومانيا'),
(29111, 1540462080, 1540462335, 'SI', 'SVN', 'سلوفينيا'),
(29112, 1540462336, 1540462591, 'UA', 'UKR', 'أوكرانيا'),
(29113, 1540462592, 1540463103, 'PL', 'POL', 'بولندا'),
(29114, 1540463104, 1540463359, 'FR', 'FRA', 'فرنسا'),
(29115, 1540463360, 1540463615, 'PL', 'POL', 'بولندا'),
(29116, 1540463616, 1540463871, 'DK', 'DNK', 'الدنيمارك'),
(29117, 1540463872, 1540464127, 'UA', 'UKR', 'أوكرانيا'),
(29118, 1540464128, 1540464383, 'CH', 'CHE', 'سويسرا'),
(29119, 1540464384, 1540464895, 'DE', 'DEU', 'ألمانيا'),
(29120, 1540464896, 1540465407, 'GB', 'GBR', 'المملكة المتحدة'),
(29121, 1540465408, 1540465663, 'ES', 'ESP', 'إسبانيا'),
(29122, 1540465664, 1540465919, 'IE', 'IRL', 'إيرلندا'),
(29123, 1540465920, 1540466175, 'UA', 'UKR', 'أوكرانيا'),
(29124, 1540466176, 1540466431, 'DK', 'DNK', 'الدنيمارك'),
(29125, 1540466432, 1540466687, 'RU', 'RUS', 'الإتحاد الروسي'),
(29126, 1540466688, 1540466943, 'NL', 'NLD', 'هولندا'),
(29127, 1540466944, 1540467455, 'CH', 'CHE', 'سويسرا'),
(29128, 1540467456, 1540467711, 'RO', 'ROM', 'رومانيا'),
(29129, 1540467712, 1540467967, 'KW', 'KWT', 'الكويت'),
(29130, 1540467968, 1540468223, 'GR', 'GRC', 'اليونان'),
(29131, 1540468224, 1540468735, 'FR', 'FRA', 'فرنسا'),
(29132, 1540468736, 1540468991, 'UA', 'UKR', 'أوكرانيا'),
(29133, 1540468992, 1540469247, 'PL', 'POL', 'بولندا'),
(29134, 1540469248, 1540469503, 'GB', 'GBR', 'المملكة المتحدة'),
(29135, 1540469504, 1540469759, 'RO', 'ROM', 'رومانيا'),
(29136, 1540469760, 1540470015, 'PL', 'POL', 'بولندا'),
(29137, 1540470016, 1540470271, 'SI', 'SVN', 'سلوفينيا'),
(29138, 1540470272, 1540470527, 'IL', 'ISR', 'إسرائيل'),
(29139, 1540470528, 1540471039, 'RU', 'RUS', 'الإتحاد الروسي'),
(29140, 1540471040, 1540471295, 'DE', 'DEU', 'ألمانيا'),
(29141, 1540471296, 1540471551, 'RU', 'RUS', 'الإتحاد الروسي'),
(29142, 1540471552, 1540471807, 'GB', 'GBR', 'المملكة المتحدة'),
(29143, 1540471808, 1540472063, 'SI', 'SVN', 'سلوفينيا'),
(29144, 1540472064, 1540472319, 'RO', 'ROM', 'رومانيا'),
(29145, 1540472320, 1540472575, 'DK', 'DNK', 'الدنيمارك'),
(29146, 1540472576, 1540472831, 'FR', 'FRA', 'فرنسا'),
(29147, 1540472832, 1540473087, 'NL', 'NLD', 'هولندا'),
(29148, 1540473088, 1540473343, 'UA', 'UKR', 'أوكرانيا'),
(29149, 1540473344, 1540473599, 'IT', 'ITA', 'إيطاليا'),
(29150, 1540473600, 1540473855, 'RO', 'ROM', 'رومانيا'),
(29151, 1540473856, 1540474367, 'GB', 'GBR', 'المملكة المتحدة'),
(29152, 1540474368, 1540474623, 'RO', 'ROM', 'رومانيا'),
(29153, 1540474624, 1540474879, 'PL', 'POL', 'بولندا'),
(29154, 1540474880, 1540475135, 'GB', 'GBR', 'المملكة المتحدة'),
(29155, 1540475136, 1540475903, 'UA', 'UKR', 'أوكرانيا'),
(29156, 1540475904, 1540476159, 'CH', 'CHE', 'سويسرا'),
(29157, 1540476160, 1540476415, 'DE', 'DEU', 'ألمانيا'),
(29158, 1540476416, 1540476671, 'UA', 'UKR', 'أوكرانيا'),
(29159, 1540476672, 1540476927, 'SI', 'SVN', 'سلوفينيا'),
(29160, 1540476928, 1540477183, 'NL', 'NLD', 'هولندا'),
(29161, 1540477184, 1540477439, 'RO', 'ROM', 'رومانيا'),
(29162, 1540477440, 1540477695, 'UA', 'UKR', 'أوكرانيا'),
(29163, 1540477696, 1540477951, 'DE', 'DEU', 'ألمانيا'),
(29164, 1540477952, 1540478207, 'NO', 'NOR', 'النرويج'),
(29165, 1540478208, 1540478463, 'NL', 'NLD', 'هولندا'),
(29166, 1540478464, 1540478719, 'UA', 'UKR', 'أوكرانيا'),
(29167, 1540478720, 1540478975, 'SA', 'SAU', 'السعودية'),
(29168, 1540478976, 1540479231, 'HR', 'HRV', 'كرواتيا'),
(29169, 1540479232, 1540479487, 'GB', 'GBR', 'المملكة المتحدة'),
(29170, 1540479488, 1540479743, 'RU', 'RUS', 'الإتحاد الروسي'),
(29171, 1540479744, 1540479999, 'AT', 'AUT', 'النمسا'),
(29172, 1540480000, 1540480255, 'GB', 'GBR', 'المملكة المتحدة'),
(29173, 1540480256, 1540480767, 'PL', 'POL', 'بولندا'),
(29174, 1540480768, 1540481023, 'GB', 'GBR', 'المملكة المتحدة'),
(29175, 1540481024, 1540481279, 'LT', 'LTU', 'ليتوانيا'),
(29176, 1540481280, 1540481535, 'GB', 'GBR', 'المملكة المتحدة'),
(29177, 1540481536, 1540481791, 'UA', 'UKR', 'أوكرانيا'),
(29178, 1540481792, 1540482047, 'RU', 'RUS', 'الإتحاد الروسي'),
(29179, 1540482048, 1540482303, 'DK', 'DNK', 'الدنيمارك'),
(29180, 1540482304, 1540482559, 'FR', 'FRA', 'فرنسا'),
(29181, 1540482560, 1540482815, 'CH', 'CHE', 'سويسرا'),
(29182, 1540482816, 1540483071, 'DE', 'DEU', 'ألمانيا'),
(29183, 1540483072, 1540483327, 'SE', 'SWE', 'السويد'),
(29184, 1540483328, 1540483839, 'RU', 'RUS', 'الإتحاد الروسي'),
(29185, 1540483840, 1540484095, 'UA', 'UKR', 'أوكرانيا'),
(29186, 1540484096, 1540484351, 'DK', 'DNK', 'الدنيمارك'),
(29187, 1540484352, 1540484607, 'SI', 'SVN', 'سلوفينيا'),
(29188, 1540484608, 1540484863, 'SO', 'SOM', 'الصومال'),
(29189, 1540484864, 1540485119, 'UA', 'UKR', 'أوكرانيا'),
(29190, 1540485376, 1540485631, 'RO', 'ROM', 'رومانيا'),
(29191, 1540485632, 1540485887, 'IR', 'IRN', 'إيران'),
(29192, 1540485888, 1540486143, 'ES', 'ESP', 'إسبانيا'),
(29193, 1540486144, 1540486399, 'GB', 'GBR', 'المملكة المتحدة'),
(29194, 1540486400, 1540486655, 'FR', 'FRA', 'فرنسا'),
(29195, 1540486656, 1540486911, 'GB', 'GBR', 'المملكة المتحدة'),
(29196, 1540486912, 1540487167, 'SK', 'SVK', 'سلوفاكيا'),
(29197, 1540487168, 1540487423, 'PS', 'PSE', 'فلسطين المحتلة'),
(29198, 1540487424, 1540487679, 'UA', 'UKR', 'أوكرانيا'),
(29199, 1540487680, 1540487935, 'DE', 'DEU', 'ألمانيا'),
(29200, 1540487936, 1540488447, 'GB', 'GBR', 'المملكة المتحدة'),
(29201, 1540488448, 1540488703, 'SA', 'SAU', 'السعودية'),
(29202, 1540488704, 1540488959, 'DE', 'DEU', 'ألمانيا'),
(29203, 1540488960, 1540489215, 'RO', 'ROM', 'رومانيا'),
(29204, 1540489216, 1540491263, 'RU', 'RUS', 'الإتحاد الروسي'),
(29205, 1540491264, 1540493311, 'UA', 'UKR', 'أوكرانيا'),
(29206, 1540493312, 1540494335, 'CZ', 'CZE', 'التشيك'),
(29207, 1540494336, 1540495359, 'UA', 'UKR', 'أوكرانيا'),
(29208, 1540495360, 1540496383, 'RU', 'RUS', 'الإتحاد الروسي'),
(29209, 1540496384, 1540499455, 'UA', 'UKR', 'أوكرانيا'),
(29210, 1540499456, 1540500479, 'AM', 'ARM', 'أرمينيا'),
(29211, 1540500480, 1540501503, 'RU', 'RUS', 'الإتحاد الروسي'),
(29212, 1540501504, 1540502527, 'PL', 'POL', 'بولندا'),
(29213, 1540502528, 1540503551, 'RU', 'RUS', 'الإتحاد الروسي'),
(29214, 1540503552, 1540504575, 'NL', 'NLD', 'هولندا'),
(29215, 1540504576, 1540505599, 'SE', 'SWE', 'السويد'),
(29216, 1540505600, 1540506623, 'RU', 'RUS', 'الإتحاد الروسي'),
(29217, 1540506624, 1540507647, 'GB', 'GBR', 'المملكة المتحدة'),
(29218, 1540507648, 1540508671, 'RU', 'RUS', 'الإتحاد الروسي'),
(29219, 1540508672, 1540509695, 'UA', 'UKR', 'أوكرانيا'),
(29220, 1540509696, 1540510719, 'RO', 'ROM', 'رومانيا'),
(29221, 1540510720, 1540511743, 'RU', 'RUS', 'الإتحاد الروسي'),
(29222, 1540511744, 1540512767, 'BG', 'BGR', 'بلغاريا'),
(29223, 1540512768, 1540514815, 'UA', 'UKR', 'أوكرانيا'),
(29224, 1540514816, 1540515839, 'GB', 'GBR', 'المملكة المتحدة'),
(29225, 1540515840, 1540516863, 'RU', 'RUS', 'الإتحاد الروسي'),
(29226, 1540516864, 1540517887, 'UA', 'UKR', 'أوكرانيا'),
(29227, 1540517888, 1540518911, 'RU', 'RUS', 'الإتحاد الروسي'),
(29228, 1540518912, 1540520959, 'UA', 'UKR', 'أوكرانيا'),
(29229, 1540520960, 1540521983, 'RU', 'RUS', 'الإتحاد الروسي'),
(29230, 1540521984, 1540523007, 'PL', 'POL', 'بولندا'),
(29231, 1540523008, 1540524031, 'RU', 'RUS', 'الإتحاد الروسي'),
(29232, 1540524032, 1540525055, 'AL', 'ALB', 'ألبانيا'),
(29233, 1540525056, 1540526079, 'AT', 'AUT', 'النمسا'),
(29234, 1540526080, 1540528127, 'UA', 'UKR', 'أوكرانيا'),
(29235, 1540528128, 1540529151, 'RU', 'RUS', 'الإتحاد الروسي'),
(29236, 1540529152, 1540530175, 'UA', 'UKR', 'أوكرانيا'),
(29237, 1540530176, 1540531199, 'RU', 'RUS', 'الإتحاد الروسي'),
(29238, 1540531200, 1540532223, 'UA', 'UKR', 'أوكرانيا'),
(29239, 1540532224, 1540533247, 'RU', 'RUS', 'الإتحاد الروسي'),
(29240, 1540533248, 1540534271, 'KZ', 'KAZ', 'كازاخستان'),
(29241, 1540534272, 1540535295, 'UA', 'UKR', 'أوكرانيا'),
(29242, 1540535296, 1540536319, 'SK', 'SVK', 'سلوفاكيا'),
(29243, 1540536320, 1540537343, 'RU', 'RUS', 'الإتحاد الروسي'),
(29244, 1540537344, 1540538367, 'UA', 'UKR', 'أوكرانيا'),
(29245, 1540538368, 1540542463, 'RU', 'RUS', 'الإتحاد الروسي'),
(29246, 1540542464, 1540543487, 'PL', 'POL', 'بولندا'),
(29247, 1540543488, 1540544511, 'DE', 'DEU', 'ألمانيا'),
(29248, 1540544512, 1540545535, 'RU', 'RUS', 'الإتحاد الروسي'),
(29249, 1540545536, 1540546559, 'AT', 'AUT', 'النمسا'),
(29250, 1540546560, 1540548607, 'RU', 'RUS', 'الإتحاد الروسي'),
(29251, 1540548608, 1540549631, 'IE', 'IRL', 'إيرلندا'),
(29252, 1540549632, 1540552703, 'PL', 'POL', 'بولندا'),
(29253, 1540552704, 1540553727, 'UA', 'UKR', 'أوكرانيا'),
(29254, 1540553728, 1540555775, 'RU', 'RUS', 'الإتحاد الروسي'),
(29255, 1540555776, 1540556799, 'UZ', 'UZB', 'أوزباكستان'),
(29256, 1540556800, 1540557823, 'GB', 'GBR', 'المملكة المتحدة'),
(29257, 1540557824, 1540559871, 'UA', 'UKR', 'أوكرانيا'),
(29258, 1540559872, 1540562943, 'RU', 'RUS', 'الإتحاد الروسي'),
(29259, 1540562944, 1540563967, 'AT', 'AUT', 'النمسا'),
(29260, 1540563968, 1540564991, 'RU', 'RUS', 'الإتحاد الروسي'),
(29261, 1540564992, 1540566015, 'DE', 'DEU', 'ألمانيا'),
(29262, 1540566016, 1540567039, 'RU', 'RUS', 'الإتحاد الروسي'),
(29263, 1540567040, 1540568063, 'MD', 'MDA', 'مولدوفا'),
(29264, 1540568064, 1540572159, 'RU', 'RUS', 'الإتحاد الروسي'),
(29265, 1540572160, 1540573183, 'UA', 'UKR', 'أوكرانيا'),
(29266, 1540573184, 1540574207, 'NL', 'NLD', 'هولندا'),
(29267, 1540574208, 1540576255, 'RU', 'RUS', 'الإتحاد الروسي'),
(29268, 1540576256, 1540577279, 'PL', 'POL', 'بولندا'),
(29269, 1540577280, 1540579327, 'RU', 'RUS', 'الإتحاد الروسي'),
(29270, 1540579328, 1540580351, 'IE', 'IRL', 'إيرلندا'),
(29271, 1540580352, 1540581375, 'PL', 'POL', 'بولندا'),
(29272, 1540581376, 1540582399, 'RU', 'RUS', 'الإتحاد الروسي'),
(29273, 1540582400, 1540583423, 'BG', 'BGR', 'بلغاريا'),
(29274, 1540583424, 1540584447, 'DE', 'DEU', 'ألمانيا'),
(29275, 1540584448, 1540586495, 'UA', 'UKR', 'أوكرانيا'),
(29276, 1540586496, 1540588543, 'RU', 'RUS', 'الإتحاد الروسي'),
(29277, 1540588544, 1540589567, 'UA', 'UKR', 'أوكرانيا'),
(29278, 1540589568, 1540593663, 'RU', 'RUS', 'الإتحاد الروسي'),
(29279, 1540593664, 1540594687, 'GB', 'GBR', 'المملكة المتحدة'),
(29280, 1540594688, 1540595711, 'IT', 'ITA', 'إيطاليا'),
(29281, 1540595712, 1540596735, 'KZ', 'KAZ', 'كازاخستان'),
(29282, 1540596736, 1540597759, 'FR', 'FRA', 'فرنسا'),
(29283, 1540597760, 1540598783, 'SE', 'SWE', 'السويد'),
(29284, 1540598784, 1540600831, 'UA', 'UKR', 'أوكرانيا'),
(29285, 1540600832, 1540602879, 'RU', 'RUS', 'الإتحاد الروسي'),
(29286, 1540602880, 1540603903, 'BG', 'BGR', 'بلغاريا'),
(29287, 1540603904, 1540605951, 'RU', 'RUS', 'الإتحاد الروسي'),
(29288, 1540605952, 1540606975, 'MD', 'MDA', 'مولدوفا'),
(29289, 1540606976, 1540607999, 'UA', 'UKR', 'أوكرانيا'),
(29290, 1540608000, 1540609023, 'RU', 'RUS', 'الإتحاد الروسي'),
(29291, 1540609024, 1540610047, 'UA', 'UKR', 'أوكرانيا'),
(29292, 1540610048, 1540611071, 'RU', 'RUS', 'الإتحاد الروسي'),
(29293, 1540611072, 1540612095, 'PL', 'POL', 'بولندا'),
(29294, 1540612096, 1540613119, 'TR', 'TUR', 'تركيا'),
(29295, 1540613120, 1540614143, 'RU', 'RUS', 'الإتحاد الروسي'),
(29296, 1540614144, 1540615167, 'BG', 'BGR', 'بلغاريا'),
(29297, 1540615168, 1540616191, 'RU', 'RUS', 'الإتحاد الروسي'),
(29298, 1540616192, 1540617215, 'AT', 'AUT', 'النمسا'),
(29299, 1540617216, 1540618239, 'LT', 'LTU', 'ليتوانيا'),
(29300, 1540618240, 1540619263, 'UA', 'UKR', 'أوكرانيا'),
(29301, 1540619264, 1540620287, 'PL', 'POL', 'بولندا'),
(29302, 1540620288, 1540620543, 'NL', 'NLD', 'هولندا'),
(29303, 1540620544, 1540620799, 'LB', 'LBN', 'لبنان'),
(29304, 1540620800, 1540621055, 'PL', 'POL', 'بولندا'),
(29305, 1540621056, 1540621311, 'DE', 'DEU', 'ألمانيا'),
(29306, 1540621312, 1540621567, 'BA', 'BIH', 'البوسنه والهرسك'),
(29307, 1540621568, 1540621823, 'PL', 'POL', 'بولندا'),
(29308, 1540621824, 1540622335, 'RU', 'RUS', 'الإتحاد الروسي'),
(29309, 1540622336, 1540622591, 'KW', 'KWT', 'الكويت'),
(29310, 1540622592, 1540622847, 'PL', 'POL', 'بولندا'),
(29311, 1540622848, 1540623103, 'RU', 'RUS', 'الإتحاد الروسي'),
(29312, 1540623104, 1540623359, 'SE', 'SWE', 'السويد'),
(29313, 1540623360, 1540623615, 'GB', 'GBR', 'المملكة المتحدة'),
(29314, 1540623616, 1540623871, 'BG', 'BGR', 'بلغاريا'),
(29315, 1540623872, 1540624127, 'RO', 'ROM', 'رومانيا'),
(29316, 1540624128, 1540624383, 'RS', 'SRB', 'صربيا'),
(29317, 1540624384, 1540624639, 'IR', 'IRN', 'إيران'),
(29318, 1540624640, 1540624895, 'BG', 'BGR', 'بلغاريا'),
(29319, 1540624896, 1540625151, 'GB', 'GBR', 'المملكة المتحدة'),
(29320, 1540625152, 1540625407, 'IR', 'IRN', 'إيران'),
(29321, 1540625408, 1540625663, 'RU', 'RUS', 'الإتحاد الروسي'),
(29322, 1540625664, 1540625919, 'FR', 'FRA', 'فرنسا'),
(29323, 1540625920, 1540626175, 'UA', 'UKR', 'أوكرانيا'),
(29324, 1540626176, 1540626431, 'RO', 'ROM', 'رومانيا'),
(29325, 1540626432, 1540626687, 'SI', 'SVN', 'سلوفينيا'),
(29326, 1540626688, 1540626943, 'PL', 'POL', 'بولندا'),
(29327, 1540626944, 1540627199, 'FR', 'FRA', 'فرنسا'),
(29328, 1540627200, 1540627455, 'PL', 'POL', 'بولندا'),
(29329, 1540627456, 1540627711, 'DK', 'DNK', 'الدنيمارك'),
(29330, 1540627712, 1540627967, 'CH', 'CHE', 'سويسرا'),
(29331, 1540627968, 1540628223, 'PL', 'POL', 'بولندا'),
(29332, 1540628224, 1540628479, 'HR', 'HRV', 'كرواتيا'),
(29333, 1540628480, 1540628735, 'KW', 'KWT', 'الكويت'),
(29334, 1540628736, 1540628991, 'PL', 'POL', 'بولندا'),
(29335, 1540628992, 1540629247, 'UA', 'UKR', 'أوكرانيا'),
(29336, 1540629248, 1540629503, 'RO', 'ROM', 'رومانيا'),
(29337, 1540629504, 1540629759, 'DK', 'DNK', 'الدنيمارك'),
(29338, 1540629760, 1540630015, 'BG', 'BGR', 'بلغاريا'),
(29339, 1540630016, 1540630271, 'DE', 'DEU', 'ألمانيا'),
(29340, 1540630272, 1540630527, 'RO', 'ROM', 'رومانيا'),
(29341, 1540630528, 1540630783, 'CH', 'CHE', 'سويسرا'),
(29342, 1540630784, 1540631039, 'RU', 'RUS', 'الإتحاد الروسي'),
(29343, 1540631040, 1540631295, 'NL', 'NLD', 'هولندا'),
(29344, 1540631296, 1540631551, 'CH', 'CHE', 'سويسرا'),
(29345, 1540631552, 1540631807, 'HR', 'HRV', 'كرواتيا'),
(29346, 1540631808, 1540632063, 'LV', 'LVA', 'لاتفيا'),
(29347, 1540632064, 1540632319, 'AT', 'AUT', 'النمسا'),
(29348, 1540632320, 1540632575, 'RU', 'RUS', 'الإتحاد الروسي'),
(29349, 1540632576, 1540632831, 'DK', 'DNK', 'الدنيمارك'),
(29350, 1540632832, 1540633087, 'GB', 'GBR', 'المملكة المتحدة'),
(29351, 1540633088, 1540633343, 'RU', 'RUS', 'الإتحاد الروسي'),
(29352, 1540633344, 1540633599, 'CH', 'CHE', 'سويسرا'),
(29353, 1540633600, 1540633855, 'RO', 'ROM', 'رومانيا'),
(29354, 1540633856, 1540634367, 'GB', 'GBR', 'المملكة المتحدة'),
(29355, 1540634368, 1540634623, 'FR', 'FRA', 'فرنسا'),
(29356, 1540634624, 1540634879, 'UA', 'UKR', 'أوكرانيا'),
(29357, 1540634880, 1540635135, 'RU', 'RUS', 'الإتحاد الروسي'),
(29358, 1540635136, 1540635391, 'FR', 'FRA', 'فرنسا'),
(29359, 1540635392, 1540635647, 'RO', 'ROM', 'رومانيا'),
(29360, 1540635648, 1540636159, 'RU', 'RUS', 'الإتحاد الروسي'),
(29361, 1540636160, 1540636415, 'RO', 'ROM', 'رومانيا'),
(29362, 1540636416, 1540636671, 'LV', 'LVA', 'لاتفيا'),
(29363, 1540636672, 1540636927, 'RU', 'RUS', 'الإتحاد الروسي'),
(29364, 1540636928, 1540637183, 'UA', 'UKR', 'أوكرانيا'),
(29365, 1540637184, 1540637439, 'RO', 'ROM', 'رومانيا'),
(29366, 1540637440, 1540637695, 'SA', 'SAU', 'السعودية'),
(29367, 1540637696, 1540637951, 'RU', 'RUS', 'الإتحاد الروسي'),
(29368, 1540637952, 1540638207, 'RS', 'SRB', 'صربيا'),
(29369, 1540638208, 1540638463, 'RO', 'ROM', 'رومانيا'),
(29370, 1540638464, 1540638719, 'AM', 'ARM', 'أرمينيا'),
(29371, 1540638720, 1540638975, 'UA', 'UKR', 'أوكرانيا'),
(29372, 1540638976, 1540639487, 'RO', 'ROM', 'رومانيا'),
(29373, 1540639488, 1540639743, 'CH', 'CHE', 'سويسرا'),
(29374, 1540639744, 1540639999, 'IL', 'ISR', 'إسرائيل'),
(29375, 1540640000, 1540640255, 'CH', 'CHE', 'سويسرا'),
(29376, 1540640256, 1540640511, 'FR', 'FRA', 'فرنسا'),
(29377, 1540640512, 1540640767, 'ES', 'ESP', 'إسبانيا'),
(29378, 1540640768, 1540641023, 'UA', 'UKR', 'أوكرانيا'),
(29379, 1540641024, 1540641535, 'RU', 'RUS', 'الإتحاد الروسي'),
(29380, 1540641536, 1540641791, 'DE', 'DEU', 'ألمانيا'),
(29381, 1540641792, 1540642047, 'PL', 'POL', 'بولندا'),
(29382, 1540642048, 1540642303, 'DE', 'DEU', 'ألمانيا'),
(29383, 1540642304, 1540642559, 'PL', 'POL', 'بولندا'),
(29384, 1540642560, 1540642815, 'DE', 'DEU', 'ألمانيا'),
(29385, 1540642816, 1540643071, 'IE', 'IRL', 'إيرلندا'),
(29386, 1540643072, 1540643327, 'UZ', 'UZB', 'أوزباكستان'),
(29387, 1540643328, 1540643583, 'GB', 'GBR', 'المملكة المتحدة'),
(29388, 1540643584, 1540643839, 'CH', 'CHE', 'سويسرا'),
(29389, 1540643840, 1540644095, 'NO', 'NOR', 'النرويج'),
(29390, 1540644096, 1540644607, 'GB', 'GBR', 'المملكة المتحدة'),
(29391, 1540644608, 1540644863, 'DE', 'DEU', 'ألمانيا'),
(29392, 1540644864, 1540645119, 'NL', 'NLD', 'هولندا'),
(29393, 1540645120, 1540645375, 'RU', 'RUS', 'الإتحاد الروسي'),
(29394, 1540645376, 1540645631, 'BE', 'BEL', 'بلجيكا'),
(29395, 1540645632, 1540645887, 'NL', 'NLD', 'هولندا'),
(29396, 1540645888, 1540646143, 'PL', 'POL', 'بولندا'),
(29397, 1540646144, 1540646399, 'RO', 'ROM', 'رومانيا'),
(29398, 1540646400, 1540646655, 'PS', 'PSE', 'فلسطين المحتلة'),
(29399, 1540646656, 1540646911, 'SE', 'SWE', 'السويد'),
(29400, 1540646912, 1540647167, 'RU', 'RUS', 'الإتحاد الروسي'),
(29401, 1540647168, 1540647423, 'GB', 'GBR', 'المملكة المتحدة'),
(29402, 1540647424, 1540647679, 'RU', 'RUS', 'الإتحاد الروسي'),
(29403, 1540647680, 1540647935, 'CY', 'CYP', 'قبرص'),
(29404, 1540647936, 1540648191, 'GB', 'GBR', 'المملكة المتحدة'),
(29405, 1540648192, 1540648447, 'CH', 'CHE', 'سويسرا'),
(29406, 1540648448, 1540648959, 'RO', 'ROM', 'رومانيا'),
(29407, 1540648960, 1540649215, 'FR', 'FRA', 'فرنسا'),
(29408, 1540649216, 1540649471, 'DE', 'DEU', 'ألمانيا'),
(29409, 1540649472, 1540649727, 'IL', 'ISR', 'إسرائيل'),
(29410, 1540649728, 1540649983, 'GB', 'GBR', 'المملكة المتحدة'),
(29411, 1540649984, 1540650239, 'FR', 'FRA', 'فرنسا'),
(29412, 1540650240, 1540650495, 'CH', 'CHE', 'سويسرا'),
(29413, 1540650496, 1540650751, 'RU', 'RUS', 'الإتحاد الروسي'),
(29414, 1540650752, 1540651007, 'FR', 'FRA', 'فرنسا'),
(29415, 1540651008, 1540651263, 'RO', 'ROM', 'رومانيا'),
(29416, 1540651264, 1540651519, 'CH', 'CHE', 'سويسرا'),
(29417, 1540651520, 1540651775, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(29418, 1540651776, 1540652031, 'RU', 'RUS', 'الإتحاد الروسي'),
(29419, 1540652032, 1540652543, 'UA', 'UKR', 'أوكرانيا'),
(29420, 1540652544, 1540652799, 'TR', 'TUR', 'تركيا'),
(29421, 1540653056, 1540653311, 'FR', 'FRA', 'فرنسا'),
(29422, 1540653312, 1540653567, 'DK', 'DNK', 'الدنيمارك'),
(29423, 1540653568, 1540653823, 'DE', 'DEU', 'ألمانيا'),
(29424, 1540653824, 1540654079, 'GB', 'GBR', 'المملكة المتحدة'),
(29425, 1540654080, 1540654335, 'RS', 'SRB', 'صربيا'),
(29426, 1540654336, 1540654591, 'RU', 'RUS', 'الإتحاد الروسي'),
(29427, 1540654592, 1540654847, 'SI', 'SVN', 'سلوفينيا'),
(29428, 1540654848, 1540655103, 'RU', 'RUS', 'الإتحاد الروسي'),
(29429, 1540655104, 1540655359, 'AT', 'AUT', 'النمسا'),
(29430, 1540655360, 1540655615, 'RU', 'RUS', 'الإتحاد الروسي'),
(29431, 1540655616, 1540655871, 'GB', 'GBR', 'المملكة المتحدة'),
(29432, 1540655872, 1540656383, 'NL', 'NLD', 'هولندا'),
(29433, 1540656384, 1540656895, 'RU', 'RUS', 'الإتحاد الروسي'),
(29434, 1540656896, 1540657151, 'RO', 'ROM', 'رومانيا'),
(29435, 1540657152, 1540657407, 'DE', 'DEU', 'ألمانيا'),
(29436, 1540657408, 1540657663, 'CY', 'CYP', 'قبرص'),
(29437, 1540657664, 1540657919, 'RU', 'RUS', 'الإتحاد الروسي'),
(29438, 1540657920, 1540658175, 'FR', 'FRA', 'فرنسا'),
(29439, 1540658176, 1540658431, 'RO', 'ROM', 'رومانيا'),
(29440, 1540658432, 1540659199, 'RU', 'RUS', 'الإتحاد الروسي'),
(29441, 1540659200, 1540659455, 'FR', 'FRA', 'فرنسا'),
(29442, 1540659456, 1540659967, 'UA', 'UKR', 'أوكرانيا'),
(29443, 1540659968, 1540660223, 'PL', 'POL', 'بولندا'),
(29444, 1540660224, 1540660479, 'UA', 'UKR', 'أوكرانيا'),
(29445, 1540660480, 1540660735, 'FR', 'FRA', 'فرنسا'),
(29446, 1540660736, 1540660991, 'UA', 'UKR', 'أوكرانيا'),
(29447, 1540660992, 1540661247, 'RO', 'ROM', 'رومانيا'),
(29448, 1540661248, 1540661503, 'GB', 'GBR', 'المملكة المتحدة'),
(29449, 1540661504, 1540662015, 'RO', 'ROM', 'رومانيا'),
(29450, 1540662016, 1540662271, 'BG', 'BGR', 'بلغاريا'),
(29451, 1540662272, 1540662527, 'RO', 'ROM', 'رومانيا'),
(29452, 1540662528, 1540662783, 'PL', 'POL', 'بولندا'),
(29453, 1540662784, 1540663039, 'GB', 'GBR', 'المملكة المتحدة'),
(29454, 1540663040, 1540663295, 'IT', 'ITA', 'إيطاليا'),
(29455, 1540663296, 1540663551, 'RU', 'RUS', 'الإتحاد الروسي'),
(29456, 1540663552, 1540664063, 'PL', 'POL', 'بولندا'),
(29457, 1540664064, 1540664319, 'RU', 'RUS', 'الإتحاد الروسي'),
(29458, 1540664320, 1540664575, 'PL', 'POL', 'بولندا'),
(29459, 1540664576, 1540665087, 'UA', 'UKR', 'أوكرانيا'),
(29460, 1540665088, 1540665343, 'ES', 'ESP', 'إسبانيا'),
(29461, 1540665344, 1540665599, 'NL', 'NLD', 'هولندا'),
(29462, 1540665600, 1540665855, 'UA', 'UKR', 'أوكرانيا'),
(29463, 1540665856, 1540666111, 'TR', 'TUR', 'تركيا'),
(29464, 1540666112, 1540666367, 'RU', 'RUS', 'الإتحاد الروسي'),
(29465, 1540666368, 1540666623, 'UZ', 'UZB', 'أوزباكستان'),
(29466, 1540666624, 1540666879, 'DE', 'DEU', 'ألمانيا'),
(29467, 1540666880, 1540667135, 'GB', 'GBR', 'المملكة المتحدة'),
(29468, 1540667136, 1540667647, 'NL', 'NLD', 'هولندا'),
(29469, 1540667648, 1540668159, 'BE', 'BEL', 'بلجيكا'),
(29470, 1540668160, 1540668415, 'AT', 'AUT', 'النمسا'),
(29471, 1540668416, 1540668671, 'SE', 'SWE', 'السويد'),
(29472, 1540668672, 1540668927, 'IL', 'ISR', 'إسرائيل'),
(29473, 1540668928, 1540669695, 'RO', 'ROM', 'رومانيا'),
(29474, 1540669696, 1540669951, 'KZ', 'KAZ', 'كازاخستان'),
(29475, 1540670208, 1540670463, 'RU', 'RUS', 'الإتحاد الروسي'),
(29476, 1540670464, 1540670719, 'CH', 'CHE', 'سويسرا'),
(29477, 1540670720, 1540671231, 'RU', 'RUS', 'الإتحاد الروسي'),
(29478, 1540671232, 1540671487, 'SI', 'SVN', 'سلوفينيا'),
(29479, 1540671488, 1540671743, 'CH', 'CHE', 'سويسرا'),
(29480, 1540671744, 1540671999, 'BG', 'BGR', 'بلغاريا'),
(29481, 1540672000, 1540672255, 'FR', 'FRA', 'فرنسا'),
(29482, 1540672256, 1540672511, 'UA', 'UKR', 'أوكرانيا'),
(29483, 1540672512, 1540672767, 'DE', 'DEU', 'ألمانيا'),
(29484, 1540672768, 1540673023, 'FR', 'FRA', 'فرنسا'),
(29485, 1540673024, 1540673279, 'DE', 'DEU', 'ألمانيا'),
(29486, 1540673280, 1540673535, 'SE', 'SWE', 'السويد'),
(29487, 1540673536, 1540673791, 'SI', 'SVN', 'سلوفينيا'),
(29488, 1540673792, 1540674047, 'SE', 'SWE', 'السويد'),
(29489, 1540674048, 1540674303, 'GB', 'GBR', 'المملكة المتحدة'),
(29490, 1540674304, 1540674559, 'FR', 'FRA', 'فرنسا'),
(29491, 1540674560, 1540674815, 'GB', 'GBR', 'المملكة المتحدة'),
(29492, 1540674816, 1540675071, 'GE', 'GEO', 'جورجيا'),
(29493, 1540675072, 1540675327, 'UA', 'UKR', 'أوكرانيا'),
(29494, 1540675328, 1540675583, 'NL', 'NLD', 'هولندا'),
(29495, 1540675584, 1540675839, 'GB', 'GBR', 'المملكة المتحدة'),
(29496, 1540675840, 1540676351, 'RU', 'RUS', 'الإتحاد الروسي'),
(29497, 1540676352, 1540676607, 'IT', 'ITA', 'إيطاليا'),
(29498, 1540676608, 1540677119, 'RU', 'RUS', 'الإتحاد الروسي'),
(29499, 1540677120, 1540677375, 'GB', 'GBR', 'المملكة المتحدة'),
(29500, 1540677376, 1540677631, 'PL', 'POL', 'بولندا'),
(29501, 1540677632, 1540677887, 'DK', 'DNK', 'الدنيمارك'),
(29502, 1540677888, 1540678143, 'DE', 'DEU', 'ألمانيا'),
(29503, 1540678144, 1540678399, 'RU', 'RUS', 'الإتحاد الروسي'),
(29504, 1540678400, 1540678655, 'RO', 'ROM', 'رومانيا'),
(29505, 1540678656, 1540678911, 'SE', 'SWE', 'السويد'),
(29506, 1540678912, 1540679167, 'RO', 'ROM', 'رومانيا'),
(29507, 1540679168, 1540679423, 'RU', 'RUS', 'الإتحاد الروسي'),
(29508, 1540679424, 1540679679, 'PL', 'POL', 'بولندا'),
(29509, 1540679680, 1540679935, 'LT', 'LTU', 'ليتوانيا'),
(29510, 1540679936, 1540680191, 'BG', 'BGR', 'بلغاريا'),
(29511, 1540680192, 1540680447, 'CH', 'CHE', 'سويسرا'),
(29512, 1540680448, 1540680703, 'BG', 'BGR', 'بلغاريا'),
(29513, 1540680704, 1540680959, 'FR', 'FRA', 'فرنسا'),
(29514, 1540680960, 1540681215, 'NL', 'NLD', 'هولندا'),
(29515, 1540681216, 1540681471, 'FR', 'FRA', 'فرنسا'),
(29516, 1540681472, 1540681727, 'RU', 'RUS', 'الإتحاد الروسي'),
(29517, 1540681728, 1540681983, 'TR', 'TUR', 'تركيا'),
(29518, 1540681984, 1540682239, 'IT', 'ITA', 'إيطاليا'),
(29519, 1540682240, 1540682495, 'PL', 'POL', 'بولندا'),
(29520, 1540682496, 1540682751, 'DE', 'DEU', 'ألمانيا'),
(29521, 1540682752, 1540683007, 'EE', 'EST', 'إستونيا'),
(29522, 1540683008, 1540683263, 'DE', 'DEU', 'ألمانيا'),
(29523, 1540683264, 1540683775, 'HR', 'HRV', 'كرواتيا'),
(29524, 1540683776, 1540684031, 'UA', 'UKR', 'أوكرانيا'),
(29525, 1540684032, 1540684287, 'IT', 'ITA', 'إيطاليا'),
(29526, 1540684288, 1540684543, 'HU', 'HUN', 'هنغاريا'),
(29527, 1540684544, 1540684799, 'SI', 'SVN', 'سلوفينيا'),
(29528, 1540684800, 1540685055, 'IR', 'IRN', 'إيران'),
(29529, 1540685056, 1540685311, 'UA', 'UKR', 'أوكرانيا'),
(29530, 1540685312, 1540685567, 'RO', 'ROM', 'رومانيا'),
(29531, 1540685568, 1540685823, 'FR', 'FRA', 'فرنسا'),
(29532, 1540685824, 1540686079, 'SE', 'SWE', 'السويد'),
(29533, 1540686080, 1540686335, 'TR', 'TUR', 'تركيا'),
(29534, 1540686336, 1540686591, 'CH', 'CHE', 'سويسرا'),
(29535, 1540686592, 1540686847, 'GB', 'GBR', 'المملكة المتحدة'),
(29536, 1540686848, 1540687103, 'CH', 'CHE', 'سويسرا'),
(29537, 1540687104, 1540687359, 'RU', 'RUS', 'الإتحاد الروسي'),
(29538, 1540687360, 1540687615, 'AT', 'AUT', 'النمسا'),
(29539, 1540687616, 1540687871, 'IT', 'ITA', 'إيطاليا'),
(29540, 1540687872, 1540688127, 'UA', 'UKR', 'أوكرانيا'),
(29541, 1540688128, 1540688383, 'HU', 'HUN', 'هنغاريا'),
(29542, 1540688384, 1540688639, 'CZ', 'CZE', 'التشيك'),
(29543, 1540688640, 1540688895, 'RO', 'ROM', 'رومانيا'),
(29544, 1540688896, 1540689151, 'BG', 'BGR', 'بلغاريا'),
(29545, 1540689152, 1540689407, 'NL', 'NLD', 'هولندا'),
(29546, 1540689408, 1540689663, 'RU', 'RUS', 'الإتحاد الروسي'),
(29547, 1540689664, 1540689919, 'FR', 'FRA', 'فرنسا'),
(29548, 1540689920, 1540690175, 'RO', 'ROM', 'رومانيا'),
(29549, 1540690176, 1540690431, 'DK', 'DNK', 'الدنيمارك'),
(29550, 1540690432, 1540690687, 'SA', 'SAU', 'السعودية'),
(29551, 1540690688, 1540690943, 'RO', 'ROM', 'رومانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(29552, 1540690944, 1540691711, 'DE', 'DEU', 'ألمانيا'),
(29553, 1540691712, 1540691967, 'RU', 'RUS', 'الإتحاد الروسي'),
(29554, 1540691968, 1540692223, 'CH', 'CHE', 'سويسرا'),
(29555, 1540692224, 1540692479, 'FR', 'FRA', 'فرنسا'),
(29556, 1540692480, 1540692735, 'BE', 'BEL', 'بلجيكا'),
(29557, 1540692736, 1540692991, 'DE', 'DEU', 'ألمانيا'),
(29558, 1540692992, 1540693247, 'GB', 'GBR', 'المملكة المتحدة'),
(29559, 1540693248, 1540693503, 'RU', 'RUS', 'الإتحاد الروسي'),
(29560, 1540693504, 1540693759, 'ES', 'ESP', 'إسبانيا'),
(29561, 1540693760, 1540694015, 'UZ', 'UZB', 'أوزباكستان'),
(29562, 1540694016, 1540694271, 'CH', 'CHE', 'سويسرا'),
(29563, 1540694272, 1540694527, 'RU', 'RUS', 'الإتحاد الروسي'),
(29564, 1540694528, 1540695039, 'RO', 'ROM', 'رومانيا'),
(29565, 1540695040, 1540695295, 'DE', 'DEU', 'ألمانيا'),
(29566, 1540695296, 1540695551, 'NL', 'NLD', 'هولندا'),
(29567, 1540695552, 1540695807, 'PL', 'POL', 'بولندا'),
(29568, 1540695808, 1540696063, 'RU', 'RUS', 'الإتحاد الروسي'),
(29569, 1540696064, 1540696319, 'HU', 'HUN', 'هنغاريا'),
(29570, 1540696320, 1540696575, 'FR', 'FRA', 'فرنسا'),
(29571, 1540696576, 1540696831, 'GB', 'GBR', 'المملكة المتحدة'),
(29572, 1540696832, 1540697087, 'EE', 'EST', 'إستونيا'),
(29573, 1540697088, 1540697343, 'RU', 'RUS', 'الإتحاد الروسي'),
(29574, 1540697344, 1540697599, 'GB', 'GBR', 'المملكة المتحدة'),
(29575, 1540697600, 1540697855, 'ES', 'ESP', 'إسبانيا'),
(29576, 1540697856, 1540698111, 'NO', 'NOR', 'النرويج'),
(29577, 1540698112, 1540698367, 'DE', 'DEU', 'ألمانيا'),
(29578, 1540698368, 1540698623, 'IE', 'IRL', 'إيرلندا'),
(29579, 1540698880, 1540699135, 'RU', 'RUS', 'الإتحاد الروسي'),
(29580, 1540699136, 1540699391, 'GR', 'GRC', 'اليونان'),
(29581, 1540699392, 1540699647, 'NL', 'NLD', 'هولندا'),
(29582, 1540699648, 1540699903, 'AT', 'AUT', 'النمسا'),
(29583, 1540699904, 1540700159, 'RO', 'ROM', 'رومانيا'),
(29584, 1540700160, 1540700415, 'DE', 'DEU', 'ألمانيا'),
(29585, 1540700416, 1540700671, 'RO', 'ROM', 'رومانيا'),
(29586, 1540700672, 1540700927, 'PL', 'POL', 'بولندا'),
(29587, 1540700928, 1540701183, 'UA', 'UKR', 'أوكرانيا'),
(29588, 1540701184, 1540701695, 'DE', 'DEU', 'ألمانيا'),
(29589, 1540701696, 1540701951, 'UA', 'UKR', 'أوكرانيا'),
(29590, 1540701952, 1540702207, 'GB', 'GBR', 'المملكة المتحدة'),
(29591, 1540702208, 1540702463, 'PL', 'POL', 'بولندا'),
(29592, 1540702464, 1540702719, 'PT', 'PRT', 'البورتوغال'),
(29593, 1540702720, 1540702975, 'AT', 'AUT', 'النمسا'),
(29594, 1540702976, 1540703231, 'RU', 'RUS', 'الإتحاد الروسي'),
(29595, 1540703232, 1540703487, 'MH', 'MHL', 'جزر مارشال'),
(29596, 1540703488, 1540703743, 'NL', 'NLD', 'هولندا'),
(29597, 1540703744, 1540703999, 'DK', 'DNK', 'الدنيمارك'),
(29598, 1540704000, 1540704255, 'PL', 'POL', 'بولندا'),
(29599, 1540704256, 1540704511, 'KZ', 'KAZ', 'كازاخستان'),
(29600, 1540704512, 1540704767, 'IE', 'IRL', 'إيرلندا'),
(29601, 1540704768, 1540705023, 'UA', 'UKR', 'أوكرانيا'),
(29602, 1540705024, 1540705279, 'HU', 'HUN', 'هنغاريا'),
(29603, 1540705280, 1540705535, 'RO', 'ROM', 'رومانيا'),
(29604, 1540705536, 1540705791, 'AT', 'AUT', 'النمسا'),
(29605, 1540705792, 1540706047, 'NL', 'NLD', 'هولندا'),
(29606, 1540706048, 1540706303, 'FR', 'FRA', 'فرنسا'),
(29607, 1540706304, 1540706559, 'SI', 'SVN', 'سلوفينيا'),
(29608, 1540706560, 1540706815, 'GB', 'GBR', 'المملكة المتحدة'),
(29609, 1540706816, 1540707071, 'FR', 'FRA', 'فرنسا'),
(29610, 1540707072, 1540707583, 'GB', 'GBR', 'المملكة المتحدة'),
(29611, 1540707584, 1540707839, 'NL', 'NLD', 'هولندا'),
(29612, 1540707840, 1540708095, 'MD', 'MDA', 'مولدوفا'),
(29613, 1540708096, 1540708351, 'RU', 'RUS', 'الإتحاد الروسي'),
(29614, 1540708352, 1540708607, 'PL', 'POL', 'بولندا'),
(29615, 1540708608, 1540708863, 'SI', 'SVN', 'سلوفينيا'),
(29616, 1540708864, 1540709119, 'FR', 'FRA', 'فرنسا'),
(29617, 1540709120, 1540709375, 'DE', 'DEU', 'ألمانيا'),
(29618, 1540709376, 1540709631, 'UA', 'UKR', 'أوكرانيا'),
(29619, 1540709632, 1540709887, 'KZ', 'KAZ', 'كازاخستان'),
(29620, 1540709888, 1540710143, 'UA', 'UKR', 'أوكرانيا'),
(29621, 1540710144, 1540710399, 'NL', 'NLD', 'هولندا'),
(29622, 1540710400, 1540710655, 'PL', 'POL', 'بولندا'),
(29623, 1540710656, 1540710911, 'FI', 'FIN', 'فنلندا'),
(29624, 1540710912, 1540711423, 'DE', 'DEU', 'ألمانيا'),
(29625, 1540711424, 1540711679, 'CH', 'CHE', 'سويسرا'),
(29626, 1540711680, 1540711935, 'RO', 'ROM', 'رومانيا'),
(29627, 1540711936, 1540712191, 'FR', 'FRA', 'فرنسا'),
(29628, 1540712192, 1540712447, 'DE', 'DEU', 'ألمانيا'),
(29629, 1540712448, 1540712703, 'RU', 'RUS', 'الإتحاد الروسي'),
(29630, 1540712704, 1540713215, 'LV', 'LVA', 'لاتفيا'),
(29631, 1540713216, 1540713727, 'PL', 'POL', 'بولندا'),
(29632, 1540713728, 1540713983, 'RU', 'RUS', 'الإتحاد الروسي'),
(29633, 1540713984, 1540714239, 'GB', 'GBR', 'المملكة المتحدة'),
(29634, 1540714240, 1540714495, 'RO', 'ROM', 'رومانيا'),
(29635, 1540714496, 1540714751, 'NL', 'NLD', 'هولندا'),
(29636, 1540714752, 1540715519, 'RU', 'RUS', 'الإتحاد الروسي'),
(29637, 1540715520, 1540715775, 'DE', 'DEU', 'ألمانيا'),
(29638, 1540715776, 1540716031, 'UA', 'UKR', 'أوكرانيا'),
(29639, 1540716032, 1540716287, 'PL', 'POL', 'بولندا'),
(29640, 1540716288, 1540716543, 'UA', 'UKR', 'أوكرانيا'),
(29641, 1540716544, 1540716799, 'RU', 'RUS', 'الإتحاد الروسي'),
(29642, 1540716800, 1540717055, 'UA', 'UKR', 'أوكرانيا'),
(29643, 1540717056, 1540717311, 'CZ', 'CZE', 'التشيك'),
(29644, 1540717312, 1540717823, 'PL', 'POL', 'بولندا'),
(29645, 1540717824, 1540718079, 'UA', 'UKR', 'أوكرانيا'),
(29646, 1540718080, 1540718335, 'CR', 'CRI', 'كوستا ريكا'),
(29647, 1540718336, 1540718591, 'DE', 'DEU', 'ألمانيا'),
(29648, 1540718592, 1540718847, 'CH', 'CHE', 'سويسرا'),
(29649, 1540718848, 1540719103, 'IT', 'ITA', 'إيطاليا'),
(29650, 1540719104, 1540719359, 'RU', 'RUS', 'الإتحاد الروسي'),
(29651, 1540719360, 1540719615, 'SI', 'SVN', 'سلوفينيا'),
(29652, 1540719616, 1540719871, 'AT', 'AUT', 'النمسا'),
(29653, 1540719872, 1540720127, 'CH', 'CHE', 'سويسرا'),
(29654, 1540720128, 1540720383, 'NL', 'NLD', 'هولندا'),
(29655, 1540720384, 1540720639, 'RO', 'ROM', 'رومانيا'),
(29656, 1540720896, 1540721151, 'PL', 'POL', 'بولندا'),
(29657, 1540721152, 1540721663, 'RU', 'RUS', 'الإتحاد الروسي'),
(29658, 1540721664, 1540721919, 'GB', 'GBR', 'المملكة المتحدة'),
(29659, 1540721920, 1540722431, 'RU', 'RUS', 'الإتحاد الروسي'),
(29660, 1540722432, 1540722687, 'CZ', 'CZE', 'التشيك'),
(29661, 1540722688, 1540722943, 'RU', 'RUS', 'الإتحاد الروسي'),
(29662, 1540722944, 1540723455, 'FR', 'FRA', 'فرنسا'),
(29663, 1540723456, 1540723711, 'SI', 'SVN', 'سلوفينيا'),
(29664, 1540723712, 1540723967, 'RU', 'RUS', 'الإتحاد الروسي'),
(29665, 1540723968, 1540724223, 'UA', 'UKR', 'أوكرانيا'),
(29666, 1540724224, 1540724479, 'HU', 'HUN', 'هنغاريا'),
(29667, 1540724480, 1540724735, 'DE', 'DEU', 'ألمانيا'),
(29668, 1540724736, 1540724991, 'CH', 'CHE', 'سويسرا'),
(29669, 1540724992, 1540725247, 'IT', 'ITA', 'إيطاليا'),
(29670, 1540725248, 1540725503, 'UA', 'UKR', 'أوكرانيا'),
(29671, 1540725504, 1540725759, 'SE', 'SWE', 'السويد'),
(29672, 1540725760, 1540726015, 'PL', 'POL', 'بولندا'),
(29673, 1540726016, 1540726271, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(29674, 1540726272, 1540726527, 'RU', 'RUS', 'الإتحاد الروسي'),
(29675, 1540726528, 1540726783, 'CH', 'CHE', 'سويسرا'),
(29676, 1540726784, 1540727039, 'CZ', 'CZE', 'التشيك'),
(29677, 1540727040, 1540727295, 'FI', 'FIN', 'فنلندا'),
(29678, 1540727296, 1540727551, 'PL', 'POL', 'بولندا'),
(29679, 1540727552, 1540727807, 'RU', 'RUS', 'الإتحاد الروسي'),
(29680, 1540727808, 1540728063, 'GB', 'GBR', 'المملكة المتحدة'),
(29681, 1540728064, 1540728319, 'NL', 'NLD', 'هولندا'),
(29682, 1540728320, 1540729343, 'RU', 'RUS', 'الإتحاد الروسي'),
(29683, 1540729344, 1540729599, 'PL', 'POL', 'بولندا'),
(29684, 1540729600, 1540729855, 'CH', 'CHE', 'سويسرا'),
(29685, 1540729856, 1540730111, 'RU', 'RUS', 'الإتحاد الروسي'),
(29686, 1540730112, 1540730367, 'GB', 'GBR', 'المملكة المتحدة'),
(29687, 1540730368, 1540730623, 'RU', 'RUS', 'الإتحاد الروسي'),
(29688, 1540730624, 1540730879, 'UA', 'UKR', 'أوكرانيا'),
(29689, 1540730880, 1540731135, 'IL', 'ISR', 'إسرائيل'),
(29690, 1540731136, 1540731391, 'DE', 'DEU', 'ألمانيا'),
(29691, 1540731392, 1540731647, 'NL', 'NLD', 'هولندا'),
(29692, 1540731648, 1540731903, 'SE', 'SWE', 'السويد'),
(29693, 1540731904, 1540732159, 'FR', 'FRA', 'فرنسا'),
(29694, 1540732160, 1540732415, 'MD', 'MDA', 'مولدوفا'),
(29695, 1540732416, 1540732671, 'UA', 'UKR', 'أوكرانيا'),
(29696, 1540732672, 1540732927, 'GB', 'GBR', 'المملكة المتحدة'),
(29697, 1540732928, 1540733183, 'RU', 'RUS', 'الإتحاد الروسي'),
(29698, 1540733184, 1540733439, 'UA', 'UKR', 'أوكرانيا'),
(29699, 1540733440, 1540733695, 'RU', 'RUS', 'الإتحاد الروسي'),
(29700, 1540733696, 1540733951, 'UA', 'UKR', 'أوكرانيا'),
(29701, 1540733952, 1540734207, 'GB', 'GBR', 'المملكة المتحدة'),
(29702, 1540734208, 1540734463, 'RU', 'RUS', 'الإتحاد الروسي'),
(29703, 1540734464, 1540734719, 'NL', 'NLD', 'هولندا'),
(29704, 1540734720, 1540734975, 'IQ', 'IRQ', 'العراق'),
(29705, 1540734976, 1540735231, 'UA', 'UKR', 'أوكرانيا'),
(29706, 1540735232, 1540735487, 'PL', 'POL', 'بولندا'),
(29707, 1540735488, 1540735743, 'CH', 'CHE', 'سويسرا'),
(29708, 1540735744, 1540735999, 'NL', 'NLD', 'هولندا'),
(29709, 1540736000, 1540736255, 'RU', 'RUS', 'الإتحاد الروسي'),
(29710, 1540736256, 1540736511, 'IT', 'ITA', 'إيطاليا'),
(29711, 1540736512, 1540736767, 'DE', 'DEU', 'ألمانيا'),
(29712, 1540736768, 1540737791, 'GB', 'GBR', 'المملكة المتحدة'),
(29713, 1540737792, 1540738047, 'NO', 'NOR', 'النرويج'),
(29714, 1540738048, 1540738303, 'AT', 'AUT', 'النمسا'),
(29715, 1540738304, 1540738559, 'SA', 'SAU', 'السعودية'),
(29716, 1540738560, 1540738815, 'PL', 'POL', 'بولندا'),
(29717, 1540738816, 1540739071, 'DE', 'DEU', 'ألمانيا'),
(29718, 1540739072, 1540739327, 'SE', 'SWE', 'السويد'),
(29719, 1540739328, 1540739583, 'PA', 'PAN', 'بنما'),
(29720, 1540739584, 1540739839, 'IT', 'ITA', 'إيطاليا'),
(29721, 1540739840, 1540740095, 'CZ', 'CZE', 'التشيك'),
(29722, 1540740096, 1540740351, 'GB', 'GBR', 'المملكة المتحدة'),
(29723, 1540740352, 1540740607, 'SA', 'SAU', 'السعودية'),
(29724, 1540740608, 1540740863, 'NL', 'NLD', 'هولندا'),
(29725, 1540740864, 1540741119, 'RO', 'ROM', 'رومانيا'),
(29726, 1540741120, 1540741375, 'GB', 'GBR', 'المملكة المتحدة'),
(29727, 1540741632, 1540742143, 'NL', 'NLD', 'هولندا'),
(29728, 1540742144, 1540742399, 'RU', 'RUS', 'الإتحاد الروسي'),
(29729, 1540742400, 1540742655, 'DE', 'DEU', 'ألمانيا'),
(29730, 1540742656, 1540742911, 'AT', 'AUT', 'النمسا'),
(29731, 1540742912, 1540743167, 'RU', 'RUS', 'الإتحاد الروسي'),
(29732, 1540743168, 1540743423, 'NO', 'NOR', 'النرويج'),
(29733, 1540743424, 1540743679, 'RU', 'RUS', 'الإتحاد الروسي'),
(29734, 1540743680, 1540743935, 'GB', 'GBR', 'المملكة المتحدة'),
(29735, 1540743936, 1540744191, 'CH', 'CHE', 'سويسرا'),
(29736, 1540744192, 1540744447, 'GR', 'GRC', 'اليونان'),
(29737, 1540744448, 1540744703, 'UA', 'UKR', 'أوكرانيا'),
(29738, 1540744704, 1540744959, 'GB', 'GBR', 'المملكة المتحدة'),
(29739, 1540744960, 1540745215, 'UA', 'UKR', 'أوكرانيا'),
(29740, 1540745216, 1540745471, 'DE', 'DEU', 'ألمانيا'),
(29741, 1540745472, 1540745727, 'KG', 'KGZ', 'قيرغيزستان'),
(29742, 1540745728, 1540746239, 'AT', 'AUT', 'النمسا'),
(29743, 1540746240, 1540746495, 'FR', 'FRA', 'فرنسا'),
(29744, 1540746496, 1540747263, 'PL', 'POL', 'بولندا'),
(29745, 1540747264, 1540747519, 'RU', 'RUS', 'الإتحاد الروسي'),
(29746, 1540747520, 1540747775, 'SI', 'SVN', 'سلوفينيا'),
(29747, 1540747776, 1540748031, 'FR', 'FRA', 'فرنسا'),
(29748, 1540748032, 1540748287, 'RU', 'RUS', 'الإتحاد الروسي'),
(29749, 1540748288, 1540748543, 'CZ', 'CZE', 'التشيك'),
(29750, 1540748544, 1540748799, 'TR', 'TUR', 'تركيا'),
(29751, 1540748800, 1540749055, 'SE', 'SWE', 'السويد'),
(29752, 1540749056, 1540749311, 'RU', 'RUS', 'الإتحاد الروسي'),
(29753, 1540749312, 1540749567, 'UZ', 'UZB', 'أوزباكستان'),
(29754, 1540749568, 1540749823, 'RU', 'RUS', 'الإتحاد الروسي'),
(29755, 1540749824, 1540750079, 'SE', 'SWE', 'السويد'),
(29756, 1540750080, 1540750335, 'BE', 'BEL', 'بلجيكا'),
(29757, 1540750336, 1540750591, 'GB', 'GBR', 'المملكة المتحدة'),
(29758, 1540750592, 1540751103, 'TR', 'TUR', 'تركيا'),
(29759, 1540751104, 1540752383, 'PL', 'POL', 'بولندا'),
(29760, 1540752384, 1540753407, 'GB', 'GBR', 'المملكة المتحدة'),
(29761, 1540753408, 1540754431, 'DE', 'DEU', 'ألمانيا'),
(29762, 1540754432, 1540755455, 'RO', 'ROM', 'رومانيا'),
(29763, 1540755456, 1540756479, 'UA', 'UKR', 'أوكرانيا'),
(29764, 1540756480, 1540757503, 'DK', 'DNK', 'الدنيمارك'),
(29765, 1540757504, 1540758527, 'PL', 'POL', 'بولندا'),
(29766, 1540758528, 1540760575, 'UA', 'UKR', 'أوكرانيا'),
(29767, 1540760576, 1540761599, 'PL', 'POL', 'بولندا'),
(29768, 1540761600, 1540762623, 'RU', 'RUS', 'الإتحاد الروسي'),
(29769, 1540762624, 1540763647, 'LU', 'LUX', 'لوكسيمبورغ'),
(29770, 1540763648, 1540764671, 'UA', 'UKR', 'أوكرانيا'),
(29771, 1540764672, 1540765695, 'PL', 'POL', 'بولندا'),
(29772, 1540765696, 1540766719, 'RU', 'RUS', 'الإتحاد الروسي'),
(29773, 1540766720, 1540767743, 'IT', 'ITA', 'إيطاليا'),
(29774, 1540767744, 1540768767, 'GB', 'GBR', 'المملكة المتحدة'),
(29775, 1540768768, 1540769791, 'RU', 'RUS', 'الإتحاد الروسي'),
(29776, 1540769792, 1540770815, 'IT', 'ITA', 'إيطاليا'),
(29777, 1540770816, 1540771839, 'RU', 'RUS', 'الإتحاد الروسي'),
(29778, 1540771840, 1540773887, 'UA', 'UKR', 'أوكرانيا'),
(29779, 1540773888, 1540774911, 'SE', 'SWE', 'السويد'),
(29780, 1540774912, 1540775935, 'GB', 'GBR', 'المملكة المتحدة'),
(29781, 1540775936, 1540776959, 'RU', 'RUS', 'الإتحاد الروسي'),
(29782, 1540776960, 1540777983, 'IL', 'ISR', 'إسرائيل'),
(29783, 1540777984, 1540779007, 'HR', 'HRV', 'كرواتيا'),
(29784, 1540779008, 1540780031, 'NL', 'NLD', 'هولندا'),
(29785, 1540780032, 1540781055, 'UA', 'UKR', 'أوكرانيا'),
(29786, 1540781056, 1540783103, 'RU', 'RUS', 'الإتحاد الروسي'),
(29787, 1540783104, 1540787199, 'UA', 'UKR', 'أوكرانيا'),
(29788, 1540787200, 1540788223, 'KZ', 'KAZ', 'كازاخستان'),
(29789, 1540788224, 1540790271, 'RU', 'RUS', 'الإتحاد الروسي'),
(29790, 1540790272, 1540791295, 'KW', 'KWT', 'الكويت'),
(29791, 1540791296, 1540792319, 'CZ', 'CZE', 'التشيك'),
(29792, 1540792320, 1540793343, 'UA', 'UKR', 'أوكرانيا'),
(29793, 1540793344, 1540794367, 'FI', 'FIN', 'فنلندا'),
(29794, 1540794368, 1540795391, 'CH', 'CHE', 'سويسرا'),
(29795, 1540795392, 1540796415, 'RU', 'RUS', 'الإتحاد الروسي'),
(29796, 1540796416, 1540798463, 'UA', 'UKR', 'أوكرانيا'),
(29797, 1540798464, 1540799487, 'RU', 'RUS', 'الإتحاد الروسي'),
(29798, 1540799488, 1540800511, 'RO', 'ROM', 'رومانيا'),
(29799, 1540800512, 1540801535, 'CZ', 'CZE', 'التشيك'),
(29800, 1540801536, 1540802559, 'RU', 'RUS', 'الإتحاد الروسي'),
(29801, 1540802560, 1540803583, 'MD', 'MDA', 'مولدوفا'),
(29802, 1540803584, 1540804607, 'RU', 'RUS', 'الإتحاد الروسي'),
(29803, 1540804608, 1540805631, 'UA', 'UKR', 'أوكرانيا'),
(29804, 1540805632, 1540809727, 'RU', 'RUS', 'الإتحاد الروسي'),
(29805, 1540809728, 1540810751, 'GB', 'GBR', 'المملكة المتحدة'),
(29806, 1540810752, 1540811775, 'UA', 'UKR', 'أوكرانيا'),
(29807, 1540811776, 1540812799, 'PL', 'POL', 'بولندا'),
(29808, 1540812800, 1540813823, 'RU', 'RUS', 'الإتحاد الروسي'),
(29809, 1540813824, 1540815871, 'UA', 'UKR', 'أوكرانيا'),
(29810, 1540815872, 1540816895, 'DE', 'DEU', 'ألمانيا'),
(29811, 1540816896, 1540817919, 'PL', 'POL', 'بولندا'),
(29812, 1540817920, 1540818943, 'NL', 'NLD', 'هولندا'),
(29813, 1540818944, 1540819967, 'UA', 'UKR', 'أوكرانيا'),
(29814, 1540819968, 1540820991, 'CZ', 'CZE', 'التشيك'),
(29815, 1540820992, 1540822015, 'RU', 'RUS', 'الإتحاد الروسي'),
(29816, 1540822016, 1540823039, 'FR', 'FRA', 'فرنسا'),
(29817, 1540823040, 1540824063, 'UA', 'UKR', 'أوكرانيا'),
(29818, 1540824064, 1540825087, 'RU', 'RUS', 'الإتحاد الروسي'),
(29819, 1540825088, 1540826111, 'PL', 'POL', 'بولندا'),
(29820, 1540826112, 1540828159, 'RU', 'RUS', 'الإتحاد الروسي'),
(29821, 1540828160, 1540829183, 'PL', 'POL', 'بولندا'),
(29822, 1540829184, 1540830207, 'RU', 'RUS', 'الإتحاد الروسي'),
(29823, 1540830208, 1540833279, 'UA', 'UKR', 'أوكرانيا'),
(29824, 1540833280, 1540834303, 'ES', 'ESP', 'إسبانيا'),
(29825, 1540834304, 1540835327, 'UA', 'UKR', 'أوكرانيا'),
(29826, 1540835328, 1540836351, 'DE', 'DEU', 'ألمانيا'),
(29827, 1540836352, 1540837375, 'RU', 'RUS', 'الإتحاد الروسي'),
(29828, 1540837376, 1540838399, 'PL', 'POL', 'بولندا'),
(29829, 1540838400, 1540840447, 'RU', 'RUS', 'الإتحاد الروسي'),
(29830, 1540840448, 1540841471, 'SE', 'SWE', 'السويد'),
(29831, 1540841472, 1540842495, 'RO', 'ROM', 'رومانيا'),
(29832, 1540842496, 1540843519, 'DE', 'DEU', 'ألمانيا'),
(29833, 1540843520, 1540844543, 'PL', 'POL', 'بولندا'),
(29834, 1540844544, 1540846591, 'RU', 'RUS', 'الإتحاد الروسي'),
(29835, 1540846592, 1540847615, 'DE', 'DEU', 'ألمانيا'),
(29836, 1540847616, 1540848639, 'RU', 'RUS', 'الإتحاد الروسي'),
(29837, 1540848640, 1540849663, 'UA', 'UKR', 'أوكرانيا'),
(29838, 1540849664, 1540850687, 'RU', 'RUS', 'الإتحاد الروسي'),
(29839, 1540850688, 1540851711, 'FI', 'FIN', 'فنلندا'),
(29840, 1540851712, 1540852735, 'UA', 'UKR', 'أوكرانيا'),
(29841, 1540852736, 1540853759, 'RU', 'RUS', 'الإتحاد الروسي'),
(29842, 1540853760, 1540854783, 'UA', 'UKR', 'أوكرانيا'),
(29843, 1540854784, 1540855807, 'NL', 'NLD', 'هولندا'),
(29844, 1540855808, 1540856831, 'RU', 'RUS', 'الإتحاد الروسي'),
(29845, 1540856832, 1540857855, 'NL', 'NLD', 'هولندا'),
(29846, 1540857856, 1540858879, 'DK', 'DNK', 'الدنيمارك'),
(29847, 1540858880, 1540859903, 'GB', 'GBR', 'المملكة المتحدة'),
(29848, 1540859904, 1540860927, 'RU', 'RUS', 'الإتحاد الروسي'),
(29849, 1540860928, 1540861951, 'KZ', 'KAZ', 'كازاخستان'),
(29850, 1540861952, 1540862975, 'BY', 'BLR', 'روسيا البيضاء'),
(29851, 1540862976, 1540865023, 'GB', 'GBR', 'المملكة المتحدة'),
(29852, 1540865024, 1540872191, 'RU', 'RUS', 'الإتحاد الروسي'),
(29853, 1540872192, 1540873215, 'BG', 'BGR', 'بلغاريا'),
(29854, 1540873216, 1540875263, 'RU', 'RUS', 'الإتحاد الروسي'),
(29855, 1540875264, 1540876287, 'PL', 'POL', 'بولندا'),
(29856, 1540876288, 1540877311, 'RU', 'RUS', 'الإتحاد الروسي'),
(29857, 1540878336, 1540879359, 'AT', 'AUT', 'النمسا'),
(29858, 1540879360, 1540880383, 'RU', 'RUS', 'الإتحاد الروسي'),
(29859, 1540880384, 1540881407, 'UA', 'UKR', 'أوكرانيا'),
(29860, 1540881408, 1540882431, 'RU', 'RUS', 'الإتحاد الروسي'),
(29861, 1540882432, 1540882687, 'SE', 'SWE', 'السويد'),
(29862, 1540882688, 1540883199, 'LV', 'LVA', 'لاتفيا'),
(29863, 1540883200, 1540883455, 'RU', 'RUS', 'الإتحاد الروسي'),
(29864, 1540883456, 1540883711, 'IR', 'IRN', 'إيران'),
(29865, 1540883712, 1540883967, 'PL', 'POL', 'بولندا'),
(29866, 1540883968, 1540884223, 'IE', 'IRL', 'إيرلندا'),
(29867, 1540884224, 1540884479, 'SE', 'SWE', 'السويد'),
(29868, 1540884480, 1540884991, 'GB', 'GBR', 'المملكة المتحدة'),
(29869, 1540884992, 1540885247, 'BE', 'BEL', 'بلجيكا'),
(29870, 1540885248, 1540885503, 'UA', 'UKR', 'أوكرانيا'),
(29871, 1540885504, 1540885759, 'ES', 'ESP', 'إسبانيا'),
(29872, 1540885760, 1540886015, 'DE', 'DEU', 'ألمانيا'),
(29873, 1540886016, 1540886271, 'DK', 'DNK', 'الدنيمارك'),
(29874, 1540886272, 1540886527, 'UA', 'UKR', 'أوكرانيا'),
(29875, 1540886528, 1540886783, 'PL', 'POL', 'بولندا'),
(29876, 1540886784, 1540887039, 'IT', 'ITA', 'إيطاليا'),
(29877, 1540887040, 1540887295, 'GB', 'GBR', 'المملكة المتحدة'),
(29878, 1540887296, 1540887551, 'FR', 'FRA', 'فرنسا'),
(29879, 1540887552, 1540887807, 'BE', 'BEL', 'بلجيكا'),
(29880, 1540887808, 1540888063, 'MD', 'MDA', 'مولدوفا'),
(29881, 1540888064, 1540888319, 'UA', 'UKR', 'أوكرانيا'),
(29882, 1540888320, 1540888575, 'DE', 'DEU', 'ألمانيا'),
(29883, 1543503872, 1545601023, 'GB', 'GBR', 'المملكة المتحدة'),
(29884, 1545601024, 1545863167, 'SE', 'SWE', 'السويد'),
(29885, 1545863168, 1545895935, 'RU', 'RUS', 'الإتحاد الروسي'),
(29886, 1545895936, 1545928703, 'BA', 'BIH', 'البوسنه والهرسك'),
(29887, 1545928704, 1545961471, 'SI', 'SVN', 'سلوفينيا'),
(29888, 1545961472, 1545994239, 'RU', 'RUS', 'الإتحاد الروسي'),
(29889, 1545994240, 1546027007, 'CZ', 'CZE', 'التشيك'),
(29890, 1546027008, 1546059775, 'RU', 'RUS', 'الإتحاد الروسي'),
(29891, 1546059776, 1546063871, 'SE', 'SWE', 'السويد'),
(29892, 1546063872, 1546067967, 'DE', 'DEU', 'ألمانيا'),
(29893, 1546067968, 1546072063, 'SE', 'SWE', 'السويد'),
(29894, 1546072064, 1546076159, 'MD', 'MDA', 'مولدوفا'),
(29895, 1546076160, 1546080255, 'RU', 'RUS', 'الإتحاد الروسي'),
(29896, 1546080256, 1546084351, 'AZ', 'AZE', 'أذربيجان'),
(29897, 1546084352, 1546088447, 'RU', 'RUS', 'الإتحاد الروسي'),
(29898, 1546088448, 1546088575, 'SN', 'SEN', 'السنغال'),
(29899, 1546088576, 1546088703, 'TM', 'TKM', 'تركمينيستان'),
(29900, 1546088704, 1546088831, 'BA', 'BIH', 'البوسنه والهرسك'),
(29901, 1546088832, 1546088959, 'TJ', 'TJK', 'طاجيكيستان'),
(29902, 1546088960, 1546089087, 'SD', 'SDN', 'السودان'),
(29903, 1546089088, 1546089215, 'DE', 'DEU', 'ألمانيا'),
(29904, 1546089216, 1546089343, 'MW', 'MWI', 'ملاوي'),
(29905, 1546089344, 1546089471, 'ZW', 'ZWE', 'زمبابواي'),
(29906, 1546089472, 1546089599, 'BI', 'BDI', 'بوروندي'),
(29907, 1546089600, 1546089727, 'GW', 'GNB', 'غينيا بيساو'),
(29908, 1546089728, 1546089855, 'LS', 'LSO', 'ليسوتو'),
(29909, 1546089856, 1546089983, 'NE', 'NER', 'النيجر'),
(29910, 1546089984, 1546090111, 'DE', 'DEU', 'ألمانيا'),
(29911, 1546090112, 1546090239, 'MR', 'MRT', 'موريتانيا'),
(29912, 1546090240, 1546090367, 'ZM', 'ZMB', 'زامبيا'),
(29913, 1546090368, 1546090495, 'MG', 'MDG', 'مدغشقر'),
(29914, 1546090496, 1546090623, 'BW', 'BWA', 'بوتسوانا'),
(29915, 1546090624, 1546090751, 'GH', 'GHA', 'غانا'),
(29916, 1546090752, 1546090879, 'ER', 'ERI', 'إريتريا'),
(29917, 1546090880, 1546091007, 'AO', 'AGO', 'أنغولا'),
(29918, 1546091008, 1546091135, 'NA', 'NAM', 'ناميبيا'),
(29919, 1546091136, 1546091263, 'KM', 'COM', 'جزر القمر'),
(29920, 1546091264, 1546091391, 'GN', 'GIN', 'غينيا'),
(29921, 1546091392, 1546091519, 'HT', 'HTI', 'هايتي'),
(29922, 1546091520, 1546091647, 'AF', 'AFG', 'أفغانستان'),
(29923, 1546091648, 1546091775, 'TD', 'TCD', 'تشاد'),
(29924, 1546091776, 1546091903, 'BF', 'BFA', 'بوركينا فاسو'),
(29925, 1546091904, 1546092031, 'RW', 'RWA', 'رواندا'),
(29926, 1546092032, 1546092159, 'TG', 'TGO', 'توغو'),
(29927, 1546092160, 1546092287, 'SD', 'SDN', 'السودان'),
(29928, 1546092288, 1546092415, 'RW', 'RWA', 'رواندا'),
(29929, 1546092416, 1546092543, 'NG', 'NGA', 'نيجيريا'),
(29930, 1546092544, 1546096639, 'RU', 'RUS', 'الإتحاد الروسي'),
(29931, 1546096640, 1546100735, 'IT', 'ITA', 'إيطاليا'),
(29932, 1546104832, 1546108927, 'IE', 'IRL', 'إيرلندا'),
(29933, 1546108928, 1546113023, 'GB', 'GBR', 'المملكة المتحدة'),
(29934, 1546113024, 1546121215, 'RU', 'RUS', 'الإتحاد الروسي'),
(29935, 1546121216, 1546124799, 'ES', 'ESP', 'إسبانيا'),
(29936, 1546124800, 1546125311, 'FR', 'FRA', 'فرنسا'),
(29937, 1546125312, 1546256383, 'GB', 'GBR', 'المملكة المتحدة'),
(29938, 1546256384, 1546264575, 'RU', 'RUS', 'الإتحاد الروسي'),
(29939, 1546264576, 1546266623, 'TR', 'TUR', 'تركيا'),
(29940, 1546266624, 1546268671, 'RU', 'RUS', 'الإتحاد الروسي'),
(29941, 1546268672, 1546270719, 'IR', 'IRN', 'إيران'),
(29942, 1546270720, 1546272767, 'GB', 'GBR', 'المملكة المتحدة'),
(29943, 1546272768, 1546274815, 'NO', 'NOR', 'النرويج'),
(29944, 1546274816, 1546276863, 'SE', 'SWE', 'السويد'),
(29945, 1546276864, 1546278911, 'GB', 'GBR', 'المملكة المتحدة'),
(29946, 1546278912, 1546280959, 'RU', 'RUS', 'الإتحاد الروسي'),
(29947, 1546280960, 1546283007, 'IT', 'ITA', 'إيطاليا'),
(29948, 1546283008, 1546285055, 'CH', 'CHE', 'سويسرا'),
(29949, 1546285056, 1546287103, 'PL', 'POL', 'بولندا'),
(29950, 1546287104, 1546289151, 'GB', 'GBR', 'المملكة المتحدة'),
(29951, 1546289152, 1546291199, 'RU', 'RUS', 'الإتحاد الروسي'),
(29952, 1546291200, 1546293247, 'AT', 'AUT', 'النمسا'),
(29953, 1546293248, 1546295295, 'GB', 'GBR', 'المملكة المتحدة'),
(29954, 1546295296, 1546297343, 'SE', 'SWE', 'السويد'),
(29955, 1546297344, 1546299391, 'RU', 'RUS', 'الإتحاد الروسي'),
(29956, 1546299392, 1546301439, 'GB', 'GBR', 'المملكة المتحدة'),
(29957, 1546301440, 1546303487, 'LU', 'LUX', 'لوكسيمبورغ'),
(29958, 1546303488, 1546305535, 'CH', 'CHE', 'سويسرا'),
(29959, 1546305536, 1546307583, 'DE', 'DEU', 'ألمانيا'),
(29960, 1546307584, 1546311679, 'RU', 'RUS', 'الإتحاد الروسي'),
(29961, 1546311680, 1546313727, 'FR', 'FRA', 'فرنسا'),
(29962, 1546313728, 1546315775, 'DE', 'DEU', 'ألمانيا'),
(29963, 1546315776, 1546317823, 'NL', 'NLD', 'هولندا'),
(29964, 1546317824, 1546319871, 'CH', 'CHE', 'سويسرا'),
(29965, 1546319872, 1546320383, 'RS', 'SRB', 'صربيا'),
(29966, 1546320384, 1546320387, 'SR', 'SUR', 'سورينام'),
(29967, 1546320388, 1546320391, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(29968, 1546320392, 1546321919, 'RS', 'SRB', 'صربيا'),
(29969, 1546321920, 1546323967, 'RU', 'RUS', 'الإتحاد الروسي'),
(29970, 1546323968, 1546324479, 'GE', 'GEO', 'جورجيا'),
(29971, 1546324480, 1546326015, 'NO', 'NOR', 'النرويج'),
(29972, 1546326016, 1546327295, 'ES', 'ESP', 'إسبانيا'),
(29973, 1546327296, 1546327551, 'FR', 'FRA', 'فرنسا'),
(29974, 1546327552, 1546328063, 'ES', 'ESP', 'إسبانيا'),
(29975, 1546328064, 1546330111, 'CZ', 'CZE', 'التشيك'),
(29976, 1546330112, 1546332159, 'SE', 'SWE', 'السويد'),
(29977, 1546332160, 1546334207, 'GB', 'GBR', 'المملكة المتحدة'),
(29978, 1546334208, 1546336255, 'DE', 'DEU', 'ألمانيا'),
(29979, 1546336256, 1546338303, 'CZ', 'CZE', 'التشيك'),
(29980, 1546338304, 1546340351, 'GB', 'GBR', 'المملكة المتحدة'),
(29981, 1546340352, 1546342399, 'DK', 'DNK', 'الدنيمارك'),
(29982, 1546342400, 1546344447, 'TR', 'TUR', 'تركيا'),
(29983, 1546344448, 1546346495, 'DK', 'DNK', 'الدنيمارك'),
(29984, 1546346496, 1546348543, 'AT', 'AUT', 'النمسا'),
(29985, 1546348544, 1546350399, 'DE', 'DEU', 'ألمانيا'),
(29986, 1546350400, 1546350431, 'JP', 'JPN', 'اليابان'),
(29987, 1546350432, 1546350591, 'DE', 'DEU', 'ألمانيا'),
(29988, 1546350592, 1546352639, 'PL', 'POL', 'بولندا'),
(29989, 1546352640, 1546354687, 'DK', 'DNK', 'الدنيمارك'),
(29990, 1546354688, 1546356735, 'FR', 'FRA', 'فرنسا'),
(29991, 1546356736, 1546358783, 'AM', 'ARM', 'أرمينيا'),
(29992, 1546358784, 1546360831, 'PL', 'POL', 'بولندا'),
(29993, 1546360832, 1546364927, 'RU', 'RUS', 'الإتحاد الروسي'),
(29994, 1546364928, 1546366975, 'SA', 'SAU', 'السعودية'),
(29995, 1546366976, 1546369023, 'DK', 'DNK', 'الدنيمارك'),
(29996, 1546369024, 1546371071, 'RU', 'RUS', 'الإتحاد الروسي'),
(29997, 1546371072, 1546373119, 'IS', 'ISL', 'أيسلندا'),
(29998, 1546373120, 1546375167, 'HU', 'HUN', 'هنغاريا'),
(29999, 1546375168, 1546377215, 'GB', 'GBR', 'المملكة المتحدة'),
(30000, 1546377216, 1546379263, 'CH', 'CHE', 'سويسرا'),
(30001, 1546379264, 1546381311, 'ES', 'ESP', 'إسبانيا'),
(30002, 1546381312, 1546383359, 'DK', 'DNK', 'الدنيمارك'),
(30003, 1546383360, 1546385407, 'IT', 'ITA', 'إيطاليا'),
(30004, 1546385408, 1546387455, 'FR', 'FRA', 'فرنسا'),
(30005, 1546387456, 1546518527, 'TR', 'TUR', 'تركيا'),
(30006, 1546518528, 1546649599, 'KZ', 'KAZ', 'كازاخستان'),
(30007, 1546649600, 1546665983, 'SA', 'SAU', 'السعودية'),
(30008, 1546665984, 1546673823, 'GB', 'GBR', 'المملكة المتحدة'),
(30009, 1546673824, 1546673839, 'RS', 'SRB', 'صربيا'),
(30010, 1546673840, 1546677503, 'GB', 'GBR', 'المملكة المتحدة'),
(30011, 1546677504, 1546677557, 'IN', 'IND', 'الهند'),
(30012, 1546677558, 1546677559, 'GB', 'GBR', 'المملكة المتحدة'),
(30013, 1546677560, 1546677561, 'IN', 'IND', 'الهند'),
(30014, 1546677562, 1546677563, 'GB', 'GBR', 'المملكة المتحدة'),
(30015, 1546677564, 1546677569, 'IN', 'IND', 'الهند'),
(30016, 1546677570, 1546677571, 'GB', 'GBR', 'المملكة المتحدة'),
(30017, 1546677572, 1546677573, 'IN', 'IND', 'الهند'),
(30018, 1546677574, 1546677575, 'GB', 'GBR', 'المملكة المتحدة'),
(30019, 1546677576, 1546677664, 'IN', 'IND', 'الهند'),
(30020, 1546677665, 1546677666, 'GB', 'GBR', 'المملكة المتحدة'),
(30021, 1546677667, 1546677671, 'IN', 'IND', 'الهند'),
(30022, 1546677672, 1546677675, 'GB', 'GBR', 'المملكة المتحدة'),
(30023, 1546677676, 1546677759, 'IN', 'IND', 'الهند'),
(30024, 1546677760, 1546678863, 'GB', 'GBR', 'المملكة المتحدة'),
(30025, 1546678864, 1546678871, 'RS', 'SRB', 'صربيا'),
(30026, 1546678872, 1546680831, 'GB', 'GBR', 'المملكة المتحدة'),
(30027, 1546680832, 1546680895, 'RS', 'SRB', 'صربيا'),
(30028, 1546680896, 1546681407, 'GB', 'GBR', 'المملكة المتحدة'),
(30029, 1546681408, 1546681439, 'RS', 'SRB', 'صربيا'),
(30030, 1546681440, 1546681455, 'GB', 'GBR', 'المملكة المتحدة'),
(30031, 1546681456, 1546681471, 'RS', 'SRB', 'صربيا'),
(30032, 1546681472, 1546682367, 'GB', 'GBR', 'المملكة المتحدة'),
(30033, 1546682368, 1546698751, 'BE', 'BEL', 'بلجيكا'),
(30034, 1546698752, 1546715135, 'NL', 'NLD', 'هولندا'),
(30035, 1546715136, 1546731519, 'LV', 'LVA', 'لاتفيا'),
(30036, 1546731520, 1546747903, 'FR', 'FRA', 'فرنسا'),
(30037, 1546747904, 1546764287, 'RU', 'RUS', 'الإتحاد الروسي'),
(30038, 1546764288, 1546780671, 'UA', 'UKR', 'أوكرانيا'),
(30039, 1546780672, 1546797055, 'IR', 'IRN', 'إيران'),
(30040, 1546797056, 1546813439, 'DE', 'DEU', 'ألمانيا'),
(30041, 1546813440, 1546862591, 'RU', 'RUS', 'الإتحاد الروسي'),
(30042, 1546862592, 1546878975, 'GE', 'GEO', 'جورجيا'),
(30043, 1546878976, 1546895359, 'DE', 'DEU', 'ألمانيا'),
(30044, 1546895360, 1546911743, 'IE', 'IRL', 'إيرلندا'),
(30045, 1546911744, 1546928127, 'SK', 'SVK', 'سلوفاكيا'),
(30046, 1546928128, 1546944511, 'GB', 'GBR', 'المملكة المتحدة'),
(30047, 1546944512, 1546960895, 'UA', 'UKR', 'أوكرانيا'),
(30048, 1546960896, 1546977279, 'HU', 'HUN', 'هنغاريا'),
(30049, 1546977280, 1546993663, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(30050, 1546993664, 1547010047, 'RU', 'RUS', 'الإتحاد الروسي'),
(30051, 1547010048, 1547026431, 'SI', 'SVN', 'سلوفينيا'),
(30052, 1547026432, 1547042815, 'NL', 'NLD', 'هولندا'),
(30053, 1547042816, 1547059199, 'ES', 'ESP', 'إسبانيا'),
(30054, 1547059200, 1547075583, 'RU', 'RUS', 'الإتحاد الروسي'),
(30055, 1547075584, 1547091967, 'GB', 'GBR', 'المملكة المتحدة'),
(30056, 1547091968, 1547108351, 'GE', 'GEO', 'جورجيا'),
(30057, 1547108352, 1547124735, 'RU', 'RUS', 'الإتحاد الروسي'),
(30058, 1547124736, 1547141119, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(30059, 1547141120, 1547157503, 'RO', 'ROM', 'رومانيا'),
(30060, 1547157504, 1547173887, 'PL', 'POL', 'بولندا'),
(30061, 1547173888, 1547436031, 'ES', 'ESP', 'إسبانيا'),
(30062, 1547436032, 1547440127, 'AT', 'AUT', 'النمسا'),
(30063, 1547440128, 1547444223, 'AL', 'ALB', 'ألبانيا'),
(30064, 1547444224, 1547448319, 'IT', 'ITA', 'إيطاليا'),
(30065, 1547448320, 1547452415, 'SK', 'SVK', 'سلوفاكيا'),
(30066, 1547452416, 1547456511, 'IT', 'ITA', 'إيطاليا'),
(30067, 1547456512, 1547460607, 'RU', 'RUS', 'الإتحاد الروسي'),
(30068, 1547460608, 1547468799, 'GB', 'GBR', 'المملكة المتحدة'),
(30069, 1547468800, 1547472895, 'PL', 'POL', 'بولندا'),
(30070, 1547472896, 1547476991, 'DK', 'DNK', 'الدنيمارك'),
(30071, 1547476992, 1547481087, 'ES', 'ESP', 'إسبانيا'),
(30072, 1547481088, 1547485183, 'UA', 'UKR', 'أوكرانيا'),
(30073, 1547485184, 1547489279, 'IE', 'IRL', 'إيرلندا'),
(30074, 1547489280, 1547493375, 'DE', 'DEU', 'ألمانيا'),
(30075, 1547493376, 1547497471, 'RS', 'SRB', 'صربيا'),
(30076, 1547497472, 1547501567, 'GB', 'GBR', 'المملكة المتحدة'),
(30077, 1547501568, 1547505663, 'TR', 'TUR', 'تركيا'),
(30078, 1547505664, 1547509759, 'RU', 'RUS', 'الإتحاد الروسي'),
(30079, 1547509760, 1547513855, 'LT', 'LTU', 'ليتوانيا'),
(30080, 1547513856, 1547517951, 'AT', 'AUT', 'النمسا'),
(30081, 1547517952, 1547522047, 'RU', 'RUS', 'الإتحاد الروسي'),
(30082, 1547522048, 1547526143, 'CZ', 'CZE', 'التشيك'),
(30083, 1547526144, 1547534335, 'HU', 'HUN', 'هنغاريا'),
(30084, 1547534336, 1547538431, 'FR', 'FRA', 'فرنسا'),
(30085, 1547538432, 1547542527, 'DE', 'DEU', 'ألمانيا'),
(30086, 1547542528, 1547546623, 'FR', 'FRA', 'فرنسا'),
(30087, 1547546624, 1547550719, 'IR', 'IRN', 'إيران'),
(30088, 1547550720, 1547554815, 'IE', 'IRL', 'إيرلندا'),
(30089, 1547554816, 1547558911, 'AT', 'AUT', 'النمسا'),
(30090, 1547558912, 1547563007, 'IL', 'ISR', 'إسرائيل'),
(30091, 1547563008, 1547564287, 'NL', 'NLD', 'هولندا'),
(30092, 1547564288, 1547564311, 'CH', 'CHE', 'سويسرا'),
(30093, 1547564312, 1547564315, 'BG', 'BGR', 'بلغاريا'),
(30094, 1547564316, 1547564335, 'NL', 'NLD', 'هولندا'),
(30095, 1547564336, 1547564415, 'US', 'USA', 'الولايات المتحدة'),
(30096, 1547564416, 1547564439, 'NZ', 'NZL', 'نيوزيلاندا'),
(30097, 1547564440, 1547564543, 'NL', 'NLD', 'هولندا'),
(30098, 1547564544, 1547564799, 'US', 'USA', 'الولايات المتحدة'),
(30099, 1547564800, 1547564831, 'NL', 'NLD', 'هولندا'),
(30100, 1547564832, 1547564863, 'LV', 'LVA', 'لاتفيا'),
(30101, 1547564864, 1547565055, 'NL', 'NLD', 'هولندا'),
(30102, 1547565056, 1547566079, 'US', 'USA', 'الولايات المتحدة'),
(30103, 1547566080, 1547567103, 'NL', 'NLD', 'هولندا'),
(30104, 1547567104, 1547571199, 'GB', 'GBR', 'المملكة المتحدة'),
(30105, 1547571200, 1547575295, 'AT', 'AUT', 'النمسا'),
(30106, 1547575296, 1547579391, 'NO', 'NOR', 'النرويج'),
(30107, 1547579392, 1547583487, 'RU', 'RUS', 'الإتحاد الروسي'),
(30108, 1547583488, 1547587583, 'KG', 'KGZ', 'قيرغيزستان'),
(30109, 1547587584, 1547591679, 'IT', 'ITA', 'إيطاليا'),
(30110, 1547591680, 1547595775, 'EE', 'EST', 'إستونيا'),
(30111, 1547595776, 1547599871, 'JO', 'JOR', 'الأردن'),
(30112, 1547599872, 1547603967, 'LT', 'LTU', 'ليتوانيا'),
(30113, 1547603968, 1547608063, 'RU', 'RUS', 'الإتحاد الروسي'),
(30114, 1547608064, 1547612159, 'LB', 'LBN', 'لبنان'),
(30115, 1547612160, 1547616255, 'IR', 'IRN', 'إيران'),
(30116, 1547616256, 1547620351, 'DK', 'DNK', 'الدنيمارك'),
(30117, 1547620352, 1547620359, 'JE', 'JEY', 'جيرسي'),
(30118, 1547620360, 1547620367, 'NG', 'NGA', 'نيجيريا'),
(30119, 1547620368, 1547620375, 'JE', 'JEY', 'جيرسي'),
(30120, 1547620376, 1547620383, 'NG', 'NGA', 'نيجيريا'),
(30121, 1547620384, 1547620399, 'JE', 'JEY', 'جيرسي'),
(30122, 1547620400, 1547620407, 'NG', 'NGA', 'نيجيريا'),
(30123, 1547620408, 1547620415, 'JE', 'JEY', 'جيرسي'),
(30124, 1547620416, 1547620423, 'NG', 'NGA', 'نيجيريا'),
(30125, 1547620424, 1547620439, 'JE', 'JEY', 'جيرسي'),
(30126, 1547620440, 1547620551, 'NG', 'NGA', 'نيجيريا'),
(30127, 1547620552, 1547620559, 'JE', 'JEY', 'جيرسي'),
(30128, 1547620560, 1547620615, 'NG', 'NGA', 'نيجيريا'),
(30129, 1547620616, 1547620639, 'JE', 'JEY', 'جيرسي'),
(30130, 1547620640, 1547620647, 'NG', 'NGA', 'نيجيريا'),
(30131, 1547620648, 1547620863, 'JE', 'JEY', 'جيرسي'),
(30132, 1547620864, 1547620871, 'NG', 'NGA', 'نيجيريا'),
(30133, 1547620872, 1547620879, 'JE', 'JEY', 'جيرسي'),
(30134, 1547620880, 1547620887, 'NG', 'NGA', 'نيجيريا'),
(30135, 1547620888, 1547620895, 'JE', 'JEY', 'جيرسي'),
(30136, 1547620896, 1547620903, 'NG', 'NGA', 'نيجيريا'),
(30137, 1547620904, 1547620911, 'JE', 'JEY', 'جيرسي'),
(30138, 1547620912, 1547620935, 'NG', 'NGA', 'نيجيريا'),
(30139, 1547620936, 1547620951, 'JE', 'JEY', 'جيرسي'),
(30140, 1547620952, 1547620959, 'NG', 'NGA', 'نيجيريا'),
(30141, 1547620960, 1547620967, 'JE', 'JEY', 'جيرسي'),
(30142, 1547620968, 1547620983, 'NG', 'NGA', 'نيجيريا'),
(30143, 1547620984, 1547620999, 'JE', 'JEY', 'جيرسي'),
(30144, 1547621000, 1547621031, 'NG', 'NGA', 'نيجيريا'),
(30145, 1547621032, 1547621039, 'JE', 'JEY', 'جيرسي'),
(30146, 1547621040, 1547621063, 'NG', 'NGA', 'نيجيريا'),
(30147, 1547621064, 1547621071, 'JE', 'JEY', 'جيرسي'),
(30148, 1547621072, 1547621087, 'NG', 'NGA', 'نيجيريا'),
(30149, 1547621088, 1547621095, 'JE', 'JEY', 'جيرسي'),
(30150, 1547621096, 1547621119, 'NG', 'NGA', 'نيجيريا'),
(30151, 1547621120, 1547621127, 'JE', 'JEY', 'جيرسي'),
(30152, 1547621128, 1547621135, 'NG', 'NGA', 'نيجيريا'),
(30153, 1547621136, 1547621143, 'JE', 'JEY', 'جيرسي'),
(30154, 1547621144, 1547621151, 'NG', 'NGA', 'نيجيريا'),
(30155, 1547621152, 1547621167, 'JE', 'JEY', 'جيرسي'),
(30156, 1547621168, 1547621191, 'NG', 'NGA', 'نيجيريا'),
(30157, 1547621192, 1547621199, 'JE', 'JEY', 'جيرسي'),
(30158, 1547621200, 1547621223, 'NG', 'NGA', 'نيجيريا'),
(30159, 1547621224, 1547621231, 'JE', 'JEY', 'جيرسي'),
(30160, 1547621232, 1547621239, 'NG', 'NGA', 'نيجيريا'),
(30161, 1547621240, 1547621247, 'JE', 'JEY', 'جيرسي'),
(30162, 1547621248, 1547621263, 'NG', 'NGA', 'نيجيريا'),
(30163, 1547621264, 1547621271, 'JE', 'JEY', 'جيرسي'),
(30164, 1547621272, 1547621279, 'NG', 'NGA', 'نيجيريا'),
(30165, 1547621280, 1547621303, 'JE', 'JEY', 'جيرسي'),
(30166, 1547621304, 1547621335, 'NG', 'NGA', 'نيجيريا'),
(30167, 1547621336, 1547621351, 'JE', 'JEY', 'جيرسي'),
(30168, 1547621352, 1547621375, 'NG', 'NGA', 'نيجيريا'),
(30169, 1547621376, 1547624191, 'JE', 'JEY', 'جيرسي'),
(30170, 1547624192, 1547624227, 'GB', 'GBR', 'المملكة المتحدة'),
(30171, 1547624228, 1547624447, 'JE', 'JEY', 'جيرسي'),
(30172, 1547624448, 1547628543, 'CZ', 'CZE', 'التشيك'),
(30173, 1547628544, 1547632639, 'BG', 'BGR', 'بلغاريا'),
(30174, 1547632640, 1547636735, 'TR', 'TUR', 'تركيا'),
(30175, 1547636736, 1547640831, 'SI', 'SVN', 'سلوفينيا'),
(30176, 1547640832, 1547644927, 'PL', 'POL', 'بولندا'),
(30177, 1547644928, 1547649023, 'CZ', 'CZE', 'التشيك'),
(30178, 1547649024, 1547653119, 'RU', 'RUS', 'الإتحاد الروسي'),
(30179, 1547653120, 1547654911, 'LV', 'LVA', 'لاتفيا'),
(30180, 1547654912, 1547655167, 'SE', 'SWE', 'السويد'),
(30181, 1547655168, 1547657215, 'LV', 'LVA', 'لاتفيا'),
(30182, 1547657216, 1547660287, 'RU', 'RUS', 'الإتحاد الروسي'),
(30183, 1547660288, 1547661311, 'BE', 'BEL', 'بلجيكا'),
(30184, 1547661312, 1547665407, 'LV', 'LVA', 'لاتفيا'),
(30185, 1547665408, 1547669503, 'GB', 'GBR', 'المملكة المتحدة'),
(30186, 1547669504, 1547672575, 'AT', 'AUT', 'النمسا'),
(30187, 1547672576, 1547673087, 'HR', 'HRV', 'كرواتيا'),
(30188, 1547673088, 1547673599, 'AT', 'AUT', 'النمسا'),
(30189, 1547673600, 1547685887, 'RU', 'RUS', 'الإتحاد الروسي'),
(30190, 1547685888, 1547689983, 'AT', 'AUT', 'النمسا'),
(30191, 1547689984, 1547694079, 'IT', 'ITA', 'إيطاليا'),
(30192, 1547694080, 1547698175, 'HU', 'HUN', 'هنغاريا'),
(30193, 1547698176, 1548157119, 'NL', 'NLD', 'هولندا'),
(30194, 1548157120, 1548157183, 'DE', 'DEU', 'ألمانيا'),
(30195, 1548157184, 1548222463, 'NL', 'NLD', 'هولندا'),
(30196, 1548222464, 1548746751, 'DE', 'DEU', 'ألمانيا'),
(30197, 1548746752, 1549271039, 'RO', 'ROM', 'رومانيا'),
(30198, 1549271040, 1549795327, 'FR', 'FRA', 'فرنسا'),
(30199, 1549795328, 1550057471, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(30200, 1550057472, 1550188543, 'RU', 'RUS', 'الإتحاد الروسي'),
(30201, 1550188544, 1550319615, 'FR', 'FRA', 'فرنسا'),
(30202, 1550319616, 1550581759, 'CH', 'CHE', 'سويسرا'),
(30203, 1550581760, 1550843903, 'NL', 'NLD', 'هولندا'),
(30204, 1550843904, 1550974975, 'UA', 'UKR', 'أوكرانيا'),
(30205, 1550974976, 1550996223, 'RO', 'ROM', 'رومانيا'),
(30206, 1550996224, 1550996479, 'CH', 'CHE', 'سويسرا'),
(30207, 1550996480, 1551007743, 'RO', 'ROM', 'رومانيا'),
(30208, 1551007744, 1551106047, 'MD', 'MDA', 'مولدوفا'),
(30209, 1551106048, 1551237119, 'DE', 'DEU', 'ألمانيا'),
(30210, 1551237120, 1551368191, 'GR', 'GRC', 'اليونان'),
(30211, 1551368192, 1551499263, 'NL', 'NLD', 'هولندا'),
(30212, 1551503360, 1551504383, 'GB', 'GBR', 'المملكة المتحدة'),
(30213, 1551504384, 1551505407, 'FR', 'FRA', 'فرنسا'),
(30214, 1551507456, 1551508479, 'DE', 'DEU', 'ألمانيا'),
(30215, 1551508480, 1551509503, 'IT', 'ITA', 'إيطاليا'),
(30216, 1551511552, 1551512575, 'GB', 'GBR', 'المملكة المتحدة'),
(30217, 1551516672, 1551517695, 'IT', 'ITA', 'إيطاليا'),
(30218, 1551517696, 1551518719, 'ES', 'ESP', 'إسبانيا'),
(30219, 1551528960, 1551529983, 'FR', 'FRA', 'فرنسا'),
(30220, 1551544320, 1551547391, 'DE', 'DEU', 'ألمانيا'),
(30221, 1551548416, 1551551487, 'DE', 'DEU', 'ألمانيا'),
(30222, 1551556608, 1551558655, 'FR', 'FRA', 'فرنسا'),
(30223, 1551564800, 1551572991, 'FR', 'FRA', 'فرنسا'),
(30224, 1551572992, 1551576063, 'NL', 'NLD', 'هولندا'),
(30225, 1551577088, 1551580159, 'NL', 'NLD', 'هولندا'),
(30226, 1551630336, 1551892479, 'RU', 'RUS', 'الإتحاد الروسي'),
(30227, 1551892480, 1556086783, 'FR', 'FRA', 'فرنسا'),
(30228, 1556086784, 1558708223, 'DE', 'DEU', 'ألمانيا'),
(30229, 1558708224, 1559232511, 'GB', 'GBR', 'المملكة المتحدة'),
(30230, 1559232512, 1559240703, 'IL', 'ISR', 'إسرائيل'),
(30231, 1559240704, 1559248895, 'BA', 'BIH', 'البوسنه والهرسك'),
(30232, 1559248896, 1559257087, 'LV', 'LVA', 'لاتفيا'),
(30233, 1559257088, 1559265279, 'UA', 'UKR', 'أوكرانيا'),
(30234, 1559265280, 1559273471, 'RU', 'RUS', 'الإتحاد الروسي'),
(30235, 1559273472, 1559281663, 'CZ', 'CZE', 'التشيك'),
(30236, 1559281664, 1559289855, 'RU', 'RUS', 'الإتحاد الروسي'),
(30237, 1559289856, 1559298047, 'SK', 'SVK', 'سلوفاكيا'),
(30238, 1559298048, 1559306239, 'RU', 'RUS', 'الإتحاد الروسي'),
(30239, 1559306240, 1559314431, 'JO', 'JOR', 'الأردن'),
(30240, 1559314432, 1559322623, 'GE', 'GEO', 'جورجيا'),
(30241, 1559322624, 1559330815, 'RU', 'RUS', 'الإتحاد الروسي'),
(30242, 1559330816, 1559339007, 'BA', 'BIH', 'البوسنه والهرسك'),
(30243, 1559339008, 1559339711, 'RU', 'RUS', 'الإتحاد الروسي'),
(30244, 1559339712, 1559339775, 'PA', 'PAN', 'بنما'),
(30245, 1559339776, 1559341695, 'RU', 'RUS', 'الإتحاد الروسي'),
(30246, 1559341696, 1559341703, 'ES', 'ESP', 'إسبانيا'),
(30247, 1559341704, 1559347199, 'RU', 'RUS', 'الإتحاد الروسي'),
(30248, 1559347200, 1559351295, 'SE', 'SWE', 'السويد'),
(30249, 1559351296, 1559355391, 'DK', 'DNK', 'الدنيمارك'),
(30250, 1559355392, 1559388159, 'RU', 'RUS', 'الإتحاد الروسي'),
(30251, 1559388160, 1559396351, 'UA', 'UKR', 'أوكرانيا'),
(30252, 1559396352, 1559404543, 'GB', 'GBR', 'المملكة المتحدة'),
(30253, 1559404544, 1559412735, 'FI', 'FIN', 'فنلندا'),
(30254, 1559412736, 1559420927, 'IR', 'IRN', 'إيران'),
(30255, 1559420928, 1559429119, 'HR', 'HRV', 'كرواتيا'),
(30256, 1559429120, 1559437311, 'FR', 'FRA', 'فرنسا'),
(30257, 1559437312, 1559445503, 'AT', 'AUT', 'النمسا'),
(30258, 1559445504, 1559461887, 'RU', 'RUS', 'الإتحاد الروسي'),
(30259, 1559461888, 1559470079, 'IT', 'ITA', 'إيطاليا'),
(30260, 1559470080, 1559478271, 'RU', 'RUS', 'الإتحاد الروسي'),
(30261, 1559478272, 1559486463, 'CZ', 'CZE', 'التشيك'),
(30262, 1559486464, 1559494655, 'DK', 'DNK', 'الدنيمارك'),
(30263, 1559494656, 1559502847, 'SE', 'SWE', 'السويد'),
(30264, 1559502848, 1559511039, 'PL', 'POL', 'بولندا'),
(30265, 1559511040, 1559519231, 'SI', 'SVN', 'سلوفينيا'),
(30266, 1559519232, 1559527423, 'UA', 'UKR', 'أوكرانيا'),
(30267, 1559527424, 1559529471, 'RS', 'SRB', 'صربيا'),
(30268, 1559529472, 1559530495, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30269, 1559530496, 1559531519, 'RS', 'SRB', 'صربيا'),
(30270, 1559531520, 1559532543, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30271, 1559532544, 1559535615, 'RS', 'SRB', 'صربيا'),
(30272, 1559535616, 1559543807, 'GB', 'GBR', 'المملكة المتحدة'),
(30273, 1559543808, 1559551999, 'SE', 'SWE', 'السويد'),
(30274, 1559552000, 1559560191, 'RU', 'RUS', 'الإتحاد الروسي'),
(30275, 1559560192, 1559568383, 'SK', 'SVK', 'سلوفاكيا'),
(30276, 1559568384, 1559576575, 'RU', 'RUS', 'الإتحاد الروسي'),
(30277, 1559576576, 1559584767, 'HU', 'HUN', 'هنغاريا'),
(30278, 1559584768, 1559592959, 'KG', 'KGZ', 'قيرغيزستان'),
(30279, 1559592960, 1559601151, 'FR', 'FRA', 'فرنسا'),
(30280, 1559601152, 1559609343, 'IT', 'ITA', 'إيطاليا'),
(30281, 1559609344, 1559617535, 'SK', 'SVK', 'سلوفاكيا'),
(30282, 1559617536, 1559625727, 'GB', 'GBR', 'المملكة المتحدة'),
(30283, 1559625728, 1559633919, 'DK', 'DNK', 'الدنيمارك'),
(30284, 1559633920, 1559642111, 'IT', 'ITA', 'إيطاليا'),
(30285, 1559642112, 1559650303, 'RU', 'RUS', 'الإتحاد الروسي'),
(30286, 1559650304, 1559658495, 'IT', 'ITA', 'إيطاليا'),
(30287, 1559658496, 1559683071, 'RU', 'RUS', 'الإتحاد الروسي'),
(30288, 1559683072, 1559691263, 'CH', 'CHE', 'سويسرا'),
(30289, 1559691264, 1559756799, 'BG', 'BGR', 'بلغاريا'),
(30290, 1559756800, 1559789567, 'AT', 'AUT', 'النمسا'),
(30291, 1559789568, 1559838719, 'RU', 'RUS', 'الإتحاد الروسي'),
(30292, 1559838720, 1559855103, 'UA', 'UKR', 'أوكرانيا'),
(30293, 1559855104, 1559887871, 'HU', 'HUN', 'هنغاريا'),
(30294, 1559887872, 1559920639, 'PT', 'PRT', 'البورتوغال'),
(30295, 1559920640, 1559932927, 'LU', 'LUX', 'لوكسيمبورغ'),
(30296, 1559932928, 1559943167, 'DE', 'DEU', 'ألمانيا'),
(30297, 1559943168, 1559950335, 'LU', 'LUX', 'لوكسيمبورغ'),
(30298, 1559950336, 1559953407, 'DE', 'DEU', 'ألمانيا'),
(30299, 1559953408, 1559986175, 'MT', 'MLT', 'مالطا'),
(30300, 1559986176, 1560018943, 'IE', 'IRL', 'إيرلندا'),
(30301, 1560018944, 1560051711, 'DE', 'DEU', 'ألمانيا'),
(30302, 1560051712, 1560084479, 'RU', 'RUS', 'الإتحاد الروسي'),
(30303, 1560084480, 1560117247, 'JO', 'JOR', 'الأردن'),
(30304, 1560117248, 1560150015, 'CZ', 'CZE', 'التشيك'),
(30305, 1560150016, 1560182783, 'NL', 'NLD', 'هولندا'),
(30306, 1560182784, 1560215551, 'SE', 'SWE', 'السويد'),
(30307, 1560215552, 1560281087, 'RU', 'RUS', 'الإتحاد الروسي'),
(30308, 1560281088, 1562378239, 'FR', 'FRA', 'فرنسا'),
(30309, 1562378240, 1564999679, 'IT', 'ITA', 'إيطاليا'),
(30310, 1564999680, 1565523967, 'UA', 'UKR', 'أوكرانيا'),
(30311, 1565523968, 1565655039, 'RU', 'RUS', 'الإتحاد الروسي'),
(30312, 1565655040, 1565786111, 'AT', 'AUT', 'النمسا'),
(30313, 1565786112, 1565917183, 'BY', 'BLR', 'روسيا البيضاء'),
(30314, 1565917184, 1565983863, 'RS', 'SRB', 'صربيا'),
(30315, 1565983864, 1565983871, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30316, 1565983872, 1565986159, 'RS', 'SRB', 'صربيا'),
(30317, 1565986160, 1565986175, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30318, 1565986176, 1565987119, 'RS', 'SRB', 'صربيا'),
(30319, 1565987120, 1565987135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30320, 1565987136, 1565987531, 'RS', 'SRB', 'صربيا'),
(30321, 1565987532, 1565987535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30322, 1565987536, 1565993215, 'RS', 'SRB', 'صربيا'),
(30323, 1565993216, 1565993983, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30324, 1565993984, 1565994239, 'RS', 'SRB', 'صربيا'),
(30325, 1565994240, 1565995263, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30326, 1565995264, 1565996543, 'RS', 'SRB', 'صربيا'),
(30327, 1565996544, 1565997055, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30328, 1565997056, 1566048255, 'RS', 'SRB', 'صربيا'),
(30329, 1566048256, 1566056447, 'RU', 'RUS', 'الإتحاد الروسي'),
(30330, 1566056448, 1566060543, 'IT', 'ITA', 'إيطاليا'),
(30331, 1566060544, 1566064639, 'UA', 'UKR', 'أوكرانيا'),
(30332, 1566064640, 1566068735, 'RU', 'RUS', 'الإتحاد الروسي'),
(30333, 1566068736, 1566072831, 'AZ', 'AZE', 'أذربيجان'),
(30334, 1566072832, 1566081023, 'IT', 'ITA', 'إيطاليا'),
(30335, 1566081024, 1566085119, 'RU', 'RUS', 'الإتحاد الروسي'),
(30336, 1566085120, 1566089215, 'NL', 'NLD', 'هولندا'),
(30337, 1566089216, 1566097407, 'RU', 'RUS', 'الإتحاد الروسي'),
(30338, 1566097408, 1566101503, 'GB', 'GBR', 'المملكة المتحدة'),
(30339, 1566101504, 1566105599, 'RU', 'RUS', 'الإتحاد الروسي'),
(30340, 1566105600, 1566109695, 'DE', 'DEU', 'ألمانيا'),
(30341, 1566109696, 1566113791, 'CH', 'CHE', 'سويسرا'),
(30342, 1566113792, 1566117887, 'DE', 'DEU', 'ألمانيا'),
(30343, 1566117888, 1566121983, 'TR', 'TUR', 'تركيا'),
(30344, 1566121984, 1566126079, 'NO', 'NOR', 'النرويج'),
(30345, 1566126080, 1566130175, 'IT', 'ITA', 'إيطاليا'),
(30346, 1566130176, 1566134271, 'TR', 'TUR', 'تركيا'),
(30347, 1566134272, 1566134999, 'GB', 'GBR', 'المملكة المتحدة'),
(30348, 1566135000, 1566135007, 'ES', 'ESP', 'إسبانيا'),
(30349, 1566135008, 1566138367, 'GB', 'GBR', 'المملكة المتحدة'),
(30350, 1566138368, 1566142463, 'CZ', 'CZE', 'التشيك'),
(30351, 1566142464, 1566146559, 'NO', 'NOR', 'النرويج'),
(30352, 1566146560, 1566150655, 'GB', 'GBR', 'المملكة المتحدة'),
(30353, 1566150656, 1566154751, 'CZ', 'CZE', 'التشيك'),
(30354, 1566154752, 1566158847, 'HU', 'HUN', 'هنغاريا'),
(30355, 1566158848, 1566162943, 'RU', 'RUS', 'الإتحاد الروسي'),
(30356, 1566162944, 1566167039, 'PL', 'POL', 'بولندا'),
(30357, 1566167040, 1566171135, 'UA', 'UKR', 'أوكرانيا'),
(30358, 1566171136, 1566175231, 'HU', 'HUN', 'هنغاريا'),
(30359, 1566175232, 1566179327, 'IE', 'IRL', 'إيرلندا'),
(30360, 1566179328, 1566183423, 'DK', 'DNK', 'الدنيمارك'),
(30361, 1566183424, 1566187519, 'ES', 'ESP', 'إسبانيا'),
(30362, 1566187520, 1566191615, 'RU', 'RUS', 'الإتحاد الروسي'),
(30363, 1566191616, 1566195711, 'FI', 'FIN', 'فنلندا'),
(30364, 1566195712, 1566199807, 'AL', 'ALB', 'ألبانيا'),
(30365, 1566199808, 1566207999, 'RU', 'RUS', 'الإتحاد الروسي'),
(30366, 1566208000, 1566212095, 'DK', 'DNK', 'الدنيمارك'),
(30367, 1566212096, 1566216191, 'DE', 'DEU', 'ألمانيا'),
(30368, 1566216192, 1566220287, 'SE', 'SWE', 'السويد'),
(30369, 1566220288, 1566224383, 'CZ', 'CZE', 'التشيك'),
(30370, 1566224384, 1566228479, 'DE', 'DEU', 'ألمانيا'),
(30371, 1566228480, 1566232575, 'GB', 'GBR', 'المملكة المتحدة'),
(30372, 1566232576, 1566248959, 'RU', 'RUS', 'الإتحاد الروسي'),
(30373, 1566248960, 1566257151, 'GB', 'GBR', 'المملكة المتحدة'),
(30374, 1566257152, 1566261247, 'CZ', 'CZE', 'التشيك'),
(30375, 1566261248, 1566265343, 'TR', 'TUR', 'تركيا'),
(30376, 1566265344, 1566269439, 'DE', 'DEU', 'ألمانيا'),
(30377, 1566269440, 1566271487, 'NO', 'NOR', 'النرويج'),
(30378, 1566271488, 1566271999, 'FI', 'FIN', 'فنلندا'),
(30379, 1566272000, 1566272511, 'SE', 'SWE', 'السويد'),
(30380, 1566272512, 1566273535, 'NO', 'NOR', 'النرويج'),
(30381, 1566273536, 1566277631, 'RU', 'RUS', 'الإتحاد الروسي'),
(30382, 1566277632, 1566281727, 'IT', 'ITA', 'إيطاليا'),
(30383, 1566281728, 1566285823, 'CZ', 'CZE', 'التشيك'),
(30384, 1566285824, 1566289919, 'RU', 'RUS', 'الإتحاد الروسي'),
(30385, 1566289920, 1566294015, 'FI', 'FIN', 'فنلندا'),
(30386, 1566294016, 1566298111, 'IQ', 'IRQ', 'العراق'),
(30387, 1566298112, 1566302207, 'PL', 'POL', 'بولندا'),
(30388, 1566302208, 1566306303, 'RU', 'RUS', 'الإتحاد الروسي'),
(30389, 1566306304, 1566310399, 'CZ', 'CZE', 'التشيك'),
(30390, 1566310400, 1566312447, 'SE', 'SWE', 'السويد'),
(30391, 1566312448, 1566314495, 'IE', 'IRL', 'إيرلندا'),
(30392, 1566314496, 1566316543, 'BE', 'BEL', 'بلجيكا'),
(30393, 1566316544, 1566318591, 'NO', 'NOR', 'النرويج'),
(30394, 1566318592, 1566320639, 'RU', 'RUS', 'الإتحاد الروسي'),
(30395, 1566320640, 1566321151, 'GB', 'GBR', 'المملكة المتحدة'),
(30396, 1566321152, 1566321407, 'NL', 'NLD', 'هولندا'),
(30397, 1566321408, 1566321663, 'UA', 'UKR', 'أوكرانيا'),
(30398, 1566321664, 1566321919, 'BZ', 'BLZ', 'بليز'),
(30399, 1566321920, 1566322431, 'GB', 'GBR', 'المملكة المتحدة'),
(30400, 1566322432, 1566322687, 'BS', 'BHS', 'جزر البهاما'),
(30401, 1566322688, 1566324735, 'CZ', 'CZE', 'التشيك'),
(30402, 1566324736, 1566326783, 'HU', 'HUN', 'هنغاريا'),
(30403, 1566326784, 1566328831, 'RU', 'RUS', 'الإتحاد الروسي'),
(30404, 1566328832, 1566330879, 'IT', 'ITA', 'إيطاليا'),
(30405, 1566330880, 1566334975, 'RU', 'RUS', 'الإتحاد الروسي'),
(30406, 1566334976, 1566337023, 'NL', 'NLD', 'هولندا'),
(30407, 1566337024, 1566339071, 'FR', 'FRA', 'فرنسا'),
(30408, 1566339072, 1566341119, 'RU', 'RUS', 'الإتحاد الروسي'),
(30409, 1566341120, 1566343167, 'GB', 'GBR', 'المملكة المتحدة'),
(30410, 1566343168, 1566345215, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(30411, 1566345216, 1566347263, 'RU', 'RUS', 'الإتحاد الروسي'),
(30412, 1566347264, 1566349311, 'DE', 'DEU', 'ألمانيا'),
(30413, 1566349312, 1566351359, 'IT', 'ITA', 'إيطاليا'),
(30414, 1566351360, 1566353407, 'AT', 'AUT', 'النمسا'),
(30415, 1566353408, 1566355455, 'ES', 'ESP', 'إسبانيا'),
(30416, 1566355456, 1566357503, 'RU', 'RUS', 'الإتحاد الروسي'),
(30417, 1566357504, 1566359551, 'IT', 'ITA', 'إيطاليا'),
(30418, 1566359552, 1566363647, 'RU', 'RUS', 'الإتحاد الروسي'),
(30419, 1566363648, 1566365695, 'GB', 'GBR', 'المملكة المتحدة'),
(30420, 1566365696, 1566367743, 'RU', 'RUS', 'الإتحاد الروسي'),
(30421, 1566367744, 1566371839, 'ES', 'ESP', 'إسبانيا'),
(30422, 1566371840, 1566373887, 'RU', 'RUS', 'الإتحاد الروسي'),
(30423, 1566373888, 1566375935, 'RS', 'SRB', 'صربيا'),
(30424, 1566375936, 1566377983, 'DE', 'DEU', 'ألمانيا'),
(30425, 1566377984, 1566380031, 'BG', 'BGR', 'بلغاريا'),
(30426, 1566380032, 1566382079, 'IT', 'ITA', 'إيطاليا'),
(30427, 1566382080, 1566384127, 'TR', 'TUR', 'تركيا'),
(30428, 1566384128, 1566386175, 'RU', 'RUS', 'الإتحاد الروسي'),
(30429, 1566386176, 1566388223, 'FR', 'FRA', 'فرنسا'),
(30430, 1566388224, 1566388735, 'HU', 'HUN', 'هنغاريا'),
(30431, 1566388736, 1566388991, 'PT', 'PRT', 'البورتوغال'),
(30432, 1566388992, 1566389247, 'SC', 'SYC', 'سيشيل'),
(30433, 1566389248, 1566389503, 'HU', 'HUN', 'هنغاريا'),
(30434, 1566389504, 1566389759, 'SC', 'SYC', 'سيشيل'),
(30435, 1566389760, 1566390271, 'US', 'USA', 'الولايات المتحدة'),
(30436, 1566390272, 1566392319, 'LT', 'LTU', 'ليتوانيا'),
(30437, 1566392320, 1566394367, 'ES', 'ESP', 'إسبانيا'),
(30438, 1566394368, 1566396415, 'NO', 'NOR', 'النرويج'),
(30439, 1566396416, 1566398463, 'GB', 'GBR', 'المملكة المتحدة'),
(30440, 1566398464, 1566400511, 'RU', 'RUS', 'الإتحاد الروسي'),
(30441, 1566400512, 1566400575, 'NO', 'NOR', 'النرويج'),
(30442, 1566400576, 1566400607, 'NL', 'NLD', 'هولندا'),
(30443, 1566400608, 1566400639, 'GB', 'GBR', 'المملكة المتحدة'),
(30444, 1566400640, 1566400671, 'NO', 'NOR', 'النرويج'),
(30445, 1566400672, 1566400703, 'DE', 'DEU', 'ألمانيا'),
(30446, 1566400704, 1566400735, 'NL', 'NLD', 'هولندا'),
(30447, 1566400736, 1566400767, 'DE', 'DEU', 'ألمانيا'),
(30448, 1566400768, 1566400832, 'NO', 'NOR', 'النرويج'),
(30449, 1566400833, 1566400895, 'GB', 'GBR', 'المملكة المتحدة'),
(30450, 1566400896, 1566401023, 'NO', 'NOR', 'النرويج'),
(30451, 1566401024, 1566401055, 'US', 'USA', 'الولايات المتحدة'),
(30452, 1566401056, 1566401087, 'NO', 'NOR', 'النرويج'),
(30453, 1566401088, 1566401215, 'US', 'USA', 'الولايات المتحدة'),
(30454, 1566401216, 1566401279, 'NO', 'NOR', 'النرويج'),
(30455, 1566401280, 1566401535, 'US', 'USA', 'الولايات المتحدة'),
(30456, 1566401536, 1566401599, 'IN', 'IND', 'الهند'),
(30457, 1566401600, 1566401663, 'CN', 'CHN', 'الصين'),
(30458, 1566401664, 1566401727, 'SG', 'SGP', 'سنغافورة'),
(30459, 1566401728, 1566401791, 'AU', 'AUS', 'أستراليا'),
(30460, 1566401792, 1566401856, 'SI', 'SVN', 'سلوفينيا'),
(30461, 1566401857, 1566401919, 'HK', 'HKG', 'هونغ كونغ'),
(30462, 1566401920, 1566401983, 'NO', 'NOR', 'النرويج'),
(30463, 1566401984, 1566402047, 'AU', 'AUS', 'أستراليا'),
(30464, 1566402048, 1566402559, 'NO', 'NOR', 'النرويج'),
(30465, 1566402560, 1566404607, 'IT', 'ITA', 'إيطاليا'),
(30466, 1566404608, 1566406655, 'ES', 'ESP', 'إسبانيا'),
(30467, 1566406656, 1566408703, 'NL', 'NLD', 'هولندا'),
(30468, 1566408704, 1566410751, 'GB', 'GBR', 'المملكة المتحدة'),
(30469, 1566410752, 1566414847, 'RU', 'RUS', 'الإتحاد الروسي'),
(30470, 1566414848, 1566416895, 'FR', 'FRA', 'فرنسا'),
(30471, 1566416896, 1566418943, 'IT', 'ITA', 'إيطاليا'),
(30472, 1566418944, 1566420991, 'RU', 'RUS', 'الإتحاد الروسي'),
(30473, 1566420992, 1566423039, 'ES', 'ESP', 'إسبانيا'),
(30474, 1566423040, 1566425087, 'FR', 'FRA', 'فرنسا'),
(30475, 1566425088, 1566427135, 'RS', 'SRB', 'صربيا'),
(30476, 1566427136, 1566429183, 'IT', 'ITA', 'إيطاليا'),
(30477, 1566429184, 1566437375, 'GB', 'GBR', 'المملكة المتحدة'),
(30478, 1566437376, 1566439423, 'BE', 'BEL', 'بلجيكا'),
(30479, 1566439424, 1566443519, 'DE', 'DEU', 'ألمانيا'),
(30480, 1566443520, 1566445567, 'NO', 'NOR', 'النرويج'),
(30481, 1566445568, 1566447615, 'CY', 'CYP', 'قبرص'),
(30482, 1566447616, 1566451711, 'IT', 'ITA', 'إيطاليا'),
(30483, 1566451712, 1566453759, 'IL', 'ISR', 'إسرائيل'),
(30484, 1566453760, 1566455807, 'IQ', 'IRQ', 'العراق'),
(30485, 1566455808, 1566457855, 'PT', 'PRT', 'البورتوغال'),
(30486, 1566457856, 1566459903, 'CH', 'CHE', 'سويسرا'),
(30487, 1566459904, 1566461951, 'GB', 'GBR', 'المملكة المتحدة'),
(30488, 1566461952, 1566463999, 'DE', 'DEU', 'ألمانيا'),
(30489, 1566464000, 1566466047, 'IT', 'ITA', 'إيطاليا'),
(30490, 1566466048, 1566468095, 'ES', 'ESP', 'إسبانيا'),
(30491, 1566468096, 1566468879, 'BE', 'BEL', 'بلجيكا'),
(30492, 1566468880, 1566468895, 'HU', 'HUN', 'هنغاريا'),
(30493, 1566468896, 1566469391, 'BE', 'BEL', 'بلجيكا'),
(30494, 1566469392, 1566469407, 'HU', 'HUN', 'هنغاريا'),
(30495, 1566469408, 1566470143, 'BE', 'BEL', 'بلجيكا'),
(30496, 1566470144, 1566472191, 'IE', 'IRL', 'إيرلندا'),
(30497, 1566472192, 1566474239, 'GB', 'GBR', 'المملكة المتحدة'),
(30498, 1566474240, 1566476287, 'DE', 'DEU', 'ألمانيا'),
(30499, 1566476288, 1566478335, 'BG', 'BGR', 'بلغاريا'),
(30500, 1566478336, 1566482431, 'RU', 'RUS', 'الإتحاد الروسي'),
(30501, 1566482432, 1566484479, 'FR', 'FRA', 'فرنسا'),
(30502, 1566484480, 1566486527, 'SE', 'SWE', 'السويد'),
(30503, 1566486528, 1566488575, 'RU', 'RUS', 'الإتحاد الروسي'),
(30504, 1566488576, 1566490623, 'PL', 'POL', 'بولندا'),
(30505, 1566490624, 1566492671, 'TR', 'TUR', 'تركيا'),
(30506, 1566492672, 1566494719, 'NL', 'NLD', 'هولندا'),
(30507, 1566494720, 1566496767, 'SE', 'SWE', 'السويد'),
(30508, 1566496768, 1566498815, 'AM', 'ARM', 'أرمينيا'),
(30509, 1566498816, 1566500863, 'NL', 'NLD', 'هولندا'),
(30510, 1566500864, 1566502911, 'RU', 'RUS', 'الإتحاد الروسي'),
(30511, 1566502912, 1566504959, 'CH', 'CHE', 'سويسرا'),
(30512, 1566504960, 1566507007, 'TR', 'TUR', 'تركيا'),
(30513, 1566507008, 1566509055, 'NL', 'NLD', 'هولندا'),
(30514, 1566509056, 1566511103, 'GB', 'GBR', 'المملكة المتحدة'),
(30515, 1566511104, 1566513151, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(30516, 1566513152, 1566515199, 'BH', 'BHR', 'البحرين'),
(30517, 1566515200, 1566517247, 'CZ', 'CZE', 'التشيك'),
(30518, 1566517248, 1566519295, 'RU', 'RUS', 'الإتحاد الروسي'),
(30519, 1566519296, 1566521343, 'BE', 'BEL', 'بلجيكا'),
(30520, 1566521344, 1566523391, 'FR', 'FRA', 'فرنسا'),
(30521, 1566523392, 1566525439, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(30522, 1566525440, 1566527487, 'IS', 'ISL', 'أيسلندا'),
(30523, 1566527488, 1566529535, 'IE', 'IRL', 'إيرلندا'),
(30524, 1566529536, 1566531583, 'PL', 'POL', 'بولندا'),
(30525, 1566531584, 1566533631, 'RU', 'RUS', 'الإتحاد الروسي'),
(30526, 1566533632, 1566535679, 'GB', 'GBR', 'المملكة المتحدة'),
(30527, 1566535680, 1566537727, 'NL', 'NLD', 'هولندا'),
(30528, 1566537728, 1566539775, 'GB', 'GBR', 'المملكة المتحدة'),
(30529, 1566539776, 1566541823, 'DE', 'DEU', 'ألمانيا'),
(30530, 1566541824, 1566543871, 'RU', 'RUS', 'الإتحاد الروسي'),
(30531, 1566543872, 1566545919, 'NL', 'NLD', 'هولندا'),
(30532, 1566545920, 1566552063, 'RU', 'RUS', 'الإتحاد الروسي'),
(30533, 1566552064, 1566554111, 'TR', 'TUR', 'تركيا'),
(30534, 1566554112, 1566556159, 'UA', 'UKR', 'أوكرانيا'),
(30535, 1566556160, 1566558207, 'RU', 'RUS', 'الإتحاد الروسي'),
(30536, 1566558208, 1566560255, 'JO', 'JOR', 'الأردن'),
(30537, 1566560256, 1566564351, 'IT', 'ITA', 'إيطاليا'),
(30538, 1566564352, 1566566399, 'IS', 'ISL', 'أيسلندا'),
(30539, 1566566400, 1566568447, 'FR', 'FRA', 'فرنسا'),
(30540, 1566568448, 1566570495, 'KZ', 'KAZ', 'كازاخستان'),
(30541, 1566570496, 1566572543, 'NL', 'NLD', 'هولندا'),
(30542, 1566572544, 1566703615, 'GB', 'GBR', 'المملكة المتحدة'),
(30543, 1566703616, 1566769151, 'SA', 'SAU', 'السعودية'),
(30544, 1566769152, 1566773759, 'CZ', 'CZE', 'التشيك'),
(30545, 1566773760, 1566774015, 'SK', 'SVK', 'سلوفاكيا'),
(30546, 1566774016, 1566793215, 'CZ', 'CZE', 'التشيك'),
(30547, 1566793216, 1566793471, 'SK', 'SVK', 'سلوفاكيا'),
(30548, 1566793472, 1566834687, 'CZ', 'CZE', 'التشيك'),
(30549, 1566834688, 1566900223, 'RU', 'RUS', 'الإتحاد الروسي'),
(30550, 1566900224, 1566965759, 'IT', 'ITA', 'إيطاليا'),
(30551, 1566965760, 1567031295, 'PT', 'PRT', 'البورتوغال'),
(30552, 1567031296, 1567096831, 'SI', 'SVN', 'سلوفينيا'),
(30553, 1567096832, 1567162367, 'DE', 'DEU', 'ألمانيا'),
(30554, 1567162368, 1567227903, 'PL', 'POL', 'بولندا'),
(30555, 1567227904, 1567293439, 'FI', 'FIN', 'فنلندا'),
(30556, 1567293440, 1567358975, 'IE', 'IRL', 'إيرلندا'),
(30557, 1567358976, 1567424511, 'PT', 'PRT', 'البورتوغال'),
(30558, 1567424512, 1567490047, 'CY', 'CYP', 'قبرص'),
(30559, 1567490048, 1567555583, 'IR', 'IRN', 'إيران'),
(30560, 1567555584, 1567621119, 'AT', 'AUT', 'النمسا'),
(30561, 1567621120, 1567696383, 'RO', 'ROM', 'رومانيا'),
(30562, 1567696384, 1567696895, 'MD', 'MDA', 'مولدوفا'),
(30563, 1567696896, 1567705087, 'RO', 'ROM', 'رومانيا'),
(30564, 1567705088, 1567707135, 'MD', 'MDA', 'مولدوفا'),
(30565, 1567707136, 1567715327, 'RO', 'ROM', 'رومانيا'),
(30566, 1567715328, 1567717375, 'MD', 'MDA', 'مولدوفا'),
(30567, 1567717376, 1567752191, 'RO', 'ROM', 'رومانيا'),
(30568, 1567752192, 1567756287, 'MD', 'MDA', 'مولدوفا'),
(30569, 1567756288, 1567775743, 'RO', 'ROM', 'رومانيا'),
(30570, 1567775744, 1567776767, 'MD', 'MDA', 'مولدوفا'),
(30571, 1567776768, 1567830015, 'RO', 'ROM', 'رومانيا'),
(30572, 1567830016, 1567831039, 'MD', 'MDA', 'مولدوفا'),
(30573, 1567831040, 1567883263, 'RO', 'ROM', 'رومانيا'),
(30574, 1567883264, 1567948799, 'MD', 'MDA', 'مولدوفا'),
(30575, 1567948800, 1568083967, 'RO', 'ROM', 'رومانيا'),
(30576, 1568083968, 1568086015, 'MD', 'MDA', 'مولدوفا'),
(30577, 1568086016, 1568178175, 'RO', 'ROM', 'رومانيا'),
(30578, 1568178176, 1568243711, 'RU', 'RUS', 'الإتحاد الروسي'),
(30579, 1568243712, 1568276479, 'FR', 'FRA', 'فرنسا'),
(30580, 1568276480, 1568293135, 'DE', 'DEU', 'ألمانيا'),
(30581, 1568293136, 1568293151, 'SA', 'SAU', 'السعودية'),
(30582, 1568293152, 1568294223, 'DE', 'DEU', 'ألمانيا'),
(30583, 1568294224, 1568294239, 'IT', 'ITA', 'إيطاليا'),
(30584, 1568294240, 1568294983, 'DE', 'DEU', 'ألمانيا'),
(30585, 1568294984, 1568294991, 'FR', 'FRA', 'فرنسا'),
(30586, 1568294992, 1568295791, 'DE', 'DEU', 'ألمانيا'),
(30587, 1568295792, 1568295799, 'GB', 'GBR', 'المملكة المتحدة'),
(30588, 1568295800, 1568309247, 'DE', 'DEU', 'ألمانيا'),
(30589, 1568309248, 1568342015, 'RO', 'ROM', 'رومانيا'),
(30590, 1568342016, 1568374783, 'BG', 'BGR', 'بلغاريا'),
(30591, 1568374784, 1568440319, 'RU', 'RUS', 'الإتحاد الروسي'),
(30592, 1568440320, 1568473087, 'NO', 'NOR', 'النرويج'),
(30593, 1568473088, 1568505855, 'BY', 'BLR', 'روسيا البيضاء'),
(30594, 1568505856, 1568538623, 'NL', 'NLD', 'هولندا'),
(30595, 1568538624, 1568555007, 'IR', 'IRN', 'إيران'),
(30596, 1568555008, 1568571391, 'UA', 'UKR', 'أوكرانيا'),
(30597, 1568571392, 1568579583, 'RO', 'ROM', 'رومانيا'),
(30598, 1568579584, 1568581631, 'BG', 'BGR', 'بلغاريا'),
(30599, 1568581632, 1568604159, 'RO', 'ROM', 'رومانيا'),
(30600, 1568604160, 1568636927, 'UA', 'UKR', 'أوكرانيا'),
(30601, 1568636928, 1568662271, 'DE', 'DEU', 'ألمانيا'),
(30602, 1568662272, 1568663039, 'GB', 'GBR', 'المملكة المتحدة'),
(30603, 1568663040, 1568665599, 'DE', 'DEU', 'ألمانيا'),
(30604, 1568665600, 1568665631, 'MD', 'MDA', 'مولدوفا'),
(30605, 1568665632, 1568665663, 'DK', 'DNK', 'الدنيمارك'),
(30606, 1568665664, 1568665727, 'MD', 'MDA', 'مولدوفا'),
(30607, 1568665728, 1568665759, 'UA', 'UKR', 'أوكرانيا'),
(30608, 1568665760, 1568665887, 'MD', 'MDA', 'مولدوفا'),
(30609, 1568665888, 1568665935, 'DK', 'DNK', 'الدنيمارك'),
(30610, 1568665936, 1568665951, 'MD', 'MDA', 'مولدوفا'),
(30611, 1568665952, 1568665983, 'DK', 'DNK', 'الدنيمارك'),
(30612, 1568665984, 1568665999, 'MD', 'MDA', 'مولدوفا'),
(30613, 1568666000, 1568666031, 'DK', 'DNK', 'الدنيمارك'),
(30614, 1568666032, 1568667135, 'MD', 'MDA', 'مولدوفا'),
(30615, 1568667136, 1568667391, 'DK', 'DNK', 'الدنيمارك'),
(30616, 1568667392, 1568667399, 'MD', 'MDA', 'مولدوفا'),
(30617, 1568667400, 1568667407, 'RU', 'RUS', 'الإتحاد الروسي'),
(30618, 1568667408, 1568667647, 'MD', 'MDA', 'مولدوفا'),
(30619, 1568667648, 1568667655, 'AF', 'AFG', 'أفغانستان'),
(30620, 1568667656, 1568669695, 'MD', 'MDA', 'مولدوفا'),
(30621, 1568669696, 1569193983, 'DE', 'DEU', 'ألمانيا'),
(30622, 1569193984, 1569718271, 'HR', 'HRV', 'كرواتيا'),
(30623, 1569718272, 1570242559, 'IT', 'ITA', 'إيطاليا'),
(30624, 1570242560, 1570275327, 'GB', 'GBR', 'المملكة المتحدة'),
(30625, 1570275328, 1570308095, 'BG', 'BGR', 'بلغاريا'),
(30626, 1570308096, 1570340863, 'CZ', 'CZE', 'التشيك'),
(30627, 1570340864, 1570406399, 'RU', 'RUS', 'الإتحاد الروسي'),
(30628, 1570406400, 1570439167, 'PL', 'POL', 'بولندا'),
(30629, 1570439168, 1570471935, 'TR', 'TUR', 'تركيا'),
(30630, 1570471936, 1570504703, 'BG', 'BGR', 'بلغاريا'),
(30631, 1570504704, 1570570239, 'ES', 'ESP', 'إسبانيا'),
(30632, 1570570240, 1570572287, 'NL', 'NLD', 'هولندا'),
(30633, 1570572288, 1570574335, 'UA', 'UKR', 'أوكرانيا'),
(30634, 1570574336, 1570576383, 'RU', 'RUS', 'الإتحاد الروسي'),
(30635, 1570576384, 1570578431, 'UA', 'UKR', 'أوكرانيا'),
(30636, 1570578432, 1570580479, 'CH', 'CHE', 'سويسرا'),
(30637, 1570580480, 1570582527, 'RU', 'RUS', 'الإتحاد الروسي'),
(30638, 1570582528, 1570584575, 'DE', 'DEU', 'ألمانيا'),
(30639, 1570584576, 1570586623, 'RU', 'RUS', 'الإتحاد الروسي'),
(30640, 1570586624, 1570590719, 'PL', 'POL', 'بولندا'),
(30641, 1570590720, 1570592767, 'IL', 'ISR', 'إسرائيل'),
(30642, 1570592768, 1570596863, 'PL', 'POL', 'بولندا'),
(30643, 1570596864, 1570598911, 'UA', 'UKR', 'أوكرانيا'),
(30644, 1570598912, 1570600959, 'PL', 'POL', 'بولندا'),
(30645, 1570600960, 1570603007, 'RU', 'RUS', 'الإتحاد الروسي'),
(30646, 1570605056, 1570607103, 'NL', 'NLD', 'هولندا'),
(30647, 1570607104, 1570609151, 'RU', 'RUS', 'الإتحاد الروسي'),
(30648, 1570609152, 1570611199, 'PL', 'POL', 'بولندا'),
(30649, 1570611200, 1570619391, 'RU', 'RUS', 'الإتحاد الروسي'),
(30650, 1570619392, 1570621439, 'BA', 'BIH', 'البوسنه والهرسك'),
(30651, 1570621440, 1570625535, 'RU', 'RUS', 'الإتحاد الروسي'),
(30652, 1570625536, 1570627583, 'GB', 'GBR', 'المملكة المتحدة'),
(30653, 1570627584, 1570635775, 'RU', 'RUS', 'الإتحاد الروسي'),
(30654, 1570635776, 1570652159, 'FR', 'FRA', 'فرنسا'),
(30655, 1570652160, 1570652543, 'SE', 'SWE', 'السويد'),
(30656, 1570652544, 1570652551, 'FR', 'FRA', 'فرنسا'),
(30657, 1570652552, 1570652891, 'SE', 'SWE', 'السويد'),
(30658, 1570652892, 1570652895, 'DE', 'DEU', 'ألمانيا'),
(30659, 1570652896, 1570655631, 'SE', 'SWE', 'السويد'),
(30660, 1570655632, 1570655635, 'DE', 'DEU', 'ألمانيا'),
(30661, 1570655636, 1570655999, 'SE', 'SWE', 'السويد'),
(30662, 1570656000, 1570656003, 'DE', 'DEU', 'ألمانيا'),
(30663, 1570656004, 1570656119, 'SE', 'SWE', 'السويد'),
(30664, 1570656120, 1570656127, 'GB', 'GBR', 'المملكة المتحدة'),
(30665, 1570656128, 1570660351, 'SE', 'SWE', 'السويد'),
(30666, 1570660352, 1570660359, 'FI', 'FIN', 'فنلندا'),
(30667, 1570660360, 1570660367, 'SE', 'SWE', 'السويد'),
(30668, 1570660368, 1570660383, 'FR', 'FRA', 'فرنسا'),
(30669, 1570660384, 1570660387, 'RU', 'RUS', 'الإتحاد الروسي'),
(30670, 1570660388, 1570660543, 'SE', 'SWE', 'السويد'),
(30671, 1570660544, 1570660575, 'FI', 'FIN', 'فنلندا'),
(30672, 1570660576, 1570660599, 'SE', 'SWE', 'السويد'),
(30673, 1570660600, 1570660607, 'FI', 'FIN', 'فنلندا'),
(30674, 1570660608, 1570660615, 'SE', 'SWE', 'السويد'),
(30675, 1570660616, 1570660619, 'RU', 'RUS', 'الإتحاد الروسي'),
(30676, 1570660620, 1570660623, 'SE', 'SWE', 'السويد'),
(30677, 1570660624, 1570660639, 'FR', 'FRA', 'فرنسا'),
(30678, 1570660640, 1570660863, 'SE', 'SWE', 'السويد'),
(30679, 1570660864, 1570661375, 'NO', 'NOR', 'النرويج'),
(30680, 1570661376, 1570663423, 'SE', 'SWE', 'السويد'),
(30681, 1570663424, 1570663679, 'US', 'USA', 'الولايات المتحدة'),
(30682, 1570663680, 1570663935, 'GB', 'GBR', 'المملكة المتحدة'),
(30683, 1570663936, 1570665343, 'SE', 'SWE', 'السويد'),
(30684, 1570665344, 1570665351, 'GB', 'GBR', 'المملكة المتحدة'),
(30685, 1570665352, 1570665407, 'SE', 'SWE', 'السويد'),
(30686, 1570665408, 1570665423, 'GB', 'GBR', 'المملكة المتحدة'),
(30687, 1570665424, 1570665439, 'SE', 'SWE', 'السويد'),
(30688, 1570665440, 1570665455, 'FR', 'FRA', 'فرنسا'),
(30689, 1570665456, 1570665919, 'SE', 'SWE', 'السويد'),
(30690, 1570665920, 1570665935, 'GB', 'GBR', 'المملكة المتحدة'),
(30691, 1570665936, 1570665951, 'IT', 'ITA', 'إيطاليا'),
(30692, 1570665952, 1570665967, 'FR', 'FRA', 'فرنسا'),
(30693, 1570665968, 1570666175, 'SE', 'SWE', 'السويد'),
(30694, 1570666176, 1570666191, 'GB', 'GBR', 'المملكة المتحدة'),
(30695, 1570666192, 1570666223, 'FR', 'FRA', 'فرنسا'),
(30696, 1570666224, 1570666367, 'SE', 'SWE', 'السويد'),
(30697, 1570666368, 1570666383, 'FR', 'FRA', 'فرنسا'),
(30698, 1570666384, 1570666431, 'SE', 'SWE', 'السويد'),
(30699, 1570666432, 1570666447, 'GB', 'GBR', 'المملكة المتحدة'),
(30700, 1570666448, 1570666463, 'DE', 'DEU', 'ألمانيا'),
(30701, 1570666464, 1570666495, 'SE', 'SWE', 'السويد'),
(30702, 1570666496, 1570666499, 'ES', 'ESP', 'إسبانيا'),
(30703, 1570666500, 1570666511, 'SE', 'SWE', 'السويد'),
(30704, 1570666512, 1570666519, 'NO', 'NOR', 'النرويج'),
(30705, 1570666520, 1570666687, 'SE', 'SWE', 'السويد'),
(30706, 1570666688, 1570666703, 'GB', 'GBR', 'المملكة المتحدة'),
(30707, 1570666704, 1570666719, 'ES', 'ESP', 'إسبانيا'),
(30708, 1570666720, 1570666735, 'FR', 'FRA', 'فرنسا'),
(30709, 1570666736, 1570666751, 'SE', 'SWE', 'السويد'),
(30710, 1570666752, 1570666755, 'ES', 'ESP', 'إسبانيا'),
(30711, 1570666756, 1570666759, 'SE', 'SWE', 'السويد'),
(30712, 1570666760, 1570666767, 'GB', 'GBR', 'المملكة المتحدة'),
(30713, 1570666768, 1570666943, 'SE', 'SWE', 'السويد'),
(30714, 1570666944, 1570666959, 'FR', 'FRA', 'فرنسا'),
(30715, 1570666960, 1570666975, 'SE', 'SWE', 'السويد'),
(30716, 1570666976, 1570666991, 'FR', 'FRA', 'فرنسا'),
(30717, 1570666992, 1570667007, 'SE', 'SWE', 'السويد'),
(30718, 1570667008, 1570667011, 'ES', 'ESP', 'إسبانيا'),
(30719, 1570667012, 1570667015, 'SE', 'SWE', 'السويد'),
(30720, 1570667016, 1570667023, 'GB', 'GBR', 'المملكة المتحدة'),
(30721, 1570667024, 1570667039, 'ES', 'ESP', 'إسبانيا'),
(30722, 1570667040, 1570667199, 'SE', 'SWE', 'السويد'),
(30723, 1570667200, 1570667215, 'FR', 'FRA', 'فرنسا'),
(30724, 1570667216, 1570667231, 'SE', 'SWE', 'السويد'),
(30725, 1570667232, 1570667247, 'FR', 'FRA', 'فرنسا'),
(30726, 1570667248, 1570667263, 'SE', 'SWE', 'السويد'),
(30727, 1570667264, 1570667267, 'ES', 'ESP', 'إسبانيا'),
(30728, 1570667268, 1570667279, 'SE', 'SWE', 'السويد'),
(30729, 1570667280, 1570667295, 'ES', 'ESP', 'إسبانيا'),
(30730, 1570667296, 1570667455, 'SE', 'SWE', 'السويد'),
(30731, 1570667456, 1570667471, 'FR', 'FRA', 'فرنسا'),
(30732, 1570667472, 1570667487, 'SE', 'SWE', 'السويد'),
(30733, 1570667488, 1570667503, 'FR', 'FRA', 'فرنسا'),
(30734, 1570667504, 1570667515, 'SE', 'SWE', 'السويد'),
(30735, 1570667516, 1570667519, 'US', 'USA', 'الولايات المتحدة'),
(30736, 1570667520, 1570667523, 'NL', 'NLD', 'هولندا'),
(30737, 1570667524, 1570667527, 'IT', 'ITA', 'إيطاليا'),
(30738, 1570667528, 1570667531, 'NO', 'NOR', 'النرويج'),
(30739, 1570667532, 1570667535, 'GB', 'GBR', 'المملكة المتحدة'),
(30740, 1570667536, 1570667711, 'SE', 'SWE', 'السويد'),
(30741, 1570667712, 1570667727, 'FR', 'FRA', 'فرنسا'),
(30742, 1570667728, 1570667743, 'NL', 'NLD', 'هولندا'),
(30743, 1570667744, 1570667775, 'SE', 'SWE', 'السويد'),
(30744, 1570667776, 1570667779, 'NL', 'NLD', 'هولندا'),
(30745, 1570667780, 1570667791, 'SE', 'SWE', 'السويد'),
(30746, 1570667792, 1570667807, 'ES', 'ESP', 'إسبانيا'),
(30747, 1570667808, 1570667839, 'SE', 'SWE', 'السويد'),
(30748, 1570667840, 1570667903, 'FR', 'FRA', 'فرنسا'),
(30749, 1570667904, 1570667967, 'SE', 'SWE', 'السويد'),
(30750, 1570667968, 1570667983, 'FR', 'FRA', 'فرنسا'),
(30751, 1570667984, 1570668031, 'SE', 'SWE', 'السويد'),
(30752, 1570668032, 1570668035, 'NL', 'NLD', 'هولندا'),
(30753, 1570668036, 1570668287, 'SE', 'SWE', 'السويد'),
(30754, 1570668288, 1570668291, 'NL', 'NLD', 'هولندا'),
(30755, 1570668292, 1570668351, 'SE', 'SWE', 'السويد'),
(30756, 1570668352, 1570668415, 'NO', 'NOR', 'النرويج'),
(30757, 1570668416, 1570668543, 'SE', 'SWE', 'السويد'),
(30758, 1570668544, 1570701311, 'RU', 'RUS', 'الإتحاد الروسي'),
(30759, 1570701312, 1570717695, 'PL', 'POL', 'بولندا'),
(30760, 1570717696, 1570725887, 'HR', 'HRV', 'كرواتيا'),
(30761, 1570725888, 1570734079, 'DE', 'DEU', 'ألمانيا'),
(30762, 1570734080, 1570750463, 'PL', 'POL', 'بولندا'),
(30763, 1570750464, 1570752511, 'NO', 'NOR', 'النرويج'),
(30764, 1570752512, 1570754559, 'GB', 'GBR', 'المملكة المتحدة'),
(30765, 1570754560, 1570756607, 'ES', 'ESP', 'إسبانيا'),
(30766, 1570756608, 1570764799, 'RU', 'RUS', 'الإتحاد الروسي'),
(30767, 1570764800, 1570766847, 'DE', 'DEU', 'ألمانيا'),
(30768, 1570766848, 1571291135, 'DK', 'DNK', 'الدنيمارك'),
(30769, 1571291136, 1571422207, 'RO', 'ROM', 'رومانيا'),
(30770, 1571422208, 1571553279, 'CZ', 'CZE', 'التشيك'),
(30771, 1571553280, 1571684351, 'IL', 'ISR', 'إسرائيل'),
(30772, 1571684352, 1571686399, 'ES', 'ESP', 'إسبانيا'),
(30773, 1571686400, 1571688447, 'GB', 'GBR', 'المملكة المتحدة'),
(30774, 1571688448, 1571690495, 'CH', 'CHE', 'سويسرا'),
(30775, 1571690496, 1571692543, 'GE', 'GEO', 'جورجيا'),
(30776, 1571692544, 1571694591, 'FR', 'FRA', 'فرنسا'),
(30777, 1571694592, 1571696639, 'LU', 'LUX', 'لوكسيمبورغ'),
(30778, 1571696640, 1571700735, 'RU', 'RUS', 'الإتحاد الروسي'),
(30779, 1571700736, 1571702783, 'IT', 'ITA', 'إيطاليا'),
(30780, 1571702784, 1571704831, 'RU', 'RUS', 'الإتحاد الروسي'),
(30781, 1571704832, 1571706879, 'GB', 'GBR', 'المملكة المتحدة'),
(30782, 1571706880, 1571707647, 'NL', 'NLD', 'هولندا'),
(30783, 1571707648, 1571707903, 'BZ', 'BLZ', 'بليز'),
(30784, 1571707904, 1571708927, 'NL', 'NLD', 'هولندا'),
(30785, 1571708928, 1571709439, 'GB', 'GBR', 'المملكة المتحدة'),
(30786, 1571709440, 1571709567, 'DE', 'DEU', 'ألمانيا'),
(30787, 1571709568, 1571709695, 'GB', 'GBR', 'المملكة المتحدة'),
(30788, 1571709696, 1571709823, 'FR', 'FRA', 'فرنسا'),
(30789, 1571709824, 1571709951, 'GB', 'GBR', 'المملكة المتحدة'),
(30790, 1571709952, 1571710079, 'NL', 'NLD', 'هولندا'),
(30791, 1571710080, 1571710207, 'GB', 'GBR', 'المملكة المتحدة'),
(30792, 1571710208, 1571710335, 'ES', 'ESP', 'إسبانيا'),
(30793, 1571710336, 1571710463, 'GB', 'GBR', 'المملكة المتحدة'),
(30794, 1571710464, 1571710591, 'IT', 'ITA', 'إيطاليا'),
(30795, 1571710592, 1571710975, 'GB', 'GBR', 'المملكة المتحدة'),
(30796, 1571710976, 1571713023, 'NL', 'NLD', 'هولندا'),
(30797, 1571713024, 1571715071, 'RU', 'RUS', 'الإتحاد الروسي'),
(30798, 1571715072, 1571717119, 'GR', 'GRC', 'اليونان'),
(30799, 1571717120, 1571719167, 'RU', 'RUS', 'الإتحاد الروسي'),
(30800, 1571719168, 1571721215, 'GB', 'GBR', 'المملكة المتحدة'),
(30801, 1571721216, 1571723263, 'FR', 'FRA', 'فرنسا'),
(30802, 1571723264, 1571723775, 'GB', 'GBR', 'المملكة المتحدة'),
(30803, 1571723776, 1571724031, 'SE', 'SWE', 'السويد'),
(30804, 1571724032, 1571725311, 'GB', 'GBR', 'المملكة المتحدة'),
(30805, 1571725312, 1571727359, 'RO', 'ROM', 'رومانيا'),
(30806, 1571727360, 1571729407, 'IE', 'IRL', 'إيرلندا'),
(30807, 1571729408, 1571731455, 'SK', 'SVK', 'سلوفاكيا'),
(30808, 1571731456, 1571732479, 'CH', 'CHE', 'سويسرا'),
(30809, 1571732480, 1571732495, 'LI', 'LIE', 'ليختنشتاين'),
(30810, 1571732496, 1571733503, 'CH', 'CHE', 'سويسرا'),
(30811, 1571733504, 1571735551, 'FI', 'FIN', 'فنلندا'),
(30812, 1571735552, 1571737599, 'NL', 'NLD', 'هولندا'),
(30813, 1571737600, 1571737855, 'GB', 'GBR', 'المملكة المتحدة'),
(30814, 1571738112, 1571738367, 'NL', 'NLD', 'هولندا'),
(30815, 1571739648, 1571741695, 'GB', 'GBR', 'المملكة المتحدة'),
(30816, 1571741696, 1571743743, 'RU', 'RUS', 'الإتحاد الروسي'),
(30817, 1571743744, 1571745791, 'GB', 'GBR', 'المملكة المتحدة'),
(30818, 1571745792, 1571747839, 'RU', 'RUS', 'الإتحاد الروسي'),
(30819, 1571747840, 1571749887, 'GB', 'GBR', 'المملكة المتحدة'),
(30820, 1571749888, 1571758079, 'RU', 'RUS', 'الإتحاد الروسي'),
(30821, 1571758080, 1571766271, 'IL', 'ISR', 'إسرائيل'),
(30822, 1571766272, 1571786751, 'PL', 'POL', 'بولندا'),
(30823, 1571790848, 1571794943, 'PL', 'POL', 'بولندا'),
(30824, 1571794944, 1571799039, 'NL', 'NLD', 'هولندا'),
(30825, 1571799040, 1571815423, 'UA', 'UKR', 'أوكرانيا'),
(30826, 1571815424, 1571831807, 'FR', 'FRA', 'فرنسا'),
(30827, 1571831808, 1571838079, 'DK', 'DNK', 'الدنيمارك'),
(30828, 1571838080, 1571838111, 'CY', 'CYP', 'قبرص'),
(30829, 1571838112, 1571848191, 'DK', 'DNK', 'الدنيمارك'),
(30830, 1571848192, 1571864575, 'RU', 'RUS', 'الإتحاد الروسي'),
(30831, 1571864576, 1571880959, 'PL', 'POL', 'بولندا'),
(30832, 1571880960, 1571897343, 'RU', 'RUS', 'الإتحاد الروسي'),
(30833, 1571897344, 1571913727, 'NO', 'NOR', 'النرويج'),
(30834, 1571913728, 1571930111, 'GE', 'GEO', 'جورجيا'),
(30835, 1571930112, 1571946495, 'LV', 'LVA', 'لاتفيا'),
(30836, 1571946496, 1571962879, 'SA', 'SAU', 'السعودية'),
(30837, 1571962880, 1571979263, 'RU', 'RUS', 'الإتحاد الروسي'),
(30838, 1571979264, 1571995647, 'DK', 'DNK', 'الدنيمارك'),
(30839, 1571995648, 1572012031, 'UA', 'UKR', 'أوكرانيا'),
(30840, 1572012032, 1572020223, 'NO', 'NOR', 'النرويج'),
(30841, 1572020224, 1572028415, 'SE', 'SWE', 'السويد'),
(30842, 1572028416, 1572044799, 'RU', 'RUS', 'الإتحاد الروسي'),
(30843, 1572044800, 1572061183, 'IT', 'ITA', 'إيطاليا'),
(30844, 1572061184, 1572077567, 'PL', 'POL', 'بولندا'),
(30845, 1572077568, 1572093951, 'RU', 'RUS', 'الإتحاد الروسي'),
(30846, 1572093952, 1572110335, 'BG', 'BGR', 'بلغاريا'),
(30847, 1572110336, 1572126719, 'RU', 'RUS', 'الإتحاد الروسي'),
(30848, 1572126720, 1572143103, 'UA', 'UKR', 'أوكرانيا'),
(30849, 1572143104, 1572159487, 'DE', 'DEU', 'ألمانيا'),
(30850, 1572159488, 1572175871, 'CZ', 'CZE', 'التشيك'),
(30851, 1572175872, 1572192255, 'PL', 'POL', 'بولندا'),
(30852, 1572192256, 1572225023, 'RU', 'RUS', 'الإتحاد الروسي'),
(30853, 1572225024, 1572241407, 'TR', 'TUR', 'تركيا'),
(30854, 1572241408, 1572257791, 'SE', 'SWE', 'السويد'),
(30855, 1572257792, 1572274175, 'FR', 'FRA', 'فرنسا'),
(30856, 1572274176, 1572282111, 'US', 'USA', 'الولايات المتحدة'),
(30857, 1572282112, 1572282367, 'PT', 'PRT', 'البورتوغال'),
(30858, 1572282368, 1572290559, 'US', 'USA', 'الولايات المتحدة'),
(30859, 1572290560, 1572306943, 'RU', 'RUS', 'الإتحاد الروسي'),
(30860, 1572306944, 1572323327, 'BG', 'BGR', 'بلغاريا'),
(30861, 1572323328, 1572339711, 'UA', 'UKR', 'أوكرانيا'),
(30862, 1572339712, 1572343807, 'PS', 'PSE', 'فلسطين المحتلة'),
(30863, 1572343808, 1572347903, 'CH', 'CHE', 'سويسرا'),
(30864, 1572347904, 1572351999, 'FR', 'FRA', 'فرنسا'),
(30865, 1572352000, 1572356095, 'DE', 'DEU', 'ألمانيا'),
(30866, 1572356096, 1572360191, 'SK', 'SVK', 'سلوفاكيا'),
(30867, 1572360192, 1572362751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(30868, 1572362752, 1572364287, 'RS', 'SRB', 'صربيا'),
(30869, 1572364288, 1572368383, 'NL', 'NLD', 'هولندا'),
(30870, 1572368384, 1572372479, 'NO', 'NOR', 'النرويج'),
(30871, 1572372480, 1572376575, 'DE', 'DEU', 'ألمانيا'),
(30872, 1572376576, 1572380671, 'TR', 'TUR', 'تركيا'),
(30873, 1572380672, 1572384767, 'RU', 'RUS', 'الإتحاد الروسي'),
(30874, 1572384768, 1572388863, 'DE', 'DEU', 'ألمانيا'),
(30875, 1572388864, 1572392959, 'DK', 'DNK', 'الدنيمارك'),
(30876, 1572392960, 1572397055, 'US', 'USA', 'الولايات المتحدة'),
(30877, 1572397056, 1572401151, 'AZ', 'AZE', 'أذربيجان'),
(30878, 1572401152, 1572405247, 'GB', 'GBR', 'المملكة المتحدة'),
(30879, 1572405248, 1572409343, 'CZ', 'CZE', 'التشيك'),
(30880, 1572409344, 1572413439, 'RU', 'RUS', 'الإتحاد الروسي'),
(30881, 1572413440, 1572417535, 'AM', 'ARM', 'أرمينيا'),
(30882, 1572417536, 1572421631, 'CZ', 'CZE', 'التشيك'),
(30883, 1572421632, 1572425727, 'KZ', 'KAZ', 'كازاخستان'),
(30884, 1572425728, 1572429823, 'LB', 'LBN', 'لبنان'),
(30885, 1572429824, 1572433919, 'CZ', 'CZE', 'التشيك'),
(30886, 1572433920, 1572438015, 'IT', 'ITA', 'إيطاليا'),
(30887, 1572438016, 1572442111, 'AT', 'AUT', 'النمسا'),
(30888, 1572442112, 1572446207, 'RU', 'RUS', 'الإتحاد الروسي'),
(30889, 1572446208, 1572450303, 'NO', 'NOR', 'النرويج'),
(30890, 1572450304, 1572458495, 'RU', 'RUS', 'الإتحاد الروسي'),
(30891, 1572458496, 1572462591, 'UA', 'UKR', 'أوكرانيا'),
(30892, 1572462592, 1572466687, 'LB', 'LBN', 'لبنان'),
(30893, 1572466688, 1572470783, 'EE', 'EST', 'إستونيا'),
(30894, 1572470784, 1572474879, 'DE', 'DEU', 'ألمانيا'),
(30895, 1572474880, 1572483071, 'GB', 'GBR', 'المملكة المتحدة'),
(30896, 1572483072, 1572487167, 'RU', 'RUS', 'الإتحاد الروسي'),
(30897, 1572487168, 1572490751, 'RS', 'SRB', 'صربيا'),
(30898, 1572490752, 1572491007, 'HR', 'HRV', 'كرواتيا'),
(30899, 1572491008, 1572491263, 'LU', 'LUX', 'لوكسيمبورغ'),
(30900, 1572491264, 1572495359, 'IT', 'ITA', 'إيطاليا'),
(30901, 1572495360, 1572499455, 'RU', 'RUS', 'الإتحاد الروسي'),
(30902, 1572499456, 1572503551, 'TR', 'TUR', 'تركيا'),
(30903, 1572503552, 1572504063, 'IT', 'ITA', 'إيطاليا'),
(30904, 1572504064, 1572504319, 'US', 'USA', 'الولايات المتحدة'),
(30905, 1572504320, 1572504575, 'DE', 'DEU', 'ألمانيا'),
(30906, 1572504576, 1572504703, 'RO', 'ROM', 'رومانيا'),
(30907, 1572504704, 1572504831, 'TR', 'TUR', 'تركيا'),
(30908, 1572504832, 1572507647, 'IT', 'ITA', 'إيطاليا'),
(30909, 1572507648, 1572511743, 'GB', 'GBR', 'المملكة المتحدة'),
(30910, 1572511744, 1572515839, 'DE', 'DEU', 'ألمانيا'),
(30911, 1572515840, 1572517759, 'NL', 'NLD', 'هولندا'),
(30912, 1572517760, 1572517775, 'CA', 'CAN', 'كندا'),
(30913, 1572517776, 1572519935, 'NL', 'NLD', 'هولندا'),
(30914, 1572519936, 1572524031, 'DE', 'DEU', 'ألمانيا'),
(30915, 1572524032, 1572528127, 'GE', 'GEO', 'جورجيا'),
(30916, 1572528128, 1572532223, 'RU', 'RUS', 'الإتحاد الروسي'),
(30917, 1572532224, 1572536319, 'IT', 'ITA', 'إيطاليا'),
(30918, 1572536320, 1572538367, 'GB', 'GBR', 'المملكة المتحدة'),
(30919, 1572538368, 1572540415, 'NL', 'NLD', 'هولندا'),
(30920, 1572540416, 1572541439, 'GB', 'GBR', 'المملكة المتحدة'),
(30921, 1572541440, 1572541447, 'FR', 'FRA', 'فرنسا'),
(30922, 1572541448, 1572541455, 'GB', 'GBR', 'المملكة المتحدة'),
(30923, 1572541456, 1572541463, 'FR', 'FRA', 'فرنسا'),
(30924, 1572541464, 1572541471, 'GB', 'GBR', 'المملكة المتحدة'),
(30925, 1572541472, 1572541535, 'FR', 'FRA', 'فرنسا'),
(30926, 1572541536, 1572541951, 'GB', 'GBR', 'المملكة المتحدة'),
(30927, 1572541952, 1572541983, 'DE', 'DEU', 'ألمانيا'),
(30928, 1572541984, 1572541999, 'ES', 'ESP', 'إسبانيا'),
(30929, 1572542000, 1572542207, 'GB', 'GBR', 'المملكة المتحدة'),
(30930, 1572542208, 1572542463, 'FR', 'FRA', 'فرنسا'),
(30931, 1572542464, 1572544511, 'IT', 'ITA', 'إيطاليا'),
(30932, 1572544512, 1572546559, 'HR', 'HRV', 'كرواتيا'),
(30933, 1572546560, 1572548607, 'FR', 'FRA', 'فرنسا'),
(30934, 1572548608, 1572550655, 'GB', 'GBR', 'المملكة المتحدة'),
(30935, 1572550656, 1572552703, 'DE', 'DEU', 'ألمانيا'),
(30936, 1572552704, 1572554751, 'TR', 'TUR', 'تركيا'),
(30937, 1572554752, 1572556799, 'CH', 'CHE', 'سويسرا'),
(30938, 1572556800, 1572558847, 'NO', 'NOR', 'النرويج'),
(30939, 1572558848, 1572560895, 'IT', 'ITA', 'إيطاليا'),
(30940, 1572560896, 1572562943, 'RU', 'RUS', 'الإتحاد الروسي'),
(30941, 1572562944, 1572564991, 'CZ', 'CZE', 'التشيك'),
(30942, 1572564992, 1572567039, 'DE', 'DEU', 'ألمانيا'),
(30943, 1572567040, 1572569087, 'RU', 'RUS', 'الإتحاد الروسي'),
(30944, 1572569088, 1572571135, 'NL', 'NLD', 'هولندا'),
(30945, 1572571136, 1572573183, 'RO', 'ROM', 'رومانيا'),
(30946, 1572573184, 1572575231, 'GB', 'GBR', 'المملكة المتحدة'),
(30947, 1572575232, 1572577279, 'RU', 'RUS', 'الإتحاد الروسي'),
(30948, 1572577280, 1572579327, 'AM', 'ARM', 'أرمينيا'),
(30949, 1572579328, 1572581375, 'GB', 'GBR', 'المملكة المتحدة'),
(30950, 1572581376, 1572585471, 'RU', 'RUS', 'الإتحاد الروسي'),
(30951, 1572585472, 1572587519, 'CH', 'CHE', 'سويسرا'),
(30952, 1572587520, 1572589567, 'TR', 'TUR', 'تركيا'),
(30953, 1572589568, 1572591615, 'CH', 'CHE', 'سويسرا'),
(30954, 1572591616, 1572593663, 'NL', 'NLD', 'هولندا'),
(30955, 1572593664, 1572595711, 'GB', 'GBR', 'المملكة المتحدة'),
(30956, 1572595712, 1572597759, 'DE', 'DEU', 'ألمانيا'),
(30957, 1572597760, 1572599807, 'RS', 'SRB', 'صربيا'),
(30958, 1572599808, 1572601855, 'DE', 'DEU', 'ألمانيا'),
(30959, 1572601856, 1572603903, 'SE', 'SWE', 'السويد'),
(30960, 1572603904, 1572605951, 'GE', 'GEO', 'جورجيا'),
(30961, 1572605952, 1572607999, 'RU', 'RUS', 'الإتحاد الروسي'),
(30962, 1572608000, 1572610047, 'DE', 'DEU', 'ألمانيا'),
(30963, 1572610048, 1572612095, 'UA', 'UKR', 'أوكرانيا'),
(30964, 1572612096, 1572614143, 'RU', 'RUS', 'الإتحاد الروسي'),
(30965, 1572614144, 1572616191, 'ES', 'ESP', 'إسبانيا'),
(30966, 1572616192, 1572618239, 'CH', 'CHE', 'سويسرا'),
(30967, 1572618240, 1572620287, 'RS', 'SRB', 'صربيا'),
(30968, 1572620288, 1572620415, 'CH', 'CHE', 'سويسرا'),
(30969, 1572620416, 1572620431, 'CZ', 'CZE', 'التشيك'),
(30970, 1572620432, 1572620559, 'CH', 'CHE', 'سويسرا'),
(30971, 1572620560, 1572620567, 'NL', 'NLD', 'هولندا'),
(30972, 1572620568, 1572622335, 'CH', 'CHE', 'سويسرا'),
(30973, 1572622336, 1572624383, 'RU', 'RUS', 'الإتحاد الروسي'),
(30974, 1572624384, 1572626431, 'NO', 'NOR', 'النرويج'),
(30975, 1572626432, 1572628479, 'RU', 'RUS', 'الإتحاد الروسي'),
(30976, 1572628480, 1572630527, 'DE', 'DEU', 'ألمانيا'),
(30977, 1572630528, 1572632575, 'IT', 'ITA', 'إيطاليا'),
(30978, 1572632576, 1572634623, 'RU', 'RUS', 'الإتحاد الروسي'),
(30979, 1572634624, 1572636671, 'US', 'USA', 'الولايات المتحدة'),
(30980, 1572636672, 1572638719, 'ES', 'ESP', 'إسبانيا'),
(30981, 1572638720, 1572640767, 'FR', 'FRA', 'فرنسا'),
(30982, 1572640768, 1572642815, 'RU', 'RUS', 'الإتحاد الروسي'),
(30983, 1572642816, 1572644863, 'UA', 'UKR', 'أوكرانيا'),
(30984, 1572644864, 1572646911, 'FR', 'FRA', 'فرنسا'),
(30985, 1572646912, 1572648959, 'GB', 'GBR', 'المملكة المتحدة'),
(30986, 1572648960, 1572651007, 'RU', 'RUS', 'الإتحاد الروسي'),
(30987, 1572651008, 1572653055, 'BH', 'BHR', 'البحرين'),
(30988, 1572653056, 1572657151, 'RU', 'RUS', 'الإتحاد الروسي'),
(30989, 1572657152, 1572659199, 'DE', 'DEU', 'ألمانيا'),
(30990, 1572659200, 1572661247, 'IT', 'ITA', 'إيطاليا'),
(30991, 1572661248, 1572663295, 'NO', 'NOR', 'النرويج'),
(30992, 1572663296, 1572665343, 'DE', 'DEU', 'ألمانيا'),
(30993, 1572665344, 1572667391, 'NL', 'NLD', 'هولندا'),
(30994, 1572667392, 1572669439, 'GB', 'GBR', 'المملكة المتحدة'),
(30995, 1572669440, 1572673535, 'RU', 'RUS', 'الإتحاد الروسي'),
(30996, 1572673536, 1572675583, 'AT', 'AUT', 'النمسا'),
(30997, 1572675584, 1572677631, 'ES', 'ESP', 'إسبانيا'),
(30998, 1572677632, 1572681727, 'RU', 'RUS', 'الإتحاد الروسي'),
(30999, 1572681728, 1572681983, 'DE', 'DEU', 'ألمانيا'),
(31000, 1572681984, 1572682239, 'RU', 'RUS', 'الإتحاد الروسي'),
(31001, 1572682240, 1572682751, 'DE', 'DEU', 'ألمانيا'),
(31002, 1572682752, 1572683775, 'RU', 'RUS', 'الإتحاد الروسي'),
(31003, 1572683776, 1572685823, 'CH', 'CHE', 'سويسرا'),
(31004, 1572685824, 1572689919, 'RU', 'RUS', 'الإتحاد الروسي'),
(31005, 1572689920, 1572691967, 'ES', 'ESP', 'إسبانيا'),
(31006, 1572691968, 1572694015, 'SA', 'SAU', 'السعودية'),
(31007, 1572694016, 1572694214, 'GB', 'GBR', 'المملكة المتحدة'),
(31008, 1572694215, 1572694217, 'US', 'USA', 'الولايات المتحدة'),
(31009, 1572694218, 1572694655, 'GB', 'GBR', 'المملكة المتحدة'),
(31010, 1572694656, 1572694783, 'SG', 'SGP', 'سنغافورة'),
(31011, 1572694784, 1572696063, 'GB', 'GBR', 'المملكة المتحدة'),
(31012, 1572696064, 1572698111, 'HU', 'HUN', 'هنغاريا'),
(31013, 1572698112, 1572700159, 'RU', 'RUS', 'الإتحاد الروسي'),
(31014, 1572700160, 1572702207, 'NL', 'NLD', 'هولندا'),
(31015, 1572702208, 1572704255, 'IT', 'ITA', 'إيطاليا'),
(31016, 1572704256, 1572706303, 'RU', 'RUS', 'الإتحاد الروسي'),
(31017, 1572706304, 1572708351, 'DE', 'DEU', 'ألمانيا'),
(31018, 1572708352, 1572710399, 'GB', 'GBR', 'المملكة المتحدة'),
(31019, 1572710400, 1572712447, 'DE', 'DEU', 'ألمانيا'),
(31020, 1572712448, 1572714495, 'ES', 'ESP', 'إسبانيا'),
(31021, 1572714496, 1572716543, 'IT', 'ITA', 'إيطاليا'),
(31022, 1572716544, 1572718591, 'SA', 'SAU', 'السعودية'),
(31023, 1572718592, 1572720639, 'RU', 'RUS', 'الإتحاد الروسي'),
(31024, 1572720640, 1572722687, 'IT', 'ITA', 'إيطاليا'),
(31025, 1572722688, 1572726783, 'RU', 'RUS', 'الإتحاد الروسي'),
(31026, 1572726784, 1572728831, 'CH', 'CHE', 'سويسرا'),
(31027, 1572728832, 1572730879, 'SE', 'SWE', 'السويد'),
(31028, 1572730880, 1572732927, 'RU', 'RUS', 'الإتحاد الروسي'),
(31029, 1572732928, 1572734975, 'HU', 'HUN', 'هنغاريا'),
(31030, 1572734976, 1572739071, 'RU', 'RUS', 'الإتحاد الروسي'),
(31031, 1572739072, 1572741119, 'IR', 'IRN', 'إيران'),
(31032, 1572741120, 1572743167, 'FI', 'FIN', 'فنلندا'),
(31033, 1572743168, 1572745215, 'UA', 'UKR', 'أوكرانيا'),
(31034, 1572745216, 1572749311, 'CZ', 'CZE', 'التشيك'),
(31035, 1572749312, 1572751359, 'DE', 'DEU', 'ألمانيا'),
(31036, 1572751360, 1572753407, 'CH', 'CHE', 'سويسرا'),
(31037, 1572753408, 1572755455, 'NO', 'NOR', 'النرويج'),
(31038, 1572755456, 1572757503, 'DE', 'DEU', 'ألمانيا'),
(31039, 1572757504, 1572759551, 'FI', 'FIN', 'فنلندا'),
(31040, 1572759552, 1572761599, 'RU', 'RUS', 'الإتحاد الروسي'),
(31041, 1572761600, 1572763647, 'GB', 'GBR', 'المملكة المتحدة'),
(31042, 1572763648, 1572765695, 'TR', 'TUR', 'تركيا'),
(31043, 1572765696, 1572767743, 'CZ', 'CZE', 'التشيك'),
(31044, 1572767744, 1572769740, 'NL', 'NLD', 'هولندا'),
(31045, 1572769741, 1572769790, 'KY', 'CYM', 'جزر كايمان'),
(31046, 1572769792, 1572770047, 'RO', 'ROM', 'رومانيا'),
(31047, 1572770048, 1572770111, 'RS', 'SRB', 'صربيا'),
(31048, 1572770112, 1572771839, 'RO', 'ROM', 'رومانيا'),
(31049, 1572771840, 1572773887, 'ES', 'ESP', 'إسبانيا'),
(31050, 1572773888, 1572775935, 'RS', 'SRB', 'صربيا'),
(31051, 1572775936, 1572777983, 'GB', 'GBR', 'المملكة المتحدة'),
(31052, 1572777984, 1572780031, 'UA', 'UKR', 'أوكرانيا'),
(31053, 1572780032, 1572782079, 'NL', 'NLD', 'هولندا'),
(31054, 1572782080, 1572784127, 'SE', 'SWE', 'السويد'),
(31055, 1572784128, 1572786175, 'RU', 'RUS', 'الإتحاد الروسي'),
(31056, 1572786176, 1572788223, 'FR', 'FRA', 'فرنسا'),
(31057, 1572788224, 1572790271, 'TR', 'TUR', 'تركيا'),
(31058, 1572790272, 1572792319, 'RU', 'RUS', 'الإتحاد الروسي'),
(31059, 1572792320, 1572794367, 'DE', 'DEU', 'ألمانيا'),
(31060, 1572794368, 1572796415, 'RU', 'RUS', 'الإتحاد الروسي'),
(31061, 1572796416, 1572798463, 'DE', 'DEU', 'ألمانيا'),
(31062, 1572798464, 1572800511, 'NL', 'NLD', 'هولندا'),
(31063, 1572800512, 1572804607, 'RU', 'RUS', 'الإتحاد الروسي'),
(31064, 1572804608, 1572808703, 'GB', 'GBR', 'المملكة المتحدة'),
(31065, 1572808704, 1572810751, 'FR', 'FRA', 'فرنسا'),
(31066, 1572810752, 1572812799, 'DE', 'DEU', 'ألمانيا'),
(31067, 1572812800, 1572814847, 'RU', 'RUS', 'الإتحاد الروسي'),
(31068, 1572814848, 1572816895, 'KW', 'KWT', 'الكويت'),
(31069, 1572816896, 1572818943, 'RU', 'RUS', 'الإتحاد الروسي'),
(31070, 1572818944, 1572820991, 'FR', 'FRA', 'فرنسا'),
(31071, 1572820992, 1572823039, 'GB', 'GBR', 'المملكة المتحدة'),
(31072, 1572823040, 1572825087, 'BY', 'BLR', 'روسيا البيضاء'),
(31073, 1572825088, 1572827135, 'RU', 'RUS', 'الإتحاد الروسي'),
(31074, 1572827136, 1572829183, 'NO', 'NOR', 'النرويج'),
(31075, 1572829184, 1572831231, 'FI', 'FIN', 'فنلندا'),
(31076, 1572831232, 1572833279, 'BH', 'BHR', 'البحرين'),
(31077, 1572833280, 1572835327, 'ES', 'ESP', 'إسبانيا'),
(31078, 1572835328, 1572837375, 'IE', 'IRL', 'إيرلندا'),
(31079, 1572837376, 1572839423, 'AM', 'ARM', 'أرمينيا'),
(31080, 1572839424, 1572841471, 'DE', 'DEU', 'ألمانيا'),
(31081, 1572842240, 1572842495, 'LV', 'LVA', 'لاتفيا'),
(31082, 1572842752, 1572843007, 'NL', 'NLD', 'هولندا'),
(31083, 1572843520, 1572845567, 'JO', 'JOR', 'الأردن'),
(31084, 1572845568, 1572847615, 'FR', 'FRA', 'فرنسا'),
(31085, 1572847616, 1572849663, 'GI', 'GIB', 'جبل طارق'),
(31086, 1572849664, 1572851711, 'GB', 'GBR', 'المملكة المتحدة'),
(31087, 1572851712, 1572853759, 'DE', 'DEU', 'ألمانيا'),
(31088, 1572853760, 1572854015, 'BE', 'BEL', 'بلجيكا'),
(31089, 1572854272, 1572854527, 'BE', 'BEL', 'بلجيكا'),
(31090, 1572855552, 1572855807, 'LU', 'LUX', 'لوكسيمبورغ'),
(31091, 1572855808, 1572857855, 'KZ', 'KAZ', 'كازاخستان'),
(31092, 1572857856, 1572859903, 'SE', 'SWE', 'السويد'),
(31093, 1572859904, 1572861951, 'IT', 'ITA', 'إيطاليا'),
(31094, 1572861952, 1572863999, 'CH', 'CHE', 'سويسرا'),
(31095, 1572864000, 1577058303, 'DE', 'DEU', 'ألمانيا'),
(31096, 1577058304, 1578106879, 'GB', 'GBR', 'المملكة المتحدة'),
(31097, 1578106880, 1578172415, 'DE', 'DEU', 'ألمانيا'),
(31098, 1578172416, 1578237951, 'MT', 'MLT', 'مالطا'),
(31099, 1578237952, 1578303487, 'DK', 'DNK', 'الدنيمارك'),
(31100, 1578303488, 1578369023, 'RU', 'RUS', 'الإتحاد الروسي'),
(31101, 1578369024, 1578434559, 'AZ', 'AZE', 'أذربيجان'),
(31102, 1578434560, 1578500095, 'HU', 'HUN', 'هنغاريا'),
(31103, 1578500096, 1578565631, 'FI', 'FIN', 'فنلندا'),
(31104, 1578565632, 1578582015, 'FR', 'FRA', 'فرنسا'),
(31105, 1578582016, 1578584575, 'IT', 'ITA', 'إيطاليا'),
(31106, 1578584576, 1578586111, 'PT', 'PRT', 'البورتوغال'),
(31107, 1578586112, 1578588159, 'ES', 'ESP', 'إسبانيا'),
(31108, 1578588160, 1578590207, 'PL', 'POL', 'بولندا'),
(31109, 1578590208, 1578590271, 'FR', 'FRA', 'فرنسا'),
(31110, 1578590272, 1578590275, 'NL', 'NLD', 'هولندا'),
(31111, 1578590276, 1578590279, 'PT', 'PRT', 'البورتوغال'),
(31112, 1578590280, 1578590283, 'PL', 'POL', 'بولندا'),
(31113, 1578590284, 1578590287, 'GB', 'GBR', 'المملكة المتحدة'),
(31114, 1578590288, 1578590303, 'PL', 'POL', 'بولندا'),
(31115, 1578590304, 1578590311, 'IT', 'ITA', 'إيطاليا'),
(31116, 1578590312, 1578590319, 'FR', 'FRA', 'فرنسا'),
(31117, 1578590320, 1578590335, 'CH', 'CHE', 'سويسرا'),
(31118, 1578590336, 1578590343, 'ES', 'ESP', 'إسبانيا'),
(31119, 1578590344, 1578590351, 'GB', 'GBR', 'المملكة المتحدة'),
(31120, 1578590352, 1578590415, 'FR', 'FRA', 'فرنسا'),
(31121, 1578590416, 1578590431, 'PL', 'POL', 'بولندا'),
(31122, 1578590432, 1578590447, 'BE', 'BEL', 'بلجيكا'),
(31123, 1578590448, 1578590471, 'FR', 'FRA', 'فرنسا'),
(31124, 1578590472, 1578590479, 'DE', 'DEU', 'ألمانيا'),
(31125, 1578590480, 1578590495, 'IT', 'ITA', 'إيطاليا'),
(31126, 1578590496, 1578590527, 'PL', 'POL', 'بولندا'),
(31127, 1578590528, 1578590543, 'FR', 'FRA', 'فرنسا'),
(31128, 1578590544, 1578590559, 'GB', 'GBR', 'المملكة المتحدة'),
(31129, 1578590560, 1578590575, 'ES', 'ESP', 'إسبانيا'),
(31130, 1578590576, 1578590603, 'FR', 'FRA', 'فرنسا'),
(31131, 1578590604, 1578590607, 'PL', 'POL', 'بولندا'),
(31132, 1578590608, 1578590619, 'FR', 'FRA', 'فرنسا'),
(31133, 1578590620, 1578590623, 'IT', 'ITA', 'إيطاليا'),
(31134, 1578590624, 1578590639, 'FR', 'FRA', 'فرنسا'),
(31135, 1578590640, 1578590647, 'CZ', 'CZE', 'التشيك'),
(31136, 1578590648, 1578590655, 'BE', 'BEL', 'بلجيكا'),
(31137, 1578590656, 1578590659, 'FR', 'FRA', 'فرنسا'),
(31138, 1578590660, 1578590663, 'DE', 'DEU', 'ألمانيا'),
(31139, 1578590664, 1578590667, 'FR', 'FRA', 'فرنسا'),
(31140, 1578590668, 1578590671, 'IT', 'ITA', 'إيطاليا'),
(31141, 1578590672, 1578590687, 'PL', 'POL', 'بولندا'),
(31142, 1578590688, 1578590703, 'FR', 'FRA', 'فرنسا'),
(31143, 1578590704, 1578590719, 'PL', 'POL', 'بولندا'),
(31144, 1578590720, 1578590799, 'FR', 'FRA', 'فرنسا'),
(31145, 1578590800, 1578590831, 'GB', 'GBR', 'المملكة المتحدة'),
(31146, 1578590832, 1578590847, 'ES', 'ESP', 'إسبانيا'),
(31147, 1578590848, 1578590879, 'FR', 'FRA', 'فرنسا'),
(31148, 1578590880, 1578590911, 'PL', 'POL', 'بولندا'),
(31149, 1578590912, 1578590927, 'ES', 'ESP', 'إسبانيا'),
(31150, 1578590928, 1578590935, 'DE', 'DEU', 'ألمانيا'),
(31151, 1578590936, 1578590943, 'ES', 'ESP', 'إسبانيا'),
(31152, 1578590944, 1578590959, 'CH', 'CHE', 'سويسرا'),
(31153, 1578590960, 1578590975, 'NL', 'NLD', 'هولندا'),
(31154, 1578590976, 1578590991, 'GB', 'GBR', 'المملكة المتحدة'),
(31155, 1578590992, 1578590999, 'IT', 'ITA', 'إيطاليا'),
(31156, 1578591000, 1578591007, 'FR', 'FRA', 'فرنسا'),
(31157, 1578591008, 1578591011, 'GB', 'GBR', 'المملكة المتحدة'),
(31158, 1578591012, 1578591023, 'FR', 'FRA', 'فرنسا'),
(31159, 1578591024, 1578591039, 'PL', 'POL', 'بولندا'),
(31160, 1578591040, 1578591055, 'NL', 'NLD', 'هولندا'),
(31161, 1578591056, 1578591087, 'FR', 'FRA', 'فرنسا'),
(31162, 1578591088, 1578591103, 'ES', 'ESP', 'إسبانيا'),
(31163, 1578591104, 1578591119, 'GB', 'GBR', 'المملكة المتحدة'),
(31164, 1578591120, 1578591127, 'FR', 'FRA', 'فرنسا'),
(31165, 1578591128, 1578591135, 'DE', 'DEU', 'ألمانيا'),
(31166, 1578591136, 1578591143, 'FR', 'FRA', 'فرنسا'),
(31167, 1578591144, 1578591151, 'GB', 'GBR', 'المملكة المتحدة'),
(31168, 1578591152, 1578591183, 'FR', 'FRA', 'فرنسا'),
(31169, 1578591184, 1578591199, 'ES', 'ESP', 'إسبانيا'),
(31170, 1578591200, 1578591247, 'FR', 'FRA', 'فرنسا'),
(31171, 1578591248, 1578591263, 'PL', 'POL', 'بولندا'),
(31172, 1578591264, 1578591279, 'FR', 'FRA', 'فرنسا'),
(31173, 1578591280, 1578591287, 'ES', 'ESP', 'إسبانيا'),
(31174, 1578591288, 1578591291, 'DE', 'DEU', 'ألمانيا'),
(31175, 1578591292, 1578591295, 'ES', 'ESP', 'إسبانيا'),
(31176, 1578591296, 1578591327, 'FR', 'FRA', 'فرنسا'),
(31177, 1578591328, 1578591343, 'PL', 'POL', 'بولندا'),
(31178, 1578591344, 1578591359, 'ES', 'ESP', 'إسبانيا'),
(31179, 1578591360, 1578591375, 'PL', 'POL', 'بولندا'),
(31180, 1578591376, 1578591391, 'FR', 'FRA', 'فرنسا'),
(31181, 1578591392, 1578591407, 'CH', 'CHE', 'سويسرا'),
(31182, 1578591408, 1578591439, 'GB', 'GBR', 'المملكة المتحدة'),
(31183, 1578591440, 1578591471, 'FR', 'FRA', 'فرنسا'),
(31184, 1578591472, 1578591487, 'PL', 'POL', 'بولندا'),
(31185, 1578591488, 1578591503, 'FR', 'FRA', 'فرنسا'),
(31186, 1578591504, 1578591519, 'CH', 'CHE', 'سويسرا'),
(31187, 1578591520, 1578591551, 'ES', 'ESP', 'إسبانيا'),
(31188, 1578591552, 1578591555, 'BE', 'BEL', 'بلجيكا'),
(31189, 1578591556, 1578591559, 'IT', 'ITA', 'إيطاليا'),
(31190, 1578591560, 1578591563, 'PL', 'POL', 'بولندا'),
(31191, 1578591564, 1578591583, 'FR', 'FRA', 'فرنسا'),
(31192, 1578591584, 1578591599, 'IT', 'ITA', 'إيطاليا'),
(31193, 1578591600, 1578591663, 'FR', 'FRA', 'فرنسا'),
(31194, 1578591664, 1578591695, 'PL', 'POL', 'بولندا'),
(31195, 1578591696, 1578591699, 'ES', 'ESP', 'إسبانيا'),
(31196, 1578591700, 1578591707, 'FR', 'FRA', 'فرنسا'),
(31197, 1578591708, 1578591711, 'CZ', 'CZE', 'التشيك'),
(31198, 1578591712, 1578591743, 'PL', 'POL', 'بولندا'),
(31199, 1578591744, 1578591759, 'ES', 'ESP', 'إسبانيا'),
(31200, 1578591760, 1578591791, 'FR', 'FRA', 'فرنسا'),
(31201, 1578591792, 1578591807, 'PL', 'POL', 'بولندا'),
(31202, 1578591808, 1578591823, 'DE', 'DEU', 'ألمانيا'),
(31203, 1578591824, 1578591887, 'FR', 'FRA', 'فرنسا'),
(31204, 1578591888, 1578591891, 'DE', 'DEU', 'ألمانيا'),
(31205, 1578591892, 1578591903, 'FR', 'FRA', 'فرنسا'),
(31206, 1578591904, 1578591919, 'PL', 'POL', 'بولندا'),
(31207, 1578591920, 1578591951, 'ES', 'ESP', 'إسبانيا'),
(31208, 1578591952, 1578591967, 'PT', 'PRT', 'البورتوغال'),
(31209, 1578591968, 1578591983, 'FR', 'FRA', 'فرنسا'),
(31210, 1578591984, 1578592031, 'PL', 'POL', 'بولندا'),
(31211, 1578592032, 1578592047, 'IT', 'ITA', 'إيطاليا'),
(31212, 1578592048, 1578592079, 'FR', 'FRA', 'فرنسا'),
(31213, 1578592080, 1578592095, 'PL', 'POL', 'بولندا'),
(31214, 1578592096, 1578592111, 'FR', 'FRA', 'فرنسا'),
(31215, 1578592112, 1578592127, 'GB', 'GBR', 'المملكة المتحدة'),
(31216, 1578592128, 1578592143, 'DE', 'DEU', 'ألمانيا'),
(31217, 1578592144, 1578592159, 'PL', 'POL', 'بولندا'),
(31218, 1578592160, 1578592163, 'FR', 'FRA', 'فرنسا'),
(31219, 1578592164, 1578592171, 'IT', 'ITA', 'إيطاليا'),
(31220, 1578592172, 1578592175, 'FR', 'FRA', 'فرنسا'),
(31221, 1578592176, 1578592183, 'CZ', 'CZE', 'التشيك'),
(31222, 1578592184, 1578592191, 'PT', 'PRT', 'البورتوغال'),
(31223, 1578592192, 1578592199, 'BE', 'BEL', 'بلجيكا'),
(31224, 1578592200, 1578592207, 'CH', 'CHE', 'سويسرا'),
(31225, 1578592208, 1578592223, 'FR', 'FRA', 'فرنسا'),
(31226, 1578592224, 1578592255, 'ES', 'ESP', 'إسبانيا'),
(31227, 1578592256, 1578592271, 'FR', 'FRA', 'فرنسا'),
(31228, 1578592272, 1578592279, 'NL', 'NLD', 'هولندا'),
(31229, 1578592280, 1578592283, 'BE', 'BEL', 'بلجيكا'),
(31230, 1578592284, 1578592287, 'NL', 'NLD', 'هولندا'),
(31231, 1578592288, 1578592303, 'DE', 'DEU', 'ألمانيا'),
(31232, 1578592304, 1578592319, 'FR', 'FRA', 'فرنسا'),
(31233, 1578592320, 1578592335, 'ES', 'ESP', 'إسبانيا'),
(31234, 1578592336, 1578592351, 'FR', 'FRA', 'فرنسا'),
(31235, 1578592352, 1578592367, 'PL', 'POL', 'بولندا'),
(31236, 1578592368, 1578592383, 'FR', 'FRA', 'فرنسا'),
(31237, 1578592384, 1578592399, 'IE', 'IRL', 'إيرلندا'),
(31238, 1578592400, 1578592415, 'GB', 'GBR', 'المملكة المتحدة'),
(31239, 1578592416, 1578592423, 'IT', 'ITA', 'إيطاليا'),
(31240, 1578592424, 1578592431, 'IE', 'IRL', 'إيرلندا'),
(31241, 1578592432, 1578592447, 'FR', 'FRA', 'فرنسا'),
(31242, 1578592448, 1578592495, 'PL', 'POL', 'بولندا'),
(31243, 1578592496, 1578592511, 'FR', 'FRA', 'فرنسا'),
(31244, 1578592512, 1578592515, 'GB', 'GBR', 'المملكة المتحدة'),
(31245, 1578592516, 1578592519, 'PL', 'POL', 'بولندا'),
(31246, 1578592520, 1578592531, 'FR', 'FRA', 'فرنسا'),
(31247, 1578592532, 1578592535, 'GB', 'GBR', 'المملكة المتحدة'),
(31248, 1578592536, 1578592543, 'NL', 'NLD', 'هولندا'),
(31249, 1578592544, 1578592559, 'FR', 'FRA', 'فرنسا'),
(31250, 1578592560, 1578592575, 'NL', 'NLD', 'هولندا'),
(31251, 1578592576, 1578592687, 'FR', 'FRA', 'فرنسا'),
(31252, 1578592688, 1578592719, 'ES', 'ESP', 'إسبانيا'),
(31253, 1578592720, 1578592735, 'CH', 'CHE', 'سويسرا'),
(31254, 1578592736, 1578592751, 'FR', 'FRA', 'فرنسا'),
(31255, 1578592752, 1578592799, 'DE', 'DEU', 'ألمانيا'),
(31256, 1578592800, 1578592831, 'FR', 'FRA', 'فرنسا'),
(31257, 1578592832, 1578592847, 'PL', 'POL', 'بولندا'),
(31258, 1578592848, 1578592863, 'FR', 'FRA', 'فرنسا'),
(31259, 1578592864, 1578592879, 'PL', 'POL', 'بولندا'),
(31260, 1578592880, 1578592895, 'CH', 'CHE', 'سويسرا'),
(31261, 1578592896, 1578592959, 'IT', 'ITA', 'إيطاليا'),
(31262, 1578592960, 1578593007, 'FR', 'FRA', 'فرنسا'),
(31263, 1578593008, 1578593279, 'DE', 'DEU', 'ألمانيا'),
(31264, 1578593280, 1578593295, 'PL', 'POL', 'بولندا'),
(31265, 1578593296, 1578593323, 'FR', 'FRA', 'فرنسا'),
(31266, 1578593324, 1578593327, 'ES', 'ESP', 'إسبانيا'),
(31267, 1578593328, 1578593343, 'IT', 'ITA', 'إيطاليا'),
(31268, 1578593344, 1578593359, 'FR', 'FRA', 'فرنسا'),
(31269, 1578593360, 1578593407, 'GB', 'GBR', 'المملكة المتحدة'),
(31270, 1578593408, 1578593415, 'FR', 'FRA', 'فرنسا'),
(31271, 1578593416, 1578593423, 'PL', 'POL', 'بولندا'),
(31272, 1578593424, 1578593439, 'FR', 'FRA', 'فرنسا'),
(31273, 1578593440, 1578593455, 'PL', 'POL', 'بولندا'),
(31274, 1578593456, 1578593487, 'FR', 'FRA', 'فرنسا'),
(31275, 1578593488, 1578593495, 'ES', 'ESP', 'إسبانيا'),
(31276, 1578593496, 1578593503, 'FR', 'FRA', 'فرنسا'),
(31277, 1578593504, 1578593535, 'PL', 'POL', 'بولندا'),
(31278, 1578593536, 1578593599, 'GB', 'GBR', 'المملكة المتحدة'),
(31279, 1578593600, 1578593631, 'FR', 'FRA', 'فرنسا'),
(31280, 1578593632, 1578593647, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(31281, 1578593648, 1578593659, 'PL', 'POL', 'بولندا'),
(31282, 1578593660, 1578593663, 'FR', 'FRA', 'فرنسا'),
(31283, 1578593664, 1578593679, 'IT', 'ITA', 'إيطاليا'),
(31284, 1578593680, 1578593711, 'FR', 'FRA', 'فرنسا'),
(31285, 1578593712, 1578593727, 'CZ', 'CZE', 'التشيك'),
(31286, 1578593728, 1578593759, 'FR', 'FRA', 'فرنسا'),
(31287, 1578593760, 1578593775, 'ES', 'ESP', 'إسبانيا'),
(31288, 1578593776, 1578593791, 'NL', 'NLD', 'هولندا'),
(31289, 1578593792, 1578593823, 'FR', 'FRA', 'فرنسا'),
(31290, 1578593824, 1578593839, 'GB', 'GBR', 'المملكة المتحدة'),
(31291, 1578593840, 1578593871, 'FR', 'FRA', 'فرنسا'),
(31292, 1578593872, 1578593875, 'ES', 'ESP', 'إسبانيا'),
(31293, 1578593876, 1578593879, 'FR', 'FRA', 'فرنسا'),
(31294, 1578593880, 1578593887, 'DE', 'DEU', 'ألمانيا'),
(31295, 1578593888, 1578593919, 'FR', 'FRA', 'فرنسا'),
(31296, 1578593920, 1578593951, 'PL', 'POL', 'بولندا'),
(31297, 1578593952, 1578593955, 'FR', 'FRA', 'فرنسا'),
(31298, 1578593956, 1578593967, 'PL', 'POL', 'بولندا'),
(31299, 1578593968, 1578593983, 'FR', 'FRA', 'فرنسا'),
(31300, 1578593984, 1578593999, 'PL', 'POL', 'بولندا'),
(31301, 1578594000, 1578594015, 'FR', 'FRA', 'فرنسا'),
(31302, 1578594016, 1578594031, 'BE', 'BEL', 'بلجيكا'),
(31303, 1578594032, 1578594047, 'PL', 'POL', 'بولندا'),
(31304, 1578594048, 1578594063, 'FR', 'FRA', 'فرنسا'),
(31305, 1578594064, 1578594079, 'PL', 'POL', 'بولندا'),
(31306, 1578594080, 1578594087, 'CH', 'CHE', 'سويسرا'),
(31307, 1578594088, 1578594095, 'CZ', 'CZE', 'التشيك'),
(31308, 1578594096, 1578594111, 'FR', 'FRA', 'فرنسا'),
(31309, 1578594112, 1578594127, 'PL', 'POL', 'بولندا'),
(31310, 1578594128, 1578594159, 'FR', 'FRA', 'فرنسا'),
(31311, 1578594160, 1578594175, 'DE', 'DEU', 'ألمانيا'),
(31312, 1578594176, 1578594191, 'FR', 'FRA', 'فرنسا'),
(31313, 1578594192, 1578594207, 'IT', 'ITA', 'إيطاليا'),
(31314, 1578594208, 1578594223, 'PL', 'POL', 'بولندا'),
(31315, 1578594224, 1578594239, 'ES', 'ESP', 'إسبانيا'),
(31316, 1578594240, 1578594255, 'FR', 'FRA', 'فرنسا'),
(31317, 1578594256, 1578594271, 'GB', 'GBR', 'المملكة المتحدة'),
(31318, 1578594272, 1578594303, 'PL', 'POL', 'بولندا'),
(31319, 1578594304, 1578594319, 'FR', 'FRA', 'فرنسا'),
(31320, 1578594320, 1578594335, 'PL', 'POL', 'بولندا'),
(31321, 1578594336, 1578594375, 'FR', 'FRA', 'فرنسا'),
(31322, 1578594376, 1578594383, 'PT', 'PRT', 'البورتوغال'),
(31323, 1578594384, 1578594399, 'FR', 'FRA', 'فرنسا'),
(31324, 1578594400, 1578594431, 'PL', 'POL', 'بولندا'),
(31325, 1578594432, 1578594447, 'FR', 'FRA', 'فرنسا'),
(31326, 1578594448, 1578594463, 'PL', 'POL', 'بولندا'),
(31327, 1578594464, 1578594479, 'FR', 'FRA', 'فرنسا'),
(31328, 1578594480, 1578594495, 'ES', 'ESP', 'إسبانيا'),
(31329, 1578594496, 1578594511, 'FR', 'FRA', 'فرنسا'),
(31330, 1578594512, 1578594515, 'DE', 'DEU', 'ألمانيا'),
(31331, 1578594516, 1578594519, 'FR', 'FRA', 'فرنسا'),
(31332, 1578594520, 1578594523, 'PL', 'POL', 'بولندا'),
(31333, 1578594524, 1578594559, 'FR', 'FRA', 'فرنسا'),
(31334, 1578594560, 1578594575, 'PL', 'POL', 'بولندا'),
(31335, 1578594576, 1578594607, 'ES', 'ESP', 'إسبانيا'),
(31336, 1578594608, 1578594623, 'FR', 'FRA', 'فرنسا'),
(31337, 1578594624, 1578594687, 'DE', 'DEU', 'ألمانيا'),
(31338, 1578594688, 1578594703, 'FR', 'FRA', 'فرنسا'),
(31339, 1578594704, 1578594707, 'BE', 'BEL', 'بلجيكا'),
(31340, 1578594708, 1578594711, 'DE', 'DEU', 'ألمانيا'),
(31341, 1578594712, 1578594715, 'IT', 'ITA', 'إيطاليا'),
(31342, 1578594716, 1578594751, 'FR', 'FRA', 'فرنسا'),
(31343, 1578594752, 1578594767, 'ES', 'ESP', 'إسبانيا'),
(31344, 1578594768, 1578594771, 'DE', 'DEU', 'ألمانيا'),
(31345, 1578594772, 1578594775, 'FR', 'FRA', 'فرنسا'),
(31346, 1578594776, 1578594783, 'ES', 'ESP', 'إسبانيا'),
(31347, 1578594784, 1578594799, 'FR', 'FRA', 'فرنسا'),
(31348, 1578594800, 1578594815, 'DE', 'DEU', 'ألمانيا'),
(31349, 1578594816, 1578595039, 'FR', 'FRA', 'فرنسا'),
(31350, 1578595040, 1578595055, 'GB', 'GBR', 'المملكة المتحدة'),
(31351, 1578595056, 1578595103, 'FR', 'FRA', 'فرنسا'),
(31352, 1578595104, 1578595119, 'GB', 'GBR', 'المملكة المتحدة'),
(31353, 1578595120, 1578595127, 'FR', 'FRA', 'فرنسا'),
(31354, 1578595128, 1578595131, 'ES', 'ESP', 'إسبانيا'),
(31355, 1578595132, 1578595151, 'FR', 'FRA', 'فرنسا'),
(31356, 1578595152, 1578595167, 'ES', 'ESP', 'إسبانيا'),
(31357, 1578595168, 1578595199, 'FR', 'FRA', 'فرنسا'),
(31358, 1578595200, 1578595327, 'GB', 'GBR', 'المملكة المتحدة'),
(31359, 1578595328, 1578595343, 'IT', 'ITA', 'إيطاليا'),
(31360, 1578595344, 1578595359, 'PL', 'POL', 'بولندا'),
(31361, 1578595360, 1578595363, 'FR', 'FRA', 'فرنسا'),
(31362, 1578595364, 1578595367, 'DE', 'DEU', 'ألمانيا'),
(31363, 1578595368, 1578595455, 'FR', 'FRA', 'فرنسا'),
(31364, 1578595456, 1578595463, 'DE', 'DEU', 'ألمانيا'),
(31365, 1578595464, 1578595487, 'FR', 'FRA', 'فرنسا'),
(31366, 1578595488, 1578595503, 'DE', 'DEU', 'ألمانيا'),
(31367, 1578595504, 1578595519, 'PL', 'POL', 'بولندا'),
(31368, 1578595520, 1578595607, 'FR', 'FRA', 'فرنسا'),
(31369, 1578595608, 1578595611, 'GB', 'GBR', 'المملكة المتحدة'),
(31370, 1578595612, 1578595615, 'ES', 'ESP', 'إسبانيا'),
(31371, 1578595616, 1578595647, 'PL', 'POL', 'بولندا'),
(31372, 1578595648, 1578595679, 'FR', 'FRA', 'فرنسا'),
(31373, 1578595680, 1578595695, 'BE', 'BEL', 'بلجيكا'),
(31374, 1578595696, 1578595759, 'FR', 'FRA', 'فرنسا'),
(31375, 1578595760, 1578595775, 'GB', 'GBR', 'المملكة المتحدة'),
(31376, 1578595776, 1578595807, 'CH', 'CHE', 'سويسرا'),
(31377, 1578595808, 1578595983, 'FR', 'FRA', 'فرنسا'),
(31378, 1578595984, 1578595991, 'NL', 'NLD', 'هولندا'),
(31379, 1578595992, 1578596111, 'FR', 'FRA', 'فرنسا'),
(31380, 1578596112, 1578596127, 'ES', 'ESP', 'إسبانيا'),
(31381, 1578596128, 1578596143, 'PL', 'POL', 'بولندا'),
(31382, 1578596144, 1578596147, 'DE', 'DEU', 'ألمانيا'),
(31383, 1578596148, 1578596151, 'FR', 'FRA', 'فرنسا'),
(31384, 1578596152, 1578596155, 'DE', 'DEU', 'ألمانيا'),
(31385, 1578596156, 1578596159, 'FR', 'FRA', 'فرنسا'),
(31386, 1578596160, 1578596191, 'PL', 'POL', 'بولندا'),
(31387, 1578596192, 1578596207, 'ES', 'ESP', 'إسبانيا'),
(31388, 1578596208, 1578596255, 'FR', 'FRA', 'فرنسا'),
(31389, 1578596256, 1578596287, 'GB', 'GBR', 'المملكة المتحدة'),
(31390, 1578596288, 1578596303, 'ES', 'ESP', 'إسبانيا'),
(31391, 1578596304, 1578596335, 'FR', 'FRA', 'فرنسا'),
(31392, 1578596336, 1578596351, 'ES', 'ESP', 'إسبانيا'),
(31393, 1578596352, 1578596863, 'GB', 'GBR', 'المملكة المتحدة'),
(31394, 1578596864, 1578600191, 'FR', 'FRA', 'فرنسا'),
(31395, 1578600192, 1578600255, 'BE', 'BEL', 'بلجيكا'),
(31396, 1578600256, 1578600511, 'FR', 'FRA', 'فرنسا'),
(31397, 1578600512, 1578600575, 'BE', 'BEL', 'بلجيكا'),
(31398, 1578600576, 1578602495, 'FR', 'FRA', 'فرنسا'),
(31399, 1578602496, 1578604543, 'NL', 'NLD', 'هولندا'),
(31400, 1578604544, 1578606591, 'GB', 'GBR', 'المملكة المتحدة'),
(31401, 1578606592, 1578608639, 'DE', 'DEU', 'ألمانيا'),
(31402, 1578608640, 1578610687, 'CZ', 'CZE', 'التشيك'),
(31403, 1578610688, 1578610943, 'FR', 'FRA', 'فرنسا'),
(31404, 1578610944, 1578610975, 'ES', 'ESP', 'إسبانيا'),
(31405, 1578610976, 1578611039, 'PL', 'POL', 'بولندا'),
(31406, 1578611040, 1578611079, 'FR', 'FRA', 'فرنسا'),
(31407, 1578611080, 1578611087, 'NL', 'NLD', 'هولندا'),
(31408, 1578611088, 1578611103, 'DE', 'DEU', 'ألمانيا'),
(31409, 1578611104, 1578611119, 'GB', 'GBR', 'المملكة المتحدة'),
(31410, 1578611120, 1578611135, 'FR', 'FRA', 'فرنسا'),
(31411, 1578611136, 1578611151, 'CH', 'CHE', 'سويسرا'),
(31412, 1578611152, 1578611167, 'FR', 'FRA', 'فرنسا'),
(31413, 1578611168, 1578611183, 'ES', 'ESP', 'إسبانيا'),
(31414, 1578611184, 1578611199, 'FR', 'FRA', 'فرنسا'),
(31415, 1578611200, 1578611215, 'NL', 'NLD', 'هولندا'),
(31416, 1578611216, 1578611231, 'PL', 'POL', 'بولندا'),
(31417, 1578611232, 1578611247, 'FR', 'FRA', 'فرنسا'),
(31418, 1578611248, 1578611251, 'ES', 'ESP', 'إسبانيا'),
(31419, 1578611252, 1578611255, 'IT', 'ITA', 'إيطاليا'),
(31420, 1578611256, 1578611263, 'PL', 'POL', 'بولندا'),
(31421, 1578611264, 1578611279, 'IT', 'ITA', 'إيطاليا'),
(31422, 1578611280, 1578611295, 'FR', 'FRA', 'فرنسا'),
(31423, 1578611296, 1578611327, 'PL', 'POL', 'بولندا'),
(31424, 1578611328, 1578611359, 'FR', 'FRA', 'فرنسا'),
(31425, 1578611360, 1578611375, 'CH', 'CHE', 'سويسرا'),
(31426, 1578611376, 1578611391, 'FR', 'FRA', 'فرنسا'),
(31427, 1578611392, 1578611407, 'DE', 'DEU', 'ألمانيا'),
(31428, 1578611408, 1578611423, 'IT', 'ITA', 'إيطاليا'),
(31429, 1578611424, 1578611439, 'FR', 'FRA', 'فرنسا'),
(31430, 1578611440, 1578611455, 'IT', 'ITA', 'إيطاليا'),
(31431, 1578611456, 1578611711, 'FR', 'FRA', 'فرنسا'),
(31432, 1578611712, 1578611775, 'CH', 'CHE', 'سويسرا'),
(31433, 1578611776, 1578611791, 'ES', 'ESP', 'إسبانيا'),
(31434, 1578611792, 1578611807, 'FR', 'FRA', 'فرنسا'),
(31435, 1578611808, 1578611839, 'CH', 'CHE', 'سويسرا'),
(31436, 1578611840, 1578611919, 'FR', 'FRA', 'فرنسا'),
(31437, 1578611920, 1578611935, 'BE', 'BEL', 'بلجيكا'),
(31438, 1578611936, 1578611943, 'PL', 'POL', 'بولندا'),
(31439, 1578611944, 1578611947, 'FR', 'FRA', 'فرنسا'),
(31440, 1578611948, 1578611951, 'GB', 'GBR', 'المملكة المتحدة'),
(31441, 1578611952, 1578611967, 'FR', 'FRA', 'فرنسا'),
(31442, 1578611968, 1578612159, 'GB', 'GBR', 'المملكة المتحدة'),
(31443, 1578612160, 1578612223, 'PL', 'POL', 'بولندا'),
(31444, 1578612224, 1578612239, 'DE', 'DEU', 'ألمانيا'),
(31445, 1578612240, 1578612255, 'FR', 'FRA', 'فرنسا'),
(31446, 1578612256, 1578612259, 'PL', 'POL', 'بولندا'),
(31447, 1578612260, 1578612263, 'IT', 'ITA', 'إيطاليا'),
(31448, 1578612264, 1578612271, 'FR', 'FRA', 'فرنسا'),
(31449, 1578612272, 1578612287, 'ES', 'ESP', 'إسبانيا'),
(31450, 1578612288, 1578612303, 'BE', 'BEL', 'بلجيكا'),
(31451, 1578612304, 1578612319, 'DE', 'DEU', 'ألمانيا'),
(31452, 1578612320, 1578612383, 'FR', 'FRA', 'فرنسا'),
(31453, 1578612384, 1578612415, 'PL', 'POL', 'بولندا'),
(31454, 1578612416, 1578612623, 'FR', 'FRA', 'فرنسا'),
(31455, 1578612624, 1578612639, 'CH', 'CHE', 'سويسرا'),
(31456, 1578612640, 1578612671, 'PL', 'POL', 'بولندا'),
(31457, 1578612672, 1578612687, 'FR', 'FRA', 'فرنسا'),
(31458, 1578612688, 1578612703, 'DE', 'DEU', 'ألمانيا'),
(31459, 1578612704, 1578612863, 'FR', 'FRA', 'فرنسا'),
(31460, 1578612864, 1578612895, 'NL', 'NLD', 'هولندا'),
(31461, 1578612896, 1578612911, 'PL', 'POL', 'بولندا'),
(31462, 1578612912, 1578612975, 'ES', 'ESP', 'إسبانيا'),
(31463, 1578612976, 1578612991, 'FR', 'FRA', 'فرنسا'),
(31464, 1578612992, 1578613247, 'DE', 'DEU', 'ألمانيا'),
(31465, 1578613248, 1578613503, 'FR', 'FRA', 'فرنسا'),
(31466, 1578613504, 1578613567, 'DE', 'DEU', 'ألمانيا'),
(31467, 1578613568, 1578613631, 'PL', 'POL', 'بولندا'),
(31468, 1578613632, 1578613647, 'DE', 'DEU', 'ألمانيا'),
(31469, 1578613648, 1578613679, 'FR', 'FRA', 'فرنسا'),
(31470, 1578613680, 1578613695, 'ES', 'ESP', 'إسبانيا'),
(31471, 1578613696, 1578613711, 'NL', 'NLD', 'هولندا'),
(31472, 1578613712, 1578613719, 'BE', 'BEL', 'بلجيكا'),
(31473, 1578613720, 1578613723, 'ES', 'ESP', 'إسبانيا'),
(31474, 1578613724, 1578613727, 'IT', 'ITA', 'إيطاليا'),
(31475, 1578613728, 1578613743, 'CZ', 'CZE', 'التشيك'),
(31476, 1578613744, 1578613751, 'ES', 'ESP', 'إسبانيا'),
(31477, 1578613752, 1578613759, 'NL', 'NLD', 'هولندا'),
(31478, 1578613760, 1578613791, 'DE', 'DEU', 'ألمانيا'),
(31479, 1578613792, 1578613823, 'ES', 'ESP', 'إسبانيا'),
(31480, 1578613824, 1578613887, 'IT', 'ITA', 'إيطاليا'),
(31481, 1578613888, 1578613951, 'ES', 'ESP', 'إسبانيا'),
(31482, 1578613952, 1578614015, 'IE', 'IRL', 'إيرلندا'),
(31483, 1578614016, 1578614031, 'FR', 'FRA', 'فرنسا'),
(31484, 1578614032, 1578614047, 'BE', 'BEL', 'بلجيكا'),
(31485, 1578614048, 1578614071, 'FR', 'FRA', 'فرنسا'),
(31486, 1578614072, 1578614079, 'ES', 'ESP', 'إسبانيا'),
(31487, 1578614080, 1578614175, 'FR', 'FRA', 'فرنسا'),
(31488, 1578614176, 1578614191, 'ES', 'ESP', 'إسبانيا'),
(31489, 1578614192, 1578614195, 'FR', 'FRA', 'فرنسا'),
(31490, 1578614196, 1578614207, 'GB', 'GBR', 'المملكة المتحدة'),
(31491, 1578614208, 1578614271, 'PL', 'POL', 'بولندا'),
(31492, 1578614272, 1578614527, 'ES', 'ESP', 'إسبانيا'),
(31493, 1578614528, 1578631167, 'FR', 'FRA', 'فرنسا'),
(31494, 1578631168, 1578663935, 'RO', 'ROM', 'رومانيا'),
(31495, 1578663936, 1578762239, 'RU', 'RUS', 'الإتحاد الروسي'),
(31496, 1578762240, 1578795007, 'BG', 'BGR', 'بلغاريا'),
(31497, 1578795008, 1578827775, 'RU', 'RUS', 'الإتحاد الروسي'),
(31498, 1578827776, 1578860543, 'UA', 'UKR', 'أوكرانيا'),
(31499, 1578860544, 1578893311, 'HU', 'HUN', 'هنغاريا'),
(31500, 1578893312, 1578991615, 'RU', 'RUS', 'الإتحاد الروسي'),
(31501, 1578991616, 1579024383, 'KW', 'KWT', 'الكويت'),
(31502, 1579024384, 1579057151, 'GB', 'GBR', 'المملكة المتحدة'),
(31503, 1579057152, 1579089919, 'LV', 'LVA', 'لاتفيا'),
(31504, 1579089920, 1579090575, 'NL', 'NLD', 'هولندا'),
(31505, 1579090576, 1579090687, 'GB', 'GBR', 'المملكة المتحدة'),
(31506, 1579090688, 1579090943, 'NL', 'NLD', 'هولندا'),
(31507, 1579090944, 1579091967, 'GB', 'GBR', 'المملكة المتحدة'),
(31508, 1579091968, 1579092223, 'DE', 'DEU', 'ألمانيا'),
(31509, 1579092224, 1579104511, 'GB', 'GBR', 'المملكة المتحدة'),
(31510, 1579104512, 1579104767, 'NL', 'NLD', 'هولندا'),
(31511, 1579104768, 1579105023, 'GB', 'GBR', 'المملكة المتحدة'),
(31512, 1579105024, 1579105151, 'NL', 'NLD', 'هولندا'),
(31513, 1579105152, 1579105279, 'GB', 'GBR', 'المملكة المتحدة'),
(31514, 1579105280, 1579105343, 'NL', 'NLD', 'هولندا'),
(31515, 1579105344, 1579105535, 'GB', 'GBR', 'المملكة المتحدة'),
(31516, 1579105536, 1579105599, 'NL', 'NLD', 'هولندا'),
(31517, 1579105600, 1579106303, 'GB', 'GBR', 'المملكة المتحدة'),
(31518, 1579106304, 1579122687, 'DE', 'DEU', 'ألمانيا'),
(31519, 1579122688, 1579155455, 'RU', 'RUS', 'الإتحاد الروسي'),
(31520, 1579155456, 1579679743, 'IT', 'ITA', 'إيطاليا'),
(31521, 1579679744, 1579745279, 'PL', 'POL', 'بولندا'),
(31522, 1579745280, 1579810815, 'RU', 'RUS', 'الإتحاد الروسي'),
(31523, 1579810816, 1579876351, 'PL', 'POL', 'بولندا'),
(31524, 1579876352, 1579941887, 'GE', 'GEO', 'جورجيا'),
(31525, 1579941888, 1580007423, 'HU', 'HUN', 'هنغاريا'),
(31526, 1580007424, 1580015615, 'RU', 'RUS', 'الإتحاد الروسي'),
(31527, 1580015616, 1580048383, 'UA', 'UKR', 'أوكرانيا'),
(31528, 1580048384, 1580064767, 'RU', 'RUS', 'الإتحاد الروسي'),
(31529, 1580064768, 1580072959, 'DE', 'DEU', 'ألمانيا'),
(31530, 1580072960, 1580134399, 'PT', 'PRT', 'البورتوغال'),
(31531, 1580134400, 1580136447, 'ES', 'ESP', 'إسبانيا'),
(31532, 1580136448, 1580138495, 'PT', 'PRT', 'البورتوغال'),
(31533, 1580138496, 1580204031, 'IT', 'ITA', 'إيطاليا'),
(31534, 1580204032, 1580335103, 'RO', 'ROM', 'رومانيا'),
(31535, 1580335104, 1580466175, 'RU', 'RUS', 'الإتحاد الروسي'),
(31536, 1580466176, 1580597247, 'RO', 'ROM', 'رومانيا'),
(31537, 1580597248, 1580728319, 'TR', 'TUR', 'تركيا'),
(31538, 1580728320, 1580990463, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(31539, 1580990464, 1581252607, 'RO', 'ROM', 'رومانيا'),
(31540, 1581252608, 1581776895, 'GR', 'GRC', 'اليونان'),
(31541, 1581776896, 1581793279, 'RU', 'RUS', 'الإتحاد الروسي'),
(31542, 1581793280, 1581809663, 'PL', 'POL', 'بولندا'),
(31543, 1581809664, 1581826047, 'BG', 'BGR', 'بلغاريا'),
(31544, 1581826048, 1581842431, 'GB', 'GBR', 'المملكة المتحدة'),
(31545, 1581842432, 1581858815, 'BG', 'BGR', 'بلغاريا'),
(31546, 1581858816, 1581875199, 'IT', 'ITA', 'إيطاليا'),
(31547, 1581875200, 1581891583, 'TR', 'TUR', 'تركيا'),
(31548, 1581891584, 1581907967, 'RU', 'RUS', 'الإتحاد الروسي'),
(31549, 1581907968, 1581924351, 'IT', 'ITA', 'إيطاليا'),
(31550, 1581924352, 1581940735, 'UA', 'UKR', 'أوكرانيا'),
(31551, 1581940736, 1581957119, 'IR', 'IRN', 'إيران'),
(31552, 1581957120, 1581973503, 'CZ', 'CZE', 'التشيك'),
(31553, 1581973504, 1581989887, 'RU', 'RUS', 'الإتحاد الروسي'),
(31554, 1581989888, 1582006271, 'PL', 'POL', 'بولندا'),
(31555, 1582006272, 1582022655, 'RU', 'RUS', 'الإتحاد الروسي'),
(31556, 1582022656, 1582039039, 'NL', 'NLD', 'هولندا'),
(31557, 1582039040, 1582055423, 'RU', 'RUS', 'الإتحاد الروسي'),
(31558, 1582055424, 1582071807, 'UA', 'UKR', 'أوكرانيا'),
(31559, 1582071808, 1582088191, 'ES', 'ESP', 'إسبانيا'),
(31560, 1582088192, 1582104575, 'GB', 'GBR', 'المملكة المتحدة'),
(31561, 1582104576, 1582153727, 'RU', 'RUS', 'الإتحاد الروسي'),
(31562, 1582153728, 1582170111, 'SA', 'SAU', 'السعودية'),
(31563, 1582170112, 1582186495, 'CH', 'CHE', 'سويسرا'),
(31564, 1582186496, 1582202879, 'TR', 'TUR', 'تركيا'),
(31565, 1582202880, 1582219263, 'PL', 'POL', 'بولندا'),
(31566, 1582219264, 1582252031, 'RU', 'RUS', 'الإتحاد الروسي'),
(31567, 1582252032, 1582268415, 'TR', 'TUR', 'تركيا'),
(31568, 1582268416, 1582284799, 'DE', 'DEU', 'ألمانيا'),
(31569, 1582284800, 1582301183, 'BH', 'BHR', 'البحرين'),
(31570, 1582301184, 1583349759, 'IT', 'ITA', 'إيطاليا'),
(31571, 1583349760, 1583611903, 'SA', 'SAU', 'السعودية'),
(31572, 1583611904, 1583615999, 'LV', 'LVA', 'لاتفيا'),
(31573, 1583616000, 1583620095, 'NL', 'NLD', 'هولندا'),
(31574, 1583620096, 1583624191, 'IT', 'ITA', 'إيطاليا'),
(31575, 1583624192, 1583628287, 'RS', 'SRB', 'صربيا'),
(31576, 1583628288, 1583632383, 'DE', 'DEU', 'ألمانيا'),
(31577, 1583632384, 1583636479, 'RU', 'RUS', 'الإتحاد الروسي'),
(31578, 1583636480, 1583640575, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(31579, 1583640576, 1583644671, 'NL', 'NLD', 'هولندا'),
(31580, 1583644672, 1583648767, 'DE', 'DEU', 'ألمانيا'),
(31581, 1583648768, 1583652863, 'CH', 'CHE', 'سويسرا'),
(31582, 1583652864, 1583656959, 'FR', 'FRA', 'فرنسا'),
(31583, 1583656960, 1583665151, 'RU', 'RUS', 'الإتحاد الروسي'),
(31584, 1583665152, 1583669247, 'UA', 'UKR', 'أوكرانيا'),
(31585, 1583669248, 1583673343, 'GE', 'GEO', 'جورجيا'),
(31586, 1583673344, 1583673991, 'DE', 'DEU', 'ألمانيا'),
(31587, 1583673992, 1583673999, 'GB', 'GBR', 'المملكة المتحدة'),
(31588, 1583674000, 1583674015, 'DE', 'DEU', 'ألمانيا'),
(31589, 1583674016, 1583674039, 'NL', 'NLD', 'هولندا'),
(31590, 1583674040, 1583677439, 'DE', 'DEU', 'ألمانيا'),
(31591, 1583677440, 1583681535, 'FI', 'FIN', 'فنلندا'),
(31592, 1583681536, 1583685631, 'PL', 'POL', 'بولندا'),
(31593, 1583685632, 1583689727, 'DE', 'DEU', 'ألمانيا'),
(31594, 1583689728, 1583693823, 'IT', 'ITA', 'إيطاليا'),
(31595, 1583693824, 1583697919, 'RU', 'RUS', 'الإتحاد الروسي'),
(31596, 1583697920, 1583702015, 'TR', 'TUR', 'تركيا'),
(31597, 1583702016, 1583706111, 'RU', 'RUS', 'الإتحاد الروسي'),
(31598, 1583706112, 1583710207, 'GI', 'GIB', 'جبل طارق'),
(31599, 1583710208, 1583712255, 'IR', 'IRN', 'إيران'),
(31600, 1583712256, 1583714303, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(31601, 1583714304, 1583722495, 'GB', 'GBR', 'المملكة المتحدة'),
(31602, 1583722496, 1583726591, 'IR', 'IRN', 'إيران'),
(31603, 1583726592, 1583730687, 'BG', 'BGR', 'بلغاريا'),
(31604, 1583730688, 1583732383, 'DK', 'DNK', 'الدنيمارك'),
(31605, 1583732384, 1583732399, 'DE', 'DEU', 'ألمانيا'),
(31606, 1583732400, 1583734783, 'DK', 'DNK', 'الدنيمارك'),
(31607, 1583734784, 1583738879, 'LV', 'LVA', 'لاتفيا'),
(31608, 1583738880, 1583742975, 'IR', 'IRN', 'إيران'),
(31609, 1583742976, 1583747071, 'TR', 'TUR', 'تركيا'),
(31610, 1583747072, 1583751167, 'RU', 'RUS', 'الإتحاد الروسي'),
(31611, 1583751168, 1583755263, 'NO', 'NOR', 'النرويج'),
(31612, 1583755264, 1583759359, 'NL', 'NLD', 'هولندا'),
(31613, 1583759360, 1583763455, 'TR', 'TUR', 'تركيا'),
(31614, 1583763456, 1583767551, 'RU', 'RUS', 'الإتحاد الروسي'),
(31615, 1583767552, 1583771647, 'AT', 'AUT', 'النمسا'),
(31616, 1583771648, 1583775743, 'RU', 'RUS', 'الإتحاد الروسي'),
(31617, 1583775744, 1583779839, 'IT', 'ITA', 'إيطاليا'),
(31618, 1583779840, 1583783935, 'GB', 'GBR', 'المملكة المتحدة'),
(31619, 1583788032, 1583792127, 'TM', 'TKM', 'تركمينيستان'),
(31620, 1583792128, 1583796223, 'IE', 'IRL', 'إيرلندا'),
(31621, 1583796224, 1583800319, 'DE', 'DEU', 'ألمانيا'),
(31622, 1583800320, 1583804415, 'ME', 'MNE', 'الجبل الأسود'),
(31623, 1583804416, 1583808511, 'GB', 'GBR', 'المملكة المتحدة'),
(31624, 1583808512, 1583812607, 'MD', 'MDA', 'مولدوفا'),
(31625, 1583812608, 1583813679, 'NL', 'NLD', 'هولندا'),
(31626, 1583813680, 1583813683, 'GB', 'GBR', 'المملكة المتحدة'),
(31627, 1583813684, 1583813711, 'NL', 'NLD', 'هولندا'),
(31628, 1583813712, 1583813727, 'US', 'USA', 'الولايات المتحدة'),
(31629, 1583813728, 1583816703, 'NL', 'NLD', 'هولندا'),
(31630, 1583816704, 1583820799, 'TR', 'TUR', 'تركيا'),
(31631, 1583820800, 1583824895, 'LV', 'LVA', 'لاتفيا'),
(31632, 1583824896, 1583828991, 'SI', 'SVN', 'سلوفينيا'),
(31633, 1583828992, 1583833087, 'RU', 'RUS', 'الإتحاد الروسي'),
(31634, 1583833088, 1583837183, 'CH', 'CHE', 'سويسرا'),
(31635, 1583837184, 1583841279, 'GB', 'GBR', 'المملكة المتحدة'),
(31636, 1583841280, 1583845375, 'FR', 'FRA', 'فرنسا'),
(31637, 1583845376, 1583845727, 'NL', 'NLD', 'هولندا'),
(31638, 1583845728, 1583845743, 'BE', 'BEL', 'بلجيكا'),
(31639, 1583845744, 1583848639, 'NL', 'NLD', 'هولندا'),
(31640, 1583848640, 1583848703, 'BE', 'BEL', 'بلجيكا'),
(31641, 1583848704, 1583848735, 'NL', 'NLD', 'هولندا'),
(31642, 1583848736, 1583848799, 'BE', 'BEL', 'بلجيكا'),
(31643, 1583848800, 1583849471, 'NL', 'NLD', 'هولندا'),
(31644, 1583849472, 1583853567, 'DE', 'DEU', 'ألمانيا'),
(31645, 1583853568, 1583857663, 'RU', 'RUS', 'الإتحاد الروسي'),
(31646, 1583857664, 1583861759, 'SE', 'SWE', 'السويد'),
(31647, 1583861760, 1583865855, 'LU', 'LUX', 'لوكسيمبورغ'),
(31648, 1583865856, 1583869951, 'RU', 'RUS', 'الإتحاد الروسي'),
(31649, 1583869952, 1583874047, 'KZ', 'KAZ', 'كازاخستان'),
(31650, 1583874048, 1584398335, 'BE', 'BEL', 'بلجيكا'),
(31651, 1584398336, 1584660479, 'CZ', 'CZE', 'التشيك'),
(31652, 1584660480, 1584922623, 'GB', 'GBR', 'المملكة المتحدة'),
(31653, 1584922624, 1585184767, 'TR', 'TUR', 'تركيا'),
(31654, 1585184768, 1585190911, 'PL', 'POL', 'بولندا'),
(31655, 1585190912, 1585192959, 'ES', 'ESP', 'إسبانيا'),
(31656, 1585192960, 1585195007, 'IT', 'ITA', 'إيطاليا'),
(31657, 1585195008, 1585197055, 'CZ', 'CZE', 'التشيك'),
(31658, 1585197056, 1585199103, 'IT', 'ITA', 'إيطاليا'),
(31659, 1585199104, 1585201151, 'NL', 'NLD', 'هولندا'),
(31660, 1585201152, 1585205247, 'IT', 'ITA', 'إيطاليا'),
(31661, 1585205248, 1585207295, 'FR', 'FRA', 'فرنسا'),
(31662, 1585207296, 1585209855, 'NL', 'NLD', 'هولندا'),
(31663, 1585209856, 1585210111, 'IQ', 'IRQ', 'العراق'),
(31664, 1585210112, 1585210879, 'IR', 'IRN', 'إيران'),
(31665, 1585210880, 1585211391, 'NL', 'NLD', 'هولندا'),
(31666, 1585211392, 1585213439, 'CZ', 'CZE', 'التشيك'),
(31667, 1585213440, 1585214463, 'GB', 'GBR', 'المملكة المتحدة'),
(31668, 1585214464, 1585217535, 'NL', 'NLD', 'هولندا'),
(31669, 1585217536, 1585219583, 'FR', 'FRA', 'فرنسا'),
(31670, 1585219584, 1585221631, 'NL', 'NLD', 'هولندا'),
(31671, 1585221632, 1585223679, 'SK', 'SVK', 'سلوفاكيا'),
(31672, 1585223680, 1585225727, 'FR', 'FRA', 'فرنسا'),
(31673, 1585225728, 1585227775, 'UA', 'UKR', 'أوكرانيا'),
(31674, 1585227776, 1585231871, 'RU', 'RUS', 'الإتحاد الروسي'),
(31675, 1585231872, 1585233919, 'CZ', 'CZE', 'التشيك'),
(31676, 1585233920, 1585235967, 'LB', 'LBN', 'لبنان'),
(31677, 1585235968, 1585238015, 'RU', 'RUS', 'الإتحاد الروسي'),
(31678, 1585238016, 1585240063, 'DE', 'DEU', 'ألمانيا'),
(31679, 1585240064, 1585241087, 'FR', 'FRA', 'فرنسا'),
(31680, 1585241088, 1585242111, 'MQ', 'MTQ', 'مارتينيك'),
(31681, 1585242112, 1585244159, 'RU', 'RUS', 'الإتحاد الروسي'),
(31682, 1585244160, 1585246207, 'FR', 'FRA', 'فرنسا'),
(31683, 1585246208, 1585248255, 'RU', 'RUS', 'الإتحاد الروسي'),
(31684, 1585248256, 1585250303, 'CZ', 'CZE', 'التشيك'),
(31685, 1585250304, 1585254399, 'RU', 'RUS', 'الإتحاد الروسي'),
(31686, 1585254400, 1585256447, 'GB', 'GBR', 'المملكة المتحدة'),
(31687, 1585256448, 1585258495, 'DE', 'DEU', 'ألمانيا'),
(31688, 1585258496, 1585260543, 'GB', 'GBR', 'المملكة المتحدة'),
(31689, 1585262592, 1585264639, 'RU', 'RUS', 'الإتحاد الروسي'),
(31690, 1585264640, 1585266687, 'MT', 'MLT', 'مالطا'),
(31691, 1585266688, 1585270783, 'DE', 'DEU', 'ألمانيا'),
(31692, 1585270784, 1585272831, 'IT', 'ITA', 'إيطاليا'),
(31693, 1585272832, 1585274879, 'RU', 'RUS', 'الإتحاد الروسي'),
(31694, 1585274880, 1585276927, 'ES', 'ESP', 'إسبانيا'),
(31695, 1585276928, 1585278975, 'FR', 'FRA', 'فرنسا'),
(31696, 1585278976, 1585281023, 'AL', 'ALB', 'ألبانيا'),
(31697, 1585281024, 1585283071, 'UA', 'UKR', 'أوكرانيا'),
(31698, 1585283072, 1585285119, 'GB', 'GBR', 'المملكة المتحدة'),
(31699, 1585285120, 1585287167, 'ES', 'ESP', 'إسبانيا'),
(31700, 1585287168, 1585289215, 'CY', 'CYP', 'قبرص'),
(31701, 1585289216, 1585291263, 'DE', 'DEU', 'ألمانيا'),
(31702, 1585291264, 1585295359, 'FR', 'FRA', 'فرنسا'),
(31703, 1585295360, 1585297407, 'HU', 'HUN', 'هنغاريا'),
(31704, 1585297408, 1585299455, 'RU', 'RUS', 'الإتحاد الروسي'),
(31705, 1585299456, 1585301503, 'GB', 'GBR', 'المملكة المتحدة'),
(31706, 1585301504, 1585303551, 'LU', 'LUX', 'لوكسيمبورغ'),
(31707, 1585303552, 1585305599, 'DE', 'DEU', 'ألمانيا'),
(31708, 1585305600, 1585307647, 'CZ', 'CZE', 'التشيك'),
(31709, 1585307648, 1585309695, 'QA', 'QAT', 'قطر'),
(31710, 1585309696, 1585311743, 'IT', 'ITA', 'إيطاليا'),
(31711, 1585311744, 1585313791, 'RU', 'RUS', 'الإتحاد الروسي'),
(31712, 1585313792, 1585315839, 'HU', 'HUN', 'هنغاريا'),
(31713, 1585315840, 1585317887, 'DK', 'DNK', 'الدنيمارك'),
(31714, 1585317888, 1585319935, 'IT', 'ITA', 'إيطاليا'),
(31715, 1585319936, 1585321983, 'CH', 'CHE', 'سويسرا'),
(31716, 1585321984, 1585324031, 'RU', 'RUS', 'الإتحاد الروسي'),
(31717, 1585324032, 1585326079, 'NL', 'NLD', 'هولندا'),
(31718, 1585326080, 1585328127, 'GB', 'GBR', 'المملكة المتحدة'),
(31719, 1585328128, 1585330175, 'BE', 'BEL', 'بلجيكا'),
(31720, 1585330176, 1585332223, 'IT', 'ITA', 'إيطاليا'),
(31721, 1585332224, 1585334271, 'NL', 'NLD', 'هولندا'),
(31722, 1585334272, 1585336319, 'DE', 'DEU', 'ألمانيا'),
(31723, 1585336320, 1585338367, 'SE', 'SWE', 'السويد'),
(31724, 1585338368, 1585340415, 'RU', 'RUS', 'الإتحاد الروسي'),
(31725, 1585340416, 1585342463, 'AT', 'AUT', 'النمسا'),
(31726, 1585342464, 1585344511, 'GB', 'GBR', 'المملكة المتحدة'),
(31727, 1585344512, 1585346559, 'FR', 'FRA', 'فرنسا'),
(31728, 1585346560, 1585348607, 'GB', 'GBR', 'المملكة المتحدة'),
(31729, 1585348608, 1585350655, 'CH', 'CHE', 'سويسرا'),
(31730, 1585350656, 1585352703, 'IT', 'ITA', 'إيطاليا'),
(31731, 1585352704, 1585354751, 'PT', 'PRT', 'البورتوغال'),
(31732, 1585354752, 1585356799, 'RU', 'RUS', 'الإتحاد الروسي'),
(31733, 1585356800, 1585358847, 'FI', 'FIN', 'فنلندا'),
(31734, 1585358848, 1585360895, 'PT', 'PRT', 'البورتوغال'),
(31735, 1585360896, 1585362943, 'GB', 'GBR', 'المملكة المتحدة'),
(31736, 1585362944, 1585363455, 'IT', 'ITA', 'إيطاليا'),
(31737, 1585363456, 1585363551, 'ES', 'ESP', 'إسبانيا'),
(31738, 1585363552, 1585364991, 'IT', 'ITA', 'إيطاليا'),
(31739, 1585364992, 1585367039, 'GB', 'GBR', 'المملكة المتحدة'),
(31740, 1585367040, 1585369087, 'RU', 'RUS', 'الإتحاد الروسي'),
(31741, 1585369088, 1585371135, 'GB', 'GBR', 'المملكة المتحدة'),
(31742, 1585371136, 1585375231, 'SE', 'SWE', 'السويد'),
(31743, 1585375232, 1585377279, 'GB', 'GBR', 'المملكة المتحدة'),
(31744, 1585377280, 1585379327, 'ES', 'ESP', 'إسبانيا'),
(31745, 1585379328, 1585381375, 'CH', 'CHE', 'سويسرا'),
(31746, 1585381376, 1585381887, 'RS', 'SRB', 'صربيا'),
(31747, 1585381888, 1585383423, 'GB', 'GBR', 'المملكة المتحدة'),
(31748, 1585383424, 1585385471, 'FR', 'FRA', 'فرنسا'),
(31749, 1585385472, 1585387519, 'DE', 'DEU', 'ألمانيا'),
(31750, 1585387520, 1585389567, 'SI', 'SVN', 'سلوفينيا'),
(31751, 1585389568, 1585391615, 'SE', 'SWE', 'السويد'),
(31752, 1585391616, 1585393663, 'IT', 'ITA', 'إيطاليا'),
(31753, 1585393664, 1585395711, 'DK', 'DNK', 'الدنيمارك'),
(31754, 1585395712, 1585397759, 'NO', 'NOR', 'النرويج'),
(31755, 1585397760, 1585399807, 'RU', 'RUS', 'الإتحاد الروسي'),
(31756, 1585399808, 1585400063, 'NL', 'NLD', 'هولندا'),
(31757, 1585400064, 1585400319, 'IL', 'ISR', 'إسرائيل'),
(31758, 1585400320, 1585400575, 'GB', 'GBR', 'المملكة المتحدة'),
(31759, 1585400576, 1585401855, 'US', 'USA', 'الولايات المتحدة'),
(31760, 1585401856, 1585403903, 'IT', 'ITA', 'إيطاليا'),
(31761, 1585403904, 1585405951, 'RU', 'RUS', 'الإتحاد الروسي'),
(31762, 1585405952, 1585407999, 'GB', 'GBR', 'المملكة المتحدة'),
(31763, 1585408000, 1585410047, 'PL', 'POL', 'بولندا'),
(31764, 1585410048, 1585412095, 'GB', 'GBR', 'المملكة المتحدة'),
(31765, 1585412096, 1585414143, 'NO', 'NOR', 'النرويج'),
(31766, 1585414144, 1585416191, 'CZ', 'CZE', 'التشيك'),
(31767, 1585416192, 1585422335, 'RU', 'RUS', 'الإتحاد الروسي'),
(31768, 1585422336, 1585424383, 'ES', 'ESP', 'إسبانيا'),
(31769, 1585424384, 1585428479, 'RU', 'RUS', 'الإتحاد الروسي'),
(31770, 1585428480, 1585432575, 'ES', 'ESP', 'إسبانيا'),
(31771, 1585432576, 1585434623, 'RU', 'RUS', 'الإتحاد الروسي'),
(31772, 1585434624, 1585436671, 'JO', 'JOR', 'الأردن'),
(31773, 1585436672, 1585438719, 'RU', 'RUS', 'الإتحاد الروسي'),
(31774, 1585438720, 1585440767, 'DE', 'DEU', 'ألمانيا'),
(31775, 1585440768, 1585442815, 'IT', 'ITA', 'إيطاليا'),
(31776, 1585442816, 1585446911, 'RU', 'RUS', 'الإتحاد الروسي'),
(31777, 1585446912, 1585577983, 'KW', 'KWT', 'الكويت'),
(31778, 1585577984, 1585709055, 'UA', 'UKR', 'أوكرانيا'),
(31779, 1585709056, 1585840127, 'PT', 'PRT', 'البورتوغال'),
(31780, 1585840128, 1585971199, 'DE', 'DEU', 'ألمانيا'),
(31781, 1585971200, 1585979391, 'AT', 'AUT', 'النمسا'),
(31782, 1585979392, 1585987583, 'GB', 'GBR', 'المملكة المتحدة'),
(31783, 1585987584, 1585988095, 'SE', 'SWE', 'السويد'),
(31784, 1585988096, 1585988103, 'IT', 'ITA', 'إيطاليا'),
(31785, 1585988104, 1585988351, 'SE', 'SWE', 'السويد'),
(31786, 1585988352, 1585988359, 'DE', 'DEU', 'ألمانيا'),
(31787, 1585988360, 1585990655, 'SE', 'SWE', 'السويد'),
(31788, 1585990656, 1585990659, 'US', 'USA', 'الولايات المتحدة'),
(31789, 1585990660, 1585990911, 'SE', 'SWE', 'السويد'),
(31790, 1585990912, 1585990915, 'US', 'USA', 'الولايات المتحدة'),
(31791, 1585990916, 1585991167, 'SE', 'SWE', 'السويد'),
(31792, 1585991168, 1585991171, 'US', 'USA', 'الولايات المتحدة'),
(31793, 1585991172, 1585991683, 'SE', 'SWE', 'السويد'),
(31794, 1585991684, 1585991687, 'US', 'USA', 'الولايات المتحدة'),
(31795, 1585991688, 1585991935, 'SE', 'SWE', 'السويد'),
(31796, 1585991936, 1585991939, 'US', 'USA', 'الولايات المتحدة'),
(31797, 1585991940, 1585995775, 'SE', 'SWE', 'السويد'),
(31798, 1585995776, 1586003967, 'AT', 'AUT', 'النمسا'),
(31799, 1586003968, 1586012159, 'SK', 'SVK', 'سلوفاكيا'),
(31800, 1586012160, 1586020351, 'DE', 'DEU', 'ألمانيا'),
(31801, 1586020352, 1586028543, 'RU', 'RUS', 'الإتحاد الروسي'),
(31802, 1586028544, 1586036735, 'GB', 'GBR', 'المملكة المتحدة'),
(31803, 1586036736, 1586061311, 'RU', 'RUS', 'الإتحاد الروسي'),
(31804, 1586061312, 1586069503, 'HR', 'HRV', 'كرواتيا'),
(31805, 1586069504, 1586077695, 'DE', 'DEU', 'ألمانيا'),
(31806, 1586077696, 1586085887, 'GE', 'GEO', 'جورجيا'),
(31807, 1586085888, 1586110463, 'RU', 'RUS', 'الإتحاد الروسي'),
(31808, 1586110464, 1586118655, 'IT', 'ITA', 'إيطاليا'),
(31809, 1586118656, 1586126847, 'DK', 'DNK', 'الدنيمارك'),
(31810, 1586126848, 1586128383, 'CZ', 'CZE', 'التشيك'),
(31811, 1586128384, 1586128639, 'SK', 'SVK', 'سلوفاكيا'),
(31812, 1586128640, 1586135039, 'CZ', 'CZE', 'التشيك'),
(31813, 1586135040, 1586143231, 'RU', 'RUS', 'الإتحاد الروسي'),
(31814, 1586143232, 1586151423, 'IT', 'ITA', 'إيطاليا'),
(31815, 1586151424, 1586159615, 'TR', 'TUR', 'تركيا'),
(31816, 1586159616, 1586167807, 'MT', 'MLT', 'مالطا'),
(31817, 1586167808, 1586175999, 'DE', 'DEU', 'ألمانيا'),
(31818, 1586176000, 1586184191, 'BE', 'BEL', 'بلجيكا'),
(31819, 1586184192, 1586192383, 'NO', 'NOR', 'النرويج'),
(31820, 1586192384, 1586200575, 'RU', 'RUS', 'الإتحاد الروسي'),
(31821, 1586200576, 1586208767, 'MD', 'MDA', 'مولدوفا'),
(31822, 1586208768, 1586216959, 'IR', 'IRN', 'إيران'),
(31823, 1586216960, 1586225151, 'BG', 'BGR', 'بلغاريا'),
(31824, 1586225152, 1586233343, 'RU', 'RUS', 'الإتحاد الروسي'),
(31825, 1586233344, 1586241535, 'FR', 'FRA', 'فرنسا'),
(31826, 1586241536, 1586249727, 'SE', 'SWE', 'السويد'),
(31827, 1586249728, 1586257919, 'SI', 'SVN', 'سلوفينيا'),
(31828, 1586266112, 1586274303, 'RU', 'RUS', 'الإتحاد الروسي'),
(31829, 1586274304, 1586282495, 'BE', 'BEL', 'بلجيكا'),
(31830, 1586282496, 1586298879, 'RU', 'RUS', 'الإتحاد الروسي'),
(31831, 1586298880, 1586307071, 'IT', 'ITA', 'إيطاليا'),
(31832, 1586307072, 1586315263, 'RU', 'RUS', 'الإتحاد الروسي'),
(31833, 1586315264, 1586323455, 'UZ', 'UZB', 'أوزباكستان'),
(31834, 1586323456, 1586331647, 'RU', 'RUS', 'الإتحاد الروسي'),
(31835, 1586331648, 1586339839, 'PL', 'POL', 'بولندا'),
(31836, 1586339840, 1586348031, 'RU', 'RUS', 'الإتحاد الروسي'),
(31837, 1586348032, 1586356223, 'SY', 'SYR', 'سوريا'),
(31838, 1586356224, 1586372607, 'RU', 'RUS', 'الإتحاد الروسي'),
(31839, 1586372608, 1586380799, 'JO', 'JOR', 'الأردن'),
(31840, 1586380800, 1586388991, 'GB', 'GBR', 'المملكة المتحدة'),
(31841, 1586388992, 1586397183, 'ES', 'ESP', 'إسبانيا'),
(31842, 1586397184, 1586399231, 'LV', 'LVA', 'لاتفيا'),
(31843, 1586399232, 1586401279, 'RU', 'RUS', 'الإتحاد الروسي'),
(31844, 1586401280, 1586403327, 'IT', 'ITA', 'إيطاليا'),
(31845, 1586403328, 1586405375, 'IS', 'ISL', 'أيسلندا'),
(31846, 1586405376, 1586407423, 'AT', 'AUT', 'النمسا'),
(31847, 1586407424, 1586409471, 'GB', 'GBR', 'المملكة المتحدة'),
(31848, 1586409472, 1586411519, 'IT', 'ITA', 'إيطاليا'),
(31849, 1586411520, 1586411775, 'GB', 'GBR', 'المملكة المتحدة'),
(31850, 1586411776, 1586412287, 'US', 'USA', 'الولايات المتحدة'),
(31851, 1586412288, 1586412543, 'HK', 'HKG', 'هونغ كونغ'),
(31852, 1586412544, 1586413567, 'GB', 'GBR', 'المملكة المتحدة'),
(31853, 1586413568, 1586415615, 'IT', 'ITA', 'إيطاليا'),
(31854, 1586415616, 1586417663, 'ES', 'ESP', 'إسبانيا'),
(31855, 1586417664, 1586419711, 'NL', 'NLD', 'هولندا'),
(31856, 1586419712, 1586421759, 'DE', 'DEU', 'ألمانيا'),
(31857, 1586421760, 1586423807, 'SE', 'SWE', 'السويد'),
(31858, 1586423808, 1586425855, 'CZ', 'CZE', 'التشيك'),
(31859, 1586425856, 1586427903, 'NL', 'NLD', 'هولندا'),
(31860, 1586427904, 1586428159, 'CH', 'CHE', 'سويسرا'),
(31861, 1586428160, 1586429951, 'FR', 'FRA', 'فرنسا'),
(31862, 1586429952, 1586431999, 'CH', 'CHE', 'سويسرا'),
(31863, 1586432000, 1586434047, 'DK', 'DNK', 'الدنيمارك'),
(31864, 1586434048, 1586436095, 'BE', 'BEL', 'بلجيكا'),
(31865, 1586436096, 1586438143, 'ES', 'ESP', 'إسبانيا'),
(31866, 1586438144, 1586446335, 'RU', 'RUS', 'الإتحاد الروسي'),
(31867, 1586446336, 1586448383, 'NO', 'NOR', 'النرويج'),
(31868, 1586448384, 1586450431, 'ES', 'ESP', 'إسبانيا'),
(31869, 1586450432, 1586452479, 'RU', 'RUS', 'الإتحاد الروسي'),
(31870, 1586452480, 1586454527, 'CH', 'CHE', 'سويسرا'),
(31871, 1586454528, 1586456575, 'IT', 'ITA', 'إيطاليا'),
(31872, 1586456576, 1586458623, 'GB', 'GBR', 'المملكة المتحدة'),
(31873, 1586458624, 1586460671, 'FR', 'FRA', 'فرنسا'),
(31874, 1586460672, 1586462719, 'GB', 'GBR', 'المملكة المتحدة'),
(31875, 1586462720, 1586464767, 'RU', 'RUS', 'الإتحاد الروسي'),
(31876, 1586464768, 1586466815, 'ES', 'ESP', 'إسبانيا'),
(31877, 1586466816, 1586468863, 'RU', 'RUS', 'الإتحاد الروسي'),
(31878, 1586468864, 1586470911, 'IT', 'ITA', 'إيطاليا'),
(31879, 1586470912, 1586472959, 'GB', 'GBR', 'المملكة المتحدة'),
(31880, 1586472960, 1586475007, 'CZ', 'CZE', 'التشيك'),
(31881, 1586475008, 1586477055, 'GR', 'GRC', 'اليونان'),
(31882, 1586477056, 1586479103, 'BE', 'BEL', 'بلجيكا'),
(31883, 1586479104, 1586481151, 'KG', 'KGZ', 'قيرغيزستان'),
(31884, 1586481152, 1586483199, 'ES', 'ESP', 'إسبانيا'),
(31885, 1586483200, 1586485247, 'NL', 'NLD', 'هولندا'),
(31886, 1586485248, 1586487295, 'FR', 'FRA', 'فرنسا'),
(31887, 1586487296, 1586489343, 'SA', 'SAU', 'السعودية'),
(31888, 1586489344, 1586491391, 'CZ', 'CZE', 'التشيك'),
(31889, 1586491392, 1586493439, 'RU', 'RUS', 'الإتحاد الروسي'),
(31890, 1586493440, 1586495487, 'GB', 'GBR', 'المملكة المتحدة'),
(31891, 1586495488, 1587019775, 'DK', 'DNK', 'الدنيمارك'),
(31892, 1587019776, 1587085311, 'PL', 'POL', 'بولندا'),
(31893, 1587085312, 1587183615, 'UA', 'UKR', 'أوكرانيا'),
(31894, 1587183616, 1587199999, 'RU', 'RUS', 'الإتحاد الروسي'),
(31895, 1587200000, 1587216383, 'UA', 'UKR', 'أوكرانيا'),
(31896, 1587216384, 1587347455, 'BG', 'BGR', 'بلغاريا'),
(31897, 1587347456, 1587412991, 'NL', 'NLD', 'هولندا'),
(31898, 1587412992, 1587417087, 'RU', 'RUS', 'الإتحاد الروسي'),
(31899, 1587417088, 1587425279, 'UA', 'UKR', 'أوكرانيا'),
(31900, 1587425280, 1587429375, 'UZ', 'UZB', 'أوزباكستان'),
(31901, 1587429376, 1587437567, 'UA', 'UKR', 'أوكرانيا'),
(31902, 1587437568, 1587445759, 'RU', 'RUS', 'الإتحاد الروسي'),
(31903, 1587445760, 1587449855, 'PL', 'POL', 'بولندا'),
(31904, 1587449856, 1587453951, 'UA', 'UKR', 'أوكرانيا'),
(31905, 1587453952, 1587470335, 'RU', 'RUS', 'الإتحاد الروسي'),
(31906, 1587470336, 1587474431, 'PL', 'POL', 'بولندا'),
(31907, 1587474432, 1587478527, 'UA', 'UKR', 'أوكرانيا'),
(31908, 1587478528, 1587511295, 'RU', 'RUS', 'الإتحاد الروسي'),
(31909, 1587511296, 1587544063, 'IL', 'ISR', 'إسرائيل'),
(31910, 1587544064, 1588068351, 'IT', 'ITA', 'إيطاليا'),
(31911, 1588068352, 1588592639, 'GB', 'GBR', 'المملكة المتحدة'),
(31912, 1588592640, 1588621311, 'RO', 'ROM', 'رومانيا'),
(31913, 1588621312, 1588625407, 'MD', 'MDA', 'مولدوفا'),
(31914, 1588625408, 1588723711, 'RO', 'ROM', 'رومانيا'),
(31915, 1588723712, 1588854783, 'UA', 'UKR', 'أوكرانيا'),
(31916, 1588854784, 1588985855, 'RU', 'RUS', 'الإتحاد الروسي'),
(31917, 1588985856, 1589182463, 'IR', 'IRN', 'إيران'),
(31918, 1589182464, 1589215231, 'RU', 'RUS', 'الإتحاد الروسي'),
(31919, 1589215232, 1589247999, 'GB', 'GBR', 'المملكة المتحدة'),
(31920, 1589248000, 1589280767, 'NO', 'NOR', 'النرويج'),
(31921, 1589280768, 1589313535, 'DE', 'DEU', 'ألمانيا'),
(31922, 1589313536, 1589346303, 'LB', 'LBN', 'لبنان'),
(31923, 1589346304, 1589379071, 'KW', 'KWT', 'الكويت'),
(31924, 1589379072, 1589411839, 'RU', 'RUS', 'الإتحاد الروسي'),
(31925, 1589411840, 1589444607, 'IL', 'ISR', 'إسرائيل'),
(31926, 1589444608, 1589477375, 'DK', 'DNK', 'الدنيمارك'),
(31927, 1589477376, 1589510143, 'RS', 'SRB', 'صربيا'),
(31928, 1589510144, 1589542911, 'RU', 'RUS', 'الإتحاد الروسي'),
(31929, 1589542912, 1589575679, 'BG', 'BGR', 'بلغاريا'),
(31930, 1589575680, 1589608447, 'RU', 'RUS', 'الإتحاد الروسي'),
(31931, 1589608448, 1589610495, 'DK', 'DNK', 'الدنيمارك'),
(31932, 1589610496, 1589620735, 'SE', 'SWE', 'السويد'),
(31933, 1589620736, 1589623807, 'DK', 'DNK', 'الدنيمارك'),
(31934, 1589623808, 1589628927, 'SE', 'SWE', 'السويد'),
(31935, 1589628928, 1589641215, 'DK', 'DNK', 'الدنيمارك'),
(31936, 1589641216, 1590034431, 'GB', 'GBR', 'المملكة المتحدة'),
(31937, 1590034432, 1590036479, 'RU', 'RUS', 'الإتحاد الروسي'),
(31938, 1590036480, 1590038527, 'GB', 'GBR', 'المملكة المتحدة'),
(31939, 1590038528, 1590040575, 'RU', 'RUS', 'الإتحاد الروسي'),
(31940, 1590042624, 1590048767, 'RU', 'RUS', 'الإتحاد الروسي'),
(31941, 1590048768, 1590050815, 'DE', 'DEU', 'ألمانيا'),
(31942, 1590050816, 1590052863, 'SE', 'SWE', 'السويد'),
(31943, 1590052864, 1590054911, 'IT', 'ITA', 'إيطاليا'),
(31944, 1590054912, 1590056959, 'GB', 'GBR', 'المملكة المتحدة'),
(31945, 1590056960, 1590059007, 'ES', 'ESP', 'إسبانيا'),
(31946, 1590059008, 1590060223, 'IT', 'ITA', 'إيطاليا'),
(31947, 1590060224, 1590060255, 'CH', 'CHE', 'سويسرا'),
(31948, 1590060256, 1590061055, 'IT', 'ITA', 'إيطاليا'),
(31949, 1590061056, 1590063103, 'RU', 'RUS', 'الإتحاد الروسي'),
(31950, 1590063104, 1590065151, 'CZ', 'CZE', 'التشيك'),
(31951, 1590065152, 1590067199, 'IE', 'IRL', 'إيرلندا'),
(31952, 1590067200, 1590069247, 'RU', 'RUS', 'الإتحاد الروسي'),
(31953, 1590069248, 1590071295, 'AT', 'AUT', 'النمسا'),
(31954, 1590071296, 1590073343, 'FR', 'FRA', 'فرنسا'),
(31955, 1590073344, 1590075391, 'NL', 'NLD', 'هولندا'),
(31956, 1590075392, 1590077247, 'BE', 'BEL', 'بلجيكا'),
(31957, 1590077248, 1590077279, 'NL', 'NLD', 'هولندا'),
(31958, 1590077280, 1590077439, 'BE', 'BEL', 'بلجيكا'),
(31959, 1590077440, 1590079487, 'GB', 'GBR', 'المملكة المتحدة'),
(31960, 1590079488, 1590081535, 'FR', 'FRA', 'فرنسا'),
(31961, 1590081536, 1590083583, 'GB', 'GBR', 'المملكة المتحدة'),
(31962, 1590083584, 1590085631, 'RU', 'RUS', 'الإتحاد الروسي'),
(31963, 1590085632, 1590087679, 'FR', 'FRA', 'فرنسا'),
(31964, 1590087680, 1590089727, 'IT', 'ITA', 'إيطاليا'),
(31965, 1590089728, 1590091775, 'RU', 'RUS', 'الإتحاد الروسي'),
(31966, 1590091776, 1590093823, 'CZ', 'CZE', 'التشيك'),
(31967, 1590093824, 1590095871, 'RU', 'RUS', 'الإتحاد الروسي'),
(31968, 1590095872, 1590097919, 'CZ', 'CZE', 'التشيك'),
(31969, 1590097920, 1590099967, 'CH', 'CHE', 'سويسرا'),
(31970, 1590099968, 1590102015, 'RU', 'RUS', 'الإتحاد الروسي'),
(31971, 1590102016, 1590104063, 'IT', 'ITA', 'إيطاليا'),
(31972, 1590104064, 1590106111, 'TJ', 'TJK', 'طاجيكيستان'),
(31973, 1590108160, 1590110207, 'TR', 'TUR', 'تركيا'),
(31974, 1590110208, 1590112255, 'CZ', 'CZE', 'التشيك'),
(31975, 1590112256, 1590114303, 'HU', 'HUN', 'هنغاريا'),
(31976, 1590114304, 1590116351, 'FI', 'FIN', 'فنلندا'),
(31977, 1590116352, 1590120447, 'RU', 'RUS', 'الإتحاد الروسي'),
(31978, 1590120448, 1590122495, 'IT', 'ITA', 'إيطاليا'),
(31979, 1590122496, 1590124543, 'DE', 'DEU', 'ألمانيا'),
(31980, 1590124544, 1590126591, 'CH', 'CHE', 'سويسرا'),
(31981, 1590126592, 1590128639, 'RU', 'RUS', 'الإتحاد الروسي'),
(31982, 1590128640, 1590130687, 'FI', 'FIN', 'فنلندا'),
(31983, 1590130688, 1590132735, 'FR', 'FRA', 'فرنسا'),
(31984, 1590134784, 1590136831, 'ES', 'ESP', 'إسبانيا'),
(31985, 1590136832, 1590138879, 'GB', 'GBR', 'المملكة المتحدة'),
(31986, 1590138880, 1590140927, 'CZ', 'CZE', 'التشيك'),
(31987, 1590140928, 1590142975, 'UA', 'UKR', 'أوكرانيا'),
(31988, 1590142976, 1590145023, 'AT', 'AUT', 'النمسا'),
(31989, 1590145024, 1590147071, 'HU', 'HUN', 'هنغاريا'),
(31990, 1590147072, 1590149119, 'GB', 'GBR', 'المملكة المتحدة'),
(31991, 1590149120, 1590151167, 'CZ', 'CZE', 'التشيك'),
(31992, 1590151168, 1590153215, 'TR', 'TUR', 'تركيا'),
(31993, 1590153216, 1590157311, 'RU', 'RUS', 'الإتحاد الروسي'),
(31994, 1590157312, 1590159359, 'IE', 'IRL', 'إيرلندا'),
(31995, 1590159360, 1590161407, 'GB', 'GBR', 'المملكة المتحدة'),
(31996, 1590161408, 1590163455, 'DE', 'DEU', 'ألمانيا'),
(31997, 1590163456, 1590165503, 'NL', 'NLD', 'هولندا'),
(31998, 1590165504, 1590689791, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(31999, 1590689792, 1591214079, 'NL', 'NLD', 'هولندا'),
(32000, 1591214080, 1591738367, 'DE', 'DEU', 'ألمانيا'),
(32001, 1591738368, 1592000511, 'BE', 'BEL', 'بلجيكا'),
(32002, 1592000512, 1592004607, 'ES', 'ESP', 'إسبانيا'),
(32003, 1592004608, 1592008703, 'AM', 'ARM', 'أرمينيا'),
(32004, 1592008704, 1592012799, 'GB', 'GBR', 'المملكة المتحدة'),
(32005, 1592012800, 1592016895, 'CH', 'CHE', 'سويسرا'),
(32006, 1592016896, 1592020991, 'GB', 'GBR', 'المملكة المتحدة'),
(32007, 1592020992, 1592025087, 'SK', 'SVK', 'سلوفاكيا'),
(32008, 1592025088, 1592029183, 'DE', 'DEU', 'ألمانيا'),
(32009, 1592029184, 1592033279, 'RU', 'RUS', 'الإتحاد الروسي'),
(32010, 1592033280, 1592037375, 'NL', 'NLD', 'هولندا'),
(32011, 1592037376, 1592041471, 'CH', 'CHE', 'سويسرا'),
(32012, 1592041472, 1592045567, 'RU', 'RUS', 'الإتحاد الروسي'),
(32013, 1592045568, 1592049663, 'FR', 'FRA', 'فرنسا'),
(32014, 1592049664, 1592053759, 'RU', 'RUS', 'الإتحاد الروسي'),
(32015, 1592053760, 1592054271, 'NL', 'NLD', 'هولندا'),
(32016, 1592054272, 1592054527, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(32017, 1592054528, 1592054783, 'NL', 'NLD', 'هولندا'),
(32018, 1592054784, 1592055295, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(32019, 1592055296, 1592056959, 'NL', 'NLD', 'هولندا'),
(32020, 1592056960, 1592057023, 'GB', 'GBR', 'المملكة المتحدة'),
(32021, 1592057024, 1592057855, 'NL', 'NLD', 'هولندا'),
(32022, 1592057856, 1592061951, 'RS', 'SRB', 'صربيا'),
(32023, 1592061952, 1592066047, 'RU', 'RUS', 'الإتحاد الروسي'),
(32024, 1592066048, 1592067583, 'US', 'USA', 'الولايات المتحدة'),
(32025, 1592067584, 1592067711, 'NO', 'NOR', 'النرويج'),
(32026, 1592067712, 1592069631, 'CY', 'CYP', 'قبرص'),
(32027, 1592069632, 1592069695, 'NL', 'NLD', 'هولندا'),
(32028, 1592069696, 1592069887, 'CY', 'CYP', 'قبرص'),
(32029, 1592069888, 1592074239, 'RU', 'RUS', 'الإتحاد الروسي'),
(32030, 1592074240, 1592078335, 'SK', 'SVK', 'سلوفاكيا'),
(32031, 1592078336, 1592082431, 'NL', 'NLD', 'هولندا'),
(32032, 1592082432, 1592085023, 'GB', 'GBR', 'المملكة المتحدة'),
(32033, 1592085024, 1592085039, 'ES', 'ESP', 'إسبانيا'),
(32034, 1592085040, 1592086527, 'GB', 'GBR', 'المملكة المتحدة'),
(32035, 1592086528, 1592087295, 'CZ', 'CZE', 'التشيك'),
(32036, 1592087296, 1592088063, 'PL', 'POL', 'بولندا'),
(32037, 1592088064, 1592090623, 'CZ', 'CZE', 'التشيك'),
(32038, 1592090624, 1592094719, 'RU', 'RUS', 'الإتحاد الروسي'),
(32039, 1592094720, 1592098815, 'RS', 'SRB', 'صربيا'),
(32040, 1592098816, 1592102911, 'GB', 'GBR', 'المملكة المتحدة'),
(32041, 1592102912, 1592107007, 'PT', 'PRT', 'البورتوغال'),
(32042, 1592107008, 1592111103, 'GB', 'GBR', 'المملكة المتحدة'),
(32043, 1592111104, 1592115199, 'DE', 'DEU', 'ألمانيا'),
(32044, 1592115200, 1592119295, 'ES', 'ESP', 'إسبانيا'),
(32045, 1592119296, 1592123391, 'PL', 'POL', 'بولندا'),
(32046, 1592123392, 1592135679, 'RU', 'RUS', 'الإتحاد الروسي'),
(32047, 1592135680, 1592139775, 'PL', 'POL', 'بولندا'),
(32048, 1592139776, 1592143871, 'RU', 'RUS', 'الإتحاد الروسي'),
(32049, 1592143872, 1592147967, 'DE', 'DEU', 'ألمانيا'),
(32050, 1592147968, 1592152063, 'IT', 'ITA', 'إيطاليا'),
(32051, 1592152064, 1592156159, 'IL', 'ISR', 'إسرائيل'),
(32052, 1592156160, 1592160255, 'IE', 'IRL', 'إيرلندا'),
(32053, 1592160256, 1592168447, 'RU', 'RUS', 'الإتحاد الروسي'),
(32054, 1592168448, 1592172543, 'CZ', 'CZE', 'التشيك'),
(32055, 1592172544, 1592176639, 'RU', 'RUS', 'الإتحاد الروسي'),
(32056, 1592176640, 1592178687, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(32057, 1592178688, 1592179199, 'RS', 'SRB', 'صربيا'),
(32058, 1592179200, 1592180735, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(32059, 1592180736, 1592184831, 'UA', 'UKR', 'أوكرانيا'),
(32060, 1592184832, 1592188927, 'CH', 'CHE', 'سويسرا'),
(32061, 1592188928, 1592193023, 'UZ', 'UZB', 'أوزباكستان'),
(32062, 1592193024, 1592197119, 'RU', 'RUS', 'الإتحاد الروسي'),
(32063, 1592197120, 1592201215, 'PL', 'POL', 'بولندا'),
(32064, 1592201216, 1592205311, 'RU', 'RUS', 'الإتحاد الروسي'),
(32065, 1592205312, 1592209407, 'UA', 'UKR', 'أوكرانيا'),
(32066, 1592209408, 1592213503, 'PL', 'POL', 'بولندا'),
(32067, 1592213504, 1592217599, 'UA', 'UKR', 'أوكرانيا'),
(32068, 1592217600, 1592221695, 'CH', 'CHE', 'سويسرا'),
(32069, 1592221696, 1592225791, 'DK', 'DNK', 'الدنيمارك'),
(32070, 1592225792, 1592242175, 'RU', 'RUS', 'الإتحاد الروسي'),
(32071, 1592242176, 1592246271, 'UA', 'UKR', 'أوكرانيا'),
(32072, 1592246272, 1592254463, 'RU', 'RUS', 'الإتحاد الروسي'),
(32073, 1592254464, 1592258559, 'PL', 'POL', 'بولندا'),
(32074, 1592258560, 1592262655, 'NL', 'NLD', 'هولندا'),
(32075, 1592262656, 1592270847, 'RU', 'RUS', 'الإتحاد الروسي'),
(32076, 1592270848, 1592272895, 'PL', 'POL', 'بولندا'),
(32077, 1592272896, 1592281087, 'RU', 'RUS', 'الإتحاد الروسي'),
(32078, 1592281088, 1592283135, 'UA', 'UKR', 'أوكرانيا'),
(32079, 1592283136, 1592285183, 'GR', 'GRC', 'اليونان'),
(32080, 1592285184, 1592287231, 'RU', 'RUS', 'الإتحاد الروسي'),
(32081, 1592287232, 1592289279, 'RO', 'ROM', 'رومانيا'),
(32082, 1592289280, 1592291327, 'RU', 'RUS', 'الإتحاد الروسي'),
(32083, 1592291328, 1592293375, 'NL', 'NLD', 'هولندا'),
(32084, 1592293376, 1592299519, 'RU', 'RUS', 'الإتحاد الروسي'),
(32085, 1592299520, 1592303615, 'PL', 'POL', 'بولندا'),
(32086, 1592303616, 1592305663, 'NL', 'NLD', 'هولندا'),
(32087, 1592305664, 1592307711, 'IR', 'IRN', 'إيران'),
(32088, 1592307712, 1592309759, 'UA', 'UKR', 'أوكرانيا'),
(32089, 1592309760, 1592311807, 'RU', 'RUS', 'الإتحاد الروسي'),
(32090, 1592311808, 1592313855, 'DE', 'DEU', 'ألمانيا'),
(32091, 1592313856, 1592315903, 'RU', 'RUS', 'الإتحاد الروسي'),
(32092, 1592315904, 1592317951, 'UA', 'UKR', 'أوكرانيا'),
(32093, 1592317952, 1592319999, 'PL', 'POL', 'بولندا'),
(32094, 1592320000, 1592322047, 'LT', 'LTU', 'ليتوانيا'),
(32095, 1592322048, 1592324095, 'RU', 'RUS', 'الإتحاد الروسي'),
(32096, 1592324096, 1592326143, 'KZ', 'KAZ', 'كازاخستان'),
(32097, 1592326144, 1592328191, 'UA', 'UKR', 'أوكرانيا'),
(32098, 1592328192, 1592393727, 'RU', 'RUS', 'الإتحاد الروسي'),
(32099, 1592393728, 1592459263, 'SE', 'SWE', 'السويد'),
(32100, 1592459264, 1592524799, 'GE', 'GEO', 'جورجيا'),
(32101, 1592524800, 1592557567, 'GB', 'GBR', 'المملكة المتحدة'),
(32102, 1592557568, 1592590335, 'BG', 'BGR', 'بلغاريا'),
(32103, 1592590336, 1592623103, 'FI', 'FIN', 'فنلندا'),
(32104, 1592623104, 1592655871, 'RU', 'RUS', 'الإتحاد الروسي'),
(32105, 1592655872, 1592786943, 'FR', 'FRA', 'فرنسا'),
(32106, 1592786944, 1592803327, 'PL', 'POL', 'بولندا'),
(32107, 1592803328, 1592819711, 'RU', 'RUS', 'الإتحاد الروسي'),
(32108, 1592819712, 1592836095, 'UA', 'UKR', 'أوكرانيا'),
(32109, 1592836096, 1592852479, 'GE', 'GEO', 'جورجيا'),
(32110, 1592852480, 1592868863, 'RU', 'RUS', 'الإتحاد الروسي'),
(32111, 1592868864, 1592885247, 'CZ', 'CZE', 'التشيك'),
(32112, 1592885248, 1592901631, 'IR', 'IRN', 'إيران'),
(32113, 1592901632, 1592934399, 'RU', 'RUS', 'الإتحاد الروسي'),
(32114, 1592934400, 1592950783, 'CZ', 'CZE', 'التشيك'),
(32115, 1592950784, 1592967167, 'RU', 'RUS', 'الإتحاد الروسي'),
(32116, 1592967168, 1592983551, 'LU', 'LUX', 'لوكسيمبورغ'),
(32117, 1592983552, 1592999935, 'RU', 'RUS', 'الإتحاد الروسي'),
(32118, 1592999936, 1593016319, 'MD', 'MDA', 'مولدوفا'),
(32119, 1593016320, 1593049087, 'RU', 'RUS', 'الإتحاد الروسي'),
(32120, 1593049088, 1593065471, 'UA', 'UKR', 'أوكرانيا'),
(32121, 1593065472, 1593081855, 'LT', 'LTU', 'ليتوانيا'),
(32122, 1593081856, 1593098239, 'UA', 'UKR', 'أوكرانيا'),
(32123, 1593098240, 1593114623, 'CH', 'CHE', 'سويسرا'),
(32124, 1593114624, 1593122815, 'DK', 'DNK', 'الدنيمارك'),
(32125, 1593122816, 1593131007, 'SE', 'SWE', 'السويد'),
(32126, 1593131008, 1593147391, 'GB', 'GBR', 'المملكة المتحدة'),
(32127, 1593147392, 1593163775, 'RU', 'RUS', 'الإتحاد الروسي'),
(32128, 1593163776, 1593180159, 'AT', 'AUT', 'النمسا'),
(32129, 1593180160, 1593196543, 'NO', 'NOR', 'النرويج'),
(32130, 1593196544, 1593196783, 'SE', 'SWE', 'السويد'),
(32131, 1593196784, 1593196799, 'GB', 'GBR', 'المملكة المتحدة'),
(32132, 1593196800, 1593204159, 'SE', 'SWE', 'السويد'),
(32133, 1593204160, 1593204223, 'DK', 'DNK', 'الدنيمارك'),
(32134, 1593204224, 1593205567, 'SE', 'SWE', 'السويد'),
(32135, 1593205568, 1593205631, 'DK', 'DNK', 'الدنيمارك'),
(32136, 1593205632, 1593206083, 'SE', 'SWE', 'السويد'),
(32137, 1593206084, 1593206095, 'DK', 'DNK', 'الدنيمارك'),
(32138, 1593206096, 1593206103, 'FI', 'FIN', 'فنلندا'),
(32139, 1593206104, 1593206111, 'GB', 'GBR', 'المملكة المتحدة'),
(32140, 1593206112, 1593206207, 'SE', 'SWE', 'السويد'),
(32141, 1593206208, 1593206271, 'FI', 'FIN', 'فنلندا'),
(32142, 1593206272, 1593209151, 'SE', 'SWE', 'السويد'),
(32143, 1593209152, 1593209155, 'GR', 'GRC', 'اليونان'),
(32144, 1593209156, 1593209159, 'HU', 'HUN', 'هنغاريا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(32145, 1593209160, 1593209163, 'FI', 'FIN', 'فنلندا'),
(32146, 1593209164, 1593209167, 'CH', 'CHE', 'سويسرا'),
(32147, 1593209168, 1593210879, 'SE', 'SWE', 'السويد'),
(32148, 1593210880, 1593211391, 'NO', 'NOR', 'النرويج'),
(32149, 1593211392, 1593212415, 'SE', 'SWE', 'السويد'),
(32150, 1593212416, 1593212927, 'NO', 'NOR', 'النرويج'),
(32151, 1593212928, 1593229311, 'PL', 'POL', 'بولندا'),
(32152, 1593229312, 1593245695, 'EE', 'EST', 'إستونيا'),
(32153, 1593245696, 1593247743, 'NL', 'NLD', 'هولندا'),
(32154, 1593247744, 1593249791, 'IT', 'ITA', 'إيطاليا'),
(32155, 1593249792, 1593251839, 'RU', 'RUS', 'الإتحاد الروسي'),
(32156, 1593251840, 1593252159, 'FR', 'FRA', 'فرنسا'),
(32157, 1593252160, 1593252192, 'GB', 'GBR', 'المملكة المتحدة'),
(32158, 1593252193, 1593253887, 'FR', 'FRA', 'فرنسا'),
(32159, 1593253888, 1593255935, 'CZ', 'CZE', 'التشيك'),
(32160, 1593255936, 1593257983, 'DE', 'DEU', 'ألمانيا'),
(32161, 1593257984, 1593260031, 'IE', 'IRL', 'إيرلندا'),
(32162, 1593260032, 1593262079, 'RU', 'RUS', 'الإتحاد الروسي'),
(32163, 1593262080, 1593264127, 'KZ', 'KAZ', 'كازاخستان'),
(32164, 1593264128, 1593266175, 'NL', 'NLD', 'هولندا'),
(32165, 1593266176, 1593268223, 'GB', 'GBR', 'المملكة المتحدة'),
(32166, 1593268224, 1593270271, 'HU', 'HUN', 'هنغاريا'),
(32167, 1593270272, 1593272319, 'GB', 'GBR', 'المملكة المتحدة'),
(32168, 1593272320, 1593274367, 'RU', 'RUS', 'الإتحاد الروسي'),
(32169, 1593274368, 1593276415, 'DE', 'DEU', 'ألمانيا'),
(32170, 1593276416, 1593278463, 'RU', 'RUS', 'الإتحاد الروسي'),
(32171, 1593278464, 1593280511, 'KZ', 'KAZ', 'كازاخستان'),
(32172, 1593280512, 1593282559, 'EE', 'EST', 'إستونيا'),
(32173, 1593282560, 1593284607, 'AT', 'AUT', 'النمسا'),
(32174, 1593284608, 1593286655, 'GB', 'GBR', 'المملكة المتحدة'),
(32175, 1593286656, 1593288703, 'FR', 'FRA', 'فرنسا'),
(32176, 1593288704, 1593290751, 'SE', 'SWE', 'السويد'),
(32177, 1593290752, 1593292799, 'FR', 'FRA', 'فرنسا'),
(32178, 1593292800, 1593294847, 'IT', 'ITA', 'إيطاليا'),
(32179, 1593294848, 1593296895, 'NL', 'NLD', 'هولندا'),
(32180, 1593296896, 1593298943, 'RS', 'SRB', 'صربيا'),
(32181, 1593298944, 1593300991, 'RU', 'RUS', 'الإتحاد الروسي'),
(32182, 1593300992, 1593303039, 'CH', 'CHE', 'سويسرا'),
(32183, 1593303040, 1593305087, 'UA', 'UKR', 'أوكرانيا'),
(32184, 1593305088, 1593307135, 'FR', 'FRA', 'فرنسا'),
(32185, 1593307136, 1593311231, 'RU', 'RUS', 'الإتحاد الروسي'),
(32186, 1593311232, 1593343999, 'UA', 'UKR', 'أوكرانيا'),
(32187, 1593344000, 1593376767, 'HU', 'HUN', 'هنغاريا'),
(32188, 1593376768, 1593409535, 'JO', 'JOR', 'الأردن'),
(32189, 1593409536, 1593416231, 'DE', 'DEU', 'ألمانيا'),
(32190, 1593416232, 1593416239, 'CH', 'CHE', 'سويسرا'),
(32191, 1593416240, 1593442303, 'DE', 'DEU', 'ألمانيا'),
(32192, 1593442304, 1593475071, 'BA', 'BIH', 'البوسنه والهرسك'),
(32193, 1593475072, 1593540607, 'RU', 'RUS', 'الإتحاد الروسي'),
(32194, 1593540608, 1593573375, 'PL', 'POL', 'بولندا'),
(32195, 1593573376, 1593606143, 'LU', 'LUX', 'لوكسيمبورغ'),
(32196, 1593606144, 1593638911, 'SY', 'SYR', 'سوريا'),
(32197, 1593638912, 1593671679, 'RU', 'RUS', 'الإتحاد الروسي'),
(32198, 1593671680, 1593704447, 'HR', 'HRV', 'كرواتيا'),
(32199, 1593704448, 1593704959, 'SE', 'SWE', 'السويد'),
(32200, 1593704960, 1593705471, 'NO', 'NOR', 'النرويج'),
(32201, 1593705472, 1593737215, 'SE', 'SWE', 'السويد'),
(32202, 1593737216, 1593769983, 'PL', 'POL', 'بولندا'),
(32203, 1593769984, 1593802751, 'RU', 'RUS', 'الإتحاد الروسي'),
(32204, 1593802752, 1593835519, 'SE', 'SWE', 'السويد'),
(32205, 1593835520, 1594884095, 'TR', 'TUR', 'تركيا'),
(32206, 1594884096, 1595408383, 'ES', 'ESP', 'إسبانيا'),
(32207, 1595408384, 1595998207, 'RU', 'RUS', 'الإتحاد الروسي'),
(32208, 1595998208, 1596063743, 'DE', 'DEU', 'ألمانيا'),
(32209, 1596063744, 1596129279, 'NO', 'NOR', 'النرويج'),
(32210, 1596129280, 1596194815, 'IL', 'ISR', 'إسرائيل'),
(32211, 1596194816, 1596260351, 'NL', 'NLD', 'هولندا'),
(32212, 1596260352, 1596325887, 'RU', 'RUS', 'الإتحاد الروسي'),
(32213, 1596325888, 1596391423, 'IR', 'IRN', 'إيران'),
(32214, 1596391424, 1596456959, 'ES', 'ESP', 'إسبانيا'),
(32215, 1596456960, 1596588031, 'PL', 'POL', 'بولندا'),
(32216, 1596588032, 1596719103, 'BG', 'BGR', 'بلغاريا'),
(32217, 1596719104, 1596850175, 'IE', 'IRL', 'إيرلندا'),
(32218, 1596850176, 1596981247, 'CZ', 'CZE', 'التشيك'),
(32219, 1596981248, 1597243391, 'PL', 'POL', 'بولندا'),
(32220, 1597243392, 1597505535, 'RU', 'RUS', 'الإتحاد الروسي'),
(32221, 1597505536, 1597767679, 'KZ', 'KAZ', 'كازاخستان'),
(32222, 1597767680, 1598029823, 'ES', 'ESP', 'إسبانيا'),
(32223, 1598029824, 1598062591, 'RO', 'ROM', 'رومانيا'),
(32224, 1598062592, 1598095359, 'RU', 'RUS', 'الإتحاد الروسي'),
(32225, 1598095360, 1598128127, 'MD', 'MDA', 'مولدوفا'),
(32226, 1598128128, 1598160895, 'TR', 'TUR', 'تركيا'),
(32227, 1598160896, 1598193663, 'KW', 'KWT', 'الكويت'),
(32228, 1598193664, 1598226431, 'RU', 'RUS', 'الإتحاد الروسي'),
(32229, 1598226432, 1598259199, 'UA', 'UKR', 'أوكرانيا'),
(32230, 1598259200, 1598291967, 'RU', 'RUS', 'الإتحاد الروسي'),
(32231, 1598291968, 1598324735, 'LV', 'LVA', 'لاتفيا'),
(32232, 1598324736, 1598357503, 'RU', 'RUS', 'الإتحاد الروسي'),
(32233, 1598357504, 1598390271, 'PT', 'PRT', 'البورتوغال'),
(32234, 1598390272, 1598423039, 'UA', 'UKR', 'أوكرانيا'),
(32235, 1598423040, 1598455807, 'RU', 'RUS', 'الإتحاد الروسي'),
(32236, 1598455808, 1598488575, 'TR', 'TUR', 'تركيا'),
(32237, 1598488576, 1598685183, 'RU', 'RUS', 'الإتحاد الروسي'),
(32238, 1598685184, 1598816255, 'IT', 'ITA', 'إيطاليا'),
(32239, 1598816256, 1598947327, 'RO', 'ROM', 'رومانيا'),
(32240, 1598947328, 1599078399, 'RU', 'RUS', 'الإتحاد الروسي'),
(32241, 1599078400, 1599094783, 'SE', 'SWE', 'السويد'),
(32242, 1599094784, 1599111167, 'RU', 'RUS', 'الإتحاد الروسي'),
(32243, 1599111168, 1599127551, 'IR', 'IRN', 'إيران'),
(32244, 1599127552, 1599143935, 'CZ', 'CZE', 'التشيك'),
(32245, 1599143936, 1599160319, 'UA', 'UKR', 'أوكرانيا'),
(32246, 1599160320, 1599176703, 'IR', 'IRN', 'إيران'),
(32247, 1599176704, 1599193087, 'FR', 'FRA', 'فرنسا'),
(32248, 1599193088, 1599209471, 'RU', 'RUS', 'الإتحاد الروسي'),
(32249, 1599209472, 1599242239, 'IR', 'IRN', 'إيران'),
(32250, 1599242240, 1599258623, 'CZ', 'CZE', 'التشيك'),
(32251, 1599258624, 1599324159, 'RU', 'RUS', 'الإتحاد الروسي'),
(32252, 1599324160, 1599340543, 'IE', 'IRL', 'إيرلندا'),
(32253, 1599340544, 1599356927, 'RU', 'RUS', 'الإتحاد الروسي'),
(32254, 1599356928, 1599373311, 'BH', 'BHR', 'البحرين'),
(32255, 1599373312, 1599438847, 'RU', 'RUS', 'الإتحاد الروسي'),
(32256, 1599438848, 1599455231, 'RS', 'SRB', 'صربيا'),
(32257, 1599455232, 1599471615, 'CZ', 'CZE', 'التشيك'),
(32258, 1599471616, 1599487999, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(32259, 1599488000, 1599504383, 'IL', 'ISR', 'إسرائيل'),
(32260, 1599504384, 1599520767, 'AZ', 'AZE', 'أذربيجان'),
(32261, 1599520768, 1599537151, 'RU', 'RUS', 'الإتحاد الروسي'),
(32262, 1599537152, 1599553535, 'BG', 'BGR', 'بلغاريا'),
(32263, 1599553536, 1599569919, 'RU', 'RUS', 'الإتحاد الروسي'),
(32264, 1599569920, 1599586303, 'SI', 'SVN', 'سلوفينيا'),
(32265, 1599586304, 1599602687, 'BG', 'BGR', 'بلغاريا'),
(32266, 1599602688, 1599864831, 'DE', 'DEU', 'ألمانيا'),
(32267, 1599864832, 1600126975, 'PT', 'PRT', 'البورتوغال'),
(32268, 1600126976, 1600389119, 'NL', 'NLD', 'هولندا'),
(32269, 1600397312, 1600401407, 'DE', 'DEU', 'ألمانيا'),
(32270, 1600520192, 1600651263, 'SK', 'SVK', 'سلوفاكيا'),
(32271, 1600651264, 1600684031, 'GE', 'GEO', 'جورجيا'),
(32272, 1600684032, 1600749567, 'RU', 'RUS', 'الإتحاد الروسي'),
(32273, 1600749568, 1600782335, 'SK', 'SVK', 'سلوفاكيا'),
(32274, 1600782336, 1600880639, 'RU', 'RUS', 'الإتحاد الروسي'),
(32275, 1600880640, 1600913407, 'AL', 'ALB', 'ألبانيا'),
(32276, 1600913408, 1600946175, 'PL', 'POL', 'بولندا'),
(32277, 1600946176, 1600963167, 'RU', 'RUS', 'الإتحاد الروسي'),
(32278, 1600963168, 1600963175, 'UA', 'UKR', 'أوكرانيا'),
(32279, 1600963176, 1600963183, 'RU', 'RUS', 'الإتحاد الروسي'),
(32280, 1600963184, 1600963191, 'BY', 'BLR', 'روسيا البيضاء'),
(32281, 1600963192, 1600963199, 'KZ', 'KAZ', 'كازاخستان'),
(32282, 1600963200, 1600978943, 'RU', 'RUS', 'الإتحاد الروسي'),
(32283, 1600978944, 1601011711, 'SE', 'SWE', 'السويد'),
(32284, 1601011712, 1601044479, 'UA', 'UKR', 'أوكرانيا'),
(32285, 1601044480, 1601077247, 'RU', 'RUS', 'الإتحاد الروسي'),
(32286, 1601077248, 1601110015, 'IT', 'ITA', 'إيطاليا'),
(32287, 1601110016, 1601142783, 'BG', 'BGR', 'بلغاريا'),
(32288, 1601142784, 1601175551, 'UA', 'UKR', 'أوكرانيا'),
(32289, 1601175552, 1601699839, 'DE', 'DEU', 'ألمانيا'),
(32290, 1601699840, 1602224127, 'ES', 'ESP', 'إسبانيا'),
(32291, 1602224128, 1602226175, 'NL', 'NLD', 'هولندا'),
(32292, 1602226176, 1602228223, 'GB', 'GBR', 'المملكة المتحدة'),
(32293, 1602228224, 1602230271, 'DE', 'DEU', 'ألمانيا'),
(32294, 1602230272, 1602232319, 'DK', 'DNK', 'الدنيمارك'),
(32295, 1602232320, 1602234367, 'CH', 'CHE', 'سويسرا'),
(32296, 1602234368, 1602234591, 'FR', 'FRA', 'فرنسا'),
(32297, 1602234592, 1602234623, 'GB', 'GBR', 'المملكة المتحدة'),
(32298, 1602234624, 1602234703, 'FR', 'FRA', 'فرنسا'),
(32299, 1602234704, 1602234848, 'GB', 'GBR', 'المملكة المتحدة'),
(32300, 1602234849, 1602234895, 'FR', 'FRA', 'فرنسا'),
(32301, 1602234896, 1602234903, 'GB', 'GBR', 'المملكة المتحدة'),
(32302, 1602234904, 1602234943, 'FR', 'FRA', 'فرنسا'),
(32303, 1602234944, 1602235135, 'GB', 'GBR', 'المملكة المتحدة'),
(32304, 1602235136, 1602235263, 'FR', 'FRA', 'فرنسا'),
(32305, 1602235264, 1602235647, 'GB', 'GBR', 'المملكة المتحدة'),
(32306, 1602235648, 1602235775, 'FR', 'FRA', 'فرنسا'),
(32307, 1602235776, 1602235903, 'GB', 'GBR', 'المملكة المتحدة'),
(32308, 1602235904, 1602235967, 'ES', 'ESP', 'إسبانيا'),
(32309, 1602235968, 1602238463, 'GB', 'GBR', 'المملكة المتحدة'),
(32310, 1602238464, 1602240511, 'TR', 'TUR', 'تركيا'),
(32311, 1602240512, 1602242559, 'BY', 'BLR', 'روسيا البيضاء'),
(32312, 1602242560, 1602244607, 'FR', 'FRA', 'فرنسا'),
(32313, 1602244608, 1602246655, 'CH', 'CHE', 'سويسرا'),
(32314, 1602246656, 1602248703, 'NL', 'NLD', 'هولندا'),
(32315, 1602248704, 1602250751, 'BE', 'BEL', 'بلجيكا'),
(32316, 1602250752, 1602252799, 'NO', 'NOR', 'النرويج'),
(32317, 1602252800, 1602254847, 'SE', 'SWE', 'السويد'),
(32318, 1602254848, 1602255103, 'US', 'USA', 'الولايات المتحدة'),
(32319, 1602255104, 1602255359, 'HU', 'HUN', 'هنغاريا'),
(32320, 1602255360, 1602255615, 'US', 'USA', 'الولايات المتحدة'),
(32321, 1602255616, 1602256895, 'HU', 'HUN', 'هنغاريا'),
(32322, 1602256896, 1602258943, 'GB', 'GBR', 'المملكة المتحدة'),
(32323, 1602258944, 1602260991, 'RU', 'RUS', 'الإتحاد الروسي'),
(32324, 1602260992, 1602263039, 'FR', 'FRA', 'فرنسا'),
(32325, 1602263040, 1602265087, 'ES', 'ESP', 'إسبانيا'),
(32326, 1602265088, 1602267135, 'RU', 'RUS', 'الإتحاد الروسي'),
(32327, 1602267136, 1602269183, 'RO', 'ROM', 'رومانيا'),
(32328, 1602269184, 1602271231, 'RU', 'RUS', 'الإتحاد الروسي'),
(32329, 1602271232, 1602273279, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(32330, 1602273280, 1602273535, 'FR', 'FRA', 'فرنسا'),
(32331, 1602273536, 1602275327, 'IE', 'IRL', 'إيرلندا'),
(32332, 1602275328, 1602275615, 'DE', 'DEU', 'ألمانيا'),
(32333, 1602275616, 1602275647, 'CY', 'CYP', 'قبرص'),
(32334, 1602275648, 1602279423, 'DE', 'DEU', 'ألمانيا'),
(32335, 1602279424, 1602281471, 'GB', 'GBR', 'المملكة المتحدة'),
(32336, 1602281472, 1602283519, 'RU', 'RUS', 'الإتحاد الروسي'),
(32337, 1602283520, 1602285567, 'HR', 'HRV', 'كرواتيا'),
(32338, 1602285568, 1602287615, 'RU', 'RUS', 'الإتحاد الروسي'),
(32339, 1602287616, 1602289663, 'DE', 'DEU', 'ألمانيا'),
(32340, 1602289664, 1602291711, 'LB', 'LBN', 'لبنان'),
(32341, 1602291712, 1602293759, 'SA', 'SAU', 'السعودية'),
(32342, 1602293760, 1602295807, 'RU', 'RUS', 'الإتحاد الروسي'),
(32343, 1602295808, 1602297855, 'NL', 'NLD', 'هولندا'),
(32344, 1602297856, 1602298367, 'IL', 'ISR', 'إسرائيل'),
(32345, 1602298368, 1602298431, 'MT', 'MLT', 'مالطا'),
(32346, 1602298432, 1602298879, 'IL', 'ISR', 'إسرائيل'),
(32347, 1602298880, 1602299391, 'MT', 'MLT', 'مالطا'),
(32348, 1602299392, 1602299903, 'IL', 'ISR', 'إسرائيل'),
(32349, 1602299904, 1602301951, 'DK', 'DNK', 'الدنيمارك'),
(32350, 1602301952, 1602303999, 'DE', 'DEU', 'ألمانيا'),
(32351, 1602304000, 1602306047, 'RU', 'RUS', 'الإتحاد الروسي'),
(32352, 1602306048, 1602308095, 'GB', 'GBR', 'المملكة المتحدة'),
(32353, 1602308096, 1602310143, 'RU', 'RUS', 'الإتحاد الروسي'),
(32354, 1602310144, 1602312191, 'NL', 'NLD', 'هولندا'),
(32355, 1602312192, 1602314239, 'RU', 'RUS', 'الإتحاد الروسي'),
(32356, 1602314240, 1602316287, 'CZ', 'CZE', 'التشيك'),
(32357, 1602316288, 1602318335, 'GB', 'GBR', 'المملكة المتحدة'),
(32358, 1602318336, 1602320383, 'ES', 'ESP', 'إسبانيا'),
(32359, 1602320384, 1602324479, 'NL', 'NLD', 'هولندا'),
(32360, 1602324480, 1602326527, 'RU', 'RUS', 'الإتحاد الروسي'),
(32361, 1602326528, 1602328575, 'GB', 'GBR', 'المملكة المتحدة'),
(32362, 1602328576, 1602330623, 'ES', 'ESP', 'إسبانيا'),
(32363, 1602330624, 1602336767, 'RU', 'RUS', 'الإتحاد الروسي'),
(32364, 1602336768, 1602338815, 'GB', 'GBR', 'المملكة المتحدة'),
(32365, 1602338816, 1602340863, 'EE', 'EST', 'إستونيا'),
(32366, 1602340864, 1602342911, 'AT', 'AUT', 'النمسا'),
(32367, 1602342912, 1602344959, 'DE', 'DEU', 'ألمانيا'),
(32368, 1602344960, 1602347007, 'ES', 'ESP', 'إسبانيا'),
(32369, 1602347008, 1602349055, 'PL', 'POL', 'بولندا'),
(32370, 1602349056, 1602351103, 'RU', 'RUS', 'الإتحاد الروسي'),
(32371, 1602351104, 1602353151, 'CZ', 'CZE', 'التشيك'),
(32372, 1602353152, 1602355199, 'RU', 'RUS', 'الإتحاد الروسي'),
(32373, 1602355200, 1602357247, 'GB', 'GBR', 'المملكة المتحدة'),
(32374, 1602357248, 1602359295, 'FR', 'FRA', 'فرنسا'),
(32375, 1602359296, 1602361343, 'DE', 'DEU', 'ألمانيا'),
(32376, 1602361344, 1602363391, 'FI', 'FIN', 'فنلندا'),
(32377, 1602363392, 1602365439, 'LV', 'LVA', 'لاتفيا'),
(32378, 1602365440, 1602367487, 'BE', 'BEL', 'بلجيكا'),
(32379, 1602367488, 1602369535, 'ES', 'ESP', 'إسبانيا'),
(32380, 1602369536, 1602371583, 'IR', 'IRN', 'إيران'),
(32381, 1602371584, 1602373631, 'SE', 'SWE', 'السويد'),
(32382, 1602373632, 1602375679, 'GB', 'GBR', 'المملكة المتحدة'),
(32383, 1602375680, 1602377727, 'BY', 'BLR', 'روسيا البيضاء'),
(32384, 1602377728, 1602379775, 'PS', 'PSE', 'فلسطين المحتلة'),
(32385, 1602379776, 1602383871, 'GB', 'GBR', 'المملكة المتحدة'),
(32386, 1602383873, 1602383873, 'DE', 'DEU', 'ألمانيا'),
(32387, 1602384896, 1602385151, 'DE', 'DEU', 'ألمانيا'),
(32388, 1602385920, 1602387967, 'AT', 'AUT', 'النمسا'),
(32389, 1602387968, 1602390015, 'RU', 'RUS', 'الإتحاد الروسي'),
(32390, 1602390016, 1602392063, 'IT', 'ITA', 'إيطاليا'),
(32391, 1602392064, 1602394111, 'GB', 'GBR', 'المملكة المتحدة'),
(32392, 1602394112, 1602396159, 'FR', 'FRA', 'فرنسا'),
(32393, 1602396160, 1602398207, 'DE', 'DEU', 'ألمانيا'),
(32394, 1602398208, 1602400255, 'TR', 'TUR', 'تركيا'),
(32395, 1602400256, 1602402303, 'RU', 'RUS', 'الإتحاد الروسي'),
(32396, 1602402304, 1602404351, 'LU', 'LUX', 'لوكسيمبورغ'),
(32397, 1602404352, 1602406399, 'GB', 'GBR', 'المملكة المتحدة'),
(32398, 1602406400, 1602408447, 'DE', 'DEU', 'ألمانيا'),
(32399, 1602408448, 1602410495, 'DK', 'DNK', 'الدنيمارك'),
(32400, 1602410496, 1602412543, 'NO', 'NOR', 'النرويج'),
(32401, 1602412544, 1602414591, 'GB', 'GBR', 'المملكة المتحدة'),
(32402, 1602414592, 1602416639, 'NL', 'NLD', 'هولندا'),
(32403, 1602416640, 1602418687, 'IR', 'IRN', 'إيران'),
(32404, 1602418688, 1602420735, 'DE', 'DEU', 'ألمانيا'),
(32405, 1602420736, 1602424831, 'RU', 'RUS', 'الإتحاد الروسي'),
(32406, 1602424832, 1602426879, 'FR', 'FRA', 'فرنسا'),
(32407, 1602426880, 1602428927, 'RU', 'RUS', 'الإتحاد الروسي'),
(32408, 1602428928, 1602430975, 'PL', 'POL', 'بولندا'),
(32409, 1602430976, 1602433023, 'IT', 'ITA', 'إيطاليا'),
(32410, 1602433024, 1602433471, 'HU', 'HUN', 'هنغاريا'),
(32411, 1602433472, 1602433479, 'CY', 'CYP', 'قبرص'),
(32412, 1602433480, 1602435071, 'HU', 'HUN', 'هنغاريا'),
(32413, 1602435072, 1602437119, 'IT', 'ITA', 'إيطاليا'),
(32414, 1602437120, 1602439167, 'GB', 'GBR', 'المملكة المتحدة'),
(32415, 1602439168, 1602441215, 'RU', 'RUS', 'الإتحاد الروسي'),
(32416, 1602441216, 1602443263, 'GB', 'GBR', 'المملكة المتحدة'),
(32417, 1602443264, 1602445311, 'RU', 'RUS', 'الإتحاد الروسي'),
(32418, 1602445312, 1602447359, 'DE', 'DEU', 'ألمانيا'),
(32419, 1602447360, 1602447871, 'GB', 'GBR', 'المملكة المتحدة'),
(32420, 1602447872, 1602448383, 'DE', 'DEU', 'ألمانيا'),
(32421, 1602448384, 1602448895, 'NL', 'NLD', 'هولندا'),
(32422, 1602448896, 1602449407, 'GB', 'GBR', 'المملكة المتحدة'),
(32423, 1602449408, 1602451455, 'LV', 'LVA', 'لاتفيا'),
(32424, 1602451456, 1602453503, 'DE', 'DEU', 'ألمانيا'),
(32425, 1602453504, 1602455551, 'SK', 'SVK', 'سلوفاكيا'),
(32426, 1602455552, 1602457599, 'FR', 'FRA', 'فرنسا'),
(32427, 1602457600, 1602459647, 'RU', 'RUS', 'الإتحاد الروسي'),
(32428, 1602459648, 1602461695, 'GB', 'GBR', 'المملكة المتحدة'),
(32429, 1602461696, 1602465791, 'ES', 'ESP', 'إسبانيا'),
(32430, 1602465792, 1602467839, 'RU', 'RUS', 'الإتحاد الروسي'),
(32431, 1602467840, 1602469887, 'GI', 'GIB', 'جبل طارق'),
(32432, 1602469888, 1602471935, 'AT', 'AUT', 'النمسا'),
(32433, 1602471936, 1602473983, 'SE', 'SWE', 'السويد'),
(32434, 1602473984, 1602476031, 'RU', 'RUS', 'الإتحاد الروسي'),
(32435, 1602476032, 1602478079, 'GB', 'GBR', 'المملكة المتحدة'),
(32436, 1602478080, 1602480127, 'RU', 'RUS', 'الإتحاد الروسي'),
(32437, 1602482176, 1602484223, 'FR', 'FRA', 'فرنسا'),
(32438, 1602484224, 1602486271, 'GB', 'GBR', 'المملكة المتحدة'),
(32439, 1602486272, 1602748415, 'UA', 'UKR', 'أوكرانيا'),
(32440, 1602748416, 1602781183, 'PT', 'PRT', 'البورتوغال'),
(32441, 1602781184, 1602813951, 'FR', 'FRA', 'فرنسا'),
(32442, 1602813952, 1602846719, 'RU', 'RUS', 'الإتحاد الروسي'),
(32443, 1602846720, 1602879487, 'GE', 'GEO', 'جورجيا'),
(32444, 1602879488, 1602912255, 'FR', 'FRA', 'فرنسا'),
(32445, 1602912256, 1603010559, 'RU', 'RUS', 'الإتحاد الروسي'),
(32446, 1603010560, 1603014655, 'FR', 'FRA', 'فرنسا'),
(32447, 1603014656, 1603018751, 'RU', 'RUS', 'الإتحاد الروسي'),
(32448, 1603018752, 1603022847, 'HU', 'HUN', 'هنغاريا'),
(32449, 1603022848, 1603026943, 'GB', 'GBR', 'المملكة المتحدة'),
(32450, 1603026944, 1603031039, 'SE', 'SWE', 'السويد'),
(32451, 1603031040, 1603035135, 'RU', 'RUS', 'الإتحاد الروسي'),
(32452, 1603035136, 1603039231, 'SY', 'SYR', 'سوريا'),
(32453, 1603039232, 1603043327, 'RS', 'SRB', 'صربيا'),
(32454, 1603043328, 1603047423, 'IT', 'ITA', 'إيطاليا'),
(32455, 1603047424, 1603051519, 'RU', 'RUS', 'الإتحاد الروسي'),
(32456, 1603051520, 1603055615, 'JO', 'JOR', 'الأردن'),
(32457, 1603055616, 1603059711, 'SE', 'SWE', 'السويد'),
(32458, 1603059712, 1603063807, 'AM', 'ARM', 'أرمينيا'),
(32459, 1603063808, 1603067903, 'BG', 'BGR', 'بلغاريا'),
(32460, 1603067904, 1603071999, 'GB', 'GBR', 'المملكة المتحدة'),
(32461, 1603072000, 1603076095, 'CZ', 'CZE', 'التشيك'),
(32462, 1603076096, 1603080191, 'RU', 'RUS', 'الإتحاد الروسي'),
(32463, 1603080192, 1603084287, 'DE', 'DEU', 'ألمانيا'),
(32464, 1603084288, 1603088383, 'IT', 'ITA', 'إيطاليا'),
(32465, 1603088384, 1603092479, 'LB', 'LBN', 'لبنان'),
(32466, 1603092480, 1603100671, 'NO', 'NOR', 'النرويج'),
(32467, 1603100672, 1603108863, 'FR', 'FRA', 'فرنسا'),
(32468, 1603108864, 1603112959, 'KZ', 'KAZ', 'كازاخستان'),
(32469, 1603112960, 1603121151, 'GB', 'GBR', 'المملكة المتحدة'),
(32470, 1603121152, 1603129343, 'RU', 'RUS', 'الإتحاد الروسي'),
(32471, 1603129344, 1603133439, 'JO', 'JOR', 'الأردن'),
(32472, 1603133440, 1603137535, 'RU', 'RUS', 'الإتحاد الروسي'),
(32473, 1603137536, 1603141631, 'KW', 'KWT', 'الكويت'),
(32474, 1603141632, 1603145727, 'ES', 'ESP', 'إسبانيا'),
(32475, 1603145728, 1603146015, 'NL', 'NLD', 'هولندا'),
(32476, 1603146016, 1603146079, 'CY', 'CYP', 'قبرص'),
(32477, 1603146080, 1603146239, 'NL', 'NLD', 'هولندا'),
(32478, 1603146240, 1603146751, 'US', 'USA', 'الولايات المتحدة'),
(32479, 1603146752, 1603147007, 'NL', 'NLD', 'هولندا'),
(32480, 1603147008, 1603147775, 'IL', 'ISR', 'إسرائيل'),
(32481, 1603147776, 1603148031, 'US', 'USA', 'الولايات المتحدة'),
(32482, 1603148032, 1603149567, 'IL', 'ISR', 'إسرائيل'),
(32483, 1603149568, 1603149823, 'US', 'USA', 'الولايات المتحدة'),
(32484, 1603149824, 1603153919, 'RU', 'RUS', 'الإتحاد الروسي'),
(32485, 1603153920, 1603158015, 'NL', 'NLD', 'هولندا'),
(32486, 1603158016, 1603162111, 'DE', 'DEU', 'ألمانيا'),
(32487, 1603162112, 1603166207, 'TJ', 'TJK', 'طاجيكيستان'),
(32488, 1603166208, 1603166751, 'NL', 'NLD', 'هولندا'),
(32489, 1603166752, 1603166767, 'MT', 'MLT', 'مالطا'),
(32490, 1603166768, 1603166815, 'NL', 'NLD', 'هولندا'),
(32491, 1603166816, 1603166847, 'VE', 'VEN', 'فنزويلا'),
(32492, 1603166848, 1603166911, 'NL', 'NLD', 'هولندا'),
(32493, 1603166912, 1603166943, 'VE', 'VEN', 'فنزويلا'),
(32494, 1603166944, 1603166959, 'NL', 'NLD', 'هولندا'),
(32495, 1603166960, 1603166975, 'US', 'USA', 'الولايات المتحدة'),
(32496, 1603166976, 1603167135, 'NL', 'NLD', 'هولندا'),
(32497, 1603167136, 1603167167, 'JP', 'JPN', 'اليابان'),
(32498, 1603167168, 1603167231, 'NL', 'NLD', 'هولندا'),
(32499, 1603167232, 1603167743, 'BE', 'BEL', 'بلجيكا'),
(32500, 1603167744, 1603167871, 'NO', 'NOR', 'النرويج'),
(32501, 1603167872, 1603170303, 'NL', 'NLD', 'هولندا'),
(32502, 1603170304, 1603174399, 'IE', 'IRL', 'إيرلندا'),
(32503, 1603174400, 1603178495, 'TR', 'TUR', 'تركيا'),
(32504, 1603178496, 1603182591, 'DK', 'DNK', 'الدنيمارك'),
(32505, 1603182592, 1603184639, 'FR', 'FRA', 'فرنسا'),
(32506, 1603184640, 1603185663, 'GB', 'GBR', 'المملكة المتحدة'),
(32507, 1603185664, 1603186687, 'FR', 'FRA', 'فرنسا'),
(32508, 1603186688, 1603190783, 'IT', 'ITA', 'إيطاليا'),
(32509, 1603190784, 1603194879, 'RU', 'RUS', 'الإتحاد الروسي'),
(32510, 1603194880, 1603198975, 'IT', 'ITA', 'إيطاليا'),
(32511, 1603198976, 1603203071, 'IR', 'IRN', 'إيران'),
(32512, 1603203072, 1603207167, 'NL', 'NLD', 'هولندا'),
(32513, 1603207168, 1603215359, 'RU', 'RUS', 'الإتحاد الروسي'),
(32514, 1603215360, 1603219455, 'DE', 'DEU', 'ألمانيا'),
(32515, 1603219456, 1603220495, 'CH', 'CHE', 'سويسرا'),
(32516, 1603220496, 1603220503, 'LI', 'LIE', 'ليختنشتاين'),
(32517, 1603220504, 1603223551, 'CH', 'CHE', 'سويسرا'),
(32518, 1603223552, 1603223615, 'FR', 'FRA', 'فرنسا'),
(32519, 1603223616, 1603223631, 'SE', 'SWE', 'السويد'),
(32520, 1603223632, 1603223703, 'FR', 'FRA', 'فرنسا'),
(32521, 1603223704, 1603223711, 'SE', 'SWE', 'السويد'),
(32522, 1603223712, 1603223887, 'FR', 'FRA', 'فرنسا'),
(32523, 1603223888, 1603223903, 'SE', 'SWE', 'السويد'),
(32524, 1603223904, 1603223935, 'FR', 'FRA', 'فرنسا'),
(32525, 1603223936, 1603224063, 'SE', 'SWE', 'السويد'),
(32526, 1603224064, 1603224319, 'FR', 'FRA', 'فرنسا'),
(32527, 1603224320, 1603224335, 'GB', 'GBR', 'المملكة المتحدة'),
(32528, 1603224336, 1603226623, 'SE', 'SWE', 'السويد'),
(32529, 1603226624, 1603226879, 'FR', 'FRA', 'فرنسا'),
(32530, 1603226880, 1603227647, 'SE', 'SWE', 'السويد'),
(32531, 1603227648, 1603231743, 'AT', 'AUT', 'النمسا'),
(32532, 1603231744, 1603235839, 'IT', 'ITA', 'إيطاليا'),
(32533, 1603235840, 1603239935, 'RU', 'RUS', 'الإتحاد الروسي'),
(32534, 1603239936, 1603244031, 'CZ', 'CZE', 'التشيك'),
(32535, 1603244032, 1603248127, 'SI', 'SVN', 'سلوفينيا'),
(32536, 1603248128, 1603252223, 'DE', 'DEU', 'ألمانيا'),
(32537, 1603252224, 1603256319, 'RU', 'RUS', 'الإتحاد الروسي'),
(32538, 1603256320, 1603260415, 'SE', 'SWE', 'السويد'),
(32539, 1603260416, 1603264511, 'RU', 'RUS', 'الإتحاد الروسي'),
(32540, 1603264512, 1603268607, 'AT', 'AUT', 'النمسا'),
(32541, 1603268608, 1603272703, 'PL', 'POL', 'بولندا'),
(32542, 1603272704, 1603796991, 'GB', 'GBR', 'المملكة المتحدة'),
(32543, 1603796992, 1603813375, 'RU', 'RUS', 'الإتحاد الروسي'),
(32544, 1603813376, 1603829759, 'CH', 'CHE', 'سويسرا'),
(32545, 1603829760, 1603846143, 'NL', 'NLD', 'هولندا'),
(32546, 1603846144, 1603862527, 'GB', 'GBR', 'المملكة المتحدة'),
(32547, 1603862528, 1603878911, 'EE', 'EST', 'إستونيا'),
(32548, 1603878912, 1603895295, 'MD', 'MDA', 'مولدوفا'),
(32549, 1603895296, 1603928063, 'RU', 'RUS', 'الإتحاد الروسي'),
(32550, 1603928064, 1603944447, 'DK', 'DNK', 'الدنيمارك'),
(32551, 1603944448, 1603977215, 'RU', 'RUS', 'الإتحاد الروسي'),
(32552, 1603977216, 1603980463, 'GB', 'GBR', 'المملكة المتحدة'),
(32553, 1603980464, 1603980479, 'CH', 'CHE', 'سويسرا'),
(32554, 1603980480, 1603981823, 'GB', 'GBR', 'المملكة المتحدة'),
(32555, 1603981824, 1603982079, 'IE', 'IRL', 'إيرلندا'),
(32556, 1603982080, 1603982655, 'GB', 'GBR', 'المملكة المتحدة'),
(32557, 1603982656, 1603982687, 'DK', 'DNK', 'الدنيمارك'),
(32558, 1603982688, 1603982719, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(32559, 1603982720, 1603982783, 'US', 'USA', 'الولايات المتحدة'),
(32560, 1603982784, 1603982847, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(32561, 1603982848, 1603984895, 'GB', 'GBR', 'المملكة المتحدة'),
(32562, 1603984896, 1603985151, 'PT', 'PRT', 'البورتوغال'),
(32563, 1603985152, 1603986687, 'GB', 'GBR', 'المملكة المتحدة'),
(32564, 1603986688, 1603986751, 'TR', 'TUR', 'تركيا'),
(32565, 1603986752, 1603990271, 'GB', 'GBR', 'المملكة المتحدة'),
(32566, 1603990272, 1603990527, 'SA', 'SAU', 'السعودية'),
(32567, 1603990528, 1603993599, 'GB', 'GBR', 'المملكة المتحدة'),
(32568, 1603993600, 1604009983, 'ME', 'MNE', 'الجبل الأسود'),
(32569, 1604009984, 1604026367, 'PL', 'POL', 'بولندا'),
(32570, 1604026368, 1604042751, 'NL', 'NLD', 'هولندا'),
(32571, 1604042752, 1604059135, 'SE', 'SWE', 'السويد'),
(32572, 1604059136, 1604075519, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(32573, 1604075520, 1604091903, 'RU', 'RUS', 'الإتحاد الروسي'),
(32574, 1604091904, 1604108287, 'BA', 'BIH', 'البوسنه والهرسك'),
(32575, 1604108288, 1604141055, 'DE', 'DEU', 'ألمانيا'),
(32576, 1604141056, 1604157439, 'RO', 'ROM', 'رومانيا'),
(32577, 1604157440, 1604190207, 'FR', 'FRA', 'فرنسا'),
(32578, 1604190208, 1604206591, 'UA', 'UKR', 'أوكرانيا'),
(32579, 1604206592, 1604222975, 'PL', 'POL', 'بولندا'),
(32580, 1604222976, 1604239359, 'BG', 'BGR', 'بلغاريا'),
(32581, 1604239360, 1604255743, 'RU', 'RUS', 'الإتحاد الروسي'),
(32582, 1604255744, 1604272127, 'SY', 'SYR', 'سوريا'),
(32583, 1604272128, 1604288511, 'IQ', 'IRQ', 'العراق'),
(32584, 1604288512, 1604304895, 'RU', 'RUS', 'الإتحاد الروسي'),
(32585, 1604304896, 1604321279, 'SI', 'SVN', 'سلوفينيا'),
(32586, 1604321280, 1604386815, 'PL', 'POL', 'بولندا'),
(32587, 1604386816, 1604452351, 'RU', 'RUS', 'الإتحاد الروسي'),
(32588, 1604452352, 1604517887, 'RO', 'ROM', 'رومانيا'),
(32589, 1604517888, 1604583423, 'RU', 'RUS', 'الإتحاد الروسي'),
(32590, 1604583424, 1604616191, 'UA', 'UKR', 'أوكرانيا'),
(32591, 1604616192, 1604632320, 'RU', 'RUS', 'الإتحاد الروسي'),
(32592, 1604632321, 1604632575, 'UA', 'UKR', 'أوكرانيا'),
(32593, 1604632576, 1604647679, 'RU', 'RUS', 'الإتحاد الروسي'),
(32594, 1604647680, 1604647935, 'UA', 'UKR', 'أوكرانيا'),
(32595, 1604647936, 1604648191, 'RU', 'RUS', 'الإتحاد الروسي'),
(32596, 1604648192, 1604648959, 'UA', 'UKR', 'أوكرانيا'),
(32597, 1604648960, 1604714495, 'RU', 'RUS', 'الإتحاد الروسي'),
(32598, 1604714496, 1604780031, 'DK', 'DNK', 'الدنيمارك'),
(32599, 1604780032, 1604845567, 'RU', 'RUS', 'الإتحاد الروسي'),
(32600, 1604845568, 1604853759, 'FR', 'FRA', 'فرنسا'),
(32601, 1604853760, 1604861951, 'HU', 'HUN', 'هنغاريا'),
(32602, 1604861952, 1604870143, 'RS', 'SRB', 'صربيا'),
(32603, 1604870144, 1604878335, 'HR', 'HRV', 'كرواتيا'),
(32604, 1604878336, 1604886655, 'DE', 'DEU', 'ألمانيا'),
(32605, 1604886656, 1604886783, 'RU', 'RUS', 'الإتحاد الروسي'),
(32606, 1604886784, 1604887039, 'DE', 'DEU', 'ألمانيا'),
(32607, 1604887040, 1604887295, 'KZ', 'KAZ', 'كازاخستان'),
(32608, 1604887296, 1604887807, 'DE', 'DEU', 'ألمانيا'),
(32609, 1604887808, 1604888063, 'BY', 'BLR', 'روسيا البيضاء'),
(32610, 1604888064, 1604889599, 'TR', 'TUR', 'تركيا'),
(32611, 1604889600, 1604889855, 'DE', 'DEU', 'ألمانيا'),
(32612, 1604889856, 1604890111, 'BY', 'BLR', 'روسيا البيضاء'),
(32613, 1604890112, 1604890367, 'RU', 'RUS', 'الإتحاد الروسي'),
(32614, 1604890368, 1604890879, 'TR', 'TUR', 'تركيا'),
(32615, 1604890880, 1604891391, 'BY', 'BLR', 'روسيا البيضاء'),
(32616, 1604891392, 1604891647, 'DE', 'DEU', 'ألمانيا'),
(32617, 1604891648, 1604891903, 'BY', 'BLR', 'روسيا البيضاء'),
(32618, 1604891904, 1604892031, 'DE', 'DEU', 'ألمانيا'),
(32619, 1604892032, 1604892159, 'RU', 'RUS', 'الإتحاد الروسي'),
(32620, 1604892160, 1604892927, 'DE', 'DEU', 'ألمانيا'),
(32621, 1604892928, 1604893183, 'HK', 'HKG', 'هونغ كونغ'),
(32622, 1604893184, 1604893311, 'RU', 'RUS', 'الإتحاد الروسي'),
(32623, 1604893312, 1604893375, 'TR', 'TUR', 'تركيا'),
(32624, 1604893376, 1604893439, 'DE', 'DEU', 'ألمانيا'),
(32625, 1604893440, 1604893695, 'TR', 'TUR', 'تركيا'),
(32626, 1604893696, 1604893951, 'DE', 'DEU', 'ألمانيا'),
(32627, 1604893952, 1604894463, 'TR', 'TUR', 'تركيا'),
(32628, 1604894464, 1604894719, 'BY', 'BLR', 'روسيا البيضاء'),
(32629, 1604894720, 1604899007, 'CZ', 'CZE', 'التشيك'),
(32630, 1604899008, 1604899039, 'SK', 'SVK', 'سلوفاكيا'),
(32631, 1604899040, 1604902911, 'CZ', 'CZE', 'التشيك'),
(32632, 1604902912, 1604911103, 'BG', 'BGR', 'بلغاريا'),
(32633, 1604911104, 1604919295, 'UA', 'UKR', 'أوكرانيا'),
(32634, 1604919296, 1604927487, 'NO', 'NOR', 'النرويج'),
(32635, 1604927488, 1604935679, 'IT', 'ITA', 'إيطاليا'),
(32636, 1604935680, 1604952063, 'RU', 'RUS', 'الإتحاد الروسي'),
(32637, 1604952064, 1604958719, 'DE', 'DEU', 'ألمانيا'),
(32638, 1604958720, 1604959231, 'RU', 'RUS', 'الإتحاد الروسي'),
(32639, 1604959232, 1604959743, 'DE', 'DEU', 'ألمانيا'),
(32640, 1604959744, 1604960255, 'RU', 'RUS', 'الإتحاد الروسي'),
(32641, 1604960256, 1604968447, 'BG', 'BGR', 'بلغاريا'),
(32642, 1604968448, 1604976639, 'ES', 'ESP', 'إسبانيا'),
(32643, 1604976640, 1604993023, 'FR', 'FRA', 'فرنسا'),
(32644, 1604993024, 1605001215, 'NL', 'NLD', 'هولندا'),
(32645, 1605001216, 1605025791, 'RU', 'RUS', 'الإتحاد الروسي'),
(32646, 1605025792, 1605033983, 'IQ', 'IRQ', 'العراق'),
(32647, 1605033984, 1605042175, 'SK', 'SVK', 'سلوفاكيا'),
(32648, 1605042176, 1605050367, 'RU', 'RUS', 'الإتحاد الروسي'),
(32649, 1605050368, 1605052039, 'IT', 'ITA', 'إيطاليا'),
(32650, 1605052040, 1605052047, 'DE', 'DEU', 'ألمانيا'),
(32651, 1605052048, 1605058559, 'IT', 'ITA', 'إيطاليا'),
(32652, 1605058560, 1605066751, 'HU', 'HUN', 'هنغاريا'),
(32653, 1605066752, 1605074943, 'PL', 'POL', 'بولندا'),
(32654, 1605074944, 1605083135, 'FR', 'FRA', 'فرنسا'),
(32655, 1605083136, 1605091327, 'BE', 'BEL', 'بلجيكا'),
(32656, 1605091328, 1605099519, 'PL', 'POL', 'بولندا'),
(32657, 1605099520, 1605107711, 'RU', 'RUS', 'الإتحاد الروسي'),
(32658, 1605107712, 1605115903, 'GB', 'GBR', 'المملكة المتحدة'),
(32659, 1605115904, 1605124095, 'RU', 'RUS', 'الإتحاد الروسي'),
(32660, 1605124096, 1605124351, 'US', 'USA', 'الولايات المتحدة'),
(32661, 1605124352, 1605125263, 'GB', 'GBR', 'المملكة المتحدة'),
(32662, 1605125264, 1605125279, 'US', 'USA', 'الولايات المتحدة'),
(32663, 1605125280, 1605125327, 'GB', 'GBR', 'المملكة المتحدة'),
(32664, 1605125328, 1605125335, 'US', 'USA', 'الولايات المتحدة'),
(32665, 1605125336, 1605125375, 'GB', 'GBR', 'المملكة المتحدة'),
(32666, 1605125376, 1605125439, 'US', 'USA', 'الولايات المتحدة'),
(32667, 1605125440, 1605125631, 'GB', 'GBR', 'المملكة المتحدة'),
(32668, 1605125632, 1605126143, 'DE', 'DEU', 'ألمانيا'),
(32669, 1605126144, 1605126911, 'US', 'USA', 'الولايات المتحدة'),
(32670, 1605126912, 1605132287, 'GB', 'GBR', 'المملكة المتحدة'),
(32671, 1605132288, 1605148671, 'RU', 'RUS', 'الإتحاد الروسي'),
(32672, 1605148672, 1605156863, 'PT', 'PRT', 'البورتوغال'),
(32673, 1605156864, 1605165055, 'JO', 'JOR', 'الأردن'),
(32674, 1605165056, 1605173247, 'GB', 'GBR', 'المملكة المتحدة'),
(32675, 1605173248, 1605181439, 'TR', 'TUR', 'تركيا'),
(32676, 1605181440, 1605189631, 'LT', 'LTU', 'ليتوانيا'),
(32677, 1605189632, 1605189663, 'SK', 'SVK', 'سلوفاكيا'),
(32678, 1605189664, 1605197823, 'CZ', 'CZE', 'التشيك'),
(32679, 1605197824, 1605206015, 'DE', 'DEU', 'ألمانيا'),
(32680, 1605206016, 1605214207, 'RU', 'RUS', 'الإتحاد الروسي'),
(32681, 1605214208, 1605222399, 'TR', 'TUR', 'تركيا'),
(32682, 1605222400, 1605230591, 'CZ', 'CZE', 'التشيك'),
(32683, 1605230592, 1605238783, 'TR', 'TUR', 'تركيا'),
(32684, 1605238784, 1605246975, 'IT', 'ITA', 'إيطاليا'),
(32685, 1605246976, 1605255167, 'PL', 'POL', 'بولندا'),
(32686, 1605255168, 1605263359, 'HU', 'HUN', 'هنغاريا'),
(32687, 1605263360, 1605271551, 'RU', 'RUS', 'الإتحاد الروسي'),
(32688, 1605271552, 1605279743, 'DE', 'DEU', 'ألمانيا'),
(32689, 1605279744, 1605287935, 'FR', 'FRA', 'فرنسا'),
(32690, 1605287936, 1605296127, 'RU', 'RUS', 'الإتحاد الروسي'),
(32691, 1605296128, 1605304319, 'CH', 'CHE', 'سويسرا'),
(32692, 1605304320, 1605312511, 'PL', 'POL', 'بولندا'),
(32693, 1605312512, 1605320703, 'IL', 'ISR', 'إسرائيل'),
(32694, 1605320704, 1605328895, 'KW', 'KWT', 'الكويت'),
(32695, 1605328896, 1605337087, 'FI', 'FIN', 'فنلندا'),
(32696, 1605337088, 1605345279, 'GB', 'GBR', 'المملكة المتحدة'),
(32697, 1605345280, 1605353471, 'FR', 'FRA', 'فرنسا'),
(32698, 1605353472, 1605361663, 'GB', 'GBR', 'المملكة المتحدة'),
(32699, 1605361664, 1605369855, 'RU', 'RUS', 'الإتحاد الروسي'),
(32700, 1605369856, 1605402623, 'FR', 'FRA', 'فرنسا'),
(32701, 1605402624, 1605435391, 'SI', 'SVN', 'سلوفينيا'),
(32702, 1605435392, 1605468159, 'GB', 'GBR', 'المملكة المتحدة'),
(32703, 1605468160, 1605500927, 'RO', 'ROM', 'رومانيا'),
(32704, 1605500928, 1605533695, 'PL', 'POL', 'بولندا'),
(32705, 1605533696, 1605566463, 'HR', 'HRV', 'كرواتيا'),
(32706, 1605566464, 1605599231, 'RU', 'RUS', 'الإتحاد الروسي'),
(32707, 1605599232, 1605631999, 'GR', 'GRC', 'اليونان'),
(32708, 1605632000, 1605664767, 'RS', 'SRB', 'صربيا'),
(32709, 1605664768, 1605697535, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(32710, 1605697536, 1605795839, 'RU', 'RUS', 'الإتحاد الروسي'),
(32711, 1605795840, 1605828607, 'BE', 'BEL', 'بلجيكا'),
(32712, 1605828608, 1605861375, 'RU', 'RUS', 'الإتحاد الروسي'),
(32713, 1605861376, 1605894143, 'TR', 'TUR', 'تركيا'),
(32714, 1605894144, 1606156287, 'RO', 'ROM', 'رومانيا'),
(32715, 1606156288, 1606418431, 'RU', 'RUS', 'الإتحاد الروسي'),
(32716, 1606418432, 1607467007, 'SE', 'SWE', 'السويد'),
(32717, 1607467008, 1607532543, 'DE', 'DEU', 'ألمانيا'),
(32718, 1607532544, 1607570431, 'SE', 'SWE', 'السويد'),
(32719, 1607570432, 1607571455, 'DK', 'DNK', 'الدنيمارك'),
(32720, 1607571456, 1607585791, 'SE', 'SWE', 'السويد'),
(32721, 1607585792, 1607587839, 'DK', 'DNK', 'الدنيمارك'),
(32722, 1607587840, 1607588863, 'SE', 'SWE', 'السويد'),
(32723, 1607588864, 1607598079, 'DK', 'DNK', 'الدنيمارك'),
(32724, 1607598080, 1607610367, 'IT', 'ITA', 'إيطاليا'),
(32725, 1607610368, 1607612415, 'IE', 'IRL', 'إيرلندا'),
(32726, 1607612416, 1607614463, 'IT', 'ITA', 'إيطاليا'),
(32727, 1607614464, 1607616511, 'GR', 'GRC', 'اليونان'),
(32728, 1607616512, 1607663615, 'IT', 'ITA', 'إيطاليا'),
(32729, 1607663616, 1607729151, 'NL', 'NLD', 'هولندا'),
(32730, 1607729152, 1607761919, 'EG', 'EGY', 'مصر'),
(32731, 1607761920, 1607766015, 'SY', 'SYR', 'سوريا'),
(32732, 1607766016, 1607794687, 'EG', 'EGY', 'مصر'),
(32733, 1607794688, 1607860223, 'RU', 'RUS', 'الإتحاد الروسي'),
(32734, 1607860224, 1607925759, 'ES', 'ESP', 'إسبانيا'),
(32735, 1607925760, 1607926783, 'RU', 'RUS', 'الإتحاد الروسي'),
(32736, 1607926784, 1607927807, 'NL', 'NLD', 'هولندا'),
(32737, 1607927808, 1607929855, 'RU', 'RUS', 'الإتحاد الروسي'),
(32738, 1607929856, 1607930879, 'SE', 'SWE', 'السويد'),
(32739, 1607930880, 1607933951, 'PL', 'POL', 'بولندا'),
(32740, 1607933952, 1607934975, 'DE', 'DEU', 'ألمانيا'),
(32741, 1607934976, 1607935999, 'UA', 'UKR', 'أوكرانيا'),
(32742, 1607937024, 1607938047, 'LV', 'LVA', 'لاتفيا'),
(32743, 1607938048, 1607939071, 'UA', 'UKR', 'أوكرانيا'),
(32744, 1607939072, 1607940095, 'PL', 'POL', 'بولندا'),
(32745, 1607940096, 1607941119, 'RU', 'RUS', 'الإتحاد الروسي'),
(32746, 1607941120, 1607942143, 'ES', 'ESP', 'إسبانيا'),
(32747, 1607942144, 1607944191, 'RU', 'RUS', 'الإتحاد الروسي'),
(32748, 1607944192, 1607945215, 'FR', 'FRA', 'فرنسا'),
(32749, 1607946240, 1607947263, 'UA', 'UKR', 'أوكرانيا'),
(32750, 1607948288, 1607949311, 'GB', 'GBR', 'المملكة المتحدة'),
(32751, 1607949312, 1607950335, 'UA', 'UKR', 'أوكرانيا'),
(32752, 1607952384, 1607953407, 'UA', 'UKR', 'أوكرانيا'),
(32753, 1607956480, 1607957503, 'ES', 'ESP', 'إسبانيا'),
(32754, 1607957504, 1607958527, 'UA', 'UKR', 'أوكرانيا'),
(32755, 1607958528, 1607959551, 'PS', 'PSE', 'فلسطين المحتلة'),
(32756, 1607959552, 1607960575, 'EE', 'EST', 'إستونيا'),
(32757, 1607960576, 1607962623, 'RU', 'RUS', 'الإتحاد الروسي'),
(32758, 1607962624, 1607963647, 'UA', 'UKR', 'أوكرانيا'),
(32759, 1607963648, 1607965695, 'RU', 'RUS', 'الإتحاد الروسي'),
(32760, 1607965696, 1607966719, 'UA', 'UKR', 'أوكرانيا'),
(32761, 1607966720, 1607967743, 'RU', 'RUS', 'الإتحاد الروسي'),
(32762, 1607967744, 1607968767, 'UA', 'UKR', 'أوكرانيا'),
(32763, 1607968768, 1607969791, 'SE', 'SWE', 'السويد'),
(32764, 1607969792, 1607971839, 'RU', 'RUS', 'الإتحاد الروسي'),
(32765, 1607974912, 1607975935, 'LV', 'LVA', 'لاتفيا'),
(32766, 1607976960, 1607977983, 'KZ', 'KAZ', 'كازاخستان'),
(32767, 1607977984, 1607979007, 'NL', 'NLD', 'هولندا'),
(32768, 1607979008, 1607980031, 'RU', 'RUS', 'الإتحاد الروسي'),
(32769, 1607980032, 1607981055, 'DE', 'DEU', 'ألمانيا'),
(32770, 1607981056, 1607982079, 'UA', 'UKR', 'أوكرانيا'),
(32771, 1607982080, 1607983103, 'RU', 'RUS', 'الإتحاد الروسي'),
(32772, 1607983104, 1607984127, 'GB', 'GBR', 'المملكة المتحدة'),
(32773, 1607984128, 1607985151, 'RU', 'RUS', 'الإتحاد الروسي'),
(32774, 1607985152, 1607986175, 'PL', 'POL', 'بولندا'),
(32775, 1607986176, 1607987199, 'UA', 'UKR', 'أوكرانيا'),
(32776, 1607987200, 1607988223, 'ES', 'ESP', 'إسبانيا'),
(32777, 1607988224, 1607989247, 'KG', 'KGZ', 'قيرغيزستان'),
(32778, 1607990272, 1607991295, 'RU', 'RUS', 'الإتحاد الروسي'),
(32779, 1607991296, 1608122367, 'UA', 'UKR', 'أوكرانيا'),
(32780, 1608122368, 1608253439, 'RO', 'ROM', 'رومانيا'),
(32781, 1608253440, 1608384511, 'RU', 'RUS', 'الإتحاد الروسي'),
(32782, 1608384512, 1608515583, 'DE', 'DEU', 'ألمانيا'),
(32783, 1608515584, 1610612735, 'IT', 'ITA', 'إيطاليا'),
(32784, 1610612736, 1610678271, 'US', 'USA', 'الولايات المتحدة'),
(32785, 1610678272, 1610743807, 'CA', 'CAN', 'كندا'),
(32786, 1610743808, 1611153407, 'US', 'USA', 'الولايات المتحدة'),
(32787, 1611169792, 1611227135, 'US', 'USA', 'الولايات المتحدة'),
(32788, 1611227136, 1611235327, 'CA', 'CAN', 'كندا'),
(32789, 1611235328, 1611923455, 'US', 'USA', 'الولايات المتحدة'),
(32790, 1611923456, 1612185599, 'CA', 'CAN', 'كندا'),
(32791, 1612185600, 1612611583, 'US', 'USA', 'الولايات المتحدة'),
(32792, 1612611584, 1612636159, 'CA', 'CAN', 'كندا'),
(32793, 1612636160, 1613451263, 'US', 'USA', 'الولايات المتحدة'),
(32794, 1613455360, 1613459455, 'US', 'USA', 'الولايات المتحدة'),
(32795, 1613463552, 1613467647, 'US', 'USA', 'الولايات المتحدة'),
(32796, 1613471744, 1613479935, 'JM', 'JAM', 'جامايكا'),
(32797, 1613479936, 1613488127, 'US', 'USA', 'الولايات المتحدة'),
(32798, 1613488128, 1613492223, 'CA', 'CAN', 'كندا'),
(32799, 1613496320, 1613504511, 'US', 'USA', 'الولايات المتحدة'),
(32800, 1613512704, 1613529087, 'CA', 'CAN', 'كندا'),
(32801, 1613529088, 1613545471, 'US', 'USA', 'الولايات المتحدة'),
(32802, 1613545472, 1613565951, 'CA', 'CAN', 'كندا'),
(32803, 1613565952, 1613570047, 'US', 'USA', 'الولايات المتحدة'),
(32804, 1613570048, 1613574143, 'CA', 'CAN', 'كندا'),
(32805, 1613574144, 1613586431, 'US', 'USA', 'الولايات المتحدة'),
(32806, 1613586432, 1613590527, 'CA', 'CAN', 'كندا'),
(32807, 1613590528, 1613606911, 'US', 'USA', 'الولايات المتحدة'),
(32808, 1613606912, 1613615103, 'CA', 'CAN', 'كندا'),
(32809, 1613615104, 1613635583, 'US', 'USA', 'الولايات المتحدة'),
(32810, 1613635584, 1613643775, 'CA', 'CAN', 'كندا'),
(32811, 1613643776, 1613676543, 'US', 'USA', 'الولايات المتحدة'),
(32812, 1613676544, 1613680639, 'CA', 'CAN', 'كندا'),
(32813, 1613680640, 1613737983, 'US', 'USA', 'الولايات المتحدة'),
(32814, 1613737984, 1613742079, 'CA', 'CAN', 'كندا'),
(32815, 1613742080, 1613758463, 'US', 'USA', 'الولايات المتحدة'),
(32816, 1613758464, 1614282751, 'CA', 'CAN', 'كندا'),
(32817, 1614282752, 1614741503, 'US', 'USA', 'الولايات المتحدة'),
(32818, 1614741504, 1614757887, 'CA', 'CAN', 'كندا'),
(32819, 1614757888, 1614774271, 'US', 'USA', 'الولايات المتحدة'),
(32820, 1614774272, 1614778367, 'CA', 'CAN', 'كندا'),
(32821, 1614790656, 1618804735, 'US', 'USA', 'الولايات المتحدة'),
(32822, 1619001344, 1632305151, 'US', 'USA', 'الولايات المتحدة'),
(32823, 1632305152, 1632321535, 'CA', 'CAN', 'كندا'),
(32824, 1632321536, 1632342015, 'US', 'USA', 'الولايات المتحدة'),
(32825, 1632346112, 1632354303, 'US', 'USA', 'الولايات المتحدة'),
(32826, 1632354304, 1632362495, 'CA', 'CAN', 'كندا'),
(32827, 1632362496, 1634414591, 'US', 'USA', 'الولايات المتحدة'),
(32828, 1634414592, 1634418687, 'CA', 'CAN', 'كندا'),
(32829, 1634418688, 1634447359, 'US', 'USA', 'الولايات المتحدة'),
(32830, 1634447360, 1634451455, 'CA', 'CAN', 'كندا'),
(32831, 1634451456, 1634455551, 'US', 'USA', 'الولايات المتحدة'),
(32832, 1634455552, 1634459647, 'CA', 'CAN', 'كندا'),
(32833, 1634459648, 1634467839, 'US', 'USA', 'الولايات المتحدة'),
(32834, 1634467840, 1634729983, 'CA', 'CAN', 'كندا'),
(32835, 1634729984, 1652293631, 'US', 'USA', 'الولايات المتحدة'),
(32836, 1652293632, 1652310015, 'CA', 'CAN', 'كندا'),
(32837, 1652310016, 1653501951, 'US', 'USA', 'الولايات المتحدة'),
(32838, 1653506048, 1653534719, 'US', 'USA', 'الولايات المتحدة'),
(32839, 1653534720, 1653538815, 'CA', 'CAN', 'كندا'),
(32840, 1653538816, 1653542911, 'US', 'USA', 'الولايات المتحدة'),
(32841, 1653547008, 1653555199, 'US', 'USA', 'الولايات المتحدة'),
(32842, 1653555200, 1653567487, 'CA', 'CAN', 'كندا'),
(32843, 1653567488, 1653571583, 'US', 'USA', 'الولايات المتحدة'),
(32844, 1653571584, 1653575679, 'CA', 'CAN', 'كندا'),
(32845, 1653575680, 1653592063, 'US', 'USA', 'الولايات المتحدة'),
(32846, 1653592064, 1653596159, 'CA', 'CAN', 'كندا'),
(32847, 1653596160, 1653600255, 'US', 'USA', 'الولايات المتحدة'),
(32848, 1653600256, 1653604351, 'CA', 'CAN', 'كندا'),
(32849, 1653604352, 1654542335, 'US', 'USA', 'الولايات المتحدة'),
(32850, 1654542336, 1654546431, 'CA', 'CAN', 'كندا'),
(32851, 1654546432, 1654550527, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(32852, 1654550528, 1654554623, 'US', 'USA', 'الولايات المتحدة'),
(32853, 1654554624, 1654558719, 'CA', 'CAN', 'كندا'),
(32854, 1654558720, 1654648831, 'US', 'USA', 'الولايات المتحدة'),
(32855, 1654648832, 1654652927, 'CA', 'CAN', 'كندا'),
(32856, 1654652928, 1673527295, 'US', 'USA', 'الولايات المتحدة'),
(32857, 1673527296, 1673560063, 'CA', 'CAN', 'كندا'),
(32858, 1673560064, 1673576447, 'US', 'USA', 'الولايات المتحدة'),
(32859, 1673592832, 1673986047, 'US', 'USA', 'الولايات المتحدة'),
(32860, 1673986048, 1674051583, 'CA', 'CAN', 'كندا'),
(32861, 1674051584, 1674575871, 'US', 'USA', 'الولايات المتحدة'),
(32862, 1674575872, 1677721599, 'CA', 'CAN', 'كندا'),
(32863, 1811939328, 1815724031, 'US', 'USA', 'الولايات المتحدة'),
(32864, 1816133632, 1820327935, 'US', 'USA', 'الولايات المتحدة'),
(32865, 1828716544, 1830813695, 'FR', 'FRA', 'فرنسا'),
(32866, 1830813696, 1831337983, 'NL', 'NLD', 'هولندا'),
(32867, 1831337984, 1831862271, 'DE', 'DEU', 'ألمانيا'),
(32868, 1831862272, 1832124415, 'PT', 'PRT', 'البورتوغال'),
(32869, 1832124416, 1832386559, 'IT', 'ITA', 'إيطاليا'),
(32870, 1832386560, 1832517631, 'DK', 'DNK', 'الدنيمارك'),
(32871, 1832517632, 1832648703, 'SE', 'SWE', 'السويد'),
(32872, 1832648704, 1832681471, 'HR', 'HRV', 'كرواتيا'),
(32873, 1832681472, 1832714239, 'RU', 'RUS', 'الإتحاد الروسي'),
(32874, 1832714240, 1832747007, 'HU', 'HUN', 'هنغاريا'),
(32875, 1832747008, 1832779775, 'RU', 'RUS', 'الإتحاد الروسي'),
(32876, 1832779776, 1832812543, 'FR', 'FRA', 'فرنسا'),
(32877, 1832812544, 1832845311, 'RU', 'RUS', 'الإتحاد الروسي'),
(32878, 1832845312, 1832878079, 'BH', 'BHR', 'البحرين'),
(32879, 1832910848, 1833172991, 'IL', 'ISR', 'إسرائيل'),
(32880, 1833172992, 1833177087, 'GB', 'GBR', 'المملكة المتحدة'),
(32881, 1833177088, 1833179135, 'RU', 'RUS', 'الإتحاد الروسي'),
(32882, 1833179136, 1833181183, 'IT', 'ITA', 'إيطاليا'),
(32883, 1833181184, 1833183231, 'GB', 'GBR', 'المملكة المتحدة'),
(32884, 1833183232, 1833185279, 'UA', 'UKR', 'أوكرانيا'),
(32885, 1833185280, 1833187327, 'DE', 'DEU', 'ألمانيا'),
(32886, 1833187328, 1833189375, 'NL', 'NLD', 'هولندا'),
(32887, 1833189376, 1833191423, 'GB', 'GBR', 'المملكة المتحدة'),
(32888, 1833191424, 1833193471, 'RU', 'RUS', 'الإتحاد الروسي'),
(32889, 1833193472, 1833195519, 'ES', 'ESP', 'إسبانيا'),
(32890, 1833195520, 1833197567, 'NO', 'NOR', 'النرويج'),
(32891, 1833197568, 1833199615, 'DE', 'DEU', 'ألمانيا'),
(32892, 1833199616, 1833201663, 'AT', 'AUT', 'النمسا'),
(32893, 1833201664, 1833203711, 'RU', 'RUS', 'الإتحاد الروسي'),
(32894, 1833203712, 1833205759, 'AM', 'ARM', 'أرمينيا'),
(32895, 1833205760, 1833207807, 'FI', 'FIN', 'فنلندا'),
(32896, 1833207808, 1833209855, 'RU', 'RUS', 'الإتحاد الروسي'),
(32897, 1833209856, 1833211903, 'GR', 'GRC', 'اليونان'),
(32898, 1833211904, 1833213951, 'IT', 'ITA', 'إيطاليا'),
(32899, 1833213952, 1833215999, 'BE', 'BEL', 'بلجيكا'),
(32900, 1833216000, 1833218047, 'RU', 'RUS', 'الإتحاد الروسي'),
(32901, 1833218048, 1833220095, 'NO', 'NOR', 'النرويج'),
(32902, 1833220096, 1833222143, 'RU', 'RUS', 'الإتحاد الروسي'),
(32903, 1833222144, 1833224191, 'GB', 'GBR', 'المملكة المتحدة'),
(32904, 1833224192, 1833228287, 'RU', 'RUS', 'الإتحاد الروسي'),
(32905, 1833228288, 1833232383, 'DE', 'DEU', 'ألمانيا'),
(32906, 1833232384, 1833234431, 'TJ', 'TJK', 'طاجيكيستان'),
(32907, 1833234432, 1833236479, 'GB', 'GBR', 'المملكة المتحدة'),
(32908, 1833236480, 1833238527, 'FI', 'FIN', 'فنلندا'),
(32909, 1833238528, 1833240575, 'AL', 'ALB', 'ألبانيا'),
(32910, 1833240576, 1833242623, 'ES', 'ESP', 'إسبانيا'),
(32911, 1833242624, 1833246719, 'RU', 'RUS', 'الإتحاد الروسي'),
(32912, 1833246720, 1833248767, 'FI', 'FIN', 'فنلندا'),
(32913, 1833248768, 1833250815, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(32914, 1833250816, 1833254911, 'GB', 'GBR', 'المملكة المتحدة'),
(32915, 1833254912, 1833256047, 'DE', 'DEU', 'ألمانيا'),
(32916, 1833256048, 1833256063, 'US', 'USA', 'الولايات المتحدة'),
(32917, 1833256064, 1833256151, 'DE', 'DEU', 'ألمانيا'),
(32918, 1833256152, 1833256155, 'US', 'USA', 'الولايات المتحدة'),
(32919, 1833256156, 1833256159, 'DE', 'DEU', 'ألمانيا'),
(32920, 1833256160, 1833256175, 'GB', 'GBR', 'المملكة المتحدة'),
(32921, 1833256176, 1833256191, 'DE', 'DEU', 'ألمانيا'),
(32922, 1833256192, 1833256223, 'US', 'USA', 'الولايات المتحدة'),
(32923, 1833256224, 1833256255, 'DE', 'DEU', 'ألمانيا'),
(32924, 1833256256, 1833256271, 'GB', 'GBR', 'المملكة المتحدة'),
(32925, 1833256272, 1833256287, 'DE', 'DEU', 'ألمانيا'),
(32926, 1833256288, 1833256295, 'GB', 'GBR', 'المملكة المتحدة'),
(32927, 1833256296, 1833256447, 'DE', 'DEU', 'ألمانيا'),
(32928, 1833256448, 1833256479, 'US', 'USA', 'الولايات المتحدة'),
(32929, 1833256480, 1833256511, 'DE', 'DEU', 'ألمانيا'),
(32930, 1833256512, 1833256543, 'US', 'USA', 'الولايات المتحدة'),
(32931, 1833256544, 1833256703, 'DE', 'DEU', 'ألمانيا'),
(32932, 1833256704, 1833256735, 'US', 'USA', 'الولايات المتحدة'),
(32933, 1833256736, 1833256799, 'DE', 'DEU', 'ألمانيا'),
(32934, 1833256800, 1833256831, 'US', 'USA', 'الولايات المتحدة'),
(32935, 1833256832, 1833256959, 'DE', 'DEU', 'ألمانيا'),
(32936, 1833256960, 1833261055, 'GB', 'GBR', 'المملكة المتحدة'),
(32937, 1833261056, 1833263103, 'PL', 'POL', 'بولندا'),
(32938, 1833263104, 1833265151, 'DE', 'DEU', 'ألمانيا'),
(32939, 1833265152, 1833267199, 'GB', 'GBR', 'المملكة المتحدة'),
(32940, 1833267200, 1833269247, 'HU', 'HUN', 'هنغاريا'),
(32941, 1833269248, 1833271295, 'FI', 'FIN', 'فنلندا'),
(32942, 1833271296, 1833273343, 'IT', 'ITA', 'إيطاليا'),
(32943, 1833275392, 1833277439, 'GB', 'GBR', 'المملكة المتحدة'),
(32944, 1833277440, 1833279487, 'CH', 'CHE', 'سويسرا'),
(32945, 1833279488, 1833281535, 'AL', 'ALB', 'ألبانيا'),
(32946, 1833281536, 1833283583, 'AT', 'AUT', 'النمسا'),
(32947, 1833283584, 1833285631, 'RU', 'RUS', 'الإتحاد الروسي'),
(32948, 1833285632, 1833289727, 'FR', 'FRA', 'فرنسا'),
(32949, 1833289728, 1833291775, 'IT', 'ITA', 'إيطاليا'),
(32950, 1833291776, 1833293823, 'CZ', 'CZE', 'التشيك'),
(32951, 1833293824, 1833295871, 'BE', 'BEL', 'بلجيكا'),
(32952, 1833295872, 1833297919, 'NL', 'NLD', 'هولندا'),
(32953, 1833297920, 1833299967, 'GB', 'GBR', 'المملكة المتحدة'),
(32954, 1833299968, 1833302015, 'LU', 'LUX', 'لوكسيمبورغ'),
(32955, 1833302016, 1833304063, 'AT', 'AUT', 'النمسا'),
(32956, 1833304064, 1833308159, 'NL', 'NLD', 'هولندا'),
(32957, 1833308160, 1833308239, 'FR', 'FRA', 'فرنسا'),
(32958, 1833308240, 1833308263, 'NL', 'NLD', 'هولندا'),
(32959, 1833308264, 1833310207, 'FR', 'FRA', 'فرنسا'),
(32960, 1833310208, 1833312255, 'RU', 'RUS', 'الإتحاد الروسي'),
(32961, 1833312256, 1833314303, 'ES', 'ESP', 'إسبانيا'),
(32962, 1833314304, 1833316351, 'GB', 'GBR', 'المملكة المتحدة'),
(32963, 1833316352, 1833318399, 'DK', 'DNK', 'الدنيمارك'),
(32964, 1833318400, 1833320447, 'GB', 'GBR', 'المملكة المتحدة'),
(32965, 1833320448, 1833322495, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(32966, 1833322496, 1833324543, 'IT', 'ITA', 'إيطاليا'),
(32967, 1833324544, 1833326591, 'NO', 'NOR', 'النرويج'),
(32968, 1833326592, 1833328639, 'US', 'USA', 'الولايات المتحدة'),
(32969, 1833328640, 1833330687, 'AT', 'AUT', 'النمسا'),
(32970, 1833330688, 1833332735, 'UA', 'UKR', 'أوكرانيا'),
(32971, 1833332736, 1833334783, 'CH', 'CHE', 'سويسرا'),
(32972, 1833334784, 1833336831, 'IT', 'ITA', 'إيطاليا'),
(32973, 1833336832, 1833336959, 'ES', 'ESP', 'إسبانيا'),
(32974, 1833336960, 1833336975, 'FR', 'FRA', 'فرنسا'),
(32975, 1833336976, 1833338879, 'ES', 'ESP', 'إسبانيا'),
(32976, 1833338880, 1833342975, 'GB', 'GBR', 'المملكة المتحدة'),
(32977, 1833342976, 1833345023, 'CH', 'CHE', 'سويسرا'),
(32978, 1833345024, 1833347071, 'FI', 'FIN', 'فنلندا'),
(32979, 1833347072, 1833349119, 'FR', 'FRA', 'فرنسا'),
(32980, 1833349120, 1833351167, 'FI', 'FIN', 'فنلندا'),
(32981, 1833351168, 1833353215, 'RU', 'RUS', 'الإتحاد الروسي'),
(32982, 1833353216, 1833355263, 'DE', 'DEU', 'ألمانيا'),
(32983, 1833355264, 1833357311, 'IT', 'ITA', 'إيطاليا'),
(32984, 1833357312, 1833359359, 'IE', 'IRL', 'إيرلندا'),
(32985, 1833359360, 1833361407, 'DE', 'DEU', 'ألمانيا'),
(32986, 1833361408, 1833363455, 'GB', 'GBR', 'المملكة المتحدة'),
(32987, 1833363456, 1833365503, 'RU', 'RUS', 'الإتحاد الروسي'),
(32988, 1833365504, 1833367551, 'IT', 'ITA', 'إيطاليا'),
(32989, 1833367552, 1833369599, 'RU', 'RUS', 'الإتحاد الروسي'),
(32990, 1833369600, 1833370111, 'NL', 'NLD', 'هولندا'),
(32991, 1833370112, 1833370367, 'BG', 'BGR', 'بلغاريا'),
(32992, 1833370368, 1833370623, 'SE', 'SWE', 'السويد'),
(32993, 1833370624, 1833371647, 'NL', 'NLD', 'هولندا'),
(32994, 1833371648, 1833373695, 'RU', 'RUS', 'الإتحاد الروسي'),
(32995, 1833373696, 1833377791, 'DE', 'DEU', 'ألمانيا'),
(32996, 1833377792, 1833379839, 'KZ', 'KAZ', 'كازاخستان'),
(32997, 1833379840, 1833381887, 'PT', 'PRT', 'البورتوغال');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(32998, 1833381888, 1833383935, 'NL', 'NLD', 'هولندا'),
(32999, 1833383936, 1833385983, 'DK', 'DNK', 'الدنيمارك'),
(33000, 1833385984, 1833388031, 'SK', 'SVK', 'سلوفاكيا'),
(33001, 1833388032, 1833390079, 'RU', 'RUS', 'الإتحاد الروسي'),
(33002, 1833390080, 1833392127, 'GB', 'GBR', 'المملكة المتحدة'),
(33003, 1833392128, 1833396223, 'CH', 'CHE', 'سويسرا'),
(33004, 1833396224, 1833398271, 'NL', 'NLD', 'هولندا'),
(33005, 1833398272, 1833400319, 'DE', 'DEU', 'ألمانيا'),
(33006, 1833400320, 1833402367, 'GB', 'GBR', 'المملكة المتحدة'),
(33007, 1833402368, 1833406463, 'FR', 'FRA', 'فرنسا'),
(33008, 1833406464, 1833408511, 'GB', 'GBR', 'المملكة المتحدة'),
(33009, 1833408512, 1833410559, 'RS', 'SRB', 'صربيا'),
(33010, 1833410560, 1833412607, 'PT', 'PRT', 'البورتوغال'),
(33011, 1833412608, 1833414655, 'GB', 'GBR', 'المملكة المتحدة'),
(33012, 1833414656, 1833416703, 'RU', 'RUS', 'الإتحاد الروسي'),
(33013, 1833416704, 1833418751, 'NL', 'NLD', 'هولندا'),
(33014, 1833418752, 1833422847, 'RU', 'RUS', 'الإتحاد الروسي'),
(33015, 1833422848, 1833424895, 'CZ', 'CZE', 'التشيك'),
(33016, 1833424896, 1833426943, 'DE', 'DEU', 'ألمانيا'),
(33017, 1833426944, 1833428991, 'KG', 'KGZ', 'قيرغيزستان'),
(33018, 1833428992, 1833431039, 'IT', 'ITA', 'إيطاليا'),
(33019, 1833431040, 1833433087, 'RU', 'RUS', 'الإتحاد الروسي'),
(33020, 1833433088, 1833435135, 'GB', 'GBR', 'المملكة المتحدة'),
(33021, 1833435136, 1833439231, 'CZ', 'CZE', 'التشيك'),
(33022, 1833439232, 1833443327, 'GB', 'GBR', 'المملكة المتحدة'),
(33023, 1833443328, 1833447423, 'NL', 'NLD', 'هولندا'),
(33024, 1833447424, 1833449471, 'RS', 'SRB', 'صربيا'),
(33025, 1833449472, 1833451519, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(33026, 1833451520, 1833455615, 'RU', 'RUS', 'الإتحاد الروسي'),
(33027, 1833455616, 1833459711, 'NL', 'NLD', 'هولندا'),
(33028, 1833459712, 1833463807, 'ME', 'MNE', 'الجبل الأسود'),
(33029, 1833463808, 1833467903, 'UA', 'UKR', 'أوكرانيا'),
(33030, 1833467904, 1833468079, 'RU', 'RUS', 'الإتحاد الروسي'),
(33031, 1833468080, 1833468575, 'CH', 'CHE', 'سويسرا'),
(33032, 1833468576, 1833468591, 'RU', 'RUS', 'الإتحاد الروسي'),
(33033, 1833468592, 1833471999, 'CH', 'CHE', 'سويسرا'),
(33034, 1833476096, 1833484287, 'NL', 'NLD', 'هولندا'),
(33035, 1833484288, 1833488383, 'IR', 'IRN', 'إيران'),
(33036, 1833488384, 1833492479, 'GB', 'GBR', 'المملكة المتحدة'),
(33037, 1833492480, 1833504767, 'RU', 'RUS', 'الإتحاد الروسي'),
(33038, 1833504768, 1833508863, 'DE', 'DEU', 'ألمانيا'),
(33039, 1833508864, 1833512959, 'RU', 'RUS', 'الإتحاد الروسي'),
(33040, 1833512960, 1833517055, 'DE', 'DEU', 'ألمانيا'),
(33041, 1833517056, 1833521151, 'ES', 'ESP', 'إسبانيا'),
(33042, 1833521152, 1833525247, 'IT', 'ITA', 'إيطاليا'),
(33043, 1833525248, 1833529343, 'LV', 'LVA', 'لاتفيا'),
(33044, 1833529344, 1833533439, 'GB', 'GBR', 'المملكة المتحدة'),
(33045, 1833533440, 1833537535, 'RU', 'RUS', 'الإتحاد الروسي'),
(33046, 1833537536, 1833541631, 'AT', 'AUT', 'النمسا'),
(33047, 1833541632, 1833542143, 'IL', 'ISR', 'إسرائيل'),
(33048, 1833542144, 1833542655, 'GB', 'GBR', 'المملكة المتحدة'),
(33049, 1833542656, 1833542911, 'IN', 'IND', 'الهند'),
(33050, 1833542912, 1833545727, 'GB', 'GBR', 'المملكة المتحدة'),
(33051, 1833545728, 1833549823, 'IT', 'ITA', 'إيطاليا'),
(33052, 1833549824, 1833553919, 'RU', 'RUS', 'الإتحاد الروسي'),
(33053, 1833553920, 1833558015, 'CZ', 'CZE', 'التشيك'),
(33054, 1833558016, 1833562111, 'RO', 'ROM', 'رومانيا'),
(33055, 1833562112, 1833566207, 'PS', 'PSE', 'فلسطين المحتلة'),
(33056, 1833566208, 1833570303, 'SE', 'SWE', 'السويد'),
(33057, 1833570304, 1833574399, 'NL', 'NLD', 'هولندا'),
(33058, 1833574400, 1833578495, 'YE', 'YEM', 'اليمن'),
(33059, 1833578496, 1833582591, 'HU', 'HUN', 'هنغاريا'),
(33060, 1833582592, 1833586687, 'TJ', 'TJK', 'طاجيكيستان'),
(33061, 1833586688, 1833590783, 'FR', 'FRA', 'فرنسا'),
(33062, 1833590784, 1833594879, 'PL', 'POL', 'بولندا'),
(33063, 1833594880, 1833603071, 'RU', 'RUS', 'الإتحاد الروسي'),
(33064, 1833603072, 1833607167, 'SK', 'SVK', 'سلوفاكيا'),
(33065, 1833607168, 1833611263, 'RU', 'RUS', 'الإتحاد الروسي'),
(33066, 1833611264, 1833615359, 'NO', 'NOR', 'النرويج'),
(33067, 1833615360, 1833619455, 'GB', 'GBR', 'المملكة المتحدة'),
(33068, 1833619456, 1833623551, 'RU', 'RUS', 'الإتحاد الروسي'),
(33069, 1833623552, 1833627647, 'IR', 'IRN', 'إيران'),
(33070, 1833627648, 1833631743, 'GB', 'GBR', 'المملكة المتحدة'),
(33071, 1833631744, 1833635839, 'CZ', 'CZE', 'التشيك'),
(33072, 1833635840, 1833639935, 'DE', 'DEU', 'ألمانيا'),
(33073, 1833639936, 1833644031, 'AM', 'ARM', 'أرمينيا'),
(33074, 1833644032, 1833648127, 'TJ', 'TJK', 'طاجيكيستان'),
(33075, 1833648128, 1833652223, 'LB', 'LBN', 'لبنان'),
(33076, 1833652224, 1833659023, 'DE', 'DEU', 'ألمانيا'),
(33077, 1833659024, 1833659039, 'BZ', 'BLZ', 'بليز'),
(33078, 1833659040, 1833659903, 'DE', 'DEU', 'ألمانيا'),
(33079, 1833659904, 1833659919, 'NA', 'NAM', 'ناميبيا'),
(33080, 1833659920, 1833660415, 'DE', 'DEU', 'ألمانيا'),
(33081, 1833660416, 1833664511, 'IT', 'ITA', 'إيطاليا'),
(33082, 1833664512, 1833668607, 'RU', 'RUS', 'الإتحاد الروسي'),
(33083, 1833668608, 1833672703, 'CZ', 'CZE', 'التشيك'),
(33084, 1833672704, 1833676799, 'GB', 'GBR', 'المملكة المتحدة'),
(33085, 1833676800, 1833680895, 'DE', 'DEU', 'ألمانيا'),
(33086, 1833680896, 1833684991, 'UA', 'UKR', 'أوكرانيا'),
(33087, 1833684992, 1833689087, 'DE', 'DEU', 'ألمانيا'),
(33088, 1833689088, 1833693183, 'FI', 'FIN', 'فنلندا'),
(33089, 1833693184, 1833697279, 'RU', 'RUS', 'الإتحاد الروسي'),
(33090, 1833697280, 1833959423, 'IE', 'IRL', 'إيرلندا'),
(33091, 1833959424, 1834090495, 'CZ', 'CZE', 'التشيك'),
(33092, 1834090496, 1834221567, 'SA', 'SAU', 'السعودية'),
(33093, 1834221568, 1834352639, 'DE', 'DEU', 'ألمانيا'),
(33094, 1834352640, 1834483711, 'UA', 'UKR', 'أوكرانيا'),
(33095, 1834483712, 1834614783, 'BE', 'BEL', 'بلجيكا'),
(33096, 1834614784, 1834745855, 'DE', 'DEU', 'ألمانيا'),
(33097, 1834745856, 1834876927, 'RS', 'SRB', 'صربيا'),
(33098, 1834876928, 1834885119, 'RU', 'RUS', 'الإتحاد الروسي'),
(33099, 1834885120, 1834893311, 'FR', 'FRA', 'فرنسا'),
(33100, 1834893312, 1834901503, 'RU', 'RUS', 'الإتحاد الروسي'),
(33101, 1834901504, 1834909695, 'RS', 'SRB', 'صربيا'),
(33102, 1834909696, 1834913791, 'GB', 'GBR', 'المملكة المتحدة'),
(33103, 1834913792, 1834917887, 'RO', 'ROM', 'رومانيا'),
(33104, 1834917888, 1834921983, 'UA', 'UKR', 'أوكرانيا'),
(33105, 1834921984, 1834930175, 'RU', 'RUS', 'الإتحاد الروسي'),
(33106, 1834930176, 1834934271, 'UA', 'UKR', 'أوكرانيا'),
(33107, 1834934272, 1834938367, 'RS', 'SRB', 'صربيا'),
(33108, 1834938368, 1834944511, 'PL', 'POL', 'بولندا'),
(33109, 1834944512, 1834946559, 'RO', 'ROM', 'رومانيا'),
(33110, 1834946560, 1834948607, 'RU', 'RUS', 'الإتحاد الروسي'),
(33111, 1834948608, 1834950655, 'PL', 'POL', 'بولندا'),
(33112, 1834950656, 1834956799, 'UA', 'UKR', 'أوكرانيا'),
(33113, 1834956800, 1834960895, 'IR', 'IRN', 'إيران'),
(33114, 1834960896, 1834964991, 'RU', 'RUS', 'الإتحاد الروسي'),
(33115, 1834964992, 1834967039, 'PL', 'POL', 'بولندا'),
(33116, 1834967040, 1834971135, 'RU', 'RUS', 'الإتحاد الروسي'),
(33117, 1834971136, 1834973183, 'KZ', 'KAZ', 'كازاخستان'),
(33118, 1834973184, 1834975231, 'RU', 'RUS', 'الإتحاد الروسي'),
(33119, 1834975232, 1834977279, 'IL', 'ISR', 'إسرائيل'),
(33120, 1834977280, 1834983423, 'PL', 'POL', 'بولندا'),
(33121, 1834983424, 1834985471, 'RU', 'RUS', 'الإتحاد الروسي'),
(33122, 1834985472, 1834989567, 'PL', 'POL', 'بولندا'),
(33123, 1834989568, 1834991615, 'GB', 'GBR', 'المملكة المتحدة'),
(33124, 1834991616, 1834993663, 'RU', 'RUS', 'الإتحاد الروسي'),
(33125, 1834993664, 1834995711, 'PL', 'POL', 'بولندا'),
(33126, 1834995712, 1835001855, 'RU', 'RUS', 'الإتحاد الروسي'),
(33127, 1835001856, 1835003903, 'PL', 'POL', 'بولندا'),
(33128, 1835003904, 1835005951, 'CH', 'CHE', 'سويسرا'),
(33129, 1835005952, 1835007999, 'RU', 'RUS', 'الإتحاد الروسي'),
(33130, 1835008000, 1835532287, 'RO', 'ROM', 'رومانيا'),
(33131, 1835532288, 1835540479, 'SE', 'SWE', 'السويد'),
(33132, 1835540480, 1835548671, 'DE', 'DEU', 'ألمانيا'),
(33133, 1835548672, 1835549695, 'GB', 'GBR', 'المملكة المتحدة'),
(33134, 1835549696, 1835550207, 'ES', 'ESP', 'إسبانيا'),
(33135, 1835550208, 1835565055, 'GB', 'GBR', 'المملكة المتحدة'),
(33136, 1835565056, 1835573247, 'AL', 'ALB', 'ألبانيا'),
(33137, 1835573248, 1835581439, 'UA', 'UKR', 'أوكرانيا'),
(33138, 1835581440, 1835589631, 'BG', 'BGR', 'بلغاريا'),
(33139, 1835589632, 1835597823, 'IT', 'ITA', 'إيطاليا'),
(33140, 1835597824, 1835606015, 'HU', 'HUN', 'هنغاريا'),
(33141, 1835606016, 1835614207, 'CZ', 'CZE', 'التشيك'),
(33142, 1835614208, 1835622399, 'RU', 'RUS', 'الإتحاد الروسي'),
(33143, 1835622400, 1835624959, 'SE', 'SWE', 'السويد'),
(33144, 1835624960, 1835625215, 'DK', 'DNK', 'الدنيمارك'),
(33145, 1835625216, 1835625471, 'SE', 'SWE', 'السويد'),
(33146, 1835625472, 1835625599, 'DK', 'DNK', 'الدنيمارك'),
(33147, 1835625600, 1835626239, 'SE', 'SWE', 'السويد'),
(33148, 1835626240, 1835626495, 'DK', 'DNK', 'الدنيمارك'),
(33149, 1835626496, 1835626751, 'SE', 'SWE', 'السويد'),
(33150, 1835626752, 1835627007, 'DK', 'DNK', 'الدنيمارك'),
(33151, 1835627008, 1835627519, 'SE', 'SWE', 'السويد'),
(33152, 1835627520, 1835627647, 'DK', 'DNK', 'الدنيمارك'),
(33153, 1835627648, 1835629567, 'SE', 'SWE', 'السويد'),
(33154, 1835629568, 1835630335, 'DK', 'DNK', 'الدنيمارك'),
(33155, 1835630336, 1835630591, 'SE', 'SWE', 'السويد'),
(33156, 1835630592, 1835646975, 'RU', 'RUS', 'الإتحاد الروسي'),
(33157, 1835646976, 1835655167, 'BA', 'BIH', 'البوسنه والهرسك'),
(33158, 1835655168, 1835663359, 'CY', 'CYP', 'قبرص'),
(33159, 1835663360, 1835671551, 'UA', 'UKR', 'أوكرانيا'),
(33160, 1835671552, 1835679743, 'LV', 'LVA', 'لاتفيا'),
(33161, 1835679744, 1835687935, 'FR', 'FRA', 'فرنسا'),
(33162, 1835687936, 1835696127, 'IE', 'IRL', 'إيرلندا'),
(33163, 1835696128, 1835704319, 'RU', 'RUS', 'الإتحاد الروسي'),
(33164, 1835704320, 1835709439, 'NL', 'NLD', 'هولندا'),
(33165, 1835712512, 1835720703, 'RU', 'RUS', 'الإتحاد الروسي'),
(33166, 1835720704, 1835728895, 'RS', 'SRB', 'صربيا'),
(33167, 1835728896, 1835737087, 'PL', 'POL', 'بولندا'),
(33168, 1835745280, 1835753471, 'BG', 'BGR', 'بلغاريا'),
(33169, 1835753472, 1835761663, 'ES', 'ESP', 'إسبانيا'),
(33170, 1835761664, 1835769855, 'JO', 'JOR', 'الأردن'),
(33171, 1835769856, 1835778047, 'RU', 'RUS', 'الإتحاد الروسي'),
(33172, 1835778048, 1835786239, 'CZ', 'CZE', 'التشيك'),
(33173, 1835786240, 1835794431, 'JO', 'JOR', 'الأردن'),
(33174, 1835794432, 1835802623, 'FI', 'FIN', 'فنلندا'),
(33175, 1835802624, 1835810815, 'RU', 'RUS', 'الإتحاد الروسي'),
(33176, 1835810816, 1835819007, 'UA', 'UKR', 'أوكرانيا'),
(33177, 1835819008, 1835827199, 'CZ', 'CZE', 'التشيك'),
(33178, 1835827200, 1835835391, 'GB', 'GBR', 'المملكة المتحدة'),
(33179, 1835835392, 1835843583, 'ES', 'ESP', 'إسبانيا'),
(33180, 1835843584, 1835851775, 'NO', 'NOR', 'النرويج'),
(33181, 1835851776, 1835859967, 'UA', 'UKR', 'أوكرانيا'),
(33182, 1835859968, 1835868159, 'DE', 'DEU', 'ألمانيا'),
(33183, 1835868160, 1835876351, 'IR', 'IRN', 'إيران'),
(33184, 1835876352, 1835884543, 'NO', 'NOR', 'النرويج'),
(33185, 1835884544, 1835892735, 'NL', 'NLD', 'هولندا'),
(33186, 1835892736, 1835909119, 'GB', 'GBR', 'المملكة المتحدة'),
(33187, 1835909120, 1835913215, 'RS', 'SRB', 'صربيا'),
(33188, 1835913216, 1835917311, 'RU', 'RUS', 'الإتحاد الروسي'),
(33189, 1835917312, 1835925503, 'GB', 'GBR', 'المملكة المتحدة'),
(33190, 1835925504, 1835933695, 'LV', 'LVA', 'لاتفيا'),
(33191, 1835933696, 1835941887, 'RU', 'RUS', 'الإتحاد الروسي'),
(33192, 1835941888, 1835950079, 'UA', 'UKR', 'أوكرانيا'),
(33193, 1835950080, 1835958271, 'LB', 'LBN', 'لبنان'),
(33194, 1835958272, 1835966463, 'HU', 'HUN', 'هنغاريا'),
(33195, 1835966464, 1835974655, 'IR', 'IRN', 'إيران'),
(33196, 1835974656, 1835982847, 'PL', 'POL', 'بولندا'),
(33197, 1835982848, 1835991039, 'CY', 'CYP', 'قبرص'),
(33198, 1835991040, 1835999231, 'RU', 'RUS', 'الإتحاد الروسي'),
(33199, 1835999232, 1836007423, 'IR', 'IRN', 'إيران'),
(33200, 1836007424, 1836015615, 'RU', 'RUS', 'الإتحاد الروسي'),
(33201, 1836015616, 1836023807, 'AD', 'AND', 'أندورا'),
(33202, 1836023808, 1836040191, 'RU', 'RUS', 'الإتحاد الروسي'),
(33203, 1836040192, 1836048383, 'GB', 'GBR', 'المملكة المتحدة'),
(33204, 1836048384, 1836056575, 'RS', 'SRB', 'صربيا'),
(33205, 1836056576, 1836580863, 'IT', 'ITA', 'إيطاليا'),
(33206, 1836580864, 1836597247, 'RU', 'RUS', 'الإتحاد الروسي'),
(33207, 1836597248, 1836597759, 'LU', 'LUX', 'لوكسيمبورغ'),
(33208, 1836597760, 1836601599, 'DE', 'DEU', 'ألمانيا'),
(33209, 1836601600, 1836613631, 'LU', 'LUX', 'لوكسيمبورغ'),
(33210, 1836613632, 1836630015, 'RU', 'RUS', 'الإتحاد الروسي'),
(33211, 1836630016, 1836646399, 'BG', 'BGR', 'بلغاريا'),
(33212, 1836646400, 1836670975, 'RS', 'SRB', 'صربيا'),
(33213, 1836670976, 1836679167, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(33214, 1836679168, 1836711935, 'BG', 'BGR', 'بلغاريا'),
(33215, 1836711936, 1836728319, 'UA', 'UKR', 'أوكرانيا'),
(33216, 1836728320, 1836744703, 'RS', 'SRB', 'صربيا'),
(33217, 1836744704, 1836761087, 'FR', 'FRA', 'فرنسا'),
(33218, 1836761088, 1836777471, 'IR', 'IRN', 'إيران'),
(33219, 1836777472, 1836793855, 'SI', 'SVN', 'سلوفينيا'),
(33220, 1836793856, 1836810239, 'GB', 'GBR', 'المملكة المتحدة'),
(33221, 1836810240, 1836826623, 'RU', 'RUS', 'الإتحاد الروسي'),
(33222, 1836826624, 1836843007, 'CZ', 'CZE', 'التشيك'),
(33223, 1836843008, 1836875775, 'RU', 'RUS', 'الإتحاد الروسي'),
(33224, 1836875776, 1836892159, 'SE', 'SWE', 'السويد'),
(33225, 1836892160, 1836908543, 'RU', 'RUS', 'الإتحاد الروسي'),
(33226, 1836908544, 1836924927, 'IE', 'IRL', 'إيرلندا'),
(33227, 1836941312, 1836957695, 'IR', 'IRN', 'إيران'),
(33228, 1836957696, 1836974079, 'PL', 'POL', 'بولندا'),
(33229, 1836974080, 1836990463, 'RU', 'RUS', 'الإتحاد الروسي'),
(33230, 1836990464, 1837006847, 'AT', 'AUT', 'النمسا'),
(33231, 1837006848, 1837023231, 'BY', 'BLR', 'روسيا البيضاء'),
(33232, 1837023232, 1837039615, 'RU', 'RUS', 'الإتحاد الروسي'),
(33233, 1837039616, 1837055999, 'AZ', 'AZE', 'أذربيجان'),
(33234, 1837056000, 1837072383, 'IQ', 'IRQ', 'العراق'),
(33235, 1837072384, 1837088767, 'RU', 'RUS', 'الإتحاد الروسي'),
(33236, 1837088768, 1837105151, 'SI', 'SVN', 'سلوفينيا'),
(33237, 1837105152, 1838153727, 'BE', 'BEL', 'بلجيكا'),
(33238, 1838153728, 1839202303, 'GB', 'GBR', 'المملكة المتحدة'),
(33239, 1839202304, 1839235071, 'BG', 'BGR', 'بلغاريا'),
(33240, 1839235072, 1839267839, 'IL', 'ISR', 'إسرائيل'),
(33241, 1839267840, 1839300607, 'RU', 'RUS', 'الإتحاد الروسي'),
(33242, 1839300608, 1839333375, 'BH', 'BHR', 'البحرين'),
(33243, 1839333376, 1839366143, 'UA', 'UKR', 'أوكرانيا'),
(33244, 1839366144, 1839398911, 'IR', 'IRN', 'إيران'),
(33245, 1839398912, 1839431679, 'NO', 'NOR', 'النرويج'),
(33246, 1839431680, 1839464447, 'RU', 'RUS', 'الإتحاد الروسي'),
(33247, 1839464448, 1839497215, 'CZ', 'CZE', 'التشيك'),
(33248, 1839497216, 1839529983, 'CH', 'CHE', 'سويسرا'),
(33249, 1839529984, 1839562751, 'RU', 'RUS', 'الإتحاد الروسي'),
(33250, 1839562752, 1839595519, 'BA', 'BIH', 'البوسنه والهرسك'),
(33251, 1839595520, 1839661055, 'RO', 'ROM', 'رومانيا'),
(33252, 1839661056, 1839693823, 'UA', 'UKR', 'أوكرانيا'),
(33253, 1839693824, 1839726591, 'RU', 'RUS', 'الإتحاد الروسي'),
(33254, 1839726592, 1839759359, 'IT', 'ITA', 'إيطاليا'),
(33255, 1839759360, 1839792127, 'RU', 'RUS', 'الإتحاد الروسي'),
(33256, 1839792128, 1839794687, 'GB', 'GBR', 'المملكة المتحدة'),
(33257, 1839794688, 1839794943, 'US', 'USA', 'الولايات المتحدة'),
(33258, 1839794944, 1839795071, 'GB', 'GBR', 'المملكة المتحدة'),
(33259, 1839795072, 1839795087, 'US', 'USA', 'الولايات المتحدة'),
(33260, 1839795088, 1839795151, 'GB', 'GBR', 'المملكة المتحدة'),
(33261, 1839795152, 1839795167, 'US', 'USA', 'الولايات المتحدة'),
(33262, 1839795168, 1839796607, 'GB', 'GBR', 'المملكة المتحدة'),
(33263, 1839796608, 1839796671, 'US', 'USA', 'الولايات المتحدة'),
(33264, 1839796672, 1839796735, 'GB', 'GBR', 'المملكة المتحدة'),
(33265, 1839796736, 1839796991, 'TR', 'TUR', 'تركيا'),
(33266, 1839796992, 1839797759, 'GB', 'GBR', 'المملكة المتحدة'),
(33267, 1839797760, 1839798015, 'GR', 'GRC', 'اليونان'),
(33268, 1839798016, 1839798527, 'GB', 'GBR', 'المملكة المتحدة'),
(33269, 1839798528, 1839798559, 'US', 'USA', 'الولايات المتحدة'),
(33270, 1839798560, 1839800447, 'GB', 'GBR', 'المملكة المتحدة'),
(33271, 1839800448, 1839800479, 'SG', 'SGP', 'سنغافورة'),
(33272, 1839800480, 1839800895, 'GB', 'GBR', 'المملكة المتحدة'),
(33273, 1839800896, 1839800959, 'CY', 'CYP', 'قبرص'),
(33274, 1839800960, 1839800991, 'GR', 'GRC', 'اليونان'),
(33275, 1839800992, 1839816703, 'GB', 'GBR', 'المملكة المتحدة'),
(33276, 1839824896, 1839890431, 'RU', 'RUS', 'الإتحاد الروسي'),
(33277, 1839890432, 1839923199, 'GB', 'GBR', 'المملكة المتحدة'),
(33278, 1839923200, 1839955967, 'RU', 'RUS', 'الإتحاد الروسي'),
(33279, 1839955968, 1839988735, 'SA', 'SAU', 'السعودية'),
(33280, 1839988736, 1840021503, 'RU', 'RUS', 'الإتحاد الروسي'),
(33281, 1840021504, 1840054271, 'GE', 'GEO', 'جورجيا'),
(33282, 1840054272, 1840087039, 'RU', 'RUS', 'الإتحاد الروسي'),
(33283, 1840087040, 1840119807, 'PL', 'POL', 'بولندا'),
(33284, 1840119808, 1840152575, 'RU', 'RUS', 'الإتحاد الروسي'),
(33285, 1840152576, 1840185343, 'GB', 'GBR', 'المملكة المتحدة'),
(33286, 1840185344, 1840218111, 'BA', 'BIH', 'البوسنه والهرسك'),
(33287, 1840250880, 1840316415, 'GB', 'GBR', 'المملكة المتحدة'),
(33288, 1840316416, 1840381951, 'RU', 'RUS', 'الإتحاد الروسي'),
(33289, 1840381952, 1840447487, 'GR', 'GRC', 'اليونان'),
(33290, 1840447488, 1840513023, 'NO', 'NOR', 'النرويج'),
(33291, 1840513024, 1840644095, 'GB', 'GBR', 'المملكة المتحدة'),
(33292, 1840644096, 1840709631, 'SI', 'SVN', 'سلوفينيا'),
(33293, 1840709632, 1840775167, 'CZ', 'CZE', 'التشيك'),
(33294, 1840775168, 1840840703, 'RU', 'RUS', 'الإتحاد الروسي'),
(33295, 1840840704, 1840906239, 'MD', 'MDA', 'مولدوفا'),
(33296, 1840906240, 1840971775, 'IL', 'ISR', 'إسرائيل'),
(33297, 1840971776, 1841102847, 'RU', 'RUS', 'الإتحاد الروسي'),
(33298, 1841102848, 1841168383, 'NO', 'NOR', 'النرويج'),
(33299, 1841168384, 1841299455, 'RU', 'RUS', 'الإتحاد الروسي'),
(33300, 1841299456, 1841430527, 'DE', 'DEU', 'ألمانيا'),
(33301, 1841430528, 1841561599, 'RU', 'RUS', 'الإتحاد الروسي'),
(33302, 1841561600, 1841565695, 'PL', 'POL', 'بولندا'),
(33303, 1841565696, 1841569791, 'RU', 'RUS', 'الإتحاد الروسي'),
(33304, 1841569792, 1841577983, 'PL', 'POL', 'بولندا'),
(33305, 1841577984, 1841582079, 'RU', 'RUS', 'الإتحاد الروسي'),
(33306, 1841582080, 1841586175, 'PL', 'POL', 'بولندا'),
(33307, 1841586176, 1841590271, 'RU', 'RUS', 'الإتحاد الروسي'),
(33308, 1841590272, 1841594367, 'PL', 'POL', 'بولندا'),
(33309, 1841594368, 1841598463, 'RU', 'RUS', 'الإتحاد الروسي'),
(33310, 1841598464, 1841602559, 'PL', 'POL', 'بولندا'),
(33311, 1841602560, 1841610751, 'UA', 'UKR', 'أوكرانيا'),
(33312, 1841610752, 1841618943, 'RU', 'RUS', 'الإتحاد الروسي'),
(33313, 1841618944, 1841627135, 'PL', 'POL', 'بولندا'),
(33314, 1841627136, 1841629183, 'NO', 'NOR', 'النرويج'),
(33315, 1841629184, 1841635327, 'RU', 'RUS', 'الإتحاد الروسي'),
(33316, 1841635328, 1841639423, 'PL', 'POL', 'بولندا'),
(33317, 1841639424, 1841641471, 'RU', 'RUS', 'الإتحاد الروسي'),
(33318, 1841641472, 1841643519, 'PL', 'POL', 'بولندا'),
(33319, 1841643520, 1841645567, 'SI', 'SVN', 'سلوفينيا'),
(33320, 1841645568, 1841647615, 'RU', 'RUS', 'الإتحاد الروسي'),
(33321, 1841647616, 1841649663, 'RO', 'ROM', 'رومانيا'),
(33322, 1841649664, 1841651711, 'RU', 'RUS', 'الإتحاد الروسي'),
(33323, 1841651712, 1841653759, 'PL', 'POL', 'بولندا'),
(33324, 1841653760, 1841655807, 'FR', 'FRA', 'فرنسا'),
(33325, 1841655808, 1841668095, 'RU', 'RUS', 'الإتحاد الروسي'),
(33326, 1841670144, 1841672191, 'PL', 'POL', 'بولندا'),
(33327, 1841672192, 1841674239, 'FR', 'FRA', 'فرنسا'),
(33328, 1841674240, 1841676287, 'PL', 'POL', 'بولندا'),
(33329, 1841676288, 1841680383, 'RU', 'RUS', 'الإتحاد الروسي'),
(33330, 1841680384, 1841682431, 'LV', 'LVA', 'لاتفيا'),
(33331, 1841682432, 1841684479, 'UA', 'UKR', 'أوكرانيا'),
(33332, 1841684480, 1841686527, 'RU', 'RUS', 'الإتحاد الروسي'),
(33333, 1841686528, 1841688575, 'RO', 'ROM', 'رومانيا'),
(33334, 1841688576, 1841690623, 'FR', 'FRA', 'فرنسا'),
(33335, 1841690624, 1841692671, 'RU', 'RUS', 'الإتحاد الروسي'),
(33336, 1841692672, 1841694719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(33337, 1841694720, 1841700863, 'RS', 'SRB', 'صربيا'),
(33338, 1841700864, 1841709055, 'MD', 'MDA', 'مولدوفا'),
(33339, 1841709056, 1841725439, 'RU', 'RUS', 'الإتحاد الروسي'),
(33340, 1841725440, 1841733631, 'DK', 'DNK', 'الدنيمارك'),
(33341, 1841733632, 1841758207, 'RU', 'RUS', 'الإتحاد الروسي'),
(33342, 1841758208, 1841766399, 'PL', 'POL', 'بولندا'),
(33343, 1841766400, 1841774591, 'HU', 'HUN', 'هنغاريا'),
(33344, 1841774592, 1841782783, 'PL', 'POL', 'بولندا'),
(33345, 1841782784, 1841790975, 'RO', 'ROM', 'رومانيا'),
(33346, 1841790976, 1841799167, 'BG', 'BGR', 'بلغاريا'),
(33347, 1841799168, 1841807359, 'DE', 'DEU', 'ألمانيا'),
(33348, 1841807360, 1841815551, 'NO', 'NOR', 'النرويج'),
(33349, 1841815552, 1841823743, 'BG', 'BGR', 'بلغاريا'),
(33350, 1841823744, 1841831935, 'GB', 'GBR', 'المملكة المتحدة'),
(33351, 1841831936, 1841840127, 'MT', 'MLT', 'مالطا'),
(33352, 1841840128, 1841848319, 'PL', 'POL', 'بولندا'),
(33353, 1841848320, 1841856511, 'RU', 'RUS', 'الإتحاد الروسي'),
(33354, 1841856512, 1841864703, 'UA', 'UKR', 'أوكرانيا'),
(33355, 1841864704, 1841872895, 'YE', 'YEM', 'اليمن'),
(33356, 1841872896, 1841881087, 'NL', 'NLD', 'هولندا'),
(33357, 1841881088, 1841889279, 'UA', 'UKR', 'أوكرانيا'),
(33358, 1841889280, 1841897471, 'IR', 'IRN', 'إيران'),
(33359, 1841897472, 1841905663, 'RO', 'ROM', 'رومانيا'),
(33360, 1841905664, 1841922047, 'RU', 'RUS', 'الإتحاد الروسي'),
(33361, 1841922048, 1841930239, 'NL', 'NLD', 'هولندا'),
(33362, 1841930240, 1841938431, 'KG', 'KGZ', 'قيرغيزستان'),
(33363, 1841938432, 1841946623, 'RU', 'RUS', 'الإتحاد الروسي'),
(33364, 1841946624, 1841954815, 'UA', 'UKR', 'أوكرانيا'),
(33365, 1841954816, 1841971199, 'RU', 'RUS', 'الإتحاد الروسي'),
(33366, 1841971200, 1841979391, 'CZ', 'CZE', 'التشيك'),
(33367, 1841979392, 1841987583, 'NL', 'NLD', 'هولندا'),
(33368, 1841987584, 1841995775, 'DK', 'DNK', 'الدنيمارك'),
(33369, 1841995776, 1842003967, 'RU', 'RUS', 'الإتحاد الروسي'),
(33370, 1842003968, 1842012159, 'CH', 'CHE', 'سويسرا'),
(33371, 1842012160, 1842020351, 'GB', 'GBR', 'المملكة المتحدة'),
(33372, 1842020352, 1842028543, 'NO', 'NOR', 'النرويج'),
(33373, 1842028544, 1842036735, 'CH', 'CHE', 'سويسرا'),
(33374, 1842036736, 1842038783, 'FR', 'FRA', 'فرنسا'),
(33375, 1842038784, 1842044927, 'LU', 'LUX', 'لوكسيمبورغ'),
(33376, 1842044928, 1842053119, 'GB', 'GBR', 'المملكة المتحدة'),
(33377, 1842053120, 1842061311, 'ES', 'ESP', 'إسبانيا'),
(33378, 1842061312, 1842069503, 'IR', 'IRN', 'إيران'),
(33379, 1842069504, 1842077695, 'RU', 'RUS', 'الإتحاد الروسي'),
(33380, 1842077696, 1842079743, 'FR', 'FRA', 'فرنسا'),
(33381, 1842079744, 1842085887, 'MQ', 'MTQ', 'مارتينيك'),
(33382, 1842085888, 1842118655, 'GB', 'GBR', 'المملكة المتحدة'),
(33383, 1842118656, 1842151423, 'FI', 'FIN', 'فنلندا'),
(33384, 1842151424, 1842153471, 'FR', 'FRA', 'فرنسا'),
(33385, 1842153472, 1842155519, 'NO', 'NOR', 'النرويج'),
(33386, 1842155520, 1842157567, 'IT', 'ITA', 'إيطاليا'),
(33387, 1842157568, 1842159615, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(33388, 1842159616, 1842161663, 'BA', 'BIH', 'البوسنه والهرسك'),
(33389, 1842161664, 1842163711, 'GE', 'GEO', 'جورجيا'),
(33390, 1842163712, 1842165759, 'PL', 'POL', 'بولندا'),
(33391, 1842165760, 1842167807, 'RU', 'RUS', 'الإتحاد الروسي'),
(33392, 1842167808, 1842169855, 'FR', 'FRA', 'فرنسا'),
(33393, 1842169856, 1842171903, 'CZ', 'CZE', 'التشيك'),
(33394, 1842171904, 1842173951, 'RU', 'RUS', 'الإتحاد الروسي'),
(33395, 1842173952, 1842175999, 'RO', 'ROM', 'رومانيا'),
(33396, 1842176000, 1842178047, 'FI', 'FIN', 'فنلندا'),
(33397, 1842178048, 1842180095, 'IT', 'ITA', 'إيطاليا'),
(33398, 1842180096, 1842182143, 'IQ', 'IRQ', 'العراق'),
(33399, 1842182144, 1842184191, 'LV', 'LVA', 'لاتفيا'),
(33400, 1842184192, 1842186239, 'DE', 'DEU', 'ألمانيا'),
(33401, 1842186240, 1842188287, 'ES', 'ESP', 'إسبانيا'),
(33402, 1842188288, 1842190335, 'RU', 'RUS', 'الإتحاد الروسي'),
(33403, 1842190336, 1842192383, 'GB', 'GBR', 'المملكة المتحدة'),
(33404, 1842192384, 1842194431, 'AZ', 'AZE', 'أذربيجان'),
(33405, 1842194432, 1842196479, 'CH', 'CHE', 'سويسرا'),
(33406, 1842196480, 1842198527, 'DE', 'DEU', 'ألمانيا'),
(33407, 1842198528, 1842200575, 'GB', 'GBR', 'المملكة المتحدة'),
(33408, 1842200576, 1842202623, 'NL', 'NLD', 'هولندا'),
(33409, 1842202624, 1842204671, 'CH', 'CHE', 'سويسرا'),
(33410, 1842204672, 1842206719, 'AZ', 'AZE', 'أذربيجان'),
(33411, 1842206720, 1842208767, 'SE', 'SWE', 'السويد'),
(33412, 1842208768, 1842210815, 'GB', 'GBR', 'المملكة المتحدة'),
(33413, 1842210816, 1842212863, 'LT', 'LTU', 'ليتوانيا'),
(33414, 1842212864, 1842214911, 'CZ', 'CZE', 'التشيك'),
(33415, 1842214912, 1842216959, 'RU', 'RUS', 'الإتحاد الروسي'),
(33416, 1842216960, 1842225151, 'RO', 'ROM', 'رومانيا'),
(33417, 1842225152, 1842233343, 'UA', 'UKR', 'أوكرانيا'),
(33418, 1842233344, 1842241535, 'RO', 'ROM', 'رومانيا'),
(33419, 1842241536, 1842249727, 'RS', 'SRB', 'صربيا'),
(33420, 1842249728, 1842257919, 'RU', 'RUS', 'الإتحاد الروسي'),
(33421, 1842266112, 1842274303, 'PL', 'POL', 'بولندا'),
(33422, 1842274304, 1842282495, 'RO', 'ROM', 'رومانيا'),
(33423, 1842282496, 1842286591, 'RU', 'RUS', 'الإتحاد الروسي'),
(33424, 1842286592, 1842290687, 'GB', 'GBR', 'المملكة المتحدة'),
(33425, 1842290688, 1842294783, 'RS', 'SRB', 'صربيا'),
(33426, 1842294784, 1842298879, 'PL', 'POL', 'بولندا'),
(33427, 1842298880, 1842302975, 'UA', 'UKR', 'أوكرانيا'),
(33428, 1842302976, 1842307071, 'RU', 'RUS', 'الإتحاد الروسي'),
(33429, 1842307072, 1842311167, 'PL', 'POL', 'بولندا'),
(33430, 1842311168, 1842315263, 'UA', 'UKR', 'أوكرانيا'),
(33431, 1842315264, 1842319359, 'RO', 'ROM', 'رومانيا'),
(33432, 1842319360, 1842323455, 'PL', 'POL', 'بولندا'),
(33433, 1842323456, 1842331647, 'RU', 'RUS', 'الإتحاد الروسي'),
(33434, 1842331648, 1842335743, 'UA', 'UKR', 'أوكرانيا'),
(33435, 1842335744, 1842339839, 'RO', 'ROM', 'رومانيا'),
(33436, 1842339840, 1842348031, 'RU', 'RUS', 'الإتحاد الروسي'),
(33437, 1842348032, 1843396607, 'FR', 'FRA', 'فرنسا'),
(33438, 1843396608, 1843412991, 'IQ', 'IRQ', 'العراق'),
(33439, 1843412992, 1843429375, 'CZ', 'CZE', 'التشيك'),
(33440, 1843429376, 1843462143, 'GB', 'GBR', 'المملكة المتحدة'),
(33441, 1843462144, 1843478527, 'RU', 'RUS', 'الإتحاد الروسي'),
(33442, 1843478528, 1843494911, 'SE', 'SWE', 'السويد'),
(33443, 1843494912, 1843511295, 'IR', 'IRN', 'إيران'),
(33444, 1843511296, 1843527679, 'RU', 'RUS', 'الإتحاد الروسي'),
(33445, 1843527680, 1843544063, 'IL', 'ISR', 'إسرائيل'),
(33446, 1843544064, 1843560447, 'RU', 'RUS', 'الإتحاد الروسي'),
(33447, 1843560448, 1843576831, 'DE', 'DEU', 'ألمانيا'),
(33448, 1843576832, 1843593215, 'RU', 'RUS', 'الإتحاد الروسي'),
(33449, 1843593216, 1843609599, 'HR', 'HRV', 'كرواتيا'),
(33450, 1843609600, 1843625983, 'UA', 'UKR', 'أوكرانيا'),
(33451, 1843625984, 1843642367, 'ES', 'ESP', 'إسبانيا'),
(33452, 1843642368, 1843658751, 'RU', 'RUS', 'الإتحاد الروسي'),
(33453, 1843658752, 1843675135, 'GB', 'GBR', 'المملكة المتحدة'),
(33454, 1843675136, 1843691519, 'ME', 'MNE', 'الجبل الأسود'),
(33455, 1843691520, 1843707903, 'SE', 'SWE', 'السويد'),
(33456, 1843707904, 1843724287, 'TR', 'TUR', 'تركيا'),
(33457, 1843724288, 1843732479, 'UA', 'UKR', 'أوكرانيا'),
(33458, 1843789824, 1843806207, 'SK', 'SVK', 'سلوفاكيا'),
(33459, 1843806208, 1843822591, 'IR', 'IRN', 'إيران'),
(33460, 1843822592, 1843838975, 'RU', 'RUS', 'الإتحاد الروسي'),
(33461, 1843838976, 1843855359, 'DE', 'DEU', 'ألمانيا'),
(33462, 1843855360, 1843871743, 'PL', 'POL', 'بولندا'),
(33463, 1843871744, 1843888127, 'GB', 'GBR', 'المملكة المتحدة'),
(33464, 1843888128, 1843904511, 'CZ', 'CZE', 'التشيك'),
(33465, 1843904512, 1843920895, 'GB', 'GBR', 'المملكة المتحدة'),
(33466, 1843920896, 1843922943, 'KZ', 'KAZ', 'كازاخستان'),
(33467, 1843922944, 1843924991, 'NL', 'NLD', 'هولندا'),
(33468, 1843924992, 1843927039, 'ES', 'ESP', 'إسبانيا'),
(33469, 1843927040, 1843929087, 'PL', 'POL', 'بولندا'),
(33470, 1843929088, 1843931135, 'IT', 'ITA', 'إيطاليا'),
(33471, 1843931136, 1843933183, 'NL', 'NLD', 'هولندا'),
(33472, 1843933184, 1843935231, 'IT', 'ITA', 'إيطاليا'),
(33473, 1843935232, 1843937279, 'GB', 'GBR', 'المملكة المتحدة'),
(33474, 1843937280, 1843939327, 'ES', 'ESP', 'إسبانيا'),
(33475, 1843939328, 1843941375, 'DK', 'DNK', 'الدنيمارك'),
(33476, 1843941376, 1843943423, 'FI', 'FIN', 'فنلندا'),
(33477, 1843943424, 1843945471, 'CH', 'CHE', 'سويسرا'),
(33478, 1843945472, 1843947519, 'FR', 'FRA', 'فرنسا'),
(33479, 1843947520, 1843949567, 'RU', 'RUS', 'الإتحاد الروسي'),
(33480, 1843949568, 1843951615, 'BY', 'BLR', 'روسيا البيضاء'),
(33481, 1843953664, 1843955711, 'DE', 'DEU', 'ألمانيا'),
(33482, 1843955712, 1843957759, 'IT', 'ITA', 'إيطاليا'),
(33483, 1843957760, 1843959807, 'CZ', 'CZE', 'التشيك'),
(33484, 1843959808, 1843961855, 'GB', 'GBR', 'المملكة المتحدة'),
(33485, 1843961856, 1843965951, 'DE', 'DEU', 'ألمانيا'),
(33486, 1843965952, 1843967999, 'GB', 'GBR', 'المملكة المتحدة'),
(33487, 1843968000, 1843970047, 'RU', 'RUS', 'الإتحاد الروسي'),
(33488, 1843970048, 1843972095, 'FR', 'FRA', 'فرنسا'),
(33489, 1843972096, 1843974143, 'HU', 'HUN', 'هنغاريا'),
(33490, 1843974144, 1843976191, 'ES', 'ESP', 'إسبانيا'),
(33491, 1843976192, 1843978239, 'TR', 'TUR', 'تركيا'),
(33492, 1843978240, 1843980287, 'NL', 'NLD', 'هولندا'),
(33493, 1843980288, 1843982335, 'FR', 'FRA', 'فرنسا'),
(33494, 1843982336, 1843984383, 'PL', 'POL', 'بولندا'),
(33495, 1843984384, 1843985407, 'RU', 'RUS', 'الإتحاد الروسي'),
(33496, 1843985408, 1843985663, 'UA', 'UKR', 'أوكرانيا'),
(33497, 1843985664, 1843986431, 'RU', 'RUS', 'الإتحاد الروسي'),
(33498, 1843986432, 1843988479, 'NO', 'NOR', 'النرويج'),
(33499, 1843988480, 1843990527, 'GB', 'GBR', 'المملكة المتحدة'),
(33500, 1843990528, 1843992575, 'LB', 'LBN', 'لبنان'),
(33501, 1843992576, 1843994623, 'AT', 'AUT', 'النمسا'),
(33502, 1843994624, 1844000767, 'GB', 'GBR', 'المملكة المتحدة'),
(33503, 1844000768, 1844002047, 'NL', 'NLD', 'هولندا'),
(33504, 1844002048, 1844002815, 'NO', 'NOR', 'النرويج'),
(33505, 1844002816, 1844006911, 'CZ', 'CZE', 'التشيك'),
(33506, 1844006912, 1844008959, 'SM', 'SMR', 'سان مارينو'),
(33507, 1844008960, 1844011007, 'PL', 'POL', 'بولندا'),
(33508, 1844011008, 1844013055, 'IT', 'ITA', 'إيطاليا'),
(33509, 1844013056, 1844015103, 'PL', 'POL', 'بولندا'),
(33510, 1844015104, 1844017151, 'GB', 'GBR', 'المملكة المتحدة'),
(33511, 1844017152, 1844019199, 'IT', 'ITA', 'إيطاليا'),
(33512, 1844019200, 1844021247, 'RU', 'RUS', 'الإتحاد الروسي'),
(33513, 1844021248, 1844027391, 'DE', 'DEU', 'ألمانيا'),
(33514, 1844027392, 1844029439, 'CZ', 'CZE', 'التشيك'),
(33515, 1844029440, 1844031487, 'RU', 'RUS', 'الإتحاد الروسي'),
(33516, 1844031744, 1844031999, 'CH', 'CHE', 'سويسرا'),
(33517, 1844032000, 1844032255, 'GB', 'GBR', 'المملكة المتحدة'),
(33518, 1844032256, 1844032511, 'CH', 'CHE', 'سويسرا'),
(33519, 1844033536, 1844035583, 'RS', 'SRB', 'صربيا'),
(33520, 1844035584, 1844037631, 'MD', 'MDA', 'مولدوفا'),
(33521, 1844037632, 1844041727, 'RU', 'RUS', 'الإتحاد الروسي'),
(33522, 1844041728, 1844043775, 'IT', 'ITA', 'إيطاليا'),
(33523, 1844043776, 1844047871, 'RU', 'RUS', 'الإتحاد الروسي'),
(33524, 1844047872, 1844049919, 'KZ', 'KAZ', 'كازاخستان'),
(33525, 1844049920, 1844051967, 'DE', 'DEU', 'ألمانيا'),
(33526, 1844051968, 1844054015, 'FR', 'FRA', 'فرنسا'),
(33527, 1844054016, 1844056063, 'RU', 'RUS', 'الإتحاد الروسي'),
(33528, 1844056064, 1844058111, 'IL', 'ISR', 'إسرائيل'),
(33529, 1844058112, 1844062207, 'RU', 'RUS', 'الإتحاد الروسي'),
(33530, 1844062208, 1844064255, 'CZ', 'CZE', 'التشيك'),
(33531, 1844064256, 1844068351, 'IT', 'ITA', 'إيطاليا'),
(33532, 1844068352, 1844072447, 'GB', 'GBR', 'المملكة المتحدة'),
(33533, 1844072448, 1844076543, 'ES', 'ESP', 'إسبانيا'),
(33534, 1844076544, 1844078591, 'IE', 'IRL', 'إيرلندا'),
(33535, 1844078592, 1844080639, 'DE', 'DEU', 'ألمانيا'),
(33536, 1844080640, 1844082687, 'GE', 'GEO', 'جورجيا'),
(33537, 1844082688, 1844084735, 'DE', 'DEU', 'ألمانيا'),
(33538, 1844084736, 1844086783, 'RU', 'RUS', 'الإتحاد الروسي'),
(33539, 1844086784, 1844088831, 'IT', 'ITA', 'إيطاليا'),
(33540, 1844088832, 1844090879, 'AT', 'AUT', 'النمسا'),
(33541, 1844090880, 1844092927, 'RU', 'RUS', 'الإتحاد الروسي'),
(33542, 1844092928, 1844094975, 'FR', 'FRA', 'فرنسا'),
(33543, 1844094976, 1844099071, 'GB', 'GBR', 'المملكة المتحدة'),
(33544, 1844099072, 1844101119, 'DE', 'DEU', 'ألمانيا'),
(33545, 1844101120, 1844105215, 'GB', 'GBR', 'المملكة المتحدة'),
(33546, 1844105216, 1844107263, 'ES', 'ESP', 'إسبانيا'),
(33547, 1844107264, 1844109311, 'DE', 'DEU', 'ألمانيا'),
(33548, 1844109312, 1844109567, 'US', 'USA', 'الولايات المتحدة'),
(33549, 1844109568, 1844111359, 'GB', 'GBR', 'المملكة المتحدة'),
(33550, 1844111360, 1844113407, 'AL', 'ALB', 'ألبانيا'),
(33551, 1844113408, 1844115455, 'FI', 'FIN', 'فنلندا'),
(33552, 1844115456, 1844117503, 'DE', 'DEU', 'ألمانيا'),
(33553, 1844117504, 1844119551, 'CZ', 'CZE', 'التشيك'),
(33554, 1844119552, 1844121599, 'UA', 'UKR', 'أوكرانيا'),
(33555, 1844121600, 1844123647, 'ES', 'ESP', 'إسبانيا'),
(33556, 1844123648, 1844125695, 'RU', 'RUS', 'الإتحاد الروسي'),
(33557, 1844125696, 1844127743, 'NL', 'NLD', 'هولندا'),
(33558, 1844127744, 1844129791, 'DE', 'DEU', 'ألمانيا'),
(33559, 1844129792, 1844130047, 'SE', 'SWE', 'السويد'),
(33560, 1844130048, 1844131839, 'NL', 'NLD', 'هولندا'),
(33561, 1844131840, 1844133887, 'DE', 'DEU', 'ألمانيا'),
(33562, 1844133888, 1844135935, 'LT', 'LTU', 'ليتوانيا'),
(33563, 1844135936, 1844137983, 'NL', 'NLD', 'هولندا'),
(33564, 1844137984, 1844140031, 'FR', 'FRA', 'فرنسا'),
(33565, 1844140032, 1844142079, 'RU', 'RUS', 'الإتحاد الروسي'),
(33566, 1844142080, 1844144127, 'RS', 'SRB', 'صربيا'),
(33567, 1844144128, 1844146175, 'SM', 'SMR', 'سان مارينو'),
(33568, 1844146176, 1844148223, 'NO', 'NOR', 'النرويج'),
(33569, 1844148224, 1844150271, 'GB', 'GBR', 'المملكة المتحدة'),
(33570, 1844150272, 1844152319, 'ES', 'ESP', 'إسبانيا'),
(33571, 1844152320, 1844154367, 'DE', 'DEU', 'ألمانيا'),
(33572, 1844154368, 1844154879, 'GB', 'GBR', 'المملكة المتحدة'),
(33573, 1844154880, 1844155135, 'FR', 'FRA', 'فرنسا'),
(33574, 1844155136, 1844155391, 'US', 'USA', 'الولايات المتحدة'),
(33575, 1844155392, 1844156415, 'GB', 'GBR', 'المملكة المتحدة'),
(33576, 1844156416, 1844158463, 'IT', 'ITA', 'إيطاليا'),
(33577, 1844158464, 1844160511, 'RU', 'RUS', 'الإتحاد الروسي'),
(33578, 1844160512, 1844162559, 'SE', 'SWE', 'السويد'),
(33579, 1844162560, 1844164607, 'CZ', 'CZE', 'التشيك'),
(33580, 1844164608, 1844166655, 'RU', 'RUS', 'الإتحاد الروسي'),
(33581, 1844166656, 1844168703, 'AZ', 'AZE', 'أذربيجان'),
(33582, 1844168704, 1844169727, 'LB', 'LBN', 'لبنان'),
(33583, 1844169728, 1844170387, 'DE', 'DEU', 'ألمانيا'),
(33584, 1844170388, 1844170751, 'GI', 'GIB', 'جبل طارق'),
(33585, 1844170752, 1844174847, 'RU', 'RUS', 'الإتحاد الروسي'),
(33586, 1844174848, 1844178943, 'DE', 'DEU', 'ألمانيا'),
(33587, 1844178944, 1844180991, 'EE', 'EST', 'إستونيا'),
(33588, 1844180992, 1844181488, 'TR', 'TUR', 'تركيا'),
(33589, 1844181489, 1844181503, 'DE', 'DEU', 'ألمانيا'),
(33590, 1844181504, 1844183039, 'TR', 'TUR', 'تركيا'),
(33591, 1844183040, 1844191231, 'IT', 'ITA', 'إيطاليا'),
(33592, 1844191232, 1844195327, 'AL', 'ALB', 'ألبانيا'),
(33593, 1844195328, 1844203519, 'RU', 'RUS', 'الإتحاد الروسي'),
(33594, 1844203520, 1844207615, 'NL', 'NLD', 'هولندا'),
(33595, 1844207616, 1844211711, 'RU', 'RUS', 'الإتحاد الروسي'),
(33596, 1844211712, 1844215807, 'SK', 'SVK', 'سلوفاكيا'),
(33597, 1844215808, 1844219903, 'BE', 'BEL', 'بلجيكا'),
(33598, 1844224000, 1844228095, 'GB', 'GBR', 'المملكة المتحدة'),
(33599, 1844228096, 1844232191, 'DK', 'DNK', 'الدنيمارك'),
(33600, 1844232192, 1844235775, 'FR', 'FRA', 'فرنسا'),
(33601, 1844235776, 1844236031, 'GB', 'GBR', 'المملكة المتحدة'),
(33602, 1844236032, 1844236287, 'FR', 'FRA', 'فرنسا'),
(33603, 1844236288, 1844252671, 'RU', 'RUS', 'الإتحاد الروسي'),
(33604, 1844252672, 1844256767, 'GB', 'GBR', 'المملكة المتحدة'),
(33605, 1844256768, 1844260863, 'BA', 'BIH', 'البوسنه والهرسك'),
(33606, 1844260864, 1844264959, 'CH', 'CHE', 'سويسرا'),
(33607, 1844264960, 1844269055, 'NL', 'NLD', 'هولندا'),
(33608, 1844273152, 1844277247, 'RU', 'RUS', 'الإتحاد الروسي'),
(33609, 1844277248, 1844281343, 'AZ', 'AZE', 'أذربيجان'),
(33610, 1844281344, 1844285439, 'DE', 'DEU', 'ألمانيا'),
(33611, 1844285440, 1844289535, 'RU', 'RUS', 'الإتحاد الروسي'),
(33612, 1844289536, 1844293631, 'IT', 'ITA', 'إيطاليا'),
(33613, 1844293632, 1844297727, 'DE', 'DEU', 'ألمانيا'),
(33614, 1844297728, 1844301823, 'IQ', 'IRQ', 'العراق'),
(33615, 1844301824, 1844305919, 'NL', 'NLD', 'هولندا'),
(33616, 1844305920, 1844310015, 'RU', 'RUS', 'الإتحاد الروسي'),
(33617, 1844310016, 1844318207, 'FR', 'FRA', 'فرنسا'),
(33618, 1844318208, 1844322303, 'IT', 'ITA', 'إيطاليا'),
(33619, 1844322304, 1844326399, 'CZ', 'CZE', 'التشيك'),
(33620, 1844326400, 1844330495, 'DK', 'DNK', 'الدنيمارك'),
(33621, 1844330496, 1844338687, 'GB', 'GBR', 'المملكة المتحدة'),
(33622, 1844338688, 1844342783, 'RU', 'RUS', 'الإتحاد الروسي'),
(33623, 1844342784, 1844346879, 'IT', 'ITA', 'إيطاليا'),
(33624, 1844346880, 1844347007, 'US', 'USA', 'الولايات المتحدة'),
(33625, 1844347008, 1844347135, 'GB', 'GBR', 'المملكة المتحدة'),
(33626, 1844347136, 1844347263, 'BE', 'BEL', 'بلجيكا'),
(33627, 1844347264, 1844347903, 'GB', 'GBR', 'المملكة المتحدة'),
(33628, 1844347904, 1844348159, 'US', 'USA', 'الولايات المتحدة'),
(33629, 1844348160, 1844348671, 'GB', 'GBR', 'المملكة المتحدة'),
(33630, 1844348672, 1844348927, 'BE', 'BEL', 'بلجيكا'),
(33631, 1844348928, 1844349439, 'GB', 'GBR', 'المملكة المتحدة'),
(33632, 1844349440, 1844349951, 'US', 'USA', 'الولايات المتحدة'),
(33633, 1844349952, 1844350207, 'HK', 'HKG', 'هونغ كونغ'),
(33634, 1844350208, 1844350719, 'CA', 'CAN', 'كندا'),
(33635, 1844350720, 1844350975, 'GB', 'GBR', 'المملكة المتحدة'),
(33636, 1844350976, 1844355071, 'SY', 'SYR', 'سوريا'),
(33637, 1844355072, 1844359167, 'KZ', 'KAZ', 'كازاخستان'),
(33638, 1844359168, 1844363263, 'IR', 'IRN', 'إيران'),
(33639, 1844363264, 1844367359, 'RU', 'RUS', 'الإتحاد الروسي'),
(33640, 1844367360, 1844371455, 'CZ', 'CZE', 'التشيك'),
(33641, 1844371456, 1844375551, 'GE', 'GEO', 'جورجيا'),
(33642, 1844375552, 1844379647, 'RU', 'RUS', 'الإتحاد الروسي'),
(33643, 1844379648, 1844383743, 'IR', 'IRN', 'إيران'),
(33644, 1844383744, 1844387839, 'AZ', 'AZE', 'أذربيجان'),
(33645, 1844387840, 1844391935, 'KZ', 'KAZ', 'كازاخستان'),
(33646, 1844391936, 1844396031, 'DE', 'DEU', 'ألمانيا'),
(33647, 1844396032, 1844400127, 'CZ', 'CZE', 'التشيك'),
(33648, 1844400128, 1844408319, 'GB', 'GBR', 'المملكة المتحدة'),
(33649, 1844408320, 1844412415, 'FR', 'FRA', 'فرنسا'),
(33650, 1844412416, 1844416511, 'RU', 'RUS', 'الإتحاد الروسي'),
(33651, 1844416512, 1844420607, 'FR', 'FRA', 'فرنسا'),
(33652, 1844420608, 1844424703, 'DE', 'DEU', 'ألمانيا'),
(33653, 1844424704, 1844428799, 'SI', 'SVN', 'سلوفينيا'),
(33654, 1844428800, 1844432895, 'DE', 'DEU', 'ألمانيا'),
(33655, 1844432896, 1844436991, 'RU', 'RUS', 'الإتحاد الروسي'),
(33656, 1844436992, 1844441087, 'NO', 'NOR', 'النرويج'),
(33657, 1844441088, 1844445183, 'IT', 'ITA', 'إيطاليا'),
(33658, 1844445184, 1844510719, 'FI', 'FIN', 'فنلندا'),
(33659, 1844510720, 1844576255, 'RU', 'RUS', 'الإتحاد الروسي'),
(33660, 1844576256, 1844641791, 'GR', 'GRC', 'اليونان'),
(33661, 1844641792, 1844707327, 'PL', 'POL', 'بولندا'),
(33662, 1844707328, 1844772863, 'RU', 'RUS', 'الإتحاد الروسي'),
(33663, 1844772864, 1844838399, 'RS', 'SRB', 'صربيا'),
(33664, 1844838400, 1844903935, 'GB', 'GBR', 'المملكة المتحدة'),
(33665, 1844969472, 1845035007, 'RU', 'RUS', 'الإتحاد الروسي'),
(33666, 1845035008, 1845100543, 'GB', 'GBR', 'المملكة المتحدة'),
(33667, 1845100544, 1845166079, 'DE', 'DEU', 'ألمانيا'),
(33668, 1845231616, 1845297151, 'RU', 'RUS', 'الإتحاد الروسي'),
(33669, 1845297152, 1845362687, 'IL', 'ISR', 'إسرائيل'),
(33670, 1845362688, 1845428223, 'UA', 'UKR', 'أوكرانيا'),
(33671, 1845428224, 1845493759, 'IE', 'IRL', 'إيرلندا'),
(33672, 1845493760, 1845755903, 'JP', 'JPN', 'اليابان'),
(33673, 1845755904, 1845764095, 'HK', 'HKG', 'هونغ كونغ'),
(33674, 1845764096, 1845766143, 'JP', 'JPN', 'اليابان'),
(33675, 1845766144, 1845768191, 'MY', 'MYS', 'ماليزيا'),
(33676, 1845768192, 1845772287, 'JP', 'JPN', 'اليابان'),
(33677, 1845772288, 1845788671, 'KR', 'KOR', 'جمهورية كوريا'),
(33678, 1845788672, 1845837823, 'JP', 'JPN', 'اليابان'),
(33679, 1845837824, 1845839871, 'PH', 'PHL', 'الفلبين'),
(33680, 1845839872, 1845841919, 'IN', 'IND', 'الهند'),
(33681, 1845841920, 1845846015, 'AU', 'AUS', 'أستراليا'),
(33682, 1845846016, 1845850111, 'ID', 'IDN', 'إندونيسيا'),
(33683, 1845850112, 1845851135, 'WS', 'WSM', 'ساموا'),
(33684, 1845851136, 1845852159, 'AU', 'AUS', 'أستراليا'),
(33685, 1845852160, 1845854207, 'JP', 'JPN', 'اليابان'),
(33686, 1845854208, 1845886975, 'KR', 'KOR', 'جمهورية كوريا'),
(33687, 1845886976, 1846018047, 'CN', 'CHN', 'الصين'),
(33688, 1846018048, 1846542335, 'KR', 'KOR', 'جمهورية كوريا'),
(33689, 1846542336, 1846804479, 'CN', 'CHN', 'الصين'),
(33690, 1846804480, 1847066623, 'AU', 'AUS', 'أستراليا'),
(33691, 1847066624, 1847590911, 'TW', 'TWN', 'تايوان'),
(33692, 1847590912, 1847721983, 'AU', 'AUS', 'أستراليا'),
(33693, 1847721984, 1847730175, 'NP', 'NPL', 'نيبال'),
(33694, 1847730176, 1847732223, 'PK', 'PAK', 'باكستان'),
(33695, 1847732224, 1847734271, 'AU', 'AUS', 'أستراليا'),
(33696, 1847734272, 1847735295, 'NZ', 'NZL', 'نيوزيلاندا'),
(33697, 1847735296, 1847736319, 'AU', 'AUS', 'أستراليا'),
(33698, 1847736320, 1847738367, 'HK', 'HKG', 'هونغ كونغ'),
(33699, 1847738368, 1847754751, 'KR', 'KOR', 'جمهورية كوريا'),
(33700, 1847754752, 1847787519, 'TH', 'THA', 'تايلند'),
(33701, 1847787520, 1847803903, 'KR', 'KOR', 'جمهورية كوريا'),
(33702, 1847803904, 1847807999, 'VN', 'VNM', 'فييتنام'),
(33703, 1847808000, 1847810047, 'ID', 'IDN', 'إندونيسيا'),
(33704, 1847810048, 1847812095, 'AU', 'AUS', 'أستراليا'),
(33705, 1847812096, 1847853055, 'KR', 'KOR', 'جمهورية كوريا'),
(33706, 1847853056, 1848115199, 'PK', 'PAK', 'باكستان'),
(33707, 1848115200, 1848377343, 'CN', 'CHN', 'الصين'),
(33708, 1848377344, 1848381439, 'HK', 'HKG', 'هونغ كونغ'),
(33709, 1848381440, 1848382463, 'NZ', 'NZL', 'نيوزيلاندا'),
(33710, 1848382464, 1848385535, 'AU', 'AUS', 'أستراليا'),
(33711, 1848385536, 1848393727, 'KR', 'KOR', 'جمهورية كوريا'),
(33712, 1848393728, 1848401919, 'JP', 'JPN', 'اليابان'),
(33713, 1848401920, 1848406015, 'PH', 'PHL', 'الفلبين'),
(33714, 1848406016, 1848410111, 'NP', 'NPL', 'نيبال'),
(33715, 1848410112, 1848414207, 'PH', 'PHL', 'الفلبين'),
(33716, 1848414208, 1848420351, 'AU', 'AUS', 'أستراليا'),
(33717, 1848420352, 1848422399, 'ID', 'IDN', 'إندونيسيا'),
(33718, 1848422400, 1848424447, 'JP', 'JPN', 'اليابان'),
(33719, 1848424448, 1848426495, 'VN', 'VNM', 'فييتنام'),
(33720, 1848426496, 1848639487, 'KR', 'KOR', 'جمهورية كوريا'),
(33721, 1848639488, 1848705023, 'CN', 'CHN', 'الصين'),
(33722, 1848705024, 1848770559, 'TH', 'THA', 'تايلند'),
(33723, 1848770560, 1848774655, 'JP', 'JPN', 'اليابان'),
(33724, 1848774656, 1848778751, 'AU', 'AUS', 'أستراليا'),
(33725, 1848778752, 1848786943, 'IN', 'IND', 'الهند'),
(33726, 1848786944, 1848791039, 'JP', 'JPN', 'اليابان'),
(33727, 1848791040, 1848793087, 'ID', 'IDN', 'إندونيسيا'),
(33728, 1848793088, 1848803327, 'JP', 'JPN', 'اليابان'),
(33729, 1848803328, 1848819711, 'TW', 'TWN', 'تايوان'),
(33730, 1848819712, 1848827903, 'JP', 'JPN', 'اليابان'),
(33731, 1848827904, 1848831999, 'PH', 'PHL', 'الفلبين'),
(33732, 1848832000, 1848832255, 'JP', 'JPN', 'اليابان'),
(33733, 1848832256, 1848832511, 'NL', 'NLD', 'هولندا'),
(33734, 1848832512, 1848832959, 'JP', 'JPN', 'اليابان'),
(33735, 1848832960, 1848832975, 'NL', 'NLD', 'هولندا'),
(33736, 1848832976, 1848833023, 'JP', 'JPN', 'اليابان'),
(33737, 1848833024, 1848833055, 'NL', 'NLD', 'هولندا'),
(33738, 1848833056, 1848836095, 'JP', 'JPN', 'اليابان'),
(33739, 1848836096, 1849032703, 'CN', 'CHN', 'الصين'),
(33740, 1849032704, 1849065471, 'JP', 'JPN', 'اليابان'),
(33741, 1849065472, 1849163775, 'PH', 'PHL', 'الفلبين'),
(33742, 1849163776, 1849819135, 'CN', 'CHN', 'الصين'),
(33743, 1849819136, 1849950207, 'JP', 'JPN', 'اليابان'),
(33744, 1849950208, 1850212351, 'KR', 'KOR', 'جمهورية كوريا'),
(33745, 1850212352, 1850343423, 'CN', 'CHN', 'الصين'),
(33746, 1850343424, 1850376191, 'JP', 'JPN', 'اليابان'),
(33747, 1850376192, 1850392575, 'MY', 'MYS', 'ماليزيا'),
(33748, 1850392576, 1850400767, 'KH', 'KHM', 'كامبوديا'),
(33749, 1850400768, 1850408959, 'JP', 'JPN', 'اليابان'),
(33750, 1850408960, 1850441727, 'AU', 'AUS', 'أستراليا'),
(33751, 1850441728, 1850490879, 'CN', 'CHN', 'الصين'),
(33752, 1850490880, 1850507263, 'KR', 'KOR', 'جمهورية كوريا'),
(33753, 1850507264, 1850511359, 'AU', 'AUS', 'أستراليا'),
(33754, 1850511360, 1850513407, 'ID', 'IDN', 'إندونيسيا'),
(33755, 1850513408, 1850514431, 'TH', 'THA', 'تايلند'),
(33756, 1850514432, 1850515455, 'AU', 'AUS', 'أستراليا'),
(33757, 1850515456, 1850519551, 'IN', 'IND', 'الهند'),
(33758, 1850519552, 1850522623, 'AU', 'AUS', 'أستراليا'),
(33759, 1850522624, 1850523647, 'HK', 'HKG', 'هونغ كونغ'),
(33760, 1850523648, 1850572799, 'CN', 'CHN', 'الصين'),
(33761, 1850572800, 1850671103, 'TH', 'THA', 'تايلند'),
(33762, 1850671104, 1850736639, 'HK', 'HKG', 'هونغ كونغ'),
(33763, 1850736640, 1851523071, 'CN', 'CHN', 'الصين'),
(33764, 1851523072, 1851527167, 'JP', 'JPN', 'اليابان'),
(33765, 1851527168, 1851528191, 'NZ', 'NZL', 'نيوزيلاندا'),
(33766, 1851528192, 1851529215, 'AU', 'AUS', 'أستراليا'),
(33767, 1851529216, 1851531263, 'PH', 'PHL', 'الفلبين'),
(33768, 1851531264, 1851539455, 'JP', 'JPN', 'اليابان'),
(33769, 1851539456, 1851542527, 'ID', 'IDN', 'إندونيسيا'),
(33770, 1851542528, 1851543551, 'HK', 'HKG', 'هونغ كونغ'),
(33771, 1851543552, 1851547647, 'JP', 'JPN', 'اليابان'),
(33772, 1851547648, 1851555839, 'SG', 'SGP', 'سنغافورة'),
(33773, 1851555840, 1851588607, 'KR', 'KOR', 'جمهورية كوريا'),
(33774, 1851588608, 1851590655, 'JP', 'JPN', 'اليابان'),
(33775, 1851590656, 1851594751, 'AU', 'AUS', 'أستراليا'),
(33776, 1851594752, 1851596799, 'KR', 'KOR', 'جمهورية كوريا'),
(33777, 1851596800, 1851604991, 'IN', 'IND', 'الهند'),
(33778, 1851604992, 1851613183, 'PH', 'PHL', 'الفلبين'),
(33779, 1851613184, 1851617279, 'JP', 'JPN', 'اليابان'),
(33780, 1851617280, 1851637759, 'KR', 'KOR', 'جمهورية كوريا'),
(33781, 1851637760, 1851654143, 'PK', 'PAK', 'باكستان'),
(33782, 1851654144, 1853882367, 'CN', 'CHN', 'الصين'),
(33783, 1853882368, 1854406655, 'JP', 'JPN', 'اليابان'),
(33784, 1854406656, 1854668799, 'ID', 'IDN', 'إندونيسيا'),
(33785, 1854668800, 1855455231, 'AU', 'AUS', 'أستراليا'),
(33786, 1855455232, 1855848447, 'CN', 'CHN', 'الصين'),
(33787, 1855848448, 1855913983, 'JP', 'JPN', 'اليابان'),
(33788, 1855913984, 1855979519, 'MY', 'MYS', 'ماليزيا'),
(33789, 1855979520, 1856241663, 'JP', 'JPN', 'اليابان'),
(33790, 1856241664, 1856307199, 'TH', 'THA', 'تايلند'),
(33791, 1856307200, 1856315391, 'KR', 'KOR', 'جمهورية كوريا'),
(33792, 1856315392, 1856323583, 'HK', 'HKG', 'هونغ كونغ'),
(33793, 1856323584, 1856339967, 'KR', 'KOR', 'جمهورية كوريا'),
(33794, 1856339968, 1856372735, 'JP', 'JPN', 'اليابان'),
(33795, 1856372736, 1856503807, 'CN', 'CHN', 'الصين'),
(33796, 1856503808, 1856765951, 'TH', 'THA', 'تايلند'),
(33797, 1856765952, 1856770047, 'JP', 'JPN', 'اليابان'),
(33798, 1856770048, 1856774143, 'IN', 'IND', 'الهند'),
(33799, 1856774144, 1856779263, 'JP', 'JPN', 'اليابان'),
(33800, 1856779264, 1856780287, 'IN', 'IND', 'الهند'),
(33801, 1856780288, 1856782335, 'JP', 'JPN', 'اليابان'),
(33802, 1856782336, 1856798719, 'KR', 'KOR', 'جمهورية كوريا'),
(33803, 1856798720, 1856815103, 'IN', 'IND', 'الهند'),
(33804, 1856815104, 1856843775, 'CN', 'CHN', 'الصين'),
(33805, 1856843776, 1856847871, 'HK', 'HKG', 'هونغ كونغ'),
(33806, 1856847872, 1856856063, 'AU', 'AUS', 'أستراليا'),
(33807, 1856856064, 1856864255, 'CN', 'CHN', 'الصين'),
(33808, 1856864256, 1856872447, 'AU', 'AUS', 'أستراليا'),
(33809, 1856872448, 1856876543, 'NZ', 'NZL', 'نيوزيلاندا'),
(33810, 1856876544, 1856880639, 'AU', 'AUS', 'أستراليا'),
(33811, 1856880640, 1856888831, 'CN', 'CHN', 'الصين'),
(33812, 1856888832, 1856892927, 'AU', 'AUS', 'أستراليا'),
(33813, 1856892928, 1856897023, 'JP', 'JPN', 'اليابان'),
(33814, 1856897024, 1857028095, 'AU', 'AUS', 'أستراليا'),
(33815, 1857028096, 1860173823, 'CN', 'CHN', 'الصين'),
(33816, 1860173824, 1860435967, 'IN', 'IND', 'الهند'),
(33817, 1860435968, 1860698111, 'CN', 'CHN', 'الصين'),
(33818, 1860698112, 1860706303, 'JP', 'JPN', 'اليابان'),
(33819, 1860706304, 1860714495, 'CN', 'CHN', 'الصين'),
(33820, 1860714496, 1860722687, 'ID', 'IDN', 'إندونيسيا'),
(33821, 1860722688, 1860726783, 'KR', 'KOR', 'جمهورية كوريا'),
(33822, 1860726784, 1860728831, 'AU', 'AUS', 'أستراليا'),
(33823, 1860728832, 1860733951, 'JP', 'JPN', 'اليابان'),
(33824, 1860733952, 1860734975, 'AU', 'AUS', 'أستراليا'),
(33825, 1860734976, 1860735999, 'NZ', 'NZL', 'نيوزيلاندا'),
(33826, 1860736000, 1860737023, 'AU', 'AUS', 'أستراليا'),
(33827, 1860737024, 1860739071, 'JP', 'JPN', 'اليابان'),
(33828, 1860739072, 1860743167, 'PH', 'PHL', 'الفلبين'),
(33829, 1860743168, 1860747263, 'AU', 'AUS', 'أستراليا'),
(33830, 1860747264, 1860759551, 'JP', 'JPN', 'اليابان'),
(33831, 1860759552, 1860763647, 'AU', 'AUS', 'أستراليا'),
(33832, 1860763648, 1860829183, 'JP', 'JPN', 'اليابان'),
(33833, 1860829184, 1860960255, 'IN', 'IND', 'الهند'),
(33834, 1860960256, 1861091327, 'CN', 'CHN', 'الصين'),
(33835, 1861091328, 1861222399, 'AU', 'AUS', 'أستراليا'),
(33836, 1861222400, 1866465279, 'CN', 'CHN', 'الصين'),
(33837, 1866465280, 1866530815, 'JP', 'JPN', 'اليابان'),
(33838, 1866530816, 1866563583, 'SG', 'SGP', 'سنغافورة'),
(33839, 1866563584, 1866579967, 'KR', 'KOR', 'جمهورية كوريا'),
(33840, 1866579968, 1866588159, 'JP', 'JPN', 'اليابان'),
(33841, 1866588160, 1866592255, 'NZ', 'NZL', 'نيوزيلاندا'),
(33842, 1866592256, 1866596351, 'AU', 'AUS', 'أستراليا'),
(33843, 1866596352, 1866661887, 'CN', 'CHN', 'الصين'),
(33844, 1866661888, 1866670079, 'AU', 'AUS', 'أستراليا'),
(33845, 1866670080, 1866674175, 'MY', 'MYS', 'ماليزيا'),
(33846, 1866674176, 1866678271, 'TW', 'TWN', 'تايوان'),
(33847, 1866678272, 1866686463, 'ID', 'IDN', 'إندونيسيا'),
(33848, 1866686464, 1866690559, 'KH', 'KHM', 'كامبوديا'),
(33849, 1866690560, 1866711039, 'JP', 'JPN', 'اليابان'),
(33850, 1866711040, 1866715135, 'CN', 'CHN', 'الصين'),
(33851, 1866715136, 1866727423, 'KR', 'KOR', 'جمهورية كوريا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(33852, 1866727424, 1866731519, 'HK', 'HKG', 'هونغ كونغ'),
(33853, 1866731520, 1866733567, 'JP', 'JPN', 'اليابان'),
(33854, 1866733568, 1866735615, 'ID', 'IDN', 'إندونيسيا'),
(33855, 1866735616, 1866743807, 'PH', 'PHL', 'الفلبين'),
(33856, 1866743808, 1866751999, 'CN', 'CHN', 'الصين'),
(33857, 1866752000, 1866756095, 'PK', 'PAK', 'باكستان'),
(33858, 1866756096, 1866760191, 'ID', 'IDN', 'إندونيسيا'),
(33859, 1866760192, 1866792959, 'JP', 'JPN', 'اليابان'),
(33860, 1866792960, 1866858495, 'NZ', 'NZL', 'نيوزيلاندا'),
(33861, 1866858496, 1866989567, 'TW', 'TWN', 'تايوان'),
(33862, 1866989568, 1867513855, 'CN', 'CHN', 'الصين'),
(33863, 1867513856, 1867775999, 'TW', 'TWN', 'تايوان'),
(33864, 1867776000, 1867841535, 'TH', 'THA', 'تايلند'),
(33865, 1867841536, 1867907071, 'CN', 'CHN', 'الصين'),
(33866, 1867907072, 1868038143, 'JP', 'JPN', 'اليابان'),
(33867, 1868038144, 1868103679, 'PK', 'PAK', 'باكستان'),
(33868, 1868103680, 1868201983, 'JP', 'JPN', 'اليابان'),
(33869, 1868201984, 1868210175, 'MY', 'MYS', 'ماليزيا'),
(33870, 1868210176, 1868212223, 'JP', 'JPN', 'اليابان'),
(33871, 1868212224, 1868214271, 'IN', 'IND', 'الهند'),
(33872, 1868214272, 1868218367, 'KH', 'KHM', 'كامبوديا'),
(33873, 1868218368, 1868227839, 'SG', 'SGP', 'سنغافورة'),
(33874, 1868227840, 1868228095, 'MY', 'MYS', 'ماليزيا'),
(33875, 1868228096, 1868234751, 'SG', 'SGP', 'سنغافورة'),
(33876, 1868234752, 1868267519, 'IN', 'IND', 'الهند'),
(33877, 1868267520, 1868283903, 'KR', 'KOR', 'جمهورية كوريا'),
(33878, 1868283904, 1868292095, 'CN', 'CHN', 'الصين'),
(33879, 1868292096, 1868294143, 'IN', 'IND', 'الهند'),
(33880, 1868294144, 1868295167, 'VN', 'VNM', 'فييتنام'),
(33881, 1868295168, 1868296191, 'HK', 'HKG', 'هونغ كونغ'),
(33882, 1868296192, 1868300287, 'JP', 'JPN', 'اليابان'),
(33883, 1868300288, 1868333055, 'IN', 'IND', 'الهند'),
(33884, 1868333056, 1868341247, 'PK', 'PAK', 'باكستان'),
(33885, 1868341248, 1868345343, 'ID', 'IDN', 'إندونيسيا'),
(33886, 1868345344, 1868346367, 'GU', 'GUM', 'غوام'),
(33887, 1868346368, 1868349439, 'AU', 'AUS', 'أستراليا'),
(33888, 1868349440, 1868357631, 'SG', 'SGP', 'سنغافورة'),
(33889, 1868357632, 1868361727, 'HK', 'HKG', 'هونغ كونغ'),
(33890, 1868361728, 1868362751, 'KH', 'KHM', 'كامبوديا'),
(33891, 1868362752, 1868363775, 'JP', 'JPN', 'اليابان'),
(33892, 1868363776, 1868365823, 'BD', 'BGD', 'بنغالاديش'),
(33893, 1868365824, 1868431359, 'IN', 'IND', 'الهند'),
(33894, 1868431360, 1868562431, 'ID', 'IDN', 'إندونيسيا'),
(33895, 1868562432, 1869611007, 'JP', 'JPN', 'اليابان'),
(33896, 1869611008, 1870004223, 'CN', 'CHN', 'الصين'),
(33897, 1870004224, 1870036991, 'KR', 'KOR', 'جمهورية كوريا'),
(33898, 1870036992, 1870045183, 'KH', 'KHM', 'كامبوديا'),
(33899, 1870045184, 1870049279, 'AU', 'AUS', 'أستراليا'),
(33900, 1870049280, 1870053375, 'IN', 'IND', 'الهند'),
(33901, 1870053376, 1870086143, 'AU', 'AUS', 'أستراليا'),
(33902, 1870086144, 1870110719, 'CN', 'CHN', 'الصين'),
(33903, 1870110720, 1870118911, 'PK', 'PAK', 'باكستان'),
(33904, 1870118912, 1870135295, 'IN', 'IND', 'الهند'),
(33905, 1870135296, 1870462975, 'CN', 'CHN', 'الصين'),
(33906, 1870462976, 1870479359, 'JP', 'JPN', 'اليابان'),
(33907, 1870479360, 1870495743, 'PH', 'PHL', 'الفلبين'),
(33908, 1870495744, 1870497791, 'TW', 'TWN', 'تايوان'),
(33909, 1870497792, 1870499839, 'IN', 'IND', 'الهند'),
(33910, 1870499840, 1870501887, 'JP', 'JPN', 'اليابان'),
(33911, 1870501888, 1870503935, 'AF', 'AFG', 'أفغانستان'),
(33912, 1870503936, 1870512127, 'AU', 'AUS', 'أستراليا'),
(33913, 1870512128, 1870528511, 'IN', 'IND', 'الهند'),
(33914, 1870528512, 1873281023, 'CN', 'CHN', 'الصين'),
(33915, 1873281024, 1873412095, 'JP', 'JPN', 'اليابان'),
(33916, 1873412096, 1873477631, 'CN', 'CHN', 'الصين'),
(33917, 1873477632, 1873510399, 'KR', 'KOR', 'جمهورية كوريا'),
(33918, 1873510400, 1873543167, 'JP', 'JPN', 'اليابان'),
(33919, 1873543168, 1874329599, 'CN', 'CHN', 'الصين'),
(33920, 1874329600, 1874460671, 'TW', 'TWN', 'تايوان'),
(33921, 1874460672, 1874591743, 'CN', 'CHN', 'الصين'),
(33922, 1874591744, 1874853887, 'JP', 'JPN', 'اليابان'),
(33923, 1874853888, 1876426751, 'CN', 'CHN', 'الصين'),
(33924, 1876426752, 1876557823, 'JP', 'JPN', 'اليابان'),
(33925, 1876557824, 1876688895, 'KR', 'KOR', 'جمهورية كوريا'),
(33926, 1876688896, 1876754431, 'AU', 'AUS', 'أستراليا'),
(33927, 1876754432, 1876756479, 'BD', 'BGD', 'بنغالاديش'),
(33928, 1876756480, 1876762623, 'SG', 'SGP', 'سنغافورة'),
(33929, 1876762624, 1876764671, 'KR', 'KOR', 'جمهورية كوريا'),
(33930, 1876764672, 1876765695, 'ID', 'IDN', 'إندونيسيا'),
(33931, 1876765696, 1876766719, 'SG', 'SGP', 'سنغافورة'),
(33932, 1876766720, 1876768767, 'MY', 'MYS', 'ماليزيا'),
(33933, 1876768768, 1876769791, 'AU', 'AUS', 'أستراليا'),
(33934, 1876769792, 1876770815, 'JP', 'JPN', 'اليابان'),
(33935, 1876770816, 1876787199, 'SG', 'SGP', 'سنغافورة'),
(33936, 1876787200, 1876885503, 'CN', 'CHN', 'الصين'),
(33937, 1876885504, 1876893695, 'PH', 'PHL', 'الفلبين'),
(33938, 1876893696, 1876901887, 'TH', 'THA', 'تايلند'),
(33939, 1876901888, 1876918271, 'SG', 'SGP', 'سنغافورة'),
(33940, 1876918272, 1876934655, 'LK', 'LKA', 'سيريلانكا'),
(33941, 1876934656, 1876942847, 'JP', 'JPN', 'اليابان'),
(33942, 1876942848, 1876951039, 'AU', 'AUS', 'أستراليا'),
(33943, 1876951040, 1877475327, 'CN', 'CHN', 'الصين'),
(33944, 1877475328, 1877688319, 'JP', 'JPN', 'اليابان'),
(33945, 1877688320, 1877689343, 'IN', 'IND', 'الهند'),
(33946, 1877689344, 1877690367, 'TH', 'THA', 'تايلند'),
(33947, 1877690368, 1877691391, 'IN', 'IND', 'الهند'),
(33948, 1877691392, 1877692415, 'JP', 'JPN', 'اليابان'),
(33949, 1877692416, 1877696511, 'PH', 'PHL', 'الفلبين'),
(33950, 1877696512, 1877704703, 'CN', 'CHN', 'الصين'),
(33951, 1877704704, 1877706751, 'AU', 'AUS', 'أستراليا'),
(33952, 1877706752, 1877707775, 'SG', 'SGP', 'سنغافورة'),
(33953, 1877707776, 1877710847, 'AU', 'AUS', 'أستراليا'),
(33954, 1877710848, 1877711871, 'HK', 'HKG', 'هونغ كونغ'),
(33955, 1877711872, 1877712895, 'BD', 'BGD', 'بنغالاديش'),
(33956, 1877712896, 1877721087, 'CN', 'CHN', 'الصين'),
(33957, 1877721088, 1877737471, 'TW', 'TWN', 'تايوان'),
(33958, 1877737472, 1877999615, 'JP', 'JPN', 'اليابان'),
(33959, 1877999616, 1879048191, 'TW', 'TWN', 'تايوان'),
(33960, 1879048192, 1883218547, 'CN', 'CHN', 'الصين'),
(33961, 1883218548, 1883218551, 'ES', 'ESP', 'إسبانيا'),
(33962, 1883218552, 1883218555, 'FR', 'FRA', 'فرنسا'),
(33963, 1883218556, 1883218579, 'CN', 'CHN', 'الصين'),
(33964, 1883218580, 1883218583, 'BE', 'BEL', 'بلجيكا'),
(33965, 1883218584, 1883504639, 'CN', 'CHN', 'الصين'),
(33966, 1883504640, 1883766783, 'JP', 'JPN', 'اليابان'),
(33967, 1883766784, 1883770879, 'MN', 'MNG', 'منغوليا'),
(33968, 1883770880, 1883783167, 'KR', 'KOR', 'جمهورية كوريا'),
(33969, 1883783168, 1883799551, 'VN', 'VNM', 'فييتنام'),
(33970, 1883799552, 1883832319, 'KR', 'KOR', 'جمهورية كوريا'),
(33971, 1883832320, 1884028927, 'CN', 'CHN', 'الصين'),
(33972, 1884028928, 1884159999, 'KR', 'KOR', 'جمهورية كوريا'),
(33973, 1884160000, 1884164095, 'VN', 'VNM', 'فييتنام'),
(33974, 1884164096, 1884168191, 'TW', 'TWN', 'تايوان'),
(33975, 1884168192, 1884172287, 'ID', 'IDN', 'إندونيسيا'),
(33976, 1884172288, 1884176383, 'PH', 'PHL', 'الفلبين'),
(33977, 1884176384, 1884184575, 'TW', 'TWN', 'تايوان'),
(33978, 1884184576, 1884186623, 'ID', 'IDN', 'إندونيسيا'),
(33979, 1884186624, 1884188671, 'TW', 'TWN', 'تايوان'),
(33980, 1884188672, 1884192767, 'JP', 'JPN', 'اليابان'),
(33981, 1884192768, 1884209151, 'ID', 'IDN', 'إندونيسيا'),
(33982, 1884209152, 1884217343, 'JP', 'JPN', 'اليابان'),
(33983, 1884217344, 1884225535, 'SG', 'SGP', 'سنغافورة'),
(33984, 1884225536, 1884291071, 'IN', 'IND', 'الهند'),
(33985, 1884291072, 1885863935, 'CN', 'CHN', 'الصين'),
(33986, 1885863936, 1885995007, 'TW', 'TWN', 'تايوان'),
(33987, 1885995008, 1886191615, 'KR', 'KOR', 'جمهورية كوريا'),
(33988, 1886191616, 1886195711, 'PH', 'PHL', 'الفلبين'),
(33989, 1886195712, 1886197759, 'ID', 'IDN', 'إندونيسيا'),
(33990, 1886197760, 1886199807, 'AU', 'AUS', 'أستراليا'),
(33991, 1886199808, 1886207999, 'KR', 'KOR', 'جمهورية كوريا'),
(33992, 1886208000, 1886214143, 'NZ', 'NZL', 'نيوزيلاندا'),
(33993, 1886214144, 1886224383, 'AU', 'AUS', 'أستراليا'),
(33994, 1886224384, 1886257151, 'CN', 'CHN', 'الصين'),
(33995, 1886257152, 1886322687, 'IN', 'IND', 'الهند'),
(33996, 1886322688, 1886781439, 'CN', 'CHN', 'الصين'),
(33997, 1886781440, 1886978047, 'HK', 'HKG', 'هونغ كونغ'),
(33998, 1886978048, 1886986239, 'KR', 'KOR', 'جمهورية كوريا'),
(33999, 1886986240, 1886990335, 'TW', 'TWN', 'تايوان'),
(34000, 1886990336, 1886994431, 'IN', 'IND', 'الهند'),
(34001, 1886994432, 1887005695, 'TW', 'TWN', 'تايوان'),
(34002, 1887005696, 1887006719, 'US', 'USA', 'الولايات المتحدة'),
(34003, 1887006720, 1887010815, 'HK', 'HKG', 'هونغ كونغ'),
(34004, 1887010816, 1887019007, 'TH', 'THA', 'تايلند'),
(34005, 1887019008, 1887027199, 'HK', 'HKG', 'هونغ كونغ'),
(34006, 1887027200, 1887043583, 'KR', 'KOR', 'جمهورية كوريا'),
(34007, 1887043584, 1887764479, 'CN', 'CHN', 'الصين'),
(34008, 1887764480, 1887813631, 'KR', 'KOR', 'جمهورية كوريا'),
(34009, 1887813632, 1887830015, 'IN', 'IND', 'الهند'),
(34010, 1887830016, 1887961087, 'LK', 'LKA', 'سيريلانكا'),
(34011, 1887961088, 1887993855, 'JP', 'JPN', 'اليابان'),
(34012, 1887993856, 1888026623, 'KR', 'KOR', 'جمهورية كوريا'),
(34013, 1888026624, 1888030719, 'BD', 'BGD', 'بنغالاديش'),
(34014, 1888030720, 1888034815, 'HK', 'HKG', 'هونغ كونغ'),
(34015, 1888034816, 1888038911, 'JP', 'JPN', 'اليابان'),
(34016, 1888038912, 1888040959, 'AU', 'AUS', 'أستراليا'),
(34017, 1888040960, 1888059391, 'JP', 'JPN', 'اليابان'),
(34018, 1888059392, 1888063487, 'VN', 'VNM', 'فييتنام'),
(34019, 1888063488, 1888067583, 'JP', 'JPN', 'اليابان'),
(34020, 1888067584, 1888071679, 'MY', 'MYS', 'ماليزيا'),
(34021, 1888071680, 1888073727, 'KR', 'KOR', 'جمهورية كوريا'),
(34022, 1888073728, 1888239615, 'JP', 'JPN', 'اليابان'),
(34023, 1888239616, 1888255999, 'KR', 'KOR', 'جمهورية كوريا'),
(34024, 1888256000, 1888260095, 'JP', 'JPN', 'اليابان'),
(34025, 1888260096, 1888264191, 'KR', 'KOR', 'جمهورية كوريا'),
(34026, 1888264192, 1888266239, 'ID', 'IDN', 'إندونيسيا'),
(34027, 1888266240, 1888268287, 'JP', 'JPN', 'اليابان'),
(34028, 1888268288, 1888270335, 'AU', 'AUS', 'أستراليا'),
(34029, 1888270336, 1888271359, 'SG', 'SGP', 'سنغافورة'),
(34030, 1888271360, 1888272383, 'TH', 'THA', 'تايلند'),
(34031, 1888272384, 1888288767, 'KR', 'KOR', 'جمهورية كوريا'),
(34032, 1888288768, 1888354303, 'AU', 'AUS', 'أستراليا'),
(34033, 1888354304, 1888485375, 'TH', 'THA', 'تايلند'),
(34034, 1888485376, 1891631103, 'KR', 'KOR', 'جمهورية كوريا'),
(34035, 1891631104, 1891893247, 'CN', 'CHN', 'الصين'),
(34036, 1891893248, 1891942399, 'IN', 'IND', 'الهند'),
(34037, 1891942400, 1891950591, 'KR', 'KOR', 'جمهورية كوريا'),
(34038, 1891950592, 1891958783, 'PH', 'PHL', 'الفلبين'),
(34039, 1891958784, 1892024319, 'VN', 'VNM', 'فييتنام'),
(34040, 1892024320, 1892122623, 'PH', 'PHL', 'الفلبين'),
(34041, 1892122624, 1892155391, 'SG', 'SGP', 'سنغافورة'),
(34042, 1892155392, 1892941823, 'PH', 'PHL', 'الفلبين'),
(34043, 1892941824, 1893015551, 'KR', 'KOR', 'جمهورية كوريا'),
(34044, 1893015552, 1893023743, 'AU', 'AUS', 'أستراليا'),
(34045, 1893023744, 1893027839, 'HK', 'HKG', 'هونغ كونغ'),
(34046, 1893027840, 1893031935, 'VN', 'VNM', 'فييتنام'),
(34047, 1893031936, 1893040127, 'HK', 'HKG', 'هونغ كونغ'),
(34048, 1893040128, 1893072895, 'AU', 'AUS', 'أستراليا'),
(34049, 1893072896, 1893138431, 'KR', 'KOR', 'جمهورية كوريا'),
(34050, 1893138432, 1893203967, 'ID', 'IDN', 'إندونيسيا'),
(34051, 1893203968, 1893728255, 'KR', 'KOR', 'جمهورية كوريا'),
(34052, 1893728256, 1896480767, 'CN', 'CHN', 'الصين'),
(34053, 1896480768, 1896497151, 'KR', 'KOR', 'جمهورية كوريا'),
(34054, 1896497152, 1896513535, 'SG', 'SGP', 'سنغافورة'),
(34055, 1896513536, 1896546303, 'HK', 'HKG', 'هونغ كونغ'),
(34056, 1896546304, 1896579071, 'BD', 'BGD', 'بنغالاديش'),
(34057, 1896579072, 1896587263, 'ID', 'IDN', 'إندونيسيا'),
(34058, 1896587264, 1896591359, 'SG', 'SGP', 'سنغافورة'),
(34059, 1896591360, 1896593407, 'ID', 'IDN', 'إندونيسيا'),
(34060, 1896593408, 1896595455, 'AU', 'AUS', 'أستراليا'),
(34061, 1896595456, 1896603647, 'CN', 'CHN', 'الصين'),
(34062, 1896603648, 1896605695, 'IN', 'IND', 'الهند'),
(34063, 1896605696, 1896607743, 'AU', 'AUS', 'أستراليا'),
(34064, 1896607744, 1896609791, 'VU', 'VUT', 'فانواتو'),
(34065, 1896609792, 1896611839, 'AU', 'AUS', 'أستراليا'),
(34066, 1896611840, 1897070591, 'CN', 'CHN', 'الصين'),
(34067, 1897070592, 1897136127, 'IN', 'IND', 'الهند'),
(34068, 1897136128, 1897140223, 'AU', 'AUS', 'أستراليا'),
(34069, 1897140224, 1897141247, 'IN', 'IND', 'الهند'),
(34070, 1897141248, 1897142271, 'HK', 'HKG', 'هونغ كونغ'),
(34071, 1897142272, 1897144319, 'AU', 'AUS', 'أستراليا'),
(34072, 1897144320, 1897152511, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(34073, 1897152512, 1897160703, 'FJ', 'FJI', 'فيجي'),
(34074, 1897160704, 1897170943, 'AU', 'AUS', 'أستراليا'),
(34075, 1897170944, 1897172991, 'ID', 'IDN', 'إندونيسيا'),
(34076, 1897172992, 1897175039, 'SG', 'SGP', 'سنغافورة'),
(34077, 1897175040, 1897176063, 'JP', 'JPN', 'اليابان'),
(34078, 1897176064, 1897177087, 'SG', 'SGP', 'سنغافورة'),
(34079, 1897177088, 1897185279, 'PH', 'PHL', 'الفلبين'),
(34080, 1897185280, 1897201663, 'JP', 'JPN', 'اليابان'),
(34081, 1897201664, 1897209855, 'KR', 'KOR', 'جمهورية كوريا'),
(34082, 1897209856, 1897213951, 'AU', 'AUS', 'أستراليا'),
(34083, 1897213952, 1897218047, 'JP', 'JPN', 'اليابان'),
(34084, 1897218048, 1897222143, 'IN', 'IND', 'الهند'),
(34085, 1897222144, 1897226239, 'TW', 'TWN', 'تايوان'),
(34086, 1897226240, 1897234431, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(34087, 1897234432, 1897242623, 'AU', 'AUS', 'أستراليا'),
(34088, 1897242624, 1897250815, 'TW', 'TWN', 'تايوان'),
(34089, 1897250816, 1897259007, 'HK', 'HKG', 'هونغ كونغ'),
(34090, 1897259008, 1897260031, 'NZ', 'NZL', 'نيوزيلاندا'),
(34091, 1897260032, 1897261055, 'BD', 'BGD', 'بنغالاديش'),
(34092, 1897261056, 1897263103, 'JP', 'JPN', 'اليابان'),
(34093, 1897263104, 1897265151, 'TH', 'THA', 'تايلند'),
(34094, 1897265152, 1897267199, 'JP', 'JPN', 'اليابان'),
(34095, 1897267200, 1897365503, 'VN', 'VNM', 'فييتنام'),
(34096, 1897365504, 1897398271, 'MY', 'MYS', 'ماليزيا'),
(34097, 1897398272, 1897660415, 'CN', 'CHN', 'الصين'),
(34098, 1897660416, 1897725951, 'HK', 'HKG', 'هونغ كونغ'),
(34099, 1897725952, 1897725983, 'JP', 'JPN', 'اليابان'),
(34100, 1897725984, 1897725999, 'AU', 'AUS', 'أستراليا'),
(34101, 1897726000, 1897726015, 'JP', 'JPN', 'اليابان'),
(34102, 1897726016, 1897734143, 'AU', 'AUS', 'أستراليا'),
(34103, 1897734144, 1897734159, 'HK', 'HKG', 'هونغ كونغ'),
(34104, 1897734160, 1897734223, 'AU', 'AUS', 'أستراليا'),
(34105, 1897734224, 1897734239, 'KR', 'KOR', 'جمهورية كوريا'),
(34106, 1897734240, 1897738239, 'AU', 'AUS', 'أستراليا'),
(34107, 1897738240, 1897738255, 'KR', 'KOR', 'جمهورية كوريا'),
(34108, 1897738256, 1897742335, 'AU', 'AUS', 'أستراليا'),
(34109, 1897742336, 1897742383, 'SG', 'SGP', 'سنغافورة'),
(34110, 1897742384, 1897758719, 'AU', 'AUS', 'أستراليا'),
(34111, 1897758720, 1897779199, 'KR', 'KOR', 'جمهورية كوريا'),
(34112, 1897779200, 1897781247, 'AU', 'AUS', 'أستراليا'),
(34113, 1897781248, 1897783295, 'JP', 'JPN', 'اليابان'),
(34114, 1897783296, 1897787391, 'SG', 'SGP', 'سنغافورة'),
(34115, 1897787392, 1897789439, 'AU', 'AUS', 'أستراليا'),
(34116, 1897789440, 1897790463, 'KH', 'KHM', 'كامبوديا'),
(34117, 1897790464, 1897791487, 'HK', 'HKG', 'هونغ كونغ'),
(34118, 1897791488, 1897824255, 'KR', 'KOR', 'جمهورية كوريا'),
(34119, 1897824256, 1897857023, 'IN', 'IND', 'الهند'),
(34120, 1897857024, 1897922559, 'CN', 'CHN', 'الصين'),
(34121, 1897922560, 1898708991, 'JP', 'JPN', 'اليابان'),
(34122, 1898708992, 1899233279, 'CN', 'CHN', 'الصين'),
(34123, 1899233280, 1899241471, 'AU', 'AUS', 'أستراليا'),
(34124, 1899241472, 1899249663, 'VN', 'VNM', 'فييتنام'),
(34125, 1899249664, 1899266047, 'MO', 'MAC', 'ماكاو'),
(34126, 1899266048, 1899268095, 'AU', 'AUS', 'أستراليا'),
(34127, 1899268096, 1899270143, 'KR', 'KOR', 'جمهورية كوريا'),
(34128, 1899270144, 1899272191, 'AU', 'AUS', 'أستراليا'),
(34129, 1899272192, 1899273215, 'SG', 'SGP', 'سنغافورة'),
(34130, 1899273216, 1899274239, 'JP', 'JPN', 'اليابان'),
(34131, 1899274240, 1899282431, 'CN', 'CHN', 'الصين'),
(34132, 1899282432, 1899290623, 'KR', 'KOR', 'جمهورية كوريا'),
(34133, 1899290624, 1899298815, 'AU', 'AUS', 'أستراليا'),
(34134, 1899298816, 1899364351, 'TH', 'THA', 'تايلند'),
(34135, 1899364352, 1899724799, 'CN', 'CHN', 'الصين'),
(34136, 1899724800, 1899741183, 'KR', 'KOR', 'جمهورية كوريا'),
(34137, 1899741184, 1899749375, 'LK', 'LKA', 'سيريلانكا'),
(34138, 1899749376, 1899750399, 'AU', 'AUS', 'أستراليا'),
(34139, 1899750400, 1899751423, 'JP', 'JPN', 'اليابان'),
(34140, 1899751424, 1899753471, 'ID', 'IDN', 'إندونيسيا'),
(34141, 1899753472, 1899757567, 'HK', 'HKG', 'هونغ كونغ'),
(34142, 1899757568, 1899831295, 'KR', 'KOR', 'جمهورية كوريا'),
(34143, 1899831296, 1899839487, 'PH', 'PHL', 'الفلبين'),
(34144, 1899839488, 1899849727, 'AU', 'AUS', 'أستراليا'),
(34145, 1899849728, 1899850751, 'KR', 'KOR', 'جمهورية كوريا'),
(34146, 1899850752, 1899851775, 'VN', 'VNM', 'فييتنام'),
(34147, 1899851776, 1899855871, 'JP', 'JPN', 'اليابان'),
(34148, 1899855872, 1899888639, 'TW', 'TWN', 'تايوان'),
(34149, 1899888640, 1904345087, 'CN', 'CHN', 'الصين'),
(34150, 1904345088, 1904361471, 'JP', 'JPN', 'اليابان'),
(34151, 1904361472, 1904369663, 'KR', 'KOR', 'جمهورية كوريا'),
(34152, 1904369664, 1904375807, 'CN', 'CHN', 'الصين'),
(34153, 1904375808, 1904376831, 'NZ', 'NZL', 'نيوزيلاندا'),
(34154, 1904376832, 1904377855, 'AU', 'AUS', 'أستراليا'),
(34155, 1904377856, 1904476159, 'KR', 'KOR', 'جمهورية كوريا'),
(34156, 1904476160, 1905262591, 'CN', 'CHN', 'الصين'),
(34157, 1905262592, 1906311167, 'JP', 'JPN', 'اليابان'),
(34158, 1906311168, 1908408319, 'VN', 'VNM', 'فييتنام'),
(34159, 1908408320, 1908441087, 'AU', 'AUS', 'أستراليا'),
(34160, 1908441088, 1908473855, 'JP', 'JPN', 'اليابان'),
(34161, 1908473856, 1908539391, 'IN', 'IND', 'الهند'),
(34162, 1908539392, 1908670463, 'CN', 'CHN', 'الصين'),
(34163, 1908670464, 1908735999, 'TW', 'TWN', 'تايوان'),
(34164, 1908736000, 1908744191, 'AU', 'AUS', 'أستراليا'),
(34165, 1908744192, 1908746239, 'SG', 'SGP', 'سنغافورة'),
(34166, 1908746240, 1908748287, 'JP', 'JPN', 'اليابان'),
(34167, 1908748288, 1908750335, 'PK', 'PAK', 'باكستان'),
(34168, 1908750336, 1908752383, 'AU', 'AUS', 'أستراليا'),
(34169, 1908752384, 1908753407, 'NZ', 'NZL', 'نيوزيلاندا'),
(34170, 1908753408, 1908754431, 'AU', 'AUS', 'أستراليا'),
(34171, 1908754432, 1908756479, 'PH', 'PHL', 'الفلبين'),
(34172, 1908756480, 1908760575, 'KR', 'KOR', 'جمهورية كوريا'),
(34173, 1908760576, 1908761599, 'NZ', 'NZL', 'نيوزيلاندا'),
(34174, 1908761600, 1908762623, 'AU', 'AUS', 'أستراليا'),
(34175, 1908762624, 1908762879, 'IN', 'IND', 'الهند'),
(34176, 1908762880, 1908763135, 'HK', 'HKG', 'هونغ كونغ'),
(34177, 1908763136, 1908763647, 'IN', 'IND', 'الهند'),
(34178, 1908763648, 1908768767, 'AU', 'AUS', 'أستراليا'),
(34179, 1908768768, 1908801535, 'JP', 'JPN', 'اليابان'),
(34180, 1908801536, 1908899839, 'KR', 'KOR', 'جمهورية كوريا'),
(34181, 1908899840, 1908932607, 'NP', 'NPL', 'نيبال'),
(34182, 1908932608, 1909129215, 'CN', 'CHN', 'الصين'),
(34183, 1909129216, 1909194751, 'AU', 'AUS', 'أستراليا'),
(34184, 1909194752, 1909456895, 'CN', 'CHN', 'الصين'),
(34185, 1909456896, 1909473279, 'JP', 'JPN', 'اليابان'),
(34186, 1909473280, 1909473791, 'ID', 'IDN', 'إندونيسيا'),
(34187, 1909473792, 1909475327, 'HK', 'HKG', 'هونغ كونغ'),
(34188, 1909475328, 1909475839, 'PK', 'PAK', 'باكستان'),
(34189, 1909475840, 1909477631, 'HK', 'HKG', 'هونغ كونغ'),
(34190, 1909477632, 1909477887, 'IQ', 'IRQ', 'العراق'),
(34191, 1909477888, 1909478655, 'HK', 'HKG', 'هونغ كونغ'),
(34192, 1909478656, 1909478911, 'BD', 'BGD', 'بنغالاديش'),
(34193, 1909478912, 1909481471, 'HK', 'HKG', 'هونغ كونغ'),
(34194, 1909481472, 1909587967, 'CN', 'CHN', 'الصين'),
(34195, 1909587968, 1909719039, 'MY', 'MYS', 'ماليزيا'),
(34196, 1909719040, 1909735423, 'CN', 'CHN', 'الصين'),
(34197, 1909735424, 1909743615, 'IN', 'IND', 'الهند'),
(34198, 1909743616, 1909745663, 'AU', 'AUS', 'أستراليا'),
(34199, 1909745664, 1909746687, 'JP', 'JPN', 'اليابان'),
(34200, 1909746688, 1909747711, 'MY', 'MYS', 'ماليزيا'),
(34201, 1909747712, 1909751807, 'ID', 'IDN', 'إندونيسيا'),
(34202, 1909751808, 1909759999, 'JP', 'JPN', 'اليابان'),
(34203, 1909760000, 1909762047, 'ID', 'IDN', 'إندونيسيا'),
(34204, 1909762048, 1909764095, 'AU', 'AUS', 'أستراليا'),
(34205, 1909764096, 1909766143, 'PH', 'PHL', 'الفلبين'),
(34206, 1909766144, 1909768191, 'AU', 'AUS', 'أستراليا'),
(34207, 1909768192, 1909784575, 'HK', 'HKG', 'هونغ كونغ'),
(34208, 1909784576, 1909817343, 'CN', 'CHN', 'الصين'),
(34209, 1909817344, 1909850111, 'JP', 'JPN', 'اليابان'),
(34210, 1909850112, 1909981183, 'CN', 'CHN', 'الصين'),
(34211, 1909981184, 1910112255, 'KR', 'KOR', 'جمهورية كوريا'),
(34212, 1910112256, 1912340479, 'CN', 'CHN', 'الصين'),
(34213, 1912340480, 1912602623, 'HK', 'HKG', 'هونغ كونغ'),
(34214, 1912602624, 1913651199, 'ID', 'IDN', 'إندونيسيا'),
(34215, 1913651200, 1914109951, 'JP', 'JPN', 'اليابان'),
(34216, 1914109952, 1914175487, 'AU', 'AUS', 'أستراليا'),
(34217, 1914175488, 1914437631, 'TW', 'TWN', 'تايوان'),
(34218, 1914437632, 1914503167, 'CN', 'CHN', 'الصين'),
(34219, 1914503168, 1914552319, 'KR', 'KOR', 'جمهورية كوريا'),
(34220, 1914552320, 1914560511, 'SG', 'SGP', 'سنغافورة'),
(34221, 1914560512, 1914568703, 'KH', 'KHM', 'كامبوديا'),
(34222, 1914568704, 1914576895, 'KR', 'KOR', 'جمهورية كوريا'),
(34223, 1914576896, 1914580991, 'TW', 'TWN', 'تايوان'),
(34224, 1914580992, 1914585087, 'KR', 'KOR', 'جمهورية كوريا'),
(34225, 1914585088, 1914587135, 'AU', 'AUS', 'أستراليا'),
(34226, 1914587136, 1914589183, 'IN', 'IND', 'الهند'),
(34227, 1914589184, 1914593279, 'ID', 'IDN', 'إندونيسيا'),
(34228, 1914593280, 1914601471, 'AU', 'AUS', 'أستراليا'),
(34229, 1914601472, 1914634239, 'KR', 'KOR', 'جمهورية كوريا'),
(34230, 1914634240, 1914642431, 'BD', 'BGD', 'بنغالاديش'),
(34231, 1914642432, 1914650623, 'KR', 'KOR', 'جمهورية كوريا'),
(34232, 1914650624, 1914652671, 'MN', 'MNG', 'منغوليا'),
(34233, 1914652672, 1914654719, 'AU', 'AUS', 'أستراليا'),
(34234, 1914654720, 1914658815, 'JP', 'JPN', 'اليابان'),
(34235, 1914658816, 1914662911, 'AU', 'AUS', 'أستراليا'),
(34236, 1914662912, 1914667007, 'KR', 'KOR', 'جمهورية كوريا'),
(34237, 1914667008, 1914683391, 'IN', 'IND', 'الهند'),
(34238, 1914683392, 1914691583, 'AU', 'AUS', 'أستراليا'),
(34239, 1914691584, 1914695679, 'IN', 'IND', 'الهند'),
(34240, 1914695680, 1914697727, 'ID', 'IDN', 'إندونيسيا'),
(34241, 1914697728, 1914699775, 'IN', 'IND', 'الهند'),
(34242, 1914699776, 1915748351, 'TW', 'TWN', 'تايوان'),
(34243, 1915748352, 1916010495, 'JP', 'JPN', 'اليابان'),
(34244, 1916010496, 1916141567, 'KR', 'KOR', 'جمهورية كوريا'),
(34245, 1916141568, 1916272639, 'CN', 'CHN', 'الصين'),
(34246, 1916272640, 1916534783, 'ID', 'IDN', 'إندونيسيا'),
(34247, 1916534784, 1917124607, 'CN', 'CHN', 'الصين'),
(34248, 1917124608, 1917169663, 'JP', 'JPN', 'اليابان'),
(34249, 1917169664, 1917177855, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(34250, 1917177856, 1917181951, 'AU', 'AUS', 'أستراليا'),
(34251, 1917181952, 1917190143, 'IN', 'IND', 'الهند'),
(34252, 1917190144, 1917321215, 'KR', 'KOR', 'جمهورية كوريا'),
(34253, 1917321216, 1917779967, 'AU', 'AUS', 'أستراليا'),
(34254, 1917779968, 1917796351, 'ID', 'IDN', 'إندونيسيا'),
(34255, 1917796352, 1917845503, 'IN', 'IND', 'الهند'),
(34256, 1917845504, 1918894079, 'AU', 'AUS', 'أستراليا'),
(34257, 1918894080, 1919680511, 'CN', 'CHN', 'الصين'),
(34258, 1919680512, 1919729663, 'KR', 'KOR', 'جمهورية كوريا'),
(34259, 1919729664, 1919746047, 'PH', 'PHL', 'الفلبين'),
(34260, 1919746048, 1919811583, 'TH', 'THA', 'تايلند'),
(34261, 1919811584, 1919815679, 'CN', 'CHN', 'الصين'),
(34262, 1919815680, 1919817727, 'ID', 'IDN', 'إندونيسيا'),
(34263, 1919817728, 1919819775, 'KR', 'KOR', 'جمهورية كوريا'),
(34264, 1919819776, 1919821823, 'NZ', 'NZL', 'نيوزيلاندا'),
(34265, 1919821824, 1919823871, 'AU', 'AUS', 'أستراليا'),
(34266, 1919823872, 1919827967, 'JP', 'JPN', 'اليابان'),
(34267, 1919827968, 1919844351, 'CN', 'CHN', 'الصين'),
(34268, 1919844352, 1919877119, 'AU', 'AUS', 'أستراليا'),
(34269, 1919877120, 1919885311, 'CN', 'CHN', 'الصين'),
(34270, 1919885312, 1919893503, 'KR', 'KOR', 'جمهورية كوريا'),
(34271, 1919893504, 1919909887, 'JP', 'JPN', 'اليابان'),
(34272, 1919909888, 1919918079, 'AU', 'AUS', 'أستراليا'),
(34273, 1919918080, 1919926271, 'CN', 'CHN', 'الصين'),
(34274, 1919926272, 1919942655, 'KR', 'KOR', 'جمهورية كوريا'),
(34275, 1919942656, 1920466943, 'CN', 'CHN', 'الصين'),
(34276, 1920466944, 1920991231, 'ID', 'IDN', 'إندونيسيا'),
(34277, 1920991232, 1921056767, 'TH', 'THA', 'تايلند'),
(34278, 1921056768, 1921058815, 'JP', 'JPN', 'اليابان'),
(34279, 1921058816, 1921060863, 'BD', 'BGD', 'بنغالاديش'),
(34280, 1921060864, 1921062911, 'ID', 'IDN', 'إندونيسيا'),
(34281, 1921062912, 1921064959, 'LA', 'LAO', 'لاو'),
(34282, 1921064960, 1921069055, 'SG', 'SGP', 'سنغافورة'),
(34283, 1921069056, 1921073151, 'JP', 'JPN', 'اليابان'),
(34284, 1921073152, 1921089535, 'KR', 'KOR', 'جمهورية كوريا'),
(34285, 1921089536, 1921105919, 'AU', 'AUS', 'أستراليا'),
(34286, 1921105920, 1921122303, 'KR', 'KOR', 'جمهورية كوريا'),
(34287, 1921122304, 1921187839, 'BD', 'BGD', 'بنغالاديش'),
(34288, 1921187840, 1921253375, 'AU', 'AUS', 'أستراليا'),
(34289, 1921253376, 1921318911, 'CN', 'CHN', 'الصين'),
(34290, 1921318912, 1921384447, 'MY', 'MYS', 'ماليزيا'),
(34291, 1921384448, 1921388543, 'NZ', 'NZL', 'نيوزيلاندا'),
(34292, 1921388544, 1921392639, 'AU', 'AUS', 'أستراليا'),
(34293, 1921392640, 1921400831, 'JP', 'JPN', 'اليابان'),
(34294, 1921400832, 1921404927, 'ID', 'IDN', 'إندونيسيا'),
(34295, 1921404928, 1921405183, 'HK', 'HKG', 'هونغ كونغ'),
(34296, 1921405184, 1921405439, 'ID', 'IDN', 'إندونيسيا'),
(34297, 1921405440, 1921406975, 'HK', 'HKG', 'هونغ كونغ'),
(34298, 1921406976, 1921409023, 'BD', 'BGD', 'بنغالاديش'),
(34299, 1921409024, 1921425407, 'JP', 'JPN', 'اليابان'),
(34300, 1921425408, 1921431551, 'NZ', 'NZL', 'نيوزيلاندا'),
(34301, 1921431552, 1921433599, 'AU', 'AUS', 'أستراليا'),
(34302, 1921433600, 1921449983, 'JP', 'JPN', 'اليابان'),
(34303, 1921449984, 1921515519, 'CN', 'CHN', 'الصين'),
(34304, 1921515520, 1921646591, 'TW', 'TWN', 'تايوان'),
(34305, 1921646592, 1921777663, 'CN', 'CHN', 'الصين'),
(34306, 1921777664, 1921843199, 'TW', 'TWN', 'تايوان'),
(34307, 1921843200, 1921851391, 'KR', 'KOR', 'جمهورية كوريا'),
(34308, 1921851392, 1921853439, 'JP', 'JPN', 'اليابان'),
(34309, 1921853440, 1921855487, 'KR', 'KOR', 'جمهورية كوريا'),
(34310, 1921855488, 1921859583, 'ID', 'IDN', 'إندونيسيا'),
(34311, 1921859584, 1921861631, 'AU', 'AUS', 'أستراليا'),
(34312, 1921861632, 1921863679, 'SG', 'SGP', 'سنغافورة'),
(34313, 1921863680, 1921865727, 'BD', 'BGD', 'بنغالاديش'),
(34314, 1921865728, 1921867775, 'ID', 'IDN', 'إندونيسيا'),
(34315, 1921867776, 1921875967, 'AU', 'AUS', 'أستراليا'),
(34316, 1921875968, 1921892351, 'CN', 'CHN', 'الصين'),
(34317, 1921892352, 1921900543, 'AU', 'AUS', 'أستراليا'),
(34318, 1921900544, 1921908735, 'KR', 'KOR', 'جمهورية كوريا'),
(34319, 1921908736, 1921943551, 'JP', 'JPN', 'اليابان'),
(34320, 1921943552, 1921945599, 'IN', 'IND', 'الهند'),
(34321, 1921945600, 1921949695, 'HK', 'HKG', 'هونغ كونغ'),
(34322, 1921949696, 1921957887, 'AU', 'AUS', 'أستراليا'),
(34323, 1921957888, 1921966079, 'GU', 'GUM', 'غوام'),
(34324, 1921966080, 1921974271, 'AU', 'AUS', 'أستراليا'),
(34325, 1921974272, 1922039807, 'IN', 'IND', 'الهند'),
(34326, 1922039808, 1925447679, 'JP', 'JPN', 'اليابان'),
(34327, 1925447680, 1925578751, 'CN', 'CHN', 'الصين'),
(34328, 1925578752, 1925611519, 'AU', 'AUS', 'أستراليا'),
(34329, 1925611520, 1925619711, 'PH', 'PHL', 'الفلبين'),
(34330, 1925619712, 1925627903, 'TW', 'TWN', 'تايوان'),
(34331, 1925627904, 1925638143, 'JP', 'JPN', 'اليابان'),
(34332, 1925638144, 1925638399, 'SA', 'SAU', 'السعودية'),
(34333, 1925638400, 1925638655, 'PK', 'PAK', 'باكستان'),
(34334, 1925638656, 1925638911, 'KW', 'KWT', 'الكويت'),
(34335, 1925638912, 1925639679, 'EG', 'EGY', 'مصر'),
(34336, 1925639680, 1925639935, 'KW', 'KWT', 'الكويت'),
(34337, 1925639936, 1925640191, 'SA', 'SAU', 'السعودية'),
(34338, 1925640192, 1925642239, 'ID', 'IDN', 'إندونيسيا'),
(34339, 1925642240, 1925644287, 'AU', 'AUS', 'أستراليا'),
(34340, 1925644288, 1925660671, 'KR', 'KOR', 'جمهورية كوريا'),
(34341, 1925660672, 1925664767, 'HK', 'HKG', 'هونغ كونغ'),
(34342, 1925664768, 1925677055, 'ID', 'IDN', 'إندونيسيا'),
(34343, 1925677056, 1926234111, 'KR', 'KOR', 'جمهورية كوريا'),
(34344, 1926234112, 1929379839, 'CN', 'CHN', 'الصين'),
(34345, 1929379840, 1930952703, 'KR', 'KOR', 'جمهورية كوريا'),
(34346, 1930952704, 1931345919, 'CN', 'CHN', 'الصين'),
(34347, 1931345920, 1931354111, 'JP', 'JPN', 'اليابان'),
(34348, 1931354112, 1931362303, 'AU', 'AUS', 'أستراليا'),
(34349, 1931362304, 1931378687, 'TW', 'TWN', 'تايوان'),
(34350, 1931378688, 1931427839, 'JP', 'JPN', 'اليابان'),
(34351, 1931427840, 1931431935, 'PH', 'PHL', 'الفلبين'),
(34352, 1931431936, 1931433983, 'JP', 'JPN', 'اليابان'),
(34353, 1931433984, 1931436031, 'AU', 'AUS', 'أستراليا'),
(34354, 1931436032, 1931444223, 'KR', 'KOR', 'جمهورية كوريا'),
(34355, 1931444224, 1931460607, 'TH', 'THA', 'تايلند'),
(34356, 1931460608, 1931468799, 'JP', 'JPN', 'اليابان'),
(34357, 1931468800, 1931476991, 'SG', 'SGP', 'سنغافورة'),
(34358, 1931476992, 1931739135, 'CN', 'CHN', 'الصين'),
(34359, 1931739136, 1932001279, 'JP', 'JPN', 'اليابان'),
(34360, 1932001280, 1932132351, 'KR', 'KOR', 'جمهورية كوريا'),
(34361, 1932132352, 1932148735, 'AU', 'AUS', 'أستراليا'),
(34362, 1932148736, 1932152831, 'PK', 'PAK', 'باكستان'),
(34363, 1932152832, 1932156927, 'AU', 'AUS', 'أستراليا'),
(34364, 1932156928, 1932161023, 'JP', 'JPN', 'اليابان'),
(34365, 1932161024, 1932163071, 'TW', 'TWN', 'تايوان'),
(34366, 1932163072, 1932165119, 'PH', 'PHL', 'الفلبين'),
(34367, 1932165120, 1932197887, 'SG', 'SGP', 'سنغافورة'),
(34368, 1932197888, 1932263423, 'TW', 'TWN', 'تايوان'),
(34369, 1932263424, 1933574143, 'CN', 'CHN', 'الصين'),
(34370, 1933574144, 1933639679, 'AU', 'AUS', 'أستراليا'),
(34371, 1933639680, 1933705215, 'JP', 'JPN', 'اليابان'),
(34372, 1933705216, 1933770751, 'SG', 'SGP', 'سنغافورة'),
(34373, 1933770752, 1933836287, 'TH', 'THA', 'تايلند'),
(34374, 1933836288, 1933901823, 'KR', 'KOR', 'جمهورية كوريا'),
(34375, 1933901824, 1933922303, 'AU', 'AUS', 'أستراليا'),
(34376, 1933922304, 1933926399, 'IN', 'IND', 'الهند'),
(34377, 1933926400, 1933934591, 'KR', 'KOR', 'جمهورية كوريا'),
(34378, 1933934592, 1933942783, 'IN', 'IND', 'الهند'),
(34379, 1933942784, 1933950975, 'AU', 'AUS', 'أستراليا'),
(34380, 1933950976, 1933955071, 'JP', 'JPN', 'اليابان'),
(34381, 1933955072, 1933957119, 'BD', 'BGD', 'بنغالاديش'),
(34382, 1933957120, 1933959167, 'ID', 'IDN', 'إندونيسيا'),
(34383, 1933959168, 1933963263, 'JP', 'JPN', 'اليابان'),
(34384, 1933963264, 1933967359, 'IN', 'IND', 'الهند'),
(34385, 1933967360, 1934098431, 'AU', 'AUS', 'أستراليا'),
(34386, 1934098432, 1934622719, 'VN', 'VNM', 'فييتنام'),
(34387, 1934622720, 1934884863, 'TW', 'TWN', 'تايوان'),
(34388, 1934884864, 1934901247, 'CN', 'CHN', 'الصين'),
(34389, 1934901248, 1934917631, 'LA', 'LAO', 'لاو'),
(34390, 1934917632, 1934925823, 'MV', 'MDV', 'جزر المالديف'),
(34391, 1934925824, 1934927871, 'KR', 'KOR', 'جمهورية كوريا'),
(34392, 1934927872, 1934929919, 'PH', 'PHL', 'الفلبين'),
(34393, 1934929920, 1934931967, 'VN', 'VNM', 'فييتنام'),
(34394, 1934931968, 1934934015, 'JP', 'JPN', 'اليابان'),
(34395, 1934934016, 1934942207, 'CN', 'CHN', 'الصين'),
(34396, 1934942208, 1934966783, 'PH', 'PHL', 'الفلبين'),
(34397, 1934966784, 1934974975, 'ID', 'IDN', 'إندونيسيا'),
(34398, 1934974976, 1934983167, 'JP', 'JPN', 'اليابان'),
(34399, 1934983168, 1934983423, 'MY', 'MYS', 'ماليزيا'),
(34400, 1934983424, 1934987263, 'AU', 'AUS', 'أستراليا'),
(34401, 1934987264, 1934991359, 'TW', 'TWN', 'تايوان'),
(34402, 1934991360, 1934999551, 'KR', 'KOR', 'جمهورية كوريا'),
(34403, 1934999552, 1935015935, 'CN', 'CHN', 'الصين'),
(34404, 1935015936, 1935081471, 'KR', 'KOR', 'جمهورية كوريا'),
(34405, 1935081472, 1935147007, 'TH', 'THA', 'تايلند'),
(34406, 1935147008, 1935671295, 'KR', 'KOR', 'جمهورية كوريا'),
(34407, 1935671296, 1935933439, 'IN', 'IND', 'الهند'),
(34408, 1935933440, 1936457727, 'CN', 'CHN', 'الصين'),
(34409, 1936457728, 1937244159, 'IN', 'IND', 'الهند'),
(34410, 1937244160, 1937506303, 'CN', 'CHN', 'الصين'),
(34411, 1937506304, 1937510399, 'AU', 'AUS', 'أستراليا'),
(34412, 1937510400, 1937514495, 'CN', 'CHN', 'الصين'),
(34413, 1937514496, 1937522687, 'AU', 'AUS', 'أستراليا'),
(34414, 1937522688, 1937530879, 'ID', 'IDN', 'إندونيسيا'),
(34415, 1937530880, 1937532927, 'US', 'USA', 'الولايات المتحدة'),
(34416, 1937532928, 1937533439, 'IN', 'IND', 'الهند'),
(34417, 1937533440, 1937534463, 'US', 'USA', 'الولايات المتحدة'),
(34418, 1937534464, 1937534975, 'GB', 'GBR', 'المملكة المتحدة'),
(34419, 1937534976, 1937535743, 'US', 'USA', 'الولايات المتحدة'),
(34420, 1937535744, 1937535999, 'IN', 'IND', 'الهند'),
(34421, 1937536000, 1937536511, 'GB', 'GBR', 'المملكة المتحدة'),
(34422, 1937536512, 1937537023, 'US', 'USA', 'الولايات المتحدة'),
(34423, 1937537024, 1937539071, 'IN', 'IND', 'الهند'),
(34424, 1937539072, 1937637375, 'JP', 'JPN', 'اليابان'),
(34425, 1937637376, 1937670143, 'HK', 'HKG', 'هونغ كونغ'),
(34426, 1937670144, 1937672191, 'NZ', 'NZL', 'نيوزيلاندا'),
(34427, 1937672192, 1937674239, 'AU', 'AUS', 'أستراليا'),
(34428, 1937674240, 1937678335, 'JP', 'JPN', 'اليابان'),
(34429, 1937678336, 1937682431, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(34430, 1937682432, 1937686527, 'AU', 'AUS', 'أستراليا'),
(34431, 1937686528, 1937702911, 'KR', 'KOR', 'جمهورية كوريا'),
(34432, 1937702912, 1937768447, 'BD', 'BGD', 'بنغالاديش'),
(34433, 1937768448, 1938030591, 'AU', 'AUS', 'أستراليا'),
(34434, 1938030592, 1938292735, 'MY', 'MYS', 'ماليزيا'),
(34435, 1938292736, 1938948095, 'KR', 'KOR', 'جمهورية كوريا'),
(34436, 1938948096, 1938964479, 'JP', 'JPN', 'اليابان'),
(34437, 1938964480, 1938972671, 'AU', 'AUS', 'أستراليا'),
(34438, 1938972672, 1938976767, 'MY', 'MYS', 'ماليزيا'),
(34439, 1938976768, 1938978815, 'SG', 'SGP', 'سنغافورة'),
(34440, 1938978816, 1938980863, 'VN', 'VNM', 'فييتنام'),
(34441, 1938980864, 1939079167, 'PH', 'PHL', 'الفلبين'),
(34442, 1939079168, 1939865599, 'CN', 'CHN', 'الصين'),
(34443, 1939865600, 1939898367, 'KR', 'KOR', 'جمهورية كوريا'),
(34444, 1939898368, 1939914751, 'HK', 'HKG', 'هونغ كونغ'),
(34445, 1939914752, 1939931135, 'IN', 'IND', 'الهند'),
(34446, 1939931136, 1939996671, 'KR', 'KOR', 'جمهورية كوريا'),
(34447, 1939996672, 1940127743, 'JP', 'JPN', 'اليابان'),
(34448, 1940127744, 1940193279, 'MY', 'MYS', 'ماليزيا'),
(34449, 1940193280, 1940234239, 'JP', 'JPN', 'اليابان'),
(34450, 1940234240, 1940236287, 'VN', 'VNM', 'فييتنام'),
(34451, 1940236288, 1940238335, 'AU', 'AUS', 'أستراليا'),
(34452, 1940238336, 1940240383, 'KR', 'KOR', 'جمهورية كوريا'),
(34453, 1940240384, 1940242431, 'JP', 'JPN', 'اليابان'),
(34454, 1940242432, 1940258815, 'TW', 'TWN', 'تايوان'),
(34455, 1940258816, 1940283391, 'AU', 'AUS', 'أستراليا'),
(34456, 1940283392, 1940291583, 'ID', 'IDN', 'إندونيسيا'),
(34457, 1940291584, 1940295679, 'HK', 'HKG', 'هونغ كونغ'),
(34458, 1940295680, 1940324351, 'JP', 'JPN', 'اليابان'),
(34459, 1940324352, 1940357119, 'PK', 'PAK', 'باكستان'),
(34460, 1940357120, 1940389887, 'JP', 'JPN', 'اليابان'),
(34461, 1940389888, 1940914175, 'CN', 'CHN', 'الصين'),
(34462, 1940914176, 1941046271, 'JP', 'JPN', 'اليابان'),
(34463, 1941046272, 1941048319, 'AU', 'AUS', 'أستراليا'),
(34464, 1941048320, 1941048831, 'SG', 'SGP', 'سنغافورة'),
(34465, 1941048832, 1941051391, 'AU', 'AUS', 'أستراليا'),
(34466, 1941051392, 1941052415, 'KH', 'KHM', 'كامبوديا'),
(34467, 1941052416, 1941053439, 'AU', 'AUS', 'أستراليا'),
(34468, 1941053440, 1941057535, 'KR', 'KOR', 'جمهورية كوريا'),
(34469, 1941057536, 1941059583, 'ID', 'IDN', 'إندونيسيا'),
(34470, 1941059584, 1941061631, 'TH', 'THA', 'تايلند'),
(34471, 1941061632, 1941069823, 'KR', 'KOR', 'جمهورية كوريا'),
(34472, 1941069824, 1941071871, 'IN', 'IND', 'الهند'),
(34473, 1941071872, 1941073919, 'AU', 'AUS', 'أستراليا'),
(34474, 1941073920, 1941075967, 'JP', 'JPN', 'اليابان'),
(34475, 1941075968, 1941110783, 'ID', 'IDN', 'إندونيسيا'),
(34476, 1941110784, 1941176319, 'JP', 'JPN', 'اليابان'),
(34477, 1941176320, 1941438463, 'CN', 'CHN', 'الصين'),
(34478, 1941438464, 1941569535, 'IN', 'IND', 'الهند'),
(34479, 1941569536, 1941618687, 'PK', 'PAK', 'باكستان'),
(34480, 1941618688, 1941635071, 'AU', 'AUS', 'أستراليا'),
(34481, 1941635072, 1941639167, 'IN', 'IND', 'الهند'),
(34482, 1941639168, 1941643263, 'NP', 'NPL', 'نيبال'),
(34483, 1941643264, 1941651455, 'IN', 'IND', 'الهند'),
(34484, 1941651456, 1941655551, 'JP', 'JPN', 'اليابان'),
(34485, 1941655552, 1941657599, 'KR', 'KOR', 'جمهورية كوريا'),
(34486, 1941657600, 1941658623, 'MN', 'MNG', 'منغوليا'),
(34487, 1941658624, 1941659647, 'JP', 'JPN', 'اليابان'),
(34488, 1941659648, 1941667839, 'NZ', 'NZL', 'نيوزيلاندا'),
(34489, 1941667840, 1941700607, 'AU', 'AUS', 'أستراليا'),
(34490, 1941700608, 1941831679, 'NZ', 'NZL', 'نيوزيلاندا'),
(34491, 1941831680, 1941962751, 'AU', 'AUS', 'أستراليا'),
(34492, 1941962752, 1945108479, 'CN', 'CHN', 'الصين'),
(34493, 1945108480, 1946157055, 'IN', 'IND', 'الهند'),
(34494, 1946157056, 1946159103, 'ID', 'IDN', 'إندونيسيا'),
(34495, 1946159104, 1946165247, 'AU', 'AUS', 'أستراليا'),
(34496, 1946165248, 1946173439, 'PK', 'PAK', 'باكستان'),
(34497, 1946173440, 1946173503, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(34498, 1946173504, 1946173519, 'SG', 'SGP', 'سنغافورة'),
(34499, 1946173520, 1946173535, 'MY', 'MYS', 'ماليزيا'),
(34500, 1946173536, 1946173567, 'AU', 'AUS', 'أستراليا'),
(34501, 1946173568, 1946173631, 'HK', 'HKG', 'هونغ كونغ'),
(34502, 1946173632, 1946173663, 'AU', 'AUS', 'أستراليا'),
(34503, 1946173664, 1946173679, 'PH', 'PHL', 'الفلبين'),
(34504, 1946173680, 1946173687, 'TW', 'TWN', 'تايوان'),
(34505, 1946173688, 1946173695, 'AU', 'AUS', 'أستراليا'),
(34506, 1946173696, 1946173951, 'TW', 'TWN', 'تايوان'),
(34507, 1946173952, 1946174463, 'AU', 'AUS', 'أستراليا'),
(34508, 1946174464, 1946174720, 'SG', 'SGP', 'سنغافورة'),
(34509, 1946174721, 1946175487, 'AU', 'AUS', 'أستراليا'),
(34510, 1946175488, 1946176511, 'SY', 'SYR', 'سوريا'),
(34511, 1946176512, 1946176767, 'PH', 'PHL', 'الفلبين'),
(34512, 1946176768, 1946177535, 'AU', 'AUS', 'أستراليا'),
(34513, 1946177536, 1946177791, 'SG', 'SGP', 'سنغافورة'),
(34514, 1946177792, 1946181631, 'AU', 'AUS', 'أستراليا'),
(34515, 1946181632, 1946189823, 'MY', 'MYS', 'ماليزيا'),
(34516, 1946189824, 1946222591, 'JP', 'JPN', 'اليابان'),
(34517, 1946222592, 1946943487, 'CN', 'CHN', 'الصين'),
(34518, 1946943488, 1946951679, 'JP', 'JPN', 'اليابان'),
(34519, 1946951680, 1946953727, 'BD', 'BGD', 'بنغالاديش'),
(34520, 1946953728, 1946955775, 'ID', 'IDN', 'إندونيسيا'),
(34521, 1946955776, 1946957823, 'SG', 'SGP', 'سنغافورة'),
(34522, 1946957824, 1946959871, 'AU', 'AUS', 'أستراليا'),
(34523, 1946959872, 1946976255, 'LK', 'LKA', 'سيريلانكا'),
(34524, 1946976256, 1947009023, 'SG', 'SGP', 'سنغافورة'),
(34525, 1947009024, 1947074559, 'CN', 'CHN', 'الصين'),
(34526, 1947074560, 1947205631, 'SG', 'SGP', 'سنغافورة'),
(34527, 1947205632, 1948254207, 'CN', 'CHN', 'الصين'),
(34528, 1948254208, 1949302783, 'KR', 'KOR', 'جمهورية كوريا'),
(34529, 1949302784, 1949433855, 'HK', 'HKG', 'هونغ كونغ'),
(34530, 1949433856, 1949439999, 'AU', 'AUS', 'أستراليا'),
(34531, 1949440000, 1949442047, 'ID', 'IDN', 'إندونيسيا'),
(34532, 1949442048, 1949446143, 'TW', 'TWN', 'تايوان'),
(34533, 1949446144, 1949448191, 'JP', 'JPN', 'اليابان'),
(34534, 1949448192, 1949450239, 'AU', 'AUS', 'أستراليا'),
(34535, 1949450240, 1949466623, 'IN', 'IND', 'الهند'),
(34536, 1949466624, 1949499391, 'PH', 'PHL', 'الفلبين'),
(34537, 1949499392, 1949564927, 'SG', 'SGP', 'سنغافورة'),
(34538, 1949564928, 1949958143, 'CN', 'CHN', 'الصين'),
(34539, 1949958144, 1949990911, 'PK', 'PAK', 'باكستان'),
(34540, 1949990912, 1949995007, 'CN', 'CHN', 'الصين'),
(34541, 1949995008, 1950007295, 'JP', 'JPN', 'اليابان'),
(34542, 1950007296, 1950009343, 'ID', 'IDN', 'إندونيسيا'),
(34543, 1950009344, 1950011391, 'BD', 'BGD', 'بنغالاديش'),
(34544, 1950011392, 1950015487, 'CN', 'CHN', 'الصين'),
(34545, 1950015488, 1950023679, 'TH', 'THA', 'تايلند'),
(34546, 1950023680, 1950089215, 'TW', 'TWN', 'تايوان'),
(34547, 1950089216, 1950351359, 'CN', 'CHN', 'الصين'),
(34548, 1950351360, 1950482431, 'JP', 'JPN', 'اليابان'),
(34549, 1950482432, 1950515199, 'CN', 'CHN', 'الصين'),
(34550, 1950515200, 1950518271, 'US', 'USA', 'الولايات المتحدة'),
(34551, 1950518272, 1950518783, 'UK', 'GBR', 'المملكة المتحدة'),
(34552, 1950518784, 1950519295, 'NL', 'NLD', 'هولندا'),
(34553, 1950519296, 1950523391, 'IN', 'IND', 'الهند'),
(34554, 1950523392, 1950531583, 'AU', 'AUS', 'أستراليا'),
(34555, 1950531584, 1950533631, 'NP', 'NPL', 'نيبال'),
(34556, 1950533632, 1950535679, 'ID', 'IDN', 'إندونيسيا'),
(34557, 1950535680, 1950539775, 'HK', 'HKG', 'هونغ كونغ'),
(34558, 1950539776, 1950543871, 'AU', 'AUS', 'أستراليا'),
(34559, 1950543872, 1950545919, 'NZ', 'NZL', 'نيوزيلاندا'),
(34560, 1950545920, 1950547967, 'PH', 'PHL', 'الفلبين'),
(34561, 1950547968, 1950580735, 'KR', 'KOR', 'جمهورية كوريا'),
(34562, 1950580736, 1950613503, 'AU', 'AUS', 'أستراليا'),
(34563, 1950613504, 1950617599, 'GU', 'GUM', 'غوام'),
(34564, 1950617600, 1950621695, 'AU', 'AUS', 'أستراليا'),
(34565, 1950621696, 1950629887, 'KR', 'KOR', 'جمهورية كوريا'),
(34566, 1950629888, 1950646271, 'IN', 'IND', 'الهند'),
(34567, 1950646272, 1950648319, 'VN', 'VNM', 'فييتنام'),
(34568, 1950648320, 1950650367, 'PH', 'PHL', 'الفلبين'),
(34569, 1950650368, 1950654463, 'TH', 'THA', 'تايلند'),
(34570, 1950654464, 1950658559, 'ID', 'IDN', 'إندونيسيا'),
(34571, 1950658560, 1950660607, 'PH', 'PHL', 'الفلبين'),
(34572, 1950660608, 1950661127, 'AU', 'AUS', 'أستراليا'),
(34573, 1950661128, 1950661135, 'HK', 'HKG', 'هونغ كونغ'),
(34574, 1950661136, 1950662655, 'AU', 'AUS', 'أستراليا'),
(34575, 1950662656, 1950666751, 'BD', 'BGD', 'بنغالاديش'),
(34576, 1950666752, 1950668799, 'NP', 'NPL', 'نيبال'),
(34577, 1950668800, 1950670847, 'JP', 'JPN', 'اليابان'),
(34578, 1950670848, 1950672895, 'ID', 'IDN', 'إندونيسيا'),
(34579, 1950672896, 1950674943, 'KR', 'KOR', 'جمهورية كوريا'),
(34580, 1950674944, 1950676991, 'IN', 'IND', 'الهند'),
(34581, 1950676992, 1950679039, 'ID', 'IDN', 'إندونيسيا'),
(34582, 1950679040, 1950777343, 'CN', 'CHN', 'الصين'),
(34583, 1950777344, 1950793727, 'JP', 'JPN', 'اليابان'),
(34584, 1950793728, 1950810111, 'AU', 'AUS', 'أستراليا'),
(34585, 1950810112, 1950875647, 'PK', 'PAK', 'باكستان'),
(34586, 1950875648, 1951137791, 'IN', 'IND', 'الهند'),
(34587, 1951137792, 1951399935, 'CN', 'CHN', 'الصين'),
(34588, 1951399936, 1951662079, 'JP', 'JPN', 'اليابان'),
(34589, 1951662080, 1951727615, 'KR', 'KOR', 'جمهورية كوريا'),
(34590, 1951727616, 1951793151, 'AU', 'AUS', 'أستراليا'),
(34591, 1951793152, 1952022527, 'SG', 'SGP', 'سنغافورة'),
(34592, 1952022528, 1952026623, 'TW', 'TWN', 'تايوان'),
(34593, 1952026624, 1952030719, 'CN', 'CHN', 'الصين'),
(34594, 1952030720, 1952038911, 'KR', 'KOR', 'جمهورية كوريا'),
(34595, 1952038912, 1952047103, 'JP', 'JPN', 'اليابان'),
(34596, 1952047104, 1952051199, 'NZ', 'NZL', 'نيوزيلاندا'),
(34597, 1952051200, 1952071679, 'AU', 'AUS', 'أستراليا'),
(34598, 1952071680, 1952073727, 'HK', 'HKG', 'هونغ كونغ'),
(34599, 1952073728, 1952074751, 'AU', 'AUS', 'أستراليا'),
(34600, 1952074752, 1952075775, 'NZ', 'NZL', 'نيوزيلاندا'),
(34601, 1952075776, 1952079871, 'CN', 'CHN', 'الصين'),
(34602, 1952079872, 1952088063, 'PK', 'PAK', 'باكستان'),
(34603, 1952088064, 1952092159, 'NZ', 'NZL', 'نيوزيلاندا'),
(34604, 1952092160, 1952096255, 'JP', 'JPN', 'اليابان'),
(34605, 1952096256, 1952102399, 'ID', 'IDN', 'إندونيسيا'),
(34606, 1952102400, 1952104447, 'CN', 'CHN', 'الصين'),
(34607, 1952104448, 1952108543, 'JP', 'JPN', 'اليابان'),
(34608, 1952108544, 1952110591, 'ID', 'IDN', 'إندونيسيا'),
(34609, 1952110592, 1952112639, 'KR', 'KOR', 'جمهورية كوريا'),
(34610, 1952112640, 1952116735, 'NP', 'NPL', 'نيبال'),
(34611, 1952116736, 1952120831, 'IN', 'IND', 'الهند'),
(34612, 1952120832, 1952186367, 'JP', 'JPN', 'اليابان'),
(34613, 1952186368, 1952251903, 'HK', 'HKG', 'هونغ كونغ'),
(34614, 1952251904, 1952268575, 'PH', 'PHL', 'الفلبين'),
(34615, 1952268576, 1952268607, 'SG', 'SGP', 'سنغافورة'),
(34616, 1952268608, 1952284671, 'PH', 'PHL', 'الفلبين'),
(34617, 1952284672, 1952288767, 'NZ', 'NZL', 'نيوزيلاندا'),
(34618, 1952288768, 1952301055, 'AU', 'AUS', 'أستراليا'),
(34619, 1952301056, 1952317439, 'KR', 'KOR', 'جمهورية كوريا'),
(34620, 1952317440, 1952382975, 'JP', 'JPN', 'اليابان'),
(34621, 1952382976, 1952448511, 'CN', 'CHN', 'الصين'),
(34622, 1952448512, 1953497087, 'VN', 'VNM', 'فييتنام'),
(34623, 1953497088, 1953890303, 'CN', 'CHN', 'الصين'),
(34624, 1953890304, 1953923071, 'VN', 'VNM', 'فييتنام'),
(34625, 1953923072, 1953939455, 'TW', 'TWN', 'تايوان'),
(34626, 1953939456, 1953951743, 'JP', 'JPN', 'اليابان'),
(34627, 1953951744, 1953955839, 'AU', 'AUS', 'أستراليا'),
(34628, 1953955840, 1954021375, 'IN', 'IND', 'الهند'),
(34629, 1954021376, 1954545663, 'KR', 'KOR', 'جمهورية كوريا'),
(34630, 1954545664, 1958805503, 'CN', 'CHN', 'الصين'),
(34631, 1958805504, 1958807551, 'SG', 'SGP', 'سنغافورة'),
(34632, 1958807552, 1958809599, 'MO', 'MAC', 'ماكاو'),
(34633, 1958809600, 1958821887, 'CN', 'CHN', 'الصين'),
(34634, 1958821888, 1958825983, 'VN', 'VNM', 'فييتنام'),
(34635, 1958825984, 1958830079, 'KR', 'KOR', 'جمهورية كوريا'),
(34636, 1958830080, 1958838271, 'JP', 'JPN', 'اليابان'),
(34637, 1958838272, 1958842367, 'IN', 'IND', 'الهند'),
(34638, 1958842368, 1958844415, 'NZ', 'NZL', 'نيوزيلاندا'),
(34639, 1958844416, 1958846463, 'AU', 'AUS', 'أستراليا'),
(34640, 1958846464, 1958848511, 'IN', 'IND', 'الهند'),
(34641, 1958848512, 1958850559, 'BD', 'BGD', 'بنغالاديش'),
(34642, 1958850560, 1958871039, 'AU', 'AUS', 'أستراليا'),
(34643, 1958871040, 1959067647, 'CN', 'CHN', 'الصين'),
(34644, 1959067648, 1959100415, 'MY', 'MYS', 'ماليزيا'),
(34645, 1959100416, 1959102463, 'ID', 'IDN', 'إندونيسيا'),
(34646, 1959102464, 1959104511, 'JP', 'JPN', 'اليابان'),
(34647, 1959104512, 1959108607, 'AU', 'AUS', 'أستراليا'),
(34648, 1959108608, 1959110655, 'NP', 'NPL', 'نيبال'),
(34649, 1959110656, 1959112703, 'JP', 'JPN', 'اليابان'),
(34650, 1959112704, 1959116799, 'HK', 'HKG', 'هونغ كونغ'),
(34651, 1959116800, 1959133183, 'SG', 'SGP', 'سنغافورة'),
(34652, 1959133184, 1959239679, 'CN', 'CHN', 'الصين'),
(34653, 1959239680, 1959241727, 'KR', 'KOR', 'جمهورية كوريا'),
(34654, 1959241728, 1959243775, 'IN', 'IND', 'الهند'),
(34655, 1959243776, 1959247871, 'JP', 'JPN', 'اليابان'),
(34656, 1959247872, 1959251967, 'ID', 'IDN', 'إندونيسيا'),
(34657, 1959251968, 1959256063, 'NZ', 'NZL', 'نيوزيلاندا'),
(34658, 1959256064, 1959264255, 'AU', 'AUS', 'أستراليا'),
(34659, 1959264256, 1959395327, 'KR', 'KOR', 'جمهورية كوريا'),
(34660, 1959395328, 1959526399, 'AU', 'AUS', 'أستراليا'),
(34661, 1959526400, 1959657471, 'CN', 'CHN', 'الصين'),
(34662, 1959657472, 1959723007, 'MY', 'MYS', 'ماليزيا'),
(34663, 1959723008, 1960050687, 'CN', 'CHN', 'الصين'),
(34664, 1960050688, 1960058879, 'KR', 'KOR', 'جمهورية كوريا'),
(34665, 1960058880, 1960069119, 'AU', 'AUS', 'أستراليا'),
(34666, 1960069120, 1960071167, 'ID', 'IDN', 'إندونيسيا'),
(34667, 1960071168, 1960075263, 'TW', 'TWN', 'تايوان'),
(34668, 1960075264, 1960077311, 'ID', 'IDN', 'إندونيسيا'),
(34669, 1960077312, 1960079359, 'BD', 'BGD', 'بنغالاديش'),
(34670, 1960079360, 1960080127, 'HK', 'HKG', 'هونغ كونغ'),
(34671, 1960080128, 1960080383, 'CN', 'CHN', 'الصين'),
(34672, 1960080384, 1960083455, 'HK', 'HKG', 'هونغ كونغ'),
(34673, 1960083456, 1960091647, 'KH', 'KHM', 'كامبوديا'),
(34674, 1960091648, 1960095743, 'CN', 'CHN', 'الصين'),
(34675, 1960095744, 1960097791, 'IN', 'IND', 'الهند'),
(34676, 1960097792, 1960099839, 'BD', 'BGD', 'بنغالاديش'),
(34677, 1960099840, 1960128511, 'AU', 'AUS', 'أستراليا'),
(34678, 1960128512, 1960132607, 'ID', 'IDN', 'إندونيسيا'),
(34679, 1960132608, 1960181759, 'CN', 'CHN', 'الصين'),
(34680, 1960181760, 1960185855, 'TW', 'TWN', 'تايوان'),
(34681, 1960185856, 1960187903, 'JP', 'JPN', 'اليابان'),
(34682, 1960187904, 1960189951, 'IN', 'IND', 'الهند'),
(34683, 1960189952, 1960202239, 'CN', 'CHN', 'الصين'),
(34684, 1960202240, 1960206335, 'JP', 'JPN', 'اليابان'),
(34685, 1960206336, 1960208383, 'SG', 'SGP', 'سنغافورة'),
(34686, 1960208384, 1960209407, 'PH', 'PHL', 'الفلبين'),
(34687, 1960209408, 1960210431, 'SG', 'SGP', 'سنغافورة'),
(34688, 1960210432, 1960210943, 'TH', 'THA', 'تايلند'),
(34689, 1960210944, 1960211455, 'IN', 'IND', 'الهند'),
(34690, 1960211456, 1960212479, 'SG', 'SGP', 'سنغافورة'),
(34691, 1960212480, 1960212991, 'IN', 'IND', 'الهند'),
(34692, 1960212992, 1960213247, 'SG', 'SGP', 'سنغافورة'),
(34693, 1960213248, 1960213503, 'PH', 'PHL', 'الفلبين'),
(34694, 1960213504, 1960214015, 'SG', 'SGP', 'سنغافورة'),
(34695, 1960214016, 1960214271, 'IN', 'IND', 'الهند'),
(34696, 1960214272, 1960214527, 'SG', 'SGP', 'سنغافورة'),
(34697, 1960214528, 1960574975, 'CN', 'CHN', 'الصين'),
(34698, 1960574976, 1960837119, 'JP', 'JPN', 'اليابان'),
(34699, 1960837120, 1961885695, 'CN', 'CHN', 'الصين'),
(34700, 1961885696, 1962016767, 'AU', 'AUS', 'أستراليا'),
(34701, 1962016768, 1962541055, 'CN', 'CHN', 'الصين'),
(34702, 1962541056, 1962672127, 'AU', 'AUS', 'أستراليا'),
(34703, 1962672128, 1962803199, 'CN', 'CHN', 'الصين'),
(34704, 1962803200, 1962827775, 'JP', 'JPN', 'اليابان'),
(34705, 1962827776, 1962829823, 'ID', 'IDN', 'إندونيسيا'),
(34706, 1962829824, 1962831871, 'JP', 'JPN', 'اليابان'),
(34707, 1962831872, 1962835967, 'ID', 'IDN', 'إندونيسيا'),
(34708, 1962835968, 1962868735, 'CN', 'CHN', 'الصين'),
(34709, 1962868736, 1962901503, 'AU', 'AUS', 'أستراليا'),
(34710, 1962901504, 1962934271, 'CN', 'CHN', 'الصين'),
(34711, 1962934272, 1963458559, 'VN', 'VNM', 'فييتنام'),
(34712, 1963458560, 1963982847, 'CN', 'CHN', 'الصين'),
(34713, 1963982848, 1964113919, 'KR', 'KOR', 'جمهورية كوريا'),
(34714, 1964113920, 1964118015, 'HK', 'HKG', 'هونغ كونغ'),
(34715, 1964118016, 1964120063, 'ID', 'IDN', 'إندونيسيا'),
(34716, 1964120064, 1964122111, 'JP', 'JPN', 'اليابان'),
(34717, 1964122112, 1964126207, 'SG', 'SGP', 'سنغافورة'),
(34718, 1964126208, 1964126463, 'HK', 'HKG', 'هونغ كونغ'),
(34719, 1964126464, 1964130303, 'SG', 'SGP', 'سنغافورة'),
(34720, 1964130304, 1964134399, 'HK', 'HKG', 'هونغ كونغ'),
(34721, 1964134400, 1964136447, 'NZ', 'NZL', 'نيوزيلاندا'),
(34722, 1964136448, 1964138495, 'AU', 'AUS', 'أستراليا'),
(34723, 1964138496, 1964146687, 'HK', 'HKG', 'هونغ كونغ'),
(34724, 1964146688, 1964171263, 'JP', 'JPN', 'اليابان'),
(34725, 1964171264, 1964173311, 'BD', 'BGD', 'بنغالاديش'),
(34726, 1964173312, 1964175359, 'AU', 'AUS', 'أستراليا'),
(34727, 1964175360, 1964179455, 'PK', 'PAK', 'باكستان'),
(34728, 1964179456, 1964244991, 'TW', 'TWN', 'تايوان'),
(34729, 1964244992, 1964249087, 'AU', 'AUS', 'أستراليا'),
(34730, 1964249088, 1964253183, 'PK', 'PAK', 'باكستان'),
(34731, 1964253184, 1964255231, 'WF', 'WLF', 'واليس وفوتونا'),
(34732, 1964255232, 1964257279, 'SG', 'SGP', 'سنغافورة'),
(34733, 1964257280, 1964261375, 'ID', 'IDN', 'إندونيسيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(34734, 1964261376, 1964263423, 'AU', 'AUS', 'أستراليا'),
(34735, 1964263424, 1964265471, 'JP', 'JPN', 'اليابان'),
(34736, 1964265472, 1964269567, 'KR', 'KOR', 'جمهورية كوريا'),
(34737, 1964269568, 1964273663, 'AU', 'AUS', 'أستراليا'),
(34738, 1964273664, 1964275711, 'KH', 'KHM', 'كامبوديا'),
(34739, 1964275712, 1964277759, 'GU', 'GUM', 'غوام'),
(34740, 1964277760, 1964294143, 'SG', 'SGP', 'سنغافورة'),
(34741, 1964294144, 1964310527, 'KR', 'KOR', 'جمهورية كوريا'),
(34742, 1964310528, 1965948927, 'CN', 'CHN', 'الصين'),
(34743, 1965948928, 1966014463, 'JP', 'JPN', 'اليابان'),
(34744, 1966014464, 1966079999, 'TH', 'THA', 'تايلند'),
(34745, 1966080000, 1966342143, 'CN', 'CHN', 'الصين'),
(34746, 1966342144, 1966407679, 'AU', 'AUS', 'أستراليا'),
(34747, 1966407680, 1966417919, 'JP', 'JPN', 'اليابان'),
(34748, 1966417920, 1966419967, 'AU', 'AUS', 'أستراليا'),
(34749, 1966419968, 1966424063, 'CN', 'CHN', 'الصين'),
(34750, 1966424064, 1966440447, 'KR', 'KOR', 'جمهورية كوريا'),
(34751, 1966440448, 1966444543, 'AU', 'AUS', 'أستراليا'),
(34752, 1966444544, 1966446591, 'NZ', 'NZL', 'نيوزيلاندا'),
(34753, 1966446592, 1966452735, 'AU', 'AUS', 'أستراليا'),
(34754, 1966452736, 1966456831, 'CN', 'CHN', 'الصين'),
(34755, 1966456832, 1966473215, 'KR', 'KOR', 'جمهورية كوريا'),
(34756, 1966473216, 1966538751, 'ID', 'IDN', 'إندونيسيا'),
(34757, 1966538752, 1966571519, 'JP', 'JPN', 'اليابان'),
(34758, 1966571520, 1966587903, 'KR', 'KOR', 'جمهورية كوريا'),
(34759, 1966587904, 1966591999, 'AF', 'AFG', 'أفغانستان'),
(34760, 1966592000, 1966596095, 'JP', 'JPN', 'اليابان'),
(34761, 1966596096, 1966600191, 'TW', 'TWN', 'تايوان'),
(34762, 1966600192, 1966602239, 'IN', 'IND', 'الهند'),
(34763, 1966602240, 1966604287, 'KH', 'KHM', 'كامبوديا'),
(34764, 1966604288, 1966669823, 'TW', 'TWN', 'تايوان'),
(34765, 1966669824, 1966768127, 'CN', 'CHN', 'الصين'),
(34766, 1966768128, 1966772223, 'KR', 'KOR', 'جمهورية كوريا'),
(34767, 1966772224, 1966776319, 'JP', 'JPN', 'اليابان'),
(34768, 1966776320, 1966784511, 'SG', 'SGP', 'سنغافورة'),
(34769, 1966784512, 1966792703, 'PH', 'PHL', 'الفلبين'),
(34770, 1966792704, 1966796799, 'JP', 'JPN', 'اليابان'),
(34771, 1966796800, 1966798847, 'BD', 'BGD', 'بنغالاديش'),
(34772, 1966798848, 1966800895, 'AU', 'AUS', 'أستراليا'),
(34773, 1966800896, 1967783935, 'CN', 'CHN', 'الصين'),
(34774, 1967783936, 1967800319, 'JP', 'JPN', 'اليابان'),
(34775, 1967800320, 1967804415, 'CN', 'CHN', 'الصين'),
(34776, 1967804416, 1967812607, 'AU', 'AUS', 'أستراليا'),
(34777, 1967812608, 1967816703, 'ID', 'IDN', 'إندونيسيا'),
(34778, 1967816704, 1969225727, 'CN', 'CHN', 'الصين'),
(34779, 1969225728, 1969487871, 'IN', 'IND', 'الهند'),
(34780, 1969487872, 1969618943, 'CN', 'CHN', 'الصين'),
(34781, 1969618944, 1969635327, 'PK', 'PAK', 'باكستان'),
(34782, 1969635328, 1969651711, 'ID', 'IDN', 'إندونيسيا'),
(34783, 1969651712, 1969659903, 'AU', 'AUS', 'أستراليا'),
(34784, 1969659904, 1969661951, 'ID', 'IDN', 'إندونيسيا'),
(34785, 1969661952, 1969676287, 'JP', 'JPN', 'اليابان'),
(34786, 1969676288, 1969688575, 'ID', 'IDN', 'إندونيسيا'),
(34787, 1969688576, 1969692671, 'CN', 'CHN', 'الصين'),
(34788, 1969692672, 1969694719, 'ID', 'IDN', 'إندونيسيا'),
(34789, 1969694720, 1969696767, 'AU', 'AUS', 'أستراليا'),
(34790, 1969696768, 1969702911, 'ID', 'IDN', 'إندونيسيا'),
(34791, 1969702912, 1969704959, 'AU', 'AUS', 'أستراليا'),
(34792, 1969704960, 1969707007, 'BD', 'BGD', 'بنغالاديش'),
(34793, 1969707008, 1969709055, 'MH', 'MHL', 'جزر مارشال'),
(34794, 1969709056, 1969713151, 'TW', 'TWN', 'تايوان'),
(34795, 1969713152, 1969717247, 'AU', 'AUS', 'أستراليا'),
(34796, 1969717248, 1969721343, 'CN', 'CHN', 'الصين'),
(34797, 1969721344, 1969725439, 'HK', 'HKG', 'هونغ كونغ'),
(34798, 1969725440, 1969727487, 'JP', 'JPN', 'اليابان'),
(34799, 1969727488, 1969729535, 'ID', 'IDN', 'إندونيسيا'),
(34800, 1969729536, 1969733631, 'JP', 'JPN', 'اليابان'),
(34801, 1969733632, 1969750015, 'VN', 'VNM', 'فييتنام'),
(34802, 1969750016, 1969790975, 'JP', 'JPN', 'اليابان'),
(34803, 1969790976, 1969795071, 'AU', 'AUS', 'أستراليا'),
(34804, 1969795072, 1969797119, 'NZ', 'NZL', 'نيوزيلاندا'),
(34805, 1969797120, 1969798143, 'SG', 'SGP', 'سنغافورة'),
(34806, 1969798144, 1969798399, 'CN', 'CHN', 'الصين'),
(34807, 1969798400, 1969799167, 'HK', 'HKG', 'هونغ كونغ'),
(34808, 1969799168, 1969807359, 'ID', 'IDN', 'إندونيسيا'),
(34809, 1969807360, 1969809407, 'AF', 'AFG', 'أفغانستان'),
(34810, 1969809408, 1969811455, 'IN', 'IND', 'الهند'),
(34811, 1969811456, 1969815551, 'PH', 'PHL', 'الفلبين'),
(34812, 1969815552, 1969881087, 'SG', 'SGP', 'سنغافورة'),
(34813, 1969881088, 1970012159, 'CN', 'CHN', 'الصين'),
(34814, 1970012160, 1970143231, 'JP', 'JPN', 'اليابان'),
(34815, 1970143232, 1970274303, 'KR', 'KOR', 'جمهورية كوريا'),
(34816, 1970274304, 1970798591, 'CN', 'CHN', 'الصين'),
(34817, 1970798592, 1970800639, 'SG', 'SGP', 'سنغافورة'),
(34818, 1970800640, 1970803711, 'AU', 'AUS', 'أستراليا'),
(34819, 1970803712, 1970804223, 'HK', 'HKG', 'هونغ كونغ'),
(34820, 1970804224, 1970804735, 'AU', 'AUS', 'أستراليا'),
(34821, 1970804736, 1970806783, 'KH', 'KHM', 'كامبوديا'),
(34822, 1970806784, 1970808831, 'NZ', 'NZL', 'نيوزيلاندا'),
(34823, 1970808832, 1970810879, 'AU', 'AUS', 'أستراليا'),
(34824, 1970810880, 1970812927, 'JP', 'JPN', 'اليابان'),
(34825, 1970812928, 1970814975, 'AU', 'AUS', 'أستراليا'),
(34826, 1970814976, 1970915327, 'CN', 'CHN', 'الصين'),
(34827, 1970915328, 1970917375, 'ID', 'IDN', 'إندونيسيا'),
(34828, 1970917376, 1970921471, 'TH', 'THA', 'تايلند'),
(34829, 1970921472, 1970925567, 'NP', 'NPL', 'نيبال'),
(34830, 1970925568, 1970925823, 'MY', 'MYS', 'ماليزيا'),
(34831, 1970925824, 1970926335, 'SG', 'SGP', 'سنغافورة'),
(34832, 1970926336, 1970926591, 'US', 'USA', 'الولايات المتحدة'),
(34833, 1970926592, 1970926847, 'SG', 'SGP', 'سنغافورة'),
(34834, 1970926848, 1970927103, 'IL', 'ISR', 'إسرائيل'),
(34835, 1970927104, 1970927359, 'SG', 'SGP', 'سنغافورة'),
(34836, 1970927360, 1970927615, 'US', 'USA', 'الولايات المتحدة'),
(34837, 1970927616, 1970929663, 'AU', 'AUS', 'أستراليا'),
(34838, 1970929664, 1970962431, 'VN', 'VNM', 'فييتنام'),
(34839, 1970962432, 1970995199, 'CN', 'CHN', 'الصين'),
(34840, 1970995200, 1971060735, 'KR', 'KOR', 'جمهورية كوريا'),
(34841, 1971060736, 1975517183, 'CN', 'CHN', 'الصين'),
(34842, 1975517184, 1979711487, 'IN', 'IND', 'الهند'),
(34843, 1979711488, 1981284351, 'JP', 'JPN', 'اليابان'),
(34844, 1981284352, 1981808639, 'CN', 'CHN', 'الصين'),
(34845, 1981808640, 1983905791, 'KR', 'KOR', 'جمهورية كوريا'),
(34846, 1983905792, 1984102399, 'CN', 'CHN', 'الصين'),
(34847, 1984102400, 1984118783, 'AU', 'AUS', 'أستراليا'),
(34848, 1984118784, 1984131071, 'JP', 'JPN', 'اليابان'),
(34849, 1984131072, 1984135167, 'CN', 'CHN', 'الصين'),
(34850, 1984135168, 1984151551, 'KR', 'KOR', 'جمهورية كوريا'),
(34851, 1984151552, 1984153599, 'AU', 'AUS', 'أستراليا'),
(34852, 1984153600, 1984155647, 'KH', 'KHM', 'كامبوديا'),
(34853, 1984155648, 1984159743, 'AU', 'AUS', 'أستراليا'),
(34854, 1984159744, 1984167935, 'IN', 'IND', 'الهند'),
(34855, 1984167936, 1984430079, 'VN', 'VNM', 'فييتنام'),
(34856, 1984430080, 1985085439, 'CN', 'CHN', 'الصين'),
(34857, 1985085440, 1985093631, 'ID', 'IDN', 'إندونيسيا'),
(34858, 1985093632, 1985101823, 'AU', 'AUS', 'أستراليا'),
(34859, 1985101824, 1985118207, 'JP', 'JPN', 'اليابان'),
(34860, 1985118208, 1985150975, 'NZ', 'NZL', 'نيوزيلاندا'),
(34861, 1985150976, 1985216511, 'JP', 'JPN', 'اليابان'),
(34862, 1985216512, 1985347583, 'CN', 'CHN', 'الصين'),
(34863, 1985347584, 1985478655, 'JP', 'JPN', 'اليابان'),
(34864, 1985478656, 1985480703, 'IN', 'IND', 'الهند'),
(34865, 1985480704, 1985482751, 'PH', 'PHL', 'الفلبين'),
(34866, 1985482752, 1985486847, 'AU', 'AUS', 'أستراليا'),
(34867, 1985486848, 1985609727, 'CN', 'CHN', 'الصين'),
(34868, 1985609728, 1985675263, 'NZ', 'NZL', 'نيوزيلاندا'),
(34869, 1985675264, 1985708031, 'KR', 'KOR', 'جمهورية كوريا'),
(34870, 1985708032, 1985712127, 'ID', 'IDN', 'إندونيسيا'),
(34871, 1985712128, 1985716223, 'KR', 'KOR', 'جمهورية كوريا'),
(34872, 1985716224, 1985720319, 'NP', 'NPL', 'نيبال'),
(34873, 1985720320, 1985724415, 'IN', 'IND', 'الهند'),
(34874, 1985724416, 1985732607, 'JP', 'JPN', 'اليابان'),
(34875, 1985732608, 1985734655, 'ID', 'IDN', 'إندونيسيا'),
(34876, 1985734656, 1985736703, 'IN', 'IND', 'الهند'),
(34877, 1985736704, 1985740799, 'CN', 'CHN', 'الصين'),
(34878, 1985740800, 1985871871, 'NZ', 'NZL', 'نيوزيلاندا'),
(34879, 1985871872, 1986002943, 'IN', 'IND', 'الهند'),
(34880, 1986002944, 1986199551, 'ID', 'IDN', 'إندونيسيا'),
(34881, 1986199552, 1986202623, 'HK', 'HKG', 'هونغ كونغ'),
(34882, 1986202624, 1986202879, 'TW', 'TWN', 'تايوان'),
(34883, 1986202880, 1986203135, 'VN', 'VNM', 'فييتنام'),
(34884, 1986203136, 1986215935, 'HK', 'HKG', 'هونغ كونغ'),
(34885, 1986215936, 1986232319, 'ID', 'IDN', 'إندونيسيا'),
(34886, 1986232320, 1986265087, 'TW', 'TWN', 'تايوان'),
(34887, 1986265088, 1986396159, 'MY', 'MYS', 'ماليزيا'),
(34888, 1986396160, 1986398207, 'VN', 'VNM', 'فييتنام'),
(34889, 1986398208, 1986400255, 'HK', 'HKG', 'هونغ كونغ'),
(34890, 1986400256, 1986404351, 'CN', 'CHN', 'الصين'),
(34891, 1986404352, 1986406399, 'AU', 'AUS', 'أستراليا'),
(34892, 1986406400, 1986412543, 'JP', 'JPN', 'اليابان'),
(34893, 1986412544, 1986428927, 'AU', 'AUS', 'أستراليا'),
(34894, 1986428928, 1986461695, 'IN', 'IND', 'الهند'),
(34895, 1986461696, 1986496511, 'JP', 'JPN', 'اليابان'),
(34896, 1986496512, 1986498559, 'BT', 'BTN', 'بوتان'),
(34897, 1986498560, 1986502655, 'HK', 'HKG', 'هونغ كونغ'),
(34898, 1986502656, 1986510847, 'KH', 'KHM', 'كامبوديا'),
(34899, 1986510848, 1986519039, 'KR', 'KOR', 'جمهورية كوريا'),
(34900, 1986519040, 1986523135, 'PK', 'PAK', 'باكستان'),
(34901, 1986523136, 1986525183, 'CN', 'CHN', 'الصين'),
(34902, 1986525184, 1986527231, 'BN', 'BRN', 'بروناي دار السلام'),
(34903, 1986527232, 1986723839, 'JP', 'JPN', 'اليابان'),
(34904, 1986723840, 1986756607, 'AU', 'AUS', 'أستراليا'),
(34905, 1986756608, 1986760703, 'PK', 'PAK', 'باكستان'),
(34906, 1986760704, 1986764799, 'AU', 'AUS', 'أستراليا'),
(34907, 1986764800, 1986768895, 'KR', 'KOR', 'جمهورية كوريا'),
(34908, 1986768896, 1986772991, 'AU', 'AUS', 'أستراليا'),
(34909, 1986772992, 1986789375, 'MY', 'MYS', 'ماليزيا'),
(34910, 1986789376, 1987051519, 'JP', 'JPN', 'اليابان'),
(34911, 1987051520, 1988034559, 'CN', 'CHN', 'الصين'),
(34912, 1988034560, 1988083711, 'AU', 'AUS', 'أستراليا'),
(34913, 1988083712, 1988362239, 'KR', 'KOR', 'جمهورية كوريا'),
(34914, 1988362240, 1988624383, 'CN', 'CHN', 'الصين'),
(34915, 1988624384, 1988755455, 'ID', 'IDN', 'إندونيسيا'),
(34916, 1988755456, 1988886527, 'AU', 'AUS', 'أستراليا'),
(34917, 1988886528, 1989148671, 'HK', 'HKG', 'هونغ كونغ'),
(34918, 1989148672, 1989410815, 'CN', 'CHN', 'الصين'),
(34919, 1989410816, 1989541887, 'NZ', 'NZL', 'نيوزيلاندا'),
(34920, 1989541888, 1989607423, 'TW', 'TWN', 'تايوان'),
(34921, 1989607424, 1989660671, 'JP', 'JPN', 'اليابان'),
(34922, 1989660672, 1989661695, 'IN', 'IND', 'الهند'),
(34923, 1989661696, 1989662719, 'ID', 'IDN', 'إندونيسيا'),
(34924, 1989662720, 1989663743, 'AU', 'AUS', 'أستراليا'),
(34925, 1989663744, 1989664767, 'ID', 'IDN', 'إندونيسيا'),
(34926, 1989664768, 1990197247, 'JP', 'JPN', 'اليابان'),
(34927, 1990197248, 1990983679, 'TW', 'TWN', 'تايوان'),
(34928, 1990983680, 1991245823, 'TH', 'THA', 'تايلند'),
(34929, 1991245824, 1991311359, 'KR', 'KOR', 'جمهورية كوريا'),
(34930, 1991311360, 1991376895, 'JP', 'JPN', 'اليابان'),
(34931, 1991376896, 1991442431, 'CN', 'CHN', 'الصين'),
(34932, 1991442432, 1991499775, 'BD', 'BGD', 'بنغالاديش'),
(34933, 1991499776, 1991507967, 'AU', 'AUS', 'أستراليا'),
(34934, 1991507968, 1993342975, 'CN', 'CHN', 'الصين'),
(34935, 1993342976, 1993605119, 'AU', 'AUS', 'أستراليا'),
(34936, 1993605120, 1993736191, 'CN', 'CHN', 'الصين'),
(34937, 1993736192, 1993867263, 'SG', 'SGP', 'سنغافورة'),
(34938, 1993867264, 1994391551, 'KR', 'KOR', 'جمهورية كوريا'),
(34939, 1994391552, 1994850303, 'CN', 'CHN', 'الصين'),
(34940, 1994850304, 1995046911, 'TW', 'TWN', 'تايوان'),
(34941, 1995046912, 1995177983, 'KR', 'KOR', 'جمهورية كوريا'),
(34942, 1995177984, 1995374591, 'JP', 'JPN', 'اليابان'),
(34943, 1995374592, 1995440127, 'CN', 'CHN', 'الصين'),
(34944, 1995440128, 1995571199, 'JP', 'JPN', 'اليابان'),
(34945, 1995571200, 1995636735, 'CN', 'CHN', 'الصين'),
(34946, 1995636736, 1995702271, 'JP', 'JPN', 'اليابان'),
(34947, 1995702272, 1996627967, 'CN', 'CHN', 'الصين'),
(34948, 1996627968, 1996630015, 'PH', 'PHL', 'الفلبين'),
(34949, 1996630016, 1996634111, 'ID', 'IDN', 'إندونيسيا'),
(34950, 1996634112, 1996636159, 'NP', 'NPL', 'نيبال'),
(34951, 1996636160, 1996644351, 'ID', 'IDN', 'إندونيسيا'),
(34952, 1996644352, 1996652543, 'BT', 'BTN', 'بوتان'),
(34953, 1996652544, 1997176831, 'CN', 'CHN', 'الصين'),
(34954, 1997176832, 1997185023, 'AU', 'AUS', 'أستراليا'),
(34955, 1997185024, 1997187071, 'JP', 'JPN', 'اليابان'),
(34956, 1997187072, 1997189119, 'HK', 'HKG', 'هونغ كونغ'),
(34957, 1997189120, 1997191167, 'ID', 'IDN', 'إندونيسيا'),
(34958, 1997191168, 1997209599, 'JP', 'JPN', 'اليابان'),
(34959, 1997209600, 1997242367, 'AU', 'AUS', 'أستراليا'),
(34960, 1997242368, 1997275135, 'ID', 'IDN', 'إندونيسيا'),
(34961, 1997275136, 1997406207, 'AU', 'AUS', 'أستراليا'),
(34962, 1997406208, 1997471743, 'TW', 'TWN', 'تايوان'),
(34963, 1997471744, 1997479935, 'NZ', 'NZL', 'نيوزيلاندا'),
(34964, 1997479936, 1997492223, 'AU', 'AUS', 'أستراليا'),
(34965, 1997492224, 1997496319, 'KH', 'KHM', 'كامبوديا'),
(34966, 1997496320, 1997504511, 'AU', 'AUS', 'أستراليا'),
(34967, 1997504512, 1997506559, 'ID', 'IDN', 'إندونيسيا'),
(34968, 1997506560, 1997508607, 'CN', 'CHN', 'الصين'),
(34969, 1997508608, 1997510655, 'JP', 'JPN', 'اليابان'),
(34970, 1997510656, 1997512703, 'BD', 'BGD', 'بنغالاديش'),
(34971, 1997512704, 1997520895, 'VN', 'VNM', 'فييتنام'),
(34972, 1997520896, 1997537279, 'TW', 'TWN', 'تايوان'),
(34973, 1997537280, 1997602815, 'CN', 'CHN', 'الصين'),
(34974, 1997602816, 1997611007, 'KR', 'KOR', 'جمهورية كوريا'),
(34975, 1997611008, 1997619199, 'AU', 'AUS', 'أستراليا'),
(34976, 1997619200, 1997635583, 'KR', 'KOR', 'جمهورية كوريا'),
(34977, 1997635584, 1997651967, 'AU', 'AUS', 'أستراليا'),
(34978, 1997651968, 1997668351, 'VN', 'VNM', 'فييتنام'),
(34979, 1997668352, 1997701119, 'AU', 'AUS', 'أستراليا'),
(34980, 1997701120, 1997705215, 'VN', 'VNM', 'فييتنام'),
(34981, 1997705216, 1997707263, 'BD', 'BGD', 'بنغالاديش'),
(34982, 1997707264, 1997709311, 'ID', 'IDN', 'إندونيسيا'),
(34983, 1997709312, 1997715455, 'JP', 'JPN', 'اليابان'),
(34984, 1997715456, 1997717503, 'VN', 'VNM', 'فييتنام'),
(34985, 1997717504, 1997723647, 'CN', 'CHN', 'الصين'),
(34986, 1997723648, 1997724495, 'JP', 'JPN', 'اليابان'),
(34987, 1997724496, 1997724543, 'NL', 'NLD', 'هولندا'),
(34988, 1997724544, 1997725695, 'JP', 'JPN', 'اليابان'),
(34989, 1997725696, 1998061567, 'CN', 'CHN', 'الصين'),
(34990, 1998061568, 1998258175, 'JP', 'JPN', 'اليابان'),
(34991, 1998258176, 1998274559, 'SG', 'SGP', 'سنغافورة'),
(34992, 1998274560, 1998290943, 'CN', 'CHN', 'الصين'),
(34993, 1998290944, 1998299135, 'AU', 'AUS', 'أستراليا'),
(34994, 1998299136, 1998454783, 'CN', 'CHN', 'الصين'),
(34995, 1998454784, 1998458879, 'AU', 'AUS', 'أستراليا'),
(34996, 1998458880, 1998462975, 'TW', 'TWN', 'تايوان'),
(34997, 1998462976, 1998467071, 'BD', 'BGD', 'بنغالاديش'),
(34998, 1998467072, 1998471167, 'CN', 'CHN', 'الصين'),
(34999, 1998471168, 1998487551, 'PK', 'PAK', 'باكستان'),
(35000, 1998487552, 1998503935, 'KR', 'KOR', 'جمهورية كوريا'),
(35001, 1998503936, 1998520319, 'JP', 'JPN', 'اليابان'),
(35002, 1998520320, 1998553087, 'TH', 'THA', 'تايلند'),
(35003, 1998553088, 1998561279, 'JP', 'JPN', 'اليابان'),
(35004, 1998561280, 1998561535, 'IN', 'IND', 'الهند'),
(35005, 1998561536, 1998561791, 'SG', 'SGP', 'سنغافورة'),
(35006, 1998561792, 1998562047, 'IN', 'IND', 'الهند'),
(35007, 1998562048, 1998562303, 'TH', 'THA', 'تايلند'),
(35008, 1998562304, 1998562559, 'IN', 'IND', 'الهند'),
(35009, 1998562560, 1998562815, 'CN', 'CHN', 'الصين'),
(35010, 1998562816, 1998563071, 'JP', 'JPN', 'اليابان'),
(35011, 1998563072, 1998563327, 'SG', 'SGP', 'سنغافورة'),
(35012, 1998563328, 1998565375, 'IN', 'IND', 'الهند'),
(35013, 1998565376, 1998569471, 'TW', 'TWN', 'تايوان'),
(35014, 1998569472, 1998577663, 'CN', 'CHN', 'الصين'),
(35015, 1998577664, 1998581759, 'AU', 'AUS', 'أستراليا'),
(35016, 1998581760, 1998585855, 'KR', 'KOR', 'جمهورية كوريا'),
(35017, 1998585856, 1999130623, 'CN', 'CHN', 'الصين'),
(35018, 1999130624, 1999134719, 'BD', 'BGD', 'بنغالاديش'),
(35019, 1999134720, 1999136767, 'MN', 'MNG', 'منغوليا'),
(35020, 1999136768, 1999138815, 'AU', 'AUS', 'أستراليا'),
(35021, 1999138816, 1999142911, 'MY', 'MYS', 'ماليزيا'),
(35022, 1999142912, 1999249407, 'CN', 'CHN', 'الصين'),
(35023, 1999249408, 1999257599, 'AU', 'AUS', 'أستراليا'),
(35024, 1999257600, 1999273983, 'TH', 'THA', 'تايلند'),
(35025, 1999273984, 1999276031, 'AU', 'AUS', 'أستراليا'),
(35026, 1999276032, 1999278079, 'CN', 'CHN', 'الصين'),
(35027, 1999278080, 1999280127, 'AU', 'AUS', 'أستراليا'),
(35028, 1999280128, 1999282175, 'IN', 'IND', 'الهند'),
(35029, 1999282176, 1999290367, 'KR', 'KOR', 'جمهورية كوريا'),
(35030, 1999290368, 1999298559, 'SG', 'SGP', 'سنغافورة'),
(35031, 1999298560, 1999306751, 'CN', 'CHN', 'الصين'),
(35032, 1999306752, 1999372287, 'IN', 'IND', 'الهند'),
(35033, 1999372288, 1999503359, 'CN', 'CHN', 'الصين'),
(35034, 1999503360, 1999568895, 'TH', 'THA', 'تايلند'),
(35035, 1999568896, 1999589375, 'JP', 'JPN', 'اليابان'),
(35036, 1999589376, 1999591423, 'HK', 'HKG', 'هونغ كونغ'),
(35037, 1999591424, 1999593471, 'ID', 'IDN', 'إندونيسيا'),
(35038, 1999593472, 1999597567, 'JP', 'JPN', 'اليابان'),
(35039, 1999597568, 1999601663, 'NZ', 'NZL', 'نيوزيلاندا'),
(35040, 1999601664, 1999634431, 'JP', 'JPN', 'اليابان'),
(35041, 1999634432, 2000158719, 'CN', 'CHN', 'الصين'),
(35042, 2000158720, 2000191487, 'SG', 'SGP', 'سنغافورة'),
(35043, 2000191488, 2000224255, 'AU', 'AUS', 'أستراليا'),
(35044, 2000224256, 2000355327, 'CN', 'CHN', 'الصين'),
(35045, 2000355328, 2000371711, 'KR', 'KOR', 'جمهورية كوريا'),
(35046, 2000371712, 2000373759, 'JP', 'JPN', 'اليابان'),
(35047, 2000373760, 2000374399, 'HK', 'HKG', 'هونغ كونغ'),
(35048, 2000374400, 2000374527, 'US', 'USA', 'الولايات المتحدة'),
(35049, 2000374528, 2000375807, 'HK', 'HKG', 'هونغ كونغ'),
(35050, 2000375808, 2000377855, 'AF', 'AFG', 'أفغانستان'),
(35051, 2000377856, 2000379903, 'JP', 'JPN', 'اليابان'),
(35052, 2000379904, 2000388095, 'AU', 'AUS', 'أستراليا'),
(35053, 2000388096, 2000617471, 'CN', 'CHN', 'الصين'),
(35054, 2000617472, 2000621567, 'PH', 'PHL', 'الفلبين'),
(35055, 2000621568, 2000625663, 'JP', 'JPN', 'اليابان'),
(35056, 2000625664, 2000633855, 'CN', 'CHN', 'الصين'),
(35057, 2000633856, 2000642047, 'TH', 'THA', 'تايلند'),
(35058, 2000642048, 2000646143, 'HK', 'HKG', 'هونغ كونغ'),
(35059, 2000646144, 2000650239, 'JP', 'JPN', 'اليابان'),
(35060, 2000650240, 2000654335, 'PK', 'PAK', 'باكستان'),
(35061, 2000654336, 2000658431, 'AU', 'AUS', 'أستراليا'),
(35062, 2000658432, 2000668671, 'JP', 'JPN', 'اليابان'),
(35063, 2000668672, 2000674815, 'AU', 'AUS', 'أستراليا'),
(35064, 2000674816, 2001207295, 'KR', 'KOR', 'جمهورية كوريا'),
(35065, 2001207296, 2001272831, 'JP', 'JPN', 'اليابان'),
(35066, 2001272832, 2001305599, 'PK', 'PAK', 'باكستان'),
(35067, 2001305600, 2001420287, 'SG', 'SGP', 'سنغافورة'),
(35068, 2001420288, 2001453055, 'KR', 'KOR', 'جمهورية كوريا'),
(35069, 2001453056, 2001457151, 'SG', 'SGP', 'سنغافورة'),
(35070, 2001457152, 2001461247, 'CN', 'CHN', 'الصين'),
(35071, 2001461248, 2001465343, 'JP', 'JPN', 'اليابان'),
(35072, 2001465344, 2001469439, 'TW', 'TWN', 'تايوان'),
(35073, 2001469440, 2001534975, 'TH', 'THA', 'تايلند'),
(35074, 2001534976, 2001559551, 'AU', 'AUS', 'أستراليا'),
(35075, 2001559552, 2001567743, 'KR', 'KOR', 'جمهورية كوريا'),
(35076, 2001567744, 2001600511, 'TW', 'TWN', 'تايوان'),
(35077, 2001600512, 2001862655, 'CN', 'CHN', 'الصين'),
(35078, 2001862656, 2001866751, 'AU', 'AUS', 'أستراليا'),
(35079, 2001866752, 2001870847, 'JP', 'JPN', 'اليابان'),
(35080, 2001870848, 2001879039, 'KR', 'KOR', 'جمهورية كوريا'),
(35081, 2001879040, 2001895423, 'IN', 'IND', 'الهند'),
(35082, 2001895424, 2001899519, 'VN', 'VNM', 'فييتنام'),
(35083, 2001899520, 2001903615, 'AU', 'AUS', 'أستراليا'),
(35084, 2001903616, 2001915903, 'JP', 'JPN', 'اليابان'),
(35085, 2001915904, 2001919999, 'AU', 'AUS', 'أستراليا'),
(35086, 2001920000, 2001926143, 'ID', 'IDN', 'إندونيسيا'),
(35087, 2001926144, 2001928191, 'KH', 'KHM', 'كامبوديا'),
(35088, 2001928192, 2001993727, 'JP', 'JPN', 'اليابان'),
(35089, 2001993728, 2002518015, 'CN', 'CHN', 'الصين'),
(35090, 2002518016, 2002780159, 'PH', 'PHL', 'الفلبين'),
(35091, 2002780160, 2003304447, 'CN', 'CHN', 'الصين'),
(35092, 2003304448, 2003566591, 'JP', 'JPN', 'اليابان'),
(35093, 2003566592, 2003697663, 'CN', 'CHN', 'الصين'),
(35094, 2003697664, 2003714047, 'MY', 'MYS', 'ماليزيا'),
(35095, 2003714048, 2003720191, 'ID', 'IDN', 'إندونيسيا'),
(35096, 2003720192, 2003722239, 'JP', 'JPN', 'اليابان'),
(35097, 2003722240, 2003726335, 'MY', 'MYS', 'ماليزيا'),
(35098, 2003726336, 2003730431, 'ID', 'IDN', 'إندونيسيا'),
(35099, 2003730432, 2003763199, 'MY', 'MYS', 'ماليزيا'),
(35100, 2003763200, 2003828735, 'PH', 'PHL', 'الفلبين'),
(35101, 2003828736, 2006188031, 'CN', 'CHN', 'الصين'),
(35102, 2006188032, 2006204415, 'BD', 'BGD', 'بنغالاديش'),
(35103, 2006204416, 2006212607, 'AU', 'AUS', 'أستراليا'),
(35104, 2006212608, 2006214655, 'TH', 'THA', 'تايلند'),
(35105, 2006214656, 2006216703, 'JP', 'JPN', 'اليابان'),
(35106, 2006216704, 2006228991, 'KR', 'KOR', 'جمهورية كوريا'),
(35107, 2006228992, 2006233087, 'CN', 'CHN', 'الصين'),
(35108, 2006233088, 2006237183, 'AU', 'AUS', 'أستراليا'),
(35109, 2006237184, 2006253567, 'JP', 'JPN', 'اليابان'),
(35110, 2006253568, 2006319103, 'KR', 'KOR', 'جمهورية كوريا'),
(35111, 2006319104, 2006384639, 'JP', 'JPN', 'اليابان'),
(35112, 2006384640, 2006450175, 'IN', 'IND', 'الهند'),
(35113, 2006450176, 2007007231, 'PK', 'PAK', 'باكستان'),
(35114, 2007007232, 2007023615, 'BN', 'BRN', 'بروناي دار السلام'),
(35115, 2007023616, 2007025663, 'IN', 'IND', 'الهند'),
(35116, 2007025664, 2007027711, 'AU', 'AUS', 'أستراليا'),
(35117, 2007027712, 2007031807, 'TH', 'THA', 'تايلند'),
(35118, 2007031808, 2007035903, 'AU', 'AUS', 'أستراليا'),
(35119, 2007035904, 2007039999, 'TW', 'TWN', 'تايوان'),
(35120, 2007040000, 2007048191, 'KR', 'KOR', 'جمهورية كوريا'),
(35121, 2007048192, 2007064575, 'AU', 'AUS', 'أستراليا'),
(35122, 2007064576, 2007066623, 'MY', 'MYS', 'ماليزيا'),
(35123, 2007066624, 2007070719, 'JP', 'JPN', 'اليابان'),
(35124, 2007070720, 2007072767, 'US', 'USA', 'الولايات المتحدة'),
(35125, 2007072768, 2007498751, 'CN', 'CHN', 'الصين'),
(35126, 2007498752, 2008023039, 'JP', 'JPN', 'اليابان'),
(35127, 2008023040, 2009071615, 'CN', 'CHN', 'الصين'),
(35128, 2009071616, 2011168767, 'KR', 'KOR', 'جمهورية كوريا'),
(35129, 2011168768, 2011205631, 'NZ', 'NZL', 'نيوزيلاندا'),
(35130, 2011205632, 2011299839, 'AU', 'AUS', 'أستراليا'),
(35131, 2011299840, 2011430911, 'IN', 'IND', 'الهند'),
(35132, 2011430912, 2011693055, 'JP', 'JPN', 'اليابان'),
(35133, 2011693056, 2011824127, 'CN', 'CHN', 'الصين'),
(35134, 2011824128, 2011889663, 'SG', 'SGP', 'سنغافورة'),
(35135, 2011889664, 2011893759, 'LK', 'LKA', 'سيريلانكا'),
(35136, 2011893760, 2011897855, 'ID', 'IDN', 'إندونيسيا'),
(35137, 2011897856, 2011899903, 'NZ', 'NZL', 'نيوزيلاندا'),
(35138, 2011899904, 2011901951, 'HK', 'HKG', 'هونغ كونغ'),
(35139, 2011901952, 2011906047, 'IN', 'IND', 'الهند'),
(35140, 2011906048, 2011916287, 'FJ', 'FJI', 'فيجي'),
(35141, 2011916288, 2011922431, 'AU', 'AUS', 'أستراليا'),
(35142, 2011922432, 2011938815, 'CN', 'CHN', 'الصين'),
(35143, 2011938816, 2011942911, 'KR', 'KOR', 'جمهورية كوريا'),
(35144, 2011942912, 2011947007, 'ID', 'IDN', 'إندونيسيا'),
(35145, 2011947008, 2011951103, 'JP', 'JPN', 'اليابان'),
(35146, 2011951104, 2011953151, 'KR', 'KOR', 'جمهورية كوريا'),
(35147, 2011953152, 2011955199, 'ID', 'IDN', 'إندونيسيا'),
(35148, 2011955200, 2012086271, 'HK', 'HKG', 'هونغ كونغ'),
(35149, 2012086272, 2012610559, 'JP', 'JPN', 'اليابان'),
(35150, 2012610560, 2012741631, 'HK', 'HKG', 'هونغ كونغ'),
(35151, 2012741632, 2013003775, 'CN', 'CHN', 'الصين'),
(35152, 2013003776, 2013028351, 'AU', 'AUS', 'أستراليا'),
(35153, 2013028352, 2013030399, 'TH', 'THA', 'تايلند'),
(35154, 2013030400, 2013032447, 'ID', 'IDN', 'إندونيسيا'),
(35155, 2013032448, 2013036543, 'FM', 'FSM', 'ولايات ميكرونيزيا الموحدة'),
(35156, 2013036544, 2013038591, 'ID', 'IDN', 'إندونيسيا'),
(35157, 2013038592, 2013040639, 'HK', 'HKG', 'هونغ كونغ'),
(35158, 2013040640, 2013044735, 'IN', 'IND', 'الهند'),
(35159, 2013044736, 2013048831, 'ID', 'IDN', 'إندونيسيا'),
(35160, 2013048832, 2013052927, 'AU', 'AUS', 'أستراليا'),
(35161, 2013052928, 2013061119, 'IN', 'IND', 'الهند'),
(35162, 2013061120, 2013065215, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(35163, 2013065216, 2013069311, 'AU', 'AUS', 'أستراليا'),
(35164, 2013069312, 2014314495, 'CN', 'CHN', 'الصين'),
(35165, 2014314496, 2014838783, 'AU', 'AUS', 'أستراليا'),
(35166, 2014838784, 2015100927, 'CN', 'CHN', 'الصين'),
(35167, 2015100928, 2015166463, 'PH', 'PHL', 'الفلبين'),
(35168, 2015166464, 2015199231, 'AU', 'AUS', 'أستراليا'),
(35169, 2015199232, 2015203327, 'KR', 'KOR', 'جمهورية كوريا'),
(35170, 2015203328, 2015205375, 'JP', 'JPN', 'اليابان'),
(35171, 2015205376, 2015207423, 'ID', 'IDN', 'إندونيسيا'),
(35172, 2015207424, 2015215615, 'JP', 'JPN', 'اليابان'),
(35173, 2015215616, 2015216279, 'HK', 'HKG', 'هونغ كونغ'),
(35174, 2015216280, 2015216319, 'SG', 'SGP', 'سنغافورة'),
(35175, 2015216320, 2015216383, 'HK', 'HKG', 'هونغ كونغ'),
(35176, 2015216384, 2015217151, 'SG', 'SGP', 'سنغافورة'),
(35177, 2015217152, 2015217663, 'JP', 'JPN', 'اليابان'),
(35178, 2015217664, 2015219456, 'GU', 'GUM', 'غوام'),
(35179, 2015219457, 2015219775, 'CA', 'CAN', 'كندا'),
(35180, 2015219776, 2015219815, 'SG', 'SGP', 'سنغافورة'),
(35181, 2015219816, 2015219823, 'PH', 'PHL', 'الفلبين'),
(35182, 2015219824, 2015219839, 'HK', 'HKG', 'هونغ كونغ'),
(35183, 2015219840, 2015219903, 'CA', 'CAN', 'كندا'),
(35184, 2015219904, 2015219935, 'HK', 'HKG', 'هونغ كونغ'),
(35185, 2015219936, 2015219967, 'SG', 'SGP', 'سنغافورة'),
(35186, 2015219968, 2015220223, 'PH', 'PHL', 'الفلبين'),
(35187, 2015220224, 2015220351, 'HK', 'HKG', 'هونغ كونغ'),
(35188, 2015220352, 2015220479, 'ID', 'IDN', 'إندونيسيا'),
(35189, 2015220480, 2015220735, 'HK', 'HKG', 'هونغ كونغ'),
(35190, 2015220736, 2015221247, 'IN', 'IND', 'الهند'),
(35191, 2015221248, 2015221759, 'SG', 'SGP', 'سنغافورة'),
(35192, 2015221760, 2015222015, 'HK', 'HKG', 'هونغ كونغ'),
(35193, 2015222016, 2015222271, 'JP', 'JPN', 'اليابان'),
(35194, 2015222272, 2015222527, 'IN', 'IND', 'الهند'),
(35195, 2015222528, 2015222783, 'CA', 'CAN', 'كندا'),
(35196, 2015222784, 2015223039, 'IN', 'IND', 'الهند'),
(35197, 2015223040, 2015223295, 'CA', 'CAN', 'كندا'),
(35198, 2015223296, 2015223551, 'TH', 'THA', 'تايلند'),
(35199, 2015223552, 2015223679, 'IN', 'IND', 'الهند'),
(35200, 2015223680, 2015223687, 'HK', 'HKG', 'هونغ كونغ'),
(35201, 2015223688, 2015223695, 'SG', 'SGP', 'سنغافورة'),
(35202, 2015223696, 2015223711, 'ID', 'IDN', 'إندونيسيا'),
(35203, 2015223712, 2015223735, 'PH', 'PHL', 'الفلبين'),
(35204, 2015223736, 2015223743, 'MY', 'MYS', 'ماليزيا'),
(35205, 2015223744, 2015223751, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(35206, 2015223752, 2015223759, 'CA', 'CAN', 'كندا'),
(35207, 2015223760, 2015223767, 'JP', 'JPN', 'اليابان'),
(35208, 2015223768, 2015223775, 'SG', 'SGP', 'سنغافورة'),
(35209, 2015223776, 2015223807, 'CA', 'CAN', 'كندا'),
(35210, 2015223808, 2015225855, 'ID', 'IDN', 'إندونيسيا'),
(35211, 2015225856, 2015227903, 'IN', 'IND', 'الهند'),
(35212, 2015227904, 2015231999, 'AU', 'AUS', 'أستراليا'),
(35213, 2015232000, 2016542719, 'CN', 'CHN', 'الصين'),
(35214, 2016542720, 2016550911, 'BD', 'BGD', 'بنغالاديش'),
(35215, 2016550912, 2016555007, 'SG', 'SGP', 'سنغافورة'),
(35216, 2016555008, 2016559103, 'MY', 'MYS', 'ماليزيا'),
(35217, 2016559104, 2016583679, 'KR', 'KOR', 'جمهورية كوريا'),
(35218, 2016583680, 2016585727, 'JP', 'JPN', 'اليابان'),
(35219, 2016585728, 2016587775, 'AU', 'AUS', 'أستراليا'),
(35220, 2016587776, 2016589823, 'BD', 'BGD', 'بنغالاديش'),
(35221, 2016589824, 2016591871, 'VN', 'VNM', 'فييتنام'),
(35222, 2016591872, 2016595967, 'JP', 'JPN', 'اليابان'),
(35223, 2016595968, 2016600063, 'AU', 'AUS', 'أستراليا'),
(35224, 2016600064, 2016673791, 'JP', 'JPN', 'اليابان'),
(35225, 2016673792, 2016935935, 'CN', 'CHN', 'الصين'),
(35226, 2016935936, 2017460223, 'IN', 'IND', 'الهند'),
(35227, 2017460224, 2017984511, 'CN', 'CHN', 'الصين'),
(35228, 2017984512, 2017988607, 'JP', 'JPN', 'اليابان'),
(35229, 2017988608, 2017992703, 'PH', 'PHL', 'الفلبين'),
(35230, 2017992704, 2018000895, 'CN', 'CHN', 'الصين'),
(35231, 2018000896, 2018004991, 'JP', 'JPN', 'اليابان'),
(35232, 2018004992, 2018007039, 'VN', 'VNM', 'فييتنام'),
(35233, 2018007040, 2018009087, 'IN', 'IND', 'الهند'),
(35234, 2018009088, 2018017279, 'VN', 'VNM', 'فييتنام'),
(35235, 2018017280, 2018050047, 'CN', 'CHN', 'الصين'),
(35236, 2018050048, 2018115583, 'KR', 'KOR', 'جمهورية كوريا'),
(35237, 2018115584, 2018246655, 'JP', 'JPN', 'اليابان'),
(35238, 2018246656, 2019033087, 'CN', 'CHN', 'الصين'),
(35239, 2019033088, 2019035135, 'AU', 'AUS', 'أستراليا'),
(35240, 2019035136, 2019037183, 'CN', 'CHN', 'الصين'),
(35241, 2019037184, 2019041279, 'JP', 'JPN', 'اليابان'),
(35242, 2019041280, 2019045375, 'IN', 'IND', 'الهند'),
(35243, 2019045376, 2019098623, 'AU', 'AUS', 'أستراليا'),
(35244, 2019098624, 2019115007, 'PH', 'PHL', 'الفلبين'),
(35245, 2019115008, 2019117055, 'US', 'USA', 'الولايات المتحدة'),
(35246, 2019117056, 2019119103, 'IN', 'IND', 'الهند'),
(35247, 2019119104, 2019121151, 'NZ', 'NZL', 'نيوزيلاندا'),
(35248, 2019121152, 2019123199, 'AU', 'AUS', 'أستراليا'),
(35249, 2019123200, 2019131391, 'NP', 'NPL', 'نيبال'),
(35250, 2019131392, 2019164159, 'JP', 'JPN', 'اليابان'),
(35251, 2019164160, 2019360767, 'CN', 'CHN', 'الصين'),
(35252, 2019360768, 2019426303, 'JP', 'JPN', 'اليابان'),
(35253, 2019426304, 2019557375, 'CN', 'CHN', 'الصين'),
(35254, 2019557376, 2021654527, 'TW', 'TWN', 'تايوان'),
(35255, 2021654528, 2022178815, 'CN', 'CHN', 'الصين'),
(35256, 2022178816, 2022180863, 'NZ', 'NZL', 'نيوزيلاندا'),
(35257, 2022180864, 2022182911, 'AU', 'AUS', 'أستراليا'),
(35258, 2022182912, 2022184959, 'ID', 'IDN', 'إندونيسيا'),
(35259, 2022184960, 2022187007, 'KH', 'KHM', 'كامبوديا'),
(35260, 2022187008, 2022187071, 'US', 'USA', 'الولايات المتحدة'),
(35261, 2022187072, 2022187663, 'HK', 'HKG', 'هونغ كونغ'),
(35262, 2022187664, 2022187679, 'US', 'USA', 'الولايات المتحدة'),
(35263, 2022187680, 2022187719, 'HK', 'HKG', 'هونغ كونغ'),
(35264, 2022187720, 2022187775, 'US', 'USA', 'الولايات المتحدة'),
(35265, 2022187776, 2022187783, 'HK', 'HKG', 'هونغ كونغ'),
(35266, 2022187784, 2022187791, 'US', 'USA', 'الولايات المتحدة'),
(35267, 2022187792, 2022187807, 'HK', 'HKG', 'هونغ كونغ'),
(35268, 2022187808, 2022187831, 'US', 'USA', 'الولايات المتحدة'),
(35269, 2022187832, 2022187839, 'HK', 'HKG', 'هونغ كونغ'),
(35270, 2022187840, 2022187959, 'US', 'USA', 'الولايات المتحدة'),
(35271, 2022187960, 2022187991, 'HK', 'HKG', 'هونغ كونغ'),
(35272, 2022187992, 2022188015, 'US', 'USA', 'الولايات المتحدة'),
(35273, 2022188016, 2022188031, 'HK', 'HKG', 'هونغ كونغ'),
(35274, 2022188032, 2022188063, 'US', 'USA', 'الولايات المتحدة'),
(35275, 2022188064, 2022188071, 'HK', 'HKG', 'هونغ كونغ'),
(35276, 2022188072, 2022188111, 'US', 'USA', 'الولايات المتحدة'),
(35277, 2022188112, 2022188119, 'HK', 'HKG', 'هونغ كونغ'),
(35278, 2022188120, 2022188135, 'US', 'USA', 'الولايات المتحدة'),
(35279, 2022188136, 2022188199, 'HK', 'HKG', 'هونغ كونغ'),
(35280, 2022188200, 2022188223, 'US', 'USA', 'الولايات المتحدة'),
(35281, 2022188224, 2022188239, 'HK', 'HKG', 'هونغ كونغ'),
(35282, 2022188240, 2022188255, 'US', 'USA', 'الولايات المتحدة'),
(35283, 2022188256, 2022188671, 'HK', 'HKG', 'هونغ كونغ'),
(35284, 2022188672, 2022188927, 'US', 'USA', 'الولايات المتحدة'),
(35285, 2022188928, 2022188959, 'HK', 'HKG', 'هونغ كونغ'),
(35286, 2022188960, 2022188991, 'US', 'USA', 'الولايات المتحدة'),
(35287, 2022188992, 2022189199, 'HK', 'HKG', 'هونغ كونغ'),
(35288, 2022189200, 2022189207, 'US', 'USA', 'الولايات المتحدة'),
(35289, 2022189208, 2022189223, 'HK', 'HKG', 'هونغ كونغ'),
(35290, 2022189224, 2022189231, 'US', 'USA', 'الولايات المتحدة'),
(35291, 2022189232, 2022189823, 'HK', 'HKG', 'هونغ كونغ'),
(35292, 2022189824, 2022189831, 'US', 'USA', 'الولايات المتحدة'),
(35293, 2022189832, 2022190335, 'HK', 'HKG', 'هونغ كونغ'),
(35294, 2022190336, 2022190847, 'US', 'USA', 'الولايات المتحدة'),
(35295, 2022190848, 2022191103, 'HK', 'HKG', 'هونغ كونغ'),
(35296, 2022191104, 2022193151, 'NZ', 'NZL', 'نيوزيلاندا'),
(35297, 2022193152, 2022195199, 'AU', 'AUS', 'أستراليا'),
(35298, 2022195200, 2022211583, 'KR', 'KOR', 'جمهورية كوريا'),
(35299, 2022211584, 2022227967, 'CN', 'CHN', 'الصين'),
(35300, 2022227968, 2022244351, 'JP', 'JPN', 'اليابان'),
(35301, 2022244352, 2022277119, 'CN', 'CHN', 'الصين'),
(35302, 2022277120, 2022309887, 'JP', 'JPN', 'اليابان'),
(35303, 2022309888, 2022313983, 'PH', 'PHL', 'الفلبين'),
(35304, 2022313984, 2022316031, 'NZ', 'NZL', 'نيوزيلاندا'),
(35305, 2022316032, 2022318079, 'AU', 'AUS', 'أستراليا'),
(35306, 2022318080, 2022318143, 'HK', 'HKG', 'هونغ كونغ'),
(35307, 2022318144, 2022318207, 'JP', 'JPN', 'اليابان'),
(35308, 2022318208, 2022318239, 'CN', 'CHN', 'الصين'),
(35309, 2022318240, 2022318271, 'IN', 'IND', 'الهند'),
(35310, 2022318272, 2022326271, 'AU', 'AUS', 'أستراليا'),
(35311, 2022326272, 2022330367, 'VN', 'VNM', 'فييتنام'),
(35312, 2022330368, 2022334463, 'MY', 'MYS', 'ماليزيا'),
(35313, 2022334464, 2022342655, 'IN', 'IND', 'الهند'),
(35314, 2022342656, 2022359039, 'JP', 'JPN', 'اليابان'),
(35315, 2022359040, 2022375423, 'IN', 'IND', 'الهند'),
(35316, 2022375424, 2022572031, 'MY', 'MYS', 'ماليزيا'),
(35317, 2022572032, 2022637567, 'KR', 'KOR', 'جمهورية كوريا'),
(35318, 2022637568, 2022662143, 'JP', 'JPN', 'اليابان'),
(35319, 2022662144, 2022678527, 'AU', 'AUS', 'أستراليا'),
(35320, 2022678528, 2022703103, 'KR', 'KOR', 'جمهورية كوريا'),
(35321, 2022703104, 2023751679, 'AU', 'AUS', 'أستراليا'),
(35322, 2023751680, 2025848831, 'ID', 'IDN', 'إندونيسيا'),
(35323, 2025848832, 2030043135, 'CN', 'CHN', 'الصين'),
(35324, 2030043136, 2030047231, 'AU', 'AUS', 'أستراليا'),
(35325, 2030047232, 2030051327, 'CN', 'CHN', 'الصين'),
(35326, 2030051328, 2030057471, 'JP', 'JPN', 'اليابان'),
(35327, 2030057472, 2030059519, 'AU', 'AUS', 'أستراليا'),
(35328, 2030059520, 2030108671, 'KR', 'KOR', 'جمهورية كوريا'),
(35329, 2030108672, 2030125055, 'PH', 'PHL', 'الفلبين'),
(35330, 2030125056, 2030141439, 'KR', 'KOR', 'جمهورية كوريا'),
(35331, 2030141440, 2030305279, 'JP', 'JPN', 'اليابان'),
(35332, 2030305280, 2030436351, 'CN', 'CHN', 'الصين'),
(35333, 2030436352, 2030567423, 'SG', 'SGP', 'سنغافورة'),
(35334, 2030567424, 2032926719, 'CN', 'CHN', 'الصين'),
(35335, 2032926720, 2033057791, 'AU', 'AUS', 'أستراليا'),
(35336, 2033057792, 2033074175, 'CN', 'CHN', 'الصين'),
(35337, 2033074176, 2033090559, 'AU', 'AUS', 'أستراليا'),
(35338, 2033090560, 2033319935, 'CN', 'CHN', 'الصين'),
(35339, 2033319936, 2033321983, 'IN', 'IND', 'الهند'),
(35340, 2033321984, 2033324031, 'AU', 'AUS', 'أستراليا'),
(35341, 2033324032, 2033328127, 'KR', 'KOR', 'جمهورية كوريا'),
(35342, 2033328128, 2033330175, 'ID', 'IDN', 'إندونيسيا'),
(35343, 2033330176, 2033336319, 'JP', 'JPN', 'اليابان'),
(35344, 2033336320, 2033352703, 'KR', 'KOR', 'جمهورية كوريا'),
(35345, 2033352704, 2033356799, 'ID', 'IDN', 'إندونيسيا'),
(35346, 2033356800, 2033358847, 'TW', 'TWN', 'تايوان'),
(35347, 2033358848, 2033362943, 'JP', 'JPN', 'اليابان'),
(35348, 2033362944, 2033364991, 'AU', 'AUS', 'أستراليا'),
(35349, 2033364992, 2033369087, 'TW', 'TWN', 'تايوان'),
(35350, 2033369088, 2033377279, 'AU', 'AUS', 'أستراليا'),
(35351, 2033377280, 2033385471, 'KR', 'KOR', 'جمهورية كوريا'),
(35352, 2033385472, 2033451007, 'CN', 'CHN', 'الصين'),
(35353, 2033451008, 2033487871, 'ID', 'IDN', 'إندونيسيا'),
(35354, 2033487872, 2033491967, 'PK', 'PAK', 'باكستان'),
(35355, 2033491968, 2033500159, 'CN', 'CHN', 'الصين'),
(35356, 2033500160, 2033502207, 'AU', 'AUS', 'أستراليا'),
(35357, 2033502208, 2033504255, 'SG', 'SGP', 'سنغافورة'),
(35358, 2033504256, 2033516543, 'CN', 'CHN', 'الصين'),
(35359, 2033516544, 2033582079, 'KR', 'KOR', 'جمهورية كوريا'),
(35360, 2033582080, 2033614847, 'PH', 'PHL', 'الفلبين'),
(35361, 2033614848, 2033623039, 'AU', 'AUS', 'أستراليا'),
(35362, 2033623040, 2033625087, 'PH', 'PHL', 'الفلبين'),
(35363, 2033625088, 2033625599, 'HK', 'HKG', 'هونغ كونغ'),
(35364, 2033625600, 2033626111, 'CN', 'CHN', 'الصين'),
(35365, 2033626112, 2033627135, 'HK', 'HKG', 'هونغ كونغ'),
(35366, 2033627136, 2033631231, 'AU', 'AUS', 'أستراليا'),
(35367, 2033631232, 2033647615, 'KR', 'KOR', 'جمهورية كوريا'),
(35368, 2033647616, 2033663999, 'CN', 'CHN', 'الصين'),
(35369, 2033664000, 2033696767, 'KR', 'KOR', 'جمهورية كوريا'),
(35370, 2033696768, 2033713151, 'GU', 'GUM', 'غوام'),
(35371, 2033713152, 2033876991, 'CN', 'CHN', 'الصين'),
(35372, 2033876992, 2033879039, 'JP', 'JPN', 'اليابان'),
(35373, 2033879040, 2033881087, 'AU', 'AUS', 'أستراليا'),
(35374, 2033881088, 2033885183, 'CN', 'CHN', 'الصين'),
(35375, 2033885184, 2033887231, 'AU', 'AUS', 'أستراليا'),
(35376, 2033887232, 2033889279, 'IN', 'IND', 'الهند'),
(35377, 2033889280, 2033891327, 'JP', 'JPN', 'اليابان'),
(35378, 2033891328, 2033893375, 'ID', 'IDN', 'إندونيسيا'),
(35379, 2033893376, 2033909759, 'PH', 'PHL', 'الفلبين'),
(35380, 2033909760, 2034213775, 'CN', 'CHN', 'الصين'),
(35381, 2034213776, 2034213779, 'FR', 'FRA', 'فرنسا'),
(35382, 2034213780, 2034213783, 'DE', 'DEU', 'ألمانيا'),
(35383, 2034213784, 2034213787, 'CN', 'CHN', 'الصين'),
(35384, 2034213788, 2034213791, 'SL', 'SLE', 'سيراليون'),
(35385, 2034213792, 2034237439, 'CN', 'CHN', 'الصين'),
(35386, 2034237440, 2034499583, 'KR', 'KOR', 'جمهورية كوريا'),
(35387, 2034499584, 2034761727, 'CN', 'CHN', 'الصين'),
(35388, 2034761728, 2035023871, 'NZ', 'NZL', 'نيوزيلاندا'),
(35389, 2035023872, 2035154943, 'CN', 'CHN', 'الصين'),
(35390, 2035154944, 2035220479, 'KR', 'KOR', 'جمهورية كوريا'),
(35391, 2035220480, 2035253247, 'AU', 'AUS', 'أستراليا'),
(35392, 2035253248, 2035269631, 'CN', 'CHN', 'الصين'),
(35393, 2035269632, 2035279871, 'NZ', 'NZL', 'نيوزيلاندا'),
(35394, 2035279872, 2035286015, 'AU', 'AUS', 'أستراليا'),
(35395, 2035286016, 2035810303, 'JP', 'JPN', 'اليابان'),
(35396, 2035810304, 2035875839, 'KR', 'KOR', 'جمهورية كوريا'),
(35397, 2035875840, 2035941375, 'CN', 'CHN', 'الصين'),
(35398, 2035941376, 2036006911, 'NZ', 'NZL', 'نيوزيلاندا'),
(35399, 2036006912, 2036072447, 'AU', 'AUS', 'أستراليا'),
(35400, 2036072448, 2036334591, 'JP', 'JPN', 'اليابان'),
(35401, 2036334592, 2036465663, 'PH', 'PHL', 'الفلبين'),
(35402, 2036465664, 2036531199, 'NZ', 'NZL', 'نيوزيلاندا'),
(35403, 2036531200, 2036596735, 'AU', 'AUS', 'أستراليا'),
(35404, 2036596736, 2036598783, 'ID', 'IDN', 'إندونيسيا'),
(35405, 2036598784, 2036600831, 'JP', 'JPN', 'اليابان'),
(35406, 2036600832, 2036604927, 'ID', 'IDN', 'إندونيسيا'),
(35407, 2036604928, 2036609023, 'SG', 'SGP', 'سنغافورة'),
(35408, 2036609024, 2036611071, 'AF', 'AFG', 'أفغانستان'),
(35409, 2036611072, 2036613119, 'AU', 'AUS', 'أستراليا'),
(35410, 2036613120, 2036629503, 'KR', 'KOR', 'جمهورية كوريا'),
(35411, 2036629504, 2036662271, 'CN', 'CHN', 'الصين'),
(35412, 2036662272, 2036678655, 'AU', 'AUS', 'أستراليا'),
(35413, 2036678656, 2036695039, 'JP', 'JPN', 'اليابان'),
(35414, 2036695040, 2036697087, 'ID', 'IDN', 'إندونيسيا'),
(35415, 2036697088, 2036699135, 'AU', 'AUS', 'أستراليا'),
(35416, 2036699136, 2036703231, 'IN', 'IND', 'الهند'),
(35417, 2036703232, 2036705279, 'AU', 'AUS', 'أستراليا'),
(35418, 2036705280, 2036707327, 'HK', 'HKG', 'هونغ كونغ'),
(35419, 2036707328, 2036709375, 'MN', 'MNG', 'منغوليا'),
(35420, 2036709376, 2036711423, 'ID', 'IDN', 'إندونيسيا'),
(35421, 2036711424, 2036715519, 'KR', 'KOR', 'جمهورية كوريا'),
(35422, 2036715520, 2036719615, 'CN', 'CHN', 'الصين'),
(35423, 2036719616, 2036727807, 'KR', 'KOR', 'جمهورية كوريا'),
(35424, 2036727808, 2037907455, 'JP', 'JPN', 'اليابان'),
(35425, 2037907456, 2038169599, 'MY', 'MYS', 'ماليزيا'),
(35426, 2038169600, 2038366207, 'KR', 'KOR', 'جمهورية كوريا'),
(35427, 2038366208, 2038374399, 'PH', 'PHL', 'الفلبين'),
(35428, 2038374400, 2038382591, 'AF', 'AFG', 'أفغانستان'),
(35429, 2038382592, 2038415359, 'KR', 'KOR', 'جمهورية كوريا'),
(35430, 2038415360, 2038423551, 'AU', 'AUS', 'أستراليا'),
(35431, 2038423552, 2038431743, 'HK', 'HKG', 'هونغ كونغ'),
(35432, 2038431744, 2042626047, 'KR', 'KOR', 'جمهورية كوريا'),
(35433, 2042626048, 2043150335, 'CN', 'CHN', 'الصين'),
(35434, 2043150336, 2043166719, 'AU', 'AUS', 'أستراليا'),
(35435, 2043166720, 2043183103, 'KR', 'KOR', 'جمهورية كوريا'),
(35436, 2043183104, 2043199487, 'JP', 'JPN', 'اليابان'),
(35437, 2043199488, 2043201535, 'BD', 'BGD', 'بنغالاديش'),
(35438, 2043201536, 2043203583, 'JP', 'JPN', 'اليابان'),
(35439, 2043203584, 2043215871, 'AU', 'AUS', 'أستراليا'),
(35440, 2043215872, 2043281407, 'CN', 'CHN', 'الصين'),
(35441, 2043281408, 2043412479, 'HK', 'HKG', 'هونغ كونغ'),
(35442, 2043412480, 2043674623, 'CN', 'CHN', 'الصين'),
(35443, 2043674624, 2044723199, 'AU', 'AUS', 'أستراليا'),
(35444, 2044723200, 2045771775, 'CN', 'CHN', 'الصين'),
(35445, 2045771776, 2046296063, 'IN', 'IND', 'الهند'),
(35446, 2046296064, 2046558207, 'CN', 'CHN', 'الصين'),
(35447, 2046558208, 2046705663, 'KR', 'KOR', 'جمهورية كوريا'),
(35448, 2046705664, 2046722047, 'TW', 'TWN', 'تايوان'),
(35449, 2046722048, 2046754815, 'KR', 'KOR', 'جمهورية كوريا'),
(35450, 2046754816, 2046820351, 'CN', 'CHN', 'الصين'),
(35451, 2046820352, 2046822399, 'TH', 'THA', 'تايلند'),
(35452, 2046822400, 2046824447, 'KR', 'KOR', 'جمهورية كوريا'),
(35453, 2046824448, 2046828543, 'MY', 'MYS', 'ماليزيا'),
(35454, 2046828544, 2046836735, 'KR', 'KOR', 'جمهورية كوريا'),
(35455, 2046836736, 2046885887, 'CN', 'CHN', 'الصين'),
(35456, 2046885888, 2046951423, 'JP', 'JPN', 'اليابان'),
(35457, 2046951424, 2047082495, 'PH', 'PHL', 'الفلبين'),
(35458, 2047082496, 2047868927, 'CN', 'CHN', 'الصين'),
(35459, 2047868928, 2048917503, 'JP', 'JPN', 'اليابان'),
(35460, 2048917504, 2049966079, 'KR', 'KOR', 'جمهورية كوريا'),
(35461, 2049966080, 2050047999, 'CN', 'CHN', 'الصين'),
(35462, 2050048000, 2050064383, 'KR', 'KOR', 'جمهورية كوريا'),
(35463, 2050064384, 2050080767, 'AU', 'AUS', 'أستراليا'),
(35464, 2050080768, 2050082815, 'JP', 'JPN', 'اليابان'),
(35465, 2050082816, 2050084863, 'AU', 'AUS', 'أستراليا'),
(35466, 2050084864, 2050088959, 'PH', 'PHL', 'الفلبين'),
(35467, 2050088960, 2050091007, 'ID', 'IDN', 'إندونيسيا'),
(35468, 2050091008, 2050097151, 'JP', 'JPN', 'اليابان'),
(35469, 2050097152, 2050101247, 'SG', 'SGP', 'سنغافورة'),
(35470, 2050101248, 2050113535, 'JP', 'JPN', 'اليابان'),
(35471, 2050113536, 2050129591, 'SG', 'SGP', 'سنغافورة'),
(35472, 2050129592, 2050129595, 'US', 'USA', 'الولايات المتحدة'),
(35473, 2050129596, 2050129647, 'SG', 'SGP', 'سنغافورة'),
(35474, 2050129648, 2050129655, 'JP', 'JPN', 'اليابان'),
(35475, 2050129656, 2050129663, 'US', 'USA', 'الولايات المتحدة'),
(35476, 2050129664, 2050129919, 'JP', 'JPN', 'اليابان'),
(35477, 2050129920, 2050162687, 'IN', 'IND', 'الهند'),
(35478, 2050162688, 2050228223, 'CN', 'CHN', 'الصين'),
(35479, 2050228224, 2050490367, 'PH', 'PHL', 'الفلبين'),
(35480, 2050490368, 2051014655, 'NZ', 'NZL', 'نيوزيلاندا'),
(35481, 2051014656, 2053242879, 'CN', 'CHN', 'الصين'),
(35482, 2053242880, 2053308415, 'IN', 'IND', 'الهند'),
(35483, 2053308416, 2053324799, 'TW', 'TWN', 'تايوان'),
(35484, 2053324800, 2053332991, 'AU', 'AUS', 'أستراليا'),
(35485, 2053332992, 2053335039, 'BD', 'BGD', 'بنغالاديش'),
(35486, 2053335040, 2053337087, 'JP', 'JPN', 'اليابان'),
(35487, 2053337088, 2053340159, 'AU', 'AUS', 'أستراليا'),
(35488, 2053340160, 2053341183, 'IN', 'IND', 'الهند'),
(35489, 2053341184, 2053373951, 'KR', 'KOR', 'جمهورية كوريا'),
(35490, 2053373952, 2053378047, 'AU', 'AUS', 'أستراليا'),
(35491, 2053378048, 2053380095, 'JP', 'JPN', 'اليابان'),
(35492, 2053380096, 2053382143, 'AU', 'AUS', 'أستراليا'),
(35493, 2053382144, 2053390335, 'KR', 'KOR', 'جمهورية كوريا'),
(35494, 2053390336, 2053406719, 'TW', 'TWN', 'تايوان'),
(35495, 2053406720, 2053439487, 'MO', 'MAC', 'ماكاو'),
(35496, 2053439488, 2053505023, 'KR', 'KOR', 'جمهورية كوريا'),
(35497, 2053505024, 2053509119, 'CN', 'CHN', 'الصين'),
(35498, 2053509120, 2053513215, 'AU', 'AUS', 'أستراليا'),
(35499, 2053513216, 2053515263, 'BD', 'BGD', 'بنغالاديش'),
(35500, 2053515264, 2053517311, 'AU', 'AUS', 'أستراليا'),
(35501, 2053517312, 2053519359, 'ID', 'IDN', 'إندونيسيا'),
(35502, 2053519360, 2053521407, 'AU', 'AUS', 'أستراليا'),
(35503, 2053521408, 2053529599, 'CN', 'CHN', 'الصين'),
(35504, 2053529600, 2053532671, 'AU', 'AUS', 'أستراليا'),
(35505, 2053532672, 2053533183, 'NZ', 'NZL', 'نيوزيلاندا'),
(35506, 2053533184, 2053537791, 'AU', 'AUS', 'أستراليا'),
(35507, 2053537792, 2053636095, 'JP', 'JPN', 'اليابان'),
(35508, 2053636096, 2054160383, 'AU', 'AUS', 'أستراليا'),
(35509, 2054160384, 2054422527, 'CN', 'CHN', 'الصين'),
(35510, 2054422528, 2054619135, 'TW', 'TWN', 'تايوان'),
(35511, 2054619136, 2054684671, 'CN', 'CHN', 'الصين'),
(35512, 2054684672, 2055208959, 'TW', 'TWN', 'تايوان'),
(35513, 2055208960, 2055213055, 'JP', 'JPN', 'اليابان'),
(35514, 2055213056, 2055217151, 'ID', 'IDN', 'إندونيسيا'),
(35515, 2055217152, 2055229439, 'KR', 'KOR', 'جمهورية كوريا'),
(35516, 2055229440, 2055231487, 'TW', 'TWN', 'تايوان'),
(35517, 2055231488, 2055233535, 'AU', 'AUS', 'أستراليا'),
(35518, 2055233536, 2055235583, 'NP', 'NPL', 'نيبال'),
(35519, 2055235584, 2055237631, 'HK', 'HKG', 'هونغ كونغ'),
(35520, 2055237632, 2055239679, 'JP', 'JPN', 'اليابان'),
(35521, 2055239680, 2055241727, 'AU', 'AUS', 'أستراليا'),
(35522, 2055241728, 2055274495, 'KR', 'KOR', 'جمهورية كوريا'),
(35523, 2055274496, 2055290879, 'AU', 'AUS', 'أستراليا'),
(35524, 2055290880, 2055299071, 'PK', 'PAK', 'باكستان'),
(35525, 2055299072, 2055305215, 'ID', 'IDN', 'إندونيسيا'),
(35526, 2055305216, 2055323647, 'AU', 'AUS', 'أستراليا'),
(35527, 2055323648, 2055327743, 'ID', 'IDN', 'إندونيسيا'),
(35528, 2055327744, 2055329791, 'KR', 'KOR', 'جمهورية كوريا'),
(35529, 2055329792, 2055331839, 'AU', 'AUS', 'أستراليا'),
(35530, 2055331840, 2055335935, 'JP', 'JPN', 'اليابان'),
(35531, 2055335936, 2055340031, 'KR', 'KOR', 'جمهورية كوريا'),
(35532, 2055340032, 2055733247, 'JP', 'JPN', 'اليابان'),
(35533, 2055733248, 2056257535, 'CN', 'CHN', 'الصين'),
(35534, 2056257536, 2056259583, 'ID', 'IDN', 'إندونيسيا'),
(35535, 2056259584, 2056261631, 'BD', 'BGD', 'بنغالاديش'),
(35536, 2056261632, 2056263679, 'IN', 'IND', 'الهند'),
(35537, 2056263680, 2056265727, 'TH', 'THA', 'تايلند'),
(35538, 2056265728, 2056273919, 'TW', 'TWN', 'تايوان'),
(35539, 2056273920, 2056290303, 'PH', 'PHL', 'الفلبين'),
(35540, 2056290304, 2056323071, 'CN', 'CHN', 'الصين'),
(35541, 2056323072, 2056388607, 'JP', 'JPN', 'اليابان'),
(35542, 2056388608, 2056519679, 'TW', 'TWN', 'تايوان'),
(35543, 2056519680, 2056781823, 'AU', 'AUS', 'أستراليا'),
(35544, 2056781824, 2056794111, 'JP', 'JPN', 'اليابان'),
(35545, 2056794112, 2056796159, 'BD', 'BGD', 'بنغالاديش'),
(35546, 2056796160, 2056798207, 'AU', 'AUS', 'أستراليا'),
(35547, 2056798208, 2056806399, 'JP', 'JPN', 'اليابان'),
(35548, 2056806400, 2056814591, 'AU', 'AUS', 'أستراليا'),
(35549, 2056814592, 2056815103, 'JP', 'JPN', 'اليابان'),
(35550, 2056815104, 2056815195, 'HK', 'HKG', 'هونغ كونغ'),
(35551, 2056815196, 2056815215, 'JP', 'JPN', 'اليابان'),
(35552, 2056815216, 2056815343, 'HK', 'HKG', 'هونغ كونغ'),
(35553, 2056815344, 2056815391, 'JP', 'JPN', 'اليابان'),
(35554, 2056815392, 2056815487, 'HK', 'HKG', 'هونغ كونغ'),
(35555, 2056815488, 2056815519, 'JP', 'JPN', 'اليابان'),
(35556, 2056815520, 2056815615, 'HK', 'HKG', 'هونغ كونغ'),
(35557, 2056815616, 2056816031, 'JP', 'JPN', 'اليابان'),
(35558, 2056816032, 2056816047, 'NZ', 'NZL', 'نيوزيلاندا'),
(35559, 2056816048, 2056816159, 'JP', 'JPN', 'اليابان'),
(35560, 2056816160, 2056816191, 'PH', 'PHL', 'الفلبين'),
(35561, 2056816192, 2056816319, 'JP', 'JPN', 'اليابان'),
(35562, 2056816320, 2056816383, 'PH', 'PHL', 'الفلبين'),
(35563, 2056816384, 2056816479, 'JP', 'JPN', 'اليابان'),
(35564, 2056816480, 2056816511, 'PH', 'PHL', 'الفلبين'),
(35565, 2056816512, 2056816639, 'TW', 'TWN', 'تايوان'),
(35566, 2056816640, 2056816783, 'SG', 'SGP', 'سنغافورة'),
(35567, 2056816784, 2056816791, 'MY', 'MYS', 'ماليزيا'),
(35568, 2056816792, 2056816799, 'JP', 'JPN', 'اليابان'),
(35569, 2056816800, 2056816823, 'SG', 'SGP', 'سنغافورة'),
(35570, 2056816824, 2056816831, 'MY', 'MYS', 'ماليزيا'),
(35571, 2056816832, 2056816927, 'SG', 'SGP', 'سنغافورة'),
(35572, 2056816928, 2056816943, 'JP', 'JPN', 'اليابان'),
(35573, 2056816944, 2056817007, 'MY', 'MYS', 'ماليزيا'),
(35574, 2056817008, 2056817151, 'SG', 'SGP', 'سنغافورة'),
(35575, 2056817152, 2056817311, 'JP', 'JPN', 'اليابان'),
(35576, 2056817312, 2056817343, 'HK', 'HKG', 'هونغ كونغ'),
(35577, 2056817344, 2056817375, 'JP', 'JPN', 'اليابان'),
(35578, 2056817376, 2056817399, 'HK', 'HKG', 'هونغ كونغ'),
(35579, 2056817400, 2056817407, 'JP', 'JPN', 'اليابان'),
(35580, 2056817408, 2056817663, 'HK', 'HKG', 'هونغ كونغ'),
(35581, 2056817664, 2056818207, 'JP', 'JPN', 'اليابان'),
(35582, 2056818208, 2056818239, 'SG', 'SGP', 'سنغافورة'),
(35583, 2056818240, 2056818271, 'MY', 'MYS', 'ماليزيا'),
(35584, 2056818272, 2056818431, 'SG', 'SGP', 'سنغافورة'),
(35585, 2056818432, 2056818559, 'JP', 'JPN', 'اليابان'),
(35586, 2056818560, 2056818623, 'SG', 'SGP', 'سنغافورة'),
(35587, 2056818624, 2056818639, 'JP', 'JPN', 'اليابان'),
(35588, 2056818640, 2056818687, 'SG', 'SGP', 'سنغافورة'),
(35589, 2056818688, 2056818815, 'MY', 'MYS', 'ماليزيا'),
(35590, 2056818816, 2056818847, 'SG', 'SGP', 'سنغافورة'),
(35591, 2056818848, 2056818863, 'MY', 'MYS', 'ماليزيا'),
(35592, 2056818864, 2056818879, 'SG', 'SGP', 'سنغافورة'),
(35593, 2056818880, 2056818927, 'JP', 'JPN', 'اليابان'),
(35594, 2056818928, 2056818943, 'SG', 'SGP', 'سنغافورة'),
(35595, 2056818944, 2056819007, 'MY', 'MYS', 'ماليزيا'),
(35596, 2056819008, 2056819023, 'SG', 'SGP', 'سنغافورة'),
(35597, 2056819024, 2056819039, 'MY', 'MYS', 'ماليزيا'),
(35598, 2056819040, 2056819071, 'JP', 'JPN', 'اليابان'),
(35599, 2056819072, 2056819199, 'MY', 'MYS', 'ماليزيا'),
(35600, 2056819200, 2056819759, 'JP', 'JPN', 'اليابان'),
(35601, 2056819760, 2056819775, 'NZ', 'NZL', 'نيوزيلاندا'),
(35602, 2056819776, 2056819839, 'JP', 'JPN', 'اليابان'),
(35603, 2056819840, 2056819871, 'NZ', 'NZL', 'نيوزيلاندا'),
(35604, 2056819872, 2056819903, 'JP', 'JPN', 'اليابان'),
(35605, 2056819904, 2056819911, 'NZ', 'NZL', 'نيوزيلاندا'),
(35606, 2056819912, 2056820223, 'JP', 'JPN', 'اليابان'),
(35607, 2056820224, 2056820279, 'HK', 'HKG', 'هونغ كونغ'),
(35608, 2056820280, 2056820287, 'JP', 'JPN', 'اليابان'),
(35609, 2056820288, 2056820319, 'HK', 'HKG', 'هونغ كونغ'),
(35610, 2056820320, 2056820351, 'JP', 'JPN', 'اليابان'),
(35611, 2056820352, 2056820415, 'HK', 'HKG', 'هونغ كونغ'),
(35612, 2056820416, 2056820511, 'JP', 'JPN', 'اليابان'),
(35613, 2056820512, 2056820607, 'HK', 'HKG', 'هونغ كونغ'),
(35614, 2056820608, 2056822911, 'JP', 'JPN', 'اليابان'),
(35615, 2056822912, 2056822959, 'HK', 'HKG', 'هونغ كونغ'),
(35616, 2056822960, 2056825535, 'JP', 'JPN', 'اليابان'),
(35617, 2056825536, 2056825663, 'HK', 'HKG', 'هونغ كونغ'),
(35618, 2056825664, 2056825727, 'JP', 'JPN', 'اليابان');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(35619, 2056825728, 2056825855, 'HK', 'HKG', 'هونغ كونغ'),
(35620, 2056825856, 2056827935, 'JP', 'JPN', 'اليابان'),
(35621, 2056827936, 2056827965, 'HK', 'HKG', 'هونغ كونغ'),
(35622, 2056827966, 2056830271, 'JP', 'JPN', 'اليابان'),
(35623, 2056830272, 2056830275, 'HK', 'HKG', 'هونغ كونغ'),
(35624, 2056830276, 2056830419, 'JP', 'JPN', 'اليابان'),
(35625, 2056830420, 2056830423, 'HK', 'HKG', 'هونغ كونغ'),
(35626, 2056830424, 2056830975, 'JP', 'JPN', 'اليابان'),
(35627, 2056830976, 2056847359, 'CN', 'CHN', 'الصين'),
(35628, 2056847360, 2056912895, 'KR', 'KOR', 'جمهورية كوريا'),
(35629, 2056912896, 2057043967, 'TH', 'THA', 'تايلند'),
(35630, 2057043968, 2057306111, 'CN', 'CHN', 'الصين'),
(35631, 2057306112, 2059141119, 'IN', 'IND', 'الهند'),
(35632, 2059141120, 2059403263, 'AU', 'AUS', 'أستراليا'),
(35633, 2059403264, 2059665407, 'CN', 'CHN', 'الصين'),
(35634, 2059665408, 2059796479, 'JP', 'JPN', 'اليابان'),
(35635, 2059796480, 2059862015, 'CN', 'CHN', 'الصين'),
(35636, 2059862016, 2059878399, 'AU', 'AUS', 'أستراليا'),
(35637, 2059878400, 2059927551, 'KR', 'KOR', 'جمهورية كوريا'),
(35638, 2059927552, 2059931647, 'ID', 'IDN', 'إندونيسيا'),
(35639, 2059931648, 2059933695, 'IN', 'IND', 'الهند'),
(35640, 2059933696, 2059935743, 'AU', 'AUS', 'أستراليا'),
(35641, 2059935744, 2059937791, 'JP', 'JPN', 'اليابان'),
(35642, 2059937792, 2059939839, 'BD', 'BGD', 'بنغالاديش'),
(35643, 2059939840, 2059941887, 'ID', 'IDN', 'إندونيسيا'),
(35644, 2059941888, 2059943935, 'AU', 'AUS', 'أستراليا'),
(35645, 2059943936, 2059960319, 'CN', 'CHN', 'الصين'),
(35646, 2059960320, 2059961343, 'AU', 'AUS', 'أستراليا'),
(35647, 2059961344, 2059962367, 'HK', 'HKG', 'هونغ كونغ'),
(35648, 2059962368, 2059964415, 'JP', 'JPN', 'اليابان'),
(35649, 2059964416, 2059966463, 'ID', 'IDN', 'إندونيسيا'),
(35650, 2059966464, 2059968511, 'TW', 'TWN', 'تايوان'),
(35651, 2059968512, 2059976703, 'AU', 'AUS', 'أستراليا'),
(35652, 2059976704, 2059995135, 'JP', 'JPN', 'اليابان'),
(35653, 2059995136, 2059997183, 'VN', 'VNM', 'فييتنام'),
(35654, 2059997184, 2060001279, 'MN', 'MNG', 'منغوليا'),
(35655, 2060001280, 2060001791, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(35656, 2060001792, 2060002239, 'HK', 'HKG', 'هونغ كونغ'),
(35657, 2060002240, 2060002247, 'PK', 'PAK', 'باكستان'),
(35658, 2060002248, 2060002391, 'HK', 'HKG', 'هونغ كونغ'),
(35659, 2060002392, 2060002415, 'AF', 'AFG', 'أفغانستان'),
(35660, 2060002416, 2060002455, 'HK', 'HKG', 'هونغ كونغ'),
(35661, 2060002456, 2060002463, 'PK', 'PAK', 'باكستان'),
(35662, 2060002464, 2060002847, 'HK', 'HKG', 'هونغ كونغ'),
(35663, 2060002848, 2060002863, 'AF', 'AFG', 'أفغانستان'),
(35664, 2060002864, 2060003039, 'HK', 'HKG', 'هونغ كونغ'),
(35665, 2060003040, 2060003071, 'AF', 'AFG', 'أفغانستان'),
(35666, 2060003072, 2060003199, 'HK', 'HKG', 'هونغ كونغ'),
(35667, 2060003200, 2060003215, 'AF', 'AFG', 'أفغانستان'),
(35668, 2060003216, 2060005375, 'HK', 'HKG', 'هونغ كونغ'),
(35669, 2060005376, 2060025855, 'AU', 'AUS', 'أستراليا'),
(35670, 2060025856, 2060058623, 'TW', 'TWN', 'تايوان'),
(35671, 2060058624, 2060062719, 'AU', 'AUS', 'أستراليا'),
(35672, 2060062720, 2060066815, 'JP', 'JPN', 'اليابان'),
(35673, 2060066816, 2060075007, 'KR', 'KOR', 'جمهورية كوريا'),
(35674, 2060075008, 2060083199, 'AU', 'AUS', 'أستراليا'),
(35675, 2060083200, 2060091391, 'PH', 'PHL', 'الفلبين'),
(35676, 2060091392, 2060189695, 'KR', 'KOR', 'جمهورية كوريا'),
(35677, 2060189696, 2060451839, 'CN', 'CHN', 'الصين'),
(35678, 2060451840, 2061500415, 'JP', 'JPN', 'اليابان'),
(35679, 2061500416, 2063073279, 'CN', 'CHN', 'الصين'),
(35680, 2063073280, 2063077375, 'BD', 'BGD', 'بنغالاديش'),
(35681, 2063077376, 2063081471, 'HK', 'HKG', 'هونغ كونغ'),
(35682, 2063081472, 2063085567, 'AU', 'AUS', 'أستراليا'),
(35683, 2063085568, 2063089663, 'CN', 'CHN', 'الصين'),
(35684, 2063089664, 2063097855, 'JP', 'JPN', 'اليابان'),
(35685, 2063097856, 2063106047, 'AU', 'AUS', 'أستراليا'),
(35686, 2063106048, 2063107631, 'SG', 'SGP', 'سنغافورة'),
(35687, 2063107632, 2063107639, 'NZ', 'NZL', 'نيوزيلاندا'),
(35688, 2063107640, 2063107647, 'PH', 'PHL', 'الفلبين'),
(35689, 2063107648, 2063107655, 'MY', 'MYS', 'ماليزيا'),
(35690, 2063107656, 2063107663, 'HK', 'HKG', 'هونغ كونغ'),
(35691, 2063107664, 2063107671, 'TW', 'TWN', 'تايوان'),
(35692, 2063107672, 2063107679, 'CN', 'CHN', 'الصين'),
(35693, 2063107680, 2063108095, 'SG', 'SGP', 'سنغافورة'),
(35694, 2063108096, 2063110143, 'HK', 'HKG', 'هونغ كونغ'),
(35695, 2063110144, 2063111167, 'JP', 'JPN', 'اليابان'),
(35696, 2063111168, 2063114239, 'AU', 'AUS', 'أستراليا'),
(35697, 2063114240, 2063115263, 'IN', 'IND', 'الهند'),
(35698, 2063115264, 2063116287, 'JP', 'JPN', 'اليابان'),
(35699, 2063116288, 2063116319, 'SG', 'SGP', 'سنغافورة'),
(35700, 2063116320, 2063116351, 'AU', 'AUS', 'أستراليا'),
(35701, 2063116352, 2063116415, 'SG', 'SGP', 'سنغافورة'),
(35702, 2063116416, 2063116799, 'AU', 'AUS', 'أستراليا'),
(35703, 2063116800, 2063117311, 'KR', 'KOR', 'جمهورية كوريا'),
(35704, 2063117312, 2063117823, 'NZ', 'NZL', 'نيوزيلاندا'),
(35705, 2063117824, 2063118335, 'PH', 'PHL', 'الفلبين'),
(35706, 2063118336, 2063118343, 'IN', 'IND', 'الهند'),
(35707, 2063118344, 2063118463, 'PH', 'PHL', 'الفلبين'),
(35708, 2063118464, 2063118591, 'IN', 'IND', 'الهند'),
(35709, 2063118592, 2063118847, 'PH', 'PHL', 'الفلبين'),
(35710, 2063118848, 2063119359, 'SG', 'SGP', 'سنغافورة'),
(35711, 2063119360, 2063119871, 'HK', 'HKG', 'هونغ كونغ'),
(35712, 2063119872, 2063138815, 'AU', 'AUS', 'أستراليا'),
(35713, 2063138816, 2063335423, 'JP', 'JPN', 'اليابان'),
(35714, 2063335424, 2063351807, 'AU', 'AUS', 'أستراليا'),
(35715, 2063351808, 2063368191, 'KR', 'KOR', 'جمهورية كوريا'),
(35716, 2063368192, 2063370239, 'AU', 'AUS', 'أستراليا'),
(35717, 2063370240, 2063372287, 'JP', 'JPN', 'اليابان'),
(35718, 2063372288, 2063376383, 'AU', 'AUS', 'أستراليا'),
(35719, 2063376384, 2063380479, 'TW', 'TWN', 'تايوان'),
(35720, 2063380480, 2063382527, 'KH', 'KHM', 'كامبوديا'),
(35721, 2063382528, 2063384575, 'AU', 'AUS', 'أستراليا'),
(35722, 2063384576, 2063392767, 'KR', 'KOR', 'جمهورية كوريا'),
(35723, 2063392768, 2063400959, 'IN', 'IND', 'الهند'),
(35724, 2063400960, 2063466495, 'JP', 'JPN', 'اليابان'),
(35725, 2063466496, 2063482879, 'TW', 'TWN', 'تايوان'),
(35726, 2063482880, 2063499263, 'MN', 'MNG', 'منغوليا'),
(35727, 2063499264, 2063532031, 'KR', 'KOR', 'جمهورية كوريا'),
(35728, 2063532032, 2063548415, 'LK', 'LKA', 'سيريلانكا'),
(35729, 2063548416, 2063550463, 'AU', 'AUS', 'أستراليا'),
(35730, 2063550464, 2063551487, 'IN', 'IND', 'الهند'),
(35731, 2063551488, 2063552511, 'AU', 'AUS', 'أستراليا'),
(35732, 2063552512, 2063556607, 'TW', 'TWN', 'تايوان'),
(35733, 2063556608, 2063564799, 'MY', 'MYS', 'ماليزيا'),
(35734, 2063564800, 2063597567, 'JP', 'JPN', 'اليابان'),
(35735, 2063597568, 2063601663, 'KR', 'KOR', 'جمهورية كوريا'),
(35736, 2063601664, 2063605759, 'AU', 'AUS', 'أستراليا'),
(35737, 2063605760, 2063613951, 'TW', 'TWN', 'تايوان'),
(35738, 2063613952, 2063630335, 'JP', 'JPN', 'اليابان'),
(35739, 2063630336, 2063646719, 'CN', 'CHN', 'الصين'),
(35740, 2063646720, 2063663103, 'TW', 'TWN', 'تايوان'),
(35741, 2063663104, 2063695871, 'JP', 'JPN', 'اليابان'),
(35742, 2063695872, 2063859711, 'AU', 'AUS', 'أستراليا'),
(35743, 2063859712, 2064646143, 'CN', 'CHN', 'الصين'),
(35744, 2064646144, 2065694719, 'VN', 'VNM', 'فييتنام'),
(35745, 2065694720, 2066743295, 'KR', 'KOR', 'جمهورية كوريا'),
(35746, 2066743296, 2066808831, 'JP', 'JPN', 'اليابان'),
(35747, 2066808832, 2066825215, 'BD', 'BGD', 'بنغالاديش'),
(35748, 2066825216, 2066841599, 'SG', 'SGP', 'سنغافورة'),
(35749, 2066841600, 2066874367, 'CN', 'CHN', 'الصين'),
(35750, 2066874368, 2066882559, 'JP', 'JPN', 'اليابان'),
(35751, 2066882560, 2066890751, 'TW', 'TWN', 'تايوان'),
(35752, 2066890752, 2066907135, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(35753, 2066907136, 2066915327, 'AU', 'AUS', 'أستراليا'),
(35754, 2066915328, 2066923519, 'IN', 'IND', 'الهند'),
(35755, 2066923520, 2066939903, 'JP', 'JPN', 'اليابان'),
(35756, 2066939904, 2066972671, 'AU', 'AUS', 'أستراليا'),
(35757, 2066972672, 2067005439, 'TW', 'TWN', 'تايوان'),
(35758, 2067005440, 2070052863, 'CN', 'CHN', 'الصين'),
(35759, 2070052864, 2070056959, 'AU', 'AUS', 'أستراليا'),
(35760, 2070056960, 2070061055, 'JP', 'JPN', 'اليابان'),
(35761, 2070061056, 2070077439, 'KR', 'KOR', 'جمهورية كوريا'),
(35762, 2070077440, 2070085631, 'JP', 'JPN', 'اليابان'),
(35763, 2070085632, 2070102015, 'TW', 'TWN', 'تايوان'),
(35764, 2070102016, 2070118399, 'KR', 'KOR', 'جمهورية كوريا'),
(35765, 2070118400, 2070159359, 'CN', 'CHN', 'الصين'),
(35766, 2070159360, 2070167551, 'AU', 'AUS', 'أستراليا'),
(35767, 2070167552, 2070183935, 'NZ', 'NZL', 'نيوزيلاندا'),
(35768, 2070183936, 2070200319, 'AU', 'AUS', 'أستراليا'),
(35769, 2070200320, 2070208511, 'JP', 'JPN', 'اليابان'),
(35770, 2070208512, 2070209279, 'MY', 'MYS', 'ماليزيا'),
(35771, 2070209280, 2070210559, 'SG', 'SGP', 'سنغافورة'),
(35772, 2070210560, 2070210815, 'CN', 'CHN', 'الصين'),
(35773, 2070210816, 2070211071, 'SG', 'SGP', 'سنغافورة'),
(35774, 2070211072, 2070211327, 'IN', 'IND', 'الهند'),
(35775, 2070211328, 2070216703, 'SG', 'SGP', 'سنغافورة'),
(35776, 2070216704, 2070282239, 'CN', 'CHN', 'الصين'),
(35777, 2070282240, 2070347775, 'AU', 'AUS', 'أستراليا'),
(35778, 2070347776, 2070380543, 'CN', 'CHN', 'الصين'),
(35779, 2070380544, 2070396927, 'JP', 'JPN', 'اليابان'),
(35780, 2070396928, 2070405119, 'AU', 'AUS', 'أستراليا'),
(35781, 2070405120, 2070409215, 'JP', 'JPN', 'اليابان'),
(35782, 2070409216, 2070413311, 'AU', 'AUS', 'أستراليا'),
(35783, 2070413312, 2070677503, 'JP', 'JPN', 'اليابان'),
(35784, 2070677504, 2070679551, 'ID', 'IDN', 'إندونيسيا'),
(35785, 2070679552, 2070683647, 'KR', 'KOR', 'جمهورية كوريا'),
(35786, 2070683648, 2070691839, 'IN', 'IND', 'الهند'),
(35787, 2070691840, 2070700031, 'AU', 'AUS', 'أستراليا'),
(35788, 2070700032, 2070702079, 'ID', 'IDN', 'إندونيسيا'),
(35789, 2070702080, 2070703103, 'AU', 'AUS', 'أستراليا'),
(35790, 2070703104, 2070704127, 'HK', 'HKG', 'هونغ كونغ'),
(35791, 2070704128, 2070708223, 'PH', 'PHL', 'الفلبين'),
(35792, 2070708224, 2070712319, 'CN', 'CHN', 'الصين'),
(35793, 2070712320, 2070714367, 'NZ', 'NZL', 'نيوزيلاندا'),
(35794, 2070714368, 2070716415, 'AU', 'AUS', 'أستراليا'),
(35795, 2070716416, 2070724607, 'KR', 'KOR', 'جمهورية كوريا'),
(35796, 2070724608, 2070726655, 'JP', 'JPN', 'اليابان'),
(35797, 2070726656, 2070728703, 'IN', 'IND', 'الهند'),
(35798, 2070728704, 2070732799, 'CN', 'CHN', 'الصين'),
(35799, 2070732800, 2070734847, 'IN', 'IND', 'الهند'),
(35800, 2070734848, 2070736895, 'JP', 'JPN', 'اليابان'),
(35801, 2070736896, 2070738943, 'BD', 'BGD', 'بنغالاديش'),
(35802, 2070738944, 2070740991, 'KH', 'KHM', 'كامبوديا'),
(35803, 2070740992, 2070806527, 'KR', 'KOR', 'جمهورية كوريا'),
(35804, 2070806528, 2070872063, 'TW', 'TWN', 'تايوان'),
(35805, 2070872064, 2070937599, 'KR', 'KOR', 'جمهورية كوريا'),
(35806, 2070937600, 2072510463, 'CN', 'CHN', 'الصين'),
(35807, 2072510464, 2072514559, 'HK', 'HKG', 'هونغ كونغ'),
(35808, 2072514560, 2072516607, 'IN', 'IND', 'الهند'),
(35809, 2072516608, 2072518655, 'BD', 'BGD', 'بنغالاديش'),
(35810, 2072518656, 2072526847, 'AU', 'AUS', 'أستراليا'),
(35811, 2072526848, 2072528895, 'SG', 'SGP', 'سنغافورة'),
(35812, 2072528896, 2072530943, 'PH', 'PHL', 'الفلبين'),
(35813, 2072530944, 2072535039, 'CN', 'CHN', 'الصين'),
(35814, 2072535040, 2072543231, 'MY', 'MYS', 'ماليزيا'),
(35815, 2072543232, 2072575999, 'IN', 'IND', 'الهند'),
(35816, 2072576000, 2072772607, 'CN', 'CHN', 'الصين'),
(35817, 2072772608, 2073034751, 'KR', 'KOR', 'جمهورية كوريا'),
(35818, 2073034752, 2075131903, 'CN', 'CHN', 'الصين'),
(35819, 2075131904, 2075140095, 'MV', 'MDV', 'جزر المالديف'),
(35820, 2075140096, 2075144191, 'IN', 'IND', 'الهند'),
(35821, 2075144192, 2075146239, 'JP', 'JPN', 'اليابان'),
(35822, 2075146240, 2075147263, 'BD', 'BGD', 'بنغالاديش'),
(35823, 2075147264, 2075148287, 'AU', 'AUS', 'أستراليا'),
(35824, 2075148288, 2075150335, 'PH', 'PHL', 'الفلبين'),
(35825, 2075150336, 2075152383, 'WS', 'WSM', 'ساموا'),
(35826, 2075152384, 2075156479, 'CN', 'CHN', 'الصين'),
(35827, 2075156480, 2075158527, 'HK', 'HKG', 'هونغ كونغ'),
(35828, 2075158528, 2075160575, 'JP', 'JPN', 'اليابان'),
(35829, 2075160576, 2075162623, 'AU', 'AUS', 'أستراليا'),
(35830, 2075162624, 2075164671, 'ID', 'IDN', 'إندونيسيا'),
(35831, 2075164672, 2075197439, 'JP', 'JPN', 'اليابان'),
(35832, 2075197440, 2076180479, 'CN', 'CHN', 'الصين'),
(35833, 2076180480, 2076442623, 'TW', 'TWN', 'تايوان'),
(35834, 2076442624, 2076573695, 'CN', 'CHN', 'الصين'),
(35835, 2076573696, 2076639231, 'JP', 'JPN', 'اليابان'),
(35836, 2076639232, 2076671999, 'KR', 'KOR', 'جمهورية كوريا'),
(35837, 2076672000, 2076704767, 'CN', 'CHN', 'الصين'),
(35838, 2076704768, 2076712959, 'BD', 'BGD', 'بنغالاديش'),
(35839, 2076712960, 2076721151, 'JP', 'JPN', 'اليابان'),
(35840, 2076721152, 2076737535, 'KR', 'KOR', 'جمهورية كوريا'),
(35841, 2076737536, 2076770303, 'AU', 'AUS', 'أستراليا'),
(35842, 2076770304, 2076835839, 'IN', 'IND', 'الهند'),
(35843, 2076835840, 2076966911, 'HK', 'HKG', 'هونغ كونغ'),
(35844, 2076966912, 2077097983, 'TW', 'TWN', 'تايوان'),
(35845, 2077097984, 2077229055, 'CN', 'CHN', 'الصين'),
(35846, 2077229056, 2077491199, 'AU', 'AUS', 'أستراليا'),
(35847, 2077491200, 2077753343, 'KR', 'KOR', 'جمهورية كوريا'),
(35848, 2077753344, 2078539775, 'JP', 'JPN', 'اليابان'),
(35849, 2078539776, 2078670847, 'KR', 'KOR', 'جمهورية كوريا'),
(35850, 2078670848, 2078736383, 'JP', 'JPN', 'اليابان'),
(35851, 2078736384, 2078769151, 'LK', 'LKA', 'سيريلانكا'),
(35852, 2078769152, 2078801919, 'ID', 'IDN', 'إندونيسيا'),
(35853, 2078801920, 2079064063, 'CN', 'CHN', 'الصين'),
(35854, 2079064064, 2079326207, 'IN', 'IND', 'الهند'),
(35855, 2079326208, 2079457279, 'TW', 'TWN', 'تايوان'),
(35856, 2079457280, 2079490047, 'CN', 'CHN', 'الصين'),
(35857, 2079490048, 2079506431, 'TH', 'THA', 'تايلند'),
(35858, 2079506432, 2079508479, 'AU', 'AUS', 'أستراليا'),
(35859, 2079508480, 2079510527, 'PH', 'PHL', 'الفلبين'),
(35860, 2079510528, 2079514623, 'JP', 'JPN', 'اليابان'),
(35861, 2079514624, 2079516671, 'HK', 'HKG', 'هونغ كونغ'),
(35862, 2079516672, 2079518719, 'JP', 'JPN', 'اليابان'),
(35863, 2079518720, 2079522815, 'IN', 'IND', 'الهند'),
(35864, 2079522816, 2079588351, 'AU', 'AUS', 'أستراليا'),
(35865, 2079588352, 2079850495, 'CN', 'CHN', 'الصين'),
(35866, 2079850496, 2079916031, 'KR', 'KOR', 'جمهورية كوريا'),
(35867, 2079916032, 2079981567, 'CN', 'CHN', 'الصين'),
(35868, 2079981568, 2080112639, 'KR', 'KOR', 'جمهورية كوريا'),
(35869, 2080112640, 2080145407, 'TW', 'TWN', 'تايوان'),
(35870, 2080145408, 2080178175, 'IN', 'IND', 'الهند'),
(35871, 2080178176, 2080243711, 'CN', 'CHN', 'الصين'),
(35872, 2080243712, 2080260095, 'JP', 'JPN', 'اليابان'),
(35873, 2080260096, 2080268287, 'KR', 'KOR', 'جمهورية كوريا'),
(35874, 2080268288, 2080276479, 'AU', 'AUS', 'أستراليا'),
(35875, 2080276480, 2080309247, 'KR', 'KOR', 'جمهورية كوريا'),
(35876, 2080309248, 2080325631, 'NZ', 'NZL', 'نيوزيلاندا'),
(35877, 2080325632, 2080342015, 'HK', 'HKG', 'هونغ كونغ'),
(35878, 2080342016, 2080360447, 'JP', 'JPN', 'اليابان'),
(35879, 2080360448, 2080362495, 'ID', 'IDN', 'إندونيسيا'),
(35880, 2080362496, 2080366591, 'AU', 'AUS', 'أستراليا'),
(35881, 2080366592, 2080368639, 'TW', 'TWN', 'تايوان'),
(35882, 2080368640, 2080372735, 'JP', 'JPN', 'اليابان'),
(35883, 2080372736, 2080374783, 'IN', 'IND', 'الهند'),
(35884, 2080374784, 2080636927, 'KR', 'KOR', 'جمهورية كوريا'),
(35885, 2080636928, 2080702463, 'IN', 'IND', 'الهند'),
(35886, 2080702464, 2080767999, 'KR', 'KOR', 'جمهورية كوريا'),
(35887, 2080768000, 2080776191, 'TW', 'TWN', 'تايوان'),
(35888, 2080776192, 2080777215, 'ID', 'IDN', 'إندونيسيا'),
(35889, 2080777216, 2080778239, 'AU', 'AUS', 'أستراليا'),
(35890, 2080778240, 2080779263, 'ID', 'IDN', 'إندونيسيا'),
(35891, 2080779264, 2080784383, 'AU', 'AUS', 'أستراليا'),
(35892, 2080784384, 2080800767, 'CN', 'CHN', 'الصين'),
(35893, 2080800768, 2080817151, 'PH', 'PHL', 'الفلبين'),
(35894, 2080817152, 2080825343, 'NZ', 'NZL', 'نيوزيلاندا'),
(35895, 2080825344, 2080829439, 'BD', 'BGD', 'بنغالاديش'),
(35896, 2080829440, 2080833535, 'AU', 'AUS', 'أستراليا'),
(35897, 2080833536, 2080899071, 'IN', 'IND', 'الهند'),
(35898, 2080899072, 2081226751, 'TW', 'TWN', 'تايوان'),
(35899, 2081226752, 2081292287, 'MY', 'MYS', 'ماليزيا'),
(35900, 2081292288, 2081554431, 'CN', 'CHN', 'الصين'),
(35901, 2081554432, 2081619967, 'JP', 'JPN', 'اليابان'),
(35902, 2081619968, 2081652735, 'AU', 'AUS', 'أستراليا'),
(35903, 2081652736, 2081685503, 'PH', 'PHL', 'الفلبين'),
(35904, 2081685504, 2081947647, 'CN', 'CHN', 'الصين'),
(35905, 2081947648, 2082209791, 'JP', 'JPN', 'اليابان'),
(35906, 2082209792, 2082258943, 'KR', 'KOR', 'جمهورية كوريا'),
(35907, 2082258944, 2082308095, 'CN', 'CHN', 'الصين'),
(35908, 2082308096, 2082324479, 'TW', 'TWN', 'تايوان'),
(35909, 2082324480, 2082340863, 'PK', 'PAK', 'باكستان'),
(35910, 2082340864, 2082406399, 'IN', 'IND', 'الهند'),
(35911, 2082406400, 2082471935, 'CN', 'CHN', 'الصين'),
(35912, 2082471936, 2083024895, 'JP', 'JPN', 'اليابان'),
(35913, 2083024896, 2083045375, 'CN', 'CHN', 'الصين'),
(35914, 2083045376, 2083053567, 'AU', 'AUS', 'أستراليا'),
(35915, 2083053568, 2083057663, 'TH', 'THA', 'تايلند'),
(35916, 2083057664, 2083059711, 'AU', 'AUS', 'أستراليا'),
(35917, 2083059712, 2083061759, 'ID', 'IDN', 'إندونيسيا'),
(35918, 2083061760, 2083110911, 'JP', 'JPN', 'اليابان'),
(35919, 2083110912, 2083127295, 'NP', 'NPL', 'نيبال'),
(35920, 2083127296, 2083192831, 'CN', 'CHN', 'الصين'),
(35921, 2083192832, 2083258367, 'LK', 'LKA', 'سيريلانكا'),
(35922, 2083258368, 2083389439, 'JP', 'JPN', 'اليابان'),
(35923, 2083389440, 2083454975, 'KR', 'KOR', 'جمهورية كوريا'),
(35924, 2083454976, 2083471359, 'CN', 'CHN', 'الصين'),
(35925, 2083471360, 2083487743, 'JP', 'JPN', 'اليابان'),
(35926, 2083487744, 2083504127, 'IN', 'IND', 'الهند'),
(35927, 2083504128, 2083520511, 'JP', 'JPN', 'اليابان'),
(35928, 2083520512, 2084569087, 'KR', 'KOR', 'جمهورية كوريا'),
(35929, 2084569088, 2084732927, 'CN', 'CHN', 'الصين'),
(35930, 2084732928, 2084741119, 'SG', 'SGP', 'سنغافورة'),
(35931, 2084741120, 2084743167, 'ID', 'IDN', 'إندونيسيا'),
(35932, 2084743168, 2084745215, 'JP', 'JPN', 'اليابان'),
(35933, 2084745216, 2084749311, 'KR', 'KOR', 'جمهورية كوريا'),
(35934, 2084749312, 2084753407, 'JP', 'JPN', 'اليابان'),
(35935, 2084753408, 2084757503, 'AU', 'AUS', 'أستراليا'),
(35936, 2084757504, 2084765695, 'JP', 'JPN', 'اليابان'),
(35937, 2084765696, 2085617663, 'CN', 'CHN', 'الصين'),
(35938, 2085617664, 2085683199, 'KR', 'KOR', 'جمهورية كوريا'),
(35939, 2085683200, 2085748735, 'ID', 'IDN', 'إندونيسيا'),
(35940, 2085748736, 2085814271, 'MY', 'MYS', 'ماليزيا'),
(35941, 2085814272, 2085847039, 'PH', 'PHL', 'الفلبين'),
(35942, 2085847040, 2086141951, 'JP', 'JPN', 'اليابان'),
(35943, 2086141952, 2086666239, 'CN', 'CHN', 'الصين'),
(35944, 2086666240, 2087190527, 'JP', 'JPN', 'اليابان'),
(35945, 2087190528, 2087452671, 'PH', 'PHL', 'الفلبين'),
(35946, 2087452672, 2087453695, 'AU', 'AUS', 'أستراليا'),
(35947, 2087453696, 2087454719, 'KH', 'KHM', 'كامبوديا'),
(35948, 2087454720, 2087456767, 'CN', 'CHN', 'الصين'),
(35949, 2087456768, 2087457791, 'AU', 'AUS', 'أستراليا'),
(35950, 2087457792, 2087458815, 'BD', 'BGD', 'بنغالاديش'),
(35951, 2087458816, 2087460863, 'FJ', 'FJI', 'فيجي'),
(35952, 2087460864, 2087462911, 'JP', 'JPN', 'اليابان'),
(35953, 2087462912, 2087464959, 'CN', 'CHN', 'الصين'),
(35954, 2087464960, 2087467007, 'KH', 'KHM', 'كامبوديا'),
(35955, 2087467008, 2087469055, 'JP', 'JPN', 'اليابان'),
(35956, 2087469056, 2087472639, 'AU', 'AUS', 'أستراليا'),
(35957, 2087472640, 2087473151, 'SG', 'SGP', 'سنغافورة'),
(35958, 2087473152, 2087474175, 'HK', 'HKG', 'هونغ كونغ'),
(35959, 2087474176, 2087475711, 'AU', 'AUS', 'أستراليا'),
(35960, 2087475712, 2087476223, 'JP', 'JPN', 'اليابان'),
(35961, 2087476224, 2087477247, 'HK', 'HKG', 'هونغ كونغ'),
(35962, 2087477248, 2087481343, 'AU', 'AUS', 'أستراليا'),
(35963, 2087481344, 2087485439, 'HK', 'HKG', 'هونغ كونغ'),
(35964, 2087485440, 2087501823, 'TW', 'TWN', 'تايوان'),
(35965, 2087501824, 2087518207, 'JP', 'JPN', 'اليابان'),
(35966, 2087518208, 2087519231, 'TH', 'THA', 'تايلند'),
(35967, 2087519232, 2087520255, 'SG', 'SGP', 'سنغافورة'),
(35968, 2087520256, 2087522303, 'FM', 'FSM', 'ولايات ميكرونيزيا الموحدة'),
(35969, 2087522304, 2087524351, 'BD', 'BGD', 'بنغالاديش'),
(35970, 2087524352, 2087526399, 'TH', 'THA', 'تايلند'),
(35971, 2087526400, 2087534591, 'PK', 'PAK', 'باكستان'),
(35972, 2087534592, 2087544831, 'AU', 'AUS', 'أستراليا'),
(35973, 2087544832, 2087545855, 'BD', 'BGD', 'بنغالاديش'),
(35974, 2087545856, 2087546879, 'JP', 'JPN', 'اليابان'),
(35975, 2087546880, 2087550975, 'TW', 'TWN', 'تايوان'),
(35976, 2087550976, 2087649279, 'JP', 'JPN', 'اليابان'),
(35977, 2087649280, 2087714815, 'KR', 'KOR', 'جمهورية كوريا'),
(35978, 2087714816, 2088239103, 'CN', 'CHN', 'الصين'),
(35979, 2088239104, 2088435711, 'TH', 'THA', 'تايلند'),
(35980, 2088435712, 2088632319, 'IN', 'IND', 'الهند'),
(35981, 2088632320, 2089287679, 'CN', 'CHN', 'الصين'),
(35982, 2089287680, 2089549823, 'KR', 'KOR', 'جمهورية كوريا'),
(35983, 2089549824, 2089943039, 'JP', 'JPN', 'اليابان'),
(35984, 2089943040, 2089959423, 'KR', 'KOR', 'جمهورية كوريا'),
(35985, 2089959424, 2090041343, 'JP', 'JPN', 'اليابان'),
(35986, 2090041344, 2090074111, 'CN', 'CHN', 'الصين'),
(35987, 2090074112, 2090237951, 'AU', 'AUS', 'أستراليا'),
(35988, 2090237952, 2090239999, 'TW', 'TWN', 'تايوان'),
(35989, 2090240000, 2090241023, 'IN', 'IND', 'الهند'),
(35990, 2090241024, 2090242047, 'MY', 'MYS', 'ماليزيا'),
(35991, 2090242048, 2090246143, 'JP', 'JPN', 'اليابان'),
(35992, 2090246144, 2090248191, 'NZ', 'NZL', 'نيوزيلاندا'),
(35993, 2090248192, 2090250239, 'AU', 'AUS', 'أستراليا'),
(35994, 2090250240, 2090270719, 'JP', 'JPN', 'اليابان'),
(35995, 2090270720, 2090336255, 'CN', 'CHN', 'الصين'),
(35996, 2090336256, 2090401791, 'AU', 'AUS', 'أستراليا'),
(35997, 2090401792, 2090418175, 'ID', 'IDN', 'إندونيسيا'),
(35998, 2090418176, 2090434559, 'IN', 'IND', 'الهند'),
(35999, 2090434560, 2090467327, 'KR', 'KOR', 'جمهورية كوريا'),
(36000, 2090467328, 2090565631, 'JP', 'JPN', 'اليابان'),
(36001, 2090565632, 2090582015, 'TW', 'TWN', 'تايوان'),
(36002, 2090582016, 2090590207, 'SG', 'SGP', 'سنغافورة'),
(36003, 2090590208, 2090594303, 'NZ', 'NZL', 'نيوزيلاندا'),
(36004, 2090594304, 2090598399, 'AU', 'AUS', 'أستراليا'),
(36005, 2090598400, 2090663935, 'CN', 'CHN', 'الصين'),
(36006, 2090663936, 2090680319, 'AU', 'AUS', 'أستراليا'),
(36007, 2090680320, 2090696703, 'NZ', 'NZL', 'نيوزيلاندا'),
(36008, 2090696704, 2090729471, 'TH', 'THA', 'تايلند'),
(36009, 2090729472, 2090733567, 'VN', 'VNM', 'فييتنام'),
(36010, 2090733568, 2090736639, 'AU', 'AUS', 'أستراليا'),
(36011, 2090736640, 2090737663, 'IN', 'IND', 'الهند'),
(36012, 2090737664, 2090745855, 'PH', 'PHL', 'الفلبين'),
(36013, 2090745856, 2090762239, 'MN', 'MNG', 'منغوليا'),
(36014, 2090762240, 2090778623, 'ID', 'IDN', 'إندونيسيا'),
(36015, 2090778624, 2090786815, 'HK', 'HKG', 'هونغ كونغ'),
(36016, 2090786816, 2090795007, 'MY', 'MYS', 'ماليزيا'),
(36017, 2090795008, 2090860543, 'JP', 'JPN', 'اليابان'),
(36018, 2090860544, 2091384831, 'CN', 'CHN', 'الصين'),
(36019, 2091384832, 2091646975, 'AU', 'AUS', 'أستراليا'),
(36020, 2091646976, 2091909119, 'CN', 'CHN', 'الصين'),
(36021, 2091909120, 2092957695, 'AU', 'AUS', 'أستراليا'),
(36022, 2092957696, 2093088767, 'CN', 'CHN', 'الصين'),
(36023, 2093088768, 2093154303, 'KR', 'KOR', 'جمهورية كوريا'),
(36024, 2093154304, 2093187071, 'ID', 'IDN', 'إندونيسيا'),
(36025, 2093187072, 2093191167, 'MY', 'MYS', 'ماليزيا'),
(36026, 2093191168, 2093195263, 'JP', 'JPN', 'اليابان'),
(36027, 2093195264, 2093203455, 'KR', 'KOR', 'جمهورية كوريا'),
(36028, 2093203456, 2093211647, 'MV', 'MDV', 'جزر المالديف'),
(36029, 2093211648, 2093219839, 'KR', 'KOR', 'جمهورية كوريا'),
(36030, 2093219840, 2093285375, 'CN', 'CHN', 'الصين'),
(36031, 2093285376, 2093301759, 'NZ', 'NZL', 'نيوزيلاندا'),
(36032, 2093301760, 2093318143, 'SG', 'SGP', 'سنغافورة'),
(36033, 2093318144, 2093342719, 'KR', 'KOR', 'جمهورية كوريا'),
(36034, 2093342720, 2093350911, 'MY', 'MYS', 'ماليزيا'),
(36035, 2093350912, 2093383679, 'KR', 'KOR', 'جمهورية كوريا'),
(36036, 2093383680, 2093416447, 'NZ', 'NZL', 'نيوزيلاندا'),
(36037, 2093416448, 2093432831, 'KR', 'KOR', 'جمهورية كوريا'),
(36038, 2093432832, 2093445119, 'TW', 'TWN', 'تايوان'),
(36039, 2093445120, 2093449215, 'AU', 'AUS', 'أستراليا'),
(36040, 2093449216, 2093481983, 'KR', 'KOR', 'جمهورية كوريا'),
(36041, 2093481984, 2094006271, 'CN', 'CHN', 'الصين'),
(36042, 2094006272, 2094530559, 'JP', 'JPN', 'اليابان'),
(36043, 2094530560, 2094596095, 'KR', 'KOR', 'جمهورية كوريا'),
(36044, 2094596096, 2094628863, 'PH', 'PHL', 'الفلبين'),
(36045, 2094628864, 2094645247, 'HK', 'HKG', 'هونغ كونغ'),
(36046, 2094645248, 2094653439, 'KR', 'KOR', 'جمهورية كوريا'),
(36047, 2094653440, 2094661631, 'MY', 'MYS', 'ماليزيا'),
(36048, 2094661632, 2094759935, 'TW', 'TWN', 'تايوان'),
(36049, 2094759936, 2094792703, 'JP', 'JPN', 'اليابان'),
(36050, 2094792704, 2096152575, 'CN', 'CHN', 'الصين'),
(36051, 2096152576, 2096160767, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(36052, 2096160768, 2096168959, 'AU', 'AUS', 'أستراليا'),
(36053, 2096168960, 2096234495, 'JP', 'JPN', 'اليابان'),
(36054, 2096234496, 2096300031, 'CN', 'CHN', 'الصين'),
(36055, 2096300032, 2096332799, 'KR', 'KOR', 'جمهورية كوريا'),
(36056, 2096332800, 2096349183, 'AU', 'AUS', 'أستراليا'),
(36057, 2096349184, 2096365567, 'CN', 'CHN', 'الصين'),
(36058, 2096365568, 2096431103, 'HK', 'HKG', 'هونغ كونغ'),
(36059, 2096431104, 2096496639, 'JP', 'JPN', 'اليابان'),
(36060, 2096496640, 2096513023, 'AU', 'AUS', 'أستراليا'),
(36061, 2096513024, 2096529407, 'SG', 'SGP', 'سنغافورة'),
(36062, 2096529408, 2096611327, 'JP', 'JPN', 'اليابان'),
(36063, 2096611328, 2096627711, 'IN', 'IND', 'الهند'),
(36064, 2096627712, 2096660479, 'CN', 'CHN', 'الصين'),
(36065, 2096660480, 2096664575, 'NZ', 'NZL', 'نيوزيلاندا'),
(36066, 2096664576, 2096668671, 'AU', 'AUS', 'أستراليا'),
(36067, 2096668672, 2096676863, 'KH', 'KHM', 'كامبوديا'),
(36068, 2096676864, 2096693247, 'HK', 'HKG', 'هونغ كونغ'),
(36069, 2096693248, 2096889855, 'CN', 'CHN', 'الصين'),
(36070, 2096889856, 2096955391, 'AU', 'AUS', 'أستراليا'),
(36071, 2096955392, 2097020927, 'IN', 'IND', 'الهند'),
(36072, 2097020928, 2097037311, 'CN', 'CHN', 'الصين'),
(36073, 2097037312, 2097053695, 'AU', 'AUS', 'أستراليا'),
(36074, 2097053696, 2097086463, 'KR', 'KOR', 'جمهورية كوريا'),
(36075, 2097086464, 2097479679, 'JP', 'JPN', 'اليابان'),
(36076, 2097479680, 2097504791, 'PH', 'PHL', 'الفلبين'),
(36077, 2097504792, 2097504799, 'US', 'USA', 'الولايات المتحدة'),
(36078, 2097504800, 2097510687, 'PH', 'PHL', 'الفلبين'),
(36079, 2097510688, 2097510695, 'HK', 'HKG', 'هونغ كونغ'),
(36080, 2097510696, 2097545215, 'PH', 'PHL', 'الفلبين'),
(36081, 2097545216, 2097610751, 'JP', 'JPN', 'اليابان'),
(36082, 2097610752, 2097643519, 'AU', 'AUS', 'أستراليا'),
(36083, 2097643520, 2097676287, 'KR', 'KOR', 'جمهورية كوريا'),
(36084, 2097676288, 2098200575, 'JP', 'JPN', 'اليابان'),
(36085, 2098200576, 2098724863, 'IN', 'IND', 'الهند'),
(36086, 2098724864, 2098987007, 'TH', 'THA', 'تايلند'),
(36087, 2098987008, 2099183615, 'JP', 'JPN', 'اليابان'),
(36088, 2099183616, 2099199999, 'MO', 'MAC', 'ماكاو'),
(36089, 2099200000, 2099216383, 'JP', 'JPN', 'اليابان'),
(36090, 2099216384, 2099232767, 'KR', 'KOR', 'جمهورية كوريا'),
(36091, 2099232768, 2100297727, 'CN', 'CHN', 'الصين'),
(36092, 2100297728, 2100854783, 'JP', 'JPN', 'اليابان'),
(36093, 2100854784, 2100887551, 'US', 'USA', 'الولايات المتحدة'),
(36094, 2100887552, 2100953087, 'KR', 'KOR', 'جمهورية كوريا'),
(36095, 2100953088, 2100969471, 'AU', 'AUS', 'أستراليا'),
(36096, 2100969472, 2100985855, 'JP', 'JPN', 'اليابان'),
(36097, 2100985856, 2101018623, 'CN', 'CHN', 'الصين'),
(36098, 2101018624, 2101084159, 'HK', 'HKG', 'هونغ كونغ'),
(36099, 2101084160, 2101116927, 'KR', 'KOR', 'جمهورية كوريا'),
(36100, 2101116928, 2101149695, 'PH', 'PHL', 'الفلبين'),
(36101, 2101149696, 2101182463, 'KR', 'KOR', 'جمهورية كوريا'),
(36102, 2101182464, 2101231615, 'CN', 'CHN', 'الصين'),
(36103, 2101231616, 2101239807, 'AU', 'AUS', 'أستراليا'),
(36104, 2101239808, 2101270527, 'IN', 'IND', 'الهند'),
(36105, 2101270528, 2101272575, 'AU', 'AUS', 'أستراليا'),
(36106, 2101272576, 2101276671, 'TW', 'TWN', 'تايوان'),
(36107, 2101276672, 2101280767, 'JP', 'JPN', 'اليابان'),
(36108, 2101280768, 2101288959, 'AU', 'AUS', 'أستراليا'),
(36109, 2101288960, 2101293055, 'JP', 'JPN', 'اليابان'),
(36110, 2101293056, 2101297151, 'AU', 'AUS', 'أستراليا'),
(36111, 2101297152, 2101313535, 'IN', 'IND', 'الهند'),
(36112, 2101313536, 2101346303, 'AU', 'AUS', 'أستراليا'),
(36113, 2101346304, 2103640063, 'CN', 'CHN', 'الصين'),
(36114, 2103640064, 2103705599, 'IN', 'IND', 'الهند'),
(36115, 2103705600, 2103967743, 'JP', 'JPN', 'اليابان'),
(36116, 2103967744, 2105540607, 'CN', 'CHN', 'الصين'),
(36117, 2105540608, 2107637759, 'KR', 'KOR', 'جمهورية كوريا'),
(36118, 2107637760, 2108162047, 'ID', 'IDN', 'إندونيسيا'),
(36119, 2108162048, 2108227583, 'AU', 'AUS', 'أستراليا'),
(36120, 2108227584, 2108293119, 'CN', 'CHN', 'الصين'),
(36121, 2108293120, 2108358655, 'JP', 'JPN', 'اليابان'),
(36122, 2108358656, 2108424191, 'CN', 'CHN', 'الصين'),
(36123, 2108424192, 2108686335, 'JP', 'JPN', 'اليابان'),
(36124, 2108686336, 2109734911, 'KR', 'KOR', 'جمهورية كوريا'),
(36125, 2109734912, 2110783487, 'JP', 'JPN', 'اليابان'),
(36126, 2110783488, 2110799871, 'CN', 'CHN', 'الصين'),
(36127, 2110799872, 2110816255, 'KR', 'KOR', 'جمهورية كوريا'),
(36128, 2110816256, 2110832639, 'ID', 'IDN', 'إندونيسيا'),
(36129, 2110832640, 2110865407, 'KR', 'KOR', 'جمهورية كوريا'),
(36130, 2110865408, 2110881791, 'PK', 'PAK', 'باكستان'),
(36131, 2110881792, 2110914559, 'AU', 'AUS', 'أستراليا'),
(36132, 2110914560, 2111045631, 'CN', 'CHN', 'الصين'),
(36133, 2111045632, 2111078399, 'PH', 'PHL', 'الفلبين'),
(36134, 2111078400, 2111111167, 'VN', 'VNM', 'فييتنام'),
(36135, 2111111168, 2111143935, 'CN', 'CHN', 'الصين'),
(36136, 2111143936, 2111152127, 'ID', 'IDN', 'إندونيسيا'),
(36137, 2111152128, 2111160319, 'AU', 'AUS', 'أستراليا'),
(36138, 2111160320, 2111168511, 'AF', 'AFG', 'أفغانستان'),
(36139, 2111168512, 2111176703, 'TH', 'THA', 'تايلند'),
(36140, 2111176704, 2111187815, 'VN', 'VNM', 'فييتنام'),
(36141, 2111187816, 2111187823, 'KH', 'KHM', 'كامبوديا'),
(36142, 2111187824, 2111193087, 'VN', 'VNM', 'فييتنام'),
(36143, 2111193088, 2111201279, 'AU', 'AUS', 'أستراليا'),
(36144, 2111201280, 2111209471, 'CN', 'CHN', 'الصين'),
(36145, 2111209472, 2111217663, 'JP', 'JPN', 'اليابان'),
(36146, 2111217664, 2111225855, 'LK', 'LKA', 'سيريلانكا'),
(36147, 2111225856, 2111242239, 'HK', 'HKG', 'هونغ كونغ'),
(36148, 2111242240, 2111258623, 'CN', 'CHN', 'الصين'),
(36149, 2111258624, 2111275007, 'JP', 'JPN', 'اليابان'),
(36150, 2111275008, 2111307775, 'HK', 'HKG', 'هونغ كونغ'),
(36151, 2111307776, 2111832063, 'CN', 'CHN', 'الصين'),
(36152, 2111832064, 2112487423, 'TW', 'TWN', 'تايوان'),
(36153, 2112487424, 2112618495, 'VN', 'VNM', 'فييتنام'),
(36154, 2112618496, 2112880639, 'NZ', 'NZL', 'نيوزيلاندا'),
(36155, 2112880640, 2113683455, 'KR', 'KOR', 'جمهورية كوريا'),
(36156, 2113683456, 2113683487, 'AU', 'AUS', 'أستراليا'),
(36157, 2113683488, 2113683519, 'TW', 'TWN', 'تايوان'),
(36158, 2113683520, 2113683599, 'PH', 'PHL', 'الفلبين'),
(36159, 2113683600, 2113683615, 'TW', 'TWN', 'تايوان'),
(36160, 2113683616, 2113683647, 'AU', 'AUS', 'أستراليا'),
(36161, 2113683648, 2113683679, 'PH', 'PHL', 'الفلبين'),
(36162, 2113683680, 2113683775, 'TW', 'TWN', 'تايوان'),
(36163, 2113683776, 2113683839, 'PH', 'PHL', 'الفلبين'),
(36164, 2113683840, 2113683967, 'AU', 'AUS', 'أستراليا'),
(36165, 2113683968, 2113683999, 'PH', 'PHL', 'الفلبين'),
(36166, 2113684000, 2113684031, 'AU', 'AUS', 'أستراليا'),
(36167, 2113684032, 2113684059, 'PH', 'PHL', 'الفلبين'),
(36168, 2113684060, 2113684095, 'AU', 'AUS', 'أستراليا'),
(36169, 2113684096, 2113684127, 'TW', 'TWN', 'تايوان'),
(36170, 2113684128, 2113684183, 'AU', 'AUS', 'أستراليا'),
(36171, 2113684184, 2113684223, 'PH', 'PHL', 'الفلبين'),
(36172, 2113684224, 2113684239, 'TW', 'TWN', 'تايوان'),
(36173, 2113684240, 2113684255, 'PH', 'PHL', 'الفلبين'),
(36174, 2113684256, 2113684271, 'TW', 'TWN', 'تايوان'),
(36175, 2113684272, 2113684279, 'AU', 'AUS', 'أستراليا'),
(36176, 2113684280, 2113684351, 'PH', 'PHL', 'الفلبين'),
(36177, 2113684352, 2113684415, 'AU', 'AUS', 'أستراليا'),
(36178, 2113684416, 2113684431, 'PH', 'PHL', 'الفلبين'),
(36179, 2113684432, 2113684439, 'TW', 'TWN', 'تايوان'),
(36180, 2113684440, 2113684447, 'AU', 'AUS', 'أستراليا'),
(36181, 2113684448, 2113684511, 'TW', 'TWN', 'تايوان'),
(36182, 2113684512, 2113684527, 'AU', 'AUS', 'أستراليا'),
(36183, 2113684528, 2113684543, 'PH', 'PHL', 'الفلبين'),
(36184, 2113684544, 2113684671, 'AU', 'AUS', 'أستراليا'),
(36185, 2113684672, 2113684735, 'PH', 'PHL', 'الفلبين'),
(36186, 2113684736, 2113684991, 'TW', 'TWN', 'تايوان'),
(36187, 2113684992, 2113685007, 'PH', 'PHL', 'الفلبين'),
(36188, 2113685008, 2113685023, 'AU', 'AUS', 'أستراليا'),
(36189, 2113685024, 2113685047, 'PH', 'PHL', 'الفلبين'),
(36190, 2113685048, 2113685055, 'AU', 'AUS', 'أستراليا'),
(36191, 2113685056, 2113685231, 'PH', 'PHL', 'الفلبين'),
(36192, 2113685232, 2113685247, 'TW', 'TWN', 'تايوان'),
(36193, 2113685248, 2113685375, 'AU', 'AUS', 'أستراليا'),
(36194, 2113685376, 2113685503, 'PH', 'PHL', 'الفلبين'),
(36195, 2113685504, 2113686015, 'AU', 'AUS', 'أستراليا'),
(36196, 2113686016, 2113686079, 'PH', 'PHL', 'الفلبين'),
(36197, 2113686080, 2113686207, 'TW', 'TWN', 'تايوان'),
(36198, 2113686208, 2113686271, 'AU', 'AUS', 'أستراليا'),
(36199, 2113686272, 2113686303, 'PH', 'PHL', 'الفلبين'),
(36200, 2113686304, 2113686311, 'AU', 'AUS', 'أستراليا'),
(36201, 2113686312, 2113686319, 'PH', 'PHL', 'الفلبين'),
(36202, 2113686320, 2113686335, 'AU', 'AUS', 'أستراليا'),
(36203, 2113686336, 2113686399, 'TW', 'TWN', 'تايوان'),
(36204, 2113686400, 2113686527, 'AU', 'AUS', 'أستراليا'),
(36205, 2113686528, 2113687039, 'TW', 'TWN', 'تايوان'),
(36206, 2113687040, 2113688063, 'AU', 'AUS', 'أستراليا'),
(36207, 2113688064, 2113688319, 'TW', 'TWN', 'تايوان'),
(36208, 2113688320, 2113688575, 'MY', 'MYS', 'ماليزيا'),
(36209, 2113688576, 2113688831, 'AU', 'AUS', 'أستراليا'),
(36210, 2113688832, 2113689087, 'PH', 'PHL', 'الفلبين'),
(36211, 2113689088, 2113689343, 'JP', 'JPN', 'اليابان'),
(36212, 2113689344, 2113689599, 'HK', 'HKG', 'هونغ كونغ'),
(36213, 2113689600, 2113689791, 'AU', 'AUS', 'أستراليا'),
(36214, 2113689792, 2113689983, 'JP', 'JPN', 'اليابان'),
(36215, 2113689984, 2113692287, 'AU', 'AUS', 'أستراليا'),
(36216, 2113692288, 2113692415, 'PH', 'PHL', 'الفلبين'),
(36217, 2113692416, 2113693183, 'AU', 'AUS', 'أستراليا'),
(36218, 2113693184, 2113693343, 'HK', 'HKG', 'هونغ كونغ'),
(36219, 2113693344, 2113693359, 'AU', 'AUS', 'أستراليا'),
(36220, 2113693360, 2113693375, 'HK', 'HKG', 'هونغ كونغ'),
(36221, 2113693376, 2113693439, 'AU', 'AUS', 'أستراليا'),
(36222, 2113693440, 2113693503, 'HK', 'HKG', 'هونغ كونغ'),
(36223, 2113693504, 2113693535, 'AU', 'AUS', 'أستراليا'),
(36224, 2113693536, 2113693599, 'HK', 'HKG', 'هونغ كونغ'),
(36225, 2113693600, 2113693631, 'AU', 'AUS', 'أستراليا'),
(36226, 2113693632, 2113693663, 'HK', 'HKG', 'هونغ كونغ'),
(36227, 2113693664, 2113693695, 'AU', 'AUS', 'أستراليا'),
(36228, 2113693696, 2113693951, 'HK', 'HKG', 'هونغ كونغ'),
(36229, 2113693952, 2113694463, 'AU', 'AUS', 'أستراليا'),
(36230, 2113694464, 2113694719, 'HK', 'HKG', 'هونغ كونغ'),
(36231, 2113694720, 2113699839, 'AU', 'AUS', 'أستراليا'),
(36232, 2113699840, 2113716223, 'JP', 'JPN', 'اليابان'),
(36233, 2113716224, 2113724927, 'AU', 'AUS', 'أستراليا'),
(36234, 2113724928, 2113725183, 'IN', 'IND', 'الهند'),
(36235, 2113725184, 2113728511, 'AU', 'AUS', 'أستراليا'),
(36236, 2113728512, 2113732607, 'JP', 'JPN', 'اليابان'),
(36237, 2113732608, 2113765375, 'AU', 'AUS', 'أستراليا'),
(36238, 2113765376, 2113798143, 'HK', 'HKG', 'هونغ كونغ'),
(36239, 2113798144, 2113812479, 'AU', 'AUS', 'أستراليا'),
(36240, 2113812480, 2113813503, 'JP', 'JPN', 'اليابان'),
(36241, 2113813504, 2113830911, 'AU', 'AUS', 'أستراليا'),
(36242, 2113830912, 2113863679, 'CN', 'CHN', 'الصين'),
(36243, 2113863680, 2113929215, 'AU', 'AUS', 'أستراليا'),
(36244, 2113929216, 2130706431, 'JP', 'JPN', 'اليابان'),
(36245, 2147549184, 2147942399, 'US', 'USA', 'الولايات المتحدة'),
(36246, 2147942400, 2148007935, 'DE', 'DEU', 'ألمانيا'),
(36247, 2148007936, 2148532223, 'US', 'USA', 'الولايات المتحدة'),
(36248, 2148532224, 2148597759, 'GB', 'GBR', 'المملكة المتحدة'),
(36249, 2148597760, 2150039551, 'US', 'USA', 'الولايات المتحدة'),
(36250, 2150039552, 2150105087, 'NO', 'NOR', 'النرويج'),
(36251, 2150105088, 2150236159, 'GB', 'GBR', 'المملكة المتحدة'),
(36252, 2150236160, 2150301695, 'US', 'USA', 'الولايات المتحدة'),
(36253, 2150301696, 2150367231, 'CA', 'CAN', 'كندا'),
(36254, 2150367232, 2150432767, 'US', 'USA', 'الولايات المتحدة'),
(36255, 2150498304, 2151743487, 'US', 'USA', 'الولايات المتحدة'),
(36256, 2152726528, 2153119743, 'US', 'USA', 'الولايات المتحدة'),
(36257, 2153119744, 2153250815, 'GB', 'GBR', 'المملكة المتحدة'),
(36258, 2153250816, 2153578495, 'US', 'USA', 'الولايات المتحدة'),
(36259, 2153578496, 2153644031, 'FR', 'FRA', 'فرنسا'),
(36260, 2153644032, 2153906175, 'US', 'USA', 'الولايات المتحدة'),
(36261, 2153906176, 2153971711, 'GB', 'GBR', 'المملكة المتحدة'),
(36262, 2153971712, 2154037247, 'US', 'USA', 'الولايات المتحدة'),
(36263, 2154037248, 2154102783, 'CA', 'CAN', 'كندا'),
(36264, 2154102784, 2155610111, 'US', 'USA', 'الولايات المتحدة'),
(36265, 2155675648, 2155806719, 'US', 'USA', 'الولايات المتحدة'),
(36266, 2155872256, 2156003327, 'US', 'USA', 'الولايات المتحدة'),
(36267, 2156003328, 2156134399, 'AT', 'AUT', 'النمسا'),
(36268, 2156134400, 2156265471, 'US', 'USA', 'الولايات المتحدة'),
(36269, 2156265472, 2156331007, 'KR', 'KOR', 'جمهورية كوريا'),
(36270, 2156331008, 2156593151, 'US', 'USA', 'الولايات المتحدة'),
(36271, 2156593152, 2156658687, 'IL', 'ISR', 'إسرائيل'),
(36272, 2156724224, 2156855295, 'CH', 'CHE', 'سويسرا'),
(36273, 2156855296, 2156920831, 'US', 'USA', 'الولايات المتحدة'),
(36274, 2156920832, 2156986367, 'CA', 'CAN', 'كندا'),
(36275, 2156986368, 2159017983, 'US', 'USA', 'الولايات المتحدة'),
(36276, 2159017984, 2159083519, 'DE', 'DEU', 'ألمانيا'),
(36277, 2159083520, 2159149055, 'US', 'USA', 'الولايات المتحدة'),
(36278, 2159149056, 2159280127, 'CH', 'CHE', 'سويسرا'),
(36279, 2159280128, 2159542271, 'US', 'USA', 'الولايات المتحدة'),
(36280, 2159542272, 2159607807, 'AU', 'AUS', 'أستراليا'),
(36281, 2159607808, 2159869951, 'US', 'USA', 'الولايات المتحدة'),
(36282, 2159869952, 2159935487, 'CA', 'CAN', 'كندا'),
(36283, 2159935488, 2160525311, 'US', 'USA', 'الولايات المتحدة'),
(36284, 2160525312, 2160590847, 'GB', 'GBR', 'المملكة المتحدة'),
(36285, 2160590848, 2160656383, 'US', 'USA', 'الولايات المتحدة'),
(36286, 2160656384, 2160721919, 'FR', 'FRA', 'فرنسا'),
(36287, 2160721920, 2160852991, 'US', 'USA', 'الولايات المتحدة'),
(36288, 2160918528, 2161508351, 'US', 'USA', 'الولايات المتحدة'),
(36289, 2161508352, 2161573887, 'FI', 'FIN', 'فنلندا'),
(36290, 2161573888, 2162687999, 'US', 'USA', 'الولايات المتحدة'),
(36291, 2162688000, 2162753535, 'GB', 'GBR', 'المملكة المتحدة'),
(36292, 2162753536, 2162819071, 'CA', 'CAN', 'كندا'),
(36293, 2162884608, 2163212287, 'US', 'USA', 'الولايات المتحدة'),
(36294, 2163212288, 2163277823, 'GB', 'GBR', 'المملكة المتحدة'),
(36295, 2163277824, 2163408895, 'US', 'USA', 'الولايات المتحدة'),
(36296, 2163408896, 2163474431, 'GB', 'GBR', 'المملكة المتحدة'),
(36297, 2163474432, 2163605503, 'US', 'USA', 'الولايات المتحدة'),
(36298, 2163605504, 2163671039, 'CH', 'CHE', 'سويسرا'),
(36299, 2163671040, 2163867647, 'US', 'USA', 'الولايات المتحدة'),
(36300, 2163867648, 2163933183, 'AU', 'AUS', 'أستراليا'),
(36301, 2163933184, 2164260863, 'US', 'USA', 'الولايات المتحدة'),
(36302, 2164326400, 2164981759, 'US', 'USA', 'الولايات المتحدة'),
(36303, 2164981760, 2165112831, 'GB', 'GBR', 'المملكة المتحدة'),
(36304, 2165112832, 2165178367, 'DE', 'DEU', 'ألمانيا'),
(36305, 2165178368, 2165309439, 'US', 'USA', 'الولايات المتحدة'),
(36306, 2165309440, 2165374975, 'SE', 'SWE', 'السويد'),
(36307, 2165374976, 2165440511, 'US', 'USA', 'الولايات المتحدة'),
(36308, 2165506048, 2165571583, 'US', 'USA', 'الولايات المتحدة'),
(36309, 2165571584, 2165637119, 'FR', 'FRA', 'فرنسا'),
(36310, 2165637120, 2165964799, 'US', 'USA', 'الولايات المتحدة'),
(36311, 2165964800, 2166030335, 'DE', 'DEU', 'ألمانيا'),
(36312, 2166030336, 2166095871, 'AT', 'AUT', 'النمسا'),
(36313, 2166095872, 2166292479, 'US', 'USA', 'الولايات المتحدة'),
(36314, 2166292480, 2166358015, 'GB', 'GBR', 'المملكة المتحدة'),
(36315, 2166358016, 2166571007, 'US', 'USA', 'الولايات المتحدة'),
(36316, 2166571008, 2166575103, 'GB', 'GBR', 'المملكة المتحدة'),
(36317, 2166575104, 2167209983, 'US', 'USA', 'الولايات المتحدة'),
(36318, 2167275520, 2167930879, 'US', 'USA', 'الولايات المتحدة'),
(36319, 2167996416, 2168193023, 'US', 'USA', 'الولايات المتحدة'),
(36320, 2168193024, 2168258559, 'JP', 'JPN', 'اليابان'),
(36321, 2168258560, 2168651775, 'US', 'USA', 'الولايات المتحدة'),
(36322, 2168651776, 2168717311, 'GB', 'GBR', 'المملكة المتحدة'),
(36323, 2168717312, 2168782847, 'US', 'USA', 'الولايات المتحدة'),
(36324, 2168782848, 2168913919, 'DE', 'DEU', 'ألمانيا'),
(36325, 2168913920, 2169044991, 'US', 'USA', 'الولايات المتحدة'),
(36326, 2169044992, 2169110527, 'CR', 'CRI', 'كوستا ريكا'),
(36327, 2169110528, 2169372671, 'US', 'USA', 'الولايات المتحدة'),
(36328, 2169372672, 2169438207, 'AU', 'AUS', 'أستراليا'),
(36329, 2169438208, 2170028031, 'US', 'USA', 'الولايات المتحدة'),
(36330, 2170028032, 2170093567, 'FR', 'FRA', 'فرنسا'),
(36331, 2170093568, 2170159103, 'US', 'USA', 'الولايات المتحدة'),
(36332, 2170159104, 2170224639, 'VE', 'VEN', 'فنزويلا'),
(36333, 2170224640, 2170421247, 'US', 'USA', 'الولايات المتحدة'),
(36334, 2170421248, 2170486783, 'AU', 'AUS', 'أستراليا'),
(36335, 2170486784, 2170552319, 'US', 'USA', 'الولايات المتحدة'),
(36336, 2170552320, 2170617855, 'AU', 'AUS', 'أستراليا'),
(36337, 2170617856, 2170683391, 'CA', 'CAN', 'كندا'),
(36338, 2170683392, 2170814463, 'US', 'USA', 'الولايات المتحدة'),
(36339, 2170814464, 2170879999, 'CA', 'CAN', 'كندا'),
(36340, 2170880000, 2170945535, 'US', 'USA', 'الولايات المتحدة'),
(36341, 2170945536, 2171011071, 'FR', 'FRA', 'فرنسا'),
(36342, 2171011072, 2171076607, 'DE', 'DEU', 'ألمانيا'),
(36343, 2171076608, 2171142143, 'FR', 'FRA', 'فرنسا'),
(36344, 2171142144, 2172256255, 'US', 'USA', 'الولايات المتحدة'),
(36345, 2172321792, 2172452863, 'US', 'USA', 'الولايات المتحدة'),
(36346, 2172452864, 2172518399, 'NL', 'NLD', 'هولندا'),
(36347, 2172518400, 2172583935, 'US', 'USA', 'الولايات المتحدة'),
(36348, 2172583936, 2172649471, 'AU', 'AUS', 'أستراليا'),
(36349, 2172649472, 2172715007, 'CA', 'CAN', 'كندا'),
(36350, 2172715008, 2172780543, 'CH', 'CHE', 'سويسرا'),
(36351, 2172780544, 2172911615, 'US', 'USA', 'الولايات المتحدة'),
(36352, 2172911616, 2172977151, 'CH', 'CHE', 'سويسرا'),
(36353, 2172977152, 2173173759, 'US', 'USA', 'الولايات المتحدة'),
(36354, 2173173760, 2173239295, 'JP', 'JPN', 'اليابان'),
(36355, 2173239296, 2173435903, 'US', 'USA', 'الولايات المتحدة'),
(36356, 2173501440, 2173566975, 'US', 'USA', 'الولايات المتحدة'),
(36357, 2173566976, 2173632511, 'DK', 'DNK', 'الدنيمارك'),
(36358, 2173632512, 2173698047, 'DE', 'DEU', 'ألمانيا'),
(36359, 2173698048, 2175336447, 'US', 'USA', 'الولايات المتحدة'),
(36360, 2175336448, 2175401983, 'GB', 'GBR', 'المملكة المتحدة'),
(36361, 2175401984, 2175598591, 'US', 'USA', 'الولايات المتحدة'),
(36362, 2175598592, 2175664127, 'CA', 'CAN', 'كندا'),
(36363, 2175664128, 2175729663, 'US', 'USA', 'الولايات المتحدة'),
(36364, 2175729664, 2175795199, 'FR', 'FRA', 'فرنسا'),
(36365, 2175795200, 2175860735, 'US', 'USA', 'الولايات المتحدة'),
(36366, 2175860736, 2175926271, 'NO', 'NOR', 'النرويج'),
(36367, 2175926272, 2175991807, 'SE', 'SWE', 'السويد'),
(36368, 2175991808, 2176057343, 'US', 'USA', 'الولايات المتحدة'),
(36369, 2176057344, 2176122879, 'AU', 'AUS', 'أستراليا'),
(36370, 2176122880, 2176450559, 'FR', 'FRA', 'فرنسا'),
(36371, 2176450560, 2176516095, 'US', 'USA', 'الولايات المتحدة'),
(36372, 2176516096, 2176581631, 'DE', 'DEU', 'ألمانيا'),
(36373, 2176581632, 2176974847, 'US', 'USA', 'الولايات المتحدة'),
(36374, 2176974848, 2177105919, 'CH', 'CHE', 'سويسرا'),
(36375, 2177105920, 2177302527, 'US', 'USA', 'الولايات المتحدة'),
(36376, 2177302528, 2177368063, 'FR', 'FRA', 'فرنسا'),
(36377, 2177368064, 2177695743, 'US', 'USA', 'الولايات المتحدة'),
(36378, 2177761280, 2177826815, 'DE', 'DEU', 'ألمانيا'),
(36379, 2177826816, 2177892351, 'US', 'USA', 'الولايات المتحدة'),
(36380, 2177892352, 2177957887, 'GB', 'GBR', 'المملكة المتحدة'),
(36381, 2177957888, 2178285567, 'US', 'USA', 'الولايات المتحدة'),
(36382, 2178285568, 2178351103, 'AR', 'ARG', 'الأرجنتين'),
(36383, 2178351104, 2178416639, 'GB', 'GBR', 'المملكة المتحدة'),
(36384, 2178416640, 2178482175, 'US', 'USA', 'الولايات المتحدة'),
(36385, 2178482176, 2178547711, 'DE', 'DEU', 'ألمانيا'),
(36386, 2178547712, 2179465215, 'US', 'USA', 'الولايات المتحدة'),
(36387, 2179530752, 2179596287, 'DE', 'DEU', 'ألمانيا'),
(36388, 2179596288, 2179661823, 'GB', 'GBR', 'المملكة المتحدة'),
(36389, 2179661824, 2179989503, 'US', 'USA', 'الولايات المتحدة'),
(36390, 2179989504, 2180186111, 'NO', 'NOR', 'النرويج'),
(36391, 2180186112, 2180448255, 'US', 'USA', 'الولايات المتحدة'),
(36392, 2180448256, 2180513791, 'DE', 'DEU', 'ألمانيا'),
(36393, 2180513792, 2180579327, 'US', 'USA', 'الولايات المتحدة'),
(36394, 2180579328, 2180644863, 'JP', 'JPN', 'اليابان'),
(36395, 2180644864, 2180907007, 'US', 'USA', 'الولايات المتحدة'),
(36396, 2180907008, 2180972543, 'KR', 'KOR', 'جمهورية كوريا'),
(36397, 2180972544, 2181038079, 'US', 'USA', 'الولايات المتحدة'),
(36398, 2181103616, 2181824511, 'US', 'USA', 'الولايات المتحدة'),
(36399, 2181824512, 2181890047, 'CA', 'CAN', 'كندا'),
(36400, 2181890048, 2182021119, 'US', 'USA', 'الولايات المتحدة'),
(36401, 2182021120, 2182086655, 'CA', 'CAN', 'كندا'),
(36402, 2182086656, 2182610943, 'US', 'USA', 'الولايات المتحدة'),
(36403, 2182610944, 2182676479, 'GB', 'GBR', 'المملكة المتحدة'),
(36404, 2182742016, 2182873087, 'US', 'USA', 'الولايات المتحدة'),
(36405, 2182873088, 2182938623, 'SE', 'SWE', 'السويد'),
(36406, 2182938624, 2183135231, 'US', 'USA', 'الولايات المتحدة'),
(36407, 2183135232, 2183200767, 'GB', 'GBR', 'المملكة المتحدة'),
(36408, 2183200768, 2183266303, 'US', 'USA', 'الولايات المتحدة'),
(36409, 2183266304, 2183331839, 'JP', 'JPN', 'اليابان'),
(36410, 2183331840, 2183462911, 'US', 'USA', 'الولايات المتحدة'),
(36411, 2183462912, 2183528447, 'NL', 'NLD', 'هولندا'),
(36412, 2183528448, 2183856127, 'US', 'USA', 'الولايات المتحدة'),
(36413, 2183921664, 2184577023, 'US', 'USA', 'الولايات المتحدة'),
(36414, 2184577024, 2184642559, 'JP', 'JPN', 'اليابان'),
(36415, 2184642560, 2184708095, 'US', 'USA', 'الولايات المتحدة'),
(36416, 2184708096, 2184773631, 'AU', 'AUS', 'أستراليا'),
(36417, 2184773632, 2184904703, 'US', 'USA', 'الولايات المتحدة'),
(36418, 2184904704, 2185035775, 'CH', 'CHE', 'سويسرا'),
(36419, 2185035776, 2185166847, 'US', 'USA', 'الولايات المتحدة'),
(36420, 2185166848, 2185232383, 'CA', 'CAN', 'كندا'),
(36421, 2185232384, 2185363455, 'US', 'USA', 'الولايات المتحدة'),
(36422, 2185363456, 2185428991, 'FR', 'FRA', 'فرنسا'),
(36423, 2185428992, 2185494527, 'NO', 'NOR', 'النرويج'),
(36424, 2185494528, 2185560063, 'US', 'USA', 'الولايات المتحدة'),
(36425, 2185560064, 2185625599, 'JP', 'JPN', 'اليابان'),
(36426, 2185625600, 2185822207, 'US', 'USA', 'الولايات المتحدة'),
(36427, 2185822208, 2185887743, 'DE', 'DEU', 'ألمانيا'),
(36428, 2185887744, 2185953279, 'US', 'USA', 'الولايات المتحدة'),
(36429, 2185953280, 2186018815, 'DE', 'DEU', 'ألمانيا'),
(36430, 2186018816, 2186149887, 'US', 'USA', 'الولايات المتحدة'),
(36431, 2186149888, 2186215423, 'NL', 'NLD', 'هولندا'),
(36432, 2186215424, 2186280959, 'FR', 'FRA', 'فرنسا'),
(36433, 2186280960, 2186412031, 'US', 'USA', 'الولايات المتحدة'),
(36434, 2186412032, 2186477567, 'CH', 'CHE', 'سويسرا'),
(36435, 2186477568, 2186543103, 'DE', 'DEU', 'ألمانيا'),
(36436, 2186543104, 2186608639, 'FR', 'FRA', 'فرنسا'),
(36437, 2186608640, 2186739711, 'US', 'USA', 'الولايات المتحدة'),
(36438, 2186739712, 2186805247, 'JP', 'JPN', 'اليابان'),
(36439, 2186805248, 2186870783, 'GB', 'GBR', 'المملكة المتحدة'),
(36440, 2186870784, 2186936319, 'NL', 'NLD', 'هولندا'),
(36441, 2186936320, 2187067391, 'US', 'USA', 'الولايات المتحدة'),
(36442, 2187067392, 2187132927, 'CH', 'CHE', 'سويسرا'),
(36443, 2187132928, 2187263999, 'US', 'USA', 'الولايات المتحدة'),
(36444, 2187264000, 2187329535, 'AU', 'AUS', 'أستراليا'),
(36445, 2187329536, 2187460607, 'US', 'USA', 'الولايات المتحدة'),
(36446, 2187460608, 2187526143, 'FR', 'FRA', 'فرنسا'),
(36447, 2187526144, 2187591679, 'US', 'USA', 'الولايات المتحدة'),
(36448, 2187591680, 2187657215, 'SE', 'SWE', 'السويد'),
(36449, 2187657216, 2187722751, 'US', 'USA', 'الولايات المتحدة'),
(36450, 2187722752, 2187788287, 'AU', 'AUS', 'أستراليا'),
(36451, 2187788288, 2187853823, 'US', 'USA', 'الولايات المتحدة'),
(36452, 2187853824, 2187919359, 'BE', 'BEL', 'بلجيكا'),
(36453, 2187919360, 2188378111, 'US', 'USA', 'الولايات المتحدة'),
(36454, 2188378112, 2188443647, 'NL', 'NLD', 'هولندا'),
(36455, 2188443648, 2188509183, 'CA', 'CAN', 'كندا'),
(36456, 2188509184, 2188574719, 'US', 'USA', 'الولايات المتحدة'),
(36457, 2188574720, 2188640255, 'NL', 'NLD', 'هولندا'),
(36458, 2188640256, 2188705791, 'AU', 'AUS', 'أستراليا'),
(36459, 2188705792, 2188902399, 'US', 'USA', 'الولايات المتحدة'),
(36460, 2188902400, 2188967935, 'FR', 'FRA', 'فرنسا'),
(36461, 2188967936, 2189099007, 'US', 'USA', 'الولايات المتحدة'),
(36462, 2189099008, 2189164543, 'NZ', 'NZL', 'نيوزيلاندا'),
(36463, 2189164544, 2189230079, 'US', 'USA', 'الولايات المتحدة'),
(36464, 2189230080, 2189295615, 'CH', 'CHE', 'سويسرا'),
(36465, 2189295616, 2189557759, 'US', 'USA', 'الولايات المتحدة'),
(36466, 2189557760, 2189623295, 'AU', 'AUS', 'أستراليا'),
(36467, 2189623296, 2189754367, 'US', 'USA', 'الولايات المتحدة'),
(36468, 2189754368, 2189819903, 'DE', 'DEU', 'ألمانيا'),
(36469, 2189819904, 2189950975, 'US', 'USA', 'الولايات المتحدة'),
(36470, 2189950976, 2190016511, 'IT', 'ITA', 'إيطاليا'),
(36471, 2190016512, 2190082047, 'US', 'USA', 'الولايات المتحدة'),
(36472, 2190082048, 2190737407, 'NL', 'NLD', 'هولندا'),
(36473, 2190737408, 2190802943, 'GB', 'GBR', 'المملكة المتحدة'),
(36474, 2190802944, 2190868479, 'DE', 'DEU', 'ألمانيا'),
(36475, 2190868480, 2191065087, 'US', 'USA', 'الولايات المتحدة'),
(36476, 2191065088, 2191130623, 'JP', 'JPN', 'اليابان'),
(36477, 2191130624, 2191196159, 'US', 'USA', 'الولايات المتحدة'),
(36478, 2191196160, 2191261695, 'AU', 'AUS', 'أستراليا'),
(36479, 2191261696, 2191392767, 'US', 'USA', 'الولايات المتحدة'),
(36480, 2191392768, 2191458303, 'JP', 'JPN', 'اليابان'),
(36481, 2191458304, 2191523839, 'GB', 'GBR', 'المملكة المتحدة'),
(36482, 2191523840, 2191589375, 'US', 'USA', 'الولايات المتحدة'),
(36483, 2191589376, 2191654911, 'NL', 'NLD', 'هولندا'),
(36484, 2191654912, 2192769023, 'US', 'USA', 'الولايات المتحدة'),
(36485, 2192769024, 2192834559, 'CA', 'CAN', 'كندا'),
(36486, 2192900096, 2193031167, 'US', 'USA', 'الولايات المتحدة'),
(36487, 2193031168, 2193096703, 'DE', 'DEU', 'ألمانيا'),
(36488, 2193096704, 2193162239, 'US', 'USA', 'الولايات المتحدة'),
(36489, 2193227776, 2193293311, 'IT', 'ITA', 'إيطاليا'),
(36490, 2193293312, 2193358847, 'US', 'USA', 'الولايات المتحدة'),
(36491, 2193358848, 2193424383, 'FI', 'FIN', 'فنلندا'),
(36492, 2193424384, 2193489919, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(36493, 2193489920, 2193555455, 'FR', 'FRA', 'فرنسا'),
(36494, 2193555456, 2193620991, 'US', 'USA', 'الولايات المتحدة'),
(36495, 2193620992, 2193686527, 'IT', 'ITA', 'إيطاليا'),
(36496, 2193752064, 2193817599, 'AU', 'AUS', 'أستراليا'),
(36497, 2193817600, 2193883135, 'NZ', 'NZL', 'نيوزيلاندا'),
(36498, 2193883136, 2194014207, 'US', 'USA', 'الولايات المتحدة'),
(36499, 2194014208, 2194079743, 'CH', 'CHE', 'سويسرا'),
(36500, 2194079744, 2194407423, 'US', 'USA', 'الولايات المتحدة'),
(36501, 2194472960, 2194538495, 'US', 'USA', 'الولايات المتحدة'),
(36502, 2194538496, 2194604031, 'ES', 'ESP', 'إسبانيا'),
(36503, 2194604032, 2194669567, 'US', 'USA', 'الولايات المتحدة'),
(36504, 2194669568, 2194735103, 'IS', 'ISL', 'أيسلندا'),
(36505, 2194735104, 2194800639, 'GB', 'GBR', 'المملكة المتحدة'),
(36506, 2194800640, 2195193855, 'US', 'USA', 'الولايات المتحدة'),
(36507, 2195193856, 2195324927, 'NZ', 'NZL', 'نيوزيلاندا'),
(36508, 2195324928, 2195455999, 'US', 'USA', 'الولايات المتحدة'),
(36509, 2195456000, 2195521535, 'AU', 'AUS', 'أستراليا'),
(36510, 2195521536, 2195652607, 'US', 'USA', 'الولايات المتحدة'),
(36511, 2195652608, 2195718143, 'CH', 'CHE', 'سويسرا'),
(36512, 2195718144, 2195783679, 'US', 'USA', 'الولايات المتحدة'),
(36513, 2195783680, 2196045823, 'DK', 'DNK', 'الدنيمارك'),
(36514, 2196045824, 2196111359, 'SE', 'SWE', 'السويد'),
(36515, 2196111360, 2196439039, 'FI', 'FIN', 'فنلندا'),
(36516, 2196439040, 2197094399, 'SE', 'SWE', 'السويد'),
(36517, 2197094400, 2197159935, 'US', 'USA', 'الولايات المتحدة'),
(36518, 2197159936, 2197225471, 'GB', 'GBR', 'المملكة المتحدة'),
(36519, 2197225472, 2197422079, 'US', 'USA', 'الولايات المتحدة'),
(36520, 2197422080, 2197487615, 'CA', 'CAN', 'كندا'),
(36521, 2197487616, 2197553151, 'IT', 'ITA', 'إيطاليا'),
(36522, 2197553152, 2197749759, 'US', 'USA', 'الولايات المتحدة'),
(36523, 2197880832, 2197946367, 'IT', 'ITA', 'إيطاليا'),
(36524, 2197946368, 2202533887, 'US', 'USA', 'الولايات المتحدة'),
(36525, 2202599424, 2204172287, 'US', 'USA', 'الولايات المتحدة'),
(36526, 2204172288, 2204237823, 'SE', 'SWE', 'السويد'),
(36527, 2204237824, 2204303359, 'US', 'USA', 'الولايات المتحدة'),
(36528, 2204303360, 2204368895, 'DE', 'DEU', 'ألمانيا'),
(36529, 2204434432, 2204499967, 'US', 'USA', 'الولايات المتحدة'),
(36530, 2204499968, 2204565503, 'CH', 'CHE', 'سويسرا'),
(36531, 2204565504, 2204631039, 'US', 'USA', 'الولايات المتحدة'),
(36532, 2204631040, 2204696575, 'CA', 'CAN', 'كندا'),
(36533, 2204696576, 2204893183, 'US', 'USA', 'الولايات المتحدة'),
(36534, 2204958720, 2205089791, 'US', 'USA', 'الولايات المتحدة'),
(36535, 2205089792, 2205155327, 'GB', 'GBR', 'المملكة المتحدة'),
(36536, 2205155328, 2205286399, 'JP', 'JPN', 'اليابان'),
(36537, 2205286400, 2205351935, 'IT', 'ITA', 'إيطاليا'),
(36538, 2205351936, 2205483007, 'SE', 'SWE', 'السويد'),
(36539, 2205483008, 2205515775, 'CH', 'CHE', 'سويسرا'),
(36540, 2205548544, 2206269439, 'US', 'USA', 'الولايات المتحدة'),
(36541, 2206269440, 2206334975, 'CA', 'CAN', 'كندا'),
(36542, 2206334976, 2206400511, 'AT', 'AUT', 'النمسا'),
(36543, 2206400512, 2206466047, 'US', 'USA', 'الولايات المتحدة'),
(36544, 2206466048, 2207121407, 'CA', 'CAN', 'كندا'),
(36545, 2207121408, 2207449087, 'US', 'USA', 'الولايات المتحدة'),
(36546, 2207449088, 2207711231, 'CA', 'CAN', 'كندا'),
(36547, 2207711232, 2207776767, 'US', 'USA', 'الولايات المتحدة'),
(36548, 2207776768, 2207842303, 'CH', 'CHE', 'سويسرا'),
(36549, 2207842304, 2207907839, 'US', 'USA', 'الولايات المتحدة'),
(36550, 2207907840, 2207973375, 'IT', 'ITA', 'إيطاليا'),
(36551, 2207973376, 2208038911, 'NL', 'NLD', 'هولندا'),
(36552, 2208038912, 2208235519, 'US', 'USA', 'الولايات المتحدة'),
(36553, 2208235520, 2208301055, 'DE', 'DEU', 'ألمانيا'),
(36554, 2208301056, 2208366591, 'FI', 'FIN', 'فنلندا'),
(36555, 2208432128, 2208563199, 'CA', 'CAN', 'كندا'),
(36556, 2208563200, 2208759807, 'DK', 'DNK', 'الدنيمارك'),
(36557, 2208759808, 2208890879, 'US', 'USA', 'الولايات المتحدة'),
(36558, 2208890880, 2208956415, 'DE', 'DEU', 'ألمانيا'),
(36559, 2208956416, 2209021951, 'AU', 'AUS', 'أستراليا'),
(36560, 2209021952, 2209087487, 'US', 'USA', 'الولايات المتحدة'),
(36561, 2209087488, 2209153023, 'AU', 'AUS', 'أستراليا'),
(36562, 2209153024, 2209218559, 'DE', 'DEU', 'ألمانيا'),
(36563, 2209218560, 2209284095, 'NL', 'NLD', 'هولندا'),
(36564, 2209284096, 2209349631, 'IT', 'ITA', 'إيطاليا'),
(36565, 2209415168, 2209480703, 'FI', 'FIN', 'فنلندا'),
(36566, 2209480704, 2209546239, 'MX', 'MEX', 'المكسيك'),
(36567, 2209546240, 2209611775, 'US', 'USA', 'الولايات المتحدة'),
(36568, 2209611776, 2209677311, 'NL', 'NLD', 'هولندا'),
(36569, 2209677312, 2209742847, 'AU', 'AUS', 'أستراليا'),
(36570, 2209742848, 2209939455, 'US', 'USA', 'الولايات المتحدة'),
(36571, 2209939456, 2210004991, 'AU', 'AUS', 'أستراليا'),
(36572, 2210004992, 2210136063, 'US', 'USA', 'الولايات المتحدة'),
(36573, 2210136064, 2210201599, 'DE', 'DEU', 'ألمانيا'),
(36574, 2210201600, 2210594815, 'US', 'USA', 'الولايات المتحدة'),
(36575, 2210594816, 2210660351, 'CA', 'CAN', 'كندا'),
(36576, 2210660352, 2210725887, 'FR', 'FRA', 'فرنسا'),
(36577, 2210725888, 2211053567, 'US', 'USA', 'الولايات المتحدة'),
(36578, 2211053568, 2211119103, 'CA', 'CAN', 'كندا'),
(36579, 2211119104, 2211184639, 'NZ', 'NZL', 'نيوزيلاندا'),
(36580, 2211184640, 2211250175, 'US', 'USA', 'الولايات المتحدة'),
(36581, 2211250176, 2211315711, 'SE', 'SWE', 'السويد'),
(36582, 2211315712, 2211381247, 'JP', 'JPN', 'اليابان'),
(36583, 2211381248, 2211446783, 'FI', 'FIN', 'فنلندا'),
(36584, 2211446784, 2211643391, 'US', 'USA', 'الولايات المتحدة'),
(36585, 2211643392, 2211708927, 'NL', 'NLD', 'هولندا'),
(36586, 2211708928, 2211774463, 'US', 'USA', 'الولايات المتحدة'),
(36587, 2211774464, 2211839999, 'CA', 'CAN', 'كندا'),
(36588, 2211840000, 2212036607, 'US', 'USA', 'الولايات المتحدة'),
(36589, 2212036608, 2212102143, 'AU', 'AUS', 'أستراليا'),
(36590, 2212102144, 2212233215, 'US', 'USA', 'الولايات المتحدة'),
(36591, 2212233216, 2212298751, 'DE', 'DEU', 'ألمانيا'),
(36592, 2212364288, 2212495359, 'US', 'USA', 'الولايات المتحدة'),
(36593, 2212495360, 2212560895, 'NL', 'NLD', 'هولندا'),
(36594, 2212560896, 2212691967, 'US', 'USA', 'الولايات المتحدة'),
(36595, 2212691968, 2212757503, 'GB', 'GBR', 'المملكة المتحدة'),
(36596, 2212757504, 2212823039, 'FI', 'FIN', 'فنلندا'),
(36597, 2212823040, 2212954111, 'US', 'USA', 'الولايات المتحدة'),
(36598, 2212954112, 2213019647, 'GB', 'GBR', 'المملكة المتحدة'),
(36599, 2213019648, 2213085183, 'CA', 'CAN', 'كندا'),
(36600, 2213085184, 2213150719, 'US', 'USA', 'الولايات المتحدة'),
(36601, 2213150720, 2213216255, 'DE', 'DEU', 'ألمانيا'),
(36602, 2213216256, 2213281791, 'CA', 'CAN', 'كندا'),
(36603, 2213281792, 2213347327, 'AU', 'AUS', 'أستراليا'),
(36604, 2213347328, 2213412863, 'NL', 'NLD', 'هولندا'),
(36605, 2213412864, 2213675007, 'US', 'USA', 'الولايات المتحدة'),
(36606, 2213675008, 2213740543, 'AU', 'AUS', 'أستراليا'),
(36607, 2213740544, 2213806079, 'US', 'USA', 'الولايات المتحدة'),
(36608, 2213806080, 2213937151, 'AU', 'AUS', 'أستراليا'),
(36609, 2213937152, 2214002687, 'DE', 'DEU', 'ألمانيا'),
(36610, 2214002688, 2214068223, 'US', 'USA', 'الولايات المتحدة'),
(36611, 2214068224, 2214133759, 'JP', 'JPN', 'اليابان'),
(36612, 2214133760, 2214264831, 'US', 'USA', 'الولايات المتحدة'),
(36613, 2214264832, 2214330367, 'GB', 'GBR', 'المملكة المتحدة'),
(36614, 2214330368, 2214395903, 'US', 'USA', 'الولايات المتحدة'),
(36615, 2214395904, 2214461439, 'CA', 'CAN', 'كندا'),
(36616, 2214461440, 2214526975, 'FR', 'FRA', 'فرنسا'),
(36617, 2214592512, 2218786815, 'US', 'USA', 'الولايات المتحدة'),
(36618, 2218786816, 2219769855, 'IL', 'ISR', 'إسرائيل'),
(36619, 2219769856, 2224160767, 'US', 'USA', 'الولايات المتحدة'),
(36620, 2224160768, 2224226303, 'GB', 'GBR', 'المملكة المتحدة'),
(36621, 2224226304, 2224357375, 'US', 'USA', 'الولايات المتحدة'),
(36622, 2224357376, 2224422911, 'FR', 'FRA', 'فرنسا'),
(36623, 2224422912, 2224488447, 'NO', 'NOR', 'النرويج'),
(36624, 2224488448, 2224619519, 'US', 'USA', 'الولايات المتحدة'),
(36625, 2224619520, 2224685055, 'GB', 'GBR', 'المملكة المتحدة'),
(36626, 2224685056, 2224750591, 'US', 'USA', 'الولايات المتحدة'),
(36627, 2224750592, 2224816127, 'FI', 'FIN', 'فنلندا'),
(36628, 2224816128, 2224881663, 'CA', 'CAN', 'كندا'),
(36629, 2224947200, 2225405951, 'US', 'USA', 'الولايات المتحدة'),
(36630, 2225405952, 2225733631, 'FR', 'FRA', 'فرنسا'),
(36631, 2225733632, 2225799167, 'US', 'USA', 'الولايات المتحدة'),
(36632, 2225799168, 2225864703, 'FI', 'FIN', 'فنلندا'),
(36633, 2225864704, 2226126847, 'US', 'USA', 'الولايات المتحدة'),
(36634, 2226126848, 2226192383, 'DE', 'DEU', 'ألمانيا'),
(36635, 2226192384, 2226323455, 'US', 'USA', 'الولايات المتحدة'),
(36636, 2226323456, 2226388991, 'JP', 'JPN', 'اليابان'),
(36637, 2226388992, 2226454527, 'DE', 'DEU', 'ألمانيا'),
(36638, 2226454528, 2226520063, 'NZ', 'NZL', 'نيوزيلاندا'),
(36639, 2226520064, 2226585599, 'JP', 'JPN', 'اليابان'),
(36640, 2226585600, 2226651135, 'US', 'USA', 'الولايات المتحدة'),
(36641, 2226716672, 2226782207, 'GB', 'GBR', 'المملكة المتحدة'),
(36642, 2226782208, 2226847743, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(36643, 2226847744, 2226913279, 'DE', 'DEU', 'ألمانيا'),
(36644, 2226913280, 2227109887, 'US', 'USA', 'الولايات المتحدة'),
(36645, 2227175424, 2227372031, 'US', 'USA', 'الولايات المتحدة'),
(36646, 2227372032, 2227437567, 'DE', 'DEU', 'ألمانيا'),
(36647, 2227437568, 2227503103, 'SE', 'SWE', 'السويد'),
(36648, 2227503104, 2227634175, 'US', 'USA', 'الولايات المتحدة'),
(36649, 2227634176, 2227699711, 'DE', 'DEU', 'ألمانيا'),
(36650, 2227699712, 2227830783, 'US', 'USA', 'الولايات المتحدة'),
(36651, 2227830784, 2229141503, 'CA', 'CAN', 'كندا'),
(36652, 2229141504, 2229207039, 'JP', 'JPN', 'اليابان'),
(36653, 2229207040, 2229338111, 'US', 'USA', 'الولايات المتحدة'),
(36654, 2229338112, 2229403647, 'CA', 'CAN', 'كندا'),
(36655, 2229403648, 2229469183, 'US', 'USA', 'الولايات المتحدة'),
(36656, 2229469184, 2229534719, 'FR', 'FRA', 'فرنسا'),
(36657, 2229534720, 2229600255, 'US', 'USA', 'الولايات المتحدة'),
(36658, 2229600256, 2229665791, 'NL', 'NLD', 'هولندا'),
(36659, 2229665792, 2229796863, 'DE', 'DEU', 'ألمانيا'),
(36660, 2229796864, 2229862399, 'GB', 'GBR', 'المملكة المتحدة'),
(36661, 2229862400, 2229927935, 'US', 'USA', 'الولايات المتحدة'),
(36662, 2229927936, 2229993471, 'AU', 'AUS', 'أستراليا'),
(36663, 2229993472, 2230583295, 'US', 'USA', 'الولايات المتحدة'),
(36664, 2230583296, 2230648831, 'GB', 'GBR', 'المملكة المتحدة'),
(36665, 2230648832, 2230714367, 'US', 'USA', 'الولايات المتحدة'),
(36666, 2230714368, 2230779903, 'CA', 'CAN', 'كندا'),
(36667, 2230779904, 2230910975, 'MX', 'MEX', 'المكسيك'),
(36668, 2230910976, 2231042047, 'US', 'USA', 'الولايات المتحدة'),
(36669, 2231107584, 2231173119, 'DE', 'DEU', 'ألمانيا'),
(36670, 2231173120, 2231238655, 'US', 'USA', 'الولايات المتحدة'),
(36671, 2231238656, 2231304191, 'MX', 'MEX', 'المكسيك'),
(36672, 2231369728, 2248146943, 'JP', 'JPN', 'اليابان'),
(36673, 2248212480, 2248343551, 'DE', 'DEU', 'ألمانيا'),
(36674, 2248409088, 2248605695, 'US', 'USA', 'الولايات المتحدة'),
(36675, 2248605696, 2248671231, 'AU', 'AUS', 'أستراليا'),
(36676, 2248671232, 2249261055, 'US', 'USA', 'الولايات المتحدة'),
(36677, 2249326592, 2249392127, 'AU', 'AUS', 'أستراليا'),
(36678, 2249457664, 2249523199, 'US', 'USA', 'الولايات المتحدة'),
(36679, 2249523200, 2249588735, 'CH', 'CHE', 'سويسرا'),
(36680, 2249588736, 2249654271, 'CA', 'CAN', 'كندا'),
(36681, 2249654272, 2249785343, 'US', 'USA', 'الولايات المتحدة'),
(36682, 2249785344, 2249850879, 'SE', 'SWE', 'السويد'),
(36683, 2249850880, 2249916415, 'US', 'USA', 'الولايات المتحدة'),
(36684, 2249916416, 2249981951, 'NL', 'NLD', 'هولندا'),
(36685, 2249981952, 2250047487, 'DE', 'DEU', 'ألمانيا'),
(36686, 2250047488, 2250113023, 'US', 'USA', 'الولايات المتحدة'),
(36687, 2250113024, 2250178559, 'DE', 'DEU', 'ألمانيا'),
(36688, 2250178560, 2250244095, 'CA', 'CAN', 'كندا'),
(36689, 2250244096, 2250375167, 'US', 'USA', 'الولايات المتحدة'),
(36690, 2250375168, 2250440703, 'DE', 'DEU', 'ألمانيا'),
(36691, 2250440704, 2250506239, 'US', 'USA', 'الولايات المتحدة'),
(36692, 2250506240, 2250571775, 'GB', 'GBR', 'المملكة المتحدة'),
(36693, 2250571776, 2250637311, 'FI', 'FIN', 'فنلندا'),
(36694, 2250637312, 2251227135, 'US', 'USA', 'الولايات المتحدة'),
(36695, 2251227136, 2251292671, 'NO', 'NOR', 'النرويج'),
(36696, 2251292672, 2251685887, 'US', 'USA', 'الولايات المتحدة'),
(36697, 2251685888, 2251751423, 'BE', 'BEL', 'بلجيكا'),
(36698, 2251751424, 2251948031, 'US', 'USA', 'الولايات المتحدة'),
(36699, 2251948032, 2252013567, 'BE', 'BEL', 'بلجيكا'),
(36700, 2252013568, 2252079103, 'FR', 'FRA', 'فرنسا'),
(36701, 2252079104, 2252210175, 'DE', 'DEU', 'ألمانيا'),
(36702, 2252210176, 2253062143, 'US', 'USA', 'الولايات المتحدة'),
(36703, 2253062144, 2253127679, 'KR', 'KOR', 'جمهورية كوريا'),
(36704, 2253127680, 2253193215, 'DE', 'DEU', 'ألمانيا'),
(36705, 2253193216, 2253455359, 'US', 'USA', 'الولايات المتحدة'),
(36706, 2253455360, 2253520895, 'DE', 'DEU', 'ألمانيا'),
(36707, 2253520896, 2253586431, 'US', 'USA', 'الولايات المتحدة'),
(36708, 2253586432, 2253651967, 'GB', 'GBR', 'المملكة المتحدة'),
(36709, 2253651968, 2253848575, 'US', 'USA', 'الولايات المتحدة'),
(36710, 2253848576, 2253914111, 'CA', 'CAN', 'كندا'),
(36711, 2253914112, 2254045183, 'US', 'USA', 'الولايات المتحدة'),
(36712, 2254110720, 2255421439, 'DE', 'DEU', 'ألمانيا'),
(36713, 2255421440, 2255683583, 'US', 'USA', 'الولايات المتحدة'),
(36714, 2255683584, 2255749119, 'AU', 'AUS', 'أستراليا'),
(36715, 2255749120, 2255814655, 'US', 'USA', 'الولايات المتحدة'),
(36716, 2255814656, 2255880191, 'CA', 'CAN', 'كندا'),
(36717, 2255880192, 2255945727, 'US', 'USA', 'الولايات المتحدة'),
(36718, 2255945728, 2256011263, 'NO', 'NOR', 'النرويج'),
(36719, 2256011264, 2256666623, 'US', 'USA', 'الولايات المتحدة'),
(36720, 2256666624, 2256732159, 'DE', 'DEU', 'ألمانيا'),
(36721, 2256732160, 2257190911, 'US', 'USA', 'الولايات المتحدة'),
(36722, 2257190912, 2257256447, 'SE', 'SWE', 'السويد'),
(36723, 2257256448, 2257453055, 'US', 'USA', 'الولايات المتحدة'),
(36724, 2257453056, 2257518591, 'GB', 'GBR', 'المملكة المتحدة'),
(36725, 2257518592, 2257584127, 'NL', 'NLD', 'هولندا'),
(36726, 2257584128, 2257649663, 'AU', 'AUS', 'أستراليا'),
(36727, 2257649664, 2257780735, 'NL', 'NLD', 'هولندا'),
(36728, 2257780736, 2257846271, 'DE', 'DEU', 'ألمانيا'),
(36729, 2257846272, 2257911807, 'AU', 'AUS', 'أستراليا'),
(36730, 2257911808, 2257977343, 'US', 'USA', 'الولايات المتحدة'),
(36731, 2257977344, 2258042879, 'CA', 'CAN', 'كندا'),
(36732, 2258042880, 2258108415, 'GB', 'GBR', 'المملكة المتحدة'),
(36733, 2258108416, 2258173951, 'US', 'USA', 'الولايات المتحدة'),
(36734, 2258173952, 2258239487, 'CA', 'CAN', 'كندا'),
(36735, 2258239488, 2258305023, 'US', 'USA', 'الولايات المتحدة'),
(36736, 2258305024, 2258370559, 'DE', 'DEU', 'ألمانيا'),
(36737, 2258370560, 2258436095, 'US', 'USA', 'الولايات المتحدة'),
(36738, 2258436096, 2258567167, 'FR', 'FRA', 'فرنسا'),
(36739, 2258567168, 2258567679, 'US', 'USA', 'الولايات المتحدة'),
(36740, 2258567680, 2258567935, 'HK', 'HKG', 'هونغ كونغ'),
(36741, 2258567936, 2258568191, 'US', 'USA', 'الولايات المتحدة'),
(36742, 2258568192, 2258568447, 'HK', 'HKG', 'هونغ كونغ'),
(36743, 2258568448, 2258571647, 'US', 'USA', 'الولايات المتحدة'),
(36744, 2258571648, 2258571679, 'HK', 'HKG', 'هونغ كونغ'),
(36745, 2258571680, 2258582783, 'US', 'USA', 'الولايات المتحدة'),
(36746, 2258582784, 2258582791, 'GB', 'GBR', 'المملكة المتحدة'),
(36747, 2258582792, 2258583551, 'US', 'USA', 'الولايات المتحدة'),
(36748, 2258583552, 2258591743, 'GB', 'GBR', 'المملكة المتحدة'),
(36749, 2258591744, 2258591839, 'AU', 'AUS', 'أستراليا'),
(36750, 2258591840, 2258591847, 'TW', 'TWN', 'تايوان'),
(36751, 2258591848, 2258591855, 'JP', 'JPN', 'اليابان'),
(36752, 2258591856, 2258591935, 'TW', 'TWN', 'تايوان'),
(36753, 2258591936, 2258591967, 'HK', 'HKG', 'هونغ كونغ'),
(36754, 2258591968, 2258592255, 'AU', 'AUS', 'أستراليا'),
(36755, 2258592256, 2258592383, 'JP', 'JPN', 'اليابان'),
(36756, 2258592384, 2258592439, 'AU', 'AUS', 'أستراليا'),
(36757, 2258592440, 2258592447, 'JP', 'JPN', 'اليابان'),
(36758, 2258592448, 2258592479, 'IN', 'IND', 'الهند'),
(36759, 2258592480, 2258593023, 'AU', 'AUS', 'أستراليا'),
(36760, 2258593024, 2258593151, 'SG', 'SGP', 'سنغافورة'),
(36761, 2258593152, 2258593279, 'AU', 'AUS', 'أستراليا'),
(36762, 2258593280, 2258593535, 'HK', 'HKG', 'هونغ كونغ'),
(36763, 2258593536, 2258594047, 'AU', 'AUS', 'أستراليا'),
(36764, 2258594048, 2258594831, 'HK', 'HKG', 'هونغ كونغ'),
(36765, 2258594832, 2258594839, 'JP', 'JPN', 'اليابان'),
(36766, 2258594840, 2258594959, 'HK', 'HKG', 'هونغ كونغ'),
(36767, 2258594960, 2258594967, 'JP', 'JPN', 'اليابان'),
(36768, 2258594968, 2258594975, 'HK', 'HKG', 'هونغ كونغ'),
(36769, 2258594976, 2258594991, 'JP', 'JPN', 'اليابان'),
(36770, 2258594992, 2258595007, 'HK', 'HKG', 'هونغ كونغ'),
(36771, 2258595008, 2258595023, 'TW', 'TWN', 'تايوان'),
(36772, 2258595024, 2258595031, 'JP', 'JPN', 'اليابان'),
(36773, 2258595032, 2258595071, 'HK', 'HKG', 'هونغ كونغ'),
(36774, 2258595072, 2258595135, 'AU', 'AUS', 'أستراليا'),
(36775, 2258595136, 2258595151, 'SG', 'SGP', 'سنغافورة'),
(36776, 2258595152, 2258595167, 'JP', 'JPN', 'اليابان'),
(36777, 2258595168, 2258595199, 'AU', 'AUS', 'أستراليا'),
(36778, 2258595200, 2258595215, 'JP', 'JPN', 'اليابان'),
(36779, 2258595216, 2258595231, 'AU', 'AUS', 'أستراليا'),
(36780, 2258595232, 2258595263, 'TW', 'TWN', 'تايوان'),
(36781, 2258595264, 2258595295, 'AU', 'AUS', 'أستراليا'),
(36782, 2258595296, 2258595327, 'SG', 'SGP', 'سنغافورة'),
(36783, 2258595328, 2258595335, 'KR', 'KOR', 'جمهورية كوريا'),
(36784, 2258595336, 2258595343, 'TW', 'TWN', 'تايوان'),
(36785, 2258595344, 2258595351, 'AU', 'AUS', 'أستراليا'),
(36786, 2258595352, 2258595359, 'JP', 'JPN', 'اليابان'),
(36787, 2258595360, 2258595383, 'AU', 'AUS', 'أستراليا'),
(36788, 2258595384, 2258595391, 'KR', 'KOR', 'جمهورية كوريا'),
(36789, 2258595392, 2258595463, 'AU', 'AUS', 'أستراليا'),
(36790, 2258595464, 2258595471, 'TW', 'TWN', 'تايوان'),
(36791, 2258595472, 2258595495, 'AU', 'AUS', 'أستراليا'),
(36792, 2258595496, 2258595503, 'HK', 'HKG', 'هونغ كونغ'),
(36793, 2258595504, 2258595551, 'AU', 'AUS', 'أستراليا'),
(36794, 2258595552, 2258595567, 'JP', 'JPN', 'اليابان'),
(36795, 2258595568, 2258595583, 'AU', 'AUS', 'أستراليا'),
(36796, 2258595584, 2258595591, 'TW', 'TWN', 'تايوان'),
(36797, 2258595592, 2258595603, 'AU', 'AUS', 'أستراليا'),
(36798, 2258595604, 2258595607, 'JP', 'JPN', 'اليابان'),
(36799, 2258595608, 2258595639, 'AU', 'AUS', 'أستراليا'),
(36800, 2258595640, 2258595643, 'JP', 'JPN', 'اليابان'),
(36801, 2258595644, 2258595655, 'AU', 'AUS', 'أستراليا'),
(36802, 2258595656, 2258595663, 'IN', 'IND', 'الهند'),
(36803, 2258595664, 2258595711, 'AU', 'AUS', 'أستراليا'),
(36804, 2258595712, 2258595775, 'HK', 'HKG', 'هونغ كونغ'),
(36805, 2258595776, 2258596079, 'AU', 'AUS', 'أستراليا'),
(36806, 2258596080, 2258596087, 'JP', 'JPN', 'اليابان'),
(36807, 2258596088, 2258596095, 'AU', 'AUS', 'أستراليا'),
(36808, 2258596096, 2258597071, 'HK', 'HKG', 'هونغ كونغ'),
(36809, 2258597072, 2258597087, 'TW', 'TWN', 'تايوان'),
(36810, 2258597088, 2258597631, 'HK', 'HKG', 'هونغ كونغ'),
(36811, 2258597632, 2258597895, 'AU', 'AUS', 'أستراليا'),
(36812, 2258597896, 2258597903, 'NZ', 'NZL', 'نيوزيلاندا'),
(36813, 2258597904, 2258597927, 'AU', 'AUS', 'أستراليا'),
(36814, 2258597928, 2258597935, 'JP', 'JPN', 'اليابان'),
(36815, 2258597936, 2258597951, 'AU', 'AUS', 'أستراليا'),
(36816, 2258597952, 2258597983, 'NZ', 'NZL', 'نيوزيلاندا'),
(36817, 2258597984, 2258597999, 'JP', 'JPN', 'اليابان'),
(36818, 2258598000, 2258598079, 'AU', 'AUS', 'أستراليا'),
(36819, 2258598080, 2258598111, 'TW', 'TWN', 'تايوان'),
(36820, 2258598112, 2258598143, 'AU', 'AUS', 'أستراليا'),
(36821, 2258598144, 2258598239, 'KR', 'KOR', 'جمهورية كوريا'),
(36822, 2258598240, 2258598255, 'AU', 'AUS', 'أستراليا'),
(36823, 2258598256, 2258598287, 'KR', 'KOR', 'جمهورية كوريا'),
(36824, 2258598288, 2258598319, 'NZ', 'NZL', 'نيوزيلاندا'),
(36825, 2258598320, 2258598335, 'JP', 'JPN', 'اليابان'),
(36826, 2258598336, 2258598351, 'TW', 'TWN', 'تايوان'),
(36827, 2258598352, 2258598527, 'AU', 'AUS', 'أستراليا'),
(36828, 2258598528, 2258598535, 'JP', 'JPN', 'اليابان'),
(36829, 2258598536, 2258598551, 'AU', 'AUS', 'أستراليا'),
(36830, 2258598552, 2258598567, 'JP', 'JPN', 'اليابان'),
(36831, 2258598568, 2258598639, 'AU', 'AUS', 'أستراليا'),
(36832, 2258598640, 2258598647, 'JP', 'JPN', 'اليابان'),
(36833, 2258598648, 2258600799, 'AU', 'AUS', 'أستراليا'),
(36834, 2258600800, 2258600831, 'KR', 'KOR', 'جمهورية كوريا'),
(36835, 2258600832, 2258600959, 'AU', 'AUS', 'أستراليا'),
(36836, 2258600960, 2258601087, 'SG', 'SGP', 'سنغافورة'),
(36837, 2258601088, 2258601167, 'AU', 'AUS', 'أستراليا'),
(36838, 2258601168, 2258601175, 'NZ', 'NZL', 'نيوزيلاندا'),
(36839, 2258601176, 2258601199, 'AU', 'AUS', 'أستراليا'),
(36840, 2258601200, 2258601207, 'JP', 'JPN', 'اليابان'),
(36841, 2258601208, 2258601471, 'AU', 'AUS', 'أستراليا'),
(36842, 2258601472, 2258601983, 'JP', 'JPN', 'اليابان'),
(36843, 2258601984, 2258602239, 'AU', 'AUS', 'أستراليا'),
(36844, 2258602240, 2258602495, 'HK', 'HKG', 'هونغ كونغ'),
(36845, 2258602496, 2258602751, 'VN', 'VNM', 'فييتنام'),
(36846, 2258602752, 2258603263, 'HK', 'HKG', 'هونغ كونغ'),
(36847, 2258603264, 2258603279, 'IN', 'IND', 'الهند'),
(36848, 2258603280, 2258603679, 'AU', 'AUS', 'أستراليا'),
(36849, 2258603680, 2258603711, 'IN', 'IND', 'الهند'),
(36850, 2258603712, 2258603743, 'AU', 'AUS', 'أستراليا'),
(36851, 2258603744, 2258603751, 'TW', 'TWN', 'تايوان'),
(36852, 2258603752, 2258603775, 'AU', 'AUS', 'أستراليا'),
(36853, 2258603776, 2258604031, 'HK', 'HKG', 'هونغ كونغ'),
(36854, 2258604032, 2258604543, 'AU', 'AUS', 'أستراليا'),
(36855, 2258604544, 2258604575, 'IN', 'IND', 'الهند'),
(36856, 2258604576, 2258604591, 'SG', 'SGP', 'سنغافورة'),
(36857, 2258604592, 2258604607, 'IN', 'IND', 'الهند'),
(36858, 2258604608, 2258604671, 'AU', 'AUS', 'أستراليا'),
(36859, 2258604672, 2258604735, 'SG', 'SGP', 'سنغافورة'),
(36860, 2258604736, 2258604799, 'AU', 'AUS', 'أستراليا'),
(36861, 2258604800, 2258605055, 'HK', 'HKG', 'هونغ كونغ'),
(36862, 2258605056, 2258605567, 'AU', 'AUS', 'أستراليا'),
(36863, 2258605568, 2258605631, 'SG', 'SGP', 'سنغافورة'),
(36864, 2258605632, 2258605967, 'AU', 'AUS', 'أستراليا'),
(36865, 2258605968, 2258605983, 'NZ', 'NZL', 'نيوزيلاندا'),
(36866, 2258605984, 2258606079, 'AU', 'AUS', 'أستراليا'),
(36867, 2258606080, 2258606367, 'HK', 'HKG', 'هونغ كونغ'),
(36868, 2258606368, 2258606463, 'AU', 'AUS', 'أستراليا'),
(36869, 2258606464, 2258606471, 'JP', 'JPN', 'اليابان'),
(36870, 2258606472, 2258606687, 'AU', 'AUS', 'أستراليا'),
(36871, 2258606688, 2258606703, 'JP', 'JPN', 'اليابان'),
(36872, 2258606704, 2258607343, 'AU', 'AUS', 'أستراليا'),
(36873, 2258607344, 2258607351, 'SG', 'SGP', 'سنغافورة'),
(36874, 2258607352, 2258607871, 'AU', 'AUS', 'أستراليا'),
(36875, 2258607872, 2258608127, 'HK', 'HKG', 'هونغ كونغ'),
(36876, 2258608128, 2258608895, 'AU', 'AUS', 'أستراليا'),
(36877, 2258608896, 2258608959, 'IN', 'IND', 'الهند'),
(36878, 2258608960, 2258609487, 'AU', 'AUS', 'أستراليا'),
(36879, 2258609488, 2258609503, 'IN', 'IND', 'الهند'),
(36880, 2258609504, 2258609511, 'AU', 'AUS', 'أستراليا'),
(36881, 2258609512, 2258609527, 'IN', 'IND', 'الهند'),
(36882, 2258609528, 2258610303, 'AU', 'AUS', 'أستراليا'),
(36883, 2258610304, 2258610431, 'IN', 'IND', 'الهند'),
(36884, 2258610432, 2258611071, 'AU', 'AUS', 'أستراليا'),
(36885, 2258611072, 2258611075, 'JP', 'JPN', 'اليابان'),
(36886, 2258611076, 2258611967, 'AU', 'AUS', 'أستراليا'),
(36887, 2258611968, 2258612223, 'HK', 'HKG', 'هونغ كونغ'),
(36888, 2258612224, 2258614783, 'AU', 'AUS', 'أستراليا'),
(36889, 2258614784, 2258614799, 'TW', 'TWN', 'تايوان'),
(36890, 2258614800, 2258616319, 'AU', 'AUS', 'أستراليا'),
(36891, 2258616320, 2258632703, 'HK', 'HKG', 'هونغ كونغ'),
(36892, 2258632704, 2258698239, 'JP', 'JPN', 'اليابان'),
(36893, 2258698240, 2259222527, 'US', 'USA', 'الولايات المتحدة'),
(36894, 2259222528, 2259288063, 'DE', 'DEU', 'ألمانيا'),
(36895, 2259288064, 2259353599, 'US', 'USA', 'الولايات المتحدة'),
(36896, 2259353600, 2259419135, 'DE', 'DEU', 'ألمانيا'),
(36897, 2259419136, 2259681279, 'US', 'USA', 'الولايات المتحدة'),
(36898, 2259681280, 2259746815, 'DE', 'DEU', 'ألمانيا'),
(36899, 2259746816, 2259812351, 'US', 'USA', 'الولايات المتحدة'),
(36900, 2259812352, 2259877887, 'AU', 'AUS', 'أستراليا'),
(36901, 2259877888, 2259943423, 'US', 'USA', 'الولايات المتحدة'),
(36902, 2259943424, 2260008959, 'JP', 'JPN', 'اليابان'),
(36903, 2260008960, 2260140031, 'US', 'USA', 'الولايات المتحدة'),
(36904, 2260140032, 2260205567, 'GB', 'GBR', 'المملكة المتحدة'),
(36905, 2260205568, 2260271103, 'BE', 'BEL', 'بلجيكا'),
(36906, 2260271104, 2260467711, 'US', 'USA', 'الولايات المتحدة'),
(36907, 2260467712, 2260533247, 'NL', 'NLD', 'هولندا'),
(36908, 2260533248, 2260598783, 'US', 'USA', 'الولايات المتحدة'),
(36909, 2260598784, 2260664319, 'CA', 'CAN', 'كندا'),
(36910, 2260664320, 2260729855, 'GB', 'GBR', 'المملكة المتحدة'),
(36911, 2260729856, 2260991999, 'US', 'USA', 'الولايات المتحدة'),
(36912, 2260992000, 2261057535, 'CN', 'CHN', 'الصين'),
(36913, 2261057536, 2261188607, 'US', 'USA', 'الولايات المتحدة'),
(36914, 2261188608, 2261254143, 'CA', 'CAN', 'كندا'),
(36915, 2261254144, 2261385215, 'US', 'USA', 'الولايات المتحدة'),
(36916, 2261385216, 2261450751, 'PR', 'PRI', 'بورتو ريكو'),
(36917, 2261450752, 2261516287, 'NL', 'NLD', 'هولندا'),
(36918, 2261516288, 2261647359, 'US', 'USA', 'الولايات المتحدة'),
(36919, 2261647360, 2261712895, 'FR', 'FRA', 'فرنسا'),
(36920, 2261712896, 2261778431, 'US', 'USA', 'الولايات المتحدة'),
(36921, 2261778432, 2261843967, 'TW', 'TWN', 'تايوان'),
(36922, 2261843968, 2261975039, 'US', 'USA', 'الولايات المتحدة'),
(36923, 2261975040, 2262040575, 'AU', 'AUS', 'أستراليا'),
(36924, 2262040576, 2262106111, 'FR', 'FRA', 'فرنسا'),
(36925, 2262106112, 2262171647, 'IE', 'IRL', 'إيرلندا'),
(36926, 2262171648, 2262237183, 'FR', 'FRA', 'فرنسا'),
(36927, 2262237184, 2262499327, 'US', 'USA', 'الولايات المتحدة'),
(36928, 2262499328, 2262630399, 'GB', 'GBR', 'المملكة المتحدة'),
(36929, 2262630400, 2262761471, 'NL', 'NLD', 'هولندا'),
(36930, 2262761472, 2262892543, 'US', 'USA', 'الولايات المتحدة'),
(36931, 2262892544, 2262958079, 'GB', 'GBR', 'المملكة المتحدة'),
(36932, 2262958080, 2263023615, 'IE', 'IRL', 'إيرلندا'),
(36933, 2263023616, 2263089151, 'FR', 'FRA', 'فرنسا'),
(36934, 2263089152, 2263678975, 'US', 'USA', 'الولايات المتحدة'),
(36935, 2263678976, 2263744511, 'JP', 'JPN', 'اليابان'),
(36936, 2263744512, 2263810047, 'US', 'USA', 'الولايات المتحدة'),
(36937, 2263810048, 2263875583, 'GB', 'GBR', 'المملكة المتحدة'),
(36938, 2263875584, 2264203263, 'US', 'USA', 'الولايات المتحدة'),
(36939, 2264203264, 2264268799, 'DE', 'DEU', 'ألمانيا'),
(36940, 2264268800, 2264334335, 'FR', 'FRA', 'فرنسا'),
(36941, 2264334336, 2264399871, 'DE', 'DEU', 'ألمانيا'),
(36942, 2264399872, 2264465407, 'US', 'USA', 'الولايات المتحدة'),
(36943, 2264530944, 2264858623, 'US', 'USA', 'الولايات المتحدة'),
(36944, 2264989696, 2265710591, 'US', 'USA', 'الولايات المتحدة'),
(36945, 2265710592, 2265776127, 'CA', 'CAN', 'كندا'),
(36946, 2265776128, 2266169343, 'US', 'USA', 'الولايات المتحدة'),
(36947, 2266234880, 2276786175, 'US', 'USA', 'الولايات المتحدة'),
(36948, 2276786176, 2276851711, 'CA', 'CAN', 'كندا'),
(36949, 2276851712, 2277769215, 'US', 'USA', 'الولايات المتحدة'),
(36950, 2277769216, 2277772543, 'GB', 'GBR', 'المملكة المتحدة'),
(36951, 2277772544, 2277772799, 'DE', 'DEU', 'ألمانيا'),
(36952, 2277772800, 2277834751, 'GB', 'GBR', 'المملكة المتحدة'),
(36953, 2277834752, 2281701375, 'US', 'USA', 'الولايات المتحدة'),
(36954, 2281766912, 2291204095, 'US', 'USA', 'الولايات المتحدة'),
(36955, 2291204096, 2291269631, 'PR', 'PRI', 'بورتو ريكو'),
(36956, 2291269632, 2291400703, 'CA', 'CAN', 'كندا'),
(36957, 2291400704, 2291466239, 'GB', 'GBR', 'المملكة المتحدة'),
(36958, 2291466240, 2291728383, 'US', 'USA', 'الولايات المتحدة'),
(36959, 2291728384, 2291859455, 'AU', 'AUS', 'أستراليا'),
(36960, 2291859456, 2291924991, 'SE', 'SWE', 'السويد'),
(36961, 2291924992, 2291990527, 'GB', 'GBR', 'المملكة المتحدة'),
(36962, 2291990528, 2292056063, 'US', 'USA', 'الولايات المتحدة'),
(36963, 2292056064, 2292121599, 'NO', 'NOR', 'النرويج'),
(36964, 2292121600, 2292187135, 'CA', 'CAN', 'كندا'),
(36965, 2292187136, 2292383743, 'US', 'USA', 'الولايات المتحدة'),
(36966, 2292383744, 2292449279, 'SE', 'SWE', 'السويد'),
(36967, 2292449280, 2292514815, 'NO', 'NOR', 'النرويج'),
(36968, 2292514816, 2292776959, 'US', 'USA', 'الولايات المتحدة'),
(36969, 2292842496, 2292908031, 'GB', 'GBR', 'المملكة المتحدة'),
(36970, 2292908032, 2292973567, 'US', 'USA', 'الولايات المتحدة'),
(36971, 2292973568, 2293039103, 'DE', 'DEU', 'ألمانيا'),
(36972, 2293039104, 2293104639, 'LU', 'LUX', 'لوكسيمبورغ'),
(36973, 2293104640, 2293891071, 'US', 'USA', 'الولايات المتحدة'),
(36974, 2293891072, 2293956607, 'AU', 'AUS', 'أستراليا'),
(36975, 2293956608, 2294022143, 'JP', 'JPN', 'اليابان'),
(36976, 2294022144, 2294677503, 'US', 'USA', 'الولايات المتحدة'),
(36977, 2294677504, 2294743039, 'JP', 'JPN', 'اليابان'),
(36978, 2294743040, 2294808575, 'DE', 'DEU', 'ألمانيا'),
(36979, 2294808576, 2294874111, 'US', 'USA', 'الولايات المتحدة'),
(36980, 2294874112, 2294939647, 'IE', 'IRL', 'إيرلندا'),
(36981, 2294939648, 2295201791, 'US', 'USA', 'الولايات المتحدة'),
(36982, 2295201792, 2295267327, 'IE', 'IRL', 'إيرلندا'),
(36983, 2295267328, 2296446975, 'US', 'USA', 'الولايات المتحدة'),
(36984, 2296446976, 2296512511, 'SE', 'SWE', 'السويد'),
(36985, 2296512512, 2296774655, 'US', 'USA', 'الولايات المتحدة'),
(36986, 2296774656, 2296840191, 'DE', 'DEU', 'ألمانيا'),
(36987, 2296840192, 2296905727, 'NL', 'NLD', 'هولندا'),
(36988, 2296905728, 2297626623, 'US', 'USA', 'الولايات المتحدة'),
(36989, 2297626624, 2297692159, 'DE', 'DEU', 'ألمانيا'),
(36990, 2297692160, 2298413055, 'US', 'USA', 'الولايات المتحدة'),
(36991, 2298478592, 2299461631, 'US', 'USA', 'الولايات المتحدة'),
(36992, 2299461632, 2299527167, 'CA', 'CAN', 'كندا'),
(36993, 2299527168, 2299592703, 'US', 'USA', 'الولايات المتحدة'),
(36994, 2299592704, 2299658239, 'NL', 'NLD', 'هولندا'),
(36995, 2299658240, 2300641279, 'US', 'USA', 'الولايات المتحدة'),
(36996, 2300641280, 2300706815, 'FI', 'FIN', 'فنلندا'),
(36997, 2300706816, 2300772351, 'CH', 'CHE', 'سويسرا'),
(36998, 2300772352, 2301296639, 'US', 'USA', 'الولايات المتحدة'),
(36999, 2301296640, 2301362175, 'IE', 'IRL', 'إيرلندا'),
(37000, 2301362176, 2301427711, 'GB', 'GBR', 'المملكة المتحدة'),
(37001, 2301427712, 2301558783, 'US', 'USA', 'الولايات المتحدة'),
(37002, 2301558784, 2301624319, 'NO', 'NOR', 'النرويج'),
(37003, 2301624320, 2301755391, 'US', 'USA', 'الولايات المتحدة'),
(37004, 2301755392, 2301820927, 'GB', 'GBR', 'المملكة المتحدة'),
(37005, 2301820928, 2302083071, 'US', 'USA', 'الولايات المتحدة'),
(37006, 2302083072, 2302214143, 'NL', 'NLD', 'هولندا'),
(37007, 2302214144, 2302279679, 'US', 'USA', 'الولايات المتحدة'),
(37008, 2302279680, 2302541823, 'SE', 'SWE', 'السويد'),
(37009, 2302541824, 2302607359, 'CH', 'CHE', 'سويسرا'),
(37010, 2302738432, 2302935039, 'US', 'USA', 'الولايات المتحدة'),
(37011, 2302935040, 2303000575, 'KR', 'KOR', 'جمهورية كوريا'),
(37012, 2303000576, 2303262719, 'US', 'USA', 'الولايات المتحدة'),
(37013, 2303262720, 2303328255, 'GB', 'GBR', 'المملكة المتحدة'),
(37014, 2303328256, 2303393791, 'CA', 'CAN', 'كندا'),
(37015, 2303393792, 2303459327, 'US', 'USA', 'الولايات المتحدة'),
(37016, 2303459328, 2303524863, 'AU', 'AUS', 'أستراليا'),
(37017, 2303524864, 2303852543, 'US', 'USA', 'الولايات المتحدة'),
(37018, 2303852544, 2303918079, 'CA', 'CAN', 'كندا'),
(37019, 2303918080, 2304507903, 'US', 'USA', 'الولايات المتحدة'),
(37020, 2304507904, 2304573439, 'AU', 'AUS', 'أستراليا'),
(37021, 2304573440, 2304638975, 'NO', 'NOR', 'النرويج'),
(37022, 2304638976, 2304704511, 'CA', 'CAN', 'كندا'),
(37023, 2304704512, 2304770047, 'US', 'USA', 'الولايات المتحدة'),
(37024, 2304770048, 2304835583, 'SE', 'SWE', 'السويد'),
(37025, 2304835584, 2305097727, 'US', 'USA', 'الولايات المتحدة'),
(37026, 2305097728, 2305163263, 'GB', 'GBR', 'المملكة المتحدة'),
(37027, 2305163264, 2305359871, 'US', 'USA', 'الولايات المتحدة'),
(37028, 2305359872, 2305425407, 'GB', 'GBR', 'المملكة المتحدة'),
(37029, 2305425408, 2305556479, 'US', 'USA', 'الولايات المتحدة'),
(37030, 2305556480, 2305622015, 'GB', 'GBR', 'المملكة المتحدة'),
(37031, 2305622016, 2305687551, 'AU', 'AUS', 'أستراليا'),
(37032, 2305687552, 2305753087, 'US', 'USA', 'الولايات المتحدة'),
(37033, 2305753088, 2305818623, 'AU', 'AUS', 'أستراليا'),
(37034, 2305818624, 2306015231, 'US', 'USA', 'الولايات المتحدة'),
(37035, 2306080768, 2306146303, 'US', 'USA', 'الولايات المتحدة'),
(37036, 2306146304, 2306211839, 'CA', 'CAN', 'كندا'),
(37037, 2306211840, 2306342911, 'US', 'USA', 'الولايات المتحدة'),
(37038, 2306342912, 2306408447, 'NL', 'NLD', 'هولندا'),
(37039, 2306408448, 2306473983, 'FR', 'FRA', 'فرنسا'),
(37040, 2306473984, 2306539519, 'CA', 'CAN', 'كندا'),
(37041, 2306539520, 2306932735, 'US', 'USA', 'الولايات المتحدة'),
(37042, 2306932736, 2306998271, 'FR', 'FRA', 'فرنسا'),
(37043, 2306998272, 2307129343, 'US', 'USA', 'الولايات المتحدة'),
(37044, 2307129344, 2307194879, 'SG', 'SGP', 'سنغافورة'),
(37045, 2307194880, 2307260415, 'NO', 'NOR', 'النرويج'),
(37046, 2307260416, 2307522559, 'US', 'USA', 'الولايات المتحدة'),
(37047, 2307522560, 2307588095, 'CH', 'CHE', 'سويسرا'),
(37048, 2307588096, 2308112383, 'US', 'USA', 'الولايات المتحدة'),
(37049, 2308112384, 2308177919, 'AU', 'AUS', 'أستراليا'),
(37050, 2308177920, 2308243455, 'US', 'USA', 'الولايات المتحدة'),
(37051, 2308243456, 2308308991, 'CA', 'CAN', 'كندا'),
(37052, 2308308992, 2308505599, 'US', 'USA', 'الولايات المتحدة'),
(37053, 2308505600, 2308571135, 'JP', 'JPN', 'اليابان'),
(37054, 2308571136, 2308636671, 'AU', 'AUS', 'أستراليا'),
(37055, 2308636672, 2308702207, 'US', 'USA', 'الولايات المتحدة'),
(37056, 2308702208, 2308767743, 'CH', 'CHE', 'سويسرا'),
(37057, 2308767744, 2308833279, 'AU', 'AUS', 'أستراليا'),
(37058, 2308898816, 2309160959, 'US', 'USA', 'الولايات المتحدة'),
(37059, 2309160960, 2309226495, 'FI', 'FIN', 'فنلندا'),
(37060, 2309226496, 2309357567, 'US', 'USA', 'الولايات المتحدة'),
(37061, 2309357568, 2309423103, 'AU', 'AUS', 'أستراليا'),
(37062, 2309423104, 2309685247, 'US', 'USA', 'الولايات المتحدة'),
(37063, 2309750784, 2309816319, 'AU', 'AUS', 'أستراليا'),
(37064, 2309816320, 2309881855, 'US', 'USA', 'الولايات المتحدة'),
(37065, 2309881856, 2309947391, 'NL', 'NLD', 'هولندا'),
(37066, 2309947392, 2310668287, 'US', 'USA', 'الولايات المتحدة'),
(37067, 2310668288, 2310733823, 'CA', 'CAN', 'كندا'),
(37068, 2310733824, 2310864895, 'US', 'USA', 'الولايات المتحدة'),
(37069, 2310864896, 2310930431, 'HK', 'HKG', 'هونغ كونغ'),
(37070, 2310930432, 2310995967, 'US', 'USA', 'الولايات المتحدة'),
(37071, 2310995968, 2311061503, 'IE', 'IRL', 'إيرلندا'),
(37072, 2311061504, 2311127039, 'US', 'USA', 'الولايات المتحدة'),
(37073, 2311127040, 2311192575, 'DE', 'DEU', 'ألمانيا'),
(37074, 2311192576, 2311258111, 'FR', 'FRA', 'فرنسا'),
(37075, 2311258112, 2311323647, 'GB', 'GBR', 'المملكة المتحدة'),
(37076, 2311389184, 2311847935, 'US', 'USA', 'الولايات المتحدة'),
(37077, 2311847936, 2311913471, 'IT', 'ITA', 'إيطاليا'),
(37078, 2311913472, 2311979007, 'GB', 'GBR', 'المملكة المتحدة'),
(37079, 2311979008, 2312044543, 'US', 'USA', 'الولايات المتحدة'),
(37080, 2312044544, 2312110079, 'CA', 'CAN', 'كندا'),
(37081, 2312110080, 2312175615, 'AT', 'AUT', 'النمسا'),
(37082, 2312175616, 2312437759, 'US', 'USA', 'الولايات المتحدة'),
(37083, 2312437760, 2312503295, 'GB', 'GBR', 'المملكة المتحدة'),
(37084, 2312634368, 2312699903, 'US', 'USA', 'الولايات المتحدة'),
(37085, 2312699904, 2312765439, 'NO', 'NOR', 'النرويج'),
(37086, 2312765440, 2312830975, 'GB', 'GBR', 'المملكة المتحدة'),
(37087, 2312830976, 2312896511, 'AU', 'AUS', 'أستراليا'),
(37088, 2312896512, 2312962047, 'US', 'USA', 'الولايات المتحدة'),
(37089, 2312962048, 2313158655, 'GB', 'GBR', 'المملكة المتحدة'),
(37090, 2313158656, 2313224191, 'NL', 'NLD', 'هولندا'),
(37091, 2313224192, 2313289727, 'US', 'USA', 'الولايات المتحدة'),
(37092, 2313289728, 2313355263, 'DE', 'DEU', 'ألمانيا'),
(37093, 2313355264, 2314731519, 'US', 'USA', 'الولايات المتحدة'),
(37094, 2314731520, 2314797055, 'DE', 'DEU', 'ألمانيا'),
(37095, 2314797056, 2314862591, 'US', 'USA', 'الولايات المتحدة'),
(37096, 2314862592, 2314993663, 'DE', 'DEU', 'ألمانيا'),
(37097, 2314993664, 2315059199, 'US', 'USA', 'الولايات المتحدة'),
(37098, 2315059200, 2315124735, 'GB', 'GBR', 'المملكة المتحدة'),
(37099, 2315124736, 2315190271, 'US', 'USA', 'الولايات المتحدة'),
(37100, 2315321344, 2315452415, 'US', 'USA', 'الولايات المتحدة'),
(37101, 2315452416, 2315517951, 'GB', 'GBR', 'المملكة المتحدة'),
(37102, 2315517952, 2315583487, 'ES', 'ESP', 'إسبانيا'),
(37103, 2315583488, 2315649023, 'US', 'USA', 'الولايات المتحدة'),
(37104, 2315649024, 2315714559, 'SE', 'SWE', 'السويد'),
(37105, 2315714560, 2315780095, 'AU', 'AUS', 'أستراليا'),
(37106, 2315780096, 2315911167, 'US', 'USA', 'الولايات المتحدة'),
(37107, 2315911168, 2316042239, 'CA', 'CAN', 'كندا'),
(37108, 2316042240, 2316173311, 'US', 'USA', 'الولايات المتحدة'),
(37109, 2316173312, 2316238847, 'SE', 'SWE', 'السويد'),
(37110, 2316238848, 2316500991, 'US', 'USA', 'الولايات المتحدة'),
(37111, 2316500992, 2316566527, 'AU', 'AUS', 'أستراليا'),
(37112, 2316566528, 2316632063, 'US', 'USA', 'الولايات المتحدة'),
(37113, 2316632064, 2316697599, 'FR', 'FRA', 'فرنسا'),
(37114, 2316697600, 2316763135, 'AT', 'AUT', 'النمسا'),
(37115, 2316763136, 2316828671, 'US', 'USA', 'الولايات المتحدة'),
(37116, 2316828672, 2316959743, 'AU', 'AUS', 'أستراليا'),
(37117, 2316959744, 2317221887, 'US', 'USA', 'الولايات المتحدة'),
(37118, 2317221888, 2317287423, 'JP', 'JPN', 'اليابان'),
(37119, 2317287424, 2317484031, 'US', 'USA', 'الولايات المتحدة'),
(37120, 2317484032, 2317549567, 'CA', 'CAN', 'كندا'),
(37121, 2317549568, 2317615103, 'US', 'USA', 'الولايات المتحدة'),
(37122, 2317680640, 2317811711, 'GB', 'GBR', 'المملكة المتحدة'),
(37123, 2317811712, 2317877247, 'US', 'USA', 'الولايات المتحدة'),
(37124, 2317877248, 2317942783, 'GB', 'GBR', 'المملكة المتحدة'),
(37125, 2317942784, 2318008319, 'IT', 'ITA', 'إيطاليا'),
(37126, 2318008320, 2318139391, 'US', 'USA', 'الولايات المتحدة'),
(37127, 2318139392, 2318204927, 'AU', 'AUS', 'أستراليا'),
(37128, 2318204928, 2318401535, 'US', 'USA', 'الولايات المتحدة'),
(37129, 2318401536, 2318467071, 'BE', 'BEL', 'بلجيكا'),
(37130, 2318467072, 2318598143, 'US', 'USA', 'الولايات المتحدة'),
(37131, 2318598144, 2318663679, 'CA', 'CAN', 'كندا'),
(37132, 2318663680, 2319122431, 'US', 'USA', 'الولايات المتحدة'),
(37133, 2319187968, 2319319039, 'US', 'USA', 'الولايات المتحدة'),
(37134, 2319319040, 2319384575, 'NO', 'NOR', 'النرويج'),
(37135, 2319384576, 2319450111, 'FR', 'FRA', 'فرنسا'),
(37136, 2319450112, 2319581183, 'US', 'USA', 'الولايات المتحدة'),
(37137, 2319581184, 2319646719, 'IT', 'ITA', 'إيطاليا'),
(37138, 2319646720, 2319843327, 'US', 'USA', 'الولايات المتحدة'),
(37139, 2319843328, 2319908863, 'IT', 'ITA', 'إيطاليا'),
(37140, 2319908864, 2319974399, 'AU', 'AUS', 'أستراليا'),
(37141, 2319974400, 2320039935, 'US', 'USA', 'الولايات المتحدة'),
(37142, 2320039936, 2320105471, 'CA', 'CAN', 'كندا'),
(37143, 2320105472, 2320171007, 'US', 'USA', 'الولايات المتحدة'),
(37144, 2320171008, 2320236543, 'NZ', 'NZL', 'نيوزيلاندا'),
(37145, 2320236544, 2320302079, 'US', 'USA', 'الولايات المتحدة'),
(37146, 2320302080, 2320367615, 'AU', 'AUS', 'أستراليا'),
(37147, 2320367616, 2320433151, 'US', 'USA', 'الولايات المتحدة'),
(37148, 2320433152, 2320564223, 'AU', 'AUS', 'أستراليا'),
(37149, 2320564224, 2320629759, 'CH', 'CHE', 'سويسرا'),
(37150, 2320629760, 2320695295, 'CA', 'CAN', 'كندا'),
(37151, 2320695296, 2321416191, 'US', 'USA', 'الولايات المتحدة'),
(37152, 2321481728, 2321547263, 'US', 'USA', 'الولايات المتحدة'),
(37153, 2321547264, 2321612799, 'FR', 'FRA', 'فرنسا'),
(37154, 2321678336, 2321743871, 'US', 'USA', 'الولايات المتحدة'),
(37155, 2321809408, 2321874943, 'ES', 'ESP', 'إسبانيا'),
(37156, 2321874944, 2321940479, 'JP', 'JPN', 'اليابان'),
(37157, 2321940480, 2322006015, 'FR', 'FRA', 'فرنسا'),
(37158, 2322006016, 2322071551, 'SE', 'SWE', 'السويد'),
(37159, 2322071552, 2322137087, 'GB', 'GBR', 'المملكة المتحدة'),
(37160, 2322137088, 2322202623, 'US', 'USA', 'الولايات المتحدة'),
(37161, 2322202624, 2322268159, 'SE', 'SWE', 'السويد'),
(37162, 2322268160, 2322333695, 'JP', 'JPN', 'اليابان'),
(37163, 2322333696, 2322923519, 'US', 'USA', 'الولايات المتحدة'),
(37164, 2323054592, 2323185663, 'CA', 'CAN', 'كندا'),
(37165, 2323316736, 2323382271, 'US', 'USA', 'الولايات المتحدة'),
(37166, 2323382272, 2323447807, 'NO', 'NOR', 'النرويج'),
(37167, 2323447808, 2323644415, 'US', 'USA', 'الولايات المتحدة'),
(37168, 2323677184, 2323677695, 'US', 'USA', 'الولايات المتحدة'),
(37169, 2323709952, 2323775487, 'US', 'USA', 'الولايات المتحدة'),
(37170, 2323775488, 2323841023, 'AU', 'AUS', 'أستراليا'),
(37171, 2323841024, 2323906559, 'CH', 'CHE', 'سويسرا'),
(37172, 2323906560, 2323972095, 'IT', 'ITA', 'إيطاليا'),
(37173, 2323972096, 2324037631, 'US', 'USA', 'الولايات المتحدة'),
(37174, 2324037632, 2324103167, 'IL', 'ISR', 'إسرائيل'),
(37175, 2324103168, 2327379967, 'US', 'USA', 'الولايات المتحدة'),
(37176, 2327511040, 2327838719, 'CH', 'CHE', 'سويسرا'),
(37177, 2327838720, 2327969791, 'US', 'USA', 'الولايات المتحدة'),
(37178, 2327969792, 2328035327, 'AU', 'AUS', 'أستراليا'),
(37179, 2328035328, 2328100863, 'FR', 'FRA', 'فرنسا'),
(37180, 2328100864, 2328231935, 'US', 'USA', 'الولايات المتحدة'),
(37181, 2328231936, 2328297471, 'GB', 'GBR', 'المملكة المتحدة'),
(37182, 2328313856, 2328317951, 'NL', 'NLD', 'هولندا'),
(37183, 2328342528, 2328342783, 'DE', 'DEU', 'ألمانيا'),
(37184, 2328362752, 2328494079, 'DE', 'DEU', 'ألمانيا'),
(37185, 2328494080, 2328559615, 'US', 'USA', 'الولايات المتحدة'),
(37186, 2328559616, 2328625151, 'BE', 'BEL', 'بلجيكا'),
(37187, 2328690688, 2328756223, 'BE', 'BEL', 'بلجيكا'),
(37188, 2328756224, 2328821759, 'CH', 'CHE', 'سويسرا'),
(37189, 2328821760, 2329083903, 'US', 'USA', 'الولايات المتحدة'),
(37190, 2329083904, 2329149439, 'NZ', 'NZL', 'نيوزيلاندا'),
(37191, 2329149440, 2329280511, 'JP', 'JPN', 'اليابان'),
(37192, 2329280512, 2329346047, 'CA', 'CAN', 'كندا'),
(37193, 2329346048, 2329411583, 'SE', 'SWE', 'السويد'),
(37194, 2329411584, 2329477119, 'FI', 'FIN', 'فنلندا'),
(37195, 2329477120, 2329542655, 'AU', 'AUS', 'أستراليا'),
(37196, 2329542656, 2329608191, 'CA', 'CAN', 'كندا'),
(37197, 2329673728, 2329739263, 'US', 'USA', 'الولايات المتحدة'),
(37198, 2329739264, 2329804799, 'SE', 'SWE', 'السويد'),
(37199, 2329804800, 2329870335, 'DE', 'DEU', 'ألمانيا'),
(37200, 2329870336, 2330132479, 'CH', 'CHE', 'سويسرا'),
(37201, 2330132480, 2330198015, 'SE', 'SWE', 'السويد'),
(37202, 2330198016, 2330263551, 'CH', 'CHE', 'سويسرا'),
(37203, 2330263552, 2330394623, 'US', 'USA', 'الولايات المتحدة'),
(37204, 2330394624, 2330460159, 'FR', 'FRA', 'فرنسا'),
(37205, 2330460160, 2330525695, 'AT', 'AUT', 'النمسا'),
(37206, 2330525696, 2330591231, 'SE', 'SWE', 'السويد'),
(37207, 2330591232, 2330656767, 'US', 'USA', 'الولايات المتحدة'),
(37208, 2330656768, 2330722303, 'NZ', 'NZL', 'نيوزيلاندا'),
(37209, 2330722304, 2331181055, 'US', 'USA', 'الولايات المتحدة'),
(37210, 2331181056, 2331246591, 'JP', 'JPN', 'اليابان'),
(37211, 2331246592, 2331443199, 'DE', 'DEU', 'ألمانيا'),
(37212, 2331443200, 2331508735, 'US', 'USA', 'الولايات المتحدة'),
(37213, 2331508736, 2331574271, 'GB', 'GBR', 'المملكة المتحدة'),
(37214, 2331574272, 2331639807, 'FI', 'FIN', 'فنلندا'),
(37215, 2331639808, 2331770879, 'GB', 'GBR', 'المملكة المتحدة'),
(37216, 2331770880, 2331836415, 'AU', 'AUS', 'أستراليا'),
(37217, 2331836416, 2331901951, 'GB', 'GBR', 'المملكة المتحدة'),
(37218, 2331901952, 2331967487, 'US', 'USA', 'الولايات المتحدة'),
(37219, 2332098560, 2332622847, 'DE', 'DEU', 'ألمانيا'),
(37220, 2332688384, 2332753919, 'BE', 'BEL', 'بلجيكا'),
(37221, 2332753920, 2334064639, 'DE', 'DEU', 'ألمانيا'),
(37222, 2334064640, 2334916607, 'US', 'USA', 'الولايات المتحدة'),
(37223, 2334916608, 2334982143, 'AU', 'AUS', 'أستراليا'),
(37224, 2334982144, 2335178751, 'US', 'USA', 'الولايات المتحدة'),
(37225, 2335178752, 2335244287, 'CA', 'CAN', 'كندا'),
(37226, 2335244288, 2335309823, 'US', 'USA', 'الولايات المتحدة'),
(37227, 2335309824, 2335375359, 'DE', 'DEU', 'ألمانيا'),
(37228, 2335375360, 2335506431, 'US', 'USA', 'الولايات المتحدة'),
(37229, 2335571968, 2335637503, 'FR', 'FRA', 'فرنسا'),
(37230, 2335637504, 2335768575, 'US', 'USA', 'الولايات المتحدة'),
(37231, 2335768576, 2335834111, 'CA', 'CAN', 'كندا'),
(37232, 2335834112, 2335899647, 'SE', 'SWE', 'السويد'),
(37233, 2335899648, 2335965183, 'AU', 'AUS', 'أستراليا'),
(37234, 2335965184, 2336161791, 'US', 'USA', 'الولايات المتحدة'),
(37235, 2336161792, 2336227327, 'NL', 'NLD', 'هولندا'),
(37236, 2336227328, 2336358399, 'US', 'USA', 'الولايات المتحدة'),
(37237, 2336358400, 2336423935, 'FI', 'FIN', 'فنلندا'),
(37238, 2336423936, 2336882687, 'US', 'USA', 'الولايات المتحدة'),
(37239, 2336882688, 2336948223, 'FI', 'FIN', 'فنلندا'),
(37240, 2336948224, 2337013759, 'DE', 'DEU', 'ألمانيا'),
(37241, 2337013760, 2337210367, 'US', 'USA', 'الولايات المتحدة'),
(37242, 2337210368, 2337275903, 'CH', 'CHE', 'سويسرا'),
(37243, 2337275904, 2337341439, 'NZ', 'NZL', 'نيوزيلاندا'),
(37244, 2337341440, 2337406975, 'US', 'USA', 'الولايات المتحدة'),
(37245, 2337406976, 2337472511, 'BR', 'BRA', 'البرازيل'),
(37246, 2337472512, 2337538047, 'PT', 'PRT', 'البورتوغال'),
(37247, 2337538048, 2337669119, 'US', 'USA', 'الولايات المتحدة'),
(37248, 2337669120, 2337734655, 'AU', 'AUS', 'أستراليا'),
(37249, 2337734656, 2337865727, 'US', 'USA', 'الولايات المتحدة'),
(37250, 2337865728, 2337931263, 'DE', 'DEU', 'ألمانيا'),
(37251, 2337931264, 2337996799, 'BE', 'BEL', 'بلجيكا'),
(37252, 2337996800, 2338062335, 'GR', 'GRC', 'اليونان'),
(37253, 2338075392, 2338075647, 'IL', 'ISR', 'إسرائيل'),
(37254, 2338084864, 2338085375, 'IL', 'ISR', 'إسرائيل'),
(37255, 2338085632, 2338086143, 'IL', 'ISR', 'إسرائيل'),
(37256, 2338087424, 2338087679, 'IL', 'ISR', 'إسرائيل'),
(37257, 2338108928, 2338109951, 'IL', 'ISR', 'إسرائيل'),
(37258, 2338115072, 2338115839, 'IL', 'ISR', 'إسرائيل'),
(37259, 2338126592, 2338127615, 'IL', 'ISR', 'إسرائيل'),
(37260, 2338127872, 2338324479, 'US', 'USA', 'الولايات المتحدة'),
(37261, 2338324480, 2338390015, 'SE', 'SWE', 'السويد'),
(37262, 2338390016, 2338455551, 'FI', 'FIN', 'فنلندا'),
(37263, 2338455552, 2338521087, 'NO', 'NOR', 'النرويج'),
(37264, 2338521088, 2338586623, 'US', 'USA', 'الولايات المتحدة'),
(37265, 2338586624, 2338652159, 'FR', 'FRA', 'فرنسا'),
(37266, 2338717696, 2338783231, 'US', 'USA', 'الولايات المتحدة'),
(37267, 2338783232, 2338848767, 'CA', 'CAN', 'كندا'),
(37268, 2338848768, 2338914303, 'US', 'USA', 'الولايات المتحدة'),
(37269, 2338914304, 2339962879, 'NO', 'NOR', 'النرويج'),
(37270, 2339962880, 2340028415, 'US', 'USA', 'الولايات المتحدة'),
(37271, 2340028416, 2340093951, 'NL', 'NLD', 'هولندا'),
(37272, 2340093952, 2340159487, 'FI', 'FIN', 'فنلندا'),
(37273, 2340159488, 2340225023, 'FR', 'FRA', 'فرنسا'),
(37274, 2340225024, 2340421631, 'US', 'USA', 'الولايات المتحدة'),
(37275, 2340421632, 2340487167, 'IT', 'ITA', 'إيطاليا'),
(37276, 2340552704, 2340618239, 'AU', 'AUS', 'أستراليا'),
(37277, 2340618240, 2340683775, 'US', 'USA', 'الولايات المتحدة'),
(37278, 2340683776, 2340749311, 'AU', 'AUS', 'أستراليا'),
(37279, 2340749312, 2340814847, 'GB', 'GBR', 'المملكة المتحدة'),
(37280, 2340814848, 2340880383, 'AU', 'AUS', 'أستراليا'),
(37281, 2340880384, 2341273599, 'US', 'USA', 'الولايات المتحدة'),
(37282, 2341273600, 2341339135, 'KW', 'KWT', 'الكويت'),
(37283, 2341339136, 2341404671, 'CA', 'CAN', 'كندا'),
(37284, 2341404672, 2341470207, 'GB', 'GBR', 'المملكة المتحدة'),
(37285, 2341470208, 2341535743, 'US', 'USA', 'الولايات المتحدة'),
(37286, 2341535744, 2341601279, 'NO', 'NOR', 'النرويج'),
(37287, 2341601280, 2341732351, 'US', 'USA', 'الولايات المتحدة'),
(37288, 2341797888, 2341863423, 'GB', 'GBR', 'المملكة المتحدة'),
(37289, 2341928960, 2341994495, 'US', 'USA', 'الولايات المتحدة'),
(37290, 2341994496, 2342060031, 'JP', 'JPN', 'اليابان'),
(37291, 2342060032, 2342125567, 'GB', 'GBR', 'المملكة المتحدة'),
(37292, 2342125568, 2342191103, 'JP', 'JPN', 'اليابان'),
(37293, 2342256640, 2342322175, 'NL', 'NLD', 'هولندا'),
(37294, 2342322176, 2342387711, 'FI', 'FIN', 'فنلندا'),
(37295, 2342387712, 2342453247, 'FR', 'FRA', 'فرنسا'),
(37296, 2342518784, 2342584319, 'FR', 'FRA', 'فرنسا'),
(37297, 2342584320, 2342649855, 'US', 'USA', 'الولايات المتحدة'),
(37298, 2342649856, 2342715391, 'NL', 'NLD', 'هولندا'),
(37299, 2342715392, 2342780927, 'AU', 'AUS', 'أستراليا'),
(37300, 2342780928, 2342846463, 'NO', 'NOR', 'النرويج'),
(37301, 2342846464, 2342911999, 'BE', 'BEL', 'بلجيكا'),
(37302, 2342912000, 2342977535, 'GB', 'GBR', 'المملكة المتحدة'),
(37303, 2342977536, 2343043071, 'US', 'USA', 'الولايات المتحدة'),
(37304, 2343043072, 2343108607, 'AU', 'AUS', 'أستراليا'),
(37305, 2343108608, 2343174143, 'US', 'USA', 'الولايات المتحدة'),
(37306, 2343239680, 2343370751, 'US', 'USA', 'الولايات المتحدة'),
(37307, 2343370752, 2343436287, 'CA', 'CAN', 'كندا'),
(37308, 2343436288, 2343501823, 'DE', 'DEU', 'ألمانيا'),
(37309, 2343501824, 2343567359, 'TW', 'TWN', 'تايوان'),
(37310, 2343632896, 2343698431, 'US', 'USA', 'الولايات المتحدة'),
(37311, 2343698432, 2343763967, 'NL', 'NLD', 'هولندا'),
(37312, 2343763968, 2343829503, 'TR', 'TUR', 'تركيا'),
(37313, 2343829504, 2344026111, 'US', 'USA', 'الولايات المتحدة'),
(37314, 2344091648, 2344157183, 'GB', 'GBR', 'المملكة المتحدة'),
(37315, 2344157184, 2344222719, 'US', 'USA', 'الولايات المتحدة'),
(37316, 2344288256, 2344353791, 'US', 'USA', 'الولايات المتحدة'),
(37317, 2344353792, 2344419327, 'AU', 'AUS', 'أستراليا'),
(37318, 2346582016, 2346647551, 'GB', 'GBR', 'المملكة المتحدة'),
(37319, 2346647552, 2346713087, 'TW', 'TWN', 'تايوان'),
(37320, 2346778624, 2346844159, 'US', 'USA', 'الولايات المتحدة'),
(37321, 2347040768, 2347106303, 'US', 'USA', 'الولايات المتحدة'),
(37322, 2347106304, 2347171839, 'AU', 'AUS', 'أستراليا'),
(37323, 2347171840, 2348744703, 'US', 'USA', 'الولايات المتحدة'),
(37324, 2348875776, 2353725439, 'US', 'USA', 'الولايات المتحدة'),
(37325, 2353790976, 2353856511, 'US', 'USA', 'الولايات المتحدة'),
(37326, 2353856512, 2353922047, 'FR', 'FRA', 'فرنسا'),
(37327, 2353922048, 2353987583, 'AT', 'AUT', 'النمسا'),
(37328, 2353987584, 2354053119, 'AU', 'AUS', 'أستراليا'),
(37329, 2354053120, 2354118655, 'CA', 'CAN', 'كندا'),
(37330, 2354118656, 2354184191, 'JP', 'JPN', 'اليابان'),
(37331, 2354184192, 2354249727, 'US', 'USA', 'الولايات المتحدة'),
(37332, 2354249728, 2354315263, 'AU', 'AUS', 'أستراليا'),
(37333, 2354315264, 2354380799, 'DE', 'DEU', 'ألمانيا'),
(37334, 2354380800, 2354446335, 'NL', 'NLD', 'هولندا'),
(37335, 2354446336, 2354511871, 'FR', 'FRA', 'فرنسا'),
(37336, 2354511872, 2354577407, 'CA', 'CAN', 'كندا'),
(37337, 2354577408, 2354839551, 'US', 'USA', 'الولايات المتحدة'),
(37338, 2354839552, 2354905087, 'TW', 'TWN', 'تايوان'),
(37339, 2354905088, 2355036159, 'FR', 'FRA', 'فرنسا'),
(37340, 2355036160, 2355101695, 'US', 'USA', 'الولايات المتحدة'),
(37341, 2355101696, 2355167231, 'TW', 'TWN', 'تايوان'),
(37342, 2355167232, 2355232767, 'GB', 'GBR', 'المملكة المتحدة'),
(37343, 2355232768, 2355305583, 'US', 'USA', 'الولايات المتحدة'),
(37344, 2355305584, 2355305591, 'DK', 'DNK', 'الدنيمارك'),
(37345, 2355305592, 2355691519, 'US', 'USA', 'الولايات المتحدة'),
(37346, 2355691520, 2355757055, 'IT', 'ITA', 'إيطاليا'),
(37347, 2355757056, 2355953663, 'US', 'USA', 'الولايات المتحدة'),
(37348, 2355953664, 2357919743, 'TW', 'TWN', 'تايوان'),
(37349, 2357919744, 2358181887, 'US', 'USA', 'الولايات المتحدة'),
(37350, 2358247424, 2358509567, 'US', 'USA', 'الولايات المتحدة'),
(37351, 2358509568, 2358575103, 'MX', 'MEX', 'المكسيك'),
(37352, 2358640640, 2358706175, 'SE', 'SWE', 'السويد'),
(37353, 2358706176, 2358771711, 'FI', 'FIN', 'فنلندا'),
(37354, 2358771712, 2359230463, 'US', 'USA', 'الولايات المتحدة'),
(37355, 2359230464, 2359295999, 'AU', 'AUS', 'أستراليا'),
(37356, 2359296000, 2359361535, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(37357, 2359361536, 2359427071, 'CA', 'CAN', 'كندا'),
(37358, 2359427072, 2359558143, 'US', 'USA', 'الولايات المتحدة'),
(37359, 2359558144, 2359623679, 'IT', 'ITA', 'إيطاليا'),
(37360, 2359623680, 2359689215, 'US', 'USA', 'الولايات المتحدة'),
(37361, 2359689216, 2359754751, 'SE', 'SWE', 'السويد'),
(37362, 2359754752, 2359820287, 'CA', 'CAN', 'كندا'),
(37363, 2359820288, 2359885823, 'AU', 'AUS', 'أستراليا'),
(37364, 2359885824, 2360672255, 'US', 'USA', 'الولايات المتحدة'),
(37365, 2360672256, 2360737791, 'DE', 'DEU', 'ألمانيا'),
(37366, 2360737792, 2360868863, 'US', 'USA', 'الولايات المتحدة'),
(37367, 2360868864, 2360934399, 'CA', 'CAN', 'كندا'),
(37368, 2360934400, 2361327615, 'US', 'USA', 'الولايات المتحدة'),
(37369, 2361327616, 2361393151, 'AR', 'ARG', 'الأرجنتين'),
(37370, 2361393152, 2361458687, 'US', 'USA', 'الولايات المتحدة'),
(37371, 2361458688, 2361524223, 'CA', 'CAN', 'كندا'),
(37372, 2361524224, 2361917439, 'US', 'USA', 'الولايات المتحدة'),
(37373, 2361917440, 2361982975, 'NZ', 'NZL', 'نيوزيلاندا'),
(37374, 2361982976, 2362114047, 'US', 'USA', 'الولايات المتحدة'),
(37375, 2362114048, 2362179583, 'IE', 'IRL', 'إيرلندا'),
(37376, 2362179584, 2362245119, 'US', 'USA', 'الولايات المتحدة'),
(37377, 2362441728, 2362572799, 'US', 'USA', 'الولايات المتحدة'),
(37378, 2362638336, 2362769407, 'US', 'USA', 'الولايات المتحدة'),
(37379, 2362834944, 2363490303, 'US', 'USA', 'الولايات المتحدة'),
(37380, 2363555840, 2363883519, 'US', 'USA', 'الولايات المتحدة'),
(37381, 2363883520, 2363949055, 'CA', 'CAN', 'كندا'),
(37382, 2363949056, 2364342271, 'US', 'USA', 'الولايات المتحدة'),
(37383, 2364407808, 2364538879, 'US', 'USA', 'الولايات المتحدة'),
(37384, 2364604416, 2364735487, 'US', 'USA', 'الولايات المتحدة'),
(37385, 2364801024, 2364932095, 'US', 'USA', 'الولايات المتحدة'),
(37386, 2364997632, 2365128703, 'US', 'USA', 'الولايات المتحدة'),
(37387, 2365259776, 2365390847, 'US', 'USA', 'الولايات المتحدة'),
(37388, 2365390848, 2365456383, 'AU', 'AUS', 'أستراليا'),
(37389, 2365456384, 2365521919, 'US', 'USA', 'الولايات المتحدة'),
(37390, 2365652992, 2366308351, 'DE', 'DEU', 'ألمانيا'),
(37391, 2366308352, 2366373887, 'FR', 'FRA', 'فرنسا'),
(37392, 2366373888, 2367487999, 'DE', 'DEU', 'ألمانيا'),
(37393, 2367488000, 2367553535, 'BA', 'BIH', 'البوسنه والهرسك'),
(37394, 2367553536, 2370895871, 'DE', 'DEU', 'ألمانيا'),
(37395, 2370895872, 2370961407, 'SE', 'SWE', 'السويد'),
(37396, 2370961408, 2371158015, 'DE', 'DEU', 'ألمانيا'),
(37397, 2371158016, 2371223551, 'RO', 'ROM', 'رومانيا'),
(37398, 2371223552, 2371289087, 'US', 'USA', 'الولايات المتحدة'),
(37399, 2371289088, 2371616767, 'DE', 'DEU', 'ألمانيا'),
(37400, 2371616768, 2371682303, 'GB', 'GBR', 'المملكة المتحدة'),
(37401, 2371682304, 2371747839, 'NL', 'NLD', 'هولندا'),
(37402, 2371747840, 2371878911, 'GB', 'GBR', 'المملكة المتحدة'),
(37403, 2371878912, 2371944447, 'BE', 'BEL', 'بلجيكا'),
(37404, 2371944448, 2372009983, 'GB', 'GBR', 'المملكة المتحدة'),
(37405, 2372009984, 2372075519, 'CH', 'CHE', 'سويسرا'),
(37406, 2372075520, 2372206591, 'DE', 'DEU', 'ألمانيا'),
(37407, 2372272128, 2372337663, 'US', 'USA', 'الولايات المتحدة'),
(37408, 2372337664, 2372403199, 'ID', 'IDN', 'إندونيسيا'),
(37409, 2372403200, 2372468735, 'US', 'USA', 'الولايات المتحدة'),
(37410, 2372534272, 2372665343, 'US', 'USA', 'الولايات المتحدة'),
(37411, 2372665344, 2372730879, 'IT', 'ITA', 'إيطاليا'),
(37412, 2372730880, 2372796415, 'CA', 'CAN', 'كندا'),
(37413, 2372796416, 2372993023, 'US', 'USA', 'الولايات المتحدة'),
(37414, 2372993024, 2373058559, 'DE', 'DEU', 'ألمانيا'),
(37415, 2373058560, 2373124095, 'US', 'USA', 'الولايات المتحدة'),
(37416, 2373124096, 2373189631, 'FR', 'FRA', 'فرنسا'),
(37417, 2373189632, 2373255167, 'US', 'USA', 'الولايات المتحدة'),
(37418, 2373255168, 2373451775, 'CA', 'CAN', 'كندا'),
(37419, 2373451776, 2373517311, 'AU', 'AUS', 'أستراليا'),
(37420, 2373517312, 2374107135, 'US', 'USA', 'الولايات المتحدة'),
(37421, 2374107136, 2374172671, 'DE', 'DEU', 'ألمانيا'),
(37422, 2374172672, 2374238207, 'US', 'USA', 'الولايات المتحدة'),
(37423, 2374238208, 2374303743, 'AU', 'AUS', 'أستراليا'),
(37424, 2374303744, 2374369279, 'US', 'USA', 'الولايات المتحدة'),
(37425, 2374565888, 2374631423, 'SE', 'SWE', 'السويد'),
(37426, 2374696960, 2374959103, 'US', 'USA', 'الولايات المتحدة'),
(37427, 2374959104, 2375024639, 'BE', 'BEL', 'بلجيكا'),
(37428, 2375024640, 2375090175, 'DK', 'DNK', 'الدنيمارك'),
(37429, 2375090176, 2375155711, 'NO', 'NOR', 'النرويج'),
(37430, 2375155712, 2375221247, 'FI', 'FIN', 'فنلندا'),
(37431, 2375221248, 2375286783, 'SE', 'SWE', 'السويد'),
(37432, 2375286784, 2375352319, 'CH', 'CHE', 'سويسرا'),
(37433, 2375352320, 2376269823, 'US', 'USA', 'الولايات المتحدة'),
(37434, 2376269824, 2376335359, 'GB', 'GBR', 'المملكة المتحدة'),
(37435, 2376335360, 2376597503, 'US', 'USA', 'الولايات المتحدة'),
(37436, 2376597504, 2376663039, 'AU', 'AUS', 'أستراليا'),
(37437, 2376663040, 2376728575, 'DE', 'DEU', 'ألمانيا'),
(37438, 2376794112, 2376859647, 'CH', 'CHE', 'سويسرا'),
(37439, 2376859648, 2376925183, 'FI', 'FIN', 'فنلندا'),
(37440, 2376925184, 2377056255, 'US', 'USA', 'الولايات المتحدة'),
(37441, 2377056256, 2377121791, 'FR', 'FRA', 'فرنسا'),
(37442, 2377121792, 2377187327, 'NL', 'NLD', 'هولندا'),
(37443, 2377187328, 2377252863, 'US', 'USA', 'الولايات المتحدة'),
(37444, 2377252864, 2377318399, 'JP', 'JPN', 'اليابان'),
(37445, 2377318400, 2378170367, 'US', 'USA', 'الولايات المتحدة'),
(37446, 2378170368, 2378235903, 'FI', 'FIN', 'فنلندا'),
(37447, 2378235904, 2378301439, 'US', 'USA', 'الولايات المتحدة'),
(37448, 2378301440, 2378366975, 'FR', 'FRA', 'فرنسا'),
(37449, 2378366976, 2378432511, 'US', 'USA', 'الولايات المتحدة'),
(37450, 2378498048, 2378694655, 'US', 'USA', 'الولايات المتحدة'),
(37451, 2378694656, 2378760191, 'DE', 'DEU', 'ألمانيا'),
(37452, 2378760192, 2378825727, 'AT', 'AUT', 'النمسا'),
(37453, 2378825728, 2378891263, 'US', 'USA', 'الولايات المتحدة'),
(37454, 2378891264, 2378956799, 'AT', 'AUT', 'النمسا'),
(37455, 2378956800, 2379218943, 'US', 'USA', 'الولايات المتحدة'),
(37456, 2379218944, 2379284479, 'FI', 'FIN', 'فنلندا'),
(37457, 2379284480, 2380201983, 'US', 'USA', 'الولايات المتحدة'),
(37458, 2380201984, 2380267519, 'KR', 'KOR', 'جمهورية كوريا'),
(37459, 2380267520, 2380398591, 'US', 'USA', 'الولايات المتحدة'),
(37460, 2380398592, 2380464127, 'IL', 'ISR', 'إسرائيل'),
(37461, 2380464128, 2380529663, 'FR', 'FRA', 'فرنسا'),
(37462, 2380529664, 2380595199, 'GB', 'GBR', 'المملكة المتحدة'),
(37463, 2380595200, 2380660735, 'JP', 'JPN', 'اليابان'),
(37464, 2380660736, 2380726271, 'US', 'USA', 'الولايات المتحدة'),
(37465, 2380726272, 2380791807, 'GB', 'GBR', 'المملكة المتحدة'),
(37466, 2380791808, 2381119487, 'US', 'USA', 'الولايات المتحدة'),
(37467, 2381185024, 2381381631, 'US', 'USA', 'الولايات المتحدة'),
(37468, 2381381632, 2381447167, 'GB', 'GBR', 'المملكة المتحدة'),
(37469, 2381447168, 2381512703, 'US', 'USA', 'الولايات المتحدة'),
(37470, 2381512704, 2381578239, 'AU', 'AUS', 'أستراليا'),
(37471, 2381578240, 2381643775, 'AT', 'AUT', 'النمسا'),
(37472, 2381643776, 2381709311, 'GB', 'GBR', 'المملكة المتحدة'),
(37473, 2381709312, 2381905919, 'US', 'USA', 'الولايات المتحدة'),
(37474, 2381905920, 2381971455, 'CH', 'CHE', 'سويسرا'),
(37475, 2381971456, 2382036991, 'IT', 'ITA', 'إيطاليا'),
(37476, 2382036992, 2382102527, 'US', 'USA', 'الولايات المتحدة'),
(37477, 2382102528, 2382168063, 'NL', 'NLD', 'هولندا'),
(37478, 2382168064, 2382233599, 'BE', 'BEL', 'بلجيكا'),
(37479, 2382233600, 2382299135, 'US', 'USA', 'الولايات المتحدة'),
(37480, 2382430208, 2383085567, 'CA', 'CAN', 'كندا'),
(37481, 2383151104, 2386624511, 'CA', 'CAN', 'كندا'),
(37482, 2386624512, 2386690047, 'US', 'USA', 'الولايات المتحدة'),
(37483, 2386690048, 2386989055, 'CA', 'CAN', 'كندا'),
(37484, 2386989056, 2386989311, 'GB', 'GBR', 'المملكة المتحدة'),
(37485, 2386989312, 2387410943, 'CA', 'CAN', 'كندا'),
(37486, 2387410944, 2387476479, 'US', 'USA', 'الولايات المتحدة'),
(37487, 2387476480, 2387542015, 'CA', 'CAN', 'كندا'),
(37488, 2387542016, 2387607551, 'US', 'USA', 'الولايات المتحدة'),
(37489, 2387607552, 2388328447, 'CA', 'CAN', 'كندا'),
(37490, 2388393984, 2389245951, 'CA', 'CAN', 'كندا'),
(37491, 2389311488, 2389639167, 'CA', 'CAN', 'كندا'),
(37492, 2389704704, 2390818815, 'CA', 'CAN', 'كندا'),
(37493, 2390884352, 2391277567, 'CA', 'CAN', 'كندا'),
(37494, 2391343104, 2394947583, 'CA', 'CAN', 'كندا'),
(37495, 2394947584, 2395013119, 'US', 'USA', 'الولايات المتحدة'),
(37496, 2395013120, 2395209727, 'CA', 'CAN', 'كندا'),
(37497, 2395340800, 2397700095, 'CA', 'CAN', 'كندا'),
(37498, 2397765632, 2398748671, 'CA', 'CAN', 'كندا'),
(37499, 2398945280, 2399010815, 'CA', 'CAN', 'كندا'),
(37500, 2399207424, 2401828863, 'US', 'USA', 'الولايات المتحدة'),
(37501, 2401828864, 2401894399, 'GB', 'GBR', 'المملكة المتحدة'),
(37502, 2401894400, 2402222079, 'US', 'USA', 'الولايات المتحدة'),
(37503, 2402222080, 2402287615, 'IE', 'IRL', 'إيرلندا'),
(37504, 2402287616, 2402418687, 'US', 'USA', 'الولايات المتحدة'),
(37505, 2402418688, 2402484223, 'AT', 'AUT', 'النمسا'),
(37506, 2402484224, 2402549759, 'FI', 'FIN', 'فنلندا'),
(37507, 2402549760, 2402680831, 'GB', 'GBR', 'المملكة المتحدة'),
(37508, 2402680832, 2402746367, 'BR', 'BRA', 'البرازيل'),
(37509, 2402746368, 2403401727, 'US', 'USA', 'الولايات المتحدة'),
(37510, 2403401728, 2403467263, 'GB', 'GBR', 'المملكة المتحدة'),
(37511, 2403467264, 2404974591, 'US', 'USA', 'الولايات المتحدة'),
(37512, 2404974592, 2405040127, 'HK', 'HKG', 'هونغ كونغ'),
(37513, 2405040128, 2405105663, 'JP', 'JPN', 'اليابان'),
(37514, 2405105664, 2405171199, 'US', 'USA', 'الولايات المتحدة'),
(37515, 2405171200, 2405236735, 'AU', 'AUS', 'أستراليا'),
(37516, 2405236736, 2405302271, 'DE', 'DEU', 'ألمانيا'),
(37517, 2405302272, 2405367807, 'JP', 'JPN', 'اليابان'),
(37518, 2405367808, 2405433343, 'US', 'USA', 'الولايات المتحدة'),
(37519, 2405433344, 2405498879, 'NZ', 'NZL', 'نيوزيلاندا'),
(37520, 2405498880, 2405564415, 'NO', 'NOR', 'النرويج'),
(37521, 2405564416, 2405629951, 'US', 'USA', 'الولايات المتحدة'),
(37522, 2405629952, 2405695487, 'CH', 'CHE', 'سويسرا'),
(37523, 2405695488, 2406088703, 'US', 'USA', 'الولايات المتحدة'),
(37524, 2406088704, 2406285311, 'BR', 'BRA', 'البرازيل'),
(37525, 2406285312, 2406809599, 'US', 'USA', 'الولايات المتحدة'),
(37526, 2406809600, 2406875135, 'GB', 'GBR', 'المملكة المتحدة'),
(37527, 2406875136, 2406940671, 'SE', 'SWE', 'السويد'),
(37528, 2406940672, 2407006207, 'AU', 'AUS', 'أستراليا'),
(37529, 2407006208, 2407071743, 'US', 'USA', 'الولايات المتحدة'),
(37530, 2407071744, 2407137279, 'NL', 'NLD', 'هولندا'),
(37531, 2407137280, 2407333887, 'US', 'USA', 'الولايات المتحدة'),
(37532, 2407333888, 2407399423, 'JP', 'JPN', 'اليابان'),
(37533, 2407399424, 2407464959, 'FR', 'FRA', 'فرنسا'),
(37534, 2407464960, 2407530495, 'US', 'USA', 'الولايات المتحدة'),
(37535, 2407596032, 2407661567, 'BE', 'BEL', 'بلجيكا'),
(37536, 2407661568, 2407727103, 'AT', 'AUT', 'النمسا'),
(37537, 2407727104, 2408054783, 'US', 'USA', 'الولايات المتحدة'),
(37538, 2408054784, 2408120319, 'JP', 'JPN', 'اليابان'),
(37539, 2408185856, 2409627647, 'US', 'USA', 'الولايات المتحدة'),
(37540, 2409693184, 2409758719, 'AT', 'AUT', 'النمسا'),
(37541, 2409758720, 2409824255, 'US', 'USA', 'الولايات المتحدة'),
(37542, 2409824256, 2409955327, 'DE', 'DEU', 'ألمانيا'),
(37543, 2409955328, 2410086399, 'US', 'USA', 'الولايات المتحدة'),
(37544, 2410086400, 2410151935, 'GB', 'GBR', 'المملكة المتحدة'),
(37545, 2410151936, 2410217471, 'US', 'USA', 'الولايات المتحدة'),
(37546, 2410217472, 2410283007, 'BE', 'BEL', 'بلجيكا'),
(37547, 2410283008, 2410348543, 'US', 'USA', 'الولايات المتحدة'),
(37548, 2410348544, 2410414079, 'JP', 'JPN', 'اليابان'),
(37549, 2410414080, 2410545151, 'US', 'USA', 'الولايات المتحدة'),
(37550, 2410545152, 2410610687, 'AU', 'AUS', 'أستراليا'),
(37551, 2410610688, 2410676223, 'US', 'USA', 'الولايات المتحدة'),
(37552, 2410676224, 2410938367, 'NL', 'NLD', 'هولندا'),
(37553, 2410938368, 2411003903, 'CH', 'CHE', 'سويسرا'),
(37554, 2411003904, 2411462655, 'US', 'USA', 'الولايات المتحدة'),
(37555, 2411462656, 2411593727, 'AU', 'AUS', 'أستراليا'),
(37556, 2411593728, 2411986943, 'US', 'USA', 'الولايات المتحدة'),
(37557, 2411986944, 2412052479, 'FR', 'FRA', 'فرنسا'),
(37558, 2412052480, 2412314623, 'US', 'USA', 'الولايات المتحدة'),
(37559, 2412314624, 2412380159, 'JP', 'JPN', 'اليابان'),
(37560, 2412445696, 2412576767, 'US', 'USA', 'الولايات المتحدة'),
(37561, 2412576768, 2412642303, 'AT', 'AUT', 'النمسا'),
(37562, 2412642304, 2412773375, 'US', 'USA', 'الولايات المتحدة'),
(37563, 2412838912, 2412904447, 'US', 'USA', 'الولايات المتحدة'),
(37564, 2412904448, 2412969983, 'GB', 'GBR', 'المملكة المتحدة'),
(37565, 2412969984, 2413297663, 'US', 'USA', 'الولايات المتحدة'),
(37566, 2413297664, 2413363199, 'AU', 'AUS', 'أستراليا'),
(37567, 2413363200, 2413428735, 'SE', 'SWE', 'السويد'),
(37568, 2413428736, 2413494271, 'AU', 'AUS', 'أستراليا'),
(37569, 2413494272, 2413625343, 'US', 'USA', 'الولايات المتحدة'),
(37570, 2413625344, 2413690879, 'JP', 'JPN', 'اليابان'),
(37571, 2413690880, 2413821951, 'US', 'USA', 'الولايات المتحدة'),
(37572, 2413821952, 2413887487, 'AT', 'AUT', 'النمسا'),
(37573, 2413887488, 2413953023, 'IT', 'ITA', 'إيطاليا'),
(37574, 2413953024, 2414411775, 'US', 'USA', 'الولايات المتحدة'),
(37575, 2414411776, 2414477311, 'GR', 'GRC', 'اليونان'),
(37576, 2414477312, 2414542847, 'GB', 'GBR', 'المملكة المتحدة'),
(37577, 2414542848, 2414673919, 'US', 'USA', 'الولايات المتحدة'),
(37578, 2414673920, 2414739455, 'SE', 'SWE', 'السويد'),
(37579, 2414739456, 2414804991, 'AU', 'AUS', 'أستراليا'),
(37580, 2414804992, 2414870527, 'IE', 'IRL', 'إيرلندا'),
(37581, 2414870528, 2415198207, 'US', 'USA', 'الولايات المتحدة'),
(37582, 2415198208, 2415263743, 'AT', 'AUT', 'النمسا'),
(37583, 2415263744, 2415394815, 'US', 'USA', 'الولايات المتحدة'),
(37584, 2415394816, 2415460351, 'KR', 'KOR', 'جمهورية كوريا'),
(37585, 2415460352, 2415656959, 'US', 'USA', 'الولايات المتحدة'),
(37586, 2415656960, 2415722495, 'GB', 'GBR', 'المملكة المتحدة'),
(37587, 2415722496, 2415788031, 'JP', 'JPN', 'اليابان'),
(37588, 2415788032, 2415853567, 'US', 'USA', 'الولايات المتحدة'),
(37589, 2415984640, 2416050175, 'JP', 'JPN', 'اليابان'),
(37590, 2416050176, 2416115711, 'NL', 'NLD', 'هولندا'),
(37591, 2416115712, 2416181247, 'US', 'USA', 'الولايات المتحدة'),
(37592, 2416181248, 2416246783, 'FI', 'FIN', 'فنلندا'),
(37593, 2416246784, 2416312319, 'US', 'USA', 'الولايات المتحدة'),
(37594, 2416312320, 2416377855, 'AU', 'AUS', 'أستراليا'),
(37595, 2416443392, 2416705535, 'US', 'USA', 'الولايات المتحدة'),
(37596, 2416771072, 2416967679, 'US', 'USA', 'الولايات المتحدة'),
(37597, 2416967680, 2417033215, 'IN', 'IND', 'الهند'),
(37598, 2417033216, 2417229823, 'US', 'USA', 'الولايات المتحدة'),
(37599, 2417229824, 2417295359, 'ES', 'ESP', 'إسبانيا'),
(37600, 2417295360, 2417360895, 'PT', 'PRT', 'البورتوغال'),
(37601, 2417360896, 2417426431, 'MX', 'MEX', 'المكسيك'),
(37602, 2417426432, 2417491967, 'BR', 'BRA', 'البرازيل'),
(37603, 2417491968, 2417557503, 'GR', 'GRC', 'اليونان'),
(37604, 2417557504, 2417688575, 'US', 'USA', 'الولايات المتحدة'),
(37605, 2417688576, 2417754111, 'SE', 'SWE', 'السويد'),
(37606, 2417754112, 2418016255, 'US', 'USA', 'الولايات المتحدة'),
(37607, 2418016256, 2418081791, 'GB', 'GBR', 'المملكة المتحدة'),
(37608, 2418081792, 2418606079, 'US', 'USA', 'الولايات المتحدة'),
(37609, 2418606080, 2418671615, 'DE', 'DEU', 'ألمانيا'),
(37610, 2418671616, 2418737151, 'US', 'USA', 'الولايات المتحدة'),
(37611, 2418737152, 2418802687, 'NL', 'NLD', 'هولندا'),
(37612, 2418868224, 2419326975, 'US', 'USA', 'الولايات المتحدة'),
(37613, 2419392512, 2419458047, 'AU', 'AUS', 'أستراليا'),
(37614, 2419458048, 2419523583, 'NL', 'NLD', 'هولندا'),
(37615, 2419523584, 2419589119, 'AU', 'AUS', 'أستراليا'),
(37616, 2419589120, 2419654655, 'FR', 'FRA', 'فرنسا'),
(37617, 2419654656, 2419720191, 'SE', 'SWE', 'السويد'),
(37618, 2419720192, 2420047871, 'US', 'USA', 'الولايات المتحدة'),
(37619, 2420047872, 2420113407, 'SE', 'SWE', 'السويد'),
(37620, 2420113408, 2420178943, 'PT', 'PRT', 'البورتوغال'),
(37621, 2420178944, 2420244479, 'AT', 'AUT', 'النمسا'),
(37622, 2420244480, 2420310015, 'NZ', 'NZL', 'نيوزيلاندا'),
(37623, 2420310016, 2420899839, 'US', 'USA', 'الولايات المتحدة'),
(37624, 2420899840, 2420965375, 'DE', 'DEU', 'ألمانيا'),
(37625, 2420965376, 2421096447, 'US', 'USA', 'الولايات المتحدة'),
(37626, 2421096448, 2421161983, 'AU', 'AUS', 'أستراليا'),
(37627, 2421161984, 2421293055, 'US', 'USA', 'الولايات المتحدة'),
(37628, 2421293056, 2421358591, 'GB', 'GBR', 'المملكة المتحدة'),
(37629, 2421358592, 2421424127, 'US', 'USA', 'الولايات المتحدة'),
(37630, 2421424128, 2421489663, 'NO', 'NOR', 'النرويج'),
(37631, 2421489664, 2421555199, 'CH', 'CHE', 'سويسرا'),
(37632, 2421555200, 2421620735, 'US', 'USA', 'الولايات المتحدة'),
(37633, 2421620736, 2421686271, 'GB', 'GBR', 'المملكة المتحدة'),
(37634, 2421686272, 2422145023, 'US', 'USA', 'الولايات المتحدة'),
(37635, 2422145024, 2422154239, 'NL', 'NLD', 'هولندا'),
(37636, 2422154240, 2422155263, 'US', 'USA', 'الولايات المتحدة'),
(37637, 2422155264, 2422161407, 'NL', 'NLD', 'هولندا'),
(37638, 2422161408, 2422163455, 'GB', 'GBR', 'المملكة المتحدة'),
(37639, 2422163456, 2422165503, 'US', 'USA', 'الولايات المتحدة'),
(37640, 2422165504, 2422167551, 'HK', 'HKG', 'هونغ كونغ'),
(37641, 2422167552, 2422210559, 'NL', 'NLD', 'هولندا'),
(37642, 2422210560, 2422276095, 'US', 'USA', 'الولايات المتحدة'),
(37643, 2422276096, 2422341631, 'AU', 'AUS', 'أستراليا'),
(37644, 2422341632, 2422407167, 'GB', 'GBR', 'المملكة المتحدة'),
(37645, 2422407168, 2423128063, 'US', 'USA', 'الولايات المتحدة'),
(37646, 2423128064, 2423193599, 'AU', 'AUS', 'أستراليا'),
(37647, 2423193600, 2423717887, 'US', 'USA', 'الولايات المتحدة'),
(37648, 2423717888, 2423783423, 'NL', 'NLD', 'هولندا'),
(37649, 2423783424, 2423848959, 'FJ', 'FJI', 'فيجي'),
(37650, 2423848960, 2423914495, 'US', 'USA', 'الولايات المتحدة'),
(37651, 2423914496, 2423980031, 'TR', 'TUR', 'تركيا'),
(37652, 2424045568, 2424111103, 'GB', 'GBR', 'المملكة المتحدة'),
(37653, 2424111104, 2424242175, 'US', 'USA', 'الولايات المتحدة'),
(37654, 2424242176, 2424307711, 'NO', 'NOR', 'النرويج'),
(37655, 2424307712, 2424438783, 'US', 'USA', 'الولايات المتحدة'),
(37656, 2424438784, 2425159679, 'AU', 'AUS', 'أستراليا'),
(37657, 2425159680, 2425421823, 'US', 'USA', 'الولايات المتحدة'),
(37658, 2425421824, 2425487359, 'DE', 'DEU', 'ألمانيا'),
(37659, 2425487360, 2426667007, 'US', 'USA', 'الولايات المتحدة'),
(37660, 2426667008, 2426732543, 'NO', 'NOR', 'النرويج'),
(37661, 2426732544, 2426798079, 'FR', 'FRA', 'فرنسا'),
(37662, 2426798080, 2426929151, 'US', 'USA', 'الولايات المتحدة'),
(37663, 2426929152, 2426994687, 'GB', 'GBR', 'المملكة المتحدة'),
(37664, 2426994688, 2427256831, 'US', 'USA', 'الولايات المتحدة'),
(37665, 2427256832, 2427322367, 'GB', 'GBR', 'المملكة المتحدة'),
(37666, 2427322368, 2427453439, 'US', 'USA', 'الولايات المتحدة'),
(37667, 2427453440, 2427584511, 'NO', 'NOR', 'النرويج'),
(37668, 2427584512, 2427650047, 'GB', 'GBR', 'المملكة المتحدة'),
(37669, 2427650048, 2427846655, 'NO', 'NOR', 'النرويج'),
(37670, 2427846656, 2428567551, 'US', 'USA', 'الولايات المتحدة'),
(37671, 2428567552, 2428633087, 'NO', 'NOR', 'النرويج'),
(37672, 2428633088, 2428698623, 'CA', 'CAN', 'كندا'),
(37673, 2428698624, 2428960767, 'US', 'USA', 'الولايات المتحدة'),
(37674, 2428960768, 2429026303, 'MY', 'MYS', 'ماليزيا'),
(37675, 2429026304, 2429091839, 'CH', 'CHE', 'سويسرا'),
(37676, 2429091840, 2429288447, 'US', 'USA', 'الولايات المتحدة'),
(37677, 2429288448, 2429353983, 'FR', 'FRA', 'فرنسا'),
(37678, 2429353984, 2429419519, 'AU', 'AUS', 'أستراليا'),
(37679, 2429419520, 2429485055, 'RU', 'RUS', 'الإتحاد الروسي'),
(37680, 2429485056, 2429616127, 'US', 'USA', 'الولايات المتحدة'),
(37681, 2429616128, 2429681663, 'NL', 'NLD', 'هولندا'),
(37682, 2429681664, 2429878271, 'US', 'USA', 'الولايات المتحدة'),
(37683, 2429878272, 2429943807, 'JP', 'JPN', 'اليابان'),
(37684, 2429943808, 2430009343, 'HK', 'HKG', 'هونغ كونغ'),
(37685, 2430009344, 2430205951, 'US', 'USA', 'الولايات المتحدة'),
(37686, 2430205952, 2430271487, 'AU', 'AUS', 'أستراليا'),
(37687, 2430271488, 2432172031, 'US', 'USA', 'الولايات المتحدة'),
(37688, 2432172032, 2432237567, 'BE', 'BEL', 'بلجيكا'),
(37689, 2432237568, 2432630783, 'US', 'USA', 'الولايات المتحدة'),
(37690, 2432696320, 2433810431, 'NL', 'NLD', 'هولندا'),
(37691, 2433810432, 2433875967, 'GB', 'GBR', 'المملكة المتحدة'),
(37692, 2433875968, 2436300799, 'NL', 'NLD', 'هولندا'),
(37693, 2436300800, 2436366335, 'GB', 'GBR', 'المملكة المتحدة'),
(37694, 2436366336, 2436759551, 'NL', 'NLD', 'هولندا'),
(37695, 2436759552, 2436825087, 'GB', 'GBR', 'المملكة المتحدة'),
(37696, 2436825088, 2447376383, 'NL', 'NLD', 'هولندا'),
(37697, 2447376384, 2447441919, 'GB', 'GBR', 'المملكة المتحدة'),
(37698, 2447441920, 2447507455, 'DE', 'DEU', 'ألمانيا'),
(37699, 2447507456, 2447572991, 'FR', 'FRA', 'فرنسا'),
(37700, 2447572992, 2447638527, 'GB', 'GBR', 'المملكة المتحدة'),
(37701, 2447638528, 2447679819, 'DE', 'DEU', 'ألمانيا'),
(37702, 2447679820, 2447679839, 'IT', 'ITA', 'إيطاليا'),
(37703, 2447679840, 2447704063, 'DE', 'DEU', 'ألمانيا'),
(37704, 2447704064, 2447769599, 'GB', 'GBR', 'المملكة المتحدة'),
(37705, 2447769600, 2447835135, 'DE', 'DEU', 'ألمانيا'),
(37706, 2447835136, 2447900671, 'FR', 'FRA', 'فرنسا'),
(37707, 2447900672, 2447966207, 'CH', 'CHE', 'سويسرا'),
(37708, 2447966208, 2448031743, 'GB', 'GBR', 'المملكة المتحدة'),
(37709, 2448031744, 2448097279, 'CH', 'CHE', 'سويسرا'),
(37710, 2448097280, 2448162815, 'SE', 'SWE', 'السويد'),
(37711, 2448162816, 2448228351, 'HU', 'HUN', 'هنغاريا'),
(37712, 2448228352, 2448293887, 'PL', 'POL', 'بولندا'),
(37713, 2448293888, 2448359423, 'FR', 'FRA', 'فرنسا'),
(37714, 2448359424, 2448424959, 'GB', 'GBR', 'المملكة المتحدة'),
(37715, 2448424960, 2448490495, 'FR', 'FRA', 'فرنسا'),
(37716, 2448490496, 2448556031, 'AT', 'AUT', 'النمسا'),
(37717, 2448556032, 2448621567, 'FR', 'FRA', 'فرنسا'),
(37718, 2448621568, 2448687103, 'DE', 'DEU', 'ألمانيا'),
(37719, 2448687104, 2448752639, 'AT', 'AUT', 'النمسا'),
(37720, 2448752640, 2448818175, 'CH', 'CHE', 'سويسرا'),
(37721, 2448818176, 2448883711, 'GB', 'GBR', 'المملكة المتحدة'),
(37722, 2448883712, 2448922367, 'FI', 'FIN', 'فنلندا'),
(37723, 2448922368, 2448927487, 'NO', 'NOR', 'النرويج'),
(37724, 2448927488, 2448949247, 'FI', 'FIN', 'فنلندا'),
(37725, 2448949248, 2449014783, 'FR', 'FRA', 'فرنسا'),
(37726, 2449014784, 2449080319, 'RU', 'RUS', 'الإتحاد الروسي'),
(37727, 2449080320, 2449145855, 'CH', 'CHE', 'سويسرا'),
(37728, 2449145856, 2449211391, 'SE', 'SWE', 'السويد'),
(37729, 2449211392, 2449276927, 'CH', 'CHE', 'سويسرا'),
(37730, 2449276928, 2449407999, 'DE', 'DEU', 'ألمانيا'),
(37731, 2449539072, 2449604607, 'US', 'USA', 'الولايات المتحدة'),
(37732, 2449604608, 2449670143, 'NO', 'NOR', 'النرويج'),
(37733, 2449670144, 2449735679, 'LU', 'LUX', 'لوكسيمبورغ'),
(37734, 2449735680, 2449801215, 'CH', 'CHE', 'سويسرا'),
(37735, 2449801216, 2450194431, 'US', 'USA', 'الولايات المتحدة'),
(37736, 2450194432, 2450259967, 'AU', 'AUS', 'أستراليا'),
(37737, 2450259968, 2450718719, 'US', 'USA', 'الولايات المتحدة'),
(37738, 2450718720, 2450784255, 'FR', 'FRA', 'فرنسا'),
(37739, 2450784256, 2450849791, 'US', 'USA', 'الولايات المتحدة'),
(37740, 2450849792, 2450915327, 'SE', 'SWE', 'السويد'),
(37741, 2450915328, 2452619263, 'US', 'USA', 'الولايات المتحدة'),
(37742, 2452619264, 2452684799, 'IT', 'ITA', 'إيطاليا'),
(37743, 2452684800, 2452750335, 'US', 'USA', 'الولايات المتحدة'),
(37744, 2452750336, 2452815871, 'NL', 'NLD', 'هولندا'),
(37745, 2452815872, 2452881407, 'JP', 'JPN', 'اليابان'),
(37746, 2452946944, 2453143551, 'US', 'USA', 'الولايات المتحدة'),
(37747, 2453143552, 2453209087, 'JP', 'JPN', 'اليابان'),
(37748, 2453209088, 2453340159, 'US', 'USA', 'الولايات المتحدة'),
(37749, 2453340160, 2453405695, 'NO', 'NOR', 'النرويج'),
(37750, 2453471232, 2453536767, 'US', 'USA', 'الولايات المتحدة'),
(37751, 2453536768, 2453602303, 'AU', 'AUS', 'أستراليا'),
(37752, 2453602304, 2453667839, 'US', 'USA', 'الولايات المتحدة'),
(37753, 2453733376, 2453798911, 'US', 'USA', 'الولايات المتحدة'),
(37754, 2453864448, 2453929983, 'CH', 'CHE', 'سويسرا'),
(37755, 2453929984, 2454061055, 'US', 'USA', 'الولايات المتحدة'),
(37756, 2454061056, 2454126591, 'GB', 'GBR', 'المملكة المتحدة'),
(37757, 2454126592, 2454192127, 'US', 'USA', 'الولايات المتحدة'),
(37758, 2454192128, 2454257663, 'NO', 'NOR', 'النرويج'),
(37759, 2454257664, 2454388735, 'US', 'USA', 'الولايات المتحدة'),
(37760, 2454388736, 2454454271, 'SE', 'SWE', 'السويد'),
(37761, 2454454272, 2454519807, 'US', 'USA', 'الولايات المتحدة'),
(37762, 2454519808, 2454585343, 'GB', 'GBR', 'المملكة المتحدة'),
(37763, 2454585344, 2454716415, 'US', 'USA', 'الولايات المتحدة'),
(37764, 2454716416, 2454781951, 'GB', 'GBR', 'المملكة المتحدة'),
(37765, 2454781952, 2454847487, 'FI', 'FIN', 'فنلندا'),
(37766, 2454847488, 2454851583, 'US', 'USA', 'الولايات المتحدة'),
(37767, 2454851584, 2454851839, 'DK', 'DNK', 'الدنيمارك'),
(37768, 2454851840, 2454853119, 'US', 'USA', 'الولايات المتحدة'),
(37769, 2454853120, 2454853375, 'DK', 'DNK', 'الدنيمارك'),
(37770, 2454853376, 2454887423, 'US', 'USA', 'الولايات المتحدة'),
(37771, 2454887424, 2454887679, 'DK', 'DNK', 'الدنيمارك'),
(37772, 2454887680, 2454913023, 'US', 'USA', 'الولايات المتحدة'),
(37773, 2454913024, 2454978559, 'CL', 'CHL', 'تشيلي'),
(37774, 2454978560, 2455175167, 'US', 'USA', 'الولايات المتحدة'),
(37775, 2455175168, 2455240703, 'GB', 'GBR', 'المملكة المتحدة'),
(37776, 2455240704, 2455371775, 'US', 'USA', 'الولايات المتحدة'),
(37777, 2455437312, 2455830527, 'US', 'USA', 'الولايات المتحدة'),
(37778, 2455830528, 2455896063, 'GB', 'GBR', 'المملكة المتحدة'),
(37779, 2455896064, 2456027135, 'US', 'USA', 'الولايات المتحدة'),
(37780, 2456027136, 2456092671, 'IT', 'ITA', 'إيطاليا'),
(37781, 2456092672, 2456158207, 'GB', 'GBR', 'المملكة المتحدة'),
(37782, 2456158208, 2456223743, 'CZ', 'CZE', 'التشيك'),
(37783, 2456223744, 2456289279, 'BE', 'BEL', 'بلجيكا'),
(37784, 2456289280, 2456354815, 'NL', 'NLD', 'هولندا'),
(37785, 2456354816, 2456420351, 'GB', 'GBR', 'المملكة المتحدة'),
(37786, 2456485888, 2456551423, 'DE', 'DEU', 'ألمانيا'),
(37787, 2456551424, 2456616959, 'AT', 'AUT', 'النمسا'),
(37788, 2456616960, 2456682495, 'CH', 'CHE', 'سويسرا'),
(37789, 2456682496, 2456748031, 'HU', 'HUN', 'هنغاريا'),
(37790, 2456748032, 2456813567, 'US', 'USA', 'الولايات المتحدة'),
(37791, 2456813568, 2456879103, 'AT', 'AUT', 'النمسا'),
(37792, 2456879104, 2457075711, 'US', 'USA', 'الولايات المتحدة'),
(37793, 2457075712, 2457141247, 'AU', 'AUS', 'أستراليا'),
(37794, 2457141248, 2457206783, 'JP', 'JPN', 'اليابان'),
(37795, 2457206784, 2457272319, 'AU', 'AUS', 'أستراليا'),
(37796, 2457272320, 2457337855, 'FI', 'FIN', 'فنلندا'),
(37797, 2457403392, 2457599999, 'US', 'USA', 'الولايات المتحدة'),
(37798, 2457600000, 2457665535, 'GR', 'GRC', 'اليونان'),
(37799, 2457665536, 2458058751, 'US', 'USA', 'الولايات المتحدة'),
(37800, 2458058752, 2458124287, 'CA', 'CAN', 'كندا'),
(37801, 2458124288, 2458189823, 'US', 'USA', 'الولايات المتحدة'),
(37802, 2458189824, 2458255359, 'IT', 'ITA', 'إيطاليا'),
(37803, 2458255360, 2458320895, 'BR', 'BRA', 'البرازيل'),
(37804, 2458320896, 2458386431, 'US', 'USA', 'الولايات المتحدة'),
(37805, 2458386432, 2458451967, 'CH', 'CHE', 'سويسرا'),
(37806, 2458451968, 2458648575, 'US', 'USA', 'الولايات المتحدة'),
(37807, 2458648576, 2458714111, 'DE', 'DEU', 'ألمانيا'),
(37808, 2458779648, 2458910719, 'US', 'USA', 'الولايات المتحدة'),
(37809, 2458910720, 2458976255, 'AU', 'AUS', 'أستراليا'),
(37810, 2458976256, 2459631615, 'US', 'USA', 'الولايات المتحدة'),
(37811, 2459631616, 2459697151, 'CL', 'CHL', 'تشيلي'),
(37812, 2459697152, 2459828223, 'US', 'USA', 'الولايات المتحدة'),
(37813, 2459893760, 2459959295, 'CH', 'CHE', 'سويسرا'),
(37814, 2459959296, 2460024831, 'US', 'USA', 'الولايات المتحدة'),
(37815, 2460024832, 2460090367, 'FI', 'FIN', 'فنلندا'),
(37816, 2460090368, 2460155903, 'GB', 'GBR', 'المملكة المتحدة'),
(37817, 2460155904, 2460221439, 'US', 'USA', 'الولايات المتحدة'),
(37818, 2460221440, 2460286975, 'BR', 'BRA', 'البرازيل'),
(37819, 2460286976, 2460549119, 'US', 'USA', 'الولايات المتحدة'),
(37820, 2460549120, 2460614655, 'GB', 'GBR', 'المملكة المتحدة'),
(37821, 2460614656, 2460680191, 'US', 'USA', 'الولايات المتحدة'),
(37822, 2460680192, 2460745727, 'NZ', 'NZL', 'نيوزيلاندا'),
(37823, 2460745728, 2460811263, 'NO', 'NOR', 'النرويج'),
(37824, 2460811264, 2460876799, 'SE', 'SWE', 'السويد'),
(37825, 2460876800, 2460942335, 'US', 'USA', 'الولايات المتحدة'),
(37826, 2460942336, 2461007871, 'BE', 'BEL', 'بلجيكا'),
(37827, 2461007872, 2461138943, 'GB', 'GBR', 'المملكة المتحدة'),
(37828, 2461138944, 2461204479, 'AU', 'AUS', 'أستراليا'),
(37829, 2461204480, 2461270015, 'GB', 'GBR', 'المملكة المتحدة'),
(37830, 2461270016, 2461401087, 'US', 'USA', 'الولايات المتحدة'),
(37831, 2461466624, 2461597695, 'US', 'USA', 'الولايات المتحدة'),
(37832, 2461663232, 2461794303, 'US', 'USA', 'الولايات المتحدة'),
(37833, 2461794304, 2461859839, 'GB', 'GBR', 'المملكة المتحدة'),
(37834, 2461859840, 2461990911, 'US', 'USA', 'الولايات المتحدة'),
(37835, 2461990912, 2462056447, 'GB', 'GBR', 'المملكة المتحدة'),
(37836, 2462056448, 2462121983, 'NO', 'NOR', 'النرويج'),
(37837, 2462121984, 2462187519, 'PT', 'PRT', 'البورتوغال'),
(37838, 2462187520, 2462253055, 'GB', 'GBR', 'المملكة المتحدة'),
(37839, 2462253056, 2462384127, 'AU', 'AUS', 'أستراليا'),
(37840, 2462384128, 2463236095, 'US', 'USA', 'الولايات المتحدة'),
(37841, 2463236096, 2463301631, 'AT', 'AUT', 'النمسا'),
(37842, 2463301632, 2463367167, 'FI', 'FIN', 'فنلندا'),
(37843, 2463432704, 2463498239, 'NO', 'NOR', 'النرويج'),
(37844, 2463498240, 2463629311, 'US', 'USA', 'الولايات المتحدة'),
(37845, 2463629312, 2463694847, 'CH', 'CHE', 'سويسرا'),
(37846, 2463694848, 2463825919, 'US', 'USA', 'الولايات المتحدة'),
(37847, 2463825920, 2463891455, 'ES', 'ESP', 'إسبانيا'),
(37848, 2463891456, 2463911935, 'LU', 'LUX', 'لوكسيمبورغ'),
(37849, 2463911936, 2463916031, 'FR', 'FRA', 'فرنسا'),
(37850, 2463916032, 2463956991, 'LU', 'LUX', 'لوكسيمبورغ'),
(37851, 2463956992, 2464022527, 'AU', 'AUS', 'أستراليا'),
(37852, 2464022528, 2464153599, 'US', 'USA', 'الولايات المتحدة'),
(37853, 2464153600, 2464219135, 'NO', 'NOR', 'النرويج'),
(37854, 2464219136, 2464284671, 'US', 'USA', 'الولايات المتحدة'),
(37855, 2464284672, 2464350207, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(37856, 2464350208, 2464415743, 'GB', 'GBR', 'المملكة المتحدة'),
(37857, 2464415744, 2464481279, 'CH', 'CHE', 'سويسرا'),
(37858, 2464481280, 2464546815, 'US', 'USA', 'الولايات المتحدة'),
(37859, 2464743424, 2464808959, 'US', 'USA', 'الولايات المتحدة'),
(37860, 2464808960, 2464874495, 'DE', 'DEU', 'ألمانيا'),
(37861, 2464874496, 2465660927, 'US', 'USA', 'الولايات المتحدة'),
(37862, 2465726464, 2465791999, 'CH', 'CHE', 'سويسرا'),
(37863, 2465792000, 2465857535, 'FR', 'FRA', 'فرنسا'),
(37864, 2465857536, 2465923071, 'US', 'USA', 'الولايات المتحدة'),
(37865, 2465988608, 2466054143, 'US', 'USA', 'الولايات المتحدة'),
(37866, 2466054144, 2466119679, 'SE', 'SWE', 'السويد'),
(37867, 2466119680, 2466185215, 'DE', 'DEU', 'ألمانيا'),
(37868, 2466316288, 2466643967, 'US', 'USA', 'الولايات المتحدة'),
(37869, 2466709504, 2466775039, 'HU', 'HUN', 'هنغاريا'),
(37870, 2466775040, 2466840575, 'HK', 'HKG', 'هونغ كونغ'),
(37871, 2466840576, 2466906111, 'US', 'USA', 'الولايات المتحدة'),
(37872, 2466906112, 2466971647, 'AU', 'AUS', 'أستراليا'),
(37873, 2466971648, 2467037183, 'US', 'USA', 'الولايات المتحدة'),
(37874, 2467037184, 2467102719, 'NL', 'NLD', 'هولندا'),
(37875, 2467102720, 2467233791, 'SE', 'SWE', 'السويد'),
(37876, 2467233792, 2468020223, 'US', 'USA', 'الولايات المتحدة'),
(37877, 2468020224, 2468085759, 'GR', 'GRC', 'اليونان'),
(37878, 2468085760, 2468151295, 'JP', 'JPN', 'اليابان'),
(37879, 2468151296, 2468174847, 'DK', 'DNK', 'الدنيمارك'),
(37880, 2468174848, 2468175359, 'NO', 'NOR', 'النرويج'),
(37881, 2468175360, 2468189663, 'DK', 'DNK', 'الدنيمارك'),
(37882, 2468189664, 2468189695, 'GB', 'GBR', 'المملكة المتحدة'),
(37883, 2468189696, 2468216831, 'DK', 'DNK', 'الدنيمارك'),
(37884, 2468216832, 2468282367, 'DE', 'DEU', 'ألمانيا'),
(37885, 2468282368, 2468347903, 'US', 'USA', 'الولايات المتحدة'),
(37886, 2468347904, 2468478975, 'CZ', 'CZE', 'التشيك'),
(37887, 2468478976, 2468937727, 'US', 'USA', 'الولايات المتحدة'),
(37888, 2468937728, 2469003263, 'AU', 'AUS', 'أستراليا'),
(37889, 2469003264, 2469068799, 'US', 'USA', 'الولايات المتحدة'),
(37890, 2469068800, 2469134335, 'KR', 'KOR', 'جمهورية كوريا'),
(37891, 2469134336, 2469199871, 'SE', 'SWE', 'السويد'),
(37892, 2469199872, 2469265407, 'RU', 'RUS', 'الإتحاد الروسي'),
(37893, 2469265408, 2469396479, 'KR', 'KOR', 'جمهورية كوريا'),
(37894, 2469396480, 2469658623, 'US', 'USA', 'الولايات المتحدة'),
(37895, 2469658624, 2469724159, 'GR', 'GRC', 'اليونان'),
(37896, 2469724160, 2469789695, 'US', 'USA', 'الولايات المتحدة'),
(37897, 2469789696, 2469855231, 'DE', 'DEU', 'ألمانيا'),
(37898, 2469855232, 2470182911, 'US', 'USA', 'الولايات المتحدة'),
(37899, 2470182912, 2470248447, 'CH', 'CHE', 'سويسرا'),
(37900, 2470248448, 2470510591, 'US', 'USA', 'الولايات المتحدة'),
(37901, 2470510592, 2470576127, 'BR', 'BRA', 'البرازيل'),
(37902, 2470576128, 2470641663, 'AU', 'AUS', 'أستراليا'),
(37903, 2470641664, 2470707199, 'LU', 'LUX', 'لوكسيمبورغ'),
(37904, 2470707200, 2470772735, 'GB', 'GBR', 'المملكة المتحدة'),
(37905, 2470772736, 2470838271, 'AU', 'AUS', 'أستراليا'),
(37906, 2470838272, 2471165951, 'US', 'USA', 'الولايات المتحدة'),
(37907, 2471165952, 2471231487, 'CH', 'CHE', 'سويسرا'),
(37908, 2471231488, 2471297023, 'AU', 'AUS', 'أستراليا'),
(37909, 2471297024, 2471362559, 'GB', 'GBR', 'المملكة المتحدة'),
(37910, 2471428096, 2471690239, 'US', 'USA', 'الولايات المتحدة'),
(37911, 2471690240, 2471821311, 'ES', 'ESP', 'إسبانيا'),
(37912, 2471886848, 2472083455, 'CH', 'CHE', 'سويسرا'),
(37913, 2472083456, 2472148991, 'GB', 'GBR', 'المملكة المتحدة'),
(37914, 2472148992, 2472214527, 'US', 'USA', 'الولايات المتحدة'),
(37915, 2472214528, 2472280063, 'RS', 'SRB', 'صربيا'),
(37916, 2472280064, 2472345599, 'US', 'USA', 'الولايات المتحدة'),
(37917, 2472345600, 2472411135, 'BE', 'BEL', 'بلجيكا'),
(37918, 2472411136, 2472476671, 'FR', 'FRA', 'فرنسا'),
(37919, 2472476672, 2472542207, 'GR', 'GRC', 'اليونان'),
(37920, 2472542208, 2472607743, 'ES', 'ESP', 'إسبانيا'),
(37921, 2472607744, 2472673279, 'US', 'USA', 'الولايات المتحدة'),
(37922, 2472673280, 2472869887, 'FR', 'FRA', 'فرنسا'),
(37923, 2472869888, 2472935423, 'US', 'USA', 'الولايات المتحدة'),
(37924, 2472935424, 2473000959, 'GR', 'GRC', 'اليونان'),
(37925, 2473000960, 2473394175, 'US', 'USA', 'الولايات المتحدة'),
(37926, 2473394176, 2473459711, 'AU', 'AUS', 'أستراليا'),
(37927, 2473525248, 2473656319, 'NO', 'NOR', 'النرويج'),
(37928, 2473656320, 2474049535, 'US', 'USA', 'الولايات المتحدة'),
(37929, 2474049536, 2474115071, 'GB', 'GBR', 'المملكة المتحدة'),
(37930, 2474115072, 2474246143, 'US', 'USA', 'الولايات المتحدة'),
(37931, 2474246144, 2474377215, 'IT', 'ITA', 'إيطاليا'),
(37932, 2474377216, 2474442751, 'US', 'USA', 'الولايات المتحدة'),
(37933, 2474442752, 2474508287, 'AT', 'AUT', 'النمسا'),
(37934, 2474508288, 2474573823, 'US', 'USA', 'الولايات المتحدة'),
(37935, 2474573824, 2474639359, 'FR', 'FRA', 'فرنسا'),
(37936, 2474639360, 2474901503, 'US', 'USA', 'الولايات المتحدة'),
(37937, 2474901504, 2474967039, 'AU', 'AUS', 'أستراليا'),
(37938, 2474967040, 2475556863, 'US', 'USA', 'الولايات المتحدة'),
(37939, 2475556864, 2475622399, 'DE', 'DEU', 'ألمانيا'),
(37940, 2475622400, 2475687935, 'GB', 'GBR', 'المملكة المتحدة'),
(37941, 2475687936, 2475884543, 'US', 'USA', 'الولايات المتحدة'),
(37942, 2475884544, 2476277759, 'GB', 'GBR', 'المملكة المتحدة'),
(37943, 2476277760, 2476474367, 'US', 'USA', 'الولايات المتحدة'),
(37944, 2476474368, 2476539903, 'ES', 'ESP', 'إسبانيا'),
(37945, 2476539904, 2476605439, 'JP', 'JPN', 'اليابان'),
(37946, 2476605440, 2476670975, 'NZ', 'NZL', 'نيوزيلاندا'),
(37947, 2476670976, 2476802047, 'US', 'USA', 'الولايات المتحدة'),
(37948, 2476802048, 2476867583, 'IL', 'ISR', 'إسرائيل'),
(37949, 2476867584, 2476998655, 'IT', 'ITA', 'إيطاليا'),
(37950, 2476998656, 2477195263, 'US', 'USA', 'الولايات المتحدة'),
(37951, 2477195264, 2477260799, 'CH', 'CHE', 'سويسرا'),
(37952, 2477260800, 2477457407, 'US', 'USA', 'الولايات المتحدة'),
(37953, 2477457408, 2477522943, 'FR', 'FRA', 'فرنسا'),
(37954, 2477522944, 2477588479, 'DE', 'DEU', 'ألمانيا'),
(37955, 2477588480, 2477654015, 'FR', 'FRA', 'فرنسا'),
(37956, 2477654016, 2477719551, 'US', 'USA', 'الولايات المتحدة'),
(37957, 2477719552, 2477785087, 'SK', 'SVK', 'سلوفاكيا'),
(37958, 2477785088, 2477850623, 'JP', 'JPN', 'اليابان'),
(37959, 2477850624, 2478047231, 'US', 'USA', 'الولايات المتحدة'),
(37960, 2478047232, 2478112767, 'SE', 'SWE', 'السويد'),
(37961, 2478112768, 2478178303, 'NL', 'NLD', 'هولندا'),
(37962, 2478178304, 2478309375, 'US', 'USA', 'الولايات المتحدة'),
(37963, 2478309376, 2478374911, 'GB', 'GBR', 'المملكة المتحدة'),
(37964, 2478374912, 2478440447, 'US', 'USA', 'الولايات المتحدة'),
(37965, 2478440448, 2478505983, 'SE', 'SWE', 'السويد'),
(37966, 2478505984, 2478571519, 'US', 'USA', 'الولايات المتحدة'),
(37967, 2478571520, 2478702591, 'GB', 'GBR', 'المملكة المتحدة'),
(37968, 2478702592, 2478899199, 'US', 'USA', 'الولايات المتحدة'),
(37969, 2478899200, 2478964735, 'GB', 'GBR', 'المملكة المتحدة'),
(37970, 2479030272, 2479095807, 'US', 'USA', 'الولايات المتحدة'),
(37971, 2479095808, 2479161343, 'FR', 'FRA', 'فرنسا'),
(37972, 2479161344, 2479226879, 'GB', 'GBR', 'المملكة المتحدة'),
(37973, 2479226880, 2479357951, 'US', 'USA', 'الولايات المتحدة'),
(37974, 2479357952, 2479423487, 'AU', 'AUS', 'أستراليا'),
(37975, 2479423488, 2479489023, 'GB', 'GBR', 'المملكة المتحدة'),
(37976, 2479489024, 2479620095, 'US', 'USA', 'الولايات المتحدة'),
(37977, 2479620096, 2479685631, 'DE', 'DEU', 'ألمانيا'),
(37978, 2479685632, 2479947775, 'US', 'USA', 'الولايات المتحدة'),
(37979, 2479947776, 2480013311, 'AU', 'AUS', 'أستراليا'),
(37980, 2480013312, 2480078847, 'FR', 'FRA', 'فرنسا'),
(37981, 2480078848, 2480209919, 'AU', 'AUS', 'أستراليا'),
(37982, 2480209920, 2480275455, 'SK', 'SVK', 'سلوفاكيا'),
(37983, 2480275456, 2480340991, 'SE', 'SWE', 'السويد'),
(37984, 2480340992, 2480406527, 'FR', 'FRA', 'فرنسا'),
(37985, 2480406528, 2480668671, 'US', 'USA', 'الولايات المتحدة'),
(37986, 2480668672, 2480734207, 'SE', 'SWE', 'السويد'),
(37987, 2480734208, 2481192959, 'US', 'USA', 'الولايات المتحدة'),
(37988, 2481192960, 2481455103, 'CZ', 'CZE', 'التشيك'),
(37989, 2481455104, 2481520639, 'SK', 'SVK', 'سلوفاكيا'),
(37990, 2481520640, 2481848319, 'IL', 'ISR', 'إسرائيل'),
(37991, 2481848320, 2482175999, 'US', 'USA', 'الولايات المتحدة'),
(37992, 2482176000, 2482208767, 'FI', 'FIN', 'فنلندا'),
(37993, 2482208768, 2482216959, 'US', 'USA', 'الولايات المتحدة'),
(37994, 2482216960, 2482225151, 'FI', 'FIN', 'فنلندا'),
(37995, 2482225152, 2482233343, 'SG', 'SGP', 'سنغافورة'),
(37996, 2482233344, 2482241535, 'CN', 'CHN', 'الصين'),
(37997, 2482241536, 2482634751, 'US', 'USA', 'الولايات المتحدة'),
(37998, 2482634752, 2482700287, 'FR', 'FRA', 'فرنسا'),
(37999, 2482700288, 2482765823, 'CZ', 'CZE', 'التشيك'),
(38000, 2482765824, 2482831359, 'IE', 'IRL', 'إيرلندا'),
(38001, 2482831360, 2482962431, 'US', 'USA', 'الولايات المتحدة'),
(38002, 2483093504, 2483159039, 'US', 'USA', 'الولايات المتحدة'),
(38003, 2483159040, 2483224575, 'SE', 'SWE', 'السويد'),
(38004, 2483224576, 2483290111, 'GB', 'GBR', 'المملكة المتحدة'),
(38005, 2483290112, 2483421183, 'US', 'USA', 'الولايات المتحدة'),
(38006, 2483421184, 2483486719, 'HU', 'HUN', 'هنغاريا'),
(38007, 2483486720, 2486566911, 'US', 'USA', 'الولايات المتحدة'),
(38008, 2486566912, 2486632447, 'CH', 'CHE', 'سويسرا'),
(38009, 2486632448, 2486697983, 'US', 'USA', 'الولايات المتحدة'),
(38010, 2486697984, 2486763519, 'AT', 'AUT', 'النمسا'),
(38011, 2486763520, 2486960127, 'US', 'USA', 'الولايات المتحدة'),
(38012, 2486960128, 2487025663, 'FR', 'FRA', 'فرنسا'),
(38013, 2487025664, 2488205311, 'US', 'USA', 'الولايات المتحدة'),
(38014, 2488205312, 2488270847, 'GB', 'GBR', 'المملكة المتحدة'),
(38015, 2488270848, 2488336383, 'US', 'USA', 'الولايات المتحدة'),
(38016, 2488336384, 2488401919, 'PL', 'POL', 'بولندا'),
(38017, 2488401920, 2488532991, 'NO', 'NOR', 'النرويج'),
(38018, 2488532992, 2488795135, 'US', 'USA', 'الولايات المتحدة'),
(38019, 2488795136, 2488860671, 'GB', 'GBR', 'المملكة المتحدة'),
(38020, 2488860672, 2489647103, 'US', 'USA', 'الولايات المتحدة'),
(38021, 2489843712, 2490236927, 'US', 'USA', 'الولايات المتحدة'),
(38022, 2490236928, 2490302463, 'LU', 'LUX', 'لوكسيمبورغ'),
(38023, 2490302464, 2490695679, 'US', 'USA', 'الولايات المتحدة'),
(38024, 2490695680, 2490761215, 'CA', 'CAN', 'كندا'),
(38025, 2490761216, 2491154431, 'NO', 'NOR', 'النرويج'),
(38026, 2491154432, 2491875327, 'US', 'USA', 'الولايات المتحدة'),
(38027, 2491875328, 2492006399, 'SE', 'SWE', 'السويد'),
(38028, 2492006400, 2492071935, 'US', 'USA', 'الولايات المتحدة'),
(38029, 2492071936, 2492137471, 'SE', 'SWE', 'السويد'),
(38030, 2492137472, 2492203007, 'US', 'USA', 'الولايات المتحدة'),
(38031, 2492203008, 2492268543, 'NO', 'NOR', 'النرويج'),
(38032, 2492268544, 2492399615, 'US', 'USA', 'الولايات المتحدة'),
(38033, 2492399616, 2492465151, 'FR', 'FRA', 'فرنسا'),
(38034, 2492465152, 2492530687, 'US', 'USA', 'الولايات المتحدة'),
(38035, 2492530688, 2492596223, 'AU', 'AUS', 'أستراليا'),
(38036, 2492596224, 2492727295, 'US', 'USA', 'الولايات المتحدة'),
(38037, 2492727296, 2492792831, 'NL', 'NLD', 'هولندا'),
(38038, 2492792832, 2492923903, 'US', 'USA', 'الولايات المتحدة'),
(38039, 2492923904, 2492989439, 'OM', 'OMN', 'عمان'),
(38040, 2492989440, 2493513727, 'US', 'USA', 'الولايات المتحدة'),
(38041, 2493513728, 2493579263, 'SE', 'SWE', 'السويد'),
(38042, 2493579264, 2493644799, 'JP', 'JPN', 'اليابان'),
(38043, 2493644800, 2494103551, 'US', 'USA', 'الولايات المتحدة'),
(38044, 2494103552, 2494169087, 'FR', 'FRA', 'فرنسا'),
(38045, 2494169088, 2494562303, 'US', 'USA', 'الولايات المتحدة'),
(38046, 2494562304, 2494627839, 'GB', 'GBR', 'المملكة المتحدة'),
(38047, 2494627840, 2494889983, 'US', 'USA', 'الولايات المتحدة'),
(38048, 2494889984, 2494955519, 'GB', 'GBR', 'المملكة المتحدة'),
(38049, 2494955520, 2495021055, 'AU', 'AUS', 'أستراليا'),
(38050, 2495021056, 2495152127, 'US', 'USA', 'الولايات المتحدة'),
(38051, 2495217664, 2495283199, 'US', 'USA', 'الولايات المتحدة'),
(38052, 2495283200, 2495348735, 'CH', 'CHE', 'سويسرا'),
(38053, 2495348736, 2495807487, 'US', 'USA', 'الولايات المتحدة'),
(38054, 2495807488, 2495873023, 'AU', 'AUS', 'أستراليا'),
(38055, 2495873024, 2495938559, 'CH', 'CHE', 'سويسرا'),
(38056, 2495938560, 2496004095, 'GB', 'GBR', 'المملكة المتحدة'),
(38057, 2496004096, 2496069631, 'AT', 'AUT', 'النمسا'),
(38058, 2496069632, 2496135167, 'US', 'USA', 'الولايات المتحدة'),
(38059, 2496135168, 2496200703, 'NL', 'NLD', 'هولندا'),
(38060, 2496200704, 2497682431, 'MX', 'MEX', 'المكسيك'),
(38061, 2497682432, 2497683455, 'EC', 'ECU', 'الإكوادور'),
(38062, 2497683456, 2498464415, 'MX', 'MEX', 'المكسيك'),
(38063, 2498464416, 2498464431, 'US', 'USA', 'الولايات المتحدة'),
(38064, 2498464432, 2498475007, 'MX', 'MEX', 'المكسيك'),
(38065, 2498475008, 2498476031, 'EC', 'ECU', 'الإكوادور'),
(38066, 2498476032, 2499477503, 'MX', 'MEX', 'المكسيك'),
(38067, 2499477504, 2499543039, 'DE', 'DEU', 'ألمانيا'),
(38068, 2499543040, 2499608575, 'NL', 'NLD', 'هولندا'),
(38069, 2499608576, 2499674111, 'GB', 'GBR', 'المملكة المتحدة'),
(38070, 2499674112, 2499739647, 'US', 'USA', 'الولايات المتحدة'),
(38071, 2499870720, 2500001791, 'US', 'USA', 'الولايات المتحدة'),
(38072, 2500067328, 2501574655, 'US', 'USA', 'الولايات المتحدة'),
(38073, 2501640192, 2503016447, 'US', 'USA', 'الولايات المتحدة'),
(38074, 2503016448, 2503081983, 'IL', 'ISR', 'إسرائيل'),
(38075, 2503081984, 2503671807, 'US', 'USA', 'الولايات المتحدة'),
(38076, 2503671808, 2503737343, 'NL', 'NLD', 'هولندا'),
(38077, 2503737344, 2503868415, 'US', 'USA', 'الولايات المتحدة'),
(38078, 2503933952, 2506293247, 'US', 'USA', 'الولايات المتحدة'),
(38079, 2506293248, 2506358783, 'CA', 'CAN', 'كندا'),
(38080, 2506358784, 2508062719, 'US', 'USA', 'الولايات المتحدة'),
(38081, 2508128256, 2508455935, 'US', 'USA', 'الولايات المتحدة'),
(38082, 2508455936, 2508521471, 'IT', 'ITA', 'إيطاليا'),
(38083, 2508521472, 2508587007, 'CH', 'CHE', 'سويسرا'),
(38084, 2508587008, 2508652543, 'BE', 'BEL', 'بلجيكا'),
(38085, 2508652544, 2508718079, 'AU', 'AUS', 'أستراليا'),
(38086, 2508718080, 2508914687, 'US', 'USA', 'الولايات المتحدة'),
(38087, 2508914688, 2508980223, 'IT', 'ITA', 'إيطاليا'),
(38088, 2509045760, 2509242367, 'US', 'USA', 'الولايات المتحدة'),
(38089, 2509242368, 2509307903, 'AU', 'AUS', 'أستراليا'),
(38090, 2509307904, 2509373439, 'US', 'USA', 'الولايات المتحدة'),
(38091, 2509373440, 2509438975, 'NL', 'NLD', 'هولندا'),
(38092, 2509504512, 2509570047, 'AT', 'AUT', 'النمسا'),
(38093, 2509570048, 2509832191, 'US', 'USA', 'الولايات المتحدة'),
(38094, 2509832192, 2509897727, 'IE', 'IRL', 'إيرلندا'),
(38095, 2509963264, 2510028799, 'GB', 'GBR', 'المملكة المتحدة'),
(38096, 2510028800, 2510094335, 'PL', 'POL', 'بولندا'),
(38097, 2510094336, 2510159871, 'IE', 'IRL', 'إيرلندا'),
(38098, 2510159872, 2510749695, 'US', 'USA', 'الولايات المتحدة'),
(38099, 2510749696, 2510815231, 'AU', 'AUS', 'أستراليا'),
(38100, 2510815232, 2510946303, 'US', 'USA', 'الولايات المتحدة'),
(38101, 2510946304, 2511011839, 'GB', 'GBR', 'المملكة المتحدة'),
(38102, 2511011840, 2511077375, 'AU', 'AUS', 'أستراليا'),
(38103, 2511142912, 2511339519, 'US', 'USA', 'الولايات المتحدة'),
(38104, 2511339520, 2511405055, 'AU', 'AUS', 'أستراليا'),
(38105, 2511405056, 2512715775, 'GB', 'GBR', 'المملكة المتحدة'),
(38106, 2512715776, 2512781311, 'FI', 'FIN', 'فنلندا'),
(38107, 2512781312, 2512912383, 'US', 'USA', 'الولايات المتحدة'),
(38108, 2512977920, 2513502207, 'DE', 'DEU', 'ألمانيا'),
(38109, 2513502208, 2513567743, 'NO', 'NOR', 'النرويج'),
(38110, 2513633280, 2513698815, 'DE', 'DEU', 'ألمانيا'),
(38111, 2513698816, 2513764351, 'DK', 'DNK', 'الدنيمارك'),
(38112, 2513764352, 2514419711, 'DE', 'DEU', 'ألمانيا'),
(38113, 2514419712, 2514485247, 'GB', 'GBR', 'المملكة المتحدة'),
(38114, 2514485248, 2514514431, 'DE', 'DEU', 'ألمانيا'),
(38115, 2514514432, 2514514687, 'NL', 'NLD', 'هولندا'),
(38116, 2514514688, 2516254719, 'DE', 'DEU', 'ألمانيا'),
(38117, 2516254720, 2516320255, 'FR', 'FRA', 'فرنسا'),
(38118, 2516320256, 2516451327, 'US', 'USA', 'الولايات المتحدة'),
(38119, 2516451328, 2516516863, 'GB', 'GBR', 'المملكة المتحدة'),
(38120, 2516647936, 2523201535, 'JP', 'JPN', 'اليابان'),
(38121, 2523201536, 2523267071, 'AU', 'AUS', 'أستراليا'),
(38122, 2523267072, 2523529215, 'US', 'USA', 'الولايات المتحدة'),
(38123, 2523529216, 2523594751, 'NO', 'NOR', 'النرويج'),
(38124, 2523594752, 2523660287, 'AT', 'AUT', 'النمسا'),
(38125, 2523660288, 2524119039, 'US', 'USA', 'الولايات المتحدة'),
(38126, 2524315648, 2524512255, 'US', 'USA', 'الولايات المتحدة'),
(38127, 2524643328, 2524971007, 'US', 'USA', 'الولايات المتحدة'),
(38128, 2524971008, 2525036543, 'ES', 'ESP', 'إسبانيا'),
(38129, 2525102080, 2525233151, 'US', 'USA', 'الولايات المتحدة'),
(38130, 2525233152, 2525298687, 'SE', 'SWE', 'السويد'),
(38131, 2525298688, 2525626367, 'US', 'USA', 'الولايات المتحدة'),
(38132, 2525757440, 2525822975, 'GR', 'GRC', 'اليونان'),
(38133, 2525822976, 2526085119, 'US', 'USA', 'الولايات المتحدة'),
(38134, 2526085120, 2526216191, 'IT', 'ITA', 'إيطاليا'),
(38135, 2526216192, 2526412799, 'US', 'USA', 'الولايات المتحدة'),
(38136, 2526412800, 2526478335, 'KR', 'KOR', 'جمهورية كوريا'),
(38137, 2526478336, 2526543871, 'AU', 'AUS', 'أستراليا'),
(38138, 2526543872, 2526937087, 'US', 'USA', 'الولايات المتحدة'),
(38139, 2526937088, 2527002623, 'BE', 'BEL', 'بلجيكا'),
(38140, 2527002624, 2527133695, 'US', 'USA', 'الولايات المتحدة'),
(38141, 2527133696, 2527461375, 'BR', 'BRA', 'البرازيل'),
(38142, 2527461376, 2527920127, 'US', 'USA', 'الولايات المتحدة'),
(38143, 2527920128, 2527985663, 'AU', 'AUS', 'أستراليا'),
(38144, 2527985664, 2528051199, 'US', 'USA', 'الولايات المتحدة'),
(38145, 2528051200, 2528116735, 'FR', 'FRA', 'فرنسا'),
(38146, 2528116736, 2528247807, 'US', 'USA', 'الولايات المتحدة'),
(38147, 2528247808, 2528313343, 'IT', 'ITA', 'إيطاليا'),
(38148, 2528313344, 2528575487, 'US', 'USA', 'الولايات المتحدة'),
(38149, 2528575488, 2528641023, 'KR', 'KOR', 'جمهورية كوريا'),
(38150, 2528641024, 2528706559, 'US', 'USA', 'الولايات المتحدة'),
(38151, 2528706560, 2529034239, 'VE', 'VEN', 'فنزويلا'),
(38152, 2529034240, 2529099775, 'US', 'USA', 'الولايات المتحدة'),
(38153, 2529099776, 2529165311, 'AU', 'AUS', 'أستراليا'),
(38154, 2529165312, 2529492991, 'US', 'USA', 'الولايات المتحدة'),
(38155, 2529492992, 2529558527, 'KR', 'KOR', 'جمهورية كوريا'),
(38156, 2529558528, 2529886207, 'US', 'USA', 'الولايات المتحدة'),
(38157, 2529886208, 2529951743, 'AU', 'AUS', 'أستراليا'),
(38158, 2529951744, 2530017279, 'GB', 'GBR', 'المملكة المتحدة'),
(38159, 2530017280, 2530082815, 'CH', 'CHE', 'سويسرا'),
(38160, 2530082816, 2530148351, 'NZ', 'NZL', 'نيوزيلاندا'),
(38161, 2530148352, 2530213887, 'AU', 'AUS', 'أستراليا'),
(38162, 2530213888, 2530541567, 'US', 'USA', 'الولايات المتحدة'),
(38163, 2530541568, 2530607103, 'CH', 'CHE', 'سويسرا'),
(38164, 2530607104, 2530672639, 'ES', 'ESP', 'إسبانيا'),
(38165, 2530672640, 2530803711, 'US', 'USA', 'الولايات المتحدة'),
(38166, 2530803712, 2530869247, 'IT', 'ITA', 'إيطاليا'),
(38167, 2530869248, 2531196927, 'US', 'USA', 'الولايات المتحدة'),
(38168, 2531262464, 2531459071, 'US', 'USA', 'الولايات المتحدة'),
(38169, 2531459072, 2531524607, 'SE', 'SWE', 'السويد'),
(38170, 2531524608, 2531590143, 'US', 'USA', 'الولايات المتحدة'),
(38171, 2531590144, 2531655679, 'AU', 'AUS', 'أستراليا'),
(38172, 2531655680, 2532048895, 'US', 'USA', 'الولايات المتحدة'),
(38173, 2532048896, 2532114431, 'SE', 'SWE', 'السويد'),
(38174, 2532114432, 2532179967, 'GB', 'GBR', 'المملكة المتحدة'),
(38175, 2532179968, 2532376575, 'US', 'USA', 'الولايات المتحدة'),
(38176, 2532376576, 2532442111, 'ES', 'ESP', 'إسبانيا'),
(38177, 2532442112, 2532507647, 'FR', 'FRA', 'فرنسا'),
(38178, 2532507648, 2532573183, 'US', 'USA', 'الولايات المتحدة'),
(38179, 2532573184, 2532638719, 'ES', 'ESP', 'إسبانيا'),
(38180, 2532638720, 2533031935, 'US', 'USA', 'الولايات المتحدة'),
(38181, 2533031936, 2533097471, 'BE', 'BEL', 'بلجيكا'),
(38182, 2533097472, 2533228543, 'US', 'USA', 'الولايات المتحدة'),
(38183, 2533228544, 2533294079, 'PL', 'POL', 'بولندا'),
(38184, 2533425152, 2539978751, 'IT', 'ITA', 'إيطاليا'),
(38185, 2539978752, 2540240895, 'US', 'USA', 'الولايات المتحدة'),
(38186, 2540240896, 2540306431, 'FI', 'FIN', 'فنلندا'),
(38187, 2540306432, 2540896255, 'US', 'USA', 'الولايات المتحدة'),
(38188, 2540896256, 2540961791, 'GB', 'GBR', 'المملكة المتحدة'),
(38189, 2540961792, 2541223935, 'US', 'USA', 'الولايات المتحدة'),
(38190, 2541223936, 2541289471, 'CH', 'CHE', 'سويسرا'),
(38191, 2541289472, 2541682687, 'US', 'USA', 'الولايات المتحدة'),
(38192, 2541682688, 2541748223, 'CH', 'CHE', 'سويسرا'),
(38193, 2541748224, 2541813759, 'US', 'USA', 'الولايات المتحدة'),
(38194, 2541813760, 2541879295, 'GB', 'GBR', 'المملكة المتحدة'),
(38195, 2541879296, 2541944831, 'AU', 'AUS', 'أستراليا'),
(38196, 2541944832, 2542075903, 'US', 'USA', 'الولايات المتحدة'),
(38197, 2542075904, 2542141439, 'GB', 'GBR', 'المملكة المتحدة'),
(38198, 2542141440, 2542206975, 'US', 'USA', 'الولايات المتحدة'),
(38199, 2542272512, 2542338047, 'DE', 'DEU', 'ألمانيا'),
(38200, 2542338048, 2543583231, 'US', 'USA', 'الولايات المتحدة'),
(38201, 2543583232, 2543648767, 'SE', 'SWE', 'السويد'),
(38202, 2543648768, 2543714303, 'NO', 'NOR', 'النرويج'),
(38203, 2543714304, 2543779839, 'JP', 'JPN', 'اليابان'),
(38204, 2543779840, 2544500735, 'US', 'USA', 'الولايات المتحدة'),
(38205, 2544500736, 2544566271, 'GB', 'GBR', 'المملكة المتحدة'),
(38206, 2544566272, 2544631807, 'US', 'USA', 'الولايات المتحدة'),
(38207, 2544631808, 2544697343, 'JP', 'JPN', 'اليابان'),
(38208, 2544697344, 2544828415, 'US', 'USA', 'الولايات المتحدة'),
(38209, 2544893952, 2544959487, 'GB', 'GBR', 'المملكة المتحدة'),
(38210, 2544959488, 2545025023, 'SE', 'SWE', 'السويد'),
(38211, 2545025024, 2545090559, 'AU', 'AUS', 'أستراليا'),
(38212, 2545090560, 2545156095, 'US', 'USA', 'الولايات المتحدة'),
(38213, 2545156096, 2545221631, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(38214, 2545221632, 2545287167, 'US', 'USA', 'الولايات المتحدة'),
(38215, 2545287168, 2545352703, 'GB', 'GBR', 'المملكة المتحدة'),
(38216, 2545352704, 2545418239, 'CH', 'CHE', 'سويسرا'),
(38217, 2545418240, 2545483775, 'NL', 'NLD', 'هولندا'),
(38218, 2545483776, 2545614847, 'US', 'USA', 'الولايات المتحدة'),
(38219, 2545614848, 2545680383, 'NO', 'NOR', 'النرويج'),
(38220, 2545680384, 2545745919, 'US', 'USA', 'الولايات المتحدة'),
(38221, 2545745920, 2545811455, 'DE', 'DEU', 'ألمانيا'),
(38222, 2545811456, 2547187711, 'US', 'USA', 'الولايات المتحدة'),
(38223, 2547187712, 2547318783, 'GB', 'GBR', 'المملكة المتحدة'),
(38224, 2547318784, 2547515391, 'US', 'USA', 'الولايات المتحدة'),
(38225, 2550202368, 2554462207, 'US', 'USA', 'الولايات المتحدة'),
(38226, 2554462208, 2554527743, 'HU', 'HUN', 'هنغاريا'),
(38227, 2554527744, 2554789887, 'US', 'USA', 'الولايات المتحدة'),
(38228, 2554789888, 2554855423, 'GB', 'GBR', 'المملكة المتحدة'),
(38229, 2554855424, 2554920959, 'US', 'USA', 'الولايات المتحدة'),
(38230, 2554920960, 2554986495, 'DK', 'DNK', 'الدنيمارك'),
(38231, 2554986496, 2555052031, 'CL', 'CHL', 'تشيلي'),
(38232, 2555052032, 2555117567, 'US', 'USA', 'الولايات المتحدة'),
(38233, 2555117568, 2555183103, 'AU', 'AUS', 'أستراليا'),
(38234, 2555183104, 2555248639, 'FR', 'FRA', 'فرنسا'),
(38235, 2555248640, 2555314175, 'GB', 'GBR', 'المملكة المتحدة'),
(38236, 2555314176, 2555445247, 'US', 'USA', 'الولايات المتحدة'),
(38237, 2555445248, 2555510783, 'FR', 'FRA', 'فرنسا'),
(38238, 2555510784, 2555576319, 'US', 'USA', 'الولايات المتحدة'),
(38239, 2555576320, 2555641855, 'AU', 'AUS', 'أستراليا'),
(38240, 2555641856, 2555707391, 'BR', 'BRA', 'البرازيل'),
(38241, 2555707392, 2555903999, 'US', 'USA', 'الولايات المتحدة'),
(38242, 2555904000, 2555969535, 'CH', 'CHE', 'سويسرا'),
(38243, 2555969536, 2556035071, 'FR', 'FRA', 'فرنسا'),
(38244, 2556035072, 2556100607, 'NO', 'NOR', 'النرويج'),
(38245, 2556100608, 2556166143, 'AU', 'AUS', 'أستراليا'),
(38246, 2556166144, 2556231679, 'BR', 'BRA', 'البرازيل'),
(38247, 2556231680, 2556362751, 'NO', 'NOR', 'النرويج'),
(38248, 2556362752, 2556428287, 'DK', 'DNK', 'الدنيمارك'),
(38249, 2556428288, 2556493823, 'CH', 'CHE', 'سويسرا'),
(38250, 2556493824, 2556559359, 'US', 'USA', 'الولايات المتحدة'),
(38251, 2556559360, 2556624895, 'AU', 'AUS', 'أستراليا'),
(38252, 2556624896, 2556690431, 'KR', 'KOR', 'جمهورية كوريا'),
(38253, 2556690432, 2556755967, 'US', 'USA', 'الولايات المتحدة'),
(38254, 2556755968, 2556821503, 'HK', 'HKG', 'هونغ كونغ'),
(38255, 2556821504, 2556887039, 'SG', 'SGP', 'سنغافورة'),
(38256, 2556887040, 2557018111, 'HK', 'HKG', 'هونغ كونغ'),
(38257, 2557018112, 2557083647, 'GB', 'GBR', 'المملكة المتحدة'),
(38258, 2557542400, 2557607935, 'US', 'USA', 'الولايات المتحدة'),
(38259, 2557607936, 2557673471, 'GB', 'GBR', 'المملكة المتحدة'),
(38260, 2557673472, 2557739007, 'DK', 'DNK', 'الدنيمارك'),
(38261, 2557739008, 2557870079, 'US', 'USA', 'الولايات المتحدة'),
(38262, 2557870080, 2557935615, 'ID', 'IDN', 'إندونيسيا'),
(38263, 2557935616, 2558918655, 'US', 'USA', 'الولايات المتحدة'),
(38264, 2558918656, 2558984191, 'GB', 'GBR', 'المملكة المتحدة'),
(38265, 2558984192, 2559246335, 'US', 'USA', 'الولايات المتحدة'),
(38266, 2559246336, 2559311871, 'CL', 'CHL', 'تشيلي'),
(38267, 2559311872, 2559508479, 'US', 'USA', 'الولايات المتحدة'),
(38268, 2559508480, 2559574015, 'DE', 'DEU', 'ألمانيا'),
(38269, 2559574016, 2559770623, 'US', 'USA', 'الولايات المتحدة'),
(38270, 2559770624, 2559836159, 'AU', 'AUS', 'أستراليا'),
(38271, 2559836160, 2559901695, 'US', 'USA', 'الولايات المتحدة'),
(38272, 2559901696, 2559967231, 'KR', 'KOR', 'جمهورية كوريا'),
(38273, 2559967232, 2560032767, 'GB', 'GBR', 'المملكة المتحدة'),
(38274, 2560032768, 2560098303, 'US', 'USA', 'الولايات المتحدة'),
(38275, 2560098304, 2560163839, 'BE', 'BEL', 'بلجيكا'),
(38276, 2560163840, 2560229375, 'NZ', 'NZL', 'نيوزيلاندا'),
(38277, 2560229376, 2560360447, 'US', 'USA', 'الولايات المتحدة'),
(38278, 2560425984, 2561015807, 'US', 'USA', 'الولايات المتحدة'),
(38279, 2561671168, 2563244031, 'US', 'USA', 'الولايات المتحدة'),
(38280, 2563768320, 2564947967, 'US', 'USA', 'الولايات المتحدة'),
(38281, 2564947968, 2565013503, 'SG', 'SGP', 'سنغافورة'),
(38282, 2565013504, 2565210111, 'US', 'USA', 'الولايات المتحدة'),
(38283, 2566979584, 2567045119, 'FI', 'FIN', 'فنلندا'),
(38284, 2567045120, 2567110655, 'US', 'USA', 'الولايات المتحدة'),
(38285, 2567176192, 2567241727, 'US', 'USA', 'الولايات المتحدة'),
(38286, 2567241728, 2567307263, 'SI', 'SVN', 'سلوفينيا'),
(38287, 2567307264, 2567897087, 'US', 'USA', 'الولايات المتحدة'),
(38288, 2567897088, 2567962623, 'NO', 'NOR', 'النرويج'),
(38289, 2567962624, 2568028159, 'US', 'USA', 'الولايات المتحدة'),
(38290, 2568028160, 2568093695, 'DE', 'DEU', 'ألمانيا'),
(38291, 2568093696, 2568159231, 'US', 'USA', 'الولايات المتحدة'),
(38292, 2568159232, 2568224767, 'PL', 'POL', 'بولندا'),
(38293, 2568224768, 2568290303, 'SG', 'SGP', 'سنغافورة'),
(38294, 2568290304, 2569142271, 'US', 'USA', 'الولايات المتحدة'),
(38295, 2569404416, 2569797631, 'US', 'USA', 'الولايات المتحدة'),
(38296, 2569797632, 2569863167, 'NO', 'NOR', 'النرويج'),
(38297, 2569863168, 2569928703, 'CH', 'CHE', 'سويسرا'),
(38298, 2569928704, 2569989631, 'US', 'USA', 'الولايات المتحدة'),
(38299, 2569989632, 2569989888, 'CH', 'CHE', 'سويسرا'),
(38300, 2569989889, 2572681215, 'US', 'USA', 'الولايات المتحدة'),
(38301, 2572681216, 2572746751, 'SE', 'SWE', 'السويد'),
(38302, 2572746752, 2572943359, 'US', 'USA', 'الولايات المتحدة'),
(38303, 2572943360, 2573402111, 'DE', 'DEU', 'ألمانيا'),
(38304, 2573467648, 2573533183, 'DE', 'DEU', 'ألمانيا'),
(38305, 2573598720, 2573926399, 'US', 'USA', 'الولايات المتحدة'),
(38306, 2573926400, 2573991935, 'AU', 'AUS', 'أستراليا'),
(38307, 2573991936, 2574123007, 'CH', 'CHE', 'سويسرا'),
(38308, 2574123008, 2574188543, 'NO', 'NOR', 'النرويج'),
(38309, 2574188544, 2574254079, 'NZ', 'NZL', 'نيوزيلاندا'),
(38310, 2574254080, 2574315007, 'SE', 'SWE', 'السويد'),
(38311, 2574315008, 2574315263, 'NO', 'NOR', 'النرويج'),
(38312, 2574315264, 2574319615, 'SE', 'SWE', 'السويد'),
(38313, 2574319616, 2574647295, 'US', 'USA', 'الولايات المتحدة'),
(38314, 2583756800, 2584018943, 'US', 'USA', 'الولايات المتحدة'),
(38315, 2584018944, 2584084479, 'CA', 'CAN', 'كندا'),
(38316, 2584084480, 2584215551, 'US', 'USA', 'الولايات المتحدة'),
(38317, 2584215552, 2584281087, 'GB', 'GBR', 'المملكة المتحدة'),
(38318, 2584281088, 2584346623, 'US', 'USA', 'الولايات المتحدة'),
(38319, 2584346624, 2584412159, 'KR', 'KOR', 'جمهورية كوريا'),
(38320, 2584412160, 2584477695, 'CA', 'CAN', 'كندا'),
(38321, 2584477696, 2584608767, 'US', 'USA', 'الولايات المتحدة'),
(38322, 2584608768, 2584805375, 'CH', 'CHE', 'سويسرا'),
(38323, 2584805376, 2585001983, 'US', 'USA', 'الولايات المتحدة'),
(38324, 2585001984, 2585067519, 'CA', 'CAN', 'كندا'),
(38325, 2585067520, 2585788415, 'US', 'USA', 'الولايات المتحدة'),
(38326, 2585788416, 2585853951, 'GB', 'GBR', 'المملكة المتحدة'),
(38327, 2585853952, 2585985023, 'JP', 'JPN', 'اليابان'),
(38328, 2585985024, 2587951103, 'US', 'USA', 'الولايات المتحدة'),
(38329, 2600534016, 2600665087, 'US', 'USA', 'الولايات المتحدة'),
(38330, 2600665088, 2600730623, 'CA', 'CAN', 'كندا'),
(38331, 2600730624, 2600796159, 'NO', 'NOR', 'النرويج'),
(38332, 2600796160, 2601123839, 'US', 'USA', 'الولايات المتحدة'),
(38333, 2601123840, 2601189375, 'CA', 'CAN', 'كندا'),
(38334, 2601320448, 2601451519, 'US', 'USA', 'الولايات المتحدة'),
(38335, 2601451520, 2601517055, 'CA', 'CAN', 'كندا'),
(38336, 2601517056, 2602565631, 'US', 'USA', 'الولايات المتحدة'),
(38337, 2602565632, 2602631167, 'NZ', 'NZL', 'نيوزيلاندا'),
(38338, 2602631168, 2604007423, 'US', 'USA', 'الولايات المتحدة'),
(38339, 2604007424, 2604072959, 'ES', 'ESP', 'إسبانيا'),
(38340, 2604072960, 2604138495, 'NO', 'NOR', 'النرويج'),
(38341, 2604138496, 2604204031, 'DE', 'DEU', 'ألمانيا'),
(38342, 2604204032, 2604335103, 'US', 'USA', 'الولايات المتحدة'),
(38343, 2604335104, 2604400639, 'NZ', 'NZL', 'نيوزيلاندا'),
(38344, 2604400640, 2604466175, 'AU', 'AUS', 'أستراليا'),
(38345, 2604466176, 2604531711, 'US', 'USA', 'الولايات المتحدة'),
(38346, 2604531712, 2604597247, 'CA', 'CAN', 'كندا'),
(38347, 2604597248, 2604793855, 'US', 'USA', 'الولايات المتحدة'),
(38348, 2604793856, 2604859391, 'CH', 'CHE', 'سويسرا'),
(38349, 2604859392, 2604990463, 'US', 'USA', 'الولايات المتحدة'),
(38350, 2604990464, 2605055999, 'SG', 'SGP', 'سنغافورة'),
(38351, 2605056000, 2605121535, 'US', 'USA', 'الولايات المتحدة'),
(38352, 2605121536, 2605187071, 'AU', 'AUS', 'أستراليا'),
(38353, 2605187072, 2605252607, 'US', 'USA', 'الولايات المتحدة'),
(38354, 2605252608, 2605318143, 'AT', 'AUT', 'النمسا'),
(38355, 2605318144, 2606301183, 'US', 'USA', 'الولايات المتحدة'),
(38356, 2606366720, 2606563327, 'US', 'USA', 'الولايات المتحدة'),
(38357, 2606628864, 2607349759, 'US', 'USA', 'الولايات المتحدة'),
(38358, 2607349760, 2607415295, 'CH', 'CHE', 'سويسرا'),
(38359, 2607415296, 2609053695, 'US', 'USA', 'الولايات المتحدة'),
(38360, 2609053696, 2609119231, 'GB', 'GBR', 'المملكة المتحدة'),
(38361, 2609119232, 2609184767, 'FR', 'FRA', 'فرنسا'),
(38362, 2609184768, 2609250303, 'DE', 'DEU', 'ألمانيا'),
(38363, 2609250304, 2609381375, 'US', 'USA', 'الولايات المتحدة'),
(38364, 2609381376, 2609446911, 'GB', 'GBR', 'المملكة المتحدة'),
(38365, 2609446912, 2609512447, 'DK', 'DNK', 'الدنيمارك'),
(38366, 2609512448, 2609643519, 'US', 'USA', 'الولايات المتحدة'),
(38367, 2609643520, 2609709055, 'GB', 'GBR', 'المملكة المتحدة'),
(38368, 2609709056, 2609840127, 'US', 'USA', 'الولايات المتحدة'),
(38369, 2609840128, 2609971199, 'AU', 'AUS', 'أستراليا'),
(38370, 2609971200, 2610036735, 'GB', 'GBR', 'المملكة المتحدة'),
(38371, 2610036736, 2610823167, 'US', 'USA', 'الولايات المتحدة'),
(38372, 2610823168, 2610888703, 'PL', 'POL', 'بولندا'),
(38373, 2610954240, 2611019775, 'JP', 'JPN', 'اليابان'),
(38374, 2611019776, 2612592639, 'US', 'USA', 'الولايات المتحدة'),
(38375, 2612592640, 2612658175, 'IT', 'ITA', 'إيطاليا'),
(38376, 2612658176, 2612723711, 'US', 'USA', 'الولايات المتحدة'),
(38377, 2612723712, 2612789247, 'AU', 'AUS', 'أستراليا'),
(38378, 2612789248, 2613051391, 'US', 'USA', 'الولايات المتحدة'),
(38379, 2613051392, 2613116927, 'GB', 'GBR', 'المملكة المتحدة'),
(38380, 2613116928, 2613182463, 'US', 'USA', 'الولايات المتحدة'),
(38381, 2613182464, 2613247999, 'CA', 'CAN', 'كندا'),
(38382, 2613248000, 2613313535, 'US', 'USA', 'الولايات المتحدة'),
(38383, 2613379072, 2613444607, 'US', 'USA', 'الولايات المتحدة'),
(38384, 2613444608, 2613510143, 'GB', 'GBR', 'المملكة المتحدة'),
(38385, 2613510144, 2613706751, 'US', 'USA', 'الولايات المتحدة'),
(38386, 2613706752, 2613772287, 'GB', 'GBR', 'المملكة المتحدة'),
(38387, 2613772288, 2613837823, 'US', 'USA', 'الولايات المتحدة'),
(38388, 2613837824, 2613903359, 'NL', 'NLD', 'هولندا'),
(38389, 2613903360, 2613968895, 'AU', 'AUS', 'أستراليا'),
(38390, 2613968896, 2614034431, 'US', 'USA', 'الولايات المتحدة'),
(38391, 2614034432, 2614099967, 'GR', 'GRC', 'اليونان'),
(38392, 2614099968, 2614165503, 'US', 'USA', 'الولايات المتحدة'),
(38393, 2614165504, 2614231039, 'NO', 'NOR', 'النرويج'),
(38394, 2614231040, 2614296575, 'ES', 'ESP', 'إسبانيا'),
(38395, 2614296576, 2614362111, 'BR', 'BRA', 'البرازيل'),
(38396, 2614362112, 2615083007, 'US', 'USA', 'الولايات المتحدة'),
(38397, 2615083008, 2615148543, 'TR', 'TUR', 'تركيا'),
(38398, 2615148544, 2615345151, 'US', 'USA', 'الولايات المتحدة'),
(38399, 2615345152, 2615410687, 'NO', 'NOR', 'النرويج'),
(38400, 2615410688, 2615476223, 'CH', 'CHE', 'سويسرا'),
(38401, 2615476224, 2615541759, 'US', 'USA', 'الولايات المتحدة'),
(38402, 2615541760, 2615607295, 'KR', 'KOR', 'جمهورية كوريا'),
(38403, 2615607296, 2615672831, 'GB', 'GBR', 'المملكة المتحدة'),
(38404, 2616262656, 2616524799, 'US', 'USA', 'الولايات المتحدة'),
(38405, 2616524800, 2616590335, 'GB', 'GBR', 'المملكة المتحدة'),
(38406, 2616590336, 2616786943, 'US', 'USA', 'الولايات المتحدة'),
(38407, 2616786944, 2616852479, 'GB', 'GBR', 'المملكة المتحدة'),
(38408, 2616852480, 2616918015, 'DE', 'DEU', 'ألمانيا'),
(38409, 2616983552, 2617049087, 'US', 'USA', 'الولايات المتحدة'),
(38410, 2617049088, 2617114623, 'IT', 'ITA', 'إيطاليا'),
(38411, 2617114880, 2617115135, 'US', 'USA', 'الولايات المتحدة'),
(38412, 2617147392, 2617148159, 'US', 'USA', 'الولايات المتحدة'),
(38413, 2617311232, 2617769983, 'US', 'USA', 'الولايات المتحدة'),
(38414, 2617835520, 2617901055, 'US', 'USA', 'الولايات المتحدة'),
(38415, 2617901056, 2617966591, 'FI', 'FIN', 'فنلندا'),
(38416, 2617966592, 2618032127, 'CA', 'CAN', 'كندا'),
(38417, 2618032128, 2618097663, 'US', 'USA', 'الولايات المتحدة'),
(38418, 2618097664, 2618163199, 'NZ', 'NZL', 'نيوزيلاندا'),
(38419, 2618163200, 2618228735, 'IT', 'ITA', 'إيطاليا'),
(38420, 2618228736, 2618294271, 'US', 'USA', 'الولايات المتحدة'),
(38421, 2618294272, 2618359807, 'AU', 'AUS', 'أستراليا'),
(38422, 2618359808, 2618425343, 'PL', 'POL', 'بولندا'),
(38423, 2618425344, 2618490879, 'FR', 'FRA', 'فرنسا'),
(38424, 2618490880, 2618687487, 'US', 'USA', 'الولايات المتحدة'),
(38425, 2618687488, 2618753023, 'AU', 'AUS', 'أستراليا'),
(38426, 2618753024, 2618884095, 'US', 'USA', 'الولايات المتحدة'),
(38427, 2618884096, 2618949631, 'CH', 'CHE', 'سويسرا'),
(38428, 2618949632, 2619080703, 'US', 'USA', 'الولايات المتحدة'),
(38429, 2619080704, 2619146239, 'FR', 'FRA', 'فرنسا'),
(38430, 2619146240, 2619277311, 'US', 'USA', 'الولايات المتحدة'),
(38431, 2619277312, 2619342847, 'BN', 'BRN', 'بروناي دار السلام'),
(38432, 2619342848, 2619473919, 'US', 'USA', 'الولايات المتحدة'),
(38433, 2619473920, 2619539455, 'CA', 'CAN', 'كندا'),
(38434, 2619539456, 2619604991, 'ES', 'ESP', 'إسبانيا'),
(38435, 2619604992, 2619736063, 'US', 'USA', 'الولايات المتحدة'),
(38436, 2619801600, 2620063743, 'US', 'USA', 'الولايات المتحدة'),
(38437, 2620063744, 2620129279, 'GB', 'GBR', 'المملكة المتحدة'),
(38438, 2620129280, 2620194815, 'CA', 'CAN', 'كندا'),
(38439, 2620194816, 2620391423, 'US', 'USA', 'الولايات المتحدة'),
(38440, 2620391424, 2620456959, 'GB', 'GBR', 'المملكة المتحدة'),
(38441, 2620456960, 2620522495, 'SE', 'SWE', 'السويد'),
(38442, 2620522496, 2620588031, 'AU', 'AUS', 'أستراليا'),
(38443, 2620588032, 2620653567, 'SE', 'SWE', 'السويد'),
(38444, 2620653568, 2620719103, 'NO', 'NOR', 'النرويج'),
(38445, 2620719104, 2620784639, 'US', 'USA', 'الولايات المتحدة'),
(38446, 2620784640, 2620850175, 'IT', 'ITA', 'إيطاليا'),
(38447, 2620850176, 2620981247, 'US', 'USA', 'الولايات المتحدة'),
(38448, 2620981248, 2621046783, 'CA', 'CAN', 'كندا'),
(38449, 2621046784, 2621112319, 'AT', 'AUT', 'النمسا'),
(38450, 2621112320, 2621177855, 'NZ', 'NZL', 'نيوزيلاندا'),
(38451, 2621177856, 2621243391, 'US', 'USA', 'الولايات المتحدة'),
(38452, 2621243392, 2621308927, 'GB', 'GBR', 'المملكة المتحدة'),
(38453, 2621308928, 2621374463, 'NZ', 'NZL', 'نيوزيلاندا'),
(38454, 2621374464, 2621636607, 'US', 'USA', 'الولايات المتحدة'),
(38455, 2621636608, 2621702143, 'DE', 'DEU', 'ألمانيا'),
(38456, 2621702144, 2621767679, 'US', 'USA', 'الولايات المتحدة'),
(38457, 2621767680, 2621833215, 'NZ', 'NZL', 'نيوزيلاندا'),
(38458, 2621833216, 2622423039, 'US', 'USA', 'الولايات المتحدة'),
(38459, 2622423040, 2622488575, 'CA', 'CAN', 'كندا'),
(38460, 2622488576, 2622685183, 'US', 'USA', 'الولايات المتحدة'),
(38461, 2622685184, 2622750719, 'NL', 'NLD', 'هولندا'),
(38462, 2622750720, 2623602687, 'US', 'USA', 'الولايات المتحدة'),
(38463, 2623602688, 2623668223, 'CL', 'CHL', 'تشيلي'),
(38464, 2623668224, 2624192511, 'US', 'USA', 'الولايات المتحدة'),
(38465, 2624192512, 2624258047, 'CH', 'CHE', 'سويسرا'),
(38466, 2624258048, 2624716799, 'US', 'USA', 'الولايات المتحدة'),
(38467, 2624716800, 2624782335, 'NL', 'NLD', 'هولندا'),
(38468, 2624782336, 2624847871, 'CH', 'CHE', 'سويسرا'),
(38469, 2624847872, 2624913407, 'NO', 'NOR', 'النرويج'),
(38470, 2624913408, 2624978943, 'US', 'USA', 'الولايات المتحدة'),
(38471, 2624978944, 2625044479, 'FR', 'FRA', 'فرنسا'),
(38472, 2625044480, 2625961983, 'US', 'USA', 'الولايات المتحدة'),
(38473, 2625961984, 2626027519, 'LU', 'LUX', 'لوكسيمبورغ'),
(38474, 2626027520, 2626093055, 'US', 'USA', 'الولايات المتحدة'),
(38475, 2626093056, 2626158591, 'CH', 'CHE', 'سويسرا'),
(38476, 2626158592, 2626879487, 'US', 'USA', 'الولايات المتحدة'),
(38477, 2626879488, 2626945023, 'KR', 'KOR', 'جمهورية كوريا'),
(38478, 2626945024, 2627010559, 'IT', 'ITA', 'إيطاليا'),
(38479, 2627010560, 2627076095, 'NZ', 'NZL', 'نيوزيلاندا'),
(38480, 2627076096, 2627141631, 'NL', 'NLD', 'هولندا'),
(38481, 2627141632, 2627403775, 'US', 'USA', 'الولايات المتحدة'),
(38482, 2634088448, 2635202559, 'JP', 'JPN', 'اليابان'),
(38483, 2635268096, 2635333631, 'JP', 'JPN', 'اليابان'),
(38484, 2635399168, 2635530239, 'US', 'USA', 'الولايات المتحدة'),
(38485, 2635530240, 2635595775, 'FR', 'FRA', 'فرنسا'),
(38486, 2635595776, 2635661311, 'FI', 'FIN', 'فنلندا'),
(38487, 2635661312, 2635726847, 'PL', 'POL', 'بولندا'),
(38488, 2635726848, 2635792383, 'CH', 'CHE', 'سويسرا'),
(38489, 2635792384, 2635988991, 'IT', 'ITA', 'إيطاليا'),
(38490, 2635988992, 2638020607, 'US', 'USA', 'الولايات المتحدة'),
(38491, 2638086144, 2638151679, 'US', 'USA', 'الولايات المتحدة'),
(38492, 2638151680, 2639462399, 'JP', 'JPN', 'اليابان'),
(38493, 2639462400, 2639593471, 'GB', 'GBR', 'المملكة المتحدة'),
(38494, 2639593472, 2639659007, 'AU', 'AUS', 'أستراليا'),
(38495, 2639659008, 2639724543, 'BR', 'BRA', 'البرازيل'),
(38496, 2639724544, 2639790079, 'US', 'USA', 'الولايات المتحدة'),
(38497, 2639790080, 2639855615, 'ES', 'ESP', 'إسبانيا'),
(38498, 2639855616, 2640052223, 'US', 'USA', 'الولايات المتحدة'),
(38499, 2640052224, 2640117759, 'AR', 'ARG', 'الأرجنتين'),
(38500, 2640117760, 2640183295, 'US', 'USA', 'الولايات المتحدة'),
(38501, 2640183296, 2640248831, 'FI', 'FIN', 'فنلندا'),
(38502, 2640248832, 2640314367, 'US', 'USA', 'الولايات المتحدة'),
(38503, 2640314368, 2640379903, 'SE', 'SWE', 'السويد'),
(38504, 2640379904, 2640445439, 'CA', 'CAN', 'كندا'),
(38505, 2640445440, 2640510975, 'US', 'USA', 'الولايات المتحدة'),
(38506, 2640510976, 2640576511, 'FR', 'FRA', 'فرنسا'),
(38507, 2640576512, 2640642047, 'EC', 'ECU', 'الإكوادور'),
(38508, 2640642048, 2641821695, 'JP', 'JPN', 'اليابان'),
(38509, 2641887232, 2641952767, 'JP', 'JPN', 'اليابان'),
(38510, 2641952768, 2642018303, 'US', 'USA', 'الولايات المتحدة'),
(38511, 2642083840, 2642149375, 'US', 'USA', 'الولايات المتحدة'),
(38512, 2642149376, 2642214911, 'FI', 'FIN', 'فنلندا'),
(38513, 2642214912, 2642280447, 'SE', 'SWE', 'السويد'),
(38514, 2642280448, 2642411519, 'US', 'USA', 'الولايات المتحدة'),
(38515, 2642411520, 2642477055, 'AU', 'AUS', 'أستراليا'),
(38516, 2642477056, 2642542591, 'FI', 'FIN', 'فنلندا'),
(38517, 2642542592, 2642935807, 'US', 'USA', 'الولايات المتحدة'),
(38518, 2642935808, 2643001343, 'FR', 'FRA', 'فرنسا'),
(38519, 2643001344, 2643066879, 'US', 'USA', 'الولايات المتحدة'),
(38520, 2643066880, 2643132415, 'IT', 'ITA', 'إيطاليا'),
(38521, 2643132416, 2643197951, 'US', 'USA', 'الولايات المتحدة'),
(38522, 2643197952, 2643263487, 'GB', 'GBR', 'المملكة المتحدة'),
(38523, 2643263488, 2643460095, 'US', 'USA', 'الولايات المتحدة'),
(38524, 2643460096, 2643525631, 'FI', 'FIN', 'فنلندا'),
(38525, 2643525632, 2643722239, 'US', 'USA', 'الولايات المتحدة'),
(38526, 2643787776, 2644180991, 'US', 'USA', 'الولايات المتحدة'),
(38527, 2644180992, 2644246527, 'AU', 'AUS', 'أستراليا'),
(38528, 2644312064, 2644377599, 'IS', 'ISL', 'أيسلندا'),
(38529, 2644377600, 2644443135, 'PL', 'POL', 'بولندا'),
(38530, 2644443136, 2644508671, 'FR', 'FRA', 'فرنسا'),
(38531, 2644508672, 2644574207, 'US', 'USA', 'الولايات المتحدة'),
(38532, 2644574208, 2644639743, 'CH', 'CHE', 'سويسرا'),
(38533, 2644639744, 2644770815, 'DE', 'DEU', 'ألمانيا'),
(38534, 2644770816, 2644836351, 'BE', 'BEL', 'بلجيكا'),
(38535, 2644836352, 2644967423, 'US', 'USA', 'الولايات المتحدة'),
(38536, 2644967424, 2645098495, 'AT', 'AUT', 'النمسا'),
(38537, 2645098496, 2645164031, 'FR', 'FRA', 'فرنسا'),
(38538, 2645164032, 2645229567, 'US', 'USA', 'الولايات المتحدة'),
(38539, 2645229568, 2645295103, 'SE', 'SWE', 'السويد'),
(38540, 2645295104, 2645360639, 'FR', 'FRA', 'فرنسا'),
(38541, 2645360640, 2645426175, 'GB', 'GBR', 'المملكة المتحدة'),
(38542, 2645426176, 2645622783, 'US', 'USA', 'الولايات المتحدة'),
(38543, 2645622784, 2645688319, 'AT', 'AUT', 'النمسا'),
(38544, 2645688320, 2645753855, 'US', 'USA', 'الولايات المتحدة'),
(38545, 2645753856, 2645819391, 'TH', 'THA', 'تايلند'),
(38546, 2645819392, 2645884927, 'SE', 'SWE', 'السويد'),
(38547, 2645884928, 2645950463, 'HU', 'HUN', 'هنغاريا'),
(38548, 2645950464, 2646212607, 'US', 'USA', 'الولايات المتحدة'),
(38549, 2646212608, 2646278143, 'RU', 'RUS', 'الإتحاد الروسي'),
(38550, 2646278144, 2646474751, 'US', 'USA', 'الولايات المتحدة'),
(38551, 2646474752, 2646540287, 'IE', 'IRL', 'إيرلندا'),
(38552, 2646540288, 2646605823, 'US', 'USA', 'الولايات المتحدة'),
(38553, 2646605824, 2646671359, 'JP', 'JPN', 'اليابان'),
(38554, 2646671360, 2646736895, 'BE', 'BEL', 'بلجيكا'),
(38555, 2646736896, 2646933503, 'US', 'USA', 'الولايات المتحدة'),
(38556, 2646933504, 2646999039, 'KR', 'KOR', 'جمهورية كوريا'),
(38557, 2646999040, 2647130111, 'US', 'USA', 'الولايات المتحدة'),
(38558, 2647130112, 2647195647, 'FI', 'FIN', 'فنلندا'),
(38559, 2647195648, 2647326719, 'US', 'USA', 'الولايات المتحدة'),
(38560, 2647326720, 2647392255, 'GB', 'GBR', 'المملكة المتحدة'),
(38561, 2647392256, 2647457791, 'US', 'USA', 'الولايات المتحدة'),
(38562, 2647457792, 2647523327, 'JP', 'JPN', 'اليابان'),
(38563, 2647523328, 2647851007, 'US', 'USA', 'الولايات المتحدة'),
(38564, 2647851008, 2647916543, 'AU', 'AUS', 'أستراليا'),
(38565, 2647916544, 2648899583, 'US', 'USA', 'الولايات المتحدة'),
(38566, 2648899584, 2648965119, 'IN', 'IND', 'الهند'),
(38567, 2648965120, 2649030655, 'GB', 'GBR', 'المملكة المتحدة'),
(38568, 2649030656, 2649489407, 'US', 'USA', 'الولايات المتحدة'),
(38569, 2649489408, 2649554943, 'GB', 'GBR', 'المملكة المتحدة'),
(38570, 2649554944, 2649620479, 'NO', 'NOR', 'النرويج'),
(38571, 2649620480, 2649948159, 'US', 'USA', 'الولايات المتحدة'),
(38572, 2649948160, 2650013695, 'FR', 'FRA', 'فرنسا'),
(38573, 2650013696, 2650079231, 'CA', 'CAN', 'كندا'),
(38574, 2650079232, 2650210303, 'US', 'USA', 'الولايات المتحدة'),
(38575, 2650210304, 2650275839, 'AT', 'AUT', 'النمسا'),
(38576, 2650275840, 2650341375, 'US', 'USA', 'الولايات المتحدة'),
(38577, 2650341376, 2650406911, 'NO', 'NOR', 'النرويج'),
(38578, 2650406912, 2650603519, 'US', 'USA', 'الولايات المتحدة'),
(38579, 2650603520, 2650669055, 'CO', 'COL', 'كولومبيا'),
(38580, 2650669056, 2650734591, 'US', 'USA', 'الولايات المتحدة'),
(38581, 2650800128, 2653159423, 'US', 'USA', 'الولايات المتحدة'),
(38582, 2653159424, 2653421567, 'NO', 'NOR', 'النرويج'),
(38583, 2653421568, 2653487103, 'AU', 'AUS', 'أستراليا'),
(38584, 2653487104, 2653552639, 'GB', 'GBR', 'المملكة المتحدة'),
(38585, 2653552640, 2653618175, 'ES', 'ESP', 'إسبانيا'),
(38586, 2653618176, 2653683711, 'GB', 'GBR', 'المملكة المتحدة'),
(38587, 2653683712, 2653749247, 'KR', 'KOR', 'جمهورية كوريا'),
(38588, 2653749248, 2653814783, 'AU', 'AUS', 'أستراليا'),
(38589, 2653880320, 2653945855, 'IT', 'ITA', 'إيطاليا'),
(38590, 2653945856, 2654011391, 'US', 'USA', 'الولايات المتحدة'),
(38591, 2654011392, 2654076927, 'ES', 'ESP', 'إسبانيا'),
(38592, 2654076928, 2654142463, 'FR', 'FRA', 'فرنسا'),
(38593, 2654142464, 2654207999, 'CA', 'CAN', 'كندا'),
(38594, 2654208000, 2654339071, 'US', 'USA', 'الولايات المتحدة'),
(38595, 2654339072, 2654404607, 'AU', 'AUS', 'أستراليا'),
(38596, 2654404608, 2654601215, 'US', 'USA', 'الولايات المتحدة'),
(38597, 2654666752, 2654994431, 'US', 'USA', 'الولايات المتحدة'),
(38598, 2654994432, 2655059967, 'LU', 'LUX', 'لوكسيمبورغ'),
(38599, 2655059968, 2655125503, 'US', 'USA', 'الولايات المتحدة'),
(38600, 2655185152, 2655186944, 'PL', 'POL', 'بولندا'),
(38601, 2655256576, 2655715327, 'US', 'USA', 'الولايات المتحدة'),
(38602, 2655715328, 2655780863, 'PL', 'POL', 'بولندا'),
(38603, 2655780864, 2656632831, 'US', 'USA', 'الولايات المتحدة'),
(38604, 2656632832, 2656698367, 'AU', 'AUS', 'أستراليا'),
(38605, 2656698368, 2656763903, 'FI', 'FIN', 'فنلندا'),
(38606, 2656763904, 2656829439, 'US', 'USA', 'الولايات المتحدة'),
(38607, 2656829440, 2656894975, 'SE', 'SWE', 'السويد'),
(38608, 2656894976, 2656960511, 'US', 'USA', 'الولايات المتحدة'),
(38609, 2656960512, 2657026047, 'GB', 'GBR', 'المملكة المتحدة'),
(38610, 2657026048, 2657157119, 'US', 'USA', 'الولايات المتحدة'),
(38611, 2657157120, 2657222655, 'MX', 'MEX', 'المكسيك'),
(38612, 2657222656, 2657288191, 'US', 'USA', 'الولايات المتحدة'),
(38613, 2657288192, 2657353727, 'ES', 'ESP', 'إسبانيا'),
(38614, 2657353728, 2657484799, 'US', 'USA', 'الولايات المتحدة'),
(38615, 2657484800, 2657550335, 'IT', 'ITA', 'إيطاليا'),
(38616, 2657550336, 2657681407, 'US', 'USA', 'الولايات المتحدة'),
(38617, 2657681408, 2657746943, 'SE', 'SWE', 'السويد'),
(38618, 2657746944, 2657878015, 'US', 'USA', 'الولايات المتحدة'),
(38619, 2657878016, 2657943551, 'TH', 'THA', 'تايلند'),
(38620, 2657943552, 2658009087, 'ES', 'ESP', 'إسبانيا'),
(38621, 2658009088, 2658074623, 'IT', 'ITA', 'إيطاليا'),
(38622, 2658074624, 2658140159, 'US', 'USA', 'الولايات المتحدة'),
(38623, 2658140160, 2658205695, 'NO', 'NOR', 'النرويج'),
(38624, 2658205696, 2658598911, 'US', 'USA', 'الولايات المتحدة'),
(38625, 2658598912, 2658664447, 'GB', 'GBR', 'المملكة المتحدة'),
(38626, 2658664448, 2658926591, 'US', 'USA', 'الولايات المتحدة'),
(38627, 2658926592, 2659057663, 'GB', 'GBR', 'المملكة المتحدة'),
(38628, 2659057664, 2659123199, 'SE', 'SWE', 'السويد'),
(38629, 2659123200, 2659188735, 'FI', 'FIN', 'فنلندا'),
(38630, 2659188736, 2659254271, 'CA', 'CAN', 'كندا'),
(38631, 2659254272, 2659319807, 'LT', 'LTU', 'ليتوانيا'),
(38632, 2659319808, 2659385343, 'US', 'USA', 'الولايات المتحدة'),
(38633, 2659385344, 2659450879, 'FI', 'FIN', 'فنلندا'),
(38634, 2659450880, 2659516415, 'HK', 'HKG', 'هونغ كونغ'),
(38635, 2659516416, 2659581951, 'CH', 'CHE', 'سويسرا'),
(38636, 2659581952, 2660040703, 'US', 'USA', 'الولايات المتحدة'),
(38637, 2660040704, 2660106239, 'CA', 'CAN', 'كندا'),
(38638, 2660106240, 2660171775, 'US', 'USA', 'الولايات المتحدة'),
(38639, 2660171776, 2660237311, 'GB', 'GBR', 'المملكة المتحدة'),
(38640, 2660237312, 2660302847, 'IN', 'IND', 'الهند'),
(38641, 2660302848, 2660499455, 'US', 'USA', 'الولايات المتحدة'),
(38642, 2660564992, 2660696063, 'NO', 'NOR', 'النرويج'),
(38643, 2660696064, 2660761599, 'US', 'USA', 'الولايات المتحدة'),
(38644, 2660761600, 2660827135, 'GB', 'GBR', 'المملكة المتحدة'),
(38645, 2660827136, 2661023743, 'US', 'USA', 'الولايات المتحدة'),
(38646, 2661023744, 2661089279, 'FR', 'FRA', 'فرنسا'),
(38647, 2661089280, 2661285887, 'US', 'USA', 'الولايات المتحدة'),
(38648, 2661285888, 2661351423, 'VE', 'VEN', 'فنزويلا'),
(38649, 2661351424, 2661416959, 'BN', 'BRN', 'بروناي دار السلام'),
(38650, 2661416960, 2661482495, 'PT', 'PRT', 'البورتوغال'),
(38651, 2661482496, 2661548031, 'CA', 'CAN', 'كندا'),
(38652, 2661548032, 2661679103, 'US', 'USA', 'الولايات المتحدة'),
(38653, 2661679104, 2661941247, 'LU', 'LUX', 'لوكسيمبورغ'),
(38654, 2661941248, 2662006783, 'CL', 'CHL', 'تشيلي'),
(38655, 2662006784, 2662072319, 'US', 'USA', 'الولايات المتحدة'),
(38656, 2662072320, 2662137855, 'ES', 'ESP', 'إسبانيا'),
(38657, 2662137856, 2662203391, 'SE', 'SWE', 'السويد'),
(38658, 2662203392, 2662662143, 'GB', 'GBR', 'المملكة المتحدة'),
(38659, 2662727680, 2662793215, 'HK', 'HKG', 'هونغ كونغ'),
(38660, 2662793216, 2663251967, 'US', 'USA', 'الولايات المتحدة'),
(38661, 2663251968, 2663448575, 'FR', 'FRA', 'فرنسا'),
(38662, 2663448576, 2663514111, 'SK', 'SVK', 'سلوفاكيا'),
(38663, 2663514112, 2663579647, 'CZ', 'CZE', 'التشيك'),
(38664, 2663579648, 2663645183, 'SK', 'SVK', 'سلوفاكيا'),
(38665, 2663645184, 2663710719, 'CZ', 'CZE', 'التشيك'),
(38666, 2663710720, 2663776255, 'SK', 'SVK', 'سلوفاكيا'),
(38667, 2663776256, 2664955903, 'JP', 'JPN', 'اليابان'),
(38668, 2664955904, 2665021439, 'CH', 'CHE', 'سويسرا'),
(38669, 2665021440, 2665086975, 'JP', 'JPN', 'اليابان'),
(38670, 2665086976, 2665152511, 'GB', 'GBR', 'المملكة المتحدة'),
(38671, 2665152512, 2665218047, 'US', 'USA', 'الولايات المتحدة'),
(38672, 2665218048, 2665283583, 'CH', 'CHE', 'سويسرا'),
(38673, 2665283584, 2665349119, 'US', 'USA', 'الولايات المتحدة'),
(38674, 2665359872, 2665361407, 'US', 'USA', 'الولايات المتحدة'),
(38675, 2665374720, 2665375231, 'US', 'USA', 'الولايات المتحدة'),
(38676, 2665414656, 2665480191, 'GB', 'GBR', 'المملكة المتحدة'),
(38677, 2665480192, 2665545727, 'US', 'USA', 'الولايات المتحدة'),
(38678, 2665545728, 2665611263, 'DE', 'DEU', 'ألمانيا'),
(38679, 2665611264, 2665676799, 'CH', 'CHE', 'سويسرا'),
(38680, 2665676800, 2665742335, 'ES', 'ESP', 'إسبانيا'),
(38681, 2665742336, 2665873407, 'US', 'USA', 'الولايات المتحدة'),
(38682, 2665873408, 2665938943, 'GB', 'GBR', 'المملكة المتحدة'),
(38683, 2665938944, 2666004479, 'FR', 'FRA', 'فرنسا'),
(38684, 2666004480, 2666070015, 'CH', 'CHE', 'سويسرا'),
(38685, 2666070016, 2666135551, 'FI', 'FIN', 'فنلندا'),
(38686, 2666135552, 2666201087, 'GB', 'GBR', 'المملكة المتحدة'),
(38687, 2666201088, 2667053055, 'US', 'USA', 'الولايات المتحدة'),
(38688, 2667053056, 2667118591, 'SE', 'SWE', 'السويد'),
(38689, 2667118592, 2667184127, 'HU', 'HUN', 'هنغاريا'),
(38690, 2667184128, 2667249663, 'RU', 'RUS', 'الإتحاد الروسي'),
(38691, 2667249664, 2667315199, 'CL', 'CHL', 'تشيلي'),
(38692, 2667315200, 2667511807, 'US', 'USA', 'الولايات المتحدة'),
(38693, 2667642880, 2667970559, 'US', 'USA', 'الولايات المتحدة'),
(38694, 2667970560, 2668036095, 'CA', 'CAN', 'كندا'),
(38695, 2668036096, 2668101631, 'SE', 'SWE', 'السويد'),
(38696, 2668101632, 2668167167, 'CH', 'CHE', 'سويسرا'),
(38697, 2668167168, 2668363775, 'US', 'USA', 'الولايات المتحدة'),
(38698, 2668363776, 2668429311, 'CH', 'CHE', 'سويسرا'),
(38699, 2668429312, 2668494847, 'AU', 'AUS', 'أستراليا'),
(38700, 2668494848, 2668560383, 'US', 'USA', 'الولايات المتحدة'),
(38701, 2668560384, 2668625919, 'GB', 'GBR', 'المملكة المتحدة'),
(38702, 2668625920, 2668691455, 'MX', 'MEX', 'المكسيك'),
(38703, 2668691456, 2668756991, 'US', 'USA', 'الولايات المتحدة'),
(38704, 2668756992, 2668822527, 'CA', 'CAN', 'كندا'),
(38705, 2668822528, 2668888063, 'US', 'USA', 'الولايات المتحدة'),
(38706, 2668953600, 2669019135, 'US', 'USA', 'الولايات المتحدة'),
(38707, 2669019136, 2669084671, 'CH', 'CHE', 'سويسرا'),
(38708, 2669084672, 2669150207, 'ES', 'ESP', 'إسبانيا'),
(38709, 2669150208, 2669215743, 'US', 'USA', 'الولايات المتحدة'),
(38710, 2669215744, 2669281279, 'DE', 'DEU', 'ألمانيا'),
(38711, 2669281280, 2669477887, 'US', 'USA', 'الولايات المتحدة'),
(38712, 2669477888, 2669543423, 'CH', 'CHE', 'سويسرا'),
(38713, 2669543424, 2669608959, 'GB', 'GBR', 'المملكة المتحدة'),
(38714, 2669608960, 2669674495, 'FR', 'FRA', 'فرنسا'),
(38715, 2669674496, 2669805567, 'CA', 'CAN', 'كندا'),
(38716, 2669805568, 2669871103, 'GB', 'GBR', 'المملكة المتحدة'),
(38717, 2669871104, 2670067711, 'US', 'USA', 'الولايات المتحدة'),
(38718, 2670067712, 2670133247, 'SE', 'SWE', 'السويد'),
(38719, 2670133248, 2670591999, 'US', 'USA', 'الولايات المتحدة'),
(38720, 2670592000, 2670657535, 'NL', 'NLD', 'هولندا'),
(38721, 2670657536, 2670854143, 'US', 'USA', 'الولايات المتحدة'),
(38722, 2670854144, 2670919679, 'FR', 'FRA', 'فرنسا'),
(38723, 2670919680, 2670985215, 'DE', 'DEU', 'ألمانيا'),
(38724, 2670985216, 2671050751, 'AU', 'AUS', 'أستراليا'),
(38725, 2671050752, 2671181823, 'US', 'USA', 'الولايات المتحدة'),
(38726, 2671181824, 2671247359, 'CA', 'CAN', 'كندا'),
(38727, 2671247360, 2671378431, 'US', 'USA', 'الولايات المتحدة'),
(38728, 2671378432, 2671443967, 'NO', 'NOR', 'النرويج'),
(38729, 2671443968, 2671509503, 'US', 'USA', 'الولايات المتحدة'),
(38730, 2671509504, 2671575039, 'NL', 'NLD', 'هولندا'),
(38731, 2671575040, 2672295935, 'US', 'USA', 'الولايات المتحدة'),
(38732, 2672295936, 2672361471, 'SE', 'SWE', 'السويد'),
(38733, 2672361472, 2672427007, 'AU', 'AUS', 'أستراليا'),
(38734, 2672427008, 2672820223, 'US', 'USA', 'الولايات المتحدة'),
(38735, 2672820224, 2672885759, 'JP', 'JPN', 'اليابان'),
(38736, 2672885760, 2672951295, 'NO', 'NOR', 'النرويج'),
(38737, 2672951296, 2673082367, 'US', 'USA', 'الولايات المتحدة'),
(38738, 2673082368, 2673147903, 'FR', 'FRA', 'فرنسا'),
(38739, 2673147904, 2673213439, 'US', 'USA', 'الولايات المتحدة'),
(38740, 2673278976, 2673410047, 'US', 'USA', 'الولايات المتحدة'),
(38741, 2673410048, 2673475583, 'CA', 'CAN', 'كندا'),
(38742, 2673475584, 2673541119, 'VE', 'VEN', 'فنزويلا'),
(38743, 2673541120, 2673606655, 'US', 'USA', 'الولايات المتحدة'),
(38744, 2673606656, 2673672191, 'GB', 'GBR', 'المملكة المتحدة'),
(38745, 2673672192, 2673737727, 'RU', 'RUS', 'الإتحاد الروسي'),
(38746, 2673737728, 2673803263, 'US', 'USA', 'الولايات المتحدة'),
(38747, 2673803264, 2673868799, 'FR', 'FRA', 'فرنسا'),
(38748, 2673868800, 2674130943, 'US', 'USA', 'الولايات المتحدة'),
(38749, 2674130944, 2674262015, 'GB', 'GBR', 'المملكة المتحدة'),
(38750, 2674262016, 2674327551, 'US', 'USA', 'الولايات المتحدة'),
(38751, 2674327552, 2674380799, 'CH', 'CHE', 'سويسرا'),
(38752, 2674380800, 2674381055, 'NL', 'NLD', 'هولندا'),
(38753, 2674381056, 2674393087, 'CH', 'CHE', 'سويسرا'),
(38754, 2674393088, 2674458623, 'GB', 'GBR', 'المملكة المتحدة'),
(38755, 2674458624, 2674589695, 'US', 'USA', 'الولايات المتحدة'),
(38756, 2674589696, 2674655231, 'SE', 'SWE', 'السويد'),
(38757, 2674655232, 2674720767, 'US', 'USA', 'الولايات المتحدة'),
(38758, 2674720768, 2674786303, 'FR', 'FRA', 'فرنسا'),
(38759, 2674786304, 2674851839, 'US', 'USA', 'الولايات المتحدة'),
(38760, 2674851840, 2674917375, 'AU', 'AUS', 'أستراليا'),
(38761, 2674917376, 2675048447, 'US', 'USA', 'الولايات المتحدة'),
(38762, 2675048448, 2675113983, 'GB', 'GBR', 'المملكة المتحدة'),
(38763, 2675113984, 2675245055, 'US', 'USA', 'الولايات المتحدة'),
(38764, 2675245056, 2675310591, 'NZ', 'NZL', 'نيوزيلاندا'),
(38765, 2675310592, 2675572735, 'US', 'USA', 'الولايات المتحدة'),
(38766, 2675572736, 2675638271, 'CH', 'CHE', 'سويسرا'),
(38767, 2675638272, 2675965951, 'US', 'USA', 'الولايات المتحدة'),
(38768, 2675965952, 2676031487, 'CA', 'CAN', 'كندا'),
(38769, 2676031488, 2676097023, 'US', 'USA', 'الولايات المتحدة'),
(38770, 2676097024, 2676162559, 'NO', 'NOR', 'النرويج'),
(38771, 2676162560, 2676359167, 'US', 'USA', 'الولايات المتحدة'),
(38772, 2676359168, 2676424703, 'IE', 'IRL', 'إيرلندا'),
(38773, 2676424704, 2677014527, 'US', 'USA', 'الولايات المتحدة'),
(38774, 2677014528, 2677080063, 'CH', 'CHE', 'سويسرا'),
(38775, 2677080064, 2677145599, 'US', 'USA', 'الولايات المتحدة'),
(38776, 2677211136, 2677276671, 'GB', 'GBR', 'المملكة المتحدة'),
(38777, 2677276672, 2677342207, 'LV', 'LVA', 'لاتفيا'),
(38778, 2677342208, 2677407743, 'IT', 'ITA', 'إيطاليا'),
(38779, 2677407744, 2677473279, 'US', 'USA', 'الولايات المتحدة'),
(38780, 2677473280, 2677538815, 'FR', 'FRA', 'فرنسا'),
(38781, 2677538816, 2677604351, 'FI', 'FIN', 'فنلندا'),
(38782, 2677604352, 2677669887, 'US', 'USA', 'الولايات المتحدة'),
(38783, 2677669888, 2677735423, 'DE', 'DEU', 'ألمانيا'),
(38784, 2677735424, 2677800959, 'US', 'USA', 'الولايات المتحدة'),
(38785, 2677800960, 2677866495, 'CH', 'CHE', 'سويسرا'),
(38786, 2677866496, 2677997567, 'US', 'USA', 'الولايات المتحدة'),
(38787, 2677997568, 2678063103, 'CA', 'CAN', 'كندا'),
(38788, 2678128640, 2678194175, 'US', 'USA', 'الولايات المتحدة'),
(38789, 2678194176, 2678259711, 'NO', 'NOR', 'النرويج'),
(38790, 2678259712, 2678521855, 'US', 'USA', 'الولايات المتحدة'),
(38791, 2678521856, 2678587391, 'GB', 'GBR', 'المملكة المتحدة'),
(38792, 2678587392, 2678652927, 'CH', 'CHE', 'سويسرا'),
(38793, 2678652928, 2678718463, 'US', 'USA', 'الولايات المتحدة'),
(38794, 2678718464, 2678783999, 'GB', 'GBR', 'المملكة المتحدة'),
(38795, 2678784000, 2678849535, 'NO', 'NOR', 'النرويج'),
(38796, 2678849536, 2678915071, 'US', 'USA', 'الولايات المتحدة'),
(38797, 2678915072, 2678980607, 'FR', 'FRA', 'فرنسا'),
(38798, 2678980608, 2679046143, 'US', 'USA', 'الولايات المتحدة'),
(38799, 2679046144, 2679111679, 'CA', 'CAN', 'كندا'),
(38800, 2679111680, 2679177215, 'US', 'USA', 'الولايات المتحدة'),
(38801, 2679177216, 2679242751, 'CA', 'CAN', 'كندا'),
(38802, 2679242752, 2679308287, 'US', 'USA', 'الولايات المتحدة'),
(38803, 2679308288, 2679373823, 'CH', 'CHE', 'سويسرا'),
(38804, 2679373824, 2679439359, 'GB', 'GBR', 'المملكة المتحدة'),
(38805, 2679439360, 2680029183, 'US', 'USA', 'الولايات المتحدة'),
(38806, 2680029184, 2680094719, 'SE', 'SWE', 'السويد'),
(38807, 2680094720, 2680225791, 'US', 'USA', 'الولايات المتحدة'),
(38808, 2680225792, 2680356863, 'SE', 'SWE', 'السويد'),
(38809, 2680356864, 2680422399, 'DK', 'DNK', 'الدنيمارك'),
(38810, 2680422400, 2680487935, 'AU', 'AUS', 'أستراليا'),
(38811, 2680487936, 2680553471, 'GB', 'GBR', 'المملكة المتحدة'),
(38812, 2680553472, 2680684543, 'US', 'USA', 'الولايات المتحدة'),
(38813, 2680684544, 2680750079, 'SE', 'SWE', 'السويد'),
(38814, 2680750080, 2681012223, 'US', 'USA', 'الولايات المتحدة'),
(38815, 2681077760, 2681143295, 'CA', 'CAN', 'كندا'),
(38816, 2681143296, 2681208831, 'AU', 'AUS', 'أستراليا'),
(38817, 2681208832, 2681274367, 'CA', 'CAN', 'كندا'),
(38818, 2681274368, 2681339903, 'US', 'USA', 'الولايات المتحدة'),
(38819, 2681339904, 2681405439, 'IT', 'ITA', 'إيطاليا'),
(38820, 2681405440, 2681470975, 'JP', 'JPN', 'اليابان'),
(38821, 2681470976, 2681536511, 'US', 'USA', 'الولايات المتحدة'),
(38822, 2681536512, 2681602047, 'IT', 'ITA', 'إيطاليا'),
(38823, 2681602048, 2681733119, 'US', 'USA', 'الولايات المتحدة'),
(38824, 2681733120, 2681798655, 'NO', 'NOR', 'النرويج'),
(38825, 2681798656, 2681864191, 'FR', 'FRA', 'فرنسا'),
(38826, 2681864192, 2681929727, 'US', 'USA', 'الولايات المتحدة'),
(38827, 2681929728, 2681995263, 'GB', 'GBR', 'المملكة المتحدة'),
(38828, 2681995264, 2682257407, 'US', 'USA', 'الولايات المتحدة'),
(38829, 2682322944, 2682388479, 'US', 'USA', 'الولايات المتحدة'),
(38830, 2682388480, 2682454015, 'CN', 'CHN', 'الصين'),
(38831, 2682454016, 2682519551, 'US', 'USA', 'الولايات المتحدة'),
(38832, 2682519552, 2682585087, 'JP', 'JPN', 'اليابان'),
(38833, 2682585088, 2682716159, 'US', 'USA', 'الولايات المتحدة'),
(38834, 2682716160, 2682781695, 'CA', 'CAN', 'كندا'),
(38835, 2682781696, 2682847231, 'CH', 'CHE', 'سويسرا'),
(38836, 2682847232, 2683043839, 'US', 'USA', 'الولايات المتحدة'),
(38837, 2683043840, 2683109375, 'GB', 'GBR', 'المملكة المتحدة'),
(38838, 2683109376, 2683174911, 'ES', 'ESP', 'إسبانيا'),
(38839, 2683174912, 2683240447, 'US', 'USA', 'الولايات المتحدة'),
(38840, 2683240448, 2683305983, 'GB', 'GBR', 'المملكة المتحدة'),
(38841, 2683305984, 2683371519, 'US', 'USA', 'الولايات المتحدة'),
(38842, 2683371520, 2683437055, 'CH', 'CHE', 'سويسرا'),
(38843, 2683437056, 2683568127, 'US', 'USA', 'الولايات المتحدة'),
(38844, 2683568128, 2683633663, 'GB', 'GBR', 'المملكة المتحدة'),
(38845, 2683637760, 2683641855, 'NL', 'NLD', 'هولندا'),
(38846, 2683641856, 2683645951, 'US', 'USA', 'الولايات المتحدة'),
(38847, 2683645952, 2683650047, 'SG', 'SGP', 'سنغافورة'),
(38848, 2683699200, 2683830271, 'US', 'USA', 'الولايات المتحدة'),
(38849, 2683830272, 2683895807, 'AU', 'AUS', 'أستراليا'),
(38850, 2683895808, 2684157951, 'US', 'USA', 'الولايات المتحدة'),
(38851, 2684223488, 2684289023, 'GB', 'GBR', 'المملكة المتحدة'),
(38852, 2684420096, 2684616703, 'US', 'USA', 'الولايات المتحدة'),
(38853, 2684616704, 2684682239, 'NZ', 'NZL', 'نيوزيلاندا'),
(38854, 2684682240, 2684747775, 'GB', 'GBR', 'المملكة المتحدة'),
(38855, 2684747776, 2684813311, 'IE', 'IRL', 'إيرلندا'),
(38856, 2684813312, 2684878847, 'US', 'USA', 'الولايات المتحدة'),
(38857, 2684878848, 2684944383, 'SE', 'SWE', 'السويد'),
(38858, 2684944384, 2685009919, 'GB', 'GBR', 'المملكة المتحدة'),
(38859, 2685009920, 2685075455, 'US', 'USA', 'الولايات المتحدة'),
(38860, 2685075456, 2686386175, 'JP', 'JPN', 'اليابان'),
(38861, 2686386176, 2686844927, 'US', 'USA', 'الولايات المتحدة'),
(38862, 2686844928, 2686910463, 'GB', 'GBR', 'المملكة المتحدة'),
(38863, 2686910464, 2686975999, 'US', 'USA', 'الولايات المتحدة'),
(38864, 2686976000, 2687041535, 'GR', 'GRC', 'اليونان'),
(38865, 2687041536, 2687238143, 'US', 'USA', 'الولايات المتحدة'),
(38866, 2687238144, 2687299119, 'DE', 'DEU', 'ألمانيا'),
(38867, 2687299120, 2687299127, 'US', 'USA', 'الولايات المتحدة'),
(38868, 2687299128, 2687299135, 'CN', 'CHN', 'الصين'),
(38869, 2687299136, 2687762431, 'DE', 'DEU', 'ألمانيا'),
(38870, 2687762432, 2687827967, 'AT', 'AUT', 'النمسا'),
(38871, 2687827968, 2687893503, 'CH', 'CHE', 'سويسرا'),
(38872, 2687893504, 2688221183, 'DE', 'DEU', 'ألمانيا'),
(38873, 2688221184, 2688286719, 'CH', 'CHE', 'سويسرا'),
(38874, 2688286720, 2688352255, 'DE', 'DEU', 'ألمانيا'),
(38875, 2688352256, 2688420095, 'CH', 'CHE', 'سويسرا'),
(38876, 2688420096, 2688420351, 'CN', 'CHN', 'الصين'),
(38877, 2688420352, 2688420863, 'CH', 'CHE', 'سويسرا'),
(38878, 2688420864, 2688421375, 'SG', 'SGP', 'سنغافورة'),
(38879, 2688421376, 2688421887, 'US', 'USA', 'الولايات المتحدة'),
(38880, 2688421888, 2688548863, 'CH', 'CHE', 'سويسرا'),
(38881, 2688548864, 2688614399, 'AU', 'AUS', 'أستراليا'),
(38882, 2688614400, 2688679935, 'US', 'USA', 'الولايات المتحدة'),
(38883, 2688679936, 2688745471, 'IT', 'ITA', 'إيطاليا'),
(38884, 2688745472, 2688876543, 'NO', 'NOR', 'النرويج'),
(38885, 2688876544, 2688942079, 'US', 'USA', 'الولايات المتحدة'),
(38886, 2688942080, 2689007615, 'DE', 'DEU', 'ألمانيا'),
(38887, 2689007616, 2689073151, 'FI', 'FIN', 'فنلندا'),
(38888, 2689073152, 2689138687, 'CA', 'CAN', 'كندا'),
(38889, 2689138688, 2689204223, 'US', 'USA', 'الولايات المتحدة'),
(38890, 2689204224, 2689269759, 'JP', 'JPN', 'اليابان'),
(38891, 2689269760, 2689335295, 'TR', 'TUR', 'تركيا'),
(38892, 2689335296, 2689400831, 'US', 'USA', 'الولايات المتحدة'),
(38893, 2689466368, 2689531903, 'IT', 'ITA', 'إيطاليا'),
(38894, 2689531904, 2689597439, 'US', 'USA', 'الولايات المتحدة'),
(38895, 2689597440, 2689662975, 'IT', 'ITA', 'إيطاليا'),
(38896, 2689662976, 2689925119, 'US', 'USA', 'الولايات المتحدة'),
(38897, 2689925120, 2689990655, 'CH', 'CHE', 'سويسرا'),
(38898, 2689990656, 2690187263, 'US', 'USA', 'الولايات المتحدة'),
(38899, 2690318336, 2690383871, 'US', 'USA', 'الولايات المتحدة'),
(38900, 2690383872, 2690449407, 'FR', 'FRA', 'فرنسا'),
(38901, 2690449408, 2690646015, 'US', 'USA', 'الولايات المتحدة'),
(38902, 2690646016, 2690711551, 'SG', 'SGP', 'سنغافورة'),
(38903, 2690711552, 2690777087, 'IT', 'ITA', 'إيطاليا'),
(38904, 2690777088, 2690842623, 'CH', 'CHE', 'سويسرا'),
(38905, 2690842624, 2690908159, 'RS', 'SRB', 'صربيا'),
(38906, 2690908160, 2690973695, 'GB', 'GBR', 'المملكة المتحدة'),
(38907, 2690973696, 2691104767, 'US', 'USA', 'الولايات المتحدة'),
(38908, 2691104768, 2691170303, 'FR', 'FRA', 'فرنسا'),
(38909, 2691170304, 2691235839, 'GB', 'GBR', 'المملكة المتحدة'),
(38910, 2691301376, 2691366911, 'CA', 'CAN', 'كندا'),
(38911, 2691366912, 2691760127, 'US', 'USA', 'الولايات المتحدة'),
(38912, 2691825664, 2691891199, 'HU', 'HUN', 'هنغاريا'),
(38913, 2692546560, 2694316031, 'US', 'USA', 'الولايات المتحدة'),
(38914, 2694381568, 2694447103, 'US', 'USA', 'الولايات المتحدة'),
(38915, 2696151040, 2696216575, 'IT', 'ITA', 'إيطاليا'),
(38916, 2696478720, 2697789439, 'JP', 'JPN', 'اليابان'),
(38917, 2697789440, 2697854975, 'US', 'USA', 'الولايات المتحدة'),
(38918, 2697854976, 2697920511, 'AU', 'AUS', 'أستراليا'),
(38919, 2697920512, 2698117119, 'US', 'USA', 'الولايات المتحدة'),
(38920, 2698117120, 2698182655, 'IS', 'ISL', 'أيسلندا'),
(38921, 2698182656, 2698248191, 'DE', 'DEU', 'ألمانيا'),
(38922, 2698248192, 2698313727, 'US', 'USA', 'الولايات المتحدة'),
(38923, 2698313728, 2698379263, 'GB', 'GBR', 'المملكة المتحدة'),
(38924, 2698379264, 2698444799, 'ES', 'ESP', 'إسبانيا'),
(38925, 2698444800, 2698510335, 'JP', 'JPN', 'اليابان'),
(38926, 2698510336, 2698706943, 'CZ', 'CZE', 'التشيك'),
(38927, 2698706944, 2698772479, 'CH', 'CHE', 'سويسرا'),
(38928, 2698772480, 2698838015, 'IT', 'ITA', 'إيطاليا'),
(38929, 2698838016, 2698903551, 'BE', 'BEL', 'بلجيكا'),
(38930, 2698903552, 2698969087, 'AU', 'AUS', 'أستراليا'),
(38931, 2698969088, 2699034623, 'CA', 'CAN', 'كندا'),
(38932, 2699231232, 2699296767, 'US', 'USA', 'الولايات المتحدة'),
(38933, 2699296768, 2699362303, 'FR', 'FRA', 'فرنسا'),
(38934, 2699362304, 2699624447, 'US', 'USA', 'الولايات المتحدة'),
(38935, 2699624448, 2700214271, 'JP', 'JPN', 'اليابان'),
(38936, 2700279808, 2700935167, 'JP', 'JPN', 'اليابان'),
(38937, 2700935168, 2701066239, 'US', 'USA', 'الولايات المتحدة'),
(38938, 2701197312, 2701262847, 'US', 'USA', 'الولايات المتحدة'),
(38939, 2701262848, 2701328383, 'GB', 'GBR', 'المملكة المتحدة'),
(38940, 2701328384, 2701393919, 'FR', 'FRA', 'فرنسا'),
(38941, 2701393920, 2701459455, 'NO', 'NOR', 'النرويج'),
(38942, 2701459456, 2701524991, 'AT', 'AUT', 'النمسا'),
(38943, 2701524992, 2701656063, 'US', 'USA', 'الولايات المتحدة'),
(38944, 2701656064, 2701721599, 'RU', 'RUS', 'الإتحاد الروسي'),
(38945, 2701721600, 2701787135, 'TR', 'TUR', 'تركيا'),
(38946, 2701852672, 2701918207, 'US', 'USA', 'الولايات المتحدة'),
(38947, 2701918208, 2701983743, 'GB', 'GBR', 'المملكة المتحدة'),
(38948, 2701983744, 2702245887, 'US', 'USA', 'الولايات المتحدة'),
(38949, 2702245888, 2702311423, 'GB', 'GBR', 'المملكة المتحدة'),
(38950, 2702376960, 2702442495, 'CA', 'CAN', 'كندا'),
(38951, 2702442496, 2702508031, 'CH', 'CHE', 'سويسرا'),
(38952, 2702508032, 2702573567, 'US', 'USA', 'الولايات المتحدة'),
(38953, 2702639104, 2702704639, 'GB', 'GBR', 'المملكة المتحدة'),
(38954, 2702704640, 2702770175, 'BR', 'BRA', 'البرازيل'),
(38955, 2702770176, 2702835711, 'CL', 'CHL', 'تشيلي'),
(38956, 2702835712, 2702901247, 'US', 'USA', 'الولايات المتحدة'),
(38957, 2702901248, 2702966783, 'IT', 'ITA', 'إيطاليا'),
(38958, 2702966784, 2703032319, 'US', 'USA', 'الولايات المتحدة'),
(38959, 2703032320, 2703097855, 'NZ', 'NZL', 'نيوزيلاندا'),
(38960, 2703097856, 2703163391, 'GB', 'GBR', 'المملكة المتحدة'),
(38961, 2703163392, 2703556607, 'US', 'USA', 'الولايات المتحدة'),
(38962, 2703556608, 2703622143, 'ES', 'ESP', 'إسبانيا'),
(38963, 2703622144, 2703818751, 'US', 'USA', 'الولايات المتحدة'),
(38964, 2703818752, 2703884287, 'FI', 'FIN', 'فنلندا'),
(38965, 2703884288, 2703949823, 'DE', 'DEU', 'ألمانيا'),
(38966, 2703949824, 2704015359, 'AU', 'AUS', 'أستراليا'),
(38967, 2704015360, 2704277503, 'US', 'USA', 'الولايات المتحدة'),
(38968, 2704277504, 2704343039, 'FR', 'FRA', 'فرنسا'),
(38969, 2704343040, 2704408575, 'US', 'USA', 'الولايات المتحدة'),
(38970, 2704408576, 2704474111, 'AU', 'AUS', 'أستراليا'),
(38971, 2704474112, 2704539647, 'US', 'USA', 'الولايات المتحدة'),
(38972, 2704539648, 2704605183, 'SE', 'SWE', 'السويد'),
(38973, 2704605184, 2704670719, 'HR', 'HRV', 'كرواتيا'),
(38974, 2704670720, 2704736255, 'SE', 'SWE', 'السويد'),
(38975, 2704736256, 2704801791, 'US', 'USA', 'الولايات المتحدة'),
(38976, 2704867328, 2704998399, 'US', 'USA', 'الولايات المتحدة'),
(38977, 2704998400, 2705063935, 'BE', 'BEL', 'بلجيكا'),
(38978, 2705063936, 2705195007, 'US', 'USA', 'الولايات المتحدة'),
(38979, 2705195008, 2705260543, 'CH', 'CHE', 'سويسرا'),
(38980, 2705260544, 2705326079, 'US', 'USA', 'الولايات المتحدة'),
(38981, 2705326080, 2705391615, 'MO', 'MAC', 'ماكاو'),
(38982, 2705391616, 2705522687, 'NZ', 'NZL', 'نيوزيلاندا'),
(38983, 2705522688, 2705588223, 'ES', 'ESP', 'إسبانيا'),
(38984, 2705588224, 2705784831, 'US', 'USA', 'الولايات المتحدة'),
(38985, 2705784832, 2705850367, 'GB', 'GBR', 'المملكة المتحدة'),
(38986, 2705850368, 2705915903, 'ES', 'ESP', 'إسبانيا'),
(38987, 2705915904, 2706046975, 'GB', 'GBR', 'المملكة المتحدة'),
(38988, 2706046976, 2706112511, 'JP', 'JPN', 'اليابان'),
(38989, 2706112512, 2706178047, 'GB', 'GBR', 'المملكة المتحدة'),
(38990, 2706178048, 2706243583, 'US', 'USA', 'الولايات المتحدة'),
(38991, 2706243584, 2706309119, 'CH', 'CHE', 'سويسرا'),
(38992, 2706309120, 2706374655, 'BR', 'BRA', 'البرازيل'),
(38993, 2706374656, 2706571263, 'US', 'USA', 'الولايات المتحدة'),
(38994, 2706571264, 2706694143, 'NL', 'NLD', 'هولندا'),
(38995, 2706694144, 2706702335, 'US', 'USA', 'الولايات المتحدة'),
(38996, 2706702336, 2706960383, 'NL', 'NLD', 'هولندا'),
(38997, 2706960384, 2706964479, 'US', 'USA', 'الولايات المتحدة'),
(38998, 2706964480, 2707226623, 'NL', 'NLD', 'هولندا'),
(38999, 2707226624, 2707488767, 'JP', 'JPN', 'اليابان'),
(39000, 2707488768, 2707947519, 'US', 'USA', 'الولايات المتحدة'),
(39001, 2707947520, 2708144127, 'FR', 'FRA', 'فرنسا'),
(39002, 2708144128, 2708340735, 'US', 'USA', 'الولايات المتحدة'),
(39003, 2708340736, 2708406271, 'AT', 'AUT', 'النمسا'),
(39004, 2708406272, 2708471807, 'ES', 'ESP', 'إسبانيا'),
(39005, 2708471808, 2708537343, 'GB', 'GBR', 'المملكة المتحدة'),
(39006, 2708537344, 2708733951, 'US', 'USA', 'الولايات المتحدة'),
(39007, 2708733952, 2708799487, 'ES', 'ESP', 'إسبانيا'),
(39008, 2708799488, 2708865023, 'AU', 'AUS', 'أستراليا'),
(39009, 2708865024, 2708930559, 'JP', 'JPN', 'اليابان'),
(39010, 2708930560, 2709127167, 'US', 'USA', 'الولايات المتحدة'),
(39011, 2709127168, 2709192703, 'KR', 'KOR', 'جمهورية كوريا'),
(39012, 2709258240, 2709389311, 'US', 'USA', 'الولايات المتحدة'),
(39013, 2709389312, 2709454847, 'SG', 'SGP', 'سنغافورة'),
(39014, 2709454848, 2709716991, 'US', 'USA', 'الولايات المتحدة'),
(39015, 2709716992, 2709782527, 'CL', 'CHL', 'تشيلي'),
(39016, 2709782528, 2709848063, 'PE', 'PER', 'بيرو'),
(39017, 2709848064, 2710175743, 'US', 'USA', 'الولايات المتحدة'),
(39018, 2710241280, 2710306815, 'MY', 'MYS', 'ماليزيا'),
(39019, 2710372352, 2710437887, 'CA', 'CAN', 'كندا'),
(39020, 2710437888, 2710503423, 'MY', 'MYS', 'ماليزيا'),
(39021, 2710503424, 2710568959, 'AU', 'AUS', 'أستراليا'),
(39022, 2710568960, 2710700031, 'US', 'USA', 'الولايات المتحدة'),
(39023, 2710700032, 2710765567, 'AU', 'AUS', 'أستراليا'),
(39024, 2710765568, 2710831103, 'IT', 'ITA', 'إيطاليا'),
(39025, 2710831104, 2710896639, 'BR', 'BRA', 'البرازيل'),
(39026, 2710896640, 2711093247, 'US', 'USA', 'الولايات المتحدة'),
(39027, 2711093248, 2711158783, 'AU', 'AUS', 'أستراليا'),
(39028, 2711158784, 2711486463, 'US', 'USA', 'الولايات المتحدة'),
(39029, 2711486464, 2711551999, 'NL', 'NLD', 'هولندا'),
(39030, 2711552000, 2713190399, 'US', 'USA', 'الولايات المتحدة'),
(39031, 2713190400, 2713255935, 'CA', 'CAN', 'كندا'),
(39032, 2713255936, 2713387007, 'US', 'USA', 'الولايات المتحدة'),
(39033, 2713387008, 2713452543, 'CA', 'CAN', 'كندا'),
(39034, 2713452544, 2713583615, 'US', 'USA', 'الولايات المتحدة'),
(39035, 2713583616, 2713649151, 'AR', 'ARG', 'الأرجنتين'),
(39036, 2713649152, 2713976831, 'US', 'USA', 'الولايات المتحدة'),
(39037, 2713976832, 2714042367, 'VE', 'VEN', 'فنزويلا'),
(39038, 2714042368, 2714238975, 'US', 'USA', 'الولايات المتحدة'),
(39039, 2714238976, 2714304511, 'TH', 'THA', 'تايلند'),
(39040, 2714304512, 2714370047, 'US', 'USA', 'الولايات المتحدة'),
(39041, 2714370048, 2714435583, 'CH', 'CHE', 'سويسرا'),
(39042, 2714435584, 2714697727, 'US', 'USA', 'الولايات المتحدة'),
(39043, 2714697728, 2714763263, 'CN', 'CHN', 'الصين'),
(39044, 2714763264, 2715025407, 'US', 'USA', 'الولايات المتحدة'),
(39045, 2715090944, 2715287551, 'US', 'USA', 'الولايات المتحدة'),
(39046, 2715287552, 2715353087, 'CA', 'CAN', 'كندا'),
(39047, 2715353088, 2716139519, 'US', 'USA', 'الولايات المتحدة'),
(39048, 2716139520, 2716205055, 'SG', 'SGP', 'سنغافورة'),
(39049, 2716205056, 2716467199, 'US', 'USA', 'الولايات المتحدة'),
(39050, 2716532736, 2716729343, 'US', 'USA', 'الولايات المتحدة'),
(39051, 2716729344, 2716794879, 'CL', 'CHL', 'تشيلي'),
(39052, 2716794880, 2717253631, 'US', 'USA', 'الولايات المتحدة'),
(39053, 2717253632, 2717319167, 'TH', 'THA', 'تايلند'),
(39054, 2717319168, 2717384703, 'US', 'USA', 'الولايات المتحدة'),
(39055, 2717384704, 2717450239, 'JP', 'JPN', 'اليابان'),
(39056, 2717450240, 2717646847, 'US', 'USA', 'الولايات المتحدة'),
(39057, 2717646848, 2717712383, 'KW', 'KWT', 'الكويت'),
(39058, 2717712384, 2717843455, 'US', 'USA', 'الولايات المتحدة'),
(39059, 2717974528, 2718171135, 'US', 'USA', 'الولايات المتحدة'),
(39060, 2718171136, 2718236671, 'JP', 'JPN', 'اليابان'),
(39061, 2718236672, 2718629887, 'US', 'USA', 'الولايات المتحدة'),
(39062, 2718629888, 2718695423, 'GB', 'GBR', 'المملكة المتحدة'),
(39063, 2718695424, 2718760959, 'US', 'USA', 'الولايات المتحدة'),
(39064, 2718760960, 2718826495, 'GB', 'GBR', 'المملكة المتحدة'),
(39065, 2718826496, 2719023103, 'US', 'USA', 'الولايات المتحدة'),
(39066, 2719088640, 2719285247, 'US', 'USA', 'الولايات المتحدة'),
(39067, 2719285248, 2719350783, 'CH', 'CHE', 'سويسرا'),
(39068, 2719350784, 2719416319, 'US', 'USA', 'الولايات المتحدة'),
(39069, 2719416320, 2719481855, 'CH', 'CHE', 'سويسرا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(39070, 2719481856, 2719547391, 'US', 'USA', 'الولايات المتحدة'),
(39071, 2719547392, 2719612927, 'AT', 'AUT', 'النمسا'),
(39072, 2719612928, 2719678463, 'CH', 'CHE', 'سويسرا'),
(39073, 2719678464, 2720399359, 'US', 'USA', 'الولايات المتحدة'),
(39074, 2720399360, 2720464895, 'FR', 'FRA', 'فرنسا'),
(39075, 2720464896, 2721382399, 'US', 'USA', 'الولايات المتحدة'),
(39076, 2721382400, 2721447935, 'CA', 'CAN', 'كندا'),
(39077, 2721447936, 2722627583, 'US', 'USA', 'الولايات المتحدة'),
(39078, 2722693120, 2722758655, 'CA', 'CAN', 'كندا'),
(39079, 2722758656, 2723479551, 'US', 'USA', 'الولايات المتحدة'),
(39080, 2723479552, 2723545087, 'CA', 'CAN', 'كندا'),
(39081, 2723545088, 2723610623, 'CH', 'CHE', 'سويسرا'),
(39082, 2723610624, 2724724735, 'US', 'USA', 'الولايات المتحدة'),
(39083, 2724790272, 2724855807, 'CN', 'CHN', 'الصين'),
(39084, 2724855808, 2724921343, 'CA', 'CAN', 'كندا'),
(39085, 2724921344, 2725249023, 'US', 'USA', 'الولايات المتحدة'),
(39086, 2725249024, 2725314559, 'NZ', 'NZL', 'نيوزيلاندا'),
(39087, 2725314560, 2725904383, 'US', 'USA', 'الولايات المتحدة'),
(39088, 2725904384, 2725969919, 'VE', 'VEN', 'فنزويلا'),
(39089, 2725969920, 2727018495, 'US', 'USA', 'الولايات المتحدة'),
(39090, 2727018496, 2727084031, 'CA', 'CAN', 'كندا'),
(39091, 2727084032, 2727346175, 'US', 'USA', 'الولايات المتحدة'),
(39092, 2727411712, 2727608319, 'AU', 'AUS', 'أستراليا'),
(39093, 2734751744, 2734817279, 'GB', 'GBR', 'المملكة المتحدة'),
(39094, 2734817280, 2734882815, 'US', 'USA', 'الولايات المتحدة'),
(39095, 2734882816, 2734948351, 'SE', 'SWE', 'السويد'),
(39096, 2734948352, 2735013887, 'US', 'USA', 'الولايات المتحدة'),
(39097, 2735013888, 2735079423, 'FR', 'FRA', 'فرنسا'),
(39098, 2735079424, 2735144959, 'US', 'USA', 'الولايات المتحدة'),
(39099, 2735144960, 2735210495, 'NZ', 'NZL', 'نيوزيلاندا'),
(39100, 2735210496, 2735276031, 'AU', 'AUS', 'أستراليا'),
(39101, 2735276032, 2735341567, 'FR', 'FRA', 'فرنسا'),
(39102, 2735341568, 2735407103, 'AR', 'ARG', 'الأرجنتين'),
(39103, 2735407104, 2735538175, 'US', 'USA', 'الولايات المتحدة'),
(39104, 2735538176, 2736848895, 'TW', 'TWN', 'تايوان'),
(39105, 2736848896, 2736914431, 'US', 'USA', 'الولايات المتحدة'),
(39106, 2736914432, 2736979967, 'NO', 'NOR', 'النرويج'),
(39107, 2736979968, 2737438719, 'US', 'USA', 'الولايات المتحدة'),
(39108, 2737438720, 2738749439, 'JP', 'JPN', 'اليابان'),
(39109, 2738749440, 2742353919, 'FR', 'FRA', 'فرنسا'),
(39110, 2742353920, 2742419455, 'ES', 'ESP', 'إسبانيا'),
(39111, 2742419456, 2742484991, 'US', 'USA', 'الولايات المتحدة'),
(39112, 2742484992, 2742550527, 'GB', 'GBR', 'المملكة المتحدة'),
(39113, 2742550528, 2742616063, 'US', 'USA', 'الولايات المتحدة'),
(39114, 2742681600, 2742747135, 'IN', 'IND', 'الهند'),
(39115, 2742747136, 2742779903, 'CA', 'CAN', 'كندا'),
(39116, 2742812672, 2742878207, 'US', 'USA', 'الولايات المتحدة'),
(39117, 2742943744, 2743009279, 'US', 'USA', 'الولايات المتحدة'),
(39118, 2743009280, 2743140351, 'AU', 'AUS', 'أستراليا'),
(39119, 2743140352, 2743205887, 'US', 'USA', 'الولايات المتحدة'),
(39120, 2743205888, 2743992319, 'JP', 'JPN', 'اليابان'),
(39121, 2744057856, 2744516607, 'JP', 'JPN', 'اليابان'),
(39122, 2744516608, 2744647679, 'US', 'USA', 'الولايات المتحدة'),
(39123, 2744647680, 2744713215, 'KR', 'KOR', 'جمهورية كوريا'),
(39124, 2744713216, 2744844287, 'US', 'USA', 'الولايات المتحدة'),
(39125, 2744844288, 2744909823, 'CA', 'CAN', 'كندا'),
(39126, 2744909824, 2744975359, 'GB', 'GBR', 'المملكة المتحدة'),
(39127, 2744975360, 2745040895, 'SE', 'SWE', 'السويد'),
(39128, 2745040896, 2745106431, 'DE', 'DEU', 'ألمانيا'),
(39129, 2745106432, 2745171967, 'SI', 'SVN', 'سلوفينيا'),
(39130, 2745171968, 2745237503, 'GB', 'GBR', 'المملكة المتحدة'),
(39131, 2745237504, 2745303039, 'CH', 'CHE', 'سويسرا'),
(39132, 2745303040, 2745368575, 'IT', 'ITA', 'إيطاليا'),
(39133, 2745368576, 2745434111, 'BE', 'BEL', 'بلجيكا'),
(39134, 2745434112, 2745499647, 'GB', 'GBR', 'المملكة المتحدة'),
(39135, 2745499648, 2745548799, 'BE', 'BEL', 'بلجيكا'),
(39136, 2745548800, 2745565183, 'DE', 'DEU', 'ألمانيا'),
(39137, 2745565184, 2745696255, 'GB', 'GBR', 'المملكة المتحدة'),
(39138, 2745696256, 2745761791, 'CH', 'CHE', 'سويسرا'),
(39139, 2745761792, 2746023935, 'GB', 'GBR', 'المملكة المتحدة'),
(39140, 2746023936, 2746089471, 'FR', 'FRA', 'فرنسا'),
(39141, 2746089472, 2746155007, 'NO', 'NOR', 'النرويج'),
(39142, 2746155008, 2746220543, 'NL', 'NLD', 'هولندا'),
(39143, 2746220544, 2746286079, 'US', 'USA', 'الولايات المتحدة'),
(39144, 2746351616, 2746417151, 'CR', 'CRI', 'كوستا ريكا'),
(39145, 2746482688, 2746548223, 'KR', 'KOR', 'جمهورية كوريا'),
(39146, 2746548224, 2747072511, 'US', 'USA', 'الولايات المتحدة'),
(39147, 2747072512, 2747138047, 'AU', 'AUS', 'أستراليا'),
(39148, 2747138048, 2747465727, 'US', 'USA', 'الولايات المتحدة'),
(39149, 2748121088, 2748317695, 'US', 'USA', 'الولايات المتحدة'),
(39150, 2748317696, 2748645375, 'JP', 'JPN', 'اليابان'),
(39151, 2748710912, 2749235199, 'JP', 'JPN', 'اليابان'),
(39152, 2749300736, 2749628415, 'JP', 'JPN', 'اليابان'),
(39153, 2749628416, 2749693951, 'US', 'USA', 'الولايات المتحدة'),
(39154, 2749759488, 2749890559, 'US', 'USA', 'الولايات المتحدة'),
(39155, 2749890560, 2750021631, 'AU', 'AUS', 'أستراليا'),
(39156, 2750021632, 2750349311, 'US', 'USA', 'الولايات المتحدة'),
(39157, 2750349312, 2750414847, 'KR', 'KOR', 'جمهورية كوريا'),
(39158, 2750414848, 2750873599, 'US', 'USA', 'الولايات المتحدة'),
(39159, 2750873600, 2750939135, 'CL', 'CHL', 'تشيلي'),
(39160, 2750939136, 2751070207, 'US', 'USA', 'الولايات المتحدة'),
(39161, 2751070208, 2751135743, 'CL', 'CHL', 'تشيلي'),
(39162, 2751135744, 2751397887, 'US', 'USA', 'الولايات المتحدة'),
(39163, 2751528960, 2751660031, 'FR', 'FRA', 'فرنسا'),
(39164, 2751660032, 2751725567, 'AT', 'AUT', 'النمسا'),
(39165, 2751725568, 2751791103, 'SE', 'SWE', 'السويد'),
(39166, 2751791104, 2751856639, 'FI', 'FIN', 'فنلندا'),
(39167, 2751856640, 2751922175, 'GB', 'GBR', 'المملكة المتحدة'),
(39168, 2751922176, 2751987711, 'FR', 'FRA', 'فرنسا'),
(39169, 2751987712, 2752053247, 'SI', 'SVN', 'سلوفينيا'),
(39170, 2752053248, 2752184319, 'SE', 'SWE', 'السويد'),
(39171, 2752184320, 2752249855, 'GB', 'GBR', 'المملكة المتحدة'),
(39172, 2752249856, 2752315391, 'DE', 'DEU', 'ألمانيا'),
(39173, 2752315392, 2752380927, 'FI', 'FIN', 'فنلندا'),
(39174, 2752380928, 2752446463, 'CH', 'CHE', 'سويسرا'),
(39175, 2752446464, 2752511999, 'BE', 'BEL', 'بلجيكا'),
(39176, 2752512000, 2753757183, 'DE', 'DEU', 'ألمانيا'),
(39177, 2753757184, 2753822719, 'BE', 'BEL', 'بلجيكا'),
(39178, 2753822720, 2753888255, 'GB', 'GBR', 'المملكة المتحدة'),
(39179, 2753888256, 2753953791, 'SE', 'SWE', 'السويد'),
(39180, 2753953792, 2754084863, 'GB', 'GBR', 'المملكة المتحدة'),
(39181, 2754150400, 2754215935, 'BR', 'BRA', 'البرازيل'),
(39182, 2754215936, 2754281471, 'PR', 'PRI', 'بورتو ريكو'),
(39183, 2754281472, 2754347007, 'JP', 'JPN', 'اليابان'),
(39184, 2754347008, 2754478079, 'US', 'USA', 'الولايات المتحدة'),
(39185, 2754478080, 2754543615, 'JP', 'JPN', 'اليابان'),
(39186, 2754543616, 2754609151, 'US', 'USA', 'الولايات المتحدة'),
(39187, 2754609152, 2754674687, 'SE', 'SWE', 'السويد'),
(39188, 2754674688, 2754936831, 'US', 'USA', 'الولايات المتحدة'),
(39189, 2754936832, 2755002367, 'AU', 'AUS', 'أستراليا'),
(39190, 2755002368, 2755330047, 'US', 'USA', 'الولايات المتحدة'),
(39191, 2755330048, 2755395583, 'DE', 'DEU', 'ألمانيا'),
(39192, 2755395584, 2755461119, 'FR', 'FRA', 'فرنسا'),
(39193, 2755461120, 2755526655, 'DE', 'DEU', 'ألمانيا'),
(39194, 2755526656, 2755985407, 'US', 'USA', 'الولايات المتحدة'),
(39195, 2755985408, 2756182015, 'JP', 'JPN', 'اليابان'),
(39196, 2756182016, 2756247551, 'US', 'USA', 'الولايات المتحدة'),
(39197, 2756247552, 2756313087, 'UY', 'URY', 'الأوروغواي'),
(39198, 2756313088, 2756378623, 'US', 'USA', 'الولايات المتحدة'),
(39199, 2756378624, 2756444159, 'AU', 'AUS', 'أستراليا'),
(39200, 2756444160, 2756509695, 'US', 'USA', 'الولايات المتحدة'),
(39201, 2756509696, 2756556543, 'CL', 'CHL', 'تشيلي'),
(39202, 2756556544, 2756557311, 'PE', 'PER', 'بيرو'),
(39203, 2756557312, 2756575231, 'CL', 'CHL', 'تشيلي'),
(39204, 2756575232, 2756640767, 'SG', 'SGP', 'سنغافورة'),
(39205, 2756640768, 2756706303, 'US', 'USA', 'الولايات المتحدة'),
(39206, 2756706304, 2756771839, 'AU', 'AUS', 'أستراليا'),
(39207, 2756771840, 2756837375, 'FR', 'FRA', 'فرنسا'),
(39208, 2756837376, 2757033983, 'US', 'USA', 'الولايات المتحدة'),
(39209, 2757033984, 2757099519, 'BR', 'BRA', 'البرازيل'),
(39210, 2757099520, 2757230591, 'US', 'USA', 'الولايات المتحدة'),
(39211, 2757296128, 2757754879, 'US', 'USA', 'الولايات المتحدة'),
(39212, 2757754880, 2757820415, 'CL', 'CHL', 'تشيلي'),
(39213, 2757820416, 2757885951, 'AU', 'AUS', 'أستراليا'),
(39214, 2757885952, 2757951487, 'CL', 'CHL', 'تشيلي'),
(39215, 2757951488, 2758017023, 'US', 'USA', 'الولايات المتحدة'),
(39216, 2758017024, 2758082559, 'IN', 'IND', 'الهند'),
(39217, 2758082560, 2758148095, 'US', 'USA', 'الولايات المتحدة'),
(39218, 2758148096, 2758213631, 'CA', 'CAN', 'كندا'),
(39219, 2758213632, 2758541311, 'US', 'USA', 'الولايات المتحدة'),
(39220, 2758541312, 2758606847, 'AU', 'AUS', 'أستراليا'),
(39221, 2758606848, 2758803455, 'US', 'USA', 'الولايات المتحدة'),
(39222, 2758803456, 2758868991, 'AU', 'AUS', 'أستراليا'),
(39223, 2758868992, 2759000063, 'US', 'USA', 'الولايات المتحدة'),
(39224, 2759000064, 2759065599, 'TH', 'THA', 'تايلند'),
(39225, 2759065600, 2759589887, 'US', 'USA', 'الولايات المتحدة'),
(39226, 2759589888, 2759720959, 'KR', 'KOR', 'جمهورية كوريا'),
(39227, 2759852032, 2759883439, 'CH', 'CHE', 'سويسرا'),
(39228, 2759883440, 2759883443, 'LI', 'LIE', 'ليختنشتاين'),
(39229, 2759883444, 2759883451, 'CH', 'CHE', 'سويسرا'),
(39230, 2759883452, 2759883455, 'LI', 'LIE', 'ليختنشتاين'),
(39231, 2759883456, 2759884111, 'CH', 'CHE', 'سويسرا'),
(39232, 2759884112, 2759884115, 'GB', 'GBR', 'المملكة المتحدة'),
(39233, 2759884116, 2759894559, 'CH', 'CHE', 'سويسرا'),
(39234, 2759894560, 2759894563, 'LI', 'LIE', 'ليختنشتاين'),
(39235, 2759894564, 2759917567, 'CH', 'CHE', 'سويسرا'),
(39236, 2759917568, 2759983103, 'FR', 'FRA', 'فرنسا'),
(39237, 2759983104, 2760048639, 'IT', 'ITA', 'إيطاليا'),
(39238, 2760048640, 2760114175, 'FR', 'FRA', 'فرنسا'),
(39239, 2760114176, 2760179711, 'IT', 'ITA', 'إيطاليا'),
(39240, 2760179712, 2760245247, 'DE', 'DEU', 'ألمانيا'),
(39241, 2760245248, 2760310783, 'GB', 'GBR', 'المملكة المتحدة'),
(39242, 2760310784, 2760376319, 'SE', 'SWE', 'السويد'),
(39243, 2760376320, 2760507391, 'GB', 'GBR', 'المملكة المتحدة'),
(39244, 2760507392, 2760572927, 'FR', 'FRA', 'فرنسا'),
(39245, 2760572928, 2760638463, 'DE', 'DEU', 'ألمانيا'),
(39246, 2760638464, 2760703999, 'NL', 'NLD', 'هولندا'),
(39247, 2760704000, 2760769535, 'FI', 'FIN', 'فنلندا'),
(39248, 2760769536, 2760835071, 'IT', 'ITA', 'إيطاليا'),
(39249, 2760835072, 2760898559, 'GB', 'GBR', 'المملكة المتحدة'),
(39250, 2760898560, 2760899583, 'US', 'USA', 'الولايات المتحدة'),
(39251, 2760899584, 2760900607, 'GB', 'GBR', 'المملكة المتحدة'),
(39252, 2760900608, 2761031679, 'US', 'USA', 'الولايات المتحدة'),
(39253, 2761424896, 2761621503, 'US', 'USA', 'الولايات المتحدة'),
(39254, 2761687040, 2761949183, 'US', 'USA', 'الولايات المتحدة'),
(39255, 2762014720, 2762145791, 'JP', 'JPN', 'اليابان'),
(39256, 2762211328, 2762276863, 'IN', 'IND', 'الهند'),
(39257, 2762276864, 2762342399, 'US', 'USA', 'الولايات المتحدة'),
(39258, 2762342400, 2762407935, 'CA', 'CAN', 'كندا'),
(39259, 2762407936, 2763063295, 'US', 'USA', 'الولايات المتحدة'),
(39260, 2763128832, 2763194367, 'CA', 'CAN', 'كندا'),
(39261, 2763194368, 2765553663, 'US', 'USA', 'الولايات المتحدة'),
(39262, 2765619200, 2768240639, 'US', 'USA', 'الولايات المتحدة'),
(39263, 2768306176, 2768437247, 'US', 'USA', 'الولايات المتحدة'),
(39264, 2768633856, 2768764927, 'US', 'USA', 'الولايات المتحدة'),
(39265, 2769027072, 2769092607, 'AU', 'AUS', 'أستراليا'),
(39266, 2769092608, 2769158143, 'US', 'USA', 'الولايات المتحدة'),
(39267, 2769158144, 2769289215, 'JP', 'JPN', 'اليابان'),
(39268, 2769354752, 2769485823, 'JP', 'JPN', 'اليابان'),
(39269, 2769485824, 2769616895, 'US', 'USA', 'الولايات المتحدة'),
(39270, 2769616896, 2769682431, 'SG', 'SGP', 'سنغافورة'),
(39271, 2769682432, 2769747967, 'US', 'USA', 'الولايات المتحدة'),
(39272, 2769747968, 2769813503, 'CA', 'CAN', 'كندا'),
(39273, 2769813504, 2769879039, 'US', 'USA', 'الولايات المتحدة'),
(39274, 2769944576, 2770272255, 'US', 'USA', 'الولايات المتحدة'),
(39275, 2770272256, 2770337791, 'AU', 'AUS', 'أستراليا'),
(39276, 2770337792, 2771451903, 'US', 'USA', 'الولايات المتحدة'),
(39277, 2772434944, 2772631551, 'US', 'USA', 'الولايات المتحدة'),
(39278, 2772631552, 2772697087, 'AU', 'AUS', 'أستراليا'),
(39279, 2772697088, 2772762623, 'US', 'USA', 'الولايات المتحدة'),
(39280, 2772762624, 2772828159, 'AU', 'AUS', 'أستراليا'),
(39281, 2772828160, 2773221375, 'US', 'USA', 'الولايات المتحدة'),
(39282, 2773221376, 2773286911, 'JP', 'JPN', 'اليابان'),
(39283, 2773286912, 2773352447, 'US', 'USA', 'الولايات المتحدة'),
(39284, 2773352448, 2773417983, 'CA', 'CAN', 'كندا'),
(39285, 2773417984, 2773745663, 'US', 'USA', 'الولايات المتحدة'),
(39286, 2773745664, 2773811199, 'NZ', 'NZL', 'نيوزيلاندا'),
(39287, 2773811200, 2773876735, 'US', 'USA', 'الولايات المتحدة'),
(39288, 2773876736, 2773942271, 'AU', 'AUS', 'أستراليا'),
(39289, 2773942272, 2774138879, 'US', 'USA', 'الولايات المتحدة'),
(39290, 2774204416, 2774335487, 'US', 'USA', 'الولايات المتحدة'),
(39291, 2774335488, 2774401023, 'JP', 'JPN', 'اليابان'),
(39292, 2774401024, 2774532095, 'US', 'USA', 'الولايات المتحدة'),
(39293, 2774532096, 2774597631, 'JP', 'JPN', 'اليابان'),
(39294, 2774597632, 2774663167, 'US', 'USA', 'الولايات المتحدة'),
(39295, 2774663168, 2774728703, 'NI', 'NIC', 'نيكاراغوا'),
(39296, 2774728704, 2774990847, 'JP', 'JPN', 'اليابان'),
(39297, 2774990848, 2775318527, 'US', 'USA', 'الولايات المتحدة'),
(39298, 2775318528, 2775384063, 'JP', 'JPN', 'اليابان'),
(39299, 2775384064, 2775711743, 'US', 'USA', 'الولايات المتحدة'),
(39300, 2775711744, 2775777279, 'NL', 'NLD', 'هولندا'),
(39301, 2775777280, 2775842815, 'CA', 'CAN', 'كندا'),
(39302, 2775842816, 2775973887, 'US', 'USA', 'الولايات المتحدة'),
(39303, 2775973888, 2776039423, 'AU', 'AUS', 'أستراليا'),
(39304, 2776039424, 2776891391, 'US', 'USA', 'الولايات المتحدة'),
(39305, 2776891392, 2777022463, 'KR', 'KOR', 'جمهورية كوريا'),
(39306, 2777022464, 2777481215, 'US', 'USA', 'الولايات المتحدة'),
(39307, 2777481216, 2777546751, 'KR', 'KOR', 'جمهورية كوريا'),
(39308, 2777546752, 2777612287, 'AU', 'AUS', 'أستراليا'),
(39309, 2778071040, 2778333183, 'US', 'USA', 'الولايات المتحدة'),
(39310, 2778333184, 2778398719, 'CA', 'CAN', 'كندا'),
(39311, 2778398720, 2779054079, 'US', 'USA', 'الولايات المتحدة'),
(39312, 2779119616, 2779316223, 'US', 'USA', 'الولايات المتحدة'),
(39313, 2779381760, 2779906047, 'US', 'USA', 'الولايات المتحدة'),
(39314, 2779906048, 2779971583, 'CA', 'CAN', 'كندا'),
(39315, 2779971584, 2780037119, 'US', 'USA', 'الولايات المتحدة'),
(39316, 2780102656, 2780168191, 'US', 'USA', 'الولايات المتحدة'),
(39317, 2780168192, 2780299263, 'CL', 'CHL', 'تشيلي'),
(39318, 2780299264, 2780364799, 'US', 'USA', 'الولايات المتحدة'),
(39319, 2780364800, 2780430335, 'CA', 'CAN', 'كندا'),
(39320, 2780430336, 2780495871, 'KR', 'KOR', 'جمهورية كوريا'),
(39321, 2780495872, 2780561407, 'AU', 'AUS', 'أستراليا'),
(39322, 2780561408, 2780758015, 'US', 'USA', 'الولايات المتحدة'),
(39323, 2780758016, 2780823551, 'AU', 'AUS', 'أستراليا'),
(39324, 2780823552, 2780904159, 'US', 'USA', 'الولايات المتحدة'),
(39325, 2780904160, 2780904191, 'CA', 'CAN', 'كندا'),
(39326, 2780904192, 2780909887, 'US', 'USA', 'الولايات المتحدة'),
(39327, 2780909888, 2780909903, 'CA', 'CAN', 'كندا'),
(39328, 2780909904, 2780921359, 'US', 'USA', 'الولايات المتحدة'),
(39329, 2780921360, 2780921367, 'GB', 'GBR', 'المملكة المتحدة'),
(39330, 2780921368, 2780925951, 'US', 'USA', 'الولايات المتحدة'),
(39331, 2780925952, 2780926207, 'GB', 'GBR', 'المملكة المتحدة'),
(39332, 2780926208, 2780926271, 'US', 'USA', 'الولايات المتحدة'),
(39333, 2780926272, 2780926303, 'FR', 'FRA', 'فرنسا'),
(39334, 2780926304, 2780926319, 'IT', 'ITA', 'إيطاليا'),
(39335, 2780926320, 2780926823, 'US', 'USA', 'الولايات المتحدة'),
(39336, 2780926824, 2780926847, 'GB', 'GBR', 'المملكة المتحدة'),
(39337, 2780926848, 2780926975, 'US', 'USA', 'الولايات المتحدة'),
(39338, 2780926976, 2780927487, 'GB', 'GBR', 'المملكة المتحدة'),
(39339, 2780927488, 2780927743, 'US', 'USA', 'الولايات المتحدة'),
(39340, 2780927744, 2780927999, 'GB', 'GBR', 'المملكة المتحدة'),
(39341, 2780928000, 2780928031, 'US', 'USA', 'الولايات المتحدة'),
(39342, 2780928032, 2780928127, 'GB', 'GBR', 'المملكة المتحدة'),
(39343, 2780928128, 2780928383, 'US', 'USA', 'الولايات المتحدة'),
(39344, 2780928384, 2780928415, 'GB', 'GBR', 'المملكة المتحدة'),
(39345, 2780928416, 2780928447, 'US', 'USA', 'الولايات المتحدة'),
(39346, 2780928448, 2780928455, 'GB', 'GBR', 'المملكة المتحدة'),
(39347, 2780928456, 2780928463, 'US', 'USA', 'الولايات المتحدة'),
(39348, 2780928464, 2780928471, 'DE', 'DEU', 'ألمانيا'),
(39349, 2780928472, 2780929023, 'US', 'USA', 'الولايات المتحدة'),
(39350, 2780929024, 2780929279, 'GB', 'GBR', 'المملكة المتحدة'),
(39351, 2780929280, 2780929791, 'FR', 'FRA', 'فرنسا'),
(39352, 2780929792, 2780930047, 'US', 'USA', 'الولايات المتحدة'),
(39353, 2780930048, 2780930559, 'GB', 'GBR', 'المملكة المتحدة'),
(39354, 2780930560, 2780930879, 'US', 'USA', 'الولايات المتحدة'),
(39355, 2780930880, 2780930927, 'GB', 'GBR', 'المملكة المتحدة'),
(39356, 2780930928, 2780930943, 'US', 'USA', 'الولايات المتحدة'),
(39357, 2780930944, 2780930959, 'GB', 'GBR', 'المملكة المتحدة'),
(39358, 2780930960, 2780930975, 'FR', 'FRA', 'فرنسا'),
(39359, 2780930976, 2780931007, 'US', 'USA', 'الولايات المتحدة'),
(39360, 2780931008, 2780931039, 'GB', 'GBR', 'المملكة المتحدة'),
(39361, 2780931040, 2780931071, 'US', 'USA', 'الولايات المتحدة'),
(39362, 2780931072, 2780932335, 'GB', 'GBR', 'المملكة المتحدة'),
(39363, 2780932336, 2780932607, 'US', 'USA', 'الولايات المتحدة'),
(39364, 2780932608, 2780933119, 'GB', 'GBR', 'المملكة المتحدة'),
(39365, 2780933120, 2780933151, 'US', 'USA', 'الولايات المتحدة'),
(39366, 2780933152, 2780933191, 'GB', 'GBR', 'المملكة المتحدة'),
(39367, 2780933192, 2780933247, 'US', 'USA', 'الولايات المتحدة'),
(39368, 2780933248, 2780933631, 'GB', 'GBR', 'المملكة المتحدة'),
(39369, 2780933632, 2780933887, 'US', 'USA', 'الولايات المتحدة'),
(39370, 2780933888, 2780934143, 'GB', 'GBR', 'المملكة المتحدة'),
(39371, 2780934144, 2780934167, 'PL', 'POL', 'بولندا'),
(39372, 2780934168, 2780940367, 'US', 'USA', 'الولايات المتحدة'),
(39373, 2780940368, 2780940383, 'CA', 'CAN', 'كندا'),
(39374, 2780940384, 2780941055, 'US', 'USA', 'الولايات المتحدة'),
(39375, 2780941056, 2780941087, 'GB', 'GBR', 'المملكة المتحدة'),
(39376, 2780941088, 2780941719, 'US', 'USA', 'الولايات المتحدة'),
(39377, 2780941720, 2780941727, 'GB', 'GBR', 'المملكة المتحدة'),
(39378, 2780941728, 2780943575, 'US', 'USA', 'الولايات المتحدة'),
(39379, 2780943576, 2780943583, 'BM', 'BMU', 'برمودا'),
(39380, 2780943584, 2780945311, 'US', 'USA', 'الولايات المتحدة'),
(39381, 2780945312, 2780945375, 'BM', 'BMU', 'برمودا'),
(39382, 2780945376, 2780945663, 'US', 'USA', 'الولايات المتحدة'),
(39383, 2780945664, 2780945695, 'BM', 'BMU', 'برمودا'),
(39384, 2780945696, 2780946127, 'US', 'USA', 'الولايات المتحدة'),
(39385, 2780946128, 2780946135, 'CA', 'CAN', 'كندا'),
(39386, 2780946136, 2780947903, 'US', 'USA', 'الولايات المتحدة'),
(39387, 2780947904, 2780947967, 'MY', 'MYS', 'ماليزيا'),
(39388, 2780947968, 2780952967, 'US', 'USA', 'الولايات المتحدة'),
(39389, 2780952968, 2780952975, 'GB', 'GBR', 'المملكة المتحدة'),
(39390, 2780952976, 2780954623, 'US', 'USA', 'الولايات المتحدة'),
(39391, 2780954624, 2781020159, 'KR', 'KOR', 'جمهورية كوريا'),
(39392, 2781020160, 2781478911, 'US', 'USA', 'الولايات المتحدة'),
(39393, 2781478912, 2781544447, 'HK', 'HKG', 'هونغ كونغ'),
(39394, 2781544448, 2781675519, 'US', 'USA', 'الولايات المتحدة'),
(39395, 2781675520, 2781741055, 'NZ', 'NZL', 'نيوزيلاندا'),
(39396, 2781741056, 2781937663, 'US', 'USA', 'الولايات المتحدة'),
(39397, 2781937664, 2782003199, 'TH', 'THA', 'تايلند'),
(39398, 2782134272, 2782199807, 'US', 'USA', 'الولايات المتحدة'),
(39399, 2782199808, 2782265343, 'KR', 'KOR', 'جمهورية كوريا'),
(39400, 2782265344, 2782658559, 'US', 'USA', 'الولايات المتحدة'),
(39401, 2782658560, 2782724095, 'PH', 'PHL', 'الفلبين'),
(39402, 2782724096, 2782789631, 'US', 'USA', 'الولايات المتحدة'),
(39403, 2782789632, 2782855167, 'CH', 'CHE', 'سويسرا'),
(39404, 2782855168, 2783182847, 'US', 'USA', 'الولايات المتحدة'),
(39405, 2783182848, 2783248383, 'AU', 'AUS', 'أستراليا'),
(39406, 2783248384, 2783313919, 'KR', 'KOR', 'جمهورية كوريا'),
(39407, 2783313920, 2783379455, 'US', 'USA', 'الولايات المتحدة'),
(39408, 2783444992, 2783510527, 'US', 'USA', 'الولايات المتحدة'),
(39409, 2783576064, 2783969279, 'US', 'USA', 'الولايات المتحدة'),
(39410, 2783969280, 2784034815, 'AU', 'AUS', 'أستراليا'),
(39411, 2784034816, 2784165887, 'JP', 'JPN', 'اليابان'),
(39412, 2784165888, 2784296959, 'KR', 'KOR', 'جمهورية كوريا'),
(39413, 2784296960, 2784362495, 'US', 'USA', 'الولايات المتحدة'),
(39414, 2784362496, 2784428031, 'KR', 'KOR', 'جمهورية كوريا'),
(39415, 2784428032, 2784952319, 'US', 'USA', 'الولايات المتحدة'),
(39416, 2785148928, 2785542143, 'US', 'USA', 'الولايات المتحدة'),
(39417, 2785542144, 2786066431, 'CH', 'CHE', 'سويسرا'),
(39418, 2786066432, 2788163583, 'US', 'USA', 'الولايات المتحدة'),
(39419, 2788229120, 2788229935, 'US', 'USA', 'الولايات المتحدة'),
(39420, 2788229936, 2788229943, 'GB', 'GBR', 'المملكة المتحدة'),
(39421, 2788229944, 2788230663, 'US', 'USA', 'الولايات المتحدة'),
(39422, 2788230664, 2788230679, 'GB', 'GBR', 'المملكة المتحدة'),
(39423, 2788230680, 2788233263, 'US', 'USA', 'الولايات المتحدة'),
(39424, 2788233264, 2788233271, 'GB', 'GBR', 'المملكة المتحدة'),
(39425, 2788233272, 2788234279, 'US', 'USA', 'الولايات المتحدة'),
(39426, 2788234280, 2788234287, 'CA', 'CAN', 'كندا'),
(39427, 2788234288, 2788234767, 'US', 'USA', 'الولايات المتحدة'),
(39428, 2788234768, 2788234775, 'GB', 'GBR', 'المملكة المتحدة'),
(39429, 2788234776, 2788238847, 'US', 'USA', 'الولايات المتحدة'),
(39430, 2788238848, 2788238855, 'GB', 'GBR', 'المملكة المتحدة'),
(39431, 2788238856, 2788241447, 'US', 'USA', 'الولايات المتحدة'),
(39432, 2788241448, 2788241455, 'GB', 'GBR', 'المملكة المتحدة'),
(39433, 2788241456, 2788245007, 'US', 'USA', 'الولايات المتحدة'),
(39434, 2788245008, 2788245023, 'CA', 'CAN', 'كندا'),
(39435, 2788245024, 2788261887, 'US', 'USA', 'الولايات المتحدة'),
(39436, 2788261888, 2788294655, 'GB', 'GBR', 'المملكة المتحدة'),
(39437, 2788294656, 2789081087, 'US', 'USA', 'الولايات المتحدة'),
(39438, 2789179392, 2789203967, 'US', 'USA', 'الولايات المتحدة'),
(39439, 2789212160, 2789277695, 'AU', 'AUS', 'أستراليا'),
(39440, 2789277696, 2789343231, 'NZ', 'NZL', 'نيوزيلاندا'),
(39441, 2789343232, 2789933055, 'US', 'USA', 'الولايات المتحدة'),
(39442, 2789933056, 2789998591, 'CL', 'CHL', 'تشيلي'),
(39443, 2789998592, 2790129663, 'US', 'USA', 'الولايات المتحدة'),
(39444, 2790195200, 2790260735, 'KR', 'KOR', 'جمهورية كوريا'),
(39445, 2790260736, 2790326271, 'US', 'USA', 'الولايات المتحدة'),
(39446, 2790326272, 2790391807, 'HK', 'HKG', 'هونغ كونغ'),
(39447, 2790391808, 2790457343, 'US', 'USA', 'الولايات المتحدة'),
(39448, 2790457344, 2790522879, 'NZ', 'NZL', 'نيوزيلاندا'),
(39449, 2790522880, 2790588415, 'US', 'USA', 'الولايات المتحدة'),
(39450, 2790653952, 2790719487, 'US', 'USA', 'الولايات المتحدة'),
(39451, 2790719488, 2790785023, 'SA', 'SAU', 'السعودية'),
(39452, 2790850560, 2791571455, 'US', 'USA', 'الولايات المتحدة'),
(39453, 2791571456, 2791636991, 'JP', 'JPN', 'اليابان'),
(39454, 2791636992, 2791768063, 'US', 'USA', 'الولايات المتحدة'),
(39455, 2791768064, 2791899135, 'KR', 'KOR', 'جمهورية كوريا'),
(39456, 2791899136, 2791964671, 'US', 'USA', 'الولايات المتحدة'),
(39457, 2791964672, 2792030207, 'NZ', 'NZL', 'نيوزيلاندا'),
(39458, 2792030208, 2792226815, 'US', 'USA', 'الولايات المتحدة'),
(39459, 2792226816, 2792292351, 'CL', 'CHL', 'تشيلي'),
(39460, 2792292352, 2792357887, 'CN', 'CHN', 'الصين'),
(39461, 2792357888, 2792488959, 'US', 'USA', 'الولايات المتحدة'),
(39462, 2792488960, 2792554495, 'BO', 'BOL', 'بوليفيا'),
(39463, 2792554496, 2792751103, 'US', 'USA', 'الولايات المتحدة'),
(39464, 2792751104, 2792882175, 'JP', 'JPN', 'اليابان'),
(39465, 2792882176, 2792947711, 'AU', 'AUS', 'أستراليا'),
(39466, 2792947712, 2793013247, 'SG', 'SGP', 'سنغافورة'),
(39467, 2793013248, 2793209855, 'US', 'USA', 'الولايات المتحدة'),
(39468, 2793209856, 2793275391, 'KR', 'KOR', 'جمهورية كوريا'),
(39469, 2793275392, 2801795071, 'US', 'USA', 'الولايات المتحدة'),
(39470, 2801860608, 2802515967, 'US', 'USA', 'الولايات المتحدة'),
(39471, 2802515968, 2802581503, 'CA', 'CAN', 'كندا'),
(39472, 2802581504, 2802909183, 'US', 'USA', 'الولايات المتحدة'),
(39473, 2802909184, 2802974719, 'CA', 'CAN', 'كندا'),
(39474, 2802974720, 2803630079, 'US', 'USA', 'الولايات المتحدة'),
(39475, 2803630080, 2803695615, 'CL', 'CHL', 'تشيلي'),
(39476, 2803695616, 2803761151, 'US', 'USA', 'الولايات المتحدة'),
(39477, 2803761152, 2803826687, 'AU', 'AUS', 'أستراليا'),
(39478, 2803826688, 2803892223, 'US', 'USA', 'الولايات المتحدة'),
(39479, 2803892224, 2805465087, 'CA', 'CAN', 'كندا'),
(39480, 2805989376, 2806644735, 'US', 'USA', 'الولايات المتحدة'),
(39481, 2806644736, 2806710271, 'CA', 'CAN', 'كندا'),
(39482, 2806710272, 2807103487, 'US', 'USA', 'الولايات المتحدة'),
(39483, 2807103488, 2807169023, 'NL', 'NLD', 'هولندا'),
(39484, 2807169024, 2807824383, 'US', 'USA', 'الولايات المتحدة'),
(39485, 2807824384, 2807889919, 'CA', 'CAN', 'كندا'),
(39486, 2807889920, 2808545279, 'US', 'USA', 'الولايات المتحدة'),
(39487, 2808545280, 2808610815, 'AU', 'AUS', 'أستراليا'),
(39488, 2808610816, 2808872959, 'US', 'USA', 'الولايات المتحدة'),
(39489, 2808938496, 2809069567, 'US', 'USA', 'الولايات المتحدة'),
(39490, 2809069568, 2809135103, 'SA', 'SAU', 'السعودية'),
(39491, 2809135104, 2809397247, 'US', 'USA', 'الولايات المتحدة'),
(39492, 2809462784, 2809855999, 'US', 'USA', 'الولايات المتحدة'),
(39493, 2809856000, 2809921535, 'AU', 'AUS', 'أستراليا'),
(39494, 2809921536, 2809987071, 'US', 'USA', 'الولايات المتحدة'),
(39495, 2809987072, 2810052607, 'CA', 'CAN', 'كندا'),
(39496, 2810052608, 2810249215, 'US', 'USA', 'الولايات المتحدة'),
(39497, 2810249216, 2810314751, 'CA', 'CAN', 'كندا'),
(39498, 2810314752, 2810380287, 'AU', 'AUS', 'أستراليا'),
(39499, 2810380288, 2810576895, 'US', 'USA', 'الولايات المتحدة'),
(39500, 2810576896, 2810642431, 'VE', 'VEN', 'فنزويلا'),
(39501, 2810642432, 2810904575, 'US', 'USA', 'الولايات المتحدة'),
(39502, 2810904576, 2810970111, 'CN', 'CHN', 'الصين'),
(39503, 2810970112, 2811559935, 'US', 'USA', 'الولايات المتحدة'),
(39504, 2811559936, 2811625471, 'CH', 'CHE', 'سويسرا'),
(39505, 2811625472, 2812084223, 'US', 'USA', 'الولايات المتحدة'),
(39506, 2812084224, 2812149759, 'BO', 'BOL', 'بوليفيا'),
(39507, 2812149760, 2812411903, 'US', 'USA', 'الولايات المتحدة'),
(39508, 2812411904, 2812477439, 'AU', 'AUS', 'أستراليا'),
(39509, 2812477440, 2812805119, 'US', 'USA', 'الولايات المتحدة'),
(39510, 2812805120, 2812870655, 'CH', 'CHE', 'سويسرا'),
(39511, 2812870656, 2812936191, 'JP', 'JPN', 'اليابان'),
(39512, 2812936192, 2813067263, 'US', 'USA', 'الولايات المتحدة'),
(39513, 2813067264, 2813132799, 'GB', 'GBR', 'المملكة المتحدة'),
(39514, 2813132800, 2813263871, 'US', 'USA', 'الولايات المتحدة'),
(39515, 2813263872, 2813329407, 'JP', 'JPN', 'اليابان'),
(39516, 2813329408, 2813526015, 'US', 'USA', 'الولايات المتحدة'),
(39517, 2813526016, 2813591551, 'NZ', 'NZL', 'نيوزيلاندا'),
(39518, 2813591552, 2814181375, 'US', 'USA', 'الولايات المتحدة'),
(39519, 2814181376, 2814246911, 'AU', 'AUS', 'أستراليا'),
(39520, 2814246912, 2815098879, 'US', 'USA', 'الولايات المتحدة'),
(39521, 2815098880, 2815164415, 'GB', 'GBR', 'المملكة المتحدة'),
(39522, 2815164416, 2815229951, 'US', 'USA', 'الولايات المتحدة'),
(39523, 2815229952, 2815295487, 'ID', 'IDN', 'إندونيسيا'),
(39524, 2815295488, 2815983615, 'US', 'USA', 'الولايات المتحدة'),
(39525, 2815983616, 2815986687, 'IL', 'ISR', 'إسرائيل'),
(39526, 2815986688, 2815986815, 'GB', 'GBR', 'المملكة المتحدة'),
(39527, 2815986816, 2815986831, 'IL', 'ISR', 'إسرائيل'),
(39528, 2815986832, 2815987215, 'GB', 'GBR', 'المملكة المتحدة'),
(39529, 2815987216, 2815987231, 'IL', 'ISR', 'إسرائيل'),
(39530, 2815987232, 2815987271, 'GB', 'GBR', 'المملكة المتحدة'),
(39531, 2815987272, 2815987327, 'IL', 'ISR', 'إسرائيل'),
(39532, 2815987328, 2815987391, 'GB', 'GBR', 'المملكة المتحدة'),
(39533, 2815987392, 2815987711, 'IL', 'ISR', 'إسرائيل'),
(39534, 2815987712, 2815988351, 'FR', 'FRA', 'فرنسا'),
(39535, 2815988352, 2815988383, 'GB', 'GBR', 'المملكة المتحدة'),
(39536, 2815988384, 2815988479, 'IL', 'ISR', 'إسرائيل'),
(39537, 2815988480, 2815988543, 'GB', 'GBR', 'المملكة المتحدة'),
(39538, 2815988544, 2816001151, 'IL', 'ISR', 'إسرائيل'),
(39539, 2816001152, 2816001183, 'DE', 'DEU', 'ألمانيا'),
(39540, 2816001184, 2816016383, 'IL', 'ISR', 'إسرائيل'),
(39541, 2816016384, 2816671743, 'US', 'USA', 'الولايات المتحدة'),
(39542, 2816671744, 2816737279, 'CA', 'CAN', 'كندا'),
(39543, 2816737280, 2818113535, 'US', 'USA', 'الولايات المتحدة'),
(39544, 2818244608, 2818310143, 'US', 'USA', 'الولايات المتحدة'),
(39545, 2818310144, 2818375679, 'AR', 'ARG', 'الأرجنتين'),
(39546, 2818375680, 2818572287, 'US', 'USA', 'الولايات المتحدة'),
(39547, 2818637824, 2818703359, 'CH', 'CHE', 'سويسرا'),
(39548, 2818703360, 2823159807, 'US', 'USA', 'الولايات المتحدة'),
(39549, 2823159808, 2823225343, 'HK', 'HKG', 'هونغ كونغ'),
(39550, 2823225344, 2823553023, 'US', 'USA', 'الولايات المتحدة'),
(39551, 2823618560, 2823684095, 'PA', 'PAN', 'بنما'),
(39552, 2823684096, 2823749631, 'KR', 'KOR', 'جمهورية كوريا'),
(39553, 2823749632, 2823815167, 'JP', 'JPN', 'اليابان'),
(39554, 2823946240, 2824011775, 'US', 'USA', 'الولايات المتحدة'),
(39555, 2824011776, 2824077311, 'AR', 'ARG', 'الأرجنتين'),
(39556, 2824077312, 2824404991, 'US', 'USA', 'الولايات المتحدة'),
(39557, 2824536064, 2824798207, 'US', 'USA', 'الولايات المتحدة'),
(39558, 2824798208, 2824863743, 'TW', 'TWN', 'تايوان'),
(39559, 2824863744, 2824929279, 'AR', 'ARG', 'الأرجنتين'),
(39560, 2824929280, 2825191423, 'US', 'USA', 'الولايات المتحدة'),
(39561, 2825191424, 2825256959, 'AR', 'ARG', 'الأرجنتين'),
(39562, 2825256960, 2825519103, 'US', 'USA', 'الولايات المتحدة'),
(39563, 2825519104, 2825584639, 'HK', 'HKG', 'هونغ كونغ'),
(39564, 2825584640, 2826108927, 'US', 'USA', 'الولايات المتحدة'),
(39565, 2826108928, 2826174463, 'KR', 'KOR', 'جمهورية كوريا'),
(39566, 2826174464, 2826436607, 'US', 'USA', 'الولايات المتحدة'),
(39567, 2826436608, 2826502143, 'TH', 'THA', 'تايلند'),
(39568, 2826567680, 2826633215, 'US', 'USA', 'الولايات المتحدة'),
(39569, 2826633216, 2826698751, 'GU', 'GUM', 'غوام'),
(39570, 2826698752, 2826829823, 'US', 'USA', 'الولايات المتحدة'),
(39571, 2826829824, 2826895359, 'KR', 'KOR', 'جمهورية كوريا'),
(39572, 2826895360, 2826960895, 'US', 'USA', 'الولايات المتحدة'),
(39573, 2827026432, 2827091967, 'US', 'USA', 'الولايات المتحدة'),
(39574, 2827091968, 2827157503, 'AU', 'AUS', 'أستراليا'),
(39575, 2827157504, 2827223039, 'KR', 'KOR', 'جمهورية كوريا'),
(39576, 2827223040, 2827288575, 'AU', 'AUS', 'أستراليا'),
(39577, 2827288576, 2827354111, 'US', 'USA', 'الولايات المتحدة'),
(39578, 2827354112, 2827419647, 'AU', 'AUS', 'أستراليا'),
(39579, 2827419648, 2827681791, 'US', 'USA', 'الولايات المتحدة'),
(39580, 2827681792, 2827747327, 'TR', 'TUR', 'تركيا'),
(39581, 2827747328, 2827812863, 'AU', 'AUS', 'أستراليا'),
(39582, 2827812864, 2827878399, 'US', 'USA', 'الولايات المتحدة'),
(39583, 2827943936, 2828009471, 'US', 'USA', 'الولايات المتحدة'),
(39584, 2828009472, 2828075007, 'CA', 'CAN', 'كندا'),
(39585, 2828075008, 2828533759, 'US', 'USA', 'الولايات المتحدة'),
(39586, 2828533760, 2828664831, 'AU', 'AUS', 'أستراليا'),
(39587, 2828664832, 2828730367, 'KR', 'KOR', 'جمهورية كوريا'),
(39588, 2828795904, 2829058047, 'US', 'USA', 'الولايات المتحدة'),
(39589, 2829058048, 2829123583, 'CN', 'CHN', 'الصين'),
(39590, 2829123584, 2829254655, 'US', 'USA', 'الولايات المتحدة'),
(39591, 2829254656, 2829320191, 'CH', 'CHE', 'سويسرا'),
(39592, 2829385728, 2829451263, 'MX', 'MEX', 'المكسيك'),
(39593, 2829451264, 2829516799, 'US', 'USA', 'الولايات المتحدة'),
(39594, 2829582336, 2829844479, 'US', 'USA', 'الولايات المتحدة'),
(39595, 2829910016, 2830106623, 'US', 'USA', 'الولايات المتحدة'),
(39596, 2830106624, 2830172159, 'CO', 'COL', 'كولومبيا'),
(39597, 2830172160, 2830434303, 'US', 'USA', 'الولايات المتحدة'),
(39598, 2830499840, 2830761983, 'US', 'USA', 'الولايات المتحدة'),
(39599, 2830761984, 2830827519, 'AU', 'AUS', 'أستراليا'),
(39600, 2830827520, 2830893055, 'KW', 'KWT', 'الكويت'),
(39601, 2830893056, 2830958591, 'KR', 'KOR', 'جمهورية كوريا'),
(39602, 2830958592, 2831286271, 'US', 'USA', 'الولايات المتحدة'),
(39603, 2831548416, 2831613951, 'AU', 'AUS', 'أستراليا'),
(39604, 2831613952, 2831810559, 'US', 'USA', 'الولايات المتحدة'),
(39605, 2831810560, 2831876095, 'IT', 'ITA', 'إيطاليا'),
(39606, 2831876096, 2832007167, 'US', 'USA', 'الولايات المتحدة'),
(39607, 2832138240, 2832269311, 'US', 'USA', 'الولايات المتحدة'),
(39608, 2832465920, 2832793599, 'US', 'USA', 'الولايات المتحدة'),
(39609, 2832793600, 2832859135, 'AU', 'AUS', 'أستراليا'),
(39610, 2832859136, 2832924671, 'US', 'USA', 'الولايات المتحدة'),
(39611, 2832924672, 2832990207, 'KR', 'KOR', 'جمهورية كوريا'),
(39612, 2832990208, 2833383423, 'US', 'USA', 'الولايات المتحدة'),
(39613, 2833383424, 2833448959, 'AR', 'ARG', 'الأرجنتين'),
(39614, 2833580032, 2833711103, 'US', 'USA', 'الولايات المتحدة'),
(39615, 2833711104, 2833776639, 'CL', 'CHL', 'تشيلي'),
(39616, 2833842176, 2833907711, 'US', 'USA', 'الولايات المتحدة'),
(39617, 2833907712, 2833973247, 'GT', 'GTM', 'غواتيمالا'),
(39618, 2833973248, 2833989631, 'US', 'USA', 'الولايات المتحدة'),
(39619, 2834038784, 2834497535, 'US', 'USA', 'الولايات المتحدة'),
(39620, 2834497536, 2834563071, 'SV', 'SLV', 'السلفادور'),
(39621, 2834563072, 2834825215, 'US', 'USA', 'الولايات المتحدة'),
(39622, 2834825216, 2834956287, 'KR', 'KOR', 'جمهورية كوريا'),
(39623, 2834956288, 2835087359, 'US', 'USA', 'الولايات المتحدة'),
(39624, 2835087360, 2835152895, 'AU', 'AUS', 'أستراليا'),
(39625, 2835218432, 2835283967, 'US', 'USA', 'الولايات المتحدة'),
(39626, 2835283968, 2835349503, 'MX', 'MEX', 'المكسيك'),
(39627, 2835480576, 2837446655, 'US', 'USA', 'الولايات المتحدة'),
(39628, 2837446656, 2839543807, 'CH', 'CHE', 'سويسرا'),
(39629, 2839543808, 2840015359, 'US', 'USA', 'الولايات المتحدة'),
(39630, 2840015360, 2840015615, 'GB', 'GBR', 'المملكة المتحدة'),
(39631, 2840015616, 2843803647, 'US', 'USA', 'الولايات المتحدة'),
(39632, 2843869184, 2844524543, 'US', 'USA', 'الولايات المتحدة'),
(39633, 2844524544, 2844590079, 'KR', 'KOR', 'جمهورية كوريا'),
(39634, 2844590080, 2845704191, 'US', 'USA', 'الولايات المتحدة'),
(39635, 2845704192, 2845769727, 'CU', 'CUB', 'كوبا'),
(39636, 2845835264, 2848276479, 'US', 'USA', 'الولايات المتحدة'),
(39637, 2848325632, 2848522239, 'US', 'USA', 'الولايات المتحدة'),
(39638, 2848522240, 2848587775, 'AU', 'AUS', 'أستراليا'),
(39639, 2848653312, 2848980991, 'US', 'USA', 'الولايات المتحدة'),
(39640, 2848980992, 2849177599, 'AU', 'AUS', 'أستراليا'),
(39641, 2849177600, 2849177855, 'JP', 'JPN', 'اليابان'),
(39642, 2849177856, 2849178111, 'CN', 'CHN', 'الصين'),
(39643, 2849178112, 2849178367, 'KR', 'KOR', 'جمهورية كوريا'),
(39644, 2849178368, 2849178623, 'TW', 'TWN', 'تايوان'),
(39645, 2849178624, 2849178879, 'ID', 'IDN', 'إندونيسيا'),
(39646, 2849178880, 2849179135, 'VN', 'VNM', 'فييتنام'),
(39647, 2849179136, 2849964031, 'AU', 'AUS', 'أستراليا'),
(39648, 2849964032, 2850029567, 'MY', 'MYS', 'ماليزيا'),
(39649, 2850029568, 2851012607, 'US', 'USA', 'الولايات المتحدة'),
(39650, 2851078144, 2852061183, 'US', 'USA', 'الولايات المتحدة'),
(39651, 2852192256, 2853306367, 'US', 'USA', 'الولايات المتحدة'),
(39652, 2853306368, 2853371903, 'CL', 'CHL', 'تشيلي'),
(39653, 2853371904, 2853765119, 'US', 'USA', 'الولايات المتحدة'),
(39654, 2853765120, 2853830655, 'MX', 'MEX', 'المكسيك'),
(39655, 2853830656, 2854617087, 'US', 'USA', 'الولايات المتحدة'),
(39656, 2854617088, 2854682623, 'MY', 'MYS', 'ماليزيا'),
(39657, 2854682624, 2855469055, 'US', 'USA', 'الولايات المتحدة'),
(39658, 2855469056, 2855484671, 'PY', 'PRY', 'باراغواي'),
(39659, 2855484672, 2855485439, 'AR', 'ARG', 'الأرجنتين'),
(39660, 2855485440, 2855501823, 'UY', 'URY', 'الأوروغواي'),
(39661, 2855501824, 2855534591, 'AR', 'ARG', 'الأرجنتين'),
(39662, 2855534592, 2856058879, 'US', 'USA', 'الولايات المتحدة'),
(39663, 2856058880, 2856124415, 'CH', 'CHE', 'سويسرا'),
(39664, 2856124416, 2856452095, 'US', 'USA', 'الولايات المتحدة'),
(39665, 2856452096, 2856517631, 'BR', 'BRA', 'البرازيل'),
(39666, 2856517632, 2856714239, 'US', 'USA', 'الولايات المتحدة'),
(39667, 2856714240, 2856779775, 'MX', 'MEX', 'المكسيك'),
(39668, 2856779776, 2857238527, 'US', 'USA', 'الولايات المتحدة'),
(39669, 2857697280, 2858352639, 'US', 'USA', 'الولايات المتحدة'),
(39670, 2858352640, 2858418175, 'SG', 'SGP', 'سنغافورة'),
(39671, 2858418176, 2859007999, 'US', 'USA', 'الولايات المتحدة'),
(39672, 2859008000, 2859073535, 'JP', 'JPN', 'اليابان'),
(39673, 2859073536, 2861957119, 'US', 'USA', 'الولايات المتحدة'),
(39674, 2862022656, 2862284799, 'US', 'USA', 'الولايات المتحدة'),
(39675, 2862284800, 2862350335, 'AR', 'ARG', 'الأرجنتين'),
(39676, 2862350336, 2862415871, 'US', 'USA', 'الولايات المتحدة'),
(39677, 2862415872, 2862481407, 'AU', 'AUS', 'أستراليا'),
(39678, 2862481408, 2863202303, 'US', 'USA', 'الولايات المتحدة'),
(39679, 2863202304, 2863267839, 'MX', 'MEX', 'المكسيك'),
(39680, 2863267840, 2863595519, 'US', 'USA', 'الولايات المتحدة'),
(39681, 2863595520, 2863661055, 'CA', 'CAN', 'كندا'),
(39682, 2863661056, 2863857663, 'US', 'USA', 'الولايات المتحدة'),
(39683, 2863857664, 2863923199, 'SG', 'SGP', 'سنغافورة'),
(39684, 2863923200, 2865577983, 'US', 'USA', 'الولايات المتحدة'),
(39685, 2865577984, 2865610751, 'BE', 'BEL', 'بلجيكا'),
(39686, 2865610752, 2865889279, 'US', 'USA', 'الولايات المتحدة'),
(39687, 2865889280, 2865954815, 'AR', 'ARG', 'الأرجنتين'),
(39688, 2865954816, 2867265535, 'US', 'USA', 'الولايات المتحدة'),
(39689, 2867331072, 2867396607, 'US', 'USA', 'الولايات المتحدة'),
(39690, 2867462144, 2867593215, 'US', 'USA', 'الولايات المتحدة'),
(39691, 2867593216, 2867639295, 'CH', 'CHE', 'سويسرا'),
(39692, 2867639296, 2867639551, 'AT', 'AUT', 'النمسا'),
(39693, 2867639552, 2867724287, 'CH', 'CHE', 'سويسرا'),
(39694, 2867855360, 2868117503, 'US', 'USA', 'الولايات المتحدة'),
(39695, 2868379648, 2868772863, 'US', 'USA', 'الولايات المتحدة'),
(39696, 2868838400, 2868903935, 'BE', 'BEL', 'بلجيكا'),
(39697, 2869952512, 2870018047, 'FR', 'FRA', 'فرنسا'),
(39698, 2870018048, 2870083583, 'DE', 'DEU', 'ألمانيا'),
(39699, 2870083584, 2870149119, 'FR', 'FRA', 'فرنسا'),
(39700, 2870149120, 2870214655, 'HU', 'HUN', 'هنغاريا'),
(39701, 2870214656, 2870280191, 'DK', 'DNK', 'الدنيمارك'),
(39702, 2870280192, 2870345727, 'NL', 'NLD', 'هولندا'),
(39703, 2870345728, 2870411263, 'GB', 'GBR', 'المملكة المتحدة'),
(39704, 2870411264, 2870476799, 'NO', 'NOR', 'النرويج'),
(39705, 2870476800, 2870542335, 'DE', 'DEU', 'ألمانيا'),
(39706, 2870542336, 2870575103, 'CH', 'CHE', 'سويسرا'),
(39707, 2870575104, 2870583295, 'SE', 'SWE', 'السويد'),
(39708, 2870583296, 2870583551, 'NL', 'NLD', 'هولندا'),
(39709, 2870583552, 2870584319, 'NO', 'NOR', 'النرويج'),
(39710, 2870607872, 2870673407, 'BE', 'BEL', 'بلجيكا'),
(39711, 2870673408, 2870738943, 'CH', 'CHE', 'سويسرا'),
(39712, 2870738944, 2870935551, 'GB', 'GBR', 'المملكة المتحدة'),
(39713, 2870935552, 2871001087, 'HU', 'HUN', 'هنغاريا'),
(39714, 2871001088, 2871066623, 'SE', 'SWE', 'السويد'),
(39715, 2871066624, 2871083007, 'CH', 'CHE', 'سويسرا'),
(39716, 2873098240, 2873884671, 'US', 'USA', 'الولايات المتحدة'),
(39717, 2877292544, 2882469887, 'US', 'USA', 'الولايات المتحدة'),
(39718, 2894069760, 2899902463, 'US', 'USA', 'الولايات المتحدة'),
(39719, 2902523904, 2904555519, 'US', 'USA', 'الولايات المتحدة'),
(39720, 2904555520, 2904817663, 'CA', 'CAN', 'كندا'),
(39721, 2904817664, 2905379327, 'US', 'USA', 'الولايات المتحدة'),
(39722, 2905379328, 2905379583, 'CA', 'CAN', 'كندا'),
(39723, 2905379584, 2905381887, 'US', 'USA', 'الولايات المتحدة'),
(39724, 2905381888, 2905382016, 'CA', 'CAN', 'كندا'),
(39725, 2905382017, 2905384191, 'US', 'USA', 'الولايات المتحدة'),
(39726, 2905384192, 2905384959, 'CA', 'CAN', 'كندا'),
(39727, 2905384960, 2905385215, 'US', 'USA', 'الولايات المتحدة'),
(39728, 2905385216, 2905385471, 'CA', 'CAN', 'كندا'),
(39729, 2905385472, 2905388031, 'US', 'USA', 'الولايات المتحدة'),
(39730, 2905388032, 2905388287, 'CA', 'CAN', 'كندا'),
(39731, 2905388288, 2905391871, 'US', 'USA', 'الولايات المتحدة'),
(39732, 2905391872, 2905392127, 'CA', 'CAN', 'كندا'),
(39733, 2905392128, 2905394687, 'US', 'USA', 'الولايات المتحدة'),
(39734, 2905394688, 2905394943, 'CA', 'CAN', 'كندا'),
(39735, 2905394944, 2905395455, 'US', 'USA', 'الولايات المتحدة'),
(39736, 2905395456, 2905398527, 'CA', 'CAN', 'كندا'),
(39737, 2905398528, 2905404671, 'US', 'USA', 'الولايات المتحدة'),
(39738, 2905404672, 2905405439, 'CA', 'CAN', 'كندا'),
(39739, 2905405440, 2905407743, 'US', 'USA', 'الولايات المتحدة'),
(39740, 2905407744, 2905407999, 'TW', 'TWN', 'تايوان'),
(39741, 2905408000, 2905450495, 'US', 'USA', 'الولايات المتحدة'),
(39742, 2905450496, 2905451007, 'CA', 'CAN', 'كندا'),
(39743, 2905451008, 2905451519, 'US', 'USA', 'الولايات المتحدة'),
(39744, 2905451520, 2905451647, 'PA', 'PAN', 'بنما'),
(39745, 2905451648, 2905451775, 'US', 'USA', 'الولايات المتحدة'),
(39746, 2905451776, 2905451903, 'PA', 'PAN', 'بنما'),
(39747, 2905451904, 2905473023, 'US', 'USA', 'الولايات المتحدة'),
(39748, 2905473024, 2905481215, 'CA', 'CAN', 'كندا'),
(39749, 2905481216, 2913992703, 'US', 'USA', 'الولايات المتحدة'),
(39750, 2913992704, 2914516991, 'CA', 'CAN', 'كندا'),
(39751, 2914516992, 2915237887, 'US', 'USA', 'الولايات المتحدة'),
(39752, 2915303424, 2915475455, 'US', 'USA', 'الولايات المتحدة'),
(39753, 2915565568, 2915860479, 'US', 'USA', 'الولايات المتحدة'),
(39754, 2915893248, 2915958783, 'US', 'USA', 'الولايات المتحدة'),
(39755, 2915958784, 2916024319, 'CA', 'CAN', 'كندا'),
(39756, 2916024320, 2916163583, 'US', 'USA', 'الولايات المتحدة'),
(39757, 2916163584, 2916171775, 'CA', 'CAN', 'كندا'),
(39758, 2916171776, 2916175871, 'US', 'USA', 'الولايات المتحدة'),
(39759, 2916179968, 2916184063, 'US', 'USA', 'الولايات المتحدة'),
(39760, 2916188160, 2916196351, 'CA', 'CAN', 'كندا'),
(39761, 2916196352, 2916200447, 'US', 'USA', 'الولايات المتحدة'),
(39762, 2916204544, 2916253695, 'US', 'USA', 'الولايات المتحدة'),
(39763, 2916253696, 2916286463, 'CA', 'CAN', 'كندا'),
(39764, 2916286464, 2916319231, 'US', 'USA', 'الولايات المتحدة'),
(39765, 2916319232, 2916335615, 'PR', 'PRI', 'بورتو ريكو'),
(39766, 2916352000, 2916364287, 'US', 'USA', 'الولايات المتحدة'),
(39767, 2916368384, 2916401151, 'CA', 'CAN', 'كندا'),
(39768, 2916401152, 2916410879, 'US', 'USA', 'الولايات المتحدة'),
(39769, 2916410880, 2916411135, 'GB', 'GBR', 'المملكة المتحدة'),
(39770, 2916411136, 2916417535, 'US', 'USA', 'الولايات المتحدة'),
(39771, 2916417536, 2916433919, 'CA', 'CAN', 'كندا'),
(39772, 2916433920, 2916434175, 'US', 'USA', 'الولايات المتحدة'),
(39773, 2916434176, 2916434495, 'CA', 'CAN', 'كندا'),
(39774, 2916434496, 2916434559, 'US', 'USA', 'الولايات المتحدة'),
(39775, 2916434560, 2916434591, 'CA', 'CAN', 'كندا'),
(39776, 2916434592, 2916437503, 'US', 'USA', 'الولايات المتحدة'),
(39777, 2916437504, 2916437567, 'CA', 'CAN', 'كندا'),
(39778, 2916437568, 2916442623, 'US', 'USA', 'الولايات المتحدة'),
(39779, 2916442624, 2916442879, 'CA', 'CAN', 'كندا'),
(39780, 2916442880, 2916443582, 'US', 'USA', 'الولايات المتحدة'),
(39781, 2916443583, 2916443614, 'PK', 'PAK', 'باكستان'),
(39782, 2916443615, 2916443647, 'CA', 'CAN', 'كندا'),
(39783, 2916443648, 2916444927, 'US', 'USA', 'الولايات المتحدة'),
(39784, 2916444928, 2916445951, 'CA', 'CAN', 'كندا'),
(39785, 2916445952, 2916447231, 'US', 'USA', 'الولايات المتحدة'),
(39786, 2916447232, 2916448255, 'CA', 'CAN', 'كندا'),
(39787, 2916448256, 2916449279, 'US', 'USA', 'الولايات المتحدة'),
(39788, 2916449280, 2916450303, 'CA', 'CAN', 'كندا'),
(39789, 2916450304, 2916470783, 'US', 'USA', 'الولايات المتحدة'),
(39790, 2916483072, 2916499455, 'US', 'USA', 'الولايات المتحدة'),
(39791, 2916548608, 2916581375, 'US', 'USA', 'الولايات المتحدة'),
(39792, 2916581376, 2916614143, 'PR', 'PRI', 'بورتو ريكو'),
(39793, 2916614144, 2917171199, 'US', 'USA', 'الولايات المتحدة'),
(39794, 2917175296, 2917195775, 'US', 'USA', 'الولايات المتحدة'),
(39795, 2917195776, 2917203967, 'CA', 'CAN', 'كندا'),
(39796, 2917203968, 2917240831, 'US', 'USA', 'الولايات المتحدة'),
(39797, 2917244928, 2917257215, 'US', 'USA', 'الولايات المتحدة'),
(39798, 2917257216, 2917261311, 'KY', 'CYM', 'جزر كايمان'),
(39799, 2917261312, 2917265407, 'US', 'USA', 'الولايات المتحدة'),
(39800, 2917265408, 2917269503, 'JM', 'JAM', 'جامايكا'),
(39801, 2917269504, 2917441535, 'US', 'USA', 'الولايات المتحدة'),
(39802, 2917466112, 2917474303, 'US', 'USA', 'الولايات المتحدة'),
(39803, 2917498880, 2917572607, 'US', 'USA', 'الولايات المتحدة'),
(39804, 2917572608, 2917580799, 'CA', 'CAN', 'كندا'),
(39805, 2917580800, 2917593087, 'US', 'USA', 'الولايات المتحدة'),
(39806, 2917597184, 2917621759, 'US', 'USA', 'الولايات المتحدة'),
(39807, 2917629952, 2917646335, 'US', 'USA', 'الولايات المتحدة'),
(39808, 2917662720, 2917676799, 'US', 'USA', 'الولايات المتحدة'),
(39809, 2917676800, 2917677055, 'CA', 'CAN', 'كندا'),
(39810, 2917677056, 2917677567, 'US', 'USA', 'الولايات المتحدة'),
(39811, 2917677568, 2917678335, 'CA', 'CAN', 'كندا'),
(39812, 2917678336, 2917680895, 'US', 'USA', 'الولايات المتحدة'),
(39813, 2917680896, 2917681407, 'CA', 'CAN', 'كندا'),
(39814, 2917681408, 2917681919, 'US', 'USA', 'الولايات المتحدة'),
(39815, 2917681920, 2917682175, 'CA', 'CAN', 'كندا'),
(39816, 2917682176, 2917685247, 'US', 'USA', 'الولايات المتحدة'),
(39817, 2917685248, 2917686015, 'CA', 'CAN', 'كندا'),
(39818, 2917686016, 2917690367, 'US', 'USA', 'الولايات المتحدة'),
(39819, 2917690368, 2917690623, 'CA', 'CAN', 'كندا'),
(39820, 2917690624, 2917699583, 'US', 'USA', 'الولايات المتحدة'),
(39821, 2917699584, 2917699839, 'CA', 'CAN', 'كندا'),
(39822, 2917699840, 2917701119, 'US', 'USA', 'الولايات المتحدة'),
(39823, 2917701120, 2917701375, 'CA', 'CAN', 'كندا'),
(39824, 2917701376, 2917706239, 'US', 'USA', 'الولايات المتحدة'),
(39825, 2917706240, 2917707007, 'CA', 'CAN', 'كندا'),
(39826, 2917707008, 2917713919, 'US', 'USA', 'الولايات المتحدة'),
(39827, 2917713920, 2917714431, 'CA', 'CAN', 'كندا'),
(39828, 2917714432, 2917718527, 'US', 'USA', 'الولايات المتحدة'),
(39829, 2917718528, 2917719039, 'CA', 'CAN', 'كندا'),
(39830, 2917719040, 2917722367, 'US', 'USA', 'الولايات المتحدة'),
(39831, 2917722368, 2917723135, 'CA', 'CAN', 'كندا'),
(39832, 2917723136, 2917875711, 'US', 'USA', 'الولايات المتحدة'),
(39833, 2917924864, 2917994495, 'US', 'USA', 'الولايات المتحدة'),
(39834, 2918121472, 2918141951, 'US', 'USA', 'الولايات المتحدة'),
(39835, 2918187008, 2918232063, 'US', 'USA', 'الولايات المتحدة'),
(39836, 2918232064, 2918236159, 'CA', 'CAN', 'كندا'),
(39837, 2918236160, 2918248447, 'US', 'USA', 'الولايات المتحدة'),
(39838, 2918481920, 2918486015, 'US', 'USA', 'الولايات المتحدة'),
(39839, 2919206912, 2919211007, 'CA', 'CAN', 'كندا'),
(39840, 2919235584, 2919759871, 'CA', 'CAN', 'كندا'),
(39841, 2919759872, 2921496895, 'US', 'USA', 'الولايات المتحدة'),
(39842, 2921496896, 2921496903, 'IN', 'IND', 'الهند'),
(39843, 2921496904, 2921496967, 'US', 'USA', 'الولايات المتحدة'),
(39844, 2921496968, 2921496975, 'IN', 'IND', 'الهند'),
(39845, 2921496976, 2921497415, 'US', 'USA', 'الولايات المتحدة'),
(39846, 2921497416, 2921497423, 'IN', 'IND', 'الهند'),
(39847, 2921497424, 2921497471, 'US', 'USA', 'الولايات المتحدة'),
(39848, 2921497472, 2921497599, 'IN', 'IND', 'الهند'),
(39849, 2921497600, 2921503695, 'US', 'USA', 'الولايات المتحدة'),
(39850, 2921503696, 2921503703, 'GB', 'GBR', 'المملكة المتحدة'),
(39851, 2921503704, 2921505919, 'US', 'USA', 'الولايات المتحدة'),
(39852, 2921505920, 2921506015, 'IN', 'IND', 'الهند'),
(39853, 2921506016, 2921506431, 'US', 'USA', 'الولايات المتحدة'),
(39854, 2921506432, 2921506463, 'IN', 'IND', 'الهند'),
(39855, 2921506464, 2921508095, 'US', 'USA', 'الولايات المتحدة'),
(39856, 2921508096, 2921508103, 'IN', 'IND', 'الهند'),
(39857, 2921508104, 2921508319, 'US', 'USA', 'الولايات المتحدة'),
(39858, 2921508320, 2921508351, 'IN', 'IND', 'الهند'),
(39859, 2921508352, 2921508639, 'US', 'USA', 'الولايات المتحدة'),
(39860, 2921508640, 2921508671, 'IN', 'IND', 'الهند'),
(39861, 2921508672, 2921508679, 'US', 'USA', 'الولايات المتحدة'),
(39862, 2921508680, 2921508727, 'IN', 'IND', 'الهند'),
(39863, 2921508728, 2921511351, 'US', 'USA', 'الولايات المتحدة'),
(39864, 2921511352, 2921511359, 'IN', 'IND', 'الهند'),
(39865, 2921511360, 2921512703, 'US', 'USA', 'الولايات المتحدة'),
(39866, 2921512704, 2921512959, 'CA', 'CAN', 'كندا'),
(39867, 2921512960, 2921562111, 'US', 'USA', 'الولايات المتحدة'),
(39868, 2921562112, 2921594879, 'CA', 'CAN', 'كندا'),
(39869, 2921594880, 2925002751, 'US', 'USA', 'الولايات المتحدة'),
(39870, 2925002752, 2925527039, 'CA', 'CAN', 'كندا'),
(39871, 2925527040, 2926575615, 'US', 'USA', 'الولايات المتحدة'),
(39872, 2926575616, 2927099903, 'CA', 'CAN', 'كندا'),
(39873, 2927099904, 2927575039, 'US', 'USA', 'الولايات المتحدة'),
(39874, 2927591424, 2927599615, 'US', 'USA', 'الولايات المتحدة'),
(39875, 2927689728, 2928177151, 'US', 'USA', 'الولايات المتحدة'),
(39876, 2928181248, 2928226303, 'US', 'USA', 'الولايات المتحدة'),
(39877, 2928226304, 2928228087, 'CA', 'CAN', 'كندا'),
(39878, 2928228088, 2928228095, 'RU', 'RUS', 'الإتحاد الروسي'),
(39879, 2928228096, 2928230399, 'CA', 'CAN', 'كندا'),
(39880, 2928230400, 2928261375, 'US', 'USA', 'الولايات المتحدة'),
(39881, 2928261376, 2928261887, 'CA', 'CAN', 'كندا'),
(39882, 2928261888, 2928263167, 'US', 'USA', 'الولايات المتحدة'),
(39883, 2928263168, 2928279551, 'CA', 'CAN', 'كندا'),
(39884, 2928279552, 2928312319, 'US', 'USA', 'الولايات المتحدة'),
(39885, 2928312320, 2928316415, 'CA', 'CAN', 'كندا'),
(39886, 2928316416, 2928323135, 'US', 'USA', 'الولايات المتحدة'),
(39887, 2928323136, 2928323143, 'RU', 'RUS', 'الإتحاد الروسي'),
(39888, 2928323144, 2928323967, 'US', 'USA', 'الولايات المتحدة'),
(39889, 2928323968, 2928323983, 'RU', 'RUS', 'الإتحاد الروسي'),
(39890, 2928323984, 2928328703, 'US', 'USA', 'الولايات المتحدة'),
(39891, 2928328704, 2928336895, 'CA', 'CAN', 'كندا'),
(39892, 2928336896, 2928455679, 'US', 'USA', 'الولايات المتحدة'),
(39893, 2928455680, 2928459775, 'CA', 'CAN', 'كندا'),
(39894, 2928459776, 2928541695, 'US', 'USA', 'الولايات المتحدة'),
(39895, 2928541696, 2928571615, 'CA', 'CAN', 'كندا'),
(39896, 2928571616, 2928571647, 'IT', 'ITA', 'إيطاليا'),
(39897, 2928571648, 2928607231, 'CA', 'CAN', 'كندا'),
(39898, 2928607232, 2936012799, 'US', 'USA', 'الولايات المتحدة'),
(39899, 2936012800, 2937847807, 'CN', 'CHN', 'الصين'),
(39900, 2937847808, 2937848831, 'KH', 'KHM', 'كامبوديا'),
(39901, 2937848832, 2937849855, 'JP', 'JPN', 'اليابان'),
(39902, 2937849856, 2937850879, 'AU', 'AUS', 'أستراليا'),
(39903, 2937850880, 2937851903, 'MY', 'MYS', 'ماليزيا'),
(39904, 2937851904, 2937855999, 'JP', 'JPN', 'اليابان'),
(39905, 2937856000, 2937860095, 'KR', 'KOR', 'جمهورية كوريا'),
(39906, 2937860096, 2937864191, 'JP', 'JPN', 'اليابان'),
(39907, 2937864192, 2937880575, 'SG', 'SGP', 'سنغافورة'),
(39908, 2937880576, 2937913343, 'JP', 'JPN', 'اليابان'),
(39909, 2937913344, 2937978879, 'BD', 'BGD', 'بنغالاديش'),
(39910, 2937978880, 2938109951, 'CN', 'CHN', 'الصين'),
(39911, 2938109952, 2938634239, 'AU', 'AUS', 'أستراليا'),
(39912, 2938634240, 2938699775, 'IN', 'IND', 'الهند'),
(39913, 2938699776, 2938703871, 'KR', 'KOR', 'جمهورية كوريا'),
(39914, 2938703872, 2938707967, 'HK', 'HKG', 'هونغ كونغ'),
(39915, 2938707968, 2938710015, 'JP', 'JPN', 'اليابان'),
(39916, 2938710016, 2938712063, 'AU', 'AUS', 'أستراليا'),
(39917, 2938712064, 2938716159, 'TW', 'TWN', 'تايوان'),
(39918, 2938716160, 2938732543, 'JP', 'JPN', 'اليابان'),
(39919, 2938732544, 2938765311, 'SG', 'SGP', 'سنغافورة'),
(39920, 2938765312, 2938961919, 'CN', 'CHN', 'الصين'),
(39921, 2938961920, 2938978303, 'HK', 'HKG', 'هونغ كونغ'),
(39922, 2938978304, 2938996735, 'AU', 'AUS', 'أستراليا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(39923, 2938996736, 2938998783, 'JP', 'JPN', 'اليابان'),
(39924, 2938998784, 2939002879, 'AU', 'AUS', 'أستراليا'),
(39925, 2939002880, 2939004927, 'KR', 'KOR', 'جمهورية كوريا'),
(39926, 2939004928, 2939006975, 'JP', 'JPN', 'اليابان'),
(39927, 2939006976, 2939007999, 'KP', 'PRK', 'جمهورية كوريا الشعبية الديمقراطية'),
(39928, 2939008000, 2939009023, 'IN', 'IND', 'الهند'),
(39929, 2939009024, 2939011071, 'ID', 'IDN', 'إندونيسيا'),
(39930, 2939011072, 2939027455, 'KR', 'KOR', 'جمهورية كوريا'),
(39931, 2939027456, 2942304255, 'CN', 'CHN', 'الصين'),
(39932, 2942304256, 2942566399, 'TW', 'TWN', 'تايوان'),
(39933, 2942566400, 2942599167, 'KH', 'KHM', 'كامبوديا'),
(39934, 2942599168, 2942608383, 'IN', 'IND', 'الهند'),
(39935, 2942608384, 2942609407, 'HK', 'HKG', 'هونغ كونغ'),
(39936, 2942609408, 2942615551, 'IN', 'IND', 'الهند'),
(39937, 2942615552, 2942619647, 'HK', 'HKG', 'هونغ كونغ'),
(39938, 2942619648, 2942631935, 'JP', 'JPN', 'اليابان'),
(39939, 2942631936, 2942697471, 'IN', 'IND', 'الهند'),
(39940, 2942697472, 2942763007, 'CN', 'CHN', 'الصين'),
(39941, 2942763008, 2942767103, 'JP', 'JPN', 'اليابان'),
(39942, 2942767104, 2942771199, 'AU', 'AUS', 'أستراليا'),
(39943, 2942771200, 2942779391, 'ID', 'IDN', 'إندونيسيا'),
(39944, 2942779392, 2942795775, 'AU', 'AUS', 'أستراليا'),
(39945, 2942795776, 2942959615, 'JP', 'JPN', 'اليابان'),
(39946, 2942959616, 2942960639, 'VN', 'VNM', 'فييتنام'),
(39947, 2942960640, 2942961663, 'AU', 'AUS', 'أستراليا'),
(39948, 2942961664, 2942965759, 'ID', 'IDN', 'إندونيسيا'),
(39949, 2942965760, 2942967807, 'AU', 'AUS', 'أستراليا'),
(39950, 2942967808, 2942975999, 'AF', 'AFG', 'أفغانستان'),
(39951, 2942976000, 2942992383, 'KR', 'KOR', 'جمهورية كوريا'),
(39952, 2942992384, 2943025151, 'CN', 'CHN', 'الصين'),
(39953, 2943025152, 2943041535, 'PK', 'PAK', 'باكستان'),
(39954, 2943041536, 2943057919, 'KR', 'KOR', 'جمهورية كوريا'),
(39955, 2943057920, 2943090687, 'AU', 'AUS', 'أستراليا'),
(39956, 2943090688, 2943221759, 'JP', 'JPN', 'اليابان'),
(39957, 2943221760, 2943291391, 'PK', 'PAK', 'باكستان'),
(39958, 2943291392, 2943295487, 'KR', 'KOR', 'جمهورية كوريا'),
(39959, 2943295488, 2943303679, 'TW', 'TWN', 'تايوان'),
(39960, 2943303680, 2943309823, 'JP', 'JPN', 'اليابان'),
(39961, 2943309824, 2943310847, 'ID', 'IDN', 'إندونيسيا'),
(39962, 2943310848, 2943311871, 'JP', 'JPN', 'اليابان'),
(39963, 2943311872, 2943312895, 'HK', 'HKG', 'هونغ كونغ'),
(39964, 2943312896, 2943313919, 'NZ', 'NZL', 'نيوزيلاندا'),
(39965, 2943313920, 2943314943, 'SG', 'SGP', 'سنغافورة'),
(39966, 2943314944, 2943315967, 'BD', 'BGD', 'بنغالاديش'),
(39967, 2943315968, 2943318015, 'ID', 'IDN', 'إندونيسيا'),
(39968, 2943318016, 2943320063, 'JP', 'JPN', 'اليابان'),
(39969, 2943320064, 2943336447, 'PK', 'PAK', 'باكستان'),
(39970, 2943336448, 2943352831, 'TW', 'TWN', 'تايوان'),
(39971, 2943352832, 2944401407, 'KR', 'KOR', 'جمهورية كوريا'),
(39972, 2944401408, 2944925695, 'JP', 'JPN', 'اليابان'),
(39973, 2944925696, 2945581055, 'MY', 'MYS', 'ماليزيا'),
(39974, 2945581056, 2946236415, 'CN', 'CHN', 'الصين'),
(39975, 2946236416, 2946301951, 'SG', 'SGP', 'سنغافورة'),
(39976, 2946301952, 2946367487, 'LK', 'LKA', 'سيريلانكا'),
(39977, 2946367488, 2946375679, 'KR', 'KOR', 'جمهورية كوريا'),
(39978, 2946375680, 2946383871, 'ID', 'IDN', 'إندونيسيا'),
(39979, 2946383872, 2946392063, 'IN', 'IND', 'الهند'),
(39980, 2946392064, 2946393087, 'BD', 'BGD', 'بنغالاديش'),
(39981, 2946393088, 2946394111, 'JP', 'JPN', 'اليابان'),
(39982, 2946394112, 2946396159, 'AU', 'AUS', 'أستراليا'),
(39983, 2946396160, 2946400255, 'JP', 'JPN', 'اليابان'),
(39984, 2946400256, 2946416639, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(39985, 2946416640, 2946433023, 'PH', 'PHL', 'الفلبين'),
(39986, 2946433024, 2946498559, 'HK', 'HKG', 'هونغ كونغ'),
(39987, 2946498560, 2947547135, 'CN', 'CHN', 'الصين'),
(39988, 2947547136, 2947579903, 'PH', 'PHL', 'الفلبين'),
(39989, 2947579904, 2947583999, 'KR', 'KOR', 'جمهورية كوريا'),
(39990, 2947584000, 2947586047, 'TO', 'TON', 'تونغا'),
(39991, 2947586048, 2947588095, 'JP', 'JPN', 'اليابان'),
(39992, 2947588096, 2947590143, 'ID', 'IDN', 'إندونيسيا'),
(39993, 2947590144, 2947590655, 'JP', 'JPN', 'اليابان'),
(39994, 2947590656, 2947590927, 'HK', 'HKG', 'هونغ كونغ'),
(39995, 2947590928, 2947592191, 'SG', 'SGP', 'سنغافورة'),
(39996, 2947592192, 2947596287, 'HK', 'HKG', 'هونغ كونغ'),
(39997, 2947596288, 2947597311, 'IN', 'IND', 'الهند'),
(39998, 2947597312, 2947598335, 'JP', 'JPN', 'اليابان'),
(39999, 2947598336, 2947602431, 'AU', 'AUS', 'أستراليا'),
(40000, 2947602432, 2947603455, 'NZ', 'NZL', 'نيوزيلاندا'),
(40001, 2947603456, 2947604479, 'TH', 'THA', 'تايلند'),
(40002, 2947604480, 2947612671, 'HK', 'HKG', 'هونغ كونغ'),
(40003, 2947612672, 2947678207, 'JP', 'JPN', 'اليابان'),
(40004, 2947678208, 2947743743, 'CN', 'CHN', 'الصين'),
(40005, 2947743744, 2947809279, 'JP', 'JPN', 'اليابان'),
(40006, 2947809280, 2948071423, 'TW', 'TWN', 'تايوان'),
(40007, 2948071424, 2948104191, 'JP', 'JPN', 'اليابان'),
(40008, 2948104192, 2948120575, 'CN', 'CHN', 'الصين'),
(40009, 2948120576, 2948128767, 'AU', 'AUS', 'أستراليا'),
(40010, 2948128768, 2948132863, 'ID', 'IDN', 'إندونيسيا'),
(40011, 2948132864, 2948134911, 'TW', 'TWN', 'تايوان'),
(40012, 2948134912, 2948135935, 'ID', 'IDN', 'إندونيسيا'),
(40013, 2948135936, 2948136959, 'IN', 'IND', 'الهند'),
(40014, 2948136960, 2948595711, 'CN', 'CHN', 'الصين'),
(40015, 2948595712, 2952790015, 'KR', 'KOR', 'جمهورية كوريا'),
(40016, 2986344448, 2987393023, 'DE', 'DEU', 'ألمانيا'),
(40017, 2987393024, 2987397119, 'GB', 'GBR', 'المملكة المتحدة'),
(40018, 2987397120, 2987401215, 'LV', 'LVA', 'لاتفيا'),
(40019, 2987401216, 2987405311, 'LT', 'LTU', 'ليتوانيا'),
(40020, 2987405312, 2987409407, 'DE', 'DEU', 'ألمانيا'),
(40021, 2987409408, 2987413503, 'NO', 'NOR', 'النرويج'),
(40022, 2987413504, 2987417599, 'UA', 'UKR', 'أوكرانيا'),
(40023, 2987417600, 2987425791, 'PL', 'POL', 'بولندا'),
(40024, 2987425792, 2987429887, 'BG', 'BGR', 'بلغاريا'),
(40025, 2987429888, 2987433983, 'RU', 'RUS', 'الإتحاد الروسي'),
(40026, 2987433984, 2987438079, 'FR', 'FRA', 'فرنسا'),
(40027, 2987438080, 2987442175, 'FI', 'FIN', 'فنلندا'),
(40028, 2987442176, 2987446271, 'IE', 'IRL', 'إيرلندا'),
(40029, 2987446272, 2987450367, 'SE', 'SWE', 'السويد'),
(40030, 2987450368, 2987454463, 'GB', 'GBR', 'المملكة المتحدة'),
(40031, 2987454464, 2987458559, 'FR', 'FRA', 'فرنسا'),
(40032, 2987458560, 2987462655, 'CZ', 'CZE', 'التشيك'),
(40033, 2987462656, 2987466751, 'RS', 'SRB', 'صربيا'),
(40034, 2987466752, 2987470847, 'GB', 'GBR', 'المملكة المتحدة'),
(40035, 2987470848, 2987474943, 'IQ', 'IRQ', 'العراق'),
(40036, 2987474944, 2987479039, 'GB', 'GBR', 'المملكة المتحدة'),
(40037, 2987479040, 2987487231, 'CZ', 'CZE', 'التشيك'),
(40038, 2987487232, 2987491327, 'HR', 'HRV', 'كرواتيا'),
(40039, 2987491328, 2987495423, 'RU', 'RUS', 'الإتحاد الروسي'),
(40040, 2987495424, 2987499519, 'NO', 'NOR', 'النرويج'),
(40041, 2987499520, 2987500103, 'MD', 'MDA', 'مولدوفا'),
(40042, 2987500104, 2987500111, 'US', 'USA', 'الولايات المتحدة'),
(40043, 2987500112, 2987503615, 'MD', 'MDA', 'مولدوفا'),
(40044, 2987503616, 2987511807, 'RU', 'RUS', 'الإتحاد الروسي'),
(40045, 2987511808, 2987515903, 'JO', 'JOR', 'الأردن'),
(40046, 2987515904, 2987519999, 'DE', 'DEU', 'ألمانيا'),
(40047, 2987520000, 2987524095, 'GB', 'GBR', 'المملكة المتحدة'),
(40048, 2987524096, 2987528191, 'RU', 'RUS', 'الإتحاد الروسي'),
(40049, 2987528192, 2987532287, 'NL', 'NLD', 'هولندا'),
(40050, 2987532288, 2987536383, 'MD', 'MDA', 'مولدوفا'),
(40051, 2987536384, 2987540479, 'FR', 'FRA', 'فرنسا'),
(40052, 2987540480, 2987544575, 'SK', 'SVK', 'سلوفاكيا'),
(40053, 2987544576, 2987548671, 'NL', 'NLD', 'هولندا'),
(40054, 2987548672, 2987552767, 'RU', 'RUS', 'الإتحاد الروسي'),
(40055, 2987552768, 2987556863, 'GB', 'GBR', 'المملكة المتحدة'),
(40056, 2987556864, 2987560959, 'NL', 'NLD', 'هولندا'),
(40057, 2987655168, 2987659263, 'DE', 'DEU', 'ألمانيا'),
(40058, 2987659264, 2987659519, 'BA', 'BIH', 'البوسنه والهرسك'),
(40059, 2987659520, 2987661311, 'SI', 'SVN', 'سلوفينيا'),
(40060, 2987661312, 2987663359, 'GB', 'GBR', 'المملكة المتحدة'),
(40061, 2987663360, 2987665407, 'IT', 'ITA', 'إيطاليا'),
(40062, 2987665408, 2987667455, 'RU', 'RUS', 'الإتحاد الروسي'),
(40063, 2987667456, 2987669503, 'FR', 'FRA', 'فرنسا'),
(40064, 2987669504, 2987671551, 'NL', 'NLD', 'هولندا'),
(40065, 2987671552, 2987673599, 'FR', 'FRA', 'فرنسا'),
(40066, 2987673600, 2987675647, 'IT', 'ITA', 'إيطاليا'),
(40067, 2987675648, 2987677695, 'IE', 'IRL', 'إيرلندا'),
(40068, 2987677696, 2987681791, 'DE', 'DEU', 'ألمانيا'),
(40069, 2987681792, 2987683839, 'NO', 'NOR', 'النرويج'),
(40070, 2987683840, 2987685887, 'IT', 'ITA', 'إيطاليا'),
(40071, 2987685888, 2987687935, 'GR', 'GRC', 'اليونان'),
(40072, 2987687936, 2987689983, 'RU', 'RUS', 'الإتحاد الروسي'),
(40073, 2987689984, 2987692031, 'CZ', 'CZE', 'التشيك'),
(40074, 2987692032, 2987694079, 'SA', 'SAU', 'السعودية'),
(40075, 2987694080, 2987696127, 'UA', 'UKR', 'أوكرانيا'),
(40076, 2987696128, 2987698175, 'RS', 'SRB', 'صربيا'),
(40077, 2987698176, 2987700223, 'NL', 'NLD', 'هولندا'),
(40078, 2987700224, 2987702271, 'RU', 'RUS', 'الإتحاد الروسي'),
(40079, 2987702272, 2987704319, 'JO', 'JOR', 'الأردن'),
(40080, 2987704320, 2987706367, 'GB', 'GBR', 'المملكة المتحدة'),
(40081, 2987706368, 2987708415, 'RS', 'SRB', 'صربيا'),
(40082, 2987708416, 2987710463, 'PT', 'PRT', 'البورتوغال'),
(40083, 2987710464, 2987712511, 'DK', 'DNK', 'الدنيمارك'),
(40084, 2987712512, 2987714559, 'GB', 'GBR', 'المملكة المتحدة'),
(40085, 2987714560, 2987716607, 'RU', 'RUS', 'الإتحاد الروسي'),
(40086, 2987716608, 2987718655, 'FR', 'FRA', 'فرنسا'),
(40087, 2987718656, 2987720703, 'NL', 'NLD', 'هولندا'),
(40088, 2987720704, 2987722751, 'DE', 'DEU', 'ألمانيا'),
(40089, 2987722752, 2987724799, 'RU', 'RUS', 'الإتحاد الروسي'),
(40090, 2987724800, 2987726847, 'NL', 'NLD', 'هولندا'),
(40091, 2987726848, 2987728895, 'RU', 'RUS', 'الإتحاد الروسي'),
(40092, 2987728896, 2987730943, 'GB', 'GBR', 'المملكة المتحدة'),
(40093, 2987730944, 2987732991, 'IR', 'IRN', 'إيران'),
(40094, 2987732992, 2987735039, 'HU', 'HUN', 'هنغاريا'),
(40095, 2987735040, 2987737087, 'ES', 'ESP', 'إسبانيا'),
(40096, 2987737088, 2987739135, 'RU', 'RUS', 'الإتحاد الروسي'),
(40097, 2987739136, 2987743231, 'SE', 'SWE', 'السويد'),
(40098, 2987743232, 2987745279, 'DK', 'DNK', 'الدنيمارك'),
(40099, 2987745280, 2987747327, 'IT', 'ITA', 'إيطاليا'),
(40100, 2987747328, 2987749375, 'ES', 'ESP', 'إسبانيا'),
(40101, 2987749376, 2987751423, 'NL', 'NLD', 'هولندا'),
(40102, 2987751424, 2987753471, 'RO', 'ROM', 'رومانيا'),
(40103, 2987753472, 2987755519, 'NO', 'NOR', 'النرويج'),
(40104, 2987755520, 2987757567, 'PL', 'POL', 'بولندا'),
(40105, 2987757568, 2987759615, 'DE', 'DEU', 'ألمانيا'),
(40106, 2987759616, 2987761663, 'PL', 'POL', 'بولندا'),
(40107, 2987761664, 2987763711, 'DK', 'DNK', 'الدنيمارك'),
(40108, 2987763712, 2987765759, 'GR', 'GRC', 'اليونان'),
(40109, 2987765760, 2987767807, 'FR', 'FRA', 'فرنسا'),
(40110, 2987767808, 2987769855, 'CZ', 'CZE', 'التشيك'),
(40111, 2987769856, 2987771903, 'FI', 'FIN', 'فنلندا'),
(40112, 2987771904, 2987773951, 'IT', 'ITA', 'إيطاليا'),
(40113, 2987773952, 2987775999, 'FR', 'FRA', 'فرنسا'),
(40114, 2987776000, 2987778047, 'NL', 'NLD', 'هولندا'),
(40115, 2987778048, 2987780095, 'CH', 'CHE', 'سويسرا'),
(40116, 2987780096, 2987782143, 'GB', 'GBR', 'المملكة المتحدة'),
(40117, 2987782144, 2987784191, 'EE', 'EST', 'إستونيا'),
(40118, 2987784192, 2987786239, 'DK', 'DNK', 'الدنيمارك'),
(40119, 2987786240, 2987788287, 'FR', 'FRA', 'فرنسا'),
(40120, 2987788288, 2987788543, 'GB', 'GBR', 'المملكة المتحدة'),
(40121, 2987788544, 2987790335, 'TR', 'TUR', 'تركيا'),
(40122, 2987790336, 2987792383, 'GB', 'GBR', 'المملكة المتحدة'),
(40123, 2987792384, 2987794431, 'CH', 'CHE', 'سويسرا'),
(40124, 2987794432, 2987796479, 'IQ', 'IRQ', 'العراق'),
(40125, 2987796480, 2987800575, 'RU', 'RUS', 'الإتحاد الروسي'),
(40126, 2987800576, 2987802623, 'NL', 'NLD', 'هولندا'),
(40127, 2987802624, 2987804671, 'CH', 'CHE', 'سويسرا'),
(40128, 2987804672, 2987806719, 'IR', 'IRN', 'إيران'),
(40129, 2987806720, 2987808767, 'NL', 'NLD', 'هولندا'),
(40130, 2987808768, 2987810815, 'RU', 'RUS', 'الإتحاد الروسي'),
(40131, 2987810816, 2987812863, 'NO', 'NOR', 'النرويج'),
(40132, 2987812864, 2987814911, 'CH', 'CHE', 'سويسرا'),
(40133, 2987814912, 2987816959, 'CZ', 'CZE', 'التشيك'),
(40134, 2987816960, 2987819007, 'NL', 'NLD', 'هولندا'),
(40135, 2987819008, 2987821055, 'FR', 'FRA', 'فرنسا'),
(40136, 2987821056, 2987823103, 'GB', 'GBR', 'المملكة المتحدة'),
(40137, 2987823104, 2987827199, 'FR', 'FRA', 'فرنسا'),
(40138, 2987827200, 2987829247, 'GB', 'GBR', 'المملكة المتحدة'),
(40139, 2987829248, 2987831295, 'KZ', 'KAZ', 'كازاخستان'),
(40140, 2987831296, 2987833343, 'FR', 'FRA', 'فرنسا'),
(40141, 2987833344, 2987835391, 'IT', 'ITA', 'إيطاليا'),
(40142, 2987835392, 2987837439, 'RU', 'RUS', 'الإتحاد الروسي'),
(40143, 2987837440, 2987839487, 'SE', 'SWE', 'السويد'),
(40144, 2987839488, 2987841535, 'GB', 'GBR', 'المملكة المتحدة'),
(40145, 2987841536, 2987843583, 'RS', 'SRB', 'صربيا'),
(40146, 2987843584, 2987845631, 'HU', 'HUN', 'هنغاريا'),
(40147, 2987845632, 2987847679, 'NL', 'NLD', 'هولندا'),
(40148, 2987847680, 2987849727, 'FR', 'FRA', 'فرنسا'),
(40149, 2987849728, 2987851775, 'IT', 'ITA', 'إيطاليا'),
(40150, 2987851776, 2987853823, 'RU', 'RUS', 'الإتحاد الروسي'),
(40151, 2987853824, 2987855871, 'IT', 'ITA', 'إيطاليا'),
(40152, 2987917312, 2988179455, 'DE', 'DEU', 'ألمانيا'),
(40153, 2988179456, 2988441599, 'SE', 'SWE', 'السويد'),
(40154, 2988441600, 2988441603, 'CH', 'CHE', 'سويسرا'),
(40155, 2988441604, 2988441655, 'FR', 'FRA', 'فرنسا'),
(40156, 2988441656, 2988441663, 'DE', 'DEU', 'ألمانيا'),
(40157, 2988441664, 2988441839, 'FR', 'FRA', 'فرنسا'),
(40158, 2988441840, 2988441843, 'PL', 'POL', 'بولندا'),
(40159, 2988441844, 2988441847, 'BE', 'BEL', 'بلجيكا'),
(40160, 2988441848, 2988441855, 'FR', 'FRA', 'فرنسا'),
(40161, 2988441856, 2988441887, 'IT', 'ITA', 'إيطاليا'),
(40162, 2988441888, 2988441895, 'FR', 'FRA', 'فرنسا'),
(40163, 2988441896, 2988441903, 'PL', 'POL', 'بولندا'),
(40164, 2988441904, 2988441911, 'IT', 'ITA', 'إيطاليا'),
(40165, 2988441912, 2988441983, 'FR', 'FRA', 'فرنسا'),
(40166, 2988441984, 2988441999, 'NL', 'NLD', 'هولندا'),
(40167, 2988442000, 2988442003, 'FR', 'FRA', 'فرنسا'),
(40168, 2988442004, 2988442007, 'ES', 'ESP', 'إسبانيا'),
(40169, 2988442008, 2988442047, 'FR', 'FRA', 'فرنسا'),
(40170, 2988442048, 2988442063, 'GB', 'GBR', 'المملكة المتحدة'),
(40171, 2988442064, 2988442067, 'FR', 'FRA', 'فرنسا'),
(40172, 2988442068, 2988442071, 'BE', 'BEL', 'بلجيكا'),
(40173, 2988442072, 2988442075, 'FR', 'FRA', 'فرنسا'),
(40174, 2988442076, 2988442079, 'GB', 'GBR', 'المملكة المتحدة'),
(40175, 2988442080, 2988442399, 'FR', 'FRA', 'فرنسا'),
(40176, 2988442400, 2988442431, 'ES', 'ESP', 'إسبانيا'),
(40177, 2988442432, 2988442439, 'CZ', 'CZE', 'التشيك'),
(40178, 2988442440, 2988442447, 'ES', 'ESP', 'إسبانيا'),
(40179, 2988442448, 2988442463, 'GB', 'GBR', 'المملكة المتحدة'),
(40180, 2988442464, 2988442895, 'FR', 'FRA', 'فرنسا'),
(40181, 2988442896, 2988442919, 'NL', 'NLD', 'هولندا'),
(40182, 2988442920, 2988442923, 'LT', 'LTU', 'ليتوانيا'),
(40183, 2988442924, 2988442927, 'GB', 'GBR', 'المملكة المتحدة'),
(40184, 2988442928, 2988442975, 'FR', 'FRA', 'فرنسا'),
(40185, 2988442976, 2988443023, 'GB', 'GBR', 'المملكة المتحدة'),
(40186, 2988443024, 2988443027, 'FR', 'FRA', 'فرنسا'),
(40187, 2988443028, 2988443031, 'BE', 'BEL', 'بلجيكا'),
(40188, 2988443032, 2988443035, 'GB', 'GBR', 'المملكة المتحدة'),
(40189, 2988443036, 2988443039, 'BE', 'BEL', 'بلجيكا'),
(40190, 2988443040, 2988443055, 'PL', 'POL', 'بولندا'),
(40191, 2988443056, 2988443071, 'DE', 'DEU', 'ألمانيا'),
(40192, 2988443072, 2988443087, 'ES', 'ESP', 'إسبانيا'),
(40193, 2988443088, 2988443111, 'PL', 'POL', 'بولندا'),
(40194, 2988443112, 2988443119, 'ES', 'ESP', 'إسبانيا'),
(40195, 2988443120, 2988443391, 'FR', 'FRA', 'فرنسا'),
(40196, 2988443392, 2988443407, 'ES', 'ESP', 'إسبانيا'),
(40197, 2988443408, 2988443455, 'FR', 'FRA', 'فرنسا'),
(40198, 2988443456, 2988443487, 'BE', 'BEL', 'بلجيكا'),
(40199, 2988443488, 2988443539, 'FR', 'FRA', 'فرنسا'),
(40200, 2988443540, 2988443547, 'ES', 'ESP', 'إسبانيا'),
(40201, 2988443548, 2988443551, 'IT', 'ITA', 'إيطاليا'),
(40202, 2988443552, 2988443555, 'FR', 'FRA', 'فرنسا'),
(40203, 2988443556, 2988443559, 'PL', 'POL', 'بولندا'),
(40204, 2988443560, 2988443563, 'GB', 'GBR', 'المملكة المتحدة'),
(40205, 2988443564, 2988443567, 'PL', 'POL', 'بولندا'),
(40206, 2988443568, 2988443583, 'FR', 'FRA', 'فرنسا'),
(40207, 2988443584, 2988443647, 'GB', 'GBR', 'المملكة المتحدة'),
(40208, 2988443648, 2988444167, 'FR', 'FRA', 'فرنسا'),
(40209, 2988444168, 2988444171, 'CZ', 'CZE', 'التشيك'),
(40210, 2988444172, 2988444199, 'FR', 'FRA', 'فرنسا'),
(40211, 2988444200, 2988444203, 'DE', 'DEU', 'ألمانيا'),
(40212, 2988444204, 2988444207, 'NL', 'NLD', 'هولندا'),
(40213, 2988444208, 2988444415, 'FR', 'FRA', 'فرنسا'),
(40214, 2988444416, 2988444679, 'ES', 'ESP', 'إسبانيا'),
(40215, 2988444680, 2988444695, 'PL', 'POL', 'بولندا'),
(40216, 2988444696, 2988444719, 'FR', 'FRA', 'فرنسا'),
(40217, 2988444720, 2988444735, 'ES', 'ESP', 'إسبانيا'),
(40218, 2988444736, 2988444739, 'GB', 'GBR', 'المملكة المتحدة'),
(40219, 2988444740, 2988444755, 'BE', 'BEL', 'بلجيكا'),
(40220, 2988444756, 2988444759, 'DE', 'DEU', 'ألمانيا'),
(40221, 2988444760, 2988444767, 'IE', 'IRL', 'إيرلندا'),
(40222, 2988444768, 2988444771, 'DE', 'DEU', 'ألمانيا'),
(40223, 2988444772, 2988444775, 'GB', 'GBR', 'المملكة المتحدة'),
(40224, 2988444776, 2988444783, 'CZ', 'CZE', 'التشيك'),
(40225, 2988444784, 2988444799, 'FR', 'FRA', 'فرنسا'),
(40226, 2988444800, 2988445055, 'ES', 'ESP', 'إسبانيا'),
(40227, 2988445056, 2988445119, 'FR', 'FRA', 'فرنسا'),
(40228, 2988445120, 2988445151, 'IT', 'ITA', 'إيطاليا'),
(40229, 2988445152, 2988445183, 'GB', 'GBR', 'المملكة المتحدة'),
(40230, 2988445184, 2988445951, 'DE', 'DEU', 'ألمانيا'),
(40231, 2988445952, 2988445967, 'FR', 'FRA', 'فرنسا'),
(40232, 2988445968, 2988445983, 'GB', 'GBR', 'المملكة المتحدة'),
(40233, 2988445984, 2988446207, 'DE', 'DEU', 'ألمانيا'),
(40234, 2988446208, 2988446271, 'PL', 'POL', 'بولندا'),
(40235, 2988446272, 2988446275, 'IT', 'ITA', 'إيطاليا'),
(40236, 2988446276, 2988446279, 'GB', 'GBR', 'المملكة المتحدة'),
(40237, 2988446280, 2988446287, 'FR', 'FRA', 'فرنسا'),
(40238, 2988446288, 2988446303, 'GB', 'GBR', 'المملكة المتحدة'),
(40239, 2988446304, 2988446323, 'FR', 'FRA', 'فرنسا'),
(40240, 2988446324, 2988446327, 'LT', 'LTU', 'ليتوانيا'),
(40241, 2988446328, 2988446335, 'NL', 'NLD', 'هولندا'),
(40242, 2988446336, 2988446399, 'PL', 'POL', 'بولندا'),
(40243, 2988446400, 2988446463, 'FR', 'FRA', 'فرنسا'),
(40244, 2988446464, 2988446719, 'PL', 'POL', 'بولندا'),
(40245, 2988446720, 2988446975, 'DE', 'DEU', 'ألمانيا'),
(40246, 2988446976, 2988447103, 'IT', 'ITA', 'إيطاليا'),
(40247, 2988447104, 2988447231, 'FR', 'FRA', 'فرنسا'),
(40248, 2988447232, 2988447871, 'DE', 'DEU', 'ألمانيا'),
(40249, 2988447872, 2988447923, 'PL', 'POL', 'بولندا'),
(40250, 2988447924, 2988447927, 'IT', 'ITA', 'إيطاليا'),
(40251, 2988447928, 2988447935, 'PL', 'POL', 'بولندا'),
(40252, 2988447936, 2988447943, 'DE', 'DEU', 'ألمانيا'),
(40253, 2988447944, 2988447947, 'NL', 'NLD', 'هولندا'),
(40254, 2988447948, 2988447951, 'DE', 'DEU', 'ألمانيا'),
(40255, 2988447952, 2988447955, 'GB', 'GBR', 'المملكة المتحدة'),
(40256, 2988447956, 2988447959, 'BE', 'BEL', 'بلجيكا'),
(40257, 2988447960, 2988447967, 'IT', 'ITA', 'إيطاليا'),
(40258, 2988447968, 2988447999, 'GB', 'GBR', 'المملكة المتحدة'),
(40259, 2988448000, 2988448127, 'DE', 'DEU', 'ألمانيا'),
(40260, 2988448128, 2988448255, 'ES', 'ESP', 'إسبانيا'),
(40261, 2988448256, 2988448511, 'DE', 'DEU', 'ألمانيا'),
(40262, 2988448512, 2988448515, 'ES', 'ESP', 'إسبانيا'),
(40263, 2988448516, 2988448519, 'FR', 'FRA', 'فرنسا'),
(40264, 2988448520, 2988448543, 'PL', 'POL', 'بولندا'),
(40265, 2988448544, 2988448559, 'FR', 'FRA', 'فرنسا'),
(40266, 2988448560, 2988448563, 'DE', 'DEU', 'ألمانيا'),
(40267, 2988448564, 2988448567, 'ES', 'ESP', 'إسبانيا'),
(40268, 2988448568, 2988448607, 'FR', 'FRA', 'فرنسا'),
(40269, 2988448608, 2988448639, 'ES', 'ESP', 'إسبانيا'),
(40270, 2988448640, 2988448671, 'GB', 'GBR', 'المملكة المتحدة'),
(40271, 2988448672, 2988448691, 'IT', 'ITA', 'إيطاليا'),
(40272, 2988448692, 2988448695, 'DE', 'DEU', 'ألمانيا'),
(40273, 2988448696, 2988448699, 'IT', 'ITA', 'إيطاليا'),
(40274, 2988448700, 2988448703, 'LT', 'LTU', 'ليتوانيا'),
(40275, 2988448704, 2988448767, 'GB', 'GBR', 'المملكة المتحدة'),
(40276, 2988448768, 2988448783, 'FR', 'FRA', 'فرنسا'),
(40277, 2988448784, 2988448815, 'PL', 'POL', 'بولندا'),
(40278, 2988448816, 2988448831, 'ES', 'ESP', 'إسبانيا'),
(40279, 2988448832, 2988448895, 'FR', 'FRA', 'فرنسا'),
(40280, 2988448896, 2988448899, 'PT', 'PRT', 'البورتوغال'),
(40281, 2988448900, 2988448903, 'PL', 'POL', 'بولندا'),
(40282, 2988448904, 2988448907, 'ES', 'ESP', 'إسبانيا'),
(40283, 2988448908, 2988448959, 'FR', 'FRA', 'فرنسا'),
(40284, 2988448960, 2988448991, 'DE', 'DEU', 'ألمانيا'),
(40285, 2988448992, 2988449007, 'FR', 'FRA', 'فرنسا'),
(40286, 2988449008, 2988449023, 'GB', 'GBR', 'المملكة المتحدة'),
(40287, 2988449024, 2988449055, 'PL', 'POL', 'بولندا'),
(40288, 2988449056, 2988449087, 'ES', 'ESP', 'إسبانيا'),
(40289, 2988449088, 2988449103, 'PL', 'POL', 'بولندا'),
(40290, 2988449104, 2988449119, 'DE', 'DEU', 'ألمانيا'),
(40291, 2988449120, 2988449123, 'FR', 'FRA', 'فرنسا'),
(40292, 2988449124, 2988449127, 'DE', 'DEU', 'ألمانيا'),
(40293, 2988449128, 2988449135, 'ES', 'ESP', 'إسبانيا'),
(40294, 2988449136, 2988449151, 'FR', 'FRA', 'فرنسا'),
(40295, 2988449152, 2988449279, 'PL', 'POL', 'بولندا'),
(40296, 2988449280, 2988449535, 'GB', 'GBR', 'المملكة المتحدة'),
(40297, 2988449536, 2988449663, 'PL', 'POL', 'بولندا'),
(40298, 2988449664, 2988449695, 'DE', 'DEU', 'ألمانيا'),
(40299, 2988449696, 2988449727, 'IT', 'ITA', 'إيطاليا'),
(40300, 2988449728, 2988449743, 'BE', 'BEL', 'بلجيكا'),
(40301, 2988449744, 2988449759, 'GB', 'GBR', 'المملكة المتحدة'),
(40302, 2988449760, 2988449791, 'CH', 'CHE', 'سويسرا'),
(40303, 2988449792, 2988451839, 'FR', 'FRA', 'فرنسا'),
(40304, 2988451840, 2988453887, 'BE', 'BEL', 'بلجيكا'),
(40305, 2988453888, 2988457987, 'GB', 'GBR', 'المملكة المتحدة'),
(40306, 2988457988, 2988457991, 'PL', 'POL', 'بولندا'),
(40307, 2988457992, 2988458031, 'FR', 'FRA', 'فرنسا'),
(40308, 2988458032, 2988458047, 'IT', 'ITA', 'إيطاليا'),
(40309, 2988458048, 2988458067, 'ES', 'ESP', 'إسبانيا'),
(40310, 2988458068, 2988458075, 'FR', 'FRA', 'فرنسا'),
(40311, 2988458076, 2988458111, 'PL', 'POL', 'بولندا'),
(40312, 2988458112, 2988458255, 'FR', 'FRA', 'فرنسا'),
(40313, 2988458256, 2988458271, 'IT', 'ITA', 'إيطاليا'),
(40314, 2988458272, 2988458287, 'PL', 'POL', 'بولندا'),
(40315, 2988458288, 2988458295, 'FR', 'FRA', 'فرنسا'),
(40316, 2988458296, 2988458299, 'GB', 'GBR', 'المملكة المتحدة'),
(40317, 2988458300, 2988458319, 'ES', 'ESP', 'إسبانيا'),
(40318, 2988458320, 2988458323, 'CZ', 'CZE', 'التشيك'),
(40319, 2988458324, 2988458335, 'FR', 'FRA', 'فرنسا'),
(40320, 2988458336, 2988458367, 'DE', 'DEU', 'ألمانيا'),
(40321, 2988458368, 2988458399, 'FR', 'FRA', 'فرنسا'),
(40322, 2988458400, 2988458431, 'PL', 'POL', 'بولندا'),
(40323, 2988458432, 2988458495, 'FR', 'FRA', 'فرنسا'),
(40324, 2988458496, 2988458751, 'GB', 'GBR', 'المملكة المتحدة'),
(40325, 2988458752, 2988459015, 'PL', 'POL', 'بولندا'),
(40326, 2988459016, 2988459019, 'DE', 'DEU', 'ألمانيا'),
(40327, 2988459020, 2988459023, 'GB', 'GBR', 'المملكة المتحدة'),
(40328, 2988459024, 2988459039, 'DE', 'DEU', 'ألمانيا'),
(40329, 2988459040, 2988459051, 'FR', 'FRA', 'فرنسا'),
(40330, 2988459052, 2988459055, 'ES', 'ESP', 'إسبانيا'),
(40331, 2988459056, 2988459071, 'CH', 'CHE', 'سويسرا'),
(40332, 2988459072, 2988459075, 'GB', 'GBR', 'المملكة المتحدة'),
(40333, 2988459076, 2988459079, 'ES', 'ESP', 'إسبانيا'),
(40334, 2988459080, 2988459103, 'GB', 'GBR', 'المملكة المتحدة'),
(40335, 2988459104, 2988459107, 'FR', 'FRA', 'فرنسا'),
(40336, 2988459108, 2988459111, 'IT', 'ITA', 'إيطاليا'),
(40337, 2988459112, 2988459119, 'ES', 'ESP', 'إسبانيا'),
(40338, 2988459120, 2988459127, 'IT', 'ITA', 'إيطاليا'),
(40339, 2988459128, 2988459135, 'PL', 'POL', 'بولندا'),
(40340, 2988459136, 2988459167, 'IT', 'ITA', 'إيطاليا'),
(40341, 2988459168, 2988459171, 'IE', 'IRL', 'إيرلندا'),
(40342, 2988459172, 2988459183, 'FR', 'FRA', 'فرنسا'),
(40343, 2988459184, 2988459199, 'ES', 'ESP', 'إسبانيا'),
(40344, 2988459200, 2988459215, 'FR', 'FRA', 'فرنسا'),
(40345, 2988459216, 2988459219, 'ES', 'ESP', 'إسبانيا'),
(40346, 2988459220, 2988459223, 'FR', 'FRA', 'فرنسا'),
(40347, 2988459224, 2988459231, 'DE', 'DEU', 'ألمانيا'),
(40348, 2988459232, 2988459263, 'PL', 'POL', 'بولندا'),
(40349, 2988459264, 2988459519, 'ES', 'ESP', 'إسبانيا'),
(40350, 2988459520, 2988459583, 'DE', 'DEU', 'ألمانيا'),
(40351, 2988459584, 2988459599, 'FR', 'FRA', 'فرنسا'),
(40352, 2988459600, 2988459603, 'GB', 'GBR', 'المملكة المتحدة'),
(40353, 2988459604, 2988459615, 'FR', 'FRA', 'فرنسا'),
(40354, 2988459616, 2988459631, 'CZ', 'CZE', 'التشيك'),
(40355, 2988459632, 2988459639, 'FR', 'FRA', 'فرنسا'),
(40356, 2988459640, 2988459643, 'IT', 'ITA', 'إيطاليا'),
(40357, 2988459644, 2988459647, 'CH', 'CHE', 'سويسرا'),
(40358, 2988459648, 2988459711, 'NL', 'NLD', 'هولندا'),
(40359, 2988459712, 2988459715, 'ES', 'ESP', 'إسبانيا'),
(40360, 2988459716, 2988459719, 'FR', 'FRA', 'فرنسا'),
(40361, 2988459720, 2988459727, 'GB', 'GBR', 'المملكة المتحدة'),
(40362, 2988459728, 2988459731, 'FR', 'FRA', 'فرنسا'),
(40363, 2988459732, 2988459735, 'BE', 'BEL', 'بلجيكا'),
(40364, 2988459736, 2988459743, 'PL', 'POL', 'بولندا'),
(40365, 2988459744, 2988459747, 'ES', 'ESP', 'إسبانيا'),
(40366, 2988459748, 2988459751, 'PL', 'POL', 'بولندا'),
(40367, 2988459752, 2988460031, 'FR', 'FRA', 'فرنسا'),
(40368, 2988460032, 2988460063, 'DE', 'DEU', 'ألمانيا'),
(40369, 2988460064, 2988460095, 'FR', 'FRA', 'فرنسا'),
(40370, 2988460096, 2988460103, 'ES', 'ESP', 'إسبانيا'),
(40371, 2988460104, 2988460107, 'PL', 'POL', 'بولندا'),
(40372, 2988460108, 2988460111, 'DE', 'DEU', 'ألمانيا'),
(40373, 2988460112, 2988460119, 'FR', 'FRA', 'فرنسا'),
(40374, 2988460120, 2988460123, 'ES', 'ESP', 'إسبانيا'),
(40375, 2988460124, 2988460127, 'FR', 'FRA', 'فرنسا'),
(40376, 2988460128, 2988460131, 'PL', 'POL', 'بولندا'),
(40377, 2988460132, 2988460135, 'CZ', 'CZE', 'التشيك'),
(40378, 2988460136, 2988460147, 'FR', 'FRA', 'فرنسا'),
(40379, 2988460148, 2988460151, 'GB', 'GBR', 'المملكة المتحدة'),
(40380, 2988460152, 2988460159, 'ES', 'ESP', 'إسبانيا'),
(40381, 2988460160, 2988460191, 'GB', 'GBR', 'المملكة المتحدة'),
(40382, 2988460192, 2988460195, 'FR', 'FRA', 'فرنسا'),
(40383, 2988460196, 2988460199, 'CZ', 'CZE', 'التشيك'),
(40384, 2988460200, 2988460207, 'FR', 'FRA', 'فرنسا'),
(40385, 2988460208, 2988460223, 'PL', 'POL', 'بولندا'),
(40386, 2988460224, 2988460239, 'FR', 'FRA', 'فرنسا'),
(40387, 2988460240, 2988460243, 'BE', 'BEL', 'بلجيكا'),
(40388, 2988460244, 2988460247, 'PL', 'POL', 'بولندا'),
(40389, 2988460248, 2988460255, 'FR', 'FRA', 'فرنسا'),
(40390, 2988460256, 2988460271, 'ES', 'ESP', 'إسبانيا'),
(40391, 2988460272, 2988460319, 'FR', 'FRA', 'فرنسا'),
(40392, 2988460320, 2988460335, 'GB', 'GBR', 'المملكة المتحدة'),
(40393, 2988460336, 2988460351, 'DE', 'DEU', 'ألمانيا'),
(40394, 2988460352, 2988460375, 'GB', 'GBR', 'المملكة المتحدة'),
(40395, 2988460376, 2988460543, 'FR', 'FRA', 'فرنسا'),
(40396, 2988460544, 2988460547, 'GB', 'GBR', 'المملكة المتحدة'),
(40397, 2988460548, 2988460551, 'FR', 'FRA', 'فرنسا'),
(40398, 2988460552, 2988460575, 'PL', 'POL', 'بولندا'),
(40399, 2988460576, 2988460591, 'PT', 'PRT', 'البورتوغال'),
(40400, 2988460592, 2988460607, 'GB', 'GBR', 'المملكة المتحدة'),
(40401, 2988460608, 2988460671, 'FR', 'FRA', 'فرنسا'),
(40402, 2988460672, 2988460687, 'DE', 'DEU', 'ألمانيا'),
(40403, 2988460688, 2988460703, 'FR', 'FRA', 'فرنسا'),
(40404, 2988460704, 2988460711, 'CH', 'CHE', 'سويسرا'),
(40405, 2988460712, 2988460719, 'FR', 'FRA', 'فرنسا'),
(40406, 2988460720, 2988460735, 'ES', 'ESP', 'إسبانيا'),
(40407, 2988460736, 2988460767, 'FR', 'FRA', 'فرنسا'),
(40408, 2988460768, 2988460799, 'PL', 'POL', 'بولندا'),
(40409, 2988460800, 2988461055, 'FR', 'FRA', 'فرنسا'),
(40410, 2988461056, 2988461119, 'IE', 'IRL', 'إيرلندا'),
(40411, 2988461120, 2988461151, 'NL', 'NLD', 'هولندا'),
(40412, 2988461152, 2988461247, 'GB', 'GBR', 'المملكة المتحدة'),
(40413, 2988461248, 2988461255, 'FR', 'FRA', 'فرنسا'),
(40414, 2988461256, 2988461295, 'IT', 'ITA', 'إيطاليا'),
(40415, 2988461296, 2988461299, 'PL', 'POL', 'بولندا'),
(40416, 2988461300, 2988461307, 'FR', 'FRA', 'فرنسا'),
(40417, 2988461308, 2988461311, 'PL', 'POL', 'بولندا'),
(40418, 2988461312, 2988461375, 'CH', 'CHE', 'سويسرا'),
(40419, 2988461376, 2988461391, 'FR', 'FRA', 'فرنسا'),
(40420, 2988461392, 2988461395, 'CH', 'CHE', 'سويسرا'),
(40421, 2988461396, 2988461399, 'DE', 'DEU', 'ألمانيا'),
(40422, 2988461400, 2988461403, 'ES', 'ESP', 'إسبانيا'),
(40423, 2988461404, 2988461407, 'GB', 'GBR', 'المملكة المتحدة'),
(40424, 2988461408, 2988461411, 'IT', 'ITA', 'إيطاليا'),
(40425, 2988461412, 2988461415, 'NL', 'NLD', 'هولندا'),
(40426, 2988461416, 2988461423, 'FR', 'FRA', 'فرنسا'),
(40427, 2988461424, 2988461431, 'IT', 'ITA', 'إيطاليا'),
(40428, 2988461432, 2988461435, 'PT', 'PRT', 'البورتوغال'),
(40429, 2988461436, 2988461439, 'BE', 'BEL', 'بلجيكا'),
(40430, 2988461440, 2988461471, 'ES', 'ESP', 'إسبانيا'),
(40431, 2988461472, 2988461475, 'PL', 'POL', 'بولندا'),
(40432, 2988461476, 2988461479, 'IE', 'IRL', 'إيرلندا'),
(40433, 2988461480, 2988461483, 'CZ', 'CZE', 'التشيك'),
(40434, 2988461484, 2988461487, 'LT', 'LTU', 'ليتوانيا'),
(40435, 2988461488, 2988461495, 'FR', 'FRA', 'فرنسا'),
(40436, 2988461496, 2988461499, 'ES', 'ESP', 'إسبانيا'),
(40437, 2988461500, 2988461503, 'BE', 'BEL', 'بلجيكا'),
(40438, 2988461504, 2988461519, 'PL', 'POL', 'بولندا'),
(40439, 2988461520, 2988461523, 'ES', 'ESP', 'إسبانيا'),
(40440, 2988461524, 2988461559, 'FR', 'FRA', 'فرنسا'),
(40441, 2988461560, 2988461567, 'GB', 'GBR', 'المملكة المتحدة'),
(40442, 2988461568, 2988461599, 'FR', 'FRA', 'فرنسا'),
(40443, 2988461600, 2988461615, 'BE', 'BEL', 'بلجيكا'),
(40444, 2988461616, 2988461623, 'IT', 'ITA', 'إيطاليا'),
(40445, 2988461624, 2988461695, 'FR', 'FRA', 'فرنسا'),
(40446, 2988461696, 2988461699, 'DE', 'DEU', 'ألمانيا'),
(40447, 2988461700, 2988461703, 'FR', 'FRA', 'فرنسا'),
(40448, 2988461704, 2988461707, 'NL', 'NLD', 'هولندا'),
(40449, 2988461708, 2988461711, 'BE', 'BEL', 'بلجيكا'),
(40450, 2988461712, 2988461719, 'FR', 'FRA', 'فرنسا'),
(40451, 2988461720, 2988461723, 'GB', 'GBR', 'المملكة المتحدة'),
(40452, 2988461724, 2988461735, 'FR', 'FRA', 'فرنسا'),
(40453, 2988461736, 2988461747, 'DE', 'DEU', 'ألمانيا'),
(40454, 2988461748, 2988461751, 'IT', 'ITA', 'إيطاليا'),
(40455, 2988461752, 2988461755, 'FR', 'FRA', 'فرنسا'),
(40456, 2988461756, 2988461759, 'NL', 'NLD', 'هولندا'),
(40457, 2988461760, 2988461791, 'PL', 'POL', 'بولندا'),
(40458, 2988461792, 2988461799, 'IT', 'ITA', 'إيطاليا'),
(40459, 2988461800, 2988461811, 'DE', 'DEU', 'ألمانيا'),
(40460, 2988461812, 2988461815, 'FR', 'FRA', 'فرنسا'),
(40461, 2988461816, 2988461819, 'PL', 'POL', 'بولندا'),
(40462, 2988461820, 2988461823, 'GB', 'GBR', 'المملكة المتحدة'),
(40463, 2988461824, 2988461855, 'NL', 'NLD', 'هولندا'),
(40464, 2988461856, 2988461859, 'PL', 'POL', 'بولندا'),
(40465, 2988461860, 2988461871, 'DE', 'DEU', 'ألمانيا'),
(40466, 2988461872, 2988461879, 'FR', 'FRA', 'فرنسا'),
(40467, 2988461880, 2988461883, 'CZ', 'CZE', 'التشيك'),
(40468, 2988461884, 2988461887, 'IT', 'ITA', 'إيطاليا'),
(40469, 2988461888, 2988461903, 'FR', 'FRA', 'فرنسا'),
(40470, 2988461904, 2988461911, 'ES', 'ESP', 'إسبانيا'),
(40471, 2988461912, 2988461935, 'FR', 'FRA', 'فرنسا'),
(40472, 2988461936, 2988461951, 'GB', 'GBR', 'المملكة المتحدة'),
(40473, 2988461952, 2988462079, 'PL', 'POL', 'بولندا'),
(40474, 2988462080, 2988462095, 'CZ', 'CZE', 'التشيك'),
(40475, 2988462096, 2988462111, 'FR', 'FRA', 'فرنسا'),
(40476, 2988462112, 2988462119, 'PL', 'POL', 'بولندا'),
(40477, 2988462120, 2988462127, 'FR', 'FRA', 'فرنسا'),
(40478, 2988462128, 2988462131, 'ES', 'ESP', 'إسبانيا'),
(40479, 2988462132, 2988462159, 'FR', 'FRA', 'فرنسا'),
(40480, 2988462160, 2988462191, 'PL', 'POL', 'بولندا'),
(40481, 2988462192, 2988462199, 'FR', 'FRA', 'فرنسا'),
(40482, 2988462200, 2988462203, 'PL', 'POL', 'بولندا'),
(40483, 2988462204, 2988462319, 'FR', 'FRA', 'فرنسا'),
(40484, 2988462320, 2988462323, 'IT', 'ITA', 'إيطاليا'),
(40485, 2988462324, 2988462327, 'DE', 'DEU', 'ألمانيا'),
(40486, 2988462328, 2988462335, 'FR', 'FRA', 'فرنسا'),
(40487, 2988462336, 2988462463, 'ES', 'ESP', 'إسبانيا'),
(40488, 2988462464, 2988462495, 'GB', 'GBR', 'المملكة المتحدة'),
(40489, 2988462496, 2988462527, 'DE', 'DEU', 'ألمانيا'),
(40490, 2988462528, 2988462559, 'NL', 'NLD', 'هولندا'),
(40491, 2988462560, 2988462575, 'FR', 'FRA', 'فرنسا'),
(40492, 2988462576, 2988462583, 'PL', 'POL', 'بولندا'),
(40493, 2988462584, 2988462587, 'FR', 'FRA', 'فرنسا'),
(40494, 2988462588, 2988462591, 'DE', 'DEU', 'ألمانيا'),
(40495, 2988462592, 2988462599, 'FR', 'FRA', 'فرنسا'),
(40496, 2988462600, 2988462603, 'IT', 'ITA', 'إيطاليا'),
(40497, 2988462604, 2988462607, 'ES', 'ESP', 'إسبانيا'),
(40498, 2988462608, 2988462735, 'FR', 'FRA', 'فرنسا'),
(40499, 2988462736, 2988462751, 'BE', 'BEL', 'بلجيكا'),
(40500, 2988462752, 2988462767, 'FR', 'FRA', 'فرنسا'),
(40501, 2988462768, 2988462775, 'GB', 'GBR', 'المملكة المتحدة'),
(40502, 2988462776, 2988462779, 'PL', 'POL', 'بولندا'),
(40503, 2988462780, 2988462783, 'FR', 'FRA', 'فرنسا'),
(40504, 2988462784, 2988462799, 'DE', 'DEU', 'ألمانيا'),
(40505, 2988462800, 2988462815, 'FR', 'FRA', 'فرنسا'),
(40506, 2988462816, 2988462823, 'BE', 'BEL', 'بلجيكا'),
(40507, 2988462824, 2988462847, 'FR', 'FRA', 'فرنسا'),
(40508, 2988462848, 2988463103, 'BE', 'BEL', 'بلجيكا'),
(40509, 2988463104, 2988463107, 'IT', 'ITA', 'إيطاليا'),
(40510, 2988463108, 2988463119, 'FR', 'FRA', 'فرنسا'),
(40511, 2988463120, 2988463127, 'GB', 'GBR', 'المملكة المتحدة'),
(40512, 2988463128, 2988463131, 'FR', 'FRA', 'فرنسا'),
(40513, 2988463132, 2988463135, 'PL', 'POL', 'بولندا'),
(40514, 2988463136, 2988463167, 'IT', 'ITA', 'إيطاليا'),
(40515, 2988463168, 2988463199, 'NL', 'NLD', 'هولندا'),
(40516, 2988463200, 2988463203, 'GB', 'GBR', 'المملكة المتحدة'),
(40517, 2988463204, 2988463207, 'DE', 'DEU', 'ألمانيا'),
(40518, 2988463208, 2988463211, 'FR', 'FRA', 'فرنسا'),
(40519, 2988463212, 2988463223, 'GB', 'GBR', 'المملكة المتحدة'),
(40520, 2988463224, 2988463227, 'FR', 'FRA', 'فرنسا'),
(40521, 2988463228, 2988463231, 'CH', 'CHE', 'سويسرا'),
(40522, 2988463232, 2988463263, 'NL', 'NLD', 'هولندا'),
(40523, 2988463264, 2988463279, 'PL', 'POL', 'بولندا'),
(40524, 2988463280, 2988463315, 'FR', 'FRA', 'فرنسا'),
(40525, 2988463316, 2988463319, 'DE', 'DEU', 'ألمانيا'),
(40526, 2988463320, 2988463323, 'FR', 'FRA', 'فرنسا'),
(40527, 2988463324, 2988463331, 'DE', 'DEU', 'ألمانيا'),
(40528, 2988463332, 2988463335, 'IT', 'ITA', 'إيطاليا'),
(40529, 2988463336, 2988463339, 'PT', 'PRT', 'البورتوغال'),
(40530, 2988463340, 2988463343, 'FR', 'FRA', 'فرنسا'),
(40531, 2988463344, 2988463359, 'BE', 'BEL', 'بلجيكا'),
(40532, 2988463360, 2988463615, 'FR', 'FRA', 'فرنسا'),
(40533, 2988463616, 2988463623, 'DE', 'DEU', 'ألمانيا'),
(40534, 2988463624, 2988463627, 'PL', 'POL', 'بولندا'),
(40535, 2988463628, 2988463631, 'FR', 'FRA', 'فرنسا'),
(40536, 2988463632, 2988463647, 'GB', 'GBR', 'المملكة المتحدة'),
(40537, 2988463648, 2988463651, 'PL', 'POL', 'بولندا'),
(40538, 2988463652, 2988463659, 'GB', 'GBR', 'المملكة المتحدة'),
(40539, 2988463660, 2988463663, 'FR', 'FRA', 'فرنسا'),
(40540, 2988463664, 2988463679, 'PL', 'POL', 'بولندا'),
(40541, 2988463680, 2988463743, 'FR', 'FRA', 'فرنسا'),
(40542, 2988463744, 2988463747, 'BE', 'BEL', 'بلجيكا'),
(40543, 2988463748, 2988463759, 'FR', 'FRA', 'فرنسا'),
(40544, 2988463760, 2988463775, 'DE', 'DEU', 'ألمانيا'),
(40545, 2988463776, 2988463791, 'PL', 'POL', 'بولندا'),
(40546, 2988463792, 2988463803, 'GB', 'GBR', 'المملكة المتحدة'),
(40547, 2988463804, 2988463823, 'FR', 'FRA', 'فرنسا'),
(40548, 2988463824, 2988463827, 'DE', 'DEU', 'ألمانيا'),
(40549, 2988463828, 2988463831, 'ES', 'ESP', 'إسبانيا'),
(40550, 2988463832, 2988463835, 'DE', 'DEU', 'ألمانيا'),
(40551, 2988463836, 2988463839, 'FR', 'FRA', 'فرنسا'),
(40552, 2988463840, 2988463871, 'PL', 'POL', 'بولندا'),
(40553, 2988463872, 2988463915, 'FR', 'FRA', 'فرنسا'),
(40554, 2988463916, 2988463919, 'GB', 'GBR', 'المملكة المتحدة'),
(40555, 2988463920, 2988463947, 'FR', 'FRA', 'فرنسا'),
(40556, 2988463948, 2988463951, 'GB', 'GBR', 'المملكة المتحدة'),
(40557, 2988463952, 2988463999, 'FR', 'FRA', 'فرنسا'),
(40558, 2988464000, 2988464007, 'IE', 'IRL', 'إيرلندا'),
(40559, 2988464008, 2988464015, 'LT', 'LTU', 'ليتوانيا'),
(40560, 2988464016, 2988464055, 'FR', 'FRA', 'فرنسا'),
(40561, 2988464056, 2988464059, 'ES', 'ESP', 'إسبانيا'),
(40562, 2988464060, 2988464063, 'FR', 'FRA', 'فرنسا'),
(40563, 2988464064, 2988464095, 'PL', 'POL', 'بولندا'),
(40564, 2988464096, 2988464303, 'FR', 'FRA', 'فرنسا'),
(40565, 2988464304, 2988464307, 'IT', 'ITA', 'إيطاليا'),
(40566, 2988464308, 2988464351, 'FR', 'FRA', 'فرنسا'),
(40567, 2988464352, 2988464355, 'DE', 'DEU', 'ألمانيا'),
(40568, 2988464356, 2988464359, 'FR', 'FRA', 'فرنسا'),
(40569, 2988464360, 2988464363, 'PL', 'POL', 'بولندا'),
(40570, 2988464364, 2988464511, 'FR', 'FRA', 'فرنسا'),
(40571, 2988464512, 2988464519, 'PT', 'PRT', 'البورتوغال'),
(40572, 2988464520, 2988464527, 'FR', 'FRA', 'فرنسا'),
(40573, 2988464528, 2988464543, 'DE', 'DEU', 'ألمانيا'),
(40574, 2988464544, 2988464575, 'IT', 'ITA', 'إيطاليا'),
(40575, 2988464576, 2988464607, 'FR', 'FRA', 'فرنسا'),
(40576, 2988464608, 2988464611, 'DE', 'DEU', 'ألمانيا'),
(40577, 2988464612, 2988464615, 'PL', 'POL', 'بولندا'),
(40578, 2988464616, 2988464619, 'FR', 'FRA', 'فرنسا'),
(40579, 2988464620, 2988464623, 'ES', 'ESP', 'إسبانيا'),
(40580, 2988464624, 2988464627, 'FR', 'FRA', 'فرنسا'),
(40581, 2988464628, 2988464631, 'IT', 'ITA', 'إيطاليا'),
(40582, 2988464632, 2988464639, 'GB', 'GBR', 'المملكة المتحدة'),
(40583, 2988464640, 2988464783, 'FR', 'FRA', 'فرنسا'),
(40584, 2988464784, 2988464787, 'IT', 'ITA', 'إيطاليا'),
(40585, 2988464788, 2988464791, 'ES', 'ESP', 'إسبانيا'),
(40586, 2988464792, 2988464795, 'DE', 'DEU', 'ألمانيا'),
(40587, 2988464796, 2988464831, 'FR', 'FRA', 'فرنسا'),
(40588, 2988464832, 2988464895, 'ES', 'ESP', 'إسبانيا'),
(40589, 2988464896, 2988464927, 'NL', 'NLD', 'هولندا'),
(40590, 2988464928, 2988464947, 'FR', 'FRA', 'فرنسا'),
(40591, 2988464948, 2988464951, 'CH', 'CHE', 'سويسرا'),
(40592, 2988464952, 2988464955, 'FR', 'FRA', 'فرنسا'),
(40593, 2988464956, 2988464959, 'GB', 'GBR', 'المملكة المتحدة'),
(40594, 2988464960, 2988465215, 'FR', 'FRA', 'فرنسا'),
(40595, 2988465216, 2988465223, 'ES', 'ESP', 'إسبانيا'),
(40596, 2988465224, 2988465279, 'FR', 'FRA', 'فرنسا'),
(40597, 2988465280, 2988465295, 'DE', 'DEU', 'ألمانيا'),
(40598, 2988465296, 2988465303, 'GB', 'GBR', 'المملكة المتحدة'),
(40599, 2988465304, 2988465375, 'FR', 'FRA', 'فرنسا'),
(40600, 2988465376, 2988465407, 'IT', 'ITA', 'إيطاليا'),
(40601, 2988465408, 2988465423, 'CH', 'CHE', 'سويسرا'),
(40602, 2988465424, 2988465439, 'FR', 'FRA', 'فرنسا'),
(40603, 2988465440, 2988465471, 'GB', 'GBR', 'المملكة المتحدة'),
(40604, 2988465472, 2988465503, 'FR', 'FRA', 'فرنسا'),
(40605, 2988465504, 2988465507, 'DE', 'DEU', 'ألمانيا'),
(40606, 2988465508, 2988465511, 'PL', 'POL', 'بولندا'),
(40607, 2988465512, 2988465515, 'PT', 'PRT', 'البورتوغال'),
(40608, 2988465516, 2988465519, 'GB', 'GBR', 'المملكة المتحدة'),
(40609, 2988465520, 2988465523, 'IT', 'ITA', 'إيطاليا'),
(40610, 2988465524, 2988465527, 'ES', 'ESP', 'إسبانيا'),
(40611, 2988465528, 2988465531, 'FR', 'FRA', 'فرنسا'),
(40612, 2988465532, 2988465535, 'GB', 'GBR', 'المملكة المتحدة'),
(40613, 2988465536, 2988465539, 'FR', 'FRA', 'فرنسا'),
(40614, 2988465540, 2988465543, 'GB', 'GBR', 'المملكة المتحدة'),
(40615, 2988465544, 2988465551, 'FR', 'FRA', 'فرنسا'),
(40616, 2988465552, 2988465559, 'ES', 'ESP', 'إسبانيا'),
(40617, 2988465560, 2988465567, 'GB', 'GBR', 'المملكة المتحدة'),
(40618, 2988465568, 2988465571, 'ES', 'ESP', 'إسبانيا'),
(40619, 2988465572, 2988465575, 'GB', 'GBR', 'المملكة المتحدة'),
(40620, 2988465576, 2988465583, 'DE', 'DEU', 'ألمانيا'),
(40621, 2988465584, 2988465587, 'PL', 'POL', 'بولندا'),
(40622, 2988465588, 2988465591, 'ES', 'ESP', 'إسبانيا'),
(40623, 2988465592, 2988465599, 'FR', 'FRA', 'فرنسا'),
(40624, 2988465600, 2988465615, 'PL', 'POL', 'بولندا'),
(40625, 2988465616, 2988465619, 'FR', 'FRA', 'فرنسا'),
(40626, 2988465620, 2988465623, 'ES', 'ESP', 'إسبانيا'),
(40627, 2988465624, 2988465631, 'FR', 'FRA', 'فرنسا'),
(40628, 2988465632, 2988465647, 'IT', 'ITA', 'إيطاليا'),
(40629, 2988465648, 2988465663, 'CZ', 'CZE', 'التشيك'),
(40630, 2988465664, 2988466047, 'FR', 'FRA', 'فرنسا'),
(40631, 2988466048, 2988466111, 'PL', 'POL', 'بولندا'),
(40632, 2988466112, 2988466115, 'FR', 'FRA', 'فرنسا'),
(40633, 2988466116, 2988466127, 'NL', 'NLD', 'هولندا'),
(40634, 2988466128, 2988466131, 'PT', 'PRT', 'البورتوغال'),
(40635, 2988466132, 2988466139, 'FR', 'FRA', 'فرنسا'),
(40636, 2988466140, 2988466143, 'PL', 'POL', 'بولندا'),
(40637, 2988466144, 2988466175, 'NL', 'NLD', 'هولندا'),
(40638, 2988466176, 2988572671, 'FR', 'FRA', 'فرنسا'),
(40639, 2988572672, 2988703743, 'RU', 'RUS', 'الإتحاد الروسي'),
(40640, 2988703744, 2988834815, 'PL', 'POL', 'بولندا'),
(40641, 2988834816, 2988965887, 'CH', 'CHE', 'سويسرا'),
(40642, 2988965888, 2989096959, 'SK', 'SVK', 'سلوفاكيا'),
(40643, 2989096960, 2989228031, 'PL', 'POL', 'بولندا'),
(40644, 2989228032, 2989490175, 'RU', 'RUS', 'الإتحاد الروسي'),
(40645, 2989490176, 2989555711, 'UA', 'UKR', 'أوكرانيا'),
(40646, 2989555712, 2989621247, 'RU', 'RUS', 'الإتحاد الروسي'),
(40647, 2989621248, 2989686783, 'BE', 'BEL', 'بلجيكا'),
(40648, 2989752320, 2989817855, 'SY', 'SYR', 'سوريا'),
(40649, 2989817856, 2989883391, 'KW', 'KWT', 'الكويت'),
(40650, 2989948928, 2990014463, 'FI', 'FIN', 'فنلندا'),
(40651, 2990014464, 2990079999, 'PL', 'POL', 'بولندا'),
(40652, 2990080000, 2990145535, 'RU', 'RUS', 'الإتحاد الروسي'),
(40653, 2990145536, 2990211071, 'SI', 'SVN', 'سلوفينيا'),
(40654, 2990211072, 2990243839, 'GR', 'GRC', 'اليونان'),
(40655, 2990243840, 2990276607, 'CY', 'CYP', 'قبرص'),
(40656, 2990276608, 2990342143, 'ES', 'ESP', 'إسبانيا'),
(40657, 2990342144, 2990407679, 'KW', 'KWT', 'الكويت'),
(40658, 2990407680, 2990473215, 'RU', 'RUS', 'الإتحاد الروسي'),
(40659, 2990473216, 2990534655, 'DE', 'DEU', 'ألمانيا'),
(40660, 2990534656, 2990534783, 'EG', 'EGY', 'مصر'),
(40661, 2990534784, 2990535935, 'DE', 'DEU', 'ألمانيا'),
(40662, 2990535936, 2990535967, 'PL', 'POL', 'بولندا'),
(40663, 2990535968, 2990538751, 'DE', 'DEU', 'ألمانيا'),
(40664, 2990538752, 2991063039, 'RU', 'RUS', 'الإتحاد الروسي'),
(40665, 2991063040, 2991079423, 'SE', 'SWE', 'السويد'),
(40666, 2991079424, 2991095807, 'RU', 'RUS', 'الإتحاد الروسي'),
(40667, 2991095808, 2991112191, 'AM', 'ARM', 'أرمينيا'),
(40668, 2991112192, 2991128575, 'CZ', 'CZE', 'التشيك'),
(40669, 2991128576, 2991144959, 'PL', 'POL', 'بولندا'),
(40670, 2991144960, 2991161343, 'SA', 'SAU', 'السعودية'),
(40671, 2991161344, 2991177727, 'FR', 'FRA', 'فرنسا'),
(40672, 2991177728, 2991194111, 'SE', 'SWE', 'السويد'),
(40673, 2991194112, 2991210495, 'NO', 'NOR', 'النرويج'),
(40674, 2991210496, 2991243263, 'RU', 'RUS', 'الإتحاد الروسي'),
(40675, 2991243264, 2991259647, 'UA', 'UKR', 'أوكرانيا'),
(40676, 2991259648, 2991292415, 'RU', 'RUS', 'الإتحاد الروسي'),
(40677, 2991292416, 2991308799, 'FI', 'FIN', 'فنلندا'),
(40678, 2991308800, 2991325183, 'BG', 'BGR', 'بلغاريا'),
(40679, 2991325184, 2991341567, 'AZ', 'AZE', 'أذربيجان'),
(40680, 2991341568, 2991357951, 'MD', 'MDA', 'مولدوفا'),
(40681, 2991357952, 2991374335, 'DE', 'DEU', 'ألمانيا'),
(40682, 2991374336, 2991390719, 'RU', 'RUS', 'الإتحاد الروسي'),
(40683, 2991390720, 2991407103, 'BA', 'BIH', 'البوسنه والهرسك'),
(40684, 2991407104, 2991423487, 'DE', 'DEU', 'ألمانيا'),
(40685, 2991587328, 2991718399, 'RU', 'RUS', 'الإتحاد الروسي'),
(40686, 2991718400, 2991849471, 'CH', 'CHE', 'سويسرا'),
(40687, 2991849472, 2991980543, 'NL', 'NLD', 'هولندا'),
(40688, 2991980544, 2991980807, 'UA', 'UKR', 'أوكرانيا'),
(40689, 2991980808, 2991980815, 'NA', 'NAM', 'ناميبيا'),
(40690, 2991980816, 2991981375, 'UA', 'UKR', 'أوكرانيا'),
(40691, 2991981376, 2991981383, 'NA', 'NAM', 'ناميبيا'),
(40692, 2991981384, 2991981415, 'UA', 'UKR', 'أوكرانيا'),
(40693, 2991981416, 2991981423, 'NA', 'NAM', 'ناميبيا'),
(40694, 2991981424, 2991981439, 'UA', 'UKR', 'أوكرانيا'),
(40695, 2991981440, 2991981447, 'NA', 'NAM', 'ناميبيا'),
(40696, 2991981448, 2991981463, 'UA', 'UKR', 'أوكرانيا'),
(40697, 2991981464, 2991981471, 'NA', 'NAM', 'ناميبيا'),
(40698, 2991981472, 2991981495, 'UA', 'UKR', 'أوكرانيا'),
(40699, 2991981496, 2991981503, 'NA', 'NAM', 'ناميبيا'),
(40700, 2991981504, 2991981583, 'UA', 'UKR', 'أوكرانيا'),
(40701, 2991981584, 2991981591, 'NA', 'NAM', 'ناميبيا'),
(40702, 2991981592, 2991981631, 'UA', 'UKR', 'أوكرانيا'),
(40703, 2991981632, 2991981639, 'NA', 'NAM', 'ناميبيا'),
(40704, 2991981640, 2991981647, 'UA', 'UKR', 'أوكرانيا'),
(40705, 2991981648, 2991981655, 'NA', 'NAM', 'ناميبيا'),
(40706, 2991981656, 2991981687, 'UA', 'UKR', 'أوكرانيا'),
(40707, 2991981688, 2991981695, 'NA', 'NAM', 'ناميبيا'),
(40708, 2991981696, 2992111615, 'UA', 'UKR', 'أوكرانيا'),
(40709, 2992111616, 2992373759, 'KZ', 'KAZ', 'كازاخستان'),
(40710, 2992373760, 2992635903, 'UA', 'UKR', 'أوكرانيا'),
(40711, 2992635904, 2993684479, 'GB', 'GBR', 'المملكة المتحدة'),
(40712, 2993684480, 2993946623, 'AT', 'AUT', 'النمسا'),
(40713, 2993946624, 2994208767, 'BE', 'BEL', 'بلجيكا'),
(40714, 2994208768, 2994733055, 'BY', 'BLR', 'روسيا البيضاء'),
(40715, 2994733056, 2994798591, 'GR', 'GRC', 'اليونان'),
(40716, 2994798592, 2994929663, 'RU', 'RUS', 'الإتحاد الروسي'),
(40717, 2994929664, 2994995199, 'IR', 'IRN', 'إيران'),
(40718, 2994995200, 2995060735, 'RU', 'RUS', 'الإتحاد الروسي'),
(40719, 2995060736, 2995126271, 'UA', 'UKR', 'أوكرانيا'),
(40720, 2995126272, 2995191807, 'GE', 'GEO', 'جورجيا'),
(40721, 2995191808, 2995257343, 'LB', 'LBN', 'لبنان'),
(40722, 2995257344, 2995388415, 'UA', 'UKR', 'أوكرانيا'),
(40723, 2995388416, 2995453951, 'RO', 'ROM', 'رومانيا'),
(40724, 2995453952, 2995519487, 'ES', 'ESP', 'إسبانيا'),
(40725, 2995519488, 2995585023, 'RU', 'RUS', 'الإتحاد الروسي'),
(40726, 2995781632, 2995912703, 'BE', 'BEL', 'بلجيكا'),
(40727, 2995912704, 2996043775, 'GR', 'GRC', 'اليونان'),
(40728, 2996043776, 2996174847, 'RS', 'SRB', 'صربيا'),
(40729, 2996174848, 2996305919, 'UA', 'UKR', 'أوكرانيا'),
(40730, 2996830208, 2996862975, 'HR', 'HRV', 'كرواتيا'),
(40731, 2996862976, 2996895743, 'AM', 'ARM', 'أرمينيا'),
(40732, 2996895744, 2996928511, 'KW', 'KWT', 'الكويت'),
(40733, 2996928512, 2996994047, 'RU', 'RUS', 'الإتحاد الروسي'),
(40734, 2996994048, 2996994303, 'DE', 'DEU', 'ألمانيا'),
(40735, 2996994304, 2996994815, 'BY', 'BLR', 'روسيا البيضاء'),
(40736, 2996994816, 2996994847, 'DE', 'DEU', 'ألمانيا'),
(40737, 2996994848, 2996994879, 'SC', 'SYC', 'سيشيل'),
(40738, 2996994880, 2996994943, 'UA', 'UKR', 'أوكرانيا'),
(40739, 2996994944, 2996995071, 'US', 'USA', 'الولايات المتحدة'),
(40740, 2996995072, 2996995327, 'BZ', 'BLZ', 'بليز'),
(40741, 2996995328, 2996995647, 'DE', 'DEU', 'ألمانيا'),
(40742, 2996995648, 2996995711, 'BZ', 'BLZ', 'بليز'),
(40743, 2996995712, 2996995775, 'BY', 'BLR', 'روسيا البيضاء'),
(40744, 2996995776, 2996995839, 'RU', 'RUS', 'الإتحاد الروسي'),
(40745, 2996995840, 2996996095, 'UA', 'UKR', 'أوكرانيا'),
(40746, 2996996096, 2996996287, 'DE', 'DEU', 'ألمانيا'),
(40747, 2996996288, 2996996351, 'RU', 'RUS', 'الإتحاد الروسي'),
(40748, 2996996352, 2996996383, 'DE', 'DEU', 'ألمانيا'),
(40749, 2996996384, 2996996447, 'RU', 'RUS', 'الإتحاد الروسي'),
(40750, 2996996448, 2996996575, 'UA', 'UKR', 'أوكرانيا'),
(40751, 2996996576, 2996996639, 'DE', 'DEU', 'ألمانيا'),
(40752, 2996996640, 2996996767, 'UA', 'UKR', 'أوكرانيا'),
(40753, 2996996768, 2996996863, 'DE', 'DEU', 'ألمانيا'),
(40754, 2996996864, 2996997119, 'CN', 'CHN', 'الصين'),
(40755, 2996997120, 2997003071, 'DE', 'DEU', 'ألمانيا'),
(40756, 2997003072, 2997003135, 'RU', 'RUS', 'الإتحاد الروسي'),
(40757, 2997003136, 2997003199, 'US', 'USA', 'الولايات المتحدة'),
(40758, 2997003200, 2997003327, 'DE', 'DEU', 'ألمانيا'),
(40759, 2997003328, 2997003391, 'RU', 'RUS', 'الإتحاد الروسي'),
(40760, 2997003392, 2997003519, 'UA', 'UKR', 'أوكرانيا'),
(40761, 2997003520, 2997003647, 'DE', 'DEU', 'ألمانيا'),
(40762, 2997003648, 2997003775, 'UA', 'UKR', 'أوكرانيا'),
(40763, 2997003776, 2997004031, 'DE', 'DEU', 'ألمانيا'),
(40764, 2997004032, 2997004287, 'BZ', 'BLZ', 'بليز'),
(40765, 2997004288, 2997004543, 'US', 'USA', 'الولايات المتحدة'),
(40766, 2997004544, 2997004671, 'DE', 'DEU', 'ألمانيا'),
(40767, 2997004672, 2997004799, 'RU', 'RUS', 'الإتحاد الروسي'),
(40768, 2997004800, 2997005055, 'BZ', 'BLZ', 'بليز'),
(40769, 2997005056, 2997026815, 'DE', 'DEU', 'ألمانيا'),
(40770, 2997026816, 2997059583, 'RU', 'RUS', 'الإتحاد الروسي'),
(40771, 2997059584, 2997092351, 'BY', 'BLR', 'روسيا البيضاء'),
(40772, 2997092352, 2997125119, 'NO', 'NOR', 'النرويج'),
(40773, 2997125120, 2997157887, 'HU', 'HUN', 'هنغاريا'),
(40774, 2997157888, 2997190655, 'UA', 'UKR', 'أوكرانيا'),
(40775, 2997190656, 2997223423, 'AT', 'AUT', 'النمسا'),
(40776, 2997223424, 2997256191, 'PT', 'PRT', 'البورتوغال'),
(40777, 2997256192, 2997321727, 'RU', 'RUS', 'الإتحاد الروسي'),
(40778, 2997321728, 2997354495, 'IE', 'IRL', 'إيرلندا'),
(40779, 2997354496, 2997387263, 'MD', 'MDA', 'مولدوفا'),
(40780, 2997387264, 2997420031, 'BY', 'BLR', 'روسيا البيضاء'),
(40781, 2997420032, 2997452799, 'RU', 'RUS', 'الإتحاد الروسي'),
(40782, 2997452800, 2997485567, 'BG', 'BGR', 'بلغاريا'),
(40783, 2997485568, 2997518335, 'FR', 'FRA', 'فرنسا'),
(40784, 2997518336, 2997583871, 'RU', 'RUS', 'الإتحاد الروسي'),
(40785, 2997583872, 2997616639, 'SY', 'SYR', 'سوريا'),
(40786, 2997616640, 2997649407, 'SI', 'SVN', 'سلوفينيا'),
(40787, 2997649408, 2997682175, 'BY', 'BLR', 'روسيا البيضاء'),
(40788, 2997682176, 2997714943, 'RU', 'RUS', 'الإتحاد الروسي'),
(40789, 2997878784, 2998140927, 'RU', 'RUS', 'الإتحاد الروسي'),
(40790, 2998140928, 2998403071, 'PL', 'POL', 'بولندا'),
(40791, 2998403072, 2998665215, 'RU', 'RUS', 'الإتحاد الروسي'),
(40792, 2998665216, 2998927359, 'AT', 'AUT', 'النمسا'),
(40793, 2998927360, 2999451647, 'CH', 'CHE', 'سويسرا'),
(40794, 2999451648, 2999713791, 'DE', 'DEU', 'ألمانيا'),
(40795, 2999713792, 2999975935, 'RU', 'RUS', 'الإتحاد الروسي'),
(40796, 2999975936, 2999984127, 'FR', 'FRA', 'فرنسا'),
(40797, 2999984128, 2999992319, 'BE', 'BEL', 'بلجيكا'),
(40798, 2999992320, 3000000511, 'RU', 'RUS', 'الإتحاد الروسي'),
(40799, 3000000512, 3000008703, 'DE', 'DEU', 'ألمانيا'),
(40800, 3000008704, 3000016895, 'RU', 'RUS', 'الإتحاد الروسي'),
(40801, 3000016896, 3000025087, 'GB', 'GBR', 'المملكة المتحدة'),
(40802, 3000025088, 3000033279, 'GI', 'GIB', 'جبل طارق'),
(40803, 3000500224, 3000506367, 'UA', 'UKR', 'أوكرانيا'),
(40804, 3000506368, 3000508415, 'PL', 'POL', 'بولندا'),
(40805, 3000508416, 3000510463, 'UA', 'UKR', 'أوكرانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(40806, 3000510464, 3000512511, 'PL', 'POL', 'بولندا'),
(40807, 3000512512, 3000514559, 'EE', 'EST', 'إستونيا'),
(40808, 3000514560, 3000516607, 'SI', 'SVN', 'سلوفينيا'),
(40809, 3000516608, 3000520703, 'RU', 'RUS', 'الإتحاد الروسي'),
(40810, 3000520704, 3000522751, 'CZ', 'CZE', 'التشيك'),
(40811, 3000522752, 3000524799, 'PL', 'POL', 'بولندا'),
(40812, 3000524800, 3000526847, 'UA', 'UKR', 'أوكرانيا'),
(40813, 3000526848, 3000528895, 'PL', 'POL', 'بولندا'),
(40814, 3000528896, 3000530943, 'IE', 'IRL', 'إيرلندا'),
(40815, 3000530944, 3000532991, 'UA', 'UKR', 'أوكرانيا'),
(40816, 3000631296, 3000647679, 'RU', 'RUS', 'الإتحاد الروسي'),
(40817, 3000647680, 3000651775, 'UA', 'UKR', 'أوكرانيا'),
(40818, 3000651776, 3000664063, 'RU', 'RUS', 'الإتحاد الروسي'),
(40819, 3000664064, 3000668159, 'RO', 'ROM', 'رومانيا'),
(40820, 3000762368, 3001024511, 'RS', 'SRB', 'صربيا'),
(40821, 3001024512, 3001548799, 'NL', 'NLD', 'هولندا'),
(40822, 3002073088, 3002597375, 'TR', 'TUR', 'تركيا'),
(40823, 3019898880, 3024093183, 'JP', 'JPN', 'اليابان'),
(40824, 3024093184, 3024617471, 'KR', 'KOR', 'جمهورية كوريا'),
(40825, 3024617472, 3024879615, 'MY', 'MYS', 'ماليزيا'),
(40826, 3024879616, 3025141759, 'CN', 'CHN', 'الصين'),
(40827, 3025141760, 3025403903, 'KR', 'KOR', 'جمهورية كوريا'),
(40828, 3025403904, 3025600511, 'CN', 'CHN', 'الصين'),
(40829, 3025600512, 3025600767, 'IN', 'IND', 'الهند'),
(40830, 3025600768, 3025600783, 'HK', 'HKG', 'هونغ كونغ'),
(40831, 3025600784, 3025600799, 'PH', 'PHL', 'الفلبين'),
(40832, 3025600800, 3025600831, 'SG', 'SGP', 'سنغافورة'),
(40833, 3025600832, 3025600847, 'TH', 'THA', 'تايلند'),
(40834, 3025600848, 3025600863, 'HK', 'HKG', 'هونغ كونغ'),
(40835, 3025600864, 3025601023, 'AU', 'AUS', 'أستراليا'),
(40836, 3025601024, 3025601031, 'JP', 'JPN', 'اليابان'),
(40837, 3025601032, 3025601039, 'SG', 'SGP', 'سنغافورة'),
(40838, 3025601040, 3025601055, 'HK', 'HKG', 'هونغ كونغ'),
(40839, 3025601056, 3025601279, 'AU', 'AUS', 'أستراليا'),
(40840, 3025601280, 3025601295, 'HK', 'HKG', 'هونغ كونغ'),
(40841, 3025601296, 3025601303, 'SG', 'SGP', 'سنغافورة'),
(40842, 3025601304, 3025601311, 'TH', 'THA', 'تايلند'),
(40843, 3025601312, 3025601327, 'HK', 'HKG', 'هونغ كونغ'),
(40844, 3025601328, 3025601335, 'TH', 'THA', 'تايلند'),
(40845, 3025601336, 3025601343, 'HK', 'HKG', 'هونغ كونغ'),
(40846, 3025601344, 3025601551, 'AU', 'AUS', 'أستراليا'),
(40847, 3025601552, 3025601567, 'HK', 'HKG', 'هونغ كونغ'),
(40848, 3025601568, 3025601791, 'AU', 'AUS', 'أستراليا'),
(40849, 3025601792, 3025601807, 'HK', 'HKG', 'هونغ كونغ'),
(40850, 3025601808, 3025602047, 'AU', 'AUS', 'أستراليا'),
(40851, 3025602048, 3025602063, 'US', 'USA', 'الولايات المتحدة'),
(40852, 3025602064, 3025602079, 'HK', 'HKG', 'هونغ كونغ'),
(40853, 3025602080, 3025602431, 'AU', 'AUS', 'أستراليا'),
(40854, 3025602432, 3025602447, 'HK', 'HKG', 'هونغ كونغ'),
(40855, 3025602448, 3025602559, 'AU', 'AUS', 'أستراليا'),
(40856, 3025602560, 3025602815, 'SG', 'SGP', 'سنغافورة'),
(40857, 3025602816, 3025603071, 'GU', 'GUM', 'غوام'),
(40858, 3025603072, 3025603583, 'HK', 'HKG', 'هونغ كونغ'),
(40859, 3025603584, 3025603839, 'ID', 'IDN', 'إندونيسيا'),
(40860, 3025603840, 3025604095, 'HK', 'HKG', 'هونغ كونغ'),
(40861, 3025604096, 3025604607, 'AU', 'AUS', 'أستراليا'),
(40862, 3025604608, 3025606655, 'SG', 'SGP', 'سنغافورة'),
(40863, 3025606656, 3025606911, 'MY', 'MYS', 'ماليزيا'),
(40864, 3025606912, 3025649663, 'AU', 'AUS', 'أستراليا'),
(40865, 3025649664, 3025666047, 'IN', 'IND', 'الهند'),
(40866, 3025666048, 3025928191, 'CN', 'CHN', 'الصين'),
(40867, 3025928192, 3025932287, 'TW', 'TWN', 'تايوان'),
(40868, 3025932288, 3025944575, 'JP', 'JPN', 'اليابان'),
(40869, 3025944576, 3025960959, 'KR', 'KOR', 'جمهورية كوريا'),
(40870, 3025960960, 3025969151, 'PK', 'PAK', 'باكستان'),
(40871, 3025969152, 3025973247, 'IN', 'IND', 'الهند'),
(40872, 3025973248, 3025975295, 'AU', 'AUS', 'أستراليا'),
(40873, 3025975296, 3025975551, 'SG', 'SGP', 'سنغافورة'),
(40874, 3025975552, 3025975807, 'IN', 'IND', 'الهند'),
(40875, 3025975808, 3025977343, 'SG', 'SGP', 'سنغافورة'),
(40876, 3025977344, 3025979391, 'AU', 'AUS', 'أستراليا'),
(40877, 3025979392, 3025981439, 'IN', 'IND', 'الهند'),
(40878, 3025981440, 3025985535, 'AU', 'AUS', 'أستراليا'),
(40879, 3025985536, 3025989631, 'BD', 'BGD', 'بنغالاديش'),
(40880, 3025989632, 3025993727, 'KR', 'KOR', 'جمهورية كوريا'),
(40881, 3025993728, 3026059263, 'VN', 'VNM', 'فييتنام'),
(40882, 3026059264, 3026067455, 'PH', 'PHL', 'الفلبين'),
(40883, 3026067456, 3026068479, 'BD', 'BGD', 'بنغالاديش'),
(40884, 3026068480, 3026069503, 'PH', 'PHL', 'الفلبين'),
(40885, 3026069504, 3026071551, 'JP', 'JPN', 'اليابان'),
(40886, 3026071552, 3026073599, 'AU', 'AUS', 'أستراليا'),
(40887, 3026073600, 3026075647, 'CN', 'CHN', 'الصين'),
(40888, 3026075648, 3026083839, 'AF', 'AFG', 'أفغانستان'),
(40889, 3026083840, 3026087935, 'CN', 'CHN', 'الصين'),
(40890, 3026087936, 3026089983, 'AU', 'AUS', 'أستراليا'),
(40891, 3026089984, 3026092031, 'MN', 'MNG', 'منغوليا'),
(40892, 3026092032, 3026108415, 'MO', 'MAC', 'ماكاو'),
(40893, 3026108416, 3026114559, 'JP', 'JPN', 'اليابان'),
(40894, 3026114560, 3026115583, 'SG', 'SGP', 'سنغافورة'),
(40895, 3026115584, 3026116607, 'AU', 'AUS', 'أستراليا'),
(40896, 3026116608, 3026118655, 'HK', 'HKG', 'هونغ كونغ'),
(40897, 3026118656, 3026120703, 'AU', 'AUS', 'أستراليا'),
(40898, 3026120704, 3026124799, 'JP', 'JPN', 'اليابان'),
(40899, 3026124800, 3026157567, 'AU', 'AUS', 'أستراليا'),
(40900, 3026157568, 3028287487, 'CN', 'CHN', 'الصين'),
(40901, 3028287488, 3028353023, 'TH', 'THA', 'تايلند'),
(40902, 3028353024, 3028385791, 'SG', 'SGP', 'سنغافورة'),
(40903, 3028385792, 3028484095, 'CN', 'CHN', 'الصين'),
(40904, 3028484096, 3028500479, 'KR', 'KOR', 'جمهورية كوريا'),
(40905, 3028500480, 3028516863, 'JP', 'JPN', 'اليابان'),
(40906, 3028516864, 3028520959, 'AU', 'AUS', 'أستراليا'),
(40907, 3028520960, 3028521983, 'ID', 'IDN', 'إندونيسيا'),
(40908, 3028521984, 3028523007, 'LA', 'LAO', 'لاو'),
(40909, 3028523008, 3028525055, 'JP', 'JPN', 'اليابان'),
(40910, 3028525056, 3028533247, 'HK', 'HKG', 'هونغ كونغ'),
(40911, 3028533248, 3028549631, 'JP', 'JPN', 'اليابان'),
(40912, 3028549632, 3028811775, 'KR', 'KOR', 'جمهورية كوريا'),
(40913, 3028811776, 3029336063, 'CN', 'CHN', 'الصين'),
(40914, 3029336064, 3029598207, 'JP', 'JPN', 'اليابان'),
(40915, 3029598208, 3029600255, 'VN', 'VNM', 'فييتنام'),
(40916, 3029600256, 3029606399, 'AU', 'AUS', 'أستراليا'),
(40917, 3029606400, 3029614591, 'IN', 'IND', 'الهند'),
(40918, 3029614592, 3029630975, 'AU', 'AUS', 'أستراليا'),
(40919, 3029630976, 3029635071, 'VN', 'VNM', 'فييتنام'),
(40920, 3029635072, 3029637119, 'JP', 'JPN', 'اليابان'),
(40921, 3029637120, 3029639167, 'BD', 'BGD', 'بنغالاديش'),
(40922, 3029639168, 3029643263, 'JP', 'JPN', 'اليابان'),
(40923, 3029643264, 3029645311, 'AU', 'AUS', 'أستراليا'),
(40924, 3029645312, 3029651455, 'JP', 'JPN', 'اليابان'),
(40925, 3029651456, 3029654527, 'BD', 'BGD', 'بنغالاديش'),
(40926, 3029654528, 3029655551, 'IN', 'IND', 'الهند'),
(40927, 3029655552, 3029663743, 'CN', 'CHN', 'الصين'),
(40928, 3029663744, 3029671935, 'BD', 'BGD', 'بنغالاديش'),
(40929, 3029671936, 3029680127, 'IN', 'IND', 'الهند'),
(40930, 3029680128, 3029696511, 'MN', 'MNG', 'منغوليا'),
(40931, 3029696512, 3029704703, 'CN', 'CHN', 'الصين'),
(40932, 3029704704, 3029712895, 'JP', 'JPN', 'اليابان'),
(40933, 3029712896, 3029714943, 'AU', 'AUS', 'أستراليا'),
(40934, 3029714944, 3029716991, 'JP', 'JPN', 'اليابان'),
(40935, 3029716992, 3029721087, 'PK', 'PAK', 'باكستان'),
(40936, 3029721088, 3029725183, 'AU', 'AUS', 'أستراليا'),
(40937, 3029725184, 3029727231, 'IN', 'IND', 'الهند'),
(40938, 3029727232, 3029728255, 'AU', 'AUS', 'أستراليا'),
(40939, 3029728256, 3029729279, 'HK', 'HKG', 'هونغ كونغ'),
(40940, 3029729280, 3029762047, 'AU', 'AUS', 'أستراليا'),
(40941, 3029762048, 3029770239, 'HK', 'HKG', 'هونغ كونغ'),
(40942, 3029770240, 3029778431, 'CN', 'CHN', 'الصين'),
(40943, 3029778432, 3029788671, 'KR', 'KOR', 'جمهورية كوريا'),
(40944, 3029788672, 3029790719, 'ID', 'IDN', 'إندونيسيا'),
(40945, 3029790720, 3029791743, 'IN', 'IND', 'الهند'),
(40946, 3029791744, 3029792767, 'ID', 'IDN', 'إندونيسيا'),
(40947, 3029792768, 3029793791, 'IN', 'IND', 'الهند'),
(40948, 3029793792, 3029794815, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(40949, 3029794816, 3029860351, 'IN', 'IND', 'الهند'),
(40950, 3029860352, 3031433215, 'CN', 'CHN', 'الصين'),
(40951, 3031433216, 3031564287, 'TW', 'TWN', 'تايوان'),
(40952, 3031564288, 3031572479, 'IN', 'IND', 'الهند'),
(40953, 3031572480, 3031580671, 'HK', 'HKG', 'هونغ كونغ'),
(40954, 3031580672, 3031582719, 'AU', 'AUS', 'أستراليا'),
(40955, 3031582720, 3031584767, 'SG', 'SGP', 'سنغافورة'),
(40956, 3031584768, 3031587839, 'JP', 'JPN', 'اليابان'),
(40957, 3031587840, 3031592959, 'ID', 'IDN', 'إندونيسيا'),
(40958, 3031592960, 3031595007, 'HK', 'HKG', 'هونغ كونغ'),
(40959, 3031595008, 3031597055, 'AU', 'AUS', 'أستراليا'),
(40960, 3031597056, 3031613439, 'PK', 'PAK', 'باكستان'),
(40961, 3031613440, 3031629823, 'CN', 'CHN', 'الصين'),
(40962, 3031629824, 3031695359, 'IN', 'IND', 'الهند'),
(40963, 3031695360, 3031760895, 'TH', 'THA', 'تايلند'),
(40964, 3031760896, 3031826431, 'AU', 'AUS', 'أستراليا'),
(40965, 3031826432, 3031891967, 'KR', 'KOR', 'جمهورية كوريا'),
(40966, 3031891968, 3031957503, 'TH', 'THA', 'تايلند'),
(40967, 3031957504, 3032252415, 'CN', 'CHN', 'الصين'),
(40968, 3032252416, 3032271871, 'HK', 'HKG', 'هونغ كونغ'),
(40969, 3032271872, 3032272895, 'AU', 'AUS', 'أستراليا'),
(40970, 3032272896, 3032276991, 'JP', 'JPN', 'اليابان'),
(40971, 3032276992, 3032285183, 'IN', 'IND', 'الهند'),
(40972, 3032285184, 3032301567, 'JP', 'JPN', 'اليابان'),
(40973, 3032301568, 3032317951, 'KR', 'KOR', 'جمهورية كوريا'),
(40974, 3032317952, 3032319999, 'JP', 'JPN', 'اليابان'),
(40975, 3032320000, 3032323071, 'AU', 'AUS', 'أستراليا'),
(40976, 3032323072, 3032324095, 'CN', 'CHN', 'الصين'),
(40977, 3032324096, 3032326143, 'AU', 'AUS', 'أستراليا'),
(40978, 3032326144, 3032330239, 'TL', 'TLS', 'تيمور الشرقية'),
(40979, 3032330240, 3032334335, 'KR', 'KOR', 'جمهورية كوريا'),
(40980, 3032334336, 3032342527, 'NZ', 'NZL', 'نيوزيلاندا'),
(40981, 3032342528, 3032350719, 'AU', 'AUS', 'أستراليا'),
(40982, 3032350720, 3032743935, 'PH', 'PHL', 'الفلبين'),
(40983, 3032743936, 3033038847, 'JP', 'JPN', 'اليابان'),
(40984, 3033038848, 3033071615, 'AU', 'AUS', 'أستراليا'),
(40985, 3033071616, 3033268223, 'CN', 'CHN', 'الصين'),
(40986, 3033268224, 3033530367, 'TW', 'TWN', 'تايوان'),
(40987, 3033530368, 3033661439, 'CN', 'CHN', 'الصين'),
(40988, 3033661440, 3033694207, 'KR', 'KOR', 'جمهورية كوريا'),
(40989, 3033694208, 3033710591, 'BD', 'BGD', 'بنغالاديش'),
(40990, 3033710592, 3033712639, 'KR', 'KOR', 'جمهورية كوريا'),
(40991, 3033712640, 3033714687, 'SG', 'SGP', 'سنغافورة'),
(40992, 3033714688, 3033715711, 'NZ', 'NZL', 'نيوزيلاندا'),
(40993, 3033715712, 3033716735, 'AU', 'AUS', 'أستراليا'),
(40994, 3033716736, 3033717759, 'TH', 'THA', 'تايلند'),
(40995, 3033717760, 3033718783, 'BD', 'BGD', 'بنغالاديش'),
(40996, 3033718784, 3033726975, 'CN', 'CHN', 'الصين'),
(40997, 3033726976, 3033743359, 'KR', 'KOR', 'جمهورية كوريا'),
(40998, 3033743360, 3033745407, 'IN', 'IND', 'الهند'),
(40999, 3033745408, 3033747455, 'JP', 'JPN', 'اليابان'),
(41000, 3033747456, 3033748479, 'IN', 'IND', 'الهند'),
(41001, 3033748480, 3033749503, 'JP', 'JPN', 'اليابان'),
(41002, 3033749504, 3033751551, 'ID', 'IDN', 'إندونيسيا'),
(41003, 3033751552, 3033759743, 'IN', 'IND', 'الهند'),
(41004, 3033759744, 3033792511, 'BD', 'BGD', 'بنغالاديش'),
(41005, 3033792512, 3033923583, 'CN', 'CHN', 'الصين'),
(41006, 3033923584, 3033939967, 'JP', 'JPN', 'اليابان'),
(41007, 3033939968, 3033956351, 'AU', 'AUS', 'أستراليا'),
(41008, 3033956352, 3033964543, 'IN', 'IND', 'الهند'),
(41009, 3033964544, 3033966591, 'HK', 'HKG', 'هونغ كونغ'),
(41010, 3033966592, 3033968639, 'AU', 'AUS', 'أستراليا'),
(41011, 3033968640, 3033972735, 'TW', 'TWN', 'تايوان'),
(41012, 3033972736, 3033980927, 'TH', 'THA', 'تايلند'),
(41013, 3033980928, 3033982975, 'JP', 'JPN', 'اليابان'),
(41014, 3033982976, 3033983999, 'ID', 'IDN', 'إندونيسيا'),
(41015, 3033984000, 3033985023, 'VN', 'VNM', 'فييتنام'),
(41016, 3033985024, 3033989119, 'ID', 'IDN', 'إندونيسيا'),
(41017, 3033989120, 3034054655, 'IN', 'IND', 'الهند'),
(41018, 3034054656, 3034120191, 'AU', 'AUS', 'أستراليا'),
(41019, 3034120192, 3034251263, 'TW', 'TWN', 'تايوان'),
(41020, 3034251264, 3034316799, 'HK', 'HKG', 'هونغ كونغ'),
(41021, 3034316800, 3034447871, 'JP', 'JPN', 'اليابان'),
(41022, 3034447872, 3034464255, 'AU', 'AUS', 'أستراليا'),
(41023, 3034464256, 3034465279, 'NZ', 'NZL', 'نيوزيلاندا'),
(41024, 3034465280, 3034466303, 'AU', 'AUS', 'أستراليا'),
(41025, 3034466304, 3034472447, 'JP', 'JPN', 'اليابان'),
(41026, 3034472448, 3034478591, 'IN', 'IND', 'الهند'),
(41027, 3034478592, 3034480639, 'AU', 'AUS', 'أستراليا'),
(41028, 3034480640, 3034482687, 'SG', 'SGP', 'سنغافورة'),
(41029, 3034482688, 3034484735, 'AF', 'AFG', 'أفغانستان'),
(41030, 3034484736, 3034488831, 'TH', 'THA', 'تايلند'),
(41031, 3034488832, 3034499071, 'AU', 'AUS', 'أستراليا'),
(41032, 3034499072, 3034500095, 'HK', 'HKG', 'هونغ كونغ'),
(41033, 3034500096, 3034501119, 'TW', 'TWN', 'تايوان'),
(41034, 3034501120, 3034502143, 'VU', 'VUT', 'فانواتو'),
(41035, 3034502144, 3034503167, 'AU', 'AUS', 'أستراليا'),
(41036, 3034503168, 3034504191, 'ID', 'IDN', 'إندونيسيا'),
(41037, 3034504192, 3034505215, 'KR', 'KOR', 'جمهورية كوريا'),
(41038, 3034505216, 3034578943, 'CN', 'CHN', 'الصين'),
(41039, 3034578944, 3035103231, 'KR', 'KOR', 'جمهورية كوريا'),
(41040, 3035103232, 3035168767, 'PH', 'PHL', 'الفلبين'),
(41041, 3035168768, 3035193343, 'CN', 'CHN', 'الصين'),
(41042, 3035193344, 3035197439, 'JP', 'JPN', 'اليابان'),
(41043, 3035197440, 3035198463, 'SG', 'SGP', 'سنغافورة'),
(41044, 3035198464, 3035198719, 'KR', 'KOR', 'جمهورية كوريا'),
(41045, 3035198720, 3035198975, 'SG', 'SGP', 'سنغافورة'),
(41046, 3035198976, 3035199487, 'AU', 'AUS', 'أستراليا'),
(41047, 3035199488, 3035200511, 'IN', 'IND', 'الهند'),
(41048, 3035200512, 3035202559, 'AU', 'AUS', 'أستراليا'),
(41049, 3035202560, 3035205631, 'JP', 'JPN', 'اليابان'),
(41050, 3035205632, 3035207679, 'MY', 'MYS', 'ماليزيا'),
(41051, 3035207680, 3035209727, 'ID', 'IDN', 'إندونيسيا'),
(41052, 3035209728, 3035217919, 'HK', 'HKG', 'هونغ كونغ'),
(41053, 3035217920, 3035234303, 'KR', 'KOR', 'جمهورية كوريا'),
(41054, 3035234304, 3035299839, 'BD', 'BGD', 'بنغالاديش'),
(41055, 3035299840, 3035316223, 'JP', 'JPN', 'اليابان'),
(41056, 3035316224, 3035324415, 'CN', 'CHN', 'الصين'),
(41057, 3035324416, 3035326463, 'JP', 'JPN', 'اليابان'),
(41058, 3035326464, 3035328511, 'AU', 'AUS', 'أستراليا'),
(41059, 3035328512, 3035332607, 'BD', 'BGD', 'بنغالاديش'),
(41060, 3035332608, 3035335679, 'AU', 'AUS', 'أستراليا'),
(41061, 3035335680, 3035337727, 'JP', 'JPN', 'اليابان'),
(41062, 3035337728, 3035338751, 'ID', 'IDN', 'إندونيسيا'),
(41063, 3035338752, 3035339007, 'SG', 'SGP', 'سنغافورة'),
(41064, 3035339008, 3035339263, 'IN', 'IND', 'الهند'),
(41065, 3035339264, 3035339775, 'HK', 'HKG', 'هونغ كونغ'),
(41066, 3035339776, 3035340799, 'AU', 'AUS', 'أستراليا'),
(41067, 3035340800, 3035348991, 'MN', 'MNG', 'منغوليا'),
(41068, 3035348992, 3035365375, 'AU', 'AUS', 'أستراليا'),
(41069, 3035365376, 3035627519, 'KR', 'KOR', 'جمهورية كوريا'),
(41070, 3035627520, 3036610559, 'ID', 'IDN', 'إندونيسيا'),
(41071, 3036610560, 3036676095, 'AU', 'AUS', 'أستراليا'),
(41072, 3053453312, 3054501887, 'ID', 'IDN', 'إندونيسيا'),
(41073, 3054501888, 3054534655, 'HK', 'HKG', 'هونغ كونغ'),
(41074, 3054534656, 3054537727, 'PH', 'PHL', 'الفلبين'),
(41075, 3054537728, 3054538751, 'SG', 'SGP', 'سنغافورة'),
(41076, 3054538752, 3054540799, 'BD', 'BGD', 'بنغالاديش'),
(41077, 3054540800, 3054541823, 'NZ', 'NZL', 'نيوزيلاندا'),
(41078, 3054541824, 3054542847, 'BD', 'BGD', 'بنغالاديش'),
(41079, 3054542848, 3054551039, 'ID', 'IDN', 'إندونيسيا'),
(41080, 3054551040, 3054559231, 'CN', 'CHN', 'الصين'),
(41081, 3054559232, 3054561279, 'JP', 'JPN', 'اليابان'),
(41082, 3054561280, 3054562303, 'SG', 'SGP', 'سنغافورة'),
(41083, 3054562304, 3054563327, 'JP', 'JPN', 'اليابان'),
(41084, 3054563328, 3054567423, 'ID', 'IDN', 'إندونيسيا'),
(41085, 3054567424, 3054632959, 'TH', 'THA', 'تايلند'),
(41086, 3054632960, 3054665727, 'CN', 'CHN', 'الصين'),
(41087, 3054665728, 3054682111, 'IN', 'IND', 'الهند'),
(41088, 3054682112, 3054698495, 'PH', 'PHL', 'الفلبين'),
(41089, 3054698496, 3054731263, 'IN', 'IND', 'الهند'),
(41090, 3054731264, 3054764031, 'AU', 'AUS', 'أستراليا'),
(41091, 3054764032, 3054960639, 'JP', 'JPN', 'اليابان'),
(41092, 3054960640, 3054993407, 'ID', 'IDN', 'إندونيسيا'),
(41093, 3054993408, 3054997503, 'IN', 'IND', 'الهند'),
(41094, 3054997504, 3055001599, 'SG', 'SGP', 'سنغافورة'),
(41095, 3055001600, 3055005695, 'ID', 'IDN', 'إندونيسيا'),
(41096, 3055005696, 3055007743, 'NZ', 'NZL', 'نيوزيلاندا'),
(41097, 3055007744, 3055013887, 'AU', 'AUS', 'أستراليا'),
(41098, 3055013888, 3055014911, 'JP', 'JPN', 'اليابان'),
(41099, 3055014912, 3055015935, 'AU', 'AUS', 'أستراليا'),
(41100, 3055015936, 3055026175, 'JP', 'JPN', 'اليابان'),
(41101, 3055026176, 3055484927, 'ID', 'IDN', 'إندونيسيا'),
(41102, 3055484928, 3055550463, 'AU', 'AUS', 'أستراليا'),
(41103, 3055550464, 3056599039, 'CN', 'CHN', 'الصين'),
(41104, 3056599040, 3056615423, 'JP', 'JPN', 'اليابان'),
(41105, 3056615424, 3056623615, 'BD', 'BGD', 'بنغالاديش'),
(41106, 3056623616, 3056631807, 'CN', 'CHN', 'الصين'),
(41107, 3056631808, 3056639999, 'NZ', 'NZL', 'نيوزيلاندا'),
(41108, 3056640000, 3056648191, 'AU', 'AUS', 'أستراليا'),
(41109, 3056648192, 3056664575, 'IN', 'IND', 'الهند'),
(41110, 3056664576, 3056734207, 'CN', 'CHN', 'الصين'),
(41111, 3056734208, 3056746495, 'KR', 'KOR', 'جمهورية كوريا'),
(41112, 3056746496, 3056747519, 'NP', 'NPL', 'نيبال'),
(41113, 3056747520, 3056748543, 'BD', 'BGD', 'بنغالاديش'),
(41114, 3056748544, 3056749567, 'WS', 'WSM', 'ساموا'),
(41115, 3056749568, 3056750591, 'AU', 'AUS', 'أستراليا'),
(41116, 3056750592, 3056754687, 'TH', 'THA', 'تايلند'),
(41117, 3056754688, 3056758783, 'JP', 'JPN', 'اليابان'),
(41118, 3056758784, 3056762879, 'CN', 'CHN', 'الصين'),
(41119, 3056762880, 3056771071, 'SG', 'SGP', 'سنغافورة'),
(41120, 3056771072, 3056772095, 'NZ', 'NZL', 'نيوزيلاندا'),
(41121, 3056772096, 3056773119, 'AU', 'AUS', 'أستراليا'),
(41122, 3056773120, 3056774143, 'WS', 'WSM', 'ساموا'),
(41123, 3056774144, 3056775167, 'AU', 'AUS', 'أستراليا'),
(41124, 3056775168, 3056779263, 'AF', 'AFG', 'أفغانستان'),
(41125, 3056779264, 3056791551, 'JP', 'JPN', 'اليابان'),
(41126, 3056791552, 3056795647, 'ID', 'IDN', 'إندونيسيا'),
(41127, 3056795648, 3056861183, 'CN', 'CHN', 'الصين'),
(41128, 3056861184, 3056992255, 'TH', 'THA', 'تايلند'),
(41129, 3056992256, 3057025023, 'CN', 'CHN', 'الصين'),
(41130, 3057025024, 3057033215, 'PH', 'PHL', 'الفلبين'),
(41131, 3057033216, 3057037311, 'NZ', 'NZL', 'نيوزيلاندا'),
(41132, 3057037312, 3057041407, 'AU', 'AUS', 'أستراليا'),
(41133, 3057041408, 3057049599, 'MY', 'MYS', 'ماليزيا'),
(41134, 3057049600, 3057053695, 'AU', 'AUS', 'أستراليا'),
(41135, 3057053696, 3057054719, 'JP', 'JPN', 'اليابان'),
(41136, 3057054720, 3057055743, 'HK', 'HKG', 'هونغ كونغ'),
(41137, 3057055744, 3057057791, 'JP', 'JPN', 'اليابان'),
(41138, 3057057792, 3057123327, 'SG', 'SGP', 'سنغافورة'),
(41139, 3057123328, 3057451007, 'IN', 'IND', 'الهند'),
(41140, 3057451008, 3057516543, 'CN', 'CHN', 'الصين'),
(41141, 3057516544, 3057647615, 'MY', 'MYS', 'ماليزيا'),
(41142, 3057647616, 3058696191, 'IN', 'IND', 'الهند'),
(41143, 3058696192, 3059548159, 'CN', 'CHN', 'الصين'),
(41144, 3059548160, 3059564543, 'MO', 'MAC', 'ماكاو'),
(41145, 3059564544, 3059572735, 'NP', 'NPL', 'نيبال'),
(41146, 3059572736, 3059580927, 'JP', 'JPN', 'اليابان'),
(41147, 3059580928, 3059613695, 'TH', 'THA', 'تايلند'),
(41148, 3059613696, 3059744767, 'IN', 'IND', 'الهند'),
(41149, 3059744768, 3063414783, 'CN', 'CHN', 'الصين'),
(41150, 3063414784, 3063545855, 'HK', 'HKG', 'هونغ كونغ'),
(41151, 3063545856, 3063611391, 'NZ', 'NZL', 'نيوزيلاندا'),
(41152, 3063611392, 3063676927, 'AU', 'AUS', 'أستراليا'),
(41153, 3063676928, 3063742463, 'IN', 'IND', 'الهند'),
(41154, 3063742464, 3063807999, 'CN', 'CHN', 'الصين'),
(41155, 3063808000, 3063939071, 'JP', 'JPN', 'اليابان'),
(41156, 3063939072, 3063955455, 'MN', 'MNG', 'منغوليا'),
(41157, 3063955456, 3063963647, 'CN', 'CHN', 'الصين'),
(41158, 3063963648, 3063971839, 'BD', 'BGD', 'بنغالاديش'),
(41159, 3063971840, 3064004607, 'AU', 'AUS', 'أستراليا'),
(41160, 3064004608, 3064012799, 'LK', 'LKA', 'سيريلانكا'),
(41161, 3064012800, 3064020991, 'MY', 'MYS', 'ماليزيا'),
(41162, 3064020992, 3064023039, 'JP', 'JPN', 'اليابان'),
(41163, 3064023040, 3064024063, 'SG', 'SGP', 'سنغافورة'),
(41164, 3064024064, 3064025087, 'JP', 'JPN', 'اليابان'),
(41165, 3064025088, 3064029183, 'VN', 'VNM', 'فييتنام'),
(41166, 3064029184, 3064135679, 'KR', 'KOR', 'جمهورية كوريا'),
(41167, 3064135680, 3064160255, 'JP', 'JPN', 'اليابان'),
(41168, 3064160256, 3064168447, 'BD', 'BGD', 'بنغالاديش'),
(41169, 3064168448, 3064201215, 'KR', 'KOR', 'جمهورية كوريا'),
(41170, 3064201216, 3064725503, 'JP', 'JPN', 'اليابان'),
(41171, 3064725504, 3064791039, 'KR', 'KOR', 'جمهورية كوريا'),
(41172, 3064791040, 3064807423, 'TW', 'TWN', 'تايوان'),
(41173, 3064807424, 3064808447, 'IN', 'IND', 'الهند'),
(41174, 3064808448, 3064809471, 'TW', 'TWN', 'تايوان'),
(41175, 3064809472, 3064810495, 'MY', 'MYS', 'ماليزيا'),
(41176, 3064810496, 3064811519, 'HK', 'HKG', 'هونغ كونغ'),
(41177, 3064811520, 3064823807, 'KR', 'KOR', 'جمهورية كوريا'),
(41178, 3064823808, 3064831999, 'JP', 'JPN', 'اليابان'),
(41179, 3064832000, 3064840191, 'KR', 'KOR', 'جمهورية كوريا'),
(41180, 3064840192, 3064856575, 'GU', 'GUM', 'غوام'),
(41181, 3064856576, 3064987647, 'CN', 'CHN', 'الصين'),
(41182, 3064987648, 3066036223, 'PK', 'PAK', 'باكستان'),
(41183, 3066036224, 3066560511, 'KR', 'KOR', 'جمهورية كوريا'),
(41184, 3066560512, 3070230527, 'AU', 'AUS', 'أستراليا'),
(41185, 3070230528, 3074949119, 'CN', 'CHN', 'الصين'),
(41186, 3074949120, 3075342335, 'JP', 'JPN', 'اليابان'),
(41187, 3075342336, 3075375103, 'MY', 'MYS', 'ماليزيا'),
(41188, 3075375104, 3075383295, 'KR', 'KOR', 'جمهورية كوريا'),
(41189, 3075383296, 3075385343, 'IN', 'IND', 'الهند'),
(41190, 3075385344, 3075385599, 'CN', 'CHN', 'الصين'),
(41191, 3075385600, 3075386367, 'MY', 'MYS', 'ماليزيا'),
(41192, 3075386368, 3075387391, 'AU', 'AUS', 'أستراليا'),
(41193, 3075387392, 3075388415, 'JP', 'JPN', 'اليابان'),
(41194, 3075388416, 3075389439, 'MY', 'MYS', 'ماليزيا'),
(41195, 3075389440, 3075390463, 'IN', 'IND', 'الهند'),
(41196, 3075390464, 3075391487, 'JP', 'JPN', 'اليابان'),
(41197, 3075391488, 3075407871, 'KR', 'KOR', 'جمهورية كوريا'),
(41198, 3075407872, 3075473407, 'JP', 'JPN', 'اليابان'),
(41199, 3075473408, 3075571711, 'VN', 'VNM', 'فييتنام'),
(41200, 3075571712, 3075575807, 'FJ', 'FJI', 'فيجي'),
(41201, 3075575808, 3075579903, 'AU', 'AUS', 'أستراليا'),
(41202, 3075579904, 3075581951, 'MY', 'MYS', 'ماليزيا'),
(41203, 3075581952, 3075582975, 'MN', 'MNG', 'منغوليا'),
(41204, 3075582976, 3075583999, 'TH', 'THA', 'تايلند'),
(41205, 3075584000, 3075585023, 'JP', 'JPN', 'اليابان'),
(41206, 3075585024, 3075586047, 'CN', 'CHN', 'الصين'),
(41207, 3075586048, 3075588095, 'KH', 'KHM', 'كامبوديا'),
(41208, 3075588096, 3075604479, 'SG', 'SGP', 'سنغافورة'),
(41209, 3075604480, 3075735551, 'IN', 'IND', 'الهند'),
(41210, 3075735552, 3075866623, 'CN', 'CHN', 'الصين'),
(41211, 3075866624, 3075915775, 'JP', 'JPN', 'اليابان'),
(41212, 3075915776, 3075932159, 'KR', 'KOR', 'جمهورية كوريا'),
(41213, 3075932160, 3075997695, 'IN', 'IND', 'الهند'),
(41214, 3075997696, 3076128767, 'TH', 'THA', 'تايلند'),
(41215, 3076128768, 3076161535, 'SG', 'SGP', 'سنغافورة'),
(41216, 3076161536, 3076169727, 'KR', 'KOR', 'جمهورية كوريا'),
(41217, 3076169728, 3076171775, 'VN', 'VNM', 'فييتنام'),
(41218, 3076171776, 3076173823, 'TH', 'THA', 'تايلند'),
(41219, 3076173824, 3076175871, 'JP', 'JPN', 'اليابان'),
(41220, 3076175872, 3076177919, 'HK', 'HKG', 'هونغ كونغ'),
(41221, 3076177920, 3076194303, 'JP', 'JPN', 'اليابان'),
(41222, 3076194304, 3076202495, 'VN', 'VNM', 'فييتنام'),
(41223, 3076202496, 3076210687, 'HK', 'HKG', 'هونغ كونغ'),
(41224, 3076210688, 3076218879, 'ID', 'IDN', 'إندونيسيا'),
(41225, 3076218880, 3076227071, 'AU', 'AUS', 'أستراليا'),
(41226, 3076227072, 3076228095, 'CN', 'CHN', 'الصين'),
(41227, 3076228096, 3076229119, 'NP', 'NPL', 'نيبال'),
(41228, 3076229120, 3076231167, 'TH', 'THA', 'تايلند'),
(41229, 3076231168, 3076235263, 'CN', 'CHN', 'الصين'),
(41230, 3076235264, 3076243455, 'VN', 'VNM', 'فييتنام'),
(41231, 3076243456, 3076259839, 'KR', 'KOR', 'جمهورية كوريا'),
(41232, 3076259840, 3076521983, 'CN', 'CHN', 'الصين'),
(41233, 3076521984, 3078619135, 'KR', 'KOR', 'جمهورية كوريا'),
(41234, 3078619136, 3081437183, 'CN', 'CHN', 'الصين'),
(41235, 3081437184, 3081502719, 'MY', 'MYS', 'ماليزيا'),
(41236, 3081502720, 3081764863, 'CN', 'CHN', 'الصين'),
(41237, 3081764864, 3081846783, 'JP', 'JPN', 'اليابان'),
(41238, 3081846784, 3081847807, 'TW', 'TWN', 'تايوان'),
(41239, 3081847808, 3081848831, 'KR', 'KOR', 'جمهورية كوريا'),
(41240, 3081848832, 3081850879, 'SG', 'SGP', 'سنغافورة'),
(41241, 3081850880, 3081851391, 'JP', 'JPN', 'اليابان'),
(41242, 3081851392, 3081854975, 'AU', 'AUS', 'أستراليا'),
(41243, 3081854976, 3081859071, 'MN', 'MNG', 'منغوليا'),
(41244, 3081859072, 3081861119, 'PH', 'PHL', 'الفلبين'),
(41245, 3081861120, 3081862143, 'AU', 'AUS', 'أستراليا'),
(41246, 3081862144, 3081863167, 'IN', 'IND', 'الهند'),
(41247, 3081863168, 3081895935, 'JP', 'JPN', 'اليابان'),
(41248, 3081895936, 3082027007, 'HK', 'HKG', 'هونغ كونغ'),
(41249, 3082027008, 3082158079, 'JP', 'JPN', 'اليابان'),
(41250, 3082158080, 3082166271, 'CN', 'CHN', 'الصين'),
(41251, 3082166272, 3082174463, 'JP', 'JPN', 'اليابان'),
(41252, 3082174464, 3082178559, 'BZ', 'BLZ', 'بليز'),
(41253, 3082178560, 3082179567, 'HK', 'HKG', 'هونغ كونغ'),
(41254, 3082179568, 3082179583, 'GB', 'GBR', 'المملكة المتحدة'),
(41255, 3082179584, 3082181631, 'IN', 'IND', 'الهند'),
(41256, 3082181632, 3082182655, 'ID', 'IDN', 'إندونيسيا'),
(41257, 3082182656, 3082190847, 'LA', 'LAO', 'لاو'),
(41258, 3082190848, 3082289151, 'JP', 'JPN', 'اليابان'),
(41259, 3082289152, 3087007743, 'CN', 'CHN', 'الصين'),
(41260, 3087007744, 3088318463, 'US', 'USA', 'الولايات المتحدة'),
(41261, 3089104896, 3091202047, 'US', 'USA', 'الولايات المتحدة'),
(41262, 3091202048, 3091726335, 'CA', 'CAN', 'كندا'),
(41263, 3091726336, 3091955711, 'US', 'USA', 'الولايات المتحدة'),
(41264, 3091988480, 3093168127, 'US', 'USA', 'الولايات المتحدة'),
(41265, 3093299200, 3093823487, 'US', 'USA', 'الولايات المتحدة'),
(41266, 3094085632, 3095920639, 'US', 'USA', 'الولايات المتحدة'),
(41267, 3096444928, 3096969215, 'CA', 'CAN', 'كندا'),
(41268, 3120562176, 3120578559, 'CO', 'COL', 'كولومبيا'),
(41269, 3120627712, 3120644095, 'NI', 'NIC', 'نيكاراغوا'),
(41270, 3120693248, 3120709631, 'BO', 'BOL', 'بوليفيا'),
(41271, 3120758784, 3120791551, 'EC', 'ECU', 'الإكوادور'),
(41272, 3120824320, 3120840703, 'CR', 'CRI', 'كوستا ريكا'),
(41273, 3121086464, 3121151999, 'UY', 'URY', 'الأوروغواي'),
(41274, 3121152000, 3121283071, 'CL', 'CHL', 'تشيلي'),
(41275, 3121348608, 3121479679, 'AR', 'ARG', 'الأرجنتين'),
(41276, 3121479680, 3121545215, 'VE', 'VEN', 'فنزويلا'),
(41277, 3121545216, 3121610751, 'CR', 'CRI', 'كوستا ريكا'),
(41278, 3121610752, 3121676287, 'PY', 'PRY', 'باراغواي'),
(41279, 3121741824, 3121872895, 'AR', 'ARG', 'الأرجنتين'),
(41280, 3122135040, 3122282495, 'VE', 'VEN', 'فنزويلا'),
(41281, 3122298880, 3122331647, 'VE', 'VEN', 'فنزويلا'),
(41282, 3122397184, 3122593791, 'CO', 'COL', 'كولومبيا'),
(41283, 3122659328, 3122675711, 'CR', 'CRI', 'كوستا ريكا'),
(41284, 3122675712, 3122683903, 'SV', 'SLV', 'السلفادور'),
(41285, 3122683904, 3122692095, 'GT', 'GTM', 'غواتيمالا'),
(41286, 3122692096, 3122700287, 'HN', 'HND', 'هندوراس'),
(41287, 3122700288, 3122724863, 'GT', 'GTM', 'غواتيمالا'),
(41288, 3122921472, 3122987007, 'CL', 'CHL', 'تشيلي'),
(41289, 3123183616, 3123216383, 'CL', 'CHL', 'تشيلي'),
(41290, 3123314688, 3123380223, 'EC', 'ECU', 'الإكوادور'),
(41291, 3123380224, 3123412991, 'CO', 'COL', 'كولومبيا'),
(41292, 3123445760, 3123576831, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(41293, 3123576832, 3123609599, 'EC', 'ECU', 'الإكوادور'),
(41294, 3123707904, 3123970047, 'UY', 'URY', 'الأوروغواي'),
(41295, 3124232192, 3124772863, 'AR', 'ARG', 'الأرجنتين'),
(41296, 3124887552, 3124953087, 'EC', 'ECU', 'الإكوادور'),
(41297, 3125018624, 3125149695, 'EC', 'ECU', 'الإكوادور'),
(41298, 3125280768, 3125346303, 'CO', 'COL', 'كولومبيا'),
(41299, 3125346304, 3125542911, 'PA', 'PAN', 'بنما'),
(41300, 3125805056, 3126329343, 'CO', 'COL', 'كولومبيا'),
(41301, 3126329344, 3126853631, 'VE', 'VEN', 'فنزويلا'),
(41302, 3126853632, 3126854911, 'US', 'USA', 'الولايات المتحدة'),
(41303, 3126854912, 3126855167, 'UM', 'UMI', 'جزر الولايات المتحدة البعيدة الصغيرة'),
(41304, 3126855168, 3126855423, 'US', 'USA', 'الولايات المتحدة'),
(41305, 3126855424, 3126855679, 'UM', 'UMI', 'جزر الولايات المتحدة البعيدة الصغيرة'),
(41306, 3126855680, 3126870015, 'US', 'USA', 'الولايات المتحدة'),
(41307, 3126886400, 3126913023, 'AR', 'ARG', 'الأرجنتين'),
(41308, 3126913024, 3126915071, 'US', 'USA', 'الولايات المتحدة'),
(41309, 3126915072, 3126919167, 'AR', 'ARG', 'الأرجنتين'),
(41310, 3126919168, 3127115775, 'CO', 'COL', 'كولومبيا'),
(41311, 3127115776, 3127181311, 'AR', 'ARG', 'الأرجنتين'),
(41312, 3127377920, 3127508991, 'CL', 'CHL', 'تشيلي'),
(41313, 3127640064, 3127902207, 'AR', 'ARG', 'الأرجنتين'),
(41314, 3127902208, 3128164351, 'CO', 'COL', 'كولومبيا'),
(41315, 3128426496, 3128492031, 'DO', 'DOM', 'الدومينيكان'),
(41316, 3128492032, 3128524799, 'CO', 'COL', 'كولومبيا'),
(41317, 3128557568, 3128623103, 'AR', 'ARG', 'الأرجنتين'),
(41318, 3128688640, 3128802975, 'AR', 'ARG', 'الأرجنتين'),
(41319, 3128802976, 3128802983, 'US', 'USA', 'الولايات المتحدة'),
(41320, 3128802984, 3128819711, 'AR', 'ARG', 'الأرجنتين'),
(41321, 3128950784, 3129212927, 'AR', 'ARG', 'الأرجنتين'),
(41322, 3129475072, 3129606143, 'AR', 'ARG', 'الأرجنتين'),
(41323, 3129737216, 3129999359, 'AR', 'ARG', 'الأرجنتين'),
(41324, 3129999360, 3130261503, 'CO', 'COL', 'كولومبيا'),
(41325, 3131047936, 3131310079, 'PE', 'PER', 'بيرو'),
(41326, 3133145088, 3135242239, 'BR', 'BRA', 'البرازيل'),
(41327, 3137339392, 3145727999, 'BR', 'BRA', 'البرازيل'),
(41328, 3145728000, 3148873727, 'MX', 'MEX', 'المكسيك'),
(41329, 3149922304, 3154116607, 'MX', 'MEX', 'المكسيك'),
(41330, 3154182144, 3154247679, 'DE', 'DEU', 'ألمانيا'),
(41331, 3154247680, 3154313215, 'RS', 'SRB', 'صربيا'),
(41332, 3154313216, 3154378751, 'TR', 'TUR', 'تركيا'),
(41333, 3154378752, 3154444287, 'GR', 'GRC', 'اليونان'),
(41334, 3154444288, 3154509823, 'BE', 'BEL', 'بلجيكا'),
(41335, 3154509824, 3154575359, 'RU', 'RUS', 'الإتحاد الروسي'),
(41336, 3154575360, 3154640895, 'FR', 'FRA', 'فرنسا'),
(41337, 3154640896, 3155165183, 'IT', 'ITA', 'إيطاليا'),
(41338, 3155165184, 3155427327, 'RU', 'RUS', 'الإتحاد الروسي'),
(41339, 3155427328, 3155689471, 'AT', 'AUT', 'النمسا'),
(41340, 3155689472, 3155951615, 'RO', 'ROM', 'رومانيا'),
(41341, 3155951616, 3156213759, 'GB', 'GBR', 'المملكة المتحدة'),
(41342, 3156213760, 3156279295, 'RU', 'RUS', 'الإتحاد الروسي'),
(41343, 3156279296, 3156344831, 'PL', 'POL', 'بولندا'),
(41344, 3156344832, 3156410367, 'IR', 'IRN', 'إيران'),
(41345, 3156410368, 3156475903, 'RU', 'RUS', 'الإتحاد الروسي'),
(41346, 3156475904, 3156539391, 'HU', 'HUN', 'هنغاريا'),
(41347, 3156539392, 3156539647, 'RO', 'ROM', 'رومانيا'),
(41348, 3156539648, 3156541439, 'HU', 'HUN', 'هنغاريا'),
(41349, 3156606976, 3156672511, 'TR', 'TUR', 'تركيا'),
(41350, 3156672512, 3156738047, 'GB', 'GBR', 'المملكة المتحدة'),
(41351, 3156738048, 3156757188, 'DE', 'DEU', 'ألمانيا'),
(41352, 3156757189, 3156757189, 'NL', 'NLD', 'هولندا'),
(41353, 3156757190, 3156759431, 'DE', 'DEU', 'ألمانيا'),
(41354, 3156759432, 3156759432, 'GB', 'GBR', 'المملكة المتحدة'),
(41355, 3156759433, 3156791439, 'DE', 'DEU', 'ألمانيا'),
(41356, 3156791440, 3156791455, 'NL', 'NLD', 'هولندا'),
(41357, 3156791456, 3156803583, 'DE', 'DEU', 'ألمانيا'),
(41358, 3156803584, 3156869119, 'TR', 'TUR', 'تركيا'),
(41359, 3156869120, 3156934655, 'LU', 'LUX', 'لوكسيمبورغ'),
(41360, 3156934656, 3157065727, 'RU', 'RUS', 'الإتحاد الروسي'),
(41361, 3157065728, 3157131263, 'AT', 'AUT', 'النمسا'),
(41362, 3157131264, 3157196799, 'DE', 'DEU', 'ألمانيا'),
(41363, 3157196800, 3157262335, 'PL', 'POL', 'بولندا'),
(41364, 3157262336, 3157786623, 'SA', 'SAU', 'السعودية'),
(41365, 3157786624, 3158048767, 'TR', 'TUR', 'تركيا'),
(41366, 3158048768, 3158310911, 'CH', 'CHE', 'سويسرا'),
(41367, 3158310912, 3158312959, 'FI', 'FIN', 'فنلندا'),
(41368, 3158312960, 3158315007, 'NL', 'NLD', 'هولندا'),
(41369, 3158315008, 3158317055, 'DE', 'DEU', 'ألمانيا'),
(41370, 3158317056, 3158319103, 'SI', 'SVN', 'سلوفينيا'),
(41371, 3158319104, 3158321151, 'GB', 'GBR', 'المملكة المتحدة'),
(41372, 3158321152, 3158321407, 'DE', 'DEU', 'ألمانيا'),
(41373, 3158321408, 3158321423, 'US', 'USA', 'الولايات المتحدة'),
(41374, 3158321424, 3158322687, 'DE', 'DEU', 'ألمانيا'),
(41375, 3158322688, 3158322831, 'NL', 'NLD', 'هولندا'),
(41376, 3158322832, 3158323199, 'DE', 'DEU', 'ألمانيا'),
(41377, 3158323200, 3158325247, 'BE', 'BEL', 'بلجيكا'),
(41378, 3158325248, 3158327295, 'DE', 'DEU', 'ألمانيا'),
(41379, 3158327296, 3158329343, 'NL', 'NLD', 'هولندا'),
(41380, 3158329344, 3158331391, 'BE', 'BEL', 'بلجيكا'),
(41381, 3158331392, 3158333439, 'GB', 'GBR', 'المملكة المتحدة'),
(41382, 3158333440, 3158335487, 'IT', 'ITA', 'إيطاليا'),
(41383, 3158335488, 3158337535, 'IL', 'ISR', 'إسرائيل'),
(41384, 3158337536, 3158339583, 'SI', 'SVN', 'سلوفينيا'),
(41385, 3158339584, 3158341631, 'RU', 'RUS', 'الإتحاد الروسي'),
(41386, 3158341632, 3158343679, 'IT', 'ITA', 'إيطاليا'),
(41387, 3158343680, 3158345727, 'RU', 'RUS', 'الإتحاد الروسي'),
(41388, 3158345728, 3158347775, 'CY', 'CYP', 'قبرص'),
(41389, 3158347776, 3158349823, 'RU', 'RUS', 'الإتحاد الروسي'),
(41390, 3158349824, 3158351871, 'DK', 'DNK', 'الدنيمارك'),
(41391, 3158351872, 3158355967, 'RU', 'RUS', 'الإتحاد الروسي'),
(41392, 3158355968, 3158358015, 'LV', 'LVA', 'لاتفيا'),
(41393, 3158358016, 3158360063, 'GB', 'GBR', 'المملكة المتحدة'),
(41394, 3158360064, 3158362111, 'DE', 'DEU', 'ألمانيا'),
(41395, 3158362112, 3158364159, 'IL', 'ISR', 'إسرائيل'),
(41396, 3158364160, 3158366207, 'TR', 'TUR', 'تركيا'),
(41397, 3158366208, 3158368255, 'RU', 'RUS', 'الإتحاد الروسي'),
(41398, 3158368256, 3158370303, 'FR', 'FRA', 'فرنسا'),
(41399, 3158370304, 3158372351, 'BE', 'BEL', 'بلجيكا'),
(41400, 3158372352, 3158374399, 'FR', 'FRA', 'فرنسا'),
(41401, 3158374400, 3158376447, 'DE', 'DEU', 'ألمانيا'),
(41402, 3158376448, 3158378495, 'IT', 'ITA', 'إيطاليا'),
(41403, 3158378496, 3158382591, 'RU', 'RUS', 'الإتحاد الروسي'),
(41404, 3158382592, 3158384639, 'OM', 'OMN', 'عمان'),
(41405, 3158384640, 3158386687, 'GB', 'GBR', 'المملكة المتحدة'),
(41406, 3158386688, 3158388735, 'PL', 'POL', 'بولندا'),
(41407, 3158388736, 3158390783, 'RU', 'RUS', 'الإتحاد الروسي'),
(41408, 3158390784, 3158392831, 'GB', 'GBR', 'المملكة المتحدة'),
(41409, 3158392832, 3158394879, 'RU', 'RUS', 'الإتحاد الروسي'),
(41410, 3158394880, 3158396927, 'AT', 'AUT', 'النمسا'),
(41411, 3158396928, 3158398975, 'IT', 'ITA', 'إيطاليا'),
(41412, 3158398976, 3158401023, 'ES', 'ESP', 'إسبانيا'),
(41413, 3158401024, 3158403071, 'GB', 'GBR', 'المملكة المتحدة'),
(41414, 3158403072, 3158405119, 'RU', 'RUS', 'الإتحاد الروسي'),
(41415, 3158405120, 3158407167, 'GB', 'GBR', 'المملكة المتحدة'),
(41416, 3158407168, 3158409215, 'FR', 'FRA', 'فرنسا'),
(41417, 3158409216, 3158411263, 'RU', 'RUS', 'الإتحاد الروسي'),
(41418, 3158411264, 3158413311, 'FI', 'FIN', 'فنلندا'),
(41419, 3158413312, 3158415359, 'DE', 'DEU', 'ألمانيا'),
(41420, 3158415360, 3158417407, 'SE', 'SWE', 'السويد'),
(41421, 3158417408, 3158419455, 'NL', 'NLD', 'هولندا'),
(41422, 3158419456, 3158421503, 'FR', 'FRA', 'فرنسا'),
(41423, 3158421504, 3158423551, 'GB', 'GBR', 'المملكة المتحدة'),
(41424, 3158423552, 3158425599, 'MT', 'MLT', 'مالطا'),
(41425, 3158425600, 3158427647, 'NL', 'NLD', 'هولندا'),
(41426, 3158427648, 3158429695, 'DE', 'DEU', 'ألمانيا'),
(41427, 3158429696, 3158431743, 'RU', 'RUS', 'الإتحاد الروسي'),
(41428, 3158431744, 3158433791, 'BE', 'BEL', 'بلجيكا'),
(41429, 3158433792, 3158435839, 'NL', 'NLD', 'هولندا'),
(41430, 3158435840, 3158439935, 'RU', 'RUS', 'الإتحاد الروسي'),
(41431, 3158439936, 3158441983, 'GB', 'GBR', 'المملكة المتحدة'),
(41432, 3158441984, 3158444031, 'EE', 'EST', 'إستونيا'),
(41433, 3158444032, 3158446079, 'BE', 'BEL', 'بلجيكا'),
(41434, 3158446080, 3158448127, 'NL', 'NLD', 'هولندا'),
(41435, 3158448128, 3158452223, 'RU', 'RUS', 'الإتحاد الروسي'),
(41436, 3158452224, 3158454271, 'DE', 'DEU', 'ألمانيا'),
(41437, 3158573056, 3158638591, 'RU', 'RUS', 'الإتحاد الروسي'),
(41438, 3158638592, 3158704127, 'LT', 'LTU', 'ليتوانيا'),
(41439, 3158835200, 3158851583, 'IQ', 'IRQ', 'العراق'),
(41440, 3158851584, 3158867967, 'RU', 'RUS', 'الإتحاد الروسي'),
(41441, 3158867968, 3158884351, 'AZ', 'AZE', 'أذربيجان'),
(41442, 3158884352, 3158884607, 'DE', 'DEU', 'ألمانيا'),
(41443, 3158884608, 3158884863, 'BE', 'BEL', 'بلجيكا'),
(41444, 3158884864, 3158885119, 'GB', 'GBR', 'المملكة المتحدة'),
(41445, 3158885120, 3158885887, 'TR', 'TUR', 'تركيا'),
(41446, 3158885888, 3158886143, 'HK', 'HKG', 'هونغ كونغ'),
(41447, 3158886144, 3158886175, 'DE', 'DEU', 'ألمانيا'),
(41448, 3158886176, 3158886207, 'BZ', 'BLZ', 'بليز'),
(41449, 3158886208, 3158886271, 'DE', 'DEU', 'ألمانيا'),
(41450, 3158886272, 3158886335, 'RO', 'ROM', 'رومانيا'),
(41451, 3158886336, 3158886399, 'DE', 'DEU', 'ألمانيا'),
(41452, 3158886400, 3158886655, 'TR', 'TUR', 'تركيا'),
(41453, 3158886656, 3158886911, 'BY', 'BLR', 'روسيا البيضاء'),
(41454, 3158886912, 3158887167, 'DE', 'DEU', 'ألمانيا'),
(41455, 3158887168, 3158887423, 'CA', 'CAN', 'كندا'),
(41456, 3158887424, 3158887679, 'BY', 'BLR', 'روسيا البيضاء'),
(41457, 3158887680, 3158889215, 'DE', 'DEU', 'ألمانيا'),
(41458, 3158889216, 3158889727, 'TR', 'TUR', 'تركيا'),
(41459, 3158889728, 3158889983, 'BY', 'BLR', 'روسيا البيضاء'),
(41460, 3158889984, 3158890239, 'HK', 'HKG', 'هونغ كونغ'),
(41461, 3158890240, 3158891263, 'DE', 'DEU', 'ألمانيا'),
(41462, 3158891264, 3158891519, 'CA', 'CAN', 'كندا'),
(41463, 3158891520, 3158891583, 'DE', 'DEU', 'ألمانيا'),
(41464, 3158891584, 3158891647, 'RU', 'RUS', 'الإتحاد الروسي'),
(41465, 3158891648, 3158891711, 'DE', 'DEU', 'ألمانيا'),
(41466, 3158891712, 3158891775, 'RU', 'RUS', 'الإتحاد الروسي'),
(41467, 3158891776, 3158892031, 'PL', 'POL', 'بولندا'),
(41468, 3158892032, 3158892671, 'DE', 'DEU', 'ألمانيا'),
(41469, 3158892672, 3158892799, 'RU', 'RUS', 'الإتحاد الروسي'),
(41470, 3158892800, 3158893567, 'DE', 'DEU', 'ألمانيا'),
(41471, 3158893568, 3158893823, 'GB', 'GBR', 'المملكة المتحدة'),
(41472, 3158893824, 3158894079, 'TR', 'TUR', 'تركيا'),
(41473, 3158894080, 3158895167, 'DE', 'DEU', 'ألمانيا'),
(41474, 3158895168, 3158895231, 'RU', 'RUS', 'الإتحاد الروسي'),
(41475, 3158895232, 3158895423, 'DE', 'DEU', 'ألمانيا'),
(41476, 3158895424, 3158895487, 'RU', 'RUS', 'الإتحاد الروسي'),
(41477, 3158895488, 3158895551, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(41478, 3158895552, 3158895615, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(41479, 3158895616, 3158895871, 'IN', 'IND', 'الهند'),
(41480, 3158895872, 3158896127, 'DE', 'DEU', 'ألمانيا'),
(41481, 3158896128, 3158896255, 'UA', 'UKR', 'أوكرانيا'),
(41482, 3158896256, 3158896383, 'IN', 'IND', 'الهند'),
(41483, 3158896384, 3158896511, 'DE', 'DEU', 'ألمانيا'),
(41484, 3158896512, 3158896639, 'UA', 'UKR', 'أوكرانيا'),
(41485, 3158896640, 3158897151, 'DE', 'DEU', 'ألمانيا'),
(41486, 3158897152, 3158897407, 'BY', 'BLR', 'روسيا البيضاء'),
(41487, 3158897408, 3158897503, 'DE', 'DEU', 'ألمانيا'),
(41488, 3158897504, 3158897567, 'RU', 'RUS', 'الإتحاد الروسي'),
(41489, 3158897568, 3158897631, 'DE', 'DEU', 'ألمانيا'),
(41490, 3158897632, 3158897663, 'BZ', 'BLZ', 'بليز'),
(41491, 3158897664, 3158897727, 'DE', 'DEU', 'ألمانيا'),
(41492, 3158897728, 3158897791, 'RU', 'RUS', 'الإتحاد الروسي'),
(41493, 3158897792, 3158897919, 'DE', 'DEU', 'ألمانيا'),
(41494, 3158897920, 3158898175, 'BY', 'BLR', 'روسيا البيضاء'),
(41495, 3158898176, 3158898207, 'DE', 'DEU', 'ألمانيا'),
(41496, 3158898208, 3158898271, 'CZ', 'CZE', 'التشيك'),
(41497, 3158898272, 3158898335, 'RU', 'RUS', 'الإتحاد الروسي'),
(41498, 3158898336, 3158898431, 'DE', 'DEU', 'ألمانيا'),
(41499, 3158898432, 3158898687, 'US', 'USA', 'الولايات المتحدة'),
(41500, 3158898688, 3158898943, 'DE', 'DEU', 'ألمانيا'),
(41501, 3158898944, 3158899199, 'ES', 'ESP', 'إسبانيا'),
(41502, 3158899200, 3158899455, 'DE', 'DEU', 'ألمانيا'),
(41503, 3158899456, 3158899711, 'CA', 'CAN', 'كندا'),
(41504, 3158899712, 3158900735, 'DE', 'DEU', 'ألمانيا'),
(41505, 3158900736, 3158917119, 'FR', 'FRA', 'فرنسا'),
(41506, 3158917120, 3158933503, 'DE', 'DEU', 'ألمانيا'),
(41507, 3158933504, 3158949887, 'RU', 'RUS', 'الإتحاد الروسي'),
(41508, 3158949888, 3158966271, 'GR', 'GRC', 'اليونان'),
(41509, 3158982656, 3158999039, 'GB', 'GBR', 'المملكة المتحدة'),
(41510, 3158999040, 3159031807, 'RO', 'ROM', 'رومانيا'),
(41511, 3159031808, 3159048191, 'RU', 'RUS', 'الإتحاد الروسي'),
(41512, 3159048192, 3159064575, 'IR', 'IRN', 'إيران'),
(41513, 3159064576, 3159080959, 'CZ', 'CZE', 'التشيك'),
(41514, 3159080960, 3159097343, 'RU', 'RUS', 'الإتحاد الروسي'),
(41515, 3159359488, 3159621631, 'PT', 'PRT', 'البورتوغال'),
(41516, 3159621632, 3159883775, 'ES', 'ESP', 'إسبانيا'),
(41517, 3159883776, 3160145919, 'NL', 'NLD', 'هولندا'),
(41518, 3160145920, 3160147967, 'RU', 'RUS', 'الإتحاد الروسي'),
(41519, 3160147968, 3160150015, 'CZ', 'CZE', 'التشيك'),
(41520, 3160150016, 3160152063, 'LV', 'LVA', 'لاتفيا'),
(41521, 3160152064, 3160154111, 'IT', 'ITA', 'إيطاليا'),
(41522, 3160154112, 3160156159, 'DE', 'DEU', 'ألمانيا'),
(41523, 3160156160, 3160158207, 'AM', 'ARM', 'أرمينيا'),
(41524, 3160160256, 3160162303, 'NL', 'NLD', 'هولندا'),
(41525, 3160162304, 3160164351, 'FR', 'FRA', 'فرنسا'),
(41526, 3160164352, 3160166399, 'LV', 'LVA', 'لاتفيا'),
(41527, 3160166400, 3160168447, 'NO', 'NOR', 'النرويج'),
(41528, 3160168448, 3160170495, 'GB', 'GBR', 'المملكة المتحدة'),
(41529, 3160170496, 3160172543, 'IT', 'ITA', 'إيطاليا'),
(41530, 3160172544, 3160174591, 'RU', 'RUS', 'الإتحاد الروسي'),
(41531, 3160174592, 3160176639, 'DE', 'DEU', 'ألمانيا'),
(41532, 3160176640, 3160178687, 'IT', 'ITA', 'إيطاليا'),
(41533, 3160178688, 3160180735, 'DE', 'DEU', 'ألمانيا'),
(41534, 3160180736, 3160182783, 'GB', 'GBR', 'المملكة المتحدة'),
(41535, 3160182784, 3160184831, 'CH', 'CHE', 'سويسرا'),
(41536, 3160184832, 3160186879, 'NL', 'NLD', 'هولندا'),
(41537, 3160186880, 3160188927, 'EE', 'EST', 'إستونيا'),
(41538, 3160188928, 3160190975, 'SE', 'SWE', 'السويد'),
(41539, 3160190976, 3160193023, 'RU', 'RUS', 'الإتحاد الروسي'),
(41540, 3160193024, 3160193279, 'IT', 'ITA', 'إيطاليا'),
(41541, 3160193280, 3160193535, 'US', 'USA', 'الولايات المتحدة'),
(41542, 3160193536, 3160193791, 'IT', 'ITA', 'إيطاليا'),
(41543, 3160193792, 3160193807, 'US', 'USA', 'الولايات المتحدة'),
(41544, 3160193808, 3160193871, 'LY', 'LBY', 'ليبيا'),
(41545, 3160193872, 3160194047, 'IT', 'ITA', 'إيطاليا'),
(41546, 3160194048, 3160194175, 'LY', 'LBY', 'ليبيا'),
(41547, 3160194176, 3160195071, 'IT', 'ITA', 'إيطاليا'),
(41548, 3160195072, 3160197119, 'RU', 'RUS', 'الإتحاد الروسي'),
(41549, 3160197120, 3160199167, 'DE', 'DEU', 'ألمانيا'),
(41550, 3160199168, 3160201215, 'GE', 'GEO', 'جورجيا'),
(41551, 3160201216, 3160203263, 'RU', 'RUS', 'الإتحاد الروسي'),
(41552, 3160203264, 3160203775, 'CH', 'CHE', 'سويسرا'),
(41553, 3160203776, 3160203783, 'DE', 'DEU', 'ألمانيا'),
(41554, 3160203784, 3160203807, 'CH', 'CHE', 'سويسرا'),
(41555, 3160203808, 3160203815, 'FR', 'FRA', 'فرنسا'),
(41556, 3160203816, 3160205311, 'CH', 'CHE', 'سويسرا'),
(41557, 3160205312, 3160207359, 'GB', 'GBR', 'المملكة المتحدة'),
(41558, 3160207360, 3160209407, 'RU', 'RUS', 'الإتحاد الروسي'),
(41559, 3160209408, 3160211455, 'SE', 'SWE', 'السويد'),
(41560, 3160211456, 3160213503, 'IE', 'IRL', 'إيرلندا'),
(41561, 3160213504, 3160215551, 'DE', 'DEU', 'ألمانيا'),
(41562, 3160215552, 3160219647, 'RU', 'RUS', 'الإتحاد الروسي'),
(41563, 3160219648, 3160221695, 'ES', 'ESP', 'إسبانيا'),
(41564, 3160221696, 3160223743, 'FR', 'FRA', 'فرنسا'),
(41565, 3160223744, 3160227839, 'RU', 'RUS', 'الإتحاد الروسي'),
(41566, 3160227840, 3160229887, 'IR', 'IRN', 'إيران'),
(41567, 3160229888, 3160231935, 'ES', 'ESP', 'إسبانيا'),
(41568, 3160231936, 3160233983, 'BE', 'BEL', 'بلجيكا'),
(41569, 3160233984, 3160236031, 'GE', 'GEO', 'جورجيا'),
(41570, 3160236032, 3160238079, 'BE', 'BEL', 'بلجيكا'),
(41571, 3160238080, 3160240127, 'RU', 'RUS', 'الإتحاد الروسي'),
(41572, 3160240128, 3160242175, 'BE', 'BEL', 'بلجيكا'),
(41573, 3160242176, 3160244223, 'RS', 'SRB', 'صربيا'),
(41574, 3160244224, 3160246271, 'RU', 'RUS', 'الإتحاد الروسي'),
(41575, 3160246272, 3160248319, 'IT', 'ITA', 'إيطاليا'),
(41576, 3160248320, 3160250367, 'NL', 'NLD', 'هولندا'),
(41577, 3160250368, 3160252415, 'BE', 'BEL', 'بلجيكا'),
(41578, 3160252416, 3160254463, 'PL', 'POL', 'بولندا'),
(41579, 3160254464, 3160256511, 'LU', 'LUX', 'لوكسيمبورغ'),
(41580, 3160256512, 3160258559, 'GB', 'GBR', 'المملكة المتحدة'),
(41581, 3160258560, 3160260607, 'NO', 'NOR', 'النرويج'),
(41582, 3160260608, 3160262655, 'PT', 'PRT', 'البورتوغال'),
(41583, 3160262656, 3160264703, 'HU', 'HUN', 'هنغاريا'),
(41584, 3160264704, 3160266751, 'RU', 'RUS', 'الإتحاد الروسي'),
(41585, 3160266752, 3160268799, 'DE', 'DEU', 'ألمانيا'),
(41586, 3160268800, 3160271615, 'PT', 'PRT', 'البورتوغال'),
(41587, 3160271616, 3160271871, 'ES', 'ESP', 'إسبانيا'),
(41588, 3160271872, 3160272895, 'PT', 'PRT', 'البورتوغال'),
(41589, 3160272896, 3160274943, 'RU', 'RUS', 'الإتحاد الروسي'),
(41590, 3160274944, 3160276991, 'AT', 'AUT', 'النمسا'),
(41591, 3160276992, 3160279039, 'RU', 'RUS', 'الإتحاد الروسي'),
(41592, 3160279040, 3160281087, 'ES', 'ESP', 'إسبانيا'),
(41593, 3160281088, 3160283135, 'GB', 'GBR', 'المملكة المتحدة'),
(41594, 3160283136, 3160285183, 'DE', 'DEU', 'ألمانيا'),
(41595, 3160285184, 3160287231, 'RU', 'RUS', 'الإتحاد الروسي'),
(41596, 3160287232, 3160289279, 'GB', 'GBR', 'المملكة المتحدة'),
(41597, 3160289280, 3160291327, 'RU', 'RUS', 'الإتحاد الروسي'),
(41598, 3160291328, 3160293375, 'ES', 'ESP', 'إسبانيا'),
(41599, 3160293376, 3160295423, 'FI', 'FIN', 'فنلندا'),
(41600, 3160295424, 3160297471, 'GB', 'GBR', 'المملكة المتحدة'),
(41601, 3160297472, 3160299519, 'MD', 'MDA', 'مولدوفا'),
(41602, 3160299520, 3160301567, 'RU', 'RUS', 'الإتحاد الروسي'),
(41603, 3160301568, 3160303615, 'DE', 'DEU', 'ألمانيا'),
(41604, 3160303616, 3160305663, 'GB', 'GBR', 'المملكة المتحدة'),
(41605, 3160305664, 3160307711, 'DE', 'DEU', 'ألمانيا'),
(41606, 3160307712, 3160309759, 'IT', 'ITA', 'إيطاليا'),
(41607, 3160309760, 3160311807, 'GB', 'GBR', 'المملكة المتحدة'),
(41608, 3160311808, 3160313855, 'HU', 'HUN', 'هنغاريا'),
(41609, 3160313856, 3160315903, 'IT', 'ITA', 'إيطاليا'),
(41610, 3160315904, 3160317951, 'KZ', 'KAZ', 'كازاخستان'),
(41611, 3160317952, 3160322047, 'RU', 'RUS', 'الإتحاد الروسي'),
(41612, 3160322048, 3160324095, 'CH', 'CHE', 'سويسرا'),
(41613, 3160324096, 3160328191, 'IT', 'ITA', 'إيطاليا'),
(41614, 3160328192, 3160330239, 'FR', 'FRA', 'فرنسا'),
(41615, 3160330240, 3160332287, 'RU', 'RUS', 'الإتحاد الروسي'),
(41616, 3160332288, 3160333055, 'NO', 'NOR', 'النرويج'),
(41617, 3160333056, 3160333087, 'CO', 'COL', 'كولومبيا'),
(41618, 3160333088, 3160334335, 'NO', 'NOR', 'النرويج'),
(41619, 3160334336, 3160336383, 'RU', 'RUS', 'الإتحاد الروسي'),
(41620, 3160336384, 3160338431, 'CZ', 'CZE', 'التشيك'),
(41621, 3160338432, 3160340479, 'GB', 'GBR', 'المملكة المتحدة'),
(41622, 3160340480, 3160346623, 'DE', 'DEU', 'ألمانيا'),
(41623, 3160346624, 3160348671, 'IT', 'ITA', 'إيطاليا'),
(41624, 3160348672, 3160350719, 'PL', 'POL', 'بولندا'),
(41625, 3160350720, 3160352767, 'SE', 'SWE', 'السويد'),
(41626, 3160352768, 3160354815, 'GB', 'GBR', 'المملكة المتحدة'),
(41627, 3160354816, 3160356863, 'NL', 'NLD', 'هولندا'),
(41628, 3160356864, 3160358911, 'CZ', 'CZE', 'التشيك'),
(41629, 3160358912, 3160360959, 'JO', 'JOR', 'الأردن'),
(41630, 3160360960, 3160363007, 'IT', 'ITA', 'إيطاليا'),
(41631, 3160363008, 3160365055, 'GB', 'GBR', 'المملكة المتحدة'),
(41632, 3160365056, 3160369151, 'NL', 'NLD', 'هولندا'),
(41633, 3160369152, 3160371199, 'RU', 'RUS', 'الإتحاد الروسي'),
(41634, 3160371200, 3160373247, 'ES', 'ESP', 'إسبانيا'),
(41635, 3160373248, 3160375295, 'CZ', 'CZE', 'التشيك'),
(41636, 3160375296, 3160377343, 'GB', 'GBR', 'المملكة المتحدة'),
(41637, 3160377344, 3160379391, 'NL', 'NLD', 'هولندا'),
(41638, 3160379392, 3160381439, 'TR', 'TUR', 'تركيا'),
(41639, 3160381440, 3160383487, 'UA', 'UKR', 'أوكرانيا'),
(41640, 3160383488, 3160385535, 'GB', 'GBR', 'المملكة المتحدة'),
(41641, 3160385536, 3160387583, 'NL', 'NLD', 'هولندا'),
(41642, 3160387584, 3160389631, 'RS', 'SRB', 'صربيا'),
(41643, 3160389632, 3160391679, 'RU', 'RUS', 'الإتحاد الروسي'),
(41644, 3160391680, 3160395775, 'GB', 'GBR', 'المملكة المتحدة'),
(41645, 3160395776, 3160397823, 'EE', 'EST', 'إستونيا'),
(41646, 3160397824, 3160399871, 'ES', 'ESP', 'إسبانيا'),
(41647, 3160399872, 3160403967, 'SE', 'SWE', 'السويد'),
(41648, 3160403968, 3160406015, 'NO', 'NOR', 'النرويج'),
(41649, 3160408064, 3161456639, 'DE', 'DEU', 'ألمانيا'),
(41650, 3161456640, 3161473023, 'PL', 'POL', 'بولندا'),
(41651, 3161473024, 3161489407, 'SK', 'SVK', 'سلوفاكيا'),
(41652, 3161489408, 3161505791, 'LV', 'LVA', 'لاتفيا'),
(41653, 3161505792, 3161538559, 'RU', 'RUS', 'الإتحاد الروسي'),
(41654, 3161538560, 3161554943, 'NO', 'NOR', 'النرويج'),
(41655, 3161554944, 3161571327, 'RU', 'RUS', 'الإتحاد الروسي'),
(41656, 3161571328, 3161587711, 'UZ', 'UZB', 'أوزباكستان'),
(41657, 3161587712, 3161620479, 'RU', 'RUS', 'الإتحاد الروسي'),
(41658, 3161620480, 3161636863, 'DK', 'DNK', 'الدنيمارك'),
(41659, 3161636864, 3161653247, 'RU', 'RUS', 'الإتحاد الروسي'),
(41660, 3161653248, 3161669631, 'LU', 'LUX', 'لوكسيمبورغ'),
(41661, 3161669632, 3161686015, 'FR', 'FRA', 'فرنسا'),
(41662, 3161686016, 3161702399, 'UA', 'UKR', 'أوكرانيا'),
(41663, 3161702400, 3161718783, 'AM', 'ARM', 'أرمينيا'),
(41664, 3161718784, 3161735167, 'PL', 'POL', 'بولندا'),
(41665, 3161735168, 3161751551, 'CZ', 'CZE', 'التشيك'),
(41666, 3161751552, 3161767935, 'RU', 'RUS', 'الإتحاد الروسي'),
(41667, 3161767936, 3161784319, 'BH', 'BHR', 'البحرين'),
(41668, 3161784320, 3161800703, 'FI', 'FIN', 'فنلندا'),
(41669, 3161800704, 3161817087, 'SA', 'SAU', 'السعودية'),
(41670, 3161817088, 3161833471, 'PL', 'POL', 'بولندا'),
(41671, 3161833472, 3161833983, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(41672, 3161833984, 3161834495, 'AT', 'AUT', 'النمسا'),
(41673, 3161834496, 3161835263, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(41674, 3161835264, 3161849855, 'AT', 'AUT', 'النمسا'),
(41675, 3161849856, 3161866239, 'BE', 'BEL', 'بلجيكا'),
(41676, 3161866240, 3161882623, 'IR', 'IRN', 'إيران'),
(41677, 3161882624, 3161899007, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(41678, 3161899008, 3161915391, 'AT', 'AUT', 'النمسا'),
(41679, 3161931776, 3161948159, 'SA', 'SAU', 'السعودية'),
(41680, 3161948160, 3161964543, 'RO', 'ROM', 'رومانيا'),
(41681, 3161964544, 3161980927, 'ES', 'ESP', 'إسبانيا'),
(41682, 3161980928, 3161989119, 'SK', 'SVK', 'سلوفاكيا'),
(41683, 3161989120, 3161997311, 'RU', 'RUS', 'الإتحاد الروسي'),
(41684, 3161997312, 3162005503, 'DK', 'DNK', 'الدنيمارك'),
(41685, 3162005504, 3162013695, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(41686, 3162013696, 3162021887, 'IL', 'ISR', 'إسرائيل'),
(41687, 3162021888, 3162030079, 'SE', 'SWE', 'السويد'),
(41688, 3162030080, 3162038271, 'CZ', 'CZE', 'التشيك'),
(41689, 3162038272, 3162046463, 'RU', 'RUS', 'الإتحاد الروسي'),
(41690, 3162046464, 3162054655, 'PL', 'POL', 'بولندا'),
(41691, 3162054656, 3162062847, 'NL', 'NLD', 'هولندا'),
(41692, 3162062848, 3162071039, 'SE', 'SWE', 'السويد'),
(41693, 3162071040, 3162087423, 'IR', 'IRN', 'إيران'),
(41694, 3162087424, 3162095615, 'SK', 'SVK', 'سلوفاكيا'),
(41695, 3162095616, 3162103807, 'GE', 'GEO', 'جورجيا'),
(41696, 3162103808, 3162104319, 'FR', 'FRA', 'فرنسا'),
(41697, 3162104320, 3162108415, 'NL', 'NLD', 'هولندا'),
(41698, 3162108416, 3162111999, 'FR', 'FRA', 'فرنسا'),
(41699, 3162112000, 3162120191, 'PL', 'POL', 'بولندا'),
(41700, 3162120192, 3162128383, 'GB', 'GBR', 'المملكة المتحدة'),
(41701, 3162128384, 3162129407, 'NL', 'NLD', 'هولندا'),
(41702, 3162129408, 3162129919, 'DE', 'DEU', 'ألمانيا'),
(41703, 3162129920, 3162136575, 'NL', 'NLD', 'هولندا'),
(41704, 3162144768, 3162152959, 'SE', 'SWE', 'السويد'),
(41705, 3162152960, 3162161151, 'RU', 'RUS', 'الإتحاد الروسي'),
(41706, 3162161152, 3162169343, 'CZ', 'CZE', 'التشيك'),
(41707, 3162169344, 3162177535, 'RU', 'RUS', 'الإتحاد الروسي'),
(41708, 3162177536, 3162185727, 'FI', 'FIN', 'فنلندا'),
(41709, 3162185728, 3162193919, 'RU', 'RUS', 'الإتحاد الروسي'),
(41710, 3162193920, 3162202111, 'FR', 'FRA', 'فرنسا'),
(41711, 3162202112, 3162210303, 'SK', 'SVK', 'سلوفاكيا'),
(41712, 3162210304, 3162218495, 'GE', 'GEO', 'جورجيا'),
(41713, 3162218496, 3162226687, 'JO', 'JOR', 'الأردن'),
(41714, 3162226688, 3162234879, 'PL', 'POL', 'بولندا'),
(41715, 3162234880, 3162243071, 'RU', 'RUS', 'الإتحاد الروسي'),
(41716, 3162243072, 3162251263, 'TR', 'TUR', 'تركيا'),
(41717, 3162251264, 3162259455, 'RU', 'RUS', 'الإتحاد الروسي'),
(41718, 3162259456, 3162267647, 'CZ', 'CZE', 'التشيك'),
(41719, 3162267648, 3162275839, 'RU', 'RUS', 'الإتحاد الروسي'),
(41720, 3162275840, 3162284031, 'NO', 'NOR', 'النرويج'),
(41721, 3162284032, 3162292223, 'PL', 'POL', 'بولندا'),
(41722, 3162292224, 3162300415, 'BA', 'BIH', 'البوسنه والهرسك'),
(41723, 3162300416, 3162308607, 'RU', 'RUS', 'الإتحاد الروسي'),
(41724, 3162308608, 3162316799, 'HR', 'HRV', 'كرواتيا'),
(41725, 3162316800, 3162324991, 'PL', 'POL', 'بولندا'),
(41726, 3162324992, 3162327039, 'GB', 'GBR', 'المملكة المتحدة'),
(41727, 3162327040, 3162327296, 'CH', 'CHE', 'سويسرا'),
(41728, 3162327297, 3162333183, 'GB', 'GBR', 'المملكة المتحدة'),
(41729, 3162333184, 3162341375, 'IT', 'ITA', 'إيطاليا'),
(41730, 3162341376, 3162349567, 'PL', 'POL', 'بولندا'),
(41731, 3162349568, 3162357759, 'TR', 'TUR', 'تركيا'),
(41732, 3162357760, 3162365951, 'PT', 'PRT', 'البورتوغال'),
(41733, 3162365952, 3162374143, 'PL', 'POL', 'بولندا'),
(41734, 3162374144, 3162382335, 'BG', 'BGR', 'بلغاريا'),
(41735, 3162382336, 3162390527, 'RU', 'RUS', 'الإتحاد الروسي'),
(41736, 3162390528, 3162398719, 'SE', 'SWE', 'السويد'),
(41737, 3162398720, 3162406911, 'BE', 'BEL', 'بلجيكا'),
(41738, 3162406912, 3162415103, 'IR', 'IRN', 'إيران'),
(41739, 3162415104, 3162423295, 'DE', 'DEU', 'ألمانيا'),
(41740, 3162423296, 3162431487, 'NO', 'NOR', 'النرويج'),
(41741, 3162431488, 3162439679, 'SE', 'SWE', 'السويد'),
(41742, 3162439680, 3162447871, 'PL', 'POL', 'بولندا'),
(41743, 3162447872, 3162456063, 'RU', 'RUS', 'الإتحاد الروسي'),
(41744, 3162456064, 3162464255, 'BG', 'BGR', 'بلغاريا'),
(41745, 3162464256, 3162472447, 'BA', 'BIH', 'البوسنه والهرسك'),
(41746, 3162472448, 3162480639, 'HU', 'HUN', 'هنغاريا'),
(41747, 3162480640, 3162488831, 'ES', 'ESP', 'إسبانيا'),
(41748, 3162488832, 3162497023, 'FI', 'FIN', 'فنلندا'),
(41749, 3162497024, 3162537983, 'RU', 'RUS', 'الإتحاد الروسي'),
(41750, 3162537984, 3162570751, 'PL', 'POL', 'بولندا'),
(41751, 3162570752, 3162603519, 'HR', 'HRV', 'كرواتيا'),
(41752, 3162603520, 3162636287, 'GE', 'GEO', 'جورجيا'),
(41753, 3162636288, 3162669055, 'FR', 'FRA', 'فرنسا'),
(41754, 3162669056, 3162681343, 'RU', 'RUS', 'الإتحاد الروسي'),
(41755, 3162681344, 3162682367, 'UA', 'UKR', 'أوكرانيا'),
(41756, 3162682368, 3162685439, 'RU', 'RUS', 'الإتحاد الروسي'),
(41757, 3162685440, 3162697727, 'UA', 'UKR', 'أوكرانيا'),
(41758, 3162697728, 3162700287, 'RU', 'RUS', 'الإتحاد الروسي'),
(41759, 3162700288, 3162700799, 'LV', 'LVA', 'لاتفيا'),
(41760, 3162700800, 3162701823, 'RU', 'RUS', 'الإتحاد الروسي'),
(41761, 3162701824, 3162734591, 'MD', 'MDA', 'مولدوفا'),
(41762, 3162734592, 3162767359, 'RU', 'RUS', 'الإتحاد الروسي'),
(41763, 3162767360, 3162800127, 'SA', 'SAU', 'السعودية'),
(41764, 3162800128, 3162802175, 'TR', 'TUR', 'تركيا'),
(41765, 3162802176, 3162803199, 'CZ', 'CZE', 'التشيك'),
(41766, 3162803200, 3162821631, 'TR', 'TUR', 'تركيا'),
(41767, 3162821632, 3162821887, 'CZ', 'CZE', 'التشيك'),
(41768, 3162821888, 3162824703, 'TR', 'TUR', 'تركيا'),
(41769, 3162824704, 3162828799, 'NL', 'NLD', 'هولندا'),
(41770, 3162828800, 3162832895, 'TR', 'TUR', 'تركيا'),
(41771, 3162832896, 3162865663, 'GR', 'GRC', 'اليونان'),
(41772, 3162865664, 3162931199, 'RU', 'RUS', 'الإتحاد الروسي'),
(41773, 3162931200, 3162963967, 'CZ', 'CZE', 'التشيك'),
(41774, 3162963968, 3162996735, 'OM', 'OMN', 'عمان'),
(41775, 3162996736, 3163029503, 'IT', 'ITA', 'إيطاليا'),
(41776, 3163029504, 3163062271, 'DE', 'DEU', 'ألمانيا'),
(41777, 3163062272, 3163095039, 'IR', 'IRN', 'إيران'),
(41778, 3163095040, 3163127807, 'PL', 'POL', 'بولندا'),
(41779, 3163160576, 3163161695, 'DE', 'DEU', 'ألمانيا'),
(41780, 3163161696, 3163161727, 'BG', 'BGR', 'بلغاريا'),
(41781, 3163161728, 3163162239, 'DE', 'DEU', 'ألمانيا'),
(41782, 3163162240, 3163162271, 'CH', 'CHE', 'سويسرا'),
(41783, 3163162272, 3163162303, 'NL', 'NLD', 'هولندا'),
(41784, 3163162304, 3163162367, 'DE', 'DEU', 'ألمانيا'),
(41785, 3163162368, 3163162399, 'TR', 'TUR', 'تركيا'),
(41786, 3163162400, 3163163743, 'DE', 'DEU', 'ألمانيا'),
(41787, 3163163744, 3163163775, 'GB', 'GBR', 'المملكة المتحدة'),
(41788, 3163163776, 3163166111, 'DE', 'DEU', 'ألمانيا'),
(41789, 3163166112, 3163166143, 'PT', 'PRT', 'البورتوغال'),
(41790, 3163166144, 3163166495, 'DE', 'DEU', 'ألمانيا'),
(41791, 3163166496, 3163166527, 'RO', 'ROM', 'رومانيا'),
(41792, 3163166528, 3163166559, 'TR', 'TUR', 'تركيا'),
(41793, 3163166560, 3163167807, 'DE', 'DEU', 'ألمانيا'),
(41794, 3163167808, 3163167839, 'TR', 'TUR', 'تركيا'),
(41795, 3163167840, 3163168031, 'DE', 'DEU', 'ألمانيا'),
(41796, 3163168032, 3163168063, 'RU', 'RUS', 'الإتحاد الروسي'),
(41797, 3163168064, 3163168319, 'DE', 'DEU', 'ألمانيا'),
(41798, 3163168320, 3163168351, 'DK', 'DNK', 'الدنيمارك'),
(41799, 3163168352, 3163168575, 'DE', 'DEU', 'ألمانيا'),
(41800, 3163168576, 3163168607, 'TR', 'TUR', 'تركيا'),
(41801, 3163168608, 3163168639, 'UA', 'UKR', 'أوكرانيا'),
(41802, 3163168640, 3163168671, 'DE', 'DEU', 'ألمانيا'),
(41803, 3163168672, 3163168703, 'US', 'USA', 'الولايات المتحدة'),
(41804, 3163168704, 3163169823, 'DE', 'DEU', 'ألمانيا'),
(41805, 3163169824, 3163169855, 'RU', 'RUS', 'الإتحاد الروسي'),
(41806, 3163169856, 3163169887, 'TR', 'TUR', 'تركيا'),
(41807, 3163169888, 3163169951, 'DE', 'DEU', 'ألمانيا'),
(41808, 3163169952, 3163169983, 'GB', 'GBR', 'المملكة المتحدة'),
(41809, 3163169984, 3163170015, 'DE', 'DEU', 'ألمانيا'),
(41810, 3163170016, 3163170047, 'TR', 'TUR', 'تركيا'),
(41811, 3163170048, 3163170079, 'DE', 'DEU', 'ألمانيا'),
(41812, 3163170080, 3163170111, 'TR', 'TUR', 'تركيا'),
(41813, 3163170112, 3163170207, 'DE', 'DEU', 'ألمانيا'),
(41814, 3163170208, 3163170239, 'RU', 'RUS', 'الإتحاد الروسي'),
(41815, 3163170240, 3163170303, 'DE', 'DEU', 'ألمانيا'),
(41816, 3163170304, 3163170335, 'IT', 'ITA', 'إيطاليا'),
(41817, 3163170336, 3163170591, 'DE', 'DEU', 'ألمانيا'),
(41818, 3163170592, 3163170623, 'BR', 'BRA', 'البرازيل'),
(41819, 3163170624, 3163170655, 'DE', 'DEU', 'ألمانيا'),
(41820, 3163170656, 3163170687, 'DK', 'DNK', 'الدنيمارك'),
(41821, 3163170688, 3163172127, 'DE', 'DEU', 'ألمانيا'),
(41822, 3163172128, 3163172159, 'TR', 'TUR', 'تركيا'),
(41823, 3163172160, 3163172223, 'DE', 'DEU', 'ألمانيا'),
(41824, 3163172224, 3163172255, 'TR', 'TUR', 'تركيا'),
(41825, 3163172256, 3163172287, 'PL', 'POL', 'بولندا'),
(41826, 3163172288, 3163172319, 'TR', 'TUR', 'تركيا'),
(41827, 3163172320, 3163172351, 'HU', 'HUN', 'هنغاريا'),
(41828, 3163172352, 3163172383, 'GB', 'GBR', 'المملكة المتحدة'),
(41829, 3163172384, 3163172607, 'DE', 'DEU', 'ألمانيا'),
(41830, 3163172608, 3163172639, 'DK', 'DNK', 'الدنيمارك'),
(41831, 3163172640, 3163172671, 'DE', 'DEU', 'ألمانيا'),
(41832, 3163172672, 3163172703, 'TR', 'TUR', 'تركيا'),
(41833, 3163172704, 3163172735, 'DE', 'DEU', 'ألمانيا'),
(41834, 3163172736, 3163172767, 'GR', 'GRC', 'اليونان'),
(41835, 3163172768, 3163174047, 'DE', 'DEU', 'ألمانيا'),
(41836, 3163174048, 3163174079, 'DK', 'DNK', 'الدنيمارك'),
(41837, 3163174080, 3163174175, 'DE', 'DEU', 'ألمانيا'),
(41838, 3163174176, 3163174207, 'RU', 'RUS', 'الإتحاد الروسي'),
(41839, 3163174208, 3163174239, 'TR', 'TUR', 'تركيا'),
(41840, 3163174240, 3163174335, 'DE', 'DEU', 'ألمانيا'),
(41841, 3163174336, 3163174367, 'RU', 'RUS', 'الإتحاد الروسي'),
(41842, 3163174368, 3163174399, 'DE', 'DEU', 'ألمانيا'),
(41843, 3163174400, 3163174431, 'DK', 'DNK', 'الدنيمارك'),
(41844, 3163174432, 3163176127, 'DE', 'DEU', 'ألمانيا'),
(41845, 3163176128, 3163176159, 'TR', 'TUR', 'تركيا'),
(41846, 3163176160, 3163176575, 'DE', 'DEU', 'ألمانيا'),
(41847, 3163176576, 3163176607, 'GR', 'GRC', 'اليونان'),
(41848, 3163176608, 3163193343, 'DE', 'DEU', 'ألمانيا'),
(41849, 3163226112, 3163258879, 'SA', 'SAU', 'السعودية'),
(41850, 3163258880, 3163291647, 'SY', 'SYR', 'سوريا'),
(41851, 3163291648, 3163324415, 'PT', 'PRT', 'البورتوغال'),
(41852, 3163324416, 3163357183, 'OM', 'OMN', 'عمان'),
(41853, 3163357184, 3163389951, 'IE', 'IRL', 'إيرلندا'),
(41854, 3163389952, 3163422719, 'FR', 'FRA', 'فرنسا'),
(41855, 3163422720, 3163455487, 'NL', 'NLD', 'هولندا'),
(41856, 3163455488, 3163488255, 'HU', 'HUN', 'هنغاريا'),
(41857, 3163488256, 3163521023, 'UA', 'UKR', 'أوكرانيا'),
(41858, 3163521024, 3163553791, 'RU', 'RUS', 'الإتحاد الروسي'),
(41859, 3163553792, 3163684863, 'DE', 'DEU', 'ألمانيا'),
(41860, 3163684864, 3163815935, 'PL', 'POL', 'بولندا'),
(41861, 3163815936, 3164078079, 'NO', 'NOR', 'النرويج'),
(41862, 3164078080, 3164209151, 'IT', 'ITA', 'إيطاليا'),
(41863, 3164209152, 3164340223, 'CH', 'CHE', 'سويسرا'),
(41864, 3164340224, 3164471295, 'HU', 'HUN', 'هنغاريا'),
(41865, 3164471296, 3164602367, 'IR', 'IRN', 'إيران'),
(41866, 3164602368, 3164667903, 'SY', 'SYR', 'سوريا'),
(41867, 3164667904, 3164733439, 'PS', 'PSE', 'فلسطين المحتلة'),
(41868, 3164733440, 3164798975, 'RU', 'RUS', 'الإتحاد الروسي'),
(41869, 3164798976, 3164864511, 'UA', 'UKR', 'أوكرانيا'),
(41870, 3164864512, 3164930047, 'RU', 'RUS', 'الإتحاد الروسي'),
(41871, 3164930048, 3164932095, 'IE', 'IRL', 'إيرلندا'),
(41872, 3164932096, 3164934143, 'FR', 'FRA', 'فرنسا'),
(41873, 3164934144, 3164936191, 'PL', 'POL', 'بولندا'),
(41874, 3164936192, 3164938239, 'LT', 'LTU', 'ليتوانيا'),
(41875, 3164938240, 3164946431, 'FR', 'FRA', 'فرنسا'),
(41876, 3164946432, 3164946435, 'PL', 'POL', 'بولندا'),
(41877, 3164946436, 3164946439, 'PT', 'PRT', 'البورتوغال'),
(41878, 3164946440, 3164946447, 'ES', 'ESP', 'إسبانيا'),
(41879, 3164946448, 3164946479, 'FR', 'FRA', 'فرنسا'),
(41880, 3164946480, 3164946483, 'ES', 'ESP', 'إسبانيا'),
(41881, 3164946484, 3164946487, 'PL', 'POL', 'بولندا'),
(41882, 3164946488, 3164946495, 'FR', 'FRA', 'فرنسا'),
(41883, 3164946496, 3164946499, 'IT', 'ITA', 'إيطاليا'),
(41884, 3164946500, 3164946503, 'GB', 'GBR', 'المملكة المتحدة'),
(41885, 3164946504, 3164946507, 'BE', 'BEL', 'بلجيكا'),
(41886, 3164946508, 3164946511, 'FR', 'FRA', 'فرنسا'),
(41887, 3164946512, 3164946527, 'ES', 'ESP', 'إسبانيا'),
(41888, 3164946528, 3164946559, 'GB', 'GBR', 'المملكة المتحدة'),
(41889, 3164946560, 3164946783, 'FR', 'FRA', 'فرنسا'),
(41890, 3164946784, 3164946799, 'BE', 'BEL', 'بلجيكا'),
(41891, 3164946800, 3164947071, 'FR', 'FRA', 'فرنسا'),
(41892, 3164947072, 3164947199, 'DE', 'DEU', 'ألمانيا'),
(41893, 3164947200, 3164947455, 'FR', 'FRA', 'فرنسا'),
(41894, 3164947456, 3164947711, 'DE', 'DEU', 'ألمانيا'),
(41895, 3164947712, 3164947743, 'FR', 'FRA', 'فرنسا'),
(41896, 3164947744, 3164947747, 'ES', 'ESP', 'إسبانيا'),
(41897, 3164947748, 3164947751, 'BE', 'BEL', 'بلجيكا'),
(41898, 3164947752, 3164947839, 'FR', 'FRA', 'فرنسا'),
(41899, 3164947840, 3164947967, 'GB', 'GBR', 'المملكة المتحدة'),
(41900, 3164947968, 3164948479, 'BE', 'BEL', 'بلجيكا'),
(41901, 3164948480, 3164948735, 'FR', 'FRA', 'فرنسا'),
(41902, 3164948736, 3164948991, 'PL', 'POL', 'بولندا'),
(41903, 3164948992, 3164949087, 'GB', 'GBR', 'المملكة المتحدة'),
(41904, 3164949088, 3164949095, 'FR', 'FRA', 'فرنسا'),
(41905, 3164949096, 3164949103, 'IT', 'ITA', 'إيطاليا'),
(41906, 3164949104, 3164949119, 'FR', 'FRA', 'فرنسا'),
(41907, 3164949120, 3164949131, 'DE', 'DEU', 'ألمانيا'),
(41908, 3164949132, 3164949135, 'FR', 'FRA', 'فرنسا'),
(41909, 3164949136, 3164949151, 'GB', 'GBR', 'المملكة المتحدة'),
(41910, 3164949152, 3164949155, 'NL', 'NLD', 'هولندا'),
(41911, 3164949156, 3164949159, 'FR', 'FRA', 'فرنسا'),
(41912, 3164949160, 3164949163, 'PL', 'POL', 'بولندا'),
(41913, 3164949164, 3164949183, 'FR', 'FRA', 'فرنسا'),
(41914, 3164949184, 3164949215, 'DE', 'DEU', 'ألمانيا'),
(41915, 3164949216, 3164949231, 'NL', 'NLD', 'هولندا'),
(41916, 3164949232, 3164949247, 'BE', 'BEL', 'بلجيكا'),
(41917, 3164949248, 3164949279, 'FR', 'FRA', 'فرنسا'),
(41918, 3164949280, 3164949295, 'ES', 'ESP', 'إسبانيا'),
(41919, 3164949296, 3164949327, 'FR', 'FRA', 'فرنسا'),
(41920, 3164949328, 3164949343, 'PL', 'POL', 'بولندا'),
(41921, 3164949344, 3164949359, 'FR', 'FRA', 'فرنسا'),
(41922, 3164949360, 3164949363, 'BE', 'BEL', 'بلجيكا'),
(41923, 3164949364, 3164949391, 'FR', 'FRA', 'فرنسا'),
(41924, 3164949392, 3164949395, 'ES', 'ESP', 'إسبانيا'),
(41925, 3164949396, 3164949439, 'FR', 'FRA', 'فرنسا'),
(41926, 3164949440, 3164949471, 'PL', 'POL', 'بولندا'),
(41927, 3164949472, 3164949503, 'FR', 'FRA', 'فرنسا'),
(41928, 3164949504, 3164950015, 'BE', 'BEL', 'بلجيكا'),
(41929, 3164950016, 3164950271, 'GB', 'GBR', 'المملكة المتحدة'),
(41930, 3164950272, 3164950527, 'DE', 'DEU', 'ألمانيا'),
(41931, 3164950528, 3164950543, 'BE', 'BEL', 'بلجيكا'),
(41932, 3164950544, 3164950591, 'NL', 'NLD', 'هولندا'),
(41933, 3164950592, 3164950623, 'FR', 'FRA', 'فرنسا'),
(41934, 3164950624, 3164950655, 'GB', 'GBR', 'المملكة المتحدة'),
(41935, 3164950656, 3164950687, 'FR', 'FRA', 'فرنسا'),
(41936, 3164950688, 3164950703, 'ES', 'ESP', 'إسبانيا'),
(41937, 3164950704, 3164950719, 'FR', 'FRA', 'فرنسا'),
(41938, 3164950720, 3164950735, 'GB', 'GBR', 'المملكة المتحدة'),
(41939, 3164950736, 3164950751, 'ES', 'ESP', 'إسبانيا'),
(41940, 3164950752, 3164950759, 'GB', 'GBR', 'المملكة المتحدة'),
(41941, 3164950760, 3164950783, 'ES', 'ESP', 'إسبانيا'),
(41942, 3164950784, 3164951039, 'FR', 'FRA', 'فرنسا'),
(41943, 3164951040, 3164951231, 'DE', 'DEU', 'ألمانيا'),
(41944, 3164951232, 3164951239, 'GB', 'GBR', 'المملكة المتحدة'),
(41945, 3164951240, 3164951263, 'FR', 'FRA', 'فرنسا'),
(41946, 3164951264, 3164951295, 'DE', 'DEU', 'ألمانيا'),
(41947, 3164951296, 3164951471, 'PL', 'POL', 'بولندا'),
(41948, 3164951472, 3164951487, 'FR', 'FRA', 'فرنسا'),
(41949, 3164951488, 3164951519, 'PL', 'POL', 'بولندا'),
(41950, 3164951520, 3164951535, 'GB', 'GBR', 'المملكة المتحدة'),
(41951, 3164951536, 3164951543, 'BE', 'BEL', 'بلجيكا'),
(41952, 3164951544, 3164951547, 'NL', 'NLD', 'هولندا'),
(41953, 3164951548, 3164951551, 'FR', 'FRA', 'فرنسا'),
(41954, 3164951552, 3164951583, 'IT', 'ITA', 'إيطاليا'),
(41955, 3164951584, 3164951615, 'NL', 'NLD', 'هولندا'),
(41956, 3164951616, 3164951647, 'GB', 'GBR', 'المملكة المتحدة'),
(41957, 3164951648, 3164951679, 'NL', 'NLD', 'هولندا'),
(41958, 3164951680, 3164951711, 'GB', 'GBR', 'المملكة المتحدة'),
(41959, 3164951712, 3164951743, 'FR', 'FRA', 'فرنسا'),
(41960, 3164951744, 3164951775, 'NL', 'NLD', 'هولندا'),
(41961, 3164951776, 3164951807, 'FR', 'FRA', 'فرنسا'),
(41962, 3164951808, 3164951823, 'NL', 'NLD', 'هولندا'),
(41963, 3164951824, 3164951839, 'FR', 'FRA', 'فرنسا'),
(41964, 3164951840, 3164951855, 'PL', 'POL', 'بولندا'),
(41965, 3164951856, 3164951871, 'FR', 'FRA', 'فرنسا'),
(41966, 3164951872, 3164951875, 'CZ', 'CZE', 'التشيك'),
(41967, 3164951876, 3164951879, 'IT', 'ITA', 'إيطاليا'),
(41968, 3164951880, 3164951887, 'DE', 'DEU', 'ألمانيا'),
(41969, 3164951888, 3164951895, 'ES', 'ESP', 'إسبانيا'),
(41970, 3164951896, 3164951903, 'FR', 'FRA', 'فرنسا'),
(41971, 3164951904, 3164951911, 'IE', 'IRL', 'إيرلندا'),
(41972, 3164951912, 3164951919, 'DE', 'DEU', 'ألمانيا'),
(41973, 3164951920, 3164951935, 'FR', 'FRA', 'فرنسا'),
(41974, 3164951936, 3164951999, 'DE', 'DEU', 'ألمانيا'),
(41975, 3164952000, 3164952015, 'ES', 'ESP', 'إسبانيا'),
(41976, 3164952016, 3164952031, 'FR', 'FRA', 'فرنسا'),
(41977, 3164952032, 3164952063, 'PL', 'POL', 'بولندا'),
(41978, 3164952064, 3164952191, 'FR', 'FRA', 'فرنسا'),
(41979, 3164952192, 3164952207, 'ES', 'ESP', 'إسبانيا'),
(41980, 3164952208, 3164952219, 'NL', 'NLD', 'هولندا'),
(41981, 3164952220, 3164952223, 'FR', 'FRA', 'فرنسا'),
(41982, 3164952224, 3164952239, 'NL', 'NLD', 'هولندا'),
(41983, 3164952240, 3164952255, 'FR', 'FRA', 'فرنسا'),
(41984, 3164952256, 3164952319, 'DE', 'DEU', 'ألمانيا'),
(41985, 3164952320, 3164952575, 'ES', 'ESP', 'إسبانيا'),
(41986, 3164952576, 3164952831, 'FR', 'FRA', 'فرنسا'),
(41987, 3164952832, 3164952959, 'IT', 'ITA', 'إيطاليا'),
(41988, 3164952960, 3164952975, 'GB', 'GBR', 'المملكة المتحدة'),
(41989, 3164952976, 3164952991, 'FR', 'FRA', 'فرنسا'),
(41990, 3164952992, 3164953007, 'PL', 'POL', 'بولندا'),
(41991, 3164953008, 3164953023, 'ES', 'ESP', 'إسبانيا'),
(41992, 3164953024, 3164953343, 'FR', 'FRA', 'فرنسا'),
(41993, 3164953344, 3164953375, 'PL', 'POL', 'بولندا'),
(41994, 3164953376, 3164953391, 'FR', 'FRA', 'فرنسا'),
(41995, 3164953392, 3164953395, 'IT', 'ITA', 'إيطاليا'),
(41996, 3164953396, 3164953399, 'NL', 'NLD', 'هولندا'),
(41997, 3164953400, 3164953403, 'BE', 'BEL', 'بلجيكا'),
(41998, 3164953404, 3164953407, 'CH', 'CHE', 'سويسرا'),
(41999, 3164953408, 3164953423, 'BE', 'BEL', 'بلجيكا'),
(42000, 3164953424, 3164953439, 'FR', 'FRA', 'فرنسا'),
(42001, 3164953440, 3164953443, 'CZ', 'CZE', 'التشيك'),
(42002, 3164953444, 3164953447, 'DE', 'DEU', 'ألمانيا'),
(42003, 3164953448, 3164953451, 'ES', 'ESP', 'إسبانيا'),
(42004, 3164953452, 3164953455, 'FR', 'FRA', 'فرنسا'),
(42005, 3164953456, 3164953459, 'IE', 'IRL', 'إيرلندا'),
(42006, 3164953460, 3164953463, 'PT', 'PRT', 'البورتوغال'),
(42007, 3164953464, 3164953467, 'PL', 'POL', 'بولندا'),
(42008, 3164953468, 3164953471, 'GB', 'GBR', 'المملكة المتحدة'),
(42009, 3164953472, 3164953503, 'PL', 'POL', 'بولندا'),
(42010, 3164953504, 3164953511, 'FR', 'FRA', 'فرنسا'),
(42011, 3164953512, 3164953515, 'PL', 'POL', 'بولندا'),
(42012, 3164953516, 3164953519, 'IE', 'IRL', 'إيرلندا'),
(42013, 3164953520, 3164953567, 'PL', 'POL', 'بولندا'),
(42014, 3164953568, 3164953571, 'FR', 'FRA', 'فرنسا'),
(42015, 3164953572, 3164953575, 'GB', 'GBR', 'المملكة المتحدة'),
(42016, 3164953576, 3164953583, 'IT', 'ITA', 'إيطاليا'),
(42017, 3164953584, 3164954111, 'ES', 'ESP', 'إسبانيا'),
(42018, 3164954112, 3164954239, 'DE', 'DEU', 'ألمانيا'),
(42019, 3164954240, 3164954263, 'FR', 'FRA', 'فرنسا'),
(42020, 3164954264, 3164954271, 'DE', 'DEU', 'ألمانيا'),
(42021, 3164954272, 3164954275, 'IT', 'ITA', 'إيطاليا'),
(42022, 3164954276, 3164954279, 'GB', 'GBR', 'المملكة المتحدة'),
(42023, 3164954280, 3164954287, 'FR', 'FRA', 'فرنسا'),
(42024, 3164954288, 3164954303, 'ES', 'ESP', 'إسبانيا'),
(42025, 3164954304, 3164954367, 'DE', 'DEU', 'ألمانيا'),
(42026, 3164954368, 3164954431, 'FR', 'FRA', 'فرنسا'),
(42027, 3164954432, 3164954439, 'ES', 'ESP', 'إسبانيا'),
(42028, 3164954440, 3164954479, 'FR', 'FRA', 'فرنسا'),
(42029, 3164954480, 3164954495, 'GB', 'GBR', 'المملكة المتحدة'),
(42030, 3164954496, 3164954499, 'PL', 'POL', 'بولندا'),
(42031, 3164954500, 3164954503, 'ES', 'ESP', 'إسبانيا'),
(42032, 3164954504, 3164954543, 'GB', 'GBR', 'المملكة المتحدة'),
(42033, 3164954544, 3164954591, 'FR', 'FRA', 'فرنسا'),
(42034, 3164954592, 3164954623, 'PL', 'POL', 'بولندا'),
(42035, 3164954624, 3164958847, 'FR', 'FRA', 'فرنسا'),
(42036, 3164958848, 3164958911, 'IT', 'ITA', 'إيطاليا'),
(42037, 3164958912, 3164958927, 'CH', 'CHE', 'سويسرا'),
(42038, 3164958928, 3164958943, 'ES', 'ESP', 'إسبانيا'),
(42039, 3164958944, 3164958947, 'FR', 'FRA', 'فرنسا'),
(42040, 3164958948, 3164958951, 'GB', 'GBR', 'المملكة المتحدة'),
(42041, 3164958952, 3164958955, 'FR', 'FRA', 'فرنسا'),
(42042, 3164958956, 3164958959, 'GB', 'GBR', 'المملكة المتحدة'),
(42043, 3164958960, 3164959039, 'FR', 'FRA', 'فرنسا'),
(42044, 3164959040, 3164959135, 'DE', 'DEU', 'ألمانيا'),
(42045, 3164959136, 3164959231, 'ES', 'ESP', 'إسبانيا'),
(42046, 3164959232, 3164959247, 'FR', 'FRA', 'فرنسا'),
(42047, 3164959248, 3164959255, 'BE', 'BEL', 'بلجيكا'),
(42048, 3164959256, 3164959259, 'FR', 'FRA', 'فرنسا'),
(42049, 3164959260, 3164959263, 'DE', 'DEU', 'ألمانيا'),
(42050, 3164959264, 3164959295, 'GB', 'GBR', 'المملكة المتحدة'),
(42051, 3164959296, 3164959299, 'CZ', 'CZE', 'التشيك'),
(42052, 3164959300, 3164959303, 'PT', 'PRT', 'البورتوغال'),
(42053, 3164959304, 3164959307, 'FR', 'FRA', 'فرنسا'),
(42054, 3164959308, 3164959311, 'DE', 'DEU', 'ألمانيا'),
(42055, 3164959312, 3164959327, 'ES', 'ESP', 'إسبانيا'),
(42056, 3164959328, 3164959343, 'BE', 'BEL', 'بلجيكا'),
(42057, 3164959344, 3164959359, 'PL', 'POL', 'بولندا'),
(42058, 3164959360, 3164959375, 'ES', 'ESP', 'إسبانيا'),
(42059, 3164959376, 3164959383, 'DE', 'DEU', 'ألمانيا'),
(42060, 3164959384, 3164959387, 'PL', 'POL', 'بولندا'),
(42061, 3164959388, 3164959391, 'FR', 'FRA', 'فرنسا'),
(42062, 3164959392, 3164959487, 'DE', 'DEU', 'ألمانيا'),
(42063, 3164959488, 3164959743, 'ES', 'ESP', 'إسبانيا'),
(42064, 3164959744, 3164960255, 'DE', 'DEU', 'ألمانيا'),
(42065, 3164960256, 3164960511, 'FR', 'FRA', 'فرنسا'),
(42066, 3164960512, 3164960575, 'PL', 'POL', 'بولندا'),
(42067, 3164960576, 3164960767, 'IT', 'ITA', 'إيطاليا'),
(42068, 3164960768, 3164960831, 'PL', 'POL', 'بولندا'),
(42069, 3164960832, 3164960895, 'FR', 'FRA', 'فرنسا'),
(42070, 3164960896, 3164960959, 'PT', 'PRT', 'البورتوغال'),
(42071, 3164960960, 3164961023, 'CH', 'CHE', 'سويسرا'),
(42072, 3164961024, 3164961279, 'FR', 'FRA', 'فرنسا'),
(42073, 3164961280, 3164961311, 'DE', 'DEU', 'ألمانيا'),
(42074, 3164961312, 3164961319, 'FR', 'FRA', 'فرنسا'),
(42075, 3164961320, 3164961327, 'PL', 'POL', 'بولندا'),
(42076, 3164961328, 3164961363, 'FR', 'FRA', 'فرنسا'),
(42077, 3164961364, 3164961367, 'ES', 'ESP', 'إسبانيا'),
(42078, 3164961368, 3164961375, 'FR', 'FRA', 'فرنسا'),
(42079, 3164961376, 3164961391, 'DE', 'DEU', 'ألمانيا'),
(42080, 3164961392, 3164961399, 'ES', 'ESP', 'إسبانيا'),
(42081, 3164961400, 3164961403, 'PL', 'POL', 'بولندا'),
(42082, 3164961404, 3164961471, 'FR', 'FRA', 'فرنسا'),
(42083, 3164961472, 3164961503, 'DE', 'DEU', 'ألمانيا'),
(42084, 3164961504, 3164961551, 'ES', 'ESP', 'إسبانيا'),
(42085, 3164961552, 3164961559, 'FR', 'FRA', 'فرنسا'),
(42086, 3164961560, 3164961563, 'DE', 'DEU', 'ألمانيا'),
(42087, 3164961564, 3164961583, 'FR', 'FRA', 'فرنسا'),
(42088, 3164961584, 3164961599, 'DE', 'DEU', 'ألمانيا'),
(42089, 3164961600, 3164961631, 'BE', 'BEL', 'بلجيكا'),
(42090, 3164961632, 3164961647, 'IT', 'ITA', 'إيطاليا'),
(42091, 3164961648, 3164961655, 'NL', 'NLD', 'هولندا'),
(42092, 3164961656, 3164961663, 'ES', 'ESP', 'إسبانيا'),
(42093, 3164961664, 3164961695, 'DE', 'DEU', 'ألمانيا'),
(42094, 3164961696, 3164961727, 'GB', 'GBR', 'المملكة المتحدة'),
(42095, 3164961728, 3164961743, 'FR', 'FRA', 'فرنسا'),
(42096, 3164961744, 3164961759, 'PL', 'POL', 'بولندا'),
(42097, 3164961760, 3164961855, 'FR', 'FRA', 'فرنسا'),
(42098, 3164961856, 3164961871, 'PL', 'POL', 'بولندا'),
(42099, 3164961872, 3164961887, 'IE', 'IRL', 'إيرلندا'),
(42100, 3164961888, 3164961903, 'ES', 'ESP', 'إسبانيا'),
(42101, 3164961904, 3164961919, 'GB', 'GBR', 'المملكة المتحدة'),
(42102, 3164961920, 3164961951, 'IT', 'ITA', 'إيطاليا'),
(42103, 3164961952, 3164961967, 'ES', 'ESP', 'إسبانيا'),
(42104, 3164961968, 3164961971, 'FR', 'FRA', 'فرنسا'),
(42105, 3164961972, 3164961975, 'PL', 'POL', 'بولندا'),
(42106, 3164961976, 3164961979, 'GB', 'GBR', 'المملكة المتحدة'),
(42107, 3164961980, 3164961999, 'DE', 'DEU', 'ألمانيا'),
(42108, 3164962000, 3164962015, 'FR', 'FRA', 'فرنسا'),
(42109, 3164962016, 3164962047, 'NL', 'NLD', 'هولندا'),
(42110, 3164962048, 3164962303, 'GB', 'GBR', 'المملكة المتحدة'),
(42111, 3164962304, 3164962335, 'NL', 'NLD', 'هولندا'),
(42112, 3164962336, 3164962367, 'DE', 'DEU', 'ألمانيا'),
(42113, 3164962368, 3164962431, 'FR', 'FRA', 'فرنسا'),
(42114, 3164962432, 3164962495, 'ES', 'ESP', 'إسبانيا'),
(42115, 3164962496, 3164962527, 'FR', 'FRA', 'فرنسا'),
(42116, 3164962528, 3164962535, 'PL', 'POL', 'بولندا'),
(42117, 3164962536, 3164962539, 'CH', 'CHE', 'سويسرا'),
(42118, 3164962540, 3164962543, 'CZ', 'CZE', 'التشيك'),
(42119, 3164962544, 3164962623, 'FR', 'FRA', 'فرنسا'),
(42120, 3164962624, 3164962627, 'BE', 'BEL', 'بلجيكا'),
(42121, 3164962628, 3164962631, 'CH', 'CHE', 'سويسرا'),
(42122, 3164962632, 3164962655, 'FR', 'FRA', 'فرنسا'),
(42123, 3164962656, 3164962687, 'ES', 'ESP', 'إسبانيا'),
(42124, 3164962688, 3164962751, 'GB', 'GBR', 'المملكة المتحدة'),
(42125, 3164962752, 3164964863, 'ES', 'ESP', 'إسبانيا'),
(42126, 3164964864, 3164966911, 'FI', 'FIN', 'فنلندا'),
(42127, 3164966912, 3164967039, 'FR', 'FRA', 'فرنسا'),
(42128, 3164967040, 3164967071, 'PL', 'POL', 'بولندا'),
(42129, 3164967072, 3164967087, 'FR', 'FRA', 'فرنسا'),
(42130, 3164967088, 3164967095, 'IT', 'ITA', 'إيطاليا'),
(42131, 3164967096, 3164967103, 'PL', 'POL', 'بولندا'),
(42132, 3164967104, 3164967135, 'ES', 'ESP', 'إسبانيا'),
(42133, 3164967136, 3164967155, 'FR', 'FRA', 'فرنسا'),
(42134, 3164967156, 3164967159, 'PL', 'POL', 'بولندا'),
(42135, 3164967160, 3164967167, 'FR', 'FRA', 'فرنسا'),
(42136, 3164967168, 3164967295, 'ES', 'ESP', 'إسبانيا'),
(42137, 3164967296, 3164967303, 'NL', 'NLD', 'هولندا'),
(42138, 3164967304, 3164967307, 'IT', 'ITA', 'إيطاليا'),
(42139, 3164967308, 3164967311, 'DE', 'DEU', 'ألمانيا'),
(42140, 3164967312, 3164967343, 'IT', 'ITA', 'إيطاليا'),
(42141, 3164967344, 3164967351, 'ES', 'ESP', 'إسبانيا'),
(42142, 3164967352, 3164967359, 'PL', 'POL', 'بولندا'),
(42143, 3164967360, 3164967423, 'FR', 'FRA', 'فرنسا'),
(42144, 3164967424, 3164967679, 'ES', 'ESP', 'إسبانيا'),
(42145, 3164967680, 3164967935, 'FR', 'FRA', 'فرنسا'),
(42146, 3164967936, 3164967967, 'DE', 'DEU', 'ألمانيا'),
(42147, 3164967968, 3164967971, 'FR', 'FRA', 'فرنسا'),
(42148, 3164967972, 3164967975, 'DE', 'DEU', 'ألمانيا'),
(42149, 3164967976, 3164967999, 'FR', 'FRA', 'فرنسا'),
(42150, 3164968000, 3164968063, 'ES', 'ESP', 'إسبانيا'),
(42151, 3164968064, 3164968191, 'FR', 'FRA', 'فرنسا'),
(42152, 3164968192, 3164968703, 'PL', 'POL', 'بولندا'),
(42153, 3164968704, 3164968831, 'FR', 'FRA', 'فرنسا'),
(42154, 3164968832, 3164968863, 'DE', 'DEU', 'ألمانيا'),
(42155, 3164968864, 3164968895, 'FR', 'FRA', 'فرنسا'),
(42156, 3164968896, 3164968927, 'GB', 'GBR', 'المملكة المتحدة'),
(42157, 3164968928, 3164968959, 'IT', 'ITA', 'إيطاليا'),
(42158, 3164968960, 3164968991, 'DE', 'DEU', 'ألمانيا'),
(42159, 3164968992, 3164969007, 'FR', 'FRA', 'فرنسا'),
(42160, 3164969008, 3164969015, 'PT', 'PRT', 'البورتوغال'),
(42161, 3164969016, 3164969023, 'FR', 'FRA', 'فرنسا'),
(42162, 3164969024, 3164969055, 'PL', 'POL', 'بولندا'),
(42163, 3164969056, 3164969071, 'CZ', 'CZE', 'التشيك'),
(42164, 3164969072, 3164969087, 'FR', 'FRA', 'فرنسا'),
(42165, 3164969088, 3164969095, 'ES', 'ESP', 'إسبانيا'),
(42166, 3164969096, 3164969099, 'PL', 'POL', 'بولندا'),
(42167, 3164969100, 3164969103, 'DE', 'DEU', 'ألمانيا'),
(42168, 3164969104, 3164969135, 'FR', 'FRA', 'فرنسا'),
(42169, 3164969136, 3164969143, 'ES', 'ESP', 'إسبانيا'),
(42170, 3164969144, 3164969147, 'PT', 'PRT', 'البورتوغال'),
(42171, 3164969148, 3164969151, 'PL', 'POL', 'بولندا'),
(42172, 3164969152, 3164969183, 'GB', 'GBR', 'المملكة المتحدة'),
(42173, 3164969184, 3164969199, 'DE', 'DEU', 'ألمانيا'),
(42174, 3164969200, 3164969207, 'GB', 'GBR', 'المملكة المتحدة'),
(42175, 3164969208, 3164969211, 'IT', 'ITA', 'إيطاليا'),
(42176, 3164969212, 3164969471, 'FR', 'FRA', 'فرنسا'),
(42177, 3164969472, 3164969727, 'PL', 'POL', 'بولندا'),
(42178, 3164969728, 3164969983, 'GB', 'GBR', 'المملكة المتحدة'),
(42179, 3164969984, 3164970047, 'IE', 'IRL', 'إيرلندا'),
(42180, 3164970048, 3164970079, 'GB', 'GBR', 'المملكة المتحدة'),
(42181, 3164970080, 3164970111, 'DE', 'DEU', 'ألمانيا'),
(42182, 3164970112, 3164970211, 'FR', 'FRA', 'فرنسا'),
(42183, 3164970212, 3164970215, 'GB', 'GBR', 'المملكة المتحدة'),
(42184, 3164970216, 3164970219, 'PL', 'POL', 'بولندا'),
(42185, 3164970220, 3164970223, 'FR', 'FRA', 'فرنسا'),
(42186, 3164970224, 3164970239, 'GB', 'GBR', 'المملكة المتحدة'),
(42187, 3164970240, 3164970495, 'IE', 'IRL', 'إيرلندا'),
(42188, 3164970496, 3164970623, 'FR', 'FRA', 'فرنسا'),
(42189, 3164970624, 3164970751, 'IE', 'IRL', 'إيرلندا'),
(42190, 3164970752, 3164970783, 'FR', 'FRA', 'فرنسا'),
(42191, 3164970784, 3164970791, 'PL', 'POL', 'بولندا'),
(42192, 3164970792, 3164970831, 'FR', 'FRA', 'فرنسا'),
(42193, 3164970832, 3164970835, 'IT', 'ITA', 'إيطاليا'),
(42194, 3164970836, 3164970839, 'PL', 'POL', 'بولندا'),
(42195, 3164970840, 3164970847, 'GB', 'GBR', 'المملكة المتحدة'),
(42196, 3164970848, 3164970991, 'FR', 'FRA', 'فرنسا'),
(42197, 3164970992, 3164971007, 'BE', 'BEL', 'بلجيكا'),
(42198, 3164971008, 3164971011, 'ES', 'ESP', 'إسبانيا'),
(42199, 3164971012, 3164971015, 'FR', 'FRA', 'فرنسا'),
(42200, 3164971016, 3164971023, 'PL', 'POL', 'بولندا'),
(42201, 3164971024, 3164971055, 'FR', 'FRA', 'فرنسا'),
(42202, 3164971056, 3164971071, 'NL', 'NLD', 'هولندا'),
(42203, 3164971072, 3164971135, 'DE', 'DEU', 'ألمانيا'),
(42204, 3164971136, 3164971263, 'GB', 'GBR', 'المملكة المتحدة'),
(42205, 3164971264, 3164971455, 'DE', 'DEU', 'ألمانيا'),
(42206, 3164971456, 3164971459, 'NL', 'NLD', 'هولندا'),
(42207, 3164971460, 3164971463, 'IT', 'ITA', 'إيطاليا'),
(42208, 3164971464, 3164971467, 'CH', 'CHE', 'سويسرا'),
(42209, 3164971468, 3164971471, 'FR', 'FRA', 'فرنسا'),
(42210, 3164971472, 3164971479, 'NL', 'NLD', 'هولندا'),
(42211, 3164971480, 3164971483, 'FR', 'FRA', 'فرنسا'),
(42212, 3164971484, 3164971487, 'PL', 'POL', 'بولندا'),
(42213, 3164971488, 3164971503, 'ES', 'ESP', 'إسبانيا'),
(42214, 3164971504, 3164971511, 'PL', 'POL', 'بولندا'),
(42215, 3164971512, 3164971519, 'CZ', 'CZE', 'التشيك'),
(42216, 3164971520, 3164971775, 'ES', 'ESP', 'إسبانيا'),
(42217, 3164971776, 3164971795, 'FR', 'FRA', 'فرنسا'),
(42218, 3164971796, 3164971799, 'IT', 'ITA', 'إيطاليا'),
(42219, 3164971800, 3164971803, 'DE', 'DEU', 'ألمانيا'),
(42220, 3164971804, 3164971807, 'FR', 'FRA', 'فرنسا'),
(42221, 3164971808, 3164971903, 'BE', 'BEL', 'بلجيكا'),
(42222, 3164971904, 3164971967, 'DE', 'DEU', 'ألمانيا'),
(42223, 3164971968, 3164971983, 'FR', 'FRA', 'فرنسا'),
(42224, 3164971984, 3164971999, 'ES', 'ESP', 'إسبانيا'),
(42225, 3164972000, 3164972015, 'CH', 'CHE', 'سويسرا'),
(42226, 3164972016, 3164972019, 'ES', 'ESP', 'إسبانيا'),
(42227, 3164972020, 3164972027, 'FR', 'FRA', 'فرنسا'),
(42228, 3164972028, 3164972031, 'ES', 'ESP', 'إسبانيا'),
(42229, 3164972032, 3164972287, 'GB', 'GBR', 'المملكة المتحدة'),
(42230, 3164972288, 3164972319, 'FR', 'FRA', 'فرنسا'),
(42231, 3164972320, 3164972351, 'DE', 'DEU', 'ألمانيا'),
(42232, 3164972352, 3164972415, 'NL', 'NLD', 'هولندا'),
(42233, 3164972416, 3164972479, 'BE', 'BEL', 'بلجيكا'),
(42234, 3164972480, 3164972499, 'FR', 'FRA', 'فرنسا'),
(42235, 3164972500, 3164972503, 'IT', 'ITA', 'إيطاليا'),
(42236, 3164972504, 3164972511, 'DE', 'DEU', 'ألمانيا'),
(42237, 3164972512, 3164972527, 'GB', 'GBR', 'المملكة المتحدة'),
(42238, 3164972528, 3164972799, 'FR', 'FRA', 'فرنسا'),
(42239, 3164972800, 3164973311, 'ES', 'ESP', 'إسبانيا'),
(42240, 3164973312, 3164973823, 'FR', 'FRA', 'فرنسا'),
(42241, 3164973824, 3164973855, 'DE', 'DEU', 'ألمانيا'),
(42242, 3164973856, 3164973863, 'PL', 'POL', 'بولندا'),
(42243, 3164973864, 3164973867, 'FR', 'FRA', 'فرنسا'),
(42244, 3164973868, 3164973875, 'ES', 'ESP', 'إسبانيا'),
(42245, 3164973876, 3164973879, 'GB', 'GBR', 'المملكة المتحدة'),
(42246, 3164973880, 3164973883, 'FR', 'FRA', 'فرنسا'),
(42247, 3164973884, 3164973887, 'DE', 'DEU', 'ألمانيا'),
(42248, 3164973888, 3164973919, 'ES', 'ESP', 'إسبانيا'),
(42249, 3164973920, 3164973935, 'FR', 'FRA', 'فرنسا'),
(42250, 3164973936, 3164973939, 'IT', 'ITA', 'إيطاليا'),
(42251, 3164973940, 3164974591, 'FR', 'FRA', 'فرنسا'),
(42252, 3164974592, 3164975103, 'GB', 'GBR', 'المملكة المتحدة'),
(42253, 3164975104, 3164975167, 'CH', 'CHE', 'سويسرا'),
(42254, 3164975168, 3164975231, 'GB', 'GBR', 'المملكة المتحدة'),
(42255, 3164975232, 3164975299, 'IT', 'ITA', 'إيطاليا'),
(42256, 3164975300, 3164975307, 'ES', 'ESP', 'إسبانيا'),
(42257, 3164975308, 3164975311, 'GB', 'GBR', 'المملكة المتحدة'),
(42258, 3164975312, 3164975343, 'ES', 'ESP', 'إسبانيا'),
(42259, 3164975344, 3164975359, 'NL', 'NLD', 'هولندا'),
(42260, 3164975360, 3164975615, 'ES', 'ESP', 'إسبانيا'),
(42261, 3164975616, 3164976127, 'GB', 'GBR', 'المملكة المتحدة'),
(42262, 3164976128, 3164976639, 'IT', 'ITA', 'إيطاليا'),
(42263, 3164976640, 3164976767, 'FR', 'FRA', 'فرنسا'),
(42264, 3164976768, 3164976783, 'DE', 'DEU', 'ألمانيا'),
(42265, 3164976784, 3164976799, 'ES', 'ESP', 'إسبانيا'),
(42266, 3164976800, 3164976815, 'DE', 'DEU', 'ألمانيا'),
(42267, 3164976816, 3164976831, 'GB', 'GBR', 'المملكة المتحدة'),
(42268, 3164976832, 3164976835, 'IT', 'ITA', 'إيطاليا'),
(42269, 3164976836, 3164976839, 'ES', 'ESP', 'إسبانيا'),
(42270, 3164976840, 3164976847, 'FR', 'FRA', 'فرنسا'),
(42271, 3164976848, 3164976863, 'CH', 'CHE', 'سويسرا'),
(42272, 3164976864, 3164976895, 'CZ', 'CZE', 'التشيك'),
(42273, 3164976896, 3164977151, 'FR', 'FRA', 'فرنسا'),
(42274, 3164977152, 3164977215, 'PL', 'POL', 'بولندا'),
(42275, 3164977216, 3164977247, 'DE', 'DEU', 'ألمانيا'),
(42276, 3164977248, 3164977279, 'ES', 'ESP', 'إسبانيا'),
(42277, 3164977280, 3164977407, 'FR', 'FRA', 'فرنسا'),
(42278, 3164977408, 3164977663, 'PL', 'POL', 'بولندا'),
(42279, 3164977664, 3164977695, 'GB', 'GBR', 'المملكة المتحدة'),
(42280, 3164977696, 3164977727, 'IT', 'ITA', 'إيطاليا'),
(42281, 3164977728, 3164977743, 'LT', 'LTU', 'ليتوانيا'),
(42282, 3164977744, 3164977759, 'PT', 'PRT', 'البورتوغال'),
(42283, 3164977760, 3164977775, 'NL', 'NLD', 'هولندا'),
(42284, 3164977776, 3164977791, 'PL', 'POL', 'بولندا'),
(42285, 3164977792, 3164977807, 'FR', 'FRA', 'فرنسا'),
(42286, 3164977808, 3164977823, 'NL', 'NLD', 'هولندا'),
(42287, 3164977824, 3164977839, 'GB', 'GBR', 'المملكة المتحدة'),
(42288, 3164977840, 3164977883, 'FR', 'FRA', 'فرنسا'),
(42289, 3164977884, 3164977887, 'GB', 'GBR', 'المملكة المتحدة'),
(42290, 3164977888, 3164977903, 'IT', 'ITA', 'إيطاليا'),
(42291, 3164977904, 3164977919, 'NL', 'NLD', 'هولندا'),
(42292, 3164977920, 3164978047, 'DE', 'DEU', 'ألمانيا'),
(42293, 3164978048, 3164978067, 'FR', 'FRA', 'فرنسا'),
(42294, 3164978068, 3164978079, 'ES', 'ESP', 'إسبانيا'),
(42295, 3164978080, 3164978111, 'IT', 'ITA', 'إيطاليا'),
(42296, 3164978112, 3164978143, 'FR', 'FRA', 'فرنسا'),
(42297, 3164978144, 3164978147, 'DE', 'DEU', 'ألمانيا'),
(42298, 3164978148, 3164978151, 'ES', 'ESP', 'إسبانيا'),
(42299, 3164978152, 3164978155, 'GB', 'GBR', 'المملكة المتحدة'),
(42300, 3164978156, 3164978159, 'DE', 'DEU', 'ألمانيا'),
(42301, 3164978160, 3164978175, 'FR', 'FRA', 'فرنسا'),
(42302, 3164978176, 3164978431, 'IT', 'ITA', 'إيطاليا'),
(42303, 3164978432, 3164978447, 'FR', 'FRA', 'فرنسا'),
(42304, 3164978448, 3164978463, 'PT', 'PRT', 'البورتوغال'),
(42305, 3164978464, 3164978495, 'DE', 'DEU', 'ألمانيا'),
(42306, 3164978496, 3164978511, 'IT', 'ITA', 'إيطاليا'),
(42307, 3164978512, 3164978527, 'ES', 'ESP', 'إسبانيا'),
(42308, 3164978528, 3164978543, 'FR', 'FRA', 'فرنسا'),
(42309, 3164978544, 3164978559, 'PT', 'PRT', 'البورتوغال'),
(42310, 3164978560, 3164978575, 'GB', 'GBR', 'المملكة المتحدة'),
(42311, 3164978576, 3164978591, 'ES', 'ESP', 'إسبانيا'),
(42312, 3164978592, 3164978607, 'FR', 'FRA', 'فرنسا'),
(42313, 3164978608, 3164978623, 'CZ', 'CZE', 'التشيك'),
(42314, 3164978624, 3164978687, 'FR', 'FRA', 'فرنسا'),
(42315, 3164978688, 3164978943, 'PL', 'POL', 'بولندا'),
(42316, 3164978944, 3164978951, 'PT', 'PRT', 'البورتوغال'),
(42317, 3164978952, 3164978955, 'PL', 'POL', 'بولندا'),
(42318, 3164978956, 3164978959, 'GB', 'GBR', 'المملكة المتحدة'),
(42319, 3164978960, 3164978975, 'FR', 'FRA', 'فرنسا'),
(42320, 3164978976, 3164978991, 'ES', 'ESP', 'إسبانيا'),
(42321, 3164978992, 3164979007, 'FR', 'FRA', 'فرنسا'),
(42322, 3164979008, 3164979023, 'ES', 'ESP', 'إسبانيا'),
(42323, 3164979024, 3164979039, 'CH', 'CHE', 'سويسرا'),
(42324, 3164979040, 3164979071, 'PT', 'PRT', 'البورتوغال'),
(42325, 3164979072, 3164979103, 'ES', 'ESP', 'إسبانيا'),
(42326, 3164979104, 3164979111, 'DE', 'DEU', 'ألمانيا'),
(42327, 3164979112, 3164979119, 'PL', 'POL', 'بولندا'),
(42328, 3164979120, 3164979135, 'NL', 'NLD', 'هولندا'),
(42329, 3164979136, 3164979151, 'DE', 'DEU', 'ألمانيا'),
(42330, 3164979152, 3164979167, 'FR', 'FRA', 'فرنسا'),
(42331, 3164979168, 3164979175, 'DE', 'DEU', 'ألمانيا'),
(42332, 3164979176, 3164979183, 'FR', 'FRA', 'فرنسا'),
(42333, 3164979184, 3164979199, 'DE', 'DEU', 'ألمانيا'),
(42334, 3164979200, 3164995583, 'FR', 'FRA', 'فرنسا'),
(42335, 3164995584, 3165061119, 'RU', 'RUS', 'الإتحاد الروسي'),
(42336, 3165061120, 3165126655, 'SK', 'SVK', 'سلوفاكيا'),
(42337, 3165126656, 3165192191, 'RU', 'RUS', 'الإتحاد الروسي'),
(42338, 3165192192, 3165257727, 'GE', 'GEO', 'جورجيا'),
(42339, 3165257728, 3165323263, 'RO', 'ROM', 'رومانيا'),
(42340, 3165323264, 3165388799, 'ES', 'ESP', 'إسبانيا'),
(42341, 3165388800, 3165519871, 'RO', 'ROM', 'رومانيا'),
(42342, 3165519872, 3165585407, 'DE', 'DEU', 'ألمانيا'),
(42343, 3165585408, 3165650943, 'CZ', 'CZE', 'التشيك'),
(42344, 3165650944, 3166175231, 'DK', 'DNK', 'الدنيمارك'),
(42345, 3166175232, 3166306303, 'CH', 'CHE', 'سويسرا'),
(42346, 3166306304, 3166437375, 'RU', 'RUS', 'الإتحاد الروسي'),
(42347, 3166437376, 3166568447, 'BE', 'BEL', 'بلجيكا'),
(42348, 3166699520, 3166961663, 'DE', 'DEU', 'ألمانيا'),
(42349, 3167223808, 3167748095, 'NL', 'NLD', 'هولندا'),
(42350, 3167748096, 3167940095, 'RO', 'ROM', 'رومانيا'),
(42351, 3167940096, 3167940351, 'CY', 'CYP', 'قبرص'),
(42352, 3167940352, 3167952895, 'RO', 'ROM', 'رومانيا'),
(42353, 3167952896, 3168002047, 'GB', 'GBR', 'المملكة المتحدة'),
(42354, 3168002048, 3168092159, 'RO', 'ROM', 'رومانيا'),
(42355, 3168092160, 3168096255, 'GB', 'GBR', 'المملكة المتحدة'),
(42356, 3168096256, 3168104447, 'RO', 'ROM', 'رومانيا'),
(42357, 3168104448, 3168108543, 'GB', 'GBR', 'المملكة المتحدة'),
(42358, 3168108544, 3168112639, 'RO', 'ROM', 'رومانيا'),
(42359, 3168112640, 3168116735, 'GB', 'GBR', 'المملكة المتحدة'),
(42360, 3168116736, 3168120831, 'RO', 'ROM', 'رومانيا'),
(42361, 3168120832, 3168124927, 'GB', 'GBR', 'المملكة المتحدة'),
(42362, 3168124928, 3168129023, 'RO', 'ROM', 'رومانيا'),
(42363, 3168129024, 3168141311, 'GB', 'GBR', 'المملكة المتحدة'),
(42364, 3168141312, 3168153599, 'RO', 'ROM', 'رومانيا'),
(42365, 3168153600, 3168194559, 'GB', 'GBR', 'المملكة المتحدة'),
(42366, 3168194560, 3168272383, 'RO', 'ROM', 'رومانيا'),
(42367, 3168272384, 3168534527, 'IT', 'ITA', 'إيطاليا'),
(42368, 3168534528, 3168796671, 'GB', 'GBR', 'المملكة المتحدة'),
(42369, 3168796672, 3168829439, 'FR', 'FRA', 'فرنسا'),
(42370, 3168829440, 3168862207, 'RO', 'ROM', 'رومانيا'),
(42371, 3168862208, 3168894975, 'RU', 'RUS', 'الإتحاد الروسي'),
(42372, 3168894976, 3168927743, 'PS', 'PSE', 'فلسطين المحتلة'),
(42373, 3168927744, 3169058815, 'RU', 'RUS', 'الإتحاد الروسي'),
(42374, 3169058816, 3169091583, 'DK', 'DNK', 'الدنيمارك'),
(42375, 3169091584, 3169124351, 'IT', 'ITA', 'إيطاليا'),
(42376, 3169124352, 3169157119, 'RO', 'ROM', 'رومانيا'),
(42377, 3169189888, 3169222655, 'UA', 'UKR', 'أوكرانيا'),
(42378, 3169222656, 3169255423, 'SI', 'SVN', 'سلوفينيا'),
(42379, 3169255424, 3169264895, 'KW', 'KWT', 'الكويت'),
(42380, 3169264896, 3169264927, 'OM', 'OMN', 'عمان'),
(42381, 3169264928, 3169265167, 'KW', 'KWT', 'الكويت'),
(42382, 3169265168, 3169265175, 'IQ', 'IRQ', 'العراق'),
(42383, 3169265176, 3169265183, 'SA', 'SAU', 'السعودية'),
(42384, 3169265184, 3169265223, 'KW', 'KWT', 'الكويت'),
(42385, 3169265224, 3169265231, 'IQ', 'IRQ', 'العراق'),
(42386, 3169265232, 3169265295, 'SA', 'SAU', 'السعودية'),
(42387, 3169265296, 3169265303, 'SD', 'SDN', 'السودان'),
(42388, 3169265304, 3169265311, 'SA', 'SAU', 'السعودية'),
(42389, 3169265312, 3169265567, 'KW', 'KWT', 'الكويت'),
(42390, 3169265568, 3169265583, 'IQ', 'IRQ', 'العراق'),
(42391, 3169265584, 3169271807, 'KW', 'KWT', 'الكويت'),
(42392, 3169271808, 3169275903, 'SY', 'SYR', 'سوريا'),
(42393, 3169275904, 3169278991, 'KW', 'KWT', 'الكويت'),
(42394, 3169278992, 3169279007, 'SA', 'SAU', 'السعودية'),
(42395, 3169279008, 3169279231, 'KW', 'KWT', 'الكويت'),
(42396, 3169279232, 3169279239, 'IQ', 'IRQ', 'العراق'),
(42397, 3169279240, 3169279255, 'SA', 'SAU', 'السعودية'),
(42398, 3169279256, 3169279263, 'KW', 'KWT', 'الكويت'),
(42399, 3169279264, 3169279295, 'SA', 'SAU', 'السعودية'),
(42400, 3169279296, 3169279303, 'KW', 'KWT', 'الكويت'),
(42401, 3169279304, 3169279311, 'SA', 'SAU', 'السعودية'),
(42402, 3169279312, 3169279319, 'SD', 'SDN', 'السودان'),
(42403, 3169279320, 3169279743, 'KW', 'KWT', 'الكويت'),
(42404, 3169279744, 3169279759, 'IQ', 'IRQ', 'العراق'),
(42405, 3169279760, 3169281023, 'KW', 'KWT', 'الكويت'),
(42406, 3169281024, 3169281279, 'US', 'USA', 'الولايات المتحدة'),
(42407, 3169281280, 3169288191, 'KW', 'KWT', 'الكويت'),
(42408, 3169288192, 3169320959, 'UA', 'UKR', 'أوكرانيا'),
(42409, 3169845248, 3169965823, 'RO', 'ROM', 'رومانيا'),
(42410, 3169965824, 3169966079, 'GB', 'GBR', 'المملكة المتحدة'),
(42411, 3169966080, 3169967871, 'RO', 'ROM', 'رومانيا'),
(42412, 3169967872, 3169968127, 'CY', 'CYP', 'قبرص'),
(42413, 3169968128, 3169976319, 'RO', 'ROM', 'رومانيا'),
(42414, 3169976320, 3170111487, 'RU', 'RUS', 'الإتحاد الروسي'),
(42415, 3170111488, 3170115583, 'MD', 'MDA', 'مولدوفا'),
(42416, 3170115584, 3170119679, 'RU', 'RUS', 'الإتحاد الروسي'),
(42417, 3170119680, 3170123775, 'CZ', 'CZE', 'التشيك'),
(42418, 3170123776, 3170127871, 'DK', 'DNK', 'الدنيمارك'),
(42419, 3170127872, 3170131967, 'ES', 'ESP', 'إسبانيا'),
(42420, 3170131968, 3170136063, 'JO', 'JOR', 'الأردن'),
(42421, 3170238464, 3170246655, 'DE', 'DEU', 'ألمانيا'),
(42422, 3170246656, 3170254847, 'RS', 'SRB', 'صربيا'),
(42423, 3170254848, 3170263039, 'BA', 'BIH', 'البوسنه والهرسك'),
(42424, 3170263040, 3170271231, 'CZ', 'CZE', 'التشيك'),
(42425, 3170271232, 3170279423, 'PL', 'POL', 'بولندا'),
(42426, 3170279424, 3170287615, 'RU', 'RUS', 'الإتحاد الروسي'),
(42427, 3170295808, 3170303999, 'RU', 'RUS', 'الإتحاد الروسي'),
(42428, 3170304000, 3170312191, 'SY', 'SYR', 'سوريا'),
(42429, 3170312192, 3170320383, 'RU', 'RUS', 'الإتحاد الروسي'),
(42430, 3170320384, 3170328575, 'JO', 'JOR', 'الأردن'),
(42431, 3170369536, 3170500607, 'SA', 'SAU', 'السعودية'),
(42432, 3170893824, 3179282431, 'BR', 'BRA', 'البرازيل'),
(42433, 3179282432, 3184269567, 'MX', 'MEX', 'المكسيك'),
(42434, 3184269568, 3184269575, 'US', 'USA', 'الولايات المتحدة'),
(42435, 3184269576, 3187671039, 'MX', 'MEX', 'المكسيك'),
(42436, 3187671040, 3187687423, 'CO', 'COL', 'كولومبيا'),
(42437, 3187687424, 3187695615, 'DO', 'DOM', 'الدومينيكان'),
(42438, 3187695616, 3187703807, 'AR', 'ARG', 'الأرجنتين'),
(42439, 3187703808, 3187711999, 'UY', 'URY', 'الأوروغواي'),
(42440, 3187712000, 3187720191, 'AR', 'ARG', 'الأرجنتين'),
(42441, 3187720192, 3187728383, 'GT', 'GTM', 'غواتيمالا'),
(42442, 3187736576, 3187752959, 'AR', 'ARG', 'الأرجنتين'),
(42443, 3187752960, 3187761151, 'CO', 'COL', 'كولومبيا'),
(42444, 3187769344, 3187802111, 'CO', 'COL', 'كولومبيا'),
(42445, 3187802112, 3187818495, 'AR', 'ARG', 'الأرجنتين'),
(42446, 3187818496, 3187820543, 'PY', 'PRY', 'باراغواي'),
(42447, 3187822592, 3187824639, 'AR', 'ARG', 'الأرجنتين'),
(42448, 3187824640, 3187826687, 'CL', 'CHL', 'تشيلي'),
(42449, 3187826688, 3187834879, 'AR', 'ARG', 'الأرجنتين'),
(42450, 3187834880, 3187851263, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(42451, 3187851264, 3187855359, 'PY', 'PRY', 'باراغواي'),
(42452, 3187859456, 3187863551, 'PA', 'PAN', 'بنما'),
(42453, 3187867648, 3187908607, 'AR', 'ARG', 'الأرجنتين'),
(42454, 3187908608, 3187910655, 'CO', 'COL', 'كولومبيا'),
(42455, 3187910656, 3187914751, 'CL', 'CHL', 'تشيلي'),
(42456, 3187914752, 3187916799, 'BO', 'BOL', 'بوليفيا'),
(42457, 3187916800, 3187933183, 'CO', 'COL', 'كولومبيا'),
(42458, 3187933184, 3187933311, 'HN', 'HND', 'هندوراس'),
(42459, 3187933312, 3187934783, 'GT', 'GTM', 'غواتيمالا'),
(42460, 3187934784, 3187934815, 'HN', 'HND', 'هندوراس'),
(42461, 3187934816, 3187934823, 'GT', 'GTM', 'غواتيمالا'),
(42462, 3187934824, 3187934847, 'HN', 'HND', 'هندوراس'),
(42463, 3187934848, 3187934991, 'GT', 'GTM', 'غواتيمالا'),
(42464, 3187934992, 3187935023, 'HN', 'HND', 'هندوراس'),
(42465, 3187935024, 3187935027, 'GT', 'GTM', 'غواتيمالا'),
(42466, 3187935028, 3187935039, 'HN', 'HND', 'هندوراس'),
(42467, 3187935040, 3187935047, 'GT', 'GTM', 'غواتيمالا'),
(42468, 3187935048, 3187935079, 'HN', 'HND', 'هندوراس'),
(42469, 3187935080, 3187935087, 'GT', 'GTM', 'غواتيمالا'),
(42470, 3187935088, 3187935111, 'HN', 'HND', 'هندوراس'),
(42471, 3187935112, 3187935151, 'GT', 'GTM', 'غواتيمالا'),
(42472, 3187935152, 3187935159, 'HN', 'HND', 'هندوراس'),
(42473, 3187935160, 3187935167, 'GT', 'GTM', 'غواتيمالا'),
(42474, 3187935168, 3187935239, 'HN', 'HND', 'هندوراس'),
(42475, 3187935240, 3187935247, 'GT', 'GTM', 'غواتيمالا'),
(42476, 3187935248, 3187935287, 'HN', 'HND', 'هندوراس'),
(42477, 3187935288, 3187935291, 'GT', 'GTM', 'غواتيمالا'),
(42478, 3187935292, 3187935339, 'HN', 'HND', 'هندوراس'),
(42479, 3187935340, 3187935351, 'GT', 'GTM', 'غواتيمالا'),
(42480, 3187935352, 3187935391, 'HN', 'HND', 'هندوراس'),
(42481, 3187935392, 3187935395, 'GT', 'GTM', 'غواتيمالا'),
(42482, 3187935396, 3187935415, 'HN', 'HND', 'هندوراس'),
(42483, 3187935416, 3187935423, 'GT', 'GTM', 'غواتيمالا'),
(42484, 3187935424, 3187935431, 'HN', 'HND', 'هندوراس'),
(42485, 3187935432, 3187935439, 'GT', 'GTM', 'غواتيمالا'),
(42486, 3187935440, 3187935463, 'HN', 'HND', 'هندوراس'),
(42487, 3187935464, 3187935467, 'GT', 'GTM', 'غواتيمالا'),
(42488, 3187935468, 3187935511, 'HN', 'HND', 'هندوراس'),
(42489, 3187935512, 3187935519, 'GT', 'GTM', 'غواتيمالا'),
(42490, 3187935520, 3187935711, 'HN', 'HND', 'هندوراس'),
(42491, 3187935712, 3187935735, 'GT', 'GTM', 'غواتيمالا'),
(42492, 3187935736, 3187935743, 'HN', 'HND', 'هندوراس'),
(42493, 3187935744, 3187936007, 'GT', 'GTM', 'غواتيمالا'),
(42494, 3187936008, 3187936011, 'HN', 'HND', 'هندوراس'),
(42495, 3187936012, 3187936015, 'GT', 'GTM', 'غواتيمالا'),
(42496, 3187936016, 3187936027, 'HN', 'HND', 'هندوراس'),
(42497, 3187936028, 3187936039, 'GT', 'GTM', 'غواتيمالا'),
(42498, 3187936040, 3187936067, 'HN', 'HND', 'هندوراس'),
(42499, 3187936068, 3187936071, 'GT', 'GTM', 'غواتيمالا'),
(42500, 3187936072, 3187936079, 'HN', 'HND', 'هندوراس'),
(42501, 3187936080, 3187936095, 'GT', 'GTM', 'غواتيمالا'),
(42502, 3187936096, 3187936115, 'HN', 'HND', 'هندوراس'),
(42503, 3187936116, 3187936119, 'GT', 'GTM', 'غواتيمالا'),
(42504, 3187936120, 3187936127, 'HN', 'HND', 'هندوراس'),
(42505, 3187936128, 3187936131, 'GT', 'GTM', 'غواتيمالا'),
(42506, 3187936132, 3187936135, 'HN', 'HND', 'هندوراس'),
(42507, 3187936136, 3187936151, 'GT', 'GTM', 'غواتيمالا'),
(42508, 3187936152, 3187936167, 'HN', 'HND', 'هندوراس'),
(42509, 3187936168, 3187936183, 'GT', 'GTM', 'غواتيمالا'),
(42510, 3187936184, 3187936191, 'HN', 'HND', 'هندوراس'),
(42511, 3187936192, 3187936199, 'GT', 'GTM', 'غواتيمالا'),
(42512, 3187936200, 3187936207, 'HN', 'HND', 'هندوراس'),
(42513, 3187936208, 3187936223, 'GT', 'GTM', 'غواتيمالا'),
(42514, 3187936224, 3187936239, 'HN', 'HND', 'هندوراس'),
(42515, 3187936240, 3187936519, 'GT', 'GTM', 'غواتيمالا'),
(42516, 3187936520, 3187936527, 'HN', 'HND', 'هندوراس'),
(42517, 3187936528, 3187936583, 'GT', 'GTM', 'غواتيمالا'),
(42518, 3187936584, 3187936599, 'HN', 'HND', 'هندوراس'),
(42519, 3187936600, 3187936607, 'GT', 'GTM', 'غواتيمالا'),
(42520, 3187936608, 3187936631, 'HN', 'HND', 'هندوراس'),
(42521, 3187936632, 3187936639, 'GT', 'GTM', 'غواتيمالا'),
(42522, 3187936640, 3187936655, 'HN', 'HND', 'هندوراس'),
(42523, 3187936656, 3187936663, 'GT', 'GTM', 'غواتيمالا'),
(42524, 3187936664, 3187936695, 'HN', 'HND', 'هندوراس'),
(42525, 3187936696, 3187936711, 'GT', 'GTM', 'غواتيمالا'),
(42526, 3187936712, 3187936735, 'HN', 'HND', 'هندوراس'),
(42527, 3187936736, 3187937031, 'GT', 'GTM', 'غواتيمالا'),
(42528, 3187937032, 3187937035, 'HN', 'HND', 'هندوراس'),
(42529, 3187937036, 3187937071, 'GT', 'GTM', 'غواتيمالا'),
(42530, 3187937072, 3187937079, 'HN', 'HND', 'هندوراس'),
(42531, 3187937080, 3187937103, 'GT', 'GTM', 'غواتيمالا'),
(42532, 3187937104, 3187937119, 'HN', 'HND', 'هندوراس'),
(42533, 3187937120, 3187937135, 'GT', 'GTM', 'غواتيمالا'),
(42534, 3187937136, 3187937139, 'HN', 'HND', 'هندوراس'),
(42535, 3187937140, 3187937143, 'GT', 'GTM', 'غواتيمالا'),
(42536, 3187937144, 3187937187, 'HN', 'HND', 'هندوراس'),
(42537, 3187937188, 3187937207, 'GT', 'GTM', 'غواتيمالا'),
(42538, 3187937208, 3187937215, 'HN', 'HND', 'هندوراس'),
(42539, 3187937216, 3187937235, 'GT', 'GTM', 'غواتيمالا'),
(42540, 3187937236, 3187937263, 'HN', 'HND', 'هندوراس'),
(42541, 3187937264, 3187937275, 'GT', 'GTM', 'غواتيمالا'),
(42542, 3187937276, 3187937279, 'HN', 'HND', 'هندوراس'),
(42543, 3187937280, 3187937287, 'GT', 'GTM', 'غواتيمالا'),
(42544, 3187937288, 3187937375, 'HN', 'HND', 'هندوراس'),
(42545, 3187937376, 3187937383, 'GT', 'GTM', 'غواتيمالا'),
(42546, 3187937384, 3187937391, 'HN', 'HND', 'هندوراس'),
(42547, 3187937392, 3187937407, 'GT', 'GTM', 'غواتيمالا'),
(42548, 3187937408, 3187937487, 'HN', 'HND', 'هندوراس'),
(42549, 3187937488, 3187937503, 'GT', 'GTM', 'غواتيمالا'),
(42550, 3187937504, 3187937527, 'HN', 'HND', 'هندوراس'),
(42551, 3187937528, 3187937791, 'GT', 'GTM', 'غواتيمالا'),
(42552, 3187937792, 3187937911, 'HN', 'HND', 'هندوراس'),
(42553, 3187937912, 3187937919, 'GT', 'GTM', 'غواتيمالا'),
(42554, 3187937920, 3187938047, 'HN', 'HND', 'هندوراس'),
(42555, 3187938048, 3187939071, 'GT', 'GTM', 'غواتيمالا'),
(42556, 3187939072, 3187939127, 'HN', 'HND', 'هندوراس'),
(42557, 3187939128, 3187939135, 'GT', 'GTM', 'غواتيمالا'),
(42558, 3187939136, 3187939139, 'HN', 'HND', 'هندوراس'),
(42559, 3187939140, 3187939143, 'GT', 'GTM', 'غواتيمالا'),
(42560, 3187939144, 3187939167, 'HN', 'HND', 'هندوراس'),
(42561, 3187939168, 3187939175, 'GT', 'GTM', 'غواتيمالا'),
(42562, 3187939176, 3187939207, 'HN', 'HND', 'هندوراس');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(42563, 3187939208, 3187939215, 'GT', 'GTM', 'غواتيمالا'),
(42564, 3187939216, 3187939231, 'HN', 'HND', 'هندوراس'),
(42565, 3187939232, 3187939239, 'GT', 'GTM', 'غواتيمالا'),
(42566, 3187939240, 3187939255, 'HN', 'HND', 'هندوراس'),
(42567, 3187939256, 3187939271, 'GT', 'GTM', 'غواتيمالا'),
(42568, 3187939272, 3187939327, 'HN', 'HND', 'هندوراس'),
(42569, 3187939328, 3187939839, 'GT', 'GTM', 'غواتيمالا'),
(42570, 3187939840, 3187939855, 'HN', 'HND', 'هندوراس'),
(42571, 3187939856, 3187939863, 'GT', 'GTM', 'غواتيمالا'),
(42572, 3187939864, 3187939879, 'HN', 'HND', 'هندوراس'),
(42573, 3187939880, 3187939887, 'GT', 'GTM', 'غواتيمالا'),
(42574, 3187939888, 3187939927, 'HN', 'HND', 'هندوراس'),
(42575, 3187939928, 3187939939, 'GT', 'GTM', 'غواتيمالا'),
(42576, 3187939940, 3187939967, 'HN', 'HND', 'هندوراس'),
(42577, 3187939968, 3187939975, 'GT', 'GTM', 'غواتيمالا'),
(42578, 3187939976, 3187940071, 'HN', 'HND', 'هندوراس'),
(42579, 3187940072, 3187940075, 'GT', 'GTM', 'غواتيمالا'),
(42580, 3187940076, 3187940211, 'HN', 'HND', 'هندوراس'),
(42581, 3187940212, 3187940215, 'GT', 'GTM', 'غواتيمالا'),
(42582, 3187940216, 3187940311, 'HN', 'HND', 'هندوراس'),
(42583, 3187940312, 3187940319, 'GT', 'GTM', 'غواتيمالا'),
(42584, 3187940320, 3187940339, 'HN', 'HND', 'هندوراس'),
(42585, 3187940340, 3187940343, 'GT', 'GTM', 'غواتيمالا'),
(42586, 3187940344, 3187940559, 'HN', 'HND', 'هندوراس'),
(42587, 3187940560, 3187940567, 'GT', 'GTM', 'غواتيمالا'),
(42588, 3187940568, 3187940639, 'HN', 'HND', 'هندوراس'),
(42589, 3187940640, 3187940647, 'GT', 'GTM', 'غواتيمالا'),
(42590, 3187940648, 3187940691, 'HN', 'HND', 'هندوراس'),
(42591, 3187940692, 3187940695, 'GT', 'GTM', 'غواتيمالا'),
(42592, 3187940696, 3187940719, 'HN', 'HND', 'هندوراس'),
(42593, 3187940720, 3187940723, 'GT', 'GTM', 'غواتيمالا'),
(42594, 3187940724, 3187940727, 'HN', 'HND', 'هندوراس'),
(42595, 3187940728, 3187940735, 'GT', 'GTM', 'غواتيمالا'),
(42596, 3187940736, 3187940791, 'HN', 'HND', 'هندوراس'),
(42597, 3187940792, 3187940795, 'GT', 'GTM', 'غواتيمالا'),
(42598, 3187940796, 3187940847, 'HN', 'HND', 'هندوراس'),
(42599, 3187940848, 3187940851, 'GT', 'GTM', 'غواتيمالا'),
(42600, 3187940852, 3187940935, 'HN', 'HND', 'هندوراس'),
(42601, 3187940936, 3187940947, 'GT', 'GTM', 'غواتيمالا'),
(42602, 3187940948, 3187940975, 'HN', 'HND', 'هندوراس'),
(42603, 3187940976, 3187940983, 'GT', 'GTM', 'غواتيمالا'),
(42604, 3187940984, 3187940991, 'HN', 'HND', 'هندوراس'),
(42605, 3187940992, 3187940999, 'GT', 'GTM', 'غواتيمالا'),
(42606, 3187941000, 3187941003, 'HN', 'HND', 'هندوراس'),
(42607, 3187941004, 3187941007, 'GT', 'GTM', 'غواتيمالا'),
(42608, 3187941008, 3187941063, 'HN', 'HND', 'هندوراس'),
(42609, 3187941064, 3187941071, 'GT', 'GTM', 'غواتيمالا'),
(42610, 3187941072, 3187941079, 'HN', 'HND', 'هندوراس'),
(42611, 3187941080, 3187941087, 'GT', 'GTM', 'غواتيمالا'),
(42612, 3187941088, 3187941131, 'HN', 'HND', 'هندوراس'),
(42613, 3187941132, 3187941139, 'GT', 'GTM', 'غواتيمالا'),
(42614, 3187941140, 3187941191, 'HN', 'HND', 'هندوراس'),
(42615, 3187941192, 3187941199, 'GT', 'GTM', 'غواتيمالا'),
(42616, 3187941200, 3187941203, 'HN', 'HND', 'هندوراس'),
(42617, 3187941204, 3187941207, 'GT', 'GTM', 'غواتيمالا'),
(42618, 3187941208, 3187941375, 'HN', 'HND', 'هندوراس'),
(42619, 3187941376, 3187941383, 'GT', 'GTM', 'غواتيمالا'),
(42620, 3187941384, 3187941399, 'HN', 'HND', 'هندوراس'),
(42621, 3187941400, 3187941407, 'GT', 'GTM', 'غواتيمالا'),
(42622, 3187941408, 3187941415, 'HN', 'HND', 'هندوراس'),
(42623, 3187941416, 3187941439, 'GT', 'GTM', 'غواتيمالا'),
(42624, 3187941440, 3187941463, 'HN', 'HND', 'هندوراس'),
(42625, 3187941464, 3187941471, 'GT', 'GTM', 'غواتيمالا'),
(42626, 3187941472, 3187941503, 'HN', 'HND', 'هندوراس'),
(42627, 3187941504, 3187941511, 'GT', 'GTM', 'غواتيمالا'),
(42628, 3187941512, 3187941527, 'HN', 'HND', 'هندوراس'),
(42629, 3187941528, 3187941531, 'GT', 'GTM', 'غواتيمالا'),
(42630, 3187941532, 3187941591, 'HN', 'HND', 'هندوراس'),
(42631, 3187941592, 3187941599, 'GT', 'GTM', 'غواتيمالا'),
(42632, 3187941600, 3187941619, 'HN', 'HND', 'هندوراس'),
(42633, 3187941620, 3187941631, 'GT', 'GTM', 'غواتيمالا'),
(42634, 3187941632, 3187941659, 'HN', 'HND', 'هندوراس'),
(42635, 3187941660, 3187941667, 'GT', 'GTM', 'غواتيمالا'),
(42636, 3187941668, 3187941691, 'HN', 'HND', 'هندوراس'),
(42637, 3187941692, 3187941695, 'GT', 'GTM', 'غواتيمالا'),
(42638, 3187941696, 3187941715, 'HN', 'HND', 'هندوراس'),
(42639, 3187941716, 3187941719, 'GT', 'GTM', 'غواتيمالا'),
(42640, 3187941720, 3187941727, 'HN', 'HND', 'هندوراس'),
(42641, 3187941728, 3187941739, 'GT', 'GTM', 'غواتيمالا'),
(42642, 3187941740, 3187941743, 'HN', 'HND', 'هندوراس'),
(42643, 3187941744, 3187941755, 'GT', 'GTM', 'غواتيمالا'),
(42644, 3187941756, 3187941767, 'HN', 'HND', 'هندوراس'),
(42645, 3187941768, 3187941787, 'GT', 'GTM', 'غواتيمالا'),
(42646, 3187941788, 3187941791, 'HN', 'HND', 'هندوراس'),
(42647, 3187941792, 3187941799, 'GT', 'GTM', 'غواتيمالا'),
(42648, 3187941800, 3187941807, 'HN', 'HND', 'هندوراس'),
(42649, 3187941808, 3187941815, 'GT', 'GTM', 'غواتيمالا'),
(42650, 3187941816, 3187941831, 'HN', 'HND', 'هندوراس'),
(42651, 3187941832, 3187941839, 'GT', 'GTM', 'غواتيمالا'),
(42652, 3187941840, 3187941847, 'HN', 'HND', 'هندوراس'),
(42653, 3187941848, 3187941855, 'GT', 'GTM', 'غواتيمالا'),
(42654, 3187941856, 3187941863, 'HN', 'HND', 'هندوراس'),
(42655, 3187941864, 3187941879, 'GT', 'GTM', 'غواتيمالا'),
(42656, 3187941880, 3187941895, 'HN', 'HND', 'هندوراس'),
(42657, 3187941896, 3187941903, 'GT', 'GTM', 'غواتيمالا'),
(42658, 3187941904, 3187941919, 'HN', 'HND', 'هندوراس'),
(42659, 3187941920, 3187941927, 'GT', 'GTM', 'غواتيمالا'),
(42660, 3187941928, 3187941931, 'HN', 'HND', 'هندوراس'),
(42661, 3187941932, 3187941935, 'GT', 'GTM', 'غواتيمالا'),
(42662, 3187941936, 3187941959, 'HN', 'HND', 'هندوراس'),
(42663, 3187941960, 3187941963, 'GT', 'GTM', 'غواتيمالا'),
(42664, 3187941964, 3187941967, 'HN', 'HND', 'هندوراس'),
(42665, 3187941968, 3187941975, 'GT', 'GTM', 'غواتيمالا'),
(42666, 3187941976, 3187942023, 'HN', 'HND', 'هندوراس'),
(42667, 3187942024, 3187942031, 'GT', 'GTM', 'غواتيمالا'),
(42668, 3187942032, 3187942039, 'HN', 'HND', 'هندوراس'),
(42669, 3187942040, 3187942063, 'GT', 'GTM', 'غواتيمالا'),
(42670, 3187942064, 3187942087, 'HN', 'HND', 'هندوراس'),
(42671, 3187942088, 3187942091, 'GT', 'GTM', 'غواتيمالا'),
(42672, 3187942092, 3187942111, 'HN', 'HND', 'هندوراس'),
(42673, 3187942112, 3187942123, 'GT', 'GTM', 'غواتيمالا'),
(42674, 3187942124, 3187942127, 'HN', 'HND', 'هندوراس'),
(42675, 3187942128, 3187942143, 'GT', 'GTM', 'غواتيمالا'),
(42676, 3187942144, 3187942147, 'HN', 'HND', 'هندوراس'),
(42677, 3187942148, 3187942151, 'GT', 'GTM', 'غواتيمالا'),
(42678, 3187942152, 3187942163, 'HN', 'HND', 'هندوراس'),
(42679, 3187942164, 3187942179, 'GT', 'GTM', 'غواتيمالا'),
(42680, 3187942180, 3187942183, 'HN', 'HND', 'هندوراس'),
(42681, 3187942184, 3187942195, 'GT', 'GTM', 'غواتيمالا'),
(42682, 3187942196, 3187942207, 'HN', 'HND', 'هندوراس'),
(42683, 3187942208, 3187942223, 'GT', 'GTM', 'غواتيمالا'),
(42684, 3187942224, 3187942231, 'HN', 'HND', 'هندوراس'),
(42685, 3187942232, 3187942235, 'GT', 'GTM', 'غواتيمالا'),
(42686, 3187942236, 3187942239, 'HN', 'HND', 'هندوراس'),
(42687, 3187942240, 3187942247, 'GT', 'GTM', 'غواتيمالا'),
(42688, 3187942248, 3187942287, 'HN', 'HND', 'هندوراس'),
(42689, 3187942288, 3187942303, 'GT', 'GTM', 'غواتيمالا'),
(42690, 3187942304, 3187942327, 'HN', 'HND', 'هندوراس'),
(42691, 3187942328, 3187942335, 'GT', 'GTM', 'غواتيمالا'),
(42692, 3187942336, 3187942359, 'HN', 'HND', 'هندوراس'),
(42693, 3187942360, 3187942391, 'GT', 'GTM', 'غواتيمالا'),
(42694, 3187942392, 3187942403, 'HN', 'HND', 'هندوراس'),
(42695, 3187942404, 3187942407, 'GT', 'GTM', 'غواتيمالا'),
(42696, 3187942408, 3187942415, 'HN', 'HND', 'هندوراس'),
(42697, 3187942416, 3187942423, 'GT', 'GTM', 'غواتيمالا'),
(42698, 3187942424, 3187942439, 'HN', 'HND', 'هندوراس'),
(42699, 3187942440, 3187942447, 'GT', 'GTM', 'غواتيمالا'),
(42700, 3187942448, 3187942495, 'HN', 'HND', 'هندوراس'),
(42701, 3187942496, 3187942503, 'GT', 'GTM', 'غواتيمالا'),
(42702, 3187942504, 3187942527, 'HN', 'HND', 'هندوراس'),
(42703, 3187942528, 3187942551, 'GT', 'GTM', 'غواتيمالا'),
(42704, 3187942552, 3187942559, 'HN', 'HND', 'هندوراس'),
(42705, 3187942560, 3187942563, 'GT', 'GTM', 'غواتيمالا'),
(42706, 3187942564, 3187942579, 'HN', 'HND', 'هندوراس'),
(42707, 3187942580, 3187942591, 'GT', 'GTM', 'غواتيمالا'),
(42708, 3187942592, 3187942599, 'HN', 'HND', 'هندوراس'),
(42709, 3187942600, 3187942623, 'GT', 'GTM', 'غواتيمالا'),
(42710, 3187942624, 3187942627, 'HN', 'HND', 'هندوراس'),
(42711, 3187942628, 3187942647, 'GT', 'GTM', 'غواتيمالا'),
(42712, 3187942648, 3187942719, 'HN', 'HND', 'هندوراس'),
(42713, 3187942720, 3187942727, 'GT', 'GTM', 'غواتيمالا'),
(42714, 3187942728, 3187942767, 'HN', 'HND', 'هندوراس'),
(42715, 3187942768, 3187942775, 'GT', 'GTM', 'غواتيمالا'),
(42716, 3187942776, 3187942831, 'HN', 'HND', 'هندوراس'),
(42717, 3187942832, 3187942839, 'GT', 'GTM', 'غواتيمالا'),
(42718, 3187942840, 3187942867, 'HN', 'HND', 'هندوراس'),
(42719, 3187942868, 3187942871, 'GT', 'GTM', 'غواتيمالا'),
(42720, 3187942872, 3187942875, 'HN', 'HND', 'هندوراس'),
(42721, 3187942876, 3187942879, 'GT', 'GTM', 'غواتيمالا'),
(42722, 3187942880, 3187942935, 'HN', 'HND', 'هندوراس'),
(42723, 3187942936, 3187942943, 'GT', 'GTM', 'غواتيمالا'),
(42724, 3187942944, 3187942959, 'HN', 'HND', 'هندوراس'),
(42725, 3187942960, 3187942975, 'GT', 'GTM', 'غواتيمالا'),
(42726, 3187942976, 3187943015, 'HN', 'HND', 'هندوراس'),
(42727, 3187943016, 3187943023, 'GT', 'GTM', 'غواتيمالا'),
(42728, 3187943024, 3187943043, 'HN', 'HND', 'هندوراس'),
(42729, 3187943044, 3187943047, 'GT', 'GTM', 'غواتيمالا'),
(42730, 3187943048, 3187943087, 'HN', 'HND', 'هندوراس'),
(42731, 3187943088, 3187943091, 'GT', 'GTM', 'غواتيمالا'),
(42732, 3187943092, 3187943095, 'HN', 'HND', 'هندوراس'),
(42733, 3187943096, 3187943103, 'GT', 'GTM', 'غواتيمالا'),
(42734, 3187943104, 3187943271, 'HN', 'HND', 'هندوراس'),
(42735, 3187943272, 3187943279, 'GT', 'GTM', 'غواتيمالا'),
(42736, 3187943280, 3187943431, 'HN', 'HND', 'هندوراس'),
(42737, 3187943432, 3187943439, 'GT', 'GTM', 'غواتيمالا'),
(42738, 3187943440, 3187943455, 'HN', 'HND', 'هندوراس'),
(42739, 3187943456, 3187943475, 'GT', 'GTM', 'غواتيمالا'),
(42740, 3187943476, 3187943727, 'HN', 'HND', 'هندوراس'),
(42741, 3187943728, 3187943743, 'GT', 'GTM', 'غواتيمالا'),
(42742, 3187943744, 3187943791, 'HN', 'HND', 'هندوراس'),
(42743, 3187943792, 3187943807, 'GT', 'GTM', 'غواتيمالا'),
(42744, 3187943808, 3187943879, 'HN', 'HND', 'هندوراس'),
(42745, 3187943880, 3187943887, 'GT', 'GTM', 'غواتيمالا'),
(42746, 3187943888, 3187943911, 'HN', 'HND', 'هندوراس'),
(42747, 3187943912, 3187943983, 'GT', 'GTM', 'غواتيمالا'),
(42748, 3187943984, 3187943991, 'HN', 'HND', 'هندوراس'),
(42749, 3187943992, 3187944015, 'GT', 'GTM', 'غواتيمالا'),
(42750, 3187944016, 3187944031, 'HN', 'HND', 'هندوراس'),
(42751, 3187944032, 3187944039, 'GT', 'GTM', 'غواتيمالا'),
(42752, 3187944040, 3187944067, 'HN', 'HND', 'هندوراس'),
(42753, 3187944068, 3187944071, 'GT', 'GTM', 'غواتيمالا'),
(42754, 3187944072, 3187944075, 'HN', 'HND', 'هندوراس'),
(42755, 3187944076, 3187944095, 'GT', 'GTM', 'غواتيمالا'),
(42756, 3187944096, 3187944103, 'HN', 'HND', 'هندوراس'),
(42757, 3187944104, 3187944107, 'GT', 'GTM', 'غواتيمالا'),
(42758, 3187944108, 3187944111, 'HN', 'HND', 'هندوراس'),
(42759, 3187944112, 3187944119, 'GT', 'GTM', 'غواتيمالا'),
(42760, 3187944120, 3187944127, 'HN', 'HND', 'هندوراس'),
(42761, 3187944128, 3187944131, 'GT', 'GTM', 'غواتيمالا'),
(42762, 3187944132, 3187944135, 'HN', 'HND', 'هندوراس'),
(42763, 3187944136, 3187944139, 'GT', 'GTM', 'غواتيمالا'),
(42764, 3187944140, 3187944147, 'HN', 'HND', 'هندوراس'),
(42765, 3187944148, 3187944151, 'GT', 'GTM', 'غواتيمالا'),
(42766, 3187944152, 3187944159, 'HN', 'HND', 'هندوراس'),
(42767, 3187944160, 3187944175, 'GT', 'GTM', 'غواتيمالا'),
(42768, 3187944176, 3187944183, 'HN', 'HND', 'هندوراس'),
(42769, 3187944184, 3187944187, 'GT', 'GTM', 'غواتيمالا'),
(42770, 3187944188, 3187944207, 'HN', 'HND', 'هندوراس'),
(42771, 3187944208, 3187944211, 'GT', 'GTM', 'غواتيمالا'),
(42772, 3187944212, 3187944255, 'HN', 'HND', 'هندوراس'),
(42773, 3187944256, 3187944263, 'GT', 'GTM', 'غواتيمالا'),
(42774, 3187944264, 3187944271, 'HN', 'HND', 'هندوراس'),
(42775, 3187944272, 3187944279, 'GT', 'GTM', 'غواتيمالا'),
(42776, 3187944280, 3187944291, 'HN', 'HND', 'هندوراس'),
(42777, 3187944292, 3187944307, 'GT', 'GTM', 'غواتيمالا'),
(42778, 3187944308, 3187944311, 'HN', 'HND', 'هندوراس'),
(42779, 3187944312, 3187944319, 'GT', 'GTM', 'غواتيمالا'),
(42780, 3187944320, 3187944343, 'HN', 'HND', 'هندوراس'),
(42781, 3187944344, 3187944351, 'GT', 'GTM', 'غواتيمالا'),
(42782, 3187944352, 3187944359, 'HN', 'HND', 'هندوراس'),
(42783, 3187944360, 3187944367, 'GT', 'GTM', 'غواتيمالا'),
(42784, 3187944368, 3187944399, 'HN', 'HND', 'هندوراس'),
(42785, 3187944400, 3187944407, 'GT', 'GTM', 'غواتيمالا'),
(42786, 3187944408, 3187944415, 'HN', 'HND', 'هندوراس'),
(42787, 3187944416, 3187944423, 'GT', 'GTM', 'غواتيمالا'),
(42788, 3187944424, 3187944447, 'HN', 'HND', 'هندوراس'),
(42789, 3187944448, 3187944463, 'GT', 'GTM', 'غواتيمالا'),
(42790, 3187944464, 3187944479, 'HN', 'HND', 'هندوراس'),
(42791, 3187944480, 3187944487, 'GT', 'GTM', 'غواتيمالا'),
(42792, 3187944488, 3187944647, 'HN', 'HND', 'هندوراس'),
(42793, 3187944648, 3187944651, 'GT', 'GTM', 'غواتيمالا'),
(42794, 3187944652, 3187944663, 'HN', 'HND', 'هندوراس'),
(42795, 3187944664, 3187944671, 'GT', 'GTM', 'غواتيمالا'),
(42796, 3187944672, 3187944695, 'HN', 'HND', 'هندوراس'),
(42797, 3187944696, 3187944719, 'GT', 'GTM', 'غواتيمالا'),
(42798, 3187944720, 3187944727, 'HN', 'HND', 'هندوراس'),
(42799, 3187944728, 3187944743, 'GT', 'GTM', 'غواتيمالا'),
(42800, 3187944744, 3187944759, 'HN', 'HND', 'هندوراس'),
(42801, 3187944760, 3187944799, 'GT', 'GTM', 'غواتيمالا'),
(42802, 3187944800, 3187944803, 'HN', 'HND', 'هندوراس'),
(42803, 3187944804, 3187944807, 'GT', 'GTM', 'غواتيمالا'),
(42804, 3187944808, 3187944811, 'HN', 'HND', 'هندوراس'),
(42805, 3187944812, 3187944819, 'GT', 'GTM', 'غواتيمالا'),
(42806, 3187944820, 3187944823, 'HN', 'HND', 'هندوراس'),
(42807, 3187944824, 3187944831, 'GT', 'GTM', 'غواتيمالا'),
(42808, 3187944832, 3187944835, 'HN', 'HND', 'هندوراس'),
(42809, 3187944836, 3187944839, 'GT', 'GTM', 'غواتيمالا'),
(42810, 3187944840, 3187944843, 'HN', 'HND', 'هندوراس'),
(42811, 3187944844, 3187944851, 'GT', 'GTM', 'غواتيمالا'),
(42812, 3187944852, 3187944863, 'HN', 'HND', 'هندوراس'),
(42813, 3187944864, 3187944871, 'GT', 'GTM', 'غواتيمالا'),
(42814, 3187944872, 3187944883, 'HN', 'HND', 'هندوراس'),
(42815, 3187944884, 3187944915, 'GT', 'GTM', 'غواتيمالا'),
(42816, 3187944916, 3187944923, 'HN', 'HND', 'هندوراس'),
(42817, 3187944924, 3187944927, 'GT', 'GTM', 'غواتيمالا'),
(42818, 3187944928, 3187944931, 'HN', 'HND', 'هندوراس'),
(42819, 3187944932, 3187944935, 'GT', 'GTM', 'غواتيمالا'),
(42820, 3187944936, 3187944939, 'HN', 'HND', 'هندوراس'),
(42821, 3187944940, 3187944959, 'GT', 'GTM', 'غواتيمالا'),
(42822, 3187944960, 3187945063, 'HN', 'HND', 'هندوراس'),
(42823, 3187945064, 3187945071, 'GT', 'GTM', 'غواتيمالا'),
(42824, 3187945072, 3187945087, 'HN', 'HND', 'هندوراس'),
(42825, 3187945088, 3187945095, 'GT', 'GTM', 'غواتيمالا'),
(42826, 3187945096, 3187945143, 'HN', 'HND', 'هندوراس'),
(42827, 3187945144, 3187945151, 'GT', 'GTM', 'غواتيمالا'),
(42828, 3187945152, 3187945167, 'HN', 'HND', 'هندوراس'),
(42829, 3187945168, 3187945175, 'GT', 'GTM', 'غواتيمالا'),
(42830, 3187945176, 3187945471, 'HN', 'HND', 'هندوراس'),
(42831, 3187945472, 3187945735, 'GT', 'GTM', 'غواتيمالا'),
(42832, 3187945736, 3187945743, 'HN', 'HND', 'هندوراس'),
(42833, 3187945744, 3187945751, 'GT', 'GTM', 'غواتيمالا'),
(42834, 3187945752, 3187945759, 'HN', 'HND', 'هندوراس'),
(42835, 3187945760, 3187945767, 'GT', 'GTM', 'غواتيمالا'),
(42836, 3187945768, 3187945775, 'HN', 'HND', 'هندوراس'),
(42837, 3187945776, 3187945783, 'GT', 'GTM', 'غواتيمالا'),
(42838, 3187945784, 3187945799, 'HN', 'HND', 'هندوراس'),
(42839, 3187945800, 3187945831, 'GT', 'GTM', 'غواتيمالا'),
(42840, 3187945832, 3187945855, 'HN', 'HND', 'هندوراس'),
(42841, 3187945856, 3187945863, 'GT', 'GTM', 'غواتيمالا'),
(42842, 3187945864, 3187945871, 'HN', 'HND', 'هندوراس'),
(42843, 3187945872, 3187945875, 'GT', 'GTM', 'غواتيمالا'),
(42844, 3187945876, 3187945879, 'HN', 'HND', 'هندوراس'),
(42845, 3187945880, 3187945887, 'GT', 'GTM', 'غواتيمالا'),
(42846, 3187945888, 3187945895, 'HN', 'HND', 'هندوراس'),
(42847, 3187945896, 3187945911, 'GT', 'GTM', 'غواتيمالا'),
(42848, 3187945912, 3187945939, 'HN', 'HND', 'هندوراس'),
(42849, 3187945940, 3187945951, 'GT', 'GTM', 'غواتيمالا'),
(42850, 3187945952, 3187945967, 'HN', 'HND', 'هندوراس'),
(42851, 3187945968, 3187945971, 'GT', 'GTM', 'غواتيمالا'),
(42852, 3187945972, 3187946247, 'HN', 'HND', 'هندوراس'),
(42853, 3187946248, 3187946255, 'GT', 'GTM', 'غواتيمالا'),
(42854, 3187946256, 3187946319, 'HN', 'HND', 'هندوراس'),
(42855, 3187946320, 3187946343, 'GT', 'GTM', 'غواتيمالا'),
(42856, 3187946344, 3187946359, 'HN', 'HND', 'هندوراس'),
(42857, 3187946360, 3187946375, 'GT', 'GTM', 'غواتيمالا'),
(42858, 3187946376, 3187946383, 'HN', 'HND', 'هندوراس'),
(42859, 3187946384, 3187946455, 'GT', 'GTM', 'غواتيمالا'),
(42860, 3187946456, 3187946459, 'HN', 'HND', 'هندوراس'),
(42861, 3187946460, 3187946463, 'GT', 'GTM', 'غواتيمالا'),
(42862, 3187946464, 3187946471, 'HN', 'HND', 'هندوراس'),
(42863, 3187946472, 3187946475, 'GT', 'GTM', 'غواتيمالا'),
(42864, 3187946476, 3187946623, 'HN', 'HND', 'هندوراس'),
(42865, 3187946624, 3187946631, 'GT', 'GTM', 'غواتيمالا'),
(42866, 3187946632, 3187946743, 'HN', 'HND', 'هندوراس'),
(42867, 3187946744, 3187946751, 'GT', 'GTM', 'غواتيمالا'),
(42868, 3187946752, 3187946911, 'HN', 'HND', 'هندوراس'),
(42869, 3187946912, 3187946919, 'GT', 'GTM', 'غواتيمالا'),
(42870, 3187946920, 3187946935, 'HN', 'HND', 'هندوراس'),
(42871, 3187946936, 3187946939, 'GT', 'GTM', 'غواتيمالا'),
(42872, 3187946940, 3187946979, 'HN', 'HND', 'هندوراس'),
(42873, 3187946980, 3187946983, 'GT', 'GTM', 'غواتيمالا'),
(42874, 3187946984, 3187946991, 'HN', 'HND', 'هندوراس'),
(42875, 3187946992, 3187946999, 'GT', 'GTM', 'غواتيمالا'),
(42876, 3187947000, 3187947075, 'HN', 'HND', 'هندوراس'),
(42877, 3187947076, 3187947095, 'GT', 'GTM', 'غواتيمالا'),
(42878, 3187947096, 3187947135, 'HN', 'HND', 'هندوراس'),
(42879, 3187947136, 3187947151, 'GT', 'GTM', 'غواتيمالا'),
(42880, 3187947152, 3187947167, 'HN', 'HND', 'هندوراس'),
(42881, 3187947168, 3187947175, 'GT', 'GTM', 'غواتيمالا'),
(42882, 3187947176, 3187947231, 'HN', 'HND', 'هندوراس'),
(42883, 3187947232, 3187947239, 'GT', 'GTM', 'غواتيمالا'),
(42884, 3187947240, 3187947303, 'HN', 'HND', 'هندوراس'),
(42885, 3187947304, 3187947315, 'GT', 'GTM', 'غواتيمالا'),
(42886, 3187947316, 3187947447, 'HN', 'HND', 'هندوراس'),
(42887, 3187947448, 3187947455, 'GT', 'GTM', 'غواتيمالا'),
(42888, 3187947456, 3187947503, 'HN', 'HND', 'هندوراس'),
(42889, 3187947504, 3187947511, 'GT', 'GTM', 'غواتيمالا'),
(42890, 3187947512, 3187947599, 'HN', 'HND', 'هندوراس'),
(42891, 3187947600, 3187947607, 'GT', 'GTM', 'غواتيمالا'),
(42892, 3187947608, 3187947615, 'HN', 'HND', 'هندوراس'),
(42893, 3187947616, 3187947623, 'GT', 'GTM', 'غواتيمالا'),
(42894, 3187947624, 3187947687, 'HN', 'HND', 'هندوراس'),
(42895, 3187947688, 3187947695, 'GT', 'GTM', 'غواتيمالا'),
(42896, 3187947696, 3187947727, 'HN', 'HND', 'هندوراس'),
(42897, 3187947728, 3187947735, 'GT', 'GTM', 'غواتيمالا'),
(42898, 3187947736, 3187947775, 'HN', 'HND', 'هندوراس'),
(42899, 3187947776, 3187947791, 'GT', 'GTM', 'غواتيمالا'),
(42900, 3187947792, 3187947811, 'HN', 'HND', 'هندوراس'),
(42901, 3187947812, 3187947815, 'GT', 'GTM', 'غواتيمالا'),
(42902, 3187947816, 3187947847, 'HN', 'HND', 'هندوراس'),
(42903, 3187947848, 3187947855, 'GT', 'GTM', 'غواتيمالا'),
(42904, 3187947856, 3187947887, 'HN', 'HND', 'هندوراس'),
(42905, 3187947888, 3187947895, 'GT', 'GTM', 'غواتيمالا'),
(42906, 3187947896, 3187947903, 'HN', 'HND', 'هندوراس'),
(42907, 3187947904, 3187947911, 'GT', 'GTM', 'غواتيمالا'),
(42908, 3187947912, 3187947919, 'HN', 'HND', 'هندوراس'),
(42909, 3187947920, 3187947935, 'GT', 'GTM', 'غواتيمالا'),
(42910, 3187947936, 3187947991, 'HN', 'HND', 'هندوراس'),
(42911, 3187947992, 3187947999, 'GT', 'GTM', 'غواتيمالا'),
(42912, 3187948000, 3187948159, 'HN', 'HND', 'هندوراس'),
(42913, 3187948160, 3187948287, 'GT', 'GTM', 'غواتيمالا'),
(42914, 3187948288, 3187948327, 'HN', 'HND', 'هندوراس'),
(42915, 3187948328, 3187948331, 'GT', 'GTM', 'غواتيمالا'),
(42916, 3187948332, 3187948359, 'HN', 'HND', 'هندوراس'),
(42917, 3187948360, 3187948367, 'GT', 'GTM', 'غواتيمالا'),
(42918, 3187948368, 3187948387, 'HN', 'HND', 'هندوراس'),
(42919, 3187948388, 3187948391, 'GT', 'GTM', 'غواتيمالا'),
(42920, 3187948392, 3187948455, 'HN', 'HND', 'هندوراس'),
(42921, 3187948456, 3187948463, 'GT', 'GTM', 'غواتيمالا'),
(42922, 3187948464, 3187948471, 'HN', 'HND', 'هندوراس'),
(42923, 3187948472, 3187948479, 'GT', 'GTM', 'غواتيمالا'),
(42924, 3187948480, 3187948543, 'HN', 'HND', 'هندوراس'),
(42925, 3187948544, 3187948799, 'GT', 'GTM', 'غواتيمالا'),
(42926, 3187948800, 3187948951, 'HN', 'HND', 'هندوراس'),
(42927, 3187948952, 3187948959, 'GT', 'GTM', 'غواتيمالا'),
(42928, 3187948960, 3187949003, 'HN', 'HND', 'هندوراس'),
(42929, 3187949004, 3187949007, 'GT', 'GTM', 'غواتيمالا'),
(42930, 3187949008, 3187949055, 'HN', 'HND', 'هندوراس'),
(42931, 3187949056, 3187949059, 'GT', 'GTM', 'غواتيمالا'),
(42932, 3187949060, 3187949083, 'HN', 'HND', 'هندوراس'),
(42933, 3187949084, 3187949087, 'GT', 'GTM', 'غواتيمالا'),
(42934, 3187949088, 3187949155, 'HN', 'HND', 'هندوراس'),
(42935, 3187949156, 3187949159, 'GT', 'GTM', 'غواتيمالا'),
(42936, 3187949160, 3187949167, 'HN', 'HND', 'هندوراس'),
(42937, 3187949168, 3187949175, 'GT', 'GTM', 'غواتيمالا'),
(42938, 3187949176, 3187949203, 'HN', 'HND', 'هندوراس'),
(42939, 3187949204, 3187949207, 'GT', 'GTM', 'غواتيمالا'),
(42940, 3187949208, 3187949231, 'HN', 'HND', 'هندوراس'),
(42941, 3187949232, 3187949239, 'GT', 'GTM', 'غواتيمالا'),
(42942, 3187949240, 3187949263, 'HN', 'HND', 'هندوراس'),
(42943, 3187949264, 3187949287, 'GT', 'GTM', 'غواتيمالا'),
(42944, 3187949288, 3187949295, 'HN', 'HND', 'هندوراس'),
(42945, 3187949296, 3187949311, 'GT', 'GTM', 'غواتيمالا'),
(42946, 3187949312, 3187949567, 'HN', 'HND', 'هندوراس'),
(42947, 3187949568, 3187953663, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(42948, 3187957760, 3187961855, 'CL', 'CHL', 'تشيلي'),
(42949, 3187965952, 3187982335, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(42950, 3187982336, 3187998719, 'CL', 'CHL', 'تشيلي'),
(42951, 3187998720, 3188006911, 'AR', 'ARG', 'الأرجنتين'),
(42952, 3188015104, 3188031487, 'HN', 'HND', 'هندوراس'),
(42953, 3188031488, 3188039679, 'SV', 'SLV', 'السلفادور'),
(42954, 3188047872, 3188051967, 'CO', 'COL', 'كولومبيا'),
(42955, 3188056064, 3188064255, 'PA', 'PAN', 'بنما'),
(42956, 3188064256, 3188080639, 'VE', 'VEN', 'فنزويلا'),
(42957, 3188080640, 3188084735, 'CU', 'CUB', 'كوبا'),
(42958, 3188088832, 3188092927, 'AR', 'ARG', 'الأرجنتين'),
(42959, 3188097024, 3188105215, 'DO', 'DOM', 'الدومينيكان'),
(42960, 3188105216, 3188113407, 'CO', 'COL', 'كولومبيا'),
(42961, 3188113408, 3188117503, 'HN', 'HND', 'هندوراس'),
(42962, 3188121600, 3188125695, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(42963, 3188129792, 3188146175, 'AR', 'ARG', 'الأرجنتين'),
(42964, 3188146176, 3188158463, 'CO', 'COL', 'كولومبيا'),
(42965, 3188162560, 3188170751, 'CO', 'COL', 'كولومبيا'),
(42966, 3188170752, 3188174847, 'CR', 'CRI', 'كوستا ريكا'),
(42967, 3188178944, 3188187135, 'CR', 'CRI', 'كوستا ريكا'),
(42968, 3188187136, 3188199423, 'AR', 'ARG', 'الأرجنتين'),
(42969, 3188203520, 3188207615, 'DO', 'DOM', 'الدومينيكان'),
(42970, 3188211712, 3188228095, 'CL', 'CHL', 'تشيلي'),
(42971, 3188228096, 3188236287, 'PE', 'PER', 'بيرو'),
(42972, 3188244480, 3188260863, 'CO', 'COL', 'كولومبيا'),
(42973, 3188260864, 3188264959, 'AR', 'ARG', 'الأرجنتين'),
(42974, 3188269056, 3188269311, 'VE', 'VEN', 'فنزويلا'),
(42975, 3188269312, 3188269439, 'MX', 'MEX', 'المكسيك'),
(42976, 3188269440, 3188273151, 'VE', 'VEN', 'فنزويلا'),
(42977, 3188273152, 3188275199, 'PA', 'PAN', 'بنما'),
(42978, 3188275200, 3188277247, 'CL', 'CHL', 'تشيلي'),
(42979, 3188277248, 3188293631, 'CO', 'COL', 'كولومبيا'),
(42980, 3188293632, 3188301823, 'VE', 'VEN', 'فنزويلا'),
(42981, 3188301824, 3188310015, 'EC', 'ECU', 'الإكوادور'),
(42982, 3188310016, 3188326399, 'CO', 'COL', 'كولومبيا'),
(42983, 3188326400, 3188359167, 'CR', 'CRI', 'كوستا ريكا'),
(42984, 3188359168, 3188400127, 'EC', 'ECU', 'الإكوادور'),
(42985, 3188400128, 3188404223, 'AR', 'ARG', 'الأرجنتين'),
(42986, 3188408320, 3188416511, 'BO', 'BOL', 'بوليفيا'),
(42987, 3188416512, 3188445183, 'AR', 'ARG', 'الأرجنتين'),
(42988, 3188449280, 3188453375, 'HN', 'HND', 'هندوراس'),
(42989, 3188457472, 3188473855, 'EC', 'ECU', 'الإكوادور'),
(42990, 3188473856, 3188482047, 'PE', 'PER', 'بيرو'),
(42991, 3188482048, 3188490239, 'AR', 'ARG', 'الأرجنتين'),
(42992, 3188490240, 3188498431, 'CO', 'COL', 'كولومبيا'),
(42993, 3188506624, 3188506879, 'AR', 'ARG', 'الأرجنتين'),
(42994, 3188506880, 3188520959, 'US', 'USA', 'الولايات المتحدة'),
(42995, 3188520960, 3188523007, 'AR', 'ARG', 'الأرجنتين'),
(42996, 3188523008, 3188539391, 'CO', 'COL', 'كولومبيا'),
(42997, 3188539392, 3188542207, 'CL', 'CHL', 'تشيلي'),
(42998, 3188542208, 3188542463, 'US', 'USA', 'الولايات المتحدة'),
(42999, 3188542464, 3188543487, 'CL', 'CHL', 'تشيلي'),
(43000, 3188547584, 3188551679, 'CO', 'COL', 'كولومبيا'),
(43001, 3188555776, 3188559871, 'CL', 'CHL', 'تشيلي'),
(43002, 3188563968, 3188572159, 'CL', 'CHL', 'تشيلي'),
(43003, 3188572160, 3188576255, 'CO', 'COL', 'كولومبيا'),
(43004, 3188580352, 3188596735, 'AR', 'ARG', 'الأرجنتين'),
(43005, 3188621312, 3188625407, 'GT', 'GTM', 'غواتيمالا'),
(43006, 3188629504, 3188637695, 'AR', 'ARG', 'الأرجنتين'),
(43007, 3188637696, 3188645887, 'PA', 'PAN', 'بنما'),
(43008, 3188645888, 3188662271, 'CO', 'COL', 'كولومبيا'),
(43009, 3188670464, 3188674559, 'HN', 'HND', 'هندوراس'),
(43010, 3188678656, 3188686847, 'AR', 'ARG', 'الأرجنتين'),
(43011, 3188686848, 3188690943, 'EC', 'ECU', 'الإكوادور'),
(43012, 3188695040, 3188703231, 'VE', 'VEN', 'فنزويلا'),
(43013, 3188703232, 3188711423, 'AR', 'ARG', 'الأرجنتين'),
(43014, 3188719616, 3188981759, 'AR', 'ARG', 'الأرجنتين'),
(43015, 3188981760, 3189178367, 'CL', 'CHL', 'تشيلي'),
(43016, 3189178368, 3189211135, 'PY', 'PRY', 'باراغواي'),
(43017, 3189243904, 3189637119, 'CO', 'COL', 'كولومبيا'),
(43018, 3189637120, 3189694175, 'AR', 'ARG', 'الأرجنتين'),
(43019, 3189694176, 3189694183, 'AW', 'ABW', 'أروبا'),
(43020, 3189694184, 3189694231, 'AR', 'ARG', 'الأرجنتين'),
(43021, 3189694232, 3189694239, 'BO', 'BOL', 'بوليفيا'),
(43022, 3189694240, 3189768191, 'AR', 'ARG', 'الأرجنتين'),
(43023, 3189768192, 3190030335, 'PA', 'PAN', 'بنما'),
(43024, 3190030336, 3190292479, 'VE', 'VEN', 'فنزويلا'),
(43025, 3190292480, 3190554623, 'PE', 'PER', 'بيرو'),
(43026, 3190554624, 3190816767, 'CL', 'CHL', 'تشيلي'),
(43027, 3190816768, 3191078911, 'AR', 'ARG', 'الأرجنتين'),
(43028, 3191078912, 3191087103, 'CO', 'COL', 'كولومبيا'),
(43029, 3191095296, 3191099391, 'EC', 'ECU', 'الإكوادور'),
(43030, 3191103488, 3191107583, 'CO', 'COL', 'كولومبيا'),
(43031, 3191111680, 3191128063, 'PY', 'PRY', 'باراغواي'),
(43032, 3191128064, 3191132159, 'EC', 'ECU', 'الإكوادور'),
(43033, 3191136256, 3191144447, 'DO', 'DOM', 'الدومينيكان'),
(43034, 3191144448, 3191152639, 'SV', 'SLV', 'السلفادور'),
(43035, 3191152640, 3191156735, 'NI', 'NIC', 'نيكاراغوا'),
(43036, 3191156736, 3191169023, 'HN', 'HND', 'هندوراس'),
(43037, 3191169024, 3191209983, 'SV', 'SLV', 'السلفادور'),
(43038, 3191209984, 3191275519, 'CL', 'CHL', 'تشيلي'),
(43039, 3191275520, 3191341055, 'AR', 'ARG', 'الأرجنتين'),
(43040, 3191341056, 3191406591, 'GT', 'GTM', 'غواتيمالا'),
(43041, 3191406592, 3191427071, 'SV', 'SLV', 'السلفادور'),
(43042, 3191427072, 3191439359, 'GT', 'GTM', 'غواتيمالا'),
(43043, 3191472128, 3191603199, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(43044, 3191603200, 3191608831, 'MX', 'MEX', 'المكسيك'),
(43045, 3191608832, 3191609343, 'US', 'USA', 'الولايات المتحدة'),
(43046, 3191609344, 3191610879, 'CO', 'COL', 'كولومبيا'),
(43047, 3191610880, 3191611135, 'US', 'USA', 'الولايات المتحدة'),
(43048, 3191611136, 3191611391, 'CO', 'COL', 'كولومبيا'),
(43049, 3191611392, 3191619583, 'VE', 'VEN', 'فنزويلا'),
(43050, 3191619584, 3191719935, 'CO', 'COL', 'كولومبيا'),
(43051, 3191719936, 3191721471, 'AR', 'ARG', 'الأرجنتين'),
(43052, 3191721472, 3191725055, 'CO', 'COL', 'كولومبيا'),
(43053, 3191725056, 3191725311, 'AR', 'ARG', 'الأرجنتين'),
(43054, 3191725312, 3191725567, 'CO', 'COL', 'كولومبيا'),
(43055, 3191725568, 3191725823, 'AR', 'ARG', 'الأرجنتين'),
(43056, 3191725824, 3191726079, 'CO', 'COL', 'كولومبيا'),
(43057, 3191726080, 3191726335, 'AR', 'ARG', 'الأرجنتين'),
(43058, 3191726336, 3191726591, 'CO', 'COL', 'كولومبيا'),
(43059, 3191726592, 3191726847, 'AR', 'ARG', 'الأرجنتين'),
(43060, 3191726848, 3191727103, 'CO', 'COL', 'كولومبيا'),
(43061, 3191727104, 3191727359, 'AR', 'ARG', 'الأرجنتين'),
(43062, 3191727360, 3191727615, 'CO', 'COL', 'كولومبيا'),
(43063, 3191727616, 3191727871, 'AR', 'ARG', 'الأرجنتين'),
(43064, 3191727872, 3191728127, 'CO', 'COL', 'كولومبيا'),
(43065, 3191728128, 3191728383, 'AR', 'ARG', 'الأرجنتين'),
(43066, 3191728384, 3191728639, 'CO', 'COL', 'كولومبيا'),
(43067, 3191728640, 3191728895, 'AR', 'ARG', 'الأرجنتين'),
(43068, 3191728896, 3191729151, 'CO', 'COL', 'كولومبيا'),
(43069, 3191729152, 3191729407, 'AR', 'ARG', 'الأرجنتين'),
(43070, 3191729408, 3191729663, 'CO', 'COL', 'كولومبيا'),
(43071, 3191729664, 3191729919, 'AR', 'ARG', 'الأرجنتين'),
(43072, 3191729920, 3191730431, 'CO', 'COL', 'كولومبيا'),
(43073, 3191730432, 3191730687, 'AR', 'ARG', 'الأرجنتين'),
(43074, 3191730688, 3191730943, 'CO', 'COL', 'كولومبيا'),
(43075, 3191730944, 3191731199, 'AR', 'ARG', 'الأرجنتين'),
(43076, 3191731200, 3191731455, 'CO', 'COL', 'كولومبيا'),
(43077, 3191731456, 3191731711, 'AR', 'ARG', 'الأرجنتين'),
(43078, 3191731712, 3191731967, 'CO', 'COL', 'كولومبيا'),
(43079, 3191731968, 3191732223, 'AR', 'ARG', 'الأرجنتين'),
(43080, 3191732224, 3191732479, 'CO', 'COL', 'كولومبيا'),
(43081, 3191732480, 3191732735, 'AR', 'ARG', 'الأرجنتين'),
(43082, 3191732736, 3191734015, 'CO', 'COL', 'كولومبيا'),
(43083, 3191734016, 3191734031, 'US', 'USA', 'الولايات المتحدة'),
(43084, 3191734032, 3191734079, 'CO', 'COL', 'كولومبيا'),
(43085, 3191734080, 3191734143, 'US', 'USA', 'الولايات المتحدة'),
(43086, 3191734144, 3191734271, 'CO', 'COL', 'كولومبيا'),
(43087, 3191865344, 3191930879, 'UY', 'URY', 'الأوروغواي'),
(43088, 3191930880, 3192389631, 'CO', 'COL', 'كولومبيا'),
(43089, 3192389632, 3192913919, 'VE', 'VEN', 'فنزويلا'),
(43090, 3192913920, 3192946687, 'GY', 'GUY', 'غيانا'),
(43091, 3192946688, 3192979455, 'DO', 'DOM', 'الدومينيكان'),
(43092, 3192979456, 3192988767, 'PE', 'PER', 'بيرو'),
(43093, 3192988768, 3192988775, 'PA', 'PAN', 'بنما'),
(43094, 3192988776, 3193044991, 'PE', 'PER', 'بيرو'),
(43095, 3193044992, 3193110527, 'CL', 'CHL', 'تشيلي'),
(43096, 3193110528, 3193143295, 'CO', 'COL', 'كولومبيا'),
(43097, 3193176064, 3193307135, 'CO', 'COL', 'كولومبيا'),
(43098, 3193307136, 3193438207, 'SV', 'SLV', 'السلفادور'),
(43099, 3193438208, 3193569279, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43100, 3193569280, 3193574399, 'CO', 'COL', 'كولومبيا'),
(43101, 3193574400, 3193575423, 'PE', 'PER', 'بيرو'),
(43102, 3193575424, 3193576447, 'CO', 'COL', 'كولومبيا'),
(43103, 3193576448, 3193576703, 'EC', 'ECU', 'الإكوادور'),
(43104, 3193576704, 3193576959, 'CO', 'COL', 'كولومبيا'),
(43105, 3193576960, 3193577215, 'PE', 'PER', 'بيرو'),
(43106, 3193577216, 3193592319, 'CO', 'COL', 'كولومبيا'),
(43107, 3193592320, 3193592575, 'EC', 'ECU', 'الإكوادور'),
(43108, 3193592576, 3193617151, 'CO', 'COL', 'كولومبيا'),
(43109, 3193617152, 3193617407, 'EC', 'ECU', 'الإكوادور'),
(43110, 3193617408, 3193620479, 'CO', 'COL', 'كولومبيا'),
(43111, 3193620480, 3193620991, 'PE', 'PER', 'بيرو'),
(43112, 3193620992, 3193628671, 'CO', 'COL', 'كولومبيا'),
(43113, 3193628672, 3193628927, 'EC', 'ECU', 'الإكوادور'),
(43114, 3193628928, 3193634815, 'CO', 'COL', 'كولومبيا'),
(43115, 3193700352, 3193716735, 'HN', 'HND', 'هندوراس'),
(43116, 3193733120, 3193741311, 'AR', 'ARG', 'الأرجنتين'),
(43117, 3193741312, 3193742335, 'US', 'USA', 'الولايات المتحدة'),
(43118, 3193742336, 3193742847, 'AR', 'ARG', 'الأرجنتين'),
(43119, 3193742848, 3193743359, 'US', 'USA', 'الولايات المتحدة'),
(43120, 3193743360, 3193743615, 'AR', 'ARG', 'الأرجنتين'),
(43121, 3193743616, 3193743871, 'US', 'USA', 'الولايات المتحدة'),
(43122, 3193743872, 3193744383, 'AR', 'ARG', 'الأرجنتين'),
(43123, 3193744384, 3193745407, 'US', 'USA', 'الولايات المتحدة'),
(43124, 3193745408, 3193748479, 'AR', 'ARG', 'الأرجنتين'),
(43125, 3193748480, 3193748735, 'US', 'USA', 'الولايات المتحدة'),
(43126, 3193748736, 3193752575, 'AR', 'ARG', 'الأرجنتين'),
(43127, 3193752576, 3193753087, 'US', 'USA', 'الولايات المتحدة'),
(43128, 3193753088, 3193753343, 'AR', 'ARG', 'الأرجنتين'),
(43129, 3193753344, 3193760511, 'US', 'USA', 'الولايات المتحدة'),
(43130, 3193760512, 3193760767, 'AR', 'ARG', 'الأرجنتين'),
(43131, 3193760768, 3193761023, 'US', 'USA', 'الولايات المتحدة'),
(43132, 3193761024, 3193765887, 'AR', 'ARG', 'الأرجنتين'),
(43133, 3193765888, 3193774079, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(43134, 3193782272, 3193798655, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(43135, 3193798656, 3193806847, 'CO', 'COL', 'كولومبيا'),
(43136, 3193815040, 3193819135, 'AR', 'ARG', 'الأرجنتين'),
(43137, 3193823232, 3193827327, 'CL', 'CHL', 'تشيلي'),
(43138, 3193831424, 3193864191, 'DO', 'DOM', 'الدومينيكان'),
(43139, 3193864192, 3193872383, 'EC', 'ECU', 'الإكوادور'),
(43140, 3193880576, 3193888767, 'VE', 'VEN', 'فنزويلا'),
(43141, 3193896960, 3193929727, 'CL', 'CHL', 'تشيلي'),
(43142, 3193929728, 3193962495, 'EC', 'ECU', 'الإكوادور'),
(43143, 3193962496, 3193987071, 'CL', 'CHL', 'تشيلي'),
(43144, 3193995264, 3194028031, 'CO', 'COL', 'كولومبيا'),
(43145, 3194028032, 3194044415, 'AR', 'ARG', 'الأرجنتين'),
(43146, 3194044416, 3194052607, 'CO', 'COL', 'كولومبيا'),
(43147, 3194052608, 3194056461, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(43148, 3194056462, 3194056462, 'US', 'USA', 'الولايات المتحدة'),
(43149, 3194056463, 3194056703, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(43150, 3194060800, 3194068991, 'CO', 'COL', 'كولومبيا'),
(43151, 3194077184, 3194085375, 'CO', 'COL', 'كولومبيا'),
(43152, 3194093568, 3194126335, 'SR', 'SUR', 'سورينام'),
(43153, 3194126336, 3194127359, 'GT', 'GTM', 'غواتيمالا'),
(43154, 3194127360, 3194129407, 'PE', 'PER', 'بيرو'),
(43155, 3194129408, 3194129919, 'BR', 'BRA', 'البرازيل'),
(43156, 3194129920, 3194130175, 'AR', 'ARG', 'الأرجنتين'),
(43157, 3194130176, 3194134527, 'BR', 'BRA', 'البرازيل'),
(43158, 3194134528, 3194135039, 'HN', 'HND', 'هندوراس'),
(43159, 3194135040, 3194142719, 'AR', 'ARG', 'الأرجنتين'),
(43160, 3194142720, 3194159103, 'CL', 'CHL', 'تشيلي'),
(43161, 3194159104, 3194163199, 'HN', 'HND', 'هندوراس'),
(43162, 3194163200, 3194167295, 'GT', 'GTM', 'غواتيمالا'),
(43163, 3194167296, 3194175487, 'SV', 'SLV', 'السلفادور'),
(43164, 3194175488, 3194177535, 'AR', 'ARG', 'الأرجنتين'),
(43165, 3194183680, 3194187775, 'UY', 'URY', 'الأوروغواي'),
(43166, 3194191872, 3194224639, 'CO', 'COL', 'كولومبيا'),
(43167, 3194224640, 3194322943, 'CL', 'CHL', 'تشيلي'),
(43168, 3194355712, 3194363903, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43169, 3194368000, 3194370047, 'BO', 'BOL', 'بوليفيا'),
(43170, 3194370048, 3194372095, 'PA', 'PAN', 'بنما'),
(43171, 3194372096, 3194380287, 'HT', 'HTI', 'هايتي'),
(43172, 3194388480, 3194396671, 'PE', 'PER', 'بيرو'),
(43173, 3194404864, 3194413055, 'CO', 'COL', 'كولومبيا'),
(43174, 3194413056, 3194421247, 'CL', 'CHL', 'تشيلي'),
(43175, 3194421248, 3194425343, 'AR', 'ARG', 'الأرجنتين'),
(43176, 3194429440, 3194437631, 'VE', 'VEN', 'فنزويلا'),
(43177, 3194437632, 3194441727, 'BO', 'BOL', 'بوليفيا'),
(43178, 3194445824, 3194454015, 'CO', 'COL', 'كولومبيا'),
(43179, 3194454016, 3194458111, 'AR', 'ARG', 'الأرجنتين'),
(43180, 3194470400, 3194486783, 'AR', 'ARG', 'الأرجنتين'),
(43181, 3194486784, 3194494975, 'BO', 'BOL', 'بوليفيا'),
(43182, 3194503168, 3194507263, 'AR', 'ARG', 'الأرجنتين'),
(43183, 3194519552, 3194535935, 'PY', 'PRY', 'باراغواي'),
(43184, 3194552320, 3194585087, 'AR', 'ARG', 'الأرجنتين'),
(43185, 3194617856, 3194626047, 'NI', 'NIC', 'نيكاراغوا'),
(43186, 3194634240, 3194638335, 'CR', 'CRI', 'كوستا ريكا'),
(43187, 3194642432, 3194646527, 'AR', 'ARG', 'الأرجنتين'),
(43188, 3194650624, 3194658815, 'AR', 'ARG', 'الأرجنتين'),
(43189, 3194658816, 3194661631, 'US', 'USA', 'الولايات المتحدة'),
(43190, 3194661632, 3194661887, 'AR', 'ARG', 'الأرجنتين'),
(43191, 3194661888, 3194667007, 'US', 'USA', 'الولايات المتحدة'),
(43192, 3194683392, 3194687487, 'CU', 'CUB', 'كوبا'),
(43193, 3194691584, 3194695679, 'BO', 'BOL', 'بوليفيا'),
(43194, 3194699776, 3194703871, 'EC', 'ECU', 'الإكوادور'),
(43195, 3194707968, 3194716159, 'AR', 'ARG', 'الأرجنتين'),
(43196, 3194716160, 3194720255, 'HN', 'HND', 'هندوراس'),
(43197, 3194724352, 3194728447, 'PA', 'PAN', 'بنما'),
(43198, 3194732544, 3194736639, 'AR', 'ARG', 'الأرجنتين'),
(43199, 3194740736, 3194742783, 'CL', 'CHL', 'تشيلي'),
(43200, 3194742784, 3194744831, 'EC', 'ECU', 'الإكوادور'),
(43201, 3194744832, 3194746879, 'AR', 'ARG', 'الأرجنتين'),
(43202, 3194746880, 3194748927, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43203, 3194748928, 3194757119, 'UY', 'URY', 'الأوروغواي'),
(43204, 3194781696, 3194798079, 'CL', 'CHL', 'تشيلي'),
(43205, 3194818560, 3194822655, 'AR', 'ARG', 'الأرجنتين'),
(43206, 3194847232, 3194863615, 'CO', 'COL', 'كولومبيا'),
(43207, 3194863616, 3194871807, 'HN', 'HND', 'هندوراس'),
(43208, 3194880000, 3194896383, 'DO', 'DOM', 'الدومينيكان'),
(43209, 3194896384, 3194904575, 'CO', 'COL', 'كولومبيا'),
(43210, 3194912768, 3194920959, 'CL', 'CHL', 'تشيلي'),
(43211, 3194929152, 3194937343, 'EC', 'ECU', 'الإكوادور'),
(43212, 3194945536, 3194953727, 'GT', 'GTM', 'غواتيمالا'),
(43213, 3194961920, 3194966015, 'EC', 'ECU', 'الإكوادور'),
(43214, 3194970112, 3194974207, 'PA', 'PAN', 'بنما'),
(43215, 3194978304, 3194978559, 'PA', 'PAN', 'بنما'),
(43216, 3194978560, 3194978815, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43217, 3194978816, 3194981375, 'PA', 'PAN', 'بنما'),
(43218, 3194981376, 3194984447, 'US', 'USA', 'الولايات المتحدة'),
(43219, 3194984448, 3194984703, 'PR', 'PRI', 'بورتو ريكو'),
(43220, 3194984704, 3194985215, 'UK', 'GBR', 'المملكة المتحدة'),
(43221, 3194985216, 3194985983, 'US', 'USA', 'الولايات المتحدة'),
(43222, 3194985984, 3194990591, 'PA', 'PAN', 'بنما'),
(43223, 3194990592, 3194990719, 'US', 'USA', 'الولايات المتحدة'),
(43224, 3194990720, 3194990784, 'CA', 'CAN', 'كندا'),
(43225, 3194990785, 3194990785, 'PR', 'PRI', 'بورتو ريكو'),
(43226, 3194990786, 3194990788, 'CA', 'CAN', 'كندا'),
(43227, 3194990789, 3194990789, 'PR', 'PRI', 'بورتو ريكو'),
(43228, 3194990790, 3194991359, 'CA', 'CAN', 'كندا'),
(43229, 3194991360, 3194991679, 'ES', 'ESP', 'إسبانيا'),
(43230, 3194991680, 3194991871, 'CA', 'CAN', 'كندا'),
(43231, 3194991872, 3194991935, 'ES', 'ESP', 'إسبانيا'),
(43232, 3194991936, 3194992159, 'CA', 'CAN', 'كندا'),
(43233, 3194992160, 3194992191, 'PR', 'PRI', 'بورتو ريكو'),
(43234, 3194992192, 3194992255, 'CA', 'CAN', 'كندا'),
(43235, 3194992256, 3194992287, 'ES', 'ESP', 'إسبانيا'),
(43236, 3194992288, 3194994687, 'CA', 'CAN', 'كندا'),
(43237, 3194994688, 3195002879, 'AR', 'ARG', 'الأرجنتين'),
(43238, 3195011072, 3195011327, 'AR', 'ARG', 'الأرجنتين'),
(43239, 3195011328, 3195011583, 'US', 'USA', 'الولايات المتحدة'),
(43240, 3195011584, 3195012351, 'AR', 'ARG', 'الأرجنتين'),
(43241, 3195012352, 3195012607, 'US', 'USA', 'الولايات المتحدة'),
(43242, 3195012608, 3195012863, 'AR', 'ARG', 'الأرجنتين'),
(43243, 3195012864, 3195013119, 'US', 'USA', 'الولايات المتحدة'),
(43244, 3195013120, 3195013375, 'AR', 'ARG', 'الأرجنتين'),
(43245, 3195013376, 3195013631, 'US', 'USA', 'الولايات المتحدة'),
(43246, 3195013632, 3195014143, 'AR', 'ARG', 'الأرجنتين'),
(43247, 3195014144, 3195014399, 'US', 'USA', 'الولايات المتحدة'),
(43248, 3195014400, 3195014655, 'AR', 'ARG', 'الأرجنتين'),
(43249, 3195014656, 3195014911, 'US', 'USA', 'الولايات المتحدة'),
(43250, 3195014912, 3195019263, 'AR', 'ARG', 'الأرجنتين'),
(43251, 3195043840, 3195052031, 'CO', 'COL', 'كولومبيا'),
(43252, 3195060224, 3195062783, 'UY', 'URY', 'الأوروغواي'),
(43253, 3195062784, 3195062791, 'AR', 'ARG', 'الأرجنتين'),
(43254, 3195062792, 3195066367, 'UY', 'URY', 'الأوروغواي'),
(43255, 3195068416, 3195072511, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43256, 3195076608, 3195084799, 'CL', 'CHL', 'تشيلي'),
(43257, 3195109376, 3195117567, 'AR', 'ARG', 'الأرجنتين'),
(43258, 3195142144, 3195150335, 'VE', 'VEN', 'فنزويلا'),
(43259, 3195174912, 3195183103, 'AR', 'ARG', 'الأرجنتين'),
(43260, 3195191296, 3195199487, 'AR', 'ARG', 'الأرجنتين'),
(43261, 3195535360, 3195539455, 'SV', 'SLV', 'السلفادور'),
(43262, 3195543552, 3195547647, 'PE', 'PER', 'بيرو'),
(43263, 3195551744, 3195555839, 'EC', 'ECU', 'الإكوادور'),
(43264, 3195559936, 3195564031, 'AR', 'ARG', 'الأرجنتين'),
(43265, 3195568128, 3195572223, 'CO', 'COL', 'كولومبيا'),
(43266, 3195576320, 3195580415, 'CL', 'CHL', 'تشيلي'),
(43267, 3195584512, 3195592703, 'HT', 'HTI', 'هايتي'),
(43268, 3195592704, 3195596799, 'PA', 'PAN', 'بنما'),
(43269, 3195600896, 3195609087, 'CL', 'CHL', 'تشيلي'),
(43270, 3195617280, 3195633663, 'CL', 'CHL', 'تشيلي'),
(43271, 3195633664, 3195637759, 'CO', 'COL', 'كولومبيا'),
(43272, 3195641856, 3195645951, 'PY', 'PRY', 'باراغواي'),
(43273, 3195650048, 3195654143, 'GT', 'GTM', 'غواتيمالا'),
(43274, 3195658240, 3195662335, 'VE', 'VEN', 'فنزويلا'),
(43275, 3195666432, 3195678719, 'AR', 'ARG', 'الأرجنتين'),
(43276, 3195682816, 3195686911, 'AR', 'ARG', 'الأرجنتين'),
(43277, 3195691008, 3195695103, 'DO', 'DOM', 'الدومينيكان'),
(43278, 3195699200, 3195703295, 'AR', 'ARG', 'الأرجنتين'),
(43279, 3195707392, 3195711487, 'PA', 'PAN', 'بنما'),
(43280, 3195715584, 3195719679, 'AR', 'ARG', 'الأرجنتين'),
(43281, 3195723776, 3195731967, 'AR', 'ARG', 'الأرجنتين'),
(43282, 3195731968, 3195736063, 'EC', 'ECU', 'الإكوادور'),
(43283, 3195740160, 3195744255, 'PA', 'PAN', 'بنما'),
(43284, 3195748352, 3195752447, 'CL', 'CHL', 'تشيلي'),
(43285, 3195756544, 3195760639, 'AR', 'ARG', 'الأرجنتين'),
(43286, 3195764736, 3195768831, 'CR', 'CRI', 'كوستا ريكا'),
(43287, 3195772928, 3195777023, 'VE', 'VEN', 'فنزويلا'),
(43288, 3195781120, 3195785215, 'PA', 'PAN', 'بنما'),
(43289, 3195789312, 3195793407, 'PA', 'PAN', 'بنما'),
(43290, 3195797504, 3195801599, 'AR', 'ARG', 'الأرجنتين'),
(43291, 3195805696, 3195807743, 'NI', 'NIC', 'نيكاراغوا'),
(43292, 3195807744, 3195809791, 'BZ', 'BLZ', 'بليز'),
(43293, 3195809792, 3195811839, 'PE', 'PER', 'بيرو'),
(43294, 3195811840, 3195813887, 'AR', 'ARG', 'الأرجنتين'),
(43295, 3195813888, 3195822079, 'DO', 'DOM', 'الدومينيكان'),
(43296, 3195830272, 3195834367, 'AR', 'ARG', 'الأرجنتين'),
(43297, 3195838464, 3195840511, 'HN', 'HND', 'هندوراس'),
(43298, 3195846656, 3195852799, 'AR', 'ARG', 'الأرجنتين'),
(43299, 3195852800, 3195853823, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43300, 3195853824, 3195854847, 'GY', 'GUY', 'غيانا'),
(43301, 3195854848, 3195859967, 'AR', 'ARG', 'الأرجنتين'),
(43302, 3195859968, 3195862015, 'CR', 'CRI', 'كوستا ريكا'),
(43303, 3195862016, 3195863039, 'AR', 'ARG', 'الأرجنتين'),
(43304, 3195863040, 3196092415, 'CO', 'COL', 'كولومبيا'),
(43305, 3196092416, 3196125183, 'PY', 'PRY', 'باراغواي'),
(43306, 3196125184, 3196190719, 'BO', 'BOL', 'بوليفيا'),
(43307, 3196190720, 3196207103, 'HN', 'HND', 'هندوراس'),
(43308, 3196256256, 3196305407, 'EC', 'ECU', 'الإكوادور'),
(43309, 3196321792, 3196583935, 'UY', 'URY', 'الأوروغواي'),
(43310, 3196583936, 3196690687, 'AR', 'ARG', 'الأرجنتين'),
(43311, 3196690688, 3196690943, 'UY', 'URY', 'الأوروغواي'),
(43312, 3196690944, 3196807359, 'AR', 'ARG', 'الأرجنتين'),
(43313, 3196807360, 3196807367, 'AW', 'ABW', 'أروبا'),
(43314, 3196807368, 3196846079, 'AR', 'ARG', 'الأرجنتين'),
(43315, 3196846080, 3196874431, 'PA', 'PAN', 'بنما'),
(43316, 3196874432, 3196874447, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(43317, 3196874448, 3196977151, 'PA', 'PAN', 'بنما'),
(43318, 3196977152, 3197042687, 'VE', 'VEN', 'فنزويلا'),
(43319, 3197042688, 3197075455, 'CO', 'COL', 'كولومبيا'),
(43320, 3197075456, 3197091839, 'GT', 'GTM', 'غواتيمالا'),
(43321, 3197108224, 3197370367, 'CO', 'COL', 'كولومبيا'),
(43322, 3197370368, 3197501439, 'GT', 'GTM', 'غواتيمالا'),
(43323, 3197501440, 3197534207, 'SV', 'SLV', 'السلفادور'),
(43324, 3197566976, 3197599743, 'CL', 'CHL', 'تشيلي'),
(43325, 3197632512, 3197698047, 'EC', 'ECU', 'الإكوادور'),
(43326, 3197698048, 3197730815, 'VE', 'VEN', 'فنزويلا'),
(43327, 3197763584, 3197894655, 'EC', 'ECU', 'الإكوادور'),
(43328, 3197894656, 3198156799, 'CO', 'COL', 'كولومبيا'),
(43329, 3198156800, 3198484479, 'CL', 'CHL', 'تشيلي'),
(43330, 3198484480, 3198500863, 'CO', 'COL', 'كولومبيا'),
(43331, 3198517248, 3198550015, 'CO', 'COL', 'كولومبيا'),
(43332, 3198550016, 3198681087, 'DO', 'DOM', 'الدومينيكان'),
(43333, 3198681088, 3198877695, 'VE', 'VEN', 'فنزويلا'),
(43334, 3198943232, 3199467519, 'AR', 'ARG', 'الأرجنتين'),
(43335, 3199467520, 3199467775, 'US', 'USA', 'الولايات المتحدة'),
(43336, 3199467776, 3199506687, 'AR', 'ARG', 'الأرجنتين'),
(43337, 3199506688, 3199506943, 'US', 'USA', 'الولايات المتحدة'),
(43338, 3199506944, 3199518719, 'AR', 'ARG', 'الأرجنتين'),
(43339, 3199518720, 3199518975, 'US', 'USA', 'الولايات المتحدة'),
(43340, 3199518976, 3199533055, 'AR', 'ARG', 'الأرجنتين'),
(43341, 3199533056, 3199549439, 'BO', 'BOL', 'بوليفيا'),
(43342, 3199598592, 3199631359, 'CO', 'COL', 'كولومبيا'),
(43343, 3199664128, 3199729663, 'AR', 'ARG', 'الأرجنتين'),
(43344, 3199729664, 3199762431, 'NI', 'NIC', 'نيكاراغوا'),
(43345, 3199795200, 3199815679, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43346, 3199860736, 3199909887, 'BO', 'BOL', 'بوليفيا'),
(43347, 3199926272, 3199991807, 'PE', 'PER', 'بيرو'),
(43348, 3199991808, 3200385023, 'AR', 'ARG', 'الأرجنتين'),
(43349, 3200516096, 3200565247, 'CL', 'CHL', 'تشيلي'),
(43350, 3200581632, 3200614399, 'BZ', 'BLZ', 'بليز'),
(43351, 3200614400, 3200647167, 'AR', 'ARG', 'الأرجنتين'),
(43352, 3200647168, 3201302527, 'VE', 'VEN', 'فنزويلا'),
(43353, 3201302528, 3201433599, 'CL', 'CHL', 'تشيلي'),
(43354, 3201433600, 3201435135, 'AR', 'ARG', 'الأرجنتين'),
(43355, 3201435136, 3201435263, 'US', 'USA', 'الولايات المتحدة'),
(43356, 3201435264, 3201435559, 'AR', 'ARG', 'الأرجنتين'),
(43357, 3201435560, 3201435567, 'US', 'USA', 'الولايات المتحدة'),
(43358, 3201435568, 3201441791, 'AR', 'ARG', 'الأرجنتين'),
(43359, 3201441792, 3201442047, 'US', 'USA', 'الولايات المتحدة'),
(43360, 3201442048, 3201482751, 'AR', 'ARG', 'الأرجنتين'),
(43361, 3201564672, 3201630207, 'NI', 'NIC', 'نيكاراغوا'),
(43362, 3201630208, 3201695743, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(43363, 3201695744, 3201761279, 'EC', 'ECU', 'الإكوادور'),
(43364, 3201826816, 3201867775, 'AR', 'ARG', 'الأرجنتين'),
(43365, 3201867776, 3201871871, 'PE', 'PER', 'بيرو'),
(43366, 3201871872, 3201875967, 'AR', 'ARG', 'الأرجنتين'),
(43367, 3201875968, 3201880063, 'CO', 'COL', 'كولومبيا'),
(43368, 3201880064, 3201884159, 'EC', 'ECU', 'الإكوادور'),
(43369, 3201884160, 3201888255, 'AR', 'ARG', 'الأرجنتين'),
(43370, 3201888256, 3201892351, 'VE', 'VEN', 'فنزويلا'),
(43371, 3201957888, 3202023423, 'PA', 'PAN', 'بنما'),
(43372, 3202088960, 3202127999, 'AR', 'ARG', 'الأرجنتين'),
(43373, 3202128000, 3202128015, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43374, 3202128016, 3202220031, 'AR', 'ARG', 'الأرجنتين'),
(43375, 3202220032, 3202351103, 'PE', 'PER', 'بيرو'),
(43376, 3202351104, 3202444455, 'AR', 'ARG', 'الأرجنتين'),
(43377, 3202444456, 3202444463, 'BR', 'BRA', 'البرازيل'),
(43378, 3202444464, 3202495495, 'AR', 'ARG', 'الأرجنتين'),
(43379, 3202495496, 3202495503, 'AW', 'ABW', 'أروبا'),
(43380, 3202495504, 3202647039, 'AR', 'ARG', 'الأرجنتين'),
(43381, 3202647040, 3202647295, 'AW', 'ABW', 'أروبا'),
(43382, 3202647296, 3202875391, 'AR', 'ARG', 'الأرجنتين'),
(43383, 3202875392, 3203137535, 'PE', 'PER', 'بيرو'),
(43384, 3203399680, 3203432447, 'CO', 'COL', 'كولومبيا'),
(43385, 3203465216, 3203530751, 'CR', 'CRI', 'كوستا ريكا'),
(43386, 3203530752, 3203531519, 'CO', 'COL', 'كولومبيا'),
(43387, 3203531520, 3203531775, 'PA', 'PAN', 'بنما'),
(43388, 3203531776, 3203532287, 'CO', 'COL', 'كولومبيا'),
(43389, 3203532288, 3203534847, 'PA', 'PAN', 'بنما'),
(43390, 3203534848, 3203535359, 'CO', 'COL', 'كولومبيا'),
(43391, 3203535360, 3203535423, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(43392, 3203535424, 3203535871, 'CO', 'COL', 'كولومبيا'),
(43393, 3203535872, 3203536383, 'PA', 'PAN', 'بنما'),
(43394, 3203536384, 3203547135, 'CO', 'COL', 'كولومبيا'),
(43395, 3203547136, 3203549183, 'PA', 'PAN', 'بنما'),
(43396, 3203549184, 3203596287, 'CO', 'COL', 'كولومبيا'),
(43397, 3203661824, 3203923967, 'AR', 'ARG', 'الأرجنتين'),
(43398, 3203923968, 3204055039, 'CO', 'COL', 'كولومبيا'),
(43399, 3204186112, 3204448255, 'CO', 'COL', 'كولومبيا'),
(43400, 3221225472, 3221225727, 'US', 'USA', 'الولايات المتحدة'),
(43401, 3221225984, 3221226239, 'US', 'USA', 'الولايات المتحدة'),
(43402, 3221233664, 3221237759, 'US', 'USA', 'الولايات المتحدة'),
(43403, 3221291008, 3221422079, 'US', 'USA', 'الولايات المتحدة'),
(43404, 3221487616, 3221553151, 'US', 'USA', 'الولايات المتحدة'),
(43405, 3221553664, 3221555967, 'US', 'USA', 'الولايات المتحدة'),
(43406, 3221556224, 3221560319, 'US', 'USA', 'الولايات المتحدة'),
(43407, 3221560320, 3221561087, 'GB', 'GBR', 'المملكة المتحدة'),
(43408, 3221561344, 3221562367, 'US', 'USA', 'الولايات المتحدة'),
(43409, 3221562368, 3221562623, 'SE', 'SWE', 'السويد'),
(43410, 3221562624, 3221564927, 'US', 'USA', 'الولايات المتحدة'),
(43411, 3221565184, 3221565951, 'US', 'USA', 'الولايات المتحدة'),
(43412, 3221565952, 3221566207, 'SE', 'SWE', 'السويد'),
(43413, 3221566464, 3221567743, 'US', 'USA', 'الولايات المتحدة'),
(43414, 3221568256, 3221568511, 'FR', 'FRA', 'فرنسا'),
(43415, 3221568768, 3221569279, 'FR', 'FRA', 'فرنسا'),
(43416, 3221569280, 3221570559, 'US', 'USA', 'الولايات المتحدة'),
(43417, 3221571072, 3221571327, 'US', 'USA', 'الولايات المتحدة'),
(43418, 3221571584, 3221576191, 'US', 'USA', 'الولايات المتحدة'),
(43419, 3221576192, 3221576447, 'KR', 'KOR', 'جمهورية كوريا'),
(43420, 3221576448, 3221577727, 'US', 'USA', 'الولايات المتحدة'),
(43421, 3221577728, 3221577983, 'CA', 'CAN', 'كندا'),
(43422, 3221577984, 3221578239, 'IT', 'ITA', 'إيطاليا'),
(43423, 3221578240, 3221579775, 'US', 'USA', 'الولايات المتحدة'),
(43424, 3221580032, 3221589503, 'US', 'USA', 'الولايات المتحدة'),
(43425, 3221589504, 3221589759, 'FR', 'FRA', 'فرنسا'),
(43426, 3221589760, 3221590015, 'US', 'USA', 'الولايات المتحدة'),
(43427, 3221590016, 3221590271, 'CA', 'CAN', 'كندا'),
(43428, 3221590272, 3221590527, 'DE', 'DEU', 'ألمانيا'),
(43429, 3221590528, 3221591807, 'US', 'USA', 'الولايات المتحدة'),
(43430, 3221592064, 3221592575, 'US', 'USA', 'الولايات المتحدة'),
(43431, 3221593088, 3221594623, 'US', 'USA', 'الولايات المتحدة'),
(43432, 3221594624, 3221594879, 'AT', 'AUT', 'النمسا'),
(43433, 3221594880, 3221605119, 'US', 'USA', 'الولايات المتحدة'),
(43434, 3221605376, 3221605887, 'CA', 'CAN', 'كندا'),
(43435, 3221605888, 3221607167, 'US', 'USA', 'الولايات المتحدة'),
(43436, 3221607424, 3221608447, 'US', 'USA', 'الولايات المتحدة'),
(43437, 3221608448, 3221608703, 'JP', 'JPN', 'اليابان'),
(43438, 3221608704, 3221609727, 'US', 'USA', 'الولايات المتحدة'),
(43439, 3221610240, 3221614335, 'US', 'USA', 'الولايات المتحدة'),
(43440, 3221614336, 3221614591, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(43441, 3221614592, 3221614847, 'AU', 'AUS', 'أستراليا'),
(43442, 3221615104, 3221618175, 'US', 'USA', 'الولايات المتحدة'),
(43443, 3221618176, 3221618431, 'GB', 'GBR', 'المملكة المتحدة'),
(43444, 3221618688, 3221621247, 'US', 'USA', 'الولايات المتحدة'),
(43445, 3221621248, 3221621503, 'GB', 'GBR', 'المملكة المتحدة'),
(43446, 3221621504, 3221627391, 'US', 'USA', 'الولايات المتحدة'),
(43447, 3221627392, 3221627647, 'FR', 'FRA', 'فرنسا'),
(43448, 3221627648, 3221633279, 'US', 'USA', 'الولايات المتحدة'),
(43449, 3221633280, 3221633535, 'CH', 'CHE', 'سويسرا'),
(43450, 3221633536, 3221633791, 'US', 'USA', 'الولايات المتحدة'),
(43451, 3221633792, 3221634047, 'CH', 'CHE', 'سويسرا'),
(43452, 3221634048, 3221636607, 'US', 'USA', 'الولايات المتحدة'),
(43453, 3221636608, 3221636863, 'CH', 'CHE', 'سويسرا'),
(43454, 3221636864, 3221637119, 'US', 'USA', 'الولايات المتحدة'),
(43455, 3221637120, 3221637375, 'DE', 'DEU', 'ألمانيا'),
(43456, 3221637376, 3221638143, 'US', 'USA', 'الولايات المتحدة'),
(43457, 3221638144, 3221638399, 'DE', 'DEU', 'ألمانيا'),
(43458, 3221638400, 3221640191, 'US', 'USA', 'الولايات المتحدة'),
(43459, 3221640192, 3221640447, 'NL', 'NLD', 'هولندا'),
(43460, 3221640448, 3221642495, 'US', 'USA', 'الولايات المتحدة'),
(43461, 3221642496, 3221642751, 'DE', 'DEU', 'ألمانيا'),
(43462, 3221642752, 3221647103, 'US', 'USA', 'الولايات المتحدة'),
(43463, 3221647104, 3221647359, 'FR', 'FRA', 'فرنسا'),
(43464, 3221647360, 3221650943, 'US', 'USA', 'الولايات المتحدة'),
(43465, 3221650944, 3221651199, 'GB', 'GBR', 'المملكة المتحدة'),
(43466, 3221651200, 3221654783, 'US', 'USA', 'الولايات المتحدة'),
(43467, 3221654784, 3221655039, 'FR', 'FRA', 'فرنسا'),
(43468, 3221655040, 3221663743, 'US', 'USA', 'الولايات المتحدة'),
(43469, 3221663744, 3221663999, 'DE', 'DEU', 'ألمانيا'),
(43470, 3221664000, 3221664255, 'NL', 'NLD', 'هولندا'),
(43471, 3221664256, 3221664511, 'US', 'USA', 'الولايات المتحدة'),
(43472, 3221664512, 3221664767, 'GB', 'GBR', 'المملكة المتحدة'),
(43473, 3221664768, 3221866495, 'US', 'USA', 'الولايات المتحدة'),
(43474, 3221866752, 3221880575, 'US', 'USA', 'الولايات المتحدة'),
(43475, 3221880832, 3222011903, 'US', 'USA', 'الولايات المتحدة'),
(43476, 3222012160, 3222012415, 'GB', 'GBR', 'المملكة المتحدة'),
(43477, 3222012672, 3222016511, 'US', 'USA', 'الولايات المتحدة'),
(43478, 3222016768, 3222017023, 'US', 'USA', 'الولايات المتحدة'),
(43479, 3222017536, 3222017791, 'US', 'USA', 'الولايات المتحدة'),
(43480, 3222018048, 3222018559, 'US', 'USA', 'الولايات المتحدة'),
(43481, 3222018816, 3222019839, 'US', 'USA', 'الولايات المتحدة'),
(43482, 3222020096, 3222022399, 'US', 'USA', 'الولايات المتحدة'),
(43483, 3222022656, 3222023423, 'US', 'USA', 'الولايات المتحدة'),
(43484, 3222023936, 3222024191, 'IT', 'ITA', 'إيطاليا'),
(43485, 3222024192, 3222024959, 'US', 'USA', 'الولايات المتحدة'),
(43486, 3222025216, 3222025727, 'US', 'USA', 'الولايات المتحدة'),
(43487, 3222025728, 3222025983, 'NL', 'NLD', 'هولندا'),
(43488, 3222026240, 3222027775, 'US', 'USA', 'الولايات المتحدة'),
(43489, 3222027776, 3222028031, 'CA', 'CAN', 'كندا'),
(43490, 3222028032, 3222030335, 'US', 'USA', 'الولايات المتحدة'),
(43491, 3222030336, 3222030847, 'GB', 'GBR', 'المملكة المتحدة'),
(43492, 3222030848, 3222031359, 'US', 'USA', 'الولايات المتحدة'),
(43493, 3222031360, 3222031615, 'AU', 'AUS', 'أستراليا'),
(43494, 3222031616, 3222031871, 'IT', 'ITA', 'إيطاليا'),
(43495, 3222031872, 3222032639, 'US', 'USA', 'الولايات المتحدة'),
(43496, 3222032640, 3222032895, 'DE', 'DEU', 'ألمانيا'),
(43497, 3222032896, 3222036479, 'US', 'USA', 'الولايات المتحدة'),
(43498, 3222036480, 3222036735, 'FR', 'FRA', 'فرنسا'),
(43499, 3222036736, 3222036991, 'US', 'USA', 'الولايات المتحدة'),
(43500, 3222036992, 3222037247, 'CA', 'CAN', 'كندا'),
(43501, 3222037248, 3222037503, 'GB', 'GBR', 'المملكة المتحدة'),
(43502, 3222037504, 3222038271, 'US', 'USA', 'الولايات المتحدة'),
(43503, 3222039808, 3222044671, 'US', 'USA', 'الولايات المتحدة'),
(43504, 3222044928, 3222045183, 'CA', 'CAN', 'كندا'),
(43505, 3222045184, 3222048767, 'US', 'USA', 'الولايات المتحدة'),
(43506, 3222049024, 3222049279, 'US', 'USA', 'الولايات المتحدة'),
(43507, 3222050304, 3222051327, 'US', 'USA', 'الولايات المتحدة'),
(43508, 3222051584, 3222055935, 'US', 'USA', 'الولايات المتحدة'),
(43509, 3222056192, 3222056447, 'US', 'USA', 'الولايات المتحدة'),
(43510, 3222056448, 3222059007, 'CA', 'CAN', 'كندا'),
(43511, 3222059008, 3222061055, 'US', 'USA', 'الولايات المتحدة'),
(43512, 3222061056, 3222061823, 'IT', 'ITA', 'إيطاليا'),
(43513, 3222061824, 3222066943, 'US', 'USA', 'الولايات المتحدة'),
(43514, 3222066944, 3222067199, 'CA', 'CAN', 'كندا'),
(43515, 3222067200, 3222067455, 'US', 'USA', 'الولايات المتحدة'),
(43516, 3222067456, 3222067967, 'CH', 'CHE', 'سويسرا'),
(43517, 3222068224, 3222068479, 'US', 'USA', 'الولايات المتحدة'),
(43518, 3222068992, 3222071039, 'US', 'USA', 'الولايات المتحدة'),
(43519, 3222071040, 3222071295, 'GB', 'GBR', 'المملكة المتحدة'),
(43520, 3222071296, 3222071551, 'PT', 'PRT', 'البورتوغال'),
(43521, 3222071552, 3222072063, 'US', 'USA', 'الولايات المتحدة'),
(43522, 3222072064, 3222072319, 'SE', 'SWE', 'السويد'),
(43523, 3222072576, 3222075135, 'US', 'USA', 'الولايات المتحدة'),
(43524, 3222075136, 3222075391, 'CH', 'CHE', 'سويسرا'),
(43525, 3222075392, 3222075903, 'US', 'USA', 'الولايات المتحدة'),
(43526, 3222076160, 3222274047, 'US', 'USA', 'الولايات المتحدة'),
(43527, 3222292480, 3222292735, 'US', 'USA', 'الولايات المتحدة'),
(43528, 3222292992, 3222305535, 'US', 'USA', 'الولايات المتحدة'),
(43529, 3222305536, 3222309119, 'SE', 'SWE', 'السويد'),
(43530, 3222309376, 3222313727, 'SE', 'SWE', 'السويد'),
(43531, 3222313728, 3222316799, 'CH', 'CHE', 'سويسرا'),
(43532, 3222316800, 3222318591, 'US', 'USA', 'الولايات المتحدة'),
(43533, 3222318848, 3222319615, 'US', 'USA', 'الولايات المتحدة'),
(43534, 3222319616, 3222320127, 'JP', 'JPN', 'اليابان'),
(43535, 3222320128, 3222320383, 'AU', 'AUS', 'أستراليا'),
(43536, 3222320384, 3222320895, 'US', 'USA', 'الولايات المتحدة'),
(43537, 3222320896, 3222326015, 'NL', 'NLD', 'هولندا'),
(43538, 3222326016, 3222326527, 'US', 'USA', 'الولايات المتحدة'),
(43539, 3222326528, 3222339583, 'CA', 'CAN', 'كندا'),
(43540, 3222339584, 3222455039, 'US', 'USA', 'الولايات المتحدة'),
(43541, 3222455040, 3222455295, 'GB', 'GBR', 'المملكة المتحدة'),
(43542, 3222455296, 3222868735, 'US', 'USA', 'الولايات المتحدة'),
(43543, 3222868736, 3222868991, 'DE', 'DEU', 'ألمانيا'),
(43544, 3222868992, 3222869503, 'US', 'USA', 'الولايات المتحدة'),
(43545, 3222869504, 3222869759, 'GB', 'GBR', 'المملكة المتحدة'),
(43546, 3222869760, 3222893311, 'US', 'USA', 'الولايات المتحدة'),
(43547, 3222893824, 3222931711, 'US', 'USA', 'الولايات المتحدة'),
(43548, 3222931968, 3222934527, 'US', 'USA', 'الولايات المتحدة'),
(43549, 3222934784, 3222936319, 'US', 'USA', 'الولايات المتحدة'),
(43550, 3222936576, 3222940927, 'CH', 'CHE', 'سويسرا'),
(43551, 3222940928, 3222941183, 'GB', 'GBR', 'المملكة المتحدة'),
(43552, 3222941184, 3222941695, 'CH', 'CHE', 'سويسرا'),
(43553, 3222941696, 3222952703, 'US', 'USA', 'الولايات المتحدة'),
(43554, 3222952704, 3222952959, 'JP', 'JPN', 'اليابان'),
(43555, 3222952960, 3222953215, 'US', 'USA', 'الولايات المتحدة'),
(43556, 3222953216, 3222953727, 'JP', 'JPN', 'اليابان'),
(43557, 3222953728, 3222953983, 'US', 'USA', 'الولايات المتحدة'),
(43558, 3222953984, 3222954239, 'JP', 'JPN', 'اليابان'),
(43559, 3222954240, 3222954495, 'US', 'USA', 'الولايات المتحدة'),
(43560, 3222955008, 3222956031, 'US', 'USA', 'الولايات المتحدة'),
(43561, 3222956288, 3222962431, 'FI', 'FIN', 'فنلندا'),
(43562, 3222963456, 3222964223, 'FI', 'FIN', 'فنلندا'),
(43563, 3222964224, 3222964479, 'US', 'USA', 'الولايات المتحدة'),
(43564, 3222967040, 3222968831, 'US', 'USA', 'الولايات المتحدة'),
(43565, 3222968832, 3222973951, 'NL', 'NLD', 'هولندا'),
(43566, 3222973952, 3222979071, 'DE', 'DEU', 'ألمانيا'),
(43567, 3222979072, 3222983167, 'US', 'USA', 'الولايات المتحدة'),
(43568, 3222983168, 3222983935, 'CA', 'CAN', 'كندا'),
(43569, 3222983936, 3222984447, 'US', 'USA', 'الولايات المتحدة'),
(43570, 3222984448, 3222988543, 'AU', 'AUS', 'أستراليا'),
(43571, 3222988544, 3222988799, 'PT', 'PRT', 'البورتوغال'),
(43572, 3222988800, 3222989055, 'AU', 'AUS', 'أستراليا'),
(43573, 3222989056, 3222989311, 'US', 'USA', 'الولايات المتحدة'),
(43574, 3222989312, 3222989567, 'GB', 'GBR', 'المملكة المتحدة'),
(43575, 3222989568, 3222989823, 'CA', 'CAN', 'كندا'),
(43576, 3222989824, 3222990079, 'PT', 'PRT', 'البورتوغال'),
(43577, 3222990080, 3222990335, 'NL', 'NLD', 'هولندا'),
(43578, 3222990336, 3222990591, 'AT', 'AUT', 'النمسا'),
(43579, 3222990592, 3222990847, 'PT', 'PRT', 'البورتوغال'),
(43580, 3222990848, 3222994687, 'US', 'USA', 'الولايات المتحدة'),
(43581, 3222994944, 3223191551, 'US', 'USA', 'الولايات المتحدة'),
(43582, 3223201024, 3223201279, 'US', 'USA', 'الولايات المتحدة'),
(43583, 3223202816, 3223203071, 'US', 'USA', 'الولايات المتحدة'),
(43584, 3223204352, 3223204607, 'US', 'USA', 'الولايات المتحدة'),
(43585, 3223205120, 3223205375, 'US', 'USA', 'الولايات المتحدة'),
(43586, 3223207168, 3223207423, 'US', 'USA', 'الولايات المتحدة'),
(43587, 3223214848, 3223215871, 'US', 'USA', 'الولايات المتحدة'),
(43588, 3223216128, 3223216383, 'US', 'USA', 'الولايات المتحدة'),
(43589, 3223217152, 3223217407, 'US', 'USA', 'الولايات المتحدة'),
(43590, 3223219200, 3223219455, 'US', 'USA', 'الولايات المتحدة'),
(43591, 3223220480, 3223220735, 'US', 'USA', 'الولايات المتحدة'),
(43592, 3223220992, 3223221247, 'US', 'USA', 'الولايات المتحدة'),
(43593, 3223222784, 3223223039, 'US', 'USA', 'الولايات المتحدة'),
(43594, 3223223552, 3223223807, 'US', 'USA', 'الولايات المتحدة'),
(43595, 3223227904, 3223228159, 'CA', 'CAN', 'كندا'),
(43596, 3223229184, 3223229695, 'US', 'USA', 'الولايات المتحدة'),
(43597, 3223229696, 3223229951, 'CA', 'CAN', 'كندا'),
(43598, 3223240448, 3223240703, 'US', 'USA', 'الولايات المتحدة'),
(43599, 3223242752, 3223243007, 'US', 'USA', 'الولايات المتحدة'),
(43600, 3223243264, 3223243519, 'CA', 'CAN', 'كندا'),
(43601, 3223244288, 3223245311, 'US', 'USA', 'الولايات المتحدة'),
(43602, 3223249408, 3223249663, 'CA', 'CAN', 'كندا'),
(43603, 3223254784, 3223255295, 'US', 'USA', 'الولايات المتحدة'),
(43604, 3223257088, 3223258623, 'US', 'USA', 'الولايات المتحدة'),
(43605, 3223258624, 3223258879, 'CA', 'CAN', 'كندا'),
(43606, 3223258880, 3223260671, 'US', 'USA', 'الولايات المتحدة'),
(43607, 3223260672, 3223260927, 'DE', 'DEU', 'ألمانيا'),
(43608, 3223261184, 3223262975, 'US', 'USA', 'الولايات المتحدة'),
(43609, 3223262976, 3223263231, 'BE', 'BEL', 'بلجيكا'),
(43610, 3223263232, 3223263743, 'US', 'USA', 'الولايات المتحدة'),
(43611, 3223263744, 3223263999, 'GB', 'GBR', 'المملكة المتحدة'),
(43612, 3223264000, 3223264255, 'FR', 'FRA', 'فرنسا'),
(43613, 3223264256, 3223265023, 'US', 'USA', 'الولايات المتحدة'),
(43614, 3223265024, 3223265279, 'GB', 'GBR', 'المملكة المتحدة'),
(43615, 3223265280, 3223267327, 'US', 'USA', 'الولايات المتحدة'),
(43616, 3223267328, 3223267583, 'BE', 'BEL', 'بلجيكا'),
(43617, 3223267584, 3223269119, 'US', 'USA', 'الولايات المتحدة'),
(43618, 3223269376, 3223269631, 'US', 'USA', 'الولايات المتحدة'),
(43619, 3223272960, 3223273215, 'GB', 'GBR', 'المملكة المتحدة'),
(43620, 3223273216, 3223280383, 'US', 'USA', 'الولايات المتحدة'),
(43621, 3223280640, 3223280895, 'US', 'USA', 'الولايات المتحدة'),
(43622, 3223281408, 3223283199, 'US', 'USA', 'الولايات المتحدة'),
(43623, 3223283200, 3223283455, 'DE', 'DEU', 'ألمانيا'),
(43624, 3223283968, 3223284991, 'US', 'USA', 'الولايات المتحدة'),
(43625, 3223285504, 3223286783, 'US', 'USA', 'الولايات المتحدة'),
(43626, 3223286784, 3223289087, 'JP', 'JPN', 'اليابان'),
(43627, 3223294208, 3223297279, 'US', 'USA', 'الولايات المتحدة'),
(43628, 3223297536, 3223298815, 'US', 'USA', 'الولايات المتحدة'),
(43629, 3223299072, 3223299327, 'US', 'USA', 'الولايات المتحدة'),
(43630, 3223299584, 3223301119, 'NL', 'NLD', 'هولندا'),
(43631, 3223301120, 3223302399, 'US', 'USA', 'الولايات المتحدة'),
(43632, 3223303168, 3223303423, 'CA', 'CAN', 'كندا'),
(43633, 3223303424, 3223303679, 'US', 'USA', 'الولايات المتحدة'),
(43634, 3223305984, 3223307519, 'US', 'USA', 'الولايات المتحدة'),
(43635, 3223307520, 3223310079, 'JP', 'JPN', 'اليابان'),
(43636, 3223310080, 3223310335, 'US', 'USA', 'الولايات المتحدة'),
(43637, 3223310848, 3223311103, 'US', 'USA', 'الولايات المتحدة'),
(43638, 3223311104, 3223311359, 'FR', 'FRA', 'فرنسا'),
(43639, 3223311360, 3223311871, 'US', 'USA', 'الولايات المتحدة'),
(43640, 3223312128, 3223314431, 'US', 'USA', 'الولايات المتحدة'),
(43641, 3223314432, 3223314687, 'CA', 'CAN', 'كندا'),
(43642, 3223314688, 3223315455, 'US', 'USA', 'الولايات المتحدة'),
(43643, 3223315712, 3223316223, 'US', 'USA', 'الولايات المتحدة'),
(43644, 3223316224, 3223316479, 'NL', 'NLD', 'هولندا'),
(43645, 3223316480, 3223316991, 'US', 'USA', 'الولايات المتحدة'),
(43646, 3223317248, 3223317759, 'US', 'USA', 'الولايات المتحدة'),
(43647, 3223318016, 3223319039, 'US', 'USA', 'الولايات المتحدة'),
(43648, 3223319808, 3223321343, 'US', 'USA', 'الولايات المتحدة'),
(43649, 3223321600, 3223321855, 'FR', 'FRA', 'فرنسا'),
(43650, 3223321856, 3223322367, 'US', 'USA', 'الولايات المتحدة'),
(43651, 3223322624, 3223388159, 'US', 'USA', 'الولايات المتحدة'),
(43652, 3223388672, 3223390719, 'US', 'USA', 'الولايات المتحدة'),
(43653, 3223391232, 3223391999, 'US', 'USA', 'الولايات المتحدة'),
(43654, 3223392000, 3223392255, 'FR', 'FRA', 'فرنسا'),
(43655, 3223392256, 3223392511, 'GB', 'GBR', 'المملكة المتحدة'),
(43656, 3223393024, 3223394047, 'US', 'USA', 'الولايات المتحدة'),
(43657, 3223396608, 3223396863, 'US', 'USA', 'الولايات المتحدة'),
(43658, 3223397120, 3223397375, 'US', 'USA', 'الولايات المتحدة'),
(43659, 3223397376, 3223397631, 'NL', 'NLD', 'هولندا'),
(43660, 3223397632, 3223410431, 'US', 'USA', 'الولايات المتحدة'),
(43661, 3223410432, 3223416831, 'CH', 'CHE', 'سويسرا'),
(43662, 3223416832, 3223417087, 'US', 'USA', 'الولايات المتحدة'),
(43663, 3223417088, 3223417599, 'FR', 'FRA', 'فرنسا'),
(43664, 3223417600, 3223418367, 'US', 'USA', 'الولايات المتحدة'),
(43665, 3223418368, 3223420927, 'CH', 'CHE', 'سويسرا'),
(43666, 3223420928, 3223421439, 'US', 'USA', 'الولايات المتحدة'),
(43667, 3223421440, 3223421695, 'GB', 'GBR', 'المملكة المتحدة'),
(43668, 3223421696, 3223421951, 'NL', 'NLD', 'هولندا'),
(43669, 3223422464, 3223422719, 'US', 'USA', 'الولايات المتحدة'),
(43670, 3223422720, 3223422975, 'JP', 'JPN', 'اليابان'),
(43671, 3223423232, 3223423743, 'US', 'USA', 'الولايات المتحدة'),
(43672, 3223424000, 3223424767, 'US', 'USA', 'الولايات المتحدة'),
(43673, 3223424768, 3223425535, 'FR', 'FRA', 'فرنسا'),
(43674, 3223425792, 3223430911, 'FR', 'FRA', 'فرنسا'),
(43675, 3223431424, 3223432191, 'FR', 'FRA', 'فرنسا'),
(43676, 3223433216, 3223435007, 'FR', 'FRA', 'فرنسا'),
(43677, 3223435008, 3223437055, 'US', 'USA', 'الولايات المتحدة'),
(43678, 3223437312, 3223447551, 'CH', 'CHE', 'سويسرا'),
(43679, 3223447552, 3223447807, 'US', 'USA', 'الولايات المتحدة'),
(43680, 3223447808, 3223449599, 'NL', 'NLD', 'هولندا'),
(43681, 3223449600, 3223452671, 'US', 'USA', 'الولايات المتحدة'),
(43682, 3223452928, 3223453183, 'US', 'USA', 'الولايات المتحدة'),
(43683, 3223453184, 3223453439, 'DE', 'DEU', 'ألمانيا'),
(43684, 3223458560, 3223458815, 'GB', 'GBR', 'المملكة المتحدة'),
(43685, 3223460096, 3223460351, 'US', 'USA', 'الولايات المتحدة'),
(43686, 3223462656, 3223462911, 'US', 'USA', 'الولايات المتحدة'),
(43687, 3223466496, 3223466751, 'GB', 'GBR', 'المملكة المتحدة'),
(43688, 3223471616, 3223471871, 'CA', 'CAN', 'كندا'),
(43689, 3223471872, 3223472383, 'US', 'USA', 'الولايات المتحدة'),
(43690, 3223476736, 3223476991, 'US', 'USA', 'الولايات المتحدة'),
(43691, 3223481088, 3223481343, 'SE', 'SWE', 'السويد'),
(43692, 3223483392, 3223483647, 'NL', 'NLD', 'هولندا'),
(43693, 3223490816, 3223491071, 'US', 'USA', 'الولايات المتحدة'),
(43694, 3223496960, 3223497215, 'US', 'USA', 'الولايات المتحدة'),
(43695, 3223499520, 3223499775, 'FI', 'FIN', 'فنلندا'),
(43696, 3223500032, 3223503871, 'CA', 'CAN', 'كندا'),
(43697, 3223504640, 3223504895, 'CA', 'CAN', 'كندا'),
(43698, 3223507968, 3223508223, 'US', 'USA', 'الولايات المتحدة'),
(43699, 3223508480, 3223508735, 'US', 'USA', 'الولايات المتحدة'),
(43700, 3223513344, 3223513599, 'US', 'USA', 'الولايات المتحدة'),
(43701, 3223514880, 3223515135, 'US', 'USA', 'الولايات المتحدة'),
(43702, 3223516160, 3223516415, 'US', 'USA', 'الولايات المتحدة'),
(43703, 3223516928, 3223517183, 'US', 'USA', 'الولايات المتحدة'),
(43704, 3223519232, 3223524351, 'DE', 'DEU', 'ألمانيا'),
(43705, 3223524352, 3223534335, 'US', 'USA', 'الولايات المتحدة'),
(43706, 3223534336, 3223534591, 'AU', 'AUS', 'أستراليا'),
(43707, 3223534592, 3223534847, 'US', 'USA', 'الولايات المتحدة'),
(43708, 3223535104, 3223535359, 'US', 'USA', 'الولايات المتحدة'),
(43709, 3223535360, 3223537919, 'DE', 'DEU', 'ألمانيا'),
(43710, 3223537920, 3223540991, 'US', 'USA', 'الولايات المتحدة'),
(43711, 3223541248, 3223542271, 'US', 'USA', 'الولايات المتحدة'),
(43712, 3223542272, 3223542527, 'DE', 'DEU', 'ألمانيا'),
(43713, 3223542528, 3223543295, 'US', 'USA', 'الولايات المتحدة'),
(43714, 3223543296, 3223543551, 'GB', 'GBR', 'المملكة المتحدة'),
(43715, 3223543552, 3223545855, 'US', 'USA', 'الولايات المتحدة'),
(43716, 3223546112, 3223546879, 'US', 'USA', 'الولايات المتحدة'),
(43717, 3223546880, 3223547135, 'GB', 'GBR', 'المملكة المتحدة'),
(43718, 3223547136, 3223551743, 'US', 'USA', 'الولايات المتحدة'),
(43719, 3223552000, 3223552511, 'US', 'USA', 'الولايات المتحدة'),
(43720, 3223552512, 3223553535, 'NL', 'NLD', 'هولندا'),
(43721, 3223553536, 3223554559, 'US', 'USA', 'الولايات المتحدة'),
(43722, 3223554560, 3223554815, 'GB', 'GBR', 'المملكة المتحدة'),
(43723, 3223555328, 3223556095, 'US', 'USA', 'الولايات المتحدة'),
(43724, 3223556096, 3223556351, 'CA', 'CAN', 'كندا'),
(43725, 3223556352, 3223556607, 'US', 'USA', 'الولايات المتحدة'),
(43726, 3223556608, 3223556863, 'IT', 'ITA', 'إيطاليا'),
(43727, 3223556864, 3223557375, 'US', 'USA', 'الولايات المتحدة'),
(43728, 3223557376, 3223558655, 'DE', 'DEU', 'ألمانيا'),
(43729, 3223558656, 3223559423, 'US', 'USA', 'الولايات المتحدة'),
(43730, 3223559936, 3223563263, 'US', 'USA', 'الولايات المتحدة'),
(43731, 3223563264, 3223563519, 'GB', 'GBR', 'المملكة المتحدة'),
(43732, 3223563520, 3223565567, 'US', 'USA', 'الولايات المتحدة'),
(43733, 3223565824, 3223566079, 'US', 'USA', 'الولايات المتحدة'),
(43734, 3223566080, 3223568639, 'NL', 'NLD', 'هولندا'),
(43735, 3223568640, 3223569663, 'US', 'USA', 'الولايات المتحدة'),
(43736, 3223569664, 3223570175, 'GB', 'GBR', 'المملكة المتحدة'),
(43737, 3223571456, 3223571711, 'US', 'USA', 'الولايات المتحدة'),
(43738, 3223571712, 3223572223, 'GB', 'GBR', 'المملكة المتحدة'),
(43739, 3223572224, 3223572479, 'IE', 'IRL', 'إيرلندا'),
(43740, 3223572480, 3223577855, 'US', 'USA', 'الولايات المتحدة'),
(43741, 3223577856, 3223578111, 'DE', 'DEU', 'ألمانيا'),
(43742, 3223578112, 3223580671, 'US', 'USA', 'الولايات المتحدة'),
(43743, 3223580672, 3223581951, 'AT', 'AUT', 'النمسا'),
(43744, 3223581952, 3223582207, 'US', 'USA', 'الولايات المتحدة'),
(43745, 3223582208, 3223582463, 'PT', 'PRT', 'البورتوغال'),
(43746, 3223582464, 3223582719, 'NL', 'NLD', 'هولندا'),
(43747, 3223582720, 3223582975, 'AU', 'AUS', 'أستراليا'),
(43748, 3223583488, 3223583743, 'US', 'USA', 'الولايات المتحدة'),
(43749, 3223584000, 3223584511, 'US', 'USA', 'الولايات المتحدة'),
(43750, 3223584768, 3223650303, 'SE', 'SWE', 'السويد'),
(43751, 3223650304, 3223715839, 'CH', 'CHE', 'سويسرا'),
(43752, 3223715840, 3223781375, 'DK', 'DNK', 'الدنيمارك'),
(43753, 3223781376, 3223823871, 'US', 'USA', 'الولايات المتحدة'),
(43754, 3223823872, 3223824127, 'AT', 'AUT', 'النمسا'),
(43755, 3223824128, 3223846911, 'US', 'USA', 'الولايات المتحدة'),
(43756, 3223848704, 3223852799, 'US', 'USA', 'الولايات المتحدة'),
(43757, 3223853312, 3223853567, 'US', 'USA', 'الولايات المتحدة'),
(43758, 3223854336, 3223854591, 'US', 'USA', 'الولايات المتحدة'),
(43759, 3223857920, 3223858175, 'US', 'USA', 'الولايات المتحدة'),
(43760, 3223858944, 3223859455, 'US', 'USA', 'الولايات المتحدة'),
(43761, 3223859968, 3223860223, 'US', 'USA', 'الولايات المتحدة'),
(43762, 3223860480, 3223860991, 'US', 'USA', 'الولايات المتحدة'),
(43763, 3223862528, 3223862783, 'US', 'USA', 'الولايات المتحدة'),
(43764, 3223863552, 3223863807, 'US', 'USA', 'الولايات المتحدة'),
(43765, 3223864576, 3223867647, 'FI', 'FIN', 'فنلندا'),
(43766, 3223874816, 3223875071, 'US', 'USA', 'الولايات المتحدة'),
(43767, 3223876608, 3223876863, 'US', 'USA', 'الولايات المتحدة'),
(43768, 3223883520, 3223883775, 'US', 'USA', 'الولايات المتحدة'),
(43769, 3223886592, 3223887103, 'US', 'USA', 'الولايات المتحدة'),
(43770, 3223887616, 3223887871, 'US', 'USA', 'الولايات المتحدة'),
(43771, 3223898368, 3223898623, 'US', 'USA', 'الولايات المتحدة'),
(43772, 3223902464, 3223902719, 'CA', 'CAN', 'كندا'),
(43773, 3223905280, 3223905535, 'FI', 'FIN', 'فنلندا'),
(43774, 3223909632, 3223910143, 'US', 'USA', 'الولايات المتحدة'),
(43775, 3223910400, 3223910911, 'US', 'USA', 'الولايات المتحدة'),
(43776, 3223911936, 3223912191, 'CA', 'CAN', 'كندا'),
(43777, 3223912448, 3223938559, 'US', 'USA', 'الولايات المتحدة'),
(43778, 3223938816, 3223946239, 'GB', 'GBR', 'المملكة المتحدة'),
(43779, 3223946240, 3223947519, 'CH', 'CHE', 'سويسرا'),
(43780, 3223947520, 3223947775, 'US', 'USA', 'الولايات المتحدة'),
(43781, 3223948288, 3223948543, 'NL', 'NLD', 'هولندا'),
(43782, 3223948544, 3223949823, 'CH', 'CHE', 'سويسرا'),
(43783, 3223949824, 3223950079, 'AU', 'AUS', 'أستراليا'),
(43784, 3223950080, 3223950335, 'DE', 'DEU', 'ألمانيا'),
(43785, 3223950336, 3223950591, 'CA', 'CAN', 'كندا'),
(43786, 3223950592, 3223953663, 'CH', 'CHE', 'سويسرا'),
(43787, 3223953664, 3223955967, 'US', 'USA', 'الولايات المتحدة'),
(43788, 3223955968, 3223956223, 'TH', 'THA', 'تايلند'),
(43789, 3223956224, 3223957759, 'US', 'USA', 'الولايات المتحدة'),
(43790, 3223958016, 3223963135, 'JP', 'JPN', 'اليابان'),
(43791, 3223963136, 3223963647, 'US', 'USA', 'الولايات المتحدة'),
(43792, 3223963904, 3223964159, 'CA', 'CAN', 'كندا'),
(43793, 3223964160, 3223964415, 'US', 'USA', 'الولايات المتحدة'),
(43794, 3223964416, 3223964671, 'AU', 'AUS', 'أستراليا'),
(43795, 3223964672, 3223965183, 'US', 'USA', 'الولايات المتحدة'),
(43796, 3223965184, 3223965439, 'ID', 'IDN', 'إندونيسيا'),
(43797, 3223965440, 3223966207, 'US', 'USA', 'الولايات المتحدة'),
(43798, 3223966208, 3223966463, 'GB', 'GBR', 'المملكة المتحدة'),
(43799, 3223966464, 3223967743, 'US', 'USA', 'الولايات المتحدة'),
(43800, 3223968000, 3223968255, 'US', 'USA', 'الولايات المتحدة'),
(43801, 3223968256, 3223968511, 'IT', 'ITA', 'إيطاليا'),
(43802, 3223968512, 3223970303, 'US', 'USA', 'الولايات المتحدة'),
(43803, 3223970560, 3223970815, 'DE', 'DEU', 'ألمانيا'),
(43804, 3223971072, 3223975935, 'US', 'USA', 'الولايات المتحدة'),
(43805, 3223976192, 3223977983, 'US', 'USA', 'الولايات المتحدة'),
(43806, 3223978240, 3223978495, 'DE', 'DEU', 'ألمانيا'),
(43807, 3223978752, 3223979263, 'US', 'USA', 'الولايات المتحدة'),
(43808, 3223979264, 3223979775, 'CA', 'CAN', 'كندا'),
(43809, 3223979776, 3223988735, 'US', 'USA', 'الولايات المتحدة'),
(43810, 3223988736, 3223990271, 'CH', 'CHE', 'سويسرا'),
(43811, 3223990272, 3223991295, 'US', 'USA', 'الولايات المتحدة'),
(43812, 3223991296, 3223991551, 'AU', 'AUS', 'أستراليا'),
(43813, 3223991552, 3223991807, 'GB', 'GBR', 'المملكة المتحدة'),
(43814, 3223991808, 3223992063, 'CA', 'CAN', 'كندا'),
(43815, 3223992064, 3223993343, 'US', 'USA', 'الولايات المتحدة'),
(43816, 3223993344, 3223994111, 'AU', 'AUS', 'أستراليا'),
(43817, 3223994112, 3223994623, 'DE', 'DEU', 'ألمانيا'),
(43818, 3223994624, 3223994879, 'NO', 'NOR', 'النرويج'),
(43819, 3223994880, 3223995391, 'US', 'USA', 'الولايات المتحدة'),
(43820, 3223995392, 3223995647, 'CA', 'CAN', 'كندا'),
(43821, 3223995648, 3223996159, 'US', 'USA', 'الولايات المتحدة'),
(43822, 3223997184, 3223999487, 'US', 'USA', 'الولايات المتحدة'),
(43823, 3223999488, 3224000255, 'JP', 'JPN', 'اليابان'),
(43824, 3224000256, 3224000511, 'GB', 'GBR', 'المملكة المتحدة'),
(43825, 3224000512, 3224001023, 'US', 'USA', 'الولايات المتحدة'),
(43826, 3224001024, 3224001279, 'CA', 'CAN', 'كندا'),
(43827, 3224001280, 3224002559, 'US', 'USA', 'الولايات المتحدة'),
(43828, 3224002816, 3224003327, 'US', 'USA', 'الولايات المتحدة'),
(43829, 3224003584, 3224003839, 'GB', 'GBR', 'المملكة المتحدة'),
(43830, 3224003840, 3224004095, 'US', 'USA', 'الولايات المتحدة'),
(43831, 3224004096, 3224004351, 'FR', 'FRA', 'فرنسا'),
(43832, 3224004352, 3224005631, 'JP', 'JPN', 'اليابان'),
(43833, 3224005632, 3224006143, 'US', 'USA', 'الولايات المتحدة'),
(43834, 3224006400, 3224006655, 'US', 'USA', 'الولايات المتحدة'),
(43835, 3224006912, 3224012031, 'NL', 'NLD', 'هولندا'),
(43836, 3224012032, 3224014591, 'US', 'USA', 'الولايات المتحدة'),
(43837, 3224014592, 3224014847, 'DE', 'DEU', 'ألمانيا'),
(43838, 3224014848, 3224015615, 'US', 'USA', 'الولايات المتحدة'),
(43839, 3224015872, 3224016639, 'US', 'USA', 'الولايات المتحدة'),
(43840, 3224016640, 3224016895, 'AU', 'AUS', 'أستراليا'),
(43841, 3224016896, 3224017663, 'US', 'USA', 'الولايات المتحدة'),
(43842, 3224017920, 3224022271, 'US', 'USA', 'الولايات المتحدة'),
(43843, 3224023808, 3224024063, 'US', 'USA', 'الولايات المتحدة'),
(43844, 3224024064, 3224029695, 'CH', 'CHE', 'سويسرا'),
(43845, 3224029696, 3224030463, 'CA', 'CAN', 'كندا'),
(43846, 3224030720, 3224030975, 'CA', 'CAN', 'كندا'),
(43847, 3224030976, 3224038655, 'US', 'USA', 'الولايات المتحدة'),
(43848, 3224038656, 3224038911, 'JP', 'JPN', 'اليابان'),
(43849, 3224038912, 3224039679, 'US', 'USA', 'الولايات المتحدة'),
(43850, 3224039936, 3224040959, 'US', 'USA', 'الولايات المتحدة'),
(43851, 3224041216, 3224042239, 'US', 'USA', 'الولايات المتحدة'),
(43852, 3224042496, 3224042751, 'US', 'USA', 'الولايات المتحدة'),
(43853, 3224042752, 3224043007, 'DE', 'DEU', 'ألمانيا'),
(43854, 3224043008, 3224043263, 'US', 'USA', 'الولايات المتحدة'),
(43855, 3224043776, 3224084991, 'US', 'USA', 'الولايات المتحدة'),
(43856, 3224084992, 3224087551, 'SE', 'SWE', 'السويد'),
(43857, 3224087552, 3224088063, 'US', 'USA', 'الولايات المتحدة'),
(43858, 3224088064, 3224088319, 'JP', 'JPN', 'اليابان'),
(43859, 3224088320, 3224090879, 'US', 'USA', 'الولايات المتحدة'),
(43860, 3224090880, 3224091135, 'AU', 'AUS', 'أستراليا'),
(43861, 3224091648, 3224091903, 'US', 'USA', 'الولايات المتحدة'),
(43862, 3224091904, 3224092159, 'JP', 'JPN', 'اليابان'),
(43863, 3224092416, 3224092671, 'US', 'USA', 'الولايات المتحدة'),
(43864, 3224092672, 3224093951, 'CH', 'CHE', 'سويسرا'),
(43865, 3224093952, 3224094207, 'US', 'USA', 'الولايات المتحدة'),
(43866, 3224094208, 3224094463, 'AU', 'AUS', 'أستراليا'),
(43867, 3224094464, 3224094975, 'US', 'USA', 'الولايات المتحدة'),
(43868, 3224094976, 3224095487, 'JP', 'JPN', 'اليابان'),
(43869, 3224095488, 3224096255, 'US', 'USA', 'الولايات المتحدة'),
(43870, 3224096512, 3224097279, 'AU', 'AUS', 'أستراليا'),
(43871, 3224097280, 3224097535, 'NL', 'NLD', 'هولندا'),
(43872, 3224097536, 3224097791, 'US', 'USA', 'الولايات المتحدة'),
(43873, 3224097792, 3224098047, 'NL', 'NLD', 'هولندا'),
(43874, 3224098048, 3224098559, 'US', 'USA', 'الولايات المتحدة'),
(43875, 3224098816, 3224099583, 'US', 'USA', 'الولايات المتحدة'),
(43876, 3224099584, 3224099839, 'CA', 'CAN', 'كندا'),
(43877, 3224099840, 3224100607, 'US', 'USA', 'الولايات المتحدة'),
(43878, 3224101120, 3224101375, 'US', 'USA', 'الولايات المتحدة'),
(43879, 3224101376, 3224102399, 'AU', 'AUS', 'أستراليا'),
(43880, 3224103424, 3224103679, 'GB', 'GBR', 'المملكة المتحدة'),
(43881, 3224103680, 3224104447, 'US', 'USA', 'الولايات المتحدة'),
(43882, 3224104704, 3224104959, 'AU', 'AUS', 'أستراليا'),
(43883, 3224104960, 3224105471, 'US', 'USA', 'الولايات المتحدة'),
(43884, 3224105728, 3224106495, 'US', 'USA', 'الولايات المتحدة'),
(43885, 3224106752, 3224108799, 'US', 'USA', 'الولايات المتحدة'),
(43886, 3224109056, 3224119551, 'DE', 'DEU', 'ألمانيا'),
(43887, 3224119552, 3224126463, 'FR', 'FRA', 'فرنسا'),
(43888, 3224127232, 3224129791, 'FR', 'FRA', 'فرنسا'),
(43889, 3224129792, 3224132351, 'DE', 'DEU', 'ألمانيا'),
(43890, 3224132352, 3224170495, 'US', 'USA', 'الولايات المتحدة'),
(43891, 3224170496, 3224173567, 'SE', 'SWE', 'السويد'),
(43892, 3224173568, 3224174335, 'US', 'USA', 'الولايات المتحدة'),
(43893, 3224174592, 3224258047, 'US', 'USA', 'الولايات المتحدة'),
(43894, 3224258048, 3224258303, 'FI', 'FIN', 'فنلندا'),
(43895, 3224258304, 3224258559, 'BE', 'BEL', 'بلجيكا'),
(43896, 3224258560, 3224305663, 'US', 'USA', 'الولايات المتحدة'),
(43897, 3224305664, 3224367615, 'JP', 'JPN', 'اليابان'),
(43898, 3224367616, 3224368127, 'US', 'USA', 'الولايات المتحدة'),
(43899, 3224368128, 3224369663, 'CH', 'CHE', 'سويسرا'),
(43900, 3224369664, 3224370431, 'US', 'USA', 'الولايات المتحدة'),
(43901, 3224370688, 3224370943, 'US', 'USA', 'الولايات المتحدة'),
(43902, 3224371200, 3224379135, 'US', 'USA', 'الولايات المتحدة'),
(43903, 3224379136, 3224379391, 'DE', 'DEU', 'ألمانيا'),
(43904, 3224379392, 3224392191, 'US', 'USA', 'الولايات المتحدة'),
(43905, 3224394752, 3224396287, 'US', 'USA', 'الولايات المتحدة'),
(43906, 3224396544, 3224397055, 'US', 'USA', 'الولايات المتحدة'),
(43907, 3224397824, 3224398079, 'US', 'USA', 'الولايات المتحدة'),
(43908, 3224398336, 3224398591, 'US', 'USA', 'الولايات المتحدة'),
(43909, 3224398592, 3224398847, 'DE', 'DEU', 'ألمانيا'),
(43910, 3224398848, 3224399103, 'US', 'USA', 'الولايات المتحدة'),
(43911, 3224399104, 3224399615, 'AU', 'AUS', 'أستراليا'),
(43912, 3224399616, 3224406015, 'US', 'USA', 'الولايات المتحدة'),
(43913, 3224406272, 3224406527, 'US', 'USA', 'الولايات المتحدة'),
(43914, 3224406784, 3224407039, 'US', 'USA', 'الولايات المتحدة'),
(43915, 3224407296, 3224407551, 'CA', 'CAN', 'كندا'),
(43916, 3224407808, 3224408319, 'US', 'USA', 'الولايات المتحدة'),
(43917, 3224408320, 3224408575, 'DE', 'DEU', 'ألمانيا'),
(43918, 3224408576, 3224424959, 'US', 'USA', 'الولايات المتحدة'),
(43919, 3224425216, 3224427007, 'US', 'USA', 'الولايات المتحدة'),
(43920, 3224427776, 3224428287, 'US', 'USA', 'الولايات المتحدة'),
(43921, 3224428544, 3224428799, 'DE', 'DEU', 'ألمانيا'),
(43922, 3224428800, 3224430079, 'US', 'USA', 'الولايات المتحدة'),
(43923, 3224430336, 3224430591, 'DE', 'DEU', 'ألمانيا'),
(43924, 3224430592, 3224430847, 'US', 'USA', 'الولايات المتحدة'),
(43925, 3224431104, 3224431359, 'CA', 'CAN', 'كندا'),
(43926, 3224431360, 3224431615, 'US', 'USA', 'الولايات المتحدة'),
(43927, 3224432128, 3224432383, 'US', 'USA', 'الولايات المتحدة'),
(43928, 3224433152, 3224433407, 'US', 'USA', 'الولايات المتحدة'),
(43929, 3224433664, 3224434687, 'US', 'USA', 'الولايات المتحدة'),
(43930, 3224434688, 3224434943, 'AU', 'AUS', 'أستراليا'),
(43931, 3224434944, 3224435967, 'US', 'USA', 'الولايات المتحدة'),
(43932, 3224436224, 3224436479, 'US', 'USA', 'الولايات المتحدة'),
(43933, 3224436736, 3224502271, 'FI', 'FIN', 'فنلندا'),
(43934, 3224502272, 3224567807, 'JP', 'JPN', 'اليابان'),
(43935, 3224567808, 3224571903, 'NO', 'NOR', 'النرويج'),
(43936, 3224571904, 3224580095, 'JP', 'JPN', 'اليابان'),
(43937, 3224580352, 3224615935, 'JP', 'JPN', 'اليابان'),
(43938, 3224616192, 3224616959, 'JP', 'JPN', 'اليابان'),
(43939, 3224617472, 3224629247, 'JP', 'JPN', 'اليابان'),
(43940, 3224629504, 3224633343, 'JP', 'JPN', 'اليابان'),
(43941, 3224633344, 3224646399, 'DE', 'DEU', 'ألمانيا'),
(43942, 3224646400, 3224651775, 'US', 'USA', 'الولايات المتحدة'),
(43943, 3224651776, 3224652287, 'AU', 'AUS', 'أستراليا'),
(43944, 3224652800, 3224660991, 'US', 'USA', 'الولايات المتحدة'),
(43945, 3224660992, 3224661247, 'CA', 'CAN', 'كندا'),
(43946, 3224661504, 3224662527, 'US', 'USA', 'الولايات المتحدة'),
(43947, 3224663040, 3224663551, 'US', 'USA', 'الولايات المتحدة'),
(43948, 3224663808, 3224671999, 'JP', 'JPN', 'اليابان'),
(43949, 3224672000, 3224672255, 'US', 'USA', 'الولايات المتحدة'),
(43950, 3224672256, 3224672511, 'NL', 'NLD', 'هولندا'),
(43951, 3224672512, 3224673791, 'US', 'USA', 'الولايات المتحدة'),
(43952, 3224674048, 3224674559, 'DE', 'DEU', 'ألمانيا'),
(43953, 3224674560, 3224674815, 'GB', 'GBR', 'المملكة المتحدة'),
(43954, 3224675072, 3224675839, 'US', 'USA', 'الولايات المتحدة'),
(43955, 3224676864, 3224677119, 'US', 'USA', 'الولايات المتحدة'),
(43956, 3224677120, 3224678655, 'AU', 'AUS', 'أستراليا'),
(43957, 3224678656, 3224680703, 'US', 'USA', 'الولايات المتحدة'),
(43958, 3224680704, 3224680959, 'AU', 'AUS', 'أستراليا'),
(43959, 3224680960, 3224681471, 'US', 'USA', 'الولايات المتحدة'),
(43960, 3224682752, 3224683519, 'US', 'USA', 'الولايات المتحدة'),
(43961, 3224683520, 3224684031, 'AU', 'AUS', 'أستراليا'),
(43962, 3224684032, 3224689919, 'US', 'USA', 'الولايات المتحدة'),
(43963, 3224689920, 3224690687, 'NL', 'NLD', 'هولندا'),
(43964, 3224690688, 3224691455, 'US', 'USA', 'الولايات المتحدة'),
(43965, 3224691968, 3224692735, 'US', 'USA', 'الولايات المتحدة'),
(43966, 3224692992, 3224694527, 'US', 'USA', 'الولايات المتحدة'),
(43967, 3224694528, 3224694783, 'CA', 'CAN', 'كندا'),
(43968, 3224694784, 3224695039, 'US', 'USA', 'الولايات المتحدة'),
(43969, 3224695808, 3224697343, 'US', 'USA', 'الولايات المتحدة'),
(43970, 3224697856, 3224698111, 'US', 'USA', 'الولايات المتحدة'),
(43971, 3224698112, 3224698367, 'GB', 'GBR', 'المملكة المتحدة'),
(43972, 3224698368, 3224698623, 'FR', 'FRA', 'فرنسا'),
(43973, 3224698880, 3224725247, 'US', 'USA', 'الولايات المتحدة'),
(43974, 3224725248, 3224725503, 'DE', 'DEU', 'ألمانيا'),
(43975, 3224725504, 3224725759, 'CH', 'CHE', 'سويسرا'),
(43976, 3224725760, 3224772351, 'US', 'USA', 'الولايات المتحدة'),
(43977, 3224772352, 3224777983, 'DE', 'DEU', 'ألمانيا'),
(43978, 3224778240, 3224785151, 'DE', 'DEU', 'ألمانيا'),
(43979, 3224785152, 3224787967, 'US', 'USA', 'الولايات المتحدة'),
(43980, 3224788480, 3224791039, 'US', 'USA', 'الولايات المتحدة'),
(43981, 3224791040, 3224791295, 'DE', 'DEU', 'ألمانيا'),
(43982, 3224791296, 3224791807, 'AU', 'AUS', 'أستراليا'),
(43983, 3224791808, 3224793343, 'US', 'USA', 'الولايات المتحدة'),
(43984, 3224793344, 3224793599, 'DE', 'DEU', 'ألمانيا'),
(43985, 3224793600, 3224793855, 'US', 'USA', 'الولايات المتحدة'),
(43986, 3224793856, 3224795391, 'DK', 'DNK', 'الدنيمارك'),
(43987, 3224795392, 3224795647, 'CA', 'CAN', 'كندا'),
(43988, 3224795648, 3224795903, 'CH', 'CHE', 'سويسرا'),
(43989, 3224796160, 3224796415, 'US', 'USA', 'الولايات المتحدة'),
(43990, 3224796416, 3224797439, 'DE', 'DEU', 'ألمانيا'),
(43991, 3224797440, 3224797695, 'US', 'USA', 'الولايات المتحدة'),
(43992, 3224797696, 3224797951, 'NZ', 'NZL', 'نيوزيلاندا'),
(43993, 3224797952, 3224798207, 'US', 'USA', 'الولايات المتحدة'),
(43994, 3224798208, 3224798463, 'CH', 'CHE', 'سويسرا'),
(43995, 3224798464, 3224798975, 'US', 'USA', 'الولايات المتحدة'),
(43996, 3224798976, 3224799231, 'AU', 'AUS', 'أستراليا'),
(43997, 3224799488, 3224799743, 'AU', 'AUS', 'أستراليا'),
(43998, 3224799744, 3224799999, 'US', 'USA', 'الولايات المتحدة'),
(43999, 3224800000, 3224800255, 'DE', 'DEU', 'ألمانيا'),
(44000, 3224800512, 3224816639, 'FR', 'FRA', 'فرنسا'),
(44001, 3224816896, 3224820735, 'FR', 'FRA', 'فرنسا'),
(44002, 3224820736, 3224820991, 'AT', 'AUT', 'النمسا'),
(44003, 3224820992, 3224821247, 'DE', 'DEU', 'ألمانيا'),
(44004, 3224821248, 3224822015, 'US', 'USA', 'الولايات المتحدة'),
(44005, 3224822016, 3224822271, 'SE', 'SWE', 'السويد'),
(44006, 3224822272, 3224822527, 'US', 'USA', 'الولايات المتحدة'),
(44007, 3224822784, 3224823039, 'US', 'USA', 'الولايات المتحدة'),
(44008, 3224823296, 3224826367, 'US', 'USA', 'الولايات المتحدة'),
(44009, 3224826368, 3224826623, 'CA', 'CAN', 'كندا'),
(44010, 3224826624, 3224826879, 'US', 'USA', 'الولايات المتحدة'),
(44011, 3224826880, 3224827135, 'CH', 'CHE', 'سويسرا'),
(44012, 3224827136, 3224827391, 'GB', 'GBR', 'المملكة المتحدة'),
(44013, 3224827392, 3224827647, 'US', 'USA', 'الولايات المتحدة'),
(44014, 3224827648, 3224827903, 'JP', 'JPN', 'اليابان'),
(44015, 3224827904, 3224828671, 'US', 'USA', 'الولايات المتحدة'),
(44016, 3224828672, 3224828927, 'AU', 'AUS', 'أستراليا'),
(44017, 3224829184, 3224829439, 'US', 'USA', 'الولايات المتحدة'),
(44018, 3224829440, 3224829695, 'DE', 'DEU', 'ألمانيا'),
(44019, 3224830208, 3224850943, 'US', 'USA', 'الولايات المتحدة'),
(44020, 3224851200, 3224851455, 'US', 'USA', 'الولايات المتحدة'),
(44021, 3224851456, 3224851711, 'DE', 'DEU', 'ألمانيا'),
(44022, 3224851968, 3224852735, 'US', 'USA', 'الولايات المتحدة'),
(44023, 3224852736, 3224852991, 'DE', 'DEU', 'ألمانيا'),
(44024, 3224852992, 3224854527, 'US', 'USA', 'الولايات المتحدة'),
(44025, 3224854784, 3224855039, 'US', 'USA', 'الولايات المتحدة'),
(44026, 3224855040, 3224855551, 'AU', 'AUS', 'أستراليا'),
(44027, 3224855552, 3224855807, 'US', 'USA', 'الولايات المتحدة'),
(44028, 3224855808, 3224856063, 'IT', 'ITA', 'إيطاليا'),
(44029, 3224856064, 3224856575, 'US', 'USA', 'الولايات المتحدة'),
(44030, 3224856832, 3224857087, 'NL', 'NLD', 'هولندا'),
(44031, 3224857088, 3224857855, 'US', 'USA', 'الولايات المتحدة'),
(44032, 3224858112, 3224858367, 'JP', 'JPN', 'اليابان'),
(44033, 3224858368, 3224858623, 'US', 'USA', 'الولايات المتحدة'),
(44034, 3224858624, 3224858879, 'AU', 'AUS', 'أستراليا'),
(44035, 3224858880, 3224859391, 'US', 'USA', 'الولايات المتحدة'),
(44036, 3224859392, 3224859647, 'NL', 'NLD', 'هولندا'),
(44037, 3224859648, 3224860159, 'US', 'USA', 'الولايات المتحدة'),
(44038, 3224860160, 3224860415, 'JP', 'JPN', 'اليابان'),
(44039, 3224860928, 3224862719, 'US', 'USA', 'الولايات المتحدة'),
(44040, 3224862976, 3224863231, 'NL', 'NLD', 'هولندا'),
(44041, 3224863488, 3224863743, 'US', 'USA', 'الولايات المتحدة'),
(44042, 3224863744, 3224863999, 'GB', 'GBR', 'المملكة المتحدة'),
(44043, 3224864000, 3224878079, 'US', 'USA', 'الولايات المتحدة'),
(44044, 3224878080, 3224878335, 'DE', 'DEU', 'ألمانيا'),
(44045, 3224878336, 3224878591, 'US', 'USA', 'الولايات المتحدة'),
(44046, 3224878592, 3224878847, 'AU', 'AUS', 'أستراليا'),
(44047, 3224879360, 3224879615, 'GB', 'GBR', 'المملكة المتحدة'),
(44048, 3224879616, 3224879871, 'CA', 'CAN', 'كندا'),
(44049, 3224879872, 3224880383, 'US', 'USA', 'الولايات المتحدة'),
(44050, 3224880384, 3224880639, 'DE', 'DEU', 'ألمانيا'),
(44051, 3224880640, 3224880895, 'AU', 'AUS', 'أستراليا'),
(44052, 3224880896, 3224881151, 'US', 'USA', 'الولايات المتحدة'),
(44053, 3224881408, 3224882431, 'US', 'USA', 'الولايات المتحدة'),
(44054, 3224882688, 3224882943, 'CA', 'CAN', 'كندا'),
(44055, 3224882944, 3224883455, 'US', 'USA', 'الولايات المتحدة'),
(44056, 3224883456, 3224883711, 'AU', 'AUS', 'أستراليا'),
(44057, 3224883712, 3224884223, 'US', 'USA', 'الولايات المتحدة'),
(44058, 3224884224, 3224884479, 'GB', 'GBR', 'المملكة المتحدة'),
(44059, 3224884480, 3224884991, 'US', 'USA', 'الولايات المتحدة'),
(44060, 3224885248, 3224885503, 'CA', 'CAN', 'كندا'),
(44061, 3224885760, 3224886015, 'US', 'USA', 'الولايات المتحدة'),
(44062, 3224886272, 3224886527, 'JP', 'JPN', 'اليابان'),
(44063, 3224886528, 3224887295, 'US', 'USA', 'الولايات المتحدة'),
(44064, 3224887296, 3224887551, 'CA', 'CAN', 'كندا'),
(44065, 3224887808, 3224889087, 'US', 'USA', 'الولايات المتحدة'),
(44066, 3224889344, 3224889599, 'AU', 'AUS', 'أستراليا'),
(44067, 3224889600, 3224890879, 'US', 'USA', 'الولايات المتحدة'),
(44068, 3224890880, 3224891135, 'JP', 'JPN', 'اليابان'),
(44069, 3224891136, 3224891647, 'US', 'USA', 'الولايات المتحدة'),
(44070, 3224892160, 3224892415, 'CA', 'CAN', 'كندا'),
(44071, 3224892416, 3224892671, 'DE', 'DEU', 'ألمانيا'),
(44072, 3224892928, 3224893183, 'US', 'USA', 'الولايات المتحدة'),
(44073, 3224893440, 3224893951, 'US', 'USA', 'الولايات المتحدة'),
(44074, 3224895488, 3224900607, 'US', 'USA', 'الولايات المتحدة'),
(44075, 3224900608, 3224900863, 'FR', 'FRA', 'فرنسا'),
(44076, 3224900864, 3224921087, 'US', 'USA', 'الولايات المتحدة'),
(44077, 3224921088, 3224921343, 'FI', 'FIN', 'فنلندا'),
(44078, 3224921344, 3224928255, 'US', 'USA', 'الولايات المتحدة'),
(44079, 3224928256, 3224928511, 'FI', 'FIN', 'فنلندا'),
(44080, 3224928512, 3225026559, 'US', 'USA', 'الولايات المتحدة'),
(44081, 3225026816, 3225028863, 'US', 'USA', 'الولايات المتحدة'),
(44082, 3225028864, 3225031423, 'JP', 'JPN', 'اليابان'),
(44083, 3225031424, 3225033727, 'US', 'USA', 'الولايات المتحدة'),
(44084, 3225033728, 3225035775, 'LU', 'LUX', 'لوكسيمبورغ'),
(44085, 3225035776, 3225037055, 'US', 'USA', 'الولايات المتحدة'),
(44086, 3225037056, 3225049599, 'FI', 'FIN', 'فنلندا'),
(44087, 3225051392, 3225052671, 'JP', 'JPN', 'اليابان'),
(44088, 3225052672, 3225056767, 'US', 'USA', 'الولايات المتحدة'),
(44089, 3225057024, 3225057535, 'US', 'USA', 'الولايات المتحدة'),
(44090, 3225057536, 3225057791, 'CA', 'CAN', 'كندا'),
(44091, 3225057792, 3225060095, 'US', 'USA', 'الولايات المتحدة'),
(44092, 3225060608, 3225061631, 'AU', 'AUS', 'أستراليا'),
(44093, 3225064704, 3225075967, 'US', 'USA', 'الولايات المتحدة'),
(44094, 3225076224, 3225076479, 'CA', 'CAN', 'كندا'),
(44095, 3225076480, 3225076991, 'US', 'USA', 'الولايات المتحدة'),
(44096, 3225076992, 3225077247, 'SE', 'SWE', 'السويد'),
(44097, 3225077504, 3225081087, 'US', 'USA', 'الولايات المتحدة'),
(44098, 3225081088, 3225081343, 'CA', 'CAN', 'كندا'),
(44099, 3225081600, 3225082367, 'US', 'USA', 'الولايات المتحدة'),
(44100, 3225082368, 3225082623, 'IT', 'ITA', 'إيطاليا'),
(44101, 3225082880, 3225084671, 'US', 'USA', 'الولايات المتحدة'),
(44102, 3225084672, 3225085439, 'NL', 'NLD', 'هولندا'),
(44103, 3225085440, 3225089279, 'US', 'USA', 'الولايات المتحدة'),
(44104, 3225089280, 3225089535, 'CA', 'CAN', 'كندا'),
(44105, 3225089536, 3225091071, 'US', 'USA', 'الولايات المتحدة'),
(44106, 3225091584, 3225091839, 'US', 'USA', 'الولايات المتحدة'),
(44107, 3225092096, 3225419775, 'US', 'USA', 'الولايات المتحدة'),
(44108, 3225420032, 3225420287, 'US', 'USA', 'الولايات المتحدة'),
(44109, 3225423872, 3225424383, 'US', 'USA', 'الولايات المتحدة'),
(44110, 3225426944, 3225427199, 'AT', 'AUT', 'النمسا'),
(44111, 3225429504, 3225429759, 'CA', 'CAN', 'كندا'),
(44112, 3225431552, 3225433087, 'US', 'USA', 'الولايات المتحدة'),
(44113, 3225437184, 3225437695, 'US', 'USA', 'الولايات المتحدة'),
(44114, 3225442304, 3225442559, 'US', 'USA', 'الولايات المتحدة'),
(44115, 3225444352, 3225444607, 'US', 'USA', 'الولايات المتحدة'),
(44116, 3225445376, 3225446399, 'BE', 'BEL', 'بلجيكا'),
(44117, 3225451776, 3225452031, 'SE', 'SWE', 'السويد'),
(44118, 3225459968, 3225460479, 'US', 'USA', 'الولايات المتحدة'),
(44119, 3225460480, 3225460735, 'CA', 'CAN', 'كندا'),
(44120, 3225460992, 3225462015, 'CA', 'CAN', 'كندا'),
(44121, 3225470464, 3225470719, 'US', 'USA', 'الولايات المتحدة'),
(44122, 3225471488, 3225471743, 'DE', 'DEU', 'ألمانيا'),
(44123, 3225471744, 3225472511, 'US', 'USA', 'الولايات المتحدة'),
(44124, 3225477632, 3225480191, 'US', 'USA', 'الولايات المتحدة'),
(44125, 3225485568, 3225498111, 'US', 'USA', 'الولايات المتحدة'),
(44126, 3225498368, 3225503487, 'NL', 'NLD', 'هولندا'),
(44127, 3225503488, 3225505535, 'US', 'USA', 'الولايات المتحدة'),
(44128, 3225505792, 3225506047, 'US', 'USA', 'الولايات المتحدة'),
(44129, 3225506304, 3225508863, 'AU', 'AUS', 'أستراليا'),
(44130, 3225508864, 3225509631, 'CH', 'CHE', 'سويسرا'),
(44131, 3225509632, 3225509887, 'US', 'USA', 'الولايات المتحدة'),
(44132, 3225509888, 3225510143, 'NL', 'NLD', 'هولندا'),
(44133, 3225510144, 3225518591, 'US', 'USA', 'الولايات المتحدة'),
(44134, 3225518592, 3225518847, 'AU', 'AUS', 'أستراليا'),
(44135, 3225518848, 3225519103, 'IT', 'ITA', 'إيطاليا'),
(44136, 3225519104, 3225519359, 'GB', 'GBR', 'المملكة المتحدة'),
(44137, 3225519872, 3225520639, 'US', 'USA', 'الولايات المتحدة'),
(44138, 3225520896, 3225521151, 'DE', 'DEU', 'ألمانيا'),
(44139, 3225521152, 3225522175, 'US', 'USA', 'الولايات المتحدة'),
(44140, 3225522176, 3225522943, 'GB', 'GBR', 'المملكة المتحدة'),
(44141, 3225522944, 3225524223, 'US', 'USA', 'الولايات المتحدة'),
(44142, 3225524224, 3225524479, 'VE', 'VEN', 'فنزويلا'),
(44143, 3225524480, 3225524735, 'GB', 'GBR', 'المملكة المتحدة'),
(44144, 3225529088, 3225529343, 'US', 'USA', 'الولايات المتحدة'),
(44145, 3225529600, 3225530367, 'US', 'USA', 'الولايات المتحدة'),
(44146, 3225530368, 3225530623, 'PR', 'PRI', 'بورتو ريكو'),
(44147, 3225530624, 3225530879, 'US', 'USA', 'الولايات المتحدة'),
(44148, 3225531136, 3225531647, 'US', 'USA', 'الولايات المتحدة'),
(44149, 3225531904, 3225532159, 'AU', 'AUS', 'أستراليا'),
(44150, 3225532160, 3225535999, 'CH', 'CHE', 'سويسرا'),
(44151, 3225536000, 3225539839, 'US', 'USA', 'الولايات المتحدة'),
(44152, 3225540096, 3225540863, 'US', 'USA', 'الولايات المتحدة'),
(44153, 3225540864, 3225541119, 'AU', 'AUS', 'أستراليا'),
(44154, 3225541120, 3225541375, 'US', 'USA', 'الولايات المتحدة'),
(44155, 3225541376, 3225543935, 'GB', 'GBR', 'المملكة المتحدة'),
(44156, 3225547776, 3225548543, 'US', 'USA', 'الولايات المتحدة'),
(44157, 3225548800, 3225549055, 'NZ', 'NZL', 'نيوزيلاندا'),
(44158, 3225549056, 3225549311, 'US', 'USA', 'الولايات المتحدة'),
(44159, 3225549312, 3225549567, 'AU', 'AUS', 'أستراليا'),
(44160, 3225549568, 3225550591, 'US', 'USA', 'الولايات المتحدة'),
(44161, 3225550848, 3225616383, 'DK', 'DNK', 'الدنيمارك'),
(44162, 3225616640, 3225616895, 'AU', 'AUS', 'أستراليا'),
(44163, 3225617152, 3225617407, 'IE', 'IRL', 'إيرلندا'),
(44164, 3225617408, 3225617663, 'GB', 'GBR', 'المملكة المتحدة'),
(44165, 3225617920, 3225618175, 'US', 'USA', 'الولايات المتحدة'),
(44166, 3225618432, 3225618687, 'US', 'USA', 'الولايات المتحدة'),
(44167, 3225618688, 3225618943, 'CA', 'CAN', 'كندا'),
(44168, 3225619200, 3225619455, 'US', 'USA', 'الولايات المتحدة'),
(44169, 3225619456, 3225619711, 'AU', 'AUS', 'أستراليا'),
(44170, 3225619712, 3225622527, 'US', 'USA', 'الولايات المتحدة'),
(44171, 3225626368, 3225626623, 'GB', 'GBR', 'المملكة المتحدة'),
(44172, 3225626880, 3225627391, 'US', 'USA', 'الولايات المتحدة'),
(44173, 3225627392, 3225627647, 'GB', 'GBR', 'المملكة المتحدة'),
(44174, 3225627648, 3225627903, 'US', 'USA', 'الولايات المتحدة'),
(44175, 3225627904, 3225628159, 'CA', 'CAN', 'كندا'),
(44176, 3225628160, 3225628415, 'US', 'USA', 'الولايات المتحدة'),
(44177, 3225628416, 3225628671, 'GB', 'GBR', 'المملكة المتحدة'),
(44178, 3225628672, 3225629183, 'US', 'USA', 'الولايات المتحدة'),
(44179, 3225629184, 3225629439, 'GB', 'GBR', 'المملكة المتحدة'),
(44180, 3225629440, 3225629695, 'US', 'USA', 'الولايات المتحدة'),
(44181, 3225629696, 3225629951, 'GB', 'GBR', 'المملكة المتحدة'),
(44182, 3225629952, 3225630207, 'US', 'USA', 'الولايات المتحدة'),
(44183, 3225630464, 3225630719, 'DE', 'DEU', 'ألمانيا'),
(44184, 3225630720, 3225631231, 'US', 'USA', 'الولايات المتحدة'),
(44185, 3225631232, 3225631487, 'SE', 'SWE', 'السويد'),
(44186, 3225631488, 3225632767, 'US', 'USA', 'الولايات المتحدة'),
(44187, 3225633536, 3225633791, 'US', 'USA', 'الولايات المتحدة'),
(44188, 3225634048, 3225634815, 'US', 'USA', 'الولايات المتحدة'),
(44189, 3225635072, 3225635583, 'US', 'USA', 'الولايات المتحدة'),
(44190, 3225635840, 3225636095, 'PT', 'PRT', 'البورتوغال'),
(44191, 3225636096, 3225636607, 'US', 'USA', 'الولايات المتحدة'),
(44192, 3225636608, 3225636863, 'ES', 'ESP', 'إسبانيا'),
(44193, 3225636864, 3225637887, 'US', 'USA', 'الولايات المتحدة'),
(44194, 3225637888, 3225638399, 'AU', 'AUS', 'أستراليا'),
(44195, 3225638400, 3225638655, 'US', 'USA', 'الولايات المتحدة'),
(44196, 3225638656, 3225638911, 'GB', 'GBR', 'المملكة المتحدة'),
(44197, 3225639424, 3225640447, 'US', 'USA', 'الولايات المتحدة'),
(44198, 3225640448, 3225640703, 'GB', 'GBR', 'المملكة المتحدة'),
(44199, 3225640704, 3225641983, 'US', 'USA', 'الولايات المتحدة'),
(44200, 3225641984, 3225643263, 'GB', 'GBR', 'المملكة المتحدة'),
(44201, 3225643264, 3225643775, 'CA', 'CAN', 'كندا'),
(44202, 3225643776, 3225649919, 'US', 'USA', 'الولايات المتحدة'),
(44203, 3225650176, 3225650943, 'US', 'USA', 'الولايات المتحدة'),
(44204, 3225650944, 3225651199, 'GB', 'GBR', 'المملكة المتحدة'),
(44205, 3225651200, 3225657087, 'US', 'USA', 'الولايات المتحدة'),
(44206, 3225658624, 3225659135, 'US', 'USA', 'الولايات المتحدة'),
(44207, 3225659136, 3225659391, 'DE', 'DEU', 'ألمانيا'),
(44208, 3225659392, 3225659647, 'NZ', 'NZL', 'نيوزيلاندا'),
(44209, 3225659904, 3225660159, 'DE', 'DEU', 'ألمانيا'),
(44210, 3225660160, 3225660415, 'AU', 'AUS', 'أستراليا'),
(44211, 3225660672, 3225663743, 'US', 'USA', 'الولايات المتحدة'),
(44212, 3225664000, 3225664511, 'US', 'USA', 'الولايات المتحدة'),
(44213, 3225664768, 3225669887, 'DE', 'DEU', 'ألمانيا'),
(44214, 3225669888, 3225671935, 'US', 'USA', 'الولايات المتحدة'),
(44215, 3225671936, 3225672191, 'AU', 'AUS', 'أستراليا'),
(44216, 3225672192, 3225672447, 'DE', 'DEU', 'ألمانيا'),
(44217, 3225672448, 3225672703, 'US', 'USA', 'الولايات المتحدة'),
(44218, 3225672704, 3225673215, 'NL', 'NLD', 'هولندا'),
(44219, 3225673472, 3225673727, 'IE', 'IRL', 'إيرلندا'),
(44220, 3225673984, 3225679871, 'US', 'USA', 'الولايات المتحدة'),
(44221, 3225679872, 3225680127, 'AU', 'AUS', 'أستراليا'),
(44222, 3225680128, 3225680383, 'GR', 'GRC', 'اليونان'),
(44223, 3225680640, 3225681151, 'US', 'USA', 'الولايات المتحدة'),
(44224, 3225681408, 3225681663, 'US', 'USA', 'الولايات المتحدة'),
(44225, 3225681920, 3225682943, 'DE', 'DEU', 'ألمانيا'),
(44226, 3225682944, 3225683199, 'AT', 'AUT', 'النمسا'),
(44227, 3225683200, 3225687039, 'DE', 'DEU', 'ألمانيا'),
(44228, 3225687040, 3225687807, 'US', 'USA', 'الولايات المتحدة'),
(44229, 3225687808, 3225688063, 'GB', 'GBR', 'المملكة المتحدة'),
(44230, 3225688320, 3225689343, 'US', 'USA', 'الولايات المتحدة'),
(44231, 3225689600, 3225689855, 'US', 'USA', 'الولايات المتحدة'),
(44232, 3225689856, 3225694975, 'NL', 'NLD', 'هولندا'),
(44233, 3225695232, 3225695487, 'US', 'USA', 'الولايات المتحدة'),
(44234, 3225695488, 3225701119, 'CA', 'CAN', 'كندا'),
(44235, 3225701120, 3225701375, 'US', 'USA', 'الولايات المتحدة'),
(44236, 3225701376, 3225709567, 'NO', 'NOR', 'النرويج'),
(44237, 3225709568, 3225710079, 'US', 'USA', 'الولايات المتحدة'),
(44238, 3225710080, 3225710591, 'JP', 'JPN', 'اليابان'),
(44239, 3225710592, 3225711615, 'US', 'USA', 'الولايات المتحدة'),
(44240, 3225712128, 3225714175, 'US', 'USA', 'الولايات المتحدة'),
(44241, 3225715456, 3225715711, 'CA', 'CAN', 'كندا'),
(44242, 3225715712, 3225715967, 'AU', 'AUS', 'أستراليا'),
(44243, 3225715968, 3225716991, 'US', 'USA', 'الولايات المتحدة'),
(44244, 3225716992, 3225717247, 'CA', 'CAN', 'كندا'),
(44245, 3225717504, 3225717759, 'AU', 'AUS', 'أستراليا'),
(44246, 3225717760, 3225720063, 'US', 'USA', 'الولايات المتحدة'),
(44247, 3225720576, 3225721343, 'GB', 'GBR', 'المملكة المتحدة'),
(44248, 3225721344, 3225722111, 'US', 'USA', 'الولايات المتحدة'),
(44249, 3225722624, 3225723647, 'US', 'USA', 'الولايات المتحدة'),
(44250, 3225724160, 3225725439, 'DE', 'DEU', 'ألمانيا'),
(44251, 3225725440, 3225725695, 'GB', 'GBR', 'المملكة المتحدة'),
(44252, 3225725696, 3225726207, 'AU', 'AUS', 'أستراليا'),
(44253, 3225726208, 3225726463, 'US', 'USA', 'الولايات المتحدة'),
(44254, 3225726464, 3225726719, 'GB', 'GBR', 'المملكة المتحدة'),
(44255, 3225726720, 3225726975, 'US', 'USA', 'الولايات المتحدة'),
(44256, 3225726976, 3225727231, 'IT', 'ITA', 'إيطاليا'),
(44257, 3225727232, 3225727487, 'US', 'USA', 'الولايات المتحدة'),
(44258, 3225727744, 3225727999, 'AU', 'AUS', 'أستراليا'),
(44259, 3225728000, 3225728511, 'US', 'USA', 'الولايات المتحدة'),
(44260, 3225728512, 3225728767, 'NL', 'NLD', 'هولندا'),
(44261, 3225728768, 3225729023, 'US', 'USA', 'الولايات المتحدة'),
(44262, 3225729024, 3225729279, 'CA', 'CAN', 'كندا'),
(44263, 3225729280, 3225729535, 'US', 'USA', 'الولايات المتحدة'),
(44264, 3225729536, 3225729791, 'PT', 'PRT', 'البورتوغال'),
(44265, 3225729792, 3225730047, 'US', 'USA', 'الولايات المتحدة'),
(44266, 3225730304, 3225730559, 'US', 'USA', 'الولايات المتحدة'),
(44267, 3225730816, 3225733887, 'US', 'USA', 'الولايات المتحدة'),
(44268, 3225734144, 3225735167, 'US', 'USA', 'الولايات المتحدة'),
(44269, 3225735424, 3225735679, 'PT', 'PRT', 'البورتوغال'),
(44270, 3225735680, 3225735935, 'US', 'USA', 'الولايات المتحدة'),
(44271, 3225735936, 3225737215, 'DE', 'DEU', 'ألمانيا'),
(44272, 3225737216, 3225737471, 'PT', 'PRT', 'البورتوغال'),
(44273, 3225737472, 3225738495, 'US', 'USA', 'الولايات المتحدة'),
(44274, 3225738496, 3225738751, 'PT', 'PRT', 'البورتوغال'),
(44275, 3225738752, 3225739263, 'US', 'USA', 'الولايات المتحدة'),
(44276, 3225739264, 3225739519, 'PT', 'PRT', 'البورتوغال'),
(44277, 3225739520, 3225740543, 'US', 'USA', 'الولايات المتحدة'),
(44278, 3225740544, 3225740799, 'CA', 'CAN', 'كندا'),
(44279, 3225740800, 3225741055, 'NL', 'NLD', 'هولندا'),
(44280, 3225741056, 3225741823, 'US', 'USA', 'الولايات المتحدة'),
(44281, 3225742080, 3225745919, 'JP', 'JPN', 'اليابان'),
(44282, 3225745920, 3225746687, 'NL', 'NLD', 'هولندا'),
(44283, 3225746688, 3225746943, 'US', 'USA', 'الولايات المتحدة'),
(44284, 3225746944, 3225747199, 'DE', 'DEU', 'ألمانيا'),
(44285, 3225747456, 3225747711, 'US', 'USA', 'الولايات المتحدة'),
(44286, 3225752832, 3225753087, 'US', 'USA', 'الولايات المتحدة'),
(44287, 3225759232, 3225759487, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(44288, 3225763840, 3225764095, 'BE', 'BEL', 'بلجيكا'),
(44289, 3225766400, 3225766655, 'CA', 'CAN', 'كندا'),
(44290, 3225767936, 3225768191, 'US', 'USA', 'الولايات المتحدة'),
(44291, 3225768960, 3225769215, 'US', 'USA', 'الولايات المتحدة'),
(44292, 3225773312, 3225773567, 'CA', 'CAN', 'كندا'),
(44293, 3225776128, 3225776383, 'US', 'USA', 'الولايات المتحدة'),
(44294, 3225777152, 3225777407, 'AU', 'AUS', 'أستراليا'),
(44295, 3225777408, 3225777663, 'US', 'USA', 'الولايات المتحدة'),
(44296, 3225780224, 3225780479, 'US', 'USA', 'الولايات المتحدة'),
(44297, 3225783296, 3225783551, 'US', 'USA', 'الولايات المتحدة'),
(44298, 3225783808, 3225784063, 'US', 'USA', 'الولايات المتحدة'),
(44299, 3225785600, 3225788159, 'CA', 'CAN', 'كندا'),
(44300, 3225796096, 3225796351, 'US', 'USA', 'الولايات المتحدة'),
(44301, 3225806080, 3225806847, 'US', 'USA', 'الولايات المتحدة'),
(44302, 3225807360, 3225807615, 'DE', 'DEU', 'ألمانيا'),
(44303, 3225810688, 3225810943, 'US', 'USA', 'الولايات المتحدة'),
(44304, 3225812992, 3225827071, 'FR', 'FRA', 'فرنسا'),
(44305, 3225827072, 3225827327, 'US', 'USA', 'الولايات المتحدة'),
(44306, 3225827328, 3225843711, 'FR', 'FRA', 'فرنسا'),
(44307, 3225843712, 3225846527, 'US', 'USA', 'الولايات المتحدة'),
(44308, 3225846784, 3225847039, 'US', 'USA', 'الولايات المتحدة'),
(44309, 3225847040, 3225847551, 'TR', 'TUR', 'تركيا'),
(44310, 3225847552, 3225847807, 'AU', 'AUS', 'أستراليا'),
(44311, 3225847808, 3225848063, 'IT', 'ITA', 'إيطاليا'),
(44312, 3225848064, 3225848831, 'US', 'USA', 'الولايات المتحدة'),
(44313, 3225848832, 3225853951, 'DE', 'DEU', 'ألمانيا'),
(44314, 3225853952, 3225854719, 'US', 'USA', 'الولايات المتحدة'),
(44315, 3225855232, 3225857023, 'US', 'USA', 'الولايات المتحدة'),
(44316, 3225857024, 3225857279, 'CA', 'CAN', 'كندا'),
(44317, 3225857280, 3225857535, 'US', 'USA', 'الولايات المتحدة'),
(44318, 3225857536, 3225857791, 'AU', 'AUS', 'أستراليا'),
(44319, 3225857792, 3225858047, 'US', 'USA', 'الولايات المتحدة'),
(44320, 3225858048, 3225858559, 'CA', 'CAN', 'كندا'),
(44321, 3225858560, 3225858815, 'US', 'USA', 'الولايات المتحدة'),
(44322, 3225858816, 3225860095, 'JP', 'JPN', 'اليابان'),
(44323, 3225860096, 3225861887, 'US', 'USA', 'الولايات المتحدة'),
(44324, 3225862144, 3225867775, 'US', 'USA', 'الولايات المتحدة'),
(44325, 3225868032, 3225868287, 'US', 'USA', 'الولايات المتحدة'),
(44326, 3225868288, 3225868543, 'AU', 'AUS', 'أستراليا'),
(44327, 3225868544, 3225869055, 'US', 'USA', 'الولايات المتحدة'),
(44328, 3225869056, 3225869311, 'AU', 'AUS', 'أستراليا'),
(44329, 3225869568, 3225870335, 'US', 'USA', 'الولايات المتحدة'),
(44330, 3225870336, 3225870591, 'CA', 'CAN', 'كندا'),
(44331, 3225870592, 3225873663, 'US', 'USA', 'الولايات المتحدة'),
(44332, 3225873920, 3225874943, 'US', 'USA', 'الولايات المتحدة'),
(44333, 3225874944, 3225875199, 'GB', 'GBR', 'المملكة المتحدة'),
(44334, 3225875456, 3225875967, 'US', 'USA', 'الولايات المتحدة'),
(44335, 3225876480, 3225878271, 'US', 'USA', 'الولايات المتحدة'),
(44336, 3225878528, 3225880319, 'SE', 'SWE', 'السويد'),
(44337, 3225880320, 3225880575, 'US', 'USA', 'الولايات المتحدة'),
(44338, 3225880576, 3225944063, 'SE', 'SWE', 'السويد'),
(44339, 3225944832, 3226008831, 'TW', 'TWN', 'تايوان'),
(44340, 3226008832, 3226009343, 'US', 'USA', 'الولايات المتحدة'),
(44341, 3226009856, 3226010879, 'US', 'USA', 'الولايات المتحدة'),
(44342, 3226010880, 3226011135, 'CA', 'CAN', 'كندا'),
(44343, 3226011136, 3226012415, 'US', 'USA', 'الولايات المتحدة'),
(44344, 3226012672, 3226012927, 'AU', 'AUS', 'أستراليا'),
(44345, 3226012928, 3226014207, 'US', 'USA', 'الولايات المتحدة'),
(44346, 3226014464, 3226014975, 'GB', 'GBR', 'المملكة المتحدة'),
(44347, 3226014976, 3226015231, 'NZ', 'NZL', 'نيوزيلاندا'),
(44348, 3226015232, 3226015487, 'AU', 'AUS', 'أستراليا'),
(44349, 3226015744, 3226016255, 'ID', 'IDN', 'إندونيسيا'),
(44350, 3226016256, 3226018303, 'US', 'USA', 'الولايات المتحدة'),
(44351, 3226018304, 3226018559, 'DE', 'DEU', 'ألمانيا'),
(44352, 3226018560, 3226021119, 'CH', 'CHE', 'سويسرا'),
(44353, 3226021120, 3226023423, 'US', 'USA', 'الولايات المتحدة'),
(44354, 3226023680, 3226026495, 'US', 'USA', 'الولايات المتحدة'),
(44355, 3226026496, 3226026751, 'AU', 'AUS', 'أستراليا'),
(44356, 3226026752, 3226030079, 'US', 'USA', 'الولايات المتحدة'),
(44357, 3226030592, 3226064383, 'US', 'USA', 'الولايات المتحدة'),
(44358, 3226064640, 3226066687, 'US', 'USA', 'الولايات المتحدة'),
(44359, 3226066944, 3226067455, 'US', 'USA', 'الولايات المتحدة'),
(44360, 3226067456, 3226067711, 'BE', 'BEL', 'بلجيكا'),
(44361, 3226067712, 3226068223, 'US', 'USA', 'الولايات المتحدة'),
(44362, 3226068224, 3226068479, 'GB', 'GBR', 'المملكة المتحدة'),
(44363, 3226068480, 3226068991, 'US', 'USA', 'الولايات المتحدة'),
(44364, 3226075136, 3226107647, 'US', 'USA', 'الولايات المتحدة'),
(44365, 3226110208, 3226110719, 'US', 'USA', 'الولايات المتحدة'),
(44366, 3226110720, 3226128639, 'AU', 'AUS', 'أستراليا'),
(44367, 3226128640, 3226131455, 'US', 'USA', 'الولايات المتحدة'),
(44368, 3226140928, 3226143487, 'CA', 'CAN', 'كندا'),
(44369, 3226143744, 3226156543, 'CA', 'CAN', 'كندا'),
(44370, 3226156800, 3226157567, 'CA', 'CAN', 'كندا'),
(44371, 3226157568, 3226157823, 'US', 'USA', 'الولايات المتحدة'),
(44372, 3226157824, 3226167807, 'CA', 'CAN', 'كندا'),
(44373, 3226168064, 3226175231, 'CA', 'CAN', 'كندا'),
(44374, 3226175744, 3226188543, 'CA', 'CAN', 'كندا'),
(44375, 3226189056, 3226189311, 'CA', 'CAN', 'كندا'),
(44376, 3226189568, 3226189823, 'CA', 'CAN', 'كندا'),
(44377, 3226191360, 3226191615, 'US', 'USA', 'الولايات المتحدة'),
(44378, 3226191872, 3226194175, 'CA', 'CAN', 'كندا'),
(44379, 3226194432, 3226194687, 'CA', 'CAN', 'كندا'),
(44380, 3226194944, 3226201855, 'CA', 'CAN', 'كندا'),
(44381, 3226201856, 3226202111, 'US', 'USA', 'الولايات المتحدة'),
(44382, 3226202112, 3226205439, 'CA', 'CAN', 'كندا'),
(44383, 3226205440, 3226205695, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(44384, 3226205696, 3226205951, 'CA', 'CAN', 'كندا'),
(44385, 3226207744, 3226215423, 'GB', 'GBR', 'المملكة المتحدة'),
(44386, 3226215424, 3226236159, 'US', 'USA', 'الولايات المتحدة'),
(44387, 3226237184, 3226237439, 'US', 'USA', 'الولايات المتحدة'),
(44388, 3226237440, 3226237695, 'AU', 'AUS', 'أستراليا'),
(44389, 3226237696, 3226240255, 'DE', 'DEU', 'ألمانيا'),
(44390, 3226240512, 3226250495, 'DE', 'DEU', 'ألمانيا'),
(44391, 3226250496, 3226251263, 'US', 'USA', 'الولايات المتحدة'),
(44392, 3226251264, 3226251519, 'DE', 'DEU', 'ألمانيا'),
(44393, 3226251520, 3226252287, 'US', 'USA', 'الولايات المتحدة'),
(44394, 3226252544, 3226253567, 'US', 'USA', 'الولايات المتحدة'),
(44395, 3226253824, 3226267903, 'US', 'USA', 'الولايات المتحدة'),
(44396, 3226267904, 3226268159, 'DE', 'DEU', 'ألمانيا'),
(44397, 3226268160, 3226268415, 'PT', 'PRT', 'البورتوغال'),
(44398, 3226268416, 3226268927, 'AT', 'AUT', 'النمسا'),
(44399, 3226268928, 3226269951, 'DE', 'DEU', 'ألمانيا'),
(44400, 3226269952, 3226270719, 'US', 'USA', 'الولايات المتحدة'),
(44401, 3226270720, 3226271487, 'JP', 'JPN', 'اليابان'),
(44402, 3226272000, 3226273791, 'US', 'USA', 'الولايات المتحدة'),
(44403, 3226273792, 3226274047, 'AU', 'AUS', 'أستراليا'),
(44404, 3226274048, 3226274559, 'US', 'USA', 'الولايات المتحدة'),
(44405, 3226274560, 3226274815, 'CH', 'CHE', 'سويسرا'),
(44406, 3226274816, 3226276095, 'US', 'USA', 'الولايات المتحدة'),
(44407, 3226276096, 3226276351, 'AU', 'AUS', 'أستراليا'),
(44408, 3226276352, 3226276863, 'US', 'USA', 'الولايات المتحدة'),
(44409, 3226277632, 3226283519, 'US', 'USA', 'الولايات المتحدة'),
(44410, 3226283520, 3226291199, 'CA', 'CAN', 'كندا'),
(44411, 3226291200, 3226300159, 'US', 'USA', 'الولايات المتحدة'),
(44412, 3226300416, 3226300927, 'US', 'USA', 'الولايات المتحدة'),
(44413, 3226300928, 3226301439, 'DE', 'DEU', 'ألمانيا'),
(44414, 3226301440, 3226302463, 'US', 'USA', 'الولايات المتحدة'),
(44415, 3226302464, 3226303487, 'FI', 'FIN', 'فنلندا'),
(44416, 3226303488, 3226304511, 'US', 'USA', 'الولايات المتحدة'),
(44417, 3226304768, 3226305535, 'US', 'USA', 'الولايات المتحدة'),
(44418, 3226305536, 3226307327, 'GB', 'GBR', 'المملكة المتحدة'),
(44419, 3226307328, 3226307583, 'US', 'USA', 'الولايات المتحدة'),
(44420, 3226307584, 3226308095, 'ES', 'ESP', 'إسبانيا'),
(44421, 3226308096, 3226308863, 'US', 'USA', 'الولايات المتحدة'),
(44422, 3226309120, 3226316799, 'US', 'USA', 'الولايات المتحدة'),
(44423, 3226318080, 3226318335, 'US', 'USA', 'الولايات المتحدة'),
(44424, 3226319360, 3226319615, 'US', 'USA', 'الولايات المتحدة'),
(44425, 3226320896, 3226331903, 'US', 'USA', 'الولايات المتحدة'),
(44426, 3226337536, 3226365439, 'US', 'USA', 'الولايات المتحدة'),
(44427, 3226365440, 3226365951, 'DE', 'DEU', 'ألمانيا'),
(44428, 3226365952, 3226374143, 'US', 'USA', 'الولايات المتحدة'),
(44429, 3226374144, 3226375423, 'DE', 'DEU', 'ألمانيا'),
(44430, 3226375424, 3226468351, 'US', 'USA', 'الولايات المتحدة'),
(44431, 3226470656, 3226473471, 'US', 'USA', 'الولايات المتحدة'),
(44432, 3226473472, 3226473983, 'PT', 'PRT', 'البورتوغال'),
(44433, 3226473984, 3226474495, 'US', 'USA', 'الولايات المتحدة'),
(44434, 3226474496, 3226474751, 'CL', 'CHL', 'تشيلي'),
(44435, 3226475264, 3226475519, 'US', 'USA', 'الولايات المتحدة'),
(44436, 3226475776, 3226476287, 'US', 'USA', 'الولايات المتحدة'),
(44437, 3226476288, 3226479359, 'CH', 'CHE', 'سويسرا'),
(44438, 3226479360, 3226479871, 'US', 'USA', 'الولايات المتحدة'),
(44439, 3226480128, 3226480383, 'GB', 'GBR', 'المملكة المتحدة'),
(44440, 3226480384, 3226481407, 'US', 'USA', 'الولايات المتحدة'),
(44441, 3226481408, 3226481663, 'DE', 'DEU', 'ألمانيا'),
(44442, 3226481664, 3226483199, 'US', 'USA', 'الولايات المتحدة'),
(44443, 3226483968, 3226484479, 'US', 'USA', 'الولايات المتحدة'),
(44444, 3226484736, 3226487295, 'US', 'USA', 'الولايات المتحدة'),
(44445, 3226488064, 3226488831, 'US', 'USA', 'الولايات المتحدة'),
(44446, 3226489088, 3226490879, 'US', 'USA', 'الولايات المتحدة'),
(44447, 3226491904, 3226492927, 'US', 'USA', 'الولايات المتحدة'),
(44448, 3226521344, 3226521855, 'US', 'USA', 'الولايات المتحدة'),
(44449, 3226521856, 3226522111, 'BR', 'BRA', 'البرازيل'),
(44450, 3226522112, 3226523135, 'US', 'USA', 'الولايات المتحدة'),
(44451, 3226523392, 3226533631, 'US', 'USA', 'الولايات المتحدة'),
(44452, 3226535936, 3226536191, 'US', 'USA', 'الولايات المتحدة'),
(44453, 3226546176, 3226546431, 'US', 'USA', 'الولايات المتحدة'),
(44454, 3226548992, 3226549247, 'BE', 'BEL', 'بلجيكا'),
(44455, 3226549504, 3226550015, 'GB', 'GBR', 'المملكة المتحدة'),
(44456, 3226551040, 3226551807, 'US', 'USA', 'الولايات المتحدة'),
(44457, 3226552832, 3226553087, 'US', 'USA', 'الولايات المتحدة'),
(44458, 3226555648, 3226555903, 'CA', 'CAN', 'كندا'),
(44459, 3226556416, 3226556671, 'US', 'USA', 'الولايات المتحدة'),
(44460, 3226558720, 3226558975, 'US', 'USA', 'الولايات المتحدة'),
(44461, 3226561792, 3226562047, 'NO', 'NOR', 'النرويج'),
(44462, 3226563072, 3226563327, 'US', 'USA', 'الولايات المتحدة'),
(44463, 3226564864, 3226565119, 'DE', 'DEU', 'ألمانيا'),
(44464, 3226565376, 3226565631, 'FI', 'FIN', 'فنلندا'),
(44465, 3226569984, 3226570239, 'US', 'USA', 'الولايات المتحدة'),
(44466, 3226574848, 3226575103, 'FI', 'FIN', 'فنلندا'),
(44467, 3226576384, 3226576639, 'US', 'USA', 'الولايات المتحدة'),
(44468, 3226580480, 3226581247, 'FI', 'FIN', 'فنلندا'),
(44469, 3226582528, 3226582783, 'US', 'USA', 'الولايات المتحدة'),
(44470, 3226583040, 3226583295, 'US', 'USA', 'الولايات المتحدة'),
(44471, 3226583552, 3226583807, 'SE', 'SWE', 'السويد'),
(44472, 3226592768, 3226593023, 'DE', 'DEU', 'ألمانيا'),
(44473, 3226593792, 3226594047, 'GB', 'GBR', 'المملكة المتحدة'),
(44474, 3226598400, 3226598911, 'US', 'USA', 'الولايات المتحدة'),
(44475, 3226599424, 3226625535, 'US', 'USA', 'الولايات المتحدة'),
(44476, 3226625792, 3226626047, 'US', 'USA', 'الولايات المتحدة'),
(44477, 3226626048, 3226626303, 'CA', 'CAN', 'كندا'),
(44478, 3226626304, 3226627327, 'US', 'USA', 'الولايات المتحدة'),
(44479, 3226627584, 3226629375, 'US', 'USA', 'الولايات المتحدة'),
(44480, 3226629376, 3226629631, 'CA', 'CAN', 'كندا'),
(44481, 3226629632, 3226630399, 'US', 'USA', 'الولايات المتحدة'),
(44482, 3226630400, 3226630655, 'GB', 'GBR', 'المملكة المتحدة'),
(44483, 3226630912, 3226631167, 'US', 'USA', 'الولايات المتحدة'),
(44484, 3226631168, 3226631423, 'CH', 'CHE', 'سويسرا'),
(44485, 3226631424, 3226631935, 'US', 'USA', 'الولايات المتحدة'),
(44486, 3226631936, 3226632191, 'PT', 'PRT', 'البورتوغال'),
(44487, 3226632192, 3226633215, 'CA', 'CAN', 'كندا'),
(44488, 3226633216, 3226633471, 'JP', 'JPN', 'اليابان'),
(44489, 3226635008, 3226635263, 'US', 'USA', 'الولايات المتحدة'),
(44490, 3226635264, 3226635519, 'AU', 'AUS', 'أستراليا'),
(44491, 3226635520, 3226635775, 'US', 'USA', 'الولايات المتحدة'),
(44492, 3226636032, 3226636287, 'AU', 'AUS', 'أستراليا'),
(44493, 3226637056, 3226637823, 'US', 'USA', 'الولايات المتحدة'),
(44494, 3226637824, 3226638079, 'CA', 'CAN', 'كندا'),
(44495, 3226638080, 3226638335, 'US', 'USA', 'الولايات المتحدة'),
(44496, 3226638592, 3226638847, 'GB', 'GBR', 'المملكة المتحدة'),
(44497, 3226638848, 3226639615, 'US', 'USA', 'الولايات المتحدة'),
(44498, 3226639616, 3226640127, 'AT', 'AUT', 'النمسا'),
(44499, 3226640128, 3226640639, 'US', 'USA', 'الولايات المتحدة'),
(44500, 3226640640, 3226640895, 'AU', 'AUS', 'أستراليا'),
(44501, 3226640896, 3226654207, 'US', 'USA', 'الولايات المتحدة'),
(44502, 3226654208, 3226654463, 'PT', 'PRT', 'البورتوغال'),
(44503, 3226654464, 3226655743, 'US', 'USA', 'الولايات المتحدة'),
(44504, 3226655744, 3226656255, 'IT', 'ITA', 'إيطاليا'),
(44505, 3226656256, 3226656511, 'AU', 'AUS', 'أستراليا'),
(44506, 3226656512, 3226658303, 'US', 'USA', 'الولايات المتحدة'),
(44507, 3226658304, 3226658559, 'AU', 'AUS', 'أستراليا'),
(44508, 3226658560, 3226658815, 'US', 'USA', 'الولايات المتحدة'),
(44509, 3226659072, 3226661119, 'US', 'USA', 'الولايات المتحدة'),
(44510, 3226661120, 3226661375, 'DE', 'DEU', 'ألمانيا'),
(44511, 3226661888, 3226662143, 'US', 'USA', 'الولايات المتحدة'),
(44512, 3226664960, 3226690815, 'FI', 'FIN', 'فنلندا'),
(44513, 3226690816, 3226691071, 'CA', 'CAN', 'كندا'),
(44514, 3226691072, 3226691327, 'GB', 'GBR', 'المملكة المتحدة'),
(44515, 3226691584, 3226691839, 'JP', 'JPN', 'اليابان'),
(44516, 3226691840, 3226693119, 'US', 'USA', 'الولايات المتحدة'),
(44517, 3226693376, 3226693887, 'US', 'USA', 'الولايات المتحدة'),
(44518, 3226694144, 3226695167, 'US', 'USA', 'الولايات المتحدة'),
(44519, 3226695168, 3226695679, 'AU', 'AUS', 'أستراليا'),
(44520, 3226695680, 3226695935, 'US', 'USA', 'الولايات المتحدة'),
(44521, 3226695936, 3226696191, 'CA', 'CAN', 'كندا'),
(44522, 3226696192, 3226696447, 'CN', 'CHN', 'الصين'),
(44523, 3226696448, 3226696703, 'AU', 'AUS', 'أستراليا'),
(44524, 3226705152, 3226705407, 'JP', 'JPN', 'اليابان'),
(44525, 3226705408, 3226705919, 'US', 'USA', 'الولايات المتحدة'),
(44526, 3226705920, 3226706175, 'FR', 'FRA', 'فرنسا'),
(44527, 3226706176, 3226706943, 'US', 'USA', 'الولايات المتحدة'),
(44528, 3226707456, 3226715391, 'TW', 'TWN', 'تايوان'),
(44529, 3226715392, 3226715647, 'US', 'USA', 'الولايات المتحدة'),
(44530, 3226715648, 3226715903, 'AU', 'AUS', 'أستراليا'),
(44531, 3226715904, 3226716159, 'US', 'USA', 'الولايات المتحدة'),
(44532, 3226716160, 3226716415, 'GB', 'GBR', 'المملكة المتحدة'),
(44533, 3226716672, 3226716927, 'GB', 'GBR', 'المملكة المتحدة'),
(44534, 3226716928, 3226717439, 'US', 'USA', 'الولايات المتحدة'),
(44535, 3226717696, 3226717951, 'US', 'USA', 'الولايات المتحدة'),
(44536, 3226717952, 3226720511, 'GB', 'GBR', 'المملكة المتحدة'),
(44537, 3226720512, 3226721279, 'JP', 'JPN', 'اليابان'),
(44538, 3226721280, 3226721791, 'US', 'USA', 'الولايات المتحدة'),
(44539, 3226722048, 3226722303, 'CH', 'CHE', 'سويسرا'),
(44540, 3226722304, 3226722559, 'AU', 'AUS', 'أستراليا'),
(44541, 3226722560, 3226723583, 'US', 'USA', 'الولايات المتحدة'),
(44542, 3226723584, 3226723839, 'DE', 'DEU', 'ألمانيا'),
(44543, 3226723840, 3226724095, 'JP', 'JPN', 'اليابان'),
(44544, 3226724096, 3226724351, 'AU', 'AUS', 'أستراليا'),
(44545, 3226724352, 3226725631, 'US', 'USA', 'الولايات المتحدة'),
(44546, 3226725632, 3226726143, 'AU', 'AUS', 'أستراليا'),
(44547, 3226726144, 3226728191, 'US', 'USA', 'الولايات المتحدة'),
(44548, 3226728192, 3226728447, 'CA', 'CAN', 'كندا'),
(44549, 3226728448, 3226729983, 'US', 'USA', 'الولايات المتحدة'),
(44550, 3226731008, 3226731519, 'US', 'USA', 'الولايات المتحدة'),
(44551, 3226731776, 3226732031, 'GB', 'GBR', 'المملكة المتحدة'),
(44552, 3226732288, 3226733567, 'US', 'USA', 'الولايات المتحدة'),
(44553, 3226733568, 3226733823, 'MX', 'MEX', 'المكسيك'),
(44554, 3226733824, 3226734079, 'PT', 'PRT', 'البورتوغال'),
(44555, 3226734080, 3226734335, 'US', 'USA', 'الولايات المتحدة'),
(44556, 3226734336, 3226734591, 'PT', 'PRT', 'البورتوغال'),
(44557, 3226734592, 3226736383, 'US', 'USA', 'الولايات المتحدة'),
(44558, 3226736640, 3226737407, 'US', 'USA', 'الولايات المتحدة'),
(44559, 3226737408, 3226737663, 'AT', 'AUT', 'النمسا'),
(44560, 3226737664, 3226738175, 'US', 'USA', 'الولايات المتحدة'),
(44561, 3226738176, 3226738431, 'NL', 'NLD', 'هولندا'),
(44562, 3226738432, 3226738687, 'US', 'USA', 'الولايات المتحدة'),
(44563, 3226738688, 3226739199, 'NO', 'NOR', 'النرويج'),
(44564, 3226740736, 3226742783, 'US', 'USA', 'الولايات المتحدة'),
(44565, 3226744576, 3226746367, 'US', 'USA', 'الولايات المتحدة'),
(44566, 3226746368, 3226746623, 'PT', 'PRT', 'البورتوغال'),
(44567, 3226746624, 3226748671, 'US', 'USA', 'الولايات المتحدة'),
(44568, 3226748672, 3226749439, 'JP', 'JPN', 'اليابان'),
(44569, 3226749440, 3226749695, 'US', 'USA', 'الولايات المتحدة'),
(44570, 3226749696, 3226752255, 'GB', 'GBR', 'المملكة المتحدة'),
(44571, 3226752256, 3226752767, 'US', 'USA', 'الولايات المتحدة'),
(44572, 3226752768, 3226753023, 'IT', 'ITA', 'إيطاليا'),
(44573, 3226753024, 3226753279, 'US', 'USA', 'الولايات المتحدة'),
(44574, 3226753280, 3226753535, 'AU', 'AUS', 'أستراليا'),
(44575, 3226753536, 3226753791, 'SI', 'SVN', 'سلوفينيا'),
(44576, 3226753792, 3226754303, 'HR', 'HRV', 'كرواتيا'),
(44577, 3226754304, 3226756095, 'SI', 'SVN', 'سلوفينيا'),
(44578, 3226756352, 3226757375, 'SI', 'SVN', 'سلوفينيا'),
(44579, 3226757376, 3226757887, 'HR', 'HRV', 'كرواتيا'),
(44580, 3226757888, 3226758655, 'SI', 'SVN', 'سلوفينيا'),
(44581, 3226758912, 3226762751, 'US', 'USA', 'الولايات المتحدة'),
(44582, 3226763008, 3226770687, 'IT', 'ITA', 'إيطاليا'),
(44583, 3226770688, 3226772991, 'US', 'USA', 'الولايات المتحدة'),
(44584, 3226772992, 3226773247, 'CH', 'CHE', 'سويسرا'),
(44585, 3226773248, 3226774783, 'US', 'USA', 'الولايات المتحدة'),
(44586, 3226774784, 3226775039, 'GB', 'GBR', 'المملكة المتحدة'),
(44587, 3226775040, 3226775295, 'US', 'USA', 'الولايات المتحدة'),
(44588, 3226775552, 3226783743, 'FI', 'FIN', 'فنلندا'),
(44589, 3226783744, 3226783999, 'US', 'USA', 'الولايات المتحدة'),
(44590, 3226784256, 3226784767, 'US', 'USA', 'الولايات المتحدة'),
(44591, 3226784768, 3226785023, 'GB', 'GBR', 'المملكة المتحدة'),
(44592, 3226785024, 3226786559, 'US', 'USA', 'الولايات المتحدة'),
(44593, 3226786560, 3226786815, 'AU', 'AUS', 'أستراليا'),
(44594, 3226786816, 3226787071, 'DE', 'DEU', 'ألمانيا'),
(44595, 3226787072, 3226787327, 'AT', 'AUT', 'النمسا'),
(44596, 3226787328, 3226788095, 'US', 'USA', 'الولايات المتحدة'),
(44597, 3226788352, 3226789375, 'HU', 'HUN', 'هنغاريا'),
(44598, 3226789376, 3226789631, 'AU', 'AUS', 'أستراليا'),
(44599, 3226789632, 3226791167, 'US', 'USA', 'الولايات المتحدة'),
(44600, 3226791168, 3226791679, 'AU', 'AUS', 'أستراليا'),
(44601, 3226791680, 3226792191, 'US', 'USA', 'الولايات المتحدة'),
(44602, 3226792192, 3226792703, 'AU', 'AUS', 'أستراليا'),
(44603, 3226792704, 3226792959, 'US', 'USA', 'الولايات المتحدة'),
(44604, 3226793216, 3226793983, 'DE', 'DEU', 'ألمانيا'),
(44605, 3226793984, 3226794239, 'US', 'USA', 'الولايات المتحدة'),
(44606, 3226794496, 3226795263, 'US', 'USA', 'الولايات المتحدة'),
(44607, 3226795264, 3226795519, 'NZ', 'NZL', 'نيوزيلاندا'),
(44608, 3226795520, 3226795775, 'US', 'USA', 'الولايات المتحدة'),
(44609, 3226796032, 3226861567, 'US', 'USA', 'الولايات المتحدة'),
(44610, 3226861824, 3226862079, 'CA', 'CAN', 'كندا'),
(44611, 3226862080, 3226864383, 'US', 'USA', 'الولايات المتحدة'),
(44612, 3226864384, 3226864639, 'RU', 'RUS', 'الإتحاد الروسي'),
(44613, 3226864640, 3226864895, 'NZ', 'NZL', 'نيوزيلاندا'),
(44614, 3226864896, 3226865151, 'US', 'USA', 'الولايات المتحدة'),
(44615, 3226865152, 3226865407, 'PL', 'POL', 'بولندا'),
(44616, 3226865408, 3226866175, 'US', 'USA', 'الولايات المتحدة'),
(44617, 3226866176, 3226866431, 'GB', 'GBR', 'المملكة المتحدة'),
(44618, 3226866432, 3226866943, 'US', 'USA', 'الولايات المتحدة'),
(44619, 3226867456, 3226867967, 'US', 'USA', 'الولايات المتحدة'),
(44620, 3226867968, 3226868223, 'IL', 'ISR', 'إسرائيل'),
(44621, 3226868224, 3226868479, 'US', 'USA', 'الولايات المتحدة'),
(44622, 3226868480, 3226868735, 'GB', 'GBR', 'المملكة المتحدة'),
(44623, 3226868736, 3226882303, 'US', 'USA', 'الولايات المتحدة'),
(44624, 3226882560, 3226884351, 'US', 'USA', 'الولايات المتحدة'),
(44625, 3226884352, 3226884607, 'IL', 'ISR', 'إسرائيل'),
(44626, 3226884608, 3226892799, 'US', 'USA', 'الولايات المتحدة'),
(44627, 3226893056, 3226893567, 'US', 'USA', 'الولايات المتحدة'),
(44628, 3226893568, 3226894079, 'NL', 'NLD', 'هولندا'),
(44629, 3226894080, 3226894335, 'GB', 'GBR', 'المملكة المتحدة'),
(44630, 3226894336, 3226894591, 'US', 'USA', 'الولايات المتحدة'),
(44631, 3226894592, 3226894847, 'AU', 'AUS', 'أستراليا'),
(44632, 3226895104, 3226895359, 'US', 'USA', 'الولايات المتحدة'),
(44633, 3226895360, 3226895871, 'SG', 'SGP', 'سنغافورة'),
(44634, 3226895872, 3226896127, 'GB', 'GBR', 'المملكة المتحدة'),
(44635, 3226896128, 3226896639, 'US', 'USA', 'الولايات المتحدة'),
(44636, 3226896640, 3226896895, 'GB', 'GBR', 'المملكة المتحدة'),
(44637, 3226896896, 3226897151, 'PT', 'PRT', 'البورتوغال'),
(44638, 3226897152, 3226902527, 'US', 'USA', 'الولايات المتحدة'),
(44639, 3226903040, 3226903295, 'US', 'USA', 'الولايات المتحدة'),
(44640, 3226903296, 3226903551, 'DE', 'DEU', 'ألمانيا'),
(44641, 3226903552, 3226903807, 'US', 'USA', 'الولايات المتحدة'),
(44642, 3226903808, 3226904063, 'AU', 'AUS', 'أستراليا'),
(44643, 3226904064, 3226904319, 'CH', 'CHE', 'سويسرا'),
(44644, 3226904320, 3226904575, 'FR', 'FRA', 'فرنسا'),
(44645, 3226904576, 3226904831, 'US', 'USA', 'الولايات المتحدة'),
(44646, 3226904832, 3226905087, 'GB', 'GBR', 'المملكة المتحدة'),
(44647, 3226905088, 3226926591, 'US', 'USA', 'الولايات المتحدة'),
(44648, 3226926592, 3226926847, 'SE', 'SWE', 'السويد'),
(44649, 3226927104, 3226992639, 'NL', 'NLD', 'هولندا'),
(44650, 3226992896, 3226993151, 'CH', 'CHE', 'سويسرا'),
(44651, 3226993152, 3226993663, 'US', 'USA', 'الولايات المتحدة'),
(44652, 3226993664, 3226993919, 'DE', 'DEU', 'ألمانيا'),
(44653, 3226993920, 3226994175, 'US', 'USA', 'الولايات المتحدة'),
(44654, 3226994176, 3226994687, 'AU', 'AUS', 'أستراليا'),
(44655, 3226994688, 3226994943, 'US', 'USA', 'الولايات المتحدة'),
(44656, 3226994944, 3226995455, 'GB', 'GBR', 'المملكة المتحدة'),
(44657, 3226995456, 3226996479, 'US', 'USA', 'الولايات المتحدة'),
(44658, 3226996992, 3226997247, 'PT', 'PRT', 'البورتوغال'),
(44659, 3226998016, 3226998527, 'US', 'USA', 'الولايات المتحدة'),
(44660, 3226998528, 3226999039, 'AT', 'AUT', 'النمسا'),
(44661, 3226999040, 3227005439, 'US', 'USA', 'الولايات المتحدة'),
(44662, 3227005696, 3227013119, 'US', 'USA', 'الولايات المتحدة'),
(44663, 3227013120, 3227013375, 'JP', 'JPN', 'اليابان'),
(44664, 3227013376, 3227013887, 'US', 'USA', 'الولايات المتحدة'),
(44665, 3227013888, 3227014399, 'GB', 'GBR', 'المملكة المتحدة'),
(44666, 3227014400, 3227014655, 'NZ', 'NZL', 'نيوزيلاندا'),
(44667, 3227014656, 3227014911, 'FI', 'FIN', 'فنلندا'),
(44668, 3227014912, 3227017215, 'US', 'USA', 'الولايات المتحدة'),
(44669, 3227017472, 3227017983, 'DE', 'DEU', 'ألمانيا'),
(44670, 3227017984, 3227018239, 'US', 'USA', 'الولايات المتحدة'),
(44671, 3227018752, 3227019007, 'JP', 'JPN', 'اليابان'),
(44672, 3227019008, 3227020287, 'US', 'USA', 'الولايات المتحدة'),
(44673, 3227020288, 3227020543, 'DE', 'DEU', 'ألمانيا'),
(44674, 3227020800, 3227022847, 'US', 'USA', 'الولايات المتحدة'),
(44675, 3227022848, 3227023103, 'GB', 'GBR', 'المملكة المتحدة'),
(44676, 3227023104, 3227023359, 'NZ', 'NZL', 'نيوزيلاندا'),
(44677, 3227023360, 3227023615, 'US', 'USA', 'الولايات المتحدة'),
(44678, 3227023872, 3227024127, 'US', 'USA', 'الولايات المتحدة'),
(44679, 3227024128, 3227024383, 'PT', 'PRT', 'البورتوغال'),
(44680, 3227024384, 3227024895, 'US', 'USA', 'الولايات المتحدة'),
(44681, 3227025408, 3227025663, 'GB', 'GBR', 'المملكة المتحدة'),
(44682, 3227025664, 3227025919, 'US', 'USA', 'الولايات المتحدة'),
(44683, 3227025920, 3227026175, 'GB', 'GBR', 'المملكة المتحدة'),
(44684, 3227026176, 3227026687, 'US', 'USA', 'الولايات المتحدة'),
(44685, 3227026688, 3227026943, 'GB', 'GBR', 'المملكة المتحدة'),
(44686, 3227027456, 3227032319, 'US', 'USA', 'الولايات المتحدة'),
(44687, 3227032576, 3227038207, 'US', 'USA', 'الولايات المتحدة'),
(44688, 3227039744, 3227040255, 'US', 'USA', 'الولايات المتحدة'),
(44689, 3227040512, 3227040767, 'AU', 'AUS', 'أستراليا'),
(44690, 3227040768, 3227041279, 'US', 'USA', 'الولايات المتحدة'),
(44691, 3227041280, 3227041535, 'NZ', 'NZL', 'نيوزيلاندا'),
(44692, 3227041536, 3227042815, 'US', 'USA', 'الولايات المتحدة'),
(44693, 3227042816, 3227043071, 'IT', 'ITA', 'إيطاليا'),
(44694, 3227043072, 3227043327, 'US', 'USA', 'الولايات المتحدة'),
(44695, 3227043584, 3227044863, 'US', 'USA', 'الولايات المتحدة'),
(44696, 3227045120, 3227053567, 'US', 'USA', 'الولايات المتحدة'),
(44697, 3227053568, 3227053823, 'GB', 'GBR', 'المملكة المتحدة'),
(44698, 3227053824, 3227054079, 'DE', 'DEU', 'ألمانيا'),
(44699, 3227054080, 3227056639, 'US', 'USA', 'الولايات المتحدة'),
(44700, 3227056640, 3227057919, 'PT', 'PRT', 'البورتوغال'),
(44701, 3227058176, 3227083519, 'FI', 'FIN', 'فنلندا'),
(44702, 3227083520, 3227083775, 'ES', 'ESP', 'إسبانيا'),
(44703, 3227083776, 3227123711, 'FI', 'FIN', 'فنلندا'),
(44704, 3227123712, 3227189247, 'US', 'USA', 'الولايات المتحدة'),
(44705, 3227189504, 3227224831, 'US', 'USA', 'الولايات المتحدة'),
(44706, 3227225088, 3227225599, 'LU', 'LUX', 'لوكسيمبورغ'),
(44707, 3227225600, 3227226111, 'US', 'USA', 'الولايات المتحدة'),
(44708, 3227226368, 3227234559, 'US', 'USA', 'الولايات المتحدة'),
(44709, 3227234560, 3227234815, 'PT', 'PRT', 'البورتوغال'),
(44710, 3227234816, 3227235071, 'US', 'USA', 'الولايات المتحدة'),
(44711, 3227235072, 3227235327, 'AU', 'AUS', 'أستراليا'),
(44712, 3227235328, 3227236607, 'US', 'USA', 'الولايات المتحدة'),
(44713, 3227236608, 3227236863, 'AU', 'AUS', 'أستراليا'),
(44714, 3227236864, 3227237119, 'RU', 'RUS', 'الإتحاد الروسي'),
(44715, 3227237120, 3227237631, 'US', 'USA', 'الولايات المتحدة'),
(44716, 3227237632, 3227237887, 'NO', 'NOR', 'النرويج'),
(44717, 3227237888, 3227238143, 'US', 'USA', 'الولايات المتحدة'),
(44718, 3227238144, 3227238399, 'GB', 'GBR', 'المملكة المتحدة'),
(44719, 3227238400, 3227239935, 'US', 'USA', 'الولايات المتحدة'),
(44720, 3227240192, 3227240447, 'GB', 'GBR', 'المملكة المتحدة'),
(44721, 3227240448, 3227240703, 'BE', 'BEL', 'بلجيكا'),
(44722, 3227240704, 3227240959, 'GB', 'GBR', 'المملكة المتحدة'),
(44723, 3227240960, 3227241471, 'US', 'USA', 'الولايات المتحدة'),
(44724, 3227241728, 3227243007, 'US', 'USA', 'الولايات المتحدة'),
(44725, 3227243008, 3227243263, 'CA', 'CAN', 'كندا'),
(44726, 3227243264, 3227243519, 'GB', 'GBR', 'المملكة المتحدة'),
(44727, 3227243520, 3227243775, 'US', 'USA', 'الولايات المتحدة'),
(44728, 3227243776, 3227244031, 'AU', 'AUS', 'أستراليا'),
(44729, 3227244032, 3227249151, 'SE', 'SWE', 'السويد'),
(44730, 3227249408, 3227249663, 'US', 'USA', 'الولايات المتحدة'),
(44731, 3227249664, 3227252735, 'CH', 'CHE', 'سويسرا'),
(44732, 3227252736, 3227252991, 'US', 'USA', 'الولايات المتحدة'),
(44733, 3227253248, 3227254271, 'US', 'USA', 'الولايات المتحدة'),
(44734, 3227257088, 3227258623, 'US', 'USA', 'الولايات المتحدة'),
(44735, 3227258624, 3227258879, 'NZ', 'NZL', 'نيوزيلاندا'),
(44736, 3227258880, 3227259135, 'US', 'USA', 'الولايات المتحدة'),
(44737, 3227259392, 3227276543, 'US', 'USA', 'الولايات المتحدة'),
(44738, 3227276800, 3227277055, 'FR', 'FRA', 'فرنسا'),
(44739, 3227277312, 3227278847, 'US', 'USA', 'الولايات المتحدة'),
(44740, 3227278848, 3227279103, 'IE', 'IRL', 'إيرلندا'),
(44741, 3227279104, 3227279615, 'US', 'USA', 'الولايات المتحدة'),
(44742, 3227279872, 3227280895, 'US', 'USA', 'الولايات المتحدة'),
(44743, 3227281152, 3227281407, 'US', 'USA', 'الولايات المتحدة'),
(44744, 3227281408, 3227282175, 'IT', 'ITA', 'إيطاليا'),
(44745, 3227282176, 3227282431, 'US', 'USA', 'الولايات المتحدة'),
(44746, 3227282432, 3227282687, 'NL', 'NLD', 'هولندا'),
(44747, 3227282688, 3227282943, 'GB', 'GBR', 'المملكة المتحدة'),
(44748, 3227282944, 3227284479, 'US', 'USA', 'الولايات المتحدة'),
(44749, 3227284480, 3227284735, 'FI', 'FIN', 'فنلندا'),
(44750, 3227284992, 3227286783, 'US', 'USA', 'الولايات المتحدة'),
(44751, 3227286784, 3227287039, 'AT', 'AUT', 'النمسا'),
(44752, 3227287040, 3227287295, 'IT', 'ITA', 'إيطاليا'),
(44753, 3227287296, 3227287551, 'NL', 'NLD', 'هولندا'),
(44754, 3227287552, 3227287807, 'CH', 'CHE', 'سويسرا'),
(44755, 3227287808, 3227288063, 'BG', 'BGR', 'بلغاريا'),
(44756, 3227288064, 3227288319, 'BE', 'BEL', 'بلجيكا'),
(44757, 3227288320, 3227288831, 'NL', 'NLD', 'هولندا'),
(44758, 3227288832, 3227289087, 'PT', 'PRT', 'البورتوغال'),
(44759, 3227289088, 3227289343, 'NL', 'NLD', 'هولندا'),
(44760, 3227289344, 3227289599, 'PT', 'PRT', 'البورتوغال'),
(44761, 3227289600, 3227290111, 'NL', 'NLD', 'هولندا'),
(44762, 3227290112, 3227290367, 'AT', 'AUT', 'النمسا'),
(44763, 3227290368, 3227290623, 'CH', 'CHE', 'سويسرا'),
(44764, 3227290880, 3227291135, 'AT', 'AUT', 'النمسا'),
(44765, 3227291136, 3227294463, 'PT', 'PRT', 'البورتوغال'),
(44766, 3227294464, 3227294975, 'GR', 'GRC', 'اليونان'),
(44767, 3227295232, 3227299839, 'US', 'USA', 'الولايات المتحدة'),
(44768, 3227300096, 3227301375, 'US', 'USA', 'الولايات المتحدة'),
(44769, 3227301632, 3227302399, 'US', 'USA', 'الولايات المتحدة'),
(44770, 3227302656, 3227304191, 'US', 'USA', 'الولايات المتحدة'),
(44771, 3227304448, 3227304959, 'US', 'USA', 'الولايات المتحدة'),
(44772, 3227305216, 3227305983, 'US', 'USA', 'الولايات المتحدة'),
(44773, 3227309824, 3227310079, 'US', 'USA', 'الولايات المتحدة'),
(44774, 3227310080, 3227310335, 'NO', 'NOR', 'النرويج'),
(44775, 3227310336, 3227312127, 'US', 'USA', 'الولايات المتحدة'),
(44776, 3227312128, 3227312383, 'DK', 'DNK', 'الدنيمارك'),
(44777, 3227312384, 3227314943, 'US', 'USA', 'الولايات المتحدة'),
(44778, 3227320320, 3227361791, 'FR', 'FRA', 'فرنسا'),
(44779, 3227361792, 3227362303, 'US', 'USA', 'الولايات المتحدة'),
(44780, 3227362304, 3227385855, 'FR', 'FRA', 'فرنسا'),
(44781, 3227386112, 3227391999, 'US', 'USA', 'الولايات المتحدة'),
(44782, 3227392000, 3227392255, 'PT', 'PRT', 'البورتوغال'),
(44783, 3227392256, 3227393023, 'US', 'USA', 'الولايات المتحدة'),
(44784, 3227393024, 3227393279, 'AT', 'AUT', 'النمسا'),
(44785, 3227393280, 3227396351, 'US', 'USA', 'الولايات المتحدة'),
(44786, 3227396352, 3227396607, 'AU', 'AUS', 'أستراليا'),
(44787, 3227396608, 3227398399, 'US', 'USA', 'الولايات المتحدة'),
(44788, 3227398656, 3227400447, 'US', 'USA', 'الولايات المتحدة'),
(44789, 3227400448, 3227400703, 'AT', 'AUT', 'النمسا'),
(44790, 3227400704, 3227400959, 'GB', 'GBR', 'المملكة المتحدة'),
(44791, 3227400960, 3227401471, 'US', 'USA', 'الولايات المتحدة'),
(44792, 3227401728, 3227402495, 'AU', 'AUS', 'أستراليا'),
(44793, 3227402496, 3227403007, 'US', 'USA', 'الولايات المتحدة'),
(44794, 3227403008, 3227403519, 'GR', 'GRC', 'اليونان'),
(44795, 3227403520, 3227403775, 'US', 'USA', 'الولايات المتحدة'),
(44796, 3227404544, 3227405311, 'US', 'USA', 'الولايات المتحدة'),
(44797, 3227405312, 3227405567, 'DE', 'DEU', 'ألمانيا'),
(44798, 3227405568, 3227414015, 'US', 'USA', 'الولايات المتحدة'),
(44799, 3227414272, 3227415551, 'GB', 'GBR', 'المملكة المتحدة'),
(44800, 3227415552, 3227415807, 'US', 'USA', 'الولايات المتحدة'),
(44801, 3227415808, 3227416063, 'GB', 'GBR', 'المملكة المتحدة'),
(44802, 3227416064, 3227417087, 'US', 'USA', 'الولايات المتحدة'),
(44803, 3227417088, 3227417343, 'BN', 'BRN', 'بروناي دار السلام'),
(44804, 3227417344, 3227417599, 'US', 'USA', 'الولايات المتحدة'),
(44805, 3227417856, 3227418111, 'US', 'USA', 'الولايات المتحدة'),
(44806, 3227418112, 3227418367, 'CA', 'CAN', 'كندا'),
(44807, 3227418368, 3227425023, 'US', 'USA', 'الولايات المتحدة'),
(44808, 3227425280, 3227425791, 'US', 'USA', 'الولايات المتحدة'),
(44809, 3227425792, 3227427583, 'DK', 'DNK', 'الدنيمارك'),
(44810, 3227427584, 3227427839, 'ES', 'ESP', 'إسبانيا'),
(44811, 3227427840, 3227428351, 'US', 'USA', 'الولايات المتحدة'),
(44812, 3227428608, 3227429119, 'US', 'USA', 'الولايات المتحدة'),
(44813, 3227429120, 3227429375, 'NZ', 'NZL', 'نيوزيلاندا'),
(44814, 3227429376, 3227429887, 'US', 'USA', 'الولايات المتحدة'),
(44815, 3227429888, 3227430143, 'GB', 'GBR', 'المملكة المتحدة'),
(44816, 3227430144, 3227430399, 'US', 'USA', 'الولايات المتحدة'),
(44817, 3227430400, 3227430655, 'HK', 'HKG', 'هونغ كونغ'),
(44818, 3227430656, 3227437055, 'FR', 'FRA', 'فرنسا'),
(44819, 3227437056, 3227437311, 'AU', 'AUS', 'أستراليا'),
(44820, 3227437312, 3227437823, 'US', 'USA', 'الولايات المتحدة'),
(44821, 3227438848, 3227439103, 'US', 'USA', 'الولايات المتحدة'),
(44822, 3227439104, 3227439615, 'AU', 'AUS', 'أستراليا'),
(44823, 3227439872, 3227440127, 'US', 'USA', 'الولايات المتحدة'),
(44824, 3227440128, 3227440383, 'IT', 'ITA', 'إيطاليا'),
(44825, 3227440384, 3227442175, 'US', 'USA', 'الولايات المتحدة'),
(44826, 3227442176, 3227442431, 'JP', 'JPN', 'اليابان'),
(44827, 3227442432, 3227442687, 'RU', 'RUS', 'الإتحاد الروسي'),
(44828, 3227442688, 3227443711, 'US', 'USA', 'الولايات المتحدة'),
(44829, 3227443712, 3227443967, 'AT', 'AUT', 'النمسا'),
(44830, 3227443968, 3227444223, 'AU', 'AUS', 'أستراليا'),
(44831, 3227444224, 3227445503, 'US', 'USA', 'الولايات المتحدة'),
(44832, 3227445504, 3227445759, 'CH', 'CHE', 'سويسرا'),
(44833, 3227445760, 3227446015, 'US', 'USA', 'الولايات المتحدة'),
(44834, 3227446016, 3227446271, 'GB', 'GBR', 'المملكة المتحدة'),
(44835, 3227446272, 3227446783, 'US', 'USA', 'الولايات المتحدة'),
(44836, 3227446784, 3227447039, 'JP', 'JPN', 'اليابان'),
(44837, 3227447040, 3227447295, 'AT', 'AUT', 'النمسا'),
(44838, 3227447808, 3227448063, 'US', 'USA', 'الولايات المتحدة'),
(44839, 3227448064, 3227448575, 'AU', 'AUS', 'أستراليا'),
(44840, 3227448576, 3227448831, 'US', 'USA', 'الولايات المتحدة'),
(44841, 3227449088, 3227450111, 'US', 'USA', 'الولايات المتحدة'),
(44842, 3227468032, 3227468287, 'US', 'USA', 'الولايات المتحدة'),
(44843, 3227582464, 3227647999, 'US', 'USA', 'الولايات المتحدة'),
(44844, 3227648000, 3227659775, 'FI', 'FIN', 'فنلندا'),
(44845, 3227659776, 3227660031, 'JP', 'JPN', 'اليابان'),
(44846, 3227660032, 3227660543, 'FI', 'FIN', 'فنلندا'),
(44847, 3227660544, 3227660799, 'EE', 'EST', 'إستونيا'),
(44848, 3227660800, 3227713535, 'FI', 'FIN', 'فنلندا'),
(44849, 3227779584, 3227779839, 'KR', 'KOR', 'جمهورية كوريا'),
(44850, 3227779840, 3227783679, 'US', 'USA', 'الولايات المتحدة'),
(44851, 3227783680, 3227783935, 'FR', 'FRA', 'فرنسا'),
(44852, 3227783936, 3227784703, 'US', 'USA', 'الولايات المتحدة'),
(44853, 3227784704, 3227784959, 'AU', 'AUS', 'أستراليا'),
(44854, 3227784960, 3227785727, 'AT', 'AUT', 'النمسا'),
(44855, 3227785728, 3227786495, 'US', 'USA', 'الولايات المتحدة'),
(44856, 3227786752, 3227792383, 'US', 'USA', 'الولايات المتحدة'),
(44857, 3227792384, 3227792639, 'GB', 'GBR', 'المملكة المتحدة'),
(44858, 3227792640, 3227792895, 'NZ', 'NZL', 'نيوزيلاندا'),
(44859, 3227792896, 3227794687, 'US', 'USA', 'الولايات المتحدة'),
(44860, 3227794688, 3227794943, 'GB', 'GBR', 'المملكة المتحدة'),
(44861, 3227794944, 3227795199, 'US', 'USA', 'الولايات المتحدة'),
(44862, 3227795200, 3227795455, 'NO', 'NOR', 'النرويج'),
(44863, 3227795456, 3227797503, 'US', 'USA', 'الولايات المتحدة'),
(44864, 3227798528, 3227798783, 'US', 'USA', 'الولايات المتحدة'),
(44865, 3227798784, 3227799039, 'TH', 'THA', 'تايلند'),
(44866, 3227799040, 3227799295, 'GB', 'GBR', 'المملكة المتحدة'),
(44867, 3227799296, 3227799551, 'US', 'USA', 'الولايات المتحدة'),
(44868, 3227799552, 3227799807, 'AU', 'AUS', 'أستراليا'),
(44869, 3227799808, 3227800063, 'US', 'USA', 'الولايات المتحدة'),
(44870, 3227800320, 3227801343, 'US', 'USA', 'الولايات المتحدة'),
(44871, 3227801600, 3227803647, 'US', 'USA', 'الولايات المتحدة'),
(44872, 3227803648, 3227804415, 'DE', 'DEU', 'ألمانيا'),
(44873, 3227804416, 3227804671, 'GB', 'GBR', 'المملكة المتحدة'),
(44874, 3227804672, 3227804927, 'US', 'USA', 'الولايات المتحدة'),
(44875, 3227804928, 3227805183, 'CA', 'CAN', 'كندا'),
(44876, 3227805184, 3227813375, 'FI', 'FIN', 'فنلندا'),
(44877, 3227813376, 3227813631, 'US', 'USA', 'الولايات المتحدة'),
(44878, 3227813632, 3227815167, 'GB', 'GBR', 'المملكة المتحدة'),
(44879, 3227815168, 3227815935, 'US', 'USA', 'الولايات المتحدة'),
(44880, 3227815936, 3227816191, 'GB', 'GBR', 'المملكة المتحدة'),
(44881, 3227816192, 3227818495, 'US', 'USA', 'الولايات المتحدة'),
(44882, 3227818496, 3227818751, 'GB', 'GBR', 'المملكة المتحدة'),
(44883, 3227818752, 3227844351, 'MX', 'MEX', 'المكسيك'),
(44884, 3227844864, 3227845119, 'ES', 'ESP', 'إسبانيا'),
(44885, 3227845120, 3227845631, 'US', 'USA', 'الولايات المتحدة'),
(44886, 3227845632, 3227845887, 'RU', 'RUS', 'الإتحاد الروسي'),
(44887, 3227846144, 3227846655, 'US', 'USA', 'الولايات المتحدة'),
(44888, 3227846656, 3227846911, 'ES', 'ESP', 'إسبانيا'),
(44889, 3227847424, 3227847679, 'GB', 'GBR', 'المملكة المتحدة'),
(44890, 3227847680, 3227848703, 'US', 'USA', 'الولايات المتحدة'),
(44891, 3227848704, 3227848959, 'NZ', 'NZL', 'نيوزيلاندا'),
(44892, 3227848960, 3227851775, 'US', 'USA', 'الولايات المتحدة'),
(44893, 3227851776, 3227852031, 'DE', 'DEU', 'ألمانيا'),
(44894, 3227852032, 3227853055, 'US', 'USA', 'الولايات المتحدة'),
(44895, 3227853312, 3227853567, 'GB', 'GBR', 'المملكة المتحدة'),
(44896, 3227853568, 3227856127, 'US', 'USA', 'الولايات المتحدة'),
(44897, 3227856896, 3227860991, 'US', 'USA', 'الولايات المتحدة'),
(44898, 3227863808, 3227864063, 'DE', 'DEU', 'ألمانيا'),
(44899, 3227864064, 3227864831, 'US', 'USA', 'الولايات المتحدة'),
(44900, 3227865088, 3227865343, 'US', 'USA', 'الولايات المتحدة'),
(44901, 3227865344, 3227867903, 'NL', 'NLD', 'هولندا'),
(44902, 3227867904, 3227868159, 'TH', 'THA', 'تايلند'),
(44903, 3227868160, 3227873023, 'US', 'USA', 'الولايات المتحدة'),
(44904, 3227873024, 3227874047, 'NL', 'NLD', 'هولندا'),
(44905, 3227874048, 3227874815, 'US', 'USA', 'الولايات المتحدة'),
(44906, 3227874816, 3227875071, 'PT', 'PRT', 'البورتوغال'),
(44907, 3227875072, 3227878911, 'US', 'USA', 'الولايات المتحدة'),
(44908, 3227878912, 3227879167, 'AU', 'AUS', 'أستراليا'),
(44909, 3227879168, 3227879679, 'US', 'USA', 'الولايات المتحدة'),
(44910, 3227879680, 3227879935, 'GB', 'GBR', 'المملكة المتحدة'),
(44911, 3227880192, 3227880959, 'US', 'USA', 'الولايات المتحدة'),
(44912, 3227881472, 3227885567, 'US', 'USA', 'الولايات المتحدة'),
(44913, 3227885824, 3227887871, 'ES', 'ESP', 'إسبانيا'),
(44914, 3227887872, 3227888127, 'PR', 'PRI', 'بورتو ريكو'),
(44915, 3227888128, 3227888383, 'BE', 'BEL', 'بلجيكا'),
(44916, 3227888384, 3227889151, 'US', 'USA', 'الولايات المتحدة'),
(44917, 3227889408, 3227889663, 'US', 'USA', 'الولايات المتحدة'),
(44918, 3227889664, 3227889919, 'CH', 'CHE', 'سويسرا'),
(44919, 3227889920, 3227890431, 'US', 'USA', 'الولايات المتحدة'),
(44920, 3227890432, 3227890943, 'DE', 'DEU', 'ألمانيا'),
(44921, 3227890944, 3227891455, 'US', 'USA', 'الولايات المتحدة'),
(44922, 3227891456, 3227891711, 'AU', 'AUS', 'أستراليا'),
(44923, 3227891712, 3227893759, 'US', 'USA', 'الولايات المتحدة'),
(44924, 3227893760, 3227894015, 'FI', 'FIN', 'فنلندا'),
(44925, 3227894016, 3227895039, 'US', 'USA', 'الولايات المتحدة'),
(44926, 3227895040, 3227895551, 'DE', 'DEU', 'ألمانيا'),
(44927, 3227895808, 3227909119, 'US', 'USA', 'الولايات المتحدة'),
(44928, 3227909120, 3227909375, 'BE', 'BEL', 'بلجيكا'),
(44929, 3227909376, 3227909631, 'US', 'USA', 'الولايات المتحدة'),
(44930, 3227909632, 3227909887, 'AU', 'AUS', 'أستراليا'),
(44931, 3227910400, 3227910655, 'AT', 'AUT', 'النمسا'),
(44932, 3227910656, 3227911679, 'US', 'USA', 'الولايات المتحدة'),
(44933, 3227911680, 3227912191, 'HU', 'HUN', 'هنغاريا'),
(44934, 3227912192, 3227912447, 'GB', 'GBR', 'المملكة المتحدة'),
(44935, 3227912704, 3227912959, 'US', 'USA', 'الولايات المتحدة'),
(44936, 3227912960, 3227913215, 'CA', 'CAN', 'كندا'),
(44937, 3227913216, 3227913983, 'US', 'USA', 'الولايات المتحدة'),
(44938, 3227914240, 3227914495, 'US', 'USA', 'الولايات المتحدة'),
(44939, 3227914496, 3227914751, 'AT', 'AUT', 'النمسا'),
(44940, 3227914752, 3227918591, 'FI', 'FIN', 'فنلندا'),
(44941, 3227918592, 3227918847, 'US', 'USA', 'الولايات المتحدة'),
(44942, 3227918848, 3227931135, 'FI', 'FIN', 'فنلندا'),
(44943, 3227931136, 3227931391, 'US', 'USA', 'الولايات المتحدة'),
(44944, 3227931392, 3227931647, 'TH', 'THA', 'تايلند'),
(44945, 3227931648, 3227931903, 'PE', 'PER', 'بيرو'),
(44946, 3227932672, 3227932927, 'US', 'USA', 'الولايات المتحدة'),
(44947, 3227932928, 3227933183, 'DE', 'DEU', 'ألمانيا'),
(44948, 3227933184, 3227933695, 'US', 'USA', 'الولايات المتحدة'),
(44949, 3227933696, 3227933951, 'NZ', 'NZL', 'نيوزيلاندا'),
(44950, 3227933952, 3227934463, 'US', 'USA', 'الولايات المتحدة'),
(44951, 3227934464, 3227934719, 'CH', 'CHE', 'سويسرا'),
(44952, 3227934720, 3227947519, 'US', 'USA', 'الولايات المتحدة'),
(44953, 3227947520, 3227955711, 'DE', 'DEU', 'ألمانيا'),
(44954, 3227955712, 3227964927, 'US', 'USA', 'الولايات المتحدة'),
(44955, 3227964928, 3227965183, 'GB', 'GBR', 'المملكة المتحدة'),
(44956, 3227965184, 3227966975, 'US', 'USA', 'الولايات المتحدة'),
(44957, 3227967232, 3227967487, 'US', 'USA', 'الولايات المتحدة'),
(44958, 3227967488, 3227967743, 'FR', 'FRA', 'فرنسا'),
(44959, 3227967744, 3227967999, 'PL', 'POL', 'بولندا'),
(44960, 3227968000, 3227968255, 'US', 'USA', 'الولايات المتحدة'),
(44961, 3227968256, 3227968767, 'GB', 'GBR', 'المملكة المتحدة'),
(44962, 3227968768, 3227969023, 'RU', 'RUS', 'الإتحاد الروسي'),
(44963, 3227969024, 3227971327, 'US', 'USA', 'الولايات المتحدة'),
(44964, 3227971328, 3227971583, 'AU', 'AUS', 'أستراليا'),
(44965, 3227971584, 3227974143, 'US', 'USA', 'الولايات المتحدة'),
(44966, 3227974144, 3227974655, 'AU', 'AUS', 'أستراليا'),
(44967, 3227974656, 3227975167, 'US', 'USA', 'الولايات المتحدة'),
(44968, 3227975936, 3227976191, 'US', 'USA', 'الولايات المتحدة'),
(44969, 3227976192, 3227976447, 'LU', 'LUX', 'لوكسيمبورغ'),
(44970, 3227976448, 3227977471, 'US', 'USA', 'الولايات المتحدة'),
(44971, 3227977472, 3227977727, 'FR', 'FRA', 'فرنسا'),
(44972, 3227977728, 3227978495, 'US', 'USA', 'الولايات المتحدة'),
(44973, 3227979008, 3227979263, 'US', 'USA', 'الولايات المتحدة'),
(44974, 3227979264, 3227979519, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(44975, 3227979520, 3227980799, 'US', 'USA', 'الولايات المتحدة'),
(44976, 3227980800, 3227981055, 'GR', 'GRC', 'اليونان'),
(44977, 3227981056, 3227981567, 'US', 'USA', 'الولايات المتحدة'),
(44978, 3227981568, 3227981823, 'DE', 'DEU', 'ألمانيا'),
(44979, 3227981824, 3227982591, 'US', 'USA', 'الولايات المتحدة'),
(44980, 3227982592, 3227982847, 'DE', 'DEU', 'ألمانيا'),
(44981, 3227982848, 3227985919, 'GB', 'GBR', 'المملكة المتحدة'),
(44982, 3227985920, 3227986175, 'DE', 'DEU', 'ألمانيا'),
(44983, 3227986176, 3227986431, 'US', 'USA', 'الولايات المتحدة'),
(44984, 3227986432, 3227986943, 'JP', 'JPN', 'اليابان'),
(44985, 3227986944, 3227987455, 'US', 'USA', 'الولايات المتحدة'),
(44986, 3227987456, 3227987711, 'AU', 'AUS', 'أستراليا'),
(44987, 3227987712, 3227997439, 'US', 'USA', 'الولايات المتحدة'),
(44988, 3227997440, 3228005631, 'FI', 'FIN', 'فنلندا'),
(44989, 3228005632, 3228008959, 'US', 'USA', 'الولايات المتحدة'),
(44990, 3228008960, 3228009215, 'AU', 'AUS', 'أستراليا'),
(44991, 3228009472, 3228009727, 'AU', 'AUS', 'أستراليا'),
(44992, 3228009728, 3228010751, 'US', 'USA', 'الولايات المتحدة'),
(44993, 3228010752, 3228011519, 'GB', 'GBR', 'المملكة المتحدة'),
(44994, 3228011520, 3228013311, 'US', 'USA', 'الولايات المتحدة'),
(44995, 3228013312, 3228013567, 'PT', 'PRT', 'البورتوغال'),
(44996, 3228013568, 3228039423, 'US', 'USA', 'الولايات المتحدة'),
(44997, 3228041472, 3228042239, 'US', 'USA', 'الولايات المتحدة'),
(44998, 3228042752, 3228045055, 'US', 'USA', 'الولايات المتحدة'),
(44999, 3228045056, 3228045311, 'KR', 'KOR', 'جمهورية كوريا'),
(45000, 3228045312, 3228046335, 'US', 'USA', 'الولايات المتحدة'),
(45001, 3228046592, 3228047103, 'US', 'USA', 'الولايات المتحدة'),
(45002, 3228047104, 3228047359, 'IT', 'ITA', 'إيطاليا'),
(45003, 3228047360, 3228048383, 'US', 'USA', 'الولايات المتحدة'),
(45004, 3228048384, 3228048895, 'GB', 'GBR', 'المملكة المتحدة'),
(45005, 3228048896, 3228050175, 'US', 'USA', 'الولايات المتحدة'),
(45006, 3228050176, 3228050943, 'PT', 'PRT', 'البورتوغال'),
(45007, 3228051200, 3228051455, 'US', 'USA', 'الولايات المتحدة'),
(45008, 3228051456, 3228051711, 'JP', 'JPN', 'اليابان'),
(45009, 3228051712, 3228051967, 'CH', 'CHE', 'سويسرا'),
(45010, 3228051968, 3228052223, 'US', 'USA', 'الولايات المتحدة'),
(45011, 3228052224, 3228052991, 'AU', 'AUS', 'أستراليا'),
(45012, 3228052992, 3228053503, 'US', 'USA', 'الولايات المتحدة'),
(45013, 3228053504, 3228053759, 'PT', 'PRT', 'البورتوغال'),
(45014, 3228054016, 3228054783, 'US', 'USA', 'الولايات المتحدة'),
(45015, 3228054784, 3228055039, 'GB', 'GBR', 'المملكة المتحدة'),
(45016, 3228055040, 3228055295, 'US', 'USA', 'الولايات المتحدة'),
(45017, 3228055296, 3228055807, 'NL', 'NLD', 'هولندا'),
(45018, 3228055808, 3228056319, 'NO', 'NOR', 'النرويج'),
(45019, 3228056320, 3228059647, 'US', 'USA', 'الولايات المتحدة'),
(45020, 3228059648, 3228059903, 'CH', 'CHE', 'سويسرا'),
(45021, 3228060160, 3228060927, 'US', 'USA', 'الولايات المتحدة'),
(45022, 3228060928, 3228061183, 'DE', 'DEU', 'ألمانيا'),
(45023, 3228061184, 3228061695, 'US', 'USA', 'الولايات المتحدة'),
(45024, 3228061696, 3228061951, 'JP', 'JPN', 'اليابان'),
(45025, 3228061952, 3228062207, 'US', 'USA', 'الولايات المتحدة'),
(45026, 3228062208, 3228062463, 'GB', 'GBR', 'المملكة المتحدة'),
(45027, 3228062464, 3228069631, 'US', 'USA', 'الولايات المتحدة'),
(45028, 3228076288, 3228077055, 'US', 'USA', 'الولايات المتحدة'),
(45029, 3228077056, 3228077311, 'NL', 'NLD', 'هولندا'),
(45030, 3228077312, 3228077567, 'US', 'USA', 'الولايات المتحدة'),
(45031, 3228077568, 3228077823, 'NL', 'NLD', 'هولندا'),
(45032, 3228077824, 3228078847, 'US', 'USA', 'الولايات المتحدة'),
(45033, 3228078848, 3228079103, 'GR', 'GRC', 'اليونان'),
(45034, 3228079360, 3228079871, 'US', 'USA', 'الولايات المتحدة'),
(45035, 3228080128, 3228080639, 'US', 'USA', 'الولايات المتحدة'),
(45036, 3228080640, 3228080895, 'IE', 'IRL', 'إيرلندا'),
(45037, 3228080896, 3228081151, 'FR', 'FRA', 'فرنسا'),
(45038, 3228081152, 3228081919, 'US', 'USA', 'الولايات المتحدة'),
(45039, 3228082944, 3228083967, 'US', 'USA', 'الولايات المتحدة'),
(45040, 3228083968, 3228084479, 'BE', 'BEL', 'بلجيكا'),
(45041, 3228084480, 3228085247, 'US', 'USA', 'الولايات المتحدة'),
(45042, 3228085248, 3228085503, 'JP', 'JPN', 'اليابان'),
(45043, 3228085504, 3228100607, 'US', 'USA', 'الولايات المتحدة'),
(45044, 3228100608, 3228101119, 'JP', 'JPN', 'اليابان'),
(45045, 3228101120, 3228102143, 'US', 'USA', 'الولايات المتحدة'),
(45046, 3228102144, 3228102399, 'GB', 'GBR', 'المملكة المتحدة'),
(45047, 3228102400, 3228103423, 'US', 'USA', 'الولايات المتحدة'),
(45048, 3228103680, 3228103935, 'US', 'USA', 'الولايات المتحدة'),
(45049, 3228103936, 3228104191, 'FR', 'FRA', 'فرنسا'),
(45050, 3228104192, 3228104703, 'JP', 'JPN', 'اليابان'),
(45051, 3228104704, 3228104959, 'DK', 'DNK', 'الدنيمارك'),
(45052, 3228104960, 3228105471, 'US', 'USA', 'الولايات المتحدة'),
(45053, 3228105472, 3228105727, 'CH', 'CHE', 'سويسرا'),
(45054, 3228105728, 3228105983, 'NZ', 'NZL', 'نيوزيلاندا'),
(45055, 3228105984, 3228106495, 'US', 'USA', 'الولايات المتحدة'),
(45056, 3228106752, 3228109311, 'US', 'USA', 'الولايات المتحدة'),
(45057, 3228109312, 3228109567, 'NZ', 'NZL', 'نيوزيلاندا'),
(45058, 3228109568, 3228125951, 'US', 'USA', 'الولايات المتحدة'),
(45059, 3228125952, 3228126207, 'DE', 'DEU', 'ألمانيا'),
(45060, 3228126208, 3228172287, 'US', 'USA', 'الولايات المتحدة'),
(45061, 3228172288, 3228222463, 'IT', 'ITA', 'إيطاليا'),
(45062, 3228222464, 3228222975, 'NL', 'NLD', 'هولندا'),
(45063, 3228222976, 3228237823, 'IT', 'ITA', 'إيطاليا'),
(45064, 3228238080, 3228238335, 'NO', 'NOR', 'النرويج'),
(45065, 3228238336, 3228238591, 'GB', 'GBR', 'المملكة المتحدة'),
(45066, 3228238592, 3228238847, 'US', 'USA', 'الولايات المتحدة'),
(45067, 3228238848, 3228239359, 'GB', 'GBR', 'المملكة المتحدة'),
(45068, 3228239616, 3228240127, 'US', 'USA', 'الولايات المتحدة'),
(45069, 3228240128, 3228240383, 'AU', 'AUS', 'أستراليا'),
(45070, 3228240384, 3228240639, 'NZ', 'NZL', 'نيوزيلاندا'),
(45071, 3228240640, 3228241407, 'GB', 'GBR', 'المملكة المتحدة'),
(45072, 3228241408, 3228250367, 'US', 'USA', 'الولايات المتحدة'),
(45073, 3228250624, 3228250879, 'US', 'USA', 'الولايات المتحدة'),
(45074, 3228250880, 3228263679, 'IT', 'ITA', 'إيطاليا'),
(45075, 3228263680, 3228263935, 'AU', 'AUS', 'أستراليا'),
(45076, 3228263936, 3228264447, 'US', 'USA', 'الولايات المتحدة'),
(45077, 3228264448, 3228264703, 'NI', 'NIC', 'نيكاراغوا'),
(45078, 3228264704, 3228265983, 'US', 'USA', 'الولايات المتحدة'),
(45079, 3228265984, 3228266239, 'IE', 'IRL', 'إيرلندا'),
(45080, 3228266496, 3228267007, 'NZ', 'NZL', 'نيوزيلاندا'),
(45081, 3228267008, 3228267263, 'NO', 'NOR', 'النرويج'),
(45082, 3228267264, 3228268543, 'US', 'USA', 'الولايات المتحدة'),
(45083, 3228269056, 3228269311, 'PT', 'PRT', 'البورتوغال'),
(45084, 3228269312, 3228269567, 'DE', 'DEU', 'ألمانيا'),
(45085, 3228269568, 3228270079, 'AT', 'AUT', 'النمسا'),
(45086, 3228270080, 3228271103, 'GB', 'GBR', 'المملكة المتحدة'),
(45087, 3228271104, 3228271359, 'US', 'USA', 'الولايات المتحدة'),
(45088, 3228271360, 3228271615, 'CA', 'CAN', 'كندا'),
(45089, 3228271616, 3228271871, 'DE', 'DEU', 'ألمانيا'),
(45090, 3228272128, 3228272383, 'US', 'USA', 'الولايات المتحدة'),
(45091, 3228274944, 3228280831, 'US', 'USA', 'الولايات المتحدة'),
(45092, 3228280832, 3228281087, 'GB', 'GBR', 'المملكة المتحدة'),
(45093, 3228281088, 3228281599, 'US', 'USA', 'الولايات المتحدة'),
(45094, 3228281600, 3228282111, 'NZ', 'NZL', 'نيوزيلاندا'),
(45095, 3228282112, 3228282367, 'US', 'USA', 'الولايات المتحدة'),
(45096, 3228282368, 3228282623, 'GB', 'GBR', 'المملكة المتحدة'),
(45097, 3228282624, 3228283135, 'US', 'USA', 'الولايات المتحدة'),
(45098, 3228283136, 3228283391, 'GR', 'GRC', 'اليونان'),
(45099, 3228283392, 3228283647, 'GB', 'GBR', 'المملكة المتحدة'),
(45100, 3228283648, 3228285695, 'US', 'USA', 'الولايات المتحدة'),
(45101, 3228285696, 3228285951, 'SE', 'SWE', 'السويد'),
(45102, 3228285952, 3228289023, 'US', 'USA', 'الولايات المتحدة'),
(45103, 3228289024, 3228297215, 'FI', 'FIN', 'فنلندا'),
(45104, 3228297216, 3228297727, 'AT', 'AUT', 'النمسا'),
(45105, 3228297728, 3228297983, 'US', 'USA', 'الولايات المتحدة'),
(45106, 3228297984, 3228298495, 'DE', 'DEU', 'ألمانيا'),
(45107, 3228298496, 3228303103, 'US', 'USA', 'الولايات المتحدة'),
(45108, 3228303360, 3228309247, 'US', 'USA', 'الولايات المتحدة'),
(45109, 3228309248, 3228316159, 'DE', 'DEU', 'ألمانيا'),
(45110, 3228316416, 3228327167, 'DE', 'DEU', 'ألمانيا'),
(45111, 3228327168, 3228328703, 'US', 'USA', 'الولايات المتحدة'),
(45112, 3228328704, 3228328959, 'AU', 'AUS', 'أستراليا'),
(45113, 3228328960, 3228329471, 'NO', 'NOR', 'النرويج'),
(45114, 3228329472, 3228330751, 'US', 'USA', 'الولايات المتحدة'),
(45115, 3228330752, 3228331263, 'SE', 'SWE', 'السويد'),
(45116, 3228331264, 3228332287, 'US', 'USA', 'الولايات المتحدة'),
(45117, 3228332288, 3228332543, 'AU', 'AUS', 'أستراليا'),
(45118, 3228332544, 3228332799, 'GR', 'GRC', 'اليونان'),
(45119, 3228332800, 3228334079, 'FR', 'FRA', 'فرنسا'),
(45120, 3228334080, 3228334335, 'GB', 'GBR', 'المملكة المتحدة'),
(45121, 3228334336, 3228334591, 'AT', 'AUT', 'النمسا'),
(45122, 3228334592, 3228335359, 'US', 'USA', 'الولايات المتحدة'),
(45123, 3228335360, 3228335615, 'SK', 'SVK', 'سلوفاكيا'),
(45124, 3228335616, 3228335871, 'CZ', 'CZE', 'التشيك'),
(45125, 3228336128, 3228336639, 'CZ', 'CZE', 'التشيك'),
(45126, 3228336640, 3228337663, 'SK', 'SVK', 'سلوفاكيا'),
(45127, 3228337664, 3228338431, 'CZ', 'CZE', 'التشيك'),
(45128, 3228338432, 3228340735, 'SK', 'SVK', 'سلوفاكيا'),
(45129, 3228340736, 3228341247, 'CZ', 'CZE', 'التشيك'),
(45130, 3228341248, 3228341759, 'SK', 'SVK', 'سلوفاكيا'),
(45131, 3228341760, 3228342271, 'CZ', 'CZE', 'التشيك'),
(45132, 3228342272, 3228342783, 'SK', 'SVK', 'سلوفاكيا'),
(45133, 3228342784, 3228343039, 'CZ', 'CZE', 'التشيك'),
(45134, 3228343040, 3228343295, 'SK', 'SVK', 'سلوفاكيا'),
(45135, 3228343296, 3228343551, 'CZ', 'CZE', 'التشيك');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(45136, 3228343552, 3228344063, 'SK', 'SVK', 'سلوفاكيا'),
(45137, 3228344064, 3228344575, 'CZ', 'CZE', 'التشيك'),
(45138, 3228344576, 3228347135, 'SK', 'SVK', 'سلوفاكيا'),
(45139, 3228347136, 3228347391, 'CZ', 'CZE', 'التشيك'),
(45140, 3228347392, 3228348159, 'SK', 'SVK', 'سلوفاكيا'),
(45141, 3228348160, 3228353279, 'US', 'USA', 'الولايات المتحدة'),
(45142, 3228353280, 3228358399, 'SE', 'SWE', 'السويد'),
(45143, 3228358400, 3228361471, 'US', 'USA', 'الولايات المتحدة'),
(45144, 3228361728, 3228362239, 'US', 'USA', 'الولايات المتحدة'),
(45145, 3228362240, 3228362495, 'TH', 'THA', 'تايلند'),
(45146, 3228362496, 3228362751, 'US', 'USA', 'الولايات المتحدة'),
(45147, 3228363008, 3228363263, 'US', 'USA', 'الولايات المتحدة'),
(45148, 3228363264, 3228363519, 'CH', 'CHE', 'سويسرا'),
(45149, 3228363520, 3228364287, 'US', 'USA', 'الولايات المتحدة'),
(45150, 3228364288, 3228364543, 'AT', 'AUT', 'النمسا'),
(45151, 3228364800, 3228368383, 'US', 'USA', 'الولايات المتحدة'),
(45152, 3228368896, 3228380415, 'DE', 'DEU', 'ألمانيا'),
(45153, 3228380672, 3228388095, 'DE', 'DEU', 'ألمانيا'),
(45154, 3228388352, 3228392447, 'DE', 'DEU', 'ألمانيا'),
(45155, 3228392960, 3228394239, 'DE', 'DEU', 'ألمانيا'),
(45156, 3228394496, 3228395263, 'DE', 'DEU', 'ألمانيا'),
(45157, 3228395776, 3228399615, 'DE', 'DEU', 'ألمانيا'),
(45158, 3228399872, 3228404735, 'DE', 'DEU', 'ألمانيا'),
(45159, 3228404736, 3228407039, 'FR', 'FRA', 'فرنسا'),
(45160, 3228407040, 3228413183, 'DE', 'DEU', 'ألمانيا'),
(45161, 3228413184, 3228413439, 'SG', 'SGP', 'سنغافورة'),
(45162, 3228413440, 3228417791, 'DE', 'DEU', 'ألمانيا'),
(45163, 3228417792, 3228418559, 'AT', 'AUT', 'النمسا'),
(45164, 3228418560, 3228418815, 'IN', 'IND', 'الهند'),
(45165, 3228418816, 3228421119, 'DE', 'DEU', 'ألمانيا'),
(45166, 3228421120, 3228421375, 'BE', 'BEL', 'بلجيكا'),
(45167, 3228421376, 3228423679, 'DE', 'DEU', 'ألمانيا'),
(45168, 3228423680, 3228424191, 'CH', 'CHE', 'سويسرا'),
(45169, 3228424192, 3228434431, 'DE', 'DEU', 'ألمانيا'),
(45170, 3228434688, 3228471295, 'US', 'USA', 'الولايات المتحدة'),
(45171, 3228472320, 3228472831, 'US', 'USA', 'الولايات المتحدة'),
(45172, 3228473344, 3228473599, 'US', 'USA', 'الولايات المتحدة'),
(45173, 3228473856, 3228474111, 'US', 'USA', 'الولايات المتحدة'),
(45174, 3228477440, 3228477695, 'US', 'USA', 'الولايات المتحدة'),
(45175, 3228491520, 3228499711, 'US', 'USA', 'الولايات المتحدة'),
(45176, 3228500224, 3228508159, 'US', 'USA', 'الولايات المتحدة'),
(45177, 3228508160, 3228508415, 'AU', 'AUS', 'أستراليا'),
(45178, 3228508416, 3228508671, 'NO', 'NOR', 'النرويج'),
(45179, 3228508672, 3228509439, 'US', 'USA', 'الولايات المتحدة'),
(45180, 3228509952, 3228510207, 'IE', 'IRL', 'إيرلندا'),
(45181, 3228510208, 3228511231, 'US', 'USA', 'الولايات المتحدة'),
(45182, 3228511232, 3228511487, 'CZ', 'CZE', 'التشيك'),
(45183, 3228511488, 3228511999, 'US', 'USA', 'الولايات المتحدة'),
(45184, 3228512000, 3228512255, 'DE', 'DEU', 'ألمانيا'),
(45185, 3228512256, 3228512511, 'CH', 'CHE', 'سويسرا'),
(45186, 3228512512, 3228513791, 'US', 'USA', 'الولايات المتحدة'),
(45187, 3228521984, 3228522495, 'US', 'USA', 'الولايات المتحدة'),
(45188, 3228522496, 3228522751, 'GB', 'GBR', 'المملكة المتحدة'),
(45189, 3228522752, 3228525823, 'US', 'USA', 'الولايات المتحدة'),
(45190, 3228525824, 3228526079, 'PT', 'PRT', 'البورتوغال'),
(45191, 3228526080, 3228526335, 'NZ', 'NZL', 'نيوزيلاندا'),
(45192, 3228526336, 3228526591, 'CH', 'CHE', 'سويسرا'),
(45193, 3228526592, 3228526847, 'AT', 'AUT', 'النمسا'),
(45194, 3228526848, 3228527103, 'AU', 'AUS', 'أستراليا'),
(45195, 3228527104, 3228528383, 'US', 'USA', 'الولايات المتحدة'),
(45196, 3228528640, 3228531711, 'US', 'USA', 'الولايات المتحدة'),
(45197, 3228531712, 3228532223, 'NO', 'NOR', 'النرويج'),
(45198, 3228532224, 3228532479, 'US', 'USA', 'الولايات المتحدة'),
(45199, 3228532480, 3228532735, 'DE', 'DEU', 'ألمانيا'),
(45200, 3228540928, 3228554751, 'US', 'USA', 'الولايات المتحدة'),
(45201, 3228555008, 3228557311, 'US', 'USA', 'الولايات المتحدة'),
(45202, 3228557568, 3228558591, 'US', 'USA', 'الولايات المتحدة'),
(45203, 3228558592, 3228559103, 'BR', 'BRA', 'البرازيل'),
(45204, 3228559104, 3228564223, 'US', 'USA', 'الولايات المتحدة'),
(45205, 3228564480, 3228564735, 'AT', 'AUT', 'النمسا'),
(45206, 3228564992, 3228565247, 'US', 'USA', 'الولايات المتحدة'),
(45207, 3228565760, 3228571391, 'US', 'USA', 'الولايات المتحدة'),
(45208, 3228571648, 3228572927, 'US', 'USA', 'الولايات المتحدة'),
(45209, 3228573184, 3228573951, 'PT', 'PRT', 'البورتوغال'),
(45210, 3228573952, 3228574463, 'US', 'USA', 'الولايات المتحدة'),
(45211, 3228574720, 3228577023, 'US', 'USA', 'الولايات المتحدة'),
(45212, 3228577024, 3228577279, 'PT', 'PRT', 'البورتوغال'),
(45213, 3228577280, 3228578047, 'US', 'USA', 'الولايات المتحدة'),
(45214, 3228578048, 3228578303, 'GB', 'GBR', 'المملكة المتحدة'),
(45215, 3228578304, 3228581119, 'US', 'USA', 'الولايات المتحدة'),
(45216, 3228581120, 3228581375, 'AT', 'AUT', 'النمسا'),
(45217, 3228581376, 3228583167, 'US', 'USA', 'الولايات المتحدة'),
(45218, 3228583424, 3228585983, 'ES', 'ESP', 'إسبانيا'),
(45219, 3228585984, 3228590591, 'US', 'USA', 'الولايات المتحدة'),
(45220, 3228590592, 3228590847, 'GB', 'GBR', 'المملكة المتحدة'),
(45221, 3228590848, 3228591103, 'DK', 'DNK', 'الدنيمارك'),
(45222, 3228591104, 3228591359, 'GB', 'GBR', 'المملكة المتحدة'),
(45223, 3228591360, 3228603391, 'US', 'USA', 'الولايات المتحدة'),
(45224, 3228603648, 3228603903, 'US', 'USA', 'الولايات المتحدة'),
(45225, 3228604160, 3228611583, 'US', 'USA', 'الولايات المتحدة'),
(45226, 3228611840, 3228617727, 'US', 'USA', 'الولايات المتحدة'),
(45227, 3228617728, 3228617983, 'FI', 'FIN', 'فنلندا'),
(45228, 3228617984, 3228618239, 'US', 'USA', 'الولايات المتحدة'),
(45229, 3228618240, 3228618495, 'SE', 'SWE', 'السويد'),
(45230, 3228618496, 3228618751, 'US', 'USA', 'الولايات المتحدة'),
(45231, 3228618752, 3228619007, 'DE', 'DEU', 'ألمانيا'),
(45232, 3228619008, 3228620031, 'US', 'USA', 'الولايات المتحدة'),
(45233, 3228620032, 3228620287, 'DE', 'DEU', 'ألمانيا'),
(45234, 3228620288, 3228620543, 'CH', 'CHE', 'سويسرا'),
(45235, 3228620544, 3228620799, 'AU', 'AUS', 'أستراليا'),
(45236, 3228620800, 3228628735, 'US', 'USA', 'الولايات المتحدة'),
(45237, 3228628736, 3228628991, 'ES', 'ESP', 'إسبانيا'),
(45238, 3228628992, 3228630527, 'US', 'USA', 'الولايات المتحدة'),
(45239, 3228630528, 3228630783, 'CH', 'CHE', 'سويسرا'),
(45240, 3228631040, 3228696575, 'NL', 'NLD', 'هولندا'),
(45241, 3228696576, 3228827647, 'IL', 'ISR', 'إسرائيل'),
(45242, 3228827648, 3228828159, 'PS', 'PSE', 'فلسطين المحتلة'),
(45243, 3228828160, 3228829183, 'IL', 'ISR', 'إسرائيل'),
(45244, 3228829184, 3228829695, 'PS', 'PSE', 'فلسطين المحتلة'),
(45245, 3228829696, 3228830207, 'IL', 'ISR', 'إسرائيل'),
(45246, 3228830208, 3228833791, 'PS', 'PSE', 'فلسطين المحتلة'),
(45247, 3228833792, 3228846335, 'IL', 'ISR', 'إسرائيل'),
(45248, 3228846336, 3228846591, 'GB', 'GBR', 'المملكة المتحدة'),
(45249, 3228846592, 3228849407, 'IL', 'ISR', 'إسرائيل'),
(45250, 3228849408, 3228849663, 'GB', 'GBR', 'المملكة المتحدة'),
(45251, 3228849664, 3228850175, 'IL', 'ISR', 'إسرائيل'),
(45252, 3228850176, 3228850431, 'GB', 'GBR', 'المملكة المتحدة'),
(45253, 3228850432, 3228858111, 'IL', 'ISR', 'إسرائيل'),
(45254, 3228858112, 3228858367, 'GB', 'GBR', 'المملكة المتحدة'),
(45255, 3228858368, 3228864255, 'IL', 'ISR', 'إسرائيل'),
(45256, 3228864256, 3228864511, 'GB', 'GBR', 'المملكة المتحدة'),
(45257, 3228864512, 3229024255, 'IL', 'ISR', 'إسرائيل'),
(45258, 3229024512, 3229024767, 'US', 'USA', 'الولايات المتحدة'),
(45259, 3229058816, 3229059071, 'US', 'USA', 'الولايات المتحدة'),
(45260, 3229090048, 3229101823, 'US', 'USA', 'الولايات المتحدة'),
(45261, 3229101824, 3229102591, 'FI', 'FIN', 'فنلندا'),
(45262, 3229102592, 3229155327, 'US', 'USA', 'الولايات المتحدة'),
(45263, 3229155328, 3229177407, 'SE', 'SWE', 'السويد'),
(45264, 3229177408, 3229177423, 'JP', 'JPN', 'اليابان'),
(45265, 3229177424, 3229219583, 'SE', 'SWE', 'السويد'),
(45266, 3229219584, 3229219839, 'EE', 'EST', 'إستونيا'),
(45267, 3229219840, 3229220863, 'SE', 'SWE', 'السويد'),
(45268, 3229221120, 3229221375, 'FR', 'FRA', 'فرنسا'),
(45269, 3229221376, 3229245439, 'GB', 'GBR', 'المملكة المتحدة'),
(45270, 3229245440, 3229246719, 'US', 'USA', 'الولايات المتحدة'),
(45271, 3229246720, 3229250815, 'GB', 'GBR', 'المملكة المتحدة'),
(45272, 3229250816, 3229251071, 'US', 'USA', 'الولايات المتحدة'),
(45273, 3229251072, 3229254399, 'GB', 'GBR', 'المملكة المتحدة'),
(45274, 3229254400, 3229256959, 'SG', 'SGP', 'سنغافورة'),
(45275, 3229256960, 3229258495, 'GB', 'GBR', 'المملكة المتحدة'),
(45276, 3229258496, 3229259007, 'US', 'USA', 'الولايات المتحدة'),
(45277, 3229259520, 3229264639, 'GB', 'GBR', 'المملكة المتحدة'),
(45278, 3229264640, 3229264895, 'NZ', 'NZL', 'نيوزيلاندا'),
(45279, 3229264896, 3229265919, 'US', 'USA', 'الولايات المتحدة'),
(45280, 3229265920, 3229266175, 'AU', 'AUS', 'أستراليا'),
(45281, 3229266176, 3229266943, 'US', 'USA', 'الولايات المتحدة'),
(45282, 3229266944, 3229267199, 'NZ', 'NZL', 'نيوزيلاندا'),
(45283, 3229267200, 3229272319, 'US', 'USA', 'الولايات المتحدة'),
(45284, 3229273856, 3229274623, 'US', 'USA', 'الولايات المتحدة'),
(45285, 3229274624, 3229274879, 'AU', 'AUS', 'أستراليا'),
(45286, 3229274880, 3229275647, 'US', 'USA', 'الولايات المتحدة'),
(45287, 3229275648, 3229275903, 'GB', 'GBR', 'المملكة المتحدة'),
(45288, 3229276160, 3229281023, 'IE', 'IRL', 'إيرلندا'),
(45289, 3229281024, 3229281791, 'US', 'USA', 'الولايات المتحدة'),
(45290, 3229281792, 3229283071, 'PT', 'PRT', 'البورتوغال'),
(45291, 3229283072, 3229285887, 'US', 'USA', 'الولايات المتحدة'),
(45292, 3229285888, 3229286143, 'NO', 'NOR', 'النرويج'),
(45293, 3229286400, 3229351935, 'US', 'USA', 'الولايات المتحدة'),
(45294, 3229352192, 3229354495, 'US', 'USA', 'الولايات المتحدة'),
(45295, 3229354496, 3229355775, 'AU', 'AUS', 'أستراليا'),
(45296, 3229355776, 3229356543, 'US', 'USA', 'الولايات المتحدة'),
(45297, 3229356800, 3229357823, 'US', 'USA', 'الولايات المتحدة'),
(45298, 3229358080, 3229358335, 'NZ', 'NZL', 'نيوزيلاندا'),
(45299, 3229358336, 3229359359, 'DE', 'DEU', 'ألمانيا'),
(45300, 3229359872, 3229360127, 'US', 'USA', 'الولايات المتحدة'),
(45301, 3229360128, 3229360383, 'AT', 'AUT', 'النمسا'),
(45302, 3229360384, 3229361919, 'US', 'USA', 'الولايات المتحدة'),
(45303, 3229361920, 3229362175, 'BE', 'BEL', 'بلجيكا'),
(45304, 3229362176, 3229363199, 'US', 'USA', 'الولايات المتحدة'),
(45305, 3229363456, 3229363711, 'US', 'USA', 'الولايات المتحدة'),
(45306, 3229363712, 3229363967, 'GB', 'GBR', 'المملكة المتحدة'),
(45307, 3229363968, 3229380607, 'US', 'USA', 'الولايات المتحدة'),
(45308, 3229380608, 3229380863, 'DE', 'DEU', 'ألمانيا'),
(45309, 3229380864, 3229381375, 'US', 'USA', 'الولايات المتحدة'),
(45310, 3229381376, 3229381631, 'DE', 'DEU', 'ألمانيا'),
(45311, 3229381632, 3229381887, 'PL', 'POL', 'بولندا'),
(45312, 3229381888, 3229382143, 'AU', 'AUS', 'أستراليا'),
(45313, 3229382144, 3229382399, 'US', 'USA', 'الولايات المتحدة'),
(45314, 3229382656, 3229384191, 'US', 'USA', 'الولايات المتحدة'),
(45315, 3229384448, 3229384959, 'US', 'USA', 'الولايات المتحدة'),
(45316, 3229385216, 3229385727, 'US', 'USA', 'الولايات المتحدة'),
(45317, 3229385984, 3229390847, 'US', 'USA', 'الولايات المتحدة'),
(45318, 3229390848, 3229391103, 'AU', 'AUS', 'أستراليا'),
(45319, 3229391104, 3229391359, 'US', 'USA', 'الولايات المتحدة'),
(45320, 3229391360, 3229391615, 'CN', 'CHN', 'الصين'),
(45321, 3229391616, 3229391871, 'AT', 'AUT', 'النمسا'),
(45322, 3229392128, 3229394175, 'US', 'USA', 'الولايات المتحدة'),
(45323, 3229395456, 3229408255, 'RU', 'RUS', 'الإتحاد الروسي'),
(45324, 3229408256, 3229409279, 'US', 'USA', 'الولايات المتحدة'),
(45325, 3229409536, 3229412095, 'US', 'USA', 'الولايات المتحدة'),
(45326, 3229412096, 3229412351, 'DE', 'DEU', 'ألمانيا'),
(45327, 3229412608, 3229414911, 'DE', 'DEU', 'ألمانيا'),
(45328, 3229414912, 3229415167, 'US', 'USA', 'الولايات المتحدة'),
(45329, 3229415168, 3229415679, 'DE', 'DEU', 'ألمانيا'),
(45330, 3229415936, 3229417215, 'DE', 'DEU', 'ألمانيا'),
(45331, 3229417472, 3229483007, 'DE', 'DEU', 'ألمانيا'),
(45332, 3229483264, 3229499647, 'FI', 'FIN', 'فنلندا'),
(45333, 3229499648, 3229500671, 'US', 'USA', 'الولايات المتحدة'),
(45334, 3229548544, 3229679615, 'US', 'USA', 'الولايات المتحدة'),
(45335, 3229679872, 3229680383, 'DE', 'DEU', 'ألمانيا'),
(45336, 3229680384, 3229680895, 'RO', 'ROM', 'رومانيا'),
(45337, 3229680896, 3229693183, 'DE', 'DEU', 'ألمانيا'),
(45338, 3229693440, 3229695487, 'DE', 'DEU', 'ألمانيا'),
(45339, 3229695488, 3229697535, 'US', 'USA', 'الولايات المتحدة'),
(45340, 3229697792, 3229699071, 'US', 'USA', 'الولايات المتحدة'),
(45341, 3229699328, 3229699583, 'US', 'USA', 'الولايات المتحدة'),
(45342, 3229699840, 3229700095, 'US', 'USA', 'الولايات المتحدة'),
(45343, 3229700096, 3229700351, 'AT', 'AUT', 'النمسا'),
(45344, 3229700352, 3229701887, 'US', 'USA', 'الولايات المتحدة'),
(45345, 3229701888, 3229702143, 'TR', 'TUR', 'تركيا'),
(45346, 3229702144, 3229704703, 'US', 'USA', 'الولايات المتحدة'),
(45347, 3229704704, 3229704959, 'DE', 'DEU', 'ألمانيا'),
(45348, 3229705216, 3229708031, 'US', 'USA', 'الولايات المتحدة'),
(45349, 3229745152, 3229749759, 'FI', 'FIN', 'فنلندا'),
(45350, 3229749760, 3229750015, 'BE', 'BEL', 'بلجيكا'),
(45351, 3229750016, 3229810687, 'FI', 'FIN', 'فنلندا'),
(45352, 3229810944, 3229811711, 'US', 'USA', 'الولايات المتحدة'),
(45353, 3229812224, 3229814015, 'US', 'USA', 'الولايات المتحدة'),
(45354, 3229814016, 3229814271, 'AU', 'AUS', 'أستراليا'),
(45355, 3229814272, 3229815807, 'US', 'USA', 'الولايات المتحدة'),
(45356, 3229815808, 3229816063, 'DE', 'DEU', 'ألمانيا'),
(45357, 3229816320, 3229817087, 'US', 'USA', 'الولايات المتحدة'),
(45358, 3229817088, 3229817599, 'SE', 'SWE', 'السويد'),
(45359, 3229817600, 3229818623, 'AU', 'AUS', 'أستراليا'),
(45360, 3229818624, 3229818879, 'US', 'USA', 'الولايات المتحدة'),
(45361, 3229822208, 3229825023, 'US', 'USA', 'الولايات المتحدة'),
(45362, 3229827072, 3229830911, 'US', 'USA', 'الولايات المتحدة'),
(45363, 3229830912, 3229831167, 'GB', 'GBR', 'المملكة المتحدة'),
(45364, 3229831168, 3229833215, 'US', 'USA', 'الولايات المتحدة'),
(45365, 3229833472, 3229833727, 'GB', 'GBR', 'المملكة المتحدة'),
(45366, 3229833728, 3229834239, 'IN', 'IND', 'الهند'),
(45367, 3229834240, 3229834495, 'AU', 'AUS', 'أستراليا'),
(45368, 3229834496, 3229834751, 'US', 'USA', 'الولايات المتحدة'),
(45369, 3229834752, 3229835007, 'CA', 'CAN', 'كندا'),
(45370, 3229835008, 3229835263, 'US', 'USA', 'الولايات المتحدة'),
(45371, 3229835264, 3229835519, 'FI', 'FIN', 'فنلندا'),
(45372, 3229835520, 3229835775, 'CA', 'CAN', 'كندا'),
(45373, 3229835776, 3229838079, 'US', 'USA', 'الولايات المتحدة'),
(45374, 3229838336, 3229838591, 'GB', 'GBR', 'المملكة المتحدة'),
(45375, 3229838592, 3229838847, 'US', 'USA', 'الولايات المتحدة'),
(45376, 3229839104, 3229844479, 'US', 'USA', 'الولايات المتحدة'),
(45377, 3229844480, 3229844735, 'BE', 'BEL', 'بلجيكا'),
(45378, 3229844736, 3229844991, 'US', 'USA', 'الولايات المتحدة'),
(45379, 3229845248, 3229845503, 'US', 'USA', 'الولايات المتحدة'),
(45380, 3229845760, 3229847295, 'CA', 'CAN', 'كندا'),
(45381, 3229847296, 3229870335, 'US', 'USA', 'الولايات المتحدة'),
(45382, 3229870848, 3229874943, 'US', 'USA', 'الولايات المتحدة'),
(45383, 3229874944, 3229875455, 'AU', 'AUS', 'أستراليا'),
(45384, 3229875456, 3229875967, 'US', 'USA', 'الولايات المتحدة'),
(45385, 3229876480, 3229877503, 'US', 'USA', 'الولايات المتحدة'),
(45386, 3229877760, 3229878271, 'US', 'USA', 'الولايات المتحدة'),
(45387, 3229878528, 3229878783, 'GB', 'GBR', 'المملكة المتحدة'),
(45388, 3229878784, 3229879039, 'IT', 'ITA', 'إيطاليا'),
(45389, 3229879040, 3229879295, 'NO', 'NOR', 'النرويج'),
(45390, 3229879296, 3229880063, 'US', 'USA', 'الولايات المتحدة'),
(45391, 3229880064, 3229880319, 'KR', 'KOR', 'جمهورية كوريا'),
(45392, 3229880320, 3229881087, 'US', 'USA', 'الولايات المتحدة'),
(45393, 3229881088, 3229881343, 'CA', 'CAN', 'كندا'),
(45394, 3229881344, 3229883135, 'US', 'USA', 'الولايات المتحدة'),
(45395, 3229883648, 3229883903, 'US', 'USA', 'الولايات المتحدة'),
(45396, 3229884160, 3229884415, 'JP', 'JPN', 'اليابان'),
(45397, 3229884928, 3229885183, 'IT', 'ITA', 'إيطاليا'),
(45398, 3229885184, 3229885439, 'BR', 'BRA', 'البرازيل'),
(45399, 3229885440, 3229886719, 'US', 'USA', 'الولايات المتحدة'),
(45400, 3229886720, 3229886975, 'AU', 'AUS', 'أستراليا'),
(45401, 3229886976, 3229887487, 'US', 'USA', 'الولايات المتحدة'),
(45402, 3229887744, 3229889791, 'US', 'USA', 'الولايات المتحدة'),
(45403, 3229889792, 3229890047, 'PT', 'PRT', 'البورتوغال'),
(45404, 3229890048, 3229890303, 'US', 'USA', 'الولايات المتحدة'),
(45405, 3229890304, 3229890559, 'PT', 'PRT', 'البورتوغال'),
(45406, 3229890560, 3229891327, 'US', 'USA', 'الولايات المتحدة'),
(45407, 3229891584, 3229891839, 'CA', 'CAN', 'كندا'),
(45408, 3229892608, 3229900031, 'US', 'USA', 'الولايات المتحدة'),
(45409, 3229900032, 3229900287, 'AU', 'AUS', 'أستراليا'),
(45410, 3229900288, 3229901567, 'US', 'USA', 'الولايات المتحدة'),
(45411, 3229901568, 3229901823, 'GB', 'GBR', 'المملكة المتحدة'),
(45412, 3229901824, 3229902335, 'US', 'USA', 'الولايات المتحدة'),
(45413, 3229902336, 3229902591, 'AU', 'AUS', 'أستراليا'),
(45414, 3229902592, 3229928703, 'US', 'USA', 'الولايات المتحدة'),
(45415, 3229928960, 3229930495, 'US', 'USA', 'الولايات المتحدة'),
(45416, 3229930752, 3229937407, 'US', 'USA', 'الولايات المتحدة'),
(45417, 3229937408, 3229937663, 'GB', 'GBR', 'المملكة المتحدة'),
(45418, 3229937664, 3229937919, 'US', 'USA', 'الولايات المتحدة'),
(45419, 3229937920, 3229938175, 'CA', 'CAN', 'كندا'),
(45420, 3229938176, 3229938431, 'US', 'USA', 'الولايات المتحدة'),
(45421, 3229938688, 3229938943, 'IL', 'ISR', 'إسرائيل'),
(45422, 3229938944, 3229939199, 'AT', 'AUT', 'النمسا'),
(45423, 3229939200, 3229939455, 'US', 'USA', 'الولايات المتحدة'),
(45424, 3229939456, 3229940735, 'KR', 'KOR', 'جمهورية كوريا'),
(45425, 3229940736, 3229940991, 'CH', 'CHE', 'سويسرا'),
(45426, 3229940992, 3229941247, 'AU', 'AUS', 'أستراليا'),
(45427, 3229941248, 3229941503, 'US', 'USA', 'الولايات المتحدة'),
(45428, 3229942272, 3229942783, 'US', 'USA', 'الولايات المتحدة'),
(45429, 3229943040, 3229943295, 'US', 'USA', 'الولايات المتحدة'),
(45430, 3229943552, 3229944319, 'US', 'USA', 'الولايات المتحدة'),
(45431, 3229944320, 3229944575, 'TH', 'THA', 'تايلند'),
(45432, 3229944576, 3229945087, 'US', 'USA', 'الولايات المتحدة'),
(45433, 3229945344, 3229945599, 'AU', 'AUS', 'أستراليا'),
(45434, 3229945600, 3229945855, 'PT', 'PRT', 'البورتوغال'),
(45435, 3229946112, 3229947135, 'US', 'USA', 'الولايات المتحدة'),
(45436, 3229947136, 3229947391, 'AU', 'AUS', 'أستراليا'),
(45437, 3229947392, 3229948415, 'US', 'USA', 'الولايات المتحدة'),
(45438, 3229948672, 3229948927, 'US', 'USA', 'الولايات المتحدة'),
(45439, 3229948928, 3229949183, 'IT', 'ITA', 'إيطاليا'),
(45440, 3229949184, 3229949439, 'GB', 'GBR', 'المملكة المتحدة'),
(45441, 3229949440, 3229949695, 'US', 'USA', 'الولايات المتحدة'),
(45442, 3229949696, 3229949951, 'NZ', 'NZL', 'نيوزيلاندا'),
(45443, 3229949952, 3229950207, 'NO', 'NOR', 'النرويج'),
(45444, 3229950208, 3229950975, 'US', 'USA', 'الولايات المتحدة'),
(45445, 3229950976, 3229951231, 'IL', 'ISR', 'إسرائيل'),
(45446, 3229951232, 3229952255, 'US', 'USA', 'الولايات المتحدة'),
(45447, 3229952256, 3229952511, 'AU', 'AUS', 'أستراليا'),
(45448, 3229952512, 3229953279, 'US', 'USA', 'الولايات المتحدة'),
(45449, 3229953536, 3229953791, 'US', 'USA', 'الولايات المتحدة'),
(45450, 3229954048, 3229954303, 'US', 'USA', 'الولايات المتحدة'),
(45451, 3229954560, 3229955327, 'US', 'USA', 'الولايات المتحدة'),
(45452, 3229955328, 3229955583, 'NL', 'NLD', 'هولندا'),
(45453, 3229955584, 3229956095, 'PT', 'PRT', 'البورتوغال'),
(45454, 3229956096, 3229956607, 'US', 'USA', 'الولايات المتحدة'),
(45455, 3229956608, 3229956863, 'GB', 'GBR', 'المملكة المتحدة'),
(45456, 3229956864, 3229958143, 'US', 'USA', 'الولايات المتحدة'),
(45457, 3229958144, 3229958399, 'NO', 'NOR', 'النرويج'),
(45458, 3229958400, 3229958655, 'US', 'USA', 'الولايات المتحدة'),
(45459, 3229958656, 3229958911, 'NZ', 'NZL', 'نيوزيلاندا'),
(45460, 3229958912, 3229959167, 'SG', 'SGP', 'سنغافورة'),
(45461, 3229959168, 3229960191, 'US', 'USA', 'الولايات المتحدة'),
(45462, 3229960448, 3229960959, 'US', 'USA', 'الولايات المتحدة'),
(45463, 3229963008, 3229963519, 'US', 'USA', 'الولايات المتحدة'),
(45464, 3229963776, 3229964799, 'US', 'USA', 'الولايات المتحدة'),
(45465, 3229965056, 3229967615, 'US', 'USA', 'الولايات المتحدة'),
(45466, 3229967872, 3229968127, 'US', 'USA', 'الولايات المتحدة'),
(45467, 3229968128, 3229968383, 'BE', 'BEL', 'بلجيكا'),
(45468, 3229968384, 3229968895, 'US', 'USA', 'الولايات المتحدة'),
(45469, 3229969408, 3229969663, 'PT', 'PRT', 'البورتوغال'),
(45470, 3229969664, 3229969919, 'AT', 'AUT', 'النمسا'),
(45471, 3229969920, 3229970431, 'FI', 'FIN', 'فنلندا'),
(45472, 3229971456, 3229972735, 'US', 'USA', 'الولايات المتحدة'),
(45473, 3229972736, 3229972991, 'SE', 'SWE', 'السويد'),
(45474, 3229972992, 3229975295, 'US', 'USA', 'الولايات المتحدة'),
(45475, 3229975296, 3229975551, 'GB', 'GBR', 'المملكة المتحدة'),
(45476, 3229975552, 3229976575, 'US', 'USA', 'الولايات المتحدة'),
(45477, 3229978624, 3230004223, 'US', 'USA', 'الولايات المتحدة'),
(45478, 3230004224, 3230004479, 'GB', 'GBR', 'المملكة المتحدة'),
(45479, 3230004480, 3230004991, 'US', 'USA', 'الولايات المتحدة'),
(45480, 3230006016, 3230007039, 'US', 'USA', 'الولايات المتحدة'),
(45481, 3230007296, 3230072831, 'FR', 'FRA', 'فرنسا'),
(45482, 3230073088, 3230074623, 'US', 'USA', 'الولايات المتحدة'),
(45483, 3230074624, 3230074879, 'DE', 'DEU', 'ألمانيا'),
(45484, 3230074880, 3230082559, 'IT', 'ITA', 'إيطاليا'),
(45485, 3230082560, 3230082815, 'US', 'USA', 'الولايات المتحدة'),
(45486, 3230083072, 3230084607, 'US', 'USA', 'الولايات المتحدة'),
(45487, 3230084608, 3230084863, 'NO', 'NOR', 'النرويج'),
(45488, 3230084864, 3230085119, 'US', 'USA', 'الولايات المتحدة'),
(45489, 3230085120, 3230085375, 'CA', 'CAN', 'كندا'),
(45490, 3230085376, 3230085631, 'US', 'USA', 'الولايات المتحدة'),
(45491, 3230085888, 3230086143, 'DE', 'DEU', 'ألمانيا'),
(45492, 3230086144, 3230086655, 'GB', 'GBR', 'المملكة المتحدة'),
(45493, 3230088960, 3230089215, 'AT', 'AUT', 'النمسا'),
(45494, 3230089216, 3230089727, 'US', 'USA', 'الولايات المتحدة'),
(45495, 3230089728, 3230089983, 'GB', 'GBR', 'المملكة المتحدة'),
(45496, 3230089984, 3230090239, 'US', 'USA', 'الولايات المتحدة'),
(45497, 3230090240, 3230090495, 'GB', 'GBR', 'المملكة المتحدة'),
(45498, 3230090496, 3230092543, 'US', 'USA', 'الولايات المتحدة'),
(45499, 3230092544, 3230092799, 'CA', 'CAN', 'كندا'),
(45500, 3230092800, 3230093823, 'US', 'USA', 'الولايات المتحدة'),
(45501, 3230093824, 3230094079, 'NL', 'NLD', 'هولندا'),
(45502, 3230094080, 3230094335, 'CA', 'CAN', 'كندا'),
(45503, 3230094336, 3230095615, 'US', 'USA', 'الولايات المتحدة'),
(45504, 3230095616, 3230095871, 'JP', 'JPN', 'اليابان'),
(45505, 3230096384, 3230096639, 'JP', 'JPN', 'اليابان'),
(45506, 3230096896, 3230097151, 'JP', 'JPN', 'اليابان'),
(45507, 3230097408, 3230097663, 'JP', 'JPN', 'اليابان'),
(45508, 3230098688, 3230100735, 'JP', 'JPN', 'اليابان'),
(45509, 3230101504, 3230104319, 'US', 'USA', 'الولايات المتحدة'),
(45510, 3230104576, 3230105855, 'US', 'USA', 'الولايات المتحدة'),
(45511, 3230105856, 3230106111, 'PT', 'PRT', 'البورتوغال'),
(45512, 3230106112, 3230106879, 'US', 'USA', 'الولايات المتحدة'),
(45513, 3230106880, 3230107135, 'AT', 'AUT', 'النمسا'),
(45514, 3230107136, 3230107647, 'US', 'USA', 'الولايات المتحدة'),
(45515, 3230107904, 3230109439, 'US', 'USA', 'الولايات المتحدة'),
(45516, 3230109440, 3230109695, 'NO', 'NOR', 'النرويج'),
(45517, 3230109696, 3230109951, 'US', 'USA', 'الولايات المتحدة'),
(45518, 3230109952, 3230115071, 'CH', 'CHE', 'سويسرا'),
(45519, 3230115072, 3230115327, 'IT', 'ITA', 'إيطاليا'),
(45520, 3230115328, 3230115583, 'GR', 'GRC', 'اليونان'),
(45521, 3230115584, 3230116095, 'BE', 'BEL', 'بلجيكا'),
(45522, 3230116096, 3230117631, 'US', 'USA', 'الولايات المتحدة'),
(45523, 3230117632, 3230117887, 'FR', 'FRA', 'فرنسا'),
(45524, 3230117888, 3230120191, 'US', 'USA', 'الولايات المتحدة'),
(45525, 3230120192, 3230120447, 'BE', 'BEL', 'بلجيكا'),
(45526, 3230120448, 3230120703, 'US', 'USA', 'الولايات المتحدة'),
(45527, 3230120704, 3230120959, 'PT', 'PRT', 'البورتوغال'),
(45528, 3230121216, 3230122495, 'US', 'USA', 'الولايات المتحدة'),
(45529, 3230123264, 3230123775, 'US', 'USA', 'الولايات المتحدة'),
(45530, 3230125312, 3230125567, 'US', 'USA', 'الولايات المتحدة'),
(45531, 3230125824, 3230126335, 'AU', 'AUS', 'أستراليا'),
(45532, 3230126336, 3230126591, 'US', 'USA', 'الولايات المتحدة'),
(45533, 3230126592, 3230126847, 'AU', 'AUS', 'أستراليا'),
(45534, 3230126848, 3230128639, 'US', 'USA', 'الولايات المتحدة'),
(45535, 3230128896, 3230129151, 'PT', 'PRT', 'البورتوغال'),
(45536, 3230129152, 3230129663, 'US', 'USA', 'الولايات المتحدة'),
(45537, 3230129664, 3230129919, 'JP', 'JPN', 'اليابان'),
(45538, 3230130432, 3230130687, 'IE', 'IRL', 'إيرلندا'),
(45539, 3230130688, 3230131711, 'US', 'USA', 'الولايات المتحدة'),
(45540, 3230131968, 3230132991, 'GB', 'GBR', 'المملكة المتحدة'),
(45541, 3230132992, 3230136319, 'US', 'USA', 'الولايات المتحدة'),
(45542, 3230136576, 3230137087, 'US', 'USA', 'الولايات المتحدة'),
(45543, 3230137344, 3230137599, 'US', 'USA', 'الولايات المتحدة'),
(45544, 3230137600, 3230137855, 'NO', 'NOR', 'النرويج'),
(45545, 3230137856, 3230138111, 'PL', 'POL', 'بولندا'),
(45546, 3230138624, 3230140159, 'US', 'USA', 'الولايات المتحدة'),
(45547, 3230140160, 3230140415, 'MT', 'MLT', 'مالطا'),
(45548, 3230140416, 3230140671, 'US', 'USA', 'الولايات المتحدة'),
(45549, 3230140672, 3230140927, 'FI', 'FIN', 'فنلندا'),
(45550, 3230140928, 3230142975, 'US', 'USA', 'الولايات المتحدة'),
(45551, 3230142976, 3230143231, 'GB', 'GBR', 'المملكة المتحدة'),
(45552, 3230143232, 3230143487, 'BE', 'BEL', 'بلجيكا'),
(45553, 3230143488, 3230144255, 'US', 'USA', 'الولايات المتحدة'),
(45554, 3230144256, 3230144511, 'NL', 'NLD', 'هولندا'),
(45555, 3230144512, 3230145279, 'US', 'USA', 'الولايات المتحدة'),
(45556, 3230145280, 3230145535, 'CA', 'CAN', 'كندا'),
(45557, 3230145536, 3230145791, 'US', 'USA', 'الولايات المتحدة'),
(45558, 3230145792, 3230146047, 'GB', 'GBR', 'المملكة المتحدة'),
(45559, 3230146048, 3230146303, 'FR', 'FRA', 'فرنسا'),
(45560, 3230146304, 3230146559, 'PT', 'PRT', 'البورتوغال'),
(45561, 3230146560, 3230147583, 'US', 'USA', 'الولايات المتحدة'),
(45562, 3230147840, 3230148351, 'US', 'USA', 'الولايات المتحدة'),
(45563, 3230148352, 3230148607, 'AU', 'AUS', 'أستراليا'),
(45564, 3230148608, 3230148863, 'GB', 'GBR', 'المملكة المتحدة'),
(45565, 3230148864, 3230149119, 'CH', 'CHE', 'سويسرا'),
(45566, 3230149120, 3230150655, 'NI', 'NIC', 'نيكاراغوا'),
(45567, 3230150656, 3230150911, 'US', 'USA', 'الولايات المتحدة'),
(45568, 3230150912, 3230151167, 'PT', 'PRT', 'البورتوغال'),
(45569, 3230151168, 3230151423, 'US', 'USA', 'الولايات المتحدة'),
(45570, 3230151424, 3230151679, 'NL', 'NLD', 'هولندا'),
(45571, 3230151680, 3230151935, 'PT', 'PRT', 'البورتوغال'),
(45572, 3230152192, 3230152447, 'FR', 'FRA', 'فرنسا'),
(45573, 3230153216, 3230153471, 'FR', 'FRA', 'فرنسا'),
(45574, 3230153472, 3230153727, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(45575, 3230153728, 3230153983, 'US', 'USA', 'الولايات المتحدة'),
(45576, 3230153984, 3230154239, 'RU', 'RUS', 'الإتحاد الروسي'),
(45577, 3230154240, 3230156543, 'US', 'USA', 'الولايات المتحدة'),
(45578, 3230156544, 3230164735, 'FI', 'FIN', 'فنلندا'),
(45579, 3230165504, 3230167295, 'US', 'USA', 'الولايات المتحدة'),
(45580, 3230167552, 3230168063, 'CA', 'CAN', 'كندا'),
(45581, 3230168832, 3230172927, 'US', 'USA', 'الولايات المتحدة'),
(45582, 3230173184, 3230174463, 'US', 'USA', 'الولايات المتحدة'),
(45583, 3230174464, 3230175231, 'IN', 'IND', 'الهند'),
(45584, 3230175232, 3230177791, 'US', 'USA', 'الولايات المتحدة'),
(45585, 3230177792, 3230178303, 'GB', 'GBR', 'المملكة المتحدة'),
(45586, 3230178304, 3230178559, 'CH', 'CHE', 'سويسرا'),
(45587, 3230203904, 3230269439, 'US', 'USA', 'الولايات المتحدة'),
(45588, 3230269696, 3230271743, 'GB', 'GBR', 'المملكة المتحدة'),
(45589, 3230275584, 3230291455, 'US', 'USA', 'الولايات المتحدة'),
(45590, 3230291456, 3230291711, 'PT', 'PRT', 'البورتوغال'),
(45591, 3230291712, 3230294783, 'US', 'USA', 'الولايات المتحدة'),
(45592, 3230295040, 3230295295, 'AU', 'AUS', 'أستراليا'),
(45593, 3230295296, 3230296319, 'US', 'USA', 'الولايات المتحدة'),
(45594, 3230296320, 3230297343, 'NO', 'NOR', 'النرويج'),
(45595, 3230297344, 3230299647, 'SE', 'SWE', 'السويد'),
(45596, 3230299648, 3230301695, 'SG', 'SGP', 'سنغافورة'),
(45597, 3230301696, 3230302207, 'US', 'USA', 'الولايات المتحدة'),
(45598, 3230302208, 3230302975, 'CA', 'CAN', 'كندا'),
(45599, 3230302976, 3230303487, 'US', 'USA', 'الولايات المتحدة'),
(45600, 3230303744, 3230307327, 'US', 'USA', 'الولايات المتحدة'),
(45601, 3230307584, 3230309119, 'US', 'USA', 'الولايات المتحدة'),
(45602, 3230309120, 3230309375, 'NO', 'NOR', 'النرويج'),
(45603, 3230309376, 3230310143, 'GB', 'GBR', 'المملكة المتحدة'),
(45604, 3230310144, 3230310655, 'US', 'USA', 'الولايات المتحدة'),
(45605, 3230310912, 3230311423, 'US', 'USA', 'الولايات المتحدة'),
(45606, 3230311680, 3230316287, 'US', 'USA', 'الولايات المتحدة'),
(45607, 3230316288, 3230316543, 'IT', 'ITA', 'إيطاليا'),
(45608, 3230316544, 3230316799, 'US', 'USA', 'الولايات المتحدة'),
(45609, 3230316800, 3230317311, 'CA', 'CAN', 'كندا'),
(45610, 3230317312, 3230317567, 'US', 'USA', 'الولايات المتحدة'),
(45611, 3230317568, 3230317823, 'SG', 'SGP', 'سنغافورة'),
(45612, 3230317824, 3230318591, 'US', 'USA', 'الولايات المتحدة'),
(45613, 3230318592, 3230318847, 'GB', 'GBR', 'المملكة المتحدة'),
(45614, 3230318848, 3230321663, 'US', 'USA', 'الولايات المتحدة'),
(45615, 3230321664, 3230321919, 'PT', 'PRT', 'البورتوغال'),
(45616, 3230321920, 3230322175, 'US', 'USA', 'الولايات المتحدة'),
(45617, 3230322432, 3230322943, 'US', 'USA', 'الولايات المتحدة'),
(45618, 3230323968, 3230325247, 'US', 'USA', 'الولايات المتحدة'),
(45619, 3230325760, 3230327551, 'US', 'USA', 'الولايات المتحدة'),
(45620, 3230327808, 3230328063, 'AT', 'AUT', 'النمسا'),
(45621, 3230328064, 3230328319, 'GB', 'GBR', 'المملكة المتحدة'),
(45622, 3230328320, 3230329087, 'CH', 'CHE', 'سويسرا'),
(45623, 3230329088, 3230332927, 'US', 'USA', 'الولايات المتحدة'),
(45624, 3230332928, 3230333183, 'GB', 'GBR', 'المملكة المتحدة'),
(45625, 3230333184, 3230333695, 'US', 'USA', 'الولايات المتحدة'),
(45626, 3230333696, 3230333951, 'NZ', 'NZL', 'نيوزيلاندا'),
(45627, 3230333952, 3230334719, 'US', 'USA', 'الولايات المتحدة'),
(45628, 3230335232, 3230335743, 'CA', 'CAN', 'كندا'),
(45629, 3230336000, 3230336255, 'CA', 'CAN', 'كندا'),
(45630, 3230336512, 3230339583, 'CA', 'CAN', 'كندا'),
(45631, 3230339840, 3230340095, 'CA', 'CAN', 'كندا'),
(45632, 3230340352, 3230350847, 'CA', 'CAN', 'كندا'),
(45633, 3230351104, 3230354943, 'CA', 'CAN', 'كندا'),
(45634, 3230354944, 3230355199, 'FR', 'FRA', 'فرنسا'),
(45635, 3230355200, 3230367743, 'CA', 'CAN', 'كندا'),
(45636, 3230368000, 3230368511, 'CA', 'CAN', 'كندا'),
(45637, 3230369024, 3230370303, 'US', 'USA', 'الولايات المتحدة'),
(45638, 3230370304, 3230370559, 'CA', 'CAN', 'كندا'),
(45639, 3230370816, 3230372607, 'CA', 'CAN', 'كندا'),
(45640, 3230372864, 3230383359, 'CA', 'CAN', 'كندا'),
(45641, 3230383616, 3230384127, 'CA', 'CAN', 'كندا'),
(45642, 3230384384, 3230387455, 'CA', 'CAN', 'كندا'),
(45643, 3230387712, 3230400255, 'CA', 'CAN', 'كندا'),
(45644, 3230400768, 3230591231, 'FR', 'FRA', 'فرنسا'),
(45645, 3230591232, 3230591487, 'FI', 'FIN', 'فنلندا'),
(45646, 3230591488, 3230625791, 'FR', 'FRA', 'فرنسا'),
(45647, 3230625792, 3230626047, 'FI', 'FIN', 'فنلندا'),
(45648, 3230626048, 3230654879, 'FR', 'FRA', 'فرنسا'),
(45649, 3230654880, 3230654895, 'HU', 'HUN', 'هنغاريا'),
(45650, 3230654896, 3230787327, 'FR', 'FRA', 'فرنسا'),
(45651, 3230793984, 3230822655, 'US', 'USA', 'الولايات المتحدة'),
(45652, 3230822912, 3230823679, 'US', 'USA', 'الولايات المتحدة'),
(45653, 3230823680, 3230823935, 'DK', 'DNK', 'الدنيمارك'),
(45654, 3230824192, 3230824447, 'FR', 'FRA', 'فرنسا'),
(45655, 3230824448, 3230825215, 'US', 'USA', 'الولايات المتحدة'),
(45656, 3230825216, 3230825471, 'GB', 'GBR', 'المملكة المتحدة'),
(45657, 3230825472, 3230826239, 'ES', 'ESP', 'إسبانيا'),
(45658, 3230826240, 3230827007, 'US', 'USA', 'الولايات المتحدة'),
(45659, 3230827520, 3230827775, 'AT', 'AUT', 'النمسا'),
(45660, 3230827776, 3230828031, 'NZ', 'NZL', 'نيوزيلاندا'),
(45661, 3230828032, 3230828543, 'HU', 'HUN', 'هنغاريا'),
(45662, 3230828544, 3230830079, 'GB', 'GBR', 'المملكة المتحدة'),
(45663, 3230830080, 3230832127, 'US', 'USA', 'الولايات المتحدة'),
(45664, 3230832128, 3230832383, 'NZ', 'NZL', 'نيوزيلاندا'),
(45665, 3230832384, 3230832639, 'US', 'USA', 'الولايات المتحدة'),
(45666, 3230832640, 3230832895, 'FI', 'FIN', 'فنلندا'),
(45667, 3230832896, 3230833663, 'US', 'USA', 'الولايات المتحدة'),
(45668, 3230833664, 3230833919, 'CA', 'CAN', 'كندا'),
(45669, 3230833920, 3230834175, 'BR', 'BRA', 'البرازيل'),
(45670, 3230834176, 3230835455, 'US', 'USA', 'الولايات المتحدة'),
(45671, 3230835456, 3230837503, 'NO', 'NOR', 'النرويج'),
(45672, 3230837504, 3230837759, 'US', 'USA', 'الولايات المتحدة'),
(45673, 3230837760, 3230838015, 'ES', 'ESP', 'إسبانيا'),
(45674, 3230838016, 3230840319, 'IT', 'ITA', 'إيطاليا'),
(45675, 3230840320, 3230840575, 'FR', 'FRA', 'فرنسا'),
(45676, 3230840576, 3230840831, 'US', 'USA', 'الولايات المتحدة'),
(45677, 3230840832, 3230841087, 'JP', 'JPN', 'اليابان'),
(45678, 3230841088, 3230841343, 'DE', 'DEU', 'ألمانيا'),
(45679, 3230841600, 3230841855, 'ES', 'ESP', 'إسبانيا'),
(45680, 3230841856, 3230842111, 'US', 'USA', 'الولايات المتحدة'),
(45681, 3230842112, 3230842367, 'AU', 'AUS', 'أستراليا'),
(45682, 3230842624, 3230843135, 'US', 'USA', 'الولايات المتحدة'),
(45683, 3230843136, 3230843391, 'NO', 'NOR', 'النرويج'),
(45684, 3230843392, 3230844671, 'US', 'USA', 'الولايات المتحدة'),
(45685, 3230844928, 3230845183, 'AU', 'AUS', 'أستراليا'),
(45686, 3230845184, 3230845951, 'US', 'USA', 'الولايات المتحدة'),
(45687, 3230845952, 3230846207, 'CZ', 'CZE', 'التشيك'),
(45688, 3230846208, 3230849535, 'US', 'USA', 'الولايات المتحدة'),
(45689, 3230849536, 3230850047, 'NZ', 'NZL', 'نيوزيلاندا'),
(45690, 3230850048, 3230851839, 'US', 'USA', 'الولايات المتحدة'),
(45691, 3230851840, 3230852095, 'NO', 'NOR', 'النرويج'),
(45692, 3230852096, 3230852351, 'GB', 'GBR', 'المملكة المتحدة'),
(45693, 3230852352, 3230852607, 'BR', 'BRA', 'البرازيل'),
(45694, 3230853120, 3230853375, 'AU', 'AUS', 'أستراليا'),
(45695, 3230853376, 3230853887, 'FR', 'FRA', 'فرنسا'),
(45696, 3230853888, 3230854399, 'US', 'USA', 'الولايات المتحدة'),
(45697, 3230854400, 3230854655, 'UY', 'URY', 'الأوروغواي'),
(45698, 3230854656, 3230855167, 'NO', 'NOR', 'النرويج'),
(45699, 3230855168, 3230855679, 'US', 'USA', 'الولايات المتحدة'),
(45700, 3230855680, 3230855935, 'IT', 'ITA', 'إيطاليا'),
(45701, 3230855936, 3230857983, 'US', 'USA', 'الولايات المتحدة'),
(45702, 3230857984, 3230858751, 'AU', 'AUS', 'أستراليا'),
(45703, 3230858752, 3230859007, 'US', 'USA', 'الولايات المتحدة'),
(45704, 3230860032, 3230865151, 'US', 'USA', 'الولايات المتحدة'),
(45705, 3230865152, 3230865407, 'GB', 'GBR', 'المملكة المتحدة'),
(45706, 3230865664, 3230867967, 'US', 'USA', 'الولايات المتحدة'),
(45707, 3230867968, 3230868223, 'IS', 'ISL', 'أيسلندا'),
(45708, 3230868224, 3230868479, 'US', 'USA', 'الولايات المتحدة'),
(45709, 3230868480, 3230868735, 'GB', 'GBR', 'المملكة المتحدة'),
(45710, 3230868992, 3230870015, 'US', 'USA', 'الولايات المتحدة'),
(45711, 3230870016, 3230870271, 'PL', 'POL', 'بولندا'),
(45712, 3230870272, 3230877183, 'US', 'USA', 'الولايات المتحدة'),
(45713, 3230877696, 3230878719, 'US', 'USA', 'الولايات المتحدة'),
(45714, 3230878720, 3230879487, 'PT', 'PRT', 'البورتوغال'),
(45715, 3230879488, 3230879743, 'FR', 'FRA', 'فرنسا'),
(45716, 3230879744, 3230888447, 'US', 'USA', 'الولايات المتحدة'),
(45717, 3230888448, 3230888703, 'AU', 'AUS', 'أستراليا'),
(45718, 3230888704, 3230888959, 'US', 'USA', 'الولايات المتحدة'),
(45719, 3230889216, 3230895359, 'US', 'USA', 'الولايات المتحدة'),
(45720, 3230895360, 3230895615, 'PL', 'POL', 'بولندا'),
(45721, 3230895616, 3230897151, 'US', 'USA', 'الولايات المتحدة'),
(45722, 3230897408, 3230897663, 'US', 'USA', 'الولايات المتحدة'),
(45723, 3230897664, 3230897919, 'GB', 'GBR', 'المملكة المتحدة'),
(45724, 3230897920, 3230898687, 'NZ', 'NZL', 'نيوزيلاندا'),
(45725, 3230898688, 3230898943, 'US', 'USA', 'الولايات المتحدة'),
(45726, 3230898944, 3230899199, 'PT', 'PRT', 'البورتوغال'),
(45727, 3230899200, 3230913023, 'US', 'USA', 'الولايات المتحدة'),
(45728, 3230913024, 3230913279, 'BR', 'BRA', 'البرازيل'),
(45729, 3230913280, 3230913535, 'US', 'USA', 'الولايات المتحدة'),
(45730, 3230913536, 3230913791, 'GB', 'GBR', 'المملكة المتحدة'),
(45731, 3230913792, 3230914047, 'CA', 'CAN', 'كندا'),
(45732, 3230914048, 3230914303, 'US', 'USA', 'الولايات المتحدة'),
(45733, 3230914304, 3230914815, 'FI', 'FIN', 'فنلندا'),
(45734, 3230914816, 3230915071, 'GB', 'GBR', 'المملكة المتحدة'),
(45735, 3230915072, 3230915327, 'BR', 'BRA', 'البرازيل'),
(45736, 3230915328, 3230915583, 'GB', 'GBR', 'المملكة المتحدة'),
(45737, 3230915584, 3230917631, 'US', 'USA', 'الولايات المتحدة'),
(45738, 3230917632, 3230917887, 'GB', 'GBR', 'المملكة المتحدة'),
(45739, 3230917888, 3230918399, 'US', 'USA', 'الولايات المتحدة'),
(45740, 3230918656, 3230919423, 'US', 'USA', 'الولايات المتحدة'),
(45741, 3230919424, 3230919679, 'AU', 'AUS', 'أستراليا'),
(45742, 3230919680, 3230920959, 'US', 'USA', 'الولايات المتحدة'),
(45743, 3230921216, 3230922239, 'US', 'USA', 'الولايات المتحدة'),
(45744, 3230922240, 3230922495, 'AU', 'AUS', 'أستراليا'),
(45745, 3230922496, 3230922751, 'IT', 'ITA', 'إيطاليا'),
(45746, 3230922752, 3230923519, 'US', 'USA', 'الولايات المتحدة'),
(45747, 3230923776, 3230924031, 'US', 'USA', 'الولايات المتحدة'),
(45748, 3230924032, 3230924287, 'AU', 'AUS', 'أستراليا'),
(45749, 3230924288, 3230924543, 'US', 'USA', 'الولايات المتحدة'),
(45750, 3230924800, 3230933247, 'US', 'USA', 'الولايات المتحدة'),
(45751, 3230933248, 3230948607, 'SE', 'SWE', 'السويد'),
(45752, 3230948608, 3230951167, 'US', 'USA', 'الولايات المتحدة'),
(45753, 3230951168, 3230951423, 'PT', 'PRT', 'البورتوغال'),
(45754, 3230951680, 3230951935, 'US', 'USA', 'الولايات المتحدة'),
(45755, 3230952192, 3230953215, 'US', 'USA', 'الولايات المتحدة'),
(45756, 3230954496, 3230967295, 'AU', 'AUS', 'أستراليا'),
(45757, 3230967296, 3230967551, 'RU', 'RUS', 'الإتحاد الروسي'),
(45758, 3230967552, 3230967807, 'ES', 'ESP', 'إسبانيا'),
(45759, 3230967808, 3230969087, 'US', 'USA', 'الولايات المتحدة'),
(45760, 3230969344, 3230969599, 'US', 'USA', 'الولايات المتحدة'),
(45761, 3230969600, 3230969855, 'MX', 'MEX', 'المكسيك'),
(45762, 3230969856, 3230970111, 'US', 'USA', 'الولايات المتحدة'),
(45763, 3230970112, 3230972671, 'GB', 'GBR', 'المملكة المتحدة'),
(45764, 3230972672, 3230973951, 'US', 'USA', 'الولايات المتحدة'),
(45765, 3230973952, 3230974207, 'NL', 'NLD', 'هولندا'),
(45766, 3230974208, 3230974463, 'IT', 'ITA', 'إيطاليا'),
(45767, 3230974464, 3230974719, 'GB', 'GBR', 'المملكة المتحدة'),
(45768, 3230974720, 3230975487, 'US', 'USA', 'الولايات المتحدة'),
(45769, 3230975488, 3230975999, 'GB', 'GBR', 'المملكة المتحدة'),
(45770, 3230976000, 3230976255, 'NL', 'NLD', 'هولندا'),
(45771, 3230976256, 3230980095, 'ES', 'ESP', 'إسبانيا'),
(45772, 3230980096, 3230980351, 'GB', 'GBR', 'المملكة المتحدة'),
(45773, 3230980352, 3230980607, 'CA', 'CAN', 'كندا'),
(45774, 3230980608, 3230980863, 'US', 'USA', 'الولايات المتحدة'),
(45775, 3230981120, 3230981375, 'IT', 'ITA', 'إيطاليا'),
(45776, 3230981376, 3230981631, 'NZ', 'NZL', 'نيوزيلاندا'),
(45777, 3230981632, 3230981887, 'US', 'USA', 'الولايات المتحدة'),
(45778, 3230981888, 3230983935, 'AU', 'AUS', 'أستراليا'),
(45779, 3230983936, 3230989823, 'US', 'USA', 'الولايات المتحدة'),
(45780, 3230990592, 3230991103, 'US', 'USA', 'الولايات المتحدة'),
(45781, 3230991104, 3230991359, 'PL', 'POL', 'بولندا'),
(45782, 3230991360, 3230991615, 'US', 'USA', 'الولايات المتحدة'),
(45783, 3230991616, 3230991871, 'FI', 'FIN', 'فنلندا'),
(45784, 3230991872, 3230992383, 'US', 'USA', 'الولايات المتحدة'),
(45785, 3230992640, 3230994175, 'US', 'USA', 'الولايات المتحدة'),
(45786, 3230994176, 3230994431, 'GB', 'GBR', 'المملكة المتحدة'),
(45787, 3230994432, 3230994687, 'US', 'USA', 'الولايات المتحدة'),
(45788, 3230994944, 3230995199, 'US', 'USA', 'الولايات المتحدة'),
(45789, 3230995200, 3230995455, 'ES', 'ESP', 'إسبانيا'),
(45790, 3230995456, 3230995711, 'AU', 'AUS', 'أستراليا'),
(45791, 3230995712, 3230996223, 'US', 'USA', 'الولايات المتحدة'),
(45792, 3230996480, 3230997247, 'US', 'USA', 'الولايات المتحدة'),
(45793, 3230997248, 3230997503, 'AT', 'AUT', 'النمسا'),
(45794, 3230997504, 3230997759, 'US', 'USA', 'الولايات المتحدة'),
(45795, 3230997760, 3230999039, 'NL', 'NLD', 'هولندا'),
(45796, 3230999040, 3230999295, 'US', 'USA', 'الولايات المتحدة'),
(45797, 3230999296, 3230999551, 'NL', 'NLD', 'هولندا'),
(45798, 3230999552, 3230999807, 'AU', 'AUS', 'أستراليا'),
(45799, 3230999808, 3231000319, 'US', 'USA', 'الولايات المتحدة'),
(45800, 3231000576, 3231000831, 'US', 'USA', 'الولايات المتحدة'),
(45801, 3231000832, 3231001087, 'FR', 'FRA', 'فرنسا'),
(45802, 3231001088, 3231003903, 'US', 'USA', 'الولايات المتحدة'),
(45803, 3231003904, 3231004159, 'CA', 'CAN', 'كندا'),
(45804, 3231004160, 3231004415, 'AU', 'AUS', 'أستراليا'),
(45805, 3231004416, 3231004927, 'US', 'USA', 'الولايات المتحدة'),
(45806, 3231004928, 3231005183, 'GB', 'GBR', 'المملكة المتحدة'),
(45807, 3231005440, 3231005695, 'FR', 'FRA', 'فرنسا'),
(45808, 3231005696, 3231005951, 'GB', 'GBR', 'المملكة المتحدة'),
(45809, 3231005952, 3231007487, 'US', 'USA', 'الولايات المتحدة'),
(45810, 3231009280, 3231009791, 'US', 'USA', 'الولايات المتحدة'),
(45811, 3231010048, 3231010303, 'FR', 'FRA', 'فرنسا'),
(45812, 3231010304, 3231010815, 'NO', 'NOR', 'النرويج'),
(45813, 3231010816, 3231011071, 'CA', 'CAN', 'كندا'),
(45814, 3231011072, 3231011839, 'US', 'USA', 'الولايات المتحدة'),
(45815, 3231012096, 3231012863, 'US', 'USA', 'الولايات المتحدة'),
(45816, 3231013120, 3231013375, 'US', 'USA', 'الولايات المتحدة'),
(45817, 3231013888, 3231014655, 'US', 'USA', 'الولايات المتحدة'),
(45818, 3231015168, 3231015423, 'US', 'USA', 'الولايات المتحدة'),
(45819, 3231015424, 3231015679, 'CA', 'CAN', 'كندا'),
(45820, 3231015680, 3231015935, 'US', 'USA', 'الولايات المتحدة'),
(45821, 3231015936, 3231016191, 'NO', 'NOR', 'النرويج'),
(45822, 3231016192, 3231016447, 'US', 'USA', 'الولايات المتحدة'),
(45823, 3231016448, 3231016703, 'NO', 'NOR', 'النرويج'),
(45824, 3231016704, 3231016959, 'US', 'USA', 'الولايات المتحدة'),
(45825, 3231017216, 3231018495, 'US', 'USA', 'الولايات المتحدة'),
(45826, 3231018496, 3231018751, 'IT', 'ITA', 'إيطاليا'),
(45827, 3231018752, 3231019007, 'GB', 'GBR', 'المملكة المتحدة'),
(45828, 3231019008, 3231019775, 'US', 'USA', 'الولايات المتحدة'),
(45829, 3231020032, 3231020287, 'US', 'USA', 'الولايات المتحدة'),
(45830, 3231020288, 3231020543, 'GB', 'GBR', 'المملكة المتحدة'),
(45831, 3231020544, 3231020799, 'NL', 'NLD', 'هولندا'),
(45832, 3231020800, 3231021567, 'GB', 'GBR', 'المملكة المتحدة'),
(45833, 3231021568, 3231021823, 'US', 'USA', 'الولايات المتحدة'),
(45834, 3231021824, 3231022079, 'CA', 'CAN', 'كندا'),
(45835, 3231022080, 3231022591, 'US', 'USA', 'الولايات المتحدة'),
(45836, 3231022592, 3231022847, 'DE', 'DEU', 'ألمانيا'),
(45837, 3231022848, 3231028479, 'US', 'USA', 'الولايات المتحدة'),
(45838, 3231028480, 3231028735, 'AU', 'AUS', 'أستراليا'),
(45839, 3231028736, 3231042047, 'US', 'USA', 'الولايات المتحدة'),
(45840, 3231042048, 3231042303, 'GU', 'GUM', 'غوام'),
(45841, 3231042304, 3231043839, 'US', 'USA', 'الولايات المتحدة'),
(45842, 3231043840, 3231044095, 'JP', 'JPN', 'اليابان'),
(45843, 3231044352, 3231046399, 'US', 'USA', 'الولايات المتحدة'),
(45844, 3231046656, 3231048447, 'US', 'USA', 'الولايات المتحدة'),
(45845, 3231048448, 3231048703, 'NL', 'NLD', 'هولندا'),
(45846, 3231048704, 3231049727, 'US', 'USA', 'الولايات المتحدة'),
(45847, 3231049728, 3231049983, 'AT', 'AUT', 'النمسا'),
(45848, 3231049984, 3231050239, 'US', 'USA', 'الولايات المتحدة'),
(45849, 3231050496, 3231051263, 'US', 'USA', 'الولايات المتحدة'),
(45850, 3231051264, 3231051519, 'GB', 'GBR', 'المملكة المتحدة'),
(45851, 3231051520, 3231051775, 'HK', 'HKG', 'هونغ كونغ'),
(45852, 3231051776, 3231053055, 'US', 'USA', 'الولايات المتحدة'),
(45853, 3231054848, 3231055103, 'US', 'USA', 'الولايات المتحدة'),
(45854, 3231056128, 3231066367, 'US', 'USA', 'الولايات المتحدة'),
(45855, 3231067392, 3231067647, 'US', 'USA', 'الولايات المتحدة'),
(45856, 3231068928, 3231070463, 'US', 'USA', 'الولايات المتحدة'),
(45857, 3231070720, 3231074559, 'SE', 'SWE', 'السويد'),
(45858, 3231075072, 3231075583, 'SE', 'SWE', 'السويد'),
(45859, 3231075840, 3231077119, 'SE', 'SWE', 'السويد'),
(45860, 3231077376, 3231077631, 'SE', 'SWE', 'السويد'),
(45861, 3231078144, 3231078655, 'US', 'USA', 'الولايات المتحدة'),
(45862, 3231078656, 3231078911, 'GB', 'GBR', 'المملكة المتحدة'),
(45863, 3231078912, 3231079423, 'CA', 'CAN', 'كندا'),
(45864, 3231079424, 3231079679, 'GB', 'GBR', 'المملكة المتحدة'),
(45865, 3231079680, 3231079935, 'US', 'USA', 'الولايات المتحدة'),
(45866, 3231079936, 3231080191, 'NL', 'NLD', 'هولندا'),
(45867, 3231080192, 3231080447, 'US', 'USA', 'الولايات المتحدة'),
(45868, 3231080448, 3231080703, 'AU', 'AUS', 'أستراليا'),
(45869, 3231080704, 3231082495, 'US', 'USA', 'الولايات المتحدة'),
(45870, 3231082496, 3231082751, 'PL', 'POL', 'بولندا'),
(45871, 3231082752, 3231083007, 'US', 'USA', 'الولايات المتحدة'),
(45872, 3231083008, 3231083263, 'GB', 'GBR', 'المملكة المتحدة'),
(45873, 3231083264, 3231083519, 'AU', 'AUS', 'أستراليا'),
(45874, 3231083520, 3231085567, 'US', 'USA', 'الولايات المتحدة'),
(45875, 3231085824, 3231087359, 'US', 'USA', 'الولايات المتحدة'),
(45876, 3231087616, 3231087871, 'NO', 'NOR', 'النرويج'),
(45877, 3231087872, 3231088127, 'US', 'USA', 'الولايات المتحدة'),
(45878, 3231088128, 3231088383, 'GT', 'GTM', 'غواتيمالا'),
(45879, 3231088384, 3231088895, 'US', 'USA', 'الولايات المتحدة'),
(45880, 3231088896, 3231091711, 'AU', 'AUS', 'أستراليا'),
(45881, 3231091712, 3231091967, 'GB', 'GBR', 'المملكة المتحدة'),
(45882, 3231091968, 3231092223, 'US', 'USA', 'الولايات المتحدة'),
(45883, 3231092480, 3231092735, 'US', 'USA', 'الولايات المتحدة'),
(45884, 3231092736, 3231092991, 'NZ', 'NZL', 'نيوزيلاندا'),
(45885, 3231092992, 3231093247, 'US', 'USA', 'الولايات المتحدة'),
(45886, 3231093248, 3231093503, 'IT', 'ITA', 'إيطاليا'),
(45887, 3231093504, 3231094527, 'US', 'USA', 'الولايات المتحدة'),
(45888, 3231097088, 3231100415, 'US', 'USA', 'الولايات المتحدة'),
(45889, 3231100672, 3231101183, 'US', 'USA', 'الولايات المتحدة'),
(45890, 3231101184, 3231103231, 'GB', 'GBR', 'المملكة المتحدة'),
(45891, 3231103488, 3231103999, 'US', 'USA', 'الولايات المتحدة'),
(45892, 3231104000, 3231104255, 'NO', 'NOR', 'النرويج'),
(45893, 3231104256, 3231104767, 'DE', 'DEU', 'ألمانيا'),
(45894, 3231104768, 3231105023, 'US', 'USA', 'الولايات المتحدة'),
(45895, 3231105024, 3231105535, 'PT', 'PRT', 'البورتوغال'),
(45896, 3231105536, 3231106303, 'IT', 'ITA', 'إيطاليا'),
(45897, 3231106304, 3231106559, 'NO', 'NOR', 'النرويج'),
(45898, 3231106560, 3231106815, 'GB', 'GBR', 'المملكة المتحدة'),
(45899, 3231106816, 3231107071, 'US', 'USA', 'الولايات المتحدة'),
(45900, 3231107072, 3231107327, 'AU', 'AUS', 'أستراليا'),
(45901, 3231107328, 3231107583, 'US', 'USA', 'الولايات المتحدة'),
(45902, 3231107584, 3231107839, 'AU', 'AUS', 'أستراليا'),
(45903, 3231107840, 3231108095, 'AT', 'AUT', 'النمسا'),
(45904, 3231108096, 3231108351, 'GB', 'GBR', 'المملكة المتحدة'),
(45905, 3231108352, 3231108607, 'RU', 'RUS', 'الإتحاد الروسي'),
(45906, 3231108608, 3231108863, 'US', 'USA', 'الولايات المتحدة'),
(45907, 3231109120, 3231109375, 'GB', 'GBR', 'المملكة المتحدة'),
(45908, 3231109376, 3231109631, 'NO', 'NOR', 'النرويج'),
(45909, 3231109632, 3231109887, 'US', 'USA', 'الولايات المتحدة'),
(45910, 3231110144, 3231110399, 'US', 'USA', 'الولايات المتحدة'),
(45911, 3231111168, 3231111679, 'US', 'USA', 'الولايات المتحدة'),
(45912, 3231111680, 3231112447, 'NZ', 'NZL', 'نيوزيلاندا'),
(45913, 3231112448, 3231112959, 'US', 'USA', 'الولايات المتحدة'),
(45914, 3231112960, 3231113215, 'NO', 'NOR', 'النرويج'),
(45915, 3231113216, 3231113983, 'US', 'USA', 'الولايات المتحدة'),
(45916, 3231113984, 3231115775, 'GB', 'GBR', 'المملكة المتحدة'),
(45917, 3231115776, 3231116799, 'AU', 'AUS', 'أستراليا'),
(45918, 3231116800, 3231117055, 'HU', 'HUN', 'هنغاريا'),
(45919, 3231117056, 3231118335, 'US', 'USA', 'الولايات المتحدة'),
(45920, 3231118592, 3231118847, 'US', 'USA', 'الولايات المتحدة'),
(45921, 3231118848, 3231119103, 'AU', 'AUS', 'أستراليا'),
(45922, 3231119104, 3231119359, 'US', 'USA', 'الولايات المتحدة'),
(45923, 3231119360, 3231119615, 'GB', 'GBR', 'المملكة المتحدة'),
(45924, 3231119616, 3231120383, 'TH', 'THA', 'تايلند'),
(45925, 3231120384, 3231120639, 'NO', 'NOR', 'النرويج'),
(45926, 3231120640, 3231120895, 'US', 'USA', 'الولايات المتحدة'),
(45927, 3231120896, 3231121151, 'NO', 'NOR', 'النرويج'),
(45928, 3231121664, 3231135231, 'US', 'USA', 'الولايات المتحدة'),
(45929, 3231135232, 3231135487, 'CH', 'CHE', 'سويسرا'),
(45930, 3231135488, 3231149311, 'US', 'USA', 'الولايات المتحدة'),
(45931, 3231149312, 3231149567, 'CA', 'CAN', 'كندا'),
(45932, 3231149568, 3231150079, 'US', 'USA', 'الولايات المتحدة'),
(45933, 3231150080, 3231150335, 'NL', 'NLD', 'هولندا'),
(45934, 3231150336, 3231154431, 'US', 'USA', 'الولايات المتحدة'),
(45935, 3231154432, 3231154687, 'IN', 'IND', 'الهند'),
(45936, 3231187200, 3231188479, 'US', 'USA', 'الولايات المتحدة'),
(45937, 3231188480, 3231188735, 'NO', 'NOR', 'النرويج'),
(45938, 3231188736, 3231189503, 'US', 'USA', 'الولايات المتحدة'),
(45939, 3231189760, 3231190527, 'US', 'USA', 'الولايات المتحدة'),
(45940, 3231190528, 3231190783, 'GB', 'GBR', 'المملكة المتحدة'),
(45941, 3231190784, 3231191295, 'US', 'USA', 'الولايات المتحدة'),
(45942, 3231191296, 3231191551, 'GB', 'GBR', 'المملكة المتحدة'),
(45943, 3231191552, 3231192575, 'US', 'USA', 'الولايات المتحدة'),
(45944, 3231193600, 3231194111, 'DE', 'DEU', 'ألمانيا'),
(45945, 3231194368, 3231197695, 'US', 'USA', 'الولايات المتحدة'),
(45946, 3231197696, 3231197951, 'FR', 'FRA', 'فرنسا'),
(45947, 3231197952, 3231198207, 'US', 'USA', 'الولايات المتحدة'),
(45948, 3231198208, 3231198463, 'GB', 'GBR', 'المملكة المتحدة'),
(45949, 3231198464, 3231198975, 'US', 'USA', 'الولايات المتحدة'),
(45950, 3231198976, 3231199231, 'PT', 'PRT', 'البورتوغال'),
(45951, 3231199232, 3231199487, 'GB', 'GBR', 'المملكة المتحدة'),
(45952, 3231199488, 3231200255, 'NL', 'NLD', 'هولندا'),
(45953, 3231200256, 3231200767, 'US', 'USA', 'الولايات المتحدة'),
(45954, 3231200768, 3231201023, 'AT', 'AUT', 'النمسا'),
(45955, 3231201024, 3231202559, 'US', 'USA', 'الولايات المتحدة'),
(45956, 3231202560, 3231203071, 'GB', 'GBR', 'المملكة المتحدة'),
(45957, 3231203072, 3231203327, 'AT', 'AUT', 'النمسا'),
(45958, 3231203328, 3231203839, 'US', 'USA', 'الولايات المتحدة'),
(45959, 3231204096, 3231204351, 'US', 'USA', 'الولايات المتحدة'),
(45960, 3231204352, 3231204607, 'FI', 'FIN', 'فنلندا'),
(45961, 3231204608, 3231204863, 'JP', 'JPN', 'اليابان'),
(45962, 3231204864, 3231207167, 'US', 'USA', 'الولايات المتحدة'),
(45963, 3231207424, 3231207935, 'US', 'USA', 'الولايات المتحدة'),
(45964, 3231207936, 3231208191, 'DE', 'DEU', 'ألمانيا'),
(45965, 3231208192, 3231208959, 'US', 'USA', 'الولايات المتحدة'),
(45966, 3231208960, 3231209471, 'AU', 'AUS', 'أستراليا'),
(45967, 3231209472, 3231210239, 'US', 'USA', 'الولايات المتحدة'),
(45968, 3231210496, 3231211775, 'US', 'USA', 'الولايات المتحدة'),
(45969, 3231211776, 3231212031, 'CA', 'CAN', 'كندا'),
(45970, 3231212032, 3231212287, 'CH', 'CHE', 'سويسرا'),
(45971, 3231212288, 3231214335, 'US', 'USA', 'الولايات المتحدة'),
(45972, 3231214336, 3231214591, 'CA', 'CAN', 'كندا'),
(45973, 3231214592, 3231215103, 'US', 'USA', 'الولايات المتحدة'),
(45974, 3231215360, 3231215615, 'NO', 'NOR', 'النرويج'),
(45975, 3231215616, 3231215871, 'GB', 'GBR', 'المملكة المتحدة'),
(45976, 3231215872, 3231217151, 'US', 'USA', 'الولايات المتحدة'),
(45977, 3231217408, 3231217663, 'AU', 'AUS', 'أستراليا'),
(45978, 3231217664, 3231218175, 'US', 'USA', 'الولايات المتحدة'),
(45979, 3231218176, 3231218431, 'GB', 'GBR', 'المملكة المتحدة'),
(45980, 3231218432, 3231218687, 'US', 'USA', 'الولايات المتحدة'),
(45981, 3231218688, 3231218943, 'BE', 'BEL', 'بلجيكا'),
(45982, 3231218944, 3231219967, 'US', 'USA', 'الولايات المتحدة'),
(45983, 3231221248, 3231221503, 'US', 'USA', 'الولايات المتحدة'),
(45984, 3231221760, 3231223039, 'US', 'USA', 'الولايات المتحدة'),
(45985, 3231223040, 3231223295, 'IT', 'ITA', 'إيطاليا'),
(45986, 3231223296, 3231223807, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(45987, 3231223808, 3231224063, 'AU', 'AUS', 'أستراليا'),
(45988, 3231224064, 3231224319, 'US', 'USA', 'الولايات المتحدة'),
(45989, 3231224320, 3231224575, 'AU', 'AUS', 'أستراليا'),
(45990, 3231224576, 3231225599, 'US', 'USA', 'الولايات المتحدة'),
(45991, 3231225600, 3231225855, 'DE', 'DEU', 'ألمانيا'),
(45992, 3231226368, 3231226879, 'US', 'USA', 'الولايات المتحدة'),
(45993, 3231226880, 3231227135, 'GB', 'GBR', 'المملكة المتحدة'),
(45994, 3231227648, 3231228927, 'US', 'USA', 'الولايات المتحدة'),
(45995, 3231228928, 3231229183, 'PR', 'PRI', 'بورتو ريكو'),
(45996, 3231229184, 3231229439, 'CA', 'CAN', 'كندا'),
(45997, 3231229440, 3231229695, 'IT', 'ITA', 'إيطاليا'),
(45998, 3231229696, 3231229951, 'FR', 'FRA', 'فرنسا'),
(45999, 3231229952, 3231231487, 'US', 'USA', 'الولايات المتحدة'),
(46000, 3231231488, 3231231743, 'PT', 'PRT', 'البورتوغال'),
(46001, 3231231744, 3231233023, 'US', 'USA', 'الولايات المتحدة'),
(46002, 3231233280, 3231234047, 'US', 'USA', 'الولايات المتحدة'),
(46003, 3231234048, 3231235071, 'GB', 'GBR', 'المملكة المتحدة'),
(46004, 3231235072, 3231236095, 'US', 'USA', 'الولايات المتحدة'),
(46005, 3231236608, 3231236863, 'US', 'USA', 'الولايات المتحدة'),
(46006, 3231236864, 3231237119, 'CA', 'CAN', 'كندا'),
(46007, 3231237120, 3231237375, 'US', 'USA', 'الولايات المتحدة'),
(46008, 3231237376, 3231237631, 'AU', 'AUS', 'أستراليا'),
(46009, 3231237632, 3231238911, 'US', 'USA', 'الولايات المتحدة'),
(46010, 3231239168, 3231241215, 'US', 'USA', 'الولايات المتحدة'),
(46011, 3231241216, 3231241471, 'JP', 'JPN', 'اليابان'),
(46012, 3231241984, 3231244287, 'US', 'USA', 'الولايات المتحدة'),
(46013, 3231244544, 3231248639, 'US', 'USA', 'الولايات المتحدة'),
(46014, 3231248640, 3231248895, 'GB', 'GBR', 'المملكة المتحدة'),
(46015, 3231248896, 3231249407, 'US', 'USA', 'الولايات المتحدة'),
(46016, 3231249408, 3231249663, 'GB', 'GBR', 'المملكة المتحدة'),
(46017, 3231249664, 3231250431, 'US', 'USA', 'الولايات المتحدة'),
(46018, 3231250432, 3231250687, 'CA', 'CAN', 'كندا'),
(46019, 3231250688, 3231251711, 'US', 'USA', 'الولايات المتحدة'),
(46020, 3231251712, 3231251967, 'GB', 'GBR', 'المملكة المتحدة'),
(46021, 3231251968, 3231252223, 'AT', 'AUT', 'النمسا'),
(46022, 3231252736, 3231252991, 'US', 'USA', 'الولايات المتحدة'),
(46023, 3231252992, 3231253503, 'GB', 'GBR', 'المملكة المتحدة'),
(46024, 3231253504, 3231254015, 'US', 'USA', 'الولايات المتحدة'),
(46025, 3231254272, 3231254783, 'US', 'USA', 'الولايات المتحدة'),
(46026, 3231254784, 3231255039, 'AU', 'AUS', 'أستراليا'),
(46027, 3231255040, 3231255551, 'US', 'USA', 'الولايات المتحدة'),
(46028, 3231255552, 3231255807, 'GB', 'GBR', 'المملكة المتحدة'),
(46029, 3231255808, 3231256063, 'PT', 'PRT', 'البورتوغال'),
(46030, 3231256320, 3231257087, 'US', 'USA', 'الولايات المتحدة'),
(46031, 3231257088, 3231257599, 'HU', 'HUN', 'هنغاريا'),
(46032, 3231257600, 3231258879, 'US', 'USA', 'الولايات المتحدة'),
(46033, 3231259136, 3231264255, 'US', 'USA', 'الولايات المتحدة'),
(46034, 3231264512, 3231265791, 'US', 'USA', 'الولايات المتحدة'),
(46035, 3231266048, 3231275007, 'US', 'USA', 'الولايات المتحدة'),
(46036, 3231275008, 3231275263, 'BR', 'BRA', 'البرازيل'),
(46037, 3231275264, 3231275519, 'CH', 'CHE', 'سويسرا'),
(46038, 3231275520, 3231276287, 'US', 'USA', 'الولايات المتحدة'),
(46039, 3231276288, 3231276543, 'AU', 'AUS', 'أستراليا'),
(46040, 3231276544, 3231276799, 'US', 'USA', 'الولايات المتحدة'),
(46041, 3231276800, 3231281919, 'JP', 'JPN', 'اليابان'),
(46042, 3231281920, 3231282175, 'US', 'USA', 'الولايات المتحدة'),
(46043, 3231282176, 3231282431, 'HU', 'HUN', 'هنغاريا'),
(46044, 3231282432, 3231282943, 'US', 'USA', 'الولايات المتحدة'),
(46045, 3231282944, 3231283199, 'CL', 'CHL', 'تشيلي'),
(46046, 3231283200, 3231283455, 'BR', 'BRA', 'البرازيل'),
(46047, 3231283456, 3231284991, 'US', 'USA', 'الولايات المتحدة'),
(46048, 3231284992, 3231285247, 'PL', 'POL', 'بولندا'),
(46049, 3231285248, 3231291647, 'US', 'USA', 'الولايات المتحدة'),
(46050, 3231291648, 3231291903, 'GB', 'GBR', 'المملكة المتحدة'),
(46051, 3231291904, 3231292159, 'US', 'USA', 'الولايات المتحدة'),
(46052, 3231292160, 3231292415, 'BR', 'BRA', 'البرازيل'),
(46053, 3231292416, 3231292927, 'US', 'USA', 'الولايات المتحدة'),
(46054, 3231292928, 3231293183, 'AU', 'AUS', 'أستراليا'),
(46055, 3231293184, 3231294975, 'US', 'USA', 'الولايات المتحدة'),
(46056, 3231294976, 3231295231, 'GB', 'GBR', 'المملكة المتحدة'),
(46057, 3231295232, 3231295487, 'CR', 'CRI', 'كوستا ريكا'),
(46058, 3231295488, 3231295743, 'BE', 'BEL', 'بلجيكا'),
(46059, 3231295744, 3231296255, 'US', 'USA', 'الولايات المتحدة'),
(46060, 3231296256, 3231296511, 'RU', 'RUS', 'الإتحاد الروسي'),
(46061, 3231296512, 3231296767, 'US', 'USA', 'الولايات المتحدة'),
(46062, 3231296768, 3231299327, 'AT', 'AUT', 'النمسا'),
(46063, 3231299328, 3231299583, 'US', 'USA', 'الولايات المتحدة'),
(46064, 3231300352, 3231300607, 'US', 'USA', 'الولايات المتحدة'),
(46065, 3231300608, 3231300863, 'SE', 'SWE', 'السويد'),
(46066, 3231300864, 3231301119, 'GB', 'GBR', 'المملكة المتحدة'),
(46067, 3231301120, 3231302143, 'US', 'USA', 'الولايات المتحدة'),
(46068, 3231302144, 3231302399, 'NO', 'NOR', 'النرويج'),
(46069, 3231302400, 3231302655, 'US', 'USA', 'الولايات المتحدة'),
(46070, 3231302656, 3231303167, 'AU', 'AUS', 'أستراليا'),
(46071, 3231303168, 3231307007, 'US', 'USA', 'الولايات المتحدة'),
(46072, 3231307008, 3231307263, 'GB', 'GBR', 'المملكة المتحدة'),
(46073, 3231307264, 3231308031, 'US', 'USA', 'الولايات المتحدة'),
(46074, 3231308032, 3231308287, 'CA', 'CAN', 'كندا'),
(46075, 3231308288, 3231308799, 'US', 'USA', 'الولايات المتحدة'),
(46076, 3231308800, 3231309055, 'CA', 'CAN', 'كندا'),
(46077, 3231309056, 3231311103, 'PH', 'PHL', 'الفلبين'),
(46078, 3231311104, 3231316735, 'US', 'USA', 'الولايات المتحدة'),
(46079, 3231316736, 3231316991, 'NZ', 'NZL', 'نيوزيلاندا'),
(46080, 3231316992, 3231317759, 'US', 'USA', 'الولايات المتحدة'),
(46081, 3231318272, 3231318783, 'US', 'USA', 'الولايات المتحدة'),
(46082, 3231319040, 3231319807, 'US', 'USA', 'الولايات المتحدة'),
(46083, 3231320064, 3231321343, 'US', 'USA', 'الولايات المتحدة'),
(46084, 3231322112, 3231324671, 'SG', 'SGP', 'سنغافورة'),
(46085, 3231326208, 3231333119, 'US', 'USA', 'الولايات المتحدة'),
(46086, 3231333376, 3231338495, 'US', 'USA', 'الولايات المتحدة'),
(46087, 3231338752, 3231342591, 'US', 'USA', 'الولايات المتحدة'),
(46088, 3231350528, 3231351551, 'US', 'USA', 'الولايات المتحدة'),
(46089, 3231383808, 3231385343, 'NO', 'NOR', 'النرويج'),
(46090, 3231385856, 3231401215, 'US', 'USA', 'الولايات المتحدة'),
(46091, 3231416320, 3231423999, 'US', 'USA', 'الولايات المتحدة'),
(46092, 3231449088, 3231482879, 'US', 'USA', 'الولايات المتحدة'),
(46093, 3231482880, 3231483135, 'BE', 'BEL', 'بلجيكا'),
(46094, 3231483136, 3231484927, 'US', 'USA', 'الولايات المتحدة'),
(46095, 3231484928, 3231485951, 'JP', 'JPN', 'اليابان'),
(46096, 3231486208, 3231489279, 'JP', 'JPN', 'اليابان'),
(46097, 3231489536, 3231490047, 'JP', 'JPN', 'اليابان'),
(46098, 3231490048, 3231490559, 'US', 'USA', 'الولايات المتحدة'),
(46099, 3231490560, 3231490815, 'GB', 'GBR', 'المملكة المتحدة'),
(46100, 3231490816, 3231491071, 'US', 'USA', 'الولايات المتحدة'),
(46101, 3231491328, 3231491583, 'NZ', 'NZL', 'نيوزيلاندا'),
(46102, 3231491584, 3231491839, 'US', 'USA', 'الولايات المتحدة'),
(46103, 3231491840, 3231492095, 'GB', 'GBR', 'المملكة المتحدة'),
(46104, 3231492096, 3231497727, 'US', 'USA', 'الولايات المتحدة'),
(46105, 3231497984, 3231499263, 'US', 'USA', 'الولايات المتحدة'),
(46106, 3231499520, 3231500031, 'US', 'USA', 'الولايات المتحدة'),
(46107, 3231500032, 3231500287, 'BM', 'BMU', 'برمودا'),
(46108, 3231500288, 3231502079, 'US', 'USA', 'الولايات المتحدة'),
(46109, 3231502080, 3231502591, 'AU', 'AUS', 'أستراليا'),
(46110, 3231502592, 3231502847, 'US', 'USA', 'الولايات المتحدة'),
(46111, 3231502848, 3231503103, 'PT', 'PRT', 'البورتوغال'),
(46112, 3231503104, 3231503615, 'US', 'USA', 'الولايات المتحدة'),
(46113, 3231503616, 3231503871, 'IT', 'ITA', 'إيطاليا'),
(46114, 3231503872, 3231504383, 'US', 'USA', 'الولايات المتحدة'),
(46115, 3231504640, 3231504895, 'GB', 'GBR', 'المملكة المتحدة'),
(46116, 3231505152, 3231505407, 'US', 'USA', 'الولايات المتحدة'),
(46117, 3231505664, 3231506687, 'US', 'USA', 'الولايات المتحدة'),
(46118, 3231506688, 3231506943, 'NZ', 'NZL', 'نيوزيلاندا'),
(46119, 3231506944, 3231507199, 'US', 'USA', 'الولايات المتحدة'),
(46120, 3231507200, 3231507455, 'BE', 'BEL', 'بلجيكا'),
(46121, 3231507456, 3231507967, 'US', 'USA', 'الولايات المتحدة'),
(46122, 3231508224, 3231508479, 'US', 'USA', 'الولايات المتحدة'),
(46123, 3231508992, 3231509247, 'US', 'USA', 'الولايات المتحدة'),
(46124, 3231510272, 3231510527, 'GB', 'GBR', 'المملكة المتحدة'),
(46125, 3231510784, 3231511551, 'US', 'USA', 'الولايات المتحدة'),
(46126, 3231512576, 3231512831, 'LU', 'LUX', 'لوكسيمبورغ'),
(46127, 3231512832, 3231513087, 'AU', 'AUS', 'أستراليا'),
(46128, 3231513088, 3231513343, 'US', 'USA', 'الولايات المتحدة'),
(46129, 3231513600, 3231514367, 'US', 'USA', 'الولايات المتحدة'),
(46130, 3231514880, 3231515647, 'NO', 'NOR', 'النرويج'),
(46131, 3231515648, 3231516159, 'US', 'USA', 'الولايات المتحدة'),
(46132, 3231516672, 3231519231, 'SE', 'SWE', 'السويد'),
(46133, 3231522560, 3231524607, 'US', 'USA', 'الولايات المتحدة'),
(46134, 3231531008, 3231533567, 'US', 'USA', 'الولايات المتحدة'),
(46135, 3231547392, 3231547647, 'US', 'USA', 'الولايات المتحدة'),
(46136, 3231547648, 3231547903, 'NO', 'NOR', 'النرويج'),
(46137, 3231547904, 3231556095, 'US', 'USA', 'الولايات المتحدة'),
(46138, 3231556096, 3231556351, 'HK', 'HKG', 'هونغ كونغ'),
(46139, 3231556352, 3231557887, 'US', 'USA', 'الولايات المتحدة'),
(46140, 3231557888, 3231558399, 'GB', 'GBR', 'المملكة المتحدة'),
(46141, 3231558400, 3231558655, 'DE', 'DEU', 'ألمانيا'),
(46142, 3231558656, 3231558911, 'GB', 'GBR', 'المملكة المتحدة'),
(46143, 3231558912, 3231559167, 'CA', 'CAN', 'كندا'),
(46144, 3231559168, 3231559423, 'GB', 'GBR', 'المملكة المتحدة'),
(46145, 3231559424, 3231559679, 'US', 'USA', 'الولايات المتحدة'),
(46146, 3231559680, 3231559935, 'GB', 'GBR', 'المملكة المتحدة'),
(46147, 3231559936, 3231561983, 'US', 'USA', 'الولايات المتحدة'),
(46148, 3231561984, 3231562239, 'IT', 'ITA', 'إيطاليا'),
(46149, 3231562240, 3231562495, 'US', 'USA', 'الولايات المتحدة'),
(46150, 3231562496, 3231562751, 'GB', 'GBR', 'المملكة المتحدة'),
(46151, 3231562752, 3231563007, 'US', 'USA', 'الولايات المتحدة'),
(46152, 3231563008, 3231563263, 'CH', 'CHE', 'سويسرا'),
(46153, 3231563520, 3231563775, 'HK', 'HKG', 'هونغ كونغ'),
(46154, 3231580416, 3231580927, 'US', 'USA', 'الولايات المتحدة'),
(46155, 3231581184, 3231583231, 'US', 'USA', 'الولايات المتحدة'),
(46156, 3231584256, 3231586559, 'US', 'USA', 'الولايات المتحدة'),
(46157, 3231588352, 3231596031, 'US', 'USA', 'الولايات المتحدة'),
(46158, 3231596544, 3231634943, 'US', 'USA', 'الولايات المتحدة'),
(46159, 3231643648, 3231644927, 'US', 'USA', 'الولايات المتحدة'),
(46160, 3231645184, 3231645439, 'US', 'USA', 'الولايات المتحدة'),
(46161, 3231645952, 3231647743, 'US', 'USA', 'الولايات المتحدة'),
(46162, 3231648000, 3231649791, 'US', 'USA', 'الولايات المتحدة'),
(46163, 3231649792, 3231653631, 'SG', 'SGP', 'سنغافورة'),
(46164, 3231653888, 3231655167, 'US', 'USA', 'الولايات المتحدة'),
(46165, 3231663616, 3231663871, 'FI', 'FIN', 'فنلندا'),
(46166, 3231663872, 3231664127, 'CA', 'CAN', 'كندا'),
(46167, 3231664128, 3231664383, 'US', 'USA', 'الولايات المتحدة'),
(46168, 3231664384, 3231664639, 'GB', 'GBR', 'المملكة المتحدة'),
(46169, 3231664640, 3231665407, 'US', 'USA', 'الولايات المتحدة'),
(46170, 3231665408, 3231665663, 'IT', 'ITA', 'إيطاليا'),
(46171, 3231665664, 3231667199, 'US', 'USA', 'الولايات المتحدة'),
(46172, 3231667200, 3231667711, 'ES', 'ESP', 'إسبانيا'),
(46173, 3231667712, 3231668735, 'US', 'USA', 'الولايات المتحدة'),
(46174, 3231668736, 3231668991, 'BE', 'BEL', 'بلجيكا'),
(46175, 3231669248, 3231669503, 'US', 'USA', 'الولايات المتحدة'),
(46176, 3231669760, 3231670015, 'CA', 'CAN', 'كندا'),
(46177, 3231670016, 3231670271, 'DE', 'DEU', 'ألمانيا'),
(46178, 3231670272, 3231671039, 'US', 'USA', 'الولايات المتحدة'),
(46179, 3231671040, 3231672319, 'GB', 'GBR', 'المملكة المتحدة'),
(46180, 3231672320, 3231672575, 'US', 'USA', 'الولايات المتحدة'),
(46181, 3231672576, 3231672831, 'NL', 'NLD', 'هولندا'),
(46182, 3231672832, 3231673343, 'US', 'USA', 'الولايات المتحدة'),
(46183, 3231673344, 3231673599, 'NO', 'NOR', 'النرويج'),
(46184, 3231673600, 3231673855, 'IE', 'IRL', 'إيرلندا'),
(46185, 3231673856, 3231674111, 'US', 'USA', 'الولايات المتحدة'),
(46186, 3231674112, 3231674367, 'CA', 'CAN', 'كندا'),
(46187, 3231674368, 3231675391, 'US', 'USA', 'الولايات المتحدة'),
(46188, 3231675392, 3231675903, 'BR', 'BRA', 'البرازيل'),
(46189, 3231675904, 3231676159, 'IE', 'IRL', 'إيرلندا'),
(46190, 3231676672, 3231676927, 'FR', 'FRA', 'فرنسا'),
(46191, 3231676928, 3231677183, 'FI', 'FIN', 'فنلندا'),
(46192, 3231678464, 3231682047, 'US', 'USA', 'الولايات المتحدة'),
(46193, 3231711488, 3231713023, 'US', 'USA', 'الولايات المتحدة'),
(46194, 3231713024, 3231713279, 'CA', 'CAN', 'كندا'),
(46195, 3231713280, 3231713791, 'US', 'USA', 'الولايات المتحدة'),
(46196, 3231713792, 3231714047, 'IE', 'IRL', 'إيرلندا'),
(46197, 3231714048, 3231715071, 'US', 'USA', 'الولايات المتحدة'),
(46198, 3231715072, 3231715327, 'SI', 'SVN', 'سلوفينيا'),
(46199, 3231715328, 3231715583, 'AU', 'AUS', 'أستراليا'),
(46200, 3231715584, 3231716095, 'US', 'USA', 'الولايات المتحدة'),
(46201, 3231716096, 3231716351, 'AU', 'AUS', 'أستراليا'),
(46202, 3231716352, 3231716607, 'US', 'USA', 'الولايات المتحدة'),
(46203, 3231716608, 3231716863, 'TR', 'TUR', 'تركيا'),
(46204, 3231716864, 3231717119, 'LU', 'LUX', 'لوكسيمبورغ'),
(46205, 3231717120, 3231717375, 'NO', 'NOR', 'النرويج'),
(46206, 3231717632, 3231718143, 'US', 'USA', 'الولايات المتحدة'),
(46207, 3231718144, 3231718399, 'IT', 'ITA', 'إيطاليا'),
(46208, 3231718400, 3231718655, 'US', 'USA', 'الولايات المتحدة'),
(46209, 3231718656, 3231718911, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(46210, 3231718912, 3231719679, 'US', 'USA', 'الولايات المتحدة'),
(46211, 3231719680, 3231719935, 'ES', 'ESP', 'إسبانيا'),
(46212, 3231720192, 3231720703, 'US', 'USA', 'الولايات المتحدة'),
(46213, 3231720704, 3231720959, 'IT', 'ITA', 'إيطاليا'),
(46214, 3231720960, 3231722751, 'US', 'USA', 'الولايات المتحدة'),
(46215, 3231722752, 3231723007, 'BR', 'BRA', 'البرازيل'),
(46216, 3231723008, 3231723519, 'US', 'USA', 'الولايات المتحدة'),
(46217, 3231723776, 3231724031, 'US', 'USA', 'الولايات المتحدة'),
(46218, 3231724032, 3231724287, 'BR', 'BRA', 'البرازيل'),
(46219, 3231724288, 3231725055, 'US', 'USA', 'الولايات المتحدة'),
(46220, 3231725312, 3231727871, 'US', 'USA', 'الولايات المتحدة'),
(46221, 3231727872, 3231728127, 'DE', 'DEU', 'ألمانيا'),
(46222, 3231728384, 3231728639, 'AT', 'AUT', 'النمسا'),
(46223, 3231728640, 3231729407, 'US', 'USA', 'الولايات المتحدة'),
(46224, 3231729408, 3231729663, 'AU', 'AUS', 'أستراليا'),
(46225, 3231729664, 3231735551, 'US', 'USA', 'الولايات المتحدة'),
(46226, 3231735552, 3231736063, 'CH', 'CHE', 'سويسرا'),
(46227, 3231736064, 3231737087, 'US', 'USA', 'الولايات المتحدة'),
(46228, 3231737600, 3231738367, 'US', 'USA', 'الولايات المتحدة'),
(46229, 3231738368, 3231738623, 'NL', 'NLD', 'هولندا'),
(46230, 3231738624, 3231739135, 'US', 'USA', 'الولايات المتحدة'),
(46231, 3231739136, 3231739391, 'GB', 'GBR', 'المملكة المتحدة'),
(46232, 3231739392, 3231739647, 'PL', 'POL', 'بولندا'),
(46233, 3231739648, 3231739903, 'BR', 'BRA', 'البرازيل'),
(46234, 3231739904, 3231742719, 'US', 'USA', 'الولايات المتحدة'),
(46235, 3231742720, 3231742975, 'FR', 'FRA', 'فرنسا'),
(46236, 3231742976, 3231743487, 'US', 'USA', 'الولايات المتحدة'),
(46237, 3231743488, 3231743743, 'NO', 'NOR', 'النرويج'),
(46238, 3231743744, 3231743999, 'US', 'USA', 'الولايات المتحدة'),
(46239, 3231744000, 3231744255, 'BR', 'BRA', 'البرازيل'),
(46240, 3231744256, 3231747583, 'US', 'USA', 'الولايات المتحدة'),
(46241, 3231747584, 3231747839, 'DE', 'DEU', 'ألمانيا'),
(46242, 3231747840, 3231748095, 'GB', 'GBR', 'المملكة المتحدة'),
(46243, 3231748096, 3231750143, 'US', 'USA', 'الولايات المتحدة'),
(46244, 3231750144, 3231750399, 'NL', 'NLD', 'هولندا'),
(46245, 3231750400, 3231750911, 'US', 'USA', 'الولايات المتحدة'),
(46246, 3231750912, 3231751167, 'AU', 'AUS', 'أستراليا'),
(46247, 3231751168, 3231751423, 'IT', 'ITA', 'إيطاليا'),
(46248, 3231751424, 3231752191, 'US', 'USA', 'الولايات المتحدة'),
(46249, 3231752192, 3231752447, 'IT', 'ITA', 'إيطاليا'),
(46250, 3231752448, 3231752703, 'JP', 'JPN', 'اليابان'),
(46251, 3231752704, 3231753983, 'US', 'USA', 'الولايات المتحدة'),
(46252, 3231753984, 3231754239, 'CA', 'CAN', 'كندا'),
(46253, 3231754240, 3231754495, 'US', 'USA', 'الولايات المتحدة'),
(46254, 3231754496, 3231755263, 'AU', 'AUS', 'أستراليا'),
(46255, 3231755264, 3231755519, 'HU', 'HUN', 'هنغاريا'),
(46256, 3231755520, 3231755775, 'US', 'USA', 'الولايات المتحدة'),
(46257, 3231755776, 3231756543, 'PR', 'PRI', 'بورتو ريكو'),
(46258, 3231756544, 3231757311, 'GB', 'GBR', 'المملكة المتحدة'),
(46259, 3231757312, 3231759359, 'US', 'USA', 'الولايات المتحدة'),
(46260, 3231759360, 3231759615, 'BR', 'BRA', 'البرازيل'),
(46261, 3231759616, 3231760895, 'US', 'USA', 'الولايات المتحدة'),
(46262, 3231760896, 3231761407, 'GB', 'GBR', 'المملكة المتحدة'),
(46263, 3231761408, 3231763711, 'US', 'USA', 'الولايات المتحدة'),
(46264, 3231763712, 3231763967, 'AU', 'AUS', 'أستراليا'),
(46265, 3231763968, 3231766271, 'US', 'USA', 'الولايات المتحدة'),
(46266, 3231766528, 3231768575, 'US', 'USA', 'الولايات المتحدة'),
(46267, 3231768832, 3231769087, 'NO', 'NOR', 'النرويج'),
(46268, 3231769088, 3231769343, 'NZ', 'NZL', 'نيوزيلاندا'),
(46269, 3231769344, 3231769855, 'US', 'USA', 'الولايات المتحدة'),
(46270, 3231769856, 3231770111, 'AU', 'AUS', 'أستراليا'),
(46271, 3231770112, 3231770367, 'US', 'USA', 'الولايات المتحدة'),
(46272, 3231770368, 3231770879, 'AT', 'AUT', 'النمسا'),
(46273, 3231770880, 3231771135, 'RU', 'RUS', 'الإتحاد الروسي'),
(46274, 3231771136, 3231773951, 'US', 'USA', 'الولايات المتحدة'),
(46275, 3231773952, 3231775231, 'PT', 'PRT', 'البورتوغال'),
(46276, 3231775488, 3231775743, 'PT', 'PRT', 'البورتوغال'),
(46277, 3231775744, 3231775999, 'IL', 'ISR', 'إسرائيل'),
(46278, 3231776000, 3231776511, 'US', 'USA', 'الولايات المتحدة'),
(46279, 3231777024, 3231778047, 'US', 'USA', 'الولايات المتحدة'),
(46280, 3231778816, 3231786495, 'US', 'USA', 'الولايات المتحدة'),
(46281, 3231793152, 3231793663, 'BE', 'BEL', 'بلجيكا'),
(46282, 3231809536, 3231810047, 'NZ', 'NZL', 'نيوزيلاندا'),
(46283, 3231846400, 3231846655, 'RO', 'ROM', 'رومانيا'),
(46284, 3231908096, 3231913215, 'US', 'USA', 'الولايات المتحدة'),
(46285, 3231916032, 3231948799, 'FI', 'FIN', 'فنلندا'),
(46286, 3231973376, 3232038911, 'AT', 'AUT', 'النمسا'),
(46287, 3232038912, 3232092671, 'SE', 'SWE', 'السويد'),
(46288, 3232092672, 3232093183, 'GB', 'GBR', 'المملكة المتحدة'),
(46289, 3232093184, 3232093439, 'US', 'USA', 'الولايات المتحدة'),
(46290, 3232093440, 3232094207, 'GB', 'GBR', 'المملكة المتحدة'),
(46291, 3232094208, 3232094719, 'CH', 'CHE', 'سويسرا'),
(46292, 3232094720, 3232095231, 'US', 'USA', 'الولايات المتحدة'),
(46293, 3232095232, 3232096255, 'GB', 'GBR', 'المملكة المتحدة'),
(46294, 3232096256, 3232104447, 'SE', 'SWE', 'السويد'),
(46295, 3232104448, 3232107519, 'DE', 'DEU', 'ألمانيا'),
(46296, 3232108544, 3232129023, 'DE', 'DEU', 'ألمانيا'),
(46297, 3232131072, 3232133119, 'DE', 'DEU', 'ألمانيا'),
(46298, 3232133632, 3232134143, 'DE', 'DEU', 'ألمانيا'),
(46299, 3232141824, 3232156159, 'DE', 'DEU', 'ألمانيا'),
(46300, 3232156672, 3232159743, 'DE', 'DEU', 'ألمانيا'),
(46301, 3232160768, 3232163839, 'DE', 'DEU', 'ألمانيا'),
(46302, 3232165888, 3232169727, 'DE', 'DEU', 'ألمانيا'),
(46303, 3232169984, 3232235519, 'IT', 'ITA', 'إيطاليا'),
(46304, 3232301056, 3232302335, 'US', 'USA', 'الولايات المتحدة'),
(46305, 3232303104, 3232303615, 'US', 'USA', 'الولايات المتحدة'),
(46306, 3232305152, 3232305919, 'US', 'USA', 'الولايات المتحدة'),
(46307, 3232309248, 3232311807, 'SG', 'SGP', 'سنغافورة'),
(46308, 3232317440, 3232317951, 'US', 'USA', 'الولايات المتحدة'),
(46309, 3232366592, 3232391167, 'US', 'USA', 'الولايات المتحدة'),
(46310, 3232391168, 3232399359, 'CH', 'CHE', 'سويسرا'),
(46311, 3232399360, 3232399615, 'US', 'USA', 'الولايات المتحدة'),
(46312, 3232433920, 3232435455, 'US', 'USA', 'الولايات المتحدة'),
(46313, 3232436224, 3232436735, 'US', 'USA', 'الولايات المتحدة'),
(46314, 3232448512, 3232461311, 'US', 'USA', 'الولايات المتحدة'),
(46315, 3232464896, 3232483327, 'GB', 'GBR', 'المملكة المتحدة'),
(46316, 3232497664, 3232555007, 'US', 'USA', 'الولايات المتحدة'),
(46317, 3232555264, 3232555775, 'US', 'USA', 'الولايات المتحدة'),
(46318, 3232555776, 3232557055, 'JP', 'JPN', 'اليابان'),
(46319, 3232557568, 3232559103, 'JP', 'JPN', 'اليابان'),
(46320, 3232559360, 3232560127, 'JP', 'JPN', 'اليابان'),
(46321, 3232560384, 3232560895, 'JP', 'JPN', 'اليابان'),
(46322, 3232560896, 3232561663, 'US', 'USA', 'الولايات المتحدة'),
(46323, 3232561664, 3232561919, 'CA', 'CAN', 'كندا'),
(46324, 3232561920, 3232562431, 'US', 'USA', 'الولايات المتحدة'),
(46325, 3232562432, 3232562687, 'LU', 'LUX', 'لوكسيمبورغ'),
(46326, 3232562688, 3232562943, 'CA', 'CAN', 'كندا'),
(46327, 3232563456, 3232564479, 'GB', 'GBR', 'المملكة المتحدة'),
(46328, 3232565248, 3232566527, 'US', 'USA', 'الولايات المتحدة'),
(46329, 3232567296, 3232569599, 'NZ', 'NZL', 'نيوزيلاندا'),
(46330, 3232571392, 3232579583, 'US', 'USA', 'الولايات المتحدة'),
(46331, 3232595968, 3232598015, 'GB', 'GBR', 'المملكة المتحدة'),
(46332, 3232629248, 3232629759, 'US', 'USA', 'الولايات المتحدة'),
(46333, 3232630784, 3232632575, 'US', 'USA', 'الولايات المتحدة'),
(46334, 3232632832, 3232634879, 'US', 'USA', 'الولايات المتحدة'),
(46335, 3232636928, 3232645119, 'US', 'USA', 'الولايات المتحدة'),
(46336, 3232645120, 3232646399, 'AT', 'AUT', 'النمسا'),
(46337, 3232661504, 3232694271, 'JP', 'JPN', 'اليابان'),
(46338, 3232694528, 3232695807, 'US', 'USA', 'الولايات المتحدة'),
(46339, 3232696320, 3232697599, 'US', 'USA', 'الولايات المتحدة'),
(46340, 3232698368, 3232699903, 'US', 'USA', 'الولايات المتحدة'),
(46341, 3232702464, 3232706559, 'FI', 'FIN', 'فنلندا'),
(46342, 3232706560, 3232706815, 'US', 'USA', 'الولايات المتحدة'),
(46343, 3232710656, 3232716799, 'US', 'USA', 'الولايات المتحدة'),
(46344, 3232727040, 3232759807, 'US', 'USA', 'الولايات المتحدة'),
(46345, 3232759808, 3232825343, 'SE', 'SWE', 'السويد'),
(46346, 3233285120, 3233285375, 'US', 'USA', 'الولايات المتحدة'),
(46347, 3233481728, 3233484799, 'US', 'USA', 'الولايات المتحدة'),
(46348, 3233484800, 3233487359, 'ES', 'ESP', 'إسبانيا'),
(46349, 3233488896, 3233496575, 'US', 'USA', 'الولايات المتحدة'),
(46350, 3233497088, 3233505279, 'US', 'USA', 'الولايات المتحدة'),
(46351, 3233513472, 3233546239, 'US', 'USA', 'الولايات المتحدة'),
(46352, 3233546496, 3233546751, 'US', 'USA', 'الولايات المتحدة'),
(46353, 3233547008, 3233548287, 'US', 'USA', 'الولايات المتحدة'),
(46354, 3233548800, 3233549055, 'PT', 'PRT', 'البورتوغال'),
(46355, 3233549056, 3233549311, 'BR', 'BRA', 'البرازيل'),
(46356, 3233549312, 3233557247, 'US', 'USA', 'الولايات المتحدة'),
(46357, 3233557248, 3233557503, 'NZ', 'NZL', 'نيوزيلاندا'),
(46358, 3233557504, 3233561855, 'EC', 'ECU', 'الإكوادور'),
(46359, 3233561856, 3233562367, 'US', 'USA', 'الولايات المتحدة'),
(46360, 3233562368, 3233562879, 'GB', 'GBR', 'المملكة المتحدة'),
(46361, 3233562880, 3233563135, 'FR', 'FRA', 'فرنسا'),
(46362, 3233563136, 3233563903, 'US', 'USA', 'الولايات المتحدة'),
(46363, 3233563904, 3233564159, 'GB', 'GBR', 'المملكة المتحدة'),
(46364, 3233564160, 3233564415, 'US', 'USA', 'الولايات المتحدة'),
(46365, 3233564416, 3233564671, 'NZ', 'NZL', 'نيوزيلاندا'),
(46366, 3233564672, 3233564927, 'US', 'USA', 'الولايات المتحدة'),
(46367, 3233564928, 3233566975, 'JP', 'JPN', 'اليابان'),
(46368, 3233568000, 3233568767, 'JP', 'JPN', 'اليابان'),
(46369, 3233569024, 3233569535, 'JP', 'JPN', 'اليابان'),
(46370, 3233569792, 3233570047, 'JP', 'JPN', 'اليابان'),
(46371, 3233570048, 3233570559, 'US', 'USA', 'الولايات المتحدة'),
(46372, 3233570816, 3233571071, 'GB', 'GBR', 'المملكة المتحدة'),
(46373, 3233571072, 3233572095, 'US', 'USA', 'الولايات المتحدة'),
(46374, 3233572096, 3233572351, 'AU', 'AUS', 'أستراليا'),
(46375, 3233572352, 3233573119, 'US', 'USA', 'الولايات المتحدة'),
(46376, 3233573120, 3233573375, 'NO', 'NOR', 'النرويج'),
(46377, 3233573376, 3233573631, 'US', 'USA', 'الولايات المتحدة'),
(46378, 3233573632, 3233573887, 'AU', 'AUS', 'أستراليا'),
(46379, 3233573888, 3233575679, 'US', 'USA', 'الولايات المتحدة'),
(46380, 3233575680, 3233575935, 'AU', 'AUS', 'أستراليا'),
(46381, 3233575936, 3233576191, 'RU', 'RUS', 'الإتحاد الروسي'),
(46382, 3233576192, 3233576447, 'GB', 'GBR', 'المملكة المتحدة'),
(46383, 3233576448, 3233577215, 'US', 'USA', 'الولايات المتحدة'),
(46384, 3233577216, 3233577471, 'AT', 'AUT', 'النمسا'),
(46385, 3233577472, 3233577727, 'GB', 'GBR', 'المملكة المتحدة'),
(46386, 3233577984, 3233578239, 'US', 'USA', 'الولايات المتحدة'),
(46387, 3233578240, 3233578495, 'GB', 'GBR', 'المملكة المتحدة'),
(46388, 3233578496, 3233578751, 'US', 'USA', 'الولايات المتحدة'),
(46389, 3233578752, 3233579007, 'IE', 'IRL', 'إيرلندا'),
(46390, 3233579008, 3233579263, 'AU', 'AUS', 'أستراليا'),
(46391, 3233579264, 3233579519, 'GB', 'GBR', 'المملكة المتحدة'),
(46392, 3233579520, 3233580031, 'US', 'USA', 'الولايات المتحدة'),
(46393, 3233580032, 3233580287, 'GB', 'GBR', 'المملكة المتحدة'),
(46394, 3233580288, 3233581055, 'US', 'USA', 'الولايات المتحدة'),
(46395, 3233581056, 3233581311, 'DE', 'DEU', 'ألمانيا'),
(46396, 3233581312, 3233583359, 'US', 'USA', 'الولايات المتحدة'),
(46397, 3233583360, 3233583615, 'GB', 'GBR', 'المملكة المتحدة'),
(46398, 3233583616, 3233584895, 'US', 'USA', 'الولايات المتحدة'),
(46399, 3233584896, 3233585151, 'AU', 'AUS', 'أستراليا'),
(46400, 3233585152, 3233586431, 'US', 'USA', 'الولايات المتحدة'),
(46401, 3233586432, 3233586943, 'GB', 'GBR', 'المملكة المتحدة'),
(46402, 3233586944, 3233588223, 'US', 'USA', 'الولايات المتحدة'),
(46403, 3233589248, 3233589759, 'CA', 'CAN', 'كندا'),
(46404, 3233589760, 3233590015, 'CN', 'CHN', 'الصين'),
(46405, 3233590016, 3233590271, 'TW', 'TWN', 'تايوان'),
(46406, 3233590272, 3233590527, 'TH', 'THA', 'تايلند'),
(46407, 3233590528, 3233590783, 'PR', 'PRI', 'بورتو ريكو'),
(46408, 3233590784, 3233591039, 'PH', 'PHL', 'الفلبين'),
(46409, 3233591040, 3233591295, 'ID', 'IDN', 'إندونيسيا'),
(46410, 3233591552, 3233593087, 'US', 'USA', 'الولايات المتحدة'),
(46411, 3233593344, 3233593599, 'US', 'USA', 'الولايات المتحدة'),
(46412, 3233593600, 3233593855, 'NZ', 'NZL', 'نيوزيلاندا'),
(46413, 3233593856, 3233594111, 'AU', 'AUS', 'أستراليا'),
(46414, 3233594112, 3233594367, 'RU', 'RUS', 'الإتحاد الروسي'),
(46415, 3233594368, 3233594623, 'US', 'USA', 'الولايات المتحدة'),
(46416, 3233594624, 3233594879, 'RU', 'RUS', 'الإتحاد الروسي'),
(46417, 3233594880, 3233595903, 'US', 'USA', 'الولايات المتحدة'),
(46418, 3233595904, 3233596927, 'EC', 'ECU', 'الإكوادور'),
(46419, 3233596928, 3233603327, 'US', 'USA', 'الولايات المتحدة'),
(46420, 3233603584, 3233605887, 'US', 'USA', 'الولايات المتحدة'),
(46421, 3233605888, 3233607167, 'PL', 'POL', 'بولندا'),
(46422, 3233607168, 3233607935, 'US', 'USA', 'الولايات المتحدة'),
(46423, 3233607936, 3233608191, 'NZ', 'NZL', 'نيوزيلاندا'),
(46424, 3233608192, 3233609727, 'HU', 'HUN', 'هنغاريا'),
(46425, 3233609728, 3233609983, 'BE', 'BEL', 'بلجيكا'),
(46426, 3233609984, 3233610495, 'US', 'USA', 'الولايات المتحدة'),
(46427, 3233610752, 3233611519, 'US', 'USA', 'الولايات المتحدة'),
(46428, 3233612032, 3233612287, 'GB', 'GBR', 'المملكة المتحدة'),
(46429, 3233612544, 3233612799, 'US', 'USA', 'الولايات المتحدة'),
(46430, 3233613056, 3233613311, 'US', 'USA', 'الولايات المتحدة'),
(46431, 3233613568, 3233613823, 'US', 'USA', 'الولايات المتحدة'),
(46432, 3233613824, 3233614847, 'GB', 'GBR', 'المملكة المتحدة'),
(46433, 3233615104, 3233615359, 'US', 'USA', 'الولايات المتحدة'),
(46434, 3233615360, 3233615615, 'DE', 'DEU', 'ألمانيا'),
(46435, 3233615616, 3233617151, 'US', 'USA', 'الولايات المتحدة'),
(46436, 3233617408, 3233617663, 'CA', 'CAN', 'كندا'),
(46437, 3233617664, 3233617919, 'GB', 'GBR', 'المملكة المتحدة'),
(46438, 3233617920, 3233618175, 'JP', 'JPN', 'اليابان'),
(46439, 3233619456, 3233620479, 'US', 'USA', 'الولايات المتحدة'),
(46440, 3233620480, 3233620735, 'NZ', 'NZL', 'نيوزيلاندا'),
(46441, 3233620736, 3233620991, 'US', 'USA', 'الولايات المتحدة'),
(46442, 3233622272, 3233622527, 'GB', 'GBR', 'المملكة المتحدة'),
(46443, 3233622528, 3233624831, 'US', 'USA', 'الولايات المتحدة'),
(46444, 3233624832, 3233625087, 'AT', 'AUT', 'النمسا'),
(46445, 3233625088, 3233625343, 'GB', 'GBR', 'المملكة المتحدة'),
(46446, 3233625344, 3233625599, 'US', 'USA', 'الولايات المتحدة'),
(46447, 3233625600, 3233625855, 'AU', 'AUS', 'أستراليا'),
(46448, 3233625856, 3233626111, 'GB', 'GBR', 'المملكة المتحدة'),
(46449, 3233626112, 3233626879, 'US', 'USA', 'الولايات المتحدة'),
(46450, 3233627136, 3233628671, 'US', 'USA', 'الولايات المتحدة'),
(46451, 3233628672, 3233628927, 'FR', 'FRA', 'فرنسا'),
(46452, 3233628928, 3233629439, 'CA', 'CAN', 'كندا'),
(46453, 3233629440, 3233629695, 'GB', 'GBR', 'المملكة المتحدة'),
(46454, 3233629696, 3233629951, 'IL', 'ISR', 'إسرائيل'),
(46455, 3233629952, 3233630463, 'US', 'USA', 'الولايات المتحدة'),
(46456, 3233630464, 3233630719, 'NL', 'NLD', 'هولندا'),
(46457, 3233630720, 3233630975, 'US', 'USA', 'الولايات المتحدة'),
(46458, 3233631232, 3233631487, 'DE', 'DEU', 'ألمانيا'),
(46459, 3233631488, 3233631743, 'US', 'USA', 'الولايات المتحدة'),
(46460, 3233632000, 3233633535, 'US', 'USA', 'الولايات المتحدة'),
(46461, 3233633792, 3233635839, 'US', 'USA', 'الولايات المتحدة'),
(46462, 3233635840, 3233636095, 'AU', 'AUS', 'أستراليا'),
(46463, 3233636096, 3233642239, 'US', 'USA', 'الولايات المتحدة'),
(46464, 3233642240, 3233642495, 'GB', 'GBR', 'المملكة المتحدة'),
(46465, 3233642496, 3233646591, 'US', 'USA', 'الولايات المتحدة'),
(46466, 3233646592, 3233646847, 'AU', 'AUS', 'أستراليا'),
(46467, 3233646848, 3233647359, 'US', 'USA', 'الولايات المتحدة'),
(46468, 3233647872, 3233649663, 'US', 'USA', 'الولايات المتحدة'),
(46469, 3233649664, 3233649919, 'AU', 'AUS', 'أستراليا'),
(46470, 3233649920, 3233650431, 'US', 'USA', 'الولايات المتحدة'),
(46471, 3233650432, 3233650687, 'DE', 'DEU', 'ألمانيا'),
(46472, 3233651200, 3233651455, 'IT', 'ITA', 'إيطاليا'),
(46473, 3233651456, 3233651967, 'US', 'USA', 'الولايات المتحدة'),
(46474, 3233651968, 3233652223, 'GB', 'GBR', 'المملكة المتحدة'),
(46475, 3233652224, 3233652479, 'US', 'USA', 'الولايات المتحدة'),
(46476, 3233652480, 3233652735, 'AU', 'AUS', 'أستراليا'),
(46477, 3233652736, 3233652991, 'GB', 'GBR', 'المملكة المتحدة'),
(46478, 3233652992, 3233654271, 'US', 'USA', 'الولايات المتحدة'),
(46479, 3233654272, 3233655551, 'GB', 'GBR', 'المملكة المتحدة'),
(46480, 3233655552, 3233662975, 'US', 'USA', 'الولايات المتحدة'),
(46481, 3233663488, 3233663999, 'GB', 'GBR', 'المملكة المتحدة'),
(46482, 3233664256, 3233665023, 'US', 'USA', 'الولايات المتحدة'),
(46483, 3233665024, 3233666047, 'AU', 'AUS', 'أستراليا'),
(46484, 3233666048, 3233668863, 'US', 'USA', 'الولايات المتحدة'),
(46485, 3233668864, 3233669119, 'PH', 'PHL', 'الفلبين'),
(46486, 3233669120, 3233670399, 'US', 'USA', 'الولايات المتحدة'),
(46487, 3233670400, 3233671679, 'AU', 'AUS', 'أستراليا'),
(46488, 3233671680, 3233675263, 'US', 'USA', 'الولايات المتحدة'),
(46489, 3233675520, 3233676031, 'US', 'USA', 'الولايات المتحدة'),
(46490, 3233676032, 3233676287, 'DE', 'DEU', 'ألمانيا'),
(46491, 3233676288, 3233677055, 'US', 'USA', 'الولايات المتحدة'),
(46492, 3233677568, 3233679103, 'US', 'USA', 'الولايات المتحدة'),
(46493, 3233679360, 3233681151, 'US', 'USA', 'الولايات المتحدة'),
(46494, 3233681408, 3233682431, 'US', 'USA', 'الولايات المتحدة'),
(46495, 3233682944, 3233684991, 'US', 'USA', 'الولايات المتحدة'),
(46496, 3233684992, 3233685503, 'BR', 'BRA', 'البرازيل'),
(46497, 3233685760, 3233688063, 'US', 'USA', 'الولايات المتحدة'),
(46498, 3233688576, 3233688831, 'GB', 'GBR', 'المملكة المتحدة'),
(46499, 3233688832, 3233692159, 'US', 'USA', 'الولايات المتحدة'),
(46500, 3233692160, 3233692671, 'NO', 'NOR', 'النرويج'),
(46501, 3233692672, 3233692927, 'US', 'USA', 'الولايات المتحدة'),
(46502, 3233692928, 3233693183, 'AU', 'AUS', 'أستراليا'),
(46503, 3233693184, 3233693695, 'US', 'USA', 'الولايات المتحدة'),
(46504, 3233693696, 3233693951, 'GB', 'GBR', 'المملكة المتحدة'),
(46505, 3233693952, 3233694207, 'US', 'USA', 'الولايات المتحدة'),
(46506, 3233694208, 3233694463, 'AU', 'AUS', 'أستراليا'),
(46507, 3233694464, 3233694719, 'GB', 'GBR', 'المملكة المتحدة'),
(46508, 3233694720, 3233694975, 'US', 'USA', 'الولايات المتحدة'),
(46509, 3233694976, 3233695231, 'FR', 'FRA', 'فرنسا'),
(46510, 3233695232, 3233696511, 'US', 'USA', 'الولايات المتحدة'),
(46511, 3233696512, 3233696767, 'CA', 'CAN', 'كندا'),
(46512, 3233696768, 3233697791, 'US', 'USA', 'الولايات المتحدة'),
(46513, 3233701632, 3233701887, 'NO', 'NOR', 'النرويج'),
(46514, 3233701888, 3233704959, 'US', 'USA', 'الولايات المتحدة'),
(46515, 3233704960, 3233705215, 'NZ', 'NZL', 'نيوزيلاندا'),
(46516, 3233705216, 3233705983, 'US', 'USA', 'الولايات المتحدة'),
(46517, 3233707008, 3233710335, 'US', 'USA', 'الولايات المتحدة'),
(46518, 3233710336, 3233711359, 'FR', 'FRA', 'فرنسا'),
(46519, 3233711360, 3233721599, 'US', 'USA', 'الولايات المتحدة'),
(46520, 3233721600, 3233721855, 'HU', 'HUN', 'هنغاريا'),
(46521, 3233721856, 3233722111, 'PT', 'PRT', 'البورتوغال'),
(46522, 3233722112, 3233723391, 'US', 'USA', 'الولايات المتحدة'),
(46523, 3233723392, 3233723903, 'AU', 'AUS', 'أستراليا'),
(46524, 3233723904, 3233724415, 'GB', 'GBR', 'المملكة المتحدة'),
(46525, 3233724416, 3233725439, 'US', 'USA', 'الولايات المتحدة'),
(46526, 3233725952, 3233726975, 'NO', 'NOR', 'النرويج'),
(46527, 3233726976, 3233728767, 'US', 'USA', 'الولايات المتحدة'),
(46528, 3233728768, 3233729279, 'GB', 'GBR', 'المملكة المتحدة'),
(46529, 3233729280, 3233729535, 'US', 'USA', 'الولايات المتحدة'),
(46530, 3233729536, 3233730047, 'SG', 'SGP', 'سنغافورة'),
(46531, 3233730560, 3233732607, 'AU', 'AUS', 'أستراليا'),
(46532, 3233732608, 3233733631, 'US', 'USA', 'الولايات المتحدة'),
(46533, 3233734656, 3233734911, 'US', 'USA', 'الولايات المتحدة'),
(46534, 3233735680, 3233736959, 'US', 'USA', 'الولايات المتحدة'),
(46535, 3233736960, 3233737983, 'FR', 'FRA', 'فرنسا'),
(46536, 3233737984, 3233738751, 'US', 'USA', 'الولايات المتحدة'),
(46537, 3233738752, 3233739007, 'GB', 'GBR', 'المملكة المتحدة'),
(46538, 3233739008, 3233739263, 'US', 'USA', 'الولايات المتحدة'),
(46539, 3233739264, 3233739519, 'FR', 'FRA', 'فرنسا'),
(46540, 3233739520, 3233740543, 'US', 'USA', 'الولايات المتحدة'),
(46541, 3233740544, 3233741311, 'GB', 'GBR', 'المملكة المتحدة'),
(46542, 3233741312, 3233742591, 'US', 'USA', 'الولايات المتحدة'),
(46543, 3233742848, 3233808383, 'US', 'USA', 'الولايات المتحدة'),
(46544, 3233808384, 3233873919, 'TW', 'TWN', 'تايوان'),
(46545, 3233873920, 3233939455, 'US', 'USA', 'الولايات المتحدة'),
(46546, 3233939456, 3233980671, 'FI', 'FIN', 'فنلندا'),
(46547, 3233980672, 3233980927, 'GB', 'GBR', 'المملكة المتحدة'),
(46548, 3233980928, 3233991167, 'FI', 'FIN', 'فنلندا'),
(46549, 3233991168, 3233991423, 'DE', 'DEU', 'ألمانيا'),
(46550, 3233991424, 3234004991, 'FI', 'FIN', 'فنلندا'),
(46551, 3234005248, 3234005503, 'GB', 'GBR', 'المملكة المتحدة'),
(46552, 3234005504, 3234005759, 'AU', 'AUS', 'أستراليا'),
(46553, 3234006528, 3234007039, 'US', 'USA', 'الولايات المتحدة'),
(46554, 3234007040, 3234007295, 'RU', 'RUS', 'الإتحاد الروسي'),
(46555, 3234007296, 3234007551, 'US', 'USA', 'الولايات المتحدة'),
(46556, 3234007552, 3234007807, 'AU', 'AUS', 'أستراليا'),
(46557, 3234007808, 3234008063, 'US', 'USA', 'الولايات المتحدة'),
(46558, 3234008064, 3234008831, 'NZ', 'NZL', 'نيوزيلاندا'),
(46559, 3234008832, 3234011135, 'US', 'USA', 'الولايات المتحدة'),
(46560, 3234012160, 3234013183, 'US', 'USA', 'الولايات المتحدة'),
(46561, 3234013440, 3234013695, 'US', 'USA', 'الولايات المتحدة'),
(46562, 3234013696, 3234013951, 'AU', 'AUS', 'أستراليا'),
(46563, 3234013952, 3234014207, 'US', 'USA', 'الولايات المتحدة'),
(46564, 3234014464, 3234014975, 'US', 'USA', 'الولايات المتحدة'),
(46565, 3234014976, 3234015487, 'KR', 'KOR', 'جمهورية كوريا'),
(46566, 3234015488, 3234015743, 'US', 'USA', 'الولايات المتحدة'),
(46567, 3234015744, 3234015999, 'IE', 'IRL', 'إيرلندا'),
(46568, 3234016000, 3234016255, 'GB', 'GBR', 'المملكة المتحدة'),
(46569, 3234016256, 3234019327, 'AU', 'AUS', 'أستراليا'),
(46570, 3234019328, 3234019839, 'MX', 'MEX', 'المكسيك'),
(46571, 3234019840, 3234023423, 'US', 'USA', 'الولايات المتحدة'),
(46572, 3234023424, 3234023679, 'PL', 'POL', 'بولندا'),
(46573, 3234023680, 3234024703, 'US', 'USA', 'الولايات المتحدة'),
(46574, 3234026752, 3234030079, 'US', 'USA', 'الولايات المتحدة'),
(46575, 3234030080, 3234030335, 'DE', 'DEU', 'ألمانيا'),
(46576, 3234030336, 3234031103, 'US', 'USA', 'الولايات المتحدة'),
(46577, 3234031104, 3234031359, 'AU', 'AUS', 'أستراليا'),
(46578, 3234031360, 3234031871, 'US', 'USA', 'الولايات المتحدة'),
(46579, 3234031872, 3234032127, 'GB', 'GBR', 'المملكة المتحدة'),
(46580, 3234032128, 3234032383, 'PL', 'POL', 'بولندا'),
(46581, 3234032384, 3234032895, 'US', 'USA', 'الولايات المتحدة'),
(46582, 3234033152, 3234033407, 'IT', 'ITA', 'إيطاليا'),
(46583, 3234033408, 3234033663, 'US', 'USA', 'الولايات المتحدة'),
(46584, 3234033664, 3234033919, 'AU', 'AUS', 'أستراليا'),
(46585, 3234033920, 3234034687, 'US', 'USA', 'الولايات المتحدة'),
(46586, 3234034688, 3234035455, 'GB', 'GBR', 'المملكة المتحدة'),
(46587, 3234035456, 3234039295, 'US', 'USA', 'الولايات المتحدة'),
(46588, 3234039296, 3234043135, 'SE', 'SWE', 'السويد'),
(46589, 3234043136, 3234043903, 'US', 'USA', 'الولايات المتحدة'),
(46590, 3234043904, 3234044159, 'AU', 'AUS', 'أستراليا'),
(46591, 3234044160, 3234048511, 'US', 'USA', 'الولايات المتحدة'),
(46592, 3234048512, 3234048767, 'AU', 'AUS', 'أستراليا'),
(46593, 3234048768, 3234049279, 'US', 'USA', 'الولايات المتحدة'),
(46594, 3234049792, 3234051839, 'US', 'USA', 'الولايات المتحدة'),
(46595, 3234051840, 3234052095, 'NL', 'NLD', 'هولندا'),
(46596, 3234052096, 3234052351, 'DE', 'DEU', 'ألمانيا'),
(46597, 3234052352, 3234052607, 'US', 'USA', 'الولايات المتحدة'),
(46598, 3234052608, 3234052863, 'NZ', 'NZL', 'نيوزيلاندا'),
(46599, 3234052864, 3234054911, 'US', 'USA', 'الولايات المتحدة'),
(46600, 3234054912, 3234055167, 'PT', 'PRT', 'البورتوغال'),
(46601, 3234055168, 3234055423, 'US', 'USA', 'الولايات المتحدة'),
(46602, 3234055424, 3234055679, 'AU', 'AUS', 'أستراليا'),
(46603, 3234055680, 3234056959, 'US', 'USA', 'الولايات المتحدة'),
(46604, 3234057216, 3234061055, 'US', 'USA', 'الولايات المتحدة'),
(46605, 3234061056, 3234061311, 'NZ', 'NZL', 'نيوزيلاندا'),
(46606, 3234061312, 3234064639, 'US', 'USA', 'الولايات المتحدة'),
(46607, 3234064640, 3234064895, 'AU', 'AUS', 'أستراليا'),
(46608, 3234064896, 3234065407, 'US', 'USA', 'الولايات المتحدة'),
(46609, 3234065408, 3234065663, 'GB', 'GBR', 'المملكة المتحدة'),
(46610, 3234065664, 3234065919, 'BR', 'BRA', 'البرازيل'),
(46611, 3234065920, 3234066943, 'US', 'USA', 'الولايات المتحدة'),
(46612, 3234067200, 3234069247, 'US', 'USA', 'الولايات المتحدة'),
(46613, 3234069504, 3234069759, 'US', 'USA', 'الولايات المتحدة'),
(46614, 3234070016, 3234070271, 'US', 'USA', 'الولايات المتحدة'),
(46615, 3234070784, 3234110463, 'FR', 'FRA', 'فرنسا'),
(46616, 3234136064, 3234150911, 'CA', 'CAN', 'كندا'),
(46617, 3234151424, 3234158847, 'CA', 'CAN', 'كندا'),
(46618, 3234159104, 3234159359, 'CA', 'CAN', 'كندا'),
(46619, 3234160128, 3234163455, 'CA', 'CAN', 'كندا'),
(46620, 3234163456, 3234163711, 'US', 'USA', 'الولايات المتحدة'),
(46621, 3234163712, 3234167295, 'CA', 'CAN', 'كندا'),
(46622, 3234167808, 3234172927, 'CA', 'CAN', 'كندا'),
(46623, 3234172928, 3234173951, 'US', 'USA', 'الولايات المتحدة'),
(46624, 3234173952, 3234175999, 'CA', 'CAN', 'كندا'),
(46625, 3234176256, 3234177279, 'US', 'USA', 'الولايات المتحدة'),
(46626, 3234177280, 3234187007, 'CA', 'CAN', 'كندا'),
(46627, 3234187008, 3234187519, 'US', 'USA', 'الولايات المتحدة'),
(46628, 3234187520, 3234189055, 'CA', 'CAN', 'كندا'),
(46629, 3234189312, 3234192383, 'CA', 'CAN', 'كندا'),
(46630, 3234192384, 3234193663, 'US', 'USA', 'الولايات المتحدة'),
(46631, 3234193664, 3234198783, 'CA', 'CAN', 'كندا'),
(46632, 3234199040, 3234201343, 'CA', 'CAN', 'كندا'),
(46633, 3234202624, 3234203647, 'US', 'USA', 'الولايات المتحدة'),
(46634, 3234203648, 3234205695, 'BR', 'BRA', 'البرازيل'),
(46635, 3234205696, 3234208255, 'US', 'USA', 'الولايات المتحدة'),
(46636, 3234209792, 3234215935, 'US', 'USA', 'الولايات المتحدة'),
(46637, 3234217984, 3234221823, 'US', 'USA', 'الولايات المتحدة'),
(46638, 3234234368, 3234247167, 'US', 'USA', 'الولايات المتحدة'),
(46639, 3234267392, 3234269695, 'US', 'USA', 'الولايات المتحدة'),
(46640, 3234271232, 3234275327, 'PT', 'PRT', 'البورتوغال'),
(46641, 3234275328, 3234279423, 'AU', 'AUS', 'أستراليا'),
(46642, 3234283520, 3234312703, 'US', 'USA', 'الولايات المتحدة'),
(46643, 3234332928, 3234334975, 'US', 'USA', 'الولايات المتحدة'),
(46644, 3234340864, 3234349055, 'US', 'USA', 'الولايات المتحدة'),
(46645, 3234349056, 3234353151, 'NZ', 'NZL', 'نيوزيلاندا'),
(46646, 3234365440, 3234367487, 'US', 'USA', 'الولايات المتحدة'),
(46647, 3234398208, 3234529279, 'US', 'USA', 'الولايات المتحدة'),
(46648, 3234529536, 3234538751, 'US', 'USA', 'الولايات المتحدة'),
(46649, 3234539008, 3234539519, 'AU', 'AUS', 'أستراليا'),
(46650, 3234539520, 3234549759, 'US', 'USA', 'الولايات المتحدة'),
(46651, 3234549760, 3234550015, 'RU', 'RUS', 'الإتحاد الروسي'),
(46652, 3234550016, 3234553855, 'NZ', 'NZL', 'نيوزيلاندا'),
(46653, 3234553856, 3234554367, 'US', 'USA', 'الولايات المتحدة'),
(46654, 3234554624, 3234554879, 'NZ', 'NZL', 'نيوزيلاندا'),
(46655, 3234555904, 3234556415, 'US', 'USA', 'الولايات المتحدة'),
(46656, 3234556416, 3234556927, 'CA', 'CAN', 'كندا'),
(46657, 3234556928, 3234557439, 'FI', 'FIN', 'فنلندا'),
(46658, 3234557440, 3234564607, 'US', 'USA', 'الولايات المتحدة'),
(46659, 3234564608, 3234566911, 'KR', 'KOR', 'جمهورية كوريا'),
(46660, 3234566912, 3234568703, 'US', 'USA', 'الولايات المتحدة'),
(46661, 3234568704, 3234568959, 'NZ', 'NZL', 'نيوزيلاندا'),
(46662, 3234568960, 3234569215, 'US', 'USA', 'الولايات المتحدة'),
(46663, 3234569216, 3234569727, 'AU', 'AUS', 'أستراليا'),
(46664, 3234569728, 3234569983, 'CL', 'CHL', 'تشيلي'),
(46665, 3234569984, 3234574335, 'US', 'USA', 'الولايات المتحدة'),
(46666, 3234574336, 3234574591, 'AU', 'AUS', 'أستراليا'),
(46667, 3234574592, 3234574847, 'MX', 'MEX', 'المكسيك'),
(46668, 3234574848, 3234576127, 'US', 'USA', 'الولايات المتحدة'),
(46669, 3234576128, 3234576895, 'HK', 'HKG', 'هونغ كونغ'),
(46670, 3234576896, 3234578687, 'US', 'USA', 'الولايات المتحدة'),
(46671, 3234578688, 3234578943, 'AU', 'AUS', 'أستراليا'),
(46672, 3234578944, 3234579711, 'US', 'USA', 'الولايات المتحدة'),
(46673, 3234579712, 3234579967, 'CA', 'CAN', 'كندا'),
(46674, 3234579968, 3234581247, 'US', 'USA', 'الولايات المتحدة'),
(46675, 3234581248, 3234581503, 'CA', 'CAN', 'كندا'),
(46676, 3234581504, 3234582527, 'US', 'USA', 'الولايات المتحدة'),
(46677, 3234582528, 3234583039, 'NZ', 'NZL', 'نيوزيلاندا'),
(46678, 3234583040, 3234583807, 'US', 'USA', 'الولايات المتحدة'),
(46679, 3234583808, 3234584063, 'AU', 'AUS', 'أستراليا'),
(46680, 3234584064, 3234584575, 'US', 'USA', 'الولايات المتحدة'),
(46681, 3234584576, 3234584831, 'NZ', 'NZL', 'نيوزيلاندا'),
(46682, 3234584832, 3234585343, 'US', 'USA', 'الولايات المتحدة'),
(46683, 3234585600, 3234587391, 'US', 'USA', 'الولايات المتحدة'),
(46684, 3234587392, 3234587647, 'SA', 'SAU', 'السعودية'),
(46685, 3234587648, 3234588415, 'US', 'USA', 'الولايات المتحدة'),
(46686, 3234588672, 3234588927, 'MO', 'MAC', 'ماكاو'),
(46687, 3234588928, 3234589439, 'US', 'USA', 'الولايات المتحدة'),
(46688, 3234589440, 3234589695, 'AU', 'AUS', 'أستراليا'),
(46689, 3234589696, 3234589951, 'US', 'USA', 'الولايات المتحدة'),
(46690, 3234590208, 3234590463, 'US', 'USA', 'الولايات المتحدة'),
(46691, 3234590720, 3234592511, 'US', 'USA', 'الولايات المتحدة'),
(46692, 3234592512, 3234592767, 'TH', 'THA', 'تايلند'),
(46693, 3234592768, 3234594047, 'US', 'USA', 'الولايات المتحدة'),
(46694, 3234594816, 3234725887, 'US', 'USA', 'الولايات المتحدة'),
(46695, 3234726144, 3234726399, 'CA', 'CAN', 'كندا'),
(46696, 3234726400, 3234726911, 'US', 'USA', 'الولايات المتحدة'),
(46697, 3234728192, 3234730495, 'US', 'USA', 'الولايات المتحدة'),
(46698, 3234730752, 3234733055, 'US', 'USA', 'الولايات المتحدة'),
(46699, 3234733056, 3234733311, 'CA', 'CAN', 'كندا'),
(46700, 3234733312, 3234734079, 'US', 'USA', 'الولايات المتحدة'),
(46701, 3234735616, 3234737407, 'US', 'USA', 'الولايات المتحدة'),
(46702, 3234738176, 3234739455, 'US', 'USA', 'الولايات المتحدة'),
(46703, 3234740224, 3234742015, 'US', 'USA', 'الولايات المتحدة'),
(46704, 3234742272, 3234743551, 'US', 'USA', 'الولايات المتحدة'),
(46705, 3234744832, 3234745599, 'US', 'USA', 'الولايات المتحدة'),
(46706, 3234745600, 3234746879, 'GB', 'GBR', 'المملكة المتحدة'),
(46707, 3234746880, 3234747903, 'US', 'USA', 'الولايات المتحدة'),
(46708, 3234747904, 3234748159, 'IL', 'ISR', 'إسرائيل'),
(46709, 3234748160, 3234749439, 'US', 'USA', 'الولايات المتحدة'),
(46710, 3234749696, 3234750207, 'CA', 'CAN', 'كندا'),
(46711, 3234750720, 3234751999, 'US', 'USA', 'الولايات المتحدة'),
(46712, 3234752000, 3234752255, 'HK', 'HKG', 'هونغ كونغ'),
(46713, 3234752256, 3234753535, 'US', 'USA', 'الولايات المتحدة'),
(46714, 3234753536, 3234753791, 'AU', 'AUS', 'أستراليا'),
(46715, 3234753792, 3234754047, 'US', 'USA', 'الولايات المتحدة'),
(46716, 3234754560, 3234755839, 'US', 'USA', 'الولايات المتحدة'),
(46717, 3234755840, 3234756095, 'AU', 'AUS', 'أستراليا'),
(46718, 3234756096, 3234760703, 'US', 'USA', 'الولايات المتحدة'),
(46719, 3234760960, 3234761727, 'US', 'USA', 'الولايات المتحدة'),
(46720, 3234763264, 3234764799, 'CA', 'CAN', 'كندا'),
(46721, 3234764800, 3234766335, 'NZ', 'NZL', 'نيوزيلاندا'),
(46722, 3234766336, 3234772223, 'US', 'USA', 'الولايات المتحدة'),
(46723, 3234772224, 3234772479, 'CA', 'CAN', 'كندا'),
(46724, 3234772480, 3234772735, 'US', 'USA', 'الولايات المتحدة'),
(46725, 3234772992, 3234777599, 'US', 'USA', 'الولايات المتحدة'),
(46726, 3234778368, 3234781439, 'US', 'USA', 'الولايات المتحدة'),
(46727, 3234781440, 3234781951, 'CA', 'CAN', 'كندا'),
(46728, 3234781952, 3234782719, 'US', 'USA', 'الولايات المتحدة'),
(46729, 3234782720, 3234783999, 'IL', 'ISR', 'إسرائيل'),
(46730, 3234784000, 3234786815, 'US', 'USA', 'الولايات المتحدة'),
(46731, 3234787328, 3234791167, 'US', 'USA', 'الولايات المتحدة'),
(46732, 3234791680, 3234794495, 'US', 'USA', 'الولايات المتحدة'),
(46733, 3234794752, 3234795007, 'US', 'USA', 'الولايات المتحدة'),
(46734, 3234795008, 3234795263, 'GB', 'GBR', 'المملكة المتحدة'),
(46735, 3234795264, 3234795519, 'US', 'USA', 'الولايات المتحدة'),
(46736, 3234795776, 3234796031, 'US', 'USA', 'الولايات المتحدة'),
(46737, 3234796544, 3234799359, 'US', 'USA', 'الولايات المتحدة'),
(46738, 3234799360, 3234799615, 'NL', 'NLD', 'هولندا'),
(46739, 3234799616, 3234799871, 'US', 'USA', 'الولايات المتحدة'),
(46740, 3234799872, 3234800127, 'AU', 'AUS', 'أستراليا'),
(46741, 3234800640, 3234800895, 'AU', 'AUS', 'أستراليا'),
(46742, 3234800896, 3234801663, 'US', 'USA', 'الولايات المتحدة'),
(46743, 3234801664, 3234802431, 'EC', 'ECU', 'الإكوادور'),
(46744, 3234802432, 3234803711, 'US', 'USA', 'الولايات المتحدة'),
(46745, 3234803712, 3234803967, 'PR', 'PRI', 'بورتو ريكو'),
(46746, 3234804224, 3234805503, 'US', 'USA', 'الولايات المتحدة'),
(46747, 3234805760, 3234806527, 'US', 'USA', 'الولايات المتحدة'),
(46748, 3234807552, 3234807807, 'US', 'USA', 'الولايات المتحدة'),
(46749, 3234807808, 3234808063, 'TH', 'THA', 'تايلند'),
(46750, 3234808064, 3234809087, 'EC', 'ECU', 'الإكوادور'),
(46751, 3234809088, 3234810879, 'US', 'USA', 'الولايات المتحدة'),
(46752, 3234810880, 3234811135, 'CA', 'CAN', 'كندا'),
(46753, 3234811136, 3234814719, 'US', 'USA', 'الولايات المتحدة'),
(46754, 3234814720, 3234814975, 'HK', 'HKG', 'هونغ كونغ'),
(46755, 3234814976, 3234815999, 'US', 'USA', 'الولايات المتحدة'),
(46756, 3234816000, 3234816767, 'AU', 'AUS', 'أستراليا'),
(46757, 3234816768, 3234820351, 'US', 'USA', 'الولايات المتحدة'),
(46758, 3234820352, 3234820607, 'AU', 'AUS', 'أستراليا'),
(46759, 3234820608, 3234820863, 'US', 'USA', 'الولايات المتحدة'),
(46760, 3234821120, 3234821887, 'US', 'USA', 'الولايات المتحدة'),
(46761, 3234821888, 3234822655, 'AU', 'AUS', 'أستراليا'),
(46762, 3234822656, 3234826751, 'US', 'USA', 'الولايات المتحدة'),
(46763, 3234826752, 3234827007, 'CA', 'CAN', 'كندا'),
(46764, 3234827008, 3234827519, 'US', 'USA', 'الولايات المتحدة'),
(46765, 3234827520, 3234827775, 'GB', 'GBR', 'المملكة المتحدة'),
(46766, 3234827776, 3234828031, 'LU', 'LUX', 'لوكسيمبورغ'),
(46767, 3234828032, 3234828287, 'NZ', 'NZL', 'نيوزيلاندا'),
(46768, 3234828288, 3234828799, 'US', 'USA', 'الولايات المتحدة'),
(46769, 3234828800, 3234829055, 'CL', 'CHL', 'تشيلي'),
(46770, 3234829056, 3234830079, 'US', 'USA', 'الولايات المتحدة'),
(46771, 3234830080, 3234832127, 'AU', 'AUS', 'أستراليا'),
(46772, 3234832128, 3234832639, 'US', 'USA', 'الولايات المتحدة'),
(46773, 3234832640, 3234832895, 'AU', 'AUS', 'أستراليا'),
(46774, 3234832896, 3234833663, 'US', 'USA', 'الولايات المتحدة'),
(46775, 3234833664, 3234833919, 'AU', 'AUS', 'أستراليا'),
(46776, 3234833920, 3234838271, 'US', 'USA', 'الولايات المتحدة'),
(46777, 3234838272, 3234838527, 'GT', 'GTM', 'غواتيمالا'),
(46778, 3234838528, 3234839295, 'US', 'USA', 'الولايات المتحدة'),
(46779, 3234839296, 3234839551, 'AU', 'AUS', 'أستراليا'),
(46780, 3234839552, 3234841087, 'US', 'USA', 'الولايات المتحدة'),
(46781, 3234841088, 3234841599, 'BR', 'BRA', 'البرازيل'),
(46782, 3234841600, 3234841855, 'PT', 'PRT', 'البورتوغال'),
(46783, 3234841856, 3234842367, 'AU', 'AUS', 'أستراليا'),
(46784, 3234842368, 3234842623, 'US', 'USA', 'الولايات المتحدة'),
(46785, 3234842624, 3234844415, 'BR', 'BRA', 'البرازيل'),
(46786, 3234844416, 3234853375, 'US', 'USA', 'الولايات المتحدة'),
(46787, 3234853376, 3234853631, 'TH', 'THA', 'تايلند'),
(46788, 3234853632, 3234853887, 'US', 'USA', 'الولايات المتحدة'),
(46789, 3234853888, 3234854143, 'EC', 'ECU', 'الإكوادور'),
(46790, 3234854144, 3234854911, 'US', 'USA', 'الولايات المتحدة'),
(46791, 3234854912, 3234855167, 'AU', 'AUS', 'أستراليا'),
(46792, 3234855168, 3234855935, 'US', 'USA', 'الولايات المتحدة'),
(46793, 3234856192, 3234856447, 'US', 'USA', 'الولايات المتحدة'),
(46794, 3234856448, 3234856703, 'TH', 'THA', 'تايلند'),
(46795, 3234857216, 3234861055, 'CA', 'CAN', 'كندا'),
(46796, 3234861056, 3234864383, 'US', 'USA', 'الولايات المتحدة'),
(46797, 3234865152, 3234870271, 'US', 'USA', 'الولايات المتحدة'),
(46798, 3234873344, 3234886143, 'US', 'USA', 'الولايات المتحدة'),
(46799, 3234889728, 3234897407, 'US', 'USA', 'الولايات المتحدة'),
(46800, 3234922752, 3234926847, 'US', 'USA', 'الولايات المتحدة'),
(46801, 3234930688, 3234938367, 'US', 'USA', 'الولايات المتحدة'),
(46802, 3234938880, 3234988031, 'US', 'USA', 'الولايات المتحدة'),
(46803, 3234988288, 3234990847, 'CA', 'CAN', 'كندا'),
(46804, 3234996224, 3234998783, 'US', 'USA', 'الولايات المتحدة'),
(46805, 3235004416, 3235020799, 'CA', 'CAN', 'كندا'),
(46806, 3235053824, 3235056383, 'US', 'USA', 'الولايات المتحدة'),
(46807, 3235057664, 3235065343, 'US', 'USA', 'الولايات المتحدة'),
(46808, 3235069952, 3235085311, 'US', 'USA', 'الولايات المتحدة'),
(46809, 3235119104, 3235275007, 'US', 'USA', 'الولايات المتحدة'),
(46810, 3235315712, 3235512319, 'US', 'USA', 'الولايات المتحدة'),
(46811, 3235512320, 3235577855, 'JP', 'JPN', 'اليابان'),
(46812, 3235578112, 3235641855, 'CA', 'CAN', 'كندا'),
(46813, 3235642112, 3235643135, 'CA', 'CAN', 'كندا'),
(46814, 3235643392, 3235774463, 'US', 'USA', 'الولايات المتحدة'),
(46815, 3235774720, 3235776767, 'CA', 'CAN', 'كندا'),
(46816, 3235778560, 3235800319, 'US', 'USA', 'الولايات المتحدة'),
(46817, 3235840256, 3235842303, 'US', 'USA', 'الولايات المتحدة'),
(46818, 3235844096, 3235846143, 'US', 'USA', 'الولايات المتحدة'),
(46819, 3235848192, 3235856383, 'US', 'USA', 'الولايات المتحدة'),
(46820, 3235856384, 3235872767, 'BR', 'BRA', 'البرازيل'),
(46821, 3235872768, 3235971071, 'US', 'USA', 'الولايات المتحدة'),
(46822, 3235971328, 3235977727, 'US', 'USA', 'الولايات المتحدة'),
(46823, 3235979264, 3235985663, 'US', 'USA', 'الولايات المتحدة'),
(46824, 3235987456, 3235995647, 'US', 'USA', 'الولايات المتحدة'),
(46825, 3236003840, 3236010239, 'US', 'USA', 'الولايات المتحدة'),
(46826, 3236038656, 3236044799, 'US', 'USA', 'الولايات المتحدة'),
(46827, 3236044800, 3236052991, 'CA', 'CAN', 'كندا'),
(46828, 3236052992, 3236069375, 'US', 'USA', 'الولايات المتحدة'),
(46829, 3236102400, 3236106239, 'PH', 'PHL', 'الفلبين'),
(46830, 3236106240, 3236134911, 'US', 'USA', 'الولايات المتحدة'),
(46831, 3236167936, 3236175871, 'CA', 'CAN', 'كندا'),
(46832, 3236175872, 3236191487, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(46833, 3236200448, 3236233215, 'MY', 'MYS', 'ماليزيا'),
(46834, 3236233472, 3236238591, 'US', 'USA', 'الولايات المتحدة'),
(46835, 3236241408, 3236249599, 'US', 'USA', 'الولايات المتحدة'),
(46836, 3236298752, 3236302847, 'US', 'USA', 'الولايات المتحدة'),
(46837, 3236302848, 3236306943, 'NZ', 'NZL', 'نيوزيلاندا'),
(46838, 3236364544, 3236365567, 'US', 'USA', 'الولايات المتحدة'),
(46839, 3236365824, 3236368127, 'US', 'USA', 'الولايات المتحدة'),
(46840, 3236368128, 3236368383, 'NZ', 'NZL', 'نيوزيلاندا'),
(46841, 3236368384, 3236372991, 'US', 'USA', 'الولايات المتحدة'),
(46842, 3236372992, 3236373247, 'AU', 'AUS', 'أستراليا'),
(46843, 3236373760, 3236379391, 'US', 'USA', 'الولايات المتحدة'),
(46844, 3236379392, 3236379647, 'AU', 'AUS', 'أستراليا'),
(46845, 3236379648, 3236380927, 'US', 'USA', 'الولايات المتحدة'),
(46846, 3236381184, 3236381439, 'CA', 'CAN', 'كندا'),
(46847, 3236381440, 3236381695, 'AT', 'AUT', 'النمسا'),
(46848, 3236381696, 3236383999, 'US', 'USA', 'الولايات المتحدة'),
(46849, 3236384000, 3236384255, 'AU', 'AUS', 'أستراليا'),
(46850, 3236384256, 3236385279, 'US', 'USA', 'الولايات المتحدة'),
(46851, 3236385280, 3236385535, 'DE', 'DEU', 'ألمانيا'),
(46852, 3236385536, 3236385791, 'US', 'USA', 'الولايات المتحدة'),
(46853, 3236386304, 3236387071, 'US', 'USA', 'الولايات المتحدة'),
(46854, 3236387072, 3236387327, 'CA', 'CAN', 'كندا'),
(46855, 3236387328, 3236387839, 'US', 'USA', 'الولايات المتحدة'),
(46856, 3236387840, 3236389375, 'PR', 'PRI', 'بورتو ريكو'),
(46857, 3236389376, 3236392447, 'US', 'USA', 'الولايات المتحدة'),
(46858, 3236392448, 3236392703, 'CL', 'CHL', 'تشيلي'),
(46859, 3236392704, 3236393471, 'US', 'USA', 'الولايات المتحدة'),
(46860, 3236393472, 3236395519, 'BR', 'BRA', 'البرازيل'),
(46861, 3236395520, 3236396799, 'US', 'USA', 'الولايات المتحدة'),
(46862, 3236396800, 3236397055, 'AU', 'AUS', 'أستراليا'),
(46863, 3236397056, 3236398591, 'US', 'USA', 'الولايات المتحدة'),
(46864, 3236398848, 3236399615, 'AU', 'AUS', 'أستراليا'),
(46865, 3236399616, 3236400127, 'US', 'USA', 'الولايات المتحدة'),
(46866, 3236400128, 3236400383, 'CL', 'CHL', 'تشيلي'),
(46867, 3236400384, 3236401151, 'US', 'USA', 'الولايات المتحدة'),
(46868, 3236401152, 3236401407, 'AU', 'AUS', 'أستراليا'),
(46869, 3236401408, 3236403967, 'US', 'USA', 'الولايات المتحدة'),
(46870, 3236404224, 3236406783, 'US', 'USA', 'الولايات المتحدة'),
(46871, 3236406784, 3236407551, 'AU', 'AUS', 'أستراليا'),
(46872, 3236407552, 3236408063, 'SG', 'SGP', 'سنغافورة'),
(46873, 3236408064, 3236408319, 'US', 'USA', 'الولايات المتحدة'),
(46874, 3236408320, 3236409087, 'CA', 'CAN', 'كندا'),
(46875, 3236409088, 3236409599, 'BR', 'BRA', 'البرازيل'),
(46876, 3236409600, 3236411135, 'US', 'USA', 'الولايات المتحدة'),
(46877, 3236411136, 3236411391, 'NZ', 'NZL', 'نيوزيلاندا'),
(46878, 3236411392, 3236412415, 'US', 'USA', 'الولايات المتحدة'),
(46879, 3236412672, 3236413695, 'US', 'USA', 'الولايات المتحدة'),
(46880, 3236413696, 3236413951, 'AU', 'AUS', 'أستراليا'),
(46881, 3236413952, 3236416255, 'US', 'USA', 'الولايات المتحدة'),
(46882, 3236416256, 3236416511, 'AU', 'AUS', 'أستراليا'),
(46883, 3236416512, 3236418303, 'US', 'USA', 'الولايات المتحدة'),
(46884, 3236418304, 3236418815, 'AU', 'AUS', 'أستراليا'),
(46885, 3236418816, 3236419071, 'US', 'USA', 'الولايات المتحدة'),
(46886, 3236419328, 3236419583, 'US', 'USA', 'الولايات المتحدة'),
(46887, 3236419584, 3236419839, 'AU', 'AUS', 'أستراليا'),
(46888, 3236419840, 3236420095, 'US', 'USA', 'الولايات المتحدة'),
(46889, 3236420096, 3236420351, 'AU', 'AUS', 'أستراليا'),
(46890, 3236420352, 3236424959, 'US', 'USA', 'الولايات المتحدة'),
(46891, 3236425216, 3236427519, 'US', 'USA', 'الولايات المتحدة'),
(46892, 3236427520, 3236427775, 'CA', 'CAN', 'كندا'),
(46893, 3236427776, 3236428031, 'NZ', 'NZL', 'نيوزيلاندا'),
(46894, 3236428800, 3236429311, 'US', 'USA', 'الولايات المتحدة'),
(46895, 3236430080, 3236432639, 'US', 'USA', 'الولايات المتحدة'),
(46896, 3236433920, 3236438015, 'US', 'USA', 'الولايات المتحدة'),
(46897, 3236438016, 3236446207, 'AU', 'AUS', 'أستراليا'),
(46898, 3236446208, 3236462591, 'US', 'USA', 'الولايات المتحدة'),
(46899, 3236462592, 3236470783, 'AU', 'AUS', 'أستراليا'),
(46900, 3236495360, 3236560895, 'US', 'USA', 'الولايات المتحدة'),
(46901, 3236561152, 3236566783, 'US', 'USA', 'الولايات المتحدة'),
(46902, 3236566784, 3236567039, 'CA', 'CAN', 'كندا'),
(46903, 3236567040, 3236568831, 'US', 'USA', 'الولايات المتحدة'),
(46904, 3236569856, 3236570367, 'US', 'USA', 'الولايات المتحدة'),
(46905, 3236571392, 3236575743, 'US', 'USA', 'الولايات المتحدة'),
(46906, 3236575744, 3236575999, 'JP', 'JPN', 'اليابان'),
(46907, 3236576000, 3236581119, 'US', 'USA', 'الولايات المتحدة'),
(46908, 3236583680, 3236585983, 'US', 'USA', 'الولايات المتحدة'),
(46909, 3236585984, 3236586239, 'CA', 'CAN', 'كندا'),
(46910, 3236586240, 3236587775, 'US', 'USA', 'الولايات المتحدة'),
(46911, 3236588032, 3236589823, 'US', 'USA', 'الولايات المتحدة'),
(46912, 3236590080, 3236591103, 'US', 'USA', 'الولايات المتحدة'),
(46913, 3236592128, 3236601343, 'US', 'USA', 'الولايات المتحدة'),
(46914, 3236601600, 3236604671, 'US', 'USA', 'الولايات المتحدة'),
(46915, 3236604672, 3236604927, 'CA', 'CAN', 'كندا'),
(46916, 3236604928, 3236610047, 'US', 'USA', 'الولايات المتحدة'),
(46917, 3236610560, 3236611071, 'US', 'USA', 'الولايات المتحدة'),
(46918, 3236612096, 3236612607, 'US', 'USA', 'الولايات المتحدة'),
(46919, 3236613376, 3236617471, 'US', 'USA', 'الولايات المتحدة'),
(46920, 3236617728, 3236617983, 'US', 'USA', 'الولايات المتحدة'),
(46921, 3236617984, 3236619775, 'CA', 'CAN', 'كندا'),
(46922, 3236619776, 3236620031, 'US', 'USA', 'الولايات المتحدة'),
(46923, 3236620032, 3236620287, 'AU', 'AUS', 'أستراليا'),
(46924, 3236620288, 3236623615, 'US', 'USA', 'الولايات المتحدة'),
(46925, 3236623616, 3236623871, 'AU', 'AUS', 'أستراليا'),
(46926, 3236623872, 3236625919, 'US', 'USA', 'الولايات المتحدة'),
(46927, 3236625920, 3236626175, 'CA', 'CAN', 'كندا'),
(46928, 3236626432, 3236642815, 'US', 'USA', 'الولايات المتحدة'),
(46929, 3236692224, 3236694271, 'US', 'USA', 'الولايات المتحدة'),
(46930, 3236696064, 3236698623, 'US', 'USA', 'الولايات المتحدة'),
(46931, 3236700160, 3236708351, 'US', 'USA', 'الولايات المتحدة'),
(46932, 3236757504, 3236765695, 'CA', 'CAN', 'كندا'),
(46933, 3236765696, 3236790271, 'US', 'USA', 'الولايات المتحدة'),
(46934, 3236823296, 3236825855, 'CH', 'CHE', 'سويسرا'),
(46935, 3236827136, 3236829183, 'US', 'USA', 'الولايات المتحدة'),
(46936, 3236831232, 3236855807, 'US', 'USA', 'الولايات المتحدة'),
(46937, 3236888576, 3236958207, 'US', 'USA', 'الولايات المتحدة'),
(46938, 3236958208, 3236962303, 'AU', 'AUS', 'أستراليا'),
(46939, 3236962304, 3236966143, 'US', 'USA', 'الولايات المتحدة'),
(46940, 3236970496, 3236978687, 'US', 'USA', 'الولايات المتحدة'),
(46941, 3236986880, 3236991999, 'US', 'USA', 'الولايات المتحدة'),
(46942, 3237019648, 3237021695, 'US', 'USA', 'الولايات المتحدة'),
(46943, 3237023744, 3237031935, 'US', 'USA', 'الولايات المتحدة'),
(46944, 3237085184, 3237155839, 'US', 'USA', 'الولايات المتحدة'),
(46945, 3237155840, 3237156863, 'AU', 'AUS', 'أستراليا'),
(46946, 3237158912, 3237159167, 'US', 'USA', 'الولايات المتحدة'),
(46947, 3237160192, 3237160703, 'US', 'USA', 'الولايات المتحدة'),
(46948, 3237183488, 3237205247, 'US', 'USA', 'الولايات المتحدة'),
(46949, 3237216256, 3237281791, 'JP', 'JPN', 'اليابان'),
(46950, 3237282560, 3237284607, 'US', 'USA', 'الولايات المتحدة'),
(46951, 3237284608, 3237284863, 'AU', 'AUS', 'أستراليا'),
(46952, 3237284864, 3237285119, 'US', 'USA', 'الولايات المتحدة'),
(46953, 3237285120, 3237285631, 'AU', 'AUS', 'أستراليا'),
(46954, 3237285632, 3237287935, 'US', 'USA', 'الولايات المتحدة'),
(46955, 3237287936, 3237288191, 'CA', 'CAN', 'كندا'),
(46956, 3237288192, 3237289471, 'US', 'USA', 'الولايات المتحدة'),
(46957, 3237289728, 3237290495, 'US', 'USA', 'الولايات المتحدة'),
(46958, 3237290496, 3237291007, 'AU', 'AUS', 'أستراليا'),
(46959, 3237291008, 3237291263, 'NZ', 'NZL', 'نيوزيلاندا'),
(46960, 3237291264, 3237294847, 'US', 'USA', 'الولايات المتحدة'),
(46961, 3237294848, 3237295103, 'CA', 'CAN', 'كندا'),
(46962, 3237295104, 3237296639, 'US', 'USA', 'الولايات المتحدة'),
(46963, 3237296640, 3237297151, 'SG', 'SGP', 'سنغافورة'),
(46964, 3237297152, 3237297407, 'CL', 'CHL', 'تشيلي'),
(46965, 3237297408, 3237300479, 'US', 'USA', 'الولايات المتحدة'),
(46966, 3237300480, 3237302527, 'NZ', 'NZL', 'نيوزيلاندا'),
(46967, 3237302528, 3237305087, 'US', 'USA', 'الولايات المتحدة'),
(46968, 3237305088, 3237305343, 'CA', 'CAN', 'كندا'),
(46969, 3237305344, 3237305855, 'US', 'USA', 'الولايات المتحدة'),
(46970, 3237305856, 3237306111, 'NZ', 'NZL', 'نيوزيلاندا'),
(46971, 3237306112, 3237308671, 'US', 'USA', 'الولايات المتحدة'),
(46972, 3237308672, 3237310719, 'AU', 'AUS', 'أستراليا'),
(46973, 3237310720, 3237311999, 'US', 'USA', 'الولايات المتحدة'),
(46974, 3237312256, 3237312767, 'US', 'USA', 'الولايات المتحدة'),
(46975, 3237312768, 3237313023, 'BO', 'BOL', 'بوليفيا'),
(46976, 3237313024, 3237317631, 'US', 'USA', 'الولايات المتحدة'),
(46977, 3237317888, 3237319679, 'US', 'USA', 'الولايات المتحدة'),
(46978, 3237319936, 3237320703, 'US', 'USA', 'الولايات المتحدة'),
(46979, 3237320704, 3237320959, 'UA', 'UKR', 'أوكرانيا'),
(46980, 3237320960, 3237321471, 'US', 'USA', 'الولايات المتحدة'),
(46981, 3237321472, 3237321727, 'HK', 'HKG', 'هونغ كونغ'),
(46982, 3237321728, 3237321983, 'US', 'USA', 'الولايات المتحدة'),
(46983, 3237323264, 3237325055, 'US', 'USA', 'الولايات المتحدة'),
(46984, 3237325056, 3237325311, 'PL', 'POL', 'بولندا'),
(46985, 3237325312, 3237325823, 'US', 'USA', 'الولايات المتحدة'),
(46986, 3237325824, 3237326079, 'CA', 'CAN', 'كندا'),
(46987, 3237326080, 3237328127, 'US', 'USA', 'الولايات المتحدة'),
(46988, 3237328384, 3237328639, 'US', 'USA', 'الولايات المتحدة'),
(46989, 3237328640, 3237328895, 'CA', 'CAN', 'كندا'),
(46990, 3237328896, 3237329151, 'US', 'USA', 'الولايات المتحدة'),
(46991, 3237329152, 3237329407, 'NZ', 'NZL', 'نيوزيلاندا'),
(46992, 3237329408, 3237330943, 'US', 'USA', 'الولايات المتحدة'),
(46993, 3237330944, 3237331199, 'AU', 'AUS', 'أستراليا'),
(46994, 3237331456, 3237331967, 'US', 'USA', 'الولايات المتحدة'),
(46995, 3237331968, 3237332223, 'HK', 'HKG', 'هونغ كونغ'),
(46996, 3237332224, 3237335039, 'US', 'USA', 'الولايات المتحدة'),
(46997, 3237335040, 3237335295, 'HK', 'HKG', 'هونغ كونغ'),
(46998, 3237335296, 3237335551, 'US', 'USA', 'الولايات المتحدة'),
(46999, 3237335552, 3237337599, 'AU', 'AUS', 'أستراليا'),
(47000, 3237337600, 3237337855, 'US', 'USA', 'الولايات المتحدة'),
(47001, 3237337856, 3237338111, 'AU', 'AUS', 'أستراليا'),
(47002, 3237338112, 3237338367, 'NZ', 'NZL', 'نيوزيلاندا'),
(47003, 3237338368, 3237339391, 'US', 'USA', 'الولايات المتحدة'),
(47004, 3237339392, 3237339647, 'GB', 'GBR', 'المملكة المتحدة'),
(47005, 3237339648, 3237340159, 'US', 'USA', 'الولايات المتحدة'),
(47006, 3237340160, 3237340415, 'CA', 'CAN', 'كندا'),
(47007, 3237340416, 3237345535, 'US', 'USA', 'الولايات المتحدة'),
(47008, 3237345536, 3237346303, 'KR', 'KOR', 'جمهورية كوريا'),
(47009, 3237346304, 3237347071, 'US', 'USA', 'الولايات المتحدة'),
(47010, 3237347328, 3237412863, 'US', 'USA', 'الولايات المتحدة'),
(47011, 3237413120, 3237415679, 'GB', 'GBR', 'المملكة المتحدة'),
(47012, 3237416960, 3237437439, 'US', 'USA', 'الولايات المتحدة'),
(47013, 3237445632, 3237478399, 'US', 'USA', 'الولايات المتحدة'),
(47014, 3237478400, 3237511167, 'LK', 'LKA', 'سيريلانكا'),
(47015, 3237511168, 3237548031, 'US', 'USA', 'الولايات المتحدة'),
(47016, 3237548032, 3237552127, 'KR', 'KOR', 'جمهورية كوريا'),
(47017, 3237552128, 3237557247, 'US', 'USA', 'الولايات المتحدة'),
(47018, 3237609472, 3237613567, 'US', 'USA', 'الولايات المتحدة'),
(47019, 3237615104, 3237615615, 'US', 'USA', 'الولايات المتحدة'),
(47020, 3237615616, 3237616895, 'CA', 'CAN', 'كندا'),
(47021, 3237617152, 3237658623, 'US', 'USA', 'الولايات المتحدة'),
(47022, 3237675264, 3237681663, 'US', 'USA', 'الولايات المتحدة'),
(47023, 3237681664, 3237682943, 'CA', 'CAN', 'كندا'),
(47024, 3237682944, 3237684991, 'US', 'USA', 'الولايات المتحدة'),
(47025, 3237684992, 3237685247, 'CL', 'CHL', 'تشيلي'),
(47026, 3237685248, 3237688319, 'US', 'USA', 'الولايات المتحدة'),
(47027, 3237688320, 3237689343, 'CA', 'CAN', 'كندا'),
(47028, 3237689344, 3237690623, 'US', 'USA', 'الولايات المتحدة'),
(47029, 3237690624, 3237691903, 'SA', 'SAU', 'السعودية'),
(47030, 3237691904, 3237698303, 'US', 'USA', 'الولايات المتحدة'),
(47031, 3237698304, 3237698559, 'CA', 'CAN', 'كندا'),
(47032, 3237698560, 3237701631, 'US', 'USA', 'الولايات المتحدة'),
(47033, 3237702400, 3237707775, 'US', 'USA', 'الولايات المتحدة'),
(47034, 3237708032, 3237712895, 'US', 'USA', 'الولايات المتحدة'),
(47035, 3237712896, 3237713151, 'AU', 'AUS', 'أستراليا'),
(47036, 3237713152, 3237716991, 'US', 'USA', 'الولايات المتحدة'),
(47037, 3237716992, 3237717247, 'CA', 'CAN', 'كندا'),
(47038, 3237717248, 3237717503, 'US', 'USA', 'الولايات المتحدة'),
(47039, 3237717504, 3237717759, 'CA', 'CAN', 'كندا'),
(47040, 3237717760, 3237724927, 'US', 'USA', 'الولايات المتحدة'),
(47041, 3237724928, 3237725183, 'AU', 'AUS', 'أستراليا'),
(47042, 3237725184, 3237725439, 'CA', 'CAN', 'كندا'),
(47043, 3237725440, 3237725695, 'US', 'USA', 'الولايات المتحدة'),
(47044, 3237726464, 3237726719, 'AU', 'AUS', 'أستراليا'),
(47045, 3237726976, 3237727231, 'US', 'USA', 'الولايات المتحدة'),
(47046, 3237727232, 3237728255, 'AU', 'AUS', 'أستراليا'),
(47047, 3237728256, 3237732863, 'US', 'USA', 'الولايات المتحدة'),
(47048, 3237732864, 3237733119, 'DE', 'DEU', 'ألمانيا'),
(47049, 3237733120, 3237733631, 'TH', 'THA', 'تايلند'),
(47050, 3237733632, 3237733887, 'AU', 'AUS', 'أستراليا'),
(47051, 3237734144, 3237734399, 'CA', 'CAN', 'كندا'),
(47052, 3237734400, 3237735679, 'US', 'USA', 'الولايات المتحدة'),
(47053, 3237740544, 3237773311, 'US', 'USA', 'الولايات المتحدة'),
(47054, 3237806336, 3237857535, 'US', 'USA', 'الولايات المتحدة'),
(47055, 3237871616, 3237887999, 'US', 'USA', 'الولايات المتحدة'),
(47056, 3238002688, 3238006783, 'NL', 'NLD', 'هولندا'),
(47057, 3238006784, 3238007039, 'GB', 'GBR', 'المملكة المتحدة'),
(47058, 3238007040, 3238010879, 'NL', 'NLD', 'هولندا'),
(47059, 3238010880, 3238017023, 'CH', 'CHE', 'سويسرا'),
(47060, 3238017024, 3238018303, 'DK', 'DNK', 'الدنيمارك'),
(47061, 3238018560, 3238018815, 'FR', 'FRA', 'فرنسا'),
(47062, 3238018816, 3238019071, 'DE', 'DEU', 'ألمانيا'),
(47063, 3238019072, 3238035455, 'PL', 'POL', 'بولندا'),
(47064, 3238035456, 3238060031, 'FR', 'FRA', 'فرنسا'),
(47065, 3238060032, 3238060287, 'CH', 'CHE', 'سويسرا'),
(47066, 3238060288, 3238060543, 'RO', 'ROM', 'رومانيا'),
(47067, 3238060544, 3238060799, 'HU', 'HUN', 'هنغاريا'),
(47068, 3238060800, 3238061311, 'UA', 'UKR', 'أوكرانيا'),
(47069, 3238061312, 3238061567, 'GB', 'GBR', 'المملكة المتحدة'),
(47070, 3238061568, 3238061823, 'AT', 'AUT', 'النمسا'),
(47071, 3238061824, 3238062079, 'CZ', 'CZE', 'التشيك'),
(47072, 3238062080, 3238062591, 'CH', 'CHE', 'سويسرا'),
(47073, 3238062592, 3238062847, 'GB', 'GBR', 'المملكة المتحدة'),
(47074, 3238062848, 3238063103, 'SE', 'SWE', 'السويد'),
(47075, 3238063104, 3238063359, 'PL', 'POL', 'بولندا'),
(47076, 3238063360, 3238063615, 'CH', 'CHE', 'سويسرا'),
(47077, 3238063616, 3238063871, 'DE', 'DEU', 'ألمانيا'),
(47078, 3238063872, 3238064127, 'GB', 'GBR', 'المملكة المتحدة'),
(47079, 3238064128, 3238064383, 'UA', 'UKR', 'أوكرانيا'),
(47080, 3238064384, 3238064639, 'ES', 'ESP', 'إسبانيا'),
(47081, 3238064640, 3238064895, 'PL', 'POL', 'بولندا'),
(47082, 3238064896, 3238065151, 'DK', 'DNK', 'الدنيمارك'),
(47083, 3238065152, 3238065407, 'SI', 'SVN', 'سلوفينيا'),
(47084, 3238065408, 3238065663, 'FR', 'FRA', 'فرنسا'),
(47085, 3238065664, 3238065919, 'DE', 'DEU', 'ألمانيا'),
(47086, 3238065920, 3238066175, 'UA', 'UKR', 'أوكرانيا'),
(47087, 3238066176, 3238066431, 'DE', 'DEU', 'ألمانيا'),
(47088, 3238066432, 3238066687, 'GB', 'GBR', 'المملكة المتحدة'),
(47089, 3238066688, 3238066943, 'DE', 'DEU', 'ألمانيا'),
(47090, 3238066944, 3238067199, 'LT', 'LTU', 'ليتوانيا'),
(47091, 3238067200, 3238067455, 'NO', 'NOR', 'النرويج'),
(47092, 3238067456, 3238067711, 'SE', 'SWE', 'السويد'),
(47093, 3238067712, 3238067967, 'AT', 'AUT', 'النمسا'),
(47094, 3238067968, 3238068223, 'GB', 'GBR', 'المملكة المتحدة'),
(47095, 3238068224, 3238133759, 'IE', 'IRL', 'إيرلندا'),
(47096, 3238133760, 3238199295, 'SI', 'SVN', 'سلوفينيا'),
(47097, 3238199296, 3238201599, 'DK', 'DNK', 'الدنيمارك'),
(47098, 3238201600, 3238202367, 'US', 'USA', 'الولايات المتحدة'),
(47099, 3238202368, 3238264831, 'DK', 'DNK', 'الدنيمارك'),
(47100, 3238264832, 3238330367, 'IS', 'ISL', 'أيسلندا'),
(47101, 3238330368, 3238337023, 'CH', 'CHE', 'سويسرا'),
(47102, 3238337024, 3238337535, 'LI', 'LIE', 'ليختنشتاين'),
(47103, 3238337536, 3238395903, 'CH', 'CHE', 'سويسرا'),
(47104, 3238395904, 3238461439, 'HU', 'HUN', 'هنغاريا'),
(47105, 3238461440, 3238502399, 'DE', 'DEU', 'ألمانيا'),
(47106, 3238502400, 3238504447, 'RU', 'RUS', 'الإتحاد الروسي'),
(47107, 3238504448, 3238526975, 'DE', 'DEU', 'ألمانيا'),
(47108, 3238527232, 3238541567, 'CH', 'CHE', 'سويسرا'),
(47109, 3238541824, 3238542591, 'CH', 'CHE', 'سويسرا'),
(47110, 3238542848, 3238545919, 'CH', 'CHE', 'سويسرا'),
(47111, 3238546432, 3238546943, 'CH', 'CHE', 'سويسرا'),
(47112, 3238547456, 3238548991, 'CH', 'CHE', 'سويسرا'),
(47113, 3238549504, 3238559231, 'CH', 'CHE', 'سويسرا'),
(47114, 3238559488, 3238562559, 'CH', 'CHE', 'سويسرا'),
(47115, 3238562816, 3238573567, 'CH', 'CHE', 'سويسرا'),
(47116, 3238574080, 3238582271, 'CH', 'CHE', 'سويسرا'),
(47117, 3238582784, 3238583295, 'CH', 'CHE', 'سويسرا'),
(47118, 3238583808, 3238589951, 'CH', 'CHE', 'سويسرا'),
(47119, 3238590208, 3238590719, 'CH', 'CHE', 'سويسرا'),
(47120, 3238591232, 3238592511, 'CH', 'CHE', 'سويسرا'),
(47121, 3238592512, 3238593023, 'GB', 'GBR', 'المملكة المتحدة'),
(47122, 3238594304, 3238594559, 'GB', 'GBR', 'المملكة المتحدة'),
(47123, 3238594560, 3238595583, 'BE', 'BEL', 'بلجيكا'),
(47124, 3238595584, 3238595839, 'SI', 'SVN', 'سلوفينيا'),
(47125, 3238595840, 3238596607, 'GB', 'GBR', 'المملكة المتحدة'),
(47126, 3238596608, 3238596863, 'BG', 'BGR', 'بلغاريا'),
(47127, 3238596864, 3238597119, 'RU', 'RUS', 'الإتحاد الروسي'),
(47128, 3238597120, 3238597375, 'DE', 'DEU', 'ألمانيا'),
(47129, 3238597376, 3238597631, 'SI', 'SVN', 'سلوفينيا'),
(47130, 3238597632, 3238597887, 'GB', 'GBR', 'المملكة المتحدة'),
(47131, 3238597888, 3238598143, 'SI', 'SVN', 'سلوفينيا'),
(47132, 3238598144, 3238598399, 'RU', 'RUS', 'الإتحاد الروسي'),
(47133, 3238598400, 3238598655, 'NL', 'NLD', 'هولندا'),
(47134, 3238598656, 3238598911, 'CH', 'CHE', 'سويسرا'),
(47135, 3238598912, 3238599167, 'PL', 'POL', 'بولندا'),
(47136, 3238599168, 3238599679, 'HU', 'HUN', 'هنغاريا'),
(47137, 3238599680, 3238599935, 'UA', 'UKR', 'أوكرانيا'),
(47138, 3238599936, 3238600703, 'HU', 'HUN', 'هنغاريا'),
(47139, 3238600704, 3238604799, 'DE', 'DEU', 'ألمانيا'),
(47140, 3238604800, 3238606335, 'NL', 'NLD', 'هولندا'),
(47141, 3238606336, 3238606591, 'SE', 'SWE', 'السويد'),
(47142, 3238606592, 3238607359, 'NL', 'NLD', 'هولندا'),
(47143, 3238607360, 3238607871, 'SE', 'SWE', 'السويد'),
(47144, 3238607872, 3238608895, 'NL', 'NLD', 'هولندا'),
(47145, 3238621184, 3238621439, 'FI', 'FIN', 'فنلندا'),
(47146, 3238621440, 3238621695, 'FR', 'FRA', 'فرنسا'),
(47147, 3238621696, 3238621951, 'IT', 'ITA', 'إيطاليا'),
(47148, 3238621952, 3238622207, 'NL', 'NLD', 'هولندا'),
(47149, 3238622208, 3238622463, 'NO', 'NOR', 'النرويج'),
(47150, 3238622464, 3238622719, 'SE', 'SWE', 'السويد'),
(47151, 3238622720, 3238622975, 'DK', 'DNK', 'الدنيمارك'),
(47152, 3238622976, 3238623231, 'GB', 'GBR', 'المملكة المتحدة'),
(47153, 3238623232, 3238623487, 'LV', 'LVA', 'لاتفيا'),
(47154, 3238623488, 3238623743, 'PL', 'POL', 'بولندا'),
(47155, 3238623744, 3238623999, 'CH', 'CHE', 'سويسرا'),
(47156, 3238624000, 3238624255, 'PL', 'POL', 'بولندا'),
(47157, 3238624256, 3238625279, 'HU', 'HUN', 'هنغاريا'),
(47158, 3238630400, 3238630655, 'GR', 'GRC', 'اليونان'),
(47159, 3238630656, 3238632959, 'GB', 'GBR', 'المملكة المتحدة'),
(47160, 3238632960, 3238633215, 'UA', 'UKR', 'أوكرانيا'),
(47161, 3238633216, 3238657791, 'DK', 'DNK', 'الدنيمارك'),
(47162, 3238657792, 3238658047, 'AT', 'AUT', 'النمسا'),
(47163, 3238658048, 3238675455, 'SE', 'SWE', 'السويد'),
(47164, 3238675456, 3238675711, 'DK', 'DNK', 'الدنيمارك'),
(47165, 3238675712, 3238723071, 'SE', 'SWE', 'السويد'),
(47166, 3238723072, 3238723327, 'DK', 'DNK', 'الدنيمارك'),
(47167, 3238723328, 3238795263, 'SE', 'SWE', 'السويد'),
(47168, 3238795264, 3238795775, 'IT', 'ITA', 'إيطاليا'),
(47169, 3238795776, 3238801279, 'SE', 'SWE', 'السويد'),
(47170, 3238801280, 3238801343, 'GB', 'GBR', 'المملكة المتحدة'),
(47171, 3238801344, 3239051263, 'SE', 'SWE', 'السويد'),
(47172, 3239051264, 3239051519, 'CH', 'CHE', 'سويسرا'),
(47173, 3239051520, 3239062271, 'DE', 'DEU', 'ألمانيا'),
(47174, 3239062272, 3239062527, 'ES', 'ESP', 'إسبانيا'),
(47175, 3239062528, 3239062783, 'CH', 'CHE', 'سويسرا'),
(47176, 3239062784, 3239063551, 'UA', 'UKR', 'أوكرانيا'),
(47177, 3239063552, 3239075839, 'DE', 'DEU', 'ألمانيا'),
(47178, 3239075840, 3239076095, 'MT', 'MLT', 'مالطا'),
(47179, 3239076096, 3239076351, 'SE', 'SWE', 'السويد'),
(47180, 3239076352, 3239076607, 'DE', 'DEU', 'ألمانيا'),
(47181, 3239076608, 3239076863, 'PL', 'POL', 'بولندا'),
(47182, 3239076864, 3239077119, 'NL', 'NLD', 'هولندا'),
(47183, 3239077120, 3239077375, 'UA', 'UKR', 'أوكرانيا'),
(47184, 3239077376, 3239077631, 'BG', 'BGR', 'بلغاريا'),
(47185, 3239077632, 3239077887, 'PT', 'PRT', 'البورتوغال'),
(47186, 3239077888, 3239078143, 'CZ', 'CZE', 'التشيك'),
(47187, 3239078144, 3239078399, 'UA', 'UKR', 'أوكرانيا'),
(47188, 3239078400, 3239078655, 'RU', 'RUS', 'الإتحاد الروسي'),
(47189, 3239078656, 3239078911, 'PL', 'POL', 'بولندا'),
(47190, 3239078912, 3239079167, 'GB', 'GBR', 'المملكة المتحدة'),
(47191, 3239079168, 3239079423, 'SI', 'SVN', 'سلوفينيا'),
(47192, 3239079424, 3239079679, 'FR', 'FRA', 'فرنسا'),
(47193, 3239079680, 3239079935, 'MD', 'MDA', 'مولدوفا'),
(47194, 3239079936, 3239088127, 'DE', 'DEU', 'ألمانيا'),
(47195, 3239088128, 3239088639, 'GB', 'GBR', 'المملكة المتحدة'),
(47196, 3239088640, 3239088895, 'DK', 'DNK', 'الدنيمارك'),
(47197, 3239088896, 3239089151, 'IL', 'ISR', 'إسرائيل'),
(47198, 3239089152, 3239089407, 'RO', 'ROM', 'رومانيا'),
(47199, 3239089408, 3239089919, 'GB', 'GBR', 'المملكة المتحدة'),
(47200, 3239089920, 3239090175, 'DE', 'DEU', 'ألمانيا'),
(47201, 3239090176, 3239090431, 'SI', 'SVN', 'سلوفينيا'),
(47202, 3239090432, 3239090687, 'ES', 'ESP', 'إسبانيا'),
(47203, 3239090688, 3239090943, 'NL', 'NLD', 'هولندا'),
(47204, 3239090944, 3239091199, 'AT', 'AUT', 'النمسا'),
(47205, 3239091200, 3239091455, 'FR', 'FRA', 'فرنسا'),
(47206, 3239091456, 3239091711, 'BG', 'BGR', 'بلغاريا'),
(47207, 3239091712, 3239091967, 'UA', 'UKR', 'أوكرانيا'),
(47208, 3239091968, 3239092223, 'FR', 'FRA', 'فرنسا'),
(47209, 3239092224, 3239104511, 'DE', 'DEU', 'ألمانيا'),
(47210, 3239104512, 3239105279, 'RU', 'RUS', 'الإتحاد الروسي'),
(47211, 3239105280, 3239105535, 'CH', 'CHE', 'سويسرا'),
(47212, 3239105536, 3239105791, 'DE', 'DEU', 'ألمانيا'),
(47213, 3239105792, 3239106047, 'RO', 'ROM', 'رومانيا'),
(47214, 3239106048, 3239106559, 'AT', 'AUT', 'النمسا'),
(47215, 3239106560, 3239106815, 'ES', 'ESP', 'إسبانيا'),
(47216, 3239106816, 3239107071, 'CH', 'CHE', 'سويسرا'),
(47217, 3239107072, 3239107327, 'RO', 'ROM', 'رومانيا'),
(47218, 3239107328, 3239107583, 'GR', 'GRC', 'اليونان'),
(47219, 3239107584, 3239107839, 'CH', 'CHE', 'سويسرا'),
(47220, 3239107840, 3239108095, 'RO', 'ROM', 'رومانيا'),
(47221, 3239108096, 3239109887, 'DE', 'DEU', 'ألمانيا'),
(47222, 3239109888, 3239110143, 'PL', 'POL', 'بولندا'),
(47223, 3239110144, 3239110655, 'DE', 'DEU', 'ألمانيا'),
(47224, 3239110656, 3239110911, 'RU', 'RUS', 'الإتحاد الروسي'),
(47225, 3239110912, 3239111167, 'UA', 'UKR', 'أوكرانيا'),
(47226, 3239111168, 3239111423, 'NL', 'NLD', 'هولندا'),
(47227, 3239111424, 3239111935, 'DE', 'DEU', 'ألمانيا'),
(47228, 3239111936, 3239112191, 'AT', 'AUT', 'النمسا'),
(47229, 3239112448, 3239112959, 'PL', 'POL', 'بولندا'),
(47230, 3239112960, 3239113215, 'CH', 'CHE', 'سويسرا'),
(47231, 3239113216, 3239113471, 'AT', 'AUT', 'النمسا'),
(47232, 3239113472, 3239113727, 'ES', 'ESP', 'إسبانيا'),
(47233, 3239113728, 3239113983, 'AT', 'AUT', 'النمسا'),
(47234, 3239113984, 3239114239, 'DE', 'DEU', 'ألمانيا'),
(47235, 3239114240, 3239114495, 'BG', 'BGR', 'بلغاريا'),
(47236, 3239114496, 3239114751, 'UA', 'UKR', 'أوكرانيا'),
(47237, 3239114752, 3239116543, 'DE', 'DEU', 'ألمانيا'),
(47238, 3239116544, 3239116799, 'PL', 'POL', 'بولندا'),
(47239, 3239116800, 3239117055, 'PT', 'PRT', 'البورتوغال'),
(47240, 3239117312, 3239119871, 'DE', 'DEU', 'ألمانيا'),
(47241, 3239119872, 3239120127, 'GB', 'GBR', 'المملكة المتحدة'),
(47242, 3239120128, 3239120383, 'CZ', 'CZE', 'التشيك'),
(47243, 3239120384, 3239120639, 'PL', 'POL', 'بولندا'),
(47244, 3239120640, 3239120895, 'FR', 'FRA', 'فرنسا'),
(47245, 3239120896, 3239121663, 'DE', 'DEU', 'ألمانيا'),
(47246, 3239121664, 3239121919, 'FR', 'FRA', 'فرنسا'),
(47247, 3239121920, 3239127039, 'DE', 'DEU', 'ألمانيا'),
(47248, 3239127040, 3239127295, 'PT', 'PRT', 'البورتوغال'),
(47249, 3239127296, 3239127551, 'PL', 'POL', 'بولندا'),
(47250, 3239127552, 3239127807, 'IL', 'ISR', 'إسرائيل'),
(47251, 3239127808, 3239128063, 'RU', 'RUS', 'الإتحاد الروسي'),
(47252, 3239128064, 3239128319, 'AT', 'AUT', 'النمسا'),
(47253, 3239128320, 3239128575, 'IT', 'ITA', 'إيطاليا'),
(47254, 3239128576, 3239128831, 'UA', 'UKR', 'أوكرانيا'),
(47255, 3239128832, 3239129087, 'CZ', 'CZE', 'التشيك'),
(47256, 3239129088, 3239130111, 'DE', 'DEU', 'ألمانيا'),
(47257, 3239130112, 3239130367, 'RU', 'RUS', 'الإتحاد الروسي'),
(47258, 3239130368, 3239130623, 'JO', 'JOR', 'الأردن'),
(47259, 3239130624, 3239131135, 'PL', 'POL', 'بولندا'),
(47260, 3239131136, 3239133183, 'DE', 'DEU', 'ألمانيا'),
(47261, 3239133184, 3239133439, 'CH', 'CHE', 'سويسرا'),
(47262, 3239133440, 3239133695, 'GB', 'GBR', 'المملكة المتحدة'),
(47263, 3239133696, 3239133951, 'ES', 'ESP', 'إسبانيا'),
(47264, 3239133952, 3239134207, 'SE', 'SWE', 'السويد'),
(47265, 3239134208, 3239134463, 'IL', 'ISR', 'إسرائيل'),
(47266, 3239134464, 3239134719, 'UA', 'UKR', 'أوكرانيا'),
(47267, 3239134720, 3239134975, 'RO', 'ROM', 'رومانيا'),
(47268, 3239134976, 3239135231, 'PL', 'POL', 'بولندا'),
(47269, 3239135232, 3239135487, 'SE', 'SWE', 'السويد'),
(47270, 3239135488, 3239135743, 'FR', 'FRA', 'فرنسا'),
(47271, 3239135744, 3239135999, 'IL', 'ISR', 'إسرائيل'),
(47272, 3239136000, 3239136255, 'UA', 'UKR', 'أوكرانيا'),
(47273, 3239136256, 3239136511, 'CH', 'CHE', 'سويسرا'),
(47274, 3239136512, 3239136767, 'DE', 'DEU', 'ألمانيا'),
(47275, 3239136768, 3239137023, 'MD', 'MDA', 'مولدوفا'),
(47276, 3239137024, 3239137279, 'LI', 'LIE', 'ليختنشتاين'),
(47277, 3239137280, 3239138303, 'DE', 'DEU', 'ألمانيا'),
(47278, 3239138304, 3239138559, 'PL', 'POL', 'بولندا'),
(47279, 3239138560, 3239138815, 'CH', 'CHE', 'سويسرا'),
(47280, 3239138816, 3239149567, 'DE', 'DEU', 'ألمانيا'),
(47281, 3239149568, 3239160319, 'GB', 'GBR', 'المملكة المتحدة'),
(47282, 3239160320, 3239160575, 'RU', 'RUS', 'الإتحاد الروسي'),
(47283, 3239160576, 3239160831, 'DE', 'DEU', 'ألمانيا'),
(47284, 3239160832, 3239161087, 'PL', 'POL', 'بولندا'),
(47285, 3239161088, 3239161343, 'BY', 'BLR', 'روسيا البيضاء'),
(47286, 3239161344, 3239161599, 'UA', 'UKR', 'أوكرانيا'),
(47287, 3239161600, 3239161855, 'HU', 'HUN', 'هنغاريا'),
(47288, 3239161856, 3239162623, 'DE', 'DEU', 'ألمانيا'),
(47289, 3239162624, 3239162879, 'BE', 'BEL', 'بلجيكا'),
(47290, 3239162880, 3239163903, 'DE', 'DEU', 'ألمانيا'),
(47291, 3239164160, 3239164671, 'DE', 'DEU', 'ألمانيا'),
(47292, 3239164672, 3239164927, 'GB', 'GBR', 'المملكة المتحدة'),
(47293, 3239164928, 3239165183, 'DK', 'DNK', 'الدنيمارك'),
(47294, 3239165184, 3239165951, 'DE', 'DEU', 'ألمانيا'),
(47295, 3239165952, 3239166207, 'FR', 'FRA', 'فرنسا'),
(47296, 3239166208, 3239166463, 'DE', 'DEU', 'ألمانيا'),
(47297, 3239166464, 3239166719, 'CH', 'CHE', 'سويسرا'),
(47298, 3239166720, 3239166975, 'RO', 'ROM', 'رومانيا'),
(47299, 3239166976, 3239167231, 'FR', 'FRA', 'فرنسا'),
(47300, 3239167232, 3239167487, 'DE', 'DEU', 'ألمانيا'),
(47301, 3239167488, 3239167743, 'FR', 'FRA', 'فرنسا'),
(47302, 3239167744, 3239168511, 'CH', 'CHE', 'سويسرا'),
(47303, 3239168512, 3239168767, 'SE', 'SWE', 'السويد'),
(47304, 3239168768, 3239169023, 'PL', 'POL', 'بولندا'),
(47305, 3239169024, 3239169535, 'DE', 'DEU', 'ألمانيا'),
(47306, 3239169536, 3239169791, 'DK', 'DNK', 'الدنيمارك'),
(47307, 3239169792, 3239170047, 'SE', 'SWE', 'السويد'),
(47308, 3239170048, 3239170303, 'UA', 'UKR', 'أوكرانيا'),
(47309, 3239170304, 3239170559, 'FR', 'FRA', 'فرنسا'),
(47310, 3239170560, 3239170815, 'GB', 'GBR', 'المملكة المتحدة'),
(47311, 3239170816, 3239171071, 'SE', 'SWE', 'السويد'),
(47312, 3239171072, 3239171327, 'PL', 'POL', 'بولندا'),
(47313, 3239171328, 3239171583, 'UA', 'UKR', 'أوكرانيا'),
(47314, 3239171584, 3239171839, 'PL', 'POL', 'بولندا'),
(47315, 3239172096, 3239172607, 'UA', 'UKR', 'أوكرانيا'),
(47316, 3239172608, 3239172863, 'SE', 'SWE', 'السويد'),
(47317, 3239172864, 3239173119, 'DE', 'DEU', 'ألمانيا'),
(47318, 3239173120, 3239173375, 'RO', 'ROM', 'رومانيا'),
(47319, 3239173376, 3239173631, 'DE', 'DEU', 'ألمانيا'),
(47320, 3239173632, 3239173887, 'AT', 'AUT', 'النمسا'),
(47321, 3239173888, 3239174143, 'PL', 'POL', 'بولندا'),
(47322, 3239174144, 3239174399, 'DE', 'DEU', 'ألمانيا'),
(47323, 3239174400, 3239174655, 'FR', 'FRA', 'فرنسا'),
(47324, 3239174656, 3239174911, 'GB', 'GBR', 'المملكة المتحدة'),
(47325, 3239174912, 3239175167, 'SI', 'SVN', 'سلوفينيا'),
(47326, 3239175168, 3239175423, 'UA', 'UKR', 'أوكرانيا'),
(47327, 3239175424, 3239175679, 'BG', 'BGR', 'بلغاريا'),
(47328, 3239175680, 3239175935, 'DE', 'DEU', 'ألمانيا'),
(47329, 3239175936, 3239176191, 'FI', 'FIN', 'فنلندا'),
(47330, 3239176192, 3239180287, 'DE', 'DEU', 'ألمانيا'),
(47331, 3239181312, 3239181567, 'AT', 'AUT', 'النمسا'),
(47332, 3239181568, 3239181823, 'UA', 'UKR', 'أوكرانيا'),
(47333, 3239181824, 3239264255, 'DE', 'DEU', 'ألمانيا'),
(47334, 3239264256, 3239264767, 'NO', 'NOR', 'النرويج'),
(47335, 3239264768, 3239266303, 'RU', 'RUS', 'الإتحاد الروسي'),
(47336, 3239266304, 3239266815, 'PL', 'POL', 'بولندا'),
(47337, 3239266816, 3239267327, 'UA', 'UKR', 'أوكرانيا'),
(47338, 3239267328, 3239267839, 'FR', 'FRA', 'فرنسا'),
(47339, 3239267840, 3239268351, 'DE', 'DEU', 'ألمانيا'),
(47340, 3239268352, 3239268863, 'SE', 'SWE', 'السويد'),
(47341, 3239268864, 3239269375, 'RU', 'RUS', 'الإتحاد الروسي'),
(47342, 3239269376, 3239270399, 'UA', 'UKR', 'أوكرانيا'),
(47343, 3239270400, 3239270911, 'GB', 'GBR', 'المملكة المتحدة'),
(47344, 3239270912, 3239271423, 'SA', 'SAU', 'السعودية'),
(47345, 3239271424, 3239271935, 'AT', 'AUT', 'النمسا'),
(47346, 3239271936, 3239272447, 'CH', 'CHE', 'سويسرا'),
(47347, 3239272448, 3239272959, 'UA', 'UKR', 'أوكرانيا'),
(47348, 3239272960, 3239273471, 'GB', 'GBR', 'المملكة المتحدة'),
(47349, 3239273472, 3239273983, 'UA', 'UKR', 'أوكرانيا'),
(47350, 3239273984, 3239274495, 'RU', 'RUS', 'الإتحاد الروسي'),
(47351, 3239274496, 3239275007, 'PL', 'POL', 'بولندا'),
(47352, 3239275008, 3239275519, 'RO', 'ROM', 'رومانيا'),
(47353, 3239275520, 3239276543, 'UA', 'UKR', 'أوكرانيا'),
(47354, 3239276544, 3239277055, 'LU', 'LUX', 'لوكسيمبورغ'),
(47355, 3239277056, 3239277567, 'DE', 'DEU', 'ألمانيا'),
(47356, 3239277568, 3239278079, 'RU', 'RUS', 'الإتحاد الروسي'),
(47357, 3239278080, 3239278591, 'UA', 'UKR', 'أوكرانيا'),
(47358, 3239278592, 3239279103, 'RU', 'RUS', 'الإتحاد الروسي'),
(47359, 3239279104, 3239280127, 'PL', 'POL', 'بولندا'),
(47360, 3239280128, 3239280639, 'RU', 'RUS', 'الإتحاد الروسي'),
(47361, 3239280640, 3239281663, 'IR', 'IRN', 'إيران'),
(47362, 3239281664, 3239282687, 'UA', 'UKR', 'أوكرانيا'),
(47363, 3239282688, 3239283711, 'FI', 'FIN', 'فنلندا'),
(47364, 3239283712, 3239284735, 'PL', 'POL', 'بولندا'),
(47365, 3239284736, 3239285759, 'UA', 'UKR', 'أوكرانيا'),
(47366, 3239285760, 3239286783, 'KW', 'KWT', 'الكويت'),
(47367, 3239286784, 3239287807, 'UA', 'UKR', 'أوكرانيا'),
(47368, 3239287808, 3239288831, 'GB', 'GBR', 'المملكة المتحدة'),
(47369, 3239288832, 3239289855, 'DE', 'DEU', 'ألمانيا'),
(47370, 3239289856, 3239290879, 'PL', 'POL', 'بولندا'),
(47371, 3239291904, 3239292927, 'BG', 'BGR', 'بلغاريا'),
(47372, 3239292928, 3239293951, 'CZ', 'CZE', 'التشيك'),
(47373, 3239293952, 3239294975, 'DE', 'DEU', 'ألمانيا'),
(47374, 3239294976, 3239295999, 'UA', 'UKR', 'أوكرانيا'),
(47375, 3239296000, 3239297023, 'SA', 'SAU', 'السعودية'),
(47376, 3239297024, 3239298047, 'RO', 'ROM', 'رومانيا'),
(47377, 3239298048, 3239299071, 'GB', 'GBR', 'المملكة المتحدة'),
(47378, 3239299072, 3239301119, 'UA', 'UKR', 'أوكرانيا'),
(47379, 3239301120, 3239302143, 'FR', 'FRA', 'فرنسا'),
(47380, 3239302144, 3239303167, 'PL', 'POL', 'بولندا'),
(47381, 3239303168, 3239304191, 'FR', 'FRA', 'فرنسا'),
(47382, 3239304192, 3239305215, 'SI', 'SVN', 'سلوفينيا'),
(47383, 3239305216, 3239306239, 'NL', 'NLD', 'هولندا'),
(47384, 3239306240, 3239307263, 'UA', 'UKR', 'أوكرانيا'),
(47385, 3239308288, 3239309311, 'DE', 'DEU', 'ألمانيا'),
(47386, 3239309312, 3239311359, 'UA', 'UKR', 'أوكرانيا'),
(47387, 3239311360, 3239312383, 'FR', 'FRA', 'فرنسا'),
(47388, 3239312384, 3239313407, 'UA', 'UKR', 'أوكرانيا'),
(47389, 3239313408, 3239445759, 'DE', 'DEU', 'ألمانيا'),
(47390, 3239445760, 3239446015, 'PL', 'POL', 'بولندا'),
(47391, 3239446016, 3239446271, 'RU', 'RUS', 'الإتحاد الروسي'),
(47392, 3239446272, 3239446527, 'FR', 'FRA', 'فرنسا'),
(47393, 3239446528, 3239451647, 'DE', 'DEU', 'ألمانيا'),
(47394, 3239451904, 3239452159, 'DE', 'DEU', 'ألمانيا'),
(47395, 3239452160, 3239452415, 'CY', 'CYP', 'قبرص'),
(47396, 3239452416, 3239452671, 'HR', 'HRV', 'كرواتيا'),
(47397, 3239452672, 3239464959, 'DE', 'DEU', 'ألمانيا'),
(47398, 3239464960, 3239465215, 'IL', 'ISR', 'إسرائيل'),
(47399, 3239465216, 3239465471, 'HR', 'HRV', 'كرواتيا'),
(47400, 3239465472, 3239465727, 'AT', 'AUT', 'النمسا'),
(47401, 3239465728, 3239465983, 'PL', 'POL', 'بولندا'),
(47402, 3239465984, 3239466239, 'UA', 'UKR', 'أوكرانيا'),
(47403, 3239466240, 3239466495, 'AT', 'AUT', 'النمسا'),
(47404, 3239466496, 3239466751, 'FI', 'FIN', 'فنلندا'),
(47405, 3239466752, 3239467007, 'GB', 'GBR', 'المملكة المتحدة'),
(47406, 3239467008, 3239467263, 'RU', 'RUS', 'الإتحاد الروسي'),
(47407, 3239467264, 3239467519, 'GB', 'GBR', 'المملكة المتحدة'),
(47408, 3239467520, 3239467775, 'IT', 'ITA', 'إيطاليا'),
(47409, 3239467776, 3239468031, 'PL', 'POL', 'بولندا'),
(47410, 3239468032, 3239468287, 'FR', 'FRA', 'فرنسا'),
(47411, 3239468288, 3239468543, 'RO', 'ROM', 'رومانيا'),
(47412, 3239468544, 3239468799, 'NO', 'NOR', 'النرويج'),
(47413, 3239468800, 3239469055, 'RO', 'ROM', 'رومانيا'),
(47414, 3239469056, 3239470591, 'DE', 'DEU', 'ألمانيا'),
(47415, 3239470592, 3239470847, 'CH', 'CHE', 'سويسرا'),
(47416, 3239470848, 3239471103, 'BG', 'BGR', 'بلغاريا'),
(47417, 3239471104, 3239471871, 'DE', 'DEU', 'ألمانيا'),
(47418, 3239471872, 3239472127, 'FR', 'FRA', 'فرنسا'),
(47419, 3239472128, 3239474943, 'DE', 'DEU', 'ألمانيا'),
(47420, 3239474944, 3239475199, 'ES', 'ESP', 'إسبانيا'),
(47421, 3239475200, 3239479295, 'DE', 'DEU', 'ألمانيا'),
(47422, 3239479552, 3239479807, 'DE', 'DEU', 'ألمانيا'),
(47423, 3239479808, 3239480063, 'UA', 'UKR', 'أوكرانيا'),
(47424, 3239480064, 3239480319, 'FR', 'FRA', 'فرنسا'),
(47425, 3239480320, 3239480575, 'UA', 'UKR', 'أوكرانيا'),
(47426, 3239480576, 3239480831, 'RO', 'ROM', 'رومانيا'),
(47427, 3239480832, 3239481087, 'CH', 'CHE', 'سويسرا'),
(47428, 3239481088, 3239481343, 'FR', 'FRA', 'فرنسا'),
(47429, 3239481344, 3239486719, 'DE', 'DEU', 'ألمانيا'),
(47430, 3239486720, 3239486975, 'ES', 'ESP', 'إسبانيا'),
(47431, 3239486976, 3239487487, 'DE', 'DEU', 'ألمانيا'),
(47432, 3239487488, 3239487743, 'GB', 'GBR', 'المملكة المتحدة'),
(47433, 3239487744, 3239487999, 'PL', 'POL', 'بولندا'),
(47434, 3239488000, 3239488255, 'AT', 'AUT', 'النمسا'),
(47435, 3239488256, 3239488511, 'CH', 'CHE', 'سويسرا'),
(47436, 3239488512, 3239488767, 'KW', 'KWT', 'الكويت'),
(47437, 3239488768, 3239489023, 'RO', 'ROM', 'رومانيا'),
(47438, 3239489280, 3239489535, 'PL', 'POL', 'بولندا'),
(47439, 3239489536, 3239501823, 'DE', 'DEU', 'ألمانيا'),
(47440, 3239501824, 3239505919, 'BE', 'BEL', 'بلجيكا'),
(47441, 3239505920, 3239506431, 'DE', 'DEU', 'ألمانيا'),
(47442, 3239506432, 3239506687, 'RU', 'RUS', 'الإتحاد الروسي'),
(47443, 3239506688, 3239507455, 'GB', 'GBR', 'المملكة المتحدة'),
(47444, 3239507456, 3239507967, 'DE', 'DEU', 'ألمانيا'),
(47445, 3239507968, 3239508223, 'BG', 'BGR', 'بلغاريا'),
(47446, 3239508224, 3239508479, 'SA', 'SAU', 'السعودية'),
(47447, 3239508480, 3239508735, 'NO', 'NOR', 'النرويج'),
(47448, 3239508736, 3239508991, 'DE', 'DEU', 'ألمانيا'),
(47449, 3239508992, 3239509247, 'PL', 'POL', 'بولندا'),
(47450, 3239509248, 3239510015, 'DE', 'DEU', 'ألمانيا'),
(47451, 3239510016, 3239510271, 'UA', 'UKR', 'أوكرانيا'),
(47452, 3239510272, 3239522303, 'DE', 'DEU', 'ألمانيا'),
(47453, 3239522304, 3239522559, 'PL', 'POL', 'بولندا'),
(47454, 3239522560, 3239522815, 'SI', 'SVN', 'سلوفينيا'),
(47455, 3239522816, 3239523071, 'LT', 'LTU', 'ليتوانيا'),
(47456, 3239523072, 3239523327, 'PL', 'POL', 'بولندا'),
(47457, 3239523328, 3239523583, 'BG', 'BGR', 'بلغاريا'),
(47458, 3239523584, 3239523839, 'UA', 'UKR', 'أوكرانيا'),
(47459, 3239523840, 3239524095, 'PL', 'POL', 'بولندا'),
(47460, 3239524096, 3239524351, 'SE', 'SWE', 'السويد'),
(47461, 3239524352, 3239524607, 'DE', 'DEU', 'ألمانيا'),
(47462, 3239524608, 3239524863, 'SE', 'SWE', 'السويد'),
(47463, 3239524864, 3239525119, 'UA', 'UKR', 'أوكرانيا'),
(47464, 3239525120, 3239525375, 'LT', 'LTU', 'ليتوانيا'),
(47465, 3239525376, 3239525631, 'UA', 'UKR', 'أوكرانيا'),
(47466, 3239525632, 3239525887, 'PL', 'POL', 'بولندا'),
(47467, 3239525888, 3239526143, 'SI', 'SVN', 'سلوفينيا'),
(47468, 3239526144, 3239526399, 'PL', 'POL', 'بولندا'),
(47469, 3239526400, 3239538687, 'DE', 'DEU', 'ألمانيا'),
(47470, 3239538688, 3239539199, 'NL', 'NLD', 'هولندا'),
(47471, 3239539200, 3239539455, 'IT', 'ITA', 'إيطاليا'),
(47472, 3239539456, 3239539711, 'BE', 'BEL', 'بلجيكا'),
(47473, 3239539712, 3239539967, 'GB', 'GBR', 'المملكة المتحدة'),
(47474, 3239539968, 3239540223, 'SE', 'SWE', 'السويد'),
(47475, 3239540224, 3239540479, 'GR', 'GRC', 'اليونان'),
(47476, 3239540480, 3239540735, 'DE', 'DEU', 'ألمانيا'),
(47477, 3239540736, 3239540991, 'GB', 'GBR', 'المملكة المتحدة'),
(47478, 3239540992, 3239541247, 'FR', 'FRA', 'فرنسا'),
(47479, 3239541248, 3239541503, 'UA', 'UKR', 'أوكرانيا'),
(47480, 3239541504, 3239541759, 'FR', 'FRA', 'فرنسا'),
(47481, 3239541760, 3239542015, 'GB', 'GBR', 'المملكة المتحدة'),
(47482, 3239542016, 3239542271, 'PL', 'POL', 'بولندا'),
(47483, 3239542528, 3239542783, 'FR', 'FRA', 'فرنسا'),
(47484, 3239542784, 3239544831, 'DE', 'DEU', 'ألمانيا'),
(47485, 3239544832, 3239545087, 'GB', 'GBR', 'المملكة المتحدة'),
(47486, 3239545088, 3239545343, 'SI', 'SVN', 'سلوفينيا'),
(47487, 3239545344, 3239545855, 'HU', 'HUN', 'هنغاريا'),
(47488, 3239545856, 3239546111, 'UA', 'UKR', 'أوكرانيا'),
(47489, 3239546112, 3239546367, 'GB', 'GBR', 'المملكة المتحدة'),
(47490, 3239546368, 3239546623, 'RU', 'RUS', 'الإتحاد الروسي'),
(47491, 3239546624, 3239546879, 'NL', 'NLD', 'هولندا'),
(47492, 3239546880, 3239549951, 'DE', 'DEU', 'ألمانيا'),
(47493, 3239549952, 3239550207, 'TR', 'TUR', 'تركيا'),
(47494, 3239550208, 3239550463, 'UA', 'UKR', 'أوكرانيا'),
(47495, 3239550464, 3239550719, 'FR', 'FRA', 'فرنسا'),
(47496, 3239550720, 3239550975, 'NO', 'NOR', 'النرويج'),
(47497, 3239550976, 3239554047, 'DE', 'DEU', 'ألمانيا'),
(47498, 3239554048, 3239554303, 'SE', 'SWE', 'السويد'),
(47499, 3239554304, 3239554559, 'DK', 'DNK', 'الدنيمارك'),
(47500, 3239554560, 3239554815, 'PL', 'POL', 'بولندا'),
(47501, 3239554816, 3239555071, 'UA', 'UKR', 'أوكرانيا'),
(47502, 3239555072, 3239556095, 'DE', 'DEU', 'ألمانيا'),
(47503, 3239556096, 3239556351, 'SA', 'SAU', 'السعودية'),
(47504, 3239556352, 3239556607, 'UA', 'UKR', 'أوكرانيا'),
(47505, 3239556608, 3239556863, 'HR', 'HRV', 'كرواتيا'),
(47506, 3239556864, 3239557119, 'UA', 'UKR', 'أوكرانيا'),
(47507, 3239557120, 3239567359, 'DE', 'DEU', 'ألمانيا'),
(47508, 3239567616, 3239567871, 'UA', 'UKR', 'أوكرانيا'),
(47509, 3239567872, 3239568127, 'DE', 'DEU', 'ألمانيا'),
(47510, 3239568128, 3239568383, 'FR', 'FRA', 'فرنسا'),
(47511, 3239568384, 3239568639, 'SE', 'SWE', 'السويد'),
(47512, 3239568640, 3239568895, 'NO', 'NOR', 'النرويج'),
(47513, 3239568896, 3239575295, 'DE', 'DEU', 'ألمانيا'),
(47514, 3239575296, 3239575551, 'DK', 'DNK', 'الدنيمارك'),
(47515, 3239575552, 3239575807, 'RO', 'ROM', 'رومانيا'),
(47516, 3239575808, 3239578879, 'DE', 'DEU', 'ألمانيا'),
(47517, 3239579136, 3239579391, 'PL', 'POL', 'بولندا'),
(47518, 3239579392, 3239581695, 'DE', 'DEU', 'ألمانيا'),
(47519, 3239581696, 3239581951, 'PL', 'POL', 'بولندا'),
(47520, 3239581952, 3239582207, 'UA', 'UKR', 'أوكرانيا'),
(47521, 3239582208, 3239582463, 'GB', 'GBR', 'المملكة المتحدة'),
(47522, 3239582464, 3239582719, 'DE', 'DEU', 'ألمانيا'),
(47523, 3239582720, 3239582975, 'GB', 'GBR', 'المملكة المتحدة'),
(47524, 3239582976, 3239583231, 'IT', 'ITA', 'إيطاليا'),
(47525, 3239583232, 3239583487, 'UA', 'UKR', 'أوكرانيا'),
(47526, 3239583488, 3239583743, 'RO', 'ROM', 'رومانيا'),
(47527, 3239583744, 3239591935, 'DE', 'DEU', 'ألمانيا'),
(47528, 3239591936, 3239593983, 'FI', 'FIN', 'فنلندا'),
(47529, 3239593984, 3239624703, 'DE', 'DEU', 'ألمانيا'),
(47530, 3239624704, 3239625727, 'CH', 'CHE', 'سويسرا'),
(47531, 3239625728, 3239626751, 'RU', 'RUS', 'الإتحاد الروسي'),
(47532, 3239626752, 3239628799, 'PL', 'POL', 'بولندا'),
(47533, 3239628800, 3239629823, 'DE', 'DEU', 'ألمانيا'),
(47534, 3239629824, 3239630847, 'FR', 'FRA', 'فرنسا'),
(47535, 3239630848, 3239631871, 'DE', 'DEU', 'ألمانيا'),
(47536, 3239631872, 3239632895, 'UA', 'UKR', 'أوكرانيا'),
(47537, 3239632896, 3239633919, 'DE', 'DEU', 'ألمانيا'),
(47538, 3239633920, 3239634943, 'FR', 'FRA', 'فرنسا'),
(47539, 3239634944, 3239635967, 'RU', 'RUS', 'الإتحاد الروسي'),
(47540, 3239635968, 3239636991, 'DE', 'DEU', 'ألمانيا'),
(47541, 3239636992, 3239638015, 'BG', 'BGR', 'بلغاريا'),
(47542, 3239638016, 3239639039, 'PL', 'POL', 'بولندا'),
(47543, 3239639040, 3239640063, 'SI', 'SVN', 'سلوفينيا'),
(47544, 3239640064, 3239641087, 'DE', 'DEU', 'ألمانيا'),
(47545, 3239641088, 3239643135, 'PL', 'POL', 'بولندا'),
(47546, 3239643136, 3239645183, 'RU', 'RUS', 'الإتحاد الروسي'),
(47547, 3239645184, 3239665663, 'DE', 'DEU', 'ألمانيا'),
(47548, 3239665664, 3239666175, 'BE', 'BEL', 'بلجيكا'),
(47549, 3239666176, 3239666687, 'AT', 'AUT', 'النمسا'),
(47550, 3239666688, 3239667199, 'SE', 'SWE', 'السويد'),
(47551, 3239667200, 3239667711, 'CH', 'CHE', 'سويسرا'),
(47552, 3239667712, 3239668223, 'RO', 'ROM', 'رومانيا'),
(47553, 3239668224, 3239668735, 'UA', 'UKR', 'أوكرانيا'),
(47554, 3239668736, 3239669247, 'PL', 'POL', 'بولندا'),
(47555, 3239669248, 3239670271, 'RO', 'ROM', 'رومانيا'),
(47556, 3239670272, 3239670783, 'DE', 'DEU', 'ألمانيا'),
(47557, 3239670784, 3239671295, 'GB', 'GBR', 'المملكة المتحدة'),
(47558, 3239671296, 3239671807, 'DE', 'DEU', 'ألمانيا'),
(47559, 3239672320, 3239672831, 'DE', 'DEU', 'ألمانيا'),
(47560, 3239672832, 3239673343, 'TR', 'TUR', 'تركيا'),
(47561, 3239673344, 3239673855, 'SE', 'SWE', 'السويد'),
(47562, 3239673856, 3239682047, 'DE', 'DEU', 'ألمانيا'),
(47563, 3239682048, 3239682559, 'PL', 'POL', 'بولندا'),
(47564, 3239682560, 3239683071, 'BG', 'BGR', 'بلغاريا'),
(47565, 3239683072, 3239683583, 'PT', 'PRT', 'البورتوغال'),
(47566, 3239683584, 3239684607, 'PL', 'POL', 'بولندا'),
(47567, 3239684608, 3239685119, 'GB', 'GBR', 'المملكة المتحدة'),
(47568, 3239685120, 3239686143, 'DE', 'DEU', 'ألمانيا'),
(47569, 3239686144, 3239686655, 'UA', 'UKR', 'أوكرانيا'),
(47570, 3239686656, 3239687167, 'IT', 'ITA', 'إيطاليا'),
(47571, 3239687168, 3239687679, 'UA', 'UKR', 'أوكرانيا'),
(47572, 3239687680, 3239688191, 'DE', 'DEU', 'ألمانيا'),
(47573, 3239688192, 3239688703, 'PL', 'POL', 'بولندا'),
(47574, 3239688704, 3239689727, 'GB', 'GBR', 'المملكة المتحدة'),
(47575, 3239689728, 3239690239, 'RU', 'RUS', 'الإتحاد الروسي'),
(47576, 3239690240, 3239690495, 'ES', 'ESP', 'إسبانيا'),
(47577, 3239690496, 3239690751, 'PL', 'POL', 'بولندا'),
(47578, 3239690752, 3239691263, 'FR', 'FRA', 'فرنسا'),
(47579, 3239691264, 3239691519, 'IT', 'ITA', 'إيطاليا'),
(47580, 3239691520, 3239691775, 'FR', 'FRA', 'فرنسا'),
(47581, 3239692032, 3239692287, 'AT', 'AUT', 'النمسا'),
(47582, 3239692288, 3239697407, 'DE', 'DEU', 'ألمانيا'),
(47583, 3239697408, 3239697663, 'NL', 'NLD', 'هولندا'),
(47584, 3239697664, 3239697919, 'RU', 'RUS', 'الإتحاد الروسي'),
(47585, 3239697920, 3239698431, 'PL', 'POL', 'بولندا'),
(47586, 3239698432, 3239702527, 'DE', 'DEU', 'ألمانيا'),
(47587, 3239704576, 3239706367, 'DE', 'DEU', 'ألمانيا'),
(47588, 3239706368, 3239706623, 'UA', 'UKR', 'أوكرانيا'),
(47589, 3239706624, 3239706879, 'RU', 'RUS', 'الإتحاد الروسي'),
(47590, 3239706880, 3239707135, 'NL', 'NLD', 'هولندا'),
(47591, 3239707136, 3239707391, 'RU', 'RUS', 'الإتحاد الروسي'),
(47592, 3239707392, 3239707647, 'UA', 'UKR', 'أوكرانيا'),
(47593, 3239707648, 3239707903, 'GB', 'GBR', 'المملكة المتحدة'),
(47594, 3239707904, 3239708159, 'DE', 'DEU', 'ألمانيا'),
(47595, 3239708160, 3239708415, 'SE', 'SWE', 'السويد'),
(47596, 3239708416, 3239708671, 'RO', 'ROM', 'رومانيا'),
(47597, 3239708672, 3239708927, 'AT', 'AUT', 'النمسا'),
(47598, 3239708928, 3239709183, 'NL', 'NLD', 'هولندا'),
(47599, 3239709184, 3239709439, 'RO', 'ROM', 'رومانيا'),
(47600, 3239709440, 3239709695, 'FR', 'FRA', 'فرنسا'),
(47601, 3239709696, 3239709951, 'DE', 'DEU', 'ألمانيا'),
(47602, 3239709952, 3239710207, 'UA', 'UKR', 'أوكرانيا'),
(47603, 3239710208, 3239710463, 'BG', 'BGR', 'بلغاريا'),
(47604, 3239710464, 3239710719, 'DE', 'DEU', 'ألمانيا'),
(47605, 3239710720, 3239710975, 'RU', 'RUS', 'الإتحاد الروسي'),
(47606, 3239710976, 3239711231, 'SE', 'SWE', 'السويد'),
(47607, 3239711232, 3239711487, 'BY', 'BLR', 'روسيا البيضاء'),
(47608, 3239711488, 3239711743, 'FR', 'FRA', 'فرنسا'),
(47609, 3239711744, 3239711999, 'UA', 'UKR', 'أوكرانيا'),
(47610, 3239712000, 3239712255, 'PL', 'POL', 'بولندا'),
(47611, 3239712256, 3239712511, 'DE', 'DEU', 'ألمانيا'),
(47612, 3239712512, 3239712767, 'GB', 'GBR', 'المملكة المتحدة'),
(47613, 3239712768, 3239713023, 'DE', 'DEU', 'ألمانيا'),
(47614, 3239713024, 3239713279, 'PL', 'POL', 'بولندا'),
(47615, 3239713280, 3239713535, 'SI', 'SVN', 'سلوفينيا'),
(47616, 3239713536, 3239713791, 'UA', 'UKR', 'أوكرانيا'),
(47617, 3239713792, 3239714047, 'DE', 'DEU', 'ألمانيا'),
(47618, 3239714048, 3239714303, 'FR', 'FRA', 'فرنسا'),
(47619, 3239714304, 3239714559, 'SE', 'SWE', 'السويد'),
(47620, 3239714560, 3239714815, 'HU', 'HUN', 'هنغاريا'),
(47621, 3239714816, 3239723007, 'DE', 'DEU', 'ألمانيا'),
(47622, 3239723008, 3239731199, 'GB', 'GBR', 'المملكة المتحدة'),
(47623, 3239731200, 3239739391, 'DE', 'DEU', 'ألمانيا'),
(47624, 3239739392, 3239739647, 'IT', 'ITA', 'إيطاليا'),
(47625, 3239739648, 3239739903, 'RO', 'ROM', 'رومانيا'),
(47626, 3239739904, 3239740159, 'CH', 'CHE', 'سويسرا'),
(47627, 3239740160, 3239740415, 'PL', 'POL', 'بولندا'),
(47628, 3239740416, 3239740671, 'DK', 'DNK', 'الدنيمارك'),
(47629, 3239740672, 3239740927, 'GB', 'GBR', 'المملكة المتحدة'),
(47630, 3239740928, 3239741183, 'UA', 'UKR', 'أوكرانيا'),
(47631, 3239741184, 3239741439, 'RU', 'RUS', 'الإتحاد الروسي'),
(47632, 3239741440, 3239759871, 'DE', 'DEU', 'ألمانيا'),
(47633, 3239759872, 3239760127, 'RU', 'RUS', 'الإتحاد الروسي'),
(47634, 3239760128, 3239760383, 'UA', 'UKR', 'أوكرانيا'),
(47635, 3239760384, 3239760895, 'PL', 'POL', 'بولندا'),
(47636, 3239760896, 3239761151, 'RU', 'RUS', 'الإتحاد الروسي'),
(47637, 3239761152, 3239761407, 'GB', 'GBR', 'المملكة المتحدة'),
(47638, 3239761408, 3239761663, 'RU', 'RUS', 'الإتحاد الروسي'),
(47639, 3239761664, 3239761919, 'PL', 'POL', 'بولندا'),
(47640, 3239761920, 3239762175, 'BG', 'BGR', 'بلغاريا'),
(47641, 3239762176, 3239762431, 'CH', 'CHE', 'سويسرا'),
(47642, 3239762432, 3239762687, 'DK', 'DNK', 'الدنيمارك'),
(47643, 3239762688, 3239762943, 'RO', 'ROM', 'رومانيا'),
(47644, 3239762944, 3239763199, 'PL', 'POL', 'بولندا'),
(47645, 3239763200, 3239763455, 'SE', 'SWE', 'السويد'),
(47646, 3239763456, 3239763967, 'GB', 'GBR', 'المملكة المتحدة'),
(47647, 3239763968, 3239772159, 'DE', 'DEU', 'ألمانيا'),
(47648, 3239772160, 3239772415, 'UA', 'UKR', 'أوكرانيا'),
(47649, 3239772416, 3239772671, 'GB', 'GBR', 'المملكة المتحدة'),
(47650, 3239772672, 3239773183, 'DK', 'DNK', 'الدنيمارك'),
(47651, 3239773184, 3239773439, 'FR', 'FRA', 'فرنسا'),
(47652, 3239773440, 3239773951, 'PL', 'POL', 'بولندا'),
(47653, 3239773952, 3239774207, 'SA', 'SAU', 'السعودية'),
(47654, 3239774208, 3239774463, 'PL', 'POL', 'بولندا'),
(47655, 3239774464, 3239774719, 'ES', 'ESP', 'إسبانيا'),
(47656, 3239774720, 3239774975, 'FR', 'FRA', 'فرنسا'),
(47657, 3239774976, 3239775231, 'PT', 'PRT', 'البورتوغال'),
(47658, 3239775232, 3239776255, 'DE', 'DEU', 'ألمانيا'),
(47659, 3239776512, 3239782399, 'DE', 'DEU', 'ألمانيا'),
(47660, 3239782400, 3239782655, 'AT', 'AUT', 'النمسا'),
(47661, 3239782656, 3239782911, 'RU', 'RUS', 'الإتحاد الروسي'),
(47662, 3239782912, 3239783167, 'GB', 'GBR', 'المملكة المتحدة'),
(47663, 3239783168, 3239783423, 'CH', 'CHE', 'سويسرا'),
(47664, 3239783424, 3239783679, 'DK', 'DNK', 'الدنيمارك'),
(47665, 3239783680, 3239783935, 'CH', 'CHE', 'سويسرا'),
(47666, 3239783936, 3239784191, 'DE', 'DEU', 'ألمانيا'),
(47667, 3239784192, 3239784447, 'UA', 'UKR', 'أوكرانيا'),
(47668, 3239784448, 3239788543, 'DE', 'DEU', 'ألمانيا'),
(47669, 3239789056, 3239789567, 'RU', 'RUS', 'الإتحاد الروسي'),
(47670, 3239789568, 3239790079, 'FR', 'FRA', 'فرنسا'),
(47671, 3239790080, 3239791103, 'RO', 'ROM', 'رومانيا'),
(47672, 3239791104, 3239792127, 'CH', 'CHE', 'سويسرا'),
(47673, 3239792128, 3239792639, 'FR', 'FRA', 'فرنسا'),
(47674, 3239792640, 3239793151, 'UA', 'UKR', 'أوكرانيا'),
(47675, 3239793152, 3239793663, 'PL', 'POL', 'بولندا'),
(47676, 3239793664, 3239794175, 'RO', 'ROM', 'رومانيا'),
(47677, 3239794176, 3239794687, 'NL', 'NLD', 'هولندا'),
(47678, 3239794688, 3239795199, 'GB', 'GBR', 'المملكة المتحدة'),
(47679, 3239795200, 3239795711, 'PL', 'POL', 'بولندا'),
(47680, 3239795712, 3239796223, 'IL', 'ISR', 'إسرائيل'),
(47681, 3239796224, 3239796735, 'NO', 'NOR', 'النرويج'),
(47682, 3239796736, 3239821311, 'DE', 'DEU', 'ألمانيا'),
(47683, 3239821312, 3239821823, 'SE', 'SWE', 'السويد'),
(47684, 3239821824, 3239822335, 'FR', 'FRA', 'فرنسا'),
(47685, 3239822336, 3239822847, 'RU', 'RUS', 'الإتحاد الروسي'),
(47686, 3239822848, 3239823359, 'PL', 'POL', 'بولندا'),
(47687, 3239823360, 3239823871, 'SE', 'SWE', 'السويد'),
(47688, 3239823872, 3239824383, 'IT', 'ITA', 'إيطاليا'),
(47689, 3239824384, 3239824895, 'PL', 'POL', 'بولندا'),
(47690, 3239824896, 3239825407, 'UZ', 'UZB', 'أوزباكستان'),
(47691, 3239825408, 3239825919, 'UA', 'UKR', 'أوكرانيا'),
(47692, 3239825920, 3239826431, 'PL', 'POL', 'بولندا'),
(47693, 3239826432, 3239826943, 'GB', 'GBR', 'المملكة المتحدة'),
(47694, 3239826944, 3239827455, 'RU', 'RUS', 'الإتحاد الروسي'),
(47695, 3239827456, 3239827967, 'DK', 'DNK', 'الدنيمارك'),
(47696, 3239827968, 3239828479, 'CH', 'CHE', 'سويسرا'),
(47697, 3239828480, 3239828991, 'DE', 'DEU', 'ألمانيا'),
(47698, 3239828992, 3239830015, 'RU', 'RUS', 'الإتحاد الروسي'),
(47699, 3239830016, 3239830527, 'CH', 'CHE', 'سويسرا'),
(47700, 3239830528, 3239831039, 'SE', 'SWE', 'السويد'),
(47701, 3239831040, 3239832063, 'RU', 'RUS', 'الإتحاد الروسي'),
(47702, 3239832064, 3239832575, 'UA', 'UKR', 'أوكرانيا'),
(47703, 3239832576, 3239834111, 'RU', 'RUS', 'الإتحاد الروسي'),
(47704, 3239834112, 3239834623, 'UA', 'UKR', 'أوكرانيا'),
(47705, 3239834624, 3239835135, 'AT', 'AUT', 'النمسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(47706, 3239835136, 3239836159, 'RU', 'RUS', 'الإتحاد الروسي'),
(47707, 3239836160, 3239836671, 'DK', 'DNK', 'الدنيمارك'),
(47708, 3239836672, 3239837183, 'DE', 'DEU', 'ألمانيا'),
(47709, 3239837184, 3239837695, 'SE', 'SWE', 'السويد'),
(47710, 3239837696, 3239837951, 'PL', 'POL', 'بولندا'),
(47711, 3239837952, 3239839231, 'DE', 'DEU', 'ألمانيا'),
(47712, 3239839232, 3239839487, 'RU', 'RUS', 'الإتحاد الروسي'),
(47713, 3239839488, 3239839743, 'DE', 'DEU', 'ألمانيا'),
(47714, 3239839744, 3239839999, 'SK', 'SVK', 'سلوفاكيا'),
(47715, 3239840000, 3239840511, 'SA', 'SAU', 'السعودية'),
(47716, 3239840512, 3239840767, 'DE', 'DEU', 'ألمانيا'),
(47717, 3239840768, 3239841023, 'AT', 'AUT', 'النمسا'),
(47718, 3239841024, 3239841279, 'NL', 'NLD', 'هولندا'),
(47719, 3239841280, 3239848447, 'DE', 'DEU', 'ألمانيا'),
(47720, 3239848448, 3239848703, 'CH', 'CHE', 'سويسرا'),
(47721, 3239848704, 3239848959, 'SE', 'SWE', 'السويد'),
(47722, 3239848960, 3239849215, 'RU', 'RUS', 'الإتحاد الروسي'),
(47723, 3239849216, 3239849471, 'GB', 'GBR', 'المملكة المتحدة'),
(47724, 3239849472, 3239849727, 'RU', 'RUS', 'الإتحاد الروسي'),
(47725, 3239849728, 3239849983, 'NL', 'NLD', 'هولندا'),
(47726, 3239849984, 3239852287, 'DE', 'DEU', 'ألمانيا'),
(47727, 3239852544, 3239852799, 'DE', 'DEU', 'ألمانيا'),
(47728, 3239853056, 3239859199, 'DE', 'DEU', 'ألمانيا'),
(47729, 3239859200, 3239859455, 'PL', 'POL', 'بولندا'),
(47730, 3239859456, 3239859711, 'UA', 'UKR', 'أوكرانيا'),
(47731, 3239859712, 3239859967, 'HU', 'HUN', 'هنغاريا'),
(47732, 3239859968, 3239860223, 'CA', 'CAN', 'كندا'),
(47733, 3239860224, 3239860479, 'DE', 'DEU', 'ألمانيا'),
(47734, 3239860480, 3239860735, 'GB', 'GBR', 'المملكة المتحدة'),
(47735, 3239860736, 3239861247, 'DE', 'DEU', 'ألمانيا'),
(47736, 3239861248, 3239861503, 'UA', 'UKR', 'أوكرانيا'),
(47737, 3239861504, 3239861759, 'PL', 'POL', 'بولندا'),
(47738, 3239861760, 3239862015, 'SA', 'SAU', 'السعودية'),
(47739, 3239862016, 3239862271, 'IT', 'ITA', 'إيطاليا'),
(47740, 3239862272, 3239874559, 'DE', 'DEU', 'ألمانيا'),
(47741, 3239874560, 3239874815, 'NL', 'NLD', 'هولندا'),
(47742, 3239874816, 3239875071, 'DE', 'DEU', 'ألمانيا'),
(47743, 3239875072, 3239875327, 'SI', 'SVN', 'سلوفينيا'),
(47744, 3239875328, 3239875583, 'DK', 'DNK', 'الدنيمارك'),
(47745, 3239875584, 3239875839, 'PL', 'POL', 'بولندا'),
(47746, 3239875840, 3239876095, 'DK', 'DNK', 'الدنيمارك'),
(47747, 3239876096, 3239876351, 'DE', 'DEU', 'ألمانيا'),
(47748, 3239876352, 3239876607, 'RO', 'ROM', 'رومانيا'),
(47749, 3239876608, 3239876863, 'NL', 'NLD', 'هولندا'),
(47750, 3239876864, 3239877119, 'DE', 'DEU', 'ألمانيا'),
(47751, 3239877120, 3239877375, 'GB', 'GBR', 'المملكة المتحدة'),
(47752, 3239877376, 3239877631, 'IL', 'ISR', 'إسرائيل'),
(47753, 3239877632, 3239877887, 'UA', 'UKR', 'أوكرانيا'),
(47754, 3239877888, 3239878143, 'IT', 'ITA', 'إيطاليا'),
(47755, 3239878144, 3239878399, 'PL', 'POL', 'بولندا'),
(47756, 3239878400, 3239882751, 'DE', 'DEU', 'ألمانيا'),
(47757, 3239882752, 3239883007, 'GB', 'GBR', 'المملكة المتحدة'),
(47758, 3239883008, 3239883263, 'UA', 'UKR', 'أوكرانيا'),
(47759, 3239883264, 3239883775, 'GB', 'GBR', 'المملكة المتحدة'),
(47760, 3239883776, 3239884031, 'DE', 'DEU', 'ألمانيا'),
(47761, 3239884032, 3239884287, 'CH', 'CHE', 'سويسرا'),
(47762, 3239884288, 3239884543, 'GB', 'GBR', 'المملكة المتحدة'),
(47763, 3239884544, 3239884799, 'FR', 'FRA', 'فرنسا'),
(47764, 3239884800, 3239885055, 'UA', 'UKR', 'أوكرانيا'),
(47765, 3239885056, 3239885311, 'CH', 'CHE', 'سويسرا'),
(47766, 3239885312, 3239885567, 'UA', 'UKR', 'أوكرانيا'),
(47767, 3239885568, 3239885823, 'PL', 'POL', 'بولندا'),
(47768, 3239885824, 3239886079, 'CH', 'CHE', 'سويسرا'),
(47769, 3239886080, 3239886335, 'PL', 'POL', 'بولندا'),
(47770, 3239886336, 3239886591, 'RU', 'RUS', 'الإتحاد الروسي'),
(47771, 3239886592, 3239886847, 'FR', 'FRA', 'فرنسا'),
(47772, 3239886848, 3239888895, 'DE', 'DEU', 'ألمانيا'),
(47773, 3239888896, 3239889151, 'UA', 'UKR', 'أوكرانيا'),
(47774, 3239889152, 3239889407, 'GB', 'GBR', 'المملكة المتحدة'),
(47775, 3239889408, 3239889663, 'CZ', 'CZE', 'التشيك'),
(47776, 3239889664, 3239889919, 'FI', 'FIN', 'فنلندا'),
(47777, 3239889920, 3239890175, 'AT', 'AUT', 'النمسا'),
(47778, 3239890176, 3239890431, 'FR', 'FRA', 'فرنسا'),
(47779, 3239890432, 3239890687, 'NL', 'NLD', 'هولندا'),
(47780, 3239890688, 3239895039, 'DE', 'DEU', 'ألمانيا'),
(47781, 3239895040, 3239895295, 'DK', 'DNK', 'الدنيمارك'),
(47782, 3239895296, 3239895551, 'TR', 'TUR', 'تركيا'),
(47783, 3239895552, 3239895807, 'PL', 'POL', 'بولندا'),
(47784, 3239895808, 3239896063, 'DK', 'DNK', 'الدنيمارك'),
(47785, 3239896064, 3239896575, 'DE', 'DEU', 'ألمانيا'),
(47786, 3239896576, 3239896831, 'PL', 'POL', 'بولندا'),
(47787, 3239896832, 3239897087, 'HU', 'HUN', 'هنغاريا'),
(47788, 3239897088, 3239897343, 'GB', 'GBR', 'المملكة المتحدة'),
(47789, 3239897344, 3239897599, 'FR', 'FRA', 'فرنسا'),
(47790, 3239897600, 3239897855, 'RU', 'RUS', 'الإتحاد الروسي'),
(47791, 3239897856, 3239898111, 'FR', 'FRA', 'فرنسا'),
(47792, 3239898112, 3239898367, 'NO', 'NOR', 'النرويج'),
(47793, 3239898368, 3239898623, 'GB', 'GBR', 'المملكة المتحدة'),
(47794, 3239898624, 3239898879, 'DE', 'DEU', 'ألمانيا'),
(47795, 3239898880, 3239899135, 'RU', 'RUS', 'الإتحاد الروسي'),
(47796, 3239899136, 3239901695, 'DE', 'DEU', 'ألمانيا'),
(47797, 3239901696, 3239901951, 'BG', 'BGR', 'بلغاريا'),
(47798, 3239901952, 3239902207, 'DE', 'DEU', 'ألمانيا'),
(47799, 3239902208, 3239902463, 'PL', 'POL', 'بولندا'),
(47800, 3239902464, 3239902719, 'RU', 'RUS', 'الإتحاد الروسي'),
(47801, 3239902720, 3239902975, 'EE', 'EST', 'إستونيا'),
(47802, 3239902976, 3239903231, 'GB', 'GBR', 'المملكة المتحدة'),
(47803, 3239903232, 3239907327, 'DE', 'DEU', 'ألمانيا'),
(47804, 3239907328, 3239907583, 'UA', 'UKR', 'أوكرانيا'),
(47805, 3239907584, 3239913215, 'DE', 'DEU', 'ألمانيا'),
(47806, 3239913216, 3239913471, 'LT', 'LTU', 'ليتوانيا'),
(47807, 3239913472, 3239915519, 'DE', 'DEU', 'ألمانيا'),
(47808, 3239915520, 3239915775, 'PL', 'POL', 'بولندا'),
(47809, 3239915776, 3239916031, 'HU', 'HUN', 'هنغاريا'),
(47810, 3239916032, 3239916287, 'SA', 'SAU', 'السعودية'),
(47811, 3239916288, 3239916543, 'PL', 'POL', 'بولندا'),
(47812, 3239916544, 3239916799, 'FR', 'FRA', 'فرنسا'),
(47813, 3239916800, 3239917055, 'KZ', 'KAZ', 'كازاخستان'),
(47814, 3239917056, 3239917311, 'DE', 'DEU', 'ألمانيا'),
(47815, 3239917312, 3239917567, 'BG', 'BGR', 'بلغاريا'),
(47816, 3239917568, 3239935999, 'DE', 'DEU', 'ألمانيا'),
(47817, 3239936000, 3239936255, 'UA', 'UKR', 'أوكرانيا'),
(47818, 3239936256, 3239936511, 'FR', 'FRA', 'فرنسا'),
(47819, 3239936512, 3239938815, 'DE', 'DEU', 'ألمانيا'),
(47820, 3239938816, 3239939071, 'NL', 'NLD', 'هولندا'),
(47821, 3239939072, 3239950335, 'DE', 'DEU', 'ألمانيا'),
(47822, 3239950848, 3239951103, 'DE', 'DEU', 'ألمانيا'),
(47823, 3239951104, 3239951359, 'AT', 'AUT', 'النمسا'),
(47824, 3239951360, 3239954431, 'DE', 'DEU', 'ألمانيا'),
(47825, 3239954688, 3239954943, 'DK', 'DNK', 'الدنيمارك'),
(47826, 3239954944, 3239955199, 'ES', 'ESP', 'إسبانيا'),
(47827, 3239955200, 3239955711, 'UA', 'UKR', 'أوكرانيا'),
(47828, 3239955712, 3239955967, 'PL', 'POL', 'بولندا'),
(47829, 3239955968, 3239956223, 'CZ', 'CZE', 'التشيك'),
(47830, 3239956224, 3239956479, 'PL', 'POL', 'بولندا'),
(47831, 3239956480, 3239959551, 'DE', 'DEU', 'ألمانيا'),
(47832, 3239959552, 3239959807, 'UA', 'UKR', 'أوكرانيا'),
(47833, 3239959808, 3239960063, 'BE', 'BEL', 'بلجيكا'),
(47834, 3239960064, 3239960319, 'FR', 'FRA', 'فرنسا'),
(47835, 3239960320, 3239960575, 'GB', 'GBR', 'المملكة المتحدة'),
(47836, 3239960576, 3239962111, 'DE', 'DEU', 'ألمانيا'),
(47837, 3239962368, 3239968511, 'DE', 'DEU', 'ألمانيا'),
(47838, 3239968512, 3239968767, 'PL', 'POL', 'بولندا'),
(47839, 3239968768, 3239969023, 'NO', 'NOR', 'النرويج'),
(47840, 3239969024, 3239970047, 'DE', 'DEU', 'ألمانيا'),
(47841, 3239970304, 3239974911, 'DE', 'DEU', 'ألمانيا'),
(47842, 3239974912, 3239975935, 'GB', 'GBR', 'المملكة المتحدة'),
(47843, 3239976960, 3239978751, 'DE', 'DEU', 'ألمانيا'),
(47844, 3239978752, 3239979007, 'RU', 'RUS', 'الإتحاد الروسي'),
(47845, 3239979008, 3239979263, 'UA', 'UKR', 'أوكرانيا'),
(47846, 3239979264, 3239979519, 'GB', 'GBR', 'المملكة المتحدة'),
(47847, 3239979520, 3239979775, 'DE', 'DEU', 'ألمانيا'),
(47848, 3239979776, 3239980031, 'SI', 'SVN', 'سلوفينيا'),
(47849, 3239980032, 3239993087, 'DE', 'DEU', 'ألمانيا'),
(47850, 3239995392, 3239996415, 'DE', 'DEU', 'ألمانيا'),
(47851, 3239996416, 3239996671, 'GB', 'GBR', 'المملكة المتحدة'),
(47852, 3239996672, 3239996927, 'PL', 'POL', 'بولندا'),
(47853, 3239996928, 3239997183, 'BE', 'BEL', 'بلجيكا'),
(47854, 3239997184, 3239997439, 'GB', 'GBR', 'المملكة المتحدة'),
(47855, 3239997440, 3240004863, 'DE', 'DEU', 'ألمانيا'),
(47856, 3240004864, 3240005119, 'FR', 'FRA', 'فرنسا'),
(47857, 3240005120, 3240005375, 'SE', 'SWE', 'السويد'),
(47858, 3240005376, 3240005631, 'NL', 'NLD', 'هولندا'),
(47859, 3240005632, 3240009727, 'DE', 'DEU', 'ألمانيا'),
(47860, 3240009728, 3240009983, 'PL', 'POL', 'بولندا'),
(47861, 3240009984, 3240010239, 'IL', 'ISR', 'إسرائيل'),
(47862, 3240010240, 3240010495, 'GB', 'GBR', 'المملكة المتحدة'),
(47863, 3240010496, 3240010751, 'AT', 'AUT', 'النمسا'),
(47864, 3240010752, 3240011007, 'HU', 'HUN', 'هنغاريا'),
(47865, 3240011008, 3240011263, 'DE', 'DEU', 'ألمانيا'),
(47866, 3240011264, 3240011519, 'GB', 'GBR', 'المملكة المتحدة'),
(47867, 3240011520, 3240011775, 'CH', 'CHE', 'سويسرا'),
(47868, 3240011776, 3240026111, 'DE', 'DEU', 'ألمانيا'),
(47869, 3240026112, 3240027135, 'FR', 'FRA', 'فرنسا'),
(47870, 3240027136, 3240028159, 'BG', 'BGR', 'بلغاريا'),
(47871, 3240028160, 3240029183, 'GB', 'GBR', 'المملكة المتحدة'),
(47872, 3240029184, 3240030207, 'RU', 'RUS', 'الإتحاد الروسي'),
(47873, 3240030208, 3240032255, 'UA', 'UKR', 'أوكرانيا'),
(47874, 3240032256, 3240033279, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(47875, 3240033280, 3240034303, 'DE', 'DEU', 'ألمانيا'),
(47876, 3240034304, 3240034559, 'RU', 'RUS', 'الإتحاد الروسي'),
(47877, 3240034560, 3240035583, 'DE', 'DEU', 'ألمانيا'),
(47878, 3240035840, 3240037375, 'DE', 'DEU', 'ألمانيا'),
(47879, 3240037888, 3240038143, 'AT', 'AUT', 'النمسا'),
(47880, 3240038144, 3240038399, 'DK', 'DNK', 'الدنيمارك'),
(47881, 3240038400, 3240098815, 'DE', 'DEU', 'ألمانيا'),
(47882, 3240098816, 3240099327, 'CH', 'CHE', 'سويسرا'),
(47883, 3240099584, 3240099839, 'DE', 'DEU', 'ألمانيا'),
(47884, 3240099840, 3240102911, 'GB', 'GBR', 'المملكة المتحدة'),
(47885, 3240103936, 3240104703, 'GB', 'GBR', 'المملكة المتحدة'),
(47886, 3240104704, 3240104959, 'NL', 'NLD', 'هولندا'),
(47887, 3240104960, 3240105215, 'RU', 'RUS', 'الإتحاد الروسي'),
(47888, 3240105216, 3240105471, 'UA', 'UKR', 'أوكرانيا'),
(47889, 3240105472, 3240109055, 'GB', 'GBR', 'المملكة المتحدة'),
(47890, 3240109056, 3240109567, 'PL', 'POL', 'بولندا'),
(47891, 3240109568, 3240125439, 'GB', 'GBR', 'المملكة المتحدة'),
(47892, 3240125440, 3240125695, 'RO', 'ROM', 'رومانيا'),
(47893, 3240125696, 3240125951, 'IE', 'IRL', 'إيرلندا'),
(47894, 3240125952, 3240165375, 'GB', 'GBR', 'المملكة المتحدة'),
(47895, 3240165376, 3240165887, 'IT', 'ITA', 'إيطاليا'),
(47896, 3240165888, 3240166399, 'ES', 'ESP', 'إسبانيا'),
(47897, 3240166400, 3240166911, 'PL', 'POL', 'بولندا'),
(47898, 3240166912, 3240167423, 'RO', 'ROM', 'رومانيا'),
(47899, 3240167936, 3240168447, 'RU', 'RUS', 'الإتحاد الروسي'),
(47900, 3240168448, 3240168959, 'FR', 'FRA', 'فرنسا'),
(47901, 3240168960, 3240169471, 'CZ', 'CZE', 'التشيك'),
(47902, 3240169472, 3240169983, 'IL', 'ISR', 'إسرائيل'),
(47903, 3240169984, 3240170495, 'IT', 'ITA', 'إيطاليا'),
(47904, 3240170496, 3240171007, 'DE', 'DEU', 'ألمانيا'),
(47905, 3240171008, 3240171519, 'CZ', 'CZE', 'التشيك'),
(47906, 3240171520, 3240172031, 'RO', 'ROM', 'رومانيا'),
(47907, 3240172032, 3240173055, 'RU', 'RUS', 'الإتحاد الروسي'),
(47908, 3240173056, 3240173567, 'CH', 'CHE', 'سويسرا'),
(47909, 3240173568, 3240174079, 'RO', 'ROM', 'رومانيا'),
(47910, 3240174080, 3240174591, 'PL', 'POL', 'بولندا'),
(47911, 3240174592, 3240175103, 'FR', 'FRA', 'فرنسا'),
(47912, 3240175104, 3240176127, 'RU', 'RUS', 'الإتحاد الروسي'),
(47913, 3240176128, 3240176639, 'PL', 'POL', 'بولندا'),
(47914, 3240176640, 3240177151, 'UA', 'UKR', 'أوكرانيا'),
(47915, 3240177152, 3240177663, 'FR', 'FRA', 'فرنسا'),
(47916, 3240177664, 3240178175, 'UA', 'UKR', 'أوكرانيا'),
(47917, 3240178176, 3240178687, 'NL', 'NLD', 'هولندا'),
(47918, 3240178688, 3240179199, 'BE', 'BEL', 'بلجيكا'),
(47919, 3240179200, 3240179711, 'UA', 'UKR', 'أوكرانيا'),
(47920, 3240179712, 3240180223, 'RO', 'ROM', 'رومانيا'),
(47921, 3240180224, 3240180735, 'PL', 'POL', 'بولندا'),
(47922, 3240180736, 3240181247, 'NL', 'NLD', 'هولندا'),
(47923, 3240181248, 3240181759, 'RU', 'RUS', 'الإتحاد الروسي'),
(47924, 3240181760, 3240182271, 'UA', 'UKR', 'أوكرانيا'),
(47925, 3240182272, 3240182783, 'RO', 'ROM', 'رومانيا'),
(47926, 3240182784, 3240183295, 'RU', 'RUS', 'الإتحاد الروسي'),
(47927, 3240183296, 3240183615, 'NL', 'NLD', 'هولندا'),
(47928, 3240183616, 3240183647, 'CR', 'CRI', 'كوستا ريكا'),
(47929, 3240183648, 3240183807, 'NL', 'NLD', 'هولندا'),
(47930, 3240183808, 3240184319, 'GB', 'GBR', 'المملكة المتحدة'),
(47931, 3240184832, 3240185343, 'GB', 'GBR', 'المملكة المتحدة'),
(47932, 3240185344, 3240185855, 'FR', 'FRA', 'فرنسا'),
(47933, 3240185856, 3240187391, 'RU', 'RUS', 'الإتحاد الروسي'),
(47934, 3240187392, 3240187903, 'UA', 'UKR', 'أوكرانيا'),
(47935, 3240187904, 3240188415, 'RU', 'RUS', 'الإتحاد الروسي'),
(47936, 3240188416, 3240188927, 'RO', 'ROM', 'رومانيا'),
(47937, 3240188928, 3240189439, 'MD', 'MDA', 'مولدوفا'),
(47938, 3240189440, 3240189951, 'RO', 'ROM', 'رومانيا'),
(47939, 3240189952, 3240190463, 'DE', 'DEU', 'ألمانيا'),
(47940, 3240190464, 3240190975, 'IT', 'ITA', 'إيطاليا'),
(47941, 3240190976, 3240191487, 'RU', 'RUS', 'الإتحاد الروسي'),
(47942, 3240191488, 3240191999, 'SE', 'SWE', 'السويد'),
(47943, 3240192000, 3240192511, 'UA', 'UKR', 'أوكرانيا'),
(47944, 3240192512, 3240193023, 'RO', 'ROM', 'رومانيا'),
(47945, 3240193024, 3240193535, 'GB', 'GBR', 'المملكة المتحدة'),
(47946, 3240193536, 3240194047, 'PL', 'POL', 'بولندا'),
(47947, 3240194048, 3240194559, 'GB', 'GBR', 'المملكة المتحدة'),
(47948, 3240194560, 3240195071, 'AT', 'AUT', 'النمسا'),
(47949, 3240195072, 3240195583, 'GB', 'GBR', 'المملكة المتحدة'),
(47950, 3240195584, 3240196095, 'RO', 'ROM', 'رومانيا'),
(47951, 3240196096, 3240197119, 'RU', 'RUS', 'الإتحاد الروسي'),
(47952, 3240197120, 3240197631, 'PL', 'POL', 'بولندا'),
(47953, 3240197632, 3240198143, 'CZ', 'CZE', 'التشيك'),
(47954, 3240198144, 3240198655, 'CH', 'CHE', 'سويسرا'),
(47955, 3240198656, 3240199167, 'RO', 'ROM', 'رومانيا'),
(47956, 3240199168, 3240199679, 'HU', 'HUN', 'هنغاريا'),
(47957, 3240199680, 3240200191, 'NL', 'NLD', 'هولندا'),
(47958, 3240200192, 3240200703, 'RO', 'ROM', 'رومانيا'),
(47959, 3240200704, 3240201215, 'GB', 'GBR', 'المملكة المتحدة'),
(47960, 3240201216, 3240201727, 'RO', 'ROM', 'رومانيا'),
(47961, 3240201728, 3240202239, 'CH', 'CHE', 'سويسرا'),
(47962, 3240202240, 3240202751, 'RU', 'RUS', 'الإتحاد الروسي'),
(47963, 3240202752, 3240203263, 'GB', 'GBR', 'المملكة المتحدة'),
(47964, 3240203264, 3240203775, 'DK', 'DNK', 'الدنيمارك'),
(47965, 3240203776, 3240204287, 'AT', 'AUT', 'النمسا'),
(47966, 3240204288, 3240204799, 'SE', 'SWE', 'السويد'),
(47967, 3240204800, 3240205311, 'RO', 'ROM', 'رومانيا'),
(47968, 3240205312, 3240205823, 'GB', 'GBR', 'المملكة المتحدة'),
(47969, 3240205824, 3240206335, 'DE', 'DEU', 'ألمانيا'),
(47970, 3240206336, 3240206847, 'RU', 'RUS', 'الإتحاد الروسي'),
(47971, 3240206848, 3240207871, 'RO', 'ROM', 'رومانيا'),
(47972, 3240207872, 3240208383, 'CN', 'CHN', 'الصين'),
(47973, 3240208384, 3240208895, 'FR', 'FRA', 'فرنسا'),
(47974, 3240208896, 3240209407, 'GB', 'GBR', 'المملكة المتحدة'),
(47975, 3240209408, 3240209919, 'UA', 'UKR', 'أوكرانيا'),
(47976, 3240209920, 3240210943, 'PL', 'POL', 'بولندا'),
(47977, 3240210944, 3240211455, 'GB', 'GBR', 'المملكة المتحدة'),
(47978, 3240211456, 3240211967, 'NL', 'NLD', 'هولندا'),
(47979, 3240211968, 3240212479, 'BE', 'BEL', 'بلجيكا'),
(47980, 3240212480, 3240212991, 'RU', 'RUS', 'الإتحاد الروسي'),
(47981, 3240212992, 3240213503, 'GB', 'GBR', 'المملكة المتحدة'),
(47982, 3240213504, 3240214015, 'SE', 'SWE', 'السويد'),
(47983, 3240214016, 3240214527, 'DK', 'DNK', 'الدنيمارك'),
(47984, 3240214528, 3240215551, 'RU', 'RUS', 'الإتحاد الروسي'),
(47985, 3240215552, 3240216063, 'UA', 'UKR', 'أوكرانيا'),
(47986, 3240216064, 3240216575, 'GB', 'GBR', 'المملكة المتحدة'),
(47987, 3240216576, 3240217087, 'RO', 'ROM', 'رومانيا'),
(47988, 3240217088, 3240217599, 'UA', 'UKR', 'أوكرانيا'),
(47989, 3240217600, 3240218111, 'RU', 'RUS', 'الإتحاد الروسي'),
(47990, 3240218112, 3240218623, 'UA', 'UKR', 'أوكرانيا'),
(47991, 3240218624, 3240219135, 'NL', 'NLD', 'هولندا'),
(47992, 3240219136, 3240219647, 'AT', 'AUT', 'النمسا'),
(47993, 3240219648, 3240220159, 'UA', 'UKR', 'أوكرانيا'),
(47994, 3240220160, 3240220671, 'NL', 'NLD', 'هولندا'),
(47995, 3240220672, 3240221183, 'AT', 'AUT', 'النمسا'),
(47996, 3240221696, 3240222207, 'NL', 'NLD', 'هولندا'),
(47997, 3240222208, 3240222719, 'FR', 'FRA', 'فرنسا'),
(47998, 3240222720, 3240223231, 'KW', 'KWT', 'الكويت'),
(47999, 3240223232, 3240223743, 'RU', 'RUS', 'الإتحاد الروسي'),
(48000, 3240223744, 3240224255, 'MT', 'MLT', 'مالطا'),
(48001, 3240224256, 3240225279, 'RU', 'RUS', 'الإتحاد الروسي'),
(48002, 3240225280, 3240225791, 'IL', 'ISR', 'إسرائيل'),
(48003, 3240225792, 3240226303, 'UA', 'UKR', 'أوكرانيا'),
(48004, 3240226304, 3240226815, 'CH', 'CHE', 'سويسرا'),
(48005, 3240226816, 3240227839, 'RU', 'RUS', 'الإتحاد الروسي'),
(48006, 3240227840, 3240228351, 'GB', 'GBR', 'المملكة المتحدة'),
(48007, 3240228352, 3240228863, 'SE', 'SWE', 'السويد'),
(48008, 3240228864, 3240229375, 'GB', 'GBR', 'المملكة المتحدة'),
(48009, 3240229376, 3240230399, 'RO', 'ROM', 'رومانيا'),
(48010, 3240230400, 3240230911, 'GB', 'GBR', 'المملكة المتحدة'),
(48011, 3240230912, 3240231935, 'PL', 'POL', 'بولندا'),
(48012, 3240231936, 3240232959, 'NL', 'NLD', 'هولندا'),
(48013, 3240232960, 3240235007, 'RU', 'RUS', 'الإتحاد الروسي'),
(48014, 3240235008, 3240236031, 'FR', 'FRA', 'فرنسا'),
(48015, 3240236032, 3240237055, 'UA', 'UKR', 'أوكرانيا'),
(48016, 3240237056, 3240238079, 'DE', 'DEU', 'ألمانيا'),
(48017, 3240238080, 3240239103, 'GB', 'GBR', 'المملكة المتحدة'),
(48018, 3240239104, 3240240127, 'FR', 'FRA', 'فرنسا'),
(48019, 3240240128, 3240241151, 'US', 'USA', 'الولايات المتحدة'),
(48020, 3240241152, 3240242175, 'FI', 'FIN', 'فنلندا'),
(48021, 3240242176, 3240243199, 'PL', 'POL', 'بولندا'),
(48022, 3240243200, 3240244223, 'DE', 'DEU', 'ألمانيا'),
(48023, 3240244224, 3240245247, 'PL', 'POL', 'بولندا'),
(48024, 3240245248, 3240246271, 'IL', 'ISR', 'إسرائيل'),
(48025, 3240246272, 3240247295, 'UA', 'UKR', 'أوكرانيا'),
(48026, 3240247296, 3240248319, 'RS', 'SRB', 'صربيا'),
(48027, 3240248320, 3240249343, 'DE', 'DEU', 'ألمانيا'),
(48028, 3240249344, 3240251391, 'UA', 'UKR', 'أوكرانيا'),
(48029, 3240251392, 3240252415, 'IE', 'IRL', 'إيرلندا'),
(48030, 3240252416, 3240253439, 'LT', 'LTU', 'ليتوانيا'),
(48031, 3240253440, 3240254463, 'BE', 'BEL', 'بلجيكا'),
(48032, 3240254464, 3240256511, 'UA', 'UKR', 'أوكرانيا'),
(48033, 3240256512, 3240257535, 'DE', 'DEU', 'ألمانيا'),
(48034, 3240257536, 3240258559, 'FO', 'FRO', 'جزر فارو'),
(48035, 3240258560, 3240259583, 'RO', 'ROM', 'رومانيا'),
(48036, 3240259584, 3240260607, 'PL', 'POL', 'بولندا'),
(48037, 3240260608, 3240262655, 'DE', 'DEU', 'ألمانيا'),
(48038, 3240262656, 3240263679, 'RU', 'RUS', 'الإتحاد الروسي'),
(48039, 3240263680, 3240264191, 'UA', 'UKR', 'أوكرانيا'),
(48040, 3240264192, 3240264703, 'FR', 'FRA', 'فرنسا'),
(48041, 3240264704, 3240265215, 'TR', 'TUR', 'تركيا'),
(48042, 3240265728, 3240266239, 'CH', 'CHE', 'سويسرا'),
(48043, 3240266240, 3240266751, 'PL', 'POL', 'بولندا'),
(48044, 3240266752, 3240267263, 'UA', 'UKR', 'أوكرانيا'),
(48045, 3240267264, 3240267775, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(48046, 3240267776, 3240268287, 'DE', 'DEU', 'ألمانيا'),
(48047, 3240268288, 3240269311, 'GB', 'GBR', 'المملكة المتحدة'),
(48048, 3240269312, 3240269823, 'NL', 'NLD', 'هولندا'),
(48049, 3240269824, 3240270335, 'SE', 'SWE', 'السويد'),
(48050, 3240270336, 3240270847, 'UA', 'UKR', 'أوكرانيا'),
(48051, 3240270848, 3240271359, 'RO', 'ROM', 'رومانيا'),
(48052, 3240271360, 3240271871, 'PL', 'POL', 'بولندا'),
(48053, 3240271872, 3240272383, 'RU', 'RUS', 'الإتحاد الروسي'),
(48054, 3240272384, 3240272895, 'PL', 'POL', 'بولندا'),
(48055, 3240272896, 3240273407, 'RU', 'RUS', 'الإتحاد الروسي'),
(48056, 3240273408, 3240273919, 'NL', 'NLD', 'هولندا'),
(48057, 3240273920, 3240274431, 'UA', 'UKR', 'أوكرانيا'),
(48058, 3240274432, 3240274943, 'GB', 'GBR', 'المملكة المتحدة'),
(48059, 3240274944, 3240275455, 'UA', 'UKR', 'أوكرانيا'),
(48060, 3240275456, 3240275967, 'RO', 'ROM', 'رومانيا'),
(48061, 3240275968, 3240276479, 'GR', 'GRC', 'اليونان'),
(48062, 3240276480, 3240276991, 'PL', 'POL', 'بولندا'),
(48063, 3240276992, 3240278015, 'RO', 'ROM', 'رومانيا'),
(48064, 3240278016, 3240278527, 'RU', 'RUS', 'الإتحاد الروسي'),
(48065, 3240278528, 3240279039, 'GB', 'GBR', 'المملكة المتحدة'),
(48066, 3240279040, 3240279551, 'CH', 'CHE', 'سويسرا'),
(48067, 3240279552, 3240280063, 'RO', 'ROM', 'رومانيا'),
(48068, 3240280064, 3240280191, 'DE', 'DEU', 'ألمانيا'),
(48069, 3240280320, 3240280447, 'PL', 'POL', 'بولندا'),
(48070, 3240280448, 3240280575, 'UA', 'UKR', 'أوكرانيا'),
(48071, 3240280576, 3240280703, 'GB', 'GBR', 'المملكة المتحدة'),
(48072, 3240280704, 3240280831, 'RU', 'RUS', 'الإتحاد الروسي'),
(48073, 3240280832, 3240280959, 'GB', 'GBR', 'المملكة المتحدة'),
(48074, 3240280960, 3240281215, 'PL', 'POL', 'بولندا'),
(48075, 3240281216, 3240281343, 'FR', 'FRA', 'فرنسا'),
(48076, 3240281344, 3240281471, 'PL', 'POL', 'بولندا'),
(48077, 3240281472, 3240281599, 'IR', 'IRN', 'إيران'),
(48078, 3240281728, 3240281855, 'PL', 'POL', 'بولندا'),
(48079, 3240282112, 3240282239, 'DE', 'DEU', 'ألمانيا'),
(48080, 3240282240, 3240282367, 'UA', 'UKR', 'أوكرانيا'),
(48081, 3240282368, 3240282495, 'RO', 'ROM', 'رومانيا'),
(48082, 3240282496, 3240282879, 'SE', 'SWE', 'السويد'),
(48083, 3240282880, 3240283007, 'UA', 'UKR', 'أوكرانيا'),
(48084, 3240284160, 3240285183, 'RU', 'RUS', 'الإتحاد الروسي'),
(48085, 3240285184, 3240286207, 'PL', 'POL', 'بولندا'),
(48086, 3240286208, 3240287231, 'UA', 'UKR', 'أوكرانيا'),
(48087, 3240287232, 3240288255, 'PL', 'POL', 'بولندا'),
(48088, 3240288256, 3240296447, 'GB', 'GBR', 'المملكة المتحدة'),
(48089, 3240296448, 3240296703, 'RO', 'ROM', 'رومانيا'),
(48090, 3240296704, 3240302847, 'GB', 'GBR', 'المملكة المتحدة'),
(48091, 3240302848, 3240303103, 'UA', 'UKR', 'أوكرانيا'),
(48092, 3240303104, 3240321023, 'GB', 'GBR', 'المملكة المتحدة'),
(48093, 3240325120, 3240361983, 'GB', 'GBR', 'المملكة المتحدة'),
(48094, 3240361984, 3240362239, 'TR', 'TUR', 'تركيا'),
(48095, 3240362496, 3240370175, 'GB', 'GBR', 'المملكة المتحدة'),
(48096, 3240370176, 3240370431, 'CH', 'CHE', 'سويسرا'),
(48097, 3240370432, 3240370687, 'DE', 'DEU', 'ألمانيا'),
(48098, 3240370688, 3240370943, 'GB', 'GBR', 'المملكة المتحدة'),
(48099, 3240370944, 3240371199, 'RU', 'RUS', 'الإتحاد الروسي'),
(48100, 3240371200, 3240371455, 'CH', 'CHE', 'سويسرا'),
(48101, 3240371456, 3240371711, 'RO', 'ROM', 'رومانيا'),
(48102, 3240371712, 3240371967, 'RU', 'RUS', 'الإتحاد الروسي'),
(48103, 3240371968, 3240372223, 'TR', 'TUR', 'تركيا'),
(48104, 3240372224, 3240372479, 'SI', 'SVN', 'سلوفينيا'),
(48105, 3240372480, 3240372991, 'RU', 'RUS', 'الإتحاد الروسي'),
(48106, 3240372992, 3240373247, 'IE', 'IRL', 'إيرلندا'),
(48107, 3240373248, 3240373503, 'RO', 'ROM', 'رومانيا'),
(48108, 3240373504, 3240373759, 'FR', 'FRA', 'فرنسا'),
(48109, 3240373760, 3240374015, 'DE', 'DEU', 'ألمانيا'),
(48110, 3240374016, 3240407039, 'GB', 'GBR', 'المملكة المتحدة'),
(48111, 3240407040, 3240407295, 'IL', 'ISR', 'إسرائيل'),
(48112, 3240407296, 3240407551, 'NL', 'NLD', 'هولندا'),
(48113, 3240407552, 3240407807, 'NO', 'NOR', 'النرويج'),
(48114, 3240407808, 3240408063, 'NL', 'NLD', 'هولندا'),
(48115, 3240408064, 3240408319, 'DE', 'DEU', 'ألمانيا'),
(48116, 3240408320, 3240408575, 'CH', 'CHE', 'سويسرا'),
(48117, 3240408576, 3240408831, 'FR', 'FRA', 'فرنسا'),
(48118, 3240408832, 3240409087, 'PL', 'POL', 'بولندا'),
(48119, 3240409088, 3240409343, 'TR', 'TUR', 'تركيا'),
(48120, 3240409344, 3240409599, 'GB', 'GBR', 'المملكة المتحدة'),
(48121, 3240409600, 3240409855, 'NL', 'NLD', 'هولندا'),
(48122, 3240409856, 3240410111, 'DE', 'DEU', 'ألمانيا'),
(48123, 3240410112, 3240410367, 'CH', 'CHE', 'سويسرا'),
(48124, 3240410368, 3240410623, 'AT', 'AUT', 'النمسا'),
(48125, 3240410624, 3240410879, 'PT', 'PRT', 'البورتوغال'),
(48126, 3240410880, 3240411135, 'NO', 'NOR', 'النرويج'),
(48127, 3240411136, 3240419839, 'GB', 'GBR', 'المملكة المتحدة'),
(48128, 3240419840, 3240420095, 'AT', 'AUT', 'النمسا'),
(48129, 3240420096, 3240420351, 'DE', 'DEU', 'ألمانيا'),
(48130, 3240420352, 3240420607, 'RO', 'ROM', 'رومانيا'),
(48131, 3240420608, 3240420863, 'NL', 'NLD', 'هولندا'),
(48132, 3240420864, 3240460287, 'GB', 'GBR', 'المملكة المتحدة'),
(48133, 3240460288, 3240461055, 'IL', 'ISR', 'إسرائيل'),
(48134, 3240461056, 3240461567, 'DE', 'DEU', 'ألمانيا'),
(48135, 3240461568, 3240461823, 'UA', 'UKR', 'أوكرانيا'),
(48136, 3240462080, 3240462335, 'TR', 'TUR', 'تركيا'),
(48137, 3240462336, 3240462591, 'RO', 'ROM', 'رومانيا'),
(48138, 3240462592, 3240462847, 'RU', 'RUS', 'الإتحاد الروسي'),
(48139, 3240462848, 3240463103, 'RO', 'ROM', 'رومانيا'),
(48140, 3240463104, 3240463615, 'PL', 'POL', 'بولندا'),
(48141, 3240463616, 3240463871, 'UA', 'UKR', 'أوكرانيا'),
(48142, 3240463872, 3240464127, 'GB', 'GBR', 'المملكة المتحدة'),
(48143, 3240464128, 3240464383, 'SA', 'SAU', 'السعودية'),
(48144, 3240464384, 3240464639, 'AT', 'AUT', 'النمسا'),
(48145, 3240464640, 3240464895, 'FR', 'FRA', 'فرنسا'),
(48146, 3240464896, 3240465151, 'GB', 'GBR', 'المملكة المتحدة'),
(48147, 3240465152, 3240465407, 'CH', 'CHE', 'سويسرا'),
(48148, 3240465408, 3240465919, 'DE', 'DEU', 'ألمانيا'),
(48149, 3240465920, 3240466175, 'FR', 'FRA', 'فرنسا'),
(48150, 3240466176, 3240466687, 'DE', 'DEU', 'ألمانيا'),
(48151, 3240466688, 3240466943, 'PT', 'PRT', 'البورتوغال'),
(48152, 3240466944, 3240467199, 'TR', 'TUR', 'تركيا'),
(48153, 3240467200, 3240467455, 'NL', 'NLD', 'هولندا'),
(48154, 3240467456, 3240467711, 'UA', 'UKR', 'أوكرانيا'),
(48155, 3240467712, 3240467967, 'RU', 'RUS', 'الإتحاد الروسي'),
(48156, 3240467968, 3240468223, 'GB', 'GBR', 'المملكة المتحدة'),
(48157, 3240468224, 3240468479, 'CH', 'CHE', 'سويسرا'),
(48158, 3240468480, 3240487935, 'GB', 'GBR', 'المملكة المتحدة'),
(48159, 3240487936, 3240488191, 'CH', 'CHE', 'سويسرا'),
(48160, 3240488192, 3240488447, 'GB', 'GBR', 'المملكة المتحدة'),
(48161, 3240488448, 3240488703, 'BG', 'BGR', 'بلغاريا'),
(48162, 3240488704, 3240488959, 'NL', 'NLD', 'هولندا'),
(48163, 3240488960, 3240575487, 'GB', 'GBR', 'المملكة المتحدة'),
(48164, 3240575488, 3240575743, 'RO', 'ROM', 'رومانيا'),
(48165, 3240575744, 3240575999, 'GB', 'GBR', 'المملكة المتحدة'),
(48166, 3240576000, 3240576255, 'DE', 'DEU', 'ألمانيا'),
(48167, 3240576256, 3240576511, 'UA', 'UKR', 'أوكرانيا'),
(48168, 3240576512, 3240576767, 'FR', 'FRA', 'فرنسا'),
(48169, 3240576768, 3240577023, 'PL', 'POL', 'بولندا'),
(48170, 3240577024, 3240577279, 'UA', 'UKR', 'أوكرانيا'),
(48171, 3240577280, 3240577535, 'RO', 'ROM', 'رومانيا'),
(48172, 3240577536, 3240577791, 'DE', 'DEU', 'ألمانيا'),
(48173, 3240577792, 3240578559, 'UA', 'UKR', 'أوكرانيا'),
(48174, 3240578816, 3240579071, 'IL', 'ISR', 'إسرائيل'),
(48175, 3240579072, 3240587263, 'GB', 'GBR', 'المملكة المتحدة'),
(48176, 3240587264, 3240587519, 'NL', 'NLD', 'هولندا'),
(48177, 3240587520, 3240587775, 'RU', 'RUS', 'الإتحاد الروسي'),
(48178, 3240587776, 3240588031, 'UA', 'UKR', 'أوكرانيا'),
(48179, 3240588032, 3240588287, 'DE', 'DEU', 'ألمانيا'),
(48180, 3240588288, 3240588543, 'RU', 'RUS', 'الإتحاد الروسي'),
(48181, 3240588544, 3240588799, 'RO', 'ROM', 'رومانيا'),
(48182, 3240588800, 3240589055, 'UA', 'UKR', 'أوكرانيا'),
(48183, 3240589056, 3240589311, 'RO', 'ROM', 'رومانيا'),
(48184, 3240589312, 3240593407, 'SE', 'SWE', 'السويد'),
(48185, 3240593408, 3240594175, 'GB', 'GBR', 'المملكة المتحدة'),
(48186, 3240594176, 3240594431, 'DK', 'DNK', 'الدنيمارك'),
(48187, 3240594432, 3240609791, 'GB', 'GBR', 'المملكة المتحدة'),
(48188, 3240609792, 3240611839, 'DE', 'DEU', 'ألمانيا'),
(48189, 3240611840, 3240622079, 'GB', 'GBR', 'المملكة المتحدة'),
(48190, 3240622080, 3240622591, 'RU', 'RUS', 'الإتحاد الروسي'),
(48191, 3240622592, 3240624127, 'GB', 'GBR', 'المملكة المتحدة'),
(48192, 3240624128, 3240689663, 'EE', 'EST', 'إستونيا'),
(48193, 3240689664, 3240690175, 'GB', 'GBR', 'المملكة المتحدة'),
(48194, 3240690176, 3240690687, 'TR', 'TUR', 'تركيا'),
(48195, 3240690688, 3240691199, 'UA', 'UKR', 'أوكرانيا'),
(48196, 3240691200, 3240691711, 'IT', 'ITA', 'إيطاليا'),
(48197, 3240691712, 3240692735, 'DE', 'DEU', 'ألمانيا'),
(48198, 3240692736, 3240693247, 'DK', 'DNK', 'الدنيمارك'),
(48199, 3240693248, 3240693759, 'ES', 'ESP', 'إسبانيا'),
(48200, 3240693760, 3240695807, 'BE', 'BEL', 'بلجيكا'),
(48201, 3240695808, 3240697855, 'ES', 'ESP', 'إسبانيا'),
(48202, 3240697856, 3240698111, 'SE', 'SWE', 'السويد'),
(48203, 3240698112, 3240698367, 'LV', 'LVA', 'لاتفيا'),
(48204, 3240698368, 3240698623, 'GB', 'GBR', 'المملكة المتحدة'),
(48205, 3240698624, 3240699135, 'SI', 'SVN', 'سلوفينيا'),
(48206, 3240699136, 3240699391, 'DE', 'DEU', 'ألمانيا'),
(48207, 3240699392, 3240699647, 'UA', 'UKR', 'أوكرانيا'),
(48208, 3240699648, 3240699903, 'NO', 'NOR', 'النرويج'),
(48209, 3240699904, 3240700159, 'LT', 'LTU', 'ليتوانيا'),
(48210, 3240700160, 3240700415, 'AT', 'AUT', 'النمسا'),
(48211, 3240700416, 3240700671, 'BE', 'BEL', 'بلجيكا'),
(48212, 3240700672, 3240700927, 'ES', 'ESP', 'إسبانيا'),
(48213, 3240700928, 3240701183, 'FR', 'FRA', 'فرنسا'),
(48214, 3240701184, 3240701439, 'LV', 'LVA', 'لاتفيا'),
(48215, 3240701440, 3240701695, 'ES', 'ESP', 'إسبانيا'),
(48216, 3240701696, 3240701951, 'FR', 'FRA', 'فرنسا'),
(48217, 3240701952, 3240702975, 'UA', 'UKR', 'أوكرانيا'),
(48218, 3240702976, 3240703999, 'DE', 'DEU', 'ألمانيا'),
(48219, 3240704000, 3240705023, 'GR', 'GRC', 'اليونان'),
(48220, 3240705024, 3240706047, 'UA', 'UKR', 'أوكرانيا'),
(48221, 3240706048, 3240707071, 'BG', 'BGR', 'بلغاريا'),
(48222, 3240707072, 3240707839, 'NL', 'NLD', 'هولندا'),
(48223, 3240707840, 3240709119, 'FR', 'FRA', 'فرنسا'),
(48224, 3240709120, 3240710143, 'IT', 'ITA', 'إيطاليا'),
(48225, 3240710144, 3240710399, 'UA', 'UKR', 'أوكرانيا'),
(48226, 3240710400, 3240710655, 'LT', 'LTU', 'ليتوانيا'),
(48227, 3240710656, 3240710911, 'DE', 'DEU', 'ألمانيا'),
(48228, 3240710912, 3240711167, 'FR', 'FRA', 'فرنسا'),
(48229, 3240711168, 3240711679, 'IT', 'ITA', 'إيطاليا'),
(48230, 3240711680, 3240711935, 'RU', 'RUS', 'الإتحاد الروسي'),
(48231, 3240711936, 3240712191, 'DE', 'DEU', 'ألمانيا'),
(48232, 3240712192, 3240712447, 'UA', 'UKR', 'أوكرانيا'),
(48233, 3240712448, 3240712703, 'SI', 'SVN', 'سلوفينيا'),
(48234, 3240712704, 3240712959, 'CH', 'CHE', 'سويسرا'),
(48235, 3240712960, 3240713215, 'IT', 'ITA', 'إيطاليا'),
(48236, 3240713216, 3240713471, 'GB', 'GBR', 'المملكة المتحدة'),
(48237, 3240713472, 3240713727, 'DE', 'DEU', 'ألمانيا'),
(48238, 3240713728, 3240713983, 'AT', 'AUT', 'النمسا'),
(48239, 3240713984, 3240714239, 'FR', 'FRA', 'فرنسا'),
(48240, 3240714240, 3240716287, 'GB', 'GBR', 'المملكة المتحدة'),
(48241, 3240716288, 3240718335, 'CH', 'CHE', 'سويسرا'),
(48242, 3240718336, 3240718847, 'PL', 'POL', 'بولندا'),
(48243, 3240718848, 3240719359, 'PT', 'PRT', 'البورتوغال'),
(48244, 3240719360, 3240719871, 'DE', 'DEU', 'ألمانيا'),
(48245, 3240719872, 3240720383, 'SE', 'SWE', 'السويد'),
(48246, 3240720384, 3240720895, 'DE', 'DEU', 'ألمانيا'),
(48247, 3240720896, 3240721407, 'RO', 'ROM', 'رومانيا'),
(48248, 3240721408, 3240721919, 'DE', 'DEU', 'ألمانيا'),
(48249, 3240721920, 3240722431, 'RO', 'ROM', 'رومانيا'),
(48250, 3240722432, 3240723455, 'UA', 'UKR', 'أوكرانيا'),
(48251, 3240723456, 3240724479, 'DE', 'DEU', 'ألمانيا'),
(48252, 3240724480, 3240724991, 'CH', 'CHE', 'سويسرا'),
(48253, 3240724992, 3240725503, 'AT', 'AUT', 'النمسا'),
(48254, 3240725504, 3240726527, 'RU', 'RUS', 'الإتحاد الروسي'),
(48255, 3240726528, 3240727039, 'DE', 'DEU', 'ألمانيا'),
(48256, 3240727552, 3240728063, 'CH', 'CHE', 'سويسرا'),
(48257, 3240728064, 3240728575, 'GR', 'GRC', 'اليونان'),
(48258, 3240728576, 3240729599, 'GB', 'GBR', 'المملكة المتحدة'),
(48259, 3240729600, 3240730111, 'DK', 'DNK', 'الدنيمارك'),
(48260, 3240730112, 3240730623, 'BE', 'BEL', 'بلجيكا'),
(48261, 3240730624, 3240731647, 'ES', 'ESP', 'إسبانيا'),
(48262, 3240731648, 3240732671, 'GB', 'GBR', 'المملكة المتحدة'),
(48263, 3240732672, 3240733695, 'SE', 'SWE', 'السويد'),
(48264, 3240733696, 3240734719, 'UA', 'UKR', 'أوكرانيا'),
(48265, 3240734720, 3240735743, 'IT', 'ITA', 'إيطاليا'),
(48266, 3240735744, 3240736255, 'FR', 'FRA', 'فرنسا'),
(48267, 3240736256, 3240736767, 'BG', 'BGR', 'بلغاريا'),
(48268, 3240736768, 3240737791, 'UA', 'UKR', 'أوكرانيا'),
(48269, 3240737792, 3240738815, 'BG', 'BGR', 'بلغاريا'),
(48270, 3240738816, 3240739071, 'UA', 'UKR', 'أوكرانيا'),
(48271, 3240739072, 3240739327, 'CH', 'CHE', 'سويسرا'),
(48272, 3240739328, 3240739583, 'FR', 'FRA', 'فرنسا'),
(48273, 3240739584, 3240739839, 'LV', 'LVA', 'لاتفيا'),
(48274, 3240739840, 3240740095, 'US', 'USA', 'الولايات المتحدة'),
(48275, 3240740096, 3240740351, 'LT', 'LTU', 'ليتوانيا'),
(48276, 3240740352, 3240740607, 'IT', 'ITA', 'إيطاليا'),
(48277, 3240740608, 3240741119, 'DE', 'DEU', 'ألمانيا'),
(48278, 3240741120, 3240741375, 'AT', 'AUT', 'النمسا'),
(48279, 3240741376, 3240741631, 'IL', 'ISR', 'إسرائيل'),
(48280, 3240741888, 3240742143, 'LV', 'LVA', 'لاتفيا'),
(48281, 3240742144, 3240742399, 'IT', 'ITA', 'إيطاليا'),
(48282, 3240742656, 3240742911, 'AT', 'AUT', 'النمسا'),
(48283, 3240742912, 3240743423, 'IL', 'ISR', 'إسرائيل'),
(48284, 3240743424, 3240743935, 'DK', 'DNK', 'الدنيمارك'),
(48285, 3240743936, 3240744447, 'DE', 'DEU', 'ألمانيا'),
(48286, 3240744448, 3240744959, 'SE', 'SWE', 'السويد'),
(48287, 3240744960, 3240745471, 'RO', 'ROM', 'رومانيا'),
(48288, 3240745472, 3240745983, 'UA', 'UKR', 'أوكرانيا'),
(48289, 3240745984, 3240746495, 'GB', 'GBR', 'المملكة المتحدة'),
(48290, 3240746496, 3240747007, 'FR', 'FRA', 'فرنسا'),
(48291, 3240747008, 3240747263, 'SE', 'SWE', 'السويد'),
(48292, 3240747520, 3240747775, 'RU', 'RUS', 'الإتحاد الروسي'),
(48293, 3240747776, 3240748031, 'ES', 'ESP', 'إسبانيا'),
(48294, 3240748032, 3240748287, 'AT', 'AUT', 'النمسا'),
(48295, 3240748288, 3240748543, 'GR', 'GRC', 'اليونان'),
(48296, 3240748544, 3240749055, 'PL', 'POL', 'بولندا'),
(48297, 3240749056, 3240749311, 'AT', 'AUT', 'النمسا'),
(48298, 3240749312, 3240749567, 'BE', 'BEL', 'بلجيكا'),
(48299, 3240749568, 3240749823, 'ES', 'ESP', 'إسبانيا'),
(48300, 3240749824, 3240750335, 'IT', 'ITA', 'إيطاليا'),
(48301, 3240750336, 3240750591, 'LU', 'LUX', 'لوكسيمبورغ'),
(48302, 3240750592, 3240750847, 'FR', 'FRA', 'فرنسا'),
(48303, 3240750848, 3240751103, 'UA', 'UKR', 'أوكرانيا'),
(48304, 3240751104, 3240752127, 'ES', 'ESP', 'إسبانيا'),
(48305, 3240752128, 3240754175, 'RO', 'ROM', 'رومانيا'),
(48306, 3240754176, 3240755199, 'DE', 'DEU', 'ألمانيا'),
(48307, 3240755200, 3240755455, 'IE', 'IRL', 'إيرلندا'),
(48308, 3240755456, 3240791551, 'IT', 'ITA', 'إيطاليا'),
(48309, 3240791552, 3240791807, 'RU', 'RUS', 'الإتحاد الروسي'),
(48310, 3240791808, 3240792063, 'ES', 'ESP', 'إسبانيا'),
(48311, 3240792064, 3240792319, 'GB', 'GBR', 'المملكة المتحدة'),
(48312, 3240792320, 3240792575, 'RO', 'ROM', 'رومانيا'),
(48313, 3240792576, 3240792831, 'CH', 'CHE', 'سويسرا'),
(48314, 3240792832, 3240793087, 'PL', 'POL', 'بولندا'),
(48315, 3240793088, 3240793343, 'UA', 'UKR', 'أوكرانيا'),
(48316, 3240793344, 3240793599, 'RU', 'RUS', 'الإتحاد الروسي'),
(48317, 3240793600, 3240794111, 'FR', 'FRA', 'فرنسا'),
(48318, 3240794112, 3240794367, 'GB', 'GBR', 'المملكة المتحدة'),
(48319, 3240794368, 3240794879, 'PL', 'POL', 'بولندا'),
(48320, 3240794880, 3240795135, 'DE', 'DEU', 'ألمانيا'),
(48321, 3240795136, 3240795391, 'BG', 'BGR', 'بلغاريا'),
(48322, 3240795392, 3240795647, 'UA', 'UKR', 'أوكرانيا'),
(48323, 3240795648, 3240795903, 'CH', 'CHE', 'سويسرا'),
(48324, 3240795904, 3240796159, 'SE', 'SWE', 'السويد'),
(48325, 3240796160, 3240808959, 'IT', 'ITA', 'إيطاليا'),
(48326, 3240808960, 3240809215, 'GB', 'GBR', 'المملكة المتحدة'),
(48327, 3240809216, 3240809471, 'PL', 'POL', 'بولندا'),
(48328, 3240809472, 3240809727, 'NL', 'NLD', 'هولندا'),
(48329, 3240809728, 3240809983, 'FR', 'FRA', 'فرنسا'),
(48330, 3240809984, 3240810239, 'GR', 'GRC', 'اليونان'),
(48331, 3240810240, 3240810495, 'SA', 'SAU', 'السعودية'),
(48332, 3240810496, 3240810751, 'TR', 'TUR', 'تركيا'),
(48333, 3240810752, 3240811007, 'GB', 'GBR', 'المملكة المتحدة'),
(48334, 3240811008, 3240811263, 'PL', 'POL', 'بولندا'),
(48335, 3240811264, 3240811519, 'FR', 'FRA', 'فرنسا'),
(48336, 3240811520, 3240811775, 'SA', 'SAU', 'السعودية'),
(48337, 3240811776, 3240812031, 'DE', 'DEU', 'ألمانيا'),
(48338, 3240812032, 3240812287, 'HU', 'HUN', 'هنغاريا'),
(48339, 3240812288, 3240812543, 'KW', 'KWT', 'الكويت'),
(48340, 3240813568, 3240814591, 'PL', 'POL', 'بولندا'),
(48341, 3240814592, 3240818687, 'IT', 'ITA', 'إيطاليا'),
(48342, 3240818688, 3240820735, 'NL', 'NLD', 'هولندا'),
(48343, 3240820800, 3240820831, 'RU', 'RUS', 'الإتحاد الروسي'),
(48344, 3240820832, 3240822783, 'IT', 'ITA', 'إيطاليا'),
(48345, 3240824320, 3240827135, 'IT', 'ITA', 'إيطاليا'),
(48346, 3240827136, 3240827391, 'FR', 'FRA', 'فرنسا'),
(48347, 3240827392, 3240827647, 'BG', 'BGR', 'بلغاريا'),
(48348, 3240827648, 3240827903, 'CH', 'CHE', 'سويسرا'),
(48349, 3240827904, 3240828159, 'IT', 'ITA', 'إيطاليا'),
(48350, 3240828160, 3240828415, 'DE', 'DEU', 'ألمانيا'),
(48351, 3240828416, 3240837119, 'IT', 'ITA', 'إيطاليا'),
(48352, 3240837120, 3240837375, 'GB', 'GBR', 'المملكة المتحدة'),
(48353, 3240837632, 3240840447, 'IT', 'ITA', 'إيطاليا'),
(48354, 3240840448, 3240840703, 'PL', 'POL', 'بولندا'),
(48355, 3240840704, 3240840959, 'RU', 'RUS', 'الإتحاد الروسي'),
(48356, 3240840960, 3240841215, 'GB', 'GBR', 'المملكة المتحدة'),
(48357, 3240841216, 3240843263, 'IT', 'ITA', 'إيطاليا'),
(48358, 3240843264, 3240843775, 'NL', 'NLD', 'هولندا'),
(48359, 3240843776, 3240844031, 'PL', 'POL', 'بولندا'),
(48360, 3240844032, 3240844543, 'NL', 'NLD', 'هولندا'),
(48361, 3240844544, 3240844799, 'CH', 'CHE', 'سويسرا'),
(48362, 3240844800, 3240845055, 'GB', 'GBR', 'المملكة المتحدة'),
(48363, 3240845056, 3240845311, 'UA', 'UKR', 'أوكرانيا'),
(48364, 3240845312, 3240846847, 'IT', 'ITA', 'إيطاليا'),
(48365, 3240846848, 3240847359, 'VA', 'VAT', 'دولة الفاتيكان'),
(48366, 3240847360, 3240852735, 'IT', 'ITA', 'إيطاليا'),
(48367, 3240852736, 3240852991, 'GB', 'GBR', 'المملكة المتحدة'),
(48368, 3240852992, 3240853247, 'IT', 'ITA', 'إيطاليا'),
(48369, 3240853248, 3240853503, 'RU', 'RUS', 'الإتحاد الروسي'),
(48370, 3240853504, 3240854527, 'VA', 'VAT', 'دولة الفاتيكان'),
(48371, 3240854528, 3240855039, 'IT', 'ITA', 'إيطاليا'),
(48372, 3240855040, 3240855295, 'RU', 'RUS', 'الإتحاد الروسي'),
(48373, 3240855296, 3240857599, 'IT', 'ITA', 'إيطاليا'),
(48374, 3240857600, 3240857855, 'PL', 'POL', 'بولندا'),
(48375, 3240857856, 3240858623, 'IT', 'ITA', 'إيطاليا'),
(48376, 3240858880, 3240859135, 'IT', 'ITA', 'إيطاليا'),
(48377, 3240859136, 3240859391, 'NL', 'NLD', 'هولندا'),
(48378, 3240859392, 3240859647, 'SE', 'SWE', 'السويد'),
(48379, 3240859648, 3240861183, 'CH', 'CHE', 'سويسرا'),
(48380, 3240861184, 3240861695, 'AT', 'AUT', 'النمسا'),
(48381, 3240861696, 3240866815, 'IT', 'ITA', 'إيطاليا'),
(48382, 3240866816, 3240867071, 'GB', 'GBR', 'المملكة المتحدة'),
(48383, 3240867072, 3240867327, 'PL', 'POL', 'بولندا'),
(48384, 3240867328, 3240867583, 'RU', 'RUS', 'الإتحاد الروسي'),
(48385, 3240867584, 3240867839, 'CH', 'CHE', 'سويسرا'),
(48386, 3240867840, 3240873983, 'IT', 'ITA', 'إيطاليا'),
(48387, 3240873984, 3240874495, 'RU', 'RUS', 'الإتحاد الروسي'),
(48388, 3240874496, 3240875007, 'FR', 'FRA', 'فرنسا'),
(48389, 3240875008, 3240875519, 'AT', 'AUT', 'النمسا'),
(48390, 3240875520, 3240876031, 'FR', 'FRA', 'فرنسا'),
(48391, 3240876032, 3240876543, 'DK', 'DNK', 'الدنيمارك'),
(48392, 3240876544, 3240877055, 'GR', 'GRC', 'اليونان'),
(48393, 3240877056, 3240877567, 'DE', 'DEU', 'ألمانيا'),
(48394, 3240877568, 3240879103, 'UA', 'UKR', 'أوكرانيا'),
(48395, 3240879104, 3240880127, 'PL', 'POL', 'بولندا'),
(48396, 3240880128, 3240881151, 'RU', 'RUS', 'الإتحاد الروسي'),
(48397, 3240882176, 3240883199, 'PL', 'POL', 'بولندا'),
(48398, 3240883200, 3240884223, 'IL', 'ISR', 'إسرائيل'),
(48399, 3240884224, 3240886271, 'UA', 'UKR', 'أوكرانيا'),
(48400, 3240886272, 3240952071, 'SE', 'SWE', 'السويد'),
(48401, 3240952072, 3240952079, 'IE', 'IRL', 'إيرلندا'),
(48402, 3240952080, 3240952087, 'GB', 'GBR', 'المملكة المتحدة'),
(48403, 3240952088, 3240952095, 'SE', 'SWE', 'السويد'),
(48404, 3240952096, 3240952127, 'US', 'USA', 'الولايات المتحدة'),
(48405, 3240952128, 3240953471, 'SE', 'SWE', 'السويد'),
(48406, 3240953472, 3240953599, 'DE', 'DEU', 'ألمانيا'),
(48407, 3240953600, 3240954495, 'SE', 'SWE', 'السويد'),
(48408, 3240954496, 3240954623, 'DE', 'DEU', 'ألمانيا'),
(48409, 3240954624, 3240955647, 'SE', 'SWE', 'السويد'),
(48410, 3240955648, 3240955903, 'GB', 'GBR', 'المملكة المتحدة'),
(48411, 3240955904, 3240961791, 'SE', 'SWE', 'السويد'),
(48412, 3240961792, 3240961799, 'FI', 'FIN', 'فنلندا'),
(48413, 3240961800, 3240968191, 'SE', 'SWE', 'السويد'),
(48414, 3240968192, 3240968447, 'DE', 'DEU', 'ألمانيا'),
(48415, 3240968448, 3240968703, 'SE', 'SWE', 'السويد'),
(48416, 3240968704, 3240968959, 'GB', 'GBR', 'المملكة المتحدة'),
(48417, 3240968960, 3240969215, 'SE', 'SWE', 'السويد'),
(48418, 3240969216, 3240969231, 'GB', 'GBR', 'المملكة المتحدة'),
(48419, 3240969232, 3240988159, 'SE', 'SWE', 'السويد'),
(48420, 3240988160, 3240988167, 'PL', 'POL', 'بولندا'),
(48421, 3240988168, 3241017343, 'SE', 'SWE', 'السويد'),
(48422, 3241017344, 3241017855, 'AT', 'AUT', 'النمسا'),
(48423, 3241017856, 3241018111, 'DE', 'DEU', 'ألمانيا'),
(48424, 3241018112, 3241029119, 'AT', 'AUT', 'النمسا'),
(48425, 3241029120, 3241029375, 'UA', 'UKR', 'أوكرانيا'),
(48426, 3241029376, 3241029631, 'PL', 'POL', 'بولندا'),
(48427, 3241029632, 3241032703, 'AT', 'AUT', 'النمسا'),
(48428, 3241032704, 3241032959, 'RU', 'RUS', 'الإتحاد الروسي'),
(48429, 3241032960, 3241033215, 'GB', 'GBR', 'المملكة المتحدة'),
(48430, 3241033216, 3241033727, 'DE', 'DEU', 'ألمانيا'),
(48431, 3241033728, 3241033983, 'IL', 'ISR', 'إسرائيل'),
(48432, 3241033984, 3241034239, 'RU', 'RUS', 'الإتحاد الروسي'),
(48433, 3241034240, 3241034495, 'UA', 'UKR', 'أوكرانيا'),
(48434, 3241034496, 3241034751, 'DE', 'DEU', 'ألمانيا'),
(48435, 3241034752, 3241035007, 'PL', 'POL', 'بولندا'),
(48436, 3241035008, 3241035263, 'DK', 'DNK', 'الدنيمارك'),
(48437, 3241035264, 3241035519, 'RO', 'ROM', 'رومانيا'),
(48438, 3241035520, 3241035775, 'SI', 'SVN', 'سلوفينيا'),
(48439, 3241035776, 3241036031, 'GB', 'GBR', 'المملكة المتحدة'),
(48440, 3241036032, 3241036287, 'CH', 'CHE', 'سويسرا'),
(48441, 3241036288, 3241036543, 'RU', 'RUS', 'الإتحاد الروسي'),
(48442, 3241036544, 3241036799, 'SI', 'SVN', 'سلوفينيا'),
(48443, 3241036800, 3241037055, 'GB', 'GBR', 'المملكة المتحدة'),
(48444, 3241037056, 3241037311, 'RU', 'RUS', 'الإتحاد الروسي'),
(48445, 3241037312, 3241037567, 'BE', 'BEL', 'بلجيكا'),
(48446, 3241037568, 3241037823, 'DK', 'DNK', 'الدنيمارك'),
(48447, 3241037824, 3241038079, 'NL', 'NLD', 'هولندا'),
(48448, 3241038080, 3241038335, 'UA', 'UKR', 'أوكرانيا'),
(48449, 3241038336, 3241038591, 'DE', 'DEU', 'ألمانيا'),
(48450, 3241038592, 3241039103, 'LT', 'LTU', 'ليتوانيا'),
(48451, 3241039104, 3241039359, 'FR', 'FRA', 'فرنسا'),
(48452, 3241039360, 3241039615, 'UA', 'UKR', 'أوكرانيا'),
(48453, 3241039616, 3241039871, 'GB', 'GBR', 'المملكة المتحدة'),
(48454, 3241039872, 3241040127, 'CH', 'CHE', 'سويسرا'),
(48455, 3241040128, 3241040383, 'UA', 'UKR', 'أوكرانيا'),
(48456, 3241040384, 3241040639, 'GB', 'GBR', 'المملكة المتحدة'),
(48457, 3241040640, 3241040895, 'RO', 'ROM', 'رومانيا'),
(48458, 3241040896, 3241063423, 'AT', 'AUT', 'النمسا'),
(48459, 3241063424, 3241063679, 'IT', 'ITA', 'إيطاليا'),
(48460, 3241063680, 3241063935, 'PL', 'POL', 'بولندا'),
(48461, 3241063936, 3241064191, 'DE', 'DEU', 'ألمانيا'),
(48462, 3241064192, 3241064447, 'GB', 'GBR', 'المملكة المتحدة'),
(48463, 3241064448, 3241064703, 'DE', 'DEU', 'ألمانيا'),
(48464, 3241064704, 3241065471, 'PL', 'POL', 'بولندا'),
(48465, 3241065472, 3241068543, 'AT', 'AUT', 'النمسا'),
(48466, 3241068544, 3241068799, 'GB', 'GBR', 'المملكة المتحدة'),
(48467, 3241068800, 3241069055, 'UA', 'UKR', 'أوكرانيا'),
(48468, 3241069312, 3241069567, 'FR', 'FRA', 'فرنسا'),
(48469, 3241069568, 3241070079, 'GB', 'GBR', 'المملكة المتحدة'),
(48470, 3241070080, 3241070335, 'FR', 'FRA', 'فرنسا'),
(48471, 3241070336, 3241070847, 'RU', 'RUS', 'الإتحاد الروسي'),
(48472, 3241070848, 3241071103, 'AT', 'AUT', 'النمسا'),
(48473, 3241071104, 3241071359, 'UA', 'UKR', 'أوكرانيا'),
(48474, 3241071360, 3241071615, 'RU', 'RUS', 'الإتحاد الروسي'),
(48475, 3241071616, 3241071871, 'MD', 'MDA', 'مولدوفا'),
(48476, 3241071872, 3241072127, 'RU', 'RUS', 'الإتحاد الروسي'),
(48477, 3241072128, 3241072383, 'BE', 'BEL', 'بلجيكا'),
(48478, 3241072384, 3241072639, 'DE', 'DEU', 'ألمانيا'),
(48479, 3241072640, 3241073919, 'AT', 'AUT', 'النمسا'),
(48480, 3241073920, 3241074175, 'GB', 'GBR', 'المملكة المتحدة'),
(48481, 3241074176, 3241076735, 'AT', 'AUT', 'النمسا'),
(48482, 3241076736, 3241076991, 'GR', 'GRC', 'اليونان'),
(48483, 3241076992, 3241077759, 'AT', 'AUT', 'النمسا'),
(48484, 3241077760, 3241078015, 'LV', 'LVA', 'لاتفيا'),
(48485, 3241078016, 3241078271, 'PL', 'POL', 'بولندا'),
(48486, 3241078272, 3241078527, 'ES', 'ESP', 'إسبانيا'),
(48487, 3241078528, 3241078783, 'DE', 'DEU', 'ألمانيا'),
(48488, 3241078784, 3241082879, 'AT', 'AUT', 'النمسا'),
(48489, 3241082880, 3241083135, 'FR', 'FRA', 'فرنسا'),
(48490, 3241083136, 3241100031, 'CH', 'CHE', 'سويسرا'),
(48491, 3241100800, 3241101055, 'UA', 'UKR', 'أوكرانيا'),
(48492, 3241101056, 3241101311, 'DK', 'DNK', 'الدنيمارك'),
(48493, 3241101312, 3241101567, 'RO', 'ROM', 'رومانيا'),
(48494, 3241101568, 3241101823, 'DE', 'DEU', 'ألمانيا'),
(48495, 3241101824, 3241102079, 'BG', 'BGR', 'بلغاريا'),
(48496, 3241102080, 3241102335, 'RO', 'ROM', 'رومانيا'),
(48497, 3241102336, 3241102591, 'ES', 'ESP', 'إسبانيا'),
(48498, 3241102592, 3241102847, 'DE', 'DEU', 'ألمانيا'),
(48499, 3241102848, 3241103359, 'NL', 'NLD', 'هولندا'),
(48500, 3241103360, 3241103615, 'FR', 'FRA', 'فرنسا'),
(48501, 3241103616, 3241103871, 'DK', 'DNK', 'الدنيمارك'),
(48502, 3241103872, 3241104127, 'DE', 'DEU', 'ألمانيا'),
(48503, 3241104128, 3241104383, 'GB', 'GBR', 'المملكة المتحدة'),
(48504, 3241104384, 3241104639, 'ES', 'ESP', 'إسبانيا'),
(48505, 3241104640, 3241104895, 'UA', 'UKR', 'أوكرانيا'),
(48506, 3241104896, 3241105151, 'ES', 'ESP', 'إسبانيا'),
(48507, 3241105152, 3241105407, 'RU', 'RUS', 'الإتحاد الروسي'),
(48508, 3241105408, 3241108223, 'CH', 'CHE', 'سويسرا'),
(48509, 3241108224, 3241108735, 'DE', 'DEU', 'ألمانيا'),
(48510, 3241108736, 3241108991, 'RO', 'ROM', 'رومانيا'),
(48511, 3241108992, 3241109247, 'SA', 'SAU', 'السعودية'),
(48512, 3241109248, 3241117695, 'CH', 'CHE', 'سويسرا'),
(48513, 3241117696, 3241117951, 'SI', 'SVN', 'سلوفينيا'),
(48514, 3241117952, 3241118207, 'UA', 'UKR', 'أوكرانيا'),
(48515, 3241118208, 3241118463, 'AT', 'AUT', 'النمسا'),
(48516, 3241118464, 3241118719, 'FR', 'FRA', 'فرنسا'),
(48517, 3241118720, 3241118975, 'CH', 'CHE', 'سويسرا'),
(48518, 3241118976, 3241119231, 'FR', 'FRA', 'فرنسا'),
(48519, 3241119488, 3241119743, 'BE', 'BEL', 'بلجيكا'),
(48520, 3241119744, 3241119999, 'RO', 'ROM', 'رومانيا'),
(48521, 3241120000, 3241120255, 'UA', 'UKR', 'أوكرانيا'),
(48522, 3241120256, 3241120511, 'CZ', 'CZE', 'التشيك'),
(48523, 3241120512, 3241120767, 'GB', 'GBR', 'المملكة المتحدة'),
(48524, 3241120768, 3241121023, 'RU', 'RUS', 'الإتحاد الروسي'),
(48525, 3241121024, 3241121279, 'CH', 'CHE', 'سويسرا'),
(48526, 3241121280, 3241121535, 'FR', 'FRA', 'فرنسا'),
(48527, 3241121536, 3241121791, 'PL', 'POL', 'بولندا'),
(48528, 3241121792, 3241122047, 'DE', 'DEU', 'ألمانيا'),
(48529, 3241122048, 3241122303, 'CH', 'CHE', 'سويسرا'),
(48530, 3241122304, 3241122559, 'RU', 'RUS', 'الإتحاد الروسي'),
(48531, 3241122560, 3241123327, 'AT', 'AUT', 'النمسا'),
(48532, 3241123328, 3241124095, 'PL', 'POL', 'بولندا'),
(48533, 3241124096, 3241124351, 'DE', 'DEU', 'ألمانيا'),
(48534, 3241124352, 3241124607, 'RO', 'ROM', 'رومانيا'),
(48535, 3241124608, 3241124863, 'PL', 'POL', 'بولندا'),
(48536, 3241124864, 3241125119, 'ES', 'ESP', 'إسبانيا'),
(48537, 3241125120, 3241125375, 'IL', 'ISR', 'إسرائيل'),
(48538, 3241125376, 3241125631, 'UA', 'UKR', 'أوكرانيا'),
(48539, 3241125632, 3241125887, 'SE', 'SWE', 'السويد'),
(48540, 3241125888, 3241129983, 'CH', 'CHE', 'سويسرا'),
(48541, 3241129984, 3241130239, 'FR', 'FRA', 'فرنسا'),
(48542, 3241130240, 3241130495, 'PT', 'PRT', 'البورتوغال'),
(48543, 3241130496, 3241130751, 'DK', 'DNK', 'الدنيمارك'),
(48544, 3241130752, 3241131007, 'DE', 'DEU', 'ألمانيا'),
(48545, 3241131008, 3241131263, 'NL', 'NLD', 'هولندا'),
(48546, 3241131264, 3241131519, 'FR', 'FRA', 'فرنسا'),
(48547, 3241131520, 3241131775, 'CH', 'CHE', 'سويسرا'),
(48548, 3241131776, 3241132031, 'DK', 'DNK', 'الدنيمارك'),
(48549, 3241132032, 3241145855, 'CH', 'CHE', 'سويسرا'),
(48550, 3241145856, 3241146111, 'HR', 'HRV', 'كرواتيا'),
(48551, 3241146112, 3241146367, 'PL', 'POL', 'بولندا'),
(48552, 3241146368, 3241146623, 'IL', 'ISR', 'إسرائيل'),
(48553, 3241146624, 3241146879, 'RO', 'ROM', 'رومانيا'),
(48554, 3241146880, 3241148415, 'CH', 'CHE', 'سويسرا'),
(48555, 3241148416, 3241476095, 'FR', 'FRA', 'فرنسا'),
(48556, 3241476096, 3241476351, 'CH', 'CHE', 'سويسرا'),
(48557, 3241476352, 3241477887, 'BE', 'BEL', 'بلجيكا'),
(48558, 3241478144, 3241481471, 'BE', 'BEL', 'بلجيكا'),
(48559, 3241481472, 3241481727, 'NL', 'NLD', 'هولندا'),
(48560, 3241481728, 3241481983, 'PT', 'PRT', 'البورتوغال'),
(48561, 3241481984, 3241482239, 'DE', 'DEU', 'ألمانيا'),
(48562, 3241482240, 3241484799, 'SE', 'SWE', 'السويد'),
(48563, 3241484800, 3241485311, 'BE', 'BEL', 'بلجيكا'),
(48564, 3241485312, 3241485567, 'GB', 'GBR', 'المملكة المتحدة'),
(48565, 3241485568, 3241496575, 'BE', 'BEL', 'بلجيكا'),
(48566, 3241496576, 3241496831, 'AT', 'AUT', 'النمسا'),
(48567, 3241496832, 3241497343, 'BE', 'BEL', 'بلجيكا'),
(48568, 3241497344, 3241497599, 'UA', 'UKR', 'أوكرانيا'),
(48569, 3241497600, 3241497855, 'SE', 'SWE', 'السويد'),
(48570, 3241497856, 3241498111, 'DK', 'DNK', 'الدنيمارك'),
(48571, 3241498112, 3241498367, 'BE', 'BEL', 'بلجيكا'),
(48572, 3241498368, 3241498623, 'RO', 'ROM', 'رومانيا'),
(48573, 3241498624, 3241498879, 'NO', 'NOR', 'النرويج'),
(48574, 3241498880, 3241499135, 'UA', 'UKR', 'أوكرانيا'),
(48575, 3241499136, 3241499903, 'BE', 'BEL', 'بلجيكا'),
(48576, 3241499904, 3241500159, 'DE', 'DEU', 'ألمانيا'),
(48577, 3241500160, 3241500671, 'GB', 'GBR', 'المملكة المتحدة'),
(48578, 3241500672, 3241502975, 'BE', 'BEL', 'بلجيكا'),
(48579, 3241502976, 3241503231, 'GR', 'GRC', 'اليونان'),
(48580, 3241503232, 3241503487, 'FR', 'FRA', 'فرنسا'),
(48581, 3241503488, 3241508095, 'BE', 'BEL', 'بلجيكا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(48582, 3241508096, 3241508351, 'NL', 'NLD', 'هولندا'),
(48583, 3241508352, 3241538815, 'BE', 'BEL', 'بلجيكا'),
(48584, 3241539072, 3241541375, 'BE', 'BEL', 'بلجيكا'),
(48585, 3241541376, 3241541631, 'PL', 'POL', 'بولندا'),
(48586, 3241541632, 3241673215, 'FR', 'FRA', 'فرنسا'),
(48587, 3241673472, 3241674751, 'FR', 'FRA', 'فرنسا'),
(48588, 3241675008, 3241681407, 'FR', 'FRA', 'فرنسا'),
(48589, 3241681664, 3241683199, 'FR', 'FRA', 'فرنسا'),
(48590, 3241683456, 3241702399, 'FR', 'FRA', 'فرنسا'),
(48591, 3241702912, 3241704447, 'FR', 'FRA', 'فرنسا'),
(48592, 3241704704, 3241714687, 'FR', 'FRA', 'فرنسا'),
(48593, 3241715200, 3241724927, 'FR', 'FRA', 'فرنسا'),
(48594, 3241725952, 3241726975, 'FR', 'FRA', 'فرنسا'),
(48595, 3241728000, 3241741311, 'FR', 'FRA', 'فرنسا'),
(48596, 3241741568, 3241760767, 'FR', 'FRA', 'فرنسا'),
(48597, 3241761024, 3241780223, 'FR', 'FRA', 'فرنسا'),
(48598, 3241780736, 3241780991, 'FR', 'FRA', 'فرنسا'),
(48599, 3241781248, 3241782527, 'FR', 'FRA', 'فرنسا'),
(48600, 3241783296, 3241784319, 'FR', 'FRA', 'فرنسا'),
(48601, 3241784576, 3241800191, 'FR', 'FRA', 'فرنسا'),
(48602, 3241800448, 3241803775, 'FR', 'FRA', 'فرنسا'),
(48603, 3241803776, 3241803791, 'GB', 'GBR', 'المملكة المتحدة'),
(48604, 3241803800, 3241803815, 'GB', 'GBR', 'المملكة المتحدة'),
(48605, 3241803816, 3241803823, 'RU', 'RUS', 'الإتحاد الروسي'),
(48606, 3241803832, 3241803839, 'GB', 'GBR', 'المملكة المتحدة'),
(48607, 3241803840, 3241803903, 'PT', 'PRT', 'البورتوغال'),
(48608, 3241804032, 3241820159, 'BE', 'BEL', 'بلجيكا'),
(48609, 3241820160, 3241821695, 'GB', 'GBR', 'المملكة المتحدة'),
(48610, 3241821696, 3241822207, 'GR', 'GRC', 'اليونان'),
(48611, 3241822208, 3241824255, 'CZ', 'CZE', 'التشيك'),
(48612, 3241824256, 3241827071, 'BE', 'BEL', 'بلجيكا'),
(48613, 3241827328, 3241843455, 'BE', 'BEL', 'بلجيكا'),
(48614, 3241843456, 3241843711, 'CH', 'CHE', 'سويسرا'),
(48615, 3241843712, 3241848063, 'BE', 'BEL', 'بلجيكا'),
(48616, 3241848064, 3241851391, 'CH', 'CHE', 'سويسرا'),
(48617, 3241851392, 3241851903, 'GR', 'GRC', 'اليونان'),
(48618, 3241851904, 3241852927, 'GB', 'GBR', 'المملكة المتحدة'),
(48619, 3241852928, 3241854463, 'SK', 'SVK', 'سلوفاكيا'),
(48620, 3241854464, 3241854975, 'GB', 'GBR', 'المملكة المتحدة'),
(48621, 3241854976, 3241855999, 'DE', 'DEU', 'ألمانيا'),
(48622, 3241856000, 3241857279, 'NL', 'NLD', 'هولندا'),
(48623, 3241857280, 3241857535, 'CH', 'CHE', 'سويسرا'),
(48624, 3241857536, 3241859071, 'AT', 'AUT', 'النمسا'),
(48625, 3241859072, 3241861119, 'US', 'USA', 'الولايات المتحدة'),
(48626, 3241861120, 3241863167, 'BE', 'BEL', 'بلجيكا'),
(48627, 3241863168, 3241863423, 'PL', 'POL', 'بولندا'),
(48628, 3241863424, 3241863679, 'FR', 'FRA', 'فرنسا'),
(48629, 3241863680, 3241863935, 'GR', 'GRC', 'اليونان'),
(48630, 3241863936, 3241864191, 'GB', 'GBR', 'المملكة المتحدة'),
(48631, 3241864192, 3241864447, 'TR', 'TUR', 'تركيا'),
(48632, 3241864448, 3241864703, 'RU', 'RUS', 'الإتحاد الروسي'),
(48633, 3241864704, 3241864959, 'SE', 'SWE', 'السويد'),
(48634, 3241864960, 3241865215, 'IT', 'ITA', 'إيطاليا'),
(48635, 3241865216, 3241865471, 'DE', 'DEU', 'ألمانيا'),
(48636, 3241865472, 3241865727, 'NO', 'NOR', 'النرويج'),
(48637, 3241865728, 3241865983, 'CH', 'CHE', 'سويسرا'),
(48638, 3241865984, 3241866239, 'RO', 'ROM', 'رومانيا'),
(48639, 3241866240, 3241866751, 'DE', 'DEU', 'ألمانيا'),
(48640, 3241866752, 3241867007, 'GB', 'GBR', 'المملكة المتحدة'),
(48641, 3241867008, 3241867263, 'FR', 'FRA', 'فرنسا'),
(48642, 3241867264, 3241867519, 'UA', 'UKR', 'أوكرانيا'),
(48643, 3241867520, 3241867775, 'PL', 'POL', 'بولندا'),
(48644, 3241867776, 3241868031, 'CH', 'CHE', 'سويسرا'),
(48645, 3241868288, 3241868543, 'HR', 'HRV', 'كرواتيا'),
(48646, 3241868544, 3241868799, 'DE', 'DEU', 'ألمانيا'),
(48647, 3241868800, 3241869055, 'UA', 'UKR', 'أوكرانيا'),
(48648, 3241869056, 3241869311, 'BY', 'BLR', 'روسيا البيضاء'),
(48649, 3241869312, 3241934847, 'PL', 'POL', 'بولندا'),
(48650, 3241934848, 3242196991, 'GB', 'GBR', 'المملكة المتحدة'),
(48651, 3242196992, 3242393599, 'FI', 'FIN', 'فنلندا'),
(48652, 3242393600, 3242459135, 'NL', 'NLD', 'هولندا'),
(48653, 3242459136, 3242467327, 'BG', 'BGR', 'بلغاريا'),
(48654, 3242467328, 3242475519, 'HU', 'HUN', 'هنغاريا'),
(48655, 3242475520, 3242483711, 'LV', 'LVA', 'لاتفيا'),
(48656, 3242483712, 3242524671, 'BG', 'BGR', 'بلغاريا'),
(48657, 3242524672, 3242590207, 'NO', 'NOR', 'النرويج'),
(48658, 3242590208, 3242655743, 'IT', 'ITA', 'إيطاليا'),
(48659, 3242655744, 3242721279, 'NO', 'NOR', 'النرويج'),
(48660, 3242721280, 3242852351, 'CH', 'CHE', 'سويسرا'),
(48661, 3242852352, 3242911231, 'BE', 'BEL', 'بلجيكا'),
(48662, 3242911232, 3242911743, 'NL', 'NLD', 'هولندا'),
(48663, 3242911744, 3242917887, 'BE', 'BEL', 'بلجيكا'),
(48664, 3242917888, 3242950655, 'NO', 'NOR', 'النرويج'),
(48665, 3242950656, 3242983423, 'BE', 'BEL', 'بلجيكا'),
(48666, 3242983424, 3243048959, 'IT', 'ITA', 'إيطاليا'),
(48667, 3243048960, 3243114495, 'SI', 'SVN', 'سلوفينيا'),
(48668, 3243114496, 3243150847, 'NL', 'NLD', 'هولندا'),
(48669, 3243150848, 3243151103, 'IT', 'ITA', 'إيطاليا'),
(48670, 3243151104, 3243216823, 'NL', 'NLD', 'هولندا'),
(48671, 3243216824, 3243216831, 'GB', 'GBR', 'المملكة المتحدة'),
(48672, 3243216832, 3243223615, 'NL', 'NLD', 'هولندا'),
(48673, 3243223616, 3243223623, 'NO', 'NOR', 'النرويج'),
(48674, 3243223624, 3243223695, 'NL', 'NLD', 'هولندا'),
(48675, 3243223696, 3243223703, 'PT', 'PRT', 'البورتوغال'),
(48676, 3243223704, 3243245567, 'NL', 'NLD', 'هولندا'),
(48677, 3243245568, 3243297791, 'AT', 'AUT', 'النمسا'),
(48678, 3243297792, 3243298047, 'SI', 'SVN', 'سلوفينيا'),
(48679, 3243298048, 3243376639, 'AT', 'AUT', 'النمسا'),
(48680, 3243376640, 3243441919, 'GB', 'GBR', 'المملكة المتحدة'),
(48681, 3243441920, 3243442175, 'MT', 'MLT', 'مالطا'),
(48682, 3243442176, 3243444167, 'AT', 'AUT', 'النمسا'),
(48683, 3243444168, 3243444183, 'NL', 'NLD', 'هولندا'),
(48684, 3243444184, 3243507711, 'AT', 'AUT', 'النمسا'),
(48685, 3243507712, 3243507967, 'GB', 'GBR', 'المملكة المتحدة'),
(48686, 3243508224, 3243508991, 'CZ', 'CZE', 'التشيك'),
(48687, 3243509248, 3243509759, 'CZ', 'CZE', 'التشيك'),
(48688, 3243509760, 3243510015, 'RU', 'RUS', 'الإتحاد الروسي'),
(48689, 3243510016, 3243510271, 'NL', 'NLD', 'هولندا'),
(48690, 3243510272, 3243510527, 'CZ', 'CZE', 'التشيك'),
(48691, 3243510784, 3243511807, 'CZ', 'CZE', 'التشيك'),
(48692, 3243511808, 3243512063, 'GB', 'GBR', 'المملكة المتحدة'),
(48693, 3243512064, 3243512319, 'UA', 'UKR', 'أوكرانيا'),
(48694, 3243512320, 3243512575, 'FR', 'FRA', 'فرنسا'),
(48695, 3243512576, 3243512831, 'UA', 'UKR', 'أوكرانيا'),
(48696, 3243512832, 3243513087, 'DE', 'DEU', 'ألمانيا'),
(48697, 3243513088, 3243513343, 'GR', 'GRC', 'اليونان'),
(48698, 3243513344, 3243513855, 'UA', 'UKR', 'أوكرانيا'),
(48699, 3243513856, 3243514111, 'BE', 'BEL', 'بلجيكا'),
(48700, 3243514112, 3243514367, 'CH', 'CHE', 'سويسرا'),
(48701, 3243514368, 3243514623, 'IE', 'IRL', 'إيرلندا'),
(48702, 3243514624, 3243514879, 'DK', 'DNK', 'الدنيمارك'),
(48703, 3243514880, 3243515135, 'AT', 'AUT', 'النمسا'),
(48704, 3243515136, 3243515391, 'PL', 'POL', 'بولندا'),
(48705, 3243515392, 3243515647, 'DE', 'DEU', 'ألمانيا'),
(48706, 3243515648, 3243515903, 'RU', 'RUS', 'الإتحاد الروسي'),
(48707, 3243515904, 3243519999, 'CZ', 'CZE', 'التشيك'),
(48708, 3243520512, 3243520767, 'UA', 'UKR', 'أوكرانيا'),
(48709, 3243520768, 3243521023, 'GB', 'GBR', 'المملكة المتحدة'),
(48710, 3243521024, 3243521279, 'AT', 'AUT', 'النمسا'),
(48711, 3243521280, 3243521535, 'CZ', 'CZE', 'التشيك'),
(48712, 3243521536, 3243521791, 'DE', 'DEU', 'ألمانيا'),
(48713, 3243521792, 3243524095, 'CZ', 'CZE', 'التشيك'),
(48714, 3243524096, 3243524351, 'RO', 'ROM', 'رومانيا'),
(48715, 3243524352, 3243524607, 'AT', 'AUT', 'النمسا'),
(48716, 3243524608, 3243524863, 'DE', 'DEU', 'ألمانيا'),
(48717, 3243524864, 3243525119, 'NL', 'NLD', 'هولندا'),
(48718, 3243525120, 3243525375, 'CZ', 'CZE', 'التشيك'),
(48719, 3243525376, 3243525631, 'RO', 'ROM', 'رومانيا'),
(48720, 3243525888, 3243526143, 'PL', 'POL', 'بولندا'),
(48721, 3243526144, 3243526399, 'UA', 'UKR', 'أوكرانيا'),
(48722, 3243526400, 3243526655, 'FR', 'FRA', 'فرنسا'),
(48723, 3243526656, 3243526911, 'PL', 'POL', 'بولندا'),
(48724, 3243526912, 3243527167, 'SE', 'SWE', 'السويد'),
(48725, 3243527168, 3243527679, 'UA', 'UKR', 'أوكرانيا'),
(48726, 3243527680, 3243527935, 'GB', 'GBR', 'المملكة المتحدة'),
(48727, 3243527936, 3243528191, 'PL', 'POL', 'بولندا'),
(48728, 3243528192, 3243529215, 'CZ', 'CZE', 'التشيك'),
(48729, 3243529216, 3243529471, 'BE', 'BEL', 'بلجيكا'),
(48730, 3243529472, 3243529727, 'GB', 'GBR', 'المملكة المتحدة'),
(48731, 3243529728, 3243529983, 'BG', 'BGR', 'بلغاريا'),
(48732, 3243529984, 3243530239, 'GB', 'GBR', 'المملكة المتحدة'),
(48733, 3243530240, 3243530495, 'RU', 'RUS', 'الإتحاد الروسي'),
(48734, 3243530496, 3243530751, 'FR', 'FRA', 'فرنسا'),
(48735, 3243530752, 3243531007, 'UA', 'UKR', 'أوكرانيا'),
(48736, 3243531008, 3243531263, 'DE', 'DEU', 'ألمانيا'),
(48737, 3243531776, 3243532031, 'AT', 'AUT', 'النمسا'),
(48738, 3243532032, 3243532287, 'DE', 'DEU', 'ألمانيا'),
(48739, 3243532288, 3243533311, 'CZ', 'CZE', 'التشيك'),
(48740, 3243534336, 3243535359, 'CZ', 'CZE', 'التشيك'),
(48741, 3243536384, 3243536639, 'AT', 'AUT', 'النمسا'),
(48742, 3243536640, 3243536895, 'CH', 'CHE', 'سويسرا'),
(48743, 3243536896, 3243537151, 'CZ', 'CZE', 'التشيك'),
(48744, 3243537152, 3243537407, 'RO', 'ROM', 'رومانيا'),
(48745, 3243537408, 3243540991, 'CZ', 'CZE', 'التشيك'),
(48746, 3243542528, 3243543551, 'CZ', 'CZE', 'التشيك'),
(48747, 3243544064, 3243544319, 'GB', 'GBR', 'المملكة المتحدة'),
(48748, 3243544320, 3243544575, 'CH', 'CHE', 'سويسرا'),
(48749, 3243544576, 3243552767, 'CZ', 'CZE', 'التشيك'),
(48750, 3243552768, 3243553023, 'NL', 'NLD', 'هولندا'),
(48751, 3243553024, 3243553279, 'FR', 'FRA', 'فرنسا'),
(48752, 3243553280, 3243553535, 'DE', 'DEU', 'ألمانيا'),
(48753, 3243553536, 3243553791, 'PL', 'POL', 'بولندا'),
(48754, 3243553792, 3243554303, 'DE', 'DEU', 'ألمانيا'),
(48755, 3243554304, 3243554559, 'PL', 'POL', 'بولندا'),
(48756, 3243554560, 3243554815, 'MD', 'MDA', 'مولدوفا'),
(48757, 3243554816, 3243555071, 'LV', 'LVA', 'لاتفيا'),
(48758, 3243555072, 3243555327, 'RO', 'ROM', 'رومانيا'),
(48759, 3243555328, 3243555583, 'CZ', 'CZE', 'التشيك'),
(48760, 3243555584, 3243555839, 'FR', 'FRA', 'فرنسا'),
(48761, 3243556864, 3243565055, 'CZ', 'CZE', 'التشيك'),
(48762, 3243565056, 3243569151, 'GB', 'GBR', 'المملكة المتحدة'),
(48763, 3243570432, 3243570687, 'CZ', 'CZE', 'التشيك'),
(48764, 3243570688, 3243570943, 'PL', 'POL', 'بولندا'),
(48765, 3243570944, 3243571199, 'CZ', 'CZE', 'التشيك'),
(48766, 3243571456, 3243571711, 'CZ', 'CZE', 'التشيك'),
(48767, 3243571712, 3243571967, 'GB', 'GBR', 'المملكة المتحدة'),
(48768, 3243571968, 3243572223, 'GR', 'GRC', 'اليونان'),
(48769, 3243572224, 3243572479, 'CZ', 'CZE', 'التشيك'),
(48770, 3243572736, 3243572991, 'CZ', 'CZE', 'التشيك'),
(48771, 3243572992, 3243573247, 'RU', 'RUS', 'الإتحاد الروسي'),
(48772, 3243573248, 3243704319, 'CZ', 'CZE', 'التشيك'),
(48773, 3243704320, 3243769855, 'SK', 'SVK', 'سلوفاكيا'),
(48774, 3243769856, 3243900927, 'DK', 'DNK', 'الدنيمارك'),
(48775, 3243900928, 3243966463, 'NO', 'NOR', 'النرويج'),
(48776, 3243966464, 3243974655, 'PL', 'POL', 'بولندا'),
(48777, 3243974656, 3243978751, 'LU', 'LUX', 'لوكسيمبورغ'),
(48778, 3243978752, 3243982847, 'NL', 'NLD', 'هولندا'),
(48779, 3243982848, 3243991039, 'HU', 'HUN', 'هنغاريا'),
(48780, 3243991040, 3243999231, 'BE', 'BEL', 'بلجيكا'),
(48781, 3243999232, 3244031999, 'NO', 'NOR', 'النرويج'),
(48782, 3244032000, 3244097535, 'GR', 'GRC', 'اليونان'),
(48783, 3244097536, 3244098559, 'DE', 'DEU', 'ألمانيا'),
(48784, 3244098560, 3244099583, 'GB', 'GBR', 'المملكة المتحدة'),
(48785, 3244099584, 3244100607, 'FR', 'FRA', 'فرنسا'),
(48786, 3244100608, 3244102655, 'UA', 'UKR', 'أوكرانيا'),
(48787, 3244102656, 3244103679, 'CH', 'CHE', 'سويسرا'),
(48788, 3244103680, 3244104703, 'BG', 'BGR', 'بلغاريا'),
(48789, 3244104704, 3244105727, 'DE', 'DEU', 'ألمانيا'),
(48790, 3244105728, 3244107775, 'GB', 'GBR', 'المملكة المتحدة'),
(48791, 3244107776, 3244108799, 'RO', 'ROM', 'رومانيا'),
(48792, 3244108800, 3244109823, 'GB', 'GBR', 'المملكة المتحدة'),
(48793, 3244109824, 3244111871, 'UA', 'UKR', 'أوكرانيا'),
(48794, 3244111872, 3244112895, 'KZ', 'KAZ', 'كازاخستان'),
(48795, 3244112896, 3244113919, 'RU', 'RUS', 'الإتحاد الروسي'),
(48796, 3244113920, 3244114943, 'CH', 'CHE', 'سويسرا'),
(48797, 3244114944, 3244115967, 'PL', 'POL', 'بولندا'),
(48798, 3244115968, 3244116991, 'SK', 'SVK', 'سلوفاكيا'),
(48799, 3244116992, 3244118015, 'UA', 'UKR', 'أوكرانيا'),
(48800, 3244118016, 3244120063, 'GB', 'GBR', 'المملكة المتحدة'),
(48801, 3244120064, 3244122111, 'PL', 'POL', 'بولندا'),
(48802, 3244123136, 3244124159, 'UA', 'UKR', 'أوكرانيا'),
(48803, 3244124160, 3244125183, 'PL', 'POL', 'بولندا'),
(48804, 3244125184, 3244126207, 'UA', 'UKR', 'أوكرانيا'),
(48805, 3244126208, 3244127231, 'BE', 'BEL', 'بلجيكا'),
(48806, 3244127232, 3244128255, 'UA', 'UKR', 'أوكرانيا'),
(48807, 3244128256, 3244129279, 'RU', 'RUS', 'الإتحاد الروسي'),
(48808, 3244129280, 3244130303, 'FR', 'FRA', 'فرنسا'),
(48809, 3244130304, 3244131327, 'NO', 'NOR', 'النرويج'),
(48810, 3244131328, 3244133375, 'FI', 'FIN', 'فنلندا'),
(48811, 3244133376, 3244134399, 'RO', 'ROM', 'رومانيا'),
(48812, 3244134400, 3244135423, 'PL', 'POL', 'بولندا'),
(48813, 3244135424, 3244137471, 'GB', 'GBR', 'المملكة المتحدة'),
(48814, 3244137472, 3244138495, 'PL', 'POL', 'بولندا'),
(48815, 3244138496, 3244139519, 'UA', 'UKR', 'أوكرانيا'),
(48816, 3244139520, 3244140543, 'GR', 'GRC', 'اليونان'),
(48817, 3244140544, 3244141567, 'UA', 'UKR', 'أوكرانيا'),
(48818, 3244141568, 3244142591, 'NL', 'NLD', 'هولندا'),
(48819, 3244142592, 3244143615, 'DE', 'DEU', 'ألمانيا'),
(48820, 3244143616, 3244144639, 'FR', 'FRA', 'فرنسا'),
(48821, 3244144640, 3244146687, 'UA', 'UKR', 'أوكرانيا'),
(48822, 3244146688, 3244147711, 'RU', 'RUS', 'الإتحاد الروسي'),
(48823, 3244147712, 3244149759, 'GB', 'GBR', 'المملكة المتحدة'),
(48824, 3244149760, 3244150783, 'PL', 'POL', 'بولندا'),
(48825, 3244150784, 3244151807, 'CH', 'CHE', 'سويسرا'),
(48826, 3244151808, 3244152831, 'KZ', 'KAZ', 'كازاخستان'),
(48827, 3244152832, 3244153855, 'UA', 'UKR', 'أوكرانيا'),
(48828, 3244153856, 3244154879, 'NO', 'NOR', 'النرويج'),
(48829, 3244154880, 3244155903, 'GB', 'GBR', 'المملكة المتحدة'),
(48830, 3244155904, 3244156927, 'UA', 'UKR', 'أوكرانيا'),
(48831, 3244156928, 3244158975, 'RU', 'RUS', 'الإتحاد الروسي'),
(48832, 3244158976, 3244159999, 'DE', 'DEU', 'ألمانيا'),
(48833, 3244160000, 3244161023, 'RU', 'RUS', 'الإتحاد الروسي'),
(48834, 3244161024, 3244163071, 'NO', 'NOR', 'النرويج'),
(48835, 3244163072, 3244228607, 'FI', 'FIN', 'فنلندا'),
(48836, 3244261376, 3244265823, 'IE', 'IRL', 'إيرلندا'),
(48837, 3244265824, 3244265831, 'ES', 'ESP', 'إسبانيا'),
(48838, 3244265832, 3244272575, 'IE', 'IRL', 'إيرلندا'),
(48839, 3244272576, 3244272639, 'US', 'USA', 'الولايات المتحدة'),
(48840, 3244272640, 3244273687, 'IE', 'IRL', 'إيرلندا'),
(48841, 3244273688, 3244273695, 'US', 'USA', 'الولايات المتحدة'),
(48842, 3244273696, 3244273727, 'IE', 'IRL', 'إيرلندا'),
(48843, 3244273728, 3244273735, 'GB', 'GBR', 'المملكة المتحدة'),
(48844, 3244273736, 3244274215, 'IE', 'IRL', 'إيرلندا'),
(48845, 3244274216, 3244274223, 'GB', 'GBR', 'المملكة المتحدة'),
(48846, 3244274224, 3244274279, 'IE', 'IRL', 'إيرلندا'),
(48847, 3244274280, 3244274287, 'US', 'USA', 'الولايات المتحدة'),
(48848, 3244274288, 3244277359, 'IE', 'IRL', 'إيرلندا'),
(48849, 3244277360, 3244277367, 'GB', 'GBR', 'المملكة المتحدة'),
(48850, 3244277368, 3244277631, 'IE', 'IRL', 'إيرلندا'),
(48851, 3244277632, 3244277695, 'US', 'USA', 'الولايات المتحدة'),
(48852, 3244277696, 3244277759, 'IE', 'IRL', 'إيرلندا'),
(48853, 3244277760, 3244294143, 'SI', 'SVN', 'سلوفينيا'),
(48854, 3244294144, 3244408575, 'DE', 'DEU', 'ألمانيا'),
(48855, 3244408576, 3244408831, 'GB', 'GBR', 'المملكة المتحدة'),
(48856, 3244408832, 3244592127, 'DE', 'DEU', 'ألمانيا'),
(48857, 3244592128, 3244592639, 'CH', 'CHE', 'سويسرا'),
(48858, 3244592640, 3244818431, 'DE', 'DEU', 'ألمانيا'),
(48859, 3244818432, 3244818687, 'ES', 'ESP', 'إسبانيا'),
(48860, 3244818688, 3244818943, 'AT', 'AUT', 'النمسا'),
(48861, 3244818944, 3244819199, 'PL', 'POL', 'بولندا'),
(48862, 3244819200, 3244819455, 'DE', 'DEU', 'ألمانيا'),
(48863, 3244819456, 3244819711, 'GB', 'GBR', 'المملكة المتحدة'),
(48864, 3244819712, 3244819967, 'RO', 'ROM', 'رومانيا'),
(48865, 3244819968, 3244820223, 'NL', 'NLD', 'هولندا'),
(48866, 3244820224, 3244820479, 'UA', 'UKR', 'أوكرانيا'),
(48867, 3244820480, 3244820735, 'BE', 'BEL', 'بلجيكا'),
(48868, 3244820736, 3244820991, 'DE', 'DEU', 'ألمانيا'),
(48869, 3244820992, 3244821247, 'SI', 'SVN', 'سلوفينيا'),
(48870, 3244821248, 3244821503, 'RU', 'RUS', 'الإتحاد الروسي'),
(48871, 3244821504, 3244821759, 'PA', 'PAN', 'بنما'),
(48872, 3244821760, 3244822015, 'TR', 'TUR', 'تركيا'),
(48873, 3244822016, 3244822271, 'RU', 'RUS', 'الإتحاد الروسي'),
(48874, 3244822272, 3244822527, 'GB', 'GBR', 'المملكة المتحدة'),
(48875, 3244822528, 3244822783, 'UA', 'UKR', 'أوكرانيا'),
(48876, 3244822784, 3244823039, 'CZ', 'CZE', 'التشيك'),
(48877, 3244823040, 3244823295, 'DE', 'DEU', 'ألمانيا'),
(48878, 3244823296, 3244823551, 'FR', 'FRA', 'فرنسا'),
(48879, 3244823552, 3244823807, 'GE', 'GEO', 'جورجيا'),
(48880, 3244823808, 3244824063, 'RO', 'ROM', 'رومانيا'),
(48881, 3244824064, 3244824319, 'MT', 'MLT', 'مالطا'),
(48882, 3244824320, 3244824575, 'SI', 'SVN', 'سلوفينيا'),
(48883, 3244824576, 3244824831, 'RU', 'RUS', 'الإتحاد الروسي'),
(48884, 3244824832, 3244825087, 'GB', 'GBR', 'المملكة المتحدة'),
(48885, 3244825088, 3244825343, 'DE', 'DEU', 'ألمانيا'),
(48886, 3244825344, 3244826111, 'RU', 'RUS', 'الإتحاد الروسي'),
(48887, 3244826112, 3244826367, 'RO', 'ROM', 'رومانيا'),
(48888, 3244826368, 3244826623, 'CH', 'CHE', 'سويسرا'),
(48889, 3244826624, 3244826879, 'DE', 'DEU', 'ألمانيا'),
(48890, 3244826880, 3244827135, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(48891, 3244827136, 3244827391, 'RU', 'RUS', 'الإتحاد الروسي'),
(48892, 3244827392, 3244827647, 'GB', 'GBR', 'المملكة المتحدة'),
(48893, 3244827648, 3244827903, 'FR', 'FRA', 'فرنسا'),
(48894, 3244827904, 3244828159, 'BE', 'BEL', 'بلجيكا'),
(48895, 3244828160, 3244828415, 'FI', 'FIN', 'فنلندا'),
(48896, 3244828416, 3244828671, 'FR', 'FRA', 'فرنسا'),
(48897, 3244828672, 3244828927, 'SA', 'SAU', 'السعودية'),
(48898, 3244828928, 3244829183, 'MD', 'MDA', 'مولدوفا'),
(48899, 3244829184, 3244829439, 'CH', 'CHE', 'سويسرا'),
(48900, 3244829440, 3244829695, 'DK', 'DNK', 'الدنيمارك'),
(48901, 3244829696, 3244829951, 'IL', 'ISR', 'إسرائيل'),
(48902, 3244829952, 3244830463, 'PL', 'POL', 'بولندا'),
(48903, 3244830464, 3244830719, 'CH', 'CHE', 'سويسرا'),
(48904, 3244830720, 3244830975, 'FR', 'FRA', 'فرنسا'),
(48905, 3244830976, 3244831231, 'DE', 'DEU', 'ألمانيا'),
(48906, 3244831232, 3244831487, 'PL', 'POL', 'بولندا'),
(48907, 3244831488, 3244831743, 'ES', 'ESP', 'إسبانيا'),
(48908, 3244831744, 3244831999, 'PT', 'PRT', 'البورتوغال'),
(48909, 3244832000, 3244832255, 'HU', 'HUN', 'هنغاريا'),
(48910, 3244832256, 3244832511, 'FR', 'FRA', 'فرنسا'),
(48911, 3244832512, 3244832767, 'AT', 'AUT', 'النمسا'),
(48912, 3244832768, 3244833023, 'FR', 'FRA', 'فرنسا'),
(48913, 3244833024, 3244833279, 'RU', 'RUS', 'الإتحاد الروسي'),
(48914, 3244833280, 3244833535, 'UA', 'UKR', 'أوكرانيا'),
(48915, 3244833536, 3244833791, 'RU', 'RUS', 'الإتحاد الروسي'),
(48916, 3244833792, 3244834047, 'FR', 'FRA', 'فرنسا'),
(48917, 3244834048, 3244834303, 'CH', 'CHE', 'سويسرا'),
(48918, 3244834304, 3244834559, 'IL', 'ISR', 'إسرائيل'),
(48919, 3244834560, 3244834815, 'GB', 'GBR', 'المملكة المتحدة'),
(48920, 3244834816, 3244835071, 'RU', 'RUS', 'الإتحاد الروسي'),
(48921, 3244835072, 3244835327, 'AT', 'AUT', 'النمسا'),
(48922, 3244835328, 3244835583, 'DE', 'DEU', 'ألمانيا'),
(48923, 3244835584, 3244835839, 'UA', 'UKR', 'أوكرانيا'),
(48924, 3244835840, 3244836095, 'RS', 'SRB', 'صربيا'),
(48925, 3244836096, 3244836607, 'RU', 'RUS', 'الإتحاد الروسي'),
(48926, 3244836608, 3244836863, 'PL', 'POL', 'بولندا'),
(48927, 3244836864, 3244837119, 'FR', 'FRA', 'فرنسا'),
(48928, 3244837120, 3244837375, 'RO', 'ROM', 'رومانيا'),
(48929, 3244837376, 3244837631, 'ES', 'ESP', 'إسبانيا'),
(48930, 3244837632, 3244837887, 'RU', 'RUS', 'الإتحاد الروسي'),
(48931, 3244837888, 3244838143, 'CY', 'CYP', 'قبرص'),
(48932, 3244838144, 3244838399, 'IL', 'ISR', 'إسرائيل'),
(48933, 3244838400, 3244838655, 'GB', 'GBR', 'المملكة المتحدة'),
(48934, 3244838656, 3244838911, 'BG', 'BGR', 'بلغاريا'),
(48935, 3244838912, 3244839167, 'TR', 'TUR', 'تركيا'),
(48936, 3244839168, 3244839423, 'GB', 'GBR', 'المملكة المتحدة'),
(48937, 3244839424, 3244839679, 'AT', 'AUT', 'النمسا'),
(48938, 3244839680, 3244839935, 'DK', 'DNK', 'الدنيمارك'),
(48939, 3244839936, 3244840191, 'DE', 'DEU', 'ألمانيا'),
(48940, 3244840192, 3244840447, 'UA', 'UKR', 'أوكرانيا'),
(48941, 3244840448, 3244840703, 'IT', 'ITA', 'إيطاليا'),
(48942, 3244840704, 3244840959, 'RU', 'RUS', 'الإتحاد الروسي'),
(48943, 3244840960, 3244841215, 'PL', 'POL', 'بولندا'),
(48944, 3244841216, 3244841471, 'GB', 'GBR', 'المملكة المتحدة'),
(48945, 3244841472, 3244841727, 'DE', 'DEU', 'ألمانيا'),
(48946, 3244841728, 3244842495, 'GB', 'GBR', 'المملكة المتحدة'),
(48947, 3244842496, 3244842751, 'RU', 'RUS', 'الإتحاد الروسي'),
(48948, 3244842752, 3244843007, 'DE', 'DEU', 'ألمانيا'),
(48949, 3244843008, 3244843263, 'UA', 'UKR', 'أوكرانيا'),
(48950, 3244843264, 3244843519, 'RU', 'RUS', 'الإتحاد الروسي'),
(48951, 3244843520, 3244843775, 'NL', 'NLD', 'هولندا'),
(48952, 3244843776, 3244844031, 'PL', 'POL', 'بولندا'),
(48953, 3244844032, 3244844287, 'SE', 'SWE', 'السويد'),
(48954, 3244844288, 3244844543, 'GB', 'GBR', 'المملكة المتحدة'),
(48955, 3244844544, 3244844799, 'RU', 'RUS', 'الإتحاد الروسي'),
(48956, 3244844800, 3244845055, 'GB', 'GBR', 'المملكة المتحدة'),
(48957, 3244845056, 3244845311, 'NL', 'NLD', 'هولندا'),
(48958, 3244845312, 3244845567, 'NO', 'NOR', 'النرويج'),
(48959, 3244845568, 3244845823, 'AD', 'AND', 'أندورا'),
(48960, 3244845824, 3244846335, 'GB', 'GBR', 'المملكة المتحدة'),
(48961, 3244846336, 3244846591, 'TR', 'TUR', 'تركيا'),
(48962, 3244846592, 3244846847, 'CZ', 'CZE', 'التشيك'),
(48963, 3244846848, 3244847103, 'NL', 'NLD', 'هولندا'),
(48964, 3244847104, 3244847359, 'SE', 'SWE', 'السويد'),
(48965, 3244847360, 3244847615, 'GB', 'GBR', 'المملكة المتحدة'),
(48966, 3244847616, 3244847871, 'DK', 'DNK', 'الدنيمارك'),
(48967, 3244847872, 3244848127, 'IL', 'ISR', 'إسرائيل'),
(48968, 3244848128, 3244848383, 'CH', 'CHE', 'سويسرا'),
(48969, 3244848384, 3244848639, 'IL', 'ISR', 'إسرائيل'),
(48970, 3244848640, 3244848895, 'HU', 'HUN', 'هنغاريا'),
(48971, 3244848896, 3244849151, 'IL', 'ISR', 'إسرائيل'),
(48972, 3244849152, 3244849407, 'AT', 'AUT', 'النمسا'),
(48973, 3244849408, 3244849663, 'RO', 'ROM', 'رومانيا'),
(48974, 3244849664, 3244849919, 'SE', 'SWE', 'السويد'),
(48975, 3244849920, 3244850175, 'RO', 'ROM', 'رومانيا'),
(48976, 3244850176, 3244850431, 'TR', 'TUR', 'تركيا'),
(48977, 3244850432, 3244850687, 'AT', 'AUT', 'النمسا'),
(48978, 3244850688, 3244850943, 'GB', 'GBR', 'المملكة المتحدة'),
(48979, 3244850944, 3244851455, 'RU', 'RUS', 'الإتحاد الروسي'),
(48980, 3244851456, 3244851711, 'NL', 'NLD', 'هولندا'),
(48981, 3244851712, 3244851967, 'TR', 'TUR', 'تركيا'),
(48982, 3244851968, 3244852223, 'GB', 'GBR', 'المملكة المتحدة'),
(48983, 3244852224, 3244852479, 'CH', 'CHE', 'سويسرا'),
(48984, 3244852480, 3244852735, 'UA', 'UKR', 'أوكرانيا'),
(48985, 3244852736, 3244852991, 'SI', 'SVN', 'سلوفينيا'),
(48986, 3244852992, 3244853247, 'DK', 'DNK', 'الدنيمارك'),
(48987, 3244853248, 3244853503, 'IE', 'IRL', 'إيرلندا'),
(48988, 3244853504, 3244853759, 'IT', 'ITA', 'إيطاليا'),
(48989, 3244853760, 3244854015, 'TR', 'TUR', 'تركيا'),
(48990, 3244854016, 3244854271, 'NL', 'NLD', 'هولندا'),
(48991, 3244854272, 3244854527, 'GB', 'GBR', 'المملكة المتحدة'),
(48992, 3244854528, 3244855295, 'RU', 'RUS', 'الإتحاد الروسي'),
(48993, 3244855296, 3244855551, 'GB', 'GBR', 'المملكة المتحدة'),
(48994, 3244855552, 3244855807, 'UA', 'UKR', 'أوكرانيا'),
(48995, 3244855808, 3244856063, 'CZ', 'CZE', 'التشيك'),
(48996, 3244856064, 3244856319, 'IL', 'ISR', 'إسرائيل'),
(48997, 3244856320, 3244856575, 'CH', 'CHE', 'سويسرا'),
(48998, 3244856576, 3244856831, 'RU', 'RUS', 'الإتحاد الروسي'),
(48999, 3244856832, 3244857087, 'RO', 'ROM', 'رومانيا'),
(49000, 3244857088, 3244857343, 'IT', 'ITA', 'إيطاليا'),
(49001, 3244857344, 3244857599, 'GB', 'GBR', 'المملكة المتحدة'),
(49002, 3244857600, 3244857855, 'LU', 'LUX', 'لوكسيمبورغ'),
(49003, 3244857856, 3244858111, 'PL', 'POL', 'بولندا'),
(49004, 3244858112, 3244858367, 'DE', 'DEU', 'ألمانيا'),
(49005, 3244858368, 3244858623, 'PL', 'POL', 'بولندا'),
(49006, 3244858624, 3244858879, 'RU', 'RUS', 'الإتحاد الروسي'),
(49007, 3244858880, 3244859135, 'FR', 'FRA', 'فرنسا'),
(49008, 3244859136, 3244859391, 'BE', 'BEL', 'بلجيكا'),
(49009, 3244859392, 3244859647, 'SE', 'SWE', 'السويد'),
(49010, 3244859648, 3244859903, 'PL', 'POL', 'بولندا'),
(49011, 3244859904, 3244860159, 'FR', 'FRA', 'فرنسا'),
(49012, 3244860160, 3244860415, 'PL', 'POL', 'بولندا'),
(49013, 3244860416, 3244860671, 'GB', 'GBR', 'المملكة المتحدة'),
(49014, 3244860672, 3244860927, 'BG', 'BGR', 'بلغاريا'),
(49015, 3244860928, 3244861183, 'PL', 'POL', 'بولندا'),
(49016, 3244861184, 3244861439, 'CH', 'CHE', 'سويسرا'),
(49017, 3244861440, 3244861951, 'GB', 'GBR', 'المملكة المتحدة'),
(49018, 3244861952, 3244862207, 'RU', 'RUS', 'الإتحاد الروسي'),
(49019, 3244862208, 3244862463, 'DK', 'DNK', 'الدنيمارك'),
(49020, 3244862464, 3244862719, 'CZ', 'CZE', 'التشيك'),
(49021, 3244862720, 3244862975, 'RO', 'ROM', 'رومانيا'),
(49022, 3244862976, 3244863231, 'DE', 'DEU', 'ألمانيا'),
(49023, 3244863232, 3244863487, 'GB', 'GBR', 'المملكة المتحدة'),
(49024, 3244863488, 3244863743, 'KZ', 'KAZ', 'كازاخستان'),
(49025, 3244863744, 3244863999, 'RU', 'RUS', 'الإتحاد الروسي'),
(49026, 3244864000, 3244864255, 'UA', 'UKR', 'أوكرانيا'),
(49027, 3244864512, 3244864767, 'RO', 'ROM', 'رومانيا'),
(49028, 3244864768, 3244865023, 'RU', 'RUS', 'الإتحاد الروسي'),
(49029, 3244865024, 3244865535, 'UA', 'UKR', 'أوكرانيا'),
(49030, 3244865536, 3244865791, 'PL', 'POL', 'بولندا'),
(49031, 3244865792, 3244866047, 'CH', 'CHE', 'سويسرا'),
(49032, 3244866048, 3244866559, 'NL', 'NLD', 'هولندا'),
(49033, 3244866560, 3244866815, 'FI', 'FIN', 'فنلندا'),
(49034, 3244866816, 3244867071, 'UA', 'UKR', 'أوكرانيا'),
(49035, 3244867072, 3244867583, 'RU', 'RUS', 'الإتحاد الروسي'),
(49036, 3244867584, 3244868095, 'NL', 'NLD', 'هولندا'),
(49037, 3244868096, 3244868351, 'DE', 'DEU', 'ألمانيا'),
(49038, 3244868352, 3244868607, 'RU', 'RUS', 'الإتحاد الروسي'),
(49039, 3244868608, 3244868863, 'FI', 'FIN', 'فنلندا'),
(49040, 3244868864, 3244869119, 'RU', 'RUS', 'الإتحاد الروسي'),
(49041, 3244869120, 3244869375, 'GB', 'GBR', 'المملكة المتحدة'),
(49042, 3244869376, 3244869631, 'FR', 'FRA', 'فرنسا'),
(49043, 3244869632, 3244869887, 'GR', 'GRC', 'اليونان'),
(49044, 3244869888, 3244870143, 'TR', 'TUR', 'تركيا'),
(49045, 3244870144, 3244870399, 'DK', 'DNK', 'الدنيمارك'),
(49046, 3244870400, 3244870655, 'UA', 'UKR', 'أوكرانيا'),
(49047, 3244870656, 3244870911, 'SA', 'SAU', 'السعودية'),
(49048, 3244870912, 3244871167, 'FR', 'FRA', 'فرنسا'),
(49049, 3244871168, 3244871423, 'LT', 'LTU', 'ليتوانيا'),
(49050, 3244871424, 3244871679, 'RU', 'RUS', 'الإتحاد الروسي'),
(49051, 3244871680, 3244872447, 'UA', 'UKR', 'أوكرانيا'),
(49052, 3244872448, 3244872703, 'CH', 'CHE', 'سويسرا'),
(49053, 3244872704, 3244872959, 'IR', 'IRN', 'إيران'),
(49054, 3244872960, 3244873215, 'UA', 'UKR', 'أوكرانيا'),
(49055, 3244873216, 3244873471, 'SE', 'SWE', 'السويد'),
(49056, 3244873472, 3244873727, 'IE', 'IRL', 'إيرلندا'),
(49057, 3244873728, 3244873983, 'DE', 'DEU', 'ألمانيا'),
(49058, 3244873984, 3244874239, 'SE', 'SWE', 'السويد'),
(49059, 3244874240, 3244874495, 'ES', 'ESP', 'إسبانيا'),
(49060, 3244874496, 3244874751, 'FR', 'FRA', 'فرنسا'),
(49061, 3244874752, 3244875007, 'DE', 'DEU', 'ألمانيا'),
(49062, 3244875008, 3244875263, 'PL', 'POL', 'بولندا'),
(49063, 3244875264, 3244875519, 'LI', 'LIE', 'ليختنشتاين'),
(49064, 3244875520, 3244875775, 'IT', 'ITA', 'إيطاليا'),
(49065, 3244876800, 3244877055, 'GB', 'GBR', 'المملكة المتحدة'),
(49066, 3244877056, 3244877311, 'JO', 'JOR', 'الأردن'),
(49067, 3244877312, 3244877567, 'RU', 'RUS', 'الإتحاد الروسي'),
(49068, 3244877568, 3244877823, 'FR', 'FRA', 'فرنسا'),
(49069, 3244877824, 3244878079, 'AT', 'AUT', 'النمسا'),
(49070, 3244878080, 3244878335, 'GB', 'GBR', 'المملكة المتحدة'),
(49071, 3244878336, 3244878591, 'RU', 'RUS', 'الإتحاد الروسي'),
(49072, 3244878592, 3244878847, 'PL', 'POL', 'بولندا'),
(49073, 3244878848, 3244879103, 'SI', 'SVN', 'سلوفينيا'),
(49074, 3244879104, 3244879359, 'RU', 'RUS', 'الإتحاد الروسي'),
(49075, 3244879360, 3244879615, 'CH', 'CHE', 'سويسرا'),
(49076, 3244879872, 3244880127, 'SI', 'SVN', 'سلوفينيا'),
(49077, 3244880128, 3244880383, 'RU', 'RUS', 'الإتحاد الروسي'),
(49078, 3244880384, 3244880639, 'UA', 'UKR', 'أوكرانيا'),
(49079, 3244880640, 3244880895, 'RU', 'RUS', 'الإتحاد الروسي'),
(49080, 3244880896, 3244881151, 'PL', 'POL', 'بولندا'),
(49081, 3244881152, 3244881407, 'RU', 'RUS', 'الإتحاد الروسي'),
(49082, 3244881408, 3244881663, 'DK', 'DNK', 'الدنيمارك'),
(49083, 3244881664, 3244881919, 'RO', 'ROM', 'رومانيا'),
(49084, 3244881920, 3244882175, 'RU', 'RUS', 'الإتحاد الروسي'),
(49085, 3244882176, 3244882431, 'UA', 'UKR', 'أوكرانيا'),
(49086, 3244882432, 3244882687, 'IT', 'ITA', 'إيطاليا'),
(49087, 3244882688, 3244882943, 'PL', 'POL', 'بولندا'),
(49088, 3244882944, 3244883199, 'NL', 'NLD', 'هولندا'),
(49089, 3244883200, 3244883455, 'UA', 'UKR', 'أوكرانيا'),
(49090, 3244883456, 3244883711, 'CZ', 'CZE', 'التشيك'),
(49091, 3244883712, 3244883967, 'NL', 'NLD', 'هولندا'),
(49092, 3244883968, 3244884223, 'MD', 'MDA', 'مولدوفا'),
(49093, 3244884224, 3244884479, 'FR', 'FRA', 'فرنسا'),
(49094, 3244884480, 3244884735, 'IR', 'IRN', 'إيران'),
(49095, 3244884736, 3244884991, 'NL', 'NLD', 'هولندا'),
(49096, 3244884992, 3244885247, 'GR', 'GRC', 'اليونان'),
(49097, 3244885248, 3244885503, 'CH', 'CHE', 'سويسرا'),
(49098, 3244885504, 3244885759, 'IR', 'IRN', 'إيران'),
(49099, 3244885760, 3244886015, 'UA', 'UKR', 'أوكرانيا'),
(49100, 3244886016, 3244886271, 'LB', 'LBN', 'لبنان'),
(49101, 3244886272, 3244886527, 'CH', 'CHE', 'سويسرا'),
(49102, 3244886528, 3244886783, 'DK', 'DNK', 'الدنيمارك'),
(49103, 3244886784, 3244887039, 'UA', 'UKR', 'أوكرانيا'),
(49104, 3244887040, 3244887295, 'NL', 'NLD', 'هولندا'),
(49105, 3244887296, 3244887551, 'GB', 'GBR', 'المملكة المتحدة'),
(49106, 3244887552, 3244887807, 'CZ', 'CZE', 'التشيك'),
(49107, 3244887808, 3244888063, 'BE', 'BEL', 'بلجيكا'),
(49108, 3244888064, 3244888319, 'RU', 'RUS', 'الإتحاد الروسي'),
(49109, 3244888320, 3244888575, 'DE', 'DEU', 'ألمانيا'),
(49110, 3244888576, 3244888831, 'FR', 'FRA', 'فرنسا'),
(49111, 3244888832, 3244889087, 'DE', 'DEU', 'ألمانيا'),
(49112, 3244889088, 3244889343, 'PL', 'POL', 'بولندا'),
(49113, 3244889344, 3244889599, 'RO', 'ROM', 'رومانيا'),
(49114, 3244889600, 3244889855, 'SI', 'SVN', 'سلوفينيا'),
(49115, 3244889856, 3244890111, 'HR', 'HRV', 'كرواتيا'),
(49116, 3244890112, 3244890367, 'PL', 'POL', 'بولندا'),
(49117, 3244890368, 3244890623, 'NL', 'NLD', 'هولندا'),
(49118, 3244890624, 3244890879, 'FR', 'FRA', 'فرنسا'),
(49119, 3244890880, 3244891135, 'RU', 'RUS', 'الإتحاد الروسي'),
(49120, 3244891136, 3244891391, 'RO', 'ROM', 'رومانيا'),
(49121, 3244891392, 3244891647, 'PL', 'POL', 'بولندا'),
(49122, 3244891648, 3244891903, 'UA', 'UKR', 'أوكرانيا'),
(49123, 3244891904, 3244892159, 'RO', 'ROM', 'رومانيا'),
(49124, 3244892160, 3244892415, 'PL', 'POL', 'بولندا'),
(49125, 3244892416, 3244892671, 'NL', 'NLD', 'هولندا'),
(49126, 3244892672, 3244892927, 'ES', 'ESP', 'إسبانيا'),
(49127, 3244892928, 3244893183, 'PL', 'POL', 'بولندا'),
(49128, 3244893184, 3244893439, 'BE', 'BEL', 'بلجيكا'),
(49129, 3244893440, 3244893695, 'RU', 'RUS', 'الإتحاد الروسي'),
(49130, 3244893696, 3244893951, 'DE', 'DEU', 'ألمانيا'),
(49131, 3244893952, 3244894463, 'RU', 'RUS', 'الإتحاد الروسي'),
(49132, 3244894464, 3244894719, 'UA', 'UKR', 'أوكرانيا'),
(49133, 3244894720, 3244894975, 'GR', 'GRC', 'اليونان'),
(49134, 3244894976, 3244895231, 'FR', 'FRA', 'فرنسا'),
(49135, 3244895232, 3244895487, 'DK', 'DNK', 'الدنيمارك'),
(49136, 3244895488, 3244895743, 'PL', 'POL', 'بولندا'),
(49137, 3244896000, 3244896511, 'GB', 'GBR', 'المملكة المتحدة'),
(49138, 3244896512, 3244896767, 'LT', 'LTU', 'ليتوانيا'),
(49139, 3244896768, 3244897023, 'NL', 'NLD', 'هولندا'),
(49140, 3244897024, 3244897279, 'GB', 'GBR', 'المملكة المتحدة'),
(49141, 3244897280, 3244897535, 'DE', 'DEU', 'ألمانيا'),
(49142, 3244897536, 3244897791, 'RU', 'RUS', 'الإتحاد الروسي'),
(49143, 3244897792, 3244898047, 'GB', 'GBR', 'المملكة المتحدة'),
(49144, 3244898048, 3244898303, 'DE', 'DEU', 'ألمانيا'),
(49145, 3244898304, 3244898559, 'UA', 'UKR', 'أوكرانيا'),
(49146, 3244898560, 3244898815, 'GI', 'GIB', 'جبل طارق'),
(49147, 3244898816, 3244899071, 'RO', 'ROM', 'رومانيا'),
(49148, 3244899072, 3244899327, 'RU', 'RUS', 'الإتحاد الروسي'),
(49149, 3244899328, 3244899583, 'BG', 'BGR', 'بلغاريا'),
(49150, 3244899584, 3244899839, 'GB', 'GBR', 'المملكة المتحدة'),
(49151, 3244899840, 3244900095, 'UA', 'UKR', 'أوكرانيا'),
(49152, 3244900096, 3244900351, 'PL', 'POL', 'بولندا'),
(49153, 3244900352, 3244900607, 'RO', 'ROM', 'رومانيا'),
(49154, 3244900608, 3244900863, 'RU', 'RUS', 'الإتحاد الروسي'),
(49155, 3244900864, 3244901119, 'PL', 'POL', 'بولندا'),
(49156, 3244901120, 3244901375, 'SI', 'SVN', 'سلوفينيا'),
(49157, 3244901376, 3244901631, 'DE', 'DEU', 'ألمانيا'),
(49158, 3244901632, 3244901887, 'GB', 'GBR', 'المملكة المتحدة'),
(49159, 3244901888, 3244902143, 'UA', 'UKR', 'أوكرانيا'),
(49160, 3244902144, 3244902655, 'RU', 'RUS', 'الإتحاد الروسي'),
(49161, 3244902656, 3244902911, 'BE', 'BEL', 'بلجيكا'),
(49162, 3244902912, 3244903167, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(49163, 3244903168, 3244903423, 'PL', 'POL', 'بولندا'),
(49164, 3244903424, 3244903679, 'FI', 'FIN', 'فنلندا'),
(49165, 3244903680, 3244903935, 'NO', 'NOR', 'النرويج'),
(49166, 3244903936, 3244904191, 'TR', 'TUR', 'تركيا'),
(49167, 3244904192, 3244904447, 'IT', 'ITA', 'إيطاليا'),
(49168, 3244904448, 3244904703, 'GR', 'GRC', 'اليونان'),
(49169, 3244904704, 3244904959, 'FR', 'FRA', 'فرنسا'),
(49170, 3244904960, 3244905215, 'BY', 'BLR', 'روسيا البيضاء'),
(49171, 3244905216, 3244905471, 'MD', 'MDA', 'مولدوفا'),
(49172, 3244905472, 3244905727, 'GB', 'GBR', 'المملكة المتحدة'),
(49173, 3244905728, 3244905983, 'GR', 'GRC', 'اليونان'),
(49174, 3244905984, 3244906239, 'AT', 'AUT', 'النمسا'),
(49175, 3244906240, 3244906751, 'DE', 'DEU', 'ألمانيا'),
(49176, 3244906752, 3244907007, 'SA', 'SAU', 'السعودية'),
(49177, 3244907008, 3244907263, 'FR', 'FRA', 'فرنسا'),
(49178, 3244907264, 3244907519, 'RO', 'ROM', 'رومانيا'),
(49179, 3244907520, 3244907775, 'GB', 'GBR', 'المملكة المتحدة'),
(49180, 3244907776, 3244908287, 'RU', 'RUS', 'الإتحاد الروسي'),
(49181, 3244908288, 3244908543, 'NL', 'NLD', 'هولندا'),
(49182, 3244908544, 3244908799, 'RU', 'RUS', 'الإتحاد الروسي'),
(49183, 3244908800, 3244909055, 'FI', 'FIN', 'فنلندا'),
(49184, 3244909056, 3244909311, 'GB', 'GBR', 'المملكة المتحدة'),
(49185, 3244909312, 3244909567, 'IL', 'ISR', 'إسرائيل'),
(49186, 3244909568, 3244909823, 'RU', 'RUS', 'الإتحاد الروسي'),
(49187, 3244909824, 3244910335, 'NL', 'NLD', 'هولندا'),
(49188, 3244910336, 3244910591, 'DE', 'DEU', 'ألمانيا'),
(49189, 3244910592, 3244910847, 'GB', 'GBR', 'المملكة المتحدة'),
(49190, 3244910848, 3244911103, 'DE', 'DEU', 'ألمانيا'),
(49191, 3244911104, 3244911359, 'BE', 'BEL', 'بلجيكا'),
(49192, 3244911360, 3244911615, 'RU', 'RUS', 'الإتحاد الروسي'),
(49193, 3244911616, 3244911871, 'GB', 'GBR', 'المملكة المتحدة'),
(49194, 3244911872, 3244912127, 'GR', 'GRC', 'اليونان'),
(49195, 3244912128, 3244912383, 'PL', 'POL', 'بولندا'),
(49196, 3244912384, 3244912639, 'NL', 'NLD', 'هولندا'),
(49197, 3244912640, 3244912895, 'NO', 'NOR', 'النرويج'),
(49198, 3244912896, 3244913151, 'SE', 'SWE', 'السويد'),
(49199, 3244913152, 3244913407, 'RU', 'RUS', 'الإتحاد الروسي'),
(49200, 3244913408, 3244913663, 'SI', 'SVN', 'سلوفينيا'),
(49201, 3244913664, 3244913919, 'DK', 'DNK', 'الدنيمارك'),
(49202, 3244913920, 3244914431, 'RU', 'RUS', 'الإتحاد الروسي'),
(49203, 3244914432, 3244914687, 'UA', 'UKR', 'أوكرانيا'),
(49204, 3244914688, 3244914943, 'GB', 'GBR', 'المملكة المتحدة'),
(49205, 3244914944, 3244915199, 'UA', 'UKR', 'أوكرانيا'),
(49206, 3244915200, 3244915455, 'PL', 'POL', 'بولندا'),
(49207, 3244915456, 3244915711, 'FI', 'FIN', 'فنلندا'),
(49208, 3244915712, 3244915967, 'UA', 'UKR', 'أوكرانيا'),
(49209, 3244915968, 3244916223, 'PL', 'POL', 'بولندا'),
(49210, 3244916224, 3244916479, 'RU', 'RUS', 'الإتحاد الروسي'),
(49211, 3244916480, 3244916735, 'SI', 'SVN', 'سلوفينيا'),
(49212, 3244916736, 3244916991, 'FR', 'FRA', 'فرنسا'),
(49213, 3244916992, 3244917247, 'PL', 'POL', 'بولندا'),
(49214, 3244917248, 3244917503, 'SE', 'SWE', 'السويد'),
(49215, 3244917504, 3244917759, 'AT', 'AUT', 'النمسا'),
(49216, 3244917760, 3244918015, 'UA', 'UKR', 'أوكرانيا'),
(49217, 3244918016, 3244918271, 'BE', 'BEL', 'بلجيكا'),
(49218, 3244918272, 3244918527, 'SE', 'SWE', 'السويد'),
(49219, 3244918528, 3244918783, 'UA', 'UKR', 'أوكرانيا'),
(49220, 3244918784, 3244919039, 'CH', 'CHE', 'سويسرا'),
(49221, 3244919040, 3244919295, 'DE', 'DEU', 'ألمانيا'),
(49222, 3244919296, 3244919551, 'SE', 'SWE', 'السويد'),
(49223, 3244919552, 3244919807, 'DE', 'DEU', 'ألمانيا'),
(49224, 3244919808, 3244920063, 'RO', 'ROM', 'رومانيا'),
(49225, 3244920064, 3244920319, 'RU', 'RUS', 'الإتحاد الروسي'),
(49226, 3244920320, 3244920575, 'SK', 'SVK', 'سلوفاكيا'),
(49227, 3244920576, 3244920831, 'PL', 'POL', 'بولندا'),
(49228, 3244920832, 3244921087, 'NL', 'NLD', 'هولندا'),
(49229, 3244921088, 3244921343, 'IE', 'IRL', 'إيرلندا'),
(49230, 3244921344, 3244921599, 'LT', 'LTU', 'ليتوانيا'),
(49231, 3244921600, 3244921855, 'DE', 'DEU', 'ألمانيا'),
(49232, 3244921856, 3244922111, 'BG', 'BGR', 'بلغاريا'),
(49233, 3244922112, 3244922367, 'DK', 'DNK', 'الدنيمارك'),
(49234, 3244922368, 3244922623, 'NL', 'NLD', 'هولندا'),
(49235, 3244922624, 3244922879, 'BG', 'BGR', 'بلغاريا'),
(49236, 3244922880, 3244923135, 'UA', 'UKR', 'أوكرانيا'),
(49237, 3244923136, 3244923391, 'AT', 'AUT', 'النمسا'),
(49238, 3244923392, 3244923903, 'LV', 'LVA', 'لاتفيا'),
(49239, 3244923904, 3244924159, 'RU', 'RUS', 'الإتحاد الروسي'),
(49240, 3244924160, 3244924927, 'CZ', 'CZE', 'التشيك'),
(49241, 3244924928, 3244925183, 'FI', 'FIN', 'فنلندا'),
(49242, 3244925184, 3244925439, 'CH', 'CHE', 'سويسرا'),
(49243, 3244925440, 3244925695, 'GB', 'GBR', 'المملكة المتحدة'),
(49244, 3244925696, 3244925951, 'RS', 'SRB', 'صربيا'),
(49245, 3244925952, 3244926207, 'UA', 'UKR', 'أوكرانيا'),
(49246, 3244926208, 3244926463, 'NL', 'NLD', 'هولندا'),
(49247, 3244926464, 3244926719, 'LV', 'LVA', 'لاتفيا'),
(49248, 3244926720, 3244926975, 'PL', 'POL', 'بولندا'),
(49249, 3244926976, 3244927231, 'DE', 'DEU', 'ألمانيا'),
(49250, 3244927232, 3244927487, 'UA', 'UKR', 'أوكرانيا'),
(49251, 3244927488, 3244927743, 'GB', 'GBR', 'المملكة المتحدة'),
(49252, 3244927744, 3244927999, 'UA', 'UKR', 'أوكرانيا'),
(49253, 3244928000, 3244928255, 'GB', 'GBR', 'المملكة المتحدة'),
(49254, 3244928512, 3244928767, 'UA', 'UKR', 'أوكرانيا'),
(49255, 3244928768, 3244929023, 'RU', 'RUS', 'الإتحاد الروسي'),
(49256, 3244929024, 3244929535, 'RO', 'ROM', 'رومانيا'),
(49257, 3244929536, 3244929791, 'PL', 'POL', 'بولندا'),
(49258, 3244929792, 3244930047, 'RU', 'RUS', 'الإتحاد الروسي'),
(49259, 3244930048, 3244930303, 'PL', 'POL', 'بولندا'),
(49260, 3244930304, 3244930559, 'AT', 'AUT', 'النمسا'),
(49261, 3244930560, 3244930815, 'GB', 'GBR', 'المملكة المتحدة'),
(49262, 3244930816, 3244931071, 'NL', 'NLD', 'هولندا'),
(49263, 3244931072, 3244931327, 'RU', 'RUS', 'الإتحاد الروسي'),
(49264, 3244931328, 3244931583, 'RO', 'ROM', 'رومانيا'),
(49265, 3244931584, 3244931839, 'FR', 'FRA', 'فرنسا'),
(49266, 3244931840, 3244932095, 'NL', 'NLD', 'هولندا'),
(49267, 3244932096, 3244932351, 'GB', 'GBR', 'المملكة المتحدة'),
(49268, 3244932352, 3244932607, 'UA', 'UKR', 'أوكرانيا'),
(49269, 3244932608, 3244932863, 'DK', 'DNK', 'الدنيمارك'),
(49270, 3244932864, 3244933375, 'PL', 'POL', 'بولندا'),
(49271, 3244933376, 3244933631, 'HR', 'HRV', 'كرواتيا'),
(49272, 3244933632, 3244933887, 'GB', 'GBR', 'المملكة المتحدة'),
(49273, 3244933888, 3244934143, 'AT', 'AUT', 'النمسا'),
(49274, 3244934144, 3244934399, 'BG', 'BGR', 'بلغاريا'),
(49275, 3244934400, 3244934655, 'FR', 'FRA', 'فرنسا'),
(49276, 3244934656, 3244934911, 'RU', 'RUS', 'الإتحاد الروسي'),
(49277, 3244934912, 3244935167, 'IL', 'ISR', 'إسرائيل'),
(49278, 3244935168, 3244935423, 'NL', 'NLD', 'هولندا'),
(49279, 3244935424, 3244935679, 'UA', 'UKR', 'أوكرانيا'),
(49280, 3244935680, 3244935935, 'PL', 'POL', 'بولندا'),
(49281, 3244935936, 3244936191, 'FR', 'FRA', 'فرنسا'),
(49282, 3244936192, 3244936959, 'AT', 'AUT', 'النمسا'),
(49283, 3244936960, 3244937215, 'KZ', 'KAZ', 'كازاخستان'),
(49284, 3244937216, 3244937471, 'TR', 'TUR', 'تركيا'),
(49285, 3244937472, 3244937727, 'GB', 'GBR', 'المملكة المتحدة'),
(49286, 3244937728, 3244937983, 'UA', 'UKR', 'أوكرانيا'),
(49287, 3244937984, 3244938239, 'TR', 'TUR', 'تركيا'),
(49288, 3244938240, 3244938495, 'GB', 'GBR', 'المملكة المتحدة'),
(49289, 3244938496, 3244938751, 'RU', 'RUS', 'الإتحاد الروسي'),
(49290, 3244938752, 3244939007, 'AT', 'AUT', 'النمسا'),
(49291, 3244939008, 3244939263, 'RO', 'ROM', 'رومانيا'),
(49292, 3244939264, 3244939519, 'UA', 'UKR', 'أوكرانيا'),
(49293, 3244939520, 3244939775, 'FR', 'FRA', 'فرنسا'),
(49294, 3244939776, 3244940031, 'GB', 'GBR', 'المملكة المتحدة'),
(49295, 3244940032, 3244940287, 'UA', 'UKR', 'أوكرانيا'),
(49296, 3244940288, 3244940543, 'DK', 'DNK', 'الدنيمارك'),
(49297, 3244940544, 3244940799, 'PL', 'POL', 'بولندا'),
(49298, 3244940800, 3244941055, 'RU', 'RUS', 'الإتحاد الروسي'),
(49299, 3244941056, 3244941311, 'DE', 'DEU', 'ألمانيا'),
(49300, 3244941312, 3244941567, 'CY', 'CYP', 'قبرص'),
(49301, 3244941568, 3244941823, 'FR', 'FRA', 'فرنسا'),
(49302, 3244941824, 3244942079, 'SE', 'SWE', 'السويد'),
(49303, 3244942080, 3244942335, 'PL', 'POL', 'بولندا'),
(49304, 3244942336, 3244942591, 'IT', 'ITA', 'إيطاليا'),
(49305, 3244942592, 3244942847, 'PL', 'POL', 'بولندا'),
(49306, 3244942848, 3244943103, 'DE', 'DEU', 'ألمانيا'),
(49307, 3244943104, 3244943359, 'GB', 'GBR', 'المملكة المتحدة'),
(49308, 3244943360, 3244943615, 'FR', 'FRA', 'فرنسا'),
(49309, 3244943872, 3244944127, 'TR', 'TUR', 'تركيا'),
(49310, 3244944128, 3244944639, 'RU', 'RUS', 'الإتحاد الروسي'),
(49311, 3244944896, 3244945151, 'FR', 'FRA', 'فرنسا'),
(49312, 3244945152, 3244945407, 'RO', 'ROM', 'رومانيا'),
(49313, 3244945408, 3244945663, 'LV', 'LVA', 'لاتفيا'),
(49314, 3244945664, 3244945919, 'NL', 'NLD', 'هولندا'),
(49315, 3244945920, 3244946175, 'PL', 'POL', 'بولندا'),
(49316, 3244946176, 3244946431, 'TR', 'TUR', 'تركيا'),
(49317, 3244946432, 3244946687, 'RO', 'ROM', 'رومانيا'),
(49318, 3244946688, 3244946943, 'RU', 'RUS', 'الإتحاد الروسي'),
(49319, 3244946944, 3244947455, 'DE', 'DEU', 'ألمانيا'),
(49320, 3244947456, 3244947711, 'PL', 'POL', 'بولندا'),
(49321, 3244947712, 3244947967, 'UA', 'UKR', 'أوكرانيا'),
(49322, 3244947968, 3244948223, 'DE', 'DEU', 'ألمانيا'),
(49323, 3244948224, 3244948479, 'PL', 'POL', 'بولندا'),
(49324, 3244948480, 3244948735, 'FR', 'FRA', 'فرنسا'),
(49325, 3244948736, 3244948991, 'IE', 'IRL', 'إيرلندا'),
(49326, 3244948992, 3244949247, 'UA', 'UKR', 'أوكرانيا'),
(49327, 3244949248, 3244951551, 'RU', 'RUS', 'الإتحاد الروسي'),
(49328, 3244951552, 3244952575, 'FI', 'FIN', 'فنلندا'),
(49329, 3244952576, 3244953599, 'GB', 'GBR', 'المملكة المتحدة'),
(49330, 3244953600, 3244954623, 'DE', 'DEU', 'ألمانيا'),
(49331, 3244954624, 3244955647, 'RU', 'RUS', 'الإتحاد الروسي'),
(49332, 3244955648, 3244957695, 'UA', 'UKR', 'أوكرانيا'),
(49333, 3244957696, 3244958719, 'AG', 'ATG', 'انتيغوا وبربودا'),
(49334, 3244958720, 3244959743, 'FR', 'FRA', 'فرنسا'),
(49335, 3244959744, 3244960767, 'RU', 'RUS', 'الإتحاد الروسي'),
(49336, 3244960768, 3244961791, 'RO', 'ROM', 'رومانيا'),
(49337, 3244961792, 3244962815, 'KG', 'KGZ', 'قيرغيزستان'),
(49338, 3244962816, 3244963839, 'IL', 'ISR', 'إسرائيل'),
(49339, 3244963840, 3244966911, 'UA', 'UKR', 'أوكرانيا'),
(49340, 3244966912, 3244968959, 'RU', 'RUS', 'الإتحاد الروسي'),
(49341, 3244968960, 3244969983, 'PL', 'POL', 'بولندا'),
(49342, 3244969984, 3244971007, 'UA', 'UKR', 'أوكرانيا'),
(49343, 3244971008, 3244972031, 'PL', 'POL', 'بولندا'),
(49344, 3244972032, 3244975103, 'RU', 'RUS', 'الإتحاد الروسي'),
(49345, 3244975104, 3244977151, 'PL', 'POL', 'بولندا'),
(49346, 3244977152, 3244978175, 'RU', 'RUS', 'الإتحاد الروسي'),
(49347, 3244978176, 3244979199, 'GB', 'GBR', 'المملكة المتحدة'),
(49348, 3244979200, 3244980223, 'FR', 'FRA', 'فرنسا'),
(49349, 3244981248, 3244982271, 'RO', 'ROM', 'رومانيا'),
(49350, 3244982272, 3244983295, 'PL', 'POL', 'بولندا'),
(49351, 3244983296, 3244984319, 'RU', 'RUS', 'الإتحاد الروسي'),
(49352, 3244984320, 3244985343, 'UA', 'UKR', 'أوكرانيا'),
(49353, 3244985344, 3244986367, 'DE', 'DEU', 'ألمانيا'),
(49354, 3244986368, 3244987391, 'UA', 'UKR', 'أوكرانيا'),
(49355, 3244987392, 3244988415, 'RU', 'RUS', 'الإتحاد الروسي'),
(49356, 3244988416, 3244990463, 'PL', 'POL', 'بولندا'),
(49357, 3244990464, 3244991487, 'UA', 'UKR', 'أوكرانيا'),
(49358, 3244991488, 3244992511, 'DK', 'DNK', 'الدنيمارك'),
(49359, 3244992512, 3244994559, 'RU', 'RUS', 'الإتحاد الروسي'),
(49360, 3244994560, 3244995583, 'ES', 'ESP', 'إسبانيا'),
(49361, 3244995584, 3244996607, 'IT', 'ITA', 'إيطاليا'),
(49362, 3244996608, 3244997631, 'UA', 'UKR', 'أوكرانيا'),
(49363, 3244997632, 3244998655, 'RO', 'ROM', 'رومانيا'),
(49364, 3244998656, 3244999679, 'PL', 'POL', 'بولندا'),
(49365, 3244999680, 3245000703, 'IQ', 'IRQ', 'العراق'),
(49366, 3245000704, 3245001727, 'UA', 'UKR', 'أوكرانيا'),
(49367, 3245001728, 3245002751, 'IL', 'ISR', 'إسرائيل'),
(49368, 3245002752, 3245003775, 'ES', 'ESP', 'إسبانيا'),
(49369, 3245003776, 3245004799, 'RU', 'RUS', 'الإتحاد الروسي'),
(49370, 3245004800, 3245005823, 'PL', 'POL', 'بولندا'),
(49371, 3245005824, 3245006847, 'UA', 'UKR', 'أوكرانيا'),
(49372, 3245006848, 3245007871, 'DE', 'DEU', 'ألمانيا'),
(49373, 3245007872, 3245008895, 'PL', 'POL', 'بولندا'),
(49374, 3245008896, 3245011967, 'RU', 'RUS', 'الإتحاد الروسي'),
(49375, 3245011968, 3245012991, 'PL', 'POL', 'بولندا'),
(49376, 3245012992, 3245014015, 'UA', 'UKR', 'أوكرانيا'),
(49377, 3245014016, 3245015039, 'GR', 'GRC', 'اليونان'),
(49378, 3245015040, 3245016063, 'RU', 'RUS', 'الإتحاد الروسي'),
(49379, 3245016064, 3245017087, 'RS', 'SRB', 'صربيا'),
(49380, 3245018112, 3245019135, 'RU', 'RUS', 'الإتحاد الروسي'),
(49381, 3245019136, 3245020159, 'SC', 'SYC', 'سيشيل'),
(49382, 3245020160, 3245021183, 'RU', 'RUS', 'الإتحاد الروسي'),
(49383, 3245021184, 3245022207, 'UA', 'UKR', 'أوكرانيا'),
(49384, 3245022208, 3245023231, 'NO', 'NOR', 'النرويج'),
(49385, 3245023232, 3245024255, 'PL', 'POL', 'بولندا'),
(49386, 3245024256, 3245025279, 'BG', 'BGR', 'بلغاريا'),
(49387, 3245025280, 3245026303, 'UA', 'UKR', 'أوكرانيا'),
(49388, 3245026304, 3245027327, 'GB', 'GBR', 'المملكة المتحدة'),
(49389, 3245027328, 3245028351, 'RU', 'RUS', 'الإتحاد الروسي'),
(49390, 3245029376, 3245030399, 'FR', 'FRA', 'فرنسا'),
(49391, 3245030400, 3245032447, 'RU', 'RUS', 'الإتحاد الروسي'),
(49392, 3245032448, 3245033471, 'BG', 'BGR', 'بلغاريا'),
(49393, 3245033472, 3245034495, 'UA', 'UKR', 'أوكرانيا'),
(49394, 3245034496, 3245035519, 'SE', 'SWE', 'السويد'),
(49395, 3245035520, 3245036543, 'UA', 'UKR', 'أوكرانيا'),
(49396, 3245036544, 3245037567, 'IS', 'ISL', 'أيسلندا'),
(49397, 3245037568, 3245038591, 'PL', 'POL', 'بولندا'),
(49398, 3245038592, 3245039615, 'RU', 'RUS', 'الإتحاد الروسي'),
(49399, 3245039616, 3245040639, 'MD', 'MDA', 'مولدوفا'),
(49400, 3245040640, 3245041663, 'RU', 'RUS', 'الإتحاد الروسي'),
(49401, 3245041664, 3245044735, 'UA', 'UKR', 'أوكرانيا'),
(49402, 3245044736, 3245045759, 'GB', 'GBR', 'المملكة المتحدة'),
(49403, 3245045760, 3245046783, 'DE', 'DEU', 'ألمانيا'),
(49404, 3245046784, 3245047807, 'FR', 'FRA', 'فرنسا'),
(49405, 3245047808, 3245050879, 'UA', 'UKR', 'أوكرانيا'),
(49406, 3245050880, 3245051903, 'RU', 'RUS', 'الإتحاد الروسي'),
(49407, 3245051904, 3245052927, 'DE', 'DEU', 'ألمانيا'),
(49408, 3245052928, 3245054975, 'RU', 'RUS', 'الإتحاد الروسي'),
(49409, 3245054976, 3245055999, 'AT', 'AUT', 'النمسا'),
(49410, 3245056000, 3245057023, 'CZ', 'CZE', 'التشيك'),
(49411, 3245057024, 3245058047, 'PL', 'POL', 'بولندا'),
(49412, 3245058048, 3245061119, 'UA', 'UKR', 'أوكرانيا'),
(49413, 3245061120, 3245062143, 'RU', 'RUS', 'الإتحاد الروسي'),
(49414, 3245062144, 3245063167, 'UA', 'UKR', 'أوكرانيا'),
(49415, 3245063168, 3245065215, 'RU', 'RUS', 'الإتحاد الروسي'),
(49416, 3245065216, 3245066239, 'PL', 'POL', 'بولندا'),
(49417, 3245066240, 3245067263, 'UA', 'UKR', 'أوكرانيا'),
(49418, 3245067264, 3245068287, 'GB', 'GBR', 'المملكة المتحدة'),
(49419, 3245068288, 3245069311, 'UA', 'UKR', 'أوكرانيا'),
(49420, 3245069312, 3245070335, 'PL', 'POL', 'بولندا'),
(49421, 3245070336, 3245071359, 'RU', 'RUS', 'الإتحاد الروسي'),
(49422, 3245071360, 3245072383, 'NL', 'NLD', 'هولندا'),
(49423, 3245072384, 3245073407, 'UA', 'UKR', 'أوكرانيا'),
(49424, 3245073408, 3245076479, 'RU', 'RUS', 'الإتحاد الروسي'),
(49425, 3245076480, 3245077503, 'FR', 'FRA', 'فرنسا'),
(49426, 3245077504, 3245078527, 'UA', 'UKR', 'أوكرانيا'),
(49427, 3245078528, 3245079551, 'PL', 'POL', 'بولندا'),
(49428, 3245079552, 3245080575, 'CZ', 'CZE', 'التشيك'),
(49429, 3245080576, 3245082623, 'SE', 'SWE', 'السويد'),
(49430, 3245082624, 3245084927, 'DE', 'DEU', 'ألمانيا'),
(49431, 3245084928, 3245085183, 'BE', 'BEL', 'بلجيكا'),
(49432, 3245085184, 3245085439, 'GB', 'GBR', 'المملكة المتحدة'),
(49433, 3245085440, 3245085695, 'DE', 'DEU', 'ألمانيا'),
(49434, 3245085696, 3245086207, 'FR', 'FRA', 'فرنسا'),
(49435, 3245086208, 3245086463, 'AT', 'AUT', 'النمسا'),
(49436, 3245086720, 3245086975, 'BG', 'BGR', 'بلغاريا'),
(49437, 3245086976, 3245087231, 'IT', 'ITA', 'إيطاليا'),
(49438, 3245087232, 3245087487, 'CH', 'CHE', 'سويسرا'),
(49439, 3245087488, 3245087743, 'NL', 'NLD', 'هولندا'),
(49440, 3245088000, 3245088255, 'LV', 'LVA', 'لاتفيا'),
(49441, 3245088256, 3245088511, 'KW', 'KWT', 'الكويت'),
(49442, 3245088512, 3245088767, 'FR', 'FRA', 'فرنسا'),
(49443, 3245088768, 3245089279, 'BG', 'BGR', 'بلغاريا'),
(49444, 3245089280, 3245089791, 'PL', 'POL', 'بولندا'),
(49445, 3245089792, 3245090303, 'BG', 'BGR', 'بلغاريا'),
(49446, 3245090304, 3245090815, 'UA', 'UKR', 'أوكرانيا'),
(49447, 3245090816, 3245091327, 'AT', 'AUT', 'النمسا'),
(49448, 3245091328, 3245091839, 'SE', 'SWE', 'السويد'),
(49449, 3245091840, 3245093887, 'UA', 'UKR', 'أوكرانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(49450, 3245093888, 3245094911, 'RO', 'ROM', 'رومانيا'),
(49451, 3245094912, 3245095935, 'UA', 'UKR', 'أوكرانيا'),
(49452, 3245095936, 3245096959, 'IT', 'ITA', 'إيطاليا'),
(49453, 3245096960, 3245099007, 'CZ', 'CZE', 'التشيك'),
(49454, 3245099008, 3245103103, 'GB', 'GBR', 'المملكة المتحدة'),
(49455, 3245105152, 3245105663, 'GB', 'GBR', 'المملكة المتحدة'),
(49456, 3245105664, 3245106175, 'NL', 'NLD', 'هولندا'),
(49457, 3245106176, 3245106687, 'AT', 'AUT', 'النمسا'),
(49458, 3245106688, 3245107711, 'UA', 'UKR', 'أوكرانيا'),
(49459, 3245107712, 3245108735, 'CZ', 'CZE', 'التشيك'),
(49460, 3245108736, 3245109247, 'FR', 'FRA', 'فرنسا'),
(49461, 3245109248, 3245112319, 'UA', 'UKR', 'أوكرانيا'),
(49462, 3245112320, 3245113343, 'PL', 'POL', 'بولندا'),
(49463, 3245113344, 3245113855, 'UA', 'UKR', 'أوكرانيا'),
(49464, 3245113856, 3245114367, 'RU', 'RUS', 'الإتحاد الروسي'),
(49465, 3245114368, 3245114879, 'SK', 'SVK', 'سلوفاكيا'),
(49466, 3245114880, 3245115391, 'JO', 'JOR', 'الأردن'),
(49467, 3245115392, 3245115903, 'CH', 'CHE', 'سويسرا'),
(49468, 3245115904, 3245116415, 'AT', 'AUT', 'النمسا'),
(49469, 3245116416, 3245116927, 'FR', 'FRA', 'فرنسا'),
(49470, 3245116928, 3245117439, 'KW', 'KWT', 'الكويت'),
(49471, 3245117440, 3245118463, 'LV', 'LVA', 'لاتفيا'),
(49472, 3245118464, 3245119487, 'GB', 'GBR', 'المملكة المتحدة'),
(49473, 3245120512, 3245121535, 'GB', 'GBR', 'المملكة المتحدة'),
(49474, 3245121536, 3245122047, 'GR', 'GRC', 'اليونان'),
(49475, 3245122048, 3245122559, 'UA', 'UKR', 'أوكرانيا'),
(49476, 3245122560, 3245123071, 'DE', 'DEU', 'ألمانيا'),
(49477, 3245123072, 3245123583, 'FR', 'FRA', 'فرنسا'),
(49478, 3245123584, 3245124095, 'GB', 'GBR', 'المملكة المتحدة'),
(49479, 3245124096, 3245124607, 'UA', 'UKR', 'أوكرانيا'),
(49480, 3245124608, 3245125119, 'DE', 'DEU', 'ألمانيا'),
(49481, 3245125120, 3245125631, 'ES', 'ESP', 'إسبانيا'),
(49482, 3245125632, 3245125887, 'DE', 'DEU', 'ألمانيا'),
(49483, 3245125888, 3245126143, 'PL', 'POL', 'بولندا'),
(49484, 3245126144, 3245126399, 'FR', 'FRA', 'فرنسا'),
(49485, 3245126400, 3245126655, 'DE', 'DEU', 'ألمانيا'),
(49486, 3245126656, 3245126911, 'FR', 'FRA', 'فرنسا'),
(49487, 3245126912, 3245127167, 'DE', 'DEU', 'ألمانيا'),
(49488, 3245127168, 3245127423, 'RU', 'RUS', 'الإتحاد الروسي'),
(49489, 3245127424, 3245127679, 'AT', 'AUT', 'النمسا'),
(49490, 3245127680, 3245127935, 'DE', 'DEU', 'ألمانيا'),
(49491, 3245127936, 3245128191, 'LV', 'LVA', 'لاتفيا'),
(49492, 3245128192, 3245128447, 'IT', 'ITA', 'إيطاليا'),
(49493, 3245128448, 3245128703, 'CH', 'CHE', 'سويسرا'),
(49494, 3245128704, 3245128959, 'GB', 'GBR', 'المملكة المتحدة'),
(49495, 3245128960, 3245129471, 'DK', 'DNK', 'الدنيمارك'),
(49496, 3245129472, 3245129983, 'GB', 'GBR', 'المملكة المتحدة'),
(49497, 3245129984, 3245130239, 'DE', 'DEU', 'ألمانيا'),
(49498, 3245130240, 3245130495, 'PL', 'POL', 'بولندا'),
(49499, 3245130496, 3245130751, 'IL', 'ISR', 'إسرائيل'),
(49500, 3245130752, 3245131007, 'SE', 'SWE', 'السويد'),
(49501, 3245131008, 3245131519, 'FR', 'FRA', 'فرنسا'),
(49502, 3245131520, 3245132031, 'GB', 'GBR', 'المملكة المتحدة'),
(49503, 3245132032, 3245132287, 'BE', 'BEL', 'بلجيكا'),
(49504, 3245132288, 3245132543, 'PL', 'POL', 'بولندا'),
(49505, 3245132544, 3245132799, 'FR', 'FRA', 'فرنسا'),
(49506, 3245132800, 3245133311, 'IT', 'ITA', 'إيطاليا'),
(49507, 3245133312, 3245133567, 'PL', 'POL', 'بولندا'),
(49508, 3245133568, 3245133823, 'RU', 'RUS', 'الإتحاد الروسي'),
(49509, 3245133824, 3245134079, 'NO', 'NOR', 'النرويج'),
(49510, 3245134080, 3245134335, 'UA', 'UKR', 'أوكرانيا'),
(49511, 3245134336, 3245134591, 'NL', 'NLD', 'هولندا'),
(49512, 3245134592, 3245134847, 'IL', 'ISR', 'إسرائيل'),
(49513, 3245134848, 3245135103, 'AT', 'AUT', 'النمسا'),
(49514, 3245135104, 3245135359, 'TR', 'TUR', 'تركيا'),
(49515, 3245135616, 3245135871, 'BE', 'BEL', 'بلجيكا'),
(49516, 3245135872, 3245136127, 'FR', 'FRA', 'فرنسا'),
(49517, 3245136128, 3245136383, 'DE', 'DEU', 'ألمانيا'),
(49518, 3245136384, 3245136639, 'GB', 'GBR', 'المملكة المتحدة'),
(49519, 3245136896, 3245137151, 'PL', 'POL', 'بولندا'),
(49520, 3245137408, 3245137663, 'DE', 'DEU', 'ألمانيا'),
(49521, 3245137664, 3245137919, 'SE', 'SWE', 'السويد'),
(49522, 3245137920, 3245138431, 'DK', 'DNK', 'الدنيمارك'),
(49523, 3245138432, 3245138943, 'UA', 'UKR', 'أوكرانيا'),
(49524, 3245138944, 3245139455, 'PL', 'POL', 'بولندا'),
(49525, 3245139456, 3245139967, 'RU', 'RUS', 'الإتحاد الروسي'),
(49526, 3245139968, 3245140479, 'CH', 'CHE', 'سويسرا'),
(49527, 3245140480, 3245140991, 'RO', 'ROM', 'رومانيا'),
(49528, 3245140992, 3245141503, 'UA', 'UKR', 'أوكرانيا'),
(49529, 3245142016, 3245143039, 'UA', 'UKR', 'أوكرانيا'),
(49530, 3245143040, 3245144063, 'GB', 'GBR', 'المملكة المتحدة'),
(49531, 3245144064, 3245145087, 'UA', 'UKR', 'أوكرانيا'),
(49532, 3245146112, 3245147135, 'FR', 'FRA', 'فرنسا'),
(49533, 3245147136, 3245148159, 'DE', 'DEU', 'ألمانيا'),
(49534, 3245148160, 3245149183, 'UA', 'UKR', 'أوكرانيا'),
(49535, 3245149184, 3245150207, 'RU', 'RUS', 'الإتحاد الروسي'),
(49536, 3245150208, 3245154303, 'IS', 'ISL', 'أيسلندا'),
(49537, 3245154304, 3245158399, 'IT', 'ITA', 'إيطاليا'),
(49538, 3245158400, 3245158911, 'CH', 'CHE', 'سويسرا'),
(49539, 3245158912, 3245159423, 'GB', 'GBR', 'المملكة المتحدة'),
(49540, 3245159424, 3245159935, 'CH', 'CHE', 'سويسرا'),
(49541, 3245159936, 3245160447, 'BG', 'BGR', 'بلغاريا'),
(49542, 3245160448, 3245160959, 'DK', 'DNK', 'الدنيمارك'),
(49543, 3245160960, 3245161471, 'LU', 'LUX', 'لوكسيمبورغ'),
(49544, 3245161472, 3245161983, 'SE', 'SWE', 'السويد'),
(49545, 3245161984, 3245162495, 'BE', 'BEL', 'بلجيكا'),
(49546, 3245162496, 3245163007, 'DE', 'DEU', 'ألمانيا'),
(49547, 3245163520, 3245164543, 'RU', 'RUS', 'الإتحاد الروسي'),
(49548, 3245164544, 3245165055, 'BE', 'BEL', 'بلجيكا'),
(49549, 3245165056, 3245165567, 'AT', 'AUT', 'النمسا'),
(49550, 3245165568, 3245166079, 'RU', 'RUS', 'الإتحاد الروسي'),
(49551, 3245166080, 3245166591, 'TZ', 'TZA', 'تانزانيا'),
(49552, 3245166592, 3245166847, 'UA', 'UKR', 'أوكرانيا'),
(49553, 3245166848, 3245167103, 'GB', 'GBR', 'المملكة المتحدة'),
(49554, 3245167104, 3245167359, 'IL', 'ISR', 'إسرائيل'),
(49555, 3245167360, 3245167615, 'GB', 'GBR', 'المملكة المتحدة'),
(49556, 3245167616, 3245167871, 'UA', 'UKR', 'أوكرانيا'),
(49557, 3245167872, 3245168127, 'LV', 'LVA', 'لاتفيا'),
(49558, 3245168128, 3245168383, 'SE', 'SWE', 'السويد'),
(49559, 3245168384, 3245168639, 'FR', 'FRA', 'فرنسا'),
(49560, 3245168640, 3245168895, 'AT', 'AUT', 'النمسا'),
(49561, 3245168896, 3245169151, 'RU', 'RUS', 'الإتحاد الروسي'),
(49562, 3245169152, 3245169407, 'IT', 'ITA', 'إيطاليا'),
(49563, 3245169408, 3245169919, 'PL', 'POL', 'بولندا'),
(49564, 3245169920, 3245170175, 'UA', 'UKR', 'أوكرانيا'),
(49565, 3245170176, 3245170431, 'GB', 'GBR', 'المملكة المتحدة'),
(49566, 3245170432, 3245170687, 'CH', 'CHE', 'سويسرا'),
(49567, 3245170688, 3245171711, 'DE', 'DEU', 'ألمانيا'),
(49568, 3245171712, 3245172735, 'UA', 'UKR', 'أوكرانيا'),
(49569, 3245172736, 3245173759, 'IT', 'ITA', 'إيطاليا'),
(49570, 3245173760, 3245174783, 'UA', 'UKR', 'أوكرانيا'),
(49571, 3245174784, 3245175039, 'IT', 'ITA', 'إيطاليا'),
(49572, 3245175040, 3245175295, 'DE', 'DEU', 'ألمانيا'),
(49573, 3245175296, 3245175551, 'RU', 'RUS', 'الإتحاد الروسي'),
(49574, 3245175552, 3245175807, 'PL', 'POL', 'بولندا'),
(49575, 3245175808, 3245176063, 'GB', 'GBR', 'المملكة المتحدة'),
(49576, 3245176064, 3245176319, 'IT', 'ITA', 'إيطاليا'),
(49577, 3245176320, 3245176575, 'UA', 'UKR', 'أوكرانيا'),
(49578, 3245176576, 3245176831, 'FR', 'FRA', 'فرنسا'),
(49579, 3245176832, 3245177343, 'ES', 'ESP', 'إسبانيا'),
(49580, 3245177344, 3245177599, 'NL', 'NLD', 'هولندا'),
(49581, 3245177600, 3245177855, 'PL', 'POL', 'بولندا'),
(49582, 3245177856, 3245178111, 'SI', 'SVN', 'سلوفينيا'),
(49583, 3245178112, 3245178623, 'BE', 'BEL', 'بلجيكا'),
(49584, 3245178624, 3245178879, 'PL', 'POL', 'بولندا'),
(49585, 3245178880, 3245179391, 'UA', 'UKR', 'أوكرانيا'),
(49586, 3245179392, 3245179903, 'LU', 'LUX', 'لوكسيمبورغ'),
(49587, 3245179904, 3245180415, 'DE', 'DEU', 'ألمانيا'),
(49588, 3245180416, 3245180927, 'TR', 'TUR', 'تركيا'),
(49589, 3245180928, 3245181439, 'NL', 'NLD', 'هولندا'),
(49590, 3245181440, 3245181951, 'DE', 'DEU', 'ألمانيا'),
(49591, 3245181952, 3245182463, 'AT', 'AUT', 'النمسا'),
(49592, 3245182464, 3245182975, 'FR', 'FRA', 'فرنسا'),
(49593, 3245182976, 3245183999, 'UA', 'UKR', 'أوكرانيا'),
(49594, 3245184000, 3245187071, 'AT', 'AUT', 'النمسا'),
(49595, 3245187072, 3245190143, 'UA', 'UKR', 'أوكرانيا'),
(49596, 3245190144, 3245191167, 'ES', 'ESP', 'إسبانيا'),
(49597, 3245191168, 3245193215, 'CZ', 'CZE', 'التشيك'),
(49598, 3245193216, 3245195263, 'BE', 'BEL', 'بلجيكا'),
(49599, 3245195264, 3245197311, 'GB', 'GBR', 'المملكة المتحدة'),
(49600, 3245197312, 3245199359, 'IT', 'ITA', 'إيطاليا'),
(49601, 3245199360, 3245199615, 'LU', 'LUX', 'لوكسيمبورغ'),
(49602, 3245199616, 3245199871, 'SE', 'SWE', 'السويد'),
(49603, 3245199872, 3245200127, 'NO', 'NOR', 'النرويج'),
(49604, 3245200128, 3245200383, 'LV', 'LVA', 'لاتفيا'),
(49605, 3245200384, 3245200639, 'PL', 'POL', 'بولندا'),
(49606, 3245200640, 3245200895, 'GR', 'GRC', 'اليونان'),
(49607, 3245200896, 3245201151, 'DE', 'DEU', 'ألمانيا'),
(49608, 3245201152, 3245201407, 'GB', 'GBR', 'المملكة المتحدة'),
(49609, 3245201408, 3245201663, 'UA', 'UKR', 'أوكرانيا'),
(49610, 3245201664, 3245201919, 'NO', 'NOR', 'النرويج'),
(49611, 3245201920, 3245202175, 'SA', 'SAU', 'السعودية'),
(49612, 3245202176, 3245202687, 'GB', 'GBR', 'المملكة المتحدة'),
(49613, 3245202688, 3245203455, 'DE', 'DEU', 'ألمانيا'),
(49614, 3245203456, 3245203711, 'FR', 'FRA', 'فرنسا'),
(49615, 3245203712, 3245204223, 'PL', 'POL', 'بولندا'),
(49616, 3245204224, 3245204479, 'SI', 'SVN', 'سلوفينيا'),
(49617, 3245204480, 3245204735, 'BE', 'BEL', 'بلجيكا'),
(49618, 3245204736, 3245205247, 'ES', 'ESP', 'إسبانيا'),
(49619, 3245205248, 3245205503, 'DE', 'DEU', 'ألمانيا'),
(49620, 3245205504, 3245205759, 'AT', 'AUT', 'النمسا'),
(49621, 3245205760, 3245206015, 'IT', 'ITA', 'إيطاليا'),
(49622, 3245206016, 3245206271, 'BE', 'BEL', 'بلجيكا'),
(49623, 3245206272, 3245206527, 'LT', 'LTU', 'ليتوانيا'),
(49624, 3245206528, 3245207551, 'DE', 'DEU', 'ألمانيا'),
(49625, 3245207552, 3245208063, 'UA', 'UKR', 'أوكرانيا'),
(49626, 3245208064, 3245208575, 'DE', 'DEU', 'ألمانيا'),
(49627, 3245208576, 3245209087, 'PL', 'POL', 'بولندا'),
(49628, 3245209088, 3245209599, 'RU', 'RUS', 'الإتحاد الروسي'),
(49629, 3245209600, 3245210111, 'UA', 'UKR', 'أوكرانيا'),
(49630, 3245210112, 3245210623, 'FR', 'FRA', 'فرنسا'),
(49631, 3245210624, 3245211135, 'HU', 'HUN', 'هنغاريا'),
(49632, 3245211136, 3245211647, 'GB', 'GBR', 'المملكة المتحدة'),
(49633, 3245211648, 3245212159, 'RU', 'RUS', 'الإتحاد الروسي'),
(49634, 3245212160, 3245212671, 'NG', 'NGA', 'نيجيريا'),
(49635, 3245212672, 3245213183, 'RU', 'RUS', 'الإتحاد الروسي'),
(49636, 3245213184, 3245213695, 'DE', 'DEU', 'ألمانيا'),
(49637, 3245213696, 3245214207, 'LV', 'LVA', 'لاتفيا'),
(49638, 3245214208, 3245214719, 'AT', 'AUT', 'النمسا'),
(49639, 3245214720, 3245215231, 'SE', 'SWE', 'السويد'),
(49640, 3245215232, 3245215743, 'SI', 'SVN', 'سلوفينيا'),
(49641, 3245215744, 3245217791, 'UA', 'UKR', 'أوكرانيا'),
(49642, 3245217792, 3245218815, 'DE', 'DEU', 'ألمانيا'),
(49643, 3245218816, 3245219839, 'AT', 'AUT', 'النمسا'),
(49644, 3245219840, 3245221887, 'FI', 'FIN', 'فنلندا'),
(49645, 3245221888, 3245223935, 'DE', 'DEU', 'ألمانيا'),
(49646, 3245223936, 3245225983, 'GB', 'GBR', 'المملكة المتحدة'),
(49647, 3245225984, 3245228031, 'HU', 'HUN', 'هنغاريا'),
(49648, 3245228032, 3245229055, 'FI', 'FIN', 'فنلندا'),
(49649, 3245229056, 3245230079, 'DE', 'DEU', 'ألمانيا'),
(49650, 3245230080, 3245232127, 'UA', 'UKR', 'أوكرانيا'),
(49651, 3245232128, 3245232383, 'PL', 'POL', 'بولندا'),
(49652, 3245232384, 3245232639, 'BE', 'BEL', 'بلجيكا'),
(49653, 3245232640, 3245232895, 'BG', 'BGR', 'بلغاريا'),
(49654, 3245232896, 3245233151, 'IT', 'ITA', 'إيطاليا'),
(49655, 3245233152, 3245233407, 'DK', 'DNK', 'الدنيمارك'),
(49656, 3245233664, 3245233919, 'GR', 'GRC', 'اليونان'),
(49657, 3245233920, 3245234175, 'DK', 'DNK', 'الدنيمارك'),
(49658, 3245234176, 3245234431, 'GB', 'GBR', 'المملكة المتحدة'),
(49659, 3245234432, 3245234687, 'UA', 'UKR', 'أوكرانيا'),
(49660, 3245234688, 3245234943, 'DE', 'DEU', 'ألمانيا'),
(49661, 3245234944, 3245235199, 'GB', 'GBR', 'المملكة المتحدة'),
(49662, 3245235200, 3245235455, 'BE', 'BEL', 'بلجيكا'),
(49663, 3245235456, 3245235711, 'GB', 'GBR', 'المملكة المتحدة'),
(49664, 3245235712, 3245235967, 'AT', 'AUT', 'النمسا'),
(49665, 3245235968, 3245236223, 'CH', 'CHE', 'سويسرا'),
(49666, 3245236224, 3245237247, 'PL', 'POL', 'بولندا'),
(49667, 3245237248, 3245237759, 'UA', 'UKR', 'أوكرانيا'),
(49668, 3245237760, 3245238271, 'DE', 'DEU', 'ألمانيا'),
(49669, 3245238784, 3245239295, 'UA', 'UKR', 'أوكرانيا'),
(49670, 3245239296, 3245240319, 'FI', 'FIN', 'فنلندا'),
(49671, 3245240320, 3245241343, 'UA', 'UKR', 'أوكرانيا'),
(49672, 3245241344, 3245242367, 'DE', 'DEU', 'ألمانيا'),
(49673, 3245242368, 3245243391, 'PL', 'POL', 'بولندا'),
(49674, 3245243392, 3245244415, 'UA', 'UKR', 'أوكرانيا'),
(49675, 3245244416, 3245244671, 'ES', 'ESP', 'إسبانيا'),
(49676, 3245244672, 3245244927, 'AT', 'AUT', 'النمسا'),
(49677, 3245244928, 3245245183, 'BE', 'BEL', 'بلجيكا'),
(49678, 3245245184, 3245245439, 'CH', 'CHE', 'سويسرا'),
(49679, 3245245440, 3245245695, 'BG', 'BGR', 'بلغاريا'),
(49680, 3245245696, 3245245951, 'DE', 'DEU', 'ألمانيا'),
(49681, 3245245952, 3245246207, 'UA', 'UKR', 'أوكرانيا'),
(49682, 3245246208, 3245246463, 'GB', 'GBR', 'المملكة المتحدة'),
(49683, 3245246464, 3245246719, 'AT', 'AUT', 'النمسا'),
(49684, 3245246720, 3245246975, 'PL', 'POL', 'بولندا'),
(49685, 3245246976, 3245247231, 'GB', 'GBR', 'المملكة المتحدة'),
(49686, 3245247232, 3245247487, 'DE', 'DEU', 'ألمانيا'),
(49687, 3245247488, 3245247999, 'FR', 'FRA', 'فرنسا'),
(49688, 3245248000, 3245248255, 'PL', 'POL', 'بولندا'),
(49689, 3245248256, 3245248511, 'GB', 'GBR', 'المملكة المتحدة'),
(49690, 3245248512, 3245248767, 'UA', 'UKR', 'أوكرانيا'),
(49691, 3245248768, 3245249023, 'SI', 'SVN', 'سلوفينيا'),
(49692, 3245249024, 3245249279, 'FR', 'FRA', 'فرنسا'),
(49693, 3245249280, 3245249535, 'NL', 'NLD', 'هولندا'),
(49694, 3245249536, 3245249791, 'FR', 'FRA', 'فرنسا'),
(49695, 3245249792, 3245250047, 'GB', 'GBR', 'المملكة المتحدة'),
(49696, 3245250048, 3245250303, 'DE', 'DEU', 'ألمانيا'),
(49697, 3245250304, 3245250559, 'IT', 'ITA', 'إيطاليا'),
(49698, 3245250560, 3245250815, 'FR', 'FRA', 'فرنسا'),
(49699, 3245250816, 3245251071, 'DE', 'DEU', 'ألمانيا'),
(49700, 3245251072, 3245251327, 'ES', 'ESP', 'إسبانيا'),
(49701, 3245251328, 3245251583, 'MT', 'MLT', 'مالطا'),
(49702, 3245251584, 3245251839, 'UA', 'UKR', 'أوكرانيا'),
(49703, 3245251840, 3245252095, 'NL', 'NLD', 'هولندا'),
(49704, 3245252096, 3245252351, 'BE', 'BEL', 'بلجيكا'),
(49705, 3245252352, 3245252607, 'BG', 'BGR', 'بلغاريا'),
(49706, 3245252608, 3245253631, 'UA', 'UKR', 'أوكرانيا'),
(49707, 3245253632, 3245254143, 'LV', 'LVA', 'لاتفيا'),
(49708, 3245254144, 3245254655, 'DK', 'DNK', 'الدنيمارك'),
(49709, 3245254656, 3245255167, 'UA', 'UKR', 'أوكرانيا'),
(49710, 3245255168, 3245255679, 'TR', 'TUR', 'تركيا'),
(49711, 3245255680, 3245257215, 'UA', 'UKR', 'أوكرانيا'),
(49712, 3245257216, 3245257727, 'DE', 'DEU', 'ألمانيا'),
(49713, 3245257728, 3245258239, 'GB', 'GBR', 'المملكة المتحدة'),
(49714, 3245258240, 3245258751, 'AT', 'AUT', 'النمسا'),
(49715, 3245258752, 3245259263, 'UA', 'UKR', 'أوكرانيا'),
(49716, 3245259264, 3245259775, 'SK', 'SVK', 'سلوفاكيا'),
(49717, 3245259776, 3245260287, 'UA', 'UKR', 'أوكرانيا'),
(49718, 3245260288, 3245260799, 'BE', 'BEL', 'بلجيكا'),
(49719, 3245260800, 3245261823, 'DE', 'DEU', 'ألمانيا'),
(49720, 3245261824, 3245262847, 'DK', 'DNK', 'الدنيمارك'),
(49721, 3245262848, 3245263871, 'IT', 'ITA', 'إيطاليا'),
(49722, 3245263872, 3245264895, 'DE', 'DEU', 'ألمانيا'),
(49723, 3245264896, 3245266943, 'TR', 'TUR', 'تركيا'),
(49724, 3245266944, 3245268991, 'BG', 'BGR', 'بلغاريا'),
(49725, 3245268992, 3245270015, 'FI', 'FIN', 'فنلندا'),
(49726, 3245270016, 3245271039, 'PL', 'POL', 'بولندا'),
(49727, 3245271040, 3245272063, 'NL', 'NLD', 'هولندا'),
(49728, 3245272064, 3245273087, 'RU', 'RUS', 'الإتحاد الروسي'),
(49729, 3245273088, 3245275135, 'GB', 'GBR', 'المملكة المتحدة'),
(49730, 3245275136, 3245277183, 'BE', 'BEL', 'بلجيكا'),
(49731, 3245277184, 3245277695, 'UA', 'UKR', 'أوكرانيا'),
(49732, 3245277696, 3245278207, 'RU', 'RUS', 'الإتحاد الروسي'),
(49733, 3245278208, 3245278719, 'GB', 'GBR', 'المملكة المتحدة'),
(49734, 3245278720, 3245279743, 'UA', 'UKR', 'أوكرانيا'),
(49735, 3245279744, 3245280255, 'TJ', 'TJK', 'طاجيكيستان'),
(49736, 3245280256, 3245280767, 'BE', 'BEL', 'بلجيكا'),
(49737, 3245280768, 3245281279, 'FR', 'FRA', 'فرنسا'),
(49738, 3245281280, 3245281791, 'RO', 'ROM', 'رومانيا'),
(49739, 3245281792, 3245282303, 'ES', 'ESP', 'إسبانيا'),
(49740, 3245282304, 3245282815, 'IT', 'ITA', 'إيطاليا'),
(49741, 3245282816, 3245283327, 'PL', 'POL', 'بولندا'),
(49742, 3245283328, 3245283839, 'GB', 'GBR', 'المملكة المتحدة'),
(49743, 3245283840, 3245284351, 'PL', 'POL', 'بولندا'),
(49744, 3245284352, 3245284863, 'GB', 'GBR', 'المملكة المتحدة'),
(49745, 3245284864, 3245285375, 'PL', 'POL', 'بولندا'),
(49746, 3245285376, 3245285631, 'NL', 'NLD', 'هولندا'),
(49747, 3245285632, 3245285887, 'GB', 'GBR', 'المملكة المتحدة'),
(49748, 3245285888, 3245286143, 'DE', 'DEU', 'ألمانيا'),
(49749, 3245286144, 3245286399, 'GB', 'GBR', 'المملكة المتحدة'),
(49750, 3245286400, 3245287423, 'PL', 'POL', 'بولندا'),
(49751, 3245287424, 3245287679, 'DE', 'DEU', 'ألمانيا'),
(49752, 3245287680, 3245287935, 'PL', 'POL', 'بولندا'),
(49753, 3245287936, 3245288191, 'PT', 'PRT', 'البورتوغال'),
(49754, 3245288192, 3245288703, 'DE', 'DEU', 'ألمانيا'),
(49755, 3245288704, 3245288959, 'FI', 'FIN', 'فنلندا'),
(49756, 3245288960, 3245289215, 'IT', 'ITA', 'إيطاليا'),
(49757, 3245289216, 3245289471, 'AT', 'AUT', 'النمسا'),
(49758, 3245289472, 3245290495, 'UA', 'UKR', 'أوكرانيا'),
(49759, 3245290496, 3245291519, 'LU', 'LUX', 'لوكسيمبورغ'),
(49760, 3245291520, 3245292543, 'DE', 'DEU', 'ألمانيا'),
(49761, 3245292544, 3245293567, 'UA', 'UKR', 'أوكرانيا'),
(49762, 3245293568, 3245294079, 'FI', 'FIN', 'فنلندا'),
(49763, 3245294080, 3245294591, 'ES', 'ESP', 'إسبانيا'),
(49764, 3245294592, 3245295103, 'RO', 'ROM', 'رومانيا'),
(49765, 3245295104, 3245296127, 'IT', 'ITA', 'إيطاليا'),
(49766, 3245296128, 3245296639, 'GB', 'GBR', 'المملكة المتحدة'),
(49767, 3245296640, 3245297151, 'TJ', 'TJK', 'طاجيكيستان'),
(49768, 3245297152, 3245297663, 'IT', 'ITA', 'إيطاليا'),
(49769, 3245297664, 3245297919, 'FR', 'FRA', 'فرنسا'),
(49770, 3245297920, 3245298175, 'NL', 'NLD', 'هولندا'),
(49771, 3245298176, 3245298431, 'IE', 'IRL', 'إيرلندا'),
(49772, 3245298432, 3245298687, 'UA', 'UKR', 'أوكرانيا'),
(49773, 3245298688, 3245298943, 'GB', 'GBR', 'المملكة المتحدة'),
(49774, 3245298944, 3245299199, 'UA', 'UKR', 'أوكرانيا'),
(49775, 3245299200, 3245299455, 'GB', 'GBR', 'المملكة المتحدة'),
(49776, 3245299456, 3245299711, 'CY', 'CYP', 'قبرص'),
(49777, 3245299712, 3245299967, 'DE', 'DEU', 'ألمانيا'),
(49778, 3245299968, 3245300223, 'BG', 'BGR', 'بلغاريا'),
(49779, 3245300224, 3245300479, 'FR', 'FRA', 'فرنسا'),
(49780, 3245300480, 3245300991, 'RU', 'RUS', 'الإتحاد الروسي'),
(49781, 3245300992, 3245301247, 'FI', 'FIN', 'فنلندا'),
(49782, 3245301248, 3245301503, 'DK', 'DNK', 'الدنيمارك'),
(49783, 3245301504, 3245301759, 'BE', 'BEL', 'بلجيكا'),
(49784, 3245301760, 3245302783, 'SK', 'SVK', 'سلوفاكيا'),
(49785, 3245302784, 3245303807, 'DE', 'DEU', 'ألمانيا'),
(49786, 3245303808, 3245304831, 'SE', 'SWE', 'السويد'),
(49787, 3245304832, 3245306367, 'DE', 'DEU', 'ألمانيا'),
(49788, 3245306368, 3245306879, 'UA', 'UKR', 'أوكرانيا'),
(49789, 3245306880, 3245307391, 'RU', 'RUS', 'الإتحاد الروسي'),
(49790, 3245307392, 3245307903, 'FI', 'FIN', 'فنلندا'),
(49791, 3245307904, 3245308415, 'RO', 'ROM', 'رومانيا'),
(49792, 3245308416, 3245308927, 'ES', 'ESP', 'إسبانيا'),
(49793, 3245308928, 3245309439, 'SE', 'SWE', 'السويد'),
(49794, 3245309440, 3245309951, 'UA', 'UKR', 'أوكرانيا'),
(49795, 3245309952, 3245311999, 'CZ', 'CZE', 'التشيك'),
(49796, 3245312000, 3245314047, 'GB', 'GBR', 'المملكة المتحدة'),
(49797, 3245314048, 3245315071, 'PL', 'POL', 'بولندا'),
(49798, 3245315072, 3245316095, 'IT', 'ITA', 'إيطاليا'),
(49799, 3245316096, 3245317119, 'SE', 'SWE', 'السويد'),
(49800, 3245317120, 3245318143, 'UA', 'UKR', 'أوكرانيا'),
(49801, 3245318144, 3245318399, 'IT', 'ITA', 'إيطاليا'),
(49802, 3245318400, 3245318655, 'RO', 'ROM', 'رومانيا'),
(49803, 3245318656, 3245318911, 'DK', 'DNK', 'الدنيمارك'),
(49804, 3245318912, 3245319167, 'DE', 'DEU', 'ألمانيا'),
(49805, 3245319168, 3245319423, 'HR', 'HRV', 'كرواتيا'),
(49806, 3245319424, 3245319679, 'SE', 'SWE', 'السويد'),
(49807, 3245319680, 3245319935, 'PL', 'POL', 'بولندا'),
(49808, 3245319936, 3245320191, 'DE', 'DEU', 'ألمانيا'),
(49809, 3245320192, 3245320703, 'GB', 'GBR', 'المملكة المتحدة'),
(49810, 3245320704, 3245320959, 'DE', 'DEU', 'ألمانيا'),
(49811, 3245320960, 3245321215, 'IE', 'IRL', 'إيرلندا'),
(49812, 3245321216, 3245321471, 'NL', 'NLD', 'هولندا'),
(49813, 3245321472, 3245321727, 'UA', 'UKR', 'أوكرانيا'),
(49814, 3245321728, 3245321983, 'PL', 'POL', 'بولندا'),
(49815, 3245321984, 3245322239, 'DE', 'DEU', 'ألمانيا'),
(49816, 3245322240, 3245323263, 'RU', 'RUS', 'الإتحاد الروسي'),
(49817, 3245323264, 3245325311, 'GB', 'GBR', 'المملكة المتحدة'),
(49818, 3245325312, 3245326335, 'UA', 'UKR', 'أوكرانيا'),
(49819, 3245326336, 3245326847, 'SI', 'SVN', 'سلوفينيا'),
(49820, 3245326848, 3245327359, 'BG', 'BGR', 'بلغاريا'),
(49821, 3245327360, 3245327871, 'CH', 'CHE', 'سويسرا'),
(49822, 3245327872, 3245328383, 'DE', 'DEU', 'ألمانيا'),
(49823, 3245328384, 3245328895, 'GB', 'GBR', 'المملكة المتحدة'),
(49824, 3245328896, 3245329407, 'CH', 'CHE', 'سويسرا'),
(49825, 3245329408, 3245329919, 'UA', 'UKR', 'أوكرانيا'),
(49826, 3245329920, 3245333503, 'DE', 'DEU', 'ألمانيا'),
(49827, 3245333504, 3245334527, 'SI', 'SVN', 'سلوفينيا'),
(49828, 3245334528, 3245334783, 'HU', 'HUN', 'هنغاريا'),
(49829, 3245334784, 3245335039, 'BE', 'BEL', 'بلجيكا'),
(49830, 3245335040, 3245335551, 'GB', 'GBR', 'المملكة المتحدة'),
(49831, 3245335552, 3245335807, 'NL', 'NLD', 'هولندا'),
(49832, 3245335808, 3245336063, 'RO', 'ROM', 'رومانيا'),
(49833, 3245336064, 3245336575, 'GB', 'GBR', 'المملكة المتحدة'),
(49834, 3245336576, 3245336831, 'RO', 'ROM', 'رومانيا'),
(49835, 3245336832, 3245337087, 'DE', 'DEU', 'ألمانيا'),
(49836, 3245337088, 3245337343, 'GB', 'GBR', 'المملكة المتحدة'),
(49837, 3245337344, 3245337599, 'BE', 'BEL', 'بلجيكا'),
(49838, 3245337600, 3245337855, 'PL', 'POL', 'بولندا'),
(49839, 3245337856, 3245338367, 'DE', 'DEU', 'ألمانيا'),
(49840, 3245338368, 3245339647, 'UA', 'UKR', 'أوكرانيا'),
(49841, 3245339648, 3245340671, 'LV', 'LVA', 'لاتفيا'),
(49842, 3245340672, 3245341695, 'UA', 'UKR', 'أوكرانيا'),
(49843, 3245341696, 3245342719, 'RU', 'RUS', 'الإتحاد الروسي'),
(49844, 3245342720, 3245867007, 'GB', 'GBR', 'المملكة المتحدة'),
(49845, 3245867008, 3245868543, 'IE', 'IRL', 'إيرلندا'),
(49846, 3245868544, 3245868575, 'GB', 'GBR', 'المملكة المتحدة'),
(49847, 3245868576, 3245878303, 'IE', 'IRL', 'إيرلندا'),
(49848, 3245878304, 3245878335, 'US', 'USA', 'الولايات المتحدة'),
(49849, 3245878336, 3245888703, 'IE', 'IRL', 'إيرلندا'),
(49850, 3245888704, 3245888767, 'US', 'USA', 'الولايات المتحدة'),
(49851, 3245888768, 3245892639, 'IE', 'IRL', 'إيرلندا'),
(49852, 3245892640, 3245892647, 'US', 'USA', 'الولايات المتحدة'),
(49853, 3245892648, 3245894391, 'IE', 'IRL', 'إيرلندا'),
(49854, 3245894392, 3245894399, 'GB', 'GBR', 'المملكة المتحدة'),
(49855, 3245894400, 3245894719, 'IE', 'IRL', 'إيرلندا'),
(49856, 3245894720, 3245894751, 'US', 'USA', 'الولايات المتحدة'),
(49857, 3245894752, 3245896311, 'IE', 'IRL', 'إيرلندا'),
(49858, 3245896312, 3245896319, 'GB', 'GBR', 'المملكة المتحدة'),
(49859, 3245896320, 3245896991, 'IE', 'IRL', 'إيرلندا'),
(49860, 3245896992, 3245897007, 'US', 'USA', 'الولايات المتحدة'),
(49861, 3245897008, 3245899343, 'IE', 'IRL', 'إيرلندا'),
(49862, 3245899344, 3245899351, 'GB', 'GBR', 'المملكة المتحدة'),
(49863, 3245899352, 3245901831, 'IE', 'IRL', 'إيرلندا'),
(49864, 3245901832, 3245901839, 'GB', 'GBR', 'المملكة المتحدة'),
(49865, 3245901840, 3245902887, 'IE', 'IRL', 'إيرلندا'),
(49866, 3245902888, 3245902895, 'GB', 'GBR', 'المملكة المتحدة'),
(49867, 3245902896, 3245902903, 'IE', 'IRL', 'إيرلندا'),
(49868, 3245902904, 3245902911, 'GB', 'GBR', 'المملكة المتحدة'),
(49869, 3245902912, 3245903031, 'IE', 'IRL', 'إيرلندا'),
(49870, 3245903032, 3245903039, 'GB', 'GBR', 'المملكة المتحدة'),
(49871, 3245903040, 3245903959, 'IE', 'IRL', 'إيرلندا'),
(49872, 3245903960, 3245903967, 'FR', 'FRA', 'فرنسا'),
(49873, 3245903968, 3245904199, 'IE', 'IRL', 'إيرلندا'),
(49874, 3245904200, 3245904207, 'GB', 'GBR', 'المملكة المتحدة'),
(49875, 3245904208, 3245906367, 'IE', 'IRL', 'إيرلندا'),
(49876, 3245906368, 3245906431, 'GB', 'GBR', 'المملكة المتحدة'),
(49877, 3245906432, 3245910831, 'IE', 'IRL', 'إيرلندا'),
(49878, 3245910832, 3245910847, 'GB', 'GBR', 'المملكة المتحدة'),
(49879, 3245910848, 3245921279, 'IE', 'IRL', 'إيرلندا'),
(49880, 3245921280, 3245921535, 'BE', 'BEL', 'بلجيكا'),
(49881, 3245921536, 3245922959, 'IE', 'IRL', 'إيرلندا'),
(49882, 3245922960, 3245922975, 'US', 'USA', 'الولايات المتحدة'),
(49883, 3245922976, 3245924647, 'IE', 'IRL', 'إيرلندا'),
(49884, 3245924648, 3245924655, 'GB', 'GBR', 'المملكة المتحدة'),
(49885, 3245924656, 3245924671, 'IE', 'IRL', 'إيرلندا'),
(49886, 3245924672, 3245924679, 'GB', 'GBR', 'المملكة المتحدة'),
(49887, 3245924680, 3245924687, 'IE', 'IRL', 'إيرلندا'),
(49888, 3245924688, 3245924695, 'GB', 'GBR', 'المملكة المتحدة'),
(49889, 3245924696, 3245924751, 'IE', 'IRL', 'إيرلندا'),
(49890, 3245924752, 3245924767, 'GB', 'GBR', 'المملكة المتحدة'),
(49891, 3245924768, 3245927959, 'IE', 'IRL', 'إيرلندا'),
(49892, 3245927960, 3245927967, 'US', 'USA', 'الولايات المتحدة'),
(49893, 3245927968, 3245931263, 'IE', 'IRL', 'إيرلندا'),
(49894, 3245931264, 3245931519, 'GB', 'GBR', 'المملكة المتحدة'),
(49895, 3245931520, 3245932543, 'IE', 'IRL', 'إيرلندا'),
(49896, 3245932544, 3245998079, 'BE', 'BEL', 'بلجيكا'),
(49897, 3245998080, 3246100351, 'GB', 'GBR', 'المملكة المتحدة'),
(49898, 3246100352, 3246100367, 'DE', 'DEU', 'ألمانيا'),
(49899, 3246100368, 3246128479, 'GB', 'GBR', 'المملكة المتحدة'),
(49900, 3246128480, 3246128495, 'DE', 'DEU', 'ألمانيا'),
(49901, 3246128496, 3246129151, 'GB', 'GBR', 'المملكة المتحدة'),
(49902, 3246129152, 3246141439, 'RU', 'RUS', 'الإتحاد الروسي'),
(49903, 3246141440, 3246141695, 'UA', 'UKR', 'أوكرانيا'),
(49904, 3246141696, 3246142975, 'RU', 'RUS', 'الإتحاد الروسي'),
(49905, 3246142976, 3246143231, 'UA', 'UKR', 'أوكرانيا'),
(49906, 3246143232, 3246143743, 'RU', 'RUS', 'الإتحاد الروسي'),
(49907, 3246143744, 3246143999, 'UA', 'UKR', 'أوكرانيا'),
(49908, 3246144000, 3246144255, 'RU', 'RUS', 'الإتحاد الروسي'),
(49909, 3246144256, 3246145023, 'UA', 'UKR', 'أوكرانيا'),
(49910, 3246145024, 3246147839, 'RU', 'RUS', 'الإتحاد الروسي'),
(49911, 3246147840, 3246148095, 'UA', 'UKR', 'أوكرانيا'),
(49912, 3246148096, 3246148607, 'RU', 'RUS', 'الإتحاد الروسي'),
(49913, 3246148608, 3246149631, 'UA', 'UKR', 'أوكرانيا'),
(49914, 3246149632, 3246260223, 'RU', 'RUS', 'الإتحاد الروسي'),
(49915, 3246260224, 3246325759, 'PT', 'PRT', 'البورتوغال'),
(49916, 3246325760, 3246328831, 'ES', 'ESP', 'إسبانيا'),
(49917, 3246329088, 3246329855, 'ES', 'ESP', 'إسبانيا'),
(49918, 3246350848, 3246351103, 'ES', 'ESP', 'إسبانيا'),
(49919, 3246351616, 3246352639, 'ES', 'ESP', 'إسبانيا'),
(49920, 3246375160, 3246375423, 'GB', 'GBR', 'المملكة المتحدة'),
(49921, 3246378496, 3246379007, 'ES', 'ESP', 'إسبانيا'),
(49922, 3246379008, 3246381055, 'GB', 'GBR', 'المملكة المتحدة'),
(49923, 3246391296, 3246418887, 'GB', 'GBR', 'المملكة المتحدة'),
(49924, 3246418888, 3246418895, 'SE', 'SWE', 'السويد'),
(49925, 3246418896, 3246613503, 'GB', 'GBR', 'المملكة المتحدة'),
(49926, 3246613504, 3246614527, 'HU', 'HUN', 'هنغاريا'),
(49927, 3246614528, 3246784511, 'GB', 'GBR', 'المملكة المتحدة'),
(49928, 3246784512, 3246915583, 'CH', 'CHE', 'سويسرا'),
(49929, 3246915584, 3247046655, 'PT', 'PRT', 'البورتوغال'),
(49930, 3247046656, 3247046911, 'AT', 'AUT', 'النمسا'),
(49931, 3247046912, 3247048191, 'SI', 'SVN', 'سلوفينيا'),
(49932, 3247048704, 3247048959, 'EE', 'EST', 'إستونيا'),
(49933, 3247048960, 3247049215, 'SI', 'SVN', 'سلوفينيا'),
(49934, 3247049216, 3247054079, 'DE', 'DEU', 'ألمانيا'),
(49935, 3247054080, 3247054335, 'CH', 'CHE', 'سويسرا'),
(49936, 3247054336, 3247054591, 'LT', 'LTU', 'ليتوانيا'),
(49937, 3247054592, 3247054847, 'DE', 'DEU', 'ألمانيا'),
(49938, 3247054848, 3247063039, 'SI', 'SVN', 'سلوفينيا'),
(49939, 3247063040, 3247063295, 'FR', 'FRA', 'فرنسا'),
(49940, 3247063296, 3247063551, 'GR', 'GRC', 'اليونان'),
(49941, 3247063552, 3247063807, 'DE', 'DEU', 'ألمانيا'),
(49942, 3247063808, 3247064063, 'BG', 'BGR', 'بلغاريا'),
(49943, 3247064064, 3247064319, 'DE', 'DEU', 'ألمانيا'),
(49944, 3247064320, 3247064575, 'CH', 'CHE', 'سويسرا'),
(49945, 3247064576, 3247064831, 'RU', 'RUS', 'الإتحاد الروسي'),
(49946, 3247064832, 3247065087, 'SE', 'SWE', 'السويد'),
(49947, 3247065088, 3247065343, 'US', 'USA', 'الولايات المتحدة'),
(49948, 3247065344, 3247065599, 'CH', 'CHE', 'سويسرا'),
(49949, 3247065600, 3247065855, 'SE', 'SWE', 'السويد'),
(49950, 3247065856, 3247066111, 'GB', 'GBR', 'المملكة المتحدة'),
(49951, 3247066112, 3247066367, 'DK', 'DNK', 'الدنيمارك'),
(49952, 3247066368, 3247066623, 'UA', 'UKR', 'أوكرانيا'),
(49953, 3247066624, 3247066879, 'CZ', 'CZE', 'التشيك'),
(49954, 3247066880, 3247067135, 'RU', 'RUS', 'الإتحاد الروسي'),
(49955, 3247067136, 3247067647, 'DE', 'DEU', 'ألمانيا'),
(49956, 3247067648, 3247067903, 'RU', 'RUS', 'الإتحاد الروسي'),
(49957, 3247067904, 3247068159, 'CH', 'CHE', 'سويسرا'),
(49958, 3247068160, 3247068415, 'UA', 'UKR', 'أوكرانيا'),
(49959, 3247068416, 3247068671, 'RO', 'ROM', 'رومانيا'),
(49960, 3247068672, 3247068927, 'GB', 'GBR', 'المملكة المتحدة'),
(49961, 3247068928, 3247069183, 'UA', 'UKR', 'أوكرانيا'),
(49962, 3247069184, 3247069439, 'DE', 'DEU', 'ألمانيا'),
(49963, 3247069440, 3247069695, 'RU', 'RUS', 'الإتحاد الروسي'),
(49964, 3247069696, 3247069951, 'FR', 'FRA', 'فرنسا'),
(49965, 3247069952, 3247070207, 'DE', 'DEU', 'ألمانيا'),
(49966, 3247070208, 3247070463, 'IL', 'ISR', 'إسرائيل'),
(49967, 3247070464, 3247070719, 'UA', 'UKR', 'أوكرانيا'),
(49968, 3247070720, 3247070975, 'AT', 'AUT', 'النمسا'),
(49969, 3247070976, 3247071231, 'GB', 'GBR', 'المملكة المتحدة'),
(49970, 3247071232, 3247071487, 'DE', 'DEU', 'ألمانيا'),
(49971, 3247071488, 3247072255, 'RO', 'ROM', 'رومانيا'),
(49972, 3247072256, 3247072511, 'IE', 'IRL', 'إيرلندا'),
(49973, 3247072512, 3247072767, 'BE', 'BEL', 'بلجيكا'),
(49974, 3247072768, 3247073023, 'SE', 'SWE', 'السويد'),
(49975, 3247073024, 3247073279, 'RO', 'ROM', 'رومانيا'),
(49976, 3247073280, 3247073535, 'DE', 'DEU', 'ألمانيا'),
(49977, 3247073536, 3247073791, 'AT', 'AUT', 'النمسا'),
(49978, 3247073792, 3247074047, 'CZ', 'CZE', 'التشيك'),
(49979, 3247074048, 3247074303, 'GB', 'GBR', 'المملكة المتحدة'),
(49980, 3247074304, 3247074559, 'DE', 'DEU', 'ألمانيا'),
(49981, 3247074560, 3247074815, 'SE', 'SWE', 'السويد'),
(49982, 3247074816, 3247075071, 'PL', 'POL', 'بولندا'),
(49983, 3247075072, 3247075327, 'IE', 'IRL', 'إيرلندا'),
(49984, 3247075328, 3247075839, 'DE', 'DEU', 'ألمانيا'),
(49985, 3247075840, 3247076095, 'UA', 'UKR', 'أوكرانيا'),
(49986, 3247076096, 3247076351, 'DK', 'DNK', 'الدنيمارك'),
(49987, 3247076352, 3247076607, 'RU', 'RUS', 'الإتحاد الروسي'),
(49988, 3247076608, 3247076863, 'DE', 'DEU', 'ألمانيا'),
(49989, 3247076864, 3247077119, 'PL', 'POL', 'بولندا'),
(49990, 3247077120, 3247077375, 'DE', 'DEU', 'ألمانيا'),
(49991, 3247077376, 3247077631, 'GB', 'GBR', 'المملكة المتحدة'),
(49992, 3247077632, 3247077887, 'NL', 'NLD', 'هولندا'),
(49993, 3247077888, 3247078143, 'UA', 'UKR', 'أوكرانيا'),
(49994, 3247078144, 3247078399, 'AT', 'AUT', 'النمسا'),
(49995, 3247078400, 3247078655, 'DK', 'DNK', 'الدنيمارك'),
(49996, 3247078656, 3247078911, 'HU', 'HUN', 'هنغاريا'),
(49997, 3247078912, 3247079167, 'FI', 'FIN', 'فنلندا'),
(49998, 3247079168, 3247079423, 'HU', 'HUN', 'هنغاريا'),
(49999, 3247079424, 3247080447, 'RU', 'RUS', 'الإتحاد الروسي'),
(50000, 3247080448, 3247081471, 'UA', 'UKR', 'أوكرانيا'),
(50001, 3247081472, 3247083519, 'PL', 'POL', 'بولندا'),
(50002, 3247083520, 3247084543, 'UA', 'UKR', 'أوكرانيا'),
(50003, 3247084544, 3247085567, 'RU', 'RUS', 'الإتحاد الروسي'),
(50004, 3247086592, 3247087615, 'NL', 'NLD', 'هولندا'),
(50005, 3247087616, 3247088639, 'IT', 'ITA', 'إيطاليا'),
(50006, 3247088640, 3247089663, 'DE', 'DEU', 'ألمانيا'),
(50007, 3247089664, 3247090687, 'RO', 'ROM', 'رومانيا'),
(50008, 3247090688, 3247091711, 'LV', 'LVA', 'لاتفيا'),
(50009, 3247091712, 3247092735, 'RU', 'RUS', 'الإتحاد الروسي'),
(50010, 3247092736, 3247093759, 'DE', 'DEU', 'ألمانيا'),
(50011, 3247093760, 3247094783, 'UA', 'UKR', 'أوكرانيا'),
(50012, 3247094784, 3247095807, 'LV', 'LVA', 'لاتفيا'),
(50013, 3247095808, 3247097855, 'RO', 'ROM', 'رومانيا'),
(50014, 3247097856, 3247098879, 'FI', 'FIN', 'فنلندا'),
(50015, 3247098880, 3247099903, 'NL', 'NLD', 'هولندا'),
(50016, 3247099904, 3247100927, 'PL', 'POL', 'بولندا'),
(50017, 3247100928, 3247101951, 'CH', 'CHE', 'سويسرا'),
(50018, 3247101952, 3247102975, 'SE', 'SWE', 'السويد'),
(50019, 3247102976, 3247106047, 'NL', 'NLD', 'هولندا'),
(50020, 3247106048, 3247107071, 'RU', 'RUS', 'الإتحاد الروسي'),
(50021, 3247107072, 3247108095, 'UA', 'UKR', 'أوكرانيا'),
(50022, 3247108096, 3247109119, 'PL', 'POL', 'بولندا'),
(50023, 3247109120, 3247110143, 'UA', 'UKR', 'أوكرانيا'),
(50024, 3247110144, 3247111167, 'NL', 'NLD', 'هولندا'),
(50025, 3247111168, 3247112191, 'DE', 'DEU', 'ألمانيا'),
(50026, 3247112192, 3247177727, 'FR', 'FRA', 'فرنسا'),
(50027, 3247177728, 3247243263, 'TR', 'TUR', 'تركيا'),
(50028, 3247243264, 3247244287, 'DE', 'DEU', 'ألمانيا'),
(50029, 3247244288, 3247244351, 'NL', 'NLD', 'هولندا'),
(50030, 3247244352, 3247244359, 'DE', 'DEU', 'ألمانيا'),
(50031, 3247244360, 3247244367, 'NL', 'NLD', 'هولندا'),
(50032, 3247244368, 3247244375, 'DE', 'DEU', 'ألمانيا'),
(50033, 3247244376, 3247244927, 'NL', 'NLD', 'هولندا'),
(50034, 3247244928, 3247244935, 'DE', 'DEU', 'ألمانيا'),
(50035, 3247244936, 3247246015, 'NL', 'NLD', 'هولندا'),
(50036, 3247246016, 3247246023, 'DE', 'DEU', 'ألمانيا'),
(50037, 3247246024, 3247246039, 'NL', 'NLD', 'هولندا'),
(50038, 3247246040, 3247246047, 'DE', 'DEU', 'ألمانيا'),
(50039, 3247246048, 3247246967, 'NL', 'NLD', 'هولندا'),
(50040, 3247246968, 3247246975, 'DE', 'DEU', 'ألمانيا'),
(50041, 3247246976, 3247247111, 'NL', 'NLD', 'هولندا'),
(50042, 3247247112, 3247247119, 'DE', 'DEU', 'ألمانيا'),
(50043, 3247247120, 3247247175, 'NL', 'NLD', 'هولندا'),
(50044, 3247247176, 3247247183, 'DE', 'DEU', 'ألمانيا'),
(50045, 3247247184, 3247247543, 'NL', 'NLD', 'هولندا'),
(50046, 3247247544, 3247247551, 'DE', 'DEU', 'ألمانيا'),
(50047, 3247247552, 3247247671, 'NL', 'NLD', 'هولندا'),
(50048, 3247247672, 3247247679, 'DE', 'DEU', 'ألمانيا'),
(50049, 3247247680, 3247247879, 'NL', 'NLD', 'هولندا'),
(50050, 3247247880, 3247247887, 'DE', 'DEU', 'ألمانيا'),
(50051, 3247247888, 3247247999, 'NL', 'NLD', 'هولندا'),
(50052, 3247248000, 3247248015, 'DE', 'DEU', 'ألمانيا'),
(50053, 3247248016, 3247248095, 'NL', 'NLD', 'هولندا'),
(50054, 3247248096, 3247248103, 'DE', 'DEU', 'ألمانيا'),
(50055, 3247248104, 3247248159, 'NL', 'NLD', 'هولندا'),
(50056, 3247248160, 3247248167, 'DE', 'DEU', 'ألمانيا'),
(50057, 3247248168, 3247248175, 'NL', 'NLD', 'هولندا'),
(50058, 3247248176, 3247248183, 'DE', 'DEU', 'ألمانيا'),
(50059, 3247248184, 3247248359, 'NL', 'NLD', 'هولندا'),
(50060, 3247248360, 3247248367, 'DE', 'DEU', 'ألمانيا'),
(50061, 3247248368, 3247248383, 'NL', 'NLD', 'هولندا'),
(50062, 3247248384, 3247250431, 'DE', 'DEU', 'ألمانيا'),
(50063, 3247250432, 3247252959, 'NL', 'NLD', 'هولندا'),
(50064, 3247252960, 3247252967, 'DE', 'DEU', 'ألمانيا'),
(50065, 3247252968, 3247252999, 'NL', 'NLD', 'هولندا'),
(50066, 3247253000, 3247253007, 'DE', 'DEU', 'ألمانيا'),
(50067, 3247253008, 3247253111, 'NL', 'NLD', 'هولندا'),
(50068, 3247253112, 3247253119, 'DE', 'DEU', 'ألمانيا'),
(50069, 3247253120, 3247253503, 'NL', 'NLD', 'هولندا'),
(50070, 3247253504, 3247255295, 'DE', 'DEU', 'ألمانيا'),
(50071, 3247255296, 3247255655, 'NL', 'NLD', 'هولندا'),
(50072, 3247255656, 3247255663, 'DE', 'DEU', 'ألمانيا'),
(50073, 3247255664, 3247255711, 'NL', 'NLD', 'هولندا'),
(50074, 3247255712, 3247255719, 'DE', 'DEU', 'ألمانيا'),
(50075, 3247255720, 3247256623, 'NL', 'NLD', 'هولندا'),
(50076, 3247256624, 3247256631, 'DE', 'DEU', 'ألمانيا'),
(50077, 3247256632, 3247256831, 'NL', 'NLD', 'هولندا'),
(50078, 3247256832, 3247260671, 'DE', 'DEU', 'ألمانيا'),
(50079, 3247260672, 3247260879, 'NL', 'NLD', 'هولندا'),
(50080, 3247260880, 3247260887, 'DE', 'DEU', 'ألمانيا'),
(50081, 3247260888, 3247260983, 'NL', 'NLD', 'هولندا'),
(50082, 3247260984, 3247260991, 'DE', 'DEU', 'ألمانيا'),
(50083, 3247260992, 3247261215, 'NL', 'NLD', 'هولندا'),
(50084, 3247261216, 3247261223, 'DE', 'DEU', 'ألمانيا'),
(50085, 3247261224, 3247261935, 'NL', 'NLD', 'هولندا'),
(50086, 3247261936, 3247261943, 'DE', 'DEU', 'ألمانيا'),
(50087, 3247261944, 3247261951, 'NL', 'NLD', 'هولندا'),
(50088, 3247261952, 3247261959, 'DE', 'DEU', 'ألمانيا'),
(50089, 3247261960, 3247262151, 'NL', 'NLD', 'هولندا'),
(50090, 3247262152, 3247262159, 'DE', 'DEU', 'ألمانيا'),
(50091, 3247262160, 3247262439, 'NL', 'NLD', 'هولندا'),
(50092, 3247262440, 3247262447, 'DE', 'DEU', 'ألمانيا'),
(50093, 3247262448, 3247262663, 'NL', 'NLD', 'هولندا'),
(50094, 3247262664, 3247262671, 'DE', 'DEU', 'ألمانيا'),
(50095, 3247262672, 3247263335, 'NL', 'NLD', 'هولندا'),
(50096, 3247263336, 3247263343, 'DE', 'DEU', 'ألمانيا'),
(50097, 3247263344, 3247263599, 'NL', 'NLD', 'هولندا'),
(50098, 3247263600, 3247263607, 'DE', 'DEU', 'ألمانيا'),
(50099, 3247263608, 3247263623, 'NL', 'NLD', 'هولندا'),
(50100, 3247263624, 3247263631, 'DE', 'DEU', 'ألمانيا'),
(50101, 3247263632, 3247263911, 'NL', 'NLD', 'هولندا'),
(50102, 3247263912, 3247263919, 'DE', 'DEU', 'ألمانيا'),
(50103, 3247263920, 3247263927, 'NL', 'NLD', 'هولندا'),
(50104, 3247263928, 3247263935, 'DE', 'DEU', 'ألمانيا'),
(50105, 3247263936, 3247265095, 'NL', 'NLD', 'هولندا'),
(50106, 3247265096, 3247265103, 'DE', 'DEU', 'ألمانيا'),
(50107, 3247265104, 3247265239, 'NL', 'NLD', 'هولندا'),
(50108, 3247265240, 3247265247, 'DE', 'DEU', 'ألمانيا'),
(50109, 3247265248, 3247265663, 'NL', 'NLD', 'هولندا'),
(50110, 3247265664, 3247265671, 'DE', 'DEU', 'ألمانيا'),
(50111, 3247265672, 3247266287, 'NL', 'NLD', 'هولندا'),
(50112, 3247266288, 3247266295, 'DE', 'DEU', 'ألمانيا'),
(50113, 3247266296, 3247266359, 'NL', 'NLD', 'هولندا'),
(50114, 3247266360, 3247266367, 'DE', 'DEU', 'ألمانيا'),
(50115, 3247266368, 3247266559, 'NL', 'NLD', 'هولندا'),
(50116, 3247266560, 3247271679, 'DE', 'DEU', 'ألمانيا'),
(50117, 3247271680, 3247272375, 'NL', 'NLD', 'هولندا'),
(50118, 3247272376, 3247272383, 'DE', 'DEU', 'ألمانيا'),
(50119, 3247272384, 3247272671, 'NL', 'NLD', 'هولندا'),
(50120, 3247272672, 3247272679, 'DE', 'DEU', 'ألمانيا'),
(50121, 3247272680, 3247273063, 'NL', 'NLD', 'هولندا'),
(50122, 3247273064, 3247273071, 'DE', 'DEU', 'ألمانيا'),
(50123, 3247273072, 3247273751, 'NL', 'NLD', 'هولندا'),
(50124, 3247273752, 3247273759, 'DE', 'DEU', 'ألمانيا'),
(50125, 3247273760, 3247274239, 'NL', 'NLD', 'هولندا'),
(50126, 3247274240, 3247274495, 'DE', 'DEU', 'ألمانيا'),
(50127, 3247274496, 3247274519, 'NL', 'NLD', 'هولندا'),
(50128, 3247274520, 3247274535, 'DE', 'DEU', 'ألمانيا'),
(50129, 3247274536, 3247274567, 'NL', 'NLD', 'هولندا'),
(50130, 3247274568, 3247274575, 'DE', 'DEU', 'ألمانيا'),
(50131, 3247274576, 3247274863, 'NL', 'NLD', 'هولندا'),
(50132, 3247274864, 3247274871, 'DE', 'DEU', 'ألمانيا'),
(50133, 3247274872, 3247275263, 'NL', 'NLD', 'هولندا'),
(50134, 3247275264, 3247276031, 'DE', 'DEU', 'ألمانيا'),
(50135, 3247276032, 3247276615, 'NL', 'NLD', 'هولندا'),
(50136, 3247276616, 3247276631, 'DE', 'DEU', 'ألمانيا'),
(50137, 3247276632, 3247276871, 'NL', 'NLD', 'هولندا'),
(50138, 3247276872, 3247276879, 'DE', 'DEU', 'ألمانيا'),
(50139, 3247276880, 3247276927, 'NL', 'NLD', 'هولندا'),
(50140, 3247276928, 3247276935, 'DE', 'DEU', 'ألمانيا'),
(50141, 3247276936, 3247276951, 'NL', 'NLD', 'هولندا'),
(50142, 3247276952, 3247276959, 'DE', 'DEU', 'ألمانيا'),
(50143, 3247276960, 3247278103, 'NL', 'NLD', 'هولندا'),
(50144, 3247278104, 3247278111, 'DE', 'DEU', 'ألمانيا'),
(50145, 3247278112, 3247278847, 'NL', 'NLD', 'هولندا'),
(50146, 3247278848, 3247280127, 'DE', 'DEU', 'ألمانيا'),
(50147, 3247280128, 3247280255, 'NL', 'NLD', 'هولندا'),
(50148, 3247280256, 3247280263, 'DE', 'DEU', 'ألمانيا'),
(50149, 3247280264, 3247280279, 'NL', 'NLD', 'هولندا'),
(50150, 3247280280, 3247280287, 'DE', 'DEU', 'ألمانيا'),
(50151, 3247280288, 3247280807, 'NL', 'NLD', 'هولندا'),
(50152, 3247280808, 3247280815, 'DE', 'DEU', 'ألمانيا'),
(50153, 3247280816, 3247281447, 'NL', 'NLD', 'هولندا'),
(50154, 3247281448, 3247281455, 'DE', 'DEU', 'ألمانيا'),
(50155, 3247281456, 3247281527, 'NL', 'NLD', 'هولندا'),
(50156, 3247281528, 3247281535, 'DE', 'DEU', 'ألمانيا'),
(50157, 3247281536, 3247281567, 'NL', 'NLD', 'هولندا'),
(50158, 3247281568, 3247281575, 'DE', 'DEU', 'ألمانيا'),
(50159, 3247281576, 3247281663, 'NL', 'NLD', 'هولندا'),
(50160, 3247281664, 3247281671, 'DE', 'DEU', 'ألمانيا'),
(50161, 3247281672, 3247281855, 'NL', 'NLD', 'هولندا'),
(50162, 3247281856, 3247281863, 'DE', 'DEU', 'ألمانيا'),
(50163, 3247281864, 3247282999, 'NL', 'NLD', 'هولندا'),
(50164, 3247283000, 3247283007, 'DE', 'DEU', 'ألمانيا'),
(50165, 3247283008, 3247283263, 'NL', 'NLD', 'هولندا'),
(50166, 3247283264, 3247283271, 'DE', 'DEU', 'ألمانيا'),
(50167, 3247283272, 3247283759, 'NL', 'NLD', 'هولندا'),
(50168, 3247283760, 3247283767, 'DE', 'DEU', 'ألمانيا'),
(50169, 3247283768, 3247283927, 'NL', 'NLD', 'هولندا'),
(50170, 3247283928, 3247283935, 'DE', 'DEU', 'ألمانيا'),
(50171, 3247283936, 3247283991, 'NL', 'NLD', 'هولندا'),
(50172, 3247283992, 3247283999, 'DE', 'DEU', 'ألمانيا'),
(50173, 3247284000, 3247284015, 'NL', 'NLD', 'هولندا'),
(50174, 3247284016, 3247284023, 'DE', 'DEU', 'ألمانيا'),
(50175, 3247284024, 3247284263, 'NL', 'NLD', 'هولندا'),
(50176, 3247284264, 3247284271, 'DE', 'DEU', 'ألمانيا'),
(50177, 3247284272, 3247284319, 'NL', 'NLD', 'هولندا'),
(50178, 3247284320, 3247284327, 'DE', 'DEU', 'ألمانيا'),
(50179, 3247284328, 3247285471, 'NL', 'NLD', 'هولندا'),
(50180, 3247285472, 3247285479, 'DE', 'DEU', 'ألمانيا'),
(50181, 3247285480, 3247286087, 'NL', 'NLD', 'هولندا'),
(50182, 3247286088, 3247286095, 'DE', 'DEU', 'ألمانيا'),
(50183, 3247286096, 3247286455, 'NL', 'NLD', 'هولندا'),
(50184, 3247286456, 3247286463, 'DE', 'DEU', 'ألمانيا'),
(50185, 3247286464, 3247286983, 'NL', 'NLD', 'هولندا'),
(50186, 3247286984, 3247286991, 'DE', 'DEU', 'ألمانيا'),
(50187, 3247286992, 3247287895, 'NL', 'NLD', 'هولندا'),
(50188, 3247287896, 3247287903, 'DE', 'DEU', 'ألمانيا'),
(50189, 3247287904, 3247288319, 'NL', 'NLD', 'هولندا'),
(50190, 3247288320, 3247302655, 'DE', 'DEU', 'ألمانيا'),
(50191, 3247302656, 3247302791, 'NL', 'NLD', 'هولندا'),
(50192, 3247302792, 3247302799, 'DE', 'DEU', 'ألمانيا'),
(50193, 3247302800, 3247303343, 'NL', 'NLD', 'هولندا'),
(50194, 3247303344, 3247303351, 'DE', 'DEU', 'ألمانيا'),
(50195, 3247303352, 3247303615, 'NL', 'NLD', 'هولندا'),
(50196, 3247303616, 3247303623, 'DE', 'DEU', 'ألمانيا'),
(50197, 3247303624, 3247304007, 'NL', 'NLD', 'هولندا'),
(50198, 3247304008, 3247304015, 'DE', 'DEU', 'ألمانيا'),
(50199, 3247304016, 3247304351, 'NL', 'NLD', 'هولندا'),
(50200, 3247304352, 3247304359, 'DE', 'DEU', 'ألمانيا'),
(50201, 3247304360, 3247305583, 'NL', 'NLD', 'هولندا'),
(50202, 3247305584, 3247305591, 'DE', 'DEU', 'ألمانيا'),
(50203, 3247305592, 3247305623, 'NL', 'NLD', 'هولندا'),
(50204, 3247305624, 3247305631, 'DE', 'DEU', 'ألمانيا'),
(50205, 3247305632, 3247305959, 'NL', 'NLD', 'هولندا'),
(50206, 3247305960, 3247305975, 'DE', 'DEU', 'ألمانيا'),
(50207, 3247305976, 3247305999, 'NL', 'NLD', 'هولندا'),
(50208, 3247306000, 3247306007, 'DE', 'DEU', 'ألمانيا'),
(50209, 3247306008, 3247306199, 'NL', 'NLD', 'هولندا'),
(50210, 3247306200, 3247306207, 'DE', 'DEU', 'ألمانيا'),
(50211, 3247306208, 3247306295, 'NL', 'NLD', 'هولندا'),
(50212, 3247306296, 3247306303, 'DE', 'DEU', 'ألمانيا'),
(50213, 3247306304, 3247306311, 'NL', 'NLD', 'هولندا'),
(50214, 3247306312, 3247306327, 'DE', 'DEU', 'ألمانيا'),
(50215, 3247306328, 3247306423, 'NL', 'NLD', 'هولندا'),
(50216, 3247306424, 3247306431, 'DE', 'DEU', 'ألمانيا'),
(50217, 3247306432, 3247306447, 'NL', 'NLD', 'هولندا'),
(50218, 3247306448, 3247306455, 'DE', 'DEU', 'ألمانيا'),
(50219, 3247306456, 3247306583, 'NL', 'NLD', 'هولندا'),
(50220, 3247306584, 3247306599, 'DE', 'DEU', 'ألمانيا'),
(50221, 3247306600, 3247306671, 'NL', 'NLD', 'هولندا'),
(50222, 3247306672, 3247306679, 'DE', 'DEU', 'ألمانيا'),
(50223, 3247306680, 3247306783, 'NL', 'NLD', 'هولندا'),
(50224, 3247306784, 3247306791, 'DE', 'DEU', 'ألمانيا'),
(50225, 3247306792, 3247306799, 'NL', 'NLD', 'هولندا'),
(50226, 3247306800, 3247306807, 'DE', 'DEU', 'ألمانيا'),
(50227, 3247306808, 3247306895, 'NL', 'NLD', 'هولندا'),
(50228, 3247306896, 3247306903, 'DE', 'DEU', 'ألمانيا'),
(50229, 3247306904, 3247306919, 'NL', 'NLD', 'هولندا'),
(50230, 3247306920, 3247306943, 'DE', 'DEU', 'ألمانيا'),
(50231, 3247306944, 3247306959, 'NL', 'NLD', 'هولندا'),
(50232, 3247306960, 3247306967, 'DE', 'DEU', 'ألمانيا'),
(50233, 3247306968, 3247306999, 'NL', 'NLD', 'هولندا'),
(50234, 3247307000, 3247307007, 'DE', 'DEU', 'ألمانيا'),
(50235, 3247307008, 3247307071, 'NL', 'NLD', 'هولندا'),
(50236, 3247307072, 3247307079, 'DE', 'DEU', 'ألمانيا'),
(50237, 3247307080, 3247307303, 'NL', 'NLD', 'هولندا'),
(50238, 3247307304, 3247307311, 'DE', 'DEU', 'ألمانيا'),
(50239, 3247307312, 3247307375, 'NL', 'NLD', 'هولندا'),
(50240, 3247307376, 3247307383, 'DE', 'DEU', 'ألمانيا'),
(50241, 3247307384, 3247307415, 'NL', 'NLD', 'هولندا'),
(50242, 3247307416, 3247307423, 'DE', 'DEU', 'ألمانيا'),
(50243, 3247307424, 3247307543, 'NL', 'NLD', 'هولندا'),
(50244, 3247307544, 3247307551, 'DE', 'DEU', 'ألمانيا'),
(50245, 3247307552, 3247307575, 'NL', 'NLD', 'هولندا'),
(50246, 3247307576, 3247307583, 'DE', 'DEU', 'ألمانيا'),
(50247, 3247307584, 3247307591, 'NL', 'NLD', 'هولندا'),
(50248, 3247307592, 3247307599, 'DE', 'DEU', 'ألمانيا'),
(50249, 3247307600, 3247307871, 'NL', 'NLD', 'هولندا'),
(50250, 3247307872, 3247307879, 'DE', 'DEU', 'ألمانيا'),
(50251, 3247307880, 3247307991, 'NL', 'NLD', 'هولندا'),
(50252, 3247307992, 3247307999, 'DE', 'DEU', 'ألمانيا'),
(50253, 3247308000, 3247308111, 'NL', 'NLD', 'هولندا'),
(50254, 3247308112, 3247308119, 'DE', 'DEU', 'ألمانيا'),
(50255, 3247308120, 3247308415, 'NL', 'NLD', 'هولندا'),
(50256, 3247308416, 3247308423, 'DE', 'DEU', 'ألمانيا'),
(50257, 3247308424, 3247308479, 'NL', 'NLD', 'هولندا'),
(50258, 3247308480, 3247308487, 'DE', 'DEU', 'ألمانيا'),
(50259, 3247308488, 3247308727, 'NL', 'NLD', 'هولندا'),
(50260, 3247308728, 3247308735, 'DE', 'DEU', 'ألمانيا'),
(50261, 3247308736, 3247308799, 'NL', 'NLD', 'هولندا'),
(50262, 3247308800, 3247309055, 'BG', 'BGR', 'بلغاريا'),
(50263, 3247309056, 3247313663, 'FI', 'FIN', 'فنلندا'),
(50264, 3247313920, 3247316479, 'FI', 'FIN', 'فنلندا'),
(50265, 3247316480, 3247316735, 'NO', 'NOR', 'النرويج'),
(50266, 3247316992, 3247322367, 'FI', 'FIN', 'فنلندا'),
(50267, 3247322368, 3247322623, 'DE', 'DEU', 'ألمانيا'),
(50268, 3247322624, 3247323135, 'FI', 'FIN', 'فنلندا'),
(50269, 3247323136, 3247323647, 'RU', 'RUS', 'الإتحاد الروسي'),
(50270, 3247323648, 3247324415, 'FI', 'FIN', 'فنلندا'),
(50271, 3247324416, 3247324671, 'AT', 'AUT', 'النمسا'),
(50272, 3247324672, 3247324927, 'CH', 'CHE', 'سويسرا'),
(50273, 3247324928, 3247333631, 'FI', 'FIN', 'فنلندا'),
(50274, 3247333632, 3247333887, 'DE', 'DEU', 'ألمانيا'),
(50275, 3247333888, 3247334399, 'FI', 'FIN', 'فنلندا'),
(50276, 3247334400, 3247334655, 'NO', 'NOR', 'النرويج'),
(50277, 3247334656, 3247335167, 'FI', 'FIN', 'فنلندا'),
(50278, 3247335168, 3247335423, 'DK', 'DNK', 'الدنيمارك'),
(50279, 3247335424, 3247336447, 'FI', 'FIN', 'فنلندا'),
(50280, 3247336448, 3247337215, 'NO', 'NOR', 'النرويج'),
(50281, 3247337216, 3247337471, 'CH', 'CHE', 'سويسرا'),
(50282, 3247337472, 3247337983, 'PL', 'POL', 'بولندا'),
(50283, 3247338240, 3247338495, 'PL', 'POL', 'بولندا'),
(50284, 3247338496, 3247338751, 'SI', 'SVN', 'سلوفينيا'),
(50285, 3247338752, 3247339519, 'GB', 'GBR', 'المملكة المتحدة'),
(50286, 3247339520, 3247340543, 'FI', 'FIN', 'فنلندا'),
(50287, 3247340544, 3247340799, 'UA', 'UKR', 'أوكرانيا'),
(50288, 3247340800, 3247341055, 'CH', 'CHE', 'سويسرا'),
(50289, 3247341056, 3247341311, 'FI', 'FIN', 'فنلندا'),
(50290, 3247341568, 3247345919, 'FI', 'FIN', 'فنلندا'),
(50291, 3247345920, 3247346175, 'HU', 'HUN', 'هنغاريا'),
(50292, 3247346176, 3247346943, 'FI', 'FIN', 'فنلندا'),
(50293, 3247346944, 3247347199, 'SI', 'SVN', 'سلوفينيا'),
(50294, 3247347200, 3247347455, 'FI', 'FIN', 'فنلندا'),
(50295, 3247347456, 3247347711, 'IL', 'ISR', 'إسرائيل'),
(50296, 3247347712, 3247347967, 'FI', 'FIN', 'فنلندا'),
(50297, 3247347968, 3247348223, 'HU', 'HUN', 'هنغاريا'),
(50298, 3247348224, 3247348991, 'FI', 'FIN', 'فنلندا'),
(50299, 3247348992, 3247349247, 'DE', 'DEU', 'ألمانيا'),
(50300, 3247349248, 3247349759, 'FI', 'FIN', 'فنلندا'),
(50301, 3247349760, 3247353855, 'SE', 'SWE', 'السويد'),
(50302, 3247353856, 3247362047, 'FI', 'FIN', 'فنلندا'),
(50303, 3247362048, 3247362303, 'RO', 'ROM', 'رومانيا'),
(50304, 3247362304, 3247362559, 'HU', 'HUN', 'هنغاريا'),
(50305, 3247362560, 3247362815, 'PL', 'POL', 'بولندا'),
(50306, 3247362816, 3247363071, 'DK', 'DNK', 'الدنيمارك'),
(50307, 3247363072, 3247363327, 'GB', 'GBR', 'المملكة المتحدة'),
(50308, 3247363328, 3247363583, 'UA', 'UKR', 'أوكرانيا'),
(50309, 3247363584, 3247363839, 'HU', 'HUN', 'هنغاريا'),
(50310, 3247363840, 3247364095, 'NL', 'NLD', 'هولندا'),
(50311, 3247364096, 3247364351, 'GB', 'GBR', 'المملكة المتحدة'),
(50312, 3247364352, 3247364607, 'ES', 'ESP', 'إسبانيا'),
(50313, 3247364608, 3247365119, 'UA', 'UKR', 'أوكرانيا'),
(50314, 3247365120, 3247365375, 'GB', 'GBR', 'المملكة المتحدة'),
(50315, 3247365376, 3247365631, 'UA', 'UKR', 'أوكرانيا'),
(50316, 3247365632, 3247365887, 'SA', 'SAU', 'السعودية'),
(50317, 3247365888, 3247366143, 'DE', 'DEU', 'ألمانيا'),
(50318, 3247366144, 3247371007, 'FI', 'FIN', 'فنلندا'),
(50319, 3247371008, 3247371263, 'PL', 'POL', 'بولندا'),
(50320, 3247371264, 3247371519, 'SE', 'SWE', 'السويد'),
(50321, 3247371520, 3247371775, 'GB', 'GBR', 'المملكة المتحدة'),
(50322, 3247371776, 3247374335, 'FI', 'FIN', 'فنلندا'),
(50323, 3247374336, 3247374591, 'RU', 'RUS', 'الإتحاد الروسي'),
(50324, 3247374592, 3247394047, 'FI', 'FIN', 'فنلندا'),
(50325, 3247394048, 3247394303, 'PL', 'POL', 'بولندا'),
(50326, 3247394304, 3247397887, 'FI', 'FIN', 'فنلندا'),
(50327, 3247398144, 3247399423, 'FI', 'FIN', 'فنلندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(50328, 3247399424, 3247399679, 'RU', 'RUS', 'الإتحاد الروسي'),
(50329, 3247399680, 3247404799, 'FI', 'FIN', 'فنلندا'),
(50330, 3247404800, 3247405055, 'RU', 'RUS', 'الإتحاد الروسي'),
(50331, 3247405056, 3247405311, 'RO', 'ROM', 'رومانيا'),
(50332, 3247405312, 3247405567, 'PL', 'POL', 'بولندا'),
(50333, 3247405568, 3247405823, 'DE', 'DEU', 'ألمانيا'),
(50334, 3247405824, 3247432191, 'FI', 'FIN', 'فنلندا'),
(50335, 3247432192, 3247432447, 'TR', 'TUR', 'تركيا'),
(50336, 3247432448, 3247438079, 'FI', 'FIN', 'فنلندا'),
(50337, 3247438080, 3247438335, 'IT', 'ITA', 'إيطاليا'),
(50338, 3247438336, 3247439871, 'FI', 'FIN', 'فنلندا'),
(50339, 3247439872, 3247702015, 'ES', 'ESP', 'إسبانيا'),
(50340, 3247702016, 3247702271, 'RO', 'ROM', 'رومانيا'),
(50341, 3247702272, 3247703551, 'ES', 'ESP', 'إسبانيا'),
(50342, 3247704064, 3247704831, 'ES', 'ESP', 'إسبانيا'),
(50343, 3247704832, 3247705087, 'GB', 'GBR', 'المملكة المتحدة'),
(50344, 3247705088, 3247705855, 'ES', 'ESP', 'إسبانيا'),
(50345, 3247705856, 3247706111, 'RU', 'RUS', 'الإتحاد الروسي'),
(50346, 3247706112, 3247711743, 'ES', 'ESP', 'إسبانيا'),
(50347, 3247711744, 3247712255, 'IT', 'ITA', 'إيطاليا'),
(50348, 3247712256, 3247713279, 'ES', 'ESP', 'إسبانيا'),
(50349, 3247713280, 3247713535, 'RU', 'RUS', 'الإتحاد الروسي'),
(50350, 3247713536, 3247713791, 'BE', 'BEL', 'بلجيكا'),
(50351, 3247713792, 3247714047, 'SK', 'SVK', 'سلوفاكيا'),
(50352, 3247714048, 3247714303, 'RU', 'RUS', 'الإتحاد الروسي'),
(50353, 3247714304, 3247716351, 'CH', 'CHE', 'سويسرا'),
(50354, 3247716352, 3247717887, 'ES', 'ESP', 'إسبانيا'),
(50355, 3247717888, 3247718399, 'CH', 'CHE', 'سويسرا'),
(50356, 3247718400, 3247769599, 'ES', 'ESP', 'إسبانيا'),
(50357, 3247769600, 3247771647, 'DE', 'DEU', 'ألمانيا'),
(50358, 3247771648, 3247775743, 'ES', 'ESP', 'إسبانيا'),
(50359, 3247775744, 3247779647, 'DE', 'DEU', 'ألمانيا'),
(50360, 3247779648, 3247779839, 'IE', 'IRL', 'إيرلندا'),
(50361, 3247779840, 3247783935, 'DE', 'DEU', 'ألمانيا'),
(50362, 3247783936, 3247792127, 'GB', 'GBR', 'المملكة المتحدة'),
(50363, 3247792128, 3247800319, 'FR', 'FRA', 'فرنسا'),
(50364, 3247800320, 3247816703, 'DK', 'DNK', 'الدنيمارك'),
(50365, 3247816704, 3247817471, 'BE', 'BEL', 'بلجيكا'),
(50366, 3247817472, 3247817727, 'CH', 'CHE', 'سويسرا'),
(50367, 3247817728, 3247820799, 'BE', 'BEL', 'بلجيكا'),
(50368, 3247820800, 3247822335, 'CH', 'CHE', 'سويسرا'),
(50369, 3247822336, 3247823103, 'DE', 'DEU', 'ألمانيا'),
(50370, 3247823104, 3247823871, 'AT', 'AUT', 'النمسا'),
(50371, 3247823872, 3247825151, 'BE', 'BEL', 'بلجيكا'),
(50372, 3247825152, 3247825919, 'CH', 'CHE', 'سويسرا'),
(50373, 3247825920, 3247826943, 'BE', 'BEL', 'بلجيكا'),
(50374, 3247826944, 3247828991, 'CH', 'CHE', 'سويسرا'),
(50375, 3247828992, 3247833087, 'BE', 'BEL', 'بلجيكا'),
(50376, 3247833088, 3247865855, 'RU', 'RUS', 'الإتحاد الروسي'),
(50377, 3247865856, 3247871999, 'GB', 'GBR', 'المملكة المتحدة'),
(50378, 3247872000, 3247875327, 'NL', 'NLD', 'هولندا'),
(50379, 3247875584, 3247876095, 'DE', 'DEU', 'ألمانيا'),
(50380, 3247876096, 3247876351, 'PL', 'POL', 'بولندا'),
(50381, 3247876352, 3247876607, 'FR', 'FRA', 'فرنسا'),
(50382, 3247876608, 3247876863, 'ES', 'ESP', 'إسبانيا'),
(50383, 3247876864, 3247877119, 'DE', 'DEU', 'ألمانيا'),
(50384, 3247877120, 3247877631, 'GR', 'GRC', 'اليونان'),
(50385, 3247877632, 3247879167, 'AT', 'AUT', 'النمسا'),
(50386, 3247879168, 3247882239, 'GB', 'GBR', 'المملكة المتحدة'),
(50387, 3247882240, 3247898623, 'SE', 'SWE', 'السويد'),
(50388, 3247898624, 3247899647, 'RU', 'RUS', 'الإتحاد الروسي'),
(50389, 3247899648, 3247900671, 'DE', 'DEU', 'ألمانيا'),
(50390, 3247900672, 3247901695, 'PL', 'POL', 'بولندا'),
(50391, 3247901696, 3247902719, 'UA', 'UKR', 'أوكرانيا'),
(50392, 3247902720, 3247903743, 'GB', 'GBR', 'المملكة المتحدة'),
(50393, 3247903744, 3247904767, 'BG', 'BGR', 'بلغاريا'),
(50394, 3247904768, 3247905791, 'GB', 'GBR', 'المملكة المتحدة'),
(50395, 3247905792, 3247906815, 'RO', 'ROM', 'رومانيا'),
(50396, 3247906816, 3247907839, 'DE', 'DEU', 'ألمانيا'),
(50397, 3247907840, 3247908863, 'PL', 'POL', 'بولندا'),
(50398, 3247908864, 3247909887, 'BY', 'BLR', 'روسيا البيضاء'),
(50399, 3247909888, 3247910911, 'DE', 'DEU', 'ألمانيا'),
(50400, 3247910912, 3247912959, 'PL', 'POL', 'بولندا'),
(50401, 3247912960, 3247913983, 'UA', 'UKR', 'أوكرانيا'),
(50402, 3247913984, 3247915007, 'DE', 'DEU', 'ألمانيا'),
(50403, 3247915008, 3247917055, 'PL', 'POL', 'بولندا'),
(50404, 3247917056, 3247918079, 'NL', 'NLD', 'هولندا'),
(50405, 3247918080, 3247919103, 'PL', 'POL', 'بولندا'),
(50406, 3247919104, 3247920127, 'BG', 'BGR', 'بلغاريا'),
(50407, 3247920128, 3247921151, 'FR', 'FRA', 'فرنسا'),
(50408, 3247922176, 3247923199, 'SE', 'SWE', 'السويد'),
(50409, 3247923200, 3247925247, 'PL', 'POL', 'بولندا'),
(50410, 3247925248, 3247926271, 'UA', 'UKR', 'أوكرانيا'),
(50411, 3247926272, 3247927295, 'RU', 'RUS', 'الإتحاد الروسي'),
(50412, 3247927296, 3247928319, 'PL', 'POL', 'بولندا'),
(50413, 3247928320, 3247929343, 'HU', 'HUN', 'هنغاريا'),
(50414, 3247929344, 3247931391, 'GB', 'GBR', 'المملكة المتحدة'),
(50415, 3247931392, 3247960063, 'FR', 'FRA', 'فرنسا'),
(50416, 3247960064, 3247962111, 'UA', 'UKR', 'أوكرانيا'),
(50417, 3247962112, 3247963135, 'DE', 'DEU', 'ألمانيا'),
(50418, 3247963136, 3247964159, 'UA', 'UKR', 'أوكرانيا'),
(50419, 3247964160, 3248095231, 'ES', 'ESP', 'إسبانيا'),
(50420, 3248095232, 3248095823, 'AT', 'AUT', 'النمسا'),
(50421, 3248095824, 3248095831, 'HU', 'HUN', 'هنغاريا'),
(50422, 3248095832, 3248160767, 'AT', 'AUT', 'النمسا'),
(50423, 3248160768, 3248226303, 'DE', 'DEU', 'ألمانيا'),
(50424, 3248226304, 3248235007, 'NO', 'NOR', 'النرويج'),
(50425, 3248235008, 3248235263, 'PK', 'PAK', 'باكستان'),
(50426, 3248235264, 3248357375, 'NO', 'NOR', 'النرويج'),
(50427, 3248357376, 3248370511, 'DE', 'DEU', 'ألمانيا'),
(50428, 3248370512, 3248370519, 'AT', 'AUT', 'النمسا'),
(50429, 3248370520, 3248371743, 'DE', 'DEU', 'ألمانيا'),
(50430, 3248371744, 3248371751, 'PL', 'POL', 'بولندا'),
(50431, 3248371752, 3248372239, 'DE', 'DEU', 'ألمانيا'),
(50432, 3248372240, 3248372247, 'AT', 'AUT', 'النمسا'),
(50433, 3248372248, 3248372255, 'CH', 'CHE', 'سويسرا'),
(50434, 3248372256, 3248372263, 'AT', 'AUT', 'النمسا'),
(50435, 3248372264, 3248372271, 'NL', 'NLD', 'هولندا'),
(50436, 3248372272, 3248372319, 'DE', 'DEU', 'ألمانيا'),
(50437, 3248372320, 3248372327, 'BE', 'BEL', 'بلجيكا'),
(50438, 3248372328, 3248488447, 'DE', 'DEU', 'ألمانيا'),
(50439, 3248488448, 3248525311, 'NO', 'NOR', 'النرويج'),
(50440, 3248525312, 3248525567, 'DE', 'DEU', 'ألمانيا'),
(50441, 3248525568, 3248525823, 'DK', 'DNK', 'الدنيمارك'),
(50442, 3248525824, 3248619519, 'NO', 'NOR', 'النرويج'),
(50443, 3248619520, 3248638463, 'DK', 'DNK', 'الدنيمارك'),
(50444, 3248638464, 3248638719, 'GB', 'GBR', 'المملكة المتحدة'),
(50445, 3248638720, 3248750591, 'DK', 'DNK', 'الدنيمارك'),
(50446, 3248750592, 3248750847, 'PT', 'PRT', 'البورتوغال'),
(50447, 3248750848, 3248752383, 'PL', 'POL', 'بولندا'),
(50448, 3248752384, 3248752639, 'NL', 'NLD', 'هولندا'),
(50449, 3248752640, 3248752895, 'DE', 'DEU', 'ألمانيا'),
(50450, 3248752896, 3248753151, 'TR', 'TUR', 'تركيا'),
(50451, 3248753152, 3248753663, 'GB', 'GBR', 'المملكة المتحدة'),
(50452, 3248753664, 3248753919, 'FR', 'FRA', 'فرنسا'),
(50453, 3248753920, 3248754431, 'GB', 'GBR', 'المملكة المتحدة'),
(50454, 3248754432, 3248754687, 'AT', 'AUT', 'النمسا'),
(50455, 3248754688, 3248758783, 'PL', 'POL', 'بولندا'),
(50456, 3248758784, 3248774143, 'SE', 'SWE', 'السويد'),
(50457, 3248774144, 3248775167, 'UA', 'UKR', 'أوكرانيا'),
(50458, 3248775168, 3248783615, 'GB', 'GBR', 'المملكة المتحدة'),
(50459, 3248783616, 3248783871, 'PL', 'POL', 'بولندا'),
(50460, 3248783872, 3248784127, 'UA', 'UKR', 'أوكرانيا'),
(50461, 3248784128, 3248785407, 'DE', 'DEU', 'ألمانيا'),
(50462, 3248785408, 3248785663, 'RO', 'ROM', 'رومانيا'),
(50463, 3248785664, 3248786943, 'SI', 'SVN', 'سلوفينيا'),
(50464, 3248786944, 3248787199, 'PL', 'POL', 'بولندا'),
(50465, 3248787200, 3248787455, 'GB', 'GBR', 'المملكة المتحدة'),
(50466, 3248787456, 3248787711, 'NL', 'NLD', 'هولندا'),
(50467, 3248787712, 3248787967, 'CH', 'CHE', 'سويسرا'),
(50468, 3248787968, 3248788223, 'RU', 'RUS', 'الإتحاد الروسي'),
(50469, 3248788224, 3248788479, 'ES', 'ESP', 'إسبانيا'),
(50470, 3248788480, 3248788735, 'FR', 'FRA', 'فرنسا'),
(50471, 3248788736, 3248788991, 'UA', 'UKR', 'أوكرانيا'),
(50472, 3248788992, 3248789503, 'FR', 'FRA', 'فرنسا'),
(50473, 3248789504, 3248789759, 'RO', 'ROM', 'رومانيا'),
(50474, 3248789760, 3248790015, 'FR', 'FRA', 'فرنسا'),
(50475, 3248790016, 3248790271, 'DE', 'DEU', 'ألمانيا'),
(50476, 3248790272, 3248790527, 'DK', 'DNK', 'الدنيمارك'),
(50477, 3248790528, 3248790783, 'FR', 'FRA', 'فرنسا'),
(50478, 3248790784, 3248791039, 'PL', 'POL', 'بولندا'),
(50479, 3248791040, 3248791295, 'BE', 'BEL', 'بلجيكا'),
(50480, 3248791296, 3248791551, 'DE', 'DEU', 'ألمانيا'),
(50481, 3248791552, 3248792383, 'GB', 'GBR', 'المملكة المتحدة'),
(50482, 3248796608, 3248796863, 'GB', 'GBR', 'المملكة المتحدة'),
(50483, 3248798648, 3248798651, 'GB', 'GBR', 'المملكة المتحدة'),
(50484, 3248798976, 3248799231, 'GB', 'GBR', 'المملكة المتحدة'),
(50485, 3248799736, 3248799743, 'GB', 'GBR', 'المملكة المتحدة'),
(50486, 3248799744, 3248800255, 'NL', 'NLD', 'هولندا'),
(50487, 3248800256, 3248800767, 'RU', 'RUS', 'الإتحاد الروسي'),
(50488, 3248800768, 3248801279, 'FR', 'FRA', 'فرنسا'),
(50489, 3248801280, 3248801791, 'RO', 'ROM', 'رومانيا'),
(50490, 3248801792, 3248802303, 'RU', 'RUS', 'الإتحاد الروسي'),
(50491, 3248802304, 3248802815, 'FR', 'FRA', 'فرنسا'),
(50492, 3248802816, 3248803327, 'RU', 'RUS', 'الإتحاد الروسي'),
(50493, 3248803328, 3248804351, 'GB', 'GBR', 'المملكة المتحدة'),
(50494, 3248804352, 3248804863, 'LV', 'LVA', 'لاتفيا'),
(50495, 3248804864, 3248805375, 'DE', 'DEU', 'ألمانيا'),
(50496, 3248805376, 3248805887, 'RU', 'RUS', 'الإتحاد الروسي'),
(50497, 3248805888, 3248806399, 'NL', 'NLD', 'هولندا'),
(50498, 3248806400, 3248806911, 'CZ', 'CZE', 'التشيك'),
(50499, 3248806912, 3248807423, 'US', 'USA', 'الولايات المتحدة'),
(50500, 3248807424, 3248807935, 'BG', 'BGR', 'بلغاريا'),
(50501, 3248807936, 3248808447, 'AT', 'AUT', 'النمسا'),
(50502, 3248808448, 3248808959, 'GR', 'GRC', 'اليونان'),
(50503, 3248808960, 3248810079, 'FR', 'FRA', 'فرنسا'),
(50504, 3248810080, 3248810111, 'UA', 'UKR', 'أوكرانيا'),
(50505, 3248810112, 3248810143, 'RU', 'RUS', 'الإتحاد الروسي'),
(50506, 3248810144, 3248810175, 'HR', 'HRV', 'كرواتيا'),
(50507, 3248810176, 3248810207, 'FR', 'FRA', 'فرنسا'),
(50508, 3248810208, 3248810239, 'GB', 'GBR', 'المملكة المتحدة'),
(50509, 3248810240, 3248810495, 'CH', 'CHE', 'سويسرا'),
(50510, 3248810496, 3248812543, 'AT', 'AUT', 'النمسا'),
(50511, 3248812544, 3248813055, 'GB', 'GBR', 'المملكة المتحدة'),
(50512, 3248813056, 3248813567, 'CH', 'CHE', 'سويسرا'),
(50513, 3248813568, 3248814079, 'DE', 'DEU', 'ألمانيا'),
(50514, 3248814080, 3248815103, 'DK', 'DNK', 'الدنيمارك'),
(50515, 3248815104, 3248815615, 'GB', 'GBR', 'المملكة المتحدة'),
(50516, 3248815616, 3248816127, 'PL', 'POL', 'بولندا'),
(50517, 3248816128, 3248881663, 'CZ', 'CZE', 'التشيك'),
(50518, 3248881664, 3249012735, 'FI', 'FIN', 'فنلندا'),
(50519, 3249012736, 3249012991, 'DE', 'DEU', 'ألمانيا'),
(50520, 3249012992, 3249014271, 'LU', 'LUX', 'لوكسيمبورغ'),
(50521, 3249014784, 3249025535, 'LU', 'LUX', 'لوكسيمبورغ'),
(50522, 3249025536, 3249025791, 'FR', 'FRA', 'فرنسا'),
(50523, 3249025792, 3249026559, 'LU', 'LUX', 'لوكسيمبورغ'),
(50524, 3249026816, 3249045503, 'LU', 'LUX', 'لوكسيمبورغ'),
(50525, 3249045504, 3249078271, 'DE', 'DEU', 'ألمانيا'),
(50526, 3249078272, 3249078783, 'RU', 'RUS', 'الإتحاد الروسي'),
(50527, 3249078784, 3249079295, 'CH', 'CHE', 'سويسرا'),
(50528, 3249079296, 3249079807, 'RU', 'RUS', 'الإتحاد الروسي'),
(50529, 3249079808, 3249080831, 'RO', 'ROM', 'رومانيا'),
(50530, 3249080832, 3249081343, 'DE', 'DEU', 'ألمانيا'),
(50531, 3249081856, 3249082367, 'GB', 'GBR', 'المملكة المتحدة'),
(50532, 3249082368, 3249082879, 'HU', 'HUN', 'هنغاريا'),
(50533, 3249082880, 3249083391, 'PL', 'POL', 'بولندا'),
(50534, 3249083392, 3249083903, 'RO', 'ROM', 'رومانيا'),
(50535, 3249083904, 3249085951, 'RU', 'RUS', 'الإتحاد الروسي'),
(50536, 3249085952, 3249086463, 'GI', 'GIB', 'جبل طارق'),
(50537, 3249086464, 3249088511, 'RU', 'RUS', 'الإتحاد الروسي'),
(50538, 3249088512, 3249089023, 'NL', 'NLD', 'هولندا'),
(50539, 3249089024, 3249089535, 'NO', 'NOR', 'النرويج'),
(50540, 3249089536, 3249090047, 'RU', 'RUS', 'الإتحاد الروسي'),
(50541, 3249090048, 3249090559, 'FR', 'FRA', 'فرنسا'),
(50542, 3249090560, 3249091071, 'SI', 'SVN', 'سلوفينيا'),
(50543, 3249091072, 3249091583, 'RO', 'ROM', 'رومانيا'),
(50544, 3249091584, 3249092095, 'RU', 'RUS', 'الإتحاد الروسي'),
(50545, 3249092096, 3249092607, 'DE', 'DEU', 'ألمانيا'),
(50546, 3249092608, 3249093119, 'IT', 'ITA', 'إيطاليا'),
(50547, 3249093120, 3249093631, 'GB', 'GBR', 'المملكة المتحدة'),
(50548, 3249093632, 3249094655, 'RU', 'RUS', 'الإتحاد الروسي'),
(50549, 3249094656, 3249095679, 'FR', 'FRA', 'فرنسا'),
(50550, 3249095680, 3249096191, 'NL', 'NLD', 'هولندا'),
(50551, 3249096192, 3249096703, 'IL', 'ISR', 'إسرائيل'),
(50552, 3249096704, 3249097215, 'DE', 'DEU', 'ألمانيا'),
(50553, 3249097216, 3249097727, 'DK', 'DNK', 'الدنيمارك'),
(50554, 3249097728, 3249098239, 'DE', 'DEU', 'ألمانيا'),
(50555, 3249098240, 3249098751, 'PL', 'POL', 'بولندا'),
(50556, 3249098752, 3249099263, 'UA', 'UKR', 'أوكرانيا'),
(50557, 3249099264, 3249099775, 'CH', 'CHE', 'سويسرا'),
(50558, 3249099776, 3249100287, 'FI', 'FIN', 'فنلندا'),
(50559, 3249100288, 3249100799, 'UA', 'UKR', 'أوكرانيا'),
(50560, 3249100800, 3249101311, 'IL', 'ISR', 'إسرائيل'),
(50561, 3249101312, 3249101823, 'GB', 'GBR', 'المملكة المتحدة'),
(50562, 3249101824, 3249102335, 'RU', 'RUS', 'الإتحاد الروسي'),
(50563, 3249102336, 3249102847, 'DE', 'DEU', 'ألمانيا'),
(50564, 3249102848, 3249103359, 'RU', 'RUS', 'الإتحاد الروسي'),
(50565, 3249103360, 3249103871, 'DE', 'DEU', 'ألمانيا'),
(50566, 3249103872, 3249104383, 'FI', 'FIN', 'فنلندا'),
(50567, 3249104384, 3249104895, 'RU', 'RUS', 'الإتحاد الروسي'),
(50568, 3249104896, 3249105407, 'IL', 'ISR', 'إسرائيل'),
(50569, 3249105408, 3249105919, 'RU', 'RUS', 'الإتحاد الروسي'),
(50570, 3249105920, 3249106431, 'NL', 'NLD', 'هولندا'),
(50571, 3249106432, 3249106943, 'RU', 'RUS', 'الإتحاد الروسي'),
(50572, 3249106944, 3249108479, 'PL', 'POL', 'بولندا'),
(50573, 3249108480, 3249108991, 'RU', 'RUS', 'الإتحاد الروسي'),
(50574, 3249108992, 3249109503, 'GB', 'GBR', 'المملكة المتحدة'),
(50575, 3249109504, 3249110015, 'RU', 'RUS', 'الإتحاد الروسي'),
(50576, 3249110016, 3249111039, 'UA', 'UKR', 'أوكرانيا'),
(50577, 3249111040, 3249111551, 'RU', 'RUS', 'الإتحاد الروسي'),
(50578, 3249111552, 3249112063, 'KW', 'KWT', 'الكويت'),
(50579, 3249112064, 3249113087, 'UA', 'UKR', 'أوكرانيا'),
(50580, 3249113088, 3249113599, 'RO', 'ROM', 'رومانيا'),
(50581, 3249113600, 3249114111, 'NL', 'NLD', 'هولندا'),
(50582, 3249114112, 3249114623, 'GB', 'GBR', 'المملكة المتحدة'),
(50583, 3249114624, 3249115647, 'RO', 'ROM', 'رومانيا'),
(50584, 3249115648, 3249116159, 'UA', 'UKR', 'أوكرانيا'),
(50585, 3249116160, 3249116671, 'PL', 'POL', 'بولندا'),
(50586, 3249116672, 3249117183, 'IT', 'ITA', 'إيطاليا'),
(50587, 3249117184, 3249117695, 'CH', 'CHE', 'سويسرا'),
(50588, 3249117696, 3249118207, 'DK', 'DNK', 'الدنيمارك'),
(50589, 3249118208, 3249118719, 'RO', 'ROM', 'رومانيا'),
(50590, 3249118720, 3249119231, 'LU', 'LUX', 'لوكسيمبورغ'),
(50591, 3249119232, 3249119743, 'RU', 'RUS', 'الإتحاد الروسي'),
(50592, 3249119744, 3249120255, 'IT', 'ITA', 'إيطاليا'),
(50593, 3249120256, 3249120767, 'SE', 'SWE', 'السويد'),
(50594, 3249120768, 3249121279, 'LV', 'LVA', 'لاتفيا'),
(50595, 3249121280, 3249121791, 'DE', 'DEU', 'ألمانيا'),
(50596, 3249121792, 3249122303, 'RO', 'ROM', 'رومانيا'),
(50597, 3249122304, 3249124351, 'RU', 'RUS', 'الإتحاد الروسي'),
(50598, 3249124352, 3249124863, 'DE', 'DEU', 'ألمانيا'),
(50599, 3249124864, 3249125375, 'CZ', 'CZE', 'التشيك'),
(50600, 3249125376, 3249125887, 'DE', 'DEU', 'ألمانيا'),
(50601, 3249125888, 3249126399, 'CH', 'CHE', 'سويسرا'),
(50602, 3249126400, 3249126911, 'UA', 'UKR', 'أوكرانيا'),
(50603, 3249126912, 3249127423, 'SA', 'SAU', 'السعودية'),
(50604, 3249127424, 3249127935, 'GB', 'GBR', 'المملكة المتحدة'),
(50605, 3249127936, 3249128447, 'LV', 'LVA', 'لاتفيا'),
(50606, 3249128448, 3249128959, 'DE', 'DEU', 'ألمانيا'),
(50607, 3249128960, 3249129471, 'BG', 'BGR', 'بلغاريا'),
(50608, 3249129472, 3249130495, 'RU', 'RUS', 'الإتحاد الروسي'),
(50609, 3249130496, 3249131007, 'DE', 'DEU', 'ألمانيا'),
(50610, 3249131008, 3249131519, 'GB', 'GBR', 'المملكة المتحدة'),
(50611, 3249131520, 3249132031, 'DK', 'DNK', 'الدنيمارك'),
(50612, 3249132032, 3249132543, 'RU', 'RUS', 'الإتحاد الروسي'),
(50613, 3249132544, 3249133055, 'DE', 'DEU', 'ألمانيا'),
(50614, 3249133056, 3249133567, 'UA', 'UKR', 'أوكرانيا'),
(50615, 3249134080, 3249134591, 'UA', 'UKR', 'أوكرانيا'),
(50616, 3249134592, 3249135615, 'RU', 'RUS', 'الإتحاد الروسي'),
(50617, 3249135616, 3249136127, 'GB', 'GBR', 'المملكة المتحدة'),
(50618, 3249136128, 3249137151, 'RU', 'RUS', 'الإتحاد الروسي'),
(50619, 3249137152, 3249137663, 'FR', 'FRA', 'فرنسا'),
(50620, 3249137664, 3249138175, 'PL', 'POL', 'بولندا'),
(50621, 3249138176, 3249138687, 'JM', 'JAM', 'جامايكا'),
(50622, 3249138688, 3249139711, 'RU', 'RUS', 'الإتحاد الروسي'),
(50623, 3249139712, 3249140223, 'UA', 'UKR', 'أوكرانيا'),
(50624, 3249140224, 3249140735, 'IT', 'ITA', 'إيطاليا'),
(50625, 3249140736, 3249141247, 'UA', 'UKR', 'أوكرانيا'),
(50626, 3249141248, 3249141759, 'IL', 'ISR', 'إسرائيل'),
(50627, 3249141760, 3249142783, 'RU', 'RUS', 'الإتحاد الروسي'),
(50628, 3249142784, 3249143295, 'UA', 'UKR', 'أوكرانيا'),
(50629, 3249143296, 3249143807, 'GB', 'GBR', 'المملكة المتحدة'),
(50630, 3249143808, 3249274879, 'AT', 'AUT', 'النمسا'),
(50631, 3249274880, 3249277759, 'NL', 'NLD', 'هولندا'),
(50632, 3249277760, 3249277775, 'BG', 'BGR', 'بلغاريا'),
(50633, 3249277776, 3249290143, 'NL', 'NLD', 'هولندا'),
(50634, 3249290144, 3249290159, 'BG', 'BGR', 'بلغاريا'),
(50635, 3249290160, 3249330111, 'NL', 'NLD', 'هولندا'),
(50636, 3249330112, 3249330143, 'BG', 'BGR', 'بلغاريا'),
(50637, 3249330144, 3249350095, 'NL', 'NLD', 'هولندا'),
(50638, 3249350096, 3249350111, 'BG', 'BGR', 'بلغاريا'),
(50639, 3249350112, 3249405951, 'NL', 'NLD', 'هولندا'),
(50640, 3249405952, 3249406975, 'DE', 'DEU', 'ألمانيا'),
(50641, 3249406976, 3249407231, 'IT', 'ITA', 'إيطاليا'),
(50642, 3249407232, 3249521279, 'DE', 'DEU', 'ألمانيا'),
(50643, 3249521280, 3249521343, 'UA', 'UKR', 'أوكرانيا'),
(50644, 3249521344, 3249537023, 'DE', 'DEU', 'ألمانيا'),
(50645, 3249537024, 3249537279, 'PT', 'PRT', 'البورتوغال'),
(50646, 3249537280, 3249537791, 'NL', 'NLD', 'هولندا'),
(50647, 3249537792, 3249538047, 'GB', 'GBR', 'المملكة المتحدة'),
(50648, 3249538048, 3249551359, 'NL', 'NLD', 'هولندا'),
(50649, 3249551360, 3249552639, 'GB', 'GBR', 'المملكة المتحدة'),
(50650, 3249552640, 3249574143, 'NL', 'NLD', 'هولندا'),
(50651, 3249574144, 3249574399, 'RU', 'RUS', 'الإتحاد الروسي'),
(50652, 3249574400, 3249574655, 'SE', 'SWE', 'السويد'),
(50653, 3249574656, 3249574911, 'UA', 'UKR', 'أوكرانيا'),
(50654, 3249574912, 3249590527, 'NL', 'NLD', 'هولندا'),
(50655, 3249590784, 3249600255, 'NL', 'NLD', 'هولندا'),
(50656, 3249601792, 3249668095, 'NL', 'NLD', 'هولندا'),
(50657, 3249668096, 3249676799, 'IE', 'IRL', 'إيرلندا'),
(50658, 3249676800, 3249677055, 'UA', 'UKR', 'أوكرانيا'),
(50659, 3249677056, 3249677311, 'SE', 'SWE', 'السويد'),
(50660, 3249677312, 3249679103, 'IE', 'IRL', 'إيرلندا'),
(50661, 3249679104, 3249679359, 'CH', 'CHE', 'سويسرا'),
(50662, 3249679360, 3249683455, 'IE', 'IRL', 'إيرلندا'),
(50663, 3249683456, 3249684479, 'SE', 'SWE', 'السويد'),
(50664, 3249684480, 3249698047, 'IE', 'IRL', 'إيرلندا'),
(50665, 3249698048, 3249698303, 'PL', 'POL', 'بولندا'),
(50666, 3249698304, 3249698559, 'RU', 'RUS', 'الإتحاد الروسي'),
(50667, 3249698560, 3249698815, 'HU', 'HUN', 'هنغاريا'),
(50668, 3249698816, 3249699839, 'GB', 'GBR', 'المملكة المتحدة'),
(50669, 3249699840, 3249700863, 'UA', 'UKR', 'أوكرانيا'),
(50670, 3249700864, 3249701631, 'SE', 'SWE', 'السويد'),
(50671, 3249701888, 3249702143, 'PL', 'POL', 'بولندا'),
(50672, 3249702144, 3249702399, 'FI', 'FIN', 'فنلندا'),
(50673, 3249702400, 3249702655, 'FR', 'FRA', 'فرنسا'),
(50674, 3249702656, 3249702911, 'RU', 'RUS', 'الإتحاد الروسي'),
(50675, 3249702912, 3249703679, 'FR', 'FRA', 'فرنسا'),
(50676, 3249703680, 3249703935, 'GB', 'GBR', 'المملكة المتحدة'),
(50677, 3249703936, 3249704191, 'FR', 'FRA', 'فرنسا'),
(50678, 3249704192, 3249704447, 'RO', 'ROM', 'رومانيا'),
(50679, 3249704448, 3249704703, 'DE', 'DEU', 'ألمانيا'),
(50680, 3249704704, 3249704959, 'PL', 'POL', 'بولندا'),
(50681, 3249704960, 3249705983, 'UA', 'UKR', 'أوكرانيا'),
(50682, 3249705984, 3249706495, 'AT', 'AUT', 'النمسا'),
(50683, 3249706496, 3249707007, 'LV', 'LVA', 'لاتفيا'),
(50684, 3249707008, 3249707519, 'BG', 'BGR', 'بلغاريا'),
(50685, 3249707520, 3249708031, 'FR', 'FRA', 'فرنسا'),
(50686, 3249708032, 3249708543, 'CH', 'CHE', 'سويسرا'),
(50687, 3249708544, 3249709055, 'RU', 'RUS', 'الإتحاد الروسي'),
(50688, 3249709056, 3249709311, 'AT', 'AUT', 'النمسا'),
(50689, 3249709312, 3249709567, 'PL', 'POL', 'بولندا'),
(50690, 3249709568, 3249709823, 'UA', 'UKR', 'أوكرانيا'),
(50691, 3249709824, 3249710079, 'DE', 'DEU', 'ألمانيا'),
(50692, 3249710080, 3249710335, 'PL', 'POL', 'بولندا'),
(50693, 3249710336, 3249710591, 'RO', 'ROM', 'رومانيا'),
(50694, 3249710592, 3249710847, 'BG', 'BGR', 'بلغاريا'),
(50695, 3249710848, 3249711103, 'PL', 'POL', 'بولندا'),
(50696, 3249711104, 3249711359, 'HU', 'HUN', 'هنغاريا'),
(50697, 3249711360, 3249711871, 'DE', 'DEU', 'ألمانيا'),
(50698, 3249711872, 3249712127, 'AT', 'AUT', 'النمسا'),
(50699, 3249712128, 3249712383, 'UA', 'UKR', 'أوكرانيا'),
(50700, 3249712384, 3249712639, 'GB', 'GBR', 'المملكة المتحدة'),
(50701, 3249712640, 3249712895, 'BE', 'BEL', 'بلجيكا'),
(50702, 3249712896, 3249713151, 'DK', 'DNK', 'الدنيمارك'),
(50703, 3249713152, 3249715199, 'LV', 'LVA', 'لاتفيا'),
(50704, 3249715200, 3249715455, 'AT', 'AUT', 'النمسا'),
(50705, 3249715456, 3249715711, 'DE', 'DEU', 'ألمانيا'),
(50706, 3249715712, 3249715967, 'FR', 'FRA', 'فرنسا'),
(50707, 3249715968, 3249716223, 'UA', 'UKR', 'أوكرانيا'),
(50708, 3249716224, 3249716479, 'SI', 'SVN', 'سلوفينيا'),
(50709, 3249716480, 3249716735, 'NL', 'NLD', 'هولندا'),
(50710, 3249716736, 3249717247, 'UA', 'UKR', 'أوكرانيا'),
(50711, 3249717248, 3249718271, 'LV', 'LVA', 'لاتفيا'),
(50712, 3249718272, 3249719295, 'DE', 'DEU', 'ألمانيا'),
(50713, 3249719296, 3249720319, 'GB', 'GBR', 'المملكة المتحدة'),
(50714, 3249720320, 3249721343, 'IT', 'ITA', 'إيطاليا'),
(50715, 3249721344, 3249721599, 'AT', 'AUT', 'النمسا'),
(50716, 3249721600, 3249721855, 'BE', 'BEL', 'بلجيكا'),
(50717, 3249721856, 3249722623, 'FR', 'FRA', 'فرنسا'),
(50718, 3249722624, 3249723135, 'PL', 'POL', 'بولندا'),
(50719, 3249723136, 3249723391, 'GB', 'GBR', 'المملكة المتحدة'),
(50720, 3249723392, 3249723647, 'IT', 'ITA', 'إيطاليا'),
(50721, 3249723648, 3249723903, 'GB', 'GBR', 'المملكة المتحدة'),
(50722, 3249723904, 3249724159, 'TR', 'TUR', 'تركيا'),
(50723, 3249724160, 3249724415, 'LU', 'LUX', 'لوكسيمبورغ'),
(50724, 3249724416, 3249724671, 'IL', 'ISR', 'إسرائيل'),
(50725, 3249724672, 3249724927, 'SE', 'SWE', 'السويد'),
(50726, 3249724928, 3249725183, 'BG', 'BGR', 'بلغاريا'),
(50727, 3249725184, 3249725439, 'GB', 'GBR', 'المملكة المتحدة'),
(50728, 3249725440, 3249725951, 'RO', 'ROM', 'رومانيا'),
(50729, 3249725952, 3249726463, 'DE', 'DEU', 'ألمانيا'),
(50730, 3249726464, 3249726975, 'UA', 'UKR', 'أوكرانيا'),
(50731, 3249726976, 3249727487, 'IT', 'ITA', 'إيطاليا'),
(50732, 3249727488, 3249727999, 'LV', 'LVA', 'لاتفيا'),
(50733, 3249728000, 3249728511, 'IT', 'ITA', 'إيطاليا'),
(50734, 3249728512, 3249729023, 'UA', 'UKR', 'أوكرانيا'),
(50735, 3249729024, 3249729535, 'GB', 'GBR', 'المملكة المتحدة'),
(50736, 3249729536, 3249730559, 'PL', 'POL', 'بولندا'),
(50737, 3249730560, 3249731583, 'IT', 'ITA', 'إيطاليا'),
(50738, 3249731584, 3249732607, 'UA', 'UKR', 'أوكرانيا'),
(50739, 3249732608, 3249733631, 'IT', 'ITA', 'إيطاليا'),
(50740, 3249733632, 3249799167, 'CZ', 'CZE', 'التشيك'),
(50741, 3249799168, 3249932287, 'SE', 'SWE', 'السويد'),
(50742, 3249932288, 3249934335, 'GB', 'GBR', 'المملكة المتحدة'),
(50743, 3249934336, 3250061311, 'SE', 'SWE', 'السويد'),
(50744, 3250061312, 3250183199, 'FI', 'FIN', 'فنلندا'),
(50745, 3250183200, 3250183215, 'SE', 'SWE', 'السويد'),
(50746, 3250183216, 3250187583, 'FI', 'FIN', 'فنلندا'),
(50747, 3250187584, 3250187647, 'SE', 'SWE', 'السويد'),
(50748, 3250187648, 3250192383, 'FI', 'FIN', 'فنلندا'),
(50749, 3250192384, 3250192639, 'AT', 'AUT', 'النمسا'),
(50750, 3250192640, 3250192895, 'RU', 'RUS', 'الإتحاد الروسي'),
(50751, 3250192896, 3250193151, 'IL', 'ISR', 'إسرائيل'),
(50752, 3250193152, 3250193407, 'DE', 'DEU', 'ألمانيا'),
(50753, 3250193408, 3250193663, 'PL', 'POL', 'بولندا'),
(50754, 3250193664, 3250194175, 'AT', 'AUT', 'النمسا'),
(50755, 3250194176, 3250194431, 'DE', 'DEU', 'ألمانيا'),
(50756, 3250194432, 3250194687, 'FR', 'FRA', 'فرنسا'),
(50757, 3250194688, 3250194943, 'UA', 'UKR', 'أوكرانيا'),
(50758, 3250194944, 3250195455, 'RO', 'ROM', 'رومانيا'),
(50759, 3250195456, 3250195711, 'DE', 'DEU', 'ألمانيا'),
(50760, 3250195712, 3250196223, 'GB', 'GBR', 'المملكة المتحدة'),
(50761, 3250196224, 3250196479, 'UA', 'UKR', 'أوكرانيا'),
(50762, 3250196480, 3250200575, 'AT', 'AUT', 'النمسا'),
(50763, 3250200576, 3250200831, 'HU', 'HUN', 'هنغاريا'),
(50764, 3250200832, 3250201087, 'RO', 'ROM', 'رومانيا'),
(50765, 3250201088, 3250201343, 'RU', 'RUS', 'الإتحاد الروسي'),
(50766, 3250201344, 3250201599, 'DK', 'DNK', 'الدنيمارك'),
(50767, 3250202624, 3250233855, 'AT', 'AUT', 'النمسا'),
(50768, 3250233856, 3250234111, 'GB', 'GBR', 'المملكة المتحدة'),
(50769, 3250234112, 3250234367, 'GR', 'GRC', 'اليونان'),
(50770, 3250234368, 3250245631, 'AT', 'AUT', 'النمسا'),
(50771, 3250245632, 3250245887, 'TR', 'TUR', 'تركيا'),
(50772, 3250245888, 3250246143, 'AT', 'AUT', 'النمسا'),
(50773, 3250246144, 3250246399, 'GB', 'GBR', 'المملكة المتحدة'),
(50774, 3250246400, 3250257663, 'AT', 'AUT', 'النمسا'),
(50775, 3250257664, 3250257919, 'PL', 'POL', 'بولندا'),
(50776, 3250258176, 3250323199, 'AT', 'AUT', 'النمسا'),
(50777, 3250323200, 3250323455, 'RU', 'RUS', 'الإتحاد الروسي'),
(50778, 3250323456, 3250323711, 'PL', 'POL', 'بولندا'),
(50779, 3250323712, 3250324479, 'SA', 'SAU', 'السعودية'),
(50780, 3250324480, 3250324991, 'GB', 'GBR', 'المملكة المتحدة'),
(50781, 3250324992, 3250325247, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(50782, 3250325504, 3250326527, 'OM', 'OMN', 'عمان'),
(50783, 3250326528, 3250327039, 'BH', 'BHR', 'البحرين'),
(50784, 3250327040, 3250331647, 'SA', 'SAU', 'السعودية'),
(50785, 3250331648, 3250335743, 'MT', 'MLT', 'مالطا'),
(50786, 3250335744, 3250339839, 'KW', 'KWT', 'الكويت'),
(50787, 3250339840, 3250348031, 'JO', 'JOR', 'الأردن'),
(50788, 3250348032, 3250356223, 'BH', 'BHR', 'البحرين'),
(50789, 3250356224, 3250357247, 'LB', 'LBN', 'لبنان'),
(50790, 3250357248, 3250357823, 'GB', 'GBR', 'المملكة المتحدة'),
(50791, 3250357824, 3250357855, 'FR', 'FRA', 'فرنسا'),
(50792, 3250357856, 3250357871, 'EE', 'EST', 'إستونيا'),
(50793, 3250357872, 3250357879, 'CH', 'CHE', 'سويسرا'),
(50794, 3250357880, 3250357887, 'SE', 'SWE', 'السويد'),
(50795, 3250357888, 3250357895, 'DK', 'DNK', 'الدنيمارك'),
(50796, 3250357920, 3250357927, 'PL', 'POL', 'بولندا'),
(50797, 3250357960, 3250358015, 'GB', 'GBR', 'المملكة المتحدة'),
(50798, 3250358016, 3250358527, 'LB', 'LBN', 'لبنان'),
(50799, 3250358528, 3250358783, 'HU', 'HUN', 'هنغاريا'),
(50800, 3250358784, 3250359295, 'LB', 'LBN', 'لبنان'),
(50801, 3250359296, 3250359807, 'HU', 'HUN', 'هنغاريا'),
(50802, 3250359808, 3250362879, 'KW', 'KWT', 'الكويت'),
(50803, 3250362880, 3250363391, 'DE', 'DEU', 'ألمانيا'),
(50804, 3250363904, 3250364415, 'DE', 'DEU', 'ألمانيا'),
(50805, 3250364416, 3250372607, 'KW', 'KWT', 'الكويت'),
(50806, 3250372608, 3250373375, 'HU', 'HUN', 'هنغاريا'),
(50807, 3250373376, 3250373631, 'GB', 'GBR', 'المملكة المتحدة'),
(50808, 3250373632, 3250374143, 'DE', 'DEU', 'ألمانيا'),
(50809, 3250374656, 3250374911, 'SA', 'SAU', 'السعودية'),
(50810, 3250374912, 3250375679, 'SE', 'SWE', 'السويد'),
(50811, 3250375680, 3250376703, 'GB', 'GBR', 'المملكة المتحدة'),
(50812, 3250376704, 3250380799, 'AT', 'AUT', 'النمسا'),
(50813, 3250380800, 3250381055, 'DK', 'DNK', 'الدنيمارك'),
(50814, 3250381056, 3250386943, 'CH', 'CHE', 'سويسرا'),
(50815, 3250386944, 3250387199, 'SE', 'SWE', 'السويد'),
(50816, 3250387200, 3250387455, 'FR', 'FRA', 'فرنسا'),
(50817, 3250387456, 3250387711, 'DE', 'DEU', 'ألمانيا'),
(50818, 3250387712, 3250387967, 'FR', 'FRA', 'فرنسا'),
(50819, 3250387968, 3250388223, 'JO', 'JOR', 'الأردن'),
(50820, 3250388224, 3250388479, 'PL', 'POL', 'بولندا'),
(50821, 3250388480, 3250388735, 'UA', 'UKR', 'أوكرانيا'),
(50822, 3250388736, 3250388991, 'FR', 'FRA', 'فرنسا'),
(50823, 3250405888, 3250406399, 'IE', 'IRL', 'إيرلندا'),
(50824, 3250406400, 3250406911, 'RU', 'RUS', 'الإتحاد الروسي'),
(50825, 3250406912, 3250407423, 'RO', 'ROM', 'رومانيا'),
(50826, 3250407424, 3250407935, 'PL', 'POL', 'بولندا'),
(50827, 3250407936, 3250408447, 'GB', 'GBR', 'المملكة المتحدة'),
(50828, 3250408448, 3250408959, 'PL', 'POL', 'بولندا'),
(50829, 3250408960, 3250409471, 'DE', 'DEU', 'ألمانيا'),
(50830, 3250409472, 3250409983, 'GB', 'GBR', 'المملكة المتحدة'),
(50831, 3250409984, 3250410495, 'DE', 'DEU', 'ألمانيا'),
(50832, 3250410496, 3250411007, 'AT', 'AUT', 'النمسا'),
(50833, 3250411008, 3250411519, 'LT', 'LTU', 'ليتوانيا'),
(50834, 3250411520, 3250412031, 'RU', 'RUS', 'الإتحاد الروسي'),
(50835, 3250412032, 3250412543, 'FR', 'FRA', 'فرنسا'),
(50836, 3250412544, 3250413055, 'DK', 'DNK', 'الدنيمارك'),
(50837, 3250413056, 3250413567, 'DE', 'DEU', 'ألمانيا'),
(50838, 3250413568, 3250414079, 'UA', 'UKR', 'أوكرانيا'),
(50839, 3250414080, 3250414591, 'RO', 'ROM', 'رومانيا'),
(50840, 3250414592, 3250415103, 'DE', 'DEU', 'ألمانيا'),
(50841, 3250415104, 3250415615, 'NL', 'NLD', 'هولندا'),
(50842, 3250415616, 3250416127, 'FR', 'FRA', 'فرنسا'),
(50843, 3250416128, 3250417663, 'DE', 'DEU', 'ألمانيا'),
(50844, 3250417664, 3250418175, 'IT', 'ITA', 'إيطاليا'),
(50845, 3250418176, 3250418687, 'DE', 'DEU', 'ألمانيا'),
(50846, 3250418688, 3250419199, 'PL', 'POL', 'بولندا'),
(50847, 3250419200, 3250419711, 'NO', 'NOR', 'النرويج'),
(50848, 3250419712, 3250420223, 'RU', 'RUS', 'الإتحاد الروسي'),
(50849, 3250420224, 3250420735, 'IR', 'IRN', 'إيران'),
(50850, 3250420736, 3250421247, 'FR', 'FRA', 'فرنسا'),
(50851, 3250421248, 3250421759, 'UA', 'UKR', 'أوكرانيا'),
(50852, 3250422016, 3250423295, 'GB', 'GBR', 'المملكة المتحدة'),
(50853, 3250423296, 3250423551, 'NL', 'NLD', 'هولندا'),
(50854, 3250423552, 3250423807, 'BE', 'BEL', 'بلجيكا'),
(50855, 3250423808, 3250424063, 'AT', 'AUT', 'النمسا'),
(50856, 3250424064, 3250424319, 'DE', 'DEU', 'ألمانيا'),
(50857, 3250424320, 3250424831, 'NL', 'NLD', 'هولندا'),
(50858, 3250424832, 3250425343, 'GB', 'GBR', 'المملكة المتحدة'),
(50859, 3250425344, 3250425599, 'TR', 'TUR', 'تركيا'),
(50860, 3250425600, 3250425855, 'FR', 'FRA', 'فرنسا'),
(50861, 3250425856, 3250426111, 'LT', 'LTU', 'ليتوانيا'),
(50862, 3250426112, 3250426367, 'NO', 'NOR', 'النرويج'),
(50863, 3250426368, 3250426623, 'AT', 'AUT', 'النمسا'),
(50864, 3250426624, 3250426879, 'BE', 'BEL', 'بلجيكا'),
(50865, 3250426880, 3250427135, 'JO', 'JOR', 'الأردن'),
(50866, 3250427136, 3250427391, 'NL', 'NLD', 'هولندا'),
(50867, 3250427392, 3250429951, 'DE', 'DEU', 'ألمانيا'),
(50868, 3250429952, 3250438143, 'SI', 'SVN', 'سلوفينيا'),
(50869, 3250438144, 3250438207, 'FR', 'FRA', 'فرنسا'),
(50870, 3250438208, 3250438399, 'CH', 'CHE', 'سويسرا'),
(50871, 3250438400, 3250438431, 'FR', 'FRA', 'فرنسا'),
(50872, 3250438432, 3250443519, 'CH', 'CHE', 'سويسرا'),
(50873, 3250443520, 3250443527, 'DE', 'DEU', 'ألمانيا'),
(50874, 3250443528, 3250443543, 'CH', 'CHE', 'سويسرا'),
(50875, 3250443544, 3250443551, 'DE', 'DEU', 'ألمانيا'),
(50876, 3250443552, 3250446335, 'CH', 'CHE', 'سويسرا'),
(50877, 3250446336, 3250451583, 'DE', 'DEU', 'ألمانيا'),
(50878, 3250451584, 3250451599, 'AT', 'AUT', 'النمسا'),
(50879, 3250451600, 3250454527, 'DE', 'DEU', 'ألمانيا'),
(50880, 3250454528, 3250585599, 'BE', 'BEL', 'بلجيكا'),
(50881, 3250585600, 3250585855, 'NL', 'NLD', 'هولندا'),
(50882, 3250585856, 3250588671, 'PT', 'PRT', 'البورتوغال'),
(50883, 3250588672, 3250588799, 'IE', 'IRL', 'إيرلندا'),
(50884, 3250588800, 3250588927, 'AT', 'AUT', 'النمسا'),
(50885, 3250588928, 3250589183, 'GB', 'GBR', 'المملكة المتحدة'),
(50886, 3250589184, 3250589439, 'DE', 'DEU', 'ألمانيا'),
(50887, 3250589440, 3250589471, 'IE', 'IRL', 'إيرلندا'),
(50888, 3250589472, 3250589503, 'NL', 'NLD', 'هولندا'),
(50889, 3250589504, 3250589567, 'HR', 'HRV', 'كرواتيا'),
(50890, 3250589632, 3250589695, 'NO', 'NOR', 'النرويج'),
(50891, 3250589696, 3250593791, 'CH', 'CHE', 'سويسرا'),
(50892, 3250593792, 3250594815, 'GB', 'GBR', 'المملكة المتحدة'),
(50893, 3250594816, 3250595327, 'UA', 'UKR', 'أوكرانيا'),
(50894, 3250595328, 3250595839, 'GR', 'GRC', 'اليونان'),
(50895, 3250595840, 3250596351, 'DE', 'DEU', 'ألمانيا'),
(50896, 3250596352, 3250597887, 'RO', 'ROM', 'رومانيا'),
(50897, 3250597888, 3250598399, 'BG', 'BGR', 'بلغاريا'),
(50898, 3250598400, 3250598911, 'GB', 'GBR', 'المملكة المتحدة'),
(50899, 3250598912, 3250599423, 'RO', 'ROM', 'رومانيا'),
(50900, 3250599424, 3250599935, 'SE', 'SWE', 'السويد'),
(50901, 3250599936, 3250600447, 'BG', 'BGR', 'بلغاريا'),
(50902, 3250600448, 3250601471, 'DE', 'DEU', 'ألمانيا'),
(50903, 3250601472, 3250601983, 'PL', 'POL', 'بولندا'),
(50904, 3250601984, 3250610175, 'GB', 'GBR', 'المملكة المتحدة'),
(50905, 3250610176, 3250618367, 'TR', 'TUR', 'تركيا'),
(50906, 3250618368, 3250626559, 'RU', 'RUS', 'الإتحاد الروسي'),
(50907, 3250626560, 3250634751, 'PL', 'POL', 'بولندا'),
(50908, 3250634752, 3250642943, 'GB', 'GBR', 'المملكة المتحدة'),
(50909, 3250642944, 3250651135, 'CH', 'CHE', 'سويسرا'),
(50910, 3250651136, 3250659327, 'IT', 'ITA', 'إيطاليا'),
(50911, 3250667520, 3250675711, 'PL', 'POL', 'بولندا'),
(50912, 3250675712, 3250683903, 'GB', 'GBR', 'المملكة المتحدة'),
(50913, 3250683904, 3250692095, 'CH', 'CHE', 'سويسرا'),
(50914, 3250692096, 3250692351, 'NO', 'NOR', 'النرويج'),
(50915, 3250692352, 3250692607, 'NL', 'NLD', 'هولندا'),
(50916, 3250692608, 3250693375, 'BG', 'BGR', 'بلغاريا'),
(50917, 3250693376, 3250694399, 'IE', 'IRL', 'إيرلندا'),
(50918, 3250694400, 3250694655, 'GB', 'GBR', 'المملكة المتحدة'),
(50919, 3250694656, 3250694911, 'SK', 'SVK', 'سلوفاكيا'),
(50920, 3250694912, 3250695167, 'NL', 'NLD', 'هولندا'),
(50921, 3250695168, 3250695679, 'IT', 'ITA', 'إيطاليا'),
(50922, 3250695680, 3250697471, 'DE', 'DEU', 'ألمانيا'),
(50923, 3250697472, 3250697727, 'PL', 'POL', 'بولندا'),
(50924, 3250697728, 3250697983, 'BG', 'BGR', 'بلغاريا'),
(50925, 3250697984, 3250698239, 'IT', 'ITA', 'إيطاليا'),
(50926, 3250698240, 3250698751, 'GR', 'GRC', 'اليونان'),
(50927, 3250699264, 3250699775, 'GB', 'GBR', 'المملكة المتحدة'),
(50928, 3250699776, 3250700287, 'DE', 'DEU', 'ألمانيا'),
(50929, 3250700288, 3250708479, 'UA', 'UKR', 'أوكرانيا'),
(50930, 3250708480, 3250716671, 'KZ', 'KAZ', 'كازاخستان'),
(50931, 3250716672, 3250716927, 'RO', 'ROM', 'رومانيا'),
(50932, 3250718208, 3250720767, 'DE', 'DEU', 'ألمانيا'),
(50933, 3250720768, 3250722047, 'IT', 'ITA', 'إيطاليا'),
(50934, 3250722048, 3250722303, 'RO', 'ROM', 'رومانيا'),
(50935, 3250722304, 3250724863, 'GB', 'GBR', 'المملكة المتحدة'),
(50936, 3250749696, 3250749951, 'IT', 'ITA', 'إيطاليا'),
(50937, 3250749952, 3250750463, 'RO', 'ROM', 'رومانيا'),
(50938, 3250750464, 3250751487, 'FR', 'FRA', 'فرنسا'),
(50939, 3250751488, 3250751999, 'DE', 'DEU', 'ألمانيا'),
(50940, 3250752000, 3250752511, 'CH', 'CHE', 'سويسرا'),
(50941, 3250752512, 3250753023, 'BG', 'BGR', 'بلغاريا'),
(50942, 3250753024, 3250754047, 'DE', 'DEU', 'ألمانيا'),
(50943, 3250754048, 3250754303, 'AT', 'AUT', 'النمسا'),
(50944, 3250754304, 3250754479, 'GB', 'GBR', 'المملكة المتحدة'),
(50945, 3250754480, 3250754495, 'IE', 'IRL', 'إيرلندا'),
(50946, 3250754496, 3250754559, 'GB', 'GBR', 'المملكة المتحدة'),
(50947, 3250754560, 3250755071, 'DE', 'DEU', 'ألمانيا'),
(50948, 3250755072, 3250755583, 'GB', 'GBR', 'المملكة المتحدة'),
(50949, 3250755584, 3250755839, 'FR', 'FRA', 'فرنسا'),
(50950, 3250755840, 3250756351, 'RU', 'RUS', 'الإتحاد الروسي'),
(50951, 3250756352, 3250756607, 'PT', 'PRT', 'البورتوغال'),
(50952, 3250756608, 3250756863, 'BG', 'BGR', 'بلغاريا'),
(50953, 3250756864, 3250757119, 'DE', 'DEU', 'ألمانيا'),
(50954, 3250757120, 3250757375, 'BE', 'BEL', 'بلجيكا'),
(50955, 3250757376, 3250757631, 'HU', 'HUN', 'هنغاريا'),
(50956, 3250765824, 3250782207, 'SE', 'SWE', 'السويد'),
(50957, 3250782208, 3250847743, 'GB', 'GBR', 'المملكة المتحدة'),
(50958, 3250847744, 3250978815, 'DE', 'DEU', 'ألمانيا'),
(50959, 3250978816, 3250989311, 'HR', 'HRV', 'كرواتيا'),
(50960, 3250989312, 3250989343, 'BA', 'BIH', 'البوسنه والهرسك'),
(50961, 3250989344, 3251044351, 'HR', 'HRV', 'كرواتيا'),
(50962, 3251044352, 3251109887, 'FI', 'FIN', 'فنلندا'),
(50963, 3251109888, 3251110143, 'SI', 'SVN', 'سلوفينيا'),
(50964, 3251110144, 3251110655, 'BG', 'BGR', 'بلغاريا'),
(50965, 3251110656, 3251110911, 'IT', 'ITA', 'إيطاليا'),
(50966, 3251110912, 3251111167, 'FR', 'FRA', 'فرنسا'),
(50967, 3251111168, 3251111423, 'CH', 'CHE', 'سويسرا'),
(50968, 3251111424, 3251111679, 'AT', 'AUT', 'النمسا'),
(50969, 3251111680, 3251111935, 'ES', 'ESP', 'إسبانيا'),
(50970, 3251111936, 3251112191, 'BG', 'BGR', 'بلغاريا'),
(50971, 3251112192, 3251112447, 'SK', 'SVK', 'سلوفاكيا'),
(50972, 3251112448, 3251112703, 'RU', 'RUS', 'الإتحاد الروسي'),
(50973, 3251112704, 3251112959, 'SE', 'SWE', 'السويد'),
(50974, 3251112960, 3251113215, 'BG', 'BGR', 'بلغاريا'),
(50975, 3251113216, 3251113471, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(50976, 3251113472, 3251114495, 'BG', 'BGR', 'بلغاريا'),
(50977, 3251114496, 3251114751, 'RU', 'RUS', 'الإتحاد الروسي'),
(50978, 3251114752, 3251115007, 'RO', 'ROM', 'رومانيا'),
(50979, 3251115008, 3251115263, 'PL', 'POL', 'بولندا'),
(50980, 3251115264, 3251115519, 'RU', 'RUS', 'الإتحاد الروسي'),
(50981, 3251115520, 3251115775, 'UA', 'UKR', 'أوكرانيا'),
(50982, 3251115776, 3251116031, 'BE', 'BEL', 'بلجيكا'),
(50983, 3251116032, 3251116287, 'BG', 'BGR', 'بلغاريا'),
(50984, 3251116288, 3251116543, 'GB', 'GBR', 'المملكة المتحدة'),
(50985, 3251116544, 3251116799, 'DK', 'DNK', 'الدنيمارك'),
(50986, 3251116800, 3251117055, 'GB', 'GBR', 'المملكة المتحدة'),
(50987, 3251117056, 3251117311, 'BG', 'BGR', 'بلغاريا'),
(50988, 3251117312, 3251117567, 'FR', 'FRA', 'فرنسا'),
(50989, 3251117568, 3251117823, 'IL', 'ISR', 'إسرائيل'),
(50990, 3251117824, 3251118079, 'SE', 'SWE', 'السويد'),
(50991, 3251118080, 3251118591, 'UA', 'UKR', 'أوكرانيا'),
(50992, 3251118592, 3251119103, 'RU', 'RUS', 'الإتحاد الروسي'),
(50993, 3251119104, 3251120127, 'UA', 'UKR', 'أوكرانيا'),
(50994, 3251120128, 3251120639, 'KW', 'KWT', 'الكويت'),
(50995, 3251120640, 3251121151, 'FR', 'FRA', 'فرنسا'),
(50996, 3251121152, 3251121663, 'DK', 'DNK', 'الدنيمارك'),
(50997, 3251121664, 3251122175, 'PL', 'POL', 'بولندا'),
(50998, 3251122176, 3251122687, 'CH', 'CHE', 'سويسرا'),
(50999, 3251122688, 3251123199, 'PL', 'POL', 'بولندا'),
(51000, 3251123200, 3251123711, 'FR', 'FRA', 'فرنسا'),
(51001, 3251123712, 3251124223, 'RO', 'ROM', 'رومانيا'),
(51002, 3251124224, 3251124735, 'NL', 'NLD', 'هولندا'),
(51003, 3251124736, 3251125247, 'FR', 'FRA', 'فرنسا'),
(51004, 3251125248, 3251125759, 'BE', 'BEL', 'بلجيكا'),
(51005, 3251125760, 3251126271, 'RU', 'RUS', 'الإتحاد الروسي'),
(51006, 3251126272, 3251126783, 'UA', 'UKR', 'أوكرانيا'),
(51007, 3251126784, 3251127295, 'PL', 'POL', 'بولندا'),
(51008, 3251127296, 3251127807, 'UA', 'UKR', 'أوكرانيا'),
(51009, 3251127808, 3251128319, 'NL', 'NLD', 'هولندا'),
(51010, 3251128320, 3251128831, 'DE', 'DEU', 'ألمانيا'),
(51011, 3251128832, 3251129343, 'SE', 'SWE', 'السويد'),
(51012, 3251129344, 3251129855, 'UA', 'UKR', 'أوكرانيا'),
(51013, 3251129856, 3251130367, 'CH', 'CHE', 'سويسرا'),
(51014, 3251130368, 3251130879, 'GB', 'GBR', 'المملكة المتحدة'),
(51015, 3251130880, 3251131391, 'PL', 'POL', 'بولندا'),
(51016, 3251131392, 3251131903, 'UA', 'UKR', 'أوكرانيا'),
(51017, 3251131904, 3251132415, 'SE', 'SWE', 'السويد'),
(51018, 3251132416, 3251132927, 'RU', 'RUS', 'الإتحاد الروسي'),
(51019, 3251132928, 3251133439, 'DK', 'DNK', 'الدنيمارك'),
(51020, 3251133440, 3251133951, 'NO', 'NOR', 'النرويج'),
(51021, 3251133952, 3251134463, 'RU', 'RUS', 'الإتحاد الروسي'),
(51022, 3251134464, 3251134975, 'DE', 'DEU', 'ألمانيا'),
(51023, 3251134976, 3251135999, 'GB', 'GBR', 'المملكة المتحدة'),
(51024, 3251136000, 3251136511, 'RO', 'ROM', 'رومانيا'),
(51025, 3251136512, 3251137023, 'DK', 'DNK', 'الدنيمارك'),
(51026, 3251137024, 3251137535, 'DE', 'DEU', 'ألمانيا'),
(51027, 3251137536, 3251138047, 'PL', 'POL', 'بولندا'),
(51028, 3251138048, 3251138559, 'FR', 'FRA', 'فرنسا'),
(51029, 3251138560, 3251139071, 'AT', 'AUT', 'النمسا'),
(51030, 3251139072, 3251139583, 'GB', 'GBR', 'المملكة المتحدة'),
(51031, 3251139584, 3251140095, 'FR', 'FRA', 'فرنسا'),
(51032, 3251140096, 3251141631, 'PL', 'POL', 'بولندا'),
(51033, 3251141632, 3251142143, 'LT', 'LTU', 'ليتوانيا'),
(51034, 3251142144, 3251142655, 'RO', 'ROM', 'رومانيا'),
(51035, 3251142656, 3251142911, 'DE', 'DEU', 'ألمانيا'),
(51036, 3251142912, 3251143167, 'RU', 'RUS', 'الإتحاد الروسي'),
(51037, 3251143168, 3251143423, 'AM', 'ARM', 'أرمينيا'),
(51038, 3251143424, 3251143679, 'LV', 'LVA', 'لاتفيا'),
(51039, 3251143680, 3251143935, 'NL', 'NLD', 'هولندا'),
(51040, 3251143936, 3251144191, 'PL', 'POL', 'بولندا'),
(51041, 3251144192, 3251144447, 'TR', 'TUR', 'تركيا'),
(51042, 3251144448, 3251144703, 'BE', 'BEL', 'بلجيكا'),
(51043, 3251144704, 3251144959, 'HU', 'HUN', 'هنغاريا'),
(51044, 3251144960, 3251145471, 'DE', 'DEU', 'ألمانيا'),
(51045, 3251145472, 3251145727, 'FR', 'FRA', 'فرنسا'),
(51046, 3251145728, 3251145983, 'NL', 'NLD', 'هولندا'),
(51047, 3251145984, 3251146239, 'RO', 'ROM', 'رومانيا'),
(51048, 3251146240, 3251146495, 'AT', 'AUT', 'النمسا'),
(51049, 3251146496, 3251146751, 'SK', 'SVK', 'سلوفاكيا'),
(51050, 3251146752, 3251147007, 'CH', 'CHE', 'سويسرا'),
(51051, 3251147008, 3251147263, 'GB', 'GBR', 'المملكة المتحدة'),
(51052, 3251147264, 3251147519, 'PL', 'POL', 'بولندا'),
(51053, 3251147520, 3251147775, 'NL', 'NLD', 'هولندا'),
(51054, 3251147776, 3251148031, 'SE', 'SWE', 'السويد'),
(51055, 3251148032, 3251148287, 'RU', 'RUS', 'الإتحاد الروسي'),
(51056, 3251148544, 3251148799, 'UA', 'UKR', 'أوكرانيا'),
(51057, 3251148800, 3251149055, 'HU', 'HUN', 'هنغاريا'),
(51058, 3251149056, 3251149311, 'NL', 'NLD', 'هولندا'),
(51059, 3251149312, 3251149567, 'DE', 'DEU', 'ألمانيا'),
(51060, 3251149568, 3251149823, 'IE', 'IRL', 'إيرلندا'),
(51061, 3251149824, 3251150079, 'DE', 'DEU', 'ألمانيا'),
(51062, 3251150080, 3251150335, 'CH', 'CHE', 'سويسرا'),
(51063, 3251150336, 3251150591, 'GB', 'GBR', 'المملكة المتحدة'),
(51064, 3251150592, 3251150847, 'CH', 'CHE', 'سويسرا'),
(51065, 3251150848, 3251151103, 'DE', 'DEU', 'ألمانيا'),
(51066, 3251151104, 3251151359, 'UA', 'UKR', 'أوكرانيا'),
(51067, 3251151360, 3251151615, 'DE', 'DEU', 'ألمانيا'),
(51068, 3251151616, 3251151871, 'PL', 'POL', 'بولندا'),
(51069, 3251151872, 3251152127, 'NL', 'NLD', 'هولندا'),
(51070, 3251152128, 3251152639, 'RO', 'ROM', 'رومانيا'),
(51071, 3251152640, 3251152895, 'UA', 'UKR', 'أوكرانيا'),
(51072, 3251152896, 3251153151, 'RU', 'RUS', 'الإتحاد الروسي'),
(51073, 3251153152, 3251153407, 'UA', 'UKR', 'أوكرانيا'),
(51074, 3251153408, 3251153663, 'TR', 'TUR', 'تركيا'),
(51075, 3251153664, 3251153919, 'FR', 'FRA', 'فرنسا'),
(51076, 3251153920, 3251154175, 'DE', 'DEU', 'ألمانيا'),
(51077, 3251154176, 3251154431, 'UA', 'UKR', 'أوكرانيا'),
(51078, 3251154432, 3251154687, 'NL', 'NLD', 'هولندا'),
(51079, 3251154688, 3251154943, 'UA', 'UKR', 'أوكرانيا'),
(51080, 3251154944, 3251155455, 'GB', 'GBR', 'المملكة المتحدة'),
(51081, 3251155456, 3251155711, 'NL', 'NLD', 'هولندا'),
(51082, 3251155712, 3251155967, 'UA', 'UKR', 'أوكرانيا'),
(51083, 3251155968, 3251156223, 'TR', 'TUR', 'تركيا'),
(51084, 3251156224, 3251156735, 'FR', 'FRA', 'فرنسا'),
(51085, 3251156736, 3251156991, 'UA', 'UKR', 'أوكرانيا'),
(51086, 3251156992, 3251157247, 'FR', 'FRA', 'فرنسا'),
(51087, 3251157248, 3251157503, 'BE', 'BEL', 'بلجيكا'),
(51088, 3251157504, 3251158015, 'PL', 'POL', 'بولندا'),
(51089, 3251158016, 3251158271, 'TR', 'TUR', 'تركيا'),
(51090, 3251158272, 3251158527, 'RU', 'RUS', 'الإتحاد الروسي'),
(51091, 3251158528, 3251158783, 'UA', 'UKR', 'أوكرانيا'),
(51092, 3251158784, 3251159295, 'GB', 'GBR', 'المملكة المتحدة'),
(51093, 3251159296, 3251159551, 'DE', 'DEU', 'ألمانيا'),
(51094, 3251159552, 3251159807, 'ES', 'ESP', 'إسبانيا'),
(51095, 3251159808, 3251160063, 'DE', 'DEU', 'ألمانيا'),
(51096, 3251160064, 3251160319, 'JO', 'JOR', 'الأردن'),
(51097, 3251160320, 3251160575, 'PL', 'POL', 'بولندا'),
(51098, 3251160576, 3251160831, 'NL', 'NLD', 'هولندا'),
(51099, 3251160832, 3251161087, 'RU', 'RUS', 'الإتحاد الروسي'),
(51100, 3251161088, 3251161343, 'RO', 'ROM', 'رومانيا'),
(51101, 3251161344, 3251161599, 'LV', 'LVA', 'لاتفيا'),
(51102, 3251161600, 3251161855, 'SE', 'SWE', 'السويد'),
(51103, 3251161856, 3251162111, 'HR', 'HRV', 'كرواتيا'),
(51104, 3251162112, 3251162367, 'DK', 'DNK', 'الدنيمارك'),
(51105, 3251162368, 3251162623, 'UA', 'UKR', 'أوكرانيا'),
(51106, 3251162624, 3251162879, 'DE', 'DEU', 'ألمانيا'),
(51107, 3251162880, 3251163135, 'SI', 'SVN', 'سلوفينيا'),
(51108, 3251163136, 3251163391, 'SE', 'SWE', 'السويد'),
(51109, 3251163392, 3251163647, 'UA', 'UKR', 'أوكرانيا'),
(51110, 3251163648, 3251163903, 'DE', 'DEU', 'ألمانيا'),
(51111, 3251163904, 3251164159, 'RU', 'RUS', 'الإتحاد الروسي'),
(51112, 3251164160, 3251164415, 'UA', 'UKR', 'أوكرانيا'),
(51113, 3251164416, 3251164671, 'IT', 'ITA', 'إيطاليا'),
(51114, 3251164672, 3251164927, 'NL', 'NLD', 'هولندا'),
(51115, 3251164928, 3251165439, 'PL', 'POL', 'بولندا'),
(51116, 3251165440, 3251165695, 'CH', 'CHE', 'سويسرا'),
(51117, 3251165696, 3251165951, 'DE', 'DEU', 'ألمانيا'),
(51118, 3251165952, 3251166207, 'UA', 'UKR', 'أوكرانيا'),
(51119, 3251166208, 3251166463, 'CH', 'CHE', 'سويسرا'),
(51120, 3251166464, 3251166719, 'RU', 'RUS', 'الإتحاد الروسي'),
(51121, 3251166720, 3251166975, 'FR', 'FRA', 'فرنسا'),
(51122, 3251166976, 3251167231, 'CH', 'CHE', 'سويسرا'),
(51123, 3251167232, 3251167487, 'LV', 'LVA', 'لاتفيا'),
(51124, 3251167488, 3251167743, 'DK', 'DNK', 'الدنيمارك'),
(51125, 3251167744, 3251168255, 'PL', 'POL', 'بولندا'),
(51126, 3251168256, 3251168511, 'AT', 'AUT', 'النمسا'),
(51127, 3251168512, 3251168767, 'UA', 'UKR', 'أوكرانيا'),
(51128, 3251168768, 3251169023, 'DE', 'DEU', 'ألمانيا'),
(51129, 3251169024, 3251169279, 'FR', 'FRA', 'فرنسا'),
(51130, 3251169280, 3251170047, 'PL', 'POL', 'بولندا'),
(51131, 3251170048, 3251170303, 'NO', 'NOR', 'النرويج'),
(51132, 3251170304, 3251170559, 'CH', 'CHE', 'سويسرا'),
(51133, 3251170560, 3251170815, 'DE', 'DEU', 'ألمانيا'),
(51134, 3251170816, 3251171327, 'RU', 'RUS', 'الإتحاد الروسي'),
(51135, 3251171328, 3251171839, 'DE', 'DEU', 'ألمانيا'),
(51136, 3251171840, 3251172095, 'RO', 'ROM', 'رومانيا'),
(51137, 3251172096, 3251172351, 'ES', 'ESP', 'إسبانيا'),
(51138, 3251172352, 3251172607, 'RO', 'ROM', 'رومانيا'),
(51139, 3251172608, 3251172863, 'GB', 'GBR', 'المملكة المتحدة'),
(51140, 3251172864, 3251173119, 'UA', 'UKR', 'أوكرانيا'),
(51141, 3251173120, 3251173375, 'SA', 'SAU', 'السعودية'),
(51142, 3251173376, 3251173631, 'UA', 'UKR', 'أوكرانيا'),
(51143, 3251173632, 3251173887, 'DE', 'DEU', 'ألمانيا'),
(51144, 3251173888, 3251174143, 'DK', 'DNK', 'الدنيمارك'),
(51145, 3251174144, 3251174399, 'RU', 'RUS', 'الإتحاد الروسي'),
(51146, 3251174400, 3251174655, 'RO', 'ROM', 'رومانيا'),
(51147, 3251174656, 3251174911, 'DE', 'DEU', 'ألمانيا'),
(51148, 3251174912, 3251175167, 'AT', 'AUT', 'النمسا'),
(51149, 3251175168, 3251175423, 'UA', 'UKR', 'أوكرانيا'),
(51150, 3251175424, 3251176703, 'FR', 'FRA', 'فرنسا'),
(51151, 3251176704, 3251176959, 'IT', 'ITA', 'إيطاليا'),
(51152, 3251176960, 3251177471, 'FR', 'FRA', 'فرنسا'),
(51153, 3251177472, 3251179519, 'DE', 'DEU', 'ألمانيا'),
(51154, 3251179520, 3251180031, 'SE', 'SWE', 'السويد'),
(51155, 3251180032, 3251180543, 'PL', 'POL', 'بولندا'),
(51156, 3251180544, 3251181055, 'RO', 'ROM', 'رومانيا'),
(51157, 3251181056, 3251181567, 'GR', 'GRC', 'اليونان'),
(51158, 3251181568, 3251182079, 'DE', 'DEU', 'ألمانيا'),
(51159, 3251182080, 3251182591, 'FR', 'FRA', 'فرنسا'),
(51160, 3251182592, 3251183103, 'IT', 'ITA', 'إيطاليا'),
(51161, 3251183104, 3251183615, 'RU', 'RUS', 'الإتحاد الروسي'),
(51162, 3251183616, 3251183871, 'NO', 'NOR', 'النرويج'),
(51163, 3251183872, 3251184127, 'CH', 'CHE', 'سويسرا'),
(51164, 3251184128, 3251184383, 'PL', 'POL', 'بولندا'),
(51165, 3251184384, 3251184639, 'DK', 'DNK', 'الدنيمارك'),
(51166, 3251184640, 3251184895, 'PL', 'POL', 'بولندا'),
(51167, 3251184896, 3251185407, 'DE', 'DEU', 'ألمانيا'),
(51168, 3251185408, 3251185663, 'DK', 'DNK', 'الدنيمارك'),
(51169, 3251185664, 3251185919, 'IT', 'ITA', 'إيطاليا'),
(51170, 3251185920, 3251186175, 'AT', 'AUT', 'النمسا'),
(51171, 3251186176, 3251186431, 'GB', 'GBR', 'المملكة المتحدة'),
(51172, 3251186432, 3251186687, 'SE', 'SWE', 'السويد'),
(51173, 3251186688, 3251186943, 'RO', 'ROM', 'رومانيا'),
(51174, 3251186944, 3251187199, 'SI', 'SVN', 'سلوفينيا'),
(51175, 3251187200, 3251187455, 'GR', 'GRC', 'اليونان'),
(51176, 3251187456, 3251187711, 'GB', 'GBR', 'المملكة المتحدة'),
(51177, 3251187712, 3251188735, 'NL', 'NLD', 'هولندا'),
(51178, 3251188736, 3251189759, 'DE', 'DEU', 'ألمانيا'),
(51179, 3251189760, 3251190783, 'IT', 'ITA', 'إيطاليا'),
(51180, 3251190784, 3251191807, 'UA', 'UKR', 'أوكرانيا'),
(51181, 3251191808, 3251192319, 'GB', 'GBR', 'المملكة المتحدة'),
(51182, 3251192320, 3251192831, 'LV', 'LVA', 'لاتفيا'),
(51183, 3251192832, 3251193343, 'BE', 'BEL', 'بلجيكا'),
(51184, 3251193344, 3251193855, 'GB', 'GBR', 'المملكة المتحدة'),
(51185, 3251193856, 3251194367, 'DE', 'DEU', 'ألمانيا'),
(51186, 3251194368, 3251194879, 'NO', 'NOR', 'النرويج'),
(51187, 3251194880, 3251195391, 'FR', 'FRA', 'فرنسا'),
(51188, 3251195392, 3251195903, 'CZ', 'CZE', 'التشيك'),
(51189, 3251195904, 3251196927, 'UA', 'UKR', 'أوكرانيا'),
(51190, 3251196928, 3251197951, 'CH', 'CHE', 'سويسرا'),
(51191, 3251197952, 3251198975, 'RU', 'RUS', 'الإتحاد الروسي'),
(51192, 3251198976, 3251199999, 'DE', 'DEU', 'ألمانيا'),
(51193, 3251200000, 3251200511, 'SE', 'SWE', 'السويد'),
(51194, 3251200512, 3251201279, 'UA', 'UKR', 'أوكرانيا'),
(51195, 3251201280, 3251201535, 'SI', 'SVN', 'سلوفينيا'),
(51196, 3251201536, 3251201791, 'AT', 'AUT', 'النمسا'),
(51197, 3251201792, 3251202047, 'FR', 'FRA', 'فرنسا'),
(51198, 3251202048, 3251202303, 'NL', 'NLD', 'هولندا'),
(51199, 3251202304, 3251202559, 'PL', 'POL', 'بولندا'),
(51200, 3251202560, 3251202815, 'AT', 'AUT', 'النمسا'),
(51201, 3251202816, 3251203327, 'ES', 'ESP', 'إسبانيا'),
(51202, 3251203328, 3251203583, 'SI', 'SVN', 'سلوفينيا'),
(51203, 3251203584, 3251203839, 'CZ', 'CZE', 'التشيك'),
(51204, 3251203840, 3251204095, 'SE', 'SWE', 'السويد'),
(51205, 3251204096, 3251204607, 'DE', 'DEU', 'ألمانيا'),
(51206, 3251204608, 3251205119, 'BG', 'BGR', 'بلغاريا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(51207, 3251205120, 3251205631, 'UA', 'UKR', 'أوكرانيا'),
(51208, 3251205632, 3251206143, 'RU', 'RUS', 'الإتحاد الروسي'),
(51209, 3251206144, 3251206655, 'GB', 'GBR', 'المملكة المتحدة'),
(51210, 3251206656, 3251207167, 'CH', 'CHE', 'سويسرا'),
(51211, 3251207168, 3251207679, 'GB', 'GBR', 'المملكة المتحدة'),
(51212, 3251207680, 3251208191, 'RU', 'RUS', 'الإتحاد الروسي'),
(51213, 3251208192, 3251209215, 'CY', 'CYP', 'قبرص'),
(51214, 3251209216, 3251210239, 'GB', 'GBR', 'المملكة المتحدة'),
(51215, 3251210240, 3251211263, 'PL', 'POL', 'بولندا'),
(51216, 3251211264, 3251212287, 'UA', 'UKR', 'أوكرانيا'),
(51217, 3251212288, 3251212415, 'DE', 'DEU', 'ألمانيا'),
(51218, 3251212416, 3251212671, 'FI', 'FIN', 'فنلندا'),
(51219, 3251212672, 3251212799, 'SE', 'SWE', 'السويد'),
(51220, 3251212800, 3251212927, 'FR', 'FRA', 'فرنسا'),
(51221, 3251213056, 3251213119, 'SE', 'SWE', 'السويد'),
(51222, 3251213120, 3251213151, 'NL', 'NLD', 'هولندا'),
(51223, 3251213152, 3251213183, 'FR', 'FRA', 'فرنسا'),
(51224, 3251213184, 3251213215, 'UA', 'UKR', 'أوكرانيا'),
(51225, 3251213216, 3251213247, 'CH', 'CHE', 'سويسرا'),
(51226, 3251213248, 3251213311, 'GB', 'GBR', 'المملكة المتحدة'),
(51227, 3251213312, 3251213439, 'DE', 'DEU', 'ألمانيا'),
(51228, 3251213440, 3251213503, 'GB', 'GBR', 'المملكة المتحدة'),
(51229, 3251213568, 3251213631, 'FR', 'FRA', 'فرنسا'),
(51230, 3251213696, 3251213759, 'LV', 'LVA', 'لاتفيا'),
(51231, 3251213760, 3251213823, 'TR', 'TUR', 'تركيا'),
(51232, 3251213824, 3251213887, 'GB', 'GBR', 'المملكة المتحدة'),
(51233, 3251213888, 3251214015, 'FI', 'FIN', 'فنلندا'),
(51234, 3251214016, 3251214079, 'UA', 'UKR', 'أوكرانيا'),
(51235, 3251214080, 3251214143, 'FR', 'FRA', 'فرنسا'),
(51236, 3251214144, 3251214207, 'MC', 'MCO', 'موناكو'),
(51237, 3251214208, 3251214271, 'RU', 'RUS', 'الإتحاد الروسي'),
(51238, 3251214272, 3251214335, 'DE', 'DEU', 'ألمانيا'),
(51239, 3251214336, 3251214463, 'RU', 'RUS', 'الإتحاد الروسي'),
(51240, 3251214464, 3251214591, 'UA', 'UKR', 'أوكرانيا'),
(51241, 3251214592, 3251214975, 'GB', 'GBR', 'المملكة المتحدة'),
(51242, 3251214976, 3251215103, 'RO', 'ROM', 'رومانيا'),
(51243, 3251215104, 3251215231, 'SI', 'SVN', 'سلوفينيا'),
(51244, 3251215232, 3251215359, 'IL', 'ISR', 'إسرائيل'),
(51245, 3251215360, 3251215487, 'UA', 'UKR', 'أوكرانيا'),
(51246, 3251215488, 3251215615, 'SE', 'SWE', 'السويد'),
(51247, 3251215616, 3251215743, 'TR', 'TUR', 'تركيا'),
(51248, 3251215744, 3251215871, 'GB', 'GBR', 'المملكة المتحدة'),
(51249, 3251216000, 3251216127, 'LI', 'LIE', 'ليختنشتاين'),
(51250, 3251216128, 3251216255, 'FI', 'FIN', 'فنلندا'),
(51251, 3251216256, 3251216383, 'RU', 'RUS', 'الإتحاد الروسي'),
(51252, 3251216384, 3251216639, 'GB', 'GBR', 'المملكة المتحدة'),
(51253, 3251216640, 3251216895, 'RO', 'ROM', 'رومانيا'),
(51254, 3251216896, 3251217151, 'BE', 'BEL', 'بلجيكا'),
(51255, 3251217152, 3251217407, 'GB', 'GBR', 'المملكة المتحدة'),
(51256, 3251217408, 3251217663, 'PL', 'POL', 'بولندا'),
(51257, 3251217664, 3251217919, 'SI', 'SVN', 'سلوفينيا'),
(51258, 3251217920, 3251218175, 'GR', 'GRC', 'اليونان'),
(51259, 3251218176, 3251218431, 'PL', 'POL', 'بولندا'),
(51260, 3251218432, 3251219199, 'DE', 'DEU', 'ألمانيا'),
(51261, 3251219200, 3251219455, 'IT', 'ITA', 'إيطاليا'),
(51262, 3251219456, 3251219711, 'BG', 'BGR', 'بلغاريا'),
(51263, 3251219712, 3251220223, 'AT', 'AUT', 'النمسا'),
(51264, 3251220224, 3251220479, 'UA', 'UKR', 'أوكرانيا'),
(51265, 3251220480, 3251222527, 'DE', 'DEU', 'ألمانيا'),
(51266, 3251222528, 3251224575, 'GB', 'GBR', 'المملكة المتحدة'),
(51267, 3251224576, 3251225087, 'UA', 'UKR', 'أوكرانيا'),
(51268, 3251225088, 3251225599, 'FR', 'FRA', 'فرنسا'),
(51269, 3251225600, 3251226111, 'GB', 'GBR', 'المملكة المتحدة'),
(51270, 3251226112, 3251226623, 'UA', 'UKR', 'أوكرانيا'),
(51271, 3251226624, 3251227135, 'GB', 'GBR', 'المملكة المتحدة'),
(51272, 3251227136, 3251227647, 'DE', 'DEU', 'ألمانيا'),
(51273, 3251227648, 3251228159, 'GB', 'GBR', 'المملكة المتحدة'),
(51274, 3251228160, 3251229695, 'UA', 'UKR', 'أوكرانيا'),
(51275, 3251229696, 3251230719, 'SI', 'SVN', 'سلوفينيا'),
(51276, 3251230720, 3251231743, 'UA', 'UKR', 'أوكرانيا'),
(51277, 3251231744, 3251232767, 'NO', 'NOR', 'النرويج'),
(51278, 3251232768, 3251233791, 'UA', 'UKR', 'أوكرانيا'),
(51279, 3251233792, 3251234815, 'RU', 'RUS', 'الإتحاد الروسي'),
(51280, 3251234816, 3251235839, 'RO', 'ROM', 'رومانيا'),
(51281, 3251235840, 3251236863, 'DE', 'DEU', 'ألمانيا'),
(51282, 3251236864, 3251237887, 'BG', 'BGR', 'بلغاريا'),
(51283, 3251237888, 3251238911, 'DK', 'DNK', 'الدنيمارك'),
(51284, 3251238912, 3251239935, 'FR', 'FRA', 'فرنسا'),
(51285, 3251239936, 3251240959, 'US', 'USA', 'الولايات المتحدة'),
(51286, 3251241216, 3251243007, 'GB', 'GBR', 'المملكة المتحدة'),
(51287, 3251243008, 3251245055, 'BE', 'BEL', 'بلجيكا'),
(51288, 3251245056, 3251245311, 'DE', 'DEU', 'ألمانيا'),
(51289, 3251245312, 3251245567, 'BE', 'BEL', 'بلجيكا'),
(51290, 3251245568, 3251245823, 'TR', 'TUR', 'تركيا'),
(51291, 3251245824, 3251246079, 'UA', 'UKR', 'أوكرانيا'),
(51292, 3251246080, 3251246335, 'DE', 'DEU', 'ألمانيا'),
(51293, 3251246336, 3251246591, 'UA', 'UKR', 'أوكرانيا'),
(51294, 3251246592, 3251246847, 'RO', 'ROM', 'رومانيا'),
(51295, 3251246848, 3251247103, 'NL', 'NLD', 'هولندا'),
(51296, 3251247104, 3251247359, 'FR', 'FRA', 'فرنسا'),
(51297, 3251247360, 3251247871, 'DE', 'DEU', 'ألمانيا'),
(51298, 3251247872, 3251248127, 'GB', 'GBR', 'المملكة المتحدة'),
(51299, 3251248128, 3251248383, 'DE', 'DEU', 'ألمانيا'),
(51300, 3251248384, 3251248639, 'SE', 'SWE', 'السويد'),
(51301, 3251248640, 3251248895, 'DE', 'DEU', 'ألمانيا'),
(51302, 3251248896, 3251249151, 'GB', 'GBR', 'المملكة المتحدة'),
(51303, 3251249152, 3251251199, 'NL', 'NLD', 'هولندا'),
(51304, 3251251200, 3251251455, 'PT', 'PRT', 'البورتوغال'),
(51305, 3251251456, 3251251711, 'GB', 'GBR', 'المملكة المتحدة'),
(51306, 3251251712, 3251251967, 'CH', 'CHE', 'سويسرا'),
(51307, 3251251968, 3251252223, 'BG', 'BGR', 'بلغاريا'),
(51308, 3251252224, 3251252479, 'AT', 'AUT', 'النمسا'),
(51309, 3251252480, 3251252735, 'NL', 'NLD', 'هولندا'),
(51310, 3251252736, 3251256831, 'CH', 'CHE', 'سويسرا'),
(51311, 3251256832, 3251257343, 'GB', 'GBR', 'المملكة المتحدة'),
(51312, 3251257344, 3251259903, 'BE', 'BEL', 'بلجيكا'),
(51313, 3251259904, 3251260671, 'FR', 'FRA', 'فرنسا'),
(51314, 3251260672, 3251261183, 'BE', 'BEL', 'بلجيكا'),
(51315, 3251261184, 3251261439, 'PT', 'PRT', 'البورتوغال'),
(51316, 3251261440, 3251264255, 'CH', 'CHE', 'سويسرا'),
(51317, 3251264256, 3251264511, 'BG', 'BGR', 'بلغاريا'),
(51318, 3251264512, 3251264767, 'IT', 'ITA', 'إيطاليا'),
(51319, 3251264768, 3251265023, 'GB', 'GBR', 'المملكة المتحدة'),
(51320, 3251265024, 3251265279, 'ES', 'ESP', 'إسبانيا'),
(51321, 3251265280, 3251265535, 'DE', 'DEU', 'ألمانيا'),
(51322, 3251265536, 3251267839, 'NL', 'NLD', 'هولندا'),
(51323, 3251267840, 3251268351, 'GB', 'GBR', 'المملكة المتحدة'),
(51324, 3251268352, 3251268607, 'NL', 'NLD', 'هولندا'),
(51325, 3251268864, 3251269119, 'NL', 'NLD', 'هولندا'),
(51326, 3251269120, 3251269375, 'DK', 'DNK', 'الدنيمارك'),
(51327, 3251269376, 3251269631, 'FR', 'FRA', 'فرنسا'),
(51328, 3251269632, 3251269887, 'NL', 'NLD', 'هولندا'),
(51329, 3251269888, 3251270143, 'GB', 'GBR', 'المملكة المتحدة'),
(51330, 3251270144, 3251270399, 'PL', 'POL', 'بولندا'),
(51331, 3251270400, 3251270655, 'NO', 'NOR', 'النرويج'),
(51332, 3251270656, 3251270911, 'DE', 'DEU', 'ألمانيا'),
(51333, 3251270912, 3251271167, 'PL', 'POL', 'بولندا'),
(51334, 3251271168, 3251271423, 'UA', 'UKR', 'أوكرانيا'),
(51335, 3251271424, 3251271679, 'DE', 'DEU', 'ألمانيا'),
(51336, 3251271680, 3251271935, 'TR', 'TUR', 'تركيا'),
(51337, 3251271936, 3251272191, 'FR', 'FRA', 'فرنسا'),
(51338, 3251272192, 3251272447, 'NL', 'NLD', 'هولندا'),
(51339, 3251272448, 3251272703, 'AT', 'AUT', 'النمسا'),
(51340, 3251272704, 3251272959, 'DE', 'DEU', 'ألمانيا'),
(51341, 3251272960, 3251273471, 'FR', 'FRA', 'فرنسا'),
(51342, 3251273472, 3251290111, 'DE', 'DEU', 'ألمانيا'),
(51343, 3251290112, 3251302399, 'GB', 'GBR', 'المملكة المتحدة'),
(51344, 3251302400, 3251306239, 'LI', 'LIE', 'ليختنشتاين'),
(51345, 3251306240, 3251306495, 'CH', 'CHE', 'سويسرا'),
(51346, 3251306496, 3251306751, 'AT', 'AUT', 'النمسا'),
(51347, 3251306752, 3251307007, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(51348, 3251307008, 3251307519, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(51349, 3251307520, 3251307775, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(51350, 3251307776, 3251308031, 'GB', 'GBR', 'المملكة المتحدة'),
(51351, 3251308032, 3251308543, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(51352, 3251308544, 3251310591, 'US', 'USA', 'الولايات المتحدة'),
(51353, 3251310592, 3251311103, 'SI', 'SVN', 'سلوفينيا'),
(51354, 3251311104, 3251311615, 'RS', 'SRB', 'صربيا'),
(51355, 3251312128, 3251312383, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(51356, 3251312384, 3251312639, 'CH', 'CHE', 'سويسرا'),
(51357, 3251312640, 3251314175, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(51358, 3251314176, 3251314687, 'CH', 'CHE', 'سويسرا'),
(51359, 3251314688, 3251315711, 'FR', 'FRA', 'فرنسا'),
(51360, 3251315712, 3251317759, 'RU', 'RUS', 'الإتحاد الروسي'),
(51361, 3251317760, 3251318783, 'PL', 'POL', 'بولندا'),
(51362, 3251318784, 3251319807, 'UA', 'UKR', 'أوكرانيا'),
(51363, 3251319808, 3251320831, 'HU', 'HUN', 'هنغاريا'),
(51364, 3251320832, 3251321855, 'PL', 'POL', 'بولندا'),
(51365, 3251321856, 3251322879, 'RU', 'RUS', 'الإتحاد الروسي'),
(51366, 3251322880, 3251329535, 'GB', 'GBR', 'المملكة المتحدة'),
(51367, 3251329536, 3251329567, 'FR', 'FRA', 'فرنسا'),
(51368, 3251329568, 3251329727, 'GB', 'GBR', 'المملكة المتحدة'),
(51369, 3251329728, 3251329791, 'FR', 'FRA', 'فرنسا'),
(51370, 3251329792, 3251330047, 'GB', 'GBR', 'المملكة المتحدة'),
(51371, 3251330048, 3251330079, 'IT', 'ITA', 'إيطاليا'),
(51372, 3251330080, 3251330239, 'GB', 'GBR', 'المملكة المتحدة'),
(51373, 3251330240, 3251330303, 'IT', 'ITA', 'إيطاليا'),
(51374, 3251330304, 3251331071, 'GB', 'GBR', 'المملكة المتحدة'),
(51375, 3251331072, 3251331583, 'FR', 'FRA', 'فرنسا'),
(51376, 3251331584, 3251332095, 'PL', 'POL', 'بولندا'),
(51377, 3251332096, 3251333119, 'RU', 'RUS', 'الإتحاد الروسي'),
(51378, 3251333120, 3251333631, 'CH', 'CHE', 'سويسرا'),
(51379, 3251333632, 3251334143, 'PT', 'PRT', 'البورتوغال'),
(51380, 3251334144, 3251334655, 'FR', 'FRA', 'فرنسا'),
(51381, 3251334656, 3251335167, 'UA', 'UKR', 'أوكرانيا'),
(51382, 3251335168, 3251335679, 'RU', 'RUS', 'الإتحاد الروسي'),
(51383, 3251335680, 3251336191, 'RO', 'ROM', 'رومانيا'),
(51384, 3251336192, 3251336703, 'GB', 'GBR', 'المملكة المتحدة'),
(51385, 3251336704, 3251337215, 'ES', 'ESP', 'إسبانيا'),
(51386, 3251337216, 3251337727, 'CH', 'CHE', 'سويسرا'),
(51387, 3251337728, 3251338239, 'DE', 'DEU', 'ألمانيا'),
(51388, 3251338240, 3251339263, 'RU', 'RUS', 'الإتحاد الروسي'),
(51389, 3251339264, 3251347455, 'IE', 'IRL', 'إيرلندا'),
(51390, 3251347456, 3251355647, 'DE', 'DEU', 'ألمانيا'),
(51391, 3251355648, 3251356159, 'GB', 'GBR', 'المملكة المتحدة'),
(51392, 3251356160, 3251356671, 'AT', 'AUT', 'النمسا'),
(51393, 3251356672, 3251357183, 'EE', 'EST', 'إستونيا'),
(51394, 3251357184, 3251357695, 'IL', 'ISR', 'إسرائيل'),
(51395, 3251357696, 3251358207, 'ES', 'ESP', 'إسبانيا'),
(51396, 3251358208, 3251358719, 'RU', 'RUS', 'الإتحاد الروسي'),
(51397, 3251358720, 3251359231, 'RO', 'ROM', 'رومانيا'),
(51398, 3251359232, 3251360255, 'PL', 'POL', 'بولندا'),
(51399, 3251360256, 3251360767, 'GB', 'GBR', 'المملكة المتحدة'),
(51400, 3251360768, 3251361279, 'FR', 'FRA', 'فرنسا'),
(51401, 3251361280, 3251361791, 'RO', 'ROM', 'رومانيا'),
(51402, 3251361792, 3251362303, 'AT', 'AUT', 'النمسا'),
(51403, 3251362304, 3251362815, 'UA', 'UKR', 'أوكرانيا'),
(51404, 3251362816, 3251363327, 'NL', 'NLD', 'هولندا'),
(51405, 3251363328, 3251363839, 'PL', 'POL', 'بولندا'),
(51406, 3251363840, 3251364095, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(51407, 3251364096, 3251364607, 'NL', 'NLD', 'هولندا'),
(51408, 3251364608, 3251364863, 'RO', 'ROM', 'رومانيا'),
(51409, 3251364864, 3251366911, 'IT', 'ITA', 'إيطاليا'),
(51410, 3251366912, 3251367423, 'UA', 'UKR', 'أوكرانيا'),
(51411, 3251367424, 3251367935, 'DE', 'DEU', 'ألمانيا'),
(51412, 3251367936, 3251372031, 'GB', 'GBR', 'المملكة المتحدة'),
(51413, 3251372032, 3251604447, 'IT', 'ITA', 'إيطاليا'),
(51414, 3251604448, 3251604455, 'CH', 'CHE', 'سويسرا'),
(51415, 3251604456, 3251634175, 'IT', 'ITA', 'إيطاليا'),
(51416, 3251634176, 3251661311, 'FI', 'FIN', 'فنلندا'),
(51417, 3251661312, 3251661567, 'NO', 'NOR', 'النرويج'),
(51418, 3251661568, 3251672575, 'FI', 'FIN', 'فنلندا'),
(51419, 3251672576, 3251672831, 'NL', 'NLD', 'هولندا'),
(51420, 3251672832, 3251674879, 'FI', 'FIN', 'فنلندا'),
(51421, 3251674880, 3251675135, 'BE', 'BEL', 'بلجيكا'),
(51422, 3251675136, 3251705343, 'FI', 'FIN', 'فنلندا'),
(51423, 3251705344, 3251705599, 'DK', 'DNK', 'الدنيمارك'),
(51424, 3251705600, 3251707391, 'FI', 'FIN', 'فنلندا'),
(51425, 3251707392, 3251707647, 'SE', 'SWE', 'السويد'),
(51426, 3251707648, 3251710207, 'FI', 'FIN', 'فنلندا'),
(51427, 3251710208, 3251710215, 'NL', 'NLD', 'هولندا'),
(51428, 3251710216, 3251710223, 'FI', 'FIN', 'فنلندا'),
(51429, 3251710224, 3251710239, 'NL', 'NLD', 'هولندا'),
(51430, 3251710240, 3251734271, 'FI', 'FIN', 'فنلندا'),
(51431, 3251734272, 3251734527, 'CH', 'CHE', 'سويسرا'),
(51432, 3251734528, 3251734783, 'NL', 'NLD', 'هولندا'),
(51433, 3251734784, 3251765247, 'FI', 'FIN', 'فنلندا'),
(51434, 3251765248, 3251765503, 'NL', 'NLD', 'هولندا'),
(51435, 3251765504, 3251774207, 'FI', 'FIN', 'فنلندا'),
(51436, 3251774208, 3251774463, 'DE', 'DEU', 'ألمانيا'),
(51437, 3251774464, 3251783423, 'FI', 'FIN', 'فنلندا'),
(51438, 3251783424, 3251783679, 'GB', 'GBR', 'المملكة المتحدة'),
(51439, 3251783680, 3251795455, 'FI', 'FIN', 'فنلندا'),
(51440, 3251795456, 3251795711, 'GB', 'GBR', 'المملكة المتحدة'),
(51441, 3251795712, 3251802879, 'FI', 'FIN', 'فنلندا'),
(51442, 3251802880, 3251803135, 'BE', 'BEL', 'بلجيكا'),
(51443, 3251803136, 3251806207, 'FI', 'FIN', 'فنلندا'),
(51444, 3251806208, 3251815167, 'BE', 'BEL', 'بلجيكا'),
(51445, 3251815168, 3251815679, 'LU', 'LUX', 'لوكسيمبورغ'),
(51446, 3251815680, 3251818495, 'BE', 'BEL', 'بلجيكا'),
(51447, 3251818496, 3251850495, 'FI', 'FIN', 'فنلندا'),
(51448, 3251850496, 3251850751, 'FR', 'FRA', 'فرنسا'),
(51449, 3251850752, 3251851007, 'CH', 'CHE', 'سويسرا'),
(51450, 3251851008, 3251896319, 'FI', 'FIN', 'فنلندا'),
(51451, 3251896320, 3251927991, 'NO', 'NOR', 'النرويج'),
(51452, 3251927992, 3251927999, 'NL', 'NLD', 'هولندا'),
(51453, 3251928000, 3252015687, 'NO', 'NOR', 'النرويج'),
(51454, 3252015688, 3252015695, 'SE', 'SWE', 'السويد'),
(51455, 3252015696, 3252289535, 'NO', 'NOR', 'النرويج'),
(51456, 3252289792, 3252291327, 'GR', 'GRC', 'اليونان'),
(51457, 3252291328, 3252291583, 'SK', 'SVK', 'سلوفاكيا'),
(51458, 3252291584, 3252293631, 'FR', 'FRA', 'فرنسا'),
(51459, 3252293632, 3252297983, 'DE', 'DEU', 'ألمانيا'),
(51460, 3252297984, 3252310527, 'GR', 'GRC', 'اليونان'),
(51461, 3252311040, 3252313599, 'GR', 'GRC', 'اليونان'),
(51462, 3252313600, 3252313855, 'SI', 'SVN', 'سلوفينيا'),
(51463, 3252313856, 3252314111, 'DE', 'DEU', 'ألمانيا'),
(51464, 3252314112, 3252314623, 'GR', 'GRC', 'اليونان'),
(51465, 3252314624, 3252314879, 'HU', 'HUN', 'هنغاريا'),
(51466, 3252314880, 3252315135, 'GB', 'GBR', 'المملكة المتحدة'),
(51467, 3252315136, 3252316415, 'CH', 'CHE', 'سويسرا'),
(51468, 3252316416, 3252316671, 'FR', 'FRA', 'فرنسا'),
(51469, 3252316672, 3252318463, 'GR', 'GRC', 'اليونان'),
(51470, 3252318464, 3252318719, 'TR', 'TUR', 'تركيا'),
(51471, 3252318720, 3252318975, 'GP', 'GLP', 'جوادلوب'),
(51472, 3252318976, 3252319231, 'PL', 'POL', 'بولندا'),
(51473, 3252319232, 3252319743, 'AT', 'AUT', 'النمسا'),
(51474, 3252320000, 3252320255, 'GR', 'GRC', 'اليونان'),
(51475, 3252320512, 3252321791, 'GR', 'GRC', 'اليونان'),
(51476, 3252321792, 3252322303, 'DE', 'DEU', 'ألمانيا'),
(51477, 3252322304, 3252323327, 'NO', 'NOR', 'النرويج'),
(51478, 3252323328, 3252324351, 'PL', 'POL', 'بولندا'),
(51479, 3252324352, 3252326399, 'RU', 'RUS', 'الإتحاد الروسي'),
(51480, 3252326400, 3252327423, 'UA', 'UKR', 'أوكرانيا'),
(51481, 3252327424, 3252329471, 'PL', 'POL', 'بولندا'),
(51482, 3252329472, 3252330495, 'UA', 'UKR', 'أوكرانيا'),
(51483, 3252330496, 3252334591, 'GB', 'GBR', 'المملكة المتحدة'),
(51484, 3252334592, 3252336639, 'RU', 'RUS', 'الإتحاد الروسي'),
(51485, 3252336640, 3252337663, 'UA', 'UKR', 'أوكرانيا'),
(51486, 3252337664, 3252338687, 'RU', 'RUS', 'الإتحاد الروسي'),
(51487, 3252338688, 3252340735, 'BE', 'BEL', 'بلجيكا'),
(51488, 3252340736, 3252340991, 'TR', 'TUR', 'تركيا'),
(51489, 3252341504, 3252341759, 'GR', 'GRC', 'اليونان'),
(51490, 3252342016, 3252342079, 'GB', 'GBR', 'المملكة المتحدة'),
(51491, 3252342080, 3252342143, 'IR', 'IRN', 'إيران'),
(51492, 3252342144, 3252342207, 'LU', 'LUX', 'لوكسيمبورغ'),
(51493, 3252342208, 3252342239, 'GB', 'GBR', 'المملكة المتحدة'),
(51494, 3252342240, 3252342271, 'CH', 'CHE', 'سويسرا'),
(51495, 3252342528, 3252342543, 'NO', 'NOR', 'النرويج'),
(51496, 3252342784, 3252346367, 'DE', 'DEU', 'ألمانيا'),
(51497, 3252346368, 3252346623, 'GB', 'GBR', 'المملكة المتحدة'),
(51498, 3252346624, 3252355071, 'GR', 'GRC', 'اليونان'),
(51499, 3252355072, 3252355327, 'GB', 'GBR', 'المملكة المتحدة'),
(51500, 3252355328, 3252358911, 'LT', 'LTU', 'ليتوانيا'),
(51501, 3252358912, 3252358927, 'GB', 'GBR', 'المملكة المتحدة'),
(51502, 3252358928, 3252359167, 'DE', 'DEU', 'ألمانيا'),
(51503, 3252359168, 3252362239, 'DK', 'DNK', 'الدنيمارك'),
(51504, 3252362240, 3252362495, 'PL', 'POL', 'بولندا'),
(51505, 3252362496, 3252362751, 'IT', 'ITA', 'إيطاليا'),
(51506, 3252362752, 3252363263, 'DK', 'DNK', 'الدنيمارك'),
(51507, 3252363264, 3252379647, 'LT', 'LTU', 'ليتوانيا'),
(51508, 3252379648, 3252379903, 'ES', 'ESP', 'إسبانيا'),
(51509, 3252379904, 3252380159, 'GB', 'GBR', 'المملكة المتحدة'),
(51510, 3252380160, 3252380415, 'BE', 'BEL', 'بلجيكا'),
(51511, 3252380416, 3252380671, 'UA', 'UKR', 'أوكرانيا'),
(51512, 3252380672, 3252380927, 'SI', 'SVN', 'سلوفينيا'),
(51513, 3252380928, 3252381183, 'RU', 'RUS', 'الإتحاد الروسي'),
(51514, 3252381184, 3252381439, 'IT', 'ITA', 'إيطاليا'),
(51515, 3252381440, 3252381695, 'ES', 'ESP', 'إسبانيا'),
(51516, 3252381696, 3252381951, 'RU', 'RUS', 'الإتحاد الروسي'),
(51517, 3252381952, 3252382207, 'DE', 'DEU', 'ألمانيا'),
(51518, 3252382208, 3252382463, 'SI', 'SVN', 'سلوفينيا'),
(51519, 3252382464, 3252382719, 'PL', 'POL', 'بولندا'),
(51520, 3252382720, 3252382975, 'GB', 'GBR', 'المملكة المتحدة'),
(51521, 3252382976, 3252383231, 'IT', 'ITA', 'إيطاليا'),
(51522, 3252383232, 3252383743, 'GB', 'GBR', 'المملكة المتحدة'),
(51523, 3252383744, 3252383999, 'SE', 'SWE', 'السويد'),
(51524, 3252384000, 3252384511, 'PL', 'POL', 'بولندا'),
(51525, 3252384512, 3252384767, 'GB', 'GBR', 'المملكة المتحدة'),
(51526, 3252384768, 3252385023, 'NL', 'NLD', 'هولندا'),
(51527, 3252385024, 3252385279, 'RO', 'ROM', 'رومانيا'),
(51528, 3252385280, 3252385535, 'GB', 'GBR', 'المملكة المتحدة'),
(51529, 3252385536, 3252385791, 'RO', 'ROM', 'رومانيا'),
(51530, 3252385792, 3252386047, 'GB', 'GBR', 'المملكة المتحدة'),
(51531, 3252386048, 3252386303, 'SI', 'SVN', 'سلوفينيا'),
(51532, 3252386304, 3252386559, 'GB', 'GBR', 'المملكة المتحدة'),
(51533, 3252386560, 3252386815, 'BE', 'BEL', 'بلجيكا'),
(51534, 3252386816, 3252387071, 'UA', 'UKR', 'أوكرانيا'),
(51535, 3252387072, 3252387327, 'RU', 'RUS', 'الإتحاد الروسي'),
(51536, 3252387328, 3252387583, 'PL', 'POL', 'بولندا'),
(51537, 3252387584, 3252387839, 'RU', 'RUS', 'الإتحاد الروسي'),
(51538, 3252387840, 3252404223, 'LT', 'LTU', 'ليتوانيا'),
(51539, 3252404224, 3252406527, 'NO', 'NOR', 'النرويج'),
(51540, 3252406528, 3252407295, 'LT', 'LTU', 'ليتوانيا'),
(51541, 3252407296, 3252407583, 'NO', 'NOR', 'النرويج'),
(51542, 3252407584, 3252407599, 'NG', 'NGA', 'نيجيريا'),
(51543, 3252407600, 3252407615, 'BJ', 'BEN', 'بنين'),
(51544, 3252407616, 3252407711, 'NO', 'NOR', 'النرويج'),
(51545, 3252407712, 3252407743, 'NG', 'NGA', 'نيجيريا'),
(51546, 3252407744, 3252407751, 'NO', 'NOR', 'النرويج'),
(51547, 3252407752, 3252407759, 'AO', 'AGO', 'أنغولا'),
(51548, 3252407760, 3252407767, 'NE', 'NER', 'النيجر'),
(51549, 3252407768, 3252407775, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51550, 3252407776, 3252407807, 'NO', 'NOR', 'النرويج'),
(51551, 3252407808, 3252407999, 'GN', 'GIN', 'غينيا'),
(51552, 3252408000, 3252408159, 'NO', 'NOR', 'النرويج'),
(51553, 3252408160, 3252408191, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(51554, 3252408192, 3252408319, 'NO', 'NOR', 'النرويج'),
(51555, 3252408320, 3252408335, 'TR', 'TUR', 'تركيا'),
(51556, 3252408336, 3252408343, 'GN', 'GIN', 'غينيا'),
(51557, 3252408344, 3252408359, 'LT', 'LTU', 'ليتوانيا'),
(51558, 3252408360, 3252408367, 'GN', 'GIN', 'غينيا'),
(51559, 3252408368, 3252408383, 'NG', 'NGA', 'نيجيريا'),
(51560, 3252408384, 3252408391, 'BI', 'BDI', 'بوروندي'),
(51561, 3252408392, 3252408415, 'LT', 'LTU', 'ليتوانيا'),
(51562, 3252408416, 3252408479, 'NO', 'NOR', 'النرويج'),
(51563, 3252408480, 3252408495, 'FI', 'FIN', 'فنلندا'),
(51564, 3252408496, 3252408543, 'LT', 'LTU', 'ليتوانيا'),
(51565, 3252408544, 3252408551, 'AF', 'AFG', 'أفغانستان'),
(51566, 3252408552, 3252408559, 'LT', 'LTU', 'ليتوانيا'),
(51567, 3252408560, 3252408575, 'IQ', 'IRQ', 'العراق'),
(51568, 3252408576, 3252408639, 'LT', 'LTU', 'ليتوانيا'),
(51569, 3252408640, 3252408671, 'CF', 'CAF', 'جمهورية أفريقيا الوسطى'),
(51570, 3252408672, 3252408687, 'LT', 'LTU', 'ليتوانيا'),
(51571, 3252408688, 3252408703, 'SO', 'SOM', 'الصومال'),
(51572, 3252408704, 3252408735, 'NG', 'NGA', 'نيجيريا'),
(51573, 3252408736, 3252408767, 'LT', 'LTU', 'ليتوانيا'),
(51574, 3252408768, 3252408783, 'NG', 'NGA', 'نيجيريا'),
(51575, 3252408784, 3252408799, 'LT', 'LTU', 'ليتوانيا'),
(51576, 3252408800, 3252408831, 'SO', 'SOM', 'الصومال'),
(51577, 3252408832, 3252408839, 'NG', 'NGA', 'نيجيريا'),
(51578, 3252408840, 3252408847, 'KE', 'KEN', 'كينيا'),
(51579, 3252408848, 3252408855, 'LR', 'LBR', 'ليبيريا'),
(51580, 3252408856, 3252408863, 'CM', 'CMR', 'الكاميرون'),
(51581, 3252408864, 3252408871, 'LR', 'LBR', 'ليبيريا'),
(51582, 3252408872, 3252408879, 'CI', 'CIV', 'كوت ديفوار'),
(51583, 3252408880, 3252409103, 'LT', 'LTU', 'ليتوانيا'),
(51584, 3252409104, 3252409111, 'SD', 'SDN', 'السودان'),
(51585, 3252409112, 3252409119, 'LT', 'LTU', 'ليتوانيا'),
(51586, 3252409120, 3252409127, 'NG', 'NGA', 'نيجيريا'),
(51587, 3252409128, 3252409167, 'LT', 'LTU', 'ليتوانيا'),
(51588, 3252409168, 3252409175, 'UG', 'UGA', 'أوغاندا'),
(51589, 3252409176, 3252409183, 'LT', 'LTU', 'ليتوانيا'),
(51590, 3252409184, 3252409191, 'UG', 'UGA', 'أوغاندا'),
(51591, 3252409192, 3252409199, 'ZW', 'ZWE', 'زمبابواي'),
(51592, 3252409200, 3252409207, 'TZ', 'TZA', 'تانزانيا'),
(51593, 3252409208, 3252409263, 'LT', 'LTU', 'ليتوانيا'),
(51594, 3252409264, 3252409343, 'SO', 'SOM', 'الصومال'),
(51595, 3252409344, 3252409375, 'TD', 'TCD', 'تشاد'),
(51596, 3252409376, 3252409407, 'LT', 'LTU', 'ليتوانيا'),
(51597, 3252409408, 3252409471, 'BI', 'BDI', 'بوروندي'),
(51598, 3252409472, 3252409503, 'LT', 'LTU', 'ليتوانيا'),
(51599, 3252409504, 3252409519, 'IQ', 'IRQ', 'العراق'),
(51600, 3252409520, 3252409527, 'NG', 'NGA', 'نيجيريا'),
(51601, 3252409528, 3252409535, 'LT', 'LTU', 'ليتوانيا'),
(51602, 3252409536, 3252409543, 'BI', 'BDI', 'بوروندي'),
(51603, 3252409544, 3252409631, 'LT', 'LTU', 'ليتوانيا'),
(51604, 3252409632, 3252409647, 'AO', 'AGO', 'أنغولا'),
(51605, 3252409648, 3252409855, 'LT', 'LTU', 'ليتوانيا'),
(51606, 3252409856, 3252410111, 'BW', 'BWA', 'بوتسوانا'),
(51607, 3252410112, 3252410367, 'LT', 'LTU', 'ليتوانيا'),
(51608, 3252410368, 3252410383, 'BW', 'BWA', 'بوتسوانا'),
(51609, 3252410384, 3252410431, 'LT', 'LTU', 'ليتوانيا'),
(51610, 3252410432, 3252410463, 'BI', 'BDI', 'بوروندي'),
(51611, 3252410464, 3252410623, 'LT', 'LTU', 'ليتوانيا'),
(51612, 3252410624, 3252410751, 'ZW', 'ZWE', 'زمبابواي'),
(51613, 3252410752, 3252411135, 'LT', 'LTU', 'ليتوانيا'),
(51614, 3252411136, 3252411167, 'IQ', 'IRQ', 'العراق'),
(51615, 3252411168, 3252411375, 'LT', 'LTU', 'ليتوانيا'),
(51616, 3252411376, 3252411391, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51617, 3252411392, 3252411647, 'LT', 'LTU', 'ليتوانيا'),
(51618, 3252411648, 3252411679, 'BI', 'BDI', 'بوروندي'),
(51619, 3252411680, 3252411695, 'LT', 'LTU', 'ليتوانيا'),
(51620, 3252411696, 3252411711, 'UG', 'UGA', 'أوغاندا'),
(51621, 3252411712, 3252411743, 'NG', 'NGA', 'نيجيريا'),
(51622, 3252411744, 3252411775, 'LT', 'LTU', 'ليتوانيا'),
(51623, 3252411776, 3252411783, 'GH', 'GHA', 'غانا'),
(51624, 3252411784, 3252411791, 'LT', 'LTU', 'ليتوانيا'),
(51625, 3252411792, 3252411823, 'NG', 'NGA', 'نيجيريا'),
(51626, 3252411824, 3252411839, 'LT', 'LTU', 'ليتوانيا'),
(51627, 3252411840, 3252411855, 'MR', 'MRT', 'موريتانيا'),
(51628, 3252411856, 3252411879, 'LT', 'LTU', 'ليتوانيا'),
(51629, 3252411880, 3252411887, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51630, 3252411888, 3252413439, 'LT', 'LTU', 'ليتوانيا'),
(51631, 3252413440, 3252414223, 'ZM', 'ZMB', 'زامبيا'),
(51632, 3252414224, 3252414239, 'LT', 'LTU', 'ليتوانيا'),
(51633, 3252414240, 3252414271, 'ZM', 'ZMB', 'زامبيا'),
(51634, 3252414272, 3252414335, 'LT', 'LTU', 'ليتوانيا'),
(51635, 3252414336, 3252414367, 'ZM', 'ZMB', 'زامبيا'),
(51636, 3252414368, 3252414399, 'LT', 'LTU', 'ليتوانيا'),
(51637, 3252414400, 3252414415, 'ZM', 'ZMB', 'زامبيا'),
(51638, 3252414416, 3252414463, 'LT', 'LTU', 'ليتوانيا'),
(51639, 3252414464, 3252414479, 'GH', 'GHA', 'غانا'),
(51640, 3252414480, 3252414495, 'ML', 'MLI', 'مالي'),
(51641, 3252414496, 3252414511, 'LT', 'LTU', 'ليتوانيا'),
(51642, 3252414512, 3252414527, 'MR', 'MRT', 'موريتانيا'),
(51643, 3252414528, 3252414591, 'LT', 'LTU', 'ليتوانيا'),
(51644, 3252414592, 3252414607, 'GH', 'GHA', 'غانا'),
(51645, 3252414608, 3252414623, 'LT', 'LTU', 'ليتوانيا'),
(51646, 3252414624, 3252414639, 'TZ', 'TZA', 'تانزانيا'),
(51647, 3252414640, 3252414647, 'GH', 'GHA', 'غانا'),
(51648, 3252414648, 3252414655, 'NE', 'NER', 'النيجر'),
(51649, 3252414656, 3252414719, 'ER', 'ERI', 'إريتريا'),
(51650, 3252414720, 3252414975, 'LT', 'LTU', 'ليتوانيا'),
(51651, 3252414976, 3252415087, 'IQ', 'IRQ', 'العراق'),
(51652, 3252415088, 3252415551, 'LT', 'LTU', 'ليتوانيا'),
(51653, 3252415552, 3252415567, 'NG', 'NGA', 'نيجيريا'),
(51654, 3252415568, 3252415743, 'LT', 'LTU', 'ليتوانيا'),
(51655, 3252415744, 3252415775, 'GB', 'GBR', 'المملكة المتحدة'),
(51656, 3252415776, 3252415967, 'LT', 'LTU', 'ليتوانيا'),
(51657, 3252415968, 3252415999, 'CM', 'CMR', 'الكاميرون'),
(51658, 3252416000, 3252416831, 'LT', 'LTU', 'ليتوانيا'),
(51659, 3252416832, 3252416927, 'GN', 'GIN', 'غينيا'),
(51660, 3252416928, 3252416959, 'LT', 'LTU', 'ليتوانيا'),
(51661, 3252416960, 3252417023, 'GN', 'GIN', 'غينيا'),
(51662, 3252417024, 3252417279, 'LT', 'LTU', 'ليتوانيا'),
(51663, 3252417280, 3252417287, 'IQ', 'IRQ', 'العراق'),
(51664, 3252417288, 3252417535, 'LT', 'LTU', 'ليتوانيا'),
(51665, 3252417536, 3252417855, 'NG', 'NGA', 'نيجيريا'),
(51666, 3252417856, 3252417919, 'LT', 'LTU', 'ليتوانيا'),
(51667, 3252417920, 3252417935, 'MW', 'MWI', 'ملاوي'),
(51668, 3252417936, 3252417951, 'ZM', 'ZMB', 'زامبيا'),
(51669, 3252417952, 3252418239, 'LT', 'LTU', 'ليتوانيا'),
(51670, 3252418240, 3252418303, 'JO', 'JOR', 'الأردن'),
(51671, 3252418304, 3252418559, 'LT', 'LTU', 'ليتوانيا'),
(51672, 3252418560, 3252418623, 'JO', 'JOR', 'الأردن'),
(51673, 3252418624, 3252418687, 'LT', 'LTU', 'ليتوانيا'),
(51674, 3252418688, 3252418719, 'JO', 'JOR', 'الأردن'),
(51675, 3252418720, 3252418815, 'LT', 'LTU', 'ليتوانيا'),
(51676, 3252418816, 3252418847, 'KE', 'KEN', 'كينيا'),
(51677, 3252418848, 3252419071, 'LT', 'LTU', 'ليتوانيا'),
(51678, 3252419072, 3252419087, 'ZM', 'ZMB', 'زامبيا'),
(51679, 3252419088, 3252419103, 'LT', 'LTU', 'ليتوانيا'),
(51680, 3252419104, 3252419119, 'SL', 'SLE', 'سيراليون'),
(51681, 3252419120, 3252419135, 'LT', 'LTU', 'ليتوانيا'),
(51682, 3252419136, 3252419167, 'SL', 'SLE', 'سيراليون'),
(51683, 3252419168, 3252419199, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51684, 3252419200, 3252419215, 'LT', 'LTU', 'ليتوانيا'),
(51685, 3252419216, 3252419247, 'GN', 'GIN', 'غينيا'),
(51686, 3252419248, 3252419263, 'SN', 'SEN', 'السنغال'),
(51687, 3252419264, 3252419279, 'TZ', 'TZA', 'تانزانيا'),
(51688, 3252419280, 3252419295, 'LT', 'LTU', 'ليتوانيا'),
(51689, 3252419296, 3252419311, 'SN', 'SEN', 'السنغال'),
(51690, 3252419312, 3252419327, 'ZM', 'ZMB', 'زامبيا'),
(51691, 3252419328, 3252419343, 'GH', 'GHA', 'غانا'),
(51692, 3252419344, 3252419359, 'LT', 'LTU', 'ليتوانيا'),
(51693, 3252419360, 3252419423, 'GH', 'GHA', 'غانا'),
(51694, 3252419424, 3252419583, 'LT', 'LTU', 'ليتوانيا'),
(51695, 3252419584, 3252419775, 'IQ', 'IRQ', 'العراق'),
(51696, 3252419776, 3252419839, 'LT', 'LTU', 'ليتوانيا'),
(51697, 3252419840, 3252419975, 'IQ', 'IRQ', 'العراق'),
(51698, 3252419976, 3252419983, 'LT', 'LTU', 'ليتوانيا'),
(51699, 3252419984, 3252420055, 'IQ', 'IRQ', 'العراق'),
(51700, 3252420056, 3252420063, 'LT', 'LTU', 'ليتوانيا'),
(51701, 3252420064, 3252420111, 'IQ', 'IRQ', 'العراق'),
(51702, 3252420112, 3252420119, 'GB', 'GBR', 'المملكة المتحدة'),
(51703, 3252420120, 3252420143, 'IQ', 'IRQ', 'العراق'),
(51704, 3252420144, 3252420151, 'LT', 'LTU', 'ليتوانيا'),
(51705, 3252420152, 3252420159, 'IQ', 'IRQ', 'العراق'),
(51706, 3252420160, 3252420191, 'LT', 'LTU', 'ليتوانيا'),
(51707, 3252420192, 3252420287, 'IQ', 'IRQ', 'العراق'),
(51708, 3252420288, 3252420295, 'LT', 'LTU', 'ليتوانيا'),
(51709, 3252420296, 3252420351, 'IQ', 'IRQ', 'العراق'),
(51710, 3252420352, 3252420367, 'LT', 'LTU', 'ليتوانيا'),
(51711, 3252420368, 3252420415, 'IQ', 'IRQ', 'العراق'),
(51712, 3252420416, 3252420431, 'GB', 'GBR', 'المملكة المتحدة'),
(51713, 3252420432, 3252420447, 'IQ', 'IRQ', 'العراق'),
(51714, 3252420448, 3252420455, 'LT', 'LTU', 'ليتوانيا'),
(51715, 3252420456, 3252420463, 'IQ', 'IRQ', 'العراق'),
(51716, 3252420464, 3252420471, 'AF', 'AFG', 'أفغانستان'),
(51717, 3252420472, 3252420479, 'LT', 'LTU', 'ليتوانيا'),
(51718, 3252420480, 3252420607, 'IQ', 'IRQ', 'العراق'),
(51719, 3252420608, 3252421119, 'LT', 'LTU', 'ليتوانيا'),
(51720, 3252421120, 3252421631, 'NO', 'NOR', 'النرويج'),
(51721, 3252421632, 3252424703, 'LT', 'LTU', 'ليتوانيا'),
(51722, 3252424704, 3252424719, 'GN', 'GIN', 'غينيا'),
(51723, 3252424720, 3252424735, 'LT', 'LTU', 'ليتوانيا'),
(51724, 3252424736, 3252424767, 'MA', 'MAR', 'المغرب'),
(51725, 3252424768, 3252424799, 'LT', 'LTU', 'ليتوانيا'),
(51726, 3252424800, 3252424815, 'NE', 'NER', 'النيجر'),
(51727, 3252424816, 3252424959, 'LT', 'LTU', 'ليتوانيا'),
(51728, 3252424960, 3252424967, 'KE', 'KEN', 'كينيا'),
(51729, 3252424968, 3252425023, 'LT', 'LTU', 'ليتوانيا'),
(51730, 3252425024, 3252425215, 'SO', 'SOM', 'الصومال'),
(51731, 3252425216, 3252425343, 'TD', 'TCD', 'تشاد'),
(51732, 3252425344, 3252425471, 'LT', 'LTU', 'ليتوانيا'),
(51733, 3252425472, 3252425543, 'AO', 'AGO', 'أنغولا'),
(51734, 3252425544, 3252425551, 'LT', 'LTU', 'ليتوانيا'),
(51735, 3252425552, 3252425575, 'AO', 'AGO', 'أنغولا'),
(51736, 3252425576, 3252425599, 'LT', 'LTU', 'ليتوانيا'),
(51737, 3252425600, 3252425631, 'AF', 'AFG', 'أفغانستان'),
(51738, 3252425632, 3252425727, 'LT', 'LTU', 'ليتوانيا'),
(51739, 3252425728, 3252425855, 'ZM', 'ZMB', 'زامبيا'),
(51740, 3252425856, 3252426751, 'LT', 'LTU', 'ليتوانيا'),
(51741, 3252426752, 3252427263, 'MZ', 'MOZ', 'موزامبيق'),
(51742, 3252427264, 3252427519, 'NG', 'NGA', 'نيجيريا'),
(51743, 3252427520, 3252427775, 'LT', 'LTU', 'ليتوانيا'),
(51744, 3252427776, 3252428287, 'MW', 'MWI', 'ملاوي'),
(51745, 3252428288, 3252428351, 'NG', 'NGA', 'نيجيريا'),
(51746, 3252428352, 3252428383, 'AO', 'AGO', 'أنغولا'),
(51747, 3252428384, 3252428415, 'LT', 'LTU', 'ليتوانيا'),
(51748, 3252428416, 3252428447, 'KE', 'KEN', 'كينيا'),
(51749, 3252428448, 3252430079, 'LT', 'LTU', 'ليتوانيا'),
(51750, 3252430080, 3252430335, 'BJ', 'BEN', 'بنين'),
(51751, 3252430336, 3252430463, 'NE', 'NER', 'النيجر'),
(51752, 3252430464, 3252430511, 'LT', 'LTU', 'ليتوانيا'),
(51753, 3252430512, 3252430543, 'BF', 'BFA', 'بوركينا فاسو'),
(51754, 3252430544, 3252430559, 'BJ', 'BEN', 'بنين'),
(51755, 3252430560, 3252430591, 'BF', 'BFA', 'بوركينا فاسو'),
(51756, 3252430592, 3252430847, 'GN', 'GIN', 'غينيا'),
(51757, 3252430848, 3252431359, 'MW', 'MWI', 'ملاوي'),
(51758, 3252431360, 3252431871, 'LT', 'LTU', 'ليتوانيا'),
(51759, 3252431872, 3252432127, 'SO', 'SOM', 'الصومال'),
(51760, 3252432128, 3252432383, 'LR', 'LBR', 'ليبيريا'),
(51761, 3252432384, 3252432399, 'MW', 'MWI', 'ملاوي'),
(51762, 3252432400, 3252432447, 'LT', 'LTU', 'ليتوانيا'),
(51763, 3252432448, 3252432463, 'MW', 'MWI', 'ملاوي'),
(51764, 3252432464, 3252432575, 'LT', 'LTU', 'ليتوانيا'),
(51765, 3252432576, 3252432591, 'MW', 'MWI', 'ملاوي'),
(51766, 3252432592, 3252433663, 'LT', 'LTU', 'ليتوانيا'),
(51767, 3252433664, 3252433919, 'SO', 'SOM', 'الصومال'),
(51768, 3252433920, 3252434175, 'MZ', 'MOZ', 'موزامبيق'),
(51769, 3252434176, 3252434687, 'LT', 'LTU', 'ليتوانيا'),
(51770, 3252434688, 3252434703, 'GH', 'GHA', 'غانا'),
(51771, 3252434704, 3252434711, 'TZ', 'TZA', 'تانزانيا'),
(51772, 3252434712, 3252434719, 'LT', 'LTU', 'ليتوانيا'),
(51773, 3252434720, 3252434735, 'GH', 'GHA', 'غانا'),
(51774, 3252434736, 3252435199, 'LT', 'LTU', 'ليتوانيا'),
(51775, 3252435200, 3252435247, 'TZ', 'TZA', 'تانزانيا'),
(51776, 3252435248, 3252435295, 'LT', 'LTU', 'ليتوانيا'),
(51777, 3252435296, 3252435303, 'TZ', 'TZA', 'تانزانيا'),
(51778, 3252435304, 3252435319, 'LT', 'LTU', 'ليتوانيا'),
(51779, 3252435320, 3252435327, 'MZ', 'MOZ', 'موزامبيق'),
(51780, 3252435328, 3252435343, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51781, 3252435344, 3252435359, 'BF', 'BFA', 'بوركينا فاسو'),
(51782, 3252435360, 3252435375, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51783, 3252435376, 3252435415, 'GN', 'GIN', 'غينيا'),
(51784, 3252435416, 3252435455, 'LT', 'LTU', 'ليتوانيا'),
(51785, 3252435456, 3252435711, 'TZ', 'TZA', 'تانزانيا'),
(51786, 3252435712, 3252435855, 'GH', 'GHA', 'غانا'),
(51787, 3252435856, 3252435871, 'LT', 'LTU', 'ليتوانيا'),
(51788, 3252435872, 3252435887, 'GH', 'GHA', 'غانا'),
(51789, 3252435888, 3252435919, 'BW', 'BWA', 'بوتسوانا'),
(51790, 3252435920, 3252435935, 'BF', 'BFA', 'بوركينا فاسو'),
(51791, 3252435936, 3252435967, 'CF', 'CAF', 'جمهورية أفريقيا الوسطى'),
(51792, 3252435968, 3252436223, 'TZ', 'TZA', 'تانزانيا'),
(51793, 3252436224, 3252436239, 'GN', 'GIN', 'غينيا'),
(51794, 3252436240, 3252436255, 'NA', 'NAM', 'ناميبيا'),
(51795, 3252436256, 3252436271, 'ML', 'MLI', 'مالي'),
(51796, 3252436272, 3252436287, 'BF', 'BFA', 'بوركينا فاسو'),
(51797, 3252436288, 3252436303, 'LT', 'LTU', 'ليتوانيا'),
(51798, 3252436304, 3252436319, 'ZM', 'ZMB', 'زامبيا'),
(51799, 3252436320, 3252436335, 'LT', 'LTU', 'ليتوانيا'),
(51800, 3252436336, 3252436351, 'ZM', 'ZMB', 'زامبيا'),
(51801, 3252436352, 3252436383, 'GN', 'GIN', 'غينيا'),
(51802, 3252436384, 3252436399, 'SN', 'SEN', 'السنغال'),
(51803, 3252436400, 3252436415, 'TZ', 'TZA', 'تانزانيا'),
(51804, 3252436416, 3252436447, 'LT', 'LTU', 'ليتوانيا'),
(51805, 3252436448, 3252436479, 'ER', 'ERI', 'إريتريا'),
(51806, 3252436480, 3252437759, 'LT', 'LTU', 'ليتوانيا'),
(51807, 3252437760, 3252438015, 'ZM', 'ZMB', 'زامبيا'),
(51808, 3252438016, 3252438271, 'TR', 'TUR', 'تركيا'),
(51809, 3252438272, 3252438527, 'MD', 'MDA', 'مولدوفا'),
(51810, 3252438528, 3252438783, 'CM', 'CMR', 'الكاميرون'),
(51811, 3252438784, 3252439039, 'LT', 'LTU', 'ليتوانيا'),
(51812, 3252439040, 3252439055, 'BJ', 'BEN', 'بنين'),
(51813, 3252439056, 3252439071, 'LT', 'LTU', 'ليتوانيا'),
(51814, 3252439072, 3252439079, 'BJ', 'BEN', 'بنين'),
(51815, 3252439080, 3252439263, 'LT', 'LTU', 'ليتوانيا'),
(51816, 3252439264, 3252439271, 'SN', 'SEN', 'السنغال'),
(51817, 3252439272, 3252439287, 'LT', 'LTU', 'ليتوانيا'),
(51818, 3252439288, 3252439295, 'SN', 'SEN', 'السنغال'),
(51819, 3252439296, 3252439391, 'SO', 'SOM', 'الصومال'),
(51820, 3252439392, 3252439807, 'LT', 'LTU', 'ليتوانيا'),
(51821, 3252439808, 3252439871, 'SO', 'SOM', 'الصومال'),
(51822, 3252439872, 3252440063, 'LT', 'LTU', 'ليتوانيا'),
(51823, 3252440064, 3252440319, 'MW', 'MWI', 'ملاوي'),
(51824, 3252440320, 3252440383, 'NG', 'NGA', 'نيجيريا'),
(51825, 3252440384, 3252444287, 'LT', 'LTU', 'ليتوانيا'),
(51826, 3252444288, 3252444351, 'TZ', 'TZA', 'تانزانيا'),
(51827, 3252444352, 3252445183, 'LT', 'LTU', 'ليتوانيا'),
(51828, 3252445184, 3252445263, 'GN', 'GIN', 'غينيا'),
(51829, 3252445264, 3252445695, 'LT', 'LTU', 'ليتوانيا'),
(51830, 3252445696, 3252446207, 'NG', 'NGA', 'نيجيريا'),
(51831, 3252446208, 3252446703, 'LT', 'LTU', 'ليتوانيا'),
(51832, 3252446704, 3252446719, 'NO', 'NOR', 'النرويج'),
(51833, 3252446720, 3252447231, 'LT', 'LTU', 'ليتوانيا'),
(51834, 3252447232, 3252448255, 'NO', 'NOR', 'النرويج'),
(51835, 3252448256, 3252448511, 'SE', 'SWE', 'السويد'),
(51836, 3252448512, 3252448767, 'NO', 'NOR', 'النرويج'),
(51837, 3252448768, 3252449279, 'SE', 'SWE', 'السويد'),
(51838, 3252449280, 3252449535, 'CN', 'CHN', 'الصين'),
(51839, 3252449536, 3252449615, 'CH', 'CHE', 'سويسرا'),
(51840, 3252449616, 3252449623, 'DK', 'DNK', 'الدنيمارك'),
(51841, 3252449624, 3252449791, 'LT', 'LTU', 'ليتوانيا'),
(51842, 3252449792, 3252450047, 'CH', 'CHE', 'سويسرا'),
(51843, 3252450048, 3252450303, 'LT', 'LTU', 'ليتوانيا'),
(51844, 3252450304, 3252450815, 'NO', 'NOR', 'النرويج'),
(51845, 3252450816, 3252450823, 'ET', 'ETH', 'إثيوبيا'),
(51846, 3252450824, 3252450879, 'LT', 'LTU', 'ليتوانيا'),
(51847, 3252450880, 3252450911, 'NO', 'NOR', 'النرويج'),
(51848, 3252450912, 3252451071, 'LT', 'LTU', 'ليتوانيا'),
(51849, 3252451072, 3252451327, 'CH', 'CHE', 'سويسرا'),
(51850, 3252451328, 3252451839, 'LT', 'LTU', 'ليتوانيا'),
(51851, 3252451840, 3252451855, 'NO', 'NOR', 'النرويج'),
(51852, 3252451856, 3252451967, 'LT', 'LTU', 'ليتوانيا'),
(51853, 3252451968, 3252451999, 'NO', 'NOR', 'النرويج'),
(51854, 3252452000, 3252452095, 'LT', 'LTU', 'ليتوانيا'),
(51855, 3252452096, 3252452127, 'NO', 'NOR', 'النرويج'),
(51856, 3252452128, 3252452135, 'LT', 'LTU', 'ليتوانيا'),
(51857, 3252452136, 3252452143, 'NO', 'NOR', 'النرويج'),
(51858, 3252452144, 3252452159, 'LT', 'LTU', 'ليتوانيا'),
(51859, 3252452160, 3252452175, 'NL', 'NLD', 'هولندا'),
(51860, 3252452176, 3252452191, 'NO', 'NOR', 'النرويج'),
(51861, 3252452192, 3252452215, 'NL', 'NLD', 'هولندا'),
(51862, 3252452216, 3252452223, 'NO', 'NOR', 'النرويج'),
(51863, 3252452224, 3252452227, 'NL', 'NLD', 'هولندا'),
(51864, 3252452228, 3252452231, 'LT', 'LTU', 'ليتوانيا'),
(51865, 3252452232, 3252452239, 'NL', 'NLD', 'هولندا'),
(51866, 3252452240, 3252452271, 'LT', 'LTU', 'ليتوانيا'),
(51867, 3252452272, 3252452351, 'NO', 'NOR', 'النرويج'),
(51868, 3252452352, 3252452487, 'LT', 'LTU', 'ليتوانيا'),
(51869, 3252452488, 3252452495, 'MW', 'MWI', 'ملاوي'),
(51870, 3252452496, 3252452503, 'ZM', 'ZMB', 'زامبيا'),
(51871, 3252452504, 3252452511, 'SD', 'SDN', 'السودان'),
(51872, 3252452512, 3252452607, 'LT', 'LTU', 'ليتوانيا'),
(51873, 3252452608, 3252452735, 'TD', 'TCD', 'تشاد'),
(51874, 3252452736, 3252452863, 'LT', 'LTU', 'ليتوانيا'),
(51875, 3252452864, 3252452879, 'TZ', 'TZA', 'تانزانيا'),
(51876, 3252452880, 3252453119, 'LT', 'LTU', 'ليتوانيا'),
(51877, 3252453120, 3252453151, 'NG', 'NGA', 'نيجيريا'),
(51878, 3252453152, 3252453247, 'LT', 'LTU', 'ليتوانيا'),
(51879, 3252453248, 3252453271, 'NG', 'NGA', 'نيجيريا'),
(51880, 3252453272, 3252454527, 'LT', 'LTU', 'ليتوانيا'),
(51881, 3252454528, 3252454583, 'IQ', 'IRQ', 'العراق'),
(51882, 3252454584, 3252454655, 'LT', 'LTU', 'ليتوانيا'),
(51883, 3252454656, 3252454911, 'IQ', 'IRQ', 'العراق'),
(51884, 3252454912, 3252455167, 'GB', 'GBR', 'المملكة المتحدة'),
(51885, 3252455168, 3252455295, 'NG', 'NGA', 'نيجيريا'),
(51886, 3252455296, 3252455679, 'LT', 'LTU', 'ليتوانيا'),
(51887, 3252455680, 3252455807, 'BI', 'BDI', 'بوروندي'),
(51888, 3252455808, 3252455935, 'LT', 'LTU', 'ليتوانيا'),
(51889, 3252455936, 3252456191, 'MW', 'MWI', 'ملاوي'),
(51890, 3252456192, 3252456959, 'LT', 'LTU', 'ليتوانيا'),
(51891, 3252456960, 3252457471, 'NG', 'NGA', 'نيجيريا'),
(51892, 3252457472, 3252460799, 'LT', 'LTU', 'ليتوانيا'),
(51893, 3252460800, 3252460831, 'AF', 'AFG', 'أفغانستان'),
(51894, 3252460832, 3252460847, 'KP', 'PRK', 'جمهورية كوريا الشعبية الديمقراطية'),
(51895, 3252460848, 3252461055, 'LT', 'LTU', 'ليتوانيا'),
(51896, 3252461056, 3252461567, 'NO', 'NOR', 'النرويج'),
(51897, 3252461568, 3252464383, 'LT', 'LTU', 'ليتوانيا'),
(51898, 3252464384, 3252465663, 'NO', 'NOR', 'النرويج'),
(51899, 3252465664, 3252465919, 'GH', 'GHA', 'غانا'),
(51900, 3252465920, 3252465951, 'LT', 'LTU', 'ليتوانيا'),
(51901, 3252465952, 3252465983, 'GH', 'GHA', 'غانا'),
(51902, 3252465984, 3252466047, 'LT', 'LTU', 'ليتوانيا'),
(51903, 3252466048, 3252466175, 'GH', 'GHA', 'غانا'),
(51904, 3252466176, 3252468223, 'LT', 'LTU', 'ليتوانيا'),
(51905, 3252468224, 3252468231, 'CM', 'CMR', 'الكاميرون'),
(51906, 3252468232, 3252468239, 'LT', 'LTU', 'ليتوانيا'),
(51907, 3252468240, 3252468479, 'CM', 'CMR', 'الكاميرون'),
(51908, 3252468480, 3252468735, 'LT', 'LTU', 'ليتوانيا'),
(51909, 3252468736, 3252469247, 'ZM', 'ZMB', 'زامبيا'),
(51910, 3252469248, 3252473343, 'LT', 'LTU', 'ليتوانيا'),
(51911, 3252473344, 3252473855, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(51912, 3252473856, 3252474879, 'SO', 'SOM', 'الصومال'),
(51913, 3252474880, 3252475903, 'LT', 'LTU', 'ليتوانيا'),
(51914, 3252475904, 3252476415, 'NG', 'NGA', 'نيجيريا'),
(51915, 3252476416, 3252481023, 'LT', 'LTU', 'ليتوانيا'),
(51916, 3252481024, 3252481535, 'MZ', 'MOZ', 'موزامبيق'),
(51917, 3252481536, 3252483071, 'LT', 'LTU', 'ليتوانيا'),
(51918, 3252483072, 3252483583, 'KW', 'KWT', 'الكويت'),
(51919, 3252483584, 3252484095, 'LT', 'LTU', 'ليتوانيا'),
(51920, 3252484096, 3252486143, 'KW', 'KWT', 'الكويت'),
(51921, 3252486144, 3252490239, 'BE', 'BEL', 'بلجيكا'),
(51922, 3252490240, 3252495871, 'SE', 'SWE', 'السويد'),
(51923, 3252495872, 3252496127, 'HU', 'HUN', 'هنغاريا'),
(51924, 3252496128, 3252500991, 'SE', 'SWE', 'السويد'),
(51925, 3252500992, 3252501247, 'DE', 'DEU', 'ألمانيا'),
(51926, 3252501248, 3252505343, 'SE', 'SWE', 'السويد'),
(51927, 3252505344, 3252505855, 'US', 'USA', 'الولايات المتحدة'),
(51928, 3252505856, 3252507135, 'SE', 'SWE', 'السويد'),
(51929, 3252507648, 3252509951, 'GB', 'GBR', 'المملكة المتحدة'),
(51930, 3252509952, 3252510719, 'CH', 'CHE', 'سويسرا'),
(51931, 3252510720, 3252514815, 'FR', 'FRA', 'فرنسا'),
(51932, 3252514816, 3252515071, 'SI', 'SVN', 'سلوفينيا'),
(51933, 3252515072, 3252515327, 'GB', 'GBR', 'المملكة المتحدة'),
(51934, 3252515328, 3252515583, 'DE', 'DEU', 'ألمانيا'),
(51935, 3252515584, 3252515839, 'SI', 'SVN', 'سلوفينيا'),
(51936, 3252515840, 3252516095, 'CH', 'CHE', 'سويسرا'),
(51937, 3252516096, 3252516351, 'FR', 'FRA', 'فرنسا'),
(51938, 3252516352, 3252516607, 'GB', 'GBR', 'المملكة المتحدة'),
(51939, 3252516608, 3252516863, 'SE', 'SWE', 'السويد'),
(51940, 3252516864, 3252517119, 'FR', 'FRA', 'فرنسا'),
(51941, 3252517376, 3252517631, 'PL', 'POL', 'بولندا'),
(51942, 3252517632, 3252517887, 'BE', 'BEL', 'بلجيكا'),
(51943, 3252517888, 3252518143, 'DK', 'DNK', 'الدنيمارك'),
(51944, 3252518144, 3252518399, 'NL', 'NLD', 'هولندا'),
(51945, 3252518400, 3252518655, 'PL', 'POL', 'بولندا'),
(51946, 3252518656, 3252518911, 'DE', 'DEU', 'ألمانيا'),
(51947, 3252518912, 3252527103, 'NL', 'NLD', 'هولندا'),
(51948, 3252527104, 3252535295, 'BE', 'BEL', 'بلجيكا'),
(51949, 3252535296, 3252539391, 'GB', 'GBR', 'المملكة المتحدة'),
(51950, 3252540416, 3252541951, 'NL', 'NLD', 'هولندا'),
(51951, 3252542208, 3252551679, 'BE', 'BEL', 'بلجيكا'),
(51952, 3252551680, 3252563967, 'CH', 'CHE', 'سويسرا'),
(51953, 3252566784, 3252567295, 'CH', 'CHE', 'سويسرا'),
(51954, 3252567296, 3252567551, 'GB', 'GBR', 'المملكة المتحدة'),
(51955, 3252567552, 3252567807, 'RU', 'RUS', 'الإتحاد الروسي'),
(51956, 3252567808, 3252568063, 'RO', 'ROM', 'رومانيا'),
(51957, 3252568064, 3252579327, 'CH', 'CHE', 'سويسرا'),
(51958, 3252579328, 3252579583, 'FR', 'FRA', 'فرنسا'),
(51959, 3252579584, 3252579839, 'RU', 'RUS', 'الإتحاد الروسي'),
(51960, 3252579840, 3252580095, 'SE', 'SWE', 'السويد'),
(51961, 3252580096, 3252580351, 'UA', 'UKR', 'أوكرانيا'),
(51962, 3252580352, 3252584447, 'LI', 'LIE', 'ليختنشتاين'),
(51963, 3252584448, 3252584703, 'FR', 'FRA', 'فرنسا'),
(51964, 3252584704, 3252584959, 'IL', 'ISR', 'إسرائيل'),
(51965, 3252584960, 3252585215, 'CZ', 'CZE', 'التشيك'),
(51966, 3252585216, 3252585471, 'PL', 'POL', 'بولندا'),
(51967, 3252585472, 3252585727, 'NL', 'NLD', 'هولندا'),
(51968, 3252585728, 3252585983, 'FI', 'FIN', 'فنلندا'),
(51969, 3252585984, 3252586239, 'FR', 'FRA', 'فرنسا'),
(51970, 3252586240, 3252586495, 'PL', 'POL', 'بولندا'),
(51971, 3252586496, 3252586751, 'IT', 'ITA', 'إيطاليا'),
(51972, 3252586752, 3252587007, 'NL', 'NLD', 'هولندا'),
(51973, 3252587008, 3252587263, 'CH', 'CHE', 'سويسرا'),
(51974, 3252587264, 3252587519, 'AT', 'AUT', 'النمسا'),
(51975, 3252587520, 3252587775, 'UA', 'UKR', 'أوكرانيا'),
(51976, 3252587776, 3252588031, 'SE', 'SWE', 'السويد'),
(51977, 3252588032, 3252600319, 'CH', 'CHE', 'سويسرا'),
(51978, 3252600576, 3252600831, 'RU', 'RUS', 'الإتحاد الروسي'),
(51979, 3252600832, 3252616703, 'CH', 'CHE', 'سويسرا'),
(51980, 3252616704, 3252616959, 'ES', 'ESP', 'إسبانيا'),
(51981, 3252616960, 3252617215, 'CH', 'CHE', 'سويسرا'),
(51982, 3252617216, 3252617471, 'PL', 'POL', 'بولندا'),
(51983, 3252617472, 3252636671, 'CH', 'CHE', 'سويسرا'),
(51984, 3252636672, 3252636927, 'TR', 'TUR', 'تركيا'),
(51985, 3252636928, 3252637183, 'DE', 'DEU', 'ألمانيا'),
(51986, 3252637184, 3252637695, 'GB', 'GBR', 'المملكة المتحدة'),
(51987, 3252637696, 3252642303, 'CH', 'CHE', 'سويسرا'),
(51988, 3252642304, 3252642559, 'UA', 'UKR', 'أوكرانيا'),
(51989, 3252642560, 3252642815, 'DK', 'DNK', 'الدنيمارك'),
(51990, 3252642816, 3252643071, 'NL', 'NLD', 'هولندا'),
(51991, 3252643072, 3252643327, 'RO', 'ROM', 'رومانيا'),
(51992, 3252643328, 3252643583, 'CH', 'CHE', 'سويسرا'),
(51993, 3252643584, 3252643839, 'AT', 'AUT', 'النمسا'),
(51994, 3252643840, 3252645631, 'CH', 'CHE', 'سويسرا'),
(51995, 3252645888, 3252682751, 'CH', 'CHE', 'سويسرا'),
(51996, 3252682752, 3252813823, 'HU', 'HUN', 'هنغاريا'),
(51997, 3252813824, 3252830207, 'RO', 'ROM', 'رومانيا'),
(51998, 3252830208, 3252832255, 'MD', 'MDA', 'مولدوفا'),
(51999, 3252832256, 3252832767, 'RO', 'ROM', 'رومانيا'),
(52000, 3252832768, 3252834303, 'MD', 'MDA', 'مولدوفا'),
(52001, 3252834304, 3252862975, 'RO', 'ROM', 'رومانيا'),
(52002, 3252862976, 3252879359, 'HU', 'HUN', 'هنغاريا'),
(52003, 3252879360, 3252895743, 'EG', 'EGY', 'مصر'),
(52004, 3252895744, 3252903935, 'IT', 'ITA', 'إيطاليا'),
(52005, 3252903936, 3252904447, 'UA', 'UKR', 'أوكرانيا'),
(52006, 3252904448, 3252904703, 'RU', 'RUS', 'الإتحاد الروسي'),
(52007, 3252904704, 3252904959, 'DE', 'DEU', 'ألمانيا'),
(52008, 3252904960, 3252905215, 'PL', 'POL', 'بولندا'),
(52009, 3252905216, 3252905471, 'CH', 'CHE', 'سويسرا'),
(52010, 3252905472, 3252905727, 'LT', 'LTU', 'ليتوانيا'),
(52011, 3252905728, 3252905983, 'BE', 'BEL', 'بلجيكا'),
(52012, 3252905984, 3252906239, 'IT', 'ITA', 'إيطاليا'),
(52013, 3252906240, 3252906495, 'PL', 'POL', 'بولندا'),
(52014, 3252906496, 3252906751, 'GB', 'GBR', 'المملكة المتحدة'),
(52015, 3252906752, 3252907007, 'FR', 'FRA', 'فرنسا'),
(52016, 3252907008, 3252907263, 'AT', 'AUT', 'النمسا'),
(52017, 3252907264, 3252907775, 'RO', 'ROM', 'رومانيا'),
(52018, 3252907776, 3252908031, 'GB', 'GBR', 'المملكة المتحدة'),
(52019, 3252908032, 3252908287, 'PL', 'POL', 'بولندا'),
(52020, 3252908288, 3252908543, 'AT', 'AUT', 'النمسا'),
(52021, 3252908544, 3252908799, 'MT', 'MLT', 'مالطا'),
(52022, 3252908800, 3252909055, 'UA', 'UKR', 'أوكرانيا'),
(52023, 3252909056, 3252909311, 'PL', 'POL', 'بولندا'),
(52024, 3252909312, 3252909567, 'DE', 'DEU', 'ألمانيا'),
(52025, 3252909568, 3252909823, 'GB', 'GBR', 'المملكة المتحدة'),
(52026, 3252909824, 3252910335, 'UA', 'UKR', 'أوكرانيا'),
(52027, 3252910336, 3252910591, 'NL', 'NLD', 'هولندا'),
(52028, 3252910592, 3252910847, 'CH', 'CHE', 'سويسرا'),
(52029, 3252910848, 3252911103, 'PL', 'POL', 'بولندا'),
(52030, 3252911104, 3252911359, 'DE', 'DEU', 'ألمانيا'),
(52031, 3252911360, 3252911615, 'RU', 'RUS', 'الإتحاد الروسي'),
(52032, 3252911616, 3252911871, 'SE', 'SWE', 'السويد'),
(52033, 3252911872, 3252912127, 'SA', 'SAU', 'السعودية'),
(52034, 3252912384, 3252912639, 'HU', 'HUN', 'هنغاريا'),
(52035, 3252912640, 3252912895, 'FR', 'FRA', 'فرنسا'),
(52036, 3252912896, 3252913151, 'PL', 'POL', 'بولندا'),
(52037, 3252913152, 3252913407, 'ES', 'ESP', 'إسبانيا'),
(52038, 3252913408, 3252913663, 'FR', 'FRA', 'فرنسا'),
(52039, 3252913664, 3252913919, 'CZ', 'CZE', 'التشيك'),
(52040, 3252913920, 3252914175, 'NO', 'NOR', 'النرويج'),
(52041, 3252914176, 3252916223, 'FR', 'FRA', 'فرنسا'),
(52042, 3252916224, 3252920319, 'DE', 'DEU', 'ألمانيا'),
(52043, 3252920320, 3252928511, 'LB', 'LBN', 'لبنان'),
(52044, 3252928512, 3252929535, 'DE', 'DEU', 'ألمانيا'),
(52045, 3252929536, 3252930559, 'HU', 'HUN', 'هنغاريا'),
(52046, 3252930560, 3252931071, 'GB', 'GBR', 'المملكة المتحدة'),
(52047, 3252931072, 3252931583, 'DE', 'DEU', 'ألمانيا'),
(52048, 3252931584, 3252932095, 'NO', 'NOR', 'النرويج'),
(52049, 3252932096, 3252933631, 'UA', 'UKR', 'أوكرانيا'),
(52050, 3252933632, 3252934655, 'IT', 'ITA', 'إيطاليا'),
(52051, 3252934656, 3252936703, 'PL', 'POL', 'بولندا'),
(52052, 3252936704, 3252937215, 'CH', 'CHE', 'سويسرا'),
(52053, 3252937216, 3252937727, 'RO', 'ROM', 'رومانيا'),
(52054, 3252937728, 3252938239, 'FR', 'FRA', 'فرنسا'),
(52055, 3252938240, 3252938751, 'UA', 'UKR', 'أوكرانيا'),
(52056, 3252938752, 3252939263, 'RU', 'RUS', 'الإتحاد الروسي'),
(52057, 3252939776, 3252940287, 'RO', 'ROM', 'رومانيا'),
(52058, 3252940288, 3252940799, 'PT', 'PRT', 'البورتوغال'),
(52059, 3252940800, 3252941311, 'RU', 'RUS', 'الإتحاد الروسي'),
(52060, 3252941312, 3252941823, 'RO', 'ROM', 'رومانيا'),
(52061, 3252941824, 3252942847, 'GB', 'GBR', 'المملكة المتحدة'),
(52062, 3252942848, 3252943359, 'FR', 'FRA', 'فرنسا'),
(52063, 3252943360, 3252943871, 'UA', 'UKR', 'أوكرانيا'),
(52064, 3252943872, 3252944383, 'RU', 'RUS', 'الإتحاد الروسي'),
(52065, 3252944384, 3252944895, 'DE', 'DEU', 'ألمانيا'),
(52066, 3252944896, 3252945151, 'AT', 'AUT', 'النمسا'),
(52067, 3252945152, 3252945407, 'GB', 'GBR', 'المملكة المتحدة'),
(52068, 3252945408, 3252945663, 'UA', 'UKR', 'أوكرانيا'),
(52069, 3252945664, 3252980735, 'AT', 'AUT', 'النمسا'),
(52070, 3252980736, 3252980991, 'PL', 'POL', 'بولندا'),
(52071, 3252980992, 3252981247, 'GB', 'GBR', 'المملكة المتحدة'),
(52072, 3252981248, 3252981503, 'RU', 'RUS', 'الإتحاد الروسي'),
(52073, 3252981504, 3252981759, 'SE', 'SWE', 'السويد'),
(52074, 3252982016, 3252982271, 'RO', 'ROM', 'رومانيا'),
(52075, 3252982272, 3252982527, 'DE', 'DEU', 'ألمانيا'),
(52076, 3252982528, 3252982783, 'FR', 'FRA', 'فرنسا'),
(52077, 3252982784, 3252983039, 'UA', 'UKR', 'أوكرانيا'),
(52078, 3252983040, 3252983551, 'DE', 'DEU', 'ألمانيا'),
(52079, 3252983552, 3252983807, 'SI', 'SVN', 'سلوفينيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(52080, 3252983808, 3252984063, 'BG', 'BGR', 'بلغاريا'),
(52081, 3252984064, 3252984319, 'RO', 'ROM', 'رومانيا'),
(52082, 3252984320, 3252984575, 'AT', 'AUT', 'النمسا'),
(52083, 3252984576, 3252984831, 'GB', 'GBR', 'المملكة المتحدة'),
(52084, 3252984832, 3252985087, 'FR', 'FRA', 'فرنسا'),
(52085, 3252985088, 3252985343, 'SE', 'SWE', 'السويد'),
(52086, 3252985344, 3252985599, 'AT', 'AUT', 'النمسا'),
(52087, 3252985600, 3252985855, 'RU', 'RUS', 'الإتحاد الروسي'),
(52088, 3252985856, 3252989439, 'AT', 'AUT', 'النمسا'),
(52089, 3252989440, 3252989695, 'PL', 'POL', 'بولندا'),
(52090, 3252989696, 3253004799, 'AT', 'AUT', 'النمسا'),
(52091, 3253004800, 3253005055, 'CZ', 'CZE', 'التشيك'),
(52092, 3253005056, 3253010431, 'AT', 'AUT', 'النمسا'),
(52093, 3253010432, 3253075967, 'FI', 'FIN', 'فنلندا'),
(52094, 3253075968, 3253207039, 'RO', 'ROM', 'رومانيا'),
(52095, 3253207040, 3253223679, 'RU', 'RUS', 'الإتحاد الروسي'),
(52096, 3253223680, 3253223935, 'UA', 'UKR', 'أوكرانيا'),
(52097, 3253223936, 3253230591, 'RU', 'RUS', 'الإتحاد الروسي'),
(52098, 3253230592, 3253230847, 'BY', 'BLR', 'روسيا البيضاء'),
(52099, 3253230848, 3253247999, 'RU', 'RUS', 'الإتحاد الروسي'),
(52100, 3253248000, 3253248255, 'DE', 'DEU', 'ألمانيا'),
(52101, 3253248256, 3253248511, 'UZ', 'UZB', 'أوزباكستان'),
(52102, 3253248512, 3253264383, 'RU', 'RUS', 'الإتحاد الروسي'),
(52103, 3253264384, 3253264895, 'KZ', 'KAZ', 'كازاخستان'),
(52104, 3253264896, 3253265407, 'RU', 'RUS', 'الإتحاد الروسي'),
(52105, 3253265408, 3253265919, 'AM', 'ARM', 'أرمينيا'),
(52106, 3253265920, 3253270527, 'RU', 'RUS', 'الإتحاد الروسي'),
(52107, 3253270528, 3253271551, 'BY', 'BLR', 'روسيا البيضاء'),
(52108, 3253271552, 3253338111, 'RU', 'RUS', 'الإتحاد الروسي'),
(52109, 3253338112, 3253469183, 'SE', 'SWE', 'السويد'),
(52110, 3253469184, 3253471231, 'AO', 'AGO', 'أنغولا'),
(52111, 3253471232, 3253534719, 'PT', 'PRT', 'البورتوغال'),
(52112, 3253534720, 3253600255, 'GB', 'GBR', 'المملكة المتحدة'),
(52113, 3253600256, 3253601279, 'RO', 'ROM', 'رومانيا'),
(52114, 3253601280, 3253602303, 'FI', 'FIN', 'فنلندا'),
(52115, 3253602304, 3253603327, 'DE', 'DEU', 'ألمانيا'),
(52116, 3253603328, 3253605375, 'PL', 'POL', 'بولندا'),
(52117, 3253605376, 3253606399, 'UA', 'UKR', 'أوكرانيا'),
(52118, 3253606400, 3253607423, 'NL', 'NLD', 'هولندا'),
(52119, 3253607424, 3253608447, 'NG', 'NGA', 'نيجيريا'),
(52120, 3253608448, 3253610495, 'UA', 'UKR', 'أوكرانيا'),
(52121, 3253610496, 3253611519, 'PL', 'POL', 'بولندا'),
(52122, 3253611520, 3253612543, 'UA', 'UKR', 'أوكرانيا'),
(52123, 3253612544, 3253613567, 'RU', 'RUS', 'الإتحاد الروسي'),
(52124, 3253613568, 3253614591, 'ES', 'ESP', 'إسبانيا'),
(52125, 3253614592, 3253615615, 'RO', 'ROM', 'رومانيا'),
(52126, 3253615616, 3253616639, 'DE', 'DEU', 'ألمانيا'),
(52127, 3253616640, 3253617663, 'PL', 'POL', 'بولندا'),
(52128, 3253617664, 3253618687, 'GB', 'GBR', 'المملكة المتحدة'),
(52129, 3253618688, 3253619711, 'UA', 'UKR', 'أوكرانيا'),
(52130, 3253619712, 3253620735, 'IT', 'ITA', 'إيطاليا'),
(52131, 3253620736, 3253622783, 'GB', 'GBR', 'المملكة المتحدة'),
(52132, 3253622784, 3253623807, 'DE', 'DEU', 'ألمانيا'),
(52133, 3253623808, 3253624831, 'PL', 'POL', 'بولندا'),
(52134, 3253624832, 3253625855, 'UA', 'UKR', 'أوكرانيا'),
(52135, 3253625856, 3253626879, 'IT', 'ITA', 'إيطاليا'),
(52136, 3253626880, 3253627903, 'DE', 'DEU', 'ألمانيا'),
(52137, 3253627904, 3253628927, 'UA', 'UKR', 'أوكرانيا'),
(52138, 3253628928, 3253629951, 'GR', 'GRC', 'اليونان'),
(52139, 3253629952, 3253630975, 'UA', 'UKR', 'أوكرانيا'),
(52140, 3253630976, 3253631999, 'RU', 'RUS', 'الإتحاد الروسي'),
(52141, 3253632000, 3253633023, 'DE', 'DEU', 'ألمانيا'),
(52142, 3253633024, 3253635071, 'RU', 'RUS', 'الإتحاد الروسي'),
(52143, 3253635072, 3253636095, 'IT', 'ITA', 'إيطاليا'),
(52144, 3253636096, 3253637119, 'CH', 'CHE', 'سويسرا'),
(52145, 3253637120, 3253638143, 'ES', 'ESP', 'إسبانيا'),
(52146, 3253638144, 3253639167, 'FR', 'FRA', 'فرنسا'),
(52147, 3253639168, 3253640191, 'UA', 'UKR', 'أوكرانيا'),
(52148, 3253640192, 3253641215, 'AT', 'AUT', 'النمسا'),
(52149, 3253641216, 3253642239, 'NL', 'NLD', 'هولندا'),
(52150, 3253642240, 3253643263, 'GB', 'GBR', 'المملكة المتحدة'),
(52151, 3253643264, 3253645311, 'PL', 'POL', 'بولندا'),
(52152, 3253645312, 3253646335, 'RU', 'RUS', 'الإتحاد الروسي'),
(52153, 3253646336, 3253647359, 'PL', 'POL', 'بولندا'),
(52154, 3253647360, 3253648383, 'DK', 'DNK', 'الدنيمارك'),
(52155, 3253648384, 3253649407, 'IL', 'ISR', 'إسرائيل'),
(52156, 3253649408, 3253650431, 'UA', 'UKR', 'أوكرانيا'),
(52157, 3253650432, 3253651455, 'DE', 'DEU', 'ألمانيا'),
(52158, 3253651456, 3253652479, 'PL', 'POL', 'بولندا'),
(52159, 3253652480, 3253653503, 'LI', 'LIE', 'ليختنشتاين'),
(52160, 3253653504, 3253654527, 'IL', 'ISR', 'إسرائيل'),
(52161, 3253654528, 3253657599, 'LV', 'LVA', 'لاتفيا'),
(52162, 3253657600, 3253658623, 'UA', 'UKR', 'أوكرانيا'),
(52163, 3253658624, 3253659647, 'FR', 'FRA', 'فرنسا'),
(52164, 3253659648, 3253660671, 'GB', 'GBR', 'المملكة المتحدة'),
(52165, 3253660672, 3253661695, 'NO', 'NOR', 'النرويج'),
(52166, 3253661696, 3253662719, 'NL', 'NLD', 'هولندا'),
(52167, 3253662720, 3253663743, 'RO', 'ROM', 'رومانيا'),
(52168, 3253663744, 3253664767, 'NL', 'NLD', 'هولندا'),
(52169, 3253664768, 3253665791, 'DE', 'DEU', 'ألمانيا'),
(52170, 3253665792, 3253666815, 'CZ', 'CZE', 'التشيك'),
(52171, 3253667840, 3253668863, 'GB', 'GBR', 'المملكة المتحدة'),
(52172, 3253668864, 3253669887, 'ES', 'ESP', 'إسبانيا'),
(52173, 3253669888, 3253670911, 'DE', 'DEU', 'ألمانيا'),
(52174, 3253670912, 3253671935, 'CH', 'CHE', 'سويسرا'),
(52175, 3253671936, 3253672959, 'UA', 'UKR', 'أوكرانيا'),
(52176, 3253672960, 3253673983, 'DE', 'DEU', 'ألمانيا'),
(52177, 3253673984, 3253675007, 'GB', 'GBR', 'المملكة المتحدة'),
(52178, 3253675008, 3253676031, 'PL', 'POL', 'بولندا'),
(52179, 3253676032, 3253677055, 'AT', 'AUT', 'النمسا'),
(52180, 3253677056, 3253678079, 'PL', 'POL', 'بولندا'),
(52181, 3253678080, 3253679103, 'DK', 'DNK', 'الدنيمارك'),
(52182, 3253679104, 3253680127, 'IT', 'ITA', 'إيطاليا'),
(52183, 3253680128, 3253682175, 'PL', 'POL', 'بولندا'),
(52184, 3253682176, 3253683199, 'RO', 'ROM', 'رومانيا'),
(52185, 3253683200, 3253685247, 'UA', 'UKR', 'أوكرانيا'),
(52186, 3253685248, 3253686271, 'FR', 'FRA', 'فرنسا'),
(52187, 3253686272, 3253687295, 'PL', 'POL', 'بولندا'),
(52188, 3253687296, 3253688319, 'UA', 'UKR', 'أوكرانيا'),
(52189, 3253688320, 3253690367, 'NL', 'NLD', 'هولندا'),
(52190, 3253690368, 3253691391, 'DK', 'DNK', 'الدنيمارك'),
(52191, 3253691392, 3253692415, 'PL', 'POL', 'بولندا'),
(52192, 3253692416, 3253693439, 'DE', 'DEU', 'ألمانيا'),
(52193, 3253693440, 3253694463, 'IL', 'ISR', 'إسرائيل'),
(52194, 3253694464, 3253695487, 'GB', 'GBR', 'المملكة المتحدة'),
(52195, 3253695488, 3253696511, 'NL', 'NLD', 'هولندا'),
(52196, 3253696512, 3253697535, 'FR', 'FRA', 'فرنسا'),
(52197, 3253697536, 3253698559, 'PL', 'POL', 'بولندا'),
(52198, 3253698560, 3253699071, 'UA', 'UKR', 'أوكرانيا'),
(52199, 3253699072, 3253699583, 'RO', 'ROM', 'رومانيا'),
(52200, 3253699584, 3253700095, 'UA', 'UKR', 'أوكرانيا'),
(52201, 3253700096, 3253700607, 'RO', 'ROM', 'رومانيا'),
(52202, 3253700608, 3253701119, 'PL', 'POL', 'بولندا'),
(52203, 3253701120, 3253702143, 'RO', 'ROM', 'رومانيا'),
(52204, 3253702144, 3253702655, 'UA', 'UKR', 'أوكرانيا'),
(52205, 3253703168, 3253703679, 'RO', 'ROM', 'رومانيا'),
(52206, 3253703680, 3253704191, 'HU', 'HUN', 'هنغاريا'),
(52207, 3253704192, 3253704703, 'RU', 'RUS', 'الإتحاد الروسي'),
(52208, 3253704704, 3253705215, 'UA', 'UKR', 'أوكرانيا'),
(52209, 3253705216, 3253705727, 'NO', 'NOR', 'النرويج'),
(52210, 3253705728, 3253706239, 'DE', 'DEU', 'ألمانيا'),
(52211, 3253706240, 3253706751, 'RO', 'ROM', 'رومانيا'),
(52212, 3253706752, 3253707263, 'GB', 'GBR', 'المملكة المتحدة'),
(52213, 3253707776, 3253708287, 'DE', 'DEU', 'ألمانيا'),
(52214, 3253708288, 3253708799, 'RO', 'ROM', 'رومانيا'),
(52215, 3253708800, 3253709311, 'DK', 'DNK', 'الدنيمارك'),
(52216, 3253709312, 3253709823, 'UA', 'UKR', 'أوكرانيا'),
(52217, 3253709824, 3253710335, 'RO', 'ROM', 'رومانيا'),
(52218, 3253710336, 3253710847, 'GB', 'GBR', 'المملكة المتحدة'),
(52219, 3253710848, 3253711359, 'DK', 'DNK', 'الدنيمارك'),
(52220, 3253711360, 3253712383, 'UA', 'UKR', 'أوكرانيا'),
(52221, 3253712384, 3253712895, 'MD', 'MDA', 'مولدوفا'),
(52222, 3253712896, 3253713407, 'GR', 'GRC', 'اليونان'),
(52223, 3253713408, 3253713919, 'NL', 'NLD', 'هولندا'),
(52224, 3253713920, 3253714431, 'AT', 'AUT', 'النمسا'),
(52225, 3253714432, 3253714943, 'RO', 'ROM', 'رومانيا'),
(52226, 3253714944, 3253715455, 'FR', 'FRA', 'فرنسا'),
(52227, 3253715456, 3253715967, 'RO', 'ROM', 'رومانيا'),
(52228, 3253715968, 3253716479, 'DE', 'DEU', 'ألمانيا'),
(52229, 3253716480, 3253716991, 'FR', 'FRA', 'فرنسا'),
(52230, 3253716992, 3253717503, 'CH', 'CHE', 'سويسرا'),
(52231, 3253717504, 3253718015, 'NL', 'NLD', 'هولندا'),
(52232, 3253718016, 3253719551, 'PL', 'POL', 'بولندا'),
(52233, 3253719552, 3253720063, 'BE', 'BEL', 'بلجيكا'),
(52234, 3253720064, 3253720575, 'RO', 'ROM', 'رومانيا'),
(52235, 3253720576, 3253721087, 'GR', 'GRC', 'اليونان'),
(52236, 3253721088, 3253721599, 'UA', 'UKR', 'أوكرانيا'),
(52237, 3253721600, 3253722111, 'RO', 'ROM', 'رومانيا'),
(52238, 3253722112, 3253722623, 'CH', 'CHE', 'سويسرا'),
(52239, 3253722624, 3253723135, 'NL', 'NLD', 'هولندا'),
(52240, 3253723136, 3253723647, 'PL', 'POL', 'بولندا'),
(52241, 3253723648, 3253724159, 'AT', 'AUT', 'النمسا'),
(52242, 3253724160, 3253724671, 'UA', 'UKR', 'أوكرانيا'),
(52243, 3253724672, 3253725695, 'RO', 'ROM', 'رومانيا'),
(52244, 3253725696, 3253726207, 'UA', 'UKR', 'أوكرانيا'),
(52245, 3253726208, 3253726719, 'RO', 'ROM', 'رومانيا'),
(52246, 3253726720, 3253727231, 'UA', 'UKR', 'أوكرانيا'),
(52247, 3253727232, 3253727743, 'FR', 'FRA', 'فرنسا'),
(52248, 3253727744, 3253728255, 'RU', 'RUS', 'الإتحاد الروسي'),
(52249, 3253728256, 3253728767, 'PL', 'POL', 'بولندا'),
(52250, 3253728768, 3253729279, 'RO', 'ROM', 'رومانيا'),
(52251, 3253729280, 3253729791, 'AT', 'AUT', 'النمسا'),
(52252, 3253729792, 3253730303, 'UA', 'UKR', 'أوكرانيا'),
(52253, 3253730304, 3253730815, 'RO', 'ROM', 'رومانيا'),
(52254, 3253730816, 3253731327, 'UA', 'UKR', 'أوكرانيا'),
(52255, 3253731328, 3253796863, 'GB', 'GBR', 'المملكة المتحدة'),
(52256, 3253796864, 3253862399, 'SE', 'SWE', 'السويد'),
(52257, 3253862400, 3253862655, 'GB', 'GBR', 'المملكة المتحدة'),
(52258, 3253862656, 3253882879, 'FR', 'FRA', 'فرنسا'),
(52259, 3253882880, 3253886975, 'NL', 'NLD', 'هولندا'),
(52260, 3253886976, 3253887231, 'GB', 'GBR', 'المملكة المتحدة'),
(52261, 3253887232, 3253887487, 'NL', 'NLD', 'هولندا'),
(52262, 3253887488, 3253887743, 'ES', 'ESP', 'إسبانيا'),
(52263, 3253887744, 3253887999, 'GB', 'GBR', 'المملكة المتحدة'),
(52264, 3253888000, 3253888255, 'PL', 'POL', 'بولندا'),
(52265, 3253888256, 3253888511, 'BE', 'BEL', 'بلجيكا'),
(52266, 3253888512, 3253888767, 'GB', 'GBR', 'المملكة المتحدة'),
(52267, 3253888768, 3253889023, 'SE', 'SWE', 'السويد'),
(52268, 3253889024, 3253889279, 'PL', 'POL', 'بولندا'),
(52269, 3253889280, 3253889535, 'CH', 'CHE', 'سويسرا'),
(52270, 3253889536, 3253889791, 'DE', 'DEU', 'ألمانيا'),
(52271, 3253889792, 3253890047, 'DK', 'DNK', 'الدنيمارك'),
(52272, 3253890048, 3253890303, 'NL', 'NLD', 'هولندا'),
(52273, 3253890304, 3253890559, 'SE', 'SWE', 'السويد'),
(52274, 3253890560, 3253890815, 'GB', 'GBR', 'المملكة المتحدة'),
(52275, 3253890816, 3253891071, 'IE', 'IRL', 'إيرلندا'),
(52276, 3253891072, 3253891327, 'DE', 'DEU', 'ألمانيا'),
(52277, 3253891328, 3253891583, 'GB', 'GBR', 'المملكة المتحدة'),
(52278, 3253891584, 3253891839, 'UA', 'UKR', 'أوكرانيا'),
(52279, 3253891840, 3253892351, 'GB', 'GBR', 'المملكة المتحدة'),
(52280, 3253892352, 3253892607, 'NL', 'NLD', 'هولندا'),
(52281, 3253892608, 3253892863, 'AT', 'AUT', 'النمسا'),
(52282, 3253892864, 3253893119, 'NL', 'NLD', 'هولندا'),
(52283, 3253893120, 3253893375, 'RO', 'ROM', 'رومانيا'),
(52284, 3253893376, 3253893631, 'DE', 'DEU', 'ألمانيا'),
(52285, 3253893632, 3253893887, 'SE', 'SWE', 'السويد'),
(52286, 3253893888, 3253894143, 'RU', 'RUS', 'الإتحاد الروسي'),
(52287, 3253894144, 3253894399, 'PT', 'PRT', 'البورتوغال'),
(52288, 3253894400, 3253894655, 'NL', 'NLD', 'هولندا'),
(52289, 3253894656, 3253894911, 'FI', 'FIN', 'فنلندا'),
(52290, 3253894912, 3253895167, 'RU', 'RUS', 'الإتحاد الروسي'),
(52291, 3253895168, 3253911551, 'BE', 'BEL', 'بلجيكا'),
(52292, 3253911552, 3253919743, 'FR', 'FRA', 'فرنسا'),
(52293, 3253919744, 3253923839, 'GB', 'GBR', 'المملكة المتحدة'),
(52294, 3253923840, 3253927935, 'GR', 'GRC', 'اليونان'),
(52295, 3253927936, 3253961727, 'GB', 'GBR', 'المملكة المتحدة'),
(52296, 3253961728, 3253962239, 'MD', 'MDA', 'مولدوفا'),
(52297, 3253962240, 3253962751, 'SE', 'SWE', 'السويد'),
(52298, 3253962752, 3253963263, 'BE', 'BEL', 'بلجيكا'),
(52299, 3253963264, 3253963775, 'RU', 'RUS', 'الإتحاد الروسي'),
(52300, 3253963776, 3253964287, 'SI', 'SVN', 'سلوفينيا'),
(52301, 3253964288, 3253964799, 'PL', 'POL', 'بولندا'),
(52302, 3253964800, 3253965311, 'SE', 'SWE', 'السويد'),
(52303, 3253965312, 3253966335, 'PL', 'POL', 'بولندا'),
(52304, 3253966336, 3253966847, 'DE', 'DEU', 'ألمانيا'),
(52305, 3253966848, 3253967359, 'UA', 'UKR', 'أوكرانيا'),
(52306, 3253967360, 3253967871, 'GR', 'GRC', 'اليونان'),
(52307, 3253967872, 3253968895, 'UA', 'UKR', 'أوكرانيا'),
(52308, 3253968896, 3253969407, 'DE', 'DEU', 'ألمانيا'),
(52309, 3253969408, 3253969919, 'AT', 'AUT', 'النمسا'),
(52310, 3253969920, 3253970431, 'NL', 'NLD', 'هولندا'),
(52311, 3253970432, 3253970687, 'DE', 'DEU', 'ألمانيا'),
(52312, 3253970688, 3253970943, 'UA', 'UKR', 'أوكرانيا'),
(52313, 3253970944, 3253971967, 'RS', 'SRB', 'صربيا'),
(52314, 3253971968, 3253972991, 'RU', 'RUS', 'الإتحاد الروسي'),
(52315, 3253972992, 3253974783, 'GB', 'GBR', 'المملكة المتحدة'),
(52316, 3253974784, 3253974847, 'NO', 'NOR', 'النرويج'),
(52317, 3253974848, 3253974911, 'SE', 'SWE', 'السويد'),
(52318, 3253974912, 3253974975, 'IL', 'ISR', 'إسرائيل'),
(52319, 3253974976, 3253975039, 'SE', 'SWE', 'السويد'),
(52320, 3253975040, 3253977087, 'DE', 'DEU', 'ألمانيا'),
(52321, 3253977088, 3253985279, 'TR', 'TUR', 'تركيا'),
(52322, 3253985280, 3253993471, 'GB', 'GBR', 'المملكة المتحدة'),
(52323, 3253993472, 3254067199, 'BE', 'BEL', 'بلجيكا'),
(52324, 3254067200, 3254069247, 'CZ', 'CZE', 'التشيك'),
(52325, 3254069248, 3254124543, 'BE', 'BEL', 'بلجيكا'),
(52326, 3254124544, 3254156799, 'CH', 'CHE', 'سويسرا'),
(52327, 3254156800, 3254157055, 'LI', 'LIE', 'ليختنشتاين'),
(52328, 3254157056, 3254177279, 'CH', 'CHE', 'سويسرا'),
(52329, 3254177280, 3254177535, 'LI', 'LIE', 'ليختنشتاين'),
(52330, 3254177536, 3254255615, 'CH', 'CHE', 'سويسرا'),
(52331, 3254255616, 3254485503, 'FR', 'FRA', 'فرنسا'),
(52332, 3254485504, 3254485799, 'CI', 'CIV', 'كوت ديفوار'),
(52333, 3254485800, 3254485807, 'FR', 'FRA', 'فرنسا'),
(52334, 3254485808, 3254485819, 'CI', 'CIV', 'كوت ديفوار'),
(52335, 3254485820, 3254485820, 'FR', 'FRA', 'فرنسا'),
(52336, 3254485821, 3254485821, 'CI', 'CIV', 'كوت ديفوار'),
(52337, 3254485822, 3254485822, 'FR', 'FRA', 'فرنسا'),
(52338, 3254485823, 3254485855, 'CI', 'CIV', 'كوت ديفوار'),
(52339, 3254485856, 3254485859, 'FR', 'FRA', 'فرنسا'),
(52340, 3254485860, 3254485887, 'CI', 'CIV', 'كوت ديفوار'),
(52341, 3254485888, 3254486527, 'FR', 'FRA', 'فرنسا'),
(52342, 3254486528, 3254486543, 'CH', 'CHE', 'سويسرا'),
(52343, 3254486544, 3254486559, 'US', 'USA', 'الولايات المتحدة'),
(52344, 3254486560, 3254486591, 'GB', 'GBR', 'المملكة المتحدة'),
(52345, 3254486592, 3254486655, 'FR', 'FRA', 'فرنسا'),
(52346, 3254486656, 3254486671, 'CH', 'CHE', 'سويسرا'),
(52347, 3254486672, 3254486687, 'FR', 'FRA', 'فرنسا'),
(52348, 3254486688, 3254486719, 'CH', 'CHE', 'سويسرا'),
(52349, 3254486720, 3254486735, 'FR', 'FRA', 'فرنسا'),
(52350, 3254486736, 3254486767, 'US', 'USA', 'الولايات المتحدة'),
(52351, 3254486768, 3254486783, 'HK', 'HKG', 'هونغ كونغ'),
(52352, 3254486784, 3254487039, 'FR', 'FRA', 'فرنسا'),
(52353, 3254487040, 3254487199, 'KM', 'COM', 'جزر القمر'),
(52354, 3254487200, 3254487263, 'FR', 'FRA', 'فرنسا'),
(52355, 3254487264, 3254487295, 'KM', 'COM', 'جزر القمر'),
(52356, 3254487296, 3254487419, 'CF', 'CAF', 'جمهورية أفريقيا الوسطى'),
(52357, 3254487420, 3254487551, 'FR', 'FRA', 'فرنسا'),
(52358, 3254487552, 3254487803, 'CI', 'CIV', 'كوت ديفوار'),
(52359, 3254487804, 3254487807, 'FR', 'FRA', 'فرنسا'),
(52360, 3254487808, 3254487855, 'LB', 'LBN', 'لبنان'),
(52361, 3254487856, 3254487863, 'FR', 'FRA', 'فرنسا'),
(52362, 3254487864, 3254488063, 'LB', 'LBN', 'لبنان'),
(52363, 3254488064, 3254488431, 'FR', 'FRA', 'فرنسا'),
(52364, 3254488432, 3254488447, 'MG', 'MDG', 'مدغشقر'),
(52365, 3254488448, 3254488831, 'FR', 'FRA', 'فرنسا'),
(52366, 3254488832, 3254489087, 'DJ', 'DJI', 'جيبوتي'),
(52367, 3254489088, 3254489343, 'DZ', 'DZA', 'الجزائر'),
(52368, 3254489344, 3254489365, 'FR', 'FRA', 'فرنسا'),
(52369, 3254489366, 3254489367, 'MR', 'MRT', 'موريتانيا'),
(52370, 3254489368, 3254489369, 'FR', 'FRA', 'فرنسا'),
(52371, 3254489370, 3254489370, 'MR', 'MRT', 'موريتانيا'),
(52372, 3254489371, 3254489373, 'FR', 'FRA', 'فرنسا'),
(52373, 3254489374, 3254489375, 'MR', 'MRT', 'موريتانيا'),
(52374, 3254489376, 3254489407, 'FR', 'FRA', 'فرنسا'),
(52375, 3254489408, 3254489439, 'MR', 'MRT', 'موريتانيا'),
(52376, 3254489440, 3254489443, 'FR', 'FRA', 'فرنسا'),
(52377, 3254489444, 3254489455, 'MR', 'MRT', 'موريتانيا'),
(52378, 3254489456, 3254489463, 'FR', 'FRA', 'فرنسا'),
(52379, 3254489464, 3254489519, 'MR', 'MRT', 'موريتانيا'),
(52380, 3254489520, 3254489535, 'FR', 'FRA', 'فرنسا'),
(52381, 3254489536, 3254489567, 'MR', 'MRT', 'موريتانيا'),
(52382, 3254489568, 3254489599, 'FR', 'FRA', 'فرنسا'),
(52383, 3254489600, 3254489855, 'MR', 'MRT', 'موريتانيا'),
(52384, 3254489856, 3254490111, 'TD', 'TCD', 'تشاد'),
(52385, 3254490112, 3254490367, 'FR', 'FRA', 'فرنسا'),
(52386, 3254490368, 3254490623, 'CF', 'CAF', 'جمهورية أفريقيا الوسطى'),
(52387, 3254490624, 3254491135, 'FR', 'FRA', 'فرنسا'),
(52388, 3254491136, 3254491391, 'DZ', 'DZA', 'الجزائر'),
(52389, 3254491392, 3254491607, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(52390, 3254491608, 3254491615, 'FR', 'FRA', 'فرنسا'),
(52391, 3254491616, 3254491647, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(52392, 3254491648, 3254491903, 'FR', 'FRA', 'فرنسا'),
(52393, 3254491904, 3254492031, 'CM', 'CMR', 'الكاميرون'),
(52394, 3254492032, 3254492159, 'FR', 'FRA', 'فرنسا'),
(52395, 3254492160, 3254492671, 'LB', 'LBN', 'لبنان'),
(52396, 3254492672, 3254492927, 'FR', 'FRA', 'فرنسا'),
(52397, 3254492928, 3254493183, 'CI', 'CIV', 'كوت ديفوار'),
(52398, 3254493184, 3254493323, 'GP', 'GLP', 'جوادلوب'),
(52399, 3254493324, 3254493327, 'FR', 'FRA', 'فرنسا'),
(52400, 3254493328, 3254493335, 'GP', 'GLP', 'جوادلوب'),
(52401, 3254493336, 3254493343, 'FR', 'FRA', 'فرنسا'),
(52402, 3254493344, 3254493439, 'GP', 'GLP', 'جوادلوب'),
(52403, 3254493440, 3254493695, 'CI', 'CIV', 'كوت ديفوار'),
(52404, 3254493696, 3254494527, 'GP', 'GLP', 'جوادلوب'),
(52405, 3254494528, 3254494719, 'FR', 'FRA', 'فرنسا'),
(52406, 3254494720, 3254494735, 'LB', 'LBN', 'لبنان'),
(52407, 3254494736, 3254494743, 'FR', 'FRA', 'فرنسا'),
(52408, 3254494744, 3254494803, 'LB', 'LBN', 'لبنان'),
(52409, 3254494804, 3254494807, 'FR', 'FRA', 'فرنسا'),
(52410, 3254494808, 3254494975, 'LB', 'LBN', 'لبنان'),
(52411, 3254494976, 3254495087, 'DJ', 'DJI', 'جيبوتي'),
(52412, 3254495088, 3254495231, 'FR', 'FRA', 'فرنسا'),
(52413, 3254495232, 3254495487, 'CI', 'CIV', 'كوت ديفوار'),
(52414, 3254495488, 3254495743, 'DZ', 'DZA', 'الجزائر'),
(52415, 3254495744, 3254496255, 'LB', 'LBN', 'لبنان'),
(52416, 3254496256, 3254496511, 'FR', 'FRA', 'فرنسا'),
(52417, 3254496512, 3254496527, 'CI', 'CIV', 'كوت ديفوار'),
(52418, 3254496528, 3254496767, 'FR', 'FRA', 'فرنسا'),
(52419, 3254496768, 3254497247, 'DZ', 'DZA', 'الجزائر'),
(52420, 3254497248, 3254508031, 'FR', 'FRA', 'فرنسا'),
(52421, 3254508032, 3254508543, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(52422, 3254508544, 3254508799, 'NE', 'NER', 'النيجر'),
(52423, 3254508800, 3254508831, 'MQ', 'MTQ', 'مارتينيك'),
(52424, 3254508832, 3254509055, 'FR', 'FRA', 'فرنسا'),
(52425, 3254509056, 3254509567, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(52426, 3254509568, 3254509783, 'DJ', 'DJI', 'جيبوتي'),
(52427, 3254509784, 3254510339, 'FR', 'FRA', 'فرنسا'),
(52428, 3254510340, 3254510359, 'NE', 'NER', 'النيجر'),
(52429, 3254510360, 3254510375, 'FR', 'FRA', 'فرنسا'),
(52430, 3254510376, 3254510407, 'NE', 'NER', 'النيجر'),
(52431, 3254510408, 3254510420, 'FR', 'FRA', 'فرنسا'),
(52432, 3254510421, 3254510421, 'NE', 'NER', 'النيجر'),
(52433, 3254510422, 3254510431, 'FR', 'FRA', 'فرنسا'),
(52434, 3254510432, 3254510432, 'NE', 'NER', 'النيجر'),
(52435, 3254510433, 3254510440, 'FR', 'FRA', 'فرنسا'),
(52436, 3254510441, 3254510441, 'NE', 'NER', 'النيجر'),
(52437, 3254510442, 3254510443, 'FR', 'FRA', 'فرنسا'),
(52438, 3254510444, 3254510451, 'NE', 'NER', 'النيجر'),
(52439, 3254510452, 3254510455, 'FR', 'FRA', 'فرنسا'),
(52440, 3254510456, 3254510519, 'NE', 'NER', 'النيجر'),
(52441, 3254510520, 3254510527, 'FR', 'FRA', 'فرنسا'),
(52442, 3254510528, 3254510559, 'NE', 'NER', 'النيجر'),
(52443, 3254510560, 3254510563, 'FR', 'FRA', 'فرنسا'),
(52444, 3254510564, 3254510847, 'NE', 'NER', 'النيجر'),
(52445, 3254510848, 3254521855, 'FR', 'FRA', 'فرنسا'),
(52446, 3254521856, 3254522367, 'GB', 'GBR', 'المملكة المتحدة'),
(52447, 3254522368, 3254550527, 'FR', 'FRA', 'فرنسا'),
(52448, 3254550528, 3254550783, 'US', 'USA', 'الولايات المتحدة'),
(52449, 3254550784, 3254551039, 'IR', 'IRN', 'إيران'),
(52450, 3254551040, 3254551295, 'US', 'USA', 'الولايات المتحدة'),
(52451, 3254551296, 3254551551, 'IR', 'IRN', 'إيران'),
(52452, 3254551552, 3254551807, 'US', 'USA', 'الولايات المتحدة'),
(52453, 3254551808, 3254552063, 'FR', 'FRA', 'فرنسا'),
(52454, 3254552064, 3254552319, 'US', 'USA', 'الولايات المتحدة'),
(52455, 3254552320, 3254552831, 'IR', 'IRN', 'إيران'),
(52456, 3254552832, 3254553087, 'HK', 'HKG', 'هونغ كونغ'),
(52457, 3254553088, 3254553343, 'FR', 'FRA', 'فرنسا'),
(52458, 3254553344, 3254553599, 'HK', 'HKG', 'هونغ كونغ'),
(52459, 3254553600, 3254554879, 'FR', 'FRA', 'فرنسا'),
(52460, 3254554880, 3254555135, 'HK', 'HKG', 'هونغ كونغ'),
(52461, 3254555136, 3254555391, 'FR', 'FRA', 'فرنسا'),
(52462, 3254555392, 3254555647, 'HK', 'HKG', 'هونغ كونغ'),
(52463, 3254555648, 3254557439, 'FR', 'FRA', 'فرنسا'),
(52464, 3254557440, 3254557695, 'AT', 'AUT', 'النمسا'),
(52465, 3254557696, 3254576383, 'FR', 'FRA', 'فرنسا'),
(52466, 3254576384, 3254576543, 'DO', 'DOM', 'الدومينيكان'),
(52467, 3254576544, 3254583296, 'FR', 'FRA', 'فرنسا'),
(52468, 3254583297, 3254583300, 'SG', 'SGP', 'سنغافورة'),
(52469, 3254583301, 3254583302, 'US', 'USA', 'الولايات المتحدة'),
(52470, 3254583303, 3254583551, 'FR', 'FRA', 'فرنسا'),
(52471, 3254583552, 3254583567, 'SG', 'SGP', 'سنغافورة'),
(52472, 3254583568, 3254583583, 'US', 'USA', 'الولايات المتحدة'),
(52473, 3254583584, 3254623743, 'FR', 'FRA', 'فرنسا'),
(52474, 3254623744, 3254624255, 'US', 'USA', 'الولايات المتحدة'),
(52475, 3254624256, 3254648831, 'FR', 'FRA', 'فرنسا'),
(52476, 3254648832, 3254648895, 'DK', 'DNK', 'الدنيمارك'),
(52477, 3254648896, 3254649087, 'GB', 'GBR', 'المملكة المتحدة'),
(52478, 3254649088, 3254649855, 'AL', 'ALB', 'ألبانيا'),
(52479, 3254649856, 3254650879, 'SE', 'SWE', 'السويد'),
(52480, 3254650880, 3254653439, 'CH', 'CHE', 'سويسرا'),
(52481, 3254653440, 3254654847, 'DE', 'DEU', 'ألمانيا'),
(52482, 3254654848, 3254654975, 'DK', 'DNK', 'الدنيمارك'),
(52483, 3254654976, 3254655743, 'IT', 'ITA', 'إيطاليا'),
(52484, 3254655744, 3254656255, 'GB', 'GBR', 'المملكة المتحدة'),
(52485, 3254656256, 3254656511, 'BG', 'BGR', 'بلغاريا'),
(52486, 3254656512, 3254656767, 'DE', 'DEU', 'ألمانيا'),
(52487, 3254656768, 3254657023, 'GB', 'GBR', 'المملكة المتحدة'),
(52488, 3254657024, 3254665215, 'RO', 'ROM', 'رومانيا'),
(52489, 3254676480, 3254676735, 'DE', 'DEU', 'ألمانيا'),
(52490, 3254681600, 3254697983, 'DE', 'DEU', 'ألمانيا'),
(52491, 3254697984, 3254698495, 'SE', 'SWE', 'السويد'),
(52492, 3254698496, 3254699007, 'GB', 'GBR', 'المملكة المتحدة'),
(52493, 3254699008, 3254699519, 'UA', 'UKR', 'أوكرانيا'),
(52494, 3254699520, 3254700031, 'US', 'USA', 'الولايات المتحدة'),
(52495, 3254700032, 3254700543, 'GR', 'GRC', 'اليونان'),
(52496, 3254700544, 3254701055, 'DE', 'DEU', 'ألمانيا'),
(52497, 3254701056, 3254701567, 'RU', 'RUS', 'الإتحاد الروسي'),
(52498, 3254701568, 3254702079, 'IL', 'ISR', 'إسرائيل'),
(52499, 3254702080, 3254702591, 'RU', 'RUS', 'الإتحاد الروسي'),
(52500, 3254702592, 3254703103, 'GB', 'GBR', 'المملكة المتحدة'),
(52501, 3254703104, 3254703615, 'DE', 'DEU', 'ألمانيا'),
(52502, 3254703616, 3254704127, 'NL', 'NLD', 'هولندا'),
(52503, 3254704128, 3254705663, 'UA', 'UKR', 'أوكرانيا'),
(52504, 3254705664, 3254706175, 'GR', 'GRC', 'اليونان'),
(52505, 3254706176, 3254706687, 'RU', 'RUS', 'الإتحاد الروسي'),
(52506, 3254706688, 3254707199, 'UA', 'UKR', 'أوكرانيا'),
(52507, 3254707200, 3254707711, 'TR', 'TUR', 'تركيا'),
(52508, 3254707712, 3254708223, 'RO', 'ROM', 'رومانيا'),
(52509, 3254708224, 3254708735, 'UA', 'UKR', 'أوكرانيا'),
(52510, 3254708736, 3254709247, 'RO', 'ROM', 'رومانيا'),
(52511, 3254709248, 3254709759, 'DE', 'DEU', 'ألمانيا'),
(52512, 3254710272, 3254710783, 'IT', 'ITA', 'إيطاليا'),
(52513, 3254710784, 3254711295, 'RO', 'ROM', 'رومانيا'),
(52514, 3254711296, 3254711807, 'FR', 'FRA', 'فرنسا'),
(52515, 3254711808, 3254712319, 'PL', 'POL', 'بولندا'),
(52516, 3254712320, 3254712831, 'RU', 'RUS', 'الإتحاد الروسي'),
(52517, 3254712832, 3254713343, 'KZ', 'KAZ', 'كازاخستان'),
(52518, 3254713344, 3254713855, 'TR', 'TUR', 'تركيا'),
(52519, 3254713856, 3254714367, 'NL', 'NLD', 'هولندا'),
(52520, 3254714368, 3254779903, 'TR', 'TUR', 'تركيا'),
(52521, 3254779904, 3254780159, 'DE', 'DEU', 'ألمانيا'),
(52522, 3254780160, 3254780671, 'GB', 'GBR', 'المملكة المتحدة'),
(52523, 3254780672, 3254780927, 'LT', 'LTU', 'ليتوانيا'),
(52524, 3254780928, 3254781183, 'GR', 'GRC', 'اليونان'),
(52525, 3254781184, 3254781439, 'NL', 'NLD', 'هولندا'),
(52526, 3254781440, 3254781951, 'BE', 'BEL', 'بلجيكا'),
(52527, 3254781952, 3254782207, 'LV', 'LVA', 'لاتفيا'),
(52528, 3254782208, 3254782463, 'FR', 'FRA', 'فرنسا'),
(52529, 3254782464, 3254782719, 'AT', 'AUT', 'النمسا'),
(52530, 3254782720, 3254782975, 'DE', 'DEU', 'ألمانيا'),
(52531, 3254782976, 3254783743, 'CZ', 'CZE', 'التشيك'),
(52532, 3254783744, 3254783999, 'SA', 'SAU', 'السعودية'),
(52533, 3254784000, 3254784255, 'IT', 'ITA', 'إيطاليا'),
(52534, 3254796288, 3254797311, 'SE', 'SWE', 'السويد'),
(52535, 3254797312, 3254798335, 'RU', 'RUS', 'الإتحاد الروسي'),
(52536, 3254798336, 3254799359, 'AT', 'AUT', 'النمسا'),
(52537, 3254799360, 3254800383, 'IE', 'IRL', 'إيرلندا'),
(52538, 3254800384, 3254801407, 'FI', 'FIN', 'فنلندا'),
(52539, 3254801408, 3254802431, 'HR', 'HRV', 'كرواتيا'),
(52540, 3254802432, 3254803455, 'UA', 'UKR', 'أوكرانيا'),
(52541, 3254803456, 3254804479, 'DE', 'DEU', 'ألمانيا'),
(52542, 3254804480, 3254806527, 'PL', 'POL', 'بولندا'),
(52543, 3254806528, 3254807551, 'UA', 'UKR', 'أوكرانيا'),
(52544, 3254807552, 3254808575, 'KZ', 'KAZ', 'كازاخستان'),
(52545, 3254808576, 3254809599, 'PL', 'POL', 'بولندا'),
(52546, 3254809600, 3254810623, 'UA', 'UKR', 'أوكرانيا'),
(52547, 3254810624, 3254811647, 'RU', 'RUS', 'الإتحاد الروسي'),
(52548, 3254811648, 3254812671, 'RO', 'ROM', 'رومانيا'),
(52549, 3254812672, 3254812927, 'PL', 'POL', 'بولندا'),
(52550, 3254812928, 3254813183, 'RO', 'ROM', 'رومانيا'),
(52551, 3254813184, 3254813439, 'TR', 'TUR', 'تركيا'),
(52552, 3254813440, 3254813695, 'UA', 'UKR', 'أوكرانيا'),
(52553, 3254813696, 3254813951, 'DK', 'DNK', 'الدنيمارك'),
(52554, 3254813952, 3254814207, 'IT', 'ITA', 'إيطاليا'),
(52555, 3254814208, 3254814463, 'SE', 'SWE', 'السويد'),
(52556, 3254814464, 3254814719, 'DE', 'DEU', 'ألمانيا'),
(52557, 3254814720, 3254814975, 'RU', 'RUS', 'الإتحاد الروسي'),
(52558, 3254814976, 3254815231, 'CH', 'CHE', 'سويسرا'),
(52559, 3254815232, 3254815487, 'UA', 'UKR', 'أوكرانيا'),
(52560, 3254815488, 3254815743, 'GB', 'GBR', 'المملكة المتحدة'),
(52561, 3254815744, 3254815999, 'IT', 'ITA', 'إيطاليا'),
(52562, 3254816000, 3254816255, 'RU', 'RUS', 'الإتحاد الروسي'),
(52563, 3254816256, 3254816511, 'TR', 'TUR', 'تركيا'),
(52564, 3254816512, 3254816767, 'DE', 'DEU', 'ألمانيا'),
(52565, 3254816768, 3254817279, 'RU', 'RUS', 'الإتحاد الروسي'),
(52566, 3254817280, 3254817535, 'CY', 'CYP', 'قبرص'),
(52567, 3254817536, 3254817791, 'GB', 'GBR', 'المملكة المتحدة'),
(52568, 3254817792, 3254818047, 'UA', 'UKR', 'أوكرانيا'),
(52569, 3254818048, 3254818303, 'DE', 'DEU', 'ألمانيا'),
(52570, 3254818304, 3254818559, 'UA', 'UKR', 'أوكرانيا'),
(52571, 3254818560, 3254818815, 'DE', 'DEU', 'ألمانيا'),
(52572, 3254818816, 3254819327, 'FR', 'FRA', 'فرنسا'),
(52573, 3254819328, 3254819583, 'PL', 'POL', 'بولندا'),
(52574, 3254819584, 3254819839, 'DK', 'DNK', 'الدنيمارك'),
(52575, 3254819840, 3254820095, 'GB', 'GBR', 'المملكة المتحدة'),
(52576, 3254820096, 3254820351, 'UA', 'UKR', 'أوكرانيا'),
(52577, 3254820352, 3254820863, 'GB', 'GBR', 'المملكة المتحدة'),
(52578, 3254820864, 3254821119, 'LT', 'LTU', 'ليتوانيا'),
(52579, 3254821120, 3254821375, 'DK', 'DNK', 'الدنيمارك'),
(52580, 3254821376, 3254821631, 'RU', 'RUS', 'الإتحاد الروسي'),
(52581, 3254821632, 3254821887, 'DE', 'DEU', 'ألمانيا'),
(52582, 3254821888, 3254822143, 'HU', 'HUN', 'هنغاريا'),
(52583, 3254822144, 3254822399, 'DE', 'DEU', 'ألمانيا'),
(52584, 3254822400, 3254822655, 'FR', 'FRA', 'فرنسا'),
(52585, 3254822656, 3254822911, 'PL', 'POL', 'بولندا'),
(52586, 3254822912, 3254823167, 'CH', 'CHE', 'سويسرا'),
(52587, 3254823168, 3254823423, 'NO', 'NOR', 'النرويج'),
(52588, 3254823424, 3254823679, 'NL', 'NLD', 'هولندا'),
(52589, 3254823680, 3254823935, 'PL', 'POL', 'بولندا'),
(52590, 3254823936, 3254824191, 'CH', 'CHE', 'سويسرا'),
(52591, 3254824192, 3254824959, 'BE', 'BEL', 'بلجيكا'),
(52592, 3254824960, 3254825215, 'FR', 'FRA', 'فرنسا'),
(52593, 3254825216, 3254825471, 'RO', 'ROM', 'رومانيا'),
(52594, 3254825472, 3254825727, 'TR', 'TUR', 'تركيا'),
(52595, 3254825728, 3254825983, 'FR', 'FRA', 'فرنسا'),
(52596, 3254825984, 3254826239, 'DE', 'DEU', 'ألمانيا'),
(52597, 3254826240, 3254826495, 'PL', 'POL', 'بولندا'),
(52598, 3254826496, 3254827263, 'DE', 'DEU', 'ألمانيا'),
(52599, 3254827264, 3254827519, 'GR', 'GRC', 'اليونان'),
(52600, 3254827520, 3254827775, 'PL', 'POL', 'بولندا'),
(52601, 3254827776, 3254828031, 'UA', 'UKR', 'أوكرانيا'),
(52602, 3254828032, 3254828287, 'DE', 'DEU', 'ألمانيا'),
(52603, 3254828288, 3254828799, 'RO', 'ROM', 'رومانيا'),
(52604, 3254828800, 3254829055, 'BE', 'BEL', 'بلجيكا'),
(52605, 3254829056, 3254829311, 'NO', 'NOR', 'النرويج'),
(52606, 3254829312, 3254829567, 'GB', 'GBR', 'المملكة المتحدة'),
(52607, 3254829568, 3254829823, 'NL', 'NLD', 'هولندا'),
(52608, 3254829824, 3254830079, 'FR', 'FRA', 'فرنسا'),
(52609, 3254830080, 3254830335, 'IE', 'IRL', 'إيرلندا'),
(52610, 3254830336, 3254830591, 'NL', 'NLD', 'هولندا'),
(52611, 3254830592, 3254830847, 'CH', 'CHE', 'سويسرا'),
(52612, 3254830848, 3254831103, 'PL', 'POL', 'بولندا'),
(52613, 3254831104, 3254831359, 'UA', 'UKR', 'أوكرانيا'),
(52614, 3254831360, 3254831615, 'DE', 'DEU', 'ألمانيا'),
(52615, 3254831616, 3254831871, 'TR', 'TUR', 'تركيا'),
(52616, 3254831872, 3254832127, 'LT', 'LTU', 'ليتوانيا'),
(52617, 3254832128, 3254832383, 'RO', 'ROM', 'رومانيا'),
(52618, 3254832384, 3254832639, 'BE', 'BEL', 'بلجيكا'),
(52619, 3254832640, 3254832895, 'UA', 'UKR', 'أوكرانيا'),
(52620, 3254832896, 3254833151, 'LV', 'LVA', 'لاتفيا'),
(52621, 3254833152, 3254833407, 'DE', 'DEU', 'ألمانيا'),
(52622, 3254833408, 3254833663, 'RU', 'RUS', 'الإتحاد الروسي'),
(52623, 3254833664, 3254833919, 'GB', 'GBR', 'المملكة المتحدة'),
(52624, 3254833920, 3254834175, 'PL', 'POL', 'بولندا'),
(52625, 3254834176, 3254834431, 'CH', 'CHE', 'سويسرا'),
(52626, 3254834432, 3254834687, 'FR', 'FRA', 'فرنسا'),
(52627, 3254834688, 3254834943, 'GB', 'GBR', 'المملكة المتحدة'),
(52628, 3254834944, 3254835199, 'NO', 'NOR', 'النرويج'),
(52629, 3254835200, 3254835455, 'DE', 'DEU', 'ألمانيا'),
(52630, 3254835456, 3254835711, 'SE', 'SWE', 'السويد'),
(52631, 3254835712, 3254835967, 'UA', 'UKR', 'أوكرانيا'),
(52632, 3254835968, 3254836223, 'GB', 'GBR', 'المملكة المتحدة'),
(52633, 3254836224, 3254836479, 'PL', 'POL', 'بولندا'),
(52634, 3254836480, 3254836735, 'MD', 'MDA', 'مولدوفا'),
(52635, 3254836736, 3254836991, 'AT', 'AUT', 'النمسا'),
(52636, 3254836992, 3254837247, 'GB', 'GBR', 'المملكة المتحدة'),
(52637, 3254837248, 3254837503, 'HR', 'HRV', 'كرواتيا'),
(52638, 3254837504, 3254837759, 'RU', 'RUS', 'الإتحاد الروسي'),
(52639, 3254837760, 3254838015, 'IE', 'IRL', 'إيرلندا'),
(52640, 3254838016, 3254838271, 'GE', 'GEO', 'جورجيا'),
(52641, 3254838272, 3254838527, 'DE', 'DEU', 'ألمانيا'),
(52642, 3254838528, 3254838783, 'CH', 'CHE', 'سويسرا'),
(52643, 3254838784, 3254839039, 'AT', 'AUT', 'النمسا'),
(52644, 3254839040, 3254839295, 'RU', 'RUS', 'الإتحاد الروسي'),
(52645, 3254839296, 3254839551, 'DE', 'DEU', 'ألمانيا'),
(52646, 3254839552, 3254839807, 'PL', 'POL', 'بولندا'),
(52647, 3254839808, 3254840063, 'BE', 'BEL', 'بلجيكا'),
(52648, 3254840064, 3254840319, 'BG', 'BGR', 'بلغاريا'),
(52649, 3254840320, 3254840575, 'DK', 'DNK', 'الدنيمارك'),
(52650, 3254840576, 3254840831, 'UA', 'UKR', 'أوكرانيا'),
(52651, 3254840832, 3254841343, 'GB', 'GBR', 'المملكة المتحدة'),
(52652, 3254841600, 3254841855, 'IE', 'IRL', 'إيرلندا'),
(52653, 3254841856, 3254842111, 'LV', 'LVA', 'لاتفيا'),
(52654, 3254842112, 3254842367, 'GB', 'GBR', 'المملكة المتحدة'),
(52655, 3254842368, 3254842623, 'PL', 'POL', 'بولندا'),
(52656, 3254842624, 3254842879, 'RU', 'RUS', 'الإتحاد الروسي'),
(52657, 3254842880, 3254843135, 'SE', 'SWE', 'السويد'),
(52658, 3254843136, 3254843647, 'DE', 'DEU', 'ألمانيا'),
(52659, 3254843648, 3254843903, 'FR', 'FRA', 'فرنسا'),
(52660, 3254843904, 3254844159, 'NL', 'NLD', 'هولندا'),
(52661, 3254844160, 3254844415, 'PL', 'POL', 'بولندا'),
(52662, 3254844416, 3254844671, 'GB', 'GBR', 'المملكة المتحدة'),
(52663, 3254844672, 3254844927, 'RO', 'ROM', 'رومانيا'),
(52664, 3254844928, 3254845183, 'DE', 'DEU', 'ألمانيا'),
(52665, 3254845184, 3254845439, 'FR', 'FRA', 'فرنسا'),
(52666, 3254845440, 3254882303, 'SK', 'SVK', 'سلوفاكيا'),
(52667, 3254882304, 3254882559, 'PL', 'POL', 'بولندا'),
(52668, 3254882560, 3254882815, 'IL', 'ISR', 'إسرائيل'),
(52669, 3254882816, 3254883071, 'PL', 'POL', 'بولندا'),
(52670, 3254883072, 3254883583, 'GB', 'GBR', 'المملكة المتحدة'),
(52671, 3254883584, 3254883839, 'AL', 'ALB', 'ألبانيا'),
(52672, 3254883840, 3254884351, 'GB', 'GBR', 'المملكة المتحدة'),
(52673, 3254884352, 3254884607, 'RU', 'RUS', 'الإتحاد الروسي'),
(52674, 3254884608, 3254884863, 'PL', 'POL', 'بولندا'),
(52675, 3254884864, 3254885119, 'SE', 'SWE', 'السويد'),
(52676, 3254885120, 3254885375, 'DE', 'DEU', 'ألمانيا'),
(52677, 3254885632, 3254885887, 'SK', 'SVK', 'سلوفاكيا'),
(52678, 3254885888, 3254886143, 'AT', 'AUT', 'النمسا'),
(52679, 3254886400, 3254886655, 'IT', 'ITA', 'إيطاليا'),
(52680, 3254886656, 3254886911, 'RU', 'RUS', 'الإتحاد الروسي'),
(52681, 3254886912, 3254887423, 'CH', 'CHE', 'سويسرا'),
(52682, 3254887424, 3254888191, 'GB', 'GBR', 'المملكة المتحدة'),
(52683, 3254888192, 3254888447, 'RO', 'ROM', 'رومانيا'),
(52684, 3254888704, 3254888959, 'RO', 'ROM', 'رومانيا'),
(52685, 3254889472, 3254890495, 'SK', 'SVK', 'سلوفاكيا'),
(52686, 3254890496, 3254890751, 'DE', 'DEU', 'ألمانيا'),
(52687, 3254890752, 3254891007, 'UA', 'UKR', 'أوكرانيا'),
(52688, 3254891008, 3254891519, 'RO', 'ROM', 'رومانيا'),
(52689, 3254891520, 3254891775, 'GB', 'GBR', 'المملكة المتحدة'),
(52690, 3254891776, 3254892031, 'DE', 'DEU', 'ألمانيا'),
(52691, 3254892032, 3254892287, 'GB', 'GBR', 'المملكة المتحدة'),
(52692, 3254892288, 3254892543, 'BE', 'BEL', 'بلجيكا'),
(52693, 3254892800, 3254893567, 'SK', 'SVK', 'سلوفاكيا'),
(52694, 3254894080, 3254894335, 'CH', 'CHE', 'سويسرا'),
(52695, 3254894336, 3254894591, 'SK', 'SVK', 'سلوفاكيا'),
(52696, 3254894592, 3254894847, 'DK', 'DNK', 'الدنيمارك'),
(52697, 3254894848, 3254895103, 'UA', 'UKR', 'أوكرانيا'),
(52698, 3254895104, 3254895359, 'GB', 'GBR', 'المملكة المتحدة'),
(52699, 3254895360, 3254895615, 'UA', 'UKR', 'أوكرانيا'),
(52700, 3254895616, 3254895871, 'PL', 'POL', 'بولندا'),
(52701, 3254895872, 3254896127, 'SE', 'SWE', 'السويد'),
(52702, 3254896128, 3254896383, 'RU', 'RUS', 'الإتحاد الروسي'),
(52703, 3254896384, 3254896639, 'PL', 'POL', 'بولندا'),
(52704, 3254896640, 3254896895, 'DK', 'DNK', 'الدنيمارك'),
(52705, 3254896896, 3254897151, 'PL', 'POL', 'بولندا'),
(52706, 3254897152, 3254897407, 'DE', 'DEU', 'ألمانيا'),
(52707, 3254897408, 3254897663, 'FR', 'FRA', 'فرنسا'),
(52708, 3254897664, 3254897919, 'NL', 'NLD', 'هولندا'),
(52709, 3254897920, 3254898175, 'BE', 'BEL', 'بلجيكا'),
(52710, 3254898176, 3254898431, 'AT', 'AUT', 'النمسا'),
(52711, 3254898432, 3254898687, 'DE', 'DEU', 'ألمانيا'),
(52712, 3254898688, 3254898943, 'IT', 'ITA', 'إيطاليا'),
(52713, 3254898944, 3254899199, 'EE', 'EST', 'إستونيا'),
(52714, 3254899200, 3254899455, 'GB', 'GBR', 'المملكة المتحدة'),
(52715, 3254899456, 3254899967, 'SE', 'SWE', 'السويد'),
(52716, 3254900480, 3254900991, 'SK', 'SVK', 'سلوفاكيا'),
(52717, 3254901248, 3254901503, 'SK', 'SVK', 'سلوفاكيا'),
(52718, 3254901760, 3254902271, 'UA', 'UKR', 'أوكرانيا'),
(52719, 3254902272, 3254904831, 'SK', 'SVK', 'سلوفاكيا'),
(52720, 3254907904, 3254908159, 'SK', 'SVK', 'سلوفاكيا'),
(52721, 3254908416, 3254908671, 'PL', 'POL', 'بولندا'),
(52722, 3254910720, 3254910975, 'HR', 'HRV', 'كرواتيا'),
(52723, 3254910976, 3254926279, 'FR', 'FRA', 'فرنسا'),
(52724, 3254926280, 3254926287, 'GB', 'GBR', 'المملكة المتحدة'),
(52725, 3254926288, 3254937999, 'FR', 'FRA', 'فرنسا'),
(52726, 3254938000, 3254938007, 'GB', 'GBR', 'المملكة المتحدة'),
(52727, 3254938008, 3254994734, 'FR', 'FRA', 'فرنسا'),
(52728, 3254994735, 3254994735, 'BE', 'BEL', 'بلجيكا'),
(52729, 3254994736, 3255017648, 'FR', 'FRA', 'فرنسا'),
(52730, 3255017649, 3255017649, 'LB', 'LBN', 'لبنان'),
(52731, 3255017650, 3255120639, 'FR', 'FRA', 'فرنسا'),
(52732, 3255120640, 3255120895, 'DE', 'DEU', 'ألمانيا'),
(52733, 3255120896, 3255123711, 'FR', 'FRA', 'فرنسا'),
(52734, 3255123712, 3255123967, 'DE', 'DEU', 'ألمانيا'),
(52735, 3255123968, 3255125759, 'FR', 'FRA', 'فرنسا'),
(52736, 3255126016, 3255172351, 'FR', 'FRA', 'فرنسا'),
(52737, 3255172352, 3255172607, 'DE', 'DEU', 'ألمانيا'),
(52738, 3255172608, 3255173119, 'FR', 'FRA', 'فرنسا'),
(52739, 3255173120, 3255173631, 'GB', 'GBR', 'المملكة المتحدة'),
(52740, 3255173648, 3255173711, 'GB', 'GBR', 'المملكة المتحدة'),
(52741, 3255173760, 3255173823, 'GB', 'GBR', 'المملكة المتحدة'),
(52742, 3255173840, 3255174151, 'GB', 'GBR', 'المملكة المتحدة'),
(52743, 3255174160, 3255174167, 'GB', 'GBR', 'المملكة المتحدة'),
(52744, 3255174200, 3255174207, 'GB', 'GBR', 'المملكة المتحدة'),
(52745, 3255174216, 3255174247, 'GB', 'GBR', 'المملكة المتحدة'),
(52746, 3255174272, 3255174279, 'GB', 'GBR', 'المملكة المتحدة'),
(52747, 3255174312, 3255174319, 'GB', 'GBR', 'المملكة المتحدة'),
(52748, 3255174328, 3255174335, 'GB', 'GBR', 'المملكة المتحدة'),
(52749, 3255174376, 3255174383, 'GB', 'GBR', 'المملكة المتحدة'),
(52750, 3255174400, 3255175167, 'GB', 'GBR', 'المملكة المتحدة'),
(52751, 3255175200, 3255175231, 'GB', 'GBR', 'المملكة المتحدة'),
(52752, 3255175248, 3255175263, 'GB', 'GBR', 'المملكة المتحدة'),
(52753, 3255175280, 3255175295, 'GB', 'GBR', 'المملكة المتحدة'),
(52754, 3255175312, 3255175327, 'GB', 'GBR', 'المملكة المتحدة'),
(52755, 3255175432, 3255175447, 'GB', 'GBR', 'المملكة المتحدة'),
(52756, 3255175456, 3255175503, 'GB', 'GBR', 'المملكة المتحدة'),
(52757, 3255175512, 3255175535, 'GB', 'GBR', 'المملكة المتحدة'),
(52758, 3255175552, 3255175559, 'GB', 'GBR', 'المملكة المتحدة'),
(52759, 3255175592, 3255175607, 'GB', 'GBR', 'المملكة المتحدة'),
(52760, 3255175680, 3255175935, 'GB', 'GBR', 'المملكة المتحدة'),
(52761, 3255176192, 3255177215, 'GB', 'GBR', 'المملكة المتحدة'),
(52762, 3255177472, 3255177855, 'GB', 'GBR', 'المملكة المتحدة'),
(52763, 3255177984, 3255187199, 'GB', 'GBR', 'المملكة المتحدة'),
(52764, 3255187200, 3255187455, 'DE', 'DEU', 'ألمانيا'),
(52765, 3255187456, 3255187711, 'GB', 'GBR', 'المملكة المتحدة'),
(52766, 3255188480, 3255191807, 'GB', 'GBR', 'المملكة المتحدة'),
(52767, 3255192320, 3255193863, 'GB', 'GBR', 'المملكة المتحدة'),
(52768, 3255193888, 3255193959, 'GB', 'GBR', 'المملكة المتحدة'),
(52769, 3255193968, 3255193975, 'GB', 'GBR', 'المملكة المتحدة'),
(52770, 3255193976, 3255193983, 'GI', 'GIB', 'جبل طارق'),
(52771, 3255193984, 3255193999, 'GB', 'GBR', 'المملكة المتحدة'),
(52772, 3255194016, 3255194039, 'GB', 'GBR', 'المملكة المتحدة'),
(52773, 3255194056, 3255194063, 'GB', 'GBR', 'المملكة المتحدة'),
(52774, 3255194072, 3255194431, 'GB', 'GBR', 'المملكة المتحدة'),
(52775, 3255194496, 3255194559, 'GB', 'GBR', 'المملكة المتحدة'),
(52776, 3255194624, 3255194703, 'GB', 'GBR', 'المملكة المتحدة'),
(52777, 3255194720, 3255194815, 'GB', 'GBR', 'المملكة المتحدة'),
(52778, 3255194880, 3255205887, 'GB', 'GBR', 'المملكة المتحدة'),
(52779, 3255205888, 3255214079, 'FR', 'FRA', 'فرنسا'),
(52780, 3255214080, 3255222271, 'CH', 'CHE', 'سويسرا'),
(52781, 3255222272, 3255223295, 'DE', 'DEU', 'ألمانيا'),
(52782, 3255224320, 3255225343, 'RO', 'ROM', 'رومانيا'),
(52783, 3255225344, 3255226367, 'PL', 'POL', 'بولندا'),
(52784, 3255226368, 3255227391, 'DE', 'DEU', 'ألمانيا'),
(52785, 3255227392, 3255228415, 'RO', 'ROM', 'رومانيا'),
(52786, 3255228416, 3255230463, 'RU', 'RUS', 'الإتحاد الروسي'),
(52787, 3255230720, 3255230975, 'PS', 'PSE', 'فلسطين المحتلة'),
(52788, 3255230976, 3255231231, 'DE', 'DEU', 'ألمانيا'),
(52789, 3255231232, 3255231487, 'BE', 'BEL', 'بلجيكا'),
(52790, 3255231488, 3255231743, 'DE', 'DEU', 'ألمانيا'),
(52791, 3255231744, 3255231999, 'PT', 'PRT', 'البورتوغال'),
(52792, 3255232000, 3255232255, 'RO', 'ROM', 'رومانيا'),
(52793, 3255232256, 3255233023, 'UA', 'UKR', 'أوكرانيا'),
(52794, 3255233024, 3255233279, 'DE', 'DEU', 'ألمانيا'),
(52795, 3255233280, 3255233535, 'GB', 'GBR', 'المملكة المتحدة'),
(52796, 3255233536, 3255233791, 'SE', 'SWE', 'السويد'),
(52797, 3255233792, 3255234047, 'SI', 'SVN', 'سلوفينيا'),
(52798, 3255234048, 3255234303, 'NO', 'NOR', 'النرويج'),
(52799, 3255234304, 3255234559, 'DE', 'DEU', 'ألمانيا'),
(52800, 3255234560, 3255234815, 'FR', 'FRA', 'فرنسا'),
(52801, 3255234816, 3255235071, 'PL', 'POL', 'بولندا'),
(52802, 3255235072, 3255235327, 'SI', 'SVN', 'سلوفينيا'),
(52803, 3255235328, 3255235583, 'SE', 'SWE', 'السويد'),
(52804, 3255235584, 3255235839, 'GB', 'GBR', 'المملكة المتحدة'),
(52805, 3255235840, 3255236351, 'PL', 'POL', 'بولندا'),
(52806, 3255236352, 3255236607, 'IT', 'ITA', 'إيطاليا'),
(52807, 3255236608, 3255236863, 'GB', 'GBR', 'المملكة المتحدة'),
(52808, 3255236864, 3255237119, 'DE', 'DEU', 'ألمانيا'),
(52809, 3255237120, 3255237375, 'AT', 'AUT', 'النمسا'),
(52810, 3255237376, 3255237887, 'SE', 'SWE', 'السويد'),
(52811, 3255237888, 3255238143, 'ES', 'ESP', 'إسبانيا'),
(52812, 3255238144, 3255238399, 'GB', 'GBR', 'المملكة المتحدة'),
(52813, 3255238400, 3255238655, 'QA', 'QAT', 'قطر'),
(52814, 3255238656, 3255243679, 'BE', 'BEL', 'بلجيكا'),
(52815, 3255243680, 3255243711, 'LU', 'LUX', 'لوكسيمبورغ'),
(52816, 3255243712, 3255245599, 'BE', 'BEL', 'بلجيكا'),
(52817, 3255245600, 3255245631, 'LU', 'LUX', 'لوكسيمبورغ'),
(52818, 3255245632, 3255245687, 'BE', 'BEL', 'بلجيكا'),
(52819, 3255245688, 3255245695, 'LU', 'LUX', 'لوكسيمبورغ'),
(52820, 3255245696, 3255247455, 'BE', 'BEL', 'بلجيكا'),
(52821, 3255247456, 3255247487, 'LU', 'LUX', 'لوكسيمبورغ'),
(52822, 3255247488, 3255247615, 'BE', 'BEL', 'بلجيكا'),
(52823, 3255247616, 3255247631, 'LU', 'LUX', 'لوكسيمبورغ'),
(52824, 3255247632, 3255247647, 'BE', 'BEL', 'بلجيكا'),
(52825, 3255247648, 3255247663, 'LU', 'LUX', 'لوكسيمبورغ'),
(52826, 3255247664, 3255248127, 'BE', 'BEL', 'بلجيكا'),
(52827, 3255248128, 3255248383, 'LU', 'LUX', 'لوكسيمبورغ'),
(52828, 3255248384, 3255248735, 'BE', 'BEL', 'بلجيكا'),
(52829, 3255248736, 3255248767, 'LU', 'LUX', 'لوكسيمبورغ'),
(52830, 3255248768, 3255249295, 'BE', 'BEL', 'بلجيكا'),
(52831, 3255249296, 3255249311, 'LU', 'LUX', 'لوكسيمبورغ'),
(52832, 3255249312, 3255249935, 'BE', 'BEL', 'بلجيكا'),
(52833, 3255249936, 3255249951, 'LU', 'LUX', 'لوكسيمبورغ'),
(52834, 3255249952, 3255250079, 'BE', 'BEL', 'بلجيكا'),
(52835, 3255250080, 3255250111, 'LU', 'LUX', 'لوكسيمبورغ'),
(52836, 3255250112, 3255252487, 'BE', 'BEL', 'بلجيكا'),
(52837, 3255252488, 3255252495, 'FR', 'FRA', 'فرنسا'),
(52838, 3255252496, 3255252527, 'BE', 'BEL', 'بلجيكا'),
(52839, 3255252528, 3255252543, 'LU', 'LUX', 'لوكسيمبورغ'),
(52840, 3255252544, 3255252559, 'BE', 'BEL', 'بلجيكا'),
(52841, 3255252560, 3255252575, 'LU', 'LUX', 'لوكسيمبورغ'),
(52842, 3255252576, 3255254847, 'BE', 'BEL', 'بلجيكا'),
(52843, 3255254848, 3255254879, 'LU', 'LUX', 'لوكسيمبورغ'),
(52844, 3255254880, 3255255559, 'BE', 'BEL', 'بلجيكا'),
(52845, 3255255560, 3255255567, 'LU', 'LUX', 'لوكسيمبورغ'),
(52846, 3255255568, 3255255599, 'BE', 'BEL', 'بلجيكا'),
(52847, 3255255600, 3255255607, 'LU', 'LUX', 'لوكسيمبورغ'),
(52848, 3255255608, 3255255711, 'BE', 'BEL', 'بلجيكا'),
(52849, 3255255712, 3255255743, 'LU', 'LUX', 'لوكسيمبورغ'),
(52850, 3255255744, 3255255751, 'BE', 'BEL', 'بلجيكا'),
(52851, 3255255752, 3255255759, 'DK', 'DNK', 'الدنيمارك'),
(52852, 3255255760, 3255256319, 'BE', 'BEL', 'بلجيكا'),
(52853, 3255256320, 3255256575, 'LU', 'LUX', 'لوكسيمبورغ'),
(52854, 3255256576, 3255259199, 'BE', 'BEL', 'بلجيكا'),
(52855, 3255259200, 3255259215, 'LU', 'LUX', 'لوكسيمبورغ'),
(52856, 3255259216, 3255259327, 'BE', 'BEL', 'بلجيكا'),
(52857, 3255259328, 3255259359, 'LU', 'LUX', 'لوكسيمبورغ'),
(52858, 3255259360, 3255259919, 'BE', 'BEL', 'بلجيكا'),
(52859, 3255259920, 3255259927, 'LU', 'LUX', 'لوكسيمبورغ'),
(52860, 3255259928, 3255260095, 'BE', 'BEL', 'بلجيكا'),
(52861, 3255260096, 3255260127, 'LU', 'LUX', 'لوكسيمبورغ'),
(52862, 3255260128, 3255260319, 'BE', 'BEL', 'بلجيكا'),
(52863, 3255260320, 3255260335, 'LU', 'LUX', 'لوكسيمبورغ'),
(52864, 3255260336, 3255260343, 'BE', 'BEL', 'بلجيكا'),
(52865, 3255260344, 3255260347, 'LU', 'LUX', 'لوكسيمبورغ'),
(52866, 3255260348, 3255261519, 'BE', 'BEL', 'بلجيكا'),
(52867, 3255261520, 3255261535, 'LU', 'LUX', 'لوكسيمبورغ'),
(52868, 3255261536, 3255262799, 'BE', 'BEL', 'بلجيكا'),
(52869, 3255262800, 3255262815, 'LU', 'LUX', 'لوكسيمبورغ'),
(52870, 3255262816, 3255263295, 'BE', 'BEL', 'بلجيكا'),
(52871, 3255263296, 3255263327, 'US', 'USA', 'الولايات المتحدة'),
(52872, 3255263328, 3255270431, 'BE', 'BEL', 'بلجيكا'),
(52873, 3255270432, 3255270463, 'FR', 'FRA', 'فرنسا'),
(52874, 3255270464, 3255273855, 'BE', 'BEL', 'بلجيكا'),
(52875, 3255273856, 3255273887, 'LU', 'LUX', 'لوكسيمبورغ'),
(52876, 3255273888, 3255274207, 'BE', 'BEL', 'بلجيكا'),
(52877, 3255274208, 3255274239, 'LU', 'LUX', 'لوكسيمبورغ'),
(52878, 3255274240, 3255274335, 'BE', 'BEL', 'بلجيكا'),
(52879, 3255274336, 3255274367, 'LU', 'LUX', 'لوكسيمبورغ'),
(52880, 3255274368, 3255274847, 'BE', 'BEL', 'بلجيكا'),
(52881, 3255274848, 3255274879, 'LU', 'LUX', 'لوكسيمبورغ'),
(52882, 3255274880, 3255274911, 'BE', 'BEL', 'بلجيكا'),
(52883, 3255274912, 3255274943, 'LU', 'LUX', 'لوكسيمبورغ'),
(52884, 3255274944, 3255276223, 'BE', 'BEL', 'بلجيكا'),
(52885, 3255276224, 3255276255, 'FR', 'FRA', 'فرنسا'),
(52886, 3255276256, 3255276575, 'BE', 'BEL', 'بلجيكا'),
(52887, 3255276576, 3255276607, 'LU', 'LUX', 'لوكسيمبورغ'),
(52888, 3255276608, 3255276671, 'BE', 'BEL', 'بلجيكا'),
(52889, 3255276672, 3255276703, 'LU', 'LUX', 'لوكسيمبورغ'),
(52890, 3255276704, 3255277955, 'BE', 'BEL', 'بلجيكا'),
(52891, 3255277956, 3255277959, 'LU', 'LUX', 'لوكسيمبورغ'),
(52892, 3255277960, 3255278719, 'BE', 'BEL', 'بلجيكا'),
(52893, 3255278720, 3255278751, 'LU', 'LUX', 'لوكسيمبورغ'),
(52894, 3255278752, 3255278855, 'BE', 'BEL', 'بلجيكا'),
(52895, 3255278856, 3255278863, 'DE', 'DEU', 'ألمانيا'),
(52896, 3255278864, 3255279007, 'BE', 'BEL', 'بلجيكا'),
(52897, 3255279008, 3255279039, 'LU', 'LUX', 'لوكسيمبورغ'),
(52898, 3255279040, 3255279087, 'BE', 'BEL', 'بلجيكا'),
(52899, 3255279088, 3255279103, 'LU', 'LUX', 'لوكسيمبورغ'),
(52900, 3255279104, 3255279639, 'BE', 'BEL', 'بلجيكا'),
(52901, 3255279640, 3255279647, 'LU', 'LUX', 'لوكسيمبورغ'),
(52902, 3255279648, 3255280031, 'BE', 'BEL', 'بلجيكا'),
(52903, 3255280032, 3255280039, 'LU', 'LUX', 'لوكسيمبورغ'),
(52904, 3255280040, 3255280047, 'BE', 'BEL', 'بلجيكا'),
(52905, 3255280048, 3255280055, 'LU', 'LUX', 'لوكسيمبورغ'),
(52906, 3255280056, 3255283927, 'BE', 'BEL', 'بلجيكا'),
(52907, 3255283928, 3255283931, 'LU', 'LUX', 'لوكسيمبورغ'),
(52908, 3255283932, 3255284239, 'BE', 'BEL', 'بلجيكا'),
(52909, 3255284240, 3255284255, 'LU', 'LUX', 'لوكسيمبورغ'),
(52910, 3255284256, 3255285535, 'BE', 'BEL', 'بلجيكا'),
(52911, 3255285536, 3255285567, 'LU', 'LUX', 'لوكسيمبورغ'),
(52912, 3255285568, 3255286095, 'BE', 'BEL', 'بلجيكا'),
(52913, 3255286096, 3255286103, 'DK', 'DNK', 'الدنيمارك'),
(52914, 3255286104, 3255286111, 'LU', 'LUX', 'لوكسيمبورغ'),
(52915, 3255286112, 3255286279, 'BE', 'BEL', 'بلجيكا'),
(52916, 3255286280, 3255286287, 'LU', 'LUX', 'لوكسيمبورغ'),
(52917, 3255286288, 3255288735, 'BE', 'BEL', 'بلجيكا'),
(52918, 3255288736, 3255288799, 'LU', 'LUX', 'لوكسيمبورغ'),
(52919, 3255288800, 3255288831, 'BE', 'BEL', 'بلجيكا'),
(52920, 3255288832, 3255289087, 'LU', 'LUX', 'لوكسيمبورغ'),
(52921, 3255289088, 3255290143, 'BE', 'BEL', 'بلجيكا'),
(52922, 3255290144, 3255290175, 'LU', 'LUX', 'لوكسيمبورغ'),
(52923, 3255290176, 3255290271, 'BE', 'BEL', 'بلجيكا'),
(52924, 3255290272, 3255290287, 'LU', 'LUX', 'لوكسيمبورغ'),
(52925, 3255290288, 3255290879, 'BE', 'BEL', 'بلجيكا'),
(52926, 3255290880, 3255291391, 'LU', 'LUX', 'لوكسيمبورغ'),
(52927, 3255291392, 3255291399, 'BE', 'BEL', 'بلجيكا'),
(52928, 3255291400, 3255291423, 'LU', 'LUX', 'لوكسيمبورغ'),
(52929, 3255291424, 3255291615, 'BE', 'BEL', 'بلجيكا'),
(52930, 3255291616, 3255291623, 'LU', 'LUX', 'لوكسيمبورغ'),
(52931, 3255291624, 3255291871, 'BE', 'BEL', 'بلجيكا'),
(52932, 3255291872, 3255291887, 'LU', 'LUX', 'لوكسيمبورغ'),
(52933, 3255291888, 3255291983, 'BE', 'BEL', 'بلجيكا'),
(52934, 3255291984, 3255291999, 'LU', 'LUX', 'لوكسيمبورغ'),
(52935, 3255292000, 3255292311, 'BE', 'BEL', 'بلجيكا'),
(52936, 3255292312, 3255292319, 'LU', 'LUX', 'لوكسيمبورغ'),
(52937, 3255292320, 3255297015, 'BE', 'BEL', 'بلجيكا'),
(52938, 3255297016, 3255297023, 'HU', 'HUN', 'هنغاريا'),
(52939, 3255297024, 3255300803, 'BE', 'BEL', 'بلجيكا'),
(52940, 3255300804, 3255300807, 'LU', 'LUX', 'لوكسيمبورغ'),
(52941, 3255300808, 3255304191, 'BE', 'BEL', 'بلجيكا'),
(52942, 3255304192, 3255304447, 'DE', 'DEU', 'ألمانيا'),
(52943, 3255304448, 3255305215, 'LV', 'LVA', 'لاتفيا'),
(52944, 3255305472, 3255307775, 'LV', 'LVA', 'لاتفيا'),
(52945, 3255307776, 3255308031, 'PL', 'POL', 'بولندا'),
(52946, 3255308032, 3255308287, 'CH', 'CHE', 'سويسرا'),
(52947, 3255308288, 3255311359, 'LV', 'LVA', 'لاتفيا'),
(52948, 3255311360, 3255311615, 'GB', 'GBR', 'المملكة المتحدة'),
(52949, 3255311616, 3255311871, 'SE', 'SWE', 'السويد'),
(52950, 3255311872, 3255312127, 'PT', 'PRT', 'البورتوغال'),
(52951, 3255312128, 3255312383, 'SE', 'SWE', 'السويد'),
(52952, 3255312384, 3255315455, 'LV', 'LVA', 'لاتفيا'),
(52953, 3255315712, 3255316223, 'PL', 'POL', 'بولندا'),
(52954, 3255316224, 3255316479, 'RU', 'RUS', 'الإتحاد الروسي'),
(52955, 3255316480, 3255316991, 'GB', 'GBR', 'المملكة المتحدة'),
(52956, 3255316992, 3255317247, 'FR', 'FRA', 'فرنسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(52957, 3255317248, 3255317503, 'UA', 'UKR', 'أوكرانيا'),
(52958, 3255317504, 3255317759, 'BE', 'BEL', 'بلجيكا'),
(52959, 3255317760, 3255318015, 'BG', 'BGR', 'بلغاريا'),
(52960, 3255318016, 3255318271, 'GB', 'GBR', 'المملكة المتحدة'),
(52961, 3255318272, 3255318527, 'RU', 'RUS', 'الإتحاد الروسي'),
(52962, 3255318528, 3255318783, 'UA', 'UKR', 'أوكرانيا'),
(52963, 3255318784, 3255319295, 'DE', 'DEU', 'ألمانيا'),
(52964, 3255319296, 3255319551, 'UA', 'UKR', 'أوكرانيا'),
(52965, 3255319552, 3255319807, 'BG', 'BGR', 'بلغاريا'),
(52966, 3255319808, 3255320063, 'AT', 'AUT', 'النمسا'),
(52967, 3255320064, 3255320319, 'BE', 'BEL', 'بلجيكا'),
(52968, 3255320320, 3255320575, 'AT', 'AUT', 'النمسا'),
(52969, 3255320576, 3255321087, 'UA', 'UKR', 'أوكرانيا'),
(52970, 3255321088, 3255322111, 'PL', 'POL', 'بولندا'),
(52971, 3255322112, 3255323135, 'RU', 'RUS', 'الإتحاد الروسي'),
(52972, 3255323136, 3255323647, 'GB', 'GBR', 'المملكة المتحدة'),
(52973, 3255323648, 3255324159, 'IL', 'ISR', 'إسرائيل'),
(52974, 3255324160, 3255324671, 'CH', 'CHE', 'سويسرا'),
(52975, 3255324672, 3255325695, 'RO', 'ROM', 'رومانيا'),
(52976, 3255325696, 3255326207, 'RU', 'RUS', 'الإتحاد الروسي'),
(52977, 3255326208, 3255326719, 'DE', 'DEU', 'ألمانيا'),
(52978, 3255326720, 3255327231, 'IL', 'ISR', 'إسرائيل'),
(52979, 3255327232, 3255327743, 'DE', 'DEU', 'ألمانيا'),
(52980, 3255327744, 3255328255, 'SE', 'SWE', 'السويد'),
(52981, 3255328256, 3255328767, 'SI', 'SVN', 'سلوفينيا'),
(52982, 3255328768, 3255336959, 'DE', 'DEU', 'ألمانيا'),
(52983, 3255336960, 3255341055, 'RU', 'RUS', 'الإتحاد الروسي'),
(52984, 3255341056, 3255342079, 'UA', 'UKR', 'أوكرانيا'),
(52985, 3255343104, 3255344127, 'RU', 'RUS', 'الإتحاد الروسي'),
(52986, 3255344128, 3255345151, 'UA', 'UKR', 'أوكرانيا'),
(52987, 3255345152, 3255353343, 'RU', 'RUS', 'الإتحاد الروسي'),
(52988, 3255353344, 3255361535, 'DE', 'DEU', 'ألمانيا'),
(52989, 3255361536, 3255362047, 'RU', 'RUS', 'الإتحاد الروسي'),
(52990, 3255362048, 3255362559, 'FI', 'FIN', 'فنلندا'),
(52991, 3255362560, 3255364607, 'RU', 'RUS', 'الإتحاد الروسي'),
(52992, 3255364608, 3255365119, 'NL', 'NLD', 'هولندا'),
(52993, 3255365120, 3255365631, 'SK', 'SVK', 'سلوفاكيا'),
(52994, 3255365632, 3255366143, 'UA', 'UKR', 'أوكرانيا'),
(52995, 3255366144, 3255366655, 'DK', 'DNK', 'الدنيمارك'),
(52996, 3255369728, 3255370239, 'LU', 'LUX', 'لوكسيمبورغ'),
(52997, 3255370240, 3255370751, 'RU', 'RUS', 'الإتحاد الروسي'),
(52998, 3255370752, 3255371263, 'DE', 'DEU', 'ألمانيا'),
(52999, 3255371264, 3255371775, 'BG', 'BGR', 'بلغاريا'),
(53000, 3255371776, 3255372287, 'SE', 'SWE', 'السويد'),
(53001, 3255372288, 3255372799, 'DE', 'DEU', 'ألمانيا'),
(53002, 3255372800, 3255373311, 'MC', 'MCO', 'موناكو'),
(53003, 3255373312, 3255373823, 'UA', 'UKR', 'أوكرانيا'),
(53004, 3255373824, 3255374335, 'PL', 'POL', 'بولندا'),
(53005, 3255374336, 3255374847, 'RU', 'RUS', 'الإتحاد الروسي'),
(53006, 3255374848, 3255375359, 'CY', 'CYP', 'قبرص'),
(53007, 3255375360, 3255375871, 'RO', 'ROM', 'رومانيا'),
(53008, 3255375872, 3255376383, 'PL', 'POL', 'بولندا'),
(53009, 3255376384, 3255376895, 'UA', 'UKR', 'أوكرانيا'),
(53010, 3255376896, 3255377407, 'GB', 'GBR', 'المملكة المتحدة'),
(53011, 3255377408, 3255377919, 'KZ', 'KAZ', 'كازاخستان'),
(53012, 3255377920, 3255378431, 'GB', 'GBR', 'المملكة المتحدة'),
(53013, 3255378432, 3255378943, 'CH', 'CHE', 'سويسرا'),
(53014, 3255378944, 3255379455, 'UA', 'UKR', 'أوكرانيا'),
(53015, 3255379456, 3255379967, 'RU', 'RUS', 'الإتحاد الروسي'),
(53016, 3255379968, 3255380479, 'GB', 'GBR', 'المملكة المتحدة'),
(53017, 3255380480, 3255380991, 'NL', 'NLD', 'هولندا'),
(53018, 3255380992, 3255381503, 'CH', 'CHE', 'سويسرا'),
(53019, 3255381504, 3255382015, 'PL', 'POL', 'بولندا'),
(53020, 3255382016, 3255382527, 'NL', 'NLD', 'هولندا'),
(53021, 3255382528, 3255383039, 'UA', 'UKR', 'أوكرانيا'),
(53022, 3255383040, 3255383551, 'PL', 'POL', 'بولندا'),
(53023, 3255383552, 3255384063, 'CH', 'CHE', 'سويسرا'),
(53024, 3255384064, 3255384575, 'RO', 'ROM', 'رومانيا'),
(53025, 3255384576, 3255385087, 'AT', 'AUT', 'النمسا'),
(53026, 3255385088, 3255385599, 'RO', 'ROM', 'رومانيا'),
(53027, 3255385600, 3255386111, 'FR', 'FRA', 'فرنسا'),
(53028, 3255386624, 3255387135, 'PL', 'POL', 'بولندا'),
(53029, 3255387136, 3255388159, 'UA', 'UKR', 'أوكرانيا'),
(53030, 3255388160, 3255388671, 'DE', 'DEU', 'ألمانيا'),
(53031, 3255388672, 3255389183, 'SE', 'SWE', 'السويد'),
(53032, 3255389184, 3255389695, 'GB', 'GBR', 'المملكة المتحدة'),
(53033, 3255389696, 3255390207, 'PL', 'POL', 'بولندا'),
(53034, 3255390208, 3255390719, 'GB', 'GBR', 'المملكة المتحدة'),
(53035, 3255391232, 3255391743, 'NL', 'NLD', 'هولندا'),
(53036, 3255391744, 3255392767, 'DE', 'DEU', 'ألمانيا'),
(53037, 3255392768, 3255393791, 'RO', 'ROM', 'رومانيا'),
(53038, 3255393792, 3255399679, 'SE', 'SWE', 'السويد'),
(53039, 3255399680, 3255400447, 'DE', 'DEU', 'ألمانيا'),
(53040, 3255400448, 3255401471, 'CH', 'CHE', 'سويسرا'),
(53041, 3255401472, 3255412479, 'DE', 'DEU', 'ألمانيا'),
(53042, 3255412480, 3255412735, 'RO', 'ROM', 'رومانيا'),
(53043, 3255412736, 3255413247, 'DE', 'DEU', 'ألمانيا'),
(53044, 3255413248, 3255413759, 'LV', 'LVA', 'لاتفيا'),
(53045, 3255413760, 3255414271, 'GB', 'GBR', 'المملكة المتحدة'),
(53046, 3255414272, 3255414527, 'TR', 'TUR', 'تركيا'),
(53047, 3255414528, 3255414783, 'LV', 'LVA', 'لاتفيا'),
(53048, 3255414784, 3255415807, 'BE', 'BEL', 'بلجيكا'),
(53049, 3255415808, 3255416319, 'AT', 'AUT', 'النمسا'),
(53050, 3255416320, 3255416831, 'DE', 'DEU', 'ألمانيا'),
(53051, 3255416832, 3255417855, 'FR', 'FRA', 'فرنسا'),
(53052, 3255417856, 3255418879, 'GB', 'GBR', 'المملكة المتحدة'),
(53053, 3255418880, 3255422975, 'DE', 'DEU', 'ألمانيا'),
(53054, 3255422976, 3255426047, 'GB', 'GBR', 'المملكة المتحدة'),
(53055, 3255426048, 3255426559, 'IT', 'ITA', 'إيطاليا'),
(53056, 3255426560, 3255426815, 'FR', 'FRA', 'فرنسا'),
(53057, 3255426816, 3255427071, 'PL', 'POL', 'بولندا'),
(53058, 3255427072, 3255431167, 'RU', 'RUS', 'الإتحاد الروسي'),
(53059, 3255431168, 3255436543, 'GB', 'GBR', 'المملكة المتحدة'),
(53060, 3255436544, 3255436799, 'NL', 'NLD', 'هولندا'),
(53061, 3255436800, 3255437055, 'DE', 'DEU', 'ألمانيا'),
(53062, 3255437056, 3255437311, 'GB', 'GBR', 'المملكة المتحدة'),
(53063, 3255446528, 3255446783, 'GB', 'GBR', 'المملكة المتحدة'),
(53064, 3255449600, 3255450111, 'BE', 'BEL', 'بلجيكا'),
(53065, 3255450112, 3255450367, 'GB', 'GBR', 'المملكة المتحدة'),
(53066, 3255450368, 3255450623, 'FR', 'FRA', 'فرنسا'),
(53067, 3255450624, 3255451135, 'DE', 'DEU', 'ألمانيا'),
(53068, 3255451136, 3255452671, 'FR', 'FRA', 'فرنسا'),
(53069, 3255468032, 3255468543, 'GB', 'GBR', 'المملكة المتحدة'),
(53070, 3255469056, 3255469567, 'GB', 'GBR', 'المملكة المتحدة'),
(53071, 3255469568, 3255469823, 'DE', 'DEU', 'ألمانيا'),
(53072, 3255469824, 3255470079, 'DK', 'DNK', 'الدنيمارك'),
(53073, 3255470080, 3255470591, 'AT', 'AUT', 'النمسا'),
(53074, 3255470592, 3255470847, 'DE', 'DEU', 'ألمانيا'),
(53075, 3255470848, 3255471103, 'HU', 'HUN', 'هنغاريا'),
(53076, 3255471104, 3255471359, 'BE', 'BEL', 'بلجيكا'),
(53077, 3255471616, 3255471871, 'GB', 'GBR', 'المملكة المتحدة'),
(53078, 3255471872, 3255472127, 'BE', 'BEL', 'بلجيكا'),
(53079, 3255472128, 3255472383, 'GB', 'GBR', 'المملكة المتحدة'),
(53080, 3255472384, 3255472639, 'BE', 'BEL', 'بلجيكا'),
(53081, 3255472640, 3255472895, 'NL', 'NLD', 'هولندا'),
(53082, 3255472896, 3255473151, 'BE', 'BEL', 'بلجيكا'),
(53083, 3255473152, 3255473407, 'GB', 'GBR', 'المملكة المتحدة'),
(53084, 3255473408, 3255473663, 'CH', 'CHE', 'سويسرا'),
(53085, 3255473664, 3255473919, 'BE', 'BEL', 'بلجيكا'),
(53086, 3255473920, 3255474175, 'NO', 'NOR', 'النرويج'),
(53087, 3255474176, 3255476735, 'GB', 'GBR', 'المملكة المتحدة'),
(53088, 3255476736, 3255476991, 'IE', 'IRL', 'إيرلندا'),
(53089, 3255476992, 3255477247, 'NL', 'NLD', 'هولندا'),
(53090, 3255477248, 3255477503, 'GB', 'GBR', 'المملكة المتحدة'),
(53091, 3255477504, 3255477759, 'CH', 'CHE', 'سويسرا'),
(53092, 3255477760, 3255478271, 'GB', 'GBR', 'المملكة المتحدة'),
(53093, 3255482368, 3255482623, 'GB', 'GBR', 'المملكة المتحدة'),
(53094, 3255482624, 3255482815, 'BE', 'BEL', 'بلجيكا'),
(53095, 3255482816, 3255482831, 'FR', 'FRA', 'فرنسا'),
(53096, 3255482832, 3255482839, 'BE', 'BEL', 'بلجيكا'),
(53097, 3255482840, 3255482847, 'FR', 'FRA', 'فرنسا'),
(53098, 3255482848, 3255482871, 'BE', 'BEL', 'بلجيكا'),
(53099, 3255482880, 3255483135, 'GB', 'GBR', 'المملكة المتحدة'),
(53100, 3255483136, 3255484415, 'DE', 'DEU', 'ألمانيا'),
(53101, 3255484416, 3255484671, 'PL', 'POL', 'بولندا'),
(53102, 3255484672, 3255484927, 'NL', 'NLD', 'هولندا'),
(53103, 3255484928, 3255485183, 'CH', 'CHE', 'سويسرا'),
(53104, 3255485184, 3255485439, 'AT', 'AUT', 'النمسا'),
(53105, 3255485440, 3255486463, 'FR', 'FRA', 'فرنسا'),
(53106, 3255486464, 3255486719, 'BE', 'BEL', 'بلجيكا'),
(53107, 3255486976, 3255487487, 'GB', 'GBR', 'المملكة المتحدة'),
(53108, 3255487488, 3255487743, 'BE', 'BEL', 'بلجيكا'),
(53109, 3255487744, 3255487999, 'GB', 'GBR', 'المملكة المتحدة'),
(53110, 3255488000, 3255488255, 'BE', 'BEL', 'بلجيكا'),
(53111, 3255488256, 3255488511, 'GB', 'GBR', 'المملكة المتحدة'),
(53112, 3255488512, 3255489535, 'AT', 'AUT', 'النمسا'),
(53113, 3255489536, 3255489887, 'DE', 'DEU', 'ألمانيا'),
(53114, 3255489888, 3255490047, 'GB', 'GBR', 'المملكة المتحدة'),
(53115, 3255490048, 3255490559, 'DE', 'DEU', 'ألمانيا'),
(53116, 3255492608, 3255496703, 'GB', 'GBR', 'المملكة المتحدة'),
(53117, 3255497728, 3255497983, 'BE', 'BEL', 'بلجيكا'),
(53118, 3255497984, 3255498239, 'DE', 'DEU', 'ألمانيا'),
(53119, 3255498240, 3255498495, 'FR', 'FRA', 'فرنسا'),
(53120, 3255498496, 3255498751, 'GB', 'GBR', 'المملكة المتحدة'),
(53121, 3255498752, 3255500799, 'FR', 'FRA', 'فرنسا'),
(53122, 3255500800, 3255504895, 'CH', 'CHE', 'سويسرا'),
(53123, 3255504896, 3255505151, 'RU', 'RUS', 'الإتحاد الروسي'),
(53124, 3255505152, 3255505919, 'GB', 'GBR', 'المملكة المتحدة'),
(53125, 3255505920, 3255506431, 'RU', 'RUS', 'الإتحاد الروسي'),
(53126, 3255506432, 3255506687, 'PL', 'POL', 'بولندا'),
(53127, 3255506688, 3255506943, 'PT', 'PRT', 'البورتوغال'),
(53128, 3255506944, 3255507199, 'PL', 'POL', 'بولندا'),
(53129, 3255507200, 3255507455, 'PT', 'PRT', 'البورتوغال'),
(53130, 3255507456, 3255507711, 'FR', 'FRA', 'فرنسا'),
(53131, 3255507712, 3255507967, 'AT', 'AUT', 'النمسا'),
(53132, 3255507968, 3255508223, 'UA', 'UKR', 'أوكرانيا'),
(53133, 3255508224, 3255508479, 'RU', 'RUS', 'الإتحاد الروسي'),
(53134, 3255508480, 3255544319, 'CH', 'CHE', 'سويسرا'),
(53135, 3255544320, 3255544575, 'DE', 'DEU', 'ألمانيا'),
(53136, 3255544576, 3255544831, 'AT', 'AUT', 'النمسا'),
(53137, 3255544832, 3255551999, 'CH', 'CHE', 'سويسرا'),
(53138, 3255552000, 3255552511, 'DE', 'DEU', 'ألمانيا'),
(53139, 3255552512, 3255558143, 'CH', 'CHE', 'سويسرا'),
(53140, 3255558144, 3255558399, 'BE', 'BEL', 'بلجيكا'),
(53141, 3255558400, 3255564031, 'CH', 'CHE', 'سويسرا'),
(53142, 3255564032, 3255564287, 'RU', 'RUS', 'الإتحاد الروسي'),
(53143, 3255564288, 3255565823, 'CH', 'CHE', 'سويسرا'),
(53144, 3255565824, 3255566079, 'DE', 'DEU', 'ألمانيا'),
(53145, 3255566080, 3255566335, 'CH', 'CHE', 'سويسرا'),
(53146, 3255566336, 3255574527, 'SE', 'SWE', 'السويد'),
(53147, 3255578624, 3255582719, 'SE', 'SWE', 'السويد'),
(53148, 3255599104, 3255615487, 'CH', 'CHE', 'سويسرا'),
(53149, 3255615488, 3255623679, 'DE', 'DEU', 'ألمانيا'),
(53150, 3255623680, 3255631871, 'BG', 'BGR', 'بلغاريا'),
(53151, 3255631872, 3255660287, 'NL', 'NLD', 'هولندا'),
(53152, 3255660288, 3255660543, 'GR', 'GRC', 'اليونان'),
(53153, 3255660544, 3255666431, 'NL', 'NLD', 'هولندا'),
(53154, 3255666432, 3255666687, 'DE', 'DEU', 'ألمانيا'),
(53155, 3255667200, 3255667455, 'NL', 'NLD', 'هولندا'),
(53156, 3255667712, 3255697407, 'NL', 'NLD', 'هولندا'),
(53157, 3255697408, 3255745535, 'SE', 'SWE', 'السويد'),
(53158, 3255745536, 3255746047, 'DK', 'DNK', 'الدنيمارك'),
(53159, 3255746048, 3255762943, 'SE', 'SWE', 'السويد'),
(53160, 3255762944, 3255799039, 'DE', 'DEU', 'ألمانيا'),
(53161, 3255799040, 3255799295, 'SE', 'SWE', 'السويد'),
(53162, 3255799296, 3255800575, 'DE', 'DEU', 'ألمانيا'),
(53163, 3255800576, 3255800831, 'UA', 'UKR', 'أوكرانيا'),
(53164, 3255800832, 3255817215, 'DE', 'DEU', 'ألمانيا'),
(53165, 3255817216, 3255817471, 'SE', 'SWE', 'السويد'),
(53166, 3255817472, 3255817727, 'ES', 'ESP', 'إسبانيا'),
(53167, 3255817728, 3255821311, 'DE', 'DEU', 'ألمانيا'),
(53168, 3255821312, 3255821823, 'CH', 'CHE', 'سويسرا'),
(53169, 3255821824, 3255822079, 'DE', 'DEU', 'ألمانيا'),
(53170, 3255822080, 3255822335, 'CH', 'CHE', 'سويسرا'),
(53171, 3255822336, 3255828479, 'DE', 'DEU', 'ألمانيا'),
(53172, 3255828480, 3255851311, 'SE', 'SWE', 'السويد'),
(53173, 3255851312, 3255851315, 'DK', 'DNK', 'الدنيمارك'),
(53174, 3255851316, 3255909183, 'SE', 'SWE', 'السويد'),
(53175, 3255909184, 3255909191, 'DK', 'DNK', 'الدنيمارك'),
(53176, 3255909192, 3256025087, 'SE', 'SWE', 'السويد'),
(53177, 3256025088, 3256057855, 'NO', 'NOR', 'النرويج'),
(53178, 3256057856, 3256074751, 'DK', 'DNK', 'الدنيمارك'),
(53179, 3256074752, 3256075007, 'SE', 'SWE', 'السويد'),
(53180, 3256075008, 3256076287, 'DK', 'DNK', 'الدنيمارك'),
(53181, 3256076288, 3256076799, 'SE', 'SWE', 'السويد'),
(53182, 3256076800, 3256082431, 'DK', 'DNK', 'الدنيمارك'),
(53183, 3256082432, 3256090623, 'LV', 'LVA', 'لاتفيا'),
(53184, 3256090624, 3256164863, 'IT', 'ITA', 'إيطاليا'),
(53185, 3256164864, 3256165375, 'SE', 'SWE', 'السويد'),
(53186, 3256165376, 3256187391, 'IT', 'ITA', 'إيطاليا'),
(53187, 3256187392, 3256187647, 'SM', 'SMR', 'سان مارينو'),
(53188, 3256187648, 3256221695, 'IT', 'ITA', 'إيطاليا'),
(53189, 3256221696, 3256222207, 'SE', 'SWE', 'السويد'),
(53190, 3256222208, 3256222463, 'NL', 'NLD', 'هولندا'),
(53191, 3256222464, 3256223743, 'SE', 'SWE', 'السويد'),
(53192, 3256223744, 3256226047, 'NL', 'NLD', 'هولندا'),
(53193, 3256226048, 3256229887, 'SE', 'SWE', 'السويد'),
(53194, 3256229888, 3256233983, 'DE', 'DEU', 'ألمانيا'),
(53195, 3256233984, 3256238079, 'SE', 'SWE', 'السويد'),
(53196, 3256238080, 3256246271, 'NO', 'NOR', 'النرويج'),
(53197, 3256246272, 3256345343, 'SE', 'SWE', 'السويد'),
(53198, 3256345344, 3256345599, 'DE', 'DEU', 'ألمانيا'),
(53199, 3256345600, 3256352767, 'SE', 'SWE', 'السويد'),
(53200, 3256352768, 3256385535, 'CH', 'CHE', 'سويسرا'),
(53201, 3256385536, 3256393727, 'AT', 'AUT', 'النمسا'),
(53202, 3256393728, 3256394239, 'DE', 'DEU', 'ألمانيا'),
(53203, 3256394240, 3256394751, 'UA', 'UKR', 'أوكرانيا'),
(53204, 3256394752, 3256395263, 'PL', 'POL', 'بولندا'),
(53205, 3256395264, 3256395775, 'GB', 'GBR', 'المملكة المتحدة'),
(53206, 3256395776, 3256396287, 'TR', 'TUR', 'تركيا'),
(53207, 3256396288, 3256396799, 'GR', 'GRC', 'اليونان'),
(53208, 3256396800, 3256397311, 'DE', 'DEU', 'ألمانيا'),
(53209, 3256397312, 3256397823, 'PL', 'POL', 'بولندا'),
(53210, 3256397824, 3256398847, 'RO', 'ROM', 'رومانيا'),
(53211, 3256398848, 3256399359, 'PL', 'POL', 'بولندا'),
(53212, 3256399360, 3256400895, 'UA', 'UKR', 'أوكرانيا'),
(53213, 3256400896, 3256401407, 'GB', 'GBR', 'المملكة المتحدة'),
(53214, 3256401408, 3256401919, 'UA', 'UKR', 'أوكرانيا'),
(53215, 3256401920, 3256410111, 'DE', 'DEU', 'ألمانيا'),
(53216, 3256410112, 3256410623, 'TR', 'TUR', 'تركيا'),
(53217, 3256410624, 3256411135, 'GR', 'GRC', 'اليونان'),
(53218, 3256411136, 3256411647, 'FR', 'FRA', 'فرنسا'),
(53219, 3256411648, 3256412159, 'DE', 'DEU', 'ألمانيا'),
(53220, 3256412160, 3256412671, 'GB', 'GBR', 'المملكة المتحدة'),
(53221, 3256412672, 3256413183, 'RO', 'ROM', 'رومانيا'),
(53222, 3256413184, 3256413695, 'UA', 'UKR', 'أوكرانيا'),
(53223, 3256413696, 3256414207, 'PL', 'POL', 'بولندا'),
(53224, 3256414208, 3256414719, 'RU', 'RUS', 'الإتحاد الروسي'),
(53225, 3256414720, 3256415231, 'DE', 'DEU', 'ألمانيا'),
(53226, 3256415232, 3256415743, 'PL', 'POL', 'بولندا'),
(53227, 3256415744, 3256416255, 'UA', 'UKR', 'أوكرانيا'),
(53228, 3256416768, 3256417279, 'GB', 'GBR', 'المملكة المتحدة'),
(53229, 3256417280, 3256417791, 'NO', 'NOR', 'النرويج'),
(53230, 3256417792, 3256418303, 'GB', 'GBR', 'المملكة المتحدة'),
(53231, 3256418304, 3256427503, 'DE', 'DEU', 'ألمانيا'),
(53232, 3256427504, 3256427511, 'GB', 'GBR', 'المملكة المتحدة'),
(53233, 3256427512, 3256443727, 'DE', 'DEU', 'ألمانيا'),
(53234, 3256443728, 3256443735, 'GB', 'GBR', 'المملكة المتحدة'),
(53235, 3256443736, 3256446855, 'DE', 'DEU', 'ألمانيا'),
(53236, 3256446856, 3256446863, 'US', 'USA', 'الولايات المتحدة'),
(53237, 3256446864, 3256448575, 'DE', 'DEU', 'ألمانيا'),
(53238, 3256448576, 3256448591, 'ES', 'ESP', 'إسبانيا'),
(53239, 3256448592, 3256448935, 'DE', 'DEU', 'ألمانيا'),
(53240, 3256448936, 3256448943, 'IT', 'ITA', 'إيطاليا'),
(53241, 3256448944, 3256452063, 'DE', 'DEU', 'ألمانيا'),
(53242, 3256452064, 3256452071, 'BE', 'BEL', 'بلجيكا'),
(53243, 3256452072, 3256483839, 'DE', 'DEU', 'ألمانيا'),
(53244, 3256483840, 3256487151, 'NL', 'NLD', 'هولندا'),
(53245, 3256487152, 3256487159, 'FR', 'FRA', 'فرنسا'),
(53246, 3256487160, 3256489471, 'NL', 'NLD', 'هولندا'),
(53247, 3256489472, 3256489983, 'GR', 'GRC', 'اليونان'),
(53248, 3256489984, 3256490239, 'BE', 'BEL', 'بلجيكا'),
(53249, 3256490240, 3256490495, 'DE', 'DEU', 'ألمانيا'),
(53250, 3256490496, 3256513023, 'NL', 'NLD', 'هولندا'),
(53251, 3256513024, 3256513279, 'GB', 'GBR', 'المملكة المتحدة'),
(53252, 3256513280, 3256513791, 'NL', 'NLD', 'هولندا'),
(53253, 3256513792, 3256514047, 'GB', 'GBR', 'المملكة المتحدة'),
(53254, 3256514048, 3256524287, 'NL', 'NLD', 'هولندا'),
(53255, 3256524288, 3256524799, 'DE', 'DEU', 'ألمانيا'),
(53256, 3256524800, 3256528895, 'NL', 'NLD', 'هولندا'),
(53257, 3256528896, 3256530943, 'DE', 'DEU', 'ألمانيا'),
(53258, 3256530944, 3256549375, 'NL', 'NLD', 'هولندا'),
(53259, 3256549376, 3256614911, 'TR', 'TUR', 'تركيا'),
(53260, 3256614912, 3256615935, 'FI', 'FIN', 'فنلندا'),
(53261, 3256615936, 3256616959, 'UA', 'UKR', 'أوكرانيا'),
(53262, 3256616960, 3256617983, 'GB', 'GBR', 'المملكة المتحدة'),
(53263, 3256617984, 3256619007, 'PL', 'POL', 'بولندا'),
(53264, 3256619008, 3256620031, 'UA', 'UKR', 'أوكرانيا'),
(53265, 3256620032, 3256621055, 'RU', 'RUS', 'الإتحاد الروسي'),
(53266, 3256621056, 3256622079, 'DK', 'DNK', 'الدنيمارك'),
(53267, 3256680448, 3256688639, 'CH', 'CHE', 'سويسرا'),
(53268, 3256688640, 3256692735, 'IL', 'ISR', 'إسرائيل'),
(53269, 3256692736, 3256693759, 'GR', 'GRC', 'اليونان'),
(53270, 3256693760, 3256694783, 'IT', 'ITA', 'إيطاليا'),
(53271, 3256694784, 3256695807, 'CH', 'CHE', 'سويسرا'),
(53272, 3256695808, 3256696831, 'UA', 'UKR', 'أوكرانيا'),
(53273, 3256696832, 3256697599, 'BE', 'BEL', 'بلجيكا'),
(53274, 3256697600, 3256697855, 'GB', 'GBR', 'المملكة المتحدة'),
(53275, 3256697856, 3256698367, 'IT', 'ITA', 'إيطاليا'),
(53276, 3256698368, 3256698623, 'NL', 'NLD', 'هولندا'),
(53277, 3256698624, 3256698879, 'GB', 'GBR', 'المملكة المتحدة'),
(53278, 3256698880, 3256699135, 'DE', 'DEU', 'ألمانيا'),
(53279, 3256699136, 3256699391, 'NL', 'NLD', 'هولندا'),
(53280, 3256699392, 3256699903, 'GB', 'GBR', 'المملكة المتحدة'),
(53281, 3256701184, 3256701439, 'BE', 'BEL', 'بلجيكا'),
(53282, 3256701440, 3256701695, 'GB', 'GBR', 'المملكة المتحدة'),
(53283, 3256705280, 3256705791, 'BE', 'BEL', 'بلجيكا'),
(53284, 3256705792, 3256706047, 'AT', 'AUT', 'النمسا'),
(53285, 3256706048, 3256706559, 'GR', 'GRC', 'اليونان'),
(53286, 3256709632, 3256709887, 'AT', 'AUT', 'النمسا'),
(53287, 3256710144, 3256710655, 'AT', 'AUT', 'النمسا'),
(53288, 3256710656, 3256711167, 'SE', 'SWE', 'السويد'),
(53289, 3256711168, 3256711423, 'DE', 'DEU', 'ألمانيا'),
(53290, 3256713216, 3256727551, 'PL', 'POL', 'بولندا'),
(53291, 3256727552, 3256728575, 'UA', 'UKR', 'أوكرانيا'),
(53292, 3256728576, 3256729599, 'DE', 'DEU', 'ألمانيا'),
(53293, 3256729600, 3256731647, 'FI', 'FIN', 'فنلندا'),
(53294, 3256731648, 3256732671, 'NO', 'NOR', 'النرويج'),
(53295, 3256732672, 3256732927, 'IT', 'ITA', 'إيطاليا'),
(53296, 3256732928, 3256733183, 'UA', 'UKR', 'أوكرانيا'),
(53297, 3256733184, 3256733439, 'FR', 'FRA', 'فرنسا'),
(53298, 3256733440, 3256733695, 'DK', 'DNK', 'الدنيمارك'),
(53299, 3256733696, 3256735743, 'TR', 'TUR', 'تركيا'),
(53300, 3256735744, 3256737791, 'GB', 'GBR', 'المملكة المتحدة'),
(53301, 3256737792, 3256745983, 'DE', 'DEU', 'ألمانيا'),
(53302, 3256745984, 3256778751, 'ES', 'ESP', 'إسبانيا'),
(53303, 3256778752, 3256786943, 'CY', 'CYP', 'قبرص'),
(53304, 3256786944, 3256787199, 'NL', 'NLD', 'هولندا'),
(53305, 3256787200, 3256787455, 'RO', 'ROM', 'رومانيا'),
(53306, 3256787456, 3256787711, 'DE', 'DEU', 'ألمانيا'),
(53307, 3256787712, 3256787967, 'UA', 'UKR', 'أوكرانيا'),
(53308, 3256787968, 3256788223, 'PL', 'POL', 'بولندا'),
(53309, 3256788224, 3256788479, 'RU', 'RUS', 'الإتحاد الروسي'),
(53310, 3256788480, 3256788735, 'GB', 'GBR', 'المملكة المتحدة'),
(53311, 3256788736, 3256788991, 'DE', 'DEU', 'ألمانيا'),
(53312, 3256788992, 3256789247, 'UA', 'UKR', 'أوكرانيا'),
(53313, 3256789248, 3256789503, 'SE', 'SWE', 'السويد'),
(53314, 3256789504, 3256789759, 'UA', 'UKR', 'أوكرانيا'),
(53315, 3256789760, 3256790015, 'GB', 'GBR', 'المملكة المتحدة'),
(53316, 3256790016, 3256790271, 'UA', 'UKR', 'أوكرانيا'),
(53317, 3256790272, 3256790783, 'DE', 'DEU', 'ألمانيا'),
(53318, 3256790784, 3256791039, 'NL', 'NLD', 'هولندا'),
(53319, 3256791040, 3256791295, 'CH', 'CHE', 'سويسرا'),
(53320, 3256791296, 3256791551, 'RO', 'ROM', 'رومانيا'),
(53321, 3256791552, 3256791807, 'DE', 'DEU', 'ألمانيا'),
(53322, 3256791808, 3256792063, 'PL', 'POL', 'بولندا'),
(53323, 3256792064, 3256792319, 'DE', 'DEU', 'ألمانيا'),
(53324, 3256792320, 3256792575, 'CH', 'CHE', 'سويسرا'),
(53325, 3256792576, 3256792831, 'NL', 'NLD', 'هولندا'),
(53326, 3256792832, 3256793087, 'DE', 'DEU', 'ألمانيا'),
(53327, 3256793088, 3256793343, 'GB', 'GBR', 'المملكة المتحدة'),
(53328, 3256793344, 3256793599, 'DE', 'DEU', 'ألمانيا'),
(53329, 3256793600, 3256793855, 'GB', 'GBR', 'المملكة المتحدة'),
(53330, 3256793856, 3256794111, 'SK', 'SVK', 'سلوفاكيا'),
(53331, 3256794112, 3256794367, 'NL', 'NLD', 'هولندا'),
(53332, 3256794368, 3256794623, 'DK', 'DNK', 'الدنيمارك'),
(53333, 3256794624, 3256794879, 'RU', 'RUS', 'الإتحاد الروسي'),
(53334, 3256794880, 3256795135, 'AT', 'AUT', 'النمسا'),
(53335, 3256795136, 3256811519, 'GR', 'GRC', 'اليونان'),
(53336, 3256811520, 3256813055, 'DE', 'DEU', 'ألمانيا'),
(53337, 3256813568, 3256819711, 'DE', 'DEU', 'ألمانيا'),
(53338, 3256827904, 3256864511, 'DE', 'DEU', 'ألمانيا'),
(53339, 3256864512, 3256864767, 'CH', 'CHE', 'سويسرا'),
(53340, 3256864768, 3256869631, 'DE', 'DEU', 'ألمانيا'),
(53341, 3256869888, 3256870911, 'DE', 'DEU', 'ألمانيا'),
(53342, 3256871168, 3256871935, 'DE', 'DEU', 'ألمانيا'),
(53343, 3256872448, 3256877055, 'DE', 'DEU', 'ألمانيا'),
(53344, 3256877056, 3256898559, 'GB', 'GBR', 'المملكة المتحدة'),
(53345, 3256899584, 3256915455, 'GB', 'GBR', 'المملكة المتحدة'),
(53346, 3256915456, 3256915967, 'SE', 'SWE', 'السويد'),
(53347, 3256915968, 3256945663, 'GB', 'GBR', 'المملكة المتحدة'),
(53348, 3256945664, 3256945919, 'UA', 'UKR', 'أوكرانيا'),
(53349, 3256945920, 3256946175, 'GB', 'GBR', 'المملكة المتحدة'),
(53350, 3256946176, 3256946431, 'RO', 'ROM', 'رومانيا'),
(53351, 3256946432, 3256946687, 'UA', 'UKR', 'أوكرانيا'),
(53352, 3256946688, 3256946943, 'GB', 'GBR', 'المملكة المتحدة'),
(53353, 3256946944, 3256947711, 'DE', 'DEU', 'ألمانيا'),
(53354, 3256947712, 3256988671, 'GB', 'GBR', 'المملكة المتحدة'),
(53355, 3256988672, 3256989183, 'UA', 'UKR', 'أوكرانيا'),
(53356, 3256989184, 3256989439, 'FR', 'FRA', 'فرنسا'),
(53357, 3256989440, 3256989695, 'GB', 'GBR', 'المملكة المتحدة'),
(53358, 3256989696, 3256989951, 'HU', 'HUN', 'هنغاريا'),
(53359, 3256989952, 3256990207, 'PL', 'POL', 'بولندا'),
(53360, 3256990208, 3256990463, 'CH', 'CHE', 'سويسرا'),
(53361, 3256990464, 3256990719, 'PL', 'POL', 'بولندا'),
(53362, 3256990720, 3256991231, 'UA', 'UKR', 'أوكرانيا'),
(53363, 3256991232, 3256991487, 'SE', 'SWE', 'السويد'),
(53364, 3256991488, 3256991743, 'RU', 'RUS', 'الإتحاد الروسي'),
(53365, 3256991744, 3257011199, 'GB', 'GBR', 'المملكة المتحدة'),
(53366, 3257011200, 3257011455, 'BG', 'BGR', 'بلغاريا'),
(53367, 3257011456, 3257058815, 'GB', 'GBR', 'المملكة المتحدة'),
(53368, 3257058816, 3257059071, 'PL', 'POL', 'بولندا'),
(53369, 3257059072, 3257077503, 'GB', 'GBR', 'المملكة المتحدة'),
(53370, 3257077760, 3257087487, 'GB', 'GBR', 'المملكة المتحدة'),
(53371, 3257087744, 3257139199, 'GB', 'GBR', 'المملكة المتحدة'),
(53372, 3257139456, 3257143295, 'GB', 'GBR', 'المملكة المتحدة'),
(53373, 3257144576, 3257144831, 'GB', 'GBR', 'المملكة المتحدة'),
(53374, 3257144832, 3257145087, 'FR', 'FRA', 'فرنسا'),
(53375, 3257145088, 3257160703, 'GB', 'GBR', 'المملكة المتحدة'),
(53376, 3257161728, 3257180159, 'GB', 'GBR', 'المملكة المتحدة'),
(53377, 3257180160, 3257180415, 'TR', 'TUR', 'تركيا'),
(53378, 3257180416, 3257180671, 'RU', 'RUS', 'الإتحاد الروسي'),
(53379, 3257180672, 3257180927, 'EE', 'EST', 'إستونيا'),
(53380, 3257180928, 3257181183, 'GB', 'GBR', 'المملكة المتحدة'),
(53381, 3257181184, 3257181439, 'SA', 'SAU', 'السعودية'),
(53382, 3257181440, 3257181695, 'PL', 'POL', 'بولندا'),
(53383, 3257181696, 3257181951, 'FR', 'FRA', 'فرنسا'),
(53384, 3257181952, 3257182207, 'BG', 'BGR', 'بلغاريا'),
(53385, 3257182208, 3257182463, 'PL', 'POL', 'بولندا'),
(53386, 3257182464, 3257196543, 'GB', 'GBR', 'المملكة المتحدة'),
(53387, 3257196544, 3257200639, 'LU', 'LUX', 'لوكسيمبورغ'),
(53388, 3257200640, 3257204735, 'GB', 'GBR', 'المملكة المتحدة'),
(53389, 3257204736, 3257268223, 'AT', 'AUT', 'النمسا'),
(53390, 3257268224, 3257268479, 'UA', 'UKR', 'أوكرانيا'),
(53391, 3257268480, 3257268735, 'SE', 'SWE', 'السويد'),
(53392, 3257268736, 3257269247, 'AT', 'AUT', 'النمسا'),
(53393, 3257269248, 3257269503, 'IT', 'ITA', 'إيطاليا'),
(53394, 3257269504, 3257270015, 'AT', 'AUT', 'النمسا'),
(53395, 3257270016, 3257270271, 'DE', 'DEU', 'ألمانيا'),
(53396, 3257270272, 3257286655, 'SE', 'SWE', 'السويد'),
(53397, 3257286656, 3257294847, 'CH', 'CHE', 'سويسرا'),
(53398, 3257294848, 3257303039, 'HU', 'HUN', 'هنغاريا'),
(53399, 3257303040, 3257311231, 'PT', 'PRT', 'البورتوغال'),
(53400, 3257311232, 3257311903, 'CH', 'CHE', 'سويسرا'),
(53401, 3257311904, 3257311911, 'ES', 'ESP', 'إسبانيا'),
(53402, 3257311912, 3257335807, 'CH', 'CHE', 'سويسرا'),
(53403, 3257335808, 3257357311, 'DE', 'DEU', 'ألمانيا'),
(53404, 3257357312, 3257357567, 'PT', 'PRT', 'البورتوغال'),
(53405, 3257357568, 3257357823, 'SI', 'SVN', 'سلوفينيا'),
(53406, 3257357824, 3257371903, 'DE', 'DEU', 'ألمانيا'),
(53407, 3257371904, 3257372159, 'BE', 'BEL', 'بلجيكا'),
(53408, 3257372160, 3257372671, 'GB', 'GBR', 'المملكة المتحدة'),
(53409, 3257372672, 3257383679, 'DE', 'DEU', 'ألمانيا'),
(53410, 3257383680, 3257383935, 'CH', 'CHE', 'سويسرا'),
(53411, 3257383936, 3257388799, 'DE', 'DEU', 'ألمانيا'),
(53412, 3257388800, 3257389055, 'FR', 'FRA', 'فرنسا'),
(53413, 3257389056, 3257401343, 'DE', 'DEU', 'ألمانيا'),
(53414, 3257401344, 3257466879, 'CH', 'CHE', 'سويسرا'),
(53415, 3257466880, 3257467135, 'DE', 'DEU', 'ألمانيا'),
(53416, 3257467136, 3257467391, 'GB', 'GBR', 'المملكة المتحدة'),
(53417, 3257467904, 3257468927, 'IT', 'ITA', 'إيطاليا'),
(53418, 3257469184, 3257469439, 'IT', 'ITA', 'إيطاليا'),
(53419, 3257469440, 3257469951, 'GB', 'GBR', 'المملكة المتحدة'),
(53420, 3257469952, 3257470975, 'BE', 'BEL', 'بلجيكا'),
(53421, 3257470976, 3257475071, 'FI', 'FIN', 'فنلندا'),
(53422, 3257475072, 3257475327, 'ES', 'ESP', 'إسبانيا'),
(53423, 3257475328, 3257475583, 'FI', 'FIN', 'فنلندا'),
(53424, 3257475584, 3257476095, 'DE', 'DEU', 'ألمانيا'),
(53425, 3257476352, 3257477119, 'DE', 'DEU', 'ألمانيا'),
(53426, 3257477120, 3257477375, 'NL', 'NLD', 'هولندا'),
(53427, 3257477376, 3257477887, 'SE', 'SWE', 'السويد'),
(53428, 3257477888, 3257480447, 'GB', 'GBR', 'المملكة المتحدة'),
(53429, 3257480448, 3257480959, 'NL', 'NLD', 'هولندا'),
(53430, 3257480960, 3257481215, 'SE', 'SWE', 'السويد'),
(53431, 3257481216, 3257481471, 'GB', 'GBR', 'المملكة المتحدة'),
(53432, 3257481472, 3257481727, 'DE', 'DEU', 'ألمانيا'),
(53433, 3257481728, 3257481983, 'FI', 'FIN', 'فنلندا'),
(53434, 3257481984, 3257482239, 'FR', 'FRA', 'فرنسا'),
(53435, 3257482752, 3257483007, 'NL', 'NLD', 'هولندا'),
(53436, 3257483008, 3257491455, 'CH', 'CHE', 'سويسرا'),
(53437, 3257491456, 3257495551, 'BE', 'BEL', 'بلجيكا'),
(53438, 3257495552, 3257497855, 'CH', 'CHE', 'سويسرا'),
(53439, 3257497856, 3257499647, 'NL', 'NLD', 'هولندا'),
(53440, 3257499648, 3257525495, 'CH', 'CHE', 'سويسرا'),
(53441, 3257525496, 3257525503, 'DK', 'DNK', 'الدنيمارك'),
(53442, 3257525504, 3257532415, 'CH', 'CHE', 'سويسرا'),
(53443, 3257532416, 3257542655, 'CY', 'CYP', 'قبرص'),
(53444, 3257542656, 3257542911, 'PL', 'POL', 'بولندا'),
(53445, 3257542912, 3257543423, 'IT', 'ITA', 'إيطاليا'),
(53446, 3257543424, 3257543679, 'PT', 'PRT', 'البورتوغال'),
(53447, 3257543680, 3257544191, 'RO', 'ROM', 'رومانيا'),
(53448, 3257544192, 3257544447, 'DE', 'DEU', 'ألمانيا'),
(53449, 3257544448, 3257544575, 'DK', 'DNK', 'الدنيمارك'),
(53450, 3257544576, 3257544703, 'DE', 'DEU', 'ألمانيا'),
(53451, 3257544704, 3257544959, 'CH', 'CHE', 'سويسرا'),
(53452, 3257544960, 3257545215, 'DK', 'DNK', 'الدنيمارك'),
(53453, 3257545216, 3257546495, 'GR', 'GRC', 'اليونان'),
(53454, 3257546496, 3257546527, 'DE', 'DEU', 'ألمانيا'),
(53455, 3257546528, 3257546623, 'CH', 'CHE', 'سويسرا'),
(53456, 3257546624, 3257546655, 'ES', 'ESP', 'إسبانيا'),
(53457, 3257546656, 3257546687, 'SE', 'SWE', 'السويد'),
(53458, 3257546688, 3257546719, 'DE', 'DEU', 'ألمانيا'),
(53459, 3257546720, 3257546751, 'DK', 'DNK', 'الدنيمارك'),
(53460, 3257546752, 3257548799, 'FI', 'FIN', 'فنلندا'),
(53461, 3257548800, 3257549055, 'DE', 'DEU', 'ألمانيا'),
(53462, 3257549056, 3257549343, 'GB', 'GBR', 'المملكة المتحدة'),
(53463, 3257549344, 3257549359, 'DE', 'DEU', 'ألمانيا'),
(53464, 3257549360, 3257549375, 'GB', 'GBR', 'المملكة المتحدة'),
(53465, 3257549376, 3257549423, 'DE', 'DEU', 'ألمانيا'),
(53466, 3257549424, 3257549567, 'GB', 'GBR', 'المملكة المتحدة'),
(53467, 3257549568, 3257549695, 'DE', 'DEU', 'ألمانيا'),
(53468, 3257549696, 3257549823, 'GB', 'GBR', 'المملكة المتحدة'),
(53469, 3257549824, 3257549871, 'DE', 'DEU', 'ألمانيا'),
(53470, 3257549872, 3257549951, 'GB', 'GBR', 'المملكة المتحدة'),
(53471, 3257549952, 3257550095, 'DE', 'DEU', 'ألمانيا'),
(53472, 3257550096, 3257550847, 'GB', 'GBR', 'المملكة المتحدة'),
(53473, 3257550848, 3257551103, 'DE', 'DEU', 'ألمانيا'),
(53474, 3257551104, 3257551631, 'GB', 'GBR', 'المملكة المتحدة'),
(53475, 3257551632, 3257551647, 'DE', 'DEU', 'ألمانيا'),
(53476, 3257551648, 3257551711, 'GB', 'GBR', 'المملكة المتحدة'),
(53477, 3257551712, 3257551807, 'DE', 'DEU', 'ألمانيا'),
(53478, 3257551808, 3257551871, 'GB', 'GBR', 'المملكة المتحدة'),
(53479, 3257551872, 3257552383, 'DE', 'DEU', 'ألمانيا'),
(53480, 3257552384, 3257552607, 'GB', 'GBR', 'المملكة المتحدة'),
(53481, 3257552608, 3257552655, 'DE', 'DEU', 'ألمانيا'),
(53482, 3257552656, 3257552703, 'GB', 'GBR', 'المملكة المتحدة'),
(53483, 3257552704, 3257552719, 'DE', 'DEU', 'ألمانيا'),
(53484, 3257552720, 3257552895, 'GB', 'GBR', 'المملكة المتحدة'),
(53485, 3257552896, 3257552959, 'DE', 'DEU', 'ألمانيا'),
(53486, 3257552960, 3257553023, 'GB', 'GBR', 'المملكة المتحدة'),
(53487, 3257553024, 3257553039, 'DE', 'DEU', 'ألمانيا'),
(53488, 3257553040, 3257553407, 'GB', 'GBR', 'المملكة المتحدة'),
(53489, 3257553408, 3257553727, 'DE', 'DEU', 'ألمانيا'),
(53490, 3257553728, 3257553791, 'GB', 'GBR', 'المملكة المتحدة'),
(53491, 3257553792, 3257553807, 'DE', 'DEU', 'ألمانيا'),
(53492, 3257553808, 3257553823, 'GB', 'GBR', 'المملكة المتحدة'),
(53493, 3257553824, 3257553839, 'DE', 'DEU', 'ألمانيا'),
(53494, 3257553840, 3257553855, 'GB', 'GBR', 'المملكة المتحدة'),
(53495, 3257553856, 3257553919, 'DE', 'DEU', 'ألمانيا'),
(53496, 3257553920, 3257554175, 'GB', 'GBR', 'المملكة المتحدة'),
(53497, 3257554176, 3257554207, 'DE', 'DEU', 'ألمانيا'),
(53498, 3257554208, 3257554239, 'GB', 'GBR', 'المملكة المتحدة'),
(53499, 3257554240, 3257554271, 'DE', 'DEU', 'ألمانيا'),
(53500, 3257554272, 3257554335, 'GB', 'GBR', 'المملكة المتحدة'),
(53501, 3257554336, 3257554351, 'DE', 'DEU', 'ألمانيا'),
(53502, 3257554352, 3257554415, 'GB', 'GBR', 'المملكة المتحدة'),
(53503, 3257554416, 3257554943, 'DE', 'DEU', 'ألمانيا'),
(53504, 3257554944, 3257555007, 'GB', 'GBR', 'المملكة المتحدة'),
(53505, 3257555008, 3257555039, 'DE', 'DEU', 'ألمانيا'),
(53506, 3257555040, 3257555167, 'GB', 'GBR', 'المملكة المتحدة'),
(53507, 3257555168, 3257555199, 'DE', 'DEU', 'ألمانيا'),
(53508, 3257555200, 3257555247, 'GB', 'GBR', 'المملكة المتحدة'),
(53509, 3257555248, 3257555263, 'DE', 'DEU', 'ألمانيا'),
(53510, 3257555264, 3257555327, 'GB', 'GBR', 'المملكة المتحدة'),
(53511, 3257555328, 3257555359, 'DE', 'DEU', 'ألمانيا'),
(53512, 3257555360, 3257555391, 'GB', 'GBR', 'المملكة المتحدة'),
(53513, 3257555392, 3257555471, 'DE', 'DEU', 'ألمانيا'),
(53514, 3257555472, 3257555583, 'GB', 'GBR', 'المملكة المتحدة'),
(53515, 3257555584, 3257555695, 'DE', 'DEU', 'ألمانيا'),
(53516, 3257555696, 3257555711, 'GB', 'GBR', 'المملكة المتحدة'),
(53517, 3257555712, 3257555775, 'DE', 'DEU', 'ألمانيا'),
(53518, 3257555776, 3257555839, 'GB', 'GBR', 'المملكة المتحدة'),
(53519, 3257555840, 3257555887, 'DE', 'DEU', 'ألمانيا'),
(53520, 3257555888, 3257555903, 'GB', 'GBR', 'المملكة المتحدة'),
(53521, 3257555904, 3257555935, 'DE', 'DEU', 'ألمانيا'),
(53522, 3257555936, 3257556223, 'GB', 'GBR', 'المملكة المتحدة'),
(53523, 3257556224, 3257556287, 'DE', 'DEU', 'ألمانيا'),
(53524, 3257556288, 3257556479, 'GB', 'GBR', 'المملكة المتحدة'),
(53525, 3257556480, 3257556991, 'DE', 'DEU', 'ألمانيا'),
(53526, 3257556992, 3257557503, 'MW', 'MWI', 'ملاوي'),
(53527, 3257557504, 3257558015, 'LU', 'LUX', 'لوكسيمبورغ'),
(53528, 3257558016, 3257559551, 'RO', 'ROM', 'رومانيا'),
(53529, 3257559552, 3257560063, 'UA', 'UKR', 'أوكرانيا'),
(53530, 3257560064, 3257560575, 'DE', 'DEU', 'ألمانيا'),
(53531, 3257560576, 3257561087, 'PL', 'POL', 'بولندا'),
(53532, 3257561600, 3257562111, 'DE', 'DEU', 'ألمانيا'),
(53533, 3257562112, 3257563647, 'PL', 'POL', 'بولندا'),
(53534, 3257564160, 3257564671, 'GB', 'GBR', 'المملكة المتحدة'),
(53535, 3257564672, 3257565183, 'RO', 'ROM', 'رومانيا'),
(53536, 3257565184, 3257570303, 'CY', 'CYP', 'قبرص'),
(53537, 3257570304, 3257570307, 'GR', 'GRC', 'اليونان'),
(53538, 3257570308, 3257570311, 'CY', 'CYP', 'قبرص'),
(53539, 3257570312, 3257570327, 'GR', 'GRC', 'اليونان'),
(53540, 3257570328, 3257570367, 'CY', 'CYP', 'قبرص'),
(53541, 3257570368, 3257570431, 'GR', 'GRC', 'اليونان'),
(53542, 3257570432, 3257570495, 'CY', 'CYP', 'قبرص'),
(53543, 3257570496, 3257570527, 'GR', 'GRC', 'اليونان'),
(53544, 3257570528, 3257573375, 'CY', 'CYP', 'قبرص'),
(53545, 3257573376, 3257574015, 'CH', 'CHE', 'سويسرا'),
(53546, 3257574016, 3257574143, 'BE', 'BEL', 'بلجيكا'),
(53547, 3257574144, 3257574399, 'GB', 'GBR', 'المملكة المتحدة'),
(53548, 3257574400, 3257574655, 'IT', 'ITA', 'إيطاليا'),
(53549, 3257574656, 3257576191, 'BE', 'BEL', 'بلجيكا'),
(53550, 3257576192, 3257577471, 'AT', 'AUT', 'النمسا'),
(53551, 3257577472, 3257581567, 'DE', 'DEU', 'ألمانيا'),
(53552, 3257581568, 3257585663, 'UA', 'UKR', 'أوكرانيا'),
(53553, 3257585664, 3257586175, 'BE', 'BEL', 'بلجيكا'),
(53554, 3257586176, 3257586687, 'NL', 'NLD', 'هولندا'),
(53555, 3257586688, 3257586943, 'LU', 'LUX', 'لوكسيمبورغ'),
(53556, 3257586944, 3257587455, 'ES', 'ESP', 'إسبانيا'),
(53557, 3257587456, 3257587711, 'GB', 'GBR', 'المملكة المتحدة'),
(53558, 3257587712, 3257587967, 'US', 'USA', 'الولايات المتحدة'),
(53559, 3257587968, 3257588223, 'FR', 'FRA', 'فرنسا'),
(53560, 3257588224, 3257588735, 'BE', 'BEL', 'بلجيكا'),
(53561, 3257588736, 3257589759, 'NL', 'NLD', 'هولندا'),
(53562, 3257589760, 3257663487, 'GB', 'GBR', 'المملكة المتحدة'),
(53563, 3257663488, 3257729023, 'UA', 'UKR', 'أوكرانيا'),
(53564, 3257729024, 3257731071, 'DE', 'DEU', 'ألمانيا'),
(53565, 3257731072, 3257731567, 'NL', 'NLD', 'هولندا'),
(53566, 3257731568, 3257731575, 'DE', 'DEU', 'ألمانيا'),
(53567, 3257731576, 3257732095, 'NL', 'NLD', 'هولندا'),
(53568, 3257732096, 3257732607, 'DE', 'DEU', 'ألمانيا'),
(53569, 3257732608, 3257732727, 'NL', 'NLD', 'هولندا'),
(53570, 3257732728, 3257732735, 'DE', 'DEU', 'ألمانيا'),
(53571, 3257732736, 3257734143, 'NL', 'NLD', 'هولندا'),
(53572, 3257734144, 3257736191, 'DE', 'DEU', 'ألمانيا'),
(53573, 3257736192, 3257737119, 'NL', 'NLD', 'هولندا'),
(53574, 3257737120, 3257737127, 'DE', 'DEU', 'ألمانيا'),
(53575, 3257737128, 3257737471, 'NL', 'NLD', 'هولندا'),
(53576, 3257737472, 3257743615, 'DE', 'DEU', 'ألمانيا'),
(53577, 3257743616, 3257743623, 'NL', 'NLD', 'هولندا'),
(53578, 3257743624, 3257743631, 'DE', 'DEU', 'ألمانيا'),
(53579, 3257743632, 3257743951, 'NL', 'NLD', 'هولندا'),
(53580, 3257743952, 3257743959, 'DE', 'DEU', 'ألمانيا'),
(53581, 3257743960, 3257744111, 'NL', 'NLD', 'هولندا'),
(53582, 3257744112, 3257744119, 'DE', 'DEU', 'ألمانيا'),
(53583, 3257744120, 3257744671, 'NL', 'NLD', 'هولندا'),
(53584, 3257744672, 3257744679, 'DE', 'DEU', 'ألمانيا'),
(53585, 3257744680, 3257744871, 'NL', 'NLD', 'هولندا'),
(53586, 3257744872, 3257744879, 'DE', 'DEU', 'ألمانيا'),
(53587, 3257744880, 3257745119, 'NL', 'NLD', 'هولندا'),
(53588, 3257745120, 3257745127, 'DE', 'DEU', 'ألمانيا'),
(53589, 3257745128, 3257746527, 'NL', 'NLD', 'هولندا'),
(53590, 3257746528, 3257746535, 'DE', 'DEU', 'ألمانيا'),
(53591, 3257746536, 3257746647, 'NL', 'NLD', 'هولندا'),
(53592, 3257746648, 3257746655, 'DE', 'DEU', 'ألمانيا'),
(53593, 3257746656, 3257746671, 'NL', 'NLD', 'هولندا'),
(53594, 3257746672, 3257746679, 'DE', 'DEU', 'ألمانيا'),
(53595, 3257746680, 3257746919, 'NL', 'NLD', 'هولندا'),
(53596, 3257746920, 3257746927, 'DE', 'DEU', 'ألمانيا'),
(53597, 3257746928, 3257746943, 'NL', 'NLD', 'هولندا'),
(53598, 3257746944, 3257747455, 'DE', 'DEU', 'ألمانيا'),
(53599, 3257747456, 3257747471, 'NL', 'NLD', 'هولندا'),
(53600, 3257747472, 3257747479, 'DE', 'DEU', 'ألمانيا'),
(53601, 3257747480, 3257747607, 'NL', 'NLD', 'هولندا'),
(53602, 3257747608, 3257747615, 'DE', 'DEU', 'ألمانيا'),
(53603, 3257747616, 3257747655, 'NL', 'NLD', 'هولندا'),
(53604, 3257747656, 3257747663, 'DE', 'DEU', 'ألمانيا'),
(53605, 3257747664, 3257747847, 'NL', 'NLD', 'هولندا'),
(53606, 3257747848, 3257747855, 'DE', 'DEU', 'ألمانيا'),
(53607, 3257747856, 3257748015, 'NL', 'NLD', 'هولندا'),
(53608, 3257748016, 3257748023, 'DE', 'DEU', 'ألمانيا'),
(53609, 3257748024, 3257748063, 'NL', 'NLD', 'هولندا'),
(53610, 3257748064, 3257748071, 'DE', 'DEU', 'ألمانيا'),
(53611, 3257748072, 3257748455, 'NL', 'NLD', 'هولندا'),
(53612, 3257748456, 3257748463, 'DE', 'DEU', 'ألمانيا'),
(53613, 3257748464, 3257748479, 'NL', 'NLD', 'هولندا'),
(53614, 3257748480, 3257749503, 'DE', 'DEU', 'ألمانيا'),
(53615, 3257749504, 3257749663, 'NL', 'NLD', 'هولندا'),
(53616, 3257749664, 3257749671, 'DE', 'DEU', 'ألمانيا'),
(53617, 3257749672, 3257749679, 'NL', 'NLD', 'هولندا'),
(53618, 3257749680, 3257749687, 'DE', 'DEU', 'ألمانيا'),
(53619, 3257749688, 3257749743, 'NL', 'NLD', 'هولندا'),
(53620, 3257749744, 3257749751, 'DE', 'DEU', 'ألمانيا'),
(53621, 3257749752, 3257749759, 'NL', 'NLD', 'هولندا'),
(53622, 3257749760, 3257749767, 'DE', 'DEU', 'ألمانيا'),
(53623, 3257749768, 3257749783, 'NL', 'NLD', 'هولندا'),
(53624, 3257749784, 3257749791, 'DE', 'DEU', 'ألمانيا'),
(53625, 3257749792, 3257749863, 'NL', 'NLD', 'هولندا'),
(53626, 3257749864, 3257749871, 'DE', 'DEU', 'ألمانيا'),
(53627, 3257749872, 3257749943, 'NL', 'NLD', 'هولندا'),
(53628, 3257749944, 3257749951, 'DE', 'DEU', 'ألمانيا'),
(53629, 3257749952, 3257750015, 'NL', 'NLD', 'هولندا'),
(53630, 3257750016, 3257750023, 'DE', 'DEU', 'ألمانيا'),
(53631, 3257750024, 3257750071, 'NL', 'NLD', 'هولندا'),
(53632, 3257750072, 3257750079, 'DE', 'DEU', 'ألمانيا'),
(53633, 3257750080, 3257750151, 'NL', 'NLD', 'هولندا'),
(53634, 3257750152, 3257750159, 'DE', 'DEU', 'ألمانيا'),
(53635, 3257750160, 3257750231, 'NL', 'NLD', 'هولندا'),
(53636, 3257750232, 3257750239, 'DE', 'DEU', 'ألمانيا'),
(53637, 3257750240, 3257750359, 'NL', 'NLD', 'هولندا'),
(53638, 3257750360, 3257750367, 'DE', 'DEU', 'ألمانيا'),
(53639, 3257750368, 3257750471, 'NL', 'NLD', 'هولندا'),
(53640, 3257750472, 3257750479, 'DE', 'DEU', 'ألمانيا'),
(53641, 3257750480, 3257750615, 'NL', 'NLD', 'هولندا'),
(53642, 3257750616, 3257750623, 'DE', 'DEU', 'ألمانيا'),
(53643, 3257750624, 3257750631, 'NL', 'NLD', 'هولندا'),
(53644, 3257750632, 3257750639, 'DE', 'DEU', 'ألمانيا'),
(53645, 3257750640, 3257750655, 'NL', 'NLD', 'هولندا'),
(53646, 3257750656, 3257750663, 'DE', 'DEU', 'ألمانيا'),
(53647, 3257750664, 3257750671, 'NL', 'NLD', 'هولندا'),
(53648, 3257750672, 3257750679, 'DE', 'DEU', 'ألمانيا'),
(53649, 3257750680, 3257750735, 'NL', 'NLD', 'هولندا'),
(53650, 3257750736, 3257750743, 'DE', 'DEU', 'ألمانيا'),
(53651, 3257750744, 3257750759, 'NL', 'NLD', 'هولندا'),
(53652, 3257750760, 3257750767, 'DE', 'DEU', 'ألمانيا'),
(53653, 3257750768, 3257750919, 'NL', 'NLD', 'هولندا'),
(53654, 3257750920, 3257750935, 'DE', 'DEU', 'ألمانيا'),
(53655, 3257750936, 3257751031, 'NL', 'NLD', 'هولندا'),
(53656, 3257751032, 3257751039, 'DE', 'DEU', 'ألمانيا'),
(53657, 3257751040, 3257751199, 'NL', 'NLD', 'هولندا'),
(53658, 3257751200, 3257751207, 'DE', 'DEU', 'ألمانيا'),
(53659, 3257751208, 3257751215, 'NL', 'NLD', 'هولندا'),
(53660, 3257751216, 3257751223, 'DE', 'DEU', 'ألمانيا'),
(53661, 3257751224, 3257751247, 'NL', 'NLD', 'هولندا'),
(53662, 3257751248, 3257751263, 'DE', 'DEU', 'ألمانيا'),
(53663, 3257751264, 3257751279, 'NL', 'NLD', 'هولندا'),
(53664, 3257751280, 3257751287, 'DE', 'DEU', 'ألمانيا'),
(53665, 3257751288, 3257751351, 'NL', 'NLD', 'هولندا'),
(53666, 3257751352, 3257751359, 'DE', 'DEU', 'ألمانيا'),
(53667, 3257751360, 3257751623, 'NL', 'NLD', 'هولندا'),
(53668, 3257751624, 3257751631, 'DE', 'DEU', 'ألمانيا'),
(53669, 3257751632, 3257751639, 'NL', 'NLD', 'هولندا'),
(53670, 3257751640, 3257751647, 'DE', 'DEU', 'ألمانيا'),
(53671, 3257751648, 3257751711, 'NL', 'NLD', 'هولندا'),
(53672, 3257751712, 3257751719, 'DE', 'DEU', 'ألمانيا'),
(53673, 3257751720, 3257751823, 'NL', 'NLD', 'هولندا'),
(53674, 3257751824, 3257751831, 'DE', 'DEU', 'ألمانيا'),
(53675, 3257751832, 3257751871, 'NL', 'NLD', 'هولندا'),
(53676, 3257751872, 3257751887, 'DE', 'DEU', 'ألمانيا'),
(53677, 3257751888, 3257751903, 'NL', 'NLD', 'هولندا'),
(53678, 3257751904, 3257751911, 'DE', 'DEU', 'ألمانيا'),
(53679, 3257751912, 3257751975, 'NL', 'NLD', 'هولندا'),
(53680, 3257751976, 3257751983, 'DE', 'DEU', 'ألمانيا'),
(53681, 3257751984, 3257752023, 'NL', 'NLD', 'هولندا'),
(53682, 3257752024, 3257752031, 'DE', 'DEU', 'ألمانيا'),
(53683, 3257752032, 3257752071, 'NL', 'NLD', 'هولندا'),
(53684, 3257752072, 3257752079, 'DE', 'DEU', 'ألمانيا'),
(53685, 3257752080, 3257752103, 'NL', 'NLD', 'هولندا'),
(53686, 3257752104, 3257752111, 'DE', 'DEU', 'ألمانيا'),
(53687, 3257752112, 3257752135, 'NL', 'NLD', 'هولندا'),
(53688, 3257752136, 3257752143, 'DE', 'DEU', 'ألمانيا'),
(53689, 3257752144, 3257752167, 'NL', 'NLD', 'هولندا'),
(53690, 3257752168, 3257752183, 'DE', 'DEU', 'ألمانيا'),
(53691, 3257752184, 3257752399, 'NL', 'NLD', 'هولندا'),
(53692, 3257752400, 3257752407, 'DE', 'DEU', 'ألمانيا'),
(53693, 3257752408, 3257752495, 'NL', 'NLD', 'هولندا'),
(53694, 3257752496, 3257752503, 'DE', 'DEU', 'ألمانيا'),
(53695, 3257752504, 3257752527, 'NL', 'NLD', 'هولندا'),
(53696, 3257752528, 3257752543, 'DE', 'DEU', 'ألمانيا'),
(53697, 3257752544, 3257752583, 'NL', 'NLD', 'هولندا'),
(53698, 3257752584, 3257752591, 'DE', 'DEU', 'ألمانيا'),
(53699, 3257752592, 3257752607, 'NL', 'NLD', 'هولندا'),
(53700, 3257752608, 3257752615, 'DE', 'DEU', 'ألمانيا'),
(53701, 3257752616, 3257752623, 'NL', 'NLD', 'هولندا'),
(53702, 3257752624, 3257752631, 'DE', 'DEU', 'ألمانيا'),
(53703, 3257752632, 3257752727, 'NL', 'NLD', 'هولندا'),
(53704, 3257752728, 3257752735, 'DE', 'DEU', 'ألمانيا'),
(53705, 3257752736, 3257752783, 'NL', 'NLD', 'هولندا'),
(53706, 3257752784, 3257752791, 'DE', 'DEU', 'ألمانيا'),
(53707, 3257752792, 3257752799, 'NL', 'NLD', 'هولندا'),
(53708, 3257752800, 3257752807, 'DE', 'DEU', 'ألمانيا'),
(53709, 3257752808, 3257752919, 'NL', 'NLD', 'هولندا'),
(53710, 3257752920, 3257752935, 'DE', 'DEU', 'ألمانيا'),
(53711, 3257752936, 3257753087, 'NL', 'NLD', 'هولندا'),
(53712, 3257753088, 3257756671, 'DE', 'DEU', 'ألمانيا'),
(53713, 3257756672, 3257756735, 'NL', 'NLD', 'هولندا'),
(53714, 3257756736, 3257756743, 'DE', 'DEU', 'ألمانيا'),
(53715, 3257756744, 3257756807, 'NL', 'NLD', 'هولندا'),
(53716, 3257756808, 3257756823, 'DE', 'DEU', 'ألمانيا'),
(53717, 3257756824, 3257756887, 'NL', 'NLD', 'هولندا'),
(53718, 3257756888, 3257756895, 'DE', 'DEU', 'ألمانيا'),
(53719, 3257756896, 3257756919, 'NL', 'NLD', 'هولندا'),
(53720, 3257756920, 3257756927, 'DE', 'DEU', 'ألمانيا'),
(53721, 3257756928, 3257757007, 'NL', 'NLD', 'هولندا'),
(53722, 3257757008, 3257757015, 'DE', 'DEU', 'ألمانيا'),
(53723, 3257757016, 3257757343, 'NL', 'NLD', 'هولندا'),
(53724, 3257757344, 3257757351, 'DE', 'DEU', 'ألمانيا'),
(53725, 3257757352, 3257757375, 'NL', 'NLD', 'هولندا'),
(53726, 3257757376, 3257757383, 'DE', 'DEU', 'ألمانيا'),
(53727, 3257757384, 3257757407, 'NL', 'NLD', 'هولندا'),
(53728, 3257757408, 3257757423, 'DE', 'DEU', 'ألمانيا'),
(53729, 3257757424, 3257757511, 'NL', 'NLD', 'هولندا'),
(53730, 3257757512, 3257757519, 'DE', 'DEU', 'ألمانيا'),
(53731, 3257757520, 3257757639, 'NL', 'NLD', 'هولندا'),
(53732, 3257757640, 3257757647, 'DE', 'DEU', 'ألمانيا'),
(53733, 3257757648, 3257757735, 'NL', 'NLD', 'هولندا'),
(53734, 3257757736, 3257757751, 'DE', 'DEU', 'ألمانيا'),
(53735, 3257757752, 3257757799, 'NL', 'NLD', 'هولندا'),
(53736, 3257757800, 3257757807, 'DE', 'DEU', 'ألمانيا'),
(53737, 3257757808, 3257757815, 'NL', 'NLD', 'هولندا'),
(53738, 3257757816, 3257757831, 'DE', 'DEU', 'ألمانيا'),
(53739, 3257757832, 3257757919, 'NL', 'NLD', 'هولندا'),
(53740, 3257757920, 3257757935, 'DE', 'DEU', 'ألمانيا'),
(53741, 3257757936, 3257758143, 'NL', 'NLD', 'هولندا'),
(53742, 3257758144, 3257758151, 'DE', 'DEU', 'ألمانيا'),
(53743, 3257758152, 3257758239, 'NL', 'NLD', 'هولندا'),
(53744, 3257758240, 3257758247, 'DE', 'DEU', 'ألمانيا'),
(53745, 3257758248, 3257758271, 'NL', 'NLD', 'هولندا'),
(53746, 3257758272, 3257758279, 'DE', 'DEU', 'ألمانيا'),
(53747, 3257758280, 3257758335, 'NL', 'NLD', 'هولندا'),
(53748, 3257758336, 3257758343, 'DE', 'DEU', 'ألمانيا'),
(53749, 3257758344, 3257758375, 'NL', 'NLD', 'هولندا'),
(53750, 3257758376, 3257758383, 'DE', 'DEU', 'ألمانيا'),
(53751, 3257758384, 3257758423, 'NL', 'NLD', 'هولندا'),
(53752, 3257758424, 3257758431, 'DE', 'DEU', 'ألمانيا'),
(53753, 3257758432, 3257758511, 'NL', 'NLD', 'هولندا'),
(53754, 3257758512, 3257758519, 'DE', 'DEU', 'ألمانيا'),
(53755, 3257758520, 3257758567, 'NL', 'NLD', 'هولندا'),
(53756, 3257758568, 3257758575, 'DE', 'DEU', 'ألمانيا'),
(53757, 3257758576, 3257758623, 'NL', 'NLD', 'هولندا'),
(53758, 3257758624, 3257758639, 'DE', 'DEU', 'ألمانيا'),
(53759, 3257758640, 3257758647, 'NL', 'NLD', 'هولندا'),
(53760, 3257758648, 3257758655, 'DE', 'DEU', 'ألمانيا'),
(53761, 3257758656, 3257758855, 'NL', 'NLD', 'هولندا'),
(53762, 3257758856, 3257758863, 'DE', 'DEU', 'ألمانيا'),
(53763, 3257758864, 3257758879, 'NL', 'NLD', 'هولندا'),
(53764, 3257758880, 3257758887, 'DE', 'DEU', 'ألمانيا'),
(53765, 3257758888, 3257758927, 'NL', 'NLD', 'هولندا'),
(53766, 3257758928, 3257758935, 'DE', 'DEU', 'ألمانيا'),
(53767, 3257758936, 3257759087, 'NL', 'NLD', 'هولندا'),
(53768, 3257759088, 3257759095, 'DE', 'DEU', 'ألمانيا'),
(53769, 3257759096, 3257759135, 'NL', 'NLD', 'هولندا'),
(53770, 3257759136, 3257759151, 'DE', 'DEU', 'ألمانيا'),
(53771, 3257759152, 3257759159, 'NL', 'NLD', 'هولندا'),
(53772, 3257759160, 3257759167, 'DE', 'DEU', 'ألمانيا'),
(53773, 3257759168, 3257759255, 'NL', 'NLD', 'هولندا'),
(53774, 3257759256, 3257759263, 'DE', 'DEU', 'ألمانيا'),
(53775, 3257759264, 3257759271, 'NL', 'NLD', 'هولندا'),
(53776, 3257759272, 3257759279, 'DE', 'DEU', 'ألمانيا'),
(53777, 3257759280, 3257759287, 'NL', 'NLD', 'هولندا'),
(53778, 3257759288, 3257759295, 'DE', 'DEU', 'ألمانيا'),
(53779, 3257759296, 3257759415, 'NL', 'NLD', 'هولندا'),
(53780, 3257759416, 3257759423, 'DE', 'DEU', 'ألمانيا'),
(53781, 3257759424, 3257759647, 'NL', 'NLD', 'هولندا'),
(53782, 3257759648, 3257759671, 'DE', 'DEU', 'ألمانيا'),
(53783, 3257759672, 3257759735, 'NL', 'NLD', 'هولندا'),
(53784, 3257759736, 3257759743, 'DE', 'DEU', 'ألمانيا'),
(53785, 3257759744, 3257759791, 'NL', 'NLD', 'هولندا'),
(53786, 3257759792, 3257759799, 'DE', 'DEU', 'ألمانيا'),
(53787, 3257759800, 3257759847, 'NL', 'NLD', 'هولندا'),
(53788, 3257759848, 3257759863, 'DE', 'DEU', 'ألمانيا'),
(53789, 3257759864, 3257759871, 'NL', 'NLD', 'هولندا'),
(53790, 3257759872, 3257759879, 'DE', 'DEU', 'ألمانيا'),
(53791, 3257759880, 3257759887, 'NL', 'NLD', 'هولندا'),
(53792, 3257759888, 3257759903, 'DE', 'DEU', 'ألمانيا'),
(53793, 3257759904, 3257759975, 'NL', 'NLD', 'هولندا'),
(53794, 3257759976, 3257759983, 'DE', 'DEU', 'ألمانيا'),
(53795, 3257759984, 3257760015, 'NL', 'NLD', 'هولندا'),
(53796, 3257760016, 3257760023, 'DE', 'DEU', 'ألمانيا'),
(53797, 3257760024, 3257760039, 'NL', 'NLD', 'هولندا'),
(53798, 3257760040, 3257760047, 'DE', 'DEU', 'ألمانيا'),
(53799, 3257760048, 3257760095, 'NL', 'NLD', 'هولندا'),
(53800, 3257760096, 3257760103, 'DE', 'DEU', 'ألمانيا'),
(53801, 3257760104, 3257760167, 'NL', 'NLD', 'هولندا'),
(53802, 3257760168, 3257760175, 'DE', 'DEU', 'ألمانيا'),
(53803, 3257760176, 3257760231, 'NL', 'NLD', 'هولندا'),
(53804, 3257760232, 3257760239, 'DE', 'DEU', 'ألمانيا'),
(53805, 3257760240, 3257760263, 'NL', 'NLD', 'هولندا'),
(53806, 3257760264, 3257760271, 'DE', 'DEU', 'ألمانيا'),
(53807, 3257760272, 3257760303, 'NL', 'NLD', 'هولندا'),
(53808, 3257760304, 3257760311, 'DE', 'DEU', 'ألمانيا'),
(53809, 3257760312, 3257760359, 'NL', 'NLD', 'هولندا'),
(53810, 3257760360, 3257760367, 'DE', 'DEU', 'ألمانيا'),
(53811, 3257760368, 3257760431, 'NL', 'NLD', 'هولندا'),
(53812, 3257760432, 3257760439, 'DE', 'DEU', 'ألمانيا'),
(53813, 3257760440, 3257760495, 'NL', 'NLD', 'هولندا'),
(53814, 3257760496, 3257760503, 'DE', 'DEU', 'ألمانيا'),
(53815, 3257760504, 3257760559, 'NL', 'NLD', 'هولندا'),
(53816, 3257760560, 3257760567, 'DE', 'DEU', 'ألمانيا'),
(53817, 3257760568, 3257760655, 'NL', 'NLD', 'هولندا'),
(53818, 3257760656, 3257760663, 'DE', 'DEU', 'ألمانيا'),
(53819, 3257760664, 3257760791, 'NL', 'NLD', 'هولندا'),
(53820, 3257760792, 3257760799, 'DE', 'DEU', 'ألمانيا'),
(53821, 3257760800, 3257760839, 'NL', 'NLD', 'هولندا'),
(53822, 3257760840, 3257760847, 'DE', 'DEU', 'ألمانيا'),
(53823, 3257760848, 3257760863, 'NL', 'NLD', 'هولندا'),
(53824, 3257760864, 3257760871, 'DE', 'DEU', 'ألمانيا'),
(53825, 3257760872, 3257760927, 'NL', 'NLD', 'هولندا'),
(53826, 3257760928, 3257760935, 'DE', 'DEU', 'ألمانيا'),
(53827, 3257760936, 3257760959, 'NL', 'NLD', 'هولندا'),
(53828, 3257760960, 3257760967, 'DE', 'DEU', 'ألمانيا'),
(53829, 3257760968, 3257761055, 'NL', 'NLD', 'هولندا'),
(53830, 3257761056, 3257761071, 'DE', 'DEU', 'ألمانيا'),
(53831, 3257761072, 3257761151, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(53832, 3257761152, 3257761159, 'DE', 'DEU', 'ألمانيا'),
(53833, 3257761160, 3257761279, 'NL', 'NLD', 'هولندا'),
(53834, 3257761280, 3257761791, 'DE', 'DEU', 'ألمانيا'),
(53835, 3257761792, 3257761839, 'NL', 'NLD', 'هولندا'),
(53836, 3257761840, 3257761847, 'DE', 'DEU', 'ألمانيا'),
(53837, 3257761848, 3257761879, 'NL', 'NLD', 'هولندا'),
(53838, 3257761880, 3257761887, 'DE', 'DEU', 'ألمانيا'),
(53839, 3257761888, 3257761903, 'NL', 'NLD', 'هولندا'),
(53840, 3257761904, 3257761919, 'DE', 'DEU', 'ألمانيا'),
(53841, 3257761920, 3257761951, 'NL', 'NLD', 'هولندا'),
(53842, 3257761952, 3257761959, 'DE', 'DEU', 'ألمانيا'),
(53843, 3257761960, 3257762023, 'NL', 'NLD', 'هولندا'),
(53844, 3257762024, 3257762031, 'DE', 'DEU', 'ألمانيا'),
(53845, 3257762032, 3257762175, 'NL', 'NLD', 'هولندا'),
(53846, 3257762176, 3257762183, 'DE', 'DEU', 'ألمانيا'),
(53847, 3257762184, 3257762215, 'NL', 'NLD', 'هولندا'),
(53848, 3257762216, 3257762223, 'DE', 'DEU', 'ألمانيا'),
(53849, 3257762224, 3257762247, 'NL', 'NLD', 'هولندا'),
(53850, 3257762248, 3257762263, 'DE', 'DEU', 'ألمانيا'),
(53851, 3257762264, 3257762359, 'NL', 'NLD', 'هولندا'),
(53852, 3257762360, 3257762367, 'DE', 'DEU', 'ألمانيا'),
(53853, 3257762368, 3257762391, 'NL', 'NLD', 'هولندا'),
(53854, 3257762392, 3257762399, 'DE', 'DEU', 'ألمانيا'),
(53855, 3257762400, 3257762407, 'NL', 'NLD', 'هولندا'),
(53856, 3257762408, 3257762415, 'DE', 'DEU', 'ألمانيا'),
(53857, 3257762416, 3257762447, 'NL', 'NLD', 'هولندا'),
(53858, 3257762448, 3257762455, 'DE', 'DEU', 'ألمانيا'),
(53859, 3257762456, 3257762591, 'NL', 'NLD', 'هولندا'),
(53860, 3257762592, 3257762599, 'DE', 'DEU', 'ألمانيا'),
(53861, 3257762600, 3257762655, 'NL', 'NLD', 'هولندا'),
(53862, 3257762656, 3257762663, 'DE', 'DEU', 'ألمانيا'),
(53863, 3257762664, 3257762679, 'NL', 'NLD', 'هولندا'),
(53864, 3257762680, 3257762695, 'DE', 'DEU', 'ألمانيا'),
(53865, 3257762696, 3257762711, 'NL', 'NLD', 'هولندا'),
(53866, 3257762712, 3257762719, 'DE', 'DEU', 'ألمانيا'),
(53867, 3257762720, 3257762807, 'NL', 'NLD', 'هولندا'),
(53868, 3257762808, 3257762815, 'DE', 'DEU', 'ألمانيا'),
(53869, 3257762816, 3257762863, 'NL', 'NLD', 'هولندا'),
(53870, 3257762864, 3257762871, 'DE', 'DEU', 'ألمانيا'),
(53871, 3257762872, 3257762951, 'NL', 'NLD', 'هولندا'),
(53872, 3257762952, 3257762959, 'DE', 'DEU', 'ألمانيا'),
(53873, 3257762960, 3257763055, 'NL', 'NLD', 'هولندا'),
(53874, 3257763056, 3257763063, 'DE', 'DEU', 'ألمانيا'),
(53875, 3257763064, 3257763151, 'NL', 'NLD', 'هولندا'),
(53876, 3257763152, 3257763159, 'DE', 'DEU', 'ألمانيا'),
(53877, 3257763160, 3257763247, 'NL', 'NLD', 'هولندا'),
(53878, 3257763248, 3257763255, 'DE', 'DEU', 'ألمانيا'),
(53879, 3257763256, 3257763327, 'NL', 'NLD', 'هولندا'),
(53880, 3257763328, 3257763839, 'DE', 'DEU', 'ألمانيا'),
(53881, 3257763840, 3257763855, 'NL', 'NLD', 'هولندا'),
(53882, 3257763856, 3257763871, 'DE', 'DEU', 'ألمانيا'),
(53883, 3257763872, 3257763927, 'NL', 'NLD', 'هولندا'),
(53884, 3257763928, 3257763935, 'DE', 'DEU', 'ألمانيا'),
(53885, 3257763936, 3257763943, 'NL', 'NLD', 'هولندا'),
(53886, 3257763944, 3257763951, 'DE', 'DEU', 'ألمانيا'),
(53887, 3257763952, 3257763999, 'NL', 'NLD', 'هولندا'),
(53888, 3257764000, 3257764007, 'DE', 'DEU', 'ألمانيا'),
(53889, 3257764008, 3257764247, 'NL', 'NLD', 'هولندا'),
(53890, 3257764248, 3257764255, 'DE', 'DEU', 'ألمانيا'),
(53891, 3257764256, 3257764287, 'NL', 'NLD', 'هولندا'),
(53892, 3257764288, 3257764295, 'DE', 'DEU', 'ألمانيا'),
(53893, 3257764296, 3257764487, 'NL', 'NLD', 'هولندا'),
(53894, 3257764488, 3257764511, 'DE', 'DEU', 'ألمانيا'),
(53895, 3257764512, 3257764543, 'NL', 'NLD', 'هولندا'),
(53896, 3257764544, 3257764551, 'DE', 'DEU', 'ألمانيا'),
(53897, 3257764552, 3257764591, 'NL', 'NLD', 'هولندا'),
(53898, 3257764592, 3257764599, 'DE', 'DEU', 'ألمانيا'),
(53899, 3257764600, 3257764647, 'NL', 'NLD', 'هولندا'),
(53900, 3257764648, 3257764655, 'DE', 'DEU', 'ألمانيا'),
(53901, 3257764656, 3257764799, 'NL', 'NLD', 'هولندا'),
(53902, 3257764800, 3257764807, 'DE', 'DEU', 'ألمانيا'),
(53903, 3257764808, 3257764879, 'NL', 'NLD', 'هولندا'),
(53904, 3257764880, 3257764887, 'DE', 'DEU', 'ألمانيا'),
(53905, 3257764888, 3257764927, 'NL', 'NLD', 'هولندا'),
(53906, 3257764928, 3257764935, 'DE', 'DEU', 'ألمانيا'),
(53907, 3257764936, 3257764983, 'NL', 'NLD', 'هولندا'),
(53908, 3257764984, 3257764991, 'DE', 'DEU', 'ألمانيا'),
(53909, 3257764992, 3257765055, 'NL', 'NLD', 'هولندا'),
(53910, 3257765056, 3257765063, 'DE', 'DEU', 'ألمانيا'),
(53911, 3257765064, 3257765263, 'NL', 'NLD', 'هولندا'),
(53912, 3257765264, 3257765279, 'DE', 'DEU', 'ألمانيا'),
(53913, 3257765280, 3257765375, 'NL', 'NLD', 'هولندا'),
(53914, 3257765376, 3257768959, 'DE', 'DEU', 'ألمانيا'),
(53915, 3257768960, 3257769071, 'NL', 'NLD', 'هولندا'),
(53916, 3257769072, 3257769079, 'DE', 'DEU', 'ألمانيا'),
(53917, 3257769080, 3257769215, 'NL', 'NLD', 'هولندا'),
(53918, 3257769216, 3257769223, 'DE', 'DEU', 'ألمانيا'),
(53919, 3257769224, 3257769543, 'NL', 'NLD', 'هولندا'),
(53920, 3257769544, 3257769551, 'DE', 'DEU', 'ألمانيا'),
(53921, 3257769552, 3257769567, 'NL', 'NLD', 'هولندا'),
(53922, 3257769568, 3257769575, 'DE', 'DEU', 'ألمانيا'),
(53923, 3257769576, 3257769703, 'NL', 'NLD', 'هولندا'),
(53924, 3257769704, 3257769711, 'DE', 'DEU', 'ألمانيا'),
(53925, 3257769712, 3257769719, 'NL', 'NLD', 'هولندا'),
(53926, 3257769720, 3257769727, 'DE', 'DEU', 'ألمانيا'),
(53927, 3257769728, 3257770023, 'NL', 'NLD', 'هولندا'),
(53928, 3257770024, 3257770031, 'DE', 'DEU', 'ألمانيا'),
(53929, 3257770032, 3257770039, 'NL', 'NLD', 'هولندا'),
(53930, 3257770040, 3257770047, 'DE', 'DEU', 'ألمانيا'),
(53931, 3257770048, 3257770071, 'NL', 'NLD', 'هولندا'),
(53932, 3257770072, 3257770079, 'DE', 'DEU', 'ألمانيا'),
(53933, 3257770080, 3257770095, 'NL', 'NLD', 'هولندا'),
(53934, 3257770096, 3257770103, 'DE', 'DEU', 'ألمانيا'),
(53935, 3257770104, 3257770151, 'NL', 'NLD', 'هولندا'),
(53936, 3257770152, 3257770159, 'DE', 'DEU', 'ألمانيا'),
(53937, 3257770160, 3257770295, 'NL', 'NLD', 'هولندا'),
(53938, 3257770296, 3257770303, 'DE', 'DEU', 'ألمانيا'),
(53939, 3257770304, 3257770359, 'NL', 'NLD', 'هولندا'),
(53940, 3257770360, 3257770367, 'DE', 'DEU', 'ألمانيا'),
(53941, 3257770368, 3257770455, 'NL', 'NLD', 'هولندا'),
(53942, 3257770456, 3257770463, 'DE', 'DEU', 'ألمانيا'),
(53943, 3257770464, 3257770511, 'NL', 'NLD', 'هولندا'),
(53944, 3257770512, 3257770519, 'DE', 'DEU', 'ألمانيا'),
(53945, 3257770520, 3257770599, 'NL', 'NLD', 'هولندا'),
(53946, 3257770600, 3257770607, 'DE', 'DEU', 'ألمانيا'),
(53947, 3257770608, 3257770623, 'NL', 'NLD', 'هولندا'),
(53948, 3257770624, 3257770631, 'DE', 'DEU', 'ألمانيا'),
(53949, 3257770632, 3257770823, 'NL', 'NLD', 'هولندا'),
(53950, 3257770824, 3257770831, 'DE', 'DEU', 'ألمانيا'),
(53951, 3257770832, 3257770911, 'NL', 'NLD', 'هولندا'),
(53952, 3257770912, 3257770919, 'DE', 'DEU', 'ألمانيا'),
(53953, 3257770920, 3257771007, 'NL', 'NLD', 'هولندا'),
(53954, 3257771008, 3257772543, 'DE', 'DEU', 'ألمانيا'),
(53955, 3257772544, 3257772631, 'NL', 'NLD', 'هولندا'),
(53956, 3257772632, 3257772639, 'DE', 'DEU', 'ألمانيا'),
(53957, 3257772640, 3257772735, 'NL', 'NLD', 'هولندا'),
(53958, 3257772736, 3257772743, 'DE', 'DEU', 'ألمانيا'),
(53959, 3257772744, 3257772783, 'NL', 'NLD', 'هولندا'),
(53960, 3257772784, 3257772791, 'DE', 'DEU', 'ألمانيا'),
(53961, 3257772792, 3257772815, 'NL', 'NLD', 'هولندا'),
(53962, 3257772816, 3257772831, 'DE', 'DEU', 'ألمانيا'),
(53963, 3257772832, 3257772847, 'NL', 'NLD', 'هولندا'),
(53964, 3257772848, 3257772855, 'DE', 'DEU', 'ألمانيا'),
(53965, 3257772856, 3257772895, 'NL', 'NLD', 'هولندا'),
(53966, 3257772896, 3257772903, 'DE', 'DEU', 'ألمانيا'),
(53967, 3257772904, 3257772991, 'NL', 'NLD', 'هولندا'),
(53968, 3257772992, 3257772999, 'DE', 'DEU', 'ألمانيا'),
(53969, 3257773000, 3257773095, 'NL', 'NLD', 'هولندا'),
(53970, 3257773096, 3257773103, 'DE', 'DEU', 'ألمانيا'),
(53971, 3257773104, 3257773199, 'NL', 'NLD', 'هولندا'),
(53972, 3257773200, 3257773223, 'DE', 'DEU', 'ألمانيا'),
(53973, 3257773224, 3257773303, 'NL', 'NLD', 'هولندا'),
(53974, 3257773304, 3257773311, 'DE', 'DEU', 'ألمانيا'),
(53975, 3257773312, 3257773391, 'NL', 'NLD', 'هولندا'),
(53976, 3257773392, 3257773399, 'DE', 'DEU', 'ألمانيا'),
(53977, 3257773400, 3257773415, 'NL', 'NLD', 'هولندا'),
(53978, 3257773416, 3257773423, 'DE', 'DEU', 'ألمانيا'),
(53979, 3257773424, 3257773439, 'NL', 'NLD', 'هولندا'),
(53980, 3257773440, 3257773447, 'DE', 'DEU', 'ألمانيا'),
(53981, 3257773448, 3257773767, 'NL', 'NLD', 'هولندا'),
(53982, 3257773768, 3257773775, 'DE', 'DEU', 'ألمانيا'),
(53983, 3257773776, 3257773799, 'NL', 'NLD', 'هولندا'),
(53984, 3257773800, 3257773807, 'DE', 'DEU', 'ألمانيا'),
(53985, 3257773808, 3257773831, 'NL', 'NLD', 'هولندا'),
(53986, 3257773832, 3257773839, 'DE', 'DEU', 'ألمانيا'),
(53987, 3257773840, 3257773847, 'NL', 'NLD', 'هولندا'),
(53988, 3257773848, 3257773855, 'DE', 'DEU', 'ألمانيا'),
(53989, 3257773856, 3257773903, 'NL', 'NLD', 'هولندا'),
(53990, 3257773904, 3257773919, 'DE', 'DEU', 'ألمانيا'),
(53991, 3257773920, 3257773951, 'NL', 'NLD', 'هولندا'),
(53992, 3257773952, 3257773959, 'DE', 'DEU', 'ألمانيا'),
(53993, 3257773960, 3257774007, 'NL', 'NLD', 'هولندا'),
(53994, 3257774008, 3257774015, 'DE', 'DEU', 'ألمانيا'),
(53995, 3257774016, 3257774055, 'NL', 'NLD', 'هولندا'),
(53996, 3257774056, 3257774063, 'DE', 'DEU', 'ألمانيا'),
(53997, 3257774064, 3257774287, 'NL', 'NLD', 'هولندا'),
(53998, 3257774288, 3257774295, 'DE', 'DEU', 'ألمانيا'),
(53999, 3257774296, 3257774335, 'NL', 'NLD', 'هولندا'),
(54000, 3257774336, 3257774343, 'DE', 'DEU', 'ألمانيا'),
(54001, 3257774344, 3257774359, 'NL', 'NLD', 'هولندا'),
(54002, 3257774360, 3257774367, 'DE', 'DEU', 'ألمانيا'),
(54003, 3257774368, 3257774375, 'NL', 'NLD', 'هولندا'),
(54004, 3257774376, 3257774383, 'DE', 'DEU', 'ألمانيا'),
(54005, 3257774384, 3257774487, 'NL', 'NLD', 'هولندا'),
(54006, 3257774488, 3257774495, 'DE', 'DEU', 'ألمانيا'),
(54007, 3257774496, 3257774775, 'NL', 'NLD', 'هولندا'),
(54008, 3257774776, 3257774791, 'DE', 'DEU', 'ألمانيا'),
(54009, 3257774792, 3257774871, 'NL', 'NLD', 'هولندا'),
(54010, 3257774872, 3257774879, 'DE', 'DEU', 'ألمانيا'),
(54011, 3257774880, 3257774951, 'NL', 'NLD', 'هولندا'),
(54012, 3257774952, 3257774959, 'DE', 'DEU', 'ألمانيا'),
(54013, 3257774960, 3257774983, 'NL', 'NLD', 'هولندا'),
(54014, 3257774984, 3257774999, 'DE', 'DEU', 'ألمانيا'),
(54015, 3257775000, 3257775047, 'NL', 'NLD', 'هولندا'),
(54016, 3257775048, 3257775055, 'DE', 'DEU', 'ألمانيا'),
(54017, 3257775056, 3257775103, 'NL', 'NLD', 'هولندا'),
(54018, 3257775104, 3257776639, 'DE', 'DEU', 'ألمانيا'),
(54019, 3257776640, 3257776663, 'NL', 'NLD', 'هولندا'),
(54020, 3257776664, 3257776671, 'DE', 'DEU', 'ألمانيا'),
(54021, 3257776672, 3257776727, 'NL', 'NLD', 'هولندا'),
(54022, 3257776728, 3257776735, 'DE', 'DEU', 'ألمانيا'),
(54023, 3257776736, 3257776767, 'NL', 'NLD', 'هولندا'),
(54024, 3257776768, 3257776775, 'DE', 'DEU', 'ألمانيا'),
(54025, 3257776776, 3257776983, 'NL', 'NLD', 'هولندا'),
(54026, 3257776984, 3257776991, 'DE', 'DEU', 'ألمانيا'),
(54027, 3257776992, 3257777047, 'NL', 'NLD', 'هولندا'),
(54028, 3257777048, 3257777055, 'DE', 'DEU', 'ألمانيا'),
(54029, 3257777056, 3257777111, 'NL', 'NLD', 'هولندا'),
(54030, 3257777112, 3257777119, 'DE', 'DEU', 'ألمانيا'),
(54031, 3257777120, 3257777151, 'NL', 'NLD', 'هولندا'),
(54032, 3257777152, 3257777159, 'DE', 'DEU', 'ألمانيا'),
(54033, 3257777160, 3257777223, 'NL', 'NLD', 'هولندا'),
(54034, 3257777224, 3257777231, 'DE', 'DEU', 'ألمانيا'),
(54035, 3257777232, 3257777335, 'NL', 'NLD', 'هولندا'),
(54036, 3257777336, 3257777343, 'DE', 'DEU', 'ألمانيا'),
(54037, 3257777344, 3257777487, 'NL', 'NLD', 'هولندا'),
(54038, 3257777488, 3257777495, 'DE', 'DEU', 'ألمانيا'),
(54039, 3257777496, 3257777551, 'NL', 'NLD', 'هولندا'),
(54040, 3257777552, 3257777559, 'DE', 'DEU', 'ألمانيا'),
(54041, 3257777560, 3257777575, 'NL', 'NLD', 'هولندا'),
(54042, 3257777576, 3257777583, 'DE', 'DEU', 'ألمانيا'),
(54043, 3257777584, 3257777751, 'NL', 'NLD', 'هولندا'),
(54044, 3257777752, 3257777767, 'DE', 'DEU', 'ألمانيا'),
(54045, 3257777768, 3257777799, 'NL', 'NLD', 'هولندا'),
(54046, 3257777800, 3257777807, 'DE', 'DEU', 'ألمانيا'),
(54047, 3257777808, 3257777935, 'NL', 'NLD', 'هولندا'),
(54048, 3257777936, 3257777943, 'DE', 'DEU', 'ألمانيا'),
(54049, 3257777944, 3257777991, 'NL', 'NLD', 'هولندا'),
(54050, 3257777992, 3257777999, 'DE', 'DEU', 'ألمانيا'),
(54051, 3257778000, 3257778023, 'NL', 'NLD', 'هولندا'),
(54052, 3257778024, 3257778031, 'DE', 'DEU', 'ألمانيا'),
(54053, 3257778032, 3257778047, 'NL', 'NLD', 'هولندا'),
(54054, 3257778048, 3257778055, 'DE', 'DEU', 'ألمانيا'),
(54055, 3257778056, 3257778071, 'NL', 'NLD', 'هولندا'),
(54056, 3257778072, 3257778079, 'DE', 'DEU', 'ألمانيا'),
(54057, 3257778080, 3257778087, 'NL', 'NLD', 'هولندا'),
(54058, 3257778088, 3257778095, 'DE', 'DEU', 'ألمانيا'),
(54059, 3257778096, 3257778159, 'NL', 'NLD', 'هولندا'),
(54060, 3257778160, 3257778167, 'DE', 'DEU', 'ألمانيا'),
(54061, 3257778168, 3257778439, 'NL', 'NLD', 'هولندا'),
(54062, 3257778440, 3257778447, 'DE', 'DEU', 'ألمانيا'),
(54063, 3257778448, 3257778479, 'NL', 'NLD', 'هولندا'),
(54064, 3257778480, 3257778487, 'DE', 'DEU', 'ألمانيا'),
(54065, 3257778488, 3257778503, 'NL', 'NLD', 'هولندا'),
(54066, 3257778504, 3257778511, 'DE', 'DEU', 'ألمانيا'),
(54067, 3257778512, 3257778583, 'NL', 'NLD', 'هولندا'),
(54068, 3257778584, 3257778591, 'DE', 'DEU', 'ألمانيا'),
(54069, 3257778592, 3257778663, 'NL', 'NLD', 'هولندا'),
(54070, 3257778664, 3257778671, 'DE', 'DEU', 'ألمانيا'),
(54071, 3257778672, 3257778815, 'NL', 'NLD', 'هولندا'),
(54072, 3257778816, 3257778823, 'DE', 'DEU', 'ألمانيا'),
(54073, 3257778824, 3257778895, 'NL', 'NLD', 'هولندا'),
(54074, 3257778896, 3257778903, 'DE', 'DEU', 'ألمانيا'),
(54075, 3257778904, 3257778943, 'NL', 'NLD', 'هولندا'),
(54076, 3257778944, 3257778951, 'DE', 'DEU', 'ألمانيا'),
(54077, 3257778952, 3257778959, 'NL', 'NLD', 'هولندا'),
(54078, 3257778960, 3257778975, 'DE', 'DEU', 'ألمانيا'),
(54079, 3257778976, 3257779055, 'NL', 'NLD', 'هولندا'),
(54080, 3257779056, 3257779063, 'DE', 'DEU', 'ألمانيا'),
(54081, 3257779064, 3257779079, 'NL', 'NLD', 'هولندا'),
(54082, 3257779080, 3257779087, 'DE', 'DEU', 'ألمانيا'),
(54083, 3257779088, 3257779111, 'NL', 'NLD', 'هولندا'),
(54084, 3257779112, 3257779127, 'DE', 'DEU', 'ألمانيا'),
(54085, 3257779128, 3257779199, 'NL', 'NLD', 'هولندا'),
(54086, 3257779200, 3257780735, 'DE', 'DEU', 'ألمانيا'),
(54087, 3257780736, 3257780743, 'NL', 'NLD', 'هولندا'),
(54088, 3257780744, 3257780751, 'DE', 'DEU', 'ألمانيا'),
(54089, 3257780752, 3257780775, 'NL', 'NLD', 'هولندا'),
(54090, 3257780776, 3257780783, 'DE', 'DEU', 'ألمانيا'),
(54091, 3257780784, 3257780967, 'NL', 'NLD', 'هولندا'),
(54092, 3257780968, 3257780983, 'DE', 'DEU', 'ألمانيا'),
(54093, 3257780984, 3257781111, 'NL', 'NLD', 'هولندا'),
(54094, 3257781112, 3257781119, 'DE', 'DEU', 'ألمانيا'),
(54095, 3257781120, 3257781135, 'NL', 'NLD', 'هولندا'),
(54096, 3257781136, 3257781143, 'DE', 'DEU', 'ألمانيا'),
(54097, 3257781144, 3257781255, 'NL', 'NLD', 'هولندا'),
(54098, 3257781256, 3257781263, 'DE', 'DEU', 'ألمانيا'),
(54099, 3257781264, 3257781279, 'NL', 'NLD', 'هولندا'),
(54100, 3257781280, 3257781287, 'DE', 'DEU', 'ألمانيا'),
(54101, 3257781288, 3257781391, 'NL', 'NLD', 'هولندا'),
(54102, 3257781392, 3257781399, 'DE', 'DEU', 'ألمانيا'),
(54103, 3257781400, 3257781479, 'NL', 'NLD', 'هولندا'),
(54104, 3257781480, 3257781487, 'DE', 'DEU', 'ألمانيا'),
(54105, 3257781488, 3257781567, 'NL', 'NLD', 'هولندا'),
(54106, 3257781568, 3257781575, 'DE', 'DEU', 'ألمانيا'),
(54107, 3257781576, 3257781615, 'NL', 'NLD', 'هولندا'),
(54108, 3257781616, 3257781623, 'DE', 'DEU', 'ألمانيا'),
(54109, 3257781624, 3257781639, 'NL', 'NLD', 'هولندا'),
(54110, 3257781640, 3257781647, 'DE', 'DEU', 'ألمانيا'),
(54111, 3257781648, 3257781711, 'NL', 'NLD', 'هولندا'),
(54112, 3257781712, 3257781719, 'DE', 'DEU', 'ألمانيا'),
(54113, 3257781720, 3257781791, 'NL', 'NLD', 'هولندا'),
(54114, 3257781792, 3257781799, 'DE', 'DEU', 'ألمانيا'),
(54115, 3257781800, 3257781839, 'NL', 'NLD', 'هولندا'),
(54116, 3257781840, 3257781847, 'DE', 'DEU', 'ألمانيا'),
(54117, 3257781848, 3257781895, 'NL', 'NLD', 'هولندا'),
(54118, 3257781896, 3257781903, 'DE', 'DEU', 'ألمانيا'),
(54119, 3257781904, 3257781919, 'NL', 'NLD', 'هولندا'),
(54120, 3257781920, 3257781927, 'DE', 'DEU', 'ألمانيا'),
(54121, 3257781928, 3257781943, 'NL', 'NLD', 'هولندا'),
(54122, 3257781944, 3257781951, 'DE', 'DEU', 'ألمانيا'),
(54123, 3257781952, 3257781975, 'NL', 'NLD', 'هولندا'),
(54124, 3257781976, 3257781999, 'DE', 'DEU', 'ألمانيا'),
(54125, 3257782000, 3257782015, 'NL', 'NLD', 'هولندا'),
(54126, 3257782016, 3257782023, 'DE', 'DEU', 'ألمانيا'),
(54127, 3257782024, 3257782031, 'NL', 'NLD', 'هولندا'),
(54128, 3257782032, 3257782039, 'DE', 'DEU', 'ألمانيا'),
(54129, 3257782040, 3257782103, 'NL', 'NLD', 'هولندا'),
(54130, 3257782104, 3257782111, 'DE', 'DEU', 'ألمانيا'),
(54131, 3257782112, 3257782191, 'NL', 'NLD', 'هولندا'),
(54132, 3257782192, 3257782207, 'DE', 'DEU', 'ألمانيا'),
(54133, 3257782208, 3257782239, 'NL', 'NLD', 'هولندا'),
(54134, 3257782240, 3257782247, 'DE', 'DEU', 'ألمانيا'),
(54135, 3257782248, 3257782271, 'NL', 'NLD', 'هولندا'),
(54136, 3257782272, 3257784831, 'DE', 'DEU', 'ألمانيا'),
(54137, 3257784832, 3257785087, 'NL', 'NLD', 'هولندا'),
(54138, 3257785088, 3257785095, 'DE', 'DEU', 'ألمانيا'),
(54139, 3257785096, 3257785151, 'NL', 'NLD', 'هولندا'),
(54140, 3257785152, 3257785159, 'DE', 'DEU', 'ألمانيا'),
(54141, 3257785160, 3257785183, 'NL', 'NLD', 'هولندا'),
(54142, 3257785184, 3257785191, 'DE', 'DEU', 'ألمانيا'),
(54143, 3257785192, 3257785343, 'NL', 'NLD', 'هولندا'),
(54144, 3257785344, 3257785359, 'DE', 'DEU', 'ألمانيا'),
(54145, 3257785360, 3257785375, 'NL', 'NLD', 'هولندا'),
(54146, 3257785376, 3257785383, 'DE', 'DEU', 'ألمانيا'),
(54147, 3257785384, 3257785415, 'NL', 'NLD', 'هولندا'),
(54148, 3257785416, 3257785431, 'DE', 'DEU', 'ألمانيا'),
(54149, 3257785432, 3257785663, 'NL', 'NLD', 'هولندا'),
(54150, 3257785664, 3257785671, 'DE', 'DEU', 'ألمانيا'),
(54151, 3257785672, 3257785679, 'NL', 'NLD', 'هولندا'),
(54152, 3257785680, 3257785695, 'DE', 'DEU', 'ألمانيا'),
(54153, 3257785696, 3257785719, 'NL', 'NLD', 'هولندا'),
(54154, 3257785720, 3257785727, 'DE', 'DEU', 'ألمانيا'),
(54155, 3257785728, 3257785735, 'NL', 'NLD', 'هولندا'),
(54156, 3257785736, 3257785743, 'DE', 'DEU', 'ألمانيا'),
(54157, 3257785744, 3257785807, 'NL', 'NLD', 'هولندا'),
(54158, 3257785808, 3257785815, 'DE', 'DEU', 'ألمانيا'),
(54159, 3257785816, 3257786079, 'NL', 'NLD', 'هولندا'),
(54160, 3257786080, 3257786087, 'DE', 'DEU', 'ألمانيا'),
(54161, 3257786088, 3257786271, 'NL', 'NLD', 'هولندا'),
(54162, 3257786272, 3257786279, 'DE', 'DEU', 'ألمانيا'),
(54163, 3257786280, 3257786335, 'NL', 'NLD', 'هولندا'),
(54164, 3257786336, 3257786343, 'DE', 'DEU', 'ألمانيا'),
(54165, 3257786344, 3257786359, 'NL', 'NLD', 'هولندا'),
(54166, 3257786360, 3257786367, 'DE', 'DEU', 'ألمانيا'),
(54167, 3257786368, 3257786383, 'NL', 'NLD', 'هولندا'),
(54168, 3257786384, 3257786391, 'DE', 'DEU', 'ألمانيا'),
(54169, 3257786392, 3257786415, 'NL', 'NLD', 'هولندا'),
(54170, 3257786416, 3257786423, 'DE', 'DEU', 'ألمانيا'),
(54171, 3257786424, 3257786431, 'NL', 'NLD', 'هولندا'),
(54172, 3257786432, 3257786439, 'DE', 'DEU', 'ألمانيا'),
(54173, 3257786440, 3257786559, 'NL', 'NLD', 'هولندا'),
(54174, 3257786560, 3257786567, 'DE', 'DEU', 'ألمانيا'),
(54175, 3257786568, 3257786623, 'NL', 'NLD', 'هولندا'),
(54176, 3257786624, 3257786631, 'DE', 'DEU', 'ألمانيا'),
(54177, 3257786632, 3257786647, 'NL', 'NLD', 'هولندا'),
(54178, 3257786648, 3257786655, 'DE', 'DEU', 'ألمانيا'),
(54179, 3257786656, 3257786703, 'NL', 'NLD', 'هولندا'),
(54180, 3257786704, 3257786711, 'DE', 'DEU', 'ألمانيا'),
(54181, 3257786712, 3257786807, 'NL', 'NLD', 'هولندا'),
(54182, 3257786808, 3257786823, 'DE', 'DEU', 'ألمانيا'),
(54183, 3257786824, 3257786839, 'NL', 'NLD', 'هولندا'),
(54184, 3257786840, 3257786847, 'DE', 'DEU', 'ألمانيا'),
(54185, 3257786848, 3257786863, 'NL', 'NLD', 'هولندا'),
(54186, 3257786864, 3257786871, 'DE', 'DEU', 'ألمانيا'),
(54187, 3257786872, 3257786879, 'NL', 'NLD', 'هولندا'),
(54188, 3257786880, 3257787391, 'DE', 'DEU', 'ألمانيا'),
(54189, 3257787392, 3257787503, 'NL', 'NLD', 'هولندا'),
(54190, 3257787504, 3257787511, 'DE', 'DEU', 'ألمانيا'),
(54191, 3257787512, 3257787695, 'NL', 'NLD', 'هولندا'),
(54192, 3257787696, 3257787703, 'DE', 'DEU', 'ألمانيا'),
(54193, 3257787704, 3257787727, 'NL', 'NLD', 'هولندا'),
(54194, 3257787728, 3257787735, 'DE', 'DEU', 'ألمانيا'),
(54195, 3257787736, 3257787751, 'NL', 'NLD', 'هولندا'),
(54196, 3257787752, 3257787759, 'DE', 'DEU', 'ألمانيا'),
(54197, 3257787760, 3257787879, 'NL', 'NLD', 'هولندا'),
(54198, 3257787880, 3257787887, 'DE', 'DEU', 'ألمانيا'),
(54199, 3257787888, 3257787911, 'NL', 'NLD', 'هولندا'),
(54200, 3257787912, 3257787919, 'DE', 'DEU', 'ألمانيا'),
(54201, 3257787920, 3257787967, 'NL', 'NLD', 'هولندا'),
(54202, 3257787968, 3257787975, 'DE', 'DEU', 'ألمانيا'),
(54203, 3257787976, 3257787999, 'NL', 'NLD', 'هولندا'),
(54204, 3257788000, 3257788015, 'DE', 'DEU', 'ألمانيا'),
(54205, 3257788016, 3257788071, 'NL', 'NLD', 'هولندا'),
(54206, 3257788072, 3257788079, 'DE', 'DEU', 'ألمانيا'),
(54207, 3257788080, 3257788095, 'NL', 'NLD', 'هولندا'),
(54208, 3257788096, 3257788103, 'DE', 'DEU', 'ألمانيا'),
(54209, 3257788104, 3257788119, 'NL', 'NLD', 'هولندا'),
(54210, 3257788120, 3257788127, 'DE', 'DEU', 'ألمانيا'),
(54211, 3257788128, 3257788175, 'NL', 'NLD', 'هولندا'),
(54212, 3257788176, 3257788183, 'DE', 'DEU', 'ألمانيا'),
(54213, 3257788184, 3257788231, 'NL', 'NLD', 'هولندا'),
(54214, 3257788232, 3257788239, 'DE', 'DEU', 'ألمانيا'),
(54215, 3257788240, 3257788247, 'NL', 'NLD', 'هولندا'),
(54216, 3257788248, 3257788255, 'DE', 'DEU', 'ألمانيا'),
(54217, 3257788256, 3257788415, 'NL', 'NLD', 'هولندا'),
(54218, 3257788416, 3257789951, 'DE', 'DEU', 'ألمانيا'),
(54219, 3257789952, 3257789975, 'NL', 'NLD', 'هولندا'),
(54220, 3257789976, 3257789983, 'DE', 'DEU', 'ألمانيا'),
(54221, 3257789984, 3257789999, 'NL', 'NLD', 'هولندا'),
(54222, 3257790000, 3257790007, 'DE', 'DEU', 'ألمانيا'),
(54223, 3257790008, 3257790039, 'NL', 'NLD', 'هولندا'),
(54224, 3257790040, 3257790047, 'DE', 'DEU', 'ألمانيا'),
(54225, 3257790048, 3257790159, 'NL', 'NLD', 'هولندا'),
(54226, 3257790160, 3257790167, 'DE', 'DEU', 'ألمانيا'),
(54227, 3257790168, 3257790191, 'NL', 'NLD', 'هولندا'),
(54228, 3257790192, 3257790199, 'DE', 'DEU', 'ألمانيا'),
(54229, 3257790200, 3257790239, 'NL', 'NLD', 'هولندا'),
(54230, 3257790240, 3257790247, 'DE', 'DEU', 'ألمانيا'),
(54231, 3257790248, 3257790255, 'NL', 'NLD', 'هولندا'),
(54232, 3257790256, 3257790263, 'DE', 'DEU', 'ألمانيا'),
(54233, 3257790264, 3257790319, 'NL', 'NLD', 'هولندا'),
(54234, 3257790320, 3257790327, 'DE', 'DEU', 'ألمانيا'),
(54235, 3257790328, 3257790391, 'NL', 'NLD', 'هولندا'),
(54236, 3257790392, 3257790407, 'DE', 'DEU', 'ألمانيا'),
(54237, 3257790408, 3257790479, 'NL', 'NLD', 'هولندا'),
(54238, 3257790480, 3257790503, 'DE', 'DEU', 'ألمانيا'),
(54239, 3257790504, 3257790623, 'NL', 'NLD', 'هولندا'),
(54240, 3257790624, 3257790639, 'DE', 'DEU', 'ألمانيا'),
(54241, 3257790640, 3257790663, 'NL', 'NLD', 'هولندا'),
(54242, 3257790664, 3257790671, 'DE', 'DEU', 'ألمانيا'),
(54243, 3257790672, 3257790711, 'NL', 'NLD', 'هولندا'),
(54244, 3257790712, 3257790719, 'DE', 'DEU', 'ألمانيا'),
(54245, 3257790720, 3257790847, 'NL', 'NLD', 'هولندا'),
(54246, 3257790848, 3257790855, 'DE', 'DEU', 'ألمانيا'),
(54247, 3257790856, 3257790903, 'NL', 'NLD', 'هولندا'),
(54248, 3257790904, 3257790919, 'DE', 'DEU', 'ألمانيا'),
(54249, 3257790920, 3257790975, 'NL', 'NLD', 'هولندا'),
(54250, 3257790976, 3257790991, 'DE', 'DEU', 'ألمانيا'),
(54251, 3257790992, 3257790999, 'NL', 'NLD', 'هولندا'),
(54252, 3257791000, 3257791007, 'DE', 'DEU', 'ألمانيا'),
(54253, 3257791008, 3257791015, 'NL', 'NLD', 'هولندا'),
(54254, 3257791016, 3257791023, 'DE', 'DEU', 'ألمانيا'),
(54255, 3257791024, 3257791151, 'NL', 'NLD', 'هولندا'),
(54256, 3257791152, 3257791159, 'DE', 'DEU', 'ألمانيا'),
(54257, 3257791160, 3257791223, 'NL', 'NLD', 'هولندا'),
(54258, 3257791224, 3257791231, 'DE', 'DEU', 'ألمانيا'),
(54259, 3257791232, 3257791255, 'NL', 'NLD', 'هولندا'),
(54260, 3257791256, 3257791263, 'DE', 'DEU', 'ألمانيا'),
(54261, 3257791264, 3257791271, 'NL', 'NLD', 'هولندا'),
(54262, 3257791272, 3257791287, 'DE', 'DEU', 'ألمانيا'),
(54263, 3257791288, 3257791327, 'NL', 'NLD', 'هولندا'),
(54264, 3257791328, 3257791335, 'DE', 'DEU', 'ألمانيا'),
(54265, 3257791336, 3257791359, 'NL', 'NLD', 'هولندا'),
(54266, 3257791360, 3257791375, 'DE', 'DEU', 'ألمانيا'),
(54267, 3257791376, 3257791503, 'NL', 'NLD', 'هولندا'),
(54268, 3257791504, 3257791511, 'DE', 'DEU', 'ألمانيا'),
(54269, 3257791512, 3257791527, 'NL', 'NLD', 'هولندا'),
(54270, 3257791528, 3257791535, 'DE', 'DEU', 'ألمانيا'),
(54271, 3257791536, 3257791623, 'NL', 'NLD', 'هولندا'),
(54272, 3257791624, 3257791631, 'DE', 'DEU', 'ألمانيا'),
(54273, 3257791632, 3257791703, 'NL', 'NLD', 'هولندا'),
(54274, 3257791704, 3257791711, 'DE', 'DEU', 'ألمانيا'),
(54275, 3257791712, 3257791727, 'NL', 'NLD', 'هولندا'),
(54276, 3257791728, 3257791743, 'DE', 'DEU', 'ألمانيا'),
(54277, 3257791744, 3257791831, 'NL', 'NLD', 'هولندا'),
(54278, 3257791832, 3257791839, 'DE', 'DEU', 'ألمانيا'),
(54279, 3257791840, 3257791863, 'NL', 'NLD', 'هولندا'),
(54280, 3257791864, 3257791871, 'DE', 'DEU', 'ألمانيا'),
(54281, 3257791872, 3257791879, 'NL', 'NLD', 'هولندا'),
(54282, 3257791880, 3257791887, 'DE', 'DEU', 'ألمانيا'),
(54283, 3257791888, 3257791895, 'NL', 'NLD', 'هولندا'),
(54284, 3257791896, 3257791903, 'DE', 'DEU', 'ألمانيا'),
(54285, 3257791904, 3257791951, 'NL', 'NLD', 'هولندا'),
(54286, 3257791952, 3257791959, 'DE', 'DEU', 'ألمانيا'),
(54287, 3257791960, 3257792095, 'NL', 'NLD', 'هولندا'),
(54288, 3257792096, 3257792103, 'DE', 'DEU', 'ألمانيا'),
(54289, 3257792104, 3257792127, 'NL', 'NLD', 'هولندا'),
(54290, 3257792128, 3257792135, 'DE', 'DEU', 'ألمانيا'),
(54291, 3257792136, 3257792143, 'NL', 'NLD', 'هولندا'),
(54292, 3257792144, 3257792159, 'DE', 'DEU', 'ألمانيا'),
(54293, 3257792160, 3257792191, 'NL', 'NLD', 'هولندا'),
(54294, 3257792192, 3257792199, 'DE', 'DEU', 'ألمانيا'),
(54295, 3257792200, 3257792207, 'NL', 'NLD', 'هولندا'),
(54296, 3257792208, 3257792215, 'DE', 'DEU', 'ألمانيا'),
(54297, 3257792216, 3257792383, 'NL', 'NLD', 'هولندا'),
(54298, 3257792384, 3257792391, 'DE', 'DEU', 'ألمانيا'),
(54299, 3257792392, 3257792399, 'NL', 'NLD', 'هولندا'),
(54300, 3257792400, 3257792407, 'DE', 'DEU', 'ألمانيا'),
(54301, 3257792408, 3257792487, 'NL', 'NLD', 'هولندا'),
(54302, 3257792488, 3257792495, 'DE', 'DEU', 'ألمانيا'),
(54303, 3257792496, 3257792503, 'NL', 'NLD', 'هولندا'),
(54304, 3257792504, 3257792511, 'DE', 'DEU', 'ألمانيا'),
(54305, 3257792512, 3257792607, 'NL', 'NLD', 'هولندا'),
(54306, 3257792608, 3257792615, 'DE', 'DEU', 'ألمانيا'),
(54307, 3257792616, 3257792719, 'NL', 'NLD', 'هولندا'),
(54308, 3257792720, 3257792727, 'DE', 'DEU', 'ألمانيا'),
(54309, 3257792728, 3257792783, 'NL', 'NLD', 'هولندا'),
(54310, 3257792784, 3257792791, 'DE', 'DEU', 'ألمانيا'),
(54311, 3257792792, 3257792927, 'NL', 'NLD', 'هولندا'),
(54312, 3257792928, 3257792935, 'DE', 'DEU', 'ألمانيا'),
(54313, 3257792936, 3257793087, 'NL', 'NLD', 'هولندا'),
(54314, 3257793088, 3257793095, 'DE', 'DEU', 'ألمانيا'),
(54315, 3257793096, 3257793167, 'NL', 'NLD', 'هولندا'),
(54316, 3257793168, 3257793175, 'DE', 'DEU', 'ألمانيا'),
(54317, 3257793176, 3257793215, 'NL', 'NLD', 'هولندا'),
(54318, 3257793216, 3257793223, 'DE', 'DEU', 'ألمانيا'),
(54319, 3257793224, 3257793391, 'NL', 'NLD', 'هولندا'),
(54320, 3257793392, 3257793399, 'DE', 'DEU', 'ألمانيا'),
(54321, 3257793400, 3257793415, 'NL', 'NLD', 'هولندا'),
(54322, 3257793416, 3257793431, 'DE', 'DEU', 'ألمانيا'),
(54323, 3257793432, 3257793439, 'NL', 'NLD', 'هولندا'),
(54324, 3257793440, 3257793447, 'DE', 'DEU', 'ألمانيا'),
(54325, 3257793448, 3257793519, 'NL', 'NLD', 'هولندا'),
(54326, 3257793520, 3257793527, 'DE', 'DEU', 'ألمانيا'),
(54327, 3257793528, 3257793551, 'NL', 'NLD', 'هولندا'),
(54328, 3257793552, 3257793559, 'DE', 'DEU', 'ألمانيا'),
(54329, 3257793560, 3257793839, 'NL', 'NLD', 'هولندا'),
(54330, 3257793840, 3257793847, 'DE', 'DEU', 'ألمانيا'),
(54331, 3257793848, 3257793919, 'NL', 'NLD', 'هولندا'),
(54332, 3257793920, 3257793927, 'DE', 'DEU', 'ألمانيا'),
(54333, 3257793928, 3257793951, 'NL', 'NLD', 'هولندا'),
(54334, 3257793952, 3257793959, 'DE', 'DEU', 'ألمانيا'),
(54335, 3257793960, 3257794095, 'NL', 'NLD', 'هولندا'),
(54336, 3257794096, 3257794103, 'DE', 'DEU', 'ألمانيا'),
(54337, 3257794104, 3257794135, 'NL', 'NLD', 'هولندا'),
(54338, 3257794136, 3257794143, 'DE', 'DEU', 'ألمانيا'),
(54339, 3257794144, 3257794351, 'NL', 'NLD', 'هولندا'),
(54340, 3257794352, 3257794359, 'DE', 'DEU', 'ألمانيا'),
(54341, 3257794360, 3257794511, 'NL', 'NLD', 'هولندا'),
(54342, 3257794512, 3257794519, 'DE', 'DEU', 'ألمانيا'),
(54343, 3257794520, 3257794559, 'NL', 'NLD', 'هولندا'),
(54344, 3257794560, 3257827327, 'GB', 'GBR', 'المملكة المتحدة'),
(54345, 3257827328, 3257827839, 'IE', 'IRL', 'إيرلندا'),
(54346, 3257827840, 3257829375, 'GB', 'GBR', 'المملكة المتحدة'),
(54347, 3257829376, 3257830399, 'IE', 'IRL', 'إيرلندا'),
(54348, 3257830400, 3257835519, 'GB', 'GBR', 'المملكة المتحدة'),
(54349, 3257835520, 3257844223, 'IE', 'IRL', 'إيرلندا'),
(54350, 3257844224, 3257851903, 'GB', 'GBR', 'المملكة المتحدة'),
(54351, 3257851904, 3257860095, 'IE', 'IRL', 'إيرلندا'),
(54352, 3257860096, 3257925631, 'SE', 'SWE', 'السويد'),
(54353, 3257925632, 3257925887, 'AT', 'AUT', 'النمسا'),
(54354, 3257925888, 3257926143, 'SE', 'SWE', 'السويد'),
(54355, 3257926144, 3257970431, 'AT', 'AUT', 'النمسا'),
(54356, 3257970432, 3257970687, 'UA', 'UKR', 'أوكرانيا'),
(54357, 3257970688, 3257977855, 'AT', 'AUT', 'النمسا'),
(54358, 3257977856, 3257978111, 'GB', 'GBR', 'المملكة المتحدة'),
(54359, 3257978112, 3257978367, 'SE', 'SWE', 'السويد'),
(54360, 3257978368, 3257978623, 'BG', 'BGR', 'بلغاريا'),
(54361, 3257978624, 3257978879, 'ES', 'ESP', 'إسبانيا'),
(54362, 3257978880, 3257979135, 'FR', 'FRA', 'فرنسا'),
(54363, 3257979392, 3257979647, 'GB', 'GBR', 'المملكة المتحدة'),
(54364, 3257979648, 3257979903, 'DE', 'DEU', 'ألمانيا'),
(54365, 3257979904, 3257980159, 'UA', 'UKR', 'أوكرانيا'),
(54366, 3257980160, 3257980415, 'SE', 'SWE', 'السويد'),
(54367, 3257980416, 3257980671, 'NL', 'NLD', 'هولندا'),
(54368, 3257980672, 3257980927, 'CH', 'CHE', 'سويسرا'),
(54369, 3257980928, 3257981183, 'PL', 'POL', 'بولندا'),
(54370, 3257981184, 3257981439, 'GB', 'GBR', 'المملكة المتحدة'),
(54371, 3257981440, 3257981695, 'RU', 'RUS', 'الإتحاد الروسي'),
(54372, 3257981696, 3257981951, 'PL', 'POL', 'بولندا'),
(54373, 3257981952, 3257987327, 'AT', 'AUT', 'النمسا'),
(54374, 3257987328, 3257987583, 'CZ', 'CZE', 'التشيك'),
(54375, 3257987584, 3257991167, 'AT', 'AUT', 'النمسا'),
(54376, 3257991168, 3258003967, 'DE', 'DEU', 'ألمانيا'),
(54377, 3258003968, 3258004479, 'RU', 'RUS', 'الإتحاد الروسي'),
(54378, 3258004480, 3258005503, 'DE', 'DEU', 'ألمانيا'),
(54379, 3258005760, 3258013183, 'DE', 'DEU', 'ألمانيا'),
(54380, 3258013696, 3258018815, 'DE', 'DEU', 'ألمانيا'),
(54381, 3258019328, 3258021887, 'DE', 'DEU', 'ألمانيا'),
(54382, 3258023168, 3258023679, 'DE', 'DEU', 'ألمانيا'),
(54383, 3258023936, 3258056703, 'DE', 'DEU', 'ألمانيا'),
(54384, 3258056704, 3258056959, 'UA', 'UKR', 'أوكرانيا'),
(54385, 3258057216, 3258057727, 'CZ', 'CZE', 'التشيك'),
(54386, 3258058240, 3258058495, 'RU', 'RUS', 'الإتحاد الروسي'),
(54387, 3258058496, 3258059007, 'RO', 'ROM', 'رومانيا'),
(54388, 3258059008, 3258059263, 'UA', 'UKR', 'أوكرانيا'),
(54389, 3258059264, 3258059519, 'RU', 'RUS', 'الإتحاد الروسي'),
(54390, 3258059520, 3258059775, 'RO', 'ROM', 'رومانيا'),
(54391, 3258062848, 3258063871, 'CZ', 'CZE', 'التشيك'),
(54392, 3258063872, 3258064127, 'AT', 'AUT', 'النمسا'),
(54393, 3258064128, 3258064383, 'FR', 'FRA', 'فرنسا'),
(54394, 3258064384, 3258065151, 'GB', 'GBR', 'المملكة المتحدة'),
(54395, 3258065152, 3258065407, 'DE', 'DEU', 'ألمانيا'),
(54396, 3258065408, 3258065663, 'LI', 'LIE', 'ليختنشتاين'),
(54397, 3258065664, 3258065919, 'SA', 'SAU', 'السعودية'),
(54398, 3258065920, 3258066175, 'DE', 'DEU', 'ألمانيا'),
(54399, 3258066176, 3258066431, 'PL', 'POL', 'بولندا'),
(54400, 3258066432, 3258066943, 'FR', 'FRA', 'فرنسا'),
(54401, 3258066944, 3258067199, 'DK', 'DNK', 'الدنيمارك'),
(54402, 3258067200, 3258067455, 'GB', 'GBR', 'المملكة المتحدة'),
(54403, 3258067456, 3258067967, 'GR', 'GRC', 'اليونان'),
(54404, 3258067968, 3258068223, 'RO', 'ROM', 'رومانيا'),
(54405, 3258068224, 3258068479, 'CH', 'CHE', 'سويسرا'),
(54406, 3258068480, 3258068735, 'GB', 'GBR', 'المملكة المتحدة'),
(54407, 3258068736, 3258068991, 'DE', 'DEU', 'ألمانيا'),
(54408, 3258068992, 3258069247, 'NL', 'NLD', 'هولندا'),
(54409, 3258069248, 3258069503, 'PL', 'POL', 'بولندا'),
(54410, 3258069504, 3258069759, 'RO', 'ROM', 'رومانيا'),
(54411, 3258069760, 3258070015, 'UA', 'UKR', 'أوكرانيا'),
(54412, 3258070016, 3258070271, 'GB', 'GBR', 'المملكة المتحدة'),
(54413, 3258070272, 3258070527, 'PL', 'POL', 'بولندا'),
(54414, 3258070528, 3258071295, 'GB', 'GBR', 'المملكة المتحدة'),
(54415, 3258071296, 3258071551, 'DK', 'DNK', 'الدنيمارك'),
(54416, 3258071552, 3258071807, 'DE', 'DEU', 'ألمانيا'),
(54417, 3258071808, 3258072063, 'GB', 'GBR', 'المملكة المتحدة'),
(54418, 3258072064, 3258072319, 'FR', 'FRA', 'فرنسا'),
(54419, 3258072320, 3258072575, 'PL', 'POL', 'بولندا'),
(54420, 3258072576, 3258072831, 'BE', 'BEL', 'بلجيكا'),
(54421, 3258072832, 3258073087, 'RO', 'ROM', 'رومانيا'),
(54422, 3258073088, 3258074111, 'CZ', 'CZE', 'التشيك'),
(54423, 3258074112, 3258074879, 'DE', 'DEU', 'ألمانيا'),
(54424, 3258074880, 3258075135, 'IL', 'ISR', 'إسرائيل'),
(54425, 3258075136, 3258075391, 'RO', 'ROM', 'رومانيا'),
(54426, 3258075392, 3258075647, 'BG', 'BGR', 'بلغاريا'),
(54427, 3258075648, 3258075903, 'FR', 'FRA', 'فرنسا'),
(54428, 3258075904, 3258076159, 'PL', 'POL', 'بولندا'),
(54429, 3258076160, 3258076415, 'BG', 'BGR', 'بلغاريا'),
(54430, 3258076416, 3258076927, 'FR', 'FRA', 'فرنسا'),
(54431, 3258076928, 3258077183, 'UA', 'UKR', 'أوكرانيا'),
(54432, 3258077184, 3258077439, 'GB', 'GBR', 'المملكة المتحدة'),
(54433, 3258077440, 3258077695, 'UA', 'UKR', 'أوكرانيا'),
(54434, 3258077696, 3258077951, 'NL', 'NLD', 'هولندا'),
(54435, 3258077952, 3258078207, 'PL', 'POL', 'بولندا'),
(54436, 3258078208, 3258078463, 'TR', 'TUR', 'تركيا'),
(54437, 3258078464, 3258078719, 'UA', 'UKR', 'أوكرانيا'),
(54438, 3258078720, 3258078975, 'GB', 'GBR', 'المملكة المتحدة'),
(54439, 3258078976, 3258079231, 'RU', 'RUS', 'الإتحاد الروسي'),
(54440, 3258079232, 3258079487, 'GB', 'GBR', 'المملكة المتحدة'),
(54441, 3258079488, 3258079743, 'PL', 'POL', 'بولندا'),
(54442, 3258079744, 3258079999, 'GB', 'GBR', 'المملكة المتحدة'),
(54443, 3258080000, 3258080255, 'BE', 'BEL', 'بلجيكا'),
(54444, 3258080256, 3258080511, 'FR', 'FRA', 'فرنسا'),
(54445, 3258080512, 3258080767, 'DE', 'DEU', 'ألمانيا'),
(54446, 3258080768, 3258081023, 'GB', 'GBR', 'المملكة المتحدة'),
(54447, 3258081024, 3258081279, 'FR', 'FRA', 'فرنسا'),
(54448, 3258081280, 3258081535, 'NL', 'NLD', 'هولندا'),
(54449, 3258081536, 3258081791, 'BE', 'BEL', 'بلجيكا'),
(54450, 3258081792, 3258082047, 'UA', 'UKR', 'أوكرانيا'),
(54451, 3258082048, 3258082303, 'NL', 'NLD', 'هولندا'),
(54452, 3258082304, 3258082559, 'CZ', 'CZE', 'التشيك'),
(54453, 3258082560, 3258082815, 'HU', 'HUN', 'هنغاريا'),
(54454, 3258082816, 3258083071, 'NL', 'NLD', 'هولندا'),
(54455, 3258083072, 3258083583, 'RU', 'RUS', 'الإتحاد الروسي'),
(54456, 3258083584, 3258083839, 'LV', 'LVA', 'لاتفيا'),
(54457, 3258083840, 3258084351, 'SE', 'SWE', 'السويد'),
(54458, 3258084352, 3258084607, 'GB', 'GBR', 'المملكة المتحدة'),
(54459, 3258084608, 3258084863, 'AT', 'AUT', 'النمسا'),
(54460, 3258084864, 3258085119, 'PL', 'POL', 'بولندا'),
(54461, 3258085120, 3258085375, 'LT', 'LTU', 'ليتوانيا'),
(54462, 3258085376, 3258085631, 'NL', 'NLD', 'هولندا'),
(54463, 3258085632, 3258085887, 'DE', 'DEU', 'ألمانيا'),
(54464, 3258085888, 3258086143, 'UA', 'UKR', 'أوكرانيا'),
(54465, 3258086144, 3258086399, 'AT', 'AUT', 'النمسا'),
(54466, 3258086400, 3258086655, 'UA', 'UKR', 'أوكرانيا'),
(54467, 3258086656, 3258087167, 'GB', 'GBR', 'المملكة المتحدة'),
(54468, 3258087168, 3258087423, 'UA', 'UKR', 'أوكرانيا'),
(54469, 3258087424, 3258087679, 'RU', 'RUS', 'الإتحاد الروسي'),
(54470, 3258087680, 3258087935, 'GB', 'GBR', 'المملكة المتحدة'),
(54471, 3258087936, 3258088191, 'BG', 'BGR', 'بلغاريا'),
(54472, 3258088192, 3258088447, 'PL', 'POL', 'بولندا'),
(54473, 3258088448, 3258088703, 'BE', 'BEL', 'بلجيكا'),
(54474, 3258088704, 3258088959, 'UA', 'UKR', 'أوكرانيا'),
(54475, 3258088960, 3258089215, 'RO', 'ROM', 'رومانيا'),
(54476, 3258089216, 3258089471, 'FR', 'FRA', 'فرنسا'),
(54477, 3258097664, 3258097919, 'DE', 'DEU', 'ألمانيا'),
(54478, 3258097920, 3258098175, 'UA', 'UKR', 'أوكرانيا'),
(54479, 3258098176, 3258098431, 'DE', 'DEU', 'ألمانيا'),
(54480, 3258098432, 3258098687, 'NL', 'NLD', 'هولندا'),
(54481, 3258098688, 3258098943, 'DE', 'DEU', 'ألمانيا'),
(54482, 3258098944, 3258099199, 'GB', 'GBR', 'المملكة المتحدة'),
(54483, 3258099200, 3258099455, 'SI', 'SVN', 'سلوفينيا'),
(54484, 3258099456, 3258099711, 'UA', 'UKR', 'أوكرانيا'),
(54485, 3258099712, 3258099967, 'FI', 'FIN', 'فنلندا'),
(54486, 3258099968, 3258100223, 'UA', 'UKR', 'أوكرانيا'),
(54487, 3258100224, 3258100479, 'RO', 'ROM', 'رومانيا'),
(54488, 3258100480, 3258100735, 'DK', 'DNK', 'الدنيمارك'),
(54489, 3258100736, 3258100991, 'CH', 'CHE', 'سويسرا'),
(54490, 3258100992, 3258101247, 'AT', 'AUT', 'النمسا'),
(54491, 3258101248, 3258101503, 'RO', 'ROM', 'رومانيا'),
(54492, 3258101504, 3258101759, 'IL', 'ISR', 'إسرائيل'),
(54493, 3258101760, 3258102015, 'CH', 'CHE', 'سويسرا'),
(54494, 3258102016, 3258102271, 'BE', 'BEL', 'بلجيكا'),
(54495, 3258102272, 3258102527, 'CH', 'CHE', 'سويسرا'),
(54496, 3258102528, 3258102783, 'TR', 'TUR', 'تركيا'),
(54497, 3258102784, 3258103039, 'PL', 'POL', 'بولندا'),
(54498, 3258103040, 3258103295, 'SE', 'SWE', 'السويد'),
(54499, 3258103296, 3258103551, 'DE', 'DEU', 'ألمانيا'),
(54500, 3258103552, 3258103807, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(54501, 3258103808, 3258104063, 'SE', 'SWE', 'السويد'),
(54502, 3258104064, 3258104319, 'GB', 'GBR', 'المملكة المتحدة'),
(54503, 3258104320, 3258104575, 'PL', 'POL', 'بولندا'),
(54504, 3258104576, 3258104831, 'DE', 'DEU', 'ألمانيا'),
(54505, 3258105088, 3258105599, 'CZ', 'CZE', 'التشيك'),
(54506, 3258105600, 3258105855, 'DE', 'DEU', 'ألمانيا'),
(54507, 3258105856, 3258109951, 'CZ', 'CZE', 'التشيك'),
(54508, 3258109952, 3258110207, 'DK', 'DNK', 'الدنيمارك'),
(54509, 3258110208, 3258111487, 'CZ', 'CZE', 'التشيك'),
(54510, 3258111488, 3258111743, 'PL', 'POL', 'بولندا'),
(54511, 3258111744, 3258118399, 'CZ', 'CZE', 'التشيك'),
(54512, 3258118656, 3258119679, 'CZ', 'CZE', 'التشيك'),
(54513, 3258120192, 3258120703, 'CZ', 'CZE', 'التشيك'),
(54514, 3258120960, 3258121215, 'CZ', 'CZE', 'التشيك'),
(54515, 3258121216, 3258121471, 'PL', 'POL', 'بولندا'),
(54516, 3258121472, 3258121727, 'AT', 'AUT', 'النمسا'),
(54517, 3258121728, 3258121983, 'UA', 'UKR', 'أوكرانيا'),
(54518, 3258121984, 3258122239, 'RU', 'RUS', 'الإتحاد الروسي'),
(54519, 3258122240, 3258128895, 'FR', 'FRA', 'فرنسا'),
(54520, 3258128896, 3258129151, 'MC', 'MCO', 'موناكو'),
(54521, 3258129152, 3258163967, 'FR', 'FRA', 'فرنسا'),
(54522, 3258163968, 3258164223, 'BJ', 'BEN', 'بنين'),
(54523, 3258164224, 3258167551, 'FR', 'FRA', 'فرنسا'),
(54524, 3258167552, 3258167807, 'ES', 'ESP', 'إسبانيا'),
(54525, 3258167808, 3258187775, 'FR', 'FRA', 'فرنسا'),
(54526, 3258187776, 3258231551, 'SE', 'SWE', 'السويد'),
(54527, 3258231552, 3258232831, 'NO', 'NOR', 'النرويج'),
(54528, 3258232832, 3258250495, 'SE', 'SWE', 'السويد'),
(54529, 3258250496, 3258250751, 'NO', 'NOR', 'النرويج'),
(54530, 3258250752, 3258251007, 'SE', 'SWE', 'السويد'),
(54531, 3258251008, 3258251775, 'NO', 'NOR', 'النرويج'),
(54532, 3258251776, 3258253311, 'SE', 'SWE', 'السويد'),
(54533, 3258253312, 3258272767, 'NL', 'NLD', 'هولندا'),
(54534, 3258272768, 3258273791, 'FR', 'FRA', 'فرنسا'),
(54535, 3258273792, 3258297343, 'NL', 'NLD', 'هولندا'),
(54536, 3258297344, 3258297599, 'BE', 'BEL', 'بلجيكا'),
(54537, 3258297600, 3258298111, 'NL', 'NLD', 'هولندا'),
(54538, 3258298112, 3258298367, 'GB', 'GBR', 'المملكة المتحدة'),
(54539, 3258298368, 3258318847, 'NL', 'NLD', 'هولندا'),
(54540, 3258318848, 3258320895, 'DE', 'DEU', 'ألمانيا'),
(54541, 3258320896, 3258321919, 'GB', 'GBR', 'المملكة المتحدة'),
(54542, 3258321920, 3258322943, 'RU', 'RUS', 'الإتحاد الروسي'),
(54543, 3258322944, 3258326015, 'PL', 'POL', 'بولندا'),
(54544, 3258326016, 3258327039, 'SE', 'SWE', 'السويد'),
(54545, 3258327040, 3258335231, 'TR', 'TUR', 'تركيا'),
(54546, 3258335232, 3258336255, 'RU', 'RUS', 'الإتحاد الروسي'),
(54547, 3258336256, 3258337279, 'NO', 'NOR', 'النرويج'),
(54548, 3258337280, 3258338303, 'DE', 'DEU', 'ألمانيا'),
(54549, 3258338304, 3258340351, 'UA', 'UKR', 'أوكرانيا'),
(54550, 3258340352, 3258341375, 'PL', 'POL', 'بولندا'),
(54551, 3258341376, 3258342399, 'UA', 'UKR', 'أوكرانيا'),
(54552, 3258342400, 3258343423, 'DE', 'DEU', 'ألمانيا'),
(54553, 3258343424, 3258351615, 'NO', 'NOR', 'النرويج'),
(54554, 3258351616, 3258352639, 'RO', 'ROM', 'رومانيا'),
(54555, 3258352640, 3258353663, 'RU', 'RUS', 'الإتحاد الروسي'),
(54556, 3258353664, 3258354687, 'NO', 'NOR', 'النرويج'),
(54557, 3258354688, 3258355711, 'BG', 'BGR', 'بلغاريا'),
(54558, 3258355712, 3258356735, 'NL', 'NLD', 'هولندا'),
(54559, 3258356736, 3258357759, 'RU', 'RUS', 'الإتحاد الروسي'),
(54560, 3258357760, 3258360831, 'UA', 'UKR', 'أوكرانيا'),
(54561, 3258360832, 3258361855, 'SE', 'SWE', 'السويد'),
(54562, 3258361856, 3258362879, 'IL', 'ISR', 'إسرائيل'),
(54563, 3258362880, 3258363903, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(54564, 3258363904, 3258364927, 'RU', 'RUS', 'الإتحاد الروسي'),
(54565, 3258364928, 3258365951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(54566, 3258365952, 3258366975, 'UA', 'UKR', 'أوكرانيا'),
(54567, 3258366976, 3258367999, 'PL', 'POL', 'بولندا'),
(54568, 3258368000, 3258384383, 'KW', 'KWT', 'الكويت'),
(54569, 3258384384, 3258419199, 'DE', 'DEU', 'ألمانيا'),
(54570, 3258419456, 3258427647, 'DE', 'DEU', 'ألمانيا'),
(54571, 3258427648, 3258427903, 'RO', 'ROM', 'رومانيا'),
(54572, 3258427904, 3258428159, 'DE', 'DEU', 'ألمانيا'),
(54573, 3258428416, 3258431999, 'DE', 'DEU', 'ألمانيا'),
(54574, 3258432512, 3258449919, 'DE', 'DEU', 'ألمانيا'),
(54575, 3258449920, 3258502682, 'CH', 'CHE', 'سويسرا'),
(54576, 3258502683, 3258502683, 'FR', 'FRA', 'فرنسا'),
(54577, 3258502684, 3258503935, 'CH', 'CHE', 'سويسرا'),
(54578, 3258503936, 3258504191, 'PL', 'POL', 'بولندا'),
(54579, 3258504192, 3258504703, 'CH', 'CHE', 'سويسرا'),
(54580, 3258504704, 3258504959, 'DE', 'DEU', 'ألمانيا'),
(54581, 3258504960, 3258505215, 'IL', 'ISR', 'إسرائيل'),
(54582, 3258505216, 3258511871, 'CH', 'CHE', 'سويسرا'),
(54583, 3258512128, 3258514687, 'CH', 'CHE', 'سويسرا'),
(54584, 3258514944, 3258515455, 'CH', 'CHE', 'سويسرا'),
(54585, 3258515456, 3258580991, 'FR', 'FRA', 'فرنسا'),
(54586, 3258580992, 3258601983, 'RU', 'RUS', 'الإتحاد الروسي'),
(54587, 3258601984, 3258602495, 'UA', 'UKR', 'أوكرانيا'),
(54588, 3258602496, 3258625791, 'RU', 'RUS', 'الإتحاد الروسي'),
(54589, 3258625792, 3258626047, 'UA', 'UKR', 'أوكرانيا'),
(54590, 3258626048, 3258646527, 'RU', 'RUS', 'الإتحاد الروسي'),
(54591, 3258646528, 3258691583, 'DE', 'DEU', 'ألمانيا'),
(54592, 3258691584, 3258691839, 'RU', 'RUS', 'الإتحاد الروسي'),
(54593, 3258691840, 3258692351, 'AT', 'AUT', 'النمسا'),
(54594, 3258692352, 3258692607, 'DE', 'DEU', 'ألمانيا'),
(54595, 3258692608, 3258692863, 'FR', 'FRA', 'فرنسا'),
(54596, 3258692864, 3258693119, 'DE', 'DEU', 'ألمانيا'),
(54597, 3258693120, 3258693375, 'SI', 'SVN', 'سلوفينيا'),
(54598, 3258693376, 3258693631, 'DE', 'DEU', 'ألمانيا'),
(54599, 3258693632, 3258693887, 'RU', 'RUS', 'الإتحاد الروسي'),
(54600, 3258693888, 3258694143, 'SI', 'SVN', 'سلوفينيا'),
(54601, 3258694144, 3258694399, 'RU', 'RUS', 'الإتحاد الروسي'),
(54602, 3258694400, 3258694655, 'DE', 'DEU', 'ألمانيا'),
(54603, 3258694656, 3258694911, 'GB', 'GBR', 'المملكة المتحدة'),
(54604, 3258694912, 3258701567, 'DE', 'DEU', 'ألمانيا'),
(54605, 3258701824, 3258710271, 'DE', 'DEU', 'ألمانيا'),
(54606, 3258710528, 3258712063, 'DE', 'DEU', 'ألمانيا'),
(54607, 3258712064, 3258728447, 'GB', 'GBR', 'المملكة المتحدة'),
(54608, 3258728448, 3258729471, 'FR', 'FRA', 'فرنسا'),
(54609, 3258729472, 3258729727, 'DE', 'DEU', 'ألمانيا'),
(54610, 3258729728, 3258729983, 'UA', 'UKR', 'أوكرانيا'),
(54611, 3258729984, 3258730239, 'CH', 'CHE', 'سويسرا'),
(54612, 3258730240, 3258730495, 'NL', 'NLD', 'هولندا'),
(54613, 3258730496, 3258730751, 'RO', 'ROM', 'رومانيا'),
(54614, 3258730752, 3258731007, 'TR', 'TUR', 'تركيا'),
(54615, 3258731008, 3258731263, 'SI', 'SVN', 'سلوفينيا'),
(54616, 3258731264, 3258731519, 'NO', 'NOR', 'النرويج'),
(54617, 3258731520, 3258731775, 'ES', 'ESP', 'إسبانيا'),
(54618, 3258731776, 3258732031, 'UA', 'UKR', 'أوكرانيا'),
(54619, 3258732032, 3258732287, 'DE', 'DEU', 'ألمانيا'),
(54620, 3258732288, 3258732543, 'PL', 'POL', 'بولندا'),
(54621, 3258732544, 3258732799, 'SE', 'SWE', 'السويد'),
(54622, 3258732800, 3258733055, 'CH', 'CHE', 'سويسرا'),
(54623, 3258733056, 3258733311, 'RO', 'ROM', 'رومانيا'),
(54624, 3258733312, 3258746111, 'GB', 'GBR', 'المملكة المتحدة'),
(54625, 3258746368, 3258746623, 'GB', 'GBR', 'المملكة المتحدة'),
(54626, 3258746880, 3258748927, 'DE', 'DEU', 'ألمانيا'),
(54627, 3258748928, 3258764287, 'GB', 'GBR', 'المملكة المتحدة'),
(54628, 3258764288, 3258764543, 'DE', 'DEU', 'ألمانيا'),
(54629, 3258764544, 3258764799, 'RU', 'RUS', 'الإتحاد الروسي'),
(54630, 3258764800, 3258765055, 'BE', 'BEL', 'بلجيكا'),
(54631, 3258765056, 3258765311, 'NL', 'NLD', 'هولندا'),
(54632, 3258765312, 3258767615, 'GB', 'GBR', 'المملكة المتحدة'),
(54633, 3258767616, 3258767871, 'CH', 'CHE', 'سويسرا'),
(54634, 3258767872, 3258802175, 'GB', 'GBR', 'المملكة المتحدة'),
(54635, 3258802176, 3258806271, 'LU', 'LUX', 'لوكسيمبورغ'),
(54636, 3258806272, 3258818047, 'GB', 'GBR', 'المملكة المتحدة'),
(54637, 3258818048, 3258818303, 'SE', 'SWE', 'السويد'),
(54638, 3258818304, 3258843135, 'GB', 'GBR', 'المملكة المتحدة'),
(54639, 3258843136, 3258843391, 'RU', 'RUS', 'الإتحاد الروسي'),
(54640, 3258843392, 3258848767, 'GB', 'GBR', 'المملكة المتحدة'),
(54641, 3258848768, 3258849023, 'RO', 'ROM', 'رومانيا'),
(54642, 3258849024, 3258849279, 'DE', 'DEU', 'ألمانيا'),
(54643, 3258849280, 3258859519, 'GB', 'GBR', 'المملكة المتحدة'),
(54644, 3258859776, 3258883297, 'GB', 'GBR', 'المملكة المتحدة'),
(54645, 3258883328, 3258902783, 'GB', 'GBR', 'المملكة المتحدة'),
(54646, 3258902784, 3258903039, 'RU', 'RUS', 'الإتحاد الروسي'),
(54647, 3258903040, 3258903295, 'FR', 'FRA', 'فرنسا'),
(54648, 3258903296, 3258903551, 'GB', 'GBR', 'المملكة المتحدة'),
(54649, 3258903552, 3258903807, 'DE', 'DEU', 'ألمانيا'),
(54650, 3258903808, 3258904063, 'RU', 'RUS', 'الإتحاد الروسي'),
(54651, 3258904064, 3258941439, 'GB', 'GBR', 'المملكة المتحدة'),
(54652, 3258941440, 3258943487, 'PL', 'POL', 'بولندا'),
(54653, 3258943488, 3258944511, 'BG', 'BGR', 'بلغاريا'),
(54654, 3258944512, 3258946559, 'RU', 'RUS', 'الإتحاد الروسي'),
(54655, 3258946560, 3258947583, 'CH', 'CHE', 'سويسرا'),
(54656, 3258947584, 3258948607, 'RO', 'ROM', 'رومانيا'),
(54657, 3258948608, 3258949631, 'RU', 'RUS', 'الإتحاد الروسي'),
(54658, 3258949632, 3258972159, 'GR', 'GRC', 'اليونان'),
(54659, 3258972160, 3258974207, 'NO', 'NOR', 'النرويج'),
(54660, 3258974208, 3259023103, 'DE', 'DEU', 'ألمانيا'),
(54661, 3259023104, 3259023119, 'IT', 'ITA', 'إيطاليا'),
(54662, 3259023120, 3259032551, 'DE', 'DEU', 'ألمانيا'),
(54663, 3259032552, 3259032559, 'IT', 'ITA', 'إيطاليا'),
(54664, 3259032560, 3259032831, 'DE', 'DEU', 'ألمانيا'),
(54665, 3259032832, 3259032879, 'GB', 'GBR', 'المملكة المتحدة'),
(54666, 3259032880, 3259034319, 'DE', 'DEU', 'ألمانيا'),
(54667, 3259034320, 3259034327, 'GB', 'GBR', 'المملكة المتحدة'),
(54668, 3259034328, 3259035447, 'DE', 'DEU', 'ألمانيا'),
(54669, 3259035448, 3259035455, 'IT', 'ITA', 'إيطاليا'),
(54670, 3259035456, 3259039743, 'DE', 'DEU', 'ألمانيا'),
(54671, 3259039744, 3259062015, 'PT', 'PRT', 'البورتوغال'),
(54672, 3259062016, 3259062271, 'GW', 'GNB', 'غينيا بيساو'),
(54673, 3259062272, 3259105279, 'PT', 'PRT', 'البورتوغال'),
(54674, 3259105280, 3259170815, 'GB', 'GBR', 'المملكة المتحدة'),
(54675, 3259170816, 3259219967, 'RU', 'RUS', 'الإتحاد الروسي'),
(54676, 3259219968, 3259220479, 'BY', 'BLR', 'روسيا البيضاء'),
(54677, 3259220480, 3259223295, 'RU', 'RUS', 'الإتحاد الروسي'),
(54678, 3259223296, 3259223807, 'TM', 'TKM', 'تركمينيستان'),
(54679, 3259223808, 3259224831, 'KZ', 'KAZ', 'كازاخستان'),
(54680, 3259224832, 3259225343, 'TJ', 'TJK', 'طاجيكيستان'),
(54681, 3259225344, 3259226111, 'AZ', 'AZE', 'أذربيجان'),
(54682, 3259226112, 3259226623, 'UZ', 'UZB', 'أوزباكستان'),
(54683, 3259226624, 3259227135, 'AM', 'ARM', 'أرمينيا'),
(54684, 3259227136, 3259227391, 'RU', 'RUS', 'الإتحاد الروسي'),
(54685, 3259227392, 3259227903, 'KZ', 'KAZ', 'كازاخستان'),
(54686, 3259227904, 3259228159, 'DE', 'DEU', 'ألمانيا'),
(54687, 3259228160, 3259236351, 'RU', 'RUS', 'الإتحاد الروسي'),
(54688, 3259236352, 3259236863, 'SE', 'SWE', 'السويد'),
(54689, 3259236864, 3259237119, 'CH', 'CHE', 'سويسرا'),
(54690, 3259237120, 3259269375, 'SE', 'SWE', 'السويد'),
(54691, 3259269376, 3259269631, 'FR', 'FRA', 'فرنسا'),
(54692, 3259269632, 3259292415, 'SE', 'SWE', 'السويد'),
(54693, 3259292416, 3259292671, 'IT', 'ITA', 'إيطاليا'),
(54694, 3259292672, 3259301887, 'SE', 'SWE', 'السويد'),
(54695, 3259301888, 3259302143, 'DE', 'DEU', 'ألمانيا'),
(54696, 3259302144, 3259302399, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(54697, 3259302400, 3259303423, 'CH', 'CHE', 'سويسرا'),
(54698, 3259303424, 3259305983, 'SE', 'SWE', 'السويد'),
(54699, 3259305984, 3259310079, 'NL', 'NLD', 'هولندا'),
(54700, 3259310080, 3259310335, 'FR', 'FRA', 'فرنسا'),
(54701, 3259310336, 3259311103, 'DK', 'DNK', 'الدنيمارك'),
(54702, 3259311104, 3259311615, 'DE', 'DEU', 'ألمانيا'),
(54703, 3259312640, 3259313151, 'GB', 'GBR', 'المملكة المتحدة'),
(54704, 3259317248, 3259318271, 'CH', 'CHE', 'سويسرا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(54705, 3259318272, 3259318311, 'GB', 'GBR', 'المملكة المتحدة'),
(54706, 3259318312, 3259318319, 'BE', 'BEL', 'بلجيكا'),
(54707, 3259318320, 3259318343, 'GB', 'GBR', 'المملكة المتحدة'),
(54708, 3259318344, 3259318351, 'FR', 'FRA', 'فرنسا'),
(54709, 3259318352, 3259318367, 'GB', 'GBR', 'المملكة المتحدة'),
(54710, 3259318368, 3259318399, 'BE', 'BEL', 'بلجيكا'),
(54711, 3259318400, 3259318503, 'GB', 'GBR', 'المملكة المتحدة'),
(54712, 3259318504, 3259318511, 'BE', 'BEL', 'بلجيكا'),
(54713, 3259318512, 3259318527, 'GB', 'GBR', 'المملكة المتحدة'),
(54714, 3259318528, 3259318591, 'CH', 'CHE', 'سويسرا'),
(54715, 3259318592, 3259318599, 'GB', 'GBR', 'المملكة المتحدة'),
(54716, 3259318600, 3259318607, 'AT', 'AUT', 'النمسا'),
(54717, 3259318608, 3259318663, 'GB', 'GBR', 'المملكة المتحدة'),
(54718, 3259318664, 3259318671, 'DK', 'DNK', 'الدنيمارك'),
(54719, 3259318672, 3259318679, 'GB', 'GBR', 'المملكة المتحدة'),
(54720, 3259318680, 3259318687, 'IT', 'ITA', 'إيطاليا'),
(54721, 3259318688, 3259318727, 'GB', 'GBR', 'المملكة المتحدة'),
(54722, 3259318728, 3259318735, 'FR', 'FRA', 'فرنسا'),
(54723, 3259318736, 3259319055, 'GB', 'GBR', 'المملكة المتحدة'),
(54724, 3259319056, 3259319071, 'IT', 'ITA', 'إيطاليا'),
(54725, 3259319072, 3259319087, 'GB', 'GBR', 'المملكة المتحدة'),
(54726, 3259319088, 3259319095, 'SE', 'SWE', 'السويد'),
(54727, 3259319096, 3259319103, 'DK', 'DNK', 'الدنيمارك'),
(54728, 3259319104, 3259319111, 'FR', 'FRA', 'فرنسا'),
(54729, 3259319112, 3259319199, 'GB', 'GBR', 'المملكة المتحدة'),
(54730, 3259319200, 3259319215, 'DE', 'DEU', 'ألمانيا'),
(54731, 3259319216, 3259319255, 'GB', 'GBR', 'المملكة المتحدة'),
(54732, 3259319256, 3259319263, 'DK', 'DNK', 'الدنيمارك'),
(54733, 3259319264, 3259319287, 'GB', 'GBR', 'المملكة المتحدة'),
(54734, 3259319288, 3259319295, 'BE', 'BEL', 'بلجيكا'),
(54735, 3259319296, 3259319303, 'GB', 'GBR', 'المملكة المتحدة'),
(54736, 3259319304, 3259319311, 'BE', 'BEL', 'بلجيكا'),
(54737, 3259319312, 3259319319, 'DK', 'DNK', 'الدنيمارك'),
(54738, 3259319320, 3259319367, 'GB', 'GBR', 'المملكة المتحدة'),
(54739, 3259319368, 3259319375, 'BE', 'BEL', 'بلجيكا'),
(54740, 3259319376, 3259319407, 'GB', 'GBR', 'المملكة المتحدة'),
(54741, 3259319408, 3259319423, 'LU', 'LUX', 'لوكسيمبورغ'),
(54742, 3259319424, 3259319439, 'GB', 'GBR', 'المملكة المتحدة'),
(54743, 3259319440, 3259319447, 'CH', 'CHE', 'سويسرا'),
(54744, 3259319448, 3259319463, 'GB', 'GBR', 'المملكة المتحدة'),
(54745, 3259319464, 3259319471, 'DK', 'DNK', 'الدنيمارك'),
(54746, 3259319472, 3259319587, 'GB', 'GBR', 'المملكة المتحدة'),
(54747, 3259319588, 3259319591, 'NL', 'NLD', 'هولندا'),
(54748, 3259319592, 3259319663, 'GB', 'GBR', 'المملكة المتحدة'),
(54749, 3259319664, 3259319667, 'FR', 'FRA', 'فرنسا'),
(54750, 3259319668, 3259319823, 'GB', 'GBR', 'المملكة المتحدة'),
(54751, 3259319824, 3259319831, 'FR', 'FRA', 'فرنسا'),
(54752, 3259319832, 3259319879, 'GB', 'GBR', 'المملكة المتحدة'),
(54753, 3259319880, 3259319887, 'BY', 'BLR', 'روسيا البيضاء'),
(54754, 3259319888, 3259319987, 'GB', 'GBR', 'المملكة المتحدة'),
(54755, 3259319988, 3259319991, 'NL', 'NLD', 'هولندا'),
(54756, 3259319992, 3259320011, 'GB', 'GBR', 'المملكة المتحدة'),
(54757, 3259320012, 3259320015, 'BE', 'BEL', 'بلجيكا'),
(54758, 3259320016, 3259320055, 'GB', 'GBR', 'المملكة المتحدة'),
(54759, 3259320056, 3259320063, 'AT', 'AUT', 'النمسا'),
(54760, 3259320064, 3259320575, 'GB', 'GBR', 'المملكة المتحدة'),
(54761, 3259320576, 3259320583, 'FR', 'FRA', 'فرنسا'),
(54762, 3259320584, 3259320743, 'GB', 'GBR', 'المملكة المتحدة'),
(54763, 3259320744, 3259320751, 'NL', 'NLD', 'هولندا'),
(54764, 3259320752, 3259334655, 'GB', 'GBR', 'المملكة المتحدة'),
(54765, 3259334656, 3259338751, 'DE', 'DEU', 'ألمانيا'),
(54766, 3259338752, 3259339519, 'GB', 'GBR', 'المملكة المتحدة'),
(54767, 3259339520, 3259339775, 'JP', 'JPN', 'اليابان'),
(54768, 3259339776, 3259340031, 'US', 'USA', 'الولايات المتحدة'),
(54769, 3259340032, 3259342847, 'GB', 'GBR', 'المملكة المتحدة'),
(54770, 3259342848, 3259344895, 'CH', 'CHE', 'سويسرا'),
(54771, 3259344896, 3259345151, 'GB', 'GBR', 'المملكة المتحدة'),
(54772, 3259345152, 3259345407, 'IE', 'IRL', 'إيرلندا'),
(54773, 3259345408, 3259345663, 'CH', 'CHE', 'سويسرا'),
(54774, 3259346944, 3259347199, 'SE', 'SWE', 'السويد'),
(54775, 3259347200, 3259347455, 'DE', 'DEU', 'ألمانيا'),
(54776, 3259347456, 3259347967, 'CH', 'CHE', 'سويسرا'),
(54777, 3259347968, 3259348223, 'SE', 'SWE', 'السويد'),
(54778, 3259348224, 3259348991, 'CH', 'CHE', 'سويسرا'),
(54779, 3259348992, 3259351039, 'NL', 'NLD', 'هولندا'),
(54780, 3259351040, 3259351551, 'IT', 'ITA', 'إيطاليا'),
(54781, 3259351552, 3259352063, 'FR', 'FRA', 'فرنسا'),
(54782, 3259352064, 3259352575, 'CH', 'CHE', 'سويسرا'),
(54783, 3259352576, 3259353087, 'IE', 'IRL', 'إيرلندا'),
(54784, 3259353088, 3259353855, 'NO', 'NOR', 'النرويج'),
(54785, 3259353856, 3259354111, 'GB', 'GBR', 'المملكة المتحدة'),
(54786, 3259354112, 3259354367, 'NL', 'NLD', 'هولندا'),
(54787, 3259354368, 3259354623, 'DE', 'DEU', 'ألمانيا'),
(54788, 3259354624, 3259354879, 'TR', 'TUR', 'تركيا'),
(54789, 3259354880, 3259355135, 'PL', 'POL', 'بولندا'),
(54790, 3259355136, 3259359231, 'NO', 'NOR', 'النرويج'),
(54791, 3259359232, 3259367423, 'ES', 'ESP', 'إسبانيا'),
(54792, 3259367424, 3259432959, 'GB', 'GBR', 'المملكة المتحدة'),
(54793, 3259432960, 3259435263, 'SE', 'SWE', 'السويد'),
(54794, 3259435264, 3259435519, 'IT', 'ITA', 'إيطاليا'),
(54795, 3259435520, 3259457279, 'SE', 'SWE', 'السويد'),
(54796, 3259457280, 3259457535, 'IT', 'ITA', 'إيطاليا'),
(54797, 3259457536, 3259460351, 'SE', 'SWE', 'السويد'),
(54798, 3259460352, 3259460607, 'DE', 'DEU', 'ألمانيا'),
(54799, 3259460608, 3259465215, 'SE', 'SWE', 'السويد'),
(54800, 3259465216, 3259465471, 'KH', 'KHM', 'كامبوديا'),
(54801, 3259465472, 3259492351, 'SE', 'SWE', 'السويد'),
(54802, 3259492352, 3259493375, 'GB', 'GBR', 'المملكة المتحدة'),
(54803, 3259493376, 3259498495, 'SE', 'SWE', 'السويد'),
(54804, 3259498496, 3259506943, 'GB', 'GBR', 'المملكة المتحدة'),
(54805, 3259506944, 3259507199, 'ES', 'ESP', 'إسبانيا'),
(54806, 3259507200, 3259507711, 'GB', 'GBR', 'المملكة المتحدة'),
(54807, 3259507712, 3259507967, 'CH', 'CHE', 'سويسرا'),
(54808, 3259507968, 3259508223, 'GB', 'GBR', 'المملكة المتحدة'),
(54809, 3259508224, 3259508479, 'ES', 'ESP', 'إسبانيا'),
(54810, 3259508480, 3259515647, 'GB', 'GBR', 'المملكة المتحدة'),
(54811, 3259515648, 3259515903, 'ES', 'ESP', 'إسبانيا'),
(54812, 3259515904, 3259518207, 'GB', 'GBR', 'المملكة المتحدة'),
(54813, 3259518208, 3259518463, 'ES', 'ESP', 'إسبانيا'),
(54814, 3259518464, 3259518719, 'GB', 'GBR', 'المملكة المتحدة'),
(54815, 3259518720, 3259518975, 'ES', 'ESP', 'إسبانيا'),
(54816, 3259518976, 3259521023, 'GB', 'GBR', 'المملكة المتحدة'),
(54817, 3259521024, 3259521535, 'NL', 'NLD', 'هولندا'),
(54818, 3259521536, 3259541503, 'GB', 'GBR', 'المملكة المتحدة'),
(54819, 3259541504, 3259543551, 'NL', 'NLD', 'هولندا'),
(54820, 3259543552, 3259545599, 'GB', 'GBR', 'المملكة المتحدة'),
(54821, 3259545600, 3259546111, 'LB', 'LBN', 'لبنان'),
(54822, 3259546112, 3259555839, 'GB', 'GBR', 'المملكة المتحدة'),
(54823, 3259555840, 3259556095, 'ES', 'ESP', 'إسبانيا'),
(54824, 3259556096, 3259562495, 'GB', 'GBR', 'المملكة المتحدة'),
(54825, 3259562496, 3259562751, 'ES', 'ESP', 'إسبانيا'),
(54826, 3259562752, 3259576351, 'GB', 'GBR', 'المملكة المتحدة'),
(54827, 3259576352, 3259576359, 'ES', 'ESP', 'إسبانيا'),
(54828, 3259576360, 3259576799, 'GB', 'GBR', 'المملكة المتحدة'),
(54829, 3259576800, 3259576831, 'ES', 'ESP', 'إسبانيا'),
(54830, 3259576832, 3259577247, 'GB', 'GBR', 'المملكة المتحدة'),
(54831, 3259577248, 3259577263, 'IR', 'IRN', 'إيران'),
(54832, 3259577264, 3259581439, 'GB', 'GBR', 'المملكة المتحدة'),
(54833, 3259581440, 3259581951, 'ES', 'ESP', 'إسبانيا'),
(54834, 3259581952, 3259587583, 'GB', 'GBR', 'المملكة المتحدة'),
(54835, 3259587584, 3259588095, 'ES', 'ESP', 'إسبانيا'),
(54836, 3259588096, 3259588607, 'IT', 'ITA', 'إيطاليا'),
(54837, 3259588608, 3259596799, 'GB', 'GBR', 'المملكة المتحدة'),
(54838, 3259596800, 3259597055, 'ES', 'ESP', 'إسبانيا'),
(54839, 3259597056, 3259599359, 'GB', 'GBR', 'المملكة المتحدة'),
(54840, 3259599360, 3259599615, 'FR', 'FRA', 'فرنسا'),
(54841, 3259599616, 3259601151, 'GB', 'GBR', 'المملكة المتحدة'),
(54842, 3259601152, 3259601407, 'IE', 'IRL', 'إيرلندا'),
(54843, 3259601408, 3259614463, 'GB', 'GBR', 'المملكة المتحدة'),
(54844, 3259614464, 3259614719, 'DE', 'DEU', 'ألمانيا'),
(54845, 3259614720, 3259614975, 'GB', 'GBR', 'المملكة المتحدة'),
(54846, 3259614976, 3259615231, 'DE', 'DEU', 'ألمانيا'),
(54847, 3259615232, 3259615743, 'GB', 'GBR', 'المملكة المتحدة'),
(54848, 3259615744, 3259615999, 'FR', 'FRA', 'فرنسا'),
(54849, 3259616000, 3259620095, 'GB', 'GBR', 'المملكة المتحدة'),
(54850, 3259620096, 3259620351, 'DE', 'DEU', 'ألمانيا'),
(54851, 3259620352, 3259628031, 'GB', 'GBR', 'المملكة المتحدة'),
(54852, 3259628032, 3259628543, 'CH', 'CHE', 'سويسرا'),
(54853, 3259628544, 3259630335, 'GB', 'GBR', 'المملكة المتحدة'),
(54854, 3259630336, 3259630591, 'ES', 'ESP', 'إسبانيا'),
(54855, 3259630592, 3259633407, 'GB', 'GBR', 'المملكة المتحدة'),
(54856, 3259633408, 3259633663, 'DE', 'DEU', 'ألمانيا'),
(54857, 3259633664, 3259635711, 'GB', 'GBR', 'المملكة المتحدة'),
(54858, 3259635712, 3259635967, 'ES', 'ESP', 'إسبانيا'),
(54859, 3259635968, 3259637759, 'GB', 'GBR', 'المملكة المتحدة'),
(54860, 3259637760, 3259638015, 'ES', 'ESP', 'إسبانيا'),
(54861, 3259638016, 3259638783, 'GB', 'GBR', 'المملكة المتحدة'),
(54862, 3259638784, 3259639039, 'BE', 'BEL', 'بلجيكا'),
(54863, 3259639040, 3259639551, 'GB', 'GBR', 'المملكة المتحدة'),
(54864, 3259639552, 3259639807, 'DE', 'DEU', 'ألمانيا'),
(54865, 3259639808, 3259640319, 'GB', 'GBR', 'المملكة المتحدة'),
(54866, 3259640320, 3259640575, 'ES', 'ESP', 'إسبانيا'),
(54867, 3259640576, 3259640831, 'GB', 'GBR', 'المملكة المتحدة'),
(54868, 3259640832, 3259641343, 'ES', 'ESP', 'إسبانيا'),
(54869, 3259641344, 3259642367, 'GB', 'GBR', 'المملكة المتحدة'),
(54870, 3259642368, 3259642623, 'BE', 'BEL', 'بلجيكا'),
(54871, 3259642624, 3259650047, 'GB', 'GBR', 'المملكة المتحدة'),
(54872, 3259650048, 3259652095, 'NL', 'NLD', 'هولندا'),
(54873, 3259652096, 3259656959, 'GB', 'GBR', 'المملكة المتحدة'),
(54874, 3259656960, 3259657215, 'BE', 'BEL', 'بلجيكا'),
(54875, 3259657216, 3259657727, 'GB', 'GBR', 'المملكة المتحدة'),
(54876, 3259657728, 3259657887, 'BE', 'BEL', 'بلجيكا'),
(54877, 3259657888, 3259657919, 'GB', 'GBR', 'المملكة المتحدة'),
(54878, 3259657920, 3259657983, 'BE', 'BEL', 'بلجيكا'),
(54879, 3259657984, 3259660287, 'GB', 'GBR', 'المملكة المتحدة'),
(54880, 3259660288, 3259660295, 'CH', 'CHE', 'سويسرا'),
(54881, 3259660296, 3259660327, 'GB', 'GBR', 'المملكة المتحدة'),
(54882, 3259660328, 3259660335, 'CH', 'CHE', 'سويسرا'),
(54883, 3259660336, 3259660543, 'GB', 'GBR', 'المملكة المتحدة'),
(54884, 3259660544, 3259660799, 'CH', 'CHE', 'سويسرا'),
(54885, 3259660800, 3259695871, 'GB', 'GBR', 'المملكة المتحدة'),
(54886, 3259695872, 3259695903, 'ES', 'ESP', 'إسبانيا'),
(54887, 3259695904, 3259696639, 'GB', 'GBR', 'المملكة المتحدة'),
(54888, 3259696640, 3259696895, 'ES', 'ESP', 'إسبانيا'),
(54889, 3259696896, 3259701759, 'GB', 'GBR', 'المملكة المتحدة'),
(54890, 3259701760, 3259702303, 'DE', 'DEU', 'ألمانيا'),
(54891, 3259702304, 3259751423, 'GB', 'GBR', 'المملكة المتحدة'),
(54892, 3259751424, 3259751431, 'FR', 'FRA', 'فرنسا'),
(54893, 3259751432, 3259751551, 'GB', 'GBR', 'المملكة المتحدة'),
(54894, 3259751552, 3259751615, 'FR', 'FRA', 'فرنسا'),
(54895, 3259751616, 3259752191, 'GB', 'GBR', 'المملكة المتحدة'),
(54896, 3259752192, 3259752447, 'FR', 'FRA', 'فرنسا'),
(54897, 3259752448, 3259760639, 'GB', 'GBR', 'المملكة المتحدة'),
(54898, 3259760640, 3259814399, 'DE', 'DEU', 'ألمانيا'),
(54899, 3259814400, 3259814655, 'AT', 'AUT', 'النمسا'),
(54900, 3259814656, 3259821823, 'DE', 'DEU', 'ألمانيا'),
(54901, 3259821824, 3259822079, 'AT', 'AUT', 'النمسا'),
(54902, 3259822080, 3259823103, 'DE', 'DEU', 'ألمانيا'),
(54903, 3259824128, 3259851823, 'DE', 'DEU', 'ألمانيا'),
(54904, 3259851824, 3259851831, 'GB', 'GBR', 'المملكة المتحدة'),
(54905, 3259851832, 3259891711, 'DE', 'DEU', 'ألمانيا'),
(54906, 3259891712, 3259957247, 'BE', 'BEL', 'بلجيكا'),
(54907, 3259957248, 3259958271, 'DE', 'DEU', 'ألمانيا'),
(54908, 3259958272, 3259959295, 'RU', 'RUS', 'الإتحاد الروسي'),
(54909, 3259959296, 3259960319, 'UA', 'UKR', 'أوكرانيا'),
(54910, 3259960320, 3259961343, 'BG', 'BGR', 'بلغاريا'),
(54911, 3259961344, 3259962367, 'FI', 'FIN', 'فنلندا'),
(54912, 3259962368, 3259963391, 'UA', 'UKR', 'أوكرانيا'),
(54913, 3259963392, 3259964415, 'PL', 'POL', 'بولندا'),
(54914, 3259964416, 3259965439, 'GB', 'GBR', 'المملكة المتحدة'),
(54915, 3259965440, 3259966463, 'RU', 'RUS', 'الإتحاد الروسي'),
(54916, 3259966464, 3259967487, 'DE', 'DEU', 'ألمانيا'),
(54917, 3259967488, 3259968511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(54918, 3259968512, 3259969535, 'RU', 'RUS', 'الإتحاد الروسي'),
(54919, 3259969536, 3259970559, 'FR', 'FRA', 'فرنسا'),
(54920, 3259970560, 3259971583, 'CZ', 'CZE', 'التشيك'),
(54921, 3259971584, 3259972607, 'IT', 'ITA', 'إيطاليا'),
(54922, 3259972608, 3259973631, 'UA', 'UKR', 'أوكرانيا'),
(54923, 3259973632, 3259981823, 'PT', 'PRT', 'البورتوغال'),
(54924, 3259990016, 3260006399, 'FR', 'FRA', 'فرنسا'),
(54925, 3260006400, 3260014591, 'IT', 'ITA', 'إيطاليا'),
(54926, 3260014592, 3260018687, 'NL', 'NLD', 'هولندا'),
(54927, 3260018688, 3260019711, 'GB', 'GBR', 'المملكة المتحدة'),
(54928, 3260019712, 3260021247, 'DE', 'DEU', 'ألمانيا'),
(54929, 3260021248, 3260021759, 'RU', 'RUS', 'الإتحاد الروسي'),
(54930, 3260021760, 3260022271, 'GR', 'GRC', 'اليونان'),
(54931, 3260022272, 3260022783, 'NL', 'NLD', 'هولندا'),
(54932, 3260022784, 3260237775, 'GB', 'GBR', 'المملكة المتحدة'),
(54933, 3260237776, 3260237791, 'GR', 'GRC', 'اليونان'),
(54934, 3260237792, 3260284927, 'GB', 'GBR', 'المملكة المتحدة'),
(54935, 3260284928, 3260288767, 'RU', 'RUS', 'الإتحاد الروسي'),
(54936, 3260288768, 3260289023, 'KZ', 'KAZ', 'كازاخستان'),
(54937, 3260289024, 3260303935, 'RU', 'RUS', 'الإتحاد الروسي'),
(54938, 3260303936, 3260304127, 'BY', 'BLR', 'روسيا البيضاء'),
(54939, 3260304128, 3260322047, 'RU', 'RUS', 'الإتحاد الروسي'),
(54940, 3260322048, 3260322303, 'BY', 'BLR', 'روسيا البيضاء'),
(54941, 3260322304, 3260353535, 'RU', 'RUS', 'الإتحاد الروسي'),
(54942, 3260353536, 3260353791, 'AZ', 'AZE', 'أذربيجان'),
(54943, 3260353792, 3260354559, 'RU', 'RUS', 'الإتحاد الروسي'),
(54944, 3260354560, 3260355839, 'KZ', 'KAZ', 'كازاخستان'),
(54945, 3260355840, 3260415487, 'RU', 'RUS', 'الإتحاد الروسي'),
(54946, 3260415488, 3260415999, 'BY', 'BLR', 'روسيا البيضاء'),
(54947, 3260416000, 3260481535, 'FI', 'FIN', 'فنلندا'),
(54948, 3260481536, 3260547071, 'RU', 'RUS', 'الإتحاد الروسي'),
(54949, 3260547072, 3260547327, 'DE', 'DEU', 'ألمانيا'),
(54950, 3260547328, 3260547583, 'UA', 'UKR', 'أوكرانيا'),
(54951, 3260547584, 3260547839, 'NL', 'NLD', 'هولندا'),
(54952, 3260547840, 3260548095, 'PL', 'POL', 'بولندا'),
(54953, 3260548096, 3260548351, 'IE', 'IRL', 'إيرلندا'),
(54954, 3260548352, 3260548607, 'DK', 'DNK', 'الدنيمارك'),
(54955, 3260548608, 3260548863, 'RO', 'ROM', 'رومانيا'),
(54956, 3260548864, 3260549119, 'CH', 'CHE', 'سويسرا'),
(54957, 3260549120, 3260549375, 'AT', 'AUT', 'النمسا'),
(54958, 3260549376, 3260549631, 'CH', 'CHE', 'سويسرا'),
(54959, 3260549632, 3260549887, 'DE', 'DEU', 'ألمانيا'),
(54960, 3260549888, 3260550143, 'RU', 'RUS', 'الإتحاد الروسي'),
(54961, 3260550144, 3260550399, 'PL', 'POL', 'بولندا'),
(54962, 3260550400, 3260550655, 'DE', 'DEU', 'ألمانيا'),
(54963, 3260550656, 3260550911, 'RU', 'RUS', 'الإتحاد الروسي'),
(54964, 3260550912, 3260551167, 'ES', 'ESP', 'إسبانيا'),
(54965, 3260551168, 3260553983, 'DE', 'DEU', 'ألمانيا'),
(54966, 3260553984, 3260554239, 'GB', 'GBR', 'المملكة المتحدة'),
(54967, 3260554240, 3260555263, 'SE', 'SWE', 'السويد'),
(54968, 3260555264, 3260559615, 'HU', 'HUN', 'هنغاريا'),
(54969, 3260559616, 3260559647, 'RO', 'ROM', 'رومانيا'),
(54970, 3260559648, 3260559711, 'HU', 'HUN', 'هنغاريا'),
(54971, 3260559712, 3260559719, 'RO', 'ROM', 'رومانيا'),
(54972, 3260559720, 3260563455, 'HU', 'HUN', 'هنغاريا'),
(54973, 3260563456, 3260571647, 'GB', 'GBR', 'المملكة المتحدة'),
(54974, 3260571648, 3260579839, 'BE', 'BEL', 'بلجيكا'),
(54975, 3260579840, 3260580351, 'PL', 'POL', 'بولندا'),
(54976, 3260580352, 3260580863, 'HU', 'HUN', 'هنغاريا'),
(54977, 3260580864, 3260581375, 'GB', 'GBR', 'المملكة المتحدة'),
(54978, 3260581376, 3260581887, 'RO', 'ROM', 'رومانيا'),
(54979, 3260581888, 3260582399, 'IL', 'ISR', 'إسرائيل'),
(54980, 3260582400, 3260583423, 'RU', 'RUS', 'الإتحاد الروسي'),
(54981, 3260583424, 3260583935, 'PT', 'PRT', 'البورتوغال'),
(54982, 3260583936, 3260584447, 'NO', 'NOR', 'النرويج'),
(54983, 3260584448, 3260585471, 'RO', 'ROM', 'رومانيا'),
(54984, 3260585472, 3260586495, 'UA', 'UKR', 'أوكرانيا'),
(54985, 3260586496, 3260587007, 'PL', 'POL', 'بولندا'),
(54986, 3260587008, 3260587519, 'FR', 'FRA', 'فرنسا'),
(54987, 3260587520, 3260588031, 'PL', 'POL', 'بولندا'),
(54988, 3260588032, 3260596223, 'DE', 'DEU', 'ألمانيا'),
(54989, 3260596224, 3260596735, 'CH', 'CHE', 'سويسرا'),
(54990, 3260596736, 3260597247, 'RO', 'ROM', 'رومانيا'),
(54991, 3260597248, 3260597759, 'CH', 'CHE', 'سويسرا'),
(54992, 3260597760, 3260598271, 'DE', 'DEU', 'ألمانيا'),
(54993, 3260598272, 3260598783, 'RU', 'RUS', 'الإتحاد الروسي'),
(54994, 3260598784, 3260599295, 'RO', 'ROM', 'رومانيا'),
(54995, 3260599296, 3260599807, 'RU', 'RUS', 'الإتحاد الروسي'),
(54996, 3260599808, 3260600319, 'UA', 'UKR', 'أوكرانيا'),
(54997, 3260600320, 3260601343, 'RU', 'RUS', 'الإتحاد الروسي'),
(54998, 3260601344, 3260601855, 'CH', 'CHE', 'سويسرا'),
(54999, 3260601856, 3260602367, 'PL', 'POL', 'بولندا'),
(55000, 3260602880, 3260603903, 'UA', 'UKR', 'أوكرانيا'),
(55001, 3260603904, 3260604415, 'FR', 'FRA', 'فرنسا'),
(55002, 3260604416, 3260604927, 'PL', 'POL', 'بولندا'),
(55003, 3260604928, 3260605439, 'RO', 'ROM', 'رومانيا'),
(55004, 3260605440, 3260605951, 'BG', 'BGR', 'بلغاريا'),
(55005, 3260605952, 3260606463, 'NL', 'NLD', 'هولندا'),
(55006, 3260606464, 3260607487, 'SE', 'SWE', 'السويد'),
(55007, 3260607488, 3260607999, 'NL', 'NLD', 'هولندا'),
(55008, 3260608000, 3260608511, 'RO', 'ROM', 'رومانيا'),
(55009, 3260608512, 3260609023, 'IE', 'IRL', 'إيرلندا'),
(55010, 3260609024, 3260609535, 'GB', 'GBR', 'المملكة المتحدة'),
(55011, 3260609536, 3260610047, 'PL', 'POL', 'بولندا'),
(55012, 3260610048, 3260610559, 'FR', 'FRA', 'فرنسا'),
(55013, 3260610560, 3260611071, 'RO', 'ROM', 'رومانيا'),
(55014, 3260611072, 3260611583, 'BG', 'BGR', 'بلغاريا'),
(55015, 3260611584, 3260612095, 'RU', 'RUS', 'الإتحاد الروسي'),
(55016, 3260612096, 3260612607, 'SE', 'SWE', 'السويد'),
(55017, 3260612608, 3260613631, 'FI', 'FIN', 'فنلندا'),
(55018, 3260613632, 3260613887, 'DE', 'DEU', 'ألمانيا'),
(55019, 3260613888, 3260614143, 'DK', 'DNK', 'الدنيمارك'),
(55020, 3260614144, 3260626175, 'FI', 'FIN', 'فنلندا'),
(55021, 3260626176, 3260626431, 'ES', 'ESP', 'إسبانيا'),
(55022, 3260626432, 3260668415, 'FI', 'FIN', 'فنلندا'),
(55023, 3260668416, 3260668671, 'ES', 'ESP', 'إسبانيا'),
(55024, 3260668672, 3260668927, 'GB', 'GBR', 'المملكة المتحدة'),
(55025, 3260668928, 3260669183, 'FI', 'FIN', 'فنلندا'),
(55026, 3260669184, 3260669695, 'DE', 'DEU', 'ألمانيا'),
(55027, 3260669696, 3260669951, 'IT', 'ITA', 'إيطاليا'),
(55028, 3260669952, 3260678143, 'FI', 'FIN', 'فنلندا'),
(55029, 3260678144, 3260743679, 'IL', 'ISR', 'إسرائيل'),
(55030, 3260743680, 3260800255, 'IT', 'ITA', 'إيطاليا'),
(55031, 3260800256, 3260800271, 'BE', 'BEL', 'بلجيكا'),
(55032, 3260800272, 3260809215, 'IT', 'ITA', 'إيطاليا'),
(55033, 3260809216, 3260874751, 'PL', 'POL', 'بولندا'),
(55034, 3260874752, 3260875775, 'DK', 'DNK', 'الدنيمارك'),
(55035, 3260875776, 3260876031, 'GB', 'GBR', 'المملكة المتحدة'),
(55036, 3260876032, 3260891391, 'DK', 'DNK', 'الدنيمارك'),
(55037, 3260891392, 3260891647, 'IT', 'ITA', 'إيطاليا'),
(55038, 3260891648, 3260891903, 'NL', 'NLD', 'هولندا'),
(55039, 3260891904, 3260892159, 'ES', 'ESP', 'إسبانيا'),
(55040, 3260892160, 3260892415, 'GB', 'GBR', 'المملكة المتحدة'),
(55041, 3260892416, 3260892671, 'FI', 'FIN', 'فنلندا'),
(55042, 3260892672, 3260892927, 'PT', 'PRT', 'البورتوغال'),
(55043, 3260892928, 3260893183, 'SE', 'SWE', 'السويد'),
(55044, 3260893184, 3260893439, 'AT', 'AUT', 'النمسا'),
(55045, 3260893440, 3260894207, 'SE', 'SWE', 'السويد'),
(55046, 3260894208, 3260895231, 'AT', 'AUT', 'النمسا'),
(55047, 3260895232, 3260898303, 'SE', 'SWE', 'السويد'),
(55048, 3260898304, 3260899327, 'ES', 'ESP', 'إسبانيا'),
(55049, 3260899328, 3260900095, 'CH', 'CHE', 'سويسرا'),
(55050, 3260900608, 3260901119, 'NL', 'NLD', 'هولندا'),
(55051, 3260901120, 3260903423, 'DE', 'DEU', 'ألمانيا'),
(55052, 3260903424, 3260906239, 'CH', 'CHE', 'سويسرا'),
(55053, 3260906240, 3260906367, 'DE', 'DEU', 'ألمانيا'),
(55054, 3260906496, 3260907519, 'FR', 'FRA', 'فرنسا'),
(55055, 3260907520, 3260915711, 'GB', 'GBR', 'المملكة المتحدة'),
(55056, 3260915712, 3260923903, 'UA', 'UKR', 'أوكرانيا'),
(55057, 3260923904, 3261071359, 'DE', 'DEU', 'ألمانيا'),
(55058, 3261071360, 3261136895, 'AT', 'AUT', 'النمسا'),
(55059, 3261136896, 3261150143, 'DE', 'DEU', 'ألمانيا'),
(55060, 3261150144, 3261150207, 'US', 'USA', 'الولايات المتحدة'),
(55061, 3261150208, 3261173987, 'DE', 'DEU', 'ألمانيا'),
(55062, 3261173988, 3261173991, 'AT', 'AUT', 'النمسا'),
(55063, 3261173992, 3261174007, 'DE', 'DEU', 'ألمانيا'),
(55064, 3261174008, 3261174015, 'AT', 'AUT', 'النمسا'),
(55065, 3261174016, 3261202431, 'DE', 'DEU', 'ألمانيا'),
(55066, 3261202432, 3261236863, 'FR', 'FRA', 'فرنسا'),
(55067, 3261236864, 3261236991, 'GB', 'GBR', 'المملكة المتحدة'),
(55068, 3261236992, 3261267967, 'FR', 'FRA', 'فرنسا'),
(55069, 3261267968, 3261297663, 'DE', 'DEU', 'ألمانيا'),
(55070, 3261297664, 3261297919, 'RU', 'RUS', 'الإتحاد الروسي'),
(55071, 3261297920, 3261298175, 'PL', 'POL', 'بولندا'),
(55072, 3261298176, 3261333503, 'DE', 'DEU', 'ألمانيا'),
(55073, 3261333504, 3261399039, 'FI', 'FIN', 'فنلندا'),
(55074, 3261399040, 3261472767, 'GB', 'GBR', 'المملكة المتحدة'),
(55075, 3261472768, 3261503487, 'RO', 'ROM', 'رومانيا'),
(55076, 3261503488, 3261503935, 'MD', 'MDA', 'مولدوفا'),
(55077, 3261503936, 3261530111, 'RO', 'ROM', 'رومانيا'),
(55078, 3261530112, 3261570303, 'SE', 'SWE', 'السويد'),
(55079, 3261570304, 3261570559, 'IT', 'ITA', 'إيطاليا'),
(55080, 3261570560, 3261595647, 'SE', 'SWE', 'السويد'),
(55081, 3261595648, 3261599743, 'NL', 'NLD', 'هولندا'),
(55082, 3261600768, 3261661183, 'NL', 'NLD', 'هولندا'),
(55083, 3261661184, 3261669375, 'RO', 'ROM', 'رومانيا'),
(55084, 3261669376, 3261673471, 'MT', 'MLT', 'مالطا'),
(55085, 3261673472, 3261675519, 'IT', 'ITA', 'إيطاليا'),
(55086, 3261675520, 3261675775, 'LV', 'LVA', 'لاتفيا'),
(55087, 3261675776, 3261676031, 'IT', 'ITA', 'إيطاليا'),
(55088, 3261676032, 3261676287, 'GB', 'GBR', 'المملكة المتحدة'),
(55089, 3261676288, 3261676543, 'IT', 'ITA', 'إيطاليا'),
(55090, 3261676544, 3261676799, 'DK', 'DNK', 'الدنيمارك'),
(55091, 3261676800, 3261677055, 'IT', 'ITA', 'إيطاليا'),
(55092, 3261677056, 3261685759, 'GB', 'GBR', 'المملكة المتحدة'),
(55093, 3261685760, 3261687807, 'DE', 'DEU', 'ألمانيا'),
(55094, 3261687808, 3261689855, 'RO', 'ROM', 'رومانيا'),
(55095, 3261689856, 3261691903, 'GB', 'GBR', 'المملكة المتحدة'),
(55096, 3261693952, 3261694463, 'NL', 'NLD', 'هولندا'),
(55097, 3261694464, 3261694975, 'RU', 'RUS', 'الإتحاد الروسي'),
(55098, 3261694976, 3261695487, 'PL', 'POL', 'بولندا'),
(55099, 3261695488, 3261695999, 'GB', 'GBR', 'المملكة المتحدة'),
(55100, 3261696000, 3261696511, 'UA', 'UKR', 'أوكرانيا'),
(55101, 3261696512, 3261697023, 'NL', 'NLD', 'هولندا'),
(55102, 3261697024, 3261698047, 'RO', 'ROM', 'رومانيا'),
(55103, 3261698048, 3261698559, 'UA', 'UKR', 'أوكرانيا'),
(55104, 3261698560, 3261699071, 'DE', 'DEU', 'ألمانيا'),
(55105, 3261699072, 3261699583, 'SA', 'SAU', 'السعودية'),
(55106, 3261699584, 3261700095, 'NL', 'NLD', 'هولندا'),
(55107, 3261700096, 3261700607, 'FR', 'FRA', 'فرنسا'),
(55108, 3261700608, 3261701119, 'GB', 'GBR', 'المملكة المتحدة'),
(55109, 3261701120, 3261701631, 'RU', 'RUS', 'الإتحاد الروسي'),
(55110, 3261701632, 3261702143, 'CH', 'CHE', 'سويسرا'),
(55111, 3261702144, 3261710335, 'GB', 'GBR', 'المملكة المتحدة'),
(55112, 3261710336, 3261718527, 'RU', 'RUS', 'الإتحاد الروسي'),
(55113, 3261718528, 3261726719, 'IS', 'ISL', 'أيسلندا'),
(55114, 3261726720, 3261734911, 'ES', 'ESP', 'إسبانيا'),
(55115, 3261734912, 3261743103, 'GB', 'GBR', 'المملكة المتحدة'),
(55116, 3261743104, 3261751295, 'MT', 'MLT', 'مالطا'),
(55117, 3261751296, 3261759487, 'EE', 'EST', 'إستونيا'),
(55118, 3261759488, 3261767679, 'IE', 'IRL', 'إيرلندا'),
(55119, 3261767680, 3261768703, 'RS', 'SRB', 'صربيا'),
(55120, 3261768704, 3261768959, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55121, 3261768960, 3261769471, 'RS', 'SRB', 'صربيا'),
(55122, 3261769472, 3261770239, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55123, 3261770240, 3261771263, 'RS', 'SRB', 'صربيا'),
(55124, 3261771264, 3261771775, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55125, 3261771776, 3261773055, 'RS', 'SRB', 'صربيا'),
(55126, 3261773056, 3261773311, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55127, 3261773312, 3261773375, 'RS', 'SRB', 'صربيا'),
(55128, 3261773376, 3261773567, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55129, 3261773568, 3261773831, 'RS', 'SRB', 'صربيا'),
(55130, 3261773832, 3261773855, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55131, 3261773856, 3261773856, 'RS', 'SRB', 'صربيا'),
(55132, 3261773857, 3261773863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55133, 3261773864, 3261773888, 'RS', 'SRB', 'صربيا'),
(55134, 3261773889, 3261773951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55135, 3261773952, 3261774015, 'RS', 'SRB', 'صربيا'),
(55136, 3261774016, 3261774079, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55137, 3261774080, 3261774143, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55138, 3261774144, 3261774175, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55139, 3261774176, 3261774191, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55140, 3261774192, 3261774207, 'RS', 'SRB', 'صربيا'),
(55141, 3261774208, 3261774223, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55142, 3261774224, 3261774239, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55143, 3261774240, 3261774271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55144, 3261774272, 3261774287, 'RS', 'SRB', 'صربيا'),
(55145, 3261774288, 3261774351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55146, 3261774352, 3261774399, 'RS', 'SRB', 'صربيا'),
(55147, 3261774400, 3261774847, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55148, 3261774848, 3261775871, 'RS', 'SRB', 'صربيا'),
(55149, 3261775872, 3261776383, 'PL', 'POL', 'بولندا'),
(55150, 3261776384, 3261777407, 'RU', 'RUS', 'الإتحاد الروسي'),
(55151, 3261777408, 3261777919, 'KZ', 'KAZ', 'كازاخستان'),
(55152, 3261777920, 3261778431, 'PL', 'POL', 'بولندا'),
(55153, 3261778432, 3261778943, 'RU', 'RUS', 'الإتحاد الروسي'),
(55154, 3261778944, 3261779455, 'RO', 'ROM', 'رومانيا'),
(55155, 3261779456, 3261779967, 'DE', 'DEU', 'ألمانيا'),
(55156, 3261779968, 3261780479, 'UA', 'UKR', 'أوكرانيا'),
(55157, 3261780480, 3261780991, 'PL', 'POL', 'بولندا'),
(55158, 3261780992, 3261781503, 'RO', 'ROM', 'رومانيا'),
(55159, 3261781504, 3261782015, 'PL', 'POL', 'بولندا'),
(55160, 3261782016, 3261783039, 'UA', 'UKR', 'أوكرانيا'),
(55161, 3261783040, 3261784063, 'GB', 'GBR', 'المملكة المتحدة'),
(55162, 3261784064, 3261796351, 'AT', 'AUT', 'النمسا'),
(55163, 3261796352, 3261796607, 'GB', 'GBR', 'المملكة المتحدة'),
(55164, 3261796608, 3261796863, 'RU', 'RUS', 'الإتحاد الروسي'),
(55165, 3261796864, 3261797119, 'PL', 'POL', 'بولندا'),
(55166, 3261797120, 3261797375, 'KR', 'KOR', 'جمهورية كوريا'),
(55167, 3261797376, 3261797631, 'AT', 'AUT', 'النمسا'),
(55168, 3261797632, 3261797887, 'RU', 'RUS', 'الإتحاد الروسي'),
(55169, 3261797888, 3261798143, 'TR', 'TUR', 'تركيا'),
(55170, 3261798144, 3261798399, 'RU', 'RUS', 'الإتحاد الروسي'),
(55171, 3261798400, 3261812735, 'AT', 'AUT', 'النمسا'),
(55172, 3261812736, 3261812991, 'RU', 'RUS', 'الإتحاد الروسي'),
(55173, 3261812992, 3261816575, 'AT', 'AUT', 'النمسا'),
(55174, 3261816576, 3261816831, 'DE', 'DEU', 'ألمانيا'),
(55175, 3261816832, 3261820927, 'AT', 'AUT', 'النمسا'),
(55176, 3261820928, 3261821183, 'RO', 'ROM', 'رومانيا'),
(55177, 3261821184, 3261821439, 'AT', 'AUT', 'النمسا'),
(55178, 3261821440, 3261821695, 'NL', 'NLD', 'هولندا'),
(55179, 3261821696, 3261821951, 'SI', 'SVN', 'سلوفينيا'),
(55180, 3261821952, 3261822207, 'RU', 'RUS', 'الإتحاد الروسي'),
(55181, 3261822208, 3261822463, 'UA', 'UKR', 'أوكرانيا'),
(55182, 3261822464, 3261822719, 'GB', 'GBR', 'المملكة المتحدة'),
(55183, 3261822720, 3261822975, 'SE', 'SWE', 'السويد'),
(55184, 3261822976, 3261823231, 'PL', 'POL', 'بولندا'),
(55185, 3261823232, 3261823743, 'NL', 'NLD', 'هولندا'),
(55186, 3261823744, 3261823999, 'BE', 'BEL', 'بلجيكا'),
(55187, 3261824000, 3261824255, 'PL', 'POL', 'بولندا'),
(55188, 3261824256, 3261824511, 'RU', 'RUS', 'الإتحاد الروسي'),
(55189, 3261824512, 3261824767, 'FR', 'FRA', 'فرنسا'),
(55190, 3261824768, 3261825023, 'PT', 'PRT', 'البورتوغال'),
(55191, 3261825024, 3261857791, 'AT', 'AUT', 'النمسا'),
(55192, 3261857792, 3261867951, 'CZ', 'CZE', 'التشيك'),
(55193, 3261867952, 3261867955, 'CR', 'CRI', 'كوستا ريكا'),
(55194, 3261867956, 3261923327, 'CZ', 'CZE', 'التشيك'),
(55195, 3261923328, 3261988863, 'NL', 'NLD', 'هولندا'),
(55196, 3261988864, 3261989119, 'SE', 'SWE', 'السويد'),
(55197, 3261989120, 3261990399, 'FI', 'FIN', 'فنلندا'),
(55198, 3261990656, 3261993471, 'FI', 'FIN', 'فنلندا'),
(55199, 3261993472, 3261993727, 'RU', 'RUS', 'الإتحاد الروسي'),
(55200, 3261993728, 3261995263, 'FI', 'FIN', 'فنلندا'),
(55201, 3261995264, 3261995519, 'DE', 'DEU', 'ألمانيا'),
(55202, 3261995520, 3261995775, 'PL', 'POL', 'بولندا'),
(55203, 3261995776, 3261996031, 'FI', 'FIN', 'فنلندا'),
(55204, 3261996032, 3261996287, 'NL', 'NLD', 'هولندا'),
(55205, 3261996288, 3262005247, 'FI', 'FIN', 'فنلندا'),
(55206, 3262005760, 3262006015, 'RU', 'RUS', 'الإتحاد الروسي'),
(55207, 3262006016, 3262006271, 'NL', 'NLD', 'هولندا'),
(55208, 3262006272, 3262006527, 'RO', 'ROM', 'رومانيا'),
(55209, 3262006528, 3262006783, 'FR', 'FRA', 'فرنسا'),
(55210, 3262006784, 3262007039, 'SE', 'SWE', 'السويد'),
(55211, 3262007040, 3262007295, 'IT', 'ITA', 'إيطاليا'),
(55212, 3262007296, 3262007551, 'SA', 'SAU', 'السعودية'),
(55213, 3262007552, 3262007807, 'GR', 'GRC', 'اليونان'),
(55214, 3262007808, 3262008063, 'RO', 'ROM', 'رومانيا'),
(55215, 3262008064, 3262008319, 'GB', 'GBR', 'المملكة المتحدة'),
(55216, 3262008320, 3262008575, 'PT', 'PRT', 'البورتوغال'),
(55217, 3262008576, 3262008831, 'PL', 'POL', 'بولندا'),
(55218, 3262008832, 3262009087, 'AT', 'AUT', 'النمسا'),
(55219, 3262009088, 3262009343, 'UA', 'UKR', 'أوكرانيا'),
(55220, 3262009344, 3262013439, 'FI', 'FIN', 'فنلندا'),
(55221, 3262013440, 3262017535, 'SE', 'SWE', 'السويد'),
(55222, 3262017536, 3262018559, 'FI', 'FIN', 'فنلندا'),
(55223, 3262018560, 3262018815, 'PL', 'POL', 'بولندا'),
(55224, 3262018816, 3262021119, 'FI', 'FIN', 'فنلندا'),
(55225, 3262021120, 3262021375, 'UA', 'UKR', 'أوكرانيا'),
(55226, 3262021376, 3262021631, 'PL', 'POL', 'بولندا'),
(55227, 3262021632, 3262021887, 'CH', 'CHE', 'سويسرا'),
(55228, 3262021888, 3262022143, 'UA', 'UKR', 'أوكرانيا'),
(55229, 3262022144, 3262022911, 'FI', 'FIN', 'فنلندا'),
(55230, 3262022912, 3262023167, 'DE', 'DEU', 'ألمانيا'),
(55231, 3262023168, 3262023679, 'FI', 'FIN', 'فنلندا'),
(55232, 3262023680, 3262023935, 'DK', 'DNK', 'الدنيمارك'),
(55233, 3262023936, 3262027263, 'FI', 'FIN', 'فنلندا'),
(55234, 3262027264, 3262027519, 'TR', 'TUR', 'تركيا'),
(55235, 3262027520, 3262027775, 'BE', 'BEL', 'بلجيكا'),
(55236, 3262029824, 3262030847, 'US', 'USA', 'الولايات المتحدة'),
(55237, 3262030848, 3262031871, 'FR', 'FRA', 'فرنسا'),
(55238, 3262031872, 3262032383, 'FI', 'FIN', 'فنلندا'),
(55239, 3262033920, 3262034111, 'FI', 'FIN', 'فنلندا'),
(55240, 3262034112, 3262034119, 'AX', 'FIN', 'فنلندا'),
(55241, 3262034120, 3262034123, 'FI', 'FIN', 'فنلندا'),
(55242, 3262034124, 3262034127, 'AX', 'FIN', 'فنلندا'),
(55243, 3262034128, 3262034455, 'FI', 'FIN', 'فنلندا'),
(55244, 3262034456, 3262034463, 'AX', 'FIN', 'فنلندا'),
(55245, 3262034464, 3262034527, 'FI', 'FIN', 'فنلندا'),
(55246, 3262034528, 3262034559, 'AX', 'FIN', 'فنلندا'),
(55247, 3262034560, 3262034687, 'FI', 'FIN', 'فنلندا'),
(55248, 3262034688, 3262034719, 'AX', 'FIN', 'فنلندا'),
(55249, 3262034720, 3262034943, 'FI', 'FIN', 'فنلندا'),
(55250, 3262034944, 3262035455, 'AX', 'FIN', 'فنلندا'),
(55251, 3262035456, 3262035487, 'FI', 'FIN', 'فنلندا'),
(55252, 3262035488, 3262035519, 'AX', 'FIN', 'فنلندا'),
(55253, 3262035520, 3262036143, 'FI', 'FIN', 'فنلندا'),
(55254, 3262036144, 3262036151, 'AX', 'FIN', 'فنلندا'),
(55255, 3262036152, 3262036287, 'FI', 'FIN', 'فنلندا'),
(55256, 3262036288, 3262036303, 'AX', 'FIN', 'فنلندا'),
(55257, 3262036304, 3262036311, 'FI', 'FIN', 'فنلندا'),
(55258, 3262036312, 3262036335, 'AX', 'FIN', 'فنلندا'),
(55259, 3262036336, 3262036367, 'FI', 'FIN', 'فنلندا'),
(55260, 3262036368, 3262036383, 'AX', 'FIN', 'فنلندا'),
(55261, 3262036384, 3262036415, 'FI', 'FIN', 'فنلندا'),
(55262, 3262036416, 3262036431, 'AX', 'FIN', 'فنلندا'),
(55263, 3262036432, 3262036463, 'FI', 'FIN', 'فنلندا'),
(55264, 3262036464, 3262036479, 'AX', 'FIN', 'فنلندا'),
(55265, 3262036480, 3262036607, 'FI', 'FIN', 'فنلندا'),
(55266, 3262036608, 3262036615, 'AX', 'FIN', 'فنلندا'),
(55267, 3262036616, 3262036719, 'FI', 'FIN', 'فنلندا'),
(55268, 3262036720, 3262038015, 'AX', 'FIN', 'فنلندا'),
(55269, 3262038016, 3262038271, 'FR', 'FRA', 'فرنسا'),
(55270, 3262038272, 3262038527, 'RU', 'RUS', 'الإتحاد الروسي'),
(55271, 3262038528, 3262038783, 'GB', 'GBR', 'المملكة المتحدة'),
(55272, 3262038784, 3262039039, 'NO', 'NOR', 'النرويج'),
(55273, 3262039040, 3262039295, 'DE', 'DEU', 'ألمانيا'),
(55274, 3262039296, 3262039551, 'GB', 'GBR', 'المملكة المتحدة'),
(55275, 3262039552, 3262039807, 'GR', 'GRC', 'اليونان'),
(55276, 3262039808, 3262040063, 'SI', 'SVN', 'سلوفينيا'),
(55277, 3262040064, 3262040319, 'PL', 'POL', 'بولندا'),
(55278, 3262040320, 3262040575, 'ES', 'ESP', 'إسبانيا'),
(55279, 3262040576, 3262040831, 'RU', 'RUS', 'الإتحاد الروسي'),
(55280, 3262040832, 3262041087, 'GB', 'GBR', 'المملكة المتحدة'),
(55281, 3262041088, 3262041343, 'HU', 'HUN', 'هنغاريا'),
(55282, 3262041344, 3262041599, 'BG', 'BGR', 'بلغاريا'),
(55283, 3262041600, 3262041855, 'DK', 'DNK', 'الدنيمارك'),
(55284, 3262041856, 3262042367, 'FR', 'FRA', 'فرنسا'),
(55285, 3262042368, 3262042623, 'GB', 'GBR', 'المملكة المتحدة'),
(55286, 3262042624, 3262042879, 'UA', 'UKR', 'أوكرانيا'),
(55287, 3262042880, 3262043135, 'NL', 'NLD', 'هولندا'),
(55288, 3262043136, 3262043391, 'RO', 'ROM', 'رومانيا'),
(55289, 3262043392, 3262043647, 'TR', 'TUR', 'تركيا'),
(55290, 3262043648, 3262043903, 'NL', 'NLD', 'هولندا'),
(55291, 3262043904, 3262044159, 'GB', 'GBR', 'المملكة المتحدة'),
(55292, 3262044160, 3262044415, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(55293, 3262044416, 3262044671, 'DE', 'DEU', 'ألمانيا'),
(55294, 3262044672, 3262044927, 'GR', 'GRC', 'اليونان'),
(55295, 3262044928, 3262045183, 'UA', 'UKR', 'أوكرانيا'),
(55296, 3262045184, 3262045439, 'LT', 'LTU', 'ليتوانيا'),
(55297, 3262045440, 3262045695, 'NL', 'NLD', 'هولندا'),
(55298, 3262045696, 3262045951, 'SI', 'SVN', 'سلوفينيا'),
(55299, 3262045952, 3262046207, 'RU', 'RUS', 'الإتحاد الروسي'),
(55300, 3262046208, 3262049279, 'FI', 'FIN', 'فنلندا'),
(55301, 3262049280, 3262049535, 'JO', 'JOR', 'الأردن'),
(55302, 3262049536, 3262049791, 'GB', 'GBR', 'المملكة المتحدة'),
(55303, 3262049792, 3262050559, 'PL', 'POL', 'بولندا'),
(55304, 3262050560, 3262050815, 'GB', 'GBR', 'المملكة المتحدة'),
(55305, 3262050816, 3262051071, 'CH', 'CHE', 'سويسرا'),
(55306, 3262051072, 3262051583, 'GB', 'GBR', 'المملكة المتحدة'),
(55307, 3262051584, 3262051839, 'FR', 'FRA', 'فرنسا'),
(55308, 3262051840, 3262052351, 'DE', 'DEU', 'ألمانيا'),
(55309, 3262052352, 3262052607, 'UA', 'UKR', 'أوكرانيا'),
(55310, 3262052608, 3262052863, 'IL', 'ISR', 'إسرائيل'),
(55311, 3262052864, 3262053119, 'GB', 'GBR', 'المملكة المتحدة'),
(55312, 3262053120, 3262053375, 'RU', 'RUS', 'الإتحاد الروسي'),
(55313, 3262053376, 3262053631, 'UA', 'UKR', 'أوكرانيا'),
(55314, 3262053632, 3262053887, 'RU', 'RUS', 'الإتحاد الروسي'),
(55315, 3262053888, 3262054143, 'UA', 'UKR', 'أوكرانيا'),
(55316, 3262054144, 3262054399, 'RU', 'RUS', 'الإتحاد الروسي'),
(55317, 3262054400, 3262099199, 'FI', 'FIN', 'فنلندا'),
(55318, 3262099200, 3262099455, 'NL', 'NLD', 'هولندا'),
(55319, 3262099456, 3262108671, 'FI', 'FIN', 'فنلندا'),
(55320, 3262108672, 3262108927, 'RU', 'RUS', 'الإتحاد الروسي'),
(55321, 3262108928, 3262114047, 'FI', 'FIN', 'فنلندا'),
(55322, 3262114048, 3262114303, 'SE', 'SWE', 'السويد'),
(55323, 3262114304, 3262115071, 'FI', 'FIN', 'فنلندا'),
(55324, 3262115072, 3262115327, 'RU', 'RUS', 'الإتحاد الروسي'),
(55325, 3262115328, 3262119935, 'FI', 'FIN', 'فنلندا'),
(55326, 3262119936, 3262120447, 'AX', 'FIN', 'فنلندا'),
(55327, 3262120448, 3262120703, 'FI', 'FIN', 'فنلندا'),
(55328, 3262120704, 3262121599, 'AX', 'FIN', 'فنلندا'),
(55329, 3262121600, 3262121663, 'FI', 'FIN', 'فنلندا'),
(55330, 3262121664, 3262121727, 'AX', 'FIN', 'فنلندا'),
(55331, 3262121728, 3262121983, 'FI', 'FIN', 'فنلندا'),
(55332, 3262121984, 3262122007, 'AX', 'FIN', 'فنلندا'),
(55333, 3262122008, 3262122015, 'FI', 'FIN', 'فنلندا'),
(55334, 3262122016, 3262122031, 'AX', 'FIN', 'فنلندا'),
(55335, 3262122032, 3262122143, 'FI', 'FIN', 'فنلندا'),
(55336, 3262122144, 3262122159, 'AX', 'FIN', 'فنلندا'),
(55337, 3262122160, 3262122239, 'FI', 'FIN', 'فنلندا'),
(55338, 3262122240, 3262122367, 'AX', 'FIN', 'فنلندا'),
(55339, 3262122368, 3262122431, 'FI', 'FIN', 'فنلندا'),
(55340, 3262122432, 3262122455, 'AX', 'FIN', 'فنلندا'),
(55341, 3262122456, 3262122463, 'FI', 'FIN', 'فنلندا'),
(55342, 3262122464, 3262122591, 'AX', 'FIN', 'فنلندا'),
(55343, 3262122592, 3262122631, 'FI', 'FIN', 'فنلندا'),
(55344, 3262122632, 3262122639, 'AX', 'FIN', 'فنلندا'),
(55345, 3262122640, 3262122751, 'FI', 'FIN', 'فنلندا'),
(55346, 3262122752, 3262122815, 'AX', 'FIN', 'فنلندا'),
(55347, 3262122816, 3262124031, 'FI', 'FIN', 'فنلندا'),
(55348, 3262124032, 3262128127, 'DE', 'DEU', 'ألمانيا'),
(55349, 3262128128, 3262136319, 'GB', 'GBR', 'المملكة المتحدة'),
(55350, 3262137600, 3262137855, 'DE', 'DEU', 'ألمانيا'),
(55351, 3262139392, 3262140415, 'GB', 'GBR', 'المملكة المتحدة'),
(55352, 3262140416, 3262140671, 'DE', 'DEU', 'ألمانيا'),
(55353, 3262141184, 3262141439, 'DE', 'DEU', 'ألمانيا'),
(55354, 3262141440, 3262142463, 'ES', 'ESP', 'إسبانيا'),
(55355, 3262142464, 3262142719, 'DE', 'DEU', 'ألمانيا'),
(55356, 3262143488, 3262143743, 'GB', 'GBR', 'المملكة المتحدة'),
(55357, 3262144000, 3262144047, 'DE', 'DEU', 'ألمانيا'),
(55358, 3262145024, 3262145279, 'DE', 'DEU', 'ألمانيا'),
(55359, 3262145552, 3262145567, 'DE', 'DEU', 'ألمانيا'),
(55360, 3262145616, 3262145631, 'DE', 'DEU', 'ألمانيا'),
(55361, 3262145664, 3262145791, 'DE', 'DEU', 'ألمانيا'),
(55362, 3262146048, 3262146815, 'DE', 'DEU', 'ألمانيا'),
(55363, 3262147584, 3262147839, 'DE', 'DEU', 'ألمانيا'),
(55364, 3262148608, 3262148863, 'DE', 'DEU', 'ألمانيا'),
(55365, 3262148880, 3262148919, 'DE', 'DEU', 'ألمانيا'),
(55366, 3262148928, 3262149119, 'DE', 'DEU', 'ألمانيا'),
(55367, 3262149120, 3262149151, 'FR', 'FRA', 'فرنسا'),
(55368, 3262149152, 3262149159, 'DE', 'DEU', 'ألمانيا'),
(55369, 3262149160, 3262149375, 'FR', 'FRA', 'فرنسا'),
(55370, 3262149632, 3262149887, 'DE', 'DEU', 'ألمانيا'),
(55371, 3262150912, 3262151047, 'DE', 'DEU', 'ألمانيا'),
(55372, 3262151072, 3262151103, 'DE', 'DEU', 'ألمانيا'),
(55373, 3262151136, 3262151151, 'DE', 'DEU', 'ألمانيا'),
(55374, 3262151168, 3262151423, 'DE', 'DEU', 'ألمانيا'),
(55375, 3262151936, 3262152191, 'DE', 'DEU', 'ألمانيا'),
(55376, 3262152664, 3262152671, 'DE', 'DEU', 'ألمانيا'),
(55377, 3262152704, 3262185471, 'AT', 'AUT', 'النمسا'),
(55378, 3262185472, 3262191615, 'DE', 'DEU', 'ألمانيا'),
(55379, 3262192128, 3262197503, 'DE', 'DEU', 'ألمانيا'),
(55380, 3262197760, 3262209535, 'DE', 'DEU', 'ألمانيا'),
(55381, 3262210048, 3262222847, 'DE', 'DEU', 'ألمانيا'),
(55382, 3262223360, 3262224895, 'DE', 'DEU', 'ألمانيا'),
(55383, 3262224896, 3262225151, 'AT', 'AUT', 'النمسا'),
(55384, 3262225152, 3262227711, 'DE', 'DEU', 'ألمانيا'),
(55385, 3262227712, 3262227967, 'RO', 'ROM', 'رومانيا'),
(55386, 3262227968, 3262283775, 'DE', 'DEU', 'ألمانيا'),
(55387, 3262283776, 3262284799, 'RU', 'RUS', 'الإتحاد الروسي'),
(55388, 3262284800, 3262286847, 'UA', 'UKR', 'أوكرانيا'),
(55389, 3262286848, 3262287871, 'SE', 'SWE', 'السويد'),
(55390, 3262287872, 3262289919, 'PL', 'POL', 'بولندا'),
(55391, 3262289920, 3262316543, 'SE', 'SWE', 'السويد'),
(55392, 3262316544, 3262348799, 'DE', 'DEU', 'ألمانيا'),
(55393, 3262348800, 3262349055, 'NL', 'NLD', 'هولندا'),
(55394, 3262349056, 3262382079, 'DE', 'DEU', 'ألمانيا'),
(55395, 3262382080, 3262414847, 'IT', 'ITA', 'إيطاليا'),
(55396, 3262414848, 3262415359, 'DE', 'DEU', 'ألمانيا'),
(55397, 3262415360, 3262416895, 'PL', 'POL', 'بولندا'),
(55398, 3262416896, 3262417407, 'RO', 'ROM', 'رومانيا'),
(55399, 3262417408, 3262417919, 'PL', 'POL', 'بولندا'),
(55400, 3262417920, 3262418431, 'RU', 'RUS', 'الإتحاد الروسي'),
(55401, 3262418432, 3262419455, 'FR', 'FRA', 'فرنسا'),
(55402, 3262419456, 3262419967, 'NL', 'NLD', 'هولندا'),
(55403, 3262419968, 3262420479, 'FR', 'FRA', 'فرنسا'),
(55404, 3262420480, 3262420991, 'CH', 'CHE', 'سويسرا'),
(55405, 3262420992, 3262421503, 'ES', 'ESP', 'إسبانيا'),
(55406, 3262421504, 3262422015, 'DE', 'DEU', 'ألمانيا'),
(55407, 3262422016, 3262422527, 'SE', 'SWE', 'السويد'),
(55408, 3262422528, 3262423039, 'AT', 'AUT', 'النمسا'),
(55409, 3262423040, 3262423551, 'GB', 'GBR', 'المملكة المتحدة'),
(55410, 3262423552, 3262424063, 'UA', 'UKR', 'أوكرانيا'),
(55411, 3262424064, 3262424575, 'IT', 'ITA', 'إيطاليا'),
(55412, 3262424576, 3262425087, 'FR', 'FRA', 'فرنسا'),
(55413, 3262425088, 3262425599, 'RO', 'ROM', 'رومانيا'),
(55414, 3262425600, 3262426111, 'UA', 'UKR', 'أوكرانيا'),
(55415, 3262426112, 3262426623, 'DE', 'DEU', 'ألمانيا'),
(55416, 3262426624, 3262427135, 'GB', 'GBR', 'المملكة المتحدة'),
(55417, 3262427136, 3262427647, 'FR', 'FRA', 'فرنسا'),
(55418, 3262427648, 3262428159, 'DK', 'DNK', 'الدنيمارك'),
(55419, 3262428160, 3262428671, 'CH', 'CHE', 'سويسرا'),
(55420, 3262428672, 3262429183, 'PL', 'POL', 'بولندا'),
(55421, 3262429184, 3262429695, 'ES', 'ESP', 'إسبانيا'),
(55422, 3262429696, 3262430207, 'DE', 'DEU', 'ألمانيا'),
(55423, 3262430208, 3262430719, 'EE', 'EST', 'إستونيا'),
(55424, 3262430720, 3262431231, 'RO', 'ROM', 'رومانيا'),
(55425, 3262431232, 3262431743, 'PL', 'POL', 'بولندا'),
(55426, 3262431744, 3262432255, 'UA', 'UKR', 'أوكرانيا'),
(55427, 3262432256, 3262432767, 'CH', 'CHE', 'سويسرا'),
(55428, 3262432768, 3262433279, 'GB', 'GBR', 'المملكة المتحدة'),
(55429, 3262433280, 3262433791, 'RO', 'ROM', 'رومانيا'),
(55430, 3262433792, 3262434303, 'FR', 'FRA', 'فرنسا'),
(55431, 3262434304, 3262434815, 'SI', 'SVN', 'سلوفينيا'),
(55432, 3262434816, 3262435839, 'DE', 'DEU', 'ألمانيا'),
(55433, 3262435840, 3262436351, 'CH', 'CHE', 'سويسرا'),
(55434, 3262436352, 3262436863, 'SE', 'SWE', 'السويد'),
(55435, 3262436864, 3262437375, 'GB', 'GBR', 'المملكة المتحدة'),
(55436, 3262437376, 3262437887, 'RO', 'ROM', 'رومانيا'),
(55437, 3262437888, 3262438399, 'FR', 'FRA', 'فرنسا'),
(55438, 3262438400, 3262438911, 'NL', 'NLD', 'هولندا'),
(55439, 3262438912, 3262439423, 'DK', 'DNK', 'الدنيمارك'),
(55440, 3262439424, 3262439935, 'AT', 'AUT', 'النمسا'),
(55441, 3262439936, 3262440447, 'IL', 'ISR', 'إسرائيل'),
(55442, 3262440448, 3262440959, 'UA', 'UKR', 'أوكرانيا'),
(55443, 3262440960, 3262441471, 'IL', 'ISR', 'إسرائيل'),
(55444, 3262441472, 3262441983, 'UA', 'UKR', 'أوكرانيا'),
(55445, 3262441984, 3262442495, 'DE', 'DEU', 'ألمانيا'),
(55446, 3262442496, 3262443007, 'RO', 'ROM', 'رومانيا'),
(55447, 3262443008, 3262443519, 'UA', 'UKR', 'أوكرانيا'),
(55448, 3262443520, 3262444031, 'ES', 'ESP', 'إسبانيا'),
(55449, 3262444032, 3262444543, 'AT', 'AUT', 'النمسا'),
(55450, 3262444544, 3262445055, 'UA', 'UKR', 'أوكرانيا'),
(55451, 3262445056, 3262445567, 'RO', 'ROM', 'رومانيا'),
(55452, 3262445568, 3262446079, 'PL', 'POL', 'بولندا'),
(55453, 3262446080, 3262446591, 'RU', 'RUS', 'الإتحاد الروسي'),
(55454, 3262446592, 3262447103, 'PL', 'POL', 'بولندا'),
(55455, 3262447104, 3262447615, 'GB', 'GBR', 'المملكة المتحدة'),
(55456, 3262447616, 3262460415, 'PT', 'PRT', 'البورتوغال'),
(55457, 3262460416, 3262460543, 'UA', 'UKR', 'أوكرانيا'),
(55458, 3262460544, 3262460671, 'RU', 'RUS', 'الإتحاد الروسي'),
(55459, 3262460800, 3262460927, 'GB', 'GBR', 'المملكة المتحدة'),
(55460, 3262460928, 3262461055, 'HU', 'HUN', 'هنغاريا'),
(55461, 3262461184, 3262461311, 'SN', 'SEN', 'السنغال'),
(55462, 3262461312, 3262461439, 'NO', 'NOR', 'النرويج'),
(55463, 3262461440, 3262461567, 'DE', 'DEU', 'ألمانيا'),
(55464, 3262461568, 3262461695, 'GB', 'GBR', 'المملكة المتحدة'),
(55465, 3262461696, 3262461823, 'UA', 'UKR', 'أوكرانيا'),
(55466, 3262461824, 3262461951, 'RO', 'ROM', 'رومانيا'),
(55467, 3262461952, 3262463999, 'IQ', 'IRQ', 'العراق'),
(55468, 3262464000, 3262472191, 'RU', 'RUS', 'الإتحاد الروسي'),
(55469, 3262472192, 3262472207, 'DE', 'DEU', 'ألمانيا'),
(55470, 3262472208, 3262472211, 'FR', 'FRA', 'فرنسا'),
(55471, 3262472212, 3262472215, 'DE', 'DEU', 'ألمانيا'),
(55472, 3262472216, 3262472219, 'NL', 'NLD', 'هولندا'),
(55473, 3262472220, 3262472223, 'AT', 'AUT', 'النمسا'),
(55474, 3262472224, 3262472231, 'DE', 'DEU', 'ألمانيا'),
(55475, 3262472232, 3262472235, 'AT', 'AUT', 'النمسا'),
(55476, 3262472236, 3262472247, 'DE', 'DEU', 'ألمانيا'),
(55477, 3262472248, 3262472251, 'IT', 'ITA', 'إيطاليا'),
(55478, 3262472252, 3262472267, 'DE', 'DEU', 'ألمانيا'),
(55479, 3262472268, 3262472271, 'AT', 'AUT', 'النمسا'),
(55480, 3262472272, 3262472275, 'IT', 'ITA', 'إيطاليا'),
(55481, 3262472276, 3262472279, 'BE', 'BEL', 'بلجيكا'),
(55482, 3262472280, 3262472291, 'DE', 'DEU', 'ألمانيا'),
(55483, 3262472292, 3262472295, 'FR', 'FRA', 'فرنسا'),
(55484, 3262472296, 3262472311, 'DE', 'DEU', 'ألمانيا'),
(55485, 3262472312, 3262472315, 'NL', 'NLD', 'هولندا'),
(55486, 3262472316, 3262472331, 'DE', 'DEU', 'ألمانيا'),
(55487, 3262472332, 3262472335, 'SE', 'SWE', 'السويد'),
(55488, 3262472336, 3262472339, 'US', 'USA', 'الولايات المتحدة'),
(55489, 3262472340, 3262472351, 'DE', 'DEU', 'ألمانيا'),
(55490, 3262472352, 3262472355, 'NL', 'NLD', 'هولندا'),
(55491, 3262472356, 3262472359, 'ES', 'ESP', 'إسبانيا'),
(55492, 3262472360, 3262472363, 'NL', 'NLD', 'هولندا'),
(55493, 3262472364, 3262472367, 'GB', 'GBR', 'المملكة المتحدة'),
(55494, 3262472368, 3262472371, 'NL', 'NLD', 'هولندا'),
(55495, 3262472372, 3262472375, 'FR', 'FRA', 'فرنسا'),
(55496, 3262472376, 3262472379, 'GB', 'GBR', 'المملكة المتحدة'),
(55497, 3262472380, 3262472387, 'DE', 'DEU', 'ألمانيا'),
(55498, 3262472388, 3262472391, 'FR', 'FRA', 'فرنسا'),
(55499, 3262472392, 3262472395, 'GB', 'GBR', 'المملكة المتحدة'),
(55500, 3262472396, 3262472399, 'DE', 'DEU', 'ألمانيا'),
(55501, 3262472400, 3262472403, 'NL', 'NLD', 'هولندا'),
(55502, 3262472404, 3262472407, 'DE', 'DEU', 'ألمانيا'),
(55503, 3262472408, 3262472411, 'US', 'USA', 'الولايات المتحدة'),
(55504, 3262472412, 3262472415, 'DE', 'DEU', 'ألمانيا'),
(55505, 3262472416, 3262472419, 'ES', 'ESP', 'إسبانيا'),
(55506, 3262472420, 3262472423, 'DE', 'DEU', 'ألمانيا'),
(55507, 3262472424, 3262472427, 'BE', 'BEL', 'بلجيكا'),
(55508, 3262472428, 3262472431, 'CH', 'CHE', 'سويسرا'),
(55509, 3262472432, 3262472435, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(55510, 3262472436, 3262472443, 'DE', 'DEU', 'ألمانيا'),
(55511, 3262472444, 3262472447, 'LU', 'LUX', 'لوكسيمبورغ'),
(55512, 3262472448, 3262472459, 'DE', 'DEU', 'ألمانيا'),
(55513, 3262472460, 3262472463, 'CH', 'CHE', 'سويسرا'),
(55514, 3262472464, 3262472467, 'DE', 'DEU', 'ألمانيا'),
(55515, 3262472468, 3262472471, 'FR', 'FRA', 'فرنسا'),
(55516, 3262472472, 3262472479, 'DE', 'DEU', 'ألمانيا'),
(55517, 3262472480, 3262472483, 'IT', 'ITA', 'إيطاليا'),
(55518, 3262472484, 3262472495, 'DE', 'DEU', 'ألمانيا'),
(55519, 3262472496, 3262472499, 'CH', 'CHE', 'سويسرا'),
(55520, 3262472500, 3262472511, 'DE', 'DEU', 'ألمانيا'),
(55521, 3262472512, 3262472515, 'CA', 'CAN', 'كندا'),
(55522, 3262472516, 3262472519, 'GB', 'GBR', 'المملكة المتحدة'),
(55523, 3262472520, 3262472527, 'DE', 'DEU', 'ألمانيا'),
(55524, 3262472528, 3262472531, 'CH', 'CHE', 'سويسرا'),
(55525, 3262472532, 3262472539, 'DE', 'DEU', 'ألمانيا'),
(55526, 3262472540, 3262472543, 'US', 'USA', 'الولايات المتحدة'),
(55527, 3262472544, 3262472547, 'DE', 'DEU', 'ألمانيا'),
(55528, 3262472548, 3262472551, 'NL', 'NLD', 'هولندا'),
(55529, 3262472552, 3262472555, 'HU', 'HUN', 'هنغاريا'),
(55530, 3262472556, 3262472563, 'DE', 'DEU', 'ألمانيا'),
(55531, 3262472564, 3262472567, 'DK', 'DNK', 'الدنيمارك'),
(55532, 3262472568, 3262472575, 'DE', 'DEU', 'ألمانيا'),
(55533, 3262472576, 3262472579, 'CA', 'CAN', 'كندا'),
(55534, 3262472580, 3262472583, 'AT', 'AUT', 'النمسا'),
(55535, 3262472584, 3262472591, 'US', 'USA', 'الولايات المتحدة'),
(55536, 3262472592, 3262472595, 'DE', 'DEU', 'ألمانيا'),
(55537, 3262472596, 3262472599, 'CH', 'CHE', 'سويسرا'),
(55538, 3262472600, 3262472603, 'FR', 'FRA', 'فرنسا'),
(55539, 3262472604, 3262472607, 'CH', 'CHE', 'سويسرا'),
(55540, 3262472608, 3262472615, 'US', 'USA', 'الولايات المتحدة'),
(55541, 3262472616, 3262472619, 'CA', 'CAN', 'كندا'),
(55542, 3262472620, 3262472623, 'TR', 'TUR', 'تركيا'),
(55543, 3262472624, 3262472631, 'DE', 'DEU', 'ألمانيا'),
(55544, 3262472632, 3262472635, 'ES', 'ESP', 'إسبانيا'),
(55545, 3262472636, 3262472651, 'DE', 'DEU', 'ألمانيا'),
(55546, 3262472652, 3262472655, 'FR', 'FRA', 'فرنسا'),
(55547, 3262472656, 3262472659, 'GB', 'GBR', 'المملكة المتحدة'),
(55548, 3262472660, 3262472663, 'IT', 'ITA', 'إيطاليا'),
(55549, 3262472664, 3262472667, 'ES', 'ESP', 'إسبانيا'),
(55550, 3262472668, 3262472675, 'DE', 'DEU', 'ألمانيا'),
(55551, 3262472676, 3262472679, 'FR', 'FRA', 'فرنسا'),
(55552, 3262472680, 3262472683, 'CL', 'CHL', 'تشيلي'),
(55553, 3262472684, 3262472691, 'US', 'USA', 'الولايات المتحدة'),
(55554, 3262472692, 3262472695, 'DE', 'DEU', 'ألمانيا'),
(55555, 3262472696, 3262472699, 'IT', 'ITA', 'إيطاليا'),
(55556, 3262472700, 3262472703, 'AT', 'AUT', 'النمسا'),
(55557, 3262472704, 3262472707, 'US', 'USA', 'الولايات المتحدة'),
(55558, 3262472708, 3262472711, 'DE', 'DEU', 'ألمانيا'),
(55559, 3262472712, 3262472715, 'US', 'USA', 'الولايات المتحدة'),
(55560, 3262472716, 3262472727, 'NL', 'NLD', 'هولندا'),
(55561, 3262472728, 3262472735, 'DE', 'DEU', 'ألمانيا'),
(55562, 3262472736, 3262472739, 'IT', 'ITA', 'إيطاليا'),
(55563, 3262472740, 3262472743, 'PT', 'PRT', 'البورتوغال'),
(55564, 3262472744, 3262472747, 'DE', 'DEU', 'ألمانيا'),
(55565, 3262472748, 3262472751, 'GB', 'GBR', 'المملكة المتحدة'),
(55566, 3262472752, 3262472763, 'DE', 'DEU', 'ألمانيا'),
(55567, 3262472764, 3262472767, 'CA', 'CAN', 'كندا'),
(55568, 3262472768, 3262472771, 'DE', 'DEU', 'ألمانيا'),
(55569, 3262472772, 3262472775, 'US', 'USA', 'الولايات المتحدة'),
(55570, 3262472776, 3262472779, 'DE', 'DEU', 'ألمانيا'),
(55571, 3262472780, 3262472783, 'US', 'USA', 'الولايات المتحدة'),
(55572, 3262472784, 3262472791, 'DE', 'DEU', 'ألمانيا'),
(55573, 3262472792, 3262472795, 'GB', 'GBR', 'المملكة المتحدة'),
(55574, 3262472796, 3262472799, 'AT', 'AUT', 'النمسا'),
(55575, 3262472800, 3262472807, 'DE', 'DEU', 'ألمانيا'),
(55576, 3262472808, 3262472811, 'CH', 'CHE', 'سويسرا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(55577, 3262472812, 3262472819, 'DE', 'DEU', 'ألمانيا'),
(55578, 3262472820, 3262472823, 'CH', 'CHE', 'سويسرا'),
(55579, 3262472824, 3262472827, 'US', 'USA', 'الولايات المتحدة'),
(55580, 3262472828, 3262472835, 'DE', 'DEU', 'ألمانيا'),
(55581, 3262472836, 3262472839, 'DK', 'DNK', 'الدنيمارك'),
(55582, 3262472840, 3262472843, 'DE', 'DEU', 'ألمانيا'),
(55583, 3262472844, 3262472847, 'AT', 'AUT', 'النمسا'),
(55584, 3262472848, 3262472851, 'DE', 'DEU', 'ألمانيا'),
(55585, 3262472852, 3262472855, 'IT', 'ITA', 'إيطاليا'),
(55586, 3262472856, 3262472859, 'FR', 'FRA', 'فرنسا'),
(55587, 3262472860, 3262472863, 'US', 'USA', 'الولايات المتحدة'),
(55588, 3262472864, 3262472867, 'FR', 'FRA', 'فرنسا'),
(55589, 3262472868, 3262472871, 'GB', 'GBR', 'المملكة المتحدة'),
(55590, 3262472872, 3262472875, 'DE', 'DEU', 'ألمانيا'),
(55591, 3262472876, 3262472879, 'FR', 'FRA', 'فرنسا'),
(55592, 3262472880, 3262472883, 'DE', 'DEU', 'ألمانيا'),
(55593, 3262472884, 3262472891, 'CA', 'CAN', 'كندا'),
(55594, 3262472892, 3262472899, 'DE', 'DEU', 'ألمانيا'),
(55595, 3262472900, 3262472903, 'AT', 'AUT', 'النمسا'),
(55596, 3262472904, 3262472907, 'US', 'USA', 'الولايات المتحدة'),
(55597, 3262472908, 3262472911, 'DE', 'DEU', 'ألمانيا'),
(55598, 3262472912, 3262472915, 'IT', 'ITA', 'إيطاليا'),
(55599, 3262472916, 3262472923, 'DE', 'DEU', 'ألمانيا'),
(55600, 3262472924, 3262472927, 'IT', 'ITA', 'إيطاليا'),
(55601, 3262472928, 3262472931, 'NL', 'NLD', 'هولندا'),
(55602, 3262472932, 3262472935, 'LB', 'LBN', 'لبنان'),
(55603, 3262472936, 3262472939, 'DE', 'DEU', 'ألمانيا'),
(55604, 3262472940, 3262472943, 'CH', 'CHE', 'سويسرا'),
(55605, 3262472944, 3262472947, 'PT', 'PRT', 'البورتوغال'),
(55606, 3262472948, 3262472951, 'LU', 'LUX', 'لوكسيمبورغ'),
(55607, 3262472952, 3262472955, 'DE', 'DEU', 'ألمانيا'),
(55608, 3262472956, 3262472959, 'CA', 'CAN', 'كندا'),
(55609, 3262472960, 3262472963, 'DE', 'DEU', 'ألمانيا'),
(55610, 3262472964, 3262472967, 'AT', 'AUT', 'النمسا'),
(55611, 3262472968, 3262472975, 'DE', 'DEU', 'ألمانيا'),
(55612, 3262472976, 3262472979, 'LU', 'LUX', 'لوكسيمبورغ'),
(55613, 3262472980, 3262472983, 'AT', 'AUT', 'النمسا'),
(55614, 3262472984, 3262472987, 'PT', 'PRT', 'البورتوغال'),
(55615, 3262472988, 3262472991, 'US', 'USA', 'الولايات المتحدة'),
(55616, 3262472992, 3262472995, 'DE', 'DEU', 'ألمانيا'),
(55617, 3262472996, 3262472999, 'FR', 'FRA', 'فرنسا'),
(55618, 3262473000, 3262473003, 'HU', 'HUN', 'هنغاريا'),
(55619, 3262473004, 3262473007, 'NO', 'NOR', 'النرويج'),
(55620, 3262473008, 3262473011, 'US', 'USA', 'الولايات المتحدة'),
(55621, 3262473012, 3262473015, 'DE', 'DEU', 'ألمانيا'),
(55622, 3262473016, 3262473019, 'AR', 'ARG', 'الأرجنتين'),
(55623, 3262473020, 3262473023, 'US', 'USA', 'الولايات المتحدة'),
(55624, 3262473024, 3262473027, 'ES', 'ESP', 'إسبانيا'),
(55625, 3262473028, 3262473031, 'BM', 'BMU', 'برمودا'),
(55626, 3262473032, 3262473035, 'DE', 'DEU', 'ألمانيا'),
(55627, 3262473036, 3262473039, 'IT', 'ITA', 'إيطاليا'),
(55628, 3262473040, 3262473043, 'GB', 'GBR', 'المملكة المتحدة'),
(55629, 3262473044, 3262473047, 'US', 'USA', 'الولايات المتحدة'),
(55630, 3262473048, 3262473051, 'DE', 'DEU', 'ألمانيا'),
(55631, 3262473052, 3262473055, 'AT', 'AUT', 'النمسا'),
(55632, 3262473056, 3262473075, 'DE', 'DEU', 'ألمانيا'),
(55633, 3262473076, 3262473079, 'GB', 'GBR', 'المملكة المتحدة'),
(55634, 3262473080, 3262473083, 'DE', 'DEU', 'ألمانيا'),
(55635, 3262473084, 3262473087, 'US', 'USA', 'الولايات المتحدة'),
(55636, 3262473088, 3262473091, 'NL', 'NLD', 'هولندا'),
(55637, 3262473092, 3262473099, 'DE', 'DEU', 'ألمانيا'),
(55638, 3262473100, 3262473103, 'BE', 'BEL', 'بلجيكا'),
(55639, 3262473104, 3262473107, 'DE', 'DEU', 'ألمانيا'),
(55640, 3262473108, 3262473115, 'ES', 'ESP', 'إسبانيا'),
(55641, 3262473116, 3262473119, 'DE', 'DEU', 'ألمانيا'),
(55642, 3262473120, 3262473127, 'FR', 'FRA', 'فرنسا'),
(55643, 3262473128, 3262473135, 'DE', 'DEU', 'ألمانيا'),
(55644, 3262473136, 3262473139, 'US', 'USA', 'الولايات المتحدة'),
(55645, 3262473140, 3262473143, 'ES', 'ESP', 'إسبانيا'),
(55646, 3262473144, 3262473151, 'DE', 'DEU', 'ألمانيا'),
(55647, 3262473152, 3262473155, 'FR', 'FRA', 'فرنسا'),
(55648, 3262473156, 3262473159, 'IT', 'ITA', 'إيطاليا'),
(55649, 3262473160, 3262473163, 'NL', 'NLD', 'هولندا'),
(55650, 3262473164, 3262473167, 'CH', 'CHE', 'سويسرا'),
(55651, 3262473168, 3262473171, 'DE', 'DEU', 'ألمانيا'),
(55652, 3262473172, 3262473175, 'US', 'USA', 'الولايات المتحدة'),
(55653, 3262473176, 3262473195, 'DE', 'DEU', 'ألمانيا'),
(55654, 3262473196, 3262473199, 'AT', 'AUT', 'النمسا'),
(55655, 3262473200, 3262473203, 'ES', 'ESP', 'إسبانيا'),
(55656, 3262473204, 3262473207, 'US', 'USA', 'الولايات المتحدة'),
(55657, 3262473208, 3262473211, 'DE', 'DEU', 'ألمانيا'),
(55658, 3262473212, 3262473215, 'FR', 'FRA', 'فرنسا'),
(55659, 3262473216, 3262473323, 'JP', 'JPN', 'اليابان'),
(55660, 3262473324, 3262473327, 'KR', 'KOR', 'جمهورية كوريا'),
(55661, 3262473328, 3262473471, 'JP', 'JPN', 'اليابان'),
(55662, 3262473472, 3262473473, 'DE', 'DEU', 'ألمانيا'),
(55663, 3262473474, 3262473478, 'US', 'USA', 'الولايات المتحدة'),
(55664, 3262473479, 3262473480, 'CA', 'CAN', 'كندا'),
(55665, 3262473481, 3262473483, 'US', 'USA', 'الولايات المتحدة'),
(55666, 3262473484, 3262473484, 'VE', 'VEN', 'فنزويلا'),
(55667, 3262473485, 3262473485, 'US', 'USA', 'الولايات المتحدة'),
(55668, 3262473486, 3262473486, 'CA', 'CAN', 'كندا'),
(55669, 3262473487, 3262473516, 'US', 'USA', 'الولايات المتحدة'),
(55670, 3262473517, 3262473517, 'CN', 'CHN', 'الصين'),
(55671, 3262473518, 3262473526, 'US', 'USA', 'الولايات المتحدة'),
(55672, 3262473527, 3262473527, 'CN', 'CHN', 'الصين'),
(55673, 3262473528, 3262473538, 'US', 'USA', 'الولايات المتحدة'),
(55674, 3262473539, 3262473539, 'DE', 'DEU', 'ألمانيا'),
(55675, 3262473540, 3262473540, 'US', 'USA', 'الولايات المتحدة'),
(55676, 3262473541, 3262473541, 'DE', 'DEU', 'ألمانيا'),
(55677, 3262473542, 3262473543, 'US', 'USA', 'الولايات المتحدة'),
(55678, 3262473544, 3262473544, 'CA', 'CAN', 'كندا'),
(55679, 3262473545, 3262473548, 'US', 'USA', 'الولايات المتحدة'),
(55680, 3262473549, 3262473549, 'CA', 'CAN', 'كندا'),
(55681, 3262473550, 3262473557, 'US', 'USA', 'الولايات المتحدة'),
(55682, 3262473558, 3262473558, 'DE', 'DEU', 'ألمانيا'),
(55683, 3262473559, 3262473567, 'US', 'USA', 'الولايات المتحدة'),
(55684, 3262473568, 3262473568, 'CA', 'CAN', 'كندا'),
(55685, 3262473569, 3262473570, 'US', 'USA', 'الولايات المتحدة'),
(55686, 3262473571, 3262473571, 'DE', 'DEU', 'ألمانيا'),
(55687, 3262473572, 3262473582, 'US', 'USA', 'الولايات المتحدة'),
(55688, 3262473583, 3262473583, 'CA', 'CAN', 'كندا'),
(55689, 3262473584, 3262473586, 'US', 'USA', 'الولايات المتحدة'),
(55690, 3262473587, 3262473587, 'CA', 'CAN', 'كندا'),
(55691, 3262473588, 3262473658, 'US', 'USA', 'الولايات المتحدة'),
(55692, 3262473659, 3262473659, 'DE', 'DEU', 'ألمانيا'),
(55693, 3262473660, 3262473663, 'US', 'USA', 'الولايات المتحدة'),
(55694, 3262473664, 3262473664, 'CA', 'CAN', 'كندا'),
(55695, 3262473665, 3262473688, 'US', 'USA', 'الولايات المتحدة'),
(55696, 3262473689, 3262473689, 'CA', 'CAN', 'كندا'),
(55697, 3262473690, 3262473691, 'AR', 'ARG', 'الأرجنتين'),
(55698, 3262473692, 3262473692, 'CA', 'CAN', 'كندا'),
(55699, 3262473693, 3262473729, 'DE', 'DEU', 'ألمانيا'),
(55700, 3262473730, 3262473735, 'US', 'USA', 'الولايات المتحدة'),
(55701, 3262473736, 3262473736, 'CA', 'CAN', 'كندا'),
(55702, 3262473737, 3262473771, 'US', 'USA', 'الولايات المتحدة'),
(55703, 3262473772, 3262473772, 'DE', 'DEU', 'ألمانيا'),
(55704, 3262473773, 3262473785, 'US', 'USA', 'الولايات المتحدة'),
(55705, 3262473786, 3262473855, 'DE', 'DEU', 'ألمانيا'),
(55706, 3262473856, 3262473859, 'US', 'USA', 'الولايات المتحدة'),
(55707, 3262473860, 3262473903, 'DE', 'DEU', 'ألمانيا'),
(55708, 3262473904, 3262473907, 'US', 'USA', 'الولايات المتحدة'),
(55709, 3262473908, 3262473931, 'DE', 'DEU', 'ألمانيا'),
(55710, 3262473932, 3262473935, 'US', 'USA', 'الولايات المتحدة'),
(55711, 3262473936, 3262473963, 'DE', 'DEU', 'ألمانيا'),
(55712, 3262473964, 3262473967, 'US', 'USA', 'الولايات المتحدة'),
(55713, 3262473968, 3262473971, 'DE', 'DEU', 'ألمانيا'),
(55714, 3262473972, 3262473983, 'US', 'USA', 'الولايات المتحدة'),
(55715, 3262473984, 3262473985, 'DE', 'DEU', 'ألمانيا'),
(55716, 3262473986, 3262473986, 'TW', 'TWN', 'تايوان'),
(55717, 3262473987, 3262473987, 'IN', 'IND', 'الهند'),
(55718, 3262473988, 3262473988, 'SG', 'SGP', 'سنغافورة'),
(55719, 3262473989, 3262473989, 'IN', 'IND', 'الهند'),
(55720, 3262473990, 3262473990, 'SG', 'SGP', 'سنغافورة'),
(55721, 3262473991, 3262473991, 'DE', 'DEU', 'ألمانيا'),
(55722, 3262473992, 3262473992, 'SG', 'SGP', 'سنغافورة'),
(55723, 3262473993, 3262473993, 'IN', 'IND', 'الهند'),
(55724, 3262473994, 3262473995, 'TW', 'TWN', 'تايوان'),
(55725, 3262473996, 3262473996, 'MY', 'MYS', 'ماليزيا'),
(55726, 3262473997, 3262473998, 'ID', 'IDN', 'إندونيسيا'),
(55727, 3262473999, 3262473999, 'TW', 'TWN', 'تايوان'),
(55728, 3262474000, 3262474000, 'SG', 'SGP', 'سنغافورة'),
(55729, 3262474001, 3262474001, 'TW', 'TWN', 'تايوان'),
(55730, 3262474002, 3262474002, 'MY', 'MYS', 'ماليزيا'),
(55731, 3262474003, 3262474003, 'TW', 'TWN', 'تايوان'),
(55732, 3262474004, 3262474004, 'SG', 'SGP', 'سنغافورة'),
(55733, 3262474005, 3262474005, 'TW', 'TWN', 'تايوان'),
(55734, 3262474006, 3262474007, 'SG', 'SGP', 'سنغافورة'),
(55735, 3262474008, 3262474009, 'TW', 'TWN', 'تايوان'),
(55736, 3262474010, 3262474010, 'SG', 'SGP', 'سنغافورة'),
(55737, 3262474011, 3262474011, 'ID', 'IDN', 'إندونيسيا'),
(55738, 3262474012, 3262474013, 'SG', 'SGP', 'سنغافورة'),
(55739, 3262474014, 3262474014, 'HK', 'HKG', 'هونغ كونغ'),
(55740, 3262474015, 3262474016, 'SG', 'SGP', 'سنغافورة'),
(55741, 3262474017, 3262474018, 'MY', 'MYS', 'ماليزيا'),
(55742, 3262474019, 3262474026, 'SG', 'SGP', 'سنغافورة'),
(55743, 3262474027, 3262474027, 'CN', 'CHN', 'الصين'),
(55744, 3262474028, 3262474030, 'SG', 'SGP', 'سنغافورة'),
(55745, 3262474031, 3262474031, 'IN', 'IND', 'الهند'),
(55746, 3262474032, 3262474032, 'MY', 'MYS', 'ماليزيا'),
(55747, 3262474033, 3262474033, 'SG', 'SGP', 'سنغافورة'),
(55748, 3262474034, 3262474034, 'MY', 'MYS', 'ماليزيا'),
(55749, 3262474035, 3262474035, 'SG', 'SGP', 'سنغافورة'),
(55750, 3262474036, 3262474036, 'MY', 'MYS', 'ماليزيا'),
(55751, 3262474037, 3262474037, 'SG', 'SGP', 'سنغافورة'),
(55752, 3262474038, 3262474038, 'MY', 'MYS', 'ماليزيا'),
(55753, 3262474039, 3262474039, 'TW', 'TWN', 'تايوان'),
(55754, 3262474040, 3262474041, 'MY', 'MYS', 'ماليزيا'),
(55755, 3262474042, 3262474042, 'CN', 'CHN', 'الصين'),
(55756, 3262474043, 3262474043, 'SG', 'SGP', 'سنغافورة'),
(55757, 3262474044, 3262474044, 'GB', 'GBR', 'المملكة المتحدة'),
(55758, 3262474045, 3262474048, 'SG', 'SGP', 'سنغافورة'),
(55759, 3262474049, 3262474049, 'IN', 'IND', 'الهند'),
(55760, 3262474050, 3262474061, 'SG', 'SGP', 'سنغافورة'),
(55761, 3262474062, 3262474063, 'CN', 'CHN', 'الصين'),
(55762, 3262474064, 3262474064, 'TW', 'TWN', 'تايوان'),
(55763, 3262474065, 3262474065, 'IN', 'IND', 'الهند'),
(55764, 3262474066, 3262474066, 'SG', 'SGP', 'سنغافورة'),
(55765, 3262474067, 3262474067, 'MY', 'MYS', 'ماليزيا'),
(55766, 3262474068, 3262474068, 'SG', 'SGP', 'سنغافورة'),
(55767, 3262474069, 3262474069, 'MY', 'MYS', 'ماليزيا'),
(55768, 3262474070, 3262474070, 'SG', 'SGP', 'سنغافورة'),
(55769, 3262474071, 3262474071, 'TW', 'TWN', 'تايوان'),
(55770, 3262474072, 3262474072, 'IN', 'IND', 'الهند'),
(55771, 3262474073, 3262474075, 'SG', 'SGP', 'سنغافورة'),
(55772, 3262474076, 3262474076, 'MY', 'MYS', 'ماليزيا'),
(55773, 3262474077, 3262474077, 'SG', 'SGP', 'سنغافورة'),
(55774, 3262474078, 3262474078, 'IN', 'IND', 'الهند'),
(55775, 3262474079, 3262474079, 'MY', 'MYS', 'ماليزيا'),
(55776, 3262474080, 3262474083, 'SG', 'SGP', 'سنغافورة'),
(55777, 3262474084, 3262474084, 'TW', 'TWN', 'تايوان'),
(55778, 3262474085, 3262474087, 'SG', 'SGP', 'سنغافورة'),
(55779, 3262474088, 3262474088, 'MY', 'MYS', 'ماليزيا'),
(55780, 3262474089, 3262474089, 'SG', 'SGP', 'سنغافورة'),
(55781, 3262474090, 3262474091, 'MY', 'MYS', 'ماليزيا'),
(55782, 3262474092, 3262474094, 'SG', 'SGP', 'سنغافورة'),
(55783, 3262474095, 3262474095, 'HK', 'HKG', 'هونغ كونغ'),
(55784, 3262474096, 3262474097, 'SG', 'SGP', 'سنغافورة'),
(55785, 3262474098, 3262474098, 'MY', 'MYS', 'ماليزيا'),
(55786, 3262474099, 3262474102, 'SG', 'SGP', 'سنغافورة'),
(55787, 3262474103, 3262474103, 'MY', 'MYS', 'ماليزيا'),
(55788, 3262474104, 3262474104, 'CN', 'CHN', 'الصين'),
(55789, 3262474105, 3262474105, 'IN', 'IND', 'الهند'),
(55790, 3262474106, 3262474106, 'MY', 'MYS', 'ماليزيا'),
(55791, 3262474107, 3262474107, 'CN', 'CHN', 'الصين'),
(55792, 3262474108, 3262474108, 'HK', 'HKG', 'هونغ كونغ'),
(55793, 3262474109, 3262474110, 'MY', 'MYS', 'ماليزيا'),
(55794, 3262474111, 3262474111, 'TH', 'THA', 'تايلند'),
(55795, 3262474112, 3262474112, 'SG', 'SGP', 'سنغافورة'),
(55796, 3262474113, 3262474113, 'PH', 'PHL', 'الفلبين'),
(55797, 3262474114, 3262474114, 'IN', 'IND', 'الهند'),
(55798, 3262474115, 3262474115, 'SG', 'SGP', 'سنغافورة'),
(55799, 3262474116, 3262474116, 'TW', 'TWN', 'تايوان'),
(55800, 3262474117, 3262474117, 'IN', 'IND', 'الهند'),
(55801, 3262474118, 3262474118, 'TH', 'THA', 'تايلند'),
(55802, 3262474119, 3262474119, 'TW', 'TWN', 'تايوان'),
(55803, 3262474120, 3262474120, 'BN', 'BRN', 'بروناي دار السلام'),
(55804, 3262474121, 3262474121, 'TW', 'TWN', 'تايوان'),
(55805, 3262474122, 3262474122, 'SG', 'SGP', 'سنغافورة'),
(55806, 3262474123, 3262474125, 'MY', 'MYS', 'ماليزيا'),
(55807, 3262474126, 3262474126, 'IN', 'IND', 'الهند'),
(55808, 3262474127, 3262474128, 'SG', 'SGP', 'سنغافورة'),
(55809, 3262474129, 3262474130, 'MY', 'MYS', 'ماليزيا'),
(55810, 3262474131, 3262474131, 'IN', 'IND', 'الهند'),
(55811, 3262474132, 3262474133, 'MY', 'MYS', 'ماليزيا'),
(55812, 3262474134, 3262474134, 'CN', 'CHN', 'الصين'),
(55813, 3262474135, 3262474136, 'SG', 'SGP', 'سنغافورة'),
(55814, 3262474137, 3262474137, 'TW', 'TWN', 'تايوان'),
(55815, 3262474138, 3262474139, 'CN', 'CHN', 'الصين'),
(55816, 3262474140, 3262474140, 'TW', 'TWN', 'تايوان'),
(55817, 3262474141, 3262474142, 'SG', 'SGP', 'سنغافورة'),
(55818, 3262474143, 3262474143, 'PH', 'PHL', 'الفلبين'),
(55819, 3262474144, 3262474150, 'SG', 'SGP', 'سنغافورة'),
(55820, 3262474151, 3262474151, 'MY', 'MYS', 'ماليزيا'),
(55821, 3262474152, 3262474152, 'SG', 'SGP', 'سنغافورة'),
(55822, 3262474153, 3262474153, 'IN', 'IND', 'الهند'),
(55823, 3262474154, 3262474154, 'SG', 'SGP', 'سنغافورة'),
(55824, 3262474155, 3262474155, 'MY', 'MYS', 'ماليزيا'),
(55825, 3262474156, 3262474156, 'IN', 'IND', 'الهند'),
(55826, 3262474157, 3262474157, 'SG', 'SGP', 'سنغافورة'),
(55827, 3262474158, 3262474159, 'MY', 'MYS', 'ماليزيا'),
(55828, 3262474160, 3262474162, 'SG', 'SGP', 'سنغافورة'),
(55829, 3262474163, 3262474163, 'MY', 'MYS', 'ماليزيا'),
(55830, 3262474164, 3262474164, 'IN', 'IND', 'الهند'),
(55831, 3262474165, 3262474165, 'CN', 'CHN', 'الصين'),
(55832, 3262474166, 3262474166, 'SG', 'SGP', 'سنغافورة'),
(55833, 3262474167, 3262474167, 'HK', 'HKG', 'هونغ كونغ'),
(55834, 3262474168, 3262474168, 'TW', 'TWN', 'تايوان'),
(55835, 3262474169, 3262474169, 'DE', 'DEU', 'ألمانيا'),
(55836, 3262474170, 3262474170, 'SG', 'SGP', 'سنغافورة'),
(55837, 3262474171, 3262474171, 'MY', 'MYS', 'ماليزيا'),
(55838, 3262474172, 3262474172, 'SG', 'SGP', 'سنغافورة'),
(55839, 3262474173, 3262474173, 'CN', 'CHN', 'الصين'),
(55840, 3262474174, 3262474174, 'TW', 'TWN', 'تايوان'),
(55841, 3262474175, 3262474175, 'SG', 'SGP', 'سنغافورة'),
(55842, 3262474176, 3262474176, 'MY', 'MYS', 'ماليزيا'),
(55843, 3262474177, 3262474177, 'SG', 'SGP', 'سنغافورة'),
(55844, 3262474178, 3262474178, 'TW', 'TWN', 'تايوان'),
(55845, 3262474179, 3262474179, 'CN', 'CHN', 'الصين'),
(55846, 3262474180, 3262474180, 'MY', 'MYS', 'ماليزيا'),
(55847, 3262474181, 3262474181, 'SG', 'SGP', 'سنغافورة'),
(55848, 3262474182, 3262474182, 'MY', 'MYS', 'ماليزيا'),
(55849, 3262474183, 3262474185, 'SG', 'SGP', 'سنغافورة'),
(55850, 3262474186, 3262474186, 'MY', 'MYS', 'ماليزيا'),
(55851, 3262474187, 3262474187, 'SG', 'SGP', 'سنغافورة'),
(55852, 3262474188, 3262474188, 'MY', 'MYS', 'ماليزيا'),
(55853, 3262474189, 3262474189, 'SG', 'SGP', 'سنغافورة'),
(55854, 3262474190, 3262474190, 'CN', 'CHN', 'الصين'),
(55855, 3262474191, 3262474192, 'SG', 'SGP', 'سنغافورة'),
(55856, 3262474193, 3262474193, 'PH', 'PHL', 'الفلبين'),
(55857, 3262474194, 3262474194, 'SG', 'SGP', 'سنغافورة'),
(55858, 3262474195, 3262474195, 'MY', 'MYS', 'ماليزيا'),
(55859, 3262474196, 3262474196, 'IN', 'IND', 'الهند'),
(55860, 3262474197, 3262474198, 'SG', 'SGP', 'سنغافورة'),
(55861, 3262474199, 3262474199, 'CN', 'CHN', 'الصين'),
(55862, 3262474200, 3262474200, 'MY', 'MYS', 'ماليزيا'),
(55863, 3262474201, 3262474201, 'SG', 'SGP', 'سنغافورة'),
(55864, 3262474202, 3262474203, 'CN', 'CHN', 'الصين'),
(55865, 3262474204, 3262474204, 'IN', 'IND', 'الهند'),
(55866, 3262474205, 3262474205, 'SG', 'SGP', 'سنغافورة'),
(55867, 3262474206, 3262474206, 'IN', 'IND', 'الهند'),
(55868, 3262474207, 3262474207, 'MY', 'MYS', 'ماليزيا'),
(55869, 3262474208, 3262474208, 'SG', 'SGP', 'سنغافورة'),
(55870, 3262474209, 3262474209, 'MY', 'MYS', 'ماليزيا'),
(55871, 3262474210, 3262474210, 'TW', 'TWN', 'تايوان'),
(55872, 3262474211, 3262474211, 'SG', 'SGP', 'سنغافورة'),
(55873, 3262474212, 3262474212, 'MY', 'MYS', 'ماليزيا'),
(55874, 3262474213, 3262474213, 'SG', 'SGP', 'سنغافورة'),
(55875, 3262474214, 3262474214, 'CN', 'CHN', 'الصين'),
(55876, 3262474215, 3262474215, 'IN', 'IND', 'الهند'),
(55877, 3262474216, 3262474216, 'SG', 'SGP', 'سنغافورة'),
(55878, 3262474217, 3262474217, 'MY', 'MYS', 'ماليزيا'),
(55879, 3262474218, 3262474218, 'SG', 'SGP', 'سنغافورة'),
(55880, 3262474219, 3262474219, 'MY', 'MYS', 'ماليزيا'),
(55881, 3262474220, 3262474222, 'IN', 'IND', 'الهند'),
(55882, 3262474223, 3262474223, 'SG', 'SGP', 'سنغافورة'),
(55883, 3262474224, 3262474224, 'MY', 'MYS', 'ماليزيا'),
(55884, 3262474225, 3262474225, 'SG', 'SGP', 'سنغافورة'),
(55885, 3262474226, 3262474226, 'MY', 'MYS', 'ماليزيا'),
(55886, 3262474227, 3262474227, 'IN', 'IND', 'الهند'),
(55887, 3262474228, 3262474228, 'SG', 'SGP', 'سنغافورة'),
(55888, 3262474229, 3262474230, 'IN', 'IND', 'الهند'),
(55889, 3262474231, 3262474231, 'SG', 'SGP', 'سنغافورة'),
(55890, 3262474232, 3262474234, 'IN', 'IND', 'الهند'),
(55891, 3262474235, 3262474236, 'MY', 'MYS', 'ماليزيا'),
(55892, 3262474237, 3262474238, 'SG', 'SGP', 'سنغافورة'),
(55893, 3262474239, 3262474239, 'DE', 'DEU', 'ألمانيا'),
(55894, 3262474240, 3262474255, 'AU', 'AUS', 'أستراليا'),
(55895, 3262474256, 3262474259, 'NZ', 'NZL', 'نيوزيلاندا'),
(55896, 3262474260, 3262474263, 'AU', 'AUS', 'أستراليا'),
(55897, 3262474264, 3262474267, 'NZ', 'NZL', 'نيوزيلاندا'),
(55898, 3262474268, 3262474271, 'AU', 'AUS', 'أستراليا'),
(55899, 3262474272, 3262474275, 'NZ', 'NZL', 'نيوزيلاندا'),
(55900, 3262474276, 3262474367, 'AU', 'AUS', 'أستراليا'),
(55901, 3262474368, 3262474371, 'NZ', 'NZL', 'نيوزيلاندا'),
(55902, 3262474372, 3262474395, 'AU', 'AUS', 'أستراليا'),
(55903, 3262474396, 3262474399, 'NZ', 'NZL', 'نيوزيلاندا'),
(55904, 3262474400, 3262474463, 'AU', 'AUS', 'أستراليا'),
(55905, 3262474464, 3262474467, 'NZ', 'NZL', 'نيوزيلاندا'),
(55906, 3262474468, 3262474495, 'AU', 'AUS', 'أستراليا'),
(55907, 3262474496, 3262474631, 'DE', 'DEU', 'ألمانيا'),
(55908, 3262474632, 3262474635, 'DK', 'DNK', 'الدنيمارك'),
(55909, 3262474636, 3262474791, 'DE', 'DEU', 'ألمانيا'),
(55910, 3262474792, 3262474815, 'JP', 'JPN', 'اليابان'),
(55911, 3262474816, 3262474895, 'DE', 'DEU', 'ألمانيا'),
(55912, 3262474896, 3262475007, 'JP', 'JPN', 'اليابان'),
(55913, 3262475008, 3262475009, 'DE', 'DEU', 'ألمانيا'),
(55914, 3262475010, 3262475023, 'US', 'USA', 'الولايات المتحدة'),
(55915, 3262475024, 3262475024, 'CO', 'COL', 'كولومبيا'),
(55916, 3262475025, 3262475025, 'US', 'USA', 'الولايات المتحدة'),
(55917, 3262475026, 3262475027, 'DE', 'DEU', 'ألمانيا'),
(55918, 3262475028, 3262475029, 'US', 'USA', 'الولايات المتحدة'),
(55919, 3262475030, 3262475033, 'DE', 'DEU', 'ألمانيا'),
(55920, 3262475034, 3262475036, 'US', 'USA', 'الولايات المتحدة'),
(55921, 3262475037, 3262475037, 'DE', 'DEU', 'ألمانيا'),
(55922, 3262475038, 3262475042, 'US', 'USA', 'الولايات المتحدة'),
(55923, 3262475043, 3262475043, 'DE', 'DEU', 'ألمانيا'),
(55924, 3262475044, 3262475044, 'US', 'USA', 'الولايات المتحدة'),
(55925, 3262475045, 3262475045, 'BR', 'BRA', 'البرازيل'),
(55926, 3262475046, 3262475065, 'US', 'USA', 'الولايات المتحدة'),
(55927, 3262475066, 3262475068, 'MX', 'MEX', 'المكسيك'),
(55928, 3262475069, 3262475072, 'US', 'USA', 'الولايات المتحدة'),
(55929, 3262475073, 3262475075, 'BR', 'BRA', 'البرازيل'),
(55930, 3262475076, 3262475076, 'US', 'USA', 'الولايات المتحدة'),
(55931, 3262475077, 3262475077, 'BR', 'BRA', 'البرازيل'),
(55932, 3262475078, 3262475079, 'US', 'USA', 'الولايات المتحدة'),
(55933, 3262475080, 3262475080, 'CA', 'CAN', 'كندا'),
(55934, 3262475081, 3262475081, 'US', 'USA', 'الولايات المتحدة'),
(55935, 3262475082, 3262475082, 'BR', 'BRA', 'البرازيل'),
(55936, 3262475083, 3262475083, 'US', 'USA', 'الولايات المتحدة'),
(55937, 3262475084, 3262475084, 'MX', 'MEX', 'المكسيك'),
(55938, 3262475085, 3262475085, 'BR', 'BRA', 'البرازيل'),
(55939, 3262475086, 3262475087, 'US', 'USA', 'الولايات المتحدة'),
(55940, 3262475088, 3262475088, 'BR', 'BRA', 'البرازيل'),
(55941, 3262475089, 3262475090, 'US', 'USA', 'الولايات المتحدة'),
(55942, 3262475091, 3262475092, 'DE', 'DEU', 'ألمانيا'),
(55943, 3262475093, 3262475094, 'BR', 'BRA', 'البرازيل'),
(55944, 3262475095, 3262475095, 'MX', 'MEX', 'المكسيك'),
(55945, 3262475096, 3262475140, 'US', 'USA', 'الولايات المتحدة'),
(55946, 3262475141, 3262475141, 'BR', 'BRA', 'البرازيل'),
(55947, 3262475142, 3262475167, 'US', 'USA', 'الولايات المتحدة'),
(55948, 3262475168, 3262475168, 'DE', 'DEU', 'ألمانيا'),
(55949, 3262475169, 3262475174, 'US', 'USA', 'الولايات المتحدة'),
(55950, 3262475175, 3262475175, 'DE', 'DEU', 'ألمانيا'),
(55951, 3262475176, 3262475185, 'US', 'USA', 'الولايات المتحدة'),
(55952, 3262475186, 3262475186, 'DE', 'DEU', 'ألمانيا'),
(55953, 3262475187, 3262475189, 'US', 'USA', 'الولايات المتحدة'),
(55954, 3262475190, 3262475190, 'MX', 'MEX', 'المكسيك'),
(55955, 3262475191, 3262475191, 'BR', 'BRA', 'البرازيل'),
(55956, 3262475192, 3262475192, 'MX', 'MEX', 'المكسيك'),
(55957, 3262475193, 3262475201, 'US', 'USA', 'الولايات المتحدة'),
(55958, 3262475202, 3262475205, 'BR', 'BRA', 'البرازيل'),
(55959, 3262475206, 3262475209, 'US', 'USA', 'الولايات المتحدة'),
(55960, 3262475210, 3262475210, 'BR', 'BRA', 'البرازيل'),
(55961, 3262475211, 3262475213, 'US', 'USA', 'الولايات المتحدة'),
(55962, 3262475214, 3262475214, 'DE', 'DEU', 'ألمانيا'),
(55963, 3262475215, 3262475222, 'US', 'USA', 'الولايات المتحدة'),
(55964, 3262475223, 3262475263, 'DE', 'DEU', 'ألمانيا'),
(55965, 3262475264, 3262475267, 'MU', 'MUS', 'موريشيوس'),
(55966, 3262475268, 3262475271, 'US', 'USA', 'الولايات المتحدة'),
(55967, 3262475272, 3262475275, 'IT', 'ITA', 'إيطاليا'),
(55968, 3262475276, 3262475279, 'US', 'USA', 'الولايات المتحدة'),
(55969, 3262475280, 3262475283, 'DE', 'DEU', 'ألمانيا'),
(55970, 3262475284, 3262475287, 'NL', 'NLD', 'هولندا'),
(55971, 3262475288, 3262475295, 'DE', 'DEU', 'ألمانيا'),
(55972, 3262475296, 3262475303, 'NL', 'NLD', 'هولندا'),
(55973, 3262475304, 3262475307, 'FR', 'FRA', 'فرنسا'),
(55974, 3262475308, 3262475311, 'AR', 'ARG', 'الأرجنتين'),
(55975, 3262475312, 3262475315, 'FR', 'FRA', 'فرنسا'),
(55976, 3262475316, 3262475319, 'SE', 'SWE', 'السويد'),
(55977, 3262475320, 3262475323, 'DE', 'DEU', 'ألمانيا'),
(55978, 3262475324, 3262475327, 'MX', 'MEX', 'المكسيك'),
(55979, 3262475328, 3262475331, 'US', 'USA', 'الولايات المتحدة'),
(55980, 3262475332, 3262475335, 'BR', 'BRA', 'البرازيل'),
(55981, 3262475336, 3262475339, 'DE', 'DEU', 'ألمانيا'),
(55982, 3262475340, 3262475343, 'FR', 'FRA', 'فرنسا'),
(55983, 3262475344, 3262475347, 'CH', 'CHE', 'سويسرا'),
(55984, 3262475348, 3262475351, 'DE', 'DEU', 'ألمانيا'),
(55985, 3262475352, 3262475355, 'ES', 'ESP', 'إسبانيا'),
(55986, 3262475356, 3262475359, 'DE', 'DEU', 'ألمانيا'),
(55987, 3262475360, 3262475363, 'IT', 'ITA', 'إيطاليا'),
(55988, 3262475364, 3262475367, 'DE', 'DEU', 'ألمانيا'),
(55989, 3262475368, 3262475371, 'FR', 'FRA', 'فرنسا'),
(55990, 3262475372, 3262475375, 'NL', 'NLD', 'هولندا'),
(55991, 3262475376, 3262475383, 'DE', 'DEU', 'ألمانيا'),
(55992, 3262475384, 3262475387, 'US', 'USA', 'الولايات المتحدة'),
(55993, 3262475388, 3262475395, 'AT', 'AUT', 'النمسا'),
(55994, 3262475396, 3262475399, 'NL', 'NLD', 'هولندا'),
(55995, 3262475400, 3262475403, 'US', 'USA', 'الولايات المتحدة'),
(55996, 3262475404, 3262475407, 'SE', 'SWE', 'السويد'),
(55997, 3262475408, 3262475415, 'DE', 'DEU', 'ألمانيا'),
(55998, 3262475416, 3262475419, 'CH', 'CHE', 'سويسرا'),
(55999, 3262475420, 3262475423, 'DE', 'DEU', 'ألمانيا'),
(56000, 3262475424, 3262475427, 'US', 'USA', 'الولايات المتحدة'),
(56001, 3262475428, 3262475431, 'ES', 'ESP', 'إسبانيا'),
(56002, 3262475432, 3262475435, 'IT', 'ITA', 'إيطاليا'),
(56003, 3262475436, 3262475439, 'GB', 'GBR', 'المملكة المتحدة'),
(56004, 3262475440, 3262475443, 'DE', 'DEU', 'ألمانيا'),
(56005, 3262475444, 3262475447, 'US', 'USA', 'الولايات المتحدة'),
(56006, 3262475448, 3262475451, 'FR', 'FRA', 'فرنسا'),
(56007, 3262475452, 3262475459, 'DE', 'DEU', 'ألمانيا'),
(56008, 3262475460, 3262475463, 'FR', 'FRA', 'فرنسا'),
(56009, 3262475464, 3262475467, 'DE', 'DEU', 'ألمانيا'),
(56010, 3262475468, 3262475471, 'ES', 'ESP', 'إسبانيا'),
(56011, 3262475472, 3262475475, 'DE', 'DEU', 'ألمانيا'),
(56012, 3262475476, 3262475479, 'ES', 'ESP', 'إسبانيا'),
(56013, 3262475480, 3262475483, 'US', 'USA', 'الولايات المتحدة'),
(56014, 3262475484, 3262475487, 'IT', 'ITA', 'إيطاليا'),
(56015, 3262475488, 3262475491, 'MX', 'MEX', 'المكسيك'),
(56016, 3262475492, 3262475495, 'CH', 'CHE', 'سويسرا'),
(56017, 3262475496, 3262475499, 'NL', 'NLD', 'هولندا'),
(56018, 3262475500, 3262475503, 'DE', 'DEU', 'ألمانيا'),
(56019, 3262475504, 3262475507, 'FR', 'FRA', 'فرنسا'),
(56020, 3262475508, 3262475511, 'DE', 'DEU', 'ألمانيا'),
(56021, 3262475512, 3262475515, 'US', 'USA', 'الولايات المتحدة'),
(56022, 3262475516, 3262475519, 'DE', 'DEU', 'ألمانيا'),
(56023, 3262475520, 3262475527, 'US', 'USA', 'الولايات المتحدة'),
(56024, 3262475528, 3262475531, 'DE', 'DEU', 'ألمانيا'),
(56025, 3262475532, 3262475559, 'US', 'USA', 'الولايات المتحدة'),
(56026, 3262475560, 3262475575, 'DE', 'DEU', 'ألمانيا'),
(56027, 3262475576, 3262475591, 'US', 'USA', 'الولايات المتحدة'),
(56028, 3262475592, 3262475595, 'BR', 'BRA', 'البرازيل'),
(56029, 3262475596, 3262475607, 'US', 'USA', 'الولايات المتحدة'),
(56030, 3262475608, 3262475611, 'IE', 'IRL', 'إيرلندا'),
(56031, 3262475612, 3262475631, 'DE', 'DEU', 'ألمانيا'),
(56032, 3262475632, 3262475635, 'US', 'USA', 'الولايات المتحدة'),
(56033, 3262475636, 3262475639, 'DE', 'DEU', 'ألمانيا'),
(56034, 3262475640, 3262475683, 'US', 'USA', 'الولايات المتحدة'),
(56035, 3262475684, 3262475687, 'BR', 'BRA', 'البرازيل'),
(56036, 3262475688, 3262475691, 'DE', 'DEU', 'ألمانيا'),
(56037, 3262475692, 3262475695, 'BR', 'BRA', 'البرازيل'),
(56038, 3262475696, 3262475715, 'US', 'USA', 'الولايات المتحدة'),
(56039, 3262475716, 3262475719, 'DE', 'DEU', 'ألمانيا'),
(56040, 3262475720, 3262475723, 'BR', 'BRA', 'البرازيل'),
(56041, 3262475724, 3262475775, 'US', 'USA', 'الولايات المتحدة'),
(56042, 3262475776, 3262475783, 'DE', 'DEU', 'ألمانيا'),
(56043, 3262475784, 3262475787, 'BE', 'BEL', 'بلجيكا'),
(56044, 3262475788, 3262475791, 'DE', 'DEU', 'ألمانيا'),
(56045, 3262475792, 3262475807, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(56046, 3262475808, 3262475811, 'US', 'USA', 'الولايات المتحدة'),
(56047, 3262475812, 3262475815, 'IE', 'IRL', 'إيرلندا'),
(56048, 3262475816, 3262475819, 'FR', 'FRA', 'فرنسا'),
(56049, 3262475820, 3262475823, 'DE', 'DEU', 'ألمانيا'),
(56050, 3262475824, 3262475839, 'RO', 'ROM', 'رومانيا'),
(56051, 3262475840, 3262475855, 'DE', 'DEU', 'ألمانيا'),
(56052, 3262475856, 3262475871, 'TR', 'TUR', 'تركيا'),
(56053, 3262475872, 3262475875, 'BE', 'BEL', 'بلجيكا'),
(56054, 3262475876, 3262475879, 'NL', 'NLD', 'هولندا'),
(56055, 3262475880, 3262475883, 'PL', 'POL', 'بولندا'),
(56056, 3262475884, 3262475887, 'BE', 'BEL', 'بلجيكا'),
(56057, 3262475888, 3262475891, 'DE', 'DEU', 'ألمانيا'),
(56058, 3262475892, 3262475895, 'SA', 'SAU', 'السعودية'),
(56059, 3262475896, 3262475903, 'CY', 'CYP', 'قبرص'),
(56060, 3262475904, 3262475919, 'GR', 'GRC', 'اليونان'),
(56061, 3262475920, 3262475935, 'DE', 'DEU', 'ألمانيا'),
(56062, 3262475936, 3262475951, 'FR', 'FRA', 'فرنسا'),
(56063, 3262475952, 3262475963, 'US', 'USA', 'الولايات المتحدة'),
(56064, 3262475964, 3262475967, 'HU', 'HUN', 'هنغاريا'),
(56065, 3262475968, 3262475975, 'DE', 'DEU', 'ألمانيا'),
(56066, 3262475976, 3262475983, 'BG', 'BGR', 'بلغاريا'),
(56067, 3262475984, 3262475991, 'SG', 'SGP', 'سنغافورة'),
(56068, 3262475992, 3262476015, 'DE', 'DEU', 'ألمانيا'),
(56069, 3262476016, 3262476019, 'ES', 'ESP', 'إسبانيا'),
(56070, 3262476020, 3262476023, 'FR', 'FRA', 'فرنسا'),
(56071, 3262476024, 3262476027, 'DE', 'DEU', 'ألمانيا'),
(56072, 3262476028, 3262476031, 'FR', 'FRA', 'فرنسا'),
(56073, 3262476032, 3262476039, 'DE', 'DEU', 'ألمانيا'),
(56074, 3262476040, 3262476043, 'CH', 'CHE', 'سويسرا'),
(56075, 3262476044, 3262476047, 'DE', 'DEU', 'ألمانيا'),
(56076, 3262476048, 3262476055, 'IL', 'ISR', 'إسرائيل'),
(56077, 3262476056, 3262476059, 'PE', 'PER', 'بيرو'),
(56078, 3262476060, 3262476063, 'US', 'USA', 'الولايات المتحدة'),
(56079, 3262476064, 3262476067, 'DE', 'DEU', 'ألمانيا'),
(56080, 3262476068, 3262476071, 'PL', 'POL', 'بولندا'),
(56081, 3262476072, 3262476075, 'US', 'USA', 'الولايات المتحدة'),
(56082, 3262476076, 3262476079, 'DE', 'DEU', 'ألمانيا'),
(56083, 3262476080, 3262476083, 'FR', 'FRA', 'فرنسا'),
(56084, 3262476084, 3262476087, 'DE', 'DEU', 'ألمانيا'),
(56085, 3262476088, 3262476091, 'DK', 'DNK', 'الدنيمارك'),
(56086, 3262476092, 3262476095, 'NL', 'NLD', 'هولندا'),
(56087, 3262476096, 3262476103, 'US', 'USA', 'الولايات المتحدة'),
(56088, 3262476104, 3262476107, 'DE', 'DEU', 'ألمانيا'),
(56089, 3262476108, 3262476111, 'BE', 'BEL', 'بلجيكا'),
(56090, 3262476112, 3262476115, 'NL', 'NLD', 'هولندا'),
(56091, 3262476116, 3262476119, 'DE', 'DEU', 'ألمانيا'),
(56092, 3262476120, 3262476123, 'FR', 'FRA', 'فرنسا'),
(56093, 3262476124, 3262476127, 'DE', 'DEU', 'ألمانيا'),
(56094, 3262476128, 3262476131, 'GB', 'GBR', 'المملكة المتحدة'),
(56095, 3262476132, 3262476135, 'AR', 'ARG', 'الأرجنتين'),
(56096, 3262476136, 3262476139, 'US', 'USA', 'الولايات المتحدة'),
(56097, 3262476140, 3262476143, 'BE', 'BEL', 'بلجيكا'),
(56098, 3262476144, 3262476147, 'CH', 'CHE', 'سويسرا'),
(56099, 3262476148, 3262476155, 'US', 'USA', 'الولايات المتحدة'),
(56100, 3262476156, 3262476159, 'BE', 'BEL', 'بلجيكا'),
(56101, 3262476160, 3262476163, 'GR', 'GRC', 'اليونان'),
(56102, 3262476164, 3262476171, 'DE', 'DEU', 'ألمانيا'),
(56103, 3262476172, 3262476175, 'GB', 'GBR', 'المملكة المتحدة'),
(56104, 3262476176, 3262476179, 'ES', 'ESP', 'إسبانيا'),
(56105, 3262476180, 3262476183, 'DE', 'DEU', 'ألمانيا'),
(56106, 3262476184, 3262476187, 'AT', 'AUT', 'النمسا'),
(56107, 3262476188, 3262476191, 'PT', 'PRT', 'البورتوغال'),
(56108, 3262476192, 3262476195, 'DE', 'DEU', 'ألمانيا'),
(56109, 3262476196, 3262476199, 'US', 'USA', 'الولايات المتحدة'),
(56110, 3262476200, 3262476203, 'GB', 'GBR', 'المملكة المتحدة'),
(56111, 3262476204, 3262476207, 'NA', 'NAM', 'ناميبيا'),
(56112, 3262476208, 3262476211, 'US', 'USA', 'الولايات المتحدة'),
(56113, 3262476212, 3262476215, 'CL', 'CHL', 'تشيلي'),
(56114, 3262476216, 3262476223, 'FR', 'FRA', 'فرنسا'),
(56115, 3262476224, 3262476227, 'GR', 'GRC', 'اليونان'),
(56116, 3262476228, 3262476231, 'SE', 'SWE', 'السويد'),
(56117, 3262476232, 3262476235, 'FR', 'FRA', 'فرنسا'),
(56118, 3262476236, 3262476239, 'US', 'USA', 'الولايات المتحدة'),
(56119, 3262476240, 3262476243, 'IT', 'ITA', 'إيطاليا'),
(56120, 3262476244, 3262476247, 'ES', 'ESP', 'إسبانيا'),
(56121, 3262476248, 3262476251, 'NL', 'NLD', 'هولندا'),
(56122, 3262476252, 3262476255, 'DE', 'DEU', 'ألمانيا'),
(56123, 3262476256, 3262476259, 'US', 'USA', 'الولايات المتحدة'),
(56124, 3262476260, 3262476267, 'DE', 'DEU', 'ألمانيا'),
(56125, 3262476268, 3262476271, 'US', 'USA', 'الولايات المتحدة'),
(56126, 3262476272, 3262476275, 'DE', 'DEU', 'ألمانيا'),
(56127, 3262476276, 3262476279, 'CA', 'CAN', 'كندا'),
(56128, 3262476280, 3262476283, 'BE', 'BEL', 'بلجيكا'),
(56129, 3262476284, 3262476291, 'DE', 'DEU', 'ألمانيا'),
(56130, 3262476292, 3262476295, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56131, 3262476296, 3262476299, 'US', 'USA', 'الولايات المتحدة'),
(56132, 3262476300, 3262476303, 'DO', 'DOM', 'الدومينيكان'),
(56133, 3262476304, 3262476307, 'US', 'USA', 'الولايات المتحدة'),
(56134, 3262476308, 3262476315, 'DE', 'DEU', 'ألمانيا'),
(56135, 3262476316, 3262476319, 'BE', 'BEL', 'بلجيكا'),
(56136, 3262476320, 3262476323, 'DE', 'DEU', 'ألمانيا'),
(56137, 3262476324, 3262476327, 'IT', 'ITA', 'إيطاليا'),
(56138, 3262476328, 3262476331, 'NL', 'NLD', 'هولندا'),
(56139, 3262476332, 3262476339, 'DE', 'DEU', 'ألمانيا'),
(56140, 3262476340, 3262476343, 'ES', 'ESP', 'إسبانيا'),
(56141, 3262476344, 3262476351, 'DE', 'DEU', 'ألمانيا'),
(56142, 3262476352, 3262476355, 'AR', 'ARG', 'الأرجنتين'),
(56143, 3262476356, 3262476363, 'US', 'USA', 'الولايات المتحدة'),
(56144, 3262476364, 3262476367, 'PT', 'PRT', 'البورتوغال'),
(56145, 3262476368, 3262476371, 'US', 'USA', 'الولايات المتحدة'),
(56146, 3262476372, 3262476375, 'DE', 'DEU', 'ألمانيا'),
(56147, 3262476376, 3262476387, 'US', 'USA', 'الولايات المتحدة'),
(56148, 3262476388, 3262476391, 'SK', 'SVK', 'سلوفاكيا'),
(56149, 3262476392, 3262476395, 'DE', 'DEU', 'ألمانيا'),
(56150, 3262476396, 3262476399, 'AT', 'AUT', 'النمسا'),
(56151, 3262476400, 3262476403, 'ES', 'ESP', 'إسبانيا'),
(56152, 3262476404, 3262476411, 'DE', 'DEU', 'ألمانيا'),
(56153, 3262476412, 3262476415, 'US', 'USA', 'الولايات المتحدة'),
(56154, 3262476416, 3262476419, 'DE', 'DEU', 'ألمانيا'),
(56155, 3262476420, 3262476423, 'CH', 'CHE', 'سويسرا'),
(56156, 3262476424, 3262476427, 'ES', 'ESP', 'إسبانيا'),
(56157, 3262476428, 3262476431, 'US', 'USA', 'الولايات المتحدة'),
(56158, 3262476432, 3262476435, 'IT', 'ITA', 'إيطاليا'),
(56159, 3262476436, 3262476439, 'AT', 'AUT', 'النمسا'),
(56160, 3262476440, 3262476443, 'DE', 'DEU', 'ألمانيا'),
(56161, 3262476444, 3262476447, 'AT', 'AUT', 'النمسا'),
(56162, 3262476448, 3262476455, 'DE', 'DEU', 'ألمانيا'),
(56163, 3262476456, 3262476459, 'CA', 'CAN', 'كندا'),
(56164, 3262476460, 3262476463, 'DK', 'DNK', 'الدنيمارك'),
(56165, 3262476464, 3262476467, 'SK', 'SVK', 'سلوفاكيا'),
(56166, 3262476468, 3262476471, 'IT', 'ITA', 'إيطاليا'),
(56167, 3262476472, 3262476475, 'CA', 'CAN', 'كندا'),
(56168, 3262476476, 3262476483, 'US', 'USA', 'الولايات المتحدة'),
(56169, 3262476484, 3262476487, 'DE', 'DEU', 'ألمانيا'),
(56170, 3262476488, 3262476491, 'US', 'USA', 'الولايات المتحدة'),
(56171, 3262476492, 3262476495, 'BE', 'BEL', 'بلجيكا'),
(56172, 3262476496, 3262476499, 'US', 'USA', 'الولايات المتحدة'),
(56173, 3262476500, 3262476503, 'DE', 'DEU', 'ألمانيا'),
(56174, 3262476504, 3262476507, 'CH', 'CHE', 'سويسرا'),
(56175, 3262476508, 3262476511, 'DE', 'DEU', 'ألمانيا'),
(56176, 3262476512, 3262476515, 'US', 'USA', 'الولايات المتحدة'),
(56177, 3262476516, 3262476519, 'DE', 'DEU', 'ألمانيا'),
(56178, 3262476520, 3262476523, 'GB', 'GBR', 'المملكة المتحدة'),
(56179, 3262476524, 3262476527, 'MX', 'MEX', 'المكسيك'),
(56180, 3262476528, 3262476531, 'DE', 'DEU', 'ألمانيا'),
(56181, 3262476532, 3262476535, 'IL', 'ISR', 'إسرائيل'),
(56182, 3262476536, 3262476539, 'US', 'USA', 'الولايات المتحدة'),
(56183, 3262476540, 3262476543, 'DE', 'DEU', 'ألمانيا'),
(56184, 3262476544, 3262476547, 'DK', 'DNK', 'الدنيمارك'),
(56185, 3262476548, 3262476551, 'AR', 'ARG', 'الأرجنتين'),
(56186, 3262476552, 3262476555, 'IT', 'ITA', 'إيطاليا'),
(56187, 3262476556, 3262476559, 'FR', 'FRA', 'فرنسا'),
(56188, 3262476560, 3262476567, 'DE', 'DEU', 'ألمانيا'),
(56189, 3262476568, 3262476571, 'US', 'USA', 'الولايات المتحدة'),
(56190, 3262476572, 3262476575, 'DE', 'DEU', 'ألمانيا'),
(56191, 3262476576, 3262476587, 'US', 'USA', 'الولايات المتحدة'),
(56192, 3262476588, 3262476591, 'ES', 'ESP', 'إسبانيا'),
(56193, 3262476592, 3262476595, 'GB', 'GBR', 'المملكة المتحدة'),
(56194, 3262476596, 3262476603, 'DE', 'DEU', 'ألمانيا'),
(56195, 3262476604, 3262476607, 'NL', 'NLD', 'هولندا'),
(56196, 3262476608, 3262476611, 'SK', 'SVK', 'سلوفاكيا'),
(56197, 3262476612, 3262476615, 'GB', 'GBR', 'المملكة المتحدة'),
(56198, 3262476616, 3262476619, 'TR', 'TUR', 'تركيا'),
(56199, 3262476620, 3262476623, 'NL', 'NLD', 'هولندا'),
(56200, 3262476624, 3262476627, 'US', 'USA', 'الولايات المتحدة'),
(56201, 3262476628, 3262476635, 'DE', 'DEU', 'ألمانيا'),
(56202, 3262476636, 3262476639, 'DK', 'DNK', 'الدنيمارك'),
(56203, 3262476640, 3262476643, 'DE', 'DEU', 'ألمانيا'),
(56204, 3262476644, 3262476647, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56205, 3262476648, 3262476651, 'US', 'USA', 'الولايات المتحدة'),
(56206, 3262476652, 3262476655, 'FR', 'FRA', 'فرنسا'),
(56207, 3262476656, 3262476667, 'US', 'USA', 'الولايات المتحدة'),
(56208, 3262476668, 3262476671, 'GB', 'GBR', 'المملكة المتحدة'),
(56209, 3262476672, 3262476675, 'SE', 'SWE', 'السويد'),
(56210, 3262476676, 3262476679, 'AT', 'AUT', 'النمسا'),
(56211, 3262476680, 3262476683, 'NL', 'NLD', 'هولندا'),
(56212, 3262476684, 3262476687, 'IT', 'ITA', 'إيطاليا'),
(56213, 3262476688, 3262476691, 'DE', 'DEU', 'ألمانيا'),
(56214, 3262476692, 3262476695, 'FR', 'FRA', 'فرنسا'),
(56215, 3262476696, 3262476699, 'ES', 'ESP', 'إسبانيا'),
(56216, 3262476700, 3262476707, 'DE', 'DEU', 'ألمانيا'),
(56217, 3262476708, 3262476715, 'US', 'USA', 'الولايات المتحدة'),
(56218, 3262476716, 3262476719, 'FR', 'FRA', 'فرنسا'),
(56219, 3262476720, 3262476723, 'IT', 'ITA', 'إيطاليا'),
(56220, 3262476724, 3262476727, 'FR', 'FRA', 'فرنسا'),
(56221, 3262476728, 3262476731, 'US', 'USA', 'الولايات المتحدة'),
(56222, 3262476732, 3262476735, 'DE', 'DEU', 'ألمانيا'),
(56223, 3262476736, 3262476739, 'CA', 'CAN', 'كندا'),
(56224, 3262476740, 3262476743, 'DE', 'DEU', 'ألمانيا'),
(56225, 3262476744, 3262476747, 'CH', 'CHE', 'سويسرا'),
(56226, 3262476748, 3262476751, 'BE', 'BEL', 'بلجيكا'),
(56227, 3262476752, 3262476755, 'ES', 'ESP', 'إسبانيا'),
(56228, 3262476756, 3262476759, 'DE', 'DEU', 'ألمانيا'),
(56229, 3262476760, 3262476763, 'US', 'USA', 'الولايات المتحدة'),
(56230, 3262476764, 3262476767, 'ES', 'ESP', 'إسبانيا'),
(56231, 3262476768, 3262476771, 'DK', 'DNK', 'الدنيمارك'),
(56232, 3262476772, 3262476779, 'US', 'USA', 'الولايات المتحدة'),
(56233, 3262476780, 3262476783, 'DE', 'DEU', 'ألمانيا'),
(56234, 3262476784, 3262476787, 'IT', 'ITA', 'إيطاليا'),
(56235, 3262476788, 3262476791, 'US', 'USA', 'الولايات المتحدة'),
(56236, 3262476792, 3262476795, 'ES', 'ESP', 'إسبانيا'),
(56237, 3262476796, 3262476799, 'DE', 'DEU', 'ألمانيا'),
(56238, 3262476800, 3262476803, 'CA', 'CAN', 'كندا'),
(56239, 3262476804, 3262476807, 'TR', 'TUR', 'تركيا'),
(56240, 3262476808, 3262476827, 'DE', 'DEU', 'ألمانيا'),
(56241, 3262476828, 3262476831, 'LU', 'LUX', 'لوكسيمبورغ'),
(56242, 3262476832, 3262476839, 'DE', 'DEU', 'ألمانيا'),
(56243, 3262476840, 3262476843, 'IT', 'ITA', 'إيطاليا'),
(56244, 3262476844, 3262476847, 'DE', 'DEU', 'ألمانيا'),
(56245, 3262476848, 3262476851, 'CH', 'CHE', 'سويسرا'),
(56246, 3262476852, 3262476855, 'US', 'USA', 'الولايات المتحدة'),
(56247, 3262476856, 3262476859, 'ES', 'ESP', 'إسبانيا'),
(56248, 3262476860, 3262476863, 'DE', 'DEU', 'ألمانيا'),
(56249, 3262476864, 3262476867, 'US', 'USA', 'الولايات المتحدة'),
(56250, 3262476868, 3262476883, 'DE', 'DEU', 'ألمانيا'),
(56251, 3262476884, 3262476887, 'FR', 'FRA', 'فرنسا'),
(56252, 3262476888, 3262476891, 'DE', 'DEU', 'ألمانيا'),
(56253, 3262476892, 3262476895, 'HU', 'HUN', 'هنغاريا'),
(56254, 3262476896, 3262476899, 'SK', 'SVK', 'سلوفاكيا'),
(56255, 3262476900, 3262476903, 'FR', 'FRA', 'فرنسا'),
(56256, 3262476904, 3262476907, 'DE', 'DEU', 'ألمانيا'),
(56257, 3262476908, 3262476911, 'NL', 'NLD', 'هولندا'),
(56258, 3262476912, 3262476915, 'CH', 'CHE', 'سويسرا'),
(56259, 3262476916, 3262476919, 'DE', 'DEU', 'ألمانيا'),
(56260, 3262476920, 3262476923, 'US', 'USA', 'الولايات المتحدة'),
(56261, 3262476924, 3262476927, 'AT', 'AUT', 'النمسا'),
(56262, 3262476928, 3262476935, 'DE', 'DEU', 'ألمانيا'),
(56263, 3262476936, 3262476939, 'AT', 'AUT', 'النمسا'),
(56264, 3262476940, 3262476951, 'DE', 'DEU', 'ألمانيا'),
(56265, 3262476952, 3262476955, 'NL', 'NLD', 'هولندا'),
(56266, 3262476956, 3262476971, 'DE', 'DEU', 'ألمانيا'),
(56267, 3262476972, 3262476975, 'US', 'USA', 'الولايات المتحدة'),
(56268, 3262476976, 3262476979, 'BE', 'BEL', 'بلجيكا'),
(56269, 3262476980, 3262476983, 'DE', 'DEU', 'ألمانيا'),
(56270, 3262476984, 3262476987, 'FR', 'FRA', 'فرنسا'),
(56271, 3262476988, 3262476995, 'DE', 'DEU', 'ألمانيا'),
(56272, 3262476996, 3262476999, 'IT', 'ITA', 'إيطاليا'),
(56273, 3262477000, 3262477003, 'GB', 'GBR', 'المملكة المتحدة'),
(56274, 3262477004, 3262477007, 'DE', 'DEU', 'ألمانيا'),
(56275, 3262477008, 3262477011, 'CA', 'CAN', 'كندا'),
(56276, 3262477012, 3262477015, 'DE', 'DEU', 'ألمانيا'),
(56277, 3262477016, 3262477019, 'CH', 'CHE', 'سويسرا'),
(56278, 3262477020, 3262477023, 'DE', 'DEU', 'ألمانيا'),
(56279, 3262477024, 3262477035, 'FR', 'FRA', 'فرنسا'),
(56280, 3262477036, 3262477039, 'DK', 'DNK', 'الدنيمارك'),
(56281, 3262477040, 3262477043, 'US', 'USA', 'الولايات المتحدة'),
(56282, 3262477044, 3262477047, 'GB', 'GBR', 'المملكة المتحدة'),
(56283, 3262477048, 3262477059, 'DE', 'DEU', 'ألمانيا'),
(56284, 3262477060, 3262477063, 'US', 'USA', 'الولايات المتحدة'),
(56285, 3262477064, 3262477067, 'DE', 'DEU', 'ألمانيا'),
(56286, 3262477068, 3262477071, 'AT', 'AUT', 'النمسا'),
(56287, 3262477072, 3262477075, 'PT', 'PRT', 'البورتوغال'),
(56288, 3262477076, 3262477083, 'FR', 'FRA', 'فرنسا'),
(56289, 3262477084, 3262477087, 'NL', 'NLD', 'هولندا'),
(56290, 3262477088, 3262477091, 'DE', 'DEU', 'ألمانيا'),
(56291, 3262477092, 3262477095, 'BE', 'BEL', 'بلجيكا'),
(56292, 3262477096, 3262477107, 'DE', 'DEU', 'ألمانيا'),
(56293, 3262477108, 3262477111, 'ES', 'ESP', 'إسبانيا'),
(56294, 3262477112, 3262477131, 'DE', 'DEU', 'ألمانيا'),
(56295, 3262477132, 3262477135, 'SK', 'SVK', 'سلوفاكيا'),
(56296, 3262477136, 3262477147, 'DE', 'DEU', 'ألمانيا'),
(56297, 3262477148, 3262477151, 'FR', 'FRA', 'فرنسا'),
(56298, 3262477152, 3262477155, 'CH', 'CHE', 'سويسرا'),
(56299, 3262477156, 3262477159, 'ES', 'ESP', 'إسبانيا'),
(56300, 3262477160, 3262477163, 'US', 'USA', 'الولايات المتحدة'),
(56301, 3262477164, 3262477167, 'FR', 'FRA', 'فرنسا'),
(56302, 3262477168, 3262477171, 'NL', 'NLD', 'هولندا'),
(56303, 3262477172, 3262477175, 'DE', 'DEU', 'ألمانيا'),
(56304, 3262477176, 3262477187, 'US', 'USA', 'الولايات المتحدة'),
(56305, 3262477188, 3262477191, 'IT', 'ITA', 'إيطاليا'),
(56306, 3262477192, 3262477195, 'GB', 'GBR', 'المملكة المتحدة'),
(56307, 3262477196, 3262477199, 'PL', 'POL', 'بولندا'),
(56308, 3262477200, 3262477203, 'GB', 'GBR', 'المملكة المتحدة'),
(56309, 3262477204, 3262477207, 'US', 'USA', 'الولايات المتحدة'),
(56310, 3262477208, 3262477211, 'ES', 'ESP', 'إسبانيا'),
(56311, 3262477212, 3262477215, 'AT', 'AUT', 'النمسا'),
(56312, 3262477216, 3262477219, 'US', 'USA', 'الولايات المتحدة'),
(56313, 3262477220, 3262477223, 'KW', 'KWT', 'الكويت'),
(56314, 3262477224, 3262477227, 'BE', 'BEL', 'بلجيكا'),
(56315, 3262477228, 3262477231, 'GB', 'GBR', 'المملكة المتحدة'),
(56316, 3262477232, 3262477239, 'DE', 'DEU', 'ألمانيا'),
(56317, 3262477240, 3262477243, 'CA', 'CAN', 'كندا'),
(56318, 3262477244, 3262477247, 'US', 'USA', 'الولايات المتحدة'),
(56319, 3262477248, 3262477251, 'AR', 'ARG', 'الأرجنتين'),
(56320, 3262477252, 3262477255, 'ES', 'ESP', 'إسبانيا'),
(56321, 3262477256, 3262477259, 'DE', 'DEU', 'ألمانيا'),
(56322, 3262477260, 3262477263, 'GB', 'GBR', 'المملكة المتحدة'),
(56323, 3262477264, 3262477267, 'GR', 'GRC', 'اليونان'),
(56324, 3262477268, 3262477271, 'NL', 'NLD', 'هولندا'),
(56325, 3262477272, 3262477275, 'US', 'USA', 'الولايات المتحدة'),
(56326, 3262477276, 3262477279, 'NL', 'NLD', 'هولندا'),
(56327, 3262477280, 3262477283, 'DE', 'DEU', 'ألمانيا'),
(56328, 3262477284, 3262477287, 'FR', 'FRA', 'فرنسا'),
(56329, 3262477288, 3262477291, 'BM', 'BMU', 'برمودا'),
(56330, 3262477292, 3262477295, 'US', 'USA', 'الولايات المتحدة'),
(56331, 3262477296, 3262477299, 'DK', 'DNK', 'الدنيمارك'),
(56332, 3262477300, 3262477303, 'IT', 'ITA', 'إيطاليا'),
(56333, 3262477304, 3262477307, 'FR', 'FRA', 'فرنسا'),
(56334, 3262477308, 3262477311, 'DE', 'DEU', 'ألمانيا'),
(56335, 3262477312, 3262477315, 'ES', 'ESP', 'إسبانيا'),
(56336, 3262477316, 3262477319, 'HU', 'HUN', 'هنغاريا'),
(56337, 3262477320, 3262477327, 'US', 'USA', 'الولايات المتحدة'),
(56338, 3262477328, 3262477331, 'HU', 'HUN', 'هنغاريا'),
(56339, 3262477332, 3262477335, 'DE', 'DEU', 'ألمانيا'),
(56340, 3262477336, 3262477339, 'CA', 'CAN', 'كندا'),
(56341, 3262477340, 3262477343, 'US', 'USA', 'الولايات المتحدة'),
(56342, 3262477344, 3262477347, 'CH', 'CHE', 'سويسرا'),
(56343, 3262477348, 3262477355, 'DE', 'DEU', 'ألمانيا'),
(56344, 3262477356, 3262477359, 'PL', 'POL', 'بولندا'),
(56345, 3262477360, 3262477363, 'LU', 'LUX', 'لوكسيمبورغ'),
(56346, 3262477364, 3262477367, 'ES', 'ESP', 'إسبانيا'),
(56347, 3262477368, 3262477371, 'US', 'USA', 'الولايات المتحدة'),
(56348, 3262477372, 3262477375, 'FR', 'FRA', 'فرنسا'),
(56349, 3262477376, 3262477379, 'AT', 'AUT', 'النمسا'),
(56350, 3262477380, 3262477383, 'US', 'USA', 'الولايات المتحدة'),
(56351, 3262477384, 3262477387, 'FR', 'FRA', 'فرنسا'),
(56352, 3262477388, 3262477399, 'DE', 'DEU', 'ألمانيا'),
(56353, 3262477400, 3262477403, 'CH', 'CHE', 'سويسرا'),
(56354, 3262477404, 3262477407, 'DE', 'DEU', 'ألمانيا'),
(56355, 3262477408, 3262477411, 'US', 'USA', 'الولايات المتحدة'),
(56356, 3262477412, 3262477415, 'SA', 'SAU', 'السعودية'),
(56357, 3262477416, 3262477419, 'DK', 'DNK', 'الدنيمارك'),
(56358, 3262477420, 3262477427, 'DE', 'DEU', 'ألمانيا'),
(56359, 3262477428, 3262477431, 'US', 'USA', 'الولايات المتحدة'),
(56360, 3262477432, 3262477439, 'DE', 'DEU', 'ألمانيا'),
(56361, 3262477440, 3262477443, 'CH', 'CHE', 'سويسرا'),
(56362, 3262477444, 3262477447, 'BE', 'BEL', 'بلجيكا'),
(56363, 3262477448, 3262477451, 'AR', 'ARG', 'الأرجنتين'),
(56364, 3262477452, 3262477455, 'PT', 'PRT', 'البورتوغال'),
(56365, 3262477456, 3262477467, 'DE', 'DEU', 'ألمانيا'),
(56366, 3262477468, 3262477471, 'AT', 'AUT', 'النمسا'),
(56367, 3262477472, 3262477475, 'HU', 'HUN', 'هنغاريا'),
(56368, 3262477476, 3262477479, 'FR', 'FRA', 'فرنسا'),
(56369, 3262477480, 3262477483, 'SE', 'SWE', 'السويد'),
(56370, 3262477484, 3262477487, 'NL', 'NLD', 'هولندا'),
(56371, 3262477488, 3262477499, 'DE', 'DEU', 'ألمانيا'),
(56372, 3262477500, 3262477503, 'ES', 'ESP', 'إسبانيا'),
(56373, 3262477504, 3262477507, 'FR', 'FRA', 'فرنسا'),
(56374, 3262477508, 3262477511, 'CH', 'CHE', 'سويسرا'),
(56375, 3262477512, 3262477519, 'US', 'USA', 'الولايات المتحدة'),
(56376, 3262477520, 3262477523, 'DE', 'DEU', 'ألمانيا'),
(56377, 3262477524, 3262477527, 'IT', 'ITA', 'إيطاليا'),
(56378, 3262477528, 3262477543, 'DE', 'DEU', 'ألمانيا'),
(56379, 3262477544, 3262477547, 'US', 'USA', 'الولايات المتحدة'),
(56380, 3262477548, 3262477551, 'DE', 'DEU', 'ألمانيا'),
(56381, 3262477552, 3262477555, 'BR', 'BRA', 'البرازيل'),
(56382, 3262477556, 3262477559, 'US', 'USA', 'الولايات المتحدة'),
(56383, 3262477560, 3262477563, 'CA', 'CAN', 'كندا'),
(56384, 3262477564, 3262477571, 'BE', 'BEL', 'بلجيكا'),
(56385, 3262477572, 3262477575, 'NL', 'NLD', 'هولندا'),
(56386, 3262477576, 3262477579, 'DE', 'DEU', 'ألمانيا'),
(56387, 3262477580, 3262477583, 'NO', 'NOR', 'النرويج'),
(56388, 3262477584, 3262477587, 'CA', 'CAN', 'كندا'),
(56389, 3262477588, 3262477591, 'FR', 'FRA', 'فرنسا'),
(56390, 3262477592, 3262477595, 'GB', 'GBR', 'المملكة المتحدة'),
(56391, 3262477596, 3262477599, 'CH', 'CHE', 'سويسرا'),
(56392, 3262477600, 3262477603, 'NL', 'NLD', 'هولندا'),
(56393, 3262477604, 3262477607, 'IT', 'ITA', 'إيطاليا'),
(56394, 3262477608, 3262477611, 'DE', 'DEU', 'ألمانيا'),
(56395, 3262477612, 3262477615, 'US', 'USA', 'الولايات المتحدة'),
(56396, 3262477616, 3262477619, 'IT', 'ITA', 'إيطاليا'),
(56397, 3262477620, 3262477623, 'DE', 'DEU', 'ألمانيا'),
(56398, 3262477624, 3262477627, 'FR', 'FRA', 'فرنسا'),
(56399, 3262477628, 3262477631, 'CH', 'CHE', 'سويسرا'),
(56400, 3262477632, 3262477635, 'AT', 'AUT', 'النمسا'),
(56401, 3262477636, 3262477639, 'VE', 'VEN', 'فنزويلا'),
(56402, 3262477640, 3262477643, 'DE', 'DEU', 'ألمانيا'),
(56403, 3262477644, 3262477647, 'GB', 'GBR', 'المملكة المتحدة'),
(56404, 3262477648, 3262477655, 'DE', 'DEU', 'ألمانيا'),
(56405, 3262477656, 3262477659, 'NL', 'NLD', 'هولندا'),
(56406, 3262477660, 3262477671, 'US', 'USA', 'الولايات المتحدة'),
(56407, 3262477672, 3262477675, 'NL', 'NLD', 'هولندا'),
(56408, 3262477676, 3262477687, 'DE', 'DEU', 'ألمانيا'),
(56409, 3262477688, 3262477691, 'FR', 'FRA', 'فرنسا'),
(56410, 3262477692, 3262477695, 'DE', 'DEU', 'ألمانيا'),
(56411, 3262477696, 3262477699, 'NL', 'NLD', 'هولندا'),
(56412, 3262477700, 3262477703, 'FR', 'FRA', 'فرنسا'),
(56413, 3262477704, 3262477707, 'IT', 'ITA', 'إيطاليا'),
(56414, 3262477708, 3262477711, 'GB', 'GBR', 'المملكة المتحدة'),
(56415, 3262477712, 3262477727, 'DE', 'DEU', 'ألمانيا'),
(56416, 3262477728, 3262477731, 'AT', 'AUT', 'النمسا'),
(56417, 3262477732, 3262477735, 'NL', 'NLD', 'هولندا'),
(56418, 3262477736, 3262477739, 'BR', 'BRA', 'البرازيل'),
(56419, 3262477740, 3262477743, 'NL', 'NLD', 'هولندا'),
(56420, 3262477744, 3262477751, 'CH', 'CHE', 'سويسرا'),
(56421, 3262477752, 3262477759, 'DE', 'DEU', 'ألمانيا'),
(56422, 3262477760, 3262477763, 'US', 'USA', 'الولايات المتحدة'),
(56423, 3262477764, 3262477767, 'VE', 'VEN', 'فنزويلا'),
(56424, 3262477768, 3262477771, 'DE', 'DEU', 'ألمانيا'),
(56425, 3262477772, 3262477775, 'CA', 'CAN', 'كندا'),
(56426, 3262477776, 3262477779, 'CZ', 'CZE', 'التشيك'),
(56427, 3262477780, 3262477783, 'GB', 'GBR', 'المملكة المتحدة'),
(56428, 3262477784, 3262477787, 'DE', 'DEU', 'ألمانيا'),
(56429, 3262477788, 3262477791, 'US', 'USA', 'الولايات المتحدة'),
(56430, 3262477792, 3262477795, 'GB', 'GBR', 'المملكة المتحدة'),
(56431, 3262477796, 3262477799, 'FR', 'FRA', 'فرنسا'),
(56432, 3262477800, 3262477803, 'BE', 'BEL', 'بلجيكا'),
(56433, 3262477804, 3262477807, 'CH', 'CHE', 'سويسرا'),
(56434, 3262477808, 3262477811, 'CA', 'CAN', 'كندا'),
(56435, 3262477812, 3262477819, 'US', 'USA', 'الولايات المتحدة'),
(56436, 3262477820, 3262477823, 'DE', 'DEU', 'ألمانيا'),
(56437, 3262477824, 3262477827, 'GB', 'GBR', 'المملكة المتحدة'),
(56438, 3262477828, 3262477831, 'US', 'USA', 'الولايات المتحدة'),
(56439, 3262477832, 3262477835, 'CH', 'CHE', 'سويسرا'),
(56440, 3262477836, 3262477839, 'ES', 'ESP', 'إسبانيا'),
(56441, 3262477840, 3262477843, 'GB', 'GBR', 'المملكة المتحدة'),
(56442, 3262477844, 3262477847, 'DE', 'DEU', 'ألمانيا'),
(56443, 3262477848, 3262477851, 'GB', 'GBR', 'المملكة المتحدة'),
(56444, 3262477852, 3262477855, 'DE', 'DEU', 'ألمانيا'),
(56445, 3262477856, 3262477859, 'CA', 'CAN', 'كندا'),
(56446, 3262477860, 3262477863, 'US', 'USA', 'الولايات المتحدة'),
(56447, 3262477864, 3262477867, 'TR', 'TUR', 'تركيا'),
(56448, 3262477868, 3262477871, 'HU', 'HUN', 'هنغاريا'),
(56449, 3262477872, 3262477883, 'DE', 'DEU', 'ألمانيا'),
(56450, 3262477884, 3262477891, 'US', 'USA', 'الولايات المتحدة'),
(56451, 3262477892, 3262477895, 'IT', 'ITA', 'إيطاليا'),
(56452, 3262477896, 3262477899, 'US', 'USA', 'الولايات المتحدة'),
(56453, 3262477900, 3262477903, 'DE', 'DEU', 'ألمانيا'),
(56454, 3262477904, 3262477907, 'GB', 'GBR', 'المملكة المتحدة'),
(56455, 3262477908, 3262477911, 'CH', 'CHE', 'سويسرا'),
(56456, 3262477912, 3262477915, 'US', 'USA', 'الولايات المتحدة'),
(56457, 3262477916, 3262477919, 'DE', 'DEU', 'ألمانيا'),
(56458, 3262477920, 3262477923, 'US', 'USA', 'الولايات المتحدة'),
(56459, 3262477924, 3262477927, 'HU', 'HUN', 'هنغاريا'),
(56460, 3262477928, 3262477931, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(56461, 3262477932, 3262477935, 'US', 'USA', 'الولايات المتحدة'),
(56462, 3262477936, 3262477939, 'DE', 'DEU', 'ألمانيا'),
(56463, 3262477940, 3262477943, 'CA', 'CAN', 'كندا'),
(56464, 3262477944, 3262477955, 'DE', 'DEU', 'ألمانيا'),
(56465, 3262477956, 3262477959, 'US', 'USA', 'الولايات المتحدة'),
(56466, 3262477960, 3262477963, 'CA', 'CAN', 'كندا'),
(56467, 3262477964, 3262477967, 'DE', 'DEU', 'ألمانيا'),
(56468, 3262477968, 3262477971, 'IT', 'ITA', 'إيطاليا'),
(56469, 3262477972, 3262477987, 'DE', 'DEU', 'ألمانيا'),
(56470, 3262477988, 3262477991, 'NL', 'NLD', 'هولندا'),
(56471, 3262477992, 3262477999, 'DE', 'DEU', 'ألمانيا'),
(56472, 3262478000, 3262478003, 'US', 'USA', 'الولايات المتحدة'),
(56473, 3262478004, 3262478007, 'FR', 'FRA', 'فرنسا'),
(56474, 3262478008, 3262478011, 'IT', 'ITA', 'إيطاليا'),
(56475, 3262478012, 3262478015, 'PE', 'PER', 'بيرو'),
(56476, 3262478016, 3262478019, 'CH', 'CHE', 'سويسرا'),
(56477, 3262478020, 3262478027, 'DE', 'DEU', 'ألمانيا'),
(56478, 3262478028, 3262478031, 'SE', 'SWE', 'السويد'),
(56479, 3262478032, 3262478035, 'AT', 'AUT', 'النمسا'),
(56480, 3262478036, 3262478039, 'DE', 'DEU', 'ألمانيا'),
(56481, 3262478040, 3262478043, 'NL', 'NLD', 'هولندا'),
(56482, 3262478044, 3262478047, 'IS', 'ISL', 'أيسلندا'),
(56483, 3262478048, 3262478055, 'DE', 'DEU', 'ألمانيا'),
(56484, 3262478056, 3262478063, 'CH', 'CHE', 'سويسرا'),
(56485, 3262478064, 3262478067, 'DE', 'DEU', 'ألمانيا'),
(56486, 3262478068, 3262478071, 'KE', 'KEN', 'كينيا'),
(56487, 3262478072, 3262478081, 'DE', 'DEU', 'ألمانيا'),
(56488, 3262478082, 3262478082, 'ES', 'ESP', 'إسبانيا'),
(56489, 3262478083, 3262478083, 'SA', 'SAU', 'السعودية'),
(56490, 3262478084, 3262478084, 'TR', 'TUR', 'تركيا'),
(56491, 3262478085, 3262478085, 'FR', 'FRA', 'فرنسا'),
(56492, 3262478086, 3262478088, 'DE', 'DEU', 'ألمانيا'),
(56493, 3262478089, 3262478089, 'AT', 'AUT', 'النمسا'),
(56494, 3262478090, 3262478090, 'DE', 'DEU', 'ألمانيا'),
(56495, 3262478091, 3262478091, 'HU', 'HUN', 'هنغاريا'),
(56496, 3262478092, 3262478092, 'PT', 'PRT', 'البورتوغال'),
(56497, 3262478093, 3262478093, 'SA', 'SAU', 'السعودية'),
(56498, 3262478094, 3262478094, 'PT', 'PRT', 'البورتوغال'),
(56499, 3262478095, 3262478095, 'DE', 'DEU', 'ألمانيا'),
(56500, 3262478096, 3262478096, 'PL', 'POL', 'بولندا'),
(56501, 3262478097, 3262478097, 'KE', 'KEN', 'كينيا'),
(56502, 3262478098, 3262478098, 'TR', 'TUR', 'تركيا'),
(56503, 3262478099, 3262478099, 'DE', 'DEU', 'ألمانيا'),
(56504, 3262478100, 3262478100, 'TR', 'TUR', 'تركيا'),
(56505, 3262478101, 3262478101, 'ZW', 'ZWE', 'زمبابواي'),
(56506, 3262478102, 3262478102, 'TR', 'TUR', 'تركيا'),
(56507, 3262478103, 3262478103, 'DE', 'DEU', 'ألمانيا'),
(56508, 3262478104, 3262478104, 'TR', 'TUR', 'تركيا'),
(56509, 3262478105, 3262478105, 'PL', 'POL', 'بولندا'),
(56510, 3262478106, 3262478106, 'IT', 'ITA', 'إيطاليا'),
(56511, 3262478107, 3262478107, 'TR', 'TUR', 'تركيا'),
(56512, 3262478108, 3262478108, 'DE', 'DEU', 'ألمانيا'),
(56513, 3262478109, 3262478109, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(56514, 3262478110, 3262478113, 'DE', 'DEU', 'ألمانيا'),
(56515, 3262478114, 3262478114, 'TR', 'TUR', 'تركيا'),
(56516, 3262478115, 3262478115, 'DE', 'DEU', 'ألمانيا'),
(56517, 3262478116, 3262478116, 'NO', 'NOR', 'النرويج'),
(56518, 3262478117, 3262478117, 'NA', 'NAM', 'ناميبيا'),
(56519, 3262478118, 3262478118, 'DE', 'DEU', 'ألمانيا'),
(56520, 3262478119, 3262478119, 'SA', 'SAU', 'السعودية'),
(56521, 3262478120, 3262478120, 'NA', 'NAM', 'ناميبيا'),
(56522, 3262478121, 3262478121, 'AO', 'AGO', 'أنغولا'),
(56523, 3262478122, 3262478122, 'NA', 'NAM', 'ناميبيا'),
(56524, 3262478123, 3262478123, 'CY', 'CYP', 'قبرص'),
(56525, 3262478124, 3262478124, 'DE', 'DEU', 'ألمانيا'),
(56526, 3262478125, 3262478125, 'PT', 'PRT', 'البورتوغال'),
(56527, 3262478126, 3262478126, 'CY', 'CYP', 'قبرص'),
(56528, 3262478127, 3262478127, 'GR', 'GRC', 'اليونان'),
(56529, 3262478128, 3262478128, 'CH', 'CHE', 'سويسرا'),
(56530, 3262478129, 3262478129, 'HU', 'HUN', 'هنغاريا'),
(56531, 3262478130, 3262478130, 'FR', 'FRA', 'فرنسا'),
(56532, 3262478131, 3262478131, 'SK', 'SVK', 'سلوفاكيا'),
(56533, 3262478132, 3262478132, 'ES', 'ESP', 'إسبانيا'),
(56534, 3262478133, 3262478133, 'TR', 'TUR', 'تركيا'),
(56535, 3262478134, 3262478134, 'ES', 'ESP', 'إسبانيا'),
(56536, 3262478135, 3262478135, 'TR', 'TUR', 'تركيا'),
(56537, 3262478136, 3262478137, 'HU', 'HUN', 'هنغاريا'),
(56538, 3262478138, 3262478138, 'TR', 'TUR', 'تركيا'),
(56539, 3262478139, 3262478139, 'MZ', 'MOZ', 'موزامبيق'),
(56540, 3262478140, 3262478140, 'FR', 'FRA', 'فرنسا'),
(56541, 3262478141, 3262478143, 'TR', 'TUR', 'تركيا'),
(56542, 3262478144, 3262478145, 'DE', 'DEU', 'ألمانيا'),
(56543, 3262478146, 3262478146, 'GR', 'GRC', 'اليونان'),
(56544, 3262478147, 3262478147, 'FR', 'FRA', 'فرنسا'),
(56545, 3262478148, 3262478148, 'KZ', 'KAZ', 'كازاخستان'),
(56546, 3262478149, 3262478149, 'UA', 'UKR', 'أوكرانيا'),
(56547, 3262478150, 3262478150, 'SA', 'SAU', 'السعودية'),
(56548, 3262478151, 3262478151, 'DE', 'DEU', 'ألمانيا'),
(56549, 3262478152, 3262478152, 'PL', 'POL', 'بولندا'),
(56550, 3262478153, 3262478153, 'TR', 'TUR', 'تركيا'),
(56551, 3262478154, 3262478154, 'FR', 'FRA', 'فرنسا'),
(56552, 3262478155, 3262478155, 'CU', 'CUB', 'كوبا'),
(56553, 3262478156, 3262478156, 'TR', 'TUR', 'تركيا'),
(56554, 3262478157, 3262478157, 'DE', 'DEU', 'ألمانيا'),
(56555, 3262478158, 3262478158, 'IT', 'ITA', 'إيطاليا'),
(56556, 3262478159, 3262478159, 'IL', 'ISR', 'إسرائيل'),
(56557, 3262478160, 3262478160, 'TR', 'TUR', 'تركيا'),
(56558, 3262478161, 3262478161, 'ZW', 'ZWE', 'زمبابواي'),
(56559, 3262478162, 3262478162, 'SA', 'SAU', 'السعودية'),
(56560, 3262478163, 3262478163, 'FR', 'FRA', 'فرنسا'),
(56561, 3262478164, 3262478164, 'ZW', 'ZWE', 'زمبابواي'),
(56562, 3262478165, 3262478165, 'SK', 'SVK', 'سلوفاكيا'),
(56563, 3262478166, 3262478166, 'TR', 'TUR', 'تركيا'),
(56564, 3262478167, 3262478167, 'KZ', 'KAZ', 'كازاخستان'),
(56565, 3262478168, 3262478168, 'ES', 'ESP', 'إسبانيا'),
(56566, 3262478169, 3262478169, 'PL', 'POL', 'بولندا'),
(56567, 3262478170, 3262478171, 'FR', 'FRA', 'فرنسا'),
(56568, 3262478172, 3262478172, 'GR', 'GRC', 'اليونان'),
(56569, 3262478173, 3262478174, 'TR', 'TUR', 'تركيا'),
(56570, 3262478175, 3262478175, 'DE', 'DEU', 'ألمانيا'),
(56571, 3262478176, 3262478176, 'TR', 'TUR', 'تركيا'),
(56572, 3262478177, 3262478177, 'DE', 'DEU', 'ألمانيا'),
(56573, 3262478178, 3262478178, 'MZ', 'MOZ', 'موزامبيق'),
(56574, 3262478179, 3262478180, 'TR', 'TUR', 'تركيا'),
(56575, 3262478181, 3262478181, 'CN', 'CHN', 'الصين'),
(56576, 3262478182, 3262478182, 'ES', 'ESP', 'إسبانيا'),
(56577, 3262478183, 3262478183, 'PL', 'POL', 'بولندا'),
(56578, 3262478184, 3262478184, 'MZ', 'MOZ', 'موزامبيق'),
(56579, 3262478185, 3262478185, 'PL', 'POL', 'بولندا'),
(56580, 3262478186, 3262478186, 'ES', 'ESP', 'إسبانيا'),
(56581, 3262478187, 3262478187, 'PT', 'PRT', 'البورتوغال'),
(56582, 3262478188, 3262478188, 'TR', 'TUR', 'تركيا'),
(56583, 3262478189, 3262478189, 'NA', 'NAM', 'ناميبيا'),
(56584, 3262478190, 3262478190, 'DE', 'DEU', 'ألمانيا'),
(56585, 3262478191, 3262478192, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56586, 3262478193, 3262478194, 'NA', 'NAM', 'ناميبيا'),
(56587, 3262478195, 3262478207, 'DE', 'DEU', 'ألمانيا'),
(56588, 3262478208, 3262478211, 'ES', 'ESP', 'إسبانيا'),
(56589, 3262478212, 3262478215, 'NL', 'NLD', 'هولندا'),
(56590, 3262478216, 3262478219, 'FR', 'FRA', 'فرنسا'),
(56591, 3262478220, 3262478223, 'SE', 'SWE', 'السويد'),
(56592, 3262478224, 3262478227, 'GB', 'GBR', 'المملكة المتحدة'),
(56593, 3262478228, 3262478231, 'ES', 'ESP', 'إسبانيا'),
(56594, 3262478232, 3262478235, 'FR', 'FRA', 'فرنسا'),
(56595, 3262478236, 3262478239, 'IT', 'ITA', 'إيطاليا'),
(56596, 3262478240, 3262478243, 'FR', 'FRA', 'فرنسا'),
(56597, 3262478244, 3262478247, 'DE', 'DEU', 'ألمانيا'),
(56598, 3262478248, 3262478251, 'IT', 'ITA', 'إيطاليا'),
(56599, 3262478252, 3262478255, 'CH', 'CHE', 'سويسرا'),
(56600, 3262478256, 3262478259, 'ES', 'ESP', 'إسبانيا'),
(56601, 3262478260, 3262478263, 'DE', 'DEU', 'ألمانيا'),
(56602, 3262478264, 3262478267, 'IT', 'ITA', 'إيطاليا'),
(56603, 3262478268, 3262478271, 'ES', 'ESP', 'إسبانيا'),
(56604, 3262478272, 3262478275, 'CH', 'CHE', 'سويسرا'),
(56605, 3262478276, 3262478299, 'DE', 'DEU', 'ألمانيا'),
(56606, 3262478300, 3262478303, 'ES', 'ESP', 'إسبانيا'),
(56607, 3262478304, 3262478307, 'PT', 'PRT', 'البورتوغال'),
(56608, 3262478308, 3262478311, 'ES', 'ESP', 'إسبانيا'),
(56609, 3262478312, 3262478319, 'DE', 'DEU', 'ألمانيا'),
(56610, 3262478320, 3262478323, 'GB', 'GBR', 'المملكة المتحدة'),
(56611, 3262478324, 3262478327, 'BE', 'BEL', 'بلجيكا'),
(56612, 3262478328, 3262478331, 'ES', 'ESP', 'إسبانيا'),
(56613, 3262478332, 3262478335, 'GB', 'GBR', 'المملكة المتحدة'),
(56614, 3262478336, 3262478337, 'DE', 'DEU', 'ألمانيا'),
(56615, 3262478338, 3262478338, 'PL', 'POL', 'بولندا'),
(56616, 3262478339, 3262478343, 'DE', 'DEU', 'ألمانيا'),
(56617, 3262478344, 3262478344, 'IT', 'ITA', 'إيطاليا'),
(56618, 3262478345, 3262478345, 'CH', 'CHE', 'سويسرا'),
(56619, 3262478346, 3262478346, 'PT', 'PRT', 'البورتوغال'),
(56620, 3262478347, 3262478347, 'AO', 'AGO', 'أنغولا'),
(56621, 3262478348, 3262478348, 'DK', 'DNK', 'الدنيمارك'),
(56622, 3262478349, 3262478349, 'BE', 'BEL', 'بلجيكا'),
(56623, 3262478350, 3262478350, 'AT', 'AUT', 'النمسا'),
(56624, 3262478351, 3262478351, 'TR', 'TUR', 'تركيا'),
(56625, 3262478352, 3262478352, 'CH', 'CHE', 'سويسرا'),
(56626, 3262478353, 3262478353, 'DK', 'DNK', 'الدنيمارك'),
(56627, 3262478354, 3262478354, 'FR', 'FRA', 'فرنسا'),
(56628, 3262478355, 3262478355, 'DE', 'DEU', 'ألمانيا'),
(56629, 3262478356, 3262478356, 'FR', 'FRA', 'فرنسا'),
(56630, 3262478357, 3262478358, 'DE', 'DEU', 'ألمانيا'),
(56631, 3262478359, 3262478360, 'FR', 'FRA', 'فرنسا'),
(56632, 3262478361, 3262478361, 'DE', 'DEU', 'ألمانيا'),
(56633, 3262478362, 3262478362, 'FR', 'FRA', 'فرنسا'),
(56634, 3262478363, 3262478363, 'CH', 'CHE', 'سويسرا'),
(56635, 3262478364, 3262478364, 'PT', 'PRT', 'البورتوغال'),
(56636, 3262478365, 3262478366, 'DE', 'DEU', 'ألمانيا'),
(56637, 3262478367, 3262478367, 'HU', 'HUN', 'هنغاريا'),
(56638, 3262478368, 3262478368, 'DE', 'DEU', 'ألمانيا'),
(56639, 3262478369, 3262478369, 'NO', 'NOR', 'النرويج'),
(56640, 3262478370, 3262478370, 'CH', 'CHE', 'سويسرا'),
(56641, 3262478371, 3262478371, 'DE', 'DEU', 'ألمانيا'),
(56642, 3262478372, 3262478373, 'CH', 'CHE', 'سويسرا'),
(56643, 3262478374, 3262478374, 'PT', 'PRT', 'البورتوغال'),
(56644, 3262478375, 3262478376, 'FR', 'FRA', 'فرنسا'),
(56645, 3262478377, 3262478377, 'DE', 'DEU', 'ألمانيا'),
(56646, 3262478378, 3262478378, 'CH', 'CHE', 'سويسرا'),
(56647, 3262478379, 3262478379, 'DE', 'DEU', 'ألمانيا'),
(56648, 3262478380, 3262478381, 'FR', 'FRA', 'فرنسا'),
(56649, 3262478382, 3262478382, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(56650, 3262478383, 3262478383, 'DE', 'DEU', 'ألمانيا'),
(56651, 3262478384, 3262478384, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(56652, 3262478385, 3262478385, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56653, 3262478386, 3262478386, 'DE', 'DEU', 'ألمانيا'),
(56654, 3262478387, 3262478387, 'IT', 'ITA', 'إيطاليا'),
(56655, 3262478388, 3262478388, 'GR', 'GRC', 'اليونان'),
(56656, 3262478389, 3262478389, 'CH', 'CHE', 'سويسرا'),
(56657, 3262478390, 3262478390, 'ES', 'ESP', 'إسبانيا'),
(56658, 3262478391, 3262478391, 'HU', 'HUN', 'هنغاريا'),
(56659, 3262478392, 3262478393, 'DE', 'DEU', 'ألمانيا'),
(56660, 3262478394, 3262478394, 'IT', 'ITA', 'إيطاليا'),
(56661, 3262478395, 3262478396, 'DE', 'DEU', 'ألمانيا'),
(56662, 3262478397, 3262478397, 'PT', 'PRT', 'البورتوغال'),
(56663, 3262478398, 3262478398, 'HU', 'HUN', 'هنغاريا'),
(56664, 3262478399, 3262478399, 'DE', 'DEU', 'ألمانيا'),
(56665, 3262478400, 3262478400, 'GB', 'GBR', 'المملكة المتحدة'),
(56666, 3262478401, 3262478401, 'DE', 'DEU', 'ألمانيا'),
(56667, 3262478402, 3262478402, 'IT', 'ITA', 'إيطاليا'),
(56668, 3262478403, 3262478403, 'CZ', 'CZE', 'التشيك'),
(56669, 3262478404, 3262478404, 'FI', 'FIN', 'فنلندا'),
(56670, 3262478405, 3262478406, 'GB', 'GBR', 'المملكة المتحدة'),
(56671, 3262478407, 3262478412, 'DE', 'DEU', 'ألمانيا'),
(56672, 3262478413, 3262478413, 'ES', 'ESP', 'إسبانيا'),
(56673, 3262478414, 3262478414, 'PL', 'POL', 'بولندا'),
(56674, 3262478415, 3262478415, 'SE', 'SWE', 'السويد'),
(56675, 3262478416, 3262478416, 'SA', 'SAU', 'السعودية'),
(56676, 3262478417, 3262478417, 'DE', 'DEU', 'ألمانيا'),
(56677, 3262478418, 3262478418, 'AT', 'AUT', 'النمسا'),
(56678, 3262478419, 3262478419, 'FR', 'FRA', 'فرنسا'),
(56679, 3262478420, 3262478421, 'DE', 'DEU', 'ألمانيا'),
(56680, 3262478422, 3262478422, 'CH', 'CHE', 'سويسرا'),
(56681, 3262478423, 3262478423, 'SA', 'SAU', 'السعودية'),
(56682, 3262478424, 3262478424, 'FR', 'FRA', 'فرنسا'),
(56683, 3262478425, 3262478425, 'IT', 'ITA', 'إيطاليا'),
(56684, 3262478426, 3262478426, 'NO', 'NOR', 'النرويج'),
(56685, 3262478427, 3262478428, 'FR', 'FRA', 'فرنسا'),
(56686, 3262478429, 3262478429, 'PT', 'PRT', 'البورتوغال'),
(56687, 3262478430, 3262478430, 'CH', 'CHE', 'سويسرا'),
(56688, 3262478431, 3262478431, 'HU', 'HUN', 'هنغاريا'),
(56689, 3262478432, 3262478432, 'RE', 'REU', 'ريونيون'),
(56690, 3262478433, 3262478433, 'AT', 'AUT', 'النمسا'),
(56691, 3262478434, 3262478434, 'PT', 'PRT', 'البورتوغال'),
(56692, 3262478435, 3262478435, 'IT', 'ITA', 'إيطاليا'),
(56693, 3262478436, 3262478437, 'DE', 'DEU', 'ألمانيا'),
(56694, 3262478438, 3262478438, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56695, 3262478439, 3262478439, 'DE', 'DEU', 'ألمانيا'),
(56696, 3262478440, 3262478440, 'SE', 'SWE', 'السويد'),
(56697, 3262478441, 3262478441, 'FR', 'FRA', 'فرنسا'),
(56698, 3262478442, 3262478442, 'IT', 'ITA', 'إيطاليا'),
(56699, 3262478443, 3262478443, 'DE', 'DEU', 'ألمانيا'),
(56700, 3262478444, 3262478444, 'AT', 'AUT', 'النمسا'),
(56701, 3262478445, 3262478445, 'PT', 'PRT', 'البورتوغال'),
(56702, 3262478446, 3262478447, 'DE', 'DEU', 'ألمانيا'),
(56703, 3262478448, 3262478448, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56704, 3262478449, 3262478449, 'DE', 'DEU', 'ألمانيا'),
(56705, 3262478450, 3262478450, 'TR', 'TUR', 'تركيا'),
(56706, 3262478451, 3262478451, 'FR', 'FRA', 'فرنسا'),
(56707, 3262478452, 3262478452, 'IL', 'ISR', 'إسرائيل'),
(56708, 3262478453, 3262478453, 'DE', 'DEU', 'ألمانيا'),
(56709, 3262478454, 3262478454, 'SE', 'SWE', 'السويد'),
(56710, 3262478455, 3262478455, 'IT', 'ITA', 'إيطاليا'),
(56711, 3262478456, 3262478456, 'DE', 'DEU', 'ألمانيا'),
(56712, 3262478457, 3262478457, 'GB', 'GBR', 'المملكة المتحدة'),
(56713, 3262478458, 3262478458, 'HU', 'HUN', 'هنغاريا'),
(56714, 3262478459, 3262478459, 'ES', 'ESP', 'إسبانيا'),
(56715, 3262478460, 3262478460, 'CY', 'CYP', 'قبرص'),
(56716, 3262478461, 3262478465, 'DE', 'DEU', 'ألمانيا'),
(56717, 3262478466, 3262478466, 'FR', 'FRA', 'فرنسا'),
(56718, 3262478467, 3262478467, 'HU', 'HUN', 'هنغاريا'),
(56719, 3262478468, 3262478468, 'DE', 'DEU', 'ألمانيا'),
(56720, 3262478469, 3262478469, 'FR', 'FRA', 'فرنسا'),
(56721, 3262478470, 3262478470, 'DE', 'DEU', 'ألمانيا'),
(56722, 3262478471, 3262478471, 'ES', 'ESP', 'إسبانيا'),
(56723, 3262478472, 3262478472, 'DE', 'DEU', 'ألمانيا'),
(56724, 3262478473, 3262478473, 'FR', 'FRA', 'فرنسا'),
(56725, 3262478474, 3262478474, 'HU', 'HUN', 'هنغاريا'),
(56726, 3262478475, 3262478476, 'DE', 'DEU', 'ألمانيا'),
(56727, 3262478477, 3262478478, 'CH', 'CHE', 'سويسرا'),
(56728, 3262478479, 3262478479, 'DK', 'DNK', 'الدنيمارك'),
(56729, 3262478480, 3262478480, 'DE', 'DEU', 'ألمانيا'),
(56730, 3262478481, 3262478481, 'DK', 'DNK', 'الدنيمارك'),
(56731, 3262478482, 3262478482, 'IT', 'ITA', 'إيطاليا'),
(56732, 3262478483, 3262478483, 'FR', 'FRA', 'فرنسا'),
(56733, 3262478484, 3262478484, 'DE', 'DEU', 'ألمانيا'),
(56734, 3262478485, 3262478485, 'CH', 'CHE', 'سويسرا'),
(56735, 3262478486, 3262478487, 'FR', 'FRA', 'فرنسا'),
(56736, 3262478488, 3262478488, 'HU', 'HUN', 'هنغاريا'),
(56737, 3262478489, 3262478489, 'HR', 'HRV', 'كرواتيا'),
(56738, 3262478490, 3262478490, 'SE', 'SWE', 'السويد'),
(56739, 3262478491, 3262478491, 'DE', 'DEU', 'ألمانيا'),
(56740, 3262478492, 3262478492, 'CH', 'CHE', 'سويسرا'),
(56741, 3262478493, 3262478493, 'DE', 'DEU', 'ألمانيا'),
(56742, 3262478494, 3262478494, 'FR', 'FRA', 'فرنسا'),
(56743, 3262478495, 3262478495, 'DE', 'DEU', 'ألمانيا'),
(56744, 3262478496, 3262478496, 'PT', 'PRT', 'البورتوغال'),
(56745, 3262478497, 3262478500, 'DE', 'DEU', 'ألمانيا'),
(56746, 3262478501, 3262478501, 'CH', 'CHE', 'سويسرا'),
(56747, 3262478502, 3262478502, 'SE', 'SWE', 'السويد'),
(56748, 3262478503, 3262478503, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(56749, 3262478504, 3262478504, 'FR', 'FRA', 'فرنسا'),
(56750, 3262478505, 3262478505, 'IT', 'ITA', 'إيطاليا'),
(56751, 3262478506, 3262478506, 'PT', 'PRT', 'البورتوغال'),
(56752, 3262478507, 3262478507, 'IT', 'ITA', 'إيطاليا'),
(56753, 3262478508, 3262478508, 'PT', 'PRT', 'البورتوغال'),
(56754, 3262478509, 3262478509, 'NL', 'NLD', 'هولندا'),
(56755, 3262478510, 3262478513, 'DE', 'DEU', 'ألمانيا'),
(56756, 3262478514, 3262478514, 'SE', 'SWE', 'السويد'),
(56757, 3262478515, 3262478515, 'PT', 'PRT', 'البورتوغال'),
(56758, 3262478516, 3262478516, 'ES', 'ESP', 'إسبانيا'),
(56759, 3262478517, 3262478519, 'DE', 'DEU', 'ألمانيا'),
(56760, 3262478520, 3262478520, 'CH', 'CHE', 'سويسرا'),
(56761, 3262478521, 3262478521, 'NL', 'NLD', 'هولندا'),
(56762, 3262478522, 3262478522, 'QA', 'QAT', 'قطر'),
(56763, 3262478523, 3262478523, 'FR', 'FRA', 'فرنسا'),
(56764, 3262478524, 3262478524, 'ES', 'ESP', 'إسبانيا'),
(56765, 3262478525, 3262478526, 'DE', 'DEU', 'ألمانيا'),
(56766, 3262478527, 3262478527, 'ES', 'ESP', 'إسبانيا'),
(56767, 3262478528, 3262478528, 'NL', 'NLD', 'هولندا'),
(56768, 3262478529, 3262478529, 'ES', 'ESP', 'إسبانيا'),
(56769, 3262478530, 3262478530, 'DE', 'DEU', 'ألمانيا'),
(56770, 3262478531, 3262478531, 'FR', 'FRA', 'فرنسا'),
(56771, 3262478532, 3262478536, 'DE', 'DEU', 'ألمانيا'),
(56772, 3262478537, 3262478537, 'HU', 'HUN', 'هنغاريا'),
(56773, 3262478538, 3262478538, 'DE', 'DEU', 'ألمانيا'),
(56774, 3262478539, 3262478539, 'FI', 'FIN', 'فنلندا'),
(56775, 3262478540, 3262478540, 'HU', 'HUN', 'هنغاريا'),
(56776, 3262478541, 3262478542, 'DE', 'DEU', 'ألمانيا'),
(56777, 3262478543, 3262478543, 'AT', 'AUT', 'النمسا'),
(56778, 3262478544, 3262478544, 'NL', 'NLD', 'هولندا'),
(56779, 3262478545, 3262478546, 'DE', 'DEU', 'ألمانيا'),
(56780, 3262478547, 3262478547, 'FR', 'FRA', 'فرنسا'),
(56781, 3262478548, 3262478548, 'ES', 'ESP', 'إسبانيا'),
(56782, 3262478549, 3262478549, 'FR', 'FRA', 'فرنسا'),
(56783, 3262478550, 3262478550, 'DE', 'DEU', 'ألمانيا'),
(56784, 3262478551, 3262478551, 'PL', 'POL', 'بولندا'),
(56785, 3262478552, 3262478552, 'HU', 'HUN', 'هنغاريا'),
(56786, 3262478553, 3262478553, 'PL', 'POL', 'بولندا'),
(56787, 3262478554, 3262478554, 'SE', 'SWE', 'السويد'),
(56788, 3262478555, 3262478555, 'DE', 'DEU', 'ألمانيا'),
(56789, 3262478556, 3262478556, 'GB', 'GBR', 'المملكة المتحدة'),
(56790, 3262478557, 3262478557, 'DE', 'DEU', 'ألمانيا'),
(56791, 3262478558, 3262478558, 'IT', 'ITA', 'إيطاليا'),
(56792, 3262478559, 3262478560, 'DE', 'DEU', 'ألمانيا'),
(56793, 3262478561, 3262478562, 'FR', 'FRA', 'فرنسا'),
(56794, 3262478563, 3262478563, 'DK', 'DNK', 'الدنيمارك'),
(56795, 3262478564, 3262478564, 'RU', 'RUS', 'الإتحاد الروسي'),
(56796, 3262478565, 3262478566, 'FR', 'FRA', 'فرنسا'),
(56797, 3262478567, 3262478567, 'HU', 'HUN', 'هنغاريا'),
(56798, 3262478568, 3262478568, 'DE', 'DEU', 'ألمانيا'),
(56799, 3262478569, 3262478569, 'TR', 'TUR', 'تركيا'),
(56800, 3262478570, 3262478570, 'FR', 'FRA', 'فرنسا'),
(56801, 3262478571, 3262478594, 'DE', 'DEU', 'ألمانيا'),
(56802, 3262478595, 3262478595, 'CH', 'CHE', 'سويسرا'),
(56803, 3262478596, 3262478596, 'PT', 'PRT', 'البورتوغال'),
(56804, 3262478597, 3262478597, 'SE', 'SWE', 'السويد'),
(56805, 3262478598, 3262478599, 'DE', 'DEU', 'ألمانيا'),
(56806, 3262478600, 3262478600, 'IT', 'ITA', 'إيطاليا'),
(56807, 3262478601, 3262478601, 'KW', 'KWT', 'الكويت'),
(56808, 3262478602, 3262478602, 'FR', 'FRA', 'فرنسا'),
(56809, 3262478603, 3262478604, 'DE', 'DEU', 'ألمانيا'),
(56810, 3262478605, 3262478605, 'ES', 'ESP', 'إسبانيا'),
(56811, 3262478606, 3262478606, 'FI', 'FIN', 'فنلندا'),
(56812, 3262478607, 3262478607, 'GR', 'GRC', 'اليونان'),
(56813, 3262478608, 3262478608, 'DE', 'DEU', 'ألمانيا'),
(56814, 3262478609, 3262478609, 'IT', 'ITA', 'إيطاليا'),
(56815, 3262478610, 3262478610, 'ES', 'ESP', 'إسبانيا'),
(56816, 3262478611, 3262478611, 'HU', 'HUN', 'هنغاريا'),
(56817, 3262478612, 3262478620, 'DE', 'DEU', 'ألمانيا'),
(56818, 3262478621, 3262478621, 'SE', 'SWE', 'السويد'),
(56819, 3262478622, 3262478622, 'TR', 'TUR', 'تركيا'),
(56820, 3262478623, 3262478623, 'ES', 'ESP', 'إسبانيا'),
(56821, 3262478624, 3262478624, 'FR', 'FRA', 'فرنسا'),
(56822, 3262478625, 3262478625, 'DE', 'DEU', 'ألمانيا'),
(56823, 3262478626, 3262478626, 'HU', 'HUN', 'هنغاريا'),
(56824, 3262478627, 3262478627, 'DE', 'DEU', 'ألمانيا'),
(56825, 3262478628, 3262478628, 'HU', 'HUN', 'هنغاريا'),
(56826, 3262478629, 3262478629, 'DE', 'DEU', 'ألمانيا'),
(56827, 3262478630, 3262478630, 'FR', 'FRA', 'فرنسا'),
(56828, 3262478631, 3262478631, 'PL', 'POL', 'بولندا'),
(56829, 3262478632, 3262478632, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(56830, 3262478633, 3262478633, 'AT', 'AUT', 'النمسا'),
(56831, 3262478634, 3262478634, 'ES', 'ESP', 'إسبانيا'),
(56832, 3262478635, 3262478635, 'SA', 'SAU', 'السعودية'),
(56833, 3262478636, 3262478636, 'CH', 'CHE', 'سويسرا'),
(56834, 3262478637, 3262478637, 'GB', 'GBR', 'المملكة المتحدة'),
(56835, 3262478638, 3262478639, 'DE', 'DEU', 'ألمانيا'),
(56836, 3262478640, 3262478640, 'PT', 'PRT', 'البورتوغال'),
(56837, 3262478641, 3262478641, 'DE', 'DEU', 'ألمانيا'),
(56838, 3262478642, 3262478642, 'CH', 'CHE', 'سويسرا'),
(56839, 3262478643, 3262478643, 'DE', 'DEU', 'ألمانيا'),
(56840, 3262478644, 3262478644, 'ES', 'ESP', 'إسبانيا'),
(56841, 3262478645, 3262478645, 'DE', 'DEU', 'ألمانيا'),
(56842, 3262478646, 3262478646, 'AT', 'AUT', 'النمسا'),
(56843, 3262478647, 3262478647, 'FR', 'FRA', 'فرنسا'),
(56844, 3262478648, 3262478648, 'PT', 'PRT', 'البورتوغال'),
(56845, 3262478649, 3262478649, 'CZ', 'CZE', 'التشيك'),
(56846, 3262478650, 3262478650, 'ES', 'ESP', 'إسبانيا'),
(56847, 3262478651, 3262478651, 'FR', 'FRA', 'فرنسا'),
(56848, 3262478652, 3262478653, 'ES', 'ESP', 'إسبانيا'),
(56849, 3262478654, 3262478655, 'DE', 'DEU', 'ألمانيا'),
(56850, 3262478656, 3262478656, 'PL', 'POL', 'بولندا'),
(56851, 3262478657, 3262478657, 'DE', 'DEU', 'ألمانيا'),
(56852, 3262478658, 3262478658, 'ES', 'ESP', 'إسبانيا'),
(56853, 3262478659, 3262478659, 'DE', 'DEU', 'ألمانيا'),
(56854, 3262478660, 3262478660, 'SK', 'SVK', 'سلوفاكيا'),
(56855, 3262478661, 3262478661, 'BE', 'BEL', 'بلجيكا'),
(56856, 3262478662, 3262478662, 'TR', 'TUR', 'تركيا'),
(56857, 3262478663, 3262478663, 'AT', 'AUT', 'النمسا'),
(56858, 3262478664, 3262478664, 'ES', 'ESP', 'إسبانيا'),
(56859, 3262478665, 3262478665, 'DK', 'DNK', 'الدنيمارك'),
(56860, 3262478666, 3262478666, 'AT', 'AUT', 'النمسا'),
(56861, 3262478667, 3262478667, 'DE', 'DEU', 'ألمانيا'),
(56862, 3262478668, 3262478668, 'IT', 'ITA', 'إيطاليا'),
(56863, 3262478669, 3262478670, 'DE', 'DEU', 'ألمانيا'),
(56864, 3262478671, 3262478671, 'FR', 'FRA', 'فرنسا'),
(56865, 3262478672, 3262478673, 'DE', 'DEU', 'ألمانيا'),
(56866, 3262478674, 3262478674, 'SK', 'SVK', 'سلوفاكيا'),
(56867, 3262478675, 3262478675, 'PL', 'POL', 'بولندا'),
(56868, 3262478676, 3262478676, 'CH', 'CHE', 'سويسرا'),
(56869, 3262478677, 3262478677, 'HU', 'HUN', 'هنغاريا'),
(56870, 3262478678, 3262478678, 'IT', 'ITA', 'إيطاليا'),
(56871, 3262478679, 3262478679, 'FR', 'FRA', 'فرنسا'),
(56872, 3262478680, 3262478680, 'GB', 'GBR', 'المملكة المتحدة'),
(56873, 3262478681, 3262478681, 'ES', 'ESP', 'إسبانيا'),
(56874, 3262478682, 3262478682, 'CH', 'CHE', 'سويسرا'),
(56875, 3262478683, 3262478683, 'IT', 'ITA', 'إيطاليا'),
(56876, 3262478684, 3262478684, 'BE', 'BEL', 'بلجيكا'),
(56877, 3262478685, 3262478685, 'DE', 'DEU', 'ألمانيا'),
(56878, 3262478686, 3262478686, 'FR', 'FRA', 'فرنسا'),
(56879, 3262478687, 3262478687, 'ES', 'ESP', 'إسبانيا'),
(56880, 3262478688, 3262478688, 'TR', 'TUR', 'تركيا'),
(56881, 3262478689, 3262478689, 'GB', 'GBR', 'المملكة المتحدة'),
(56882, 3262478690, 3262478690, 'AT', 'AUT', 'النمسا'),
(56883, 3262478691, 3262478691, 'CH', 'CHE', 'سويسرا'),
(56884, 3262478692, 3262478692, 'PL', 'POL', 'بولندا'),
(56885, 3262478693, 3262478693, 'TR', 'TUR', 'تركيا'),
(56886, 3262478694, 3262478694, 'CH', 'CHE', 'سويسرا'),
(56887, 3262478695, 3262478695, 'DE', 'DEU', 'ألمانيا'),
(56888, 3262478696, 3262478696, 'LI', 'LIE', 'ليختنشتاين'),
(56889, 3262478697, 3262478697, 'ES', 'ESP', 'إسبانيا'),
(56890, 3262478698, 3262478698, 'IT', 'ITA', 'إيطاليا'),
(56891, 3262478699, 3262478699, 'ES', 'ESP', 'إسبانيا'),
(56892, 3262478700, 3262478700, 'IT', 'ITA', 'إيطاليا'),
(56893, 3262478701, 3262478701, 'DE', 'DEU', 'ألمانيا'),
(56894, 3262478702, 3262478702, 'CH', 'CHE', 'سويسرا'),
(56895, 3262478703, 3262478703, 'FR', 'FRA', 'فرنسا'),
(56896, 3262478704, 3262478704, 'IT', 'ITA', 'إيطاليا'),
(56897, 3262478705, 3262478706, 'PT', 'PRT', 'البورتوغال'),
(56898, 3262478707, 3262478707, 'ES', 'ESP', 'إسبانيا'),
(56899, 3262478708, 3262478721, 'DE', 'DEU', 'ألمانيا'),
(56900, 3262478722, 3262478722, 'FR', 'FRA', 'فرنسا'),
(56901, 3262478723, 3262478724, 'DE', 'DEU', 'ألمانيا'),
(56902, 3262478725, 3262478725, 'IT', 'ITA', 'إيطاليا'),
(56903, 3262478726, 3262478726, 'FR', 'FRA', 'فرنسا'),
(56904, 3262478727, 3262478727, 'AT', 'AUT', 'النمسا'),
(56905, 3262478728, 3262478728, 'NL', 'NLD', 'هولندا'),
(56906, 3262478729, 3262478729, 'SK', 'SVK', 'سلوفاكيا'),
(56907, 3262478730, 3262478730, 'IT', 'ITA', 'إيطاليا'),
(56908, 3262478731, 3262478731, 'PT', 'PRT', 'البورتوغال'),
(56909, 3262478732, 3262478732, 'PL', 'POL', 'بولندا'),
(56910, 3262478733, 3262478733, 'SK', 'SVK', 'سلوفاكيا'),
(56911, 3262478734, 3262478735, 'DE', 'DEU', 'ألمانيا'),
(56912, 3262478736, 3262478736, 'HU', 'HUN', 'هنغاريا'),
(56913, 3262478737, 3262478737, 'ES', 'ESP', 'إسبانيا'),
(56914, 3262478738, 3262478738, 'SK', 'SVK', 'سلوفاكيا'),
(56915, 3262478739, 3262478739, 'SE', 'SWE', 'السويد'),
(56916, 3262478740, 3262478740, 'FR', 'FRA', 'فرنسا'),
(56917, 3262478741, 3262478741, 'DK', 'DNK', 'الدنيمارك'),
(56918, 3262478742, 3262478742, 'CH', 'CHE', 'سويسرا'),
(56919, 3262478743, 3262478743, 'FR', 'FRA', 'فرنسا'),
(56920, 3262478744, 3262478744, 'GR', 'GRC', 'اليونان'),
(56921, 3262478745, 3262478745, 'IT', 'ITA', 'إيطاليا'),
(56922, 3262478746, 3262478746, 'SE', 'SWE', 'السويد'),
(56923, 3262478747, 3262478747, 'FR', 'FRA', 'فرنسا'),
(56924, 3262478748, 3262478748, 'DE', 'DEU', 'ألمانيا'),
(56925, 3262478749, 3262478751, 'FR', 'FRA', 'فرنسا'),
(56926, 3262478752, 3262478752, 'PT', 'PRT', 'البورتوغال'),
(56927, 3262478753, 3262478753, 'IE', 'IRL', 'إيرلندا'),
(56928, 3262478754, 3262478754, 'ES', 'ESP', 'إسبانيا'),
(56929, 3262478755, 3262478755, 'DK', 'DNK', 'الدنيمارك'),
(56930, 3262478756, 3262478756, 'FR', 'FRA', 'فرنسا'),
(56931, 3262478757, 3262478757, 'AT', 'AUT', 'النمسا'),
(56932, 3262478758, 3262478758, 'FR', 'FRA', 'فرنسا'),
(56933, 3262478759, 3262478759, 'CH', 'CHE', 'سويسرا'),
(56934, 3262478760, 3262478760, 'TR', 'TUR', 'تركيا'),
(56935, 3262478761, 3262478761, 'HU', 'HUN', 'هنغاريا'),
(56936, 3262478762, 3262478762, 'CY', 'CYP', 'قبرص'),
(56937, 3262478763, 3262478763, 'ES', 'ESP', 'إسبانيا'),
(56938, 3262478764, 3262478764, 'DE', 'DEU', 'ألمانيا'),
(56939, 3262478765, 3262478766, 'ES', 'ESP', 'إسبانيا'),
(56940, 3262478767, 3262478767, 'PT', 'PRT', 'البورتوغال'),
(56941, 3262478768, 3262478768, 'PL', 'POL', 'بولندا'),
(56942, 3262478769, 3262478769, 'ES', 'ESP', 'إسبانيا'),
(56943, 3262478770, 3262478770, 'IT', 'ITA', 'إيطاليا'),
(56944, 3262478771, 3262478771, 'SK', 'SVK', 'سلوفاكيا'),
(56945, 3262478772, 3262478772, 'FR', 'FRA', 'فرنسا'),
(56946, 3262478773, 3262478773, 'CZ', 'CZE', 'التشيك'),
(56947, 3262478774, 3262478774, 'DE', 'DEU', 'ألمانيا'),
(56948, 3262478775, 3262478775, 'CH', 'CHE', 'سويسرا'),
(56949, 3262478776, 3262478776, 'ES', 'ESP', 'إسبانيا'),
(56950, 3262478777, 3262478778, 'IT', 'ITA', 'إيطاليا'),
(56951, 3262478779, 3262478779, 'ES', 'ESP', 'إسبانيا'),
(56952, 3262478780, 3262478780, 'PT', 'PRT', 'البورتوغال'),
(56953, 3262478781, 3262478781, 'PL', 'POL', 'بولندا'),
(56954, 3262478782, 3262478782, 'MA', 'MAR', 'المغرب'),
(56955, 3262478783, 3262478783, 'ES', 'ESP', 'إسبانيا'),
(56956, 3262478784, 3262478785, 'TR', 'TUR', 'تركيا'),
(56957, 3262478786, 3262478786, 'DE', 'DEU', 'ألمانيا'),
(56958, 3262478787, 3262478787, 'PT', 'PRT', 'البورتوغال'),
(56959, 3262478788, 3262478788, 'NO', 'NOR', 'النرويج'),
(56960, 3262478789, 3262478789, 'GR', 'GRC', 'اليونان'),
(56961, 3262478790, 3262478790, 'DE', 'DEU', 'ألمانيا'),
(56962, 3262478791, 3262478791, 'GB', 'GBR', 'المملكة المتحدة'),
(56963, 3262478792, 3262478792, 'PT', 'PRT', 'البورتوغال'),
(56964, 3262478793, 3262478793, 'FR', 'FRA', 'فرنسا'),
(56965, 3262478794, 3262478794, 'PT', 'PRT', 'البورتوغال'),
(56966, 3262478795, 3262478795, 'PL', 'POL', 'بولندا'),
(56967, 3262478796, 3262478796, 'HU', 'HUN', 'هنغاريا'),
(56968, 3262478797, 3262478797, 'CY', 'CYP', 'قبرص'),
(56969, 3262478798, 3262478798, 'IT', 'ITA', 'إيطاليا'),
(56970, 3262478799, 3262478799, 'HU', 'HUN', 'هنغاريا'),
(56971, 3262478800, 3262478800, 'PL', 'POL', 'بولندا'),
(56972, 3262478801, 3262478801, 'DE', 'DEU', 'ألمانيا'),
(56973, 3262478802, 3262478802, 'IT', 'ITA', 'إيطاليا'),
(56974, 3262478803, 3262478803, 'ES', 'ESP', 'إسبانيا'),
(56975, 3262478804, 3262478804, 'SK', 'SVK', 'سلوفاكيا'),
(56976, 3262478805, 3262478806, 'GR', 'GRC', 'اليونان'),
(56977, 3262478807, 3262478807, 'CH', 'CHE', 'سويسرا'),
(56978, 3262478808, 3262478808, 'HU', 'HUN', 'هنغاريا'),
(56979, 3262478809, 3262478809, 'TR', 'TUR', 'تركيا'),
(56980, 3262478810, 3262478810, 'CH', 'CHE', 'سويسرا'),
(56981, 3262478811, 3262478811, 'FR', 'FRA', 'فرنسا'),
(56982, 3262478812, 3262478812, 'PL', 'POL', 'بولندا'),
(56983, 3262478813, 3262478813, 'LB', 'LBN', 'لبنان'),
(56984, 3262478814, 3262478851, 'DE', 'DEU', 'ألمانيا'),
(56985, 3262478852, 3262478853, 'CH', 'CHE', 'سويسرا'),
(56986, 3262478854, 3262478855, 'DE', 'DEU', 'ألمانيا'),
(56987, 3262478856, 3262478856, 'FR', 'FRA', 'فرنسا'),
(56988, 3262478857, 3262478857, 'LI', 'LIE', 'ليختنشتاين'),
(56989, 3262478858, 3262478860, 'DE', 'DEU', 'ألمانيا'),
(56990, 3262478861, 3262478861, 'FR', 'FRA', 'فرنسا'),
(56991, 3262478862, 3262478862, 'DE', 'DEU', 'ألمانيا'),
(56992, 3262478863, 3262478863, 'AT', 'AUT', 'النمسا'),
(56993, 3262478864, 3262478864, 'NL', 'NLD', 'هولندا'),
(56994, 3262478865, 3262478865, 'DE', 'DEU', 'ألمانيا'),
(56995, 3262478866, 3262478866, 'CH', 'CHE', 'سويسرا'),
(56996, 3262478867, 3262478867, 'GB', 'GBR', 'المملكة المتحدة'),
(56997, 3262478868, 3262478868, 'IT', 'ITA', 'إيطاليا'),
(56998, 3262478869, 3262478870, 'FR', 'FRA', 'فرنسا'),
(56999, 3262478871, 3262478872, 'DE', 'DEU', 'ألمانيا'),
(57000, 3262478873, 3262478873, 'NL', 'NLD', 'هولندا'),
(57001, 3262478874, 3262478874, 'AT', 'AUT', 'النمسا'),
(57002, 3262478875, 3262478875, 'DE', 'DEU', 'ألمانيا'),
(57003, 3262478876, 3262478876, 'GB', 'GBR', 'المملكة المتحدة'),
(57004, 3262478877, 3262478877, 'DE', 'DEU', 'ألمانيا'),
(57005, 3262478878, 3262478878, 'AT', 'AUT', 'النمسا'),
(57006, 3262478879, 3262478881, 'DE', 'DEU', 'ألمانيا'),
(57007, 3262478882, 3262478882, 'GR', 'GRC', 'اليونان'),
(57008, 3262478883, 3262478886, 'DE', 'DEU', 'ألمانيا'),
(57009, 3262478887, 3262478887, 'NL', 'NLD', 'هولندا'),
(57010, 3262478888, 3262478888, 'DK', 'DNK', 'الدنيمارك'),
(57011, 3262478889, 3262478890, 'FR', 'FRA', 'فرنسا'),
(57012, 3262478891, 3262478893, 'DE', 'DEU', 'ألمانيا'),
(57013, 3262478894, 3262478894, 'AT', 'AUT', 'النمسا'),
(57014, 3262478895, 3262478895, 'DE', 'DEU', 'ألمانيا'),
(57015, 3262478896, 3262478896, 'NL', 'NLD', 'هولندا'),
(57016, 3262478897, 3262478897, 'FR', 'FRA', 'فرنسا'),
(57017, 3262478898, 3262478898, 'GB', 'GBR', 'المملكة المتحدة'),
(57018, 3262478899, 3262478899, 'SE', 'SWE', 'السويد'),
(57019, 3262478900, 3262478900, 'GB', 'GBR', 'المملكة المتحدة'),
(57020, 3262478901, 3262478901, 'DE', 'DEU', 'ألمانيا'),
(57021, 3262478902, 3262478902, 'IT', 'ITA', 'إيطاليا'),
(57022, 3262478903, 3262478904, 'DE', 'DEU', 'ألمانيا'),
(57023, 3262478905, 3262478905, 'SE', 'SWE', 'السويد'),
(57024, 3262478906, 3262478909, 'DE', 'DEU', 'ألمانيا'),
(57025, 3262478910, 3262478910, 'DK', 'DNK', 'الدنيمارك'),
(57026, 3262478911, 3262478911, 'BH', 'BHR', 'البحرين'),
(57027, 3262478912, 3262478912, 'NL', 'NLD', 'هولندا'),
(57028, 3262478913, 3262478913, 'FR', 'FRA', 'فرنسا'),
(57029, 3262478914, 3262478914, 'DE', 'DEU', 'ألمانيا'),
(57030, 3262478915, 3262478915, 'NL', 'NLD', 'هولندا'),
(57031, 3262478916, 3262478919, 'DE', 'DEU', 'ألمانيا'),
(57032, 3262478920, 3262478920, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(57033, 3262478921, 3262478921, 'AT', 'AUT', 'النمسا'),
(57034, 3262478922, 3262478924, 'DE', 'DEU', 'ألمانيا'),
(57035, 3262478925, 3262478925, 'NL', 'NLD', 'هولندا'),
(57036, 3262478926, 3262478926, 'AT', 'AUT', 'النمسا'),
(57037, 3262478927, 3262478927, 'PT', 'PRT', 'البورتوغال'),
(57038, 3262478928, 3262478928, 'DK', 'DNK', 'الدنيمارك'),
(57039, 3262478929, 3262478929, 'GB', 'GBR', 'المملكة المتحدة'),
(57040, 3262478930, 3262478931, 'DE', 'DEU', 'ألمانيا'),
(57041, 3262478932, 3262478932, 'CH', 'CHE', 'سويسرا'),
(57042, 3262478933, 3262478935, 'DE', 'DEU', 'ألمانيا'),
(57043, 3262478936, 3262478937, 'CH', 'CHE', 'سويسرا'),
(57044, 3262478938, 3262478938, 'NL', 'NLD', 'هولندا'),
(57045, 3262478939, 3262478939, 'GB', 'GBR', 'المملكة المتحدة'),
(57046, 3262478940, 3262478940, 'NL', 'NLD', 'هولندا'),
(57047, 3262478941, 3262478941, 'DE', 'DEU', 'ألمانيا'),
(57048, 3262478942, 3262478942, 'BE', 'BEL', 'بلجيكا'),
(57049, 3262478943, 3262478943, 'SI', 'SVN', 'سلوفينيا'),
(57050, 3262478944, 3262478945, 'DE', 'DEU', 'ألمانيا'),
(57051, 3262478946, 3262478946, 'IE', 'IRL', 'إيرلندا'),
(57052, 3262478947, 3262478947, 'DE', 'DEU', 'ألمانيا'),
(57053, 3262478948, 3262478948, 'IT', 'ITA', 'إيطاليا'),
(57054, 3262478949, 3262478949, 'SE', 'SWE', 'السويد'),
(57055, 3262478950, 3262478952, 'DE', 'DEU', 'ألمانيا'),
(57056, 3262478953, 3262478953, 'AT', 'AUT', 'النمسا'),
(57057, 3262478954, 3262478954, 'DE', 'DEU', 'ألمانيا'),
(57058, 3262478955, 3262478955, 'FR', 'FRA', 'فرنسا'),
(57059, 3262478956, 3262478956, 'DE', 'DEU', 'ألمانيا'),
(57060, 3262478957, 3262478957, 'PT', 'PRT', 'البورتوغال'),
(57061, 3262478958, 3262478958, 'SE', 'SWE', 'السويد'),
(57062, 3262478959, 3262478961, 'NL', 'NLD', 'هولندا'),
(57063, 3262478962, 3262478963, 'DE', 'DEU', 'ألمانيا'),
(57064, 3262478964, 3262478964, 'CH', 'CHE', 'سويسرا'),
(57065, 3262478965, 3262478966, 'DE', 'DEU', 'ألمانيا'),
(57066, 3262478967, 3262478967, 'NL', 'NLD', 'هولندا'),
(57067, 3262478968, 3262478968, 'ES', 'ESP', 'إسبانيا'),
(57068, 3262478969, 3262478969, 'DE', 'DEU', 'ألمانيا'),
(57069, 3262478970, 3262478970, 'BE', 'BEL', 'بلجيكا'),
(57070, 3262478971, 3262478971, 'DE', 'DEU', 'ألمانيا'),
(57071, 3262478972, 3262478972, 'NO', 'NOR', 'النرويج'),
(57072, 3262478973, 3262478973, 'CH', 'CHE', 'سويسرا'),
(57073, 3262478974, 3262478974, 'GB', 'GBR', 'المملكة المتحدة'),
(57074, 3262478975, 3262478980, 'DE', 'DEU', 'ألمانيا'),
(57075, 3262478981, 3262478981, 'IT', 'ITA', 'إيطاليا'),
(57076, 3262478982, 3262478982, 'DE', 'DEU', 'ألمانيا'),
(57077, 3262478983, 3262478983, 'NL', 'NLD', 'هولندا'),
(57078, 3262478984, 3262478984, 'CH', 'CHE', 'سويسرا'),
(57079, 3262478985, 3262478985, 'PT', 'PRT', 'البورتوغال'),
(57080, 3262478986, 3262478986, 'NL', 'NLD', 'هولندا'),
(57081, 3262478987, 3262478987, 'GB', 'GBR', 'المملكة المتحدة'),
(57082, 3262478988, 3262478988, 'IE', 'IRL', 'إيرلندا'),
(57083, 3262478989, 3262478989, 'NL', 'NLD', 'هولندا'),
(57084, 3262478990, 3262478990, 'DE', 'DEU', 'ألمانيا'),
(57085, 3262478991, 3262478992, 'FR', 'FRA', 'فرنسا'),
(57086, 3262478993, 3262478993, 'NL', 'NLD', 'هولندا'),
(57087, 3262478994, 3262478997, 'DE', 'DEU', 'ألمانيا'),
(57088, 3262478998, 3262478998, 'GB', 'GBR', 'المملكة المتحدة'),
(57089, 3262478999, 3262478999, 'AT', 'AUT', 'النمسا'),
(57090, 3262479000, 3262479000, 'CH', 'CHE', 'سويسرا'),
(57091, 3262479001, 3262479001, 'AT', 'AUT', 'النمسا'),
(57092, 3262479002, 3262479002, 'DE', 'DEU', 'ألمانيا'),
(57093, 3262479003, 3262479003, 'FR', 'FRA', 'فرنسا'),
(57094, 3262479004, 3262479007, 'DE', 'DEU', 'ألمانيا'),
(57095, 3262479008, 3262479008, 'NL', 'NLD', 'هولندا'),
(57096, 3262479009, 3262479009, 'NO', 'NOR', 'النرويج'),
(57097, 3262479010, 3262479011, 'NL', 'NLD', 'هولندا'),
(57098, 3262479012, 3262479012, 'DE', 'DEU', 'ألمانيا'),
(57099, 3262479013, 3262479013, 'NL', 'NLD', 'هولندا'),
(57100, 3262479014, 3262479014, 'ES', 'ESP', 'إسبانيا'),
(57101, 3262479015, 3262479015, 'CH', 'CHE', 'سويسرا'),
(57102, 3262479016, 3262479016, 'SE', 'SWE', 'السويد'),
(57103, 3262479017, 3262479017, 'DK', 'DNK', 'الدنيمارك'),
(57104, 3262479018, 3262479018, 'IT', 'ITA', 'إيطاليا'),
(57105, 3262479019, 3262479019, 'DE', 'DEU', 'ألمانيا'),
(57106, 3262479020, 3262479022, 'CH', 'CHE', 'سويسرا'),
(57107, 3262479023, 3262479024, 'DE', 'DEU', 'ألمانيا'),
(57108, 3262479025, 3262479025, 'NL', 'NLD', 'هولندا'),
(57109, 3262479026, 3262479027, 'DE', 'DEU', 'ألمانيا'),
(57110, 3262479028, 3262479028, 'CH', 'CHE', 'سويسرا'),
(57111, 3262479029, 3262479029, 'DE', 'DEU', 'ألمانيا'),
(57112, 3262479030, 3262479030, 'ES', 'ESP', 'إسبانيا'),
(57113, 3262479031, 3262479031, 'AT', 'AUT', 'النمسا'),
(57114, 3262479032, 3262479036, 'DE', 'DEU', 'ألمانيا'),
(57115, 3262479037, 3262479037, 'AT', 'AUT', 'النمسا'),
(57116, 3262479038, 3262479038, 'DK', 'DNK', 'الدنيمارك'),
(57117, 3262479039, 3262479039, 'DE', 'DEU', 'ألمانيا'),
(57118, 3262479040, 3262479040, 'NL', 'NLD', 'هولندا'),
(57119, 3262479041, 3262479041, 'CH', 'CHE', 'سويسرا'),
(57120, 3262479042, 3262479042, 'DK', 'DNK', 'الدنيمارك'),
(57121, 3262479043, 3262479043, 'FR', 'FRA', 'فرنسا'),
(57122, 3262479044, 3262479044, 'DE', 'DEU', 'ألمانيا'),
(57123, 3262479045, 3262479045, 'IT', 'ITA', 'إيطاليا'),
(57124, 3262479046, 3262479046, 'DE', 'DEU', 'ألمانيا'),
(57125, 3262479047, 3262479047, 'AT', 'AUT', 'النمسا'),
(57126, 3262479048, 3262479048, 'NL', 'NLD', 'هولندا'),
(57127, 3262479049, 3262479050, 'DE', 'DEU', 'ألمانيا'),
(57128, 3262479051, 3262479051, 'GB', 'GBR', 'المملكة المتحدة'),
(57129, 3262479052, 3262479052, 'DE', 'DEU', 'ألمانيا'),
(57130, 3262479053, 3262479053, 'NL', 'NLD', 'هولندا'),
(57131, 3262479054, 3262479056, 'DE', 'DEU', 'ألمانيا'),
(57132, 3262479057, 3262479057, 'GB', 'GBR', 'المملكة المتحدة'),
(57133, 3262479058, 3262479058, 'FR', 'FRA', 'فرنسا'),
(57134, 3262479059, 3262479059, 'IT', 'ITA', 'إيطاليا'),
(57135, 3262479060, 3262479062, 'DE', 'DEU', 'ألمانيا'),
(57136, 3262479063, 3262479063, 'CH', 'CHE', 'سويسرا'),
(57137, 3262479064, 3262479065, 'FR', 'FRA', 'فرنسا'),
(57138, 3262479066, 3262479066, 'IT', 'ITA', 'إيطاليا'),
(57139, 3262479067, 3262479067, 'DE', 'DEU', 'ألمانيا'),
(57140, 3262479068, 3262479068, 'ES', 'ESP', 'إسبانيا'),
(57141, 3262479069, 3262479069, 'FR', 'FRA', 'فرنسا'),
(57142, 3262479070, 3262479070, 'ES', 'ESP', 'إسبانيا'),
(57143, 3262479071, 3262479074, 'DE', 'DEU', 'ألمانيا'),
(57144, 3262479075, 3262479075, 'CH', 'CHE', 'سويسرا'),
(57145, 3262479076, 3262479076, 'BE', 'BEL', 'بلجيكا'),
(57146, 3262479077, 3262479077, 'DE', 'DEU', 'ألمانيا'),
(57147, 3262479078, 3262479078, 'IT', 'ITA', 'إيطاليا'),
(57148, 3262479079, 3262479079, 'ES', 'ESP', 'إسبانيا'),
(57149, 3262479080, 3262479080, 'LU', 'LUX', 'لوكسيمبورغ'),
(57150, 3262479081, 3262479081, 'CH', 'CHE', 'سويسرا'),
(57151, 3262479082, 3262479082, 'IT', 'ITA', 'إيطاليا'),
(57152, 3262479083, 3262479083, 'NL', 'NLD', 'هولندا'),
(57153, 3262479084, 3262479084, 'CH', 'CHE', 'سويسرا'),
(57154, 3262479085, 3262479085, 'IT', 'ITA', 'إيطاليا'),
(57155, 3262479086, 3262479086, 'FR', 'FRA', 'فرنسا'),
(57156, 3262479087, 3262479088, 'DE', 'DEU', 'ألمانيا'),
(57157, 3262479089, 3262479089, 'CH', 'CHE', 'سويسرا'),
(57158, 3262479090, 3262479090, 'FR', 'FRA', 'فرنسا'),
(57159, 3262479091, 3262479091, 'DE', 'DEU', 'ألمانيا'),
(57160, 3262479092, 3262479092, 'IT', 'ITA', 'إيطاليا'),
(57161, 3262479093, 3262479093, 'FR', 'FRA', 'فرنسا'),
(57162, 3262479094, 3262479095, 'GB', 'GBR', 'المملكة المتحدة'),
(57163, 3262479096, 3262479096, 'ES', 'ESP', 'إسبانيا'),
(57164, 3262479097, 3262479097, 'FR', 'FRA', 'فرنسا'),
(57165, 3262479098, 3262479098, 'IT', 'ITA', 'إيطاليا'),
(57166, 3262479099, 3262479099, 'DE', 'DEU', 'ألمانيا'),
(57167, 3262479100, 3262479100, 'DK', 'DNK', 'الدنيمارك'),
(57168, 3262479101, 3262479101, 'CH', 'CHE', 'سويسرا'),
(57169, 3262479102, 3262479102, 'IT', 'ITA', 'إيطاليا'),
(57170, 3262479103, 3262479105, 'DE', 'DEU', 'ألمانيا'),
(57171, 3262479106, 3262479106, 'ES', 'ESP', 'إسبانيا'),
(57172, 3262479107, 3262479107, 'IT', 'ITA', 'إيطاليا'),
(57173, 3262479108, 3262479108, 'AT', 'AUT', 'النمسا'),
(57174, 3262479109, 3262479109, 'FR', 'FRA', 'فرنسا'),
(57175, 3262479110, 3262479110, 'DE', 'DEU', 'ألمانيا'),
(57176, 3262479111, 3262479111, 'LU', 'LUX', 'لوكسيمبورغ'),
(57177, 3262479112, 3262479115, 'DE', 'DEU', 'ألمانيا'),
(57178, 3262479116, 3262479116, 'IT', 'ITA', 'إيطاليا'),
(57179, 3262479117, 3262479117, 'CH', 'CHE', 'سويسرا'),
(57180, 3262479118, 3262479118, 'GR', 'GRC', 'اليونان'),
(57181, 3262479119, 3262479120, 'DE', 'DEU', 'ألمانيا'),
(57182, 3262479121, 3262479121, 'ES', 'ESP', 'إسبانيا'),
(57183, 3262479122, 3262479122, 'FR', 'FRA', 'فرنسا'),
(57184, 3262479123, 3262479123, 'DE', 'DEU', 'ألمانيا'),
(57185, 3262479124, 3262479124, 'FR', 'FRA', 'فرنسا'),
(57186, 3262479125, 3262479125, 'IL', 'ISR', 'إسرائيل'),
(57187, 3262479126, 3262479130, 'DE', 'DEU', 'ألمانيا'),
(57188, 3262479131, 3262479131, 'NL', 'NLD', 'هولندا'),
(57189, 3262479132, 3262479132, 'AT', 'AUT', 'النمسا'),
(57190, 3262479133, 3262479133, 'NL', 'NLD', 'هولندا'),
(57191, 3262479134, 3262479134, 'ES', 'ESP', 'إسبانيا'),
(57192, 3262479135, 3262479139, 'DE', 'DEU', 'ألمانيا'),
(57193, 3262479140, 3262479140, 'NL', 'NLD', 'هولندا'),
(57194, 3262479141, 3262479142, 'DE', 'DEU', 'ألمانيا'),
(57195, 3262479143, 3262479143, 'GB', 'GBR', 'المملكة المتحدة'),
(57196, 3262479144, 3262479144, 'CH', 'CHE', 'سويسرا'),
(57197, 3262479145, 3262479145, 'NO', 'NOR', 'النرويج'),
(57198, 3262479146, 3262479146, 'DE', 'DEU', 'ألمانيا'),
(57199, 3262479147, 3262479147, 'IT', 'ITA', 'إيطاليا'),
(57200, 3262479148, 3262479149, 'ES', 'ESP', 'إسبانيا'),
(57201, 3262479150, 3262479151, 'DE', 'DEU', 'ألمانيا'),
(57202, 3262479152, 3262479152, 'NL', 'NLD', 'هولندا'),
(57203, 3262479153, 3262479153, 'DE', 'DEU', 'ألمانيا'),
(57204, 3262479154, 3262479154, 'FR', 'FRA', 'فرنسا'),
(57205, 3262479155, 3262479155, 'NL', 'NLD', 'هولندا'),
(57206, 3262479156, 3262479156, 'DE', 'DEU', 'ألمانيا'),
(57207, 3262479157, 3262479157, 'ES', 'ESP', 'إسبانيا'),
(57208, 3262479158, 3262479158, 'DE', 'DEU', 'ألمانيا'),
(57209, 3262479159, 3262479159, 'FR', 'FRA', 'فرنسا'),
(57210, 3262479160, 3262479160, 'DE', 'DEU', 'ألمانيا'),
(57211, 3262479161, 3262479161, 'FR', 'FRA', 'فرنسا'),
(57212, 3262479162, 3262479162, 'DE', 'DEU', 'ألمانيا'),
(57213, 3262479163, 3262479163, 'FR', 'FRA', 'فرنسا'),
(57214, 3262479164, 3262479164, 'DE', 'DEU', 'ألمانيا'),
(57215, 3262479165, 3262479167, 'CH', 'CHE', 'سويسرا'),
(57216, 3262479168, 3262479168, 'DE', 'DEU', 'ألمانيا'),
(57217, 3262479169, 3262479169, 'IT', 'ITA', 'إيطاليا'),
(57218, 3262479170, 3262479170, 'CH', 'CHE', 'سويسرا'),
(57219, 3262479171, 3262479171, 'ES', 'ESP', 'إسبانيا'),
(57220, 3262479172, 3262479174, 'DE', 'DEU', 'ألمانيا'),
(57221, 3262479175, 3262479175, 'FR', 'FRA', 'فرنسا'),
(57222, 3262479176, 3262479178, 'DE', 'DEU', 'ألمانيا'),
(57223, 3262479179, 3262479179, 'AT', 'AUT', 'النمسا'),
(57224, 3262479180, 3262479180, 'NL', 'NLD', 'هولندا'),
(57225, 3262479181, 3262479181, 'DE', 'DEU', 'ألمانيا'),
(57226, 3262479182, 3262479182, 'LU', 'LUX', 'لوكسيمبورغ'),
(57227, 3262479183, 3262479183, 'DK', 'DNK', 'الدنيمارك'),
(57228, 3262479184, 3262479184, 'CH', 'CHE', 'سويسرا'),
(57229, 3262479185, 3262479185, 'IT', 'ITA', 'إيطاليا'),
(57230, 3262479186, 3262479186, 'ES', 'ESP', 'إسبانيا'),
(57231, 3262479187, 3262479187, 'DE', 'DEU', 'ألمانيا'),
(57232, 3262479188, 3262479188, 'CH', 'CHE', 'سويسرا'),
(57233, 3262479189, 3262479189, 'ES', 'ESP', 'إسبانيا'),
(57234, 3262479190, 3262479191, 'IT', 'ITA', 'إيطاليا'),
(57235, 3262479192, 3262479192, 'FR', 'FRA', 'فرنسا'),
(57236, 3262479193, 3262479193, 'GB', 'GBR', 'المملكة المتحدة'),
(57237, 3262479194, 3262479194, 'DE', 'DEU', 'ألمانيا'),
(57238, 3262479195, 3262479195, 'BE', 'BEL', 'بلجيكا'),
(57239, 3262479196, 3262479196, 'DE', 'DEU', 'ألمانيا'),
(57240, 3262479197, 3262479197, 'GB', 'GBR', 'المملكة المتحدة'),
(57241, 3262479198, 3262479199, 'DE', 'DEU', 'ألمانيا'),
(57242, 3262479200, 3262479200, 'NL', 'NLD', 'هولندا'),
(57243, 3262479201, 3262479201, 'HU', 'HUN', 'هنغاريا'),
(57244, 3262479202, 3262479202, 'FR', 'FRA', 'فرنسا'),
(57245, 3262479203, 3262479208, 'DE', 'DEU', 'ألمانيا'),
(57246, 3262479209, 3262479209, 'ES', 'ESP', 'إسبانيا'),
(57247, 3262479210, 3262479212, 'DE', 'DEU', 'ألمانيا'),
(57248, 3262479213, 3262479213, 'NO', 'NOR', 'النرويج'),
(57249, 3262479214, 3262479214, 'DE', 'DEU', 'ألمانيا'),
(57250, 3262479215, 3262479215, 'IT', 'ITA', 'إيطاليا'),
(57251, 3262479216, 3262479219, 'DE', 'DEU', 'ألمانيا'),
(57252, 3262479220, 3262479220, 'NL', 'NLD', 'هولندا'),
(57253, 3262479221, 3262479223, 'DE', 'DEU', 'ألمانيا'),
(57254, 3262479224, 3262479224, 'BE', 'BEL', 'بلجيكا'),
(57255, 3262479225, 3262479225, 'FR', 'FRA', 'فرنسا'),
(57256, 3262479226, 3262479226, 'DE', 'DEU', 'ألمانيا'),
(57257, 3262479227, 3262479227, 'NL', 'NLD', 'هولندا'),
(57258, 3262479228, 3262479228, 'DK', 'DNK', 'الدنيمارك'),
(57259, 3262479229, 3262479233, 'DE', 'DEU', 'ألمانيا'),
(57260, 3262479234, 3262479234, 'GB', 'GBR', 'المملكة المتحدة'),
(57261, 3262479235, 3262479236, 'DE', 'DEU', 'ألمانيا'),
(57262, 3262479237, 3262479238, 'NL', 'NLD', 'هولندا'),
(57263, 3262479239, 3262479239, 'FR', 'FRA', 'فرنسا'),
(57264, 3262479240, 3262479240, 'DE', 'DEU', 'ألمانيا'),
(57265, 3262479241, 3262479242, 'FR', 'FRA', 'فرنسا'),
(57266, 3262479243, 3262479243, 'NL', 'NLD', 'هولندا'),
(57267, 3262479244, 3262479244, 'IT', 'ITA', 'إيطاليا'),
(57268, 3262479245, 3262479249, 'DE', 'DEU', 'ألمانيا'),
(57269, 3262479250, 3262479250, 'AT', 'AUT', 'النمسا'),
(57270, 3262479251, 3262479252, 'DE', 'DEU', 'ألمانيا'),
(57271, 3262479253, 3262479253, 'NL', 'NLD', 'هولندا'),
(57272, 3262479254, 3262479254, 'FR', 'FRA', 'فرنسا'),
(57273, 3262479255, 3262479255, 'DE', 'DEU', 'ألمانيا'),
(57274, 3262479256, 3262479256, 'IT', 'ITA', 'إيطاليا'),
(57275, 3262479257, 3262479257, 'US', 'USA', 'الولايات المتحدة'),
(57276, 3262479258, 3262479261, 'DE', 'DEU', 'ألمانيا'),
(57277, 3262479262, 3262479262, 'CH', 'CHE', 'سويسرا'),
(57278, 3262479263, 3262479264, 'DE', 'DEU', 'ألمانيا'),
(57279, 3262479265, 3262479265, 'CH', 'CHE', 'سويسرا'),
(57280, 3262479266, 3262479266, 'FR', 'FRA', 'فرنسا'),
(57281, 3262479267, 3262479267, 'DE', 'DEU', 'ألمانيا'),
(57282, 3262479268, 3262479268, 'NL', 'NLD', 'هولندا'),
(57283, 3262479269, 3262479269, 'DE', 'DEU', 'ألمانيا'),
(57284, 3262479270, 3262479271, 'DK', 'DNK', 'الدنيمارك'),
(57285, 3262479272, 3262479272, 'IT', 'ITA', 'إيطاليا'),
(57286, 3262479273, 3262479273, 'DE', 'DEU', 'ألمانيا'),
(57287, 3262479274, 3262479274, 'ES', 'ESP', 'إسبانيا'),
(57288, 3262479275, 3262479275, 'IT', 'ITA', 'إيطاليا'),
(57289, 3262479276, 3262479276, 'DE', 'DEU', 'ألمانيا'),
(57290, 3262479277, 3262479277, 'NL', 'NLD', 'هولندا'),
(57291, 3262479278, 3262479278, 'DE', 'DEU', 'ألمانيا'),
(57292, 3262479279, 3262479279, 'ES', 'ESP', 'إسبانيا'),
(57293, 3262479280, 3262479280, 'DE', 'DEU', 'ألمانيا'),
(57294, 3262479281, 3262479281, 'FR', 'FRA', 'فرنسا'),
(57295, 3262479282, 3262479282, 'AD', 'AND', 'أندورا'),
(57296, 3262479283, 3262479283, 'IT', 'ITA', 'إيطاليا'),
(57297, 3262479284, 3262479284, 'NO', 'NOR', 'النرويج'),
(57298, 3262479285, 3262479289, 'DE', 'DEU', 'ألمانيا'),
(57299, 3262479290, 3262479290, 'BE', 'BEL', 'بلجيكا'),
(57300, 3262479291, 3262479293, 'DE', 'DEU', 'ألمانيا'),
(57301, 3262479294, 3262479294, 'FR', 'FRA', 'فرنسا'),
(57302, 3262479295, 3262479295, 'DE', 'DEU', 'ألمانيا'),
(57303, 3262479296, 3262479296, 'IT', 'ITA', 'إيطاليا'),
(57304, 3262479297, 3262479298, 'DE', 'DEU', 'ألمانيا'),
(57305, 3262479299, 3262479299, 'ES', 'ESP', 'إسبانيا'),
(57306, 3262479300, 3262479300, 'DE', 'DEU', 'ألمانيا'),
(57307, 3262479301, 3262479301, 'ES', 'ESP', 'إسبانيا'),
(57308, 3262479302, 3262479303, 'DE', 'DEU', 'ألمانيا'),
(57309, 3262479304, 3262479304, 'AT', 'AUT', 'النمسا'),
(57310, 3262479305, 3262479307, 'DE', 'DEU', 'ألمانيا'),
(57311, 3262479308, 3262479308, 'DK', 'DNK', 'الدنيمارك'),
(57312, 3262479309, 3262479309, 'SE', 'SWE', 'السويد'),
(57313, 3262479310, 3262479311, 'DE', 'DEU', 'ألمانيا'),
(57314, 3262479312, 3262479312, 'IT', 'ITA', 'إيطاليا'),
(57315, 3262479313, 3262479313, 'FR', 'FRA', 'فرنسا'),
(57316, 3262479314, 3262479318, 'DE', 'DEU', 'ألمانيا'),
(57317, 3262479319, 3262479319, 'DK', 'DNK', 'الدنيمارك'),
(57318, 3262479320, 3262479320, 'DE', 'DEU', 'ألمانيا'),
(57319, 3262479321, 3262479321, 'GR', 'GRC', 'اليونان'),
(57320, 3262479322, 3262479323, 'CH', 'CHE', 'سويسرا'),
(57321, 3262479324, 3262479324, 'NL', 'NLD', 'هولندا'),
(57322, 3262479325, 3262479325, 'ES', 'ESP', 'إسبانيا'),
(57323, 3262479326, 3262479327, 'DE', 'DEU', 'ألمانيا'),
(57324, 3262479328, 3262479328, 'DK', 'DNK', 'الدنيمارك'),
(57325, 3262479329, 3262479329, 'ES', 'ESP', 'إسبانيا'),
(57326, 3262479330, 3262479330, 'NL', 'NLD', 'هولندا'),
(57327, 3262479331, 3262479332, 'FR', 'FRA', 'فرنسا'),
(57328, 3262479333, 3262479333, 'HU', 'HUN', 'هنغاريا'),
(57329, 3262479334, 3262479334, 'NL', 'NLD', 'هولندا'),
(57330, 3262479335, 3262479335, 'DE', 'DEU', 'ألمانيا'),
(57331, 3262479336, 3262479336, 'FR', 'FRA', 'فرنسا'),
(57332, 3262479337, 3262479337, 'ES', 'ESP', 'إسبانيا'),
(57333, 3262479338, 3262479338, 'DE', 'DEU', 'ألمانيا'),
(57334, 3262479339, 3262479339, 'NL', 'NLD', 'هولندا'),
(57335, 3262479340, 3262479340, 'CH', 'CHE', 'سويسرا'),
(57336, 3262479341, 3262479341, 'DE', 'DEU', 'ألمانيا'),
(57337, 3262479342, 3262479342, 'PT', 'PRT', 'البورتوغال'),
(57338, 3262479343, 3262479343, 'NO', 'NOR', 'النرويج'),
(57339, 3262479344, 3262479344, 'NL', 'NLD', 'هولندا'),
(57340, 3262479345, 3262479345, 'DE', 'DEU', 'ألمانيا'),
(57341, 3262479346, 3262479346, 'DK', 'DNK', 'الدنيمارك'),
(57342, 3262479347, 3262479347, 'NO', 'NOR', 'النرويج'),
(57343, 3262479348, 3262479350, 'IT', 'ITA', 'إيطاليا'),
(57344, 3262479351, 3262479351, 'DE', 'DEU', 'ألمانيا'),
(57345, 3262479352, 3262479352, 'IT', 'ITA', 'إيطاليا'),
(57346, 3262479353, 3262479353, 'CH', 'CHE', 'سويسرا'),
(57347, 3262479354, 3262479355, 'DE', 'DEU', 'ألمانيا'),
(57348, 3262479356, 3262479356, 'CH', 'CHE', 'سويسرا'),
(57349, 3262479357, 3262479357, 'FR', 'FRA', 'فرنسا'),
(57350, 3262479358, 3262479361, 'DE', 'DEU', 'ألمانيا'),
(57351, 3262479362, 3262479362, 'PT', 'PRT', 'البورتوغال'),
(57352, 3262479363, 3262479366, 'DE', 'DEU', 'ألمانيا'),
(57353, 3262479367, 3262479367, 'CH', 'CHE', 'سويسرا'),
(57354, 3262479368, 3262479368, 'DE', 'DEU', 'ألمانيا'),
(57355, 3262479369, 3262479369, 'FR', 'FRA', 'فرنسا'),
(57356, 3262479370, 3262479370, 'CH', 'CHE', 'سويسرا'),
(57357, 3262479371, 3262479371, 'GB', 'GBR', 'المملكة المتحدة'),
(57358, 3262479372, 3262479372, 'DE', 'DEU', 'ألمانيا'),
(57359, 3262479373, 3262479373, 'IT', 'ITA', 'إيطاليا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(57360, 3262479374, 3262479374, 'DE', 'DEU', 'ألمانيا'),
(57361, 3262479375, 3262479375, 'NL', 'NLD', 'هولندا'),
(57362, 3262479376, 3262479377, 'FR', 'FRA', 'فرنسا'),
(57363, 3262479378, 3262479378, 'DE', 'DEU', 'ألمانيا'),
(57364, 3262479379, 3262479379, 'CH', 'CHE', 'سويسرا'),
(57365, 3262479380, 3262479380, 'AT', 'AUT', 'النمسا'),
(57366, 3262479381, 3262479381, 'FR', 'FRA', 'فرنسا'),
(57367, 3262479382, 3262479385, 'DE', 'DEU', 'ألمانيا'),
(57368, 3262479386, 3262479386, 'NL', 'NLD', 'هولندا'),
(57369, 3262479387, 3262479387, 'DK', 'DNK', 'الدنيمارك'),
(57370, 3262479388, 3262479389, 'DE', 'DEU', 'ألمانيا'),
(57371, 3262479390, 3262479390, 'DK', 'DNK', 'الدنيمارك'),
(57372, 3262479391, 3262479391, 'NO', 'NOR', 'النرويج'),
(57373, 3262479392, 3262479393, 'DE', 'DEU', 'ألمانيا'),
(57374, 3262479394, 3262479394, 'FR', 'FRA', 'فرنسا'),
(57375, 3262479395, 3262479395, 'NL', 'NLD', 'هولندا'),
(57376, 3262479396, 3262479396, 'CH', 'CHE', 'سويسرا'),
(57377, 3262479397, 3262479397, 'IT', 'ITA', 'إيطاليا'),
(57378, 3262479398, 3262479399, 'DE', 'DEU', 'ألمانيا'),
(57379, 3262479400, 3262479400, 'NL', 'NLD', 'هولندا'),
(57380, 3262479401, 3262479402, 'DE', 'DEU', 'ألمانيا'),
(57381, 3262479403, 3262479403, 'GB', 'GBR', 'المملكة المتحدة'),
(57382, 3262479404, 3262479404, 'DE', 'DEU', 'ألمانيا'),
(57383, 3262479405, 3262479405, 'IE', 'IRL', 'إيرلندا'),
(57384, 3262479406, 3262479406, 'GB', 'GBR', 'المملكة المتحدة'),
(57385, 3262479407, 3262479410, 'DE', 'DEU', 'ألمانيا'),
(57386, 3262479411, 3262479411, 'ES', 'ESP', 'إسبانيا'),
(57387, 3262479412, 3262479413, 'DE', 'DEU', 'ألمانيا'),
(57388, 3262479414, 3262479414, 'CH', 'CHE', 'سويسرا'),
(57389, 3262479415, 3262479415, 'DE', 'DEU', 'ألمانيا'),
(57390, 3262479416, 3262479416, 'DK', 'DNK', 'الدنيمارك'),
(57391, 3262479417, 3262479419, 'DE', 'DEU', 'ألمانيا'),
(57392, 3262479420, 3262479420, 'ES', 'ESP', 'إسبانيا'),
(57393, 3262479421, 3262479421, 'DE', 'DEU', 'ألمانيا'),
(57394, 3262479422, 3262479422, 'SE', 'SWE', 'السويد'),
(57395, 3262479423, 3262479423, 'AT', 'AUT', 'النمسا'),
(57396, 3262479424, 3262479426, 'DE', 'DEU', 'ألمانيا'),
(57397, 3262479427, 3262479427, 'IT', 'ITA', 'إيطاليا'),
(57398, 3262479428, 3262479429, 'FR', 'FRA', 'فرنسا'),
(57399, 3262479430, 3262479430, 'GB', 'GBR', 'المملكة المتحدة'),
(57400, 3262479431, 3262479432, 'DE', 'DEU', 'ألمانيا'),
(57401, 3262479433, 3262479433, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(57402, 3262479434, 3262479434, 'IT', 'ITA', 'إيطاليا'),
(57403, 3262479435, 3262479437, 'DE', 'DEU', 'ألمانيا'),
(57404, 3262479438, 3262479438, 'IT', 'ITA', 'إيطاليا'),
(57405, 3262479439, 3262479439, 'DE', 'DEU', 'ألمانيا'),
(57406, 3262479440, 3262479440, 'AT', 'AUT', 'النمسا'),
(57407, 3262479441, 3262479441, 'DK', 'DNK', 'الدنيمارك'),
(57408, 3262479442, 3262479442, 'IT', 'ITA', 'إيطاليا'),
(57409, 3262479443, 3262479443, 'GR', 'GRC', 'اليونان'),
(57410, 3262479444, 3262479444, 'ES', 'ESP', 'إسبانيا'),
(57411, 3262479445, 3262479445, 'DE', 'DEU', 'ألمانيا'),
(57412, 3262479446, 3262479446, 'IT', 'ITA', 'إيطاليا'),
(57413, 3262479447, 3262479448, 'DE', 'DEU', 'ألمانيا'),
(57414, 3262479449, 3262479449, 'GB', 'GBR', 'المملكة المتحدة'),
(57415, 3262479450, 3262479452, 'DE', 'DEU', 'ألمانيا'),
(57416, 3262479453, 3262479453, 'CH', 'CHE', 'سويسرا'),
(57417, 3262479454, 3262479455, 'DE', 'DEU', 'ألمانيا'),
(57418, 3262479456, 3262479456, 'IT', 'ITA', 'إيطاليا'),
(57419, 3262479457, 3262479462, 'DE', 'DEU', 'ألمانيا'),
(57420, 3262479463, 3262479463, 'IT', 'ITA', 'إيطاليا'),
(57421, 3262479464, 3262479465, 'NL', 'NLD', 'هولندا'),
(57422, 3262479466, 3262479466, 'GB', 'GBR', 'المملكة المتحدة'),
(57423, 3262479467, 3262479467, 'CH', 'CHE', 'سويسرا'),
(57424, 3262479468, 3262479469, 'DE', 'DEU', 'ألمانيا'),
(57425, 3262479470, 3262479471, 'GB', 'GBR', 'المملكة المتحدة'),
(57426, 3262479472, 3262479472, 'DE', 'DEU', 'ألمانيا'),
(57427, 3262479473, 3262479473, 'CH', 'CHE', 'سويسرا'),
(57428, 3262479474, 3262479474, 'BE', 'BEL', 'بلجيكا'),
(57429, 3262479475, 3262479475, 'CH', 'CHE', 'سويسرا'),
(57430, 3262479476, 3262479476, 'GB', 'GBR', 'المملكة المتحدة'),
(57431, 3262479477, 3262479477, 'BE', 'BEL', 'بلجيكا'),
(57432, 3262479478, 3262479478, 'IT', 'ITA', 'إيطاليا'),
(57433, 3262479479, 3262479480, 'DE', 'DEU', 'ألمانيا'),
(57434, 3262479481, 3262479481, 'LI', 'LIE', 'ليختنشتاين'),
(57435, 3262479482, 3262479482, 'IT', 'ITA', 'إيطاليا'),
(57436, 3262479483, 3262479483, 'DE', 'DEU', 'ألمانيا'),
(57437, 3262479484, 3262479484, 'AT', 'AUT', 'النمسا'),
(57438, 3262479485, 3262479489, 'DE', 'DEU', 'ألمانيا'),
(57439, 3262479490, 3262479490, 'IT', 'ITA', 'إيطاليا'),
(57440, 3262479491, 3262479492, 'DE', 'DEU', 'ألمانيا'),
(57441, 3262479493, 3262479493, 'CH', 'CHE', 'سويسرا'),
(57442, 3262479494, 3262479494, 'DE', 'DEU', 'ألمانيا'),
(57443, 3262479495, 3262479495, 'BE', 'BEL', 'بلجيكا'),
(57444, 3262479496, 3262479498, 'DE', 'DEU', 'ألمانيا'),
(57445, 3262479499, 3262479499, 'ES', 'ESP', 'إسبانيا'),
(57446, 3262479500, 3262479502, 'IT', 'ITA', 'إيطاليا'),
(57447, 3262479503, 3262479503, 'DE', 'DEU', 'ألمانيا'),
(57448, 3262479504, 3262479504, 'GB', 'GBR', 'المملكة المتحدة'),
(57449, 3262479505, 3262479507, 'DE', 'DEU', 'ألمانيا'),
(57450, 3262479508, 3262479508, 'HU', 'HUN', 'هنغاريا'),
(57451, 3262479509, 3262479509, 'FR', 'FRA', 'فرنسا'),
(57452, 3262479510, 3262479513, 'DE', 'DEU', 'ألمانيا'),
(57453, 3262479514, 3262479514, 'FR', 'FRA', 'فرنسا'),
(57454, 3262479515, 3262479515, 'ES', 'ESP', 'إسبانيا'),
(57455, 3262479516, 3262479517, 'DE', 'DEU', 'ألمانيا'),
(57456, 3262479518, 3262479518, 'GB', 'GBR', 'المملكة المتحدة'),
(57457, 3262479519, 3262479519, 'GR', 'GRC', 'اليونان'),
(57458, 3262479520, 3262479521, 'DE', 'DEU', 'ألمانيا'),
(57459, 3262479522, 3262479522, 'CH', 'CHE', 'سويسرا'),
(57460, 3262479523, 3262479526, 'DE', 'DEU', 'ألمانيا'),
(57461, 3262479527, 3262479528, 'NL', 'NLD', 'هولندا'),
(57462, 3262479529, 3262479529, 'DE', 'DEU', 'ألمانيا'),
(57463, 3262479530, 3262479530, 'BE', 'BEL', 'بلجيكا'),
(57464, 3262479531, 3262479535, 'DE', 'DEU', 'ألمانيا'),
(57465, 3262479536, 3262479536, 'GB', 'GBR', 'المملكة المتحدة'),
(57466, 3262479537, 3262479538, 'DE', 'DEU', 'ألمانيا'),
(57467, 3262479539, 3262479539, 'IT', 'ITA', 'إيطاليا'),
(57468, 3262479540, 3262479540, 'DE', 'DEU', 'ألمانيا'),
(57469, 3262479541, 3262479541, 'CH', 'CHE', 'سويسرا'),
(57470, 3262479542, 3262479543, 'DE', 'DEU', 'ألمانيا'),
(57471, 3262479544, 3262479544, 'IT', 'ITA', 'إيطاليا'),
(57472, 3262479545, 3262479545, 'BE', 'BEL', 'بلجيكا'),
(57473, 3262479546, 3262479546, 'GB', 'GBR', 'المملكة المتحدة'),
(57474, 3262479547, 3262479547, 'AT', 'AUT', 'النمسا'),
(57475, 3262479548, 3262479548, 'CH', 'CHE', 'سويسرا'),
(57476, 3262479549, 3262479549, 'IT', 'ITA', 'إيطاليا'),
(57477, 3262479550, 3262479552, 'DE', 'DEU', 'ألمانيا'),
(57478, 3262479553, 3262479553, 'IL', 'ISR', 'إسرائيل'),
(57479, 3262479554, 3262479554, 'DK', 'DNK', 'الدنيمارك'),
(57480, 3262479555, 3262479555, 'FR', 'FRA', 'فرنسا'),
(57481, 3262479556, 3262479556, 'IE', 'IRL', 'إيرلندا'),
(57482, 3262479557, 3262479558, 'DE', 'DEU', 'ألمانيا'),
(57483, 3262479559, 3262479559, 'SE', 'SWE', 'السويد'),
(57484, 3262479560, 3262479560, 'DE', 'DEU', 'ألمانيا'),
(57485, 3262479561, 3262479561, 'BE', 'BEL', 'بلجيكا'),
(57486, 3262479562, 3262479562, 'GB', 'GBR', 'المملكة المتحدة'),
(57487, 3262479563, 3262479563, 'DE', 'DEU', 'ألمانيا'),
(57488, 3262479564, 3262479564, 'GB', 'GBR', 'المملكة المتحدة'),
(57489, 3262479565, 3262479565, 'SE', 'SWE', 'السويد'),
(57490, 3262479566, 3262479566, 'NL', 'NLD', 'هولندا'),
(57491, 3262479567, 3262479567, 'CH', 'CHE', 'سويسرا'),
(57492, 3262479568, 3262479568, 'NO', 'NOR', 'النرويج'),
(57493, 3262479569, 3262479572, 'DE', 'DEU', 'ألمانيا'),
(57494, 3262479573, 3262479573, 'IT', 'ITA', 'إيطاليا'),
(57495, 3262479574, 3262479574, 'CH', 'CHE', 'سويسرا'),
(57496, 3262479575, 3262479575, 'DE', 'DEU', 'ألمانيا'),
(57497, 3262479576, 3262479576, 'NL', 'NLD', 'هولندا'),
(57498, 3262479577, 3262479577, 'FR', 'FRA', 'فرنسا'),
(57499, 3262479578, 3262479578, 'DE', 'DEU', 'ألمانيا'),
(57500, 3262479579, 3262479579, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(57501, 3262479580, 3262479580, 'DE', 'DEU', 'ألمانيا'),
(57502, 3262479581, 3262479581, 'IT', 'ITA', 'إيطاليا'),
(57503, 3262479582, 3262479583, 'DE', 'DEU', 'ألمانيا'),
(57504, 3262479584, 3262479584, 'NL', 'NLD', 'هولندا'),
(57505, 3262479585, 3262479585, 'DE', 'DEU', 'ألمانيا'),
(57506, 3262479586, 3262479586, 'GR', 'GRC', 'اليونان'),
(57507, 3262479587, 3262479588, 'DE', 'DEU', 'ألمانيا'),
(57508, 3262479589, 3262479589, 'IT', 'ITA', 'إيطاليا'),
(57509, 3262479590, 3262479590, 'GB', 'GBR', 'المملكة المتحدة'),
(57510, 3262479591, 3262479591, 'NL', 'NLD', 'هولندا'),
(57511, 3262479592, 3262479592, 'DE', 'DEU', 'ألمانيا'),
(57512, 3262479593, 3262479593, 'FR', 'FRA', 'فرنسا'),
(57513, 3262479594, 3262479594, 'DE', 'DEU', 'ألمانيا'),
(57514, 3262479595, 3262479596, 'FR', 'FRA', 'فرنسا'),
(57515, 3262479597, 3262479598, 'DE', 'DEU', 'ألمانيا'),
(57516, 3262479599, 3262479600, 'IT', 'ITA', 'إيطاليا'),
(57517, 3262479601, 3262479601, 'DE', 'DEU', 'ألمانيا'),
(57518, 3262479602, 3262479602, 'GB', 'GBR', 'المملكة المتحدة'),
(57519, 3262479603, 3262479604, 'DE', 'DEU', 'ألمانيا'),
(57520, 3262479605, 3262479605, 'SE', 'SWE', 'السويد'),
(57521, 3262479606, 3262479606, 'FR', 'FRA', 'فرنسا'),
(57522, 3262479607, 3262479607, 'NL', 'NLD', 'هولندا'),
(57523, 3262479608, 3262479609, 'DE', 'DEU', 'ألمانيا'),
(57524, 3262479610, 3262479610, 'SI', 'SVN', 'سلوفينيا'),
(57525, 3262479611, 3262479611, 'DE', 'DEU', 'ألمانيا'),
(57526, 3262479612, 3262479612, 'ES', 'ESP', 'إسبانيا'),
(57527, 3262479613, 3262479613, 'NL', 'NLD', 'هولندا'),
(57528, 3262479614, 3262479617, 'DE', 'DEU', 'ألمانيا'),
(57529, 3262479618, 3262479618, 'NO', 'NOR', 'النرويج'),
(57530, 3262479619, 3262479619, 'ES', 'ESP', 'إسبانيا'),
(57531, 3262479620, 3262479620, 'GB', 'GBR', 'المملكة المتحدة'),
(57532, 3262479621, 3262479622, 'DE', 'DEU', 'ألمانيا'),
(57533, 3262479623, 3262479623, 'CH', 'CHE', 'سويسرا'),
(57534, 3262479624, 3262479624, 'ES', 'ESP', 'إسبانيا'),
(57535, 3262479625, 3262479625, 'NL', 'NLD', 'هولندا'),
(57536, 3262479626, 3262479626, 'AT', 'AUT', 'النمسا'),
(57537, 3262479627, 3262479628, 'DE', 'DEU', 'ألمانيا'),
(57538, 3262479629, 3262479629, 'SI', 'SVN', 'سلوفينيا'),
(57539, 3262479630, 3262479630, 'NL', 'NLD', 'هولندا'),
(57540, 3262479631, 3262479631, 'HU', 'HUN', 'هنغاريا'),
(57541, 3262479632, 3262479632, 'DE', 'DEU', 'ألمانيا'),
(57542, 3262479633, 3262479633, 'LU', 'LUX', 'لوكسيمبورغ'),
(57543, 3262479634, 3262479634, 'DE', 'DEU', 'ألمانيا'),
(57544, 3262479635, 3262479636, 'GB', 'GBR', 'المملكة المتحدة'),
(57545, 3262479637, 3262479637, 'ES', 'ESP', 'إسبانيا'),
(57546, 3262479638, 3262479638, 'DE', 'DEU', 'ألمانيا'),
(57547, 3262479639, 3262479639, 'AT', 'AUT', 'النمسا'),
(57548, 3262479640, 3262479640, 'FR', 'FRA', 'فرنسا'),
(57549, 3262479641, 3262479641, 'IT', 'ITA', 'إيطاليا'),
(57550, 3262479642, 3262479642, 'GB', 'GBR', 'المملكة المتحدة'),
(57551, 3262479643, 3262479643, 'DE', 'DEU', 'ألمانيا'),
(57552, 3262479644, 3262479644, 'NL', 'NLD', 'هولندا'),
(57553, 3262479645, 3262479645, 'DE', 'DEU', 'ألمانيا'),
(57554, 3262479646, 3262479646, 'GB', 'GBR', 'المملكة المتحدة'),
(57555, 3262479647, 3262479647, 'DE', 'DEU', 'ألمانيا'),
(57556, 3262479648, 3262479648, 'NO', 'NOR', 'النرويج'),
(57557, 3262479649, 3262479653, 'DE', 'DEU', 'ألمانيا'),
(57558, 3262479654, 3262479654, 'ES', 'ESP', 'إسبانيا'),
(57559, 3262479655, 3262479655, 'NL', 'NLD', 'هولندا'),
(57560, 3262479656, 3262479656, 'CH', 'CHE', 'سويسرا'),
(57561, 3262479657, 3262479657, 'NL', 'NLD', 'هولندا'),
(57562, 3262479658, 3262479658, 'DE', 'DEU', 'ألمانيا'),
(57563, 3262479659, 3262479659, 'NL', 'NLD', 'هولندا'),
(57564, 3262479660, 3262479660, 'PT', 'PRT', 'البورتوغال'),
(57565, 3262479661, 3262479662, 'FR', 'FRA', 'فرنسا'),
(57566, 3262479663, 3262479664, 'DE', 'DEU', 'ألمانيا'),
(57567, 3262479665, 3262479665, 'DK', 'DNK', 'الدنيمارك'),
(57568, 3262479666, 3262479667, 'DE', 'DEU', 'ألمانيا'),
(57569, 3262479668, 3262479668, 'NL', 'NLD', 'هولندا'),
(57570, 3262479669, 3262479669, 'IT', 'ITA', 'إيطاليا'),
(57571, 3262479670, 3262479670, 'DK', 'DNK', 'الدنيمارك'),
(57572, 3262479671, 3262479671, 'IT', 'ITA', 'إيطاليا'),
(57573, 3262479672, 3262479673, 'DE', 'DEU', 'ألمانيا'),
(57574, 3262479674, 3262479674, 'BE', 'BEL', 'بلجيكا'),
(57575, 3262479675, 3262479676, 'DE', 'DEU', 'ألمانيا'),
(57576, 3262479677, 3262479677, 'ES', 'ESP', 'إسبانيا'),
(57577, 3262479678, 3262479678, 'IT', 'ITA', 'إيطاليا'),
(57578, 3262479679, 3262479679, 'AT', 'AUT', 'النمسا'),
(57579, 3262479680, 3262479680, 'IT', 'ITA', 'إيطاليا'),
(57580, 3262479681, 3262479681, 'DE', 'DEU', 'ألمانيا'),
(57581, 3262479682, 3262479682, 'IT', 'ITA', 'إيطاليا'),
(57582, 3262479683, 3262479683, 'HU', 'HUN', 'هنغاريا'),
(57583, 3262479684, 3262479685, 'DE', 'DEU', 'ألمانيا'),
(57584, 3262479686, 3262479687, 'FR', 'FRA', 'فرنسا'),
(57585, 3262479688, 3262479688, 'DE', 'DEU', 'ألمانيا'),
(57586, 3262479689, 3262479689, 'NL', 'NLD', 'هولندا'),
(57587, 3262479690, 3262479690, 'LU', 'LUX', 'لوكسيمبورغ'),
(57588, 3262479691, 3262479691, 'DE', 'DEU', 'ألمانيا'),
(57589, 3262479692, 3262479692, 'LU', 'LUX', 'لوكسيمبورغ'),
(57590, 3262479693, 3262479693, 'DE', 'DEU', 'ألمانيا'),
(57591, 3262479694, 3262479694, 'CH', 'CHE', 'سويسرا'),
(57592, 3262479695, 3262479695, 'ES', 'ESP', 'إسبانيا'),
(57593, 3262479696, 3262479696, 'CH', 'CHE', 'سويسرا'),
(57594, 3262479697, 3262479697, 'GB', 'GBR', 'المملكة المتحدة'),
(57595, 3262479698, 3262479698, 'FR', 'FRA', 'فرنسا'),
(57596, 3262479699, 3262479701, 'NL', 'NLD', 'هولندا'),
(57597, 3262479702, 3262479702, 'AT', 'AUT', 'النمسا'),
(57598, 3262479703, 3262479703, 'FR', 'FRA', 'فرنسا'),
(57599, 3262479704, 3262479707, 'DE', 'DEU', 'ألمانيا'),
(57600, 3262479708, 3262479708, 'CH', 'CHE', 'سويسرا'),
(57601, 3262479709, 3262479709, 'NL', 'NLD', 'هولندا'),
(57602, 3262479710, 3262479711, 'DE', 'DEU', 'ألمانيا'),
(57603, 3262479712, 3262479712, 'GB', 'GBR', 'المملكة المتحدة'),
(57604, 3262479713, 3262479713, 'DE', 'DEU', 'ألمانيا'),
(57605, 3262479714, 3262479714, 'AT', 'AUT', 'النمسا'),
(57606, 3262479715, 3262479715, 'ES', 'ESP', 'إسبانيا'),
(57607, 3262479716, 3262479716, 'DE', 'DEU', 'ألمانيا'),
(57608, 3262479717, 3262479717, 'BE', 'BEL', 'بلجيكا'),
(57609, 3262479718, 3262479720, 'DE', 'DEU', 'ألمانيا'),
(57610, 3262479721, 3262479721, 'AT', 'AUT', 'النمسا'),
(57611, 3262479722, 3262479724, 'DE', 'DEU', 'ألمانيا'),
(57612, 3262479725, 3262479725, 'AT', 'AUT', 'النمسا'),
(57613, 3262479726, 3262479727, 'DE', 'DEU', 'ألمانيا'),
(57614, 3262479728, 3262479728, 'BE', 'BEL', 'بلجيكا'),
(57615, 3262479729, 3262479730, 'ES', 'ESP', 'إسبانيا'),
(57616, 3262479731, 3262479731, 'CH', 'CHE', 'سويسرا'),
(57617, 3262479732, 3262479732, 'IT', 'ITA', 'إيطاليا'),
(57618, 3262479733, 3262479734, 'DE', 'DEU', 'ألمانيا'),
(57619, 3262479735, 3262479736, 'CH', 'CHE', 'سويسرا'),
(57620, 3262479737, 3262479737, 'DE', 'DEU', 'ألمانيا'),
(57621, 3262479738, 3262479738, 'AT', 'AUT', 'النمسا'),
(57622, 3262479739, 3262479739, 'DK', 'DNK', 'الدنيمارك'),
(57623, 3262479740, 3262479740, 'DE', 'DEU', 'ألمانيا'),
(57624, 3262479741, 3262479741, 'NL', 'NLD', 'هولندا'),
(57625, 3262479742, 3262479742, 'FR', 'FRA', 'فرنسا'),
(57626, 3262479743, 3262479745, 'DE', 'DEU', 'ألمانيا'),
(57627, 3262479746, 3262479746, 'GB', 'GBR', 'المملكة المتحدة'),
(57628, 3262479747, 3262479747, 'CH', 'CHE', 'سويسرا'),
(57629, 3262479748, 3262479748, 'DE', 'DEU', 'ألمانيا'),
(57630, 3262479749, 3262479749, 'FR', 'FRA', 'فرنسا'),
(57631, 3262479750, 3262479750, 'AT', 'AUT', 'النمسا'),
(57632, 3262479751, 3262479751, 'DE', 'DEU', 'ألمانيا'),
(57633, 3262479752, 3262479752, 'CH', 'CHE', 'سويسرا'),
(57634, 3262479753, 3262479753, 'DE', 'DEU', 'ألمانيا'),
(57635, 3262479754, 3262479754, 'FR', 'FRA', 'فرنسا'),
(57636, 3262479755, 3262479755, 'NL', 'NLD', 'هولندا'),
(57637, 3262479756, 3262479756, 'FR', 'FRA', 'فرنسا'),
(57638, 3262479757, 3262479757, 'SE', 'SWE', 'السويد'),
(57639, 3262479758, 3262479762, 'DE', 'DEU', 'ألمانيا'),
(57640, 3262479763, 3262479763, 'NO', 'NOR', 'النرويج'),
(57641, 3262479764, 3262479764, 'FR', 'FRA', 'فرنسا'),
(57642, 3262479765, 3262479765, 'DE', 'DEU', 'ألمانيا'),
(57643, 3262479766, 3262479766, 'CH', 'CHE', 'سويسرا'),
(57644, 3262479767, 3262479770, 'DE', 'DEU', 'ألمانيا'),
(57645, 3262479771, 3262479771, 'IT', 'ITA', 'إيطاليا'),
(57646, 3262479772, 3262479775, 'DE', 'DEU', 'ألمانيا'),
(57647, 3262479776, 3262479776, 'IT', 'ITA', 'إيطاليا'),
(57648, 3262479777, 3262479777, 'BE', 'BEL', 'بلجيكا'),
(57649, 3262479778, 3262479778, 'NL', 'NLD', 'هولندا'),
(57650, 3262479779, 3262479782, 'DE', 'DEU', 'ألمانيا'),
(57651, 3262479783, 3262479783, 'GB', 'GBR', 'المملكة المتحدة'),
(57652, 3262479784, 3262479784, 'AT', 'AUT', 'النمسا'),
(57653, 3262479785, 3262479785, 'FR', 'FRA', 'فرنسا'),
(57654, 3262479786, 3262479786, 'CH', 'CHE', 'سويسرا'),
(57655, 3262479787, 3262479788, 'DE', 'DEU', 'ألمانيا'),
(57656, 3262479789, 3262479789, 'IT', 'ITA', 'إيطاليا'),
(57657, 3262479790, 3262479790, 'DE', 'DEU', 'ألمانيا'),
(57658, 3262479791, 3262479792, 'IT', 'ITA', 'إيطاليا'),
(57659, 3262479793, 3262479793, 'DE', 'DEU', 'ألمانيا'),
(57660, 3262479794, 3262479794, 'FR', 'FRA', 'فرنسا'),
(57661, 3262479795, 3262479795, 'CH', 'CHE', 'سويسرا'),
(57662, 3262479796, 3262479797, 'AT', 'AUT', 'النمسا'),
(57663, 3262479798, 3262479799, 'GB', 'GBR', 'المملكة المتحدة'),
(57664, 3262479800, 3262479808, 'DE', 'DEU', 'ألمانيا'),
(57665, 3262479809, 3262479809, 'FR', 'FRA', 'فرنسا'),
(57666, 3262479810, 3262479810, 'NL', 'NLD', 'هولندا'),
(57667, 3262479811, 3262479811, 'ES', 'ESP', 'إسبانيا'),
(57668, 3262479812, 3262479812, 'GB', 'GBR', 'المملكة المتحدة'),
(57669, 3262479813, 3262479816, 'DE', 'DEU', 'ألمانيا'),
(57670, 3262479817, 3262479817, 'HU', 'HUN', 'هنغاريا'),
(57671, 3262479818, 3262479818, 'DE', 'DEU', 'ألمانيا'),
(57672, 3262479819, 3262479819, 'NL', 'NLD', 'هولندا'),
(57673, 3262479820, 3262479820, 'DE', 'DEU', 'ألمانيا'),
(57674, 3262479821, 3262479822, 'NL', 'NLD', 'هولندا'),
(57675, 3262479823, 3262479823, 'ES', 'ESP', 'إسبانيا'),
(57676, 3262479824, 3262479824, 'GB', 'GBR', 'المملكة المتحدة'),
(57677, 3262479825, 3262479825, 'DE', 'DEU', 'ألمانيا'),
(57678, 3262479826, 3262479826, 'BE', 'BEL', 'بلجيكا'),
(57679, 3262479827, 3262479827, 'DE', 'DEU', 'ألمانيا'),
(57680, 3262479828, 3262479829, 'CH', 'CHE', 'سويسرا'),
(57681, 3262479830, 3262479830, 'GB', 'GBR', 'المملكة المتحدة'),
(57682, 3262479831, 3262479832, 'DE', 'DEU', 'ألمانيا'),
(57683, 3262479833, 3262479833, 'ES', 'ESP', 'إسبانيا'),
(57684, 3262479834, 3262479834, 'DE', 'DEU', 'ألمانيا'),
(57685, 3262479835, 3262479835, 'AT', 'AUT', 'النمسا'),
(57686, 3262479836, 3262479836, 'NL', 'NLD', 'هولندا'),
(57687, 3262479837, 3262479837, 'HU', 'HUN', 'هنغاريا'),
(57688, 3262479838, 3262479838, 'CH', 'CHE', 'سويسرا'),
(57689, 3262479839, 3262479839, 'NL', 'NLD', 'هولندا'),
(57690, 3262479840, 3262479840, 'DE', 'DEU', 'ألمانيا'),
(57691, 3262479841, 3262479841, 'FR', 'FRA', 'فرنسا'),
(57692, 3262479842, 3262479842, 'DK', 'DNK', 'الدنيمارك'),
(57693, 3262479843, 3262479843, 'GB', 'GBR', 'المملكة المتحدة'),
(57694, 3262479844, 3262479844, 'DE', 'DEU', 'ألمانيا'),
(57695, 3262479845, 3262479845, 'CH', 'CHE', 'سويسرا'),
(57696, 3262479846, 3262479846, 'DE', 'DEU', 'ألمانيا'),
(57697, 3262479847, 3262479847, 'LU', 'LUX', 'لوكسيمبورغ'),
(57698, 3262479848, 3262479852, 'DE', 'DEU', 'ألمانيا'),
(57699, 3262479853, 3262479853, 'IS', 'ISL', 'أيسلندا'),
(57700, 3262479854, 3262479855, 'DE', 'DEU', 'ألمانيا'),
(57701, 3262479856, 3262479856, 'CH', 'CHE', 'سويسرا'),
(57702, 3262479857, 3262479859, 'DE', 'DEU', 'ألمانيا'),
(57703, 3262479860, 3262479860, 'NL', 'NLD', 'هولندا'),
(57704, 3262479861, 3262479861, 'NO', 'NOR', 'النرويج'),
(57705, 3262479862, 3262479862, 'BE', 'BEL', 'بلجيكا'),
(57706, 3262479863, 3262479863, 'NL', 'NLD', 'هولندا'),
(57707, 3262479864, 3262479864, 'DE', 'DEU', 'ألمانيا'),
(57708, 3262479865, 3262479865, 'FR', 'FRA', 'فرنسا'),
(57709, 3262479866, 3262479866, 'DE', 'DEU', 'ألمانيا'),
(57710, 3262479867, 3262479867, 'SE', 'SWE', 'السويد'),
(57711, 3262479868, 3262479868, 'DE', 'DEU', 'ألمانيا'),
(57712, 3262479869, 3262479869, 'GB', 'GBR', 'المملكة المتحدة'),
(57713, 3262479870, 3262479873, 'DE', 'DEU', 'ألمانيا'),
(57714, 3262479874, 3262479875, 'FR', 'FRA', 'فرنسا'),
(57715, 3262479876, 3262479876, 'DE', 'DEU', 'ألمانيا'),
(57716, 3262479877, 3262479877, 'CH', 'CHE', 'سويسرا'),
(57717, 3262479878, 3262479879, 'DE', 'DEU', 'ألمانيا'),
(57718, 3262479880, 3262479880, 'AT', 'AUT', 'النمسا'),
(57719, 3262479881, 3262479881, 'HU', 'HUN', 'هنغاريا'),
(57720, 3262479882, 3262479883, 'DE', 'DEU', 'ألمانيا'),
(57721, 3262479884, 3262479884, 'GB', 'GBR', 'المملكة المتحدة'),
(57722, 3262479885, 3262479886, 'DE', 'DEU', 'ألمانيا'),
(57723, 3262479887, 3262479887, 'GR', 'GRC', 'اليونان'),
(57724, 3262479888, 3262479888, 'FR', 'FRA', 'فرنسا'),
(57725, 3262479889, 3262479889, 'NL', 'NLD', 'هولندا'),
(57726, 3262479890, 3262479892, 'DE', 'DEU', 'ألمانيا'),
(57727, 3262479893, 3262479893, 'LU', 'LUX', 'لوكسيمبورغ'),
(57728, 3262479894, 3262479894, 'CH', 'CHE', 'سويسرا'),
(57729, 3262479895, 3262479896, 'ES', 'ESP', 'إسبانيا'),
(57730, 3262479897, 3262479899, 'DE', 'DEU', 'ألمانيا'),
(57731, 3262479900, 3262479900, 'NL', 'NLD', 'هولندا'),
(57732, 3262479901, 3262479901, 'AT', 'AUT', 'النمسا'),
(57733, 3262479902, 3262479902, 'DE', 'DEU', 'ألمانيا'),
(57734, 3262479903, 3262479903, 'CH', 'CHE', 'سويسرا'),
(57735, 3262479904, 3262479908, 'DE', 'DEU', 'ألمانيا'),
(57736, 3262479909, 3262479909, 'SE', 'SWE', 'السويد'),
(57737, 3262479910, 3262479912, 'DE', 'DEU', 'ألمانيا'),
(57738, 3262479913, 3262479913, 'NO', 'NOR', 'النرويج'),
(57739, 3262479914, 3262479914, 'DE', 'DEU', 'ألمانيا'),
(57740, 3262479915, 3262479915, 'FR', 'FRA', 'فرنسا'),
(57741, 3262479916, 3262479917, 'DE', 'DEU', 'ألمانيا'),
(57742, 3262479918, 3262479918, 'GB', 'GBR', 'المملكة المتحدة'),
(57743, 3262479919, 3262479922, 'DE', 'DEU', 'ألمانيا'),
(57744, 3262479923, 3262479923, 'AT', 'AUT', 'النمسا'),
(57745, 3262479924, 3262479929, 'DE', 'DEU', 'ألمانيا'),
(57746, 3262479930, 3262479930, 'IT', 'ITA', 'إيطاليا'),
(57747, 3262479931, 3262479931, 'DK', 'DNK', 'الدنيمارك'),
(57748, 3262479932, 3262479932, 'DE', 'DEU', 'ألمانيا'),
(57749, 3262479933, 3262479933, 'NL', 'NLD', 'هولندا'),
(57750, 3262479934, 3262479935, 'DE', 'DEU', 'ألمانيا'),
(57751, 3262479936, 3262479936, 'BE', 'BEL', 'بلجيكا'),
(57752, 3262479937, 3262479937, 'FR', 'FRA', 'فرنسا'),
(57753, 3262479938, 3262479939, 'DE', 'DEU', 'ألمانيا'),
(57754, 3262479940, 3262479940, 'ES', 'ESP', 'إسبانيا'),
(57755, 3262479941, 3262479941, 'IT', 'ITA', 'إيطاليا'),
(57756, 3262479942, 3262479944, 'DE', 'DEU', 'ألمانيا'),
(57757, 3262479945, 3262479945, 'FR', 'FRA', 'فرنسا'),
(57758, 3262479946, 3262479946, 'DE', 'DEU', 'ألمانيا'),
(57759, 3262479947, 3262479947, 'HU', 'HUN', 'هنغاريا'),
(57760, 3262479948, 3262479948, 'DE', 'DEU', 'ألمانيا'),
(57761, 3262479949, 3262479949, 'NL', 'NLD', 'هولندا'),
(57762, 3262479950, 3262479950, 'CH', 'CHE', 'سويسرا'),
(57763, 3262479951, 3262479953, 'DE', 'DEU', 'ألمانيا'),
(57764, 3262479954, 3262479954, 'CH', 'CHE', 'سويسرا'),
(57765, 3262479955, 3262479955, 'DE', 'DEU', 'ألمانيا'),
(57766, 3262479956, 3262479956, 'IT', 'ITA', 'إيطاليا'),
(57767, 3262479957, 3262479957, 'BE', 'BEL', 'بلجيكا'),
(57768, 3262479958, 3262479959, 'DE', 'DEU', 'ألمانيا'),
(57769, 3262479960, 3262479960, 'AT', 'AUT', 'النمسا'),
(57770, 3262479961, 3262479961, 'DE', 'DEU', 'ألمانيا'),
(57771, 3262479962, 3262479962, 'GB', 'GBR', 'المملكة المتحدة'),
(57772, 3262479963, 3262479963, 'ES', 'ESP', 'إسبانيا'),
(57773, 3262479964, 3262479964, 'DE', 'DEU', 'ألمانيا'),
(57774, 3262479965, 3262479965, 'ES', 'ESP', 'إسبانيا'),
(57775, 3262479966, 3262479974, 'DE', 'DEU', 'ألمانيا'),
(57776, 3262479975, 3262479975, 'FR', 'FRA', 'فرنسا'),
(57777, 3262479976, 3262479976, 'NL', 'NLD', 'هولندا'),
(57778, 3262479977, 3262479978, 'DE', 'DEU', 'ألمانيا'),
(57779, 3262479979, 3262479979, 'CH', 'CHE', 'سويسرا'),
(57780, 3262479980, 3262479980, 'AT', 'AUT', 'النمسا'),
(57781, 3262479981, 3262479984, 'DE', 'DEU', 'ألمانيا'),
(57782, 3262479985, 3262479985, 'CH', 'CHE', 'سويسرا'),
(57783, 3262479986, 3262479987, 'DE', 'DEU', 'ألمانيا'),
(57784, 3262479988, 3262479988, 'FR', 'FRA', 'فرنسا'),
(57785, 3262479989, 3262479989, 'DE', 'DEU', 'ألمانيا'),
(57786, 3262479990, 3262479990, 'NL', 'NLD', 'هولندا'),
(57787, 3262479991, 3262479993, 'DE', 'DEU', 'ألمانيا'),
(57788, 3262479994, 3262479994, 'CH', 'CHE', 'سويسرا'),
(57789, 3262479995, 3262479995, 'DE', 'DEU', 'ألمانيا'),
(57790, 3262479996, 3262479996, 'NL', 'NLD', 'هولندا'),
(57791, 3262479997, 3262480001, 'DE', 'DEU', 'ألمانيا'),
(57792, 3262480002, 3262480002, 'BE', 'BEL', 'بلجيكا'),
(57793, 3262480003, 3262480005, 'DE', 'DEU', 'ألمانيا'),
(57794, 3262480006, 3262480006, 'FR', 'FRA', 'فرنسا'),
(57795, 3262480007, 3262480009, 'DE', 'DEU', 'ألمانيا'),
(57796, 3262480010, 3262480010, 'FR', 'FRA', 'فرنسا'),
(57797, 3262480011, 3262480011, 'BE', 'BEL', 'بلجيكا'),
(57798, 3262480012, 3262480012, 'NL', 'NLD', 'هولندا'),
(57799, 3262480013, 3262480015, 'DE', 'DEU', 'ألمانيا'),
(57800, 3262480016, 3262480016, 'ES', 'ESP', 'إسبانيا'),
(57801, 3262480017, 3262480018, 'DE', 'DEU', 'ألمانيا'),
(57802, 3262480019, 3262480019, 'BE', 'BEL', 'بلجيكا'),
(57803, 3262480020, 3262480020, 'DE', 'DEU', 'ألمانيا'),
(57804, 3262480021, 3262480021, 'DK', 'DNK', 'الدنيمارك'),
(57805, 3262480022, 3262480022, 'CH', 'CHE', 'سويسرا'),
(57806, 3262480023, 3262480029, 'DE', 'DEU', 'ألمانيا'),
(57807, 3262480030, 3262480030, 'GB', 'GBR', 'المملكة المتحدة'),
(57808, 3262480031, 3262480031, 'DE', 'DEU', 'ألمانيا'),
(57809, 3262480032, 3262480032, 'CH', 'CHE', 'سويسرا'),
(57810, 3262480033, 3262480033, 'GB', 'GBR', 'المملكة المتحدة'),
(57811, 3262480034, 3262480034, 'DE', 'DEU', 'ألمانيا'),
(57812, 3262480035, 3262480035, 'LU', 'LUX', 'لوكسيمبورغ'),
(57813, 3262480036, 3262480037, 'DE', 'DEU', 'ألمانيا'),
(57814, 3262480038, 3262480038, 'NL', 'NLD', 'هولندا'),
(57815, 3262480039, 3262480039, 'CH', 'CHE', 'سويسرا'),
(57816, 3262480040, 3262480040, 'DE', 'DEU', 'ألمانيا'),
(57817, 3262480041, 3262480041, 'AT', 'AUT', 'النمسا'),
(57818, 3262480042, 3262480042, 'DE', 'DEU', 'ألمانيا'),
(57819, 3262480043, 3262480043, 'GB', 'GBR', 'المملكة المتحدة'),
(57820, 3262480044, 3262480044, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(57821, 3262480045, 3262480045, 'GB', 'GBR', 'المملكة المتحدة'),
(57822, 3262480046, 3262480048, 'DE', 'DEU', 'ألمانيا'),
(57823, 3262480049, 3262480049, 'LU', 'LUX', 'لوكسيمبورغ'),
(57824, 3262480050, 3262480051, 'DE', 'DEU', 'ألمانيا'),
(57825, 3262480052, 3262480052, 'NL', 'NLD', 'هولندا'),
(57826, 3262480053, 3262480057, 'DE', 'DEU', 'ألمانيا'),
(57827, 3262480058, 3262480058, 'NL', 'NLD', 'هولندا'),
(57828, 3262480059, 3262480059, 'CH', 'CHE', 'سويسرا'),
(57829, 3262480060, 3262480060, 'DE', 'DEU', 'ألمانيا'),
(57830, 3262480061, 3262480062, 'GB', 'GBR', 'المملكة المتحدة'),
(57831, 3262480063, 3262480063, 'SI', 'SVN', 'سلوفينيا'),
(57832, 3262480064, 3262480066, 'DE', 'DEU', 'ألمانيا'),
(57833, 3262480067, 3262480067, 'NL', 'NLD', 'هولندا'),
(57834, 3262480068, 3262480071, 'DE', 'DEU', 'ألمانيا'),
(57835, 3262480072, 3262480072, 'IT', 'ITA', 'إيطاليا'),
(57836, 3262480073, 3262480073, 'DE', 'DEU', 'ألمانيا'),
(57837, 3262480074, 3262480074, 'AT', 'AUT', 'النمسا'),
(57838, 3262480075, 3262480076, 'DE', 'DEU', 'ألمانيا'),
(57839, 3262480077, 3262480078, 'FR', 'FRA', 'فرنسا'),
(57840, 3262480079, 3262480080, 'DE', 'DEU', 'ألمانيا'),
(57841, 3262480081, 3262480081, 'CH', 'CHE', 'سويسرا'),
(57842, 3262480082, 3262480082, 'DE', 'DEU', 'ألمانيا'),
(57843, 3262480083, 3262480083, 'NO', 'NOR', 'النرويج'),
(57844, 3262480084, 3262480084, 'IT', 'ITA', 'إيطاليا'),
(57845, 3262480085, 3262480085, 'FR', 'FRA', 'فرنسا'),
(57846, 3262480086, 3262480087, 'DE', 'DEU', 'ألمانيا'),
(57847, 3262480088, 3262480088, 'FR', 'FRA', 'فرنسا'),
(57848, 3262480089, 3262480089, 'NL', 'NLD', 'هولندا'),
(57849, 3262480090, 3262480090, 'CH', 'CHE', 'سويسرا'),
(57850, 3262480091, 3262480092, 'DE', 'DEU', 'ألمانيا'),
(57851, 3262480093, 3262480093, 'BE', 'BEL', 'بلجيكا'),
(57852, 3262480094, 3262480094, 'DE', 'DEU', 'ألمانيا'),
(57853, 3262480095, 3262480095, 'AT', 'AUT', 'النمسا'),
(57854, 3262480096, 3262480097, 'DE', 'DEU', 'ألمانيا'),
(57855, 3262480098, 3262480098, 'GB', 'GBR', 'المملكة المتحدة'),
(57856, 3262480099, 3262480104, 'DE', 'DEU', 'ألمانيا'),
(57857, 3262480105, 3262480105, 'IT', 'ITA', 'إيطاليا'),
(57858, 3262480106, 3262480106, 'DE', 'DEU', 'ألمانيا'),
(57859, 3262480107, 3262480107, 'DK', 'DNK', 'الدنيمارك'),
(57860, 3262480108, 3262480109, 'DE', 'DEU', 'ألمانيا'),
(57861, 3262480110, 3262480110, 'GB', 'GBR', 'المملكة المتحدة'),
(57862, 3262480111, 3262480111, 'AT', 'AUT', 'النمسا'),
(57863, 3262480112, 3262480112, 'BE', 'BEL', 'بلجيكا'),
(57864, 3262480113, 3262480113, 'DE', 'DEU', 'ألمانيا'),
(57865, 3262480114, 3262480114, 'IT', 'ITA', 'إيطاليا'),
(57866, 3262480115, 3262480116, 'DE', 'DEU', 'ألمانيا'),
(57867, 3262480117, 3262480117, 'BE', 'BEL', 'بلجيكا'),
(57868, 3262480118, 3262480125, 'DE', 'DEU', 'ألمانيا'),
(57869, 3262480126, 3262480126, 'ES', 'ESP', 'إسبانيا'),
(57870, 3262480127, 3262480133, 'DE', 'DEU', 'ألمانيا'),
(57871, 3262480134, 3262480134, 'AT', 'AUT', 'النمسا'),
(57872, 3262480135, 3262480135, 'NL', 'NLD', 'هولندا'),
(57873, 3262480136, 3262480136, 'FR', 'FRA', 'فرنسا'),
(57874, 3262480137, 3262480139, 'DE', 'DEU', 'ألمانيا'),
(57875, 3262480140, 3262480140, 'FR', 'FRA', 'فرنسا'),
(57876, 3262480141, 3262480141, 'AT', 'AUT', 'النمسا'),
(57877, 3262480142, 3262480146, 'DE', 'DEU', 'ألمانيا'),
(57878, 3262480147, 3262480147, 'IT', 'ITA', 'إيطاليا'),
(57879, 3262480148, 3262480148, 'GB', 'GBR', 'المملكة المتحدة'),
(57880, 3262480149, 3262480150, 'DE', 'DEU', 'ألمانيا'),
(57881, 3262480151, 3262480151, 'GB', 'GBR', 'المملكة المتحدة'),
(57882, 3262480152, 3262480154, 'DE', 'DEU', 'ألمانيا'),
(57883, 3262480155, 3262480155, 'ES', 'ESP', 'إسبانيا'),
(57884, 3262480156, 3262480158, 'DE', 'DEU', 'ألمانيا'),
(57885, 3262480159, 3262480159, 'IT', 'ITA', 'إيطاليا'),
(57886, 3262480160, 3262480161, 'DE', 'DEU', 'ألمانيا'),
(57887, 3262480162, 3262480162, 'NO', 'NOR', 'النرويج'),
(57888, 3262480163, 3262480164, 'DE', 'DEU', 'ألمانيا'),
(57889, 3262480165, 3262480165, 'FR', 'FRA', 'فرنسا'),
(57890, 3262480166, 3262480172, 'DE', 'DEU', 'ألمانيا'),
(57891, 3262480173, 3262480173, 'NL', 'NLD', 'هولندا'),
(57892, 3262480174, 3262480174, 'DE', 'DEU', 'ألمانيا'),
(57893, 3262480175, 3262480175, 'NL', 'NLD', 'هولندا'),
(57894, 3262480176, 3262480176, 'DE', 'DEU', 'ألمانيا'),
(57895, 3262480177, 3262480177, 'CH', 'CHE', 'سويسرا'),
(57896, 3262480178, 3262480178, 'IT', 'ITA', 'إيطاليا'),
(57897, 3262480179, 3262480179, 'DE', 'DEU', 'ألمانيا'),
(57898, 3262480180, 3262480180, 'FR', 'FRA', 'فرنسا'),
(57899, 3262480181, 3262480181, 'ES', 'ESP', 'إسبانيا'),
(57900, 3262480182, 3262480182, 'DE', 'DEU', 'ألمانيا'),
(57901, 3262480183, 3262480183, 'SE', 'SWE', 'السويد'),
(57902, 3262480184, 3262480184, 'DE', 'DEU', 'ألمانيا'),
(57903, 3262480185, 3262480185, 'FR', 'FRA', 'فرنسا'),
(57904, 3262480186, 3262480186, 'PT', 'PRT', 'البورتوغال'),
(57905, 3262480187, 3262480187, 'DE', 'DEU', 'ألمانيا'),
(57906, 3262480188, 3262480188, 'FI', 'FIN', 'فنلندا'),
(57907, 3262480189, 3262480189, 'CH', 'CHE', 'سويسرا'),
(57908, 3262480190, 3262480190, 'DE', 'DEU', 'ألمانيا'),
(57909, 3262480191, 3262480191, 'NO', 'NOR', 'النرويج'),
(57910, 3262480192, 3262480193, 'DE', 'DEU', 'ألمانيا'),
(57911, 3262480194, 3262480194, 'NL', 'NLD', 'هولندا'),
(57912, 3262480195, 3262480195, 'GB', 'GBR', 'المملكة المتحدة'),
(57913, 3262480196, 3262480197, 'DE', 'DEU', 'ألمانيا'),
(57914, 3262480198, 3262480198, 'NL', 'NLD', 'هولندا'),
(57915, 3262480199, 3262480199, 'GB', 'GBR', 'المملكة المتحدة'),
(57916, 3262480200, 3262480201, 'DE', 'DEU', 'ألمانيا'),
(57917, 3262480202, 3262480202, 'GB', 'GBR', 'المملكة المتحدة'),
(57918, 3262480203, 3262480205, 'DE', 'DEU', 'ألمانيا'),
(57919, 3262480206, 3262480206, 'CH', 'CHE', 'سويسرا'),
(57920, 3262480207, 3262480212, 'DE', 'DEU', 'ألمانيا'),
(57921, 3262480213, 3262480213, 'FR', 'FRA', 'فرنسا'),
(57922, 3262480214, 3262480215, 'DE', 'DEU', 'ألمانيا'),
(57923, 3262480216, 3262480216, 'HU', 'HUN', 'هنغاريا'),
(57924, 3262480217, 3262480218, 'DE', 'DEU', 'ألمانيا'),
(57925, 3262480219, 3262480219, 'ES', 'ESP', 'إسبانيا'),
(57926, 3262480220, 3262480220, 'NL', 'NLD', 'هولندا'),
(57927, 3262480221, 3262480221, 'BE', 'BEL', 'بلجيكا'),
(57928, 3262480222, 3262480226, 'DE', 'DEU', 'ألمانيا'),
(57929, 3262480227, 3262480227, 'IE', 'IRL', 'إيرلندا'),
(57930, 3262480228, 3262480229, 'DE', 'DEU', 'ألمانيا'),
(57931, 3262480230, 3262480230, 'SE', 'SWE', 'السويد'),
(57932, 3262480231, 3262480232, 'DE', 'DEU', 'ألمانيا'),
(57933, 3262480233, 3262480233, 'SE', 'SWE', 'السويد'),
(57934, 3262480234, 3262480234, 'DE', 'DEU', 'ألمانيا'),
(57935, 3262480235, 3262480235, 'HU', 'HUN', 'هنغاريا'),
(57936, 3262480236, 3262480236, 'DE', 'DEU', 'ألمانيا'),
(57937, 3262480237, 3262480237, 'PL', 'POL', 'بولندا'),
(57938, 3262480238, 3262480238, 'DE', 'DEU', 'ألمانيا'),
(57939, 3262480239, 3262480239, 'NL', 'NLD', 'هولندا'),
(57940, 3262480240, 3262480243, 'DE', 'DEU', 'ألمانيا'),
(57941, 3262480244, 3262480244, 'CH', 'CHE', 'سويسرا'),
(57942, 3262480245, 3262480246, 'DE', 'DEU', 'ألمانيا'),
(57943, 3262480247, 3262480247, 'NL', 'NLD', 'هولندا'),
(57944, 3262480248, 3262480248, 'DE', 'DEU', 'ألمانيا'),
(57945, 3262480249, 3262480249, 'NL', 'NLD', 'هولندا'),
(57946, 3262480250, 3262480250, 'DE', 'DEU', 'ألمانيا'),
(57947, 3262480251, 3262480251, 'NL', 'NLD', 'هولندا'),
(57948, 3262480252, 3262480253, 'DE', 'DEU', 'ألمانيا'),
(57949, 3262480254, 3262480254, 'CH', 'CHE', 'سويسرا'),
(57950, 3262480255, 3262480260, 'DE', 'DEU', 'ألمانيا'),
(57951, 3262480261, 3262480261, 'BE', 'BEL', 'بلجيكا'),
(57952, 3262480262, 3262480264, 'DE', 'DEU', 'ألمانيا'),
(57953, 3262480265, 3262480265, 'GB', 'GBR', 'المملكة المتحدة'),
(57954, 3262480266, 3262480267, 'DE', 'DEU', 'ألمانيا'),
(57955, 3262480268, 3262480268, 'FR', 'FRA', 'فرنسا'),
(57956, 3262480269, 3262480269, 'NL', 'NLD', 'هولندا'),
(57957, 3262480270, 3262480270, 'DE', 'DEU', 'ألمانيا'),
(57958, 3262480271, 3262480271, 'CH', 'CHE', 'سويسرا'),
(57959, 3262480272, 3262480272, 'DK', 'DNK', 'الدنيمارك'),
(57960, 3262480273, 3262480273, 'DE', 'DEU', 'ألمانيا'),
(57961, 3262480274, 3262480274, 'IT', 'ITA', 'إيطاليا'),
(57962, 3262480275, 3262480275, 'BE', 'BEL', 'بلجيكا'),
(57963, 3262480276, 3262480276, 'ES', 'ESP', 'إسبانيا'),
(57964, 3262480277, 3262480277, 'DE', 'DEU', 'ألمانيا'),
(57965, 3262480278, 3262480278, 'CH', 'CHE', 'سويسرا'),
(57966, 3262480279, 3262480282, 'DE', 'DEU', 'ألمانيا'),
(57967, 3262480283, 3262480283, 'GB', 'GBR', 'المملكة المتحدة'),
(57968, 3262480284, 3262480285, 'DE', 'DEU', 'ألمانيا'),
(57969, 3262480286, 3262480286, 'CH', 'CHE', 'سويسرا'),
(57970, 3262480287, 3262480293, 'DE', 'DEU', 'ألمانيا'),
(57971, 3262480294, 3262480294, 'FR', 'FRA', 'فرنسا'),
(57972, 3262480295, 3262480295, 'CH', 'CHE', 'سويسرا'),
(57973, 3262480296, 3262480296, 'NO', 'NOR', 'النرويج'),
(57974, 3262480297, 3262480300, 'DE', 'DEU', 'ألمانيا'),
(57975, 3262480301, 3262480301, 'LU', 'LUX', 'لوكسيمبورغ'),
(57976, 3262480302, 3262480302, 'DE', 'DEU', 'ألمانيا'),
(57977, 3262480303, 3262480304, 'IT', 'ITA', 'إيطاليا'),
(57978, 3262480305, 3262480305, 'DE', 'DEU', 'ألمانيا'),
(57979, 3262480306, 3262480306, 'AT', 'AUT', 'النمسا'),
(57980, 3262480307, 3262480311, 'DE', 'DEU', 'ألمانيا'),
(57981, 3262480312, 3262480312, 'NL', 'NLD', 'هولندا'),
(57982, 3262480313, 3262480313, 'FR', 'FRA', 'فرنسا'),
(57983, 3262480314, 3262480314, 'NL', 'NLD', 'هولندا'),
(57984, 3262480315, 3262480315, 'DE', 'DEU', 'ألمانيا'),
(57985, 3262480316, 3262480316, 'IT', 'ITA', 'إيطاليا'),
(57986, 3262480317, 3262480317, 'NL', 'NLD', 'هولندا'),
(57987, 3262480318, 3262480318, 'IT', 'ITA', 'إيطاليا'),
(57988, 3262480319, 3262480319, 'AT', 'AUT', 'النمسا'),
(57989, 3262480320, 3262480320, 'DK', 'DNK', 'الدنيمارك'),
(57990, 3262480321, 3262480321, 'DE', 'DEU', 'ألمانيا'),
(57991, 3262480322, 3262480322, 'GB', 'GBR', 'المملكة المتحدة'),
(57992, 3262480323, 3262480324, 'DE', 'DEU', 'ألمانيا'),
(57993, 3262480325, 3262480325, 'ES', 'ESP', 'إسبانيا'),
(57994, 3262480326, 3262480329, 'DE', 'DEU', 'ألمانيا'),
(57995, 3262480330, 3262480330, 'FR', 'FRA', 'فرنسا'),
(57996, 3262480331, 3262480331, 'IT', 'ITA', 'إيطاليا'),
(57997, 3262480332, 3262480332, 'DE', 'DEU', 'ألمانيا'),
(57998, 3262480333, 3262480333, 'CH', 'CHE', 'سويسرا'),
(57999, 3262480334, 3262480334, 'DE', 'DEU', 'ألمانيا'),
(58000, 3262480335, 3262480335, 'GB', 'GBR', 'المملكة المتحدة'),
(58001, 3262480336, 3262480336, 'DE', 'DEU', 'ألمانيا'),
(58002, 3262480337, 3262480337, 'NL', 'NLD', 'هولندا'),
(58003, 3262480338, 3262480340, 'DE', 'DEU', 'ألمانيا'),
(58004, 3262480341, 3262480341, 'CH', 'CHE', 'سويسرا'),
(58005, 3262480342, 3262480342, 'DE', 'DEU', 'ألمانيا'),
(58006, 3262480343, 3262480343, 'DK', 'DNK', 'الدنيمارك'),
(58007, 3262480344, 3262480344, 'DE', 'DEU', 'ألمانيا'),
(58008, 3262480345, 3262480345, 'CH', 'CHE', 'سويسرا'),
(58009, 3262480346, 3262480346, 'DE', 'DEU', 'ألمانيا'),
(58010, 3262480347, 3262480347, 'NL', 'NLD', 'هولندا'),
(58011, 3262480348, 3262480348, 'IS', 'ISL', 'أيسلندا'),
(58012, 3262480349, 3262480349, 'AT', 'AUT', 'النمسا'),
(58013, 3262480350, 3262480352, 'DE', 'DEU', 'ألمانيا'),
(58014, 3262480353, 3262480353, 'CH', 'CHE', 'سويسرا'),
(58015, 3262480354, 3262480354, 'DE', 'DEU', 'ألمانيا'),
(58016, 3262480355, 3262480355, 'GB', 'GBR', 'المملكة المتحدة'),
(58017, 3262480356, 3262480356, 'DE', 'DEU', 'ألمانيا'),
(58018, 3262480357, 3262480357, 'GB', 'GBR', 'المملكة المتحدة'),
(58019, 3262480358, 3262480359, 'CH', 'CHE', 'سويسرا'),
(58020, 3262480360, 3262480363, 'DE', 'DEU', 'ألمانيا'),
(58021, 3262480364, 3262480364, 'ES', 'ESP', 'إسبانيا'),
(58022, 3262480365, 3262480365, 'DE', 'DEU', 'ألمانيا'),
(58023, 3262480366, 3262480366, 'AT', 'AUT', 'النمسا'),
(58024, 3262480367, 3262480367, 'DE', 'DEU', 'ألمانيا'),
(58025, 3262480368, 3262480368, 'GB', 'GBR', 'المملكة المتحدة'),
(58026, 3262480369, 3262480369, 'FR', 'FRA', 'فرنسا'),
(58027, 3262480370, 3262480370, 'ES', 'ESP', 'إسبانيا'),
(58028, 3262480371, 3262480371, 'GB', 'GBR', 'المملكة المتحدة'),
(58029, 3262480372, 3262480372, 'DE', 'DEU', 'ألمانيا'),
(58030, 3262480373, 3262480373, 'AT', 'AUT', 'النمسا'),
(58031, 3262480374, 3262480374, 'ES', 'ESP', 'إسبانيا'),
(58032, 3262480375, 3262480375, 'NL', 'NLD', 'هولندا'),
(58033, 3262480376, 3262480376, 'DE', 'DEU', 'ألمانيا'),
(58034, 3262480377, 3262480377, 'IT', 'ITA', 'إيطاليا'),
(58035, 3262480378, 3262480378, 'DE', 'DEU', 'ألمانيا'),
(58036, 3262480379, 3262480379, 'CH', 'CHE', 'سويسرا'),
(58037, 3262480380, 3262480380, 'GB', 'GBR', 'المملكة المتحدة'),
(58038, 3262480381, 3262480381, 'IT', 'ITA', 'إيطاليا'),
(58039, 3262480382, 3262480382, 'ES', 'ESP', 'إسبانيا'),
(58040, 3262480383, 3262480383, 'DE', 'DEU', 'ألمانيا'),
(58041, 3262480384, 3262488575, 'GB', 'GBR', 'المملكة المتحدة'),
(58042, 3262488576, 3262496767, 'SE', 'SWE', 'السويد'),
(58043, 3262496768, 3262504959, 'FR', 'FRA', 'فرنسا'),
(58044, 3262504960, 3262505471, 'DE', 'DEU', 'ألمانيا'),
(58045, 3262505472, 3262505983, 'GB', 'GBR', 'المملكة المتحدة'),
(58046, 3262505984, 3262506495, 'PL', 'POL', 'بولندا'),
(58047, 3262506496, 3262507007, 'RO', 'ROM', 'رومانيا'),
(58048, 3262507008, 3262507519, 'DK', 'DNK', 'الدنيمارك'),
(58049, 3262507520, 3262509055, 'RO', 'ROM', 'رومانيا'),
(58050, 3262509056, 3262509567, 'PL', 'POL', 'بولندا'),
(58051, 3262509568, 3262510079, 'RO', 'ROM', 'رومانيا'),
(58052, 3262510080, 3262511103, 'FR', 'FRA', 'فرنسا'),
(58053, 3262511104, 3262511615, 'GB', 'GBR', 'المملكة المتحدة'),
(58054, 3262511616, 3262512127, 'DE', 'DEU', 'ألمانيا'),
(58055, 3262512128, 3262512639, 'GB', 'GBR', 'المملكة المتحدة'),
(58056, 3262512640, 3262513151, 'DE', 'DEU', 'ألمانيا'),
(58057, 3262513152, 3262578687, 'AT', 'AUT', 'النمسا'),
(58058, 3262578688, 3262611455, 'FR', 'FRA', 'فرنسا'),
(58059, 3262611456, 3262627839, 'GB', 'GBR', 'المملكة المتحدة'),
(58060, 3262627840, 3262636031, 'IT', 'ITA', 'إيطاليا'),
(58061, 3262636032, 3262644223, 'BE', 'BEL', 'بلجيكا'),
(58062, 3262644224, 3262644695, 'NL', 'NLD', 'هولندا'),
(58063, 3262644696, 3262644703, 'DE', 'DEU', 'ألمانيا'),
(58064, 3262644704, 3262644735, 'NL', 'NLD', 'هولندا'),
(58065, 3262644736, 3262644743, 'DE', 'DEU', 'ألمانيا'),
(58066, 3262644744, 3262645047, 'NL', 'NLD', 'هولندا'),
(58067, 3262645048, 3262645063, 'DE', 'DEU', 'ألمانيا'),
(58068, 3262645064, 3262645119, 'NL', 'NLD', 'هولندا'),
(58069, 3262645120, 3262645127, 'DE', 'DEU', 'ألمانيا'),
(58070, 3262645128, 3262645143, 'NL', 'NLD', 'هولندا'),
(58071, 3262645144, 3262645151, 'DE', 'DEU', 'ألمانيا'),
(58072, 3262645152, 3262645167, 'NL', 'NLD', 'هولندا'),
(58073, 3262645168, 3262645175, 'DE', 'DEU', 'ألمانيا'),
(58074, 3262645176, 3262645447, 'NL', 'NLD', 'هولندا'),
(58075, 3262645448, 3262645463, 'DE', 'DEU', 'ألمانيا'),
(58076, 3262645464, 3262645591, 'NL', 'NLD', 'هولندا'),
(58077, 3262645592, 3262645599, 'DE', 'DEU', 'ألمانيا'),
(58078, 3262645600, 3262645631, 'NL', 'NLD', 'هولندا'),
(58079, 3262645632, 3262645639, 'DE', 'DEU', 'ألمانيا'),
(58080, 3262645640, 3262645983, 'NL', 'NLD', 'هولندا'),
(58081, 3262645984, 3262645991, 'DE', 'DEU', 'ألمانيا'),
(58082, 3262645992, 3262646007, 'NL', 'NLD', 'هولندا'),
(58083, 3262646008, 3262646015, 'DE', 'DEU', 'ألمانيا'),
(58084, 3262646016, 3262646055, 'NL', 'NLD', 'هولندا'),
(58085, 3262646056, 3262646063, 'DE', 'DEU', 'ألمانيا'),
(58086, 3262646064, 3262646095, 'NL', 'NLD', 'هولندا'),
(58087, 3262646096, 3262646103, 'DE', 'DEU', 'ألمانيا'),
(58088, 3262646104, 3262646127, 'NL', 'NLD', 'هولندا'),
(58089, 3262646128, 3262646143, 'DE', 'DEU', 'ألمانيا'),
(58090, 3262646144, 3262646239, 'NL', 'NLD', 'هولندا'),
(58091, 3262646240, 3262646247, 'DE', 'DEU', 'ألمانيا'),
(58092, 3262646248, 3262646303, 'NL', 'NLD', 'هولندا'),
(58093, 3262646304, 3262646311, 'DE', 'DEU', 'ألمانيا'),
(58094, 3262646312, 3262646335, 'NL', 'NLD', 'هولندا'),
(58095, 3262646336, 3262646343, 'DE', 'DEU', 'ألمانيا'),
(58096, 3262646344, 3262646359, 'NL', 'NLD', 'هولندا'),
(58097, 3262646360, 3262646375, 'DE', 'DEU', 'ألمانيا'),
(58098, 3262646376, 3262646399, 'NL', 'NLD', 'هولندا'),
(58099, 3262646400, 3262646407, 'DE', 'DEU', 'ألمانيا'),
(58100, 3262646408, 3262646559, 'NL', 'NLD', 'هولندا'),
(58101, 3262646560, 3262646567, 'DE', 'DEU', 'ألمانيا'),
(58102, 3262646568, 3262646575, 'NL', 'NLD', 'هولندا'),
(58103, 3262646576, 3262646583, 'DE', 'DEU', 'ألمانيا'),
(58104, 3262646584, 3262646591, 'NL', 'NLD', 'هولندا'),
(58105, 3262646592, 3262646599, 'DE', 'DEU', 'ألمانيا'),
(58106, 3262646600, 3262646855, 'NL', 'NLD', 'هولندا'),
(58107, 3262646856, 3262646871, 'DE', 'DEU', 'ألمانيا'),
(58108, 3262646872, 3262646895, 'NL', 'NLD', 'هولندا'),
(58109, 3262646896, 3262646903, 'DE', 'DEU', 'ألمانيا'),
(58110, 3262646904, 3262646911, 'NL', 'NLD', 'هولندا'),
(58111, 3262646912, 3262646919, 'DE', 'DEU', 'ألمانيا'),
(58112, 3262646920, 3262646943, 'NL', 'NLD', 'هولندا'),
(58113, 3262646944, 3262646951, 'DE', 'DEU', 'ألمانيا'),
(58114, 3262646952, 3262647063, 'NL', 'NLD', 'هولندا'),
(58115, 3262647064, 3262647071, 'DE', 'DEU', 'ألمانيا'),
(58116, 3262647072, 3262647287, 'NL', 'NLD', 'هولندا'),
(58117, 3262647288, 3262647295, 'DE', 'DEU', 'ألمانيا'),
(58118, 3262647296, 3262647367, 'NL', 'NLD', 'هولندا'),
(58119, 3262647368, 3262647375, 'DE', 'DEU', 'ألمانيا'),
(58120, 3262647376, 3262647519, 'NL', 'NLD', 'هولندا'),
(58121, 3262647520, 3262647527, 'DE', 'DEU', 'ألمانيا'),
(58122, 3262647528, 3262647559, 'NL', 'NLD', 'هولندا'),
(58123, 3262647560, 3262647567, 'DE', 'DEU', 'ألمانيا'),
(58124, 3262647568, 3262647599, 'NL', 'NLD', 'هولندا'),
(58125, 3262647600, 3262647607, 'DE', 'DEU', 'ألمانيا'),
(58126, 3262647608, 3262647647, 'NL', 'NLD', 'هولندا'),
(58127, 3262647648, 3262647663, 'DE', 'DEU', 'ألمانيا'),
(58128, 3262647664, 3262647679, 'NL', 'NLD', 'هولندا'),
(58129, 3262647680, 3262647687, 'DE', 'DEU', 'ألمانيا'),
(58130, 3262647688, 3262647695, 'NL', 'NLD', 'هولندا'),
(58131, 3262647696, 3262647703, 'DE', 'DEU', 'ألمانيا'),
(58132, 3262647704, 3262647767, 'NL', 'NLD', 'هولندا'),
(58133, 3262647768, 3262647775, 'DE', 'DEU', 'ألمانيا'),
(58134, 3262647776, 3262647807, 'NL', 'NLD', 'هولندا'),
(58135, 3262647808, 3262647823, 'DE', 'DEU', 'ألمانيا'),
(58136, 3262647824, 3262647863, 'NL', 'NLD', 'هولندا'),
(58137, 3262647864, 3262647871, 'DE', 'DEU', 'ألمانيا'),
(58138, 3262647872, 3262647895, 'NL', 'NLD', 'هولندا'),
(58139, 3262647896, 3262647903, 'DE', 'DEU', 'ألمانيا'),
(58140, 3262647904, 3262647959, 'NL', 'NLD', 'هولندا'),
(58141, 3262647960, 3262647967, 'DE', 'DEU', 'ألمانيا'),
(58142, 3262647968, 3262647983, 'NL', 'NLD', 'هولندا'),
(58143, 3262647984, 3262647991, 'DE', 'DEU', 'ألمانيا'),
(58144, 3262647992, 3262648255, 'NL', 'NLD', 'هولندا'),
(58145, 3262648256, 3262648271, 'DE', 'DEU', 'ألمانيا'),
(58146, 3262648272, 3262648319, 'NL', 'NLD', 'هولندا'),
(58147, 3262648320, 3262650623, 'DE', 'DEU', 'ألمانيا'),
(58148, 3262650624, 3262650663, 'NL', 'NLD', 'هولندا'),
(58149, 3262650664, 3262650671, 'DE', 'DEU', 'ألمانيا'),
(58150, 3262650672, 3262650719, 'NL', 'NLD', 'هولندا'),
(58151, 3262650720, 3262650727, 'DE', 'DEU', 'ألمانيا'),
(58152, 3262650728, 3262650807, 'NL', 'NLD', 'هولندا'),
(58153, 3262650808, 3262650815, 'DE', 'DEU', 'ألمانيا'),
(58154, 3262650816, 3262650823, 'NL', 'NLD', 'هولندا'),
(58155, 3262650824, 3262650831, 'DE', 'DEU', 'ألمانيا'),
(58156, 3262650832, 3262650871, 'NL', 'NLD', 'هولندا'),
(58157, 3262650872, 3262650879, 'DE', 'DEU', 'ألمانيا'),
(58158, 3262650880, 3262650895, 'NL', 'NLD', 'هولندا'),
(58159, 3262650896, 3262650903, 'DE', 'DEU', 'ألمانيا'),
(58160, 3262650904, 3262650943, 'NL', 'NLD', 'هولندا'),
(58161, 3262650944, 3262650951, 'DE', 'DEU', 'ألمانيا'),
(58162, 3262650952, 3262650999, 'NL', 'NLD', 'هولندا'),
(58163, 3262651000, 3262651007, 'DE', 'DEU', 'ألمانيا'),
(58164, 3262651008, 3262651039, 'NL', 'NLD', 'هولندا'),
(58165, 3262651040, 3262651047, 'DE', 'DEU', 'ألمانيا'),
(58166, 3262651048, 3262651079, 'NL', 'NLD', 'هولندا'),
(58167, 3262651080, 3262651095, 'DE', 'DEU', 'ألمانيا'),
(58168, 3262651096, 3262651103, 'NL', 'NLD', 'هولندا'),
(58169, 3262651104, 3262651119, 'DE', 'DEU', 'ألمانيا'),
(58170, 3262651120, 3262651231, 'NL', 'NLD', 'هولندا'),
(58171, 3262651232, 3262651247, 'DE', 'DEU', 'ألمانيا'),
(58172, 3262651248, 3262651279, 'NL', 'NLD', 'هولندا'),
(58173, 3262651280, 3262651287, 'DE', 'DEU', 'ألمانيا'),
(58174, 3262651288, 3262651367, 'NL', 'NLD', 'هولندا'),
(58175, 3262651368, 3262651375, 'DE', 'DEU', 'ألمانيا'),
(58176, 3262651376, 3262651431, 'NL', 'NLD', 'هولندا'),
(58177, 3262651432, 3262651439, 'DE', 'DEU', 'ألمانيا'),
(58178, 3262651440, 3262651447, 'NL', 'NLD', 'هولندا'),
(58179, 3262651448, 3262651455, 'DE', 'DEU', 'ألمانيا'),
(58180, 3262651456, 3262651463, 'NL', 'NLD', 'هولندا'),
(58181, 3262651464, 3262651471, 'DE', 'DEU', 'ألمانيا'),
(58182, 3262651472, 3262651567, 'NL', 'NLD', 'هولندا'),
(58183, 3262651568, 3262651583, 'DE', 'DEU', 'ألمانيا'),
(58184, 3262651584, 3262651759, 'NL', 'NLD', 'هولندا'),
(58185, 3262651760, 3262651775, 'DE', 'DEU', 'ألمانيا'),
(58186, 3262651776, 3262651919, 'NL', 'NLD', 'هولندا'),
(58187, 3262651920, 3262651943, 'DE', 'DEU', 'ألمانيا'),
(58188, 3262651944, 3262651959, 'NL', 'NLD', 'هولندا'),
(58189, 3262651960, 3262651967, 'DE', 'DEU', 'ألمانيا'),
(58190, 3262651968, 3262651983, 'NL', 'NLD', 'هولندا'),
(58191, 3262651984, 3262651991, 'DE', 'DEU', 'ألمانيا'),
(58192, 3262651992, 3262652015, 'NL', 'NLD', 'هولندا'),
(58193, 3262652016, 3262652031, 'DE', 'DEU', 'ألمانيا'),
(58194, 3262652032, 3262652087, 'NL', 'NLD', 'هولندا'),
(58195, 3262652088, 3262652095, 'DE', 'DEU', 'ألمانيا'),
(58196, 3262652096, 3262652159, 'NL', 'NLD', 'هولندا'),
(58197, 3262652160, 3262652167, 'DE', 'DEU', 'ألمانيا'),
(58198, 3262652168, 3262652295, 'NL', 'NLD', 'هولندا'),
(58199, 3262652296, 3262652303, 'DE', 'DEU', 'ألمانيا'),
(58200, 3262652304, 3262652343, 'NL', 'NLD', 'هولندا'),
(58201, 3262652344, 3262652351, 'DE', 'DEU', 'ألمانيا'),
(58202, 3262652352, 3262652543, 'NL', 'NLD', 'هولندا'),
(58203, 3262652544, 3262652559, 'DE', 'DEU', 'ألمانيا'),
(58204, 3262652560, 3262652631, 'NL', 'NLD', 'هولندا'),
(58205, 3262652632, 3262652639, 'DE', 'DEU', 'ألمانيا'),
(58206, 3262652640, 3262652679, 'NL', 'NLD', 'هولندا'),
(58207, 3262652680, 3262652687, 'DE', 'DEU', 'ألمانيا'),
(58208, 3262652688, 3262652799, 'NL', 'NLD', 'هولندا'),
(58209, 3262652800, 3262652807, 'DE', 'DEU', 'ألمانيا'),
(58210, 3262652808, 3262652887, 'NL', 'NLD', 'هولندا'),
(58211, 3262652888, 3262652903, 'DE', 'DEU', 'ألمانيا'),
(58212, 3262652904, 3262652983, 'NL', 'NLD', 'هولندا'),
(58213, 3262652984, 3262652991, 'DE', 'DEU', 'ألمانيا'),
(58214, 3262652992, 3262653095, 'NL', 'NLD', 'هولندا'),
(58215, 3262653096, 3262653103, 'DE', 'DEU', 'ألمانيا'),
(58216, 3262653104, 3262653111, 'NL', 'NLD', 'هولندا'),
(58217, 3262653112, 3262653119, 'DE', 'DEU', 'ألمانيا'),
(58218, 3262653120, 3262653223, 'NL', 'NLD', 'هولندا'),
(58219, 3262653224, 3262653231, 'DE', 'DEU', 'ألمانيا'),
(58220, 3262653232, 3262653311, 'NL', 'NLD', 'هولندا'),
(58221, 3262653312, 3262653319, 'DE', 'DEU', 'ألمانيا'),
(58222, 3262653320, 3262653343, 'NL', 'NLD', 'هولندا'),
(58223, 3262653344, 3262653351, 'DE', 'DEU', 'ألمانيا'),
(58224, 3262653352, 3262653391, 'NL', 'NLD', 'هولندا'),
(58225, 3262653392, 3262653399, 'DE', 'DEU', 'ألمانيا'),
(58226, 3262653400, 3262653423, 'NL', 'NLD', 'هولندا'),
(58227, 3262653424, 3262653431, 'DE', 'DEU', 'ألمانيا'),
(58228, 3262653432, 3262653439, 'NL', 'NLD', 'هولندا'),
(58229, 3262653440, 3262653447, 'DE', 'DEU', 'ألمانيا'),
(58230, 3262653448, 3262653727, 'NL', 'NLD', 'هولندا'),
(58231, 3262653728, 3262653735, 'DE', 'DEU', 'ألمانيا'),
(58232, 3262653736, 3262653807, 'NL', 'NLD', 'هولندا'),
(58233, 3262653808, 3262653815, 'DE', 'DEU', 'ألمانيا'),
(58234, 3262653816, 3262653823, 'NL', 'NLD', 'هولندا'),
(58235, 3262653824, 3262653831, 'DE', 'DEU', 'ألمانيا'),
(58236, 3262653832, 3262653863, 'NL', 'NLD', 'هولندا'),
(58237, 3262653864, 3262653871, 'DE', 'DEU', 'ألمانيا'),
(58238, 3262653872, 3262653975, 'NL', 'NLD', 'هولندا'),
(58239, 3262653976, 3262653983, 'DE', 'DEU', 'ألمانيا'),
(58240, 3262653984, 3262654111, 'NL', 'NLD', 'هولندا'),
(58241, 3262654112, 3262654119, 'DE', 'DEU', 'ألمانيا'),
(58242, 3262654120, 3262654207, 'NL', 'NLD', 'هولندا'),
(58243, 3262654208, 3262654215, 'DE', 'DEU', 'ألمانيا'),
(58244, 3262654216, 3262654407, 'NL', 'NLD', 'هولندا'),
(58245, 3262654408, 3262654415, 'DE', 'DEU', 'ألمانيا'),
(58246, 3262654416, 3262654463, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(58247, 3262654464, 3262655487, 'DE', 'DEU', 'ألمانيا'),
(58248, 3262655488, 3262655607, 'NL', 'NLD', 'هولندا'),
(58249, 3262655608, 3262655623, 'DE', 'DEU', 'ألمانيا'),
(58250, 3262655624, 3262655695, 'NL', 'NLD', 'هولندا'),
(58251, 3262655696, 3262655703, 'DE', 'DEU', 'ألمانيا'),
(58252, 3262655704, 3262656135, 'NL', 'NLD', 'هولندا'),
(58253, 3262656136, 3262656143, 'DE', 'DEU', 'ألمانيا'),
(58254, 3262656144, 3262656335, 'NL', 'NLD', 'هولندا'),
(58255, 3262656336, 3262656343, 'DE', 'DEU', 'ألمانيا'),
(58256, 3262656344, 3262656391, 'NL', 'NLD', 'هولندا'),
(58257, 3262656392, 3262656399, 'DE', 'DEU', 'ألمانيا'),
(58258, 3262656400, 3262656423, 'NL', 'NLD', 'هولندا'),
(58259, 3262656424, 3262656431, 'DE', 'DEU', 'ألمانيا'),
(58260, 3262656432, 3262656511, 'NL', 'NLD', 'هولندا'),
(58261, 3262656512, 3262656527, 'DE', 'DEU', 'ألمانيا'),
(58262, 3262656528, 3262656743, 'NL', 'NLD', 'هولندا'),
(58263, 3262656744, 3262656751, 'DE', 'DEU', 'ألمانيا'),
(58264, 3262656752, 3262656767, 'NL', 'NLD', 'هولندا'),
(58265, 3262656768, 3262656775, 'DE', 'DEU', 'ألمانيا'),
(58266, 3262656776, 3262656863, 'NL', 'NLD', 'هولندا'),
(58267, 3262656864, 3262656871, 'DE', 'DEU', 'ألمانيا'),
(58268, 3262656872, 3262656879, 'NL', 'NLD', 'هولندا'),
(58269, 3262656880, 3262656887, 'DE', 'DEU', 'ألمانيا'),
(58270, 3262656888, 3262657039, 'NL', 'NLD', 'هولندا'),
(58271, 3262657040, 3262657047, 'DE', 'DEU', 'ألمانيا'),
(58272, 3262657048, 3262657495, 'NL', 'NLD', 'هولندا'),
(58273, 3262657496, 3262657503, 'DE', 'DEU', 'ألمانيا'),
(58274, 3262657504, 3262657519, 'NL', 'NLD', 'هولندا'),
(58275, 3262657520, 3262657535, 'DE', 'DEU', 'ألمانيا'),
(58276, 3262657536, 3262657543, 'NL', 'NLD', 'هولندا'),
(58277, 3262657544, 3262657551, 'DE', 'DEU', 'ألمانيا'),
(58278, 3262657552, 3262657599, 'NL', 'NLD', 'هولندا'),
(58279, 3262657600, 3262657607, 'DE', 'DEU', 'ألمانيا'),
(58280, 3262657608, 3262657719, 'NL', 'NLD', 'هولندا'),
(58281, 3262657720, 3262657727, 'DE', 'DEU', 'ألمانيا'),
(58282, 3262657728, 3262657855, 'NL', 'NLD', 'هولندا'),
(58283, 3262657856, 3262657863, 'DE', 'DEU', 'ألمانيا'),
(58284, 3262657864, 3262657871, 'NL', 'NLD', 'هولندا'),
(58285, 3262657872, 3262657879, 'DE', 'DEU', 'ألمانيا'),
(58286, 3262657880, 3262657903, 'NL', 'NLD', 'هولندا'),
(58287, 3262657904, 3262657911, 'DE', 'DEU', 'ألمانيا'),
(58288, 3262657912, 3262657919, 'NL', 'NLD', 'هولندا'),
(58289, 3262657920, 3262657927, 'DE', 'DEU', 'ألمانيا'),
(58290, 3262657928, 3262658015, 'NL', 'NLD', 'هولندا'),
(58291, 3262658016, 3262658023, 'DE', 'DEU', 'ألمانيا'),
(58292, 3262658024, 3262658031, 'NL', 'NLD', 'هولندا'),
(58293, 3262658032, 3262658039, 'DE', 'DEU', 'ألمانيا'),
(58294, 3262658040, 3262658183, 'NL', 'NLD', 'هولندا'),
(58295, 3262658184, 3262658191, 'DE', 'DEU', 'ألمانيا'),
(58296, 3262658192, 3262658303, 'NL', 'NLD', 'هولندا'),
(58297, 3262658304, 3262658559, 'DE', 'DEU', 'ألمانيا'),
(58298, 3262658560, 3262658623, 'NL', 'NLD', 'هولندا'),
(58299, 3262658624, 3262658631, 'DE', 'DEU', 'ألمانيا'),
(58300, 3262658632, 3262658975, 'NL', 'NLD', 'هولندا'),
(58301, 3262658976, 3262658991, 'DE', 'DEU', 'ألمانيا'),
(58302, 3262658992, 3262658999, 'NL', 'NLD', 'هولندا'),
(58303, 3262659000, 3262659007, 'DE', 'DEU', 'ألمانيا'),
(58304, 3262659008, 3262659039, 'NL', 'NLD', 'هولندا'),
(58305, 3262659040, 3262659047, 'DE', 'DEU', 'ألمانيا'),
(58306, 3262659048, 3262659103, 'NL', 'NLD', 'هولندا'),
(58307, 3262659104, 3262659111, 'DE', 'DEU', 'ألمانيا'),
(58308, 3262659112, 3262659175, 'NL', 'NLD', 'هولندا'),
(58309, 3262659176, 3262659183, 'DE', 'DEU', 'ألمانيا'),
(58310, 3262659184, 3262659191, 'NL', 'NLD', 'هولندا'),
(58311, 3262659192, 3262659207, 'DE', 'DEU', 'ألمانيا'),
(58312, 3262659208, 3262659303, 'NL', 'NLD', 'هولندا'),
(58313, 3262659304, 3262659311, 'DE', 'DEU', 'ألمانيا'),
(58314, 3262659312, 3262659327, 'NL', 'NLD', 'هولندا'),
(58315, 3262659328, 3262659343, 'DE', 'DEU', 'ألمانيا'),
(58316, 3262659344, 3262659375, 'NL', 'NLD', 'هولندا'),
(58317, 3262659376, 3262659383, 'DE', 'DEU', 'ألمانيا'),
(58318, 3262659384, 3262659463, 'NL', 'NLD', 'هولندا'),
(58319, 3262659464, 3262659471, 'DE', 'DEU', 'ألمانيا'),
(58320, 3262659472, 3262659503, 'NL', 'NLD', 'هولندا'),
(58321, 3262659504, 3262659511, 'DE', 'DEU', 'ألمانيا'),
(58322, 3262659512, 3262659551, 'NL', 'NLD', 'هولندا'),
(58323, 3262659552, 3262659559, 'DE', 'DEU', 'ألمانيا'),
(58324, 3262659560, 3262659615, 'NL', 'NLD', 'هولندا'),
(58325, 3262659616, 3262659623, 'DE', 'DEU', 'ألمانيا'),
(58326, 3262659624, 3262659631, 'NL', 'NLD', 'هولندا'),
(58327, 3262659632, 3262659639, 'DE', 'DEU', 'ألمانيا'),
(58328, 3262659640, 3262659647, 'NL', 'NLD', 'هولندا'),
(58329, 3262659648, 3262659655, 'DE', 'DEU', 'ألمانيا'),
(58330, 3262659656, 3262659679, 'NL', 'NLD', 'هولندا'),
(58331, 3262659680, 3262659695, 'DE', 'DEU', 'ألمانيا'),
(58332, 3262659696, 3262659711, 'NL', 'NLD', 'هولندا'),
(58333, 3262659712, 3262659735, 'DE', 'DEU', 'ألمانيا'),
(58334, 3262659736, 3262659807, 'NL', 'NLD', 'هولندا'),
(58335, 3262659808, 3262659815, 'DE', 'DEU', 'ألمانيا'),
(58336, 3262659816, 3262659911, 'NL', 'NLD', 'هولندا'),
(58337, 3262659912, 3262659919, 'DE', 'DEU', 'ألمانيا'),
(58338, 3262659920, 3262659951, 'NL', 'NLD', 'هولندا'),
(58339, 3262659952, 3262659959, 'DE', 'DEU', 'ألمانيا'),
(58340, 3262659960, 3262660215, 'NL', 'NLD', 'هولندا'),
(58341, 3262660216, 3262660223, 'DE', 'DEU', 'ألمانيا'),
(58342, 3262660224, 3262660279, 'NL', 'NLD', 'هولندا'),
(58343, 3262660280, 3262660287, 'DE', 'DEU', 'ألمانيا'),
(58344, 3262660288, 3262660311, 'NL', 'NLD', 'هولندا'),
(58345, 3262660312, 3262660319, 'DE', 'DEU', 'ألمانيا'),
(58346, 3262660320, 3262660399, 'NL', 'NLD', 'هولندا'),
(58347, 3262660400, 3262660415, 'DE', 'DEU', 'ألمانيا'),
(58348, 3262660416, 3262660471, 'NL', 'NLD', 'هولندا'),
(58349, 3262660472, 3262660487, 'DE', 'DEU', 'ألمانيا'),
(58350, 3262660488, 3262660535, 'NL', 'NLD', 'هولندا'),
(58351, 3262660536, 3262660543, 'DE', 'DEU', 'ألمانيا'),
(58352, 3262660544, 3262660719, 'NL', 'NLD', 'هولندا'),
(58353, 3262660720, 3262660727, 'DE', 'DEU', 'ألمانيا'),
(58354, 3262660728, 3262660775, 'NL', 'NLD', 'هولندا'),
(58355, 3262660776, 3262660783, 'DE', 'DEU', 'ألمانيا'),
(58356, 3262660784, 3262660791, 'NL', 'NLD', 'هولندا'),
(58357, 3262660792, 3262660799, 'DE', 'DEU', 'ألمانيا'),
(58358, 3262660800, 3262660871, 'NL', 'NLD', 'هولندا'),
(58359, 3262660872, 3262660879, 'DE', 'DEU', 'ألمانيا'),
(58360, 3262660880, 3262660903, 'NL', 'NLD', 'هولندا'),
(58361, 3262660904, 3262660911, 'DE', 'DEU', 'ألمانيا'),
(58362, 3262660912, 3262661039, 'NL', 'NLD', 'هولندا'),
(58363, 3262661040, 3262661047, 'DE', 'DEU', 'ألمانيا'),
(58364, 3262661048, 3262661063, 'NL', 'NLD', 'هولندا'),
(58365, 3262661064, 3262661087, 'DE', 'DEU', 'ألمانيا'),
(58366, 3262661088, 3262661119, 'NL', 'NLD', 'هولندا'),
(58367, 3262661120, 3262661375, 'DE', 'DEU', 'ألمانيا'),
(58368, 3262661376, 3262661447, 'NL', 'NLD', 'هولندا'),
(58369, 3262661448, 3262661455, 'DE', 'DEU', 'ألمانيا'),
(58370, 3262661456, 3262661527, 'NL', 'NLD', 'هولندا'),
(58371, 3262661528, 3262661535, 'DE', 'DEU', 'ألمانيا'),
(58372, 3262661536, 3262661543, 'NL', 'NLD', 'هولندا'),
(58373, 3262661544, 3262661551, 'DE', 'DEU', 'ألمانيا'),
(58374, 3262661552, 3262661575, 'NL', 'NLD', 'هولندا'),
(58375, 3262661576, 3262661583, 'DE', 'DEU', 'ألمانيا'),
(58376, 3262661584, 3262661607, 'NL', 'NLD', 'هولندا'),
(58377, 3262661608, 3262661615, 'DE', 'DEU', 'ألمانيا'),
(58378, 3262661616, 3262661663, 'NL', 'NLD', 'هولندا'),
(58379, 3262661664, 3262661671, 'DE', 'DEU', 'ألمانيا'),
(58380, 3262661672, 3262661719, 'NL', 'NLD', 'هولندا'),
(58381, 3262661720, 3262661727, 'DE', 'DEU', 'ألمانيا'),
(58382, 3262661728, 3262661743, 'NL', 'NLD', 'هولندا'),
(58383, 3262661744, 3262661751, 'DE', 'DEU', 'ألمانيا'),
(58384, 3262661752, 3262661775, 'NL', 'NLD', 'هولندا'),
(58385, 3262661776, 3262661783, 'DE', 'DEU', 'ألمانيا'),
(58386, 3262661784, 3262661807, 'NL', 'NLD', 'هولندا'),
(58387, 3262661808, 3262661815, 'DE', 'DEU', 'ألمانيا'),
(58388, 3262661816, 3262661831, 'NL', 'NLD', 'هولندا'),
(58389, 3262661832, 3262661839, 'DE', 'DEU', 'ألمانيا'),
(58390, 3262661840, 3262661847, 'NL', 'NLD', 'هولندا'),
(58391, 3262661848, 3262661855, 'DE', 'DEU', 'ألمانيا'),
(58392, 3262661856, 3262661895, 'NL', 'NLD', 'هولندا'),
(58393, 3262661896, 3262661903, 'DE', 'DEU', 'ألمانيا'),
(58394, 3262661904, 3262661975, 'NL', 'NLD', 'هولندا'),
(58395, 3262661976, 3262661983, 'DE', 'DEU', 'ألمانيا'),
(58396, 3262661984, 3262662023, 'NL', 'NLD', 'هولندا'),
(58397, 3262662024, 3262662031, 'DE', 'DEU', 'ألمانيا'),
(58398, 3262662032, 3262662087, 'NL', 'NLD', 'هولندا'),
(58399, 3262662088, 3262662095, 'DE', 'DEU', 'ألمانيا'),
(58400, 3262662096, 3262662167, 'NL', 'NLD', 'هولندا'),
(58401, 3262662168, 3262662175, 'DE', 'DEU', 'ألمانيا'),
(58402, 3262662176, 3262662223, 'NL', 'NLD', 'هولندا'),
(58403, 3262662224, 3262662231, 'DE', 'DEU', 'ألمانيا'),
(58404, 3262662232, 3262662335, 'NL', 'NLD', 'هولندا'),
(58405, 3262662336, 3262662343, 'DE', 'DEU', 'ألمانيا'),
(58406, 3262662344, 3262662567, 'NL', 'NLD', 'هولندا'),
(58407, 3262662568, 3262662575, 'DE', 'DEU', 'ألمانيا'),
(58408, 3262662576, 3262662607, 'NL', 'NLD', 'هولندا'),
(58409, 3262662608, 3262662615, 'DE', 'DEU', 'ألمانيا'),
(58410, 3262662616, 3262662623, 'NL', 'NLD', 'هولندا'),
(58411, 3262662624, 3262662631, 'DE', 'DEU', 'ألمانيا'),
(58412, 3262662632, 3262662655, 'NL', 'NLD', 'هولندا'),
(58413, 3262662656, 3262662663, 'DE', 'DEU', 'ألمانيا'),
(58414, 3262662664, 3262662775, 'NL', 'NLD', 'هولندا'),
(58415, 3262662776, 3262662783, 'DE', 'DEU', 'ألمانيا'),
(58416, 3262662784, 3262662935, 'NL', 'NLD', 'هولندا'),
(58417, 3262662936, 3262662943, 'DE', 'DEU', 'ألمانيا'),
(58418, 3262662944, 3262663119, 'NL', 'NLD', 'هولندا'),
(58419, 3262663120, 3262663127, 'DE', 'DEU', 'ألمانيا'),
(58420, 3262663128, 3262663191, 'NL', 'NLD', 'هولندا'),
(58421, 3262663192, 3262663199, 'DE', 'DEU', 'ألمانيا'),
(58422, 3262663200, 3262663223, 'NL', 'NLD', 'هولندا'),
(58423, 3262663224, 3262663231, 'DE', 'DEU', 'ألمانيا'),
(58424, 3262663232, 3262663295, 'NL', 'NLD', 'هولندا'),
(58425, 3262663296, 3262663303, 'DE', 'DEU', 'ألمانيا'),
(58426, 3262663304, 3262663327, 'NL', 'NLD', 'هولندا'),
(58427, 3262663328, 3262663335, 'DE', 'DEU', 'ألمانيا'),
(58428, 3262663336, 3262663503, 'NL', 'NLD', 'هولندا'),
(58429, 3262663504, 3262663511, 'DE', 'DEU', 'ألمانيا'),
(58430, 3262663512, 3262663591, 'NL', 'NLD', 'هولندا'),
(58431, 3262663592, 3262663599, 'DE', 'DEU', 'ألمانيا'),
(58432, 3262663600, 3262663831, 'NL', 'NLD', 'هولندا'),
(58433, 3262663832, 3262663839, 'DE', 'DEU', 'ألمانيا'),
(58434, 3262663840, 3262663847, 'NL', 'NLD', 'هولندا'),
(58435, 3262663848, 3262663855, 'DE', 'DEU', 'ألمانيا'),
(58436, 3262663856, 3262664015, 'NL', 'NLD', 'هولندا'),
(58437, 3262664016, 3262664023, 'DE', 'DEU', 'ألمانيا'),
(58438, 3262664024, 3262664063, 'NL', 'NLD', 'هولندا'),
(58439, 3262664064, 3262664071, 'DE', 'DEU', 'ألمانيا'),
(58440, 3262664072, 3262664311, 'NL', 'NLD', 'هولندا'),
(58441, 3262664312, 3262664319, 'DE', 'DEU', 'ألمانيا'),
(58442, 3262664320, 3262664343, 'NL', 'NLD', 'هولندا'),
(58443, 3262664344, 3262664359, 'DE', 'DEU', 'ألمانيا'),
(58444, 3262664360, 3262664399, 'NL', 'NLD', 'هولندا'),
(58445, 3262664400, 3262664407, 'DE', 'DEU', 'ألمانيا'),
(58446, 3262664408, 3262664463, 'NL', 'NLD', 'هولندا'),
(58447, 3262664464, 3262664471, 'DE', 'DEU', 'ألمانيا'),
(58448, 3262664472, 3262664559, 'NL', 'NLD', 'هولندا'),
(58449, 3262664560, 3262664567, 'DE', 'DEU', 'ألمانيا'),
(58450, 3262664568, 3262664599, 'NL', 'NLD', 'هولندا'),
(58451, 3262664600, 3262664607, 'DE', 'DEU', 'ألمانيا'),
(58452, 3262664608, 3262664615, 'NL', 'NLD', 'هولندا'),
(58453, 3262664616, 3262664631, 'DE', 'DEU', 'ألمانيا'),
(58454, 3262664632, 3262664703, 'NL', 'NLD', 'هولندا'),
(58455, 3262664704, 3262678527, 'DE', 'DEU', 'ألمانيا'),
(58456, 3262678528, 3262678559, 'NL', 'NLD', 'هولندا'),
(58457, 3262678560, 3262678567, 'DE', 'DEU', 'ألمانيا'),
(58458, 3262678568, 3262678743, 'NL', 'NLD', 'هولندا'),
(58459, 3262678744, 3262678751, 'DE', 'DEU', 'ألمانيا'),
(58460, 3262678752, 3262678791, 'NL', 'NLD', 'هولندا'),
(58461, 3262678792, 3262678799, 'DE', 'DEU', 'ألمانيا'),
(58462, 3262678800, 3262678991, 'NL', 'NLD', 'هولندا'),
(58463, 3262678992, 3262678999, 'DE', 'DEU', 'ألمانيا'),
(58464, 3262679000, 3262679151, 'NL', 'NLD', 'هولندا'),
(58465, 3262679152, 3262679167, 'DE', 'DEU', 'ألمانيا'),
(58466, 3262679168, 3262679175, 'NL', 'NLD', 'هولندا'),
(58467, 3262679176, 3262679183, 'DE', 'DEU', 'ألمانيا'),
(58468, 3262679184, 3262679215, 'NL', 'NLD', 'هولندا'),
(58469, 3262679216, 3262679223, 'DE', 'DEU', 'ألمانيا'),
(58470, 3262679224, 3262679231, 'NL', 'NLD', 'هولندا'),
(58471, 3262679232, 3262679239, 'DE', 'DEU', 'ألمانيا'),
(58472, 3262679240, 3262679263, 'NL', 'NLD', 'هولندا'),
(58473, 3262679264, 3262679287, 'DE', 'DEU', 'ألمانيا'),
(58474, 3262679288, 3262679311, 'NL', 'NLD', 'هولندا'),
(58475, 3262679312, 3262679319, 'DE', 'DEU', 'ألمانيا'),
(58476, 3262679320, 3262679327, 'NL', 'NLD', 'هولندا'),
(58477, 3262679328, 3262679335, 'DE', 'DEU', 'ألمانيا'),
(58478, 3262679336, 3262679423, 'NL', 'NLD', 'هولندا'),
(58479, 3262679424, 3262679431, 'DE', 'DEU', 'ألمانيا'),
(58480, 3262679432, 3262679471, 'NL', 'NLD', 'هولندا'),
(58481, 3262679472, 3262679479, 'DE', 'DEU', 'ألمانيا'),
(58482, 3262679480, 3262679759, 'NL', 'NLD', 'هولندا'),
(58483, 3262679760, 3262679767, 'DE', 'DEU', 'ألمانيا'),
(58484, 3262679768, 3262679839, 'NL', 'NLD', 'هولندا'),
(58485, 3262679840, 3262679847, 'DE', 'DEU', 'ألمانيا'),
(58486, 3262679848, 3262680143, 'NL', 'NLD', 'هولندا'),
(58487, 3262680144, 3262680151, 'DE', 'DEU', 'ألمانيا'),
(58488, 3262680152, 3262680199, 'NL', 'NLD', 'هولندا'),
(58489, 3262680200, 3262680215, 'DE', 'DEU', 'ألمانيا'),
(58490, 3262680216, 3262680303, 'NL', 'NLD', 'هولندا'),
(58491, 3262680304, 3262680319, 'DE', 'DEU', 'ألمانيا'),
(58492, 3262680320, 3262680335, 'NL', 'NLD', 'هولندا'),
(58493, 3262680336, 3262680343, 'DE', 'DEU', 'ألمانيا'),
(58494, 3262680344, 3262680375, 'NL', 'NLD', 'هولندا'),
(58495, 3262680376, 3262680383, 'DE', 'DEU', 'ألمانيا'),
(58496, 3262680384, 3262680399, 'NL', 'NLD', 'هولندا'),
(58497, 3262680400, 3262680407, 'DE', 'DEU', 'ألمانيا'),
(58498, 3262680408, 3262680495, 'NL', 'NLD', 'هولندا'),
(58499, 3262680496, 3262680503, 'DE', 'DEU', 'ألمانيا'),
(58500, 3262680504, 3262680607, 'NL', 'NLD', 'هولندا'),
(58501, 3262680608, 3262680615, 'DE', 'DEU', 'ألمانيا'),
(58502, 3262680616, 3262680647, 'NL', 'NLD', 'هولندا'),
(58503, 3262680648, 3262680663, 'DE', 'DEU', 'ألمانيا'),
(58504, 3262680664, 3262680695, 'NL', 'NLD', 'هولندا'),
(58505, 3262680696, 3262680703, 'DE', 'DEU', 'ألمانيا'),
(58506, 3262680704, 3262680743, 'NL', 'NLD', 'هولندا'),
(58507, 3262680744, 3262680751, 'DE', 'DEU', 'ألمانيا'),
(58508, 3262680752, 3262680807, 'NL', 'NLD', 'هولندا'),
(58509, 3262680808, 3262680815, 'DE', 'DEU', 'ألمانيا'),
(58510, 3262680816, 3262680831, 'NL', 'NLD', 'هولندا'),
(58511, 3262680832, 3262680839, 'DE', 'DEU', 'ألمانيا'),
(58512, 3262680840, 3262681087, 'NL', 'NLD', 'هولندا'),
(58513, 3262681088, 3262682879, 'DE', 'DEU', 'ألمانيا'),
(58514, 3262682880, 3262682887, 'NL', 'NLD', 'هولندا'),
(58515, 3262682888, 3262682895, 'DE', 'DEU', 'ألمانيا'),
(58516, 3262682896, 3262682903, 'NL', 'NLD', 'هولندا'),
(58517, 3262682904, 3262682911, 'DE', 'DEU', 'ألمانيا'),
(58518, 3262682912, 3262683063, 'NL', 'NLD', 'هولندا'),
(58519, 3262683064, 3262683071, 'DE', 'DEU', 'ألمانيا'),
(58520, 3262683072, 3262683255, 'NL', 'NLD', 'هولندا'),
(58521, 3262683256, 3262683263, 'DE', 'DEU', 'ألمانيا'),
(58522, 3262683264, 3262683303, 'NL', 'NLD', 'هولندا'),
(58523, 3262683304, 3262683311, 'DE', 'DEU', 'ألمانيا'),
(58524, 3262683312, 3262683447, 'NL', 'NLD', 'هولندا'),
(58525, 3262683448, 3262683455, 'DE', 'DEU', 'ألمانيا'),
(58526, 3262683456, 3262683471, 'NL', 'NLD', 'هولندا'),
(58527, 3262683472, 3262683479, 'DE', 'DEU', 'ألمانيا'),
(58528, 3262683480, 3262683687, 'NL', 'NLD', 'هولندا'),
(58529, 3262683688, 3262683695, 'DE', 'DEU', 'ألمانيا'),
(58530, 3262683696, 3262683711, 'NL', 'NLD', 'هولندا'),
(58531, 3262683712, 3262683719, 'DE', 'DEU', 'ألمانيا'),
(58532, 3262683720, 3262683743, 'NL', 'NLD', 'هولندا'),
(58533, 3262683744, 3262683751, 'DE', 'DEU', 'ألمانيا'),
(58534, 3262683752, 3262683815, 'NL', 'NLD', 'هولندا'),
(58535, 3262683816, 3262683831, 'DE', 'DEU', 'ألمانيا'),
(58536, 3262683832, 3262683871, 'NL', 'NLD', 'هولندا'),
(58537, 3262683872, 3262683879, 'DE', 'DEU', 'ألمانيا'),
(58538, 3262683880, 3262683999, 'NL', 'NLD', 'هولندا'),
(58539, 3262684000, 3262684007, 'DE', 'DEU', 'ألمانيا'),
(58540, 3262684008, 3262684015, 'NL', 'NLD', 'هولندا'),
(58541, 3262684016, 3262684023, 'DE', 'DEU', 'ألمانيا'),
(58542, 3262684024, 3262684271, 'NL', 'NLD', 'هولندا'),
(58543, 3262684272, 3262684279, 'DE', 'DEU', 'ألمانيا'),
(58544, 3262684280, 3262684367, 'NL', 'NLD', 'هولندا'),
(58545, 3262684368, 3262684375, 'DE', 'DEU', 'ألمانيا'),
(58546, 3262684376, 3262684383, 'NL', 'NLD', 'هولندا'),
(58547, 3262684384, 3262684399, 'DE', 'DEU', 'ألمانيا'),
(58548, 3262684400, 3262684487, 'NL', 'NLD', 'هولندا'),
(58549, 3262684488, 3262684495, 'DE', 'DEU', 'ألمانيا'),
(58550, 3262684496, 3262684511, 'NL', 'NLD', 'هولندا'),
(58551, 3262684512, 3262684519, 'DE', 'DEU', 'ألمانيا'),
(58552, 3262684520, 3262684591, 'NL', 'NLD', 'هولندا'),
(58553, 3262684592, 3262684607, 'DE', 'DEU', 'ألمانيا'),
(58554, 3262684608, 3262684615, 'NL', 'NLD', 'هولندا'),
(58555, 3262684616, 3262684623, 'DE', 'DEU', 'ألمانيا'),
(58556, 3262684624, 3262684679, 'NL', 'NLD', 'هولندا'),
(58557, 3262684680, 3262684687, 'DE', 'DEU', 'ألمانيا'),
(58558, 3262684688, 3262684703, 'NL', 'NLD', 'هولندا'),
(58559, 3262684704, 3262684711, 'DE', 'DEU', 'ألمانيا'),
(58560, 3262684712, 3262684751, 'NL', 'NLD', 'هولندا'),
(58561, 3262684752, 3262684759, 'DE', 'DEU', 'ألمانيا'),
(58562, 3262684760, 3262684991, 'NL', 'NLD', 'هولندا'),
(58563, 3262684992, 3262684999, 'DE', 'DEU', 'ألمانيا'),
(58564, 3262685000, 3262685287, 'NL', 'NLD', 'هولندا'),
(58565, 3262685288, 3262685295, 'DE', 'DEU', 'ألمانيا'),
(58566, 3262685296, 3262685327, 'NL', 'NLD', 'هولندا'),
(58567, 3262685328, 3262685335, 'DE', 'DEU', 'ألمانيا'),
(58568, 3262685336, 3262685359, 'NL', 'NLD', 'هولندا'),
(58569, 3262685360, 3262685367, 'DE', 'DEU', 'ألمانيا'),
(58570, 3262685368, 3262685407, 'NL', 'NLD', 'هولندا'),
(58571, 3262685408, 3262685415, 'DE', 'DEU', 'ألمانيا'),
(58572, 3262685416, 3262685423, 'NL', 'NLD', 'هولندا'),
(58573, 3262685424, 3262685447, 'DE', 'DEU', 'ألمانيا'),
(58574, 3262685448, 3262685623, 'NL', 'NLD', 'هولندا'),
(58575, 3262685624, 3262685631, 'DE', 'DEU', 'ألمانيا'),
(58576, 3262685632, 3262685655, 'NL', 'NLD', 'هولندا'),
(58577, 3262685656, 3262685663, 'DE', 'DEU', 'ألمانيا'),
(58578, 3262685664, 3262685751, 'NL', 'NLD', 'هولندا'),
(58579, 3262685752, 3262685767, 'DE', 'DEU', 'ألمانيا'),
(58580, 3262685768, 3262685815, 'NL', 'NLD', 'هولندا'),
(58581, 3262685816, 3262685823, 'DE', 'DEU', 'ألمانيا'),
(58582, 3262685824, 3262685951, 'NL', 'NLD', 'هولندا'),
(58583, 3262685952, 3262688767, 'DE', 'DEU', 'ألمانيا'),
(58584, 3262688768, 3262688791, 'NL', 'NLD', 'هولندا'),
(58585, 3262688792, 3262688799, 'DE', 'DEU', 'ألمانيا'),
(58586, 3262688800, 3262688879, 'NL', 'NLD', 'هولندا'),
(58587, 3262688880, 3262688887, 'DE', 'DEU', 'ألمانيا'),
(58588, 3262688888, 3262689055, 'NL', 'NLD', 'هولندا'),
(58589, 3262689056, 3262689063, 'DE', 'DEU', 'ألمانيا'),
(58590, 3262689064, 3262689087, 'NL', 'NLD', 'هولندا'),
(58591, 3262689088, 3262689095, 'DE', 'DEU', 'ألمانيا'),
(58592, 3262689096, 3262689127, 'NL', 'NLD', 'هولندا'),
(58593, 3262689128, 3262689135, 'DE', 'DEU', 'ألمانيا'),
(58594, 3262689136, 3262689215, 'NL', 'NLD', 'هولندا'),
(58595, 3262689216, 3262689223, 'DE', 'DEU', 'ألمانيا'),
(58596, 3262689224, 3262689343, 'NL', 'NLD', 'هولندا'),
(58597, 3262689344, 3262689351, 'DE', 'DEU', 'ألمانيا'),
(58598, 3262689352, 3262689367, 'NL', 'NLD', 'هولندا'),
(58599, 3262689368, 3262689375, 'DE', 'DEU', 'ألمانيا'),
(58600, 3262689376, 3262689559, 'NL', 'NLD', 'هولندا'),
(58601, 3262689560, 3262689567, 'DE', 'DEU', 'ألمانيا'),
(58602, 3262689568, 3262689607, 'NL', 'NLD', 'هولندا'),
(58603, 3262689608, 3262689623, 'DE', 'DEU', 'ألمانيا'),
(58604, 3262689624, 3262689751, 'NL', 'NLD', 'هولندا'),
(58605, 3262689752, 3262689759, 'DE', 'DEU', 'ألمانيا'),
(58606, 3262689760, 3262689847, 'NL', 'NLD', 'هولندا'),
(58607, 3262689848, 3262689855, 'DE', 'DEU', 'ألمانيا'),
(58608, 3262689856, 3262689871, 'NL', 'NLD', 'هولندا'),
(58609, 3262689872, 3262689879, 'DE', 'DEU', 'ألمانيا'),
(58610, 3262689880, 3262689895, 'NL', 'NLD', 'هولندا'),
(58611, 3262689896, 3262689911, 'DE', 'DEU', 'ألمانيا'),
(58612, 3262689912, 3262689927, 'NL', 'NLD', 'هولندا'),
(58613, 3262689928, 3262689935, 'DE', 'DEU', 'ألمانيا'),
(58614, 3262689936, 3262689959, 'NL', 'NLD', 'هولندا'),
(58615, 3262689960, 3262689967, 'DE', 'DEU', 'ألمانيا'),
(58616, 3262689968, 3262689983, 'NL', 'NLD', 'هولندا'),
(58617, 3262689984, 3262689991, 'DE', 'DEU', 'ألمانيا'),
(58618, 3262689992, 3262690119, 'NL', 'NLD', 'هولندا'),
(58619, 3262690120, 3262690127, 'DE', 'DEU', 'ألمانيا'),
(58620, 3262690128, 3262690151, 'NL', 'NLD', 'هولندا'),
(58621, 3262690152, 3262690159, 'DE', 'DEU', 'ألمانيا'),
(58622, 3262690160, 3262690327, 'NL', 'NLD', 'هولندا'),
(58623, 3262690328, 3262690335, 'DE', 'DEU', 'ألمانيا'),
(58624, 3262690336, 3262690359, 'NL', 'NLD', 'هولندا'),
(58625, 3262690360, 3262690367, 'DE', 'DEU', 'ألمانيا'),
(58626, 3262690368, 3262690487, 'NL', 'NLD', 'هولندا'),
(58627, 3262690488, 3262690495, 'DE', 'DEU', 'ألمانيا'),
(58628, 3262690496, 3262690511, 'NL', 'NLD', 'هولندا'),
(58629, 3262690512, 3262690519, 'DE', 'DEU', 'ألمانيا'),
(58630, 3262690520, 3262690527, 'NL', 'NLD', 'هولندا'),
(58631, 3262690528, 3262690535, 'DE', 'DEU', 'ألمانيا'),
(58632, 3262690536, 3262690671, 'NL', 'NLD', 'هولندا'),
(58633, 3262690672, 3262690687, 'DE', 'DEU', 'ألمانيا'),
(58634, 3262690688, 3262690775, 'NL', 'NLD', 'هولندا'),
(58635, 3262690776, 3262690783, 'DE', 'DEU', 'ألمانيا'),
(58636, 3262690784, 3262690815, 'NL', 'NLD', 'هولندا'),
(58637, 3262690816, 3262704383, 'DE', 'DEU', 'ألمانيا'),
(58638, 3262704384, 3262704479, 'NL', 'NLD', 'هولندا'),
(58639, 3262704480, 3262704487, 'DE', 'DEU', 'ألمانيا'),
(58640, 3262704488, 3262704543, 'NL', 'NLD', 'هولندا'),
(58641, 3262704544, 3262704551, 'DE', 'DEU', 'ألمانيا'),
(58642, 3262704552, 3262704575, 'NL', 'NLD', 'هولندا'),
(58643, 3262704576, 3262704583, 'DE', 'DEU', 'ألمانيا'),
(58644, 3262704584, 3262704663, 'NL', 'NLD', 'هولندا'),
(58645, 3262704664, 3262704671, 'DE', 'DEU', 'ألمانيا'),
(58646, 3262704672, 3262704735, 'NL', 'NLD', 'هولندا'),
(58647, 3262704736, 3262704743, 'DE', 'DEU', 'ألمانيا'),
(58648, 3262704744, 3262704759, 'NL', 'NLD', 'هولندا'),
(58649, 3262704760, 3262704767, 'DE', 'DEU', 'ألمانيا'),
(58650, 3262704768, 3262704855, 'NL', 'NLD', 'هولندا'),
(58651, 3262704856, 3262704863, 'DE', 'DEU', 'ألمانيا'),
(58652, 3262704864, 3262705031, 'NL', 'NLD', 'هولندا'),
(58653, 3262705032, 3262705039, 'DE', 'DEU', 'ألمانيا'),
(58654, 3262705040, 3262705063, 'NL', 'NLD', 'هولندا'),
(58655, 3262705064, 3262705071, 'DE', 'DEU', 'ألمانيا'),
(58656, 3262705072, 3262705111, 'NL', 'NLD', 'هولندا'),
(58657, 3262705112, 3262705119, 'DE', 'DEU', 'ألمانيا'),
(58658, 3262705120, 3262705303, 'NL', 'NLD', 'هولندا'),
(58659, 3262705304, 3262705311, 'DE', 'DEU', 'ألمانيا'),
(58660, 3262705312, 3262705319, 'NL', 'NLD', 'هولندا'),
(58661, 3262705320, 3262705327, 'DE', 'DEU', 'ألمانيا'),
(58662, 3262705328, 3262705367, 'NL', 'NLD', 'هولندا'),
(58663, 3262705368, 3262705375, 'DE', 'DEU', 'ألمانيا'),
(58664, 3262705376, 3262705639, 'NL', 'NLD', 'هولندا'),
(58665, 3262705640, 3262705647, 'DE', 'DEU', 'ألمانيا'),
(58666, 3262705648, 3262705695, 'NL', 'NLD', 'هولندا'),
(58667, 3262705696, 3262705703, 'DE', 'DEU', 'ألمانيا'),
(58668, 3262705704, 3262705759, 'NL', 'NLD', 'هولندا'),
(58669, 3262705760, 3262705767, 'DE', 'DEU', 'ألمانيا'),
(58670, 3262705768, 3262705799, 'NL', 'NLD', 'هولندا'),
(58671, 3262705800, 3262705807, 'DE', 'DEU', 'ألمانيا'),
(58672, 3262705808, 3262705831, 'NL', 'NLD', 'هولندا'),
(58673, 3262705832, 3262705839, 'DE', 'DEU', 'ألمانيا'),
(58674, 3262705840, 3262706031, 'NL', 'NLD', 'هولندا'),
(58675, 3262706032, 3262706039, 'DE', 'DEU', 'ألمانيا'),
(58676, 3262706040, 3262706127, 'NL', 'NLD', 'هولندا'),
(58677, 3262706128, 3262706143, 'DE', 'DEU', 'ألمانيا'),
(58678, 3262706144, 3262706159, 'NL', 'NLD', 'هولندا'),
(58679, 3262706160, 3262706175, 'DE', 'DEU', 'ألمانيا'),
(58680, 3262706176, 3262706271, 'NL', 'NLD', 'هولندا'),
(58681, 3262706272, 3262706279, 'DE', 'DEU', 'ألمانيا'),
(58682, 3262706280, 3262706439, 'NL', 'NLD', 'هولندا'),
(58683, 3262706440, 3262706447, 'DE', 'DEU', 'ألمانيا'),
(58684, 3262706448, 3262706487, 'NL', 'NLD', 'هولندا'),
(58685, 3262706488, 3262706495, 'DE', 'DEU', 'ألمانيا'),
(58686, 3262706496, 3262706559, 'NL', 'NLD', 'هولندا'),
(58687, 3262706560, 3262706567, 'DE', 'DEU', 'ألمانيا'),
(58688, 3262706568, 3262706655, 'NL', 'NLD', 'هولندا'),
(58689, 3262706656, 3262706663, 'DE', 'DEU', 'ألمانيا'),
(58690, 3262706664, 3262706767, 'NL', 'NLD', 'هولندا'),
(58691, 3262706768, 3262706783, 'DE', 'DEU', 'ألمانيا'),
(58692, 3262706784, 3262706839, 'NL', 'NLD', 'هولندا'),
(58693, 3262706840, 3262706847, 'DE', 'DEU', 'ألمانيا'),
(58694, 3262706848, 3262706903, 'NL', 'NLD', 'هولندا'),
(58695, 3262706904, 3262706911, 'DE', 'DEU', 'ألمانيا'),
(58696, 3262706912, 3262706951, 'NL', 'NLD', 'هولندا'),
(58697, 3262706952, 3262706959, 'DE', 'DEU', 'ألمانيا'),
(58698, 3262706960, 3262706975, 'NL', 'NLD', 'هولندا'),
(58699, 3262706976, 3262706999, 'DE', 'DEU', 'ألمانيا'),
(58700, 3262707000, 3262707159, 'NL', 'NLD', 'هولندا'),
(58701, 3262707160, 3262707167, 'DE', 'DEU', 'ألمانيا'),
(58702, 3262707168, 3262707207, 'NL', 'NLD', 'هولندا'),
(58703, 3262707208, 3262707215, 'DE', 'DEU', 'ألمانيا'),
(58704, 3262707216, 3262707223, 'NL', 'NLD', 'هولندا'),
(58705, 3262707224, 3262707231, 'DE', 'DEU', 'ألمانيا'),
(58706, 3262707232, 3262707239, 'NL', 'NLD', 'هولندا'),
(58707, 3262707240, 3262707247, 'DE', 'DEU', 'ألمانيا'),
(58708, 3262707248, 3262707271, 'NL', 'NLD', 'هولندا'),
(58709, 3262707272, 3262707295, 'DE', 'DEU', 'ألمانيا'),
(58710, 3262707296, 3262707303, 'NL', 'NLD', 'هولندا'),
(58711, 3262707304, 3262707311, 'DE', 'DEU', 'ألمانيا'),
(58712, 3262707312, 3262707391, 'NL', 'NLD', 'هولندا'),
(58713, 3262707392, 3262707399, 'DE', 'DEU', 'ألمانيا'),
(58714, 3262707400, 3262707463, 'NL', 'NLD', 'هولندا'),
(58715, 3262707464, 3262707471, 'DE', 'DEU', 'ألمانيا'),
(58716, 3262707472, 3262707487, 'NL', 'NLD', 'هولندا'),
(58717, 3262707488, 3262707495, 'DE', 'DEU', 'ألمانيا'),
(58718, 3262707496, 3262707519, 'NL', 'NLD', 'هولندا'),
(58719, 3262707520, 3262707527, 'DE', 'DEU', 'ألمانيا'),
(58720, 3262707528, 3262707559, 'NL', 'NLD', 'هولندا'),
(58721, 3262707560, 3262707567, 'DE', 'DEU', 'ألمانيا'),
(58722, 3262707568, 3262707591, 'NL', 'NLD', 'هولندا'),
(58723, 3262707592, 3262707599, 'DE', 'DEU', 'ألمانيا'),
(58724, 3262707600, 3262707711, 'NL', 'NLD', 'هولندا'),
(58725, 3262707712, 3262710527, 'DE', 'DEU', 'ألمانيا'),
(58726, 3262710528, 3262710583, 'NL', 'NLD', 'هولندا'),
(58727, 3262710584, 3262710591, 'DE', 'DEU', 'ألمانيا'),
(58728, 3262710592, 3262710727, 'NL', 'NLD', 'هولندا'),
(58729, 3262710728, 3262710735, 'DE', 'DEU', 'ألمانيا'),
(58730, 3262710736, 3262710935, 'NL', 'NLD', 'هولندا'),
(58731, 3262710936, 3262710943, 'DE', 'DEU', 'ألمانيا'),
(58732, 3262710944, 3262710991, 'NL', 'NLD', 'هولندا'),
(58733, 3262710992, 3262710999, 'DE', 'DEU', 'ألمانيا'),
(58734, 3262711000, 3262711143, 'NL', 'NLD', 'هولندا'),
(58735, 3262711144, 3262711151, 'DE', 'DEU', 'ألمانيا'),
(58736, 3262711152, 3262711223, 'NL', 'NLD', 'هولندا'),
(58737, 3262711224, 3262711231, 'DE', 'DEU', 'ألمانيا'),
(58738, 3262711232, 3262711383, 'NL', 'NLD', 'هولندا'),
(58739, 3262711384, 3262711391, 'DE', 'DEU', 'ألمانيا'),
(58740, 3262711392, 3262711471, 'NL', 'NLD', 'هولندا'),
(58741, 3262711472, 3262711487, 'DE', 'DEU', 'ألمانيا'),
(58742, 3262711488, 3262711543, 'NL', 'NLD', 'هولندا'),
(58743, 3262711544, 3262711551, 'DE', 'DEU', 'ألمانيا'),
(58744, 3262711552, 3262711823, 'NL', 'NLD', 'هولندا'),
(58745, 3262711824, 3262711831, 'DE', 'DEU', 'ألمانيا'),
(58746, 3262711832, 3262711855, 'NL', 'NLD', 'هولندا'),
(58747, 3262711856, 3262711863, 'DE', 'DEU', 'ألمانيا'),
(58748, 3262711864, 3262711887, 'NL', 'NLD', 'هولندا'),
(58749, 3262711888, 3262711895, 'DE', 'DEU', 'ألمانيا'),
(58750, 3262711896, 3262711919, 'NL', 'NLD', 'هولندا'),
(58751, 3262711920, 3262711927, 'DE', 'DEU', 'ألمانيا'),
(58752, 3262711928, 3262711943, 'NL', 'NLD', 'هولندا'),
(58753, 3262711944, 3262711951, 'DE', 'DEU', 'ألمانيا'),
(58754, 3262711952, 3262712199, 'NL', 'NLD', 'هولندا'),
(58755, 3262712200, 3262712207, 'DE', 'DEU', 'ألمانيا'),
(58756, 3262712208, 3262712375, 'NL', 'NLD', 'هولندا'),
(58757, 3262712376, 3262712383, 'DE', 'DEU', 'ألمانيا'),
(58758, 3262712384, 3262712471, 'NL', 'NLD', 'هولندا'),
(58759, 3262712472, 3262712479, 'DE', 'DEU', 'ألمانيا'),
(58760, 3262712480, 3262712575, 'NL', 'NLD', 'هولندا'),
(58761, 3262712576, 3262712831, 'DE', 'DEU', 'ألمانيا'),
(58762, 3262712832, 3262713135, 'NL', 'NLD', 'هولندا'),
(58763, 3262713136, 3262713143, 'DE', 'DEU', 'ألمانيا'),
(58764, 3262713144, 3262713399, 'NL', 'NLD', 'هولندا'),
(58765, 3262713400, 3262713407, 'DE', 'DEU', 'ألمانيا'),
(58766, 3262713408, 3262713415, 'NL', 'NLD', 'هولندا'),
(58767, 3262713416, 3262713423, 'DE', 'DEU', 'ألمانيا'),
(58768, 3262713424, 3262713455, 'NL', 'NLD', 'هولندا'),
(58769, 3262713456, 3262713463, 'DE', 'DEU', 'ألمانيا'),
(58770, 3262713464, 3262713519, 'NL', 'NLD', 'هولندا'),
(58771, 3262713520, 3262713527, 'DE', 'DEU', 'ألمانيا'),
(58772, 3262713528, 3262713583, 'NL', 'NLD', 'هولندا'),
(58773, 3262713584, 3262713591, 'DE', 'DEU', 'ألمانيا'),
(58774, 3262713592, 3262713703, 'NL', 'NLD', 'هولندا'),
(58775, 3262713704, 3262713711, 'DE', 'DEU', 'ألمانيا'),
(58776, 3262713712, 3262713807, 'NL', 'NLD', 'هولندا'),
(58777, 3262713808, 3262713815, 'DE', 'DEU', 'ألمانيا'),
(58778, 3262713816, 3262713943, 'NL', 'NLD', 'هولندا'),
(58779, 3262713944, 3262713951, 'DE', 'DEU', 'ألمانيا'),
(58780, 3262713952, 3262714023, 'NL', 'NLD', 'هولندا'),
(58781, 3262714024, 3262714031, 'DE', 'DEU', 'ألمانيا'),
(58782, 3262714032, 3262714063, 'NL', 'NLD', 'هولندا'),
(58783, 3262714064, 3262714071, 'DE', 'DEU', 'ألمانيا'),
(58784, 3262714072, 3262714183, 'NL', 'NLD', 'هولندا'),
(58785, 3262714184, 3262714191, 'DE', 'DEU', 'ألمانيا'),
(58786, 3262714192, 3262714207, 'NL', 'NLD', 'هولندا'),
(58787, 3262714208, 3262714215, 'DE', 'DEU', 'ألمانيا'),
(58788, 3262714216, 3262714311, 'NL', 'NLD', 'هولندا'),
(58789, 3262714312, 3262714327, 'DE', 'DEU', 'ألمانيا'),
(58790, 3262714328, 3262714511, 'NL', 'NLD', 'هولندا'),
(58791, 3262714512, 3262714519, 'DE', 'DEU', 'ألمانيا'),
(58792, 3262714520, 3262714527, 'NL', 'NLD', 'هولندا'),
(58793, 3262714528, 3262714535, 'DE', 'DEU', 'ألمانيا'),
(58794, 3262714536, 3262714583, 'NL', 'NLD', 'هولندا'),
(58795, 3262714584, 3262714591, 'DE', 'DEU', 'ألمانيا'),
(58796, 3262714592, 3262714599, 'NL', 'NLD', 'هولندا'),
(58797, 3262714600, 3262714615, 'DE', 'DEU', 'ألمانيا'),
(58798, 3262714616, 3262714703, 'NL', 'NLD', 'هولندا'),
(58799, 3262714704, 3262714711, 'DE', 'DEU', 'ألمانيا'),
(58800, 3262714712, 3262714719, 'NL', 'NLD', 'هولندا'),
(58801, 3262714720, 3262714727, 'DE', 'DEU', 'ألمانيا'),
(58802, 3262714728, 3262714735, 'NL', 'NLD', 'هولندا'),
(58803, 3262714736, 3262714743, 'DE', 'DEU', 'ألمانيا'),
(58804, 3262714744, 3262714775, 'NL', 'NLD', 'هولندا'),
(58805, 3262714776, 3262714791, 'DE', 'DEU', 'ألمانيا'),
(58806, 3262714792, 3262714799, 'NL', 'NLD', 'هولندا'),
(58807, 3262714800, 3262714807, 'DE', 'DEU', 'ألمانيا'),
(58808, 3262714808, 3262714815, 'NL', 'NLD', 'هولندا'),
(58809, 3262714816, 3262714823, 'DE', 'DEU', 'ألمانيا'),
(58810, 3262714824, 3262714831, 'NL', 'NLD', 'هولندا'),
(58811, 3262714832, 3262714839, 'DE', 'DEU', 'ألمانيا'),
(58812, 3262714840, 3262714895, 'NL', 'NLD', 'هولندا'),
(58813, 3262714896, 3262714903, 'DE', 'DEU', 'ألمانيا'),
(58814, 3262714904, 3262714919, 'NL', 'NLD', 'هولندا'),
(58815, 3262714920, 3262714927, 'DE', 'DEU', 'ألمانيا'),
(58816, 3262714928, 3262715135, 'NL', 'NLD', 'هولندا'),
(58817, 3262715136, 3262716671, 'DE', 'DEU', 'ألمانيا'),
(58818, 3262716672, 3262716743, 'NL', 'NLD', 'هولندا'),
(58819, 3262716744, 3262716751, 'DE', 'DEU', 'ألمانيا'),
(58820, 3262716752, 3262716791, 'NL', 'NLD', 'هولندا'),
(58821, 3262716792, 3262716799, 'DE', 'DEU', 'ألمانيا'),
(58822, 3262716800, 3262716823, 'NL', 'NLD', 'هولندا'),
(58823, 3262716824, 3262716839, 'DE', 'DEU', 'ألمانيا'),
(58824, 3262716840, 3262716911, 'NL', 'NLD', 'هولندا'),
(58825, 3262716912, 3262716919, 'DE', 'DEU', 'ألمانيا'),
(58826, 3262716920, 3262716935, 'NL', 'NLD', 'هولندا'),
(58827, 3262716936, 3262716943, 'DE', 'DEU', 'ألمانيا'),
(58828, 3262716944, 3262716959, 'NL', 'NLD', 'هولندا'),
(58829, 3262716960, 3262716967, 'DE', 'DEU', 'ألمانيا'),
(58830, 3262716968, 3262717191, 'NL', 'NLD', 'هولندا'),
(58831, 3262717192, 3262717207, 'DE', 'DEU', 'ألمانيا'),
(58832, 3262717208, 3262717263, 'NL', 'NLD', 'هولندا'),
(58833, 3262717264, 3262717271, 'DE', 'DEU', 'ألمانيا'),
(58834, 3262717272, 3262717415, 'NL', 'NLD', 'هولندا'),
(58835, 3262717416, 3262717423, 'DE', 'DEU', 'ألمانيا'),
(58836, 3262717424, 3262717487, 'NL', 'NLD', 'هولندا'),
(58837, 3262717488, 3262717495, 'DE', 'DEU', 'ألمانيا'),
(58838, 3262717496, 3262717551, 'NL', 'NLD', 'هولندا'),
(58839, 3262717552, 3262717559, 'DE', 'DEU', 'ألمانيا'),
(58840, 3262717560, 3262717607, 'NL', 'NLD', 'هولندا'),
(58841, 3262717608, 3262717615, 'DE', 'DEU', 'ألمانيا'),
(58842, 3262717616, 3262717783, 'NL', 'NLD', 'هولندا'),
(58843, 3262717784, 3262717791, 'DE', 'DEU', 'ألمانيا'),
(58844, 3262717792, 3262717903, 'NL', 'NLD', 'هولندا'),
(58845, 3262717904, 3262717911, 'DE', 'DEU', 'ألمانيا'),
(58846, 3262717912, 3262718063, 'NL', 'NLD', 'هولندا'),
(58847, 3262718064, 3262718071, 'DE', 'DEU', 'ألمانيا'),
(58848, 3262718072, 3262718079, 'NL', 'NLD', 'هولندا'),
(58849, 3262718080, 3262718087, 'DE', 'DEU', 'ألمانيا'),
(58850, 3262718088, 3262718175, 'NL', 'NLD', 'هولندا'),
(58851, 3262718176, 3262718183, 'DE', 'DEU', 'ألمانيا'),
(58852, 3262718184, 3262718223, 'NL', 'NLD', 'هولندا'),
(58853, 3262718224, 3262718231, 'DE', 'DEU', 'ألمانيا'),
(58854, 3262718232, 3262718263, 'NL', 'NLD', 'هولندا'),
(58855, 3262718264, 3262718271, 'DE', 'DEU', 'ألمانيا'),
(58856, 3262718272, 3262718279, 'NL', 'NLD', 'هولندا'),
(58857, 3262718280, 3262718287, 'DE', 'DEU', 'ألمانيا'),
(58858, 3262718288, 3262718471, 'NL', 'NLD', 'هولندا'),
(58859, 3262718472, 3262718479, 'DE', 'DEU', 'ألمانيا'),
(58860, 3262718480, 3262718487, 'NL', 'NLD', 'هولندا'),
(58861, 3262718488, 3262718495, 'DE', 'DEU', 'ألمانيا'),
(58862, 3262718496, 3262718511, 'NL', 'NLD', 'هولندا'),
(58863, 3262718512, 3262718519, 'DE', 'DEU', 'ألمانيا'),
(58864, 3262718520, 3262718559, 'NL', 'NLD', 'هولندا'),
(58865, 3262718560, 3262718567, 'DE', 'DEU', 'ألمانيا'),
(58866, 3262718568, 3262718839, 'NL', 'NLD', 'هولندا'),
(58867, 3262718840, 3262718847, 'DE', 'DEU', 'ألمانيا'),
(58868, 3262718848, 3262718919, 'NL', 'NLD', 'هولندا'),
(58869, 3262718920, 3262718935, 'DE', 'DEU', 'ألمانيا'),
(58870, 3262718936, 3262719047, 'NL', 'NLD', 'هولندا'),
(58871, 3262719048, 3262719063, 'DE', 'DEU', 'ألمانيا'),
(58872, 3262719064, 3262719095, 'NL', 'NLD', 'هولندا'),
(58873, 3262719096, 3262719103, 'DE', 'DEU', 'ألمانيا'),
(58874, 3262719104, 3262719127, 'NL', 'NLD', 'هولندا'),
(58875, 3262719128, 3262719135, 'DE', 'DEU', 'ألمانيا'),
(58876, 3262719136, 3262719159, 'NL', 'NLD', 'هولندا'),
(58877, 3262719160, 3262719167, 'DE', 'DEU', 'ألمانيا'),
(58878, 3262719168, 3262719175, 'NL', 'NLD', 'هولندا'),
(58879, 3262719176, 3262719183, 'DE', 'DEU', 'ألمانيا'),
(58880, 3262719184, 3262719255, 'NL', 'NLD', 'هولندا'),
(58881, 3262719256, 3262719263, 'DE', 'DEU', 'ألمانيا'),
(58882, 3262719264, 3262719303, 'NL', 'NLD', 'هولندا'),
(58883, 3262719304, 3262719311, 'DE', 'DEU', 'ألمانيا'),
(58884, 3262719312, 3262719383, 'NL', 'NLD', 'هولندا'),
(58885, 3262719384, 3262719391, 'DE', 'DEU', 'ألمانيا'),
(58886, 3262719392, 3262719423, 'NL', 'NLD', 'هولندا'),
(58887, 3262719424, 3262719431, 'DE', 'DEU', 'ألمانيا'),
(58888, 3262719432, 3262719519, 'NL', 'NLD', 'هولندا'),
(58889, 3262719520, 3262719527, 'DE', 'DEU', 'ألمانيا'),
(58890, 3262719528, 3262719615, 'NL', 'NLD', 'هولندا'),
(58891, 3262719616, 3262719623, 'DE', 'DEU', 'ألمانيا'),
(58892, 3262719624, 3262719743, 'NL', 'NLD', 'هولندا'),
(58893, 3262719744, 3262719751, 'DE', 'DEU', 'ألمانيا'),
(58894, 3262719752, 3262719839, 'NL', 'NLD', 'هولندا'),
(58895, 3262719840, 3262719847, 'DE', 'DEU', 'ألمانيا'),
(58896, 3262719848, 3262719855, 'NL', 'NLD', 'هولندا'),
(58897, 3262719856, 3262719863, 'DE', 'DEU', 'ألمانيا'),
(58898, 3262719864, 3262719895, 'NL', 'NLD', 'هولندا'),
(58899, 3262719896, 3262719903, 'DE', 'DEU', 'ألمانيا'),
(58900, 3262719904, 3262719911, 'NL', 'NLD', 'هولندا'),
(58901, 3262719912, 3262719919, 'DE', 'DEU', 'ألمانيا'),
(58902, 3262719920, 3262719927, 'NL', 'NLD', 'هولندا'),
(58903, 3262719928, 3262719935, 'DE', 'DEU', 'ألمانيا'),
(58904, 3262719936, 3262720055, 'NL', 'NLD', 'هولندا'),
(58905, 3262720056, 3262720063, 'DE', 'DEU', 'ألمانيا'),
(58906, 3262720064, 3262720119, 'NL', 'NLD', 'هولندا'),
(58907, 3262720120, 3262720127, 'DE', 'DEU', 'ألمانيا'),
(58908, 3262720128, 3262720199, 'NL', 'NLD', 'هولندا'),
(58909, 3262720200, 3262720207, 'DE', 'DEU', 'ألمانيا'),
(58910, 3262720208, 3262720319, 'NL', 'NLD', 'هولندا'),
(58911, 3262720320, 3262720327, 'DE', 'DEU', 'ألمانيا'),
(58912, 3262720328, 3262720447, 'NL', 'NLD', 'هولندا'),
(58913, 3262720448, 3262720455, 'DE', 'DEU', 'ألمانيا'),
(58914, 3262720456, 3262720631, 'NL', 'NLD', 'هولندا'),
(58915, 3262720632, 3262720647, 'DE', 'DEU', 'ألمانيا'),
(58916, 3262720648, 3262720687, 'NL', 'NLD', 'هولندا'),
(58917, 3262720688, 3262720695, 'DE', 'DEU', 'ألمانيا'),
(58918, 3262720696, 3262720751, 'NL', 'NLD', 'هولندا'),
(58919, 3262720752, 3262720759, 'DE', 'DEU', 'ألمانيا'),
(58920, 3262720760, 3262720855, 'NL', 'NLD', 'هولندا'),
(58921, 3262720856, 3262720863, 'DE', 'DEU', 'ألمانيا'),
(58922, 3262720864, 3262720871, 'NL', 'NLD', 'هولندا'),
(58923, 3262720872, 3262720879, 'DE', 'DEU', 'ألمانيا'),
(58924, 3262720880, 3262720951, 'NL', 'NLD', 'هولندا'),
(58925, 3262720952, 3262720959, 'DE', 'DEU', 'ألمانيا'),
(58926, 3262720960, 3262720975, 'NL', 'NLD', 'هولندا'),
(58927, 3262720976, 3262720991, 'DE', 'DEU', 'ألمانيا'),
(58928, 3262720992, 3262720999, 'NL', 'NLD', 'هولندا'),
(58929, 3262721000, 3262721007, 'DE', 'DEU', 'ألمانيا'),
(58930, 3262721008, 3262721087, 'NL', 'NLD', 'هولندا'),
(58931, 3262721088, 3262721095, 'DE', 'DEU', 'ألمانيا'),
(58932, 3262721096, 3262721111, 'NL', 'NLD', 'هولندا'),
(58933, 3262721112, 3262721119, 'DE', 'DEU', 'ألمانيا'),
(58934, 3262721120, 3262721247, 'NL', 'NLD', 'هولندا'),
(58935, 3262721248, 3262721255, 'DE', 'DEU', 'ألمانيا'),
(58936, 3262721256, 3262721327, 'NL', 'NLD', 'هولندا'),
(58937, 3262721328, 3262721335, 'DE', 'DEU', 'ألمانيا'),
(58938, 3262721336, 3262721463, 'NL', 'NLD', 'هولندا'),
(58939, 3262721464, 3262721471, 'DE', 'DEU', 'ألمانيا'),
(58940, 3262721472, 3262721527, 'NL', 'NLD', 'هولندا'),
(58941, 3262721528, 3262726911, 'DE', 'DEU', 'ألمانيا'),
(58942, 3262726912, 3262727007, 'NL', 'NLD', 'هولندا'),
(58943, 3262727008, 3262727015, 'DE', 'DEU', 'ألمانيا'),
(58944, 3262727016, 3262727023, 'NL', 'NLD', 'هولندا'),
(58945, 3262727024, 3262727031, 'DE', 'DEU', 'ألمانيا'),
(58946, 3262727032, 3262727039, 'NL', 'NLD', 'هولندا'),
(58947, 3262727040, 3262727047, 'DE', 'DEU', 'ألمانيا'),
(58948, 3262727048, 3262727159, 'NL', 'NLD', 'هولندا'),
(58949, 3262727160, 3262727167, 'DE', 'DEU', 'ألمانيا'),
(58950, 3262727168, 3262727303, 'NL', 'NLD', 'هولندا'),
(58951, 3262727304, 3262727311, 'DE', 'DEU', 'ألمانيا'),
(58952, 3262727312, 3262727583, 'NL', 'NLD', 'هولندا'),
(58953, 3262727584, 3262727591, 'DE', 'DEU', 'ألمانيا'),
(58954, 3262727592, 3262727671, 'NL', 'NLD', 'هولندا'),
(58955, 3262727672, 3262727679, 'DE', 'DEU', 'ألمانيا'),
(58956, 3262727680, 3262727711, 'NL', 'NLD', 'هولندا'),
(58957, 3262727712, 3262727719, 'DE', 'DEU', 'ألمانيا'),
(58958, 3262727720, 3262727727, 'NL', 'NLD', 'هولندا'),
(58959, 3262727728, 3262727735, 'DE', 'DEU', 'ألمانيا'),
(58960, 3262727736, 3262727999, 'NL', 'NLD', 'هولندا'),
(58961, 3262728000, 3262728007, 'DE', 'DEU', 'ألمانيا'),
(58962, 3262728008, 3262728015, 'NL', 'NLD', 'هولندا'),
(58963, 3262728016, 3262728023, 'DE', 'DEU', 'ألمانيا'),
(58964, 3262728024, 3262728095, 'NL', 'NLD', 'هولندا'),
(58965, 3262728096, 3262728103, 'DE', 'DEU', 'ألمانيا'),
(58966, 3262728104, 3262728151, 'NL', 'NLD', 'هولندا'),
(58967, 3262728152, 3262728159, 'DE', 'DEU', 'ألمانيا'),
(58968, 3262728160, 3262728199, 'NL', 'NLD', 'هولندا'),
(58969, 3262728200, 3262728207, 'DE', 'DEU', 'ألمانيا'),
(58970, 3262728208, 3262728231, 'NL', 'NLD', 'هولندا'),
(58971, 3262728232, 3262728239, 'DE', 'DEU', 'ألمانيا'),
(58972, 3262728240, 3262728279, 'NL', 'NLD', 'هولندا'),
(58973, 3262728280, 3262728287, 'DE', 'DEU', 'ألمانيا'),
(58974, 3262728288, 3262728335, 'NL', 'NLD', 'هولندا'),
(58975, 3262728336, 3262728343, 'DE', 'DEU', 'ألمانيا'),
(58976, 3262728344, 3262728423, 'NL', 'NLD', 'هولندا'),
(58977, 3262728424, 3262728431, 'DE', 'DEU', 'ألمانيا'),
(58978, 3262728432, 3262728447, 'NL', 'NLD', 'هولندا'),
(58979, 3262728448, 3262728463, 'DE', 'DEU', 'ألمانيا'),
(58980, 3262728464, 3262728519, 'NL', 'NLD', 'هولندا'),
(58981, 3262728520, 3262728527, 'DE', 'DEU', 'ألمانيا'),
(58982, 3262728528, 3262728543, 'NL', 'NLD', 'هولندا'),
(58983, 3262728544, 3262728551, 'DE', 'DEU', 'ألمانيا'),
(58984, 3262728552, 3262728671, 'NL', 'NLD', 'هولندا'),
(58985, 3262728672, 3262728679, 'DE', 'DEU', 'ألمانيا'),
(58986, 3262728680, 3262728735, 'NL', 'NLD', 'هولندا'),
(58987, 3262728736, 3262728751, 'DE', 'DEU', 'ألمانيا'),
(58988, 3262728752, 3262728799, 'NL', 'NLD', 'هولندا'),
(58989, 3262728800, 3262728807, 'DE', 'DEU', 'ألمانيا'),
(58990, 3262728808, 3262728935, 'NL', 'NLD', 'هولندا'),
(58991, 3262728936, 3262728943, 'DE', 'DEU', 'ألمانيا'),
(58992, 3262728944, 3262729023, 'NL', 'NLD', 'هولندا'),
(58993, 3262729024, 3262729031, 'DE', 'DEU', 'ألمانيا'),
(58994, 3262729032, 3262729135, 'NL', 'NLD', 'هولندا'),
(58995, 3262729136, 3262729143, 'DE', 'DEU', 'ألمانيا'),
(58996, 3262729144, 3262729199, 'NL', 'NLD', 'هولندا'),
(58997, 3262729200, 3262729207, 'DE', 'DEU', 'ألمانيا'),
(58998, 3262729208, 3262729231, 'NL', 'NLD', 'هولندا'),
(58999, 3262729232, 3262729247, 'DE', 'DEU', 'ألمانيا'),
(59000, 3262729248, 3262729423, 'NL', 'NLD', 'هولندا'),
(59001, 3262729424, 3262729431, 'DE', 'DEU', 'ألمانيا'),
(59002, 3262729432, 3262729439, 'NL', 'NLD', 'هولندا'),
(59003, 3262729440, 3262729447, 'DE', 'DEU', 'ألمانيا'),
(59004, 3262729448, 3262729479, 'NL', 'NLD', 'هولندا'),
(59005, 3262729480, 3262729487, 'DE', 'DEU', 'ألمانيا'),
(59006, 3262729488, 3262729607, 'NL', 'NLD', 'هولندا'),
(59007, 3262729608, 3262729615, 'DE', 'DEU', 'ألمانيا'),
(59008, 3262729616, 3262729727, 'NL', 'NLD', 'هولندا'),
(59009, 3262729728, 3262729735, 'DE', 'DEU', 'ألمانيا'),
(59010, 3262729736, 3262729887, 'NL', 'NLD', 'هولندا'),
(59011, 3262729888, 3262729895, 'DE', 'DEU', 'ألمانيا'),
(59012, 3262729896, 3262729903, 'NL', 'NLD', 'هولندا'),
(59013, 3262729904, 3262729911, 'DE', 'DEU', 'ألمانيا'),
(59014, 3262729912, 3262729975, 'NL', 'NLD', 'هولندا'),
(59015, 3262729976, 3262729983, 'DE', 'DEU', 'ألمانيا'),
(59016, 3262729984, 3262730071, 'NL', 'NLD', 'هولندا'),
(59017, 3262730072, 3262730079, 'DE', 'DEU', 'ألمانيا'),
(59018, 3262730080, 3262730095, 'NL', 'NLD', 'هولندا'),
(59019, 3262730096, 3262730103, 'DE', 'DEU', 'ألمانيا'),
(59020, 3262730104, 3262730183, 'NL', 'NLD', 'هولندا'),
(59021, 3262730184, 3262730191, 'DE', 'DEU', 'ألمانيا'),
(59022, 3262730192, 3262730207, 'NL', 'NLD', 'هولندا'),
(59023, 3262730208, 3262730215, 'DE', 'DEU', 'ألمانيا'),
(59024, 3262730216, 3262730231, 'NL', 'NLD', 'هولندا'),
(59025, 3262730232, 3262730239, 'DE', 'DEU', 'ألمانيا'),
(59026, 3262730240, 3262730559, 'NL', 'NLD', 'هولندا'),
(59027, 3262730560, 3262730567, 'DE', 'DEU', 'ألمانيا'),
(59028, 3262730568, 3262730591, 'NL', 'NLD', 'هولندا'),
(59029, 3262730592, 3262730599, 'DE', 'DEU', 'ألمانيا'),
(59030, 3262730600, 3262730783, 'NL', 'NLD', 'هولندا'),
(59031, 3262730784, 3262730791, 'DE', 'DEU', 'ألمانيا'),
(59032, 3262730792, 3262730799, 'NL', 'NLD', 'هولندا'),
(59033, 3262730800, 3262730807, 'DE', 'DEU', 'ألمانيا'),
(59034, 3262730808, 3262730903, 'NL', 'NLD', 'هولندا'),
(59035, 3262730904, 3262730911, 'DE', 'DEU', 'ألمانيا'),
(59036, 3262730912, 3262731023, 'NL', 'NLD', 'هولندا'),
(59037, 3262731024, 3262731031, 'DE', 'DEU', 'ألمانيا'),
(59038, 3262731032, 3262731055, 'NL', 'NLD', 'هولندا'),
(59039, 3262731056, 3262731063, 'DE', 'DEU', 'ألمانيا'),
(59040, 3262731064, 3262731095, 'NL', 'NLD', 'هولندا'),
(59041, 3262731096, 3262731103, 'DE', 'DEU', 'ألمانيا'),
(59042, 3262731104, 3262731127, 'NL', 'NLD', 'هولندا'),
(59043, 3262731128, 3262731135, 'DE', 'DEU', 'ألمانيا'),
(59044, 3262731136, 3262731175, 'NL', 'NLD', 'هولندا'),
(59045, 3262731176, 3262731183, 'DE', 'DEU', 'ألمانيا'),
(59046, 3262731184, 3262731255, 'NL', 'NLD', 'هولندا'),
(59047, 3262731256, 3262731263, 'DE', 'DEU', 'ألمانيا'),
(59048, 3262731264, 3262731391, 'NL', 'NLD', 'هولندا'),
(59049, 3262731392, 3262731399, 'DE', 'DEU', 'ألمانيا'),
(59050, 3262731400, 3262731471, 'NL', 'NLD', 'هولندا'),
(59051, 3262731472, 3262731479, 'DE', 'DEU', 'ألمانيا'),
(59052, 3262731480, 3262731495, 'NL', 'NLD', 'هولندا'),
(59053, 3262731496, 3262731503, 'DE', 'DEU', 'ألمانيا'),
(59054, 3262731504, 3262731663, 'NL', 'NLD', 'هولندا'),
(59055, 3262731664, 3262731671, 'DE', 'DEU', 'ألمانيا'),
(59056, 3262731672, 3262731695, 'NL', 'NLD', 'هولندا'),
(59057, 3262731696, 3262731703, 'DE', 'DEU', 'ألمانيا'),
(59058, 3262731704, 3262731743, 'NL', 'NLD', 'هولندا'),
(59059, 3262731744, 3262731751, 'DE', 'DEU', 'ألمانيا'),
(59060, 3262731752, 3262731767, 'NL', 'NLD', 'هولندا'),
(59061, 3262731768, 3262731775, 'DE', 'DEU', 'ألمانيا'),
(59062, 3262731776, 3262731895, 'NL', 'NLD', 'هولندا'),
(59063, 3262731896, 3262731903, 'DE', 'DEU', 'ألمانيا'),
(59064, 3262731904, 3262731911, 'NL', 'NLD', 'هولندا'),
(59065, 3262731912, 3262731919, 'DE', 'DEU', 'ألمانيا'),
(59066, 3262731920, 3262731975, 'NL', 'NLD', 'هولندا'),
(59067, 3262731976, 3262731983, 'DE', 'DEU', 'ألمانيا'),
(59068, 3262731984, 3262732047, 'NL', 'NLD', 'هولندا'),
(59069, 3262732048, 3262732055, 'DE', 'DEU', 'ألمانيا'),
(59070, 3262732056, 3262732135, 'NL', 'NLD', 'هولندا'),
(59071, 3262732136, 3262732143, 'DE', 'DEU', 'ألمانيا'),
(59072, 3262732144, 3262732199, 'NL', 'NLD', 'هولندا'),
(59073, 3262732200, 3262732207, 'DE', 'DEU', 'ألمانيا'),
(59074, 3262732208, 3262732303, 'NL', 'NLD', 'هولندا'),
(59075, 3262732304, 3262732311, 'DE', 'DEU', 'ألمانيا'),
(59076, 3262732312, 3262732495, 'NL', 'NLD', 'هولندا'),
(59077, 3262732496, 3262732511, 'DE', 'DEU', 'ألمانيا'),
(59078, 3262732512, 3262732551, 'NL', 'NLD', 'هولندا'),
(59079, 3262732552, 3262732559, 'DE', 'DEU', 'ألمانيا'),
(59080, 3262732560, 3262732639, 'NL', 'NLD', 'هولندا'),
(59081, 3262732640, 3262732647, 'DE', 'DEU', 'ألمانيا'),
(59082, 3262732648, 3262732655, 'NL', 'NLD', 'هولندا'),
(59083, 3262732656, 3262732663, 'DE', 'DEU', 'ألمانيا'),
(59084, 3262732664, 3262732671, 'NL', 'NLD', 'هولندا'),
(59085, 3262732672, 3262732679, 'DE', 'DEU', 'ألمانيا'),
(59086, 3262732680, 3262732703, 'NL', 'NLD', 'هولندا'),
(59087, 3262732704, 3262732711, 'DE', 'DEU', 'ألمانيا'),
(59088, 3262732712, 3262732799, 'NL', 'NLD', 'هولندا'),
(59089, 3262732800, 3262733063, 'DE', 'DEU', 'ألمانيا'),
(59090, 3262733064, 3262733119, 'NL', 'NLD', 'هولندا'),
(59091, 3262733120, 3262733127, 'DE', 'DEU', 'ألمانيا'),
(59092, 3262733128, 3262733151, 'NL', 'NLD', 'هولندا'),
(59093, 3262733152, 3262733159, 'DE', 'DEU', 'ألمانيا'),
(59094, 3262733160, 3262733247, 'NL', 'NLD', 'هولندا'),
(59095, 3262733248, 3262733255, 'DE', 'DEU', 'ألمانيا'),
(59096, 3262733256, 3262733311, 'NL', 'NLD', 'هولندا'),
(59097, 3262733312, 3262733319, 'DE', 'DEU', 'ألمانيا'),
(59098, 3262733320, 3262733359, 'NL', 'NLD', 'هولندا'),
(59099, 3262733360, 3262733367, 'DE', 'DEU', 'ألمانيا'),
(59100, 3262733368, 3262733391, 'NL', 'NLD', 'هولندا'),
(59101, 3262733392, 3262733399, 'DE', 'DEU', 'ألمانيا'),
(59102, 3262733400, 3262733463, 'NL', 'NLD', 'هولندا'),
(59103, 3262733464, 3262733471, 'DE', 'DEU', 'ألمانيا'),
(59104, 3262733472, 3262733503, 'NL', 'NLD', 'هولندا'),
(59105, 3262733504, 3262733511, 'DE', 'DEU', 'ألمانيا'),
(59106, 3262733512, 3262733655, 'NL', 'NLD', 'هولندا'),
(59107, 3262733656, 3262733663, 'DE', 'DEU', 'ألمانيا'),
(59108, 3262733664, 3262733671, 'NL', 'NLD', 'هولندا'),
(59109, 3262733672, 3262733679, 'DE', 'DEU', 'ألمانيا'),
(59110, 3262733680, 3262733847, 'NL', 'NLD', 'هولندا'),
(59111, 3262733848, 3262733855, 'DE', 'DEU', 'ألمانيا'),
(59112, 3262733856, 3262733967, 'NL', 'NLD', 'هولندا'),
(59113, 3262733968, 3262733975, 'DE', 'DEU', 'ألمانيا'),
(59114, 3262733976, 3262734215, 'NL', 'NLD', 'هولندا'),
(59115, 3262734216, 3262734223, 'DE', 'DEU', 'ألمانيا'),
(59116, 3262734224, 3262734263, 'NL', 'NLD', 'هولندا'),
(59117, 3262734264, 3262734271, 'DE', 'DEU', 'ألمانيا'),
(59118, 3262734272, 3262734287, 'NL', 'NLD', 'هولندا'),
(59119, 3262734288, 3262734295, 'DE', 'DEU', 'ألمانيا'),
(59120, 3262734296, 3262734359, 'NL', 'NLD', 'هولندا'),
(59121, 3262734360, 3262734375, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(59122, 3262734376, 3262734431, 'NL', 'NLD', 'هولندا'),
(59123, 3262734432, 3262734439, 'DE', 'DEU', 'ألمانيا'),
(59124, 3262734440, 3262734447, 'NL', 'NLD', 'هولندا'),
(59125, 3262734448, 3262734455, 'DE', 'DEU', 'ألمانيا'),
(59126, 3262734456, 3262734463, 'NL', 'NLD', 'هولندا'),
(59127, 3262734464, 3262734471, 'DE', 'DEU', 'ألمانيا'),
(59128, 3262734472, 3262734503, 'NL', 'NLD', 'هولندا'),
(59129, 3262734504, 3262734511, 'DE', 'DEU', 'ألمانيا'),
(59130, 3262734512, 3262734687, 'NL', 'NLD', 'هولندا'),
(59131, 3262734688, 3262734695, 'DE', 'DEU', 'ألمانيا'),
(59132, 3262734696, 3262734799, 'NL', 'NLD', 'هولندا'),
(59133, 3262734800, 3262734815, 'DE', 'DEU', 'ألمانيا'),
(59134, 3262734816, 3262734919, 'NL', 'NLD', 'هولندا'),
(59135, 3262734920, 3262734927, 'DE', 'DEU', 'ألمانيا'),
(59136, 3262734928, 3262735087, 'NL', 'NLD', 'هولندا'),
(59137, 3262735088, 3262735095, 'DE', 'DEU', 'ألمانيا'),
(59138, 3262735096, 3262735111, 'NL', 'NLD', 'هولندا'),
(59139, 3262735112, 3262735119, 'DE', 'DEU', 'ألمانيا'),
(59140, 3262735120, 3262735407, 'NL', 'NLD', 'هولندا'),
(59141, 3262735408, 3262735415, 'DE', 'DEU', 'ألمانيا'),
(59142, 3262735416, 3262735431, 'NL', 'NLD', 'هولندا'),
(59143, 3262735432, 3262735439, 'DE', 'DEU', 'ألمانيا'),
(59144, 3262735440, 3262735511, 'NL', 'NLD', 'هولندا'),
(59145, 3262735512, 3262735519, 'DE', 'DEU', 'ألمانيا'),
(59146, 3262735520, 3262735551, 'NL', 'NLD', 'هولندا'),
(59147, 3262735552, 3262735567, 'DE', 'DEU', 'ألمانيا'),
(59148, 3262735568, 3262735679, 'NL', 'NLD', 'هولندا'),
(59149, 3262735680, 3262735687, 'DE', 'DEU', 'ألمانيا'),
(59150, 3262735688, 3262735719, 'NL', 'NLD', 'هولندا'),
(59151, 3262735720, 3262735727, 'DE', 'DEU', 'ألمانيا'),
(59152, 3262735728, 3262735735, 'NL', 'NLD', 'هولندا'),
(59153, 3262735736, 3262735743, 'DE', 'DEU', 'ألمانيا'),
(59154, 3262735744, 3262735807, 'NL', 'NLD', 'هولندا'),
(59155, 3262735808, 3262735815, 'DE', 'DEU', 'ألمانيا'),
(59156, 3262735816, 3262735831, 'NL', 'NLD', 'هولندا'),
(59157, 3262735832, 3262735839, 'DE', 'DEU', 'ألمانيا'),
(59158, 3262735840, 3262735959, 'NL', 'NLD', 'هولندا'),
(59159, 3262735960, 3262735967, 'DE', 'DEU', 'ألمانيا'),
(59160, 3262735968, 3262736183, 'NL', 'NLD', 'هولندا'),
(59161, 3262736184, 3262736191, 'DE', 'DEU', 'ألمانيا'),
(59162, 3262736192, 3262736255, 'NL', 'NLD', 'هولندا'),
(59163, 3262736256, 3262736263, 'DE', 'DEU', 'ألمانيا'),
(59164, 3262736264, 3262736303, 'NL', 'NLD', 'هولندا'),
(59165, 3262736304, 3262736311, 'DE', 'DEU', 'ألمانيا'),
(59166, 3262736312, 3262736383, 'NL', 'NLD', 'هولندا'),
(59167, 3262736384, 3262736895, 'DE', 'DEU', 'ألمانيا'),
(59168, 3262736896, 3262737063, 'NL', 'NLD', 'هولندا'),
(59169, 3262737064, 3262737071, 'DE', 'DEU', 'ألمانيا'),
(59170, 3262737072, 3262737167, 'NL', 'NLD', 'هولندا'),
(59171, 3262737168, 3262737175, 'DE', 'DEU', 'ألمانيا'),
(59172, 3262737176, 3262737191, 'NL', 'NLD', 'هولندا'),
(59173, 3262737192, 3262737215, 'DE', 'DEU', 'ألمانيا'),
(59174, 3262737216, 3262737319, 'NL', 'NLD', 'هولندا'),
(59175, 3262737320, 3262737327, 'DE', 'DEU', 'ألمانيا'),
(59176, 3262737328, 3262737471, 'NL', 'NLD', 'هولندا'),
(59177, 3262737472, 3262737487, 'DE', 'DEU', 'ألمانيا'),
(59178, 3262737488, 3262737735, 'NL', 'NLD', 'هولندا'),
(59179, 3262737736, 3262737743, 'DE', 'DEU', 'ألمانيا'),
(59180, 3262737744, 3262737799, 'NL', 'NLD', 'هولندا'),
(59181, 3262737800, 3262737815, 'DE', 'DEU', 'ألمانيا'),
(59182, 3262737816, 3262737823, 'NL', 'NLD', 'هولندا'),
(59183, 3262737824, 3262737831, 'DE', 'DEU', 'ألمانيا'),
(59184, 3262737832, 3262737935, 'NL', 'NLD', 'هولندا'),
(59185, 3262737936, 3262737943, 'DE', 'DEU', 'ألمانيا'),
(59186, 3262737944, 3262737959, 'NL', 'NLD', 'هولندا'),
(59187, 3262737960, 3262737967, 'DE', 'DEU', 'ألمانيا'),
(59188, 3262737968, 3262738039, 'NL', 'NLD', 'هولندا'),
(59189, 3262738040, 3262738047, 'DE', 'DEU', 'ألمانيا'),
(59190, 3262738048, 3262738055, 'NL', 'NLD', 'هولندا'),
(59191, 3262738056, 3262738063, 'DE', 'DEU', 'ألمانيا'),
(59192, 3262738064, 3262738087, 'NL', 'NLD', 'هولندا'),
(59193, 3262738088, 3262738095, 'DE', 'DEU', 'ألمانيا'),
(59194, 3262738096, 3262738127, 'NL', 'NLD', 'هولندا'),
(59195, 3262738128, 3262738135, 'DE', 'DEU', 'ألمانيا'),
(59196, 3262738136, 3262738151, 'NL', 'NLD', 'هولندا'),
(59197, 3262738152, 3262738159, 'DE', 'DEU', 'ألمانيا'),
(59198, 3262738160, 3262738175, 'NL', 'NLD', 'هولندا'),
(59199, 3262738176, 3262738183, 'DE', 'DEU', 'ألمانيا'),
(59200, 3262738184, 3262738255, 'NL', 'NLD', 'هولندا'),
(59201, 3262738256, 3262738263, 'DE', 'DEU', 'ألمانيا'),
(59202, 3262738264, 3262738319, 'NL', 'NLD', 'هولندا'),
(59203, 3262738320, 3262738327, 'DE', 'DEU', 'ألمانيا'),
(59204, 3262738328, 3262738407, 'NL', 'NLD', 'هولندا'),
(59205, 3262738408, 3262738423, 'DE', 'DEU', 'ألمانيا'),
(59206, 3262738424, 3262738487, 'NL', 'NLD', 'هولندا'),
(59207, 3262738488, 3262738495, 'DE', 'DEU', 'ألمانيا'),
(59208, 3262738496, 3262738511, 'NL', 'NLD', 'هولندا'),
(59209, 3262738512, 3262738519, 'DE', 'DEU', 'ألمانيا'),
(59210, 3262738520, 3262738535, 'NL', 'NLD', 'هولندا'),
(59211, 3262738536, 3262738543, 'DE', 'DEU', 'ألمانيا'),
(59212, 3262738544, 3262738655, 'NL', 'NLD', 'هولندا'),
(59213, 3262738656, 3262738663, 'DE', 'DEU', 'ألمانيا'),
(59214, 3262738664, 3262738903, 'NL', 'NLD', 'هولندا'),
(59215, 3262738904, 3262738911, 'DE', 'DEU', 'ألمانيا'),
(59216, 3262738912, 3262738975, 'NL', 'NLD', 'هولندا'),
(59217, 3262738976, 3262738991, 'DE', 'DEU', 'ألمانيا'),
(59218, 3262738992, 3262739047, 'NL', 'NLD', 'هولندا'),
(59219, 3262739048, 3262739055, 'DE', 'DEU', 'ألمانيا'),
(59220, 3262739056, 3262739119, 'NL', 'NLD', 'هولندا'),
(59221, 3262739120, 3262739135, 'DE', 'DEU', 'ألمانيا'),
(59222, 3262739136, 3262739223, 'NL', 'NLD', 'هولندا'),
(59223, 3262739224, 3262739231, 'DE', 'DEU', 'ألمانيا'),
(59224, 3262739232, 3262739255, 'NL', 'NLD', 'هولندا'),
(59225, 3262739256, 3262739263, 'DE', 'DEU', 'ألمانيا'),
(59226, 3262739264, 3262739311, 'NL', 'NLD', 'هولندا'),
(59227, 3262739312, 3262739319, 'DE', 'DEU', 'ألمانيا'),
(59228, 3262739320, 3262739407, 'NL', 'NLD', 'هولندا'),
(59229, 3262739408, 3262739415, 'DE', 'DEU', 'ألمانيا'),
(59230, 3262739416, 3262739727, 'NL', 'NLD', 'هولندا'),
(59231, 3262739728, 3262739735, 'DE', 'DEU', 'ألمانيا'),
(59232, 3262739736, 3262739799, 'NL', 'NLD', 'هولندا'),
(59233, 3262739800, 3262739807, 'DE', 'DEU', 'ألمانيا'),
(59234, 3262739808, 3262739919, 'NL', 'NLD', 'هولندا'),
(59235, 3262739920, 3262739927, 'DE', 'DEU', 'ألمانيا'),
(59236, 3262739928, 3262739935, 'NL', 'NLD', 'هولندا'),
(59237, 3262739936, 3262739943, 'DE', 'DEU', 'ألمانيا'),
(59238, 3262739944, 3262740063, 'NL', 'NLD', 'هولندا'),
(59239, 3262740064, 3262740071, 'DE', 'DEU', 'ألمانيا'),
(59240, 3262740072, 3262740111, 'NL', 'NLD', 'هولندا'),
(59241, 3262740112, 3262740119, 'DE', 'DEU', 'ألمانيا'),
(59242, 3262740120, 3262740223, 'NL', 'NLD', 'هولندا'),
(59243, 3262740224, 3262740239, 'DE', 'DEU', 'ألمانيا'),
(59244, 3262740240, 3262740247, 'NL', 'NLD', 'هولندا'),
(59245, 3262740248, 3262740255, 'DE', 'DEU', 'ألمانيا'),
(59246, 3262740256, 3262740263, 'NL', 'NLD', 'هولندا'),
(59247, 3262740264, 3262740279, 'DE', 'DEU', 'ألمانيا'),
(59248, 3262740280, 3262740295, 'NL', 'NLD', 'هولندا'),
(59249, 3262740296, 3262740303, 'DE', 'DEU', 'ألمانيا'),
(59250, 3262740304, 3262740343, 'NL', 'NLD', 'هولندا'),
(59251, 3262740344, 3262740351, 'DE', 'DEU', 'ألمانيا'),
(59252, 3262740352, 3262740399, 'NL', 'NLD', 'هولندا'),
(59253, 3262740400, 3262740407, 'DE', 'DEU', 'ألمانيا'),
(59254, 3262740408, 3262740583, 'NL', 'NLD', 'هولندا'),
(59255, 3262740584, 3262740591, 'DE', 'DEU', 'ألمانيا'),
(59256, 3262740592, 3262740775, 'NL', 'NLD', 'هولندا'),
(59257, 3262740776, 3262740783, 'DE', 'DEU', 'ألمانيا'),
(59258, 3262740784, 3262740815, 'NL', 'NLD', 'هولندا'),
(59259, 3262740816, 3262740823, 'DE', 'DEU', 'ألمانيا'),
(59260, 3262740824, 3262740911, 'NL', 'NLD', 'هولندا'),
(59261, 3262740912, 3262740919, 'DE', 'DEU', 'ألمانيا'),
(59262, 3262740920, 3262740967, 'NL', 'NLD', 'هولندا'),
(59263, 3262740968, 3262740975, 'DE', 'DEU', 'ألمانيا'),
(59264, 3262740976, 3262740991, 'NL', 'NLD', 'هولندا'),
(59265, 3262740992, 3262740999, 'DE', 'DEU', 'ألمانيا'),
(59266, 3262741000, 3262741031, 'NL', 'NLD', 'هولندا'),
(59267, 3262741032, 3262741039, 'DE', 'DEU', 'ألمانيا'),
(59268, 3262741040, 3262741103, 'NL', 'NLD', 'هولندا'),
(59269, 3262741104, 3262741111, 'DE', 'DEU', 'ألمانيا'),
(59270, 3262741112, 3262741231, 'NL', 'NLD', 'هولندا'),
(59271, 3262741232, 3262741239, 'DE', 'DEU', 'ألمانيا'),
(59272, 3262741240, 3262741247, 'NL', 'NLD', 'هولندا'),
(59273, 3262741248, 3262741503, 'DE', 'DEU', 'ألمانيا'),
(59274, 3262741504, 3262741559, 'NL', 'NLD', 'هولندا'),
(59275, 3262741560, 3262741575, 'DE', 'DEU', 'ألمانيا'),
(59276, 3262741576, 3262741655, 'NL', 'NLD', 'هولندا'),
(59277, 3262741656, 3262741663, 'DE', 'DEU', 'ألمانيا'),
(59278, 3262741664, 3262741695, 'NL', 'NLD', 'هولندا'),
(59279, 3262741696, 3262741703, 'DE', 'DEU', 'ألمانيا'),
(59280, 3262741704, 3262741823, 'NL', 'NLD', 'هولندا'),
(59281, 3262741824, 3262741831, 'DE', 'DEU', 'ألمانيا'),
(59282, 3262741832, 3262741839, 'NL', 'NLD', 'هولندا'),
(59283, 3262741840, 3262741847, 'DE', 'DEU', 'ألمانيا'),
(59284, 3262741848, 3262741935, 'NL', 'NLD', 'هولندا'),
(59285, 3262741936, 3262741943, 'DE', 'DEU', 'ألمانيا'),
(59286, 3262741944, 3262741959, 'NL', 'NLD', 'هولندا'),
(59287, 3262741960, 3262741983, 'DE', 'DEU', 'ألمانيا'),
(59288, 3262741984, 3262742095, 'NL', 'NLD', 'هولندا'),
(59289, 3262742096, 3262742103, 'DE', 'DEU', 'ألمانيا'),
(59290, 3262742104, 3262742111, 'NL', 'NLD', 'هولندا'),
(59291, 3262742112, 3262742119, 'DE', 'DEU', 'ألمانيا'),
(59292, 3262742120, 3262742143, 'NL', 'NLD', 'هولندا'),
(59293, 3262742144, 3262742151, 'DE', 'DEU', 'ألمانيا'),
(59294, 3262742152, 3262742159, 'NL', 'NLD', 'هولندا'),
(59295, 3262742160, 3262742167, 'DE', 'DEU', 'ألمانيا'),
(59296, 3262742168, 3262742183, 'NL', 'NLD', 'هولندا'),
(59297, 3262742184, 3262742191, 'DE', 'DEU', 'ألمانيا'),
(59298, 3262742192, 3262742207, 'NL', 'NLD', 'هولندا'),
(59299, 3262742208, 3262742215, 'DE', 'DEU', 'ألمانيا'),
(59300, 3262742216, 3262742287, 'NL', 'NLD', 'هولندا'),
(59301, 3262742288, 3262742295, 'DE', 'DEU', 'ألمانيا'),
(59302, 3262742296, 3262742399, 'NL', 'NLD', 'هولندا'),
(59303, 3262742400, 3262742407, 'DE', 'DEU', 'ألمانيا'),
(59304, 3262742408, 3262742431, 'NL', 'NLD', 'هولندا'),
(59305, 3262742432, 3262742439, 'DE', 'DEU', 'ألمانيا'),
(59306, 3262742440, 3262742455, 'NL', 'NLD', 'هولندا'),
(59307, 3262742456, 3262742463, 'DE', 'DEU', 'ألمانيا'),
(59308, 3262742464, 3262742511, 'NL', 'NLD', 'هولندا'),
(59309, 3262742512, 3262742519, 'DE', 'DEU', 'ألمانيا'),
(59310, 3262742520, 3262742647, 'NL', 'NLD', 'هولندا'),
(59311, 3262742648, 3262742663, 'DE', 'DEU', 'ألمانيا'),
(59312, 3262742664, 3262742695, 'NL', 'NLD', 'هولندا'),
(59313, 3262742696, 3262742703, 'DE', 'DEU', 'ألمانيا'),
(59314, 3262742704, 3262742847, 'NL', 'NLD', 'هولندا'),
(59315, 3262742848, 3262742855, 'DE', 'DEU', 'ألمانيا'),
(59316, 3262742856, 3262742863, 'NL', 'NLD', 'هولندا'),
(59317, 3262742864, 3262742871, 'DE', 'DEU', 'ألمانيا'),
(59318, 3262742872, 3262742879, 'NL', 'NLD', 'هولندا'),
(59319, 3262742880, 3262742887, 'DE', 'DEU', 'ألمانيا'),
(59320, 3262742888, 3262742895, 'NL', 'NLD', 'هولندا'),
(59321, 3262742896, 3262742911, 'DE', 'DEU', 'ألمانيا'),
(59322, 3262742912, 3262743135, 'NL', 'NLD', 'هولندا'),
(59323, 3262743136, 3262743143, 'DE', 'DEU', 'ألمانيا'),
(59324, 3262743144, 3262743167, 'NL', 'NLD', 'هولندا'),
(59325, 3262743168, 3262743175, 'DE', 'DEU', 'ألمانيا'),
(59326, 3262743176, 3262743191, 'NL', 'NLD', 'هولندا'),
(59327, 3262743192, 3262743199, 'DE', 'DEU', 'ألمانيا'),
(59328, 3262743200, 3262743247, 'NL', 'NLD', 'هولندا'),
(59329, 3262743248, 3262743255, 'DE', 'DEU', 'ألمانيا'),
(59330, 3262743256, 3262743415, 'NL', 'NLD', 'هولندا'),
(59331, 3262743416, 3262743423, 'DE', 'DEU', 'ألمانيا'),
(59332, 3262743424, 3262743455, 'NL', 'NLD', 'هولندا'),
(59333, 3262743456, 3262743463, 'DE', 'DEU', 'ألمانيا'),
(59334, 3262743464, 3262743535, 'NL', 'NLD', 'هولندا'),
(59335, 3262743536, 3262743543, 'DE', 'DEU', 'ألمانيا'),
(59336, 3262743544, 3262743583, 'NL', 'NLD', 'هولندا'),
(59337, 3262743584, 3262743591, 'DE', 'DEU', 'ألمانيا'),
(59338, 3262743592, 3262743767, 'NL', 'NLD', 'هولندا'),
(59339, 3262743768, 3262743775, 'DE', 'DEU', 'ألمانيا'),
(59340, 3262743776, 3262743831, 'NL', 'NLD', 'هولندا'),
(59341, 3262743832, 3262743839, 'DE', 'DEU', 'ألمانيا'),
(59342, 3262743840, 3262743871, 'NL', 'NLD', 'هولندا'),
(59343, 3262743872, 3262743879, 'DE', 'DEU', 'ألمانيا'),
(59344, 3262743880, 3262743935, 'NL', 'NLD', 'هولندا'),
(59345, 3262743936, 3262743943, 'DE', 'DEU', 'ألمانيا'),
(59346, 3262743944, 3262744039, 'NL', 'NLD', 'هولندا'),
(59347, 3262744040, 3262744047, 'DE', 'DEU', 'ألمانيا'),
(59348, 3262744048, 3262744095, 'NL', 'NLD', 'هولندا'),
(59349, 3262744096, 3262744103, 'DE', 'DEU', 'ألمانيا'),
(59350, 3262744104, 3262744215, 'NL', 'NLD', 'هولندا'),
(59351, 3262744216, 3262744223, 'DE', 'DEU', 'ألمانيا'),
(59352, 3262744224, 3262744351, 'NL', 'NLD', 'هولندا'),
(59353, 3262744352, 3262744359, 'DE', 'DEU', 'ألمانيا'),
(59354, 3262744360, 3262744375, 'NL', 'NLD', 'هولندا'),
(59355, 3262744376, 3262744383, 'DE', 'DEU', 'ألمانيا'),
(59356, 3262744384, 3262744439, 'NL', 'NLD', 'هولندا'),
(59357, 3262744440, 3262744447, 'DE', 'DEU', 'ألمانيا'),
(59358, 3262744448, 3262744623, 'NL', 'NLD', 'هولندا'),
(59359, 3262744624, 3262744631, 'DE', 'DEU', 'ألمانيا'),
(59360, 3262744632, 3262744647, 'NL', 'NLD', 'هولندا'),
(59361, 3262744648, 3262744663, 'DE', 'DEU', 'ألمانيا'),
(59362, 3262744664, 3262744895, 'NL', 'NLD', 'هولندا'),
(59363, 3262744896, 3262744903, 'DE', 'DEU', 'ألمانيا'),
(59364, 3262744904, 3262744943, 'NL', 'NLD', 'هولندا'),
(59365, 3262744944, 3262744951, 'DE', 'DEU', 'ألمانيا'),
(59366, 3262744952, 3262745087, 'NL', 'NLD', 'هولندا'),
(59367, 3262745088, 3262745103, 'DE', 'DEU', 'ألمانيا'),
(59368, 3262745104, 3262745151, 'NL', 'NLD', 'هولندا'),
(59369, 3262745152, 3262745159, 'DE', 'DEU', 'ألمانيا'),
(59370, 3262745160, 3262745311, 'NL', 'NLD', 'هولندا'),
(59371, 3262745312, 3262745319, 'DE', 'DEU', 'ألمانيا'),
(59372, 3262745320, 3262745327, 'NL', 'NLD', 'هولندا'),
(59373, 3262745328, 3262745335, 'DE', 'DEU', 'ألمانيا'),
(59374, 3262745336, 3262745351, 'NL', 'NLD', 'هولندا'),
(59375, 3262745352, 3262745367, 'DE', 'DEU', 'ألمانيا'),
(59376, 3262745368, 3262745575, 'NL', 'NLD', 'هولندا'),
(59377, 3262745576, 3262745583, 'DE', 'DEU', 'ألمانيا'),
(59378, 3262745584, 3262745727, 'NL', 'NLD', 'هولندا'),
(59379, 3262745728, 3262745735, 'DE', 'DEU', 'ألمانيا'),
(59380, 3262745736, 3262745743, 'NL', 'NLD', 'هولندا'),
(59381, 3262745744, 3262745751, 'DE', 'DEU', 'ألمانيا'),
(59382, 3262745752, 3262745807, 'NL', 'NLD', 'هولندا'),
(59383, 3262745808, 3262745823, 'DE', 'DEU', 'ألمانيا'),
(59384, 3262745824, 3262745831, 'NL', 'NLD', 'هولندا'),
(59385, 3262745832, 3262745847, 'DE', 'DEU', 'ألمانيا'),
(59386, 3262745848, 3262745959, 'NL', 'NLD', 'هولندا'),
(59387, 3262745960, 3262745967, 'DE', 'DEU', 'ألمانيا'),
(59388, 3262745968, 3262745983, 'NL', 'NLD', 'هولندا'),
(59389, 3262745984, 3262745991, 'DE', 'DEU', 'ألمانيا'),
(59390, 3262745992, 3262746031, 'NL', 'NLD', 'هولندا'),
(59391, 3262746032, 3262746039, 'DE', 'DEU', 'ألمانيا'),
(59392, 3262746040, 3262746055, 'NL', 'NLD', 'هولندا'),
(59393, 3262746056, 3262746063, 'DE', 'DEU', 'ألمانيا'),
(59394, 3262746064, 3262746079, 'NL', 'NLD', 'هولندا'),
(59395, 3262746080, 3262746087, 'DE', 'DEU', 'ألمانيا'),
(59396, 3262746088, 3262746111, 'NL', 'NLD', 'هولندا'),
(59397, 3262746112, 3262746119, 'DE', 'DEU', 'ألمانيا'),
(59398, 3262746120, 3262746175, 'NL', 'NLD', 'هولندا'),
(59399, 3262746176, 3262746183, 'DE', 'DEU', 'ألمانيا'),
(59400, 3262746184, 3262746255, 'NL', 'NLD', 'هولندا'),
(59401, 3262746256, 3262746263, 'DE', 'DEU', 'ألمانيا'),
(59402, 3262746264, 3262746343, 'NL', 'NLD', 'هولندا'),
(59403, 3262746344, 3262746351, 'DE', 'DEU', 'ألمانيا'),
(59404, 3262746352, 3262746479, 'NL', 'NLD', 'هولندا'),
(59405, 3262746480, 3262746487, 'DE', 'DEU', 'ألمانيا'),
(59406, 3262746488, 3262746519, 'NL', 'NLD', 'هولندا'),
(59407, 3262746520, 3262746527, 'DE', 'DEU', 'ألمانيا'),
(59408, 3262746528, 3262746535, 'NL', 'NLD', 'هولندا'),
(59409, 3262746536, 3262746543, 'DE', 'DEU', 'ألمانيا'),
(59410, 3262746544, 3262746783, 'NL', 'NLD', 'هولندا'),
(59411, 3262746784, 3262746799, 'DE', 'DEU', 'ألمانيا'),
(59412, 3262746800, 3262746855, 'NL', 'NLD', 'هولندا'),
(59413, 3262746856, 3262746863, 'DE', 'DEU', 'ألمانيا'),
(59414, 3262746864, 3262746895, 'NL', 'NLD', 'هولندا'),
(59415, 3262746896, 3262746903, 'DE', 'DEU', 'ألمانيا'),
(59416, 3262746904, 3262746951, 'NL', 'NLD', 'هولندا'),
(59417, 3262746952, 3262746959, 'DE', 'DEU', 'ألمانيا'),
(59418, 3262746960, 3262747079, 'NL', 'NLD', 'هولندا'),
(59419, 3262747080, 3262747087, 'DE', 'DEU', 'ألمانيا'),
(59420, 3262747088, 3262747095, 'NL', 'NLD', 'هولندا'),
(59421, 3262747096, 3262747103, 'DE', 'DEU', 'ألمانيا'),
(59422, 3262747104, 3262747135, 'NL', 'NLD', 'هولندا'),
(59423, 3262747136, 3262747143, 'DE', 'DEU', 'ألمانيا'),
(59424, 3262747144, 3262747183, 'NL', 'NLD', 'هولندا'),
(59425, 3262747184, 3262747191, 'DE', 'DEU', 'ألمانيا'),
(59426, 3262747192, 3262747295, 'NL', 'NLD', 'هولندا'),
(59427, 3262747296, 3262747303, 'DE', 'DEU', 'ألمانيا'),
(59428, 3262747304, 3262747423, 'NL', 'NLD', 'هولندا'),
(59429, 3262747424, 3262747431, 'DE', 'DEU', 'ألمانيا'),
(59430, 3262747432, 3262747551, 'NL', 'NLD', 'هولندا'),
(59431, 3262747552, 3262747559, 'DE', 'DEU', 'ألمانيا'),
(59432, 3262747560, 3262747591, 'NL', 'NLD', 'هولندا'),
(59433, 3262747592, 3262747599, 'DE', 'DEU', 'ألمانيا'),
(59434, 3262747600, 3262747615, 'NL', 'NLD', 'هولندا'),
(59435, 3262747616, 3262747623, 'DE', 'DEU', 'ألمانيا'),
(59436, 3262747624, 3262747631, 'NL', 'NLD', 'هولندا'),
(59437, 3262747632, 3262747639, 'DE', 'DEU', 'ألمانيا'),
(59438, 3262747640, 3262747647, 'NL', 'NLD', 'هولندا'),
(59439, 3262747648, 3262747655, 'DE', 'DEU', 'ألمانيا'),
(59440, 3262747656, 3262747719, 'NL', 'NLD', 'هولندا'),
(59441, 3262747720, 3262747727, 'DE', 'DEU', 'ألمانيا'),
(59442, 3262747728, 3262748231, 'NL', 'NLD', 'هولندا'),
(59443, 3262748232, 3262748239, 'DE', 'DEU', 'ألمانيا'),
(59444, 3262748240, 3262748431, 'NL', 'NLD', 'هولندا'),
(59445, 3262748432, 3262748463, 'DE', 'DEU', 'ألمانيا'),
(59446, 3262748464, 3262748487, 'NL', 'NLD', 'هولندا'),
(59447, 3262748488, 3262748495, 'DE', 'DEU', 'ألمانيا'),
(59448, 3262748496, 3262748511, 'NL', 'NLD', 'هولندا'),
(59449, 3262748512, 3262748519, 'DE', 'DEU', 'ألمانيا'),
(59450, 3262748520, 3262748999, 'NL', 'NLD', 'هولندا'),
(59451, 3262749000, 3262749007, 'DE', 'DEU', 'ألمانيا'),
(59452, 3262749008, 3262749231, 'NL', 'NLD', 'هولندا'),
(59453, 3262749232, 3262749239, 'DE', 'DEU', 'ألمانيا'),
(59454, 3262749240, 3262749303, 'NL', 'NLD', 'هولندا'),
(59455, 3262749304, 3262749311, 'DE', 'DEU', 'ألمانيا'),
(59456, 3262749312, 3262749431, 'NL', 'NLD', 'هولندا'),
(59457, 3262749432, 3262749439, 'DE', 'DEU', 'ألمانيا'),
(59458, 3262749440, 3262749519, 'NL', 'NLD', 'هولندا'),
(59459, 3262749520, 3262749527, 'DE', 'DEU', 'ألمانيا'),
(59460, 3262749528, 3262749567, 'NL', 'NLD', 'هولندا'),
(59461, 3262749568, 3262749575, 'DE', 'DEU', 'ألمانيا'),
(59462, 3262749576, 3262749671, 'NL', 'NLD', 'هولندا'),
(59463, 3262749672, 3262749679, 'DE', 'DEU', 'ألمانيا'),
(59464, 3262749680, 3262749719, 'NL', 'NLD', 'هولندا'),
(59465, 3262749720, 3262749727, 'DE', 'DEU', 'ألمانيا'),
(59466, 3262749728, 3262749759, 'NL', 'NLD', 'هولندا'),
(59467, 3262749760, 3262749767, 'DE', 'DEU', 'ألمانيا'),
(59468, 3262749768, 3262749807, 'NL', 'NLD', 'هولندا'),
(59469, 3262749808, 3262749815, 'DE', 'DEU', 'ألمانيا'),
(59470, 3262749816, 3262749831, 'NL', 'NLD', 'هولندا'),
(59471, 3262749832, 3262749847, 'DE', 'DEU', 'ألمانيا'),
(59472, 3262749848, 3262749887, 'NL', 'NLD', 'هولندا'),
(59473, 3262749888, 3262749895, 'DE', 'DEU', 'ألمانيا'),
(59474, 3262749896, 3262749927, 'NL', 'NLD', 'هولندا'),
(59475, 3262749928, 3262749935, 'DE', 'DEU', 'ألمانيا'),
(59476, 3262749936, 3262749999, 'NL', 'NLD', 'هولندا'),
(59477, 3262750000, 3262750007, 'DE', 'DEU', 'ألمانيا'),
(59478, 3262750008, 3262750223, 'NL', 'NLD', 'هولندا'),
(59479, 3262750224, 3262750231, 'DE', 'DEU', 'ألمانيا'),
(59480, 3262750232, 3262750303, 'NL', 'NLD', 'هولندا'),
(59481, 3262750304, 3262750311, 'DE', 'DEU', 'ألمانيا'),
(59482, 3262750312, 3262750359, 'NL', 'NLD', 'هولندا'),
(59483, 3262750360, 3262750367, 'DE', 'DEU', 'ألمانيا'),
(59484, 3262750368, 3262750511, 'NL', 'NLD', 'هولندا'),
(59485, 3262750512, 3262750519, 'DE', 'DEU', 'ألمانيا'),
(59486, 3262750520, 3262750647, 'NL', 'NLD', 'هولندا'),
(59487, 3262750648, 3262750655, 'DE', 'DEU', 'ألمانيا'),
(59488, 3262750656, 3262750727, 'NL', 'NLD', 'هولندا'),
(59489, 3262750728, 3262750735, 'DE', 'DEU', 'ألمانيا'),
(59490, 3262750736, 3262750767, 'NL', 'NLD', 'هولندا'),
(59491, 3262750768, 3262750775, 'DE', 'DEU', 'ألمانيا'),
(59492, 3262750776, 3262750791, 'NL', 'NLD', 'هولندا'),
(59493, 3262750792, 3262750799, 'DE', 'DEU', 'ألمانيا'),
(59494, 3262750800, 3262751031, 'NL', 'NLD', 'هولندا'),
(59495, 3262751032, 3262751039, 'DE', 'DEU', 'ألمانيا'),
(59496, 3262751040, 3262751207, 'NL', 'NLD', 'هولندا'),
(59497, 3262751208, 3262751215, 'DE', 'DEU', 'ألمانيا'),
(59498, 3262751216, 3262751327, 'NL', 'NLD', 'هولندا'),
(59499, 3262751328, 3262751335, 'DE', 'DEU', 'ألمانيا'),
(59500, 3262751336, 3262751391, 'NL', 'NLD', 'هولندا'),
(59501, 3262751392, 3262751399, 'DE', 'DEU', 'ألمانيا'),
(59502, 3262751400, 3262751695, 'NL', 'NLD', 'هولندا'),
(59503, 3262751696, 3262751703, 'DE', 'DEU', 'ألمانيا'),
(59504, 3262751704, 3262751863, 'NL', 'NLD', 'هولندا'),
(59505, 3262751864, 3262751871, 'DE', 'DEU', 'ألمانيا'),
(59506, 3262751872, 3262751887, 'NL', 'NLD', 'هولندا'),
(59507, 3262751888, 3262751895, 'DE', 'DEU', 'ألمانيا'),
(59508, 3262751896, 3262751927, 'NL', 'NLD', 'هولندا'),
(59509, 3262751928, 3262751935, 'DE', 'DEU', 'ألمانيا'),
(59510, 3262751936, 3262752055, 'NL', 'NLD', 'هولندا'),
(59511, 3262752056, 3262752063, 'DE', 'DEU', 'ألمانيا'),
(59512, 3262752064, 3262752279, 'NL', 'NLD', 'هولندا'),
(59513, 3262752280, 3262752287, 'DE', 'DEU', 'ألمانيا'),
(59514, 3262752288, 3262752343, 'NL', 'NLD', 'هولندا'),
(59515, 3262752344, 3262752351, 'DE', 'DEU', 'ألمانيا'),
(59516, 3262752352, 3262752399, 'NL', 'NLD', 'هولندا'),
(59517, 3262752400, 3262752407, 'DE', 'DEU', 'ألمانيا'),
(59518, 3262752408, 3262752599, 'NL', 'NLD', 'هولندا'),
(59519, 3262752600, 3262752607, 'DE', 'DEU', 'ألمانيا'),
(59520, 3262752608, 3262752663, 'NL', 'NLD', 'هولندا'),
(59521, 3262752664, 3262752671, 'DE', 'DEU', 'ألمانيا'),
(59522, 3262752672, 3262752799, 'NL', 'NLD', 'هولندا'),
(59523, 3262752800, 3262752807, 'DE', 'DEU', 'ألمانيا'),
(59524, 3262752808, 3262752847, 'NL', 'NLD', 'هولندا'),
(59525, 3262752848, 3262752855, 'DE', 'DEU', 'ألمانيا'),
(59526, 3262752856, 3262752887, 'NL', 'NLD', 'هولندا'),
(59527, 3262752888, 3262752895, 'DE', 'DEU', 'ألمانيا'),
(59528, 3262752896, 3262753015, 'NL', 'NLD', 'هولندا'),
(59529, 3262753016, 3262753023, 'DE', 'DEU', 'ألمانيا'),
(59530, 3262753024, 3262753079, 'NL', 'NLD', 'هولندا'),
(59531, 3262753080, 3262753087, 'DE', 'DEU', 'ألمانيا'),
(59532, 3262753088, 3262753175, 'NL', 'NLD', 'هولندا'),
(59533, 3262753176, 3262753183, 'DE', 'DEU', 'ألمانيا'),
(59534, 3262753184, 3262753287, 'NL', 'NLD', 'هولندا'),
(59535, 3262753288, 3262753295, 'DE', 'DEU', 'ألمانيا'),
(59536, 3262753296, 3262753319, 'NL', 'NLD', 'هولندا'),
(59537, 3262753320, 3262753327, 'DE', 'DEU', 'ألمانيا'),
(59538, 3262753328, 3262753375, 'NL', 'NLD', 'هولندا'),
(59539, 3262753376, 3262753383, 'DE', 'DEU', 'ألمانيا'),
(59540, 3262753384, 3262753487, 'NL', 'NLD', 'هولندا'),
(59541, 3262753488, 3262753495, 'DE', 'DEU', 'ألمانيا'),
(59542, 3262753496, 3262753503, 'NL', 'NLD', 'هولندا'),
(59543, 3262753504, 3262753511, 'DE', 'DEU', 'ألمانيا'),
(59544, 3262753512, 3262753519, 'NL', 'NLD', 'هولندا'),
(59545, 3262753520, 3262753527, 'DE', 'DEU', 'ألمانيا'),
(59546, 3262753528, 3262753543, 'NL', 'NLD', 'هولندا'),
(59547, 3262753544, 3262753551, 'DE', 'DEU', 'ألمانيا'),
(59548, 3262753552, 3262753743, 'NL', 'NLD', 'هولندا'),
(59549, 3262753744, 3262753751, 'DE', 'DEU', 'ألمانيا'),
(59550, 3262753752, 3262753783, 'NL', 'NLD', 'هولندا'),
(59551, 3262753784, 3262754815, 'DE', 'DEU', 'ألمانيا'),
(59552, 3262754816, 3262754983, 'NL', 'NLD', 'هولندا'),
(59553, 3262754984, 3262754991, 'DE', 'DEU', 'ألمانيا'),
(59554, 3262754992, 3262755015, 'NL', 'NLD', 'هولندا'),
(59555, 3262755016, 3262755023, 'DE', 'DEU', 'ألمانيا'),
(59556, 3262755024, 3262755055, 'NL', 'NLD', 'هولندا'),
(59557, 3262755056, 3262755063, 'DE', 'DEU', 'ألمانيا'),
(59558, 3262755064, 3262755223, 'NL', 'NLD', 'هولندا'),
(59559, 3262755224, 3262755231, 'DE', 'DEU', 'ألمانيا'),
(59560, 3262755232, 3262755303, 'NL', 'NLD', 'هولندا'),
(59561, 3262755304, 3262755311, 'DE', 'DEU', 'ألمانيا'),
(59562, 3262755312, 3262755615, 'NL', 'NLD', 'هولندا'),
(59563, 3262755616, 3262755623, 'DE', 'DEU', 'ألمانيا'),
(59564, 3262755624, 3262755663, 'NL', 'NLD', 'هولندا'),
(59565, 3262755664, 3262755671, 'DE', 'DEU', 'ألمانيا'),
(59566, 3262755672, 3262755703, 'NL', 'NLD', 'هولندا'),
(59567, 3262755704, 3262755711, 'DE', 'DEU', 'ألمانيا'),
(59568, 3262755712, 3262755815, 'NL', 'NLD', 'هولندا'),
(59569, 3262755816, 3262755823, 'DE', 'DEU', 'ألمانيا'),
(59570, 3262755824, 3262755975, 'NL', 'NLD', 'هولندا'),
(59571, 3262755976, 3262755983, 'DE', 'DEU', 'ألمانيا'),
(59572, 3262755984, 3262756031, 'NL', 'NLD', 'هولندا'),
(59573, 3262756032, 3262756039, 'DE', 'DEU', 'ألمانيا'),
(59574, 3262756040, 3262756087, 'NL', 'NLD', 'هولندا'),
(59575, 3262756088, 3262756095, 'DE', 'DEU', 'ألمانيا'),
(59576, 3262756096, 3262756215, 'NL', 'NLD', 'هولندا'),
(59577, 3262756216, 3262756223, 'DE', 'DEU', 'ألمانيا'),
(59578, 3262756224, 3262756343, 'NL', 'NLD', 'هولندا'),
(59579, 3262756344, 3262756367, 'DE', 'DEU', 'ألمانيا'),
(59580, 3262756368, 3262756479, 'NL', 'NLD', 'هولندا'),
(59581, 3262756480, 3262756487, 'DE', 'DEU', 'ألمانيا'),
(59582, 3262756488, 3262756511, 'NL', 'NLD', 'هولندا'),
(59583, 3262756512, 3262756519, 'DE', 'DEU', 'ألمانيا'),
(59584, 3262756520, 3262756535, 'NL', 'NLD', 'هولندا'),
(59585, 3262756536, 3262756543, 'DE', 'DEU', 'ألمانيا'),
(59586, 3262756544, 3262756687, 'NL', 'NLD', 'هولندا'),
(59587, 3262756688, 3262756695, 'DE', 'DEU', 'ألمانيا'),
(59588, 3262756696, 3262756711, 'NL', 'NLD', 'هولندا'),
(59589, 3262756712, 3262756719, 'DE', 'DEU', 'ألمانيا'),
(59590, 3262756720, 3262756735, 'NL', 'NLD', 'هولندا'),
(59591, 3262756736, 3262756743, 'DE', 'DEU', 'ألمانيا'),
(59592, 3262756744, 3262756751, 'NL', 'NLD', 'هولندا'),
(59593, 3262756752, 3262756759, 'DE', 'DEU', 'ألمانيا'),
(59594, 3262756760, 3262756879, 'NL', 'NLD', 'هولندا'),
(59595, 3262756880, 3262756887, 'DE', 'DEU', 'ألمانيا'),
(59596, 3262756888, 3262756903, 'NL', 'NLD', 'هولندا'),
(59597, 3262756904, 3262756911, 'DE', 'DEU', 'ألمانيا'),
(59598, 3262756912, 3262756967, 'NL', 'NLD', 'هولندا'),
(59599, 3262756968, 3262756983, 'DE', 'DEU', 'ألمانيا'),
(59600, 3262756984, 3262757007, 'NL', 'NLD', 'هولندا'),
(59601, 3262757008, 3262757015, 'DE', 'DEU', 'ألمانيا'),
(59602, 3262757016, 3262757207, 'NL', 'NLD', 'هولندا'),
(59603, 3262757208, 3262757215, 'DE', 'DEU', 'ألمانيا'),
(59604, 3262757216, 3262757327, 'NL', 'NLD', 'هولندا'),
(59605, 3262757328, 3262757335, 'DE', 'DEU', 'ألمانيا'),
(59606, 3262757336, 3262757359, 'NL', 'NLD', 'هولندا'),
(59607, 3262757360, 3262757367, 'DE', 'DEU', 'ألمانيا'),
(59608, 3262757368, 3262757487, 'NL', 'NLD', 'هولندا'),
(59609, 3262757488, 3262757495, 'DE', 'DEU', 'ألمانيا'),
(59610, 3262757496, 3262757647, 'NL', 'NLD', 'هولندا'),
(59611, 3262757648, 3262757655, 'DE', 'DEU', 'ألمانيا'),
(59612, 3262757656, 3262757671, 'NL', 'NLD', 'هولندا'),
(59613, 3262757672, 3262757679, 'DE', 'DEU', 'ألمانيا'),
(59614, 3262757680, 3262757975, 'NL', 'NLD', 'هولندا'),
(59615, 3262757976, 3262758007, 'DE', 'DEU', 'ألمانيا'),
(59616, 3262758008, 3262758127, 'NL', 'NLD', 'هولندا'),
(59617, 3262758128, 3262758135, 'DE', 'DEU', 'ألمانيا'),
(59618, 3262758136, 3262758183, 'NL', 'NLD', 'هولندا'),
(59619, 3262758184, 3262758191, 'DE', 'DEU', 'ألمانيا'),
(59620, 3262758192, 3262758223, 'NL', 'NLD', 'هولندا'),
(59621, 3262758224, 3262758231, 'DE', 'DEU', 'ألمانيا'),
(59622, 3262758232, 3262758343, 'NL', 'NLD', 'هولندا'),
(59623, 3262758344, 3262758351, 'DE', 'DEU', 'ألمانيا'),
(59624, 3262758352, 3262758535, 'NL', 'NLD', 'هولندا'),
(59625, 3262758536, 3262758543, 'DE', 'DEU', 'ألمانيا'),
(59626, 3262758544, 3262758551, 'NL', 'NLD', 'هولندا'),
(59627, 3262758552, 3262758559, 'DE', 'DEU', 'ألمانيا'),
(59628, 3262758560, 3262758567, 'NL', 'NLD', 'هولندا'),
(59629, 3262758568, 3262758575, 'DE', 'DEU', 'ألمانيا'),
(59630, 3262758576, 3262758759, 'NL', 'NLD', 'هولندا'),
(59631, 3262758760, 3262758767, 'DE', 'DEU', 'ألمانيا'),
(59632, 3262758768, 3262758775, 'NL', 'NLD', 'هولندا'),
(59633, 3262758776, 3262758783, 'DE', 'DEU', 'ألمانيا'),
(59634, 3262758784, 3262758815, 'NL', 'NLD', 'هولندا'),
(59635, 3262758816, 3262758831, 'DE', 'DEU', 'ألمانيا'),
(59636, 3262758832, 3262758855, 'NL', 'NLD', 'هولندا'),
(59637, 3262758856, 3262758887, 'DE', 'DEU', 'ألمانيا'),
(59638, 3262758888, 3262758951, 'NL', 'NLD', 'هولندا'),
(59639, 3262758952, 3262758967, 'DE', 'DEU', 'ألمانيا'),
(59640, 3262758968, 3262758991, 'NL', 'NLD', 'هولندا'),
(59641, 3262758992, 3262758999, 'DE', 'DEU', 'ألمانيا'),
(59642, 3262759000, 3262759119, 'NL', 'NLD', 'هولندا'),
(59643, 3262759120, 3262759127, 'DE', 'DEU', 'ألمانيا'),
(59644, 3262759128, 3262759263, 'NL', 'NLD', 'هولندا'),
(59645, 3262759264, 3262759271, 'DE', 'DEU', 'ألمانيا'),
(59646, 3262759272, 3262759311, 'NL', 'NLD', 'هولندا'),
(59647, 3262759312, 3262759319, 'DE', 'DEU', 'ألمانيا'),
(59648, 3262759320, 3262759335, 'NL', 'NLD', 'هولندا'),
(59649, 3262759336, 3262759343, 'DE', 'DEU', 'ألمانيا'),
(59650, 3262759344, 3262759351, 'NL', 'NLD', 'هولندا'),
(59651, 3262759352, 3262759359, 'DE', 'DEU', 'ألمانيا'),
(59652, 3262759360, 3262759415, 'NL', 'NLD', 'هولندا'),
(59653, 3262759416, 3262759423, 'DE', 'DEU', 'ألمانيا'),
(59654, 3262759424, 3262759455, 'NL', 'NLD', 'هولندا'),
(59655, 3262759456, 3262759463, 'DE', 'DEU', 'ألمانيا'),
(59656, 3262759464, 3262759503, 'NL', 'NLD', 'هولندا'),
(59657, 3262759504, 3262759511, 'DE', 'DEU', 'ألمانيا'),
(59658, 3262759512, 3262759527, 'NL', 'NLD', 'هولندا'),
(59659, 3262759528, 3262759543, 'DE', 'DEU', 'ألمانيا'),
(59660, 3262759544, 3262759575, 'NL', 'NLD', 'هولندا'),
(59661, 3262759576, 3262759583, 'DE', 'DEU', 'ألمانيا'),
(59662, 3262759584, 3262759607, 'NL', 'NLD', 'هولندا'),
(59663, 3262759608, 3262759615, 'DE', 'DEU', 'ألمانيا'),
(59664, 3262759616, 3262759639, 'NL', 'NLD', 'هولندا'),
(59665, 3262759640, 3262759647, 'DE', 'DEU', 'ألمانيا'),
(59666, 3262759648, 3262759695, 'NL', 'NLD', 'هولندا'),
(59667, 3262759696, 3262759703, 'DE', 'DEU', 'ألمانيا'),
(59668, 3262759704, 3262759735, 'NL', 'NLD', 'هولندا'),
(59669, 3262759736, 3262759743, 'DE', 'DEU', 'ألمانيا'),
(59670, 3262759744, 3262759927, 'NL', 'NLD', 'هولندا'),
(59671, 3262759928, 3262759935, 'DE', 'DEU', 'ألمانيا'),
(59672, 3262759936, 3262759943, 'NL', 'NLD', 'هولندا'),
(59673, 3262759944, 3262759951, 'DE', 'DEU', 'ألمانيا'),
(59674, 3262759952, 3262759959, 'NL', 'NLD', 'هولندا'),
(59675, 3262759960, 3262759967, 'DE', 'DEU', 'ألمانيا'),
(59676, 3262759968, 3262759991, 'NL', 'NLD', 'هولندا'),
(59677, 3262759992, 3262759999, 'DE', 'DEU', 'ألمانيا'),
(59678, 3262760000, 3262760039, 'NL', 'NLD', 'هولندا'),
(59679, 3262760040, 3262760047, 'DE', 'DEU', 'ألمانيا'),
(59680, 3262760048, 3262760055, 'NL', 'NLD', 'هولندا'),
(59681, 3262760056, 3262760063, 'DE', 'DEU', 'ألمانيا'),
(59682, 3262760064, 3262760151, 'NL', 'NLD', 'هولندا'),
(59683, 3262760152, 3262760159, 'DE', 'DEU', 'ألمانيا'),
(59684, 3262760160, 3262760343, 'NL', 'NLD', 'هولندا'),
(59685, 3262760344, 3262760351, 'DE', 'DEU', 'ألمانيا'),
(59686, 3262760352, 3262760367, 'NL', 'NLD', 'هولندا'),
(59687, 3262760368, 3262760375, 'DE', 'DEU', 'ألمانيا'),
(59688, 3262760376, 3262760471, 'NL', 'NLD', 'هولندا'),
(59689, 3262760472, 3262760479, 'DE', 'DEU', 'ألمانيا'),
(59690, 3262760480, 3262760503, 'NL', 'NLD', 'هولندا'),
(59691, 3262760504, 3262760511, 'DE', 'DEU', 'ألمانيا'),
(59692, 3262760512, 3262760575, 'NL', 'NLD', 'هولندا'),
(59693, 3262760576, 3262760583, 'DE', 'DEU', 'ألمانيا'),
(59694, 3262760584, 3262760639, 'NL', 'NLD', 'هولندا'),
(59695, 3262760640, 3262760647, 'DE', 'DEU', 'ألمانيا'),
(59696, 3262760648, 3262760663, 'NL', 'NLD', 'هولندا'),
(59697, 3262760664, 3262760671, 'DE', 'DEU', 'ألمانيا'),
(59698, 3262760672, 3262760791, 'NL', 'NLD', 'هولندا'),
(59699, 3262760792, 3262760799, 'DE', 'DEU', 'ألمانيا'),
(59700, 3262760800, 3262760951, 'NL', 'NLD', 'هولندا'),
(59701, 3262760952, 3262760959, 'DE', 'DEU', 'ألمانيا'),
(59702, 3262760960, 3262760999, 'NL', 'NLD', 'هولندا'),
(59703, 3262761000, 3262761007, 'DE', 'DEU', 'ألمانيا'),
(59704, 3262761008, 3262761119, 'NL', 'NLD', 'هولندا'),
(59705, 3262761120, 3262761127, 'DE', 'DEU', 'ألمانيا'),
(59706, 3262761128, 3262761135, 'NL', 'NLD', 'هولندا'),
(59707, 3262761136, 3262761151, 'DE', 'DEU', 'ألمانيا'),
(59708, 3262761152, 3262761167, 'NL', 'NLD', 'هولندا'),
(59709, 3262761168, 3262761175, 'DE', 'DEU', 'ألمانيا'),
(59710, 3262761176, 3262761215, 'NL', 'NLD', 'هولندا'),
(59711, 3262761216, 3262761223, 'DE', 'DEU', 'ألمانيا'),
(59712, 3262761224, 3262761279, 'NL', 'NLD', 'هولندا'),
(59713, 3262761280, 3262761287, 'DE', 'DEU', 'ألمانيا'),
(59714, 3262761288, 3262761335, 'NL', 'NLD', 'هولندا'),
(59715, 3262761336, 3262761343, 'DE', 'DEU', 'ألمانيا'),
(59716, 3262761344, 3262761711, 'NL', 'NLD', 'هولندا'),
(59717, 3262761712, 3262761719, 'DE', 'DEU', 'ألمانيا'),
(59718, 3262761720, 3262761727, 'NL', 'NLD', 'هولندا'),
(59719, 3262761728, 3262761983, 'DE', 'DEU', 'ألمانيا'),
(59720, 3262761984, 3262761991, 'NL', 'NLD', 'هولندا'),
(59721, 3262761992, 3262762007, 'DE', 'DEU', 'ألمانيا'),
(59722, 3262762008, 3262762079, 'NL', 'NLD', 'هولندا'),
(59723, 3262762080, 3262762087, 'DE', 'DEU', 'ألمانيا'),
(59724, 3262762088, 3262762175, 'NL', 'NLD', 'هولندا'),
(59725, 3262762176, 3262762183, 'DE', 'DEU', 'ألمانيا'),
(59726, 3262762184, 3262762279, 'NL', 'NLD', 'هولندا'),
(59727, 3262762280, 3262762287, 'DE', 'DEU', 'ألمانيا'),
(59728, 3262762288, 3262762359, 'NL', 'NLD', 'هولندا'),
(59729, 3262762360, 3262762367, 'DE', 'DEU', 'ألمانيا'),
(59730, 3262762368, 3262762695, 'NL', 'NLD', 'هولندا'),
(59731, 3262762696, 3262762703, 'DE', 'DEU', 'ألمانيا'),
(59732, 3262762704, 3262762791, 'NL', 'NLD', 'هولندا'),
(59733, 3262762792, 3262762799, 'DE', 'DEU', 'ألمانيا'),
(59734, 3262762800, 3262762807, 'NL', 'NLD', 'هولندا'),
(59735, 3262762808, 3262762815, 'DE', 'DEU', 'ألمانيا'),
(59736, 3262762816, 3262762839, 'NL', 'NLD', 'هولندا'),
(59737, 3262762840, 3262762847, 'DE', 'DEU', 'ألمانيا'),
(59738, 3262762848, 3262762895, 'NL', 'NLD', 'هولندا'),
(59739, 3262762896, 3262762903, 'DE', 'DEU', 'ألمانيا'),
(59740, 3262762904, 3262762935, 'NL', 'NLD', 'هولندا'),
(59741, 3262762936, 3262762943, 'DE', 'DEU', 'ألمانيا'),
(59742, 3262762944, 3262763311, 'NL', 'NLD', 'هولندا'),
(59743, 3262763312, 3262763319, 'DE', 'DEU', 'ألمانيا'),
(59744, 3262763320, 3262763463, 'NL', 'NLD', 'هولندا'),
(59745, 3262763464, 3262763471, 'DE', 'DEU', 'ألمانيا'),
(59746, 3262763472, 3262763487, 'NL', 'NLD', 'هولندا'),
(59747, 3262763488, 3262763495, 'DE', 'DEU', 'ألمانيا'),
(59748, 3262763496, 3262763519, 'NL', 'NLD', 'هولندا'),
(59749, 3262763520, 3262763527, 'DE', 'DEU', 'ألمانيا'),
(59750, 3262763528, 3262763535, 'NL', 'NLD', 'هولندا'),
(59751, 3262763536, 3262763543, 'DE', 'DEU', 'ألمانيا'),
(59752, 3262763544, 3262763551, 'NL', 'NLD', 'هولندا'),
(59753, 3262763552, 3262763559, 'DE', 'DEU', 'ألمانيا'),
(59754, 3262763560, 3262763615, 'NL', 'NLD', 'هولندا'),
(59755, 3262763616, 3262763623, 'DE', 'DEU', 'ألمانيا'),
(59756, 3262763624, 3262763743, 'NL', 'NLD', 'هولندا'),
(59757, 3262763744, 3262763751, 'DE', 'DEU', 'ألمانيا'),
(59758, 3262763752, 3262763839, 'NL', 'NLD', 'هولندا'),
(59759, 3262763840, 3262763847, 'DE', 'DEU', 'ألمانيا'),
(59760, 3262763848, 3262763879, 'NL', 'NLD', 'هولندا'),
(59761, 3262763880, 3262763895, 'DE', 'DEU', 'ألمانيا'),
(59762, 3262763896, 3262763999, 'NL', 'NLD', 'هولندا'),
(59763, 3262764000, 3262764007, 'DE', 'DEU', 'ألمانيا'),
(59764, 3262764008, 3262764015, 'NL', 'NLD', 'هولندا'),
(59765, 3262764016, 3262764023, 'DE', 'DEU', 'ألمانيا'),
(59766, 3262764024, 3262764175, 'NL', 'NLD', 'هولندا'),
(59767, 3262764176, 3262764183, 'DE', 'DEU', 'ألمانيا'),
(59768, 3262764184, 3262764407, 'NL', 'NLD', 'هولندا'),
(59769, 3262764408, 3262764415, 'DE', 'DEU', 'ألمانيا'),
(59770, 3262764416, 3262764551, 'NL', 'NLD', 'هولندا'),
(59771, 3262764552, 3262764559, 'DE', 'DEU', 'ألمانيا'),
(59772, 3262764560, 3262764615, 'NL', 'NLD', 'هولندا'),
(59773, 3262764616, 3262764623, 'DE', 'DEU', 'ألمانيا'),
(59774, 3262764624, 3262764695, 'NL', 'NLD', 'هولندا'),
(59775, 3262764696, 3262764703, 'DE', 'DEU', 'ألمانيا'),
(59776, 3262764704, 3262764719, 'NL', 'NLD', 'هولندا'),
(59777, 3262764720, 3262764727, 'DE', 'DEU', 'ألمانيا'),
(59778, 3262764728, 3262764927, 'NL', 'NLD', 'هولندا'),
(59779, 3262764928, 3262764935, 'DE', 'DEU', 'ألمانيا'),
(59780, 3262764936, 3262765191, 'NL', 'NLD', 'هولندا'),
(59781, 3262765192, 3262765199, 'DE', 'DEU', 'ألمانيا'),
(59782, 3262765200, 3262765335, 'NL', 'NLD', 'هولندا'),
(59783, 3262765336, 3262765343, 'DE', 'DEU', 'ألمانيا'),
(59784, 3262765344, 3262765375, 'NL', 'NLD', 'هولندا'),
(59785, 3262765376, 3262765383, 'DE', 'DEU', 'ألمانيا'),
(59786, 3262765384, 3262765447, 'NL', 'NLD', 'هولندا'),
(59787, 3262765448, 3262765455, 'DE', 'DEU', 'ألمانيا'),
(59788, 3262765456, 3262765535, 'NL', 'NLD', 'هولندا'),
(59789, 3262765536, 3262765543, 'DE', 'DEU', 'ألمانيا'),
(59790, 3262765544, 3262765559, 'NL', 'NLD', 'هولندا'),
(59791, 3262765560, 3262765567, 'DE', 'DEU', 'ألمانيا'),
(59792, 3262765568, 3262765599, 'NL', 'NLD', 'هولندا'),
(59793, 3262765600, 3262765615, 'DE', 'DEU', 'ألمانيا'),
(59794, 3262765616, 3262765663, 'NL', 'NLD', 'هولندا'),
(59795, 3262765664, 3262765671, 'DE', 'DEU', 'ألمانيا'),
(59796, 3262765672, 3262765735, 'NL', 'NLD', 'هولندا'),
(59797, 3262765736, 3262765743, 'DE', 'DEU', 'ألمانيا'),
(59798, 3262765744, 3262765751, 'NL', 'NLD', 'هولندا'),
(59799, 3262765752, 3262765759, 'DE', 'DEU', 'ألمانيا'),
(59800, 3262765760, 3262765815, 'NL', 'NLD', 'هولندا'),
(59801, 3262765816, 3262765823, 'DE', 'DEU', 'ألمانيا'),
(59802, 3262765824, 3262766047, 'NL', 'NLD', 'هولندا'),
(59803, 3262766048, 3262766055, 'DE', 'DEU', 'ألمانيا'),
(59804, 3262766056, 3262766079, 'NL', 'NLD', 'هولندا'),
(59805, 3262766080, 3262767103, 'DE', 'DEU', 'ألمانيا'),
(59806, 3262767104, 3262767167, 'NL', 'NLD', 'هولندا'),
(59807, 3262767168, 3262767175, 'DE', 'DEU', 'ألمانيا'),
(59808, 3262767176, 3262767231, 'NL', 'NLD', 'هولندا'),
(59809, 3262767232, 3262767239, 'DE', 'DEU', 'ألمانيا'),
(59810, 3262767240, 3262767295, 'NL', 'NLD', 'هولندا'),
(59811, 3262767296, 3262767311, 'DE', 'DEU', 'ألمانيا'),
(59812, 3262767312, 3262767319, 'NL', 'NLD', 'هولندا'),
(59813, 3262767320, 3262767327, 'DE', 'DEU', 'ألمانيا'),
(59814, 3262767328, 3262767367, 'NL', 'NLD', 'هولندا'),
(59815, 3262767368, 3262767375, 'DE', 'DEU', 'ألمانيا'),
(59816, 3262767376, 3262767407, 'NL', 'NLD', 'هولندا'),
(59817, 3262767408, 3262767415, 'DE', 'DEU', 'ألمانيا'),
(59818, 3262767416, 3262767535, 'NL', 'NLD', 'هولندا'),
(59819, 3262767536, 3262767543, 'DE', 'DEU', 'ألمانيا'),
(59820, 3262767544, 3262767599, 'NL', 'NLD', 'هولندا'),
(59821, 3262767600, 3262767607, 'DE', 'DEU', 'ألمانيا'),
(59822, 3262767608, 3262767671, 'NL', 'NLD', 'هولندا'),
(59823, 3262767672, 3262767679, 'DE', 'DEU', 'ألمانيا'),
(59824, 3262767680, 3262767735, 'NL', 'NLD', 'هولندا'),
(59825, 3262767736, 3262767743, 'DE', 'DEU', 'ألمانيا'),
(59826, 3262767744, 3262767855, 'NL', 'NLD', 'هولندا'),
(59827, 3262767856, 3262767879, 'DE', 'DEU', 'ألمانيا'),
(59828, 3262767880, 3262767967, 'NL', 'NLD', 'هولندا'),
(59829, 3262767968, 3262767975, 'DE', 'DEU', 'ألمانيا'),
(59830, 3262767976, 3262768007, 'NL', 'NLD', 'هولندا'),
(59831, 3262768008, 3262768015, 'DE', 'DEU', 'ألمانيا'),
(59832, 3262768016, 3262768511, 'NL', 'NLD', 'هولندا'),
(59833, 3262768512, 3262768519, 'DE', 'DEU', 'ألمانيا'),
(59834, 3262768520, 3262768559, 'NL', 'NLD', 'هولندا'),
(59835, 3262768560, 3262768567, 'DE', 'DEU', 'ألمانيا'),
(59836, 3262768568, 3262768599, 'NL', 'NLD', 'هولندا'),
(59837, 3262768600, 3262768607, 'DE', 'DEU', 'ألمانيا'),
(59838, 3262768608, 3262768631, 'NL', 'NLD', 'هولندا'),
(59839, 3262768632, 3262768639, 'DE', 'DEU', 'ألمانيا'),
(59840, 3262768640, 3262768743, 'NL', 'NLD', 'هولندا'),
(59841, 3262768744, 3262768751, 'DE', 'DEU', 'ألمانيا'),
(59842, 3262768752, 3262768991, 'NL', 'NLD', 'هولندا'),
(59843, 3262768992, 3262768999, 'DE', 'DEU', 'ألمانيا'),
(59844, 3262769000, 3262769111, 'NL', 'NLD', 'هولندا'),
(59845, 3262769112, 3262769119, 'DE', 'DEU', 'ألمانيا'),
(59846, 3262769120, 3262769375, 'NL', 'NLD', 'هولندا'),
(59847, 3262769376, 3262769383, 'DE', 'DEU', 'ألمانيا'),
(59848, 3262769384, 3262769503, 'NL', 'NLD', 'هولندا'),
(59849, 3262769504, 3262769511, 'DE', 'DEU', 'ألمانيا'),
(59850, 3262769512, 3262769631, 'NL', 'NLD', 'هولندا'),
(59851, 3262769632, 3262769639, 'DE', 'DEU', 'ألمانيا'),
(59852, 3262769640, 3262769671, 'NL', 'NLD', 'هولندا'),
(59853, 3262769672, 3262769679, 'DE', 'DEU', 'ألمانيا'),
(59854, 3262769680, 3262769823, 'NL', 'NLD', 'هولندا'),
(59855, 3262769824, 3262769831, 'DE', 'DEU', 'ألمانيا'),
(59856, 3262769832, 3262769839, 'NL', 'NLD', 'هولندا'),
(59857, 3262769840, 3262769847, 'DE', 'DEU', 'ألمانيا'),
(59858, 3262769848, 3262769935, 'NL', 'NLD', 'هولندا'),
(59859, 3262769936, 3262769951, 'DE', 'DEU', 'ألمانيا'),
(59860, 3262769952, 3262769999, 'NL', 'NLD', 'هولندا'),
(59861, 3262770000, 3262770007, 'DE', 'DEU', 'ألمانيا'),
(59862, 3262770008, 3262770055, 'NL', 'NLD', 'هولندا'),
(59863, 3262770056, 3262770063, 'DE', 'DEU', 'ألمانيا'),
(59864, 3262770064, 3262770119, 'NL', 'NLD', 'هولندا'),
(59865, 3262770120, 3262770135, 'DE', 'DEU', 'ألمانيا'),
(59866, 3262770136, 3262770143, 'NL', 'NLD', 'هولندا'),
(59867, 3262770144, 3262770151, 'DE', 'DEU', 'ألمانيا'),
(59868, 3262770152, 3262770167, 'NL', 'NLD', 'هولندا'),
(59869, 3262770168, 3262770175, 'DE', 'DEU', 'ألمانيا'),
(59870, 3262770176, 3262770279, 'NL', 'NLD', 'هولندا'),
(59871, 3262770280, 3262770287, 'DE', 'DEU', 'ألمانيا'),
(59872, 3262770288, 3262770391, 'NL', 'NLD', 'هولندا'),
(59873, 3262770392, 3262770399, 'DE', 'DEU', 'ألمانيا'),
(59874, 3262770400, 3262770535, 'NL', 'NLD', 'هولندا'),
(59875, 3262770536, 3262770543, 'DE', 'DEU', 'ألمانيا'),
(59876, 3262770544, 3262770551, 'NL', 'NLD', 'هولندا'),
(59877, 3262770552, 3262770559, 'DE', 'DEU', 'ألمانيا'),
(59878, 3262770560, 3262770583, 'NL', 'NLD', 'هولندا'),
(59879, 3262770584, 3262770599, 'DE', 'DEU', 'ألمانيا'),
(59880, 3262770600, 3262770615, 'NL', 'NLD', 'هولندا'),
(59881, 3262770616, 3262770623, 'DE', 'DEU', 'ألمانيا'),
(59882, 3262770624, 3262770631, 'NL', 'NLD', 'هولندا'),
(59883, 3262770632, 3262770639, 'DE', 'DEU', 'ألمانيا'),
(59884, 3262770640, 3262770647, 'NL', 'NLD', 'هولندا'),
(59885, 3262770648, 3262770655, 'DE', 'DEU', 'ألمانيا'),
(59886, 3262770656, 3262770815, 'NL', 'NLD', 'هولندا'),
(59887, 3262770816, 3262770823, 'DE', 'DEU', 'ألمانيا'),
(59888, 3262770824, 3262770871, 'NL', 'NLD', 'هولندا'),
(59889, 3262770872, 3262770879, 'DE', 'DEU', 'ألمانيا'),
(59890, 3262770880, 3262770927, 'NL', 'NLD', 'هولندا'),
(59891, 3262770928, 3262770935, 'DE', 'DEU', 'ألمانيا'),
(59892, 3262770936, 3262770999, 'NL', 'NLD', 'هولندا'),
(59893, 3262771000, 3262771007, 'DE', 'DEU', 'ألمانيا'),
(59894, 3262771008, 3262771031, 'NL', 'NLD', 'هولندا'),
(59895, 3262771032, 3262771039, 'DE', 'DEU', 'ألمانيا'),
(59896, 3262771040, 3262771079, 'NL', 'NLD', 'هولندا'),
(59897, 3262771080, 3262771087, 'DE', 'DEU', 'ألمانيا'),
(59898, 3262771088, 3262771119, 'NL', 'NLD', 'هولندا'),
(59899, 3262771120, 3262771127, 'DE', 'DEU', 'ألمانيا'),
(59900, 3262771128, 3262771135, 'NL', 'NLD', 'هولندا'),
(59901, 3262771136, 3262771143, 'DE', 'DEU', 'ألمانيا'),
(59902, 3262771144, 3262771151, 'NL', 'NLD', 'هولندا'),
(59903, 3262771152, 3262771159, 'DE', 'DEU', 'ألمانيا'),
(59904, 3262771160, 3262771183, 'NL', 'NLD', 'هولندا'),
(59905, 3262771184, 3262771199, 'DE', 'DEU', 'ألمانيا'),
(59906, 3262771200, 3262771215, 'NL', 'NLD', 'هولندا'),
(59907, 3262771216, 3262771223, 'DE', 'DEU', 'ألمانيا'),
(59908, 3262771224, 3262771255, 'NL', 'NLD', 'هولندا'),
(59909, 3262771256, 3262771263, 'DE', 'DEU', 'ألمانيا'),
(59910, 3262771264, 3262771295, 'NL', 'NLD', 'هولندا'),
(59911, 3262771296, 3262771303, 'DE', 'DEU', 'ألمانيا'),
(59912, 3262771304, 3262771375, 'NL', 'NLD', 'هولندا'),
(59913, 3262771376, 3262771391, 'DE', 'DEU', 'ألمانيا'),
(59914, 3262771392, 3262771399, 'NL', 'NLD', 'هولندا'),
(59915, 3262771400, 3262771407, 'DE', 'DEU', 'ألمانيا'),
(59916, 3262771408, 3262771463, 'NL', 'NLD', 'هولندا'),
(59917, 3262771464, 3262771471, 'DE', 'DEU', 'ألمانيا'),
(59918, 3262771472, 3262771551, 'NL', 'NLD', 'هولندا'),
(59919, 3262771552, 3262771559, 'DE', 'DEU', 'ألمانيا'),
(59920, 3262771560, 3262771895, 'NL', 'NLD', 'هولندا'),
(59921, 3262771896, 3262771903, 'DE', 'DEU', 'ألمانيا'),
(59922, 3262771904, 3262772039, 'NL', 'NLD', 'هولندا'),
(59923, 3262772040, 3262772047, 'DE', 'DEU', 'ألمانيا'),
(59924, 3262772048, 3262772191, 'NL', 'NLD', 'هولندا'),
(59925, 3262772192, 3262772199, 'DE', 'DEU', 'ألمانيا'),
(59926, 3262772200, 3262772287, 'NL', 'NLD', 'هولندا'),
(59927, 3262772288, 3262772295, 'DE', 'DEU', 'ألمانيا'),
(59928, 3262772296, 3262772447, 'NL', 'NLD', 'هولندا'),
(59929, 3262772448, 3262772455, 'DE', 'DEU', 'ألمانيا'),
(59930, 3262772456, 3262772495, 'NL', 'NLD', 'هولندا'),
(59931, 3262772496, 3262772503, 'DE', 'DEU', 'ألمانيا'),
(59932, 3262772504, 3262772511, 'NL', 'NLD', 'هولندا'),
(59933, 3262772512, 3262772519, 'DE', 'DEU', 'ألمانيا'),
(59934, 3262772520, 3262772567, 'NL', 'NLD', 'هولندا'),
(59935, 3262772568, 3262772575, 'DE', 'DEU', 'ألمانيا'),
(59936, 3262772576, 3262772679, 'NL', 'NLD', 'هولندا'),
(59937, 3262772680, 3262772687, 'DE', 'DEU', 'ألمانيا'),
(59938, 3262772688, 3262772703, 'NL', 'NLD', 'هولندا'),
(59939, 3262772704, 3262772711, 'DE', 'DEU', 'ألمانيا'),
(59940, 3262772712, 3262772727, 'NL', 'NLD', 'هولندا'),
(59941, 3262772728, 3262772735, 'DE', 'DEU', 'ألمانيا'),
(59942, 3262772736, 3262772759, 'NL', 'NLD', 'هولندا'),
(59943, 3262772760, 3262772767, 'DE', 'DEU', 'ألمانيا'),
(59944, 3262772768, 3262772783, 'NL', 'NLD', 'هولندا'),
(59945, 3262772784, 3262772791, 'DE', 'DEU', 'ألمانيا'),
(59946, 3262772792, 3262772855, 'NL', 'NLD', 'هولندا'),
(59947, 3262772856, 3262772863, 'DE', 'DEU', 'ألمانيا'),
(59948, 3262772864, 3262773007, 'NL', 'NLD', 'هولندا'),
(59949, 3262773008, 3262773015, 'DE', 'DEU', 'ألمانيا'),
(59950, 3262773016, 3262773127, 'NL', 'NLD', 'هولندا'),
(59951, 3262773128, 3262773135, 'DE', 'DEU', 'ألمانيا'),
(59952, 3262773136, 3262773439, 'NL', 'NLD', 'هولندا'),
(59953, 3262773440, 3262773447, 'DE', 'DEU', 'ألمانيا'),
(59954, 3262773448, 3262773471, 'NL', 'NLD', 'هولندا'),
(59955, 3262773472, 3262773479, 'DE', 'DEU', 'ألمانيا'),
(59956, 3262773480, 3262773503, 'NL', 'NLD', 'هولندا'),
(59957, 3262773504, 3262775295, 'DE', 'DEU', 'ألمانيا'),
(59958, 3262775296, 3262775303, 'NL', 'NLD', 'هولندا'),
(59959, 3262775304, 3262775319, 'DE', 'DEU', 'ألمانيا'),
(59960, 3262775320, 3262775407, 'NL', 'NLD', 'هولندا'),
(59961, 3262775408, 3262775415, 'DE', 'DEU', 'ألمانيا'),
(59962, 3262775416, 3262775423, 'NL', 'NLD', 'هولندا'),
(59963, 3262775424, 3262775431, 'DE', 'DEU', 'ألمانيا'),
(59964, 3262775432, 3262775503, 'NL', 'NLD', 'هولندا'),
(59965, 3262775504, 3262775511, 'DE', 'DEU', 'ألمانيا'),
(59966, 3262775512, 3262775535, 'NL', 'NLD', 'هولندا'),
(59967, 3262775536, 3262775543, 'DE', 'DEU', 'ألمانيا'),
(59968, 3262775544, 3262775559, 'NL', 'NLD', 'هولندا'),
(59969, 3262775560, 3262775567, 'DE', 'DEU', 'ألمانيا'),
(59970, 3262775568, 3262775623, 'NL', 'NLD', 'هولندا'),
(59971, 3262775624, 3262775639, 'DE', 'DEU', 'ألمانيا'),
(59972, 3262775640, 3262775647, 'NL', 'NLD', 'هولندا'),
(59973, 3262775648, 3262775655, 'DE', 'DEU', 'ألمانيا'),
(59974, 3262775656, 3262775695, 'NL', 'NLD', 'هولندا'),
(59975, 3262775696, 3262775703, 'DE', 'DEU', 'ألمانيا'),
(59976, 3262775704, 3262775735, 'NL', 'NLD', 'هولندا'),
(59977, 3262775736, 3262775743, 'DE', 'DEU', 'ألمانيا'),
(59978, 3262775744, 3262775751, 'NL', 'NLD', 'هولندا'),
(59979, 3262775752, 3262775759, 'DE', 'DEU', 'ألمانيا'),
(59980, 3262775760, 3262775831, 'NL', 'NLD', 'هولندا'),
(59981, 3262775832, 3262775839, 'DE', 'DEU', 'ألمانيا'),
(59982, 3262775840, 3262775871, 'NL', 'NLD', 'هولندا'),
(59983, 3262775872, 3262775879, 'DE', 'DEU', 'ألمانيا'),
(59984, 3262775880, 3262775935, 'NL', 'NLD', 'هولندا'),
(59985, 3262775936, 3262775943, 'DE', 'DEU', 'ألمانيا'),
(59986, 3262775944, 3262776055, 'NL', 'NLD', 'هولندا'),
(59987, 3262776056, 3262776063, 'DE', 'DEU', 'ألمانيا'),
(59988, 3262776064, 3262776199, 'NL', 'NLD', 'هولندا'),
(59989, 3262776200, 3262776207, 'DE', 'DEU', 'ألمانيا'),
(59990, 3262776208, 3262776239, 'NL', 'NLD', 'هولندا'),
(59991, 3262776240, 3262776247, 'DE', 'DEU', 'ألمانيا'),
(59992, 3262776248, 3262776287, 'NL', 'NLD', 'هولندا'),
(59993, 3262776288, 3262776295, 'DE', 'DEU', 'ألمانيا'),
(59994, 3262776296, 3262776351, 'NL', 'NLD', 'هولندا'),
(59995, 3262776352, 3262776359, 'DE', 'DEU', 'ألمانيا'),
(59996, 3262776360, 3262776543, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(59997, 3262776544, 3262776551, 'DE', 'DEU', 'ألمانيا'),
(59998, 3262776552, 3262776559, 'NL', 'NLD', 'هولندا'),
(59999, 3262776560, 3262776567, 'DE', 'DEU', 'ألمانيا'),
(60000, 3262776568, 3262776663, 'NL', 'NLD', 'هولندا'),
(60001, 3262776664, 3262776671, 'DE', 'DEU', 'ألمانيا'),
(60002, 3262776672, 3262776687, 'NL', 'NLD', 'هولندا'),
(60003, 3262776688, 3262776695, 'DE', 'DEU', 'ألمانيا'),
(60004, 3262776696, 3262776719, 'NL', 'NLD', 'هولندا'),
(60005, 3262776720, 3262776727, 'DE', 'DEU', 'ألمانيا'),
(60006, 3262776728, 3262776751, 'NL', 'NLD', 'هولندا'),
(60007, 3262776752, 3262776759, 'DE', 'DEU', 'ألمانيا'),
(60008, 3262776760, 3262776823, 'NL', 'NLD', 'هولندا'),
(60009, 3262776824, 3262776831, 'DE', 'DEU', 'ألمانيا'),
(60010, 3262776832, 3262776887, 'NL', 'NLD', 'هولندا'),
(60011, 3262776888, 3262776895, 'DE', 'DEU', 'ألمانيا'),
(60012, 3262776896, 3262777015, 'NL', 'NLD', 'هولندا'),
(60013, 3262777016, 3262777031, 'DE', 'DEU', 'ألمانيا'),
(60014, 3262777032, 3262777079, 'NL', 'NLD', 'هولندا'),
(60015, 3262777080, 3262777087, 'DE', 'DEU', 'ألمانيا'),
(60016, 3262777088, 3262777127, 'NL', 'NLD', 'هولندا'),
(60017, 3262777128, 3262777135, 'DE', 'DEU', 'ألمانيا'),
(60018, 3262777136, 3262777215, 'NL', 'NLD', 'هولندا'),
(60019, 3262777216, 3262777223, 'DE', 'DEU', 'ألمانيا'),
(60020, 3262777224, 3262777279, 'NL', 'NLD', 'هولندا'),
(60021, 3262777280, 3262777287, 'DE', 'DEU', 'ألمانيا'),
(60022, 3262777288, 3262777343, 'NL', 'NLD', 'هولندا'),
(60023, 3262777344, 3262777351, 'DE', 'DEU', 'ألمانيا'),
(60024, 3262777352, 3262777359, 'NL', 'NLD', 'هولندا'),
(60025, 3262777360, 3262777375, 'DE', 'DEU', 'ألمانيا'),
(60026, 3262777376, 3262777543, 'NL', 'NLD', 'هولندا'),
(60027, 3262777544, 3262777551, 'DE', 'DEU', 'ألمانيا'),
(60028, 3262777552, 3262777919, 'NL', 'NLD', 'هولندا'),
(60029, 3262777920, 3262777927, 'DE', 'DEU', 'ألمانيا'),
(60030, 3262777928, 3262777943, 'NL', 'NLD', 'هولندا'),
(60031, 3262777944, 3262777951, 'DE', 'DEU', 'ألمانيا'),
(60032, 3262777952, 3262778015, 'NL', 'NLD', 'هولندا'),
(60033, 3262778016, 3262778023, 'DE', 'DEU', 'ألمانيا'),
(60034, 3262778024, 3262778063, 'NL', 'NLD', 'هولندا'),
(60035, 3262778064, 3262778079, 'DE', 'DEU', 'ألمانيا'),
(60036, 3262778080, 3262778095, 'NL', 'NLD', 'هولندا'),
(60037, 3262778096, 3262778103, 'DE', 'DEU', 'ألمانيا'),
(60038, 3262778104, 3262778175, 'NL', 'NLD', 'هولندا'),
(60039, 3262778176, 3262778191, 'DE', 'DEU', 'ألمانيا'),
(60040, 3262778192, 3262778239, 'NL', 'NLD', 'هولندا'),
(60041, 3262778240, 3262778247, 'DE', 'DEU', 'ألمانيا'),
(60042, 3262778248, 3262778663, 'NL', 'NLD', 'هولندا'),
(60043, 3262778664, 3262778671, 'DE', 'DEU', 'ألمانيا'),
(60044, 3262778672, 3262779055, 'NL', 'NLD', 'هولندا'),
(60045, 3262779056, 3262779063, 'DE', 'DEU', 'ألمانيا'),
(60046, 3262779064, 3262779079, 'NL', 'NLD', 'هولندا'),
(60047, 3262779080, 3262779095, 'DE', 'DEU', 'ألمانيا'),
(60048, 3262779096, 3262779119, 'NL', 'NLD', 'هولندا'),
(60049, 3262779120, 3262779127, 'DE', 'DEU', 'ألمانيا'),
(60050, 3262779128, 3262779151, 'NL', 'NLD', 'هولندا'),
(60051, 3262779152, 3262779159, 'DE', 'DEU', 'ألمانيا'),
(60052, 3262779160, 3262779175, 'NL', 'NLD', 'هولندا'),
(60053, 3262779176, 3262779191, 'DE', 'DEU', 'ألمانيا'),
(60054, 3262779192, 3262779327, 'NL', 'NLD', 'هولندا'),
(60055, 3262779328, 3262779335, 'DE', 'DEU', 'ألمانيا'),
(60056, 3262779336, 3262779519, 'NL', 'NLD', 'هولندا'),
(60057, 3262779520, 3262779527, 'DE', 'DEU', 'ألمانيا'),
(60058, 3262779528, 3262779543, 'NL', 'NLD', 'هولندا'),
(60059, 3262779544, 3262779551, 'DE', 'DEU', 'ألمانيا'),
(60060, 3262779552, 3262779687, 'NL', 'NLD', 'هولندا'),
(60061, 3262779688, 3262779695, 'DE', 'DEU', 'ألمانيا'),
(60062, 3262779696, 3262779735, 'NL', 'NLD', 'هولندا'),
(60063, 3262779736, 3262779743, 'DE', 'DEU', 'ألمانيا'),
(60064, 3262779744, 3262779911, 'NL', 'NLD', 'هولندا'),
(60065, 3262779912, 3262779951, 'DE', 'DEU', 'ألمانيا'),
(60066, 3262779952, 3262779959, 'NL', 'NLD', 'هولندا'),
(60067, 3262779960, 3262779983, 'DE', 'DEU', 'ألمانيا'),
(60068, 3262779984, 3262780055, 'NL', 'NLD', 'هولندا'),
(60069, 3262780056, 3262780071, 'DE', 'DEU', 'ألمانيا'),
(60070, 3262780072, 3262780127, 'NL', 'NLD', 'هولندا'),
(60071, 3262780128, 3262780135, 'DE', 'DEU', 'ألمانيا'),
(60072, 3262780136, 3262780399, 'NL', 'NLD', 'هولندا'),
(60073, 3262780400, 3262780407, 'DE', 'DEU', 'ألمانيا'),
(60074, 3262780408, 3262780463, 'NL', 'NLD', 'هولندا'),
(60075, 3262780464, 3262780471, 'DE', 'DEU', 'ألمانيا'),
(60076, 3262780472, 3262780503, 'NL', 'NLD', 'هولندا'),
(60077, 3262780504, 3262780511, 'DE', 'DEU', 'ألمانيا'),
(60078, 3262780512, 3262780583, 'NL', 'NLD', 'هولندا'),
(60079, 3262780584, 3262780591, 'DE', 'DEU', 'ألمانيا'),
(60080, 3262780592, 3262780671, 'NL', 'NLD', 'هولندا'),
(60081, 3262780672, 3262780679, 'DE', 'DEU', 'ألمانيا'),
(60082, 3262780680, 3262780727, 'NL', 'NLD', 'هولندا'),
(60083, 3262780728, 3262780735, 'DE', 'DEU', 'ألمانيا'),
(60084, 3262780736, 3262780791, 'NL', 'NLD', 'هولندا'),
(60085, 3262780792, 3262780799, 'DE', 'DEU', 'ألمانيا'),
(60086, 3262780800, 3262780807, 'NL', 'NLD', 'هولندا'),
(60087, 3262780808, 3262780815, 'DE', 'DEU', 'ألمانيا'),
(60088, 3262780816, 3262780823, 'NL', 'NLD', 'هولندا'),
(60089, 3262780824, 3262780831, 'DE', 'DEU', 'ألمانيا'),
(60090, 3262780832, 3262780935, 'NL', 'NLD', 'هولندا'),
(60091, 3262780936, 3262780967, 'DE', 'DEU', 'ألمانيا'),
(60092, 3262780968, 3262781287, 'NL', 'NLD', 'هولندا'),
(60093, 3262781288, 3262781295, 'DE', 'DEU', 'ألمانيا'),
(60094, 3262781296, 3262781375, 'NL', 'NLD', 'هولندا'),
(60095, 3262781376, 3262781383, 'DE', 'DEU', 'ألمانيا'),
(60096, 3262781384, 3262781487, 'NL', 'NLD', 'هولندا'),
(60097, 3262781488, 3262781495, 'DE', 'DEU', 'ألمانيا'),
(60098, 3262781496, 3262781503, 'NL', 'NLD', 'هولندا'),
(60099, 3262781504, 3262781519, 'DE', 'DEU', 'ألمانيا'),
(60100, 3262781520, 3262781575, 'NL', 'NLD', 'هولندا'),
(60101, 3262781576, 3262781583, 'DE', 'DEU', 'ألمانيا'),
(60102, 3262781584, 3262781631, 'NL', 'NLD', 'هولندا'),
(60103, 3262781632, 3262781639, 'DE', 'DEU', 'ألمانيا'),
(60104, 3262781640, 3262781663, 'NL', 'NLD', 'هولندا'),
(60105, 3262781664, 3262781671, 'DE', 'DEU', 'ألمانيا'),
(60106, 3262781672, 3262781679, 'NL', 'NLD', 'هولندا'),
(60107, 3262781680, 3262781687, 'DE', 'DEU', 'ألمانيا'),
(60108, 3262781688, 3262781719, 'NL', 'NLD', 'هولندا'),
(60109, 3262781720, 3262781727, 'DE', 'DEU', 'ألمانيا'),
(60110, 3262781728, 3262781815, 'NL', 'NLD', 'هولندا'),
(60111, 3262781816, 3262781823, 'DE', 'DEU', 'ألمانيا'),
(60112, 3262781824, 3262781831, 'NL', 'NLD', 'هولندا'),
(60113, 3262781832, 3262781839, 'DE', 'DEU', 'ألمانيا'),
(60114, 3262781840, 3262781871, 'NL', 'NLD', 'هولندا'),
(60115, 3262781872, 3262781879, 'DE', 'DEU', 'ألمانيا'),
(60116, 3262781880, 3262781959, 'NL', 'NLD', 'هولندا'),
(60117, 3262781960, 3262781967, 'DE', 'DEU', 'ألمانيا'),
(60118, 3262781968, 3262782127, 'NL', 'NLD', 'هولندا'),
(60119, 3262782128, 3262782135, 'DE', 'DEU', 'ألمانيا'),
(60120, 3262782136, 3262782159, 'NL', 'NLD', 'هولندا'),
(60121, 3262782160, 3262782167, 'DE', 'DEU', 'ألمانيا'),
(60122, 3262782168, 3262782375, 'NL', 'NLD', 'هولندا'),
(60123, 3262782376, 3262782383, 'DE', 'DEU', 'ألمانيا'),
(60124, 3262782384, 3262782399, 'NL', 'NLD', 'هولندا'),
(60125, 3262782400, 3262782407, 'DE', 'DEU', 'ألمانيا'),
(60126, 3262782408, 3262782559, 'NL', 'NLD', 'هولندا'),
(60127, 3262782560, 3262782567, 'DE', 'DEU', 'ألمانيا'),
(60128, 3262782568, 3262782791, 'NL', 'NLD', 'هولندا'),
(60129, 3262782792, 3262782799, 'DE', 'DEU', 'ألمانيا'),
(60130, 3262782800, 3262782871, 'NL', 'NLD', 'هولندا'),
(60131, 3262782872, 3262782879, 'DE', 'DEU', 'ألمانيا'),
(60132, 3262782880, 3262782935, 'NL', 'NLD', 'هولندا'),
(60133, 3262782936, 3262782943, 'DE', 'DEU', 'ألمانيا'),
(60134, 3262782944, 3262783071, 'NL', 'NLD', 'هولندا'),
(60135, 3262783072, 3262783079, 'DE', 'DEU', 'ألمانيا'),
(60136, 3262783080, 3262783159, 'NL', 'NLD', 'هولندا'),
(60137, 3262783160, 3262783167, 'DE', 'DEU', 'ألمانيا'),
(60138, 3262783168, 3262783383, 'NL', 'NLD', 'هولندا'),
(60139, 3262783384, 3262783391, 'DE', 'DEU', 'ألمانيا'),
(60140, 3262783392, 3262783415, 'NL', 'NLD', 'هولندا'),
(60141, 3262783416, 3262783423, 'DE', 'DEU', 'ألمانيا'),
(60142, 3262783424, 3262783647, 'NL', 'NLD', 'هولندا'),
(60143, 3262783648, 3262783655, 'DE', 'DEU', 'ألمانيا'),
(60144, 3262783656, 3262783679, 'NL', 'NLD', 'هولندا'),
(60145, 3262783680, 3262783687, 'DE', 'DEU', 'ألمانيا'),
(60146, 3262783688, 3262783719, 'NL', 'NLD', 'هولندا'),
(60147, 3262783720, 3262783727, 'DE', 'DEU', 'ألمانيا'),
(60148, 3262783728, 3262783879, 'NL', 'NLD', 'هولندا'),
(60149, 3262783880, 3262783887, 'DE', 'DEU', 'ألمانيا'),
(60150, 3262783888, 3262784007, 'NL', 'NLD', 'هولندا'),
(60151, 3262784008, 3262784015, 'DE', 'DEU', 'ألمانيا'),
(60152, 3262784016, 3262784143, 'NL', 'NLD', 'هولندا'),
(60153, 3262784144, 3262784151, 'DE', 'DEU', 'ألمانيا'),
(60154, 3262784152, 3262784359, 'NL', 'NLD', 'هولندا'),
(60155, 3262784360, 3262784367, 'DE', 'DEU', 'ألمانيا'),
(60156, 3262784368, 3262784439, 'NL', 'NLD', 'هولندا'),
(60157, 3262784440, 3262784447, 'DE', 'DEU', 'ألمانيا'),
(60158, 3262784448, 3262784495, 'NL', 'NLD', 'هولندا'),
(60159, 3262784496, 3262784503, 'DE', 'DEU', 'ألمانيا'),
(60160, 3262784504, 3262784767, 'NL', 'NLD', 'هولندا'),
(60161, 3262784768, 3262784775, 'DE', 'DEU', 'ألمانيا'),
(60162, 3262784776, 3262785023, 'NL', 'NLD', 'هولندا'),
(60163, 3262785024, 3262785031, 'DE', 'DEU', 'ألمانيا'),
(60164, 3262785032, 3262785167, 'NL', 'NLD', 'هولندا'),
(60165, 3262785168, 3262785175, 'DE', 'DEU', 'ألمانيا'),
(60166, 3262785176, 3262785423, 'NL', 'NLD', 'هولندا'),
(60167, 3262785424, 3262785431, 'DE', 'DEU', 'ألمانيا'),
(60168, 3262785432, 3262785455, 'NL', 'NLD', 'هولندا'),
(60169, 3262785456, 3262785463, 'DE', 'DEU', 'ألمانيا'),
(60170, 3262785464, 3262785511, 'NL', 'NLD', 'هولندا'),
(60171, 3262785512, 3262785519, 'DE', 'DEU', 'ألمانيا'),
(60172, 3262785520, 3262785527, 'NL', 'NLD', 'هولندا'),
(60173, 3262785528, 3262785535, 'DE', 'DEU', 'ألمانيا'),
(60174, 3262785536, 3262785951, 'NL', 'NLD', 'هولندا'),
(60175, 3262785952, 3262785959, 'DE', 'DEU', 'ألمانيا'),
(60176, 3262785960, 3262786023, 'NL', 'NLD', 'هولندا'),
(60177, 3262786024, 3262786031, 'DE', 'DEU', 'ألمانيا'),
(60178, 3262786032, 3262786167, 'NL', 'NLD', 'هولندا'),
(60179, 3262786168, 3262786183, 'DE', 'DEU', 'ألمانيا'),
(60180, 3262786184, 3262786207, 'NL', 'NLD', 'هولندا'),
(60181, 3262786208, 3262786223, 'DE', 'DEU', 'ألمانيا'),
(60182, 3262786224, 3262786471, 'NL', 'NLD', 'هولندا'),
(60183, 3262786472, 3262786479, 'DE', 'DEU', 'ألمانيا'),
(60184, 3262786480, 3262786679, 'NL', 'NLD', 'هولندا'),
(60185, 3262786680, 3262786687, 'DE', 'DEU', 'ألمانيا'),
(60186, 3262786688, 3262786759, 'NL', 'NLD', 'هولندا'),
(60187, 3262786760, 3262786767, 'DE', 'DEU', 'ألمانيا'),
(60188, 3262786768, 3262786959, 'NL', 'NLD', 'هولندا'),
(60189, 3262786960, 3262786975, 'DE', 'DEU', 'ألمانيا'),
(60190, 3262786976, 3262786983, 'NL', 'NLD', 'هولندا'),
(60191, 3262786984, 3262786991, 'DE', 'DEU', 'ألمانيا'),
(60192, 3262786992, 3262786999, 'NL', 'NLD', 'هولندا'),
(60193, 3262787000, 3262787015, 'DE', 'DEU', 'ألمانيا'),
(60194, 3262787016, 3262787031, 'NL', 'NLD', 'هولندا'),
(60195, 3262787032, 3262787063, 'DE', 'DEU', 'ألمانيا'),
(60196, 3262787064, 3262787087, 'NL', 'NLD', 'هولندا'),
(60197, 3262787088, 3262787103, 'DE', 'DEU', 'ألمانيا'),
(60198, 3262787104, 3262787111, 'NL', 'NLD', 'هولندا'),
(60199, 3262787112, 3262787119, 'DE', 'DEU', 'ألمانيا'),
(60200, 3262787120, 3262787143, 'NL', 'NLD', 'هولندا'),
(60201, 3262787144, 3262787151, 'DE', 'DEU', 'ألمانيا'),
(60202, 3262787152, 3262787191, 'NL', 'NLD', 'هولندا'),
(60203, 3262787192, 3262787199, 'DE', 'DEU', 'ألمانيا'),
(60204, 3262787200, 3262787239, 'NL', 'NLD', 'هولندا'),
(60205, 3262787240, 3262787247, 'DE', 'DEU', 'ألمانيا'),
(60206, 3262787248, 3262787335, 'NL', 'NLD', 'هولندا'),
(60207, 3262787336, 3262787351, 'DE', 'DEU', 'ألمانيا'),
(60208, 3262787352, 3262787359, 'NL', 'NLD', 'هولندا'),
(60209, 3262787360, 3262787367, 'DE', 'DEU', 'ألمانيا'),
(60210, 3262787368, 3262787407, 'NL', 'NLD', 'هولندا'),
(60211, 3262787408, 3262787415, 'DE', 'DEU', 'ألمانيا'),
(60212, 3262787416, 3262787543, 'NL', 'NLD', 'هولندا'),
(60213, 3262787544, 3262787551, 'DE', 'DEU', 'ألمانيا'),
(60214, 3262787552, 3262787583, 'NL', 'NLD', 'هولندا'),
(60215, 3262787584, 3262787591, 'DE', 'DEU', 'ألمانيا'),
(60216, 3262787592, 3262787623, 'NL', 'NLD', 'هولندا'),
(60217, 3262787624, 3262787631, 'DE', 'DEU', 'ألمانيا'),
(60218, 3262787632, 3262787655, 'NL', 'NLD', 'هولندا'),
(60219, 3262787656, 3262787663, 'DE', 'DEU', 'ألمانيا'),
(60220, 3262787664, 3262787823, 'NL', 'NLD', 'هولندا'),
(60221, 3262787824, 3262787831, 'DE', 'DEU', 'ألمانيا'),
(60222, 3262787832, 3262788055, 'NL', 'NLD', 'هولندا'),
(60223, 3262788056, 3262788063, 'DE', 'DEU', 'ألمانيا'),
(60224, 3262788064, 3262788167, 'NL', 'NLD', 'هولندا'),
(60225, 3262788168, 3262788175, 'DE', 'DEU', 'ألمانيا'),
(60226, 3262788176, 3262788199, 'NL', 'NLD', 'هولندا'),
(60227, 3262788200, 3262788207, 'DE', 'DEU', 'ألمانيا'),
(60228, 3262788208, 3262788279, 'NL', 'NLD', 'هولندا'),
(60229, 3262788280, 3262788287, 'DE', 'DEU', 'ألمانيا'),
(60230, 3262788288, 3262788479, 'NL', 'NLD', 'هولندا'),
(60231, 3262788480, 3262788495, 'DE', 'DEU', 'ألمانيا'),
(60232, 3262788496, 3262788559, 'NL', 'NLD', 'هولندا'),
(60233, 3262788560, 3262788567, 'DE', 'DEU', 'ألمانيا'),
(60234, 3262788568, 3262788623, 'NL', 'NLD', 'هولندا'),
(60235, 3262788624, 3262788631, 'DE', 'DEU', 'ألمانيا'),
(60236, 3262788632, 3262788743, 'NL', 'NLD', 'هولندا'),
(60237, 3262788744, 3262788751, 'DE', 'DEU', 'ألمانيا'),
(60238, 3262788752, 3262788799, 'NL', 'NLD', 'هولندا'),
(60239, 3262788800, 3262788807, 'DE', 'DEU', 'ألمانيا'),
(60240, 3262788808, 3262788919, 'NL', 'NLD', 'هولندا'),
(60241, 3262788920, 3262788927, 'DE', 'DEU', 'ألمانيا'),
(60242, 3262788928, 3262788951, 'NL', 'NLD', 'هولندا'),
(60243, 3262788952, 3262788959, 'DE', 'DEU', 'ألمانيا'),
(60244, 3262788960, 3262788983, 'NL', 'NLD', 'هولندا'),
(60245, 3262788984, 3262788991, 'DE', 'DEU', 'ألمانيا'),
(60246, 3262788992, 3262789079, 'NL', 'NLD', 'هولندا'),
(60247, 3262789080, 3262789095, 'DE', 'DEU', 'ألمانيا'),
(60248, 3262789096, 3262789119, 'NL', 'NLD', 'هولندا'),
(60249, 3262789120, 3262790143, 'DE', 'DEU', 'ألمانيا'),
(60250, 3262790144, 3262790287, 'NL', 'NLD', 'هولندا'),
(60251, 3262790288, 3262790295, 'DE', 'DEU', 'ألمانيا'),
(60252, 3262790296, 3262790543, 'NL', 'NLD', 'هولندا'),
(60253, 3262790544, 3262790551, 'DE', 'DEU', 'ألمانيا'),
(60254, 3262790552, 3262790639, 'NL', 'NLD', 'هولندا'),
(60255, 3262790640, 3262790647, 'DE', 'DEU', 'ألمانيا'),
(60256, 3262790648, 3262790695, 'NL', 'NLD', 'هولندا'),
(60257, 3262790696, 3262790703, 'DE', 'DEU', 'ألمانيا'),
(60258, 3262790704, 3262790815, 'NL', 'NLD', 'هولندا'),
(60259, 3262790816, 3262790823, 'DE', 'DEU', 'ألمانيا'),
(60260, 3262790824, 3262790911, 'NL', 'NLD', 'هولندا'),
(60261, 3262790912, 3262790919, 'DE', 'DEU', 'ألمانيا'),
(60262, 3262790920, 3262791039, 'NL', 'NLD', 'هولندا'),
(60263, 3262791040, 3262791047, 'DE', 'DEU', 'ألمانيا'),
(60264, 3262791048, 3262791095, 'NL', 'NLD', 'هولندا'),
(60265, 3262791096, 3262791103, 'DE', 'DEU', 'ألمانيا'),
(60266, 3262791104, 3262791319, 'NL', 'NLD', 'هولندا'),
(60267, 3262791320, 3262791327, 'DE', 'DEU', 'ألمانيا'),
(60268, 3262791328, 3262791335, 'NL', 'NLD', 'هولندا'),
(60269, 3262791336, 3262791343, 'DE', 'DEU', 'ألمانيا'),
(60270, 3262791344, 3262791399, 'NL', 'NLD', 'هولندا'),
(60271, 3262791400, 3262791407, 'DE', 'DEU', 'ألمانيا'),
(60272, 3262791408, 3262791543, 'NL', 'NLD', 'هولندا'),
(60273, 3262791544, 3262791551, 'DE', 'DEU', 'ألمانيا'),
(60274, 3262791552, 3262791575, 'NL', 'NLD', 'هولندا'),
(60275, 3262791576, 3262791583, 'DE', 'DEU', 'ألمانيا'),
(60276, 3262791584, 3262791751, 'NL', 'NLD', 'هولندا'),
(60277, 3262791752, 3262791759, 'DE', 'DEU', 'ألمانيا'),
(60278, 3262791760, 3262791887, 'NL', 'NLD', 'هولندا'),
(60279, 3262791888, 3262791895, 'DE', 'DEU', 'ألمانيا'),
(60280, 3262791896, 3262791903, 'NL', 'NLD', 'هولندا'),
(60281, 3262791904, 3262791911, 'DE', 'DEU', 'ألمانيا'),
(60282, 3262791912, 3262791951, 'NL', 'NLD', 'هولندا'),
(60283, 3262791952, 3262791959, 'DE', 'DEU', 'ألمانيا'),
(60284, 3262791960, 3262792079, 'NL', 'NLD', 'هولندا'),
(60285, 3262792080, 3262792087, 'DE', 'DEU', 'ألمانيا'),
(60286, 3262792088, 3262792191, 'NL', 'NLD', 'هولندا'),
(60287, 3262792192, 3262792199, 'DE', 'DEU', 'ألمانيا'),
(60288, 3262792200, 3262792367, 'NL', 'NLD', 'هولندا'),
(60289, 3262792368, 3262792375, 'DE', 'DEU', 'ألمانيا'),
(60290, 3262792376, 3262792383, 'NL', 'NLD', 'هولندا'),
(60291, 3262792384, 3262792391, 'DE', 'DEU', 'ألمانيا'),
(60292, 3262792392, 3262792463, 'NL', 'NLD', 'هولندا'),
(60293, 3262792464, 3262792471, 'DE', 'DEU', 'ألمانيا'),
(60294, 3262792472, 3262792495, 'NL', 'NLD', 'هولندا'),
(60295, 3262792496, 3262792503, 'DE', 'DEU', 'ألمانيا'),
(60296, 3262792504, 3262792607, 'NL', 'NLD', 'هولندا'),
(60297, 3262792608, 3262792615, 'DE', 'DEU', 'ألمانيا'),
(60298, 3262792616, 3262792823, 'NL', 'NLD', 'هولندا'),
(60299, 3262792824, 3262792831, 'DE', 'DEU', 'ألمانيا'),
(60300, 3262792832, 3262792871, 'NL', 'NLD', 'هولندا'),
(60301, 3262792872, 3262792879, 'DE', 'DEU', 'ألمانيا'),
(60302, 3262792880, 3262793215, 'NL', 'NLD', 'هولندا'),
(60303, 3262793216, 3262793223, 'DE', 'DEU', 'ألمانيا'),
(60304, 3262793224, 3262793287, 'NL', 'NLD', 'هولندا'),
(60305, 3262793288, 3262793295, 'DE', 'DEU', 'ألمانيا'),
(60306, 3262793296, 3262793303, 'NL', 'NLD', 'هولندا'),
(60307, 3262793304, 3262793311, 'DE', 'DEU', 'ألمانيا'),
(60308, 3262793312, 3262793407, 'NL', 'NLD', 'هولندا'),
(60309, 3262793408, 3262793415, 'DE', 'DEU', 'ألمانيا'),
(60310, 3262793416, 3262793583, 'NL', 'NLD', 'هولندا'),
(60311, 3262793584, 3262793591, 'DE', 'DEU', 'ألمانيا'),
(60312, 3262793592, 3262793607, 'NL', 'NLD', 'هولندا'),
(60313, 3262793608, 3262793623, 'DE', 'DEU', 'ألمانيا'),
(60314, 3262793624, 3262793687, 'NL', 'NLD', 'هولندا'),
(60315, 3262793688, 3262793695, 'DE', 'DEU', 'ألمانيا'),
(60316, 3262793696, 3262793775, 'NL', 'NLD', 'هولندا'),
(60317, 3262793776, 3262793783, 'DE', 'DEU', 'ألمانيا'),
(60318, 3262793784, 3262793815, 'NL', 'NLD', 'هولندا'),
(60319, 3262793816, 3262793831, 'DE', 'DEU', 'ألمانيا'),
(60320, 3262793832, 3262793847, 'NL', 'NLD', 'هولندا'),
(60321, 3262793848, 3262793855, 'DE', 'DEU', 'ألمانيا'),
(60322, 3262793856, 3262793951, 'NL', 'NLD', 'هولندا'),
(60323, 3262793952, 3262793959, 'DE', 'DEU', 'ألمانيا'),
(60324, 3262793960, 3262793991, 'NL', 'NLD', 'هولندا'),
(60325, 3262793992, 3262793999, 'DE', 'DEU', 'ألمانيا'),
(60326, 3262794000, 3262794007, 'NL', 'NLD', 'هولندا'),
(60327, 3262794008, 3262794015, 'DE', 'DEU', 'ألمانيا'),
(60328, 3262794016, 3262794063, 'NL', 'NLD', 'هولندا'),
(60329, 3262794064, 3262794071, 'DE', 'DEU', 'ألمانيا'),
(60330, 3262794072, 3262794151, 'NL', 'NLD', 'هولندا'),
(60331, 3262794152, 3262794159, 'DE', 'DEU', 'ألمانيا'),
(60332, 3262794160, 3262794279, 'NL', 'NLD', 'هولندا'),
(60333, 3262794280, 3262794287, 'DE', 'DEU', 'ألمانيا'),
(60334, 3262794288, 3262794327, 'NL', 'NLD', 'هولندا'),
(60335, 3262794328, 3262794335, 'DE', 'DEU', 'ألمانيا'),
(60336, 3262794336, 3262794447, 'NL', 'NLD', 'هولندا'),
(60337, 3262794448, 3262794455, 'DE', 'DEU', 'ألمانيا'),
(60338, 3262794456, 3262794719, 'NL', 'NLD', 'هولندا'),
(60339, 3262794720, 3262794727, 'DE', 'DEU', 'ألمانيا'),
(60340, 3262794728, 3262794751, 'NL', 'NLD', 'هولندا'),
(60341, 3262794752, 3262797823, 'DE', 'DEU', 'ألمانيا'),
(60342, 3262797824, 3262797839, 'NL', 'NLD', 'هولندا'),
(60343, 3262797840, 3262797847, 'DE', 'DEU', 'ألمانيا'),
(60344, 3262797848, 3262797967, 'NL', 'NLD', 'هولندا'),
(60345, 3262797968, 3262797975, 'DE', 'DEU', 'ألمانيا'),
(60346, 3262797976, 3262797983, 'NL', 'NLD', 'هولندا'),
(60347, 3262797984, 3262797991, 'DE', 'DEU', 'ألمانيا'),
(60348, 3262797992, 3262798039, 'NL', 'NLD', 'هولندا'),
(60349, 3262798040, 3262798047, 'DE', 'DEU', 'ألمانيا'),
(60350, 3262798048, 3262798103, 'NL', 'NLD', 'هولندا'),
(60351, 3262798104, 3262798111, 'DE', 'DEU', 'ألمانيا'),
(60352, 3262798112, 3262798135, 'NL', 'NLD', 'هولندا'),
(60353, 3262798136, 3262798151, 'DE', 'DEU', 'ألمانيا'),
(60354, 3262798152, 3262798231, 'NL', 'NLD', 'هولندا'),
(60355, 3262798232, 3262798239, 'DE', 'DEU', 'ألمانيا'),
(60356, 3262798240, 3262798279, 'NL', 'NLD', 'هولندا'),
(60357, 3262798280, 3262798287, 'DE', 'DEU', 'ألمانيا'),
(60358, 3262798288, 3262798319, 'NL', 'NLD', 'هولندا'),
(60359, 3262798320, 3262798327, 'DE', 'DEU', 'ألمانيا'),
(60360, 3262798328, 3262798343, 'NL', 'NLD', 'هولندا'),
(60361, 3262798344, 3262798351, 'DE', 'DEU', 'ألمانيا'),
(60362, 3262798352, 3262798407, 'NL', 'NLD', 'هولندا'),
(60363, 3262798408, 3262798415, 'DE', 'DEU', 'ألمانيا'),
(60364, 3262798416, 3262798431, 'NL', 'NLD', 'هولندا'),
(60365, 3262798432, 3262798439, 'DE', 'DEU', 'ألمانيا'),
(60366, 3262798440, 3262798447, 'NL', 'NLD', 'هولندا'),
(60367, 3262798448, 3262798455, 'DE', 'DEU', 'ألمانيا'),
(60368, 3262798456, 3262798463, 'NL', 'NLD', 'هولندا'),
(60369, 3262798464, 3262798471, 'DE', 'DEU', 'ألمانيا'),
(60370, 3262798472, 3262798487, 'NL', 'NLD', 'هولندا'),
(60371, 3262798488, 3262798503, 'DE', 'DEU', 'ألمانيا'),
(60372, 3262798504, 3262798511, 'NL', 'NLD', 'هولندا'),
(60373, 3262798512, 3262798519, 'DE', 'DEU', 'ألمانيا'),
(60374, 3262798520, 3262798583, 'NL', 'NLD', 'هولندا'),
(60375, 3262798584, 3262798591, 'DE', 'DEU', 'ألمانيا'),
(60376, 3262798592, 3262798975, 'NL', 'NLD', 'هولندا'),
(60377, 3262798976, 3262798983, 'DE', 'DEU', 'ألمانيا'),
(60378, 3262798984, 3262799111, 'NL', 'NLD', 'هولندا'),
(60379, 3262799112, 3262799119, 'DE', 'DEU', 'ألمانيا'),
(60380, 3262799120, 3262799143, 'NL', 'NLD', 'هولندا'),
(60381, 3262799144, 3262799151, 'DE', 'DEU', 'ألمانيا'),
(60382, 3262799152, 3262799199, 'NL', 'NLD', 'هولندا'),
(60383, 3262799200, 3262799207, 'DE', 'DEU', 'ألمانيا'),
(60384, 3262799208, 3262799303, 'NL', 'NLD', 'هولندا'),
(60385, 3262799304, 3262799311, 'DE', 'DEU', 'ألمانيا'),
(60386, 3262799312, 3262799383, 'NL', 'NLD', 'هولندا'),
(60387, 3262799384, 3262799399, 'DE', 'DEU', 'ألمانيا'),
(60388, 3262799400, 3262799479, 'NL', 'NLD', 'هولندا'),
(60389, 3262799480, 3262799487, 'DE', 'DEU', 'ألمانيا'),
(60390, 3262799488, 3262799591, 'NL', 'NLD', 'هولندا'),
(60391, 3262799592, 3262799599, 'DE', 'DEU', 'ألمانيا'),
(60392, 3262799600, 3262799735, 'NL', 'NLD', 'هولندا'),
(60393, 3262799736, 3262799743, 'DE', 'DEU', 'ألمانيا'),
(60394, 3262799744, 3262799855, 'NL', 'NLD', 'هولندا'),
(60395, 3262799856, 3262799871, 'DE', 'DEU', 'ألمانيا'),
(60396, 3262799872, 3262799991, 'NL', 'NLD', 'هولندا'),
(60397, 3262799992, 3262800007, 'DE', 'DEU', 'ألمانيا'),
(60398, 3262800008, 3262800071, 'NL', 'NLD', 'هولندا'),
(60399, 3262800072, 3262800079, 'DE', 'DEU', 'ألمانيا'),
(60400, 3262800080, 3262800127, 'NL', 'NLD', 'هولندا'),
(60401, 3262800128, 3262800135, 'DE', 'DEU', 'ألمانيا'),
(60402, 3262800136, 3262800175, 'NL', 'NLD', 'هولندا'),
(60403, 3262800176, 3262800183, 'DE', 'DEU', 'ألمانيا'),
(60404, 3262800184, 3262800215, 'NL', 'NLD', 'هولندا'),
(60405, 3262800216, 3262800223, 'DE', 'DEU', 'ألمانيا'),
(60406, 3262800224, 3262800239, 'NL', 'NLD', 'هولندا'),
(60407, 3262800240, 3262800247, 'DE', 'DEU', 'ألمانيا'),
(60408, 3262800248, 3262800383, 'NL', 'NLD', 'هولندا'),
(60409, 3262800384, 3262800391, 'DE', 'DEU', 'ألمانيا'),
(60410, 3262800392, 3262800407, 'NL', 'NLD', 'هولندا'),
(60411, 3262800408, 3262800423, 'DE', 'DEU', 'ألمانيا'),
(60412, 3262800424, 3262800431, 'NL', 'NLD', 'هولندا'),
(60413, 3262800432, 3262800439, 'DE', 'DEU', 'ألمانيا'),
(60414, 3262800440, 3262800519, 'NL', 'NLD', 'هولندا'),
(60415, 3262800520, 3262800527, 'DE', 'DEU', 'ألمانيا'),
(60416, 3262800528, 3262800567, 'NL', 'NLD', 'هولندا'),
(60417, 3262800568, 3262800575, 'DE', 'DEU', 'ألمانيا'),
(60418, 3262800576, 3262800671, 'NL', 'NLD', 'هولندا'),
(60419, 3262800672, 3262800679, 'DE', 'DEU', 'ألمانيا'),
(60420, 3262800680, 3262800727, 'NL', 'NLD', 'هولندا'),
(60421, 3262800728, 3262800735, 'DE', 'DEU', 'ألمانيا'),
(60422, 3262800736, 3262800871, 'NL', 'NLD', 'هولندا'),
(60423, 3262800872, 3262800879, 'DE', 'DEU', 'ألمانيا'),
(60424, 3262800880, 3262800999, 'NL', 'NLD', 'هولندا'),
(60425, 3262801000, 3262801007, 'DE', 'DEU', 'ألمانيا'),
(60426, 3262801008, 3262801031, 'NL', 'NLD', 'هولندا'),
(60427, 3262801032, 3262801039, 'DE', 'DEU', 'ألمانيا'),
(60428, 3262801040, 3262801071, 'NL', 'NLD', 'هولندا'),
(60429, 3262801072, 3262801079, 'DE', 'DEU', 'ألمانيا'),
(60430, 3262801080, 3262801223, 'NL', 'NLD', 'هولندا'),
(60431, 3262801224, 3262801231, 'DE', 'DEU', 'ألمانيا'),
(60432, 3262801232, 3262801271, 'NL', 'NLD', 'هولندا'),
(60433, 3262801272, 3262801279, 'DE', 'DEU', 'ألمانيا'),
(60434, 3262801280, 3262801287, 'NL', 'NLD', 'هولندا'),
(60435, 3262801288, 3262801311, 'DE', 'DEU', 'ألمانيا'),
(60436, 3262801312, 3262801679, 'NL', 'NLD', 'هولندا'),
(60437, 3262801680, 3262801687, 'DE', 'DEU', 'ألمانيا'),
(60438, 3262801688, 3262801695, 'NL', 'NLD', 'هولندا'),
(60439, 3262801696, 3262801703, 'DE', 'DEU', 'ألمانيا'),
(60440, 3262801704, 3262801791, 'NL', 'NLD', 'هولندا'),
(60441, 3262801792, 3262801799, 'DE', 'DEU', 'ألمانيا'),
(60442, 3262801800, 3262801863, 'NL', 'NLD', 'هولندا'),
(60443, 3262801864, 3262801871, 'DE', 'DEU', 'ألمانيا'),
(60444, 3262801872, 3262801975, 'NL', 'NLD', 'هولندا'),
(60445, 3262801976, 3262801991, 'DE', 'DEU', 'ألمانيا'),
(60446, 3262801992, 3262802007, 'NL', 'NLD', 'هولندا'),
(60447, 3262802008, 3262802015, 'DE', 'DEU', 'ألمانيا'),
(60448, 3262802016, 3262802039, 'NL', 'NLD', 'هولندا'),
(60449, 3262802040, 3262802047, 'DE', 'DEU', 'ألمانيا'),
(60450, 3262802048, 3262802127, 'NL', 'NLD', 'هولندا'),
(60451, 3262802128, 3262802135, 'DE', 'DEU', 'ألمانيا'),
(60452, 3262802136, 3262802183, 'NL', 'NLD', 'هولندا'),
(60453, 3262802184, 3262802191, 'DE', 'DEU', 'ألمانيا'),
(60454, 3262802192, 3262802231, 'NL', 'NLD', 'هولندا'),
(60455, 3262802232, 3262802239, 'DE', 'DEU', 'ألمانيا'),
(60456, 3262802240, 3262802271, 'NL', 'NLD', 'هولندا'),
(60457, 3262802272, 3262802287, 'DE', 'DEU', 'ألمانيا'),
(60458, 3262802288, 3262802519, 'NL', 'NLD', 'هولندا'),
(60459, 3262802520, 3262802527, 'DE', 'DEU', 'ألمانيا'),
(60460, 3262802528, 3262802639, 'NL', 'NLD', 'هولندا'),
(60461, 3262802640, 3262802647, 'DE', 'DEU', 'ألمانيا'),
(60462, 3262802648, 3262802727, 'NL', 'NLD', 'هولندا'),
(60463, 3262802728, 3262802743, 'DE', 'DEU', 'ألمانيا'),
(60464, 3262802744, 3262802815, 'NL', 'NLD', 'هولندا'),
(60465, 3262802816, 3262802823, 'DE', 'DEU', 'ألمانيا'),
(60466, 3262802824, 3262803023, 'NL', 'NLD', 'هولندا'),
(60467, 3262803024, 3262803039, 'DE', 'DEU', 'ألمانيا'),
(60468, 3262803040, 3262803127, 'NL', 'NLD', 'هولندا'),
(60469, 3262803128, 3262803135, 'DE', 'DEU', 'ألمانيا'),
(60470, 3262803136, 3262803159, 'NL', 'NLD', 'هولندا'),
(60471, 3262803160, 3262803167, 'DE', 'DEU', 'ألمانيا'),
(60472, 3262803168, 3262803183, 'NL', 'NLD', 'هولندا'),
(60473, 3262803184, 3262803199, 'DE', 'DEU', 'ألمانيا'),
(60474, 3262803200, 3262803351, 'NL', 'NLD', 'هولندا'),
(60475, 3262803352, 3262803359, 'DE', 'DEU', 'ألمانيا'),
(60476, 3262803360, 3262803367, 'NL', 'NLD', 'هولندا'),
(60477, 3262803368, 3262803391, 'DE', 'DEU', 'ألمانيا'),
(60478, 3262803392, 3262803487, 'NL', 'NLD', 'هولندا'),
(60479, 3262803488, 3262803495, 'DE', 'DEU', 'ألمانيا'),
(60480, 3262803496, 3262803535, 'NL', 'NLD', 'هولندا'),
(60481, 3262803536, 3262803543, 'DE', 'DEU', 'ألمانيا'),
(60482, 3262803544, 3262803567, 'NL', 'NLD', 'هولندا'),
(60483, 3262803568, 3262803575, 'DE', 'DEU', 'ألمانيا'),
(60484, 3262803576, 3262803623, 'NL', 'NLD', 'هولندا'),
(60485, 3262803624, 3262803631, 'DE', 'DEU', 'ألمانيا'),
(60486, 3262803632, 3262803703, 'NL', 'NLD', 'هولندا'),
(60487, 3262803704, 3262803743, 'DE', 'DEU', 'ألمانيا'),
(60488, 3262803744, 3262803847, 'NL', 'NLD', 'هولندا'),
(60489, 3262803848, 3262803855, 'DE', 'DEU', 'ألمانيا'),
(60490, 3262803856, 3262803895, 'NL', 'NLD', 'هولندا'),
(60491, 3262803896, 3262803903, 'DE', 'DEU', 'ألمانيا'),
(60492, 3262803904, 3262803991, 'NL', 'NLD', 'هولندا'),
(60493, 3262803992, 3262803999, 'DE', 'DEU', 'ألمانيا'),
(60494, 3262804000, 3262804055, 'NL', 'NLD', 'هولندا'),
(60495, 3262804056, 3262804063, 'DE', 'DEU', 'ألمانيا'),
(60496, 3262804064, 3262804095, 'NL', 'NLD', 'هولندا'),
(60497, 3262804096, 3262804103, 'DE', 'DEU', 'ألمانيا'),
(60498, 3262804104, 3262804135, 'NL', 'NLD', 'هولندا'),
(60499, 3262804136, 3262804143, 'DE', 'DEU', 'ألمانيا'),
(60500, 3262804144, 3262804183, 'NL', 'NLD', 'هولندا'),
(60501, 3262804184, 3262804191, 'DE', 'DEU', 'ألمانيا'),
(60502, 3262804192, 3262804231, 'NL', 'NLD', 'هولندا'),
(60503, 3262804232, 3262804239, 'DE', 'DEU', 'ألمانيا'),
(60504, 3262804240, 3262804359, 'NL', 'NLD', 'هولندا'),
(60505, 3262804360, 3262804367, 'DE', 'DEU', 'ألمانيا'),
(60506, 3262804368, 3262804383, 'NL', 'NLD', 'هولندا'),
(60507, 3262804384, 3262804407, 'DE', 'DEU', 'ألمانيا'),
(60508, 3262804408, 3262804447, 'NL', 'NLD', 'هولندا'),
(60509, 3262804448, 3262804455, 'DE', 'DEU', 'ألمانيا'),
(60510, 3262804456, 3262804479, 'NL', 'NLD', 'هولندا'),
(60511, 3262804480, 3262804487, 'DE', 'DEU', 'ألمانيا'),
(60512, 3262804488, 3262804519, 'NL', 'NLD', 'هولندا'),
(60513, 3262804520, 3262804527, 'DE', 'DEU', 'ألمانيا'),
(60514, 3262804528, 3262804823, 'NL', 'NLD', 'هولندا'),
(60515, 3262804824, 3262804839, 'DE', 'DEU', 'ألمانيا'),
(60516, 3262804840, 3262804871, 'NL', 'NLD', 'هولندا'),
(60517, 3262804872, 3262804879, 'DE', 'DEU', 'ألمانيا'),
(60518, 3262804880, 3262804887, 'NL', 'NLD', 'هولندا'),
(60519, 3262804888, 3262804895, 'DE', 'DEU', 'ألمانيا'),
(60520, 3262804896, 3262804991, 'NL', 'NLD', 'هولندا'),
(60521, 3262804992, 3262804999, 'DE', 'DEU', 'ألمانيا'),
(60522, 3262805000, 3262805255, 'NL', 'NLD', 'هولندا'),
(60523, 3262805256, 3262805271, 'DE', 'DEU', 'ألمانيا'),
(60524, 3262805272, 3262805287, 'NL', 'NLD', 'هولندا'),
(60525, 3262805288, 3262805295, 'DE', 'DEU', 'ألمانيا'),
(60526, 3262805296, 3262805343, 'NL', 'NLD', 'هولندا'),
(60527, 3262805344, 3262805351, 'DE', 'DEU', 'ألمانيا'),
(60528, 3262805352, 3262805551, 'NL', 'NLD', 'هولندا'),
(60529, 3262805552, 3262805559, 'DE', 'DEU', 'ألمانيا'),
(60530, 3262805560, 3262805895, 'NL', 'NLD', 'هولندا'),
(60531, 3262805896, 3262805903, 'DE', 'DEU', 'ألمانيا'),
(60532, 3262805904, 3262805927, 'NL', 'NLD', 'هولندا'),
(60533, 3262805928, 3262805943, 'DE', 'DEU', 'ألمانيا'),
(60534, 3262805944, 3262805991, 'NL', 'NLD', 'هولندا'),
(60535, 3262805992, 3262805999, 'DE', 'DEU', 'ألمانيا'),
(60536, 3262806000, 3262806015, 'NL', 'NLD', 'هولندا'),
(60537, 3262806016, 3262809087, 'DE', 'DEU', 'ألمانيا'),
(60538, 3262809088, 3262809111, 'NL', 'NLD', 'هولندا'),
(60539, 3262809112, 3262809135, 'DE', 'DEU', 'ألمانيا'),
(60540, 3262809136, 3262809183, 'NL', 'NLD', 'هولندا'),
(60541, 3262809184, 3262809191, 'DE', 'DEU', 'ألمانيا'),
(60542, 3262809192, 3262809247, 'NL', 'NLD', 'هولندا'),
(60543, 3262809248, 3262809255, 'DE', 'DEU', 'ألمانيا'),
(60544, 3262809256, 3262809423, 'NL', 'NLD', 'هولندا'),
(60545, 3262809424, 3262809431, 'DE', 'DEU', 'ألمانيا'),
(60546, 3262809432, 3262809503, 'NL', 'NLD', 'هولندا'),
(60547, 3262809504, 3262809511, 'DE', 'DEU', 'ألمانيا'),
(60548, 3262809512, 3262809687, 'NL', 'NLD', 'هولندا'),
(60549, 3262809688, 3262809695, 'DE', 'DEU', 'ألمانيا'),
(60550, 3262809696, 3262809831, 'NL', 'NLD', 'هولندا'),
(60551, 3262809832, 3262809839, 'DE', 'DEU', 'ألمانيا'),
(60552, 3262809840, 3262809935, 'NL', 'NLD', 'هولندا'),
(60553, 3262809936, 3262809943, 'DE', 'DEU', 'ألمانيا'),
(60554, 3262809944, 3262810143, 'NL', 'NLD', 'هولندا'),
(60555, 3262810144, 3262810151, 'DE', 'DEU', 'ألمانيا'),
(60556, 3262810152, 3262810167, 'NL', 'NLD', 'هولندا'),
(60557, 3262810168, 3262810183, 'DE', 'DEU', 'ألمانيا'),
(60558, 3262810184, 3262810247, 'NL', 'NLD', 'هولندا'),
(60559, 3262810248, 3262810255, 'DE', 'DEU', 'ألمانيا'),
(60560, 3262810256, 3262810271, 'NL', 'NLD', 'هولندا'),
(60561, 3262810272, 3262810279, 'DE', 'DEU', 'ألمانيا'),
(60562, 3262810280, 3262810471, 'NL', 'NLD', 'هولندا'),
(60563, 3262810472, 3262810479, 'DE', 'DEU', 'ألمانيا'),
(60564, 3262810480, 3262810623, 'NL', 'NLD', 'هولندا'),
(60565, 3262810624, 3262810631, 'DE', 'DEU', 'ألمانيا'),
(60566, 3262810632, 3262810647, 'NL', 'NLD', 'هولندا'),
(60567, 3262810648, 3262810663, 'DE', 'DEU', 'ألمانيا'),
(60568, 3262810664, 3262810727, 'NL', 'NLD', 'هولندا'),
(60569, 3262810728, 3262810735, 'DE', 'DEU', 'ألمانيا'),
(60570, 3262810736, 3262810807, 'NL', 'NLD', 'هولندا'),
(60571, 3262810808, 3262810815, 'DE', 'DEU', 'ألمانيا'),
(60572, 3262810816, 3262810879, 'NL', 'NLD', 'هولندا'),
(60573, 3262810880, 3262810887, 'DE', 'DEU', 'ألمانيا'),
(60574, 3262810888, 3262810911, 'NL', 'NLD', 'هولندا'),
(60575, 3262810912, 3262810927, 'DE', 'DEU', 'ألمانيا'),
(60576, 3262810928, 3262810951, 'NL', 'NLD', 'هولندا'),
(60577, 3262810952, 3262810967, 'DE', 'DEU', 'ألمانيا'),
(60578, 3262810968, 3262811023, 'NL', 'NLD', 'هولندا'),
(60579, 3262811024, 3262811031, 'DE', 'DEU', 'ألمانيا'),
(60580, 3262811032, 3262811039, 'NL', 'NLD', 'هولندا'),
(60581, 3262811040, 3262811047, 'DE', 'DEU', 'ألمانيا'),
(60582, 3262811048, 3262811055, 'NL', 'NLD', 'هولندا'),
(60583, 3262811056, 3262811063, 'DE', 'DEU', 'ألمانيا'),
(60584, 3262811064, 3262811095, 'NL', 'NLD', 'هولندا'),
(60585, 3262811096, 3262811103, 'DE', 'DEU', 'ألمانيا'),
(60586, 3262811104, 3262811175, 'NL', 'NLD', 'هولندا'),
(60587, 3262811176, 3262811183, 'DE', 'DEU', 'ألمانيا'),
(60588, 3262811184, 3262811199, 'NL', 'NLD', 'هولندا'),
(60589, 3262811200, 3262811207, 'DE', 'DEU', 'ألمانيا'),
(60590, 3262811208, 3262811231, 'NL', 'NLD', 'هولندا'),
(60591, 3262811232, 3262811239, 'DE', 'DEU', 'ألمانيا'),
(60592, 3262811240, 3262811279, 'NL', 'NLD', 'هولندا'),
(60593, 3262811280, 3262811287, 'DE', 'DEU', 'ألمانيا'),
(60594, 3262811288, 3262811295, 'NL', 'NLD', 'هولندا'),
(60595, 3262811296, 3262811303, 'DE', 'DEU', 'ألمانيا'),
(60596, 3262811304, 3262811319, 'NL', 'NLD', 'هولندا'),
(60597, 3262811320, 3262811327, 'DE', 'DEU', 'ألمانيا'),
(60598, 3262811328, 3262811343, 'NL', 'NLD', 'هولندا'),
(60599, 3262811344, 3262811351, 'DE', 'DEU', 'ألمانيا'),
(60600, 3262811352, 3262811399, 'NL', 'NLD', 'هولندا'),
(60601, 3262811400, 3262811407, 'DE', 'DEU', 'ألمانيا'),
(60602, 3262811408, 3262811503, 'NL', 'NLD', 'هولندا'),
(60603, 3262811504, 3262811511, 'DE', 'DEU', 'ألمانيا'),
(60604, 3262811512, 3262811535, 'NL', 'NLD', 'هولندا'),
(60605, 3262811536, 3262811543, 'DE', 'DEU', 'ألمانيا'),
(60606, 3262811544, 3262811599, 'NL', 'NLD', 'هولندا'),
(60607, 3262811600, 3262811607, 'DE', 'DEU', 'ألمانيا'),
(60608, 3262811608, 3262811759, 'NL', 'NLD', 'هولندا'),
(60609, 3262811760, 3262811767, 'DE', 'DEU', 'ألمانيا'),
(60610, 3262811768, 3262811855, 'NL', 'NLD', 'هولندا'),
(60611, 3262811856, 3262811863, 'DE', 'DEU', 'ألمانيا'),
(60612, 3262811864, 3262811935, 'NL', 'NLD', 'هولندا'),
(60613, 3262811936, 3262811943, 'DE', 'DEU', 'ألمانيا'),
(60614, 3262811944, 3262812007, 'NL', 'NLD', 'هولندا'),
(60615, 3262812008, 3262812015, 'DE', 'DEU', 'ألمانيا'),
(60616, 3262812016, 3262812063, 'NL', 'NLD', 'هولندا'),
(60617, 3262812064, 3262812071, 'DE', 'DEU', 'ألمانيا'),
(60618, 3262812072, 3262812087, 'NL', 'NLD', 'هولندا'),
(60619, 3262812088, 3262812095, 'DE', 'DEU', 'ألمانيا'),
(60620, 3262812096, 3262812127, 'NL', 'NLD', 'هولندا'),
(60621, 3262812128, 3262812135, 'DE', 'DEU', 'ألمانيا'),
(60622, 3262812136, 3262812247, 'NL', 'NLD', 'هولندا'),
(60623, 3262812248, 3262812263, 'DE', 'DEU', 'ألمانيا'),
(60624, 3262812264, 3262812287, 'NL', 'NLD', 'هولندا'),
(60625, 3262812288, 3262812295, 'DE', 'DEU', 'ألمانيا'),
(60626, 3262812296, 3262812487, 'NL', 'NLD', 'هولندا'),
(60627, 3262812488, 3262812495, 'DE', 'DEU', 'ألمانيا'),
(60628, 3262812496, 3262812551, 'NL', 'NLD', 'هولندا'),
(60629, 3262812552, 3262812559, 'DE', 'DEU', 'ألمانيا'),
(60630, 3262812560, 3262812575, 'NL', 'NLD', 'هولندا'),
(60631, 3262812576, 3262812583, 'DE', 'DEU', 'ألمانيا'),
(60632, 3262812584, 3262812751, 'NL', 'NLD', 'هولندا'),
(60633, 3262812752, 3262812759, 'DE', 'DEU', 'ألمانيا'),
(60634, 3262812760, 3262812775, 'NL', 'NLD', 'هولندا'),
(60635, 3262812776, 3262812783, 'DE', 'DEU', 'ألمانيا'),
(60636, 3262812784, 3262812839, 'NL', 'NLD', 'هولندا'),
(60637, 3262812840, 3262812847, 'DE', 'DEU', 'ألمانيا'),
(60638, 3262812848, 3262812927, 'NL', 'NLD', 'هولندا'),
(60639, 3262812928, 3262812935, 'DE', 'DEU', 'ألمانيا'),
(60640, 3262812936, 3262812991, 'NL', 'NLD', 'هولندا'),
(60641, 3262812992, 3262812999, 'DE', 'DEU', 'ألمانيا'),
(60642, 3262813000, 3262813047, 'NL', 'NLD', 'هولندا'),
(60643, 3262813048, 3262813055, 'DE', 'DEU', 'ألمانيا'),
(60644, 3262813056, 3262813327, 'NL', 'NLD', 'هولندا'),
(60645, 3262813328, 3262813335, 'DE', 'DEU', 'ألمانيا'),
(60646, 3262813336, 3262813343, 'NL', 'NLD', 'هولندا'),
(60647, 3262813344, 3262813351, 'DE', 'DEU', 'ألمانيا'),
(60648, 3262813352, 3262813391, 'NL', 'NLD', 'هولندا'),
(60649, 3262813392, 3262813399, 'DE', 'DEU', 'ألمانيا'),
(60650, 3262813400, 3262813415, 'NL', 'NLD', 'هولندا'),
(60651, 3262813416, 3262813423, 'DE', 'DEU', 'ألمانيا'),
(60652, 3262813424, 3262813455, 'NL', 'NLD', 'هولندا'),
(60653, 3262813456, 3262813463, 'DE', 'DEU', 'ألمانيا'),
(60654, 3262813464, 3262813503, 'NL', 'NLD', 'هولندا'),
(60655, 3262813504, 3262813511, 'DE', 'DEU', 'ألمانيا'),
(60656, 3262813512, 3262813623, 'NL', 'NLD', 'هولندا'),
(60657, 3262813624, 3262813639, 'DE', 'DEU', 'ألمانيا'),
(60658, 3262813640, 3262813735, 'NL', 'NLD', 'هولندا'),
(60659, 3262813736, 3262813743, 'DE', 'DEU', 'ألمانيا'),
(60660, 3262813744, 3262813807, 'NL', 'NLD', 'هولندا'),
(60661, 3262813808, 3262813815, 'DE', 'DEU', 'ألمانيا'),
(60662, 3262813816, 3262813903, 'NL', 'NLD', 'هولندا'),
(60663, 3262813904, 3262813911, 'DE', 'DEU', 'ألمانيا'),
(60664, 3262813912, 3262813951, 'NL', 'NLD', 'هولندا'),
(60665, 3262813952, 3262813959, 'DE', 'DEU', 'ألمانيا'),
(60666, 3262813960, 3262813983, 'NL', 'NLD', 'هولندا'),
(60667, 3262813984, 3262813991, 'DE', 'DEU', 'ألمانيا'),
(60668, 3262813992, 3262814023, 'NL', 'NLD', 'هولندا'),
(60669, 3262814024, 3262814031, 'DE', 'DEU', 'ألمانيا'),
(60670, 3262814032, 3262814079, 'NL', 'NLD', 'هولندا'),
(60671, 3262814080, 3262814087, 'DE', 'DEU', 'ألمانيا'),
(60672, 3262814088, 3262814095, 'NL', 'NLD', 'هولندا'),
(60673, 3262814096, 3262814103, 'DE', 'DEU', 'ألمانيا'),
(60674, 3262814104, 3262814383, 'NL', 'NLD', 'هولندا'),
(60675, 3262814384, 3262814399, 'DE', 'DEU', 'ألمانيا'),
(60676, 3262814400, 3262814519, 'NL', 'NLD', 'هولندا'),
(60677, 3262814520, 3262814527, 'DE', 'DEU', 'ألمانيا'),
(60678, 3262814528, 3262814575, 'NL', 'NLD', 'هولندا'),
(60679, 3262814576, 3262814583, 'DE', 'DEU', 'ألمانيا'),
(60680, 3262814584, 3262814791, 'NL', 'NLD', 'هولندا'),
(60681, 3262814792, 3262814799, 'DE', 'DEU', 'ألمانيا'),
(60682, 3262814800, 3262814847, 'NL', 'NLD', 'هولندا'),
(60683, 3262814848, 3262814855, 'DE', 'DEU', 'ألمانيا'),
(60684, 3262814856, 3262814887, 'NL', 'NLD', 'هولندا'),
(60685, 3262814888, 3262814895, 'DE', 'DEU', 'ألمانيا'),
(60686, 3262814896, 3262815191, 'NL', 'NLD', 'هولندا'),
(60687, 3262815192, 3262815207, 'DE', 'DEU', 'ألمانيا'),
(60688, 3262815208, 3262815263, 'NL', 'NLD', 'هولندا'),
(60689, 3262815264, 3262815271, 'DE', 'DEU', 'ألمانيا'),
(60690, 3262815272, 3262815303, 'NL', 'NLD', 'هولندا'),
(60691, 3262815304, 3262815311, 'DE', 'DEU', 'ألمانيا'),
(60692, 3262815312, 3262815423, 'NL', 'NLD', 'هولندا'),
(60693, 3262815424, 3262815431, 'DE', 'DEU', 'ألمانيا'),
(60694, 3262815432, 3262815599, 'NL', 'NLD', 'هولندا'),
(60695, 3262815600, 3262815607, 'DE', 'DEU', 'ألمانيا'),
(60696, 3262815608, 3262815671, 'NL', 'NLD', 'هولندا'),
(60697, 3262815672, 3262815687, 'DE', 'DEU', 'ألمانيا'),
(60698, 3262815688, 3262815719, 'NL', 'NLD', 'هولندا'),
(60699, 3262815720, 3262815727, 'DE', 'DEU', 'ألمانيا'),
(60700, 3262815728, 3262815791, 'NL', 'NLD', 'هولندا'),
(60701, 3262815792, 3262815799, 'DE', 'DEU', 'ألمانيا'),
(60702, 3262815800, 3262824527, 'NL', 'NLD', 'هولندا'),
(60703, 3262824528, 3262824551, 'DE', 'DEU', 'ألمانيا'),
(60704, 3262824552, 3262824599, 'NL', 'NLD', 'هولندا'),
(60705, 3262824600, 3262824607, 'DE', 'DEU', 'ألمانيا'),
(60706, 3262824608, 3262824687, 'NL', 'NLD', 'هولندا'),
(60707, 3262824688, 3262824695, 'DE', 'DEU', 'ألمانيا'),
(60708, 3262824696, 3262824759, 'NL', 'NLD', 'هولندا'),
(60709, 3262824760, 3262824767, 'DE', 'DEU', 'ألمانيا'),
(60710, 3262824768, 3262824783, 'NL', 'NLD', 'هولندا'),
(60711, 3262824784, 3262824791, 'DE', 'DEU', 'ألمانيا'),
(60712, 3262824792, 3262824903, 'NL', 'NLD', 'هولندا'),
(60713, 3262824904, 3262824911, 'DE', 'DEU', 'ألمانيا'),
(60714, 3262824912, 3262824919, 'NL', 'NLD', 'هولندا'),
(60715, 3262824920, 3262824927, 'DE', 'DEU', 'ألمانيا'),
(60716, 3262824928, 3262824959, 'NL', 'NLD', 'هولندا'),
(60717, 3262824960, 3262824975, 'DE', 'DEU', 'ألمانيا'),
(60718, 3262824976, 3262825071, 'NL', 'NLD', 'هولندا'),
(60719, 3262825072, 3262825079, 'DE', 'DEU', 'ألمانيا'),
(60720, 3262825080, 3262825119, 'NL', 'NLD', 'هولندا'),
(60721, 3262825120, 3262825127, 'DE', 'DEU', 'ألمانيا'),
(60722, 3262825128, 3262825135, 'NL', 'NLD', 'هولندا'),
(60723, 3262825136, 3262825143, 'DE', 'DEU', 'ألمانيا'),
(60724, 3262825144, 3262825151, 'NL', 'NLD', 'هولندا'),
(60725, 3262825152, 3262825159, 'DE', 'DEU', 'ألمانيا'),
(60726, 3262825160, 3262825223, 'NL', 'NLD', 'هولندا'),
(60727, 3262825224, 3262825231, 'DE', 'DEU', 'ألمانيا'),
(60728, 3262825232, 3262825239, 'NL', 'NLD', 'هولندا'),
(60729, 3262825240, 3262825247, 'DE', 'DEU', 'ألمانيا'),
(60730, 3262825248, 3262825327, 'NL', 'NLD', 'هولندا'),
(60731, 3262825328, 3262825335, 'DE', 'DEU', 'ألمانيا'),
(60732, 3262825336, 3262825431, 'NL', 'NLD', 'هولندا'),
(60733, 3262825432, 3262825439, 'DE', 'DEU', 'ألمانيا'),
(60734, 3262825440, 3262825455, 'NL', 'NLD', 'هولندا'),
(60735, 3262825456, 3262825471, 'DE', 'DEU', 'ألمانيا'),
(60736, 3262825472, 3262825503, 'NL', 'NLD', 'هولندا'),
(60737, 3262825504, 3262825511, 'DE', 'DEU', 'ألمانيا'),
(60738, 3262825512, 3262825519, 'NL', 'NLD', 'هولندا'),
(60739, 3262825520, 3262825527, 'DE', 'DEU', 'ألمانيا'),
(60740, 3262825528, 3262825535, 'NL', 'NLD', 'هولندا'),
(60741, 3262825536, 3262825543, 'DE', 'DEU', 'ألمانيا'),
(60742, 3262825544, 3262825567, 'NL', 'NLD', 'هولندا'),
(60743, 3262825568, 3262825575, 'DE', 'DEU', 'ألمانيا'),
(60744, 3262825576, 3262825591, 'NL', 'NLD', 'هولندا'),
(60745, 3262825592, 3262825599, 'DE', 'DEU', 'ألمانيا'),
(60746, 3262825600, 3262825639, 'NL', 'NLD', 'هولندا'),
(60747, 3262825640, 3262825647, 'DE', 'DEU', 'ألمانيا'),
(60748, 3262825648, 3262825671, 'NL', 'NLD', 'هولندا'),
(60749, 3262825672, 3262825687, 'DE', 'DEU', 'ألمانيا'),
(60750, 3262825688, 3262825719, 'NL', 'NLD', 'هولندا'),
(60751, 3262825720, 3262825727, 'DE', 'DEU', 'ألمانيا'),
(60752, 3262825728, 3262825751, 'NL', 'NLD', 'هولندا'),
(60753, 3262825752, 3262825759, 'DE', 'DEU', 'ألمانيا'),
(60754, 3262825760, 3262825783, 'NL', 'NLD', 'هولندا'),
(60755, 3262825784, 3262825791, 'DE', 'DEU', 'ألمانيا'),
(60756, 3262825792, 3262825879, 'NL', 'NLD', 'هولندا'),
(60757, 3262825880, 3262825887, 'DE', 'DEU', 'ألمانيا'),
(60758, 3262825888, 3262825999, 'NL', 'NLD', 'هولندا'),
(60759, 3262826000, 3262826007, 'DE', 'DEU', 'ألمانيا'),
(60760, 3262826008, 3262826103, 'NL', 'NLD', 'هولندا'),
(60761, 3262826104, 3262826111, 'DE', 'DEU', 'ألمانيا'),
(60762, 3262826112, 3262826119, 'NL', 'NLD', 'هولندا'),
(60763, 3262826120, 3262826127, 'DE', 'DEU', 'ألمانيا'),
(60764, 3262826128, 3262826263, 'NL', 'NLD', 'هولندا'),
(60765, 3262826264, 3262826271, 'DE', 'DEU', 'ألمانيا'),
(60766, 3262826272, 3262826647, 'NL', 'NLD', 'هولندا'),
(60767, 3262826648, 3262826655, 'DE', 'DEU', 'ألمانيا'),
(60768, 3262826656, 3262826671, 'NL', 'NLD', 'هولندا'),
(60769, 3262826672, 3262826679, 'DE', 'DEU', 'ألمانيا'),
(60770, 3262826680, 3262826727, 'NL', 'NLD', 'هولندا'),
(60771, 3262826728, 3262826735, 'DE', 'DEU', 'ألمانيا'),
(60772, 3262826736, 3262826815, 'NL', 'NLD', 'هولندا'),
(60773, 3262826816, 3262826831, 'DE', 'DEU', 'ألمانيا'),
(60774, 3262826832, 3262826855, 'NL', 'NLD', 'هولندا'),
(60775, 3262826856, 3262826863, 'DE', 'DEU', 'ألمانيا'),
(60776, 3262826864, 3262827039, 'NL', 'NLD', 'هولندا'),
(60777, 3262827040, 3262827047, 'DE', 'DEU', 'ألمانيا'),
(60778, 3262827048, 3262827143, 'NL', 'NLD', 'هولندا'),
(60779, 3262827144, 3262827151, 'DE', 'DEU', 'ألمانيا'),
(60780, 3262827152, 3262827215, 'NL', 'NLD', 'هولندا'),
(60781, 3262827216, 3262827223, 'DE', 'DEU', 'ألمانيا'),
(60782, 3262827224, 3262827247, 'NL', 'NLD', 'هولندا'),
(60783, 3262827248, 3262827255, 'DE', 'DEU', 'ألمانيا'),
(60784, 3262827256, 3262827263, 'NL', 'NLD', 'هولندا'),
(60785, 3262827264, 3262827271, 'DE', 'DEU', 'ألمانيا'),
(60786, 3262827272, 3262827287, 'NL', 'NLD', 'هولندا'),
(60787, 3262827288, 3262827295, 'DE', 'DEU', 'ألمانيا'),
(60788, 3262827296, 3262827303, 'NL', 'NLD', 'هولندا'),
(60789, 3262827304, 3262827319, 'DE', 'DEU', 'ألمانيا'),
(60790, 3262827320, 3262827327, 'NL', 'NLD', 'هولندا'),
(60791, 3262827328, 3262827335, 'DE', 'DEU', 'ألمانيا'),
(60792, 3262827336, 3262827487, 'NL', 'NLD', 'هولندا'),
(60793, 3262827488, 3262827495, 'DE', 'DEU', 'ألمانيا'),
(60794, 3262827496, 3262827671, 'NL', 'NLD', 'هولندا'),
(60795, 3262827672, 3262827679, 'DE', 'DEU', 'ألمانيا'),
(60796, 3262827680, 3262827687, 'NL', 'NLD', 'هولندا'),
(60797, 3262827688, 3262827695, 'DE', 'DEU', 'ألمانيا'),
(60798, 3262827696, 3262827703, 'NL', 'NLD', 'هولندا'),
(60799, 3262827704, 3262827711, 'DE', 'DEU', 'ألمانيا'),
(60800, 3262827712, 3262827719, 'NL', 'NLD', 'هولندا'),
(60801, 3262827720, 3262827727, 'DE', 'DEU', 'ألمانيا'),
(60802, 3262827728, 3262827799, 'NL', 'NLD', 'هولندا'),
(60803, 3262827800, 3262827807, 'DE', 'DEU', 'ألمانيا'),
(60804, 3262827808, 3262827815, 'NL', 'NLD', 'هولندا'),
(60805, 3262827816, 3262827823, 'DE', 'DEU', 'ألمانيا'),
(60806, 3262827824, 3262828023, 'NL', 'NLD', 'هولندا'),
(60807, 3262828024, 3262828031, 'DE', 'DEU', 'ألمانيا'),
(60808, 3262828032, 3262828159, 'NL', 'NLD', 'هولندا'),
(60809, 3262828160, 3262828167, 'DE', 'DEU', 'ألمانيا'),
(60810, 3262828168, 3262828247, 'NL', 'NLD', 'هولندا'),
(60811, 3262828248, 3262828255, 'DE', 'DEU', 'ألمانيا'),
(60812, 3262828256, 3262828391, 'NL', 'NLD', 'هولندا'),
(60813, 3262828392, 3262828399, 'DE', 'DEU', 'ألمانيا'),
(60814, 3262828400, 3262828463, 'NL', 'NLD', 'هولندا'),
(60815, 3262828464, 3262828471, 'DE', 'DEU', 'ألمانيا'),
(60816, 3262828472, 3262828551, 'NL', 'NLD', 'هولندا'),
(60817, 3262828552, 3262828559, 'DE', 'DEU', 'ألمانيا'),
(60818, 3262828560, 3262828591, 'NL', 'NLD', 'هولندا'),
(60819, 3262828592, 3262828599, 'DE', 'DEU', 'ألمانيا'),
(60820, 3262828600, 3262828663, 'NL', 'NLD', 'هولندا'),
(60821, 3262828664, 3262828671, 'DE', 'DEU', 'ألمانيا'),
(60822, 3262828672, 3262828751, 'NL', 'NLD', 'هولندا'),
(60823, 3262828752, 3262828759, 'DE', 'DEU', 'ألمانيا'),
(60824, 3262828760, 3262828879, 'NL', 'NLD', 'هولندا'),
(60825, 3262828880, 3262828887, 'DE', 'DEU', 'ألمانيا'),
(60826, 3262828888, 3262828951, 'NL', 'NLD', 'هولندا'),
(60827, 3262828952, 3262828959, 'DE', 'DEU', 'ألمانيا'),
(60828, 3262828960, 3262829015, 'NL', 'NLD', 'هولندا'),
(60829, 3262829016, 3262829023, 'DE', 'DEU', 'ألمانيا'),
(60830, 3262829024, 3262829055, 'NL', 'NLD', 'هولندا'),
(60831, 3262829056, 3262829063, 'DE', 'DEU', 'ألمانيا'),
(60832, 3262829064, 3262829087, 'NL', 'NLD', 'هولندا'),
(60833, 3262829088, 3262829095, 'DE', 'DEU', 'ألمانيا'),
(60834, 3262829096, 3262829167, 'NL', 'NLD', 'هولندا'),
(60835, 3262829168, 3262829183, 'DE', 'DEU', 'ألمانيا'),
(60836, 3262829184, 3262829303, 'NL', 'NLD', 'هولندا'),
(60837, 3262829304, 3262829311, 'DE', 'DEU', 'ألمانيا'),
(60838, 3262829312, 3262829391, 'NL', 'NLD', 'هولندا'),
(60839, 3262829392, 3262829407, 'DE', 'DEU', 'ألمانيا'),
(60840, 3262829408, 3262829431, 'NL', 'NLD', 'هولندا'),
(60841, 3262829432, 3262829439, 'DE', 'DEU', 'ألمانيا'),
(60842, 3262829440, 3262829495, 'NL', 'NLD', 'هولندا'),
(60843, 3262829496, 3262829503, 'DE', 'DEU', 'ألمانيا'),
(60844, 3262829504, 3262829527, 'NL', 'NLD', 'هولندا'),
(60845, 3262829528, 3262829551, 'DE', 'DEU', 'ألمانيا'),
(60846, 3262829552, 3262829567, 'NL', 'NLD', 'هولندا'),
(60847, 3262829568, 3262830599, 'DE', 'DEU', 'ألمانيا'),
(60848, 3262830600, 3262830815, 'NL', 'NLD', 'هولندا'),
(60849, 3262830816, 3262830823, 'DE', 'DEU', 'ألمانيا'),
(60850, 3262830824, 3262830839, 'NL', 'NLD', 'هولندا'),
(60851, 3262830840, 3262830847, 'DE', 'DEU', 'ألمانيا'),
(60852, 3262830848, 3262830951, 'NL', 'NLD', 'هولندا'),
(60853, 3262830952, 3262830959, 'DE', 'DEU', 'ألمانيا'),
(60854, 3262830960, 3262830999, 'NL', 'NLD', 'هولندا'),
(60855, 3262831000, 3262831015, 'DE', 'DEU', 'ألمانيا'),
(60856, 3262831016, 3262831127, 'NL', 'NLD', 'هولندا'),
(60857, 3262831128, 3262831135, 'DE', 'DEU', 'ألمانيا'),
(60858, 3262831136, 3262831295, 'NL', 'NLD', 'هولندا'),
(60859, 3262831296, 3262831303, 'DE', 'DEU', 'ألمانيا'),
(60860, 3262831304, 3262831415, 'NL', 'NLD', 'هولندا'),
(60861, 3262831416, 3262831423, 'DE', 'DEU', 'ألمانيا'),
(60862, 3262831424, 3262831495, 'NL', 'NLD', 'هولندا'),
(60863, 3262831496, 3262831503, 'DE', 'DEU', 'ألمانيا'),
(60864, 3262831504, 3262831743, 'NL', 'NLD', 'هولندا'),
(60865, 3262831744, 3262831751, 'DE', 'DEU', 'ألمانيا'),
(60866, 3262831752, 3262831791, 'NL', 'NLD', 'هولندا'),
(60867, 3262831792, 3262831799, 'DE', 'DEU', 'ألمانيا'),
(60868, 3262831800, 3262831983, 'NL', 'NLD', 'هولندا'),
(60869, 3262831984, 3262831991, 'DE', 'DEU', 'ألمانيا'),
(60870, 3262831992, 3262831999, 'NL', 'NLD', 'هولندا'),
(60871, 3262832000, 3262832007, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(60872, 3262832008, 3262832055, 'NL', 'NLD', 'هولندا'),
(60873, 3262832056, 3262832063, 'DE', 'DEU', 'ألمانيا'),
(60874, 3262832064, 3262832087, 'NL', 'NLD', 'هولندا'),
(60875, 3262832088, 3262832095, 'DE', 'DEU', 'ألمانيا'),
(60876, 3262832096, 3262832159, 'NL', 'NLD', 'هولندا'),
(60877, 3262832160, 3262832167, 'DE', 'DEU', 'ألمانيا'),
(60878, 3262832168, 3262832191, 'NL', 'NLD', 'هولندا'),
(60879, 3262832192, 3262832199, 'DE', 'DEU', 'ألمانيا'),
(60880, 3262832200, 3262832239, 'NL', 'NLD', 'هولندا'),
(60881, 3262832240, 3262832247, 'DE', 'DEU', 'ألمانيا'),
(60882, 3262832248, 3262832271, 'NL', 'NLD', 'هولندا'),
(60883, 3262832272, 3262832279, 'DE', 'DEU', 'ألمانيا'),
(60884, 3262832280, 3262832463, 'NL', 'NLD', 'هولندا'),
(60885, 3262832464, 3262832471, 'DE', 'DEU', 'ألمانيا'),
(60886, 3262832472, 3262832479, 'NL', 'NLD', 'هولندا'),
(60887, 3262832480, 3262832495, 'DE', 'DEU', 'ألمانيا'),
(60888, 3262832496, 3262832567, 'NL', 'NLD', 'هولندا'),
(60889, 3262832568, 3262832575, 'DE', 'DEU', 'ألمانيا'),
(60890, 3262832576, 3262832639, 'NL', 'NLD', 'هولندا'),
(60891, 3262832640, 3262840319, 'DE', 'DEU', 'ألمانيا'),
(60892, 3262840320, 3262840471, 'NL', 'NLD', 'هولندا'),
(60893, 3262840472, 3262840479, 'DE', 'DEU', 'ألمانيا'),
(60894, 3262840480, 3262840583, 'NL', 'NLD', 'هولندا'),
(60895, 3262840584, 3262840591, 'DE', 'DEU', 'ألمانيا'),
(60896, 3262840592, 3262840751, 'NL', 'NLD', 'هولندا'),
(60897, 3262840752, 3262840759, 'DE', 'DEU', 'ألمانيا'),
(60898, 3262840760, 3262840791, 'NL', 'NLD', 'هولندا'),
(60899, 3262840792, 3262840807, 'DE', 'DEU', 'ألمانيا'),
(60900, 3262840808, 3262840903, 'NL', 'NLD', 'هولندا'),
(60901, 3262840904, 3262840911, 'DE', 'DEU', 'ألمانيا'),
(60902, 3262840912, 3262841055, 'NL', 'NLD', 'هولندا'),
(60903, 3262841056, 3262841063, 'DE', 'DEU', 'ألمانيا'),
(60904, 3262841064, 3262841199, 'NL', 'NLD', 'هولندا'),
(60905, 3262841200, 3262841207, 'DE', 'DEU', 'ألمانيا'),
(60906, 3262841208, 3262841255, 'NL', 'NLD', 'هولندا'),
(60907, 3262841256, 3262841263, 'DE', 'DEU', 'ألمانيا'),
(60908, 3262841264, 3262841287, 'NL', 'NLD', 'هولندا'),
(60909, 3262841288, 3262841295, 'DE', 'DEU', 'ألمانيا'),
(60910, 3262841296, 3262841519, 'NL', 'NLD', 'هولندا'),
(60911, 3262841520, 3262841527, 'DE', 'DEU', 'ألمانيا'),
(60912, 3262841528, 3262841551, 'NL', 'NLD', 'هولندا'),
(60913, 3262841552, 3262841567, 'DE', 'DEU', 'ألمانيا'),
(60914, 3262841568, 3262841743, 'NL', 'NLD', 'هولندا'),
(60915, 3262841744, 3262841751, 'DE', 'DEU', 'ألمانيا'),
(60916, 3262841752, 3262841775, 'NL', 'NLD', 'هولندا'),
(60917, 3262841776, 3262841783, 'DE', 'DEU', 'ألمانيا'),
(60918, 3262841784, 3262841807, 'NL', 'NLD', 'هولندا'),
(60919, 3262841808, 3262841815, 'DE', 'DEU', 'ألمانيا'),
(60920, 3262841816, 3262841831, 'NL', 'NLD', 'هولندا'),
(60921, 3262841832, 3262841847, 'DE', 'DEU', 'ألمانيا'),
(60922, 3262841848, 3262841863, 'NL', 'NLD', 'هولندا'),
(60923, 3262841864, 3262841871, 'DE', 'DEU', 'ألمانيا'),
(60924, 3262841872, 3262841887, 'NL', 'NLD', 'هولندا'),
(60925, 3262841888, 3262841895, 'DE', 'DEU', 'ألمانيا'),
(60926, 3262841896, 3262842007, 'NL', 'NLD', 'هولندا'),
(60927, 3262842008, 3262842015, 'DE', 'DEU', 'ألمانيا'),
(60928, 3262842016, 3262842071, 'NL', 'NLD', 'هولندا'),
(60929, 3262842072, 3262842079, 'DE', 'DEU', 'ألمانيا'),
(60930, 3262842080, 3262842183, 'NL', 'NLD', 'هولندا'),
(60931, 3262842184, 3262842207, 'DE', 'DEU', 'ألمانيا'),
(60932, 3262842208, 3262842287, 'NL', 'NLD', 'هولندا'),
(60933, 3262842288, 3262842295, 'DE', 'DEU', 'ألمانيا'),
(60934, 3262842296, 3262842327, 'NL', 'NLD', 'هولندا'),
(60935, 3262842328, 3262842343, 'DE', 'DEU', 'ألمانيا'),
(60936, 3262842344, 3262842375, 'NL', 'NLD', 'هولندا'),
(60937, 3262842376, 3262842383, 'DE', 'DEU', 'ألمانيا'),
(60938, 3262842384, 3262842423, 'NL', 'NLD', 'هولندا'),
(60939, 3262842424, 3262842431, 'DE', 'DEU', 'ألمانيا'),
(60940, 3262842432, 3262842487, 'NL', 'NLD', 'هولندا'),
(60941, 3262842488, 3262842495, 'DE', 'DEU', 'ألمانيا'),
(60942, 3262842496, 3262842607, 'NL', 'NLD', 'هولندا'),
(60943, 3262842608, 3262842615, 'DE', 'DEU', 'ألمانيا'),
(60944, 3262842616, 3262842623, 'NL', 'NLD', 'هولندا'),
(60945, 3262842624, 3262842887, 'DE', 'DEU', 'ألمانيا'),
(60946, 3262842888, 3262843055, 'NL', 'NLD', 'هولندا'),
(60947, 3262843056, 3262843063, 'DE', 'DEU', 'ألمانيا'),
(60948, 3262843064, 3262843311, 'NL', 'NLD', 'هولندا'),
(60949, 3262843312, 3262843327, 'DE', 'DEU', 'ألمانيا'),
(60950, 3262843328, 3262843415, 'NL', 'NLD', 'هولندا'),
(60951, 3262843416, 3262843423, 'DE', 'DEU', 'ألمانيا'),
(60952, 3262843424, 3262843463, 'NL', 'NLD', 'هولندا'),
(60953, 3262843464, 3262843471, 'DE', 'DEU', 'ألمانيا'),
(60954, 3262843472, 3262843583, 'NL', 'NLD', 'هولندا'),
(60955, 3262843584, 3262843591, 'DE', 'DEU', 'ألمانيا'),
(60956, 3262843592, 3262843799, 'NL', 'NLD', 'هولندا'),
(60957, 3262843800, 3262843807, 'DE', 'DEU', 'ألمانيا'),
(60958, 3262843808, 3262843815, 'NL', 'NLD', 'هولندا'),
(60959, 3262843816, 3262843823, 'DE', 'DEU', 'ألمانيا'),
(60960, 3262843824, 3262843967, 'NL', 'NLD', 'هولندا'),
(60961, 3262843968, 3262843975, 'DE', 'DEU', 'ألمانيا'),
(60962, 3262843976, 3262844055, 'NL', 'NLD', 'هولندا'),
(60963, 3262844056, 3262844071, 'DE', 'DEU', 'ألمانيا'),
(60964, 3262844072, 3262844143, 'NL', 'NLD', 'هولندا'),
(60965, 3262844144, 3262844151, 'DE', 'DEU', 'ألمانيا'),
(60966, 3262844152, 3262844159, 'NL', 'NLD', 'هولندا'),
(60967, 3262844160, 3262844167, 'DE', 'DEU', 'ألمانيا'),
(60968, 3262844168, 3262844231, 'NL', 'NLD', 'هولندا'),
(60969, 3262844232, 3262844239, 'DE', 'DEU', 'ألمانيا'),
(60970, 3262844240, 3262844247, 'NL', 'NLD', 'هولندا'),
(60971, 3262844248, 3262844255, 'DE', 'DEU', 'ألمانيا'),
(60972, 3262844256, 3262844303, 'NL', 'NLD', 'هولندا'),
(60973, 3262844304, 3262844319, 'DE', 'DEU', 'ألمانيا'),
(60974, 3262844320, 3262844375, 'NL', 'NLD', 'هولندا'),
(60975, 3262844376, 3262844383, 'DE', 'DEU', 'ألمانيا'),
(60976, 3262844384, 3262844399, 'NL', 'NLD', 'هولندا'),
(60977, 3262844400, 3262844407, 'DE', 'DEU', 'ألمانيا'),
(60978, 3262844408, 3262844511, 'NL', 'NLD', 'هولندا'),
(60979, 3262844512, 3262844519, 'DE', 'DEU', 'ألمانيا'),
(60980, 3262844520, 3262844663, 'NL', 'NLD', 'هولندا'),
(60981, 3262844664, 3262844671, 'DE', 'DEU', 'ألمانيا'),
(60982, 3262844672, 3262844735, 'NL', 'NLD', 'هولندا'),
(60983, 3262844736, 3262844743, 'DE', 'DEU', 'ألمانيا'),
(60984, 3262844744, 3262844767, 'NL', 'NLD', 'هولندا'),
(60985, 3262844768, 3262844775, 'DE', 'DEU', 'ألمانيا'),
(60986, 3262844776, 3262844855, 'NL', 'NLD', 'هولندا'),
(60987, 3262844856, 3262844871, 'DE', 'DEU', 'ألمانيا'),
(60988, 3262844872, 3262844895, 'NL', 'NLD', 'هولندا'),
(60989, 3262844896, 3262844903, 'DE', 'DEU', 'ألمانيا'),
(60990, 3262844904, 3262844967, 'NL', 'NLD', 'هولندا'),
(60991, 3262844968, 3262844983, 'DE', 'DEU', 'ألمانيا'),
(60992, 3262844984, 3262845231, 'NL', 'NLD', 'هولندا'),
(60993, 3262845232, 3262845239, 'DE', 'DEU', 'ألمانيا'),
(60994, 3262845240, 3262845247, 'NL', 'NLD', 'هولندا'),
(60995, 3262845248, 3262845255, 'DE', 'DEU', 'ألمانيا'),
(60996, 3262845256, 3262845335, 'NL', 'NLD', 'هولندا'),
(60997, 3262845336, 3262845343, 'DE', 'DEU', 'ألمانيا'),
(60998, 3262845344, 3262845383, 'NL', 'NLD', 'هولندا'),
(60999, 3262845384, 3262845391, 'DE', 'DEU', 'ألمانيا'),
(61000, 3262845392, 3262845399, 'NL', 'NLD', 'هولندا'),
(61001, 3262845400, 3262845415, 'DE', 'DEU', 'ألمانيا'),
(61002, 3262845416, 3262845655, 'NL', 'NLD', 'هولندا'),
(61003, 3262845656, 3262845671, 'DE', 'DEU', 'ألمانيا'),
(61004, 3262845672, 3262845679, 'NL', 'NLD', 'هولندا'),
(61005, 3262845680, 3262845695, 'DE', 'DEU', 'ألمانيا'),
(61006, 3262845696, 3262845767, 'NL', 'NLD', 'هولندا'),
(61007, 3262845768, 3262845775, 'DE', 'DEU', 'ألمانيا'),
(61008, 3262845776, 3262845815, 'NL', 'NLD', 'هولندا'),
(61009, 3262845816, 3262845823, 'DE', 'DEU', 'ألمانيا'),
(61010, 3262845824, 3262845919, 'NL', 'NLD', 'هولندا'),
(61011, 3262845920, 3262845927, 'DE', 'DEU', 'ألمانيا'),
(61012, 3262845928, 3262845959, 'NL', 'NLD', 'هولندا'),
(61013, 3262845960, 3262845967, 'DE', 'DEU', 'ألمانيا'),
(61014, 3262845968, 3262846151, 'NL', 'NLD', 'هولندا'),
(61015, 3262846152, 3262846159, 'DE', 'DEU', 'ألمانيا'),
(61016, 3262846160, 3262846231, 'NL', 'NLD', 'هولندا'),
(61017, 3262846232, 3262846239, 'DE', 'DEU', 'ألمانيا'),
(61018, 3262846240, 3262846255, 'NL', 'NLD', 'هولندا'),
(61019, 3262846256, 3262846263, 'DE', 'DEU', 'ألمانيا'),
(61020, 3262846264, 3262846543, 'NL', 'NLD', 'هولندا'),
(61021, 3262846544, 3262846551, 'DE', 'DEU', 'ألمانيا'),
(61022, 3262846552, 3262846567, 'NL', 'NLD', 'هولندا'),
(61023, 3262846568, 3262846575, 'DE', 'DEU', 'ألمانيا'),
(61024, 3262846576, 3262846687, 'NL', 'NLD', 'هولندا'),
(61025, 3262846688, 3262846695, 'DE', 'DEU', 'ألمانيا'),
(61026, 3262846696, 3262846759, 'NL', 'NLD', 'هولندا'),
(61027, 3262846760, 3262846767, 'DE', 'DEU', 'ألمانيا'),
(61028, 3262846768, 3262846783, 'NL', 'NLD', 'هولندا'),
(61029, 3262846784, 3262846791, 'DE', 'DEU', 'ألمانيا'),
(61030, 3262846792, 3262846887, 'NL', 'NLD', 'هولندا'),
(61031, 3262846888, 3262846895, 'DE', 'DEU', 'ألمانيا'),
(61032, 3262846896, 3262846911, 'NL', 'NLD', 'هولندا'),
(61033, 3262846912, 3262846919, 'DE', 'DEU', 'ألمانيا'),
(61034, 3262846920, 3262847039, 'NL', 'NLD', 'هولندا'),
(61035, 3262847040, 3262847047, 'DE', 'DEU', 'ألمانيا'),
(61036, 3262847048, 3262847079, 'NL', 'NLD', 'هولندا'),
(61037, 3262847080, 3262847087, 'DE', 'DEU', 'ألمانيا'),
(61038, 3262847088, 3262847111, 'NL', 'NLD', 'هولندا'),
(61039, 3262847112, 3262847119, 'DE', 'DEU', 'ألمانيا'),
(61040, 3262847120, 3262847135, 'NL', 'NLD', 'هولندا'),
(61041, 3262847136, 3262847143, 'DE', 'DEU', 'ألمانيا'),
(61042, 3262847144, 3262847151, 'NL', 'NLD', 'هولندا'),
(61043, 3262847152, 3262847159, 'DE', 'DEU', 'ألمانيا'),
(61044, 3262847160, 3262847263, 'NL', 'NLD', 'هولندا'),
(61045, 3262847264, 3262847271, 'DE', 'DEU', 'ألمانيا'),
(61046, 3262847272, 3262847295, 'NL', 'NLD', 'هولندا'),
(61047, 3262847296, 3262847303, 'DE', 'DEU', 'ألمانيا'),
(61048, 3262847304, 3262847407, 'NL', 'NLD', 'هولندا'),
(61049, 3262847408, 3262847415, 'DE', 'DEU', 'ألمانيا'),
(61050, 3262847416, 3262847647, 'NL', 'NLD', 'هولندا'),
(61051, 3262847648, 3262847663, 'DE', 'DEU', 'ألمانيا'),
(61052, 3262847664, 3262847711, 'NL', 'NLD', 'هولندا'),
(61053, 3262847712, 3262847719, 'DE', 'DEU', 'ألمانيا'),
(61054, 3262847720, 3262847815, 'NL', 'NLD', 'هولندا'),
(61055, 3262847816, 3262847823, 'DE', 'DEU', 'ألمانيا'),
(61056, 3262847824, 3262847887, 'NL', 'NLD', 'هولندا'),
(61057, 3262847888, 3262847895, 'DE', 'DEU', 'ألمانيا'),
(61058, 3262847896, 3262847935, 'NL', 'NLD', 'هولندا'),
(61059, 3262847936, 3262847943, 'DE', 'DEU', 'ألمانيا'),
(61060, 3262847944, 3262848511, 'NL', 'NLD', 'هولندا'),
(61061, 3262848512, 3262848519, 'DE', 'DEU', 'ألمانيا'),
(61062, 3262848520, 3262848543, 'NL', 'NLD', 'هولندا'),
(61063, 3262848544, 3262848551, 'DE', 'DEU', 'ألمانيا'),
(61064, 3262848552, 3262848663, 'NL', 'NLD', 'هولندا'),
(61065, 3262848664, 3262848679, 'DE', 'DEU', 'ألمانيا'),
(61066, 3262848680, 3262848695, 'NL', 'NLD', 'هولندا'),
(61067, 3262848696, 3262848703, 'DE', 'DEU', 'ألمانيا'),
(61068, 3262848704, 3262848711, 'NL', 'NLD', 'هولندا'),
(61069, 3262848712, 3262848719, 'DE', 'DEU', 'ألمانيا'),
(61070, 3262848720, 3262848815, 'NL', 'NLD', 'هولندا'),
(61071, 3262848816, 3262848831, 'DE', 'DEU', 'ألمانيا'),
(61072, 3262848832, 3262848871, 'NL', 'NLD', 'هولندا'),
(61073, 3262848872, 3262848887, 'DE', 'DEU', 'ألمانيا'),
(61074, 3262848888, 3262848911, 'NL', 'NLD', 'هولندا'),
(61075, 3262848912, 3262848919, 'DE', 'DEU', 'ألمانيا'),
(61076, 3262848920, 3262848927, 'NL', 'NLD', 'هولندا'),
(61077, 3262848928, 3262848935, 'DE', 'DEU', 'ألمانيا'),
(61078, 3262848936, 3262848943, 'NL', 'NLD', 'هولندا'),
(61079, 3262848944, 3262848983, 'DE', 'DEU', 'ألمانيا'),
(61080, 3262848984, 3262849055, 'NL', 'NLD', 'هولندا'),
(61081, 3262849056, 3262849071, 'DE', 'DEU', 'ألمانيا'),
(61082, 3262849072, 3262849103, 'NL', 'NLD', 'هولندا'),
(61083, 3262849104, 3262849111, 'DE', 'DEU', 'ألمانيا'),
(61084, 3262849112, 3262849175, 'NL', 'NLD', 'هولندا'),
(61085, 3262849176, 3262849183, 'DE', 'DEU', 'ألمانيا'),
(61086, 3262849184, 3262849199, 'NL', 'NLD', 'هولندا'),
(61087, 3262849200, 3262849207, 'DE', 'DEU', 'ألمانيا'),
(61088, 3262849208, 3262849215, 'NL', 'NLD', 'هولندا'),
(61089, 3262849216, 3262849223, 'DE', 'DEU', 'ألمانيا'),
(61090, 3262849224, 3262849303, 'NL', 'NLD', 'هولندا'),
(61091, 3262849304, 3262849311, 'DE', 'DEU', 'ألمانيا'),
(61092, 3262849312, 3262849359, 'NL', 'NLD', 'هولندا'),
(61093, 3262849360, 3262849367, 'DE', 'DEU', 'ألمانيا'),
(61094, 3262849368, 3262849495, 'NL', 'NLD', 'هولندا'),
(61095, 3262849496, 3262849503, 'DE', 'DEU', 'ألمانيا'),
(61096, 3262849504, 3262849631, 'NL', 'NLD', 'هولندا'),
(61097, 3262849632, 3262849639, 'DE', 'DEU', 'ألمانيا'),
(61098, 3262849640, 3262849767, 'NL', 'NLD', 'هولندا'),
(61099, 3262849768, 3262849775, 'DE', 'DEU', 'ألمانيا'),
(61100, 3262849776, 3262849831, 'NL', 'NLD', 'هولندا'),
(61101, 3262849832, 3262849839, 'DE', 'DEU', 'ألمانيا'),
(61102, 3262849840, 3262850071, 'NL', 'NLD', 'هولندا'),
(61103, 3262850072, 3262850079, 'DE', 'DEU', 'ألمانيا'),
(61104, 3262850080, 3262850111, 'NL', 'NLD', 'هولندا'),
(61105, 3262850112, 3262850119, 'DE', 'DEU', 'ألمانيا'),
(61106, 3262850120, 3262850191, 'NL', 'NLD', 'هولندا'),
(61107, 3262850192, 3262850199, 'DE', 'DEU', 'ألمانيا'),
(61108, 3262850200, 3262850263, 'NL', 'NLD', 'هولندا'),
(61109, 3262850264, 3262850279, 'DE', 'DEU', 'ألمانيا'),
(61110, 3262850280, 3262850303, 'NL', 'NLD', 'هولندا'),
(61111, 3262850304, 3262850311, 'DE', 'DEU', 'ألمانيا'),
(61112, 3262850312, 3262850375, 'NL', 'NLD', 'هولندا'),
(61113, 3262850376, 3262850383, 'DE', 'DEU', 'ألمانيا'),
(61114, 3262850384, 3262850399, 'NL', 'NLD', 'هولندا'),
(61115, 3262850400, 3262850407, 'DE', 'DEU', 'ألمانيا'),
(61116, 3262850408, 3262850447, 'NL', 'NLD', 'هولندا'),
(61117, 3262850448, 3262850455, 'DE', 'DEU', 'ألمانيا'),
(61118, 3262850456, 3262850599, 'NL', 'NLD', 'هولندا'),
(61119, 3262850600, 3262850607, 'DE', 'DEU', 'ألمانيا'),
(61120, 3262850608, 3262850623, 'NL', 'NLD', 'هولندا'),
(61121, 3262850624, 3262850631, 'DE', 'DEU', 'ألمانيا'),
(61122, 3262850632, 3262850647, 'NL', 'NLD', 'هولندا'),
(61123, 3262850648, 3262850663, 'DE', 'DEU', 'ألمانيا'),
(61124, 3262850664, 3262850679, 'NL', 'NLD', 'هولندا'),
(61125, 3262850680, 3262850695, 'DE', 'DEU', 'ألمانيا'),
(61126, 3262850696, 3262850759, 'NL', 'NLD', 'هولندا'),
(61127, 3262850760, 3262850767, 'DE', 'DEU', 'ألمانيا'),
(61128, 3262850768, 3262850783, 'NL', 'NLD', 'هولندا'),
(61129, 3262850784, 3262850791, 'DE', 'DEU', 'ألمانيا'),
(61130, 3262850792, 3262850823, 'NL', 'NLD', 'هولندا'),
(61131, 3262850824, 3262850831, 'DE', 'DEU', 'ألمانيا'),
(61132, 3262850832, 3262850935, 'NL', 'NLD', 'هولندا'),
(61133, 3262850936, 3262850943, 'DE', 'DEU', 'ألمانيا'),
(61134, 3262850944, 3262850967, 'NL', 'NLD', 'هولندا'),
(61135, 3262850968, 3262850975, 'DE', 'DEU', 'ألمانيا'),
(61136, 3262850976, 3262851103, 'NL', 'NLD', 'هولندا'),
(61137, 3262851104, 3262851119, 'DE', 'DEU', 'ألمانيا'),
(61138, 3262851120, 3262851135, 'NL', 'NLD', 'هولندا'),
(61139, 3262851136, 3262851143, 'DE', 'DEU', 'ألمانيا'),
(61140, 3262851144, 3262851175, 'NL', 'NLD', 'هولندا'),
(61141, 3262851176, 3262851183, 'DE', 'DEU', 'ألمانيا'),
(61142, 3262851184, 3262851247, 'NL', 'NLD', 'هولندا'),
(61143, 3262851248, 3262851255, 'DE', 'DEU', 'ألمانيا'),
(61144, 3262851256, 3262851407, 'NL', 'NLD', 'هولندا'),
(61145, 3262851408, 3262851415, 'DE', 'DEU', 'ألمانيا'),
(61146, 3262851416, 3262851455, 'NL', 'NLD', 'هولندا'),
(61147, 3262851456, 3262851471, 'DE', 'DEU', 'ألمانيا'),
(61148, 3262851472, 3262851487, 'NL', 'NLD', 'هولندا'),
(61149, 3262851488, 3262851495, 'DE', 'DEU', 'ألمانيا'),
(61150, 3262851496, 3262851735, 'NL', 'NLD', 'هولندا'),
(61151, 3262851736, 3262851743, 'DE', 'DEU', 'ألمانيا'),
(61152, 3262851744, 3262851887, 'NL', 'NLD', 'هولندا'),
(61153, 3262851888, 3262851895, 'DE', 'DEU', 'ألمانيا'),
(61154, 3262851896, 3262851935, 'NL', 'NLD', 'هولندا'),
(61155, 3262851936, 3262851943, 'DE', 'DEU', 'ألمانيا'),
(61156, 3262851944, 3262852199, 'NL', 'NLD', 'هولندا'),
(61157, 3262852200, 3262852207, 'DE', 'DEU', 'ألمانيا'),
(61158, 3262852208, 3262852247, 'NL', 'NLD', 'هولندا'),
(61159, 3262852248, 3262852255, 'DE', 'DEU', 'ألمانيا'),
(61160, 3262852256, 3262852295, 'NL', 'NLD', 'هولندا'),
(61161, 3262852296, 3262852311, 'DE', 'DEU', 'ألمانيا'),
(61162, 3262852312, 3262852351, 'NL', 'NLD', 'هولندا'),
(61163, 3262852352, 3262852615, 'DE', 'DEU', 'ألمانيا'),
(61164, 3262852616, 3262852887, 'NL', 'NLD', 'هولندا'),
(61165, 3262852888, 3262852895, 'DE', 'DEU', 'ألمانيا'),
(61166, 3262852896, 3262852911, 'NL', 'NLD', 'هولندا'),
(61167, 3262852912, 3262852919, 'DE', 'DEU', 'ألمانيا'),
(61168, 3262852920, 3262852951, 'NL', 'NLD', 'هولندا'),
(61169, 3262852952, 3262852959, 'DE', 'DEU', 'ألمانيا'),
(61170, 3262852960, 3262852975, 'NL', 'NLD', 'هولندا'),
(61171, 3262852976, 3262852983, 'DE', 'DEU', 'ألمانيا'),
(61172, 3262852984, 3262853063, 'NL', 'NLD', 'هولندا'),
(61173, 3262853064, 3262853079, 'DE', 'DEU', 'ألمانيا'),
(61174, 3262853080, 3262853103, 'NL', 'NLD', 'هولندا'),
(61175, 3262853104, 3262853111, 'DE', 'DEU', 'ألمانيا'),
(61176, 3262853112, 3262853127, 'NL', 'NLD', 'هولندا'),
(61177, 3262853128, 3262853143, 'DE', 'DEU', 'ألمانيا'),
(61178, 3262853144, 3262853343, 'NL', 'NLD', 'هولندا'),
(61179, 3262853344, 3262853351, 'DE', 'DEU', 'ألمانيا'),
(61180, 3262853352, 3262853367, 'NL', 'NLD', 'هولندا'),
(61181, 3262853368, 3262853375, 'DE', 'DEU', 'ألمانيا'),
(61182, 3262853376, 3262853399, 'NL', 'NLD', 'هولندا'),
(61183, 3262853400, 3262853407, 'DE', 'DEU', 'ألمانيا'),
(61184, 3262853408, 3262853431, 'NL', 'NLD', 'هولندا'),
(61185, 3262853432, 3262853439, 'DE', 'DEU', 'ألمانيا'),
(61186, 3262853440, 3262853447, 'NL', 'NLD', 'هولندا'),
(61187, 3262853448, 3262853455, 'DE', 'DEU', 'ألمانيا'),
(61188, 3262853456, 3262853463, 'NL', 'NLD', 'هولندا'),
(61189, 3262853464, 3262853471, 'DE', 'DEU', 'ألمانيا'),
(61190, 3262853472, 3262853695, 'NL', 'NLD', 'هولندا'),
(61191, 3262853696, 3262853703, 'DE', 'DEU', 'ألمانيا'),
(61192, 3262853704, 3262853831, 'NL', 'NLD', 'هولندا'),
(61193, 3262853832, 3262853839, 'DE', 'DEU', 'ألمانيا'),
(61194, 3262853840, 3262854119, 'NL', 'NLD', 'هولندا'),
(61195, 3262854120, 3262854127, 'DE', 'DEU', 'ألمانيا'),
(61196, 3262854128, 3262854175, 'NL', 'NLD', 'هولندا'),
(61197, 3262854176, 3262854183, 'DE', 'DEU', 'ألمانيا'),
(61198, 3262854184, 3262854223, 'NL', 'NLD', 'هولندا'),
(61199, 3262854224, 3262854231, 'DE', 'DEU', 'ألمانيا'),
(61200, 3262854232, 3262854399, 'NL', 'NLD', 'هولندا'),
(61201, 3262854400, 3262854407, 'DE', 'DEU', 'ألمانيا'),
(61202, 3262854408, 3262854463, 'NL', 'NLD', 'هولندا'),
(61203, 3262854464, 3262854471, 'DE', 'DEU', 'ألمانيا'),
(61204, 3262854472, 3262854495, 'NL', 'NLD', 'هولندا'),
(61205, 3262854496, 3262854503, 'DE', 'DEU', 'ألمانيا'),
(61206, 3262854504, 3262854599, 'NL', 'NLD', 'هولندا'),
(61207, 3262854600, 3262854607, 'DE', 'DEU', 'ألمانيا'),
(61208, 3262854608, 3262854663, 'NL', 'NLD', 'هولندا'),
(61209, 3262854664, 3262854671, 'DE', 'DEU', 'ألمانيا'),
(61210, 3262854672, 3262854735, 'NL', 'NLD', 'هولندا'),
(61211, 3262854736, 3262854743, 'DE', 'DEU', 'ألمانيا'),
(61212, 3262854744, 3262854775, 'NL', 'NLD', 'هولندا'),
(61213, 3262854776, 3262854783, 'DE', 'DEU', 'ألمانيا'),
(61214, 3262854784, 3262854823, 'NL', 'NLD', 'هولندا'),
(61215, 3262854824, 3262854831, 'DE', 'DEU', 'ألمانيا'),
(61216, 3262854832, 3262854863, 'NL', 'NLD', 'هولندا'),
(61217, 3262854864, 3262854871, 'DE', 'DEU', 'ألمانيا'),
(61218, 3262854872, 3262854943, 'NL', 'NLD', 'هولندا'),
(61219, 3262854944, 3262854967, 'DE', 'DEU', 'ألمانيا'),
(61220, 3262854968, 3262855031, 'NL', 'NLD', 'هولندا'),
(61221, 3262855032, 3262855047, 'DE', 'DEU', 'ألمانيا'),
(61222, 3262855048, 3262855119, 'NL', 'NLD', 'هولندا'),
(61223, 3262855120, 3262855127, 'DE', 'DEU', 'ألمانيا'),
(61224, 3262855128, 3262855359, 'NL', 'NLD', 'هولندا'),
(61225, 3262855360, 3262855367, 'DE', 'DEU', 'ألمانيا'),
(61226, 3262855368, 3262855439, 'NL', 'NLD', 'هولندا'),
(61227, 3262855440, 3262855447, 'DE', 'DEU', 'ألمانيا'),
(61228, 3262855448, 3262855559, 'NL', 'NLD', 'هولندا'),
(61229, 3262855560, 3262855567, 'DE', 'DEU', 'ألمانيا'),
(61230, 3262855568, 3262855767, 'NL', 'NLD', 'هولندا'),
(61231, 3262855768, 3262855775, 'DE', 'DEU', 'ألمانيا'),
(61232, 3262855776, 3262855911, 'NL', 'NLD', 'هولندا'),
(61233, 3262855912, 3262855919, 'DE', 'DEU', 'ألمانيا'),
(61234, 3262855920, 3262855935, 'NL', 'NLD', 'هولندا'),
(61235, 3262855936, 3262857215, 'DE', 'DEU', 'ألمانيا'),
(61236, 3262857216, 3262857367, 'NL', 'NLD', 'هولندا'),
(61237, 3262857368, 3262857375, 'DE', 'DEU', 'ألمانيا'),
(61238, 3262857376, 3262857439, 'NL', 'NLD', 'هولندا'),
(61239, 3262857440, 3262857447, 'DE', 'DEU', 'ألمانيا'),
(61240, 3262857448, 3262857463, 'NL', 'NLD', 'هولندا'),
(61241, 3262857464, 3262857471, 'DE', 'DEU', 'ألمانيا'),
(61242, 3262857472, 3262857703, 'NL', 'NLD', 'هولندا'),
(61243, 3262857704, 3262857711, 'DE', 'DEU', 'ألمانيا'),
(61244, 3262857712, 3262857791, 'NL', 'NLD', 'هولندا'),
(61245, 3262857792, 3262857799, 'DE', 'DEU', 'ألمانيا'),
(61246, 3262857800, 3262857887, 'NL', 'NLD', 'هولندا'),
(61247, 3262857888, 3262857895, 'DE', 'DEU', 'ألمانيا'),
(61248, 3262857896, 3262857919, 'NL', 'NLD', 'هولندا'),
(61249, 3262857920, 3262857935, 'DE', 'DEU', 'ألمانيا'),
(61250, 3262857936, 3262857975, 'NL', 'NLD', 'هولندا'),
(61251, 3262857976, 3262857983, 'DE', 'DEU', 'ألمانيا'),
(61252, 3262857984, 3262858039, 'NL', 'NLD', 'هولندا'),
(61253, 3262858040, 3262858047, 'DE', 'DEU', 'ألمانيا'),
(61254, 3262858048, 3262858063, 'NL', 'NLD', 'هولندا'),
(61255, 3262858064, 3262858071, 'DE', 'DEU', 'ألمانيا'),
(61256, 3262858072, 3262858175, 'NL', 'NLD', 'هولندا'),
(61257, 3262858176, 3262858183, 'DE', 'DEU', 'ألمانيا'),
(61258, 3262858184, 3262858335, 'NL', 'NLD', 'هولندا'),
(61259, 3262858336, 3262858343, 'DE', 'DEU', 'ألمانيا'),
(61260, 3262858344, 3262858431, 'NL', 'NLD', 'هولندا'),
(61261, 3262858432, 3262858439, 'DE', 'DEU', 'ألمانيا'),
(61262, 3262858440, 3262858447, 'NL', 'NLD', 'هولندا'),
(61263, 3262858448, 3262858455, 'DE', 'DEU', 'ألمانيا'),
(61264, 3262858456, 3262858647, 'NL', 'NLD', 'هولندا'),
(61265, 3262858648, 3262858655, 'DE', 'DEU', 'ألمانيا'),
(61266, 3262858656, 3262858751, 'NL', 'NLD', 'هولندا'),
(61267, 3262858752, 3262858759, 'DE', 'DEU', 'ألمانيا'),
(61268, 3262858760, 3262858791, 'NL', 'NLD', 'هولندا'),
(61269, 3262858792, 3262858799, 'DE', 'DEU', 'ألمانيا'),
(61270, 3262858800, 3262858823, 'NL', 'NLD', 'هولندا'),
(61271, 3262858824, 3262858839, 'DE', 'DEU', 'ألمانيا'),
(61272, 3262858840, 3262858847, 'NL', 'NLD', 'هولندا'),
(61273, 3262858848, 3262858863, 'DE', 'DEU', 'ألمانيا'),
(61274, 3262858864, 3262858975, 'NL', 'NLD', 'هولندا'),
(61275, 3262858976, 3262858983, 'DE', 'DEU', 'ألمانيا'),
(61276, 3262858984, 3262859071, 'NL', 'NLD', 'هولندا'),
(61277, 3262859072, 3262859079, 'DE', 'DEU', 'ألمانيا'),
(61278, 3262859080, 3262859263, 'NL', 'NLD', 'هولندا'),
(61279, 3262859264, 3262859271, 'DE', 'DEU', 'ألمانيا'),
(61280, 3262859272, 3262859367, 'NL', 'NLD', 'هولندا'),
(61281, 3262859368, 3262859375, 'DE', 'DEU', 'ألمانيا'),
(61282, 3262859376, 3262859399, 'NL', 'NLD', 'هولندا'),
(61283, 3262859400, 3262859407, 'DE', 'DEU', 'ألمانيا'),
(61284, 3262859408, 3262859431, 'NL', 'NLD', 'هولندا'),
(61285, 3262859432, 3262859439, 'DE', 'DEU', 'ألمانيا'),
(61286, 3262859440, 3262859487, 'NL', 'NLD', 'هولندا'),
(61287, 3262859488, 3262859495, 'DE', 'DEU', 'ألمانيا'),
(61288, 3262859496, 3262859583, 'NL', 'NLD', 'هولندا'),
(61289, 3262859584, 3262859591, 'DE', 'DEU', 'ألمانيا'),
(61290, 3262859592, 3262859663, 'NL', 'NLD', 'هولندا'),
(61291, 3262859664, 3262859679, 'DE', 'DEU', 'ألمانيا'),
(61292, 3262859680, 3262859703, 'NL', 'NLD', 'هولندا'),
(61293, 3262859704, 3262859711, 'DE', 'DEU', 'ألمانيا'),
(61294, 3262859712, 3262859727, 'NL', 'NLD', 'هولندا'),
(61295, 3262859728, 3262859735, 'DE', 'DEU', 'ألمانيا'),
(61296, 3262859736, 3262859743, 'NL', 'NLD', 'هولندا'),
(61297, 3262859744, 3262859751, 'DE', 'DEU', 'ألمانيا'),
(61298, 3262859752, 3262859759, 'NL', 'NLD', 'هولندا'),
(61299, 3262859760, 3262859775, 'DE', 'DEU', 'ألمانيا'),
(61300, 3262859776, 3262859823, 'NL', 'NLD', 'هولندا'),
(61301, 3262859824, 3262859831, 'DE', 'DEU', 'ألمانيا'),
(61302, 3262859832, 3262859863, 'NL', 'NLD', 'هولندا'),
(61303, 3262859864, 3262859871, 'DE', 'DEU', 'ألمانيا'),
(61304, 3262859872, 3262859983, 'NL', 'NLD', 'هولندا'),
(61305, 3262859984, 3262859991, 'DE', 'DEU', 'ألمانيا'),
(61306, 3262859992, 3262860127, 'NL', 'NLD', 'هولندا'),
(61307, 3262860128, 3262860135, 'DE', 'DEU', 'ألمانيا'),
(61308, 3262860136, 3262860175, 'NL', 'NLD', 'هولندا'),
(61309, 3262860176, 3262860183, 'DE', 'DEU', 'ألمانيا'),
(61310, 3262860184, 3262860191, 'NL', 'NLD', 'هولندا'),
(61311, 3262860192, 3262860207, 'DE', 'DEU', 'ألمانيا'),
(61312, 3262860208, 3262860263, 'NL', 'NLD', 'هولندا'),
(61313, 3262860264, 3262860271, 'DE', 'DEU', 'ألمانيا'),
(61314, 3262860272, 3262860319, 'NL', 'NLD', 'هولندا'),
(61315, 3262860320, 3262860327, 'DE', 'DEU', 'ألمانيا'),
(61316, 3262860328, 3262860367, 'NL', 'NLD', 'هولندا'),
(61317, 3262860368, 3262860375, 'DE', 'DEU', 'ألمانيا'),
(61318, 3262860376, 3262860399, 'NL', 'NLD', 'هولندا'),
(61319, 3262860400, 3262860407, 'DE', 'DEU', 'ألمانيا'),
(61320, 3262860408, 3262860431, 'NL', 'NLD', 'هولندا'),
(61321, 3262860432, 3262860439, 'DE', 'DEU', 'ألمانيا'),
(61322, 3262860440, 3262860455, 'NL', 'NLD', 'هولندا'),
(61323, 3262860456, 3262860463, 'DE', 'DEU', 'ألمانيا'),
(61324, 3262860464, 3262860583, 'NL', 'NLD', 'هولندا'),
(61325, 3262860584, 3262860591, 'DE', 'DEU', 'ألمانيا'),
(61326, 3262860592, 3262860647, 'NL', 'NLD', 'هولندا'),
(61327, 3262860648, 3262860663, 'DE', 'DEU', 'ألمانيا'),
(61328, 3262860664, 3262860751, 'NL', 'NLD', 'هولندا'),
(61329, 3262860752, 3262860759, 'DE', 'DEU', 'ألمانيا'),
(61330, 3262860760, 3262860807, 'NL', 'NLD', 'هولندا'),
(61331, 3262860808, 3262860815, 'DE', 'DEU', 'ألمانيا'),
(61332, 3262860816, 3262860863, 'NL', 'NLD', 'هولندا'),
(61333, 3262860864, 3262860871, 'DE', 'DEU', 'ألمانيا'),
(61334, 3262860872, 3262860927, 'NL', 'NLD', 'هولندا'),
(61335, 3262860928, 3262860935, 'DE', 'DEU', 'ألمانيا'),
(61336, 3262860936, 3262861063, 'NL', 'NLD', 'هولندا'),
(61337, 3262861064, 3262861071, 'DE', 'DEU', 'ألمانيا'),
(61338, 3262861072, 3262861095, 'NL', 'NLD', 'هولندا'),
(61339, 3262861096, 3262861103, 'DE', 'DEU', 'ألمانيا'),
(61340, 3262861104, 3262861135, 'NL', 'NLD', 'هولندا'),
(61341, 3262861136, 3262861143, 'DE', 'DEU', 'ألمانيا'),
(61342, 3262861144, 3262861231, 'NL', 'NLD', 'هولندا'),
(61343, 3262861232, 3262861239, 'DE', 'DEU', 'ألمانيا'),
(61344, 3262861240, 3262861279, 'NL', 'NLD', 'هولندا'),
(61345, 3262861280, 3262861287, 'DE', 'DEU', 'ألمانيا'),
(61346, 3262861288, 3262861399, 'NL', 'NLD', 'هولندا'),
(61347, 3262861400, 3262861407, 'DE', 'DEU', 'ألمانيا'),
(61348, 3262861408, 3262861487, 'NL', 'NLD', 'هولندا'),
(61349, 3262861488, 3262861503, 'DE', 'DEU', 'ألمانيا'),
(61350, 3262861504, 3262861543, 'NL', 'NLD', 'هولندا'),
(61351, 3262861544, 3262861551, 'DE', 'DEU', 'ألمانيا'),
(61352, 3262861552, 3262861607, 'NL', 'NLD', 'هولندا'),
(61353, 3262861608, 3262861615, 'DE', 'DEU', 'ألمانيا'),
(61354, 3262861616, 3262861623, 'NL', 'NLD', 'هولندا'),
(61355, 3262861624, 3262861631, 'DE', 'DEU', 'ألمانيا'),
(61356, 3262861632, 3262861735, 'NL', 'NLD', 'هولندا'),
(61357, 3262861736, 3262861743, 'DE', 'DEU', 'ألمانيا'),
(61358, 3262861744, 3262861759, 'NL', 'NLD', 'هولندا'),
(61359, 3262861760, 3262861767, 'DE', 'DEU', 'ألمانيا'),
(61360, 3262861768, 3262861999, 'NL', 'NLD', 'هولندا'),
(61361, 3262862000, 3262862007, 'DE', 'DEU', 'ألمانيا'),
(61362, 3262862008, 3262862015, 'NL', 'NLD', 'هولندا'),
(61363, 3262862016, 3262862023, 'DE', 'DEU', 'ألمانيا'),
(61364, 3262862024, 3262862103, 'NL', 'NLD', 'هولندا'),
(61365, 3262862104, 3262862111, 'DE', 'DEU', 'ألمانيا'),
(61366, 3262862112, 3262862191, 'NL', 'NLD', 'هولندا'),
(61367, 3262862192, 3262862207, 'DE', 'DEU', 'ألمانيا'),
(61368, 3262862208, 3262862247, 'NL', 'NLD', 'هولندا'),
(61369, 3262862248, 3262862255, 'DE', 'DEU', 'ألمانيا'),
(61370, 3262862256, 3262862615, 'NL', 'NLD', 'هولندا'),
(61371, 3262862616, 3262862623, 'DE', 'DEU', 'ألمانيا'),
(61372, 3262862624, 3262862767, 'NL', 'NLD', 'هولندا'),
(61373, 3262862768, 3262862775, 'DE', 'DEU', 'ألمانيا'),
(61374, 3262862776, 3262862823, 'NL', 'NLD', 'هولندا'),
(61375, 3262862824, 3262862831, 'DE', 'DEU', 'ألمانيا'),
(61376, 3262862832, 3262862855, 'NL', 'NLD', 'هولندا'),
(61377, 3262862856, 3262862863, 'DE', 'DEU', 'ألمانيا'),
(61378, 3262862864, 3262862927, 'NL', 'NLD', 'هولندا'),
(61379, 3262862928, 3262862935, 'DE', 'DEU', 'ألمانيا'),
(61380, 3262862936, 3262862967, 'NL', 'NLD', 'هولندا'),
(61381, 3262862968, 3262862975, 'DE', 'DEU', 'ألمانيا'),
(61382, 3262862976, 3262863079, 'NL', 'NLD', 'هولندا'),
(61383, 3262863080, 3262863087, 'DE', 'DEU', 'ألمانيا'),
(61384, 3262863088, 3262863143, 'NL', 'NLD', 'هولندا'),
(61385, 3262863144, 3262863151, 'DE', 'DEU', 'ألمانيا'),
(61386, 3262863152, 3262863191, 'NL', 'NLD', 'هولندا'),
(61387, 3262863192, 3262863199, 'DE', 'DEU', 'ألمانيا'),
(61388, 3262863200, 3262863271, 'NL', 'NLD', 'هولندا'),
(61389, 3262863272, 3262863279, 'DE', 'DEU', 'ألمانيا'),
(61390, 3262863280, 3262863383, 'NL', 'NLD', 'هولندا'),
(61391, 3262863384, 3262863391, 'DE', 'DEU', 'ألمانيا'),
(61392, 3262863392, 3262863463, 'NL', 'NLD', 'هولندا'),
(61393, 3262863464, 3262863479, 'DE', 'DEU', 'ألمانيا'),
(61394, 3262863480, 3262863527, 'NL', 'NLD', 'هولندا'),
(61395, 3262863528, 3262863535, 'DE', 'DEU', 'ألمانيا'),
(61396, 3262863536, 3262863631, 'NL', 'NLD', 'هولندا'),
(61397, 3262863632, 3262863639, 'DE', 'DEU', 'ألمانيا'),
(61398, 3262863640, 3262863751, 'NL', 'NLD', 'هولندا'),
(61399, 3262863752, 3262863775, 'DE', 'DEU', 'ألمانيا'),
(61400, 3262863776, 3262863807, 'NL', 'NLD', 'هولندا'),
(61401, 3262863808, 3262863815, 'DE', 'DEU', 'ألمانيا'),
(61402, 3262863816, 3262863871, 'NL', 'NLD', 'هولندا'),
(61403, 3262863872, 3262863879, 'DE', 'DEU', 'ألمانيا'),
(61404, 3262863880, 3262864063, 'NL', 'NLD', 'هولندا'),
(61405, 3262864064, 3262864071, 'DE', 'DEU', 'ألمانيا'),
(61406, 3262864072, 3262864239, 'NL', 'NLD', 'هولندا'),
(61407, 3262864240, 3262864247, 'DE', 'DEU', 'ألمانيا'),
(61408, 3262864248, 3262864279, 'NL', 'NLD', 'هولندا'),
(61409, 3262864280, 3262864287, 'DE', 'DEU', 'ألمانيا'),
(61410, 3262864288, 3262864423, 'NL', 'NLD', 'هولندا'),
(61411, 3262864424, 3262864431, 'DE', 'DEU', 'ألمانيا'),
(61412, 3262864432, 3262864439, 'NL', 'NLD', 'هولندا'),
(61413, 3262864440, 3262864447, 'DE', 'DEU', 'ألمانيا'),
(61414, 3262864448, 3262864495, 'NL', 'NLD', 'هولندا'),
(61415, 3262864496, 3262864503, 'DE', 'DEU', 'ألمانيا'),
(61416, 3262864504, 3262864519, 'NL', 'NLD', 'هولندا'),
(61417, 3262864520, 3262864527, 'DE', 'DEU', 'ألمانيا'),
(61418, 3262864528, 3262864583, 'NL', 'NLD', 'هولندا'),
(61419, 3262864584, 3262864591, 'DE', 'DEU', 'ألمانيا'),
(61420, 3262864592, 3262864743, 'NL', 'NLD', 'هولندا'),
(61421, 3262864744, 3262864751, 'DE', 'DEU', 'ألمانيا'),
(61422, 3262864752, 3262864759, 'NL', 'NLD', 'هولندا'),
(61423, 3262864760, 3262864767, 'DE', 'DEU', 'ألمانيا'),
(61424, 3262864768, 3262864863, 'NL', 'NLD', 'هولندا'),
(61425, 3262864864, 3262864871, 'DE', 'DEU', 'ألمانيا'),
(61426, 3262864872, 3262864943, 'NL', 'NLD', 'هولندا'),
(61427, 3262864944, 3262864951, 'DE', 'DEU', 'ألمانيا'),
(61428, 3262864952, 3262865223, 'NL', 'NLD', 'هولندا'),
(61429, 3262865224, 3262865231, 'DE', 'DEU', 'ألمانيا'),
(61430, 3262865232, 3262865303, 'NL', 'NLD', 'هولندا'),
(61431, 3262865304, 3262865311, 'DE', 'DEU', 'ألمانيا'),
(61432, 3262865312, 3262865479, 'NL', 'NLD', 'هولندا'),
(61433, 3262865480, 3262865487, 'DE', 'DEU', 'ألمانيا'),
(61434, 3262865488, 3262865511, 'NL', 'NLD', 'هولندا'),
(61435, 3262865512, 3262865519, 'DE', 'DEU', 'ألمانيا'),
(61436, 3262865520, 3262865527, 'NL', 'NLD', 'هولندا'),
(61437, 3262865528, 3262865535, 'DE', 'DEU', 'ألمانيا'),
(61438, 3262865536, 3262865543, 'NL', 'NLD', 'هولندا'),
(61439, 3262865544, 3262865551, 'DE', 'DEU', 'ألمانيا'),
(61440, 3262865552, 3262865575, 'NL', 'NLD', 'هولندا'),
(61441, 3262865576, 3262865583, 'DE', 'DEU', 'ألمانيا'),
(61442, 3262865584, 3262865615, 'NL', 'NLD', 'هولندا'),
(61443, 3262865616, 3262865623, 'DE', 'DEU', 'ألمانيا'),
(61444, 3262865624, 3262865631, 'NL', 'NLD', 'هولندا'),
(61445, 3262865632, 3262865639, 'DE', 'DEU', 'ألمانيا'),
(61446, 3262865640, 3262865655, 'NL', 'NLD', 'هولندا'),
(61447, 3262865656, 3262865663, 'DE', 'DEU', 'ألمانيا'),
(61448, 3262865664, 3262865783, 'NL', 'NLD', 'هولندا'),
(61449, 3262865784, 3262865791, 'DE', 'DEU', 'ألمانيا'),
(61450, 3262865792, 3262865823, 'NL', 'NLD', 'هولندا'),
(61451, 3262865824, 3262865831, 'DE', 'DEU', 'ألمانيا'),
(61452, 3262865832, 3262865975, 'NL', 'NLD', 'هولندا'),
(61453, 3262865976, 3262865983, 'DE', 'DEU', 'ألمانيا'),
(61454, 3262865984, 3262866151, 'NL', 'NLD', 'هولندا'),
(61455, 3262866152, 3262866159, 'DE', 'DEU', 'ألمانيا'),
(61456, 3262866160, 3262866183, 'NL', 'NLD', 'هولندا'),
(61457, 3262866184, 3262866199, 'DE', 'DEU', 'ألمانيا'),
(61458, 3262866200, 3262866271, 'NL', 'NLD', 'هولندا'),
(61459, 3262866272, 3262866279, 'DE', 'DEU', 'ألمانيا'),
(61460, 3262866280, 3262866295, 'NL', 'NLD', 'هولندا'),
(61461, 3262866296, 3262866303, 'DE', 'DEU', 'ألمانيا'),
(61462, 3262866304, 3262866375, 'NL', 'NLD', 'هولندا'),
(61463, 3262866376, 3262866383, 'DE', 'DEU', 'ألمانيا'),
(61464, 3262866384, 3262866447, 'NL', 'NLD', 'هولندا'),
(61465, 3262866448, 3262866471, 'DE', 'DEU', 'ألمانيا'),
(61466, 3262866472, 3262866495, 'NL', 'NLD', 'هولندا'),
(61467, 3262866496, 3262866503, 'DE', 'DEU', 'ألمانيا'),
(61468, 3262866504, 3262866543, 'NL', 'NLD', 'هولندا'),
(61469, 3262866544, 3262866551, 'DE', 'DEU', 'ألمانيا'),
(61470, 3262866552, 3262866599, 'NL', 'NLD', 'هولندا'),
(61471, 3262866600, 3262866607, 'DE', 'DEU', 'ألمانيا'),
(61472, 3262866608, 3262866655, 'NL', 'NLD', 'هولندا'),
(61473, 3262866656, 3262866671, 'DE', 'DEU', 'ألمانيا'),
(61474, 3262866672, 3262866823, 'NL', 'NLD', 'هولندا'),
(61475, 3262866824, 3262866831, 'DE', 'DEU', 'ألمانيا'),
(61476, 3262866832, 3262866935, 'NL', 'NLD', 'هولندا'),
(61477, 3262866936, 3262866943, 'DE', 'DEU', 'ألمانيا'),
(61478, 3262866944, 3262867191, 'NL', 'NLD', 'هولندا'),
(61479, 3262867192, 3262867199, 'DE', 'DEU', 'ألمانيا'),
(61480, 3262867200, 3262867271, 'NL', 'NLD', 'هولندا'),
(61481, 3262867272, 3262867279, 'DE', 'DEU', 'ألمانيا'),
(61482, 3262867280, 3262867383, 'NL', 'NLD', 'هولندا'),
(61483, 3262867384, 3262867391, 'DE', 'DEU', 'ألمانيا'),
(61484, 3262867392, 3262867407, 'NL', 'NLD', 'هولندا'),
(61485, 3262867408, 3262867415, 'DE', 'DEU', 'ألمانيا'),
(61486, 3262867416, 3262867479, 'NL', 'NLD', 'هولندا'),
(61487, 3262867480, 3262867487, 'DE', 'DEU', 'ألمانيا'),
(61488, 3262867488, 3262867703, 'NL', 'NLD', 'هولندا'),
(61489, 3262867704, 3262867711, 'DE', 'DEU', 'ألمانيا'),
(61490, 3262867712, 3262867815, 'NL', 'NLD', 'هولندا'),
(61491, 3262867816, 3262867823, 'DE', 'DEU', 'ألمانيا'),
(61492, 3262867824, 3262867863, 'NL', 'NLD', 'هولندا'),
(61493, 3262867864, 3262867871, 'DE', 'DEU', 'ألمانيا'),
(61494, 3262867872, 3262867895, 'NL', 'NLD', 'هولندا'),
(61495, 3262867896, 3262867903, 'DE', 'DEU', 'ألمانيا'),
(61496, 3262867904, 3262868063, 'NL', 'NLD', 'هولندا'),
(61497, 3262868064, 3262868071, 'DE', 'DEU', 'ألمانيا'),
(61498, 3262868072, 3262868095, 'NL', 'NLD', 'هولندا'),
(61499, 3262868096, 3262868111, 'DE', 'DEU', 'ألمانيا'),
(61500, 3262868112, 3262868119, 'NL', 'NLD', 'هولندا'),
(61501, 3262868120, 3262868127, 'DE', 'DEU', 'ألمانيا'),
(61502, 3262868128, 3262868327, 'NL', 'NLD', 'هولندا'),
(61503, 3262868328, 3262868335, 'DE', 'DEU', 'ألمانيا'),
(61504, 3262868336, 3262868343, 'NL', 'NLD', 'هولندا'),
(61505, 3262868344, 3262868359, 'DE', 'DEU', 'ألمانيا'),
(61506, 3262868360, 3262868383, 'NL', 'NLD', 'هولندا'),
(61507, 3262868384, 3262868399, 'DE', 'DEU', 'ألمانيا'),
(61508, 3262868400, 3262868407, 'NL', 'NLD', 'هولندا'),
(61509, 3262868408, 3262868415, 'DE', 'DEU', 'ألمانيا'),
(61510, 3262868416, 3262868423, 'NL', 'NLD', 'هولندا'),
(61511, 3262868424, 3262868431, 'DE', 'DEU', 'ألمانيا'),
(61512, 3262868432, 3262868487, 'NL', 'NLD', 'هولندا'),
(61513, 3262868488, 3262868495, 'DE', 'DEU', 'ألمانيا'),
(61514, 3262868496, 3262868559, 'NL', 'NLD', 'هولندا'),
(61515, 3262868560, 3262868567, 'DE', 'DEU', 'ألمانيا'),
(61516, 3262868568, 3262868607, 'NL', 'NLD', 'هولندا'),
(61517, 3262868608, 3262868615, 'DE', 'DEU', 'ألمانيا'),
(61518, 3262868616, 3262868695, 'NL', 'NLD', 'هولندا'),
(61519, 3262868696, 3262868703, 'DE', 'DEU', 'ألمانيا'),
(61520, 3262868704, 3262868743, 'NL', 'NLD', 'هولندا'),
(61521, 3262868744, 3262868751, 'DE', 'DEU', 'ألمانيا'),
(61522, 3262868752, 3262868903, 'NL', 'NLD', 'هولندا'),
(61523, 3262868904, 3262868911, 'DE', 'DEU', 'ألمانيا'),
(61524, 3262868912, 3262868927, 'NL', 'NLD', 'هولندا'),
(61525, 3262868928, 3262868935, 'DE', 'DEU', 'ألمانيا'),
(61526, 3262868936, 3262868943, 'NL', 'NLD', 'هولندا'),
(61527, 3262868944, 3262868951, 'DE', 'DEU', 'ألمانيا'),
(61528, 3262868952, 3262869023, 'NL', 'NLD', 'هولندا'),
(61529, 3262869024, 3262869031, 'DE', 'DEU', 'ألمانيا'),
(61530, 3262869032, 3262869047, 'NL', 'NLD', 'هولندا'),
(61531, 3262869048, 3262869055, 'DE', 'DEU', 'ألمانيا'),
(61532, 3262869056, 3262869143, 'NL', 'NLD', 'هولندا'),
(61533, 3262869144, 3262869151, 'DE', 'DEU', 'ألمانيا'),
(61534, 3262869152, 3262869199, 'NL', 'NLD', 'هولندا'),
(61535, 3262869200, 3262869207, 'DE', 'DEU', 'ألمانيا'),
(61536, 3262869208, 3262869367, 'NL', 'NLD', 'هولندا'),
(61537, 3262869368, 3262869375, 'DE', 'DEU', 'ألمانيا'),
(61538, 3262869376, 3262869439, 'NL', 'NLD', 'هولندا'),
(61539, 3262869440, 3262869447, 'DE', 'DEU', 'ألمانيا'),
(61540, 3262869448, 3262869575, 'NL', 'NLD', 'هولندا'),
(61541, 3262869576, 3262869583, 'DE', 'DEU', 'ألمانيا'),
(61542, 3262869584, 3262869599, 'NL', 'NLD', 'هولندا'),
(61543, 3262869600, 3262869607, 'DE', 'DEU', 'ألمانيا'),
(61544, 3262869608, 3262869639, 'NL', 'NLD', 'هولندا'),
(61545, 3262869640, 3262869647, 'DE', 'DEU', 'ألمانيا'),
(61546, 3262869648, 3262869663, 'NL', 'NLD', 'هولندا'),
(61547, 3262869664, 3262869671, 'DE', 'DEU', 'ألمانيا'),
(61548, 3262869672, 3262869687, 'NL', 'NLD', 'هولندا'),
(61549, 3262869688, 3262869695, 'DE', 'DEU', 'ألمانيا'),
(61550, 3262869696, 3262869751, 'NL', 'NLD', 'هولندا'),
(61551, 3262869752, 3262869759, 'DE', 'DEU', 'ألمانيا'),
(61552, 3262869760, 3262869831, 'NL', 'NLD', 'هولندا'),
(61553, 3262869832, 3262869839, 'DE', 'DEU', 'ألمانيا'),
(61554, 3262869840, 3262870063, 'NL', 'NLD', 'هولندا'),
(61555, 3262870064, 3262870071, 'DE', 'DEU', 'ألمانيا'),
(61556, 3262870072, 3262870095, 'NL', 'NLD', 'هولندا'),
(61557, 3262870096, 3262870103, 'DE', 'DEU', 'ألمانيا'),
(61558, 3262870104, 3262870119, 'NL', 'NLD', 'هولندا'),
(61559, 3262870120, 3262870127, 'DE', 'DEU', 'ألمانيا'),
(61560, 3262870128, 3262870287, 'NL', 'NLD', 'هولندا'),
(61561, 3262870288, 3262870295, 'DE', 'DEU', 'ألمانيا'),
(61562, 3262870296, 3262870343, 'NL', 'NLD', 'هولندا'),
(61563, 3262870344, 3262870351, 'DE', 'DEU', 'ألمانيا'),
(61564, 3262870352, 3262870479, 'NL', 'NLD', 'هولندا'),
(61565, 3262870480, 3262870487, 'DE', 'DEU', 'ألمانيا'),
(61566, 3262870488, 3262870527, 'NL', 'NLD', 'هولندا'),
(61567, 3262870528, 3262870535, 'DE', 'DEU', 'ألمانيا'),
(61568, 3262870536, 3262870567, 'NL', 'NLD', 'هولندا'),
(61569, 3262870568, 3262870575, 'DE', 'DEU', 'ألمانيا'),
(61570, 3262870576, 3262870751, 'NL', 'NLD', 'هولندا'),
(61571, 3262870752, 3262870759, 'DE', 'DEU', 'ألمانيا'),
(61572, 3262870760, 3262870863, 'NL', 'NLD', 'هولندا'),
(61573, 3262870864, 3262870879, 'DE', 'DEU', 'ألمانيا'),
(61574, 3262870880, 3262870999, 'NL', 'NLD', 'هولندا'),
(61575, 3262871000, 3262871007, 'DE', 'DEU', 'ألمانيا'),
(61576, 3262871008, 3262871119, 'NL', 'NLD', 'هولندا'),
(61577, 3262871120, 3262871127, 'DE', 'DEU', 'ألمانيا'),
(61578, 3262871128, 3262871223, 'NL', 'NLD', 'هولندا'),
(61579, 3262871224, 3262871231, 'DE', 'DEU', 'ألمانيا'),
(61580, 3262871232, 3262871255, 'NL', 'NLD', 'هولندا'),
(61581, 3262871256, 3262871263, 'DE', 'DEU', 'ألمانيا'),
(61582, 3262871264, 3262871335, 'NL', 'NLD', 'هولندا'),
(61583, 3262871336, 3262871343, 'DE', 'DEU', 'ألمانيا'),
(61584, 3262871344, 3262871359, 'NL', 'NLD', 'هولندا'),
(61585, 3262871360, 3262871367, 'DE', 'DEU', 'ألمانيا'),
(61586, 3262871368, 3262871551, 'NL', 'NLD', 'هولندا'),
(61587, 3262871552, 3262872319, 'DE', 'DEU', 'ألمانيا'),
(61588, 3262872320, 3262872399, 'NL', 'NLD', 'هولندا'),
(61589, 3262872400, 3262872407, 'DE', 'DEU', 'ألمانيا'),
(61590, 3262872408, 3262872423, 'NL', 'NLD', 'هولندا'),
(61591, 3262872424, 3262872431, 'DE', 'DEU', 'ألمانيا'),
(61592, 3262872432, 3262872503, 'NL', 'NLD', 'هولندا'),
(61593, 3262872504, 3262872511, 'DE', 'DEU', 'ألمانيا'),
(61594, 3262872512, 3262872519, 'NL', 'NLD', 'هولندا'),
(61595, 3262872520, 3262872527, 'DE', 'DEU', 'ألمانيا'),
(61596, 3262872528, 3262872663, 'NL', 'NLD', 'هولندا'),
(61597, 3262872664, 3262872671, 'DE', 'DEU', 'ألمانيا'),
(61598, 3262872672, 3262872751, 'NL', 'NLD', 'هولندا'),
(61599, 3262872752, 3262872759, 'DE', 'DEU', 'ألمانيا'),
(61600, 3262872760, 3262872903, 'NL', 'NLD', 'هولندا'),
(61601, 3262872904, 3262872911, 'DE', 'DEU', 'ألمانيا'),
(61602, 3262872912, 3262872951, 'NL', 'NLD', 'هولندا'),
(61603, 3262872952, 3262872959, 'DE', 'DEU', 'ألمانيا'),
(61604, 3262872960, 3262872975, 'NL', 'NLD', 'هولندا'),
(61605, 3262872976, 3262872983, 'DE', 'DEU', 'ألمانيا'),
(61606, 3262872984, 3262873023, 'NL', 'NLD', 'هولندا'),
(61607, 3262873024, 3262873031, 'DE', 'DEU', 'ألمانيا'),
(61608, 3262873032, 3262873287, 'NL', 'NLD', 'هولندا'),
(61609, 3262873288, 3262873295, 'DE', 'DEU', 'ألمانيا'),
(61610, 3262873296, 3262873303, 'NL', 'NLD', 'هولندا'),
(61611, 3262873304, 3262873311, 'DE', 'DEU', 'ألمانيا'),
(61612, 3262873312, 3262873351, 'NL', 'NLD', 'هولندا'),
(61613, 3262873352, 3262873359, 'DE', 'DEU', 'ألمانيا'),
(61614, 3262873360, 3262873407, 'NL', 'NLD', 'هولندا'),
(61615, 3262873408, 3262873423, 'DE', 'DEU', 'ألمانيا'),
(61616, 3262873424, 3262873703, 'NL', 'NLD', 'هولندا'),
(61617, 3262873704, 3262873711, 'DE', 'DEU', 'ألمانيا'),
(61618, 3262873712, 3262873759, 'NL', 'NLD', 'هولندا'),
(61619, 3262873760, 3262873775, 'DE', 'DEU', 'ألمانيا'),
(61620, 3262873776, 3262873823, 'NL', 'NLD', 'هولندا'),
(61621, 3262873824, 3262873831, 'DE', 'DEU', 'ألمانيا'),
(61622, 3262873832, 3262873871, 'NL', 'NLD', 'هولندا'),
(61623, 3262873872, 3262873879, 'DE', 'DEU', 'ألمانيا'),
(61624, 3262873880, 3262874087, 'NL', 'NLD', 'هولندا'),
(61625, 3262874088, 3262874095, 'DE', 'DEU', 'ألمانيا'),
(61626, 3262874096, 3262874103, 'NL', 'NLD', 'هولندا'),
(61627, 3262874104, 3262874111, 'DE', 'DEU', 'ألمانيا'),
(61628, 3262874112, 3262874399, 'NL', 'NLD', 'هولندا'),
(61629, 3262874400, 3262874407, 'DE', 'DEU', 'ألمانيا'),
(61630, 3262874408, 3262874575, 'NL', 'NLD', 'هولندا'),
(61631, 3262874576, 3262874583, 'DE', 'DEU', 'ألمانيا'),
(61632, 3262874584, 3262874591, 'NL', 'NLD', 'هولندا'),
(61633, 3262874592, 3262874599, 'DE', 'DEU', 'ألمانيا'),
(61634, 3262874600, 3262874639, 'NL', 'NLD', 'هولندا'),
(61635, 3262874640, 3262874647, 'DE', 'DEU', 'ألمانيا'),
(61636, 3262874648, 3262874719, 'NL', 'NLD', 'هولندا'),
(61637, 3262874720, 3262874727, 'DE', 'DEU', 'ألمانيا'),
(61638, 3262874728, 3262874783, 'NL', 'NLD', 'هولندا'),
(61639, 3262874784, 3262874791, 'DE', 'DEU', 'ألمانيا'),
(61640, 3262874792, 3262874871, 'NL', 'NLD', 'هولندا'),
(61641, 3262874872, 3262874879, 'DE', 'DEU', 'ألمانيا'),
(61642, 3262874880, 3262874903, 'NL', 'NLD', 'هولندا'),
(61643, 3262874904, 3262874911, 'DE', 'DEU', 'ألمانيا'),
(61644, 3262874912, 3262874999, 'NL', 'NLD', 'هولندا'),
(61645, 3262875000, 3262875015, 'DE', 'DEU', 'ألمانيا'),
(61646, 3262875016, 3262875031, 'NL', 'NLD', 'هولندا'),
(61647, 3262875032, 3262875039, 'DE', 'DEU', 'ألمانيا'),
(61648, 3262875040, 3262875079, 'NL', 'NLD', 'هولندا'),
(61649, 3262875080, 3262875087, 'DE', 'DEU', 'ألمانيا'),
(61650, 3262875088, 3262875199, 'NL', 'NLD', 'هولندا'),
(61651, 3262875200, 3262875207, 'DE', 'DEU', 'ألمانيا'),
(61652, 3262875208, 3262875335, 'NL', 'NLD', 'هولندا'),
(61653, 3262875336, 3262875343, 'DE', 'DEU', 'ألمانيا'),
(61654, 3262875344, 3262875415, 'NL', 'NLD', 'هولندا'),
(61655, 3262875416, 3262875423, 'DE', 'DEU', 'ألمانيا'),
(61656, 3262875424, 3262875431, 'NL', 'NLD', 'هولندا'),
(61657, 3262875432, 3262875439, 'DE', 'DEU', 'ألمانيا'),
(61658, 3262875440, 3262875511, 'NL', 'NLD', 'هولندا'),
(61659, 3262875512, 3262875519, 'DE', 'DEU', 'ألمانيا'),
(61660, 3262875520, 3262875623, 'NL', 'NLD', 'هولندا'),
(61661, 3262875624, 3262875631, 'DE', 'DEU', 'ألمانيا'),
(61662, 3262875632, 3262875791, 'NL', 'NLD', 'هولندا'),
(61663, 3262875792, 3262875807, 'DE', 'DEU', 'ألمانيا'),
(61664, 3262875808, 3262875967, 'NL', 'NLD', 'هولندا'),
(61665, 3262875968, 3262875975, 'DE', 'DEU', 'ألمانيا'),
(61666, 3262875976, 3262876079, 'NL', 'NLD', 'هولندا'),
(61667, 3262876080, 3262876087, 'DE', 'DEU', 'ألمانيا'),
(61668, 3262876088, 3262876095, 'NL', 'NLD', 'هولندا'),
(61669, 3262876096, 3262876103, 'DE', 'DEU', 'ألمانيا'),
(61670, 3262876104, 3262876271, 'NL', 'NLD', 'هولندا'),
(61671, 3262876272, 3262876279, 'DE', 'DEU', 'ألمانيا'),
(61672, 3262876280, 3262876375, 'NL', 'NLD', 'هولندا'),
(61673, 3262876376, 3262876383, 'DE', 'DEU', 'ألمانيا'),
(61674, 3262876384, 3262876423, 'NL', 'NLD', 'هولندا'),
(61675, 3262876424, 3262876431, 'DE', 'DEU', 'ألمانيا'),
(61676, 3262876432, 3262876655, 'NL', 'NLD', 'هولندا'),
(61677, 3262876656, 3262876663, 'DE', 'DEU', 'ألمانيا'),
(61678, 3262876664, 3262876807, 'NL', 'NLD', 'هولندا'),
(61679, 3262876808, 3262876815, 'DE', 'DEU', 'ألمانيا'),
(61680, 3262876816, 3262876847, 'NL', 'NLD', 'هولندا'),
(61681, 3262876848, 3262876855, 'DE', 'DEU', 'ألمانيا'),
(61682, 3262876856, 3262876911, 'NL', 'NLD', 'هولندا'),
(61683, 3262876912, 3262876919, 'DE', 'DEU', 'ألمانيا'),
(61684, 3262876920, 3262876927, 'NL', 'NLD', 'هولندا'),
(61685, 3262876928, 3262877951, 'DE', 'DEU', 'ألمانيا'),
(61686, 3262877952, 3262878015, 'NL', 'NLD', 'هولندا'),
(61687, 3262878016, 3262878023, 'DE', 'DEU', 'ألمانيا'),
(61688, 3262878024, 3262878087, 'NL', 'NLD', 'هولندا'),
(61689, 3262878088, 3262878095, 'DE', 'DEU', 'ألمانيا'),
(61690, 3262878096, 3262878255, 'NL', 'NLD', 'هولندا'),
(61691, 3262878256, 3262878263, 'DE', 'DEU', 'ألمانيا'),
(61692, 3262878264, 3262878271, 'NL', 'NLD', 'هولندا'),
(61693, 3262878272, 3262878279, 'DE', 'DEU', 'ألمانيا'),
(61694, 3262878280, 3262878295, 'NL', 'NLD', 'هولندا'),
(61695, 3262878296, 3262878303, 'DE', 'DEU', 'ألمانيا'),
(61696, 3262878304, 3262878375, 'NL', 'NLD', 'هولندا'),
(61697, 3262878376, 3262878383, 'DE', 'DEU', 'ألمانيا'),
(61698, 3262878384, 3262878415, 'NL', 'NLD', 'هولندا'),
(61699, 3262878416, 3262878423, 'DE', 'DEU', 'ألمانيا'),
(61700, 3262878424, 3262878455, 'NL', 'NLD', 'هولندا'),
(61701, 3262878456, 3262878463, 'DE', 'DEU', 'ألمانيا'),
(61702, 3262878464, 3262878767, 'NL', 'NLD', 'هولندا'),
(61703, 3262878768, 3262878775, 'DE', 'DEU', 'ألمانيا'),
(61704, 3262878776, 3262879143, 'NL', 'NLD', 'هولندا'),
(61705, 3262879144, 3262879151, 'DE', 'DEU', 'ألمانيا'),
(61706, 3262879152, 3262879167, 'NL', 'NLD', 'هولندا'),
(61707, 3262879168, 3262879175, 'DE', 'DEU', 'ألمانيا'),
(61708, 3262879176, 3262879231, 'NL', 'NLD', 'هولندا'),
(61709, 3262879232, 3262879239, 'DE', 'DEU', 'ألمانيا'),
(61710, 3262879240, 3262879271, 'NL', 'NLD', 'هولندا'),
(61711, 3262879272, 3262879279, 'DE', 'DEU', 'ألمانيا'),
(61712, 3262879280, 3262879535, 'NL', 'NLD', 'هولندا'),
(61713, 3262879536, 3262879543, 'DE', 'DEU', 'ألمانيا'),
(61714, 3262879544, 3262879567, 'NL', 'NLD', 'هولندا'),
(61715, 3262879568, 3262879575, 'DE', 'DEU', 'ألمانيا'),
(61716, 3262879576, 3262879631, 'NL', 'NLD', 'هولندا'),
(61717, 3262879632, 3262879639, 'DE', 'DEU', 'ألمانيا'),
(61718, 3262879640, 3262879807, 'NL', 'NLD', 'هولندا'),
(61719, 3262879808, 3262879815, 'DE', 'DEU', 'ألمانيا'),
(61720, 3262879816, 3262879855, 'NL', 'NLD', 'هولندا'),
(61721, 3262879856, 3262879863, 'DE', 'DEU', 'ألمانيا'),
(61722, 3262879864, 3262879927, 'NL', 'NLD', 'هولندا'),
(61723, 3262879928, 3262879935, 'DE', 'DEU', 'ألمانيا'),
(61724, 3262879936, 3262879967, 'NL', 'NLD', 'هولندا'),
(61725, 3262879968, 3262879983, 'DE', 'DEU', 'ألمانيا'),
(61726, 3262879984, 3262880055, 'NL', 'NLD', 'هولندا'),
(61727, 3262880056, 3262880063, 'DE', 'DEU', 'ألمانيا'),
(61728, 3262880064, 3262880239, 'NL', 'NLD', 'هولندا'),
(61729, 3262880240, 3262880247, 'DE', 'DEU', 'ألمانيا'),
(61730, 3262880248, 3262880255, 'NL', 'NLD', 'هولندا'),
(61731, 3262880256, 3262880263, 'DE', 'DEU', 'ألمانيا'),
(61732, 3262880264, 3262880399, 'NL', 'NLD', 'هولندا'),
(61733, 3262880400, 3262880407, 'DE', 'DEU', 'ألمانيا'),
(61734, 3262880408, 3262880431, 'NL', 'NLD', 'هولندا'),
(61735, 3262880432, 3262880439, 'DE', 'DEU', 'ألمانيا'),
(61736, 3262880440, 3262880655, 'NL', 'NLD', 'هولندا'),
(61737, 3262880656, 3262880663, 'DE', 'DEU', 'ألمانيا'),
(61738, 3262880664, 3262880679, 'NL', 'NLD', 'هولندا'),
(61739, 3262880680, 3262880687, 'DE', 'DEU', 'ألمانيا'),
(61740, 3262880688, 3262880743, 'NL', 'NLD', 'هولندا'),
(61741, 3262880744, 3262880751, 'DE', 'DEU', 'ألمانيا'),
(61742, 3262880752, 3262880759, 'NL', 'NLD', 'هولندا'),
(61743, 3262880760, 3262880767, 'DE', 'DEU', 'ألمانيا'),
(61744, 3262880768, 3262880815, 'NL', 'NLD', 'هولندا'),
(61745, 3262880816, 3262880823, 'DE', 'DEU', 'ألمانيا'),
(61746, 3262880824, 3262880863, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(61747, 3262880864, 3262880871, 'DE', 'DEU', 'ألمانيا'),
(61748, 3262880872, 3262880895, 'NL', 'NLD', 'هولندا'),
(61749, 3262880896, 3262880903, 'DE', 'DEU', 'ألمانيا'),
(61750, 3262880904, 3262880911, 'NL', 'NLD', 'هولندا'),
(61751, 3262880912, 3262880919, 'DE', 'DEU', 'ألمانيا'),
(61752, 3262880920, 3262880967, 'NL', 'NLD', 'هولندا'),
(61753, 3262880968, 3262880975, 'DE', 'DEU', 'ألمانيا'),
(61754, 3262880976, 3262881103, 'NL', 'NLD', 'هولندا'),
(61755, 3262881104, 3262881111, 'DE', 'DEU', 'ألمانيا'),
(61756, 3262881112, 3262881127, 'NL', 'NLD', 'هولندا'),
(61757, 3262881128, 3262881143, 'DE', 'DEU', 'ألمانيا'),
(61758, 3262881144, 3262881423, 'NL', 'NLD', 'هولندا'),
(61759, 3262881424, 3262881431, 'DE', 'DEU', 'ألمانيا'),
(61760, 3262881432, 3262881527, 'NL', 'NLD', 'هولندا'),
(61761, 3262881528, 3262881535, 'DE', 'DEU', 'ألمانيا'),
(61762, 3262881536, 3262881567, 'NL', 'NLD', 'هولندا'),
(61763, 3262881568, 3262881575, 'DE', 'DEU', 'ألمانيا'),
(61764, 3262881576, 3262881599, 'NL', 'NLD', 'هولندا'),
(61765, 3262881600, 3262881607, 'DE', 'DEU', 'ألمانيا'),
(61766, 3262881608, 3262881839, 'NL', 'NLD', 'هولندا'),
(61767, 3262881840, 3262881847, 'DE', 'DEU', 'ألمانيا'),
(61768, 3262881848, 3262881855, 'NL', 'NLD', 'هولندا'),
(61769, 3262881856, 3262881871, 'DE', 'DEU', 'ألمانيا'),
(61770, 3262881872, 3262881927, 'NL', 'NLD', 'هولندا'),
(61771, 3262881928, 3262881935, 'DE', 'DEU', 'ألمانيا'),
(61772, 3262881936, 3262881975, 'NL', 'NLD', 'هولندا'),
(61773, 3262881976, 3262881983, 'DE', 'DEU', 'ألمانيا'),
(61774, 3262881984, 3262881999, 'NL', 'NLD', 'هولندا'),
(61775, 3262882000, 3262882015, 'DE', 'DEU', 'ألمانيا'),
(61776, 3262882016, 3262882039, 'NL', 'NLD', 'هولندا'),
(61777, 3262882040, 3262882047, 'DE', 'DEU', 'ألمانيا'),
(61778, 3262882048, 3262882119, 'NL', 'NLD', 'هولندا'),
(61779, 3262882120, 3262882127, 'DE', 'DEU', 'ألمانيا'),
(61780, 3262882128, 3262882215, 'NL', 'NLD', 'هولندا'),
(61781, 3262882216, 3262882223, 'DE', 'DEU', 'ألمانيا'),
(61782, 3262882224, 3262882527, 'NL', 'NLD', 'هولندا'),
(61783, 3262882528, 3262882535, 'DE', 'DEU', 'ألمانيا'),
(61784, 3262882536, 3262882543, 'NL', 'NLD', 'هولندا'),
(61785, 3262882544, 3262883079, 'DE', 'DEU', 'ألمانيا'),
(61786, 3262883080, 3262883127, 'NL', 'NLD', 'هولندا'),
(61787, 3262883128, 3262883135, 'DE', 'DEU', 'ألمانيا'),
(61788, 3262883136, 3262883167, 'NL', 'NLD', 'هولندا'),
(61789, 3262883168, 3262883183, 'DE', 'DEU', 'ألمانيا'),
(61790, 3262883184, 3262883335, 'NL', 'NLD', 'هولندا'),
(61791, 3262883336, 3262883343, 'DE', 'DEU', 'ألمانيا'),
(61792, 3262883344, 3262883399, 'NL', 'NLD', 'هولندا'),
(61793, 3262883400, 3262883407, 'DE', 'DEU', 'ألمانيا'),
(61794, 3262883408, 3262883423, 'NL', 'NLD', 'هولندا'),
(61795, 3262883424, 3262883431, 'DE', 'DEU', 'ألمانيا'),
(61796, 3262883432, 3262883439, 'NL', 'NLD', 'هولندا'),
(61797, 3262883440, 3262883447, 'DE', 'DEU', 'ألمانيا'),
(61798, 3262883448, 3262883647, 'NL', 'NLD', 'هولندا'),
(61799, 3262883648, 3262883655, 'DE', 'DEU', 'ألمانيا'),
(61800, 3262883656, 3262883743, 'NL', 'NLD', 'هولندا'),
(61801, 3262883744, 3262883751, 'DE', 'DEU', 'ألمانيا'),
(61802, 3262883752, 3262883895, 'NL', 'NLD', 'هولندا'),
(61803, 3262883896, 3262883903, 'DE', 'DEU', 'ألمانيا'),
(61804, 3262883904, 3262884055, 'NL', 'NLD', 'هولندا'),
(61805, 3262884056, 3262884063, 'DE', 'DEU', 'ألمانيا'),
(61806, 3262884064, 3262884087, 'NL', 'NLD', 'هولندا'),
(61807, 3262884088, 3262884095, 'DE', 'DEU', 'ألمانيا'),
(61808, 3262884096, 3262884103, 'NL', 'NLD', 'هولندا'),
(61809, 3262884104, 3262884111, 'DE', 'DEU', 'ألمانيا'),
(61810, 3262884112, 3262884127, 'NL', 'NLD', 'هولندا'),
(61811, 3262884128, 3262884135, 'DE', 'DEU', 'ألمانيا'),
(61812, 3262884136, 3262884159, 'NL', 'NLD', 'هولندا'),
(61813, 3262884160, 3262884167, 'DE', 'DEU', 'ألمانيا'),
(61814, 3262884168, 3262884183, 'NL', 'NLD', 'هولندا'),
(61815, 3262884184, 3262884191, 'DE', 'DEU', 'ألمانيا'),
(61816, 3262884192, 3262884199, 'NL', 'NLD', 'هولندا'),
(61817, 3262884200, 3262884207, 'DE', 'DEU', 'ألمانيا'),
(61818, 3262884208, 3262884247, 'NL', 'NLD', 'هولندا'),
(61819, 3262884248, 3262884255, 'DE', 'DEU', 'ألمانيا'),
(61820, 3262884256, 3262884319, 'NL', 'NLD', 'هولندا'),
(61821, 3262884320, 3262884327, 'DE', 'DEU', 'ألمانيا'),
(61822, 3262884328, 3262884335, 'NL', 'NLD', 'هولندا'),
(61823, 3262884336, 3262884343, 'DE', 'DEU', 'ألمانيا'),
(61824, 3262884344, 3262884455, 'NL', 'NLD', 'هولندا'),
(61825, 3262884456, 3262884479, 'DE', 'DEU', 'ألمانيا'),
(61826, 3262884480, 3262884495, 'NL', 'NLD', 'هولندا'),
(61827, 3262884496, 3262884503, 'DE', 'DEU', 'ألمانيا'),
(61828, 3262884504, 3262884511, 'NL', 'NLD', 'هولندا'),
(61829, 3262884512, 3262884519, 'DE', 'DEU', 'ألمانيا'),
(61830, 3262884520, 3262884615, 'NL', 'NLD', 'هولندا'),
(61831, 3262884616, 3262884639, 'DE', 'DEU', 'ألمانيا'),
(61832, 3262884640, 3262884807, 'NL', 'NLD', 'هولندا'),
(61833, 3262884808, 3262884815, 'DE', 'DEU', 'ألمانيا'),
(61834, 3262884816, 3262884951, 'NL', 'NLD', 'هولندا'),
(61835, 3262884952, 3262884959, 'DE', 'DEU', 'ألمانيا'),
(61836, 3262884960, 3262884967, 'NL', 'NLD', 'هولندا'),
(61837, 3262884968, 3262884975, 'DE', 'DEU', 'ألمانيا'),
(61838, 3262884976, 3262885023, 'NL', 'NLD', 'هولندا'),
(61839, 3262885024, 3262885031, 'DE', 'DEU', 'ألمانيا'),
(61840, 3262885032, 3262885047, 'NL', 'NLD', 'هولندا'),
(61841, 3262885048, 3262885055, 'DE', 'DEU', 'ألمانيا'),
(61842, 3262885056, 3262885135, 'NL', 'NLD', 'هولندا'),
(61843, 3262885136, 3262885143, 'DE', 'DEU', 'ألمانيا'),
(61844, 3262885144, 3262885199, 'NL', 'NLD', 'هولندا'),
(61845, 3262885200, 3262885207, 'DE', 'DEU', 'ألمانيا'),
(61846, 3262885208, 3262885295, 'NL', 'NLD', 'هولندا'),
(61847, 3262885296, 3262885303, 'DE', 'DEU', 'ألمانيا'),
(61848, 3262885304, 3262885431, 'NL', 'NLD', 'هولندا'),
(61849, 3262885432, 3262885439, 'DE', 'DEU', 'ألمانيا'),
(61850, 3262885440, 3262885447, 'NL', 'NLD', 'هولندا'),
(61851, 3262885448, 3262885463, 'DE', 'DEU', 'ألمانيا'),
(61852, 3262885464, 3262885703, 'NL', 'NLD', 'هولندا'),
(61853, 3262885704, 3262885727, 'DE', 'DEU', 'ألمانيا'),
(61854, 3262885728, 3262885743, 'NL', 'NLD', 'هولندا'),
(61855, 3262885744, 3262885751, 'DE', 'DEU', 'ألمانيا'),
(61856, 3262885752, 3262885759, 'NL', 'NLD', 'هولندا'),
(61857, 3262885760, 3262885767, 'DE', 'DEU', 'ألمانيا'),
(61858, 3262885768, 3262885855, 'NL', 'NLD', 'هولندا'),
(61859, 3262885856, 3262885863, 'DE', 'DEU', 'ألمانيا'),
(61860, 3262885864, 3262885895, 'NL', 'NLD', 'هولندا'),
(61861, 3262885896, 3262885903, 'DE', 'DEU', 'ألمانيا'),
(61862, 3262885904, 3262885927, 'NL', 'NLD', 'هولندا'),
(61863, 3262885928, 3262885935, 'DE', 'DEU', 'ألمانيا'),
(61864, 3262885936, 3262886015, 'NL', 'NLD', 'هولندا'),
(61865, 3262886016, 3262886023, 'DE', 'DEU', 'ألمانيا'),
(61866, 3262886024, 3262886167, 'NL', 'NLD', 'هولندا'),
(61867, 3262886168, 3262886175, 'DE', 'DEU', 'ألمانيا'),
(61868, 3262886176, 3262886191, 'NL', 'NLD', 'هولندا'),
(61869, 3262886192, 3262886199, 'DE', 'DEU', 'ألمانيا'),
(61870, 3262886200, 3262886247, 'NL', 'NLD', 'هولندا'),
(61871, 3262886248, 3262886255, 'DE', 'DEU', 'ألمانيا'),
(61872, 3262886256, 3262886407, 'NL', 'NLD', 'هولندا'),
(61873, 3262886408, 3262886415, 'DE', 'DEU', 'ألمانيا'),
(61874, 3262886416, 3262886455, 'NL', 'NLD', 'هولندا'),
(61875, 3262886456, 3262886463, 'DE', 'DEU', 'ألمانيا'),
(61876, 3262886464, 3262886551, 'NL', 'NLD', 'هولندا'),
(61877, 3262886552, 3262886559, 'DE', 'DEU', 'ألمانيا'),
(61878, 3262886560, 3262886583, 'NL', 'NLD', 'هولندا'),
(61879, 3262886584, 3262886591, 'DE', 'DEU', 'ألمانيا'),
(61880, 3262886592, 3262886655, 'NL', 'NLD', 'هولندا'),
(61881, 3262886656, 3262886663, 'DE', 'DEU', 'ألمانيا'),
(61882, 3262886664, 3262886679, 'NL', 'NLD', 'هولندا'),
(61883, 3262886680, 3262886687, 'DE', 'DEU', 'ألمانيا'),
(61884, 3262886688, 3262886735, 'NL', 'NLD', 'هولندا'),
(61885, 3262886736, 3262886751, 'DE', 'DEU', 'ألمانيا'),
(61886, 3262886752, 3262886767, 'NL', 'NLD', 'هولندا'),
(61887, 3262886768, 3262886783, 'DE', 'DEU', 'ألمانيا'),
(61888, 3262886784, 3262886791, 'NL', 'NLD', 'هولندا'),
(61889, 3262886792, 3262886807, 'DE', 'DEU', 'ألمانيا'),
(61890, 3262886808, 3262886887, 'NL', 'NLD', 'هولندا'),
(61891, 3262886888, 3262886903, 'DE', 'DEU', 'ألمانيا'),
(61892, 3262886904, 3262886991, 'NL', 'NLD', 'هولندا'),
(61893, 3262886992, 3262887007, 'DE', 'DEU', 'ألمانيا'),
(61894, 3262887008, 3262887031, 'NL', 'NLD', 'هولندا'),
(61895, 3262887032, 3262887039, 'DE', 'DEU', 'ألمانيا'),
(61896, 3262887040, 3262887167, 'NL', 'NLD', 'هولندا'),
(61897, 3262887168, 3262887175, 'DE', 'DEU', 'ألمانيا'),
(61898, 3262887176, 3262887191, 'NL', 'NLD', 'هولندا'),
(61899, 3262887192, 3262887199, 'DE', 'DEU', 'ألمانيا'),
(61900, 3262887200, 3262887247, 'NL', 'NLD', 'هولندا'),
(61901, 3262887248, 3262887255, 'DE', 'DEU', 'ألمانيا'),
(61902, 3262887256, 3262887367, 'NL', 'NLD', 'هولندا'),
(61903, 3262887368, 3262887375, 'DE', 'DEU', 'ألمانيا'),
(61904, 3262887376, 3262887479, 'NL', 'NLD', 'هولندا'),
(61905, 3262887480, 3262887495, 'DE', 'DEU', 'ألمانيا'),
(61906, 3262887496, 3262887519, 'NL', 'NLD', 'هولندا'),
(61907, 3262887520, 3262887527, 'DE', 'DEU', 'ألمانيا'),
(61908, 3262887528, 3262887559, 'NL', 'NLD', 'هولندا'),
(61909, 3262887560, 3262887567, 'DE', 'DEU', 'ألمانيا'),
(61910, 3262887568, 3262887647, 'NL', 'NLD', 'هولندا'),
(61911, 3262887648, 3262887663, 'DE', 'DEU', 'ألمانيا'),
(61912, 3262887664, 3262887783, 'NL', 'NLD', 'هولندا'),
(61913, 3262887784, 3262887799, 'DE', 'DEU', 'ألمانيا'),
(61914, 3262887800, 3262888023, 'NL', 'NLD', 'هولندا'),
(61915, 3262888024, 3262888031, 'DE', 'DEU', 'ألمانيا'),
(61916, 3262888032, 3262888167, 'NL', 'NLD', 'هولندا'),
(61917, 3262888168, 3262888175, 'DE', 'DEU', 'ألمانيا'),
(61918, 3262888176, 3262888191, 'NL', 'NLD', 'هولندا'),
(61919, 3262888192, 3262888199, 'DE', 'DEU', 'ألمانيا'),
(61920, 3262888200, 3262888207, 'NL', 'NLD', 'هولندا'),
(61921, 3262888208, 3262888215, 'DE', 'DEU', 'ألمانيا'),
(61922, 3262888216, 3262888255, 'NL', 'NLD', 'هولندا'),
(61923, 3262888256, 3262888263, 'DE', 'DEU', 'ألمانيا'),
(61924, 3262888264, 3262888391, 'NL', 'NLD', 'هولندا'),
(61925, 3262888392, 3262888399, 'DE', 'DEU', 'ألمانيا'),
(61926, 3262888400, 3262888447, 'NL', 'NLD', 'هولندا'),
(61927, 3262888448, 3262888455, 'DE', 'DEU', 'ألمانيا'),
(61928, 3262888456, 3262888511, 'NL', 'NLD', 'هولندا'),
(61929, 3262888512, 3262888527, 'DE', 'DEU', 'ألمانيا'),
(61930, 3262888528, 3262888535, 'NL', 'NLD', 'هولندا'),
(61931, 3262888536, 3262888543, 'DE', 'DEU', 'ألمانيا'),
(61932, 3262888544, 3262888575, 'NL', 'NLD', 'هولندا'),
(61933, 3262888576, 3262888583, 'DE', 'DEU', 'ألمانيا'),
(61934, 3262888584, 3262888735, 'NL', 'NLD', 'هولندا'),
(61935, 3262888736, 3262888743, 'DE', 'DEU', 'ألمانيا'),
(61936, 3262888744, 3262888783, 'NL', 'NLD', 'هولندا'),
(61937, 3262888784, 3262888791, 'DE', 'DEU', 'ألمانيا'),
(61938, 3262888792, 3262888807, 'NL', 'NLD', 'هولندا'),
(61939, 3262888808, 3262888815, 'DE', 'DEU', 'ألمانيا'),
(61940, 3262888816, 3262888839, 'NL', 'NLD', 'هولندا'),
(61941, 3262888840, 3262888847, 'DE', 'DEU', 'ألمانيا'),
(61942, 3262888848, 3262888943, 'NL', 'NLD', 'هولندا'),
(61943, 3262888944, 3262888951, 'DE', 'DEU', 'ألمانيا'),
(61944, 3262888952, 3262888983, 'NL', 'NLD', 'هولندا'),
(61945, 3262888984, 3262888991, 'DE', 'DEU', 'ألمانيا'),
(61946, 3262888992, 3262889031, 'NL', 'NLD', 'هولندا'),
(61947, 3262889032, 3262889039, 'DE', 'DEU', 'ألمانيا'),
(61948, 3262889040, 3262889095, 'NL', 'NLD', 'هولندا'),
(61949, 3262889096, 3262889103, 'DE', 'DEU', 'ألمانيا'),
(61950, 3262889104, 3262889111, 'NL', 'NLD', 'هولندا'),
(61951, 3262889112, 3262889119, 'DE', 'DEU', 'ألمانيا'),
(61952, 3262889120, 3262889167, 'NL', 'NLD', 'هولندا'),
(61953, 3262889168, 3262889175, 'DE', 'DEU', 'ألمانيا'),
(61954, 3262889176, 3262889207, 'NL', 'NLD', 'هولندا'),
(61955, 3262889208, 3262889215, 'DE', 'DEU', 'ألمانيا'),
(61956, 3262889216, 3262889343, 'NL', 'NLD', 'هولندا'),
(61957, 3262889344, 3262889359, 'DE', 'DEU', 'ألمانيا'),
(61958, 3262889360, 3262889399, 'NL', 'NLD', 'هولندا'),
(61959, 3262889400, 3262889407, 'DE', 'DEU', 'ألمانيا'),
(61960, 3262889408, 3262889415, 'NL', 'NLD', 'هولندا'),
(61961, 3262889416, 3262889423, 'DE', 'DEU', 'ألمانيا'),
(61962, 3262889424, 3262889439, 'NL', 'NLD', 'هولندا'),
(61963, 3262889440, 3262889471, 'DE', 'DEU', 'ألمانيا'),
(61964, 3262889472, 3262889519, 'NL', 'NLD', 'هولندا'),
(61965, 3262889520, 3262889527, 'DE', 'DEU', 'ألمانيا'),
(61966, 3262889528, 3262889543, 'NL', 'NLD', 'هولندا'),
(61967, 3262889544, 3262889567, 'DE', 'DEU', 'ألمانيا'),
(61968, 3262889568, 3262889583, 'NL', 'NLD', 'هولندا'),
(61969, 3262889584, 3262889599, 'DE', 'DEU', 'ألمانيا'),
(61970, 3262889600, 3262889671, 'NL', 'NLD', 'هولندا'),
(61971, 3262889672, 3262889679, 'DE', 'DEU', 'ألمانيا'),
(61972, 3262889680, 3262889703, 'NL', 'NLD', 'هولندا'),
(61973, 3262889704, 3262889711, 'DE', 'DEU', 'ألمانيا'),
(61974, 3262889712, 3262889775, 'NL', 'NLD', 'هولندا'),
(61975, 3262889776, 3262889783, 'DE', 'DEU', 'ألمانيا'),
(61976, 3262889784, 3262889983, 'NL', 'NLD', 'هولندا'),
(61977, 3262889984, 3262889999, 'DE', 'DEU', 'ألمانيا'),
(61978, 3262890000, 3262890007, 'NL', 'NLD', 'هولندا'),
(61979, 3262890008, 3262890015, 'DE', 'DEU', 'ألمانيا'),
(61980, 3262890016, 3262890047, 'NL', 'NLD', 'هولندا'),
(61981, 3262890048, 3262890055, 'DE', 'DEU', 'ألمانيا'),
(61982, 3262890056, 3262890087, 'NL', 'NLD', 'هولندا'),
(61983, 3262890088, 3262890095, 'DE', 'DEU', 'ألمانيا'),
(61984, 3262890096, 3262890135, 'NL', 'NLD', 'هولندا'),
(61985, 3262890136, 3262890143, 'DE', 'DEU', 'ألمانيا'),
(61986, 3262890144, 3262890295, 'NL', 'NLD', 'هولندا'),
(61987, 3262890296, 3262890303, 'DE', 'DEU', 'ألمانيا'),
(61988, 3262890304, 3262890319, 'NL', 'NLD', 'هولندا'),
(61989, 3262890320, 3262890327, 'DE', 'DEU', 'ألمانيا'),
(61990, 3262890328, 3262890583, 'NL', 'NLD', 'هولندا'),
(61991, 3262890584, 3262890591, 'DE', 'DEU', 'ألمانيا'),
(61992, 3262890592, 3262890623, 'NL', 'NLD', 'هولندا'),
(61993, 3262890624, 3262890631, 'DE', 'DEU', 'ألمانيا'),
(61994, 3262890632, 3262890639, 'NL', 'NLD', 'هولندا'),
(61995, 3262890640, 3262890647, 'DE', 'DEU', 'ألمانيا'),
(61996, 3262890648, 3262890703, 'NL', 'NLD', 'هولندا'),
(61997, 3262890704, 3262890711, 'DE', 'DEU', 'ألمانيا'),
(61998, 3262890712, 3262890839, 'NL', 'NLD', 'هولندا'),
(61999, 3262890840, 3262890855, 'DE', 'DEU', 'ألمانيا'),
(62000, 3262890856, 3262890879, 'NL', 'NLD', 'هولندا'),
(62001, 3262890880, 3262890887, 'DE', 'DEU', 'ألمانيا'),
(62002, 3262890888, 3262890991, 'NL', 'NLD', 'هولندا'),
(62003, 3262890992, 3262890999, 'DE', 'DEU', 'ألمانيا'),
(62004, 3262891000, 3262891015, 'NL', 'NLD', 'هولندا'),
(62005, 3262891016, 3262891023, 'DE', 'DEU', 'ألمانيا'),
(62006, 3262891024, 3262891047, 'NL', 'NLD', 'هولندا'),
(62007, 3262891048, 3262891055, 'DE', 'DEU', 'ألمانيا'),
(62008, 3262891056, 3262891191, 'NL', 'NLD', 'هولندا'),
(62009, 3262891192, 3262891215, 'DE', 'DEU', 'ألمانيا'),
(62010, 3262891216, 3262891359, 'NL', 'NLD', 'هولندا'),
(62011, 3262891360, 3262891367, 'DE', 'DEU', 'ألمانيا'),
(62012, 3262891368, 3262891455, 'NL', 'NLD', 'هولندا'),
(62013, 3262891456, 3262891471, 'DE', 'DEU', 'ألمانيا'),
(62014, 3262891472, 3262891479, 'NL', 'NLD', 'هولندا'),
(62015, 3262891480, 3262891487, 'DE', 'DEU', 'ألمانيا'),
(62016, 3262891488, 3262891519, 'NL', 'NLD', 'هولندا'),
(62017, 3262891520, 3262891527, 'DE', 'DEU', 'ألمانيا'),
(62018, 3262891528, 3262891607, 'NL', 'NLD', 'هولندا'),
(62019, 3262891608, 3262891615, 'DE', 'DEU', 'ألمانيا'),
(62020, 3262891616, 3262891647, 'NL', 'NLD', 'هولندا'),
(62021, 3262891648, 3262891663, 'DE', 'DEU', 'ألمانيا'),
(62022, 3262891664, 3262891759, 'NL', 'NLD', 'هولندا'),
(62023, 3262891760, 3262891767, 'DE', 'DEU', 'ألمانيا'),
(62024, 3262891768, 3262891871, 'NL', 'NLD', 'هولندا'),
(62025, 3262891872, 3262891879, 'DE', 'DEU', 'ألمانيا'),
(62026, 3262891880, 3262892095, 'NL', 'NLD', 'هولندا'),
(62027, 3262892096, 3262892103, 'DE', 'DEU', 'ألمانيا'),
(62028, 3262892104, 3262892119, 'NL', 'NLD', 'هولندا'),
(62029, 3262892120, 3262892127, 'DE', 'DEU', 'ألمانيا'),
(62030, 3262892128, 3262892223, 'NL', 'NLD', 'هولندا'),
(62031, 3262892224, 3262892231, 'DE', 'DEU', 'ألمانيا'),
(62032, 3262892232, 3262892311, 'NL', 'NLD', 'هولندا'),
(62033, 3262892312, 3262892319, 'DE', 'DEU', 'ألمانيا'),
(62034, 3262892320, 3262892391, 'NL', 'NLD', 'هولندا'),
(62035, 3262892392, 3262892407, 'DE', 'DEU', 'ألمانيا'),
(62036, 3262892408, 3262892671, 'NL', 'NLD', 'هولندا'),
(62037, 3262892672, 3262892679, 'DE', 'DEU', 'ألمانيا'),
(62038, 3262892680, 3262892703, 'NL', 'NLD', 'هولندا'),
(62039, 3262892704, 3262892711, 'DE', 'DEU', 'ألمانيا'),
(62040, 3262892712, 3262892879, 'NL', 'NLD', 'هولندا'),
(62041, 3262892880, 3262892895, 'DE', 'DEU', 'ألمانيا'),
(62042, 3262892896, 3262892903, 'NL', 'NLD', 'هولندا'),
(62043, 3262892904, 3262892911, 'DE', 'DEU', 'ألمانيا'),
(62044, 3262892912, 3262892991, 'NL', 'NLD', 'هولندا'),
(62045, 3262892992, 3262892999, 'DE', 'DEU', 'ألمانيا'),
(62046, 3262893000, 3262893127, 'NL', 'NLD', 'هولندا'),
(62047, 3262893128, 3262893135, 'DE', 'DEU', 'ألمانيا'),
(62048, 3262893136, 3262893151, 'NL', 'NLD', 'هولندا'),
(62049, 3262893152, 3262893159, 'DE', 'DEU', 'ألمانيا'),
(62050, 3262893160, 3262893255, 'NL', 'NLD', 'هولندا'),
(62051, 3262893256, 3262893263, 'DE', 'DEU', 'ألمانيا'),
(62052, 3262893264, 3262893327, 'NL', 'NLD', 'هولندا'),
(62053, 3262893328, 3262893335, 'DE', 'DEU', 'ألمانيا'),
(62054, 3262893336, 3262893343, 'NL', 'NLD', 'هولندا'),
(62055, 3262893344, 3262893351, 'DE', 'DEU', 'ألمانيا'),
(62056, 3262893352, 3262893479, 'NL', 'NLD', 'هولندا'),
(62057, 3262893480, 3262893487, 'DE', 'DEU', 'ألمانيا'),
(62058, 3262893488, 3262893535, 'NL', 'NLD', 'هولندا'),
(62059, 3262893536, 3262893543, 'DE', 'DEU', 'ألمانيا'),
(62060, 3262893544, 3262893679, 'NL', 'NLD', 'هولندا'),
(62061, 3262893680, 3262893687, 'DE', 'DEU', 'ألمانيا'),
(62062, 3262893688, 3262893775, 'NL', 'NLD', 'هولندا'),
(62063, 3262893776, 3262893783, 'DE', 'DEU', 'ألمانيا'),
(62064, 3262893784, 3262893879, 'NL', 'NLD', 'هولندا'),
(62065, 3262893880, 3262893887, 'DE', 'DEU', 'ألمانيا'),
(62066, 3262893888, 3262893975, 'NL', 'NLD', 'هولندا'),
(62067, 3262893976, 3262893983, 'DE', 'DEU', 'ألمانيا'),
(62068, 3262893984, 3262894039, 'NL', 'NLD', 'هولندا'),
(62069, 3262894040, 3262894047, 'DE', 'DEU', 'ألمانيا'),
(62070, 3262894048, 3262894119, 'NL', 'NLD', 'هولندا'),
(62071, 3262894120, 3262894127, 'DE', 'DEU', 'ألمانيا'),
(62072, 3262894128, 3262894239, 'NL', 'NLD', 'هولندا'),
(62073, 3262894240, 3262894247, 'DE', 'DEU', 'ألمانيا'),
(62074, 3262894248, 3262894359, 'NL', 'NLD', 'هولندا'),
(62075, 3262894360, 3262894367, 'DE', 'DEU', 'ألمانيا'),
(62076, 3262894368, 3262894455, 'NL', 'NLD', 'هولندا'),
(62077, 3262894456, 3262894471, 'DE', 'DEU', 'ألمانيا'),
(62078, 3262894472, 3262894511, 'NL', 'NLD', 'هولندا'),
(62079, 3262894512, 3262894519, 'DE', 'DEU', 'ألمانيا'),
(62080, 3262894520, 3262894575, 'NL', 'NLD', 'هولندا'),
(62081, 3262894576, 3262894591, 'DE', 'DEU', 'ألمانيا'),
(62082, 3262894592, 3262894623, 'NL', 'NLD', 'هولندا'),
(62083, 3262894624, 3262894631, 'DE', 'DEU', 'ألمانيا'),
(62084, 3262894632, 3262894791, 'NL', 'NLD', 'هولندا'),
(62085, 3262894792, 3262894799, 'DE', 'DEU', 'ألمانيا'),
(62086, 3262894800, 3262894831, 'NL', 'NLD', 'هولندا'),
(62087, 3262894832, 3262894839, 'DE', 'DEU', 'ألمانيا'),
(62088, 3262894840, 3262894855, 'NL', 'NLD', 'هولندا'),
(62089, 3262894856, 3262894863, 'DE', 'DEU', 'ألمانيا'),
(62090, 3262894864, 3262895055, 'NL', 'NLD', 'هولندا'),
(62091, 3262895056, 3262895063, 'DE', 'DEU', 'ألمانيا'),
(62092, 3262895064, 3262895103, 'NL', 'NLD', 'هولندا'),
(62093, 3262895104, 3262895111, 'DE', 'DEU', 'ألمانيا'),
(62094, 3262895112, 3262895119, 'NL', 'NLD', 'هولندا'),
(62095, 3262895120, 3262895127, 'DE', 'DEU', 'ألمانيا'),
(62096, 3262895128, 3262895159, 'NL', 'NLD', 'هولندا'),
(62097, 3262895160, 3262895183, 'DE', 'DEU', 'ألمانيا'),
(62098, 3262895184, 3262895223, 'NL', 'NLD', 'هولندا'),
(62099, 3262895224, 3262895231, 'DE', 'DEU', 'ألمانيا'),
(62100, 3262895232, 3262895335, 'NL', 'NLD', 'هولندا'),
(62101, 3262895336, 3262895343, 'DE', 'DEU', 'ألمانيا'),
(62102, 3262895344, 3262895367, 'NL', 'NLD', 'هولندا'),
(62103, 3262895368, 3262895375, 'DE', 'DEU', 'ألمانيا'),
(62104, 3262895376, 3262895415, 'NL', 'NLD', 'هولندا'),
(62105, 3262895416, 3262895423, 'DE', 'DEU', 'ألمانيا'),
(62106, 3262895424, 3262895487, 'NL', 'NLD', 'هولندا'),
(62107, 3262895488, 3262895511, 'DE', 'DEU', 'ألمانيا'),
(62108, 3262895512, 3262895551, 'NL', 'NLD', 'هولندا'),
(62109, 3262895552, 3262895559, 'DE', 'DEU', 'ألمانيا'),
(62110, 3262895560, 3262895679, 'NL', 'NLD', 'هولندا'),
(62111, 3262895680, 3262895687, 'DE', 'DEU', 'ألمانيا'),
(62112, 3262895688, 3262895727, 'NL', 'NLD', 'هولندا'),
(62113, 3262895728, 3262895735, 'DE', 'DEU', 'ألمانيا'),
(62114, 3262895736, 3262895775, 'NL', 'NLD', 'هولندا'),
(62115, 3262895776, 3262895783, 'DE', 'DEU', 'ألمانيا'),
(62116, 3262895784, 3262895911, 'NL', 'NLD', 'هولندا'),
(62117, 3262895912, 3262895919, 'DE', 'DEU', 'ألمانيا'),
(62118, 3262895920, 3262895991, 'NL', 'NLD', 'هولندا'),
(62119, 3262895992, 3262895999, 'DE', 'DEU', 'ألمانيا'),
(62120, 3262896000, 3262896183, 'NL', 'NLD', 'هولندا'),
(62121, 3262896184, 3262896191, 'DE', 'DEU', 'ألمانيا'),
(62122, 3262896192, 3262896207, 'NL', 'NLD', 'هولندا'),
(62123, 3262896208, 3262896215, 'DE', 'DEU', 'ألمانيا'),
(62124, 3262896216, 3262896223, 'NL', 'NLD', 'هولندا'),
(62125, 3262896224, 3262896231, 'DE', 'DEU', 'ألمانيا'),
(62126, 3262896232, 3262896271, 'NL', 'NLD', 'هولندا'),
(62127, 3262896272, 3262896279, 'DE', 'DEU', 'ألمانيا'),
(62128, 3262896280, 3262896327, 'NL', 'NLD', 'هولندا'),
(62129, 3262896328, 3262896335, 'DE', 'DEU', 'ألمانيا'),
(62130, 3262896336, 3262896471, 'NL', 'NLD', 'هولندا'),
(62131, 3262896472, 3262896479, 'DE', 'DEU', 'ألمانيا'),
(62132, 3262896480, 3262896727, 'NL', 'NLD', 'هولندا'),
(62133, 3262896728, 3262896735, 'DE', 'DEU', 'ألمانيا'),
(62134, 3262896736, 3262896943, 'NL', 'NLD', 'هولندا'),
(62135, 3262896944, 3262896951, 'DE', 'DEU', 'ألمانيا'),
(62136, 3262896952, 3262896959, 'NL', 'NLD', 'هولندا'),
(62137, 3262896960, 3262896967, 'DE', 'DEU', 'ألمانيا'),
(62138, 3262896968, 3262896983, 'NL', 'NLD', 'هولندا'),
(62139, 3262896984, 3262896991, 'DE', 'DEU', 'ألمانيا'),
(62140, 3262896992, 3262897167, 'NL', 'NLD', 'هولندا'),
(62141, 3262897168, 3262897175, 'DE', 'DEU', 'ألمانيا'),
(62142, 3262897176, 3262897295, 'NL', 'NLD', 'هولندا'),
(62143, 3262897296, 3262897303, 'DE', 'DEU', 'ألمانيا'),
(62144, 3262897304, 3262897343, 'NL', 'NLD', 'هولندا'),
(62145, 3262897344, 3262897351, 'DE', 'DEU', 'ألمانيا'),
(62146, 3262897352, 3262897447, 'NL', 'NLD', 'هولندا'),
(62147, 3262897448, 3262897455, 'DE', 'DEU', 'ألمانيا'),
(62148, 3262897456, 3262897503, 'NL', 'NLD', 'هولندا'),
(62149, 3262897504, 3262897511, 'DE', 'DEU', 'ألمانيا'),
(62150, 3262897512, 3262897655, 'NL', 'NLD', 'هولندا'),
(62151, 3262897656, 3262897663, 'DE', 'DEU', 'ألمانيا'),
(62152, 3262897664, 3262897791, 'NL', 'NLD', 'هولندا'),
(62153, 3262897792, 3262897799, 'DE', 'DEU', 'ألمانيا'),
(62154, 3262897800, 3262897815, 'NL', 'NLD', 'هولندا'),
(62155, 3262897816, 3262897823, 'DE', 'DEU', 'ألمانيا'),
(62156, 3262897824, 3262897983, 'NL', 'NLD', 'هولندا'),
(62157, 3262897984, 3262897991, 'DE', 'DEU', 'ألمانيا'),
(62158, 3262897992, 3262898103, 'NL', 'NLD', 'هولندا'),
(62159, 3262898104, 3262898111, 'DE', 'DEU', 'ألمانيا'),
(62160, 3262898112, 3262898119, 'NL', 'NLD', 'هولندا'),
(62161, 3262898120, 3262898127, 'DE', 'DEU', 'ألمانيا'),
(62162, 3262898128, 3262898199, 'NL', 'NLD', 'هولندا'),
(62163, 3262898200, 3262898207, 'DE', 'DEU', 'ألمانيا'),
(62164, 3262898208, 3262898231, 'NL', 'NLD', 'هولندا'),
(62165, 3262898232, 3262898239, 'DE', 'DEU', 'ألمانيا'),
(62166, 3262898240, 3262898351, 'NL', 'NLD', 'هولندا'),
(62167, 3262898352, 3262898367, 'DE', 'DEU', 'ألمانيا'),
(62168, 3262898368, 3262898431, 'NL', 'NLD', 'هولندا'),
(62169, 3262898432, 3262898439, 'DE', 'DEU', 'ألمانيا'),
(62170, 3262898440, 3262898471, 'NL', 'NLD', 'هولندا'),
(62171, 3262898472, 3262898479, 'DE', 'DEU', 'ألمانيا'),
(62172, 3262898480, 3262898551, 'NL', 'NLD', 'هولندا'),
(62173, 3262898552, 3262898559, 'DE', 'DEU', 'ألمانيا'),
(62174, 3262898560, 3262898599, 'NL', 'NLD', 'هولندا'),
(62175, 3262898600, 3262898607, 'DE', 'DEU', 'ألمانيا'),
(62176, 3262898608, 3262898639, 'NL', 'NLD', 'هولندا'),
(62177, 3262898640, 3262898647, 'DE', 'DEU', 'ألمانيا'),
(62178, 3262898648, 3262898703, 'NL', 'NLD', 'هولندا'),
(62179, 3262898704, 3262898711, 'DE', 'DEU', 'ألمانيا'),
(62180, 3262898712, 3262898727, 'NL', 'NLD', 'هولندا'),
(62181, 3262898728, 3262898735, 'DE', 'DEU', 'ألمانيا'),
(62182, 3262898736, 3262898807, 'NL', 'NLD', 'هولندا'),
(62183, 3262898808, 3262898815, 'DE', 'DEU', 'ألمانيا'),
(62184, 3262898816, 3262898863, 'NL', 'NLD', 'هولندا'),
(62185, 3262898864, 3262898871, 'DE', 'DEU', 'ألمانيا'),
(62186, 3262898872, 3262898879, 'NL', 'NLD', 'هولندا'),
(62187, 3262898880, 3262898887, 'DE', 'DEU', 'ألمانيا'),
(62188, 3262898888, 3262898951, 'NL', 'NLD', 'هولندا'),
(62189, 3262898952, 3262898959, 'DE', 'DEU', 'ألمانيا'),
(62190, 3262898960, 3262899007, 'NL', 'NLD', 'هولندا'),
(62191, 3262899008, 3262899015, 'DE', 'DEU', 'ألمانيا'),
(62192, 3262899016, 3262899031, 'NL', 'NLD', 'هولندا'),
(62193, 3262899032, 3262899047, 'DE', 'DEU', 'ألمانيا'),
(62194, 3262899048, 3262899103, 'NL', 'NLD', 'هولندا'),
(62195, 3262899104, 3262899111, 'DE', 'DEU', 'ألمانيا'),
(62196, 3262899112, 3262899159, 'NL', 'NLD', 'هولندا'),
(62197, 3262899160, 3262899175, 'DE', 'DEU', 'ألمانيا'),
(62198, 3262899176, 3262899255, 'NL', 'NLD', 'هولندا'),
(62199, 3262899256, 3262899263, 'DE', 'DEU', 'ألمانيا'),
(62200, 3262899264, 3262899271, 'NL', 'NLD', 'هولندا'),
(62201, 3262899272, 3262899279, 'DE', 'DEU', 'ألمانيا'),
(62202, 3262899280, 3262899423, 'NL', 'NLD', 'هولندا'),
(62203, 3262899424, 3262899431, 'DE', 'DEU', 'ألمانيا'),
(62204, 3262899432, 3262899655, 'NL', 'NLD', 'هولندا'),
(62205, 3262899656, 3262899663, 'DE', 'DEU', 'ألمانيا'),
(62206, 3262899664, 3262899743, 'NL', 'NLD', 'هولندا'),
(62207, 3262899744, 3262899751, 'DE', 'DEU', 'ألمانيا'),
(62208, 3262899752, 3262899935, 'NL', 'NLD', 'هولندا'),
(62209, 3262899936, 3262899943, 'DE', 'DEU', 'ألمانيا'),
(62210, 3262899944, 3262899959, 'NL', 'NLD', 'هولندا'),
(62211, 3262899960, 3262899967, 'DE', 'DEU', 'ألمانيا'),
(62212, 3262899968, 3262900055, 'NL', 'NLD', 'هولندا'),
(62213, 3262900056, 3262900063, 'DE', 'DEU', 'ألمانيا'),
(62214, 3262900064, 3262900183, 'NL', 'NLD', 'هولندا'),
(62215, 3262900184, 3262900191, 'DE', 'DEU', 'ألمانيا'),
(62216, 3262900192, 3262900223, 'NL', 'NLD', 'هولندا'),
(62217, 3262900224, 3262900479, 'DE', 'DEU', 'ألمانيا'),
(62218, 3262900480, 3262900487, 'NL', 'NLD', 'هولندا'),
(62219, 3262900488, 3262900503, 'DE', 'DEU', 'ألمانيا'),
(62220, 3262900504, 3262900583, 'NL', 'NLD', 'هولندا'),
(62221, 3262900584, 3262900591, 'DE', 'DEU', 'ألمانيا'),
(62222, 3262900592, 3262900663, 'NL', 'NLD', 'هولندا'),
(62223, 3262900664, 3262900671, 'DE', 'DEU', 'ألمانيا'),
(62224, 3262900672, 3262900799, 'NL', 'NLD', 'هولندا'),
(62225, 3262900800, 3262900807, 'DE', 'DEU', 'ألمانيا'),
(62226, 3262900808, 3262900919, 'NL', 'NLD', 'هولندا'),
(62227, 3262900920, 3262900927, 'DE', 'DEU', 'ألمانيا'),
(62228, 3262900928, 3262901015, 'NL', 'NLD', 'هولندا'),
(62229, 3262901016, 3262901023, 'DE', 'DEU', 'ألمانيا'),
(62230, 3262901024, 3262901079, 'NL', 'NLD', 'هولندا'),
(62231, 3262901080, 3262901087, 'DE', 'DEU', 'ألمانيا'),
(62232, 3262901088, 3262901111, 'NL', 'NLD', 'هولندا'),
(62233, 3262901112, 3262901119, 'DE', 'DEU', 'ألمانيا'),
(62234, 3262901120, 3262901207, 'NL', 'NLD', 'هولندا'),
(62235, 3262901208, 3262901215, 'DE', 'DEU', 'ألمانيا'),
(62236, 3262901216, 3262901511, 'NL', 'NLD', 'هولندا'),
(62237, 3262901512, 3262901519, 'DE', 'DEU', 'ألمانيا'),
(62238, 3262901520, 3262901615, 'NL', 'NLD', 'هولندا'),
(62239, 3262901616, 3262901623, 'DE', 'DEU', 'ألمانيا'),
(62240, 3262901624, 3262901663, 'NL', 'NLD', 'هولندا'),
(62241, 3262901664, 3262901671, 'DE', 'DEU', 'ألمانيا'),
(62242, 3262901672, 3262901743, 'NL', 'NLD', 'هولندا'),
(62243, 3262901744, 3262901759, 'DE', 'DEU', 'ألمانيا'),
(62244, 3262901760, 3262901887, 'NL', 'NLD', 'هولندا'),
(62245, 3262901888, 3262901895, 'DE', 'DEU', 'ألمانيا'),
(62246, 3262901896, 3262901975, 'NL', 'NLD', 'هولندا'),
(62247, 3262901976, 3262901983, 'DE', 'DEU', 'ألمانيا'),
(62248, 3262901984, 3262902175, 'NL', 'NLD', 'هولندا'),
(62249, 3262902176, 3262902183, 'DE', 'DEU', 'ألمانيا'),
(62250, 3262902184, 3262902295, 'NL', 'NLD', 'هولندا'),
(62251, 3262902296, 3262902303, 'DE', 'DEU', 'ألمانيا'),
(62252, 3262902304, 3262902327, 'NL', 'NLD', 'هولندا'),
(62253, 3262902328, 3262902335, 'DE', 'DEU', 'ألمانيا'),
(62254, 3262902336, 3262902631, 'NL', 'NLD', 'هولندا'),
(62255, 3262902632, 3262902639, 'DE', 'DEU', 'ألمانيا'),
(62256, 3262902640, 3262902727, 'NL', 'NLD', 'هولندا'),
(62257, 3262902728, 3262902735, 'DE', 'DEU', 'ألمانيا'),
(62258, 3262902736, 3262902831, 'NL', 'NLD', 'هولندا'),
(62259, 3262902832, 3262902839, 'DE', 'DEU', 'ألمانيا'),
(62260, 3262902840, 3262902871, 'NL', 'NLD', 'هولندا'),
(62261, 3262902872, 3262902879, 'DE', 'DEU', 'ألمانيا'),
(62262, 3262902880, 3262902991, 'NL', 'NLD', 'هولندا'),
(62263, 3262902992, 3262902999, 'DE', 'DEU', 'ألمانيا'),
(62264, 3262903000, 3262903047, 'NL', 'NLD', 'هولندا'),
(62265, 3262903048, 3262903055, 'DE', 'DEU', 'ألمانيا'),
(62266, 3262903056, 3262903143, 'NL', 'NLD', 'هولندا'),
(62267, 3262903144, 3262903151, 'DE', 'DEU', 'ألمانيا'),
(62268, 3262903152, 3262903327, 'NL', 'NLD', 'هولندا'),
(62269, 3262903328, 3262903343, 'DE', 'DEU', 'ألمانيا'),
(62270, 3262903344, 3262903399, 'NL', 'NLD', 'هولندا'),
(62271, 3262903400, 3262903407, 'DE', 'DEU', 'ألمانيا'),
(62272, 3262903408, 3262903575, 'NL', 'NLD', 'هولندا'),
(62273, 3262903576, 3262903583, 'DE', 'DEU', 'ألمانيا'),
(62274, 3262903584, 3262903623, 'NL', 'NLD', 'هولندا'),
(62275, 3262903624, 3262903631, 'DE', 'DEU', 'ألمانيا'),
(62276, 3262903632, 3262903671, 'NL', 'NLD', 'هولندا'),
(62277, 3262903672, 3262903679, 'DE', 'DEU', 'ألمانيا'),
(62278, 3262903680, 3262903751, 'NL', 'NLD', 'هولندا'),
(62279, 3262903752, 3262903759, 'DE', 'DEU', 'ألمانيا'),
(62280, 3262903760, 3262903807, 'NL', 'NLD', 'هولندا'),
(62281, 3262903808, 3262903815, 'DE', 'DEU', 'ألمانيا'),
(62282, 3262903816, 3262903831, 'NL', 'NLD', 'هولندا'),
(62283, 3262903832, 3262903839, 'DE', 'DEU', 'ألمانيا'),
(62284, 3262903840, 3262904095, 'NL', 'NLD', 'هولندا'),
(62285, 3262904096, 3262904103, 'DE', 'DEU', 'ألمانيا'),
(62286, 3262904104, 3262904127, 'NL', 'NLD', 'هولندا'),
(62287, 3262904128, 3262904135, 'DE', 'DEU', 'ألمانيا'),
(62288, 3262904136, 3262904167, 'NL', 'NLD', 'هولندا'),
(62289, 3262904168, 3262904175, 'DE', 'DEU', 'ألمانيا'),
(62290, 3262904176, 3262904215, 'NL', 'NLD', 'هولندا'),
(62291, 3262904216, 3262904223, 'DE', 'DEU', 'ألمانيا'),
(62292, 3262904224, 3262904255, 'NL', 'NLD', 'هولندا'),
(62293, 3262904256, 3262904263, 'DE', 'DEU', 'ألمانيا'),
(62294, 3262904264, 3262904319, 'NL', 'NLD', 'هولندا'),
(62295, 3262904320, 3262904327, 'DE', 'DEU', 'ألمانيا'),
(62296, 3262904328, 3262904383, 'NL', 'NLD', 'هولندا'),
(62297, 3262904384, 3262904391, 'DE', 'DEU', 'ألمانيا'),
(62298, 3262904392, 3262904463, 'NL', 'NLD', 'هولندا'),
(62299, 3262904464, 3262904471, 'DE', 'DEU', 'ألمانيا'),
(62300, 3262904472, 3262904583, 'NL', 'NLD', 'هولندا'),
(62301, 3262904584, 3262904591, 'DE', 'DEU', 'ألمانيا'),
(62302, 3262904592, 3262904631, 'NL', 'NLD', 'هولندا'),
(62303, 3262904632, 3262904639, 'DE', 'DEU', 'ألمانيا'),
(62304, 3262904640, 3262904655, 'NL', 'NLD', 'هولندا'),
(62305, 3262904656, 3262904663, 'DE', 'DEU', 'ألمانيا'),
(62306, 3262904664, 3262904703, 'NL', 'NLD', 'هولندا'),
(62307, 3262904704, 3262904711, 'DE', 'DEU', 'ألمانيا'),
(62308, 3262904712, 3262904791, 'NL', 'NLD', 'هولندا'),
(62309, 3262904792, 3262904799, 'DE', 'DEU', 'ألمانيا'),
(62310, 3262904800, 3262904959, 'NL', 'NLD', 'هولندا'),
(62311, 3262904960, 3262904967, 'DE', 'DEU', 'ألمانيا'),
(62312, 3262904968, 3262904975, 'NL', 'NLD', 'هولندا'),
(62313, 3262904976, 3262904983, 'DE', 'DEU', 'ألمانيا'),
(62314, 3262904984, 3262905007, 'NL', 'NLD', 'هولندا'),
(62315, 3262905008, 3262905015, 'DE', 'DEU', 'ألمانيا'),
(62316, 3262905016, 3262905111, 'NL', 'NLD', 'هولندا'),
(62317, 3262905112, 3262905119, 'DE', 'DEU', 'ألمانيا'),
(62318, 3262905120, 3262905199, 'NL', 'NLD', 'هولندا'),
(62319, 3262905200, 3262905207, 'DE', 'DEU', 'ألمانيا'),
(62320, 3262905208, 3262905223, 'NL', 'NLD', 'هولندا'),
(62321, 3262905224, 3262905231, 'DE', 'DEU', 'ألمانيا'),
(62322, 3262905232, 3262905239, 'NL', 'NLD', 'هولندا'),
(62323, 3262905240, 3262905247, 'DE', 'DEU', 'ألمانيا'),
(62324, 3262905248, 3262905287, 'NL', 'NLD', 'هولندا'),
(62325, 3262905288, 3262905295, 'DE', 'DEU', 'ألمانيا'),
(62326, 3262905296, 3262905327, 'NL', 'NLD', 'هولندا'),
(62327, 3262905328, 3262905335, 'DE', 'DEU', 'ألمانيا'),
(62328, 3262905336, 3262905375, 'NL', 'NLD', 'هولندا'),
(62329, 3262905376, 3262905383, 'DE', 'DEU', 'ألمانيا'),
(62330, 3262905384, 3262905399, 'NL', 'NLD', 'هولندا'),
(62331, 3262905400, 3262905407, 'DE', 'DEU', 'ألمانيا'),
(62332, 3262905408, 3262905495, 'NL', 'NLD', 'هولندا'),
(62333, 3262905496, 3262905503, 'DE', 'DEU', 'ألمانيا'),
(62334, 3262905504, 3262905511, 'NL', 'NLD', 'هولندا'),
(62335, 3262905512, 3262905519, 'DE', 'DEU', 'ألمانيا'),
(62336, 3262905520, 3262905559, 'NL', 'NLD', 'هولندا'),
(62337, 3262905560, 3262905567, 'DE', 'DEU', 'ألمانيا'),
(62338, 3262905568, 3262905647, 'NL', 'NLD', 'هولندا'),
(62339, 3262905648, 3262905655, 'DE', 'DEU', 'ألمانيا'),
(62340, 3262905656, 3262905751, 'NL', 'NLD', 'هولندا'),
(62341, 3262905752, 3262905759, 'DE', 'DEU', 'ألمانيا'),
(62342, 3262905760, 3262905991, 'NL', 'NLD', 'هولندا'),
(62343, 3262905992, 3262906015, 'DE', 'DEU', 'ألمانيا'),
(62344, 3262906016, 3262906039, 'NL', 'NLD', 'هولندا'),
(62345, 3262906040, 3262906047, 'DE', 'DEU', 'ألمانيا'),
(62346, 3262906048, 3262906103, 'NL', 'NLD', 'هولندا'),
(62347, 3262906104, 3262906111, 'DE', 'DEU', 'ألمانيا'),
(62348, 3262906112, 3262906223, 'NL', 'NLD', 'هولندا'),
(62349, 3262906224, 3262906231, 'DE', 'DEU', 'ألمانيا'),
(62350, 3262906232, 3262906295, 'NL', 'NLD', 'هولندا'),
(62351, 3262906296, 3262906303, 'DE', 'DEU', 'ألمانيا'),
(62352, 3262906304, 3262906327, 'NL', 'NLD', 'هولندا'),
(62353, 3262906328, 3262906343, 'DE', 'DEU', 'ألمانيا'),
(62354, 3262906344, 3262906367, 'NL', 'NLD', 'هولندا'),
(62355, 3262906368, 3262964991, 'CH', 'CHE', 'سويسرا'),
(62356, 3262964992, 3262965247, 'DE', 'DEU', 'ألمانيا'),
(62357, 3262965248, 3262969599, 'CH', 'CHE', 'سويسرا'),
(62358, 3262969856, 3262971903, 'CH', 'CHE', 'سويسرا'),
(62359, 3262971904, 3263029247, 'IE', 'IRL', 'إيرلندا'),
(62360, 3263029248, 3263030271, 'UA', 'UKR', 'أوكرانيا'),
(62361, 3263030272, 3263031295, 'GB', 'GBR', 'المملكة المتحدة'),
(62362, 3263031296, 3263032319, 'TR', 'TUR', 'تركيا'),
(62363, 3263032320, 3263033343, 'RU', 'RUS', 'الإتحاد الروسي'),
(62364, 3263033344, 3263033855, 'LV', 'LVA', 'لاتفيا'),
(62365, 3263033856, 3263034367, 'IT', 'ITA', 'إيطاليا'),
(62366, 3263034368, 3263034879, 'UA', 'UKR', 'أوكرانيا'),
(62367, 3263034880, 3263035391, 'GB', 'GBR', 'المملكة المتحدة'),
(62368, 3263035392, 3263035903, 'UA', 'UKR', 'أوكرانيا'),
(62369, 3263035904, 3263036415, 'CH', 'CHE', 'سويسرا'),
(62370, 3263036416, 3263036927, 'GR', 'GRC', 'اليونان'),
(62371, 3263036928, 3263037439, 'RU', 'RUS', 'الإتحاد الروسي'),
(62372, 3263037440, 3263045631, 'LB', 'LBN', 'لبنان'),
(62373, 3263045632, 3263046847, 'KW', 'KWT', 'الكويت'),
(62374, 3263046848, 3263046911, 'IQ', 'IRQ', 'العراق'),
(62375, 3263046912, 3263047935, 'KW', 'KWT', 'الكويت'),
(62376, 3263047936, 3263048191, 'LB', 'LBN', 'لبنان'),
(62377, 3263048192, 3263053823, 'KW', 'KWT', 'الكويت'),
(62378, 3263053824, 3263062015, 'GB', 'GBR', 'المملكة المتحدة'),
(62379, 3263062016, 3263070207, 'EE', 'EST', 'إستونيا'),
(62380, 3263070208, 3263070719, 'FR', 'FRA', 'فرنسا'),
(62381, 3263070720, 3263070975, 'NL', 'NLD', 'هولندا'),
(62382, 3263070976, 3263071487, 'DE', 'DEU', 'ألمانيا'),
(62383, 3263071488, 3263072255, 'NL', 'NLD', 'هولندا'),
(62384, 3263072256, 3263074303, 'LB', 'LBN', 'لبنان'),
(62385, 3263074304, 3263074815, 'CH', 'CHE', 'سويسرا'),
(62386, 3263074816, 3263075327, 'RO', 'ROM', 'رومانيا'),
(62387, 3263075840, 3263076351, 'SE', 'SWE', 'السويد'),
(62388, 3263076352, 3263076863, 'RO', 'ROM', 'رومانيا'),
(62389, 3263076864, 3263077375, 'IT', 'ITA', 'إيطاليا'),
(62390, 3263077376, 3263077887, 'FR', 'FRA', 'فرنسا'),
(62391, 3263077888, 3263078399, 'DE', 'DEU', 'ألمانيا'),
(62392, 3263078400, 3263079423, 'RO', 'ROM', 'رومانيا'),
(62393, 3263079424, 3263080447, 'PL', 'POL', 'بولندا'),
(62394, 3263080448, 3263081471, 'RU', 'RUS', 'الإتحاد الروسي'),
(62395, 3263081472, 3263082495, 'NL', 'NLD', 'هولندا'),
(62396, 3263082496, 3263083519, 'RO', 'ROM', 'رومانيا'),
(62397, 3263083520, 3263084543, 'UA', 'UKR', 'أوكرانيا'),
(62398, 3263084544, 3263085567, 'RO', 'ROM', 'رومانيا'),
(62399, 3263085568, 3263086591, 'CH', 'CHE', 'سويسرا'),
(62400, 3263086592, 3263086847, 'DK', 'DNK', 'الدنيمارك'),
(62401, 3263086848, 3263087103, 'NL', 'NLD', 'هولندا'),
(62402, 3263087104, 3263087871, 'DE', 'DEU', 'ألمانيا'),
(62403, 3263087872, 3263088127, 'SI', 'SVN', 'سلوفينيا'),
(62404, 3263088128, 3263088639, 'DE', 'DEU', 'ألمانيا'),
(62405, 3263088640, 3263089151, 'CH', 'CHE', 'سويسرا'),
(62406, 3263089152, 3263089407, 'RO', 'ROM', 'رومانيا'),
(62407, 3263089408, 3263089663, 'RU', 'RUS', 'الإتحاد الروسي'),
(62408, 3263089664, 3263089919, 'UA', 'UKR', 'أوكرانيا'),
(62409, 3263089920, 3263090175, 'RO', 'ROM', 'رومانيا'),
(62410, 3263090176, 3263090431, 'DE', 'DEU', 'ألمانيا'),
(62411, 3263090432, 3263090687, 'PL', 'POL', 'بولندا'),
(62412, 3263090688, 3263090943, 'DE', 'DEU', 'ألمانيا'),
(62413, 3263090944, 3263091199, 'GB', 'GBR', 'المملكة المتحدة'),
(62414, 3263091200, 3263091455, 'PL', 'POL', 'بولندا'),
(62415, 3263091456, 3263091711, 'NO', 'NOR', 'النرويج'),
(62416, 3263091712, 3263091967, 'FI', 'FIN', 'فنلندا'),
(62417, 3263091968, 3263092479, 'HR', 'HRV', 'كرواتيا'),
(62418, 3263092480, 3263092735, 'ES', 'ESP', 'إسبانيا'),
(62419, 3263092736, 3263092991, 'PL', 'POL', 'بولندا'),
(62420, 3263092992, 3263093247, 'FR', 'FRA', 'فرنسا'),
(62421, 3263093248, 3263093503, 'CH', 'CHE', 'سويسرا'),
(62422, 3263093504, 3263093759, 'RU', 'RUS', 'الإتحاد الروسي'),
(62423, 3263093760, 3263094015, 'RO', 'ROM', 'رومانيا'),
(62424, 3263094016, 3263094527, 'PL', 'POL', 'بولندا'),
(62425, 3263094528, 3263094783, 'DK', 'DNK', 'الدنيمارك'),
(62426, 3263094784, 3263095039, 'UA', 'UKR', 'أوكرانيا'),
(62427, 3263095040, 3263095295, 'ES', 'ESP', 'إسبانيا'),
(62428, 3263095296, 3263095551, 'FR', 'FRA', 'فرنسا'),
(62429, 3263095552, 3263095807, 'RO', 'ROM', 'رومانيا'),
(62430, 3263095808, 3263096063, 'DE', 'DEU', 'ألمانيا'),
(62431, 3263096064, 3263096319, 'PL', 'POL', 'بولندا'),
(62432, 3263096320, 3263096575, 'TR', 'TUR', 'تركيا'),
(62433, 3263096576, 3263096831, 'SA', 'SAU', 'السعودية'),
(62434, 3263097088, 3263097343, 'FR', 'FRA', 'فرنسا'),
(62435, 3263097344, 3263097599, 'DK', 'DNK', 'الدنيمارك'),
(62436, 3263097600, 3263097855, 'NL', 'NLD', 'هولندا'),
(62437, 3263097856, 3263098111, 'FR', 'FRA', 'فرنسا'),
(62438, 3263098112, 3263098367, 'DE', 'DEU', 'ألمانيا'),
(62439, 3263098368, 3263098623, 'PL', 'POL', 'بولندا'),
(62440, 3263098624, 3263098879, 'DE', 'DEU', 'ألمانيا'),
(62441, 3263098880, 3263099135, 'GB', 'GBR', 'المملكة المتحدة'),
(62442, 3263099136, 3263099391, 'NL', 'NLD', 'هولندا'),
(62443, 3263099392, 3263099903, 'DE', 'DEU', 'ألمانيا'),
(62444, 3263099904, 3263100159, 'RO', 'ROM', 'رومانيا'),
(62445, 3263100160, 3263100415, 'FR', 'FRA', 'فرنسا'),
(62446, 3263100416, 3263100671, 'DE', 'DEU', 'ألمانيا'),
(62447, 3263100672, 3263100927, 'GB', 'GBR', 'المملكة المتحدة'),
(62448, 3263100928, 3263101183, 'AT', 'AUT', 'النمسا'),
(62449, 3263101184, 3263101439, 'SE', 'SWE', 'السويد'),
(62450, 3263101440, 3263101695, 'DK', 'DNK', 'الدنيمارك'),
(62451, 3263101696, 3263101951, 'RU', 'RUS', 'الإتحاد الروسي'),
(62452, 3263101952, 3263102207, 'LT', 'LTU', 'ليتوانيا'),
(62453, 3263102208, 3263102463, 'RO', 'ROM', 'رومانيا'),
(62454, 3263102464, 3263102719, 'PL', 'POL', 'بولندا'),
(62455, 3263102720, 3263102975, 'GR', 'GRC', 'اليونان'),
(62456, 3263102976, 3263128575, 'DE', 'DEU', 'ألمانيا'),
(62457, 3263128832, 3263137791, 'DE', 'DEU', 'ألمانيا'),
(62458, 3263137792, 3263138303, 'PL', 'POL', 'بولندا'),
(62459, 3263138304, 3263138559, 'DE', 'DEU', 'ألمانيا'),
(62460, 3263138560, 3263138815, 'AT', 'AUT', 'النمسا'),
(62461, 3263138816, 3263148543, 'DE', 'DEU', 'ألمانيا'),
(62462, 3263149056, 3263155711, 'DE', 'DEU', 'ألمانيا'),
(62463, 3263155968, 3263168511, 'DE', 'DEU', 'ألمانيا'),
(62464, 3263168512, 3263430655, 'GB', 'GBR', 'المملكة المتحدة'),
(62465, 3263430656, 3263436799, 'SE', 'SWE', 'السويد'),
(62466, 3263436800, 3263437311, 'GB', 'GBR', 'المملكة المتحدة'),
(62467, 3263437312, 3263477759, 'SE', 'SWE', 'السويد'),
(62468, 3263477760, 3263478015, 'JP', 'JPN', 'اليابان'),
(62469, 3263478016, 3263478271, 'AU', 'AUS', 'أستراليا'),
(62470, 3263478272, 3263496191, 'SE', 'SWE', 'السويد'),
(62471, 3263497984, 3263498239, 'GB', 'GBR', 'المملكة المتحدة'),
(62472, 3263498752, 3263498879, 'US', 'USA', 'الولايات المتحدة'),
(62473, 3263498880, 3263498943, 'GB', 'GBR', 'المملكة المتحدة'),
(62474, 3263498960, 3263499007, 'GB', 'GBR', 'المملكة المتحدة'),
(62475, 3263499776, 3263500031, 'FR', 'FRA', 'فرنسا'),
(62476, 3263500032, 3263500287, 'GB', 'GBR', 'المملكة المتحدة'),
(62477, 3263500800, 3263501341, 'GB', 'GBR', 'المملكة المتحدة'),
(62478, 3263501344, 3263501439, 'GB', 'GBR', 'المملكة المتحدة'),
(62479, 3263501440, 3263501503, 'US', 'USA', 'الولايات المتحدة'),
(62480, 3263501504, 3263501519, 'GB', 'GBR', 'المملكة المتحدة'),
(62481, 3263501520, 3263501527, 'IR', 'IRN', 'إيران'),
(62482, 3263501528, 3263501535, 'GB', 'GBR', 'المملكة المتحدة'),
(62483, 3263501536, 3263501551, 'DE', 'DEU', 'ألمانيا'),
(62484, 3263501552, 3263501823, 'GB', 'GBR', 'المملكة المتحدة'),
(62485, 3263501824, 3263502079, 'EG', 'EGY', 'مصر'),
(62486, 3263503104, 3263503167, 'DE', 'DEU', 'ألمانيا'),
(62487, 3263503200, 3263503267, 'DE', 'DEU', 'ألمانيا'),
(62488, 3263503272, 3263503279, 'DE', 'DEU', 'ألمانيا'),
(62489, 3263503296, 3263503359, 'DE', 'DEU', 'ألمانيا'),
(62490, 3263503872, 3263504127, 'GB', 'GBR', 'المملكة المتحدة'),
(62491, 3263504128, 3263504255, 'EG', 'EGY', 'مصر'),
(62492, 3263506688, 3263506815, 'DE', 'DEU', 'ألمانيا'),
(62493, 3263506816, 3263506943, 'US', 'USA', 'الولايات المتحدة'),
(62494, 3263507200, 3263507455, 'US', 'USA', 'الولايات المتحدة'),
(62495, 3263508224, 3263508479, 'GB', 'GBR', 'المملكة المتحدة'),
(62496, 3263509504, 3263509759, 'SE', 'SWE', 'السويد'),
(62497, 3263509760, 3263509791, 'GB', 'GBR', 'المملكة المتحدة'),
(62498, 3263509792, 3263509807, 'IE', 'IRL', 'إيرلندا'),
(62499, 3263509808, 3263509831, 'GB', 'GBR', 'المملكة المتحدة'),
(62500, 3263509832, 3263509839, 'FR', 'FRA', 'فرنسا'),
(62501, 3263509840, 3263509847, 'GB', 'GBR', 'المملكة المتحدة'),
(62502, 3263509848, 3263509887, 'US', 'USA', 'الولايات المتحدة'),
(62503, 3263509888, 3263510023, 'GB', 'GBR', 'المملكة المتحدة'),
(62504, 3263510024, 3263510031, 'BE', 'BEL', 'بلجيكا'),
(62505, 3263510032, 3263510063, 'GB', 'GBR', 'المملكة المتحدة'),
(62506, 3263510064, 3263510079, 'US', 'USA', 'الولايات المتحدة'),
(62507, 3263510080, 3263510271, 'GB', 'GBR', 'المملكة المتحدة'),
(62508, 3263511296, 3263511551, 'GB', 'GBR', 'المملكة المتحدة'),
(62509, 3263512064, 3263512311, 'GB', 'GBR', 'المملكة المتحدة'),
(62510, 3263513344, 3263513599, 'US', 'USA', 'الولايات المتحدة'),
(62511, 3263513856, 3263514111, 'RU', 'RUS', 'الإتحاد الروسي'),
(62512, 3263516672, 3263516927, 'US', 'USA', 'الولايات المتحدة'),
(62513, 3263516928, 3263517183, 'GB', 'GBR', 'المملكة المتحدة'),
(62514, 3263517696, 3263517951, 'US', 'USA', 'الولايات المتحدة'),
(62515, 3263517952, 3263518463, 'GB', 'GBR', 'المملكة المتحدة'),
(62516, 3263518464, 3263518719, 'FR', 'FRA', 'فرنسا'),
(62517, 3263518720, 3263518751, 'IR', 'IRN', 'إيران'),
(62518, 3263518976, 3263519231, 'GB', 'GBR', 'المملكة المتحدة'),
(62519, 3263519744, 3263519759, 'GB', 'GBR', 'المملكة المتحدة'),
(62520, 3263520256, 3263520511, 'FR', 'FRA', 'فرنسا'),
(62521, 3263520512, 3263520767, 'US', 'USA', 'الولايات المتحدة'),
(62522, 3263521792, 3263522047, 'GB', 'GBR', 'المملكة المتحدة'),
(62523, 3263523072, 3263523583, 'DE', 'DEU', 'ألمانيا'),
(62524, 3263525760, 3263525887, 'DE', 'DEU', 'ألمانيا'),
(62525, 3263527424, 3263527679, 'ZW', 'ZWE', 'زمبابواي'),
(62526, 3263527680, 3263527935, 'DE', 'DEU', 'ألمانيا'),
(62527, 3263528192, 3263528447, 'FR', 'FRA', 'فرنسا'),
(62528, 3263528704, 3263528959, 'GB', 'GBR', 'المملكة المتحدة'),
(62529, 3263530496, 3263530751, 'GB', 'GBR', 'المملكة المتحدة'),
(62530, 3263531520, 3263531535, 'DE', 'DEU', 'ألمانيا'),
(62531, 3263531552, 3263531775, 'DE', 'DEU', 'ألمانيا'),
(62532, 3263532544, 3263532799, 'GB', 'GBR', 'المملكة المتحدة'),
(62533, 3263537664, 3263538431, 'TR', 'TUR', 'تركيا'),
(62534, 3263540224, 3263540479, 'TR', 'TUR', 'تركيا'),
(62535, 3263540480, 3263540735, 'GB', 'GBR', 'المملكة المتحدة'),
(62536, 3263541504, 3263541535, 'GB', 'GBR', 'المملكة المتحدة'),
(62537, 3263557632, 3263557887, 'TR', 'TUR', 'تركيا'),
(62538, 3263558656, 3263558911, 'TR', 'TUR', 'تركيا'),
(62539, 3263558912, 3263559679, 'GB', 'GBR', 'المملكة المتحدة'),
(62540, 3263559680, 3263560191, 'TR', 'TUR', 'تركيا'),
(62541, 3263560448, 3263560703, 'TR', 'TUR', 'تركيا'),
(62542, 3263560960, 3263561231, 'TR', 'TUR', 'تركيا'),
(62543, 3263561472, 3263561727, 'TR', 'TUR', 'تركيا'),
(62544, 3263561728, 3263627263, 'NL', 'NLD', 'هولندا'),
(62545, 3263627264, 3263657471, 'RU', 'RUS', 'الإتحاد الروسي'),
(62546, 3263657472, 3263657727, 'KZ', 'KAZ', 'كازاخستان'),
(62547, 3263657728, 3263684351, 'RU', 'RUS', 'الإتحاد الروسي'),
(62548, 3263684352, 3263684607, 'UA', 'UKR', 'أوكرانيا'),
(62549, 3263684608, 3263688959, 'RU', 'RUS', 'الإتحاد الروسي'),
(62550, 3263688960, 3263689215, 'UA', 'UKR', 'أوكرانيا'),
(62551, 3263689216, 3263689471, 'RU', 'RUS', 'الإتحاد الروسي'),
(62552, 3263689472, 3263689727, 'UA', 'UKR', 'أوكرانيا'),
(62553, 3263689728, 3263689983, 'RU', 'RUS', 'الإتحاد الروسي'),
(62554, 3263689984, 3263690239, 'UA', 'UKR', 'أوكرانيا'),
(62555, 3263690240, 3263691007, 'RU', 'RUS', 'الإتحاد الروسي'),
(62556, 3263691008, 3263691263, 'UA', 'UKR', 'أوكرانيا'),
(62557, 3263691264, 3263691775, 'RU', 'RUS', 'الإتحاد الروسي'),
(62558, 3263691776, 3263692031, 'UA', 'UKR', 'أوكرانيا'),
(62559, 3263692032, 3263692287, 'RU', 'RUS', 'الإتحاد الروسي'),
(62560, 3263692288, 3263692799, 'UA', 'UKR', 'أوكرانيا'),
(62561, 3263692800, 3263760127, 'FI', 'FIN', 'فنلندا'),
(62562, 3263760128, 3263760383, 'SE', 'SWE', 'السويد'),
(62563, 3263760384, 3263764991, 'FI', 'FIN', 'فنلندا'),
(62564, 3263764992, 3263765503, 'BE', 'BEL', 'بلجيكا'),
(62565, 3263765504, 3263766975, 'FI', 'FIN', 'فنلندا'),
(62566, 3263766976, 3263767039, 'RU', 'RUS', 'الإتحاد الروسي'),
(62567, 3263767040, 3263773951, 'FI', 'FIN', 'فنلندا'),
(62568, 3263773952, 3263774207, 'BE', 'BEL', 'بلجيكا'),
(62569, 3263774208, 3263774463, 'FI', 'FIN', 'فنلندا'),
(62570, 3263774464, 3263774719, 'BE', 'BEL', 'بلجيكا'),
(62571, 3263774720, 3263792351, 'FI', 'FIN', 'فنلندا'),
(62572, 3263792352, 3263792367, 'SE', 'SWE', 'السويد'),
(62573, 3263792368, 3263793151, 'FI', 'FIN', 'فنلندا'),
(62574, 3263793152, 3263793407, 'BE', 'BEL', 'بلجيكا'),
(62575, 3263793408, 3263816703, 'FI', 'FIN', 'فنلندا'),
(62576, 3263816704, 3263816959, 'ES', 'ESP', 'إسبانيا'),
(62577, 3263816960, 3263817215, 'NL', 'NLD', 'هولندا'),
(62578, 3263817216, 3263823871, 'FI', 'FIN', 'فنلندا'),
(62579, 3263823872, 3263954943, 'DE', 'DEU', 'ألمانيا'),
(62580, 3263954944, 3263979519, 'ES', 'ESP', 'إسبانيا'),
(62581, 3263979520, 3263987711, 'DE', 'DEU', 'ألمانيا'),
(62582, 3263987712, 3264004095, 'ES', 'ESP', 'إسبانيا'),
(62583, 3264004096, 3264012287, 'HU', 'HUN', 'هنغاريا'),
(62584, 3264012288, 3264012543, 'AT', 'AUT', 'النمسا'),
(62585, 3264012544, 3264012799, 'FR', 'FRA', 'فرنسا'),
(62586, 3264012800, 3264013055, 'GB', 'GBR', 'المملكة المتحدة'),
(62587, 3264013056, 3264013311, 'TR', 'TUR', 'تركيا'),
(62588, 3264013312, 3264013567, 'UA', 'UKR', 'أوكرانيا'),
(62589, 3264013568, 3264013823, 'RU', 'RUS', 'الإتحاد الروسي'),
(62590, 3264013824, 3264014079, 'NL', 'NLD', 'هولندا'),
(62591, 3264014080, 3264014335, 'DE', 'DEU', 'ألمانيا'),
(62592, 3264014336, 3264014591, 'PT', 'PRT', 'البورتوغال'),
(62593, 3264014592, 3264014847, 'PL', 'POL', 'بولندا'),
(62594, 3264014848, 3264015103, 'IE', 'IRL', 'إيرلندا'),
(62595, 3264015104, 3264015359, 'RO', 'ROM', 'رومانيا'),
(62596, 3264015360, 3264015615, 'DK', 'DNK', 'الدنيمارك'),
(62597, 3264015616, 3264015871, 'UA', 'UKR', 'أوكرانيا'),
(62598, 3264015872, 3264016127, 'PT', 'PRT', 'البورتوغال'),
(62599, 3264016384, 3264016639, 'SE', 'SWE', 'السويد'),
(62600, 3264016640, 3264016895, 'PL', 'POL', 'بولندا'),
(62601, 3264016896, 3264017151, 'GB', 'GBR', 'المملكة المتحدة'),
(62602, 3264017152, 3264017663, 'SE', 'SWE', 'السويد'),
(62603, 3264017664, 3264017919, 'RO', 'ROM', 'رومانيا'),
(62604, 3264017920, 3264018175, 'NL', 'NLD', 'هولندا'),
(62605, 3264018176, 3264018431, 'FR', 'FRA', 'فرنسا'),
(62606, 3264018432, 3264018687, 'HU', 'HUN', 'هنغاريا'),
(62607, 3264018688, 3264018943, 'GB', 'GBR', 'المملكة المتحدة'),
(62608, 3264018944, 3264019199, 'PL', 'POL', 'بولندا'),
(62609, 3264019200, 3264019967, 'GB', 'GBR', 'المملكة المتحدة'),
(62610, 3264019968, 3264020223, 'AT', 'AUT', 'النمسا'),
(62611, 3264020224, 3264020479, 'PL', 'POL', 'بولندا'),
(62612, 3264020480, 3264086015, 'BG', 'BGR', 'بلغاريا'),
(62613, 3264086016, 3264099839, 'FI', 'FIN', 'فنلندا'),
(62614, 3264099840, 3264100095, 'GB', 'GBR', 'المملكة المتحدة'),
(62615, 3264100096, 3264124927, 'FI', 'FIN', 'فنلندا'),
(62616, 3264124928, 3264125183, 'DE', 'DEU', 'ألمانيا'),
(62617, 3264125184, 3264125439, 'NL', 'NLD', 'هولندا'),
(62618, 3264125440, 3264125695, 'FI', 'FIN', 'فنلندا'),
(62619, 3264125696, 3264125951, 'BE', 'BEL', 'بلجيكا'),
(62620, 3264125952, 3264133375, 'FI', 'FIN', 'فنلندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(62621, 3264133376, 3264133631, 'SE', 'SWE', 'السويد'),
(62622, 3264133632, 3264151551, 'FI', 'FIN', 'فنلندا'),
(62623, 3264151552, 3264184319, 'NO', 'NOR', 'النرويج'),
(62624, 3264184320, 3264184831, 'MD', 'MDA', 'مولدوفا'),
(62625, 3264184832, 3264185343, 'NL', 'NLD', 'هولندا'),
(62626, 3264185344, 3264185855, 'FR', 'FRA', 'فرنسا'),
(62627, 3264185856, 3264186367, 'DE', 'DEU', 'ألمانيا'),
(62628, 3264186368, 3264186879, 'UA', 'UKR', 'أوكرانيا'),
(62629, 3264186880, 3264187391, 'RU', 'RUS', 'الإتحاد الروسي'),
(62630, 3264187392, 3264187903, 'IR', 'IRN', 'إيران'),
(62631, 3264187904, 3264188415, 'IT', 'ITA', 'إيطاليا'),
(62632, 3264188416, 3264189439, 'UA', 'UKR', 'أوكرانيا'),
(62633, 3264189440, 3264190463, 'RU', 'RUS', 'الإتحاد الروسي'),
(62634, 3264190464, 3264190975, 'LV', 'LVA', 'لاتفيا'),
(62635, 3264190976, 3264191487, 'GB', 'GBR', 'المملكة المتحدة'),
(62636, 3264191488, 3264191999, 'DE', 'DEU', 'ألمانيا'),
(62637, 3264192000, 3264200703, 'GB', 'GBR', 'المملكة المتحدة'),
(62638, 3264200704, 3264208895, 'ES', 'ESP', 'إسبانيا'),
(62639, 3264208896, 3264217087, 'HU', 'HUN', 'هنغاريا'),
(62640, 3264217088, 3264282623, 'IS', 'ISL', 'أيسلندا'),
(62641, 3264282624, 3264290815, 'GB', 'GBR', 'المملكة المتحدة'),
(62642, 3264290816, 3264296191, 'FI', 'FIN', 'فنلندا'),
(62643, 3264296192, 3264297727, 'FR', 'FRA', 'فرنسا'),
(62644, 3264297728, 3264298751, 'PT', 'PRT', 'البورتوغال'),
(62645, 3264298752, 3264299007, 'BG', 'BGR', 'بلغاريا'),
(62646, 3264299008, 3264307199, 'DE', 'DEU', 'ألمانيا'),
(62647, 3264307200, 3264311295, 'PL', 'POL', 'بولندا'),
(62648, 3264311296, 3264311551, 'FR', 'FRA', 'فرنسا'),
(62649, 3264311552, 3264311807, 'IT', 'ITA', 'إيطاليا'),
(62650, 3264311808, 3264312063, 'DE', 'DEU', 'ألمانيا'),
(62651, 3264312064, 3264312319, 'CH', 'CHE', 'سويسرا'),
(62652, 3264312320, 3264312575, 'PL', 'POL', 'بولندا'),
(62653, 3264312576, 3264312831, 'UA', 'UKR', 'أوكرانيا'),
(62654, 3264312832, 3264313087, 'DE', 'DEU', 'ألمانيا'),
(62655, 3264313344, 3264313599, 'RO', 'ROM', 'رومانيا'),
(62656, 3264313600, 3264313855, 'PT', 'PRT', 'البورتوغال'),
(62657, 3264313856, 3264314623, 'DE', 'DEU', 'ألمانيا'),
(62658, 3264314624, 3264314879, 'SE', 'SWE', 'السويد'),
(62659, 3264314880, 3264315135, 'GB', 'GBR', 'المملكة المتحدة'),
(62660, 3264315136, 3264315391, 'GR', 'GRC', 'اليونان'),
(62661, 3264315392, 3264317439, 'IE', 'IRL', 'إيرلندا'),
(62662, 3264317440, 3264318463, 'SK', 'SVK', 'سلوفاكيا'),
(62663, 3264318464, 3264318975, 'ES', 'ESP', 'إسبانيا'),
(62664, 3264318976, 3264319487, 'DE', 'DEU', 'ألمانيا'),
(62665, 3264319488, 3264319743, 'FR', 'FRA', 'فرنسا'),
(62666, 3264319744, 3264319999, 'SE', 'SWE', 'السويد'),
(62667, 3264320000, 3264320255, 'DE', 'DEU', 'ألمانيا'),
(62668, 3264320256, 3264321023, 'GB', 'GBR', 'المملكة المتحدة'),
(62669, 3264321024, 3264321535, 'DE', 'DEU', 'ألمانيا'),
(62670, 3264321536, 3264321791, 'SE', 'SWE', 'السويد'),
(62671, 3264321792, 3264322047, 'RS', 'SRB', 'صربيا'),
(62672, 3264322048, 3264322303, 'FR', 'FRA', 'فرنسا'),
(62673, 3264322304, 3264322559, 'RO', 'ROM', 'رومانيا'),
(62674, 3264322560, 3264322815, 'HU', 'HUN', 'هنغاريا'),
(62675, 3264322816, 3264323071, 'CH', 'CHE', 'سويسرا'),
(62676, 3264323072, 3264323327, 'RU', 'RUS', 'الإتحاد الروسي'),
(62677, 3264323328, 3264323583, 'RO', 'ROM', 'رومانيا'),
(62678, 3264323584, 3264324607, 'BG', 'BGR', 'بلغاريا'),
(62679, 3264324608, 3264325631, 'SE', 'SWE', 'السويد'),
(62680, 3264325632, 3264326655, 'RU', 'RUS', 'الإتحاد الروسي'),
(62681, 3264326656, 3264327679, 'SE', 'SWE', 'السويد'),
(62682, 3264327680, 3264328703, 'AT', 'AUT', 'النمسا'),
(62683, 3264328704, 3264329727, 'CZ', 'CZE', 'التشيك'),
(62684, 3264329728, 3264330751, 'PL', 'POL', 'بولندا'),
(62685, 3264330752, 3264331775, 'GB', 'GBR', 'المملكة المتحدة'),
(62686, 3264331776, 3264332287, 'DE', 'DEU', 'ألمانيا'),
(62687, 3264332288, 3264332799, 'NL', 'NLD', 'هولندا'),
(62688, 3264332800, 3264333311, 'GB', 'GBR', 'المملكة المتحدة'),
(62689, 3264333312, 3264333823, 'UA', 'UKR', 'أوكرانيا'),
(62690, 3264333824, 3264334335, 'NL', 'NLD', 'هولندا'),
(62691, 3264334848, 3264335359, 'PL', 'POL', 'بولندا'),
(62692, 3264335360, 3264335871, 'SK', 'SVK', 'سلوفاكيا'),
(62693, 3264335872, 3264336383, 'CY', 'CYP', 'قبرص'),
(62694, 3264336384, 3264336895, 'GB', 'GBR', 'المملكة المتحدة'),
(62695, 3264336896, 3264337407, 'RU', 'RUS', 'الإتحاد الروسي'),
(62696, 3264337408, 3264338431, 'UA', 'UKR', 'أوكرانيا'),
(62697, 3264338432, 3264338943, 'DE', 'DEU', 'ألمانيا'),
(62698, 3264338944, 3264339455, 'UA', 'UKR', 'أوكرانيا'),
(62699, 3264339456, 3264339967, 'GB', 'GBR', 'المملكة المتحدة'),
(62700, 3264339968, 3264340223, 'DE', 'DEU', 'ألمانيا'),
(62701, 3264340224, 3264340479, 'PL', 'POL', 'بولندا'),
(62702, 3264340480, 3264340735, 'DE', 'DEU', 'ألمانيا'),
(62703, 3264340736, 3264340991, 'UA', 'UKR', 'أوكرانيا'),
(62704, 3264340992, 3264341503, 'PL', 'POL', 'بولندا'),
(62705, 3264341504, 3264341759, 'DE', 'DEU', 'ألمانيا'),
(62706, 3264341760, 3264342015, 'IT', 'ITA', 'إيطاليا'),
(62707, 3264342016, 3264342783, 'DE', 'DEU', 'ألمانيا'),
(62708, 3264342784, 3264343039, 'ES', 'ESP', 'إسبانيا'),
(62709, 3264343040, 3264343295, 'DE', 'DEU', 'ألمانيا'),
(62710, 3264343296, 3264343551, 'GB', 'GBR', 'المملكة المتحدة'),
(62711, 3264343552, 3264343807, 'RO', 'ROM', 'رومانيا'),
(62712, 3264343808, 3264344063, 'DE', 'DEU', 'ألمانيا'),
(62713, 3264344064, 3264345087, 'GB', 'GBR', 'المملكة المتحدة'),
(62714, 3264345088, 3264346111, 'NL', 'NLD', 'هولندا'),
(62715, 3264346112, 3264347135, 'SE', 'SWE', 'السويد'),
(62716, 3264347136, 3264348159, 'DE', 'DEU', 'ألمانيا'),
(62717, 3264348160, 3264350463, 'FR', 'FRA', 'فرنسا'),
(62718, 3264350720, 3264372223, 'FR', 'FRA', 'فرنسا'),
(62719, 3264372736, 3264375039, 'FR', 'FRA', 'فرنسا'),
(62720, 3264375040, 3264376063, 'SE', 'SWE', 'السويد'),
(62721, 3264376064, 3264376319, 'HR', 'HRV', 'كرواتيا'),
(62722, 3264376320, 3264376575, 'UA', 'UKR', 'أوكرانيا'),
(62723, 3264376576, 3264376831, 'CH', 'CHE', 'سويسرا'),
(62724, 3264376832, 3264377087, 'UA', 'UKR', 'أوكرانيا'),
(62725, 3264377088, 3264377343, 'RU', 'RUS', 'الإتحاد الروسي'),
(62726, 3264377344, 3264377599, 'IT', 'ITA', 'إيطاليا'),
(62727, 3264377600, 3264378111, 'RU', 'RUS', 'الإتحاد الروسي'),
(62728, 3264378112, 3264378367, 'SE', 'SWE', 'السويد'),
(62729, 3264378368, 3264378623, 'DE', 'DEU', 'ألمانيا'),
(62730, 3264378624, 3264378879, 'RU', 'RUS', 'الإتحاد الروسي'),
(62731, 3264378880, 3264379135, 'PL', 'POL', 'بولندا'),
(62732, 3264379136, 3264379391, 'BE', 'BEL', 'بلجيكا'),
(62733, 3264379392, 3264379647, 'RU', 'RUS', 'الإتحاد الروسي'),
(62734, 3264379648, 3264380159, 'DE', 'DEU', 'ألمانيا'),
(62735, 3264380160, 3264380415, 'RO', 'ROM', 'رومانيا'),
(62736, 3264380416, 3264380671, 'CH', 'CHE', 'سويسرا'),
(62737, 3264380672, 3264380927, 'NL', 'NLD', 'هولندا'),
(62738, 3264380928, 3264381951, 'PL', 'POL', 'بولندا'),
(62739, 3264381952, 3264385023, 'UA', 'UKR', 'أوكرانيا'),
(62740, 3264385024, 3264386047, 'DE', 'DEU', 'ألمانيا'),
(62741, 3264386048, 3264387071, 'IR', 'IRN', 'إيران'),
(62742, 3264387072, 3264388095, 'LB', 'LBN', 'لبنان'),
(62743, 3264388096, 3264389119, 'UA', 'UKR', 'أوكرانيا'),
(62744, 3264390144, 3264391167, 'IR', 'IRN', 'إيران'),
(62745, 3264391168, 3264392191, 'SE', 'SWE', 'السويد'),
(62746, 3264392192, 3264393215, 'FR', 'FRA', 'فرنسا'),
(62747, 3264393216, 3264394239, 'DE', 'DEU', 'ألمانيا'),
(62748, 3264394240, 3264395263, 'UA', 'UKR', 'أوكرانيا'),
(62749, 3264395264, 3264396287, 'AT', 'AUT', 'النمسا'),
(62750, 3264396288, 3264397311, 'UA', 'UKR', 'أوكرانيا'),
(62751, 3264397312, 3264398335, 'GB', 'GBR', 'المملكة المتحدة'),
(62752, 3264398336, 3264399359, 'UA', 'UKR', 'أوكرانيا'),
(62753, 3264399360, 3264400383, 'RU', 'RUS', 'الإتحاد الروسي'),
(62754, 3264400384, 3264401407, 'PA', 'PAN', 'بنما'),
(62755, 3264401408, 3264402431, 'DE', 'DEU', 'ألمانيا'),
(62756, 3264402432, 3264403455, 'CH', 'CHE', 'سويسرا'),
(62757, 3264403456, 3264404479, 'PL', 'POL', 'بولندا'),
(62758, 3264404480, 3264405503, 'UA', 'UKR', 'أوكرانيا'),
(62759, 3264405504, 3264406527, 'FR', 'FRA', 'فرنسا'),
(62760, 3264406528, 3264407551, 'UA', 'UKR', 'أوكرانيا'),
(62761, 3264407552, 3264408575, 'BG', 'BGR', 'بلغاريا'),
(62762, 3264408576, 3264409599, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(62763, 3264409600, 3264410623, 'RU', 'RUS', 'الإتحاد الروسي'),
(62764, 3264410624, 3264411647, 'NO', 'NOR', 'النرويج'),
(62765, 3264411648, 3264413695, 'PL', 'POL', 'بولندا'),
(62766, 3264417536, 3264431103, 'CH', 'CHE', 'سويسرا'),
(62767, 3264431104, 3264431615, 'LI', 'LIE', 'ليختنشتاين'),
(62768, 3264431616, 3264439039, 'CH', 'CHE', 'سويسرا'),
(62769, 3264439296, 3264439807, 'CH', 'CHE', 'سويسرا'),
(62770, 3264440320, 3264441599, 'CH', 'CHE', 'سويسرا'),
(62771, 3264442112, 3264445439, 'CH', 'CHE', 'سويسرا'),
(62772, 3264446208, 3264446463, 'FR', 'FRA', 'فرنسا'),
(62773, 3264446464, 3264456191, 'CH', 'CHE', 'سويسرا'),
(62774, 3264456704, 3264476671, 'CH', 'CHE', 'سويسرا'),
(62775, 3264477696, 3264483071, 'CH', 'CHE', 'سويسرا'),
(62776, 3264483072, 3264483327, 'LI', 'LIE', 'ليختنشتاين'),
(62777, 3264483328, 3264486527, 'CH', 'CHE', 'سويسرا'),
(62778, 3264486528, 3264486559, 'LI', 'LIE', 'ليختنشتاين'),
(62779, 3264486560, 3264494079, 'CH', 'CHE', 'سويسرا'),
(62780, 3264494080, 3264494335, 'US', 'USA', 'الولايات المتحدة'),
(62781, 3264494336, 3264544767, 'CH', 'CHE', 'سويسرا'),
(62782, 3264544768, 3264561151, 'HU', 'HUN', 'هنغاريا'),
(62783, 3264561152, 3264562687, 'RU', 'RUS', 'الإتحاد الروسي'),
(62784, 3264562944, 3264563183, 'RU', 'RUS', 'الإتحاد الروسي'),
(62785, 3264563200, 3264564223, 'ES', 'ESP', 'إسبانيا'),
(62786, 3264564224, 3264565247, 'IE', 'IRL', 'إيرلندا'),
(62787, 3264565248, 3264567295, 'NL', 'NLD', 'هولندا'),
(62788, 3264567296, 3264567551, 'PL', 'POL', 'بولندا'),
(62789, 3264567552, 3264567807, 'GB', 'GBR', 'المملكة المتحدة'),
(62790, 3264567808, 3264568319, 'RU', 'RUS', 'الإتحاد الروسي'),
(62791, 3264568576, 3264568831, 'RU', 'RUS', 'الإتحاد الروسي'),
(62792, 3264569088, 3264569343, 'RU', 'RUS', 'الإتحاد الروسي'),
(62793, 3264569344, 3264577535, 'CZ', 'CZE', 'التشيك'),
(62794, 3264577536, 3264585727, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(62795, 3264585728, 3264593919, 'FR', 'FRA', 'فرنسا'),
(62796, 3264593920, 3264602111, 'ES', 'ESP', 'إسبانيا'),
(62797, 3264602112, 3264603135, 'RU', 'RUS', 'الإتحاد الروسي'),
(62798, 3264603136, 3264604159, 'PL', 'POL', 'بولندا'),
(62799, 3264604160, 3264604671, 'IT', 'ITA', 'إيطاليا'),
(62800, 3264604672, 3264605183, 'RU', 'RUS', 'الإتحاد الروسي'),
(62801, 3264605184, 3264605695, 'GR', 'GRC', 'اليونان'),
(62802, 3264605696, 3264606207, 'DK', 'DNK', 'الدنيمارك'),
(62803, 3264606208, 3264606463, 'PL', 'POL', 'بولندا'),
(62804, 3264606464, 3264606719, 'DE', 'DEU', 'ألمانيا'),
(62805, 3264606720, 3264606975, 'FR', 'FRA', 'فرنسا'),
(62806, 3264606976, 3264607231, 'BE', 'BEL', 'بلجيكا'),
(62807, 3264607232, 3264607487, 'IT', 'ITA', 'إيطاليا'),
(62808, 3264607488, 3264610303, 'DE', 'DEU', 'ألمانيا'),
(62809, 3264610304, 3264611583, 'GB', 'GBR', 'المملكة المتحدة'),
(62810, 3264611584, 3264612095, 'FR', 'FRA', 'فرنسا'),
(62811, 3264612096, 3264612351, 'GB', 'GBR', 'المملكة المتحدة'),
(62812, 3264612352, 3264612479, 'FR', 'FRA', 'فرنسا'),
(62813, 3264612480, 3264612511, 'GB', 'GBR', 'المملكة المتحدة'),
(62814, 3264612512, 3264612591, 'FR', 'FRA', 'فرنسا'),
(62815, 3264612592, 3264613119, 'GB', 'GBR', 'المملكة المتحدة'),
(62816, 3264613120, 3264614399, 'FR', 'FRA', 'فرنسا'),
(62817, 3264614400, 3264614431, 'GB', 'GBR', 'المملكة المتحدة'),
(62818, 3264614432, 3264614447, 'FR', 'FRA', 'فرنسا'),
(62819, 3264614448, 3264614463, 'GB', 'GBR', 'المملكة المتحدة'),
(62820, 3264614464, 3264614527, 'FR', 'FRA', 'فرنسا'),
(62821, 3264614528, 3264614559, 'GB', 'GBR', 'المملكة المتحدة'),
(62822, 3264614560, 3264614591, 'FR', 'FRA', 'فرنسا'),
(62823, 3264614592, 3264614623, 'GB', 'GBR', 'المملكة المتحدة'),
(62824, 3264614624, 3264614655, 'FR', 'FRA', 'فرنسا'),
(62825, 3264614656, 3264615935, 'GB', 'GBR', 'المملكة المتحدة'),
(62826, 3264615936, 3264615999, 'FR', 'FRA', 'فرنسا'),
(62827, 3264616000, 3264616095, 'GB', 'GBR', 'المملكة المتحدة'),
(62828, 3264616096, 3264616159, 'FR', 'FRA', 'فرنسا'),
(62829, 3264616160, 3264616191, 'GB', 'GBR', 'المملكة المتحدة'),
(62830, 3264616192, 3264616511, 'FR', 'FRA', 'فرنسا'),
(62831, 3264616512, 3264616575, 'GB', 'GBR', 'المملكة المتحدة'),
(62832, 3264616576, 3264616591, 'FR', 'FRA', 'فرنسا'),
(62833, 3264616592, 3264616639, 'GB', 'GBR', 'المملكة المتحدة'),
(62834, 3264616640, 3264616655, 'FR', 'FRA', 'فرنسا'),
(62835, 3264616656, 3264616671, 'GB', 'GBR', 'المملكة المتحدة'),
(62836, 3264616672, 3264616687, 'FR', 'FRA', 'فرنسا'),
(62837, 3264616688, 3264616959, 'GB', 'GBR', 'المملكة المتحدة'),
(62838, 3264616960, 3264617215, 'FR', 'FRA', 'فرنسا'),
(62839, 3264617216, 3264617311, 'GB', 'GBR', 'المملكة المتحدة'),
(62840, 3264617312, 3264617983, 'FR', 'FRA', 'فرنسا'),
(62841, 3264617984, 3264618751, 'GB', 'GBR', 'المملكة المتحدة'),
(62842, 3264618752, 3264619007, 'FR', 'FRA', 'فرنسا'),
(62843, 3264619008, 3264619519, 'GB', 'GBR', 'المملكة المتحدة'),
(62844, 3264619520, 3264619551, 'FR', 'FRA', 'فرنسا'),
(62845, 3264619552, 3264619583, 'GB', 'GBR', 'المملكة المتحدة'),
(62846, 3264619584, 3264619615, 'FR', 'FRA', 'فرنسا'),
(62847, 3264619616, 3264619775, 'GB', 'GBR', 'المملكة المتحدة'),
(62848, 3264619776, 3264620031, 'FR', 'FRA', 'فرنسا'),
(62849, 3264620032, 3264620159, 'GB', 'GBR', 'المملكة المتحدة'),
(62850, 3264620160, 3264620191, 'FR', 'FRA', 'فرنسا'),
(62851, 3264620192, 3264620543, 'GB', 'GBR', 'المملكة المتحدة'),
(62852, 3264620544, 3264620927, 'FR', 'FRA', 'فرنسا'),
(62853, 3264620928, 3264621567, 'GB', 'GBR', 'المملكة المتحدة'),
(62854, 3264621568, 3264621823, 'FR', 'FRA', 'فرنسا'),
(62855, 3264621824, 3264626687, 'GB', 'GBR', 'المملكة المتحدة'),
(62856, 3264626688, 3264627711, 'EE', 'EST', 'إستونيا'),
(62857, 3264627712, 3264628735, 'GR', 'GRC', 'اليونان'),
(62858, 3264628736, 3264630783, 'UA', 'UKR', 'أوكرانيا'),
(62859, 3264630784, 3264631807, 'DE', 'DEU', 'ألمانيا'),
(62860, 3264631808, 3264632831, 'RO', 'ROM', 'رومانيا'),
(62861, 3264632832, 3264633855, 'RU', 'RUS', 'الإتحاد الروسي'),
(62862, 3264633856, 3264634879, 'UA', 'UKR', 'أوكرانيا'),
(62863, 3264634880, 3264636927, 'PL', 'POL', 'بولندا'),
(62864, 3264636928, 3264637951, 'RU', 'RUS', 'الإتحاد الروسي'),
(62865, 3264637952, 3264639999, 'DK', 'DNK', 'الدنيمارك'),
(62866, 3264640000, 3264641023, 'BG', 'BGR', 'بلغاريا'),
(62867, 3264641024, 3264642047, 'GB', 'GBR', 'المملكة المتحدة'),
(62868, 3264642048, 3264651263, 'RU', 'RUS', 'الإتحاد الروسي'),
(62869, 3264651264, 3264651775, 'CH', 'CHE', 'سويسرا'),
(62870, 3264651776, 3264652287, 'IT', 'ITA', 'إيطاليا'),
(62871, 3264652288, 3264652799, 'RU', 'RUS', 'الإتحاد الروسي'),
(62872, 3264652800, 3264653311, 'PL', 'POL', 'بولندا'),
(62873, 3264653312, 3264653823, 'DE', 'DEU', 'ألمانيا'),
(62874, 3264654336, 3264654847, 'DE', 'DEU', 'ألمانيا'),
(62875, 3264654848, 3264655359, 'UA', 'UKR', 'أوكرانيا'),
(62876, 3264655360, 3264655871, 'GB', 'GBR', 'المملكة المتحدة'),
(62877, 3264655872, 3264656383, 'RU', 'RUS', 'الإتحاد الروسي'),
(62878, 3264656384, 3264656895, 'BG', 'BGR', 'بلغاريا'),
(62879, 3264656896, 3264657407, 'GB', 'GBR', 'المملكة المتحدة'),
(62880, 3264657408, 3264657919, 'PL', 'POL', 'بولندا'),
(62881, 3264657920, 3264658431, 'RO', 'ROM', 'رومانيا'),
(62882, 3264658432, 3264659455, 'DE', 'DEU', 'ألمانيا'),
(62883, 3264659456, 3264659967, 'UA', 'UKR', 'أوكرانيا'),
(62884, 3264659968, 3264660479, 'GB', 'GBR', 'المملكة المتحدة'),
(62885, 3264660480, 3264660991, 'PL', 'POL', 'بولندا'),
(62886, 3264660992, 3264661503, 'CH', 'CHE', 'سويسرا'),
(62887, 3264661504, 3264662015, 'GB', 'GBR', 'المملكة المتحدة'),
(62888, 3264662016, 3264662527, 'RU', 'RUS', 'الإتحاد الروسي'),
(62889, 3264662528, 3264663039, 'UA', 'UKR', 'أوكرانيا'),
(62890, 3264663040, 3264663551, 'PL', 'POL', 'بولندا'),
(62891, 3264663552, 3264664063, 'NL', 'NLD', 'هولندا'),
(62892, 3264664064, 3264664575, 'DE', 'DEU', 'ألمانيا'),
(62893, 3264664576, 3264665087, 'NO', 'NOR', 'النرويج'),
(62894, 3264665088, 3264665599, 'SE', 'SWE', 'السويد'),
(62895, 3264665600, 3264666111, 'RO', 'ROM', 'رومانيا'),
(62896, 3264666112, 3264666623, 'IL', 'ISR', 'إسرائيل'),
(62897, 3264666624, 3264667135, 'UA', 'UKR', 'أوكرانيا'),
(62898, 3264667136, 3264667647, 'SE', 'SWE', 'السويد'),
(62899, 3264667648, 3264668159, 'BE', 'BEL', 'بلجيكا'),
(62900, 3264668160, 3264669183, 'DE', 'DEU', 'ألمانيا'),
(62901, 3264669184, 3264669695, 'PL', 'POL', 'بولندا'),
(62902, 3264669696, 3264670207, 'UA', 'UKR', 'أوكرانيا'),
(62903, 3264670208, 3264670719, 'RU', 'RUS', 'الإتحاد الروسي'),
(62904, 3264670720, 3264671231, 'FR', 'FRA', 'فرنسا'),
(62905, 3264671232, 3264671743, 'PL', 'POL', 'بولندا'),
(62906, 3264671744, 3264672255, 'DE', 'DEU', 'ألمانيا'),
(62907, 3264672256, 3264672767, 'RO', 'ROM', 'رومانيا'),
(62908, 3264672768, 3264673279, 'CH', 'CHE', 'سويسرا'),
(62909, 3264673280, 3264673791, 'PL', 'POL', 'بولندا'),
(62910, 3264673792, 3264674303, 'CH', 'CHE', 'سويسرا'),
(62911, 3264674304, 3264674815, 'PL', 'POL', 'بولندا'),
(62912, 3264674816, 3264675327, 'GB', 'GBR', 'المملكة المتحدة'),
(62913, 3264675328, 3264675839, 'RU', 'RUS', 'الإتحاد الروسي'),
(62914, 3264675840, 3264741375, 'NL', 'NLD', 'هولندا'),
(62915, 3264741376, 3264749567, 'SI', 'SVN', 'سلوفينيا'),
(62916, 3264749568, 3264750079, 'LV', 'LVA', 'لاتفيا'),
(62917, 3264750080, 3264750591, 'RU', 'RUS', 'الإتحاد الروسي'),
(62918, 3264750592, 3264751103, 'KG', 'KGZ', 'قيرغيزستان'),
(62919, 3264751104, 3264751615, 'DK', 'DNK', 'الدنيمارك'),
(62920, 3264751616, 3264752127, 'GB', 'GBR', 'المملكة المتحدة'),
(62921, 3264752128, 3264752639, 'RO', 'ROM', 'رومانيا'),
(62922, 3264752640, 3264753151, 'NL', 'NLD', 'هولندا'),
(62923, 3264753152, 3264753663, 'PL', 'POL', 'بولندا'),
(62924, 3264753664, 3264754175, 'IT', 'ITA', 'إيطاليا'),
(62925, 3264754176, 3264754687, 'PL', 'POL', 'بولندا'),
(62926, 3264754688, 3264755199, 'RU', 'RUS', 'الإتحاد الروسي'),
(62927, 3264755200, 3264755711, 'DE', 'DEU', 'ألمانيا'),
(62928, 3264755712, 3264756223, 'PL', 'POL', 'بولندا'),
(62929, 3264756224, 3264756735, 'FI', 'FIN', 'فنلندا'),
(62930, 3264756736, 3264757247, 'PL', 'POL', 'بولندا'),
(62931, 3264757248, 3264757759, 'RU', 'RUS', 'الإتحاد الروسي'),
(62932, 3264757760, 3264765951, 'GB', 'GBR', 'المملكة المتحدة'),
(62933, 3264765952, 3264774143, 'AT', 'AUT', 'النمسا'),
(62934, 3264774144, 3264782335, 'HU', 'HUN', 'هنغاريا'),
(62935, 3264782336, 3264790527, 'AT', 'AUT', 'النمسا'),
(62936, 3264790528, 3264806911, 'HR', 'HRV', 'كرواتيا'),
(62937, 3264806912, 3264815103, 'GB', 'GBR', 'المملكة المتحدة'),
(62938, 3264815104, 3264825343, 'SE', 'SWE', 'السويد'),
(62939, 3264825344, 3264825599, 'NO', 'NOR', 'النرويج'),
(62940, 3264825600, 3264825855, 'IT', 'ITA', 'إيطاليا'),
(62941, 3264825856, 3264826111, 'NL', 'NLD', 'هولندا'),
(62942, 3264826112, 3264826879, 'GB', 'GBR', 'المملكة المتحدة'),
(62943, 3264826880, 3264827135, 'NL', 'NLD', 'هولندا'),
(62944, 3264827136, 3264827391, 'LV', 'LVA', 'لاتفيا'),
(62945, 3264827392, 3264827647, 'FR', 'FRA', 'فرنسا'),
(62946, 3264827648, 3264828159, 'GR', 'GRC', 'اليونان'),
(62947, 3264828160, 3264828415, 'CH', 'CHE', 'سويسرا'),
(62948, 3264828416, 3264828671, 'SE', 'SWE', 'السويد'),
(62949, 3264828672, 3264828927, 'MT', 'MLT', 'مالطا'),
(62950, 3264828928, 3264829439, 'DE', 'DEU', 'ألمانيا'),
(62951, 3264829440, 3264830207, 'FR', 'FRA', 'فرنسا'),
(62952, 3264830208, 3264830463, 'SE', 'SWE', 'السويد'),
(62953, 3264830464, 3264830719, 'FR', 'FRA', 'فرنسا'),
(62954, 3264830720, 3264830975, 'AT', 'AUT', 'النمسا'),
(62955, 3264830976, 3264831231, 'CH', 'CHE', 'سويسرا'),
(62956, 3264831232, 3264831487, 'PL', 'POL', 'بولندا'),
(62957, 3264831488, 3264831743, 'CH', 'CHE', 'سويسرا'),
(62958, 3264831744, 3264831999, 'FR', 'FRA', 'فرنسا'),
(62959, 3264832000, 3264832255, 'AT', 'AUT', 'النمسا'),
(62960, 3264832256, 3264832511, 'IT', 'ITA', 'إيطاليا'),
(62961, 3264832512, 3264832767, 'DE', 'DEU', 'ألمانيا'),
(62962, 3264832768, 3264833023, 'IL', 'ISR', 'إسرائيل'),
(62963, 3264833024, 3264833535, 'IT', 'ITA', 'إيطاليا'),
(62964, 3264833536, 3264834047, 'DE', 'DEU', 'ألمانيا'),
(62965, 3264834048, 3264834559, 'GB', 'GBR', 'المملكة المتحدة'),
(62966, 3264834560, 3264835327, 'FR', 'FRA', 'فرنسا'),
(62967, 3264835328, 3264835583, 'AT', 'AUT', 'النمسا'),
(62968, 3264835584, 3264835839, 'RU', 'RUS', 'الإتحاد الروسي'),
(62969, 3264835840, 3264836351, 'DE', 'DEU', 'ألمانيا'),
(62970, 3264836352, 3264836607, 'PL', 'POL', 'بولندا'),
(62971, 3264836608, 3264836863, 'DE', 'DEU', 'ألمانيا'),
(62972, 3264836864, 3264837119, 'NL', 'NLD', 'هولندا'),
(62973, 3264837120, 3264837375, 'BG', 'BGR', 'بلغاريا'),
(62974, 3264837376, 3264837631, 'PL', 'POL', 'بولندا'),
(62975, 3264837632, 3264839679, 'AT', 'AUT', 'النمسا'),
(62976, 3264839680, 3264840191, 'UA', 'UKR', 'أوكرانيا'),
(62977, 3264840192, 3264840447, 'DE', 'DEU', 'ألمانيا'),
(62978, 3264840448, 3264840703, 'IT', 'ITA', 'إيطاليا'),
(62979, 3264840704, 3264840959, 'PT', 'PRT', 'البورتوغال'),
(62980, 3264840960, 3264841471, 'PL', 'POL', 'بولندا'),
(62981, 3264841472, 3264841727, 'LV', 'LVA', 'لاتفيا'),
(62982, 3264841728, 3264844031, 'GB', 'GBR', 'المملكة المتحدة'),
(62983, 3264844032, 3264844287, 'BG', 'BGR', 'بلغاريا'),
(62984, 3264844288, 3264844799, 'DE', 'DEU', 'ألمانيا'),
(62985, 3264844800, 3264845311, 'UA', 'UKR', 'أوكرانيا'),
(62986, 3264845312, 3264845951, 'DE', 'DEU', 'ألمانيا'),
(62987, 3264845952, 3264846079, 'GB', 'GBR', 'المملكة المتحدة'),
(62988, 3264846080, 3264846207, 'UG', 'UGA', 'أوغاندا'),
(62989, 3264846208, 3264846335, 'PL', 'POL', 'بولندا'),
(62990, 3264846464, 3264846591, 'NO', 'NOR', 'النرويج'),
(62991, 3264846592, 3264846719, 'US', 'USA', 'الولايات المتحدة'),
(62992, 3264846720, 3264846847, 'RU', 'RUS', 'الإتحاد الروسي'),
(62993, 3264846848, 3264846911, 'DK', 'DNK', 'الدنيمارك'),
(62994, 3264847040, 3264847103, 'GB', 'GBR', 'المملكة المتحدة'),
(62995, 3264847104, 3264847135, 'FR', 'FRA', 'فرنسا'),
(62996, 3264847136, 3264847167, 'ES', 'ESP', 'إسبانيا'),
(62997, 3264847168, 3264847199, 'IE', 'IRL', 'إيرلندا'),
(62998, 3264847200, 3264847231, 'NO', 'NOR', 'النرويج'),
(62999, 3264847264, 3264847295, 'LI', 'LIE', 'ليختنشتاين'),
(63000, 3264847328, 3264847359, 'NL', 'NLD', 'هولندا'),
(63001, 3264847360, 3264847487, 'FR', 'FRA', 'فرنسا'),
(63002, 3264847488, 3264847615, 'RU', 'RUS', 'الإتحاد الروسي'),
(63003, 3264847616, 3264847679, 'PL', 'POL', 'بولندا'),
(63004, 3264847744, 3264847807, 'BE', 'BEL', 'بلجيكا'),
(63005, 3264847808, 3264847871, 'SE', 'SWE', 'السويد'),
(63006, 3264847872, 3264849919, 'DE', 'DEU', 'ألمانيا'),
(63007, 3264849920, 3264850431, 'GB', 'GBR', 'المملكة المتحدة'),
(63008, 3264850432, 3264850687, 'PL', 'POL', 'بولندا'),
(63009, 3264850688, 3264850943, 'LV', 'LVA', 'لاتفيا'),
(63010, 3264850944, 3264851967, 'IT', 'ITA', 'إيطاليا'),
(63011, 3264851968, 3264854015, 'CH', 'CHE', 'سويسرا'),
(63012, 3264854016, 3264854527, 'DE', 'DEU', 'ألمانيا'),
(63013, 3264854528, 3264854783, 'RU', 'RUS', 'الإتحاد الروسي'),
(63014, 3264854784, 3264855039, 'IT', 'ITA', 'إيطاليا'),
(63015, 3264855040, 3264855551, 'CH', 'CHE', 'سويسرا'),
(63016, 3264855552, 3264856063, 'DE', 'DEU', 'ألمانيا'),
(63017, 3264856064, 3264861695, 'IT', 'ITA', 'إيطاليا'),
(63018, 3264861696, 3264862207, 'FR', 'FRA', 'فرنسا'),
(63019, 3264862208, 3264862463, 'PL', 'POL', 'بولندا'),
(63020, 3264862464, 3264862719, 'AT', 'AUT', 'النمسا'),
(63021, 3264862720, 3264862975, 'GB', 'GBR', 'المملكة المتحدة'),
(63022, 3264862976, 3264863231, 'DE', 'DEU', 'ألمانيا'),
(63023, 3264863232, 3264864255, 'AT', 'AUT', 'النمسا'),
(63024, 3264864256, 3264872447, 'RO', 'ROM', 'رومانيا'),
(63025, 3264872448, 3264888831, 'GB', 'GBR', 'المملكة المتحدة'),
(63026, 3264888832, 3264897023, 'RU', 'RUS', 'الإتحاد الروسي'),
(63027, 3264897024, 3264905215, 'GB', 'GBR', 'المملكة المتحدة'),
(63028, 3264905216, 3264906255, 'CY', 'CYP', 'قبرص'),
(63029, 3264906256, 3264906263, 'GR', 'GRC', 'اليونان'),
(63030, 3264906264, 3264906287, 'CY', 'CYP', 'قبرص'),
(63031, 3264906288, 3264906291, 'GR', 'GRC', 'اليونان'),
(63032, 3264906292, 3264906295, 'CY', 'CYP', 'قبرص'),
(63033, 3264906296, 3264906303, 'GR', 'GRC', 'اليونان'),
(63034, 3264906304, 3264906323, 'CY', 'CYP', 'قبرص'),
(63035, 3264906324, 3264906327, 'GR', 'GRC', 'اليونان'),
(63036, 3264906328, 3264906332, 'CY', 'CYP', 'قبرص'),
(63037, 3264906333, 3264906335, 'GR', 'GRC', 'اليونان'),
(63038, 3264906336, 3264906339, 'CY', 'CYP', 'قبرص'),
(63039, 3264906340, 3264906351, 'GR', 'GRC', 'اليونان'),
(63040, 3264906352, 3264906367, 'CY', 'CYP', 'قبرص'),
(63041, 3264906368, 3264906411, 'GR', 'GRC', 'اليونان'),
(63042, 3264906412, 3264906423, 'CY', 'CYP', 'قبرص'),
(63043, 3264906424, 3264906435, 'GR', 'GRC', 'اليونان'),
(63044, 3264906436, 3264906495, 'CY', 'CYP', 'قبرص'),
(63045, 3264906496, 3264906623, 'GR', 'GRC', 'اليونان'),
(63046, 3264906624, 3264906751, 'CY', 'CYP', 'قبرص'),
(63047, 3264906752, 3264906761, 'GR', 'GRC', 'اليونان'),
(63048, 3264906762, 3264906879, 'CY', 'CYP', 'قبرص'),
(63049, 3264906880, 3264906895, 'GR', 'GRC', 'اليونان'),
(63050, 3264906896, 3264906911, 'CY', 'CYP', 'قبرص'),
(63051, 3264906912, 3264906919, 'GR', 'GRC', 'اليونان'),
(63052, 3264906920, 3264906983, 'CY', 'CYP', 'قبرص'),
(63053, 3264906984, 3264906995, 'GR', 'GRC', 'اليونان'),
(63054, 3264906996, 3264907135, 'CY', 'CYP', 'قبرص'),
(63055, 3264907136, 3264907143, 'GR', 'GRC', 'اليونان'),
(63056, 3264907144, 3264907151, 'CY', 'CYP', 'قبرص'),
(63057, 3264907152, 3264907155, 'GR', 'GRC', 'اليونان'),
(63058, 3264907156, 3264907639, 'CY', 'CYP', 'قبرص'),
(63059, 3264907640, 3264907647, 'GR', 'GRC', 'اليونان'),
(63060, 3264907648, 3264907663, 'CY', 'CYP', 'قبرص'),
(63061, 3264907664, 3264907671, 'GR', 'GRC', 'اليونان'),
(63062, 3264907672, 3264907679, 'CY', 'CYP', 'قبرص'),
(63063, 3264907680, 3264907683, 'GR', 'GRC', 'اليونان'),
(63064, 3264907684, 3264907687, 'CY', 'CYP', 'قبرص'),
(63065, 3264907688, 3264907691, 'GR', 'GRC', 'اليونان'),
(63066, 3264907692, 3264907695, 'CY', 'CYP', 'قبرص'),
(63067, 3264907696, 3264907703, 'GR', 'GRC', 'اليونان'),
(63068, 3264907704, 3264907715, 'CY', 'CYP', 'قبرص'),
(63069, 3264907716, 3264907727, 'GR', 'GRC', 'اليونان'),
(63070, 3264907728, 3264907735, 'CY', 'CYP', 'قبرص'),
(63071, 3264907736, 3264907743, 'GR', 'GRC', 'اليونان'),
(63072, 3264907744, 3264907755, 'CY', 'CYP', 'قبرص'),
(63073, 3264907756, 3264907759, 'GR', 'GRC', 'اليونان'),
(63074, 3264907760, 3264907772, 'CY', 'CYP', 'قبرص'),
(63075, 3264907773, 3264907775, 'GR', 'GRC', 'اليونان'),
(63076, 3264907776, 3264907919, 'CY', 'CYP', 'قبرص'),
(63077, 3264907920, 3264907927, 'GR', 'GRC', 'اليونان'),
(63078, 3264907928, 3264907935, 'CY', 'CYP', 'قبرص'),
(63079, 3264907936, 3264907939, 'GR', 'GRC', 'اليونان'),
(63080, 3264907940, 3264907963, 'CY', 'CYP', 'قبرص'),
(63081, 3264907964, 3264907971, 'GR', 'GRC', 'اليونان'),
(63082, 3264907972, 3264907987, 'CY', 'CYP', 'قبرص'),
(63083, 3264907988, 3264907991, 'GR', 'GRC', 'اليونان'),
(63084, 3264907992, 3264908011, 'CY', 'CYP', 'قبرص'),
(63085, 3264908012, 3264908019, 'GR', 'GRC', 'اليونان'),
(63086, 3264908020, 3264908023, 'CY', 'CYP', 'قبرص'),
(63087, 3264908024, 3264908031, 'GR', 'GRC', 'اليونان'),
(63088, 3264908032, 3264908063, 'CY', 'CYP', 'قبرص'),
(63089, 3264908064, 3264908071, 'GR', 'GRC', 'اليونان'),
(63090, 3264908072, 3264908095, 'CY', 'CYP', 'قبرص'),
(63091, 3264908096, 3264908103, 'GR', 'GRC', 'اليونان'),
(63092, 3264908104, 3264908111, 'CY', 'CYP', 'قبرص'),
(63093, 3264908112, 3264908119, 'GR', 'GRC', 'اليونان'),
(63094, 3264908120, 3264908167, 'CY', 'CYP', 'قبرص'),
(63095, 3264908168, 3264908175, 'GR', 'GRC', 'اليونان'),
(63096, 3264908176, 3264908183, 'CY', 'CYP', 'قبرص'),
(63097, 3264908184, 3264908191, 'GR', 'GRC', 'اليونان'),
(63098, 3264908192, 3264908223, 'CY', 'CYP', 'قبرص'),
(63099, 3264908224, 3264908255, 'GR', 'GRC', 'اليونان'),
(63100, 3264908256, 3264908286, 'CY', 'CYP', 'قبرص'),
(63101, 3264908287, 3264908799, 'GR', 'GRC', 'اليونان'),
(63102, 3264908800, 3264909055, 'GB', 'GBR', 'المملكة المتحدة'),
(63103, 3264909056, 3264909311, 'GR', 'GRC', 'اليونان'),
(63104, 3264909312, 3264909639, 'CY', 'CYP', 'قبرص'),
(63105, 3264909640, 3264909647, 'GR', 'GRC', 'اليونان'),
(63106, 3264909648, 3264909655, 'CY', 'CYP', 'قبرص'),
(63107, 3264909656, 3264909663, 'GR', 'GRC', 'اليونان'),
(63108, 3264909664, 3264910590, 'CY', 'CYP', 'قبرص'),
(63109, 3264910591, 3264910591, 'GR', 'GRC', 'اليونان'),
(63110, 3264910592, 3264910607, 'CY', 'CYP', 'قبرص'),
(63111, 3264910608, 3264910623, 'GR', 'GRC', 'اليونان'),
(63112, 3264910624, 3264910655, 'CY', 'CYP', 'قبرص'),
(63113, 3264910656, 3264910671, 'GR', 'GRC', 'اليونان'),
(63114, 3264910672, 3264910696, 'CY', 'CYP', 'قبرص'),
(63115, 3264910697, 3264910699, 'GR', 'GRC', 'اليونان'),
(63116, 3264910700, 3264910707, 'CY', 'CYP', 'قبرص'),
(63117, 3264910708, 3264910719, 'GR', 'GRC', 'اليونان'),
(63118, 3264910720, 3264910815, 'CY', 'CYP', 'قبرص'),
(63119, 3264910816, 3264911103, 'GR', 'GRC', 'اليونان'),
(63120, 3264911104, 3264911651, 'CY', 'CYP', 'قبرص'),
(63121, 3264911652, 3264911655, 'GR', 'GRC', 'اليونان'),
(63122, 3264911656, 3264911679, 'CY', 'CYP', 'قبرص'),
(63123, 3264911680, 3264911703, 'GR', 'GRC', 'اليونان'),
(63124, 3264911704, 3264911743, 'CY', 'CYP', 'قبرص'),
(63125, 3264911744, 3264911807, 'GR', 'GRC', 'اليونان'),
(63126, 3264911808, 3264912131, 'CY', 'CYP', 'قبرص'),
(63127, 3264912132, 3264912135, 'GR', 'GRC', 'اليونان'),
(63128, 3264912136, 3264912139, 'CY', 'CYP', 'قبرص'),
(63129, 3264912140, 3264912143, 'GR', 'GRC', 'اليونان'),
(63130, 3264912144, 3264912147, 'CY', 'CYP', 'قبرص'),
(63131, 3264912148, 3264912151, 'GR', 'GRC', 'اليونان'),
(63132, 3264912152, 3264912167, 'CY', 'CYP', 'قبرص'),
(63133, 3264912168, 3264912183, 'GR', 'GRC', 'اليونان'),
(63134, 3264912184, 3264912191, 'CY', 'CYP', 'قبرص'),
(63135, 3264912192, 3264912219, 'GR', 'GRC', 'اليونان'),
(63136, 3264912220, 3264912223, 'CY', 'CYP', 'قبرص'),
(63137, 3264912224, 3264912231, 'GR', 'GRC', 'اليونان'),
(63138, 3264912232, 3264912235, 'CY', 'CYP', 'قبرص'),
(63139, 3264912236, 3264912239, 'GR', 'GRC', 'اليونان'),
(63140, 3264912240, 3264912243, 'CY', 'CYP', 'قبرص'),
(63141, 3264912244, 3264912251, 'GR', 'GRC', 'اليونان'),
(63142, 3264912252, 3264912263, 'CY', 'CYP', 'قبرص'),
(63143, 3264912264, 3264912279, 'GR', 'GRC', 'اليونان'),
(63144, 3264912280, 3264912283, 'CY', 'CYP', 'قبرص'),
(63145, 3264912284, 3264912287, 'GR', 'GRC', 'اليونان'),
(63146, 3264912288, 3264912295, 'CY', 'CYP', 'قبرص'),
(63147, 3264912296, 3264912319, 'GR', 'GRC', 'اليونان'),
(63148, 3264912320, 3264912655, 'CY', 'CYP', 'قبرص'),
(63149, 3264912656, 3264912663, 'GR', 'GRC', 'اليونان'),
(63150, 3264912664, 3264912815, 'CY', 'CYP', 'قبرص'),
(63151, 3264912816, 3264912839, 'GR', 'GRC', 'اليونان'),
(63152, 3264912840, 3264912843, 'CY', 'CYP', 'قبرص'),
(63153, 3264912844, 3264912863, 'GR', 'GRC', 'اليونان'),
(63154, 3264912864, 3264912879, 'CY', 'CYP', 'قبرص'),
(63155, 3264912880, 3264912895, 'GR', 'GRC', 'اليونان'),
(63156, 3264912896, 3264913151, 'CY', 'CYP', 'قبرص'),
(63157, 3264913152, 3264913183, 'GR', 'GRC', 'اليونان'),
(63158, 3264913184, 3264913191, 'CY', 'CYP', 'قبرص'),
(63159, 3264913192, 3264913199, 'GR', 'GRC', 'اليونان'),
(63160, 3264913200, 3264913223, 'CY', 'CYP', 'قبرص'),
(63161, 3264913224, 3264913231, 'GR', 'GRC', 'اليونان'),
(63162, 3264913232, 3264913243, 'CY', 'CYP', 'قبرص'),
(63163, 3264913244, 3264913263, 'GR', 'GRC', 'اليونان'),
(63164, 3264913264, 3264913279, 'CY', 'CYP', 'قبرص'),
(63165, 3264913280, 3264913295, 'GR', 'GRC', 'اليونان'),
(63166, 3264913296, 3264913299, 'CY', 'CYP', 'قبرص'),
(63167, 3264913300, 3264913303, 'GR', 'GRC', 'اليونان'),
(63168, 3264913304, 3264913311, 'CY', 'CYP', 'قبرص'),
(63169, 3264913312, 3264913327, 'GR', 'GRC', 'اليونان'),
(63170, 3264913328, 3264913375, 'CY', 'CYP', 'قبرص'),
(63171, 3264913376, 3264913383, 'GR', 'GRC', 'اليونان'),
(63172, 3264913384, 3264913399, 'CY', 'CYP', 'قبرص'),
(63173, 3264913400, 3264913407, 'GR', 'GRC', 'اليونان'),
(63174, 3264913408, 3264917247, 'GB', 'GBR', 'المملكة المتحدة'),
(63175, 3264917248, 3264917375, 'NL', 'NLD', 'هولندا'),
(63176, 3264917376, 3264921599, 'GB', 'GBR', 'المملكة المتحدة'),
(63177, 3264921600, 3264922303, 'LU', 'LUX', 'لوكسيمبورغ'),
(63178, 3264922304, 3264922319, 'SA', 'SAU', 'السعودية'),
(63179, 3264922320, 3264929791, 'LU', 'LUX', 'لوكسيمبورغ'),
(63180, 3264929792, 3264937983, 'SK', 'SVK', 'سلوفاكيا'),
(63181, 3264937984, 3265003519, 'GB', 'GBR', 'المملكة المتحدة'),
(63182, 3265003520, 3265006335, 'DE', 'DEU', 'ألمانيا'),
(63183, 3265006592, 3265010943, 'DE', 'DEU', 'ألمانيا'),
(63184, 3265011200, 3265043199, 'DE', 'DEU', 'ألمانيا'),
(63185, 3265043456, 3265052671, 'DE', 'DEU', 'ألمانيا'),
(63186, 3265053440, 3265055231, 'DE', 'DEU', 'ألمانيا'),
(63187, 3265055232, 3265055743, 'FR', 'FRA', 'فرنسا'),
(63188, 3265055744, 3265069055, 'DE', 'DEU', 'ألمانيا'),
(63189, 3265069056, 3265134591, 'FI', 'FIN', 'فنلندا'),
(63190, 3265134592, 3265142783, 'CH', 'CHE', 'سويسرا'),
(63191, 3265142784, 3265150975, 'MT', 'MLT', 'مالطا'),
(63192, 3265150976, 3265159167, 'AD', 'AND', 'أندورا'),
(63193, 3265159168, 3265167359, 'FR', 'FRA', 'فرنسا'),
(63194, 3265167360, 3265175551, 'AT', 'AUT', 'النمسا'),
(63195, 3265175552, 3265183743, 'NL', 'NLD', 'هولندا'),
(63196, 3265183744, 3265191935, 'BY', 'BLR', 'روسيا البيضاء'),
(63197, 3265191936, 3265200127, 'CH', 'CHE', 'سويسرا'),
(63198, 3265200128, 3265216767, 'GB', 'GBR', 'المملكة المتحدة'),
(63199, 3265216768, 3265217023, 'FR', 'FRA', 'فرنسا'),
(63200, 3265217024, 3265218559, 'GB', 'GBR', 'المملكة المتحدة'),
(63201, 3265218560, 3265219071, 'NL', 'NLD', 'هولندا'),
(63202, 3265219072, 3265257471, 'GB', 'GBR', 'المملكة المتحدة'),
(63203, 3265257472, 3265259519, 'NL', 'NLD', 'هولندا'),
(63204, 3265259520, 3265265663, 'GB', 'GBR', 'المملكة المتحدة'),
(63205, 3265265664, 3265286463, 'SK', 'SVK', 'سلوفاكيا'),
(63206, 3265286464, 3265286527, 'SR', 'SUR', 'سورينام'),
(63207, 3265286528, 3265331199, 'SK', 'SVK', 'سلوفاكيا'),
(63208, 3265331200, 3265340415, 'GB', 'GBR', 'المملكة المتحدة'),
(63209, 3265340416, 3265340671, 'DE', 'DEU', 'ألمانيا'),
(63210, 3265340672, 3265340927, 'GB', 'GBR', 'المملكة المتحدة'),
(63211, 3265340928, 3265341183, 'CH', 'CHE', 'سويسرا'),
(63212, 3265341184, 3265341279, 'AT', 'AUT', 'النمسا'),
(63213, 3265341312, 3265341439, 'FR', 'FRA', 'فرنسا'),
(63214, 3265341440, 3265341695, 'GB', 'GBR', 'المملكة المتحدة'),
(63215, 3265341696, 3265341951, 'DE', 'DEU', 'ألمانيا'),
(63216, 3265341952, 3265343487, 'GB', 'GBR', 'المملكة المتحدة'),
(63217, 3265343488, 3265347583, 'DE', 'DEU', 'ألمانيا'),
(63218, 3265347584, 3265352703, 'FR', 'FRA', 'فرنسا'),
(63219, 3265352704, 3265352959, 'BE', 'BEL', 'بلجيكا'),
(63220, 3265352960, 3265353215, 'FR', 'FRA', 'فرنسا'),
(63221, 3265353216, 3265355263, 'DE', 'DEU', 'ألمانيا'),
(63222, 3265355264, 3265355775, 'FR', 'FRA', 'فرنسا'),
(63223, 3265355776, 3265357055, 'BE', 'BEL', 'بلجيكا'),
(63224, 3265357056, 3265357311, 'FR', 'FRA', 'فرنسا'),
(63225, 3265357312, 3265357567, 'DE', 'DEU', 'ألمانيا'),
(63226, 3265357568, 3265357823, 'BE', 'BEL', 'بلجيكا'),
(63227, 3265357824, 3265358847, 'NL', 'NLD', 'هولندا'),
(63228, 3265358848, 3265359103, 'BE', 'BEL', 'بلجيكا'),
(63229, 3265359104, 3265359871, 'NL', 'NLD', 'هولندا'),
(63230, 3265359872, 3265360127, 'CH', 'CHE', 'سويسرا'),
(63231, 3265360128, 3265360383, 'GB', 'GBR', 'المملكة المتحدة'),
(63232, 3265360384, 3265360895, 'CH', 'CHE', 'سويسرا'),
(63233, 3265360896, 3265361919, 'GB', 'GBR', 'المملكة المتحدة'),
(63234, 3265361920, 3265363967, 'IT', 'ITA', 'إيطاليا'),
(63235, 3265363968, 3265366015, 'ES', 'ESP', 'إسبانيا'),
(63236, 3265366080, 3265366271, 'BE', 'BEL', 'بلجيكا'),
(63237, 3265366272, 3265366527, 'HU', 'HUN', 'هنغاريا'),
(63238, 3265366528, 3265367039, 'DK', 'DNK', 'الدنيمارك'),
(63239, 3265367040, 3265367295, 'AT', 'AUT', 'النمسا'),
(63240, 3265367296, 3265367551, 'ES', 'ESP', 'إسبانيا'),
(63241, 3265367552, 3265367807, 'SE', 'SWE', 'السويد'),
(63242, 3265367808, 3265369343, 'DK', 'DNK', 'الدنيمارك'),
(63243, 3265369344, 3265369599, 'IL', 'ISR', 'إسرائيل'),
(63244, 3265369600, 3265369855, 'SE', 'SWE', 'السويد'),
(63245, 3265369856, 3265370111, 'DE', 'DEU', 'ألمانيا'),
(63246, 3265370112, 3265370623, 'DK', 'DNK', 'الدنيمارك'),
(63247, 3265370624, 3265370879, 'GB', 'GBR', 'المملكة المتحدة'),
(63248, 3265370880, 3265376255, 'DE', 'DEU', 'ألمانيا'),
(63249, 3265376256, 3265376511, 'IT', 'ITA', 'إيطاليا'),
(63250, 3265376512, 3265378303, 'GB', 'GBR', 'المملكة المتحدة'),
(63251, 3265378304, 3265380095, 'NL', 'NLD', 'هولندا'),
(63252, 3265380096, 3265382399, 'GB', 'GBR', 'المملكة المتحدة'),
(63253, 3265382400, 3265382911, 'CH', 'CHE', 'سويسرا'),
(63254, 3265382912, 3265384447, 'GB', 'GBR', 'المملكة المتحدة'),
(63255, 3265384448, 3265386495, 'DE', 'DEU', 'ألمانيا'),
(63256, 3265386496, 3265387519, 'NL', 'NLD', 'هولندا'),
(63257, 3265388544, 3265396735, 'GB', 'GBR', 'المملكة المتحدة'),
(63258, 3265396736, 3265464847, 'DE', 'DEU', 'ألمانيا'),
(63259, 3265464848, 3265464863, 'AT', 'AUT', 'النمسا'),
(63260, 3265464864, 3265465343, 'DE', 'DEU', 'ألمانيا'),
(63261, 3265465344, 3265465599, 'AT', 'AUT', 'النمسا'),
(63262, 3265465600, 3265527807, 'DE', 'DEU', 'ألمانيا'),
(63263, 3265527808, 3265569279, 'GB', 'GBR', 'المملكة المتحدة'),
(63264, 3265569280, 3265569791, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(63265, 3265569792, 3265593343, 'GB', 'GBR', 'المملكة المتحدة'),
(63266, 3265593344, 3265594367, 'RU', 'RUS', 'الإتحاد الروسي'),
(63267, 3265594368, 3265595391, 'UA', 'UKR', 'أوكرانيا'),
(63268, 3265595392, 3265595903, 'PL', 'POL', 'بولندا'),
(63269, 3265595904, 3265596415, 'RU', 'RUS', 'الإتحاد الروسي'),
(63270, 3265596416, 3265596927, 'GB', 'GBR', 'المملكة المتحدة'),
(63271, 3265596928, 3265597439, 'FR', 'FRA', 'فرنسا'),
(63272, 3265597440, 3265599999, 'RU', 'RUS', 'الإتحاد الروسي'),
(63273, 3265600000, 3265600511, 'HU', 'HUN', 'هنغاريا'),
(63274, 3265600512, 3265601023, 'GB', 'GBR', 'المملكة المتحدة'),
(63275, 3265601024, 3265601535, 'RU', 'RUS', 'الإتحاد الروسي'),
(63276, 3265601536, 3265601791, 'SE', 'SWE', 'السويد'),
(63277, 3265601792, 3265602047, 'CH', 'CHE', 'سويسرا'),
(63278, 3265602048, 3265602559, 'NL', 'NLD', 'هولندا'),
(63279, 3265602560, 3265602815, 'IT', 'ITA', 'إيطاليا'),
(63280, 3265602816, 3265603071, 'IE', 'IRL', 'إيرلندا'),
(63281, 3265603072, 3265603327, 'DK', 'DNK', 'الدنيمارك'),
(63282, 3265603328, 3265603583, 'MD', 'MDA', 'مولدوفا'),
(63283, 3265603584, 3265603839, 'DE', 'DEU', 'ألمانيا'),
(63284, 3265603840, 3265604095, 'PL', 'POL', 'بولندا'),
(63285, 3265604096, 3265604351, 'SA', 'SAU', 'السعودية'),
(63286, 3265604352, 3265604607, 'FR', 'FRA', 'فرنسا'),
(63287, 3265604608, 3265604863, 'CH', 'CHE', 'سويسرا'),
(63288, 3265604864, 3265605119, 'FR', 'FRA', 'فرنسا'),
(63289, 3265605120, 3265605375, 'UA', 'UKR', 'أوكرانيا'),
(63290, 3265605376, 3265605631, 'CZ', 'CZE', 'التشيك'),
(63291, 3265605632, 3265605887, 'PL', 'POL', 'بولندا'),
(63292, 3265605888, 3265606143, 'FR', 'FRA', 'فرنسا'),
(63293, 3265606400, 3265606655, 'DE', 'DEU', 'ألمانيا'),
(63294, 3265606656, 3265606911, 'AT', 'AUT', 'النمسا'),
(63295, 3265606912, 3265607167, 'FR', 'FRA', 'فرنسا'),
(63296, 3265607168, 3265607423, 'PL', 'POL', 'بولندا'),
(63297, 3265607424, 3265607935, 'DK', 'DNK', 'الدنيمارك'),
(63298, 3265607936, 3265608191, 'CZ', 'CZE', 'التشيك'),
(63299, 3265608192, 3265608447, 'RU', 'RUS', 'الإتحاد الروسي'),
(63300, 3265608448, 3265608703, 'SE', 'SWE', 'السويد'),
(63301, 3265608704, 3265608959, 'GB', 'GBR', 'المملكة المتحدة'),
(63302, 3265608960, 3265609215, 'RU', 'RUS', 'الإتحاد الروسي'),
(63303, 3265609216, 3265609727, 'UA', 'UKR', 'أوكرانيا'),
(63304, 3265609728, 3265617919, 'NL', 'NLD', 'هولندا'),
(63305, 3265617920, 3265626111, 'SI', 'SVN', 'سلوفينيا'),
(63306, 3265626112, 3265634303, 'JO', 'JOR', 'الأردن'),
(63307, 3265634304, 3265642287, 'IE', 'IRL', 'إيرلندا'),
(63308, 3265642288, 3265642303, 'US', 'USA', 'الولايات المتحدة'),
(63309, 3265642304, 3265642495, 'IE', 'IRL', 'إيرلندا'),
(63310, 3265642496, 3265650687, 'GB', 'GBR', 'المملكة المتحدة'),
(63311, 3265650688, 3265658879, 'SE', 'SWE', 'السويد'),
(63312, 3265658880, 3265724415, 'AT', 'AUT', 'النمسا'),
(63313, 3265724416, 3265789951, 'FR', 'FRA', 'فرنسا'),
(63314, 3265789952, 3265824767, 'GB', 'GBR', 'المملكة المتحدة'),
(63315, 3265824768, 3265825023, 'US', 'USA', 'الولايات المتحدة'),
(63316, 3265825024, 3265887487, 'GB', 'GBR', 'المملكة المتحدة'),
(63317, 3265887488, 3265887743, 'PT', 'PRT', 'البورتوغال'),
(63318, 3265887744, 3265888255, 'PL', 'POL', 'بولندا'),
(63319, 3265888256, 3265902335, 'GB', 'GBR', 'المملكة المتحدة'),
(63320, 3265902336, 3265902591, 'FR', 'FRA', 'فرنسا'),
(63321, 3265902592, 3265904383, 'GB', 'GBR', 'المملكة المتحدة'),
(63322, 3265904384, 3265904639, 'RO', 'ROM', 'رومانيا'),
(63323, 3265904640, 3265904895, 'DE', 'DEU', 'ألمانيا'),
(63324, 3265904896, 3265905151, 'UA', 'UKR', 'أوكرانيا'),
(63325, 3265905152, 3265905663, 'GB', 'GBR', 'المملكة المتحدة'),
(63326, 3265905664, 3265905919, 'IE', 'IRL', 'إيرلندا'),
(63327, 3265905920, 3265906175, 'GB', 'GBR', 'المملكة المتحدة'),
(63328, 3265906176, 3265906431, 'DE', 'DEU', 'ألمانيا'),
(63329, 3265906432, 3265906687, 'CH', 'CHE', 'سويسرا'),
(63330, 3265906688, 3265906943, 'AT', 'AUT', 'النمسا'),
(63331, 3265906944, 3265907199, 'ES', 'ESP', 'إسبانيا'),
(63332, 3265907200, 3265907455, 'DE', 'DEU', 'ألمانيا'),
(63333, 3265907456, 3265907711, 'FR', 'FRA', 'فرنسا'),
(63334, 3265907712, 3265907967, 'MD', 'MDA', 'مولدوفا'),
(63335, 3265907968, 3265908735, 'UA', 'UKR', 'أوكرانيا'),
(63336, 3265908736, 3265908991, 'NL', 'NLD', 'هولندا'),
(63337, 3265908992, 3265909247, 'RO', 'ROM', 'رومانيا'),
(63338, 3265909248, 3265909503, 'UA', 'UKR', 'أوكرانيا'),
(63339, 3265909504, 3265909759, 'DE', 'DEU', 'ألمانيا'),
(63340, 3265909760, 3265910015, 'RO', 'ROM', 'رومانيا'),
(63341, 3265910016, 3265910271, 'PL', 'POL', 'بولندا'),
(63342, 3265910272, 3265910527, 'FR', 'FRA', 'فرنسا'),
(63343, 3265910528, 3265910783, 'PT', 'PRT', 'البورتوغال'),
(63344, 3265910784, 3265911039, 'DE', 'DEU', 'ألمانيا'),
(63345, 3265911040, 3265911551, 'GB', 'GBR', 'المملكة المتحدة'),
(63346, 3265911552, 3265911807, 'CH', 'CHE', 'سويسرا'),
(63347, 3265911808, 3265912063, 'PL', 'POL', 'بولندا'),
(63348, 3265912064, 3265912319, 'GB', 'GBR', 'المملكة المتحدة'),
(63349, 3265912320, 3265912575, 'DE', 'DEU', 'ألمانيا'),
(63350, 3265912576, 3265912831, 'RO', 'ROM', 'رومانيا'),
(63351, 3265912832, 3265913087, 'CZ', 'CZE', 'التشيك'),
(63352, 3265913088, 3265913343, 'SE', 'SWE', 'السويد'),
(63353, 3265913344, 3265914367, 'PL', 'POL', 'بولندا'),
(63354, 3265914368, 3265914623, 'RU', 'RUS', 'الإتحاد الروسي'),
(63355, 3265914624, 3265914879, 'BG', 'BGR', 'بلغاريا'),
(63356, 3265914880, 3265915135, 'GR', 'GRC', 'اليونان'),
(63357, 3265915136, 3265915391, 'RO', 'ROM', 'رومانيا'),
(63358, 3265915392, 3265915647, 'GB', 'GBR', 'المملكة المتحدة'),
(63359, 3265915648, 3265915903, 'RO', 'ROM', 'رومانيا'),
(63360, 3265915904, 3265916415, 'PL', 'POL', 'بولندا'),
(63361, 3265916416, 3265916671, 'UA', 'UKR', 'أوكرانيا'),
(63362, 3265916672, 3265916927, 'DE', 'DEU', 'ألمانيا'),
(63363, 3265916928, 3265917183, 'FR', 'FRA', 'فرنسا'),
(63364, 3265917184, 3265917439, 'PL', 'POL', 'بولندا'),
(63365, 3265917440, 3265917695, 'RU', 'RUS', 'الإتحاد الروسي'),
(63366, 3265917696, 3265917951, 'SE', 'SWE', 'السويد'),
(63367, 3265917952, 3265918207, 'GB', 'GBR', 'المملكة المتحدة'),
(63368, 3265918464, 3265918719, 'AT', 'AUT', 'النمسا'),
(63369, 3265918720, 3265918975, 'RU', 'RUS', 'الإتحاد الروسي'),
(63370, 3265918976, 3265919231, 'NL', 'NLD', 'هولندا'),
(63371, 3265919232, 3265919487, 'FR', 'FRA', 'فرنسا'),
(63372, 3265919488, 3265919743, 'RU', 'RUS', 'الإتحاد الروسي'),
(63373, 3265919744, 3265919999, 'DK', 'DNK', 'الدنيمارك'),
(63374, 3265920000, 3265920255, 'CZ', 'CZE', 'التشيك'),
(63375, 3265920256, 3265920511, 'TR', 'TUR', 'تركيا'),
(63376, 3265920512, 3265921023, 'GB', 'GBR', 'المملكة المتحدة'),
(63377, 3265921024, 3265986559, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(63378, 3265986560, 3266052095, 'NL', 'NLD', 'هولندا'),
(63379, 3266052096, 3266322431, 'DE', 'DEU', 'ألمانيا'),
(63380, 3266322432, 3266330623, 'LT', 'LTU', 'ليتوانيا'),
(63381, 3266330624, 3266338815, 'GB', 'GBR', 'المملكة المتحدة'),
(63382, 3266338816, 3266339071, 'RU', 'RUS', 'الإتحاد الروسي'),
(63383, 3266339072, 3266339327, 'UA', 'UKR', 'أوكرانيا'),
(63384, 3266339328, 3266339583, 'ES', 'ESP', 'إسبانيا'),
(63385, 3266339584, 3266339839, 'GB', 'GBR', 'المملكة المتحدة'),
(63386, 3266339840, 3266340095, 'RU', 'RUS', 'الإتحاد الروسي'),
(63387, 3266340096, 3266340607, 'PL', 'POL', 'بولندا'),
(63388, 3266340608, 3266340863, 'FI', 'FIN', 'فنلندا'),
(63389, 3266340864, 3266341119, 'CH', 'CHE', 'سويسرا'),
(63390, 3266341120, 3266341375, 'GB', 'GBR', 'المملكة المتحدة'),
(63391, 3266341376, 3266341631, 'DE', 'DEU', 'ألمانيا'),
(63392, 3266341632, 3266341887, 'GB', 'GBR', 'المملكة المتحدة'),
(63393, 3266341888, 3266342143, 'KW', 'KWT', 'الكويت'),
(63394, 3266342144, 3266342399, 'CH', 'CHE', 'سويسرا'),
(63395, 3266342400, 3266342655, 'BE', 'BEL', 'بلجيكا'),
(63396, 3266342656, 3266342911, 'KG', 'KGZ', 'قيرغيزستان'),
(63397, 3266342912, 3266343167, 'SI', 'SVN', 'سلوفينيا'),
(63398, 3266343168, 3266343423, 'GR', 'GRC', 'اليونان'),
(63399, 3266343424, 3266343679, 'RU', 'RUS', 'الإتحاد الروسي'),
(63400, 3266343680, 3266343935, 'RO', 'ROM', 'رومانيا'),
(63401, 3266343936, 3266344191, 'CH', 'CHE', 'سويسرا'),
(63402, 3266344192, 3266344447, 'UA', 'UKR', 'أوكرانيا'),
(63403, 3266344448, 3266344703, 'RU', 'RUS', 'الإتحاد الروسي'),
(63404, 3266344704, 3266344959, 'ES', 'ESP', 'إسبانيا'),
(63405, 3266344960, 3266345727, 'DE', 'DEU', 'ألمانيا'),
(63406, 3266345728, 3266345983, 'DK', 'DNK', 'الدنيمارك'),
(63407, 3266345984, 3266346495, 'GB', 'GBR', 'المملكة المتحدة'),
(63408, 3266346496, 3266346751, 'IT', 'ITA', 'إيطاليا'),
(63409, 3266346752, 3266347007, 'FR', 'FRA', 'فرنسا'),
(63410, 3266347008, 3266347263, 'GB', 'GBR', 'المملكة المتحدة'),
(63411, 3266351360, 3266352623, 'GB', 'GBR', 'المملكة المتحدة'),
(63412, 3266352896, 3266353567, 'GB', 'GBR', 'المملكة المتحدة'),
(63413, 3266353584, 3266353591, 'GB', 'GBR', 'المملكة المتحدة'),
(63414, 3266353664, 3266353671, 'GB', 'GBR', 'المملكة المتحدة'),
(63415, 3266353680, 3266353687, 'GB', 'GBR', 'المملكة المتحدة'),
(63416, 3266353776, 3266353783, 'US', 'USA', 'الولايات المتحدة'),
(63417, 3266353856, 3266353863, 'GB', 'GBR', 'المملكة المتحدة'),
(63418, 3266353880, 3266353887, 'GB', 'GBR', 'المملكة المتحدة'),
(63419, 3266353896, 3266353903, 'GB', 'GBR', 'المملكة المتحدة'),
(63420, 3266353920, 3266355199, 'GB', 'GBR', 'المملكة المتحدة'),
(63421, 3266355200, 3266363391, 'RO', 'ROM', 'رومانيا'),
(63422, 3266363392, 3266371583, 'GB', 'GBR', 'المملكة المتحدة'),
(63423, 3266371584, 3266379775, 'HU', 'HUN', 'هنغاريا'),
(63424, 3266379776, 3266380799, 'UA', 'UKR', 'أوكرانيا'),
(63425, 3266380800, 3266381823, 'PL', 'POL', 'بولندا'),
(63426, 3266381824, 3266382847, 'FR', 'FRA', 'فرنسا'),
(63427, 3266382848, 3266383871, 'RU', 'RUS', 'الإتحاد الروسي'),
(63428, 3266383872, 3266384895, 'IL', 'ISR', 'إسرائيل'),
(63429, 3266384896, 3266385919, 'RU', 'RUS', 'الإتحاد الروسي'),
(63430, 3266385920, 3266386943, 'UA', 'UKR', 'أوكرانيا'),
(63431, 3266386944, 3266387967, 'PL', 'POL', 'بولندا'),
(63432, 3266387968, 3266388375, 'FR', 'FRA', 'فرنسا'),
(63433, 3266388376, 3266388378, 'NL', 'NLD', 'هولندا'),
(63434, 3266388379, 3266389247, 'FR', 'FRA', 'فرنسا'),
(63435, 3266389248, 3266389327, 'LU', 'LUX', 'لوكسيمبورغ'),
(63436, 3266389328, 3266395135, 'FR', 'FRA', 'فرنسا'),
(63437, 3266395136, 3266395903, 'NL', 'NLD', 'هولندا'),
(63438, 3266395904, 3266396159, 'FR', 'FRA', 'فرنسا'),
(63439, 3266396160, 3266412543, 'IT', 'ITA', 'إيطاليا'),
(63440, 3266412544, 3266420735, 'AT', 'AUT', 'النمسا'),
(63441, 3266420736, 3266428927, 'GB', 'GBR', 'المملكة المتحدة'),
(63442, 3266428928, 3266437119, 'GR', 'GRC', 'اليونان'),
(63443, 3266437120, 3266445311, 'GL', 'GRL', 'غرينلاند'),
(63444, 3266445312, 3266510847, 'NL', 'NLD', 'هولندا'),
(63445, 3266510848, 3266543615, 'ES', 'ESP', 'إسبانيا'),
(63446, 3266543616, 3266576383, 'IT', 'ITA', 'إيطاليا'),
(63447, 3266576384, 3266603519, 'DE', 'DEU', 'ألمانيا'),
(63448, 3266604032, 3266617327, 'DE', 'DEU', 'ألمانيا'),
(63449, 3266617344, 3266634383, 'DE', 'DEU', 'ألمانيا'),
(63450, 3266634392, 3266634399, 'EE', 'EST', 'إستونيا'),
(63451, 3266634400, 3266641919, 'DE', 'DEU', 'ألمانيا'),
(63452, 3266641920, 3266707455, 'PL', 'POL', 'بولندا'),
(63453, 3266707456, 3266772991, 'DK', 'DNK', 'الدنيمارك'),
(63454, 3266772992, 3266781183, 'IT', 'ITA', 'إيطاليا'),
(63455, 3266781184, 3266789375, 'PL', 'POL', 'بولندا'),
(63456, 3266789376, 3266796543, 'SM', 'SMR', 'سان مارينو'),
(63457, 3266796544, 3266796799, 'IT', 'ITA', 'إيطاليا'),
(63458, 3266796800, 3266797567, 'SM', 'SMR', 'سان مارينو'),
(63459, 3266797568, 3266797823, 'GB', 'GBR', 'المملكة المتحدة'),
(63460, 3266797824, 3266798079, 'NL', 'NLD', 'هولندا'),
(63461, 3266798080, 3266799103, 'GB', 'GBR', 'المملكة المتحدة'),
(63462, 3266799104, 3266799615, 'NL', 'NLD', 'هولندا'),
(63463, 3266799616, 3266800127, 'GB', 'GBR', 'المملكة المتحدة'),
(63464, 3266800128, 3266800319, 'NL', 'NLD', 'هولندا'),
(63465, 3266800320, 3266800639, 'GB', 'GBR', 'المملكة المتحدة'),
(63466, 3266800640, 3266800703, 'NL', 'NLD', 'هولندا'),
(63467, 3266800704, 3266800727, 'GB', 'GBR', 'المملكة المتحدة'),
(63468, 3266800728, 3266800735, 'NL', 'NLD', 'هولندا'),
(63469, 3266800736, 3266800895, 'GB', 'GBR', 'المملكة المتحدة'),
(63470, 3266800896, 3266801215, 'NL', 'NLD', 'هولندا'),
(63471, 3266801216, 3266801407, 'GB', 'GBR', 'المملكة المتحدة'),
(63472, 3266801408, 3266801471, 'NL', 'NLD', 'هولندا'),
(63473, 3266801472, 3266801487, 'GB', 'GBR', 'المملكة المتحدة'),
(63474, 3266801488, 3266801519, 'NL', 'NLD', 'هولندا'),
(63475, 3266801520, 3266801535, 'GB', 'GBR', 'المملكة المتحدة'),
(63476, 3266801536, 3266801599, 'NL', 'NLD', 'هولندا'),
(63477, 3266801600, 3266801615, 'GB', 'GBR', 'المملكة المتحدة'),
(63478, 3266801616, 3266801647, 'NL', 'NLD', 'هولندا'),
(63479, 3266801648, 3266801663, 'GB', 'GBR', 'المملكة المتحدة'),
(63480, 3266801664, 3266801919, 'NL', 'NLD', 'هولندا'),
(63481, 3266801920, 3266802943, 'GB', 'GBR', 'المملكة المتحدة'),
(63482, 3266802944, 3266803199, 'NL', 'NLD', 'هولندا'),
(63483, 3266803200, 3266803727, 'GB', 'GBR', 'المملكة المتحدة'),
(63484, 3266803728, 3266803831, 'NL', 'NLD', 'هولندا'),
(63485, 3266803832, 3266804223, 'GB', 'GBR', 'المملكة المتحدة'),
(63486, 3266804224, 3266804479, 'NL', 'NLD', 'هولندا'),
(63487, 3266804480, 3266804735, 'GB', 'GBR', 'المملكة المتحدة'),
(63488, 3266804736, 3266804991, 'NL', 'NLD', 'هولندا'),
(63489, 3266804992, 3266805503, 'GB', 'GBR', 'المملكة المتحدة'),
(63490, 3266805504, 3266805759, 'NL', 'NLD', 'هولندا'),
(63491, 3266805760, 3266809343, 'AT', 'AUT', 'النمسا'),
(63492, 3266809344, 3266809599, 'LI', 'LIE', 'ليختنشتاين'),
(63493, 3266809600, 3266813951, 'AT', 'AUT', 'النمسا'),
(63494, 3266813952, 3266822143, 'UA', 'UKR', 'أوكرانيا'),
(63495, 3266822144, 3266830335, 'FR', 'FRA', 'فرنسا'),
(63496, 3266830336, 3266835151, 'BE', 'BEL', 'بلجيكا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(63497, 3266835152, 3266835159, 'FR', 'FRA', 'فرنسا'),
(63498, 3266835160, 3266836479, 'BE', 'BEL', 'بلجيكا'),
(63499, 3266836480, 3266837503, 'LU', 'LUX', 'لوكسيمبورغ'),
(63500, 3266837504, 3266838527, 'BE', 'BEL', 'بلجيكا'),
(63501, 3266838528, 3266969599, 'IT', 'ITA', 'إيطاليا'),
(63502, 3266969600, 3267008767, 'RU', 'RUS', 'الإتحاد الروسي'),
(63503, 3267008768, 3267009023, 'UA', 'UKR', 'أوكرانيا'),
(63504, 3267009024, 3267030095, 'RU', 'RUS', 'الإتحاد الروسي'),
(63505, 3267030096, 3267030103, 'KZ', 'KAZ', 'كازاخستان'),
(63506, 3267030104, 3267032575, 'RU', 'RUS', 'الإتحاد الروسي'),
(63507, 3267032576, 3267032831, 'KZ', 'KAZ', 'كازاخستان'),
(63508, 3267032832, 3267035135, 'RU', 'RUS', 'الإتحاد الروسي'),
(63509, 3267035136, 3267039231, 'NO', 'NOR', 'النرويج'),
(63510, 3267039232, 3267040255, 'DE', 'DEU', 'ألمانيا'),
(63511, 3267040256, 3267041279, 'RO', 'ROM', 'رومانيا'),
(63512, 3267041280, 3267043327, 'UA', 'UKR', 'أوكرانيا'),
(63513, 3267043328, 3267044351, 'GB', 'GBR', 'المملكة المتحدة'),
(63514, 3267044352, 3267045375, 'RU', 'RUS', 'الإتحاد الروسي'),
(63515, 3267045376, 3267046399, 'PL', 'POL', 'بولندا'),
(63516, 3267046400, 3267047423, 'NL', 'NLD', 'هولندا'),
(63517, 3267047424, 3267048447, 'UA', 'UKR', 'أوكرانيا'),
(63518, 3267048448, 3267049471, 'PL', 'POL', 'بولندا'),
(63519, 3267050496, 3267051519, 'SE', 'SWE', 'السويد'),
(63520, 3267051520, 3267052543, 'DE', 'DEU', 'ألمانيا'),
(63521, 3267052544, 3267053567, 'LV', 'LVA', 'لاتفيا'),
(63522, 3267053568, 3267054591, 'PL', 'POL', 'بولندا'),
(63523, 3267054592, 3267055615, 'NL', 'NLD', 'هولندا'),
(63524, 3267055616, 3267056639, 'PS', 'PSE', 'فلسطين المحتلة'),
(63525, 3267056640, 3267057663, 'IL', 'ISR', 'إسرائيل'),
(63526, 3267057664, 3267058687, 'CH', 'CHE', 'سويسرا'),
(63527, 3267058688, 3267059711, 'AT', 'AUT', 'النمسا'),
(63528, 3267059712, 3267060735, 'NL', 'NLD', 'هولندا'),
(63529, 3267060736, 3267061759, 'LV', 'LVA', 'لاتفيا'),
(63530, 3267061760, 3267063807, 'UA', 'UKR', 'أوكرانيا'),
(63531, 3267063808, 3267064831, 'DE', 'DEU', 'ألمانيا'),
(63532, 3267064832, 3267065855, 'PL', 'POL', 'بولندا'),
(63533, 3267065856, 3267066879, 'RO', 'ROM', 'رومانيا'),
(63534, 3267066880, 3267067903, 'IT', 'ITA', 'إيطاليا'),
(63535, 3267067904, 3267068927, 'UA', 'UKR', 'أوكرانيا'),
(63536, 3267068928, 3267069951, 'BG', 'BGR', 'بلغاريا'),
(63537, 3267069952, 3267070975, 'RO', 'ROM', 'رومانيا'),
(63538, 3267070976, 3267071999, 'DE', 'DEU', 'ألمانيا'),
(63539, 3267072000, 3267073023, 'PL', 'POL', 'بولندا'),
(63540, 3267073024, 3267075071, 'UA', 'UKR', 'أوكرانيا'),
(63541, 3267075072, 3267076095, 'CH', 'CHE', 'سويسرا'),
(63542, 3267076096, 3267078143, 'DE', 'DEU', 'ألمانيا'),
(63543, 3267078144, 3267079167, 'PL', 'POL', 'بولندا'),
(63544, 3267079168, 3267080191, 'IT', 'ITA', 'إيطاليا'),
(63545, 3267080192, 3267081215, 'AT', 'AUT', 'النمسا'),
(63546, 3267081216, 3267082239, 'PL', 'POL', 'بولندا'),
(63547, 3267082240, 3267083263, 'DE', 'DEU', 'ألمانيا'),
(63548, 3267083264, 3267084287, 'RO', 'ROM', 'رومانيا'),
(63549, 3267084288, 3267085311, 'FR', 'FRA', 'فرنسا'),
(63550, 3267085312, 3267086335, 'RU', 'RUS', 'الإتحاد الروسي'),
(63551, 3267086336, 3267087359, 'PL', 'POL', 'بولندا'),
(63552, 3267087360, 3267088383, 'RU', 'RUS', 'الإتحاد الروسي'),
(63553, 3267088384, 3267089407, 'UA', 'UKR', 'أوكرانيا'),
(63554, 3267089408, 3267090431, 'FI', 'FIN', 'فنلندا'),
(63555, 3267090432, 3267091455, 'UA', 'UKR', 'أوكرانيا'),
(63556, 3267091456, 3267092479, 'DE', 'DEU', 'ألمانيا'),
(63557, 3267092480, 3267093503, 'FR', 'FRA', 'فرنسا'),
(63558, 3267093504, 3267094527, 'UA', 'UKR', 'أوكرانيا'),
(63559, 3267094528, 3267095551, 'GB', 'GBR', 'المملكة المتحدة'),
(63560, 3267095552, 3267096575, 'PL', 'POL', 'بولندا'),
(63561, 3267096576, 3267097599, 'DE', 'DEU', 'ألمانيا'),
(63562, 3267097600, 3267098623, 'KZ', 'KAZ', 'كازاخستان'),
(63563, 3267098624, 3267099647, 'GB', 'GBR', 'المملكة المتحدة'),
(63564, 3267099648, 3267100671, 'IT', 'ITA', 'إيطاليا'),
(63565, 3267100672, 3267166207, 'FI', 'FIN', 'فنلندا'),
(63566, 3267166208, 3267231743, 'GB', 'GBR', 'المملكة المتحدة'),
(63567, 3267231744, 3267297279, 'RU', 'RUS', 'الإتحاد الروسي'),
(63568, 3267297280, 3267362815, 'CH', 'CHE', 'سويسرا'),
(63569, 3267362816, 3267426879, 'DK', 'DNK', 'الدنيمارك'),
(63570, 3267426880, 3267426943, 'CH', 'CHE', 'سويسرا'),
(63571, 3267426944, 3267428351, 'DK', 'DNK', 'الدنيمارك'),
(63572, 3267428352, 3267493887, 'GB', 'GBR', 'المملكة المتحدة'),
(63573, 3267493888, 3267494143, 'DE', 'DEU', 'ألمانيا'),
(63574, 3267494144, 3267498239, 'GB', 'GBR', 'المملكة المتحدة'),
(63575, 3267498240, 3267498495, 'IE', 'IRL', 'إيرلندا'),
(63576, 3267498496, 3267498751, 'DE', 'DEU', 'ألمانيا'),
(63577, 3267498752, 3267504383, 'GB', 'GBR', 'المملكة المتحدة'),
(63578, 3267504384, 3267504639, 'AT', 'AUT', 'النمسا'),
(63579, 3267504640, 3267505151, 'FR', 'FRA', 'فرنسا'),
(63580, 3267505152, 3267507711, 'DE', 'DEU', 'ألمانيا'),
(63581, 3267507712, 3267507743, 'GB', 'GBR', 'المملكة المتحدة'),
(63582, 3267507744, 3267507775, 'DE', 'DEU', 'ألمانيا'),
(63583, 3267507776, 3267507807, 'GB', 'GBR', 'المملكة المتحدة'),
(63584, 3267507808, 3267507839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(63585, 3267507840, 3267508223, 'GB', 'GBR', 'المملكة المتحدة'),
(63586, 3267508224, 3267508735, 'DE', 'DEU', 'ألمانيا'),
(63587, 3267508736, 3267508991, 'IL', 'ISR', 'إسرائيل'),
(63588, 3267508992, 3267509247, 'GB', 'GBR', 'المملكة المتحدة'),
(63589, 3267509248, 3267509503, 'AT', 'AUT', 'النمسا'),
(63590, 3267509504, 3267509695, 'CH', 'CHE', 'سويسرا'),
(63591, 3267509728, 3267509759, 'CH', 'CHE', 'سويسرا'),
(63592, 3267509760, 3267510271, 'GB', 'GBR', 'المملكة المتحدة'),
(63593, 3267510272, 3267512831, 'FR', 'FRA', 'فرنسا'),
(63594, 3267512832, 3267513343, 'GB', 'GBR', 'المملكة المتحدة'),
(63595, 3267513344, 3267514367, 'FR', 'FRA', 'فرنسا'),
(63596, 3267514368, 3267517951, 'DE', 'DEU', 'ألمانيا'),
(63597, 3267517952, 3267518463, 'GB', 'GBR', 'المملكة المتحدة'),
(63598, 3267518464, 3267524607, 'DE', 'DEU', 'ألمانيا'),
(63599, 3267526656, 3267527679, 'DE', 'DEU', 'ألمانيا'),
(63600, 3267527680, 3267529215, 'FR', 'FRA', 'فرنسا'),
(63601, 3267529216, 3267529471, 'GB', 'GBR', 'المملكة المتحدة'),
(63602, 3267529472, 3267529727, 'FR', 'FRA', 'فرنسا'),
(63603, 3267529728, 3267530751, 'AT', 'AUT', 'النمسا'),
(63604, 3267530752, 3267534335, 'FR', 'FRA', 'فرنسا'),
(63605, 3267534336, 3267534527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(63606, 3267534560, 3267534575, 'FR', 'FRA', 'فرنسا'),
(63607, 3267534576, 3267534591, 'AT', 'AUT', 'النمسا'),
(63608, 3267534592, 3267538943, 'FR', 'FRA', 'فرنسا'),
(63609, 3267538944, 3267540223, 'NL', 'NLD', 'هولندا'),
(63610, 3267540224, 3267540479, 'GB', 'GBR', 'المملكة المتحدة'),
(63611, 3267540480, 3267541759, 'NL', 'NLD', 'هولندا'),
(63612, 3267541760, 3267542527, 'GB', 'GBR', 'المملكة المتحدة'),
(63613, 3267542528, 3267542783, 'CH', 'CHE', 'سويسرا'),
(63614, 3267542784, 3267543039, 'DE', 'DEU', 'ألمانيا'),
(63615, 3267543040, 3267543295, 'IT', 'ITA', 'إيطاليا'),
(63616, 3267543296, 3267543551, 'AT', 'AUT', 'النمسا'),
(63617, 3267543552, 3267544319, 'GB', 'GBR', 'المملكة المتحدة'),
(63618, 3267544320, 3267544575, 'DE', 'DEU', 'ألمانيا'),
(63619, 3267544576, 3267544703, 'IT', 'ITA', 'إيطاليا'),
(63620, 3267544704, 3267544831, 'DE', 'DEU', 'ألمانيا'),
(63621, 3267544832, 3267545087, 'FR', 'FRA', 'فرنسا'),
(63622, 3267545088, 3267545855, 'ES', 'ESP', 'إسبانيا'),
(63623, 3267545856, 3267546111, 'DE', 'DEU', 'ألمانيا'),
(63624, 3267546112, 3267546623, 'ES', 'ESP', 'إسبانيا'),
(63625, 3267546624, 3267547135, 'FR', 'FRA', 'فرنسا'),
(63626, 3267547136, 3267547391, 'BE', 'BEL', 'بلجيكا'),
(63627, 3267547392, 3267547647, 'DE', 'DEU', 'ألمانيا'),
(63628, 3267547648, 3267549183, 'GB', 'GBR', 'المملكة المتحدة'),
(63629, 3267549184, 3267550463, 'DK', 'DNK', 'الدنيمارك'),
(63630, 3267550464, 3267550719, 'NL', 'NLD', 'هولندا'),
(63631, 3267550720, 3267551231, 'DK', 'DNK', 'الدنيمارك'),
(63632, 3267551232, 3267551743, 'AT', 'AUT', 'النمسا'),
(63633, 3267551744, 3267551999, 'SE', 'SWE', 'السويد'),
(63634, 3267552000, 3267552255, 'NO', 'NOR', 'النرويج'),
(63635, 3267552256, 3267553023, 'AT', 'AUT', 'النمسا'),
(63636, 3267553024, 3267553279, 'NL', 'NLD', 'هولندا'),
(63637, 3267553280, 3267554303, 'DK', 'DNK', 'الدنيمارك'),
(63638, 3267554304, 3267554815, 'DE', 'DEU', 'ألمانيا'),
(63639, 3267554816, 3267555071, 'FR', 'FRA', 'فرنسا'),
(63640, 3267555200, 3267555327, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(63641, 3267555328, 3267555583, 'FI', 'FIN', 'فنلندا'),
(63642, 3267555584, 3267556095, 'GB', 'GBR', 'المملكة المتحدة'),
(63643, 3267556096, 3267556351, 'NO', 'NOR', 'النرويج'),
(63644, 3267556352, 3267556607, 'GB', 'GBR', 'المملكة المتحدة'),
(63645, 3267556608, 3267556863, 'NO', 'NOR', 'النرويج'),
(63646, 3267556864, 3267557375, 'IL', 'ISR', 'إسرائيل'),
(63647, 3267557376, 3267557631, 'NO', 'NOR', 'النرويج'),
(63648, 3267557632, 3267557887, 'AT', 'AUT', 'النمسا'),
(63649, 3267557888, 3267558399, 'IL', 'ISR', 'إسرائيل'),
(63650, 3267558400, 3267558911, 'CH', 'CHE', 'سويسرا'),
(63651, 3267558912, 3267559423, 'AT', 'AUT', 'النمسا'),
(63652, 3267559424, 3267622527, 'DE', 'DEU', 'ألمانيا'),
(63653, 3267622528, 3267622559, 'GB', 'GBR', 'المملكة المتحدة'),
(63654, 3267622560, 3267624959, 'DE', 'DEU', 'ألمانيا'),
(63655, 3267624960, 3267625471, 'GB', 'GBR', 'المملكة المتحدة'),
(63656, 3267625472, 3267625727, 'FR', 'FRA', 'فرنسا'),
(63657, 3267625728, 3267625983, 'BE', 'BEL', 'بلجيكا'),
(63658, 3267625984, 3267626239, 'NL', 'NLD', 'هولندا'),
(63659, 3267626240, 3267626495, 'BE', 'BEL', 'بلجيكا'),
(63660, 3267626496, 3267626751, 'ES', 'ESP', 'إسبانيا'),
(63661, 3267626752, 3267627007, 'RU', 'RUS', 'الإتحاد الروسي'),
(63662, 3267627008, 3267627167, 'DE', 'DEU', 'ألمانيا'),
(63663, 3267627200, 3267627343, 'DE', 'DEU', 'ألمانيا'),
(63664, 3267627360, 3267627423, 'DE', 'DEU', 'ألمانيا'),
(63665, 3267627432, 3267627519, 'DE', 'DEU', 'ألمانيا'),
(63666, 3267627776, 3267627807, 'DE', 'DEU', 'ألمانيا'),
(63667, 3267627872, 3267628031, 'DE', 'DEU', 'ألمانيا'),
(63668, 3267628032, 3267628287, 'IT', 'ITA', 'إيطاليا'),
(63669, 3267628544, 3267628799, 'IT', 'ITA', 'إيطاليا'),
(63670, 3267628800, 3267629055, 'HU', 'HUN', 'هنغاريا'),
(63671, 3267629056, 3267629311, 'CZ', 'CZE', 'التشيك'),
(63672, 3267629312, 3267629567, 'DK', 'DNK', 'الدنيمارك'),
(63673, 3267629568, 3267629759, 'BE', 'BEL', 'بلجيكا'),
(63674, 3267629808, 3267629823, 'BE', 'BEL', 'بلجيكا'),
(63675, 3267629824, 3267630079, 'GR', 'GRC', 'اليونان'),
(63676, 3267630080, 3267630591, 'GB', 'GBR', 'المملكة المتحدة'),
(63677, 3267630592, 3267630847, 'SK', 'SVK', 'سلوفاكيا'),
(63678, 3267630848, 3267630863, 'IT', 'ITA', 'إيطاليا'),
(63679, 3267630880, 3267630943, 'FR', 'FRA', 'فرنسا'),
(63680, 3267630960, 3267631055, 'IT', 'ITA', 'إيطاليا'),
(63681, 3267631088, 3267631103, 'IT', 'ITA', 'إيطاليا'),
(63682, 3267631104, 3267631615, 'GB', 'GBR', 'المملكة المتحدة'),
(63683, 3267631616, 3267631935, 'DE', 'DEU', 'ألمانيا'),
(63684, 3267632000, 3267632127, 'DE', 'DEU', 'ألمانيا'),
(63685, 3267632384, 3267632511, 'BE', 'BEL', 'بلجيكا'),
(63686, 3267632640, 3267632895, 'IT', 'ITA', 'إيطاليا'),
(63687, 3267632896, 3267633151, 'BE', 'BEL', 'بلجيكا'),
(63688, 3267633152, 3267633679, 'NO', 'NOR', 'النرويج'),
(63689, 3267633728, 3267633855, 'NO', 'NOR', 'النرويج'),
(63690, 3267634176, 3267634431, 'GB', 'GBR', 'المملكة المتحدة'),
(63691, 3267634944, 3267635711, 'GB', 'GBR', 'المملكة المتحدة'),
(63692, 3267635968, 3267636223, 'BE', 'BEL', 'بلجيكا'),
(63693, 3267636736, 3267636783, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(63694, 3267636800, 3267636815, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(63695, 3267636832, 3267636991, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(63696, 3267636992, 3267637247, 'AT', 'AUT', 'النمسا'),
(63697, 3267637504, 3267637591, 'IT', 'ITA', 'إيطاليا'),
(63698, 3267637600, 3267637695, 'IT', 'ITA', 'إيطاليا'),
(63699, 3267637760, 3267637823, 'ES', 'ESP', 'إسبانيا'),
(63700, 3267637856, 3267637887, 'ES', 'ESP', 'إسبانيا'),
(63701, 3267638016, 3267638271, 'ES', 'ESP', 'إسبانيا'),
(63702, 3267638272, 3267638527, 'BE', 'BEL', 'بلجيكا'),
(63703, 3267638528, 3267638783, 'DK', 'DNK', 'الدنيمارك'),
(63704, 3267638784, 3267639295, 'CZ', 'CZE', 'التشيك'),
(63705, 3267639296, 3267639551, 'NL', 'NLD', 'هولندا'),
(63706, 3267639552, 3267639807, 'GB', 'GBR', 'المملكة المتحدة'),
(63707, 3267639808, 3267640063, 'CH', 'CHE', 'سويسرا'),
(63708, 3267640064, 3267640319, 'GB', 'GBR', 'المملكة المتحدة'),
(63709, 3267640320, 3267640575, 'CH', 'CHE', 'سويسرا'),
(63710, 3267640576, 3267640831, 'IT', 'ITA', 'إيطاليا'),
(63711, 3267640832, 3267641087, 'GR', 'GRC', 'اليونان'),
(63712, 3267641344, 3267641599, 'IE', 'IRL', 'إيرلندا'),
(63713, 3267641856, 3267642111, 'GB', 'GBR', 'المملكة المتحدة'),
(63714, 3267642112, 3267642367, 'SE', 'SWE', 'السويد'),
(63715, 3267642368, 3267642623, 'GB', 'GBR', 'المملكة المتحدة'),
(63716, 3267642624, 3267642879, 'NO', 'NOR', 'النرويج'),
(63717, 3267642880, 3267643135, 'SI', 'SVN', 'سلوفينيا'),
(63718, 3267643136, 3267643391, 'BE', 'BEL', 'بلجيكا'),
(63719, 3267643392, 3267643439, 'RU', 'RUS', 'الإتحاد الروسي'),
(63720, 3267643456, 3267643487, 'RU', 'RUS', 'الإتحاد الروسي'),
(63721, 3267643520, 3267643647, 'RU', 'RUS', 'الإتحاد الروسي'),
(63722, 3267643648, 3267643903, 'GB', 'GBR', 'المملكة المتحدة'),
(63723, 3267644160, 3267644415, 'BE', 'BEL', 'بلجيكا'),
(63724, 3267644416, 3267644671, 'DE', 'DEU', 'ألمانيا'),
(63725, 3267644672, 3267644927, 'SI', 'SVN', 'سلوفينيا'),
(63726, 3267644936, 3267644959, 'BE', 'BEL', 'بلجيكا'),
(63727, 3267644960, 3267644975, 'FR', 'FRA', 'فرنسا'),
(63728, 3267644976, 3267644983, 'GB', 'GBR', 'المملكة المتحدة'),
(63729, 3267644984, 3267645055, 'BE', 'BEL', 'بلجيكا'),
(63730, 3267645056, 3267645183, 'GB', 'GBR', 'المملكة المتحدة'),
(63731, 3267645440, 3267645695, 'GB', 'GBR', 'المملكة المتحدة'),
(63732, 3267645696, 3267645951, 'DE', 'DEU', 'ألمانيا'),
(63733, 3267645952, 3267646207, 'DK', 'DNK', 'الدنيمارك'),
(63734, 3267647488, 3267647743, 'GB', 'GBR', 'المملكة المتحدة'),
(63735, 3267647744, 3267647999, 'SI', 'SVN', 'سلوفينيا'),
(63736, 3267648000, 3267648255, 'DE', 'DEU', 'ألمانيا'),
(63737, 3267648432, 3267648447, 'BE', 'BEL', 'بلجيكا'),
(63738, 3267648448, 3267648479, 'FR', 'FRA', 'فرنسا'),
(63739, 3267648480, 3267648511, 'GB', 'GBR', 'المملكة المتحدة'),
(63740, 3267648512, 3267648767, 'DE', 'DEU', 'ألمانيا'),
(63741, 3267648768, 3267649023, 'NL', 'NLD', 'هولندا'),
(63742, 3267649024, 3267649279, 'RU', 'RUS', 'الإتحاد الروسي'),
(63743, 3267649280, 3267649295, 'DE', 'DEU', 'ألمانيا'),
(63744, 3267649312, 3267649471, 'DE', 'DEU', 'ألمانيا'),
(63745, 3267649792, 3267650303, 'NL', 'NLD', 'هولندا'),
(63746, 3267650320, 3267650367, 'AT', 'AUT', 'النمسا'),
(63747, 3267650464, 3267650495, 'AT', 'AUT', 'النمسا'),
(63748, 3267650528, 3267650559, 'AT', 'AUT', 'النمسا'),
(63749, 3267650560, 3267651071, 'GB', 'GBR', 'المملكة المتحدة'),
(63750, 3267651072, 3267651327, 'DE', 'DEU', 'ألمانيا'),
(63751, 3267651584, 3267651839, 'FR', 'FRA', 'فرنسا'),
(63752, 3267652096, 3267652351, 'GB', 'GBR', 'المملكة المتحدة'),
(63753, 3267652608, 3267652863, 'DE', 'DEU', 'ألمانيا'),
(63754, 3267652864, 3267653119, 'PT', 'PRT', 'البورتوغال'),
(63755, 3267653120, 3267653375, 'GB', 'GBR', 'المملكة المتحدة'),
(63756, 3267653888, 3267654143, 'GB', 'GBR', 'المملكة المتحدة'),
(63757, 3267654912, 3267655167, 'SK', 'SVK', 'سلوفاكيا'),
(63758, 3267655168, 3267655679, 'GB', 'GBR', 'المملكة المتحدة'),
(63759, 3267655680, 3267656191, 'IT', 'ITA', 'إيطاليا'),
(63760, 3267656192, 3267656447, 'DK', 'DNK', 'الدنيمارك'),
(63761, 3267657216, 3267657471, 'HU', 'HUN', 'هنغاريا'),
(63762, 3267657472, 3267657487, 'RO', 'ROM', 'رومانيا'),
(63763, 3267657504, 3267657567, 'RO', 'ROM', 'رومانيا'),
(63764, 3267657664, 3267657679, 'RO', 'ROM', 'رومانيا'),
(63765, 3267657984, 3267658239, 'GB', 'GBR', 'المملكة المتحدة'),
(63766, 3267658240, 3267658495, 'IT', 'ITA', 'إيطاليا'),
(63767, 3267658752, 3267659263, 'CH', 'CHE', 'سويسرا'),
(63768, 3267659520, 3267659775, 'IT', 'ITA', 'إيطاليا'),
(63769, 3267660288, 3267660543, 'CH', 'CHE', 'سويسرا'),
(63770, 3267660544, 3267660671, 'ES', 'ESP', 'إسبانيا'),
(63771, 3267661312, 3267661567, 'SK', 'SVK', 'سلوفاكيا'),
(63772, 3267661568, 3267661679, 'GB', 'GBR', 'المملكة المتحدة'),
(63773, 3267661696, 3267661823, 'GB', 'GBR', 'المملكة المتحدة'),
(63774, 3267661824, 3267661847, 'ES', 'ESP', 'إسبانيا'),
(63775, 3267661856, 3267661887, 'ES', 'ESP', 'إسبانيا'),
(63776, 3267662024, 3267662031, 'ES', 'ESP', 'إسبانيا'),
(63777, 3267662048, 3267662079, 'ES', 'ESP', 'إسبانيا'),
(63778, 3267662848, 3267662879, 'IE', 'IRL', 'إيرلندا'),
(63779, 3267662888, 3267662895, 'GB', 'GBR', 'المملكة المتحدة'),
(63780, 3267662896, 3267662951, 'IE', 'IRL', 'إيرلندا'),
(63781, 3267662952, 3267662959, 'GB', 'GBR', 'المملكة المتحدة'),
(63782, 3267662960, 3267662991, 'IE', 'IRL', 'إيرلندا'),
(63783, 3267663008, 3267663071, 'IE', 'IRL', 'إيرلندا'),
(63784, 3267663088, 3267663103, 'IE', 'IRL', 'إيرلندا'),
(63785, 3267663104, 3267663327, 'IT', 'ITA', 'إيطاليا'),
(63786, 3267663360, 3267663871, 'GB', 'GBR', 'المملكة المتحدة'),
(63787, 3267663872, 3267664127, 'DE', 'DEU', 'ألمانيا'),
(63788, 3267664384, 3267664639, 'GB', 'GBR', 'المملكة المتحدة'),
(63789, 3267664640, 3267664671, 'SK', 'SVK', 'سلوفاكيا'),
(63790, 3267664800, 3267664815, 'SK', 'SVK', 'سلوفاكيا'),
(63791, 3267664832, 3267664879, 'SK', 'SVK', 'سلوفاكيا'),
(63792, 3267664888, 3267664895, 'SK', 'SVK', 'سلوفاكيا'),
(63793, 3267665920, 3267666175, 'GB', 'GBR', 'المملكة المتحدة'),
(63794, 3267666192, 3267666207, 'GR', 'GRC', 'اليونان'),
(63795, 3267666256, 3267666263, 'GR', 'GRC', 'اليونان'),
(63796, 3267666272, 3267666431, 'GR', 'GRC', 'اليونان'),
(63797, 3267666432, 3267666447, 'GB', 'GBR', 'المملكة المتحدة'),
(63798, 3267666496, 3267666543, 'GB', 'GBR', 'المملكة المتحدة'),
(63799, 3267666576, 3267667199, 'GB', 'GBR', 'المملكة المتحدة'),
(63800, 3267667200, 3267667455, 'NL', 'NLD', 'هولندا'),
(63801, 3267667456, 3267667967, 'GB', 'GBR', 'المملكة المتحدة'),
(63802, 3267670016, 3267671551, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(63803, 3267671552, 3267671807, 'DE', 'DEU', 'ألمانيا'),
(63804, 3267671808, 3267672063, 'NO', 'NOR', 'النرويج'),
(63805, 3267672064, 3267672223, 'DE', 'DEU', 'ألمانيا'),
(63806, 3267672256, 3267672319, 'DE', 'DEU', 'ألمانيا'),
(63807, 3267672576, 3267672831, 'AT', 'AUT', 'النمسا'),
(63808, 3267672832, 3267672927, 'FR', 'FRA', 'فرنسا'),
(63809, 3267672936, 3267672999, 'FR', 'FRA', 'فرنسا'),
(63810, 3267673008, 3267673015, 'FR', 'FRA', 'فرنسا'),
(63811, 3267673024, 3267673087, 'FR', 'FRA', 'فرنسا'),
(63812, 3267673088, 3267673439, 'DE', 'DEU', 'ألمانيا'),
(63813, 3267673472, 3267673503, 'DE', 'DEU', 'ألمانيا'),
(63814, 3267673600, 3267673759, 'DE', 'DEU', 'ألمانيا'),
(63815, 3267673808, 3267673855, 'DE', 'DEU', 'ألمانيا'),
(63816, 3267674112, 3267674127, 'NL', 'NLD', 'هولندا'),
(63817, 3267674128, 3267674159, 'GB', 'GBR', 'المملكة المتحدة'),
(63818, 3267674160, 3267674207, 'BE', 'BEL', 'بلجيكا'),
(63819, 3267674208, 3267674239, 'GB', 'GBR', 'المملكة المتحدة'),
(63820, 3267674240, 3267674303, 'BE', 'BEL', 'بلجيكا'),
(63821, 3267674336, 3267674367, 'GB', 'GBR', 'المملكة المتحدة'),
(63822, 3267674368, 3267674879, 'BE', 'BEL', 'بلجيكا'),
(63823, 3267675136, 3267675391, 'AT', 'AUT', 'النمسا'),
(63824, 3267675392, 3267675615, 'CH', 'CHE', 'سويسرا'),
(63825, 3267675624, 3267675631, 'CH', 'CHE', 'سويسرا'),
(63826, 3267675648, 3267675775, 'CY', 'CYP', 'قبرص'),
(63827, 3267675776, 3267675903, 'CH', 'CHE', 'سويسرا'),
(63828, 3267676160, 3267676415, 'GB', 'GBR', 'المملكة المتحدة'),
(63829, 3267676672, 3267676679, 'HU', 'HUN', 'هنغاريا'),
(63830, 3267676688, 3267676711, 'HU', 'HUN', 'هنغاريا'),
(63831, 3267676736, 3267676767, 'HU', 'HUN', 'هنغاريا'),
(63832, 3267676784, 3267676799, 'HU', 'HUN', 'هنغاريا'),
(63833, 3267676864, 3267676879, 'HU', 'HUN', 'هنغاريا'),
(63834, 3267676928, 3267677367, 'GB', 'GBR', 'المملكة المتحدة'),
(63835, 3267677376, 3267677695, 'GB', 'GBR', 'المملكة المتحدة'),
(63836, 3267678208, 3267678719, 'FR', 'FRA', 'فرنسا'),
(63837, 3267678976, 3267679231, 'NL', 'NLD', 'هولندا'),
(63838, 3267679488, 3267679743, 'BE', 'BEL', 'بلجيكا'),
(63839, 3267680000, 3267680255, 'CZ', 'CZE', 'التشيك'),
(63840, 3267680256, 3267680767, 'SK', 'SVK', 'سلوفاكيا'),
(63841, 3267681280, 3267681319, 'FR', 'FRA', 'فرنسا'),
(63842, 3267681328, 3267681503, 'FR', 'FRA', 'فرنسا'),
(63843, 3267681512, 3267681535, 'FR', 'FRA', 'فرنسا'),
(63844, 3267681792, 3267681887, 'FR', 'FRA', 'فرنسا'),
(63845, 3267681904, 3267681975, 'FR', 'FRA', 'فرنسا'),
(63846, 3267682016, 3267682047, 'FR', 'FRA', 'فرنسا'),
(63847, 3267682304, 3267682559, 'BE', 'BEL', 'بلجيكا'),
(63848, 3267683336, 3267683359, 'PL', 'POL', 'بولندا'),
(63849, 3267683392, 3267683471, 'PL', 'POL', 'بولندا'),
(63850, 3267683520, 3267683527, 'PL', 'POL', 'بولندا'),
(63851, 3267683536, 3267683551, 'PL', 'POL', 'بولندا'),
(63852, 3267683568, 3267683575, 'PL', 'POL', 'بولندا'),
(63853, 3267684384, 3267684399, 'GB', 'GBR', 'المملكة المتحدة'),
(63854, 3267684416, 3267684783, 'GB', 'GBR', 'المملكة المتحدة'),
(63855, 3267684792, 3267685119, 'GB', 'GBR', 'المملكة المتحدة'),
(63856, 3267685120, 3267685375, 'DE', 'DEU', 'ألمانيا'),
(63857, 3267685376, 3267685887, 'NL', 'NLD', 'هولندا'),
(63858, 3267685888, 3267686399, 'GB', 'GBR', 'المملكة المتحدة'),
(63859, 3267687936, 3267688191, 'IE', 'IRL', 'إيرلندا'),
(63860, 3267688192, 3267688703, 'DE', 'DEU', 'ألمانيا'),
(63861, 3267688704, 3267688959, 'SE', 'SWE', 'السويد'),
(63862, 3267689216, 3267689247, 'CZ', 'CZE', 'التشيك'),
(63863, 3267689328, 3267689471, 'CZ', 'CZE', 'التشيك'),
(63864, 3267689728, 3267689983, 'GB', 'GBR', 'المملكة المتحدة'),
(63865, 3267689984, 3267690239, 'FR', 'FRA', 'فرنسا'),
(63866, 3267690272, 3267690495, 'FR', 'FRA', 'فرنسا'),
(63867, 3267690496, 3267691519, 'FI', 'FIN', 'فنلندا'),
(63868, 3267691520, 3267692543, 'SE', 'SWE', 'السويد'),
(63869, 3267692544, 3267711999, 'FI', 'FIN', 'فنلندا'),
(63870, 3267712000, 3267712255, 'SE', 'SWE', 'السويد'),
(63871, 3267712256, 3267741439, 'FI', 'FIN', 'فنلندا'),
(63872, 3267741440, 3267741695, 'BE', 'BEL', 'بلجيكا'),
(63873, 3267741696, 3267741759, 'FI', 'FIN', 'فنلندا'),
(63874, 3267741760, 3267741791, 'SE', 'SWE', 'السويد'),
(63875, 3267741792, 3267741855, 'FI', 'FIN', 'فنلندا'),
(63876, 3267741856, 3267741919, 'SE', 'SWE', 'السويد'),
(63877, 3267741920, 3267743999, 'FI', 'FIN', 'فنلندا'),
(63878, 3267744000, 3267744255, 'DE', 'DEU', 'ألمانيا'),
(63879, 3267744256, 3267744511, 'BE', 'BEL', 'بلجيكا'),
(63880, 3267744512, 3267746303, 'FI', 'FIN', 'فنلندا'),
(63881, 3267746304, 3267746559, 'NL', 'NLD', 'هولندا'),
(63882, 3267746560, 3267756031, 'FI', 'FIN', 'فنلندا'),
(63883, 3267756032, 3267760639, 'SE', 'SWE', 'السويد'),
(63884, 3267760640, 3267761151, 'NO', 'NOR', 'النرويج'),
(63885, 3267761152, 3267761919, 'SE', 'SWE', 'السويد'),
(63886, 3267761920, 3267762175, 'NO', 'NOR', 'النرويج'),
(63887, 3267762176, 3267763711, 'SE', 'SWE', 'السويد'),
(63888, 3267763712, 3267763967, 'NO', 'NOR', 'النرويج'),
(63889, 3267763968, 3267764223, 'SE', 'SWE', 'السويد'),
(63890, 3267764224, 3267764479, 'NO', 'NOR', 'النرويج'),
(63891, 3267764480, 3267765775, 'SE', 'SWE', 'السويد'),
(63892, 3267765776, 3267765791, 'NO', 'NOR', 'النرويج'),
(63893, 3267765792, 3267765823, 'SE', 'SWE', 'السويد'),
(63894, 3267765824, 3267765855, 'NO', 'NOR', 'النرويج'),
(63895, 3267765856, 3267766031, 'SE', 'SWE', 'السويد'),
(63896, 3267766032, 3267766047, 'NO', 'NOR', 'النرويج'),
(63897, 3267766048, 3267766303, 'SE', 'SWE', 'السويد'),
(63898, 3267766304, 3267766319, 'NO', 'NOR', 'النرويج'),
(63899, 3267766320, 3267766351, 'SE', 'SWE', 'السويد'),
(63900, 3267766352, 3267766367, 'NO', 'NOR', 'النرويج'),
(63901, 3267766368, 3267766383, 'SE', 'SWE', 'السويد'),
(63902, 3267766384, 3267766415, 'NO', 'NOR', 'النرويج'),
(63903, 3267766416, 3267787007, 'SE', 'SWE', 'السويد'),
(63904, 3267787008, 3267787263, 'NO', 'NOR', 'النرويج'),
(63905, 3267787264, 3267787519, 'SE', 'SWE', 'السويد'),
(63906, 3267787520, 3267787775, 'NO', 'NOR', 'النرويج'),
(63907, 3267787776, 3267793919, 'SE', 'SWE', 'السويد'),
(63908, 3267793920, 3267794175, 'DK', 'DNK', 'الدنيمارك'),
(63909, 3267794176, 3267821567, 'SE', 'SWE', 'السويد'),
(63910, 3267821568, 3267887103, 'FR', 'FRA', 'فرنسا'),
(63911, 3267887104, 3268017407, 'GB', 'GBR', 'المملكة المتحدة'),
(63912, 3268017408, 3268017663, 'KE', 'KEN', 'كينيا'),
(63913, 3268017664, 3268149247, 'GB', 'GBR', 'المملكة المتحدة'),
(63914, 3268149248, 3268165631, 'EE', 'EST', 'إستونيا'),
(63915, 3268165632, 3268173823, 'CH', 'CHE', 'سويسرا'),
(63916, 3268173824, 3268182015, 'MT', 'MLT', 'مالطا'),
(63917, 3268182016, 3268198399, 'PL', 'POL', 'بولندا'),
(63918, 3268215584, 3268215615, 'GB', 'GBR', 'المملكة المتحدة'),
(63919, 3268215648, 3268215679, 'GB', 'GBR', 'المملكة المتحدة'),
(63920, 3268215712, 3268215743, 'GB', 'GBR', 'المملكة المتحدة'),
(63921, 3268215808, 3268216063, 'GB', 'GBR', 'المملكة المتحدة'),
(63922, 3268218112, 3268218367, 'GB', 'GBR', 'المملكة المتحدة'),
(63923, 3268219808, 3268219823, 'GB', 'GBR', 'المملكة المتحدة'),
(63924, 3268219856, 3268219871, 'GB', 'GBR', 'المملكة المتحدة'),
(63925, 3268221440, 3268221471, 'GB', 'GBR', 'المملكة المتحدة'),
(63926, 3268221504, 3268221599, 'GB', 'GBR', 'المملكة المتحدة'),
(63927, 3268221696, 3268221951, 'GB', 'GBR', 'المملكة المتحدة'),
(63928, 3268222976, 3268223167, 'GB', 'GBR', 'المملكة المتحدة'),
(63929, 3268223200, 3268223231, 'GB', 'GBR', 'المملكة المتحدة'),
(63930, 3268224768, 3268225023, 'US', 'USA', 'الولايات المتحدة'),
(63931, 3268226368, 3268226815, 'GB', 'GBR', 'المملكة المتحدة'),
(63932, 3268227328, 3268227391, 'GB', 'GBR', 'المملكة المتحدة'),
(63933, 3268227520, 3268227615, 'GB', 'GBR', 'المملكة المتحدة'),
(63934, 3268229632, 3268229887, 'GB', 'GBR', 'المملكة المتحدة'),
(63935, 3268230656, 3268230911, 'GB', 'GBR', 'المملكة المتحدة'),
(63936, 3268231168, 3268231199, 'GB', 'GBR', 'المملكة المتحدة'),
(63937, 3268231320, 3268231359, 'GB', 'GBR', 'المملكة المتحدة'),
(63938, 3268231392, 3268231423, 'GB', 'GBR', 'المملكة المتحدة'),
(63939, 3268231648, 3268231679, 'GB', 'GBR', 'المملكة المتحدة'),
(63940, 3268231744, 3268231807, 'GB', 'GBR', 'المملكة المتحدة'),
(63941, 3268232224, 3268232243, 'GB', 'GBR', 'المملكة المتحدة'),
(63942, 3268232352, 3268232367, 'GB', 'GBR', 'المملكة المتحدة'),
(63943, 3268232384, 3268232415, 'GB', 'GBR', 'المملكة المتحدة'),
(63944, 3268232480, 3268232575, 'GB', 'GBR', 'المملكة المتحدة'),
(63945, 3268232960, 3268233087, 'GB', 'GBR', 'المملكة المتحدة'),
(63946, 3268233920, 3268234047, 'GB', 'GBR', 'المملكة المتحدة'),
(63947, 3268234176, 3268234239, 'GB', 'GBR', 'المملكة المتحدة'),
(63948, 3268234560, 3268234623, 'GB', 'GBR', 'المملكة المتحدة'),
(63949, 3268235008, 3268235263, 'GB', 'GBR', 'المملكة المتحدة'),
(63950, 3268235264, 3268235519, 'DE', 'DEU', 'ألمانيا'),
(63951, 3268235520, 3268235775, 'GB', 'GBR', 'المملكة المتحدة'),
(63952, 3268235936, 3268236031, 'GB', 'GBR', 'المملكة المتحدة'),
(63953, 3268236192, 3268236207, 'GB', 'GBR', 'المملكة المتحدة'),
(63954, 3268236544, 3268236607, 'GB', 'GBR', 'المملكة المتحدة'),
(63955, 3268236672, 3268236799, 'GB', 'GBR', 'المملكة المتحدة'),
(63956, 3268237312, 3268237567, 'GB', 'GBR', 'المملكة المتحدة'),
(63957, 3268237824, 3268237847, 'GB', 'GBR', 'المملكة المتحدة'),
(63958, 3268237856, 3268237887, 'GB', 'GBR', 'المملكة المتحدة'),
(63959, 3268238336, 3268238359, 'GB', 'GBR', 'المملكة المتحدة'),
(63960, 3268238360, 3268238367, 'DE', 'DEU', 'ألمانيا'),
(63961, 3268238368, 3268238463, 'GB', 'GBR', 'المملكة المتحدة'),
(63962, 3268238464, 3268238471, 'DE', 'DEU', 'ألمانيا'),
(63963, 3268238480, 3268238527, 'GB', 'GBR', 'المملكة المتحدة'),
(63964, 3268239104, 3268239359, 'GB', 'GBR', 'المملكة المتحدة'),
(63965, 3268239584, 3268240127, 'GB', 'GBR', 'المملكة المتحدة'),
(63966, 3268240160, 3268240191, 'GB', 'GBR', 'المملكة المتحدة'),
(63967, 3268240256, 3268240399, 'GB', 'GBR', 'المملكة المتحدة'),
(63968, 3268240688, 3268240695, 'GB', 'GBR', 'المملكة المتحدة'),
(63969, 3268240712, 3268240735, 'GB', 'GBR', 'المملكة المتحدة'),
(63970, 3268240744, 3268240751, 'GB', 'GBR', 'المملكة المتحدة'),
(63971, 3268240776, 3268240783, 'GB', 'GBR', 'المملكة المتحدة'),
(63972, 3268240976, 3268240991, 'GB', 'GBR', 'المملكة المتحدة'),
(63973, 3268241008, 3268241023, 'GB', 'GBR', 'المملكة المتحدة'),
(63974, 3268241544, 3268241551, 'GB', 'GBR', 'المملكة المتحدة'),
(63975, 3268241640, 3268241663, 'GB', 'GBR', 'المملكة المتحدة'),
(63976, 3268242496, 3268242523, 'GB', 'GBR', 'المملكة المتحدة'),
(63977, 3268242880, 3268243103, 'GB', 'GBR', 'المملكة المتحدة'),
(63978, 3268243328, 3268243391, 'GB', 'GBR', 'المملكة المتحدة'),
(63979, 3268243744, 3268243775, 'GB', 'GBR', 'المملكة المتحدة'),
(63980, 3268243968, 3268244031, 'GB', 'GBR', 'المملكة المتحدة'),
(63981, 3268244776, 3268244783, 'GB', 'GBR', 'المملكة المتحدة'),
(63982, 3268244792, 3268244799, 'GB', 'GBR', 'المملكة المتحدة'),
(63983, 3268245112, 3268245115, 'GB', 'GBR', 'المملكة المتحدة'),
(63984, 3268245504, 3268245759, 'GB', 'GBR', 'المملكة المتحدة'),
(63985, 3268246272, 3268246783, 'GB', 'GBR', 'المملكة المتحدة'),
(63986, 3268246792, 3268246807, 'GB', 'GBR', 'المملكة المتحدة'),
(63987, 3268246912, 3268246927, 'GB', 'GBR', 'المملكة المتحدة'),
(63988, 3268246960, 3268246991, 'GB', 'GBR', 'المملكة المتحدة'),
(63989, 3268248320, 3268248447, 'GB', 'GBR', 'المملكة المتحدة'),
(63990, 3268248512, 3268248543, 'GB', 'GBR', 'المملكة المتحدة'),
(63991, 3268248832, 3268248959, 'GB', 'GBR', 'المملكة المتحدة'),
(63992, 3268249600, 3268251311, 'GB', 'GBR', 'المملكة المتحدة'),
(63993, 3268251312, 3268251327, 'IE', 'IRL', 'إيرلندا'),
(63994, 3268251328, 3268251583, 'GB', 'GBR', 'المملكة المتحدة'),
(63995, 3268251584, 3268251615, 'DE', 'DEU', 'ألمانيا'),
(63996, 3268251616, 3268251631, 'CH', 'CHE', 'سويسرا'),
(63997, 3268251632, 3268251647, 'GB', 'GBR', 'المملكة المتحدة'),
(63998, 3268254464, 3268254543, 'GB', 'GBR', 'المملكة المتحدة'),
(63999, 3268254592, 3268254607, 'GB', 'GBR', 'المملكة المتحدة'),
(64000, 3268254624, 3268254639, 'GB', 'GBR', 'المملكة المتحدة'),
(64001, 3268254896, 3268254903, 'GB', 'GBR', 'المملكة المتحدة'),
(64002, 3268255824, 3268255863, 'GB', 'GBR', 'المملكة المتحدة'),
(64003, 3268255872, 3268255887, 'GB', 'GBR', 'المملكة المتحدة'),
(64004, 3268255896, 3268255919, 'GB', 'GBR', 'المملكة المتحدة'),
(64005, 3268255952, 3268255983, 'GB', 'GBR', 'المملكة المتحدة'),
(64006, 3268256896, 3268256959, 'GB', 'GBR', 'المملكة المتحدة'),
(64007, 3268257024, 3268257055, 'GB', 'GBR', 'المملكة المتحدة'),
(64008, 3268257088, 3268257119, 'GB', 'GBR', 'المملكة المتحدة'),
(64009, 3268257264, 3268257271, 'GB', 'GBR', 'المملكة المتحدة'),
(64010, 3268257416, 3268257419, 'GB', 'GBR', 'المملكة المتحدة'),
(64011, 3268257424, 3268257431, 'GB', 'GBR', 'المملكة المتحدة'),
(64012, 3268257432, 3268257439, 'IT', 'ITA', 'إيطاليا'),
(64013, 3268257456, 3268257471, 'GB', 'GBR', 'المملكة المتحدة'),
(64014, 3268257488, 3268257527, 'GB', 'GBR', 'المملكة المتحدة'),
(64015, 3268258560, 3268258623, 'GB', 'GBR', 'المملكة المتحدة'),
(64016, 3268258688, 3268258751, 'GB', 'GBR', 'المملكة المتحدة'),
(64017, 3268259264, 3268259327, 'GB', 'GBR', 'المملكة المتحدة'),
(64018, 3268259520, 3268259527, 'GB', 'GBR', 'المملكة المتحدة'),
(64019, 3268259544, 3268259551, 'GB', 'GBR', 'المملكة المتحدة'),
(64020, 3268259560, 3268259575, 'GB', 'GBR', 'المملكة المتحدة'),
(64021, 3268259808, 3268259823, 'GB', 'GBR', 'المملكة المتحدة'),
(64022, 3268259832, 3268260095, 'GB', 'GBR', 'المملكة المتحدة'),
(64023, 3268260352, 3268260383, 'GB', 'GBR', 'المملكة المتحدة'),
(64024, 3268260416, 3268260447, 'GB', 'GBR', 'المملكة المتحدة'),
(64025, 3268260512, 3268260607, 'GB', 'GBR', 'المملكة المتحدة'),
(64026, 3268260640, 3268260647, 'GB', 'GBR', 'المملكة المتحدة'),
(64027, 3268260656, 3268260671, 'GB', 'GBR', 'المملكة المتحدة'),
(64028, 3268261936, 3268261951, 'GB', 'GBR', 'المملكة المتحدة'),
(64029, 3268262768, 3268262783, 'GB', 'GBR', 'المملكة المتحدة'),
(64030, 3268262880, 3268262887, 'GB', 'GBR', 'المملكة المتحدة'),
(64031, 3268263232, 3268263263, 'GB', 'GBR', 'المملكة المتحدة'),
(64032, 3268263392, 3268263423, 'GB', 'GBR', 'المملكة المتحدة'),
(64033, 3268263776, 3268263783, 'GB', 'GBR', 'المملكة المتحدة'),
(64034, 3268264736, 3268264767, 'GB', 'GBR', 'المملكة المتحدة'),
(64035, 3268265416, 3268265431, 'GB', 'GBR', 'المملكة المتحدة'),
(64036, 3268265984, 3268266495, 'GB', 'GBR', 'المملكة المتحدة'),
(64037, 3268266984, 3268266991, 'GB', 'GBR', 'المملكة المتحدة'),
(64038, 3268267536, 3268267551, 'GB', 'GBR', 'المملكة المتحدة'),
(64039, 3268267584, 3268267599, 'GB', 'GBR', 'المملكة المتحدة'),
(64040, 3268267616, 3268267647, 'GB', 'GBR', 'المملكة المتحدة'),
(64041, 3268267744, 3268267775, 'GB', 'GBR', 'المملكة المتحدة'),
(64042, 3268267952, 3268267959, 'GB', 'GBR', 'المملكة المتحدة'),
(64043, 3268268544, 3268268799, 'GB', 'GBR', 'المملكة المتحدة'),
(64044, 3268270352, 3268270367, 'GB', 'GBR', 'المملكة المتحدة'),
(64045, 3268270496, 3268270511, 'GB', 'GBR', 'المملكة المتحدة'),
(64046, 3268270848, 3268271359, 'GB', 'GBR', 'المملكة المتحدة'),
(64047, 3268271912, 3268271919, 'GB', 'GBR', 'المملكة المتحدة'),
(64048, 3268271928, 3268271935, 'GB', 'GBR', 'المملكة المتحدة'),
(64049, 3268272704, 3268272719, 'GB', 'GBR', 'المملكة المتحدة'),
(64050, 3268272728, 3268272743, 'GB', 'GBR', 'المملكة المتحدة'),
(64051, 3268272752, 3268272759, 'GB', 'GBR', 'المملكة المتحدة'),
(64052, 3268273024, 3268273151, 'GB', 'GBR', 'المملكة المتحدة'),
(64053, 3268273920, 3268273983, 'GB', 'GBR', 'المملكة المتحدة'),
(64054, 3268274112, 3268274175, 'GB', 'GBR', 'المملكة المتحدة'),
(64055, 3268274456, 3268274459, 'GB', 'GBR', 'المملكة المتحدة'),
(64056, 3268274528, 3268274543, 'GB', 'GBR', 'المملكة المتحدة'),
(64057, 3268274560, 3268274591, 'GB', 'GBR', 'المملكة المتحدة'),
(64058, 3268275984, 3268275999, 'GB', 'GBR', 'المملكة المتحدة'),
(64059, 3268276640, 3268276655, 'GB', 'GBR', 'المملكة المتحدة'),
(64060, 3268276672, 3268276687, 'GB', 'GBR', 'المملكة المتحدة'),
(64061, 3268276768, 3268276799, 'GB', 'GBR', 'المملكة المتحدة'),
(64062, 3268276864, 3268276895, 'GB', 'GBR', 'المملكة المتحدة'),
(64063, 3268277056, 3268277119, 'GB', 'GBR', 'المملكة المتحدة'),
(64064, 3268277760, 3268278015, 'GB', 'GBR', 'المملكة المتحدة'),
(64065, 3268278464, 3268278495, 'GB', 'GBR', 'المملكة المتحدة'),
(64066, 3268280064, 3268280319, 'GB', 'GBR', 'المملكة المتحدة'),
(64067, 3268280320, 3268335615, 'FR', 'FRA', 'فرنسا'),
(64068, 3268335616, 3268335871, 'CH', 'CHE', 'سويسرا'),
(64069, 3268335872, 3268345855, 'FR', 'FRA', 'فرنسا'),
(64070, 3268345856, 3268411391, 'GB', 'GBR', 'المملكة المتحدة'),
(64071, 3268411392, 3268424959, 'AT', 'AUT', 'النمسا'),
(64072, 3268424960, 3268425727, 'CH', 'CHE', 'سويسرا'),
(64073, 3268425728, 3268425983, 'LI', 'LIE', 'ليختنشتاين'),
(64074, 3268425984, 3268426495, 'AT', 'AUT', 'النمسا'),
(64075, 3268426496, 3268428031, 'CH', 'CHE', 'سويسرا'),
(64076, 3268428032, 3268428287, 'AT', 'AUT', 'النمسا'),
(64077, 3268428288, 3268428543, 'CH', 'CHE', 'سويسرا'),
(64078, 3268428544, 3268429055, 'AT', 'AUT', 'النمسا'),
(64079, 3268429056, 3268429311, 'CH', 'CHE', 'سويسرا'),
(64080, 3268429312, 3268429567, 'AT', 'AUT', 'النمسا'),
(64081, 3268429568, 3268430079, 'CH', 'CHE', 'سويسرا'),
(64082, 3268430080, 3268430847, 'AT', 'AUT', 'النمسا'),
(64083, 3268430848, 3268431103, 'LI', 'LIE', 'ليختنشتاين'),
(64084, 3268431104, 3268476927, 'AT', 'AUT', 'النمسا'),
(64085, 3268476928, 3268542463, 'CH', 'CHE', 'سويسرا'),
(64086, 3268542464, 3268607999, 'PT', 'PRT', 'البورتوغال'),
(64087, 3268608000, 3268673535, 'FI', 'FIN', 'فنلندا'),
(64088, 3268673536, 3268703799, 'CZ', 'CZE', 'التشيك'),
(64089, 3268703800, 3268703807, 'CR', 'CRI', 'كوستا ريكا'),
(64090, 3268703808, 3268728287, 'CZ', 'CZE', 'التشيك'),
(64091, 3268728288, 3268728299, 'CR', 'CRI', 'كوستا ريكا'),
(64092, 3268728300, 3268739071, 'CZ', 'CZE', 'التشيك'),
(64093, 3268739072, 3268739327, 'DE', 'DEU', 'ألمانيا'),
(64094, 3268739328, 3268739583, 'PL', 'POL', 'بولندا'),
(64095, 3268739584, 3268739839, 'DE', 'DEU', 'ألمانيا'),
(64096, 3268739840, 3268740095, 'CH', 'CHE', 'سويسرا'),
(64097, 3268740096, 3268740351, 'IL', 'ISR', 'إسرائيل'),
(64098, 3268740352, 3268740607, 'DE', 'DEU', 'ألمانيا'),
(64099, 3268740608, 3268740863, 'UA', 'UKR', 'أوكرانيا'),
(64100, 3268740864, 3268741119, 'CH', 'CHE', 'سويسرا'),
(64101, 3268741120, 3268741375, 'FR', 'FRA', 'فرنسا'),
(64102, 3268741376, 3268741887, 'LV', 'LVA', 'لاتفيا'),
(64103, 3268741888, 3268742143, 'AT', 'AUT', 'النمسا'),
(64104, 3268742144, 3268742399, 'RU', 'RUS', 'الإتحاد الروسي'),
(64105, 3268742400, 3268742655, 'CZ', 'CZE', 'التشيك'),
(64106, 3268742656, 3268742911, 'BE', 'BEL', 'بلجيكا'),
(64107, 3268742912, 3268743167, 'NL', 'NLD', 'هولندا'),
(64108, 3268743168, 3268743423, 'RO', 'ROM', 'رومانيا'),
(64109, 3268743424, 3268743679, 'PL', 'POL', 'بولندا'),
(64110, 3268743680, 3268743935, 'GR', 'GRC', 'اليونان'),
(64111, 3268743936, 3268744191, 'ES', 'ESP', 'إسبانيا'),
(64112, 3268744192, 3268744447, 'DE', 'DEU', 'ألمانيا'),
(64113, 3268744448, 3268744703, 'RU', 'RUS', 'الإتحاد الروسي'),
(64114, 3268744704, 3268744959, 'PL', 'POL', 'بولندا'),
(64115, 3268744960, 3268745215, 'UA', 'UKR', 'أوكرانيا'),
(64116, 3268745216, 3268745471, 'KZ', 'KAZ', 'كازاخستان'),
(64117, 3268745472, 3268745727, 'RU', 'RUS', 'الإتحاد الروسي'),
(64118, 3268745984, 3268746239, 'DE', 'DEU', 'ألمانيا'),
(64119, 3268746240, 3268746495, 'GB', 'GBR', 'المملكة المتحدة'),
(64120, 3268746496, 3268746751, 'IE', 'IRL', 'إيرلندا'),
(64121, 3268746752, 3268747007, 'FR', 'FRA', 'فرنسا'),
(64122, 3268747008, 3268747263, 'DE', 'DEU', 'ألمانيا'),
(64123, 3268747264, 3268755455, 'CZ', 'CZE', 'التشيك'),
(64124, 3268755456, 3268763647, 'SE', 'SWE', 'السويد'),
(64125, 3268771840, 3268788223, 'NO', 'NOR', 'النرويج'),
(64126, 3268788224, 3268804607, 'CZ', 'CZE', 'التشيك'),
(64127, 3268804608, 3268869375, 'FR', 'FRA', 'فرنسا'),
(64128, 3268869376, 3268870143, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(64129, 3268870144, 3268876063, 'FI', 'FIN', 'فنلندا'),
(64130, 3268876064, 3268876127, 'SE', 'SWE', 'السويد'),
(64131, 3268876128, 3268876191, 'FI', 'FIN', 'فنلندا'),
(64132, 3268876192, 3268876223, 'SE', 'SWE', 'السويد'),
(64133, 3268876224, 3268881151, 'FI', 'FIN', 'فنلندا'),
(64134, 3268881152, 3268881407, 'SE', 'SWE', 'السويد'),
(64135, 3268881408, 3268881919, 'FI', 'FIN', 'فنلندا'),
(64136, 3268881920, 3268882175, 'SE', 'SWE', 'السويد'),
(64137, 3268882176, 3268916223, 'FI', 'FIN', 'فنلندا'),
(64138, 3268916224, 3268916479, 'GB', 'GBR', 'المملكة المتحدة'),
(64139, 3268916480, 3268920575, 'FI', 'FIN', 'فنلندا'),
(64140, 3268920576, 3268920831, 'SE', 'SWE', 'السويد'),
(64141, 3268920832, 3268932351, 'FI', 'FIN', 'فنلندا'),
(64142, 3268932352, 3268932607, 'RU', 'RUS', 'الإتحاد الروسي'),
(64143, 3268932608, 3268935679, 'FI', 'FIN', 'فنلندا'),
(64144, 3268935680, 3269057535, 'GB', 'GBR', 'المملكة المتحدة'),
(64145, 3269057536, 3269058047, 'NL', 'NLD', 'هولندا'),
(64146, 3269058048, 3269066751, 'GB', 'GBR', 'المملكة المتحدة'),
(64147, 3269066752, 3269131555, 'SE', 'SWE', 'السويد'),
(64148, 3269131556, 3269131559, 'NO', 'NOR', 'النرويج'),
(64149, 3269131560, 3269132287, 'SE', 'SWE', 'السويد'),
(64150, 3269132288, 3269197823, 'GR', 'GRC', 'اليونان'),
(64151, 3269197824, 3269200639, 'RU', 'RUS', 'الإتحاد الروسي'),
(64152, 3269200640, 3269200895, 'UA', 'UKR', 'أوكرانيا'),
(64153, 3269200896, 3269212671, 'RU', 'RUS', 'الإتحاد الروسي'),
(64154, 3269212672, 3269213183, 'UA', 'UKR', 'أوكرانيا'),
(64155, 3269213184, 3269231871, 'RU', 'RUS', 'الإتحاد الروسي'),
(64156, 3269231872, 3269232127, 'UA', 'UKR', 'أوكرانيا'),
(64157, 3269232128, 3269233407, 'RU', 'RUS', 'الإتحاد الروسي'),
(64158, 3269233408, 3269233663, 'UA', 'UKR', 'أوكرانيا'),
(64159, 3269233664, 3269239039, 'RU', 'RUS', 'الإتحاد الروسي'),
(64160, 3269239040, 3269239295, 'UA', 'UKR', 'أوكرانيا'),
(64161, 3269239296, 3269263359, 'RU', 'RUS', 'الإتحاد الروسي'),
(64162, 3269264640, 3269264895, 'DE', 'DEU', 'ألمانيا'),
(64163, 3269265856, 3269265919, 'DE', 'DEU', 'ألمانيا'),
(64164, 3269265920, 3269266175, 'GB', 'GBR', 'المملكة المتحدة'),
(64165, 3269266688, 3269266943, 'DE', 'DEU', 'ألمانيا'),
(64166, 3269266944, 3269267455, 'GB', 'GBR', 'المملكة المتحدة'),
(64167, 3269272576, 3269272583, 'DE', 'DEU', 'ألمانيا'),
(64168, 3269272704, 3269272831, 'DE', 'DEU', 'ألمانيا'),
(64169, 3269272832, 3269272847, 'GB', 'GBR', 'المملكة المتحدة'),
(64170, 3269272848, 3269272863, 'NL', 'NLD', 'هولندا'),
(64171, 3269272864, 3269272879, 'GB', 'GBR', 'المملكة المتحدة'),
(64172, 3269272896, 3269273087, 'NL', 'NLD', 'هولندا'),
(64173, 3269273088, 3269273343, 'DE', 'DEU', 'ألمانيا'),
(64174, 3269273600, 3269273855, 'GB', 'GBR', 'المملكة المتحدة'),
(64175, 3269273856, 3269275647, 'DE', 'DEU', 'ألمانيا'),
(64176, 3269275904, 3269276159, 'DE', 'DEU', 'ألمانيا'),
(64177, 3269276160, 3269276415, 'GB', 'GBR', 'المملكة المتحدة'),
(64178, 3269277184, 3269277695, 'FR', 'FRA', 'فرنسا'),
(64179, 3269277696, 3269277759, 'GB', 'GBR', 'المملكة المتحدة'),
(64180, 3269277760, 3269278719, 'NL', 'NLD', 'هولندا'),
(64181, 3269279232, 3269279487, 'NL', 'NLD', 'هولندا'),
(64182, 3269279672, 3269279679, 'CH', 'CHE', 'سويسرا'),
(64183, 3269279744, 3269279999, 'GB', 'GBR', 'المملكة المتحدة'),
(64184, 3269280000, 3269280767, 'NL', 'NLD', 'هولندا'),
(64185, 3269280768, 3269281023, 'GB', 'GBR', 'المملكة المتحدة'),
(64186, 3269281024, 3269281279, 'DE', 'DEU', 'ألمانيا'),
(64187, 3269282048, 3269282303, 'DE', 'DEU', 'ألمانيا'),
(64188, 3269282304, 3269282559, 'GB', 'GBR', 'المملكة المتحدة'),
(64189, 3269282560, 3269282815, 'FR', 'FRA', 'فرنسا'),
(64190, 3269283328, 3269283583, 'DE', 'DEU', 'ألمانيا'),
(64191, 3269283872, 3269283903, 'DE', 'DEU', 'ألمانيا'),
(64192, 3269284096, 3269284351, 'GB', 'GBR', 'المملكة المتحدة'),
(64193, 3269284864, 3269285055, 'FR', 'FRA', 'فرنسا'),
(64194, 3269285088, 3269285135, 'DE', 'DEU', 'ألمانيا'),
(64195, 3269285152, 3269285215, 'DE', 'DEU', 'ألمانيا'),
(64196, 3269285312, 3269285327, 'DE', 'DEU', 'ألمانيا'),
(64197, 3269285632, 3269285887, 'DE', 'DEU', 'ألمانيا'),
(64198, 3269286400, 3269286463, 'DE', 'DEU', 'ألمانيا'),
(64199, 3269288688, 3269288959, 'DE', 'DEU', 'ألمانيا'),
(64200, 3269290560, 3269290575, 'DE', 'DEU', 'ألمانيا'),
(64201, 3269290592, 3269290687, 'DE', 'DEU', 'ألمانيا'),
(64202, 3269290736, 3269290743, 'DE', 'DEU', 'ألمانيا'),
(64203, 3269291264, 3269291519, 'DE', 'DEU', 'ألمانيا'),
(64204, 3269291520, 3269291559, 'GB', 'GBR', 'المملكة المتحدة'),
(64205, 3269291584, 3269291647, 'GB', 'GBR', 'المملكة المتحدة'),
(64206, 3269291776, 3269292287, 'ES', 'ESP', 'إسبانيا'),
(64207, 3269293120, 3269293151, 'DE', 'DEU', 'ألمانيا'),
(64208, 3269293208, 3269293215, 'DE', 'DEU', 'ألمانيا'),
(64209, 3269293248, 3269293279, 'DE', 'DEU', 'ألمانيا'),
(64210, 3269293376, 3269293391, 'DE', 'DEU', 'ألمانيا'),
(64211, 3269293856, 3269293887, 'DE', 'DEU', 'ألمانيا'),
(64212, 3269293920, 3269293951, 'DE', 'DEU', 'ألمانيا'),
(64213, 3269296232, 3269296235, 'DE', 'DEU', 'ألمانيا'),
(64214, 3269296368, 3269296375, 'DE', 'DEU', 'ألمانيا'),
(64215, 3269297152, 3269297663, 'GB', 'GBR', 'المملكة المتحدة'),
(64216, 3269298664, 3269298671, 'DE', 'DEU', 'ألمانيا'),
(64217, 3269303040, 3269303295, 'DE', 'DEU', 'ألمانيا'),
(64218, 3269303296, 3269303423, 'GB', 'GBR', 'المملكة المتحدة'),
(64219, 3269303552, 3269303679, 'DE', 'DEU', 'ألمانيا'),
(64220, 3269305344, 3269305351, 'DE', 'DEU', 'ألمانيا'),
(64221, 3269305856, 3269306879, 'DE', 'DEU', 'ألمانيا'),
(64222, 3269307648, 3269307903, 'DE', 'DEU', 'ألمانيا'),
(64223, 3269310656, 3269310671, 'DE', 'DEU', 'ألمانيا'),
(64224, 3269310976, 3269311231, 'DE', 'DEU', 'ألمانيا'),
(64225, 3269311872, 3269311999, 'DE', 'DEU', 'ألمانيا'),
(64226, 3269313792, 3269314175, 'DE', 'DEU', 'ألمانيا'),
(64227, 3269314192, 3269314199, 'DE', 'DEU', 'ألمانيا'),
(64228, 3269315584, 3269315591, 'DE', 'DEU', 'ألمانيا'),
(64229, 3269317632, 3269317663, 'GB', 'GBR', 'المملكة المتحدة'),
(64230, 3269317664, 3269317671, 'IE', 'IRL', 'إيرلندا'),
(64231, 3269317672, 3269317887, 'GB', 'GBR', 'المملكة المتحدة'),
(64232, 3269317888, 3269318399, 'DE', 'DEU', 'ألمانيا'),
(64233, 3269318400, 3269318655, 'GB', 'GBR', 'المملكة المتحدة'),
(64234, 3269318656, 3269318983, 'DE', 'DEU', 'ألمانيا'),
(64235, 3269319008, 3269319047, 'DE', 'DEU', 'ألمانيا'),
(64236, 3269319056, 3269319071, 'DE', 'DEU', 'ألمانيا'),
(64237, 3269319136, 3269320447, 'DE', 'DEU', 'ألمانيا'),
(64238, 3269320704, 3269321727, 'GB', 'GBR', 'المملكة المتحدة'),
(64239, 3269322240, 3269322495, 'DE', 'DEU', 'ألمانيا'),
(64240, 3269322680, 3269322683, 'DE', 'DEU', 'ألمانيا'),
(64241, 3269322752, 3269323263, 'DE', 'DEU', 'ألمانيا'),
(64242, 3269326848, 3269326855, 'DE', 'DEU', 'ألمانيا'),
(64243, 3269326960, 3269326971, 'DE', 'DEU', 'ألمانيا'),
(64244, 3269326992, 3269326999, 'DE', 'DEU', 'ألمانيا'),
(64245, 3269327024, 3269327039, 'DE', 'DEU', 'ألمانيا'),
(64246, 3269327056, 3269327103, 'DE', 'DEU', 'ألمانيا'),
(64247, 3269327760, 3269327767, 'DE', 'DEU', 'ألمانيا'),
(64248, 3269327864, 3269328383, 'DE', 'DEU', 'ألمانيا'),
(64249, 3269328896, 3269459967, 'GB', 'GBR', 'المملكة المتحدة'),
(64250, 3269459968, 3269525503, 'ES', 'ESP', 'إسبانيا'),
(64251, 3269525504, 3269556223, 'IR', 'IRN', 'إيران'),
(64252, 3269556224, 3269556479, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(64253, 3269556480, 3269591039, 'IR', 'IRN', 'إيران'),
(64254, 3269591040, 3269621759, 'RU', 'RUS', 'الإتحاد الروسي'),
(64255, 3269621760, 3269623551, 'BY', 'BLR', 'روسيا البيضاء'),
(64256, 3269623552, 3269656575, 'RU', 'RUS', 'الإتحاد الروسي'),
(64257, 3269656576, 3269722111, 'GB', 'GBR', 'المملكة المتحدة'),
(64258, 3269722112, 3269750799, 'CZ', 'CZE', 'التشيك'),
(64259, 3269750800, 3269750815, 'CR', 'CRI', 'كوستا ريكا'),
(64260, 3269750816, 3269787647, 'CZ', 'CZE', 'التشيك'),
(64261, 3269787648, 3269853183, 'NL', 'NLD', 'هولندا'),
(64262, 3269853184, 3269918719, 'CH', 'CHE', 'سويسرا'),
(64263, 3269918720, 3269936063, 'DE', 'DEU', 'ألمانيا'),
(64264, 3269936064, 3269936079, 'NL', 'NLD', 'هولندا'),
(64265, 3269936080, 3269984255, 'DE', 'DEU', 'ألمانيا'),
(64266, 3269984256, 3270049791, 'AT', 'AUT', 'النمسا'),
(64267, 3270049792, 3270115327, 'DE', 'DEU', 'ألمانيا'),
(64268, 3270117504, 3270117631, 'DK', 'DNK', 'الدنيمارك'),
(64269, 3270122240, 3270122495, 'DK', 'DNK', 'الدنيمارك'),
(64270, 3270123716, 3270123719, 'DK', 'DNK', 'الدنيمارك'),
(64271, 3270123776, 3270124031, 'DK', 'DNK', 'الدنيمارك'),
(64272, 3270124544, 3270124799, 'DK', 'DNK', 'الدنيمارك'),
(64273, 3270125056, 3270125567, 'DK', 'DNK', 'الدنيمارك'),
(64274, 3270126080, 3270126335, 'DK', 'DNK', 'الدنيمارك'),
(64275, 3270126624, 3270126655, 'DK', 'DNK', 'الدنيمارك'),
(64276, 3270131968, 3270132223, 'NO', 'NOR', 'النرويج'),
(64277, 3270132992, 3270133023, 'NO', 'NOR', 'النرويج'),
(64278, 3270136928, 3270136959, 'NO', 'NOR', 'النرويج'),
(64279, 3270136992, 3270137055, 'NO', 'NOR', 'النرويج'),
(64280, 3270140928, 3270141439, 'NO', 'NOR', 'النرويج'),
(64281, 3270142208, 3270142463, 'NO', 'NOR', 'النرويج'),
(64282, 3270144000, 3270144767, 'NO', 'NOR', 'النرويج'),
(64283, 3270146816, 3270147327, 'NO', 'NOR', 'النرويج'),
(64284, 3270147584, 3270148095, 'NO', 'NOR', 'النرويج'),
(64285, 3270148096, 3270151423, 'FI', 'FIN', 'فنلندا'),
(64286, 3270151936, 3270154527, 'FI', 'FIN', 'فنلندا'),
(64287, 3270155008, 3270155775, 'FI', 'FIN', 'فنلندا'),
(64288, 3270156288, 3270156799, 'DK', 'DNK', 'الدنيمارك'),
(64289, 3270159616, 3270159871, 'DK', 'DNK', 'الدنيمارك'),
(64290, 3270164992, 3270165247, 'NO', 'NOR', 'النرويج'),
(64291, 3270166528, 3270167807, 'NO', 'NOR', 'النرويج'),
(64292, 3270169088, 3270169343, 'NO', 'NOR', 'النرويج'),
(64293, 3270170112, 3270170623, 'NO', 'NOR', 'النرويج'),
(64294, 3270174720, 3270174975, 'NO', 'NOR', 'النرويج'),
(64295, 3270175744, 3270175999, 'NO', 'NOR', 'النرويج'),
(64296, 3270181120, 3270181375, 'CH', 'CHE', 'سويسرا'),
(64297, 3270181632, 3270181887, 'CH', 'CHE', 'سويسرا'),
(64298, 3270182144, 3270182399, 'CH', 'CHE', 'سويسرا'),
(64299, 3270182656, 3270183679, 'CH', 'CHE', 'سويسرا'),
(64300, 3270189056, 3270189311, 'BE', 'BEL', 'بلجيكا'),
(64301, 3270190080, 3270190591, 'IT', 'ITA', 'إيطاليا'),
(64302, 3270190592, 3270191103, 'CH', 'CHE', 'سويسرا'),
(64303, 3270191872, 3270192047, 'CH', 'CHE', 'سويسرا'),
(64304, 3270196992, 3270197247, 'CH', 'CHE', 'سويسرا'),
(64305, 3270200064, 3270200319, 'NL', 'NLD', 'هولندا'),
(64306, 3270201344, 3270201599, 'NL', 'NLD', 'هولندا'),
(64307, 3270202880, 3270203135, 'NL', 'NLD', 'هولندا'),
(64308, 3270205440, 3270205695, 'NL', 'NLD', 'هولندا'),
(64309, 3270205984, 3270205999, 'ES', 'ESP', 'إسبانيا'),
(64310, 3270206064, 3270206079, 'ES', 'ESP', 'إسبانيا'),
(64311, 3270206976, 3270207231, 'ES', 'ESP', 'إسبانيا'),
(64312, 3270207232, 3270207487, 'CH', 'CHE', 'سويسرا'),
(64313, 3270207744, 3270207903, 'IT', 'ITA', 'إيطاليا'),
(64314, 3270208000, 3270208255, 'CH', 'CHE', 'سويسرا'),
(64315, 3270208256, 3270208511, 'LU', 'LUX', 'لوكسيمبورغ'),
(64316, 3270208768, 3270209023, 'RO', 'ROM', 'رومانيا'),
(64317, 3270209024, 3270209279, 'NL', 'NLD', 'هولندا'),
(64318, 3270212352, 3270212863, 'NL', 'NLD', 'هولندا'),
(64319, 3270213120, 3270213631, 'NL', 'NLD', 'هولندا'),
(64320, 3270213888, 3270214279, 'PT', 'PRT', 'البورتوغال'),
(64321, 3270214280, 3270214287, 'US', 'USA', 'الولايات المتحدة'),
(64322, 3270214288, 3270214303, 'PT', 'PRT', 'البورتوغال'),
(64323, 3270214320, 3270215439, 'PT', 'PRT', 'البورتوغال'),
(64324, 3270215520, 3270215935, 'PT', 'PRT', 'البورتوغال'),
(64325, 3270216192, 3270216351, 'PT', 'PRT', 'البورتوغال'),
(64326, 3270216384, 3270216703, 'PT', 'PRT', 'البورتوغال'),
(64327, 3270216736, 3270216751, 'IT', 'ITA', 'إيطاليا'),
(64328, 3270216800, 3270216815, 'IT', 'ITA', 'إيطاليا'),
(64329, 3270216832, 3270216879, 'IT', 'ITA', 'إيطاليا'),
(64330, 3270217472, 3270217727, 'CH', 'CHE', 'سويسرا'),
(64331, 3270218496, 3270218751, 'CH', 'CHE', 'سويسرا'),
(64332, 3270224640, 3270224895, 'CH', 'CHE', 'سويسرا'),
(64333, 3270230272, 3270230783, 'LU', 'LUX', 'لوكسيمبورغ'),
(64334, 3270231296, 3270231647, 'LU', 'LUX', 'لوكسيمبورغ'),
(64335, 3270232576, 3270232831, 'LU', 'LUX', 'لوكسيمبورغ'),
(64336, 3270234112, 3270234367, 'LU', 'LUX', 'لوكسيمبورغ'),
(64337, 3270234368, 3270234623, 'NL', 'NLD', 'هولندا'),
(64338, 3270235136, 3270236159, 'NL', 'NLD', 'هولندا'),
(64339, 3270238208, 3270238719, 'NL', 'NLD', 'هولندا'),
(64340, 3270238976, 3270239487, 'CH', 'CHE', 'سويسرا'),
(64341, 3270241792, 3270242559, 'RO', 'ROM', 'رومانيا'),
(64342, 3270243328, 3270243839, 'RO', 'ROM', 'رومانيا'),
(64343, 3270244096, 3270244351, 'NL', 'NLD', 'هولندا'),
(64344, 3270244352, 3270244863, 'CH', 'CHE', 'سويسرا'),
(64345, 3270245888, 3270246143, 'RO', 'ROM', 'رومانيا'),
(64346, 3270246144, 3270246399, 'CH', 'CHE', 'سويسرا'),
(64347, 3270246400, 3270247951, 'SE', 'SWE', 'السويد'),
(64348, 3270247952, 3270247955, 'NO', 'NOR', 'النرويج'),
(64349, 3270247956, 3270369919, 'SE', 'SWE', 'السويد'),
(64350, 3270369920, 3270369927, 'NO', 'NOR', 'النرويج'),
(64351, 3270369928, 3270377471, 'SE', 'SWE', 'السويد'),
(64352, 3270377472, 3270443007, 'GB', 'GBR', 'المملكة المتحدة'),
(64353, 3270443008, 3270508543, 'DK', 'DNK', 'الدنيمارك'),
(64354, 3270508544, 3270639615, 'FI', 'FIN', 'فنلندا'),
(64355, 3270639616, 3270640127, 'PL', 'POL', 'بولندا'),
(64356, 3270640128, 3270642175, 'RU', 'RUS', 'الإتحاد الروسي'),
(64357, 3270642176, 3270642687, 'NO', 'NOR', 'النرويج'),
(64358, 3270643200, 3270643711, 'RU', 'RUS', 'الإتحاد الروسي'),
(64359, 3270643712, 3270644223, 'AT', 'AUT', 'النمسا'),
(64360, 3270644224, 3270644735, 'NL', 'NLD', 'هولندا'),
(64361, 3270644736, 3270645247, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(64362, 3270645248, 3270645759, 'PL', 'POL', 'بولندا'),
(64363, 3270645760, 3270646271, 'IL', 'ISR', 'إسرائيل'),
(64364, 3270646272, 3270647807, 'RU', 'RUS', 'الإتحاد الروسي'),
(64365, 3270647808, 3270648063, 'TR', 'TUR', 'تركيا'),
(64366, 3270648064, 3270648319, 'RU', 'RUS', 'الإتحاد الروسي'),
(64367, 3270648320, 3270648575, 'CH', 'CHE', 'سويسرا'),
(64368, 3270648576, 3270648831, 'AT', 'AUT', 'النمسا'),
(64369, 3270648832, 3270649087, 'SI', 'SVN', 'سلوفينيا'),
(64370, 3270649088, 3270649343, 'AT', 'AUT', 'النمسا'),
(64371, 3270649344, 3270649599, 'DK', 'DNK', 'الدنيمارك'),
(64372, 3270649600, 3270649855, 'PL', 'POL', 'بولندا'),
(64373, 3270649856, 3270650111, 'DK', 'DNK', 'الدنيمارك'),
(64374, 3270650112, 3270650367, 'AT', 'AUT', 'النمسا'),
(64375, 3270650368, 3270650623, 'DK', 'DNK', 'الدنيمارك'),
(64376, 3270650624, 3270651391, 'FR', 'FRA', 'فرنسا'),
(64377, 3270651392, 3270651647, 'DE', 'DEU', 'ألمانيا'),
(64378, 3270651648, 3270651903, 'FR', 'FRA', 'فرنسا'),
(64379, 3270651904, 3270652415, 'IT', 'ITA', 'إيطاليا'),
(64380, 3270652416, 3270652671, 'DK', 'DNK', 'الدنيمارك'),
(64381, 3270652672, 3270652927, 'CH', 'CHE', 'سويسرا'),
(64382, 3270652928, 3270653183, 'PL', 'POL', 'بولندا'),
(64383, 3270653184, 3270653439, 'UA', 'UKR', 'أوكرانيا'),
(64384, 3270653440, 3270653695, 'NL', 'NLD', 'هولندا'),
(64385, 3270653696, 3270653951, 'GB', 'GBR', 'المملكة المتحدة'),
(64386, 3270653952, 3270654207, 'ES', 'ESP', 'إسبانيا'),
(64387, 3270654464, 3270654719, 'BE', 'BEL', 'بلجيكا'),
(64388, 3270654720, 3270655231, 'UA', 'UKR', 'أوكرانيا'),
(64389, 3270655232, 3270655487, 'IT', 'ITA', 'إيطاليا'),
(64390, 3270655488, 3270655743, 'PL', 'POL', 'بولندا'),
(64391, 3270655744, 3270655999, 'CH', 'CHE', 'سويسرا'),
(64392, 3270656000, 3270664191, 'NL', 'NLD', 'هولندا'),
(64393, 3270664192, 3270666239, 'UA', 'UKR', 'أوكرانيا'),
(64394, 3270666240, 3270667263, 'PL', 'POL', 'بولندا'),
(64395, 3270667264, 3270668287, 'SE', 'SWE', 'السويد'),
(64396, 3270668288, 3270669311, 'FR', 'FRA', 'فرنسا'),
(64397, 3270669312, 3270670335, 'UA', 'UKR', 'أوكرانيا'),
(64398, 3270670336, 3270672383, 'RU', 'RUS', 'الإتحاد الروسي'),
(64399, 3270672384, 3270680575, 'GB', 'GBR', 'المملكة المتحدة'),
(64400, 3270680576, 3270688767, 'FR', 'FRA', 'فرنسا'),
(64401, 3270688768, 3270772079, 'IT', 'ITA', 'إيطاليا'),
(64402, 3270772080, 3270772087, 'NL', 'NLD', 'هولندا'),
(64403, 3270772088, 3270781343, 'IT', 'ITA', 'إيطاليا'),
(64404, 3270781344, 3270781359, 'RO', 'ROM', 'رومانيا'),
(64405, 3270781360, 3270808127, 'IT', 'ITA', 'إيطاليا'),
(64406, 3270808128, 3270808159, 'LU', 'LUX', 'لوكسيمبورغ'),
(64407, 3270808160, 3270836223, 'IT', 'ITA', 'إيطاليا'),
(64408, 3270836224, 3270911807, 'DE', 'DEU', 'ألمانيا'),
(64409, 3270911872, 3270911935, 'DE', 'DEU', 'ألمانيا'),
(64410, 3270911936, 3270911967, 'PL', 'POL', 'بولندا'),
(64411, 3270911968, 3270911999, 'NL', 'NLD', 'هولندا'),
(64412, 3270912000, 3270920191, 'DE', 'DEU', 'ألمانيا'),
(64413, 3270922240, 3270926335, 'DE', 'DEU', 'ألمانيا'),
(64414, 3270926336, 3270926591, 'AT', 'AUT', 'النمسا'),
(64415, 3270926592, 3270926847, 'CH', 'CHE', 'سويسرا'),
(64416, 3270926848, 3270927103, 'PL', 'POL', 'بولندا'),
(64417, 3270927104, 3270927359, 'UA', 'UKR', 'أوكرانيا'),
(64418, 3270927360, 3270927615, 'CH', 'CHE', 'سويسرا'),
(64419, 3270927616, 3270927871, 'FR', 'FRA', 'فرنسا'),
(64420, 3270927872, 3270928127, 'HU', 'HUN', 'هنغاريا'),
(64421, 3270928128, 3270928383, 'RO', 'ROM', 'رومانيا'),
(64422, 3270928384, 3270928895, 'UA', 'UKR', 'أوكرانيا'),
(64423, 3270928896, 3270929407, 'PL', 'POL', 'بولندا'),
(64424, 3270929408, 3270929919, 'GB', 'GBR', 'المملكة المتحدة'),
(64425, 3270929920, 3270930431, 'BG', 'BGR', 'بلغاريا'),
(64426, 3270930432, 3270931455, 'RU', 'RUS', 'الإتحاد الروسي'),
(64427, 3270931456, 3270931967, 'UA', 'UKR', 'أوكرانيا'),
(64428, 3270931968, 3270932479, 'CH', 'CHE', 'سويسرا'),
(64429, 3270932480, 3270932991, 'UA', 'UKR', 'أوكرانيا'),
(64430, 3270932992, 3270933503, 'DE', 'DEU', 'ألمانيا'),
(64431, 3270933504, 3270934015, 'PL', 'POL', 'بولندا'),
(64432, 3270934016, 3270934527, 'IT', 'ITA', 'إيطاليا'),
(64433, 3270934528, 3270967295, 'DE', 'DEU', 'ألمانيا'),
(64434, 3270967296, 3270968319, 'PL', 'POL', 'بولندا'),
(64435, 3270968320, 3270968831, 'DE', 'DEU', 'ألمانيا'),
(64436, 3270968832, 3270969343, 'SE', 'SWE', 'السويد'),
(64437, 3270969344, 3270969855, 'CH', 'CHE', 'سويسرا'),
(64438, 3270969856, 3270970367, 'AT', 'AUT', 'النمسا'),
(64439, 3270970368, 3270970879, 'UA', 'UKR', 'أوكرانيا'),
(64440, 3270970880, 3270971391, 'RU', 'RUS', 'الإتحاد الروسي'),
(64441, 3270971392, 3270972415, 'UA', 'UKR', 'أوكرانيا'),
(64442, 3270972416, 3270973951, 'RU', 'RUS', 'الإتحاد الروسي'),
(64443, 3270973952, 3270974463, 'FR', 'FRA', 'فرنسا'),
(64444, 3270974464, 3270974975, 'IT', 'ITA', 'إيطاليا'),
(64445, 3270974976, 3270975487, 'NL', 'NLD', 'هولندا'),
(64446, 3270975488, 3270991871, 'GB', 'GBR', 'المملكة المتحدة'),
(64447, 3270991872, 3271000063, 'NL', 'NLD', 'هولندا'),
(64448, 3271000064, 3271008255, 'RU', 'RUS', 'الإتحاد الروسي'),
(64449, 3271008256, 3271008767, 'BE', 'BEL', 'بلجيكا'),
(64450, 3271008768, 3271009279, 'SI', 'SVN', 'سلوفينيا'),
(64451, 3271009280, 3271009791, 'MD', 'MDA', 'مولدوفا'),
(64452, 3271009792, 3271010303, 'IL', 'ISR', 'إسرائيل'),
(64453, 3271010304, 3271010815, 'RU', 'RUS', 'الإتحاد الروسي'),
(64454, 3271010816, 3271011327, 'GB', 'GBR', 'المملكة المتحدة'),
(64455, 3271011328, 3271013375, 'UA', 'UKR', 'أوكرانيا'),
(64456, 3271013376, 3271013887, 'FR', 'FRA', 'فرنسا'),
(64457, 3271013888, 3271014399, 'UA', 'UKR', 'أوكرانيا'),
(64458, 3271014400, 3271014911, 'RU', 'RUS', 'الإتحاد الروسي'),
(64459, 3271014912, 3271015423, 'RO', 'ROM', 'رومانيا'),
(64460, 3271015424, 3271015935, 'DK', 'DNK', 'الدنيمارك'),
(64461, 3271015936, 3271016447, 'RU', 'RUS', 'الإتحاد الروسي'),
(64462, 3271016448, 3271018655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64463, 3271018656, 3271018671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64464, 3271018672, 3271019183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64465, 3271019184, 3271019200, 'RS', 'SRB', 'صربيا'),
(64466, 3271019201, 3271019271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64467, 3271019272, 3271019279, 'RS', 'SRB', 'صربيا'),
(64468, 3271019280, 3271019903, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64469, 3271019904, 3271019919, 'RS', 'SRB', 'صربيا'),
(64470, 3271019920, 3271020199, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64471, 3271020200, 3271020207, 'RS', 'SRB', 'صربيا'),
(64472, 3271020208, 3271020215, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64473, 3271020216, 3271020223, 'RS', 'SRB', 'صربيا'),
(64474, 3271020224, 3271020247, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64475, 3271020248, 3271020255, 'RS', 'SRB', 'صربيا'),
(64476, 3271020256, 3271020271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64477, 3271020272, 3271020279, 'RS', 'SRB', 'صربيا'),
(64478, 3271020280, 3271020511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64479, 3271020512, 3271020543, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64480, 3271020544, 3271020671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64481, 3271020672, 3271020687, 'RS', 'SRB', 'صربيا'),
(64482, 3271020688, 3271020695, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64483, 3271020696, 3271020703, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64484, 3271020704, 3271020751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64485, 3271020752, 3271020767, 'RS', 'SRB', 'صربيا'),
(64486, 3271020768, 3271021311, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64487, 3271021312, 3271021327, 'RS', 'SRB', 'صربيا'),
(64488, 3271021328, 3271022335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64489, 3271022336, 3271022463, 'CY', 'CYP', 'قبرص'),
(64490, 3271022464, 3271022583, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64491, 3271022584, 3271022591, 'RS', 'SRB', 'صربيا'),
(64492, 3271022592, 3271023631, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64493, 3271023632, 3271023647, 'RS', 'SRB', 'صربيا'),
(64494, 3271023648, 3271024395, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64495, 3271024396, 3271024447, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64496, 3271024448, 3271024451, 'BA', 'BIH', 'البوسنه والهرسك'),
(64497, 3271024452, 3271024455, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64498, 3271024456, 3271024495, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64499, 3271024496, 3271024639, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(64500, 3271024640, 3271032831, 'GB', 'GBR', 'المملكة المتحدة'),
(64501, 3271032832, 3271098367, 'NO', 'NOR', 'النرويج'),
(64502, 3271098368, 3271163903, 'SI', 'SVN', 'سلوفينيا'),
(64503, 3271163904, 3271200767, 'FR', 'FRA', 'فرنسا'),
(64504, 3271200768, 3271200775, 'GB', 'GBR', 'المملكة المتحدة'),
(64505, 3271200776, 3271200783, 'ES', 'ESP', 'إسبانيا'),
(64506, 3271200784, 3271229439, 'FR', 'FRA', 'فرنسا'),
(64507, 3271229440, 3271249919, 'FI', 'FIN', 'فنلندا'),
(64508, 3271249920, 3271250175, 'SE', 'SWE', 'السويد'),
(64509, 3271250176, 3271280351, 'FI', 'FIN', 'فنلندا'),
(64510, 3271280352, 3271280383, 'RU', 'RUS', 'الإتحاد الروسي'),
(64511, 3271280384, 3271280687, 'FI', 'FIN', 'فنلندا'),
(64512, 3271280688, 3271280703, 'SE', 'SWE', 'السويد'),
(64513, 3271280704, 3271280719, 'FI', 'FIN', 'فنلندا'),
(64514, 3271280720, 3271280735, 'SE', 'SWE', 'السويد'),
(64515, 3271280736, 3271290623, 'FI', 'FIN', 'فنلندا'),
(64516, 3271290624, 3271290879, 'BE', 'BEL', 'بلجيكا'),
(64517, 3271290880, 3271310079, 'FI', 'FIN', 'فنلندا'),
(64518, 3271310080, 3271310335, 'DE', 'DEU', 'ألمانيا'),
(64519, 3271310336, 3271360511, 'FI', 'FIN', 'فنلندا'),
(64520, 3271360512, 3271363407, 'GB', 'GBR', 'المملكة المتحدة'),
(64521, 3271363408, 3271363415, 'AT', 'AUT', 'النمسا'),
(64522, 3271363416, 3271363423, 'GB', 'GBR', 'المملكة المتحدة'),
(64523, 3271363424, 3271363455, 'IT', 'ITA', 'إيطاليا'),
(64524, 3271363456, 3271363471, 'GB', 'GBR', 'المملكة المتحدة'),
(64525, 3271363472, 3271363487, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64526, 3271363488, 3271363519, 'IT', 'ITA', 'إيطاليا'),
(64527, 3271363552, 3271363583, 'FR', 'FRA', 'فرنسا'),
(64528, 3271363584, 3271365887, 'GB', 'GBR', 'المملكة المتحدة'),
(64529, 3271365888, 3271366143, 'DE', 'DEU', 'ألمانيا'),
(64530, 3271366144, 3271366399, 'GB', 'GBR', 'المملكة المتحدة'),
(64531, 3271366400, 3271366655, 'NL', 'NLD', 'هولندا'),
(64532, 3271366656, 3271371263, 'GB', 'GBR', 'المملكة المتحدة'),
(64533, 3271371264, 3271371519, 'IE', 'IRL', 'إيرلندا'),
(64534, 3271371520, 3271371679, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64535, 3271371680, 3271371711, 'DE', 'DEU', 'ألمانيا'),
(64536, 3271371712, 3271371775, 'CH', 'CHE', 'سويسرا'),
(64537, 3271371776, 3271372031, 'GB', 'GBR', 'المملكة المتحدة'),
(64538, 3271372032, 3271372287, 'BE', 'BEL', 'بلجيكا'),
(64539, 3271372288, 3271372799, 'FR', 'FRA', 'فرنسا'),
(64540, 3271372800, 3271373055, 'SE', 'SWE', 'السويد'),
(64541, 3271373056, 3271373311, 'BE', 'BEL', 'بلجيكا'),
(64542, 3271373312, 3271373567, 'GB', 'GBR', 'المملكة المتحدة'),
(64543, 3271373568, 3271373823, 'FR', 'FRA', 'فرنسا'),
(64544, 3271373824, 3271374079, 'DE', 'DEU', 'ألمانيا'),
(64545, 3271374080, 3271374335, 'BE', 'BEL', 'بلجيكا'),
(64546, 3271374336, 3271374847, 'DE', 'DEU', 'ألمانيا'),
(64547, 3271374848, 3271375359, 'GB', 'GBR', 'المملكة المتحدة'),
(64548, 3271375360, 3271375871, 'CH', 'CHE', 'سويسرا'),
(64549, 3271375872, 3271376383, 'BE', 'BEL', 'بلجيكا'),
(64550, 3271376384, 3271376447, 'GB', 'GBR', 'المملكة المتحدة'),
(64551, 3271376448, 3271376463, 'FR', 'FRA', 'فرنسا'),
(64552, 3271376464, 3271376479, 'IT', 'ITA', 'إيطاليا'),
(64553, 3271376480, 3271376511, 'FR', 'FRA', 'فرنسا'),
(64554, 3271376512, 3271376639, 'DE', 'DEU', 'ألمانيا'),
(64555, 3271376640, 3271376895, 'AT', 'AUT', 'النمسا'),
(64556, 3271376896, 3271377407, 'ES', 'ESP', 'إسبانيا'),
(64557, 3271377408, 3271377919, 'NL', 'NLD', 'هولندا'),
(64558, 3271377920, 3271378687, 'BE', 'BEL', 'بلجيكا'),
(64559, 3271378688, 3271378943, 'SE', 'SWE', 'السويد'),
(64560, 3271378944, 3271380991, 'GB', 'GBR', 'المملكة المتحدة'),
(64561, 3271380992, 3271381247, 'BE', 'BEL', 'بلجيكا'),
(64562, 3271381248, 3271381503, 'NO', 'NOR', 'النرويج'),
(64563, 3271381504, 3271381759, 'SE', 'SWE', 'السويد'),
(64564, 3271381760, 3271382527, 'IT', 'ITA', 'إيطاليا'),
(64565, 3271382528, 3271383039, 'IL', 'ISR', 'إسرائيل'),
(64566, 3271383040, 3271383295, 'CH', 'CHE', 'سويسرا'),
(64567, 3271383296, 3271383551, 'BE', 'BEL', 'بلجيكا'),
(64568, 3271383552, 3271384063, 'GB', 'GBR', 'المملكة المتحدة'),
(64569, 3271384064, 3271384319, 'CH', 'CHE', 'سويسرا'),
(64570, 3271384320, 3271384575, 'BE', 'BEL', 'بلجيكا'),
(64571, 3271384576, 3271384831, 'GB', 'GBR', 'المملكة المتحدة'),
(64572, 3271384832, 3271385087, 'BE', 'BEL', 'بلجيكا'),
(64573, 3271385088, 3271385159, 'DE', 'DEU', 'ألمانيا'),
(64574, 3271385160, 3271385183, 'GB', 'GBR', 'المملكة المتحدة'),
(64575, 3271385184, 3271385215, 'ES', 'ESP', 'إسبانيا'),
(64576, 3271385216, 3271385343, 'NL', 'NLD', 'هولندا'),
(64577, 3271385344, 3271391231, 'DE', 'DEU', 'ألمانيا'),
(64578, 3271391232, 3271391743, 'NL', 'NLD', 'هولندا'),
(64579, 3271391744, 3271391999, 'NO', 'NOR', 'النرويج'),
(64580, 3271392000, 3271392255, 'DE', 'DEU', 'ألمانيا'),
(64581, 3271392256, 3271392511, 'FR', 'FRA', 'فرنسا'),
(64582, 3271392512, 3271392767, 'BE', 'BEL', 'بلجيكا'),
(64583, 3271392768, 3271393279, 'FR', 'FRA', 'فرنسا'),
(64584, 3271393280, 3271393791, 'AT', 'AUT', 'النمسا'),
(64585, 3271393792, 3271394047, 'DK', 'DNK', 'الدنيمارك'),
(64586, 3271394048, 3271394303, 'DE', 'DEU', 'ألمانيا'),
(64587, 3271394304, 3271394559, 'BE', 'BEL', 'بلجيكا'),
(64588, 3271394560, 3271394815, 'GB', 'GBR', 'المملكة المتحدة'),
(64589, 3271394816, 3271395071, 'DE', 'DEU', 'ألمانيا'),
(64590, 3271395072, 3271395327, 'GB', 'GBR', 'المملكة المتحدة'),
(64591, 3271395328, 3271396863, 'IT', 'ITA', 'إيطاليا'),
(64592, 3271396864, 3271397119, 'GB', 'GBR', 'المملكة المتحدة'),
(64593, 3271397120, 3271397375, 'NL', 'NLD', 'هولندا'),
(64594, 3271397376, 3271397887, 'CH', 'CHE', 'سويسرا'),
(64595, 3271397888, 3271397951, 'FR', 'FRA', 'فرنسا'),
(64596, 3271397952, 3271397983, 'IT', 'ITA', 'إيطاليا'),
(64597, 3271397984, 3271397999, 'NL', 'NLD', 'هولندا'),
(64598, 3271398000, 3271398015, 'FR', 'FRA', 'فرنسا'),
(64599, 3271398016, 3271398047, 'NL', 'NLD', 'هولندا'),
(64600, 3271398048, 3271398079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64601, 3271398080, 3271398143, 'GB', 'GBR', 'المملكة المتحدة'),
(64602, 3271398144, 3271398303, 'NL', 'NLD', 'هولندا'),
(64603, 3271398304, 3271398335, 'DE', 'DEU', 'ألمانيا'),
(64604, 3271398336, 3271398399, 'IT', 'ITA', 'إيطاليا'),
(64605, 3271398400, 3271398911, 'DE', 'DEU', 'ألمانيا'),
(64606, 3271398912, 3271399167, 'GB', 'GBR', 'المملكة المتحدة'),
(64607, 3271399168, 3271400959, 'BE', 'BEL', 'بلجيكا'),
(64608, 3271400960, 3271401215, 'CH', 'CHE', 'سويسرا'),
(64609, 3271401216, 3271401471, 'DE', 'DEU', 'ألمانيا'),
(64610, 3271401472, 3271403263, 'DK', 'DNK', 'الدنيمارك'),
(64611, 3271403264, 3271403519, 'DE', 'DEU', 'ألمانيا'),
(64612, 3271403520, 3271403775, 'NL', 'NLD', 'هولندا'),
(64613, 3271403776, 3271403903, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64614, 3271403904, 3271403919, 'GB', 'GBR', 'المملكة المتحدة'),
(64615, 3271403920, 3271403935, 'IE', 'IRL', 'إيرلندا'),
(64616, 3271403936, 3271403967, 'GB', 'GBR', 'المملكة المتحدة'),
(64617, 3271403968, 3271403983, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64618, 3271403984, 3271403991, 'GB', 'GBR', 'المملكة المتحدة'),
(64619, 3271403992, 3271403999, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64620, 3271404000, 3271404031, 'DE', 'DEU', 'ألمانيا'),
(64621, 3271404032, 3271405311, 'NL', 'NLD', 'هولندا'),
(64622, 3271405312, 3271405567, 'FR', 'FRA', 'فرنسا'),
(64623, 3271405568, 3271405823, 'ES', 'ESP', 'إسبانيا'),
(64624, 3271405824, 3271406079, 'AT', 'AUT', 'النمسا'),
(64625, 3271406080, 3271406335, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(64626, 3271406336, 3271406591, 'RO', 'ROM', 'رومانيا'),
(64627, 3271406592, 3271406847, 'GB', 'GBR', 'المملكة المتحدة'),
(64628, 3271406848, 3271407615, 'AT', 'AUT', 'النمسا'),
(64629, 3271407616, 3271407871, 'DE', 'DEU', 'ألمانيا'),
(64630, 3271407872, 3271408127, 'AT', 'AUT', 'النمسا'),
(64631, 3271408128, 3271408383, 'DE', 'DEU', 'ألمانيا'),
(64632, 3271408384, 3271408639, 'FR', 'FRA', 'فرنسا'),
(64633, 3271408640, 3271408895, 'BE', 'BEL', 'بلجيكا'),
(64634, 3271408896, 3271409151, 'ES', 'ESP', 'إسبانيا'),
(64635, 3271409152, 3271409407, 'IT', 'ITA', 'إيطاليا'),
(64636, 3271409408, 3271409663, 'GB', 'GBR', 'المملكة المتحدة'),
(64637, 3271409664, 3271417855, 'BE', 'BEL', 'بلجيكا'),
(64638, 3271417856, 3271424071, 'FR', 'FRA', 'فرنسا'),
(64639, 3271424072, 3271424079, 'IT', 'ITA', 'إيطاليا'),
(64640, 3271424080, 3271424095, 'IE', 'IRL', 'إيرلندا'),
(64641, 3271424096, 3271424111, 'GB', 'GBR', 'المملكة المتحدة'),
(64642, 3271424112, 3271424127, 'BE', 'BEL', 'بلجيكا'),
(64643, 3271424128, 3271424191, 'GB', 'GBR', 'المملكة المتحدة'),
(64644, 3271424192, 3271424511, 'FR', 'FRA', 'فرنسا'),
(64645, 3271424512, 3271425023, 'GB', 'GBR', 'المملكة المتحدة'),
(64646, 3271425024, 3271425279, 'DE', 'DEU', 'ألمانيا'),
(64647, 3271425280, 3271425535, 'DK', 'DNK', 'الدنيمارك'),
(64648, 3271425536, 3271426047, 'DE', 'DEU', 'ألمانيا'),
(64649, 3271426048, 3271426303, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(64650, 3271426304, 3271491583, 'FR', 'FRA', 'فرنسا'),
(64651, 3271491584, 3271495679, 'DK', 'DNK', 'الدنيمارك'),
(64652, 3271495680, 3271495807, 'SE', 'SWE', 'السويد'),
(64653, 3271495808, 3271557119, 'DK', 'DNK', 'الدنيمارك'),
(64654, 3271557120, 3271589887, 'BE', 'BEL', 'بلجيكا'),
(64655, 3271589888, 3271688191, 'NO', 'NOR', 'النرويج'),
(64656, 3271691776, 3271692031, 'US', 'USA', 'الولايات المتحدة'),
(64657, 3271692032, 3271692287, 'GB', 'GBR', 'المملكة المتحدة'),
(64658, 3271694848, 3271695103, 'GB', 'GBR', 'المملكة المتحدة'),
(64659, 3271696384, 3271698431, 'DE', 'DEU', 'ألمانيا'),
(64660, 3271704576, 3271712767, 'RU', 'RUS', 'الإتحاد الروسي'),
(64661, 3271712768, 3271716863, 'LV', 'LVA', 'لاتفيا'),
(64662, 3271716864, 3271717119, 'RU', 'RUS', 'الإتحاد الروسي'),
(64663, 3271717120, 3271720959, 'LV', 'LVA', 'لاتفيا'),
(64664, 3271720960, 3271729151, 'GB', 'GBR', 'المملكة المتحدة'),
(64665, 3271729152, 3271737343, 'DE', 'DEU', 'ألمانيا'),
(64666, 3271737344, 3271738367, 'RU', 'RUS', 'الإتحاد الروسي'),
(64667, 3271738368, 3271738879, 'RO', 'ROM', 'رومانيا'),
(64668, 3271738880, 3271739391, 'RU', 'RUS', 'الإتحاد الروسي'),
(64669, 3271739392, 3271739903, 'AT', 'AUT', 'النمسا'),
(64670, 3271739904, 3271740415, 'IE', 'IRL', 'إيرلندا'),
(64671, 3271740416, 3271740927, 'UA', 'UKR', 'أوكرانيا'),
(64672, 3271740928, 3271741439, 'RU', 'RUS', 'الإتحاد الروسي'),
(64673, 3271741440, 3271741951, 'PL', 'POL', 'بولندا'),
(64674, 3271741952, 3271743999, 'RU', 'RUS', 'الإتحاد الروسي'),
(64675, 3271744000, 3271744511, 'RO', 'ROM', 'رومانيا'),
(64676, 3271744512, 3271745023, 'AT', 'AUT', 'النمسا'),
(64677, 3271745024, 3271745535, 'PL', 'POL', 'بولندا'),
(64678, 3271745536, 3271746047, 'GB', 'GBR', 'المملكة المتحدة'),
(64679, 3271746048, 3271746559, 'IE', 'IRL', 'إيرلندا'),
(64680, 3271746560, 3271747071, 'CH', 'CHE', 'سويسرا'),
(64681, 3271747072, 3271747583, 'KZ', 'KAZ', 'كازاخستان'),
(64682, 3271747584, 3271748095, 'RU', 'RUS', 'الإتحاد الروسي'),
(64683, 3271748096, 3271748607, 'GR', 'GRC', 'اليونان'),
(64684, 3271748608, 3271749119, 'UA', 'UKR', 'أوكرانيا'),
(64685, 3271749120, 3271750143, 'RU', 'RUS', 'الإتحاد الروسي'),
(64686, 3271750144, 3271750655, 'UA', 'UKR', 'أوكرانيا'),
(64687, 3271750656, 3271750783, 'NL', 'NLD', 'هولندا'),
(64688, 3271750784, 3271751167, 'GB', 'GBR', 'المملكة المتحدة'),
(64689, 3271751168, 3271751679, 'RO', 'ROM', 'رومانيا'),
(64690, 3271751680, 3271752191, 'NL', 'NLD', 'هولندا'),
(64691, 3271752192, 3271752703, 'GB', 'GBR', 'المملكة المتحدة'),
(64692, 3271752704, 3271753215, 'RU', 'RUS', 'الإتحاد الروسي'),
(64693, 3271753216, 3271753727, 'PL', 'POL', 'بولندا'),
(64694, 3271753728, 3271770111, 'FR', 'FRA', 'فرنسا'),
(64695, 3271770112, 3271786495, 'AT', 'AUT', 'النمسا'),
(64696, 3271786496, 3271788543, 'UA', 'UKR', 'أوكرانيا'),
(64697, 3271788544, 3271789567, 'GB', 'GBR', 'المملكة المتحدة'),
(64698, 3271789568, 3271790591, 'RU', 'RUS', 'الإتحاد الروسي'),
(64699, 3271790592, 3271791615, 'LV', 'LVA', 'لاتفيا'),
(64700, 3271791616, 3271792639, 'UA', 'UKR', 'أوكرانيا'),
(64701, 3271792640, 3271793663, 'PL', 'POL', 'بولندا'),
(64702, 3271793664, 3271794687, 'UA', 'UKR', 'أوكرانيا'),
(64703, 3271794688, 3271795711, 'IT', 'ITA', 'إيطاليا'),
(64704, 3271795712, 3271796735, 'NL', 'NLD', 'هولندا'),
(64705, 3271796736, 3271797759, 'SK', 'SVK', 'سلوفاكيا'),
(64706, 3271797760, 3271798783, 'GB', 'GBR', 'المملكة المتحدة'),
(64707, 3271798784, 3271799807, 'NL', 'NLD', 'هولندا'),
(64708, 3271799808, 3271800831, 'RU', 'RUS', 'الإتحاد الروسي'),
(64709, 3271800832, 3271801855, 'GB', 'GBR', 'المملكة المتحدة'),
(64710, 3271801856, 3271802879, 'PS', 'PSE', 'فلسطين المحتلة'),
(64711, 3271802880, 3271803903, 'DE', 'DEU', 'ألمانيا'),
(64712, 3271803904, 3271804927, 'UA', 'UKR', 'أوكرانيا'),
(64713, 3271804928, 3271805951, 'PL', 'POL', 'بولندا'),
(64714, 3271805952, 3271806975, 'UA', 'UKR', 'أوكرانيا'),
(64715, 3271806976, 3271807999, 'GB', 'GBR', 'المملكة المتحدة'),
(64716, 3271808000, 3271810047, 'DE', 'DEU', 'ألمانيا'),
(64717, 3271810048, 3271811071, 'PL', 'POL', 'بولندا'),
(64718, 3271811072, 3271812095, 'UA', 'UKR', 'أوكرانيا'),
(64719, 3271812096, 3271813119, 'ES', 'ESP', 'إسبانيا'),
(64720, 3271813120, 3271814143, 'PL', 'POL', 'بولندا'),
(64721, 3271814144, 3271815167, 'UA', 'UKR', 'أوكرانيا'),
(64722, 3271815168, 3271816191, 'RU', 'RUS', 'الإتحاد الروسي'),
(64723, 3271816192, 3271817215, 'UA', 'UKR', 'أوكرانيا'),
(64724, 3271817216, 3271818239, 'DE', 'DEU', 'ألمانيا'),
(64725, 3271818240, 3271819263, 'RU', 'RUS', 'الإتحاد الروسي'),
(64726, 3271819264, 3271821246, 'DE', 'DEU', 'ألمانيا'),
(64727, 3271821247, 3271821247, 'AT', 'AUT', 'النمسا'),
(64728, 3271821248, 3271847487, 'DE', 'DEU', 'ألمانيا'),
(64729, 3271847488, 3271847495, 'US', 'USA', 'الولايات المتحدة'),
(64730, 3271847496, 3271851879, 'DE', 'DEU', 'ألمانيا'),
(64731, 3271851880, 3271851887, 'NL', 'NLD', 'هولندا'),
(64732, 3271851888, 3271884799, 'DE', 'DEU', 'ألمانيا'),
(64733, 3271884800, 3271901183, 'UA', 'UKR', 'أوكرانيا'),
(64734, 3271901184, 3271909375, 'ES', 'ESP', 'إسبانيا'),
(64735, 3271909376, 3271909887, 'RO', 'ROM', 'رومانيا'),
(64736, 3271909888, 3271910399, 'DE', 'DEU', 'ألمانيا'),
(64737, 3271910400, 3271910911, 'DK', 'DNK', 'الدنيمارك'),
(64738, 3271910912, 3271911423, 'LV', 'LVA', 'لاتفيا'),
(64739, 3271911424, 3271911935, 'LI', 'LIE', 'ليختنشتاين'),
(64740, 3271911936, 3271912959, 'UA', 'UKR', 'أوكرانيا'),
(64741, 3271912960, 3271913471, 'NL', 'NLD', 'هولندا'),
(64742, 3271913472, 3271913983, 'NO', 'NOR', 'النرويج'),
(64743, 3271913984, 3271914495, 'RO', 'ROM', 'رومانيا'),
(64744, 3271914496, 3271915007, 'ES', 'ESP', 'إسبانيا'),
(64745, 3271915008, 3271915519, 'SE', 'SWE', 'السويد'),
(64746, 3271915520, 3271916031, 'NL', 'NLD', 'هولندا'),
(64747, 3271916032, 3271916543, 'GB', 'GBR', 'المملكة المتحدة'),
(64748, 3271916544, 3271917055, 'UA', 'UKR', 'أوكرانيا'),
(64749, 3271917056, 3271917567, 'RO', 'ROM', 'رومانيا'),
(64750, 3271917568, 3271925759, 'RU', 'RUS', 'الإتحاد الروسي'),
(64751, 3271925760, 3271926015, 'DE', 'DEU', 'ألمانيا'),
(64752, 3271926016, 3271926271, 'MD', 'MDA', 'مولدوفا'),
(64753, 3271926272, 3271926527, 'RU', 'RUS', 'الإتحاد الروسي'),
(64754, 3271926528, 3271926783, 'NL', 'NLD', 'هولندا'),
(64755, 3271926784, 3271927295, 'SI', 'SVN', 'سلوفينيا'),
(64756, 3271927296, 3271927551, 'NO', 'NOR', 'النرويج'),
(64757, 3271927552, 3271927807, 'GB', 'GBR', 'المملكة المتحدة'),
(64758, 3271927808, 3271928063, 'TR', 'TUR', 'تركيا'),
(64759, 3271928064, 3271928319, 'GB', 'GBR', 'المملكة المتحدة'),
(64760, 3271928320, 3271928575, 'RU', 'RUS', 'الإتحاد الروسي'),
(64761, 3271928576, 3271928831, 'CH', 'CHE', 'سويسرا'),
(64762, 3271928832, 3271929087, 'IE', 'IRL', 'إيرلندا'),
(64763, 3271929088, 3271929343, 'LB', 'LBN', 'لبنان'),
(64764, 3271929344, 3271929599, 'NO', 'NOR', 'النرويج'),
(64765, 3271929600, 3271929855, 'GB', 'GBR', 'المملكة المتحدة'),
(64766, 3271929856, 3271930111, 'PL', 'POL', 'بولندا'),
(64767, 3271930112, 3271930367, 'HU', 'HUN', 'هنغاريا'),
(64768, 3271930368, 3271930623, 'RU', 'RUS', 'الإتحاد الروسي'),
(64769, 3271930624, 3271930879, 'GB', 'GBR', 'المملكة المتحدة'),
(64770, 3271930880, 3271931135, 'CH', 'CHE', 'سويسرا'),
(64771, 3271931136, 3271931647, 'PL', 'POL', 'بولندا'),
(64772, 3271931648, 3271931903, 'NO', 'NOR', 'النرويج'),
(64773, 3271931904, 3271932159, 'UA', 'UKR', 'أوكرانيا'),
(64774, 3271932160, 3271932415, 'SE', 'SWE', 'السويد'),
(64775, 3271932416, 3271932671, 'CZ', 'CZE', 'التشيك'),
(64776, 3271932672, 3271932927, 'DE', 'DEU', 'ألمانيا'),
(64777, 3271932928, 3271933183, 'PL', 'POL', 'بولندا'),
(64778, 3271933184, 3271933439, 'GB', 'GBR', 'المملكة المتحدة'),
(64779, 3271933440, 3271933695, 'SE', 'SWE', 'السويد'),
(64780, 3271933696, 3271933951, 'DE', 'DEU', 'ألمانيا'),
(64781, 3271933952, 3271977533, 'FR', 'FRA', 'فرنسا'),
(64782, 3271977534, 3271977534, 'US', 'USA', 'الولايات المتحدة'),
(64783, 3271977535, 3272015871, 'FR', 'FRA', 'فرنسا'),
(64784, 3272015872, 3272019967, 'RO', 'ROM', 'رومانيا'),
(64785, 3272019968, 3272020991, 'IT', 'ITA', 'إيطاليا'),
(64786, 3272020992, 3272024063, 'DK', 'DNK', 'الدنيمارك'),
(64787, 3272024064, 3272032255, 'IE', 'IRL', 'إيرلندا'),
(64788, 3272032256, 3272040447, 'SE', 'SWE', 'السويد'),
(64789, 3272040448, 3272048639, 'FR', 'FRA', 'فرنسا'),
(64790, 3272048640, 3272056831, 'NL', 'NLD', 'هولندا'),
(64791, 3272056832, 3272065023, 'RU', 'RUS', 'الإتحاد الروسي'),
(64792, 3272065024, 3272065087, 'NL', 'NLD', 'هولندا'),
(64793, 3272065088, 3272065151, 'GB', 'GBR', 'المملكة المتحدة'),
(64794, 3272065152, 3272065183, 'NL', 'NLD', 'هولندا'),
(64795, 3272065184, 3272065215, 'GB', 'GBR', 'المملكة المتحدة'),
(64796, 3272065216, 3272065279, 'NL', 'NLD', 'هولندا'),
(64797, 3272065280, 3272065343, 'GB', 'GBR', 'المملكة المتحدة'),
(64798, 3272065344, 3272065503, 'NL', 'NLD', 'هولندا'),
(64799, 3272065504, 3272065535, 'GB', 'GBR', 'المملكة المتحدة'),
(64800, 3272065536, 3272065551, 'NL', 'NLD', 'هولندا'),
(64801, 3272065552, 3272065559, 'GB', 'GBR', 'المملكة المتحدة'),
(64802, 3272065560, 3272065575, 'NL', 'NLD', 'هولندا'),
(64803, 3272065576, 3272065583, 'GB', 'GBR', 'المملكة المتحدة'),
(64804, 3272065584, 3272065599, 'NL', 'NLD', 'هولندا'),
(64805, 3272065600, 3272065615, 'GB', 'GBR', 'المملكة المتحدة'),
(64806, 3272065616, 3272065663, 'NL', 'NLD', 'هولندا'),
(64807, 3272065664, 3272065791, 'GB', 'GBR', 'المملكة المتحدة'),
(64808, 3272065792, 3272065823, 'NL', 'NLD', 'هولندا'),
(64809, 3272065824, 3272066335, 'GB', 'GBR', 'المملكة المتحدة'),
(64810, 3272066336, 3272066431, 'NL', 'NLD', 'هولندا'),
(64811, 3272066432, 3272066815, 'GB', 'GBR', 'المملكة المتحدة'),
(64812, 3272066816, 3272066879, 'NL', 'NLD', 'هولندا'),
(64813, 3272066880, 3272066911, 'GB', 'GBR', 'المملكة المتحدة'),
(64814, 3272066912, 3272066943, 'NL', 'NLD', 'هولندا'),
(64815, 3272066944, 3272067063, 'GB', 'GBR', 'المملكة المتحدة'),
(64816, 3272067064, 3272067071, 'NL', 'NLD', 'هولندا'),
(64817, 3272067072, 3272067327, 'GB', 'GBR', 'المملكة المتحدة'),
(64818, 3272067328, 3272067583, 'NL', 'NLD', 'هولندا'),
(64819, 3272067584, 3272067615, 'GB', 'GBR', 'المملكة المتحدة'),
(64820, 3272067616, 3272067647, 'NL', 'NLD', 'هولندا'),
(64821, 3272067648, 3272067711, 'GB', 'GBR', 'المملكة المتحدة'),
(64822, 3272067712, 3272067775, 'NL', 'NLD', 'هولندا'),
(64823, 3272067776, 3272067807, 'GB', 'GBR', 'المملكة المتحدة'),
(64824, 3272067808, 3272067839, 'NL', 'NLD', 'هولندا'),
(64825, 3272067840, 3272067871, 'GB', 'GBR', 'المملكة المتحدة'),
(64826, 3272067872, 3272067887, 'NL', 'NLD', 'هولندا'),
(64827, 3272067888, 3272067927, 'GB', 'GBR', 'المملكة المتحدة'),
(64828, 3272067928, 3272067967, 'NL', 'NLD', 'هولندا'),
(64829, 3272067968, 3272068095, 'GB', 'GBR', 'المملكة المتحدة'),
(64830, 3272068096, 3272068351, 'NL', 'NLD', 'هولندا'),
(64831, 3272068352, 3272068607, 'GB', 'GBR', 'المملكة المتحدة'),
(64832, 3272068608, 3272068863, 'NL', 'NLD', 'هولندا'),
(64833, 3272068864, 3272069119, 'GB', 'GBR', 'المملكة المتحدة'),
(64834, 3272069120, 3272069247, 'NL', 'NLD', 'هولندا'),
(64835, 3272069248, 3272069343, 'GB', 'GBR', 'المملكة المتحدة'),
(64836, 3272069344, 3272069375, 'IT', 'ITA', 'إيطاليا'),
(64837, 3272069376, 3272069439, 'NL', 'NLD', 'هولندا'),
(64838, 3272069440, 3272069503, 'GB', 'GBR', 'المملكة المتحدة'),
(64839, 3272069504, 3272069567, 'NL', 'NLD', 'هولندا'),
(64840, 3272069568, 3272069599, 'GB', 'GBR', 'المملكة المتحدة'),
(64841, 3272069600, 3272069603, 'NL', 'NLD', 'هولندا'),
(64842, 3272069604, 3272069607, 'GB', 'GBR', 'المملكة المتحدة'),
(64843, 3272069608, 3272069611, 'NL', 'NLD', 'هولندا'),
(64844, 3272069612, 3272069615, 'GB', 'GBR', 'المملكة المتحدة'),
(64845, 3272069616, 3272069631, 'NL', 'NLD', 'هولندا'),
(64846, 3272069632, 3272070143, 'GB', 'GBR', 'المملكة المتحدة'),
(64847, 3272070144, 3272070255, 'NL', 'NLD', 'هولندا'),
(64848, 3272070256, 3272070263, 'GB', 'GBR', 'المملكة المتحدة'),
(64849, 3272070264, 3272070271, 'NL', 'NLD', 'هولندا'),
(64850, 3272070272, 3272070399, 'GB', 'GBR', 'المملكة المتحدة'),
(64851, 3272070400, 3272070463, 'NL', 'NLD', 'هولندا'),
(64852, 3272070464, 3272070559, 'GB', 'GBR', 'المملكة المتحدة'),
(64853, 3272070560, 3272070591, 'NL', 'NLD', 'هولندا'),
(64854, 3272070592, 3272070623, 'GB', 'GBR', 'المملكة المتحدة'),
(64855, 3272070624, 3272070639, 'NL', 'NLD', 'هولندا'),
(64856, 3272070640, 3272070647, 'GB', 'GBR', 'المملكة المتحدة'),
(64857, 3272070648, 3272070655, 'NL', 'NLD', 'هولندا'),
(64858, 3272070656, 3272070911, 'GB', 'GBR', 'المملكة المتحدة'),
(64859, 3272070912, 3272071167, 'NL', 'NLD', 'هولندا'),
(64860, 3272071168, 3272071247, 'GB', 'GBR', 'المملكة المتحدة'),
(64861, 3272071248, 3272071283, 'NL', 'NLD', 'هولندا'),
(64862, 3272071284, 3272071287, 'GB', 'GBR', 'المملكة المتحدة'),
(64863, 3272071288, 3272071295, 'NL', 'NLD', 'هولندا'),
(64864, 3272071296, 3272071327, 'GB', 'GBR', 'المملكة المتحدة'),
(64865, 3272071328, 3272071551, 'NL', 'NLD', 'هولندا'),
(64866, 3272071552, 3272071615, 'GB', 'GBR', 'المملكة المتحدة'),
(64867, 3272071616, 3272071647, 'NL', 'NLD', 'هولندا'),
(64868, 3272071648, 3272071935, 'GB', 'GBR', 'المملكة المتحدة'),
(64869, 3272071936, 3272072063, 'NL', 'NLD', 'هولندا'),
(64870, 3272072064, 3272072191, 'GB', 'GBR', 'المملكة المتحدة'),
(64871, 3272072192, 3272073215, 'NL', 'NLD', 'هولندا'),
(64872, 3272073216, 3272081407, 'GB', 'GBR', 'المملكة المتحدة'),
(64873, 3272081408, 3272081919, 'PT', 'PRT', 'البورتوغال'),
(64874, 3272081920, 3272082687, 'CV', 'CPV', 'الرأس الأخضر'),
(64875, 3272082688, 3272083455, 'PT', 'PRT', 'البورتوغال'),
(64876, 3272083456, 3272083711, 'ST', 'STP', 'ساو تومي وبرينسيبي'),
(64877, 3272083712, 3272084735, 'PT', 'PRT', 'البورتوغال'),
(64878, 3272084736, 3272084991, 'CV', 'CPV', 'الرأس الأخضر'),
(64879, 3272084992, 3272085503, 'GW', 'GNB', 'غينيا بيساو'),
(64880, 3272085504, 3272086015, 'AO', 'AGO', 'أنغولا'),
(64881, 3272086016, 3272086527, 'ST', 'STP', 'ساو تومي وبرينسيبي'),
(64882, 3272086528, 3272086655, 'AO', 'AGO', 'أنغولا'),
(64883, 3272086656, 3272086783, 'PT', 'PRT', 'البورتوغال'),
(64884, 3272086784, 3272086807, 'GH', 'GHA', 'غانا'),
(64885, 3272086808, 3272086815, 'RO', 'ROM', 'رومانيا'),
(64886, 3272086816, 3272086831, 'NI', 'NIC', 'نيكاراغوا'),
(64887, 3272086832, 3272086879, 'AO', 'AGO', 'أنغولا'),
(64888, 3272086880, 3272086975, 'PT', 'PRT', 'البورتوغال'),
(64889, 3272086976, 3272087039, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(64890, 3272087040, 3272087295, 'PT', 'PRT', 'البورتوغال'),
(64891, 3272087296, 3272087551, 'AO', 'AGO', 'أنغولا'),
(64892, 3272087552, 3272088063, 'PT', 'PRT', 'البورتوغال'),
(64893, 3272088064, 3272088319, 'GH', 'GHA', 'غانا'),
(64894, 3272088320, 3272089343, 'PT', 'PRT', 'البورتوغال'),
(64895, 3272089344, 3272089479, 'ST', 'STP', 'ساو تومي وبرينسيبي'),
(64896, 3272089480, 3272089535, 'PT', 'PRT', 'البورتوغال'),
(64897, 3272089536, 3272089551, 'ST', 'STP', 'ساو تومي وبرينسيبي'),
(64898, 3272089552, 3272089599, 'PT', 'PRT', 'البورتوغال'),
(64899, 3272089600, 3272090111, 'NO', 'NOR', 'النرويج'),
(64900, 3272090112, 3272091647, 'RU', 'RUS', 'الإتحاد الروسي'),
(64901, 3272091648, 3272092671, 'UA', 'UKR', 'أوكرانيا'),
(64902, 3272092672, 3272093183, 'RU', 'RUS', 'الإتحاد الروسي'),
(64903, 3272093184, 3272094207, 'RO', 'ROM', 'رومانيا'),
(64904, 3272094208, 3272094719, 'AM', 'ARM', 'أرمينيا'),
(64905, 3272094720, 3272095231, 'PL', 'POL', 'بولندا'),
(64906, 3272095232, 3272095743, 'FI', 'FIN', 'فنلندا'),
(64907, 3272095744, 3272096255, 'UA', 'UKR', 'أوكرانيا'),
(64908, 3272096256, 3272096767, 'PT', 'PRT', 'البورتوغال'),
(64909, 3272096768, 3272097279, 'FI', 'FIN', 'فنلندا'),
(64910, 3272097280, 3272097791, 'RU', 'RUS', 'الإتحاد الروسي'),
(64911, 3272097792, 3272098519, 'GB', 'GBR', 'المملكة المتحدة'),
(64912, 3272098520, 3272098527, 'FR', 'FRA', 'فرنسا'),
(64913, 3272098528, 3272106239, 'GB', 'GBR', 'المملكة المتحدة'),
(64914, 3272106240, 3272106495, 'PL', 'POL', 'بولندا'),
(64915, 3272106496, 3272106751, 'SE', 'SWE', 'السويد'),
(64916, 3272106752, 3272107007, 'PL', 'POL', 'بولندا'),
(64917, 3272107008, 3272107263, 'GB', 'GBR', 'المملكة المتحدة'),
(64918, 3272107264, 3272107519, 'PL', 'POL', 'بولندا'),
(64919, 3272107520, 3272107775, 'RU', 'RUS', 'الإتحاد الروسي'),
(64920, 3272107776, 3272108031, 'GB', 'GBR', 'المملكة المتحدة'),
(64921, 3272108032, 3272108287, 'DE', 'DEU', 'ألمانيا'),
(64922, 3272108288, 3272108543, 'RO', 'ROM', 'رومانيا'),
(64923, 3272108544, 3272109055, 'PL', 'POL', 'بولندا'),
(64924, 3272109056, 3272109311, 'CH', 'CHE', 'سويسرا'),
(64925, 3272109312, 3272109567, 'TR', 'TUR', 'تركيا'),
(64926, 3272109568, 3272109823, 'GB', 'GBR', 'المملكة المتحدة'),
(64927, 3272109824, 3272110079, 'FR', 'FRA', 'فرنسا'),
(64928, 3272110080, 3272110335, 'SE', 'SWE', 'السويد'),
(64929, 3272110336, 3272110591, 'CH', 'CHE', 'سويسرا'),
(64930, 3272110592, 3272110847, 'AT', 'AUT', 'النمسا'),
(64931, 3272110848, 3272111103, 'LV', 'LVA', 'لاتفيا'),
(64932, 3272111104, 3272111871, 'GB', 'GBR', 'المملكة المتحدة'),
(64933, 3272111872, 3272112383, 'RO', 'ROM', 'رومانيا'),
(64934, 3272112384, 3272113151, 'DE', 'DEU', 'ألمانيا'),
(64935, 3272113152, 3272113407, 'FR', 'FRA', 'فرنسا'),
(64936, 3272113408, 3272113663, 'PL', 'POL', 'بولندا'),
(64937, 3272113664, 3272113919, 'GB', 'GBR', 'المملكة المتحدة'),
(64938, 3272113920, 3272114175, 'AT', 'AUT', 'النمسا'),
(64939, 3272114176, 3272122367, 'PL', 'POL', 'بولندا'),
(64940, 3272122368, 3272131071, 'GB', 'GBR', 'المملكة المتحدة'),
(64941, 3272131072, 3272131583, 'RO', 'ROM', 'رومانيا'),
(64942, 3272131584, 3272132095, 'GB', 'GBR', 'المملكة المتحدة'),
(64943, 3272132096, 3272132607, 'CH', 'CHE', 'سويسرا'),
(64944, 3272132608, 3272133119, 'UA', 'UKR', 'أوكرانيا'),
(64945, 3272133120, 3272133631, 'GB', 'GBR', 'المملكة المتحدة'),
(64946, 3272133632, 3272134143, 'EE', 'EST', 'إستونيا'),
(64947, 3272134144, 3272134655, 'RO', 'ROM', 'رومانيا'),
(64948, 3272134656, 3272135167, 'NL', 'NLD', 'هولندا'),
(64949, 3272135168, 3272135679, 'CH', 'CHE', 'سويسرا'),
(64950, 3272135680, 3272136191, 'AT', 'AUT', 'النمسا'),
(64951, 3272136192, 3272136703, 'FR', 'FRA', 'فرنسا'),
(64952, 3272136704, 3272137215, 'PL', 'POL', 'بولندا'),
(64953, 3272137216, 3272137727, 'LT', 'LTU', 'ليتوانيا'),
(64954, 3272137728, 3272138239, 'PL', 'POL', 'بولندا'),
(64955, 3272138240, 3272138751, 'BG', 'BGR', 'بلغاريا'),
(64956, 3272138752, 3272146943, 'DE', 'DEU', 'ألمانيا'),
(64957, 3272146944, 3272161023, 'RU', 'RUS', 'الإتحاد الروسي'),
(64958, 3272161024, 3272161279, 'KZ', 'KAZ', 'كازاخستان'),
(64959, 3272161280, 3272169215, 'RU', 'RUS', 'الإتحاد الروسي'),
(64960, 3272169216, 3272169471, 'UA', 'UKR', 'أوكرانيا'),
(64961, 3272169472, 3272178559, 'RU', 'RUS', 'الإتحاد الروسي'),
(64962, 3272178560, 3272178623, 'UA', 'UKR', 'أوكرانيا'),
(64963, 3272178624, 3272210175, 'RU', 'RUS', 'الإتحاد الروسي'),
(64964, 3272210176, 3272210431, 'UA', 'UKR', 'أوكرانيا'),
(64965, 3272210432, 3272212479, 'RU', 'RUS', 'الإتحاد الروسي'),
(64966, 3272212480, 3272212991, 'GB', 'GBR', 'المملكة المتحدة'),
(64967, 3272213376, 3272213391, 'IT', 'ITA', 'إيطاليا'),
(64968, 3272213392, 3272213399, 'GB', 'GBR', 'المملكة المتحدة'),
(64969, 3272213408, 3272213415, 'NL', 'NLD', 'هولندا'),
(64970, 3272213424, 3272213431, 'NL', 'NLD', 'هولندا'),
(64971, 3272213432, 3272213455, 'GB', 'GBR', 'المملكة المتحدة'),
(64972, 3272213472, 3272213487, 'CY', 'CYP', 'قبرص'),
(64973, 3272213488, 3272213495, 'GB', 'GBR', 'المملكة المتحدة'),
(64974, 3272213504, 3272213567, 'IT', 'ITA', 'إيطاليا'),
(64975, 3272213568, 3272213575, 'GB', 'GBR', 'المملكة المتحدة'),
(64976, 3272213576, 3272213583, 'IE', 'IRL', 'إيرلندا'),
(64977, 3272213584, 3272213599, 'DE', 'DEU', 'ألمانيا'),
(64978, 3272213632, 3272213639, 'NL', 'NLD', 'هولندا'),
(64979, 3272213656, 3272213663, 'IT', 'ITA', 'إيطاليا'),
(64980, 3272213672, 3272213679, 'IT', 'ITA', 'إيطاليا'),
(64981, 3272213696, 3272213735, 'IT', 'ITA', 'إيطاليا'),
(64982, 3272213752, 3272213759, 'IT', 'ITA', 'إيطاليا'),
(64983, 3272213760, 3272213823, 'NL', 'NLD', 'هولندا'),
(64984, 3272213824, 3272213831, 'DE', 'DEU', 'ألمانيا'),
(64985, 3272213832, 3272213839, 'NL', 'NLD', 'هولندا'),
(64986, 3272213840, 3272213855, 'RU', 'RUS', 'الإتحاد الروسي'),
(64987, 3272213888, 3272214015, 'GB', 'GBR', 'المملكة المتحدة'),
(64988, 3272214016, 3272214271, 'ES', 'ESP', 'إسبانيا'),
(64989, 3272214272, 3272214351, 'GB', 'GBR', 'المملكة المتحدة'),
(64990, 3272214352, 3272214407, 'FR', 'FRA', 'فرنسا'),
(64991, 3272214432, 3272214463, 'SE', 'SWE', 'السويد'),
(64992, 3272214656, 3272214671, 'NL', 'NLD', 'هولندا'),
(64993, 3272214672, 3272214679, 'GB', 'GBR', 'المملكة المتحدة'),
(64994, 3272214680, 3272214687, 'FR', 'FRA', 'فرنسا'),
(64995, 3272214816, 3272214823, 'CH', 'CHE', 'سويسرا'),
(64996, 3272214832, 3272214847, 'BE', 'BEL', 'بلجيكا'),
(64997, 3272214848, 3272214879, 'NL', 'NLD', 'هولندا'),
(64998, 3272214884, 3272214887, 'NL', 'NLD', 'هولندا'),
(64999, 3272214896, 3272214903, 'ES', 'ESP', 'إسبانيا'),
(65000, 3272214904, 3272214911, 'SE', 'SWE', 'السويد'),
(65001, 3272214944, 3272214951, 'DE', 'DEU', 'ألمانيا'),
(65002, 3272214952, 3272214959, 'BE', 'BEL', 'بلجيكا'),
(65003, 3272214960, 3272215007, 'NL', 'NLD', 'هولندا'),
(65004, 3272215008, 3272215015, 'FR', 'FRA', 'فرنسا'),
(65005, 3272215016, 3272215023, 'IT', 'ITA', 'إيطاليا'),
(65006, 3272215040, 3272215295, 'ES', 'ESP', 'إسبانيا'),
(65007, 3272215296, 3272215551, 'IR', 'IRN', 'إيران'),
(65008, 3272215552, 3272215807, 'CH', 'CHE', 'سويسرا'),
(65009, 3272215808, 3272215823, 'NL', 'NLD', 'هولندا'),
(65010, 3272215872, 3272215879, 'BE', 'BEL', 'بلجيكا'),
(65011, 3272215884, 3272215919, 'CH', 'CHE', 'سويسرا'),
(65012, 3272215920, 3272215935, 'NL', 'NLD', 'هولندا'),
(65013, 3272215936, 3272215999, 'GB', 'GBR', 'المملكة المتحدة'),
(65014, 3272216016, 3272216031, 'DE', 'DEU', 'ألمانيا'),
(65015, 3272216040, 3272216047, 'GB', 'GBR', 'المملكة المتحدة'),
(65016, 3272216192, 3272216207, 'BE', 'BEL', 'بلجيكا'),
(65017, 3272216216, 3272216223, 'FR', 'FRA', 'فرنسا'),
(65018, 3272216224, 3272216231, 'DE', 'DEU', 'ألمانيا'),
(65019, 3272216240, 3272216255, 'NL', 'NLD', 'هولندا'),
(65020, 3272216256, 3272216287, 'CH', 'CHE', 'سويسرا'),
(65021, 3272216304, 3272216311, 'ES', 'ESP', 'إسبانيا'),
(65022, 3272216320, 3272216351, 'NL', 'NLD', 'هولندا'),
(65023, 3272216352, 3272216383, 'DE', 'DEU', 'ألمانيا'),
(65024, 3272216384, 3272216447, 'CH', 'CHE', 'سويسرا'),
(65025, 3272216452, 3272216455, 'NL', 'NLD', 'هولندا'),
(65026, 3272216464, 3272216479, 'FR', 'FRA', 'فرنسا'),
(65027, 3272216480, 3272216495, 'IR', 'IRN', 'إيران'),
(65028, 3272216512, 3272216575, 'IT', 'ITA', 'إيطاليا'),
(65029, 3272216576, 3272216895, 'GB', 'GBR', 'المملكة المتحدة'),
(65030, 3272216896, 3272216911, 'FR', 'FRA', 'فرنسا'),
(65031, 3272216912, 3272216927, 'DE', 'DEU', 'ألمانيا'),
(65032, 3272216960, 3272217007, 'GB', 'GBR', 'المملكة المتحدة'),
(65033, 3272217216, 3272217279, 'BE', 'BEL', 'بلجيكا'),
(65034, 3272217280, 3272217303, 'DE', 'DEU', 'ألمانيا'),
(65035, 3272217304, 3272217311, 'BE', 'BEL', 'بلجيكا'),
(65036, 3272217600, 3272217631, 'CH', 'CHE', 'سويسرا'),
(65037, 3272217856, 3272217875, 'ES', 'ESP', 'إسبانيا'),
(65038, 3272217880, 3272217895, 'IT', 'ITA', 'إيطاليا'),
(65039, 3272217896, 3272217903, 'ES', 'ESP', 'إسبانيا'),
(65040, 3272217920, 3272217983, 'DE', 'DEU', 'ألمانيا'),
(65041, 3272217984, 3272218079, 'ES', 'ESP', 'إسبانيا'),
(65042, 3272218112, 3272218623, 'GB', 'GBR', 'المملكة المتحدة'),
(65043, 3272218624, 3272218639, 'RU', 'RUS', 'الإتحاد الروسي'),
(65044, 3272218640, 3272218671, 'DE', 'DEU', 'ألمانيا'),
(65045, 3272218688, 3272218719, 'DE', 'DEU', 'ألمانيا'),
(65046, 3272218880, 3272219135, 'BE', 'BEL', 'بلجيكا'),
(65047, 3272219136, 3272219391, 'NL', 'NLD', 'هولندا'),
(65048, 3272219648, 3272219903, 'FR', 'FRA', 'فرنسا'),
(65049, 3272219904, 3272220159, 'DE', 'DEU', 'ألمانيا'),
(65050, 3272220160, 3272220415, 'FR', 'FRA', 'فرنسا'),
(65051, 3272220416, 3272221183, 'GB', 'GBR', 'المملكة المتحدة'),
(65052, 3272221184, 3272221311, 'NL', 'NLD', 'هولندا'),
(65053, 3272221440, 3272221447, 'SE', 'SWE', 'السويد'),
(65054, 3272221448, 3272221455, 'NO', 'NOR', 'النرويج'),
(65055, 3272221456, 3272221463, 'SE', 'SWE', 'السويد'),
(65056, 3272221696, 3272221951, 'NL', 'NLD', 'هولندا'),
(65057, 3272221952, 3272222207, 'GB', 'GBR', 'المملكة المتحدة'),
(65058, 3272222208, 3272222463, 'ES', 'ESP', 'إسبانيا'),
(65059, 3272222464, 3272222719, 'NL', 'NLD', 'هولندا'),
(65060, 3272222720, 3272222975, 'DE', 'DEU', 'ألمانيا'),
(65061, 3272222976, 3272223015, 'GB', 'GBR', 'المملكة المتحدة'),
(65062, 3272223024, 3272223039, 'GB', 'GBR', 'المملكة المتحدة'),
(65063, 3272223232, 3272223487, 'NL', 'NLD', 'هولندا'),
(65064, 3272223488, 3272223743, 'GB', 'GBR', 'المملكة المتحدة'),
(65065, 3272223744, 3272223775, 'GI', 'GIB', 'جبل طارق'),
(65066, 3272223808, 3272223815, 'CY', 'CYP', 'قبرص'),
(65067, 3272223824, 3272223839, 'GB', 'GBR', 'المملكة المتحدة'),
(65068, 3272224000, 3272224255, 'GB', 'GBR', 'المملكة المتحدة'),
(65069, 3272224256, 3272224383, 'GI', 'GIB', 'جبل طارق'),
(65070, 3272224512, 3272225279, 'GB', 'GBR', 'المملكة المتحدة'),
(65071, 3272225280, 3272225791, 'IT', 'ITA', 'إيطاليا'),
(65072, 3272226048, 3272226815, 'FR', 'FRA', 'فرنسا'),
(65073, 3272226816, 3272227071, 'GB', 'GBR', 'المملكة المتحدة'),
(65074, 3272227072, 3272227327, 'NL', 'NLD', 'هولندا'),
(65075, 3272227328, 3272227359, 'US', 'USA', 'الولايات المتحدة'),
(65076, 3272227360, 3272227511, 'GB', 'GBR', 'المملكة المتحدة'),
(65077, 3272227520, 3272227583, 'GB', 'GBR', 'المملكة المتحدة'),
(65078, 3272227584, 3272227839, 'FR', 'FRA', 'فرنسا'),
(65079, 3272227840, 3272228095, 'ES', 'ESP', 'إسبانيا'),
(65080, 3272228096, 3272228223, 'GB', 'GBR', 'المملكة المتحدة'),
(65081, 3272228224, 3272228351, 'ES', 'ESP', 'إسبانيا'),
(65082, 3272228352, 3272228607, 'FR', 'FRA', 'فرنسا'),
(65083, 3272228608, 3272228623, 'NL', 'NLD', 'هولندا'),
(65084, 3272228624, 3272228631, 'CY', 'CYP', 'قبرص'),
(65085, 3272228632, 3272228639, 'NL', 'NLD', 'هولندا'),
(65086, 3272228640, 3272228671, 'IT', 'ITA', 'إيطاليا'),
(65087, 3272228672, 3272228703, 'DE', 'DEU', 'ألمانيا'),
(65088, 3272228704, 3272228735, 'FR', 'FRA', 'فرنسا'),
(65089, 3272228736, 3272228799, 'NL', 'NLD', 'هولندا'),
(65090, 3272228800, 3272228863, 'CH', 'CHE', 'سويسرا'),
(65091, 3272228864, 3272237055, 'LU', 'LUX', 'لوكسيمبورغ'),
(65092, 3272237056, 3272240575, 'GB', 'GBR', 'المملكة المتحدة'),
(65093, 3272240576, 3272240639, 'GH', 'GHA', 'غانا'),
(65094, 3272240640, 3272245247, 'GB', 'GBR', 'المملكة المتحدة'),
(65095, 3272245248, 3272261631, 'FI', 'FIN', 'فنلندا'),
(65096, 3272261632, 3272261887, 'MT', 'MLT', 'مالطا'),
(65097, 3272261888, 3272262143, 'BG', 'BGR', 'بلغاريا'),
(65098, 3272262144, 3272262399, 'IL', 'ISR', 'إسرائيل'),
(65099, 3272262400, 3272262655, 'DE', 'DEU', 'ألمانيا'),
(65100, 3272262656, 3272262911, 'NO', 'NOR', 'النرويج'),
(65101, 3272262912, 3272263167, 'SA', 'SAU', 'السعودية'),
(65102, 3272263168, 3272263423, 'RU', 'RUS', 'الإتحاد الروسي'),
(65103, 3272263424, 3272263935, 'GB', 'GBR', 'المملكة المتحدة'),
(65104, 3272263936, 3272264191, 'ES', 'ESP', 'إسبانيا'),
(65105, 3272264192, 3272264447, 'NL', 'NLD', 'هولندا'),
(65106, 3272264448, 3272264703, 'DE', 'DEU', 'ألمانيا'),
(65107, 3272264704, 3272264959, 'LV', 'LVA', 'لاتفيا'),
(65108, 3272264960, 3272265215, 'RU', 'RUS', 'الإتحاد الروسي'),
(65109, 3272265216, 3272265471, 'AT', 'AUT', 'النمسا'),
(65110, 3272265472, 3272265727, 'DK', 'DNK', 'الدنيمارك'),
(65111, 3272265728, 3272265983, 'DE', 'DEU', 'ألمانيا'),
(65112, 3272265984, 3272266239, 'GB', 'GBR', 'المملكة المتحدة'),
(65113, 3272266240, 3272266495, 'UA', 'UKR', 'أوكرانيا'),
(65114, 3272266496, 3272266751, 'SE', 'SWE', 'السويد'),
(65115, 3272267008, 3272267263, 'GB', 'GBR', 'المملكة المتحدة'),
(65116, 3272267264, 3272267519, 'SE', 'SWE', 'السويد'),
(65117, 3272267520, 3272267775, 'GB', 'GBR', 'المملكة المتحدة'),
(65118, 3272267776, 3272268031, 'LV', 'LVA', 'لاتفيا'),
(65119, 3272268288, 3272268543, 'UA', 'UKR', 'أوكرانيا'),
(65120, 3272268544, 3272268799, 'RO', 'ROM', 'رومانيا'),
(65121, 3272268800, 3272269055, 'IL', 'ISR', 'إسرائيل'),
(65122, 3272269056, 3272269311, 'GB', 'GBR', 'المملكة المتحدة'),
(65123, 3272269312, 3272269567, 'IL', 'ISR', 'إسرائيل'),
(65124, 3272269568, 3272335359, 'GB', 'GBR', 'المملكة المتحدة'),
(65125, 3272335360, 3272343551, 'NL', 'NLD', 'هولندا'),
(65126, 3272343552, 3272351743, 'GB', 'GBR', 'المملكة المتحدة'),
(65127, 3272351744, 3272352767, 'PL', 'POL', 'بولندا'),
(65128, 3272352768, 3272353791, 'UA', 'UKR', 'أوكرانيا'),
(65129, 3272353792, 3272355839, 'CH', 'CHE', 'سويسرا'),
(65130, 3272355840, 3272356863, 'GB', 'GBR', 'المملكة المتحدة'),
(65131, 3272356864, 3272357887, 'RO', 'ROM', 'رومانيا'),
(65132, 3272357888, 3272358911, 'UA', 'UKR', 'أوكرانيا'),
(65133, 3272358912, 3272359935, 'NL', 'NLD', 'هولندا'),
(65134, 3272359936, 3272368127, 'RU', 'RUS', 'الإتحاد الروسي'),
(65135, 3272368128, 3272376319, 'KZ', 'KAZ', 'كازاخستان'),
(65136, 3272376320, 3272384511, 'SK', 'SVK', 'سلوفاكيا'),
(65137, 3272384512, 3272392703, 'LT', 'LTU', 'ليتوانيا'),
(65138, 3272392704, 3272400895, 'AT', 'AUT', 'النمسا'),
(65139, 3272400904, 3272400927, 'GB', 'GBR', 'المملكة المتحدة'),
(65140, 3272401024, 3272401087, 'GB', 'GBR', 'المملكة المتحدة'),
(65141, 3272401184, 3272401199, 'GB', 'GBR', 'المملكة المتحدة'),
(65142, 3272401408, 3272401919, 'ES', 'ESP', 'إسبانيا'),
(65143, 3272401920, 3272401951, 'GB', 'GBR', 'المملكة المتحدة'),
(65144, 3272401984, 3272402015, 'DE', 'DEU', 'ألمانيا'),
(65145, 3272402032, 3272402039, 'GB', 'GBR', 'المملكة المتحدة'),
(65146, 3272402040, 3272402047, 'US', 'USA', 'الولايات المتحدة'),
(65147, 3272402080, 3272402111, 'SE', 'SWE', 'السويد'),
(65148, 3272402176, 3272402191, 'GB', 'GBR', 'المملكة المتحدة'),
(65149, 3272402240, 3272402303, 'GB', 'GBR', 'المملكة المتحدة'),
(65150, 3272402304, 3272402431, 'FR', 'FRA', 'فرنسا'),
(65151, 3272402560, 3272402623, 'GB', 'GBR', 'المملكة المتحدة'),
(65152, 3272402688, 3272402815, 'SE', 'SWE', 'السويد'),
(65153, 3272402816, 3272402879, 'GB', 'GBR', 'المملكة المتحدة'),
(65154, 3272403072, 3272403199, 'FR', 'FRA', 'فرنسا'),
(65155, 3272409088, 3272417279, 'BE', 'BEL', 'بلجيكا'),
(65156, 3272417280, 3272418687, 'FR', 'FRA', 'فرنسا'),
(65157, 3272418688, 3272419327, 'PL', 'POL', 'بولندا'),
(65158, 3272419328, 3272420863, 'DE', 'DEU', 'ألمانيا'),
(65159, 3272420864, 3272420991, 'PL', 'POL', 'بولندا'),
(65160, 3272420992, 3272421119, 'DK', 'DNK', 'الدنيمارك'),
(65161, 3272421120, 3272421375, 'UA', 'UKR', 'أوكرانيا'),
(65162, 3272421376, 3272421887, 'RO', 'ROM', 'رومانيا'),
(65163, 3272421888, 3272422399, 'GB', 'GBR', 'المملكة المتحدة'),
(65164, 3272422400, 3272422911, 'CH', 'CHE', 'سويسرا'),
(65165, 3272422912, 3272423423, 'SE', 'SWE', 'السويد'),
(65166, 3272423424, 3272423935, 'BE', 'BEL', 'بلجيكا'),
(65167, 3272423936, 3272424447, 'FR', 'FRA', 'فرنسا'),
(65168, 3272424448, 3272425471, 'DE', 'DEU', 'ألمانيا'),
(65169, 3272425472, 3272426655, 'GB', 'GBR', 'المملكة المتحدة'),
(65170, 3272426656, 3272426671, 'IL', 'ISR', 'إسرائيل'),
(65171, 3272426672, 3272441855, 'GB', 'GBR', 'المملكة المتحدة'),
(65172, 3272441856, 3272474623, 'LV', 'LVA', 'لاتفيا'),
(65173, 3272474624, 3272474879, 'FR', 'FRA', 'فرنسا'),
(65174, 3272474880, 3272475135, 'NL', 'NLD', 'هولندا'),
(65175, 3272475136, 3272475391, 'RU', 'RUS', 'الإتحاد الروسي'),
(65176, 3272475392, 3272475903, 'PL', 'POL', 'بولندا'),
(65177, 3272475904, 3272476159, 'FR', 'FRA', 'فرنسا'),
(65178, 3272476160, 3272476671, 'RO', 'ROM', 'رومانيا'),
(65179, 3272476672, 3272476927, 'DE', 'DEU', 'ألمانيا'),
(65180, 3272476928, 3272477183, 'GR', 'GRC', 'اليونان'),
(65181, 3272477184, 3272477439, 'GB', 'GBR', 'المملكة المتحدة'),
(65182, 3272477440, 3272477695, 'PL', 'POL', 'بولندا'),
(65183, 3272477696, 3272477951, 'RU', 'RUS', 'الإتحاد الروسي'),
(65184, 3272477952, 3272478207, 'RO', 'ROM', 'رومانيا'),
(65185, 3272478208, 3272478463, 'DK', 'DNK', 'الدنيمارك'),
(65186, 3272478464, 3272478719, 'FI', 'FIN', 'فنلندا'),
(65187, 3272478720, 3272478975, 'GB', 'GBR', 'المملكة المتحدة'),
(65188, 3272478976, 3272479231, 'UA', 'UKR', 'أوكرانيا'),
(65189, 3272479232, 3272479487, 'GB', 'GBR', 'المملكة المتحدة'),
(65190, 3272479488, 3272479743, 'SA', 'SAU', 'السعودية'),
(65191, 3272479744, 3272480255, 'SE', 'SWE', 'السويد'),
(65192, 3272480256, 3272480511, 'FR', 'FRA', 'فرنسا'),
(65193, 3272480512, 3272480767, 'CH', 'CHE', 'سويسرا'),
(65194, 3272480768, 3272481023, 'DE', 'DEU', 'ألمانيا'),
(65195, 3272481024, 3272481279, 'SE', 'SWE', 'السويد'),
(65196, 3272481280, 3272481535, 'CH', 'CHE', 'سويسرا'),
(65197, 3272481536, 3272481791, 'FR', 'FRA', 'فرنسا'),
(65198, 3272481792, 3272482047, 'IT', 'ITA', 'إيطاليا'),
(65199, 3272482048, 3272482303, 'NL', 'NLD', 'هولندا'),
(65200, 3272482304, 3272482559, 'FR', 'FRA', 'فرنسا'),
(65201, 3272482560, 3272482815, 'BE', 'BEL', 'بلجيكا'),
(65202, 3272482816, 3272491007, 'RU', 'RUS', 'الإتحاد الروسي'),
(65203, 3272491008, 3272499199, 'GB', 'GBR', 'المملكة المتحدة'),
(65204, 3272507392, 3272515583, 'CY', 'CYP', 'قبرص'),
(65205, 3272515584, 3272523775, 'LT', 'LTU', 'ليتوانيا'),
(65206, 3272523776, 3272540159, 'DE', 'DEU', 'ألمانيا'),
(65207, 3272540160, 3272546559, 'CH', 'CHE', 'سويسرا'),
(65208, 3272546560, 3272546815, 'FR', 'FRA', 'فرنسا'),
(65209, 3272546816, 3272547387, 'CH', 'CHE', 'سويسرا'),
(65210, 3272547388, 3272547391, 'FR', 'FRA', 'فرنسا'),
(65211, 3272547392, 3272552735, 'CH', 'CHE', 'سويسرا'),
(65212, 3272552736, 3272552743, 'FR', 'FRA', 'فرنسا'),
(65213, 3272552744, 3272552879, 'CH', 'CHE', 'سويسرا'),
(65214, 3272552880, 3272552887, 'FR', 'FRA', 'فرنسا'),
(65215, 3272552888, 3272553471, 'CH', 'CHE', 'سويسرا'),
(65216, 3272553472, 3272553487, 'FR', 'FRA', 'فرنسا'),
(65217, 3272553488, 3272554779, 'CH', 'CHE', 'سويسرا'),
(65218, 3272554780, 3272554783, 'FR', 'FRA', 'فرنسا'),
(65219, 3272554784, 3272555247, 'CH', 'CHE', 'سويسرا'),
(65220, 3272555248, 3272555255, 'FR', 'FRA', 'فرنسا'),
(65221, 3272555256, 3272555407, 'CH', 'CHE', 'سويسرا'),
(65222, 3272555408, 3272555423, 'FR', 'FRA', 'فرنسا'),
(65223, 3272555424, 3272556599, 'CH', 'CHE', 'سويسرا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(65224, 3272556600, 3272556607, 'FR', 'FRA', 'فرنسا'),
(65225, 3272556608, 3272568079, 'CH', 'CHE', 'سويسرا'),
(65226, 3272568080, 3272568095, 'FR', 'FRA', 'فرنسا'),
(65227, 3272568096, 3272572879, 'CH', 'CHE', 'سويسرا'),
(65228, 3272572880, 3272572895, 'FR', 'FRA', 'فرنسا'),
(65229, 3272572896, 3272605695, 'CH', 'CHE', 'سويسرا'),
(65230, 3272605696, 3272613887, 'BE', 'BEL', 'بلجيكا'),
(65231, 3272613888, 3272622079, 'RU', 'RUS', 'الإتحاد الروسي'),
(65232, 3272622080, 3272623103, 'RO', 'ROM', 'رومانيا'),
(65233, 3272623104, 3272624127, 'DE', 'DEU', 'ألمانيا'),
(65234, 3272624128, 3272625151, 'RU', 'RUS', 'الإتحاد الروسي'),
(65235, 3272625152, 3272626175, 'UA', 'UKR', 'أوكرانيا'),
(65236, 3272626176, 3272627199, 'DE', 'DEU', 'ألمانيا'),
(65237, 3272627200, 3272628223, 'NL', 'NLD', 'هولندا'),
(65238, 3272628224, 3272629247, 'UA', 'UKR', 'أوكرانيا'),
(65239, 3272629248, 3272633983, 'RU', 'RUS', 'الإتحاد الروسي'),
(65240, 3272633984, 3272634047, 'KZ', 'KAZ', 'كازاخستان'),
(65241, 3272634048, 3272638463, 'RU', 'RUS', 'الإتحاد الروسي'),
(65242, 3272638464, 3272646655, 'ES', 'ESP', 'إسبانيا'),
(65243, 3272646656, 3272646784, 'DE', 'DEU', 'ألمانيا'),
(65244, 3272646785, 3272646911, 'GB', 'GBR', 'المملكة المتحدة'),
(65245, 3272646912, 3272647423, 'DE', 'DEU', 'ألمانيا'),
(65246, 3272647424, 3272649215, 'GB', 'GBR', 'المملكة المتحدة'),
(65247, 3272649216, 3272649727, 'IE', 'IRL', 'إيرلندا'),
(65248, 3272649728, 3272650623, 'GB', 'GBR', 'المملكة المتحدة'),
(65249, 3272650624, 3272650639, 'FR', 'FRA', 'فرنسا'),
(65250, 3272650640, 3272650655, 'GB', 'GBR', 'المملكة المتحدة'),
(65251, 3272650656, 3272650751, 'NL', 'NLD', 'هولندا'),
(65252, 3272650752, 3272651135, 'GB', 'GBR', 'المملكة المتحدة'),
(65253, 3272651136, 3272651151, 'CH', 'CHE', 'سويسرا'),
(65254, 3272651152, 3272651183, 'GB', 'GBR', 'المملكة المتحدة'),
(65255, 3272651184, 3272651191, 'NL', 'NLD', 'هولندا'),
(65256, 3272651192, 3272651231, 'GB', 'GBR', 'المملكة المتحدة'),
(65257, 3272651232, 3272651239, 'UZ', 'UZB', 'أوزباكستان'),
(65258, 3272651240, 3272652287, 'GB', 'GBR', 'المملكة المتحدة'),
(65259, 3272652288, 3272652799, 'FR', 'FRA', 'فرنسا'),
(65260, 3272652800, 3272653055, 'GB', 'GBR', 'المملكة المتحدة'),
(65261, 3272653056, 3272653087, 'CH', 'CHE', 'سويسرا'),
(65262, 3272653088, 3272653247, 'GB', 'GBR', 'المملكة المتحدة'),
(65263, 3272653248, 3272653279, 'FR', 'FRA', 'فرنسا'),
(65264, 3272653280, 3272653311, 'GB', 'GBR', 'المملكة المتحدة'),
(65265, 3272653312, 3272653439, 'SE', 'SWE', 'السويد'),
(65266, 3272653440, 3272653447, 'GB', 'GBR', 'المملكة المتحدة'),
(65267, 3272653448, 3272653455, 'IE', 'IRL', 'إيرلندا'),
(65268, 3272653456, 3272653463, 'DE', 'DEU', 'ألمانيا'),
(65269, 3272653464, 3272653543, 'GB', 'GBR', 'المملكة المتحدة'),
(65270, 3272653544, 3272653551, 'NL', 'NLD', 'هولندا'),
(65271, 3272653552, 3272653567, 'GB', 'GBR', 'المملكة المتحدة'),
(65272, 3272653568, 3272653631, 'SE', 'SWE', 'السويد'),
(65273, 3272653632, 3272653663, 'FR', 'FRA', 'فرنسا'),
(65274, 3272653664, 3272653695, 'DE', 'DEU', 'ألمانيا'),
(65275, 3272653696, 3272653727, 'IT', 'ITA', 'إيطاليا'),
(65276, 3272653728, 3272653759, 'NL', 'NLD', 'هولندا'),
(65277, 3272653760, 3272653791, 'DK', 'DNK', 'الدنيمارك'),
(65278, 3272653792, 3272653823, 'GB', 'GBR', 'المملكة المتحدة'),
(65279, 3272653824, 3272653951, 'FR', 'FRA', 'فرنسا'),
(65280, 3272653952, 3272654207, 'DE', 'DEU', 'ألمانيا'),
(65281, 3272654208, 3272654335, 'FR', 'FRA', 'فرنسا'),
(65282, 3272654336, 3272654463, 'ES', 'ESP', 'إسبانيا'),
(65283, 3272654464, 3272654591, 'GB', 'GBR', 'المملكة المتحدة'),
(65284, 3272654592, 3272654719, 'NO', 'NOR', 'النرويج'),
(65285, 3272654720, 3272654783, 'IT', 'ITA', 'إيطاليا'),
(65286, 3272654784, 3272654847, 'NL', 'NLD', 'هولندا'),
(65287, 3272654848, 3272663039, 'FI', 'FIN', 'فنلندا'),
(65288, 3272663040, 3272671231, 'AT', 'AUT', 'النمسا'),
(65289, 3272671232, 3272704255, 'SE', 'SWE', 'السويد'),
(65290, 3272704256, 3272705279, 'IE', 'IRL', 'إيرلندا'),
(65291, 3272705280, 3272705535, 'SE', 'SWE', 'السويد'),
(65292, 3272705536, 3272707071, 'IE', 'IRL', 'إيرلندا'),
(65293, 3272707072, 3272707327, 'SE', 'SWE', 'السويد'),
(65294, 3272707328, 3272707583, 'IE', 'IRL', 'إيرلندا'),
(65295, 3272707584, 3272712191, 'SE', 'SWE', 'السويد'),
(65296, 3272712192, 3272712447, 'GB', 'GBR', 'المملكة المتحدة'),
(65297, 3272712448, 3272712703, 'SE', 'SWE', 'السويد'),
(65298, 3272712704, 3272712959, 'GB', 'GBR', 'المملكة المتحدة'),
(65299, 3272712960, 3272713215, 'SE', 'SWE', 'السويد'),
(65300, 3272713216, 3272713983, 'GB', 'GBR', 'المملكة المتحدة'),
(65301, 3272713984, 3272714495, 'SE', 'SWE', 'السويد'),
(65302, 3272714496, 3272714751, 'GB', 'GBR', 'المملكة المتحدة'),
(65303, 3272714752, 3272715015, 'SE', 'SWE', 'السويد'),
(65304, 3272715016, 3272715023, 'GB', 'GBR', 'المملكة المتحدة'),
(65305, 3272715024, 3272715135, 'SE', 'SWE', 'السويد'),
(65306, 3272715136, 3272715263, 'GB', 'GBR', 'المملكة المتحدة'),
(65307, 3272715264, 3272733119, 'SE', 'SWE', 'السويد'),
(65308, 3272733120, 3272733135, 'DE', 'DEU', 'ألمانيا'),
(65309, 3272733136, 3272733983, 'SE', 'SWE', 'السويد'),
(65310, 3272733984, 3272733991, 'RU', 'RUS', 'الإتحاد الروسي'),
(65311, 3272733992, 3272736767, 'SE', 'SWE', 'السويد'),
(65312, 3272736768, 3272737791, 'IT', 'ITA', 'إيطاليا'),
(65313, 3272744960, 3272753151, 'RU', 'RUS', 'الإتحاد الروسي'),
(65314, 3272753152, 3272769535, 'NL', 'NLD', 'هولندا'),
(65315, 3272769536, 3272802303, 'NO', 'NOR', 'النرويج'),
(65316, 3272802304, 3272867839, 'RU', 'RUS', 'الإتحاد الروسي'),
(65317, 3272867840, 3272868863, 'PL', 'POL', 'بولندا'),
(65318, 3272868864, 3272869887, 'UA', 'UKR', 'أوكرانيا'),
(65319, 3272869888, 3272870911, 'NL', 'NLD', 'هولندا'),
(65320, 3272870912, 3272871935, 'FR', 'FRA', 'فرنسا'),
(65321, 3272871936, 3272872959, 'FI', 'FIN', 'فنلندا'),
(65322, 3272872960, 3272875007, 'BG', 'BGR', 'بلغاريا'),
(65323, 3272875008, 3272876031, 'UA', 'UKR', 'أوكرانيا'),
(65324, 3272876032, 3272884223, 'NL', 'NLD', 'هولندا'),
(65325, 3272884224, 3272892415, 'DE', 'DEU', 'ألمانيا'),
(65326, 3272892416, 3272892927, 'UA', 'UKR', 'أوكرانيا'),
(65327, 3272892928, 3272893439, 'DE', 'DEU', 'ألمانيا'),
(65328, 3272893440, 3272893951, 'SE', 'SWE', 'السويد'),
(65329, 3272893952, 3272894463, 'UA', 'UKR', 'أوكرانيا'),
(65330, 3272894464, 3272894975, 'FR', 'FRA', 'فرنسا'),
(65331, 3272894976, 3272895487, 'RO', 'ROM', 'رومانيا'),
(65332, 3272895488, 3272895999, 'GB', 'GBR', 'المملكة المتحدة'),
(65333, 3272896000, 3272896511, 'PL', 'POL', 'بولندا'),
(65334, 3272896512, 3272897535, 'DE', 'DEU', 'ألمانيا'),
(65335, 3272897536, 3272898047, 'FI', 'FIN', 'فنلندا'),
(65336, 3272898048, 3272898559, 'UA', 'UKR', 'أوكرانيا'),
(65337, 3272898560, 3272899071, 'DE', 'DEU', 'ألمانيا'),
(65338, 3272899072, 3272899583, 'GB', 'GBR', 'المملكة المتحدة'),
(65339, 3272899584, 3272900095, 'UA', 'UKR', 'أوكرانيا'),
(65340, 3272900096, 3272900607, 'LV', 'LVA', 'لاتفيا'),
(65341, 3272908800, 3272910847, 'SK', 'SVK', 'سلوفاكيا'),
(65342, 3272910848, 3272911359, 'NL', 'NLD', 'هولندا'),
(65343, 3272911360, 3272911871, 'SK', 'SVK', 'سلوفاكيا'),
(65344, 3272911872, 3272912383, 'CZ', 'CZE', 'التشيك'),
(65345, 3272912384, 3272916991, 'SK', 'SVK', 'سلوفاكيا'),
(65346, 3272916992, 3272917503, 'MC', 'MCO', 'موناكو'),
(65347, 3272917504, 3272918527, 'RU', 'RUS', 'الإتحاد الروسي'),
(65348, 3272918528, 3272919039, 'FR', 'FRA', 'فرنسا'),
(65349, 3272919040, 3272919551, 'GB', 'GBR', 'المملكة المتحدة'),
(65350, 3272919552, 3272920063, 'RO', 'ROM', 'رومانيا'),
(65351, 3272920064, 3272920575, 'NL', 'NLD', 'هولندا'),
(65352, 3272920576, 3272921087, 'SE', 'SWE', 'السويد'),
(65353, 3272921088, 3272921599, 'CH', 'CHE', 'سويسرا'),
(65354, 3272921600, 3272922111, 'DE', 'DEU', 'ألمانيا'),
(65355, 3272922112, 3272922623, 'PL', 'POL', 'بولندا'),
(65356, 3272923136, 3272923647, 'ES', 'ESP', 'إسبانيا'),
(65357, 3272923648, 3272924159, 'PL', 'POL', 'بولندا'),
(65358, 3272924160, 3272924671, 'DE', 'DEU', 'ألمانيا'),
(65359, 3272924672, 3272925183, 'GB', 'GBR', 'المملكة المتحدة'),
(65360, 3272925184, 3272933375, 'DE', 'DEU', 'ألمانيا'),
(65361, 3272933376, 3272933759, 'GB', 'GBR', 'المملكة المتحدة'),
(65362, 3272933760, 3272933775, 'DK', 'DNK', 'الدنيمارك'),
(65363, 3272933776, 3272934687, 'GB', 'GBR', 'المملكة المتحدة'),
(65364, 3272934688, 3272934703, 'DE', 'DEU', 'ألمانيا'),
(65365, 3272934704, 3272934847, 'GB', 'GBR', 'المملكة المتحدة'),
(65366, 3272934848, 3272934911, 'DE', 'DEU', 'ألمانيا'),
(65367, 3272934912, 3272935167, 'GB', 'GBR', 'المملكة المتحدة'),
(65368, 3272935168, 3272935679, 'DE', 'DEU', 'ألمانيا'),
(65369, 3272935680, 3272936447, 'GB', 'GBR', 'المملكة المتحدة'),
(65370, 3272936448, 3272936479, 'DE', 'DEU', 'ألمانيا'),
(65371, 3272936480, 3272936703, 'GB', 'GBR', 'المملكة المتحدة'),
(65372, 3272936704, 3272936719, 'DE', 'DEU', 'ألمانيا'),
(65373, 3272936720, 3272936735, 'GB', 'GBR', 'المملكة المتحدة'),
(65374, 3272936736, 3272936895, 'DE', 'DEU', 'ألمانيا'),
(65375, 3272936896, 3272936959, 'GB', 'GBR', 'المملكة المتحدة'),
(65376, 3272936960, 3272937087, 'DE', 'DEU', 'ألمانيا'),
(65377, 3272937088, 3272937471, 'GB', 'GBR', 'المملكة المتحدة'),
(65378, 3272937472, 3272937535, 'DE', 'DEU', 'ألمانيا'),
(65379, 3272937536, 3272937599, 'GB', 'GBR', 'المملكة المتحدة'),
(65380, 3272937600, 3272937631, 'DE', 'DEU', 'ألمانيا'),
(65381, 3272937632, 3272937791, 'GB', 'GBR', 'المملكة المتحدة'),
(65382, 3272937792, 3272937903, 'DE', 'DEU', 'ألمانيا'),
(65383, 3272937904, 3272937919, 'GB', 'GBR', 'المملكة المتحدة'),
(65384, 3272937920, 3272937983, 'DE', 'DEU', 'ألمانيا'),
(65385, 3272937984, 3272938015, 'GB', 'GBR', 'المملكة المتحدة'),
(65386, 3272938016, 3272938063, 'DE', 'DEU', 'ألمانيا'),
(65387, 3272938064, 3272938239, 'GB', 'GBR', 'المملكة المتحدة'),
(65388, 3272938240, 3272938271, 'DE', 'DEU', 'ألمانيا'),
(65389, 3272938272, 3272938479, 'GB', 'GBR', 'المملكة المتحدة'),
(65390, 3272938480, 3272938495, 'DE', 'DEU', 'ألمانيا'),
(65391, 3272938496, 3272939775, 'GB', 'GBR', 'المملكة المتحدة'),
(65392, 3272939776, 3272940223, 'DE', 'DEU', 'ألمانيا'),
(65393, 3272940224, 3272940287, 'GB', 'GBR', 'المملكة المتحدة'),
(65394, 3272940288, 3272940543, 'DE', 'DEU', 'ألمانيا'),
(65395, 3272940544, 3272940799, 'GB', 'GBR', 'المملكة المتحدة'),
(65396, 3272940800, 3272940831, 'DE', 'DEU', 'ألمانيا'),
(65397, 3272940832, 3272941055, 'GB', 'GBR', 'المملكة المتحدة'),
(65398, 3272941056, 3272941311, 'DE', 'DEU', 'ألمانيا'),
(65399, 3272941312, 3272943103, 'GB', 'GBR', 'المملكة المتحدة'),
(65400, 3272943104, 3272943167, 'DE', 'DEU', 'ألمانيا'),
(65401, 3272943168, 3272943359, 'GB', 'GBR', 'المملكة المتحدة'),
(65402, 3272943360, 3272943391, 'DE', 'DEU', 'ألمانيا'),
(65403, 3272943392, 3272943439, 'GB', 'GBR', 'المملكة المتحدة'),
(65404, 3272943440, 3272943455, 'DE', 'DEU', 'ألمانيا'),
(65405, 3272943456, 3272943471, 'GB', 'GBR', 'المملكة المتحدة'),
(65406, 3272943472, 3272943487, 'DE', 'DEU', 'ألمانيا'),
(65407, 3272943488, 3272943503, 'GB', 'GBR', 'المملكة المتحدة'),
(65408, 3272943504, 3272943535, 'DE', 'DEU', 'ألمانيا'),
(65409, 3272943536, 3272943551, 'GB', 'GBR', 'المملكة المتحدة'),
(65410, 3272943552, 3272943583, 'DE', 'DEU', 'ألمانيا'),
(65411, 3272943584, 3272944127, 'GB', 'GBR', 'المملكة المتحدة'),
(65412, 3272944128, 3272944191, 'DE', 'DEU', 'ألمانيا'),
(65413, 3272944192, 3272944383, 'GB', 'GBR', 'المملكة المتحدة'),
(65414, 3272944384, 3272944415, 'DE', 'DEU', 'ألمانيا'),
(65415, 3272944416, 3272944447, 'GB', 'GBR', 'المملكة المتحدة'),
(65416, 3272944448, 3272944463, 'DE', 'DEU', 'ألمانيا'),
(65417, 3272944464, 3272944575, 'GB', 'GBR', 'المملكة المتحدة'),
(65418, 3272944576, 3272944607, 'DE', 'DEU', 'ألمانيا'),
(65419, 3272944608, 3272944639, 'GB', 'GBR', 'المملكة المتحدة'),
(65420, 3272944640, 3272944959, 'DE', 'DEU', 'ألمانيا'),
(65421, 3272944960, 3272945151, 'GB', 'GBR', 'المملكة المتحدة'),
(65422, 3272945152, 3272945423, 'DE', 'DEU', 'ألمانيا'),
(65423, 3272945424, 3272945471, 'GB', 'GBR', 'المملكة المتحدة'),
(65424, 3272945472, 3272945487, 'DE', 'DEU', 'ألمانيا'),
(65425, 3272945488, 3272945503, 'GB', 'GBR', 'المملكة المتحدة'),
(65426, 3272945504, 3272945519, 'DE', 'DEU', 'ألمانيا'),
(65427, 3272945520, 3272945535, 'GB', 'GBR', 'المملكة المتحدة'),
(65428, 3272945536, 3272945551, 'DE', 'DEU', 'ألمانيا'),
(65429, 3272945552, 3272945567, 'GB', 'GBR', 'المملكة المتحدة'),
(65430, 3272945568, 3272945599, 'DE', 'DEU', 'ألمانيا'),
(65431, 3272945600, 3272945919, 'GB', 'GBR', 'المملكة المتحدة'),
(65432, 3272945920, 3272946229, 'DE', 'DEU', 'ألمانيا'),
(65433, 3272946230, 3272946271, 'GB', 'GBR', 'المملكة المتحدة'),
(65434, 3272946272, 3272946287, 'DE', 'DEU', 'ألمانيا'),
(65435, 3272946288, 3272946335, 'GB', 'GBR', 'المملكة المتحدة'),
(65436, 3272946336, 3272946351, 'DE', 'DEU', 'ألمانيا'),
(65437, 3272946352, 3272946367, 'GB', 'GBR', 'المملكة المتحدة'),
(65438, 3272946368, 3272946383, 'DE', 'DEU', 'ألمانيا'),
(65439, 3272946384, 3272946399, 'GB', 'GBR', 'المملكة المتحدة'),
(65440, 3272946400, 3272946415, 'DE', 'DEU', 'ألمانيا'),
(65441, 3272946416, 3272946687, 'GB', 'GBR', 'المملكة المتحدة'),
(65442, 3272946688, 3272946751, 'DE', 'DEU', 'ألمانيا'),
(65443, 3272946752, 3272946783, 'GB', 'GBR', 'المملكة المتحدة'),
(65444, 3272946784, 3272946831, 'DE', 'DEU', 'ألمانيا'),
(65445, 3272946832, 3272946847, 'GB', 'GBR', 'المملكة المتحدة'),
(65446, 3272946848, 3272946863, 'DE', 'DEU', 'ألمانيا'),
(65447, 3272946864, 3272947199, 'GB', 'GBR', 'المملكة المتحدة'),
(65448, 3272947200, 3272947215, 'DE', 'DEU', 'ألمانيا'),
(65449, 3272947216, 3272947231, 'GB', 'GBR', 'المملكة المتحدة'),
(65450, 3272947232, 3272947247, 'DE', 'DEU', 'ألمانيا'),
(65451, 3272947248, 3272947263, 'GB', 'GBR', 'المملكة المتحدة'),
(65452, 3272947264, 3272947279, 'DE', 'DEU', 'ألمانيا'),
(65453, 3272947280, 3272947327, 'GB', 'GBR', 'المملكة المتحدة'),
(65454, 3272947328, 3272947343, 'DE', 'DEU', 'ألمانيا'),
(65455, 3272947344, 3272962303, 'GB', 'GBR', 'المملكة المتحدة'),
(65456, 3272962304, 3272962319, 'DE', 'DEU', 'ألمانيا'),
(65457, 3272962320, 3272962559, 'GB', 'GBR', 'المملكة المتحدة'),
(65458, 3272962560, 3272962688, 'DE', 'DEU', 'ألمانيا'),
(65459, 3272962689, 3272964351, 'GB', 'GBR', 'المملكة المتحدة'),
(65460, 3272964352, 3272964607, 'DE', 'DEU', 'ألمانيا'),
(65461, 3272964608, 3272966399, 'GB', 'GBR', 'المملكة المتحدة'),
(65462, 3272966400, 3272966975, 'DE', 'DEU', 'ألمانيا'),
(65463, 3272966976, 3272967103, 'GB', 'GBR', 'المملكة المتحدة'),
(65464, 3272967104, 3272967167, 'DE', 'DEU', 'ألمانيا'),
(65465, 3272967168, 3272967423, 'GB', 'GBR', 'المملكة المتحدة'),
(65466, 3272967424, 3272968703, 'DE', 'DEU', 'ألمانيا'),
(65467, 3272968704, 3272968735, 'GB', 'GBR', 'المملكة المتحدة'),
(65468, 3272968736, 3272968879, 'DE', 'DEU', 'ألمانيا'),
(65469, 3272968880, 3272968927, 'GB', 'GBR', 'المملكة المتحدة'),
(65470, 3272968928, 3272968959, 'DE', 'DEU', 'ألمانيا'),
(65471, 3272968960, 3272969215, 'GB', 'GBR', 'المملكة المتحدة'),
(65472, 3272969216, 3272969279, 'DE', 'DEU', 'ألمانيا'),
(65473, 3272969280, 3272969727, 'GB', 'GBR', 'المملكة المتحدة'),
(65474, 3272969728, 3272969791, 'DE', 'DEU', 'ألمانيا'),
(65475, 3272969792, 3272970015, 'GB', 'GBR', 'المملكة المتحدة'),
(65476, 3272970016, 3272970079, 'DE', 'DEU', 'ألمانيا'),
(65477, 3272970080, 3272970095, 'GB', 'GBR', 'المملكة المتحدة'),
(65478, 3272970096, 3272970175, 'DE', 'DEU', 'ألمانيا'),
(65479, 3272970176, 3272971263, 'GB', 'GBR', 'المملكة المتحدة'),
(65480, 3272971264, 3272971519, 'DE', 'DEU', 'ألمانيا'),
(65481, 3272971520, 3272972031, 'GB', 'GBR', 'المملكة المتحدة'),
(65482, 3272972032, 3272972287, 'DE', 'DEU', 'ألمانيا'),
(65483, 3272972288, 3272974335, 'GB', 'GBR', 'المملكة المتحدة'),
(65484, 3272974336, 3272974367, 'DE', 'DEU', 'ألمانيا'),
(65485, 3272974368, 3272975871, 'GB', 'GBR', 'المملكة المتحدة'),
(65486, 3272975872, 3272976383, 'DE', 'DEU', 'ألمانيا'),
(65487, 3272976384, 3272976895, 'GB', 'GBR', 'المملكة المتحدة'),
(65488, 3272976896, 3272976927, 'DE', 'DEU', 'ألمانيا'),
(65489, 3272976928, 3272976959, 'GB', 'GBR', 'المملكة المتحدة'),
(65490, 3272976960, 3272976991, 'DE', 'DEU', 'ألمانيا'),
(65491, 3272976992, 3272977151, 'GB', 'GBR', 'المملكة المتحدة'),
(65492, 3272977152, 3272977407, 'DE', 'DEU', 'ألمانيا'),
(65493, 3272977408, 3272978415, 'GB', 'GBR', 'المملكة المتحدة'),
(65494, 3272978416, 3272978687, 'DE', 'DEU', 'ألمانيا'),
(65495, 3272978688, 3272979023, 'GB', 'GBR', 'المملكة المتحدة'),
(65496, 3272979024, 3272979103, 'DE', 'DEU', 'ألمانيا'),
(65497, 3272979104, 3272979119, 'GB', 'GBR', 'المملكة المتحدة'),
(65498, 3272979120, 3272979167, 'DE', 'DEU', 'ألمانيا'),
(65499, 3272979168, 3272979519, 'GB', 'GBR', 'المملكة المتحدة'),
(65500, 3272979520, 3272979535, 'DE', 'DEU', 'ألمانيا'),
(65501, 3272979536, 3272979967, 'GB', 'GBR', 'المملكة المتحدة'),
(65502, 3272979968, 3272979999, 'DE', 'DEU', 'ألمانيا'),
(65503, 3272980000, 3272980095, 'GB', 'GBR', 'المملكة المتحدة'),
(65504, 3272980096, 3272980127, 'DE', 'DEU', 'ألمانيا'),
(65505, 3272980128, 3272980479, 'GB', 'GBR', 'المملكة المتحدة'),
(65506, 3272980480, 3272980607, 'DE', 'DEU', 'ألمانيا'),
(65507, 3272980608, 3272980639, 'GB', 'GBR', 'المملكة المتحدة'),
(65508, 3272980640, 3272980767, 'DE', 'DEU', 'ألمانيا'),
(65509, 3272980768, 3272980799, 'GB', 'GBR', 'المملكة المتحدة'),
(65510, 3272980800, 3272980863, 'DE', 'DEU', 'ألمانيا'),
(65511, 3272980864, 3272980927, 'GB', 'GBR', 'المملكة المتحدة'),
(65512, 3272980928, 3272980943, 'DE', 'DEU', 'ألمانيا'),
(65513, 3272980944, 3272981119, 'GB', 'GBR', 'المملكة المتحدة'),
(65514, 3272981120, 3272981215, 'DE', 'DEU', 'ألمانيا'),
(65515, 3272981216, 3272981503, 'GB', 'GBR', 'المملكة المتحدة'),
(65516, 3272981504, 3272981759, 'DE', 'DEU', 'ألمانيا'),
(65517, 3272981760, 3272982015, 'GB', 'GBR', 'المملكة المتحدة'),
(65518, 3272982016, 3272982527, 'DE', 'DEU', 'ألمانيا'),
(65519, 3272982528, 3272982783, 'GB', 'GBR', 'المملكة المتحدة'),
(65520, 3272982784, 3272983039, 'DE', 'DEU', 'ألمانيا'),
(65521, 3272983040, 3272983295, 'GB', 'GBR', 'المملكة المتحدة'),
(65522, 3272983296, 3272983343, 'DE', 'DEU', 'ألمانيا'),
(65523, 3272983344, 3272983391, 'GB', 'GBR', 'المملكة المتحدة'),
(65524, 3272983392, 3272983423, 'DE', 'DEU', 'ألمانيا'),
(65525, 3272983424, 3272983551, 'GB', 'GBR', 'المملكة المتحدة'),
(65526, 3272983552, 3272983823, 'DE', 'DEU', 'ألمانيا'),
(65527, 3272983824, 3272984079, 'GB', 'GBR', 'المملكة المتحدة'),
(65528, 3272984080, 3272984095, 'DE', 'DEU', 'ألمانيا'),
(65529, 3272984096, 3272984191, 'GB', 'GBR', 'المملكة المتحدة'),
(65530, 3272984192, 3272984255, 'DE', 'DEU', 'ألمانيا'),
(65531, 3272984256, 3272985599, 'GB', 'GBR', 'المملكة المتحدة'),
(65532, 3272985600, 3272985615, 'DE', 'DEU', 'ألمانيا'),
(65533, 3272985616, 3272985631, 'GB', 'GBR', 'المملكة المتحدة'),
(65534, 3272985632, 3272985647, 'DE', 'DEU', 'ألمانيا'),
(65535, 3272985648, 3272985695, 'GB', 'GBR', 'المملكة المتحدة'),
(65536, 3272985696, 3272985871, 'DE', 'DEU', 'ألمانيا'),
(65537, 3272985872, 3272985887, 'GB', 'GBR', 'المملكة المتحدة'),
(65538, 3272985888, 3272985935, 'DE', 'DEU', 'ألمانيا'),
(65539, 3272985936, 3272985951, 'GB', 'GBR', 'المملكة المتحدة'),
(65540, 3272985952, 3272986047, 'DE', 'DEU', 'ألمانيا'),
(65541, 3272986048, 3272986063, 'GB', 'GBR', 'المملكة المتحدة'),
(65542, 3272986064, 3272986079, 'DE', 'DEU', 'ألمانيا'),
(65543, 3272986080, 3272986095, 'GB', 'GBR', 'المملكة المتحدة'),
(65544, 3272986096, 3272986111, 'DE', 'DEU', 'ألمانيا'),
(65545, 3272986112, 3272988415, 'GB', 'GBR', 'المملكة المتحدة'),
(65546, 3272988416, 3272988927, 'DE', 'DEU', 'ألمانيا'),
(65547, 3272988928, 3272989183, 'GB', 'GBR', 'المملكة المتحدة'),
(65548, 3272989184, 3272989199, 'DE', 'DEU', 'ألمانيا'),
(65549, 3272989200, 3272990975, 'GB', 'GBR', 'المملكة المتحدة'),
(65550, 3272990976, 3272991007, 'DE', 'DEU', 'ألمانيا'),
(65551, 3272991008, 3272994815, 'GB', 'GBR', 'المملكة المتحدة'),
(65552, 3272994816, 3272994847, 'DE', 'DEU', 'ألمانيا'),
(65553, 3272994848, 3272994927, 'GB', 'GBR', 'المملكة المتحدة'),
(65554, 3272994928, 3272995008, 'DE', 'DEU', 'ألمانيا'),
(65555, 3272995009, 3272995023, 'GB', 'GBR', 'المملكة المتحدة'),
(65556, 3272995024, 3272995055, 'DE', 'DEU', 'ألمانيا'),
(65557, 3272995056, 3272996863, 'GB', 'GBR', 'المملكة المتحدة'),
(65558, 3272996864, 3272997119, 'DE', 'DEU', 'ألمانيا'),
(65559, 3272997120, 3272998911, 'GB', 'GBR', 'المملكة المتحدة'),
(65560, 3272998912, 3273007103, 'PT', 'PRT', 'البورتوغال'),
(65561, 3273007104, 3273015295, 'CZ', 'CZE', 'التشيك'),
(65562, 3273015296, 3273023487, 'SE', 'SWE', 'السويد'),
(65563, 3273023488, 3273024511, 'PL', 'POL', 'بولندا'),
(65564, 3273024512, 3273025535, 'NL', 'NLD', 'هولندا'),
(65565, 3273025536, 3273027583, 'RU', 'RUS', 'الإتحاد الروسي'),
(65566, 3273027584, 3273028607, 'UA', 'UKR', 'أوكرانيا'),
(65567, 3273028608, 3273029631, 'PL', 'POL', 'بولندا'),
(65568, 3273029632, 3273030655, 'DK', 'DNK', 'الدنيمارك'),
(65569, 3273030656, 3273031679, 'PL', 'POL', 'بولندا'),
(65570, 3273031680, 3273032191, 'GB', 'GBR', 'المملكة المتحدة'),
(65571, 3273032192, 3273033215, 'UA', 'UKR', 'أوكرانيا'),
(65572, 3273033216, 3273033727, 'GB', 'GBR', 'المملكة المتحدة'),
(65573, 3273033728, 3273034239, 'DE', 'DEU', 'ألمانيا'),
(65574, 3273034240, 3273034751, 'BE', 'BEL', 'بلجيكا'),
(65575, 3273034752, 3273035263, 'UA', 'UKR', 'أوكرانيا'),
(65576, 3273035264, 3273035775, 'DE', 'DEU', 'ألمانيا'),
(65577, 3273035776, 3273036287, 'FR', 'FRA', 'فرنسا'),
(65578, 3273036288, 3273036799, 'BG', 'BGR', 'بلغاريا'),
(65579, 3273036800, 3273037311, 'IL', 'ISR', 'إسرائيل'),
(65580, 3273037312, 3273037823, 'GB', 'GBR', 'المملكة المتحدة'),
(65581, 3273037824, 3273038335, 'UA', 'UKR', 'أوكرانيا'),
(65582, 3273038336, 3273038847, 'GR', 'GRC', 'اليونان'),
(65583, 3273038848, 3273039871, 'GB', 'GBR', 'المملكة المتحدة'),
(65584, 3273039872, 3273048063, 'LT', 'LTU', 'ليتوانيا'),
(65585, 3273048064, 3273048319, 'IT', 'ITA', 'إيطاليا'),
(65586, 3273048320, 3273048575, 'GR', 'GRC', 'اليونان'),
(65587, 3273048576, 3273048831, 'IT', 'ITA', 'إيطاليا'),
(65588, 3273048832, 3273049087, 'US', 'USA', 'الولايات المتحدة'),
(65589, 3273049088, 3273049855, 'IT', 'ITA', 'إيطاليا'),
(65590, 3273049856, 3273050111, 'US', 'USA', 'الولايات المتحدة'),
(65591, 3273050112, 3273051647, 'IT', 'ITA', 'إيطاليا'),
(65592, 3273051648, 3273051903, 'US', 'USA', 'الولايات المتحدة'),
(65593, 3273051904, 3273052039, 'IT', 'ITA', 'إيطاليا'),
(65594, 3273052040, 3273052047, 'NL', 'NLD', 'هولندا'),
(65595, 3273052048, 3273052063, 'GR', 'GRC', 'اليونان'),
(65596, 3273052064, 3273052087, 'IT', 'ITA', 'إيطاليا'),
(65597, 3273052088, 3273052111, 'GR', 'GRC', 'اليونان'),
(65598, 3273052112, 3273052415, 'IT', 'ITA', 'إيطاليا'),
(65599, 3273052416, 3273052671, 'GB', 'GBR', 'المملكة المتحدة'),
(65600, 3273052672, 3273052927, 'FR', 'FRA', 'فرنسا'),
(65601, 3273052928, 3273053183, 'DE', 'DEU', 'ألمانيا'),
(65602, 3273053184, 3273053439, 'CH', 'CHE', 'سويسرا'),
(65603, 3273053440, 3273053695, 'NL', 'NLD', 'هولندا'),
(65604, 3273053696, 3273053951, 'BE', 'BEL', 'بلجيكا'),
(65605, 3273053952, 3273054207, 'AT', 'AUT', 'النمسا'),
(65606, 3273054208, 3273054463, 'US', 'USA', 'الولايات المتحدة'),
(65607, 3273054464, 3273054719, 'ES', 'ESP', 'إسبانيا'),
(65608, 3273054720, 3273054975, 'IT', 'ITA', 'إيطاليا'),
(65609, 3273054976, 3273055231, 'BR', 'BRA', 'البرازيل'),
(65610, 3273055232, 3273055487, 'AR', 'ARG', 'الأرجنتين'),
(65611, 3273055488, 3273055743, 'CL', 'CHL', 'تشيلي'),
(65612, 3273055744, 3273055999, 'PE', 'PER', 'بيرو'),
(65613, 3273056000, 3273056127, 'IT', 'ITA', 'إيطاليا'),
(65614, 3273056128, 3273056255, 'HK', 'HKG', 'هونغ كونغ'),
(65615, 3273056256, 3273064447, 'MD', 'MDA', 'مولدوفا'),
(65616, 3273064448, 3273129983, 'PT', 'PRT', 'البورتوغال'),
(65617, 3273129984, 3273131999, 'DK', 'DNK', 'الدنيمارك'),
(65618, 3273132000, 3273132015, 'NO', 'NOR', 'النرويج'),
(65619, 3273132016, 3273138175, 'DK', 'DNK', 'الدنيمارك'),
(65620, 3273138176, 3273146367, 'BG', 'BGR', 'بلغاريا'),
(65621, 3273146368, 3273148415, 'RU', 'RUS', 'الإتحاد الروسي'),
(65622, 3273148416, 3273150463, 'LU', 'LUX', 'لوكسيمبورغ'),
(65623, 3273152512, 3273154559, 'BG', 'BGR', 'بلغاريا'),
(65624, 3273154560, 3273162751, 'DE', 'DEU', 'ألمانيا'),
(65625, 3273162752, 3273170943, 'UA', 'UKR', 'أوكرانيا'),
(65626, 3273170944, 3273179135, 'SE', 'SWE', 'السويد'),
(65627, 3273187328, 3273187839, 'SE', 'SWE', 'السويد'),
(65628, 3273187840, 3273188351, 'DK', 'DNK', 'الدنيمارك'),
(65629, 3273188352, 3273188863, 'RU', 'RUS', 'الإتحاد الروسي'),
(65630, 3273188864, 3273189887, 'GB', 'GBR', 'المملكة المتحدة'),
(65631, 3273189888, 3273190399, 'UA', 'UKR', 'أوكرانيا'),
(65632, 3273190400, 3273191935, 'RO', 'ROM', 'رومانيا'),
(65633, 3273191936, 3273192447, 'UA', 'UKR', 'أوكرانيا'),
(65634, 3273192448, 3273192959, 'DK', 'DNK', 'الدنيمارك'),
(65635, 3273192960, 3273193471, 'FR', 'FRA', 'فرنسا'),
(65636, 3273193472, 3273193983, 'PL', 'POL', 'بولندا'),
(65637, 3273193984, 3273194495, 'GB', 'GBR', 'المملكة المتحدة'),
(65638, 3273194496, 3273195007, 'UA', 'UKR', 'أوكرانيا'),
(65639, 3273195008, 3273195519, 'RU', 'RUS', 'الإتحاد الروسي'),
(65640, 3273195520, 3273230983, 'FR', 'FRA', 'فرنسا'),
(65641, 3273230984, 3273230991, 'DE', 'DEU', 'ألمانيا'),
(65642, 3273230992, 3273240119, 'FR', 'FRA', 'فرنسا'),
(65643, 3273240120, 3273240127, 'DE', 'DEU', 'ألمانيا'),
(65644, 3273240128, 3273240223, 'FR', 'FRA', 'فرنسا'),
(65645, 3273240224, 3273240231, 'MC', 'MCO', 'موناكو'),
(65646, 3273240232, 3273261055, 'FR', 'FRA', 'فرنسا'),
(65647, 3273261056, 3273261567, 'NO', 'NOR', 'النرويج'),
(65648, 3273261568, 3273262079, 'BE', 'BEL', 'بلجيكا'),
(65649, 3273262080, 3273262591, 'LU', 'LUX', 'لوكسيمبورغ'),
(65650, 3273262592, 3273263103, 'RU', 'RUS', 'الإتحاد الروسي'),
(65651, 3273263104, 3273263615, 'FR', 'FRA', 'فرنسا'),
(65652, 3273263616, 3273264127, 'SE', 'SWE', 'السويد'),
(65653, 3273264128, 3273264639, 'PL', 'POL', 'بولندا'),
(65654, 3273264640, 3273265151, 'AT', 'AUT', 'النمسا'),
(65655, 3273265152, 3273266175, 'UA', 'UKR', 'أوكرانيا'),
(65656, 3273266176, 3273266687, 'LV', 'LVA', 'لاتفيا'),
(65657, 3273266688, 3273267711, 'PL', 'POL', 'بولندا'),
(65658, 3273267712, 3273268223, 'GB', 'GBR', 'المملكة المتحدة'),
(65659, 3273268224, 3273268735, 'SE', 'SWE', 'السويد'),
(65660, 3273268736, 3273269247, 'RU', 'RUS', 'الإتحاد الروسي'),
(65661, 3273269248, 3273276119, 'GB', 'GBR', 'المملكة المتحدة'),
(65662, 3273276120, 3273276127, 'US', 'USA', 'الولايات المتحدة'),
(65663, 3273276128, 3273277439, 'GB', 'GBR', 'المملكة المتحدة'),
(65664, 3273277440, 3273278463, 'UA', 'UKR', 'أوكرانيا'),
(65665, 3273278464, 3273279487, 'RU', 'RUS', 'الإتحاد الروسي'),
(65666, 3273279488, 3273281535, 'PL', 'POL', 'بولندا'),
(65667, 3273281536, 3273283583, 'UA', 'UKR', 'أوكرانيا'),
(65668, 3273283584, 3273284607, 'GB', 'GBR', 'المملكة المتحدة'),
(65669, 3273284608, 3273285631, 'UA', 'UKR', 'أوكرانيا'),
(65670, 3273285632, 3273293823, 'GB', 'GBR', 'المملكة المتحدة'),
(65671, 3273293824, 3273302015, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(65672, 3273302016, 3273310207, 'RU', 'RUS', 'الإتحاد الروسي'),
(65673, 3273310208, 3273318399, 'AT', 'AUT', 'النمسا'),
(65674, 3273318400, 3273326591, 'GB', 'GBR', 'المملكة المتحدة'),
(65675, 3273326592, 3273326847, 'IE', 'IRL', 'إيرلندا'),
(65676, 3273326984, 3273326987, 'DE', 'DEU', 'ألمانيا'),
(65677, 3273326992, 3273327047, 'DE', 'DEU', 'ألمانيا'),
(65678, 3273327280, 3273327287, 'DE', 'DEU', 'ألمانيا'),
(65679, 3273327360, 3273327423, 'IE', 'IRL', 'إيرلندا'),
(65680, 3273327424, 3273327487, 'GB', 'GBR', 'المملكة المتحدة'),
(65681, 3273328512, 3273328639, 'DE', 'DEU', 'ألمانيا'),
(65682, 3273328640, 3273329199, 'GB', 'GBR', 'المملكة المتحدة'),
(65683, 3273329200, 3273329215, 'DE', 'DEU', 'ألمانيا'),
(65684, 3273329216, 3273329311, 'GB', 'GBR', 'المملكة المتحدة'),
(65685, 3273329408, 3273329423, 'GB', 'GBR', 'المملكة المتحدة'),
(65686, 3273329424, 3273329439, 'DE', 'DEU', 'ألمانيا'),
(65687, 3273329440, 3273330175, 'GB', 'GBR', 'المملكة المتحدة'),
(65688, 3273330176, 3273330183, 'IR', 'IRN', 'إيران'),
(65689, 3273330184, 3273330191, 'IE', 'IRL', 'إيرلندا'),
(65690, 3273330192, 3273330199, 'GB', 'GBR', 'المملكة المتحدة'),
(65691, 3273330200, 3273330223, 'IE', 'IRL', 'إيرلندا'),
(65692, 3273330224, 3273330271, 'GB', 'GBR', 'المملكة المتحدة'),
(65693, 3273330272, 3273330295, 'IE', 'IRL', 'إيرلندا'),
(65694, 3273330296, 3273330303, 'GB', 'GBR', 'المملكة المتحدة'),
(65695, 3273330304, 3273330431, 'IE', 'IRL', 'إيرلندا'),
(65696, 3273330432, 3273331199, 'GB', 'GBR', 'المملكة المتحدة'),
(65697, 3273331712, 3273331967, 'GB', 'GBR', 'المملكة المتحدة'),
(65698, 3273331968, 3273332031, 'DE', 'DEU', 'ألمانيا'),
(65699, 3273332096, 3273332223, 'DE', 'DEU', 'ألمانيا'),
(65700, 3273332544, 3273332575, 'DE', 'DEU', 'ألمانيا'),
(65701, 3273332608, 3273332671, 'DE', 'DEU', 'ألمانيا'),
(65702, 3273333056, 3273333119, 'DE', 'DEU', 'ألمانيا'),
(65703, 3273334272, 3273334783, 'DE', 'DEU', 'ألمانيا'),
(65704, 3273335040, 3273335295, 'DE', 'DEU', 'ألمانيا'),
(65705, 3273335296, 3273335807, 'GB', 'GBR', 'المملكة المتحدة'),
(65706, 3273335936, 3273335999, 'DE', 'DEU', 'ألمانيا'),
(65707, 3273336848, 3273336863, 'DE', 'DEU', 'ألمانيا'),
(65708, 3273336864, 3273336871, 'GB', 'GBR', 'المملكة المتحدة'),
(65709, 3273336872, 3273336879, 'DE', 'DEU', 'ألمانيا'),
(65710, 3273336960, 3273337087, 'DE', 'DEU', 'ألمانيا'),
(65711, 3273337856, 3273338111, 'DE', 'DEU', 'ألمانيا'),
(65712, 3273338624, 3273338879, 'DE', 'DEU', 'ألمانيا'),
(65713, 3273339136, 3273339391, 'DE', 'DEU', 'ألمانيا'),
(65714, 3273339392, 3273339919, 'GB', 'GBR', 'المملكة المتحدة'),
(65715, 3273339920, 3273339943, 'DE', 'DEU', 'ألمانيا'),
(65716, 3273339944, 3273339955, 'GB', 'GBR', 'المملكة المتحدة'),
(65717, 3273339956, 3273339959, 'DE', 'DEU', 'ألمانيا'),
(65718, 3273339960, 3273340095, 'GB', 'GBR', 'المملكة المتحدة'),
(65719, 3273340096, 3273340111, 'GI', 'GIB', 'جبل طارق'),
(65720, 3273340112, 3273340415, 'GB', 'GBR', 'المملكة المتحدة'),
(65721, 3273340928, 3273341695, 'FR', 'FRA', 'فرنسا'),
(65722, 3273341696, 3273341951, 'DE', 'DEU', 'ألمانيا'),
(65723, 3273342464, 3273342975, 'DE', 'DEU', 'ألمانيا'),
(65724, 3273342976, 3273343999, 'GB', 'GBR', 'المملكة المتحدة'),
(65725, 3273344000, 3273344767, 'DE', 'DEU', 'ألمانيا'),
(65726, 3273345024, 3273345279, 'DE', 'DEU', 'ألمانيا'),
(65727, 3273346816, 3273347071, 'DE', 'DEU', 'ألمانيا'),
(65728, 3273347840, 3273348351, 'DE', 'DEU', 'ألمانيا'),
(65729, 3273349120, 3273349631, 'DE', 'DEU', 'ألمانيا'),
(65730, 3273350272, 3273350287, 'DE', 'DEU', 'ألمانيا'),
(65731, 3273350336, 3273350351, 'DE', 'DEU', 'ألمانيا'),
(65732, 3273351424, 3273351455, 'DE', 'DEU', 'ألمانيا'),
(65733, 3273351504, 3273351519, 'DE', 'DEU', 'ألمانيا'),
(65734, 3273351872, 3273351903, 'DE', 'DEU', 'ألمانيا'),
(65735, 3273351936, 3273352191, 'DE', 'DEU', 'ألمانيا'),
(65736, 3273352928, 3273352959, 'DE', 'DEU', 'ألمانيا'),
(65737, 3273352992, 3273353023, 'DE', 'DEU', 'ألمانيا'),
(65738, 3273355520, 3273356287, 'DE', 'DEU', 'ألمانيا'),
(65739, 3273359888, 3273359903, 'DE', 'DEU', 'ألمانيا'),
(65740, 3273360016, 3273360079, 'DE', 'DEU', 'ألمانيا'),
(65741, 3273361472, 3273361535, 'DE', 'DEU', 'ألمانيا'),
(65742, 3273361632, 3273361663, 'DE', 'DEU', 'ألمانيا'),
(65743, 3273361792, 3273361823, 'DE', 'DEU', 'ألمانيا'),
(65744, 3273361856, 3273361919, 'DE', 'DEU', 'ألمانيا'),
(65745, 3273362048, 3273362175, 'DE', 'DEU', 'ألمانيا'),
(65746, 3273362240, 3273362255, 'DE', 'DEU', 'ألمانيا'),
(65747, 3273363208, 3273363211, 'DE', 'DEU', 'ألمانيا'),
(65748, 3273363328, 3273363391, 'DE', 'DEU', 'ألمانيا'),
(65749, 3273364608, 3273364735, 'DE', 'DEU', 'ألمانيا'),
(65750, 3273364992, 3273365247, 'DE', 'DEU', 'ألمانيا'),
(65751, 3273365504, 3273365519, 'NL', 'NLD', 'هولندا'),
(65752, 3273365520, 3273365527, 'GB', 'GBR', 'المملكة المتحدة'),
(65753, 3273365528, 3273365759, 'NL', 'NLD', 'هولندا'),
(65754, 3273365760, 3273365767, 'GB', 'GBR', 'المملكة المتحدة'),
(65755, 3273365888, 3273366015, 'FR', 'FRA', 'فرنسا'),
(65756, 3273366016, 3273366527, 'DE', 'DEU', 'ألمانيا'),
(65757, 3273367296, 3273367423, 'DE', 'DEU', 'ألمانيا'),
(65758, 3273367552, 3273367567, 'DE', 'DEU', 'ألمانيا'),
(65759, 3273368064, 3273368575, 'DE', 'DEU', 'ألمانيا'),
(65760, 3273369344, 3273369855, 'DE', 'DEU', 'ألمانيا'),
(65761, 3273370624, 3273371135, 'DE', 'DEU', 'ألمانيا'),
(65762, 3273371712, 3273371743, 'DE', 'DEU', 'ألمانيا'),
(65763, 3273371760, 3273371775, 'DE', 'DEU', 'ألمانيا'),
(65764, 3273371808, 3273371823, 'DE', 'DEU', 'ألمانيا'),
(65765, 3273371872, 3273371875, 'DE', 'DEU', 'ألمانيا'),
(65766, 3273372000, 3273372055, 'DE', 'DEU', 'ألمانيا'),
(65767, 3273372144, 3273372151, 'DE', 'DEU', 'ألمانيا'),
(65768, 3273372672, 3273372927, 'GB', 'GBR', 'المملكة المتحدة'),
(65769, 3273372928, 3273373183, 'NL', 'NLD', 'هولندا'),
(65770, 3273373184, 3273373455, 'GB', 'GBR', 'المملكة المتحدة'),
(65771, 3273373456, 3273373695, 'DE', 'DEU', 'ألمانيا'),
(65772, 3273375232, 3273375551, 'DE', 'DEU', 'ألمانيا'),
(65773, 3273375744, 3273375871, 'DE', 'DEU', 'ألمانيا'),
(65774, 3273376000, 3273376255, 'DE', 'DEU', 'ألمانيا'),
(65775, 3273376536, 3273376543, 'DE', 'DEU', 'ألمانيا'),
(65776, 3273377792, 3273378095, 'DE', 'DEU', 'ألمانيا'),
(65777, 3273378560, 3273378815, 'DE', 'DEU', 'ألمانيا'),
(65778, 3273381888, 3273382143, 'DE', 'DEU', 'ألمانيا'),
(65779, 3273382144, 3273382399, 'GB', 'GBR', 'المملكة المتحدة'),
(65780, 3273382400, 3273382463, 'DE', 'DEU', 'ألمانيا'),
(65781, 3273382480, 3273382591, 'DE', 'DEU', 'ألمانيا'),
(65782, 3273382640, 3273382687, 'DE', 'DEU', 'ألمانيا'),
(65783, 3273384192, 3273384703, 'DE', 'DEU', 'ألمانيا'),
(65784, 3273384960, 3273385215, 'DE', 'DEU', 'ألمانيا'),
(65785, 3273385280, 3273385343, 'DE', 'DEU', 'ألمانيا'),
(65786, 3273385472, 3273385727, 'DE', 'DEU', 'ألمانيا'),
(65787, 3273385760, 3273385791, 'DE', 'DEU', 'ألمانيا'),
(65788, 3273385856, 3273385919, 'DE', 'DEU', 'ألمانيا'),
(65789, 3273387056, 3273387071, 'DE', 'DEU', 'ألمانيا'),
(65790, 3273387216, 3273387231, 'DE', 'DEU', 'ألمانيا'),
(65791, 3273387264, 3273387519, 'DE', 'DEU', 'ألمانيا'),
(65792, 3273387552, 3273387583, 'DE', 'DEU', 'ألمانيا'),
(65793, 3273388160, 3273388223, 'DE', 'DEU', 'ألمانيا'),
(65794, 3273388800, 3273388807, 'DE', 'DEU', 'ألمانيا'),
(65795, 3273388816, 3273388863, 'DE', 'DEU', 'ألمانيا'),
(65796, 3273388872, 3273388879, 'DE', 'DEU', 'ألمانيا'),
(65797, 3273388904, 3273388911, 'DE', 'DEU', 'ألمانيا'),
(65798, 3273388928, 3273389055, 'DE', 'DEU', 'ألمانيا'),
(65799, 3273390080, 3273390111, 'DE', 'DEU', 'ألمانيا'),
(65800, 3273390112, 3273390143, 'US', 'USA', 'الولايات المتحدة'),
(65801, 3273390144, 3273390207, 'DE', 'DEU', 'ألمانيا'),
(65802, 3273390368, 3273390463, 'DE', 'DEU', 'ألمانيا'),
(65803, 3273391296, 3273391327, 'DE', 'DEU', 'ألمانيا'),
(65804, 3273391344, 3273391359, 'DE', 'DEU', 'ألمانيا'),
(65805, 3273392128, 3273392639, 'UA', 'UKR', 'أوكرانيا'),
(65806, 3273392640, 3273393663, 'RO', 'ROM', 'رومانيا'),
(65807, 3273393664, 3273394175, 'BG', 'BGR', 'بلغاريا'),
(65808, 3273394176, 3273394687, 'RO', 'ROM', 'رومانيا'),
(65809, 3273394688, 3273395199, 'RU', 'RUS', 'الإتحاد الروسي'),
(65810, 3273395200, 3273395711, 'DE', 'DEU', 'ألمانيا'),
(65811, 3273395712, 3273396223, 'RU', 'RUS', 'الإتحاد الروسي'),
(65812, 3273396224, 3273396735, 'PL', 'POL', 'بولندا'),
(65813, 3273396736, 3273397247, 'RO', 'ROM', 'رومانيا'),
(65814, 3273397248, 3273397759, 'RU', 'RUS', 'الإتحاد الروسي'),
(65815, 3273397760, 3273398271, 'NL', 'NLD', 'هولندا'),
(65816, 3273398272, 3273398783, 'RO', 'ROM', 'رومانيا'),
(65817, 3273398784, 3273399295, 'LV', 'LVA', 'لاتفيا'),
(65818, 3273399296, 3273399807, 'SE', 'SWE', 'السويد'),
(65819, 3273399808, 3273400319, 'UA', 'UKR', 'أوكرانيا'),
(65820, 3273400320, 3273408511, 'RU', 'RUS', 'الإتحاد الروسي'),
(65821, 3273408512, 3273433087, 'SK', 'SVK', 'سلوفاكيا'),
(65822, 3273433088, 3273433599, 'LU', 'LUX', 'لوكسيمبورغ'),
(65823, 3273433600, 3273434111, 'RO', 'ROM', 'رومانيا'),
(65824, 3273434112, 3273434623, 'BE', 'BEL', 'بلجيكا'),
(65825, 3273434624, 3273435135, 'IL', 'ISR', 'إسرائيل'),
(65826, 3273435136, 3273435647, 'GB', 'GBR', 'المملكة المتحدة'),
(65827, 3273435648, 3273436159, 'PL', 'POL', 'بولندا'),
(65828, 3273436160, 3273436671, 'NO', 'NOR', 'النرويج'),
(65829, 3273436672, 3273437183, 'DE', 'DEU', 'ألمانيا'),
(65830, 3273437184, 3273437695, 'RO', 'ROM', 'رومانيا'),
(65831, 3273437696, 3273438207, 'PL', 'POL', 'بولندا'),
(65832, 3273438208, 3273438719, 'IL', 'ISR', 'إسرائيل'),
(65833, 3273438720, 3273439231, 'PL', 'POL', 'بولندا'),
(65834, 3273439232, 3273439743, 'RO', 'ROM', 'رومانيا'),
(65835, 3273439744, 3273440255, 'UA', 'UKR', 'أوكرانيا'),
(65836, 3273440256, 3273440767, 'RO', 'ROM', 'رومانيا'),
(65837, 3273440768, 3273441279, 'AT', 'AUT', 'النمسا'),
(65838, 3273441280, 3273441463, 'FR', 'FRA', 'فرنسا'),
(65839, 3273441464, 3273441535, 'GB', 'GBR', 'المملكة المتحدة'),
(65840, 3273441536, 3273441607, 'FR', 'FRA', 'فرنسا'),
(65841, 3273441608, 3273441615, 'GB', 'GBR', 'المملكة المتحدة'),
(65842, 3273441616, 3273441631, 'FR', 'FRA', 'فرنسا'),
(65843, 3273441632, 3273441647, 'GB', 'GBR', 'المملكة المتحدة'),
(65844, 3273441648, 3273441759, 'FR', 'FRA', 'فرنسا'),
(65845, 3273441760, 3273441791, 'GB', 'GBR', 'المملكة المتحدة'),
(65846, 3273441792, 3273442127, 'FR', 'FRA', 'فرنسا'),
(65847, 3273442128, 3273442143, 'GB', 'GBR', 'المملكة المتحدة'),
(65848, 3273442144, 3273442151, 'FR', 'FRA', 'فرنسا'),
(65849, 3273442152, 3273442303, 'GB', 'GBR', 'المملكة المتحدة'),
(65850, 3273442304, 3273442331, 'FR', 'FRA', 'فرنسا'),
(65851, 3273442332, 3273442335, 'GB', 'GBR', 'المملكة المتحدة'),
(65852, 3273442336, 3273442367, 'FR', 'FRA', 'فرنسا'),
(65853, 3273442368, 3273442431, 'GB', 'GBR', 'المملكة المتحدة'),
(65854, 3273442432, 3273442815, 'FR', 'FRA', 'فرنسا'),
(65855, 3273442816, 3273443071, 'GB', 'GBR', 'المملكة المتحدة'),
(65856, 3273443072, 3273443080, 'FR', 'FRA', 'فرنسا'),
(65857, 3273443081, 3273443327, 'GB', 'GBR', 'المملكة المتحدة'),
(65858, 3273443328, 3273443839, 'FR', 'FRA', 'فرنسا'),
(65859, 3273443840, 3273444095, 'GB', 'GBR', 'المملكة المتحدة'),
(65860, 3273444096, 3273444351, 'FR', 'FRA', 'فرنسا'),
(65861, 3273444352, 3273449471, 'GB', 'GBR', 'المملكة المتحدة'),
(65862, 3273449472, 3273457663, 'CH', 'CHE', 'سويسرا'),
(65863, 3273457664, 3273523199, 'HR', 'HRV', 'كرواتيا'),
(65864, 3273523200, 3273532463, 'DE', 'DEU', 'ألمانيا'),
(65865, 3273532464, 3273532471, 'US', 'USA', 'الولايات المتحدة'),
(65866, 3273532472, 3273588735, 'DE', 'DEU', 'ألمانيا'),
(65867, 3273588736, 3273687039, 'IT', 'ITA', 'إيطاليا'),
(65868, 3273687040, 3273719807, 'DE', 'DEU', 'ألمانيا'),
(65869, 3273719808, 3273720831, 'GB', 'GBR', 'المملكة المتحدة'),
(65870, 3273720832, 3273720839, 'IE', 'IRL', 'إيرلندا'),
(65871, 3273720840, 3273727071, 'GB', 'GBR', 'المملكة المتحدة'),
(65872, 3273727072, 3273727079, 'DK', 'DNK', 'الدنيمارك'),
(65873, 3273727080, 3273727087, 'FR', 'FRA', 'فرنسا'),
(65874, 3273727088, 3273727095, 'ES', 'ESP', 'إسبانيا'),
(65875, 3273727096, 3273727103, 'DE', 'DEU', 'ألمانيا'),
(65876, 3273727104, 3273727119, 'GB', 'GBR', 'المملكة المتحدة'),
(65877, 3273727120, 3273727127, 'PT', 'PRT', 'البورتوغال'),
(65878, 3273727128, 3273727135, 'FI', 'FIN', 'فنلندا'),
(65879, 3273727136, 3273727143, 'NO', 'NOR', 'النرويج'),
(65880, 3273727144, 3273727151, 'CZ', 'CZE', 'التشيك'),
(65881, 3273727152, 3273727999, 'GB', 'GBR', 'المملكة المتحدة'),
(65882, 3273728000, 3273728255, 'NL', 'NLD', 'هولندا'),
(65883, 3273728256, 3273728511, 'GB', 'GBR', 'المملكة المتحدة'),
(65884, 3273728512, 3273732095, 'NL', 'NLD', 'هولندا'),
(65885, 3273732096, 3273736191, 'GB', 'GBR', 'المملكة المتحدة'),
(65886, 3273736192, 3273743359, 'FR', 'FRA', 'فرنسا'),
(65887, 3273743360, 3273743615, 'JO', 'JOR', 'الأردن'),
(65888, 3273743616, 3273744383, 'FR', 'FRA', 'فرنسا'),
(65889, 3273744384, 3273752575, 'GB', 'GBR', 'المملكة المتحدة'),
(65890, 3273752576, 3273760767, 'NL', 'NLD', 'هولندا'),
(65891, 3273760768, 3273768959, 'DE', 'DEU', 'ألمانيا'),
(65892, 3273768960, 3273785343, 'TR', 'TUR', 'تركيا'),
(65893, 3273785344, 3273801727, 'RU', 'RUS', 'الإتحاد الروسي'),
(65894, 3273801728, 3273802239, 'DE', 'DEU', 'ألمانيا'),
(65895, 3273802240, 3273802751, 'RO', 'ROM', 'رومانيا'),
(65896, 3273802752, 3273803263, 'SA', 'SAU', 'السعودية'),
(65897, 3273803264, 3273803775, 'ES', 'ESP', 'إسبانيا'),
(65898, 3273803776, 3273804287, 'CH', 'CHE', 'سويسرا'),
(65899, 3273804288, 3273804799, 'UA', 'UKR', 'أوكرانيا'),
(65900, 3273804800, 3273805311, 'RO', 'ROM', 'رومانيا'),
(65901, 3273805312, 3273805823, 'GB', 'GBR', 'المملكة المتحدة'),
(65902, 3273805824, 3273806335, 'PL', 'POL', 'بولندا'),
(65903, 3273806336, 3273806847, 'DE', 'DEU', 'ألمانيا'),
(65904, 3273806848, 3273807359, 'SE', 'SWE', 'السويد'),
(65905, 3273807360, 3273807871, 'LB', 'LBN', 'لبنان'),
(65906, 3273807872, 3273808383, 'CH', 'CHE', 'سويسرا'),
(65907, 3273808384, 3273808895, 'UA', 'UKR', 'أوكرانيا'),
(65908, 3273808896, 3273809407, 'GB', 'GBR', 'المملكة المتحدة'),
(65909, 3273809408, 3273809919, 'UA', 'UKR', 'أوكرانيا'),
(65910, 3273809920, 3273818111, 'BG', 'BGR', 'بلغاريا'),
(65911, 3273818112, 3273826303, 'AT', 'AUT', 'النمسا'),
(65912, 3273826304, 3273831231, 'DE', 'DEU', 'ألمانيا'),
(65913, 3273831232, 3273831247, 'PL', 'POL', 'بولندا'),
(65914, 3273831248, 3273831263, 'LV', 'LVA', 'لاتفيا'),
(65915, 3273831264, 3273834495, 'DE', 'DEU', 'ألمانيا'),
(65916, 3273834496, 3273835519, 'RU', 'RUS', 'الإتحاد الروسي'),
(65917, 3273835520, 3273838591, 'UA', 'UKR', 'أوكرانيا'),
(65918, 3273838592, 3273839615, 'PL', 'POL', 'بولندا'),
(65919, 3273839616, 3273840639, 'LT', 'LTU', 'ليتوانيا'),
(65920, 3273840640, 3273841663, 'PL', 'POL', 'بولندا'),
(65921, 3273841664, 3273842687, 'AT', 'AUT', 'النمسا'),
(65922, 3273842688, 3273850879, 'RU', 'RUS', 'الإتحاد الروسي'),
(65923, 3273850880, 3273867263, 'DE', 'DEU', 'ألمانيا'),
(65924, 3273867264, 3273867519, 'BE', 'BEL', 'بلجيكا'),
(65925, 3273867520, 3273867775, 'UA', 'UKR', 'أوكرانيا'),
(65926, 3273867776, 3273868031, 'PT', 'PRT', 'البورتوغال'),
(65927, 3273868032, 3273868287, 'GB', 'GBR', 'المملكة المتحدة'),
(65928, 3273868288, 3273869311, 'RU', 'RUS', 'الإتحاد الروسي'),
(65929, 3273869312, 3273871359, 'DE', 'DEU', 'ألمانيا'),
(65930, 3273871360, 3273871615, 'PL', 'POL', 'بولندا'),
(65931, 3273871616, 3273871871, 'LU', 'LUX', 'لوكسيمبورغ'),
(65932, 3273871872, 3273872383, 'SE', 'SWE', 'السويد'),
(65933, 3273872384, 3273872639, 'BG', 'BGR', 'بلغاريا'),
(65934, 3273872640, 3273872895, 'PS', 'PSE', 'فلسطين المحتلة'),
(65935, 3273872896, 3273873151, 'SE', 'SWE', 'السويد'),
(65936, 3273873152, 3273873919, 'DE', 'DEU', 'ألمانيا'),
(65937, 3273873920, 3273874431, 'GB', 'GBR', 'المملكة المتحدة'),
(65938, 3273874432, 3273875455, 'GR', 'GRC', 'اليونان'),
(65939, 3273875456, 3273875711, 'PT', 'PRT', 'البورتوغال'),
(65940, 3273875712, 3273875967, 'SE', 'SWE', 'السويد'),
(65941, 3273875968, 3273876223, 'DE', 'DEU', 'ألمانيا'),
(65942, 3273876224, 3273876479, 'IT', 'ITA', 'إيطاليا'),
(65943, 3273876480, 3273876991, 'SE', 'SWE', 'السويد'),
(65944, 3273876992, 3273877247, 'CH', 'CHE', 'سويسرا'),
(65945, 3273877248, 3273877503, 'DE', 'DEU', 'ألمانيا'),
(65946, 3273877504, 3273877535, 'GB', 'GBR', 'المملكة المتحدة'),
(65947, 3273877536, 3273877567, 'AT', 'AUT', 'النمسا'),
(65948, 3273877568, 3273877759, 'IT', 'ITA', 'إيطاليا'),
(65949, 3273877760, 3273878015, 'GR', 'GRC', 'اليونان'),
(65950, 3273878016, 3273878271, 'FR', 'FRA', 'فرنسا'),
(65951, 3273878272, 3273878527, 'LV', 'LVA', 'لاتفيا'),
(65952, 3273878528, 3273879039, 'DE', 'DEU', 'ألمانيا'),
(65953, 3273879040, 3273879551, 'BE', 'BEL', 'بلجيكا'),
(65954, 3273879552, 3273880063, 'GB', 'GBR', 'المملكة المتحدة'),
(65955, 3273880064, 3273880575, 'LV', 'LVA', 'لاتفيا'),
(65956, 3273880576, 3273881087, 'RU', 'RUS', 'الإتحاد الروسي'),
(65957, 3273881088, 3273881343, 'RO', 'ROM', 'رومانيا'),
(65958, 3273881344, 3273881599, 'CH', 'CHE', 'سويسرا'),
(65959, 3273881600, 3273881855, 'GB', 'GBR', 'المملكة المتحدة'),
(65960, 3273881856, 3273882111, 'CH', 'CHE', 'سويسرا'),
(65961, 3273882112, 3273882367, 'SI', 'SVN', 'سلوفينيا'),
(65962, 3273882368, 3273883135, 'GB', 'GBR', 'المملكة المتحدة'),
(65963, 3273883136, 3273883391, 'GR', 'GRC', 'اليونان'),
(65964, 3273883392, 3273883647, 'DE', 'DEU', 'ألمانيا'),
(65965, 3273883648, 3273916415, 'NL', 'NLD', 'هولندا'),
(65966, 3273916416, 3273932799, 'IT', 'ITA', 'إيطاليا'),
(65967, 3273932800, 3273949183, 'DE', 'DEU', 'ألمانيا'),
(65968, 3273949184, 3273981951, 'FR', 'FRA', 'فرنسا'),
(65969, 3273981952, 3274047487, 'DE', 'DEU', 'ألمانيا'),
(65970, 3274047488, 3274049535, 'SE', 'SWE', 'السويد'),
(65971, 3274049536, 3274050559, 'DE', 'DEU', 'ألمانيا'),
(65972, 3274050560, 3274051583, 'PL', 'POL', 'بولندا'),
(65973, 3274051584, 3274052351, 'UA', 'UKR', 'أوكرانيا'),
(65974, 3274052352, 3274052607, 'GB', 'GBR', 'المملكة المتحدة'),
(65975, 3274052608, 3274052863, 'DE', 'DEU', 'ألمانيا'),
(65976, 3274052864, 3274053119, 'GB', 'GBR', 'المملكة المتحدة'),
(65977, 3274053120, 3274053375, 'KZ', 'KAZ', 'كازاخستان'),
(65978, 3274053376, 3274053631, 'RU', 'RUS', 'الإتحاد الروسي'),
(65979, 3274053632, 3274054655, 'DE', 'DEU', 'ألمانيا'),
(65980, 3274054656, 3274055167, 'GB', 'GBR', 'المملكة المتحدة'),
(65981, 3274055168, 3274055423, 'MT', 'MLT', 'مالطا'),
(65982, 3274055424, 3274055679, 'PL', 'POL', 'بولندا'),
(65983, 3274055680, 3274063871, 'RU', 'RUS', 'الإتحاد الروسي'),
(65984, 3274063872, 3274072063, 'GB', 'GBR', 'المملكة المتحدة'),
(65985, 3274072064, 3274080255, 'HU', 'HUN', 'هنغاريا'),
(65986, 3274080256, 3274088447, 'DE', 'DEU', 'ألمانيا'),
(65987, 3274088448, 3274096639, 'KG', 'KGZ', 'قيرغيزستان'),
(65988, 3274096640, 3274113023, 'NL', 'NLD', 'هولندا'),
(65989, 3274113024, 3274145791, 'CZ', 'CZE', 'التشيك'),
(65990, 3274145792, 3274162175, 'KW', 'KWT', 'الكويت'),
(65991, 3274162176, 3274162687, 'GB', 'GBR', 'المملكة المتحدة'),
(65992, 3274162688, 3274163199, 'DE', 'DEU', 'ألمانيا'),
(65993, 3274163200, 3274163711, 'UA', 'UKR', 'أوكرانيا'),
(65994, 3274163712, 3274164223, 'BG', 'BGR', 'بلغاريا'),
(65995, 3274164224, 3274164735, 'AT', 'AUT', 'النمسا'),
(65996, 3274164736, 3274165759, 'GB', 'GBR', 'المملكة المتحدة'),
(65997, 3274165760, 3274166271, 'RU', 'RUS', 'الإتحاد الروسي'),
(65998, 3274166272, 3274166783, 'AT', 'AUT', 'النمسا'),
(65999, 3274166784, 3274167295, 'UA', 'UKR', 'أوكرانيا'),
(66000, 3274167296, 3274167807, 'BG', 'BGR', 'بلغاريا'),
(66001, 3274167808, 3274168319, 'UA', 'UKR', 'أوكرانيا'),
(66002, 3274168320, 3274168831, 'PL', 'POL', 'بولندا'),
(66003, 3274169344, 3274170367, 'DE', 'DEU', 'ألمانيا'),
(66004, 3274170368, 3274170879, 'TR', 'TUR', 'تركيا'),
(66005, 3274170880, 3274171391, 'DE', 'DEU', 'ألمانيا'),
(66006, 3274171392, 3274171903, 'RU', 'RUS', 'الإتحاد الروسي'),
(66007, 3274171904, 3274172415, 'DE', 'DEU', 'ألمانيا'),
(66008, 3274172416, 3274172927, 'UA', 'UKR', 'أوكرانيا'),
(66009, 3274172928, 3274173439, 'DE', 'DEU', 'ألمانيا'),
(66010, 3274173440, 3274173951, 'GR', 'GRC', 'اليونان'),
(66011, 3274173952, 3274174463, 'DE', 'DEU', 'ألمانيا'),
(66012, 3274174464, 3274175487, 'UA', 'UKR', 'أوكرانيا'),
(66013, 3274175488, 3274175999, 'BE', 'BEL', 'بلجيكا'),
(66014, 3274176000, 3274176511, 'DE', 'DEU', 'ألمانيا'),
(66015, 3274176512, 3274177023, 'UA', 'UKR', 'أوكرانيا'),
(66016, 3274177024, 3274177535, 'FR', 'FRA', 'فرنسا'),
(66017, 3274177536, 3274178047, 'UA', 'UKR', 'أوكرانيا'),
(66018, 3274178048, 3274178559, 'NL', 'NLD', 'هولندا'),
(66019, 3274178560, 3274204063, 'GB', 'GBR', 'المملكة المتحدة'),
(66020, 3274204064, 3274204095, 'FR', 'FRA', 'فرنسا'),
(66021, 3274204096, 3274244095, 'GB', 'GBR', 'المملكة المتحدة'),
(66022, 3274244096, 3274309631, 'DK', 'DNK', 'الدنيمارك'),
(66023, 3274309632, 3274318031, 'FR', 'FRA', 'فرنسا'),
(66024, 3274318032, 3274318047, 'RU', 'RUS', 'الإتحاد الروسي'),
(66025, 3274318048, 3274326015, 'FR', 'FRA', 'فرنسا'),
(66026, 3274326016, 3274334719, 'RU', 'RUS', 'الإتحاد الروسي'),
(66027, 3274334720, 3274335231, 'PL', 'POL', 'بولندا'),
(66028, 3274335232, 3274335743, 'DE', 'DEU', 'ألمانيا'),
(66029, 3274335744, 3274336255, 'NL', 'NLD', 'هولندا'),
(66030, 3274336256, 3274336767, 'SE', 'SWE', 'السويد'),
(66031, 3274336768, 3274337279, 'AT', 'AUT', 'النمسا'),
(66032, 3274337280, 3274337791, 'DE', 'DEU', 'ألمانيا'),
(66033, 3274337792, 3274338303, 'SE', 'SWE', 'السويد'),
(66034, 3274338304, 3274338815, 'PL', 'POL', 'بولندا'),
(66035, 3274338816, 3274339327, 'DE', 'DEU', 'ألمانيا'),
(66036, 3274339328, 3274339839, 'RO', 'ROM', 'رومانيا'),
(66037, 3274340352, 3274340863, 'IE', 'IRL', 'إيرلندا'),
(66038, 3274340864, 3274341375, 'RU', 'RUS', 'الإتحاد الروسي'),
(66039, 3274341376, 3274341887, 'FR', 'FRA', 'فرنسا'),
(66040, 3274341888, 3274342399, 'UA', 'UKR', 'أوكرانيا'),
(66041, 3274342400, 3274342911, 'RO', 'ROM', 'رومانيا'),
(66042, 3274342912, 3274343423, 'UA', 'UKR', 'أوكرانيا'),
(66043, 3274343424, 3274343935, 'US', 'USA', 'الولايات المتحدة'),
(66044, 3274343936, 3274344447, 'NL', 'NLD', 'هولندا'),
(66045, 3274344448, 3274344959, 'UA', 'UKR', 'أوكرانيا'),
(66046, 3274344960, 3274345471, 'RO', 'ROM', 'رومانيا'),
(66047, 3274345472, 3274345983, 'PL', 'POL', 'بولندا'),
(66048, 3274345984, 3274346495, 'DE', 'DEU', 'ألمانيا'),
(66049, 3274346496, 3274347007, 'FR', 'FRA', 'فرنسا'),
(66050, 3274347008, 3274347519, 'RU', 'RUS', 'الإتحاد الروسي'),
(66051, 3274348032, 3274348543, 'DK', 'DNK', 'الدنيمارك'),
(66052, 3274348544, 3274349055, 'PL', 'POL', 'بولندا'),
(66053, 3274349056, 3274358783, 'RU', 'RUS', 'الإتحاد الروسي'),
(66054, 3274358784, 3274366975, 'SE', 'SWE', 'السويد'),
(66055, 3274366976, 3274368511, 'NL', 'NLD', 'هولندا'),
(66056, 3274368512, 3274368767, 'AT', 'AUT', 'النمسا'),
(66057, 3274368768, 3274369023, 'FR', 'FRA', 'فرنسا'),
(66058, 3274369024, 3274370047, 'DE', 'DEU', 'ألمانيا'),
(66059, 3274370048, 3274371071, 'GB', 'GBR', 'المملكة المتحدة'),
(66060, 3274371072, 3274373375, 'NL', 'NLD', 'هولندا'),
(66061, 3274373376, 3274373631, 'PL', 'POL', 'بولندا'),
(66062, 3274373632, 3274374143, 'FR', 'FRA', 'فرنسا'),
(66063, 3274374144, 3274375167, 'DE', 'DEU', 'ألمانيا'),
(66064, 3274375168, 3274383359, 'EG', 'EGY', 'مصر'),
(66065, 3274383360, 3274384383, 'RU', 'RUS', 'الإتحاد الروسي'),
(66066, 3274384384, 3274385407, 'SE', 'SWE', 'السويد'),
(66067, 3274385408, 3274386431, 'UA', 'UKR', 'أوكرانيا'),
(66068, 3274386432, 3274388479, 'GB', 'GBR', 'المملكة المتحدة'),
(66069, 3274388480, 3274389503, 'DE', 'DEU', 'ألمانيا'),
(66070, 3274389504, 3274390527, 'CH', 'CHE', 'سويسرا'),
(66071, 3274390528, 3274391551, 'NO', 'NOR', 'النرويج'),
(66072, 3274399744, 3274407935, 'LU', 'LUX', 'لوكسيمبورغ'),
(66073, 3274407936, 3274408191, 'ES', 'ESP', 'إسبانيا'),
(66074, 3274408192, 3274408447, 'IT', 'ITA', 'إيطاليا'),
(66075, 3274408448, 3274408703, 'NL', 'NLD', 'هولندا'),
(66076, 3274408704, 3274408959, 'SI', 'SVN', 'سلوفينيا'),
(66077, 3274408960, 3274409215, 'GR', 'GRC', 'اليونان'),
(66078, 3274409216, 3274409471, 'SI', 'SVN', 'سلوفينيا'),
(66079, 3274409472, 3274409727, 'CH', 'CHE', 'سويسرا'),
(66080, 3274409728, 3274409983, 'RU', 'RUS', 'الإتحاد الروسي'),
(66081, 3274409984, 3274410239, 'LT', 'LTU', 'ليتوانيا'),
(66082, 3274410240, 3274410495, 'SA', 'SAU', 'السعودية'),
(66083, 3274410496, 3274410751, 'NL', 'NLD', 'هولندا'),
(66084, 3274410752, 3274411007, 'AT', 'AUT', 'النمسا'),
(66085, 3274411008, 3274411263, 'CH', 'CHE', 'سويسرا'),
(66086, 3274411264, 3274411519, 'LI', 'LIE', 'ليختنشتاين'),
(66087, 3274411520, 3274412031, 'PL', 'POL', 'بولندا'),
(66088, 3274412032, 3274412287, 'RU', 'RUS', 'الإتحاد الروسي'),
(66089, 3274412288, 3274412543, 'NO', 'NOR', 'النرويج'),
(66090, 3274412544, 3274412799, 'UA', 'UKR', 'أوكرانيا'),
(66091, 3274412800, 3274413055, 'RU', 'RUS', 'الإتحاد الروسي'),
(66092, 3274413056, 3274413311, 'UA', 'UKR', 'أوكرانيا'),
(66093, 3274413312, 3274413567, 'AT', 'AUT', 'النمسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(66094, 3274413568, 3274413823, 'FR', 'FRA', 'فرنسا'),
(66095, 3274413824, 3274414079, 'SE', 'SWE', 'السويد'),
(66096, 3274414080, 3274414335, 'AT', 'AUT', 'النمسا'),
(66097, 3274414336, 3274414591, 'CH', 'CHE', 'سويسرا'),
(66098, 3274414592, 3274414847, 'NL', 'NLD', 'هولندا'),
(66099, 3274414848, 3274415103, 'IE', 'IRL', 'إيرلندا'),
(66100, 3274415104, 3274415359, 'GR', 'GRC', 'اليونان'),
(66101, 3274415360, 3274415615, 'GB', 'GBR', 'المملكة المتحدة'),
(66102, 3274415616, 3274415871, 'NL', 'NLD', 'هولندا'),
(66103, 3274415872, 3274416127, 'SI', 'SVN', 'سلوفينيا'),
(66104, 3274416128, 3274424319, 'IT', 'ITA', 'إيطاليا'),
(66105, 3274424320, 3274435711, 'SE', 'SWE', 'السويد'),
(66106, 3274435712, 3274435839, 'US', 'USA', 'الولايات المتحدة'),
(66107, 3274435840, 3274440703, 'SE', 'SWE', 'السويد'),
(66108, 3274442752, 3274443263, 'GB', 'GBR', 'المملكة المتحدة'),
(66109, 3274443520, 3274443647, 'GB', 'GBR', 'المملكة المتحدة'),
(66110, 3274443712, 3274443775, 'GB', 'GBR', 'المملكة المتحدة'),
(66111, 3274443808, 3274444031, 'GB', 'GBR', 'المملكة المتحدة'),
(66112, 3274446336, 3274447871, 'GB', 'GBR', 'المملكة المتحدة'),
(66113, 3274448384, 3274448639, 'GB', 'GBR', 'المملكة المتحدة'),
(66114, 3274448896, 3274449663, 'GB', 'GBR', 'المملكة المتحدة'),
(66115, 3274449920, 3274450231, 'GB', 'GBR', 'المملكة المتحدة'),
(66116, 3274450248, 3274450367, 'GB', 'GBR', 'المملكة المتحدة'),
(66117, 3274450376, 3274450391, 'GB', 'GBR', 'المملكة المتحدة'),
(66118, 3274450408, 3274450415, 'GB', 'GBR', 'المملكة المتحدة'),
(66119, 3274450432, 3274450591, 'GB', 'GBR', 'المملكة المتحدة'),
(66120, 3274450656, 3274450687, 'GB', 'GBR', 'المملكة المتحدة'),
(66121, 3274451200, 3274452255, 'GB', 'GBR', 'المملكة المتحدة'),
(66122, 3274452264, 3274452311, 'GB', 'GBR', 'المملكة المتحدة'),
(66123, 3274452320, 3274452335, 'GB', 'GBR', 'المملكة المتحدة'),
(66124, 3274452344, 3274452367, 'GB', 'GBR', 'المملكة المتحدة'),
(66125, 3274452384, 3274452391, 'GB', 'GBR', 'المملكة المتحدة'),
(66126, 3274452400, 3274452423, 'GB', 'GBR', 'المملكة المتحدة'),
(66127, 3274452432, 3274452439, 'GB', 'GBR', 'المملكة المتحدة'),
(66128, 3274452448, 3274452455, 'GB', 'GBR', 'المملكة المتحدة'),
(66129, 3274452464, 3274452471, 'GB', 'GBR', 'المملكة المتحدة'),
(66130, 3274452496, 3274452543, 'GB', 'GBR', 'المملكة المتحدة'),
(66131, 3274452560, 3274452575, 'GB', 'GBR', 'المملكة المتحدة'),
(66132, 3274452656, 3274452703, 'GB', 'GBR', 'المملكة المتحدة'),
(66133, 3274452736, 3274452927, 'GB', 'GBR', 'المملكة المتحدة'),
(66134, 3274452992, 3274453767, 'GB', 'GBR', 'المملكة المتحدة'),
(66135, 3274453784, 3274453791, 'GB', 'GBR', 'المملكة المتحدة'),
(66136, 3274453800, 3274453847, 'GB', 'GBR', 'المملكة المتحدة'),
(66137, 3274453864, 3274453871, 'GB', 'GBR', 'المملكة المتحدة'),
(66138, 3274453888, 3274453903, 'GB', 'GBR', 'المملكة المتحدة'),
(66139, 3274453920, 3274453935, 'GB', 'GBR', 'المملكة المتحدة'),
(66140, 3274453944, 3274453951, 'GB', 'GBR', 'المملكة المتحدة'),
(66141, 3274453960, 3274453975, 'GB', 'GBR', 'المملكة المتحدة'),
(66142, 3274453984, 3274453991, 'GB', 'GBR', 'المملكة المتحدة'),
(66143, 3274454000, 3274454271, 'GB', 'GBR', 'المملكة المتحدة'),
(66144, 3274454656, 3274455311, 'GB', 'GBR', 'المملكة المتحدة'),
(66145, 3274455328, 3274455335, 'GB', 'GBR', 'المملكة المتحدة'),
(66146, 3274455344, 3274455351, 'GB', 'GBR', 'المملكة المتحدة'),
(66147, 3274455360, 3274455375, 'GB', 'GBR', 'المملكة المتحدة'),
(66148, 3274455384, 3274455391, 'GB', 'GBR', 'المملكة المتحدة'),
(66149, 3274455400, 3274455423, 'GB', 'GBR', 'المملكة المتحدة'),
(66150, 3274455432, 3274455439, 'GB', 'GBR', 'المملكة المتحدة'),
(66151, 3274455448, 3274455503, 'GB', 'GBR', 'المملكة المتحدة'),
(66152, 3274455520, 3274455535, 'GB', 'GBR', 'المملكة المتحدة'),
(66153, 3274455744, 3274455807, 'GB', 'GBR', 'المملكة المتحدة'),
(66154, 3274455872, 3274455935, 'GB', 'GBR', 'المملكة المتحدة'),
(66155, 3274455968, 3274456359, 'GB', 'GBR', 'المملكة المتحدة'),
(66156, 3274456368, 3274456375, 'GB', 'GBR', 'المملكة المتحدة'),
(66157, 3274456384, 3274456391, 'GB', 'GBR', 'المملكة المتحدة'),
(66158, 3274456400, 3274456407, 'GB', 'GBR', 'المملكة المتحدة'),
(66159, 3274456416, 3274456447, 'GB', 'GBR', 'المملكة المتحدة'),
(66160, 3274456456, 3274456511, 'GB', 'GBR', 'المملكة المتحدة'),
(66161, 3274456528, 3274456535, 'GB', 'GBR', 'المملكة المتحدة'),
(66162, 3274456544, 3274456559, 'GB', 'GBR', 'المملكة المتحدة'),
(66163, 3274456568, 3274460223, 'GB', 'GBR', 'المملكة المتحدة'),
(66164, 3274460416, 3274462207, 'GB', 'GBR', 'المملكة المتحدة'),
(66165, 3274462464, 3274465023, 'GB', 'GBR', 'المملكة المتحدة'),
(66166, 3274465152, 3274466351, 'GB', 'GBR', 'المملكة المتحدة'),
(66167, 3274466368, 3274466399, 'GB', 'GBR', 'المملكة المتحدة'),
(66168, 3274466416, 3274466463, 'GB', 'GBR', 'المملكة المتحدة'),
(66169, 3274466560, 3274466735, 'GB', 'GBR', 'المملكة المتحدة'),
(66170, 3274466744, 3274466763, 'GB', 'GBR', 'المملكة المتحدة'),
(66171, 3274466768, 3274466783, 'GB', 'GBR', 'المملكة المتحدة'),
(66172, 3274466816, 3274467099, 'GB', 'GBR', 'المملكة المتحدة'),
(66173, 3274467104, 3274467307, 'GB', 'GBR', 'المملكة المتحدة'),
(66174, 3274467328, 3274470383, 'GB', 'GBR', 'المملكة المتحدة'),
(66175, 3274470400, 3274470535, 'GB', 'GBR', 'المملكة المتحدة'),
(66176, 3274470656, 3274471423, 'GB', 'GBR', 'المملكة المتحدة'),
(66177, 3274471536, 3274471615, 'GB', 'GBR', 'المملكة المتحدة'),
(66178, 3274471680, 3274471935, 'GB', 'GBR', 'المملكة المتحدة'),
(66179, 3274472960, 3274483711, 'GB', 'GBR', 'المملكة المتحدة'),
(66180, 3274489600, 3274489855, 'GB', 'GBR', 'المملكة المتحدة'),
(66181, 3274490176, 3274490895, 'GB', 'GBR', 'المملكة المتحدة'),
(66182, 3274490912, 3274491247, 'GB', 'GBR', 'المملكة المتحدة'),
(66183, 3274491256, 3274491295, 'GB', 'GBR', 'المملكة المتحدة'),
(66184, 3274491304, 3274491319, 'GB', 'GBR', 'المملكة المتحدة'),
(66185, 3274491328, 3274491383, 'GB', 'GBR', 'المملكة المتحدة'),
(66186, 3274491392, 3274504447, 'GB', 'GBR', 'المملكة المتحدة'),
(66187, 3274505728, 3274505791, 'GB', 'GBR', 'المملكة المتحدة'),
(66188, 3274505793, 3274505855, 'GB', 'GBR', 'المملكة المتحدة'),
(66189, 3274506240, 3274571775, 'IT', 'ITA', 'إيطاليا'),
(66190, 3274571776, 3274579967, 'GR', 'GRC', 'اليونان'),
(66191, 3274580992, 3274582015, 'NL', 'NLD', 'هولندا'),
(66192, 3274582016, 3274583039, 'PL', 'POL', 'بولندا'),
(66193, 3274583040, 3274584063, 'DE', 'DEU', 'ألمانيا'),
(66194, 3274584064, 3274585087, 'GB', 'GBR', 'المملكة المتحدة'),
(66195, 3274585088, 3274586111, 'RS', 'SRB', 'صربيا'),
(66196, 3274586112, 3274587135, 'UA', 'UKR', 'أوكرانيا'),
(66197, 3274587136, 3274588159, 'GB', 'GBR', 'المملكة المتحدة'),
(66198, 3274588160, 3274596351, 'SK', 'SVK', 'سلوفاكيا'),
(66199, 3274596352, 3274604543, 'RU', 'RUS', 'الإتحاد الروسي'),
(66200, 3274604544, 3274612735, 'TR', 'TUR', 'تركيا'),
(66201, 3274612736, 3274620927, 'RU', 'RUS', 'الإتحاد الروسي'),
(66202, 3274620928, 3274629119, 'FR', 'FRA', 'فرنسا'),
(66203, 3274629120, 3274637311, 'LU', 'LUX', 'لوكسيمبورغ'),
(66204, 3274637312, 3274670079, 'CZ', 'CZE', 'التشيك'),
(66205, 3274670080, 3274686463, 'DK', 'DNK', 'الدنيمارك'),
(66206, 3274686464, 3274686719, 'RU', 'RUS', 'الإتحاد الروسي'),
(66207, 3274686720, 3274686975, 'BG', 'BGR', 'بلغاريا'),
(66208, 3274686976, 3274687231, 'RO', 'ROM', 'رومانيا'),
(66209, 3274687232, 3274687487, 'DE', 'DEU', 'ألمانيا'),
(66210, 3274687488, 3274687743, 'RU', 'RUS', 'الإتحاد الروسي'),
(66211, 3274687744, 3274687999, 'SI', 'SVN', 'سلوفينيا'),
(66212, 3274688000, 3274688255, 'GB', 'GBR', 'المملكة المتحدة'),
(66213, 3274688256, 3274688511, 'IT', 'ITA', 'إيطاليا'),
(66214, 3274688512, 3274688767, 'PT', 'PRT', 'البورتوغال'),
(66215, 3274688768, 3274689023, 'PL', 'POL', 'بولندا'),
(66216, 3274689024, 3274689279, 'UA', 'UKR', 'أوكرانيا'),
(66217, 3274689280, 3274689535, 'PL', 'POL', 'بولندا'),
(66218, 3274689536, 3274689791, 'RU', 'RUS', 'الإتحاد الروسي'),
(66219, 3274689792, 3274690047, 'SE', 'SWE', 'السويد'),
(66220, 3274690048, 3274690303, 'ES', 'ESP', 'إسبانيا'),
(66221, 3274690304, 3274690559, 'GB', 'GBR', 'المملكة المتحدة'),
(66222, 3274690560, 3274690815, 'GR', 'GRC', 'اليونان'),
(66223, 3274690816, 3274691071, 'ES', 'ESP', 'إسبانيا'),
(66224, 3274691072, 3274691327, 'DK', 'DNK', 'الدنيمارك'),
(66225, 3274691328, 3274691583, 'SI', 'SVN', 'سلوفينيا'),
(66226, 3274691584, 3274691839, 'UA', 'UKR', 'أوكرانيا'),
(66227, 3274691840, 3274692095, 'SI', 'SVN', 'سلوفينيا'),
(66228, 3274692096, 3274692351, 'RO', 'ROM', 'رومانيا'),
(66229, 3274692352, 3274692607, 'BE', 'BEL', 'بلجيكا'),
(66230, 3274692608, 3274692863, 'DK', 'DNK', 'الدنيمارك'),
(66231, 3274692864, 3274693119, 'AT', 'AUT', 'النمسا'),
(66232, 3274693120, 3274693375, 'LT', 'LTU', 'ليتوانيا'),
(66233, 3274693376, 3274693631, 'UA', 'UKR', 'أوكرانيا'),
(66234, 3274693632, 3274693887, 'NL', 'NLD', 'هولندا'),
(66235, 3274693888, 3274694143, 'IT', 'ITA', 'إيطاليا'),
(66236, 3274694144, 3274694399, 'DK', 'DNK', 'الدنيمارك'),
(66237, 3274694400, 3274694655, 'GB', 'GBR', 'المملكة المتحدة'),
(66238, 3274694656, 3274694911, 'SI', 'SVN', 'سلوفينيا'),
(66239, 3274694912, 3274695167, 'GB', 'GBR', 'المملكة المتحدة'),
(66240, 3274695168, 3274695423, 'SI', 'SVN', 'سلوفينيا'),
(66241, 3274695424, 3274695679, 'PL', 'POL', 'بولندا'),
(66242, 3274695680, 3274695935, 'SI', 'SVN', 'سلوفينيا'),
(66243, 3274695936, 3274696191, 'DE', 'DEU', 'ألمانيا'),
(66244, 3274696192, 3274696447, 'DK', 'DNK', 'الدنيمارك'),
(66245, 3274696448, 3274696703, 'CH', 'CHE', 'سويسرا'),
(66246, 3274696704, 3274696959, 'IT', 'ITA', 'إيطاليا'),
(66247, 3274696960, 3274697215, 'GR', 'GRC', 'اليونان'),
(66248, 3274697216, 3274697471, 'SA', 'SAU', 'السعودية'),
(66249, 3274697472, 3274697727, 'CZ', 'CZE', 'التشيك'),
(66250, 3274697728, 3274697983, 'ES', 'ESP', 'إسبانيا'),
(66251, 3274697984, 3274698239, 'GB', 'GBR', 'المملكة المتحدة'),
(66252, 3274698240, 3274698495, 'SE', 'SWE', 'السويد'),
(66253, 3274698496, 3274698751, 'PL', 'POL', 'بولندا'),
(66254, 3274698752, 3274699007, 'GB', 'GBR', 'المملكة المتحدة'),
(66255, 3274699008, 3274699263, 'FR', 'FRA', 'فرنسا'),
(66256, 3274699264, 3274699519, 'RO', 'ROM', 'رومانيا'),
(66257, 3274699520, 3274700031, 'GB', 'GBR', 'المملكة المتحدة'),
(66258, 3274700032, 3274700287, 'CH', 'CHE', 'سويسرا'),
(66259, 3274700288, 3274700543, 'PL', 'POL', 'بولندا'),
(66260, 3274700544, 3274700799, 'DK', 'DNK', 'الدنيمارك'),
(66261, 3274700800, 3274701055, 'UA', 'UKR', 'أوكرانيا'),
(66262, 3274701056, 3274701311, 'DE', 'DEU', 'ألمانيا'),
(66263, 3274701312, 3274701567, 'TJ', 'TJK', 'طاجيكيستان'),
(66264, 3274701568, 3274702079, 'IT', 'ITA', 'إيطاليا'),
(66265, 3274702080, 3274702335, 'UA', 'UKR', 'أوكرانيا'),
(66266, 3274702336, 3274702591, 'SE', 'SWE', 'السويد'),
(66267, 3274702592, 3274702847, 'KZ', 'KAZ', 'كازاخستان'),
(66268, 3274702848, 3274801151, 'CH', 'CHE', 'سويسرا'),
(66269, 3274801152, 3274802175, 'UA', 'UKR', 'أوكرانيا'),
(66270, 3274802176, 3274803199, 'FR', 'FRA', 'فرنسا'),
(66271, 3274803200, 3274804223, 'DE', 'DEU', 'ألمانيا'),
(66272, 3274804224, 3274805247, 'FR', 'FRA', 'فرنسا'),
(66273, 3274805248, 3274806271, 'GB', 'GBR', 'المملكة المتحدة'),
(66274, 3274806272, 3274807295, 'UA', 'UKR', 'أوكرانيا'),
(66275, 3274807296, 3274809343, 'DE', 'DEU', 'ألمانيا'),
(66276, 3274809344, 3274810367, 'SE', 'SWE', 'السويد'),
(66277, 3274810368, 3274811391, 'UA', 'UKR', 'أوكرانيا'),
(66278, 3274811392, 3274812415, 'RU', 'RUS', 'الإتحاد الروسي'),
(66279, 3274812416, 3274813439, 'SE', 'SWE', 'السويد'),
(66280, 3274813440, 3274814463, 'ES', 'ESP', 'إسبانيا'),
(66281, 3274814464, 3274815487, 'GB', 'GBR', 'المملكة المتحدة'),
(66282, 3274815488, 3274816511, 'RU', 'RUS', 'الإتحاد الروسي'),
(66283, 3274816512, 3274817535, 'SK', 'SVK', 'سلوفاكيا'),
(66284, 3274817536, 3274819583, 'RU', 'RUS', 'الإتحاد الروسي'),
(66285, 3274819584, 3274821631, 'UA', 'UKR', 'أوكرانيا'),
(66286, 3274821632, 3274823679, 'KZ', 'KAZ', 'كازاخستان'),
(66287, 3274823680, 3274825727, 'TR', 'TUR', 'تركيا'),
(66288, 3274825728, 3274827775, 'DE', 'DEU', 'ألمانيا'),
(66289, 3274827776, 3274829823, 'RU', 'RUS', 'الإتحاد الروسي'),
(66290, 3274829824, 3274831871, 'SE', 'SWE', 'السويد'),
(66291, 3274831872, 3274833919, 'RO', 'ROM', 'رومانيا'),
(66292, 3274833920, 3274842111, 'BY', 'BLR', 'روسيا البيضاء'),
(66293, 3274842112, 3274850303, 'DK', 'DNK', 'الدنيمارك'),
(66294, 3274850304, 3274866687, 'GB', 'GBR', 'المملكة المتحدة'),
(66295, 3274866688, 3274883071, 'DE', 'DEU', 'ألمانيا'),
(66296, 3274883072, 3274891263, 'EE', 'EST', 'إستونيا'),
(66297, 3274891264, 3274899455, 'CH', 'CHE', 'سويسرا'),
(66298, 3274899456, 3274902399, 'DE', 'DEU', 'ألمانيا'),
(66299, 3274902400, 3274902423, 'AT', 'AUT', 'النمسا'),
(66300, 3274902528, 3274909695, 'DE', 'DEU', 'ألمانيا'),
(66301, 3274910208, 3274910975, 'DE', 'DEU', 'ألمانيا'),
(66302, 3274911232, 3274911743, 'DE', 'DEU', 'ألمانيا'),
(66303, 3274911744, 3274911999, 'FR', 'FRA', 'فرنسا'),
(66304, 3274912000, 3274912031, 'GB', 'GBR', 'المملكة المتحدة'),
(66305, 3274912032, 3274912063, 'DE', 'DEU', 'ألمانيا'),
(66306, 3274912064, 3274912191, 'FR', 'FRA', 'فرنسا'),
(66307, 3274912192, 3274912287, 'DE', 'DEU', 'ألمانيا'),
(66308, 3274912288, 3274912295, 'LU', 'LUX', 'لوكسيمبورغ'),
(66309, 3274912296, 3274912303, 'GB', 'GBR', 'المملكة المتحدة'),
(66310, 3274912304, 3274912447, 'FR', 'FRA', 'فرنسا'),
(66311, 3274912448, 3274912511, 'NL', 'NLD', 'هولندا'),
(66312, 3274912512, 3274912767, 'FR', 'FRA', 'فرنسا'),
(66313, 3274912768, 3274912799, 'DE', 'DEU', 'ألمانيا'),
(66314, 3274912800, 3274912831, 'IT', 'ITA', 'إيطاليا'),
(66315, 3274912832, 3274912895, 'FR', 'FRA', 'فرنسا'),
(66316, 3274912896, 3274913023, 'RO', 'ROM', 'رومانيا'),
(66317, 3274913024, 3274913279, 'FR', 'FRA', 'فرنسا'),
(66318, 3274913280, 3274914815, 'DE', 'DEU', 'ألمانيا'),
(66319, 3274915072, 3274915839, 'DE', 'DEU', 'ألمانيا'),
(66320, 3274915840, 3274916735, 'NL', 'NLD', 'هولندا'),
(66321, 3274916736, 3274916863, 'DE', 'DEU', 'ألمانيا'),
(66322, 3274916864, 3274917215, 'NL', 'NLD', 'هولندا'),
(66323, 3274917216, 3274917311, 'GB', 'GBR', 'المملكة المتحدة'),
(66324, 3274917312, 3274917327, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66325, 3274917328, 3274917335, 'CH', 'CHE', 'سويسرا'),
(66326, 3274917336, 3274917343, 'GB', 'GBR', 'المملكة المتحدة'),
(66327, 3274917344, 3274917375, 'SE', 'SWE', 'السويد'),
(66328, 3274917376, 3274917887, 'NL', 'NLD', 'هولندا'),
(66329, 3274917888, 3274918911, 'BE', 'BEL', 'بلجيكا'),
(66330, 3274918912, 3274919359, 'CH', 'CHE', 'سويسرا'),
(66331, 3274919392, 3274919423, 'CH', 'CHE', 'سويسرا'),
(66332, 3274919424, 3274919935, 'GB', 'GBR', 'المملكة المتحدة'),
(66333, 3274919936, 3274921983, 'BE', 'BEL', 'بلجيكا'),
(66334, 3274921984, 3274922847, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66335, 3274922848, 3274922863, 'BE', 'BEL', 'بلجيكا'),
(66336, 3274922864, 3274922871, 'GB', 'GBR', 'المملكة المتحدة'),
(66337, 3274922872, 3274922879, 'IT', 'ITA', 'إيطاليا'),
(66338, 3274922880, 3274922943, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66339, 3274922944, 3274923007, 'NL', 'NLD', 'هولندا'),
(66340, 3274923264, 3274924031, 'NL', 'NLD', 'هولندا'),
(66341, 3274924032, 3274928127, 'FR', 'FRA', 'فرنسا'),
(66342, 3274928128, 3274928511, 'ES', 'ESP', 'إسبانيا'),
(66343, 3274928512, 3274928575, 'RU', 'RUS', 'الإتحاد الروسي'),
(66344, 3274928576, 3274928639, 'GB', 'GBR', 'المملكة المتحدة'),
(66345, 3274928640, 3274929151, 'ES', 'ESP', 'إسبانيا'),
(66346, 3274929408, 3274929663, 'FR', 'FRA', 'فرنسا'),
(66347, 3274929664, 3274930175, 'BE', 'BEL', 'بلجيكا'),
(66348, 3274930176, 3274932223, 'IT', 'ITA', 'إيطاليا'),
(66349, 3274932224, 3274932991, 'GB', 'GBR', 'المملكة المتحدة'),
(66350, 3274932992, 3274933151, 'DE', 'DEU', 'ألمانيا'),
(66351, 3274933152, 3274933183, 'CH', 'CHE', 'سويسرا'),
(66352, 3274933184, 3274933215, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66353, 3274933216, 3274933247, 'BE', 'BEL', 'بلجيكا'),
(66354, 3274933248, 3274936063, 'GB', 'GBR', 'المملكة المتحدة'),
(66355, 3274936064, 3274936159, 'SE', 'SWE', 'السويد'),
(66356, 3274936160, 3274936175, 'GB', 'GBR', 'المملكة المتحدة'),
(66357, 3274936192, 3274936863, 'GB', 'GBR', 'المملكة المتحدة'),
(66358, 3274936864, 3274936871, 'BE', 'BEL', 'بلجيكا'),
(66359, 3274936872, 3274936879, 'CH', 'CHE', 'سويسرا'),
(66360, 3274936880, 3274936895, 'SE', 'SWE', 'السويد'),
(66361, 3274936896, 3274938367, 'GB', 'GBR', 'المملكة المتحدة'),
(66362, 3274938496, 3274938535, 'GB', 'GBR', 'المملكة المتحدة'),
(66363, 3274938536, 3274938543, 'FR', 'FRA', 'فرنسا'),
(66364, 3274938544, 3274938559, 'GB', 'GBR', 'المملكة المتحدة'),
(66365, 3274938624, 3274938879, 'GB', 'GBR', 'المملكة المتحدة'),
(66366, 3274938880, 3274939135, 'DE', 'DEU', 'ألمانيا'),
(66367, 3274939136, 3274939391, 'IT', 'ITA', 'إيطاليا'),
(66368, 3274939392, 3274940415, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66369, 3274940416, 3274941055, 'DE', 'DEU', 'ألمانيا'),
(66370, 3274941056, 3274941087, 'NL', 'NLD', 'هولندا'),
(66371, 3274941088, 3274941095, 'DE', 'DEU', 'ألمانيا'),
(66372, 3274941096, 3274941103, 'IT', 'ITA', 'إيطاليا'),
(66373, 3274941104, 3274942463, 'DE', 'DEU', 'ألمانيا'),
(66374, 3274942464, 3274944511, 'FR', 'FRA', 'فرنسا'),
(66375, 3274944512, 3274948607, 'NL', 'NLD', 'هولندا'),
(66376, 3274948608, 3274952447, 'DK', 'DNK', 'الدنيمارك'),
(66377, 3274952448, 3274952479, 'SE', 'SWE', 'السويد'),
(66378, 3274952480, 3274952511, 'FR', 'FRA', 'فرنسا'),
(66379, 3274952512, 3274952527, 'GB', 'GBR', 'المملكة المتحدة'),
(66380, 3274952528, 3274952543, 'BE', 'BEL', 'بلجيكا'),
(66381, 3274952544, 3274952575, 'GB', 'GBR', 'المملكة المتحدة'),
(66382, 3274952576, 3274952703, 'IT', 'ITA', 'إيطاليا'),
(66383, 3274952704, 3274954239, 'AT', 'AUT', 'النمسا'),
(66384, 3274954240, 3274954399, 'NL', 'NLD', 'هولندا'),
(66385, 3274954400, 3274954415, 'BE', 'BEL', 'بلجيكا'),
(66386, 3274954416, 3274954431, 'GB', 'GBR', 'المملكة المتحدة'),
(66387, 3274954432, 3274954495, 'PT', 'PRT', 'البورتوغال'),
(66388, 3274954496, 3274954623, 'AT', 'AUT', 'النمسا'),
(66389, 3274954624, 3274954751, 'NL', 'NLD', 'هولندا'),
(66390, 3274954752, 3274955007, 'SE', 'SWE', 'السويد'),
(66391, 3274955264, 3274956287, 'SE', 'SWE', 'السويد'),
(66392, 3274956288, 3274956543, 'GB', 'GBR', 'المملكة المتحدة'),
(66393, 3274956544, 3274956615, 'BE', 'BEL', 'بلجيكا'),
(66394, 3274956616, 3274956623, 'AT', 'AUT', 'النمسا'),
(66395, 3274956624, 3274956639, 'DE', 'DEU', 'ألمانيا'),
(66396, 3274956640, 3274956655, 'GB', 'GBR', 'المملكة المتحدة'),
(66397, 3274956656, 3274956671, 'FR', 'FRA', 'فرنسا'),
(66398, 3274956672, 3274956735, 'DE', 'DEU', 'ألمانيا'),
(66399, 3274956736, 3274956767, 'DK', 'DNK', 'الدنيمارك'),
(66400, 3274956768, 3274956799, 'SE', 'SWE', 'السويد'),
(66401, 3274956800, 3274957055, 'CH', 'CHE', 'سويسرا'),
(66402, 3274957056, 3274957567, 'AT', 'AUT', 'النمسا'),
(66403, 3274957568, 3274957823, 'CH', 'CHE', 'سويسرا'),
(66404, 3274957824, 3274957831, 'GR', 'GRC', 'اليونان'),
(66405, 3274957952, 3274957959, 'BE', 'BEL', 'بلجيكا'),
(66406, 3274957968, 3274957983, 'FR', 'FRA', 'فرنسا'),
(66407, 3274957984, 3274957999, 'BE', 'BEL', 'بلجيكا'),
(66408, 3274958000, 3274958007, 'GB', 'GBR', 'المملكة المتحدة'),
(66409, 3274958008, 3274958015, 'BE', 'BEL', 'بلجيكا'),
(66410, 3274958080, 3274958279, 'IE', 'IRL', 'إيرلندا'),
(66411, 3274958288, 3274958335, 'IE', 'IRL', 'إيرلندا'),
(66412, 3274958336, 3274959231, 'AT', 'AUT', 'النمسا'),
(66413, 3274959232, 3274959247, 'IT', 'ITA', 'إيطاليا'),
(66414, 3274959248, 3274959255, 'GB', 'GBR', 'المملكة المتحدة'),
(66415, 3274959256, 3274959263, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66416, 3274959272, 3274959279, 'GB', 'GBR', 'المملكة المتحدة'),
(66417, 3274959280, 3274959287, 'DE', 'DEU', 'ألمانيا'),
(66418, 3274959288, 3274959295, 'GB', 'GBR', 'المملكة المتحدة'),
(66419, 3274959296, 3274959327, 'ES', 'ESP', 'إسبانيا'),
(66420, 3274959328, 3274959615, 'DE', 'DEU', 'ألمانيا'),
(66421, 3274960384, 3274960447, 'BE', 'BEL', 'بلجيكا'),
(66422, 3274960448, 3274960511, 'ES', 'ESP', 'إسبانيا'),
(66423, 3274960512, 3274960575, 'GB', 'GBR', 'المملكة المتحدة'),
(66424, 3274960576, 3274960639, 'IT', 'ITA', 'إيطاليا'),
(66425, 3274960640, 3274961407, 'AT', 'AUT', 'النمسا'),
(66426, 3274961408, 3274961503, 'CH', 'CHE', 'سويسرا'),
(66427, 3274961504, 3274961535, 'DK', 'DNK', 'الدنيمارك'),
(66428, 3274961536, 3274961559, 'CH', 'CHE', 'سويسرا'),
(66429, 3274961568, 3274961663, 'CH', 'CHE', 'سويسرا'),
(66430, 3274961664, 3274961727, 'BY', 'BLR', 'روسيا البيضاء'),
(66431, 3274961920, 3274962111, 'AT', 'AUT', 'النمسا'),
(66432, 3274962112, 3274962175, 'GB', 'GBR', 'المملكة المتحدة'),
(66433, 3274962176, 3274962431, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(66434, 3274962432, 3274962687, 'BE', 'BEL', 'بلجيكا'),
(66435, 3274962688, 3274962879, 'GR', 'GRC', 'اليونان'),
(66436, 3274962880, 3274963167, 'GB', 'GBR', 'المملكة المتحدة'),
(66437, 3274963168, 3274963183, 'IE', 'IRL', 'إيرلندا'),
(66438, 3274963184, 3274963191, 'GB', 'GBR', 'المملكة المتحدة'),
(66439, 3274963192, 3274963199, 'NL', 'NLD', 'هولندا'),
(66440, 3274963200, 3274963455, 'DE', 'DEU', 'ألمانيا'),
(66441, 3274963456, 3274963711, 'CH', 'CHE', 'سويسرا'),
(66442, 3274963712, 3274963743, 'DE', 'DEU', 'ألمانيا'),
(66443, 3274963744, 3274963775, 'FR', 'FRA', 'فرنسا'),
(66444, 3274963776, 3274963783, 'GB', 'GBR', 'المملكة المتحدة'),
(66445, 3274963784, 3274963791, 'BE', 'BEL', 'بلجيكا'),
(66446, 3274963792, 3274963807, 'NL', 'NLD', 'هولندا'),
(66447, 3274963808, 3274963839, 'IT', 'ITA', 'إيطاليا'),
(66448, 3274963840, 3274963967, 'DE', 'DEU', 'ألمانيا'),
(66449, 3274963968, 3274964223, 'FR', 'FRA', 'فرنسا'),
(66450, 3274964224, 3274964735, 'BE', 'BEL', 'بلجيكا'),
(66451, 3274964736, 3274964863, 'GB', 'GBR', 'المملكة المتحدة'),
(66452, 3274964864, 3274964879, 'HU', 'HUN', 'هنغاريا'),
(66453, 3274964880, 3274964895, 'FR', 'FRA', 'فرنسا'),
(66454, 3274964896, 3274964927, 'NL', 'NLD', 'هولندا'),
(66455, 3274964928, 3274964991, 'GB', 'GBR', 'المملكة المتحدة'),
(66456, 3274964992, 3275030527, 'DE', 'DEU', 'ألمانيا'),
(66457, 3275030528, 3275096063, 'ES', 'ESP', 'إسبانيا'),
(66458, 3275096064, 3275104255, 'RU', 'RUS', 'الإتحاد الروسي'),
(66459, 3275112448, 3275120639, 'DK', 'DNK', 'الدنيمارك'),
(66460, 3275120640, 3275136639, 'SE', 'SWE', 'السويد'),
(66461, 3275136640, 3275136767, 'DK', 'DNK', 'الدنيمارك'),
(66462, 3275136768, 3275137023, 'SE', 'SWE', 'السويد'),
(66463, 3275145216, 3275153407, 'RU', 'RUS', 'الإتحاد الروسي'),
(66464, 3275153408, 3275161599, 'GB', 'GBR', 'المملكة المتحدة'),
(66465, 3275161600, 3275227135, 'ES', 'ESP', 'إسبانيا'),
(66466, 3275227136, 3275292671, 'HU', 'HUN', 'هنغاريا'),
(66467, 3275292672, 3275358207, 'ES', 'ESP', 'إسبانيا'),
(66468, 3275358208, 3275371775, 'RU', 'RUS', 'الإتحاد الروسي'),
(66469, 3275371776, 3275372031, 'TJ', 'TJK', 'طاجيكيستان'),
(66470, 3275372032, 3275374591, 'RU', 'RUS', 'الإتحاد الروسي'),
(66471, 3275374592, 3275382783, 'GB', 'GBR', 'المملكة المتحدة'),
(66472, 3275382784, 3275390975, 'SE', 'SWE', 'السويد'),
(66473, 3275390976, 3275399167, 'GB', 'GBR', 'المملكة المتحدة'),
(66474, 3275399168, 3275407359, 'AT', 'AUT', 'النمسا'),
(66475, 3275407360, 3275415551, 'GB', 'GBR', 'المملكة المتحدة'),
(66476, 3275415552, 3275423743, 'UA', 'UKR', 'أوكرانيا'),
(66477, 3275423744, 3275423751, 'GB', 'GBR', 'المملكة المتحدة'),
(66478, 3275423776, 3275423807, 'GB', 'GBR', 'المملكة المتحدة'),
(66479, 3275424000, 3275424255, 'GB', 'GBR', 'المملكة المتحدة'),
(66480, 3275425792, 3275426575, 'GB', 'GBR', 'المملكة المتحدة'),
(66481, 3275426816, 3275427071, 'GB', 'GBR', 'المملكة المتحدة'),
(66482, 3275427840, 3275428367, 'GB', 'GBR', 'المملكة المتحدة'),
(66483, 3275429888, 3275430143, 'GB', 'GBR', 'المملكة المتحدة'),
(66484, 3275430272, 3275430399, 'GB', 'GBR', 'المملكة المتحدة'),
(66485, 3275430592, 3275430623, 'GB', 'GBR', 'المملكة المتحدة'),
(66486, 3275431936, 3275432447, 'GB', 'GBR', 'المملكة المتحدة'),
(66487, 3275433984, 3275437567, 'GB', 'GBR', 'المملكة المتحدة'),
(66488, 3275438080, 3275438607, 'GB', 'GBR', 'المملكة المتحدة'),
(66489, 3275440128, 3275440639, 'GB', 'GBR', 'المملكة المتحدة'),
(66490, 3275442176, 3275442719, 'GB', 'GBR', 'المملكة المتحدة'),
(66491, 3275444224, 3275444735, 'GB', 'GBR', 'المملكة المتحدة'),
(66492, 3275446272, 3275446815, 'GB', 'GBR', 'المملكة المتحدة'),
(66493, 3275446848, 3275446911, 'GB', 'GBR', 'المملكة المتحدة'),
(66494, 3275448320, 3275449519, 'GB', 'GBR', 'المملكة المتحدة'),
(66495, 3275449520, 3275449527, 'FR', 'FRA', 'فرنسا'),
(66496, 3275449528, 3275450879, 'GB', 'GBR', 'المملكة المتحدة'),
(66497, 3275451232, 3275451263, 'GB', 'GBR', 'المملكة المتحدة'),
(66498, 3275452416, 3275453695, 'GB', 'GBR', 'المملكة المتحدة'),
(66499, 3275454464, 3275455255, 'GB', 'GBR', 'المملكة المتحدة'),
(66500, 3275455264, 3275455279, 'GB', 'GBR', 'المملكة المتحدة'),
(66501, 3275455296, 3275455327, 'GB', 'GBR', 'المملكة المتحدة'),
(66502, 3275455360, 3275455999, 'GB', 'GBR', 'المملكة المتحدة'),
(66503, 3275456512, 3275457023, 'GB', 'GBR', 'المملكة المتحدة'),
(66504, 3275457024, 3275457791, 'FK', 'FLK', 'جزر فوكلاند (مالفيناس)'),
(66505, 3275457792, 3275458559, 'GB', 'GBR', 'المملكة المتحدة'),
(66506, 3275458560, 3275460095, 'IE', 'IRL', 'إيرلندا'),
(66507, 3275460608, 3275460863, 'HK', 'HKG', 'هونغ كونغ'),
(66508, 3275460864, 3275463391, 'GB', 'GBR', 'المملكة المتحدة'),
(66509, 3275463680, 3275464031, 'GB', 'GBR', 'المملكة المتحدة'),
(66510, 3275464032, 3275464047, 'IE', 'IRL', 'إيرلندا'),
(66511, 3275464048, 3275468655, 'GB', 'GBR', 'المملكة المتحدة'),
(66512, 3275468656, 3275468671, 'IE', 'IRL', 'إيرلندا'),
(66513, 3275468672, 3275468735, 'GB', 'GBR', 'المملكة المتحدة'),
(66514, 3275468736, 3275468751, 'IE', 'IRL', 'إيرلندا'),
(66515, 3275468752, 3275468767, 'GB', 'GBR', 'المملكة المتحدة'),
(66516, 3275468768, 3275468799, 'IE', 'IRL', 'إيرلندا'),
(66517, 3275468800, 3275469071, 'GB', 'GBR', 'المملكة المتحدة'),
(66518, 3275469072, 3275469087, 'IE', 'IRL', 'إيرلندا'),
(66519, 3275469088, 3275469639, 'GB', 'GBR', 'المملكة المتحدة'),
(66520, 3275469952, 3275469983, 'GB', 'GBR', 'المملكة المتحدة'),
(66521, 3275489280, 3275497471, 'GB', 'GBR', 'المملكة المتحدة'),
(66522, 3275497472, 3275505663, 'DE', 'DEU', 'ألمانيا'),
(66523, 3275505664, 3275506175, 'PL', 'POL', 'بولندا'),
(66524, 3275506176, 3275506687, 'UA', 'UKR', 'أوكرانيا'),
(66525, 3275506688, 3275507199, 'SE', 'SWE', 'السويد'),
(66526, 3275507200, 3275507711, 'UA', 'UKR', 'أوكرانيا'),
(66527, 3275507712, 3275509759, 'RO', 'ROM', 'رومانيا'),
(66528, 3275509760, 3275509855, 'IT', 'ITA', 'إيطاليا'),
(66529, 3275509856, 3275509887, 'PL', 'POL', 'بولندا'),
(66530, 3275509888, 3275509919, 'AM', 'ARM', 'أرمينيا'),
(66531, 3275509920, 3275509951, 'PL', 'POL', 'بولندا'),
(66532, 3275509952, 3275509983, 'GB', 'GBR', 'المملكة المتحدة'),
(66533, 3275509984, 3275510015, 'PT', 'PRT', 'البورتوغال'),
(66534, 3275510016, 3275510079, 'SE', 'SWE', 'السويد'),
(66535, 3275510080, 3275510143, 'ES', 'ESP', 'إسبانيا'),
(66536, 3275510208, 3275510271, 'FR', 'FRA', 'فرنسا'),
(66537, 3275510272, 3275510335, 'LV', 'LVA', 'لاتفيا'),
(66538, 3275510336, 3275510399, 'IE', 'IRL', 'إيرلندا'),
(66539, 3275510400, 3275510463, 'NL', 'NLD', 'هولندا'),
(66540, 3275510464, 3275510527, 'GB', 'GBR', 'المملكة المتحدة'),
(66541, 3275510528, 3275510559, 'PL', 'POL', 'بولندا'),
(66542, 3275510560, 3275510591, 'DE', 'DEU', 'ألمانيا'),
(66543, 3275510784, 3275510911, 'RU', 'RUS', 'الإتحاد الروسي'),
(66544, 3275510912, 3275511167, 'GB', 'GBR', 'المملكة المتحدة'),
(66545, 3275511168, 3275511295, 'LV', 'LVA', 'لاتفيا'),
(66546, 3275511296, 3275511551, 'GB', 'GBR', 'المملكة المتحدة'),
(66547, 3275511552, 3275511679, 'NL', 'NLD', 'هولندا'),
(66548, 3275511680, 3275511807, 'GB', 'GBR', 'المملكة المتحدة'),
(66549, 3275511808, 3275511935, 'CH', 'CHE', 'سويسرا'),
(66550, 3275511936, 3275512063, 'IT', 'ITA', 'إيطاليا'),
(66551, 3275512064, 3275512191, 'CZ', 'CZE', 'التشيك'),
(66552, 3275512192, 3275512319, 'IT', 'ITA', 'إيطاليا'),
(66553, 3275512320, 3275512447, 'FI', 'FIN', 'فنلندا'),
(66554, 3275512448, 3275512575, 'DK', 'DNK', 'الدنيمارك'),
(66555, 3275512576, 3275512703, 'BE', 'BEL', 'بلجيكا'),
(66556, 3275512704, 3275512831, 'PL', 'POL', 'بولندا'),
(66557, 3275512832, 3275512895, 'SE', 'SWE', 'السويد'),
(66558, 3275512896, 3275512959, 'AT', 'AUT', 'النمسا'),
(66559, 3275512960, 3275513023, 'PL', 'POL', 'بولندا'),
(66560, 3275513024, 3275513151, 'UA', 'UKR', 'أوكرانيا'),
(66561, 3275513152, 3275513215, 'ES', 'ESP', 'إسبانيا'),
(66562, 3275513216, 3275513279, 'CH', 'CHE', 'سويسرا'),
(66563, 3275513280, 3275513343, 'DK', 'DNK', 'الدنيمارك'),
(66564, 3275513344, 3275513471, 'PL', 'POL', 'بولندا'),
(66565, 3275513472, 3275513599, 'FR', 'FRA', 'فرنسا'),
(66566, 3275513600, 3275513727, 'PL', 'POL', 'بولندا'),
(66567, 3275513728, 3275513855, 'GB', 'GBR', 'المملكة المتحدة'),
(66568, 3275513856, 3275514615, 'DE', 'DEU', 'ألمانيا'),
(66569, 3275514616, 3275514623, 'CH', 'CHE', 'سويسرا'),
(66570, 3275514624, 3275522047, 'DE', 'DEU', 'ألمانيا'),
(66571, 3275522048, 3275530239, 'IT', 'ITA', 'إيطاليا'),
(66572, 3275530240, 3275530751, 'DK', 'DNK', 'الدنيمارك'),
(66573, 3275530752, 3275531263, 'AT', 'AUT', 'النمسا'),
(66574, 3275531264, 3275531775, 'GB', 'GBR', 'المملكة المتحدة'),
(66575, 3275531776, 3275532287, 'IE', 'IRL', 'إيرلندا'),
(66576, 3275532288, 3275532799, 'FR', 'FRA', 'فرنسا'),
(66577, 3275532800, 3275533823, 'GB', 'GBR', 'المملكة المتحدة'),
(66578, 3275533824, 3275534335, 'UA', 'UKR', 'أوكرانيا'),
(66579, 3275534336, 3275534847, 'IL', 'ISR', 'إسرائيل'),
(66580, 3275534848, 3275535359, 'RO', 'ROM', 'رومانيا'),
(66581, 3275535360, 3275535871, 'DE', 'DEU', 'ألمانيا'),
(66582, 3275535872, 3275536383, 'SE', 'SWE', 'السويد'),
(66583, 3275536384, 3275536895, 'UA', 'UKR', 'أوكرانيا'),
(66584, 3275536896, 3275537407, 'DE', 'DEU', 'ألمانيا'),
(66585, 3275537408, 3275537919, 'FR', 'FRA', 'فرنسا'),
(66586, 3275537920, 3275538431, 'IT', 'ITA', 'إيطاليا'),
(66587, 3275538432, 3275539455, 'CH', 'CHE', 'سويسرا'),
(66588, 3275539456, 3275540479, 'GB', 'GBR', 'المملكة المتحدة'),
(66589, 3275540480, 3275542527, 'UA', 'UKR', 'أوكرانيا'),
(66590, 3275542528, 3275543551, 'DE', 'DEU', 'ألمانيا'),
(66591, 3275543552, 3275544575, 'NL', 'NLD', 'هولندا'),
(66592, 3275544576, 3275545599, 'PL', 'POL', 'بولندا'),
(66593, 3275546624, 3275547647, 'UA', 'UKR', 'أوكرانيا'),
(66594, 3275547648, 3275548671, 'RU', 'RUS', 'الإتحاد الروسي'),
(66595, 3275548672, 3275549695, 'IL', 'ISR', 'إسرائيل'),
(66596, 3275549696, 3275550719, 'SY', 'SYR', 'سوريا'),
(66597, 3275550720, 3275551743, 'PL', 'POL', 'بولندا'),
(66598, 3275551744, 3275552767, 'RU', 'RUS', 'الإتحاد الروسي'),
(66599, 3275552768, 3275553791, 'LV', 'LVA', 'لاتفيا'),
(66600, 3275553792, 3275554815, 'FI', 'FIN', 'فنلندا'),
(66601, 3275555392, 3275555455, 'ES', 'ESP', 'إسبانيا'),
(66602, 3275555592, 3275555647, 'ES', 'ESP', 'إسبانيا'),
(66603, 3275555744, 3275555759, 'ES', 'ESP', 'إسبانيا'),
(66604, 3275555768, 3275555776, 'ES', 'ESP', 'إسبانيا'),
(66605, 3275556608, 3275556863, 'ES', 'ESP', 'إسبانيا'),
(66606, 3275560960, 3275561215, 'ES', 'ESP', 'إسبانيا'),
(66607, 3275561472, 3275561727, 'ES', 'ESP', 'إسبانيا'),
(66608, 3275562496, 3275562751, 'ES', 'ESP', 'إسبانيا'),
(66609, 3275563008, 3275563519, 'CH', 'CHE', 'سويسرا'),
(66610, 3275563584, 3275563647, 'CH', 'CHE', 'سويسرا'),
(66611, 3275563648, 3275563775, 'DE', 'DEU', 'ألمانيا'),
(66612, 3275563776, 3275564287, 'CH', 'CHE', 'سويسرا'),
(66613, 3275564416, 3275564495, 'CH', 'CHE', 'سويسرا'),
(66614, 3275564800, 3275565055, 'CH', 'CHE', 'سويسرا'),
(66615, 3275565312, 3275565567, 'CH', 'CHE', 'سويسرا'),
(66616, 3275565824, 3275567487, 'CH', 'CHE', 'سويسرا'),
(66617, 3275567616, 3275568127, 'CH', 'CHE', 'سويسرا'),
(66618, 3275568384, 3275569407, 'CH', 'CHE', 'سويسرا'),
(66619, 3275569920, 3275570687, 'CH', 'CHE', 'سويسرا'),
(66620, 3275571200, 3275571455, 'PT', 'PRT', 'البورتوغال'),
(66621, 3275571968, 3275572095, 'PT', 'PRT', 'البورتوغال'),
(66622, 3275572768, 3275572863, 'PT', 'PRT', 'البورتوغال'),
(66623, 3275572992, 3275573055, 'PT', 'PRT', 'البورتوغال'),
(66624, 3275573120, 3275574015, 'PT', 'PRT', 'البورتوغال'),
(66625, 3275574032, 3275574047, 'PT', 'PRT', 'البورتوغال'),
(66626, 3275574144, 3275574147, 'PT', 'PRT', 'البورتوغال'),
(66627, 3275574152, 3275574159, 'PT', 'PRT', 'البورتوغال'),
(66628, 3275574176, 3275574191, 'PT', 'PRT', 'البورتوغال'),
(66629, 3275574784, 3275575231, 'PT', 'PRT', 'البورتوغال'),
(66630, 3275575424, 3275575727, 'PT', 'PRT', 'البورتوغال'),
(66631, 3275575808, 3275575935, 'PT', 'PRT', 'البورتوغال'),
(66632, 3275576064, 3275577407, 'PT', 'PRT', 'البورتوغال'),
(66633, 3275577472, 3275577495, 'PT', 'PRT', 'البورتوغال'),
(66634, 3275577520, 3275577567, 'PT', 'PRT', 'البورتوغال'),
(66635, 3275577600, 3275577727, 'PT', 'PRT', 'البورتوغال'),
(66636, 3275577792, 3275577807, 'PT', 'PRT', 'البورتوغال'),
(66637, 3275577840, 3275578623, 'PT', 'PRT', 'البورتوغال'),
(66638, 3275578880, 3275579007, 'PT', 'PRT', 'البورتوغال'),
(66639, 3275579136, 3275579391, 'PT', 'PRT', 'البورتوغال'),
(66640, 3275579392, 3275579519, 'FR', 'FRA', 'فرنسا'),
(66641, 3275579520, 3275579583, 'NL', 'NLD', 'هولندا'),
(66642, 3275579600, 3275579615, 'NL', 'NLD', 'هولندا'),
(66643, 3275579648, 3275579703, 'NL', 'NLD', 'هولندا'),
(66644, 3275579904, 3275580159, 'NL', 'NLD', 'هولندا'),
(66645, 3275580928, 3275581311, 'NL', 'NLD', 'هولندا'),
(66646, 3275581536, 3275581671, 'NL', 'NLD', 'هولندا'),
(66647, 3275581680, 3275581695, 'NL', 'NLD', 'هولندا'),
(66648, 3275582224, 3275582247, 'NL', 'NLD', 'هولندا'),
(66649, 3275582256, 3275582287, 'NL', 'NLD', 'هولندا'),
(66650, 3275582656, 3275582719, 'NL', 'NLD', 'هولندا'),
(66651, 3275582976, 3275583231, 'NL', 'NLD', 'هولندا'),
(66652, 3275584256, 3275584287, 'NL', 'NLD', 'هولندا'),
(66653, 3275584512, 3275584527, 'NL', 'NLD', 'هولندا'),
(66654, 3275585024, 3275585279, 'NL', 'NLD', 'هولندا'),
(66655, 3275587072, 3275587136, 'NL', 'NLD', 'هولندا'),
(66656, 3275587584, 3275587855, 'BE', 'BEL', 'بلجيكا'),
(66657, 3275588096, 3275588287, 'BE', 'BEL', 'بلجيكا'),
(66658, 3275588288, 3275588319, 'NL', 'NLD', 'هولندا'),
(66659, 3275588352, 3275588607, 'BE', 'BEL', 'بلجيكا'),
(66660, 3275588640, 3275588655, 'BE', 'BEL', 'بلجيكا'),
(66661, 3275588712, 3275588719, 'CH', 'CHE', 'سويسرا'),
(66662, 3275588736, 3275588799, 'BE', 'BEL', 'بلجيكا'),
(66663, 3275588848, 3275588855, 'BE', 'BEL', 'بلجيكا'),
(66664, 3275588864, 3275589119, 'IT', 'ITA', 'إيطاليا'),
(66665, 3275589272, 3275589279, 'BE', 'BEL', 'بلجيكا'),
(66666, 3275589376, 3275589471, 'BE', 'BEL', 'بلجيكا'),
(66667, 3275589888, 3275591167, 'BE', 'BEL', 'بلجيكا'),
(66668, 3275591424, 3275591679, 'BE', 'BEL', 'بلجيكا'),
(66669, 3275591680, 3275592063, 'RO', 'ROM', 'رومانيا'),
(66670, 3275592192, 3275592959, 'RO', 'ROM', 'رومانيا'),
(66671, 3275592960, 3275593215, 'MD', 'MDA', 'مولدوفا'),
(66672, 3275593344, 3275593855, 'RO', 'ROM', 'رومانيا'),
(66673, 3275593984, 3275595007, 'RO', 'ROM', 'رومانيا'),
(66674, 3275595008, 3275595039, 'BE', 'BEL', 'بلجيكا'),
(66675, 3275595264, 3275595519, 'US', 'USA', 'الولايات المتحدة'),
(66676, 3275596168, 3275596175, 'AT', 'AUT', 'النمسا'),
(66677, 3275599104, 3275599231, 'AT', 'AUT', 'النمسا'),
(66678, 3275599872, 3275600127, 'AT', 'AUT', 'النمسا'),
(66679, 3275603968, 3275604735, 'IT', 'ITA', 'إيطاليا'),
(66680, 3275604736, 3275604767, 'IL', 'ISR', 'إسرائيل'),
(66681, 3275604992, 3275606271, 'IT', 'ITA', 'إيطاليا'),
(66682, 3275606528, 3275606783, 'IT', 'ITA', 'إيطاليا'),
(66683, 3275608832, 3275610063, 'IT', 'ITA', 'إيطاليا'),
(66684, 3275610112, 3275610623, 'IT', 'ITA', 'إيطاليا'),
(66685, 3275612160, 3275612287, 'LU', 'LUX', 'لوكسيمبورغ'),
(66686, 3275612416, 3275612671, 'LU', 'LUX', 'لوكسيمبورغ'),
(66687, 3275612672, 3275612927, 'BE', 'BEL', 'بلجيكا'),
(66688, 3275612928, 3275613951, 'LU', 'LUX', 'لوكسيمبورغ'),
(66689, 3275620352, 3275622399, 'RU', 'RUS', 'الإتحاد الروسي'),
(66690, 3275622400, 3275623423, 'GB', 'GBR', 'المملكة المتحدة'),
(66691, 3275623424, 3275623935, 'PL', 'POL', 'بولندا'),
(66692, 3275623936, 3275624447, 'UA', 'UKR', 'أوكرانيا'),
(66693, 3275624448, 3275624959, 'SK', 'SVK', 'سلوفاكيا'),
(66694, 3275624960, 3275625471, 'IL', 'ISR', 'إسرائيل'),
(66695, 3275625472, 3275625983, 'DE', 'DEU', 'ألمانيا'),
(66696, 3275625984, 3275626495, 'BG', 'BGR', 'بلغاريا'),
(66697, 3275626496, 3275627007, 'UA', 'UKR', 'أوكرانيا'),
(66698, 3275627008, 3275627519, 'AT', 'AUT', 'النمسا'),
(66699, 3275627520, 3275628031, 'GB', 'GBR', 'المملكة المتحدة'),
(66700, 3275628032, 3275628543, 'IL', 'ISR', 'إسرائيل'),
(66701, 3275628544, 3275629567, 'RU', 'RUS', 'الإتحاد الروسي'),
(66702, 3275629568, 3275630079, 'UA', 'UKR', 'أوكرانيا'),
(66703, 3275630592, 3275631103, 'PL', 'POL', 'بولندا'),
(66704, 3275631104, 3275631615, 'FR', 'FRA', 'فرنسا'),
(66705, 3275631616, 3275632127, 'DE', 'DEU', 'ألمانيا'),
(66706, 3275632128, 3275633151, 'RU', 'RUS', 'الإتحاد الروسي'),
(66707, 3275633152, 3275633663, 'FR', 'FRA', 'فرنسا'),
(66708, 3275633664, 3275634687, 'RU', 'RUS', 'الإتحاد الروسي'),
(66709, 3275634688, 3275635199, 'RO', 'ROM', 'رومانيا'),
(66710, 3275635200, 3275636735, 'RU', 'RUS', 'الإتحاد الروسي'),
(66711, 3275636736, 3275637247, 'PL', 'POL', 'بولندا'),
(66712, 3275637248, 3275637759, 'SE', 'SWE', 'السويد'),
(66713, 3275637760, 3275638271, 'BE', 'BEL', 'بلجيكا'),
(66714, 3275638272, 3275638783, 'RU', 'RUS', 'الإتحاد الروسي'),
(66715, 3275638784, 3275639807, 'FR', 'FRA', 'فرنسا'),
(66716, 3275639808, 3275640319, 'SE', 'SWE', 'السويد'),
(66717, 3275640320, 3275640831, 'RU', 'RUS', 'الإتحاد الروسي'),
(66718, 3275640832, 3275641343, 'DE', 'DEU', 'ألمانيا'),
(66719, 3275641344, 3275641855, 'NL', 'NLD', 'هولندا'),
(66720, 3275641856, 3275642367, 'AT', 'AUT', 'النمسا'),
(66721, 3275642368, 3275642879, 'RU', 'RUS', 'الإتحاد الروسي'),
(66722, 3275642880, 3275643391, 'RO', 'ROM', 'رومانيا'),
(66723, 3275643392, 3275643903, 'BE', 'BEL', 'بلجيكا'),
(66724, 3275643904, 3275644415, 'RU', 'RUS', 'الإتحاد الروسي'),
(66725, 3275644416, 3275644927, 'RO', 'ROM', 'رومانيا'),
(66726, 3275644928, 3275653119, 'DE', 'DEU', 'ألمانيا'),
(66727, 3275653120, 3275661311, 'LV', 'LVA', 'لاتفيا'),
(66728, 3275661312, 3275669503, 'IT', 'ITA', 'إيطاليا'),
(66729, 3275669504, 3275677695, 'GB', 'GBR', 'المملكة المتحدة'),
(66730, 3275677696, 3275685887, 'IT', 'ITA', 'إيطاليا'),
(66731, 3275685888, 3275751423, 'DE', 'DEU', 'ألمانيا'),
(66732, 3275751424, 3275759615, 'AT', 'AUT', 'النمسا'),
(66733, 3275759616, 3275775999, 'NL', 'NLD', 'هولندا'),
(66734, 3275776000, 3275784191, 'DE', 'DEU', 'ألمانيا'),
(66735, 3275784192, 3275784703, 'RO', 'ROM', 'رومانيا'),
(66736, 3275784704, 3275785215, 'PL', 'POL', 'بولندا'),
(66737, 3275785216, 3275785727, 'RO', 'ROM', 'رومانيا'),
(66738, 3275785728, 3275786239, 'CH', 'CHE', 'سويسرا'),
(66739, 3275786240, 3275786751, 'UA', 'UKR', 'أوكرانيا'),
(66740, 3275786752, 3275787263, 'CH', 'CHE', 'سويسرا'),
(66741, 3275787264, 3275787775, 'RU', 'RUS', 'الإتحاد الروسي'),
(66742, 3275787776, 3275788287, 'UA', 'UKR', 'أوكرانيا'),
(66743, 3275788288, 3275788799, 'SE', 'SWE', 'السويد'),
(66744, 3275788800, 3275789311, 'AT', 'AUT', 'النمسا'),
(66745, 3275789312, 3275789823, 'UA', 'UKR', 'أوكرانيا'),
(66746, 3275789824, 3275790335, 'PL', 'POL', 'بولندا'),
(66747, 3275790336, 3275790847, 'MD', 'MDA', 'مولدوفا'),
(66748, 3275790848, 3275791359, 'DK', 'DNK', 'الدنيمارك'),
(66749, 3275791360, 3275791871, 'RU', 'RUS', 'الإتحاد الروسي'),
(66750, 3275791872, 3275792383, 'PL', 'POL', 'بولندا'),
(66751, 3275792384, 3275792895, 'BG', 'BGR', 'بلغاريا'),
(66752, 3275792896, 3275793407, 'UA', 'UKR', 'أوكرانيا'),
(66753, 3275793408, 3275793919, 'FR', 'FRA', 'فرنسا'),
(66754, 3275793920, 3275794431, 'UA', 'UKR', 'أوكرانيا'),
(66755, 3275794432, 3275794943, 'IT', 'ITA', 'إيطاليا'),
(66756, 3275794944, 3275795455, 'RS', 'SRB', 'صربيا'),
(66757, 3275795456, 3275795967, 'GR', 'GRC', 'اليونان'),
(66758, 3275795968, 3275796479, 'PL', 'POL', 'بولندا'),
(66759, 3275796480, 3275796991, 'DE', 'DEU', 'ألمانيا'),
(66760, 3275796992, 3275797503, 'RO', 'ROM', 'رومانيا'),
(66761, 3275797504, 3275798015, 'DE', 'DEU', 'ألمانيا'),
(66762, 3275798528, 3275799039, 'UA', 'UKR', 'أوكرانيا'),
(66763, 3275799040, 3275799551, 'ES', 'ESP', 'إسبانيا'),
(66764, 3275799552, 3275800063, 'IT', 'ITA', 'إيطاليا'),
(66765, 3275800064, 3275800575, 'UA', 'UKR', 'أوكرانيا'),
(66766, 3275800576, 3275808767, 'RU', 'RUS', 'الإتحاد الروسي'),
(66767, 3275808768, 3275816959, 'UA', 'UKR', 'أوكرانيا'),
(66768, 3275816960, 3275818207, 'CH', 'CHE', 'سويسرا'),
(66769, 3275818208, 3275818215, 'DE', 'DEU', 'ألمانيا'),
(66770, 3275818216, 3275881335, 'CH', 'CHE', 'سويسرا'),
(66771, 3275881336, 3275881343, 'DE', 'DEU', 'ألمانيا'),
(66772, 3275881344, 3275882495, 'CH', 'CHE', 'سويسرا'),
(66773, 3275882496, 3275884543, 'DE', 'DEU', 'ألمانيا'),
(66774, 3275884544, 3275886591, 'IT', 'ITA', 'إيطاليا'),
(66775, 3275886592, 3275888639, 'PL', 'POL', 'بولندا'),
(66776, 3275888640, 3275890687, 'GB', 'GBR', 'المملكة المتحدة'),
(66777, 3275890688, 3275898879, 'SE', 'SWE', 'السويد'),
(66778, 3275898880, 3275899135, 'LV', 'LVA', 'لاتفيا'),
(66779, 3275899136, 3275899647, 'UA', 'UKR', 'أوكرانيا'),
(66780, 3275899648, 3275900159, 'PL', 'POL', 'بولندا'),
(66781, 3275900160, 3275900415, 'SI', 'SVN', 'سلوفينيا'),
(66782, 3275900416, 3275900671, 'DE', 'DEU', 'ألمانيا'),
(66783, 3275900672, 3275901183, 'RU', 'RUS', 'الإتحاد الروسي'),
(66784, 3275901184, 3275901439, 'PL', 'POL', 'بولندا'),
(66785, 3275901440, 3275901695, 'DE', 'DEU', 'ألمانيا'),
(66786, 3275901696, 3275901951, 'IE', 'IRL', 'إيرلندا'),
(66787, 3275901952, 3275902207, 'DE', 'DEU', 'ألمانيا'),
(66788, 3275902208, 3275902719, 'RU', 'RUS', 'الإتحاد الروسي'),
(66789, 3275902720, 3275902975, 'UA', 'UKR', 'أوكرانيا'),
(66790, 3275902976, 3275903231, 'FR', 'FRA', 'فرنسا'),
(66791, 3275903232, 3275903487, 'GB', 'GBR', 'المملكة المتحدة'),
(66792, 3275903488, 3275903999, 'DE', 'DEU', 'ألمانيا'),
(66793, 3275904000, 3275904255, 'RU', 'RUS', 'الإتحاد الروسي'),
(66794, 3275904256, 3275904511, 'CH', 'CHE', 'سويسرا'),
(66795, 3275904512, 3275904767, 'PL', 'POL', 'بولندا'),
(66796, 3275904768, 3275905023, 'RU', 'RUS', 'الإتحاد الروسي'),
(66797, 3275905024, 3275905279, 'PL', 'POL', 'بولندا'),
(66798, 3275905280, 3275905535, 'RU', 'RUS', 'الإتحاد الروسي'),
(66799, 3275905536, 3275905791, 'NL', 'NLD', 'هولندا'),
(66800, 3275905792, 3275906303, 'AT', 'AUT', 'النمسا'),
(66801, 3275906304, 3275906559, 'UA', 'UKR', 'أوكرانيا'),
(66802, 3275906560, 3275907071, 'SE', 'SWE', 'السويد'),
(66803, 3275907072, 3275907327, 'RU', 'RUS', 'الإتحاد الروسي'),
(66804, 3275907328, 3275907583, 'CH', 'CHE', 'سويسرا'),
(66805, 3275907584, 3275907839, 'PL', 'POL', 'بولندا'),
(66806, 3275907840, 3275908095, 'DE', 'DEU', 'ألمانيا'),
(66807, 3275908096, 3275908351, 'SA', 'SAU', 'السعودية'),
(66808, 3275908352, 3275908607, 'SE', 'SWE', 'السويد'),
(66809, 3275908608, 3275908863, 'US', 'USA', 'الولايات المتحدة'),
(66810, 3275908864, 3275909119, 'PL', 'POL', 'بولندا'),
(66811, 3275909120, 3275909375, 'RU', 'RUS', 'الإتحاد الروسي'),
(66812, 3275909376, 3275909631, 'UA', 'UKR', 'أوكرانيا'),
(66813, 3275909632, 3275909887, 'EE', 'EST', 'إستونيا'),
(66814, 3275909888, 3275910143, 'SI', 'SVN', 'سلوفينيا'),
(66815, 3275910144, 3275910399, 'RU', 'RUS', 'الإتحاد الروسي'),
(66816, 3275910400, 3275910655, 'DK', 'DNK', 'الدنيمارك'),
(66817, 3275910656, 3275910911, 'CH', 'CHE', 'سويسرا'),
(66818, 3275910912, 3275911167, 'DE', 'DEU', 'ألمانيا'),
(66819, 3275911168, 3275911423, 'FR', 'FRA', 'فرنسا'),
(66820, 3275911424, 3275911679, 'RO', 'ROM', 'رومانيا'),
(66821, 3275911680, 3275911935, 'UA', 'UKR', 'أوكرانيا'),
(66822, 3275911936, 3275912191, 'BE', 'BEL', 'بلجيكا'),
(66823, 3275912192, 3275912447, 'PL', 'POL', 'بولندا'),
(66824, 3275912448, 3275912703, 'RU', 'RUS', 'الإتحاد الروسي'),
(66825, 3275912704, 3275912959, 'IL', 'ISR', 'إسرائيل'),
(66826, 3275912960, 3275913215, 'FR', 'FRA', 'فرنسا'),
(66827, 3275913216, 3275913471, 'UA', 'UKR', 'أوكرانيا'),
(66828, 3275913472, 3275913983, 'DE', 'DEU', 'ألمانيا'),
(66829, 3275913984, 3275914239, 'CH', 'CHE', 'سويسرا'),
(66830, 3275914240, 3275914495, 'RO', 'ROM', 'رومانيا'),
(66831, 3275914496, 3275914751, 'BG', 'BGR', 'بلغاريا'),
(66832, 3275914752, 3275915007, 'RU', 'RUS', 'الإتحاد الروسي'),
(66833, 3275915008, 3275915263, 'PT', 'PRT', 'البورتوغال'),
(66834, 3275915264, 3275915775, 'FR', 'FRA', 'فرنسا'),
(66835, 3275915776, 3275916287, 'SE', 'SWE', 'السويد'),
(66836, 3275916288, 3275916799, 'US', 'USA', 'الولايات المتحدة'),
(66837, 3275916800, 3275917311, 'NL', 'NLD', 'هولندا'),
(66838, 3275917312, 3275918847, 'UA', 'UKR', 'أوكرانيا'),
(66839, 3275918848, 3275919359, 'RO', 'ROM', 'رومانيا'),
(66840, 3275919360, 3275919871, 'PL', 'POL', 'بولندا'),
(66841, 3275920384, 3275920895, 'GB', 'GBR', 'المملكة المتحدة'),
(66842, 3275920896, 3275921407, 'ES', 'ESP', 'إسبانيا'),
(66843, 3275921408, 3275921919, 'UA', 'UKR', 'أوكرانيا'),
(66844, 3275921920, 3275922431, 'DE', 'DEU', 'ألمانيا'),
(66845, 3275922432, 3275922943, 'UA', 'UKR', 'أوكرانيا'),
(66846, 3275922944, 3275923455, 'GR', 'GRC', 'اليونان'),
(66847, 3275923456, 3275924479, 'ME', 'MNE', 'الجبل الأسود'),
(66848, 3275924480, 3275925759, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66849, 3275925760, 3275926287, 'ME', 'MNE', 'الجبل الأسود'),
(66850, 3275926288, 3275926303, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66851, 3275926304, 3275926527, 'ME', 'MNE', 'الجبل الأسود'),
(66852, 3275926528, 3275926783, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66853, 3275926784, 3275928927, 'ME', 'MNE', 'الجبل الأسود'),
(66854, 3275928928, 3275928943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66855, 3275928944, 3275929151, 'ME', 'MNE', 'الجبل الأسود'),
(66856, 3275929152, 3275929159, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66857, 3275929160, 3275929167, 'ME', 'MNE', 'الجبل الأسود'),
(66858, 3275929168, 3275929183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66859, 3275929184, 3275929295, 'ME', 'MNE', 'الجبل الأسود'),
(66860, 3275929296, 3275929311, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66861, 3275929312, 3275929471, 'ME', 'MNE', 'الجبل الأسود'),
(66862, 3275929472, 3275929487, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66863, 3275929488, 3275929503, 'ME', 'MNE', 'الجبل الأسود'),
(66864, 3275929504, 3275929535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66865, 3275929536, 3275929615, 'ME', 'MNE', 'الجبل الأسود'),
(66866, 3275929616, 3275929663, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66867, 3275929664, 3275929695, 'ME', 'MNE', 'الجبل الأسود'),
(66868, 3275929696, 3275929711, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66869, 3275929712, 3275929719, 'ME', 'MNE', 'الجبل الأسود'),
(66870, 3275929720, 3275929727, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66871, 3275929728, 3275929855, 'ME', 'MNE', 'الجبل الأسود'),
(66872, 3275929856, 3275929919, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66873, 3275929920, 3275929935, 'ME', 'MNE', 'الجبل الأسود'),
(66874, 3275929936, 3275929951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66875, 3275929952, 3275930015, 'ME', 'MNE', 'الجبل الأسود'),
(66876, 3275930016, 3275930023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66877, 3275930024, 3275930079, 'ME', 'MNE', 'الجبل الأسود'),
(66878, 3275930080, 3275930095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66879, 3275930096, 3275930239, 'ME', 'MNE', 'الجبل الأسود'),
(66880, 3275930240, 3275930271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66881, 3275930272, 3275930287, 'ME', 'MNE', 'الجبل الأسود'),
(66882, 3275930288, 3275930295, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(66883, 3275930296, 3275931647, 'ME', 'MNE', 'الجبل الأسود'),
(66884, 3275931648, 3275939839, 'UA', 'UKR', 'أوكرانيا'),
(66885, 3275939840, 3275948031, 'GB', 'GBR', 'المملكة المتحدة'),
(66886, 3275948032, 3275965267, 'SE', 'SWE', 'السويد'),
(66887, 3275965268, 3275965271, 'FI', 'FIN', 'فنلندا'),
(66888, 3275965272, 3276013567, 'SE', 'SWE', 'السويد'),
(66889, 3276013568, 3276014087, 'FR', 'FRA', 'فرنسا'),
(66890, 3276014088, 3276014095, 'GB', 'GBR', 'المملكة المتحدة'),
(66891, 3276014096, 3276014151, 'FR', 'FRA', 'فرنسا'),
(66892, 3276014152, 3276014159, 'GB', 'GBR', 'المملكة المتحدة'),
(66893, 3276014160, 3276014191, 'FR', 'FRA', 'فرنسا'),
(66894, 3276014192, 3276014207, 'GB', 'GBR', 'المملكة المتحدة'),
(66895, 3276014208, 3276014255, 'FR', 'FRA', 'فرنسا'),
(66896, 3276014256, 3276014263, 'GB', 'GBR', 'المملكة المتحدة'),
(66897, 3276014264, 3276014471, 'FR', 'FRA', 'فرنسا'),
(66898, 3276014472, 3276014495, 'GB', 'GBR', 'المملكة المتحدة'),
(66899, 3276014496, 3276014671, 'FR', 'FRA', 'فرنسا'),
(66900, 3276014672, 3276014679, 'GB', 'GBR', 'المملكة المتحدة'),
(66901, 3276014680, 3276014703, 'FR', 'FRA', 'فرنسا'),
(66902, 3276014704, 3276014711, 'GB', 'GBR', 'المملكة المتحدة'),
(66903, 3276014712, 3276014887, 'FR', 'FRA', 'فرنسا'),
(66904, 3276014888, 3276014895, 'IE', 'IRL', 'إيرلندا'),
(66905, 3276014896, 3276015007, 'FR', 'FRA', 'فرنسا'),
(66906, 3276015008, 3276015015, 'GB', 'GBR', 'المملكة المتحدة'),
(66907, 3276015016, 3276015199, 'FR', 'FRA', 'فرنسا'),
(66908, 3276015200, 3276015231, 'GB', 'GBR', 'المملكة المتحدة'),
(66909, 3276015232, 3276015247, 'FR', 'FRA', 'فرنسا'),
(66910, 3276015248, 3276015263, 'GB', 'GBR', 'المملكة المتحدة'),
(66911, 3276015264, 3276015295, 'FR', 'FRA', 'فرنسا'),
(66912, 3276015296, 3276015327, 'GB', 'GBR', 'المملكة المتحدة'),
(66913, 3276015328, 3276015559, 'FR', 'FRA', 'فرنسا'),
(66914, 3276015560, 3276015583, 'GB', 'GBR', 'المملكة المتحدة'),
(66915, 3276015584, 3276015879, 'FR', 'FRA', 'فرنسا'),
(66916, 3276015880, 3276015887, 'GB', 'GBR', 'المملكة المتحدة'),
(66917, 3276015888, 3276016391, 'FR', 'FRA', 'فرنسا'),
(66918, 3276016392, 3276016399, 'GB', 'GBR', 'المملكة المتحدة'),
(66919, 3276016400, 3276016415, 'FR', 'FRA', 'فرنسا'),
(66920, 3276016416, 3276016463, 'GB', 'GBR', 'المملكة المتحدة'),
(66921, 3276016464, 3276016527, 'FR', 'FRA', 'فرنسا'),
(66922, 3276016528, 3276016591, 'GB', 'GBR', 'المملكة المتحدة'),
(66923, 3276016592, 3276016703, 'FR', 'FRA', 'فرنسا'),
(66924, 3276016704, 3276016735, 'GB', 'GBR', 'المملكة المتحدة'),
(66925, 3276016736, 3276016767, 'FR', 'FRA', 'فرنسا'),
(66926, 3276016768, 3276016783, 'GB', 'GBR', 'المملكة المتحدة'),
(66927, 3276016784, 3276016799, 'FR', 'FRA', 'فرنسا'),
(66928, 3276016800, 3276016815, 'GB', 'GBR', 'المملكة المتحدة'),
(66929, 3276016816, 3276016831, 'FR', 'FRA', 'فرنسا'),
(66930, 3276016832, 3276016847, 'GB', 'GBR', 'المملكة المتحدة'),
(66931, 3276016848, 3276016863, 'FR', 'FRA', 'فرنسا'),
(66932, 3276016864, 3276016879, 'GB', 'GBR', 'المملكة المتحدة'),
(66933, 3276016880, 3276016943, 'FR', 'FRA', 'فرنسا'),
(66934, 3276016944, 3276016959, 'GB', 'GBR', 'المملكة المتحدة'),
(66935, 3276016960, 3276016975, 'FR', 'FRA', 'فرنسا'),
(66936, 3276016976, 3276016991, 'GB', 'GBR', 'المملكة المتحدة'),
(66937, 3276016992, 3276017039, 'FR', 'FRA', 'فرنسا'),
(66938, 3276017040, 3276017043, 'GB', 'GBR', 'المملكة المتحدة'),
(66939, 3276017044, 3276017047, 'FR', 'FRA', 'فرنسا'),
(66940, 3276017048, 3276017055, 'GB', 'GBR', 'المملكة المتحدة'),
(66941, 3276017056, 3276017119, 'FR', 'FRA', 'فرنسا'),
(66942, 3276017120, 3276017151, 'GB', 'GBR', 'المملكة المتحدة'),
(66943, 3276017152, 3276017327, 'FR', 'FRA', 'فرنسا'),
(66944, 3276017328, 3276017343, 'GB', 'GBR', 'المملكة المتحدة'),
(66945, 3276017344, 3276017551, 'FR', 'FRA', 'فرنسا'),
(66946, 3276017552, 3276017567, 'GB', 'GBR', 'المملكة المتحدة'),
(66947, 3276017568, 3276017607, 'FR', 'FRA', 'فرنسا'),
(66948, 3276017608, 3276017663, 'GB', 'GBR', 'المملكة المتحدة'),
(66949, 3276017664, 3276018015, 'FR', 'FRA', 'فرنسا'),
(66950, 3276018016, 3276018031, 'GB', 'GBR', 'المملكة المتحدة'),
(66951, 3276018032, 3276018047, 'FR', 'FRA', 'فرنسا'),
(66952, 3276018048, 3276018063, 'GB', 'GBR', 'المملكة المتحدة'),
(66953, 3276018064, 3276018095, 'FR', 'FRA', 'فرنسا'),
(66954, 3276018096, 3276018127, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(66955, 3276018128, 3276018143, 'FR', 'FRA', 'فرنسا'),
(66956, 3276018144, 3276018159, 'GB', 'GBR', 'المملكة المتحدة'),
(66957, 3276018160, 3276018183, 'FR', 'FRA', 'فرنسا'),
(66958, 3276018184, 3276018207, 'GB', 'GBR', 'المملكة المتحدة'),
(66959, 3276018208, 3276018375, 'FR', 'FRA', 'فرنسا'),
(66960, 3276018376, 3276018383, 'GB', 'GBR', 'المملكة المتحدة'),
(66961, 3276018384, 3276018415, 'FR', 'FRA', 'فرنسا'),
(66962, 3276018416, 3276018423, 'GB', 'GBR', 'المملكة المتحدة'),
(66963, 3276018424, 3276018495, 'FR', 'FRA', 'فرنسا'),
(66964, 3276018496, 3276018527, 'GB', 'GBR', 'المملكة المتحدة'),
(66965, 3276018528, 3276018543, 'FR', 'FRA', 'فرنسا'),
(66966, 3276018544, 3276018623, 'GB', 'GBR', 'المملكة المتحدة'),
(66967, 3276018624, 3276018943, 'FR', 'FRA', 'فرنسا'),
(66968, 3276018944, 3276018975, 'GB', 'GBR', 'المملكة المتحدة'),
(66969, 3276018976, 3276018985, 'FR', 'FRA', 'فرنسا'),
(66970, 3276018986, 3276019007, 'GB', 'GBR', 'المملكة المتحدة'),
(66971, 3276019008, 3276019023, 'FR', 'FRA', 'فرنسا'),
(66972, 3276019024, 3276019071, 'GB', 'GBR', 'المملكة المتحدة'),
(66973, 3276019072, 3276019135, 'FR', 'FRA', 'فرنسا'),
(66974, 3276019136, 3276019151, 'GB', 'GBR', 'المملكة المتحدة'),
(66975, 3276019152, 3276019463, 'FR', 'FRA', 'فرنسا'),
(66976, 3276019464, 3276019471, 'GB', 'GBR', 'المملكة المتحدة'),
(66977, 3276019472, 3276019503, 'FR', 'FRA', 'فرنسا'),
(66978, 3276019504, 3276019511, 'GB', 'GBR', 'المملكة المتحدة'),
(66979, 3276019512, 3276019535, 'FR', 'FRA', 'فرنسا'),
(66980, 3276019536, 3276019543, 'GB', 'GBR', 'المملكة المتحدة'),
(66981, 3276019544, 3276019559, 'FR', 'FRA', 'فرنسا'),
(66982, 3276019560, 3276019599, 'GB', 'GBR', 'المملكة المتحدة'),
(66983, 3276019600, 3276019639, 'FR', 'FRA', 'فرنسا'),
(66984, 3276019640, 3276019647, 'GB', 'GBR', 'المملكة المتحدة'),
(66985, 3276019648, 3276019679, 'FR', 'FRA', 'فرنسا'),
(66986, 3276019680, 3276019687, 'GB', 'GBR', 'المملكة المتحدة'),
(66987, 3276019688, 3276019695, 'FR', 'FRA', 'فرنسا'),
(66988, 3276019696, 3276019703, 'GB', 'GBR', 'المملكة المتحدة'),
(66989, 3276019704, 3276019823, 'FR', 'FRA', 'فرنسا'),
(66990, 3276019824, 3276019831, 'GB', 'GBR', 'المملكة المتحدة'),
(66991, 3276019832, 3276019839, 'FR', 'FRA', 'فرنسا'),
(66992, 3276019840, 3276019855, 'GB', 'GBR', 'المملكة المتحدة'),
(66993, 3276019856, 3276019863, 'FR', 'FRA', 'فرنسا'),
(66994, 3276019864, 3276019871, 'GB', 'GBR', 'المملكة المتحدة'),
(66995, 3276019872, 3276019919, 'FR', 'FRA', 'فرنسا'),
(66996, 3276019920, 3276019927, 'GB', 'GBR', 'المملكة المتحدة'),
(66997, 3276019928, 3276020223, 'FR', 'FRA', 'فرنسا'),
(66998, 3276020224, 3276020287, 'GB', 'GBR', 'المملكة المتحدة'),
(66999, 3276020288, 3276020399, 'FR', 'FRA', 'فرنسا'),
(67000, 3276020400, 3276020415, 'GB', 'GBR', 'المملكة المتحدة'),
(67001, 3276020416, 3276020431, 'FR', 'FRA', 'فرنسا'),
(67002, 3276020432, 3276020439, 'GB', 'GBR', 'المملكة المتحدة'),
(67003, 3276020440, 3276020623, 'FR', 'FRA', 'فرنسا'),
(67004, 3276020624, 3276020631, 'GB', 'GBR', 'المملكة المتحدة'),
(67005, 3276020632, 3276020679, 'FR', 'FRA', 'فرنسا'),
(67006, 3276020680, 3276020687, 'GB', 'GBR', 'المملكة المتحدة'),
(67007, 3276020688, 3276020703, 'FR', 'FRA', 'فرنسا'),
(67008, 3276020704, 3276020735, 'GB', 'GBR', 'المملكة المتحدة'),
(67009, 3276020736, 3276020879, 'FR', 'FRA', 'فرنسا'),
(67010, 3276020880, 3276020887, 'GB', 'GBR', 'المملكة المتحدة'),
(67011, 3276020888, 3276020943, 'FR', 'FRA', 'فرنسا'),
(67012, 3276020944, 3276020991, 'GB', 'GBR', 'المملكة المتحدة'),
(67013, 3276020992, 3276021727, 'FR', 'FRA', 'فرنسا'),
(67014, 3276021728, 3276021759, 'GB', 'GBR', 'المملكة المتحدة'),
(67015, 3276021760, 3276021991, 'FR', 'FRA', 'فرنسا'),
(67016, 3276021992, 3276021999, 'GB', 'GBR', 'المملكة المتحدة'),
(67017, 3276022000, 3276022031, 'FR', 'FRA', 'فرنسا'),
(67018, 3276022032, 3276022047, 'GB', 'GBR', 'المملكة المتحدة'),
(67019, 3276022048, 3276022087, 'FR', 'FRA', 'فرنسا'),
(67020, 3276022088, 3276022095, 'GB', 'GBR', 'المملكة المتحدة'),
(67021, 3276022096, 3276022127, 'FR', 'FRA', 'فرنسا'),
(67022, 3276022128, 3276022143, 'GB', 'GBR', 'المملكة المتحدة'),
(67023, 3276022144, 3276022255, 'FR', 'FRA', 'فرنسا'),
(67024, 3276022256, 3276022271, 'GB', 'GBR', 'المملكة المتحدة'),
(67025, 3276022272, 3276022455, 'FR', 'FRA', 'فرنسا'),
(67026, 3276022456, 3276022463, 'GB', 'GBR', 'المملكة المتحدة'),
(67027, 3276022464, 3276022479, 'FR', 'FRA', 'فرنسا'),
(67028, 3276022480, 3276022495, 'GB', 'GBR', 'المملكة المتحدة'),
(67029, 3276022496, 3276022519, 'FR', 'FRA', 'فرنسا'),
(67030, 3276022520, 3276022527, 'GB', 'GBR', 'المملكة المتحدة'),
(67031, 3276022528, 3276022567, 'FR', 'FRA', 'فرنسا'),
(67032, 3276022568, 3276022639, 'GB', 'GBR', 'المملكة المتحدة'),
(67033, 3276022640, 3276022655, 'FR', 'FRA', 'فرنسا'),
(67034, 3276022656, 3276022687, 'GB', 'GBR', 'المملكة المتحدة'),
(67035, 3276022688, 3276022751, 'FR', 'FRA', 'فرنسا'),
(67036, 3276022752, 3276022783, 'GB', 'GBR', 'المملكة المتحدة'),
(67037, 3276022784, 3276022983, 'FR', 'FRA', 'فرنسا'),
(67038, 3276022984, 3276022991, 'GB', 'GBR', 'المملكة المتحدة'),
(67039, 3276022992, 3276023031, 'FR', 'FRA', 'فرنسا'),
(67040, 3276023032, 3276023039, 'GB', 'GBR', 'المملكة المتحدة'),
(67041, 3276023040, 3276023071, 'FR', 'FRA', 'فرنسا'),
(67042, 3276023072, 3276023079, 'GB', 'GBR', 'المملكة المتحدة'),
(67043, 3276023080, 3276023103, 'FR', 'FRA', 'فرنسا'),
(67044, 3276023104, 3276023279, 'GB', 'GBR', 'المملكة المتحدة'),
(67045, 3276023280, 3276023679, 'FR', 'FRA', 'فرنسا'),
(67046, 3276023680, 3276023695, 'GB', 'GBR', 'المملكة المتحدة'),
(67047, 3276023696, 3276023759, 'FR', 'FRA', 'فرنسا'),
(67048, 3276023760, 3276023767, 'GB', 'GBR', 'المملكة المتحدة'),
(67049, 3276023768, 3276023871, 'FR', 'FRA', 'فرنسا'),
(67050, 3276023872, 3276023887, 'GB', 'GBR', 'المملكة المتحدة'),
(67051, 3276023888, 3276023903, 'FR', 'FRA', 'فرنسا'),
(67052, 3276023904, 3276023919, 'GB', 'GBR', 'المملكة المتحدة'),
(67053, 3276023920, 3276023943, 'FR', 'FRA', 'فرنسا'),
(67054, 3276023944, 3276023951, 'GB', 'GBR', 'المملكة المتحدة'),
(67055, 3276023952, 3276023959, 'FR', 'FRA', 'فرنسا'),
(67056, 3276023960, 3276023967, 'GB', 'GBR', 'المملكة المتحدة'),
(67057, 3276023968, 3276024703, 'FR', 'FRA', 'فرنسا'),
(67058, 3276024704, 3276024831, 'GB', 'GBR', 'المملكة المتحدة'),
(67059, 3276024832, 3276025111, 'FR', 'FRA', 'فرنسا'),
(67060, 3276025112, 3276025135, 'GB', 'GBR', 'المملكة المتحدة'),
(67061, 3276025136, 3276025151, 'FR', 'FRA', 'فرنسا'),
(67062, 3276025152, 3276025159, 'GB', 'GBR', 'المملكة المتحدة'),
(67063, 3276025160, 3276025167, 'FR', 'FRA', 'فرنسا'),
(67064, 3276025168, 3276025175, 'GB', 'GBR', 'المملكة المتحدة'),
(67065, 3276025176, 3276025183, 'FR', 'FRA', 'فرنسا'),
(67066, 3276025184, 3276025191, 'GB', 'GBR', 'المملكة المتحدة'),
(67067, 3276025192, 3276025207, 'FR', 'FRA', 'فرنسا'),
(67068, 3276025208, 3276025215, 'GB', 'GBR', 'المملكة المتحدة'),
(67069, 3276025216, 3276025247, 'FR', 'FRA', 'فرنسا'),
(67070, 3276025248, 3276025279, 'GB', 'GBR', 'المملكة المتحدة'),
(67071, 3276025280, 3276025295, 'FR', 'FRA', 'فرنسا'),
(67072, 3276025296, 3276025327, 'GB', 'GBR', 'المملكة المتحدة'),
(67073, 3276025328, 3276026143, 'FR', 'FRA', 'فرنسا'),
(67074, 3276026144, 3276026159, 'GB', 'GBR', 'المملكة المتحدة'),
(67075, 3276026160, 3276026167, 'FR', 'FRA', 'فرنسا'),
(67076, 3276026168, 3276026175, 'GB', 'GBR', 'المملكة المتحدة'),
(67077, 3276026176, 3276026191, 'FR', 'FRA', 'فرنسا'),
(67078, 3276026192, 3276026199, 'GB', 'GBR', 'المملكة المتحدة'),
(67079, 3276026200, 3276026215, 'FR', 'FRA', 'فرنسا'),
(67080, 3276026216, 3276026223, 'GB', 'GBR', 'المملكة المتحدة'),
(67081, 3276026224, 3276026319, 'FR', 'FRA', 'فرنسا'),
(67082, 3276026320, 3276026351, 'GB', 'GBR', 'المملكة المتحدة'),
(67083, 3276026352, 3276026423, 'FR', 'FRA', 'فرنسا'),
(67084, 3276026424, 3276026431, 'GB', 'GBR', 'المملكة المتحدة'),
(67085, 3276026432, 3276026527, 'FR', 'FRA', 'فرنسا'),
(67086, 3276026528, 3276026535, 'GB', 'GBR', 'المملكة المتحدة'),
(67087, 3276026536, 3276026543, 'FR', 'FRA', 'فرنسا'),
(67088, 3276026544, 3276026575, 'GB', 'GBR', 'المملكة المتحدة'),
(67089, 3276026576, 3276026591, 'FR', 'FRA', 'فرنسا'),
(67090, 3276026592, 3276026607, 'GB', 'GBR', 'المملكة المتحدة'),
(67091, 3276026608, 3276026703, 'FR', 'FRA', 'فرنسا'),
(67092, 3276026704, 3276026719, 'GB', 'GBR', 'المملكة المتحدة'),
(67093, 3276026720, 3276026727, 'FR', 'FRA', 'فرنسا'),
(67094, 3276026728, 3276026743, 'GB', 'GBR', 'المملكة المتحدة'),
(67095, 3276026744, 3276026751, 'FR', 'FRA', 'فرنسا'),
(67096, 3276026752, 3276026783, 'GB', 'GBR', 'المملكة المتحدة'),
(67097, 3276026784, 3276026815, 'FR', 'FRA', 'فرنسا'),
(67098, 3276026816, 3276026823, 'GB', 'GBR', 'المملكة المتحدة'),
(67099, 3276026824, 3276026847, 'FR', 'FRA', 'فرنسا'),
(67100, 3276026848, 3276026927, 'GB', 'GBR', 'المملكة المتحدة'),
(67101, 3276026928, 3276026943, 'FR', 'FRA', 'فرنسا'),
(67102, 3276026944, 3276026991, 'GB', 'GBR', 'المملكة المتحدة'),
(67103, 3276026992, 3276027311, 'FR', 'FRA', 'فرنسا'),
(67104, 3276027312, 3276027327, 'GB', 'GBR', 'المملكة المتحدة'),
(67105, 3276027328, 3276027503, 'FR', 'FRA', 'فرنسا'),
(67106, 3276027504, 3276027519, 'GB', 'GBR', 'المملكة المتحدة'),
(67107, 3276027520, 3276027551, 'FR', 'FRA', 'فرنسا'),
(67108, 3276027552, 3276027583, 'GB', 'GBR', 'المملكة المتحدة'),
(67109, 3276027584, 3276027695, 'FR', 'FRA', 'فرنسا'),
(67110, 3276027696, 3276027743, 'GB', 'GBR', 'المملكة المتحدة'),
(67111, 3276027744, 3276027791, 'FR', 'FRA', 'فرنسا'),
(67112, 3276027792, 3276027807, 'GB', 'GBR', 'المملكة المتحدة'),
(67113, 3276027808, 3276027855, 'FR', 'FRA', 'فرنسا'),
(67114, 3276027856, 3276027871, 'GB', 'GBR', 'المملكة المتحدة'),
(67115, 3276027872, 3276027951, 'FR', 'FRA', 'فرنسا'),
(67116, 3276027952, 3276027967, 'GB', 'GBR', 'المملكة المتحدة'),
(67117, 3276027968, 3276028047, 'FR', 'FRA', 'فرنسا'),
(67118, 3276028048, 3276028063, 'GB', 'GBR', 'المملكة المتحدة'),
(67119, 3276028064, 3276028079, 'FR', 'FRA', 'فرنسا'),
(67120, 3276028080, 3276028111, 'GB', 'GBR', 'المملكة المتحدة'),
(67121, 3276028112, 3276028127, 'FR', 'FRA', 'فرنسا'),
(67122, 3276028128, 3276028143, 'GB', 'GBR', 'المملكة المتحدة'),
(67123, 3276028144, 3276028159, 'FR', 'FRA', 'فرنسا'),
(67124, 3276028160, 3276028231, 'GB', 'GBR', 'المملكة المتحدة'),
(67125, 3276028232, 3276028247, 'FR', 'FRA', 'فرنسا'),
(67126, 3276028248, 3276028255, 'GB', 'GBR', 'المملكة المتحدة'),
(67127, 3276028256, 3276028263, 'FR', 'FRA', 'فرنسا'),
(67128, 3276028264, 3276028287, 'GB', 'GBR', 'المملكة المتحدة'),
(67129, 3276028288, 3276028479, 'FR', 'FRA', 'فرنسا'),
(67130, 3276028480, 3276028511, 'GB', 'GBR', 'المملكة المتحدة'),
(67131, 3276028512, 3276028743, 'FR', 'FRA', 'فرنسا'),
(67132, 3276028744, 3276028751, 'GB', 'GBR', 'المملكة المتحدة'),
(67133, 3276028752, 3276028759, 'FR', 'FRA', 'فرنسا'),
(67134, 3276028760, 3276028767, 'GB', 'GBR', 'المملكة المتحدة'),
(67135, 3276028768, 3276028791, 'FR', 'FRA', 'فرنسا'),
(67136, 3276028792, 3276028799, 'GB', 'GBR', 'المملكة المتحدة'),
(67137, 3276028800, 3276028807, 'FR', 'FRA', 'فرنسا'),
(67138, 3276028808, 3276028815, 'GB', 'GBR', 'المملكة المتحدة'),
(67139, 3276028816, 3276028863, 'FR', 'FRA', 'فرنسا'),
(67140, 3276028864, 3276028871, 'GB', 'GBR', 'المملكة المتحدة'),
(67141, 3276028872, 3276028879, 'FR', 'FRA', 'فرنسا'),
(67142, 3276028880, 3276028887, 'GB', 'GBR', 'المملكة المتحدة'),
(67143, 3276028888, 3276028895, 'FR', 'FRA', 'فرنسا'),
(67144, 3276028896, 3276028927, 'GB', 'GBR', 'المملكة المتحدة'),
(67145, 3276028928, 3276029183, 'FR', 'FRA', 'فرنسا'),
(67146, 3276029184, 3276029199, 'GB', 'GBR', 'المملكة المتحدة'),
(67147, 3276029200, 3276029343, 'FR', 'FRA', 'فرنسا'),
(67148, 3276029344, 3276029359, 'GB', 'GBR', 'المملكة المتحدة'),
(67149, 3276029360, 3276029375, 'FR', 'FRA', 'فرنسا'),
(67150, 3276029376, 3276029407, 'GB', 'GBR', 'المملكة المتحدة'),
(67151, 3276029408, 3276029423, 'FR', 'FRA', 'فرنسا'),
(67152, 3276029424, 3276029439, 'GB', 'GBR', 'المملكة المتحدة'),
(67153, 3276029440, 3276029583, 'FR', 'FRA', 'فرنسا'),
(67154, 3276029584, 3276029599, 'GB', 'GBR', 'المملكة المتحدة'),
(67155, 3276029600, 3276029727, 'FR', 'FRA', 'فرنسا'),
(67156, 3276029728, 3276029791, 'GB', 'GBR', 'المملكة المتحدة'),
(67157, 3276029792, 3276029855, 'FR', 'FRA', 'فرنسا'),
(67158, 3276029856, 3276029887, 'GB', 'GBR', 'المملكة المتحدة'),
(67159, 3276029888, 3276029919, 'FR', 'FRA', 'فرنسا'),
(67160, 3276029920, 3276029967, 'GB', 'GBR', 'المملكة المتحدة'),
(67161, 3276029968, 3276030079, 'FR', 'FRA', 'فرنسا'),
(67162, 3276030080, 3276030095, 'GB', 'GBR', 'المملكة المتحدة'),
(67163, 3276030096, 3276030191, 'FR', 'FRA', 'فرنسا'),
(67164, 3276030192, 3276030207, 'GB', 'GBR', 'المملكة المتحدة'),
(67165, 3276030208, 3276030215, 'FR', 'FRA', 'فرنسا'),
(67166, 3276030216, 3276030239, 'GB', 'GBR', 'المملكة المتحدة'),
(67167, 3276030240, 3276030255, 'FR', 'FRA', 'فرنسا'),
(67168, 3276030256, 3276030263, 'GB', 'GBR', 'المملكة المتحدة'),
(67169, 3276030264, 3276030271, 'FR', 'FRA', 'فرنسا'),
(67170, 3276030272, 3276030303, 'GB', 'GBR', 'المملكة المتحدة'),
(67171, 3276030304, 3276030407, 'FR', 'FRA', 'فرنسا'),
(67172, 3276030408, 3276030415, 'GB', 'GBR', 'المملكة المتحدة'),
(67173, 3276030416, 3276030543, 'FR', 'FRA', 'فرنسا'),
(67174, 3276030544, 3276030559, 'GB', 'GBR', 'المملكة المتحدة'),
(67175, 3276030560, 3276031255, 'FR', 'FRA', 'فرنسا'),
(67176, 3276031256, 3276031263, 'GB', 'GBR', 'المملكة المتحدة'),
(67177, 3276031264, 3276031375, 'FR', 'FRA', 'فرنسا'),
(67178, 3276031376, 3276031383, 'GB', 'GBR', 'المملكة المتحدة'),
(67179, 3276031384, 3276031423, 'FR', 'FRA', 'فرنسا'),
(67180, 3276031424, 3276031439, 'GB', 'GBR', 'المملكة المتحدة'),
(67181, 3276031440, 3276031519, 'FR', 'FRA', 'فرنسا'),
(67182, 3276031520, 3276031535, 'GB', 'GBR', 'المملكة المتحدة'),
(67183, 3276031536, 3276031559, 'FR', 'FRA', 'فرنسا'),
(67184, 3276031560, 3276031567, 'GB', 'GBR', 'المملكة المتحدة'),
(67185, 3276031568, 3276031583, 'FR', 'FRA', 'فرنسا'),
(67186, 3276031584, 3276031591, 'GB', 'GBR', 'المملكة المتحدة'),
(67187, 3276031592, 3276031615, 'FR', 'FRA', 'فرنسا'),
(67188, 3276031616, 3276031679, 'GB', 'GBR', 'المملكة المتحدة'),
(67189, 3276031680, 3276031719, 'FR', 'FRA', 'فرنسا'),
(67190, 3276031720, 3276031743, 'GB', 'GBR', 'المملكة المتحدة'),
(67191, 3276031744, 3276032007, 'FR', 'FRA', 'فرنسا'),
(67192, 3276032008, 3276032015, 'GB', 'GBR', 'المملكة المتحدة'),
(67193, 3276032016, 3276032023, 'FR', 'FRA', 'فرنسا'),
(67194, 3276032024, 3276032031, 'GB', 'GBR', 'المملكة المتحدة'),
(67195, 3276032032, 3276032103, 'FR', 'FRA', 'فرنسا'),
(67196, 3276032104, 3276032111, 'GB', 'GBR', 'المملكة المتحدة'),
(67197, 3276032112, 3276032271, 'FR', 'FRA', 'فرنسا'),
(67198, 3276032272, 3276032303, 'GB', 'GBR', 'المملكة المتحدة'),
(67199, 3276032304, 3276032319, 'FR', 'FRA', 'فرنسا'),
(67200, 3276032320, 3276032343, 'GB', 'GBR', 'المملكة المتحدة'),
(67201, 3276032344, 3276032367, 'FR', 'FRA', 'فرنسا'),
(67202, 3276032368, 3276032383, 'GB', 'GBR', 'المملكة المتحدة'),
(67203, 3276032384, 3276032447, 'FR', 'FRA', 'فرنسا'),
(67204, 3276032448, 3276032479, 'GB', 'GBR', 'المملكة المتحدة'),
(67205, 3276032480, 3276032543, 'FR', 'FRA', 'فرنسا'),
(67206, 3276032544, 3276032559, 'GB', 'GBR', 'المملكة المتحدة'),
(67207, 3276032560, 3276032591, 'FR', 'FRA', 'فرنسا'),
(67208, 3276032592, 3276032607, 'GB', 'GBR', 'المملكة المتحدة'),
(67209, 3276032608, 3276032719, 'FR', 'FRA', 'فرنسا'),
(67210, 3276032720, 3276032735, 'GB', 'GBR', 'المملكة المتحدة'),
(67211, 3276032736, 3276033039, 'FR', 'FRA', 'فرنسا'),
(67212, 3276033040, 3276033119, 'GB', 'GBR', 'المملكة المتحدة'),
(67213, 3276033120, 3276033151, 'FR', 'FRA', 'فرنسا'),
(67214, 3276033152, 3276033167, 'GB', 'GBR', 'المملكة المتحدة'),
(67215, 3276033168, 3276033215, 'FR', 'FRA', 'فرنسا'),
(67216, 3276033216, 3276033231, 'GB', 'GBR', 'المملكة المتحدة'),
(67217, 3276033232, 3276033247, 'FR', 'FRA', 'فرنسا'),
(67218, 3276033248, 3276033279, 'GB', 'GBR', 'المملكة المتحدة'),
(67219, 3276033280, 3276033535, 'FR', 'FRA', 'فرنسا'),
(67220, 3276033536, 3276033647, 'GB', 'GBR', 'المملكة المتحدة'),
(67221, 3276033648, 3276033663, 'FR', 'FRA', 'فرنسا'),
(67222, 3276033664, 3276033695, 'GB', 'GBR', 'المملكة المتحدة'),
(67223, 3276033696, 3276033791, 'FR', 'FRA', 'فرنسا'),
(67224, 3276033792, 3276033823, 'GB', 'GBR', 'المملكة المتحدة'),
(67225, 3276033824, 3276033839, 'FR', 'FRA', 'فرنسا'),
(67226, 3276033840, 3276033855, 'GB', 'GBR', 'المملكة المتحدة'),
(67227, 3276033856, 3276033863, 'FR', 'FRA', 'فرنسا'),
(67228, 3276033864, 3276033871, 'GB', 'GBR', 'المملكة المتحدة'),
(67229, 3276033872, 3276033879, 'FR', 'FRA', 'فرنسا'),
(67230, 3276033880, 3276033887, 'GB', 'GBR', 'المملكة المتحدة'),
(67231, 3276033888, 3276033927, 'FR', 'FRA', 'فرنسا'),
(67232, 3276033928, 3276033951, 'GB', 'GBR', 'المملكة المتحدة'),
(67233, 3276033952, 3276036095, 'FR', 'FRA', 'فرنسا'),
(67234, 3276036096, 3276036103, 'GB', 'GBR', 'المملكة المتحدة'),
(67235, 3276036104, 3276036111, 'FR', 'FRA', 'فرنسا'),
(67236, 3276036112, 3276036119, 'GB', 'GBR', 'المملكة المتحدة'),
(67237, 3276036120, 3276036191, 'FR', 'FRA', 'فرنسا'),
(67238, 3276036192, 3276036207, 'GB', 'GBR', 'المملكة المتحدة'),
(67239, 3276036208, 3276036223, 'FR', 'FRA', 'فرنسا'),
(67240, 3276036224, 3276036255, 'GB', 'GBR', 'المملكة المتحدة'),
(67241, 3276036256, 3276036271, 'FR', 'FRA', 'فرنسا'),
(67242, 3276036272, 3276036287, 'GB', 'GBR', 'المملكة المتحدة'),
(67243, 3276036288, 3276036303, 'FR', 'FRA', 'فرنسا'),
(67244, 3276036304, 3276036335, 'GB', 'GBR', 'المملكة المتحدة'),
(67245, 3276036336, 3276036383, 'FR', 'FRA', 'فرنسا'),
(67246, 3276036384, 3276036415, 'GB', 'GBR', 'المملكة المتحدة'),
(67247, 3276036416, 3276036591, 'FR', 'FRA', 'فرنسا'),
(67248, 3276036592, 3276036607, 'GB', 'GBR', 'المملكة المتحدة'),
(67249, 3276036608, 3276037199, 'FR', 'FRA', 'فرنسا'),
(67250, 3276037200, 3276037215, 'GB', 'GBR', 'المملكة المتحدة'),
(67251, 3276037216, 3276037359, 'FR', 'FRA', 'فرنسا'),
(67252, 3276037360, 3276037375, 'GB', 'GBR', 'المملكة المتحدة'),
(67253, 3276037376, 3276037695, 'FR', 'FRA', 'فرنسا'),
(67254, 3276037696, 3276037743, 'GB', 'GBR', 'المملكة المتحدة'),
(67255, 3276037744, 3276037887, 'FR', 'FRA', 'فرنسا'),
(67256, 3276037888, 3276037903, 'GB', 'GBR', 'المملكة المتحدة'),
(67257, 3276037904, 3276037959, 'FR', 'FRA', 'فرنسا'),
(67258, 3276037960, 3276037983, 'GB', 'GBR', 'المملكة المتحدة'),
(67259, 3276037984, 3276038047, 'FR', 'FRA', 'فرنسا'),
(67260, 3276038048, 3276038111, 'GB', 'GBR', 'المملكة المتحدة'),
(67261, 3276038112, 3276038143, 'FR', 'FRA', 'فرنسا'),
(67262, 3276038144, 3276038399, 'GB', 'GBR', 'المملكة المتحدة'),
(67263, 3276038400, 3276038703, 'FR', 'FRA', 'فرنسا'),
(67264, 3276038704, 3276038719, 'GB', 'GBR', 'المملكة المتحدة'),
(67265, 3276038720, 3276038735, 'FR', 'FRA', 'فرنسا'),
(67266, 3276038736, 3276038767, 'GB', 'GBR', 'المملكة المتحدة'),
(67267, 3276038768, 3276038799, 'FR', 'FRA', 'فرنسا'),
(67268, 3276038800, 3276038815, 'GB', 'GBR', 'المملكة المتحدة'),
(67269, 3276038816, 3276038847, 'FR', 'FRA', 'فرنسا'),
(67270, 3276038848, 3276038911, 'GB', 'GBR', 'المملكة المتحدة'),
(67271, 3276038912, 3276039199, 'FR', 'FRA', 'فرنسا'),
(67272, 3276039200, 3276039247, 'GB', 'GBR', 'المملكة المتحدة'),
(67273, 3276039248, 3276039279, 'FR', 'FRA', 'فرنسا'),
(67274, 3276039280, 3276039295, 'GB', 'GBR', 'المملكة المتحدة'),
(67275, 3276039296, 3276039327, 'FR', 'FRA', 'فرنسا'),
(67276, 3276039328, 3276039343, 'GB', 'GBR', 'المملكة المتحدة'),
(67277, 3276039344, 3276039391, 'FR', 'FRA', 'فرنسا'),
(67278, 3276039392, 3276039423, 'GB', 'GBR', 'المملكة المتحدة'),
(67279, 3276039424, 3276039551, 'FR', 'FRA', 'فرنسا'),
(67280, 3276039552, 3276039567, 'GB', 'GBR', 'المملكة المتحدة'),
(67281, 3276039568, 3276039647, 'FR', 'FRA', 'فرنسا'),
(67282, 3276039648, 3276039663, 'GB', 'GBR', 'المملكة المتحدة'),
(67283, 3276039664, 3276039943, 'FR', 'FRA', 'فرنسا'),
(67284, 3276039944, 3276039951, 'GB', 'GBR', 'المملكة المتحدة'),
(67285, 3276039952, 3276039967, 'FR', 'FRA', 'فرنسا'),
(67286, 3276039968, 3276040031, 'GB', 'GBR', 'المملكة المتحدة'),
(67287, 3276040032, 3276040063, 'FR', 'FRA', 'فرنسا'),
(67288, 3276040064, 3276040095, 'GB', 'GBR', 'المملكة المتحدة'),
(67289, 3276040096, 3276040159, 'FR', 'FRA', 'فرنسا'),
(67290, 3276040160, 3276040175, 'GB', 'GBR', 'المملكة المتحدة'),
(67291, 3276040176, 3276040207, 'FR', 'FRA', 'فرنسا'),
(67292, 3276040208, 3276040215, 'GB', 'GBR', 'المملكة المتحدة'),
(67293, 3276040216, 3276040231, 'FR', 'FRA', 'فرنسا'),
(67294, 3276040232, 3276040239, 'GB', 'GBR', 'المملكة المتحدة'),
(67295, 3276040240, 3276040319, 'FR', 'FRA', 'فرنسا'),
(67296, 3276040320, 3276040327, 'GB', 'GBR', 'المملكة المتحدة'),
(67297, 3276040328, 3276040335, 'FR', 'FRA', 'فرنسا'),
(67298, 3276040336, 3276040343, 'GB', 'GBR', 'المملكة المتحدة'),
(67299, 3276040344, 3276040351, 'FR', 'FRA', 'فرنسا'),
(67300, 3276040352, 3276040367, 'GB', 'GBR', 'المملكة المتحدة'),
(67301, 3276040368, 3276040439, 'FR', 'FRA', 'فرنسا'),
(67302, 3276040440, 3276040463, 'GB', 'GBR', 'المملكة المتحدة'),
(67303, 3276040464, 3276040479, 'FR', 'FRA', 'فرنسا'),
(67304, 3276040480, 3276040495, 'GB', 'GBR', 'المملكة المتحدة'),
(67305, 3276040496, 3276040543, 'FR', 'FRA', 'فرنسا'),
(67306, 3276040544, 3276040575, 'GB', 'GBR', 'المملكة المتحدة'),
(67307, 3276040576, 3276040591, 'FR', 'FRA', 'فرنسا'),
(67308, 3276040592, 3276040607, 'GB', 'GBR', 'المملكة المتحدة'),
(67309, 3276040608, 3276040639, 'FR', 'FRA', 'فرنسا'),
(67310, 3276040640, 3276040671, 'GB', 'GBR', 'المملكة المتحدة'),
(67311, 3276040672, 3276040879, 'FR', 'FRA', 'فرنسا'),
(67312, 3276040880, 3276040895, 'GB', 'GBR', 'المملكة المتحدة'),
(67313, 3276040896, 3276040991, 'FR', 'FRA', 'فرنسا'),
(67314, 3276040992, 3276041007, 'GB', 'GBR', 'المملكة المتحدة'),
(67315, 3276041008, 3276041071, 'FR', 'FRA', 'فرنسا'),
(67316, 3276041072, 3276041087, 'GB', 'GBR', 'المملكة المتحدة'),
(67317, 3276041088, 3276041199, 'FR', 'FRA', 'فرنسا'),
(67318, 3276041200, 3276041215, 'GB', 'GBR', 'المملكة المتحدة'),
(67319, 3276041216, 3276041279, 'FR', 'FRA', 'فرنسا'),
(67320, 3276041280, 3276041311, 'GB', 'GBR', 'المملكة المتحدة'),
(67321, 3276041312, 3276041391, 'FR', 'FRA', 'فرنسا'),
(67322, 3276041392, 3276041407, 'GB', 'GBR', 'المملكة المتحدة'),
(67323, 3276041408, 3276041487, 'FR', 'FRA', 'فرنسا'),
(67324, 3276041488, 3276041503, 'GB', 'GBR', 'المملكة المتحدة'),
(67325, 3276041504, 3276041519, 'FR', 'FRA', 'فرنسا'),
(67326, 3276041520, 3276041535, 'GB', 'GBR', 'المملكة المتحدة'),
(67327, 3276041536, 3276041551, 'FR', 'FRA', 'فرنسا'),
(67328, 3276041552, 3276041599, 'GB', 'GBR', 'المملكة المتحدة'),
(67329, 3276041600, 3276041759, 'FR', 'FRA', 'فرنسا'),
(67330, 3276041760, 3276041775, 'GB', 'GBR', 'المملكة المتحدة'),
(67331, 3276041776, 3276041839, 'FR', 'FRA', 'فرنسا'),
(67332, 3276041840, 3276041887, 'GB', 'GBR', 'المملكة المتحدة'),
(67333, 3276041888, 3276041919, 'FR', 'FRA', 'فرنسا'),
(67334, 3276041920, 3276041951, 'GB', 'GBR', 'المملكة المتحدة'),
(67335, 3276041952, 3276041967, 'FR', 'FRA', 'فرنسا'),
(67336, 3276041968, 3276041983, 'GB', 'GBR', 'المملكة المتحدة'),
(67337, 3276041984, 3276041999, 'FR', 'FRA', 'فرنسا'),
(67338, 3276042000, 3276042007, 'GB', 'GBR', 'المملكة المتحدة'),
(67339, 3276042008, 3276042015, 'FR', 'FRA', 'فرنسا'),
(67340, 3276042016, 3276042047, 'GB', 'GBR', 'المملكة المتحدة'),
(67341, 3276042048, 3276042111, 'FR', 'FRA', 'فرنسا'),
(67342, 3276042112, 3276042143, 'GB', 'GBR', 'المملكة المتحدة'),
(67343, 3276042144, 3276042175, 'FR', 'FRA', 'فرنسا'),
(67344, 3276042176, 3276042191, 'GB', 'GBR', 'المملكة المتحدة'),
(67345, 3276042192, 3276042207, 'FR', 'FRA', 'فرنسا'),
(67346, 3276042208, 3276042239, 'GB', 'GBR', 'المملكة المتحدة'),
(67347, 3276042240, 3276042767, 'FR', 'FRA', 'فرنسا'),
(67348, 3276042768, 3276042799, 'GB', 'GBR', 'المملكة المتحدة'),
(67349, 3276042800, 3276042831, 'FR', 'FRA', 'فرنسا'),
(67350, 3276042832, 3276042847, 'GB', 'GBR', 'المملكة المتحدة'),
(67351, 3276042848, 3276043519, 'FR', 'FRA', 'فرنسا'),
(67352, 3276043520, 3276043731, 'GB', 'GBR', 'المملكة المتحدة'),
(67353, 3276043732, 3276043735, 'FR', 'FRA', 'فرنسا'),
(67354, 3276043736, 3276043775, 'GB', 'GBR', 'المملكة المتحدة'),
(67355, 3276043776, 3276044303, 'FR', 'FRA', 'فرنسا'),
(67356, 3276044304, 3276044319, 'GB', 'GBR', 'المملكة المتحدة'),
(67357, 3276044320, 3276044351, 'FR', 'FRA', 'فرنسا'),
(67358, 3276044352, 3276044359, 'GB', 'GBR', 'المملكة المتحدة'),
(67359, 3276044360, 3276044367, 'FR', 'FRA', 'فرنسا'),
(67360, 3276044368, 3276044375, 'GB', 'GBR', 'المملكة المتحدة'),
(67361, 3276044376, 3276044447, 'FR', 'FRA', 'فرنسا'),
(67362, 3276044448, 3276044463, 'GB', 'GBR', 'المملكة المتحدة'),
(67363, 3276044464, 3276044479, 'FR', 'FRA', 'فرنسا'),
(67364, 3276044480, 3276044495, 'GB', 'GBR', 'المملكة المتحدة'),
(67365, 3276044496, 3276044511, 'FR', 'FRA', 'فرنسا'),
(67366, 3276044512, 3276044543, 'GB', 'GBR', 'المملكة المتحدة'),
(67367, 3276044544, 3276044607, 'FR', 'FRA', 'فرنسا'),
(67368, 3276044608, 3276044639, 'GB', 'GBR', 'المملكة المتحدة'),
(67369, 3276044640, 3276044671, 'FR', 'FRA', 'فرنسا'),
(67370, 3276044672, 3276044703, 'GB', 'GBR', 'المملكة المتحدة'),
(67371, 3276044704, 3276044735, 'FR', 'FRA', 'فرنسا'),
(67372, 3276044736, 3276044799, 'GB', 'GBR', 'المملكة المتحدة'),
(67373, 3276044800, 3276044815, 'FR', 'FRA', 'فرنسا'),
(67374, 3276044816, 3276044831, 'GB', 'GBR', 'المملكة المتحدة'),
(67375, 3276044832, 3276044863, 'FR', 'FRA', 'فرنسا'),
(67376, 3276044864, 3276044879, 'GB', 'GBR', 'المملكة المتحدة'),
(67377, 3276044880, 3276044927, 'FR', 'FRA', 'فرنسا'),
(67378, 3276044928, 3276044943, 'GB', 'GBR', 'المملكة المتحدة'),
(67379, 3276044944, 3276044959, 'FR', 'FRA', 'فرنسا'),
(67380, 3276044960, 3276044967, 'GB', 'GBR', 'المملكة المتحدة'),
(67381, 3276044968, 3276044991, 'FR', 'FRA', 'فرنسا'),
(67382, 3276044992, 3276044999, 'GB', 'GBR', 'المملكة المتحدة'),
(67383, 3276045000, 3276045023, 'FR', 'FRA', 'فرنسا'),
(67384, 3276045024, 3276045039, 'GB', 'GBR', 'المملكة المتحدة'),
(67385, 3276045040, 3276045055, 'FR', 'FRA', 'فرنسا'),
(67386, 3276045056, 3276045071, 'GB', 'GBR', 'المملكة المتحدة'),
(67387, 3276045072, 3276045119, 'FR', 'FRA', 'فرنسا'),
(67388, 3276045120, 3276045127, 'GB', 'GBR', 'المملكة المتحدة'),
(67389, 3276045128, 3276045135, 'FR', 'FRA', 'فرنسا'),
(67390, 3276045136, 3276045151, 'GB', 'GBR', 'المملكة المتحدة'),
(67391, 3276045152, 3276045183, 'FR', 'FRA', 'فرنسا'),
(67392, 3276045184, 3276045199, 'GB', 'GBR', 'المملكة المتحدة'),
(67393, 3276045200, 3276045223, 'FR', 'FRA', 'فرنسا'),
(67394, 3276045224, 3276045239, 'GB', 'GBR', 'المملكة المتحدة'),
(67395, 3276045240, 3276045255, 'FR', 'FRA', 'فرنسا'),
(67396, 3276045256, 3276045271, 'GB', 'GBR', 'المملكة المتحدة'),
(67397, 3276045272, 3276045287, 'FR', 'FRA', 'فرنسا'),
(67398, 3276045288, 3276045311, 'GB', 'GBR', 'المملكة المتحدة'),
(67399, 3276045312, 3276045351, 'FR', 'FRA', 'فرنسا'),
(67400, 3276045352, 3276045359, 'GB', 'GBR', 'المملكة المتحدة'),
(67401, 3276045360, 3276045455, 'FR', 'FRA', 'فرنسا'),
(67402, 3276045456, 3276045463, 'GB', 'GBR', 'المملكة المتحدة'),
(67403, 3276045464, 3276045479, 'FR', 'FRA', 'فرنسا'),
(67404, 3276045480, 3276045487, 'GB', 'GBR', 'المملكة المتحدة'),
(67405, 3276045488, 3276045543, 'FR', 'FRA', 'فرنسا'),
(67406, 3276045544, 3276045551, 'GB', 'GBR', 'المملكة المتحدة'),
(67407, 3276045552, 3276045567, 'FR', 'FRA', 'فرنسا'),
(67408, 3276045568, 3276045599, 'GB', 'GBR', 'المملكة المتحدة'),
(67409, 3276045600, 3276045631, 'FR', 'FRA', 'فرنسا'),
(67410, 3276045632, 3276045647, 'GB', 'GBR', 'المملكة المتحدة'),
(67411, 3276045648, 3276045767, 'FR', 'FRA', 'فرنسا'),
(67412, 3276045768, 3276045783, 'GB', 'GBR', 'المملكة المتحدة'),
(67413, 3276045784, 3276045815, 'FR', 'FRA', 'فرنسا'),
(67414, 3276045816, 3276045823, 'GB', 'GBR', 'المملكة المتحدة'),
(67415, 3276045824, 3276045919, 'FR', 'FRA', 'فرنسا'),
(67416, 3276045920, 3276045951, 'GB', 'GBR', 'المملكة المتحدة'),
(67417, 3276045952, 3276046335, 'FR', 'FRA', 'فرنسا'),
(67418, 3276046336, 3276062719, 'RU', 'RUS', 'الإتحاد الروسي'),
(67419, 3276062720, 3276063231, 'PL', 'POL', 'بولندا'),
(67420, 3276063232, 3276063743, 'FR', 'FRA', 'فرنسا'),
(67421, 3276063744, 3276064255, 'UA', 'UKR', 'أوكرانيا'),
(67422, 3276064256, 3276064767, 'DE', 'DEU', 'ألمانيا'),
(67423, 3276064768, 3276065279, 'BG', 'BGR', 'بلغاريا'),
(67424, 3276065280, 3276065791, 'UA', 'UKR', 'أوكرانيا'),
(67425, 3276065792, 3276066303, 'DE', 'DEU', 'ألمانيا'),
(67426, 3276066304, 3276066815, 'GB', 'GBR', 'المملكة المتحدة'),
(67427, 3276066816, 3276067327, 'PS', 'PSE', 'فلسطين المحتلة'),
(67428, 3276067328, 3276067839, 'UA', 'UKR', 'أوكرانيا'),
(67429, 3276067840, 3276068351, 'AT', 'AUT', 'النمسا'),
(67430, 3276068352, 3276068863, 'BG', 'BGR', 'بلغاريا'),
(67431, 3276068864, 3276069887, 'UA', 'UKR', 'أوكرانيا'),
(67432, 3276069888, 3276070399, 'GB', 'GBR', 'المملكة المتحدة'),
(67433, 3276070400, 3276070911, 'UA', 'UKR', 'أوكرانيا'),
(67434, 3276070912, 3276071423, 'GB', 'GBR', 'المملكة المتحدة'),
(67435, 3276071424, 3276071935, 'PL', 'POL', 'بولندا'),
(67436, 3276071936, 3276072447, 'GB', 'GBR', 'المملكة المتحدة'),
(67437, 3276072448, 3276072959, 'SK', 'SVK', 'سلوفاكيا'),
(67438, 3276072960, 3276073471, 'PL', 'POL', 'بولندا'),
(67439, 3276073472, 3276073983, 'SK', 'SVK', 'سلوفاكيا'),
(67440, 3276073984, 3276074495, 'DE', 'DEU', 'ألمانيا'),
(67441, 3276074496, 3276075007, 'GB', 'GBR', 'المملكة المتحدة'),
(67442, 3276075008, 3276075519, 'RU', 'RUS', 'الإتحاد الروسي'),
(67443, 3276075520, 3276076031, 'DE', 'DEU', 'ألمانيا'),
(67444, 3276076032, 3276076543, 'GB', 'GBR', 'المملكة المتحدة'),
(67445, 3276076544, 3276077055, 'DE', 'DEU', 'ألمانيا'),
(67446, 3276077056, 3276077567, 'UA', 'UKR', 'أوكرانيا'),
(67447, 3276077568, 3276078079, 'FR', 'FRA', 'فرنسا'),
(67448, 3276078080, 3276078591, 'RU', 'RUS', 'الإتحاد الروسي'),
(67449, 3276078592, 3276079103, 'GB', 'GBR', 'المملكة المتحدة'),
(67450, 3276079104, 3276095487, 'NO', 'NOR', 'النرويج'),
(67451, 3276095488, 3276096511, 'RU', 'RUS', 'الإتحاد الروسي'),
(67452, 3276096512, 3276097535, 'IT', 'ITA', 'إيطاليا'),
(67453, 3276097536, 3276098559, 'NL', 'NLD', 'هولندا'),
(67454, 3276098560, 3276099583, 'UA', 'UKR', 'أوكرانيا'),
(67455, 3276099584, 3276100607, 'PL', 'POL', 'بولندا'),
(67456, 3276100608, 3276101631, 'UA', 'UKR', 'أوكرانيا'),
(67457, 3276101632, 3276102655, 'LV', 'LVA', 'لاتفيا'),
(67458, 3276102656, 3276103679, 'GB', 'GBR', 'المملكة المتحدة'),
(67459, 3276103680, 3276104703, 'SI', 'SVN', 'سلوفينيا'),
(67460, 3276104704, 3276105727, 'RU', 'RUS', 'الإتحاد الروسي'),
(67461, 3276105728, 3276106751, 'AT', 'AUT', 'النمسا'),
(67462, 3276106752, 3276107775, 'BG', 'BGR', 'بلغاريا'),
(67463, 3276107776, 3276108799, 'DE', 'DEU', 'ألمانيا'),
(67464, 3276108800, 3276109823, 'SE', 'SWE', 'السويد'),
(67465, 3276109824, 3276110847, 'BG', 'BGR', 'بلغاريا'),
(67466, 3276110848, 3276111871, 'PL', 'POL', 'بولندا'),
(67467, 3276111872, 3276112895, 'DK', 'DNK', 'الدنيمارك'),
(67468, 3276112896, 3276114943, 'UA', 'UKR', 'أوكرانيا'),
(67469, 3276114944, 3276115967, 'KW', 'KWT', 'الكويت'),
(67470, 3276115968, 3276116991, 'NL', 'NLD', 'هولندا'),
(67471, 3276116992, 3276118015, 'RU', 'RUS', 'الإتحاد الروسي'),
(67472, 3276118016, 3276119039, 'GB', 'GBR', 'المملكة المتحدة'),
(67473, 3276119040, 3276120063, 'RU', 'RUS', 'الإتحاد الروسي'),
(67474, 3276120064, 3276121087, 'GB', 'GBR', 'المملكة المتحدة'),
(67475, 3276121088, 3276122111, 'BG', 'BGR', 'بلغاريا'),
(67476, 3276122112, 3276123135, 'RU', 'RUS', 'الإتحاد الروسي'),
(67477, 3276123136, 3276124159, 'AT', 'AUT', 'النمسا'),
(67478, 3276124160, 3276125183, 'UA', 'UKR', 'أوكرانيا'),
(67479, 3276125184, 3276126207, 'AT', 'AUT', 'النمسا'),
(67480, 3276126208, 3276127231, 'UA', 'UKR', 'أوكرانيا'),
(67481, 3276127232, 3276128255, 'UZ', 'UZB', 'أوزباكستان'),
(67482, 3276128256, 3276129279, 'AT', 'AUT', 'النمسا'),
(67483, 3276129280, 3276131327, 'UA', 'UKR', 'أوكرانيا'),
(67484, 3276131328, 3276132351, 'DK', 'DNK', 'الدنيمارك'),
(67485, 3276133376, 3276134399, 'GB', 'GBR', 'المملكة المتحدة'),
(67486, 3276134400, 3276135423, 'RU', 'RUS', 'الإتحاد الروسي'),
(67487, 3276135424, 3276136447, 'UA', 'UKR', 'أوكرانيا'),
(67488, 3276136448, 3276138495, 'PL', 'POL', 'بولندا'),
(67489, 3276138496, 3276139519, 'NL', 'NLD', 'هولندا'),
(67490, 3276140544, 3276141567, 'DE', 'DEU', 'ألمانيا'),
(67491, 3276141568, 3276143615, 'UA', 'UKR', 'أوكرانيا'),
(67492, 3276143616, 3276144639, 'GB', 'GBR', 'المملكة المتحدة'),
(67493, 3276144640, 3276152831, 'CH', 'CHE', 'سويسرا'),
(67494, 3276152832, 3276161023, 'HU', 'HUN', 'هنغاريا'),
(67495, 3276161024, 3276169215, 'GB', 'GBR', 'المملكة المتحدة'),
(67496, 3276169216, 3276177407, 'AT', 'AUT', 'النمسا'),
(67497, 3276177408, 3276185599, 'CZ', 'CZE', 'التشيك'),
(67498, 3276185600, 3276193791, 'NO', 'NOR', 'النرويج'),
(67499, 3276193792, 3276201983, 'RU', 'RUS', 'الإتحاد الروسي'),
(67500, 3276201984, 3276210175, 'AT', 'AUT', 'النمسا'),
(67501, 3276210176, 3276227607, 'DE', 'DEU', 'ألمانيا'),
(67502, 3276227608, 3276227615, 'MT', 'MLT', 'مالطا'),
(67503, 3276227616, 3276227727, 'DE', 'DEU', 'ألمانيا'),
(67504, 3276227728, 3276227743, 'MT', 'MLT', 'مالطا'),
(67505, 3276227744, 3276234303, 'DE', 'DEU', 'ألمانيا'),
(67506, 3276234304, 3276234367, 'GB', 'GBR', 'المملكة المتحدة'),
(67507, 3276234368, 3276235519, 'DE', 'DEU', 'ألمانيا'),
(67508, 3276235520, 3276235583, 'NL', 'NLD', 'هولندا'),
(67509, 3276235584, 3276241759, 'DE', 'DEU', 'ألمانيا'),
(67510, 3276241760, 3276241767, 'FR', 'FRA', 'فرنسا'),
(67511, 3276241768, 3276242871, 'DE', 'DEU', 'ألمانيا'),
(67512, 3276242872, 3276242879, 'NL', 'NLD', 'هولندا'),
(67513, 3276242880, 3276244351, 'DE', 'DEU', 'ألمانيا'),
(67514, 3276244352, 3276244367, 'NL', 'NLD', 'هولندا'),
(67515, 3276244368, 3276244447, 'DE', 'DEU', 'ألمانيا'),
(67516, 3276244448, 3276244479, 'RO', 'ROM', 'رومانيا'),
(67517, 3276244480, 3276249279, 'DE', 'DEU', 'ألمانيا'),
(67518, 3276249280, 3276249287, 'FR', 'FRA', 'فرنسا'),
(67519, 3276249288, 3276249855, 'DE', 'DEU', 'ألمانيا'),
(67520, 3276249856, 3276249983, 'GB', 'GBR', 'المملكة المتحدة'),
(67521, 3276249984, 3276250079, 'DE', 'DEU', 'ألمانيا'),
(67522, 3276250080, 3276250095, 'FR', 'FRA', 'فرنسا'),
(67523, 3276250096, 3276275711, 'DE', 'DEU', 'ألمانيا'),
(67524, 3276275712, 3276283903, 'SK', 'SVK', 'سلوفاكيا'),
(67525, 3276283904, 3276292095, 'GB', 'GBR', 'المملكة المتحدة'),
(67526, 3276292096, 3276292479, 'BE', 'BEL', 'بلجيكا'),
(67527, 3276292480, 3276292511, 'LU', 'LUX', 'لوكسيمبورغ'),
(67528, 3276292512, 3276299295, 'BE', 'BEL', 'بلجيكا'),
(67529, 3276299296, 3276299327, 'CH', 'CHE', 'سويسرا'),
(67530, 3276299328, 3276300287, 'BE', 'BEL', 'بلجيكا'),
(67531, 3276300288, 3276304383, 'DE', 'DEU', 'ألمانيا'),
(67532, 3276304384, 3276304639, 'BG', 'BGR', 'بلغاريا'),
(67533, 3276304640, 3276305407, 'GB', 'GBR', 'المملكة المتحدة'),
(67534, 3276305408, 3276308479, 'IL', 'ISR', 'إسرائيل'),
(67535, 3276308480, 3276309503, 'GB', 'GBR', 'المملكة المتحدة'),
(67536, 3276309504, 3276310527, 'AT', 'AUT', 'النمسا'),
(67537, 3276310528, 3276311551, 'PT', 'PRT', 'البورتوغال'),
(67538, 3276311552, 3276312575, 'RU', 'RUS', 'الإتحاد الروسي'),
(67539, 3276312576, 3276313599, 'UA', 'UKR', 'أوكرانيا'),
(67540, 3276313600, 3276314623, 'PL', 'POL', 'بولندا'),
(67541, 3276314624, 3276315647, 'FR', 'FRA', 'فرنسا'),
(67542, 3276315648, 3276316671, 'UA', 'UKR', 'أوكرانيا'),
(67543, 3276316672, 3276324863, 'GB', 'GBR', 'المملكة المتحدة'),
(67544, 3276324864, 3276333055, 'IT', 'ITA', 'إيطاليا'),
(67545, 3276333056, 3276341247, 'RU', 'RUS', 'الإتحاد الروسي'),
(67546, 3276341248, 3276341263, 'NL', 'NLD', 'هولندا'),
(67547, 3276341264, 3276341279, 'DE', 'DEU', 'ألمانيا'),
(67548, 3276341280, 3276341535, 'NL', 'NLD', 'هولندا'),
(67549, 3276341536, 3276341543, 'DE', 'DEU', 'ألمانيا'),
(67550, 3276341544, 3276341655, 'NL', 'NLD', 'هولندا'),
(67551, 3276341656, 3276341663, 'DE', 'DEU', 'ألمانيا'),
(67552, 3276341664, 3276341679, 'NL', 'NLD', 'هولندا'),
(67553, 3276341680, 3276341695, 'DE', 'DEU', 'ألمانيا'),
(67554, 3276341696, 3276341735, 'NL', 'NLD', 'هولندا'),
(67555, 3276341736, 3276341743, 'DE', 'DEU', 'ألمانيا'),
(67556, 3276341744, 3276341767, 'NL', 'NLD', 'هولندا'),
(67557, 3276341768, 3276341775, 'DE', 'DEU', 'ألمانيا'),
(67558, 3276341776, 3276341823, 'NL', 'NLD', 'هولندا'),
(67559, 3276341824, 3276341831, 'DE', 'DEU', 'ألمانيا'),
(67560, 3276341832, 3276341879, 'NL', 'NLD', 'هولندا'),
(67561, 3276341880, 3276341887, 'DE', 'DEU', 'ألمانيا'),
(67562, 3276341888, 3276341975, 'NL', 'NLD', 'هولندا'),
(67563, 3276341976, 3276341983, 'DE', 'DEU', 'ألمانيا'),
(67564, 3276341984, 3276342119, 'NL', 'NLD', 'هولندا'),
(67565, 3276342120, 3276342127, 'DE', 'DEU', 'ألمانيا'),
(67566, 3276342128, 3276342191, 'NL', 'NLD', 'هولندا'),
(67567, 3276342192, 3276342199, 'DE', 'DEU', 'ألمانيا'),
(67568, 3276342200, 3276342247, 'NL', 'NLD', 'هولندا'),
(67569, 3276342248, 3276342255, 'DE', 'DEU', 'ألمانيا'),
(67570, 3276342256, 3276342383, 'NL', 'NLD', 'هولندا'),
(67571, 3276342384, 3276342391, 'DE', 'DEU', 'ألمانيا'),
(67572, 3276342392, 3276342495, 'NL', 'NLD', 'هولندا'),
(67573, 3276342496, 3276342503, 'DE', 'DEU', 'ألمانيا'),
(67574, 3276342504, 3276342535, 'NL', 'NLD', 'هولندا'),
(67575, 3276342536, 3276342551, 'DE', 'DEU', 'ألمانيا'),
(67576, 3276342552, 3276342583, 'NL', 'NLD', 'هولندا'),
(67577, 3276342584, 3276342591, 'DE', 'DEU', 'ألمانيا'),
(67578, 3276342592, 3276342671, 'NL', 'NLD', 'هولندا'),
(67579, 3276342672, 3276342679, 'DE', 'DEU', 'ألمانيا'),
(67580, 3276342680, 3276342703, 'NL', 'NLD', 'هولندا'),
(67581, 3276342704, 3276342719, 'DE', 'DEU', 'ألمانيا'),
(67582, 3276342720, 3276342767, 'NL', 'NLD', 'هولندا'),
(67583, 3276342768, 3276342783, 'DE', 'DEU', 'ألمانيا'),
(67584, 3276342784, 3276342831, 'NL', 'NLD', 'هولندا'),
(67585, 3276342832, 3276342839, 'DE', 'DEU', 'ألمانيا'),
(67586, 3276342840, 3276342847, 'NL', 'NLD', 'هولندا'),
(67587, 3276342848, 3276342863, 'DE', 'DEU', 'ألمانيا'),
(67588, 3276342864, 3276342991, 'NL', 'NLD', 'هولندا'),
(67589, 3276342992, 3276342999, 'DE', 'DEU', 'ألمانيا'),
(67590, 3276343000, 3276343039, 'NL', 'NLD', 'هولندا'),
(67591, 3276343040, 3276343047, 'DE', 'DEU', 'ألمانيا'),
(67592, 3276343048, 3276343055, 'NL', 'NLD', 'هولندا'),
(67593, 3276343056, 3276343063, 'DE', 'DEU', 'ألمانيا'),
(67594, 3276343064, 3276343071, 'NL', 'NLD', 'هولندا'),
(67595, 3276343072, 3276343079, 'DE', 'DEU', 'ألمانيا'),
(67596, 3276343080, 3276343087, 'NL', 'NLD', 'هولندا'),
(67597, 3276343088, 3276343095, 'DE', 'DEU', 'ألمانيا'),
(67598, 3276343096, 3276343231, 'NL', 'NLD', 'هولندا'),
(67599, 3276343232, 3276343239, 'DE', 'DEU', 'ألمانيا'),
(67600, 3276343240, 3276343247, 'NL', 'NLD', 'هولندا'),
(67601, 3276343248, 3276343255, 'DE', 'DEU', 'ألمانيا'),
(67602, 3276343256, 3276343287, 'NL', 'NLD', 'هولندا'),
(67603, 3276343288, 3276343295, 'DE', 'DEU', 'ألمانيا'),
(67604, 3276343296, 3276343359, 'NL', 'NLD', 'هولندا'),
(67605, 3276343360, 3276343367, 'DE', 'DEU', 'ألمانيا'),
(67606, 3276343368, 3276343391, 'NL', 'NLD', 'هولندا'),
(67607, 3276343392, 3276343399, 'DE', 'DEU', 'ألمانيا'),
(67608, 3276343400, 3276343423, 'NL', 'NLD', 'هولندا'),
(67609, 3276343424, 3276343447, 'DE', 'DEU', 'ألمانيا'),
(67610, 3276343448, 3276343463, 'NL', 'NLD', 'هولندا'),
(67611, 3276343464, 3276343479, 'DE', 'DEU', 'ألمانيا'),
(67612, 3276343480, 3276343487, 'NL', 'NLD', 'هولندا'),
(67613, 3276343488, 3276343495, 'DE', 'DEU', 'ألمانيا'),
(67614, 3276343496, 3276343511, 'NL', 'NLD', 'هولندا'),
(67615, 3276343512, 3276343519, 'DE', 'DEU', 'ألمانيا'),
(67616, 3276343520, 3276343551, 'NL', 'NLD', 'هولندا'),
(67617, 3276343552, 3276343815, 'DE', 'DEU', 'ألمانيا'),
(67618, 3276343816, 3276343831, 'NL', 'NLD', 'هولندا'),
(67619, 3276343832, 3276343839, 'DE', 'DEU', 'ألمانيا'),
(67620, 3276343840, 3276343871, 'NL', 'NLD', 'هولندا'),
(67621, 3276343872, 3276343879, 'DE', 'DEU', 'ألمانيا'),
(67622, 3276343880, 3276343903, 'NL', 'NLD', 'هولندا'),
(67623, 3276343904, 3276343911, 'DE', 'DEU', 'ألمانيا'),
(67624, 3276343912, 3276344047, 'NL', 'NLD', 'هولندا'),
(67625, 3276344048, 3276344055, 'DE', 'DEU', 'ألمانيا'),
(67626, 3276344056, 3276344063, 'NL', 'NLD', 'هولندا'),
(67627, 3276344064, 3276344071, 'DE', 'DEU', 'ألمانيا'),
(67628, 3276344072, 3276344111, 'NL', 'NLD', 'هولندا'),
(67629, 3276344112, 3276344119, 'DE', 'DEU', 'ألمانيا'),
(67630, 3276344120, 3276344215, 'NL', 'NLD', 'هولندا'),
(67631, 3276344216, 3276344223, 'DE', 'DEU', 'ألمانيا'),
(67632, 3276344224, 3276344303, 'NL', 'NLD', 'هولندا'),
(67633, 3276344304, 3276344319, 'DE', 'DEU', 'ألمانيا'),
(67634, 3276344320, 3276344391, 'NL', 'NLD', 'هولندا'),
(67635, 3276344392, 3276344399, 'DE', 'DEU', 'ألمانيا'),
(67636, 3276344400, 3276344415, 'NL', 'NLD', 'هولندا'),
(67637, 3276344416, 3276344423, 'DE', 'DEU', 'ألمانيا'),
(67638, 3276344424, 3276344471, 'NL', 'NLD', 'هولندا'),
(67639, 3276344472, 3276344479, 'DE', 'DEU', 'ألمانيا'),
(67640, 3276344480, 3276344551, 'NL', 'NLD', 'هولندا'),
(67641, 3276344552, 3276344559, 'DE', 'DEU', 'ألمانيا'),
(67642, 3276344560, 3276344575, 'NL', 'NLD', 'هولندا'),
(67643, 3276344576, 3276344583, 'DE', 'DEU', 'ألمانيا'),
(67644, 3276344584, 3276344623, 'NL', 'NLD', 'هولندا'),
(67645, 3276344624, 3276344631, 'DE', 'DEU', 'ألمانيا'),
(67646, 3276344632, 3276344663, 'NL', 'NLD', 'هولندا'),
(67647, 3276344664, 3276344671, 'DE', 'DEU', 'ألمانيا'),
(67648, 3276344672, 3276344711, 'NL', 'NLD', 'هولندا'),
(67649, 3276344712, 3276344719, 'DE', 'DEU', 'ألمانيا'),
(67650, 3276344720, 3276344727, 'NL', 'NLD', 'هولندا'),
(67651, 3276344728, 3276344759, 'DE', 'DEU', 'ألمانيا'),
(67652, 3276344760, 3276344799, 'NL', 'NLD', 'هولندا'),
(67653, 3276344800, 3276344807, 'DE', 'DEU', 'ألمانيا'),
(67654, 3276344808, 3276344895, 'NL', 'NLD', 'هولندا'),
(67655, 3276344896, 3276344903, 'DE', 'DEU', 'ألمانيا'),
(67656, 3276344904, 3276344983, 'NL', 'NLD', 'هولندا'),
(67657, 3276344984, 3276344991, 'DE', 'DEU', 'ألمانيا'),
(67658, 3276344992, 3276345007, 'NL', 'NLD', 'هولندا'),
(67659, 3276345008, 3276345015, 'DE', 'DEU', 'ألمانيا'),
(67660, 3276345016, 3276345063, 'NL', 'NLD', 'هولندا'),
(67661, 3276345064, 3276345071, 'DE', 'DEU', 'ألمانيا'),
(67662, 3276345072, 3276345223, 'NL', 'NLD', 'هولندا'),
(67663, 3276345224, 3276345231, 'DE', 'DEU', 'ألمانيا'),
(67664, 3276345232, 3276345295, 'NL', 'NLD', 'هولندا'),
(67665, 3276345296, 3276345303, 'DE', 'DEU', 'ألمانيا'),
(67666, 3276345304, 3276345327, 'NL', 'NLD', 'هولندا'),
(67667, 3276345328, 3276345335, 'DE', 'DEU', 'ألمانيا'),
(67668, 3276345336, 3276345343, 'NL', 'NLD', 'هولندا'),
(67669, 3276345344, 3276345359, 'DE', 'DEU', 'ألمانيا'),
(67670, 3276345360, 3276345415, 'NL', 'NLD', 'هولندا'),
(67671, 3276345416, 3276345423, 'DE', 'DEU', 'ألمانيا'),
(67672, 3276345424, 3276345647, 'NL', 'NLD', 'هولندا'),
(67673, 3276345648, 3276345655, 'DE', 'DEU', 'ألمانيا'),
(67674, 3276345656, 3276345727, 'NL', 'NLD', 'هولندا'),
(67675, 3276345728, 3276345735, 'DE', 'DEU', 'ألمانيا'),
(67676, 3276345736, 3276345767, 'NL', 'NLD', 'هولندا'),
(67677, 3276345768, 3276345783, 'DE', 'DEU', 'ألمانيا'),
(67678, 3276345784, 3276345823, 'NL', 'NLD', 'هولندا'),
(67679, 3276345824, 3276345831, 'DE', 'DEU', 'ألمانيا'),
(67680, 3276345832, 3276345839, 'NL', 'NLD', 'هولندا'),
(67681, 3276345840, 3276345847, 'DE', 'DEU', 'ألمانيا'),
(67682, 3276345848, 3276345863, 'NL', 'NLD', 'هولندا'),
(67683, 3276345864, 3276345871, 'DE', 'DEU', 'ألمانيا'),
(67684, 3276345872, 3276345927, 'NL', 'NLD', 'هولندا'),
(67685, 3276345928, 3276345935, 'DE', 'DEU', 'ألمانيا'),
(67686, 3276345936, 3276346167, 'NL', 'NLD', 'هولندا'),
(67687, 3276346168, 3276346175, 'DE', 'DEU', 'ألمانيا'),
(67688, 3276346176, 3276346207, 'NL', 'NLD', 'هولندا'),
(67689, 3276346208, 3276346215, 'DE', 'DEU', 'ألمانيا'),
(67690, 3276346216, 3276346223, 'NL', 'NLD', 'هولندا'),
(67691, 3276346224, 3276346231, 'DE', 'DEU', 'ألمانيا'),
(67692, 3276346232, 3276346295, 'NL', 'NLD', 'هولندا'),
(67693, 3276346296, 3276346303, 'DE', 'DEU', 'ألمانيا'),
(67694, 3276346304, 3276346359, 'NL', 'NLD', 'هولندا'),
(67695, 3276346360, 3276346375, 'DE', 'DEU', 'ألمانيا'),
(67696, 3276346376, 3276346655, 'NL', 'NLD', 'هولندا'),
(67697, 3276346656, 3276346663, 'DE', 'DEU', 'ألمانيا'),
(67698, 3276346664, 3276346703, 'NL', 'NLD', 'هولندا'),
(67699, 3276346704, 3276346711, 'DE', 'DEU', 'ألمانيا'),
(67700, 3276346712, 3276346727, 'NL', 'NLD', 'هولندا'),
(67701, 3276346728, 3276346735, 'DE', 'DEU', 'ألمانيا'),
(67702, 3276346736, 3276346839, 'NL', 'NLD', 'هولندا'),
(67703, 3276346840, 3276346847, 'DE', 'DEU', 'ألمانيا'),
(67704, 3276346848, 3276346879, 'NL', 'NLD', 'هولندا'),
(67705, 3276346880, 3276346887, 'DE', 'DEU', 'ألمانيا'),
(67706, 3276346888, 3276346951, 'NL', 'NLD', 'هولندا'),
(67707, 3276346952, 3276346959, 'DE', 'DEU', 'ألمانيا'),
(67708, 3276346960, 3276347039, 'NL', 'NLD', 'هولندا'),
(67709, 3276347040, 3276347047, 'DE', 'DEU', 'ألمانيا'),
(67710, 3276347048, 3276347111, 'NL', 'NLD', 'هولندا'),
(67711, 3276347112, 3276347127, 'DE', 'DEU', 'ألمانيا'),
(67712, 3276347128, 3276347135, 'NL', 'NLD', 'هولندا'),
(67713, 3276347136, 3276347143, 'DE', 'DEU', 'ألمانيا'),
(67714, 3276347144, 3276347159, 'NL', 'NLD', 'هولندا'),
(67715, 3276347160, 3276347167, 'DE', 'DEU', 'ألمانيا'),
(67716, 3276347168, 3276347207, 'NL', 'NLD', 'هولندا'),
(67717, 3276347208, 3276347215, 'DE', 'DEU', 'ألمانيا'),
(67718, 3276347216, 3276347327, 'NL', 'NLD', 'هولندا'),
(67719, 3276347328, 3276347335, 'DE', 'DEU', 'ألمانيا'),
(67720, 3276347336, 3276347391, 'NL', 'NLD', 'هولندا'),
(67721, 3276347392, 3276347399, 'DE', 'DEU', 'ألمانيا'),
(67722, 3276347400, 3276347543, 'NL', 'NLD', 'هولندا'),
(67723, 3276347544, 3276347551, 'DE', 'DEU', 'ألمانيا'),
(67724, 3276347552, 3276347655, 'NL', 'NLD', 'هولندا'),
(67725, 3276347656, 3276347663, 'DE', 'DEU', 'ألمانيا'),
(67726, 3276347664, 3276347759, 'NL', 'NLD', 'هولندا'),
(67727, 3276347760, 3276347767, 'DE', 'DEU', 'ألمانيا'),
(67728, 3276347768, 3276347847, 'NL', 'NLD', 'هولندا'),
(67729, 3276347848, 3276347855, 'DE', 'DEU', 'ألمانيا'),
(67730, 3276347856, 3276347903, 'NL', 'NLD', 'هولندا'),
(67731, 3276347904, 3276347911, 'DE', 'DEU', 'ألمانيا'),
(67732, 3276347912, 3276347959, 'NL', 'NLD', 'هولندا'),
(67733, 3276347960, 3276347967, 'DE', 'DEU', 'ألمانيا'),
(67734, 3276347968, 3276347991, 'NL', 'NLD', 'هولندا'),
(67735, 3276347992, 3276347999, 'DE', 'DEU', 'ألمانيا'),
(67736, 3276348000, 3276348015, 'NL', 'NLD', 'هولندا'),
(67737, 3276348016, 3276348023, 'DE', 'DEU', 'ألمانيا'),
(67738, 3276348024, 3276348063, 'NL', 'NLD', 'هولندا'),
(67739, 3276348064, 3276348071, 'DE', 'DEU', 'ألمانيا'),
(67740, 3276348072, 3276348111, 'NL', 'NLD', 'هولندا'),
(67741, 3276348112, 3276348119, 'DE', 'DEU', 'ألمانيا'),
(67742, 3276348120, 3276348127, 'NL', 'NLD', 'هولندا'),
(67743, 3276348128, 3276348135, 'DE', 'DEU', 'ألمانيا'),
(67744, 3276348136, 3276348151, 'NL', 'NLD', 'هولندا'),
(67745, 3276348152, 3276348167, 'DE', 'DEU', 'ألمانيا'),
(67746, 3276348168, 3276348183, 'NL', 'NLD', 'هولندا'),
(67747, 3276348184, 3276348191, 'DE', 'DEU', 'ألمانيا'),
(67748, 3276348192, 3276348199, 'NL', 'NLD', 'هولندا'),
(67749, 3276348200, 3276348223, 'DE', 'DEU', 'ألمانيا'),
(67750, 3276348224, 3276348231, 'NL', 'NLD', 'هولندا'),
(67751, 3276348232, 3276348239, 'DE', 'DEU', 'ألمانيا'),
(67752, 3276348240, 3276348295, 'NL', 'NLD', 'هولندا'),
(67753, 3276348296, 3276348303, 'DE', 'DEU', 'ألمانيا'),
(67754, 3276348304, 3276348319, 'NL', 'NLD', 'هولندا'),
(67755, 3276348320, 3276348327, 'DE', 'DEU', 'ألمانيا'),
(67756, 3276348328, 3276348343, 'NL', 'NLD', 'هولندا'),
(67757, 3276348344, 3276348351, 'DE', 'DEU', 'ألمانيا'),
(67758, 3276348352, 3276348431, 'NL', 'NLD', 'هولندا'),
(67759, 3276348432, 3276348439, 'DE', 'DEU', 'ألمانيا'),
(67760, 3276348440, 3276348455, 'NL', 'NLD', 'هولندا'),
(67761, 3276348456, 3276348463, 'DE', 'DEU', 'ألمانيا'),
(67762, 3276348464, 3276348511, 'NL', 'NLD', 'هولندا'),
(67763, 3276348512, 3276348519, 'DE', 'DEU', 'ألمانيا'),
(67764, 3276348520, 3276348623, 'NL', 'NLD', 'هولندا'),
(67765, 3276348624, 3276348631, 'DE', 'DEU', 'ألمانيا'),
(67766, 3276348632, 3276348679, 'NL', 'NLD', 'هولندا'),
(67767, 3276348680, 3276348687, 'DE', 'DEU', 'ألمانيا'),
(67768, 3276348688, 3276348719, 'NL', 'NLD', 'هولندا'),
(67769, 3276348720, 3276348751, 'DE', 'DEU', 'ألمانيا'),
(67770, 3276348752, 3276348767, 'NL', 'NLD', 'هولندا'),
(67771, 3276348768, 3276348775, 'DE', 'DEU', 'ألمانيا'),
(67772, 3276348776, 3276348839, 'NL', 'NLD', 'هولندا'),
(67773, 3276348840, 3276348847, 'DE', 'DEU', 'ألمانيا'),
(67774, 3276348848, 3276349063, 'NL', 'NLD', 'هولندا'),
(67775, 3276349064, 3276349071, 'DE', 'DEU', 'ألمانيا'),
(67776, 3276349072, 3276349135, 'NL', 'NLD', 'هولندا'),
(67777, 3276349136, 3276349143, 'DE', 'DEU', 'ألمانيا'),
(67778, 3276349144, 3276349167, 'NL', 'NLD', 'هولندا'),
(67779, 3276349168, 3276349175, 'DE', 'DEU', 'ألمانيا'),
(67780, 3276349176, 3276349199, 'NL', 'NLD', 'هولندا'),
(67781, 3276349200, 3276349207, 'DE', 'DEU', 'ألمانيا'),
(67782, 3276349208, 3276349215, 'NL', 'NLD', 'هولندا'),
(67783, 3276349216, 3276349223, 'DE', 'DEU', 'ألمانيا'),
(67784, 3276349224, 3276349679, 'NL', 'NLD', 'هولندا'),
(67785, 3276349680, 3276349687, 'DE', 'DEU', 'ألمانيا'),
(67786, 3276349688, 3276349831, 'NL', 'NLD', 'هولندا'),
(67787, 3276349832, 3276349839, 'DE', 'DEU', 'ألمانيا'),
(67788, 3276349840, 3276349871, 'NL', 'NLD', 'هولندا'),
(67789, 3276349872, 3276349879, 'DE', 'DEU', 'ألمانيا'),
(67790, 3276349880, 3276349903, 'NL', 'NLD', 'هولندا'),
(67791, 3276349904, 3276349911, 'DE', 'DEU', 'ألمانيا'),
(67792, 3276349912, 3276349991, 'NL', 'NLD', 'هولندا'),
(67793, 3276349992, 3276349999, 'DE', 'DEU', 'ألمانيا'),
(67794, 3276350000, 3276350031, 'NL', 'NLD', 'هولندا'),
(67795, 3276350032, 3276350047, 'DE', 'DEU', 'ألمانيا'),
(67796, 3276350048, 3276350191, 'NL', 'NLD', 'هولندا'),
(67797, 3276350192, 3276350199, 'DE', 'DEU', 'ألمانيا'),
(67798, 3276350200, 3276350207, 'NL', 'NLD', 'هولندا'),
(67799, 3276350208, 3276350215, 'DE', 'DEU', 'ألمانيا'),
(67800, 3276350216, 3276350239, 'NL', 'NLD', 'هولندا'),
(67801, 3276350240, 3276350247, 'DE', 'DEU', 'ألمانيا'),
(67802, 3276350248, 3276350287, 'NL', 'NLD', 'هولندا'),
(67803, 3276350288, 3276350295, 'DE', 'DEU', 'ألمانيا'),
(67804, 3276350296, 3276350455, 'NL', 'NLD', 'هولندا'),
(67805, 3276350456, 3276350463, 'DE', 'DEU', 'ألمانيا'),
(67806, 3276350464, 3276350519, 'NL', 'NLD', 'هولندا'),
(67807, 3276350520, 3276350527, 'DE', 'DEU', 'ألمانيا'),
(67808, 3276350528, 3276350639, 'NL', 'NLD', 'هولندا'),
(67809, 3276350640, 3276350647, 'DE', 'DEU', 'ألمانيا'),
(67810, 3276350648, 3276350671, 'NL', 'NLD', 'هولندا'),
(67811, 3276350672, 3276350679, 'DE', 'DEU', 'ألمانيا'),
(67812, 3276350680, 3276350687, 'NL', 'NLD', 'هولندا'),
(67813, 3276350688, 3276350695, 'DE', 'DEU', 'ألمانيا'),
(67814, 3276350696, 3276350959, 'NL', 'NLD', 'هولندا'),
(67815, 3276350960, 3276350967, 'DE', 'DEU', 'ألمانيا'),
(67816, 3276350968, 3276350975, 'NL', 'NLD', 'هولندا'),
(67817, 3276350976, 3276350983, 'DE', 'DEU', 'ألمانيا'),
(67818, 3276350984, 3276351007, 'NL', 'NLD', 'هولندا'),
(67819, 3276351008, 3276351015, 'DE', 'DEU', 'ألمانيا'),
(67820, 3276351016, 3276351095, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(67821, 3276351096, 3276351103, 'DE', 'DEU', 'ألمانيا'),
(67822, 3276351104, 3276351119, 'NL', 'NLD', 'هولندا'),
(67823, 3276351120, 3276351135, 'DE', 'DEU', 'ألمانيا'),
(67824, 3276351136, 3276351191, 'NL', 'NLD', 'هولندا'),
(67825, 3276351192, 3276351199, 'DE', 'DEU', 'ألمانيا'),
(67826, 3276351200, 3276351215, 'NL', 'NLD', 'هولندا'),
(67827, 3276351216, 3276351223, 'DE', 'DEU', 'ألمانيا'),
(67828, 3276351224, 3276351311, 'NL', 'NLD', 'هولندا'),
(67829, 3276351312, 3276351319, 'DE', 'DEU', 'ألمانيا'),
(67830, 3276351320, 3276351383, 'NL', 'NLD', 'هولندا'),
(67831, 3276351384, 3276351391, 'DE', 'DEU', 'ألمانيا'),
(67832, 3276351392, 3276351535, 'NL', 'NLD', 'هولندا'),
(67833, 3276351536, 3276351543, 'DE', 'DEU', 'ألمانيا'),
(67834, 3276351544, 3276351559, 'NL', 'NLD', 'هولندا'),
(67835, 3276351560, 3276351567, 'DE', 'DEU', 'ألمانيا'),
(67836, 3276351568, 3276351575, 'NL', 'NLD', 'هولندا'),
(67837, 3276351576, 3276351583, 'DE', 'DEU', 'ألمانيا'),
(67838, 3276351584, 3276351591, 'NL', 'NLD', 'هولندا'),
(67839, 3276351592, 3276351599, 'DE', 'DEU', 'ألمانيا'),
(67840, 3276351600, 3276351607, 'NL', 'NLD', 'هولندا'),
(67841, 3276351608, 3276351623, 'DE', 'DEU', 'ألمانيا'),
(67842, 3276351624, 3276351647, 'NL', 'NLD', 'هولندا'),
(67843, 3276351648, 3276351655, 'DE', 'DEU', 'ألمانيا'),
(67844, 3276351656, 3276351703, 'NL', 'NLD', 'هولندا'),
(67845, 3276351704, 3276351711, 'DE', 'DEU', 'ألمانيا'),
(67846, 3276351712, 3276351727, 'NL', 'NLD', 'هولندا'),
(67847, 3276351728, 3276351735, 'DE', 'DEU', 'ألمانيا'),
(67848, 3276351736, 3276351775, 'NL', 'NLD', 'هولندا'),
(67849, 3276351776, 3276351783, 'DE', 'DEU', 'ألمانيا'),
(67850, 3276351784, 3276351791, 'NL', 'NLD', 'هولندا'),
(67851, 3276351792, 3276351799, 'DE', 'DEU', 'ألمانيا'),
(67852, 3276351800, 3276351807, 'NL', 'NLD', 'هولندا'),
(67853, 3276351808, 3276351815, 'DE', 'DEU', 'ألمانيا'),
(67854, 3276351816, 3276351879, 'NL', 'NLD', 'هولندا'),
(67855, 3276351880, 3276351887, 'DE', 'DEU', 'ألمانيا'),
(67856, 3276351888, 3276351967, 'NL', 'NLD', 'هولندا'),
(67857, 3276351968, 3276351975, 'DE', 'DEU', 'ألمانيا'),
(67858, 3276351976, 3276352167, 'NL', 'NLD', 'هولندا'),
(67859, 3276352168, 3276352175, 'DE', 'DEU', 'ألمانيا'),
(67860, 3276352176, 3276352279, 'NL', 'NLD', 'هولندا'),
(67861, 3276352280, 3276352287, 'DE', 'DEU', 'ألمانيا'),
(67862, 3276352288, 3276352335, 'NL', 'NLD', 'هولندا'),
(67863, 3276352336, 3276352343, 'DE', 'DEU', 'ألمانيا'),
(67864, 3276352344, 3276352399, 'NL', 'NLD', 'هولندا'),
(67865, 3276352400, 3276352407, 'DE', 'DEU', 'ألمانيا'),
(67866, 3276352408, 3276352511, 'NL', 'NLD', 'هولندا'),
(67867, 3276352512, 3276352519, 'DE', 'DEU', 'ألمانيا'),
(67868, 3276352520, 3276352655, 'NL', 'NLD', 'هولندا'),
(67869, 3276352656, 3276352663, 'DE', 'DEU', 'ألمانيا'),
(67870, 3276352664, 3276352695, 'NL', 'NLD', 'هولندا'),
(67871, 3276352696, 3276352703, 'DE', 'DEU', 'ألمانيا'),
(67872, 3276352704, 3276352767, 'NL', 'NLD', 'هولندا'),
(67873, 3276352768, 3276352775, 'DE', 'DEU', 'ألمانيا'),
(67874, 3276352776, 3276352783, 'NL', 'NLD', 'هولندا'),
(67875, 3276352784, 3276352791, 'DE', 'DEU', 'ألمانيا'),
(67876, 3276352792, 3276352831, 'NL', 'NLD', 'هولندا'),
(67877, 3276352832, 3276352839, 'DE', 'DEU', 'ألمانيا'),
(67878, 3276352840, 3276352911, 'NL', 'NLD', 'هولندا'),
(67879, 3276352912, 3276352935, 'DE', 'DEU', 'ألمانيا'),
(67880, 3276352936, 3276352943, 'NL', 'NLD', 'هولندا'),
(67881, 3276352944, 3276352951, 'DE', 'DEU', 'ألمانيا'),
(67882, 3276352952, 3276352959, 'NL', 'NLD', 'هولندا'),
(67883, 3276352960, 3276352967, 'DE', 'DEU', 'ألمانيا'),
(67884, 3276352968, 3276353039, 'NL', 'NLD', 'هولندا'),
(67885, 3276353040, 3276353047, 'DE', 'DEU', 'ألمانيا'),
(67886, 3276353048, 3276353079, 'NL', 'NLD', 'هولندا'),
(67887, 3276353080, 3276353087, 'DE', 'DEU', 'ألمانيا'),
(67888, 3276353088, 3276353143, 'NL', 'NLD', 'هولندا'),
(67889, 3276353144, 3276353151, 'DE', 'DEU', 'ألمانيا'),
(67890, 3276353152, 3276353207, 'NL', 'NLD', 'هولندا'),
(67891, 3276353208, 3276353215, 'DE', 'DEU', 'ألمانيا'),
(67892, 3276353216, 3276353295, 'NL', 'NLD', 'هولندا'),
(67893, 3276353296, 3276353303, 'DE', 'DEU', 'ألمانيا'),
(67894, 3276353304, 3276353343, 'NL', 'NLD', 'هولندا'),
(67895, 3276353344, 3276353351, 'DE', 'DEU', 'ألمانيا'),
(67896, 3276353352, 3276353359, 'NL', 'NLD', 'هولندا'),
(67897, 3276353360, 3276353367, 'DE', 'DEU', 'ألمانيا'),
(67898, 3276353368, 3276353655, 'NL', 'NLD', 'هولندا'),
(67899, 3276353656, 3276353663, 'DE', 'DEU', 'ألمانيا'),
(67900, 3276353664, 3276353687, 'NL', 'NLD', 'هولندا'),
(67901, 3276353688, 3276353695, 'DE', 'DEU', 'ألمانيا'),
(67902, 3276353696, 3276353711, 'NL', 'NLD', 'هولندا'),
(67903, 3276353712, 3276353719, 'DE', 'DEU', 'ألمانيا'),
(67904, 3276353720, 3276353799, 'NL', 'NLD', 'هولندا'),
(67905, 3276353800, 3276353807, 'DE', 'DEU', 'ألمانيا'),
(67906, 3276353808, 3276353927, 'NL', 'NLD', 'هولندا'),
(67907, 3276353928, 3276353935, 'DE', 'DEU', 'ألمانيا'),
(67908, 3276353936, 3276354095, 'NL', 'NLD', 'هولندا'),
(67909, 3276354096, 3276354103, 'DE', 'DEU', 'ألمانيا'),
(67910, 3276354104, 3276354183, 'NL', 'NLD', 'هولندا'),
(67911, 3276354184, 3276354191, 'DE', 'DEU', 'ألمانيا'),
(67912, 3276354192, 3276354207, 'NL', 'NLD', 'هولندا'),
(67913, 3276354208, 3276354223, 'DE', 'DEU', 'ألمانيا'),
(67914, 3276354224, 3276354255, 'NL', 'NLD', 'هولندا'),
(67915, 3276354256, 3276354263, 'DE', 'DEU', 'ألمانيا'),
(67916, 3276354264, 3276354327, 'NL', 'NLD', 'هولندا'),
(67917, 3276354328, 3276354335, 'DE', 'DEU', 'ألمانيا'),
(67918, 3276354336, 3276354343, 'NL', 'NLD', 'هولندا'),
(67919, 3276354344, 3276354351, 'DE', 'DEU', 'ألمانيا'),
(67920, 3276354352, 3276354415, 'NL', 'NLD', 'هولندا'),
(67921, 3276354416, 3276354423, 'DE', 'DEU', 'ألمانيا'),
(67922, 3276354424, 3276354623, 'NL', 'NLD', 'هولندا'),
(67923, 3276354624, 3276354639, 'DE', 'DEU', 'ألمانيا'),
(67924, 3276354640, 3276354647, 'NL', 'NLD', 'هولندا'),
(67925, 3276354648, 3276354655, 'DE', 'DEU', 'ألمانيا'),
(67926, 3276354656, 3276354735, 'NL', 'NLD', 'هولندا'),
(67927, 3276354736, 3276354743, 'DE', 'DEU', 'ألمانيا'),
(67928, 3276354744, 3276354831, 'NL', 'NLD', 'هولندا'),
(67929, 3276354832, 3276354847, 'DE', 'DEU', 'ألمانيا'),
(67930, 3276354848, 3276354855, 'NL', 'NLD', 'هولندا'),
(67931, 3276354856, 3276354879, 'DE', 'DEU', 'ألمانيا'),
(67932, 3276354880, 3276354887, 'NL', 'NLD', 'هولندا'),
(67933, 3276354888, 3276354895, 'DE', 'DEU', 'ألمانيا'),
(67934, 3276354896, 3276354903, 'NL', 'NLD', 'هولندا'),
(67935, 3276354904, 3276354911, 'DE', 'DEU', 'ألمانيا'),
(67936, 3276354912, 3276354967, 'NL', 'NLD', 'هولندا'),
(67937, 3276354968, 3276354975, 'DE', 'DEU', 'ألمانيا'),
(67938, 3276354976, 3276354999, 'NL', 'NLD', 'هولندا'),
(67939, 3276355000, 3276355007, 'DE', 'DEU', 'ألمانيا'),
(67940, 3276355008, 3276355063, 'NL', 'NLD', 'هولندا'),
(67941, 3276355064, 3276355071, 'DE', 'DEU', 'ألمانيا'),
(67942, 3276355072, 3276355183, 'NL', 'NLD', 'هولندا'),
(67943, 3276355184, 3276355191, 'DE', 'DEU', 'ألمانيا'),
(67944, 3276355192, 3276355263, 'NL', 'NLD', 'هولندا'),
(67945, 3276355264, 3276355271, 'DE', 'DEU', 'ألمانيا'),
(67946, 3276355272, 3276355367, 'NL', 'NLD', 'هولندا'),
(67947, 3276355368, 3276355383, 'DE', 'DEU', 'ألمانيا'),
(67948, 3276355384, 3276355399, 'NL', 'NLD', 'هولندا'),
(67949, 3276355400, 3276355407, 'DE', 'DEU', 'ألمانيا'),
(67950, 3276355408, 3276355439, 'NL', 'NLD', 'هولندا'),
(67951, 3276355440, 3276355447, 'DE', 'DEU', 'ألمانيا'),
(67952, 3276355448, 3276355543, 'NL', 'NLD', 'هولندا'),
(67953, 3276355544, 3276355559, 'DE', 'DEU', 'ألمانيا'),
(67954, 3276355560, 3276355647, 'NL', 'NLD', 'هولندا'),
(67955, 3276355648, 3276355655, 'DE', 'DEU', 'ألمانيا'),
(67956, 3276355656, 3276355663, 'NL', 'NLD', 'هولندا'),
(67957, 3276355664, 3276355671, 'DE', 'DEU', 'ألمانيا'),
(67958, 3276355672, 3276355783, 'NL', 'NLD', 'هولندا'),
(67959, 3276355784, 3276355791, 'DE', 'DEU', 'ألمانيا'),
(67960, 3276355792, 3276355847, 'NL', 'NLD', 'هولندا'),
(67961, 3276355848, 3276355855, 'DE', 'DEU', 'ألمانيا'),
(67962, 3276355856, 3276356063, 'NL', 'NLD', 'هولندا'),
(67963, 3276356064, 3276356071, 'DE', 'DEU', 'ألمانيا'),
(67964, 3276356072, 3276356135, 'NL', 'NLD', 'هولندا'),
(67965, 3276356136, 3276356143, 'DE', 'DEU', 'ألمانيا'),
(67966, 3276356144, 3276356207, 'NL', 'NLD', 'هولندا'),
(67967, 3276356208, 3276356215, 'DE', 'DEU', 'ألمانيا'),
(67968, 3276356216, 3276356279, 'NL', 'NLD', 'هولندا'),
(67969, 3276356280, 3276356295, 'DE', 'DEU', 'ألمانيا'),
(67970, 3276356296, 3276356311, 'NL', 'NLD', 'هولندا'),
(67971, 3276356312, 3276356319, 'DE', 'DEU', 'ألمانيا'),
(67972, 3276356320, 3276356351, 'NL', 'NLD', 'هولندا'),
(67973, 3276356352, 3276356607, 'DE', 'DEU', 'ألمانيا'),
(67974, 3276356608, 3276356623, 'NL', 'NLD', 'هولندا'),
(67975, 3276356624, 3276356631, 'DE', 'DEU', 'ألمانيا'),
(67976, 3276356632, 3276356647, 'NL', 'NLD', 'هولندا'),
(67977, 3276356648, 3276356655, 'DE', 'DEU', 'ألمانيا'),
(67978, 3276356656, 3276356775, 'NL', 'NLD', 'هولندا'),
(67979, 3276356776, 3276356783, 'DE', 'DEU', 'ألمانيا'),
(67980, 3276356784, 3276356799, 'NL', 'NLD', 'هولندا'),
(67981, 3276356800, 3276356807, 'DE', 'DEU', 'ألمانيا'),
(67982, 3276356808, 3276356911, 'NL', 'NLD', 'هولندا'),
(67983, 3276356912, 3276356927, 'DE', 'DEU', 'ألمانيا'),
(67984, 3276356928, 3276356935, 'NL', 'NLD', 'هولندا'),
(67985, 3276356936, 3276356943, 'DE', 'DEU', 'ألمانيا'),
(67986, 3276356944, 3276357015, 'NL', 'NLD', 'هولندا'),
(67987, 3276357016, 3276357023, 'DE', 'DEU', 'ألمانيا'),
(67988, 3276357024, 3276357175, 'NL', 'NLD', 'هولندا'),
(67989, 3276357176, 3276357183, 'DE', 'DEU', 'ألمانيا'),
(67990, 3276357184, 3276357279, 'NL', 'NLD', 'هولندا'),
(67991, 3276357280, 3276357287, 'DE', 'DEU', 'ألمانيا'),
(67992, 3276357288, 3276357295, 'NL', 'NLD', 'هولندا'),
(67993, 3276357296, 3276357303, 'DE', 'DEU', 'ألمانيا'),
(67994, 3276357304, 3276357319, 'NL', 'NLD', 'هولندا'),
(67995, 3276357320, 3276357327, 'DE', 'DEU', 'ألمانيا'),
(67996, 3276357328, 3276357343, 'NL', 'NLD', 'هولندا'),
(67997, 3276357344, 3276357351, 'DE', 'DEU', 'ألمانيا'),
(67998, 3276357352, 3276357383, 'NL', 'NLD', 'هولندا'),
(67999, 3276357384, 3276357391, 'DE', 'DEU', 'ألمانيا'),
(68000, 3276357392, 3276357415, 'NL', 'NLD', 'هولندا'),
(68001, 3276357416, 3276357423, 'DE', 'DEU', 'ألمانيا'),
(68002, 3276357424, 3276357447, 'NL', 'NLD', 'هولندا'),
(68003, 3276357448, 3276357455, 'DE', 'DEU', 'ألمانيا'),
(68004, 3276357456, 3276357503, 'NL', 'NLD', 'هولندا'),
(68005, 3276357504, 3276357519, 'DE', 'DEU', 'ألمانيا'),
(68006, 3276357520, 3276357543, 'NL', 'NLD', 'هولندا'),
(68007, 3276357544, 3276357551, 'DE', 'DEU', 'ألمانيا'),
(68008, 3276357552, 3276357655, 'NL', 'NLD', 'هولندا'),
(68009, 3276357656, 3276357663, 'DE', 'DEU', 'ألمانيا'),
(68010, 3276357664, 3276357783, 'NL', 'NLD', 'هولندا'),
(68011, 3276357784, 3276357791, 'DE', 'DEU', 'ألمانيا'),
(68012, 3276357792, 3276357831, 'NL', 'NLD', 'هولندا'),
(68013, 3276357832, 3276357847, 'DE', 'DEU', 'ألمانيا'),
(68014, 3276357848, 3276357903, 'NL', 'NLD', 'هولندا'),
(68015, 3276357904, 3276357911, 'DE', 'DEU', 'ألمانيا'),
(68016, 3276357912, 3276357927, 'NL', 'NLD', 'هولندا'),
(68017, 3276357928, 3276357935, 'DE', 'DEU', 'ألمانيا'),
(68018, 3276357936, 3276358111, 'NL', 'NLD', 'هولندا'),
(68019, 3276358112, 3276358127, 'DE', 'DEU', 'ألمانيا'),
(68020, 3276358128, 3276358199, 'NL', 'NLD', 'هولندا'),
(68021, 3276358200, 3276358207, 'DE', 'DEU', 'ألمانيا'),
(68022, 3276358208, 3276358215, 'NL', 'NLD', 'هولندا'),
(68023, 3276358216, 3276358223, 'DE', 'DEU', 'ألمانيا'),
(68024, 3276358224, 3276358239, 'NL', 'NLD', 'هولندا'),
(68025, 3276358240, 3276358247, 'DE', 'DEU', 'ألمانيا'),
(68026, 3276358248, 3276358279, 'NL', 'NLD', 'هولندا'),
(68027, 3276358280, 3276358295, 'DE', 'DEU', 'ألمانيا'),
(68028, 3276358296, 3276358335, 'NL', 'NLD', 'هولندا'),
(68029, 3276358336, 3276358343, 'DE', 'DEU', 'ألمانيا'),
(68030, 3276358344, 3276358471, 'NL', 'NLD', 'هولندا'),
(68031, 3276358472, 3276358479, 'DE', 'DEU', 'ألمانيا'),
(68032, 3276358480, 3276358495, 'NL', 'NLD', 'هولندا'),
(68033, 3276358496, 3276358503, 'DE', 'DEU', 'ألمانيا'),
(68034, 3276358504, 3276358591, 'NL', 'NLD', 'هولندا'),
(68035, 3276358592, 3276358599, 'DE', 'DEU', 'ألمانيا'),
(68036, 3276358600, 3276358607, 'NL', 'NLD', 'هولندا'),
(68037, 3276358608, 3276358615, 'DE', 'DEU', 'ألمانيا'),
(68038, 3276358616, 3276358631, 'NL', 'NLD', 'هولندا'),
(68039, 3276358632, 3276358647, 'DE', 'DEU', 'ألمانيا'),
(68040, 3276358648, 3276358743, 'NL', 'NLD', 'هولندا'),
(68041, 3276358744, 3276358759, 'DE', 'DEU', 'ألمانيا'),
(68042, 3276358760, 3276358775, 'NL', 'NLD', 'هولندا'),
(68043, 3276358776, 3276358783, 'DE', 'DEU', 'ألمانيا'),
(68044, 3276358784, 3276358791, 'NL', 'NLD', 'هولندا'),
(68045, 3276358792, 3276358807, 'DE', 'DEU', 'ألمانيا'),
(68046, 3276358808, 3276358903, 'NL', 'NLD', 'هولندا'),
(68047, 3276358904, 3276358911, 'DE', 'DEU', 'ألمانيا'),
(68048, 3276358912, 3276358927, 'NL', 'NLD', 'هولندا'),
(68049, 3276358928, 3276358935, 'DE', 'DEU', 'ألمانيا'),
(68050, 3276358936, 3276358951, 'NL', 'NLD', 'هولندا'),
(68051, 3276358952, 3276358959, 'DE', 'DEU', 'ألمانيا'),
(68052, 3276358960, 3276359047, 'NL', 'NLD', 'هولندا'),
(68053, 3276359048, 3276359055, 'DE', 'DEU', 'ألمانيا'),
(68054, 3276359056, 3276359135, 'NL', 'NLD', 'هولندا'),
(68055, 3276359136, 3276359143, 'DE', 'DEU', 'ألمانيا'),
(68056, 3276359144, 3276359167, 'NL', 'NLD', 'هولندا'),
(68057, 3276359168, 3276359175, 'DE', 'DEU', 'ألمانيا'),
(68058, 3276359176, 3276359383, 'NL', 'NLD', 'هولندا'),
(68059, 3276359384, 3276359391, 'DE', 'DEU', 'ألمانيا'),
(68060, 3276359392, 3276359439, 'NL', 'NLD', 'هولندا'),
(68061, 3276359440, 3276359447, 'DE', 'DEU', 'ألمانيا'),
(68062, 3276359448, 3276359511, 'NL', 'NLD', 'هولندا'),
(68063, 3276359512, 3276359519, 'DE', 'DEU', 'ألمانيا'),
(68064, 3276359520, 3276359607, 'NL', 'NLD', 'هولندا'),
(68065, 3276359608, 3276359615, 'DE', 'DEU', 'ألمانيا'),
(68066, 3276359616, 3276359703, 'NL', 'NLD', 'هولندا'),
(68067, 3276359704, 3276359711, 'DE', 'DEU', 'ألمانيا'),
(68068, 3276359712, 3276359727, 'NL', 'NLD', 'هولندا'),
(68069, 3276359728, 3276359735, 'DE', 'DEU', 'ألمانيا'),
(68070, 3276359736, 3276359751, 'NL', 'NLD', 'هولندا'),
(68071, 3276359752, 3276359759, 'DE', 'DEU', 'ألمانيا'),
(68072, 3276359760, 3276359783, 'NL', 'NLD', 'هولندا'),
(68073, 3276359784, 3276359791, 'DE', 'DEU', 'ألمانيا'),
(68074, 3276359792, 3276359807, 'NL', 'NLD', 'هولندا'),
(68075, 3276359808, 3276359815, 'DE', 'DEU', 'ألمانيا'),
(68076, 3276359816, 3276359839, 'NL', 'NLD', 'هولندا'),
(68077, 3276359840, 3276359847, 'DE', 'DEU', 'ألمانيا'),
(68078, 3276359848, 3276359919, 'NL', 'NLD', 'هولندا'),
(68079, 3276359920, 3276359927, 'DE', 'DEU', 'ألمانيا'),
(68080, 3276359928, 3276360007, 'NL', 'NLD', 'هولندا'),
(68081, 3276360008, 3276360015, 'DE', 'DEU', 'ألمانيا'),
(68082, 3276360016, 3276360055, 'NL', 'NLD', 'هولندا'),
(68083, 3276360056, 3276360063, 'DE', 'DEU', 'ألمانيا'),
(68084, 3276360064, 3276360087, 'NL', 'NLD', 'هولندا'),
(68085, 3276360088, 3276360095, 'DE', 'DEU', 'ألمانيا'),
(68086, 3276360096, 3276360111, 'NL', 'NLD', 'هولندا'),
(68087, 3276360112, 3276360119, 'DE', 'DEU', 'ألمانيا'),
(68088, 3276360120, 3276360175, 'NL', 'NLD', 'هولندا'),
(68089, 3276360176, 3276360183, 'DE', 'DEU', 'ألمانيا'),
(68090, 3276360184, 3276360199, 'NL', 'NLD', 'هولندا'),
(68091, 3276360200, 3276360207, 'DE', 'DEU', 'ألمانيا'),
(68092, 3276360208, 3276360223, 'NL', 'NLD', 'هولندا'),
(68093, 3276360224, 3276360239, 'DE', 'DEU', 'ألمانيا'),
(68094, 3276360240, 3276360271, 'NL', 'NLD', 'هولندا'),
(68095, 3276360272, 3276360279, 'DE', 'DEU', 'ألمانيا'),
(68096, 3276360280, 3276360327, 'NL', 'NLD', 'هولندا'),
(68097, 3276360328, 3276360335, 'DE', 'DEU', 'ألمانيا'),
(68098, 3276360336, 3276360351, 'NL', 'NLD', 'هولندا'),
(68099, 3276360352, 3276360359, 'DE', 'DEU', 'ألمانيا'),
(68100, 3276360360, 3276360375, 'NL', 'NLD', 'هولندا'),
(68101, 3276360376, 3276360383, 'DE', 'DEU', 'ألمانيا'),
(68102, 3276360384, 3276360399, 'NL', 'NLD', 'هولندا'),
(68103, 3276360400, 3276360407, 'DE', 'DEU', 'ألمانيا'),
(68104, 3276360408, 3276360495, 'NL', 'NLD', 'هولندا'),
(68105, 3276360496, 3276360503, 'DE', 'DEU', 'ألمانيا'),
(68106, 3276360504, 3276360519, 'NL', 'NLD', 'هولندا'),
(68107, 3276360520, 3276360527, 'DE', 'DEU', 'ألمانيا'),
(68108, 3276360528, 3276360559, 'NL', 'NLD', 'هولندا'),
(68109, 3276360560, 3276360567, 'DE', 'DEU', 'ألمانيا'),
(68110, 3276360568, 3276360583, 'NL', 'NLD', 'هولندا'),
(68111, 3276360584, 3276360591, 'DE', 'DEU', 'ألمانيا'),
(68112, 3276360592, 3276360615, 'NL', 'NLD', 'هولندا'),
(68113, 3276360616, 3276360623, 'DE', 'DEU', 'ألمانيا'),
(68114, 3276360624, 3276360687, 'NL', 'NLD', 'هولندا'),
(68115, 3276360688, 3276360703, 'DE', 'DEU', 'ألمانيا'),
(68116, 3276360704, 3276360743, 'NL', 'NLD', 'هولندا'),
(68117, 3276360744, 3276360751, 'DE', 'DEU', 'ألمانيا'),
(68118, 3276360752, 3276360847, 'NL', 'NLD', 'هولندا'),
(68119, 3276360848, 3276360863, 'DE', 'DEU', 'ألمانيا'),
(68120, 3276360864, 3276360999, 'NL', 'NLD', 'هولندا'),
(68121, 3276361000, 3276361007, 'DE', 'DEU', 'ألمانيا'),
(68122, 3276361008, 3276361015, 'NL', 'NLD', 'هولندا'),
(68123, 3276361016, 3276361023, 'DE', 'DEU', 'ألمانيا'),
(68124, 3276361024, 3276361063, 'NL', 'NLD', 'هولندا'),
(68125, 3276361064, 3276361071, 'DE', 'DEU', 'ألمانيا'),
(68126, 3276361072, 3276361239, 'NL', 'NLD', 'هولندا'),
(68127, 3276361240, 3276361247, 'DE', 'DEU', 'ألمانيا'),
(68128, 3276361248, 3276361255, 'NL', 'NLD', 'هولندا'),
(68129, 3276361256, 3276361271, 'DE', 'DEU', 'ألمانيا'),
(68130, 3276361272, 3276361303, 'NL', 'NLD', 'هولندا'),
(68131, 3276361304, 3276361311, 'DE', 'DEU', 'ألمانيا'),
(68132, 3276361312, 3276361343, 'NL', 'NLD', 'هولندا'),
(68133, 3276361344, 3276361351, 'DE', 'DEU', 'ألمانيا'),
(68134, 3276361352, 3276361383, 'NL', 'NLD', 'هولندا'),
(68135, 3276361384, 3276361391, 'DE', 'DEU', 'ألمانيا'),
(68136, 3276361392, 3276361399, 'NL', 'NLD', 'هولندا'),
(68137, 3276361400, 3276361407, 'DE', 'DEU', 'ألمانيا'),
(68138, 3276361408, 3276361519, 'NL', 'NLD', 'هولندا'),
(68139, 3276361520, 3276361527, 'DE', 'DEU', 'ألمانيا'),
(68140, 3276361528, 3276361599, 'NL', 'NLD', 'هولندا'),
(68141, 3276361600, 3276361607, 'DE', 'DEU', 'ألمانيا'),
(68142, 3276361608, 3276361655, 'NL', 'NLD', 'هولندا'),
(68143, 3276361656, 3276361663, 'DE', 'DEU', 'ألمانيا'),
(68144, 3276361664, 3276361679, 'NL', 'NLD', 'هولندا'),
(68145, 3276361680, 3276361687, 'DE', 'DEU', 'ألمانيا'),
(68146, 3276361688, 3276361751, 'NL', 'NLD', 'هولندا'),
(68147, 3276361752, 3276361767, 'DE', 'DEU', 'ألمانيا'),
(68148, 3276361768, 3276361999, 'NL', 'NLD', 'هولندا'),
(68149, 3276362000, 3276362007, 'DE', 'DEU', 'ألمانيا'),
(68150, 3276362008, 3276362047, 'NL', 'NLD', 'هولندا'),
(68151, 3276362048, 3276362055, 'DE', 'DEU', 'ألمانيا'),
(68152, 3276362056, 3276362071, 'NL', 'NLD', 'هولندا'),
(68153, 3276362072, 3276362079, 'DE', 'DEU', 'ألمانيا'),
(68154, 3276362080, 3276362143, 'NL', 'NLD', 'هولندا'),
(68155, 3276362144, 3276362151, 'DE', 'DEU', 'ألمانيا'),
(68156, 3276362152, 3276362311, 'NL', 'NLD', 'هولندا'),
(68157, 3276362312, 3276362319, 'DE', 'DEU', 'ألمانيا'),
(68158, 3276362320, 3276362599, 'NL', 'NLD', 'هولندا'),
(68159, 3276362600, 3276362607, 'DE', 'DEU', 'ألمانيا'),
(68160, 3276362608, 3276362695, 'NL', 'NLD', 'هولندا'),
(68161, 3276362696, 3276362703, 'DE', 'DEU', 'ألمانيا'),
(68162, 3276362704, 3276362759, 'NL', 'NLD', 'هولندا'),
(68163, 3276362760, 3276362767, 'DE', 'DEU', 'ألمانيا'),
(68164, 3276362768, 3276362775, 'NL', 'NLD', 'هولندا'),
(68165, 3276362776, 3276362783, 'DE', 'DEU', 'ألمانيا'),
(68166, 3276362784, 3276362791, 'NL', 'NLD', 'هولندا'),
(68167, 3276362792, 3276362799, 'DE', 'DEU', 'ألمانيا'),
(68168, 3276362800, 3276362967, 'NL', 'NLD', 'هولندا'),
(68169, 3276362968, 3276362975, 'DE', 'DEU', 'ألمانيا'),
(68170, 3276362976, 3276362983, 'NL', 'NLD', 'هولندا'),
(68171, 3276362984, 3276362991, 'DE', 'DEU', 'ألمانيا'),
(68172, 3276362992, 3276363047, 'NL', 'NLD', 'هولندا'),
(68173, 3276363048, 3276363055, 'DE', 'DEU', 'ألمانيا'),
(68174, 3276363056, 3276363071, 'NL', 'NLD', 'هولندا'),
(68175, 3276363072, 3276363079, 'DE', 'DEU', 'ألمانيا'),
(68176, 3276363080, 3276363223, 'NL', 'NLD', 'هولندا'),
(68177, 3276363224, 3276363231, 'DE', 'DEU', 'ألمانيا'),
(68178, 3276363232, 3276363295, 'NL', 'NLD', 'هولندا'),
(68179, 3276363296, 3276363303, 'DE', 'DEU', 'ألمانيا'),
(68180, 3276363304, 3276363335, 'NL', 'NLD', 'هولندا'),
(68181, 3276363336, 3276363343, 'DE', 'DEU', 'ألمانيا'),
(68182, 3276363344, 3276363375, 'NL', 'NLD', 'هولندا'),
(68183, 3276363376, 3276363383, 'DE', 'DEU', 'ألمانيا'),
(68184, 3276363384, 3276363503, 'NL', 'NLD', 'هولندا'),
(68185, 3276363504, 3276363511, 'DE', 'DEU', 'ألمانيا'),
(68186, 3276363512, 3276363583, 'NL', 'NLD', 'هولندا'),
(68187, 3276363584, 3276363591, 'DE', 'DEU', 'ألمانيا'),
(68188, 3276363592, 3276363607, 'NL', 'NLD', 'هولندا'),
(68189, 3276363608, 3276363615, 'DE', 'DEU', 'ألمانيا'),
(68190, 3276363616, 3276363623, 'NL', 'NLD', 'هولندا'),
(68191, 3276363624, 3276363631, 'DE', 'DEU', 'ألمانيا'),
(68192, 3276363632, 3276363655, 'NL', 'NLD', 'هولندا'),
(68193, 3276363656, 3276363679, 'DE', 'DEU', 'ألمانيا'),
(68194, 3276363680, 3276363703, 'NL', 'NLD', 'هولندا'),
(68195, 3276363704, 3276363711, 'DE', 'DEU', 'ألمانيا'),
(68196, 3276363712, 3276363823, 'NL', 'NLD', 'هولندا'),
(68197, 3276363824, 3276363831, 'DE', 'DEU', 'ألمانيا'),
(68198, 3276363832, 3276363855, 'NL', 'NLD', 'هولندا'),
(68199, 3276363856, 3276363863, 'DE', 'DEU', 'ألمانيا'),
(68200, 3276363864, 3276363951, 'NL', 'NLD', 'هولندا'),
(68201, 3276363952, 3276363967, 'DE', 'DEU', 'ألمانيا'),
(68202, 3276363968, 3276363975, 'NL', 'NLD', 'هولندا'),
(68203, 3276363976, 3276363991, 'DE', 'DEU', 'ألمانيا'),
(68204, 3276363992, 3276364183, 'NL', 'NLD', 'هولندا'),
(68205, 3276364184, 3276364191, 'DE', 'DEU', 'ألمانيا'),
(68206, 3276364192, 3276364295, 'NL', 'NLD', 'هولندا'),
(68207, 3276364296, 3276364303, 'DE', 'DEU', 'ألمانيا'),
(68208, 3276364304, 3276364311, 'NL', 'NLD', 'هولندا'),
(68209, 3276364312, 3276364319, 'DE', 'DEU', 'ألمانيا'),
(68210, 3276364320, 3276364383, 'NL', 'NLD', 'هولندا'),
(68211, 3276364384, 3276364391, 'DE', 'DEU', 'ألمانيا'),
(68212, 3276364392, 3276364431, 'NL', 'NLD', 'هولندا'),
(68213, 3276364432, 3276364439, 'DE', 'DEU', 'ألمانيا'),
(68214, 3276364440, 3276364543, 'NL', 'NLD', 'هولندا'),
(68215, 3276364544, 3276364551, 'DE', 'DEU', 'ألمانيا'),
(68216, 3276364552, 3276364639, 'NL', 'NLD', 'هولندا'),
(68217, 3276364640, 3276364655, 'DE', 'DEU', 'ألمانيا'),
(68218, 3276364656, 3276364807, 'NL', 'NLD', 'هولندا'),
(68219, 3276364808, 3276364815, 'DE', 'DEU', 'ألمانيا'),
(68220, 3276364816, 3276364855, 'NL', 'NLD', 'هولندا'),
(68221, 3276364856, 3276364863, 'DE', 'DEU', 'ألمانيا'),
(68222, 3276364864, 3276364935, 'NL', 'NLD', 'هولندا'),
(68223, 3276364936, 3276364943, 'DE', 'DEU', 'ألمانيا'),
(68224, 3276364944, 3276364959, 'NL', 'NLD', 'هولندا'),
(68225, 3276364960, 3276364967, 'DE', 'DEU', 'ألمانيا'),
(68226, 3276364968, 3276364991, 'NL', 'NLD', 'هولندا'),
(68227, 3276364992, 3276365007, 'DE', 'DEU', 'ألمانيا'),
(68228, 3276365008, 3276365215, 'NL', 'NLD', 'هولندا'),
(68229, 3276365216, 3276365223, 'DE', 'DEU', 'ألمانيا'),
(68230, 3276365224, 3276365247, 'NL', 'NLD', 'هولندا'),
(68231, 3276365248, 3276365255, 'DE', 'DEU', 'ألمانيا'),
(68232, 3276365256, 3276365303, 'NL', 'NLD', 'هولندا'),
(68233, 3276365304, 3276365311, 'DE', 'DEU', 'ألمانيا'),
(68234, 3276365312, 3276365327, 'NL', 'NLD', 'هولندا'),
(68235, 3276365328, 3276365335, 'DE', 'DEU', 'ألمانيا'),
(68236, 3276365336, 3276365375, 'NL', 'NLD', 'هولندا'),
(68237, 3276365376, 3276365391, 'DE', 'DEU', 'ألمانيا'),
(68238, 3276365392, 3276365415, 'NL', 'NLD', 'هولندا'),
(68239, 3276365416, 3276365423, 'DE', 'DEU', 'ألمانيا'),
(68240, 3276365424, 3276365495, 'NL', 'NLD', 'هولندا'),
(68241, 3276365496, 3276365519, 'DE', 'DEU', 'ألمانيا'),
(68242, 3276365520, 3276365543, 'NL', 'NLD', 'هولندا'),
(68243, 3276365544, 3276365551, 'DE', 'DEU', 'ألمانيا'),
(68244, 3276365552, 3276365623, 'NL', 'NLD', 'هولندا'),
(68245, 3276365624, 3276365631, 'DE', 'DEU', 'ألمانيا'),
(68246, 3276365632, 3276365647, 'NL', 'NLD', 'هولندا'),
(68247, 3276365648, 3276365655, 'DE', 'DEU', 'ألمانيا'),
(68248, 3276365656, 3276365743, 'NL', 'NLD', 'هولندا'),
(68249, 3276365744, 3276365751, 'DE', 'DEU', 'ألمانيا'),
(68250, 3276365752, 3276365999, 'NL', 'NLD', 'هولندا'),
(68251, 3276366000, 3276366007, 'DE', 'DEU', 'ألمانيا'),
(68252, 3276366008, 3276366039, 'NL', 'NLD', 'هولندا'),
(68253, 3276366040, 3276366047, 'DE', 'DEU', 'ألمانيا'),
(68254, 3276366048, 3276366055, 'NL', 'NLD', 'هولندا'),
(68255, 3276366056, 3276366063, 'DE', 'DEU', 'ألمانيا'),
(68256, 3276366064, 3276366119, 'NL', 'NLD', 'هولندا'),
(68257, 3276366120, 3276366127, 'DE', 'DEU', 'ألمانيا'),
(68258, 3276366128, 3276366143, 'NL', 'NLD', 'هولندا'),
(68259, 3276366144, 3276366151, 'DE', 'DEU', 'ألمانيا'),
(68260, 3276366152, 3276366255, 'NL', 'NLD', 'هولندا'),
(68261, 3276366256, 3276366263, 'DE', 'DEU', 'ألمانيا'),
(68262, 3276366264, 3276366319, 'NL', 'NLD', 'هولندا'),
(68263, 3276366320, 3276366335, 'DE', 'DEU', 'ألمانيا'),
(68264, 3276366336, 3276366455, 'NL', 'NLD', 'هولندا'),
(68265, 3276366456, 3276366471, 'DE', 'DEU', 'ألمانيا'),
(68266, 3276366472, 3276366591, 'NL', 'NLD', 'هولندا'),
(68267, 3276366592, 3276366599, 'DE', 'DEU', 'ألمانيا'),
(68268, 3276366600, 3276366639, 'NL', 'NLD', 'هولندا'),
(68269, 3276366640, 3276366647, 'DE', 'DEU', 'ألمانيا'),
(68270, 3276366648, 3276366679, 'NL', 'NLD', 'هولندا'),
(68271, 3276366680, 3276366695, 'DE', 'DEU', 'ألمانيا'),
(68272, 3276366696, 3276366727, 'NL', 'NLD', 'هولندا'),
(68273, 3276366728, 3276366735, 'DE', 'DEU', 'ألمانيا'),
(68274, 3276366736, 3276366751, 'NL', 'NLD', 'هولندا'),
(68275, 3276366752, 3276366767, 'DE', 'DEU', 'ألمانيا'),
(68276, 3276366768, 3276366775, 'NL', 'NLD', 'هولندا'),
(68277, 3276366776, 3276366783, 'DE', 'DEU', 'ألمانيا'),
(68278, 3276366784, 3276366855, 'NL', 'NLD', 'هولندا'),
(68279, 3276366856, 3276366863, 'DE', 'DEU', 'ألمانيا'),
(68280, 3276366864, 3276366887, 'NL', 'NLD', 'هولندا'),
(68281, 3276366888, 3276366895, 'DE', 'DEU', 'ألمانيا'),
(68282, 3276366896, 3276366919, 'NL', 'NLD', 'هولندا'),
(68283, 3276366920, 3276366927, 'DE', 'DEU', 'ألمانيا'),
(68284, 3276366928, 3276367063, 'NL', 'NLD', 'هولندا'),
(68285, 3276367064, 3276367071, 'DE', 'DEU', 'ألمانيا'),
(68286, 3276367072, 3276367079, 'NL', 'NLD', 'هولندا'),
(68287, 3276367080, 3276367087, 'DE', 'DEU', 'ألمانيا'),
(68288, 3276367088, 3276367119, 'NL', 'NLD', 'هولندا'),
(68289, 3276367120, 3276367127, 'DE', 'DEU', 'ألمانيا'),
(68290, 3276367128, 3276367159, 'NL', 'NLD', 'هولندا'),
(68291, 3276367160, 3276367175, 'DE', 'DEU', 'ألمانيا'),
(68292, 3276367176, 3276367271, 'NL', 'NLD', 'هولندا'),
(68293, 3276367272, 3276367279, 'DE', 'DEU', 'ألمانيا'),
(68294, 3276367280, 3276367455, 'NL', 'NLD', 'هولندا'),
(68295, 3276367456, 3276367463, 'DE', 'DEU', 'ألمانيا'),
(68296, 3276367464, 3276367607, 'NL', 'NLD', 'هولندا'),
(68297, 3276367608, 3276367615, 'DE', 'DEU', 'ألمانيا'),
(68298, 3276367616, 3276367623, 'NL', 'NLD', 'هولندا'),
(68299, 3276367624, 3276367631, 'DE', 'DEU', 'ألمانيا'),
(68300, 3276367632, 3276367679, 'NL', 'NLD', 'هولندا'),
(68301, 3276367680, 3276367687, 'DE', 'DEU', 'ألمانيا'),
(68302, 3276367688, 3276367711, 'NL', 'NLD', 'هولندا'),
(68303, 3276367712, 3276367719, 'DE', 'DEU', 'ألمانيا'),
(68304, 3276367720, 3276367743, 'NL', 'NLD', 'هولندا'),
(68305, 3276367744, 3276367751, 'DE', 'DEU', 'ألمانيا'),
(68306, 3276367752, 3276367783, 'NL', 'NLD', 'هولندا'),
(68307, 3276367784, 3276367791, 'DE', 'DEU', 'ألمانيا'),
(68308, 3276367792, 3276367855, 'NL', 'NLD', 'هولندا'),
(68309, 3276367856, 3276367863, 'DE', 'DEU', 'ألمانيا'),
(68310, 3276367864, 3276368079, 'NL', 'NLD', 'هولندا'),
(68311, 3276368080, 3276368087, 'DE', 'DEU', 'ألمانيا'),
(68312, 3276368088, 3276368103, 'NL', 'NLD', 'هولندا'),
(68313, 3276368104, 3276368111, 'DE', 'DEU', 'ألمانيا'),
(68314, 3276368112, 3276368191, 'NL', 'NLD', 'هولندا'),
(68315, 3276368192, 3276368199, 'DE', 'DEU', 'ألمانيا'),
(68316, 3276368200, 3276368271, 'NL', 'NLD', 'هولندا'),
(68317, 3276368272, 3276368279, 'DE', 'DEU', 'ألمانيا'),
(68318, 3276368280, 3276368343, 'NL', 'NLD', 'هولندا'),
(68319, 3276368344, 3276368351, 'DE', 'DEU', 'ألمانيا'),
(68320, 3276368352, 3276368431, 'NL', 'NLD', 'هولندا'),
(68321, 3276368432, 3276368439, 'DE', 'DEU', 'ألمانيا'),
(68322, 3276368440, 3276368527, 'NL', 'NLD', 'هولندا'),
(68323, 3276368528, 3276368535, 'DE', 'DEU', 'ألمانيا'),
(68324, 3276368536, 3276368615, 'NL', 'NLD', 'هولندا'),
(68325, 3276368616, 3276368623, 'DE', 'DEU', 'ألمانيا'),
(68326, 3276368624, 3276368631, 'NL', 'NLD', 'هولندا'),
(68327, 3276368632, 3276368639, 'DE', 'DEU', 'ألمانيا'),
(68328, 3276368640, 3276368655, 'NL', 'NLD', 'هولندا'),
(68329, 3276368656, 3276368663, 'DE', 'DEU', 'ألمانيا'),
(68330, 3276368664, 3276368703, 'NL', 'NLD', 'هولندا'),
(68331, 3276368704, 3276368711, 'DE', 'DEU', 'ألمانيا'),
(68332, 3276368712, 3276368727, 'NL', 'NLD', 'هولندا'),
(68333, 3276368728, 3276368735, 'DE', 'DEU', 'ألمانيا'),
(68334, 3276368736, 3276368751, 'NL', 'NLD', 'هولندا'),
(68335, 3276368752, 3276368759, 'DE', 'DEU', 'ألمانيا'),
(68336, 3276368760, 3276368815, 'NL', 'NLD', 'هولندا'),
(68337, 3276368816, 3276368823, 'DE', 'DEU', 'ألمانيا'),
(68338, 3276368824, 3276368871, 'NL', 'NLD', 'هولندا'),
(68339, 3276368872, 3276368879, 'DE', 'DEU', 'ألمانيا'),
(68340, 3276368880, 3276369031, 'NL', 'NLD', 'هولندا'),
(68341, 3276369032, 3276369047, 'DE', 'DEU', 'ألمانيا'),
(68342, 3276369048, 3276369079, 'NL', 'NLD', 'هولندا'),
(68343, 3276369080, 3276369087, 'DE', 'DEU', 'ألمانيا'),
(68344, 3276369088, 3276369167, 'NL', 'NLD', 'هولندا'),
(68345, 3276369168, 3276369183, 'DE', 'DEU', 'ألمانيا'),
(68346, 3276369184, 3276369263, 'NL', 'NLD', 'هولندا'),
(68347, 3276369264, 3276369271, 'DE', 'DEU', 'ألمانيا'),
(68348, 3276369272, 3276369431, 'NL', 'NLD', 'هولندا'),
(68349, 3276369432, 3276369439, 'DE', 'DEU', 'ألمانيا'),
(68350, 3276369440, 3276369527, 'NL', 'NLD', 'هولندا'),
(68351, 3276369528, 3276369543, 'DE', 'DEU', 'ألمانيا'),
(68352, 3276369544, 3276369551, 'NL', 'NLD', 'هولندا'),
(68353, 3276369552, 3276369559, 'DE', 'DEU', 'ألمانيا'),
(68354, 3276369560, 3276369599, 'NL', 'NLD', 'هولندا'),
(68355, 3276369600, 3276369607, 'DE', 'DEU', 'ألمانيا'),
(68356, 3276369608, 3276369623, 'NL', 'NLD', 'هولندا'),
(68357, 3276369624, 3276369631, 'DE', 'DEU', 'ألمانيا'),
(68358, 3276369632, 3276369639, 'NL', 'NLD', 'هولندا'),
(68359, 3276369640, 3276369647, 'DE', 'DEU', 'ألمانيا'),
(68360, 3276369648, 3276369703, 'NL', 'NLD', 'هولندا'),
(68361, 3276369704, 3276369711, 'DE', 'DEU', 'ألمانيا'),
(68362, 3276369712, 3276369735, 'NL', 'NLD', 'هولندا'),
(68363, 3276369736, 3276369743, 'DE', 'DEU', 'ألمانيا'),
(68364, 3276369744, 3276369751, 'NL', 'NLD', 'هولندا'),
(68365, 3276369752, 3276369759, 'DE', 'DEU', 'ألمانيا'),
(68366, 3276369760, 3276369855, 'NL', 'NLD', 'هولندا'),
(68367, 3276369856, 3276369863, 'DE', 'DEU', 'ألمانيا'),
(68368, 3276369864, 3276369871, 'NL', 'NLD', 'هولندا'),
(68369, 3276369872, 3276369879, 'DE', 'DEU', 'ألمانيا'),
(68370, 3276369880, 3276369919, 'NL', 'NLD', 'هولندا'),
(68371, 3276369920, 3276369927, 'DE', 'DEU', 'ألمانيا'),
(68372, 3276369928, 3276369999, 'NL', 'NLD', 'هولندا'),
(68373, 3276370000, 3276370015, 'DE', 'DEU', 'ألمانيا'),
(68374, 3276370016, 3276370063, 'NL', 'NLD', 'هولندا'),
(68375, 3276370064, 3276370071, 'DE', 'DEU', 'ألمانيا'),
(68376, 3276370072, 3276370119, 'NL', 'NLD', 'هولندا'),
(68377, 3276370120, 3276370143, 'DE', 'DEU', 'ألمانيا'),
(68378, 3276370144, 3276370183, 'NL', 'NLD', 'هولندا'),
(68379, 3276370184, 3276370191, 'DE', 'DEU', 'ألمانيا'),
(68380, 3276370192, 3276370335, 'NL', 'NLD', 'هولندا'),
(68381, 3276370336, 3276370343, 'DE', 'DEU', 'ألمانيا'),
(68382, 3276370344, 3276370375, 'NL', 'NLD', 'هولندا'),
(68383, 3276370376, 3276370383, 'DE', 'DEU', 'ألمانيا'),
(68384, 3276370384, 3276370551, 'NL', 'NLD', 'هولندا'),
(68385, 3276370552, 3276370567, 'DE', 'DEU', 'ألمانيا'),
(68386, 3276370568, 3276370599, 'NL', 'NLD', 'هولندا'),
(68387, 3276370600, 3276370607, 'DE', 'DEU', 'ألمانيا'),
(68388, 3276370608, 3276370831, 'NL', 'NLD', 'هولندا'),
(68389, 3276370832, 3276370839, 'DE', 'DEU', 'ألمانيا'),
(68390, 3276370840, 3276370919, 'NL', 'NLD', 'هولندا'),
(68391, 3276370920, 3276370927, 'DE', 'DEU', 'ألمانيا'),
(68392, 3276370928, 3276370959, 'NL', 'NLD', 'هولندا'),
(68393, 3276370960, 3276370967, 'DE', 'DEU', 'ألمانيا'),
(68394, 3276370968, 3276370999, 'NL', 'NLD', 'هولندا'),
(68395, 3276371000, 3276371007, 'DE', 'DEU', 'ألمانيا'),
(68396, 3276371008, 3276371039, 'NL', 'NLD', 'هولندا'),
(68397, 3276371040, 3276371055, 'DE', 'DEU', 'ألمانيا'),
(68398, 3276371056, 3276371167, 'NL', 'NLD', 'هولندا'),
(68399, 3276371168, 3276371175, 'DE', 'DEU', 'ألمانيا'),
(68400, 3276371176, 3276371239, 'NL', 'NLD', 'هولندا'),
(68401, 3276371240, 3276371247, 'DE', 'DEU', 'ألمانيا'),
(68402, 3276371248, 3276371255, 'NL', 'NLD', 'هولندا'),
(68403, 3276371256, 3276371271, 'DE', 'DEU', 'ألمانيا'),
(68404, 3276371272, 3276371327, 'NL', 'NLD', 'هولندا'),
(68405, 3276371328, 3276371335, 'DE', 'DEU', 'ألمانيا'),
(68406, 3276371336, 3276371343, 'NL', 'NLD', 'هولندا'),
(68407, 3276371344, 3276371351, 'DE', 'DEU', 'ألمانيا'),
(68408, 3276371352, 3276371367, 'NL', 'NLD', 'هولندا'),
(68409, 3276371368, 3276371375, 'DE', 'DEU', 'ألمانيا'),
(68410, 3276371376, 3276371407, 'NL', 'NLD', 'هولندا'),
(68411, 3276371408, 3276371415, 'DE', 'DEU', 'ألمانيا'),
(68412, 3276371416, 3276371431, 'NL', 'NLD', 'هولندا'),
(68413, 3276371432, 3276371439, 'DE', 'DEU', 'ألمانيا'),
(68414, 3276371440, 3276371455, 'NL', 'NLD', 'هولندا'),
(68415, 3276371456, 3276371463, 'DE', 'DEU', 'ألمانيا'),
(68416, 3276371464, 3276371511, 'NL', 'NLD', 'هولندا'),
(68417, 3276371512, 3276371527, 'DE', 'DEU', 'ألمانيا'),
(68418, 3276371528, 3276371727, 'NL', 'NLD', 'هولندا'),
(68419, 3276371728, 3276371735, 'DE', 'DEU', 'ألمانيا'),
(68420, 3276371736, 3276371815, 'NL', 'NLD', 'هولندا'),
(68421, 3276371816, 3276371823, 'DE', 'DEU', 'ألمانيا'),
(68422, 3276371824, 3276371831, 'NL', 'NLD', 'هولندا'),
(68423, 3276371832, 3276371839, 'DE', 'DEU', 'ألمانيا'),
(68424, 3276371840, 3276371863, 'NL', 'NLD', 'هولندا'),
(68425, 3276371864, 3276371871, 'DE', 'DEU', 'ألمانيا'),
(68426, 3276371872, 3276371879, 'NL', 'NLD', 'هولندا'),
(68427, 3276371880, 3276371887, 'DE', 'DEU', 'ألمانيا'),
(68428, 3276371888, 3276371903, 'NL', 'NLD', 'هولندا'),
(68429, 3276371904, 3276371911, 'DE', 'DEU', 'ألمانيا'),
(68430, 3276371912, 3276371951, 'NL', 'NLD', 'هولندا'),
(68431, 3276371952, 3276371959, 'DE', 'DEU', 'ألمانيا'),
(68432, 3276371960, 3276372023, 'NL', 'NLD', 'هولندا'),
(68433, 3276372024, 3276372031, 'DE', 'DEU', 'ألمانيا'),
(68434, 3276372032, 3276372095, 'NL', 'NLD', 'هولندا'),
(68435, 3276372096, 3276372111, 'DE', 'DEU', 'ألمانيا'),
(68436, 3276372112, 3276372303, 'NL', 'NLD', 'هولندا'),
(68437, 3276372304, 3276372311, 'DE', 'DEU', 'ألمانيا'),
(68438, 3276372312, 3276372343, 'NL', 'NLD', 'هولندا'),
(68439, 3276372344, 3276372351, 'DE', 'DEU', 'ألمانيا'),
(68440, 3276372352, 3276372679, 'NL', 'NLD', 'هولندا'),
(68441, 3276372680, 3276372687, 'DE', 'DEU', 'ألمانيا'),
(68442, 3276372688, 3276372807, 'NL', 'NLD', 'هولندا'),
(68443, 3276372808, 3276372815, 'DE', 'DEU', 'ألمانيا'),
(68444, 3276372816, 3276372911, 'NL', 'NLD', 'هولندا'),
(68445, 3276372912, 3276372919, 'DE', 'DEU', 'ألمانيا'),
(68446, 3276372920, 3276372943, 'NL', 'NLD', 'هولندا'),
(68447, 3276372944, 3276372951, 'DE', 'DEU', 'ألمانيا'),
(68448, 3276372952, 3276373015, 'NL', 'NLD', 'هولندا'),
(68449, 3276373016, 3276373023, 'DE', 'DEU', 'ألمانيا'),
(68450, 3276373024, 3276373039, 'NL', 'NLD', 'هولندا'),
(68451, 3276373040, 3276373047, 'DE', 'DEU', 'ألمانيا'),
(68452, 3276373048, 3276373063, 'NL', 'NLD', 'هولندا'),
(68453, 3276373064, 3276373071, 'DE', 'DEU', 'ألمانيا'),
(68454, 3276373072, 3276373119, 'NL', 'NLD', 'هولندا'),
(68455, 3276373120, 3276373127, 'DE', 'DEU', 'ألمانيا'),
(68456, 3276373128, 3276373167, 'NL', 'NLD', 'هولندا'),
(68457, 3276373168, 3276373175, 'DE', 'DEU', 'ألمانيا'),
(68458, 3276373176, 3276373207, 'NL', 'NLD', 'هولندا'),
(68459, 3276373208, 3276373215, 'DE', 'DEU', 'ألمانيا'),
(68460, 3276373216, 3276373223, 'NL', 'NLD', 'هولندا'),
(68461, 3276373224, 3276373231, 'DE', 'DEU', 'ألمانيا'),
(68462, 3276373232, 3276373343, 'NL', 'NLD', 'هولندا'),
(68463, 3276373344, 3276373351, 'DE', 'DEU', 'ألمانيا'),
(68464, 3276373352, 3276373431, 'NL', 'NLD', 'هولندا'),
(68465, 3276373432, 3276373439, 'DE', 'DEU', 'ألمانيا'),
(68466, 3276373440, 3276373447, 'NL', 'NLD', 'هولندا'),
(68467, 3276373448, 3276373455, 'DE', 'DEU', 'ألمانيا'),
(68468, 3276373456, 3276373519, 'NL', 'NLD', 'هولندا'),
(68469, 3276373520, 3276373527, 'DE', 'DEU', 'ألمانيا'),
(68470, 3276373528, 3276373551, 'NL', 'NLD', 'هولندا'),
(68471, 3276373552, 3276373559, 'DE', 'DEU', 'ألمانيا'),
(68472, 3276373560, 3276373727, 'NL', 'NLD', 'هولندا'),
(68473, 3276373728, 3276373735, 'DE', 'DEU', 'ألمانيا'),
(68474, 3276373736, 3276373751, 'NL', 'NLD', 'هولندا'),
(68475, 3276373752, 3276373759, 'DE', 'DEU', 'ألمانيا'),
(68476, 3276373760, 3276373863, 'NL', 'NLD', 'هولندا'),
(68477, 3276373864, 3276373871, 'DE', 'DEU', 'ألمانيا'),
(68478, 3276373872, 3276373911, 'NL', 'NLD', 'هولندا'),
(68479, 3276373912, 3276373919, 'DE', 'DEU', 'ألمانيا'),
(68480, 3276373920, 3276373927, 'NL', 'NLD', 'هولندا'),
(68481, 3276373928, 3276373943, 'DE', 'DEU', 'ألمانيا'),
(68482, 3276373944, 3276374063, 'NL', 'NLD', 'هولندا'),
(68483, 3276374064, 3276374071, 'DE', 'DEU', 'ألمانيا'),
(68484, 3276374072, 3276374143, 'NL', 'NLD', 'هولندا'),
(68485, 3276374144, 3276374151, 'DE', 'DEU', 'ألمانيا'),
(68486, 3276374152, 3276374159, 'NL', 'NLD', 'هولندا'),
(68487, 3276374160, 3276374167, 'DE', 'DEU', 'ألمانيا'),
(68488, 3276374168, 3276374327, 'NL', 'NLD', 'هولندا'),
(68489, 3276374328, 3276374335, 'DE', 'DEU', 'ألمانيا'),
(68490, 3276374336, 3276374399, 'NL', 'NLD', 'هولندا'),
(68491, 3276374400, 3276374407, 'DE', 'DEU', 'ألمانيا'),
(68492, 3276374408, 3276374439, 'NL', 'NLD', 'هولندا'),
(68493, 3276374440, 3276374447, 'DE', 'DEU', 'ألمانيا'),
(68494, 3276374448, 3276374479, 'NL', 'NLD', 'هولندا'),
(68495, 3276374480, 3276374487, 'DE', 'DEU', 'ألمانيا'),
(68496, 3276374488, 3276374527, 'NL', 'NLD', 'هولندا'),
(68497, 3276374528, 3276374535, 'DE', 'DEU', 'ألمانيا'),
(68498, 3276374536, 3276374575, 'NL', 'NLD', 'هولندا'),
(68499, 3276374576, 3276374583, 'DE', 'DEU', 'ألمانيا'),
(68500, 3276374584, 3276374679, 'NL', 'NLD', 'هولندا'),
(68501, 3276374680, 3276374687, 'DE', 'DEU', 'ألمانيا'),
(68502, 3276374688, 3276374703, 'NL', 'NLD', 'هولندا'),
(68503, 3276374704, 3276374711, 'DE', 'DEU', 'ألمانيا'),
(68504, 3276374712, 3276374727, 'NL', 'NLD', 'هولندا'),
(68505, 3276374728, 3276374735, 'DE', 'DEU', 'ألمانيا'),
(68506, 3276374736, 3276374751, 'NL', 'NLD', 'هولندا'),
(68507, 3276374752, 3276374767, 'DE', 'DEU', 'ألمانيا'),
(68508, 3276374768, 3276374775, 'NL', 'NLD', 'هولندا'),
(68509, 3276374776, 3276374783, 'DE', 'DEU', 'ألمانيا'),
(68510, 3276374784, 3276374807, 'NL', 'NLD', 'هولندا'),
(68511, 3276374808, 3276374815, 'DE', 'DEU', 'ألمانيا'),
(68512, 3276374816, 3276374823, 'NL', 'NLD', 'هولندا'),
(68513, 3276374824, 3276374831, 'DE', 'DEU', 'ألمانيا'),
(68514, 3276374832, 3276374999, 'NL', 'NLD', 'هولندا'),
(68515, 3276375000, 3276375007, 'DE', 'DEU', 'ألمانيا'),
(68516, 3276375008, 3276375103, 'NL', 'NLD', 'هولندا'),
(68517, 3276375104, 3276375119, 'DE', 'DEU', 'ألمانيا'),
(68518, 3276375120, 3276375183, 'NL', 'NLD', 'هولندا'),
(68519, 3276375184, 3276375191, 'DE', 'DEU', 'ألمانيا'),
(68520, 3276375192, 3276375223, 'NL', 'NLD', 'هولندا'),
(68521, 3276375224, 3276375231, 'DE', 'DEU', 'ألمانيا'),
(68522, 3276375232, 3276375335, 'NL', 'NLD', 'هولندا'),
(68523, 3276375336, 3276375359, 'DE', 'DEU', 'ألمانيا'),
(68524, 3276375360, 3276375423, 'NL', 'NLD', 'هولندا'),
(68525, 3276375424, 3276375439, 'DE', 'DEU', 'ألمانيا'),
(68526, 3276375440, 3276375607, 'NL', 'NLD', 'هولندا'),
(68527, 3276375608, 3276375615, 'DE', 'DEU', 'ألمانيا'),
(68528, 3276375616, 3276375679, 'NL', 'NLD', 'هولندا'),
(68529, 3276375680, 3276375687, 'DE', 'DEU', 'ألمانيا'),
(68530, 3276375688, 3276375727, 'NL', 'NLD', 'هولندا'),
(68531, 3276375728, 3276375735, 'DE', 'DEU', 'ألمانيا'),
(68532, 3276375736, 3276375783, 'NL', 'NLD', 'هولندا'),
(68533, 3276375784, 3276375791, 'DE', 'DEU', 'ألمانيا'),
(68534, 3276375792, 3276375911, 'NL', 'NLD', 'هولندا'),
(68535, 3276375912, 3276375919, 'DE', 'DEU', 'ألمانيا'),
(68536, 3276375920, 3276376015, 'NL', 'NLD', 'هولندا'),
(68537, 3276376016, 3276376023, 'DE', 'DEU', 'ألمانيا'),
(68538, 3276376024, 3276376055, 'NL', 'NLD', 'هولندا'),
(68539, 3276376056, 3276376063, 'DE', 'DEU', 'ألمانيا'),
(68540, 3276376064, 3276376095, 'NL', 'NLD', 'هولندا'),
(68541, 3276376096, 3276376103, 'DE', 'DEU', 'ألمانيا'),
(68542, 3276376104, 3276376143, 'NL', 'NLD', 'هولندا'),
(68543, 3276376144, 3276376151, 'DE', 'DEU', 'ألمانيا'),
(68544, 3276376152, 3276376191, 'NL', 'NLD', 'هولندا'),
(68545, 3276376192, 3276376199, 'DE', 'DEU', 'ألمانيا'),
(68546, 3276376200, 3276376311, 'NL', 'NLD', 'هولندا'),
(68547, 3276376312, 3276376319, 'DE', 'DEU', 'ألمانيا'),
(68548, 3276376320, 3276376359, 'NL', 'NLD', 'هولندا'),
(68549, 3276376360, 3276376367, 'DE', 'DEU', 'ألمانيا'),
(68550, 3276376368, 3276376375, 'NL', 'NLD', 'هولندا'),
(68551, 3276376376, 3276376383, 'DE', 'DEU', 'ألمانيا'),
(68552, 3276376384, 3276376471, 'NL', 'NLD', 'هولندا'),
(68553, 3276376472, 3276376479, 'DE', 'DEU', 'ألمانيا'),
(68554, 3276376480, 3276376503, 'NL', 'NLD', 'هولندا'),
(68555, 3276376504, 3276376511, 'DE', 'DEU', 'ألمانيا'),
(68556, 3276376512, 3276376599, 'NL', 'NLD', 'هولندا'),
(68557, 3276376600, 3276376607, 'DE', 'DEU', 'ألمانيا'),
(68558, 3276376608, 3276376679, 'NL', 'NLD', 'هولندا'),
(68559, 3276376680, 3276376687, 'DE', 'DEU', 'ألمانيا'),
(68560, 3276376688, 3276376767, 'NL', 'NLD', 'هولندا'),
(68561, 3276376768, 3276376775, 'DE', 'DEU', 'ألمانيا'),
(68562, 3276376776, 3276376871, 'NL', 'NLD', 'هولندا'),
(68563, 3276376872, 3276376879, 'DE', 'DEU', 'ألمانيا'),
(68564, 3276376880, 3276376927, 'NL', 'NLD', 'هولندا'),
(68565, 3276376928, 3276376935, 'DE', 'DEU', 'ألمانيا'),
(68566, 3276376936, 3276377031, 'NL', 'NLD', 'هولندا'),
(68567, 3276377032, 3276377039, 'DE', 'DEU', 'ألمانيا'),
(68568, 3276377040, 3276377087, 'NL', 'NLD', 'هولندا'),
(68569, 3276377088, 3276377095, 'DE', 'DEU', 'ألمانيا'),
(68570, 3276377096, 3276377335, 'NL', 'NLD', 'هولندا'),
(68571, 3276377336, 3276377351, 'DE', 'DEU', 'ألمانيا'),
(68572, 3276377352, 3276377359, 'NL', 'NLD', 'هولندا'),
(68573, 3276377360, 3276377367, 'DE', 'DEU', 'ألمانيا'),
(68574, 3276377368, 3276377407, 'NL', 'NLD', 'هولندا'),
(68575, 3276377408, 3276377415, 'DE', 'DEU', 'ألمانيا'),
(68576, 3276377416, 3276377447, 'NL', 'NLD', 'هولندا'),
(68577, 3276377448, 3276377455, 'DE', 'DEU', 'ألمانيا'),
(68578, 3276377456, 3276377631, 'NL', 'NLD', 'هولندا'),
(68579, 3276377632, 3276377639, 'DE', 'DEU', 'ألمانيا'),
(68580, 3276377640, 3276377687, 'NL', 'NLD', 'هولندا'),
(68581, 3276377688, 3276377695, 'DE', 'DEU', 'ألمانيا'),
(68582, 3276377696, 3276377807, 'NL', 'NLD', 'هولندا'),
(68583, 3276377808, 3276377815, 'DE', 'DEU', 'ألمانيا'),
(68584, 3276377816, 3276377831, 'NL', 'NLD', 'هولندا'),
(68585, 3276377832, 3276377847, 'DE', 'DEU', 'ألمانيا'),
(68586, 3276377848, 3276377887, 'NL', 'NLD', 'هولندا'),
(68587, 3276377888, 3276377895, 'DE', 'DEU', 'ألمانيا'),
(68588, 3276377896, 3276377983, 'NL', 'NLD', 'هولندا'),
(68589, 3276377984, 3276377991, 'DE', 'DEU', 'ألمانيا'),
(68590, 3276377992, 3276378063, 'NL', 'NLD', 'هولندا'),
(68591, 3276378064, 3276378071, 'DE', 'DEU', 'ألمانيا'),
(68592, 3276378072, 3276378103, 'NL', 'NLD', 'هولندا'),
(68593, 3276378104, 3276378111, 'DE', 'DEU', 'ألمانيا'),
(68594, 3276378112, 3276378143, 'NL', 'NLD', 'هولندا'),
(68595, 3276378144, 3276378151, 'DE', 'DEU', 'ألمانيا'),
(68596, 3276378152, 3276378231, 'NL', 'NLD', 'هولندا'),
(68597, 3276378232, 3276378239, 'DE', 'DEU', 'ألمانيا'),
(68598, 3276378240, 3276378311, 'NL', 'NLD', 'هولندا'),
(68599, 3276378312, 3276378319, 'DE', 'DEU', 'ألمانيا'),
(68600, 3276378320, 3276378351, 'NL', 'NLD', 'هولندا'),
(68601, 3276378352, 3276378359, 'DE', 'DEU', 'ألمانيا'),
(68602, 3276378360, 3276378567, 'NL', 'NLD', 'هولندا'),
(68603, 3276378568, 3276378591, 'DE', 'DEU', 'ألمانيا'),
(68604, 3276378592, 3276378607, 'NL', 'NLD', 'هولندا'),
(68605, 3276378608, 3276378615, 'DE', 'DEU', 'ألمانيا'),
(68606, 3276378616, 3276378631, 'NL', 'NLD', 'هولندا'),
(68607, 3276378632, 3276378639, 'DE', 'DEU', 'ألمانيا'),
(68608, 3276378640, 3276378735, 'NL', 'NLD', 'هولندا'),
(68609, 3276378736, 3276378743, 'DE', 'DEU', 'ألمانيا'),
(68610, 3276378744, 3276378839, 'NL', 'NLD', 'هولندا'),
(68611, 3276378840, 3276378847, 'DE', 'DEU', 'ألمانيا'),
(68612, 3276378848, 3276378871, 'NL', 'NLD', 'هولندا'),
(68613, 3276378872, 3276378879, 'DE', 'DEU', 'ألمانيا'),
(68614, 3276378880, 3276378911, 'NL', 'NLD', 'هولندا'),
(68615, 3276378912, 3276378919, 'DE', 'DEU', 'ألمانيا'),
(68616, 3276378920, 3276378935, 'NL', 'NLD', 'هولندا'),
(68617, 3276378936, 3276378943, 'DE', 'DEU', 'ألمانيا'),
(68618, 3276378944, 3276378951, 'NL', 'NLD', 'هولندا'),
(68619, 3276378952, 3276378959, 'DE', 'DEU', 'ألمانيا'),
(68620, 3276378960, 3276378983, 'NL', 'NLD', 'هولندا'),
(68621, 3276378984, 3276378991, 'DE', 'DEU', 'ألمانيا'),
(68622, 3276378992, 3276379047, 'NL', 'NLD', 'هولندا'),
(68623, 3276379048, 3276379055, 'DE', 'DEU', 'ألمانيا'),
(68624, 3276379056, 3276379071, 'NL', 'NLD', 'هولندا'),
(68625, 3276379072, 3276379079, 'DE', 'DEU', 'ألمانيا'),
(68626, 3276379080, 3276379167, 'NL', 'NLD', 'هولندا'),
(68627, 3276379168, 3276379175, 'DE', 'DEU', 'ألمانيا'),
(68628, 3276379176, 3276379215, 'NL', 'NLD', 'هولندا'),
(68629, 3276379216, 3276379223, 'DE', 'DEU', 'ألمانيا'),
(68630, 3276379224, 3276379279, 'NL', 'NLD', 'هولندا'),
(68631, 3276379280, 3276379287, 'DE', 'DEU', 'ألمانيا'),
(68632, 3276379288, 3276379295, 'NL', 'NLD', 'هولندا'),
(68633, 3276379296, 3276379303, 'DE', 'DEU', 'ألمانيا'),
(68634, 3276379304, 3276379463, 'NL', 'NLD', 'هولندا'),
(68635, 3276379464, 3276379471, 'DE', 'DEU', 'ألمانيا'),
(68636, 3276379472, 3276379503, 'NL', 'NLD', 'هولندا'),
(68637, 3276379504, 3276379511, 'DE', 'DEU', 'ألمانيا'),
(68638, 3276379512, 3276379583, 'NL', 'NLD', 'هولندا'),
(68639, 3276379584, 3276379591, 'DE', 'DEU', 'ألمانيا'),
(68640, 3276379592, 3276379607, 'NL', 'NLD', 'هولندا'),
(68641, 3276379608, 3276379615, 'DE', 'DEU', 'ألمانيا'),
(68642, 3276379616, 3276379703, 'NL', 'NLD', 'هولندا'),
(68643, 3276379704, 3276379711, 'DE', 'DEU', 'ألمانيا'),
(68644, 3276379712, 3276379727, 'NL', 'NLD', 'هولندا'),
(68645, 3276379728, 3276379735, 'DE', 'DEU', 'ألمانيا'),
(68646, 3276379736, 3276379767, 'NL', 'NLD', 'هولندا'),
(68647, 3276379768, 3276379775, 'DE', 'DEU', 'ألمانيا'),
(68648, 3276379776, 3276379815, 'NL', 'NLD', 'هولندا'),
(68649, 3276379816, 3276379823, 'DE', 'DEU', 'ألمانيا'),
(68650, 3276379824, 3276379943, 'NL', 'NLD', 'هولندا'),
(68651, 3276379944, 3276379951, 'DE', 'DEU', 'ألمانيا'),
(68652, 3276379952, 3276379959, 'NL', 'NLD', 'هولندا'),
(68653, 3276379960, 3276379967, 'DE', 'DEU', 'ألمانيا'),
(68654, 3276379968, 3276380023, 'NL', 'NLD', 'هولندا'),
(68655, 3276380024, 3276380031, 'DE', 'DEU', 'ألمانيا'),
(68656, 3276380032, 3276380199, 'NL', 'NLD', 'هولندا'),
(68657, 3276380200, 3276380215, 'DE', 'DEU', 'ألمانيا'),
(68658, 3276380216, 3276380295, 'NL', 'NLD', 'هولندا'),
(68659, 3276380296, 3276380303, 'DE', 'DEU', 'ألمانيا'),
(68660, 3276380304, 3276380351, 'NL', 'NLD', 'هولندا'),
(68661, 3276380352, 3276380359, 'DE', 'DEU', 'ألمانيا'),
(68662, 3276380360, 3276380471, 'NL', 'NLD', 'هولندا'),
(68663, 3276380472, 3276380479, 'DE', 'DEU', 'ألمانيا'),
(68664, 3276380480, 3276380687, 'NL', 'NLD', 'هولندا'),
(68665, 3276380688, 3276380695, 'DE', 'DEU', 'ألمانيا'),
(68666, 3276380696, 3276380879, 'NL', 'NLD', 'هولندا'),
(68667, 3276380880, 3276380887, 'DE', 'DEU', 'ألمانيا'),
(68668, 3276380888, 3276380919, 'NL', 'NLD', 'هولندا'),
(68669, 3276380920, 3276380927, 'DE', 'DEU', 'ألمانيا'),
(68670, 3276380928, 3276381103, 'NL', 'NLD', 'هولندا'),
(68671, 3276381104, 3276381111, 'DE', 'DEU', 'ألمانيا'),
(68672, 3276381112, 3276381127, 'NL', 'NLD', 'هولندا'),
(68673, 3276381128, 3276381135, 'DE', 'DEU', 'ألمانيا'),
(68674, 3276381136, 3276381167, 'NL', 'NLD', 'هولندا'),
(68675, 3276381168, 3276381175, 'DE', 'DEU', 'ألمانيا'),
(68676, 3276381176, 3276381247, 'NL', 'NLD', 'هولندا'),
(68677, 3276381248, 3276381263, 'DE', 'DEU', 'ألمانيا'),
(68678, 3276381264, 3276381279, 'NL', 'NLD', 'هولندا'),
(68679, 3276381280, 3276381287, 'DE', 'DEU', 'ألمانيا'),
(68680, 3276381288, 3276381295, 'NL', 'NLD', 'هولندا'),
(68681, 3276381296, 3276381303, 'DE', 'DEU', 'ألمانيا'),
(68682, 3276381304, 3276381311, 'NL', 'NLD', 'هولندا'),
(68683, 3276381312, 3276381319, 'DE', 'DEU', 'ألمانيا'),
(68684, 3276381320, 3276381327, 'NL', 'NLD', 'هولندا'),
(68685, 3276381328, 3276381335, 'DE', 'DEU', 'ألمانيا'),
(68686, 3276381336, 3276381359, 'NL', 'NLD', 'هولندا'),
(68687, 3276381360, 3276381367, 'DE', 'DEU', 'ألمانيا'),
(68688, 3276381368, 3276381415, 'NL', 'NLD', 'هولندا'),
(68689, 3276381416, 3276381431, 'DE', 'DEU', 'ألمانيا'),
(68690, 3276381432, 3276381583, 'NL', 'NLD', 'هولندا'),
(68691, 3276381584, 3276381599, 'DE', 'DEU', 'ألمانيا'),
(68692, 3276381600, 3276381607, 'NL', 'NLD', 'هولندا'),
(68693, 3276381608, 3276381615, 'DE', 'DEU', 'ألمانيا'),
(68694, 3276381616, 3276381671, 'NL', 'NLD', 'هولندا'),
(68695, 3276381672, 3276381679, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(68696, 3276381680, 3276381775, 'NL', 'NLD', 'هولندا'),
(68697, 3276381776, 3276381783, 'DE', 'DEU', 'ألمانيا'),
(68698, 3276381784, 3276381967, 'NL', 'NLD', 'هولندا'),
(68699, 3276381968, 3276381975, 'DE', 'DEU', 'ألمانيا'),
(68700, 3276381976, 3276382055, 'NL', 'NLD', 'هولندا'),
(68701, 3276382056, 3276382063, 'DE', 'DEU', 'ألمانيا'),
(68702, 3276382064, 3276382103, 'NL', 'NLD', 'هولندا'),
(68703, 3276382104, 3276382111, 'DE', 'DEU', 'ألمانيا'),
(68704, 3276382112, 3276382119, 'NL', 'NLD', 'هولندا'),
(68705, 3276382120, 3276382135, 'DE', 'DEU', 'ألمانيا'),
(68706, 3276382136, 3276382175, 'NL', 'NLD', 'هولندا'),
(68707, 3276382176, 3276382183, 'DE', 'DEU', 'ألمانيا'),
(68708, 3276382184, 3276382287, 'NL', 'NLD', 'هولندا'),
(68709, 3276382288, 3276382295, 'DE', 'DEU', 'ألمانيا'),
(68710, 3276382296, 3276382383, 'NL', 'NLD', 'هولندا'),
(68711, 3276382384, 3276382399, 'DE', 'DEU', 'ألمانيا'),
(68712, 3276382400, 3276382495, 'NL', 'NLD', 'هولندا'),
(68713, 3276382496, 3276382511, 'DE', 'DEU', 'ألمانيا'),
(68714, 3276382512, 3276382575, 'NL', 'NLD', 'هولندا'),
(68715, 3276382576, 3276382583, 'DE', 'DEU', 'ألمانيا'),
(68716, 3276382584, 3276382663, 'NL', 'NLD', 'هولندا'),
(68717, 3276382664, 3276382671, 'DE', 'DEU', 'ألمانيا'),
(68718, 3276382672, 3276382711, 'NL', 'NLD', 'هولندا'),
(68719, 3276382712, 3276382719, 'DE', 'DEU', 'ألمانيا'),
(68720, 3276382720, 3276382863, 'NL', 'NLD', 'هولندا'),
(68721, 3276382864, 3276382871, 'DE', 'DEU', 'ألمانيا'),
(68722, 3276382872, 3276382887, 'NL', 'NLD', 'هولندا'),
(68723, 3276382888, 3276382895, 'DE', 'DEU', 'ألمانيا'),
(68724, 3276382896, 3276383039, 'NL', 'NLD', 'هولندا'),
(68725, 3276383040, 3276383047, 'DE', 'DEU', 'ألمانيا'),
(68726, 3276383048, 3276383063, 'NL', 'NLD', 'هولندا'),
(68727, 3276383064, 3276383071, 'DE', 'DEU', 'ألمانيا'),
(68728, 3276383072, 3276383079, 'NL', 'NLD', 'هولندا'),
(68729, 3276383080, 3276383087, 'DE', 'DEU', 'ألمانيا'),
(68730, 3276383088, 3276383095, 'NL', 'NLD', 'هولندا'),
(68731, 3276383096, 3276383111, 'DE', 'DEU', 'ألمانيا'),
(68732, 3276383112, 3276383119, 'NL', 'NLD', 'هولندا'),
(68733, 3276383120, 3276383127, 'DE', 'DEU', 'ألمانيا'),
(68734, 3276383128, 3276383207, 'NL', 'NLD', 'هولندا'),
(68735, 3276383208, 3276383215, 'DE', 'DEU', 'ألمانيا'),
(68736, 3276383216, 3276383247, 'NL', 'NLD', 'هولندا'),
(68737, 3276383248, 3276383255, 'DE', 'DEU', 'ألمانيا'),
(68738, 3276383256, 3276383311, 'NL', 'NLD', 'هولندا'),
(68739, 3276383312, 3276383327, 'DE', 'DEU', 'ألمانيا'),
(68740, 3276383328, 3276383359, 'NL', 'NLD', 'هولندا'),
(68741, 3276383360, 3276383367, 'DE', 'DEU', 'ألمانيا'),
(68742, 3276383368, 3276383479, 'NL', 'NLD', 'هولندا'),
(68743, 3276383480, 3276383487, 'DE', 'DEU', 'ألمانيا'),
(68744, 3276383488, 3276383527, 'NL', 'NLD', 'هولندا'),
(68745, 3276383528, 3276383559, 'DE', 'DEU', 'ألمانيا'),
(68746, 3276383560, 3276383615, 'NL', 'NLD', 'هولندا'),
(68747, 3276383616, 3276383623, 'DE', 'DEU', 'ألمانيا'),
(68748, 3276383624, 3276383671, 'NL', 'NLD', 'هولندا'),
(68749, 3276383672, 3276383687, 'DE', 'DEU', 'ألمانيا'),
(68750, 3276383688, 3276383703, 'NL', 'NLD', 'هولندا'),
(68751, 3276383704, 3276383711, 'DE', 'DEU', 'ألمانيا'),
(68752, 3276383712, 3276383783, 'NL', 'NLD', 'هولندا'),
(68753, 3276383784, 3276383791, 'DE', 'DEU', 'ألمانيا'),
(68754, 3276383792, 3276383887, 'NL', 'NLD', 'هولندا'),
(68755, 3276383888, 3276383895, 'DE', 'DEU', 'ألمانيا'),
(68756, 3276383896, 3276384063, 'NL', 'NLD', 'هولندا'),
(68757, 3276384064, 3276384071, 'DE', 'DEU', 'ألمانيا'),
(68758, 3276384072, 3276384111, 'NL', 'NLD', 'هولندا'),
(68759, 3276384112, 3276384119, 'DE', 'DEU', 'ألمانيا'),
(68760, 3276384120, 3276384199, 'NL', 'NLD', 'هولندا'),
(68761, 3276384200, 3276384207, 'DE', 'DEU', 'ألمانيا'),
(68762, 3276384208, 3276384263, 'NL', 'NLD', 'هولندا'),
(68763, 3276384264, 3276384271, 'DE', 'DEU', 'ألمانيا'),
(68764, 3276384272, 3276384279, 'NL', 'NLD', 'هولندا'),
(68765, 3276384280, 3276384287, 'DE', 'DEU', 'ألمانيا'),
(68766, 3276384288, 3276384335, 'NL', 'NLD', 'هولندا'),
(68767, 3276384336, 3276384343, 'DE', 'DEU', 'ألمانيا'),
(68768, 3276384344, 3276384367, 'NL', 'NLD', 'هولندا'),
(68769, 3276384368, 3276384375, 'DE', 'DEU', 'ألمانيا'),
(68770, 3276384376, 3276384383, 'NL', 'NLD', 'هولندا'),
(68771, 3276384384, 3276384391, 'DE', 'DEU', 'ألمانيا'),
(68772, 3276384392, 3276384399, 'NL', 'NLD', 'هولندا'),
(68773, 3276384400, 3276384407, 'DE', 'DEU', 'ألمانيا'),
(68774, 3276384408, 3276384415, 'NL', 'NLD', 'هولندا'),
(68775, 3276384416, 3276384423, 'DE', 'DEU', 'ألمانيا'),
(68776, 3276384424, 3276384439, 'NL', 'NLD', 'هولندا'),
(68777, 3276384440, 3276384447, 'DE', 'DEU', 'ألمانيا'),
(68778, 3276384448, 3276384551, 'NL', 'NLD', 'هولندا'),
(68779, 3276384552, 3276384559, 'DE', 'DEU', 'ألمانيا'),
(68780, 3276384560, 3276384567, 'NL', 'NLD', 'هولندا'),
(68781, 3276384568, 3276384575, 'DE', 'DEU', 'ألمانيا'),
(68782, 3276384576, 3276384647, 'NL', 'NLD', 'هولندا'),
(68783, 3276384648, 3276384655, 'DE', 'DEU', 'ألمانيا'),
(68784, 3276384656, 3276384727, 'NL', 'NLD', 'هولندا'),
(68785, 3276384728, 3276384735, 'DE', 'DEU', 'ألمانيا'),
(68786, 3276384736, 3276384823, 'NL', 'NLD', 'هولندا'),
(68787, 3276384824, 3276384839, 'DE', 'DEU', 'ألمانيا'),
(68788, 3276384840, 3276384879, 'NL', 'NLD', 'هولندا'),
(68789, 3276384880, 3276384887, 'DE', 'DEU', 'ألمانيا'),
(68790, 3276384888, 3276384895, 'NL', 'NLD', 'هولندا'),
(68791, 3276384896, 3276384903, 'DE', 'DEU', 'ألمانيا'),
(68792, 3276384904, 3276385031, 'NL', 'NLD', 'هولندا'),
(68793, 3276385032, 3276385039, 'DE', 'DEU', 'ألمانيا'),
(68794, 3276385040, 3276385047, 'NL', 'NLD', 'هولندا'),
(68795, 3276385048, 3276385055, 'DE', 'DEU', 'ألمانيا'),
(68796, 3276385056, 3276385079, 'NL', 'NLD', 'هولندا'),
(68797, 3276385080, 3276385087, 'DE', 'DEU', 'ألمانيا'),
(68798, 3276385088, 3276385111, 'NL', 'NLD', 'هولندا'),
(68799, 3276385112, 3276385119, 'DE', 'DEU', 'ألمانيا'),
(68800, 3276385120, 3276385135, 'NL', 'NLD', 'هولندا'),
(68801, 3276385136, 3276385143, 'DE', 'DEU', 'ألمانيا'),
(68802, 3276385144, 3276385175, 'NL', 'NLD', 'هولندا'),
(68803, 3276385176, 3276385183, 'DE', 'DEU', 'ألمانيا'),
(68804, 3276385184, 3276385191, 'NL', 'NLD', 'هولندا'),
(68805, 3276385192, 3276385199, 'DE', 'DEU', 'ألمانيا'),
(68806, 3276385200, 3276385215, 'NL', 'NLD', 'هولندا'),
(68807, 3276385216, 3276385223, 'DE', 'DEU', 'ألمانيا'),
(68808, 3276385224, 3276385247, 'NL', 'NLD', 'هولندا'),
(68809, 3276385248, 3276385255, 'DE', 'DEU', 'ألمانيا'),
(68810, 3276385256, 3276385295, 'NL', 'NLD', 'هولندا'),
(68811, 3276385296, 3276385303, 'DE', 'DEU', 'ألمانيا'),
(68812, 3276385304, 3276385383, 'NL', 'NLD', 'هولندا'),
(68813, 3276385384, 3276385399, 'DE', 'DEU', 'ألمانيا'),
(68814, 3276385400, 3276385575, 'NL', 'NLD', 'هولندا'),
(68815, 3276385576, 3276385583, 'DE', 'DEU', 'ألمانيا'),
(68816, 3276385584, 3276385679, 'NL', 'NLD', 'هولندا'),
(68817, 3276385680, 3276385687, 'DE', 'DEU', 'ألمانيا'),
(68818, 3276385688, 3276385695, 'NL', 'NLD', 'هولندا'),
(68819, 3276385696, 3276385703, 'DE', 'DEU', 'ألمانيا'),
(68820, 3276385704, 3276385751, 'NL', 'NLD', 'هولندا'),
(68821, 3276385752, 3276385759, 'DE', 'DEU', 'ألمانيا'),
(68822, 3276385760, 3276385799, 'NL', 'NLD', 'هولندا'),
(68823, 3276385800, 3276385807, 'DE', 'DEU', 'ألمانيا'),
(68824, 3276385808, 3276385903, 'NL', 'NLD', 'هولندا'),
(68825, 3276385904, 3276385911, 'DE', 'DEU', 'ألمانيا'),
(68826, 3276385912, 3276385919, 'NL', 'NLD', 'هولندا'),
(68827, 3276385920, 3276385927, 'DE', 'DEU', 'ألمانيا'),
(68828, 3276385928, 3276385935, 'NL', 'NLD', 'هولندا'),
(68829, 3276385936, 3276385943, 'DE', 'DEU', 'ألمانيا'),
(68830, 3276385944, 3276385959, 'NL', 'NLD', 'هولندا'),
(68831, 3276385960, 3276385967, 'DE', 'DEU', 'ألمانيا'),
(68832, 3276385968, 3276386047, 'NL', 'NLD', 'هولندا'),
(68833, 3276386048, 3276386055, 'DE', 'DEU', 'ألمانيا'),
(68834, 3276386056, 3276386087, 'NL', 'NLD', 'هولندا'),
(68835, 3276386088, 3276386095, 'DE', 'DEU', 'ألمانيا'),
(68836, 3276386096, 3276386199, 'NL', 'NLD', 'هولندا'),
(68837, 3276386200, 3276386207, 'DE', 'DEU', 'ألمانيا'),
(68838, 3276386208, 3276386231, 'NL', 'NLD', 'هولندا'),
(68839, 3276386232, 3276386239, 'DE', 'DEU', 'ألمانيا'),
(68840, 3276386240, 3276386359, 'NL', 'NLD', 'هولندا'),
(68841, 3276386360, 3276386367, 'DE', 'DEU', 'ألمانيا'),
(68842, 3276386368, 3276386375, 'NL', 'NLD', 'هولندا'),
(68843, 3276386376, 3276386383, 'DE', 'DEU', 'ألمانيا'),
(68844, 3276386384, 3276386399, 'NL', 'NLD', 'هولندا'),
(68845, 3276386400, 3276386407, 'DE', 'DEU', 'ألمانيا'),
(68846, 3276386408, 3276386415, 'NL', 'NLD', 'هولندا'),
(68847, 3276386416, 3276386423, 'DE', 'DEU', 'ألمانيا'),
(68848, 3276386424, 3276386431, 'NL', 'NLD', 'هولندا'),
(68849, 3276386432, 3276386439, 'DE', 'DEU', 'ألمانيا'),
(68850, 3276386440, 3276386503, 'NL', 'NLD', 'هولندا'),
(68851, 3276386504, 3276386511, 'DE', 'DEU', 'ألمانيا'),
(68852, 3276386512, 3276386559, 'NL', 'NLD', 'هولندا'),
(68853, 3276386560, 3276386567, 'DE', 'DEU', 'ألمانيا'),
(68854, 3276386568, 3276386575, 'NL', 'NLD', 'هولندا'),
(68855, 3276386576, 3276386583, 'DE', 'DEU', 'ألمانيا'),
(68856, 3276386584, 3276386599, 'NL', 'NLD', 'هولندا'),
(68857, 3276386600, 3276386607, 'DE', 'DEU', 'ألمانيا'),
(68858, 3276386608, 3276386615, 'NL', 'NLD', 'هولندا'),
(68859, 3276386616, 3276386623, 'DE', 'DEU', 'ألمانيا'),
(68860, 3276386624, 3276386655, 'NL', 'NLD', 'هولندا'),
(68861, 3276386656, 3276386663, 'DE', 'DEU', 'ألمانيا'),
(68862, 3276386664, 3276386727, 'NL', 'NLD', 'هولندا'),
(68863, 3276386728, 3276386735, 'DE', 'DEU', 'ألمانيا'),
(68864, 3276386736, 3276386743, 'NL', 'NLD', 'هولندا'),
(68865, 3276386744, 3276386751, 'DE', 'DEU', 'ألمانيا'),
(68866, 3276386752, 3276386759, 'NL', 'NLD', 'هولندا'),
(68867, 3276386760, 3276386767, 'DE', 'DEU', 'ألمانيا'),
(68868, 3276386768, 3276386831, 'NL', 'NLD', 'هولندا'),
(68869, 3276386832, 3276386839, 'DE', 'DEU', 'ألمانيا'),
(68870, 3276386840, 3276386847, 'NL', 'NLD', 'هولندا'),
(68871, 3276386848, 3276386855, 'DE', 'DEU', 'ألمانيا'),
(68872, 3276386856, 3276386863, 'NL', 'NLD', 'هولندا'),
(68873, 3276386864, 3276386871, 'DE', 'DEU', 'ألمانيا'),
(68874, 3276386872, 3276386879, 'NL', 'NLD', 'هولندا'),
(68875, 3276386880, 3276386887, 'DE', 'DEU', 'ألمانيا'),
(68876, 3276386888, 3276386895, 'NL', 'NLD', 'هولندا'),
(68877, 3276386896, 3276386903, 'DE', 'DEU', 'ألمانيا'),
(68878, 3276386904, 3276386927, 'NL', 'NLD', 'هولندا'),
(68879, 3276386928, 3276386935, 'DE', 'DEU', 'ألمانيا'),
(68880, 3276386936, 3276386951, 'NL', 'NLD', 'هولندا'),
(68881, 3276386952, 3276386959, 'DE', 'DEU', 'ألمانيا'),
(68882, 3276386960, 3276386975, 'NL', 'NLD', 'هولندا'),
(68883, 3276386976, 3276386983, 'DE', 'DEU', 'ألمانيا'),
(68884, 3276386984, 3276387007, 'NL', 'NLD', 'هولندا'),
(68885, 3276387008, 3276387015, 'DE', 'DEU', 'ألمانيا'),
(68886, 3276387016, 3276387071, 'NL', 'NLD', 'هولندا'),
(68887, 3276387072, 3276387079, 'DE', 'DEU', 'ألمانيا'),
(68888, 3276387080, 3276387199, 'NL', 'NLD', 'هولندا'),
(68889, 3276387200, 3276387207, 'DE', 'DEU', 'ألمانيا'),
(68890, 3276387208, 3276387231, 'NL', 'NLD', 'هولندا'),
(68891, 3276387232, 3276387239, 'DE', 'DEU', 'ألمانيا'),
(68892, 3276387240, 3276387247, 'NL', 'NLD', 'هولندا'),
(68893, 3276387248, 3276387255, 'DE', 'DEU', 'ألمانيا'),
(68894, 3276387256, 3276387263, 'NL', 'NLD', 'هولندا'),
(68895, 3276387264, 3276387271, 'DE', 'DEU', 'ألمانيا'),
(68896, 3276387272, 3276387311, 'NL', 'NLD', 'هولندا'),
(68897, 3276387312, 3276387319, 'DE', 'DEU', 'ألمانيا'),
(68898, 3276387320, 3276387383, 'NL', 'NLD', 'هولندا'),
(68899, 3276387384, 3276387391, 'DE', 'DEU', 'ألمانيا'),
(68900, 3276387392, 3276387399, 'NL', 'NLD', 'هولندا'),
(68901, 3276387400, 3276387415, 'DE', 'DEU', 'ألمانيا'),
(68902, 3276387416, 3276387423, 'NL', 'NLD', 'هولندا'),
(68903, 3276387424, 3276387431, 'DE', 'DEU', 'ألمانيا'),
(68904, 3276387432, 3276387439, 'NL', 'NLD', 'هولندا'),
(68905, 3276387440, 3276387455, 'DE', 'DEU', 'ألمانيا'),
(68906, 3276387456, 3276387471, 'NL', 'NLD', 'هولندا'),
(68907, 3276387472, 3276387487, 'DE', 'DEU', 'ألمانيا'),
(68908, 3276387488, 3276387511, 'NL', 'NLD', 'هولندا'),
(68909, 3276387512, 3276387519, 'DE', 'DEU', 'ألمانيا'),
(68910, 3276387520, 3276387559, 'NL', 'NLD', 'هولندا'),
(68911, 3276387560, 3276387567, 'DE', 'DEU', 'ألمانيا'),
(68912, 3276387568, 3276387575, 'NL', 'NLD', 'هولندا'),
(68913, 3276387576, 3276387591, 'DE', 'DEU', 'ألمانيا'),
(68914, 3276387592, 3276387599, 'NL', 'NLD', 'هولندا'),
(68915, 3276387600, 3276387615, 'DE', 'DEU', 'ألمانيا'),
(68916, 3276387616, 3276387639, 'NL', 'NLD', 'هولندا'),
(68917, 3276387640, 3276387647, 'DE', 'DEU', 'ألمانيا'),
(68918, 3276387648, 3276387671, 'NL', 'NLD', 'هولندا'),
(68919, 3276387672, 3276387679, 'DE', 'DEU', 'ألمانيا'),
(68920, 3276387680, 3276387887, 'NL', 'NLD', 'هولندا'),
(68921, 3276387888, 3276387895, 'DE', 'DEU', 'ألمانيا'),
(68922, 3276387896, 3276387911, 'NL', 'NLD', 'هولندا'),
(68923, 3276387912, 3276387927, 'DE', 'DEU', 'ألمانيا'),
(68924, 3276387928, 3276387983, 'NL', 'NLD', 'هولندا'),
(68925, 3276387984, 3276387991, 'DE', 'DEU', 'ألمانيا'),
(68926, 3276387992, 3276388015, 'NL', 'NLD', 'هولندا'),
(68927, 3276388016, 3276388023, 'DE', 'DEU', 'ألمانيا'),
(68928, 3276388024, 3276388191, 'NL', 'NLD', 'هولندا'),
(68929, 3276388192, 3276388199, 'DE', 'DEU', 'ألمانيا'),
(68930, 3276388200, 3276388207, 'NL', 'NLD', 'هولندا'),
(68931, 3276388208, 3276388215, 'DE', 'DEU', 'ألمانيا'),
(68932, 3276388216, 3276388223, 'NL', 'NLD', 'هولندا'),
(68933, 3276388224, 3276388231, 'DE', 'DEU', 'ألمانيا'),
(68934, 3276388232, 3276388239, 'NL', 'NLD', 'هولندا'),
(68935, 3276388240, 3276388255, 'DE', 'DEU', 'ألمانيا'),
(68936, 3276388256, 3276388279, 'NL', 'NLD', 'هولندا'),
(68937, 3276388280, 3276388287, 'DE', 'DEU', 'ألمانيا'),
(68938, 3276388288, 3276388303, 'NL', 'NLD', 'هولندا'),
(68939, 3276388304, 3276388311, 'DE', 'DEU', 'ألمانيا'),
(68940, 3276388312, 3276388319, 'NL', 'NLD', 'هولندا'),
(68941, 3276388320, 3276388327, 'DE', 'DEU', 'ألمانيا'),
(68942, 3276388328, 3276388375, 'NL', 'NLD', 'هولندا'),
(68943, 3276388376, 3276388383, 'DE', 'DEU', 'ألمانيا'),
(68944, 3276388384, 3276388519, 'NL', 'NLD', 'هولندا'),
(68945, 3276388520, 3276388527, 'DE', 'DEU', 'ألمانيا'),
(68946, 3276388528, 3276388783, 'NL', 'NLD', 'هولندا'),
(68947, 3276388784, 3276388791, 'DE', 'DEU', 'ألمانيا'),
(68948, 3276388792, 3276388815, 'NL', 'NLD', 'هولندا'),
(68949, 3276388816, 3276388831, 'DE', 'DEU', 'ألمانيا'),
(68950, 3276388832, 3276388879, 'NL', 'NLD', 'هولندا'),
(68951, 3276388880, 3276388887, 'DE', 'DEU', 'ألمانيا'),
(68952, 3276388888, 3276388975, 'NL', 'NLD', 'هولندا'),
(68953, 3276388976, 3276388983, 'DE', 'DEU', 'ألمانيا'),
(68954, 3276388984, 3276389055, 'NL', 'NLD', 'هولندا'),
(68955, 3276389056, 3276389063, 'DE', 'DEU', 'ألمانيا'),
(68956, 3276389064, 3276389159, 'NL', 'NLD', 'هولندا'),
(68957, 3276389160, 3276389167, 'DE', 'DEU', 'ألمانيا'),
(68958, 3276389168, 3276389199, 'NL', 'NLD', 'هولندا'),
(68959, 3276389200, 3276389207, 'DE', 'DEU', 'ألمانيا'),
(68960, 3276389208, 3276389231, 'NL', 'NLD', 'هولندا'),
(68961, 3276389232, 3276389239, 'DE', 'DEU', 'ألمانيا'),
(68962, 3276389240, 3276389303, 'NL', 'NLD', 'هولندا'),
(68963, 3276389304, 3276389311, 'DE', 'DEU', 'ألمانيا'),
(68964, 3276389312, 3276389335, 'NL', 'NLD', 'هولندا'),
(68965, 3276389336, 3276389343, 'DE', 'DEU', 'ألمانيا'),
(68966, 3276389344, 3276389351, 'NL', 'NLD', 'هولندا'),
(68967, 3276389352, 3276389359, 'DE', 'DEU', 'ألمانيا'),
(68968, 3276389360, 3276389391, 'NL', 'NLD', 'هولندا'),
(68969, 3276389392, 3276389399, 'DE', 'DEU', 'ألمانيا'),
(68970, 3276389400, 3276389407, 'NL', 'NLD', 'هولندا'),
(68971, 3276389408, 3276389415, 'DE', 'DEU', 'ألمانيا'),
(68972, 3276389416, 3276389431, 'NL', 'NLD', 'هولندا'),
(68973, 3276389432, 3276389439, 'DE', 'DEU', 'ألمانيا'),
(68974, 3276389440, 3276389447, 'NL', 'NLD', 'هولندا'),
(68975, 3276389448, 3276389455, 'DE', 'DEU', 'ألمانيا'),
(68976, 3276389456, 3276389575, 'NL', 'NLD', 'هولندا'),
(68977, 3276389576, 3276389607, 'DE', 'DEU', 'ألمانيا'),
(68978, 3276389608, 3276389615, 'NL', 'NLD', 'هولندا'),
(68979, 3276389616, 3276389623, 'DE', 'DEU', 'ألمانيا'),
(68980, 3276389624, 3276389695, 'NL', 'NLD', 'هولندا'),
(68981, 3276389696, 3276389703, 'DE', 'DEU', 'ألمانيا'),
(68982, 3276389704, 3276389711, 'NL', 'NLD', 'هولندا'),
(68983, 3276389712, 3276389727, 'DE', 'DEU', 'ألمانيا'),
(68984, 3276389728, 3276389791, 'NL', 'NLD', 'هولندا'),
(68985, 3276389792, 3276389815, 'DE', 'DEU', 'ألمانيا'),
(68986, 3276389816, 3276389887, 'NL', 'NLD', 'هولندا'),
(68987, 3276389888, 3276389903, 'DE', 'DEU', 'ألمانيا'),
(68988, 3276389904, 3276389951, 'NL', 'NLD', 'هولندا'),
(68989, 3276389952, 3276389967, 'DE', 'DEU', 'ألمانيا'),
(68990, 3276389968, 3276390231, 'NL', 'NLD', 'هولندا'),
(68991, 3276390232, 3276390239, 'DE', 'DEU', 'ألمانيا'),
(68992, 3276390240, 3276390295, 'NL', 'NLD', 'هولندا'),
(68993, 3276390296, 3276390303, 'DE', 'DEU', 'ألمانيا'),
(68994, 3276390304, 3276390351, 'NL', 'NLD', 'هولندا'),
(68995, 3276390352, 3276390359, 'DE', 'DEU', 'ألمانيا'),
(68996, 3276390360, 3276390383, 'NL', 'NLD', 'هولندا'),
(68997, 3276390384, 3276390391, 'DE', 'DEU', 'ألمانيا'),
(68998, 3276390392, 3276390407, 'NL', 'NLD', 'هولندا'),
(68999, 3276390408, 3276390423, 'DE', 'DEU', 'ألمانيا'),
(69000, 3276390424, 3276390431, 'NL', 'NLD', 'هولندا'),
(69001, 3276390432, 3276390439, 'DE', 'DEU', 'ألمانيا'),
(69002, 3276390440, 3276390463, 'NL', 'NLD', 'هولندا'),
(69003, 3276390464, 3276390471, 'DE', 'DEU', 'ألمانيا'),
(69004, 3276390472, 3276390527, 'NL', 'NLD', 'هولندا'),
(69005, 3276390528, 3276390535, 'DE', 'DEU', 'ألمانيا'),
(69006, 3276390536, 3276390591, 'NL', 'NLD', 'هولندا'),
(69007, 3276390592, 3276390599, 'DE', 'DEU', 'ألمانيا'),
(69008, 3276390600, 3276390687, 'NL', 'NLD', 'هولندا'),
(69009, 3276390688, 3276390695, 'DE', 'DEU', 'ألمانيا'),
(69010, 3276390696, 3276390711, 'NL', 'NLD', 'هولندا'),
(69011, 3276390712, 3276390719, 'DE', 'DEU', 'ألمانيا'),
(69012, 3276390720, 3276390727, 'NL', 'NLD', 'هولندا'),
(69013, 3276390728, 3276390735, 'DE', 'DEU', 'ألمانيا'),
(69014, 3276390736, 3276390807, 'NL', 'NLD', 'هولندا'),
(69015, 3276390808, 3276390815, 'DE', 'DEU', 'ألمانيا'),
(69016, 3276390816, 3276390911, 'NL', 'NLD', 'هولندا'),
(69017, 3276390912, 3276390919, 'DE', 'DEU', 'ألمانيا'),
(69018, 3276390920, 3276390927, 'NL', 'NLD', 'هولندا'),
(69019, 3276390928, 3276390943, 'DE', 'DEU', 'ألمانيا'),
(69020, 3276390944, 3276390959, 'NL', 'NLD', 'هولندا'),
(69021, 3276390960, 3276390967, 'DE', 'DEU', 'ألمانيا'),
(69022, 3276390968, 3276390983, 'NL', 'NLD', 'هولندا'),
(69023, 3276390984, 3276390991, 'DE', 'DEU', 'ألمانيا'),
(69024, 3276390992, 3276391023, 'NL', 'NLD', 'هولندا'),
(69025, 3276391024, 3276391047, 'DE', 'DEU', 'ألمانيا'),
(69026, 3276391048, 3276391111, 'NL', 'NLD', 'هولندا'),
(69027, 3276391112, 3276391119, 'DE', 'DEU', 'ألمانيا'),
(69028, 3276391120, 3276391191, 'NL', 'NLD', 'هولندا'),
(69029, 3276391192, 3276391207, 'DE', 'DEU', 'ألمانيا'),
(69030, 3276391208, 3276391215, 'NL', 'NLD', 'هولندا'),
(69031, 3276391216, 3276391223, 'DE', 'DEU', 'ألمانيا'),
(69032, 3276391224, 3276391343, 'NL', 'NLD', 'هولندا'),
(69033, 3276391344, 3276391351, 'DE', 'DEU', 'ألمانيا'),
(69034, 3276391352, 3276391407, 'NL', 'NLD', 'هولندا'),
(69035, 3276391408, 3276391415, 'DE', 'DEU', 'ألمانيا'),
(69036, 3276391416, 3276391439, 'NL', 'NLD', 'هولندا'),
(69037, 3276391440, 3276391447, 'DE', 'DEU', 'ألمانيا'),
(69038, 3276391448, 3276391495, 'NL', 'NLD', 'هولندا'),
(69039, 3276391496, 3276391503, 'DE', 'DEU', 'ألمانيا'),
(69040, 3276391504, 3276391535, 'NL', 'NLD', 'هولندا'),
(69041, 3276391536, 3276391543, 'DE', 'DEU', 'ألمانيا'),
(69042, 3276391544, 3276391591, 'NL', 'NLD', 'هولندا'),
(69043, 3276391592, 3276391599, 'DE', 'DEU', 'ألمانيا'),
(69044, 3276391600, 3276391719, 'NL', 'NLD', 'هولندا'),
(69045, 3276391720, 3276391727, 'DE', 'DEU', 'ألمانيا'),
(69046, 3276391728, 3276391791, 'NL', 'NLD', 'هولندا'),
(69047, 3276391792, 3276391799, 'DE', 'DEU', 'ألمانيا'),
(69048, 3276391800, 3276391815, 'NL', 'NLD', 'هولندا'),
(69049, 3276391816, 3276391823, 'DE', 'DEU', 'ألمانيا'),
(69050, 3276391824, 3276391895, 'NL', 'NLD', 'هولندا'),
(69051, 3276391896, 3276391903, 'DE', 'DEU', 'ألمانيا'),
(69052, 3276391904, 3276391935, 'NL', 'NLD', 'هولندا'),
(69053, 3276391936, 3276391943, 'DE', 'DEU', 'ألمانيا'),
(69054, 3276391944, 3276392079, 'NL', 'NLD', 'هولندا'),
(69055, 3276392080, 3276392087, 'DE', 'DEU', 'ألمانيا'),
(69056, 3276392088, 3276392119, 'NL', 'NLD', 'هولندا'),
(69057, 3276392120, 3276392127, 'DE', 'DEU', 'ألمانيا'),
(69058, 3276392128, 3276392143, 'NL', 'NLD', 'هولندا'),
(69059, 3276392144, 3276392151, 'DE', 'DEU', 'ألمانيا'),
(69060, 3276392152, 3276392239, 'NL', 'NLD', 'هولندا'),
(69061, 3276392240, 3276392247, 'DE', 'DEU', 'ألمانيا'),
(69062, 3276392248, 3276392255, 'NL', 'NLD', 'هولندا'),
(69063, 3276392256, 3276392263, 'DE', 'DEU', 'ألمانيا'),
(69064, 3276392264, 3276392279, 'NL', 'NLD', 'هولندا'),
(69065, 3276392280, 3276392287, 'DE', 'DEU', 'ألمانيا'),
(69066, 3276392288, 3276392319, 'NL', 'NLD', 'هولندا'),
(69067, 3276392320, 3276392327, 'DE', 'DEU', 'ألمانيا'),
(69068, 3276392328, 3276392351, 'NL', 'NLD', 'هولندا'),
(69069, 3276392352, 3276392359, 'DE', 'DEU', 'ألمانيا'),
(69070, 3276392360, 3276392423, 'NL', 'NLD', 'هولندا'),
(69071, 3276392424, 3276392431, 'DE', 'DEU', 'ألمانيا'),
(69072, 3276392432, 3276392519, 'NL', 'NLD', 'هولندا'),
(69073, 3276392520, 3276392527, 'DE', 'DEU', 'ألمانيا'),
(69074, 3276392528, 3276392615, 'NL', 'NLD', 'هولندا'),
(69075, 3276392616, 3276392631, 'DE', 'DEU', 'ألمانيا'),
(69076, 3276392632, 3276392679, 'NL', 'NLD', 'هولندا'),
(69077, 3276392680, 3276392687, 'DE', 'DEU', 'ألمانيا'),
(69078, 3276392688, 3276392751, 'NL', 'NLD', 'هولندا'),
(69079, 3276392752, 3276392759, 'DE', 'DEU', 'ألمانيا'),
(69080, 3276392760, 3276392903, 'NL', 'NLD', 'هولندا'),
(69081, 3276392904, 3276392911, 'DE', 'DEU', 'ألمانيا'),
(69082, 3276392912, 3276392935, 'NL', 'NLD', 'هولندا'),
(69083, 3276392936, 3276392943, 'DE', 'DEU', 'ألمانيا'),
(69084, 3276392944, 3276392959, 'NL', 'NLD', 'هولندا'),
(69085, 3276392960, 3276392967, 'DE', 'DEU', 'ألمانيا'),
(69086, 3276392968, 3276392991, 'NL', 'NLD', 'هولندا'),
(69087, 3276392992, 3276392999, 'DE', 'DEU', 'ألمانيا'),
(69088, 3276393000, 3276393007, 'NL', 'NLD', 'هولندا'),
(69089, 3276393008, 3276393023, 'DE', 'DEU', 'ألمانيا'),
(69090, 3276393024, 3276393159, 'NL', 'NLD', 'هولندا'),
(69091, 3276393160, 3276393167, 'DE', 'DEU', 'ألمانيا'),
(69092, 3276393168, 3276393399, 'NL', 'NLD', 'هولندا'),
(69093, 3276393400, 3276393407, 'DE', 'DEU', 'ألمانيا'),
(69094, 3276393408, 3276393423, 'NL', 'NLD', 'هولندا'),
(69095, 3276393424, 3276393431, 'DE', 'DEU', 'ألمانيا'),
(69096, 3276393432, 3276393447, 'NL', 'NLD', 'هولندا'),
(69097, 3276393448, 3276393455, 'DE', 'DEU', 'ألمانيا'),
(69098, 3276393456, 3276393463, 'NL', 'NLD', 'هولندا'),
(69099, 3276393464, 3276393479, 'DE', 'DEU', 'ألمانيا'),
(69100, 3276393480, 3276393511, 'NL', 'NLD', 'هولندا'),
(69101, 3276393512, 3276393519, 'DE', 'DEU', 'ألمانيا'),
(69102, 3276393520, 3276393599, 'NL', 'NLD', 'هولندا'),
(69103, 3276393600, 3276393615, 'DE', 'DEU', 'ألمانيا'),
(69104, 3276393616, 3276393695, 'NL', 'NLD', 'هولندا'),
(69105, 3276393696, 3276393703, 'DE', 'DEU', 'ألمانيا'),
(69106, 3276393704, 3276393783, 'NL', 'NLD', 'هولندا'),
(69107, 3276393784, 3276393791, 'DE', 'DEU', 'ألمانيا'),
(69108, 3276393792, 3276393799, 'NL', 'NLD', 'هولندا'),
(69109, 3276393800, 3276393815, 'DE', 'DEU', 'ألمانيا'),
(69110, 3276393816, 3276393823, 'NL', 'NLD', 'هولندا'),
(69111, 3276393824, 3276393831, 'DE', 'DEU', 'ألمانيا'),
(69112, 3276393832, 3276393871, 'NL', 'NLD', 'هولندا'),
(69113, 3276393872, 3276393879, 'DE', 'DEU', 'ألمانيا'),
(69114, 3276393880, 3276393903, 'NL', 'NLD', 'هولندا'),
(69115, 3276393904, 3276393911, 'DE', 'DEU', 'ألمانيا'),
(69116, 3276393912, 3276393983, 'NL', 'NLD', 'هولندا'),
(69117, 3276393984, 3276393999, 'DE', 'DEU', 'ألمانيا'),
(69118, 3276394000, 3276394015, 'NL', 'NLD', 'هولندا'),
(69119, 3276394016, 3276394023, 'DE', 'DEU', 'ألمانيا'),
(69120, 3276394024, 3276394063, 'NL', 'NLD', 'هولندا'),
(69121, 3276394064, 3276394071, 'DE', 'DEU', 'ألمانيا'),
(69122, 3276394072, 3276394191, 'NL', 'NLD', 'هولندا'),
(69123, 3276394192, 3276394199, 'DE', 'DEU', 'ألمانيا'),
(69124, 3276394200, 3276394215, 'NL', 'NLD', 'هولندا'),
(69125, 3276394216, 3276394223, 'DE', 'DEU', 'ألمانيا'),
(69126, 3276394224, 3276394279, 'NL', 'NLD', 'هولندا'),
(69127, 3276394280, 3276394287, 'DE', 'DEU', 'ألمانيا'),
(69128, 3276394288, 3276394327, 'NL', 'NLD', 'هولندا'),
(69129, 3276394328, 3276394335, 'DE', 'DEU', 'ألمانيا'),
(69130, 3276394336, 3276394351, 'NL', 'NLD', 'هولندا'),
(69131, 3276394352, 3276394359, 'DE', 'DEU', 'ألمانيا'),
(69132, 3276394360, 3276394471, 'NL', 'NLD', 'هولندا'),
(69133, 3276394472, 3276394487, 'DE', 'DEU', 'ألمانيا'),
(69134, 3276394488, 3276394495, 'NL', 'NLD', 'هولندا'),
(69135, 3276394496, 3276394511, 'DE', 'DEU', 'ألمانيا'),
(69136, 3276394512, 3276394575, 'NL', 'NLD', 'هولندا'),
(69137, 3276394576, 3276394591, 'DE', 'DEU', 'ألمانيا'),
(69138, 3276394592, 3276394671, 'NL', 'NLD', 'هولندا'),
(69139, 3276394672, 3276394687, 'DE', 'DEU', 'ألمانيا'),
(69140, 3276394688, 3276394695, 'NL', 'NLD', 'هولندا'),
(69141, 3276394696, 3276394703, 'DE', 'DEU', 'ألمانيا'),
(69142, 3276394704, 3276394775, 'NL', 'NLD', 'هولندا'),
(69143, 3276394776, 3276394783, 'DE', 'DEU', 'ألمانيا'),
(69144, 3276394784, 3276394815, 'NL', 'NLD', 'هولندا'),
(69145, 3276394816, 3276394823, 'DE', 'DEU', 'ألمانيا'),
(69146, 3276394824, 3276394871, 'NL', 'NLD', 'هولندا'),
(69147, 3276394872, 3276394879, 'DE', 'DEU', 'ألمانيا'),
(69148, 3276394880, 3276394919, 'NL', 'NLD', 'هولندا'),
(69149, 3276394920, 3276394927, 'DE', 'DEU', 'ألمانيا'),
(69150, 3276394928, 3276394951, 'NL', 'NLD', 'هولندا'),
(69151, 3276394952, 3276394959, 'DE', 'DEU', 'ألمانيا'),
(69152, 3276394960, 3276395047, 'NL', 'NLD', 'هولندا'),
(69153, 3276395048, 3276395055, 'DE', 'DEU', 'ألمانيا'),
(69154, 3276395056, 3276395063, 'NL', 'NLD', 'هولندا'),
(69155, 3276395064, 3276395071, 'DE', 'DEU', 'ألمانيا'),
(69156, 3276395072, 3276395095, 'NL', 'NLD', 'هولندا'),
(69157, 3276395096, 3276395103, 'DE', 'DEU', 'ألمانيا'),
(69158, 3276395104, 3276395175, 'NL', 'NLD', 'هولندا'),
(69159, 3276395176, 3276395183, 'DE', 'DEU', 'ألمانيا'),
(69160, 3276395184, 3276395191, 'NL', 'NLD', 'هولندا'),
(69161, 3276395192, 3276395199, 'DE', 'DEU', 'ألمانيا'),
(69162, 3276395200, 3276395295, 'NL', 'NLD', 'هولندا'),
(69163, 3276395296, 3276395303, 'DE', 'DEU', 'ألمانيا'),
(69164, 3276395304, 3276395319, 'NL', 'NLD', 'هولندا'),
(69165, 3276395320, 3276395327, 'DE', 'DEU', 'ألمانيا'),
(69166, 3276395328, 3276395423, 'NL', 'NLD', 'هولندا'),
(69167, 3276395424, 3276395439, 'DE', 'DEU', 'ألمانيا'),
(69168, 3276395440, 3276395487, 'NL', 'NLD', 'هولندا'),
(69169, 3276395488, 3276395495, 'DE', 'DEU', 'ألمانيا'),
(69170, 3276395496, 3276395543, 'NL', 'NLD', 'هولندا'),
(69171, 3276395544, 3276395551, 'DE', 'DEU', 'ألمانيا'),
(69172, 3276395552, 3276395567, 'NL', 'NLD', 'هولندا'),
(69173, 3276395568, 3276395575, 'DE', 'DEU', 'ألمانيا'),
(69174, 3276395576, 3276395599, 'NL', 'NLD', 'هولندا'),
(69175, 3276395600, 3276395607, 'DE', 'DEU', 'ألمانيا'),
(69176, 3276395608, 3276395647, 'NL', 'NLD', 'هولندا'),
(69177, 3276395648, 3276395655, 'DE', 'DEU', 'ألمانيا'),
(69178, 3276395656, 3276395687, 'NL', 'NLD', 'هولندا'),
(69179, 3276395688, 3276395695, 'DE', 'DEU', 'ألمانيا'),
(69180, 3276395696, 3276395743, 'NL', 'NLD', 'هولندا'),
(69181, 3276395744, 3276395751, 'DE', 'DEU', 'ألمانيا'),
(69182, 3276395752, 3276395759, 'NL', 'NLD', 'هولندا'),
(69183, 3276395760, 3276395767, 'DE', 'DEU', 'ألمانيا'),
(69184, 3276395768, 3276395807, 'NL', 'NLD', 'هولندا'),
(69185, 3276395808, 3276395815, 'DE', 'DEU', 'ألمانيا'),
(69186, 3276395816, 3276395831, 'NL', 'NLD', 'هولندا'),
(69187, 3276395832, 3276395839, 'DE', 'DEU', 'ألمانيا'),
(69188, 3276395840, 3276395871, 'NL', 'NLD', 'هولندا'),
(69189, 3276395872, 3276395879, 'DE', 'DEU', 'ألمانيا'),
(69190, 3276395880, 3276395959, 'NL', 'NLD', 'هولندا'),
(69191, 3276395960, 3276395975, 'DE', 'DEU', 'ألمانيا'),
(69192, 3276395976, 3276396007, 'NL', 'NLD', 'هولندا'),
(69193, 3276396008, 3276396023, 'DE', 'DEU', 'ألمانيا'),
(69194, 3276396024, 3276396047, 'NL', 'NLD', 'هولندا'),
(69195, 3276396048, 3276396055, 'DE', 'DEU', 'ألمانيا'),
(69196, 3276396056, 3276396095, 'NL', 'NLD', 'هولندا'),
(69197, 3276396096, 3276396103, 'DE', 'DEU', 'ألمانيا'),
(69198, 3276396104, 3276396111, 'NL', 'NLD', 'هولندا'),
(69199, 3276396112, 3276396119, 'DE', 'DEU', 'ألمانيا'),
(69200, 3276396120, 3276396207, 'NL', 'NLD', 'هولندا'),
(69201, 3276396208, 3276396223, 'DE', 'DEU', 'ألمانيا'),
(69202, 3276396224, 3276396287, 'NL', 'NLD', 'هولندا'),
(69203, 3276396288, 3276396295, 'DE', 'DEU', 'ألمانيا'),
(69204, 3276396296, 3276396319, 'NL', 'NLD', 'هولندا'),
(69205, 3276396320, 3276396327, 'DE', 'DEU', 'ألمانيا'),
(69206, 3276396328, 3276396351, 'NL', 'NLD', 'هولندا'),
(69207, 3276396352, 3276396359, 'DE', 'DEU', 'ألمانيا'),
(69208, 3276396360, 3276396399, 'NL', 'NLD', 'هولندا'),
(69209, 3276396400, 3276396415, 'DE', 'DEU', 'ألمانيا'),
(69210, 3276396416, 3276396431, 'NL', 'NLD', 'هولندا'),
(69211, 3276396432, 3276396439, 'DE', 'DEU', 'ألمانيا'),
(69212, 3276396440, 3276396471, 'NL', 'NLD', 'هولندا'),
(69213, 3276396472, 3276396495, 'DE', 'DEU', 'ألمانيا'),
(69214, 3276396496, 3276396527, 'NL', 'NLD', 'هولندا'),
(69215, 3276396528, 3276396535, 'DE', 'DEU', 'ألمانيا'),
(69216, 3276396536, 3276396583, 'NL', 'NLD', 'هولندا'),
(69217, 3276396584, 3276396591, 'DE', 'DEU', 'ألمانيا'),
(69218, 3276396592, 3276396599, 'NL', 'NLD', 'هولندا'),
(69219, 3276396600, 3276396607, 'DE', 'DEU', 'ألمانيا'),
(69220, 3276396608, 3276396615, 'NL', 'NLD', 'هولندا'),
(69221, 3276396616, 3276396623, 'DE', 'DEU', 'ألمانيا'),
(69222, 3276396624, 3276396655, 'NL', 'NLD', 'هولندا'),
(69223, 3276396656, 3276396663, 'DE', 'DEU', 'ألمانيا'),
(69224, 3276396664, 3276396719, 'NL', 'NLD', 'هولندا'),
(69225, 3276396720, 3276396735, 'DE', 'DEU', 'ألمانيا'),
(69226, 3276396736, 3276396759, 'NL', 'NLD', 'هولندا'),
(69227, 3276396760, 3276396767, 'DE', 'DEU', 'ألمانيا'),
(69228, 3276396768, 3276396783, 'NL', 'NLD', 'هولندا'),
(69229, 3276396784, 3276396791, 'DE', 'DEU', 'ألمانيا'),
(69230, 3276396792, 3276396991, 'NL', 'NLD', 'هولندا'),
(69231, 3276396992, 3276397007, 'DE', 'DEU', 'ألمانيا'),
(69232, 3276397008, 3276397031, 'NL', 'NLD', 'هولندا'),
(69233, 3276397032, 3276397039, 'DE', 'DEU', 'ألمانيا'),
(69234, 3276397040, 3276397055, 'NL', 'NLD', 'هولندا'),
(69235, 3276397056, 3276397063, 'DE', 'DEU', 'ألمانيا'),
(69236, 3276397064, 3276397215, 'NL', 'NLD', 'هولندا'),
(69237, 3276397216, 3276397223, 'DE', 'DEU', 'ألمانيا'),
(69238, 3276397224, 3276397327, 'NL', 'NLD', 'هولندا'),
(69239, 3276397328, 3276397335, 'DE', 'DEU', 'ألمانيا'),
(69240, 3276397336, 3276397343, 'NL', 'NLD', 'هولندا'),
(69241, 3276397344, 3276397351, 'DE', 'DEU', 'ألمانيا'),
(69242, 3276397352, 3276397479, 'NL', 'NLD', 'هولندا'),
(69243, 3276397480, 3276397487, 'DE', 'DEU', 'ألمانيا'),
(69244, 3276397488, 3276397535, 'NL', 'NLD', 'هولندا'),
(69245, 3276397536, 3276397543, 'DE', 'DEU', 'ألمانيا'),
(69246, 3276397544, 3276397559, 'NL', 'NLD', 'هولندا'),
(69247, 3276397560, 3276397567, 'DE', 'DEU', 'ألمانيا'),
(69248, 3276397568, 3276397743, 'NL', 'NLD', 'هولندا'),
(69249, 3276397744, 3276397751, 'DE', 'DEU', 'ألمانيا'),
(69250, 3276397752, 3276397791, 'NL', 'NLD', 'هولندا'),
(69251, 3276397792, 3276397815, 'DE', 'DEU', 'ألمانيا'),
(69252, 3276397816, 3276397871, 'NL', 'NLD', 'هولندا'),
(69253, 3276397872, 3276397879, 'DE', 'DEU', 'ألمانيا'),
(69254, 3276397880, 3276397895, 'NL', 'NLD', 'هولندا'),
(69255, 3276397896, 3276397911, 'DE', 'DEU', 'ألمانيا'),
(69256, 3276397912, 3276397935, 'NL', 'NLD', 'هولندا'),
(69257, 3276397936, 3276397943, 'DE', 'DEU', 'ألمانيا'),
(69258, 3276397944, 3276397967, 'NL', 'NLD', 'هولندا'),
(69259, 3276397968, 3276397975, 'DE', 'DEU', 'ألمانيا'),
(69260, 3276397976, 3276397983, 'NL', 'NLD', 'هولندا'),
(69261, 3276397984, 3276397991, 'DE', 'DEU', 'ألمانيا'),
(69262, 3276397992, 3276398047, 'NL', 'NLD', 'هولندا'),
(69263, 3276398048, 3276398055, 'DE', 'DEU', 'ألمانيا'),
(69264, 3276398056, 3276398071, 'NL', 'NLD', 'هولندا'),
(69265, 3276398072, 3276398079, 'DE', 'DEU', 'ألمانيا'),
(69266, 3276398080, 3276398255, 'NL', 'NLD', 'هولندا'),
(69267, 3276398256, 3276398271, 'DE', 'DEU', 'ألمانيا'),
(69268, 3276398272, 3276398287, 'NL', 'NLD', 'هولندا'),
(69269, 3276398288, 3276398295, 'DE', 'DEU', 'ألمانيا'),
(69270, 3276398296, 3276398311, 'NL', 'NLD', 'هولندا'),
(69271, 3276398312, 3276398319, 'DE', 'DEU', 'ألمانيا'),
(69272, 3276398320, 3276398351, 'NL', 'NLD', 'هولندا'),
(69273, 3276398352, 3276398359, 'DE', 'DEU', 'ألمانيا'),
(69274, 3276398360, 3276398367, 'NL', 'NLD', 'هولندا'),
(69275, 3276398368, 3276398375, 'DE', 'DEU', 'ألمانيا'),
(69276, 3276398376, 3276398423, 'NL', 'NLD', 'هولندا'),
(69277, 3276398424, 3276398447, 'DE', 'DEU', 'ألمانيا'),
(69278, 3276398448, 3276398455, 'NL', 'NLD', 'هولندا'),
(69279, 3276398456, 3276398463, 'DE', 'DEU', 'ألمانيا'),
(69280, 3276398464, 3276398511, 'NL', 'NLD', 'هولندا'),
(69281, 3276398512, 3276398519, 'DE', 'DEU', 'ألمانيا'),
(69282, 3276398520, 3276398559, 'NL', 'NLD', 'هولندا'),
(69283, 3276398560, 3276398567, 'DE', 'DEU', 'ألمانيا'),
(69284, 3276398568, 3276398575, 'NL', 'NLD', 'هولندا'),
(69285, 3276398576, 3276398583, 'DE', 'DEU', 'ألمانيا'),
(69286, 3276398584, 3276398591, 'NL', 'NLD', 'هولندا'),
(69287, 3276398592, 3276398607, 'DE', 'DEU', 'ألمانيا'),
(69288, 3276398608, 3276398623, 'NL', 'NLD', 'هولندا'),
(69289, 3276398624, 3276398631, 'DE', 'DEU', 'ألمانيا'),
(69290, 3276398632, 3276398679, 'NL', 'NLD', 'هولندا'),
(69291, 3276398680, 3276398687, 'DE', 'DEU', 'ألمانيا'),
(69292, 3276398688, 3276398783, 'NL', 'NLD', 'هولندا'),
(69293, 3276398784, 3276398807, 'DE', 'DEU', 'ألمانيا'),
(69294, 3276398808, 3276398839, 'NL', 'NLD', 'هولندا'),
(69295, 3276398840, 3276398855, 'DE', 'DEU', 'ألمانيا'),
(69296, 3276398856, 3276398927, 'NL', 'NLD', 'هولندا'),
(69297, 3276398928, 3276398935, 'DE', 'DEU', 'ألمانيا'),
(69298, 3276398936, 3276398959, 'NL', 'NLD', 'هولندا'),
(69299, 3276398960, 3276398967, 'DE', 'DEU', 'ألمانيا'),
(69300, 3276398968, 3276398983, 'NL', 'NLD', 'هولندا'),
(69301, 3276398984, 3276398991, 'DE', 'DEU', 'ألمانيا'),
(69302, 3276398992, 3276399015, 'NL', 'NLD', 'هولندا'),
(69303, 3276399016, 3276399023, 'DE', 'DEU', 'ألمانيا'),
(69304, 3276399024, 3276399031, 'NL', 'NLD', 'هولندا'),
(69305, 3276399032, 3276399039, 'DE', 'DEU', 'ألمانيا'),
(69306, 3276399040, 3276399079, 'NL', 'NLD', 'هولندا'),
(69307, 3276399080, 3276399087, 'DE', 'DEU', 'ألمانيا'),
(69308, 3276399088, 3276399191, 'NL', 'NLD', 'هولندا'),
(69309, 3276399192, 3276399199, 'DE', 'DEU', 'ألمانيا'),
(69310, 3276399200, 3276399279, 'NL', 'NLD', 'هولندا'),
(69311, 3276399280, 3276399287, 'DE', 'DEU', 'ألمانيا'),
(69312, 3276399288, 3276399319, 'NL', 'NLD', 'هولندا'),
(69313, 3276399320, 3276399327, 'DE', 'DEU', 'ألمانيا'),
(69314, 3276399328, 3276399495, 'NL', 'NLD', 'هولندا'),
(69315, 3276399496, 3276399503, 'DE', 'DEU', 'ألمانيا'),
(69316, 3276399504, 3276399511, 'NL', 'NLD', 'هولندا'),
(69317, 3276399512, 3276399519, 'DE', 'DEU', 'ألمانيا'),
(69318, 3276399520, 3276399527, 'NL', 'NLD', 'هولندا'),
(69319, 3276399528, 3276399535, 'DE', 'DEU', 'ألمانيا'),
(69320, 3276399536, 3276399583, 'NL', 'NLD', 'هولندا'),
(69321, 3276399584, 3276399615, 'DE', 'DEU', 'ألمانيا'),
(69322, 3276399616, 3276399679, 'NL', 'NLD', 'هولندا'),
(69323, 3276399680, 3276399687, 'DE', 'DEU', 'ألمانيا'),
(69324, 3276399688, 3276399807, 'NL', 'NLD', 'هولندا'),
(69325, 3276399808, 3276399823, 'DE', 'DEU', 'ألمانيا'),
(69326, 3276399824, 3276399895, 'NL', 'NLD', 'هولندا'),
(69327, 3276399896, 3276399903, 'DE', 'DEU', 'ألمانيا'),
(69328, 3276399904, 3276399935, 'NL', 'NLD', 'هولندا'),
(69329, 3276399936, 3276399951, 'DE', 'DEU', 'ألمانيا'),
(69330, 3276399952, 3276399983, 'NL', 'NLD', 'هولندا'),
(69331, 3276399984, 3276399991, 'DE', 'DEU', 'ألمانيا'),
(69332, 3276399992, 3276400007, 'NL', 'NLD', 'هولندا'),
(69333, 3276400008, 3276400015, 'DE', 'DEU', 'ألمانيا'),
(69334, 3276400016, 3276400023, 'NL', 'NLD', 'هولندا'),
(69335, 3276400024, 3276400031, 'DE', 'DEU', 'ألمانيا'),
(69336, 3276400032, 3276400087, 'NL', 'NLD', 'هولندا'),
(69337, 3276400088, 3276400095, 'DE', 'DEU', 'ألمانيا'),
(69338, 3276400096, 3276400151, 'NL', 'NLD', 'هولندا'),
(69339, 3276400152, 3276400159, 'DE', 'DEU', 'ألمانيا'),
(69340, 3276400160, 3276400223, 'NL', 'NLD', 'هولندا'),
(69341, 3276400224, 3276400231, 'DE', 'DEU', 'ألمانيا'),
(69342, 3276400232, 3276400239, 'NL', 'NLD', 'هولندا'),
(69343, 3276400240, 3276400247, 'DE', 'DEU', 'ألمانيا'),
(69344, 3276400248, 3276400295, 'NL', 'NLD', 'هولندا'),
(69345, 3276400296, 3276400303, 'DE', 'DEU', 'ألمانيا'),
(69346, 3276400304, 3276400343, 'NL', 'NLD', 'هولندا'),
(69347, 3276400344, 3276400351, 'DE', 'DEU', 'ألمانيا'),
(69348, 3276400352, 3276400487, 'NL', 'NLD', 'هولندا'),
(69349, 3276400488, 3276400495, 'DE', 'DEU', 'ألمانيا'),
(69350, 3276400496, 3276400503, 'NL', 'NLD', 'هولندا'),
(69351, 3276400504, 3276400519, 'DE', 'DEU', 'ألمانيا'),
(69352, 3276400520, 3276400527, 'NL', 'NLD', 'هولندا'),
(69353, 3276400528, 3276400535, 'DE', 'DEU', 'ألمانيا'),
(69354, 3276400536, 3276400543, 'NL', 'NLD', 'هولندا'),
(69355, 3276400544, 3276400551, 'DE', 'DEU', 'ألمانيا'),
(69356, 3276400552, 3276400639, 'NL', 'NLD', 'هولندا'),
(69357, 3276400640, 3276400647, 'DE', 'DEU', 'ألمانيا'),
(69358, 3276400648, 3276400839, 'NL', 'NLD', 'هولندا'),
(69359, 3276400840, 3276400847, 'DE', 'DEU', 'ألمانيا'),
(69360, 3276400848, 3276400855, 'NL', 'NLD', 'هولندا'),
(69361, 3276400856, 3276400863, 'DE', 'DEU', 'ألمانيا'),
(69362, 3276400864, 3276400895, 'NL', 'NLD', 'هولندا'),
(69363, 3276400896, 3276400911, 'DE', 'DEU', 'ألمانيا'),
(69364, 3276400912, 3276401023, 'NL', 'NLD', 'هولندا'),
(69365, 3276401024, 3276401031, 'DE', 'DEU', 'ألمانيا'),
(69366, 3276401032, 3276401063, 'NL', 'NLD', 'هولندا'),
(69367, 3276401064, 3276401071, 'DE', 'DEU', 'ألمانيا'),
(69368, 3276401072, 3276401087, 'NL', 'NLD', 'هولندا'),
(69369, 3276401088, 3276401095, 'DE', 'DEU', 'ألمانيا'),
(69370, 3276401096, 3276401111, 'NL', 'NLD', 'هولندا'),
(69371, 3276401112, 3276401119, 'DE', 'DEU', 'ألمانيا'),
(69372, 3276401120, 3276401167, 'NL', 'NLD', 'هولندا'),
(69373, 3276401168, 3276401175, 'DE', 'DEU', 'ألمانيا'),
(69374, 3276401176, 3276401215, 'NL', 'NLD', 'هولندا'),
(69375, 3276401216, 3276401223, 'DE', 'DEU', 'ألمانيا'),
(69376, 3276401224, 3276401239, 'NL', 'NLD', 'هولندا'),
(69377, 3276401240, 3276401247, 'DE', 'DEU', 'ألمانيا'),
(69378, 3276401248, 3276401279, 'NL', 'NLD', 'هولندا'),
(69379, 3276401280, 3276401287, 'DE', 'DEU', 'ألمانيا'),
(69380, 3276401288, 3276401327, 'NL', 'NLD', 'هولندا'),
(69381, 3276401328, 3276401335, 'DE', 'DEU', 'ألمانيا'),
(69382, 3276401336, 3276401391, 'NL', 'NLD', 'هولندا'),
(69383, 3276401392, 3276401399, 'DE', 'DEU', 'ألمانيا'),
(69384, 3276401400, 3276401455, 'NL', 'NLD', 'هولندا'),
(69385, 3276401456, 3276401463, 'DE', 'DEU', 'ألمانيا'),
(69386, 3276401464, 3276401535, 'NL', 'NLD', 'هولندا'),
(69387, 3276401536, 3276401543, 'DE', 'DEU', 'ألمانيا'),
(69388, 3276401544, 3276401583, 'NL', 'NLD', 'هولندا'),
(69389, 3276401584, 3276401591, 'DE', 'DEU', 'ألمانيا'),
(69390, 3276401592, 3276401615, 'NL', 'NLD', 'هولندا'),
(69391, 3276401616, 3276401623, 'DE', 'DEU', 'ألمانيا'),
(69392, 3276401624, 3276401703, 'NL', 'NLD', 'هولندا'),
(69393, 3276401704, 3276401711, 'DE', 'DEU', 'ألمانيا'),
(69394, 3276401712, 3276401727, 'NL', 'NLD', 'هولندا'),
(69395, 3276401728, 3276401735, 'DE', 'DEU', 'ألمانيا'),
(69396, 3276401736, 3276401743, 'NL', 'NLD', 'هولندا'),
(69397, 3276401744, 3276401759, 'DE', 'DEU', 'ألمانيا'),
(69398, 3276401760, 3276401775, 'NL', 'NLD', 'هولندا'),
(69399, 3276401776, 3276401783, 'DE', 'DEU', 'ألمانيا'),
(69400, 3276401784, 3276401855, 'NL', 'NLD', 'هولندا'),
(69401, 3276401856, 3276401863, 'DE', 'DEU', 'ألمانيا'),
(69402, 3276401864, 3276401919, 'NL', 'NLD', 'هولندا'),
(69403, 3276401920, 3276401927, 'DE', 'DEU', 'ألمانيا'),
(69404, 3276401928, 3276401943, 'NL', 'NLD', 'هولندا'),
(69405, 3276401944, 3276401959, 'DE', 'DEU', 'ألمانيا'),
(69406, 3276401960, 3276401975, 'NL', 'NLD', 'هولندا'),
(69407, 3276401976, 3276401983, 'DE', 'DEU', 'ألمانيا'),
(69408, 3276401984, 3276401991, 'NL', 'NLD', 'هولندا'),
(69409, 3276401992, 3276402007, 'DE', 'DEU', 'ألمانيا'),
(69410, 3276402008, 3276402055, 'NL', 'NLD', 'هولندا'),
(69411, 3276402056, 3276402063, 'DE', 'DEU', 'ألمانيا'),
(69412, 3276402064, 3276402271, 'NL', 'NLD', 'هولندا'),
(69413, 3276402272, 3276402279, 'DE', 'DEU', 'ألمانيا'),
(69414, 3276402280, 3276402303, 'NL', 'NLD', 'هولندا'),
(69415, 3276402304, 3276402311, 'DE', 'DEU', 'ألمانيا'),
(69416, 3276402312, 3276402327, 'NL', 'NLD', 'هولندا'),
(69417, 3276402328, 3276402351, 'DE', 'DEU', 'ألمانيا'),
(69418, 3276402352, 3276402383, 'NL', 'NLD', 'هولندا'),
(69419, 3276402384, 3276402391, 'DE', 'DEU', 'ألمانيا'),
(69420, 3276402392, 3276402415, 'NL', 'NLD', 'هولندا'),
(69421, 3276402416, 3276402423, 'DE', 'DEU', 'ألمانيا'),
(69422, 3276402424, 3276402439, 'NL', 'NLD', 'هولندا'),
(69423, 3276402440, 3276402447, 'DE', 'DEU', 'ألمانيا'),
(69424, 3276402448, 3276402503, 'NL', 'NLD', 'هولندا'),
(69425, 3276402504, 3276402511, 'DE', 'DEU', 'ألمانيا'),
(69426, 3276402512, 3276402519, 'NL', 'NLD', 'هولندا'),
(69427, 3276402520, 3276402527, 'DE', 'DEU', 'ألمانيا'),
(69428, 3276402528, 3276402591, 'NL', 'NLD', 'هولندا'),
(69429, 3276402592, 3276402599, 'DE', 'DEU', 'ألمانيا'),
(69430, 3276402600, 3276402607, 'NL', 'NLD', 'هولندا'),
(69431, 3276402608, 3276402615, 'DE', 'DEU', 'ألمانيا'),
(69432, 3276402616, 3276402639, 'NL', 'NLD', 'هولندا'),
(69433, 3276402640, 3276402647, 'DE', 'DEU', 'ألمانيا'),
(69434, 3276402648, 3276402655, 'NL', 'NLD', 'هولندا'),
(69435, 3276402656, 3276402671, 'DE', 'DEU', 'ألمانيا'),
(69436, 3276402672, 3276402711, 'NL', 'NLD', 'هولندا'),
(69437, 3276402712, 3276402719, 'DE', 'DEU', 'ألمانيا'),
(69438, 3276402720, 3276402735, 'NL', 'NLD', 'هولندا'),
(69439, 3276402736, 3276402743, 'DE', 'DEU', 'ألمانيا'),
(69440, 3276402744, 3276402759, 'NL', 'NLD', 'هولندا'),
(69441, 3276402760, 3276402767, 'DE', 'DEU', 'ألمانيا'),
(69442, 3276402768, 3276402783, 'NL', 'NLD', 'هولندا'),
(69443, 3276402784, 3276402791, 'DE', 'DEU', 'ألمانيا'),
(69444, 3276402792, 3276402847, 'NL', 'NLD', 'هولندا'),
(69445, 3276402848, 3276402855, 'DE', 'DEU', 'ألمانيا'),
(69446, 3276402856, 3276402959, 'NL', 'NLD', 'هولندا'),
(69447, 3276402960, 3276402967, 'DE', 'DEU', 'ألمانيا'),
(69448, 3276402968, 3276402975, 'NL', 'NLD', 'هولندا'),
(69449, 3276402976, 3276402983, 'DE', 'DEU', 'ألمانيا'),
(69450, 3276402984, 3276403007, 'NL', 'NLD', 'هولندا'),
(69451, 3276403008, 3276403015, 'DE', 'DEU', 'ألمانيا'),
(69452, 3276403016, 3276403023, 'NL', 'NLD', 'هولندا'),
(69453, 3276403024, 3276403031, 'DE', 'DEU', 'ألمانيا'),
(69454, 3276403032, 3276403047, 'NL', 'NLD', 'هولندا'),
(69455, 3276403048, 3276403055, 'DE', 'DEU', 'ألمانيا'),
(69456, 3276403056, 3276403135, 'NL', 'NLD', 'هولندا'),
(69457, 3276403136, 3276403143, 'DE', 'DEU', 'ألمانيا'),
(69458, 3276403144, 3276403151, 'NL', 'NLD', 'هولندا'),
(69459, 3276403152, 3276403159, 'DE', 'DEU', 'ألمانيا'),
(69460, 3276403160, 3276403167, 'NL', 'NLD', 'هولندا'),
(69461, 3276403168, 3276403191, 'DE', 'DEU', 'ألمانيا'),
(69462, 3276403192, 3276403239, 'NL', 'NLD', 'هولندا'),
(69463, 3276403240, 3276403247, 'DE', 'DEU', 'ألمانيا'),
(69464, 3276403248, 3276403271, 'NL', 'NLD', 'هولندا'),
(69465, 3276403272, 3276403279, 'DE', 'DEU', 'ألمانيا'),
(69466, 3276403280, 3276403287, 'NL', 'NLD', 'هولندا'),
(69467, 3276403288, 3276403295, 'DE', 'DEU', 'ألمانيا'),
(69468, 3276403296, 3276403343, 'NL', 'NLD', 'هولندا'),
(69469, 3276403344, 3276403351, 'DE', 'DEU', 'ألمانيا'),
(69470, 3276403352, 3276403367, 'NL', 'NLD', 'هولندا'),
(69471, 3276403368, 3276403375, 'DE', 'DEU', 'ألمانيا'),
(69472, 3276403376, 3276403399, 'NL', 'NLD', 'هولندا'),
(69473, 3276403400, 3276403407, 'DE', 'DEU', 'ألمانيا'),
(69474, 3276403408, 3276403479, 'NL', 'NLD', 'هولندا'),
(69475, 3276403480, 3276403487, 'DE', 'DEU', 'ألمانيا'),
(69476, 3276403488, 3276403495, 'NL', 'NLD', 'هولندا'),
(69477, 3276403496, 3276403503, 'DE', 'DEU', 'ألمانيا'),
(69478, 3276403504, 3276403511, 'NL', 'NLD', 'هولندا'),
(69479, 3276403512, 3276403519, 'DE', 'DEU', 'ألمانيا'),
(69480, 3276403520, 3276403527, 'NL', 'NLD', 'هولندا'),
(69481, 3276403528, 3276403535, 'DE', 'DEU', 'ألمانيا'),
(69482, 3276403536, 3276403567, 'NL', 'NLD', 'هولندا'),
(69483, 3276403568, 3276403583, 'DE', 'DEU', 'ألمانيا'),
(69484, 3276403584, 3276403679, 'NL', 'NLD', 'هولندا'),
(69485, 3276403680, 3276403687, 'DE', 'DEU', 'ألمانيا'),
(69486, 3276403688, 3276403799, 'NL', 'NLD', 'هولندا'),
(69487, 3276403800, 3276403807, 'DE', 'DEU', 'ألمانيا'),
(69488, 3276403808, 3276403839, 'NL', 'NLD', 'هولندا'),
(69489, 3276403840, 3276403847, 'DE', 'DEU', 'ألمانيا'),
(69490, 3276403848, 3276403967, 'NL', 'NLD', 'هولندا'),
(69491, 3276403968, 3276403975, 'DE', 'DEU', 'ألمانيا'),
(69492, 3276403976, 3276403983, 'NL', 'NLD', 'هولندا'),
(69493, 3276403984, 3276403991, 'DE', 'DEU', 'ألمانيا'),
(69494, 3276403992, 3276404023, 'NL', 'NLD', 'هولندا'),
(69495, 3276404024, 3276404031, 'DE', 'DEU', 'ألمانيا'),
(69496, 3276404032, 3276404047, 'NL', 'NLD', 'هولندا'),
(69497, 3276404048, 3276404055, 'DE', 'DEU', 'ألمانيا'),
(69498, 3276404056, 3276404079, 'NL', 'NLD', 'هولندا'),
(69499, 3276404080, 3276404087, 'DE', 'DEU', 'ألمانيا'),
(69500, 3276404088, 3276404119, 'NL', 'NLD', 'هولندا'),
(69501, 3276404120, 3276404127, 'DE', 'DEU', 'ألمانيا'),
(69502, 3276404128, 3276404399, 'NL', 'NLD', 'هولندا'),
(69503, 3276404400, 3276404407, 'DE', 'DEU', 'ألمانيا'),
(69504, 3276404408, 3276404447, 'NL', 'NLD', 'هولندا'),
(69505, 3276404448, 3276404455, 'DE', 'DEU', 'ألمانيا'),
(69506, 3276404456, 3276404479, 'NL', 'NLD', 'هولندا'),
(69507, 3276404480, 3276404487, 'DE', 'DEU', 'ألمانيا'),
(69508, 3276404488, 3276404639, 'NL', 'NLD', 'هولندا'),
(69509, 3276404640, 3276404647, 'DE', 'DEU', 'ألمانيا'),
(69510, 3276404648, 3276404719, 'NL', 'NLD', 'هولندا'),
(69511, 3276404720, 3276404743, 'DE', 'DEU', 'ألمانيا'),
(69512, 3276404744, 3276404903, 'NL', 'NLD', 'هولندا'),
(69513, 3276404904, 3276404911, 'DE', 'DEU', 'ألمانيا'),
(69514, 3276404912, 3276404935, 'NL', 'NLD', 'هولندا'),
(69515, 3276404936, 3276404943, 'DE', 'DEU', 'ألمانيا'),
(69516, 3276404944, 3276405023, 'NL', 'NLD', 'هولندا'),
(69517, 3276405024, 3276405031, 'DE', 'DEU', 'ألمانيا'),
(69518, 3276405032, 3276405063, 'NL', 'NLD', 'هولندا'),
(69519, 3276405064, 3276405079, 'DE', 'DEU', 'ألمانيا'),
(69520, 3276405080, 3276405263, 'NL', 'NLD', 'هولندا'),
(69521, 3276405264, 3276405271, 'DE', 'DEU', 'ألمانيا'),
(69522, 3276405272, 3276405327, 'NL', 'NLD', 'هولندا'),
(69523, 3276405328, 3276405335, 'DE', 'DEU', 'ألمانيا'),
(69524, 3276405336, 3276405391, 'NL', 'NLD', 'هولندا'),
(69525, 3276405392, 3276405399, 'DE', 'DEU', 'ألمانيا'),
(69526, 3276405400, 3276405679, 'NL', 'NLD', 'هولندا'),
(69527, 3276405680, 3276405687, 'DE', 'DEU', 'ألمانيا'),
(69528, 3276405688, 3276405719, 'NL', 'NLD', 'هولندا'),
(69529, 3276405720, 3276405735, 'DE', 'DEU', 'ألمانيا'),
(69530, 3276405736, 3276405759, 'NL', 'NLD', 'هولندا'),
(69531, 3276405760, 3276405767, 'DE', 'DEU', 'ألمانيا'),
(69532, 3276405768, 3276405775, 'NL', 'NLD', 'هولندا'),
(69533, 3276405776, 3276405783, 'DE', 'DEU', 'ألمانيا'),
(69534, 3276405784, 3276405943, 'NL', 'NLD', 'هولندا'),
(69535, 3276405944, 3276405951, 'DE', 'DEU', 'ألمانيا'),
(69536, 3276405952, 3276406159, 'NL', 'NLD', 'هولندا'),
(69537, 3276406160, 3276406167, 'DE', 'DEU', 'ألمانيا'),
(69538, 3276406168, 3276406175, 'NL', 'NLD', 'هولندا'),
(69539, 3276406176, 3276406183, 'DE', 'DEU', 'ألمانيا'),
(69540, 3276406184, 3276406207, 'NL', 'NLD', 'هولندا'),
(69541, 3276406208, 3276406215, 'DE', 'DEU', 'ألمانيا'),
(69542, 3276406216, 3276406287, 'NL', 'NLD', 'هولندا'),
(69543, 3276406288, 3276406295, 'DE', 'DEU', 'ألمانيا'),
(69544, 3276406296, 3276406375, 'NL', 'NLD', 'هولندا'),
(69545, 3276406376, 3276406383, 'DE', 'DEU', 'ألمانيا'),
(69546, 3276406384, 3276406407, 'NL', 'NLD', 'هولندا'),
(69547, 3276406408, 3276406415, 'DE', 'DEU', 'ألمانيا'),
(69548, 3276406416, 3276406511, 'NL', 'NLD', 'هولندا'),
(69549, 3276406512, 3276406519, 'DE', 'DEU', 'ألمانيا'),
(69550, 3276406520, 3276406559, 'NL', 'NLD', 'هولندا'),
(69551, 3276406560, 3276406567, 'DE', 'DEU', 'ألمانيا'),
(69552, 3276406568, 3276406639, 'NL', 'NLD', 'هولندا'),
(69553, 3276406640, 3276406647, 'DE', 'DEU', 'ألمانيا'),
(69554, 3276406648, 3276406759, 'NL', 'NLD', 'هولندا'),
(69555, 3276406760, 3276406767, 'DE', 'DEU', 'ألمانيا'),
(69556, 3276406768, 3276406783, 'NL', 'NLD', 'هولندا'),
(69557, 3276406784, 3276414975, 'FI', 'FIN', 'فنلندا'),
(69558, 3276414976, 3276415999, 'DK', 'DNK', 'الدنيمارك'),
(69559, 3276416000, 3276417023, 'SE', 'SWE', 'السويد'),
(69560, 3276417024, 3276419071, 'DE', 'DEU', 'ألمانيا'),
(69561, 3276419072, 3276420095, 'PL', 'POL', 'بولندا'),
(69562, 3276420096, 3276421119, 'GB', 'GBR', 'المملكة المتحدة'),
(69563, 3276421120, 3276422143, 'PL', 'POL', 'بولندا'),
(69564, 3276422144, 3276422655, 'GB', 'GBR', 'المملكة المتحدة'),
(69565, 3276422656, 3276423167, 'RU', 'RUS', 'الإتحاد الروسي'),
(69566, 3276423168, 3276423423, 'PL', 'POL', 'بولندا'),
(69567, 3276423424, 3276423679, 'NL', 'NLD', 'هولندا'),
(69568, 3276423680, 3276423935, 'SE', 'SWE', 'السويد'),
(69569, 3276423936, 3276424191, 'UA', 'UKR', 'أوكرانيا'),
(69570, 3276424192, 3276424447, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(69571, 3276424448, 3276424703, 'PL', 'POL', 'بولندا'),
(69572, 3276424704, 3276424959, 'DE', 'DEU', 'ألمانيا'),
(69573, 3276424960, 3276425215, 'RO', 'ROM', 'رومانيا'),
(69574, 3276425216, 3276425471, 'UA', 'UKR', 'أوكرانيا'),
(69575, 3276425472, 3276425727, 'DE', 'DEU', 'ألمانيا'),
(69576, 3276425728, 3276425983, 'RU', 'RUS', 'الإتحاد الروسي'),
(69577, 3276425984, 3276426239, 'IT', 'ITA', 'إيطاليا'),
(69578, 3276426240, 3276426751, 'DK', 'DNK', 'الدنيمارك'),
(69579, 3276426752, 3276427007, 'RO', 'ROM', 'رومانيا'),
(69580, 3276427008, 3276427263, 'PL', 'POL', 'بولندا'),
(69581, 3276427264, 3276427519, 'FR', 'FRA', 'فرنسا'),
(69582, 3276427520, 3276427775, 'IT', 'ITA', 'إيطاليا'),
(69583, 3276427776, 3276428031, 'RU', 'RUS', 'الإتحاد الروسي'),
(69584, 3276428032, 3276428287, 'GB', 'GBR', 'المملكة المتحدة'),
(69585, 3276428288, 3276428543, 'RU', 'RUS', 'الإتحاد الروسي'),
(69586, 3276428544, 3276428799, 'BG', 'BGR', 'بلغاريا'),
(69587, 3276428800, 3276429055, 'DE', 'DEU', 'ألمانيا'),
(69588, 3276429056, 3276429311, 'NL', 'NLD', 'هولندا'),
(69589, 3276429312, 3276430079, 'RU', 'RUS', 'الإتحاد الروسي'),
(69590, 3276430080, 3276430591, 'PL', 'POL', 'بولندا'),
(69591, 3276430592, 3276430847, 'GB', 'GBR', 'المملكة المتحدة'),
(69592, 3276430848, 3276431103, 'DE', 'DEU', 'ألمانيا'),
(69593, 3276431104, 3276431359, 'RU', 'RUS', 'الإتحاد الروسي'),
(69594, 3276431360, 3276447743, 'GB', 'GBR', 'المملكة المتحدة'),
(69595, 3276447744, 3276451583, 'DE', 'DEU', 'ألمانيا'),
(69596, 3276455936, 3276464127, 'BE', 'BEL', 'بلجيكا'),
(69597, 3276464128, 3276472319, 'GR', 'GRC', 'اليونان'),
(69598, 3276472576, 3276472831, 'AT', 'AUT', 'النمسا'),
(69599, 3276472864, 3276472895, 'AT', 'AUT', 'النمسا'),
(69600, 3276473104, 3276473111, 'AT', 'AUT', 'النمسا'),
(69601, 3276473120, 3276473135, 'AT', 'AUT', 'النمسا'),
(69602, 3276473144, 3276473199, 'AT', 'AUT', 'النمسا'),
(69603, 3276473216, 3276473279, 'AT', 'AUT', 'النمسا'),
(69604, 3276473296, 3276473311, 'AT', 'AUT', 'النمسا'),
(69605, 3276473344, 3276473855, 'AT', 'AUT', 'النمسا'),
(69606, 3276474272, 3276474295, 'AT', 'AUT', 'النمسا'),
(69607, 3276474320, 3276474367, 'AT', 'AUT', 'النمسا'),
(69608, 3276475016, 3276475023, 'IT', 'ITA', 'إيطاليا'),
(69609, 3276475040, 3276475063, 'IT', 'ITA', 'إيطاليا'),
(69610, 3276475072, 3276475135, 'IT', 'ITA', 'إيطاليا'),
(69611, 3276475904, 3276475951, 'IT', 'ITA', 'إيطاليا'),
(69612, 3276475984, 3276476055, 'IT', 'ITA', 'إيطاليا'),
(69613, 3276476064, 3276476071, 'IT', 'ITA', 'إيطاليا'),
(69614, 3276476080, 3276476095, 'IT', 'ITA', 'إيطاليا'),
(69615, 3276476120, 3276476159, 'IT', 'ITA', 'إيطاليا'),
(69616, 3276476160, 3276476287, 'GB', 'GBR', 'المملكة المتحدة'),
(69617, 3276476416, 3276476671, 'CH', 'CHE', 'سويسرا'),
(69618, 3276477440, 3276477983, 'CH', 'CHE', 'سويسرا'),
(69619, 3276478304, 3276478311, 'CH', 'CHE', 'سويسرا'),
(69620, 3276478320, 3276478335, 'CH', 'CHE', 'سويسرا'),
(69621, 3276478464, 3276478855, 'FR', 'FRA', 'فرنسا'),
(69622, 3276478864, 3276479127, 'FR', 'FRA', 'فرنسا'),
(69623, 3276479136, 3276479167, 'FR', 'FRA', 'فرنسا'),
(69624, 3276479200, 3276479215, 'FR', 'FRA', 'فرنسا'),
(69625, 3276479224, 3276479343, 'FR', 'FRA', 'فرنسا'),
(69626, 3276479344, 3276479351, 'GB', 'GBR', 'المملكة المتحدة'),
(69627, 3276479352, 3276479615, 'FR', 'FRA', 'فرنسا'),
(69628, 3276479648, 3276479743, 'FR', 'FRA', 'فرنسا'),
(69629, 3276480016, 3276480047, 'FR', 'FRA', 'فرنسا'),
(69630, 3276480064, 3276480095, 'FR', 'FRA', 'فرنسا'),
(69631, 3276480112, 3276480159, 'FR', 'FRA', 'فرنسا'),
(69632, 3276480192, 3276480271, 'FR', 'FRA', 'فرنسا'),
(69633, 3276480288, 3276480295, 'FR', 'FRA', 'فرنسا'),
(69634, 3276480304, 3276480319, 'FR', 'FRA', 'فرنسا'),
(69635, 3276480352, 3276480375, 'FR', 'FRA', 'فرنسا'),
(69636, 3276480400, 3276480439, 'FR', 'FRA', 'فرنسا'),
(69637, 3276480456, 3276480479, 'FR', 'FRA', 'فرنسا'),
(69638, 3276480512, 3276480767, 'RU', 'RUS', 'الإتحاد الروسي'),
(69639, 3276481024, 3276481535, 'RU', 'RUS', 'الإتحاد الروسي'),
(69640, 3276482560, 3276482815, 'GR', 'GRC', 'اليونان'),
(69641, 3276483072, 3276483359, 'GR', 'GRC', 'اليونان'),
(69642, 3276483392, 3276483519, 'GR', 'GRC', 'اليونان'),
(69643, 3276483584, 3276483711, 'GR', 'GRC', 'اليونان'),
(69644, 3276483840, 3276484351, 'GR', 'GRC', 'اليونان'),
(69645, 3276484384, 3276484479, 'GR', 'GRC', 'اليونان'),
(69646, 3276484608, 3276484863, 'SK', 'SVK', 'سلوفاكيا'),
(69647, 3276485632, 3276486655, 'GB', 'GBR', 'المملكة المتحدة'),
(69648, 3276486912, 3276487167, 'GR', 'GRC', 'اليونان'),
(69649, 3276488960, 3276489215, 'CZ', 'CZE', 'التشيك'),
(69650, 3276490752, 3276491263, 'NL', 'NLD', 'هولندا'),
(69651, 3276491264, 3276491327, 'CZ', 'CZE', 'التشيك'),
(69652, 3276491392, 3276491775, 'CZ', 'CZE', 'التشيك'),
(69653, 3276491776, 3276491847, 'GB', 'GBR', 'المملكة المتحدة'),
(69654, 3276491856, 3276492055, 'GB', 'GBR', 'المملكة المتحدة'),
(69655, 3276492064, 3276492127, 'GB', 'GBR', 'المملكة المتحدة'),
(69656, 3276492144, 3276492151, 'GB', 'GBR', 'المملكة المتحدة'),
(69657, 3276492288, 3276492487, 'GB', 'GBR', 'المملكة المتحدة'),
(69658, 3276492496, 3276493215, 'GB', 'GBR', 'المملكة المتحدة'),
(69659, 3276493248, 3276494335, 'GB', 'GBR', 'المملكة المتحدة'),
(69660, 3276494368, 3276494383, 'GB', 'GBR', 'المملكة المتحدة'),
(69661, 3276494416, 3276494431, 'GB', 'GBR', 'المملكة المتحدة'),
(69662, 3276494448, 3276495503, 'GB', 'GBR', 'المملكة المتحدة'),
(69663, 3276495520, 3276495679, 'GB', 'GBR', 'المملكة المتحدة'),
(69664, 3276495776, 3276495791, 'GB', 'GBR', 'المملكة المتحدة'),
(69665, 3276495808, 3276496639, 'GB', 'GBR', 'المملكة المتحدة'),
(69666, 3276496896, 3276497151, 'DE', 'DEU', 'ألمانيا'),
(69667, 3276497216, 3276497279, 'DE', 'DEU', 'ألمانيا'),
(69668, 3276497296, 3276497311, 'DE', 'DEU', 'ألمانيا'),
(69669, 3276497344, 3276497375, 'DE', 'DEU', 'ألمانيا'),
(69670, 3276497408, 3276497599, 'DE', 'DEU', 'ألمانيا'),
(69671, 3276497616, 3276497647, 'DE', 'DEU', 'ألمانيا'),
(69672, 3276497664, 3276497919, 'DE', 'DEU', 'ألمانيا'),
(69673, 3276497920, 3276498047, 'GB', 'GBR', 'المملكة المتحدة'),
(69674, 3276498304, 3276498311, 'GB', 'GBR', 'المملكة المتحدة'),
(69675, 3276498320, 3276498431, 'GB', 'GBR', 'المملكة المتحدة'),
(69676, 3276498432, 3276499199, 'DE', 'DEU', 'ألمانيا'),
(69677, 3276499456, 3276499503, 'DE', 'DEU', 'ألمانيا'),
(69678, 3276499520, 3276499615, 'DE', 'DEU', 'ألمانيا'),
(69679, 3276499680, 3276499695, 'DE', 'DEU', 'ألمانيا'),
(69680, 3276499712, 3276499759, 'DE', 'DEU', 'ألمانيا'),
(69681, 3276499776, 3276499791, 'DE', 'DEU', 'ألمانيا'),
(69682, 3276499800, 3276499815, 'DE', 'DEU', 'ألمانيا'),
(69683, 3276499936, 3276499999, 'DE', 'DEU', 'ألمانيا'),
(69684, 3276500000, 3276500031, 'CH', 'CHE', 'سويسرا'),
(69685, 3276500032, 3276500095, 'DE', 'DEU', 'ألمانيا'),
(69686, 3276500128, 3276500159, 'DE', 'DEU', 'ألمانيا'),
(69687, 3276500480, 3276500735, 'DE', 'DEU', 'ألمانيا'),
(69688, 3276500992, 3276501023, 'DE', 'DEU', 'ألمانيا'),
(69689, 3276501024, 3276501055, 'FR', 'FRA', 'فرنسا'),
(69690, 3276501120, 3276501167, 'DE', 'DEU', 'ألمانيا'),
(69691, 3276501248, 3276501503, 'DE', 'DEU', 'ألمانيا'),
(69692, 3276502272, 3276505087, 'DE', 'DEU', 'ألمانيا'),
(69693, 3276505088, 3276505599, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69694, 3276505856, 3276505887, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69695, 3276505904, 3276505919, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69696, 3276505984, 3276506063, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69697, 3276506072, 3276506079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69698, 3276506096, 3276506159, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69699, 3276506176, 3276506191, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69700, 3276506208, 3276506367, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69701, 3276506624, 3276507135, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69702, 3276507136, 3276507231, 'CH', 'CHE', 'سويسرا'),
(69703, 3276507392, 3276507647, 'CH', 'CHE', 'سويسرا'),
(69704, 3276508160, 3276508327, 'GB', 'GBR', 'المملكة المتحدة'),
(69705, 3276508352, 3276508415, 'FR', 'FRA', 'فرنسا'),
(69706, 3276508416, 3276508671, 'GB', 'GBR', 'المملكة المتحدة'),
(69707, 3276508680, 3276509183, 'GB', 'GBR', 'المملكة المتحدة'),
(69708, 3276509184, 3276510207, 'IT', 'ITA', 'إيطاليا'),
(69709, 3276510720, 3276510735, 'IT', 'ITA', 'إيطاليا'),
(69710, 3276510784, 3276510815, 'IT', 'ITA', 'إيطاليا'),
(69711, 3276510848, 3276510911, 'GB', 'GBR', 'المملكة المتحدة'),
(69712, 3276511488, 3276511775, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69713, 3276511824, 3276511839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69714, 3276511872, 3276511919, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69715, 3276511936, 3276511951, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69716, 3276511968, 3276512191, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69717, 3276512200, 3276512207, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69718, 3276512256, 3276513023, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(69719, 3276513536, 3276513551, 'CH', 'CHE', 'سويسرا'),
(69720, 3276513560, 3276513567, 'CH', 'CHE', 'سويسرا'),
(69721, 3276514336, 3276514367, 'CH', 'CHE', 'سويسرا'),
(69722, 3276514560, 3276514815, 'CH', 'CHE', 'سويسرا'),
(69723, 3276515328, 3276515583, 'ES', 'ESP', 'إسبانيا'),
(69724, 3276517376, 3276517503, 'NL', 'NLD', 'هولندا'),
(69725, 3276517632, 3276517647, 'NL', 'NLD', 'هولندا'),
(69726, 3276517656, 3276517759, 'NL', 'NLD', 'هولندا'),
(69727, 3276517792, 3276517887, 'NL', 'NLD', 'هولندا'),
(69728, 3276517904, 3276517951, 'NL', 'NLD', 'هولندا'),
(69729, 3276518016, 3276518023, 'NL', 'NLD', 'هولندا'),
(69730, 3276518056, 3276518063, 'NL', 'NLD', 'هولندا'),
(69731, 3276518096, 3276518111, 'NL', 'NLD', 'هولندا'),
(69732, 3276518128, 3276518175, 'NL', 'NLD', 'هولندا'),
(69733, 3276518184, 3276518191, 'NL', 'NLD', 'هولندا'),
(69734, 3276518208, 3276518271, 'NL', 'NLD', 'هولندا'),
(69735, 3276518304, 3276518335, 'NL', 'NLD', 'هولندا'),
(69736, 3276518400, 3276518527, 'BE', 'BEL', 'بلجيكا'),
(69737, 3276518592, 3276518655, 'BE', 'BEL', 'بلجيكا'),
(69738, 3276518912, 3276519423, 'BE', 'BEL', 'بلجيكا'),
(69739, 3276519424, 3276520191, 'DK', 'DNK', 'الدنيمارك'),
(69740, 3276520192, 3276520223, 'BE', 'BEL', 'بلجيكا'),
(69741, 3276520224, 3276520255, 'GB', 'GBR', 'المملكة المتحدة'),
(69742, 3276520256, 3276520415, 'BE', 'BEL', 'بلجيكا'),
(69743, 3276520432, 3276520447, 'BE', 'BEL', 'بلجيكا'),
(69744, 3276520464, 3276520591, 'SE', 'SWE', 'السويد'),
(69745, 3276520608, 3276520623, 'SE', 'SWE', 'السويد'),
(69746, 3276520640, 3276520703, 'SE', 'SWE', 'السويد'),
(69747, 3276520768, 3276520815, 'SE', 'SWE', 'السويد'),
(69748, 3276520832, 3276520927, 'SE', 'SWE', 'السويد'),
(69749, 3276520944, 3276521215, 'SE', 'SWE', 'السويد'),
(69750, 3276521984, 3276523519, 'NL', 'NLD', 'هولندا'),
(69751, 3276523792, 3276523911, 'NO', 'NOR', 'النرويج'),
(69752, 3276523928, 3276523951, 'NO', 'NOR', 'النرويج'),
(69753, 3276523968, 3276524031, 'NO', 'NOR', 'النرويج'),
(69754, 3276524064, 3276524095, 'TR', 'TUR', 'تركيا'),
(69755, 3276524192, 3276524279, 'TR', 'TUR', 'تركيا'),
(69756, 3276524544, 3276524799, 'GB', 'GBR', 'المملكة المتحدة'),
(69757, 3276524800, 3276524855, 'PT', 'PRT', 'البورتوغال'),
(69758, 3276525040, 3276525055, 'PT', 'PRT', 'البورتوغال'),
(69759, 3276525056, 3276525311, 'FI', 'FIN', 'فنلندا'),
(69760, 3276525504, 3276525527, 'HR', 'HRV', 'كرواتيا'),
(69761, 3276525528, 3276525535, 'PL', 'POL', 'بولندا'),
(69762, 3276525536, 3276525567, 'HR', 'HRV', 'كرواتيا'),
(69763, 3276526080, 3276526111, 'CH', 'CHE', 'سويسرا'),
(69764, 3276526144, 3276526159, 'CH', 'CHE', 'سويسرا'),
(69765, 3276526336, 3276526591, 'CH', 'CHE', 'سويسرا'),
(69766, 3276527104, 3276527135, 'SI', 'SVN', 'سلوفينيا'),
(69767, 3276527168, 3276527199, 'SI', 'SVN', 'سلوفينيا'),
(69768, 3276527216, 3276527231, 'SI', 'SVN', 'سلوفينيا'),
(69769, 3276527360, 3276527615, 'SI', 'SVN', 'سلوفينيا'),
(69770, 3276527616, 3276527743, 'PK', 'PAK', 'باكستان'),
(69771, 3276527872, 3276527999, 'PK', 'PAK', 'باكستان'),
(69772, 3276528128, 3276528223, 'BE', 'BEL', 'بلجيكا'),
(69773, 3276528224, 3276528239, 'GB', 'GBR', 'المملكة المتحدة'),
(69774, 3276528240, 3276528247, 'BE', 'BEL', 'بلجيكا'),
(69775, 3276528248, 3276528255, 'GB', 'GBR', 'المملكة المتحدة'),
(69776, 3276528256, 3276528351, 'BE', 'BEL', 'بلجيكا'),
(69777, 3276528352, 3276528359, 'GB', 'GBR', 'المملكة المتحدة'),
(69778, 3276528360, 3276528367, 'FR', 'FRA', 'فرنسا'),
(69779, 3276528368, 3276528399, 'BE', 'BEL', 'بلجيكا'),
(69780, 3276528448, 3276528503, 'BE', 'BEL', 'بلجيكا'),
(69781, 3276528560, 3276528567, 'BE', 'BEL', 'بلجيكا'),
(69782, 3276528576, 3276528719, 'BE', 'BEL', 'بلجيكا'),
(69783, 3276528728, 3276528799, 'BE', 'BEL', 'بلجيكا'),
(69784, 3276528800, 3276528815, 'GB', 'GBR', 'المملكة المتحدة'),
(69785, 3276528832, 3276528895, 'BE', 'BEL', 'بلجيكا'),
(69786, 3276528896, 3276528903, 'IE', 'IRL', 'إيرلندا'),
(69787, 3276528912, 3276528927, 'IE', 'IRL', 'إيرلندا'),
(69788, 3276528936, 3276528943, 'IE', 'IRL', 'إيرلندا'),
(69789, 3276528960, 3276529151, 'IE', 'IRL', 'إيرلندا'),
(69790, 3276529152, 3276529167, 'TR', 'TUR', 'تركيا'),
(69791, 3276529184, 3276529279, 'TR', 'TUR', 'تركيا'),
(69792, 3276529328, 3276529351, 'TR', 'TUR', 'تركيا'),
(69793, 3276529360, 3276529375, 'TR', 'TUR', 'تركيا'),
(69794, 3276529392, 3276529407, 'TR', 'TUR', 'تركيا'),
(69795, 3276529664, 3276530455, 'NL', 'NLD', 'هولندا'),
(69796, 3276530464, 3276530495, 'NL', 'NLD', 'هولندا'),
(69797, 3276530560, 3276532735, 'NL', 'NLD', 'هولندا'),
(69798, 3276532736, 3276532775, 'TR', 'TUR', 'تركيا'),
(69799, 3276532784, 3276532791, 'TR', 'TUR', 'تركيا'),
(69800, 3276532856, 3276532991, 'TR', 'TUR', 'تركيا'),
(69801, 3276532992, 3276533023, 'HU', 'HUN', 'هنغاريا'),
(69802, 3276533072, 3276533087, 'HU', 'HUN', 'هنغاريا'),
(69803, 3276533120, 3276533183, 'HU', 'HUN', 'هنغاريا'),
(69804, 3276533248, 3276533375, 'TR', 'TUR', 'تركيا'),
(69805, 3276533776, 3276533791, 'GB', 'GBR', 'المملكة المتحدة'),
(69806, 3276533824, 3276533887, 'IE', 'IRL', 'إيرلندا'),
(69807, 3276533920, 3276534015, 'IE', 'IRL', 'إيرلندا'),
(69808, 3276534016, 3276534271, 'NL', 'NLD', 'هولندا'),
(69809, 3276534400, 3276534415, 'GB', 'GBR', 'المملكة المتحدة'),
(69810, 3276534416, 3276534431, 'NL', 'NLD', 'هولندا'),
(69811, 3276534432, 3276534463, 'GB', 'GBR', 'المملكة المتحدة'),
(69812, 3276534464, 3276534495, 'FR', 'FRA', 'فرنسا'),
(69813, 3276534512, 3276534527, 'NL', 'NLD', 'هولندا'),
(69814, 3276534544, 3276534591, 'NL', 'NLD', 'هولندا'),
(69815, 3276534624, 3276534671, 'NL', 'NLD', 'هولندا'),
(69816, 3276534688, 3276534719, 'NL', 'NLD', 'هولندا'),
(69817, 3276534784, 3276534879, 'NL', 'NLD', 'هولندا'),
(69818, 3276534888, 3276534895, 'NL', 'NLD', 'هولندا'),
(69819, 3276534912, 3276534919, 'NL', 'NLD', 'هولندا'),
(69820, 3276534944, 3276534975, 'NL', 'NLD', 'هولندا'),
(69821, 3276535016, 3276535039, 'GB', 'GBR', 'المملكة المتحدة'),
(69822, 3276535040, 3276535063, 'RU', 'RUS', 'الإتحاد الروسي'),
(69823, 3276535064, 3276535071, 'LV', 'LVA', 'لاتفيا'),
(69824, 3276535072, 3276535103, 'RU', 'RUS', 'الإتحاد الروسي'),
(69825, 3276535296, 3276535319, 'FI', 'FIN', 'فنلندا'),
(69826, 3276535336, 3276535359, 'FI', 'FIN', 'فنلندا'),
(69827, 3276535376, 3276535423, 'FI', 'FIN', 'فنلندا'),
(69828, 3276535552, 3276535807, 'PK', 'PAK', 'باكستان'),
(69829, 3276535808, 3276536063, 'FI', 'FIN', 'فنلندا'),
(69830, 3276536320, 3276536415, 'ES', 'ESP', 'إسبانيا'),
(69831, 3276536448, 3276536511, 'ES', 'ESP', 'إسبانيا'),
(69832, 3276536584, 3276536591, 'HR', 'HRV', 'كرواتيا'),
(69833, 3276536640, 3276536671, 'HU', 'HUN', 'هنغاريا'),
(69834, 3276536688, 3276536711, 'HU', 'HUN', 'هنغاريا'),
(69835, 3276536736, 3276536743, 'HU', 'HUN', 'هنغاريا'),
(69836, 3276536864, 3276536895, 'ES', 'ESP', 'إسبانيا'),
(69837, 3276536968, 3276536991, 'ES', 'ESP', 'إسبانيا'),
(69838, 3276537152, 3276537215, 'AT', 'AUT', 'النمسا'),
(69839, 3276537344, 3276537599, 'AT', 'AUT', 'النمسا'),
(69840, 3276537600, 3276537663, 'GR', 'GRC', 'اليونان'),
(69841, 3276537856, 3276668927, 'ES', 'ESP', 'إسبانيا'),
(69842, 3276668928, 3276677119, 'MC', 'MCO', 'موناكو'),
(69843, 3276677120, 3276678143, 'HR', 'HRV', 'كرواتيا'),
(69844, 3276678144, 3276678655, 'SE', 'SWE', 'السويد'),
(69845, 3276678656, 3276679167, 'UA', 'UKR', 'أوكرانيا'),
(69846, 3276679168, 3276679679, 'DE', 'DEU', 'ألمانيا'),
(69847, 3276679680, 3276680191, 'RO', 'ROM', 'رومانيا'),
(69848, 3276680192, 3276680703, 'SK', 'SVK', 'سلوفاكيا'),
(69849, 3276680704, 3276681215, 'AT', 'AUT', 'النمسا'),
(69850, 3276681216, 3276681727, 'PL', 'POL', 'بولندا'),
(69851, 3276681728, 3276682239, 'BE', 'BEL', 'بلجيكا'),
(69852, 3276682240, 3276682751, 'AT', 'AUT', 'النمسا'),
(69853, 3276682752, 3276683263, 'GB', 'GBR', 'المملكة المتحدة'),
(69854, 3276683264, 3276684287, 'UA', 'UKR', 'أوكرانيا'),
(69855, 3276684288, 3276684799, 'RU', 'RUS', 'الإتحاد الروسي'),
(69856, 3276684800, 3276685311, 'DE', 'DEU', 'ألمانيا'),
(69857, 3276685312, 3276685823, 'RO', 'ROM', 'رومانيا'),
(69858, 3276685824, 3276686335, 'PL', 'POL', 'بولندا'),
(69859, 3276686336, 3276686847, 'UA', 'UKR', 'أوكرانيا'),
(69860, 3276686848, 3276687359, 'FI', 'FIN', 'فنلندا'),
(69861, 3276687360, 3276687871, 'RU', 'RUS', 'الإتحاد الروسي'),
(69862, 3276687872, 3276688383, 'KW', 'KWT', 'الكويت'),
(69863, 3276688384, 3276688895, 'DE', 'DEU', 'ألمانيا'),
(69864, 3276688896, 3276689407, 'ES', 'ESP', 'إسبانيا'),
(69865, 3276689408, 3276690431, 'GB', 'GBR', 'المملكة المتحدة'),
(69866, 3276690432, 3276690943, 'NL', 'NLD', 'هولندا'),
(69867, 3276690944, 3276691455, 'GR', 'GRC', 'اليونان'),
(69868, 3276691456, 3276691967, 'RO', 'ROM', 'رومانيا'),
(69869, 3276691968, 3276692479, 'RU', 'RUS', 'الإتحاد الروسي'),
(69870, 3276692480, 3276692991, 'UA', 'UKR', 'أوكرانيا'),
(69871, 3276692992, 3276693503, 'GB', 'GBR', 'المملكة المتحدة'),
(69872, 3276693504, 3276694015, 'UA', 'UKR', 'أوكرانيا'),
(69873, 3276694016, 3276694527, 'AT', 'AUT', 'النمسا'),
(69874, 3276694528, 3276695039, 'UA', 'UKR', 'أوكرانيا'),
(69875, 3276695040, 3276695551, 'RU', 'RUS', 'الإتحاد الروسي'),
(69876, 3276695552, 3276696063, 'UA', 'UKR', 'أوكرانيا'),
(69877, 3276696064, 3276696575, 'RO', 'ROM', 'رومانيا'),
(69878, 3276697088, 3276697599, 'GB', 'GBR', 'المملكة المتحدة'),
(69879, 3276697600, 3276698111, 'UA', 'UKR', 'أوكرانيا'),
(69880, 3276698112, 3276699647, 'RU', 'RUS', 'الإتحاد الروسي'),
(69881, 3276699648, 3276700159, 'FR', 'FRA', 'فرنسا'),
(69882, 3276700160, 3276700671, 'KZ', 'KAZ', 'كازاخستان'),
(69883, 3276700672, 3276701183, 'RO', 'ROM', 'رومانيا'),
(69884, 3276701184, 3276701695, 'RU', 'RUS', 'الإتحاد الروسي'),
(69885, 3276701696, 3276709887, 'SE', 'SWE', 'السويد'),
(69886, 3276709888, 3276718079, 'DE', 'DEU', 'ألمانيا'),
(69887, 3276718080, 3276726271, 'IT', 'ITA', 'إيطاليا'),
(69888, 3276726272, 3276727295, 'DE', 'DEU', 'ألمانيا'),
(69889, 3276727296, 3276728319, 'ES', 'ESP', 'إسبانيا'),
(69890, 3276728320, 3276729343, 'UA', 'UKR', 'أوكرانيا'),
(69891, 3276729344, 3276730367, 'PL', 'POL', 'بولندا'),
(69892, 3276730368, 3276731391, 'DE', 'DEU', 'ألمانيا'),
(69893, 3276731392, 3276732415, 'UA', 'UKR', 'أوكرانيا'),
(69894, 3276732416, 3276733439, 'DE', 'DEU', 'ألمانيا'),
(69895, 3276733440, 3276734463, 'UA', 'UKR', 'أوكرانيا'),
(69896, 3276734464, 3276734735, 'AT', 'AUT', 'النمسا'),
(69897, 3276734736, 3276734751, 'DK', 'DNK', 'الدنيمارك'),
(69898, 3276734752, 3276734815, 'AT', 'AUT', 'النمسا'),
(69899, 3276734816, 3276734847, 'DE', 'DEU', 'ألمانيا'),
(69900, 3276734880, 3276734895, 'GB', 'GBR', 'المملكة المتحدة'),
(69901, 3276734896, 3276734911, 'NL', 'NLD', 'هولندا'),
(69902, 3276734912, 3276734943, 'FR', 'FRA', 'فرنسا'),
(69903, 3276734944, 3276735455, 'AT', 'AUT', 'النمسا'),
(69904, 3276735456, 3276735487, 'NL', 'NLD', 'هولندا'),
(69905, 3276735488, 3276735871, 'AT', 'AUT', 'النمسا'),
(69906, 3276735936, 3276735999, 'ES', 'ESP', 'إسبانيا'),
(69907, 3276736000, 3276736511, 'AT', 'AUT', 'النمسا'),
(69908, 3276736512, 3276736575, 'IT', 'ITA', 'إيطاليا'),
(69909, 3276736576, 3276736735, 'GB', 'GBR', 'المملكة المتحدة'),
(69910, 3276736768, 3276736799, 'IT', 'ITA', 'إيطاليا'),
(69911, 3276736800, 3276736815, 'DE', 'DEU', 'ألمانيا'),
(69912, 3276736816, 3276736831, 'CZ', 'CZE', 'التشيك'),
(69913, 3276736832, 3276736863, 'NL', 'NLD', 'هولندا'),
(69914, 3276736864, 3276736871, 'DE', 'DEU', 'ألمانيا'),
(69915, 3276736872, 3276736879, 'NL', 'NLD', 'هولندا'),
(69916, 3276736880, 3276736959, 'DK', 'DNK', 'الدنيمارك'),
(69917, 3276736960, 3276736991, 'CH', 'CHE', 'سويسرا'),
(69918, 3276736992, 3276737015, 'GB', 'GBR', 'المملكة المتحدة'),
(69919, 3276737016, 3276737023, 'BE', 'BEL', 'بلجيكا'),
(69920, 3276737024, 3276737343, 'IT', 'ITA', 'إيطاليا'),
(69921, 3276737344, 3276737407, 'DE', 'DEU', 'ألمانيا'),
(69922, 3276737408, 3276737535, 'ES', 'ESP', 'إسبانيا'),
(69923, 3276737536, 3276737615, 'IT', 'ITA', 'إيطاليا'),
(69924, 3276737616, 3276737631, 'DE', 'DEU', 'ألمانيا'),
(69925, 3276737632, 3276737791, 'RU', 'RUS', 'الإتحاد الروسي'),
(69926, 3276737792, 3276737935, 'NL', 'NLD', 'هولندا'),
(69927, 3276737936, 3276737943, 'DE', 'DEU', 'ألمانيا'),
(69928, 3276737944, 3276737991, 'GB', 'GBR', 'المملكة المتحدة'),
(69929, 3276737992, 3276737999, 'IT', 'ITA', 'إيطاليا'),
(69930, 3276738000, 3276738015, 'GB', 'GBR', 'المملكة المتحدة'),
(69931, 3276738016, 3276738047, 'BE', 'BEL', 'بلجيكا'),
(69932, 3276738048, 3276738079, 'GB', 'GBR', 'المملكة المتحدة'),
(69933, 3276738080, 3276738111, 'ES', 'ESP', 'إسبانيا'),
(69934, 3276738112, 3276738143, 'GB', 'GBR', 'المملكة المتحدة'),
(69935, 3276738144, 3276738175, 'IT', 'ITA', 'إيطاليا'),
(69936, 3276738176, 3276738559, 'GB', 'GBR', 'المملكة المتحدة'),
(69937, 3276738560, 3276738847, 'CH', 'CHE', 'سويسرا'),
(69938, 3276739072, 3276739151, 'CH', 'CHE', 'سويسرا'),
(69939, 3276739168, 3276740127, 'CH', 'CHE', 'سويسرا'),
(69940, 3276740128, 3276740167, 'GB', 'GBR', 'المملكة المتحدة'),
(69941, 3276740168, 3276740175, 'DE', 'DEU', 'ألمانيا'),
(69942, 3276740176, 3276740191, 'NL', 'NLD', 'هولندا'),
(69943, 3276740224, 3276740351, 'CH', 'CHE', 'سويسرا'),
(69944, 3276740352, 3276740703, 'FR', 'FRA', 'فرنسا'),
(69945, 3276740704, 3276740719, 'IT', 'ITA', 'إيطاليا'),
(69946, 3276740720, 3276740735, 'CZ', 'CZE', 'التشيك'),
(69947, 3276740736, 3276740799, 'PT', 'PRT', 'البورتوغال'),
(69948, 3276740800, 3276740815, 'SI', 'SVN', 'سلوفينيا'),
(69949, 3276740816, 3276740831, 'SK', 'SVK', 'سلوفاكيا'),
(69950, 3276740832, 3276740863, 'DE', 'DEU', 'ألمانيا'),
(69951, 3276740864, 3276741375, 'FR', 'FRA', 'فرنسا'),
(69952, 3276741632, 3276742655, 'FR', 'FRA', 'فرنسا'),
(69953, 3276742656, 3276742735, 'RU', 'RUS', 'الإتحاد الروسي'),
(69954, 3276742736, 3276742751, 'NL', 'NLD', 'هولندا'),
(69955, 3276742752, 3276742783, 'GR', 'GRC', 'اليونان'),
(69956, 3276742784, 3276742911, 'HU', 'HUN', 'هنغاريا'),
(69957, 3276742912, 3276743071, 'AT', 'AUT', 'النمسا'),
(69958, 3276743072, 3276743103, 'DE', 'DEU', 'ألمانيا'),
(69959, 3276743104, 3276743135, 'HU', 'HUN', 'هنغاريا'),
(69960, 3276743136, 3276743167, 'NL', 'NLD', 'هولندا'),
(69961, 3276743424, 3276743903, 'AT', 'AUT', 'النمسا'),
(69962, 3276743904, 3276743935, 'BE', 'BEL', 'بلجيكا'),
(69963, 3276743936, 3276744191, 'AT', 'AUT', 'النمسا'),
(69964, 3276744192, 3276744703, 'BE', 'BEL', 'بلجيكا'),
(69965, 3276744704, 3276744959, 'IT', 'ITA', 'إيطاليا'),
(69966, 3276744960, 3276745215, 'GR', 'GRC', 'اليونان'),
(69967, 3276745216, 3276745295, 'DK', 'DNK', 'الدنيمارك'),
(69968, 3276745296, 3276745311, 'NL', 'NLD', 'هولندا'),
(69969, 3276745312, 3276745343, 'DK', 'DNK', 'الدنيمارك'),
(69970, 3276745344, 3276745407, 'DE', 'DEU', 'ألمانيا'),
(69971, 3276745408, 3276745655, 'DK', 'DNK', 'الدنيمارك'),
(69972, 3276745664, 3276745727, 'DK', 'DNK', 'الدنيمارك'),
(69973, 3276745728, 3276746047, 'GB', 'GBR', 'المملكة المتحدة'),
(69974, 3276746048, 3276746111, 'DE', 'DEU', 'ألمانيا'),
(69975, 3276746112, 3276746239, 'IT', 'ITA', 'إيطاليا'),
(69976, 3276746240, 3276746335, 'GB', 'GBR', 'المملكة المتحدة'),
(69977, 3276746336, 3276746351, 'BE', 'BEL', 'بلجيكا'),
(69978, 3276746352, 3276746367, 'NL', 'NLD', 'هولندا'),
(69979, 3276746368, 3276746751, 'GB', 'GBR', 'المملكة المتحدة'),
(69980, 3276746752, 3276748287, 'CH', 'CHE', 'سويسرا'),
(69981, 3276748288, 3276748799, 'GB', 'GBR', 'المملكة المتحدة'),
(69982, 3276748800, 3276748951, 'AT', 'AUT', 'النمسا'),
(69983, 3276748952, 3276748959, 'GB', 'GBR', 'المملكة المتحدة'),
(69984, 3276748960, 3276749023, 'AT', 'AUT', 'النمسا'),
(69985, 3276749024, 3276749055, 'IT', 'ITA', 'إيطاليا'),
(69986, 3276749056, 3276749087, 'AT', 'AUT', 'النمسا'),
(69987, 3276749088, 3276749103, 'FR', 'FRA', 'فرنسا'),
(69988, 3276749120, 3276749183, 'NL', 'NLD', 'هولندا'),
(69989, 3276749184, 3276749311, 'DE', 'DEU', 'ألمانيا'),
(69990, 3276749312, 3276749343, 'BE', 'BEL', 'بلجيكا'),
(69991, 3276749344, 3276749375, 'DE', 'DEU', 'ألمانيا'),
(69992, 3276749376, 3276749823, 'BE', 'BEL', 'بلجيكا'),
(69993, 3276749824, 3276750151, 'NL', 'NLD', 'هولندا'),
(69994, 3276750152, 3276750159, 'GB', 'GBR', 'المملكة المتحدة'),
(69995, 3276750160, 3276750175, 'FR', 'FRA', 'فرنسا'),
(69996, 3276750176, 3276750207, 'BE', 'BEL', 'بلجيكا'),
(69997, 3276750208, 3276750335, 'FR', 'FRA', 'فرنسا'),
(69998, 3276750336, 3276750431, 'GB', 'GBR', 'المملكة المتحدة'),
(69999, 3276750464, 3276751039, 'GB', 'GBR', 'المملكة المتحدة'),
(70000, 3276751040, 3276751071, 'FR', 'FRA', 'فرنسا'),
(70001, 3276751072, 3276751087, 'GB', 'GBR', 'المملكة المتحدة'),
(70002, 3276751088, 3276751103, 'NL', 'NLD', 'هولندا'),
(70003, 3276751104, 3276751175, 'GB', 'GBR', 'المملكة المتحدة'),
(70004, 3276751176, 3276751199, 'SE', 'SWE', 'السويد'),
(70005, 3276751232, 3276751295, 'IL', 'ISR', 'إسرائيل'),
(70006, 3276751296, 3276751359, 'AT', 'AUT', 'النمسا'),
(70007, 3276751360, 3276753055, 'GB', 'GBR', 'المملكة المتحدة'),
(70008, 3276753056, 3276753071, 'NO', 'NOR', 'النرويج'),
(70009, 3276753072, 3276753119, 'GB', 'GBR', 'المملكة المتحدة'),
(70010, 3276753120, 3276753151, 'IT', 'ITA', 'إيطاليا'),
(70011, 3276753152, 3276753375, 'GB', 'GBR', 'المملكة المتحدة'),
(70012, 3276753376, 3276753407, 'FI', 'FIN', 'فنلندا'),
(70013, 3276753408, 3276753951, 'GB', 'GBR', 'المملكة المتحدة'),
(70014, 3276753952, 3276753983, 'HU', 'HUN', 'هنغاريا'),
(70015, 3276753984, 3276754991, 'GB', 'GBR', 'المملكة المتحدة'),
(70016, 3276754992, 3276755007, 'DE', 'DEU', 'ألمانيا'),
(70017, 3276755008, 3276755071, 'HU', 'HUN', 'هنغاريا'),
(70018, 3276755072, 3276755199, 'DE', 'DEU', 'ألمانيا'),
(70019, 3276755200, 3276755775, 'GB', 'GBR', 'المملكة المتحدة'),
(70020, 3276755776, 3276755791, 'NO', 'NOR', 'النرويج'),
(70021, 3276755792, 3276755807, 'RU', 'RUS', 'الإتحاد الروسي'),
(70022, 3276755808, 3276755839, 'GB', 'GBR', 'المملكة المتحدة'),
(70023, 3276755840, 3276755967, 'ES', 'ESP', 'إسبانيا'),
(70024, 3276755968, 3276756031, 'GB', 'GBR', 'المملكة المتحدة'),
(70025, 3276756032, 3276756063, 'NL', 'NLD', 'هولندا'),
(70026, 3276756064, 3276756095, 'BE', 'BEL', 'بلجيكا'),
(70027, 3276756096, 3276756287, 'GB', 'GBR', 'المملكة المتحدة'),
(70028, 3276756288, 3276756319, 'SE', 'SWE', 'السويد'),
(70029, 3276756320, 3276756351, 'FR', 'FRA', 'فرنسا'),
(70030, 3276756352, 3276756671, 'GB', 'GBR', 'المملكة المتحدة'),
(70031, 3276756672, 3276756735, 'DE', 'DEU', 'ألمانيا'),
(70032, 3276756736, 3276757119, 'GB', 'GBR', 'المملكة المتحدة'),
(70033, 3276757120, 3276757135, 'NO', 'NOR', 'النرويج'),
(70034, 3276757136, 3276757151, 'NL', 'NLD', 'هولندا'),
(70035, 3276757152, 3276757183, 'GB', 'GBR', 'المملكة المتحدة'),
(70036, 3276757248, 3276757503, 'GB', 'GBR', 'المملكة المتحدة'),
(70037, 3276757760, 3276757823, 'GB', 'GBR', 'المملكة المتحدة'),
(70038, 3276757824, 3276757839, 'DE', 'DEU', 'ألمانيا'),
(70039, 3276757840, 3276757855, 'ES', 'ESP', 'إسبانيا'),
(70040, 3276757856, 3276757887, 'CH', 'CHE', 'سويسرا'),
(70041, 3276757888, 3276759039, 'GB', 'GBR', 'المملكة المتحدة'),
(70042, 3276759040, 3276759695, 'DE', 'DEU', 'ألمانيا'),
(70043, 3276759696, 3276759711, 'NL', 'NLD', 'هولندا'),
(70044, 3276759712, 3276759743, 'DE', 'DEU', 'ألمانيا'),
(70045, 3276759744, 3276759775, 'CH', 'CHE', 'سويسرا'),
(70046, 3276759808, 3276761215, 'DE', 'DEU', 'ألمانيا'),
(70047, 3276761216, 3276761279, 'ES', 'ESP', 'إسبانيا'),
(70048, 3276761280, 3276761919, 'DE', 'DEU', 'ألمانيا'),
(70049, 3276761920, 3276761983, 'GB', 'GBR', 'المملكة المتحدة'),
(70050, 3276761984, 3276762015, 'DK', 'DNK', 'الدنيمارك'),
(70051, 3276762016, 3276762111, 'FR', 'FRA', 'فرنسا'),
(70052, 3276762112, 3276762623, 'DE', 'DEU', 'ألمانيا'),
(70053, 3276762880, 3276762943, 'DE', 'DEU', 'ألمانيا'),
(70054, 3276762944, 3276762959, 'GB', 'GBR', 'المملكة المتحدة'),
(70055, 3276762960, 3276762975, 'IT', 'ITA', 'إيطاليا'),
(70056, 3276762976, 3276763007, 'NO', 'NOR', 'النرويج'),
(70057, 3276763008, 3276763327, 'DE', 'DEU', 'ألمانيا'),
(70058, 3276763328, 3276763391, 'SE', 'SWE', 'السويد'),
(70059, 3276763392, 3276763519, 'DE', 'DEU', 'ألمانيا'),
(70060, 3276763520, 3276763551, 'IT', 'ITA', 'إيطاليا'),
(70061, 3276763552, 3276763567, 'CH', 'CHE', 'سويسرا'),
(70062, 3276763568, 3276763583, 'GR', 'GRC', 'اليونان'),
(70063, 3276763584, 3276763647, 'GB', 'GBR', 'المملكة المتحدة'),
(70064, 3276763648, 3276763967, 'DE', 'DEU', 'ألمانيا'),
(70065, 3276763968, 3276763983, 'DK', 'DNK', 'الدنيمارك'),
(70066, 3276763984, 3276763991, 'GB', 'GBR', 'المملكة المتحدة'),
(70067, 3276763992, 3276763999, 'BE', 'BEL', 'بلجيكا'),
(70068, 3276764000, 3276764031, 'IT', 'ITA', 'إيطاليا'),
(70069, 3276764160, 3276765183, 'DE', 'DEU', 'ألمانيا'),
(70070, 3276765184, 3276766975, 'GB', 'GBR', 'المملكة المتحدة'),
(70071, 3276766976, 3276766983, 'FR', 'FRA', 'فرنسا'),
(70072, 3276766992, 3276767015, 'FR', 'FRA', 'فرنسا'),
(70073, 3276767016, 3276767023, 'DK', 'DNK', 'الدنيمارك'),
(70074, 3276767024, 3276767039, 'BE', 'BEL', 'بلجيكا'),
(70075, 3276767040, 3276767079, 'FR', 'FRA', 'فرنسا'),
(70076, 3276767080, 3276767087, 'GB', 'GBR', 'المملكة المتحدة'),
(70077, 3276767088, 3276767103, 'NL', 'NLD', 'هولندا'),
(70078, 3276767104, 3276767231, 'FR', 'FRA', 'فرنسا'),
(70079, 3276767232, 3276767743, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(70080, 3276767744, 3276767807, 'NL', 'NLD', 'هولندا'),
(70081, 3276767808, 3276767871, 'DK', 'DNK', 'الدنيمارك'),
(70082, 3276767872, 3276767935, 'NL', 'NLD', 'هولندا'),
(70083, 3276767936, 3276767967, 'FR', 'FRA', 'فرنسا'),
(70084, 3276767968, 3276767999, 'AT', 'AUT', 'النمسا'),
(70085, 3276768000, 3276768511, 'NL', 'NLD', 'هولندا'),
(70086, 3276768512, 3276768767, 'DE', 'DEU', 'ألمانيا'),
(70087, 3276768768, 3276768863, 'ES', 'ESP', 'إسبانيا'),
(70088, 3276768864, 3276768895, 'AT', 'AUT', 'النمسا'),
(70089, 3276768896, 3276769023, 'HU', 'HUN', 'هنغاريا'),
(70090, 3276769024, 3276769279, 'DE', 'DEU', 'ألمانيا'),
(70091, 3276769280, 3276769295, 'ES', 'ESP', 'إسبانيا'),
(70092, 3276769296, 3276769311, 'DE', 'DEU', 'ألمانيا'),
(70093, 3276769312, 3276769343, 'CH', 'CHE', 'سويسرا'),
(70094, 3276769344, 3276769407, 'NL', 'NLD', 'هولندا'),
(70095, 3276769408, 3276769919, 'ES', 'ESP', 'إسبانيا'),
(70096, 3276769984, 3276770015, 'AT', 'AUT', 'النمسا'),
(70097, 3276770016, 3276770031, 'IT', 'ITA', 'إيطاليا'),
(70098, 3276770032, 3276770047, 'CH', 'CHE', 'سويسرا'),
(70099, 3276770048, 3276770143, 'ES', 'ESP', 'إسبانيا'),
(70100, 3276770144, 3276770175, 'FI', 'FIN', 'فنلندا'),
(70101, 3276770176, 3276770239, 'ES', 'ESP', 'إسبانيا'),
(70102, 3276770240, 3276770303, 'DK', 'DNK', 'الدنيمارك'),
(70103, 3276770304, 3276770815, 'ES', 'ESP', 'إسبانيا'),
(70104, 3276770944, 3276771135, 'ES', 'ESP', 'إسبانيا'),
(70105, 3276771200, 3276771327, 'ES', 'ESP', 'إسبانيا'),
(70106, 3276771328, 3276771455, 'NL', 'NLD', 'هولندا'),
(70107, 3276771456, 3276771583, 'GB', 'GBR', 'المملكة المتحدة'),
(70108, 3276771584, 3276772287, 'NL', 'NLD', 'هولندا'),
(70109, 3276772288, 3276772351, 'AT', 'AUT', 'النمسا'),
(70110, 3276772352, 3276772567, 'BE', 'BEL', 'بلجيكا'),
(70111, 3276772576, 3276773375, 'BE', 'BEL', 'بلجيكا'),
(70112, 3276773376, 3276774047, 'DK', 'DNK', 'الدنيمارك'),
(70113, 3276774048, 3276774079, 'FI', 'FIN', 'فنلندا'),
(70114, 3276774080, 3276774095, 'DK', 'DNK', 'الدنيمارك'),
(70115, 3276774112, 3276774143, 'IE', 'IRL', 'إيرلندا'),
(70116, 3276774144, 3276774271, 'DK', 'DNK', 'الدنيمارك'),
(70117, 3276774272, 3276774303, 'DE', 'DEU', 'ألمانيا'),
(70118, 3276774304, 3276774335, 'FR', 'FRA', 'فرنسا'),
(70119, 3276774336, 3276774399, 'GB', 'GBR', 'المملكة المتحدة'),
(70120, 3276774400, 3276774543, 'SE', 'SWE', 'السويد'),
(70121, 3276774544, 3276774559, 'GB', 'GBR', 'المملكة المتحدة'),
(70122, 3276774560, 3276774591, 'DE', 'DEU', 'ألمانيا'),
(70123, 3276774592, 3276774655, 'CH', 'CHE', 'سويسرا'),
(70124, 3276774656, 3276775103, 'SE', 'SWE', 'السويد'),
(70125, 3276775104, 3276775167, 'NL', 'NLD', 'هولندا'),
(70126, 3276775168, 3276775295, 'SE', 'SWE', 'السويد'),
(70127, 3276775296, 3276775359, 'FR', 'FRA', 'فرنسا'),
(70128, 3276775360, 3276775391, 'DK', 'DNK', 'الدنيمارك'),
(70129, 3276775392, 3276775423, 'DE', 'DEU', 'ألمانيا'),
(70130, 3276775424, 3276781151, 'NL', 'NLD', 'هولندا'),
(70131, 3276781152, 3276781247, 'FR', 'FRA', 'فرنسا'),
(70132, 3276781248, 3276781311, 'BE', 'BEL', 'بلجيكا'),
(70133, 3276781312, 3276781503, 'NL', 'NLD', 'هولندا'),
(70134, 3276781504, 3276781567, 'FR', 'FRA', 'فرنسا'),
(70135, 3276781568, 3276782719, 'BE', 'BEL', 'بلجيكا'),
(70136, 3276782784, 3276782799, 'FR', 'FRA', 'فرنسا'),
(70137, 3276782800, 3276782815, 'CZ', 'CZE', 'التشيك'),
(70138, 3276782816, 3276782847, 'ES', 'ESP', 'إسبانيا'),
(70139, 3276782848, 3276782975, 'BE', 'BEL', 'بلجيكا'),
(70140, 3276782976, 3276783039, 'GR', 'GRC', 'اليونان'),
(70141, 3276783040, 3276783055, 'DK', 'DNK', 'الدنيمارك'),
(70142, 3276783056, 3276783071, 'GB', 'GBR', 'المملكة المتحدة'),
(70143, 3276783072, 3276783087, 'PT', 'PRT', 'البورتوغال'),
(70144, 3276783088, 3276783103, 'CH', 'CHE', 'سويسرا'),
(70145, 3276783104, 3276783615, 'IT', 'ITA', 'إيطاليا'),
(70146, 3276783616, 3276784383, 'FR', 'FRA', 'فرنسا'),
(70147, 3276784640, 3276784895, 'FR', 'FRA', 'فرنسا'),
(70148, 3276784896, 3276785151, 'NO', 'NOR', 'النرويج'),
(70149, 3276785152, 3276785407, 'IE', 'IRL', 'إيرلندا'),
(70150, 3276785408, 3276785439, 'PT', 'PRT', 'البورتوغال'),
(70151, 3276785440, 3276785455, 'GR', 'GRC', 'اليونان'),
(70152, 3276785456, 3276785463, 'GB', 'GBR', 'المملكة المتحدة'),
(70153, 3276785464, 3276785471, 'IE', 'IRL', 'إيرلندا'),
(70154, 3276785472, 3276785535, 'PT', 'PRT', 'البورتوغال'),
(70155, 3276785536, 3276785567, 'BE', 'BEL', 'بلجيكا'),
(70156, 3276785568, 3276785599, 'PT', 'PRT', 'البورتوغال'),
(70157, 3276785600, 3276785607, 'TR', 'TUR', 'تركيا'),
(70158, 3276785608, 3276785615, 'PL', 'POL', 'بولندا'),
(70159, 3276785616, 3276785631, 'CZ', 'CZE', 'التشيك'),
(70160, 3276785632, 3276785663, 'IT', 'ITA', 'إيطاليا'),
(70161, 3276785664, 3276785791, 'IL', 'ISR', 'إسرائيل'),
(70162, 3276785792, 3276785823, 'NL', 'NLD', 'هولندا'),
(70163, 3276785856, 3276785919, 'GB', 'GBR', 'المملكة المتحدة'),
(70164, 3276785920, 3276786175, 'AT', 'AUT', 'النمسا'),
(70165, 3276786176, 3276786431, 'NO', 'NOR', 'النرويج'),
(70166, 3276786688, 3276786815, 'HU', 'HUN', 'هنغاريا'),
(70167, 3276786816, 3276786879, 'SE', 'SWE', 'السويد'),
(70168, 3276786880, 3276786911, 'TR', 'TUR', 'تركيا'),
(70169, 3276786912, 3276786943, 'BE', 'BEL', 'بلجيكا'),
(70170, 3276786944, 3276787359, 'AT', 'AUT', 'النمسا'),
(70171, 3276787360, 3276787391, 'DE', 'DEU', 'ألمانيا'),
(70172, 3276787392, 3276787455, 'BE', 'BEL', 'بلجيكا'),
(70173, 3276787456, 3276787775, 'FR', 'FRA', 'فرنسا'),
(70174, 3276787968, 3276788735, 'FR', 'FRA', 'فرنسا'),
(70175, 3276788736, 3276788863, 'IE', 'IRL', 'إيرلندا'),
(70176, 3276788864, 3276788895, 'DE', 'DEU', 'ألمانيا'),
(70177, 3276788928, 3276788991, 'NL', 'NLD', 'هولندا'),
(70178, 3276788992, 3276789247, 'NO', 'NOR', 'النرويج'),
(70179, 3276789248, 3276789439, 'FI', 'FIN', 'فنلندا'),
(70180, 3276789504, 3276789567, 'FR', 'FRA', 'فرنسا'),
(70181, 3276789568, 3276789583, 'ES', 'ESP', 'إسبانيا'),
(70182, 3276789584, 3276789599, 'FR', 'FRA', 'فرنسا'),
(70183, 3276789600, 3276789615, 'ES', 'ESP', 'إسبانيا'),
(70184, 3276789616, 3276789631, 'NL', 'NLD', 'هولندا'),
(70185, 3276789632, 3276789759, 'FR', 'FRA', 'فرنسا'),
(70186, 3276789760, 3276790015, 'IT', 'ITA', 'إيطاليا'),
(70187, 3276790016, 3276790111, 'ES', 'ESP', 'إسبانيا'),
(70188, 3276790112, 3276790127, 'FR', 'FRA', 'فرنسا'),
(70189, 3276790128, 3276790143, 'NL', 'NLD', 'هولندا'),
(70190, 3276790144, 3276790175, 'IT', 'ITA', 'إيطاليا'),
(70191, 3276790176, 3276790199, 'NL', 'NLD', 'هولندا'),
(70192, 3276790200, 3276790207, 'DE', 'DEU', 'ألمانيا'),
(70193, 3276790208, 3276790223, 'NL', 'NLD', 'هولندا'),
(70194, 3276790224, 3276790271, 'GB', 'GBR', 'المملكة المتحدة'),
(70195, 3276790272, 3276790527, 'IE', 'IRL', 'إيرلندا'),
(70196, 3276790528, 3276790783, 'HU', 'HUN', 'هنغاريا'),
(70197, 3276790784, 3276790943, 'PK', 'PAK', 'باكستان'),
(70198, 3276790944, 3276791007, 'IT', 'ITA', 'إيطاليا'),
(70199, 3276791008, 3276791039, 'NL', 'NLD', 'هولندا'),
(70200, 3276791040, 3276791295, 'GB', 'GBR', 'المملكة المتحدة'),
(70201, 3276791296, 3276791327, 'PT', 'PRT', 'البورتوغال'),
(70202, 3276791552, 3276792831, 'GB', 'GBR', 'المملكة المتحدة'),
(70203, 3276792832, 3276793087, 'FR', 'FRA', 'فرنسا'),
(70204, 3276793088, 3276793279, 'GB', 'GBR', 'المملكة المتحدة'),
(70205, 3276793280, 3276793343, 'IE', 'IRL', 'إيرلندا'),
(70206, 3276793344, 3276793735, 'FR', 'FRA', 'فرنسا'),
(70207, 3276793736, 3276793743, 'NL', 'NLD', 'هولندا'),
(70208, 3276793744, 3276793751, 'BE', 'BEL', 'بلجيكا'),
(70209, 3276793752, 3276793759, 'FR', 'FRA', 'فرنسا'),
(70210, 3276793760, 3276793791, 'PL', 'POL', 'بولندا'),
(70211, 3276793792, 3276793855, 'FR', 'FRA', 'فرنسا'),
(70212, 3276794112, 3276794255, 'NL', 'NLD', 'هولندا'),
(70213, 3276794256, 3276794271, 'DE', 'DEU', 'ألمانيا'),
(70214, 3276794304, 3276794335, 'DK', 'DNK', 'الدنيمارك'),
(70215, 3276794336, 3276794367, 'NL', 'NLD', 'هولندا'),
(70216, 3276794368, 3276795903, 'BE', 'BEL', 'بلجيكا'),
(70217, 3276795904, 3276797951, 'AT', 'AUT', 'النمسا'),
(70218, 3276799104, 3276799231, 'GB', 'GBR', 'المملكة المتحدة'),
(70219, 3276799296, 3276799359, 'GB', 'GBR', 'المملكة المتحدة'),
(70220, 3276799360, 3276799391, 'NL', 'NLD', 'هولندا'),
(70221, 3276799392, 3276799455, 'AT', 'AUT', 'النمسا'),
(70222, 3276799456, 3276799471, 'PL', 'POL', 'بولندا'),
(70223, 3276799472, 3276799487, 'NL', 'NLD', 'هولندا'),
(70224, 3276799488, 3276799743, 'DE', 'DEU', 'ألمانيا'),
(70225, 3276799744, 3276799775, 'NL', 'NLD', 'هولندا'),
(70226, 3276799776, 3276799807, 'GB', 'GBR', 'المملكة المتحدة'),
(70227, 3276799808, 3276799839, 'FR', 'FRA', 'فرنسا'),
(70228, 3276799840, 3276799871, 'ES', 'ESP', 'إسبانيا'),
(70229, 3276799872, 3276799999, 'NL', 'NLD', 'هولندا'),
(70230, 3276800000, 3276824575, 'GB', 'GBR', 'المملكة المتحدة'),
(70231, 3276824576, 3276832767, 'EE', 'EST', 'إستونيا'),
(70232, 3276832768, 3276834495, 'GB', 'GBR', 'المملكة المتحدة'),
(70233, 3276834496, 3276834503, 'FR', 'FRA', 'فرنسا'),
(70234, 3276834504, 3276834815, 'GB', 'GBR', 'المملكة المتحدة'),
(70235, 3276836864, 3276837887, 'RU', 'RUS', 'الإتحاد الروسي'),
(70236, 3276838912, 3276840959, 'FR', 'FRA', 'فرنسا'),
(70237, 3276840960, 3276849151, 'SK', 'SVK', 'سلوفاكيا'),
(70238, 3276849152, 3276857343, 'DE', 'DEU', 'ألمانيا'),
(70239, 3276857344, 3276857599, 'RU', 'RUS', 'الإتحاد الروسي'),
(70240, 3276857600, 3276857855, 'SI', 'SVN', 'سلوفينيا'),
(70241, 3276857856, 3276858111, 'NL', 'NLD', 'هولندا'),
(70242, 3276858112, 3276858367, 'KW', 'KWT', 'الكويت'),
(70243, 3276858368, 3276858623, 'RU', 'RUS', 'الإتحاد الروسي'),
(70244, 3276858624, 3276858879, 'PL', 'POL', 'بولندا'),
(70245, 3276858880, 3276859135, 'DE', 'DEU', 'ألمانيا'),
(70246, 3276859136, 3276859647, 'UA', 'UKR', 'أوكرانيا'),
(70247, 3276859648, 3276859903, 'CH', 'CHE', 'سويسرا'),
(70248, 3276859904, 3276860159, 'AT', 'AUT', 'النمسا'),
(70249, 3276860160, 3276860415, 'CH', 'CHE', 'سويسرا'),
(70250, 3276860416, 3276860927, 'PL', 'POL', 'بولندا'),
(70251, 3276860928, 3276861183, 'BE', 'BEL', 'بلجيكا'),
(70252, 3276861184, 3276861439, 'DE', 'DEU', 'ألمانيا'),
(70253, 3276861440, 3276865535, 'DK', 'DNK', 'الدنيمارك'),
(70254, 3276865536, 3276866559, 'NL', 'NLD', 'هولندا'),
(70255, 3276866560, 3276866815, 'IT', 'ITA', 'إيطاليا'),
(70256, 3276866816, 3276866863, 'DE', 'DEU', 'ألمانيا'),
(70257, 3276866864, 3276866871, 'FR', 'FRA', 'فرنسا'),
(70258, 3276866872, 3276867071, 'GB', 'GBR', 'المملكة المتحدة'),
(70259, 3276867072, 3276868606, 'IT', 'ITA', 'إيطاليا'),
(70260, 3276868607, 3276868607, 'GB', 'GBR', 'المملكة المتحدة'),
(70261, 3276868608, 3276868863, 'NL', 'NLD', 'هولندا'),
(70262, 3276868864, 3276869855, 'IT', 'ITA', 'إيطاليا'),
(70263, 3276869856, 3276869887, 'GB', 'GBR', 'المملكة المتحدة'),
(70264, 3276869888, 3276870143, 'NL', 'NLD', 'هولندا'),
(70265, 3276870144, 3276871679, 'IT', 'ITA', 'إيطاليا'),
(70266, 3276871680, 3276872479, 'DE', 'DEU', 'ألمانيا'),
(70267, 3276872480, 3276872511, 'GB', 'GBR', 'المملكة المتحدة'),
(70268, 3276872512, 3276872703, 'DE', 'DEU', 'ألمانيا'),
(70269, 3276872704, 3276873727, 'GB', 'GBR', 'المملكة المتحدة'),
(70270, 3276873728, 3276873735, 'ES', 'ESP', 'إسبانيا'),
(70271, 3276873736, 3276873743, 'GB', 'GBR', 'المملكة المتحدة'),
(70272, 3276873744, 3276874303, 'ES', 'ESP', 'إسبانيا'),
(70273, 3276874304, 3276874367, 'GB', 'GBR', 'المملكة المتحدة'),
(70274, 3276874368, 3276874751, 'ES', 'ESP', 'إسبانيا'),
(70275, 3276874752, 3276875263, 'GB', 'GBR', 'المملكة المتحدة'),
(70276, 3276875264, 3276875775, 'NL', 'NLD', 'هولندا'),
(70277, 3276875776, 3276876799, 'GB', 'GBR', 'المملكة المتحدة'),
(70278, 3276876800, 3276876823, 'AT', 'AUT', 'النمسا'),
(70279, 3276876824, 3276877303, 'GB', 'GBR', 'المملكة المتحدة'),
(70280, 3276877304, 3276877311, 'AT', 'AUT', 'النمسا'),
(70281, 3276877312, 3276877535, 'GB', 'GBR', 'المملكة المتحدة'),
(70282, 3276877536, 3276877551, 'AT', 'AUT', 'النمسا'),
(70283, 3276877552, 3276877559, 'GB', 'GBR', 'المملكة المتحدة'),
(70284, 3276877560, 3276877567, 'AT', 'AUT', 'النمسا'),
(70285, 3276877568, 3276877815, 'GB', 'GBR', 'المملكة المتحدة'),
(70286, 3276877816, 3276877823, 'AT', 'AUT', 'النمسا'),
(70287, 3276877824, 3276877831, 'BG', 'BGR', 'بلغاريا'),
(70288, 3276877832, 3276878079, 'GB', 'GBR', 'المملكة المتحدة'),
(70289, 3276878080, 3276878335, 'BG', 'BGR', 'بلغاريا'),
(70290, 3276878336, 3276879871, 'GB', 'GBR', 'المملكة المتحدة'),
(70291, 3276879872, 3276880639, 'DK', 'DNK', 'الدنيمارك'),
(70292, 3276880640, 3276881919, 'GB', 'GBR', 'المملكة المتحدة'),
(70293, 3276881920, 3276883327, 'IT', 'ITA', 'إيطاليا'),
(70294, 3276883328, 3276883967, 'GB', 'GBR', 'المملكة المتحدة'),
(70295, 3276883968, 3276884487, 'PL', 'POL', 'بولندا'),
(70296, 3276884488, 3276886015, 'GB', 'GBR', 'المملكة المتحدة'),
(70297, 3276886016, 3276886271, 'RO', 'ROM', 'رومانيا'),
(70298, 3276886272, 3276888575, 'GB', 'GBR', 'المملكة المتحدة'),
(70299, 3276888576, 3276888831, 'AT', 'AUT', 'النمسا'),
(70300, 3276888832, 3276889087, 'GB', 'GBR', 'المملكة المتحدة'),
(70301, 3276889088, 3276890111, 'AT', 'AUT', 'النمسا'),
(70302, 3276890112, 3276890135, 'US', 'USA', 'الولايات المتحدة'),
(70303, 3276890136, 3276890143, 'GB', 'GBR', 'المملكة المتحدة'),
(70304, 3276890144, 3276890175, 'US', 'USA', 'الولايات المتحدة'),
(70305, 3276890176, 3276890367, 'GB', 'GBR', 'المملكة المتحدة'),
(70306, 3276890368, 3276890623, 'US', 'USA', 'الولايات المتحدة'),
(70307, 3276890624, 3276891135, 'IT', 'ITA', 'إيطاليا'),
(70308, 3276891136, 3276891903, 'GB', 'GBR', 'المملكة المتحدة'),
(70309, 3276891904, 3276892159, 'US', 'USA', 'الولايات المتحدة'),
(70310, 3276892160, 3276893183, 'IT', 'ITA', 'إيطاليا'),
(70311, 3276893184, 3276895231, 'GB', 'GBR', 'المملكة المتحدة'),
(70312, 3276895232, 3276895999, 'IT', 'ITA', 'إيطاليا'),
(70313, 3276896000, 3276896255, 'CZ', 'CZE', 'التشيك'),
(70314, 3276896256, 3276896831, 'BE', 'BEL', 'بلجيكا'),
(70315, 3276896832, 3276896847, 'SE', 'SWE', 'السويد'),
(70316, 3276896848, 3276896895, 'GB', 'GBR', 'المملكة المتحدة'),
(70317, 3276896896, 3276896927, 'BE', 'BEL', 'بلجيكا'),
(70318, 3276896928, 3276897023, 'GB', 'GBR', 'المملكة المتحدة'),
(70319, 3276897024, 3276897279, 'BE', 'BEL', 'بلجيكا'),
(70320, 3276897280, 3276898303, 'GB', 'GBR', 'المملكة المتحدة'),
(70321, 3276898304, 3276898415, 'CH', 'CHE', 'سويسرا'),
(70322, 3276898416, 3276898431, 'GB', 'GBR', 'المملكة المتحدة'),
(70323, 3276898432, 3276898775, 'CH', 'CHE', 'سويسرا'),
(70324, 3276898776, 3276898783, 'GB', 'GBR', 'المملكة المتحدة'),
(70325, 3276898784, 3276900031, 'CH', 'CHE', 'سويسرا'),
(70326, 3276900032, 3276900095, 'GB', 'GBR', 'المملكة المتحدة'),
(70327, 3276900096, 3276900351, 'CH', 'CHE', 'سويسرا'),
(70328, 3276900352, 3276902143, 'GB', 'GBR', 'المملكة المتحدة'),
(70329, 3276902144, 3276902151, 'CH', 'CHE', 'سويسرا'),
(70330, 3276902152, 3276902159, 'GB', 'GBR', 'المملكة المتحدة'),
(70331, 3276902160, 3276902175, 'CH', 'CHE', 'سويسرا'),
(70332, 3276902176, 3276902399, 'GB', 'GBR', 'المملكة المتحدة'),
(70333, 3276902400, 3276902575, 'SE', 'SWE', 'السويد'),
(70334, 3276902576, 3276902655, 'GB', 'GBR', 'المملكة المتحدة'),
(70335, 3276902656, 3276903422, 'SE', 'SWE', 'السويد'),
(70336, 3276903423, 3276903423, 'GB', 'GBR', 'المملكة المتحدة'),
(70337, 3276903424, 3276903487, 'SE', 'SWE', 'السويد'),
(70338, 3276903488, 3276903551, 'GB', 'GBR', 'المملكة المتحدة'),
(70339, 3276903552, 3276903679, 'SE', 'SWE', 'السويد'),
(70340, 3276903680, 3276905471, 'GB', 'GBR', 'المملكة المتحدة'),
(70341, 3276905472, 3276905727, 'SE', 'SWE', 'السويد'),
(70342, 3276905728, 3276906239, 'BE', 'BEL', 'بلجيكا'),
(70343, 3276906240, 3276906279, 'SE', 'SWE', 'السويد'),
(70344, 3276906280, 3276906495, 'GB', 'GBR', 'المملكة المتحدة'),
(70345, 3276906496, 3276906863, 'NL', 'NLD', 'هولندا'),
(70346, 3276906864, 3276907007, 'GB', 'GBR', 'المملكة المتحدة'),
(70347, 3276907008, 3276907263, 'NL', 'NLD', 'هولندا'),
(70348, 3276907264, 3276910079, 'GB', 'GBR', 'المملكة المتحدة'),
(70349, 3276910080, 3276910591, 'NL', 'NLD', 'هولندا'),
(70350, 3276910592, 3276912615, 'IT', 'ITA', 'إيطاليا'),
(70351, 3276912616, 3276912623, 'GB', 'GBR', 'المملكة المتحدة'),
(70352, 3276912624, 3276913919, 'IT', 'ITA', 'إيطاليا'),
(70353, 3276913920, 3276913983, 'US', 'USA', 'الولايات المتحدة'),
(70354, 3276913984, 3276914095, 'IT', 'ITA', 'إيطاليا'),
(70355, 3276914096, 3276914111, 'GB', 'GBR', 'المملكة المتحدة'),
(70356, 3276914112, 3276914687, 'IT', 'ITA', 'إيطاليا'),
(70357, 3276914688, 3276915455, 'ES', 'ESP', 'إسبانيا'),
(70358, 3276915456, 3276915487, 'GB', 'GBR', 'المملكة المتحدة'),
(70359, 3276915488, 3276916175, 'ES', 'ESP', 'إسبانيا'),
(70360, 3276916176, 3276916183, 'GB', 'GBR', 'المملكة المتحدة'),
(70361, 3276916184, 3276917231, 'ES', 'ESP', 'إسبانيا'),
(70362, 3276917232, 3276917247, 'GB', 'GBR', 'المملكة المتحدة'),
(70363, 3276917248, 3276917279, 'ES', 'ESP', 'إسبانيا'),
(70364, 3276917280, 3276917287, 'GB', 'GBR', 'المملكة المتحدة'),
(70365, 3276917288, 3276917311, 'ES', 'ESP', 'إسبانيا'),
(70366, 3276917312, 3276917343, 'GB', 'GBR', 'المملكة المتحدة'),
(70367, 3276917344, 3276917759, 'ES', 'ESP', 'إسبانيا'),
(70368, 3276917760, 3276918783, 'GB', 'GBR', 'المملكة المتحدة'),
(70369, 3276918784, 3276920551, 'DE', 'DEU', 'ألمانيا'),
(70370, 3276920552, 3276920559, 'GB', 'GBR', 'المملكة المتحدة'),
(70371, 3276920560, 3276921183, 'DE', 'DEU', 'ألمانيا'),
(70372, 3276921184, 3276921191, 'GB', 'GBR', 'المملكة المتحدة'),
(70373, 3276921192, 3276921231, 'DE', 'DEU', 'ألمانيا'),
(70374, 3276921232, 3276921599, 'GB', 'GBR', 'المملكة المتحدة'),
(70375, 3276921600, 3276921607, 'DE', 'DEU', 'ألمانيا'),
(70376, 3276921608, 3276921855, 'GB', 'GBR', 'المملكة المتحدة'),
(70377, 3276921856, 3276922623, 'DE', 'DEU', 'ألمانيا'),
(70378, 3276922624, 3276923431, 'FR', 'FRA', 'فرنسا'),
(70379, 3276923432, 3276923455, 'GB', 'GBR', 'المملكة المتحدة'),
(70380, 3276923456, 3276923583, 'FR', 'FRA', 'فرنسا'),
(70381, 3276923584, 3276923647, 'GB', 'GBR', 'المملكة المتحدة'),
(70382, 3276923648, 3276924039, 'FR', 'FRA', 'فرنسا'),
(70383, 3276924040, 3276924159, 'GB', 'GBR', 'المملكة المتحدة'),
(70384, 3276924160, 3276924287, 'FR', 'FRA', 'فرنسا'),
(70385, 3276924288, 3276924415, 'GB', 'GBR', 'المملكة المتحدة'),
(70386, 3276924416, 3276925695, 'FR', 'FRA', 'فرنسا'),
(70387, 3276925696, 3276926719, 'GB', 'GBR', 'المملكة المتحدة'),
(70388, 3276926720, 3276926735, 'FR', 'FRA', 'فرنسا'),
(70389, 3276926736, 3276931071, 'GB', 'GBR', 'المملكة المتحدة'),
(70390, 3276931072, 3276939263, 'KZ', 'KAZ', 'كازاخستان'),
(70391, 3276939264, 3276955647, 'DE', 'DEU', 'ألمانيا'),
(70392, 3276955648, 3276963839, 'GB', 'GBR', 'المملكة المتحدة'),
(70393, 3276963840, 3276964351, 'IL', 'ISR', 'إسرائيل'),
(70394, 3276964352, 3276965375, 'RO', 'ROM', 'رومانيا'),
(70395, 3276965376, 3276966399, 'RU', 'RUS', 'الإتحاد الروسي'),
(70396, 3276966400, 3276966911, 'BH', 'BHR', 'البحرين'),
(70397, 3276966912, 3276968959, 'RU', 'RUS', 'الإتحاد الروسي'),
(70398, 3276968960, 3276969471, 'RO', 'ROM', 'رومانيا'),
(70399, 3276969472, 3276969983, 'UA', 'UKR', 'أوكرانيا'),
(70400, 3276969984, 3276970495, 'NL', 'NLD', 'هولندا'),
(70401, 3276970496, 3276971519, 'RU', 'RUS', 'الإتحاد الروسي'),
(70402, 3276971520, 3276972031, 'DE', 'DEU', 'ألمانيا'),
(70403, 3276972032, 3276980223, 'PL', 'POL', 'بولندا'),
(70404, 3276980224, 3276988415, 'DK', 'DNK', 'الدنيمارك'),
(70405, 3276988416, 3276996607, 'AT', 'AUT', 'النمسا'),
(70406, 3276996608, 3277062143, 'FR', 'FRA', 'فرنسا'),
(70407, 3277062144, 3277127679, 'SE', 'SWE', 'السويد'),
(70408, 3277127680, 3277160447, 'DK', 'DNK', 'الدنيمارك'),
(70409, 3277160448, 3277176831, 'NL', 'NLD', 'هولندا'),
(70410, 3277176832, 3277177087, 'SI', 'SVN', 'سلوفينيا'),
(70411, 3277177088, 3277177343, 'GB', 'GBR', 'المملكة المتحدة'),
(70412, 3277177344, 3277177599, 'RO', 'ROM', 'رومانيا'),
(70413, 3277177600, 3277178111, 'PL', 'POL', 'بولندا'),
(70414, 3277178112, 3277178623, 'UA', 'UKR', 'أوكرانيا'),
(70415, 3277178624, 3277178879, 'PL', 'POL', 'بولندا'),
(70416, 3277178880, 3277179135, 'ES', 'ESP', 'إسبانيا'),
(70417, 3277179136, 3277179391, 'RO', 'ROM', 'رومانيا'),
(70418, 3277179392, 3277179647, 'DE', 'DEU', 'ألمانيا'),
(70419, 3277179648, 3277180159, 'BE', 'BEL', 'بلجيكا'),
(70420, 3277180160, 3277180415, 'NL', 'NLD', 'هولندا'),
(70421, 3277180416, 3277180671, 'GB', 'GBR', 'المملكة المتحدة'),
(70422, 3277180672, 3277180927, 'FR', 'FRA', 'فرنسا'),
(70423, 3277180928, 3277181183, 'DE', 'DEU', 'ألمانيا'),
(70424, 3277181184, 3277181439, 'PL', 'POL', 'بولندا'),
(70425, 3277181440, 3277181695, 'DE', 'DEU', 'ألمانيا'),
(70426, 3277181696, 3277181951, 'RO', 'ROM', 'رومانيا'),
(70427, 3277181952, 3277182207, 'IT', 'ITA', 'إيطاليا'),
(70428, 3277182208, 3277182463, 'RU', 'RUS', 'الإتحاد الروسي'),
(70429, 3277182464, 3277182719, 'UA', 'UKR', 'أوكرانيا'),
(70430, 3277182720, 3277182975, 'BG', 'BGR', 'بلغاريا'),
(70431, 3277182976, 3277183231, 'UA', 'UKR', 'أوكرانيا'),
(70432, 3277183232, 3277183487, 'DE', 'DEU', 'ألمانيا'),
(70433, 3277183488, 3277183743, 'DK', 'DNK', 'الدنيمارك'),
(70434, 3277183744, 3277183999, 'UA', 'UKR', 'أوكرانيا'),
(70435, 3277184000, 3277184255, 'DE', 'DEU', 'ألمانيا'),
(70436, 3277184256, 3277184511, 'PT', 'PRT', 'البورتوغال'),
(70437, 3277184512, 3277184767, 'DE', 'DEU', 'ألمانيا'),
(70438, 3277184768, 3277185023, 'UA', 'UKR', 'أوكرانيا'),
(70439, 3277185024, 3277185279, 'SA', 'SAU', 'السعودية'),
(70440, 3277185280, 3277185535, 'RU', 'RUS', 'الإتحاد الروسي'),
(70441, 3277185536, 3277185791, 'DE', 'DEU', 'ألمانيا'),
(70442, 3277185792, 3277186047, 'PL', 'POL', 'بولندا'),
(70443, 3277186048, 3277186303, 'IT', 'ITA', 'إيطاليا'),
(70444, 3277186304, 3277186559, 'DE', 'DEU', 'ألمانيا'),
(70445, 3277186560, 3277186815, 'PL', 'POL', 'بولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(70446, 3277186816, 3277187071, 'RU', 'RUS', 'الإتحاد الروسي'),
(70447, 3277187072, 3277187327, 'GB', 'GBR', 'المملكة المتحدة'),
(70448, 3277187328, 3277187583, 'UA', 'UKR', 'أوكرانيا'),
(70449, 3277187584, 3277188351, 'RU', 'RUS', 'الإتحاد الروسي'),
(70450, 3277188352, 3277188607, 'GB', 'GBR', 'المملكة المتحدة'),
(70451, 3277188608, 3277188863, 'RU', 'RUS', 'الإتحاد الروسي'),
(70452, 3277188864, 3277189119, 'RO', 'ROM', 'رومانيا'),
(70453, 3277189120, 3277189375, 'DE', 'DEU', 'ألمانيا'),
(70454, 3277189376, 3277189631, 'PL', 'POL', 'بولندا'),
(70455, 3277189632, 3277189887, 'TR', 'TUR', 'تركيا'),
(70456, 3277189888, 3277190143, 'PL', 'POL', 'بولندا'),
(70457, 3277190144, 3277190399, 'SE', 'SWE', 'السويد'),
(70458, 3277190400, 3277190655, 'GB', 'GBR', 'المملكة المتحدة'),
(70459, 3277190656, 3277190911, 'BE', 'BEL', 'بلجيكا'),
(70460, 3277190912, 3277191167, 'FR', 'FRA', 'فرنسا'),
(70461, 3277191168, 3277191423, 'DK', 'DNK', 'الدنيمارك'),
(70462, 3277191424, 3277191679, 'PL', 'POL', 'بولندا'),
(70463, 3277191680, 3277191935, 'UA', 'UKR', 'أوكرانيا'),
(70464, 3277191936, 3277192191, 'DK', 'DNK', 'الدنيمارك'),
(70465, 3277192192, 3277192447, 'PL', 'POL', 'بولندا'),
(70466, 3277192448, 3277192703, 'DK', 'DNK', 'الدنيمارك'),
(70467, 3277192704, 3277192959, 'IL', 'ISR', 'إسرائيل'),
(70468, 3277192960, 3277193215, 'TR', 'TUR', 'تركيا'),
(70469, 3277193216, 3277254727, 'NL', 'NLD', 'هولندا'),
(70470, 3277254728, 3277254735, 'DE', 'DEU', 'ألمانيا'),
(70471, 3277254736, 3277258751, 'NL', 'NLD', 'هولندا'),
(70472, 3277258752, 3277324287, 'TR', 'TUR', 'تركيا'),
(70473, 3277324288, 3277325311, 'RU', 'RUS', 'الإتحاد الروسي'),
(70474, 3277325312, 3277326335, 'IT', 'ITA', 'إيطاليا'),
(70475, 3277326336, 3277326847, 'GB', 'GBR', 'المملكة المتحدة'),
(70476, 3277326848, 3277327359, 'AT', 'AUT', 'النمسا'),
(70477, 3277327360, 3277327871, 'RS', 'SRB', 'صربيا'),
(70478, 3277327872, 3277328383, 'UA', 'UKR', 'أوكرانيا'),
(70479, 3277328384, 3277328895, 'RU', 'RUS', 'الإتحاد الروسي'),
(70480, 3277328896, 3277329407, 'NL', 'NLD', 'هولندا'),
(70481, 3277329408, 3277329919, 'GB', 'GBR', 'المملكة المتحدة'),
(70482, 3277329920, 3277330431, 'RU', 'RUS', 'الإتحاد الروسي'),
(70483, 3277330432, 3277330943, 'RO', 'ROM', 'رومانيا'),
(70484, 3277330944, 3277331455, 'UA', 'UKR', 'أوكرانيا'),
(70485, 3277331456, 3277332479, 'PL', 'POL', 'بولندا'),
(70486, 3277332992, 3277333503, 'AT', 'AUT', 'النمسا'),
(70487, 3277334016, 3277334527, 'RO', 'ROM', 'رومانيا'),
(70488, 3277334528, 3277335039, 'RU', 'RUS', 'الإتحاد الروسي'),
(70489, 3277335040, 3277335551, 'UA', 'UKR', 'أوكرانيا'),
(70490, 3277335552, 3277336063, 'DE', 'DEU', 'ألمانيا'),
(70491, 3277336064, 3277336575, 'HR', 'HRV', 'كرواتيا'),
(70492, 3277336576, 3277337087, 'AT', 'AUT', 'النمسا'),
(70493, 3277337088, 3277337599, 'PL', 'POL', 'بولندا'),
(70494, 3277337600, 3277338111, 'UA', 'UKR', 'أوكرانيا'),
(70495, 3277338112, 3277338623, 'NO', 'NOR', 'النرويج'),
(70496, 3277338624, 3277339647, 'RU', 'RUS', 'الإتحاد الروسي'),
(70497, 3277339648, 3277340159, 'RO', 'ROM', 'رومانيا'),
(70498, 3277340160, 3277340671, 'RU', 'RUS', 'الإتحاد الروسي'),
(70499, 3277340672, 3277341183, 'RO', 'ROM', 'رومانيا'),
(70500, 3277341184, 3277341695, 'AM', 'ARM', 'أرمينيا'),
(70501, 3277341696, 3277342207, 'RU', 'RUS', 'الإتحاد الروسي'),
(70502, 3277342208, 3277342719, 'GB', 'GBR', 'المملكة المتحدة'),
(70503, 3277342720, 3277343231, 'UA', 'UKR', 'أوكرانيا'),
(70504, 3277343232, 3277343743, 'BG', 'BGR', 'بلغاريا'),
(70505, 3277343744, 3277344767, 'UA', 'UKR', 'أوكرانيا'),
(70506, 3277345280, 3277345791, 'SI', 'SVN', 'سلوفينيا'),
(70507, 3277345792, 3277346303, 'FR', 'FRA', 'فرنسا'),
(70508, 3277346304, 3277346815, 'GB', 'GBR', 'المملكة المتحدة'),
(70509, 3277346816, 3277347327, 'DE', 'DEU', 'ألمانيا'),
(70510, 3277347328, 3277347839, 'PL', 'POL', 'بولندا'),
(70511, 3277347840, 3277348351, 'RU', 'RUS', 'الإتحاد الروسي'),
(70512, 3277348352, 3277348863, 'FR', 'FRA', 'فرنسا'),
(70513, 3277348864, 3277349887, 'RO', 'ROM', 'رومانيا'),
(70514, 3277349888, 3277350399, 'GB', 'GBR', 'المملكة المتحدة'),
(70515, 3277350400, 3277351423, 'RU', 'RUS', 'الإتحاد الروسي'),
(70516, 3277351424, 3277351935, 'NO', 'NOR', 'النرويج'),
(70517, 3277351936, 3277352447, 'DE', 'DEU', 'ألمانيا'),
(70518, 3277352448, 3277352959, 'SE', 'SWE', 'السويد'),
(70519, 3277352960, 3277353471, 'UA', 'UKR', 'أوكرانيا'),
(70520, 3277353472, 3277353983, 'PL', 'POL', 'بولندا'),
(70521, 3277353984, 3277354495, 'DE', 'DEU', 'ألمانيا'),
(70522, 3277354496, 3277355007, 'GB', 'GBR', 'المملكة المتحدة'),
(70523, 3277355008, 3277355519, 'RU', 'RUS', 'الإتحاد الروسي'),
(70524, 3277355520, 3277356031, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(70525, 3277356032, 3277356543, 'UA', 'UKR', 'أوكرانيا'),
(70526, 3277356544, 3277357055, 'RU', 'RUS', 'الإتحاد الروسي'),
(70527, 3277357056, 3277357567, 'PL', 'POL', 'بولندا'),
(70528, 3277357568, 3277358079, 'SE', 'SWE', 'السويد'),
(70529, 3277358080, 3277359103, 'RU', 'RUS', 'الإتحاد الروسي'),
(70530, 3277359104, 3277359615, 'NL', 'NLD', 'هولندا'),
(70531, 3277359616, 3277360127, 'UA', 'UKR', 'أوكرانيا'),
(70532, 3277360128, 3277360639, 'BG', 'BGR', 'بلغاريا'),
(70533, 3277360640, 3277361151, 'CZ', 'CZE', 'التشيك'),
(70534, 3277361152, 3277361663, 'UA', 'UKR', 'أوكرانيا'),
(70535, 3277361664, 3277362175, 'RU', 'RUS', 'الإتحاد الروسي'),
(70536, 3277362176, 3277362687, 'ES', 'ESP', 'إسبانيا'),
(70537, 3277362688, 3277363199, 'IE', 'IRL', 'إيرلندا'),
(70538, 3277363200, 3277363711, 'ES', 'ESP', 'إسبانيا'),
(70539, 3277363712, 3277364223, 'RU', 'RUS', 'الإتحاد الروسي'),
(70540, 3277364224, 3277364735, 'GB', 'GBR', 'المملكة المتحدة'),
(70541, 3277364736, 3277365247, 'UA', 'UKR', 'أوكرانيا'),
(70542, 3277365248, 3277365759, 'NL', 'NLD', 'هولندا'),
(70543, 3277365760, 3277366271, 'GR', 'GRC', 'اليونان'),
(70544, 3277366272, 3277366783, 'CZ', 'CZE', 'التشيك'),
(70545, 3277366784, 3277367295, 'AT', 'AUT', 'النمسا'),
(70546, 3277367296, 3277367807, 'PL', 'POL', 'بولندا'),
(70547, 3277367808, 3277368319, 'RU', 'RUS', 'الإتحاد الروسي'),
(70548, 3277368320, 3277369343, 'RO', 'ROM', 'رومانيا'),
(70549, 3277369344, 3277369855, 'CY', 'CYP', 'قبرص'),
(70550, 3277369856, 3277370367, 'RU', 'RUS', 'الإتحاد الروسي'),
(70551, 3277370368, 3277370879, 'SE', 'SWE', 'السويد'),
(70552, 3277370880, 3277371391, 'RO', 'ROM', 'رومانيا'),
(70553, 3277371392, 3277371903, 'RU', 'RUS', 'الإتحاد الروسي'),
(70554, 3277371904, 3277372415, 'PL', 'POL', 'بولندا'),
(70555, 3277372416, 3277373951, 'RU', 'RUS', 'الإتحاد الروسي'),
(70556, 3277373952, 3277374463, 'FR', 'FRA', 'فرنسا'),
(70557, 3277374464, 3277375999, 'RU', 'RUS', 'الإتحاد الروسي'),
(70558, 3277376000, 3277376511, 'NL', 'NLD', 'هولندا'),
(70559, 3277376512, 3277377023, 'RO', 'ROM', 'رومانيا'),
(70560, 3277377024, 3277378559, 'RU', 'RUS', 'الإتحاد الروسي'),
(70561, 3277378560, 3277379071, 'HR', 'HRV', 'كرواتيا'),
(70562, 3277379072, 3277379583, 'UZ', 'UZB', 'أوزباكستان'),
(70563, 3277379584, 3277380095, 'RS', 'SRB', 'صربيا'),
(70564, 3277380096, 3277380607, 'RO', 'ROM', 'رومانيا'),
(70565, 3277380608, 3277381119, 'RU', 'RUS', 'الإتحاد الروسي'),
(70566, 3277381120, 3277381631, 'KW', 'KWT', 'الكويت'),
(70567, 3277381632, 3277382143, 'RU', 'RUS', 'الإتحاد الروسي'),
(70568, 3277382144, 3277382655, 'MD', 'MDA', 'مولدوفا'),
(70569, 3277382656, 3277383167, 'GB', 'GBR', 'المملكة المتحدة'),
(70570, 3277383168, 3277383679, 'UA', 'UKR', 'أوكرانيا'),
(70571, 3277383680, 3277384191, 'PL', 'POL', 'بولندا'),
(70572, 3277384192, 3277384703, 'IL', 'ISR', 'إسرائيل'),
(70573, 3277384704, 3277385215, 'GB', 'GBR', 'المملكة المتحدة'),
(70574, 3277385216, 3277385727, 'AT', 'AUT', 'النمسا'),
(70575, 3277385728, 3277386239, 'RU', 'RUS', 'الإتحاد الروسي'),
(70576, 3277386240, 3277386751, 'UA', 'UKR', 'أوكرانيا'),
(70577, 3277386752, 3277387263, 'SA', 'SAU', 'السعودية'),
(70578, 3277387264, 3277388287, 'RU', 'RUS', 'الإتحاد الروسي'),
(70579, 3277388288, 3277388799, 'SE', 'SWE', 'السويد'),
(70580, 3277388800, 3277389311, 'RU', 'RUS', 'الإتحاد الروسي'),
(70581, 3277389312, 3277389823, 'AM', 'ARM', 'أرمينيا'),
(70582, 3277389824, 3277394943, 'GB', 'GBR', 'المملكة المتحدة'),
(70583, 3277394944, 3277395455, 'US', 'USA', 'الولايات المتحدة'),
(70584, 3277395456, 3277395951, 'GB', 'GBR', 'المملكة المتحدة'),
(70585, 3277395952, 3277395967, 'IE', 'IRL', 'إيرلندا'),
(70586, 3277395968, 3277452647, 'GB', 'GBR', 'المملكة المتحدة'),
(70587, 3277452648, 3277452655, 'DK', 'DNK', 'الدنيمارك'),
(70588, 3277452656, 3277455359, 'GB', 'GBR', 'المملكة المتحدة'),
(70589, 3277455360, 3277463551, 'DE', 'DEU', 'ألمانيا'),
(70590, 3277463552, 3277463807, 'GB', 'GBR', 'المملكة المتحدة'),
(70591, 3277463808, 3277464063, 'US', 'USA', 'الولايات المتحدة'),
(70592, 3277464064, 3277464575, 'FR', 'FRA', 'فرنسا'),
(70593, 3277464576, 3277464831, 'BE', 'BEL', 'بلجيكا'),
(70594, 3277466624, 3277466879, 'US', 'USA', 'الولايات المتحدة'),
(70595, 3277467472, 3277467551, 'CA', 'CAN', 'كندا'),
(70596, 3277467648, 3277467663, 'US', 'USA', 'الولايات المتحدة'),
(70597, 3277467904, 3277467919, 'US', 'USA', 'الولايات المتحدة'),
(70598, 3277468096, 3277468607, 'US', 'USA', 'الولايات المتحدة'),
(70599, 3277468672, 3277468735, 'US', 'USA', 'الولايات المتحدة'),
(70600, 3277469184, 3277469439, 'US', 'USA', 'الولايات المتحدة'),
(70601, 3277471744, 3277472607, 'NL', 'NLD', 'هولندا'),
(70602, 3277472608, 3277472623, 'IL', 'ISR', 'إسرائيل'),
(70603, 3277472624, 3277474815, 'NL', 'NLD', 'هولندا'),
(70604, 3277474816, 3277475711, 'BE', 'BEL', 'بلجيكا'),
(70605, 3277475712, 3277476607, 'NL', 'NLD', 'هولندا'),
(70606, 3277476608, 3277477631, 'BE', 'BEL', 'بلجيكا'),
(70607, 3277477632, 3277479935, 'NL', 'NLD', 'هولندا'),
(70608, 3277479936, 3277480959, 'GB', 'GBR', 'المملكة المتحدة'),
(70609, 3277480960, 3277481471, 'DK', 'DNK', 'الدنيمارك'),
(70610, 3277481472, 3277481983, 'PL', 'POL', 'بولندا'),
(70611, 3277481984, 3277482495, 'SE', 'SWE', 'السويد'),
(70612, 3277482496, 3277483007, 'PL', 'POL', 'بولندا'),
(70613, 3277483008, 3277483519, 'IT', 'ITA', 'إيطاليا'),
(70614, 3277483520, 3277484031, 'RO', 'ROM', 'رومانيا'),
(70615, 3277484032, 3277484543, 'CH', 'CHE', 'سويسرا'),
(70616, 3277484544, 3277485055, 'RO', 'ROM', 'رومانيا'),
(70617, 3277485056, 3277485567, 'CH', 'CHE', 'سويسرا'),
(70618, 3277485568, 3277486591, 'GB', 'GBR', 'المملكة المتحدة'),
(70619, 3277486592, 3277487103, 'UA', 'UKR', 'أوكرانيا'),
(70620, 3277487104, 3277487615, 'RO', 'ROM', 'رومانيا'),
(70621, 3277487616, 3277488127, 'PL', 'POL', 'بولندا'),
(70622, 3277488128, 3277504511, 'RU', 'RUS', 'الإتحاد الروسي'),
(70623, 3277504512, 3277520895, 'DE', 'DEU', 'ألمانيا'),
(70624, 3277520896, 3277553663, 'SK', 'SVK', 'سلوفاكيا'),
(70625, 3277553664, 3277586431, 'RU', 'RUS', 'الإتحاد الروسي'),
(70626, 3277586432, 3277651967, 'GB', 'GBR', 'المملكة المتحدة'),
(70627, 3277651968, 3277684735, 'US', 'USA', 'الولايات المتحدة'),
(70628, 3277684736, 3277685247, 'RU', 'RUS', 'الإتحاد الروسي'),
(70629, 3277685248, 3277685759, 'DE', 'DEU', 'ألمانيا'),
(70630, 3277685760, 3277686271, 'IE', 'IRL', 'إيرلندا'),
(70631, 3277686272, 3277686783, 'PL', 'POL', 'بولندا'),
(70632, 3277686784, 3277687295, 'RO', 'ROM', 'رومانيا'),
(70633, 3277687296, 3277687807, 'UA', 'UKR', 'أوكرانيا'),
(70634, 3277687808, 3277688319, 'RO', 'ROM', 'رومانيا'),
(70635, 3277688320, 3277688831, 'PL', 'POL', 'بولندا'),
(70636, 3277689344, 3277689855, 'AT', 'AUT', 'النمسا'),
(70637, 3277689856, 3277690879, 'RU', 'RUS', 'الإتحاد الروسي'),
(70638, 3277690880, 3277691391, 'KZ', 'KAZ', 'كازاخستان'),
(70639, 3277691392, 3277691903, 'UA', 'UKR', 'أوكرانيا'),
(70640, 3277691904, 3277692415, 'GB', 'GBR', 'المملكة المتحدة'),
(70641, 3277692416, 3277692927, 'DE', 'DEU', 'ألمانيا'),
(70642, 3277692928, 3277693439, 'UA', 'UKR', 'أوكرانيا'),
(70643, 3277693440, 3277693951, 'PL', 'POL', 'بولندا'),
(70644, 3277693952, 3277694463, 'RU', 'RUS', 'الإتحاد الروسي'),
(70645, 3277694464, 3277694975, 'DE', 'DEU', 'ألمانيا'),
(70646, 3277694976, 3277695487, 'IT', 'ITA', 'إيطاليا'),
(70647, 3277695488, 3277695999, 'ES', 'ESP', 'إسبانيا'),
(70648, 3277696000, 3277696511, 'UA', 'UKR', 'أوكرانيا'),
(70649, 3277696512, 3277697023, 'AT', 'AUT', 'النمسا'),
(70650, 3277697024, 3277697535, 'RO', 'ROM', 'رومانيا'),
(70651, 3277697536, 3277698047, 'PL', 'POL', 'بولندا'),
(70652, 3277698048, 3277698559, 'RU', 'RUS', 'الإتحاد الروسي'),
(70653, 3277698560, 3277699071, 'DE', 'DEU', 'ألمانيا'),
(70654, 3277699072, 3277699583, 'UA', 'UKR', 'أوكرانيا'),
(70655, 3277699584, 3277700607, 'RU', 'RUS', 'الإتحاد الروسي'),
(70656, 3277700608, 3277701119, 'UA', 'UKR', 'أوكرانيا'),
(70657, 3277701120, 3277701631, 'DK', 'DNK', 'الدنيمارك'),
(70658, 3277701632, 3277702143, 'AT', 'AUT', 'النمسا'),
(70659, 3277702144, 3277702655, 'GB', 'GBR', 'المملكة المتحدة'),
(70660, 3277702656, 3277703167, 'RO', 'ROM', 'رومانيا'),
(70661, 3277703168, 3277703679, 'DE', 'DEU', 'ألمانيا'),
(70662, 3277703680, 3277704191, 'PL', 'POL', 'بولندا'),
(70663, 3277704192, 3277704703, 'UA', 'UKR', 'أوكرانيا'),
(70664, 3277704704, 3277705215, 'RU', 'RUS', 'الإتحاد الروسي'),
(70665, 3277705216, 3277705727, 'KZ', 'KAZ', 'كازاخستان'),
(70666, 3277705728, 3277706239, 'ES', 'ESP', 'إسبانيا'),
(70667, 3277706240, 3277707263, 'UA', 'UKR', 'أوكرانيا'),
(70668, 3277707264, 3277707775, 'CZ', 'CZE', 'التشيك'),
(70669, 3277707776, 3277708287, 'MD', 'MDA', 'مولدوفا'),
(70670, 3277708288, 3277708799, 'AT', 'AUT', 'النمسا'),
(70671, 3277708800, 3277709311, 'PL', 'POL', 'بولندا'),
(70672, 3277709312, 3277709823, 'NL', 'NLD', 'هولندا'),
(70673, 3277709824, 3277710335, 'GB', 'GBR', 'المملكة المتحدة'),
(70674, 3277710336, 3277710847, 'RU', 'RUS', 'الإتحاد الروسي'),
(70675, 3277710848, 3277711359, 'PL', 'POL', 'بولندا'),
(70676, 3277711360, 3277711871, 'NO', 'NOR', 'النرويج'),
(70677, 3277711872, 3277712383, 'IL', 'ISR', 'إسرائيل'),
(70678, 3277712384, 3277712895, 'FR', 'FRA', 'فرنسا'),
(70679, 3277712896, 3277713407, 'NL', 'NLD', 'هولندا'),
(70680, 3277713408, 3277713919, 'RU', 'RUS', 'الإتحاد الروسي'),
(70681, 3277713920, 3277714943, 'DE', 'DEU', 'ألمانيا'),
(70682, 3277714944, 3277715967, 'RU', 'RUS', 'الإتحاد الروسي'),
(70683, 3277715968, 3277716479, 'PL', 'POL', 'بولندا'),
(70684, 3277716480, 3277716991, 'SE', 'SWE', 'السويد'),
(70685, 3277716992, 3277717503, 'IT', 'ITA', 'إيطاليا'),
(70686, 3277717504, 3277725695, 'YE', 'YEM', 'اليمن'),
(70687, 3277725696, 3277728367, 'CH', 'CHE', 'سويسرا'),
(70688, 3277728368, 3277728383, 'NL', 'NLD', 'هولندا'),
(70689, 3277728384, 3277733887, 'CH', 'CHE', 'سويسرا'),
(70690, 3277733888, 3277742079, 'DE', 'DEU', 'ألمانيا'),
(70691, 3277742080, 3277750271, 'FI', 'FIN', 'فنلندا'),
(70692, 3277750272, 3277766655, 'IT', 'ITA', 'إيطاليا'),
(70693, 3277766656, 3277774847, 'PL', 'POL', 'بولندا'),
(70694, 3277774848, 3277783039, 'RU', 'RUS', 'الإتحاد الروسي'),
(70695, 3277783040, 3277815807, 'BE', 'BEL', 'بلجيكا'),
(70696, 3277815808, 3277816063, 'RO', 'ROM', 'رومانيا'),
(70697, 3277816064, 3277816319, 'PL', 'POL', 'بولندا'),
(70698, 3277816320, 3277816575, 'CM', 'CMR', 'الكاميرون'),
(70699, 3277816576, 3277816831, 'GB', 'GBR', 'المملكة المتحدة'),
(70700, 3277816832, 3277817087, 'CH', 'CHE', 'سويسرا'),
(70701, 3277817088, 3277817343, 'GB', 'GBR', 'المملكة المتحدة'),
(70702, 3277817344, 3277817855, 'FR', 'FRA', 'فرنسا'),
(70703, 3277817856, 3277818111, 'BE', 'BEL', 'بلجيكا'),
(70704, 3277818112, 3277818367, 'DE', 'DEU', 'ألمانيا'),
(70705, 3277818368, 3277818623, 'CY', 'CYP', 'قبرص'),
(70706, 3277818624, 3277818879, 'UA', 'UKR', 'أوكرانيا'),
(70707, 3277818880, 3277819135, 'SE', 'SWE', 'السويد'),
(70708, 3277819136, 3277819391, 'CH', 'CHE', 'سويسرا'),
(70709, 3277819392, 3277819647, 'IT', 'ITA', 'إيطاليا'),
(70710, 3277819648, 3277819903, 'GB', 'GBR', 'المملكة المتحدة'),
(70711, 3277819904, 3277820159, 'PL', 'POL', 'بولندا'),
(70712, 3277820160, 3277820415, 'RO', 'ROM', 'رومانيا'),
(70713, 3277820416, 3277820671, 'DE', 'DEU', 'ألمانيا'),
(70714, 3277820672, 3277820927, 'UA', 'UKR', 'أوكرانيا'),
(70715, 3277820928, 3277821183, 'CH', 'CHE', 'سويسرا'),
(70716, 3277821184, 3277821439, 'TR', 'TUR', 'تركيا'),
(70717, 3277821440, 3277821695, 'NL', 'NLD', 'هولندا'),
(70718, 3277821696, 3277821951, 'UA', 'UKR', 'أوكرانيا'),
(70719, 3277821952, 3277822207, 'RO', 'ROM', 'رومانيا'),
(70720, 3277822208, 3277822463, 'ES', 'ESP', 'إسبانيا'),
(70721, 3277822464, 3277822719, 'PL', 'POL', 'بولندا'),
(70722, 3277822720, 3277822975, 'RU', 'RUS', 'الإتحاد الروسي'),
(70723, 3277822976, 3277823231, 'FR', 'FRA', 'فرنسا'),
(70724, 3277823232, 3277823487, 'UA', 'UKR', 'أوكرانيا'),
(70725, 3277823488, 3277823743, 'SI', 'SVN', 'سلوفينيا'),
(70726, 3277823744, 3277823999, 'UA', 'UKR', 'أوكرانيا'),
(70727, 3277824000, 3277824255, 'TR', 'TUR', 'تركيا'),
(70728, 3277824256, 3277824511, 'SI', 'SVN', 'سلوفينيا'),
(70729, 3277824512, 3277824767, 'UA', 'UKR', 'أوكرانيا'),
(70730, 3277824768, 3277825023, 'AT', 'AUT', 'النمسا'),
(70731, 3277825024, 3277825279, 'PL', 'POL', 'بولندا'),
(70732, 3277825280, 3277825535, 'UA', 'UKR', 'أوكرانيا'),
(70733, 3277825536, 3277826047, 'RO', 'ROM', 'رومانيا'),
(70734, 3277826048, 3277826303, 'FR', 'FRA', 'فرنسا'),
(70735, 3277826304, 3277826815, 'PL', 'POL', 'بولندا'),
(70736, 3277826816, 3277827071, 'UA', 'UKR', 'أوكرانيا'),
(70737, 3277827072, 3277827327, 'DK', 'DNK', 'الدنيمارك'),
(70738, 3277827328, 3277827583, 'SI', 'SVN', 'سلوفينيا'),
(70739, 3277827584, 3277828095, 'NL', 'NLD', 'هولندا'),
(70740, 3277828096, 3277828351, 'AT', 'AUT', 'النمسا'),
(70741, 3277828352, 3277828607, 'NL', 'NLD', 'هولندا'),
(70742, 3277828608, 3277828863, 'RO', 'ROM', 'رومانيا'),
(70743, 3277828864, 3277829119, 'TR', 'TUR', 'تركيا'),
(70744, 3277829120, 3277829375, 'RO', 'ROM', 'رومانيا'),
(70745, 3277829376, 3277829631, 'DK', 'DNK', 'الدنيمارك'),
(70746, 3277829632, 3277829887, 'PL', 'POL', 'بولندا'),
(70747, 3277829888, 3277830143, 'IL', 'ISR', 'إسرائيل'),
(70748, 3277830144, 3277830399, 'SE', 'SWE', 'السويد'),
(70749, 3277830400, 3277830655, 'UA', 'UKR', 'أوكرانيا'),
(70750, 3277830656, 3277830911, 'PL', 'POL', 'بولندا'),
(70751, 3277830912, 3277831167, 'GB', 'GBR', 'المملكة المتحدة'),
(70752, 3277831168, 3277831423, 'PL', 'POL', 'بولندا'),
(70753, 3277831424, 3277831679, 'UA', 'UKR', 'أوكرانيا'),
(70754, 3277831680, 3277832191, 'IE', 'IRL', 'إيرلندا'),
(70755, 3277833216, 3277833727, 'BE', 'BEL', 'بلجيكا'),
(70756, 3277833728, 3277834239, 'NL', 'NLD', 'هولندا'),
(70757, 3277834240, 3277834751, 'RU', 'RUS', 'الإتحاد الروسي'),
(70758, 3277834752, 3277835263, 'UA', 'UKR', 'أوكرانيا'),
(70759, 3277835264, 3277835775, 'SK', 'SVK', 'سلوفاكيا'),
(70760, 3277835776, 3277836287, 'UA', 'UKR', 'أوكرانيا'),
(70761, 3277836288, 3277836799, 'FI', 'FIN', 'فنلندا'),
(70762, 3277836800, 3277837311, 'UA', 'UKR', 'أوكرانيا'),
(70763, 3277837312, 3277838847, 'RU', 'RUS', 'الإتحاد الروسي'),
(70764, 3277839360, 3277839871, 'DE', 'DEU', 'ألمانيا'),
(70765, 3277839872, 3277840383, 'UA', 'UKR', 'أوكرانيا'),
(70766, 3277840384, 3277840895, 'FR', 'FRA', 'فرنسا'),
(70767, 3277840896, 3277841407, 'GR', 'GRC', 'اليونان'),
(70768, 3277841408, 3277841919, 'RO', 'ROM', 'رومانيا'),
(70769, 3277842432, 3277842943, 'UA', 'UKR', 'أوكرانيا'),
(70770, 3277842944, 3277843455, 'PL', 'POL', 'بولندا'),
(70771, 3277843456, 3277843967, 'PT', 'PRT', 'البورتوغال'),
(70772, 3277843968, 3277845503, 'DK', 'DNK', 'الدنيمارك'),
(70773, 3277845504, 3277847039, 'NL', 'NLD', 'هولندا'),
(70774, 3277847040, 3277847551, 'DK', 'DNK', 'الدنيمارك'),
(70775, 3277847552, 3277848063, 'RU', 'RUS', 'الإتحاد الروسي'),
(70776, 3277848064, 3277848575, 'RO', 'ROM', 'رومانيا'),
(70777, 3277848576, 3277856767, 'AT', 'AUT', 'النمسا'),
(70778, 3277856768, 3277864959, 'DE', 'DEU', 'ألمانيا'),
(70779, 3277864960, 3277873151, 'RU', 'RUS', 'الإتحاد الروسي'),
(70780, 3277873152, 3277881343, 'NL', 'NLD', 'هولندا'),
(70781, 3277881344, 3277884175, 'IT', 'ITA', 'إيطاليا'),
(70782, 3277884176, 3277884191, 'IR', 'IRN', 'إيران'),
(70783, 3277884192, 3277886207, 'IT', 'ITA', 'إيطاليا'),
(70784, 3277886208, 3277886975, 'IR', 'IRN', 'إيران'),
(70785, 3277886976, 3277889535, 'IT', 'ITA', 'إيطاليا'),
(70786, 3277889536, 3277897727, 'RU', 'RUS', 'الإتحاد الروسي'),
(70787, 3277897728, 3277905919, 'IT', 'ITA', 'إيطاليا'),
(70788, 3277905920, 3277914111, 'BG', 'BGR', 'بلغاريا'),
(70789, 3277914112, 3277946879, 'GR', 'GRC', 'اليونان'),
(70790, 3277946880, 3277963263, 'DK', 'DNK', 'الدنيمارك'),
(70791, 3277963264, 3277979647, 'GB', 'GBR', 'المملكة المتحدة'),
(70792, 3277979648, 3277987839, 'SK', 'SVK', 'سلوفاكيا'),
(70793, 3277987840, 3278004223, 'RU', 'RUS', 'الإتحاد الروسي'),
(70794, 3278004224, 3278012415, 'FR', 'FRA', 'فرنسا'),
(70795, 3278012416, 3278020607, 'SK', 'SVK', 'سلوفاكيا'),
(70796, 3278020608, 3278028799, 'RU', 'RUS', 'الإتحاد الروسي'),
(70797, 3278028800, 3278036991, 'DE', 'DEU', 'ألمانيا'),
(70798, 3278036992, 3278045183, 'FR', 'FRA', 'فرنسا'),
(70799, 3278045184, 3278054911, 'GB', 'GBR', 'المملكة المتحدة'),
(70800, 3278054912, 3278055423, 'NL', 'NLD', 'هولندا'),
(70801, 3278055424, 3278061567, 'GB', 'GBR', 'المملكة المتحدة'),
(70802, 3278061568, 3278065663, 'NL', 'NLD', 'هولندا'),
(70803, 3278065664, 3278067967, 'GB', 'GBR', 'المملكة المتحدة'),
(70804, 3278067968, 3278068223, 'BE', 'BEL', 'بلجيكا'),
(70805, 3278068224, 3278103039, 'GB', 'GBR', 'المملكة المتحدة'),
(70806, 3278103040, 3278103295, 'FR', 'FRA', 'فرنسا'),
(70807, 3278103296, 3278110719, 'GB', 'GBR', 'المملكة المتحدة'),
(70808, 3278110720, 3278110751, 'SE', 'SWE', 'السويد'),
(70809, 3278110752, 3278110767, 'ES', 'ESP', 'إسبانيا'),
(70810, 3278110768, 3278111239, 'SE', 'SWE', 'السويد'),
(70811, 3278111240, 3278111247, 'ES', 'ESP', 'إسبانيا'),
(70812, 3278111248, 3278114815, 'SE', 'SWE', 'السويد'),
(70813, 3278114816, 3278115071, 'ES', 'ESP', 'إسبانيا'),
(70814, 3278115072, 3278115327, 'SE', 'SWE', 'السويد'),
(70815, 3278115328, 3278116607, 'ES', 'ESP', 'إسبانيا'),
(70816, 3278116608, 3278116735, 'SE', 'SWE', 'السويد'),
(70817, 3278116736, 3278118175, 'ES', 'ESP', 'إسبانيا'),
(70818, 3278118176, 3278119935, 'SE', 'SWE', 'السويد'),
(70819, 3278119936, 3278119943, 'DE', 'DEU', 'ألمانيا'),
(70820, 3278119944, 3278119967, 'SE', 'SWE', 'السويد'),
(70821, 3278119968, 3278119975, 'NO', 'NOR', 'النرويج'),
(70822, 3278119976, 3278120151, 'SE', 'SWE', 'السويد'),
(70823, 3278120152, 3278120159, 'DE', 'DEU', 'ألمانيا'),
(70824, 3278120160, 3278161631, 'SE', 'SWE', 'السويد'),
(70825, 3278161632, 3278161647, 'DE', 'DEU', 'ألمانيا'),
(70826, 3278161648, 3278168111, 'SE', 'SWE', 'السويد'),
(70827, 3278168112, 3278168119, 'DK', 'DNK', 'الدنيمارك'),
(70828, 3278168120, 3278168175, 'SE', 'SWE', 'السويد'),
(70829, 3278168176, 3278168191, 'DK', 'DNK', 'الدنيمارك'),
(70830, 3278168192, 3278176255, 'SE', 'SWE', 'السويد'),
(70831, 3278176256, 3278232511, 'FR', 'FRA', 'فرنسا'),
(70832, 3278232512, 3278232575, 'MC', 'MCO', 'موناكو'),
(70833, 3278232576, 3278241791, 'FR', 'FRA', 'فرنسا'),
(70834, 3278241792, 3278307327, 'GB', 'GBR', 'المملكة المتحدة'),
(70835, 3278307328, 3278372863, 'IT', 'ITA', 'إيطاليا'),
(70836, 3278372864, 3278635007, 'GB', 'GBR', 'المملكة المتحدة'),
(70837, 3278635008, 3278766079, 'NL', 'NLD', 'هولندا'),
(70838, 3278766080, 3278766591, 'RO', 'ROM', 'رومانيا'),
(70839, 3278766592, 3278767103, 'RU', 'RUS', 'الإتحاد الروسي'),
(70840, 3278767104, 3278767615, 'RO', 'ROM', 'رومانيا'),
(70841, 3278767616, 3278768127, 'UA', 'UKR', 'أوكرانيا'),
(70842, 3278768128, 3278769151, 'GB', 'GBR', 'المملكة المتحدة'),
(70843, 3278769152, 3278769663, 'FR', 'FRA', 'فرنسا'),
(70844, 3278769664, 3278770175, 'DE', 'DEU', 'ألمانيا'),
(70845, 3278770176, 3278770687, 'DK', 'DNK', 'الدنيمارك'),
(70846, 3278770688, 3278771199, 'DE', 'DEU', 'ألمانيا'),
(70847, 3278771200, 3278771711, 'GB', 'GBR', 'المملكة المتحدة'),
(70848, 3278771712, 3278772223, 'NL', 'NLD', 'هولندا'),
(70849, 3278772224, 3278772735, 'BG', 'BGR', 'بلغاريا'),
(70850, 3278772736, 3278773247, 'DE', 'DEU', 'ألمانيا'),
(70851, 3278773248, 3278773759, 'NO', 'NOR', 'النرويج'),
(70852, 3278773760, 3278774271, 'GB', 'GBR', 'المملكة المتحدة'),
(70853, 3278774272, 3278774783, 'RU', 'RUS', 'الإتحاد الروسي'),
(70854, 3278775296, 3278775807, 'GB', 'GBR', 'المملكة المتحدة'),
(70855, 3278775808, 3278776319, 'IR', 'IRN', 'إيران'),
(70856, 3278776320, 3278776831, 'IL', 'ISR', 'إسرائيل'),
(70857, 3278776832, 3278777343, 'ES', 'ESP', 'إسبانيا'),
(70858, 3278777344, 3278777855, 'SE', 'SWE', 'السويد'),
(70859, 3278777856, 3278778367, 'RU', 'RUS', 'الإتحاد الروسي'),
(70860, 3278778368, 3278779391, 'PL', 'POL', 'بولندا'),
(70861, 3278779392, 3278779903, 'RU', 'RUS', 'الإتحاد الروسي'),
(70862, 3278779904, 3278780415, 'BE', 'BEL', 'بلجيكا'),
(70863, 3278780416, 3278780927, 'UA', 'UKR', 'أوكرانيا'),
(70864, 3278780928, 3278781439, 'LT', 'LTU', 'ليتوانيا'),
(70865, 3278781440, 3278781951, 'DE', 'DEU', 'ألمانيا'),
(70866, 3278781952, 3278782463, 'RU', 'RUS', 'الإتحاد الروسي'),
(70867, 3278782464, 3278782975, 'GB', 'GBR', 'المملكة المتحدة'),
(70868, 3278782976, 3278783231, 'DE', 'DEU', 'ألمانيا'),
(70869, 3278783232, 3278790655, 'GB', 'GBR', 'المملكة المتحدة'),
(70870, 3278790656, 3278807039, 'IT', 'ITA', 'إيطاليا'),
(70871, 3278807040, 3278815231, 'GB', 'GBR', 'المملكة المتحدة'),
(70872, 3278815232, 3278823423, 'AT', 'AUT', 'النمسا'),
(70873, 3278823424, 3278831615, 'FR', 'FRA', 'فرنسا'),
(70874, 3278831616, 3278865663, 'HU', 'HUN', 'هنغاريا'),
(70875, 3278865664, 3278865919, 'SK', 'SVK', 'سلوفاكيا'),
(70876, 3278865920, 3278897151, 'HU', 'HUN', 'هنغاريا'),
(70877, 3278897152, 3278913535, 'GB', 'GBR', 'المملكة المتحدة'),
(70878, 3278913536, 3278921727, 'CH', 'CHE', 'سويسرا'),
(70879, 3278921728, 3278929919, 'RU', 'RUS', 'الإتحاد الروسي'),
(70880, 3278929920, 3278938111, 'TR', 'TUR', 'تركيا'),
(70881, 3278938112, 3278938119, 'DE', 'DEU', 'ألمانيا'),
(70882, 3278938120, 3278938123, 'DK', 'DNK', 'الدنيمارك'),
(70883, 3278938124, 3278938127, 'DE', 'DEU', 'ألمانيا'),
(70884, 3278938128, 3278938131, 'TR', 'TUR', 'تركيا'),
(70885, 3278938132, 3278938151, 'DE', 'DEU', 'ألمانيا'),
(70886, 3278938152, 3278938155, 'GB', 'GBR', 'المملكة المتحدة'),
(70887, 3278938156, 3278938159, 'DE', 'DEU', 'ألمانيا'),
(70888, 3278938160, 3278938163, 'ES', 'ESP', 'إسبانيا'),
(70889, 3278938164, 3278938167, 'CH', 'CHE', 'سويسرا'),
(70890, 3278938168, 3278938171, 'DE', 'DEU', 'ألمانيا'),
(70891, 3278938172, 3278938175, 'NL', 'NLD', 'هولندا'),
(70892, 3278938176, 3278938179, 'FR', 'FRA', 'فرنسا'),
(70893, 3278938180, 3278938183, 'NL', 'NLD', 'هولندا'),
(70894, 3278938184, 3278938187, 'DE', 'DEU', 'ألمانيا'),
(70895, 3278938188, 3278938191, 'PT', 'PRT', 'البورتوغال'),
(70896, 3278938192, 3278938195, 'ES', 'ESP', 'إسبانيا'),
(70897, 3278938196, 3278938199, 'NL', 'NLD', 'هولندا'),
(70898, 3278938200, 3278938203, 'CH', 'CHE', 'سويسرا'),
(70899, 3278938204, 3278938207, 'DE', 'DEU', 'ألمانيا'),
(70900, 3278938208, 3278938219, 'IT', 'ITA', 'إيطاليا'),
(70901, 3278938220, 3278938223, 'FR', 'FRA', 'فرنسا'),
(70902, 3278938224, 3278938227, 'DE', 'DEU', 'ألمانيا'),
(70903, 3278938228, 3278938231, 'FR', 'FRA', 'فرنسا'),
(70904, 3278938232, 3278938235, 'DE', 'DEU', 'ألمانيا'),
(70905, 3278938236, 3278938239, 'FR', 'FRA', 'فرنسا'),
(70906, 3278938240, 3278938243, 'LI', 'LIE', 'ليختنشتاين'),
(70907, 3278938244, 3278938247, 'IT', 'ITA', 'إيطاليا'),
(70908, 3278938248, 3278938251, 'AT', 'AUT', 'النمسا'),
(70909, 3278938252, 3278938255, 'GR', 'GRC', 'اليونان'),
(70910, 3278938256, 3278938263, 'CH', 'CHE', 'سويسرا'),
(70911, 3278938264, 3278938267, 'PL', 'POL', 'بولندا'),
(70912, 3278938268, 3278938275, 'FR', 'FRA', 'فرنسا'),
(70913, 3278938276, 3278938279, 'NL', 'NLD', 'هولندا'),
(70914, 3278938280, 3278938283, 'AT', 'AUT', 'النمسا'),
(70915, 3278938284, 3278938287, 'FR', 'FRA', 'فرنسا'),
(70916, 3278938288, 3278938291, 'ES', 'ESP', 'إسبانيا'),
(70917, 3278938292, 3278938299, 'DE', 'DEU', 'ألمانيا'),
(70918, 3278938300, 3278938303, 'ES', 'ESP', 'إسبانيا'),
(70919, 3278938304, 3278938307, 'DE', 'DEU', 'ألمانيا'),
(70920, 3278938308, 3278938311, 'GB', 'GBR', 'المملكة المتحدة'),
(70921, 3278938312, 3278938315, 'DE', 'DEU', 'ألمانيا'),
(70922, 3278938316, 3278938323, 'FR', 'FRA', 'فرنسا'),
(70923, 3278938324, 3278938335, 'DE', 'DEU', 'ألمانيا'),
(70924, 3278938336, 3278938339, 'CH', 'CHE', 'سويسرا'),
(70925, 3278938340, 3278938343, 'DE', 'DEU', 'ألمانيا'),
(70926, 3278938344, 3278938347, 'NL', 'NLD', 'هولندا'),
(70927, 3278938348, 3278938351, 'FR', 'FRA', 'فرنسا'),
(70928, 3278938352, 3278938355, 'DE', 'DEU', 'ألمانيا'),
(70929, 3278938356, 3278938359, 'ES', 'ESP', 'إسبانيا'),
(70930, 3278938360, 3278938363, 'DK', 'DNK', 'الدنيمارك'),
(70931, 3278938364, 3278938367, 'BH', 'BHR', 'البحرين'),
(70932, 3278938368, 3278938375, 'FR', 'FRA', 'فرنسا'),
(70933, 3278938376, 3278938379, 'DE', 'DEU', 'ألمانيا'),
(70934, 3278938380, 3278938383, 'FR', 'FRA', 'فرنسا'),
(70935, 3278938384, 3278938387, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(70936, 3278938388, 3278938399, 'DE', 'DEU', 'ألمانيا'),
(70937, 3278938400, 3278938403, 'AT', 'AUT', 'النمسا'),
(70938, 3278938404, 3278938407, 'GB', 'GBR', 'المملكة المتحدة'),
(70939, 3278938408, 3278938411, 'CH', 'CHE', 'سويسرا'),
(70940, 3278938412, 3278938415, 'DE', 'DEU', 'ألمانيا'),
(70941, 3278938416, 3278938419, 'CH', 'CHE', 'سويسرا'),
(70942, 3278938420, 3278938423, 'GB', 'GBR', 'المملكة المتحدة'),
(70943, 3278938424, 3278938427, 'DE', 'DEU', 'ألمانيا'),
(70944, 3278938428, 3278938431, 'FR', 'FRA', 'فرنسا'),
(70945, 3278938432, 3278938435, 'SI', 'SVN', 'سلوفينيا'),
(70946, 3278938436, 3278938439, 'DE', 'DEU', 'ألمانيا'),
(70947, 3278938440, 3278938443, 'IT', 'ITA', 'إيطاليا'),
(70948, 3278938444, 3278938447, 'DE', 'DEU', 'ألمانيا'),
(70949, 3278938448, 3278938451, 'IT', 'ITA', 'إيطاليا'),
(70950, 3278938452, 3278938455, 'GB', 'GBR', 'المملكة المتحدة'),
(70951, 3278938456, 3278938459, 'ES', 'ESP', 'إسبانيا'),
(70952, 3278938460, 3278938463, 'FR', 'FRA', 'فرنسا'),
(70953, 3278938464, 3278938467, 'DE', 'DEU', 'ألمانيا'),
(70954, 3278938468, 3278938471, 'NL', 'NLD', 'هولندا'),
(70955, 3278938472, 3278938479, 'DE', 'DEU', 'ألمانيا'),
(70956, 3278938480, 3278938483, 'CH', 'CHE', 'سويسرا'),
(70957, 3278938484, 3278938487, 'DE', 'DEU', 'ألمانيا'),
(70958, 3278938488, 3278938491, 'NL', 'NLD', 'هولندا'),
(70959, 3278938492, 3278938495, 'ES', 'ESP', 'إسبانيا'),
(70960, 3278938496, 3278938499, 'NL', 'NLD', 'هولندا'),
(70961, 3278938500, 3278938503, 'DE', 'DEU', 'ألمانيا'),
(70962, 3278938504, 3278938507, 'SE', 'SWE', 'السويد'),
(70963, 3278938508, 3278938511, 'IT', 'ITA', 'إيطاليا'),
(70964, 3278938512, 3278938515, 'DE', 'DEU', 'ألمانيا'),
(70965, 3278938516, 3278938523, 'NL', 'NLD', 'هولندا'),
(70966, 3278938524, 3278938527, 'FR', 'FRA', 'فرنسا'),
(70967, 3278938528, 3278938531, 'NO', 'NOR', 'النرويج'),
(70968, 3278938532, 3278938535, 'DK', 'DNK', 'الدنيمارك'),
(70969, 3278938536, 3278938555, 'DE', 'DEU', 'ألمانيا'),
(70970, 3278938556, 3278938559, 'HU', 'HUN', 'هنغاريا'),
(70971, 3278938560, 3278938563, 'CY', 'CYP', 'قبرص'),
(70972, 3278938564, 3278938567, 'FR', 'FRA', 'فرنسا'),
(70973, 3278938568, 3278938575, 'DE', 'DEU', 'ألمانيا'),
(70974, 3278938576, 3278938579, 'CZ', 'CZE', 'التشيك'),
(70975, 3278938580, 3278938583, 'DE', 'DEU', 'ألمانيا'),
(70976, 3278938584, 3278938587, 'GB', 'GBR', 'المملكة المتحدة'),
(70977, 3278938588, 3278938591, 'CH', 'CHE', 'سويسرا'),
(70978, 3278938592, 3278938595, 'DE', 'DEU', 'ألمانيا'),
(70979, 3278938596, 3278938599, 'DK', 'DNK', 'الدنيمارك'),
(70980, 3278938600, 3278938603, 'DE', 'DEU', 'ألمانيا'),
(70981, 3278938604, 3278938607, 'IT', 'ITA', 'إيطاليا'),
(70982, 3278938608, 3278938611, 'AT', 'AUT', 'النمسا'),
(70983, 3278938612, 3278938615, 'NL', 'NLD', 'هولندا'),
(70984, 3278938616, 3278938619, 'DK', 'DNK', 'الدنيمارك'),
(70985, 3278938620, 3278938627, 'FR', 'FRA', 'فرنسا'),
(70986, 3278938628, 3278938631, 'DE', 'DEU', 'ألمانيا'),
(70987, 3278938632, 3278938635, 'NL', 'NLD', 'هولندا'),
(70988, 3278938636, 3278938639, 'GB', 'GBR', 'المملكة المتحدة'),
(70989, 3278938640, 3278938643, 'DE', 'DEU', 'ألمانيا'),
(70990, 3278938644, 3278938647, 'GB', 'GBR', 'المملكة المتحدة'),
(70991, 3278938648, 3278938659, 'DE', 'DEU', 'ألمانيا'),
(70992, 3278938660, 3278938663, 'CH', 'CHE', 'سويسرا'),
(70993, 3278938664, 3278938667, 'GB', 'GBR', 'المملكة المتحدة'),
(70994, 3278938668, 3278938671, 'AT', 'AUT', 'النمسا'),
(70995, 3278938672, 3278938675, 'IT', 'ITA', 'إيطاليا'),
(70996, 3278938676, 3278938679, 'FR', 'FRA', 'فرنسا'),
(70997, 3278938680, 3278938683, 'NO', 'NOR', 'النرويج'),
(70998, 3278938684, 3278938687, 'DE', 'DEU', 'ألمانيا'),
(70999, 3278938688, 3278938691, 'CH', 'CHE', 'سويسرا'),
(71000, 3278938692, 3278938695, 'DE', 'DEU', 'ألمانيا'),
(71001, 3278938696, 3278938699, 'IT', 'ITA', 'إيطاليا'),
(71002, 3278938700, 3278938703, 'ES', 'ESP', 'إسبانيا'),
(71003, 3278938704, 3278938707, 'FR', 'FRA', 'فرنسا'),
(71004, 3278938708, 3278938715, 'DE', 'DEU', 'ألمانيا'),
(71005, 3278938716, 3278938719, 'CH', 'CHE', 'سويسرا'),
(71006, 3278938720, 3278938723, 'NL', 'NLD', 'هولندا'),
(71007, 3278938724, 3278938727, 'BE', 'BEL', 'بلجيكا'),
(71008, 3278938728, 3278938731, 'ES', 'ESP', 'إسبانيا'),
(71009, 3278938732, 3278938735, 'CH', 'CHE', 'سويسرا'),
(71010, 3278938736, 3278938739, 'IT', 'ITA', 'إيطاليا'),
(71011, 3278938740, 3278938743, 'FR', 'FRA', 'فرنسا'),
(71012, 3278938744, 3278938751, 'DE', 'DEU', 'ألمانيا'),
(71013, 3278938752, 3278938755, 'CH', 'CHE', 'سويسرا'),
(71014, 3278938756, 3278938759, 'DE', 'DEU', 'ألمانيا'),
(71015, 3278938760, 3278938763, 'GB', 'GBR', 'المملكة المتحدة'),
(71016, 3278938764, 3278938767, 'FR', 'FRA', 'فرنسا'),
(71017, 3278938768, 3278938771, 'GB', 'GBR', 'المملكة المتحدة'),
(71018, 3278938772, 3278938775, 'SE', 'SWE', 'السويد'),
(71019, 3278938776, 3278938779, 'GB', 'GBR', 'المملكة المتحدة'),
(71020, 3278938780, 3278938783, 'IT', 'ITA', 'إيطاليا'),
(71021, 3278938784, 3278938787, 'BE', 'BEL', 'بلجيكا'),
(71022, 3278938788, 3278938791, 'ES', 'ESP', 'إسبانيا'),
(71023, 3278938792, 3278938795, 'DE', 'DEU', 'ألمانيا'),
(71024, 3278938796, 3278938799, 'GR', 'GRC', 'اليونان'),
(71025, 3278938800, 3278938803, 'DE', 'DEU', 'ألمانيا'),
(71026, 3278938804, 3278938807, 'IT', 'ITA', 'إيطاليا'),
(71027, 3278938808, 3278938815, 'GB', 'GBR', 'المملكة المتحدة'),
(71028, 3278938816, 3278938819, 'ES', 'ESP', 'إسبانيا'),
(71029, 3278938820, 3278938827, 'DE', 'DEU', 'ألمانيا'),
(71030, 3278938828, 3278938831, 'GB', 'GBR', 'المملكة المتحدة'),
(71031, 3278938832, 3278938835, 'IT', 'ITA', 'إيطاليا'),
(71032, 3278938836, 3278938839, 'FR', 'FRA', 'فرنسا'),
(71033, 3278938840, 3278938843, 'DE', 'DEU', 'ألمانيا'),
(71034, 3278938844, 3278938847, 'HU', 'HUN', 'هنغاريا'),
(71035, 3278938848, 3278938851, 'CH', 'CHE', 'سويسرا'),
(71036, 3278938852, 3278938855, 'DE', 'DEU', 'ألمانيا'),
(71037, 3278938856, 3278938859, 'PT', 'PRT', 'البورتوغال'),
(71038, 3278938860, 3278938863, 'DE', 'DEU', 'ألمانيا'),
(71039, 3278938864, 3278938871, 'IT', 'ITA', 'إيطاليا'),
(71040, 3278938872, 3278938875, 'DE', 'DEU', 'ألمانيا'),
(71041, 3278938876, 3278938879, 'NL', 'NLD', 'هولندا'),
(71042, 3278938880, 3278938887, 'FR', 'FRA', 'فرنسا'),
(71043, 3278938888, 3278938891, 'ES', 'ESP', 'إسبانيا'),
(71044, 3278938892, 3278938895, 'DE', 'DEU', 'ألمانيا'),
(71045, 3278938896, 3278938903, 'FR', 'FRA', 'فرنسا'),
(71046, 3278938904, 3278938911, 'GB', 'GBR', 'المملكة المتحدة'),
(71047, 3278938912, 3278938919, 'DE', 'DEU', 'ألمانيا'),
(71048, 3278938920, 3278938923, 'SK', 'SVK', 'سلوفاكيا'),
(71049, 3278938924, 3278938927, 'DE', 'DEU', 'ألمانيا'),
(71050, 3278938928, 3278938935, 'GB', 'GBR', 'المملكة المتحدة'),
(71051, 3278938936, 3278938939, 'CH', 'CHE', 'سويسرا'),
(71052, 3278938940, 3278938943, 'GR', 'GRC', 'اليونان'),
(71053, 3278938944, 3278938947, 'IT', 'ITA', 'إيطاليا'),
(71054, 3278938948, 3278938951, 'DE', 'DEU', 'ألمانيا'),
(71055, 3278938952, 3278938955, 'FR', 'FRA', 'فرنسا'),
(71056, 3278938956, 3278938959, 'GB', 'GBR', 'المملكة المتحدة'),
(71057, 3278938960, 3278938967, 'DE', 'DEU', 'ألمانيا'),
(71058, 3278938968, 3278938971, 'BE', 'BEL', 'بلجيكا'),
(71059, 3278938972, 3278938975, 'DE', 'DEU', 'ألمانيا'),
(71060, 3278938976, 3278938979, 'NL', 'NLD', 'هولندا'),
(71061, 3278938980, 3278938987, 'FR', 'FRA', 'فرنسا'),
(71062, 3278938988, 3278938991, 'AT', 'AUT', 'النمسا'),
(71063, 3278938992, 3278938995, 'FR', 'FRA', 'فرنسا'),
(71064, 3278938996, 3278938999, 'DE', 'DEU', 'ألمانيا'),
(71065, 3278939000, 3278939003, 'ES', 'ESP', 'إسبانيا'),
(71066, 3278939004, 3278939007, 'NL', 'NLD', 'هولندا'),
(71067, 3278939008, 3278939011, 'IE', 'IRL', 'إيرلندا'),
(71068, 3278939012, 3278939015, 'RU', 'RUS', 'الإتحاد الروسي'),
(71069, 3278939016, 3278939019, 'ES', 'ESP', 'إسبانيا'),
(71070, 3278939020, 3278939023, 'NL', 'NLD', 'هولندا'),
(71071, 3278939024, 3278939027, 'IT', 'ITA', 'إيطاليا'),
(71072, 3278939028, 3278939031, 'CY', 'CYP', 'قبرص'),
(71073, 3278939032, 3278939035, 'DE', 'DEU', 'ألمانيا'),
(71074, 3278939036, 3278939039, 'HU', 'HUN', 'هنغاريا'),
(71075, 3278939040, 3278939047, 'DE', 'DEU', 'ألمانيا'),
(71076, 3278939048, 3278939055, 'FR', 'FRA', 'فرنسا'),
(71077, 3278939056, 3278939063, 'DE', 'DEU', 'ألمانيا'),
(71078, 3278939064, 3278939067, 'ES', 'ESP', 'إسبانيا'),
(71079, 3278939068, 3278939071, 'IT', 'ITA', 'إيطاليا'),
(71080, 3278939072, 3278939075, 'DE', 'DEU', 'ألمانيا'),
(71081, 3278939076, 3278939079, 'CH', 'CHE', 'سويسرا'),
(71082, 3278939080, 3278939083, 'DE', 'DEU', 'ألمانيا'),
(71083, 3278939084, 3278939087, 'IT', 'ITA', 'إيطاليا'),
(71084, 3278939088, 3278939091, 'IS', 'ISL', 'أيسلندا'),
(71085, 3278939092, 3278939095, 'DE', 'DEU', 'ألمانيا'),
(71086, 3278939096, 3278939099, 'IT', 'ITA', 'إيطاليا'),
(71087, 3278939100, 3278939103, 'DE', 'DEU', 'ألمانيا'),
(71088, 3278939104, 3278939107, 'CH', 'CHE', 'سويسرا'),
(71089, 3278939108, 3278939111, 'FR', 'FRA', 'فرنسا'),
(71090, 3278939112, 3278939115, 'DE', 'DEU', 'ألمانيا'),
(71091, 3278939116, 3278939119, 'NL', 'NLD', 'هولندا'),
(71092, 3278939120, 3278939131, 'DE', 'DEU', 'ألمانيا'),
(71093, 3278939132, 3278939135, 'NL', 'NLD', 'هولندا'),
(71094, 3278939136, 3278939147, 'US', 'USA', 'الولايات المتحدة'),
(71095, 3278939148, 3278939151, 'AR', 'ARG', 'الأرجنتين'),
(71096, 3278939152, 3278939155, 'ES', 'ESP', 'إسبانيا'),
(71097, 3278939156, 3278939195, 'US', 'USA', 'الولايات المتحدة'),
(71098, 3278939196, 3278939199, 'CL', 'CHL', 'تشيلي'),
(71099, 3278939200, 3278939259, 'US', 'USA', 'الولايات المتحدة'),
(71100, 3278939260, 3278939263, 'BR', 'BRA', 'البرازيل'),
(71101, 3278939264, 3278939271, 'AR', 'ARG', 'الأرجنتين'),
(71102, 3278939272, 3278939279, 'US', 'USA', 'الولايات المتحدة'),
(71103, 3278939280, 3278939283, 'CO', 'COL', 'كولومبيا'),
(71104, 3278939284, 3278939291, 'US', 'USA', 'الولايات المتحدة'),
(71105, 3278939292, 3278939295, 'AR', 'ARG', 'الأرجنتين'),
(71106, 3278939296, 3278939307, 'US', 'USA', 'الولايات المتحدة'),
(71107, 3278939308, 3278939311, 'MX', 'MEX', 'المكسيك'),
(71108, 3278939312, 3278939315, 'US', 'USA', 'الولايات المتحدة'),
(71109, 3278939316, 3278939319, 'AR', 'ARG', 'الأرجنتين'),
(71110, 3278939320, 3278939323, 'US', 'USA', 'الولايات المتحدة'),
(71111, 3278939324, 3278939327, 'CA', 'CAN', 'كندا'),
(71112, 3278939328, 3278939331, 'US', 'USA', 'الولايات المتحدة'),
(71113, 3278939332, 3278939335, 'BR', 'BRA', 'البرازيل'),
(71114, 3278939336, 3278939339, 'CA', 'CAN', 'كندا'),
(71115, 3278939340, 3278939351, 'US', 'USA', 'الولايات المتحدة'),
(71116, 3278939352, 3278939355, 'BR', 'BRA', 'البرازيل'),
(71117, 3278939356, 3278939379, 'US', 'USA', 'الولايات المتحدة'),
(71118, 3278939380, 3278939383, 'BR', 'BRA', 'البرازيل'),
(71119, 3278939384, 3278939391, 'US', 'USA', 'الولايات المتحدة'),
(71120, 3278939392, 3278939395, 'DE', 'DEU', 'ألمانيا'),
(71121, 3278939396, 3278939399, 'GB', 'GBR', 'المملكة المتحدة'),
(71122, 3278939400, 3278939403, 'DE', 'DEU', 'ألمانيا'),
(71123, 3278939404, 3278939407, 'CH', 'CHE', 'سويسرا'),
(71124, 3278939408, 3278939415, 'DE', 'DEU', 'ألمانيا'),
(71125, 3278939416, 3278939419, 'ZW', 'ZWE', 'زمبابواي'),
(71126, 3278939420, 3278939423, 'IE', 'IRL', 'إيرلندا'),
(71127, 3278939424, 3278939427, 'GB', 'GBR', 'المملكة المتحدة'),
(71128, 3278939428, 3278939439, 'DE', 'DEU', 'ألمانيا'),
(71129, 3278939440, 3278939443, 'IT', 'ITA', 'إيطاليا'),
(71130, 3278939444, 3278939447, 'DE', 'DEU', 'ألمانيا'),
(71131, 3278939448, 3278939451, 'PL', 'POL', 'بولندا'),
(71132, 3278939452, 3278939459, 'DE', 'DEU', 'ألمانيا'),
(71133, 3278939460, 3278939463, 'DK', 'DNK', 'الدنيمارك'),
(71134, 3278939464, 3278939467, 'CY', 'CYP', 'قبرص'),
(71135, 3278939468, 3278939471, 'DE', 'DEU', 'ألمانيا'),
(71136, 3278939472, 3278939475, 'PL', 'POL', 'بولندا'),
(71137, 3278939476, 3278939479, 'BE', 'BEL', 'بلجيكا'),
(71138, 3278939480, 3278939483, 'IT', 'ITA', 'إيطاليا'),
(71139, 3278939484, 3278939491, 'NL', 'NLD', 'هولندا'),
(71140, 3278939492, 3278939495, 'DE', 'DEU', 'ألمانيا'),
(71141, 3278939496, 3278939499, 'CH', 'CHE', 'سويسرا'),
(71142, 3278939500, 3278939503, 'ES', 'ESP', 'إسبانيا'),
(71143, 3278939504, 3278939511, 'DE', 'DEU', 'ألمانيا'),
(71144, 3278939512, 3278939515, 'LU', 'LUX', 'لوكسيمبورغ'),
(71145, 3278939516, 3278939523, 'NL', 'NLD', 'هولندا'),
(71146, 3278939524, 3278939527, 'LU', 'LUX', 'لوكسيمبورغ'),
(71147, 3278939528, 3278939531, 'FR', 'FRA', 'فرنسا'),
(71148, 3278939532, 3278939535, 'DE', 'DEU', 'ألمانيا'),
(71149, 3278939536, 3278939539, 'BE', 'BEL', 'بلجيكا'),
(71150, 3278939540, 3278939555, 'DE', 'DEU', 'ألمانيا'),
(71151, 3278939556, 3278939559, 'IT', 'ITA', 'إيطاليا'),
(71152, 3278939560, 3278939563, 'DE', 'DEU', 'ألمانيا'),
(71153, 3278939564, 3278939567, 'FR', 'FRA', 'فرنسا'),
(71154, 3278939568, 3278939571, 'PT', 'PRT', 'البورتوغال'),
(71155, 3278939572, 3278939575, 'ES', 'ESP', 'إسبانيا'),
(71156, 3278939576, 3278939579, 'DE', 'DEU', 'ألمانيا'),
(71157, 3278939580, 3278939583, 'NL', 'NLD', 'هولندا'),
(71158, 3278939584, 3278939587, 'IT', 'ITA', 'إيطاليا'),
(71159, 3278939588, 3278939591, 'LU', 'LUX', 'لوكسيمبورغ'),
(71160, 3278939592, 3278939595, 'AO', 'AGO', 'أنغولا'),
(71161, 3278939596, 3278939599, 'NL', 'NLD', 'هولندا'),
(71162, 3278939600, 3278939603, 'GB', 'GBR', 'المملكة المتحدة'),
(71163, 3278939604, 3278939607, 'DE', 'DEU', 'ألمانيا'),
(71164, 3278939608, 3278939611, 'DK', 'DNK', 'الدنيمارك'),
(71165, 3278939612, 3278939615, 'FR', 'FRA', 'فرنسا'),
(71166, 3278939616, 3278939631, 'DE', 'DEU', 'ألمانيا'),
(71167, 3278939632, 3278939635, 'GB', 'GBR', 'المملكة المتحدة'),
(71168, 3278939636, 3278939639, 'DK', 'DNK', 'الدنيمارك'),
(71169, 3278939640, 3278939643, 'DE', 'DEU', 'ألمانيا'),
(71170, 3278939644, 3278939647, 'UA', 'UKR', 'أوكرانيا'),
(71171, 3278939648, 3278939651, 'FR', 'FRA', 'فرنسا'),
(71172, 3278939652, 3278939655, 'DE', 'DEU', 'ألمانيا'),
(71173, 3278939656, 3278939659, 'FR', 'FRA', 'فرنسا'),
(71174, 3278939660, 3278939663, 'TR', 'TUR', 'تركيا'),
(71175, 3278939664, 3278939667, 'IT', 'ITA', 'إيطاليا'),
(71176, 3278939668, 3278939671, 'GB', 'GBR', 'المملكة المتحدة'),
(71177, 3278939672, 3278939679, 'FR', 'FRA', 'فرنسا'),
(71178, 3278939680, 3278939683, 'GR', 'GRC', 'اليونان'),
(71179, 3278939684, 3278939687, 'FR', 'FRA', 'فرنسا'),
(71180, 3278939688, 3278939691, 'DE', 'DEU', 'ألمانيا'),
(71181, 3278939692, 3278939695, 'FR', 'FRA', 'فرنسا'),
(71182, 3278939696, 3278939699, 'GR', 'GRC', 'اليونان'),
(71183, 3278939700, 3278939703, 'TR', 'TUR', 'تركيا'),
(71184, 3278939704, 3278939707, 'KE', 'KEN', 'كينيا'),
(71185, 3278939708, 3278939711, 'TR', 'TUR', 'تركيا'),
(71186, 3278939712, 3278939715, 'CY', 'CYP', 'قبرص'),
(71187, 3278939716, 3278939723, 'TR', 'TUR', 'تركيا'),
(71188, 3278939724, 3278939727, 'MC', 'MCO', 'موناكو'),
(71189, 3278939728, 3278939731, 'TR', 'TUR', 'تركيا'),
(71190, 3278939732, 3278939735, 'AT', 'AUT', 'النمسا'),
(71191, 3278939736, 3278939739, 'RU', 'RUS', 'الإتحاد الروسي'),
(71192, 3278939740, 3278939743, 'HU', 'HUN', 'هنغاريا'),
(71193, 3278939744, 3278939747, 'GB', 'GBR', 'المملكة المتحدة'),
(71194, 3278939748, 3278939751, 'ES', 'ESP', 'إسبانيا'),
(71195, 3278939752, 3278939755, 'GR', 'GRC', 'اليونان'),
(71196, 3278939756, 3278939759, 'AO', 'AGO', 'أنغولا'),
(71197, 3278939760, 3278939763, 'FR', 'FRA', 'فرنسا'),
(71198, 3278939764, 3278939767, 'GR', 'GRC', 'اليونان'),
(71199, 3278939768, 3278939771, 'ES', 'ESP', 'إسبانيا'),
(71200, 3278939772, 3278939775, 'IT', 'ITA', 'إيطاليا'),
(71201, 3278939776, 3278939779, 'GR', 'GRC', 'اليونان'),
(71202, 3278939780, 3278939783, 'FR', 'FRA', 'فرنسا'),
(71203, 3278939784, 3278939787, 'BE', 'BEL', 'بلجيكا'),
(71204, 3278939788, 3278939791, 'DE', 'DEU', 'ألمانيا'),
(71205, 3278939792, 3278939803, 'ES', 'ESP', 'إسبانيا'),
(71206, 3278939804, 3278939807, 'GB', 'GBR', 'المملكة المتحدة'),
(71207, 3278939808, 3278939815, 'DE', 'DEU', 'ألمانيا'),
(71208, 3278939816, 3278939819, 'NL', 'NLD', 'هولندا'),
(71209, 3278939820, 3278939823, 'DE', 'DEU', 'ألمانيا'),
(71210, 3278939824, 3278939827, 'HU', 'HUN', 'هنغاريا'),
(71211, 3278939828, 3278939835, 'DE', 'DEU', 'ألمانيا'),
(71212, 3278939836, 3278939839, 'FR', 'FRA', 'فرنسا'),
(71213, 3278939840, 3278939843, 'IT', 'ITA', 'إيطاليا'),
(71214, 3278939844, 3278939847, 'BE', 'BEL', 'بلجيكا'),
(71215, 3278939848, 3278939851, 'CH', 'CHE', 'سويسرا'),
(71216, 3278939852, 3278939855, 'DE', 'DEU', 'ألمانيا'),
(71217, 3278939856, 3278939859, 'FR', 'FRA', 'فرنسا'),
(71218, 3278939860, 3278939863, 'GB', 'GBR', 'المملكة المتحدة'),
(71219, 3278939864, 3278939867, 'IT', 'ITA', 'إيطاليا'),
(71220, 3278939868, 3278939871, 'CH', 'CHE', 'سويسرا'),
(71221, 3278939872, 3278939875, 'ES', 'ESP', 'إسبانيا'),
(71222, 3278939876, 3278939879, 'IT', 'ITA', 'إيطاليا'),
(71223, 3278939880, 3278939883, 'ES', 'ESP', 'إسبانيا'),
(71224, 3278939884, 3278939887, 'DE', 'DEU', 'ألمانيا'),
(71225, 3278939888, 3278939891, 'PL', 'POL', 'بولندا'),
(71226, 3278939892, 3278939899, 'ES', 'ESP', 'إسبانيا'),
(71227, 3278939900, 3278939903, 'IT', 'ITA', 'إيطاليا'),
(71228, 3278939904, 3278939907, 'HK', 'HKG', 'هونغ كونغ'),
(71229, 3278939908, 3278939911, 'MY', 'MYS', 'ماليزيا'),
(71230, 3278939912, 3278939915, 'TH', 'THA', 'تايلند'),
(71231, 3278939916, 3278939923, 'SG', 'SGP', 'سنغافورة'),
(71232, 3278939924, 3278939927, 'CN', 'CHN', 'الصين'),
(71233, 3278939928, 3278939931, 'SG', 'SGP', 'سنغافورة'),
(71234, 3278939932, 3278939935, 'IN', 'IND', 'الهند'),
(71235, 3278939936, 3278939939, 'MY', 'MYS', 'ماليزيا'),
(71236, 3278939940, 3278939943, 'SG', 'SGP', 'سنغافورة'),
(71237, 3278939944, 3278939947, 'TW', 'TWN', 'تايوان'),
(71238, 3278939948, 3278939951, 'SG', 'SGP', 'سنغافورة'),
(71239, 3278939952, 3278939955, 'MY', 'MYS', 'ماليزيا'),
(71240, 3278939956, 3278939959, 'SG', 'SGP', 'سنغافورة'),
(71241, 3278939960, 3278939963, 'CN', 'CHN', 'الصين'),
(71242, 3278939964, 3278939967, 'MY', 'MYS', 'ماليزيا'),
(71243, 3278939968, 3278939971, 'TW', 'TWN', 'تايوان'),
(71244, 3278939972, 3278939979, 'MY', 'MYS', 'ماليزيا'),
(71245, 3278939980, 3278939983, 'TH', 'THA', 'تايلند'),
(71246, 3278939984, 3278939987, 'DE', 'DEU', 'ألمانيا'),
(71247, 3278939988, 3278939991, 'CN', 'CHN', 'الصين'),
(71248, 3278939992, 3278939995, 'SG', 'SGP', 'سنغافورة'),
(71249, 3278939996, 3278939999, 'MY', 'MYS', 'ماليزيا'),
(71250, 3278940000, 3278940011, 'SG', 'SGP', 'سنغافورة'),
(71251, 3278940012, 3278940015, 'ID', 'IDN', 'إندونيسيا'),
(71252, 3278940016, 3278940059, 'SG', 'SGP', 'سنغافورة'),
(71253, 3278940060, 3278940067, 'CN', 'CHN', 'الصين'),
(71254, 3278940068, 3278940071, 'TW', 'TWN', 'تايوان'),
(71255, 3278940072, 3278940083, 'SG', 'SGP', 'سنغافورة'),
(71256, 3278940084, 3278940091, 'MY', 'MYS', 'ماليزيا'),
(71257, 3278940092, 3278940095, 'SG', 'SGP', 'سنغافورة'),
(71258, 3278940096, 3278940099, 'IN', 'IND', 'الهند'),
(71259, 3278940100, 3278940103, 'SG', 'SGP', 'سنغافورة'),
(71260, 3278940104, 3278940107, 'MY', 'MYS', 'ماليزيا'),
(71261, 3278940108, 3278940127, 'SG', 'SGP', 'سنغافورة'),
(71262, 3278940128, 3278940131, 'TW', 'TWN', 'تايوان'),
(71263, 3278940132, 3278940135, 'BD', 'BGD', 'بنغالاديش'),
(71264, 3278940136, 3278940139, 'SG', 'SGP', 'سنغافورة'),
(71265, 3278940140, 3278940143, 'IN', 'IND', 'الهند'),
(71266, 3278940144, 3278940151, 'MY', 'MYS', 'ماليزيا'),
(71267, 3278940152, 3278940155, 'IN', 'IND', 'الهند'),
(71268, 3278940156, 3278940159, 'PH', 'PHL', 'الفلبين'),
(71269, 3278940160, 3278940163, 'GR', 'GRC', 'اليونان'),
(71270, 3278940164, 3278940167, 'CH', 'CHE', 'سويسرا'),
(71271, 3278940168, 3278940171, 'DK', 'DNK', 'الدنيمارك'),
(71272, 3278940172, 3278940175, 'FR', 'FRA', 'فرنسا'),
(71273, 3278940176, 3278940179, 'GB', 'GBR', 'المملكة المتحدة'),
(71274, 3278940180, 3278940183, 'CH', 'CHE', 'سويسرا'),
(71275, 3278940184, 3278940187, 'DE', 'DEU', 'ألمانيا'),
(71276, 3278940188, 3278940195, 'GB', 'GBR', 'المملكة المتحدة'),
(71277, 3278940196, 3278940211, 'DE', 'DEU', 'ألمانيا'),
(71278, 3278940212, 3278940215, 'PT', 'PRT', 'البورتوغال'),
(71279, 3278940216, 3278940219, 'NL', 'NLD', 'هولندا'),
(71280, 3278940220, 3278940223, 'GB', 'GBR', 'المملكة المتحدة'),
(71281, 3278940224, 3278940227, 'CH', 'CHE', 'سويسرا'),
(71282, 3278940228, 3278940231, 'DE', 'DEU', 'ألمانيا'),
(71283, 3278940232, 3278940235, 'CH', 'CHE', 'سويسرا'),
(71284, 3278940236, 3278940239, 'ES', 'ESP', 'إسبانيا'),
(71285, 3278940240, 3278940243, 'CY', 'CYP', 'قبرص'),
(71286, 3278940244, 3278940247, 'DE', 'DEU', 'ألمانيا'),
(71287, 3278940248, 3278940251, 'FR', 'FRA', 'فرنسا'),
(71288, 3278940252, 3278940255, 'IT', 'ITA', 'إيطاليا'),
(71289, 3278940256, 3278940259, 'BE', 'BEL', 'بلجيكا'),
(71290, 3278940260, 3278940263, 'DE', 'DEU', 'ألمانيا'),
(71291, 3278940264, 3278940267, 'ES', 'ESP', 'إسبانيا'),
(71292, 3278940268, 3278940275, 'DE', 'DEU', 'ألمانيا'),
(71293, 3278940276, 3278940279, 'GB', 'GBR', 'المملكة المتحدة'),
(71294, 3278940280, 3278940283, 'CH', 'CHE', 'سويسرا'),
(71295, 3278940284, 3278940291, 'NL', 'NLD', 'هولندا'),
(71296, 3278940292, 3278940295, 'DE', 'DEU', 'ألمانيا'),
(71297, 3278940296, 3278940299, 'IT', 'ITA', 'إيطاليا'),
(71298, 3278940300, 3278940303, 'FR', 'FRA', 'فرنسا'),
(71299, 3278940304, 3278940307, 'DE', 'DEU', 'ألمانيا'),
(71300, 3278940308, 3278940311, 'CH', 'CHE', 'سويسرا'),
(71301, 3278940312, 3278940315, 'IT', 'ITA', 'إيطاليا'),
(71302, 3278940316, 3278940319, 'DE', 'DEU', 'ألمانيا'),
(71303, 3278940320, 3278940323, 'NL', 'NLD', 'هولندا'),
(71304, 3278940324, 3278940327, 'ES', 'ESP', 'إسبانيا'),
(71305, 3278940328, 3278940335, 'DE', 'DEU', 'ألمانيا'),
(71306, 3278940336, 3278940339, 'NL', 'NLD', 'هولندا'),
(71307, 3278940340, 3278940347, 'DE', 'DEU', 'ألمانيا'),
(71308, 3278940348, 3278940355, 'GB', 'GBR', 'المملكة المتحدة'),
(71309, 3278940356, 3278940359, 'NL', 'NLD', 'هولندا'),
(71310, 3278940360, 3278940363, 'GR', 'GRC', 'اليونان'),
(71311, 3278940364, 3278940367, 'IT', 'ITA', 'إيطاليا'),
(71312, 3278940368, 3278940371, 'FR', 'FRA', 'فرنسا'),
(71313, 3278940372, 3278940375, 'GB', 'GBR', 'المملكة المتحدة'),
(71314, 3278940376, 3278940379, 'PT', 'PRT', 'البورتوغال'),
(71315, 3278940380, 3278940383, 'FR', 'FRA', 'فرنسا'),
(71316, 3278940384, 3278940387, 'NL', 'NLD', 'هولندا'),
(71317, 3278940388, 3278940391, 'IE', 'IRL', 'إيرلندا'),
(71318, 3278940392, 3278940395, 'FR', 'FRA', 'فرنسا'),
(71319, 3278940396, 3278940399, 'NL', 'NLD', 'هولندا'),
(71320, 3278940400, 3278940403, 'DE', 'DEU', 'ألمانيا'),
(71321, 3278940404, 3278940407, 'FR', 'FRA', 'فرنسا'),
(71322, 3278940408, 3278940411, 'IT', 'ITA', 'إيطاليا'),
(71323, 3278940412, 3278940412, 'CH', 'CHE', 'سويسرا'),
(71324, 3278940413, 3278940415, 'DE', 'DEU', 'ألمانيا'),
(71325, 3278940416, 3278940419, 'BE', 'BEL', 'بلجيكا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(71326, 3278940420, 3278940423, 'DE', 'DEU', 'ألمانيا'),
(71327, 3278940424, 3278940427, 'CH', 'CHE', 'سويسرا'),
(71328, 3278940428, 3278940431, 'DE', 'DEU', 'ألمانيا'),
(71329, 3278940432, 3278940443, 'CH', 'CHE', 'سويسرا'),
(71330, 3278940444, 3278940447, 'DE', 'DEU', 'ألمانيا'),
(71331, 3278940448, 3278940451, 'GB', 'GBR', 'المملكة المتحدة'),
(71332, 3278940452, 3278940455, 'DE', 'DEU', 'ألمانيا'),
(71333, 3278940456, 3278940459, 'GB', 'GBR', 'المملكة المتحدة'),
(71334, 3278940460, 3278940463, 'DE', 'DEU', 'ألمانيا'),
(71335, 3278940464, 3278940467, 'FR', 'FRA', 'فرنسا'),
(71336, 3278940468, 3278940471, 'DE', 'DEU', 'ألمانيا'),
(71337, 3278940472, 3278940475, 'ES', 'ESP', 'إسبانيا'),
(71338, 3278940476, 3278940479, 'FR', 'FRA', 'فرنسا'),
(71339, 3278940480, 3278940483, 'CH', 'CHE', 'سويسرا'),
(71340, 3278940484, 3278940487, 'FR', 'FRA', 'فرنسا'),
(71341, 3278940488, 3278940491, 'ES', 'ESP', 'إسبانيا'),
(71342, 3278940492, 3278940495, 'IT', 'ITA', 'إيطاليا'),
(71343, 3278940496, 3278940499, 'NL', 'NLD', 'هولندا'),
(71344, 3278940500, 3278940503, 'FR', 'FRA', 'فرنسا'),
(71345, 3278940504, 3278940507, 'DK', 'DNK', 'الدنيمارك'),
(71346, 3278940508, 3278940511, 'FR', 'FRA', 'فرنسا'),
(71347, 3278940512, 3278940515, 'DE', 'DEU', 'ألمانيا'),
(71348, 3278940516, 3278940523, 'CH', 'CHE', 'سويسرا'),
(71349, 3278940524, 3278940531, 'ES', 'ESP', 'إسبانيا'),
(71350, 3278940532, 3278940535, 'DE', 'DEU', 'ألمانيا'),
(71351, 3278940536, 3278940539, 'CH', 'CHE', 'سويسرا'),
(71352, 3278940540, 3278940543, 'ES', 'ESP', 'إسبانيا'),
(71353, 3278940544, 3278940551, 'DE', 'DEU', 'ألمانيا'),
(71354, 3278940552, 3278940555, 'GB', 'GBR', 'المملكة المتحدة'),
(71355, 3278940556, 3278940559, 'DE', 'DEU', 'ألمانيا'),
(71356, 3278940560, 3278940563, 'AT', 'AUT', 'النمسا'),
(71357, 3278940564, 3278940571, 'FR', 'FRA', 'فرنسا'),
(71358, 3278940572, 3278940579, 'CH', 'CHE', 'سويسرا'),
(71359, 3278940580, 3278940587, 'DE', 'DEU', 'ألمانيا'),
(71360, 3278940588, 3278940591, 'IT', 'ITA', 'إيطاليا'),
(71361, 3278940592, 3278940595, 'FR', 'FRA', 'فرنسا'),
(71362, 3278940596, 3278940599, 'BE', 'BEL', 'بلجيكا'),
(71363, 3278940600, 3278940603, 'DE', 'DEU', 'ألمانيا'),
(71364, 3278940604, 3278940607, 'FR', 'FRA', 'فرنسا'),
(71365, 3278940608, 3278940611, 'ES', 'ESP', 'إسبانيا'),
(71366, 3278940612, 3278940615, 'PT', 'PRT', 'البورتوغال'),
(71367, 3278940616, 3278940619, 'IT', 'ITA', 'إيطاليا'),
(71368, 3278940620, 3278940623, 'DE', 'DEU', 'ألمانيا'),
(71369, 3278940624, 3278940631, 'IT', 'ITA', 'إيطاليا'),
(71370, 3278940632, 3278940635, 'GB', 'GBR', 'المملكة المتحدة'),
(71371, 3278940636, 3278940639, 'BE', 'BEL', 'بلجيكا'),
(71372, 3278940640, 3278940643, 'CH', 'CHE', 'سويسرا'),
(71373, 3278940644, 3278940647, 'IT', 'ITA', 'إيطاليا'),
(71374, 3278940648, 3278940651, 'DE', 'DEU', 'ألمانيا'),
(71375, 3278940652, 3278940655, 'FR', 'FRA', 'فرنسا'),
(71376, 3278940656, 3278940663, 'IT', 'ITA', 'إيطاليا'),
(71377, 3278940664, 3278940671, 'FR', 'FRA', 'فرنسا'),
(71378, 3278940672, 3278940679, 'DE', 'DEU', 'ألمانيا'),
(71379, 3278940680, 3278940683, 'CH', 'CHE', 'سويسرا'),
(71380, 3278940684, 3278940691, 'NL', 'NLD', 'هولندا'),
(71381, 3278940692, 3278940695, 'SE', 'SWE', 'السويد'),
(71382, 3278940696, 3278940707, 'DE', 'DEU', 'ألمانيا'),
(71383, 3278940708, 3278940711, 'ES', 'ESP', 'إسبانيا'),
(71384, 3278940712, 3278940715, 'BE', 'BEL', 'بلجيكا'),
(71385, 3278940716, 3278940723, 'ES', 'ESP', 'إسبانيا'),
(71386, 3278940724, 3278940727, 'FR', 'FRA', 'فرنسا'),
(71387, 3278940728, 3278940731, 'DE', 'DEU', 'ألمانيا'),
(71388, 3278940732, 3278940739, 'FR', 'FRA', 'فرنسا'),
(71389, 3278940740, 3278940743, 'GB', 'GBR', 'المملكة المتحدة'),
(71390, 3278940744, 3278940747, 'ES', 'ESP', 'إسبانيا'),
(71391, 3278940748, 3278940751, 'DE', 'DEU', 'ألمانيا'),
(71392, 3278940752, 3278940759, 'FR', 'FRA', 'فرنسا'),
(71393, 3278940760, 3278940763, 'NL', 'NLD', 'هولندا'),
(71394, 3278940764, 3278940767, 'DE', 'DEU', 'ألمانيا'),
(71395, 3278940768, 3278940771, 'GB', 'GBR', 'المملكة المتحدة'),
(71396, 3278940772, 3278940783, 'DE', 'DEU', 'ألمانيا'),
(71397, 3278940784, 3278940787, 'CH', 'CHE', 'سويسرا'),
(71398, 3278940788, 3278940791, 'GB', 'GBR', 'المملكة المتحدة'),
(71399, 3278940792, 3278940795, 'NL', 'NLD', 'هولندا'),
(71400, 3278940796, 3278940803, 'DE', 'DEU', 'ألمانيا'),
(71401, 3278940804, 3278940807, 'DK', 'DNK', 'الدنيمارك'),
(71402, 3278940808, 3278940815, 'DE', 'DEU', 'ألمانيا'),
(71403, 3278940816, 3278940819, 'IT', 'ITA', 'إيطاليا'),
(71404, 3278940820, 3278940823, 'GB', 'GBR', 'المملكة المتحدة'),
(71405, 3278940824, 3278940827, 'IT', 'ITA', 'إيطاليا'),
(71406, 3278940828, 3278940831, 'DE', 'DEU', 'ألمانيا'),
(71407, 3278940832, 3278940835, 'CH', 'CHE', 'سويسرا'),
(71408, 3278940836, 3278940839, 'IT', 'ITA', 'إيطاليا'),
(71409, 3278940840, 3278940847, 'DE', 'DEU', 'ألمانيا'),
(71410, 3278940848, 3278940851, 'CH', 'CHE', 'سويسرا'),
(71411, 3278940852, 3278940855, 'DE', 'DEU', 'ألمانيا'),
(71412, 3278940856, 3278940859, 'PT', 'PRT', 'البورتوغال'),
(71413, 3278940860, 3278940863, 'NL', 'NLD', 'هولندا'),
(71414, 3278940864, 3278940867, 'CH', 'CHE', 'سويسرا'),
(71415, 3278940868, 3278940871, 'GB', 'GBR', 'المملكة المتحدة'),
(71416, 3278940872, 3278940875, 'DE', 'DEU', 'ألمانيا'),
(71417, 3278940876, 3278940879, 'IT', 'ITA', 'إيطاليا'),
(71418, 3278940880, 3278940883, 'CH', 'CHE', 'سويسرا'),
(71419, 3278940884, 3278940887, 'ES', 'ESP', 'إسبانيا'),
(71420, 3278940888, 3278940891, 'BE', 'BEL', 'بلجيكا'),
(71421, 3278940892, 3278940895, 'DE', 'DEU', 'ألمانيا'),
(71422, 3278940896, 3278940899, 'IT', 'ITA', 'إيطاليا'),
(71423, 3278940900, 3278940903, 'FR', 'FRA', 'فرنسا'),
(71424, 3278940904, 3278940911, 'ES', 'ESP', 'إسبانيا'),
(71425, 3278940912, 3278940915, 'IT', 'ITA', 'إيطاليا'),
(71426, 3278940916, 3278940919, 'DE', 'DEU', 'ألمانيا'),
(71427, 3278940920, 3278940923, 'PT', 'PRT', 'البورتوغال'),
(71428, 3278940924, 3278940931, 'DE', 'DEU', 'ألمانيا'),
(71429, 3278940932, 3278940935, 'NL', 'NLD', 'هولندا'),
(71430, 3278940936, 3278940939, 'ES', 'ESP', 'إسبانيا'),
(71431, 3278940940, 3278940943, 'FR', 'FRA', 'فرنسا'),
(71432, 3278940944, 3278940947, 'NL', 'NLD', 'هولندا'),
(71433, 3278940948, 3278940951, 'FR', 'FRA', 'فرنسا'),
(71434, 3278940952, 3278940955, 'IT', 'ITA', 'إيطاليا'),
(71435, 3278940956, 3278940959, 'DK', 'DNK', 'الدنيمارك'),
(71436, 3278940960, 3278940963, 'FR', 'FRA', 'فرنسا'),
(71437, 3278940964, 3278940967, 'IT', 'ITA', 'إيطاليا'),
(71438, 3278940968, 3278940971, 'FR', 'FRA', 'فرنسا'),
(71439, 3278940972, 3278940983, 'DE', 'DEU', 'ألمانيا'),
(71440, 3278940984, 3278940987, 'IT', 'ITA', 'إيطاليا'),
(71441, 3278940988, 3278940991, 'NL', 'NLD', 'هولندا'),
(71442, 3278940992, 3278940995, 'PT', 'PRT', 'البورتوغال'),
(71443, 3278940996, 3278940999, 'DE', 'DEU', 'ألمانيا'),
(71444, 3278941000, 3278941003, 'NL', 'NLD', 'هولندا'),
(71445, 3278941004, 3278941007, 'CH', 'CHE', 'سويسرا'),
(71446, 3278941008, 3278941011, 'ES', 'ESP', 'إسبانيا'),
(71447, 3278941012, 3278941015, 'GB', 'GBR', 'المملكة المتحدة'),
(71448, 3278941016, 3278941023, 'DE', 'DEU', 'ألمانيا'),
(71449, 3278941024, 3278941027, 'IT', 'ITA', 'إيطاليا'),
(71450, 3278941028, 3278941031, 'FR', 'FRA', 'فرنسا'),
(71451, 3278941032, 3278941035, 'DE', 'DEU', 'ألمانيا'),
(71452, 3278941036, 3278941039, 'IT', 'ITA', 'إيطاليا'),
(71453, 3278941040, 3278941043, 'DE', 'DEU', 'ألمانيا'),
(71454, 3278941044, 3278941047, 'FR', 'FRA', 'فرنسا'),
(71455, 3278941048, 3278941051, 'ES', 'ESP', 'إسبانيا'),
(71456, 3278941052, 3278941059, 'DE', 'DEU', 'ألمانيا'),
(71457, 3278941060, 3278941063, 'GB', 'GBR', 'المملكة المتحدة'),
(71458, 3278941064, 3278941067, 'IT', 'ITA', 'إيطاليا'),
(71459, 3278941068, 3278941071, 'ES', 'ESP', 'إسبانيا'),
(71460, 3278941072, 3278941075, 'IT', 'ITA', 'إيطاليا'),
(71461, 3278941076, 3278941083, 'DE', 'DEU', 'ألمانيا'),
(71462, 3278941084, 3278941087, 'GB', 'GBR', 'المملكة المتحدة'),
(71463, 3278941088, 3278941091, 'BE', 'BEL', 'بلجيكا'),
(71464, 3278941092, 3278941095, 'DK', 'DNK', 'الدنيمارك'),
(71465, 3278941096, 3278941099, 'FR', 'FRA', 'فرنسا'),
(71466, 3278941100, 3278941107, 'DE', 'DEU', 'ألمانيا'),
(71467, 3278941108, 3278941111, 'DK', 'DNK', 'الدنيمارك'),
(71468, 3278941112, 3278941119, 'FR', 'FRA', 'فرنسا'),
(71469, 3278941120, 3278941127, 'DE', 'DEU', 'ألمانيا'),
(71470, 3278941128, 3278941131, 'BE', 'BEL', 'بلجيكا'),
(71471, 3278941132, 3278941135, 'NL', 'NLD', 'هولندا'),
(71472, 3278941136, 3278941139, 'GB', 'GBR', 'المملكة المتحدة'),
(71473, 3278941140, 3278941143, 'DE', 'DEU', 'ألمانيا'),
(71474, 3278941144, 3278941151, 'IT', 'ITA', 'إيطاليا'),
(71475, 3278941152, 3278941155, 'PT', 'PRT', 'البورتوغال'),
(71476, 3278941156, 3278941159, 'SE', 'SWE', 'السويد'),
(71477, 3278941160, 3278941167, 'DE', 'DEU', 'ألمانيا'),
(71478, 3278941168, 3278941171, 'GB', 'GBR', 'المملكة المتحدة'),
(71479, 3278941172, 3278941175, 'AT', 'AUT', 'النمسا'),
(71480, 3278941176, 3278941179, 'IT', 'ITA', 'إيطاليا'),
(71481, 3278941180, 3278941183, 'FR', 'FRA', 'فرنسا'),
(71482, 3278941184, 3278941191, 'US', 'USA', 'الولايات المتحدة'),
(71483, 3278941192, 3278941195, 'BR', 'BRA', 'البرازيل'),
(71484, 3278941196, 3278941215, 'US', 'USA', 'الولايات المتحدة'),
(71485, 3278941216, 3278941219, 'BR', 'BRA', 'البرازيل'),
(71486, 3278941220, 3278941243, 'US', 'USA', 'الولايات المتحدة'),
(71487, 3278941244, 3278941247, 'CO', 'COL', 'كولومبيا'),
(71488, 3278941248, 3278941255, 'US', 'USA', 'الولايات المتحدة'),
(71489, 3278941256, 3278941259, 'MX', 'MEX', 'المكسيك'),
(71490, 3278941260, 3278941279, 'US', 'USA', 'الولايات المتحدة'),
(71491, 3278941280, 3278941283, 'BR', 'BRA', 'البرازيل'),
(71492, 3278941284, 3278941287, 'AR', 'ARG', 'الأرجنتين'),
(71493, 3278941288, 3278941303, 'US', 'USA', 'الولايات المتحدة'),
(71494, 3278941304, 3278941307, 'CO', 'COL', 'كولومبيا'),
(71495, 3278941308, 3278941319, 'US', 'USA', 'الولايات المتحدة'),
(71496, 3278941320, 3278941323, 'CA', 'CAN', 'كندا'),
(71497, 3278941324, 3278941331, 'US', 'USA', 'الولايات المتحدة'),
(71498, 3278941332, 3278941335, 'BR', 'BRA', 'البرازيل'),
(71499, 3278941336, 3278941343, 'US', 'USA', 'الولايات المتحدة'),
(71500, 3278941344, 3278941347, 'AR', 'ARG', 'الأرجنتين'),
(71501, 3278941348, 3278941371, 'US', 'USA', 'الولايات المتحدة'),
(71502, 3278941372, 3278941375, 'CA', 'CAN', 'كندا'),
(71503, 3278941376, 3278941399, 'US', 'USA', 'الولايات المتحدة'),
(71504, 3278941400, 3278941403, 'VE', 'VEN', 'فنزويلا'),
(71505, 3278941404, 3278941407, 'BR', 'BRA', 'البرازيل'),
(71506, 3278941408, 3278941419, 'US', 'USA', 'الولايات المتحدة'),
(71507, 3278941420, 3278941423, 'DE', 'DEU', 'ألمانيا'),
(71508, 3278941424, 3278941427, 'CL', 'CHL', 'تشيلي'),
(71509, 3278941428, 3278941431, 'PE', 'PER', 'بيرو'),
(71510, 3278941432, 3278941439, 'US', 'USA', 'الولايات المتحدة'),
(71511, 3278941440, 3278941443, 'AR', 'ARG', 'الأرجنتين'),
(71512, 3278941444, 3278941455, 'US', 'USA', 'الولايات المتحدة'),
(71513, 3278941456, 3278941459, 'JM', 'JAM', 'جامايكا'),
(71514, 3278941460, 3278941475, 'US', 'USA', 'الولايات المتحدة'),
(71515, 3278941476, 3278941479, 'BR', 'BRA', 'البرازيل'),
(71516, 3278941480, 3278941491, 'US', 'USA', 'الولايات المتحدة'),
(71517, 3278941492, 3278941495, 'MX', 'MEX', 'المكسيك'),
(71518, 3278941496, 3278941499, 'US', 'USA', 'الولايات المتحدة'),
(71519, 3278941500, 3278941503, 'CA', 'CAN', 'كندا'),
(71520, 3278941504, 3278941587, 'US', 'USA', 'الولايات المتحدة'),
(71521, 3278941588, 3278941591, 'DE', 'DEU', 'ألمانيا'),
(71522, 3278941592, 3278941595, 'US', 'USA', 'الولايات المتحدة'),
(71523, 3278941596, 3278941599, 'PE', 'PER', 'بيرو'),
(71524, 3278941600, 3278941615, 'US', 'USA', 'الولايات المتحدة'),
(71525, 3278941616, 3278941619, 'CA', 'CAN', 'كندا'),
(71526, 3278941620, 3278941639, 'US', 'USA', 'الولايات المتحدة'),
(71527, 3278941640, 3278941643, 'BR', 'BRA', 'البرازيل'),
(71528, 3278941644, 3278941651, 'US', 'USA', 'الولايات المتحدة'),
(71529, 3278941652, 3278941655, 'VE', 'VEN', 'فنزويلا'),
(71530, 3278941656, 3278941659, 'US', 'USA', 'الولايات المتحدة'),
(71531, 3278941660, 3278941663, 'BR', 'BRA', 'البرازيل'),
(71532, 3278941664, 3278941667, 'CA', 'CAN', 'كندا'),
(71533, 3278941668, 3278941671, 'US', 'USA', 'الولايات المتحدة'),
(71534, 3278941672, 3278941675, 'VE', 'VEN', 'فنزويلا'),
(71535, 3278941676, 3278941691, 'US', 'USA', 'الولايات المتحدة'),
(71536, 3278941692, 3278941695, 'MX', 'MEX', 'المكسيك'),
(71537, 3278941696, 3278941735, 'US', 'USA', 'الولايات المتحدة'),
(71538, 3278941736, 3278941739, 'CA', 'CAN', 'كندا'),
(71539, 3278941740, 3278941743, 'US', 'USA', 'الولايات المتحدة'),
(71540, 3278941744, 3278941747, 'CA', 'CAN', 'كندا'),
(71541, 3278941748, 3278941819, 'US', 'USA', 'الولايات المتحدة'),
(71542, 3278941820, 3278941823, 'CL', 'CHL', 'تشيلي'),
(71543, 3278941824, 3278941847, 'US', 'USA', 'الولايات المتحدة'),
(71544, 3278941848, 3278941855, 'AR', 'ARG', 'الأرجنتين'),
(71545, 3278941856, 3278941891, 'US', 'USA', 'الولايات المتحدة'),
(71546, 3278941892, 3278941895, 'CA', 'CAN', 'كندا'),
(71547, 3278941896, 3278941911, 'US', 'USA', 'الولايات المتحدة'),
(71548, 3278941912, 3278941915, 'MX', 'MEX', 'المكسيك'),
(71549, 3278941916, 3278941943, 'US', 'USA', 'الولايات المتحدة'),
(71550, 3278941944, 3278941947, 'CO', 'COL', 'كولومبيا'),
(71551, 3278941948, 3278941951, 'US', 'USA', 'الولايات المتحدة'),
(71552, 3278941952, 3278941955, 'GB', 'GBR', 'المملكة المتحدة'),
(71553, 3278941956, 3278941959, 'FR', 'FRA', 'فرنسا'),
(71554, 3278941960, 3278941963, 'DE', 'DEU', 'ألمانيا'),
(71555, 3278941964, 3278941971, 'GB', 'GBR', 'المملكة المتحدة'),
(71556, 3278941972, 3278941979, 'DE', 'DEU', 'ألمانيا'),
(71557, 3278941980, 3278941987, 'ES', 'ESP', 'إسبانيا'),
(71558, 3278941988, 3278941995, 'FR', 'FRA', 'فرنسا'),
(71559, 3278941996, 3278941999, 'ES', 'ESP', 'إسبانيا'),
(71560, 3278942000, 3278942003, 'DE', 'DEU', 'ألمانيا'),
(71561, 3278942004, 3278942011, 'IT', 'ITA', 'إيطاليا'),
(71562, 3278942012, 3278942015, 'DE', 'DEU', 'ألمانيا'),
(71563, 3278942016, 3278942019, 'FR', 'FRA', 'فرنسا'),
(71564, 3278942020, 3278942023, 'DE', 'DEU', 'ألمانيا'),
(71565, 3278942024, 3278942027, 'FR', 'FRA', 'فرنسا'),
(71566, 3278942028, 3278942031, 'CH', 'CHE', 'سويسرا'),
(71567, 3278942032, 3278942035, 'GR', 'GRC', 'اليونان'),
(71568, 3278942036, 3278942039, 'CH', 'CHE', 'سويسرا'),
(71569, 3278942040, 3278942043, 'ES', 'ESP', 'إسبانيا'),
(71570, 3278942044, 3278942047, 'FR', 'FRA', 'فرنسا'),
(71571, 3278942048, 3278942051, 'DE', 'DEU', 'ألمانيا'),
(71572, 3278942052, 3278942055, 'CH', 'CHE', 'سويسرا'),
(71573, 3278942056, 3278942059, 'ES', 'ESP', 'إسبانيا'),
(71574, 3278942060, 3278942063, 'DE', 'DEU', 'ألمانيا'),
(71575, 3278942064, 3278942071, 'ES', 'ESP', 'إسبانيا'),
(71576, 3278942072, 3278942075, 'FR', 'FRA', 'فرنسا'),
(71577, 3278942076, 3278942079, 'DE', 'DEU', 'ألمانيا'),
(71578, 3278942080, 3278942083, 'ES', 'ESP', 'إسبانيا'),
(71579, 3278942084, 3278942087, 'BE', 'BEL', 'بلجيكا'),
(71580, 3278942088, 3278942091, 'ES', 'ESP', 'إسبانيا'),
(71581, 3278942092, 3278942095, 'BE', 'BEL', 'بلجيكا'),
(71582, 3278942096, 3278942099, 'PL', 'POL', 'بولندا'),
(71583, 3278942100, 3278942103, 'GB', 'GBR', 'المملكة المتحدة'),
(71584, 3278942104, 3278942107, 'CH', 'CHE', 'سويسرا'),
(71585, 3278942108, 3278942111, 'DE', 'DEU', 'ألمانيا'),
(71586, 3278942112, 3278942115, 'FR', 'FRA', 'فرنسا'),
(71587, 3278942116, 3278942119, 'DE', 'DEU', 'ألمانيا'),
(71588, 3278942120, 3278942123, 'GB', 'GBR', 'المملكة المتحدة'),
(71589, 3278942124, 3278942127, 'AT', 'AUT', 'النمسا'),
(71590, 3278942128, 3278942131, 'DE', 'DEU', 'ألمانيا'),
(71591, 3278942132, 3278942135, 'GB', 'GBR', 'المملكة المتحدة'),
(71592, 3278942136, 3278942139, 'UA', 'UKR', 'أوكرانيا'),
(71593, 3278942140, 3278942143, 'NL', 'NLD', 'هولندا'),
(71594, 3278942144, 3278942147, 'GB', 'GBR', 'المملكة المتحدة'),
(71595, 3278942148, 3278942155, 'DE', 'DEU', 'ألمانيا'),
(71596, 3278942156, 3278942159, 'FR', 'FRA', 'فرنسا'),
(71597, 3278942160, 3278942163, 'DE', 'DEU', 'ألمانيا'),
(71598, 3278942164, 3278942167, 'IT', 'ITA', 'إيطاليا'),
(71599, 3278942168, 3278942171, 'CH', 'CHE', 'سويسرا'),
(71600, 3278942172, 3278942175, 'GB', 'GBR', 'المملكة المتحدة'),
(71601, 3278942176, 3278942179, 'DE', 'DEU', 'ألمانيا'),
(71602, 3278942180, 3278942183, 'FR', 'FRA', 'فرنسا'),
(71603, 3278942184, 3278942187, 'DK', 'DNK', 'الدنيمارك'),
(71604, 3278942188, 3278942191, 'IT', 'ITA', 'إيطاليا'),
(71605, 3278942192, 3278942199, 'DE', 'DEU', 'ألمانيا'),
(71606, 3278942200, 3278942203, 'GB', 'GBR', 'المملكة المتحدة'),
(71607, 3278942204, 3278942207, 'CH', 'CHE', 'سويسرا'),
(71608, 3278942208, 3278942211, 'TW', 'TWN', 'تايوان'),
(71609, 3278942212, 3278942227, 'AU', 'AUS', 'أستراليا'),
(71610, 3278942228, 3278942231, 'NZ', 'NZL', 'نيوزيلاندا'),
(71611, 3278942232, 3278942243, 'AU', 'AUS', 'أستراليا'),
(71612, 3278942244, 3278942247, 'NZ', 'NZL', 'نيوزيلاندا'),
(71613, 3278942248, 3278942255, 'AU', 'AUS', 'أستراليا'),
(71614, 3278942256, 3278942259, 'NZ', 'NZL', 'نيوزيلاندا'),
(71615, 3278942260, 3278942271, 'AU', 'AUS', 'أستراليا'),
(71616, 3278942272, 3278942275, 'NZ', 'NZL', 'نيوزيلاندا'),
(71617, 3278942276, 3278942291, 'AU', 'AUS', 'أستراليا'),
(71618, 3278942292, 3278942295, 'NZ', 'NZL', 'نيوزيلاندا'),
(71619, 3278942296, 3278942299, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(71620, 3278942300, 3278942355, 'AU', 'AUS', 'أستراليا'),
(71621, 3278942356, 3278942359, 'NZ', 'NZL', 'نيوزيلاندا'),
(71622, 3278942360, 3278942383, 'AU', 'AUS', 'أستراليا'),
(71623, 3278942384, 3278942387, 'NZ', 'NZL', 'نيوزيلاندا'),
(71624, 3278942388, 3278942399, 'AU', 'AUS', 'أستراليا'),
(71625, 3278942400, 3278942403, 'NZ', 'NZL', 'نيوزيلاندا'),
(71626, 3278942404, 3278942435, 'AU', 'AUS', 'أستراليا'),
(71627, 3278942436, 3278942439, 'DE', 'DEU', 'ألمانيا'),
(71628, 3278942440, 3278942443, 'AU', 'AUS', 'أستراليا'),
(71629, 3278942444, 3278942447, 'NZ', 'NZL', 'نيوزيلاندا'),
(71630, 3278942448, 3278942455, 'AU', 'AUS', 'أستراليا'),
(71631, 3278942456, 3278942463, 'DE', 'DEU', 'ألمانيا'),
(71632, 3278942464, 3278942467, 'SG', 'SGP', 'سنغافورة'),
(71633, 3278942468, 3278942471, 'MY', 'MYS', 'ماليزيا'),
(71634, 3278942472, 3278942475, 'IN', 'IND', 'الهند'),
(71635, 3278942476, 3278942483, 'SG', 'SGP', 'سنغافورة'),
(71636, 3278942484, 3278942487, 'CN', 'CHN', 'الصين'),
(71637, 3278942488, 3278942491, 'IN', 'IND', 'الهند'),
(71638, 3278942492, 3278942495, 'MY', 'MYS', 'ماليزيا'),
(71639, 3278942496, 3278942499, 'CN', 'CHN', 'الصين'),
(71640, 3278942500, 3278942507, 'MY', 'MYS', 'ماليزيا'),
(71641, 3278942508, 3278942511, 'TH', 'THA', 'تايلند'),
(71642, 3278942512, 3278942515, 'SG', 'SGP', 'سنغافورة'),
(71643, 3278942516, 3278942519, 'PH', 'PHL', 'الفلبين'),
(71644, 3278942520, 3278942539, 'IN', 'IND', 'الهند'),
(71645, 3278942540, 3278942543, 'TW', 'TWN', 'تايوان'),
(71646, 3278942544, 3278942547, 'PK', 'PAK', 'باكستان'),
(71647, 3278942548, 3278942551, 'MY', 'MYS', 'ماليزيا'),
(71648, 3278942552, 3278942555, 'TW', 'TWN', 'تايوان'),
(71649, 3278942556, 3278942559, 'IN', 'IND', 'الهند'),
(71650, 3278942560, 3278942571, 'MY', 'MYS', 'ماليزيا'),
(71651, 3278942572, 3278942575, 'IN', 'IND', 'الهند'),
(71652, 3278942576, 3278942579, 'MY', 'MYS', 'ماليزيا'),
(71653, 3278942580, 3278942583, 'TW', 'TWN', 'تايوان'),
(71654, 3278942584, 3278942587, 'SG', 'SGP', 'سنغافورة'),
(71655, 3278942588, 3278942591, 'CN', 'CHN', 'الصين'),
(71656, 3278942592, 3278942595, 'TW', 'TWN', 'تايوان'),
(71657, 3278942596, 3278942599, 'IN', 'IND', 'الهند'),
(71658, 3278942600, 3278942603, 'SG', 'SGP', 'سنغافورة'),
(71659, 3278942604, 3278942607, 'TW', 'TWN', 'تايوان'),
(71660, 3278942608, 3278942611, 'TH', 'THA', 'تايلند'),
(71661, 3278942612, 3278942615, 'PH', 'PHL', 'الفلبين'),
(71662, 3278942616, 3278942627, 'SG', 'SGP', 'سنغافورة'),
(71663, 3278942628, 3278942635, 'MY', 'MYS', 'ماليزيا'),
(71664, 3278942636, 3278942643, 'SG', 'SGP', 'سنغافورة'),
(71665, 3278942644, 3278942647, 'MY', 'MYS', 'ماليزيا'),
(71666, 3278942648, 3278942651, 'IN', 'IND', 'الهند'),
(71667, 3278942652, 3278942655, 'MY', 'MYS', 'ماليزيا'),
(71668, 3278942656, 3278942667, 'SG', 'SGP', 'سنغافورة'),
(71669, 3278942668, 3278942671, 'MY', 'MYS', 'ماليزيا'),
(71670, 3278942672, 3278942675, 'SG', 'SGP', 'سنغافورة'),
(71671, 3278942676, 3278942679, 'HK', 'HKG', 'هونغ كونغ'),
(71672, 3278942680, 3278942683, 'TW', 'TWN', 'تايوان'),
(71673, 3278942684, 3278942687, 'DE', 'DEU', 'ألمانيا'),
(71674, 3278942688, 3278942691, 'SG', 'SGP', 'سنغافورة'),
(71675, 3278942692, 3278942695, 'IN', 'IND', 'الهند'),
(71676, 3278942696, 3278942699, 'SG', 'SGP', 'سنغافورة'),
(71677, 3278942700, 3278942703, 'TW', 'TWN', 'تايوان'),
(71678, 3278942704, 3278942707, 'MY', 'MYS', 'ماليزيا'),
(71679, 3278942708, 3278942719, 'SG', 'SGP', 'سنغافورة'),
(71680, 3278942720, 3278942721, 'DE', 'DEU', 'ألمانيا'),
(71681, 3278942722, 3278942722, 'GB', 'GBR', 'المملكة المتحدة'),
(71682, 3278942723, 3278942724, 'DE', 'DEU', 'ألمانيا'),
(71683, 3278942725, 3278942725, 'GB', 'GBR', 'المملكة المتحدة'),
(71684, 3278942726, 3278942726, 'IT', 'ITA', 'إيطاليا'),
(71685, 3278942727, 3278942727, 'DE', 'DEU', 'ألمانيا'),
(71686, 3278942728, 3278942728, 'CH', 'CHE', 'سويسرا'),
(71687, 3278942729, 3278942730, 'BE', 'BEL', 'بلجيكا'),
(71688, 3278942731, 3278942731, 'DE', 'DEU', 'ألمانيا'),
(71689, 3278942732, 3278942732, 'ES', 'ESP', 'إسبانيا'),
(71690, 3278942733, 3278942733, 'LU', 'LUX', 'لوكسيمبورغ'),
(71691, 3278942734, 3278942734, 'GB', 'GBR', 'المملكة المتحدة'),
(71692, 3278942735, 3278942735, 'DE', 'DEU', 'ألمانيا'),
(71693, 3278942736, 3278942736, 'IT', 'ITA', 'إيطاليا'),
(71694, 3278942737, 3278942737, 'GB', 'GBR', 'المملكة المتحدة'),
(71695, 3278942738, 3278942739, 'DE', 'DEU', 'ألمانيا'),
(71696, 3278942740, 3278942740, 'NL', 'NLD', 'هولندا'),
(71697, 3278942741, 3278942741, 'GB', 'GBR', 'المملكة المتحدة'),
(71698, 3278942742, 3278942742, 'DE', 'DEU', 'ألمانيا'),
(71699, 3278942743, 3278942743, 'ES', 'ESP', 'إسبانيا'),
(71700, 3278942744, 3278942748, 'DE', 'DEU', 'ألمانيا'),
(71701, 3278942749, 3278942749, 'GB', 'GBR', 'المملكة المتحدة'),
(71702, 3278942750, 3278942750, 'IT', 'ITA', 'إيطاليا'),
(71703, 3278942751, 3278942751, 'FR', 'FRA', 'فرنسا'),
(71704, 3278942752, 3278942753, 'CH', 'CHE', 'سويسرا'),
(71705, 3278942754, 3278942754, 'DE', 'DEU', 'ألمانيا'),
(71706, 3278942755, 3278942755, 'GB', 'GBR', 'المملكة المتحدة'),
(71707, 3278942756, 3278942756, 'DE', 'DEU', 'ألمانيا'),
(71708, 3278942757, 3278942757, 'GB', 'GBR', 'المملكة المتحدة'),
(71709, 3278942758, 3278942759, 'IT', 'ITA', 'إيطاليا'),
(71710, 3278942760, 3278942761, 'DE', 'DEU', 'ألمانيا'),
(71711, 3278942762, 3278942762, 'GB', 'GBR', 'المملكة المتحدة'),
(71712, 3278942763, 3278942763, 'NL', 'NLD', 'هولندا'),
(71713, 3278942764, 3278942764, 'FR', 'FRA', 'فرنسا'),
(71714, 3278942765, 3278942765, 'CH', 'CHE', 'سويسرا'),
(71715, 3278942766, 3278942766, 'PL', 'POL', 'بولندا'),
(71716, 3278942767, 3278942767, 'FR', 'FRA', 'فرنسا'),
(71717, 3278942768, 3278942768, 'NO', 'NOR', 'النرويج'),
(71718, 3278942769, 3278942769, 'GB', 'GBR', 'المملكة المتحدة'),
(71719, 3278942770, 3278942771, 'DE', 'DEU', 'ألمانيا'),
(71720, 3278942772, 3278942772, 'BE', 'BEL', 'بلجيكا'),
(71721, 3278942773, 3278942773, 'DE', 'DEU', 'ألمانيا'),
(71722, 3278942774, 3278942774, 'CH', 'CHE', 'سويسرا'),
(71723, 3278942775, 3278942775, 'FR', 'FRA', 'فرنسا'),
(71724, 3278942776, 3278942776, 'DE', 'DEU', 'ألمانيا'),
(71725, 3278942777, 3278942778, 'GB', 'GBR', 'المملكة المتحدة'),
(71726, 3278942779, 3278942779, 'SE', 'SWE', 'السويد'),
(71727, 3278942780, 3278942781, 'DE', 'DEU', 'ألمانيا'),
(71728, 3278942782, 3278942782, 'ES', 'ESP', 'إسبانيا'),
(71729, 3278942783, 3278942784, 'DE', 'DEU', 'ألمانيا'),
(71730, 3278942785, 3278942785, 'GR', 'GRC', 'اليونان'),
(71731, 3278942786, 3278942786, 'SI', 'SVN', 'سلوفينيا'),
(71732, 3278942787, 3278942787, 'IT', 'ITA', 'إيطاليا'),
(71733, 3278942788, 3278942789, 'DE', 'DEU', 'ألمانيا'),
(71734, 3278942790, 3278942790, 'ES', 'ESP', 'إسبانيا'),
(71735, 3278942791, 3278942791, 'IT', 'ITA', 'إيطاليا'),
(71736, 3278942792, 3278942792, 'US', 'USA', 'الولايات المتحدة'),
(71737, 3278942793, 3278942793, 'CH', 'CHE', 'سويسرا'),
(71738, 3278942794, 3278942794, 'DE', 'DEU', 'ألمانيا'),
(71739, 3278942795, 3278942795, 'GB', 'GBR', 'المملكة المتحدة'),
(71740, 3278942796, 3278942796, 'IT', 'ITA', 'إيطاليا'),
(71741, 3278942797, 3278942797, 'GB', 'GBR', 'المملكة المتحدة'),
(71742, 3278942798, 3278942798, 'DE', 'DEU', 'ألمانيا'),
(71743, 3278942799, 3278942799, 'IT', 'ITA', 'إيطاليا'),
(71744, 3278942800, 3278942800, 'FR', 'FRA', 'فرنسا'),
(71745, 3278942801, 3278942801, 'GB', 'GBR', 'المملكة المتحدة'),
(71746, 3278942802, 3278942803, 'DE', 'DEU', 'ألمانيا'),
(71747, 3278942804, 3278942804, 'IT', 'ITA', 'إيطاليا'),
(71748, 3278942805, 3278942805, 'DE', 'DEU', 'ألمانيا'),
(71749, 3278942806, 3278942806, 'BE', 'BEL', 'بلجيكا'),
(71750, 3278942807, 3278942807, 'AT', 'AUT', 'النمسا'),
(71751, 3278942808, 3278942809, 'DE', 'DEU', 'ألمانيا'),
(71752, 3278942810, 3278942810, 'ES', 'ESP', 'إسبانيا'),
(71753, 3278942811, 3278942811, 'NL', 'NLD', 'هولندا'),
(71754, 3278942812, 3278942813, 'DE', 'DEU', 'ألمانيا'),
(71755, 3278942814, 3278942814, 'CH', 'CHE', 'سويسرا'),
(71756, 3278942815, 3278942815, 'DE', 'DEU', 'ألمانيا'),
(71757, 3278942816, 3278942816, 'AT', 'AUT', 'النمسا'),
(71758, 3278942817, 3278942817, 'FR', 'FRA', 'فرنسا'),
(71759, 3278942818, 3278942818, 'DK', 'DNK', 'الدنيمارك'),
(71760, 3278942819, 3278942819, 'DE', 'DEU', 'ألمانيا'),
(71761, 3278942820, 3278942820, 'IT', 'ITA', 'إيطاليا'),
(71762, 3278942821, 3278942821, 'NL', 'NLD', 'هولندا'),
(71763, 3278942822, 3278942824, 'DE', 'DEU', 'ألمانيا'),
(71764, 3278942825, 3278942825, 'NL', 'NLD', 'هولندا'),
(71765, 3278942826, 3278942826, 'RU', 'RUS', 'الإتحاد الروسي'),
(71766, 3278942827, 3278942827, 'FR', 'FRA', 'فرنسا'),
(71767, 3278942828, 3278942828, 'ES', 'ESP', 'إسبانيا'),
(71768, 3278942829, 3278942829, 'NL', 'NLD', 'هولندا'),
(71769, 3278942830, 3278942830, 'IT', 'ITA', 'إيطاليا'),
(71770, 3278942831, 3278942831, 'CH', 'CHE', 'سويسرا'),
(71771, 3278942832, 3278942832, 'IT', 'ITA', 'إيطاليا'),
(71772, 3278942833, 3278942833, 'DE', 'DEU', 'ألمانيا'),
(71773, 3278942834, 3278942834, 'NL', 'NLD', 'هولندا'),
(71774, 3278942835, 3278942835, 'AT', 'AUT', 'النمسا'),
(71775, 3278942836, 3278942837, 'DE', 'DEU', 'ألمانيا'),
(71776, 3278942838, 3278942838, 'ES', 'ESP', 'إسبانيا'),
(71777, 3278942839, 3278942839, 'FR', 'FRA', 'فرنسا'),
(71778, 3278942840, 3278942841, 'DE', 'DEU', 'ألمانيا'),
(71779, 3278942842, 3278942843, 'IT', 'ITA', 'إيطاليا'),
(71780, 3278942844, 3278942844, 'ES', 'ESP', 'إسبانيا'),
(71781, 3278942845, 3278942850, 'DE', 'DEU', 'ألمانيا'),
(71782, 3278942851, 3278942851, 'HU', 'HUN', 'هنغاريا'),
(71783, 3278942852, 3278942852, 'DE', 'DEU', 'ألمانيا'),
(71784, 3278942853, 3278942853, 'ES', 'ESP', 'إسبانيا'),
(71785, 3278942854, 3278942854, 'GB', 'GBR', 'المملكة المتحدة'),
(71786, 3278942855, 3278942855, 'ES', 'ESP', 'إسبانيا'),
(71787, 3278942856, 3278942856, 'NO', 'NOR', 'النرويج'),
(71788, 3278942857, 3278942857, 'DE', 'DEU', 'ألمانيا'),
(71789, 3278942858, 3278942858, 'IT', 'ITA', 'إيطاليا'),
(71790, 3278942859, 3278942859, 'DE', 'DEU', 'ألمانيا'),
(71791, 3278942860, 3278942860, 'IT', 'ITA', 'إيطاليا'),
(71792, 3278942861, 3278942861, 'FR', 'FRA', 'فرنسا'),
(71793, 3278942862, 3278942863, 'DE', 'DEU', 'ألمانيا'),
(71794, 3278942864, 3278942864, 'ES', 'ESP', 'إسبانيا'),
(71795, 3278942865, 3278942865, 'GB', 'GBR', 'المملكة المتحدة'),
(71796, 3278942866, 3278942867, 'NL', 'NLD', 'هولندا'),
(71797, 3278942868, 3278942868, 'DE', 'DEU', 'ألمانيا'),
(71798, 3278942869, 3278942869, 'IT', 'ITA', 'إيطاليا'),
(71799, 3278942870, 3278942870, 'CH', 'CHE', 'سويسرا'),
(71800, 3278942871, 3278942871, 'IS', 'ISL', 'أيسلندا'),
(71801, 3278942872, 3278942872, 'ES', 'ESP', 'إسبانيا'),
(71802, 3278942873, 3278942873, 'IT', 'ITA', 'إيطاليا'),
(71803, 3278942874, 3278942875, 'DE', 'DEU', 'ألمانيا'),
(71804, 3278942876, 3278942876, 'PL', 'POL', 'بولندا'),
(71805, 3278942877, 3278942877, 'DE', 'DEU', 'ألمانيا'),
(71806, 3278942878, 3278942878, 'NL', 'NLD', 'هولندا'),
(71807, 3278942879, 3278942879, 'DK', 'DNK', 'الدنيمارك'),
(71808, 3278942880, 3278942881, 'DE', 'DEU', 'ألمانيا'),
(71809, 3278942882, 3278942882, 'CH', 'CHE', 'سويسرا'),
(71810, 3278942883, 3278942883, 'GB', 'GBR', 'المملكة المتحدة'),
(71811, 3278942884, 3278942884, 'DE', 'DEU', 'ألمانيا'),
(71812, 3278942885, 3278942885, 'NL', 'NLD', 'هولندا'),
(71813, 3278942886, 3278942886, 'DE', 'DEU', 'ألمانيا'),
(71814, 3278942887, 3278942887, 'IT', 'ITA', 'إيطاليا'),
(71815, 3278942888, 3278942889, 'DE', 'DEU', 'ألمانيا'),
(71816, 3278942890, 3278942890, 'ES', 'ESP', 'إسبانيا'),
(71817, 3278942891, 3278942894, 'DE', 'DEU', 'ألمانيا'),
(71818, 3278942895, 3278942895, 'NL', 'NLD', 'هولندا'),
(71819, 3278942896, 3278942896, 'GB', 'GBR', 'المملكة المتحدة'),
(71820, 3278942897, 3278942897, 'CH', 'CHE', 'سويسرا'),
(71821, 3278942898, 3278942899, 'NL', 'NLD', 'هولندا'),
(71822, 3278942900, 3278942903, 'DE', 'DEU', 'ألمانيا'),
(71823, 3278942904, 3278942904, 'BE', 'BEL', 'بلجيكا'),
(71824, 3278942905, 3278942905, 'IE', 'IRL', 'إيرلندا'),
(71825, 3278942906, 3278942907, 'DE', 'DEU', 'ألمانيا'),
(71826, 3278942908, 3278942908, 'GB', 'GBR', 'المملكة المتحدة'),
(71827, 3278942909, 3278942910, 'DE', 'DEU', 'ألمانيا'),
(71828, 3278942911, 3278942911, 'IT', 'ITA', 'إيطاليا'),
(71829, 3278942912, 3278942913, 'DE', 'DEU', 'ألمانيا'),
(71830, 3278942914, 3278942914, 'CH', 'CHE', 'سويسرا'),
(71831, 3278942915, 3278942915, 'DE', 'DEU', 'ألمانيا'),
(71832, 3278942916, 3278942916, 'CH', 'CHE', 'سويسرا'),
(71833, 3278942917, 3278942922, 'DE', 'DEU', 'ألمانيا'),
(71834, 3278942923, 3278942923, 'NL', 'NLD', 'هولندا'),
(71835, 3278942924, 3278942924, 'DE', 'DEU', 'ألمانيا'),
(71836, 3278942925, 3278942925, 'GB', 'GBR', 'المملكة المتحدة'),
(71837, 3278942926, 3278942930, 'DE', 'DEU', 'ألمانيا'),
(71838, 3278942931, 3278942931, 'CH', 'CHE', 'سويسرا'),
(71839, 3278942932, 3278942932, 'NL', 'NLD', 'هولندا'),
(71840, 3278942933, 3278942933, 'BE', 'BEL', 'بلجيكا'),
(71841, 3278942934, 3278942934, 'IT', 'ITA', 'إيطاليا'),
(71842, 3278942935, 3278942936, 'NL', 'NLD', 'هولندا'),
(71843, 3278942937, 3278942937, 'DE', 'DEU', 'ألمانيا'),
(71844, 3278942938, 3278942938, 'CH', 'CHE', 'سويسرا'),
(71845, 3278942939, 3278942939, 'ES', 'ESP', 'إسبانيا'),
(71846, 3278942940, 3278942940, 'DE', 'DEU', 'ألمانيا'),
(71847, 3278942941, 3278942941, 'IT', 'ITA', 'إيطاليا'),
(71848, 3278942942, 3278942942, 'DE', 'DEU', 'ألمانيا'),
(71849, 3278942943, 3278942944, 'NL', 'NLD', 'هولندا'),
(71850, 3278942945, 3278942946, 'DE', 'DEU', 'ألمانيا'),
(71851, 3278942947, 3278942947, 'BE', 'BEL', 'بلجيكا'),
(71852, 3278942948, 3278942948, 'AT', 'AUT', 'النمسا'),
(71853, 3278942949, 3278942949, 'CH', 'CHE', 'سويسرا'),
(71854, 3278942950, 3278942950, 'DE', 'DEU', 'ألمانيا'),
(71855, 3278942951, 3278942951, 'IT', 'ITA', 'إيطاليا'),
(71856, 3278942952, 3278942953, 'DE', 'DEU', 'ألمانيا'),
(71857, 3278942954, 3278942954, 'AT', 'AUT', 'النمسا'),
(71858, 3278942955, 3278942955, 'DE', 'DEU', 'ألمانيا'),
(71859, 3278942956, 3278942956, 'IT', 'ITA', 'إيطاليا'),
(71860, 3278942957, 3278942957, 'DE', 'DEU', 'ألمانيا'),
(71861, 3278942958, 3278942958, 'CH', 'CHE', 'سويسرا'),
(71862, 3278942959, 3278942959, 'DE', 'DEU', 'ألمانيا'),
(71863, 3278942960, 3278942960, 'FR', 'FRA', 'فرنسا'),
(71864, 3278942961, 3278942961, 'PT', 'PRT', 'البورتوغال'),
(71865, 3278942962, 3278942963, 'NL', 'NLD', 'هولندا'),
(71866, 3278942964, 3278942966, 'DE', 'DEU', 'ألمانيا'),
(71867, 3278942967, 3278942967, 'NO', 'NOR', 'النرويج'),
(71868, 3278942968, 3278942968, 'NL', 'NLD', 'هولندا'),
(71869, 3278942969, 3278942969, 'AT', 'AUT', 'النمسا'),
(71870, 3278942970, 3278942970, 'ES', 'ESP', 'إسبانيا'),
(71871, 3278942971, 3278942972, 'IT', 'ITA', 'إيطاليا'),
(71872, 3278942973, 3278942977, 'DE', 'DEU', 'ألمانيا'),
(71873, 3278942978, 3278942978, 'BE', 'BEL', 'بلجيكا'),
(71874, 3278942979, 3278942979, 'FR', 'FRA', 'فرنسا'),
(71875, 3278942980, 3278942980, 'IT', 'ITA', 'إيطاليا'),
(71876, 3278942981, 3278942983, 'DE', 'DEU', 'ألمانيا'),
(71877, 3278942984, 3278942984, 'IT', 'ITA', 'إيطاليا'),
(71878, 3278942985, 3278942985, 'ES', 'ESP', 'إسبانيا'),
(71879, 3278942986, 3278942986, 'CH', 'CHE', 'سويسرا'),
(71880, 3278942987, 3278942987, 'BE', 'BEL', 'بلجيكا'),
(71881, 3278942988, 3278942990, 'CH', 'CHE', 'سويسرا'),
(71882, 3278942991, 3278942991, 'GB', 'GBR', 'المملكة المتحدة'),
(71883, 3278942992, 3278942992, 'DE', 'DEU', 'ألمانيا'),
(71884, 3278942993, 3278942993, 'GB', 'GBR', 'المملكة المتحدة'),
(71885, 3278942994, 3278942994, 'CH', 'CHE', 'سويسرا'),
(71886, 3278942995, 3278942997, 'DE', 'DEU', 'ألمانيا'),
(71887, 3278942998, 3278942998, 'CH', 'CHE', 'سويسرا'),
(71888, 3278942999, 3278942999, 'GB', 'GBR', 'المملكة المتحدة'),
(71889, 3278943000, 3278943002, 'DE', 'DEU', 'ألمانيا'),
(71890, 3278943003, 3278943003, 'CH', 'CHE', 'سويسرا'),
(71891, 3278943004, 3278943005, 'DE', 'DEU', 'ألمانيا'),
(71892, 3278943006, 3278943006, 'FR', 'FRA', 'فرنسا'),
(71893, 3278943007, 3278943007, 'DE', 'DEU', 'ألمانيا'),
(71894, 3278943008, 3278943008, 'IT', 'ITA', 'إيطاليا'),
(71895, 3278943009, 3278943009, 'DE', 'DEU', 'ألمانيا'),
(71896, 3278943010, 3278943010, 'NL', 'NLD', 'هولندا'),
(71897, 3278943011, 3278943011, 'DE', 'DEU', 'ألمانيا'),
(71898, 3278943012, 3278943012, 'CZ', 'CZE', 'التشيك'),
(71899, 3278943013, 3278943013, 'IT', 'ITA', 'إيطاليا'),
(71900, 3278943014, 3278943014, 'AT', 'AUT', 'النمسا'),
(71901, 3278943015, 3278943016, 'ES', 'ESP', 'إسبانيا'),
(71902, 3278943017, 3278943017, 'FR', 'FRA', 'فرنسا'),
(71903, 3278943018, 3278943018, 'CH', 'CHE', 'سويسرا'),
(71904, 3278943019, 3278943019, 'DE', 'DEU', 'ألمانيا'),
(71905, 3278943020, 3278943020, 'CH', 'CHE', 'سويسرا'),
(71906, 3278943021, 3278943021, 'BE', 'BEL', 'بلجيكا'),
(71907, 3278943022, 3278943022, 'ES', 'ESP', 'إسبانيا'),
(71908, 3278943023, 3278943023, 'BE', 'BEL', 'بلجيكا'),
(71909, 3278943024, 3278943024, 'FR', 'FRA', 'فرنسا'),
(71910, 3278943025, 3278943025, 'DE', 'DEU', 'ألمانيا'),
(71911, 3278943026, 3278943026, 'DK', 'DNK', 'الدنيمارك'),
(71912, 3278943027, 3278943027, 'DE', 'DEU', 'ألمانيا'),
(71913, 3278943028, 3278943029, 'GB', 'GBR', 'المملكة المتحدة'),
(71914, 3278943030, 3278943030, 'ES', 'ESP', 'إسبانيا'),
(71915, 3278943031, 3278943031, 'NL', 'NLD', 'هولندا'),
(71916, 3278943032, 3278943032, 'FR', 'FRA', 'فرنسا'),
(71917, 3278943033, 3278943033, 'IT', 'ITA', 'إيطاليا'),
(71918, 3278943034, 3278943034, 'DE', 'DEU', 'ألمانيا'),
(71919, 3278943035, 3278943035, 'ES', 'ESP', 'إسبانيا'),
(71920, 3278943036, 3278943036, 'DE', 'DEU', 'ألمانيا'),
(71921, 3278943037, 3278943037, 'FR', 'FRA', 'فرنسا'),
(71922, 3278943038, 3278943038, 'DE', 'DEU', 'ألمانيا'),
(71923, 3278943039, 3278943039, 'CH', 'CHE', 'سويسرا'),
(71924, 3278943040, 3278943040, 'IT', 'ITA', 'إيطاليا'),
(71925, 3278943041, 3278943041, 'DE', 'DEU', 'ألمانيا'),
(71926, 3278943042, 3278943042, 'BE', 'BEL', 'بلجيكا'),
(71927, 3278943043, 3278943043, 'SI', 'SVN', 'سلوفينيا'),
(71928, 3278943044, 3278943044, 'FR', 'FRA', 'فرنسا'),
(71929, 3278943045, 3278943048, 'DE', 'DEU', 'ألمانيا'),
(71930, 3278943049, 3278943049, 'GB', 'GBR', 'المملكة المتحدة'),
(71931, 3278943050, 3278943050, 'IT', 'ITA', 'إيطاليا'),
(71932, 3278943051, 3278943051, 'AT', 'AUT', 'النمسا'),
(71933, 3278943052, 3278943053, 'IT', 'ITA', 'إيطاليا'),
(71934, 3278943054, 3278943056, 'DE', 'DEU', 'ألمانيا'),
(71935, 3278943057, 3278943057, 'CH', 'CHE', 'سويسرا'),
(71936, 3278943058, 3278943058, 'FR', 'FRA', 'فرنسا'),
(71937, 3278943059, 3278943059, 'CH', 'CHE', 'سويسرا'),
(71938, 3278943060, 3278943065, 'DE', 'DEU', 'ألمانيا'),
(71939, 3278943066, 3278943066, 'GB', 'GBR', 'المملكة المتحدة'),
(71940, 3278943067, 3278943069, 'DE', 'DEU', 'ألمانيا'),
(71941, 3278943070, 3278943070, 'PL', 'POL', 'بولندا'),
(71942, 3278943071, 3278943072, 'DE', 'DEU', 'ألمانيا'),
(71943, 3278943073, 3278943073, 'AT', 'AUT', 'النمسا'),
(71944, 3278943074, 3278943074, 'ES', 'ESP', 'إسبانيا'),
(71945, 3278943075, 3278943076, 'FR', 'FRA', 'فرنسا'),
(71946, 3278943077, 3278943077, 'DE', 'DEU', 'ألمانيا'),
(71947, 3278943078, 3278943079, 'CH', 'CHE', 'سويسرا'),
(71948, 3278943080, 3278943080, 'BE', 'BEL', 'بلجيكا'),
(71949, 3278943081, 3278943081, 'FR', 'FRA', 'فرنسا'),
(71950, 3278943082, 3278943082, 'CH', 'CHE', 'سويسرا'),
(71951, 3278943083, 3278943084, 'DE', 'DEU', 'ألمانيا'),
(71952, 3278943085, 3278943085, 'NL', 'NLD', 'هولندا'),
(71953, 3278943086, 3278943087, 'DE', 'DEU', 'ألمانيا'),
(71954, 3278943088, 3278943088, 'NL', 'NLD', 'هولندا'),
(71955, 3278943089, 3278943090, 'DE', 'DEU', 'ألمانيا'),
(71956, 3278943091, 3278943091, 'IT', 'ITA', 'إيطاليا'),
(71957, 3278943092, 3278943092, 'ES', 'ESP', 'إسبانيا'),
(71958, 3278943093, 3278943096, 'DE', 'DEU', 'ألمانيا'),
(71959, 3278943097, 3278943097, 'BE', 'BEL', 'بلجيكا'),
(71960, 3278943098, 3278943098, 'DE', 'DEU', 'ألمانيا'),
(71961, 3278943099, 3278943099, 'AT', 'AUT', 'النمسا'),
(71962, 3278943100, 3278943100, 'SE', 'SWE', 'السويد'),
(71963, 3278943101, 3278943101, 'AT', 'AUT', 'النمسا'),
(71964, 3278943102, 3278943102, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(71965, 3278943103, 3278943105, 'DE', 'DEU', 'ألمانيا'),
(71966, 3278943106, 3278943106, 'FR', 'FRA', 'فرنسا'),
(71967, 3278943107, 3278943107, 'DE', 'DEU', 'ألمانيا'),
(71968, 3278943108, 3278943108, 'FR', 'FRA', 'فرنسا'),
(71969, 3278943109, 3278943109, 'IT', 'ITA', 'إيطاليا'),
(71970, 3278943110, 3278943110, 'DK', 'DNK', 'الدنيمارك'),
(71971, 3278943111, 3278943111, 'GB', 'GBR', 'المملكة المتحدة'),
(71972, 3278943112, 3278943112, 'PT', 'PRT', 'البورتوغال'),
(71973, 3278943113, 3278943113, 'ES', 'ESP', 'إسبانيا'),
(71974, 3278943114, 3278943114, 'CH', 'CHE', 'سويسرا'),
(71975, 3278943115, 3278943115, 'PT', 'PRT', 'البورتوغال'),
(71976, 3278943116, 3278943116, 'CH', 'CHE', 'سويسرا'),
(71977, 3278943117, 3278943117, 'DE', 'DEU', 'ألمانيا'),
(71978, 3278943118, 3278943119, 'IT', 'ITA', 'إيطاليا'),
(71979, 3278943120, 3278943120, 'FR', 'FRA', 'فرنسا'),
(71980, 3278943121, 3278943121, 'AT', 'AUT', 'النمسا'),
(71981, 3278943122, 3278943122, 'GB', 'GBR', 'المملكة المتحدة'),
(71982, 3278943123, 3278943123, 'FR', 'FRA', 'فرنسا'),
(71983, 3278943124, 3278943124, 'BE', 'BEL', 'بلجيكا'),
(71984, 3278943125, 3278943125, 'CH', 'CHE', 'سويسرا'),
(71985, 3278943126, 3278943126, 'IT', 'ITA', 'إيطاليا'),
(71986, 3278943127, 3278943127, 'DE', 'DEU', 'ألمانيا'),
(71987, 3278943128, 3278943128, 'GB', 'GBR', 'المملكة المتحدة'),
(71988, 3278943129, 3278943130, 'DE', 'DEU', 'ألمانيا'),
(71989, 3278943131, 3278943131, 'BE', 'BEL', 'بلجيكا'),
(71990, 3278943132, 3278943132, 'FR', 'FRA', 'فرنسا'),
(71991, 3278943133, 3278943133, 'IT', 'ITA', 'إيطاليا'),
(71992, 3278943134, 3278943135, 'NL', 'NLD', 'هولندا'),
(71993, 3278943136, 3278943136, 'FR', 'FRA', 'فرنسا'),
(71994, 3278943137, 3278943137, 'CH', 'CHE', 'سويسرا'),
(71995, 3278943138, 3278943138, 'BE', 'BEL', 'بلجيكا'),
(71996, 3278943139, 3278943139, 'IT', 'ITA', 'إيطاليا'),
(71997, 3278943140, 3278943140, 'ES', 'ESP', 'إسبانيا'),
(71998, 3278943141, 3278943141, 'NL', 'NLD', 'هولندا'),
(71999, 3278943142, 3278943142, 'FR', 'FRA', 'فرنسا'),
(72000, 3278943143, 3278943143, 'ES', 'ESP', 'إسبانيا'),
(72001, 3278943144, 3278943145, 'DE', 'DEU', 'ألمانيا'),
(72002, 3278943146, 3278943146, 'CH', 'CHE', 'سويسرا'),
(72003, 3278943147, 3278943147, 'NL', 'NLD', 'هولندا'),
(72004, 3278943148, 3278943148, 'FR', 'FRA', 'فرنسا'),
(72005, 3278943149, 3278943149, 'BE', 'BEL', 'بلجيكا'),
(72006, 3278943150, 3278943150, 'DE', 'DEU', 'ألمانيا'),
(72007, 3278943151, 3278943151, 'NL', 'NLD', 'هولندا'),
(72008, 3278943152, 3278943153, 'DE', 'DEU', 'ألمانيا'),
(72009, 3278943154, 3278943154, 'SE', 'SWE', 'السويد'),
(72010, 3278943155, 3278943159, 'DE', 'DEU', 'ألمانيا'),
(72011, 3278943160, 3278943160, 'ES', 'ESP', 'إسبانيا'),
(72012, 3278943161, 3278943161, 'BE', 'BEL', 'بلجيكا'),
(72013, 3278943162, 3278943162, 'ES', 'ESP', 'إسبانيا'),
(72014, 3278943163, 3278943163, 'DE', 'DEU', 'ألمانيا'),
(72015, 3278943164, 3278943164, 'NL', 'NLD', 'هولندا'),
(72016, 3278943165, 3278943165, 'SE', 'SWE', 'السويد'),
(72017, 3278943166, 3278943168, 'DE', 'DEU', 'ألمانيا'),
(72018, 3278943169, 3278943169, 'BE', 'BEL', 'بلجيكا'),
(72019, 3278943170, 3278943172, 'FR', 'FRA', 'فرنسا'),
(72020, 3278943173, 3278943173, 'NL', 'NLD', 'هولندا'),
(72021, 3278943174, 3278943174, 'DE', 'DEU', 'ألمانيا'),
(72022, 3278943175, 3278943177, 'ES', 'ESP', 'إسبانيا'),
(72023, 3278943178, 3278943178, 'DE', 'DEU', 'ألمانيا'),
(72024, 3278943179, 3278943179, 'CH', 'CHE', 'سويسرا'),
(72025, 3278943180, 3278943181, 'DE', 'DEU', 'ألمانيا'),
(72026, 3278943182, 3278943182, 'SE', 'SWE', 'السويد'),
(72027, 3278943183, 3278943183, 'FR', 'FRA', 'فرنسا'),
(72028, 3278943184, 3278943184, 'DE', 'DEU', 'ألمانيا'),
(72029, 3278943185, 3278943185, 'BE', 'BEL', 'بلجيكا'),
(72030, 3278943186, 3278943186, 'NL', 'NLD', 'هولندا'),
(72031, 3278943187, 3278943187, 'DE', 'DEU', 'ألمانيا'),
(72032, 3278943188, 3278943188, 'GB', 'GBR', 'المملكة المتحدة'),
(72033, 3278943189, 3278943191, 'DE', 'DEU', 'ألمانيا'),
(72034, 3278943192, 3278943192, 'LU', 'LUX', 'لوكسيمبورغ'),
(72035, 3278943193, 3278943193, 'DE', 'DEU', 'ألمانيا'),
(72036, 3278943194, 3278943194, 'IT', 'ITA', 'إيطاليا'),
(72037, 3278943195, 3278943195, 'DE', 'DEU', 'ألمانيا'),
(72038, 3278943196, 3278943196, 'CH', 'CHE', 'سويسرا'),
(72039, 3278943197, 3278943197, 'NL', 'NLD', 'هولندا'),
(72040, 3278943198, 3278943198, 'GR', 'GRC', 'اليونان'),
(72041, 3278943199, 3278943199, 'GB', 'GBR', 'المملكة المتحدة'),
(72042, 3278943200, 3278943200, 'DE', 'DEU', 'ألمانيا'),
(72043, 3278943201, 3278943202, 'CH', 'CHE', 'سويسرا'),
(72044, 3278943203, 3278943203, 'SE', 'SWE', 'السويد'),
(72045, 3278943204, 3278943206, 'DE', 'DEU', 'ألمانيا'),
(72046, 3278943207, 3278943207, 'IT', 'ITA', 'إيطاليا'),
(72047, 3278943208, 3278943208, 'GB', 'GBR', 'المملكة المتحدة'),
(72048, 3278943209, 3278943209, 'ES', 'ESP', 'إسبانيا'),
(72049, 3278943210, 3278943212, 'IT', 'ITA', 'إيطاليا'),
(72050, 3278943213, 3278943213, 'DE', 'DEU', 'ألمانيا'),
(72051, 3278943214, 3278943214, 'IT', 'ITA', 'إيطاليا'),
(72052, 3278943215, 3278943215, 'GB', 'GBR', 'المملكة المتحدة'),
(72053, 3278943216, 3278943216, 'CH', 'CHE', 'سويسرا'),
(72054, 3278943217, 3278943217, 'GB', 'GBR', 'المملكة المتحدة'),
(72055, 3278943218, 3278943218, 'IT', 'ITA', 'إيطاليا'),
(72056, 3278943219, 3278943220, 'DE', 'DEU', 'ألمانيا'),
(72057, 3278943221, 3278943221, 'CH', 'CHE', 'سويسرا'),
(72058, 3278943222, 3278943222, 'DE', 'DEU', 'ألمانيا'),
(72059, 3278943223, 3278943223, 'NL', 'NLD', 'هولندا'),
(72060, 3278943224, 3278943225, 'DE', 'DEU', 'ألمانيا'),
(72061, 3278943226, 3278943226, 'FR', 'FRA', 'فرنسا'),
(72062, 3278943227, 3278943227, 'GB', 'GBR', 'المملكة المتحدة'),
(72063, 3278943228, 3278943228, 'ES', 'ESP', 'إسبانيا'),
(72064, 3278943229, 3278943235, 'DE', 'DEU', 'ألمانيا'),
(72065, 3278943236, 3278943236, 'ES', 'ESP', 'إسبانيا'),
(72066, 3278943237, 3278943237, 'FR', 'FRA', 'فرنسا'),
(72067, 3278943238, 3278943239, 'DE', 'DEU', 'ألمانيا'),
(72068, 3278943240, 3278943240, 'NL', 'NLD', 'هولندا'),
(72069, 3278943241, 3278943242, 'DE', 'DEU', 'ألمانيا'),
(72070, 3278943243, 3278943243, 'ES', 'ESP', 'إسبانيا'),
(72071, 3278943244, 3278943244, 'FR', 'FRA', 'فرنسا'),
(72072, 3278943245, 3278943245, 'DE', 'DEU', 'ألمانيا'),
(72073, 3278943246, 3278943246, 'NL', 'NLD', 'هولندا'),
(72074, 3278943247, 3278943247, 'CH', 'CHE', 'سويسرا'),
(72075, 3278943248, 3278943248, 'DE', 'DEU', 'ألمانيا'),
(72076, 3278943249, 3278943249, 'ES', 'ESP', 'إسبانيا'),
(72077, 3278943250, 3278943251, 'FR', 'FRA', 'فرنسا'),
(72078, 3278943252, 3278943252, 'IT', 'ITA', 'إيطاليا'),
(72079, 3278943253, 3278943253, 'DE', 'DEU', 'ألمانيا'),
(72080, 3278943254, 3278943254, 'DK', 'DNK', 'الدنيمارك'),
(72081, 3278943255, 3278943255, 'DE', 'DEU', 'ألمانيا'),
(72082, 3278943256, 3278943256, 'FR', 'FRA', 'فرنسا'),
(72083, 3278943257, 3278943257, 'IT', 'ITA', 'إيطاليا'),
(72084, 3278943258, 3278943260, 'DE', 'DEU', 'ألمانيا'),
(72085, 3278943261, 3278943261, 'ES', 'ESP', 'إسبانيا'),
(72086, 3278943262, 3278943262, 'NL', 'NLD', 'هولندا'),
(72087, 3278943263, 3278943263, 'FR', 'FRA', 'فرنسا'),
(72088, 3278943264, 3278943265, 'DE', 'DEU', 'ألمانيا'),
(72089, 3278943266, 3278943266, 'FR', 'FRA', 'فرنسا'),
(72090, 3278943267, 3278943267, 'NL', 'NLD', 'هولندا'),
(72091, 3278943268, 3278943268, 'DE', 'DEU', 'ألمانيا'),
(72092, 3278943269, 3278943270, 'CH', 'CHE', 'سويسرا'),
(72093, 3278943271, 3278943271, 'ES', 'ESP', 'إسبانيا'),
(72094, 3278943272, 3278943274, 'DE', 'DEU', 'ألمانيا'),
(72095, 3278943275, 3278943275, 'IT', 'ITA', 'إيطاليا'),
(72096, 3278943276, 3278943277, 'DE', 'DEU', 'ألمانيا'),
(72097, 3278943278, 3278943278, 'GB', 'GBR', 'المملكة المتحدة'),
(72098, 3278943279, 3278943279, 'DE', 'DEU', 'ألمانيا'),
(72099, 3278943280, 3278943280, 'FR', 'FRA', 'فرنسا'),
(72100, 3278943281, 3278943281, 'IT', 'ITA', 'إيطاليا'),
(72101, 3278943282, 3278943283, 'DE', 'DEU', 'ألمانيا'),
(72102, 3278943284, 3278943284, 'IT', 'ITA', 'إيطاليا'),
(72103, 3278943285, 3278943287, 'DE', 'DEU', 'ألمانيا'),
(72104, 3278943288, 3278943288, 'FR', 'FRA', 'فرنسا'),
(72105, 3278943289, 3278943289, 'DE', 'DEU', 'ألمانيا'),
(72106, 3278943290, 3278943290, 'IT', 'ITA', 'إيطاليا'),
(72107, 3278943291, 3278943292, 'DE', 'DEU', 'ألمانيا'),
(72108, 3278943293, 3278943293, 'GB', 'GBR', 'المملكة المتحدة'),
(72109, 3278943294, 3278943294, 'IT', 'ITA', 'إيطاليا'),
(72110, 3278943295, 3278943296, 'ES', 'ESP', 'إسبانيا'),
(72111, 3278943297, 3278943297, 'IT', 'ITA', 'إيطاليا'),
(72112, 3278943298, 3278943298, 'PT', 'PRT', 'البورتوغال'),
(72113, 3278943299, 3278943299, 'DK', 'DNK', 'الدنيمارك'),
(72114, 3278943300, 3278943300, 'GB', 'GBR', 'المملكة المتحدة'),
(72115, 3278943301, 3278943301, 'CH', 'CHE', 'سويسرا'),
(72116, 3278943302, 3278943302, 'BE', 'BEL', 'بلجيكا'),
(72117, 3278943303, 3278943303, 'DK', 'DNK', 'الدنيمارك'),
(72118, 3278943304, 3278943304, 'FR', 'FRA', 'فرنسا'),
(72119, 3278943305, 3278943305, 'LU', 'LUX', 'لوكسيمبورغ'),
(72120, 3278943306, 3278943306, 'AT', 'AUT', 'النمسا'),
(72121, 3278943307, 3278943308, 'DE', 'DEU', 'ألمانيا'),
(72122, 3278943309, 3278943309, 'PT', 'PRT', 'البورتوغال'),
(72123, 3278943310, 3278943310, 'ES', 'ESP', 'إسبانيا'),
(72124, 3278943311, 3278943311, 'BE', 'BEL', 'بلجيكا'),
(72125, 3278943312, 3278943314, 'DE', 'DEU', 'ألمانيا'),
(72126, 3278943315, 3278943316, 'FR', 'FRA', 'فرنسا'),
(72127, 3278943317, 3278943318, 'DE', 'DEU', 'ألمانيا'),
(72128, 3278943319, 3278943319, 'NL', 'NLD', 'هولندا'),
(72129, 3278943320, 3278943320, 'BE', 'BEL', 'بلجيكا'),
(72130, 3278943321, 3278943321, 'DE', 'DEU', 'ألمانيا'),
(72131, 3278943322, 3278943322, 'NL', 'NLD', 'هولندا'),
(72132, 3278943323, 3278943323, 'FR', 'FRA', 'فرنسا'),
(72133, 3278943324, 3278943324, 'GB', 'GBR', 'المملكة المتحدة'),
(72134, 3278943325, 3278943326, 'DE', 'DEU', 'ألمانيا'),
(72135, 3278943327, 3278943328, 'IT', 'ITA', 'إيطاليا'),
(72136, 3278943329, 3278943329, 'PT', 'PRT', 'البورتوغال'),
(72137, 3278943330, 3278943330, 'ES', 'ESP', 'إسبانيا'),
(72138, 3278943331, 3278943331, 'PL', 'POL', 'بولندا'),
(72139, 3278943332, 3278943333, 'DE', 'DEU', 'ألمانيا'),
(72140, 3278943334, 3278943334, 'FR', 'FRA', 'فرنسا'),
(72141, 3278943335, 3278943335, 'AT', 'AUT', 'النمسا'),
(72142, 3278943336, 3278943337, 'IT', 'ITA', 'إيطاليا'),
(72143, 3278943338, 3278943338, 'DE', 'DEU', 'ألمانيا'),
(72144, 3278943339, 3278943339, 'PT', 'PRT', 'البورتوغال'),
(72145, 3278943340, 3278943340, 'ES', 'ESP', 'إسبانيا'),
(72146, 3278943341, 3278943341, 'CH', 'CHE', 'سويسرا'),
(72147, 3278943342, 3278943343, 'DE', 'DEU', 'ألمانيا'),
(72148, 3278943344, 3278943344, 'GB', 'GBR', 'المملكة المتحدة'),
(72149, 3278943345, 3278943345, 'DE', 'DEU', 'ألمانيا'),
(72150, 3278943346, 3278943346, 'FR', 'FRA', 'فرنسا'),
(72151, 3278943347, 3278943347, 'DE', 'DEU', 'ألمانيا'),
(72152, 3278943348, 3278943349, 'GB', 'GBR', 'المملكة المتحدة'),
(72153, 3278943350, 3278943351, 'DE', 'DEU', 'ألمانيا'),
(72154, 3278943352, 3278943352, 'NL', 'NLD', 'هولندا'),
(72155, 3278943353, 3278943353, 'DE', 'DEU', 'ألمانيا'),
(72156, 3278943354, 3278943355, 'ES', 'ESP', 'إسبانيا'),
(72157, 3278943356, 3278943356, 'FR', 'FRA', 'فرنسا'),
(72158, 3278943357, 3278943357, 'ES', 'ESP', 'إسبانيا'),
(72159, 3278943358, 3278943358, 'FR', 'FRA', 'فرنسا'),
(72160, 3278943359, 3278943359, 'ES', 'ESP', 'إسبانيا'),
(72161, 3278943360, 3278943360, 'CH', 'CHE', 'سويسرا'),
(72162, 3278943361, 3278943361, 'DE', 'DEU', 'ألمانيا'),
(72163, 3278943362, 3278943362, 'IT', 'ITA', 'إيطاليا'),
(72164, 3278943363, 3278943363, 'DE', 'DEU', 'ألمانيا'),
(72165, 3278943364, 3278943364, 'IT', 'ITA', 'إيطاليا'),
(72166, 3278943365, 3278943366, 'DE', 'DEU', 'ألمانيا'),
(72167, 3278943367, 3278943367, 'FR', 'FRA', 'فرنسا'),
(72168, 3278943368, 3278943369, 'DE', 'DEU', 'ألمانيا'),
(72169, 3278943370, 3278943370, 'FR', 'FRA', 'فرنسا'),
(72170, 3278943371, 3278943371, 'DE', 'DEU', 'ألمانيا'),
(72171, 3278943372, 3278943372, 'CH', 'CHE', 'سويسرا'),
(72172, 3278943373, 3278943374, 'GR', 'GRC', 'اليونان'),
(72173, 3278943375, 3278943375, 'ES', 'ESP', 'إسبانيا'),
(72174, 3278943376, 3278943376, 'NO', 'NOR', 'النرويج'),
(72175, 3278943377, 3278943377, 'IT', 'ITA', 'إيطاليا'),
(72176, 3278943378, 3278943378, 'DE', 'DEU', 'ألمانيا'),
(72177, 3278943379, 3278943379, 'CH', 'CHE', 'سويسرا'),
(72178, 3278943380, 3278943380, 'ES', 'ESP', 'إسبانيا'),
(72179, 3278943381, 3278943381, 'GB', 'GBR', 'المملكة المتحدة'),
(72180, 3278943382, 3278943382, 'ES', 'ESP', 'إسبانيا'),
(72181, 3278943383, 3278943383, 'PL', 'POL', 'بولندا'),
(72182, 3278943384, 3278943384, 'IT', 'ITA', 'إيطاليا'),
(72183, 3278943385, 3278943385, 'DE', 'DEU', 'ألمانيا'),
(72184, 3278943386, 3278943387, 'FR', 'FRA', 'فرنسا'),
(72185, 3278943388, 3278943388, 'ES', 'ESP', 'إسبانيا'),
(72186, 3278943389, 3278943389, 'BE', 'BEL', 'بلجيكا'),
(72187, 3278943390, 3278943390, 'ES', 'ESP', 'إسبانيا'),
(72188, 3278943391, 3278943391, 'DE', 'DEU', 'ألمانيا'),
(72189, 3278943392, 3278943392, 'PL', 'POL', 'بولندا'),
(72190, 3278943393, 3278943393, 'CH', 'CHE', 'سويسرا'),
(72191, 3278943394, 3278943394, 'FR', 'FRA', 'فرنسا'),
(72192, 3278943395, 3278943395, 'IT', 'ITA', 'إيطاليا'),
(72193, 3278943396, 3278943396, 'NL', 'NLD', 'هولندا'),
(72194, 3278943397, 3278943399, 'DE', 'DEU', 'ألمانيا'),
(72195, 3278943400, 3278943400, 'FR', 'FRA', 'فرنسا'),
(72196, 3278943401, 3278943401, 'DE', 'DEU', 'ألمانيا'),
(72197, 3278943402, 3278943402, 'FR', 'FRA', 'فرنسا'),
(72198, 3278943403, 3278943403, 'GB', 'GBR', 'المملكة المتحدة'),
(72199, 3278943404, 3278943404, 'DE', 'DEU', 'ألمانيا'),
(72200, 3278943405, 3278943405, 'GB', 'GBR', 'المملكة المتحدة'),
(72201, 3278943406, 3278943406, 'AT', 'AUT', 'النمسا'),
(72202, 3278943407, 3278943407, 'DE', 'DEU', 'ألمانيا'),
(72203, 3278943408, 3278943408, 'FR', 'FRA', 'فرنسا'),
(72204, 3278943409, 3278943409, 'IT', 'ITA', 'إيطاليا'),
(72205, 3278943410, 3278943410, 'NL', 'NLD', 'هولندا'),
(72206, 3278943411, 3278943411, 'ES', 'ESP', 'إسبانيا'),
(72207, 3278943412, 3278943412, 'GB', 'GBR', 'المملكة المتحدة'),
(72208, 3278943413, 3278943413, 'NL', 'NLD', 'هولندا'),
(72209, 3278943414, 3278943414, 'ES', 'ESP', 'إسبانيا'),
(72210, 3278943415, 3278943415, 'UA', 'UKR', 'أوكرانيا'),
(72211, 3278943416, 3278943416, 'NL', 'NLD', 'هولندا'),
(72212, 3278943417, 3278943417, 'DE', 'DEU', 'ألمانيا'),
(72213, 3278943418, 3278943418, 'GB', 'GBR', 'المملكة المتحدة'),
(72214, 3278943419, 3278943419, 'ES', 'ESP', 'إسبانيا'),
(72215, 3278943420, 3278943420, 'BE', 'BEL', 'بلجيكا'),
(72216, 3278943421, 3278943422, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(72217, 3278943423, 3278943423, 'IT', 'ITA', 'إيطاليا'),
(72218, 3278943424, 3278943424, 'DE', 'DEU', 'ألمانيا'),
(72219, 3278943425, 3278943425, 'GB', 'GBR', 'المملكة المتحدة'),
(72220, 3278943426, 3278943426, 'DE', 'DEU', 'ألمانيا'),
(72221, 3278943427, 3278943427, 'AT', 'AUT', 'النمسا'),
(72222, 3278943428, 3278943428, 'DE', 'DEU', 'ألمانيا'),
(72223, 3278943429, 3278943430, 'IT', 'ITA', 'إيطاليا'),
(72224, 3278943431, 3278943431, 'CH', 'CHE', 'سويسرا'),
(72225, 3278943432, 3278943432, 'DE', 'DEU', 'ألمانيا'),
(72226, 3278943433, 3278943433, 'GB', 'GBR', 'المملكة المتحدة'),
(72227, 3278943434, 3278943435, 'DE', 'DEU', 'ألمانيا'),
(72228, 3278943436, 3278943436, 'ES', 'ESP', 'إسبانيا'),
(72229, 3278943437, 3278943437, 'FR', 'FRA', 'فرنسا'),
(72230, 3278943438, 3278943438, 'DE', 'DEU', 'ألمانيا'),
(72231, 3278943439, 3278943439, 'SE', 'SWE', 'السويد'),
(72232, 3278943440, 3278943440, 'DK', 'DNK', 'الدنيمارك'),
(72233, 3278943441, 3278943441, 'IT', 'ITA', 'إيطاليا'),
(72234, 3278943442, 3278943442, 'FR', 'FRA', 'فرنسا'),
(72235, 3278943443, 3278943443, 'DE', 'DEU', 'ألمانيا'),
(72236, 3278943444, 3278943444, 'GB', 'GBR', 'المملكة المتحدة'),
(72237, 3278943445, 3278943445, 'DE', 'DEU', 'ألمانيا'),
(72238, 3278943446, 3278943446, 'CH', 'CHE', 'سويسرا'),
(72239, 3278943447, 3278943447, 'DE', 'DEU', 'ألمانيا'),
(72240, 3278943448, 3278943448, 'FR', 'FRA', 'فرنسا'),
(72241, 3278943449, 3278943449, 'DE', 'DEU', 'ألمانيا'),
(72242, 3278943450, 3278943450, 'CH', 'CHE', 'سويسرا'),
(72243, 3278943451, 3278943451, 'AT', 'AUT', 'النمسا'),
(72244, 3278943452, 3278943452, 'DE', 'DEU', 'ألمانيا'),
(72245, 3278943453, 3278943453, 'PT', 'PRT', 'البورتوغال'),
(72246, 3278943454, 3278943455, 'DE', 'DEU', 'ألمانيا'),
(72247, 3278943456, 3278943456, 'IT', 'ITA', 'إيطاليا'),
(72248, 3278943457, 3278943457, 'GB', 'GBR', 'المملكة المتحدة'),
(72249, 3278943458, 3278943459, 'DE', 'DEU', 'ألمانيا'),
(72250, 3278943460, 3278943460, 'FR', 'FRA', 'فرنسا'),
(72251, 3278943461, 3278943464, 'DE', 'DEU', 'ألمانيا'),
(72252, 3278943465, 3278943465, 'ES', 'ESP', 'إسبانيا'),
(72253, 3278943466, 3278943466, 'DE', 'DEU', 'ألمانيا'),
(72254, 3278943467, 3278943467, 'ES', 'ESP', 'إسبانيا'),
(72255, 3278943468, 3278943468, 'DE', 'DEU', 'ألمانيا'),
(72256, 3278943469, 3278943469, 'NL', 'NLD', 'هولندا'),
(72257, 3278943470, 3278943471, 'ES', 'ESP', 'إسبانيا'),
(72258, 3278943472, 3278943472, 'BE', 'BEL', 'بلجيكا'),
(72259, 3278943473, 3278943473, 'DE', 'DEU', 'ألمانيا'),
(72260, 3278943474, 3278943474, 'BE', 'BEL', 'بلجيكا'),
(72261, 3278943475, 3278943477, 'DE', 'DEU', 'ألمانيا'),
(72262, 3278943478, 3278943478, 'NL', 'NLD', 'هولندا'),
(72263, 3278943479, 3278943481, 'DE', 'DEU', 'ألمانيا'),
(72264, 3278943482, 3278943482, 'IT', 'ITA', 'إيطاليا'),
(72265, 3278943483, 3278943489, 'DE', 'DEU', 'ألمانيا'),
(72266, 3278943490, 3278943490, 'BE', 'BEL', 'بلجيكا'),
(72267, 3278943491, 3278943491, 'DE', 'DEU', 'ألمانيا'),
(72268, 3278943492, 3278943492, 'CH', 'CHE', 'سويسرا'),
(72269, 3278943493, 3278943494, 'DE', 'DEU', 'ألمانيا'),
(72270, 3278943495, 3278943495, 'FR', 'FRA', 'فرنسا'),
(72271, 3278943496, 3278943496, 'GB', 'GBR', 'المملكة المتحدة'),
(72272, 3278943497, 3278943497, 'AT', 'AUT', 'النمسا'),
(72273, 3278943498, 3278943499, 'DE', 'DEU', 'ألمانيا'),
(72274, 3278943500, 3278943500, 'IT', 'ITA', 'إيطاليا'),
(72275, 3278943501, 3278943501, 'FR', 'FRA', 'فرنسا'),
(72276, 3278943502, 3278943504, 'DE', 'DEU', 'ألمانيا'),
(72277, 3278943505, 3278943505, 'LI', 'LIE', 'ليختنشتاين'),
(72278, 3278943506, 3278943506, 'AT', 'AUT', 'النمسا'),
(72279, 3278943507, 3278943507, 'FR', 'FRA', 'فرنسا'),
(72280, 3278943508, 3278943509, 'IT', 'ITA', 'إيطاليا'),
(72281, 3278943510, 3278943510, 'DE', 'DEU', 'ألمانيا'),
(72282, 3278943511, 3278943512, 'IT', 'ITA', 'إيطاليا'),
(72283, 3278943513, 3278943513, 'ES', 'ESP', 'إسبانيا'),
(72284, 3278943514, 3278943514, 'BE', 'BEL', 'بلجيكا'),
(72285, 3278943515, 3278943515, 'DE', 'DEU', 'ألمانيا'),
(72286, 3278943516, 3278943517, 'ES', 'ESP', 'إسبانيا'),
(72287, 3278943518, 3278943518, 'FR', 'FRA', 'فرنسا'),
(72288, 3278943519, 3278943519, 'HU', 'HUN', 'هنغاريا'),
(72289, 3278943520, 3278943520, 'AT', 'AUT', 'النمسا'),
(72290, 3278943521, 3278943521, 'ES', 'ESP', 'إسبانيا'),
(72291, 3278943522, 3278943523, 'DE', 'DEU', 'ألمانيا'),
(72292, 3278943524, 3278943524, 'AT', 'AUT', 'النمسا'),
(72293, 3278943525, 3278943525, 'BE', 'BEL', 'بلجيكا'),
(72294, 3278943526, 3278943526, 'FR', 'FRA', 'فرنسا'),
(72295, 3278943527, 3278943527, 'DE', 'DEU', 'ألمانيا'),
(72296, 3278943528, 3278943528, 'CH', 'CHE', 'سويسرا'),
(72297, 3278943529, 3278943530, 'AT', 'AUT', 'النمسا'),
(72298, 3278943531, 3278943531, 'DE', 'DEU', 'ألمانيا'),
(72299, 3278943532, 3278943532, 'NL', 'NLD', 'هولندا'),
(72300, 3278943533, 3278943533, 'ES', 'ESP', 'إسبانيا'),
(72301, 3278943534, 3278943534, 'GB', 'GBR', 'المملكة المتحدة'),
(72302, 3278943535, 3278943535, 'BR', 'BRA', 'البرازيل'),
(72303, 3278943536, 3278943537, 'ES', 'ESP', 'إسبانيا'),
(72304, 3278943538, 3278943538, 'RE', 'REU', 'ريونيون'),
(72305, 3278943539, 3278943539, 'IT', 'ITA', 'إيطاليا'),
(72306, 3278943540, 3278943540, 'ES', 'ESP', 'إسبانيا'),
(72307, 3278943541, 3278943542, 'DE', 'DEU', 'ألمانيا'),
(72308, 3278943543, 3278943543, 'IT', 'ITA', 'إيطاليا'),
(72309, 3278943544, 3278943545, 'DE', 'DEU', 'ألمانيا'),
(72310, 3278943546, 3278943546, 'NL', 'NLD', 'هولندا'),
(72311, 3278943547, 3278943547, 'CH', 'CHE', 'سويسرا'),
(72312, 3278943548, 3278943548, 'GB', 'GBR', 'المملكة المتحدة'),
(72313, 3278943549, 3278943549, 'IL', 'ISR', 'إسرائيل'),
(72314, 3278943550, 3278943550, 'IT', 'ITA', 'إيطاليا'),
(72315, 3278943551, 3278943551, 'DE', 'DEU', 'ألمانيا'),
(72316, 3278943552, 3278943552, 'IT', 'ITA', 'إيطاليا'),
(72317, 3278943553, 3278943553, 'DE', 'DEU', 'ألمانيا'),
(72318, 3278943554, 3278943554, 'FR', 'FRA', 'فرنسا'),
(72319, 3278943555, 3278943555, 'DE', 'DEU', 'ألمانيا'),
(72320, 3278943556, 3278943556, 'FR', 'FRA', 'فرنسا'),
(72321, 3278943557, 3278943557, 'DE', 'DEU', 'ألمانيا'),
(72322, 3278943558, 3278943558, 'AT', 'AUT', 'النمسا'),
(72323, 3278943559, 3278943559, 'DE', 'DEU', 'ألمانيا'),
(72324, 3278943560, 3278943560, 'CH', 'CHE', 'سويسرا'),
(72325, 3278943561, 3278943561, 'FR', 'FRA', 'فرنسا'),
(72326, 3278943562, 3278943564, 'DE', 'DEU', 'ألمانيا'),
(72327, 3278943565, 3278943565, 'GB', 'GBR', 'المملكة المتحدة'),
(72328, 3278943566, 3278943566, 'BE', 'BEL', 'بلجيكا'),
(72329, 3278943567, 3278943567, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(72330, 3278943568, 3278943568, 'NL', 'NLD', 'هولندا'),
(72331, 3278943569, 3278943569, 'ES', 'ESP', 'إسبانيا'),
(72332, 3278943570, 3278943570, 'DE', 'DEU', 'ألمانيا'),
(72333, 3278943571, 3278943571, 'BE', 'BEL', 'بلجيكا'),
(72334, 3278943572, 3278943572, 'GB', 'GBR', 'المملكة المتحدة'),
(72335, 3278943573, 3278943573, 'DE', 'DEU', 'ألمانيا'),
(72336, 3278943574, 3278943574, 'DK', 'DNK', 'الدنيمارك'),
(72337, 3278943575, 3278943575, 'BE', 'BEL', 'بلجيكا'),
(72338, 3278943576, 3278943576, 'NL', 'NLD', 'هولندا'),
(72339, 3278943577, 3278943577, 'FR', 'FRA', 'فرنسا'),
(72340, 3278943578, 3278943578, 'DE', 'DEU', 'ألمانيا'),
(72341, 3278943579, 3278943579, 'BE', 'BEL', 'بلجيكا'),
(72342, 3278943580, 3278943580, 'IT', 'ITA', 'إيطاليا'),
(72343, 3278943581, 3278943581, 'CH', 'CHE', 'سويسرا'),
(72344, 3278943582, 3278943582, 'DE', 'DEU', 'ألمانيا'),
(72345, 3278943583, 3278943583, 'NL', 'NLD', 'هولندا'),
(72346, 3278943584, 3278943585, 'DE', 'DEU', 'ألمانيا'),
(72347, 3278943586, 3278943586, 'NL', 'NLD', 'هولندا'),
(72348, 3278943587, 3278943587, 'ES', 'ESP', 'إسبانيا'),
(72349, 3278943588, 3278943588, 'DE', 'DEU', 'ألمانيا'),
(72350, 3278943589, 3278943589, 'IT', 'ITA', 'إيطاليا'),
(72351, 3278943590, 3278943590, 'DE', 'DEU', 'ألمانيا'),
(72352, 3278943591, 3278943591, 'NL', 'NLD', 'هولندا'),
(72353, 3278943592, 3278943592, 'DE', 'DEU', 'ألمانيا'),
(72354, 3278943593, 3278943593, 'PL', 'POL', 'بولندا'),
(72355, 3278943594, 3278943594, 'ES', 'ESP', 'إسبانيا'),
(72356, 3278943595, 3278943595, 'GB', 'GBR', 'المملكة المتحدة'),
(72357, 3278943596, 3278943596, 'GR', 'GRC', 'اليونان'),
(72358, 3278943597, 3278943598, 'DE', 'DEU', 'ألمانيا'),
(72359, 3278943599, 3278943599, 'ES', 'ESP', 'إسبانيا'),
(72360, 3278943600, 3278943601, 'DE', 'DEU', 'ألمانيا'),
(72361, 3278943602, 3278943602, 'PL', 'POL', 'بولندا'),
(72362, 3278943603, 3278943603, 'FR', 'FRA', 'فرنسا'),
(72363, 3278943604, 3278943604, 'ES', 'ESP', 'إسبانيا'),
(72364, 3278943605, 3278943605, 'DE', 'DEU', 'ألمانيا'),
(72365, 3278943606, 3278943606, 'AT', 'AUT', 'النمسا'),
(72366, 3278943607, 3278943607, 'DE', 'DEU', 'ألمانيا'),
(72367, 3278943608, 3278943608, 'ES', 'ESP', 'إسبانيا'),
(72368, 3278943609, 3278943609, 'DE', 'DEU', 'ألمانيا'),
(72369, 3278943610, 3278943610, 'BE', 'BEL', 'بلجيكا'),
(72370, 3278943611, 3278943611, 'NL', 'NLD', 'هولندا'),
(72371, 3278943612, 3278943613, 'DE', 'DEU', 'ألمانيا'),
(72372, 3278943614, 3278943614, 'IT', 'ITA', 'إيطاليا'),
(72373, 3278943615, 3278943615, 'CH', 'CHE', 'سويسرا'),
(72374, 3278943616, 3278943616, 'DE', 'DEU', 'ألمانيا'),
(72375, 3278943617, 3278943617, 'ES', 'ESP', 'إسبانيا'),
(72376, 3278943618, 3278943619, 'DE', 'DEU', 'ألمانيا'),
(72377, 3278943620, 3278943620, 'IT', 'ITA', 'إيطاليا'),
(72378, 3278943621, 3278943621, 'CH', 'CHE', 'سويسرا'),
(72379, 3278943622, 3278943622, 'IT', 'ITA', 'إيطاليا'),
(72380, 3278943623, 3278943623, 'DK', 'DNK', 'الدنيمارك'),
(72381, 3278943624, 3278943624, 'PL', 'POL', 'بولندا'),
(72382, 3278943625, 3278943625, 'FR', 'FRA', 'فرنسا'),
(72383, 3278943626, 3278943628, 'DE', 'DEU', 'ألمانيا'),
(72384, 3278943629, 3278943630, 'FR', 'FRA', 'فرنسا'),
(72385, 3278943631, 3278943631, 'CH', 'CHE', 'سويسرا'),
(72386, 3278943632, 3278943632, 'DE', 'DEU', 'ألمانيا'),
(72387, 3278943633, 3278943633, 'GB', 'GBR', 'المملكة المتحدة'),
(72388, 3278943634, 3278943634, 'DE', 'DEU', 'ألمانيا'),
(72389, 3278943635, 3278943635, 'IT', 'ITA', 'إيطاليا'),
(72390, 3278943636, 3278943636, 'CH', 'CHE', 'سويسرا'),
(72391, 3278943637, 3278943638, 'IT', 'ITA', 'إيطاليا'),
(72392, 3278943639, 3278943639, 'HU', 'HUN', 'هنغاريا'),
(72393, 3278943640, 3278943641, 'DE', 'DEU', 'ألمانيا'),
(72394, 3278943642, 3278943642, 'FR', 'FRA', 'فرنسا'),
(72395, 3278943643, 3278943643, 'NL', 'NLD', 'هولندا'),
(72396, 3278943644, 3278943645, 'FR', 'FRA', 'فرنسا'),
(72397, 3278943646, 3278943646, 'IT', 'ITA', 'إيطاليا'),
(72398, 3278943647, 3278943647, 'DE', 'DEU', 'ألمانيا'),
(72399, 3278943648, 3278943648, 'DK', 'DNK', 'الدنيمارك'),
(72400, 3278943649, 3278943649, 'DE', 'DEU', 'ألمانيا'),
(72401, 3278943650, 3278943650, 'ES', 'ESP', 'إسبانيا'),
(72402, 3278943651, 3278943651, 'FR', 'FRA', 'فرنسا'),
(72403, 3278943652, 3278943653, 'IT', 'ITA', 'إيطاليا'),
(72404, 3278943654, 3278943654, 'BE', 'BEL', 'بلجيكا'),
(72405, 3278943655, 3278943655, 'FR', 'FRA', 'فرنسا'),
(72406, 3278943656, 3278943656, 'AT', 'AUT', 'النمسا'),
(72407, 3278943657, 3278943658, 'DE', 'DEU', 'ألمانيا'),
(72408, 3278943659, 3278943659, 'NL', 'NLD', 'هولندا'),
(72409, 3278943660, 3278943660, 'CY', 'CYP', 'قبرص'),
(72410, 3278943661, 3278943661, 'DE', 'DEU', 'ألمانيا'),
(72411, 3278943662, 3278943662, 'ES', 'ESP', 'إسبانيا'),
(72412, 3278943663, 3278943663, 'CH', 'CHE', 'سويسرا'),
(72413, 3278943664, 3278943666, 'ES', 'ESP', 'إسبانيا'),
(72414, 3278943667, 3278943667, 'IT', 'ITA', 'إيطاليا'),
(72415, 3278943668, 3278943669, 'DE', 'DEU', 'ألمانيا'),
(72416, 3278943670, 3278943670, 'IT', 'ITA', 'إيطاليا'),
(72417, 3278943671, 3278943672, 'DE', 'DEU', 'ألمانيا'),
(72418, 3278943673, 3278943673, 'ES', 'ESP', 'إسبانيا'),
(72419, 3278943674, 3278943675, 'DE', 'DEU', 'ألمانيا'),
(72420, 3278943676, 3278943676, 'LU', 'LUX', 'لوكسيمبورغ'),
(72421, 3278943677, 3278943677, 'IT', 'ITA', 'إيطاليا'),
(72422, 3278943678, 3278943678, 'BE', 'BEL', 'بلجيكا'),
(72423, 3278943679, 3278943679, 'FR', 'FRA', 'فرنسا'),
(72424, 3278943680, 3278943680, 'GB', 'GBR', 'المملكة المتحدة'),
(72425, 3278943681, 3278943681, 'CH', 'CHE', 'سويسرا'),
(72426, 3278943682, 3278943682, 'DE', 'DEU', 'ألمانيا'),
(72427, 3278943683, 3278943683, 'PT', 'PRT', 'البورتوغال'),
(72428, 3278943684, 3278943684, 'AD', 'AND', 'أندورا'),
(72429, 3278943685, 3278943686, 'DE', 'DEU', 'ألمانيا'),
(72430, 3278943687, 3278943687, 'CH', 'CHE', 'سويسرا'),
(72431, 3278943688, 3278943689, 'IT', 'ITA', 'إيطاليا'),
(72432, 3278943690, 3278943690, 'ES', 'ESP', 'إسبانيا'),
(72433, 3278943691, 3278943692, 'DE', 'DEU', 'ألمانيا'),
(72434, 3278943693, 3278943693, 'PL', 'POL', 'بولندا'),
(72435, 3278943694, 3278943694, 'GB', 'GBR', 'المملكة المتحدة'),
(72436, 3278943695, 3278943695, 'DE', 'DEU', 'ألمانيا'),
(72437, 3278943696, 3278943696, 'GB', 'GBR', 'المملكة المتحدة'),
(72438, 3278943697, 3278943697, 'AT', 'AUT', 'النمسا'),
(72439, 3278943698, 3278943698, 'IT', 'ITA', 'إيطاليا'),
(72440, 3278943699, 3278943699, 'FR', 'FRA', 'فرنسا'),
(72441, 3278943700, 3278943700, 'CH', 'CHE', 'سويسرا'),
(72442, 3278943701, 3278943701, 'AT', 'AUT', 'النمسا'),
(72443, 3278943702, 3278943702, 'FR', 'FRA', 'فرنسا'),
(72444, 3278943703, 3278943703, 'PL', 'POL', 'بولندا'),
(72445, 3278943704, 3278943705, 'DE', 'DEU', 'ألمانيا'),
(72446, 3278943706, 3278943706, 'ES', 'ESP', 'إسبانيا'),
(72447, 3278943707, 3278943707, 'CH', 'CHE', 'سويسرا'),
(72448, 3278943708, 3278943710, 'DE', 'DEU', 'ألمانيا'),
(72449, 3278943711, 3278943711, 'IT', 'ITA', 'إيطاليا'),
(72450, 3278943712, 3278943713, 'DE', 'DEU', 'ألمانيا'),
(72451, 3278943714, 3278943714, 'ES', 'ESP', 'إسبانيا'),
(72452, 3278943715, 3278943715, 'DE', 'DEU', 'ألمانيا'),
(72453, 3278943716, 3278943716, 'ES', 'ESP', 'إسبانيا'),
(72454, 3278943717, 3278943719, 'DE', 'DEU', 'ألمانيا'),
(72455, 3278943720, 3278943720, 'CH', 'CHE', 'سويسرا'),
(72456, 3278943721, 3278943726, 'DE', 'DEU', 'ألمانيا'),
(72457, 3278943727, 3278943727, 'PL', 'POL', 'بولندا'),
(72458, 3278943728, 3278943729, 'DE', 'DEU', 'ألمانيا'),
(72459, 3278943730, 3278943730, 'FR', 'FRA', 'فرنسا'),
(72460, 3278943731, 3278943731, 'DK', 'DNK', 'الدنيمارك'),
(72461, 3278943732, 3278943733, 'CH', 'CHE', 'سويسرا'),
(72462, 3278943734, 3278943734, 'DE', 'DEU', 'ألمانيا'),
(72463, 3278943735, 3278943735, 'AD', 'AND', 'أندورا'),
(72464, 3278943736, 3278943736, 'DE', 'DEU', 'ألمانيا'),
(72465, 3278943737, 3278943737, 'ES', 'ESP', 'إسبانيا'),
(72466, 3278943738, 3278943740, 'DE', 'DEU', 'ألمانيا'),
(72467, 3278943741, 3278943741, 'PT', 'PRT', 'البورتوغال'),
(72468, 3278943742, 3278943742, 'IL', 'ISR', 'إسرائيل'),
(72469, 3278943743, 3278943745, 'DE', 'DEU', 'ألمانيا'),
(72470, 3278943746, 3278943746, 'CH', 'CHE', 'سويسرا'),
(72471, 3278943747, 3278943747, 'DE', 'DEU', 'ألمانيا'),
(72472, 3278943748, 3278943749, 'ES', 'ESP', 'إسبانيا'),
(72473, 3278943750, 3278943751, 'DE', 'DEU', 'ألمانيا'),
(72474, 3278943752, 3278943752, 'GR', 'GRC', 'اليونان'),
(72475, 3278943753, 3278943753, 'DE', 'DEU', 'ألمانيا'),
(72476, 3278943754, 3278943754, 'FR', 'FRA', 'فرنسا'),
(72477, 3278943755, 3278943755, 'SL', 'SLE', 'سيراليون'),
(72478, 3278943756, 3278943756, 'DE', 'DEU', 'ألمانيا'),
(72479, 3278943757, 3278943757, 'FR', 'FRA', 'فرنسا'),
(72480, 3278943758, 3278943758, 'DE', 'DEU', 'ألمانيا'),
(72481, 3278943759, 3278943759, 'NL', 'NLD', 'هولندا'),
(72482, 3278943760, 3278943761, 'DE', 'DEU', 'ألمانيا'),
(72483, 3278943762, 3278943762, 'CY', 'CYP', 'قبرص'),
(72484, 3278943763, 3278943763, 'DE', 'DEU', 'ألمانيا'),
(72485, 3278943764, 3278943764, 'FR', 'FRA', 'فرنسا'),
(72486, 3278943765, 3278943765, 'CH', 'CHE', 'سويسرا'),
(72487, 3278943766, 3278943766, 'BE', 'BEL', 'بلجيكا'),
(72488, 3278943767, 3278943767, 'ES', 'ESP', 'إسبانيا'),
(72489, 3278943768, 3278943768, 'DE', 'DEU', 'ألمانيا'),
(72490, 3278943769, 3278943769, 'CZ', 'CZE', 'التشيك'),
(72491, 3278943770, 3278943770, 'FR', 'FRA', 'فرنسا'),
(72492, 3278943771, 3278943771, 'CH', 'CHE', 'سويسرا'),
(72493, 3278943772, 3278943772, 'ES', 'ESP', 'إسبانيا'),
(72494, 3278943773, 3278943773, 'IT', 'ITA', 'إيطاليا'),
(72495, 3278943774, 3278943774, 'DE', 'DEU', 'ألمانيا'),
(72496, 3278943775, 3278943776, 'PT', 'PRT', 'البورتوغال'),
(72497, 3278943777, 3278943777, 'FR', 'FRA', 'فرنسا'),
(72498, 3278943778, 3278943778, 'CH', 'CHE', 'سويسرا'),
(72499, 3278943779, 3278943780, 'DE', 'DEU', 'ألمانيا'),
(72500, 3278943781, 3278943781, 'GB', 'GBR', 'المملكة المتحدة'),
(72501, 3278943782, 3278943782, 'IT', 'ITA', 'إيطاليا'),
(72502, 3278943783, 3278943786, 'DE', 'DEU', 'ألمانيا'),
(72503, 3278943787, 3278943787, 'IT', 'ITA', 'إيطاليا'),
(72504, 3278943788, 3278943788, 'DE', 'DEU', 'ألمانيا'),
(72505, 3278943789, 3278943789, 'ES', 'ESP', 'إسبانيا'),
(72506, 3278943790, 3278943790, 'DE', 'DEU', 'ألمانيا'),
(72507, 3278943791, 3278943791, 'IT', 'ITA', 'إيطاليا'),
(72508, 3278943792, 3278943792, 'FR', 'FRA', 'فرنسا'),
(72509, 3278943793, 3278943793, 'IT', 'ITA', 'إيطاليا'),
(72510, 3278943794, 3278943794, 'HU', 'HUN', 'هنغاريا'),
(72511, 3278943795, 3278943796, 'DE', 'DEU', 'ألمانيا'),
(72512, 3278943797, 3278943797, 'ES', 'ESP', 'إسبانيا'),
(72513, 3278943798, 3278943798, 'DE', 'DEU', 'ألمانيا'),
(72514, 3278943799, 3278943799, 'IE', 'IRL', 'إيرلندا'),
(72515, 3278943800, 3278943800, 'DE', 'DEU', 'ألمانيا'),
(72516, 3278943801, 3278943801, 'LU', 'LUX', 'لوكسيمبورغ'),
(72517, 3278943802, 3278943802, 'DE', 'DEU', 'ألمانيا'),
(72518, 3278943803, 3278943803, 'GB', 'GBR', 'المملكة المتحدة'),
(72519, 3278943804, 3278943804, 'DE', 'DEU', 'ألمانيا'),
(72520, 3278943805, 3278943805, 'DK', 'DNK', 'الدنيمارك'),
(72521, 3278943806, 3278943806, 'ES', 'ESP', 'إسبانيا'),
(72522, 3278943807, 3278943807, 'DE', 'DEU', 'ألمانيا'),
(72523, 3278943808, 3278943808, 'IT', 'ITA', 'إيطاليا'),
(72524, 3278943809, 3278943809, 'FR', 'FRA', 'فرنسا'),
(72525, 3278943810, 3278943810, 'DE', 'DEU', 'ألمانيا'),
(72526, 3278943811, 3278943811, 'GR', 'GRC', 'اليونان'),
(72527, 3278943812, 3278943812, 'IT', 'ITA', 'إيطاليا'),
(72528, 3278943813, 3278943813, 'IN', 'IND', 'الهند'),
(72529, 3278943814, 3278943814, 'ES', 'ESP', 'إسبانيا'),
(72530, 3278943815, 3278943815, 'MA', 'MAR', 'المغرب'),
(72531, 3278943816, 3278943816, 'GB', 'GBR', 'المملكة المتحدة'),
(72532, 3278943817, 3278943817, 'FR', 'FRA', 'فرنسا'),
(72533, 3278943818, 3278943818, 'DE', 'DEU', 'ألمانيا'),
(72534, 3278943819, 3278943819, 'AT', 'AUT', 'النمسا'),
(72535, 3278943820, 3278943820, 'DE', 'DEU', 'ألمانيا'),
(72536, 3278943821, 3278943821, 'SM', 'SMR', 'سان مارينو'),
(72537, 3278943822, 3278943822, 'PL', 'POL', 'بولندا'),
(72538, 3278943823, 3278943823, 'DE', 'DEU', 'ألمانيا'),
(72539, 3278943824, 3278943824, 'CH', 'CHE', 'سويسرا'),
(72540, 3278943825, 3278943826, 'DE', 'DEU', 'ألمانيا'),
(72541, 3278943827, 3278943827, 'AT', 'AUT', 'النمسا'),
(72542, 3278943828, 3278943828, 'ES', 'ESP', 'إسبانيا'),
(72543, 3278943829, 3278943829, 'CH', 'CHE', 'سويسرا'),
(72544, 3278943830, 3278943830, 'ES', 'ESP', 'إسبانيا'),
(72545, 3278943831, 3278943831, 'US', 'USA', 'الولايات المتحدة'),
(72546, 3278943832, 3278943832, 'BE', 'BEL', 'بلجيكا'),
(72547, 3278943833, 3278943833, 'IT', 'ITA', 'إيطاليا'),
(72548, 3278943834, 3278943835, 'GB', 'GBR', 'المملكة المتحدة'),
(72549, 3278943836, 3278943836, 'DE', 'DEU', 'ألمانيا'),
(72550, 3278943837, 3278943837, 'ES', 'ESP', 'إسبانيا'),
(72551, 3278943838, 3278943838, 'DE', 'DEU', 'ألمانيا'),
(72552, 3278943839, 3278943839, 'IT', 'ITA', 'إيطاليا'),
(72553, 3278943840, 3278943845, 'DE', 'DEU', 'ألمانيا'),
(72554, 3278943846, 3278943846, 'GB', 'GBR', 'المملكة المتحدة'),
(72555, 3278943847, 3278943847, 'FR', 'FRA', 'فرنسا'),
(72556, 3278943848, 3278943848, 'IT', 'ITA', 'إيطاليا'),
(72557, 3278943849, 3278943849, 'DE', 'DEU', 'ألمانيا'),
(72558, 3278943850, 3278943851, 'FR', 'FRA', 'فرنسا'),
(72559, 3278943852, 3278943852, 'BE', 'BEL', 'بلجيكا'),
(72560, 3278943853, 3278943853, 'GB', 'GBR', 'المملكة المتحدة'),
(72561, 3278943854, 3278943854, 'ES', 'ESP', 'إسبانيا'),
(72562, 3278943855, 3278943855, 'BE', 'BEL', 'بلجيكا'),
(72563, 3278943856, 3278943856, 'DE', 'DEU', 'ألمانيا'),
(72564, 3278943857, 3278943857, 'PL', 'POL', 'بولندا'),
(72565, 3278943858, 3278943858, 'NL', 'NLD', 'هولندا'),
(72566, 3278943859, 3278943859, 'DE', 'DEU', 'ألمانيا'),
(72567, 3278943860, 3278943860, 'FR', 'FRA', 'فرنسا'),
(72568, 3278943861, 3278943862, 'DE', 'DEU', 'ألمانيا'),
(72569, 3278943863, 3278943863, 'IT', 'ITA', 'إيطاليا'),
(72570, 3278943864, 3278943864, 'DK', 'DNK', 'الدنيمارك'),
(72571, 3278943865, 3278943865, 'GB', 'GBR', 'المملكة المتحدة'),
(72572, 3278943866, 3278943866, 'IT', 'ITA', 'إيطاليا'),
(72573, 3278943867, 3278943867, 'ES', 'ESP', 'إسبانيا'),
(72574, 3278943868, 3278943868, 'IT', 'ITA', 'إيطاليا'),
(72575, 3278943869, 3278943869, 'IE', 'IRL', 'إيرلندا'),
(72576, 3278943870, 3278943870, 'NL', 'NLD', 'هولندا'),
(72577, 3278943871, 3278943871, 'FR', 'FRA', 'فرنسا'),
(72578, 3278943872, 3278943872, 'DE', 'DEU', 'ألمانيا'),
(72579, 3278943873, 3278943873, 'IT', 'ITA', 'إيطاليا'),
(72580, 3278943874, 3278943874, 'CH', 'CHE', 'سويسرا'),
(72581, 3278943875, 3278943875, 'IL', 'ISR', 'إسرائيل'),
(72582, 3278943876, 3278943881, 'DE', 'DEU', 'ألمانيا'),
(72583, 3278943882, 3278943882, 'PL', 'POL', 'بولندا'),
(72584, 3278943883, 3278943883, 'CH', 'CHE', 'سويسرا'),
(72585, 3278943884, 3278943884, 'DE', 'DEU', 'ألمانيا'),
(72586, 3278943885, 3278943885, 'IT', 'ITA', 'إيطاليا'),
(72587, 3278943886, 3278943888, 'DE', 'DEU', 'ألمانيا'),
(72588, 3278943889, 3278943889, 'BE', 'BEL', 'بلجيكا'),
(72589, 3278943890, 3278943890, 'NL', 'NLD', 'هولندا'),
(72590, 3278943891, 3278943891, 'ES', 'ESP', 'إسبانيا'),
(72591, 3278943892, 3278943892, 'BE', 'BEL', 'بلجيكا'),
(72592, 3278943893, 3278943893, 'DE', 'DEU', 'ألمانيا'),
(72593, 3278943894, 3278943894, 'IT', 'ITA', 'إيطاليا'),
(72594, 3278943895, 3278943895, 'DE', 'DEU', 'ألمانيا'),
(72595, 3278943896, 3278943896, 'PL', 'POL', 'بولندا'),
(72596, 3278943897, 3278943897, 'ES', 'ESP', 'إسبانيا'),
(72597, 3278943898, 3278943898, 'IT', 'ITA', 'إيطاليا'),
(72598, 3278943899, 3278943899, 'GB', 'GBR', 'المملكة المتحدة'),
(72599, 3278943900, 3278943900, 'ES', 'ESP', 'إسبانيا'),
(72600, 3278943901, 3278943901, 'DE', 'DEU', 'ألمانيا'),
(72601, 3278943902, 3278943902, 'GB', 'GBR', 'المملكة المتحدة'),
(72602, 3278943903, 3278943903, 'IT', 'ITA', 'إيطاليا'),
(72603, 3278943904, 3278943904, 'DE', 'DEU', 'ألمانيا'),
(72604, 3278943905, 3278943905, 'FR', 'FRA', 'فرنسا'),
(72605, 3278943906, 3278943907, 'IT', 'ITA', 'إيطاليا'),
(72606, 3278943908, 3278943908, 'GB', 'GBR', 'المملكة المتحدة'),
(72607, 3278943909, 3278943909, 'HU', 'HUN', 'هنغاريا'),
(72608, 3278943910, 3278943910, 'FR', 'FRA', 'فرنسا'),
(72609, 3278943911, 3278943911, 'DE', 'DEU', 'ألمانيا'),
(72610, 3278943912, 3278943913, 'IT', 'ITA', 'إيطاليا'),
(72611, 3278943914, 3278943914, 'DE', 'DEU', 'ألمانيا'),
(72612, 3278943915, 3278943915, 'PL', 'POL', 'بولندا'),
(72613, 3278943916, 3278943916, 'IT', 'ITA', 'إيطاليا'),
(72614, 3278943917, 3278943917, 'FR', 'FRA', 'فرنسا'),
(72615, 3278943918, 3278943918, 'ES', 'ESP', 'إسبانيا'),
(72616, 3278943919, 3278943920, 'FR', 'FRA', 'فرنسا'),
(72617, 3278943921, 3278943921, 'DE', 'DEU', 'ألمانيا'),
(72618, 3278943922, 3278943922, 'ES', 'ESP', 'إسبانيا'),
(72619, 3278943923, 3278943923, 'DE', 'DEU', 'ألمانيا'),
(72620, 3278943924, 3278943924, 'IT', 'ITA', 'إيطاليا'),
(72621, 3278943925, 3278943926, 'ES', 'ESP', 'إسبانيا'),
(72622, 3278943927, 3278943927, 'GB', 'GBR', 'المملكة المتحدة'),
(72623, 3278943928, 3278943928, 'DE', 'DEU', 'ألمانيا'),
(72624, 3278943929, 3278943929, 'PT', 'PRT', 'البورتوغال'),
(72625, 3278943930, 3278943930, 'IT', 'ITA', 'إيطاليا'),
(72626, 3278943931, 3278943932, 'DE', 'DEU', 'ألمانيا'),
(72627, 3278943933, 3278943933, 'ES', 'ESP', 'إسبانيا'),
(72628, 3278943934, 3278943934, 'DE', 'DEU', 'ألمانيا'),
(72629, 3278943935, 3278943935, 'GR', 'GRC', 'اليونان'),
(72630, 3278943936, 3278943939, 'DE', 'DEU', 'ألمانيا'),
(72631, 3278943940, 3278943940, 'DK', 'DNK', 'الدنيمارك'),
(72632, 3278943941, 3278943941, 'GB', 'GBR', 'المملكة المتحدة'),
(72633, 3278943942, 3278943942, 'NL', 'NLD', 'هولندا'),
(72634, 3278943943, 3278943943, 'AT', 'AUT', 'النمسا'),
(72635, 3278943944, 3278943944, 'IT', 'ITA', 'إيطاليا'),
(72636, 3278943945, 3278943945, 'NL', 'NLD', 'هولندا'),
(72637, 3278943946, 3278943946, 'LU', 'LUX', 'لوكسيمبورغ'),
(72638, 3278943947, 3278943947, 'DE', 'DEU', 'ألمانيا'),
(72639, 3278943948, 3278943948, 'ES', 'ESP', 'إسبانيا'),
(72640, 3278943949, 3278943949, 'DE', 'DEU', 'ألمانيا'),
(72641, 3278943950, 3278943950, 'BE', 'BEL', 'بلجيكا'),
(72642, 3278943951, 3278943951, 'LU', 'LUX', 'لوكسيمبورغ'),
(72643, 3278943952, 3278943953, 'DE', 'DEU', 'ألمانيا'),
(72644, 3278943954, 3278943954, 'FR', 'FRA', 'فرنسا'),
(72645, 3278943955, 3278943956, 'DE', 'DEU', 'ألمانيا'),
(72646, 3278943957, 3278943957, 'GB', 'GBR', 'المملكة المتحدة'),
(72647, 3278943958, 3278943958, 'DK', 'DNK', 'الدنيمارك'),
(72648, 3278943959, 3278943959, 'DE', 'DEU', 'ألمانيا'),
(72649, 3278943960, 3278943960, 'FR', 'FRA', 'فرنسا'),
(72650, 3278943961, 3278943964, 'DE', 'DEU', 'ألمانيا'),
(72651, 3278943965, 3278943965, 'CH', 'CHE', 'سويسرا'),
(72652, 3278943966, 3278943967, 'DE', 'DEU', 'ألمانيا'),
(72653, 3278943968, 3278943968, 'ES', 'ESP', 'إسبانيا'),
(72654, 3278943969, 3278943969, 'PL', 'POL', 'بولندا'),
(72655, 3278943970, 3278943970, 'ES', 'ESP', 'إسبانيا'),
(72656, 3278943971, 3278943971, 'BE', 'BEL', 'بلجيكا'),
(72657, 3278943972, 3278943972, 'IT', 'ITA', 'إيطاليا'),
(72658, 3278943973, 3278943973, 'DE', 'DEU', 'ألمانيا'),
(72659, 3278943974, 3278943974, 'GR', 'GRC', 'اليونان'),
(72660, 3278943975, 3278943975, 'CH', 'CHE', 'سويسرا'),
(72661, 3278943976, 3278943976, 'DE', 'DEU', 'ألمانيا'),
(72662, 3278943977, 3278943977, 'DK', 'DNK', 'الدنيمارك'),
(72663, 3278943978, 3278943978, 'DE', 'DEU', 'ألمانيا'),
(72664, 3278943979, 3278943979, 'ES', 'ESP', 'إسبانيا'),
(72665, 3278943980, 3278943980, 'GB', 'GBR', 'المملكة المتحدة'),
(72666, 3278943981, 3278943981, 'DE', 'DEU', 'ألمانيا'),
(72667, 3278943982, 3278943982, 'ES', 'ESP', 'إسبانيا'),
(72668, 3278943983, 3278943983, 'DE', 'DEU', 'ألمانيا'),
(72669, 3278943984, 3278943984, 'AT', 'AUT', 'النمسا'),
(72670, 3278943985, 3278943985, 'NL', 'NLD', 'هولندا'),
(72671, 3278943986, 3278943987, 'IT', 'ITA', 'إيطاليا'),
(72672, 3278943988, 3278943988, 'ES', 'ESP', 'إسبانيا'),
(72673, 3278943989, 3278943990, 'DE', 'DEU', 'ألمانيا'),
(72674, 3278943991, 3278943991, 'NL', 'NLD', 'هولندا'),
(72675, 3278943992, 3278943992, 'IT', 'ITA', 'إيطاليا'),
(72676, 3278943993, 3278943993, 'AT', 'AUT', 'النمسا'),
(72677, 3278943994, 3278943995, 'DE', 'DEU', 'ألمانيا'),
(72678, 3278943996, 3278943997, 'CH', 'CHE', 'سويسرا'),
(72679, 3278943998, 3278943998, 'FR', 'FRA', 'فرنسا'),
(72680, 3278943999, 3278944001, 'DE', 'DEU', 'ألمانيا'),
(72681, 3278944002, 3278944002, 'GB', 'GBR', 'المملكة المتحدة'),
(72682, 3278944003, 3278944003, 'LU', 'LUX', 'لوكسيمبورغ'),
(72683, 3278944004, 3278944004, 'PT', 'PRT', 'البورتوغال'),
(72684, 3278944005, 3278944006, 'DE', 'DEU', 'ألمانيا'),
(72685, 3278944007, 3278944007, 'NL', 'NLD', 'هولندا'),
(72686, 3278944008, 3278944008, 'IT', 'ITA', 'إيطاليا'),
(72687, 3278944009, 3278944009, 'CH', 'CHE', 'سويسرا'),
(72688, 3278944010, 3278944010, 'NL', 'NLD', 'هولندا'),
(72689, 3278944011, 3278944012, 'DE', 'DEU', 'ألمانيا'),
(72690, 3278944013, 3278944013, 'DK', 'DNK', 'الدنيمارك'),
(72691, 3278944014, 3278944014, 'IT', 'ITA', 'إيطاليا'),
(72692, 3278944015, 3278944015, 'IS', 'ISL', 'أيسلندا'),
(72693, 3278944016, 3278944016, 'PL', 'POL', 'بولندا'),
(72694, 3278944017, 3278944017, 'DE', 'DEU', 'ألمانيا'),
(72695, 3278944018, 3278944018, 'BE', 'BEL', 'بلجيكا'),
(72696, 3278944019, 3278944019, 'FR', 'FRA', 'فرنسا'),
(72697, 3278944020, 3278944020, 'DE', 'DEU', 'ألمانيا'),
(72698, 3278944021, 3278944021, 'IT', 'ITA', 'إيطاليا'),
(72699, 3278944022, 3278944022, 'FR', 'FRA', 'فرنسا'),
(72700, 3278944023, 3278944023, 'AT', 'AUT', 'النمسا'),
(72701, 3278944024, 3278944025, 'CH', 'CHE', 'سويسرا'),
(72702, 3278944026, 3278944027, 'FR', 'FRA', 'فرنسا'),
(72703, 3278944028, 3278944028, 'DE', 'DEU', 'ألمانيا'),
(72704, 3278944029, 3278944029, 'IT', 'ITA', 'إيطاليا'),
(72705, 3278944030, 3278944030, 'DE', 'DEU', 'ألمانيا'),
(72706, 3278944031, 3278944031, 'FR', 'FRA', 'فرنسا'),
(72707, 3278944032, 3278944033, 'DE', 'DEU', 'ألمانيا'),
(72708, 3278944034, 3278944034, 'GR', 'GRC', 'اليونان'),
(72709, 3278944035, 3278944035, 'FR', 'FRA', 'فرنسا'),
(72710, 3278944036, 3278944036, 'US', 'USA', 'الولايات المتحدة'),
(72711, 3278944037, 3278944037, 'FR', 'FRA', 'فرنسا'),
(72712, 3278944038, 3278944038, 'GB', 'GBR', 'المملكة المتحدة'),
(72713, 3278944039, 3278944039, 'ES', 'ESP', 'إسبانيا'),
(72714, 3278944040, 3278944040, 'FR', 'FRA', 'فرنسا'),
(72715, 3278944041, 3278944041, 'DE', 'DEU', 'ألمانيا'),
(72716, 3278944042, 3278944042, 'FR', 'FRA', 'فرنسا'),
(72717, 3278944043, 3278944043, 'DE', 'DEU', 'ألمانيا'),
(72718, 3278944044, 3278944045, 'FR', 'FRA', 'فرنسا'),
(72719, 3278944046, 3278944046, 'NL', 'NLD', 'هولندا'),
(72720, 3278944047, 3278944047, 'GB', 'GBR', 'المملكة المتحدة'),
(72721, 3278944048, 3278944048, 'BE', 'BEL', 'بلجيكا'),
(72722, 3278944049, 3278944049, 'IT', 'ITA', 'إيطاليا'),
(72723, 3278944050, 3278944050, 'DE', 'DEU', 'ألمانيا'),
(72724, 3278944051, 3278944051, 'BE', 'BEL', 'بلجيكا'),
(72725, 3278944052, 3278944052, 'AT', 'AUT', 'النمسا'),
(72726, 3278944053, 3278944053, 'IT', 'ITA', 'إيطاليا'),
(72727, 3278944054, 3278944054, 'DE', 'DEU', 'ألمانيا'),
(72728, 3278944055, 3278944055, 'IT', 'ITA', 'إيطاليا'),
(72729, 3278944056, 3278944058, 'DE', 'DEU', 'ألمانيا'),
(72730, 3278944059, 3278944059, 'ES', 'ESP', 'إسبانيا'),
(72731, 3278944060, 3278944060, 'BE', 'BEL', 'بلجيكا'),
(72732, 3278944061, 3278944061, 'FR', 'FRA', 'فرنسا'),
(72733, 3278944062, 3278944063, 'DE', 'DEU', 'ألمانيا'),
(72734, 3278944064, 3278944064, 'FR', 'FRA', 'فرنسا'),
(72735, 3278944065, 3278944065, 'IT', 'ITA', 'إيطاليا'),
(72736, 3278944066, 3278944066, 'GB', 'GBR', 'المملكة المتحدة'),
(72737, 3278944067, 3278944067, 'DE', 'DEU', 'ألمانيا'),
(72738, 3278944068, 3278944068, 'ES', 'ESP', 'إسبانيا'),
(72739, 3278944069, 3278944069, 'PL', 'POL', 'بولندا'),
(72740, 3278944070, 3278944070, 'DE', 'DEU', 'ألمانيا'),
(72741, 3278944071, 3278944071, 'DK', 'DNK', 'الدنيمارك'),
(72742, 3278944072, 3278944072, 'AT', 'AUT', 'النمسا'),
(72743, 3278944073, 3278944073, 'FR', 'FRA', 'فرنسا'),
(72744, 3278944074, 3278944075, 'ES', 'ESP', 'إسبانيا'),
(72745, 3278944076, 3278944076, 'DE', 'DEU', 'ألمانيا'),
(72746, 3278944077, 3278944077, 'GB', 'GBR', 'المملكة المتحدة'),
(72747, 3278944078, 3278944078, 'DE', 'DEU', 'ألمانيا'),
(72748, 3278944079, 3278944079, 'GB', 'GBR', 'المملكة المتحدة'),
(72749, 3278944080, 3278944080, 'DE', 'DEU', 'ألمانيا'),
(72750, 3278944081, 3278944081, 'GB', 'GBR', 'المملكة المتحدة'),
(72751, 3278944082, 3278944082, 'IT', 'ITA', 'إيطاليا'),
(72752, 3278944083, 3278944084, 'ES', 'ESP', 'إسبانيا'),
(72753, 3278944085, 3278944085, 'PT', 'PRT', 'البورتوغال'),
(72754, 3278944086, 3278944086, 'NL', 'NLD', 'هولندا'),
(72755, 3278944087, 3278944087, 'CH', 'CHE', 'سويسرا'),
(72756, 3278944088, 3278944088, 'IT', 'ITA', 'إيطاليا'),
(72757, 3278944089, 3278944089, 'DE', 'DEU', 'ألمانيا'),
(72758, 3278944090, 3278944090, 'IT', 'ITA', 'إيطاليا'),
(72759, 3278944091, 3278944091, 'MA', 'MAR', 'المغرب'),
(72760, 3278944092, 3278944092, 'GR', 'GRC', 'اليونان'),
(72761, 3278944093, 3278944094, 'DE', 'DEU', 'ألمانيا'),
(72762, 3278944095, 3278944095, 'AT', 'AUT', 'النمسا'),
(72763, 3278944096, 3278944096, 'GB', 'GBR', 'المملكة المتحدة'),
(72764, 3278944097, 3278944097, 'DE', 'DEU', 'ألمانيا'),
(72765, 3278944098, 3278944098, 'SE', 'SWE', 'السويد'),
(72766, 3278944099, 3278944099, 'GB', 'GBR', 'المملكة المتحدة'),
(72767, 3278944100, 3278944102, 'DE', 'DEU', 'ألمانيا'),
(72768, 3278944103, 3278944104, 'IT', 'ITA', 'إيطاليا'),
(72769, 3278944105, 3278944105, 'FR', 'FRA', 'فرنسا'),
(72770, 3278944106, 3278944106, 'AT', 'AUT', 'النمسا'),
(72771, 3278944107, 3278944108, 'DE', 'DEU', 'ألمانيا'),
(72772, 3278944109, 3278944109, 'ES', 'ESP', 'إسبانيا'),
(72773, 3278944110, 3278944111, 'DE', 'DEU', 'ألمانيا'),
(72774, 3278944112, 3278944112, 'NL', 'NLD', 'هولندا'),
(72775, 3278944113, 3278944113, 'DE', 'DEU', 'ألمانيا'),
(72776, 3278944114, 3278944114, 'IT', 'ITA', 'إيطاليا'),
(72777, 3278944115, 3278944116, 'ES', 'ESP', 'إسبانيا'),
(72778, 3278944117, 3278944118, 'IT', 'ITA', 'إيطاليا'),
(72779, 3278944119, 3278944119, 'ES', 'ESP', 'إسبانيا'),
(72780, 3278944120, 3278944121, 'DE', 'DEU', 'ألمانيا'),
(72781, 3278944122, 3278944122, 'FR', 'FRA', 'فرنسا'),
(72782, 3278944123, 3278944123, 'IT', 'ITA', 'إيطاليا'),
(72783, 3278944124, 3278944124, 'DE', 'DEU', 'ألمانيا'),
(72784, 3278944125, 3278944125, 'SE', 'SWE', 'السويد'),
(72785, 3278944126, 3278944126, 'ES', 'ESP', 'إسبانيا'),
(72786, 3278944127, 3278944127, 'IT', 'ITA', 'إيطاليا'),
(72787, 3278944128, 3278944128, 'PT', 'PRT', 'البورتوغال'),
(72788, 3278944129, 3278944129, 'BE', 'BEL', 'بلجيكا'),
(72789, 3278944130, 3278944130, 'DE', 'DEU', 'ألمانيا'),
(72790, 3278944131, 3278944131, 'FR', 'FRA', 'فرنسا'),
(72791, 3278944132, 3278944132, 'IE', 'IRL', 'إيرلندا'),
(72792, 3278944133, 3278944133, 'IT', 'ITA', 'إيطاليا'),
(72793, 3278944134, 3278944134, 'ES', 'ESP', 'إسبانيا'),
(72794, 3278944135, 3278944135, 'NL', 'NLD', 'هولندا'),
(72795, 3278944136, 3278944137, 'DE', 'DEU', 'ألمانيا'),
(72796, 3278944138, 3278944138, 'GB', 'GBR', 'المملكة المتحدة'),
(72797, 3278944139, 3278944139, 'FR', 'FRA', 'فرنسا'),
(72798, 3278944140, 3278944140, 'PT', 'PRT', 'البورتوغال'),
(72799, 3278944141, 3278944141, 'FR', 'FRA', 'فرنسا'),
(72800, 3278944142, 3278944142, 'GB', 'GBR', 'المملكة المتحدة'),
(72801, 3278944143, 3278944143, 'AT', 'AUT', 'النمسا'),
(72802, 3278944144, 3278944144, 'DE', 'DEU', 'ألمانيا'),
(72803, 3278944145, 3278944145, 'SE', 'SWE', 'السويد'),
(72804, 3278944146, 3278944147, 'DE', 'DEU', 'ألمانيا'),
(72805, 3278944148, 3278944148, 'ES', 'ESP', 'إسبانيا'),
(72806, 3278944149, 3278944149, 'DE', 'DEU', 'ألمانيا'),
(72807, 3278944150, 3278944150, 'IE', 'IRL', 'إيرلندا'),
(72808, 3278944151, 3278944151, 'IT', 'ITA', 'إيطاليا'),
(72809, 3278944152, 3278944152, 'IS', 'ISL', 'أيسلندا'),
(72810, 3278944153, 3278944156, 'DE', 'DEU', 'ألمانيا'),
(72811, 3278944157, 3278944157, 'FR', 'FRA', 'فرنسا'),
(72812, 3278944158, 3278944158, 'DE', 'DEU', 'ألمانيا'),
(72813, 3278944159, 3278944159, 'CH', 'CHE', 'سويسرا'),
(72814, 3278944160, 3278944160, 'FR', 'FRA', 'فرنسا'),
(72815, 3278944161, 3278944161, 'DE', 'DEU', 'ألمانيا'),
(72816, 3278944162, 3278944162, 'GB', 'GBR', 'المملكة المتحدة'),
(72817, 3278944163, 3278944163, 'HU', 'HUN', 'هنغاريا'),
(72818, 3278944164, 3278944164, 'IT', 'ITA', 'إيطاليا'),
(72819, 3278944165, 3278944166, 'DE', 'DEU', 'ألمانيا'),
(72820, 3278944167, 3278944167, 'IT', 'ITA', 'إيطاليا'),
(72821, 3278944168, 3278944168, 'CH', 'CHE', 'سويسرا'),
(72822, 3278944169, 3278944169, 'DE', 'DEU', 'ألمانيا'),
(72823, 3278944170, 3278944171, 'CH', 'CHE', 'سويسرا'),
(72824, 3278944172, 3278944172, 'DE', 'DEU', 'ألمانيا'),
(72825, 3278944173, 3278944173, 'FR', 'FRA', 'فرنسا'),
(72826, 3278944174, 3278944174, 'GB', 'GBR', 'المملكة المتحدة'),
(72827, 3278944175, 3278944175, 'DE', 'DEU', 'ألمانيا'),
(72828, 3278944176, 3278944176, 'ES', 'ESP', 'إسبانيا'),
(72829, 3278944177, 3278944177, 'LU', 'LUX', 'لوكسيمبورغ'),
(72830, 3278944178, 3278944179, 'DE', 'DEU', 'ألمانيا'),
(72831, 3278944180, 3278944180, 'GB', 'GBR', 'المملكة المتحدة'),
(72832, 3278944181, 3278944181, 'IT', 'ITA', 'إيطاليا'),
(72833, 3278944182, 3278944182, 'FR', 'FRA', 'فرنسا'),
(72834, 3278944183, 3278944184, 'ES', 'ESP', 'إسبانيا'),
(72835, 3278944185, 3278944185, 'NL', 'NLD', 'هولندا'),
(72836, 3278944186, 3278944192, 'DE', 'DEU', 'ألمانيا'),
(72837, 3278944193, 3278944193, 'FR', 'FRA', 'فرنسا'),
(72838, 3278944194, 3278944194, 'GB', 'GBR', 'المملكة المتحدة'),
(72839, 3278944195, 3278944195, 'IT', 'ITA', 'إيطاليا'),
(72840, 3278944196, 3278944197, 'DE', 'DEU', 'ألمانيا'),
(72841, 3278944198, 3278944198, 'IT', 'ITA', 'إيطاليا'),
(72842, 3278944199, 3278944199, 'AT', 'AUT', 'النمسا'),
(72843, 3278944200, 3278944200, 'DE', 'DEU', 'ألمانيا'),
(72844, 3278944201, 3278944201, 'SE', 'SWE', 'السويد'),
(72845, 3278944202, 3278944202, 'NO', 'NOR', 'النرويج'),
(72846, 3278944203, 3278944203, 'NL', 'NLD', 'هولندا'),
(72847, 3278944204, 3278944207, 'DE', 'DEU', 'ألمانيا'),
(72848, 3278944208, 3278944208, 'NL', 'NLD', 'هولندا'),
(72849, 3278944209, 3278944209, 'PL', 'POL', 'بولندا'),
(72850, 3278944210, 3278944210, 'AT', 'AUT', 'النمسا'),
(72851, 3278944211, 3278944211, 'DE', 'DEU', 'ألمانيا'),
(72852, 3278944212, 3278944212, 'FR', 'FRA', 'فرنسا'),
(72853, 3278944213, 3278944213, 'DK', 'DNK', 'الدنيمارك'),
(72854, 3278944214, 3278944214, 'GB', 'GBR', 'المملكة المتحدة'),
(72855, 3278944215, 3278944215, 'IT', 'ITA', 'إيطاليا'),
(72856, 3278944216, 3278944216, 'DE', 'DEU', 'ألمانيا'),
(72857, 3278944217, 3278944217, 'IT', 'ITA', 'إيطاليا'),
(72858, 3278944218, 3278944219, 'DE', 'DEU', 'ألمانيا'),
(72859, 3278944220, 3278944220, 'GB', 'GBR', 'المملكة المتحدة'),
(72860, 3278944221, 3278944221, 'GR', 'GRC', 'اليونان'),
(72861, 3278944222, 3278944222, 'IT', 'ITA', 'إيطاليا'),
(72862, 3278944223, 3278944224, 'DE', 'DEU', 'ألمانيا'),
(72863, 3278944225, 3278944225, 'NL', 'NLD', 'هولندا'),
(72864, 3278944226, 3278944226, 'RU', 'RUS', 'الإتحاد الروسي'),
(72865, 3278944227, 3278944227, 'IT', 'ITA', 'إيطاليا'),
(72866, 3278944228, 3278944230, 'DE', 'DEU', 'ألمانيا'),
(72867, 3278944231, 3278944231, 'CH', 'CHE', 'سويسرا'),
(72868, 3278944232, 3278944232, 'NL', 'NLD', 'هولندا'),
(72869, 3278944233, 3278944233, 'GB', 'GBR', 'المملكة المتحدة'),
(72870, 3278944234, 3278944234, 'AT', 'AUT', 'النمسا'),
(72871, 3278944235, 3278944235, 'DE', 'DEU', 'ألمانيا'),
(72872, 3278944236, 3278944236, 'IT', 'ITA', 'إيطاليا'),
(72873, 3278944237, 3278944238, 'DE', 'DEU', 'ألمانيا'),
(72874, 3278944239, 3278944239, 'SE', 'SWE', 'السويد'),
(72875, 3278944240, 3278944240, 'FR', 'FRA', 'فرنسا'),
(72876, 3278944241, 3278944241, 'IT', 'ITA', 'إيطاليا'),
(72877, 3278944242, 3278944242, 'ES', 'ESP', 'إسبانيا'),
(72878, 3278944243, 3278944243, 'DE', 'DEU', 'ألمانيا'),
(72879, 3278944244, 3278944244, 'ES', 'ESP', 'إسبانيا'),
(72880, 3278944245, 3278944245, 'BE', 'BEL', 'بلجيكا'),
(72881, 3278944246, 3278944246, 'NL', 'NLD', 'هولندا'),
(72882, 3278944247, 3278944247, 'ES', 'ESP', 'إسبانيا'),
(72883, 3278944248, 3278944248, 'NL', 'NLD', 'هولندا'),
(72884, 3278944249, 3278944249, 'ES', 'ESP', 'إسبانيا'),
(72885, 3278944250, 3278944250, 'IT', 'ITA', 'إيطاليا'),
(72886, 3278944251, 3278944251, 'AT', 'AUT', 'النمسا'),
(72887, 3278944252, 3278944252, 'IT', 'ITA', 'إيطاليا'),
(72888, 3278944253, 3278944254, 'GB', 'GBR', 'المملكة المتحدة'),
(72889, 3278944255, 3278944256, 'DE', 'DEU', 'ألمانيا'),
(72890, 3278944257, 3278944272, 'US', 'USA', 'الولايات المتحدة'),
(72891, 3278944273, 3278944273, 'CA', 'CAN', 'كندا'),
(72892, 3278944274, 3278944274, 'US', 'USA', 'الولايات المتحدة'),
(72893, 3278944275, 3278944275, 'CA', 'CAN', 'كندا'),
(72894, 3278944276, 3278944277, 'US', 'USA', 'الولايات المتحدة'),
(72895, 3278944278, 3278944278, 'VE', 'VEN', 'فنزويلا'),
(72896, 3278944279, 3278944279, 'DE', 'DEU', 'ألمانيا'),
(72897, 3278944280, 3278944284, 'US', 'USA', 'الولايات المتحدة'),
(72898, 3278944285, 3278944285, 'DE', 'DEU', 'ألمانيا'),
(72899, 3278944286, 3278944286, 'US', 'USA', 'الولايات المتحدة'),
(72900, 3278944287, 3278944288, 'CA', 'CAN', 'كندا'),
(72901, 3278944289, 3278944293, 'US', 'USA', 'الولايات المتحدة'),
(72902, 3278944294, 3278944294, 'CA', 'CAN', 'كندا'),
(72903, 3278944295, 3278944346, 'US', 'USA', 'الولايات المتحدة'),
(72904, 3278944347, 3278944347, 'AR', 'ARG', 'الأرجنتين'),
(72905, 3278944348, 3278944360, 'US', 'USA', 'الولايات المتحدة'),
(72906, 3278944361, 3278944361, 'AR', 'ARG', 'الأرجنتين'),
(72907, 3278944362, 3278944365, 'US', 'USA', 'الولايات المتحدة'),
(72908, 3278944366, 3278944366, 'MX', 'MEX', 'المكسيك'),
(72909, 3278944367, 3278944367, 'US', 'USA', 'الولايات المتحدة'),
(72910, 3278944368, 3278944368, 'CA', 'CAN', 'كندا'),
(72911, 3278944369, 3278944379, 'US', 'USA', 'الولايات المتحدة'),
(72912, 3278944380, 3278944380, 'DE', 'DEU', 'ألمانيا'),
(72913, 3278944381, 3278944385, 'US', 'USA', 'الولايات المتحدة'),
(72914, 3278944386, 3278944386, 'DE', 'DEU', 'ألمانيا'),
(72915, 3278944387, 3278944388, 'US', 'USA', 'الولايات المتحدة'),
(72916, 3278944389, 3278944389, 'CA', 'CAN', 'كندا'),
(72917, 3278944390, 3278944390, 'AR', 'ARG', 'الأرجنتين'),
(72918, 3278944391, 3278944391, 'CA', 'CAN', 'كندا'),
(72919, 3278944392, 3278944395, 'US', 'USA', 'الولايات المتحدة'),
(72920, 3278944396, 3278944396, 'CA', 'CAN', 'كندا'),
(72921, 3278944397, 3278944399, 'US', 'USA', 'الولايات المتحدة'),
(72922, 3278944400, 3278944400, 'BR', 'BRA', 'البرازيل'),
(72923, 3278944401, 3278944401, 'US', 'USA', 'الولايات المتحدة'),
(72924, 3278944402, 3278944402, 'CA', 'CAN', 'كندا'),
(72925, 3278944403, 3278944412, 'US', 'USA', 'الولايات المتحدة'),
(72926, 3278944413, 3278944413, 'CA', 'CAN', 'كندا'),
(72927, 3278944414, 3278944418, 'US', 'USA', 'الولايات المتحدة'),
(72928, 3278944419, 3278944419, 'DE', 'DEU', 'ألمانيا'),
(72929, 3278944420, 3278944420, 'CA', 'CAN', 'كندا'),
(72930, 3278944421, 3278944421, 'DE', 'DEU', 'ألمانيا'),
(72931, 3278944422, 3278944432, 'US', 'USA', 'الولايات المتحدة'),
(72932, 3278944433, 3278944433, 'DE', 'DEU', 'ألمانيا'),
(72933, 3278944434, 3278944444, 'US', 'USA', 'الولايات المتحدة'),
(72934, 3278944445, 3278944449, 'DE', 'DEU', 'ألمانيا'),
(72935, 3278944450, 3278944451, 'CA', 'CAN', 'كندا'),
(72936, 3278944452, 3278944460, 'DE', 'DEU', 'ألمانيا'),
(72937, 3278944461, 3278944461, 'US', 'USA', 'الولايات المتحدة'),
(72938, 3278944462, 3278944470, 'DE', 'DEU', 'ألمانيا'),
(72939, 3278944471, 3278944471, 'US', 'USA', 'الولايات المتحدة'),
(72940, 3278944472, 3278944513, 'DE', 'DEU', 'ألمانيا'),
(72941, 3278944514, 3278944517, 'US', 'USA', 'الولايات المتحدة'),
(72942, 3278944518, 3278944518, 'DE', 'DEU', 'ألمانيا'),
(72943, 3278944519, 3278944520, 'US', 'USA', 'الولايات المتحدة'),
(72944, 3278944521, 3278944521, 'CA', 'CAN', 'كندا'),
(72945, 3278944522, 3278944522, 'US', 'USA', 'الولايات المتحدة'),
(72946, 3278944523, 3278944523, 'CA', 'CAN', 'كندا'),
(72947, 3278944524, 3278944524, 'US', 'USA', 'الولايات المتحدة'),
(72948, 3278944525, 3278944525, 'CL', 'CHL', 'تشيلي'),
(72949, 3278944526, 3278944526, 'US', 'USA', 'الولايات المتحدة'),
(72950, 3278944527, 3278944527, 'CA', 'CAN', 'كندا'),
(72951, 3278944528, 3278944528, 'US', 'USA', 'الولايات المتحدة'),
(72952, 3278944529, 3278944529, 'CA', 'CAN', 'كندا'),
(72953, 3278944530, 3278944537, 'US', 'USA', 'الولايات المتحدة'),
(72954, 3278944538, 3278944538, 'AR', 'ARG', 'الأرجنتين'),
(72955, 3278944539, 3278944544, 'US', 'USA', 'الولايات المتحدة'),
(72956, 3278944545, 3278944545, 'CA', 'CAN', 'كندا'),
(72957, 3278944546, 3278944555, 'US', 'USA', 'الولايات المتحدة'),
(72958, 3278944556, 3278944556, 'CL', 'CHL', 'تشيلي'),
(72959, 3278944557, 3278944559, 'US', 'USA', 'الولايات المتحدة'),
(72960, 3278944560, 3278944560, 'AR', 'ARG', 'الأرجنتين'),
(72961, 3278944561, 3278944561, 'US', 'USA', 'الولايات المتحدة'),
(72962, 3278944562, 3278944562, 'CA', 'CAN', 'كندا'),
(72963, 3278944563, 3278944563, 'US', 'USA', 'الولايات المتحدة'),
(72964, 3278944564, 3278944564, 'CA', 'CAN', 'كندا'),
(72965, 3278944565, 3278944569, 'US', 'USA', 'الولايات المتحدة'),
(72966, 3278944570, 3278944570, 'DE', 'DEU', 'ألمانيا'),
(72967, 3278944571, 3278944572, 'US', 'USA', 'الولايات المتحدة'),
(72968, 3278944573, 3278944573, 'DE', 'DEU', 'ألمانيا'),
(72969, 3278944574, 3278944574, 'US', 'USA', 'الولايات المتحدة'),
(72970, 3278944575, 3278944575, 'DE', 'DEU', 'ألمانيا'),
(72971, 3278944576, 3278944578, 'US', 'USA', 'الولايات المتحدة'),
(72972, 3278944579, 3278944579, 'DE', 'DEU', 'ألمانيا'),
(72973, 3278944580, 3278944580, 'AR', 'ARG', 'الأرجنتين'),
(72974, 3278944581, 3278944581, 'US', 'USA', 'الولايات المتحدة'),
(72975, 3278944582, 3278944583, 'DE', 'DEU', 'ألمانيا'),
(72976, 3278944584, 3278944588, 'US', 'USA', 'الولايات المتحدة'),
(72977, 3278944589, 3278944589, 'DE', 'DEU', 'ألمانيا'),
(72978, 3278944590, 3278944599, 'US', 'USA', 'الولايات المتحدة'),
(72979, 3278944600, 3278944600, 'SA', 'SAU', 'السعودية'),
(72980, 3278944601, 3278944606, 'US', 'USA', 'الولايات المتحدة'),
(72981, 3278944607, 3278944608, 'DE', 'DEU', 'ألمانيا'),
(72982, 3278944609, 3278944611, 'US', 'USA', 'الولايات المتحدة'),
(72983, 3278944612, 3278944612, 'DE', 'DEU', 'ألمانيا'),
(72984, 3278944613, 3278944633, 'US', 'USA', 'الولايات المتحدة'),
(72985, 3278944634, 3278944634, 'DE', 'DEU', 'ألمانيا'),
(72986, 3278944635, 3278944638, 'US', 'USA', 'الولايات المتحدة'),
(72987, 3278944639, 3278944640, 'DE', 'DEU', 'ألمانيا'),
(72988, 3278944641, 3278944642, 'US', 'USA', 'الولايات المتحدة'),
(72989, 3278944643, 3278944643, 'CL', 'CHL', 'تشيلي'),
(72990, 3278944644, 3278944650, 'US', 'USA', 'الولايات المتحدة'),
(72991, 3278944651, 3278944651, 'DE', 'DEU', 'ألمانيا'),
(72992, 3278944652, 3278944654, 'US', 'USA', 'الولايات المتحدة'),
(72993, 3278944655, 3278944657, 'AR', 'ARG', 'الأرجنتين'),
(72994, 3278944658, 3278944659, 'US', 'USA', 'الولايات المتحدة'),
(72995, 3278944660, 3278944660, 'AR', 'ARG', 'الأرجنتين'),
(72996, 3278944661, 3278944661, 'US', 'USA', 'الولايات المتحدة'),
(72997, 3278944662, 3278944663, 'DE', 'DEU', 'ألمانيا'),
(72998, 3278944664, 3278944665, 'AR', 'ARG', 'الأرجنتين'),
(72999, 3278944666, 3278944667, 'US', 'USA', 'الولايات المتحدة'),
(73000, 3278944668, 3278944668, 'AR', 'ARG', 'الأرجنتين'),
(73001, 3278944669, 3278944670, 'US', 'USA', 'الولايات المتحدة'),
(73002, 3278944671, 3278944671, 'CL', 'CHL', 'تشيلي'),
(73003, 3278944672, 3278944672, 'DE', 'DEU', 'ألمانيا'),
(73004, 3278944673, 3278944673, 'PE', 'PER', 'بيرو'),
(73005, 3278944674, 3278944674, 'DE', 'DEU', 'ألمانيا'),
(73006, 3278944675, 3278944677, 'US', 'USA', 'الولايات المتحدة'),
(73007, 3278944678, 3278944678, 'CA', 'CAN', 'كندا'),
(73008, 3278944679, 3278944679, 'US', 'USA', 'الولايات المتحدة'),
(73009, 3278944680, 3278944680, 'CA', 'CAN', 'كندا'),
(73010, 3278944681, 3278944683, 'US', 'USA', 'الولايات المتحدة'),
(73011, 3278944684, 3278944686, 'DE', 'DEU', 'ألمانيا'),
(73012, 3278944687, 3278944687, 'US', 'USA', 'الولايات المتحدة'),
(73013, 3278944688, 3278944688, 'AR', 'ARG', 'الأرجنتين'),
(73014, 3278944689, 3278944693, 'US', 'USA', 'الولايات المتحدة'),
(73015, 3278944694, 3278944695, 'DE', 'DEU', 'ألمانيا'),
(73016, 3278944696, 3278944696, 'US', 'USA', 'الولايات المتحدة'),
(73017, 3278944697, 3278944697, 'CA', 'CAN', 'كندا'),
(73018, 3278944698, 3278944706, 'US', 'USA', 'الولايات المتحدة'),
(73019, 3278944707, 3278944707, 'DE', 'DEU', 'ألمانيا'),
(73020, 3278944708, 3278944708, 'PE', 'PER', 'بيرو'),
(73021, 3278944709, 3278944709, 'US', 'USA', 'الولايات المتحدة'),
(73022, 3278944710, 3278944710, 'DE', 'DEU', 'ألمانيا'),
(73023, 3278944711, 3278944712, 'CL', 'CHL', 'تشيلي'),
(73024, 3278944713, 3278944713, 'DE', 'DEU', 'ألمانيا'),
(73025, 3278944714, 3278944714, 'JM', 'JAM', 'جامايكا'),
(73026, 3278944715, 3278944715, 'CA', 'CAN', 'كندا'),
(73027, 3278944716, 3278944716, 'DE', 'DEU', 'ألمانيا'),
(73028, 3278944717, 3278944718, 'US', 'USA', 'الولايات المتحدة'),
(73029, 3278944719, 3278944719, 'CA', 'CAN', 'كندا'),
(73030, 3278944720, 3278944720, 'US', 'USA', 'الولايات المتحدة'),
(73031, 3278944721, 3278944721, 'CA', 'CAN', 'كندا'),
(73032, 3278944722, 3278944727, 'US', 'USA', 'الولايات المتحدة'),
(73033, 3278944728, 3278944728, 'DE', 'DEU', 'ألمانيا'),
(73034, 3278944729, 3278944730, 'US', 'USA', 'الولايات المتحدة'),
(73035, 3278944731, 3278944731, 'DE', 'DEU', 'ألمانيا'),
(73036, 3278944732, 3278944734, 'US', 'USA', 'الولايات المتحدة'),
(73037, 3278944735, 3278944735, 'DE', 'DEU', 'ألمانيا'),
(73038, 3278944736, 3278944736, 'AR', 'ARG', 'الأرجنتين'),
(73039, 3278944737, 3278944739, 'US', 'USA', 'الولايات المتحدة'),
(73040, 3278944740, 3278944740, 'CA', 'CAN', 'كندا'),
(73041, 3278944741, 3278944741, 'DE', 'DEU', 'ألمانيا'),
(73042, 3278944742, 3278944743, 'US', 'USA', 'الولايات المتحدة'),
(73043, 3278944744, 3278944745, 'DE', 'DEU', 'ألمانيا'),
(73044, 3278944746, 3278944749, 'US', 'USA', 'الولايات المتحدة'),
(73045, 3278944750, 3278944750, 'DE', 'DEU', 'ألمانيا'),
(73046, 3278944751, 3278944751, 'US', 'USA', 'الولايات المتحدة'),
(73047, 3278944752, 3278944752, 'DE', 'DEU', 'ألمانيا'),
(73048, 3278944753, 3278944753, 'US', 'USA', 'الولايات المتحدة'),
(73049, 3278944754, 3278944754, 'BR', 'BRA', 'البرازيل'),
(73050, 3278944755, 3278944755, 'AR', 'ARG', 'الأرجنتين'),
(73051, 3278944756, 3278944758, 'US', 'USA', 'الولايات المتحدة'),
(73052, 3278944759, 3278944760, 'DE', 'DEU', 'ألمانيا'),
(73053, 3278944761, 3278944761, 'UY', 'URY', 'الأوروغواي'),
(73054, 3278944762, 3278944763, 'DE', 'DEU', 'ألمانيا'),
(73055, 3278944764, 3278944764, 'AR', 'ARG', 'الأرجنتين'),
(73056, 3278944765, 3278944765, 'US', 'USA', 'الولايات المتحدة'),
(73057, 3278944766, 3278944767, 'DE', 'DEU', 'ألمانيا'),
(73058, 3278944768, 3278944771, 'DO', 'DOM', 'الدومينيكان'),
(73059, 3278944772, 3278944819, 'US', 'USA', 'الولايات المتحدة'),
(73060, 3278944820, 3278944823, 'AR', 'ARG', 'الأرجنتين'),
(73061, 3278944824, 3278944827, 'BR', 'BRA', 'البرازيل'),
(73062, 3278944828, 3278944851, 'US', 'USA', 'الولايات المتحدة'),
(73063, 3278944852, 3278944855, 'CA', 'CAN', 'كندا'),
(73064, 3278944856, 3278944863, 'US', 'USA', 'الولايات المتحدة'),
(73065, 3278944864, 3278944867, 'MX', 'MEX', 'المكسيك'),
(73066, 3278944868, 3278944871, 'US', 'USA', 'الولايات المتحدة'),
(73067, 3278944872, 3278944875, 'DE', 'DEU', 'ألمانيا'),
(73068, 3278944876, 3278944887, 'US', 'USA', 'الولايات المتحدة'),
(73069, 3278944888, 3278944891, 'CO', 'COL', 'كولومبيا'),
(73070, 3278944892, 3278944903, 'US', 'USA', 'الولايات المتحدة'),
(73071, 3278944904, 3278944907, 'BR', 'BRA', 'البرازيل'),
(73072, 3278944908, 3278944919, 'US', 'USA', 'الولايات المتحدة'),
(73073, 3278944920, 3278944923, 'CO', 'COL', 'كولومبيا'),
(73074, 3278944924, 3278944935, 'US', 'USA', 'الولايات المتحدة'),
(73075, 3278944936, 3278944939, 'BR', 'BRA', 'البرازيل'),
(73076, 3278944940, 3278944947, 'US', 'USA', 'الولايات المتحدة'),
(73077, 3278944948, 3278944951, 'CO', 'COL', 'كولومبيا'),
(73078, 3278944952, 3278944963, 'US', 'USA', 'الولايات المتحدة'),
(73079, 3278944964, 3278944971, 'CA', 'CAN', 'كندا'),
(73080, 3278944972, 3278944975, 'US', 'USA', 'الولايات المتحدة'),
(73081, 3278944976, 3278944995, 'CA', 'CAN', 'كندا'),
(73082, 3278944996, 3278944999, 'CO', 'COL', 'كولومبيا'),
(73083, 3278945000, 3278945007, 'US', 'USA', 'الولايات المتحدة'),
(73084, 3278945008, 3278945011, 'CO', 'COL', 'كولومبيا'),
(73085, 3278945012, 3278945015, 'PE', 'PER', 'بيرو'),
(73086, 3278945016, 3278945023, 'US', 'USA', 'الولايات المتحدة'),
(73087, 3278945024, 3278945027, 'BR', 'BRA', 'البرازيل'),
(73088, 3278945028, 3278945031, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(73089, 3278945032, 3278945087, 'US', 'USA', 'الولايات المتحدة'),
(73090, 3278945088, 3278945091, 'BR', 'BRA', 'البرازيل'),
(73091, 3278945092, 3278945099, 'US', 'USA', 'الولايات المتحدة'),
(73092, 3278945100, 3278945107, 'BR', 'BRA', 'البرازيل'),
(73093, 3278945108, 3278945111, 'DO', 'DOM', 'الدومينيكان'),
(73094, 3278945112, 3278945127, 'US', 'USA', 'الولايات المتحدة'),
(73095, 3278945128, 3278945131, 'AR', 'ARG', 'الأرجنتين'),
(73096, 3278945132, 3278945135, 'BR', 'BRA', 'البرازيل'),
(73097, 3278945136, 3278945151, 'US', 'USA', 'الولايات المتحدة'),
(73098, 3278945152, 3278945155, 'CA', 'CAN', 'كندا'),
(73099, 3278945156, 3278945159, 'BR', 'BRA', 'البرازيل'),
(73100, 3278945160, 3278945171, 'US', 'USA', 'الولايات المتحدة'),
(73101, 3278945172, 3278945175, 'AR', 'ARG', 'الأرجنتين'),
(73102, 3278945176, 3278945191, 'US', 'USA', 'الولايات المتحدة'),
(73103, 3278945192, 3278945199, 'CA', 'CAN', 'كندا'),
(73104, 3278945200, 3278945203, 'US', 'USA', 'الولايات المتحدة'),
(73105, 3278945204, 3278945207, 'AR', 'ARG', 'الأرجنتين'),
(73106, 3278945208, 3278945227, 'US', 'USA', 'الولايات المتحدة'),
(73107, 3278945228, 3278945235, 'CA', 'CAN', 'كندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(73108, 3278945236, 3278945247, 'US', 'USA', 'الولايات المتحدة'),
(73109, 3278945248, 3278945255, 'CA', 'CAN', 'كندا'),
(73110, 3278945256, 3278945267, 'US', 'USA', 'الولايات المتحدة'),
(73111, 3278945268, 3278945271, 'AR', 'ARG', 'الأرجنتين'),
(73112, 3278945272, 3278945275, 'US', 'USA', 'الولايات المتحدة'),
(73113, 3278945276, 3278945279, 'CL', 'CHL', 'تشيلي'),
(73114, 3278945280, 3278945283, 'CA', 'CAN', 'كندا'),
(73115, 3278945284, 3278945299, 'US', 'USA', 'الولايات المتحدة'),
(73116, 3278945300, 3278945303, 'DE', 'DEU', 'ألمانيا'),
(73117, 3278945304, 3278945307, 'CO', 'COL', 'كولومبيا'),
(73118, 3278945308, 3278945311, 'CA', 'CAN', 'كندا'),
(73119, 3278945312, 3278945319, 'US', 'USA', 'الولايات المتحدة'),
(73120, 3278945320, 3278945323, 'MX', 'MEX', 'المكسيك'),
(73121, 3278945324, 3278945327, 'AR', 'ARG', 'الأرجنتين'),
(73122, 3278945328, 3278945331, 'CA', 'CAN', 'كندا'),
(73123, 3278945332, 3278945335, 'US', 'USA', 'الولايات المتحدة'),
(73124, 3278945336, 3278945339, 'CA', 'CAN', 'كندا'),
(73125, 3278945340, 3278945343, 'US', 'USA', 'الولايات المتحدة'),
(73126, 3278945344, 3278945347, 'BR', 'BRA', 'البرازيل'),
(73127, 3278945348, 3278945363, 'US', 'USA', 'الولايات المتحدة'),
(73128, 3278945364, 3278945367, 'PR', 'PRI', 'بورتو ريكو'),
(73129, 3278945368, 3278945395, 'US', 'USA', 'الولايات المتحدة'),
(73130, 3278945396, 3278945399, 'AR', 'ARG', 'الأرجنتين'),
(73131, 3278945400, 3278945403, 'MX', 'MEX', 'المكسيك'),
(73132, 3278945404, 3278945427, 'US', 'USA', 'الولايات المتحدة'),
(73133, 3278945428, 3278945431, 'CA', 'CAN', 'كندا'),
(73134, 3278945432, 3278945435, 'AR', 'ARG', 'الأرجنتين'),
(73135, 3278945436, 3278945439, 'MX', 'MEX', 'المكسيك'),
(73136, 3278945440, 3278945451, 'US', 'USA', 'الولايات المتحدة'),
(73137, 3278945452, 3278945455, 'BR', 'BRA', 'البرازيل'),
(73138, 3278945456, 3278945459, 'US', 'USA', 'الولايات المتحدة'),
(73139, 3278945460, 3278945463, 'MX', 'MEX', 'المكسيك'),
(73140, 3278945464, 3278945479, 'US', 'USA', 'الولايات المتحدة'),
(73141, 3278945480, 3278945483, 'CL', 'CHL', 'تشيلي'),
(73142, 3278945484, 3278945491, 'BR', 'BRA', 'البرازيل'),
(73143, 3278945492, 3278945503, 'US', 'USA', 'الولايات المتحدة'),
(73144, 3278945504, 3278945507, 'MX', 'MEX', 'المكسيك'),
(73145, 3278945508, 3278945515, 'AR', 'ARG', 'الأرجنتين'),
(73146, 3278945516, 3278945519, 'BR', 'BRA', 'البرازيل'),
(73147, 3278945520, 3278945523, 'US', 'USA', 'الولايات المتحدة'),
(73148, 3278945524, 3278945527, 'CA', 'CAN', 'كندا'),
(73149, 3278945528, 3278945531, 'US', 'USA', 'الولايات المتحدة'),
(73150, 3278945532, 3278945535, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(73151, 3278945536, 3278945539, 'AR', 'ARG', 'الأرجنتين'),
(73152, 3278945540, 3278945579, 'US', 'USA', 'الولايات المتحدة'),
(73153, 3278945580, 3278945583, 'AR', 'ARG', 'الأرجنتين'),
(73154, 3278945584, 3278945587, 'US', 'USA', 'الولايات المتحدة'),
(73155, 3278945588, 3278945591, 'DO', 'DOM', 'الدومينيكان'),
(73156, 3278945592, 3278945659, 'US', 'USA', 'الولايات المتحدة'),
(73157, 3278945660, 3278945663, 'AR', 'ARG', 'الأرجنتين'),
(73158, 3278945664, 3278945667, 'US', 'USA', 'الولايات المتحدة'),
(73159, 3278945668, 3278945671, 'UY', 'URY', 'الأوروغواي'),
(73160, 3278945672, 3278945675, 'DE', 'DEU', 'ألمانيا'),
(73161, 3278945676, 3278945687, 'US', 'USA', 'الولايات المتحدة'),
(73162, 3278945688, 3278945691, 'BR', 'BRA', 'البرازيل'),
(73163, 3278945692, 3278945699, 'US', 'USA', 'الولايات المتحدة'),
(73164, 3278945700, 3278945703, 'AR', 'ARG', 'الأرجنتين'),
(73165, 3278945704, 3278945715, 'US', 'USA', 'الولايات المتحدة'),
(73166, 3278945716, 3278945719, 'CO', 'COL', 'كولومبيا'),
(73167, 3278945720, 3278945723, 'US', 'USA', 'الولايات المتحدة'),
(73168, 3278945724, 3278945727, 'AR', 'ARG', 'الأرجنتين'),
(73169, 3278945728, 3278945743, 'US', 'USA', 'الولايات المتحدة'),
(73170, 3278945744, 3278945747, 'MX', 'MEX', 'المكسيك'),
(73171, 3278945748, 3278945763, 'US', 'USA', 'الولايات المتحدة'),
(73172, 3278945764, 3278945767, 'MX', 'MEX', 'المكسيك'),
(73173, 3278945768, 3278945771, 'CO', 'COL', 'كولومبيا'),
(73174, 3278945772, 3278945779, 'US', 'USA', 'الولايات المتحدة'),
(73175, 3278945780, 3278945783, 'PE', 'PER', 'بيرو'),
(73176, 3278945784, 3278945791, 'US', 'USA', 'الولايات المتحدة'),
(73177, 3278945792, 3278945794, 'DE', 'DEU', 'ألمانيا'),
(73178, 3278945795, 3278945795, 'CH', 'CHE', 'سويسرا'),
(73179, 3278945796, 3278945796, 'DE', 'DEU', 'ألمانيا'),
(73180, 3278945797, 3278945797, 'BE', 'BEL', 'بلجيكا'),
(73181, 3278945798, 3278945798, 'NL', 'NLD', 'هولندا'),
(73182, 3278945799, 3278945799, 'LU', 'LUX', 'لوكسيمبورغ'),
(73183, 3278945800, 3278945800, 'SE', 'SWE', 'السويد'),
(73184, 3278945801, 3278945801, 'NL', 'NLD', 'هولندا'),
(73185, 3278945802, 3278945802, 'PT', 'PRT', 'البورتوغال'),
(73186, 3278945803, 3278945803, 'GB', 'GBR', 'المملكة المتحدة'),
(73187, 3278945804, 3278945804, 'DE', 'DEU', 'ألمانيا'),
(73188, 3278945805, 3278945805, 'DK', 'DNK', 'الدنيمارك'),
(73189, 3278945806, 3278945806, 'FR', 'FRA', 'فرنسا'),
(73190, 3278945807, 3278945807, 'DE', 'DEU', 'ألمانيا'),
(73191, 3278945808, 3278945808, 'RU', 'RUS', 'الإتحاد الروسي'),
(73192, 3278945809, 3278945809, 'DE', 'DEU', 'ألمانيا'),
(73193, 3278945810, 3278945810, 'CH', 'CHE', 'سويسرا'),
(73194, 3278945811, 3278945815, 'DE', 'DEU', 'ألمانيا'),
(73195, 3278945816, 3278945816, 'GB', 'GBR', 'المملكة المتحدة'),
(73196, 3278945817, 3278945821, 'DE', 'DEU', 'ألمانيا'),
(73197, 3278945822, 3278945822, 'GR', 'GRC', 'اليونان'),
(73198, 3278945823, 3278945823, 'CH', 'CHE', 'سويسرا'),
(73199, 3278945824, 3278945826, 'DE', 'DEU', 'ألمانيا'),
(73200, 3278945827, 3278945827, 'DK', 'DNK', 'الدنيمارك'),
(73201, 3278945828, 3278945828, 'FR', 'FRA', 'فرنسا'),
(73202, 3278945829, 3278945829, 'DE', 'DEU', 'ألمانيا'),
(73203, 3278945830, 3278945831, 'NL', 'NLD', 'هولندا'),
(73204, 3278945832, 3278945832, 'DE', 'DEU', 'ألمانيا'),
(73205, 3278945833, 3278945833, 'GB', 'GBR', 'المملكة المتحدة'),
(73206, 3278945834, 3278945834, 'NL', 'NLD', 'هولندا'),
(73207, 3278945835, 3278945835, 'CH', 'CHE', 'سويسرا'),
(73208, 3278945836, 3278945838, 'DE', 'DEU', 'ألمانيا'),
(73209, 3278945839, 3278945839, 'CZ', 'CZE', 'التشيك'),
(73210, 3278945840, 3278945840, 'DE', 'DEU', 'ألمانيا'),
(73211, 3278945841, 3278945841, 'CH', 'CHE', 'سويسرا'),
(73212, 3278945842, 3278945844, 'DE', 'DEU', 'ألمانيا'),
(73213, 3278945845, 3278945845, 'ES', 'ESP', 'إسبانيا'),
(73214, 3278945846, 3278945846, 'CH', 'CHE', 'سويسرا'),
(73215, 3278945847, 3278945847, 'DE', 'DEU', 'ألمانيا'),
(73216, 3278945848, 3278945848, 'GB', 'GBR', 'المملكة المتحدة'),
(73217, 3278945849, 3278945849, 'DE', 'DEU', 'ألمانيا'),
(73218, 3278945850, 3278945850, 'NL', 'NLD', 'هولندا'),
(73219, 3278945851, 3278945852, 'DE', 'DEU', 'ألمانيا'),
(73220, 3278945853, 3278945853, 'CH', 'CHE', 'سويسرا'),
(73221, 3278945854, 3278945854, 'FR', 'FRA', 'فرنسا'),
(73222, 3278945855, 3278945855, 'DE', 'DEU', 'ألمانيا'),
(73223, 3278945856, 3278945856, 'DK', 'DNK', 'الدنيمارك'),
(73224, 3278945857, 3278945858, 'DE', 'DEU', 'ألمانيا'),
(73225, 3278945859, 3278945859, 'GB', 'GBR', 'المملكة المتحدة'),
(73226, 3278945860, 3278945860, 'FR', 'FRA', 'فرنسا'),
(73227, 3278945861, 3278945861, 'IT', 'ITA', 'إيطاليا'),
(73228, 3278945862, 3278945862, 'BE', 'BEL', 'بلجيكا'),
(73229, 3278945863, 3278945863, 'ES', 'ESP', 'إسبانيا'),
(73230, 3278945864, 3278945864, 'IE', 'IRL', 'إيرلندا'),
(73231, 3278945865, 3278945866, 'DE', 'DEU', 'ألمانيا'),
(73232, 3278945867, 3278945867, 'FR', 'FRA', 'فرنسا'),
(73233, 3278945868, 3278945868, 'NO', 'NOR', 'النرويج'),
(73234, 3278945869, 3278945870, 'DE', 'DEU', 'ألمانيا'),
(73235, 3278945871, 3278945871, 'IT', 'ITA', 'إيطاليا'),
(73236, 3278945872, 3278945872, 'FR', 'FRA', 'فرنسا'),
(73237, 3278945873, 3278945873, 'DE', 'DEU', 'ألمانيا'),
(73238, 3278945874, 3278945874, 'IT', 'ITA', 'إيطاليا'),
(73239, 3278945875, 3278945875, 'ES', 'ESP', 'إسبانيا'),
(73240, 3278945876, 3278945876, 'NL', 'NLD', 'هولندا'),
(73241, 3278945877, 3278945877, 'SE', 'SWE', 'السويد'),
(73242, 3278945878, 3278945879, 'FR', 'FRA', 'فرنسا'),
(73243, 3278945880, 3278945880, 'DE', 'DEU', 'ألمانيا'),
(73244, 3278945881, 3278945881, 'BE', 'BEL', 'بلجيكا'),
(73245, 3278945882, 3278945886, 'DE', 'DEU', 'ألمانيا'),
(73246, 3278945887, 3278945888, 'IT', 'ITA', 'إيطاليا'),
(73247, 3278945889, 3278945890, 'DE', 'DEU', 'ألمانيا'),
(73248, 3278945891, 3278945891, 'CH', 'CHE', 'سويسرا'),
(73249, 3278945892, 3278945892, 'BE', 'BEL', 'بلجيكا'),
(73250, 3278945893, 3278945893, 'DE', 'DEU', 'ألمانيا'),
(73251, 3278945894, 3278945894, 'AT', 'AUT', 'النمسا'),
(73252, 3278945895, 3278945895, 'ES', 'ESP', 'إسبانيا'),
(73253, 3278945896, 3278945896, 'GB', 'GBR', 'المملكة المتحدة'),
(73254, 3278945897, 3278945897, 'IT', 'ITA', 'إيطاليا'),
(73255, 3278945898, 3278945898, 'ES', 'ESP', 'إسبانيا'),
(73256, 3278945899, 3278945899, 'DE', 'DEU', 'ألمانيا'),
(73257, 3278945900, 3278945900, 'FR', 'FRA', 'فرنسا'),
(73258, 3278945901, 3278945904, 'DE', 'DEU', 'ألمانيا'),
(73259, 3278945905, 3278945905, 'PT', 'PRT', 'البورتوغال'),
(73260, 3278945906, 3278945906, 'FR', 'FRA', 'فرنسا'),
(73261, 3278945907, 3278945907, 'GB', 'GBR', 'المملكة المتحدة'),
(73262, 3278945908, 3278945908, 'DE', 'DEU', 'ألمانيا'),
(73263, 3278945909, 3278945909, 'FR', 'FRA', 'فرنسا'),
(73264, 3278945910, 3278945910, 'DE', 'DEU', 'ألمانيا'),
(73265, 3278945911, 3278945911, 'NL', 'NLD', 'هولندا'),
(73266, 3278945912, 3278945917, 'DE', 'DEU', 'ألمانيا'),
(73267, 3278945918, 3278945918, 'IT', 'ITA', 'إيطاليا'),
(73268, 3278945919, 3278946049, 'DE', 'DEU', 'ألمانيا'),
(73269, 3278946050, 3278946054, 'US', 'USA', 'الولايات المتحدة'),
(73270, 3278946055, 3278946055, 'CA', 'CAN', 'كندا'),
(73271, 3278946056, 3278946059, 'US', 'USA', 'الولايات المتحدة'),
(73272, 3278946060, 3278946060, 'CN', 'CHN', 'الصين'),
(73273, 3278946061, 3278946061, 'US', 'USA', 'الولايات المتحدة'),
(73274, 3278946062, 3278946062, 'DE', 'DEU', 'ألمانيا'),
(73275, 3278946063, 3278946067, 'US', 'USA', 'الولايات المتحدة'),
(73276, 3278946068, 3278946068, 'DE', 'DEU', 'ألمانيا'),
(73277, 3278946069, 3278946084, 'US', 'USA', 'الولايات المتحدة'),
(73278, 3278946085, 3278946085, 'DE', 'DEU', 'ألمانيا'),
(73279, 3278946086, 3278946091, 'US', 'USA', 'الولايات المتحدة'),
(73280, 3278946092, 3278946092, 'DE', 'DEU', 'ألمانيا'),
(73281, 3278946093, 3278946108, 'US', 'USA', 'الولايات المتحدة'),
(73282, 3278946109, 3278946109, 'GB', 'GBR', 'المملكة المتحدة'),
(73283, 3278946110, 3278946166, 'US', 'USA', 'الولايات المتحدة'),
(73284, 3278946167, 3278946167, 'DE', 'DEU', 'ألمانيا'),
(73285, 3278946168, 3278946208, 'US', 'USA', 'الولايات المتحدة'),
(73286, 3278946209, 3278946213, 'DE', 'DEU', 'ألمانيا'),
(73287, 3278946214, 3278946214, 'US', 'USA', 'الولايات المتحدة'),
(73288, 3278946215, 3278946221, 'DE', 'DEU', 'ألمانيا'),
(73289, 3278946222, 3278946222, 'US', 'USA', 'الولايات المتحدة'),
(73290, 3278946223, 3278946224, 'DE', 'DEU', 'ألمانيا'),
(73291, 3278946225, 3278946225, 'US', 'USA', 'الولايات المتحدة'),
(73292, 3278946226, 3278946229, 'DE', 'DEU', 'ألمانيا'),
(73293, 3278946230, 3278946231, 'US', 'USA', 'الولايات المتحدة'),
(73294, 3278946232, 3278946239, 'DE', 'DEU', 'ألمانيا'),
(73295, 3278946240, 3278946263, 'US', 'USA', 'الولايات المتحدة'),
(73296, 3278946264, 3278946267, 'DE', 'DEU', 'ألمانيا'),
(73297, 3278946268, 3278946271, 'US', 'USA', 'الولايات المتحدة'),
(73298, 3278946272, 3278946275, 'SV', 'SLV', 'السلفادور'),
(73299, 3278946276, 3278946279, 'DO', 'DOM', 'الدومينيكان'),
(73300, 3278946280, 3278946283, 'DE', 'DEU', 'ألمانيا'),
(73301, 3278946284, 3278946287, 'US', 'USA', 'الولايات المتحدة'),
(73302, 3278946288, 3278946291, 'DE', 'DEU', 'ألمانيا'),
(73303, 3278946292, 3278946299, 'US', 'USA', 'الولايات المتحدة'),
(73304, 3278946300, 3278946303, 'DE', 'DEU', 'ألمانيا'),
(73305, 3278946304, 3278954495, 'LB', 'LBN', 'لبنان'),
(73306, 3278954496, 3278962687, 'RU', 'RUS', 'الإتحاد الروسي'),
(73307, 3278962688, 3279028223, 'CZ', 'CZE', 'التشيك'),
(73308, 3279028224, 3279028735, 'PL', 'POL', 'بولندا'),
(73309, 3279028736, 3279029247, 'RU', 'RUS', 'الإتحاد الروسي'),
(73310, 3279029248, 3279030271, 'UA', 'UKR', 'أوكرانيا'),
(73311, 3279030272, 3279030783, 'RU', 'RUS', 'الإتحاد الروسي'),
(73312, 3279030784, 3279031295, 'DE', 'DEU', 'ألمانيا'),
(73313, 3279031296, 3279031807, 'NL', 'NLD', 'هولندا'),
(73314, 3279031808, 3279032319, 'RO', 'ROM', 'رومانيا'),
(73315, 3279032320, 3279032831, 'HU', 'HUN', 'هنغاريا'),
(73316, 3279032832, 3279033343, 'FR', 'FRA', 'فرنسا'),
(73317, 3279033344, 3279033855, 'RU', 'RUS', 'الإتحاد الروسي'),
(73318, 3279033856, 3279034367, 'DE', 'DEU', 'ألمانيا'),
(73319, 3279034368, 3279035391, 'FR', 'FRA', 'فرنسا'),
(73320, 3279035392, 3279035903, 'PS', 'PSE', 'فلسطين المحتلة'),
(73321, 3279035904, 3279036415, 'UA', 'UKR', 'أوكرانيا'),
(73322, 3279036416, 3279044607, 'LV', 'LVA', 'لاتفيا'),
(73323, 3279044608, 3279052799, 'FR', 'FRA', 'فرنسا'),
(73324, 3279052800, 3279053311, 'UA', 'UKR', 'أوكرانيا'),
(73325, 3279053312, 3279053823, 'DE', 'DEU', 'ألمانيا'),
(73326, 3279053824, 3279054335, 'NL', 'NLD', 'هولندا'),
(73327, 3279054336, 3279054847, 'GB', 'GBR', 'المملكة المتحدة'),
(73328, 3279055360, 3279055871, 'SA', 'SAU', 'السعودية'),
(73329, 3279055872, 3279056383, 'TR', 'TUR', 'تركيا'),
(73330, 3279056384, 3279056895, 'GB', 'GBR', 'المملكة المتحدة'),
(73331, 3279056896, 3279057407, 'BG', 'BGR', 'بلغاريا'),
(73332, 3279057408, 3279057919, 'FR', 'FRA', 'فرنسا'),
(73333, 3279057920, 3279058431, 'RO', 'ROM', 'رومانيا'),
(73334, 3279058432, 3279058943, 'RU', 'RUS', 'الإتحاد الروسي'),
(73335, 3279058944, 3279059455, 'UA', 'UKR', 'أوكرانيا'),
(73336, 3279059968, 3279060479, 'RU', 'RUS', 'الإتحاد الروسي'),
(73337, 3279060480, 3279060991, 'PL', 'POL', 'بولندا'),
(73338, 3279060992, 3279069183, 'UA', 'UKR', 'أوكرانيا'),
(73339, 3279069184, 3279077375, 'PL', 'POL', 'بولندا'),
(73340, 3279077376, 3279078399, 'ES', 'ESP', 'إسبانيا'),
(73341, 3279078400, 3279078655, 'IT', 'ITA', 'إيطاليا'),
(73342, 3279078656, 3279078911, 'FR', 'FRA', 'فرنسا'),
(73343, 3279078912, 3279081215, 'ES', 'ESP', 'إسبانيا'),
(73344, 3279081216, 3279081231, 'DE', 'DEU', 'ألمانيا'),
(73345, 3279081232, 3279083583, 'ES', 'ESP', 'إسبانيا'),
(73346, 3279083584, 3279083599, 'NL', 'NLD', 'هولندا'),
(73347, 3279083600, 3279083807, 'ES', 'ESP', 'إسبانيا'),
(73348, 3279083808, 3279083839, 'NL', 'NLD', 'هولندا'),
(73349, 3279083840, 3279084543, 'ES', 'ESP', 'إسبانيا'),
(73350, 3279084544, 3279085567, 'IT', 'ITA', 'إيطاليا'),
(73351, 3279085568, 3279093759, 'NL', 'NLD', 'هولندا'),
(73352, 3279093760, 3279103103, 'FR', 'FRA', 'فرنسا'),
(73353, 3279103104, 3279103135, 'GB', 'GBR', 'المملكة المتحدة'),
(73354, 3279103136, 3279119295, 'FR', 'FRA', 'فرنسا'),
(73355, 3279119296, 3279119327, 'GB', 'GBR', 'المملكة المتحدة'),
(73356, 3279119328, 3279159295, 'FR', 'FRA', 'فرنسا'),
(73357, 3279159296, 3279290367, 'PL', 'POL', 'بولندا'),
(73358, 3279290368, 3279291391, 'NL', 'NLD', 'هولندا'),
(73359, 3279291392, 3279291647, 'GB', 'GBR', 'المملكة المتحدة'),
(73360, 3279291648, 3279294463, 'NL', 'NLD', 'هولندا'),
(73361, 3279294720, 3279294975, 'IE', 'IRL', 'إيرلندا'),
(73362, 3279294976, 3279295231, 'SE', 'SWE', 'السويد'),
(73363, 3279295232, 3279295487, 'ES', 'ESP', 'إسبانيا'),
(73364, 3279295488, 3279295743, 'PT', 'PRT', 'البورتوغال'),
(73365, 3279295744, 3279295999, 'IL', 'ISR', 'إسرائيل'),
(73366, 3279296000, 3279296511, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73367, 3279296512, 3279297279, 'ES', 'ESP', 'إسبانيا'),
(73368, 3279297280, 3279297535, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73369, 3279297536, 3279298047, 'SE', 'SWE', 'السويد'),
(73370, 3279298048, 3279298559, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73371, 3279298560, 3279305471, 'DE', 'DEU', 'ألمانيا'),
(73372, 3279305488, 3279305503, 'DE', 'DEU', 'ألمانيا'),
(73373, 3279305504, 3279305535, 'GB', 'GBR', 'المملكة المتحدة'),
(73374, 3279305536, 3279305631, 'DE', 'DEU', 'ألمانيا'),
(73375, 3279305632, 3279305663, 'GB', 'GBR', 'المملكة المتحدة'),
(73376, 3279305664, 3279305727, 'ES', 'ESP', 'إسبانيا'),
(73377, 3279305728, 3279306751, 'DE', 'DEU', 'ألمانيا'),
(73378, 3279306752, 3279310847, 'FR', 'FRA', 'فرنسا'),
(73379, 3279310848, 3279311871, 'DE', 'DEU', 'ألمانيا'),
(73380, 3279312896, 3279313415, 'DE', 'DEU', 'ألمانيا'),
(73381, 3279313424, 3279313919, 'DE', 'DEU', 'ألمانيا'),
(73382, 3279313920, 3279314943, 'GB', 'GBR', 'المملكة المتحدة'),
(73383, 3279314944, 3279315711, 'CH', 'CHE', 'سويسرا'),
(73384, 3279315712, 3279315967, 'BE', 'BEL', 'بلجيكا'),
(73385, 3279315968, 3279316223, 'DE', 'DEU', 'ألمانيا'),
(73386, 3279316224, 3279316479, 'BE', 'BEL', 'بلجيكا'),
(73387, 3279316480, 3279317759, 'IT', 'ITA', 'إيطاليا'),
(73388, 3279317760, 3279317887, 'DE', 'DEU', 'ألمانيا'),
(73389, 3279317888, 3279317951, 'IT', 'ITA', 'إيطاليا'),
(73390, 3279317952, 3279317967, 'DE', 'DEU', 'ألمانيا'),
(73391, 3279317968, 3279317983, 'IT', 'ITA', 'إيطاليا'),
(73392, 3279317984, 3279318015, 'NL', 'NLD', 'هولندا'),
(73393, 3279318016, 3279318271, 'DE', 'DEU', 'ألمانيا'),
(73394, 3279318272, 3279318527, 'GB', 'GBR', 'المملكة المتحدة'),
(73395, 3279318528, 3279318559, 'CZ', 'CZE', 'التشيك'),
(73396, 3279318560, 3279318655, 'FR', 'FRA', 'فرنسا'),
(73397, 3279318656, 3279318687, 'CZ', 'CZE', 'التشيك'),
(73398, 3279318688, 3279318719, 'FR', 'FRA', 'فرنسا'),
(73399, 3279318720, 3279318751, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73400, 3279318752, 3279318783, 'GB', 'GBR', 'المملكة المتحدة'),
(73401, 3279318784, 3279319039, 'NL', 'NLD', 'هولندا'),
(73402, 3279319040, 3279320063, 'AT', 'AUT', 'النمسا'),
(73403, 3279320064, 3279321087, 'FR', 'FRA', 'فرنسا'),
(73404, 3279321088, 3279322623, 'DK', 'DNK', 'الدنيمارك'),
(73405, 3279322624, 3279322663, 'NL', 'NLD', 'هولندا'),
(73406, 3279322664, 3279322671, 'AT', 'AUT', 'النمسا'),
(73407, 3279322672, 3279322687, 'GB', 'GBR', 'المملكة المتحدة'),
(73408, 3279322688, 3279322879, 'DE', 'DEU', 'ألمانيا'),
(73409, 3279322880, 3279322975, 'NL', 'NLD', 'هولندا'),
(73410, 3279322976, 3279323071, 'DE', 'DEU', 'ألمانيا'),
(73411, 3279323072, 3279330079, 'GB', 'GBR', 'المملكة المتحدة'),
(73412, 3279330080, 3279330111, 'DK', 'DNK', 'الدنيمارك'),
(73413, 3279330112, 3279330815, 'GB', 'GBR', 'المملكة المتحدة'),
(73414, 3279331072, 3279335295, 'GB', 'GBR', 'المملكة المتحدة'),
(73415, 3279335296, 3279335423, 'BE', 'BEL', 'بلجيكا'),
(73416, 3279335424, 3279339519, 'GB', 'GBR', 'المملكة المتحدة'),
(73417, 3279339520, 3279340031, 'ES', 'ESP', 'إسبانيا'),
(73418, 3279340032, 3279340543, 'IT', 'ITA', 'إيطاليا'),
(73419, 3279340544, 3279340671, 'FR', 'FRA', 'فرنسا'),
(73420, 3279340800, 3279341055, 'FR', 'FRA', 'فرنسا'),
(73421, 3279341056, 3279341567, 'IT', 'ITA', 'إيطاليا'),
(73422, 3279341568, 3279341823, 'SE', 'SWE', 'السويد'),
(73423, 3279341824, 3279342079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73424, 3279342080, 3279342335, 'IT', 'ITA', 'إيطاليا'),
(73425, 3279342336, 3279342591, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73426, 3279342592, 3279342847, 'SE', 'SWE', 'السويد'),
(73427, 3279342848, 3279343103, 'HR', 'HRV', 'كرواتيا'),
(73428, 3279343104, 3279343359, 'SI', 'SVN', 'سلوفينيا'),
(73429, 3279343360, 3279343615, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(73430, 3279343616, 3279345151, 'BE', 'BEL', 'بلجيكا'),
(73431, 3279345152, 3279345663, 'SE', 'SWE', 'السويد'),
(73432, 3279345664, 3279346943, 'GB', 'GBR', 'المملكة المتحدة'),
(73433, 3279346944, 3279347711, 'FR', 'FRA', 'فرنسا'),
(73434, 3279347712, 3279348223, 'SE', 'SWE', 'السويد'),
(73435, 3279348224, 3279348735, 'IT', 'ITA', 'إيطاليا'),
(73436, 3279348736, 3279348991, 'GB', 'GBR', 'المملكة المتحدة'),
(73437, 3279348992, 3279349247, 'ES', 'ESP', 'إسبانيا'),
(73438, 3279349248, 3279349503, 'IT', 'ITA', 'إيطاليا'),
(73439, 3279349504, 3279349759, 'FR', 'FRA', 'فرنسا'),
(73440, 3279349760, 3279351039, 'DE', 'DEU', 'ألمانيا'),
(73441, 3279351040, 3279351295, 'FR', 'FRA', 'فرنسا'),
(73442, 3279351296, 3279351807, 'GB', 'GBR', 'المملكة المتحدة'),
(73443, 3279351808, 3279352319, 'DK', 'DNK', 'الدنيمارك'),
(73444, 3279352320, 3279352575, 'GB', 'GBR', 'المملكة المتحدة'),
(73445, 3279352576, 3279352831, 'BE', 'BEL', 'بلجيكا'),
(73446, 3279352832, 3279352855, 'SE', 'SWE', 'السويد'),
(73447, 3279353088, 3279353343, 'GB', 'GBR', 'المملكة المتحدة'),
(73448, 3279353344, 3279354879, 'DK', 'DNK', 'الدنيمارك'),
(73449, 3279354880, 3279355647, 'AT', 'AUT', 'النمسا'),
(73450, 3279355648, 3279355903, 'BE', 'BEL', 'بلجيكا'),
(73451, 3279356040, 3279356047, 'NO', 'NOR', 'النرويج'),
(73452, 3279356064, 3279356127, 'NO', 'NOR', 'النرويج'),
(73453, 3279356160, 3279356415, 'NO', 'NOR', 'النرويج'),
(73454, 3279356928, 3279357439, 'NO', 'NOR', 'النرويج'),
(73455, 3279372288, 3279372799, 'FI', 'FIN', 'فنلندا'),
(73456, 3279373056, 3279375359, 'FI', 'FIN', 'فنلندا'),
(73457, 3279380480, 3279380991, 'CH', 'CHE', 'سويسرا'),
(73458, 3279382784, 3279383807, 'CH', 'CHE', 'سويسرا'),
(73459, 3279384064, 3279385343, 'CH', 'CHE', 'سويسرا'),
(73460, 3279386368, 3279386495, 'CH', 'CHE', 'سويسرا'),
(73461, 3279387136, 3279387391, 'CH', 'CHE', 'سويسرا'),
(73462, 3279388672, 3279388927, 'GR', 'GRC', 'اليونان'),
(73463, 3279389184, 3279389243, 'GR', 'GRC', 'اليونان'),
(73464, 3279389248, 3279389255, 'GR', 'GRC', 'اليونان'),
(73465, 3279389260, 3279389275, 'GR', 'GRC', 'اليونان'),
(73466, 3279389280, 3279389359, 'GR', 'GRC', 'اليونان'),
(73467, 3279389364, 3279389379, 'GR', 'GRC', 'اليونان'),
(73468, 3279389384, 3279389439, 'GR', 'GRC', 'اليونان'),
(73469, 3279389712, 3279389727, 'GR', 'GRC', 'اليونان'),
(73470, 3279390016, 3279390143, 'GR', 'GRC', 'اليونان'),
(73471, 3279393792, 3279394047, 'GR', 'GRC', 'اليونان'),
(73472, 3279394304, 3279394559, 'GR', 'GRC', 'اليونان'),
(73473, 3279402752, 3279403007, 'CZ', 'CZE', 'التشيك'),
(73474, 3279403264, 3279403903, 'CZ', 'CZE', 'التشيك'),
(73475, 3279404288, 3279404415, 'CZ', 'CZE', 'التشيك'),
(73476, 3279404800, 3279405055, 'CZ', 'CZE', 'التشيك'),
(73477, 3279421440, 3279486975, 'IT', 'ITA', 'إيطاليا'),
(73478, 3279486976, 3279552511, 'NL', 'NLD', 'هولندا'),
(73479, 3279552512, 3279560703, 'LV', 'LVA', 'لاتفيا'),
(73480, 3279560704, 3279568895, 'GB', 'GBR', 'المملكة المتحدة'),
(73481, 3279568896, 3279577087, 'IT', 'ITA', 'إيطاليا'),
(73482, 3279577088, 3279585279, 'BE', 'BEL', 'بلجيكا'),
(73483, 3279585280, 3279585919, 'DE', 'DEU', 'ألمانيا'),
(73484, 3279585920, 3279585951, 'GB', 'GBR', 'المملكة المتحدة'),
(73485, 3279585952, 3279585991, 'DE', 'DEU', 'ألمانيا'),
(73486, 3279585992, 3279585999, 'GB', 'GBR', 'المملكة المتحدة'),
(73487, 3279586000, 3279586303, 'DE', 'DEU', 'ألمانيا'),
(73488, 3279586304, 3279586559, 'GB', 'GBR', 'المملكة المتحدة'),
(73489, 3279586560, 3279588095, 'DE', 'DEU', 'ألمانيا'),
(73490, 3279588096, 3279588607, 'GB', 'GBR', 'المملكة المتحدة'),
(73491, 3279588608, 3279588863, 'DE', 'DEU', 'ألمانيا'),
(73492, 3279588864, 3279590655, 'GB', 'GBR', 'المملكة المتحدة'),
(73493, 3279590656, 3279590935, 'DE', 'DEU', 'ألمانيا'),
(73494, 3279590936, 3279591167, 'GB', 'GBR', 'المملكة المتحدة'),
(73495, 3279591168, 3279591935, 'DE', 'DEU', 'ألمانيا'),
(73496, 3279591936, 3279592959, 'GB', 'GBR', 'المملكة المتحدة'),
(73497, 3279592960, 3279593215, 'DE', 'DEU', 'ألمانيا'),
(73498, 3279593216, 3279593247, 'GB', 'GBR', 'المملكة المتحدة'),
(73499, 3279593248, 3279593267, 'DE', 'DEU', 'ألمانيا'),
(73500, 3279593268, 3279593271, 'GB', 'GBR', 'المملكة المتحدة'),
(73501, 3279593272, 3279593275, 'DE', 'DEU', 'ألمانيا'),
(73502, 3279593276, 3279593407, 'GB', 'GBR', 'المملكة المتحدة'),
(73503, 3279593408, 3279593440, 'DE', 'DEU', 'ألمانيا'),
(73504, 3279593441, 3279593471, 'GB', 'GBR', 'المملكة المتحدة'),
(73505, 3279593472, 3279593487, 'DE', 'DEU', 'ألمانيا'),
(73506, 3279593488, 3279593535, 'GB', 'GBR', 'المملكة المتحدة'),
(73507, 3279593536, 3279593567, 'DE', 'DEU', 'ألمانيا'),
(73508, 3279593568, 3279593599, 'GB', 'GBR', 'المملكة المتحدة'),
(73509, 3279593600, 3279593727, 'DE', 'DEU', 'ألمانيا'),
(73510, 3279593728, 3279595903, 'GB', 'GBR', 'المملكة المتحدة'),
(73511, 3279595904, 3279595999, 'DE', 'DEU', 'ألمانيا'),
(73512, 3279596000, 3279596023, 'GB', 'GBR', 'المملكة المتحدة'),
(73513, 3279596024, 3279596031, 'DE', 'DEU', 'ألمانيا'),
(73514, 3279596032, 3279596543, 'GB', 'GBR', 'المملكة المتحدة'),
(73515, 3279596544, 3279597311, 'DE', 'DEU', 'ألمانيا'),
(73516, 3279597312, 3279600383, 'GB', 'GBR', 'المملكة المتحدة'),
(73517, 3279600384, 3279600479, 'DE', 'DEU', 'ألمانيا'),
(73518, 3279600480, 3279600487, 'GB', 'GBR', 'المملكة المتحدة'),
(73519, 3279600488, 3279600639, 'DE', 'DEU', 'ألمانيا'),
(73520, 3279600640, 3279601663, 'GB', 'GBR', 'المملكة المتحدة'),
(73521, 3279601664, 3279609855, 'CZ', 'CZE', 'التشيك'),
(73522, 3279609856, 3279618047, 'RU', 'RUS', 'الإتحاد الروسي'),
(73523, 3279618048, 3279683583, 'UA', 'UKR', 'أوكرانيا'),
(73524, 3279683584, 3279752959, 'DE', 'DEU', 'ألمانيا'),
(73525, 3279752960, 3279753215, 'CH', 'CHE', 'سويسرا'),
(73526, 3279753216, 3279946751, 'DE', 'DEU', 'ألمانيا'),
(73527, 3279946752, 3279947775, 'SE', 'SWE', 'السويد'),
(73528, 3279947776, 3279948799, 'NL', 'NLD', 'هولندا'),
(73529, 3279948800, 3279949823, 'GB', 'GBR', 'المملكة المتحدة'),
(73530, 3279949824, 3279950847, 'UA', 'UKR', 'أوكرانيا'),
(73531, 3279950848, 3279951871, 'DE', 'DEU', 'ألمانيا'),
(73532, 3279951872, 3279952895, 'IQ', 'IRQ', 'العراق'),
(73533, 3279952896, 3279953919, 'PL', 'POL', 'بولندا'),
(73534, 3279953920, 3279955967, 'TR', 'TUR', 'تركيا'),
(73535, 3279955968, 3279958015, 'DE', 'DEU', 'ألمانيا'),
(73536, 3279958016, 3279972351, 'RU', 'RUS', 'الإتحاد الروسي'),
(73537, 3279972352, 3279974399, 'AT', 'AUT', 'النمسا'),
(73538, 3279974400, 3279976447, 'PL', 'POL', 'بولندا'),
(73539, 3279976448, 3279986687, 'RU', 'RUS', 'الإتحاد الروسي'),
(73540, 3279986688, 3279987199, 'NL', 'NLD', 'هولندا'),
(73541, 3279987200, 3279987711, 'RU', 'RUS', 'الإتحاد الروسي'),
(73542, 3279987712, 3279988223, 'RO', 'ROM', 'رومانيا'),
(73543, 3279988736, 3279989247, 'RO', 'ROM', 'رومانيا'),
(73544, 3279989248, 3279989759, 'AT', 'AUT', 'النمسا'),
(73545, 3279989760, 3279990271, 'PL', 'POL', 'بولندا'),
(73546, 3279990272, 3279990783, 'DK', 'DNK', 'الدنيمارك'),
(73547, 3279990784, 3279991295, 'IL', 'ISR', 'إسرائيل'),
(73548, 3279991296, 3279991807, 'UA', 'UKR', 'أوكرانيا'),
(73549, 3279991808, 3279992319, 'PL', 'POL', 'بولندا'),
(73550, 3279992320, 3279992831, 'UA', 'UKR', 'أوكرانيا'),
(73551, 3279992832, 3279993855, 'NL', 'NLD', 'هولندا'),
(73552, 3279993856, 3279994367, 'RO', 'ROM', 'رومانيا'),
(73553, 3279994368, 3279994879, 'GB', 'GBR', 'المملكة المتحدة'),
(73554, 3279994880, 3280003071, 'CZ', 'CZE', 'التشيك'),
(73555, 3280003072, 3280003583, 'BG', 'BGR', 'بلغاريا'),
(73556, 3280003584, 3280004095, 'UA', 'UKR', 'أوكرانيا'),
(73557, 3280004096, 3280004607, 'PL', 'POL', 'بولندا'),
(73558, 3280004608, 3280005119, 'UA', 'UKR', 'أوكرانيا'),
(73559, 3280005120, 3280005631, 'HU', 'HUN', 'هنغاريا'),
(73560, 3280005632, 3280006143, 'IT', 'ITA', 'إيطاليا'),
(73561, 3280006144, 3280006655, 'DK', 'DNK', 'الدنيمارك'),
(73562, 3280006656, 3280007167, 'GB', 'GBR', 'المملكة المتحدة'),
(73563, 3280007168, 3280007679, 'SE', 'SWE', 'السويد'),
(73564, 3280007680, 3280008191, 'PL', 'POL', 'بولندا'),
(73565, 3280008192, 3280009215, 'RU', 'RUS', 'الإتحاد الروسي'),
(73566, 3280009216, 3280009727, 'UA', 'UKR', 'أوكرانيا'),
(73567, 3280009728, 3280010239, 'GB', 'GBR', 'المملكة المتحدة'),
(73568, 3280010240, 3280010751, 'UA', 'UKR', 'أوكرانيا'),
(73569, 3280010752, 3280011263, 'TR', 'TUR', 'تركيا'),
(73570, 3280011264, 3280011327, 'DE', 'DEU', 'ألمانيا'),
(73571, 3280011328, 3280011391, 'NL', 'NLD', 'هولندا'),
(73572, 3280011408, 3280011415, 'GB', 'GBR', 'المملكة المتحدة'),
(73573, 3280011552, 3280011567, 'GB', 'GBR', 'المملكة المتحدة'),
(73574, 3280011648, 3280011775, 'IT', 'ITA', 'إيطاليا'),
(73575, 3280011776, 3280011783, 'NL', 'NLD', 'هولندا'),
(73576, 3280011784, 3280011791, 'BE', 'BEL', 'بلجيكا'),
(73577, 3280011904, 3280011951, 'BE', 'BEL', 'بلجيكا'),
(73578, 3280014848, 3280015103, 'FR', 'FRA', 'فرنسا'),
(73579, 3280015104, 3280015359, 'GB', 'GBR', 'المملكة المتحدة'),
(73580, 3280015872, 3280016383, 'GB', 'GBR', 'المملكة المتحدة'),
(73581, 3280016448, 3280016463, 'BE', 'BEL', 'بلجيكا'),
(73582, 3280016544, 3280016559, 'BE', 'BEL', 'بلجيكا'),
(73583, 3280016560, 3280016575, 'GR', 'GRC', 'اليونان'),
(73584, 3280016576, 3280016607, 'NO', 'NOR', 'النرويج'),
(73585, 3280016608, 3280016623, 'CH', 'CHE', 'سويسرا'),
(73586, 3280016960, 3280016991, 'BE', 'BEL', 'بلجيكا'),
(73587, 3280016992, 3280017023, 'FR', 'FRA', 'فرنسا'),
(73588, 3280017024, 3280017055, 'IT', 'ITA', 'إيطاليا'),
(73589, 3280017088, 3280017151, 'IE', 'IRL', 'إيرلندا'),
(73590, 3280017920, 3280018431, 'IT', 'ITA', 'إيطاليا'),
(73591, 3280018432, 3280019455, 'GB', 'GBR', 'المملكة المتحدة'),
(73592, 3280019712, 3280020479, 'CH', 'CHE', 'سويسرا'),
(73593, 3280020480, 3280020735, 'IE', 'IRL', 'إيرلندا'),
(73594, 3280020736, 3280020991, 'BE', 'BEL', 'بلجيكا'),
(73595, 3280020992, 3280021087, 'GB', 'GBR', 'المملكة المتحدة'),
(73596, 3280021120, 3280021183, 'NL', 'NLD', 'هولندا'),
(73597, 3280021248, 3280021503, 'CH', 'CHE', 'سويسرا'),
(73598, 3280021760, 3280021823, 'BE', 'BEL', 'بلجيكا'),
(73599, 3280022784, 3280023039, 'IT', 'ITA', 'إيطاليا'),
(73600, 3280023552, 3280024575, 'IT', 'ITA', 'إيطاليا'),
(73601, 3280024576, 3280024831, 'SE', 'SWE', 'السويد'),
(73602, 3280027136, 3280027391, 'IE', 'IRL', 'إيرلندا'),
(73603, 3280027648, 3280027903, 'CH', 'CHE', 'سويسرا'),
(73604, 3280028160, 3280028415, 'IT', 'ITA', 'إيطاليا'),
(73605, 3280028416, 3280028671, 'BE', 'BEL', 'بلجيكا'),
(73606, 3280030208, 3280030463, 'CH', 'CHE', 'سويسرا'),
(73607, 3280031744, 3280031999, 'IE', 'IRL', 'إيرلندا'),
(73608, 3280032128, 3280032255, 'CH', 'CHE', 'سويسرا'),
(73609, 3280035328, 3280035583, 'CH', 'CHE', 'سويسرا'),
(73610, 3280036608, 3280036863, 'CH', 'CHE', 'سويسرا'),
(73611, 3280037888, 3280038399, 'CH', 'CHE', 'سويسرا'),
(73612, 3280041472, 3280041727, 'CH', 'CHE', 'سويسرا'),
(73613, 3280076800, 3280084991, 'GB', 'GBR', 'المملكة المتحدة'),
(73614, 3280084992, 3280093183, 'BA', 'BIH', 'البوسنه والهرسك'),
(73615, 3280093184, 3280109567, 'GR', 'GRC', 'اليونان'),
(73616, 3280109568, 3280117759, 'BE', 'BEL', 'بلجيكا'),
(73617, 3280117760, 3280125951, 'CH', 'CHE', 'سويسرا'),
(73618, 3280125952, 3280126207, 'DE', 'DEU', 'ألمانيا'),
(73619, 3280126208, 3280126463, 'IS', 'ISL', 'أيسلندا'),
(73620, 3280126464, 3280126719, 'SI', 'SVN', 'سلوفينيا'),
(73621, 3280126720, 3280126975, 'IT', 'ITA', 'إيطاليا'),
(73622, 3280126976, 3280127231, 'CH', 'CHE', 'سويسرا'),
(73623, 3280127232, 3280127487, 'PL', 'POL', 'بولندا'),
(73624, 3280127488, 3280127743, 'AT', 'AUT', 'النمسا'),
(73625, 3280128000, 3280128255, 'SE', 'SWE', 'السويد'),
(73626, 3280128256, 3280128511, 'GB', 'GBR', 'المملكة المتحدة'),
(73627, 3280128512, 3280129023, 'HU', 'HUN', 'هنغاريا'),
(73628, 3280129024, 3280129279, 'RU', 'RUS', 'الإتحاد الروسي'),
(73629, 3280129280, 3280129535, 'LV', 'LVA', 'لاتفيا'),
(73630, 3280129536, 3280129791, 'SA', 'SAU', 'السعودية'),
(73631, 3280129792, 3280130047, 'FR', 'FRA', 'فرنسا'),
(73632, 3280130048, 3280130559, 'RU', 'RUS', 'الإتحاد الروسي'),
(73633, 3280130560, 3280130815, 'GB', 'GBR', 'المملكة المتحدة'),
(73634, 3280130816, 3280131071, 'IS', 'ISL', 'أيسلندا'),
(73635, 3280131072, 3280131327, 'PL', 'POL', 'بولندا'),
(73636, 3280131328, 3280131583, 'IT', 'ITA', 'إيطاليا'),
(73637, 3280131584, 3280131839, 'RU', 'RUS', 'الإتحاد الروسي'),
(73638, 3280131840, 3280132095, 'RO', 'ROM', 'رومانيا'),
(73639, 3280132096, 3280132351, 'RU', 'RUS', 'الإتحاد الروسي'),
(73640, 3280132352, 3280132607, 'GB', 'GBR', 'المملكة المتحدة'),
(73641, 3280132608, 3280132863, 'CH', 'CHE', 'سويسرا'),
(73642, 3280132864, 3280133119, 'UA', 'UKR', 'أوكرانيا'),
(73643, 3280133120, 3280133375, 'IT', 'ITA', 'إيطاليا'),
(73644, 3280133376, 3280133631, 'DE', 'DEU', 'ألمانيا'),
(73645, 3280133632, 3280133887, 'FR', 'FRA', 'فرنسا'),
(73646, 3280133888, 3280134143, 'NL', 'NLD', 'هولندا'),
(73647, 3280134144, 3280142335, 'IT', 'ITA', 'إيطاليا'),
(73648, 3280142336, 3280144815, 'RU', 'RUS', 'الإتحاد الروسي'),
(73649, 3280144816, 3280144823, 'RO', 'ROM', 'رومانيا'),
(73650, 3280144824, 3280207871, 'RU', 'RUS', 'الإتحاد الروسي'),
(73651, 3280207872, 3280273407, 'FR', 'FRA', 'فرنسا'),
(73652, 3280273408, 3280338943, 'RU', 'RUS', 'الإتحاد الروسي'),
(73653, 3280338944, 3280347135, 'GB', 'GBR', 'المملكة المتحدة'),
(73654, 3280347136, 3280355327, 'NO', 'NOR', 'النرويج'),
(73655, 3280355328, 3280371711, 'GR', 'GRC', 'اليونان'),
(73656, 3280371712, 3280379903, 'CH', 'CHE', 'سويسرا'),
(73657, 3280379904, 3280388095, 'FR', 'FRA', 'فرنسا'),
(73658, 3280388096, 3280388159, 'GB', 'GBR', 'المملكة المتحدة'),
(73659, 3280388160, 3280388191, 'FR', 'FRA', 'فرنسا'),
(73660, 3280388192, 3280388223, 'GB', 'GBR', 'المملكة المتحدة'),
(73661, 3280388224, 3280388759, 'FR', 'FRA', 'فرنسا'),
(73662, 3280388760, 3280388767, 'GB', 'GBR', 'المملكة المتحدة'),
(73663, 3280388768, 3280388799, 'FR', 'FRA', 'فرنسا'),
(73664, 3280388800, 3280388831, 'GB', 'GBR', 'المملكة المتحدة'),
(73665, 3280388832, 3280390655, 'FR', 'FRA', 'فرنسا'),
(73666, 3280390656, 3280390719, 'GB', 'GBR', 'المملكة المتحدة'),
(73667, 3280390720, 3280390751, 'FR', 'FRA', 'فرنسا'),
(73668, 3280390752, 3280390783, 'GB', 'GBR', 'المملكة المتحدة'),
(73669, 3280390784, 3280390815, 'FR', 'FRA', 'فرنسا'),
(73670, 3280390816, 3280390879, 'GB', 'GBR', 'المملكة المتحدة'),
(73671, 3280390880, 3280390911, 'FR', 'FRA', 'فرنسا'),
(73672, 3280390912, 3280391039, 'GB', 'GBR', 'المملكة المتحدة'),
(73673, 3280391040, 3280391551, 'FR', 'FRA', 'فرنسا'),
(73674, 3280391552, 3280391583, 'GB', 'GBR', 'المملكة المتحدة'),
(73675, 3280391584, 3280391743, 'FR', 'FRA', 'فرنسا'),
(73676, 3280391744, 3280391775, 'GB', 'GBR', 'المملكة المتحدة'),
(73677, 3280391776, 3280391807, 'FR', 'FRA', 'فرنسا'),
(73678, 3280391808, 3280391967, 'GB', 'GBR', 'المملكة المتحدة'),
(73679, 3280391968, 3280392007, 'FR', 'FRA', 'فرنسا'),
(73680, 3280392008, 3280392031, 'GB', 'GBR', 'المملكة المتحدة'),
(73681, 3280392032, 3280392063, 'FR', 'FRA', 'فرنسا'),
(73682, 3280392064, 3280392095, 'GB', 'GBR', 'المملكة المتحدة'),
(73683, 3280392096, 3280392127, 'FR', 'FRA', 'فرنسا'),
(73684, 3280392128, 3280392191, 'CH', 'CHE', 'سويسرا'),
(73685, 3280392192, 3280392319, 'FR', 'FRA', 'فرنسا'),
(73686, 3280392320, 3280392383, 'GB', 'GBR', 'المملكة المتحدة'),
(73687, 3280392384, 3280392415, 'FR', 'FRA', 'فرنسا'),
(73688, 3280392416, 3280392447, 'GB', 'GBR', 'المملكة المتحدة'),
(73689, 3280392448, 3280392463, 'FR', 'FRA', 'فرنسا'),
(73690, 3280392464, 3280392639, 'GB', 'GBR', 'المملكة المتحدة'),
(73691, 3280392640, 3280392671, 'FR', 'FRA', 'فرنسا'),
(73692, 3280392672, 3280392703, 'GB', 'GBR', 'المملكة المتحدة'),
(73693, 3280392704, 3280392831, 'FR', 'FRA', 'فرنسا'),
(73694, 3280392832, 3280393023, 'GB', 'GBR', 'المملكة المتحدة'),
(73695, 3280393024, 3280393055, 'FR', 'FRA', 'فرنسا'),
(73696, 3280393056, 3280393087, 'GB', 'GBR', 'المملكة المتحدة'),
(73697, 3280393088, 3280393151, 'FR', 'FRA', 'فرنسا'),
(73698, 3280393152, 3280393343, 'GB', 'GBR', 'المملكة المتحدة'),
(73699, 3280393344, 3280393375, 'FR', 'FRA', 'فرنسا'),
(73700, 3280393376, 3280393407, 'GB', 'GBR', 'المملكة المتحدة'),
(73701, 3280393408, 3280393535, 'FR', 'FRA', 'فرنسا'),
(73702, 3280393536, 3280393599, 'GB', 'GBR', 'المملكة المتحدة'),
(73703, 3280393600, 3280393631, 'FR', 'FRA', 'فرنسا'),
(73704, 3280393632, 3280393695, 'GB', 'GBR', 'المملكة المتحدة'),
(73705, 3280393696, 3280393727, 'FR', 'FRA', 'فرنسا'),
(73706, 3280393728, 3280394367, 'GB', 'GBR', 'المملكة المتحدة'),
(73707, 3280394368, 3280394431, 'FR', 'FRA', 'فرنسا'),
(73708, 3280394432, 3280394463, 'GB', 'GBR', 'المملكة المتحدة'),
(73709, 3280394464, 3280394495, 'FR', 'FRA', 'فرنسا'),
(73710, 3280394496, 3280394527, 'GB', 'GBR', 'المملكة المتحدة'),
(73711, 3280394528, 3280394559, 'FR', 'FRA', 'فرنسا'),
(73712, 3280394560, 3280394623, 'GB', 'GBR', 'المملكة المتحدة'),
(73713, 3280394624, 3280395519, 'FR', 'FRA', 'فرنسا'),
(73714, 3280395520, 3280395647, 'GB', 'GBR', 'المملكة المتحدة'),
(73715, 3280395648, 3280395839, 'FR', 'FRA', 'فرنسا'),
(73716, 3280395840, 3280396031, 'GB', 'GBR', 'المملكة المتحدة'),
(73717, 3280396032, 3280396055, 'FR', 'FRA', 'فرنسا'),
(73718, 3280396056, 3280396071, 'GB', 'GBR', 'المملكة المتحدة'),
(73719, 3280396072, 3280396095, 'FR', 'FRA', 'فرنسا'),
(73720, 3280396096, 3280396191, 'GB', 'GBR', 'المملكة المتحدة'),
(73721, 3280396192, 3280396223, 'FR', 'FRA', 'فرنسا'),
(73722, 3280396224, 3280396255, 'GB', 'GBR', 'المملكة المتحدة'),
(73723, 3280396256, 3280396263, 'FR', 'FRA', 'فرنسا'),
(73724, 3280396264, 3280396287, 'GB', 'GBR', 'المملكة المتحدة'),
(73725, 3280396288, 3280404479, 'FI', 'FIN', 'فنلندا'),
(73726, 3280404480, 3280437247, 'IT', 'ITA', 'إيطاليا'),
(73727, 3280437248, 3280453631, 'DE', 'DEU', 'ألمانيا'),
(73728, 3280453632, 3280454655, 'RO', 'ROM', 'رومانيا'),
(73729, 3280454656, 3280455679, 'UA', 'UKR', 'أوكرانيا'),
(73730, 3280455680, 3280456703, 'IT', 'ITA', 'إيطاليا'),
(73731, 3280456704, 3280457727, 'RU', 'RUS', 'الإتحاد الروسي'),
(73732, 3280457728, 3280458751, 'GB', 'GBR', 'المملكة المتحدة'),
(73733, 3280458752, 3280459775, 'RU', 'RUS', 'الإتحاد الروسي'),
(73734, 3280459776, 3280460799, 'DK', 'DNK', 'الدنيمارك'),
(73735, 3280460800, 3280462847, 'DE', 'DEU', 'ألمانيا'),
(73736, 3280463872, 3280466943, 'RU', 'RUS', 'الإتحاد الروسي'),
(73737, 3280466944, 3280467967, 'UA', 'UKR', 'أوكرانيا'),
(73738, 3280468992, 3280470015, 'CY', 'CYP', 'قبرص'),
(73739, 3280470016, 3280535551, 'PL', 'POL', 'بولندا'),
(73740, 3280535552, 3280568319, 'GB', 'GBR', 'المملكة المتحدة'),
(73741, 3280568320, 3280576511, 'IT', 'ITA', 'إيطاليا'),
(73742, 3280576512, 3280576767, 'BY', 'BLR', 'روسيا البيضاء'),
(73743, 3280576768, 3280577279, 'PL', 'POL', 'بولندا'),
(73744, 3280577280, 3280577535, 'DE', 'DEU', 'ألمانيا'),
(73745, 3280577536, 3280577791, 'IL', 'ISR', 'إسرائيل'),
(73746, 3280577792, 3280578047, 'NL', 'NLD', 'هولندا'),
(73747, 3280578048, 3280578303, 'RO', 'ROM', 'رومانيا'),
(73748, 3280578304, 3280578559, 'UA', 'UKR', 'أوكرانيا'),
(73749, 3280578560, 3280578815, 'PL', 'POL', 'بولندا'),
(73750, 3280578816, 3280579071, 'NL', 'NLD', 'هولندا'),
(73751, 3280579072, 3280579327, 'DE', 'DEU', 'ألمانيا'),
(73752, 3280579328, 3280579583, 'RU', 'RUS', 'الإتحاد الروسي'),
(73753, 3280579584, 3280579839, 'CH', 'CHE', 'سويسرا'),
(73754, 3280579840, 3280580095, 'HR', 'HRV', 'كرواتيا'),
(73755, 3280580096, 3280580351, 'KW', 'KWT', 'الكويت'),
(73756, 3280580352, 3280580607, 'CH', 'CHE', 'سويسرا'),
(73757, 3280580608, 3280580863, 'GB', 'GBR', 'المملكة المتحدة'),
(73758, 3280580864, 3280581119, 'DE', 'DEU', 'ألمانيا'),
(73759, 3280581120, 3280581375, 'DK', 'DNK', 'الدنيمارك'),
(73760, 3280581376, 3280581631, 'EE', 'EST', 'إستونيا'),
(73761, 3280581632, 3280581887, 'BY', 'BLR', 'روسيا البيضاء'),
(73762, 3280581888, 3280582143, 'FR', 'FRA', 'فرنسا'),
(73763, 3280582144, 3280582399, 'CZ', 'CZE', 'التشيك'),
(73764, 3280582400, 3280582655, 'DK', 'DNK', 'الدنيمارك'),
(73765, 3280582656, 3280582911, 'FR', 'FRA', 'فرنسا'),
(73766, 3280582912, 3280583167, 'UA', 'UKR', 'أوكرانيا'),
(73767, 3280583168, 3280583423, 'RO', 'ROM', 'رومانيا'),
(73768, 3280583424, 3280583679, 'RU', 'RUS', 'الإتحاد الروسي'),
(73769, 3280583680, 3280583935, 'PS', 'PSE', 'فلسطين المحتلة'),
(73770, 3280583936, 3280584191, 'PL', 'POL', 'بولندا'),
(73771, 3280584192, 3280584447, 'RO', 'ROM', 'رومانيا'),
(73772, 3280584448, 3280584703, 'DE', 'DEU', 'ألمانيا'),
(73773, 3280584704, 3280585215, 'UA', 'UKR', 'أوكرانيا'),
(73774, 3280585216, 3280585727, 'DK', 'DNK', 'الدنيمارك'),
(73775, 3280585728, 3280586239, 'UA', 'UKR', 'أوكرانيا'),
(73776, 3280586240, 3280586751, 'DE', 'DEU', 'ألمانيا'),
(73777, 3280586752, 3280587263, 'RU', 'RUS', 'الإتحاد الروسي'),
(73778, 3280587264, 3280587775, 'UA', 'UKR', 'أوكرانيا'),
(73779, 3280587776, 3280588287, 'RO', 'ROM', 'رومانيا'),
(73780, 3280588288, 3280588799, 'UA', 'UKR', 'أوكرانيا'),
(73781, 3280588800, 3280589311, 'PL', 'POL', 'بولندا'),
(73782, 3280589312, 3280590335, 'DE', 'DEU', 'ألمانيا'),
(73783, 3280590336, 3280590847, 'NL', 'NLD', 'هولندا'),
(73784, 3280590848, 3280591359, 'DE', 'DEU', 'ألمانيا'),
(73785, 3280591872, 3280592383, 'GB', 'GBR', 'المملكة المتحدة'),
(73786, 3280592384, 3280592895, 'TR', 'TUR', 'تركيا'),
(73787, 3280592896, 3280593407, 'DE', 'DEU', 'ألمانيا'),
(73788, 3280593408, 3280593919, 'UA', 'UKR', 'أوكرانيا'),
(73789, 3280593920, 3280594431, 'LU', 'LUX', 'لوكسيمبورغ'),
(73790, 3280594432, 3280594943, 'NL', 'NLD', 'هولندا'),
(73791, 3280594944, 3280595455, 'UA', 'UKR', 'أوكرانيا'),
(73792, 3280595456, 3280595967, 'DE', 'DEU', 'ألمانيا'),
(73793, 3280595968, 3280596479, 'DK', 'DNK', 'الدنيمارك'),
(73794, 3280596480, 3280596991, 'AT', 'AUT', 'النمسا'),
(73795, 3280596992, 3280597503, 'UA', 'UKR', 'أوكرانيا'),
(73796, 3280597504, 3280598015, 'FR', 'FRA', 'فرنسا'),
(73797, 3280598016, 3280598527, 'UA', 'UKR', 'أوكرانيا'),
(73798, 3280598528, 3280599039, 'PL', 'POL', 'بولندا'),
(73799, 3280599040, 3280599551, 'FR', 'FRA', 'فرنسا'),
(73800, 3280599552, 3280600063, 'UA', 'UKR', 'أوكرانيا'),
(73801, 3280600064, 3280600575, 'BG', 'BGR', 'بلغاريا'),
(73802, 3280600576, 3280601087, 'UA', 'UKR', 'أوكرانيا'),
(73803, 3280601088, 3280609279, 'PT', 'PRT', 'البورتوغال'),
(73804, 3280609280, 3280617471, 'DE', 'DEU', 'ألمانيا'),
(73805, 3280617472, 3280625663, 'UA', 'UKR', 'أوكرانيا'),
(73806, 3280625664, 3280633855, 'MD', 'MDA', 'مولدوفا'),
(73807, 3280633856, 3280635807, 'BG', 'BGR', 'بلغاريا'),
(73808, 3280635808, 3280635815, 'DE', 'DEU', 'ألمانيا'),
(73809, 3280635816, 3280642047, 'BG', 'BGR', 'بلغاريا'),
(73810, 3280642048, 3280650239, 'UA', 'UKR', 'أوكرانيا'),
(73811, 3280650240, 3280650495, 'RO', 'ROM', 'رومانيا'),
(73812, 3280650496, 3280650751, 'UA', 'UKR', 'أوكرانيا'),
(73813, 3280650752, 3280651263, 'GB', 'GBR', 'المملكة المتحدة'),
(73814, 3280651264, 3280651519, 'SI', 'SVN', 'سلوفينيا'),
(73815, 3280651520, 3280651775, 'FR', 'FRA', 'فرنسا'),
(73816, 3280651776, 3280652031, 'UA', 'UKR', 'أوكرانيا'),
(73817, 3280652032, 3280652287, 'NO', 'NOR', 'النرويج'),
(73818, 3280652288, 3280652543, 'PL', 'POL', 'بولندا'),
(73819, 3280652544, 3280652799, 'SI', 'SVN', 'سلوفينيا'),
(73820, 3280652800, 3280653055, 'FR', 'FRA', 'فرنسا'),
(73821, 3280653056, 3280653311, 'CH', 'CHE', 'سويسرا'),
(73822, 3280653312, 3280653823, 'GB', 'GBR', 'المملكة المتحدة'),
(73823, 3280653824, 3280654079, 'RU', 'RUS', 'الإتحاد الروسي'),
(73824, 3280654080, 3280654335, 'CH', 'CHE', 'سويسرا'),
(73825, 3280654336, 3280654591, 'PL', 'POL', 'بولندا'),
(73826, 3280654592, 3280654847, 'ES', 'ESP', 'إسبانيا'),
(73827, 3280654848, 3280655103, 'RU', 'RUS', 'الإتحاد الروسي'),
(73828, 3280655104, 3280655359, 'PL', 'POL', 'بولندا'),
(73829, 3280655360, 3280655615, 'SE', 'SWE', 'السويد'),
(73830, 3280655616, 3280655871, 'FI', 'FIN', 'فنلندا'),
(73831, 3280655872, 3280656127, 'RO', 'ROM', 'رومانيا'),
(73832, 3280656128, 3280656639, 'CH', 'CHE', 'سويسرا'),
(73833, 3280656640, 3280657407, 'UA', 'UKR', 'أوكرانيا'),
(73834, 3280657408, 3280657663, 'RU', 'RUS', 'الإتحاد الروسي'),
(73835, 3280657664, 3280657919, 'SE', 'SWE', 'السويد'),
(73836, 3280657920, 3280658175, 'RO', 'ROM', 'رومانيا'),
(73837, 3280658176, 3280658431, 'DE', 'DEU', 'ألمانيا'),
(73838, 3280658432, 3280666623, 'GB', 'GBR', 'المملكة المتحدة'),
(73839, 3280666624, 3280732159, 'NO', 'NOR', 'النرويج'),
(73840, 3280732160, 3280764927, 'DE', 'DEU', 'ألمانيا'),
(73841, 3280764928, 3280765951, 'TJ', 'TJK', 'طاجيكيستان'),
(73842, 3280765952, 3280766975, 'DK', 'DNK', 'الدنيمارك'),
(73843, 3280766976, 3280767999, 'AT', 'AUT', 'النمسا'),
(73844, 3280768000, 3280769023, 'FR', 'FRA', 'فرنسا'),
(73845, 3280769024, 3280770047, 'NL', 'NLD', 'هولندا'),
(73846, 3280770048, 3280771071, 'FR', 'FRA', 'فرنسا'),
(73847, 3280771072, 3280772095, 'PL', 'POL', 'بولندا'),
(73848, 3280772096, 3280773119, 'ES', 'ESP', 'إسبانيا'),
(73849, 3280773120, 3280774143, 'UA', 'UKR', 'أوكرانيا'),
(73850, 3280774144, 3280775167, 'ME', 'MNE', 'الجبل الأسود'),
(73851, 3280775168, 3280776191, 'UA', 'UKR', 'أوكرانيا'),
(73852, 3280776192, 3280777215, 'SE', 'SWE', 'السويد'),
(73853, 3280777216, 3280778239, 'UA', 'UKR', 'أوكرانيا'),
(73854, 3280778240, 3280779263, 'RU', 'RUS', 'الإتحاد الروسي'),
(73855, 3280779264, 3280780287, 'DE', 'DEU', 'ألمانيا'),
(73856, 3280780288, 3280781311, 'PL', 'POL', 'بولندا'),
(73857, 3280781312, 3280782335, 'FI', 'FIN', 'فنلندا'),
(73858, 3280782336, 3280783359, 'TR', 'TUR', 'تركيا'),
(73859, 3280783360, 3280784383, 'SE', 'SWE', 'السويد'),
(73860, 3280784384, 3280785407, 'RU', 'RUS', 'الإتحاد الروسي'),
(73861, 3280785408, 3280787455, 'DE', 'DEU', 'ألمانيا'),
(73862, 3280787456, 3280788479, 'GB', 'GBR', 'المملكة المتحدة'),
(73863, 3280788480, 3280789503, 'PL', 'POL', 'بولندا'),
(73864, 3280789504, 3280790527, 'UA', 'UKR', 'أوكرانيا'),
(73865, 3280791552, 3280792575, 'DE', 'DEU', 'ألمانيا'),
(73866, 3280792576, 3280793599, 'PL', 'POL', 'بولندا'),
(73867, 3280793600, 3280794623, 'NL', 'NLD', 'هولندا'),
(73868, 3280794624, 3280795647, 'UA', 'UKR', 'أوكرانيا'),
(73869, 3280795648, 3280796671, 'MZ', 'MOZ', 'موزامبيق'),
(73870, 3280796672, 3280797695, 'CZ', 'CZE', 'التشيك'),
(73871, 3280797696, 3280810783, 'CH', 'CHE', 'سويسرا'),
(73872, 3280810784, 3280810799, 'DE', 'DEU', 'ألمانيا'),
(73873, 3280810800, 3280844292, 'CH', 'CHE', 'سويسرا'),
(73874, 3280844293, 3280844295, 'GB', 'GBR', 'المملكة المتحدة'),
(73875, 3280844296, 3280863231, 'CH', 'CHE', 'سويسرا'),
(73876, 3280863232, 3280928767, 'TR', 'TUR', 'تركيا'),
(73877, 3280928768, 3280928768, 'GB', 'GBR', 'المملكة المتحدة'),
(73878, 3280928769, 3280928769, 'DE', 'DEU', 'ألمانيا'),
(73879, 3280928770, 3280928771, 'GB', 'GBR', 'المملكة المتحدة'),
(73880, 3280928772, 3280928791, 'DE', 'DEU', 'ألمانيا'),
(73881, 3280928792, 3280928799, 'GB', 'GBR', 'المملكة المتحدة'),
(73882, 3280928800, 3280928815, 'DE', 'DEU', 'ألمانيا'),
(73883, 3280928816, 3280928831, 'GB', 'GBR', 'المملكة المتحدة'),
(73884, 3280928832, 3280928843, 'DE', 'DEU', 'ألمانيا'),
(73885, 3280928844, 3280928847, 'GB', 'GBR', 'المملكة المتحدة'),
(73886, 3280928848, 3280928849, 'DE', 'DEU', 'ألمانيا'),
(73887, 3280928850, 3280928854, 'GB', 'GBR', 'المملكة المتحدة'),
(73888, 3280928855, 3280928859, 'DE', 'DEU', 'ألمانيا'),
(73889, 3280928860, 3280928895, 'GB', 'GBR', 'المملكة المتحدة'),
(73890, 3280928896, 3280928906, 'DE', 'DEU', 'ألمانيا'),
(73891, 3280928907, 3280928907, 'GB', 'GBR', 'المملكة المتحدة'),
(73892, 3280928908, 3280928927, 'DE', 'DEU', 'ألمانيا'),
(73893, 3280928928, 3280928960, 'GB', 'GBR', 'المملكة المتحدة'),
(73894, 3280928961, 3280928961, 'DE', 'DEU', 'ألمانيا'),
(73895, 3280928962, 3280928962, 'GB', 'GBR', 'المملكة المتحدة'),
(73896, 3280928963, 3280928963, 'DE', 'DEU', 'ألمانيا'),
(73897, 3280928964, 3280928964, 'GB', 'GBR', 'المملكة المتحدة'),
(73898, 3280928965, 3280928965, 'DE', 'DEU', 'ألمانيا'),
(73899, 3280928966, 3280928991, 'GB', 'GBR', 'المملكة المتحدة'),
(73900, 3280928992, 3280928998, 'DE', 'DEU', 'ألمانيا'),
(73901, 3280928999, 3280929007, 'GB', 'GBR', 'المملكة المتحدة'),
(73902, 3280929008, 3280929015, 'DE', 'DEU', 'ألمانيا'),
(73903, 3280929016, 3280929055, 'GB', 'GBR', 'المملكة المتحدة'),
(73904, 3280929056, 3280929096, 'DE', 'DEU', 'ألمانيا'),
(73905, 3280929097, 3280929098, 'GB', 'GBR', 'المملكة المتحدة'),
(73906, 3280929099, 3280929099, 'DE', 'DEU', 'ألمانيا'),
(73907, 3280929100, 3280929100, 'GB', 'GBR', 'المملكة المتحدة'),
(73908, 3280929101, 3280929101, 'DE', 'DEU', 'ألمانيا'),
(73909, 3280929102, 3280929119, 'GB', 'GBR', 'المملكة المتحدة'),
(73910, 3280929120, 3280929151, 'DE', 'DEU', 'ألمانيا'),
(73911, 3280929152, 3280929183, 'GB', 'GBR', 'المملكة المتحدة'),
(73912, 3280929184, 3280929247, 'DE', 'DEU', 'ألمانيا'),
(73913, 3280929248, 3280929255, 'GB', 'GBR', 'المملكة المتحدة'),
(73914, 3280929256, 3280929259, 'DE', 'DEU', 'ألمانيا'),
(73915, 3280929260, 3280929263, 'GB', 'GBR', 'المملكة المتحدة'),
(73916, 3280929264, 3280929271, 'DE', 'DEU', 'ألمانيا'),
(73917, 3280929272, 3280929272, 'GB', 'GBR', 'المملكة المتحدة'),
(73918, 3280929273, 3280929273, 'DE', 'DEU', 'ألمانيا'),
(73919, 3280929274, 3280929274, 'GB', 'GBR', 'المملكة المتحدة'),
(73920, 3280929275, 3280929276, 'DE', 'DEU', 'ألمانيا'),
(73921, 3280929277, 3280929277, 'GB', 'GBR', 'المملكة المتحدة'),
(73922, 3280929278, 3280929278, 'DE', 'DEU', 'ألمانيا'),
(73923, 3280929279, 3280929343, 'GB', 'GBR', 'المملكة المتحدة'),
(73924, 3280929344, 3280929367, 'DE', 'DEU', 'ألمانيا'),
(73925, 3280929368, 3280929375, 'GB', 'GBR', 'المملكة المتحدة'),
(73926, 3280929376, 3280929395, 'DE', 'DEU', 'ألمانيا'),
(73927, 3280929396, 3280929399, 'GB', 'GBR', 'المملكة المتحدة'),
(73928, 3280929400, 3280929403, 'DE', 'DEU', 'ألمانيا'),
(73929, 3280929404, 3280929404, 'GB', 'GBR', 'المملكة المتحدة'),
(73930, 3280929405, 3280929406, 'DE', 'DEU', 'ألمانيا'),
(73931, 3280929407, 3280929455, 'GB', 'GBR', 'المملكة المتحدة'),
(73932, 3280929456, 3280929487, 'DE', 'DEU', 'ألمانيا'),
(73933, 3280929488, 3280929503, 'GB', 'GBR', 'المملكة المتحدة'),
(73934, 3280929504, 3280929527, 'DE', 'DEU', 'ألمانيا'),
(73935, 3280929528, 3280929531, 'GB', 'GBR', 'المملكة المتحدة'),
(73936, 3280929532, 3280929534, 'DE', 'DEU', 'ألمانيا'),
(73937, 3280929535, 3280929551, 'GB', 'GBR', 'المملكة المتحدة'),
(73938, 3280929552, 3280929583, 'DE', 'DEU', 'ألمانيا'),
(73939, 3280929584, 3280929599, 'GB', 'GBR', 'المملكة المتحدة'),
(73940, 3280929600, 3280929615, 'DE', 'DEU', 'ألمانيا'),
(73941, 3280929616, 3280929631, 'GB', 'GBR', 'المملكة المتحدة'),
(73942, 3280929632, 3280929641, 'DE', 'DEU', 'ألمانيا'),
(73943, 3280929642, 3280929642, 'GB', 'GBR', 'المملكة المتحدة'),
(73944, 3280929643, 3280929645, 'DE', 'DEU', 'ألمانيا'),
(73945, 3280929646, 3280929647, 'GB', 'GBR', 'المملكة المتحدة'),
(73946, 3280929648, 3280929655, 'DE', 'DEU', 'ألمانيا'),
(73947, 3280929656, 3280929663, 'GB', 'GBR', 'المملكة المتحدة'),
(73948, 3280929664, 3280929695, 'DE', 'DEU', 'ألمانيا'),
(73949, 3280929696, 3280929696, 'GB', 'GBR', 'المملكة المتحدة'),
(73950, 3280929697, 3280929697, 'DE', 'DEU', 'ألمانيا'),
(73951, 3280929698, 3280929698, 'GB', 'GBR', 'المملكة المتحدة'),
(73952, 3280929699, 3280929699, 'DE', 'DEU', 'ألمانيا'),
(73953, 3280929700, 3280929700, 'GB', 'GBR', 'المملكة المتحدة'),
(73954, 3280929701, 3280929703, 'DE', 'DEU', 'ألمانيا'),
(73955, 3280929704, 3280929711, 'GB', 'GBR', 'المملكة المتحدة'),
(73956, 3280929712, 3280929727, 'DE', 'DEU', 'ألمانيا'),
(73957, 3280929728, 3280929792, 'GB', 'GBR', 'المملكة المتحدة'),
(73958, 3280929793, 3280929799, 'DE', 'DEU', 'ألمانيا'),
(73959, 3280929800, 3280929827, 'GB', 'GBR', 'المملكة المتحدة'),
(73960, 3280929828, 3280929839, 'DE', 'DEU', 'ألمانيا'),
(73961, 3280929840, 3280929855, 'GB', 'GBR', 'المملكة المتحدة'),
(73962, 3280929856, 3280929887, 'DE', 'DEU', 'ألمانيا'),
(73963, 3280929888, 3280929888, 'GB', 'GBR', 'المملكة المتحدة'),
(73964, 3280929889, 3280929889, 'DE', 'DEU', 'ألمانيا'),
(73965, 3280929890, 3280930047, 'GB', 'GBR', 'المملكة المتحدة'),
(73966, 3280930048, 3280930079, 'DE', 'DEU', 'ألمانيا'),
(73967, 3280930080, 3280930087, 'GB', 'GBR', 'المملكة المتحدة'),
(73968, 3280930088, 3280930091, 'DE', 'DEU', 'ألمانيا'),
(73969, 3280930092, 3280930095, 'GB', 'GBR', 'المملكة المتحدة'),
(73970, 3280930096, 3280930111, 'DE', 'DEU', 'ألمانيا'),
(73971, 3280930112, 3280930127, 'GB', 'GBR', 'المملكة المتحدة'),
(73972, 3280930128, 3280930155, 'DE', 'DEU', 'ألمانيا'),
(73973, 3280930156, 3280930175, 'GB', 'GBR', 'المملكة المتحدة'),
(73974, 3280930176, 3280930177, 'DE', 'DEU', 'ألمانيا'),
(73975, 3280930178, 3280930180, 'GB', 'GBR', 'المملكة المتحدة'),
(73976, 3280930181, 3280930182, 'DE', 'DEU', 'ألمانيا'),
(73977, 3280930183, 3280930190, 'GB', 'GBR', 'المملكة المتحدة'),
(73978, 3280930191, 3280930191, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(73979, 3280930192, 3280930197, 'GB', 'GBR', 'المملكة المتحدة'),
(73980, 3280930198, 3280930198, 'DE', 'DEU', 'ألمانيا'),
(73981, 3280930199, 3280930199, 'GB', 'GBR', 'المملكة المتحدة'),
(73982, 3280930200, 3280930239, 'DE', 'DEU', 'ألمانيا'),
(73983, 3280930240, 3280930351, 'GB', 'GBR', 'المملكة المتحدة'),
(73984, 3280930352, 3280930367, 'DE', 'DEU', 'ألمانيا'),
(73985, 3280930368, 3280930383, 'GB', 'GBR', 'المملكة المتحدة'),
(73986, 3280930384, 3280930391, 'DE', 'DEU', 'ألمانيا'),
(73987, 3280930392, 3280930407, 'GB', 'GBR', 'المملكة المتحدة'),
(73988, 3280930408, 3280930420, 'DE', 'DEU', 'ألمانيا'),
(73989, 3280930421, 3280930421, 'GB', 'GBR', 'المملكة المتحدة'),
(73990, 3280930422, 3280930431, 'DE', 'DEU', 'ألمانيا'),
(73991, 3280930432, 3280930464, 'GB', 'GBR', 'المملكة المتحدة'),
(73992, 3280930465, 3280930465, 'DE', 'DEU', 'ألمانيا'),
(73993, 3280930466, 3280930466, 'GB', 'GBR', 'المملكة المتحدة'),
(73994, 3280930467, 3280930495, 'DE', 'DEU', 'ألمانيا'),
(73995, 3280930496, 3280930511, 'GB', 'GBR', 'المملكة المتحدة'),
(73996, 3280930512, 3280930515, 'DE', 'DEU', 'ألمانيا'),
(73997, 3280930516, 3280930524, 'GB', 'GBR', 'المملكة المتحدة'),
(73998, 3280930525, 3280930535, 'DE', 'DEU', 'ألمانيا'),
(73999, 3280930536, 3280930537, 'GB', 'GBR', 'المملكة المتحدة'),
(74000, 3280930538, 3280930541, 'DE', 'DEU', 'ألمانيا'),
(74001, 3280930542, 3280930561, 'GB', 'GBR', 'المملكة المتحدة'),
(74002, 3280930562, 3280930562, 'DE', 'DEU', 'ألمانيا'),
(74003, 3280930563, 3280930563, 'GB', 'GBR', 'المملكة المتحدة'),
(74004, 3280930564, 3280930575, 'DE', 'DEU', 'ألمانيا'),
(74005, 3280930576, 3280930579, 'GB', 'GBR', 'المملكة المتحدة'),
(74006, 3280930580, 3280930591, 'DE', 'DEU', 'ألمانيا'),
(74007, 3280930592, 3280930639, 'GB', 'GBR', 'المملكة المتحدة'),
(74008, 3280930640, 3280930655, 'DE', 'DEU', 'ألمانيا'),
(74009, 3280930656, 3280930671, 'GB', 'GBR', 'المملكة المتحدة'),
(74010, 3280930672, 3280930687, 'DE', 'DEU', 'ألمانيا'),
(74011, 3280930688, 3280930719, 'GB', 'GBR', 'المملكة المتحدة'),
(74012, 3280930720, 3280930731, 'DE', 'DEU', 'ألمانيا'),
(74013, 3280930732, 3280930735, 'GB', 'GBR', 'المملكة المتحدة'),
(74014, 3280930736, 3280930743, 'DE', 'DEU', 'ألمانيا'),
(74015, 3280930744, 3280930747, 'GB', 'GBR', 'المملكة المتحدة'),
(74016, 3280930748, 3280930759, 'DE', 'DEU', 'ألمانيا'),
(74017, 3280930760, 3280930767, 'GB', 'GBR', 'المملكة المتحدة'),
(74018, 3280930768, 3280930771, 'DE', 'DEU', 'ألمانيا'),
(74019, 3280930772, 3280930779, 'GB', 'GBR', 'المملكة المتحدة'),
(74020, 3280930780, 3280930783, 'DE', 'DEU', 'ألمانيا'),
(74021, 3280930784, 3280930807, 'GB', 'GBR', 'المملكة المتحدة'),
(74022, 3280930808, 3280930812, 'DE', 'DEU', 'ألمانيا'),
(74023, 3280930813, 3280930818, 'GB', 'GBR', 'المملكة المتحدة'),
(74024, 3280930819, 3280930819, 'DE', 'DEU', 'ألمانيا'),
(74025, 3280930820, 3280930822, 'GB', 'GBR', 'المملكة المتحدة'),
(74026, 3280930823, 3280930823, 'DE', 'DEU', 'ألمانيا'),
(74027, 3280930824, 3280930863, 'GB', 'GBR', 'المملكة المتحدة'),
(74028, 3280930864, 3280930868, 'DE', 'DEU', 'ألمانيا'),
(74029, 3280930869, 3280930869, 'GB', 'GBR', 'المملكة المتحدة'),
(74030, 3280930870, 3280930870, 'DE', 'DEU', 'ألمانيا'),
(74031, 3280930871, 3280930879, 'GB', 'GBR', 'المملكة المتحدة'),
(74032, 3280930880, 3280930911, 'DE', 'DEU', 'ألمانيا'),
(74033, 3280930912, 3280930919, 'GB', 'GBR', 'المملكة المتحدة'),
(74034, 3280930920, 3280930927, 'DE', 'DEU', 'ألمانيا'),
(74035, 3280930928, 3280930975, 'GB', 'GBR', 'المملكة المتحدة'),
(74036, 3280930976, 3280930983, 'DE', 'DEU', 'ألمانيا'),
(74037, 3280930984, 3280931103, 'GB', 'GBR', 'المملكة المتحدة'),
(74038, 3280931104, 3280931119, 'DE', 'DEU', 'ألمانيا'),
(74039, 3280931120, 3280931135, 'GB', 'GBR', 'المملكة المتحدة'),
(74040, 3280931136, 3280931143, 'DE', 'DEU', 'ألمانيا'),
(74041, 3280931144, 3280931154, 'GB', 'GBR', 'المملكة المتحدة'),
(74042, 3280931155, 3280931155, 'DE', 'DEU', 'ألمانيا'),
(74043, 3280931156, 3280931157, 'GB', 'GBR', 'المملكة المتحدة'),
(74044, 3280931158, 3280931158, 'DE', 'DEU', 'ألمانيا'),
(74045, 3280931159, 3280931159, 'GB', 'GBR', 'المملكة المتحدة'),
(74046, 3280931160, 3280931167, 'DE', 'DEU', 'ألمانيا'),
(74047, 3280931168, 3280931175, 'GB', 'GBR', 'المملكة المتحدة'),
(74048, 3280931176, 3280931180, 'DE', 'DEU', 'ألمانيا'),
(74049, 3280931181, 3280931191, 'GB', 'GBR', 'المملكة المتحدة'),
(74050, 3280931192, 3280931193, 'DE', 'DEU', 'ألمانيا'),
(74051, 3280931194, 3280931194, 'GB', 'GBR', 'المملكة المتحدة'),
(74052, 3280931195, 3280931199, 'DE', 'DEU', 'ألمانيا'),
(74053, 3280931200, 3280931327, 'GB', 'GBR', 'المملكة المتحدة'),
(74054, 3280931328, 3280931631, 'DE', 'DEU', 'ألمانيا'),
(74055, 3280931632, 3280931633, 'GB', 'GBR', 'المملكة المتحدة'),
(74056, 3280931634, 3280931634, 'DE', 'DEU', 'ألمانيا'),
(74057, 3280931635, 3280931635, 'GB', 'GBR', 'المملكة المتحدة'),
(74058, 3280931636, 3280931639, 'DE', 'DEU', 'ألمانيا'),
(74059, 3280931640, 3280931649, 'GB', 'GBR', 'المملكة المتحدة'),
(74060, 3280931650, 3280931650, 'DE', 'DEU', 'ألمانيا'),
(74061, 3280931651, 3280931655, 'GB', 'GBR', 'المملكة المتحدة'),
(74062, 3280931656, 3280931663, 'DE', 'DEU', 'ألمانيا'),
(74063, 3280931664, 3280931815, 'GB', 'GBR', 'المملكة المتحدة'),
(74064, 3280931816, 3280931819, 'DE', 'DEU', 'ألمانيا'),
(74065, 3280931820, 3280931825, 'GB', 'GBR', 'المملكة المتحدة'),
(74066, 3280931826, 3280931826, 'DE', 'DEU', 'ألمانيا'),
(74067, 3280931827, 3280931935, 'GB', 'GBR', 'المملكة المتحدة'),
(74068, 3280931936, 3280931943, 'DE', 'DEU', 'ألمانيا'),
(74069, 3280931944, 3280931951, 'GB', 'GBR', 'المملكة المتحدة'),
(74070, 3280931952, 3280931983, 'DE', 'DEU', 'ألمانيا'),
(74071, 3280931984, 3280932015, 'GB', 'GBR', 'المملكة المتحدة'),
(74072, 3280932016, 3280932031, 'DE', 'DEU', 'ألمانيا'),
(74073, 3280932032, 3280932351, 'GB', 'GBR', 'المملكة المتحدة'),
(74074, 3280932352, 3280932367, 'DE', 'DEU', 'ألمانيا'),
(74075, 3280932368, 3280932383, 'GB', 'GBR', 'المملكة المتحدة'),
(74076, 3280932384, 3280932399, 'DE', 'DEU', 'ألمانيا'),
(74077, 3280932400, 3280932431, 'GB', 'GBR', 'المملكة المتحدة'),
(74078, 3280932432, 3280932455, 'DE', 'DEU', 'ألمانيا'),
(74079, 3280932456, 3280932463, 'GB', 'GBR', 'المملكة المتحدة'),
(74080, 3280932464, 3280932472, 'DE', 'DEU', 'ألمانيا'),
(74081, 3280932473, 3280932474, 'GB', 'GBR', 'المملكة المتحدة'),
(74082, 3280932475, 3280932477, 'DE', 'DEU', 'ألمانيا'),
(74083, 3280932478, 3280932479, 'GB', 'GBR', 'المملكة المتحدة'),
(74084, 3280932480, 3280932495, 'DE', 'DEU', 'ألمانيا'),
(74085, 3280932496, 3280932543, 'GB', 'GBR', 'المملكة المتحدة'),
(74086, 3280932544, 3280932559, 'DE', 'DEU', 'ألمانيا'),
(74087, 3280932560, 3280932567, 'GB', 'GBR', 'المملكة المتحدة'),
(74088, 3280932568, 3280932575, 'DE', 'DEU', 'ألمانيا'),
(74089, 3280932576, 3280932591, 'GB', 'GBR', 'المملكة المتحدة'),
(74090, 3280932592, 3280932607, 'DE', 'DEU', 'ألمانيا'),
(74091, 3280932608, 3280932655, 'GB', 'GBR', 'المملكة المتحدة'),
(74092, 3280932656, 3280932663, 'DE', 'DEU', 'ألمانيا'),
(74093, 3280932664, 3280932671, 'GB', 'GBR', 'المملكة المتحدة'),
(74094, 3280932672, 3280932687, 'DE', 'DEU', 'ألمانيا'),
(74095, 3280932688, 3280932711, 'GB', 'GBR', 'المملكة المتحدة'),
(74096, 3280932712, 3280932735, 'DE', 'DEU', 'ألمانيا'),
(74097, 3280932736, 3280932831, 'GB', 'GBR', 'المملكة المتحدة'),
(74098, 3280932832, 3280932847, 'DE', 'DEU', 'ألمانيا'),
(74099, 3280932848, 3280932976, 'GB', 'GBR', 'المملكة المتحدة'),
(74100, 3280932977, 3280932983, 'DE', 'DEU', 'ألمانيا'),
(74101, 3280932984, 3280932984, 'GB', 'GBR', 'المملكة المتحدة'),
(74102, 3280932985, 3280932985, 'DE', 'DEU', 'ألمانيا'),
(74103, 3280932986, 3280932988, 'GB', 'GBR', 'المملكة المتحدة'),
(74104, 3280932989, 3280932989, 'DE', 'DEU', 'ألمانيا'),
(74105, 3280932990, 3280932990, 'GB', 'GBR', 'المملكة المتحدة'),
(74106, 3280932991, 3280932991, 'DE', 'DEU', 'ألمانيا'),
(74107, 3280932992, 3280933023, 'GB', 'GBR', 'المملكة المتحدة'),
(74108, 3280933024, 3280933039, 'DE', 'DEU', 'ألمانيا'),
(74109, 3280933040, 3280933071, 'GB', 'GBR', 'المملكة المتحدة'),
(74110, 3280933072, 3280933087, 'DE', 'DEU', 'ألمانيا'),
(74111, 3280933088, 3280933103, 'GB', 'GBR', 'المملكة المتحدة'),
(74112, 3280933104, 3280933119, 'DE', 'DEU', 'ألمانيا'),
(74113, 3280933120, 3280933175, 'GB', 'GBR', 'المملكة المتحدة'),
(74114, 3280933176, 3280933215, 'DE', 'DEU', 'ألمانيا'),
(74115, 3280933216, 3280933311, 'GB', 'GBR', 'المملكة المتحدة'),
(74116, 3280933312, 3280933375, 'DE', 'DEU', 'ألمانيا'),
(74117, 3280933376, 3280933439, 'GB', 'GBR', 'المملكة المتحدة'),
(74118, 3280933440, 3280933451, 'DE', 'DEU', 'ألمانيا'),
(74119, 3280933452, 3280933487, 'GB', 'GBR', 'المملكة المتحدة'),
(74120, 3280933488, 3280933519, 'DE', 'DEU', 'ألمانيا'),
(74121, 3280933520, 3280933539, 'GB', 'GBR', 'المملكة المتحدة'),
(74122, 3280933540, 3280933551, 'DE', 'DEU', 'ألمانيا'),
(74123, 3280933552, 3280933567, 'GB', 'GBR', 'المملكة المتحدة'),
(74124, 3280933568, 3280933599, 'DE', 'DEU', 'ألمانيا'),
(74125, 3280933600, 3280933615, 'GB', 'GBR', 'المملكة المتحدة'),
(74126, 3280933616, 3280933616, 'DE', 'DEU', 'ألمانيا'),
(74127, 3280933617, 3280933618, 'GB', 'GBR', 'المملكة المتحدة'),
(74128, 3280933619, 3280933620, 'DE', 'DEU', 'ألمانيا'),
(74129, 3280933621, 3280933631, 'GB', 'GBR', 'المملكة المتحدة'),
(74130, 3280933632, 3280934399, 'DE', 'DEU', 'ألمانيا'),
(74131, 3280934400, 3280934655, 'GB', 'GBR', 'المملكة المتحدة'),
(74132, 3280934656, 3280934863, 'DE', 'DEU', 'ألمانيا'),
(74133, 3280934864, 3280934911, 'GB', 'GBR', 'المملكة المتحدة'),
(74134, 3280934912, 3280934943, 'DE', 'DEU', 'ألمانيا'),
(74135, 3280934944, 3280935007, 'GB', 'GBR', 'المملكة المتحدة'),
(74136, 3280935008, 3280935015, 'DE', 'DEU', 'ألمانيا'),
(74137, 3280935016, 3280935053, 'GB', 'GBR', 'المملكة المتحدة'),
(74138, 3280935054, 3280935055, 'DE', 'DEU', 'ألمانيا'),
(74139, 3280935056, 3280935059, 'GB', 'GBR', 'المملكة المتحدة'),
(74140, 3280935060, 3280935063, 'DE', 'DEU', 'ألمانيا'),
(74141, 3280935064, 3280935119, 'GB', 'GBR', 'المملكة المتحدة'),
(74142, 3280935120, 3280935127, 'DE', 'DEU', 'ألمانيا'),
(74143, 3280935128, 3280935135, 'GB', 'GBR', 'المملكة المتحدة'),
(74144, 3280935136, 3280935167, 'DE', 'DEU', 'ألمانيا'),
(74145, 3280935168, 3280935247, 'GB', 'GBR', 'المملكة المتحدة'),
(74146, 3280935248, 3280935263, 'DE', 'DEU', 'ألمانيا'),
(74147, 3280935264, 3280935344, 'GB', 'GBR', 'المملكة المتحدة'),
(74148, 3280935345, 3280935345, 'DE', 'DEU', 'ألمانيا'),
(74149, 3280935346, 3280935347, 'GB', 'GBR', 'المملكة المتحدة'),
(74150, 3280935348, 3280935351, 'DE', 'DEU', 'ألمانيا'),
(74151, 3280935352, 3280935807, 'GB', 'GBR', 'المملكة المتحدة'),
(74152, 3280935808, 3280935823, 'DE', 'DEU', 'ألمانيا'),
(74153, 3280935824, 3280935856, 'GB', 'GBR', 'المملكة المتحدة'),
(74154, 3280935857, 3280935858, 'DE', 'DEU', 'ألمانيا'),
(74155, 3280935859, 3280935859, 'GB', 'GBR', 'المملكة المتحدة'),
(74156, 3280935860, 3280935863, 'DE', 'DEU', 'ألمانيا'),
(74157, 3280935864, 3280935887, 'GB', 'GBR', 'المملكة المتحدة'),
(74158, 3280935888, 3280935903, 'DE', 'DEU', 'ألمانيا'),
(74159, 3280935904, 3280936039, 'GB', 'GBR', 'المملكة المتحدة'),
(74160, 3280936040, 3280936048, 'DE', 'DEU', 'ألمانيا'),
(74161, 3280936049, 3280936052, 'GB', 'GBR', 'المملكة المتحدة'),
(74162, 3280936053, 3280936053, 'DE', 'DEU', 'ألمانيا'),
(74163, 3280936054, 3280936054, 'GB', 'GBR', 'المملكة المتحدة'),
(74164, 3280936055, 3280936063, 'DE', 'DEU', 'ألمانيا'),
(74165, 3280936064, 3280936143, 'GB', 'GBR', 'المملكة المتحدة'),
(74166, 3280936144, 3280936159, 'DE', 'DEU', 'ألمانيا'),
(74167, 3280936160, 3280936191, 'GB', 'GBR', 'المملكة المتحدة'),
(74168, 3280936192, 3280936319, 'DE', 'DEU', 'ألمانيا'),
(74169, 3280936320, 3280936463, 'GB', 'GBR', 'المملكة المتحدة'),
(74170, 3280936464, 3280936479, 'DE', 'DEU', 'ألمانيا'),
(74171, 3280936480, 3280936495, 'GB', 'GBR', 'المملكة المتحدة'),
(74172, 3280936496, 3280936498, 'DE', 'DEU', 'ألمانيا'),
(74173, 3280936499, 3280936500, 'GB', 'GBR', 'المملكة المتحدة'),
(74174, 3280936501, 3280936501, 'DE', 'DEU', 'ألمانيا'),
(74175, 3280936502, 3280936504, 'GB', 'GBR', 'المملكة المتحدة'),
(74176, 3280936505, 3280936505, 'DE', 'DEU', 'ألمانيا'),
(74177, 3280936506, 3280936506, 'GB', 'GBR', 'المملكة المتحدة'),
(74178, 3280936507, 3280936510, 'DE', 'DEU', 'ألمانيا'),
(74179, 3280936511, 3280936511, 'GB', 'GBR', 'المملكة المتحدة'),
(74180, 3280936512, 3280936512, 'DE', 'DEU', 'ألمانيا'),
(74181, 3280936513, 3280936519, 'GB', 'GBR', 'المملكة المتحدة'),
(74182, 3280936520, 3280936523, 'DE', 'DEU', 'ألمانيا'),
(74183, 3280936524, 3280936559, 'GB', 'GBR', 'المملكة المتحدة'),
(74184, 3280936560, 3280936567, 'DE', 'DEU', 'ألمانيا'),
(74185, 3280936568, 3280936575, 'GB', 'GBR', 'المملكة المتحدة'),
(74186, 3280936576, 3280936583, 'DE', 'DEU', 'ألمانيا'),
(74187, 3280936584, 3280936591, 'GB', 'GBR', 'المملكة المتحدة'),
(74188, 3280936592, 3280936655, 'DE', 'DEU', 'ألمانيا'),
(74189, 3280936656, 3280936999, 'GB', 'GBR', 'المملكة المتحدة'),
(74190, 3280937000, 3280937003, 'DE', 'DEU', 'ألمانيا'),
(74191, 3280937004, 3280937007, 'GB', 'GBR', 'المملكة المتحدة'),
(74192, 3280937008, 3280937023, 'DE', 'DEU', 'ألمانيا'),
(74193, 3280937024, 3280937639, 'GB', 'GBR', 'المملكة المتحدة'),
(74194, 3280937640, 3280937643, 'DE', 'DEU', 'ألمانيا'),
(74195, 3280937644, 3280937919, 'GB', 'GBR', 'المملكة المتحدة'),
(74196, 3280937920, 3280937935, 'DE', 'DEU', 'ألمانيا'),
(74197, 3280937936, 3280937999, 'GB', 'GBR', 'المملكة المتحدة'),
(74198, 3280938000, 3280938003, 'DE', 'DEU', 'ألمانيا'),
(74199, 3280938004, 3280938167, 'GB', 'GBR', 'المملكة المتحدة'),
(74200, 3280938168, 3280938175, 'DE', 'DEU', 'ألمانيا'),
(74201, 3280938176, 3280938207, 'GB', 'GBR', 'المملكة المتحدة'),
(74202, 3280938208, 3280938223, 'DE', 'DEU', 'ألمانيا'),
(74203, 3280938224, 3280938236, 'GB', 'GBR', 'المملكة المتحدة'),
(74204, 3280938237, 3280938237, 'DE', 'DEU', 'ألمانيا'),
(74205, 3280938238, 3280938271, 'GB', 'GBR', 'المملكة المتحدة'),
(74206, 3280938272, 3280938279, 'DE', 'DEU', 'ألمانيا'),
(74207, 3280938280, 3280938283, 'GB', 'GBR', 'المملكة المتحدة'),
(74208, 3280938284, 3280938284, 'DE', 'DEU', 'ألمانيا'),
(74209, 3280938285, 3280938285, 'GB', 'GBR', 'المملكة المتحدة'),
(74210, 3280938286, 3280938286, 'DE', 'DEU', 'ألمانيا'),
(74211, 3280938287, 3280938303, 'GB', 'GBR', 'المملكة المتحدة'),
(74212, 3280938304, 3280938367, 'DE', 'DEU', 'ألمانيا'),
(74213, 3280938368, 3280938400, 'GB', 'GBR', 'المملكة المتحدة'),
(74214, 3280938401, 3280938401, 'DE', 'DEU', 'ألمانيا'),
(74215, 3280938402, 3280938402, 'GB', 'GBR', 'المملكة المتحدة'),
(74216, 3280938403, 3280938407, 'DE', 'DEU', 'ألمانيا'),
(74217, 3280938408, 3280938543, 'GB', 'GBR', 'المملكة المتحدة'),
(74218, 3280938544, 3280938591, 'DE', 'DEU', 'ألمانيا'),
(74219, 3280938592, 3280938619, 'GB', 'GBR', 'المملكة المتحدة'),
(74220, 3280938620, 3280938623, 'DE', 'DEU', 'ألمانيا'),
(74221, 3280938624, 3280938668, 'GB', 'GBR', 'المملكة المتحدة'),
(74222, 3280938669, 3280938669, 'DE', 'DEU', 'ألمانيا'),
(74223, 3280938670, 3280938723, 'GB', 'GBR', 'المملكة المتحدة'),
(74224, 3280938724, 3280938751, 'DE', 'DEU', 'ألمانيا'),
(74225, 3280938752, 3280938767, 'GB', 'GBR', 'المملكة المتحدة'),
(74226, 3280938768, 3280938815, 'DE', 'DEU', 'ألمانيا'),
(74227, 3280938816, 3280938919, 'GB', 'GBR', 'المملكة المتحدة'),
(74228, 3280938920, 3280938931, 'DE', 'DEU', 'ألمانيا'),
(74229, 3280938932, 3280939167, 'GB', 'GBR', 'المملكة المتحدة'),
(74230, 3280939168, 3280939175, 'DE', 'DEU', 'ألمانيا'),
(74231, 3280939176, 3280939179, 'GB', 'GBR', 'المملكة المتحدة'),
(74232, 3280939180, 3280939183, 'DE', 'DEU', 'ألمانيا'),
(74233, 3280939184, 3280939839, 'GB', 'GBR', 'المملكة المتحدة'),
(74234, 3280939840, 3280939871, 'DE', 'DEU', 'ألمانيا'),
(74235, 3280939872, 3280939887, 'GB', 'GBR', 'المملكة المتحدة'),
(74236, 3280939888, 3280939895, 'DE', 'DEU', 'ألمانيا'),
(74237, 3280939896, 3280939896, 'GB', 'GBR', 'المملكة المتحدة'),
(74238, 3280939897, 3280939900, 'DE', 'DEU', 'ألمانيا'),
(74239, 3280939901, 3280939901, 'GB', 'GBR', 'المملكة المتحدة'),
(74240, 3280939902, 3280939902, 'DE', 'DEU', 'ألمانيا'),
(74241, 3280939903, 3280939923, 'GB', 'GBR', 'المملكة المتحدة'),
(74242, 3280939924, 3280939924, 'DE', 'DEU', 'ألمانيا'),
(74243, 3280939925, 3280939925, 'GB', 'GBR', 'المملكة المتحدة'),
(74244, 3280939926, 3280939926, 'DE', 'DEU', 'ألمانيا'),
(74245, 3280939927, 3280939975, 'GB', 'GBR', 'المملكة المتحدة'),
(74246, 3280939976, 3280939977, 'DE', 'DEU', 'ألمانيا'),
(74247, 3280939978, 3280939978, 'GB', 'GBR', 'المملكة المتحدة'),
(74248, 3280939979, 3280939979, 'DE', 'DEU', 'ألمانيا'),
(74249, 3280939980, 3280939983, 'GB', 'GBR', 'المملكة المتحدة'),
(74250, 3280939984, 3280939999, 'DE', 'DEU', 'ألمانيا'),
(74251, 3280940000, 3280940015, 'GB', 'GBR', 'المملكة المتحدة'),
(74252, 3280940016, 3280940023, 'DE', 'DEU', 'ألمانيا'),
(74253, 3280940024, 3280940095, 'GB', 'GBR', 'المملكة المتحدة'),
(74254, 3280940096, 3280940103, 'DE', 'DEU', 'ألمانيا'),
(74255, 3280940104, 3280940132, 'GB', 'GBR', 'المملكة المتحدة'),
(74256, 3280940133, 3280940135, 'DE', 'DEU', 'ألمانيا'),
(74257, 3280940136, 3280940143, 'GB', 'GBR', 'المملكة المتحدة'),
(74258, 3280940144, 3280940151, 'DE', 'DEU', 'ألمانيا'),
(74259, 3280940152, 3280940487, 'GB', 'GBR', 'المملكة المتحدة'),
(74260, 3280940488, 3280940495, 'DE', 'DEU', 'ألمانيا'),
(74261, 3280940496, 3280940503, 'GB', 'GBR', 'المملكة المتحدة'),
(74262, 3280940504, 3280940511, 'DE', 'DEU', 'ألمانيا'),
(74263, 3280940512, 3280940575, 'GB', 'GBR', 'المملكة المتحدة'),
(74264, 3280940576, 3280940599, 'DE', 'DEU', 'ألمانيا'),
(74265, 3280940600, 3280940703, 'GB', 'GBR', 'المملكة المتحدة'),
(74266, 3280940704, 3280940719, 'DE', 'DEU', 'ألمانيا'),
(74267, 3280940720, 3280940735, 'GB', 'GBR', 'المملكة المتحدة'),
(74268, 3280940736, 3280940767, 'DE', 'DEU', 'ألمانيا'),
(74269, 3280940768, 3280940832, 'GB', 'GBR', 'المملكة المتحدة'),
(74270, 3280940833, 3280940833, 'DE', 'DEU', 'ألمانيا'),
(74271, 3280940834, 3280940834, 'GB', 'GBR', 'المملكة المتحدة'),
(74272, 3280940835, 3280940835, 'DE', 'DEU', 'ألمانيا'),
(74273, 3280940836, 3280940836, 'GB', 'GBR', 'المملكة المتحدة'),
(74274, 3280940837, 3280940837, 'DE', 'DEU', 'ألمانيا'),
(74275, 3280940838, 3280940959, 'GB', 'GBR', 'المملكة المتحدة'),
(74276, 3280940960, 3280940967, 'DE', 'DEU', 'ألمانيا'),
(74277, 3280940968, 3280941124, 'GB', 'GBR', 'المملكة المتحدة'),
(74278, 3280941125, 3280941127, 'DE', 'DEU', 'ألمانيا'),
(74279, 3280941128, 3280941183, 'GB', 'GBR', 'المملكة المتحدة'),
(74280, 3280941184, 3280941199, 'DE', 'DEU', 'ألمانيا'),
(74281, 3280941200, 3280941312, 'GB', 'GBR', 'المملكة المتحدة'),
(74282, 3280941313, 3280941314, 'DE', 'DEU', 'ألمانيا'),
(74283, 3280941315, 3280941335, 'GB', 'GBR', 'المملكة المتحدة'),
(74284, 3280941336, 3280941343, 'DE', 'DEU', 'ألمانيا'),
(74285, 3280941344, 3280941359, 'GB', 'GBR', 'المملكة المتحدة'),
(74286, 3280941360, 3280941367, 'DE', 'DEU', 'ألمانيا'),
(74287, 3280941368, 3280941369, 'GB', 'GBR', 'المملكة المتحدة'),
(74288, 3280941370, 3280941370, 'DE', 'DEU', 'ألمانيا'),
(74289, 3280941371, 3280941371, 'GB', 'GBR', 'المملكة المتحدة'),
(74290, 3280941372, 3280941373, 'DE', 'DEU', 'ألمانيا'),
(74291, 3280941374, 3280941423, 'GB', 'GBR', 'المملكة المتحدة'),
(74292, 3280941424, 3280941439, 'DE', 'DEU', 'ألمانيا'),
(74293, 3280941440, 3280941479, 'GB', 'GBR', 'المملكة المتحدة'),
(74294, 3280941480, 3280941484, 'DE', 'DEU', 'ألمانيا'),
(74295, 3280941485, 3280941485, 'GB', 'GBR', 'المملكة المتحدة'),
(74296, 3280941486, 3280941523, 'DE', 'DEU', 'ألمانيا'),
(74297, 3280941524, 3280941527, 'GB', 'GBR', 'المملكة المتحدة'),
(74298, 3280941528, 3280941551, 'DE', 'DEU', 'ألمانيا'),
(74299, 3280941552, 3280941655, 'GB', 'GBR', 'المملكة المتحدة'),
(74300, 3280941656, 3280941663, 'DE', 'DEU', 'ألمانيا'),
(74301, 3280941664, 3280941672, 'GB', 'GBR', 'المملكة المتحدة'),
(74302, 3280941673, 3280941675, 'DE', 'DEU', 'ألمانيا'),
(74303, 3280941676, 3280941887, 'GB', 'GBR', 'المملكة المتحدة'),
(74304, 3280941888, 3280941888, 'DE', 'DEU', 'ألمانيا'),
(74305, 3280941889, 3280941894, 'GB', 'GBR', 'المملكة المتحدة'),
(74306, 3280941895, 3280941895, 'DE', 'DEU', 'ألمانيا'),
(74307, 3280941896, 3280941901, 'GB', 'GBR', 'المملكة المتحدة'),
(74308, 3280941902, 3280941902, 'DE', 'DEU', 'ألمانيا'),
(74309, 3280941903, 3280941912, 'GB', 'GBR', 'المملكة المتحدة'),
(74310, 3280941913, 3280941919, 'DE', 'DEU', 'ألمانيا'),
(74311, 3280941920, 3280941952, 'GB', 'GBR', 'المملكة المتحدة'),
(74312, 3280941953, 3280941953, 'DE', 'DEU', 'ألمانيا'),
(74313, 3280941954, 3280941957, 'GB', 'GBR', 'المملكة المتحدة'),
(74314, 3280941958, 3280941958, 'DE', 'DEU', 'ألمانيا'),
(74315, 3280941959, 3280941964, 'GB', 'GBR', 'المملكة المتحدة'),
(74316, 3280941965, 3280941967, 'DE', 'DEU', 'ألمانيا'),
(74317, 3280941968, 3280941994, 'GB', 'GBR', 'المملكة المتحدة'),
(74318, 3280941995, 3280941996, 'DE', 'DEU', 'ألمانيا'),
(74319, 3280941997, 3280941998, 'GB', 'GBR', 'المملكة المتحدة'),
(74320, 3280941999, 3280942000, 'DE', 'DEU', 'ألمانيا'),
(74321, 3280942001, 3280942008, 'GB', 'GBR', 'المملكة المتحدة'),
(74322, 3280942009, 3280942009, 'DE', 'DEU', 'ألمانيا'),
(74323, 3280942010, 3280942010, 'GB', 'GBR', 'المملكة المتحدة'),
(74324, 3280942011, 3280942011, 'DE', 'DEU', 'ألمانيا'),
(74325, 3280942012, 3280942031, 'GB', 'GBR', 'المملكة المتحدة'),
(74326, 3280942032, 3280942047, 'DE', 'DEU', 'ألمانيا'),
(74327, 3280942048, 3280942335, 'GB', 'GBR', 'المملكة المتحدة'),
(74328, 3280942336, 3280942351, 'DE', 'DEU', 'ألمانيا'),
(74329, 3280942352, 3280942383, 'GB', 'GBR', 'المملكة المتحدة'),
(74330, 3280942384, 3280942399, 'DE', 'DEU', 'ألمانيا'),
(74331, 3280942400, 3280942431, 'GB', 'GBR', 'المملكة المتحدة'),
(74332, 3280942432, 3280942471, 'DE', 'DEU', 'ألمانيا'),
(74333, 3280942472, 3280943103, 'GB', 'GBR', 'المملكة المتحدة'),
(74334, 3280943104, 3280943359, 'DE', 'DEU', 'ألمانيا'),
(74335, 3280943360, 3280943615, 'GB', 'GBR', 'المملكة المتحدة'),
(74336, 3280943616, 3280943679, 'DE', 'DEU', 'ألمانيا'),
(74337, 3280943680, 3280943711, 'GB', 'GBR', 'المملكة المتحدة'),
(74338, 3280943712, 3280943743, 'DE', 'DEU', 'ألمانيا'),
(74339, 3280943744, 3280943935, 'GB', 'GBR', 'المملكة المتحدة'),
(74340, 3280943936, 3280943943, 'DE', 'DEU', 'ألمانيا'),
(74341, 3280943944, 3280943967, 'GB', 'GBR', 'المملكة المتحدة'),
(74342, 3280943968, 3280943983, 'DE', 'DEU', 'ألمانيا'),
(74343, 3280943984, 3280944191, 'GB', 'GBR', 'المملكة المتحدة'),
(74344, 3280944192, 3280944199, 'DE', 'DEU', 'ألمانيا'),
(74345, 3280944200, 3280944215, 'GB', 'GBR', 'المملكة المتحدة'),
(74346, 3280944216, 3280944219, 'DE', 'DEU', 'ألمانيا'),
(74347, 3280944220, 3280944223, 'GB', 'GBR', 'المملكة المتحدة'),
(74348, 3280944224, 3280944225, 'DE', 'DEU', 'ألمانيا'),
(74349, 3280944226, 3280944243, 'GB', 'GBR', 'المملكة المتحدة'),
(74350, 3280944244, 3280944247, 'DE', 'DEU', 'ألمانيا'),
(74351, 3280944248, 3280944447, 'GB', 'GBR', 'المملكة المتحدة'),
(74352, 3280944448, 3280944527, 'DE', 'DEU', 'ألمانيا'),
(74353, 3280944528, 3280944543, 'GB', 'GBR', 'المملكة المتحدة'),
(74354, 3280944544, 3280944575, 'DE', 'DEU', 'ألمانيا'),
(74355, 3280944576, 3280944591, 'GB', 'GBR', 'المملكة المتحدة'),
(74356, 3280944592, 3280944607, 'DE', 'DEU', 'ألمانيا'),
(74357, 3280944608, 3280944623, 'GB', 'GBR', 'المملكة المتحدة'),
(74358, 3280944624, 3280944639, 'DE', 'DEU', 'ألمانيا'),
(74359, 3280944640, 3280945186, 'GB', 'GBR', 'المملكة المتحدة'),
(74360, 3280945187, 3280945189, 'DE', 'DEU', 'ألمانيا'),
(74361, 3280945190, 3280945312, 'GB', 'GBR', 'المملكة المتحدة'),
(74362, 3280945313, 3280945313, 'DE', 'DEU', 'ألمانيا'),
(74363, 3280945314, 3280945315, 'GB', 'GBR', 'المملكة المتحدة'),
(74364, 3280945316, 3280945317, 'DE', 'DEU', 'ألمانيا'),
(74365, 3280945318, 3280945319, 'GB', 'GBR', 'المملكة المتحدة'),
(74366, 3280945320, 3280945323, 'DE', 'DEU', 'ألمانيا'),
(74367, 3280945324, 3280945327, 'GB', 'GBR', 'المملكة المتحدة'),
(74368, 3280945328, 3280945335, 'DE', 'DEU', 'ألمانيا'),
(74369, 3280945336, 3280945439, 'GB', 'GBR', 'المملكة المتحدة'),
(74370, 3280945440, 3280945503, 'DE', 'DEU', 'ألمانيا'),
(74371, 3280945504, 3280945535, 'GB', 'GBR', 'المملكة المتحدة'),
(74372, 3280945536, 3280945551, 'DE', 'DEU', 'ألمانيا'),
(74373, 3280945552, 3280945679, 'GB', 'GBR', 'المملكة المتحدة'),
(74374, 3280945680, 3280945695, 'DE', 'DEU', 'ألمانيا'),
(74375, 3280945696, 3280945715, 'GB', 'GBR', 'المملكة المتحدة'),
(74376, 3280945716, 3280945719, 'DE', 'DEU', 'ألمانيا'),
(74377, 3280945720, 3280945743, 'GB', 'GBR', 'المملكة المتحدة'),
(74378, 3280945744, 3280945751, 'DE', 'DEU', 'ألمانيا'),
(74379, 3280945752, 3280945759, 'GB', 'GBR', 'المملكة المتحدة'),
(74380, 3280945760, 3280945767, 'DE', 'DEU', 'ألمانيا'),
(74381, 3280945768, 3280945776, 'GB', 'GBR', 'المملكة المتحدة'),
(74382, 3280945777, 3280945777, 'DE', 'DEU', 'ألمانيا'),
(74383, 3280945778, 3280945812, 'GB', 'GBR', 'المملكة المتحدة'),
(74384, 3280945813, 3280945814, 'DE', 'DEU', 'ألمانيا'),
(74385, 3280945815, 3280945817, 'GB', 'GBR', 'المملكة المتحدة'),
(74386, 3280945818, 3280945818, 'DE', 'DEU', 'ألمانيا'),
(74387, 3280945819, 3280945819, 'GB', 'GBR', 'المملكة المتحدة'),
(74388, 3280945820, 3280945820, 'DE', 'DEU', 'ألمانيا'),
(74389, 3280945821, 3280945821, 'GB', 'GBR', 'المملكة المتحدة'),
(74390, 3280945822, 3280945823, 'DE', 'DEU', 'ألمانيا'),
(74391, 3280945824, 3280945835, 'GB', 'GBR', 'المملكة المتحدة'),
(74392, 3280945836, 3280945840, 'DE', 'DEU', 'ألمانيا'),
(74393, 3280945841, 3280945842, 'GB', 'GBR', 'المملكة المتحدة'),
(74394, 3280945843, 3280945843, 'DE', 'DEU', 'ألمانيا'),
(74395, 3280945844, 3280945847, 'GB', 'GBR', 'المملكة المتحدة'),
(74396, 3280945848, 3280945853, 'DE', 'DEU', 'ألمانيا'),
(74397, 3280945854, 3280945855, 'GB', 'GBR', 'المملكة المتحدة'),
(74398, 3280945856, 3280945919, 'DE', 'DEU', 'ألمانيا'),
(74399, 3280945920, 3280946721, 'GB', 'GBR', 'المملكة المتحدة'),
(74400, 3280946722, 3280946722, 'DE', 'DEU', 'ألمانيا'),
(74401, 3280946723, 3280946723, 'GB', 'GBR', 'المملكة المتحدة'),
(74402, 3280946724, 3280946724, 'DE', 'DEU', 'ألمانيا'),
(74403, 3280946725, 3280948623, 'GB', 'GBR', 'المملكة المتحدة'),
(74404, 3280948624, 3280948639, 'DE', 'DEU', 'ألمانيا'),
(74405, 3280948640, 3280948719, 'GB', 'GBR', 'المملكة المتحدة'),
(74406, 3280948720, 3280948735, 'DE', 'DEU', 'ألمانيا'),
(74407, 3280948736, 3280949503, 'GB', 'GBR', 'المملكة المتحدة'),
(74408, 3280949504, 3280950015, 'DE', 'DEU', 'ألمانيا'),
(74409, 3280950016, 3280951039, 'GB', 'GBR', 'المملكة المتحدة'),
(74410, 3280951040, 3280951807, 'DE', 'DEU', 'ألمانيا'),
(74411, 3280951808, 3280952327, 'GB', 'GBR', 'المملكة المتحدة'),
(74412, 3280952328, 3280952335, 'DE', 'DEU', 'ألمانيا'),
(74413, 3280952336, 3280953104, 'GB', 'GBR', 'المملكة المتحدة'),
(74414, 3280953105, 3280953135, 'DE', 'DEU', 'ألمانيا'),
(74415, 3280953136, 3280953343, 'GB', 'GBR', 'المملكة المتحدة'),
(74416, 3280953344, 3280953371, 'DE', 'DEU', 'ألمانيا'),
(74417, 3280953372, 3280953375, 'GB', 'GBR', 'المملكة المتحدة'),
(74418, 3280953376, 3280953383, 'DE', 'DEU', 'ألمانيا'),
(74419, 3280953384, 3280953423, 'GB', 'GBR', 'المملكة المتحدة'),
(74420, 3280953424, 3280953431, 'DE', 'DEU', 'ألمانيا'),
(74421, 3280953432, 3280953443, 'GB', 'GBR', 'المملكة المتحدة'),
(74422, 3280953444, 3280953444, 'DE', 'DEU', 'ألمانيا'),
(74423, 3280953445, 3280953451, 'GB', 'GBR', 'المملكة المتحدة'),
(74424, 3280953452, 3280953454, 'DE', 'DEU', 'ألمانيا'),
(74425, 3280953455, 3280953455, 'GB', 'GBR', 'المملكة المتحدة'),
(74426, 3280953456, 3280953463, 'DE', 'DEU', 'ألمانيا'),
(74427, 3280953464, 3280953471, 'GB', 'GBR', 'المملكة المتحدة'),
(74428, 3280953472, 3280953475, 'DE', 'DEU', 'ألمانيا'),
(74429, 3280953476, 3280953479, 'GB', 'GBR', 'المملكة المتحدة'),
(74430, 3280953480, 3280953487, 'DE', 'DEU', 'ألمانيا'),
(74431, 3280953488, 3280953491, 'GB', 'GBR', 'المملكة المتحدة'),
(74432, 3280953492, 3280953492, 'DE', 'DEU', 'ألمانيا'),
(74433, 3280953493, 3280953493, 'GB', 'GBR', 'المملكة المتحدة'),
(74434, 3280953494, 3280953494, 'DE', 'DEU', 'ألمانيا'),
(74435, 3280953495, 3280953495, 'GB', 'GBR', 'المملكة المتحدة'),
(74436, 3280953496, 3280953503, 'DE', 'DEU', 'ألمانيا'),
(74437, 3280953504, 3280953519, 'GB', 'GBR', 'المملكة المتحدة'),
(74438, 3280953520, 3280953527, 'DE', 'DEU', 'ألمانيا'),
(74439, 3280953528, 3280953599, 'GB', 'GBR', 'المملكة المتحدة'),
(74440, 3280953600, 3280953663, 'DE', 'DEU', 'ألمانيا'),
(74441, 3280953664, 3280953807, 'GB', 'GBR', 'المملكة المتحدة'),
(74442, 3280953808, 3280953823, 'DE', 'DEU', 'ألمانيا'),
(74443, 3280953824, 3280954063, 'GB', 'GBR', 'المملكة المتحدة'),
(74444, 3280954064, 3280954079, 'DE', 'DEU', 'ألمانيا'),
(74445, 3280954080, 3280954119, 'GB', 'GBR', 'المملكة المتحدة'),
(74446, 3280954120, 3280954127, 'DE', 'DEU', 'ألمانيا'),
(74447, 3280954128, 3280954367, 'GB', 'GBR', 'المملكة المتحدة'),
(74448, 3280954368, 3280954495, 'DE', 'DEU', 'ألمانيا'),
(74449, 3280954496, 3280955391, 'GB', 'GBR', 'المملكة المتحدة'),
(74450, 3280955392, 3280956927, 'DE', 'DEU', 'ألمانيا'),
(74451, 3280956928, 3280956991, 'GB', 'GBR', 'المملكة المتحدة'),
(74452, 3280956992, 3280957007, 'DE', 'DEU', 'ألمانيا'),
(74453, 3280957008, 3280957015, 'GB', 'GBR', 'المملكة المتحدة'),
(74454, 3280957016, 3280957019, 'DE', 'DEU', 'ألمانيا'),
(74455, 3280957020, 3280957151, 'GB', 'GBR', 'المملكة المتحدة'),
(74456, 3280957152, 3280957167, 'DE', 'DEU', 'ألمانيا'),
(74457, 3280957168, 3280957183, 'GB', 'GBR', 'المملكة المتحدة'),
(74458, 3280957184, 3280957199, 'DE', 'DEU', 'ألمانيا'),
(74459, 3280957200, 3280957215, 'GB', 'GBR', 'المملكة المتحدة'),
(74460, 3280957216, 3280957231, 'DE', 'DEU', 'ألمانيا'),
(74461, 3280957232, 3280957247, 'GB', 'GBR', 'المملكة المتحدة'),
(74462, 3280957248, 3280957249, 'DE', 'DEU', 'ألمانيا'),
(74463, 3280957250, 3280957255, 'GB', 'GBR', 'المملكة المتحدة'),
(74464, 3280957256, 3280957263, 'DE', 'DEU', 'ألمانيا'),
(74465, 3280957264, 3280957311, 'GB', 'GBR', 'المملكة المتحدة'),
(74466, 3280957312, 3280957695, 'DE', 'DEU', 'ألمانيا'),
(74467, 3280957696, 3280957743, 'GB', 'GBR', 'المملكة المتحدة'),
(74468, 3280957744, 3280957791, 'DE', 'DEU', 'ألمانيا'),
(74469, 3280957792, 3280957823, 'GB', 'GBR', 'المملكة المتحدة'),
(74470, 3280957824, 3280957839, 'DE', 'DEU', 'ألمانيا'),
(74471, 3280957840, 3280957871, 'GB', 'GBR', 'المملكة المتحدة'),
(74472, 3280957872, 3280957887, 'DE', 'DEU', 'ألمانيا'),
(74473, 3280957888, 3280957935, 'GB', 'GBR', 'المملكة المتحدة'),
(74474, 3280957936, 3280957943, 'DE', 'DEU', 'ألمانيا'),
(74475, 3280957944, 3280958207, 'GB', 'GBR', 'المملكة المتحدة'),
(74476, 3280958208, 3280958223, 'DE', 'DEU', 'ألمانيا'),
(74477, 3280958224, 3280958287, 'GB', 'GBR', 'المملكة المتحدة'),
(74478, 3280958288, 3280958335, 'DE', 'DEU', 'ألمانيا'),
(74479, 3280958336, 3280958343, 'GB', 'GBR', 'المملكة المتحدة'),
(74480, 3280958344, 3280958350, 'DE', 'DEU', 'ألمانيا'),
(74481, 3280958351, 3280958591, 'GB', 'GBR', 'المملكة المتحدة'),
(74482, 3280958592, 3280958599, 'DE', 'DEU', 'ألمانيا'),
(74483, 3280958600, 3280958607, 'GB', 'GBR', 'المملكة المتحدة'),
(74484, 3280958608, 3280958615, 'DE', 'DEU', 'ألمانيا'),
(74485, 3280958616, 3280958655, 'GB', 'GBR', 'المملكة المتحدة'),
(74486, 3280958656, 3280958663, 'DE', 'DEU', 'ألمانيا'),
(74487, 3280958664, 3280958975, 'GB', 'GBR', 'المملكة المتحدة'),
(74488, 3280958976, 3280959231, 'DE', 'DEU', 'ألمانيا'),
(74489, 3280959232, 3280959487, 'GB', 'GBR', 'المملكة المتحدة'),
(74490, 3280959488, 3280959711, 'DE', 'DEU', 'ألمانيا'),
(74491, 3280959712, 3280959743, 'GB', 'GBR', 'المملكة المتحدة'),
(74492, 3280959744, 3280959935, 'DE', 'DEU', 'ألمانيا'),
(74493, 3280959936, 3280959999, 'GB', 'GBR', 'المملكة المتحدة'),
(74494, 3280960000, 3280960039, 'DE', 'DEU', 'ألمانيا'),
(74495, 3280960040, 3280960255, 'GB', 'GBR', 'المملكة المتحدة'),
(74496, 3280960256, 3280960287, 'DE', 'DEU', 'ألمانيا'),
(74497, 3280960288, 3280960511, 'GB', 'GBR', 'المملكة المتحدة'),
(74498, 3280960512, 3280961279, 'DE', 'DEU', 'ألمانيا'),
(74499, 3280961280, 3280961791, 'GB', 'GBR', 'المملكة المتحدة'),
(74500, 3280961792, 3280961807, 'DE', 'DEU', 'ألمانيا'),
(74501, 3280961808, 3280961855, 'GB', 'GBR', 'المملكة المتحدة'),
(74502, 3280961856, 3280961863, 'DE', 'DEU', 'ألمانيا'),
(74503, 3280961864, 3280961869, 'GB', 'GBR', 'المملكة المتحدة'),
(74504, 3280961870, 3280961871, 'DE', 'DEU', 'ألمانيا'),
(74505, 3280961872, 3280961887, 'GB', 'GBR', 'المملكة المتحدة'),
(74506, 3280961888, 3280961919, 'DE', 'DEU', 'ألمانيا'),
(74507, 3280961920, 3280962111, 'GB', 'GBR', 'المملكة المتحدة'),
(74508, 3280962112, 3280962175, 'DE', 'DEU', 'ألمانيا'),
(74509, 3280962176, 3280963199, 'GB', 'GBR', 'المملكة المتحدة'),
(74510, 3280963200, 3280963263, 'DE', 'DEU', 'ألمانيا'),
(74511, 3280963264, 3280963303, 'GB', 'GBR', 'المملكة المتحدة'),
(74512, 3280963304, 3280963311, 'DE', 'DEU', 'ألمانيا'),
(74513, 3280963312, 3280963327, 'GB', 'GBR', 'المملكة المتحدة'),
(74514, 3280963328, 3280963583, 'DE', 'DEU', 'ألمانيا'),
(74515, 3280963584, 3280963590, 'GB', 'GBR', 'المملكة المتحدة'),
(74516, 3280963591, 3280963591, 'DE', 'DEU', 'ألمانيا'),
(74517, 3280963592, 3280963593, 'GB', 'GBR', 'المملكة المتحدة'),
(74518, 3280963594, 3280963595, 'DE', 'DEU', 'ألمانيا'),
(74519, 3280963596, 3280963603, 'GB', 'GBR', 'المملكة المتحدة'),
(74520, 3280963604, 3280963604, 'DE', 'DEU', 'ألمانيا'),
(74521, 3280963605, 3280963615, 'GB', 'GBR', 'المملكة المتحدة'),
(74522, 3280963616, 3280963616, 'DE', 'DEU', 'ألمانيا'),
(74523, 3280963617, 3280963623, 'GB', 'GBR', 'المملكة المتحدة'),
(74524, 3280963624, 3280963631, 'DE', 'DEU', 'ألمانيا'),
(74525, 3280963632, 3280963711, 'GB', 'GBR', 'المملكة المتحدة'),
(74526, 3280963712, 3280963719, 'DE', 'DEU', 'ألمانيا'),
(74527, 3280963720, 3280963727, 'GB', 'GBR', 'المملكة المتحدة'),
(74528, 3280963728, 3280963735, 'DE', 'DEU', 'ألمانيا'),
(74529, 3280963736, 3280963751, 'GB', 'GBR', 'المملكة المتحدة'),
(74530, 3280963752, 3280963767, 'DE', 'DEU', 'ألمانيا'),
(74531, 3280963768, 3280963775, 'GB', 'GBR', 'المملكة المتحدة'),
(74532, 3280963776, 3280963791, 'DE', 'DEU', 'ألمانيا'),
(74533, 3280963792, 3280963823, 'GB', 'GBR', 'المملكة المتحدة'),
(74534, 3280963824, 3280963839, 'DE', 'DEU', 'ألمانيا'),
(74535, 3280963840, 3280964095, 'GB', 'GBR', 'المملكة المتحدة'),
(74536, 3280964096, 3280964351, 'DE', 'DEU', 'ألمانيا'),
(74537, 3280964352, 3280965631, 'GB', 'GBR', 'المملكة المتحدة'),
(74538, 3280965632, 3280965887, 'DE', 'DEU', 'ألمانيا'),
(74539, 3280965888, 3280965951, 'GB', 'GBR', 'المملكة المتحدة'),
(74540, 3280965952, 3280965967, 'DE', 'DEU', 'ألمانيا'),
(74541, 3280965968, 3280966015, 'GB', 'GBR', 'المملكة المتحدة'),
(74542, 3280966016, 3280966079, 'DE', 'DEU', 'ألمانيا'),
(74543, 3280966080, 3280966127, 'GB', 'GBR', 'المملكة المتحدة'),
(74544, 3280966128, 3280966143, 'DE', 'DEU', 'ألمانيا'),
(74545, 3280966144, 3280967167, 'GB', 'GBR', 'المملكة المتحدة'),
(74546, 3280967168, 3280967455, 'DE', 'DEU', 'ألمانيا'),
(74547, 3280967456, 3280967535, 'GB', 'GBR', 'المملكة المتحدة'),
(74548, 3280967536, 3280967551, 'DE', 'DEU', 'ألمانيا'),
(74549, 3280967552, 3280968447, 'GB', 'GBR', 'المملكة المتحدة'),
(74550, 3280968448, 3280968703, 'DE', 'DEU', 'ألمانيا'),
(74551, 3280968704, 3280969039, 'GB', 'GBR', 'المملكة المتحدة'),
(74552, 3280969040, 3280969087, 'DE', 'DEU', 'ألمانيا'),
(74553, 3280969088, 3280969599, 'GB', 'GBR', 'المملكة المتحدة'),
(74554, 3280969600, 3280969603, 'DE', 'DEU', 'ألمانيا'),
(74555, 3280969604, 3280969631, 'GB', 'GBR', 'المملكة المتحدة'),
(74556, 3280969632, 3280969647, 'DE', 'DEU', 'ألمانيا'),
(74557, 3280969648, 3280970239, 'GB', 'GBR', 'المملكة المتحدة'),
(74558, 3280970240, 3280970367, 'NL', 'NLD', 'هولندا'),
(74559, 3280970368, 3280970399, 'DE', 'DEU', 'ألمانيا'),
(74560, 3280970400, 3280970431, 'GB', 'GBR', 'المملكة المتحدة'),
(74561, 3280970432, 3280970463, 'DE', 'DEU', 'ألمانيا'),
(74562, 3280970464, 3280970507, 'GB', 'GBR', 'المملكة المتحدة'),
(74563, 3280970508, 3280970511, 'DE', 'DEU', 'ألمانيا'),
(74564, 3280970512, 3280970575, 'GB', 'GBR', 'المملكة المتحدة'),
(74565, 3280970576, 3280970579, 'DE', 'DEU', 'ألمانيا'),
(74566, 3280970580, 3280970671, 'GB', 'GBR', 'المملكة المتحدة'),
(74567, 3280970672, 3280970687, 'DE', 'DEU', 'ألمانيا'),
(74568, 3280970688, 3280970775, 'GB', 'GBR', 'المملكة المتحدة'),
(74569, 3280970776, 3280970783, 'DE', 'DEU', 'ألمانيا'),
(74570, 3280970784, 3280970799, 'GB', 'GBR', 'المملكة المتحدة'),
(74571, 3280970800, 3280970815, 'DE', 'DEU', 'ألمانيا'),
(74572, 3280970816, 3280970847, 'GB', 'GBR', 'المملكة المتحدة'),
(74573, 3280970848, 3280970863, 'DE', 'DEU', 'ألمانيا'),
(74574, 3280970864, 3280970975, 'GB', 'GBR', 'المملكة المتحدة'),
(74575, 3280970976, 3280970991, 'DE', 'DEU', 'ألمانيا'),
(74576, 3280970992, 3280971039, 'GB', 'GBR', 'المملكة المتحدة'),
(74577, 3280971040, 3280971055, 'DE', 'DEU', 'ألمانيا'),
(74578, 3280971056, 3280971295, 'GB', 'GBR', 'المملكة المتحدة'),
(74579, 3280971296, 3280971327, 'DE', 'DEU', 'ألمانيا'),
(74580, 3280971328, 3280971343, 'GB', 'GBR', 'المملكة المتحدة'),
(74581, 3280971344, 3280971351, 'DE', 'DEU', 'ألمانيا'),
(74582, 3280971352, 3280971359, 'GB', 'GBR', 'المملكة المتحدة'),
(74583, 3280971360, 3280971391, 'DE', 'DEU', 'ألمانيا'),
(74584, 3280971392, 3280971599, 'GB', 'GBR', 'المملكة المتحدة'),
(74585, 3280971600, 3280971615, 'DE', 'DEU', 'ألمانيا'),
(74586, 3280971616, 3280971647, 'GB', 'GBR', 'المملكة المتحدة'),
(74587, 3280971648, 3280971743, 'DE', 'DEU', 'ألمانيا'),
(74588, 3280971744, 3280971799, 'GB', 'GBR', 'المملكة المتحدة'),
(74589, 3280971800, 3280971807, 'DE', 'DEU', 'ألمانيا'),
(74590, 3280971808, 3280971815, 'GB', 'GBR', 'المملكة المتحدة'),
(74591, 3280971816, 3280971819, 'DE', 'DEU', 'ألمانيا'),
(74592, 3280971820, 3280971823, 'GB', 'GBR', 'المملكة المتحدة'),
(74593, 3280971824, 3280971839, 'DE', 'DEU', 'ألمانيا'),
(74594, 3280971840, 3280972031, 'GB', 'GBR', 'المملكة المتحدة'),
(74595, 3280972032, 3280972063, 'DE', 'DEU', 'ألمانيا'),
(74596, 3280972064, 3280972071, 'GB', 'GBR', 'المملكة المتحدة'),
(74597, 3280972072, 3280972079, 'DE', 'DEU', 'ألمانيا'),
(74598, 3280972080, 3280972319, 'GB', 'GBR', 'المملكة المتحدة'),
(74599, 3280972320, 3280972335, 'DE', 'DEU', 'ألمانيا'),
(74600, 3280972336, 3280972351, 'GB', 'GBR', 'المملكة المتحدة'),
(74601, 3280972352, 3280972415, 'DE', 'DEU', 'ألمانيا'),
(74602, 3280972416, 3280974079, 'GB', 'GBR', 'المملكة المتحدة'),
(74603, 3280974080, 3280974335, 'DE', 'DEU', 'ألمانيا'),
(74604, 3280974336, 3280974591, 'GB', 'GBR', 'المملكة المتحدة'),
(74605, 3280974592, 3280974847, 'DE', 'DEU', 'ألمانيا'),
(74606, 3280974848, 3280976695, 'GB', 'GBR', 'المملكة المتحدة'),
(74607, 3280976696, 3280976719, 'DE', 'DEU', 'ألمانيا'),
(74608, 3280976720, 3280976831, 'GB', 'GBR', 'المملكة المتحدة'),
(74609, 3280976832, 3280976847, 'DE', 'DEU', 'ألمانيا'),
(74610, 3280976848, 3280976895, 'GB', 'GBR', 'المملكة المتحدة'),
(74611, 3280976896, 3280977152, 'DE', 'DEU', 'ألمانيا'),
(74612, 3280977153, 3280977439, 'GB', 'GBR', 'المملكة المتحدة'),
(74613, 3280977440, 3280977479, 'DE', 'DEU', 'ألمانيا'),
(74614, 3280977480, 3280977487, 'GB', 'GBR', 'المملكة المتحدة'),
(74615, 3280977488, 3280977495, 'DE', 'DEU', 'ألمانيا'),
(74616, 3280977496, 3280977935, 'GB', 'GBR', 'المملكة المتحدة'),
(74617, 3280977936, 3280977936, 'DE', 'DEU', 'ألمانيا'),
(74618, 3280977937, 3280977937, 'GB', 'GBR', 'المملكة المتحدة'),
(74619, 3280977938, 3280977938, 'DE', 'DEU', 'ألمانيا'),
(74620, 3280977939, 3280977941, 'GB', 'GBR', 'المملكة المتحدة'),
(74621, 3280977942, 3280977942, 'DE', 'DEU', 'ألمانيا'),
(74622, 3280977943, 3280977947, 'GB', 'GBR', 'المملكة المتحدة'),
(74623, 3280977948, 3280977959, 'DE', 'DEU', 'ألمانيا'),
(74624, 3280977960, 3280977967, 'GB', 'GBR', 'المملكة المتحدة'),
(74625, 3280977968, 3280977969, 'DE', 'DEU', 'ألمانيا'),
(74626, 3280977970, 3280977974, 'GB', 'GBR', 'المملكة المتحدة'),
(74627, 3280977975, 3280977975, 'DE', 'DEU', 'ألمانيا'),
(74628, 3280977976, 3280977983, 'GB', 'GBR', 'المملكة المتحدة'),
(74629, 3280977984, 3280978007, 'DE', 'DEU', 'ألمانيا'),
(74630, 3280978008, 3280978063, 'GB', 'GBR', 'المملكة المتحدة'),
(74631, 3280978064, 3280978079, 'DE', 'DEU', 'ألمانيا'),
(74632, 3280978080, 3280978127, 'GB', 'GBR', 'المملكة المتحدة'),
(74633, 3280978128, 3280978143, 'DE', 'DEU', 'ألمانيا'),
(74634, 3280978144, 3280978175, 'GB', 'GBR', 'المملكة المتحدة'),
(74635, 3280978176, 3280978191, 'DE', 'DEU', 'ألمانيا'),
(74636, 3280978192, 3280978225, 'GB', 'GBR', 'المملكة المتحدة'),
(74637, 3280978226, 3280978226, 'DE', 'DEU', 'ألمانيا'),
(74638, 3280978227, 3280978231, 'GB', 'GBR', 'المملكة المتحدة'),
(74639, 3280978232, 3280978239, 'DE', 'DEU', 'ألمانيا'),
(74640, 3280978240, 3280978271, 'GB', 'GBR', 'المملكة المتحدة'),
(74641, 3280978272, 3280978279, 'DE', 'DEU', 'ألمانيا'),
(74642, 3280978280, 3280978335, 'GB', 'GBR', 'المملكة المتحدة'),
(74643, 3280978336, 3280978367, 'DE', 'DEU', 'ألمانيا'),
(74644, 3280978368, 3280978383, 'GB', 'GBR', 'المملكة المتحدة'),
(74645, 3280978384, 3280978415, 'DE', 'DEU', 'ألمانيا'),
(74646, 3280978416, 3280978433, 'GB', 'GBR', 'المملكة المتحدة'),
(74647, 3280978434, 3280978441, 'DE', 'DEU', 'ألمانيا'),
(74648, 3280978442, 3280978442, 'GB', 'GBR', 'المملكة المتحدة'),
(74649, 3280978443, 3280978443, 'DE', 'DEU', 'ألمانيا'),
(74650, 3280978444, 3280978445, 'GB', 'GBR', 'المملكة المتحدة'),
(74651, 3280978446, 3280978479, 'DE', 'DEU', 'ألمانيا'),
(74652, 3280978480, 3280978503, 'GB', 'GBR', 'المملكة المتحدة'),
(74653, 3280978504, 3280978507, 'DE', 'DEU', 'ألمانيا'),
(74654, 3280978508, 3280978543, 'GB', 'GBR', 'المملكة المتحدة'),
(74655, 3280978544, 3280978552, 'DE', 'DEU', 'ألمانيا'),
(74656, 3280978553, 3280978575, 'GB', 'GBR', 'المملكة المتحدة'),
(74657, 3280978576, 3280978591, 'DE', 'DEU', 'ألمانيا'),
(74658, 3280978592, 3280978783, 'GB', 'GBR', 'المملكة المتحدة'),
(74659, 3280978784, 3280978799, 'DE', 'DEU', 'ألمانيا'),
(74660, 3280978800, 3280978847, 'GB', 'GBR', 'المملكة المتحدة'),
(74661, 3280978848, 3280978863, 'DE', 'DEU', 'ألمانيا'),
(74662, 3280978864, 3280978887, 'GB', 'GBR', 'المملكة المتحدة'),
(74663, 3280978888, 3280978891, 'DE', 'DEU', 'ألمانيا'),
(74664, 3280978892, 3280979003, 'GB', 'GBR', 'المملكة المتحدة'),
(74665, 3280979004, 3280979007, 'DE', 'DEU', 'ألمانيا'),
(74666, 3280979008, 3280979023, 'GB', 'GBR', 'المملكة المتحدة'),
(74667, 3280979024, 3280979044, 'DE', 'DEU', 'ألمانيا'),
(74668, 3280979045, 3280979049, 'GB', 'GBR', 'المملكة المتحدة'),
(74669, 3280979050, 3280979051, 'DE', 'DEU', 'ألمانيا'),
(74670, 3280979052, 3280979052, 'GB', 'GBR', 'المملكة المتحدة'),
(74671, 3280979053, 3280979053, 'DE', 'DEU', 'ألمانيا'),
(74672, 3280979054, 3280979103, 'GB', 'GBR', 'المملكة المتحدة'),
(74673, 3280979104, 3280979111, 'DE', 'DEU', 'ألمانيا'),
(74674, 3280979112, 3280979141, 'GB', 'GBR', 'المملكة المتحدة'),
(74675, 3280979142, 3280979142, 'DE', 'DEU', 'ألمانيا'),
(74676, 3280979143, 3280979143, 'GB', 'GBR', 'المملكة المتحدة'),
(74677, 3280979144, 3280979147, 'DE', 'DEU', 'ألمانيا'),
(74678, 3280979148, 3280979151, 'GB', 'GBR', 'المملكة المتحدة'),
(74679, 3280979152, 3280979159, 'DE', 'DEU', 'ألمانيا'),
(74680, 3280979160, 3280979167, 'GB', 'GBR', 'المملكة المتحدة'),
(74681, 3280979168, 3280979183, 'DE', 'DEU', 'ألمانيا'),
(74682, 3280979184, 3280979199, 'GB', 'GBR', 'المملكة المتحدة'),
(74683, 3280979200, 3280979215, 'DE', 'DEU', 'ألمانيا'),
(74684, 3280979216, 3280979231, 'GB', 'GBR', 'المملكة المتحدة'),
(74685, 3280979232, 3280979247, 'DE', 'DEU', 'ألمانيا'),
(74686, 3280979248, 3280979311, 'GB', 'GBR', 'المملكة المتحدة'),
(74687, 3280979312, 3280979327, 'DE', 'DEU', 'ألمانيا'),
(74688, 3280979328, 3280979344, 'GB', 'GBR', 'المملكة المتحدة'),
(74689, 3280979345, 3280979345, 'DE', 'DEU', 'ألمانيا'),
(74690, 3280979346, 3280979348, 'GB', 'GBR', 'المملكة المتحدة'),
(74691, 3280979349, 3280979350, 'DE', 'DEU', 'ألمانيا'),
(74692, 3280979351, 3280979363, 'GB', 'GBR', 'المملكة المتحدة'),
(74693, 3280979364, 3280979364, 'DE', 'DEU', 'ألمانيا'),
(74694, 3280979365, 3280979419, 'GB', 'GBR', 'المملكة المتحدة'),
(74695, 3280979420, 3280979420, 'DE', 'DEU', 'ألمانيا'),
(74696, 3280979421, 3280979431, 'GB', 'GBR', 'المملكة المتحدة'),
(74697, 3280979432, 3280979435, 'DE', 'DEU', 'ألمانيا'),
(74698, 3280979436, 3280979471, 'GB', 'GBR', 'المملكة المتحدة'),
(74699, 3280979472, 3280979479, 'DE', 'DEU', 'ألمانيا'),
(74700, 3280979480, 3280979503, 'GB', 'GBR', 'المملكة المتحدة'),
(74701, 3280979504, 3280979519, 'DE', 'DEU', 'ألمانيا'),
(74702, 3280979520, 3280979527, 'GB', 'GBR', 'المملكة المتحدة'),
(74703, 3280979528, 3280979535, 'DE', 'DEU', 'ألمانيا'),
(74704, 3280979536, 3280979555, 'GB', 'GBR', 'المملكة المتحدة'),
(74705, 3280979556, 3280979559, 'DE', 'DEU', 'ألمانيا'),
(74706, 3280979560, 3280979567, 'GB', 'GBR', 'المملكة المتحدة'),
(74707, 3280979568, 3280979568, 'DE', 'DEU', 'ألمانيا'),
(74708, 3280979569, 3280979569, 'GB', 'GBR', 'المملكة المتحدة'),
(74709, 3280979570, 3280979571, 'DE', 'DEU', 'ألمانيا'),
(74710, 3280979572, 3280979573, 'GB', 'GBR', 'المملكة المتحدة'),
(74711, 3280979574, 3280979574, 'DE', 'DEU', 'ألمانيا'),
(74712, 3280979575, 3280979576, 'GB', 'GBR', 'المملكة المتحدة'),
(74713, 3280979577, 3280979577, 'DE', 'DEU', 'ألمانيا'),
(74714, 3280979578, 3280979631, 'GB', 'GBR', 'المملكة المتحدة'),
(74715, 3280979632, 3280979647, 'DE', 'DEU', 'ألمانيا'),
(74716, 3280979648, 3280979679, 'GB', 'GBR', 'المملكة المتحدة'),
(74717, 3280979680, 3280979695, 'DE', 'DEU', 'ألمانيا'),
(74718, 3280979696, 3280979711, 'GB', 'GBR', 'المملكة المتحدة'),
(74719, 3280979712, 3280979743, 'DE', 'DEU', 'ألمانيا'),
(74720, 3280979744, 3280979839, 'GB', 'GBR', 'المملكة المتحدة'),
(74721, 3280979840, 3280979975, 'DE', 'DEU', 'ألمانيا'),
(74722, 3280979976, 3280980031, 'GB', 'GBR', 'المملكة المتحدة'),
(74723, 3280980032, 3280980039, 'DE', 'DEU', 'ألمانيا'),
(74724, 3280980040, 3280980047, 'GB', 'GBR', 'المملكة المتحدة'),
(74725, 3280980048, 3280980071, 'DE', 'DEU', 'ألمانيا'),
(74726, 3280980072, 3280980079, 'GB', 'GBR', 'المملكة المتحدة'),
(74727, 3280980080, 3280980081, 'DE', 'DEU', 'ألمانيا'),
(74728, 3280980082, 3280980085, 'GB', 'GBR', 'المملكة المتحدة'),
(74729, 3280980086, 3280980086, 'DE', 'DEU', 'ألمانيا'),
(74730, 3280980087, 3280980089, 'GB', 'GBR', 'المملكة المتحدة'),
(74731, 3280980090, 3280980090, 'DE', 'DEU', 'ألمانيا'),
(74732, 3280980091, 3280980092, 'GB', 'GBR', 'المملكة المتحدة'),
(74733, 3280980093, 3280980093, 'DE', 'DEU', 'ألمانيا'),
(74734, 3280980094, 3280980094, 'GB', 'GBR', 'المملكة المتحدة'),
(74735, 3280980095, 3280980095, 'DE', 'DEU', 'ألمانيا'),
(74736, 3280980096, 3280980103, 'GB', 'GBR', 'المملكة المتحدة'),
(74737, 3280980104, 3280980111, 'DE', 'DEU', 'ألمانيا'),
(74738, 3280980112, 3280980135, 'GB', 'GBR', 'المملكة المتحدة'),
(74739, 3280980136, 3280980143, 'DE', 'DEU', 'ألمانيا'),
(74740, 3280980144, 3280980147, 'GB', 'GBR', 'المملكة المتحدة'),
(74741, 3280980148, 3280980151, 'DE', 'DEU', 'ألمانيا'),
(74742, 3280980152, 3280980168, 'GB', 'GBR', 'المملكة المتحدة'),
(74743, 3280980169, 3280980170, 'DE', 'DEU', 'ألمانيا'),
(74744, 3280980171, 3280980175, 'GB', 'GBR', 'المملكة المتحدة'),
(74745, 3280980176, 3280980183, 'DE', 'DEU', 'ألمانيا'),
(74746, 3280980184, 3280980191, 'GB', 'GBR', 'المملكة المتحدة'),
(74747, 3280980192, 3280980199, 'DE', 'DEU', 'ألمانيا'),
(74748, 3280980200, 3280980298, 'GB', 'GBR', 'المملكة المتحدة'),
(74749, 3280980299, 3280980299, 'DE', 'DEU', 'ألمانيا'),
(74750, 3280980300, 3280980300, 'GB', 'GBR', 'المملكة المتحدة'),
(74751, 3280980301, 3280980304, 'DE', 'DEU', 'ألمانيا'),
(74752, 3280980305, 3280980305, 'GB', 'GBR', 'المملكة المتحدة'),
(74753, 3280980306, 3280980307, 'DE', 'DEU', 'ألمانيا'),
(74754, 3280980308, 3280980310, 'GB', 'GBR', 'المملكة المتحدة'),
(74755, 3280980311, 3280980311, 'DE', 'DEU', 'ألمانيا'),
(74756, 3280980312, 3280980312, 'GB', 'GBR', 'المملكة المتحدة'),
(74757, 3280980313, 3280980313, 'DE', 'DEU', 'ألمانيا'),
(74758, 3280980314, 3280980351, 'GB', 'GBR', 'المملكة المتحدة'),
(74759, 3280980352, 3280980367, 'DE', 'DEU', 'ألمانيا'),
(74760, 3280980368, 3280980383, 'GB', 'GBR', 'المملكة المتحدة'),
(74761, 3280980384, 3280980399, 'DE', 'DEU', 'ألمانيا'),
(74762, 3280980400, 3280980471, 'GB', 'GBR', 'المملكة المتحدة'),
(74763, 3280980472, 3280980479, 'DE', 'DEU', 'ألمانيا'),
(74764, 3280980480, 3280980503, 'GB', 'GBR', 'المملكة المتحدة'),
(74765, 3280980504, 3280980508, 'DE', 'DEU', 'ألمانيا'),
(74766, 3280980509, 3280980592, 'GB', 'GBR', 'المملكة المتحدة'),
(74767, 3280980593, 3280980594, 'DE', 'DEU', 'ألمانيا'),
(74768, 3280980595, 3280980597, 'GB', 'GBR', 'المملكة المتحدة'),
(74769, 3280980598, 3280980598, 'DE', 'DEU', 'ألمانيا'),
(74770, 3280980599, 3280980601, 'GB', 'GBR', 'المملكة المتحدة'),
(74771, 3280980602, 3280980602, 'DE', 'DEU', 'ألمانيا'),
(74772, 3280980603, 3280980603, 'GB', 'GBR', 'المملكة المتحدة'),
(74773, 3280980604, 3280980606, 'DE', 'DEU', 'ألمانيا'),
(74774, 3280980607, 3280980639, 'GB', 'GBR', 'المملكة المتحدة'),
(74775, 3280980640, 3280980647, 'DE', 'DEU', 'ألمانيا'),
(74776, 3280980648, 3280980683, 'GB', 'GBR', 'المملكة المتحدة'),
(74777, 3280980684, 3280980703, 'DE', 'DEU', 'ألمانيا'),
(74778, 3280980704, 3280980759, 'GB', 'GBR', 'المملكة المتحدة'),
(74779, 3280980760, 3280980767, 'DE', 'DEU', 'ألمانيا'),
(74780, 3280980768, 3280980823, 'GB', 'GBR', 'المملكة المتحدة'),
(74781, 3280980824, 3280980827, 'DE', 'DEU', 'ألمانيا'),
(74782, 3280980828, 3280980831, 'GB', 'GBR', 'المملكة المتحدة'),
(74783, 3280980832, 3280980847, 'DE', 'DEU', 'ألمانيا'),
(74784, 3280980848, 3280980927, 'GB', 'GBR', 'المملكة المتحدة'),
(74785, 3280980928, 3280980991, 'DE', 'DEU', 'ألمانيا'),
(74786, 3280980992, 3280980993, 'GB', 'GBR', 'المملكة المتحدة'),
(74787, 3280980994, 3280980996, 'DE', 'DEU', 'ألمانيا'),
(74788, 3280980997, 3280981000, 'GB', 'GBR', 'المملكة المتحدة'),
(74789, 3280981001, 3280981001, 'DE', 'DEU', 'ألمانيا'),
(74790, 3280981002, 3280981039, 'GB', 'GBR', 'المملكة المتحدة'),
(74791, 3280981040, 3280981055, 'DE', 'DEU', 'ألمانيا'),
(74792, 3280981056, 3280981087, 'GB', 'GBR', 'المملكة المتحدة'),
(74793, 3280981088, 3280981111, 'DE', 'DEU', 'ألمانيا'),
(74794, 3280981112, 3280981135, 'GB', 'GBR', 'المملكة المتحدة'),
(74795, 3280981136, 3280981151, 'DE', 'DEU', 'ألمانيا'),
(74796, 3280981152, 3280981179, 'GB', 'GBR', 'المملكة المتحدة'),
(74797, 3280981180, 3280981183, 'DE', 'DEU', 'ألمانيا'),
(74798, 3280981184, 3280981199, 'GB', 'GBR', 'المملكة المتحدة'),
(74799, 3280981200, 3280981207, 'DE', 'DEU', 'ألمانيا'),
(74800, 3280981208, 3280981215, 'GB', 'GBR', 'المملكة المتحدة'),
(74801, 3280981216, 3280981231, 'DE', 'DEU', 'ألمانيا'),
(74802, 3280981232, 3280981247, 'GB', 'GBR', 'المملكة المتحدة'),
(74803, 3280981248, 3280981375, 'DE', 'DEU', 'ألمانيا'),
(74804, 3280981376, 3280981407, 'GB', 'GBR', 'المملكة المتحدة'),
(74805, 3280981408, 3280981415, 'DE', 'DEU', 'ألمانيا'),
(74806, 3280981416, 3280981487, 'GB', 'GBR', 'المملكة المتحدة'),
(74807, 3280981488, 3280981503, 'DE', 'DEU', 'ألمانيا'),
(74808, 3280981504, 3280981555, 'GB', 'GBR', 'المملكة المتحدة'),
(74809, 3280981556, 3280981556, 'DE', 'DEU', 'ألمانيا'),
(74810, 3280981557, 3280981557, 'GB', 'GBR', 'المملكة المتحدة'),
(74811, 3280981558, 3280981558, 'DE', 'DEU', 'ألمانيا'),
(74812, 3280981559, 3280981559, 'GB', 'GBR', 'المملكة المتحدة'),
(74813, 3280981560, 3280981561, 'DE', 'DEU', 'ألمانيا'),
(74814, 3280981562, 3280981599, 'GB', 'GBR', 'المملكة المتحدة'),
(74815, 3280981600, 3280981615, 'DE', 'DEU', 'ألمانيا'),
(74816, 3280981616, 3280981623, 'GB', 'GBR', 'المملكة المتحدة'),
(74817, 3280981624, 3280981647, 'DE', 'DEU', 'ألمانيا'),
(74818, 3280981648, 3280981983, 'GB', 'GBR', 'المملكة المتحدة'),
(74819, 3280981984, 3280981999, 'DE', 'DEU', 'ألمانيا'),
(74820, 3280982000, 3280982015, 'GB', 'GBR', 'المملكة المتحدة'),
(74821, 3280982016, 3280982023, 'DE', 'DEU', 'ألمانيا'),
(74822, 3280982024, 3280982047, 'GB', 'GBR', 'المملكة المتحدة'),
(74823, 3280982048, 3280982051, 'DE', 'DEU', 'ألمانيا'),
(74824, 3280982052, 3280982052, 'GB', 'GBR', 'المملكة المتحدة'),
(74825, 3280982053, 3280982053, 'DE', 'DEU', 'ألمانيا'),
(74826, 3280982054, 3280982079, 'GB', 'GBR', 'المملكة المتحدة'),
(74827, 3280982080, 3280982095, 'DE', 'DEU', 'ألمانيا'),
(74828, 3280982096, 3280982167, 'GB', 'GBR', 'المملكة المتحدة'),
(74829, 3280982168, 3280982175, 'DE', 'DEU', 'ألمانيا'),
(74830, 3280982176, 3280982239, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(74831, 3280982240, 3280982263, 'DE', 'DEU', 'ألمانيا'),
(74832, 3280982264, 3280982269, 'GB', 'GBR', 'المملكة المتحدة'),
(74833, 3280982270, 3280982270, 'DE', 'DEU', 'ألمانيا'),
(74834, 3280982271, 3280982271, 'GB', 'GBR', 'المملكة المتحدة'),
(74835, 3280982272, 3280982287, 'DE', 'DEU', 'ألمانيا'),
(74836, 3280982288, 3280982399, 'GB', 'GBR', 'المملكة المتحدة'),
(74837, 3280982400, 3280982431, 'DE', 'DEU', 'ألمانيا'),
(74838, 3280982432, 3280982528, 'GB', 'GBR', 'المملكة المتحدة'),
(74839, 3280982529, 3280982529, 'DE', 'DEU', 'ألمانيا'),
(74840, 3280982530, 3280982530, 'GB', 'GBR', 'المملكة المتحدة'),
(74841, 3280982531, 3280982531, 'DE', 'DEU', 'ألمانيا'),
(74842, 3280982532, 3280982536, 'GB', 'GBR', 'المملكة المتحدة'),
(74843, 3280982537, 3280982537, 'DE', 'DEU', 'ألمانيا'),
(74844, 3280982538, 3280982580, 'GB', 'GBR', 'المملكة المتحدة'),
(74845, 3280982581, 3280982582, 'DE', 'DEU', 'ألمانيا'),
(74846, 3280982583, 3280982607, 'GB', 'GBR', 'المملكة المتحدة'),
(74847, 3280982608, 3280982671, 'DE', 'DEU', 'ألمانيا'),
(74848, 3280982672, 3280982676, 'GB', 'GBR', 'المملكة المتحدة'),
(74849, 3280982677, 3280982677, 'DE', 'DEU', 'ألمانيا'),
(74850, 3280982678, 3280982678, 'GB', 'GBR', 'المملكة المتحدة'),
(74851, 3280982679, 3280982679, 'DE', 'DEU', 'ألمانيا'),
(74852, 3280982680, 3280982680, 'GB', 'GBR', 'المملكة المتحدة'),
(74853, 3280982681, 3280982686, 'DE', 'DEU', 'ألمانيا'),
(74854, 3280982687, 3280982767, 'GB', 'GBR', 'المملكة المتحدة'),
(74855, 3280982768, 3280982783, 'DE', 'DEU', 'ألمانيا'),
(74856, 3280982784, 3280982799, 'GB', 'GBR', 'المملكة المتحدة'),
(74857, 3280982800, 3280982815, 'DE', 'DEU', 'ألمانيا'),
(74858, 3280982816, 3280982863, 'GB', 'GBR', 'المملكة المتحدة'),
(74859, 3280982864, 3280982864, 'DE', 'DEU', 'ألمانيا'),
(74860, 3280982865, 3280982866, 'GB', 'GBR', 'المملكة المتحدة'),
(74861, 3280982867, 3280982867, 'DE', 'DEU', 'ألمانيا'),
(74862, 3280982868, 3280982879, 'GB', 'GBR', 'المملكة المتحدة'),
(74863, 3280982880, 3280982895, 'DE', 'DEU', 'ألمانيا'),
(74864, 3280982896, 3280982911, 'GB', 'GBR', 'المملكة المتحدة'),
(74865, 3280982912, 3280982931, 'DE', 'DEU', 'ألمانيا'),
(74866, 3280982932, 3280982943, 'GB', 'GBR', 'المملكة المتحدة'),
(74867, 3280982944, 3280982975, 'DE', 'DEU', 'ألمانيا'),
(74868, 3280982976, 3280983072, 'GB', 'GBR', 'المملكة المتحدة'),
(74869, 3280983073, 3280983073, 'DE', 'DEU', 'ألمانيا'),
(74870, 3280983074, 3280983103, 'GB', 'GBR', 'المملكة المتحدة'),
(74871, 3280983104, 3280983104, 'DE', 'DEU', 'ألمانيا'),
(74872, 3280983105, 3280983112, 'GB', 'GBR', 'المملكة المتحدة'),
(74873, 3280983113, 3280983113, 'DE', 'DEU', 'ألمانيا'),
(74874, 3280983114, 3280983114, 'GB', 'GBR', 'المملكة المتحدة'),
(74875, 3280983115, 3280983183, 'DE', 'DEU', 'ألمانيا'),
(74876, 3280983184, 3280983199, 'GB', 'GBR', 'المملكة المتحدة'),
(74877, 3280983200, 3280983215, 'DE', 'DEU', 'ألمانيا'),
(74878, 3280983216, 3280983343, 'GB', 'GBR', 'المملكة المتحدة'),
(74879, 3280983344, 3280983375, 'DE', 'DEU', 'ألمانيا'),
(74880, 3280983376, 3280983391, 'GB', 'GBR', 'المملكة المتحدة'),
(74881, 3280983392, 3280983407, 'DE', 'DEU', 'ألمانيا'),
(74882, 3280983408, 3280983423, 'GB', 'GBR', 'المملكة المتحدة'),
(74883, 3280983424, 3280983431, 'DE', 'DEU', 'ألمانيا'),
(74884, 3280983432, 3280983455, 'GB', 'GBR', 'المملكة المتحدة'),
(74885, 3280983456, 3280983471, 'DE', 'DEU', 'ألمانيا'),
(74886, 3280983472, 3280983487, 'GB', 'GBR', 'المملكة المتحدة'),
(74887, 3280983488, 3280983515, 'DE', 'DEU', 'ألمانيا'),
(74888, 3280983516, 3280983516, 'GB', 'GBR', 'المملكة المتحدة'),
(74889, 3280983517, 3280983517, 'DE', 'DEU', 'ألمانيا'),
(74890, 3280983518, 3280983518, 'GB', 'GBR', 'المملكة المتحدة'),
(74891, 3280983519, 3280983527, 'DE', 'DEU', 'ألمانيا'),
(74892, 3280983528, 3280983695, 'GB', 'GBR', 'المملكة المتحدة'),
(74893, 3280983696, 3280983711, 'DE', 'DEU', 'ألمانيا'),
(74894, 3280983712, 3280983783, 'GB', 'GBR', 'المملكة المتحدة'),
(74895, 3280983784, 3280983791, 'DE', 'DEU', 'ألمانيا'),
(74896, 3280983792, 3280983807, 'GB', 'GBR', 'المملكة المتحدة'),
(74897, 3280983808, 3280983815, 'DE', 'DEU', 'ألمانيا'),
(74898, 3280983816, 3280983887, 'GB', 'GBR', 'المملكة المتحدة'),
(74899, 3280983888, 3280983919, 'DE', 'DEU', 'ألمانيا'),
(74900, 3280983920, 3280983927, 'GB', 'GBR', 'المملكة المتحدة'),
(74901, 3280983928, 3280983939, 'DE', 'DEU', 'ألمانيا'),
(74902, 3280983940, 3280983951, 'GB', 'GBR', 'المملكة المتحدة'),
(74903, 3280983952, 3280983975, 'DE', 'DEU', 'ألمانيا'),
(74904, 3280983976, 3280983999, 'GB', 'GBR', 'المملكة المتحدة'),
(74905, 3280984000, 3280984007, 'DE', 'DEU', 'ألمانيا'),
(74906, 3280984008, 3280984013, 'GB', 'GBR', 'المملكة المتحدة'),
(74907, 3280984014, 3280984014, 'DE', 'DEU', 'ألمانيا'),
(74908, 3280984015, 3280984015, 'GB', 'GBR', 'المملكة المتحدة'),
(74909, 3280984016, 3280984031, 'DE', 'DEU', 'ألمانيا'),
(74910, 3280984032, 3280984319, 'GB', 'GBR', 'المملكة المتحدة'),
(74911, 3280984320, 3280984335, 'DE', 'DEU', 'ألمانيا'),
(74912, 3280984336, 3280984367, 'GB', 'GBR', 'المملكة المتحدة'),
(74913, 3280984368, 3280984399, 'DE', 'DEU', 'ألمانيا'),
(74914, 3280984400, 3280984431, 'GB', 'GBR', 'المملكة المتحدة'),
(74915, 3280984432, 3280984443, 'DE', 'DEU', 'ألمانيا'),
(74916, 3280984444, 3280984445, 'GB', 'GBR', 'المملكة المتحدة'),
(74917, 3280984446, 3280984495, 'DE', 'DEU', 'ألمانيا'),
(74918, 3280984496, 3280984503, 'GB', 'GBR', 'المملكة المتحدة'),
(74919, 3280984504, 3280984511, 'DE', 'DEU', 'ألمانيا'),
(74920, 3280984512, 3280984527, 'GB', 'GBR', 'المملكة المتحدة'),
(74921, 3280984528, 3280984535, 'DE', 'DEU', 'ألمانيا'),
(74922, 3280984536, 3280984559, 'GB', 'GBR', 'المملكة المتحدة'),
(74923, 3280984560, 3280984567, 'DE', 'DEU', 'ألمانيا'),
(74924, 3280984568, 3280984639, 'GB', 'GBR', 'المملكة المتحدة'),
(74925, 3280984640, 3280984640, 'DE', 'DEU', 'ألمانيا'),
(74926, 3280984641, 3280984642, 'GB', 'GBR', 'المملكة المتحدة'),
(74927, 3280984643, 3280984643, 'DE', 'DEU', 'ألمانيا'),
(74928, 3280984644, 3280984646, 'GB', 'GBR', 'المملكة المتحدة'),
(74929, 3280984647, 3280984647, 'DE', 'DEU', 'ألمانيا'),
(74930, 3280984648, 3280984661, 'GB', 'GBR', 'المملكة المتحدة'),
(74931, 3280984662, 3280984662, 'DE', 'DEU', 'ألمانيا'),
(74932, 3280984663, 3280984663, 'GB', 'GBR', 'المملكة المتحدة'),
(74933, 3280984664, 3280984671, 'DE', 'DEU', 'ألمانيا'),
(74934, 3280984672, 3280984984, 'GB', 'GBR', 'المملكة المتحدة'),
(74935, 3280984985, 3280984985, 'DE', 'DEU', 'ألمانيا'),
(74936, 3280984986, 3280984987, 'GB', 'GBR', 'المملكة المتحدة'),
(74937, 3280984988, 3280984988, 'DE', 'DEU', 'ألمانيا'),
(74938, 3280984989, 3280984991, 'GB', 'GBR', 'المملكة المتحدة'),
(74939, 3280984992, 3280985007, 'DE', 'DEU', 'ألمانيا'),
(74940, 3280985008, 3280985047, 'GB', 'GBR', 'المملكة المتحدة'),
(74941, 3280985048, 3280985055, 'DE', 'DEU', 'ألمانيا'),
(74942, 3280985056, 3280985079, 'GB', 'GBR', 'المملكة المتحدة'),
(74943, 3280985080, 3280985087, 'DE', 'DEU', 'ألمانيا'),
(74944, 3280985088, 3280985343, 'GB', 'GBR', 'المملكة المتحدة'),
(74945, 3280985344, 3280985415, 'DE', 'DEU', 'ألمانيا'),
(74946, 3280985416, 3280985431, 'GB', 'GBR', 'المملكة المتحدة'),
(74947, 3280985432, 3280985435, 'DE', 'DEU', 'ألمانيا'),
(74948, 3280985436, 3280985471, 'GB', 'GBR', 'المملكة المتحدة'),
(74949, 3280985472, 3280985631, 'DE', 'DEU', 'ألمانيا'),
(74950, 3280985632, 3280985635, 'GB', 'GBR', 'المملكة المتحدة'),
(74951, 3280985636, 3280985647, 'DE', 'DEU', 'ألمانيا'),
(74952, 3280985648, 3280985663, 'GB', 'GBR', 'المملكة المتحدة'),
(74953, 3280985664, 3280985679, 'DE', 'DEU', 'ألمانيا'),
(74954, 3280985680, 3280985695, 'GB', 'GBR', 'المملكة المتحدة'),
(74955, 3280985696, 3280985703, 'DE', 'DEU', 'ألمانيا'),
(74956, 3280985704, 3280985727, 'GB', 'GBR', 'المملكة المتحدة'),
(74957, 3280985728, 3280985735, 'DE', 'DEU', 'ألمانيا'),
(74958, 3280985736, 3280985791, 'GB', 'GBR', 'المملكة المتحدة'),
(74959, 3280985792, 3280985823, 'DE', 'DEU', 'ألمانيا'),
(74960, 3280985824, 3280985831, 'GB', 'GBR', 'المملكة المتحدة'),
(74961, 3280985832, 3280985832, 'DE', 'DEU', 'ألمانيا'),
(74962, 3280985833, 3280985833, 'GB', 'GBR', 'المملكة المتحدة'),
(74963, 3280985834, 3280985834, 'DE', 'DEU', 'ألمانيا'),
(74964, 3280985835, 3280986263, 'GB', 'GBR', 'المملكة المتحدة'),
(74965, 3280986264, 3280986267, 'DE', 'DEU', 'ألمانيا'),
(74966, 3280986268, 3280986271, 'GB', 'GBR', 'المملكة المتحدة'),
(74967, 3280986272, 3280986303, 'DE', 'DEU', 'ألمانيا'),
(74968, 3280986304, 3280986336, 'GB', 'GBR', 'المملكة المتحدة'),
(74969, 3280986337, 3280986337, 'DE', 'DEU', 'ألمانيا'),
(74970, 3280986338, 3280986338, 'GB', 'GBR', 'المملكة المتحدة'),
(74971, 3280986339, 3280986339, 'DE', 'DEU', 'ألمانيا'),
(74972, 3280986340, 3280986342, 'GB', 'GBR', 'المملكة المتحدة'),
(74973, 3280986343, 3280986343, 'DE', 'DEU', 'ألمانيا'),
(74974, 3280986344, 3280986356, 'GB', 'GBR', 'المملكة المتحدة'),
(74975, 3280986357, 3280986357, 'DE', 'DEU', 'ألمانيا'),
(74976, 3280986358, 3280986364, 'GB', 'GBR', 'المملكة المتحدة'),
(74977, 3280986365, 3280986365, 'DE', 'DEU', 'ألمانيا'),
(74978, 3280986366, 3280986527, 'GB', 'GBR', 'المملكة المتحدة'),
(74979, 3280986528, 3280986541, 'DE', 'DEU', 'ألمانيا'),
(74980, 3280986542, 3280986583, 'GB', 'GBR', 'المملكة المتحدة'),
(74981, 3280986584, 3280986599, 'DE', 'DEU', 'ألمانيا'),
(74982, 3280986600, 3280986615, 'GB', 'GBR', 'المملكة المتحدة'),
(74983, 3280986616, 3280986619, 'DE', 'DEU', 'ألمانيا'),
(74984, 3280986620, 3280986767, 'GB', 'GBR', 'المملكة المتحدة'),
(74985, 3280986768, 3280986775, 'DE', 'DEU', 'ألمانيا'),
(74986, 3280986776, 3280986783, 'GB', 'GBR', 'المملكة المتحدة'),
(74987, 3280986784, 3280986799, 'DE', 'DEU', 'ألمانيا'),
(74988, 3280986800, 3280986867, 'GB', 'GBR', 'المملكة المتحدة'),
(74989, 3280986868, 3280986871, 'DE', 'DEU', 'ألمانيا'),
(74990, 3280986872, 3280987343, 'GB', 'GBR', 'المملكة المتحدة'),
(74991, 3280987344, 3280987359, 'DE', 'DEU', 'ألمانيا'),
(74992, 3280987360, 3280987385, 'GB', 'GBR', 'المملكة المتحدة'),
(74993, 3280987386, 3280987387, 'DE', 'DEU', 'ألمانيا'),
(74994, 3280987388, 3280987647, 'GB', 'GBR', 'المملكة المتحدة'),
(74995, 3280987648, 3280987679, 'DE', 'DEU', 'ألمانيا'),
(74996, 3280987680, 3280987696, 'GB', 'GBR', 'المملكة المتحدة'),
(74997, 3280987697, 3280987697, 'DE', 'DEU', 'ألمانيا'),
(74998, 3280987698, 3280987698, 'GB', 'GBR', 'المملكة المتحدة'),
(74999, 3280987699, 3280987699, 'DE', 'DEU', 'ألمانيا'),
(75000, 3280987700, 3280987711, 'GB', 'GBR', 'المملكة المتحدة'),
(75001, 3280987712, 3280987727, 'DE', 'DEU', 'ألمانيا'),
(75002, 3280987728, 3280987775, 'GB', 'GBR', 'المملكة المتحدة'),
(75003, 3280987776, 3280987855, 'DE', 'DEU', 'ألمانيا'),
(75004, 3280987856, 3280987919, 'GB', 'GBR', 'المملكة المتحدة'),
(75005, 3280987920, 3280987935, 'DE', 'DEU', 'ألمانيا'),
(75006, 3280987936, 3280987936, 'GB', 'GBR', 'المملكة المتحدة'),
(75007, 3280987937, 3280987939, 'DE', 'DEU', 'ألمانيا'),
(75008, 3280987940, 3280987940, 'GB', 'GBR', 'المملكة المتحدة'),
(75009, 3280987941, 3280987942, 'DE', 'DEU', 'ألمانيا'),
(75010, 3280987943, 3280988111, 'GB', 'GBR', 'المملكة المتحدة'),
(75011, 3280988112, 3280988127, 'DE', 'DEU', 'ألمانيا'),
(75012, 3280988128, 3280988171, 'GB', 'GBR', 'المملكة المتحدة'),
(75013, 3280988172, 3280988175, 'DE', 'DEU', 'ألمانيا'),
(75014, 3280988176, 3280988207, 'GB', 'GBR', 'المملكة المتحدة'),
(75015, 3280988208, 3280988215, 'DE', 'DEU', 'ألمانيا'),
(75016, 3280988216, 3280988303, 'GB', 'GBR', 'المملكة المتحدة'),
(75017, 3280988304, 3280988311, 'DE', 'DEU', 'ألمانيا'),
(75018, 3280988312, 3280988383, 'GB', 'GBR', 'المملكة المتحدة'),
(75019, 3280988384, 3280988391, 'DE', 'DEU', 'ألمانيا'),
(75020, 3280988392, 3280988399, 'GB', 'GBR', 'المملكة المتحدة'),
(75021, 3280988400, 3280988431, 'DE', 'DEU', 'ألمانيا'),
(75022, 3280988432, 3280988671, 'GB', 'GBR', 'المملكة المتحدة'),
(75023, 3280988672, 3280988679, 'DE', 'DEU', 'ألمانيا'),
(75024, 3280988680, 3280988703, 'GB', 'GBR', 'المملكة المتحدة'),
(75025, 3280988704, 3280988719, 'DE', 'DEU', 'ألمانيا'),
(75026, 3280988720, 3280988740, 'GB', 'GBR', 'المملكة المتحدة'),
(75027, 3280988741, 3280988741, 'DE', 'DEU', 'ألمانيا'),
(75028, 3280988742, 3280988747, 'GB', 'GBR', 'المملكة المتحدة'),
(75029, 3280988748, 3280988751, 'DE', 'DEU', 'ألمانيا'),
(75030, 3280988752, 3280988815, 'GB', 'GBR', 'المملكة المتحدة'),
(75031, 3280988816, 3280988831, 'DE', 'DEU', 'ألمانيا'),
(75032, 3280988832, 3280988855, 'GB', 'GBR', 'المملكة المتحدة'),
(75033, 3280988856, 3280988879, 'DE', 'DEU', 'ألمانيا'),
(75034, 3280988880, 3280988895, 'GB', 'GBR', 'المملكة المتحدة'),
(75035, 3280988896, 3280988903, 'DE', 'DEU', 'ألمانيا'),
(75036, 3280988904, 3280988915, 'GB', 'GBR', 'المملكة المتحدة'),
(75037, 3280988916, 3280988916, 'DE', 'DEU', 'ألمانيا'),
(75038, 3280988917, 3280988917, 'GB', 'GBR', 'المملكة المتحدة'),
(75039, 3280988918, 3280988918, 'DE', 'DEU', 'ألمانيا'),
(75040, 3280988919, 3280988923, 'GB', 'GBR', 'المملكة المتحدة'),
(75041, 3280988924, 3280988943, 'DE', 'DEU', 'ألمانيا'),
(75042, 3280988944, 3280989007, 'GB', 'GBR', 'المملكة المتحدة'),
(75043, 3280989008, 3280989010, 'DE', 'DEU', 'ألمانيا'),
(75044, 3280989011, 3280989011, 'GB', 'GBR', 'المملكة المتحدة'),
(75045, 3280989012, 3280989012, 'DE', 'DEU', 'ألمانيا'),
(75046, 3280989013, 3280989023, 'GB', 'GBR', 'المملكة المتحدة'),
(75047, 3280989024, 3280989039, 'DE', 'DEU', 'ألمانيا'),
(75048, 3280989040, 3280989055, 'GB', 'GBR', 'المملكة المتحدة'),
(75049, 3280989056, 3280989063, 'DE', 'DEU', 'ألمانيا'),
(75050, 3280989064, 3280989067, 'GB', 'GBR', 'المملكة المتحدة'),
(75051, 3280989068, 3280989071, 'DE', 'DEU', 'ألمانيا'),
(75052, 3280989072, 3280989135, 'GB', 'GBR', 'المملكة المتحدة'),
(75053, 3280989136, 3280989151, 'DE', 'DEU', 'ألمانيا'),
(75054, 3280989152, 3280989183, 'GB', 'GBR', 'المملكة المتحدة'),
(75055, 3280989184, 3280989187, 'DE', 'DEU', 'ألمانيا'),
(75056, 3280989188, 3280989195, 'GB', 'GBR', 'المملكة المتحدة'),
(75057, 3280989196, 3280989199, 'DE', 'DEU', 'ألمانيا'),
(75058, 3280989200, 3280989239, 'GB', 'GBR', 'المملكة المتحدة'),
(75059, 3280989240, 3280989243, 'DE', 'DEU', 'ألمانيا'),
(75060, 3280989244, 3280989255, 'GB', 'GBR', 'المملكة المتحدة'),
(75061, 3280989256, 3280989263, 'DE', 'DEU', 'ألمانيا'),
(75062, 3280989264, 3280989270, 'GB', 'GBR', 'المملكة المتحدة'),
(75063, 3280989271, 3280989279, 'DE', 'DEU', 'ألمانيا'),
(75064, 3280989280, 3280989303, 'GB', 'GBR', 'المملكة المتحدة'),
(75065, 3280989304, 3280989311, 'DE', 'DEU', 'ألمانيا'),
(75066, 3280989312, 3280989351, 'GB', 'GBR', 'المملكة المتحدة'),
(75067, 3280989352, 3280989359, 'DE', 'DEU', 'ألمانيا'),
(75068, 3280989360, 3280989367, 'GB', 'GBR', 'المملكة المتحدة'),
(75069, 3280989368, 3280989371, 'DE', 'DEU', 'ألمانيا'),
(75070, 3280989372, 3280989373, 'GB', 'GBR', 'المملكة المتحدة'),
(75071, 3280989374, 3280989391, 'DE', 'DEU', 'ألمانيا'),
(75072, 3280989392, 3280989406, 'GB', 'GBR', 'المملكة المتحدة'),
(75073, 3280989407, 3280989407, 'DE', 'DEU', 'ألمانيا'),
(75074, 3280989408, 3280989427, 'GB', 'GBR', 'المملكة المتحدة'),
(75075, 3280989428, 3280989439, 'DE', 'DEU', 'ألمانيا'),
(75076, 3280989440, 3280989446, 'GB', 'GBR', 'المملكة المتحدة'),
(75077, 3280989447, 3280989447, 'DE', 'DEU', 'ألمانيا'),
(75078, 3280989448, 3280989535, 'GB', 'GBR', 'المملكة المتحدة'),
(75079, 3280989536, 3280989551, 'DE', 'DEU', 'ألمانيا'),
(75080, 3280989552, 3280989575, 'GB', 'GBR', 'المملكة المتحدة'),
(75081, 3280989576, 3280989583, 'DE', 'DEU', 'ألمانيا'),
(75082, 3280989584, 3280989607, 'GB', 'GBR', 'المملكة المتحدة'),
(75083, 3280989608, 3280989615, 'DE', 'DEU', 'ألمانيا'),
(75084, 3280989616, 3280989623, 'GB', 'GBR', 'المملكة المتحدة'),
(75085, 3280989624, 3280989631, 'DE', 'DEU', 'ألمانيا'),
(75086, 3280989632, 3280989807, 'GB', 'GBR', 'المملكة المتحدة'),
(75087, 3280989808, 3280989811, 'DE', 'DEU', 'ألمانيا'),
(75088, 3280989812, 3280989814, 'GB', 'GBR', 'المملكة المتحدة'),
(75089, 3280989815, 3280989815, 'DE', 'DEU', 'ألمانيا'),
(75090, 3280989816, 3280989820, 'GB', 'GBR', 'المملكة المتحدة'),
(75091, 3280989821, 3280989821, 'DE', 'DEU', 'ألمانيا'),
(75092, 3280989822, 3280989839, 'GB', 'GBR', 'المملكة المتحدة'),
(75093, 3280989840, 3280989847, 'DE', 'DEU', 'ألمانيا'),
(75094, 3280989848, 3280990047, 'GB', 'GBR', 'المملكة المتحدة'),
(75095, 3280990048, 3280990079, 'DE', 'DEU', 'ألمانيا'),
(75096, 3280990080, 3280990119, 'GB', 'GBR', 'المملكة المتحدة'),
(75097, 3280990120, 3280990143, 'DE', 'DEU', 'ألمانيا'),
(75098, 3280990144, 3280990191, 'GB', 'GBR', 'المملكة المتحدة'),
(75099, 3280990192, 3280990223, 'DE', 'DEU', 'ألمانيا'),
(75100, 3280990224, 3280990231, 'GB', 'GBR', 'المملكة المتحدة'),
(75101, 3280990232, 3280990239, 'DE', 'DEU', 'ألمانيا'),
(75102, 3280990240, 3280990271, 'GB', 'GBR', 'المملكة المتحدة'),
(75103, 3280990272, 3280990287, 'DE', 'DEU', 'ألمانيا'),
(75104, 3280990288, 3280990335, 'GB', 'GBR', 'المملكة المتحدة'),
(75105, 3280990336, 3280990367, 'DE', 'DEU', 'ألمانيا'),
(75106, 3280990368, 3280990377, 'GB', 'GBR', 'المملكة المتحدة'),
(75107, 3280990378, 3280990379, 'DE', 'DEU', 'ألمانيا'),
(75108, 3280990380, 3280990491, 'GB', 'GBR', 'المملكة المتحدة'),
(75109, 3280990492, 3280990495, 'DE', 'DEU', 'ألمانيا'),
(75110, 3280990496, 3280990511, 'GB', 'GBR', 'المملكة المتحدة'),
(75111, 3280990512, 3280990527, 'DE', 'DEU', 'ألمانيا'),
(75112, 3280990528, 3280990575, 'GB', 'GBR', 'المملكة المتحدة'),
(75113, 3280990576, 3280990599, 'DE', 'DEU', 'ألمانيا'),
(75114, 3280990600, 3280990607, 'GB', 'GBR', 'المملكة المتحدة'),
(75115, 3280990608, 3280990623, 'DE', 'DEU', 'ألمانيا'),
(75116, 3280990624, 3280990647, 'GB', 'GBR', 'المملكة المتحدة'),
(75117, 3280990648, 3280990687, 'DE', 'DEU', 'ألمانيا'),
(75118, 3280990688, 3280990703, 'GB', 'GBR', 'المملكة المتحدة'),
(75119, 3280990704, 3280990719, 'DE', 'DEU', 'ألمانيا'),
(75120, 3280990720, 3280990751, 'GB', 'GBR', 'المملكة المتحدة'),
(75121, 3280990752, 3280990767, 'DE', 'DEU', 'ألمانيا'),
(75122, 3280990768, 3280990847, 'GB', 'GBR', 'المملكة المتحدة'),
(75123, 3280990848, 3280990871, 'DE', 'DEU', 'ألمانيا'),
(75124, 3280990872, 3280990872, 'GB', 'GBR', 'المملكة المتحدة'),
(75125, 3280990873, 3280990873, 'DE', 'DEU', 'ألمانيا'),
(75126, 3280990874, 3280990875, 'GB', 'GBR', 'المملكة المتحدة'),
(75127, 3280990876, 3280990879, 'DE', 'DEU', 'ألمانيا'),
(75128, 3280990880, 3280990901, 'GB', 'GBR', 'المملكة المتحدة'),
(75129, 3280990902, 3280990902, 'DE', 'DEU', 'ألمانيا'),
(75130, 3280990903, 3280990903, 'GB', 'GBR', 'المملكة المتحدة'),
(75131, 3280990904, 3280990905, 'DE', 'DEU', 'ألمانيا'),
(75132, 3280990906, 3280990908, 'GB', 'GBR', 'المملكة المتحدة'),
(75133, 3280990909, 3280990910, 'DE', 'DEU', 'ألمانيا'),
(75134, 3280990911, 3280990911, 'GB', 'GBR', 'المملكة المتحدة'),
(75135, 3280990912, 3280990927, 'DE', 'DEU', 'ألمانيا'),
(75136, 3280990928, 3280990963, 'GB', 'GBR', 'المملكة المتحدة'),
(75137, 3280990964, 3280990964, 'DE', 'DEU', 'ألمانيا'),
(75138, 3280990965, 3280990968, 'GB', 'GBR', 'المملكة المتحدة'),
(75139, 3280990969, 3280990969, 'DE', 'DEU', 'ألمانيا'),
(75140, 3280990970, 3280990975, 'GB', 'GBR', 'المملكة المتحدة'),
(75141, 3280990976, 3280990983, 'DE', 'DEU', 'ألمانيا'),
(75142, 3280990984, 3280991027, 'GB', 'GBR', 'المملكة المتحدة'),
(75143, 3280991028, 3280991028, 'DE', 'DEU', 'ألمانيا'),
(75144, 3280991029, 3280991031, 'GB', 'GBR', 'المملكة المتحدة'),
(75145, 3280991032, 3280991055, 'DE', 'DEU', 'ألمانيا'),
(75146, 3280991056, 3280991199, 'GB', 'GBR', 'المملكة المتحدة'),
(75147, 3280991200, 3280991211, 'DE', 'DEU', 'ألمانيا'),
(75148, 3280991212, 3280991359, 'GB', 'GBR', 'المملكة المتحدة'),
(75149, 3280991360, 3280991375, 'DE', 'DEU', 'ألمانيا'),
(75150, 3280991376, 3280991391, 'GB', 'GBR', 'المملكة المتحدة'),
(75151, 3280991392, 3280991407, 'DE', 'DEU', 'ألمانيا'),
(75152, 3280991408, 3280991422, 'GB', 'GBR', 'المملكة المتحدة'),
(75153, 3280991423, 3280991423, 'DE', 'DEU', 'ألمانيا'),
(75154, 3280991424, 3280991743, 'GB', 'GBR', 'المملكة المتحدة'),
(75155, 3280991744, 3280992007, 'DE', 'DEU', 'ألمانيا'),
(75156, 3280992008, 3280992095, 'GB', 'GBR', 'المملكة المتحدة'),
(75157, 3280992096, 3280992111, 'DE', 'DEU', 'ألمانيا'),
(75158, 3280992112, 3280992131, 'GB', 'GBR', 'المملكة المتحدة'),
(75159, 3280992132, 3280992135, 'DE', 'DEU', 'ألمانيا'),
(75160, 3280992136, 3280992159, 'GB', 'GBR', 'المملكة المتحدة'),
(75161, 3280992160, 3280992207, 'DE', 'DEU', 'ألمانيا'),
(75162, 3280992208, 3280992219, 'GB', 'GBR', 'المملكة المتحدة'),
(75163, 3280992220, 3280992223, 'DE', 'DEU', 'ألمانيا'),
(75164, 3280992224, 3280992231, 'GB', 'GBR', 'المملكة المتحدة'),
(75165, 3280992232, 3280992239, 'DE', 'DEU', 'ألمانيا'),
(75166, 3280992240, 3280992319, 'GB', 'GBR', 'المملكة المتحدة'),
(75167, 3280992320, 3280992335, 'DE', 'DEU', 'ألمانيا'),
(75168, 3280992336, 3280992367, 'GB', 'GBR', 'المملكة المتحدة'),
(75169, 3280992368, 3280992383, 'DE', 'DEU', 'ألمانيا'),
(75170, 3280992384, 3280992391, 'GB', 'GBR', 'المملكة المتحدة'),
(75171, 3280992392, 3280992415, 'DE', 'DEU', 'ألمانيا'),
(75172, 3280992416, 3280992495, 'GB', 'GBR', 'المملكة المتحدة'),
(75173, 3280992496, 3280992503, 'DE', 'DEU', 'ألمانيا'),
(75174, 3280992504, 3280992508, 'GB', 'GBR', 'المملكة المتحدة'),
(75175, 3280992509, 3280992509, 'DE', 'DEU', 'ألمانيا'),
(75176, 3280992510, 3280992543, 'GB', 'GBR', 'المملكة المتحدة'),
(75177, 3280992544, 3280992551, 'DE', 'DEU', 'ألمانيا'),
(75178, 3280992552, 3280992575, 'GB', 'GBR', 'المملكة المتحدة'),
(75179, 3280992576, 3280992591, 'DE', 'DEU', 'ألمانيا'),
(75180, 3280992592, 3280992767, 'GB', 'GBR', 'المملكة المتحدة'),
(75181, 3280992768, 3280992775, 'DE', 'DEU', 'ألمانيا'),
(75182, 3280992776, 3280992783, 'GB', 'GBR', 'المملكة المتحدة'),
(75183, 3280992784, 3280992799, 'DE', 'DEU', 'ألمانيا'),
(75184, 3280992800, 3280992847, 'GB', 'GBR', 'المملكة المتحدة'),
(75185, 3280992848, 3280992863, 'DE', 'DEU', 'ألمانيا'),
(75186, 3280992864, 3280992871, 'GB', 'GBR', 'المملكة المتحدة'),
(75187, 3280992872, 3280992879, 'DE', 'DEU', 'ألمانيا'),
(75188, 3280992880, 3280993119, 'GB', 'GBR', 'المملكة المتحدة'),
(75189, 3280993120, 3280993135, 'DE', 'DEU', 'ألمانيا'),
(75190, 3280993136, 3280993159, 'GB', 'GBR', 'المملكة المتحدة'),
(75191, 3280993160, 3280993175, 'DE', 'DEU', 'ألمانيا'),
(75192, 3280993176, 3280993199, 'GB', 'GBR', 'المملكة المتحدة'),
(75193, 3280993200, 3280993215, 'DE', 'DEU', 'ألمانيا'),
(75194, 3280993216, 3280993247, 'GB', 'GBR', 'المملكة المتحدة'),
(75195, 3280993248, 3280993263, 'DE', 'DEU', 'ألمانيا'),
(75196, 3280993264, 3280993791, 'GB', 'GBR', 'المملكة المتحدة'),
(75197, 3280993792, 3280994303, 'DE', 'DEU', 'ألمانيا'),
(75198, 3280994304, 3280994559, 'GB', 'GBR', 'المملكة المتحدة'),
(75199, 3280994560, 3280994815, 'RU', 'RUS', 'الإتحاد الروسي'),
(75200, 3280994816, 3280995071, 'NL', 'NLD', 'هولندا'),
(75201, 3280995072, 3280995327, 'DE', 'DEU', 'ألمانيا'),
(75202, 3280995328, 3280995583, 'SE', 'SWE', 'السويد'),
(75203, 3280995584, 3280995839, 'GB', 'GBR', 'المملكة المتحدة'),
(75204, 3280995840, 3280996095, 'RU', 'RUS', 'الإتحاد الروسي'),
(75205, 3280996096, 3280996351, 'CH', 'CHE', 'سويسرا'),
(75206, 3280996352, 3280996607, 'GB', 'GBR', 'المملكة المتحدة'),
(75207, 3280996608, 3280996863, 'PL', 'POL', 'بولندا'),
(75208, 3280996864, 3280997119, 'NL', 'NLD', 'هولندا'),
(75209, 3280997120, 3280997375, 'FR', 'FRA', 'فرنسا'),
(75210, 3280997376, 3280997631, 'BE', 'BEL', 'بلجيكا'),
(75211, 3280997632, 3280997887, 'SE', 'SWE', 'السويد'),
(75212, 3280997888, 3280998143, 'UA', 'UKR', 'أوكرانيا'),
(75213, 3280998144, 3280998399, 'DE', 'DEU', 'ألمانيا'),
(75214, 3280998400, 3280998655, 'GR', 'GRC', 'اليونان'),
(75215, 3280998656, 3280999423, 'GB', 'GBR', 'المملكة المتحدة'),
(75216, 3280999424, 3280999679, 'HU', 'HUN', 'هنغاريا'),
(75217, 3280999680, 3280999935, 'UA', 'UKR', 'أوكرانيا'),
(75218, 3280999936, 3281000447, 'DE', 'DEU', 'ألمانيا'),
(75219, 3281000448, 3281000703, 'FR', 'FRA', 'فرنسا'),
(75220, 3281000704, 3281000959, 'UA', 'UKR', 'أوكرانيا'),
(75221, 3281000960, 3281001215, 'SI', 'SVN', 'سلوفينيا'),
(75222, 3281001216, 3281001471, 'RO', 'ROM', 'رومانيا'),
(75223, 3281001472, 3281001727, 'UA', 'UKR', 'أوكرانيا'),
(75224, 3281001728, 3281001983, 'RU', 'RUS', 'الإتحاد الروسي'),
(75225, 3281001984, 3281002239, 'CH', 'CHE', 'سويسرا'),
(75226, 3281002240, 3281002495, 'DE', 'DEU', 'ألمانيا'),
(75227, 3281002496, 3281010687, 'CH', 'CHE', 'سويسرا'),
(75228, 3281010688, 3281018879, 'BE', 'BEL', 'بلجيكا'),
(75229, 3281018880, 3281027071, 'CZ', 'CZE', 'التشيك'),
(75230, 3281027080, 3281027087, 'GB', 'GBR', 'المملكة المتحدة'),
(75231, 3281027136, 3281027151, 'GB', 'GBR', 'المملكة المتحدة'),
(75232, 3281027200, 3281027215, 'GB', 'GBR', 'المملكة المتحدة'),
(75233, 3281027280, 3281027287, 'GB', 'GBR', 'المملكة المتحدة'),
(75234, 3281027304, 3281027311, 'GB', 'GBR', 'المملكة المتحدة'),
(75235, 3281027320, 3281027327, 'GB', 'GBR', 'المملكة المتحدة'),
(75236, 3281027584, 3281027615, 'GB', 'GBR', 'المملكة المتحدة'),
(75237, 3281027632, 3281027679, 'GB', 'GBR', 'المملكة المتحدة'),
(75238, 3281027696, 3281027743, 'GB', 'GBR', 'المملكة المتحدة'),
(75239, 3281027776, 3281027807, 'GB', 'GBR', 'المملكة المتحدة'),
(75240, 3281027840, 3281027903, 'GB', 'GBR', 'المملكة المتحدة'),
(75241, 3281028064, 3281028223, 'GB', 'GBR', 'المملكة المتحدة'),
(75242, 3281028992, 3281029055, 'GB', 'GBR', 'المملكة المتحدة'),
(75243, 3281030400, 3281035263, 'GB', 'GBR', 'المملكة المتحدة'),
(75244, 3281035264, 3281043455, 'CH', 'CHE', 'سويسرا'),
(75245, 3281043456, 3281059839, 'RU', 'RUS', 'الإتحاد الروسي'),
(75246, 3281059840, 3281074671, 'DE', 'DEU', 'ألمانيا'),
(75247, 3281074672, 3281074679, 'ES', 'ESP', 'إسبانيا'),
(75248, 3281074680, 3281093951, 'DE', 'DEU', 'ألمانيا'),
(75249, 3281093952, 3281093983, 'US', 'USA', 'الولايات المتحدة'),
(75250, 3281093984, 3281103935, 'DE', 'DEU', 'ألمانيا'),
(75251, 3281103936, 3281103943, 'AT', 'AUT', 'النمسا'),
(75252, 3281103944, 3281104127, 'DE', 'DEU', 'ألمانيا'),
(75253, 3281104128, 3281104383, 'FR', 'FRA', 'فرنسا'),
(75254, 3281104384, 3281113703, 'DE', 'DEU', 'ألمانيا'),
(75255, 3281113704, 3281113711, 'BE', 'BEL', 'بلجيكا'),
(75256, 3281113712, 3281125375, 'DE', 'DEU', 'ألمانيا'),
(75257, 3281125376, 3281133567, 'SK', 'SVK', 'سلوفاكيا'),
(75258, 3281133568, 3281141759, 'IR', 'IRN', 'إيران'),
(75259, 3281141760, 3281149951, 'RU', 'RUS', 'الإتحاد الروسي'),
(75260, 3281149952, 3281158143, 'CZ', 'CZE', 'التشيك'),
(75261, 3281158144, 3281166335, 'SK', 'SVK', 'سلوفاكيا'),
(75262, 3281166336, 3281174527, 'GB', 'GBR', 'المملكة المتحدة'),
(75263, 3281174528, 3281190911, 'FR', 'FRA', 'فرنسا'),
(75264, 3281190912, 3281256447, 'GB', 'GBR', 'المملكة المتحدة'),
(75265, 3281256448, 3281321983, 'FI', 'FIN', 'فنلندا'),
(75266, 3281321984, 3281338367, 'GB', 'GBR', 'المملكة المتحدة'),
(75267, 3281338368, 3281338623, 'PL', 'POL', 'بولندا'),
(75268, 3281338624, 3281338879, 'SA', 'SAU', 'السعودية'),
(75269, 3281338880, 3281339135, 'FR', 'FRA', 'فرنسا'),
(75270, 3281339136, 3281339391, 'RO', 'ROM', 'رومانيا'),
(75271, 3281339392, 3281339647, 'PL', 'POL', 'بولندا'),
(75272, 3281339648, 3281339903, 'GB', 'GBR', 'المملكة المتحدة'),
(75273, 3281339904, 3281340159, 'UA', 'UKR', 'أوكرانيا'),
(75274, 3281340416, 3281340927, 'RO', 'ROM', 'رومانيا'),
(75275, 3281340928, 3281341183, 'DE', 'DEU', 'ألمانيا'),
(75276, 3281341184, 3281341439, 'AT', 'AUT', 'النمسا'),
(75277, 3281341440, 3281341695, 'DE', 'DEU', 'ألمانيا'),
(75278, 3281341696, 3281341951, 'PL', 'POL', 'بولندا'),
(75279, 3281341952, 3281342207, 'DK', 'DNK', 'الدنيمارك'),
(75280, 3281342464, 3281343231, 'DE', 'DEU', 'ألمانيا'),
(75281, 3281343232, 3281343487, 'FI', 'FIN', 'فنلندا'),
(75282, 3281343488, 3281343743, 'GB', 'GBR', 'المملكة المتحدة'),
(75283, 3281343744, 3281343999, 'TR', 'TUR', 'تركيا'),
(75284, 3281344000, 3281344255, 'PL', 'POL', 'بولندا'),
(75285, 3281344256, 3281344511, 'RU', 'RUS', 'الإتحاد الروسي'),
(75286, 3281344512, 3281344767, 'UA', 'UKR', 'أوكرانيا'),
(75287, 3281344768, 3281345023, 'RU', 'RUS', 'الإتحاد الروسي'),
(75288, 3281345024, 3281345279, 'UA', 'UKR', 'أوكرانيا'),
(75289, 3281345280, 3281345535, 'SA', 'SAU', 'السعودية'),
(75290, 3281345536, 3281345791, 'CH', 'CHE', 'سويسرا'),
(75291, 3281345792, 3281346047, 'RU', 'RUS', 'الإتحاد الروسي'),
(75292, 3281346048, 3281346303, 'SI', 'SVN', 'سلوفينيا'),
(75293, 3281346304, 3281346559, 'PL', 'POL', 'بولندا'),
(75294, 3281346560, 3281346815, 'UA', 'UKR', 'أوكرانيا'),
(75295, 3281346816, 3281347071, 'DE', 'DEU', 'ألمانيا'),
(75296, 3281347072, 3281347327, 'PL', 'POL', 'بولندا'),
(75297, 3281347328, 3281347583, 'DE', 'DEU', 'ألمانيا'),
(75298, 3281347584, 3281347839, 'PL', 'POL', 'بولندا'),
(75299, 3281347840, 3281348095, 'SE', 'SWE', 'السويد'),
(75300, 3281348096, 3281348351, 'DE', 'DEU', 'ألمانيا'),
(75301, 3281348352, 3281348607, 'GB', 'GBR', 'المملكة المتحدة'),
(75302, 3281348608, 3281349119, 'RU', 'RUS', 'الإتحاد الروسي'),
(75303, 3281349120, 3281349375, 'UA', 'UKR', 'أوكرانيا'),
(75304, 3281349376, 3281349631, 'NL', 'NLD', 'هولندا'),
(75305, 3281349632, 3281350143, 'UA', 'UKR', 'أوكرانيا'),
(75306, 3281350144, 3281350655, 'RU', 'RUS', 'الإتحاد الروسي'),
(75307, 3281350656, 3281350911, 'UA', 'UKR', 'أوكرانيا'),
(75308, 3281350912, 3281351167, 'ES', 'ESP', 'إسبانيا'),
(75309, 3281351168, 3281351423, 'UA', 'UKR', 'أوكرانيا'),
(75310, 3281351424, 3281351679, 'AT', 'AUT', 'النمسا'),
(75311, 3281351680, 3281351935, 'TR', 'TUR', 'تركيا'),
(75312, 3281351936, 3281352191, 'DE', 'DEU', 'ألمانيا'),
(75313, 3281352192, 3281352447, 'PL', 'POL', 'بولندا'),
(75314, 3281352448, 3281352703, 'RO', 'ROM', 'رومانيا'),
(75315, 3281352704, 3281352959, 'DE', 'DEU', 'ألمانيا'),
(75316, 3281352960, 3281353215, 'GB', 'GBR', 'المملكة المتحدة'),
(75317, 3281353216, 3281353471, 'DE', 'DEU', 'ألمانيا'),
(75318, 3281353472, 3281353727, 'SE', 'SWE', 'السويد'),
(75319, 3281353728, 3281353983, 'PL', 'POL', 'بولندا'),
(75320, 3281353984, 3281354239, 'UA', 'UKR', 'أوكرانيا'),
(75321, 3281354240, 3281354751, 'GB', 'GBR', 'المملكة المتحدة'),
(75322, 3281354752, 3281359071, 'SE', 'SWE', 'السويد'),
(75323, 3281359072, 3281359103, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(75324, 3281359104, 3281371135, 'SE', 'SWE', 'السويد'),
(75325, 3281373184, 3281375231, 'RU', 'RUS', 'الإتحاد الروسي'),
(75326, 3281375232, 3281377279, 'ES', 'ESP', 'إسبانيا'),
(75327, 3281377280, 3281379327, 'AT', 'AUT', 'النمسا'),
(75328, 3281379328, 3281383423, 'PL', 'POL', 'بولندا'),
(75329, 3281383424, 3281385471, 'AT', 'AUT', 'النمسا'),
(75330, 3281385472, 3281387519, 'BG', 'BGR', 'بلغاريا'),
(75331, 3281387520, 3281453055, 'PL', 'POL', 'بولندا'),
(75332, 3281453056, 3281470975, 'RU', 'RUS', 'الإتحاد الروسي'),
(75333, 3281470976, 3281471231, 'UZ', 'UZB', 'أوزباكستان'),
(75334, 3281471232, 3281518591, 'RU', 'RUS', 'الإتحاد الروسي'),
(75335, 3281518592, 3281578431, 'GB', 'GBR', 'المملكة المتحدة'),
(75336, 3281578432, 3281578447, 'IE', 'IRL', 'إيرلندا'),
(75337, 3281578448, 3281640959, 'GB', 'GBR', 'المملكة المتحدة'),
(75338, 3281640960, 3281640983, 'SE', 'SWE', 'السويد'),
(75339, 3281640984, 3281641023, 'GB', 'GBR', 'المملكة المتحدة'),
(75340, 3281641024, 3281641039, 'SE', 'SWE', 'السويد'),
(75341, 3281641040, 3281641087, 'GB', 'GBR', 'المملكة المتحدة'),
(75342, 3281641088, 3281641119, 'SE', 'SWE', 'السويد'),
(75343, 3281641120, 3281649663, 'GB', 'GBR', 'المملكة المتحدة'),
(75344, 3281649664, 3281699999, 'FR', 'FRA', 'فرنسا'),
(75345, 3281700000, 3281700031, 'US', 'USA', 'الولايات المتحدة'),
(75346, 3281700032, 3281703551, 'FR', 'FRA', 'فرنسا'),
(75347, 3281703552, 3281703615, 'US', 'USA', 'الولايات المتحدة'),
(75348, 3281703616, 3281706687, 'FR', 'FRA', 'فرنسا'),
(75349, 3281706688, 3281706719, 'US', 'USA', 'الولايات المتحدة'),
(75350, 3281706720, 3281710799, 'FR', 'FRA', 'فرنسا'),
(75351, 3281710800, 3281710815, 'US', 'USA', 'الولايات المتحدة'),
(75352, 3281710816, 3281711487, 'FR', 'FRA', 'فرنسا'),
(75353, 3281711488, 3281711519, 'BE', 'BEL', 'بلجيكا'),
(75354, 3281711520, 3281712127, 'FR', 'FRA', 'فرنسا'),
(75355, 3281712128, 3281712159, 'US', 'USA', 'الولايات المتحدة'),
(75356, 3281712160, 3281712191, 'FR', 'FRA', 'فرنسا'),
(75357, 3281712192, 3281712255, 'US', 'USA', 'الولايات المتحدة'),
(75358, 3281712256, 3281712831, 'FR', 'FRA', 'فرنسا'),
(75359, 3281712832, 3281712895, 'US', 'USA', 'الولايات المتحدة'),
(75360, 3281712896, 3281715199, 'FR', 'FRA', 'فرنسا'),
(75361, 3281715200, 3281780735, 'TR', 'TUR', 'تركيا'),
(75362, 3281780736, 3281846271, 'FI', 'FIN', 'فنلندا'),
(75363, 3281846272, 3281911807, 'GB', 'GBR', 'المملكة المتحدة'),
(75364, 3281911808, 3281919999, 'UZ', 'UZB', 'أوزباكستان'),
(75365, 3281920000, 3281928191, 'DE', 'DEU', 'ألمانيا'),
(75366, 3281928192, 3281944575, 'MT', 'MLT', 'مالطا'),
(75367, 3281944576, 3281960959, 'DE', 'DEU', 'ألمانيا'),
(75368, 3281960960, 3281969151, 'JO', 'JOR', 'الأردن'),
(75369, 3281969152, 3281969663, 'RU', 'RUS', 'الإتحاد الروسي'),
(75370, 3281969664, 3281970175, 'PL', 'POL', 'بولندا'),
(75371, 3281970176, 3281970687, 'RU', 'RUS', 'الإتحاد الروسي'),
(75372, 3281970688, 3281971199, 'CH', 'CHE', 'سويسرا'),
(75373, 3281971200, 3281971711, 'RU', 'RUS', 'الإتحاد الروسي'),
(75374, 3281971712, 3281972223, 'RO', 'ROM', 'رومانيا'),
(75375, 3281972224, 3281972735, 'DE', 'DEU', 'ألمانيا'),
(75376, 3281972736, 3281973247, 'RU', 'RUS', 'الإتحاد الروسي'),
(75377, 3281973248, 3281973759, 'FR', 'FRA', 'فرنسا'),
(75378, 3281973760, 3281974271, 'DK', 'DNK', 'الدنيمارك'),
(75379, 3281974272, 3281974783, 'RU', 'RUS', 'الإتحاد الروسي'),
(75380, 3281974784, 3281975295, 'PL', 'POL', 'بولندا'),
(75381, 3281975296, 3281976319, 'RU', 'RUS', 'الإتحاد الروسي'),
(75382, 3281976320, 3281976831, 'DE', 'DEU', 'ألمانيا'),
(75383, 3281976832, 3281977343, 'RU', 'RUS', 'الإتحاد الروسي'),
(75384, 3281977344, 3281999095, 'NO', 'NOR', 'النرويج'),
(75385, 3281999096, 3281999103, 'US', 'USA', 'الولايات المتحدة'),
(75386, 3281999104, 3282042879, 'NO', 'NOR', 'النرويج'),
(75387, 3282042880, 3282083839, 'CH', 'CHE', 'سويسرا'),
(75388, 3282083840, 3282084351, 'DE', 'DEU', 'ألمانيا'),
(75389, 3282084352, 3282084863, 'RO', 'ROM', 'رومانيا'),
(75390, 3282084864, 3282085375, 'RU', 'RUS', 'الإتحاد الروسي'),
(75391, 3282085376, 3282085887, 'BE', 'BEL', 'بلجيكا'),
(75392, 3282085888, 3282086399, 'DE', 'DEU', 'ألمانيا'),
(75393, 3282086400, 3282086911, 'LV', 'LVA', 'لاتفيا'),
(75394, 3282086912, 3282087423, 'DE', 'DEU', 'ألمانيا'),
(75395, 3282087424, 3282087935, 'PL', 'POL', 'بولندا'),
(75396, 3282087936, 3282088447, 'SE', 'SWE', 'السويد'),
(75397, 3282088448, 3282089471, 'PL', 'POL', 'بولندا'),
(75398, 3282089472, 3282089983, 'SK', 'SVK', 'سلوفاكيا'),
(75399, 3282089984, 3282090495, 'PL', 'POL', 'بولندا'),
(75400, 3282090496, 3282091007, 'GB', 'GBR', 'المملكة المتحدة'),
(75401, 3282091008, 3282091519, 'FR', 'FRA', 'فرنسا'),
(75402, 3282091520, 3282092031, 'CH', 'CHE', 'سويسرا'),
(75403, 3282092032, 3282093055, 'UA', 'UKR', 'أوكرانيا'),
(75404, 3282093056, 3282095103, 'DE', 'DEU', 'ألمانيا'),
(75405, 3282095104, 3282096127, 'UA', 'UKR', 'أوكرانيا'),
(75406, 3282096128, 3282097151, 'IT', 'ITA', 'إيطاليا'),
(75407, 3282097152, 3282098175, 'GB', 'GBR', 'المملكة المتحدة'),
(75408, 3282098176, 3282099199, 'NL', 'NLD', 'هولندا'),
(75409, 3282099200, 3282100223, 'UA', 'UKR', 'أوكرانيا'),
(75410, 3282100224, 3282101247, 'ES', 'ESP', 'إسبانيا'),
(75411, 3282101248, 3282102271, 'DE', 'DEU', 'ألمانيا'),
(75412, 3282102272, 3282103295, 'UA', 'UKR', 'أوكرانيا'),
(75413, 3282103296, 3282104319, 'GB', 'GBR', 'المملكة المتحدة'),
(75414, 3282104320, 3282105343, 'IL', 'ISR', 'إسرائيل'),
(75415, 3282105344, 3282106367, 'RU', 'RUS', 'الإتحاد الروسي'),
(75416, 3282106368, 3282107391, 'DE', 'DEU', 'ألمانيا'),
(75417, 3282107392, 3282108415, 'NL', 'NLD', 'هولندا'),
(75418, 3282108416, 3282119423, 'RU', 'RUS', 'الإتحاد الروسي'),
(75419, 3282119424, 3282119679, 'KZ', 'KAZ', 'كازاخستان'),
(75420, 3282119680, 3282149455, 'RU', 'RUS', 'الإتحاد الروسي'),
(75421, 3282149456, 3282149471, 'KG', 'KGZ', 'قيرغيزستان'),
(75422, 3282149472, 3282149599, 'RU', 'RUS', 'الإتحاد الروسي'),
(75423, 3282149600, 3282149631, 'GB', 'GBR', 'المملكة المتحدة'),
(75424, 3282149632, 3282173951, 'RU', 'RUS', 'الإتحاد الروسي'),
(75425, 3282173952, 3282174463, 'UA', 'UKR', 'أوكرانيا'),
(75426, 3282174464, 3282174975, 'GB', 'GBR', 'المملكة المتحدة'),
(75427, 3282174976, 3282177023, 'RU', 'RUS', 'الإتحاد الروسي'),
(75428, 3282177024, 3282177535, 'GB', 'GBR', 'المملكة المتحدة'),
(75429, 3282177536, 3282178047, 'KZ', 'KAZ', 'كازاخستان'),
(75430, 3282178048, 3282178559, 'PL', 'POL', 'بولندا'),
(75431, 3282178560, 3282179071, 'ES', 'ESP', 'إسبانيا'),
(75432, 3282179072, 3282179583, 'GB', 'GBR', 'المملكة المتحدة'),
(75433, 3282179584, 3282180095, 'RU', 'RUS', 'الإتحاد الروسي'),
(75434, 3282180096, 3282180607, 'PL', 'POL', 'بولندا'),
(75435, 3282180608, 3282181119, 'KZ', 'KAZ', 'كازاخستان'),
(75436, 3282181120, 3282181631, 'GB', 'GBR', 'المملكة المتحدة'),
(75437, 3282181632, 3282182143, 'DE', 'DEU', 'ألمانيا'),
(75438, 3282182144, 3282190335, 'RU', 'RUS', 'الإتحاد الروسي'),
(75439, 3282190336, 3282194431, 'SE', 'SWE', 'السويد'),
(75440, 3282194432, 3282195455, 'UA', 'UKR', 'أوكرانيا'),
(75441, 3282195456, 3282196479, 'IE', 'IRL', 'إيرلندا'),
(75442, 3282196480, 3282197503, 'UA', 'UKR', 'أوكرانيا'),
(75443, 3282197504, 3282198527, 'RU', 'RUS', 'الإتحاد الروسي'),
(75444, 3282198528, 3282206719, 'GB', 'GBR', 'المملكة المتحدة'),
(75445, 3282206720, 3282223103, 'CH', 'CHE', 'سويسرا'),
(75446, 3282223104, 3282231295, 'BE', 'BEL', 'بلجيكا'),
(75447, 3282231296, 3282239487, 'DE', 'DEU', 'ألمانيا'),
(75448, 3282239488, 3282242223, 'SE', 'SWE', 'السويد'),
(75449, 3282242224, 3282242227, 'NO', 'NOR', 'النرويج'),
(75450, 3282242228, 3282284543, 'SE', 'SWE', 'السويد'),
(75451, 3282284544, 3282284551, 'FI', 'FIN', 'فنلندا'),
(75452, 3282284552, 3282284567, 'SE', 'SWE', 'السويد'),
(75453, 3282284568, 3282284575, 'FR', 'FRA', 'فرنسا'),
(75454, 3282284576, 3282284579, 'SE', 'SWE', 'السويد'),
(75455, 3282284580, 3282284583, 'FI', 'FIN', 'فنلندا'),
(75456, 3282284584, 3282284591, 'SE', 'SWE', 'السويد'),
(75457, 3282284592, 3282284595, 'FR', 'FRA', 'فرنسا'),
(75458, 3282284596, 3282284599, 'SE', 'SWE', 'السويد'),
(75459, 3282284600, 3282284603, 'FR', 'FRA', 'فرنسا'),
(75460, 3282284604, 3282284735, 'SE', 'SWE', 'السويد'),
(75461, 3282284736, 3282284783, 'FI', 'FIN', 'فنلندا'),
(75462, 3282284784, 3282286975, 'SE', 'SWE', 'السويد'),
(75463, 3282286976, 3282287007, 'FI', 'FIN', 'فنلندا'),
(75464, 3282287008, 3282287615, 'SE', 'SWE', 'السويد'),
(75465, 3282287616, 3282287759, 'FI', 'FIN', 'فنلندا'),
(75466, 3282287760, 3282305023, 'SE', 'SWE', 'السويد'),
(75467, 3282305024, 3282370559, 'PL', 'POL', 'بولندا'),
(75468, 3282370560, 3282388175, 'FI', 'FIN', 'فنلندا'),
(75469, 3282388176, 3282388191, 'SE', 'SWE', 'السويد'),
(75470, 3282388192, 3282390015, 'FI', 'FIN', 'فنلندا'),
(75471, 3282390016, 3282390271, 'NL', 'NLD', 'هولندا'),
(75472, 3282390272, 3282416383, 'FI', 'FIN', 'فنلندا'),
(75473, 3282416384, 3282416511, 'RU', 'RUS', 'الإتحاد الروسي'),
(75474, 3282416512, 3282429279, 'FI', 'FIN', 'فنلندا'),
(75475, 3282429280, 3282429311, 'SE', 'SWE', 'السويد'),
(75476, 3282429312, 3282429343, 'NO', 'NOR', 'النرويج'),
(75477, 3282429344, 3282436095, 'FI', 'FIN', 'فنلندا'),
(75478, 3282436096, 3282444159, 'GB', 'GBR', 'المملكة المتحدة'),
(75479, 3282444160, 3282444223, 'US', 'USA', 'الولايات المتحدة'),
(75480, 3282444224, 3282449023, 'GB', 'GBR', 'المملكة المتحدة'),
(75481, 3282449024, 3282449151, 'NL', 'NLD', 'هولندا'),
(75482, 3282449152, 3282452479, 'GB', 'GBR', 'المملكة المتحدة'),
(75483, 3282452480, 3282452735, 'DE', 'DEU', 'ألمانيا'),
(75484, 3282452736, 3282456023, 'GB', 'GBR', 'المملكة المتحدة'),
(75485, 3282456024, 3282456031, 'IT', 'ITA', 'إيطاليا'),
(75486, 3282456032, 3282461439, 'GB', 'GBR', 'المملكة المتحدة'),
(75487, 3282461440, 3282461695, 'CH', 'CHE', 'سويسرا'),
(75488, 3282461696, 3282464767, 'GB', 'GBR', 'المملكة المتحدة'),
(75489, 3282464768, 3282465023, 'SE', 'SWE', 'السويد'),
(75490, 3282465024, 3282465279, 'DE', 'DEU', 'ألمانيا'),
(75491, 3282465280, 3282465535, 'IT', 'ITA', 'إيطاليا'),
(75492, 3282465536, 3282466047, 'GB', 'GBR', 'المملكة المتحدة'),
(75493, 3282466048, 3282466111, 'US', 'USA', 'الولايات المتحدة'),
(75494, 3282466112, 3282466643, 'GB', 'GBR', 'المملكة المتحدة'),
(75495, 3282466644, 3282466655, 'IT', 'ITA', 'إيطاليا'),
(75496, 3282466656, 3282466687, 'GB', 'GBR', 'المملكة المتحدة'),
(75497, 3282466688, 3282466727, 'IT', 'ITA', 'إيطاليا'),
(75498, 3282466728, 3282466815, 'GB', 'GBR', 'المملكة المتحدة'),
(75499, 3282466816, 3282467071, 'US', 'USA', 'الولايات المتحدة'),
(75500, 3282467072, 3282467327, 'GB', 'GBR', 'المملكة المتحدة'),
(75501, 3282467328, 3282467359, 'DE', 'DEU', 'ألمانيا'),
(75502, 3282467360, 3282477055, 'GB', 'GBR', 'المملكة المتحدة'),
(75503, 3282477056, 3282485247, 'RU', 'RUS', 'الإتحاد الروسي'),
(75504, 3282485248, 3282493439, 'GI', 'GIB', 'جبل طارق'),
(75505, 3282501632, 3282534399, 'GR', 'GRC', 'اليونان'),
(75506, 3282534400, 3282550783, 'GB', 'GBR', 'المملكة المتحدة'),
(75507, 3282550784, 3282554879, 'FR', 'FRA', 'فرنسا'),
(75508, 3282554880, 3282558975, 'DE', 'DEU', 'ألمانيا'),
(75509, 3282558976, 3282563071, 'FR', 'FRA', 'فرنسا'),
(75510, 3282563072, 3282567167, 'GB', 'GBR', 'المملكة المتحدة'),
(75511, 3282567168, 3282632703, 'SK', 'SVK', 'سلوفاكيا'),
(75512, 3282632704, 3282698239, 'NL', 'NLD', 'هولندا'),
(75513, 3282698240, 3282706431, 'GR', 'GRC', 'اليونان'),
(75514, 3282706432, 3282714623, 'RU', 'RUS', 'الإتحاد الروسي'),
(75515, 3282714624, 3282722815, 'AT', 'AUT', 'النمسا'),
(75516, 3282722816, 3282731007, 'DE', 'DEU', 'ألمانيا'),
(75517, 3282731008, 3282739199, 'FI', 'FIN', 'فنلندا'),
(75518, 3282739200, 3282739455, 'CH', 'CHE', 'سويسرا'),
(75519, 3282739456, 3282739711, 'RO', 'ROM', 'رومانيا'),
(75520, 3282739712, 3282739967, 'FR', 'FRA', 'فرنسا'),
(75521, 3282739968, 3282740223, 'IR', 'IRN', 'إيران'),
(75522, 3282740224, 3282740479, 'FR', 'FRA', 'فرنسا'),
(75523, 3282740480, 3282740735, 'AT', 'AUT', 'النمسا'),
(75524, 3282740736, 3282740991, 'BG', 'BGR', 'بلغاريا'),
(75525, 3282740992, 3282741247, 'DE', 'DEU', 'ألمانيا'),
(75526, 3282741248, 3282741503, 'PT', 'PRT', 'البورتوغال'),
(75527, 3282741504, 3282741759, 'GB', 'GBR', 'المملكة المتحدة'),
(75528, 3282741760, 3282742015, 'ES', 'ESP', 'إسبانيا'),
(75529, 3282742016, 3282742527, 'RO', 'ROM', 'رومانيا'),
(75530, 3282742528, 3282742783, 'GB', 'GBR', 'المملكة المتحدة'),
(75531, 3282742784, 3282743039, 'RU', 'RUS', 'الإتحاد الروسي'),
(75532, 3282743040, 3282743295, 'CH', 'CHE', 'سويسرا'),
(75533, 3282743296, 3282743551, 'CY', 'CYP', 'قبرص'),
(75534, 3282743552, 3282743807, 'SI', 'SVN', 'سلوفينيا'),
(75535, 3282743808, 3282744063, 'MD', 'MDA', 'مولدوفا'),
(75536, 3282744064, 3282744319, 'UA', 'UKR', 'أوكرانيا'),
(75537, 3282744320, 3282744575, 'SA', 'SAU', 'السعودية'),
(75538, 3282744576, 3282744831, 'LT', 'LTU', 'ليتوانيا'),
(75539, 3282744832, 3282745087, 'PL', 'POL', 'بولندا'),
(75540, 3282745088, 3282745343, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75541, 3282745344, 3282745599, 'HU', 'HUN', 'هنغاريا'),
(75542, 3282745600, 3282746111, 'DE', 'DEU', 'ألمانيا'),
(75543, 3282746112, 3282746367, 'SE', 'SWE', 'السويد'),
(75544, 3282746368, 3282746623, 'PL', 'POL', 'بولندا'),
(75545, 3282746624, 3282746879, 'SE', 'SWE', 'السويد'),
(75546, 3282746880, 3282747135, 'RO', 'ROM', 'رومانيا'),
(75547, 3282747136, 3282747391, 'PL', 'POL', 'بولندا'),
(75548, 3282747392, 3282763775, 'RU', 'RUS', 'الإتحاد الروسي'),
(75549, 3282763776, 3282772991, 'GB', 'GBR', 'المملكة المتحدة'),
(75550, 3282772992, 3282773119, 'BE', 'BEL', 'بلجيكا'),
(75551, 3282773120, 3282952191, 'GB', 'GBR', 'المملكة المتحدة'),
(75552, 3282952192, 3282960383, 'NL', 'NLD', 'هولندا'),
(75553, 3282960384, 3283091455, 'TR', 'TUR', 'تركيا'),
(75554, 3283091456, 3283156991, 'CH', 'CHE', 'سويسرا'),
(75555, 3283156992, 3283158215, 'DE', 'DEU', 'ألمانيا'),
(75556, 3283158216, 3283158219, 'EE', 'EST', 'إستونيا'),
(75557, 3283158220, 3283160171, 'DE', 'DEU', 'ألمانيا'),
(75558, 3283160172, 3283160175, 'BE', 'BEL', 'بلجيكا'),
(75559, 3283160176, 3283173375, 'DE', 'DEU', 'ألمانيا'),
(75560, 3283173376, 3283174399, 'PL', 'POL', 'بولندا'),
(75561, 3283174400, 3283176447, 'UA', 'UKR', 'أوكرانيا'),
(75562, 3283176448, 3283177471, 'GB', 'GBR', 'المملكة المتحدة'),
(75563, 3283177472, 3283178495, 'BE', 'BEL', 'بلجيكا'),
(75564, 3283178496, 3283179519, 'PL', 'POL', 'بولندا'),
(75565, 3283179520, 3283180543, 'LU', 'LUX', 'لوكسيمبورغ'),
(75566, 3283180544, 3283181567, 'UA', 'UKR', 'أوكرانيا'),
(75567, 3283181568, 3283182591, 'NO', 'NOR', 'النرويج'),
(75568, 3283182592, 3283183615, 'PL', 'POL', 'بولندا'),
(75569, 3283183616, 3283184639, 'RU', 'RUS', 'الإتحاد الروسي'),
(75570, 3283184640, 3283185663, 'IL', 'ISR', 'إسرائيل'),
(75571, 3283185664, 3283187711, 'UA', 'UKR', 'أوكرانيا'),
(75572, 3283187712, 3283188735, 'RU', 'RUS', 'الإتحاد الروسي'),
(75573, 3283188736, 3283189759, 'UA', 'UKR', 'أوكرانيا'),
(75574, 3283189760, 3283206143, 'DE', 'DEU', 'ألمانيا'),
(75575, 3283206144, 3283206655, 'GB', 'GBR', 'المملكة المتحدة'),
(75576, 3283206656, 3283207167, 'SA', 'SAU', 'السعودية'),
(75577, 3283207168, 3283207679, 'PL', 'POL', 'بولندا'),
(75578, 3283207680, 3283208191, 'AT', 'AUT', 'النمسا'),
(75579, 3283208192, 3283208703, 'DE', 'DEU', 'ألمانيا'),
(75580, 3283208704, 3283209215, 'NO', 'NOR', 'النرويج'),
(75581, 3283209216, 3283209727, 'RU', 'RUS', 'الإتحاد الروسي'),
(75582, 3283209728, 3283210239, 'TR', 'TUR', 'تركيا'),
(75583, 3283210240, 3283210751, 'UA', 'UKR', 'أوكرانيا'),
(75584, 3283210752, 3283211263, 'PL', 'POL', 'بولندا'),
(75585, 3283211264, 3283211775, 'GB', 'GBR', 'المملكة المتحدة'),
(75586, 3283211776, 3283212287, 'NL', 'NLD', 'هولندا'),
(75587, 3283212288, 3283212799, 'RU', 'RUS', 'الإتحاد الروسي'),
(75588, 3283212800, 3283213311, 'BG', 'BGR', 'بلغاريا'),
(75589, 3283213312, 3283213823, 'ES', 'ESP', 'إسبانيا'),
(75590, 3283213824, 3283214335, 'UA', 'UKR', 'أوكرانيا'),
(75591, 3283214336, 3283214847, 'RO', 'ROM', 'رومانيا'),
(75592, 3283214848, 3283215359, 'RU', 'RUS', 'الإتحاد الروسي'),
(75593, 3283215360, 3283215871, 'AT', 'AUT', 'النمسا'),
(75594, 3283215872, 3283216383, 'TR', 'TUR', 'تركيا'),
(75595, 3283216384, 3283216895, 'DE', 'DEU', 'ألمانيا'),
(75596, 3283216896, 3283217407, 'CH', 'CHE', 'سويسرا'),
(75597, 3283217408, 3283218943, 'UA', 'UKR', 'أوكرانيا'),
(75598, 3283218944, 3283219455, 'NL', 'NLD', 'هولندا'),
(75599, 3283219456, 3283219967, 'GB', 'GBR', 'المملكة المتحدة'),
(75600, 3283219968, 3283220479, 'BE', 'BEL', 'بلجيكا'),
(75601, 3283220480, 3283220991, 'BG', 'BGR', 'بلغاريا'),
(75602, 3283220992, 3283221503, 'AT', 'AUT', 'النمسا'),
(75603, 3283221504, 3283222015, 'GB', 'GBR', 'المملكة المتحدة'),
(75604, 3283222016, 3283223039, 'DE', 'DEU', 'ألمانيا'),
(75605, 3283223040, 3283223551, 'RU', 'RUS', 'الإتحاد الروسي'),
(75606, 3283223552, 3283224063, 'NL', 'NLD', 'هولندا'),
(75607, 3283224576, 3283225087, 'BG', 'BGR', 'بلغاريا'),
(75608, 3283225088, 3283225599, 'UA', 'UKR', 'أوكرانيا'),
(75609, 3283225600, 3283226111, 'RU', 'RUS', 'الإتحاد الروسي'),
(75610, 3283226112, 3283226623, 'DK', 'DNK', 'الدنيمارك'),
(75611, 3283226624, 3283227135, 'RU', 'RUS', 'الإتحاد الروسي'),
(75612, 3283227136, 3283227647, 'UA', 'UKR', 'أوكرانيا'),
(75613, 3283227648, 3283228159, 'RU', 'RUS', 'الإتحاد الروسي'),
(75614, 3283228160, 3283228671, 'RO', 'ROM', 'رومانيا'),
(75615, 3283228672, 3283229183, 'RU', 'RUS', 'الإتحاد الروسي'),
(75616, 3283229184, 3283229695, 'PL', 'POL', 'بولندا'),
(75617, 3283229696, 3283230207, 'IT', 'ITA', 'إيطاليا'),
(75618, 3283230208, 3283230719, 'UA', 'UKR', 'أوكرانيا'),
(75619, 3283230720, 3283230975, 'RS', 'SRB', 'صربيا'),
(75620, 3283230976, 3283231231, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75621, 3283231232, 3283232255, 'RS', 'SRB', 'صربيا'),
(75622, 3283232256, 3283232511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75623, 3283232512, 3283232895, 'RS', 'SRB', 'صربيا'),
(75624, 3283232896, 3283233023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75625, 3283233024, 3283233343, 'RS', 'SRB', 'صربيا'),
(75626, 3283233344, 3283233359, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75627, 3283233360, 3283233367, 'RS', 'SRB', 'صربيا'),
(75628, 3283233368, 3283233479, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75629, 3283233480, 3283233483, 'RS', 'SRB', 'صربيا'),
(75630, 3283233484, 3283233791, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75631, 3283233792, 3283234559, 'RS', 'SRB', 'صربيا'),
(75632, 3283234560, 3283234815, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75633, 3283234816, 3283235215, 'RS', 'SRB', 'صربيا'),
(75634, 3283235216, 3283235223, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75635, 3283235224, 3283235227, 'RS', 'SRB', 'صربيا'),
(75636, 3283235228, 3283235275, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75637, 3283235276, 3283235279, 'RS', 'SRB', 'صربيا'),
(75638, 3283235280, 3283235303, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75639, 3283235304, 3283235311, 'RS', 'SRB', 'صربيا'),
(75640, 3283235312, 3283235319, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75641, 3283235320, 3283235327, 'RS', 'SRB', 'صربيا'),
(75642, 3283235328, 3283235439, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75643, 3283235440, 3283235455, 'RS', 'SRB', 'صربيا'),
(75644, 3283235456, 3283235471, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75645, 3283235472, 3283235487, 'RS', 'SRB', 'صربيا'),
(75646, 3283235488, 3283235519, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75647, 3283235520, 3283235535, 'RS', 'SRB', 'صربيا'),
(75648, 3283235536, 3283235551, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75649, 3283235552, 3283235559, 'RS', 'SRB', 'صربيا'),
(75650, 3283235560, 3283235647, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75651, 3283235648, 3283235655, 'RS', 'SRB', 'صربيا'),
(75652, 3283235656, 3283235671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75653, 3283235672, 3283235679, 'RS', 'SRB', 'صربيا'),
(75654, 3283235680, 3283235871, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75655, 3283235872, 3283235875, 'RS', 'SRB', 'صربيا'),
(75656, 3283235876, 3283235879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75657, 3283235880, 3283235883, 'RS', 'SRB', 'صربيا'),
(75658, 3283235884, 3283235891, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75659, 3283235892, 3283235895, 'RS', 'SRB', 'صربيا'),
(75660, 3283235896, 3283235991, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75661, 3283235992, 3283236015, 'RS', 'SRB', 'صربيا'),
(75662, 3283236016, 3283236063, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75663, 3283236064, 3283236071, 'RS', 'SRB', 'صربيا'),
(75664, 3283236072, 3283236095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75665, 3283236096, 3283236119, 'RS', 'SRB', 'صربيا'),
(75666, 3283236120, 3283236159, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75667, 3283236160, 3283236183, 'RS', 'SRB', 'صربيا'),
(75668, 3283236184, 3283236351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75669, 3283236352, 3283236511, 'RS', 'SRB', 'صربيا'),
(75670, 3283236512, 3283236895, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75671, 3283236896, 3283236903, 'RS', 'SRB', 'صربيا'),
(75672, 3283236904, 3283236911, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75673, 3283236912, 3283236919, 'RS', 'SRB', 'صربيا'),
(75674, 3283236920, 3283237103, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75675, 3283237104, 3283237119, 'RS', 'SRB', 'صربيا'),
(75676, 3283237120, 3283237279, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75677, 3283237280, 3283237287, 'RS', 'SRB', 'صربيا'),
(75678, 3283237288, 3283237349, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75679, 3283237350, 3283237351, 'RS', 'SRB', 'صربيا'),
(75680, 3283237352, 3283237359, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75681, 3283237360, 3283237367, 'RS', 'SRB', 'صربيا'),
(75682, 3283237368, 3283237383, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75683, 3283237384, 3283237391, 'RS', 'SRB', 'صربيا'),
(75684, 3283237392, 3283237631, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75685, 3283237632, 3283238143, 'RS', 'SRB', 'صربيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(75686, 3283238144, 3283238335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75687, 3283238336, 3283238399, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75688, 3283238400, 3283238463, 'RS', 'SRB', 'صربيا'),
(75689, 3283238464, 3283238479, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75690, 3283238480, 3283238495, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75691, 3283238496, 3283238511, 'RS', 'SRB', 'صربيا'),
(75692, 3283238512, 3283238527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75693, 3283238528, 3283238623, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75694, 3283238624, 3283238655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75695, 3283238656, 3283238671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75696, 3283238672, 3283238687, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75697, 3283238688, 3283238719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75698, 3283238720, 3283238783, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75699, 3283238784, 3283238911, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(75700, 3283238912, 3283247103, 'CZ', 'CZE', 'التشيك'),
(75701, 3283247104, 3283247615, 'LV', 'LVA', 'لاتفيا'),
(75702, 3283247616, 3283248127, 'BG', 'BGR', 'بلغاريا'),
(75703, 3283248128, 3283248639, 'DE', 'DEU', 'ألمانيا'),
(75704, 3283248640, 3283249151, 'RO', 'ROM', 'رومانيا'),
(75705, 3283249152, 3283249663, 'UA', 'UKR', 'أوكرانيا'),
(75706, 3283249664, 3283250175, 'GB', 'GBR', 'المملكة المتحدة'),
(75707, 3283250176, 3283250687, 'RU', 'RUS', 'الإتحاد الروسي'),
(75708, 3283250688, 3283251199, 'RO', 'ROM', 'رومانيا'),
(75709, 3283251200, 3283251711, 'FR', 'FRA', 'فرنسا'),
(75710, 3283251712, 3283252223, 'PL', 'POL', 'بولندا'),
(75711, 3283252224, 3283252735, 'BG', 'BGR', 'بلغاريا'),
(75712, 3283252736, 3283253247, 'SI', 'SVN', 'سلوفينيا'),
(75713, 3283253248, 3283253759, 'RO', 'ROM', 'رومانيا'),
(75714, 3283253760, 3283254271, 'PL', 'POL', 'بولندا'),
(75715, 3283254272, 3283255295, 'RO', 'ROM', 'رومانيا'),
(75716, 3283255296, 3283263487, 'UA', 'UKR', 'أوكرانيا'),
(75717, 3283263488, 3283271679, 'SE', 'SWE', 'السويد'),
(75718, 3283271680, 3283279871, 'RU', 'RUS', 'الإتحاد الروسي'),
(75719, 3283279872, 3283288063, 'SE', 'SWE', 'السويد'),
(75720, 3283288064, 3283288575, 'DE', 'DEU', 'ألمانيا'),
(75721, 3283288576, 3283288579, 'BE', 'BEL', 'بلجيكا'),
(75722, 3283288580, 3283291999, 'DE', 'DEU', 'ألمانيا'),
(75723, 3283292000, 3283292015, 'CH', 'CHE', 'سويسرا'),
(75724, 3283292016, 3283304919, 'DE', 'DEU', 'ألمانيا'),
(75725, 3283304920, 3283304923, 'ES', 'ESP', 'إسبانيا'),
(75726, 3283304924, 3283305087, 'DE', 'DEU', 'ألمانيا'),
(75727, 3283305088, 3283305127, 'FR', 'FRA', 'فرنسا'),
(75728, 3283305128, 3283305711, 'DE', 'DEU', 'ألمانيا'),
(75729, 3283305712, 3283305715, 'ES', 'ESP', 'إسبانيا'),
(75730, 3283305716, 3283318975, 'DE', 'DEU', 'ألمانيا'),
(75731, 3283318976, 3283318991, 'NL', 'NLD', 'هولندا'),
(75732, 3283318992, 3283318999, 'ES', 'ESP', 'إسبانيا'),
(75733, 3283319000, 3283321087, 'DE', 'DEU', 'ألمانيا'),
(75734, 3283321088, 3283321119, 'GB', 'GBR', 'المملكة المتحدة'),
(75735, 3283321120, 3283321151, 'DE', 'DEU', 'ألمانيا'),
(75736, 3283321152, 3283321155, 'ES', 'ESP', 'إسبانيا'),
(75737, 3283321156, 3283329923, 'DE', 'DEU', 'ألمانيا'),
(75738, 3283329924, 3283329927, 'ES', 'ESP', 'إسبانيا'),
(75739, 3283329928, 3283419135, 'DE', 'DEU', 'ألمانيا'),
(75740, 3283419136, 3283484671, 'DK', 'DNK', 'الدنيمارك'),
(75741, 3283484672, 3283484927, 'UA', 'UKR', 'أوكرانيا'),
(75742, 3283484928, 3283485183, 'NL', 'NLD', 'هولندا'),
(75743, 3283485184, 3283485439, 'DE', 'DEU', 'ألمانيا'),
(75744, 3283485440, 3283485695, 'UA', 'UKR', 'أوكرانيا'),
(75745, 3283485696, 3283485951, 'GB', 'GBR', 'المملكة المتحدة'),
(75746, 3283485952, 3283486207, 'SE', 'SWE', 'السويد'),
(75747, 3283486208, 3283486463, 'AT', 'AUT', 'النمسا'),
(75748, 3283486464, 3283486719, 'UA', 'UKR', 'أوكرانيا'),
(75749, 3283486720, 3283486975, 'RU', 'RUS', 'الإتحاد الروسي'),
(75750, 3283486976, 3283487231, 'PL', 'POL', 'بولندا'),
(75751, 3283487232, 3283487487, 'FR', 'FRA', 'فرنسا'),
(75752, 3283487488, 3283487743, 'DE', 'DEU', 'ألمانيا'),
(75753, 3283487744, 3283487999, 'CH', 'CHE', 'سويسرا'),
(75754, 3283488000, 3283488255, 'NL', 'NLD', 'هولندا'),
(75755, 3283488256, 3283488511, 'PL', 'POL', 'بولندا'),
(75756, 3283488512, 3283488767, 'RU', 'RUS', 'الإتحاد الروسي'),
(75757, 3283488768, 3283489279, 'FR', 'FRA', 'فرنسا'),
(75758, 3283489280, 3283489535, 'DE', 'DEU', 'ألمانيا'),
(75759, 3283489536, 3283490047, 'PL', 'POL', 'بولندا'),
(75760, 3283490048, 3283490559, 'UA', 'UKR', 'أوكرانيا'),
(75761, 3283490560, 3283490815, 'PL', 'POL', 'بولندا'),
(75762, 3283490816, 3283491071, 'CH', 'CHE', 'سويسرا'),
(75763, 3283491072, 3283491327, 'TR', 'TUR', 'تركيا'),
(75764, 3283491328, 3283491583, 'AT', 'AUT', 'النمسا'),
(75765, 3283491584, 3283491839, 'RO', 'ROM', 'رومانيا'),
(75766, 3283491840, 3283492095, 'RU', 'RUS', 'الإتحاد الروسي'),
(75767, 3283492096, 3283492351, 'AT', 'AUT', 'النمسا'),
(75768, 3283492352, 3283492607, 'ES', 'ESP', 'إسبانيا'),
(75769, 3283492608, 3283492863, 'SA', 'SAU', 'السعودية'),
(75770, 3283492864, 3283493119, 'DK', 'DNK', 'الدنيمارك'),
(75771, 3283493120, 3283493375, 'IL', 'ISR', 'إسرائيل'),
(75772, 3283493376, 3283493887, 'PL', 'POL', 'بولندا'),
(75773, 3283493888, 3283494143, 'DK', 'DNK', 'الدنيمارك'),
(75774, 3283494144, 3283494399, 'GB', 'GBR', 'المملكة المتحدة'),
(75775, 3283494400, 3283494655, 'PL', 'POL', 'بولندا'),
(75776, 3283494656, 3283494911, 'DK', 'DNK', 'الدنيمارك'),
(75777, 3283494912, 3283495167, 'PL', 'POL', 'بولندا'),
(75778, 3283495168, 3283495423, 'BG', 'BGR', 'بلغاريا'),
(75779, 3283495424, 3283495679, 'TR', 'TUR', 'تركيا'),
(75780, 3283495680, 3283495935, 'NL', 'NLD', 'هولندا'),
(75781, 3283495936, 3283496191, 'BG', 'BGR', 'بلغاريا'),
(75782, 3283496192, 3283496447, 'DE', 'DEU', 'ألمانيا'),
(75783, 3283496448, 3283496703, 'FR', 'FRA', 'فرنسا'),
(75784, 3283496704, 3283496959, 'LV', 'LVA', 'لاتفيا'),
(75785, 3283496960, 3283497215, 'DE', 'DEU', 'ألمانيا'),
(75786, 3283497216, 3283497471, 'GB', 'GBR', 'المملكة المتحدة'),
(75787, 3283497472, 3283497727, 'DE', 'DEU', 'ألمانيا'),
(75788, 3283497728, 3283498239, 'PL', 'POL', 'بولندا'),
(75789, 3283498240, 3283498495, 'CH', 'CHE', 'سويسرا'),
(75790, 3283498496, 3283498751, 'PL', 'POL', 'بولندا'),
(75791, 3283498752, 3283499007, 'AT', 'AUT', 'النمسا'),
(75792, 3283499008, 3283499263, 'DE', 'DEU', 'ألمانيا'),
(75793, 3283499264, 3283499519, 'GB', 'GBR', 'المملكة المتحدة'),
(75794, 3283499520, 3283499775, 'DE', 'DEU', 'ألمانيا'),
(75795, 3283499776, 3283500031, 'GB', 'GBR', 'المملكة المتحدة'),
(75796, 3283500032, 3283500287, 'DE', 'DEU', 'ألمانيا'),
(75797, 3283500288, 3283500543, 'SI', 'SVN', 'سلوفينيا'),
(75798, 3283500544, 3283500799, 'GB', 'GBR', 'المملكة المتحدة'),
(75799, 3283500800, 3283501055, 'UA', 'UKR', 'أوكرانيا'),
(75800, 3283501056, 3283509247, 'LT', 'LTU', 'ليتوانيا'),
(75801, 3283509248, 3283513375, 'DE', 'DEU', 'ألمانيا'),
(75802, 3283513408, 3283513415, 'DE', 'DEU', 'ألمانيا'),
(75803, 3283513432, 3283513435, 'DE', 'DEU', 'ألمانيا'),
(75804, 3283513448, 3283513519, 'DE', 'DEU', 'ألمانيا'),
(75805, 3283513536, 3283513855, 'DE', 'DEU', 'ألمانيا'),
(75806, 3283513984, 3283514095, 'DE', 'DEU', 'ألمانيا'),
(75807, 3283514112, 3283514463, 'DE', 'DEU', 'ألمانيا'),
(75808, 3283514528, 3283514547, 'DE', 'DEU', 'ألمانيا'),
(75809, 3283514552, 3283516415, 'DE', 'DEU', 'ألمانيا'),
(75810, 3283516800, 3283516863, 'DE', 'DEU', 'ألمانيا'),
(75811, 3283516992, 3283517055, 'DE', 'DEU', 'ألمانيا'),
(75812, 3283517184, 3283517439, 'DE', 'DEU', 'ألمانيا'),
(75813, 3283517440, 3283525631, 'RU', 'RUS', 'الإتحاد الروسي'),
(75814, 3283525632, 3283533823, 'GB', 'GBR', 'المملكة المتحدة'),
(75815, 3283533824, 3283534847, 'UA', 'UKR', 'أوكرانيا'),
(75816, 3283534848, 3283535359, 'DE', 'DEU', 'ألمانيا'),
(75817, 3283535360, 3283535871, 'RO', 'ROM', 'رومانيا'),
(75818, 3283535872, 3283536383, 'GI', 'GIB', 'جبل طارق'),
(75819, 3283536384, 3283536895, 'UA', 'UKR', 'أوكرانيا'),
(75820, 3283536896, 3283537407, 'DK', 'DNK', 'الدنيمارك'),
(75821, 3283537408, 3283537919, 'PL', 'POL', 'بولندا'),
(75822, 3283537920, 3283538431, 'RO', 'ROM', 'رومانيا'),
(75823, 3283538432, 3283538943, 'IT', 'ITA', 'إيطاليا'),
(75824, 3283538944, 3283539455, 'RO', 'ROM', 'رومانيا'),
(75825, 3283539456, 3283539967, 'RS', 'SRB', 'صربيا'),
(75826, 3283539968, 3283540479, 'DK', 'DNK', 'الدنيمارك'),
(75827, 3283540480, 3283540991, 'PL', 'POL', 'بولندا'),
(75828, 3283540992, 3283541503, 'RO', 'ROM', 'رومانيا'),
(75829, 3283541504, 3283542015, 'CH', 'CHE', 'سويسرا'),
(75830, 3283542016, 3283550207, 'IT', 'ITA', 'إيطاليا'),
(75831, 3283550208, 3283550239, 'AT', 'AUT', 'النمسا'),
(75832, 3283550288, 3283550319, 'AT', 'AUT', 'النمسا'),
(75833, 3283550464, 3283550623, 'AT', 'AUT', 'النمسا'),
(75834, 3283550624, 3283550655, 'FR', 'FRA', 'فرنسا'),
(75835, 3283550656, 3283550719, 'GB', 'GBR', 'المملكة المتحدة'),
(75836, 3283550720, 3283552255, 'AT', 'AUT', 'النمسا'),
(75837, 3283552256, 3283552279, 'IT', 'ITA', 'إيطاليا'),
(75838, 3283552288, 3283552319, 'IT', 'ITA', 'إيطاليا'),
(75839, 3283552352, 3283552415, 'IT', 'ITA', 'إيطاليا'),
(75840, 3283552448, 3283552495, 'IT', 'ITA', 'إيطاليا'),
(75841, 3283552512, 3283552575, 'IT', 'ITA', 'إيطاليا'),
(75842, 3283552576, 3283552639, 'DE', 'DEU', 'ألمانيا'),
(75843, 3283552640, 3283552671, 'IT', 'ITA', 'إيطاليا'),
(75844, 3283552672, 3283552703, 'CH', 'CHE', 'سويسرا'),
(75845, 3283552704, 3283552735, 'DE', 'DEU', 'ألمانيا'),
(75846, 3283552736, 3283552751, 'FR', 'FRA', 'فرنسا'),
(75847, 3283552752, 3283553047, 'IT', 'ITA', 'إيطاليا'),
(75848, 3283553048, 3283553055, 'GB', 'GBR', 'المملكة المتحدة'),
(75849, 3283553056, 3283553071, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75850, 3283553072, 3283553079, 'SE', 'SWE', 'السويد'),
(75851, 3283553080, 3283553119, 'DE', 'DEU', 'ألمانيا'),
(75852, 3283553120, 3283553151, 'GR', 'GRC', 'اليونان'),
(75853, 3283553152, 3283553279, 'GB', 'GBR', 'المملكة المتحدة'),
(75854, 3283553280, 3283553535, 'IT', 'ITA', 'إيطاليا'),
(75855, 3283553792, 3283554047, 'GB', 'GBR', 'المملكة المتحدة'),
(75856, 3283554048, 3283554079, 'IT', 'ITA', 'إيطاليا'),
(75857, 3283554080, 3283554095, 'ES', 'ESP', 'إسبانيا'),
(75858, 3283554096, 3283554111, 'NL', 'NLD', 'هولندا'),
(75859, 3283554112, 3283554175, 'IT', 'ITA', 'إيطاليا'),
(75860, 3283554176, 3283554239, 'FR', 'FRA', 'فرنسا'),
(75861, 3283554240, 3283554255, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75862, 3283554256, 3283554271, 'RU', 'RUS', 'الإتحاد الروسي'),
(75863, 3283554272, 3283554303, 'GB', 'GBR', 'المملكة المتحدة'),
(75864, 3283554304, 3283554327, 'CH', 'CHE', 'سويسرا'),
(75865, 3283554336, 3283554367, 'CH', 'CHE', 'سويسرا'),
(75866, 3283554432, 3283555743, 'CH', 'CHE', 'سويسرا'),
(75867, 3283555744, 3283555759, 'SE', 'SWE', 'السويد'),
(75868, 3283555760, 3283555775, 'DE', 'DEU', 'ألمانيا'),
(75869, 3283555776, 3283555807, 'NL', 'NLD', 'هولندا'),
(75870, 3283555808, 3283555839, 'DE', 'DEU', 'ألمانيا'),
(75871, 3283555840, 3283556351, 'CH', 'CHE', 'سويسرا'),
(75872, 3283556352, 3283556391, 'FR', 'FRA', 'فرنسا'),
(75873, 3283556400, 3283556623, 'FR', 'FRA', 'فرنسا'),
(75874, 3283556672, 3283556735, 'FR', 'FRA', 'فرنسا'),
(75875, 3283556864, 3283558303, 'FR', 'FRA', 'فرنسا'),
(75876, 3283558304, 3283558335, 'DE', 'DEU', 'ألمانيا'),
(75877, 3283558336, 3283558367, 'IT', 'ITA', 'إيطاليا'),
(75878, 3283558368, 3283558383, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75879, 3283558384, 3283558399, 'GB', 'GBR', 'المملكة المتحدة'),
(75880, 3283558400, 3283558431, 'RU', 'RUS', 'الإتحاد الروسي'),
(75881, 3283558432, 3283558463, 'DE', 'DEU', 'ألمانيا'),
(75882, 3283558464, 3283558535, 'RU', 'RUS', 'الإتحاد الروسي'),
(75883, 3283558656, 3283558751, 'FR', 'FRA', 'فرنسا'),
(75884, 3283558752, 3283558783, 'BE', 'BEL', 'بلجيكا'),
(75885, 3283558784, 3283558799, 'GB', 'GBR', 'المملكة المتحدة'),
(75886, 3283558800, 3283558815, 'BE', 'BEL', 'بلجيكا'),
(75887, 3283558816, 3283558847, 'NL', 'NLD', 'هولندا'),
(75888, 3283558848, 3283558863, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75889, 3283558864, 3283558871, 'GB', 'GBR', 'المملكة المتحدة'),
(75890, 3283558872, 3283558879, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75891, 3283558880, 3283558895, 'GB', 'GBR', 'المملكة المتحدة'),
(75892, 3283558896, 3283558911, 'BE', 'BEL', 'بلجيكا'),
(75893, 3283558912, 3283559039, 'DE', 'DEU', 'ألمانيا'),
(75894, 3283559040, 3283559167, 'IE', 'IRL', 'إيرلندا'),
(75895, 3283559168, 3283559231, 'DE', 'DEU', 'ألمانيا'),
(75896, 3283559232, 3283559263, 'GB', 'GBR', 'المملكة المتحدة'),
(75897, 3283559264, 3283559295, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75898, 3283559296, 3283559423, 'DE', 'DEU', 'ألمانيا'),
(75899, 3283559424, 3283559679, 'NL', 'NLD', 'هولندا'),
(75900, 3283559680, 3283559935, 'IT', 'ITA', 'إيطاليا'),
(75901, 3283559936, 3283560191, 'GB', 'GBR', 'المملكة المتحدة'),
(75902, 3283560192, 3283560447, 'NO', 'NOR', 'النرويج'),
(75903, 3283560704, 3283560847, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75904, 3283560864, 3283560895, 'SE', 'SWE', 'السويد'),
(75905, 3283560896, 3283560959, 'GB', 'GBR', 'المملكة المتحدة'),
(75906, 3283560960, 3283561215, 'BE', 'BEL', 'بلجيكا'),
(75907, 3283561376, 3283561407, 'GB', 'GBR', 'المملكة المتحدة'),
(75908, 3283561408, 3283561471, 'ES', 'ESP', 'إسبانيا'),
(75909, 3283561472, 3283562495, 'GB', 'GBR', 'المملكة المتحدة'),
(75910, 3283562496, 3283562751, 'DE', 'DEU', 'ألمانيا'),
(75911, 3283562752, 3283562895, 'GB', 'GBR', 'المملكة المتحدة'),
(75912, 3283562896, 3283562903, 'NL', 'NLD', 'هولندا'),
(75913, 3283562904, 3283562911, 'CH', 'CHE', 'سويسرا'),
(75914, 3283562912, 3283562943, 'DE', 'DEU', 'ألمانيا'),
(75915, 3283562944, 3283563007, 'IT', 'ITA', 'إيطاليا'),
(75916, 3283563008, 3283566015, 'GB', 'GBR', 'المملكة المتحدة'),
(75917, 3283566016, 3283566079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75918, 3283566080, 3283566591, 'GB', 'GBR', 'المملكة المتحدة'),
(75919, 3283566592, 3283566719, 'PL', 'POL', 'بولندا'),
(75920, 3283566848, 3283567103, 'NO', 'NOR', 'النرويج'),
(75921, 3283567104, 3283567423, 'GB', 'GBR', 'المملكة المتحدة'),
(75922, 3283567424, 3283567455, 'DE', 'DEU', 'ألمانيا'),
(75923, 3283567456, 3283567471, 'GB', 'GBR', 'المملكة المتحدة'),
(75924, 3283567472, 3283567487, 'ES', 'ESP', 'إسبانيا'),
(75925, 3283567488, 3283567615, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75926, 3283567616, 3283567967, 'GB', 'GBR', 'المملكة المتحدة'),
(75927, 3283567968, 3283567999, 'IT', 'ITA', 'إيطاليا'),
(75928, 3283568000, 3283568031, 'GB', 'GBR', 'المملكة المتحدة'),
(75929, 3283568032, 3283568063, 'DE', 'DEU', 'ألمانيا'),
(75930, 3283568064, 3283568079, 'NL', 'NLD', 'هولندا'),
(75931, 3283568080, 3283568095, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75932, 3283568096, 3283568127, 'DK', 'DNK', 'الدنيمارك'),
(75933, 3283568128, 3283569991, 'GB', 'GBR', 'المملكة المتحدة'),
(75934, 3283569992, 3283570015, 'SE', 'SWE', 'السويد'),
(75935, 3283570016, 3283570047, 'DK', 'DNK', 'الدنيمارك'),
(75936, 3283570048, 3283570175, 'DE', 'DEU', 'ألمانيا'),
(75937, 3283570176, 3283570439, 'GB', 'GBR', 'المملكة المتحدة'),
(75938, 3283570440, 3283570447, 'SE', 'SWE', 'السويد'),
(75939, 3283570448, 3283570463, 'IT', 'ITA', 'إيطاليا'),
(75940, 3283570464, 3283570495, 'GB', 'GBR', 'المملكة المتحدة'),
(75941, 3283570496, 3283570559, 'DE', 'DEU', 'ألمانيا'),
(75942, 3283570560, 3283570623, 'FR', 'FRA', 'فرنسا'),
(75943, 3283570624, 3283571167, 'GB', 'GBR', 'المملكة المتحدة'),
(75944, 3283571168, 3283571199, 'DE', 'DEU', 'ألمانيا'),
(75945, 3283571200, 3283571711, 'GB', 'GBR', 'المملكة المتحدة'),
(75946, 3283571712, 3283571719, 'HU', 'HUN', 'هنغاريا'),
(75947, 3283571744, 3283571775, 'DE', 'DEU', 'ألمانيا'),
(75948, 3283571776, 3283571839, 'GB', 'GBR', 'المملكة المتحدة'),
(75949, 3283571840, 3283571903, 'SE', 'SWE', 'السويد'),
(75950, 3283571904, 3283571967, 'DE', 'DEU', 'ألمانيا'),
(75951, 3283571968, 3283572111, 'GB', 'GBR', 'المملكة المتحدة'),
(75952, 3283572112, 3283572127, 'BE', 'BEL', 'بلجيكا'),
(75953, 3283572128, 3283572159, 'SE', 'SWE', 'السويد'),
(75954, 3283572160, 3283572175, 'GB', 'GBR', 'المملكة المتحدة'),
(75955, 3283572176, 3283572191, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75956, 3283572192, 3283572223, 'CH', 'CHE', 'سويسرا'),
(75957, 3283572224, 3283572615, 'GB', 'GBR', 'المملكة المتحدة'),
(75958, 3283572616, 3283572623, 'FR', 'FRA', 'فرنسا'),
(75959, 3283572624, 3283572631, 'GB', 'GBR', 'المملكة المتحدة'),
(75960, 3283572632, 3283572639, 'CH', 'CHE', 'سويسرا'),
(75961, 3283572640, 3283572671, 'GB', 'GBR', 'المملكة المتحدة'),
(75962, 3283572672, 3283572735, 'DE', 'DEU', 'ألمانيا'),
(75963, 3283573248, 3283574527, 'GB', 'GBR', 'المملكة المتحدة'),
(75964, 3283574592, 3283574607, 'GB', 'GBR', 'المملكة المتحدة'),
(75965, 3283574608, 3283574615, 'NL', 'NLD', 'هولندا'),
(75966, 3283574616, 3283574623, 'GB', 'GBR', 'المملكة المتحدة'),
(75967, 3283574624, 3283574639, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75968, 3283574640, 3283574655, 'GB', 'GBR', 'المملكة المتحدة'),
(75969, 3283574656, 3283575071, 'DE', 'DEU', 'ألمانيا'),
(75970, 3283575072, 3283575087, 'NL', 'NLD', 'هولندا'),
(75971, 3283575088, 3283575679, 'DE', 'DEU', 'ألمانيا'),
(75972, 3283575808, 3283576415, 'DE', 'DEU', 'ألمانيا'),
(75973, 3283576416, 3283576447, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75974, 3283576448, 3283580159, 'DE', 'DEU', 'ألمانيا'),
(75975, 3283580416, 3283580455, 'DE', 'DEU', 'ألمانيا'),
(75976, 3283580464, 3283582975, 'DE', 'DEU', 'ألمانيا'),
(75977, 3283583008, 3283583359, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75978, 3283583488, 3283583503, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75979, 3283583520, 3283583615, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75980, 3283583744, 3283583839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75981, 3283583840, 3283583847, 'IT', 'ITA', 'إيطاليا'),
(75982, 3283583848, 3283583871, 'GB', 'GBR', 'المملكة المتحدة'),
(75983, 3283583872, 3283583999, 'BE', 'BEL', 'بلجيكا'),
(75984, 3283584000, 3283584031, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75985, 3283584032, 3283584063, 'DE', 'DEU', 'ألمانيا'),
(75986, 3283584064, 3283584127, 'IE', 'IRL', 'إيرلندا'),
(75987, 3283584128, 3283585023, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75988, 3283585032, 3283585279, 'ES', 'ESP', 'إسبانيا'),
(75989, 3283585280, 3283585535, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(75990, 3283585536, 3283585679, 'ES', 'ESP', 'إسبانيا'),
(75991, 3283585680, 3283585695, 'IE', 'IRL', 'إيرلندا'),
(75992, 3283585696, 3283585727, 'FR', 'FRA', 'فرنسا'),
(75993, 3283585728, 3283585791, 'ES', 'ESP', 'إسبانيا'),
(75994, 3283585792, 3283586047, 'IE', 'IRL', 'إيرلندا'),
(75995, 3283586048, 3283586335, 'ES', 'ESP', 'إسبانيا'),
(75996, 3283586344, 3283586351, 'ES', 'ESP', 'إسبانيا'),
(75997, 3283586368, 3283586407, 'ES', 'ESP', 'إسبانيا'),
(75998, 3283586416, 3283586503, 'ES', 'ESP', 'إسبانيا'),
(75999, 3283586560, 3283586815, 'FR', 'FRA', 'فرنسا'),
(76000, 3283586816, 3283587071, 'DE', 'DEU', 'ألمانيا'),
(76001, 3283587072, 3283587231, 'NL', 'NLD', 'هولندا'),
(76002, 3283587328, 3283587335, 'NL', 'NLD', 'هولندا'),
(76003, 3283587336, 3283587343, 'GB', 'GBR', 'المملكة المتحدة'),
(76004, 3283587344, 3283587359, 'NL', 'NLD', 'هولندا'),
(76005, 3283587360, 3283587391, 'SE', 'SWE', 'السويد'),
(76006, 3283587392, 3283587423, 'NL', 'NLD', 'هولندا'),
(76007, 3283587424, 3283587431, 'SE', 'SWE', 'السويد'),
(76008, 3283587440, 3283587447, 'GB', 'GBR', 'المملكة المتحدة'),
(76009, 3283587448, 3283587455, 'DE', 'DEU', 'ألمانيا'),
(76010, 3283587456, 3283587487, 'CH', 'CHE', 'سويسرا'),
(76011, 3283587520, 3283587551, 'CH', 'CHE', 'سويسرا'),
(76012, 3283587584, 3283587647, 'NL', 'NLD', 'هولندا'),
(76013, 3283587648, 3283587679, 'DE', 'DEU', 'ألمانيا'),
(76014, 3283587680, 3283587711, 'CH', 'CHE', 'سويسرا'),
(76015, 3283587712, 3283587839, 'DE', 'DEU', 'ألمانيا'),
(76016, 3283587840, 3283587871, 'NL', 'NLD', 'هولندا'),
(76017, 3283587872, 3283587887, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76018, 3283587888, 3283587895, 'SE', 'SWE', 'السويد'),
(76019, 3283587896, 3283587903, 'CH', 'CHE', 'سويسرا'),
(76020, 3283587904, 3283587967, 'IE', 'IRL', 'إيرلندا'),
(76021, 3283587968, 3283588095, 'DE', 'DEU', 'ألمانيا'),
(76022, 3283588096, 3283588191, 'BE', 'BEL', 'بلجيكا'),
(76023, 3283588224, 3283588479, 'BE', 'BEL', 'بلجيكا'),
(76024, 3283588480, 3283588543, 'AT', 'AUT', 'النمسا'),
(76025, 3283588544, 3283588607, 'GB', 'GBR', 'المملكة المتحدة'),
(76026, 3283588608, 3283589119, 'BE', 'BEL', 'بلجيكا'),
(76027, 3283589152, 3283589791, 'DK', 'DNK', 'الدنيمارك'),
(76028, 3283589792, 3283589823, 'DE', 'DEU', 'ألمانيا'),
(76029, 3283589840, 3283589887, 'DE', 'DEU', 'ألمانيا'),
(76030, 3283589888, 3283590143, 'DK', 'DNK', 'الدنيمارك'),
(76031, 3283590160, 3283590167, 'SE', 'SWE', 'السويد'),
(76032, 3283590176, 3283590207, 'SE', 'SWE', 'السويد'),
(76033, 3283590272, 3283590319, 'SE', 'SWE', 'السويد'),
(76034, 3283590336, 3283590359, 'SE', 'SWE', 'السويد'),
(76035, 3283590368, 3283590527, 'SE', 'SWE', 'السويد'),
(76036, 3283590528, 3283590543, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76037, 3283590544, 3283590591, 'DE', 'DEU', 'ألمانيا'),
(76038, 3283590592, 3283590623, 'CH', 'CHE', 'سويسرا'),
(76039, 3283590624, 3283590655, 'GB', 'GBR', 'المملكة المتحدة'),
(76040, 3283590656, 3283590847, 'SE', 'SWE', 'السويد'),
(76041, 3283590848, 3283590879, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76042, 3283590880, 3283590911, 'DE', 'DEU', 'ألمانيا'),
(76043, 3283590912, 3283591167, 'SE', 'SWE', 'السويد'),
(76044, 3283591168, 3283591359, 'DE', 'DEU', 'ألمانيا'),
(76045, 3283591360, 3283591367, 'GB', 'GBR', 'المملكة المتحدة'),
(76046, 3283591368, 3283591375, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76047, 3283591376, 3283591423, 'CH', 'CHE', 'سويسرا'),
(76048, 3283591424, 3283592191, 'DE', 'DEU', 'ألمانيا'),
(76049, 3283592192, 3283592847, 'CH', 'CHE', 'سويسرا'),
(76050, 3283592848, 3283592863, 'GB', 'GBR', 'المملكة المتحدة'),
(76051, 3283592864, 3283592895, 'DE', 'DEU', 'ألمانيا'),
(76052, 3283592896, 3283592903, 'SE', 'SWE', 'السويد'),
(76053, 3283592904, 3283592911, 'GB', 'GBR', 'المملكة المتحدة'),
(76054, 3283592912, 3283592927, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76055, 3283592928, 3283593023, 'CH', 'CHE', 'سويسرا'),
(76056, 3283593024, 3283593055, 'BE', 'BEL', 'بلجيكا'),
(76057, 3283593056, 3283593087, 'IT', 'ITA', 'إيطاليا'),
(76058, 3283593088, 3283593215, 'CH', 'CHE', 'سويسرا'),
(76059, 3283593216, 3283595263, 'IT', 'ITA', 'إيطاليا'),
(76060, 3283595264, 3283595775, 'DE', 'DEU', 'ألمانيا'),
(76061, 3283596288, 3283598127, 'GB', 'GBR', 'المملكة المتحدة'),
(76062, 3283598144, 3283598175, 'DE', 'DEU', 'ألمانيا'),
(76063, 3283598208, 3283598335, 'DE', 'DEU', 'ألمانيا'),
(76064, 3283598336, 3283598639, 'GB', 'GBR', 'المملكة المتحدة'),
(76065, 3283598640, 3283598655, 'CH', 'CHE', 'سويسرا'),
(76066, 3283598656, 3283598687, 'IE', 'IRL', 'إيرلندا'),
(76067, 3283598688, 3283598719, 'SE', 'SWE', 'السويد'),
(76068, 3283598720, 3283598735, 'DE', 'DEU', 'ألمانيا'),
(76069, 3283598736, 3283598743, 'DK', 'DNK', 'الدنيمارك'),
(76070, 3283598744, 3283598847, 'DE', 'DEU', 'ألمانيا'),
(76071, 3283598848, 3283598879, 'GB', 'GBR', 'المملكة المتحدة'),
(76072, 3283598880, 3283598911, 'CH', 'CHE', 'سويسرا'),
(76073, 3283598912, 3283598975, 'GB', 'GBR', 'المملكة المتحدة'),
(76074, 3283598976, 3283599103, 'DK', 'DNK', 'الدنيمارك'),
(76075, 3283599104, 3283599295, 'GB', 'GBR', 'المملكة المتحدة'),
(76076, 3283599296, 3283599311, 'DE', 'DEU', 'ألمانيا'),
(76077, 3283599312, 3283599327, 'NL', 'NLD', 'هولندا'),
(76078, 3283599328, 3283599359, 'GB', 'GBR', 'المملكة المتحدة'),
(76079, 3283599360, 3283599615, 'SE', 'SWE', 'السويد'),
(76080, 3283599616, 3283599871, 'IE', 'IRL', 'إيرلندا'),
(76081, 3283599872, 3283600527, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76082, 3283600528, 3283600543, 'FR', 'FRA', 'فرنسا'),
(76083, 3283600544, 3283600575, 'DE', 'DEU', 'ألمانيا'),
(76084, 3283600576, 3283600607, 'IT', 'ITA', 'إيطاليا'),
(76085, 3283600640, 3283600671, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76086, 3283600672, 3283600703, 'DE', 'DEU', 'ألمانيا'),
(76087, 3283600704, 3283600767, 'IT', 'ITA', 'إيطاليا'),
(76088, 3283600768, 3283600895, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76089, 3283600896, 3283601343, 'AT', 'AUT', 'النمسا'),
(76090, 3283601344, 3283601375, 'IT', 'ITA', 'إيطاليا'),
(76091, 3283601376, 3283601391, 'IE', 'IRL', 'إيرلندا'),
(76092, 3283601392, 3283601399, 'NL', 'NLD', 'هولندا'),
(76093, 3283601400, 3283601919, 'AT', 'AUT', 'النمسا'),
(76094, 3283601920, 3283602239, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76095, 3283602240, 3283602271, 'GB', 'GBR', 'المملكة المتحدة'),
(76096, 3283602272, 3283602287, 'IT', 'ITA', 'إيطاليا'),
(76097, 3283602288, 3283602303, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76098, 3283602304, 3283602367, 'GB', 'GBR', 'المملكة المتحدة'),
(76099, 3283602368, 3283602431, 'BE', 'BEL', 'بلجيكا'),
(76100, 3283602432, 3283602943, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76101, 3283602944, 3283603007, 'CH', 'CHE', 'سويسرا'),
(76102, 3283603008, 3283603071, 'IT', 'ITA', 'إيطاليا'),
(76103, 3283603072, 3283603199, 'CH', 'CHE', 'سويسرا'),
(76104, 3283603456, 3283604479, 'GB', 'GBR', 'المملكة المتحدة'),
(76105, 3283604736, 3283605503, 'GB', 'GBR', 'المملكة المتحدة'),
(76106, 3283605504, 3283606783, 'DE', 'DEU', 'ألمانيا'),
(76107, 3283606784, 3283607359, 'BE', 'BEL', 'بلجيكا'),
(76108, 3283607360, 3283607423, 'NO', 'NOR', 'النرويج'),
(76109, 3283607424, 3283607551, 'AT', 'AUT', 'النمسا'),
(76110, 3283607552, 3283608575, 'BE', 'BEL', 'بلجيكا'),
(76111, 3283608576, 3283608831, 'DE', 'DEU', 'ألمانيا'),
(76112, 3283608896, 3283608959, 'DE', 'DEU', 'ألمانيا'),
(76113, 3283608960, 3283609087, 'IT', 'ITA', 'إيطاليا'),
(76114, 3283609088, 3283610783, 'DE', 'DEU', 'ألمانيا'),
(76115, 3283610784, 3283610815, 'CH', 'CHE', 'سويسرا'),
(76116, 3283610816, 3283610879, 'TR', 'TUR', 'تركيا'),
(76117, 3283610880, 3283611903, 'DE', 'DEU', 'ألمانيا'),
(76118, 3283611904, 3283613247, 'IT', 'ITA', 'إيطاليا'),
(76119, 3283613248, 3283613311, 'DE', 'DEU', 'ألمانيا'),
(76120, 3283613312, 3283613695, 'IT', 'ITA', 'إيطاليا'),
(76121, 3283613696, 3283614079, 'CH', 'CHE', 'سويسرا'),
(76122, 3283614080, 3283614207, 'FR', 'FRA', 'فرنسا'),
(76123, 3283614208, 3283614975, 'CH', 'CHE', 'سويسرا'),
(76124, 3283615232, 3283615743, 'CH', 'CHE', 'سويسرا'),
(76125, 3283615744, 3283623935, 'HU', 'HUN', 'هنغاريا'),
(76126, 3283623936, 3283632127, 'DK', 'DNK', 'الدنيمارك'),
(76127, 3283632128, 3283632639, 'NL', 'NLD', 'هولندا'),
(76128, 3283632640, 3283633151, 'GB', 'GBR', 'المملكة المتحدة'),
(76129, 3283633152, 3283633663, 'SE', 'SWE', 'السويد'),
(76130, 3283633664, 3283634175, 'UA', 'UKR', 'أوكرانيا'),
(76131, 3283634176, 3283635199, 'RU', 'RUS', 'الإتحاد الروسي'),
(76132, 3283635200, 3283635711, 'GB', 'GBR', 'المملكة المتحدة'),
(76133, 3283635712, 3283636223, 'RU', 'RUS', 'الإتحاد الروسي'),
(76134, 3283636224, 3283636735, 'UA', 'UKR', 'أوكرانيا'),
(76135, 3283636736, 3283637247, 'PL', 'POL', 'بولندا'),
(76136, 3283637248, 3283637759, 'FR', 'FRA', 'فرنسا'),
(76137, 3283637760, 3283638271, 'UA', 'UKR', 'أوكرانيا'),
(76138, 3283638272, 3283638783, 'PL', 'POL', 'بولندا'),
(76139, 3283638784, 3283639295, 'RU', 'RUS', 'الإتحاد الروسي'),
(76140, 3283639296, 3283639807, 'CH', 'CHE', 'سويسرا'),
(76141, 3283639808, 3283640319, 'DE', 'DEU', 'ألمانيا'),
(76142, 3283640320, 3283648511, 'DK', 'DNK', 'الدنيمارك'),
(76143, 3283648512, 3283649023, 'BE', 'BEL', 'بلجيكا'),
(76144, 3283649024, 3283649535, 'GB', 'GBR', 'المملكة المتحدة'),
(76145, 3283649536, 3283649791, 'DE', 'DEU', 'ألمانيا'),
(76146, 3283649792, 3283650047, 'FR', 'FRA', 'فرنسا'),
(76147, 3283650048, 3283650559, 'DE', 'DEU', 'ألمانيا'),
(76148, 3283650560, 3283650687, 'SE', 'SWE', 'السويد'),
(76149, 3283650688, 3283650815, 'CH', 'CHE', 'سويسرا'),
(76150, 3283650816, 3283650879, 'SE', 'SWE', 'السويد'),
(76151, 3283650880, 3283650911, 'GB', 'GBR', 'المملكة المتحدة'),
(76152, 3283650912, 3283650927, 'SE', 'SWE', 'السويد'),
(76153, 3283650928, 3283650943, 'GB', 'GBR', 'المملكة المتحدة'),
(76154, 3283650944, 3283650959, 'RU', 'RUS', 'الإتحاد الروسي'),
(76155, 3283650960, 3283650975, 'CH', 'CHE', 'سويسرا'),
(76156, 3283650976, 3283651071, 'GB', 'GBR', 'المملكة المتحدة'),
(76157, 3283651072, 3283651135, 'IT', 'ITA', 'إيطاليا'),
(76158, 3283651136, 3283651167, 'BE', 'BEL', 'بلجيكا'),
(76159, 3283651168, 3283651183, 'ES', 'ESP', 'إسبانيا'),
(76160, 3283651184, 3283651199, 'BE', 'BEL', 'بلجيكا'),
(76161, 3283651200, 3283651263, 'HU', 'HUN', 'هنغاريا'),
(76162, 3283651264, 3283651327, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76163, 3283651328, 3283651423, 'BE', 'BEL', 'بلجيكا'),
(76164, 3283651424, 3283651439, 'DE', 'DEU', 'ألمانيا'),
(76165, 3283651440, 3283651463, 'BE', 'BEL', 'بلجيكا'),
(76166, 3283651464, 3283651471, 'DE', 'DEU', 'ألمانيا'),
(76167, 3283651472, 3283651487, 'BE', 'BEL', 'بلجيكا'),
(76168, 3283651488, 3283651519, 'FR', 'FRA', 'فرنسا'),
(76169, 3283651520, 3283651583, 'IL', 'ISR', 'إسرائيل'),
(76170, 3283651584, 3283651591, 'GB', 'GBR', 'المملكة المتحدة'),
(76171, 3283651592, 3283651599, 'BE', 'BEL', 'بلجيكا'),
(76172, 3283651600, 3283651615, 'DE', 'DEU', 'ألمانيا'),
(76173, 3283651616, 3283651647, 'BE', 'BEL', 'بلجيكا'),
(76174, 3283651648, 3283651663, 'SE', 'SWE', 'السويد'),
(76175, 3283651664, 3283651671, 'RO', 'ROM', 'رومانيا'),
(76176, 3283651672, 3283651687, 'BE', 'BEL', 'بلجيكا'),
(76177, 3283651688, 3283651695, 'IT', 'ITA', 'إيطاليا'),
(76178, 3283651696, 3283651711, 'GB', 'GBR', 'المملكة المتحدة'),
(76179, 3283651712, 3283651727, 'CH', 'CHE', 'سويسرا'),
(76180, 3283651728, 3283651735, 'FR', 'FRA', 'فرنسا'),
(76181, 3283651736, 3283651743, 'CH', 'CHE', 'سويسرا'),
(76182, 3283651744, 3283651775, 'FR', 'FRA', 'فرنسا'),
(76183, 3283651776, 3283651839, 'SE', 'SWE', 'السويد'),
(76184, 3283651840, 3283651967, 'NL', 'NLD', 'هولندا'),
(76185, 3283651968, 3283652031, 'DK', 'DNK', 'الدنيمارك'),
(76186, 3283652032, 3283652063, 'DE', 'DEU', 'ألمانيا'),
(76187, 3283652064, 3283652071, 'BE', 'BEL', 'بلجيكا'),
(76188, 3283652072, 3283652079, 'GB', 'GBR', 'المملكة المتحدة'),
(76189, 3283652080, 3283652095, 'BE', 'BEL', 'بلجيكا'),
(76190, 3283652096, 3283652351, 'GB', 'GBR', 'المملكة المتحدة'),
(76191, 3283652352, 3283652479, 'IT', 'ITA', 'إيطاليا'),
(76192, 3283652480, 3283652519, 'BE', 'BEL', 'بلجيكا'),
(76193, 3283652520, 3283652527, 'SE', 'SWE', 'السويد'),
(76194, 3283652528, 3283652543, 'BE', 'BEL', 'بلجيكا'),
(76195, 3283652544, 3283652575, 'FR', 'FRA', 'فرنسا'),
(76196, 3283652576, 3283652607, 'DE', 'DEU', 'ألمانيا'),
(76197, 3283652608, 3283652863, 'NO', 'NOR', 'النرويج'),
(76198, 3283652864, 3283653247, 'BE', 'BEL', 'بلجيكا'),
(76199, 3283653248, 3283653311, 'NO', 'NOR', 'النرويج'),
(76200, 3283653312, 3283653503, 'BE', 'BEL', 'بلجيكا'),
(76201, 3283653504, 3283653631, 'GB', 'GBR', 'المملكة المتحدة'),
(76202, 3283653632, 3283653887, 'FR', 'FRA', 'فرنسا'),
(76203, 3283653888, 3283654015, 'SE', 'SWE', 'السويد'),
(76204, 3283654016, 3283654143, 'FR', 'FRA', 'فرنسا'),
(76205, 3283654144, 3283654399, 'DE', 'DEU', 'ألمانيا'),
(76206, 3283654400, 3283654655, 'CH', 'CHE', 'سويسرا'),
(76207, 3283654656, 3283654911, 'DK', 'DNK', 'الدنيمارك'),
(76208, 3283654912, 3283655039, 'BE', 'BEL', 'بلجيكا'),
(76209, 3283655040, 3283655167, 'DK', 'DNK', 'الدنيمارك'),
(76210, 3283655168, 3283655295, 'DE', 'DEU', 'ألمانيا'),
(76211, 3283655296, 3283655423, 'BE', 'BEL', 'بلجيكا'),
(76212, 3283655424, 3283655679, 'FR', 'FRA', 'فرنسا'),
(76213, 3283655680, 3283655935, 'ES', 'ESP', 'إسبانيا'),
(76214, 3283655936, 3283656191, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(76215, 3283656192, 3283656223, 'GB', 'GBR', 'المملكة المتحدة'),
(76216, 3283656224, 3283656255, 'BE', 'BEL', 'بلجيكا'),
(76217, 3283656256, 3283656271, 'GB', 'GBR', 'المملكة المتحدة'),
(76218, 3283656272, 3283656303, 'BE', 'BEL', 'بلجيكا'),
(76219, 3283656304, 3283656311, 'GB', 'GBR', 'المملكة المتحدة'),
(76220, 3283656312, 3283656447, 'BE', 'BEL', 'بلجيكا'),
(76221, 3283656448, 3283656559, 'ES', 'ESP', 'إسبانيا'),
(76222, 3283656560, 3283656575, 'FR', 'FRA', 'فرنسا'),
(76223, 3283656576, 3283656591, 'BE', 'BEL', 'بلجيكا'),
(76224, 3283656592, 3283656599, 'FR', 'FRA', 'فرنسا'),
(76225, 3283656600, 3283656703, 'BE', 'BEL', 'بلجيكا'),
(76226, 3283656704, 3283664895, 'HU', 'HUN', 'هنغاريا'),
(76227, 3283664896, 3283673087, 'UA', 'UKR', 'أوكرانيا'),
(76228, 3283673088, 3283681279, 'GB', 'GBR', 'المملكة المتحدة'),
(76229, 3283681280, 3283729023, 'DE', 'DEU', 'ألمانيا'),
(76230, 3283729024, 3283729151, 'US', 'USA', 'الولايات المتحدة'),
(76231, 3283729152, 3283746815, 'DE', 'DEU', 'ألمانيا'),
(76232, 3283746816, 3283812351, 'CH', 'CHE', 'سويسرا'),
(76233, 3283812352, 3283877887, 'PL', 'POL', 'بولندا'),
(76234, 3283877888, 3283943423, 'GB', 'GBR', 'المملكة المتحدة'),
(76235, 3283943424, 3283944447, 'CZ', 'CZE', 'التشيك'),
(76236, 3283944448, 3283945471, 'AT', 'AUT', 'النمسا'),
(76237, 3283945472, 3283946495, 'UA', 'UKR', 'أوكرانيا'),
(76238, 3283946496, 3283947519, 'GB', 'GBR', 'المملكة المتحدة'),
(76239, 3283947520, 3283948543, 'UA', 'UKR', 'أوكرانيا'),
(76240, 3283948544, 3283949567, 'NL', 'NLD', 'هولندا'),
(76241, 3283949568, 3283950591, 'SE', 'SWE', 'السويد'),
(76242, 3283950592, 3283951615, 'KZ', 'KAZ', 'كازاخستان'),
(76243, 3283951616, 3283952639, 'PL', 'POL', 'بولندا'),
(76244, 3283952640, 3283953663, 'UA', 'UKR', 'أوكرانيا'),
(76245, 3283953664, 3283954687, 'PL', 'POL', 'بولندا'),
(76246, 3283954688, 3283956735, 'UA', 'UKR', 'أوكرانيا'),
(76247, 3283956736, 3283957759, 'PL', 'POL', 'بولندا'),
(76248, 3283957760, 3283958783, 'GR', 'GRC', 'اليونان'),
(76249, 3283958784, 3283959807, 'UA', 'UKR', 'أوكرانيا'),
(76250, 3283959808, 3283960831, 'FR', 'FRA', 'فرنسا'),
(76251, 3283960832, 3283961855, 'KZ', 'KAZ', 'كازاخستان'),
(76252, 3283961856, 3283962879, 'RU', 'RUS', 'الإتحاد الروسي'),
(76253, 3283962880, 3283963903, 'PL', 'POL', 'بولندا'),
(76254, 3283963904, 3283964927, 'RU', 'RUS', 'الإتحاد الروسي'),
(76255, 3283965952, 3283966975, 'PL', 'POL', 'بولندا'),
(76256, 3283966976, 3283967999, 'DE', 'DEU', 'ألمانيا'),
(76257, 3283968000, 3283969023, 'UA', 'UKR', 'أوكرانيا'),
(76258, 3283969024, 3283970047, 'RU', 'RUS', 'الإتحاد الروسي'),
(76259, 3283970048, 3283971071, 'UA', 'UKR', 'أوكرانيا'),
(76260, 3283971072, 3283972095, 'RU', 'RUS', 'الإتحاد الروسي'),
(76261, 3283972096, 3283973119, 'SE', 'SWE', 'السويد'),
(76262, 3283973120, 3283974143, 'NL', 'NLD', 'هولندا'),
(76263, 3283974144, 3283975167, 'RU', 'RUS', 'الإتحاد الروسي'),
(76264, 3283975168, 3283976191, 'NL', 'NLD', 'هولندا'),
(76265, 3283976192, 3283976703, 'IE', 'IRL', 'إيرلندا'),
(76266, 3283976704, 3283977215, 'DK', 'DNK', 'الدنيمارك'),
(76267, 3283977216, 3283977727, 'UA', 'UKR', 'أوكرانيا'),
(76268, 3283977728, 3283978751, 'RU', 'RUS', 'الإتحاد الروسي'),
(76269, 3283978752, 3283979263, 'RO', 'ROM', 'رومانيا'),
(76270, 3283979264, 3283979775, 'IL', 'ISR', 'إسرائيل'),
(76271, 3283979776, 3283980287, 'NO', 'NOR', 'النرويج'),
(76272, 3283980288, 3283980799, 'RO', 'ROM', 'رومانيا'),
(76273, 3283980800, 3283981823, 'CH', 'CHE', 'سويسرا'),
(76274, 3283981824, 3283983359, 'RO', 'ROM', 'رومانيا'),
(76275, 3283983360, 3283983871, 'CY', 'CYP', 'قبرص'),
(76276, 3283983872, 3283984383, 'GB', 'GBR', 'المملكة المتحدة'),
(76277, 3283984384, 3283984895, 'SE', 'SWE', 'السويد'),
(76278, 3283984896, 3283985407, 'GR', 'GRC', 'اليونان'),
(76279, 3283985408, 3283985919, 'RO', 'ROM', 'رومانيا'),
(76280, 3283985920, 3283986431, 'AT', 'AUT', 'النمسا'),
(76281, 3283986432, 3283986943, 'RU', 'RUS', 'الإتحاد الروسي'),
(76282, 3283986944, 3283987455, 'AT', 'AUT', 'النمسا'),
(76283, 3283987456, 3283987967, 'GB', 'GBR', 'المملكة المتحدة'),
(76284, 3283987968, 3283988991, 'RO', 'ROM', 'رومانيا'),
(76285, 3283988992, 3283989503, 'FR', 'FRA', 'فرنسا'),
(76286, 3283989504, 3283990015, 'RU', 'RUS', 'الإتحاد الروسي'),
(76287, 3283990016, 3283990527, 'SE', 'SWE', 'السويد'),
(76288, 3283990528, 3283991551, 'RO', 'ROM', 'رومانيا'),
(76289, 3283991552, 3283992063, 'SE', 'SWE', 'السويد'),
(76290, 3283992064, 3283992575, 'RO', 'ROM', 'رومانيا'),
(76291, 3283992576, 3283993087, 'IL', 'ISR', 'إسرائيل'),
(76292, 3283993088, 3283993599, 'RO', 'ROM', 'رومانيا'),
(76293, 3283993600, 3283994111, 'UA', 'UKR', 'أوكرانيا'),
(76294, 3283994112, 3283994623, 'AT', 'AUT', 'النمسا'),
(76295, 3283994624, 3283995135, 'UA', 'UKR', 'أوكرانيا'),
(76296, 3283995136, 3283995647, 'BE', 'BEL', 'بلجيكا'),
(76297, 3283995648, 3283996159, 'CH', 'CHE', 'سويسرا'),
(76298, 3283996160, 3283996671, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(76299, 3283996672, 3283997183, 'RO', 'ROM', 'رومانيا'),
(76300, 3283997184, 3283997695, 'PS', 'PSE', 'فلسطين المحتلة'),
(76301, 3283997696, 3283998207, 'SA', 'SAU', 'السعودية'),
(76302, 3283998208, 3283998719, 'UA', 'UKR', 'أوكرانيا'),
(76303, 3283998720, 3283999231, 'NL', 'NLD', 'هولندا'),
(76304, 3283999232, 3283999743, 'RU', 'RUS', 'الإتحاد الروسي'),
(76305, 3283999744, 3284000255, 'GB', 'GBR', 'المملكة المتحدة'),
(76306, 3284000256, 3284000767, 'RU', 'RUS', 'الإتحاد الروسي'),
(76307, 3284000768, 3284001279, 'BG', 'BGR', 'بلغاريا'),
(76308, 3284001280, 3284002303, 'UA', 'UKR', 'أوكرانيا'),
(76309, 3284002304, 3284002815, 'PL', 'POL', 'بولندا'),
(76310, 3284002816, 3284003327, 'DK', 'DNK', 'الدنيمارك'),
(76311, 3284003328, 3284003839, 'UA', 'UKR', 'أوكرانيا'),
(76312, 3284003840, 3284004351, 'DE', 'DEU', 'ألمانيا'),
(76313, 3284004352, 3284004863, 'RU', 'RUS', 'الإتحاد الروسي'),
(76314, 3284004864, 3284005375, 'UA', 'UKR', 'أوكرانيا'),
(76315, 3284005376, 3284005887, 'PA', 'PAN', 'بنما'),
(76316, 3284005888, 3284006399, 'DE', 'DEU', 'ألمانيا'),
(76317, 3284006400, 3284007423, 'UA', 'UKR', 'أوكرانيا'),
(76318, 3284007424, 3284007935, 'RO', 'ROM', 'رومانيا'),
(76319, 3284007936, 3284008447, 'CH', 'CHE', 'سويسرا'),
(76320, 3284008448, 3284008959, 'NO', 'NOR', 'النرويج'),
(76321, 3284008960, 3284009215, 'NL', 'NLD', 'هولندا'),
(76322, 3284009216, 3284009471, 'PL', 'POL', 'بولندا'),
(76323, 3284009472, 3284009727, 'DE', 'DEU', 'ألمانيا'),
(76324, 3284009728, 3284009983, 'FR', 'FRA', 'فرنسا'),
(76325, 3284009984, 3284010239, 'CH', 'CHE', 'سويسرا'),
(76326, 3284010240, 3284010751, 'FR', 'FRA', 'فرنسا'),
(76327, 3284010752, 3284011519, 'DE', 'DEU', 'ألمانيا'),
(76328, 3284011520, 3284011775, 'HR', 'HRV', 'كرواتيا'),
(76329, 3284011776, 3284012031, 'DE', 'DEU', 'ألمانيا'),
(76330, 3284012032, 3284012287, 'RU', 'RUS', 'الإتحاد الروسي'),
(76331, 3284012288, 3284012543, 'UA', 'UKR', 'أوكرانيا'),
(76332, 3284012544, 3284012799, 'RU', 'RUS', 'الإتحاد الروسي'),
(76333, 3284012800, 3284013311, 'AT', 'AUT', 'النمسا'),
(76334, 3284013312, 3284013567, 'PL', 'POL', 'بولندا'),
(76335, 3284013568, 3284013823, 'DK', 'DNK', 'الدنيمارك'),
(76336, 3284013824, 3284014079, 'IL', 'ISR', 'إسرائيل'),
(76337, 3284014080, 3284014335, 'TR', 'TUR', 'تركيا'),
(76338, 3284014336, 3284014591, 'IT', 'ITA', 'إيطاليا'),
(76339, 3284014592, 3284014847, 'GB', 'GBR', 'المملكة المتحدة'),
(76340, 3284014848, 3284015103, 'IL', 'ISR', 'إسرائيل'),
(76341, 3284015104, 3284015359, 'US', 'USA', 'الولايات المتحدة'),
(76342, 3284015360, 3284015615, 'DK', 'DNK', 'الدنيمارك'),
(76343, 3284015616, 3284015871, 'AT', 'AUT', 'النمسا'),
(76344, 3284015872, 3284016127, 'FR', 'FRA', 'فرنسا'),
(76345, 3284016128, 3284016383, 'NL', 'NLD', 'هولندا'),
(76346, 3284016384, 3284016639, 'CH', 'CHE', 'سويسرا'),
(76347, 3284016640, 3284017151, 'DK', 'DNK', 'الدنيمارك'),
(76348, 3284017152, 3284025343, 'GR', 'GRC', 'اليونان'),
(76349, 3284025344, 3284025359, 'DE', 'DEU', 'ألمانيا'),
(76350, 3284025360, 3284025439, 'GB', 'GBR', 'المملكة المتحدة'),
(76351, 3284025440, 3284025471, 'DE', 'DEU', 'ألمانيا'),
(76352, 3284025472, 3284025535, 'GB', 'GBR', 'المملكة المتحدة'),
(76353, 3284025536, 3284025567, 'DE', 'DEU', 'ألمانيا'),
(76354, 3284025568, 3284026111, 'GB', 'GBR', 'المملكة المتحدة'),
(76355, 3284026112, 3284026479, 'DE', 'DEU', 'ألمانيا'),
(76356, 3284026480, 3284026495, 'GB', 'GBR', 'المملكة المتحدة'),
(76357, 3284026496, 3284026623, 'DE', 'DEU', 'ألمانيا'),
(76358, 3284026624, 3284026815, 'GB', 'GBR', 'المملكة المتحدة'),
(76359, 3284026816, 3284026879, 'DE', 'DEU', 'ألمانيا'),
(76360, 3284026880, 3284027231, 'GB', 'GBR', 'المملكة المتحدة'),
(76361, 3284027232, 3284027359, 'DE', 'DEU', 'ألمانيا'),
(76362, 3284027360, 3284027743, 'GB', 'GBR', 'المملكة المتحدة'),
(76363, 3284027744, 3284027775, 'DE', 'DEU', 'ألمانيا'),
(76364, 3284027776, 3284027807, 'GB', 'GBR', 'المملكة المتحدة'),
(76365, 3284027808, 3284027903, 'DE', 'DEU', 'ألمانيا'),
(76366, 3284027904, 3284028415, 'GB', 'GBR', 'المملكة المتحدة'),
(76367, 3284028416, 3284028671, 'DE', 'DEU', 'ألمانيا'),
(76368, 3284028672, 3284028879, 'GB', 'GBR', 'المملكة المتحدة'),
(76369, 3284028880, 3284028895, 'DE', 'DEU', 'ألمانيا'),
(76370, 3284028896, 3284028911, 'GB', 'GBR', 'المملكة المتحدة'),
(76371, 3284028912, 3284028927, 'DE', 'DEU', 'ألمانيا'),
(76372, 3284028928, 3284029215, 'GB', 'GBR', 'المملكة المتحدة'),
(76373, 3284029216, 3284029311, 'DE', 'DEU', 'ألمانيا'),
(76374, 3284029312, 3284029695, 'GB', 'GBR', 'المملكة المتحدة'),
(76375, 3284029696, 3284029791, 'DE', 'DEU', 'ألمانيا'),
(76376, 3284029792, 3284029951, 'GB', 'GBR', 'المملكة المتحدة'),
(76377, 3284029952, 3284030463, 'DE', 'DEU', 'ألمانيا'),
(76378, 3284030464, 3284030655, 'GB', 'GBR', 'المملكة المتحدة'),
(76379, 3284030656, 3284030687, 'DE', 'DEU', 'ألمانيا'),
(76380, 3284030688, 3284030975, 'GB', 'GBR', 'المملكة المتحدة'),
(76381, 3284030976, 3284031167, 'DE', 'DEU', 'ألمانيا'),
(76382, 3284031168, 3284031551, 'GB', 'GBR', 'المملكة المتحدة'),
(76383, 3284031552, 3284031615, 'DE', 'DEU', 'ألمانيا'),
(76384, 3284031616, 3284031743, 'GB', 'GBR', 'المملكة المتحدة'),
(76385, 3284031744, 3284032031, 'DE', 'DEU', 'ألمانيا'),
(76386, 3284032032, 3284032063, 'GB', 'GBR', 'المملكة المتحدة'),
(76387, 3284032064, 3284032095, 'DE', 'DEU', 'ألمانيا'),
(76388, 3284032096, 3284032127, 'GB', 'GBR', 'المملكة المتحدة'),
(76389, 3284032128, 3284032255, 'DE', 'DEU', 'ألمانيا'),
(76390, 3284032256, 3284032639, 'GB', 'GBR', 'المملكة المتحدة'),
(76391, 3284032640, 3284032703, 'DE', 'DEU', 'ألمانيا'),
(76392, 3284032704, 3284032767, 'GB', 'GBR', 'المملكة المتحدة'),
(76393, 3284032768, 3284032895, 'DE', 'DEU', 'ألمانيا'),
(76394, 3284032896, 3284033535, 'GB', 'GBR', 'المملكة المتحدة'),
(76395, 3284033536, 3284041727, 'RU', 'RUS', 'الإتحاد الروسي'),
(76396, 3284041728, 3284041983, 'DK', 'DNK', 'الدنيمارك'),
(76397, 3284041984, 3284042239, 'SI', 'SVN', 'سلوفينيا'),
(76398, 3284042240, 3284042495, 'GB', 'GBR', 'المملكة المتحدة'),
(76399, 3284042496, 3284042751, 'AT', 'AUT', 'النمسا'),
(76400, 3284042752, 3284043007, 'GB', 'GBR', 'المملكة المتحدة'),
(76401, 3284043008, 3284043263, 'DE', 'DEU', 'ألمانيا'),
(76402, 3284043264, 3284043519, 'EE', 'EST', 'إستونيا'),
(76403, 3284043520, 3284043775, 'DE', 'DEU', 'ألمانيا'),
(76404, 3284043776, 3284044031, 'HR', 'HRV', 'كرواتيا'),
(76405, 3284044032, 3284044287, 'FR', 'FRA', 'فرنسا'),
(76406, 3284044288, 3284044799, 'DE', 'DEU', 'ألمانيا'),
(76407, 3284044800, 3284045055, 'CH', 'CHE', 'سويسرا'),
(76408, 3284045056, 3284045311, 'LT', 'LTU', 'ليتوانيا'),
(76409, 3284045312, 3284045567, 'DE', 'DEU', 'ألمانيا'),
(76410, 3284045568, 3284045823, 'AT', 'AUT', 'النمسا'),
(76411, 3284045824, 3284046079, 'UA', 'UKR', 'أوكرانيا'),
(76412, 3284046080, 3284046335, 'DE', 'DEU', 'ألمانيا'),
(76413, 3284046336, 3284046591, 'NL', 'NLD', 'هولندا'),
(76414, 3284046592, 3284046847, 'SE', 'SWE', 'السويد'),
(76415, 3284046848, 3284047103, 'DE', 'DEU', 'ألمانيا'),
(76416, 3284047104, 3284047359, 'DK', 'DNK', 'الدنيمارك'),
(76417, 3284047360, 3284047615, 'DE', 'DEU', 'ألمانيا'),
(76418, 3284047616, 3284047871, 'NL', 'NLD', 'هولندا'),
(76419, 3284048128, 3284048383, 'DK', 'DNK', 'الدنيمارك'),
(76420, 3284048384, 3284048639, 'GB', 'GBR', 'المملكة المتحدة'),
(76421, 3284048640, 3284049151, 'FR', 'FRA', 'فرنسا'),
(76422, 3284049152, 3284049407, 'UA', 'UKR', 'أوكرانيا'),
(76423, 3284049408, 3284049663, 'SI', 'SVN', 'سلوفينيا'),
(76424, 3284049664, 3284049919, 'RO', 'ROM', 'رومانيا'),
(76425, 3284049920, 3284058111, 'CH', 'CHE', 'سويسرا'),
(76426, 3284058112, 3284066303, 'SE', 'SWE', 'السويد'),
(76427, 3284066304, 3284075007, 'NL', 'NLD', 'هولندا'),
(76428, 3284075008, 3284075519, 'DE', 'DEU', 'ألمانيا'),
(76429, 3284075520, 3284076031, 'RU', 'RUS', 'الإتحاد الروسي'),
(76430, 3284076032, 3284076543, 'SA', 'SAU', 'السعودية'),
(76431, 3284076544, 3284077055, 'PL', 'POL', 'بولندا'),
(76432, 3284077056, 3284077567, 'RU', 'RUS', 'الإتحاد الروسي'),
(76433, 3284077568, 3284078079, 'UA', 'UKR', 'أوكرانيا'),
(76434, 3284078080, 3284078591, 'DE', 'DEU', 'ألمانيا'),
(76435, 3284078592, 3284079103, 'NL', 'NLD', 'هولندا'),
(76436, 3284079104, 3284079615, 'RU', 'RUS', 'الإتحاد الروسي'),
(76437, 3284079616, 3284080127, 'DE', 'DEU', 'ألمانيا'),
(76438, 3284080128, 3284080639, 'BE', 'BEL', 'بلجيكا'),
(76439, 3284080640, 3284081151, 'UA', 'UKR', 'أوكرانيا'),
(76440, 3284081152, 3284081663, 'CH', 'CHE', 'سويسرا'),
(76441, 3284081664, 3284082175, 'IE', 'IRL', 'إيرلندا'),
(76442, 3284082176, 3284082687, 'NO', 'NOR', 'النرويج'),
(76443, 3284082688, 3284083199, 'RU', 'RUS', 'الإتحاد الروسي'),
(76444, 3284083200, 3284083711, 'BG', 'BGR', 'بلغاريا'),
(76445, 3284083712, 3284084223, 'RU', 'RUS', 'الإتحاد الروسي'),
(76446, 3284084224, 3284084735, 'UA', 'UKR', 'أوكرانيا'),
(76447, 3284084736, 3284085247, 'RU', 'RUS', 'الإتحاد الروسي'),
(76448, 3284085248, 3284085759, 'DE', 'DEU', 'ألمانيا'),
(76449, 3284085760, 3284086783, 'RO', 'ROM', 'رومانيا'),
(76450, 3284086784, 3284087295, 'CZ', 'CZE', 'التشيك'),
(76451, 3284087296, 3284087807, 'RU', 'RUS', 'الإتحاد الروسي'),
(76452, 3284087808, 3284088319, 'IL', 'ISR', 'إسرائيل'),
(76453, 3284088320, 3284088831, 'LV', 'LVA', 'لاتفيا'),
(76454, 3284088832, 3284089855, 'UA', 'UKR', 'أوكرانيا'),
(76455, 3284089856, 3284090367, 'BG', 'BGR', 'بلغاريا'),
(76456, 3284090368, 3284090879, 'PL', 'POL', 'بولندا'),
(76457, 3284090880, 3284091391, 'RU', 'RUS', 'الإتحاد الروسي'),
(76458, 3284091392, 3284091903, 'GB', 'GBR', 'المملكة المتحدة'),
(76459, 3284091904, 3284092415, 'DE', 'DEU', 'ألمانيا'),
(76460, 3284092416, 3284092927, 'GB', 'GBR', 'المملكة المتحدة'),
(76461, 3284093440, 3284093951, 'IR', 'IRN', 'إيران'),
(76462, 3284093952, 3284094463, 'RU', 'RUS', 'الإتحاد الروسي'),
(76463, 3284094464, 3284094975, 'DK', 'DNK', 'الدنيمارك'),
(76464, 3284094976, 3284095487, 'UA', 'UKR', 'أوكرانيا'),
(76465, 3284095488, 3284095999, 'RU', 'RUS', 'الإتحاد الروسي'),
(76466, 3284096000, 3284096511, 'IT', 'ITA', 'إيطاليا'),
(76467, 3284096512, 3284097023, 'GB', 'GBR', 'المملكة المتحدة'),
(76468, 3284097024, 3284097535, 'RU', 'RUS', 'الإتحاد الروسي'),
(76469, 3284097536, 3284098047, 'UA', 'UKR', 'أوكرانيا'),
(76470, 3284098048, 3284098559, 'DE', 'DEU', 'ألمانيا'),
(76471, 3284098560, 3284099071, 'BG', 'BGR', 'بلغاريا'),
(76472, 3284099072, 3284099583, 'RO', 'ROM', 'رومانيا'),
(76473, 3284099584, 3284100095, 'GR', 'GRC', 'اليونان'),
(76474, 3284100096, 3284100607, 'AM', 'ARM', 'أرمينيا'),
(76475, 3284100608, 3284101119, 'CN', 'CHN', 'الصين'),
(76476, 3284101120, 3284101631, 'UA', 'UKR', 'أوكرانيا'),
(76477, 3284101632, 3284102143, 'GB', 'GBR', 'المملكة المتحدة'),
(76478, 3284102144, 3284102655, 'DK', 'DNK', 'الدنيمارك'),
(76479, 3284103168, 3284103679, 'NL', 'NLD', 'هولندا'),
(76480, 3284103680, 3284104191, 'DE', 'DEU', 'ألمانيا'),
(76481, 3284104192, 3284104703, 'NO', 'NOR', 'النرويج'),
(76482, 3284104704, 3284105215, 'TR', 'TUR', 'تركيا'),
(76483, 3284105216, 3284105727, 'NL', 'NLD', 'هولندا'),
(76484, 3284105728, 3284106239, 'FI', 'FIN', 'فنلندا'),
(76485, 3284106240, 3284106751, 'RO', 'ROM', 'رومانيا'),
(76486, 3284106752, 3284107263, 'UA', 'UKR', 'أوكرانيا'),
(76487, 3284107264, 3284108287, 'RU', 'RUS', 'الإتحاد الروسي'),
(76488, 3284108288, 3284108799, 'CH', 'CHE', 'سويسرا'),
(76489, 3284108800, 3284109311, 'FR', 'FRA', 'فرنسا'),
(76490, 3284109312, 3284109823, 'RU', 'RUS', 'الإتحاد الروسي'),
(76491, 3284109824, 3284110335, 'UA', 'UKR', 'أوكرانيا'),
(76492, 3284110336, 3284110847, 'RU', 'RUS', 'الإتحاد الروسي'),
(76493, 3284110848, 3284111359, 'DK', 'DNK', 'الدنيمارك'),
(76494, 3284111360, 3284111871, 'SE', 'SWE', 'السويد'),
(76495, 3284111872, 3284112383, 'RU', 'RUS', 'الإتحاد الروسي'),
(76496, 3284112384, 3284112895, 'BG', 'BGR', 'بلغاريا'),
(76497, 3284112896, 3284113919, 'NL', 'NLD', 'هولندا'),
(76498, 3284113920, 3284114431, 'AM', 'ARM', 'أرمينيا'),
(76499, 3284114432, 3284114943, 'GB', 'GBR', 'المملكة المتحدة'),
(76500, 3284114944, 3284115455, 'RU', 'RUS', 'الإتحاد الروسي'),
(76501, 3284115456, 3284115967, 'RO', 'ROM', 'رومانيا'),
(76502, 3284115968, 3284116479, 'PL', 'POL', 'بولندا'),
(76503, 3284116480, 3284116991, 'NL', 'NLD', 'هولندا'),
(76504, 3284116992, 3284117503, 'RU', 'RUS', 'الإتحاد الروسي'),
(76505, 3284117504, 3284118015, 'UA', 'UKR', 'أوكرانيا'),
(76506, 3284118016, 3284118527, 'PL', 'POL', 'بولندا'),
(76507, 3284118528, 3284119039, 'FR', 'FRA', 'فرنسا'),
(76508, 3284119040, 3284120063, 'RU', 'RUS', 'الإتحاد الروسي'),
(76509, 3284120064, 3284120575, 'UA', 'UKR', 'أوكرانيا'),
(76510, 3284120576, 3284121087, 'PL', 'POL', 'بولندا'),
(76511, 3284121088, 3284121599, 'RU', 'RUS', 'الإتحاد الروسي'),
(76512, 3284121600, 3284122111, 'PL', 'POL', 'بولندا'),
(76513, 3284122112, 3284122623, 'AM', 'ARM', 'أرمينيا'),
(76514, 3284122624, 3284123135, 'CH', 'CHE', 'سويسرا'),
(76515, 3284123136, 3284124159, 'RU', 'RUS', 'الإتحاد الروسي'),
(76516, 3284124160, 3284124671, 'UA', 'UKR', 'أوكرانيا'),
(76517, 3284124672, 3284125183, 'DE', 'DEU', 'ألمانيا'),
(76518, 3284125184, 3284125695, 'RO', 'ROM', 'رومانيا'),
(76519, 3284125696, 3284126207, 'UA', 'UKR', 'أوكرانيا'),
(76520, 3284126208, 3284127231, 'CZ', 'CZE', 'التشيك'),
(76521, 3284127232, 3284127743, 'NL', 'NLD', 'هولندا'),
(76522, 3284127744, 3284128255, 'RU', 'RUS', 'الإتحاد الروسي'),
(76523, 3284128256, 3284128767, 'GB', 'GBR', 'المملكة المتحدة'),
(76524, 3284128768, 3284129279, 'CZ', 'CZE', 'التشيك'),
(76525, 3284129280, 3284129791, 'UA', 'UKR', 'أوكرانيا'),
(76526, 3284129792, 3284130303, 'DE', 'DEU', 'ألمانيا'),
(76527, 3284130304, 3284130815, 'GB', 'GBR', 'المملكة المتحدة'),
(76528, 3284130816, 3284131327, 'RU', 'RUS', 'الإتحاد الروسي'),
(76529, 3284131328, 3284131839, 'HU', 'HUN', 'هنغاريا'),
(76530, 3284131840, 3284132351, 'DE', 'DEU', 'ألمانيا'),
(76531, 3284132352, 3284132863, 'UA', 'UKR', 'أوكرانيا'),
(76532, 3284132864, 3284133375, 'HU', 'HUN', 'هنغاريا'),
(76533, 3284133888, 3284134399, 'PL', 'POL', 'بولندا'),
(76534, 3284134400, 3284134911, 'UA', 'UKR', 'أوكرانيا'),
(76535, 3284134912, 3284135935, 'RU', 'RUS', 'الإتحاد الروسي'),
(76536, 3284135936, 3284136447, 'CH', 'CHE', 'سويسرا'),
(76537, 3284136448, 3284136959, 'RU', 'RUS', 'الإتحاد الروسي'),
(76538, 3284136960, 3284137471, 'FR', 'FRA', 'فرنسا'),
(76539, 3284137472, 3284137983, 'UA', 'UKR', 'أوكرانيا'),
(76540, 3284137984, 3284138495, 'PL', 'POL', 'بولندا'),
(76541, 3284138496, 3284139007, 'RU', 'RUS', 'الإتحاد الروسي'),
(76542, 3284139008, 3284140031, 'AT', 'AUT', 'النمسا'),
(76543, 3284140032, 3284205567, 'DK', 'DNK', 'الدنيمارك'),
(76544, 3284205568, 3284271103, 'NL', 'NLD', 'هولندا'),
(76545, 3284271104, 3284402175, 'GB', 'GBR', 'المملكة المتحدة'),
(76546, 3284402176, 3284467711, 'SE', 'SWE', 'السويد'),
(76547, 3284467712, 3284531775, 'FI', 'FIN', 'فنلندا'),
(76548, 3284531776, 3284531779, 'NL', 'NLD', 'هولندا'),
(76549, 3284531780, 3284533247, 'FI', 'FIN', 'فنلندا'),
(76550, 3284533248, 3284598783, 'SE', 'SWE', 'السويد'),
(76551, 3284598784, 3284664319, 'HU', 'HUN', 'هنغاريا'),
(76552, 3284664320, 3284672511, 'GB', 'GBR', 'المملكة المتحدة'),
(76553, 3284672512, 3284680703, 'DE', 'DEU', 'ألمانيا'),
(76554, 3284680704, 3284681215, 'UA', 'UKR', 'أوكرانيا'),
(76555, 3284681216, 3284681727, 'RO', 'ROM', 'رومانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(76556, 3284681728, 3284682239, 'FI', 'FIN', 'فنلندا'),
(76557, 3284682240, 3284682751, 'DE', 'DEU', 'ألمانيا'),
(76558, 3284682752, 3284683263, 'SE', 'SWE', 'السويد'),
(76559, 3284683264, 3284683775, 'KZ', 'KAZ', 'كازاخستان'),
(76560, 3284683776, 3284684287, 'GB', 'GBR', 'المملكة المتحدة'),
(76561, 3284684288, 3284684799, 'FR', 'FRA', 'فرنسا'),
(76562, 3284684800, 3284685311, 'DE', 'DEU', 'ألمانيا'),
(76563, 3284685312, 3284685823, 'NL', 'NLD', 'هولندا'),
(76564, 3284685824, 3284686335, 'US', 'USA', 'الولايات المتحدة'),
(76565, 3284686336, 3284686847, 'RO', 'ROM', 'رومانيا'),
(76566, 3284686848, 3284687359, 'PL', 'POL', 'بولندا'),
(76567, 3284687360, 3284687871, 'UA', 'UKR', 'أوكرانيا'),
(76568, 3284687872, 3284688383, 'NG', 'NGA', 'نيجيريا'),
(76569, 3284688384, 3284688895, 'RU', 'RUS', 'الإتحاد الروسي'),
(76570, 3284688896, 3284697087, 'FR', 'FRA', 'فرنسا'),
(76571, 3284697088, 3284705279, 'GB', 'GBR', 'المملكة المتحدة'),
(76572, 3284705280, 3284713471, 'FR', 'FRA', 'فرنسا'),
(76573, 3284713728, 3284713983, 'GR', 'GRC', 'اليونان'),
(76574, 3284713984, 3284714239, 'DE', 'DEU', 'ألمانيا'),
(76575, 3284714240, 3284714495, 'FR', 'FRA', 'فرنسا'),
(76576, 3284714496, 3284714751, 'UA', 'UKR', 'أوكرانيا'),
(76577, 3284714752, 3284715007, 'AT', 'AUT', 'النمسا'),
(76578, 3284715008, 3284715263, 'GB', 'GBR', 'المملكة المتحدة'),
(76579, 3284715264, 3284715519, 'PL', 'POL', 'بولندا'),
(76580, 3284715520, 3284715775, 'RO', 'ROM', 'رومانيا'),
(76581, 3284715776, 3284716031, 'BE', 'BEL', 'بلجيكا'),
(76582, 3284716032, 3284716287, 'IT', 'ITA', 'إيطاليا'),
(76583, 3284716288, 3284716543, 'RU', 'RUS', 'الإتحاد الروسي'),
(76584, 3284716544, 3284716799, 'GR', 'GRC', 'اليونان'),
(76585, 3284716800, 3284717055, 'IL', 'ISR', 'إسرائيل'),
(76586, 3284717056, 3284717311, 'PL', 'POL', 'بولندا'),
(76587, 3284717312, 3284717567, 'DE', 'DEU', 'ألمانيا'),
(76588, 3284717568, 3284717823, 'FR', 'FRA', 'فرنسا'),
(76589, 3284717824, 3284718079, 'RU', 'RUS', 'الإتحاد الروسي'),
(76590, 3284718080, 3284718591, 'GB', 'GBR', 'المملكة المتحدة'),
(76591, 3284718592, 3284718847, 'PL', 'POL', 'بولندا'),
(76592, 3284718848, 3284719103, 'RU', 'RUS', 'الإتحاد الروسي'),
(76593, 3284719104, 3284719359, 'PL', 'POL', 'بولندا'),
(76594, 3284719360, 3284719615, 'DE', 'DEU', 'ألمانيا'),
(76595, 3284719616, 3284719871, 'RU', 'RUS', 'الإتحاد الروسي'),
(76596, 3284719872, 3284720127, 'FR', 'FRA', 'فرنسا'),
(76597, 3284720128, 3284720383, 'CH', 'CHE', 'سويسرا'),
(76598, 3284720384, 3284720895, 'SE', 'SWE', 'السويد'),
(76599, 3284720896, 3284721151, 'UA', 'UKR', 'أوكرانيا'),
(76600, 3284721152, 3284721407, 'TR', 'TUR', 'تركيا'),
(76601, 3284721408, 3284721663, 'NL', 'NLD', 'هولندا'),
(76602, 3284721664, 3284722175, 'BE', 'BEL', 'بلجيكا'),
(76603, 3284722176, 3284722687, 'RU', 'RUS', 'الإتحاد الروسي'),
(76604, 3284722688, 3284723199, 'FR', 'FRA', 'فرنسا'),
(76605, 3284723200, 3284723711, 'GB', 'GBR', 'المملكة المتحدة'),
(76606, 3284723712, 3284724223, 'RU', 'RUS', 'الإتحاد الروسي'),
(76607, 3284724224, 3284724735, 'PL', 'POL', 'بولندا'),
(76608, 3284724736, 3284725247, 'RU', 'RUS', 'الإتحاد الروسي'),
(76609, 3284725248, 3284725759, 'GR', 'GRC', 'اليونان'),
(76610, 3284725760, 3284726271, 'LU', 'LUX', 'لوكسيمبورغ'),
(76611, 3284726272, 3284726783, 'DE', 'DEU', 'ألمانيا'),
(76612, 3284726784, 3284727295, 'UA', 'UKR', 'أوكرانيا'),
(76613, 3284727296, 3284727807, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(76614, 3284728320, 3284728831, 'UA', 'UKR', 'أوكرانيا'),
(76615, 3284728832, 3284729343, 'PT', 'PRT', 'البورتوغال'),
(76616, 3284729344, 3284729855, 'FR', 'FRA', 'فرنسا'),
(76617, 3284729856, 3284795391, 'RU', 'RUS', 'الإتحاد الروسي'),
(76618, 3284795392, 3284803583, 'FR', 'FRA', 'فرنسا'),
(76619, 3284803584, 3284811775, 'DE', 'DEU', 'ألمانيا'),
(76620, 3284819968, 3284820479, 'GB', 'GBR', 'المملكة المتحدة'),
(76621, 3284820480, 3284820495, 'DE', 'DEU', 'ألمانيا'),
(76622, 3284820496, 3284822527, 'GB', 'GBR', 'المملكة المتحدة'),
(76623, 3284822528, 3284822783, 'DE', 'DEU', 'ألمانيا'),
(76624, 3284822784, 3284823519, 'GB', 'GBR', 'المملكة المتحدة'),
(76625, 3284823520, 3284823527, 'DE', 'DEU', 'ألمانيا'),
(76626, 3284823528, 3284825343, 'GB', 'GBR', 'المملكة المتحدة'),
(76627, 3284825344, 3284825359, 'DE', 'DEU', 'ألمانيا'),
(76628, 3284825360, 3284825423, 'GB', 'GBR', 'المملكة المتحدة'),
(76629, 3284825424, 3284825439, 'DE', 'DEU', 'ألمانيا'),
(76630, 3284825440, 3284828159, 'GB', 'GBR', 'المملكة المتحدة'),
(76631, 3284828160, 3284844543, 'AT', 'AUT', 'النمسا'),
(76632, 3284844544, 3284860927, 'CH', 'CHE', 'سويسرا'),
(76633, 3284860928, 3284863743, 'DE', 'DEU', 'ألمانيا'),
(76634, 3284863744, 3284863999, 'FR', 'FRA', 'فرنسا'),
(76635, 3284864000, 3284868863, 'DE', 'DEU', 'ألمانيا'),
(76636, 3284868864, 3284869375, 'FR', 'FRA', 'فرنسا'),
(76637, 3284869376, 3284869631, 'DE', 'DEU', 'ألمانيا'),
(76638, 3284869632, 3284869887, 'IT', 'ITA', 'إيطاليا'),
(76639, 3284869888, 3284872959, 'DE', 'DEU', 'ألمانيا'),
(76640, 3284872960, 3284873471, 'IT', 'ITA', 'إيطاليا'),
(76641, 3284873472, 3284926463, 'DE', 'DEU', 'ألمانيا'),
(76642, 3284926464, 3284991999, 'NO', 'NOR', 'النرويج'),
(76643, 3284992000, 3285057535, 'PL', 'POL', 'بولندا'),
(76644, 3285057536, 3285065727, 'IT', 'ITA', 'إيطاليا'),
(76645, 3285065728, 3285073919, 'RU', 'RUS', 'الإتحاد الروسي'),
(76646, 3285073920, 3285074687, 'GB', 'GBR', 'المملكة المتحدة'),
(76647, 3285074688, 3285076607, 'NL', 'NLD', 'هولندا'),
(76648, 3285076608, 3285076767, 'BE', 'BEL', 'بلجيكا'),
(76649, 3285076768, 3285078111, 'NL', 'NLD', 'هولندا'),
(76650, 3285078112, 3285078143, 'GB', 'GBR', 'المملكة المتحدة'),
(76651, 3285078144, 3285078175, 'NL', 'NLD', 'هولندا'),
(76652, 3285078176, 3285078191, 'GB', 'GBR', 'المملكة المتحدة'),
(76653, 3285078192, 3285079423, 'NL', 'NLD', 'هولندا'),
(76654, 3285079424, 3285079551, 'DE', 'DEU', 'ألمانيا'),
(76655, 3285079552, 3285079967, 'NL', 'NLD', 'هولندا'),
(76656, 3285079968, 3285079999, 'DE', 'DEU', 'ألمانيا'),
(76657, 3285080000, 3285082111, 'NL', 'NLD', 'هولندا'),
(76658, 3285082112, 3285084159, 'AT', 'AUT', 'النمسا'),
(76659, 3285084160, 3285085183, 'LU', 'LUX', 'لوكسيمبورغ'),
(76660, 3285085184, 3285086207, 'GB', 'GBR', 'المملكة المتحدة'),
(76661, 3285086208, 3285088255, 'PL', 'POL', 'بولندا'),
(76662, 3285088256, 3285089279, 'RU', 'RUS', 'الإتحاد الروسي'),
(76663, 3285089280, 3285090303, 'PL', 'POL', 'بولندا'),
(76664, 3285090304, 3285098495, 'DE', 'DEU', 'ألمانيا'),
(76665, 3285098496, 3285114879, 'GB', 'GBR', 'المملكة المتحدة'),
(76666, 3285123072, 3285158639, 'BE', 'BEL', 'بلجيكا'),
(76667, 3285158640, 3285158647, 'FR', 'FRA', 'فرنسا'),
(76668, 3285158648, 3285164367, 'BE', 'BEL', 'بلجيكا'),
(76669, 3285164368, 3285164375, 'NL', 'NLD', 'هولندا'),
(76670, 3285164376, 3285188607, 'BE', 'BEL', 'بلجيكا'),
(76671, 3285188608, 3285265999, 'RU', 'RUS', 'الإتحاد الروسي'),
(76672, 3285266000, 3285266007, 'CH', 'CHE', 'سويسرا'),
(76673, 3285266008, 3285319679, 'RU', 'RUS', 'الإتحاد الروسي'),
(76674, 3285327872, 3285328383, 'RU', 'RUS', 'الإتحاد الروسي'),
(76675, 3285328384, 3285328895, 'PL', 'POL', 'بولندا'),
(76676, 3285328896, 3285329407, 'SE', 'SWE', 'السويد'),
(76677, 3285329408, 3285329919, 'GB', 'GBR', 'المملكة المتحدة'),
(76678, 3285329920, 3285330431, 'RO', 'ROM', 'رومانيا'),
(76679, 3285330432, 3285330943, 'FR', 'FRA', 'فرنسا'),
(76680, 3285330944, 3285331455, 'RO', 'ROM', 'رومانيا'),
(76681, 3285331456, 3285331967, 'KZ', 'KAZ', 'كازاخستان'),
(76682, 3285331968, 3285332991, 'DE', 'DEU', 'ألمانيا'),
(76683, 3285332992, 3285333503, 'SE', 'SWE', 'السويد'),
(76684, 3285333504, 3285334015, 'GB', 'GBR', 'المملكة المتحدة'),
(76685, 3285334016, 3285334527, 'NL', 'NLD', 'هولندا'),
(76686, 3285334528, 3285335551, 'DE', 'DEU', 'ألمانيا'),
(76687, 3285335552, 3285336063, 'SE', 'SWE', 'السويد'),
(76688, 3285336064, 3285352447, 'IT', 'ITA', 'إيطاليا'),
(76689, 3285352448, 3285368831, 'RU', 'RUS', 'الإتحاد الروسي'),
(76690, 3285368832, 3285385215, 'SI', 'SVN', 'سلوفينيا'),
(76691, 3285385216, 3285386239, 'PL', 'POL', 'بولندا'),
(76692, 3285386240, 3285387263, 'RU', 'RUS', 'الإتحاد الروسي'),
(76693, 3285387264, 3285388287, 'PL', 'POL', 'بولندا'),
(76694, 3285388288, 3285389311, 'CH', 'CHE', 'سويسرا'),
(76695, 3285389312, 3285390335, 'FI', 'FIN', 'فنلندا'),
(76696, 3285390336, 3285391359, 'RU', 'RUS', 'الإتحاد الروسي'),
(76697, 3285391360, 3285392383, 'AM', 'ARM', 'أرمينيا'),
(76698, 3285392384, 3285393407, 'RU', 'RUS', 'الإتحاد الروسي'),
(76699, 3285393408, 3285394431, 'AT', 'AUT', 'النمسا'),
(76700, 3285394432, 3285396479, 'RU', 'RUS', 'الإتحاد الروسي'),
(76701, 3285396480, 3285397503, 'IR', 'IRN', 'إيران'),
(76702, 3285397504, 3285398527, 'NL', 'NLD', 'هولندا'),
(76703, 3285398528, 3285399551, 'RU', 'RUS', 'الإتحاد الروسي'),
(76704, 3285399552, 3285400575, 'NL', 'NLD', 'هولندا'),
(76705, 3285400576, 3285401599, 'UA', 'UKR', 'أوكرانيا'),
(76706, 3285401600, 3285402623, 'RU', 'RUS', 'الإتحاد الروسي'),
(76707, 3285402624, 3285403647, 'IL', 'ISR', 'إسرائيل'),
(76708, 3285403648, 3285404671, 'NL', 'NLD', 'هولندا'),
(76709, 3285404672, 3285406719, 'RU', 'RUS', 'الإتحاد الروسي'),
(76710, 3285406720, 3285407743, 'UA', 'UKR', 'أوكرانيا'),
(76711, 3285407744, 3285408767, 'RU', 'RUS', 'الإتحاد الروسي'),
(76712, 3285408768, 3285409791, 'GB', 'GBR', 'المملكة المتحدة'),
(76713, 3285409792, 3285410815, 'UA', 'UKR', 'أوكرانيا'),
(76714, 3285410816, 3285412863, 'RU', 'RUS', 'الإتحاد الروسي'),
(76715, 3285412864, 3285413887, 'UA', 'UKR', 'أوكرانيا'),
(76716, 3285413888, 3285414911, 'RU', 'RUS', 'الإتحاد الروسي'),
(76717, 3285414912, 3285415935, 'UA', 'UKR', 'أوكرانيا'),
(76718, 3285415936, 3285419007, 'RU', 'RUS', 'الإتحاد الروسي'),
(76719, 3285419008, 3285420031, 'SE', 'SWE', 'السويد'),
(76720, 3285420032, 3285424127, 'UA', 'UKR', 'أوكرانيا'),
(76721, 3285424128, 3285425151, 'RO', 'ROM', 'رومانيا'),
(76722, 3285425152, 3285427199, 'UA', 'UKR', 'أوكرانيا'),
(76723, 3285427200, 3285428223, 'GB', 'GBR', 'المملكة المتحدة'),
(76724, 3285428224, 3285429247, 'RU', 'RUS', 'الإتحاد الروسي'),
(76725, 3285429248, 3285430271, 'UA', 'UKR', 'أوكرانيا'),
(76726, 3285430272, 3285431295, 'DK', 'DNK', 'الدنيمارك'),
(76727, 3285431296, 3285432319, 'UZ', 'UZB', 'أوزباكستان'),
(76728, 3285432320, 3285434367, 'UA', 'UKR', 'أوكرانيا'),
(76729, 3285434368, 3285436415, 'RU', 'RUS', 'الإتحاد الروسي'),
(76730, 3285436416, 3285437439, 'GR', 'GRC', 'اليونان'),
(76731, 3285437440, 3285438463, 'RU', 'RUS', 'الإتحاد الروسي'),
(76732, 3285438464, 3285440511, 'UA', 'UKR', 'أوكرانيا'),
(76733, 3285440512, 3285442559, 'RU', 'RUS', 'الإتحاد الروسي'),
(76734, 3285442560, 3285443583, 'IE', 'IRL', 'إيرلندا'),
(76735, 3285443584, 3285444607, 'UA', 'UKR', 'أوكرانيا'),
(76736, 3285444608, 3285446655, 'RU', 'RUS', 'الإتحاد الروسي'),
(76737, 3285446656, 3285447679, 'UA', 'UKR', 'أوكرانيا'),
(76738, 3285447680, 3285449727, 'RU', 'RUS', 'الإتحاد الروسي'),
(76739, 3285449728, 3285450751, 'UA', 'UKR', 'أوكرانيا'),
(76740, 3285450752, 3285453055, 'GB', 'GBR', 'المملكة المتحدة'),
(76741, 3285453120, 3285453415, 'GB', 'GBR', 'المملكة المتحدة'),
(76742, 3285453424, 3285453439, 'GB', 'GBR', 'المملكة المتحدة'),
(76743, 3285453568, 3285453623, 'GB', 'GBR', 'المملكة المتحدة'),
(76744, 3285453632, 3285454047, 'GB', 'GBR', 'المملكة المتحدة'),
(76745, 3285454080, 3285454175, 'GB', 'GBR', 'المملكة المتحدة'),
(76746, 3285454208, 3285454847, 'GB', 'GBR', 'المملكة المتحدة'),
(76747, 3285454848, 3285455695, 'DE', 'DEU', 'ألمانيا'),
(76748, 3285455712, 3285455743, 'DE', 'DEU', 'ألمانيا'),
(76749, 3285455872, 3285455887, 'DE', 'DEU', 'ألمانيا'),
(76750, 3285455896, 3285455903, 'GB', 'GBR', 'المملكة المتحدة'),
(76751, 3285455936, 3285456015, 'DE', 'DEU', 'ألمانيا'),
(76752, 3285456032, 3285456255, 'DE', 'DEU', 'ألمانيا'),
(76753, 3285456288, 3285456351, 'DE', 'DEU', 'ألمانيا'),
(76754, 3285456384, 3285456639, 'DE', 'DEU', 'ألمانيا'),
(76755, 3285456640, 3285456703, 'DK', 'DNK', 'الدنيمارك'),
(76756, 3285456720, 3285456743, 'DK', 'DNK', 'الدنيمارك'),
(76757, 3285456760, 3285456871, 'DK', 'DNK', 'الدنيمارك'),
(76758, 3285456880, 3285456895, 'DK', 'DNK', 'الدنيمارك'),
(76759, 3285456896, 3285456959, 'GB', 'GBR', 'المملكة المتحدة'),
(76760, 3285456976, 3285457023, 'GB', 'GBR', 'المملكة المتحدة'),
(76761, 3285457056, 3285457151, 'GB', 'GBR', 'المملكة المتحدة'),
(76762, 3285457152, 3285457183, 'SE', 'SWE', 'السويد'),
(76763, 3285457232, 3285457247, 'SE', 'SWE', 'السويد'),
(76764, 3285457280, 3285457407, 'SE', 'SWE', 'السويد'),
(76765, 3285457408, 3285457663, 'GB', 'GBR', 'المملكة المتحدة'),
(76766, 3285457664, 3285457759, 'IT', 'ITA', 'إيطاليا'),
(76767, 3285457792, 3285457919, 'IT', 'ITA', 'إيطاليا'),
(76768, 3285457920, 3285457951, 'GB', 'GBR', 'المملكة المتحدة'),
(76769, 3285457984, 3285458031, 'GB', 'GBR', 'المملكة المتحدة'),
(76770, 3285458040, 3285458111, 'GB', 'GBR', 'المملكة المتحدة'),
(76771, 3285458176, 3285458943, 'GB', 'GBR', 'المملكة المتحدة'),
(76772, 3285458944, 3285459071, 'DK', 'DNK', 'الدنيمارك'),
(76773, 3285459104, 3285459327, 'DK', 'DNK', 'الدنيمارك'),
(76774, 3285459392, 3285459535, 'DK', 'DNK', 'الدنيمارك'),
(76775, 3285459544, 3285459711, 'DK', 'DNK', 'الدنيمارك'),
(76776, 3285459712, 3285459967, 'NO', 'NOR', 'النرويج'),
(76777, 3285459968, 3285460479, 'FI', 'FIN', 'فنلندا'),
(76778, 3285460480, 3285460991, 'DK', 'DNK', 'الدنيمارك'),
(76779, 3285460992, 3285461007, 'NL', 'NLD', 'هولندا'),
(76780, 3285461056, 3285461111, 'NL', 'NLD', 'هولندا'),
(76781, 3285461120, 3285461263, 'NL', 'NLD', 'هولندا'),
(76782, 3285461264, 3285461279, 'BE', 'BEL', 'بلجيكا'),
(76783, 3285461312, 3285461375, 'CH', 'CHE', 'سويسرا'),
(76784, 3285461376, 3285461447, 'NL', 'NLD', 'هولندا'),
(76785, 3285461448, 3285461455, 'DE', 'DEU', 'ألمانيا'),
(76786, 3285461456, 3285461503, 'NL', 'NLD', 'هولندا'),
(76787, 3285461528, 3285461535, 'NL', 'NLD', 'هولندا'),
(76788, 3285461568, 3285461807, 'NL', 'NLD', 'هولندا'),
(76789, 3285461856, 3285461877, 'NL', 'NLD', 'هولندا'),
(76790, 3285461880, 3285461991, 'NL', 'NLD', 'هولندا'),
(76791, 3285461992, 3285461999, 'GB', 'GBR', 'المملكة المتحدة'),
(76792, 3285462000, 3285462007, 'NL', 'NLD', 'هولندا'),
(76793, 3285462016, 3285462175, 'DE', 'DEU', 'ألمانيا'),
(76794, 3285462192, 3285462207, 'DE', 'DEU', 'ألمانيا'),
(76795, 3285462208, 3285462223, 'GB', 'GBR', 'المملكة المتحدة'),
(76796, 3285462224, 3285462367, 'DE', 'DEU', 'ألمانيا'),
(76797, 3285462400, 3285462527, 'DE', 'DEU', 'ألمانيا'),
(76798, 3285462544, 3285462655, 'DE', 'DEU', 'ألمانيا'),
(76799, 3285462784, 3285462831, 'AT', 'AUT', 'النمسا'),
(76800, 3285462840, 3285462847, 'AT', 'AUT', 'النمسا'),
(76801, 3285462880, 3285462911, 'AT', 'AUT', 'النمسا'),
(76802, 3285462952, 3285462959, 'AT', 'AUT', 'النمسا'),
(76803, 3285463008, 3285463039, 'AT', 'AUT', 'النمسا'),
(76804, 3285463040, 3285463079, 'LU', 'LUX', 'لوكسيمبورغ'),
(76805, 3285463104, 3285463135, 'LU', 'LUX', 'لوكسيمبورغ'),
(76806, 3285463296, 3285463311, 'FR', 'FRA', 'فرنسا'),
(76807, 3285463312, 3285463319, 'BE', 'BEL', 'بلجيكا'),
(76808, 3285463320, 3285463327, 'FR', 'FRA', 'فرنسا'),
(76809, 3285463360, 3285463455, 'BE', 'BEL', 'بلجيكا'),
(76810, 3285463520, 3285463615, 'BE', 'BEL', 'بلجيكا'),
(76811, 3285463616, 3285463647, 'FR', 'FRA', 'فرنسا'),
(76812, 3285463664, 3285463759, 'BE', 'BEL', 'بلجيكا'),
(76813, 3285463776, 3285463839, 'BE', 'BEL', 'بلجيكا'),
(76814, 3285463856, 3285463991, 'BE', 'BEL', 'بلجيكا'),
(76815, 3285464016, 3285464063, 'BE', 'BEL', 'بلجيكا'),
(76816, 3285464072, 3285464095, 'BE', 'BEL', 'بلجيكا'),
(76817, 3285464096, 3285464127, 'GB', 'GBR', 'المملكة المتحدة'),
(76818, 3285464320, 3285464351, 'BE', 'BEL', 'بلجيكا'),
(76819, 3285464360, 3285464383, 'BE', 'BEL', 'بلجيكا'),
(76820, 3285464384, 3285464415, 'GB', 'GBR', 'المملكة المتحدة'),
(76821, 3285464416, 3285464431, 'BE', 'BEL', 'بلجيكا'),
(76822, 3285464432, 3285464447, 'DE', 'DEU', 'ألمانيا'),
(76823, 3285464448, 3285465087, 'BE', 'BEL', 'بلجيكا'),
(76824, 3285465088, 3285465103, 'DK', 'DNK', 'الدنيمارك'),
(76825, 3285465152, 3285465231, 'DK', 'DNK', 'الدنيمارك'),
(76826, 3285465248, 3285465343, 'DK', 'DNK', 'الدنيمارك'),
(76827, 3285465664, 3285465727, 'DE', 'DEU', 'ألمانيا'),
(76828, 3285465856, 3285466367, 'DE', 'DEU', 'ألمانيا'),
(76829, 3285466368, 3285466447, 'CH', 'CHE', 'سويسرا'),
(76830, 3285466456, 3285466463, 'CH', 'CHE', 'سويسرا'),
(76831, 3285466528, 3285466559, 'CH', 'CHE', 'سويسرا'),
(76832, 3285466624, 3285466879, 'AT', 'AUT', 'النمسا'),
(76833, 3285466880, 3285466895, 'BG', 'BGR', 'بلغاريا'),
(76834, 3285466912, 3285466943, 'BG', 'BGR', 'بلغاريا'),
(76835, 3285466952, 3285466959, 'BG', 'BGR', 'بلغاريا'),
(76836, 3285466984, 3285467007, 'BG', 'BGR', 'بلغاريا'),
(76837, 3285467016, 3285467023, 'BG', 'BGR', 'بلغاريا'),
(76838, 3285467136, 3285467391, 'DE', 'DEU', 'ألمانيا'),
(76839, 3285467664, 3285467679, 'DE', 'DEU', 'ألمانيا'),
(76840, 3285467832, 3285467839, 'DE', 'DEU', 'ألمانيا'),
(76841, 3285467936, 3285467951, 'DE', 'DEU', 'ألمانيا'),
(76842, 3285467952, 3285467959, 'GB', 'GBR', 'المملكة المتحدة'),
(76843, 3285467968, 3285468511, 'DE', 'DEU', 'ألمانيا'),
(76844, 3285468576, 3285468591, 'DE', 'DEU', 'ألمانيا'),
(76845, 3285468600, 3285468615, 'DE', 'DEU', 'ألمانيا'),
(76846, 3285468616, 3285468623, 'GB', 'GBR', 'المملكة المتحدة'),
(76847, 3285468656, 3285471007, 'DE', 'DEU', 'ألمانيا'),
(76848, 3285471040, 3285471055, 'DE', 'DEU', 'ألمانيا'),
(76849, 3285471104, 3285471743, 'DE', 'DEU', 'ألمانيا'),
(76850, 3285471808, 3285471871, 'DE', 'DEU', 'ألمانيا'),
(76851, 3285471936, 3285471967, 'DE', 'DEU', 'ألمانيا'),
(76852, 3285472000, 3285472127, 'DE', 'DEU', 'ألمانيا'),
(76853, 3285472160, 3285472175, 'DE', 'DEU', 'ألمانيا'),
(76854, 3285472192, 3285472223, 'DE', 'DEU', 'ألمانيا'),
(76855, 3285472256, 3285472287, 'DE', 'DEU', 'ألمانيا'),
(76856, 3285472368, 3285472511, 'DE', 'DEU', 'ألمانيا'),
(76857, 3285473328, 3285473343, 'DE', 'DEU', 'ألمانيا'),
(76858, 3285473440, 3285473527, 'DE', 'DEU', 'ألمانيا'),
(76859, 3285473536, 3285473567, 'DE', 'DEU', 'ألمانيا'),
(76860, 3285473584, 3285473591, 'GB', 'GBR', 'المملكة المتحدة'),
(76861, 3285473592, 3285473599, 'DE', 'DEU', 'ألمانيا'),
(76862, 3285473632, 3285473663, 'DE', 'DEU', 'ألمانيا'),
(76863, 3285473792, 3285474047, 'DE', 'DEU', 'ألمانيا'),
(76864, 3285474080, 3285474095, 'DE', 'DEU', 'ألمانيا'),
(76865, 3285474176, 3285474231, 'DE', 'DEU', 'ألمانيا'),
(76866, 3285474240, 3285474271, 'DE', 'DEU', 'ألمانيا'),
(76867, 3285474304, 3285474319, 'DE', 'DEU', 'ألمانيا'),
(76868, 3285474336, 3285474559, 'DE', 'DEU', 'ألمانيا'),
(76869, 3285475072, 3285475127, 'DE', 'DEU', 'ألمانيا'),
(76870, 3285475144, 3285475167, 'DE', 'DEU', 'ألمانيا'),
(76871, 3285475200, 3285475207, 'DE', 'DEU', 'ألمانيا'),
(76872, 3285475232, 3285475327, 'DE', 'DEU', 'ألمانيا'),
(76873, 3285475624, 3285475647, 'AT', 'AUT', 'النمسا'),
(76874, 3285475680, 3285475711, 'AT', 'AUT', 'النمسا'),
(76875, 3285475776, 3285475783, 'AT', 'AUT', 'النمسا'),
(76876, 3285475808, 3285475823, 'AT', 'AUT', 'النمسا'),
(76877, 3285475904, 3285475951, 'AT', 'AUT', 'النمسا'),
(76878, 3285475968, 3285476095, 'AT', 'AUT', 'النمسا'),
(76879, 3285476352, 3285476607, 'DE', 'DEU', 'ألمانيا'),
(76880, 3285476736, 3285476863, 'GB', 'GBR', 'المملكة المتحدة'),
(76881, 3285476864, 3285476895, 'AT', 'AUT', 'النمسا'),
(76882, 3285477024, 3285477087, 'AT', 'AUT', 'النمسا'),
(76883, 3285477152, 3285477247, 'IT', 'ITA', 'إيطاليا'),
(76884, 3285477256, 3285477263, 'IT', 'ITA', 'إيطاليا'),
(76885, 3285477280, 3285477319, 'IT', 'ITA', 'إيطاليا'),
(76886, 3285477336, 3285477343, 'IT', 'ITA', 'إيطاليا'),
(76887, 3285477360, 3285477375, 'IT', 'ITA', 'إيطاليا'),
(76888, 3285477376, 3285477631, 'FR', 'FRA', 'فرنسا'),
(76889, 3285477888, 3285477919, 'FR', 'FRA', 'فرنسا'),
(76890, 3285477952, 3285477983, 'FR', 'FRA', 'فرنسا'),
(76891, 3285478000, 3285478655, 'FR', 'FRA', 'فرنسا'),
(76892, 3285478912, 3285479391, 'FR', 'FRA', 'فرنسا'),
(76893, 3285479400, 3285479407, 'GB', 'GBR', 'المملكة المتحدة'),
(76894, 3285479424, 3285479807, 'CH', 'CHE', 'سويسرا'),
(76895, 3285480448, 3285480575, 'CH', 'CHE', 'سويسرا'),
(76896, 3285480704, 3285480719, 'CH', 'CHE', 'سويسرا'),
(76897, 3285480736, 3285480767, 'CH', 'CHE', 'سويسرا'),
(76898, 3285480776, 3285480895, 'CH', 'CHE', 'سويسرا'),
(76899, 3285480960, 3285481215, 'CH', 'CHE', 'سويسرا'),
(76900, 3285481472, 3285481727, 'IT', 'ITA', 'إيطاليا'),
(76901, 3285481728, 3285481791, 'CH', 'CHE', 'سويسرا'),
(76902, 3285481984, 3285481999, 'FR', 'FRA', 'فرنسا'),
(76903, 3285482000, 3285482007, 'CY', 'CYP', 'قبرص'),
(76904, 3285482016, 3285482087, 'FR', 'FRA', 'فرنسا'),
(76905, 3285482096, 3285482239, 'FR', 'FRA', 'فرنسا'),
(76906, 3285482496, 3285482527, 'CH', 'CHE', 'سويسرا'),
(76907, 3285482752, 3285482783, 'CH', 'CHE', 'سويسرا'),
(76908, 3285483008, 3285483519, 'CH', 'CHE', 'سويسرا'),
(76909, 3285484544, 3285485055, 'IE', 'IRL', 'إيرلندا'),
(76910, 3285485104, 3285485119, 'SK', 'SVK', 'سلوفاكيا'),
(76911, 3285485640, 3285485647, 'SK', 'SVK', 'سلوفاكيا'),
(76912, 3285485728, 3285485743, 'SK', 'SVK', 'سلوفاكيا'),
(76913, 3285485800, 3285485815, 'SK', 'SVK', 'سلوفاكيا'),
(76914, 3285486592, 3285487103, 'IT', 'ITA', 'إيطاليا'),
(76915, 3285487104, 3285487359, 'HU', 'HUN', 'هنغاريا'),
(76916, 3285487360, 3285487423, 'NL', 'NLD', 'هولندا'),
(76917, 3285487424, 3285487487, 'GB', 'GBR', 'المملكة المتحدة'),
(76918, 3285487488, 3285487679, 'NL', 'NLD', 'هولندا'),
(76919, 3285487744, 3285488127, 'NL', 'NLD', 'هولندا'),
(76920, 3285488896, 3285489663, 'GB', 'GBR', 'المملكة المتحدة'),
(76921, 3285490176, 3285490319, 'RU', 'RUS', 'الإتحاد الروسي'),
(76922, 3285490336, 3285490463, 'RU', 'RUS', 'الإتحاد الروسي'),
(76923, 3285490496, 3285490511, 'RU', 'RUS', 'الإتحاد الروسي'),
(76924, 3285490520, 3285490527, 'LT', 'LTU', 'ليتوانيا'),
(76925, 3285490528, 3285490535, 'LV', 'LVA', 'لاتفيا'),
(76926, 3285490536, 3285490543, 'RU', 'RUS', 'الإتحاد الروسي'),
(76927, 3285490560, 3285490687, 'RU', 'RUS', 'الإتحاد الروسي'),
(76928, 3285490944, 3285491007, 'RU', 'RUS', 'الإتحاد الروسي'),
(76929, 3285491456, 3285491711, 'RU', 'RUS', 'الإتحاد الروسي'),
(76930, 3285492224, 3285492479, 'FR', 'FRA', 'فرنسا'),
(76931, 3285492480, 3285492687, 'GB', 'GBR', 'المملكة المتحدة'),
(76932, 3285492696, 3285492735, 'GB', 'GBR', 'المملكة المتحدة'),
(76933, 3285493760, 3285493775, 'ES', 'ESP', 'إسبانيا'),
(76934, 3285493784, 3285493791, 'ES', 'ESP', 'إسبانيا'),
(76935, 3285493808, 3285493887, 'ES', 'ESP', 'إسبانيا'),
(76936, 3285493968, 3285493983, 'ES', 'ESP', 'إسبانيا'),
(76937, 3285493984, 3285493991, 'GB', 'GBR', 'المملكة المتحدة'),
(76938, 3285494000, 3285494015, 'ES', 'ESP', 'إسبانيا'),
(76939, 3285494016, 3285494079, 'IT', 'ITA', 'إيطاليا'),
(76940, 3285494112, 3285494783, 'IT', 'ITA', 'إيطاليا'),
(76941, 3285495808, 3285496319, 'DE', 'DEU', 'ألمانيا'),
(76942, 3285496320, 3285496335, 'ES', 'ESP', 'إسبانيا'),
(76943, 3285496352, 3285496383, 'ES', 'ESP', 'إسبانيا'),
(76944, 3285496464, 3285496471, 'ES', 'ESP', 'إسبانيا'),
(76945, 3285496480, 3285496495, 'ES', 'ESP', 'إسبانيا'),
(76946, 3285496496, 3285496527, 'FR', 'FRA', 'فرنسا'),
(76947, 3285496544, 3285496575, 'FR', 'FRA', 'فرنسا'),
(76948, 3285496576, 3285496607, 'GB', 'GBR', 'المملكة المتحدة'),
(76949, 3285496608, 3285496815, 'DE', 'DEU', 'ألمانيا'),
(76950, 3285496832, 3285497855, 'DE', 'DEU', 'ألمانيا'),
(76951, 3285497888, 3285498031, 'DE', 'DEU', 'ألمانيا'),
(76952, 3285498096, 3285498111, 'DE', 'DEU', 'ألمانيا'),
(76953, 3285498112, 3285498367, 'IT', 'ITA', 'إيطاليا'),
(76954, 3285498368, 3285498623, 'DE', 'DEU', 'ألمانيا'),
(76955, 3285498624, 3285498655, 'CH', 'CHE', 'سويسرا'),
(76956, 3285498656, 3285498663, 'CY', 'CYP', 'قبرص'),
(76957, 3285498672, 3285498687, 'CH', 'CHE', 'سويسرا'),
(76958, 3285499392, 3285499455, 'FR', 'FRA', 'فرنسا'),
(76959, 3285499488, 3285499647, 'FR', 'FRA', 'فرنسا'),
(76960, 3285499648, 3285499903, 'DE', 'DEU', 'ألمانيا'),
(76961, 3285499904, 3285500159, 'CZ', 'CZE', 'التشيك'),
(76962, 3285500288, 3285500415, 'CZ', 'CZE', 'التشيك'),
(76963, 3285500416, 3285500927, 'GB', 'GBR', 'المملكة المتحدة'),
(76964, 3285500928, 3285501183, 'DK', 'DNK', 'الدنيمارك'),
(76965, 3285501184, 3285501311, 'CZ', 'CZE', 'التشيك'),
(76966, 3285501320, 3285501327, 'CZ', 'CZE', 'التشيك'),
(76967, 3285501336, 3285501343, 'CZ', 'CZE', 'التشيك'),
(76968, 3285501344, 3285501375, 'GB', 'GBR', 'المملكة المتحدة'),
(76969, 3285501376, 3285501407, 'CZ', 'CZE', 'التشيك'),
(76970, 3285501440, 3285501567, 'CZ', 'CZE', 'التشيك'),
(76971, 3285501728, 3285501759, 'GB', 'GBR', 'المملكة المتحدة'),
(76972, 3285501760, 3285501767, 'CZ', 'CZE', 'التشيك'),
(76973, 3285502208, 3285502463, 'CZ', 'CZE', 'التشيك'),
(76974, 3285502464, 3285502495, 'IL', 'ISR', 'إسرائيل'),
(76975, 3285502496, 3285502503, 'CY', 'CYP', 'قبرص'),
(76976, 3285502504, 3285502511, 'IL', 'ISR', 'إسرائيل'),
(76977, 3285502512, 3285502527, 'CY', 'CYP', 'قبرص'),
(76978, 3285502528, 3285502591, 'BY', 'BLR', 'روسيا البيضاء'),
(76979, 3285502592, 3285502655, 'GB', 'GBR', 'المملكة المتحدة'),
(76980, 3285502656, 3285502719, 'IL', 'ISR', 'إسرائيل'),
(76981, 3285503392, 3285503423, 'CZ', 'CZE', 'التشيك'),
(76982, 3285503488, 3285503551, 'ES', 'ESP', 'إسبانيا'),
(76983, 3285503744, 3285503999, 'FI', 'FIN', 'فنلندا'),
(76984, 3285504512, 3285504607, 'CZ', 'CZE', 'التشيك'),
(76985, 3285505216, 3285505279, 'CZ', 'CZE', 'التشيك'),
(76986, 3285505440, 3285505471, 'CZ', 'CZE', 'التشيك'),
(76987, 3285506048, 3285506079, 'CZ', 'CZE', 'التشيك'),
(76988, 3285507328, 3285507391, 'GR', 'GRC', 'اليونان'),
(76989, 3285507664, 3285507711, 'CZ', 'CZE', 'التشيك'),
(76990, 3285507840, 3285508095, 'CZ', 'CZE', 'التشيك'),
(76991, 3285508096, 3285508607, 'DE', 'DEU', 'ألمانيا'),
(76992, 3285508608, 3285508623, 'RU', 'RUS', 'الإتحاد الروسي'),
(76993, 3285508640, 3285508671, 'RU', 'RUS', 'الإتحاد الروسي'),
(76994, 3285508736, 3285508863, 'RU', 'RUS', 'الإتحاد الروسي'),
(76995, 3285508872, 3285508927, 'PT', 'PRT', 'البورتوغال'),
(76996, 3285509120, 3285509247, 'SE', 'SWE', 'السويد'),
(76997, 3285509280, 3285509311, 'SE', 'SWE', 'السويد'),
(76998, 3285509632, 3285509887, 'TR', 'TUR', 'تركيا'),
(76999, 3285510016, 3285510047, 'HU', 'HUN', 'هنغاريا'),
(77000, 3285510080, 3285510143, 'HU', 'HUN', 'هنغاريا'),
(77001, 3285510144, 3285512191, 'GB', 'GBR', 'المملكة المتحدة'),
(77002, 3285512192, 3285512511, 'GR', 'GRC', 'اليونان'),
(77003, 3285512576, 3285512719, 'GR', 'GRC', 'اليونان'),
(77004, 3285512768, 3285512831, 'GR', 'GRC', 'اليونان'),
(77005, 3285513216, 3285513223, 'GB', 'GBR', 'المملكة المتحدة'),
(77006, 3285513232, 3285513247, 'GR', 'GRC', 'اليونان'),
(77007, 3285513280, 3285513343, 'GR', 'GRC', 'اليونان'),
(77008, 3285513728, 3285514239, 'GR', 'GRC', 'اليونان'),
(77009, 3285515264, 3285515519, 'AT', 'AUT', 'النمسا'),
(77010, 3285515792, 3285515803, 'GR', 'GRC', 'اليونان'),
(77011, 3285516160, 3285516191, 'GR', 'GRC', 'اليونان'),
(77012, 3285516224, 3285516287, 'GR', 'GRC', 'اليونان'),
(77013, 3285516288, 3285516543, 'DK', 'DNK', 'الدنيمارك'),
(77014, 3285516544, 3285516671, 'NO', 'NOR', 'النرويج'),
(77015, 3285516672, 3285516687, 'BE', 'BEL', 'بلجيكا'),
(77016, 3285516688, 3285516691, 'NL', 'NLD', 'هولندا'),
(77017, 3285516692, 3285516695, 'IT', 'ITA', 'إيطاليا'),
(77018, 3285516696, 3285516703, 'NL', 'NLD', 'هولندا'),
(77019, 3285516704, 3285516719, 'GB', 'GBR', 'المملكة المتحدة'),
(77020, 3285516720, 3285516735, 'IL', 'ISR', 'إسرائيل'),
(77021, 3285516736, 3285516799, 'DE', 'DEU', 'ألمانيا'),
(77022, 3285516800, 3285516927, 'GB', 'GBR', 'المملكة المتحدة'),
(77023, 3285516928, 3285516991, 'PL', 'POL', 'بولندا'),
(77024, 3285516992, 3285517023, 'BE', 'BEL', 'بلجيكا'),
(77025, 3285517024, 3285517055, 'SE', 'SWE', 'السويد'),
(77026, 3285517056, 3285517215, 'GB', 'GBR', 'المملكة المتحدة'),
(77027, 3285517216, 3285517247, 'AT', 'AUT', 'النمسا'),
(77028, 3285517248, 3285518335, 'GB', 'GBR', 'المملكة المتحدة'),
(77029, 3285518336, 3285518351, 'NL', 'NLD', 'هولندا'),
(77030, 3285518352, 3285518367, 'ES', 'ESP', 'إسبانيا'),
(77031, 3285518368, 3285518463, 'BE', 'BEL', 'بلجيكا'),
(77032, 3285518464, 3285518591, 'ES', 'ESP', 'إسبانيا'),
(77033, 3285518592, 3285518847, 'CH', 'CHE', 'سويسرا'),
(77034, 3285518848, 3285519103, 'BE', 'BEL', 'بلجيكا'),
(77035, 3285519104, 3285519359, 'FR', 'FRA', 'فرنسا'),
(77036, 3285519360, 3285519615, 'DE', 'DEU', 'ألمانيا'),
(77037, 3285519616, 3285520127, 'GB', 'GBR', 'المملكة المتحدة'),
(77038, 3285520128, 3285520383, 'NL', 'NLD', 'هولندا'),
(77039, 3285520384, 3285520527, 'GB', 'GBR', 'المملكة المتحدة'),
(77040, 3285520528, 3285520543, 'CH', 'CHE', 'سويسرا'),
(77041, 3285520544, 3285520575, 'GB', 'GBR', 'المملكة المتحدة'),
(77042, 3285520576, 3285520639, 'DE', 'DEU', 'ألمانيا'),
(77043, 3285520640, 3285520767, 'NL', 'NLD', 'هولندا'),
(77044, 3285520768, 3285520895, 'GB', 'GBR', 'المملكة المتحدة'),
(77045, 3285520896, 3285521167, 'BE', 'BEL', 'بلجيكا'),
(77046, 3285521168, 3285521407, 'GB', 'GBR', 'المملكة المتحدة'),
(77047, 3285521408, 3285521695, 'BE', 'BEL', 'بلجيكا'),
(77048, 3285521696, 3285521791, 'GB', 'GBR', 'المملكة المتحدة'),
(77049, 3285521792, 3285522175, 'BE', 'BEL', 'بلجيكا'),
(77050, 3285522176, 3285523071, 'GB', 'GBR', 'المملكة المتحدة'),
(77051, 3285523072, 3285523079, 'BE', 'BEL', 'بلجيكا'),
(77052, 3285523080, 3285523087, 'ES', 'ESP', 'إسبانيا'),
(77053, 3285523088, 3285523199, 'CH', 'CHE', 'سويسرا'),
(77054, 3285523200, 3285523231, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77055, 3285523232, 3285523327, 'BE', 'BEL', 'بلجيكا'),
(77056, 3285523328, 3285523335, 'FI', 'FIN', 'فنلندا'),
(77057, 3285523336, 3285523359, 'BE', 'BEL', 'بلجيكا'),
(77058, 3285523360, 3285523391, 'GB', 'GBR', 'المملكة المتحدة'),
(77059, 3285523392, 3285523711, 'FR', 'FRA', 'فرنسا'),
(77060, 3285523712, 3285523967, 'CH', 'CHE', 'سويسرا'),
(77061, 3285523968, 3285524063, 'GB', 'GBR', 'المملكة المتحدة'),
(77062, 3285524064, 3285524095, 'LU', 'LUX', 'لوكسيمبورغ'),
(77063, 3285524096, 3285524159, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77064, 3285524160, 3285524175, 'GB', 'GBR', 'المملكة المتحدة'),
(77065, 3285524176, 3285524191, 'CH', 'CHE', 'سويسرا'),
(77066, 3285524192, 3285524223, 'BE', 'BEL', 'بلجيكا'),
(77067, 3285524224, 3285524351, 'GB', 'GBR', 'المملكة المتحدة'),
(77068, 3285524352, 3285524479, 'BE', 'BEL', 'بلجيكا'),
(77069, 3285524480, 3285524735, 'DK', 'DNK', 'الدنيمارك'),
(77070, 3285524736, 3285524863, 'GB', 'GBR', 'المملكة المتحدة'),
(77071, 3285524864, 3285524895, 'BE', 'BEL', 'بلجيكا'),
(77072, 3285524896, 3285524927, 'ES', 'ESP', 'إسبانيا'),
(77073, 3285524928, 3285524991, 'GB', 'GBR', 'المملكة المتحدة'),
(77074, 3285524992, 3285525247, 'BE', 'BEL', 'بلجيكا'),
(77075, 3285525248, 3285525503, 'CH', 'CHE', 'سويسرا'),
(77076, 3285525504, 3285526015, 'BE', 'BEL', 'بلجيكا'),
(77077, 3285526016, 3285526023, 'IL', 'ISR', 'إسرائيل'),
(77078, 3285526024, 3285526035, 'BE', 'BEL', 'بلجيكا'),
(77079, 3285526036, 3285526039, 'FR', 'FRA', 'فرنسا'),
(77080, 3285526040, 3285526047, 'BE', 'BEL', 'بلجيكا'),
(77081, 3285526048, 3285526079, 'CZ', 'CZE', 'التشيك'),
(77082, 3285526080, 3285526143, 'BE', 'BEL', 'بلجيكا'),
(77083, 3285526144, 3285526175, 'HU', 'HUN', 'هنغاريا'),
(77084, 3285526176, 3285526383, 'BE', 'BEL', 'بلجيكا'),
(77085, 3285526384, 3285526399, 'PT', 'PRT', 'البورتوغال'),
(77086, 3285526400, 3285526527, 'CH', 'CHE', 'سويسرا'),
(77087, 3285526528, 3285526783, 'ES', 'ESP', 'إسبانيا'),
(77088, 3285526784, 3285526815, 'CH', 'CHE', 'سويسرا'),
(77089, 3285526816, 3285526847, 'BE', 'BEL', 'بلجيكا'),
(77090, 3285526848, 3285526911, 'CH', 'CHE', 'سويسرا'),
(77091, 3285526912, 3285527295, 'GB', 'GBR', 'المملكة المتحدة'),
(77092, 3285527296, 3285527423, 'BE', 'BEL', 'بلجيكا'),
(77093, 3285527424, 3285527427, 'GB', 'GBR', 'المملكة المتحدة'),
(77094, 3285527428, 3285527431, 'BE', 'BEL', 'بلجيكا'),
(77095, 3285527432, 3285527439, 'FR', 'FRA', 'فرنسا'),
(77096, 3285527440, 3285527455, 'LU', 'LUX', 'لوكسيمبورغ'),
(77097, 3285527456, 3285527487, 'IL', 'ISR', 'إسرائيل'),
(77098, 3285527488, 3285527495, 'BE', 'BEL', 'بلجيكا'),
(77099, 3285527496, 3285527503, 'DE', 'DEU', 'ألمانيا'),
(77100, 3285527504, 3285527519, 'JP', 'JPN', 'اليابان'),
(77101, 3285527520, 3285527551, 'BE', 'BEL', 'بلجيكا'),
(77102, 3285527552, 3285527615, 'IL', 'ISR', 'إسرائيل'),
(77103, 3285527616, 3285527679, 'GB', 'GBR', 'المملكة المتحدة'),
(77104, 3285527680, 3285527807, 'BE', 'BEL', 'بلجيكا'),
(77105, 3285527808, 3285527811, 'GB', 'GBR', 'المملكة المتحدة'),
(77106, 3285527812, 3285527815, 'PL', 'POL', 'بولندا'),
(77107, 3285527816, 3285527855, 'BE', 'BEL', 'بلجيكا'),
(77108, 3285527856, 3285527871, 'FR', 'FRA', 'فرنسا'),
(77109, 3285527872, 3285527967, 'BE', 'BEL', 'بلجيكا'),
(77110, 3285527968, 3285527999, 'DE', 'DEU', 'ألمانيا'),
(77111, 3285528000, 3285528319, 'BE', 'BEL', 'بلجيكا'),
(77112, 3285528320, 3285528447, 'DE', 'DEU', 'ألمانيا'),
(77113, 3285528448, 3285528575, 'FR', 'FRA', 'فرنسا'),
(77114, 3285528576, 3285528799, 'BE', 'BEL', 'بلجيكا'),
(77115, 3285528800, 3285528831, 'GB', 'GBR', 'المملكة المتحدة'),
(77116, 3285528832, 3285528847, 'BE', 'BEL', 'بلجيكا'),
(77117, 3285528848, 3285528863, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77118, 3285528864, 3285528883, 'BE', 'BEL', 'بلجيكا'),
(77119, 3285528884, 3285528887, 'FR', 'FRA', 'فرنسا'),
(77120, 3285528888, 3285528895, 'BE', 'BEL', 'بلجيكا'),
(77121, 3285528896, 3285528911, 'GB', 'GBR', 'المملكة المتحدة'),
(77122, 3285528912, 3285528931, 'BE', 'BEL', 'بلجيكا'),
(77123, 3285528932, 3285528935, 'FR', 'FRA', 'فرنسا'),
(77124, 3285528936, 3285528943, 'BE', 'BEL', 'بلجيكا'),
(77125, 3285528944, 3285529071, 'GB', 'GBR', 'المملكة المتحدة'),
(77126, 3285529072, 3285529151, 'BE', 'BEL', 'بلجيكا'),
(77127, 3285529152, 3285529183, 'DE', 'DEU', 'ألمانيا'),
(77128, 3285529184, 3285529199, 'NL', 'NLD', 'هولندا'),
(77129, 3285529200, 3285529215, 'IL', 'ISR', 'إسرائيل'),
(77130, 3285529216, 3285529247, 'CH', 'CHE', 'سويسرا'),
(77131, 3285529248, 3285529263, 'GB', 'GBR', 'المملكة المتحدة'),
(77132, 3285529264, 3285529343, 'BE', 'BEL', 'بلجيكا'),
(77133, 3285529344, 3285529599, 'IT', 'ITA', 'إيطاليا'),
(77134, 3285529600, 3285529631, 'NO', 'NOR', 'النرويج'),
(77135, 3285529632, 3285529663, 'IE', 'IRL', 'إيرلندا'),
(77136, 3285529664, 3285529679, 'LI', 'LIE', 'ليختنشتاين'),
(77137, 3285529680, 3285529687, 'FI', 'FIN', 'فنلندا'),
(77138, 3285529688, 3285529695, 'IT', 'ITA', 'إيطاليا'),
(77139, 3285529696, 3285529727, 'BE', 'BEL', 'بلجيكا'),
(77140, 3285529728, 3285529855, 'GB', 'GBR', 'المملكة المتحدة'),
(77141, 3285529856, 3285529951, 'LU', 'LUX', 'لوكسيمبورغ'),
(77142, 3285529952, 3285529983, 'GR', 'GRC', 'اليونان'),
(77143, 3285529984, 3285529999, 'CZ', 'CZE', 'التشيك'),
(77144, 3285530000, 3285530143, 'BE', 'BEL', 'بلجيكا'),
(77145, 3285530144, 3285530175, 'GB', 'GBR', 'المملكة المتحدة'),
(77146, 3285530176, 3285530183, 'NL', 'NLD', 'هولندا'),
(77147, 3285530184, 3285530215, 'BE', 'BEL', 'بلجيكا'),
(77148, 3285530216, 3285530223, 'GB', 'GBR', 'المملكة المتحدة'),
(77149, 3285530224, 3285530271, 'FR', 'FRA', 'فرنسا'),
(77150, 3285530272, 3285530399, 'BE', 'BEL', 'بلجيكا'),
(77151, 3285530400, 3285530431, 'NL', 'NLD', 'هولندا'),
(77152, 3285530432, 3285530463, 'IT', 'ITA', 'إيطاليا'),
(77153, 3285530464, 3285530495, 'DE', 'DEU', 'ألمانيا'),
(77154, 3285530496, 3285530559, 'AT', 'AUT', 'النمسا'),
(77155, 3285530560, 3285530575, 'BE', 'BEL', 'بلجيكا'),
(77156, 3285530576, 3285530583, 'GB', 'GBR', 'المملكة المتحدة'),
(77157, 3285530584, 3285530591, 'BE', 'BEL', 'بلجيكا'),
(77158, 3285530592, 3285530607, 'GB', 'GBR', 'المملكة المتحدة'),
(77159, 3285530608, 3285530655, 'BE', 'BEL', 'بلجيكا'),
(77160, 3285530656, 3285530687, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77161, 3285530688, 3285530719, 'GB', 'GBR', 'المملكة المتحدة'),
(77162, 3285530720, 3285530723, 'BE', 'BEL', 'بلجيكا'),
(77163, 3285530724, 3285530727, 'GB', 'GBR', 'المملكة المتحدة'),
(77164, 3285530728, 3285530735, 'DE', 'DEU', 'ألمانيا'),
(77165, 3285530736, 3285530739, 'GB', 'GBR', 'المملكة المتحدة'),
(77166, 3285530740, 3285530743, 'BE', 'BEL', 'بلجيكا'),
(77167, 3285530744, 3285530751, 'GB', 'GBR', 'المملكة المتحدة'),
(77168, 3285530752, 3285530767, 'IT', 'ITA', 'إيطاليا'),
(77169, 3285530768, 3285530783, 'DE', 'DEU', 'ألمانيا'),
(77170, 3285530784, 3285530815, 'BE', 'BEL', 'بلجيكا'),
(77171, 3285530816, 3285530831, 'GB', 'GBR', 'المملكة المتحدة'),
(77172, 3285530832, 3285530879, 'BE', 'BEL', 'بلجيكا'),
(77173, 3285530880, 3285530911, 'CH', 'CHE', 'سويسرا'),
(77174, 3285530912, 3285530975, 'GB', 'GBR', 'المملكة المتحدة'),
(77175, 3285530976, 3285530983, 'BE', 'BEL', 'بلجيكا'),
(77176, 3285530984, 3285530991, 'IE', 'IRL', 'إيرلندا'),
(77177, 3285530992, 3285531007, 'GB', 'GBR', 'المملكة المتحدة'),
(77178, 3285531008, 3285531023, 'FR', 'FRA', 'فرنسا'),
(77179, 3285531024, 3285531039, 'LU', 'LUX', 'لوكسيمبورغ'),
(77180, 3285531040, 3285531071, 'ES', 'ESP', 'إسبانيا'),
(77181, 3285531072, 3285531103, 'NL', 'NLD', 'هولندا'),
(77182, 3285531104, 3285531119, 'FR', 'FRA', 'فرنسا'),
(77183, 3285531120, 3285531263, 'BE', 'BEL', 'بلجيكا'),
(77184, 3285531264, 3285531311, 'GB', 'GBR', 'المملكة المتحدة'),
(77185, 3285531312, 3285531327, 'DK', 'DNK', 'الدنيمارك'),
(77186, 3285531328, 3285531343, 'BE', 'BEL', 'بلجيكا'),
(77187, 3285531344, 3285531351, 'GB', 'GBR', 'المملكة المتحدة'),
(77188, 3285531352, 3285531355, 'FR', 'FRA', 'فرنسا'),
(77189, 3285531356, 3285531359, 'ES', 'ESP', 'إسبانيا'),
(77190, 3285531360, 3285531367, 'BE', 'BEL', 'بلجيكا'),
(77191, 3285531368, 3285531375, 'DE', 'DEU', 'ألمانيا'),
(77192, 3285531376, 3285531383, 'BE', 'BEL', 'بلجيكا'),
(77193, 3285531384, 3285531391, 'DE', 'DEU', 'ألمانيا'),
(77194, 3285531392, 3285531423, 'BE', 'BEL', 'بلجيكا'),
(77195, 3285531424, 3285531455, 'DE', 'DEU', 'ألمانيا'),
(77196, 3285531456, 3285531495, 'BE', 'BEL', 'بلجيكا'),
(77197, 3285531496, 3285531503, 'NL', 'NLD', 'هولندا'),
(77198, 3285531504, 3285531519, 'FR', 'FRA', 'فرنسا'),
(77199, 3285531520, 3285531535, 'BE', 'BEL', 'بلجيكا'),
(77200, 3285531536, 3285531551, 'DE', 'DEU', 'ألمانيا'),
(77201, 3285531552, 3285531567, 'IL', 'ISR', 'إسرائيل'),
(77202, 3285531568, 3285531615, 'BE', 'BEL', 'بلجيكا'),
(77203, 3285531616, 3285531647, 'NL', 'NLD', 'هولندا'),
(77204, 3285531648, 3285531903, 'BE', 'BEL', 'بلجيكا'),
(77205, 3285531904, 3285532159, 'GB', 'GBR', 'المملكة المتحدة'),
(77206, 3285532160, 3285532223, 'BE', 'BEL', 'بلجيكا'),
(77207, 3285532224, 3285532231, 'ES', 'ESP', 'إسبانيا'),
(77208, 3285532232, 3285532415, 'BE', 'BEL', 'بلجيكا'),
(77209, 3285532416, 3285532687, 'IT', 'ITA', 'إيطاليا'),
(77210, 3285532688, 3285532703, 'DE', 'DEU', 'ألمانيا'),
(77211, 3285532704, 3285532711, 'BE', 'BEL', 'بلجيكا'),
(77212, 3285532712, 3285532719, 'RU', 'RUS', 'الإتحاد الروسي'),
(77213, 3285532720, 3285532735, 'IT', 'ITA', 'إيطاليا'),
(77214, 3285532736, 3285532799, 'CH', 'CHE', 'سويسرا'),
(77215, 3285532800, 3285532831, 'DE', 'DEU', 'ألمانيا'),
(77216, 3285532832, 3285532847, 'FI', 'FIN', 'فنلندا'),
(77217, 3285532848, 3285532863, 'IT', 'ITA', 'إيطاليا'),
(77218, 3285532864, 3285532895, 'BE', 'BEL', 'بلجيكا'),
(77219, 3285532896, 3285532959, 'IT', 'ITA', 'إيطاليا'),
(77220, 3285532960, 3285533055, 'BE', 'BEL', 'بلجيكا'),
(77221, 3285533056, 3285533059, 'NL', 'NLD', 'هولندا'),
(77222, 3285533060, 3285533087, 'BE', 'BEL', 'بلجيكا'),
(77223, 3285533088, 3285533103, 'IT', 'ITA', 'إيطاليا'),
(77224, 3285533104, 3285533119, 'LU', 'LUX', 'لوكسيمبورغ'),
(77225, 3285533120, 3285533127, 'BE', 'BEL', 'بلجيكا'),
(77226, 3285533128, 3285533135, 'SE', 'SWE', 'السويد'),
(77227, 3285533136, 3285533151, 'GB', 'GBR', 'المملكة المتحدة'),
(77228, 3285533152, 3285533183, 'FR', 'FRA', 'فرنسا'),
(77229, 3285533184, 3285533311, 'IT', 'ITA', 'إيطاليا'),
(77230, 3285533312, 3285533343, 'SE', 'SWE', 'السويد'),
(77231, 3285533344, 3285533367, 'BE', 'BEL', 'بلجيكا'),
(77232, 3285533368, 3285533375, 'CH', 'CHE', 'سويسرا'),
(77233, 3285533376, 3285533471, 'GB', 'GBR', 'المملكة المتحدة'),
(77234, 3285533472, 3285533503, 'BE', 'BEL', 'بلجيكا'),
(77235, 3285533504, 3285533519, 'GB', 'GBR', 'المملكة المتحدة'),
(77236, 3285533520, 3285533535, 'SE', 'SWE', 'السويد'),
(77237, 3285533536, 3285533543, 'BE', 'BEL', 'بلجيكا'),
(77238, 3285533544, 3285533551, 'DE', 'DEU', 'ألمانيا'),
(77239, 3285533552, 3285533567, 'GB', 'GBR', 'المملكة المتحدة'),
(77240, 3285533568, 3285533951, 'IT', 'ITA', 'إيطاليا'),
(77241, 3285533952, 3285534079, 'IL', 'ISR', 'إسرائيل'),
(77242, 3285534080, 3285534095, 'IT', 'ITA', 'إيطاليا'),
(77243, 3285534096, 3285534111, 'TR', 'TUR', 'تركيا'),
(77244, 3285534112, 3285534143, 'BE', 'BEL', 'بلجيكا'),
(77245, 3285534144, 3285534207, 'IT', 'ITA', 'إيطاليا'),
(77246, 3285534208, 3285534463, 'PT', 'PRT', 'البورتوغال'),
(77247, 3285534464, 3285534479, 'NL', 'NLD', 'هولندا'),
(77248, 3285534480, 3285534527, 'BE', 'BEL', 'بلجيكا'),
(77249, 3285534528, 3285534559, 'FR', 'FRA', 'فرنسا'),
(77250, 3285534560, 3285534591, 'IT', 'ITA', 'إيطاليا'),
(77251, 3285534592, 3285534627, 'GB', 'GBR', 'المملكة المتحدة'),
(77252, 3285534628, 3285534639, 'BE', 'BEL', 'بلجيكا'),
(77253, 3285534640, 3285534655, 'GB', 'GBR', 'المملكة المتحدة'),
(77254, 3285534656, 3285534719, 'IT', 'ITA', 'إيطاليا'),
(77255, 3285534720, 3285534751, 'GB', 'GBR', 'المملكة المتحدة'),
(77256, 3285534752, 3285534767, 'BE', 'BEL', 'بلجيكا'),
(77257, 3285534768, 3285534783, 'GB', 'GBR', 'المملكة المتحدة'),
(77258, 3285534784, 3285534799, 'DK', 'DNK', 'الدنيمارك'),
(77259, 3285534800, 3285534815, 'ES', 'ESP', 'إسبانيا'),
(77260, 3285534816, 3285534831, 'HU', 'HUN', 'هنغاريا'),
(77261, 3285534832, 3285534927, 'IE', 'IRL', 'إيرلندا'),
(77262, 3285534928, 3285534943, 'GB', 'GBR', 'المملكة المتحدة'),
(77263, 3285534944, 3285534975, 'BE', 'BEL', 'بلجيكا'),
(77264, 3285534976, 3285535103, 'IT', 'ITA', 'إيطاليا'),
(77265, 3285535104, 3285535123, 'BE', 'BEL', 'بلجيكا'),
(77266, 3285535124, 3285535127, 'ES', 'ESP', 'إسبانيا'),
(77267, 3285535128, 3285535131, 'BE', 'BEL', 'بلجيكا'),
(77268, 3285535132, 3285535135, 'NL', 'NLD', 'هولندا'),
(77269, 3285535136, 3285535139, 'FR', 'FRA', 'فرنسا'),
(77270, 3285535140, 3285535143, 'BE', 'BEL', 'بلجيكا'),
(77271, 3285535144, 3285535147, 'GR', 'GRC', 'اليونان'),
(77272, 3285535148, 3285535151, 'CZ', 'CZE', 'التشيك'),
(77273, 3285535152, 3285535155, 'SE', 'SWE', 'السويد'),
(77274, 3285535156, 3285535231, 'BE', 'BEL', 'بلجيكا'),
(77275, 3285535232, 3285535743, 'NO', 'NOR', 'النرويج'),
(77276, 3285535744, 3285535871, 'IT', 'ITA', 'إيطاليا'),
(77277, 3285535872, 3285535903, 'FR', 'FRA', 'فرنسا'),
(77278, 3285535904, 3285535907, 'DK', 'DNK', 'الدنيمارك'),
(77279, 3285535908, 3285535911, 'NO', 'NOR', 'النرويج'),
(77280, 3285535912, 3285535919, 'BE', 'BEL', 'بلجيكا'),
(77281, 3285535920, 3285535927, 'NL', 'NLD', 'هولندا'),
(77282, 3285535928, 3285535951, 'BE', 'BEL', 'بلجيكا'),
(77283, 3285535952, 3285535967, 'GB', 'GBR', 'المملكة المتحدة'),
(77284, 3285535968, 3285535999, 'BE', 'BEL', 'بلجيكا'),
(77285, 3285536000, 3285536063, 'GB', 'GBR', 'المملكة المتحدة'),
(77286, 3285536064, 3285536079, 'BE', 'BEL', 'بلجيكا'),
(77287, 3285536080, 3285536095, 'IT', 'ITA', 'إيطاليا'),
(77288, 3285536096, 3285536111, 'GB', 'GBR', 'المملكة المتحدة'),
(77289, 3285536112, 3285536255, 'BE', 'BEL', 'بلجيكا'),
(77290, 3285536256, 3285536511, 'GB', 'GBR', 'المملكة المتحدة'),
(77291, 3285536512, 3285536543, 'LU', 'LUX', 'لوكسيمبورغ'),
(77292, 3285536544, 3285536575, 'DE', 'DEU', 'ألمانيا'),
(77293, 3285536576, 3285536607, 'IL', 'ISR', 'إسرائيل'),
(77294, 3285536608, 3285536703, 'BE', 'BEL', 'بلجيكا'),
(77295, 3285536704, 3285536735, 'GB', 'GBR', 'المملكة المتحدة'),
(77296, 3285536736, 3285536739, 'IT', 'ITA', 'إيطاليا'),
(77297, 3285536740, 3285536743, 'GB', 'GBR', 'المملكة المتحدة'),
(77298, 3285536744, 3285536747, 'DE', 'DEU', 'ألمانيا'),
(77299, 3285536748, 3285536751, 'AT', 'AUT', 'النمسا'),
(77300, 3285536752, 3285536755, 'BE', 'BEL', 'بلجيكا'),
(77301, 3285536756, 3285536759, 'IL', 'ISR', 'إسرائيل'),
(77302, 3285536760, 3285536767, 'BE', 'BEL', 'بلجيكا'),
(77303, 3285536768, 3285536959, 'DK', 'DNK', 'الدنيمارك'),
(77304, 3285536960, 3285536991, 'ES', 'ESP', 'إسبانيا'),
(77305, 3285536992, 3285537023, 'GB', 'GBR', 'المملكة المتحدة'),
(77306, 3285537024, 3285537087, 'IL', 'ISR', 'إسرائيل'),
(77307, 3285537088, 3285537127, 'GB', 'GBR', 'المملكة المتحدة'),
(77308, 3285537128, 3285537135, 'BE', 'BEL', 'بلجيكا'),
(77309, 3285537136, 3285537143, 'DK', 'DNK', 'الدنيمارك'),
(77310, 3285537144, 3285537151, 'GB', 'GBR', 'المملكة المتحدة'),
(77311, 3285537152, 3285537167, 'DK', 'DNK', 'الدنيمارك'),
(77312, 3285537168, 3285537175, 'CH', 'CHE', 'سويسرا'),
(77313, 3285537176, 3285537183, 'BE', 'BEL', 'بلجيكا'),
(77314, 3285537184, 3285537215, 'DE', 'DEU', 'ألمانيا'),
(77315, 3285537216, 3285537231, 'GB', 'GBR', 'المملكة المتحدة'),
(77316, 3285537232, 3285537535, 'BE', 'BEL', 'بلجيكا'),
(77317, 3285537536, 3285537599, 'RU', 'RUS', 'الإتحاد الروسي'),
(77318, 3285537600, 3285537615, 'FR', 'FRA', 'فرنسا'),
(77319, 3285537616, 3285537631, 'BE', 'BEL', 'بلجيكا'),
(77320, 3285537632, 3285537663, 'SE', 'SWE', 'السويد'),
(77321, 3285537664, 3285537727, 'DE', 'DEU', 'ألمانيا'),
(77322, 3285537728, 3285537759, 'IT', 'ITA', 'إيطاليا'),
(77323, 3285537760, 3285537791, 'LU', 'LUX', 'لوكسيمبورغ'),
(77324, 3285537792, 3285537919, 'NL', 'NLD', 'هولندا'),
(77325, 3285537920, 3285538047, 'LU', 'LUX', 'لوكسيمبورغ'),
(77326, 3285538048, 3285538175, 'NL', 'NLD', 'هولندا'),
(77327, 3285538176, 3285538183, 'DE', 'DEU', 'ألمانيا'),
(77328, 3285538184, 3285538187, 'LU', 'LUX', 'لوكسيمبورغ'),
(77329, 3285538188, 3285538207, 'BE', 'BEL', 'بلجيكا'),
(77330, 3285538208, 3285538239, 'LU', 'LUX', 'لوكسيمبورغ'),
(77331, 3285538240, 3285538271, 'NO', 'NOR', 'النرويج'),
(77332, 3285538272, 3285538287, 'FI', 'FIN', 'فنلندا'),
(77333, 3285538288, 3285538295, 'CH', 'CHE', 'سويسرا'),
(77334, 3285538296, 3285538299, 'BE', 'BEL', 'بلجيكا'),
(77335, 3285538300, 3285538319, 'GB', 'GBR', 'المملكة المتحدة'),
(77336, 3285538320, 3285538327, 'LU', 'LUX', 'لوكسيمبورغ'),
(77337, 3285538328, 3285538335, 'BE', 'BEL', 'بلجيكا'),
(77338, 3285538336, 3285538351, 'GB', 'GBR', 'المملكة المتحدة'),
(77339, 3285538352, 3285538367, 'LU', 'LUX', 'لوكسيمبورغ'),
(77340, 3285538368, 3285538375, 'BE', 'BEL', 'بلجيكا'),
(77341, 3285538376, 3285538383, 'AT', 'AUT', 'النمسا'),
(77342, 3285538384, 3285538399, 'BE', 'BEL', 'بلجيكا'),
(77343, 3285538400, 3285538431, 'DK', 'DNK', 'الدنيمارك'),
(77344, 3285538432, 3285538623, 'BE', 'BEL', 'بلجيكا'),
(77345, 3285538624, 3285538687, 'LU', 'LUX', 'لوكسيمبورغ'),
(77346, 3285538688, 3285538719, 'BE', 'BEL', 'بلجيكا'),
(77347, 3285538720, 3285538751, 'DE', 'DEU', 'ألمانيا'),
(77348, 3285538752, 3285538755, 'IT', 'ITA', 'إيطاليا'),
(77349, 3285538756, 3285538759, 'FR', 'FRA', 'فرنسا'),
(77350, 3285538760, 3285538763, 'IE', 'IRL', 'إيرلندا'),
(77351, 3285538764, 3285538767, 'BE', 'BEL', 'بلجيكا'),
(77352, 3285538768, 3285538783, 'CZ', 'CZE', 'التشيك'),
(77353, 3285538784, 3285538815, 'BE', 'BEL', 'بلجيكا'),
(77354, 3285538816, 3285538847, 'CH', 'CHE', 'سويسرا'),
(77355, 3285538848, 3285538879, 'BE', 'BEL', 'بلجيكا'),
(77356, 3285538880, 3285539071, 'ES', 'ESP', 'إسبانيا'),
(77357, 3285539072, 3285539327, 'NL', 'NLD', 'هولندا'),
(77358, 3285539328, 3285539583, 'BE', 'BEL', 'بلجيكا'),
(77359, 3285539584, 3285539711, 'IE', 'IRL', 'إيرلندا'),
(77360, 3285539712, 3285539839, 'GB', 'GBR', 'المملكة المتحدة'),
(77361, 3285539840, 3285539967, 'IT', 'ITA', 'إيطاليا'),
(77362, 3285539968, 3285540031, 'GB', 'GBR', 'المملكة المتحدة'),
(77363, 3285540032, 3285540095, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77364, 3285540096, 3285540103, 'GB', 'GBR', 'المملكة المتحدة'),
(77365, 3285540104, 3285540107, 'IT', 'ITA', 'إيطاليا'),
(77366, 3285540108, 3285540111, 'BE', 'BEL', 'بلجيكا'),
(77367, 3285540112, 3285540127, 'IL', 'ISR', 'إسرائيل'),
(77368, 3285540128, 3285540159, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77369, 3285540160, 3285540191, 'FI', 'FIN', 'فنلندا'),
(77370, 3285540192, 3285540207, 'CH', 'CHE', 'سويسرا'),
(77371, 3285540208, 3285540215, 'IE', 'IRL', 'إيرلندا'),
(77372, 3285540216, 3285540219, 'BE', 'BEL', 'بلجيكا'),
(77373, 3285540220, 3285540223, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77374, 3285540224, 3285540351, 'CZ', 'CZE', 'التشيك'),
(77375, 3285540352, 3285540415, 'PT', 'PRT', 'البورتوغال'),
(77376, 3285540416, 3285540423, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77377, 3285540424, 3285540447, 'BE', 'BEL', 'بلجيكا'),
(77378, 3285540448, 3285540479, 'DE', 'DEU', 'ألمانيا'),
(77379, 3285540480, 3285540607, 'NL', 'NLD', 'هولندا'),
(77380, 3285540608, 3285540623, 'FI', 'FIN', 'فنلندا'),
(77381, 3285540624, 3285540671, 'BE', 'BEL', 'بلجيكا'),
(77382, 3285540672, 3285540735, 'DE', 'DEU', 'ألمانيا'),
(77383, 3285540736, 3285540863, 'BE', 'BEL', 'بلجيكا'),
(77384, 3285540864, 3285540871, 'FR', 'FRA', 'فرنسا'),
(77385, 3285540872, 3285540879, 'BE', 'BEL', 'بلجيكا'),
(77386, 3285540880, 3285541375, 'FR', 'FRA', 'فرنسا'),
(77387, 3285541376, 3285541391, 'GB', 'GBR', 'المملكة المتحدة'),
(77388, 3285541392, 3285541439, 'FR', 'FRA', 'فرنسا'),
(77389, 3285541440, 3285541519, 'GB', 'GBR', 'المملكة المتحدة'),
(77390, 3285541520, 3285541527, 'BG', 'BGR', 'بلغاريا'),
(77391, 3285541528, 3285541535, 'BE', 'BEL', 'بلجيكا'),
(77392, 3285541536, 3285541551, 'FR', 'FRA', 'فرنسا'),
(77393, 3285541552, 3285541567, 'BE', 'BEL', 'بلجيكا'),
(77394, 3285541568, 3285541599, 'GB', 'GBR', 'المملكة المتحدة'),
(77395, 3285541600, 3285541631, 'BE', 'BEL', 'بلجيكا'),
(77396, 3285541632, 3285541663, 'ES', 'ESP', 'إسبانيا'),
(77397, 3285541664, 3285541695, 'FR', 'FRA', 'فرنسا'),
(77398, 3285541696, 3285541759, 'BE', 'BEL', 'بلجيكا'),
(77399, 3285541760, 3285541887, 'FR', 'FRA', 'فرنسا'),
(77400, 3285541888, 3285541919, 'GB', 'GBR', 'المملكة المتحدة'),
(77401, 3285541920, 3285541951, 'FR', 'FRA', 'فرنسا'),
(77402, 3285541952, 3285542079, 'DE', 'DEU', 'ألمانيا'),
(77403, 3285542080, 3285542143, 'FR', 'FRA', 'فرنسا'),
(77404, 3285542144, 3285542399, 'BE', 'BEL', 'بلجيكا'),
(77405, 3285542400, 3285542655, 'GB', 'GBR', 'المملكة المتحدة'),
(77406, 3285542656, 3285542911, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77407, 3285542912, 3285543167, 'IT', 'ITA', 'إيطاليا'),
(77408, 3285543168, 3285543423, 'NL', 'NLD', 'هولندا'),
(77409, 3285543424, 3285543679, 'SE', 'SWE', 'السويد'),
(77410, 3285543680, 3285543743, 'AT', 'AUT', 'النمسا'),
(77411, 3285543744, 3285543759, 'FR', 'FRA', 'فرنسا'),
(77412, 3285543760, 3285543775, 'BE', 'BEL', 'بلجيكا'),
(77413, 3285543776, 3285543791, 'IT', 'ITA', 'إيطاليا'),
(77414, 3285543792, 3285543795, 'ES', 'ESP', 'إسبانيا'),
(77415, 3285543796, 3285543799, 'BE', 'BEL', 'بلجيكا'),
(77416, 3285543800, 3285543807, 'FR', 'FRA', 'فرنسا'),
(77417, 3285543808, 3285543871, 'NL', 'NLD', 'هولندا'),
(77418, 3285543872, 3285543935, 'FR', 'FRA', 'فرنسا'),
(77419, 3285543936, 3285544191, 'BE', 'BEL', 'بلجيكا'),
(77420, 3285544192, 3285544255, 'IL', 'ISR', 'إسرائيل'),
(77421, 3285544256, 3285544319, 'DE', 'DEU', 'ألمانيا'),
(77422, 3285544320, 3285544335, 'ES', 'ESP', 'إسبانيا'),
(77423, 3285544336, 3285544351, 'NL', 'NLD', 'هولندا'),
(77424, 3285544352, 3285544383, 'BE', 'BEL', 'بلجيكا'),
(77425, 3285544384, 3285544479, 'FR', 'FRA', 'فرنسا'),
(77426, 3285544480, 3285544511, 'ES', 'ESP', 'إسبانيا'),
(77427, 3285544512, 3285544639, 'FR', 'FRA', 'فرنسا'),
(77428, 3285544640, 3285544703, 'BE', 'BEL', 'بلجيكا'),
(77429, 3285544704, 3285544959, 'FR', 'FRA', 'فرنسا'),
(77430, 3285544960, 3285545215, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(77431, 3285545216, 3285545343, 'BE', 'BEL', 'بلجيكا'),
(77432, 3285545344, 3285545379, 'GB', 'GBR', 'المملكة المتحدة'),
(77433, 3285545380, 3285545471, 'BE', 'BEL', 'بلجيكا'),
(77434, 3285545472, 3285545727, 'SE', 'SWE', 'السويد'),
(77435, 3285545728, 3285545983, 'FI', 'FIN', 'فنلندا'),
(77436, 3285545984, 3285545999, 'IT', 'ITA', 'إيطاليا'),
(77437, 3285546000, 3285546007, 'BE', 'BEL', 'بلجيكا'),
(77438, 3285546008, 3285546015, 'IT', 'ITA', 'إيطاليا'),
(77439, 3285546016, 3285546063, 'ES', 'ESP', 'إسبانيا'),
(77440, 3285546064, 3285546071, 'IT', 'ITA', 'إيطاليا'),
(77441, 3285546072, 3285546111, 'ES', 'ESP', 'إسبانيا'),
(77442, 3285546112, 3285546239, 'AT', 'AUT', 'النمسا'),
(77443, 3285546240, 3285546367, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77444, 3285546368, 3285546495, 'FR', 'FRA', 'فرنسا'),
(77445, 3285546496, 3285546559, 'NL', 'NLD', 'هولندا'),
(77446, 3285546560, 3285546623, 'BE', 'BEL', 'بلجيكا'),
(77447, 3285546624, 3285546671, 'FR', 'FRA', 'فرنسا'),
(77448, 3285546672, 3285546687, 'SE', 'SWE', 'السويد'),
(77449, 3285546688, 3285546751, 'GB', 'GBR', 'المملكة المتحدة'),
(77450, 3285546752, 3285547007, 'DK', 'DNK', 'الدنيمارك'),
(77451, 3285547008, 3285547023, 'AT', 'AUT', 'النمسا'),
(77452, 3285547024, 3285547039, 'FR', 'FRA', 'فرنسا'),
(77453, 3285547040, 3285547071, 'AT', 'AUT', 'النمسا'),
(77454, 3285547072, 3285547135, 'AU', 'AUS', 'أستراليا'),
(77455, 3285547136, 3285547167, 'RU', 'RUS', 'الإتحاد الروسي'),
(77456, 3285547168, 3285547199, 'LU', 'LUX', 'لوكسيمبورغ'),
(77457, 3285547200, 3285547263, 'SE', 'SWE', 'السويد'),
(77458, 3285547264, 3285547519, 'LU', 'LUX', 'لوكسيمبورغ'),
(77459, 3285547520, 3285547775, 'NL', 'NLD', 'هولندا'),
(77460, 3285547776, 3285547903, 'ES', 'ESP', 'إسبانيا'),
(77461, 3285547904, 3285548031, 'BE', 'BEL', 'بلجيكا'),
(77462, 3285548032, 3285548287, 'FR', 'FRA', 'فرنسا'),
(77463, 3285548288, 3285548543, 'DE', 'DEU', 'ألمانيا'),
(77464, 3285548544, 3285548607, 'FR', 'FRA', 'فرنسا'),
(77465, 3285548608, 3285548639, 'LI', 'LIE', 'ليختنشتاين'),
(77466, 3285548640, 3285548647, 'BE', 'BEL', 'بلجيكا'),
(77467, 3285548648, 3285548655, 'LI', 'LIE', 'ليختنشتاين'),
(77468, 3285548656, 3285548735, 'GB', 'GBR', 'المملكة المتحدة'),
(77469, 3285548736, 3285548767, 'BE', 'BEL', 'بلجيكا'),
(77470, 3285548768, 3285548799, 'LU', 'LUX', 'لوكسيمبورغ'),
(77471, 3285548800, 3285548831, 'IT', 'ITA', 'إيطاليا'),
(77472, 3285548832, 3285548839, 'GB', 'GBR', 'المملكة المتحدة'),
(77473, 3285548840, 3285548847, 'IL', 'ISR', 'إسرائيل'),
(77474, 3285548848, 3285548959, 'IT', 'ITA', 'إيطاليا'),
(77475, 3285548960, 3285549023, 'FR', 'FRA', 'فرنسا'),
(77476, 3285549024, 3285549039, 'PT', 'PRT', 'البورتوغال'),
(77477, 3285549040, 3285549055, 'FR', 'FRA', 'فرنسا'),
(77478, 3285549056, 3285549183, 'DE', 'DEU', 'ألمانيا'),
(77479, 3285549184, 3285549215, 'BE', 'BEL', 'بلجيكا'),
(77480, 3285549216, 3285549247, 'CH', 'CHE', 'سويسرا'),
(77481, 3285549248, 3285549279, 'DE', 'DEU', 'ألمانيا'),
(77482, 3285549280, 3285549311, 'GB', 'GBR', 'المملكة المتحدة'),
(77483, 3285549312, 3285549695, 'DE', 'DEU', 'ألمانيا'),
(77484, 3285549696, 3285549719, 'BE', 'BEL', 'بلجيكا'),
(77485, 3285549720, 3285549727, 'GB', 'GBR', 'المملكة المتحدة'),
(77486, 3285549728, 3285549735, 'SE', 'SWE', 'السويد'),
(77487, 3285549736, 3285549767, 'BE', 'BEL', 'بلجيكا'),
(77488, 3285549768, 3285549775, 'FI', 'FIN', 'فنلندا'),
(77489, 3285549776, 3285549791, 'DE', 'DEU', 'ألمانيا'),
(77490, 3285549792, 3285549823, 'LU', 'LUX', 'لوكسيمبورغ'),
(77491, 3285549824, 3285549871, 'DE', 'DEU', 'ألمانيا'),
(77492, 3285549872, 3285549887, 'DK', 'DNK', 'الدنيمارك'),
(77493, 3285549888, 3285549951, 'DE', 'DEU', 'ألمانيا'),
(77494, 3285549952, 3285550335, 'BE', 'BEL', 'بلجيكا'),
(77495, 3285550336, 3285550463, 'GB', 'GBR', 'المملكة المتحدة'),
(77496, 3285550464, 3285550527, 'DE', 'DEU', 'ألمانيا'),
(77497, 3285550528, 3285550591, 'IT', 'ITA', 'إيطاليا'),
(77498, 3285550592, 3285550847, 'FR', 'FRA', 'فرنسا'),
(77499, 3285550848, 3285550943, 'IT', 'ITA', 'إيطاليا'),
(77500, 3285550944, 3285550975, 'NL', 'NLD', 'هولندا'),
(77501, 3285550976, 3285551007, 'BE', 'BEL', 'بلجيكا'),
(77502, 3285551008, 3285551039, 'CH', 'CHE', 'سويسرا'),
(77503, 3285551040, 3285551071, 'DE', 'DEU', 'ألمانيا'),
(77504, 3285551072, 3285551103, 'BE', 'BEL', 'بلجيكا'),
(77505, 3285551104, 3285551359, 'DE', 'DEU', 'ألمانيا'),
(77506, 3285551360, 3285551391, 'BE', 'BEL', 'بلجيكا'),
(77507, 3285551392, 3285551423, 'DE', 'DEU', 'ألمانيا'),
(77508, 3285551424, 3285551487, 'DK', 'DNK', 'الدنيمارك'),
(77509, 3285551488, 3285551551, 'BE', 'BEL', 'بلجيكا'),
(77510, 3285551552, 3285551615, 'DE', 'DEU', 'ألمانيا'),
(77511, 3285551616, 3285551647, 'GB', 'GBR', 'المملكة المتحدة'),
(77512, 3285551648, 3285551679, 'FR', 'FRA', 'فرنسا'),
(77513, 3285551680, 3285551807, 'GB', 'GBR', 'المملكة المتحدة'),
(77514, 3285551808, 3285551839, 'RU', 'RUS', 'الإتحاد الروسي'),
(77515, 3285551840, 3285552127, 'BE', 'BEL', 'بلجيكا'),
(77516, 3285552128, 3285552191, 'DE', 'DEU', 'ألمانيا'),
(77517, 3285552192, 3285552255, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77518, 3285552256, 3285552287, 'CZ', 'CZE', 'التشيك'),
(77519, 3285552288, 3285552319, 'HU', 'HUN', 'هنغاريا'),
(77520, 3285552320, 3285552383, 'GB', 'GBR', 'المملكة المتحدة'),
(77521, 3285552384, 3285552511, 'DE', 'DEU', 'ألمانيا'),
(77522, 3285552512, 3285552639, 'GB', 'GBR', 'المملكة المتحدة'),
(77523, 3285552640, 3285552927, 'DE', 'DEU', 'ألمانيا'),
(77524, 3285552928, 3285552959, 'BE', 'BEL', 'بلجيكا'),
(77525, 3285552960, 3285553023, 'FR', 'FRA', 'فرنسا'),
(77526, 3285553024, 3285553039, 'BE', 'BEL', 'بلجيكا'),
(77527, 3285553040, 3285553055, 'EG', 'EGY', 'مصر'),
(77528, 3285553056, 3285553087, 'BE', 'BEL', 'بلجيكا'),
(77529, 3285553088, 3285553151, 'IT', 'ITA', 'إيطاليا'),
(77530, 3285553152, 3285553215, 'DE', 'DEU', 'ألمانيا'),
(77531, 3285553216, 3285553247, 'BE', 'BEL', 'بلجيكا'),
(77532, 3285553248, 3285553263, 'PL', 'POL', 'بولندا'),
(77533, 3285553264, 3285553727, 'DE', 'DEU', 'ألمانيا'),
(77534, 3285553728, 3285553759, 'CH', 'CHE', 'سويسرا'),
(77535, 3285553760, 3285553767, 'GB', 'GBR', 'المملكة المتحدة'),
(77536, 3285553768, 3285553775, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77537, 3285553776, 3285553791, 'FR', 'FRA', 'فرنسا'),
(77538, 3285553792, 3285553855, 'BE', 'BEL', 'بلجيكا'),
(77539, 3285553856, 3285553887, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77540, 3285553888, 3285553919, 'DE', 'DEU', 'ألمانيا'),
(77541, 3285553920, 3285554047, 'CH', 'CHE', 'سويسرا'),
(77542, 3285554048, 3285554127, 'DE', 'DEU', 'ألمانيا'),
(77543, 3285554128, 3285554143, 'BE', 'BEL', 'بلجيكا'),
(77544, 3285554144, 3285554175, 'GB', 'GBR', 'المملكة المتحدة'),
(77545, 3285554176, 3285554431, 'AT', 'AUT', 'النمسا'),
(77546, 3285554432, 3285554687, 'BE', 'BEL', 'بلجيكا'),
(77547, 3285554688, 3285554703, 'DE', 'DEU', 'ألمانيا'),
(77548, 3285554704, 3285554719, 'BE', 'BEL', 'بلجيكا'),
(77549, 3285554720, 3285554751, 'FR', 'FRA', 'فرنسا'),
(77550, 3285554752, 3285554815, 'BE', 'BEL', 'بلجيكا'),
(77551, 3285554816, 3285554943, 'CH', 'CHE', 'سويسرا'),
(77552, 3285554944, 3285555199, 'LU', 'LUX', 'لوكسيمبورغ'),
(77553, 3285555200, 3285555231, 'AT', 'AUT', 'النمسا'),
(77554, 3285555232, 3285555263, 'NL', 'NLD', 'هولندا'),
(77555, 3285555264, 3285555327, 'FR', 'FRA', 'فرنسا'),
(77556, 3285555328, 3285555455, 'IL', 'ISR', 'إسرائيل'),
(77557, 3285555456, 3285555711, 'BE', 'BEL', 'بلجيكا'),
(77558, 3285555712, 3285555967, 'LU', 'LUX', 'لوكسيمبورغ'),
(77559, 3285555968, 3285556223, 'IT', 'ITA', 'إيطاليا'),
(77560, 3285556224, 3285556479, 'BE', 'BEL', 'بلجيكا'),
(77561, 3285556480, 3285556735, 'DE', 'DEU', 'ألمانيا'),
(77562, 3285556736, 3285556767, 'CH', 'CHE', 'سويسرا'),
(77563, 3285556768, 3285556775, 'BE', 'BEL', 'بلجيكا'),
(77564, 3285556776, 3285556779, 'NL', 'NLD', 'هولندا'),
(77565, 3285556780, 3285556799, 'BE', 'BEL', 'بلجيكا'),
(77566, 3285556800, 3285556863, 'DE', 'DEU', 'ألمانيا'),
(77567, 3285556864, 3285556991, 'BE', 'BEL', 'بلجيكا'),
(77568, 3285556992, 3285557055, 'GB', 'GBR', 'المملكة المتحدة'),
(77569, 3285557056, 3285557119, 'NL', 'NLD', 'هولندا'),
(77570, 3285557120, 3285557247, 'DE', 'DEU', 'ألمانيا'),
(77571, 3285557248, 3285557363, 'NL', 'NLD', 'هولندا'),
(77572, 3285557364, 3285557375, 'BE', 'BEL', 'بلجيكا'),
(77573, 3285557376, 3285557519, 'NL', 'NLD', 'هولندا'),
(77574, 3285557520, 3285557535, 'FI', 'FIN', 'فنلندا'),
(77575, 3285557536, 3285557575, 'NL', 'NLD', 'هولندا'),
(77576, 3285557576, 3285557579, 'SE', 'SWE', 'السويد'),
(77577, 3285557580, 3285557583, 'BE', 'BEL', 'بلجيكا'),
(77578, 3285557584, 3285557599, 'NL', 'NLD', 'هولندا'),
(77579, 3285557600, 3285557631, 'BE', 'BEL', 'بلجيكا'),
(77580, 3285557632, 3285557791, 'NL', 'NLD', 'هولندا'),
(77581, 3285557792, 3285557823, 'NO', 'NOR', 'النرويج'),
(77582, 3285557824, 3285557887, 'SE', 'SWE', 'السويد'),
(77583, 3285557888, 3285557911, 'CH', 'CHE', 'سويسرا'),
(77584, 3285557912, 3285557919, 'CZ', 'CZE', 'التشيك'),
(77585, 3285557920, 3285557951, 'FR', 'FRA', 'فرنسا'),
(77586, 3285557952, 3285558015, 'DE', 'DEU', 'ألمانيا'),
(77587, 3285558016, 3285558271, 'NL', 'NLD', 'هولندا'),
(77588, 3285558272, 3285558463, 'BE', 'BEL', 'بلجيكا'),
(77589, 3285558464, 3285558591, 'NL', 'NLD', 'هولندا'),
(77590, 3285558592, 3285558655, 'BE', 'BEL', 'بلجيكا'),
(77591, 3285558656, 3285558783, 'IT', 'ITA', 'إيطاليا'),
(77592, 3285558784, 3285559039, 'GB', 'GBR', 'المملكة المتحدة'),
(77593, 3285559040, 3285559167, 'BE', 'BEL', 'بلجيكا'),
(77594, 3285559168, 3285559231, 'NL', 'NLD', 'هولندا'),
(77595, 3285559232, 3285559295, 'BE', 'BEL', 'بلجيكا'),
(77596, 3285559296, 3285559807, 'SE', 'SWE', 'السويد'),
(77597, 3285559808, 3285559839, 'IE', 'IRL', 'إيرلندا'),
(77598, 3285559840, 3285559871, 'CH', 'CHE', 'سويسرا'),
(77599, 3285559872, 3285559887, 'BE', 'BEL', 'بلجيكا'),
(77600, 3285559888, 3285559903, 'SE', 'SWE', 'السويد'),
(77601, 3285559904, 3285559919, 'NL', 'NLD', 'هولندا'),
(77602, 3285559920, 3285559935, 'SE', 'SWE', 'السويد'),
(77603, 3285559936, 3285560063, 'NO', 'NOR', 'النرويج'),
(77604, 3285560064, 3285560351, 'SE', 'SWE', 'السويد'),
(77605, 3285560352, 3285560383, 'ES', 'ESP', 'إسبانيا'),
(77606, 3285560384, 3285560447, 'SE', 'SWE', 'السويد'),
(77607, 3285560448, 3285560479, 'LI', 'LIE', 'ليختنشتاين'),
(77608, 3285560480, 3285560511, 'CH', 'CHE', 'سويسرا'),
(77609, 3285560512, 3285560575, 'BE', 'BEL', 'بلجيكا'),
(77610, 3285560576, 3285560831, 'DE', 'DEU', 'ألمانيا'),
(77611, 3285560832, 3285561215, 'SE', 'SWE', 'السويد'),
(77612, 3285561216, 3285561343, 'NO', 'NOR', 'النرويج'),
(77613, 3285561344, 3285561407, 'GB', 'GBR', 'المملكة المتحدة'),
(77614, 3285561408, 3285561471, 'PL', 'POL', 'بولندا'),
(77615, 3285561472, 3285561599, 'DK', 'DNK', 'الدنيمارك'),
(77616, 3285561600, 3285561619, 'NO', 'NOR', 'النرويج'),
(77617, 3285561620, 3285561623, 'DE', 'DEU', 'ألمانيا'),
(77618, 3285561624, 3285561647, 'BE', 'BEL', 'بلجيكا'),
(77619, 3285561648, 3285561663, 'NO', 'NOR', 'النرويج'),
(77620, 3285561664, 3285561727, 'BE', 'BEL', 'بلجيكا'),
(77621, 3285561728, 3285561791, 'NO', 'NOR', 'النرويج'),
(77622, 3285561792, 3285561919, 'BE', 'BEL', 'بلجيكا'),
(77623, 3285561920, 3285561951, 'CH', 'CHE', 'سويسرا'),
(77624, 3285561952, 3285561967, 'NO', 'NOR', 'النرويج'),
(77625, 3285561968, 3285561983, 'BE', 'BEL', 'بلجيكا'),
(77626, 3285561984, 3285562111, 'FI', 'FIN', 'فنلندا'),
(77627, 3285562112, 3285562367, 'NO', 'NOR', 'النرويج'),
(77628, 3285562368, 3285562751, 'FI', 'FIN', 'فنلندا'),
(77629, 3285562752, 3285562783, 'NL', 'NLD', 'هولندا'),
(77630, 3285562784, 3285562815, 'BE', 'BEL', 'بلجيكا'),
(77631, 3285562816, 3285562879, 'IT', 'ITA', 'إيطاليا'),
(77632, 3285562880, 3285562911, 'FI', 'FIN', 'فنلندا'),
(77633, 3285562912, 3285562943, 'BE', 'BEL', 'بلجيكا'),
(77634, 3285562944, 3285562975, 'DE', 'DEU', 'ألمانيا'),
(77635, 3285562976, 3285562991, 'FI', 'FIN', 'فنلندا'),
(77636, 3285562992, 3285562999, 'BE', 'BEL', 'بلجيكا'),
(77637, 3285563000, 3285563007, 'GB', 'GBR', 'المملكة المتحدة'),
(77638, 3285563008, 3285563135, 'SE', 'SWE', 'السويد'),
(77639, 3285563136, 3285563391, 'FI', 'FIN', 'فنلندا'),
(77640, 3285563392, 3285563455, 'BE', 'BEL', 'بلجيكا'),
(77641, 3285563456, 3285563471, 'NL', 'NLD', 'هولندا'),
(77642, 3285563472, 3285563487, 'BE', 'BEL', 'بلجيكا'),
(77643, 3285563488, 3285563519, 'SE', 'SWE', 'السويد'),
(77644, 3285563520, 3285563647, 'PL', 'POL', 'بولندا'),
(77645, 3285563648, 3285563903, 'CH', 'CHE', 'سويسرا'),
(77646, 3285563904, 3285564031, 'SE', 'SWE', 'السويد'),
(77647, 3285564032, 3285564159, 'FI', 'FIN', 'فنلندا'),
(77648, 3285564160, 3285564415, 'GB', 'GBR', 'المملكة المتحدة'),
(77649, 3285564416, 3285564511, 'CH', 'CHE', 'سويسرا'),
(77650, 3285564512, 3285564543, 'NO', 'NOR', 'النرويج'),
(77651, 3285564544, 3285564671, 'BE', 'BEL', 'بلجيكا'),
(77652, 3285564672, 3285564735, 'CH', 'CHE', 'سويسرا'),
(77653, 3285564736, 3285564751, 'FR', 'FRA', 'فرنسا'),
(77654, 3285564752, 3285564767, 'BE', 'BEL', 'بلجيكا'),
(77655, 3285564768, 3285564799, 'SE', 'SWE', 'السويد'),
(77656, 3285564800, 3285564927, 'BE', 'BEL', 'بلجيكا'),
(77657, 3285564928, 3285565183, 'FR', 'FRA', 'فرنسا'),
(77658, 3285565184, 3285565439, 'NL', 'NLD', 'هولندا'),
(77659, 3285565440, 3285565951, 'GB', 'GBR', 'المملكة المتحدة'),
(77660, 3285565952, 3285566015, 'FR', 'FRA', 'فرنسا'),
(77661, 3285566016, 3285566031, 'IT', 'ITA', 'إيطاليا'),
(77662, 3285566032, 3285566047, 'BE', 'BEL', 'بلجيكا'),
(77663, 3285566048, 3285566079, 'CH', 'CHE', 'سويسرا'),
(77664, 3285566080, 3285566143, 'FR', 'FRA', 'فرنسا'),
(77665, 3285566144, 3285566207, 'BE', 'BEL', 'بلجيكا'),
(77666, 3285566208, 3285566495, 'RU', 'RUS', 'الإتحاد الروسي'),
(77667, 3285566496, 3285566511, 'SE', 'SWE', 'السويد'),
(77668, 3285566512, 3285566527, 'FI', 'FIN', 'فنلندا'),
(77669, 3285566528, 3285566559, 'CH', 'CHE', 'سويسرا'),
(77670, 3285566560, 3285566575, 'BE', 'BEL', 'بلجيكا'),
(77671, 3285566576, 3285566591, 'CH', 'CHE', 'سويسرا'),
(77672, 3285566592, 3285566655, 'NL', 'NLD', 'هولندا'),
(77673, 3285566656, 3285566847, 'BE', 'BEL', 'بلجيكا'),
(77674, 3285566848, 3285566975, 'FR', 'FRA', 'فرنسا'),
(77675, 3285566976, 3285567231, 'GB', 'GBR', 'المملكة المتحدة'),
(77676, 3285567232, 3285567487, 'PT', 'PRT', 'البورتوغال'),
(77677, 3285567488, 3285568511, 'NL', 'NLD', 'هولندا'),
(77678, 3285568512, 3285568671, 'DE', 'DEU', 'ألمانيا'),
(77679, 3285568672, 3285568703, 'CH', 'CHE', 'سويسرا'),
(77680, 3285568704, 3285568751, 'BE', 'BEL', 'بلجيكا'),
(77681, 3285568752, 3285569023, 'DE', 'DEU', 'ألمانيا'),
(77682, 3285569024, 3285569407, 'BE', 'BEL', 'بلجيكا'),
(77683, 3285569408, 3285569535, 'GB', 'GBR', 'المملكة المتحدة'),
(77684, 3285569536, 3285569791, 'DE', 'DEU', 'ألمانيا'),
(77685, 3285569792, 3285570047, 'FI', 'FIN', 'فنلندا'),
(77686, 3285570048, 3285570175, 'FR', 'FRA', 'فرنسا'),
(77687, 3285570176, 3285570207, 'BE', 'BEL', 'بلجيكا'),
(77688, 3285570208, 3285570223, 'PL', 'POL', 'بولندا'),
(77689, 3285570224, 3285570239, 'NL', 'NLD', 'هولندا'),
(77690, 3285570240, 3285570559, 'BE', 'BEL', 'بلجيكا'),
(77691, 3285570560, 3285570815, 'SE', 'SWE', 'السويد'),
(77692, 3285570816, 3285571071, 'IT', 'ITA', 'إيطاليا'),
(77693, 3285571072, 3285571327, 'DE', 'DEU', 'ألمانيا'),
(77694, 3285571328, 3285571583, 'FI', 'FIN', 'فنلندا'),
(77695, 3285571584, 3285571711, 'FR', 'FRA', 'فرنسا'),
(77696, 3285571712, 3285571775, 'SE', 'SWE', 'السويد'),
(77697, 3285571776, 3285571807, 'BE', 'BEL', 'بلجيكا'),
(77698, 3285571808, 3285571839, 'DE', 'DEU', 'ألمانيا'),
(77699, 3285571840, 3285571903, 'BE', 'BEL', 'بلجيكا'),
(77700, 3285571904, 3285571967, 'SE', 'SWE', 'السويد'),
(77701, 3285571968, 3285572095, 'BE', 'BEL', 'بلجيكا'),
(77702, 3285572096, 3285572223, 'DE', 'DEU', 'ألمانيا'),
(77703, 3285572224, 3285572351, 'FI', 'FIN', 'فنلندا'),
(77704, 3285572352, 3285572367, 'IR', 'IRN', 'إيران'),
(77705, 3285572368, 3285572383, 'ES', 'ESP', 'إسبانيا'),
(77706, 3285572384, 3285572447, 'BE', 'BEL', 'بلجيكا'),
(77707, 3285572448, 3285572479, 'CH', 'CHE', 'سويسرا'),
(77708, 3285572480, 3285572607, 'FR', 'FRA', 'فرنسا'),
(77709, 3285572608, 3285572863, 'DK', 'DNK', 'الدنيمارك'),
(77710, 3285572864, 3285573119, 'IT', 'ITA', 'إيطاليا'),
(77711, 3285573120, 3285573375, 'SE', 'SWE', 'السويد'),
(77712, 3285573376, 3285573535, 'BE', 'BEL', 'بلجيكا'),
(77713, 3285573536, 3285573567, 'CH', 'CHE', 'سويسرا'),
(77714, 3285573568, 3285573631, 'FR', 'FRA', 'فرنسا'),
(77715, 3285573632, 3285573887, 'NL', 'NLD', 'هولندا'),
(77716, 3285573888, 3285573951, 'IL', 'ISR', 'إسرائيل'),
(77717, 3285573952, 3285574143, 'BE', 'BEL', 'بلجيكا'),
(77718, 3285574144, 3285574399, 'RU', 'RUS', 'الإتحاد الروسي'),
(77719, 3285574400, 3285574655, 'IL', 'ISR', 'إسرائيل'),
(77720, 3285574656, 3285574911, 'GB', 'GBR', 'المملكة المتحدة'),
(77721, 3285574912, 3285575167, 'IL', 'ISR', 'إسرائيل'),
(77722, 3285575168, 3285575423, 'ES', 'ESP', 'إسبانيا'),
(77723, 3285575424, 3285575679, 'IL', 'ISR', 'إسرائيل'),
(77724, 3285575680, 3285575935, 'BE', 'BEL', 'بلجيكا'),
(77725, 3285575936, 3285575999, 'DK', 'DNK', 'الدنيمارك'),
(77726, 3285576000, 3285576063, 'BE', 'BEL', 'بلجيكا'),
(77727, 3285576064, 3285576127, 'FR', 'FRA', 'فرنسا'),
(77728, 3285576128, 3285576159, 'BE', 'BEL', 'بلجيكا'),
(77729, 3285576160, 3285576191, 'DK', 'DNK', 'الدنيمارك'),
(77730, 3285576192, 3285576447, 'BE', 'BEL', 'بلجيكا'),
(77731, 3285576448, 3285576703, 'CZ', 'CZE', 'التشيك'),
(77732, 3285576704, 3285576959, 'HU', 'HUN', 'هنغاريا'),
(77733, 3285576960, 3285577215, 'BE', 'BEL', 'بلجيكا'),
(77734, 3285577216, 3285577471, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77735, 3285577472, 3285577599, 'IT', 'ITA', 'إيطاليا'),
(77736, 3285577600, 3285577983, 'BE', 'BEL', 'بلجيكا'),
(77737, 3285577984, 3285578111, 'IT', 'ITA', 'إيطاليا'),
(77738, 3285578112, 3285578239, 'DE', 'DEU', 'ألمانيا'),
(77739, 3285578240, 3285578367, 'BE', 'BEL', 'بلجيكا'),
(77740, 3285578368, 3285578431, 'FR', 'FRA', 'فرنسا'),
(77741, 3285578432, 3285578495, 'BE', 'BEL', 'بلجيكا'),
(77742, 3285578496, 3285578751, 'DE', 'DEU', 'ألمانيا'),
(77743, 3285578752, 3285579007, 'BE', 'BEL', 'بلجيكا'),
(77744, 3285579008, 3285579519, 'ES', 'ESP', 'إسبانيا'),
(77745, 3285579520, 3285579775, 'FR', 'FRA', 'فرنسا'),
(77746, 3285579776, 3285580031, 'US', 'USA', 'الولايات المتحدة'),
(77747, 3285580032, 3285580287, 'HU', 'HUN', 'هنغاريا'),
(77748, 3285580288, 3285580415, 'DE', 'DEU', 'ألمانيا'),
(77749, 3285580416, 3285580543, 'BE', 'BEL', 'بلجيكا'),
(77750, 3285580544, 3285580547, 'NL', 'NLD', 'هولندا'),
(77751, 3285580548, 3285580651, 'BE', 'BEL', 'بلجيكا'),
(77752, 3285580652, 3285580655, 'SE', 'SWE', 'السويد'),
(77753, 3285580656, 3285580799, 'BE', 'BEL', 'بلجيكا'),
(77754, 3285580800, 3285580831, 'SE', 'SWE', 'السويد'),
(77755, 3285580832, 3285580847, 'PL', 'POL', 'بولندا'),
(77756, 3285580848, 3285580927, 'BE', 'BEL', 'بلجيكا'),
(77757, 3285580928, 3285581055, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(77758, 3285581056, 3285581503, 'BE', 'BEL', 'بلجيكا'),
(77759, 3285581504, 3285581567, 'AT', 'AUT', 'النمسا'),
(77760, 3285581568, 3285581599, 'FR', 'FRA', 'فرنسا'),
(77761, 3285581600, 3285581615, 'GB', 'GBR', 'المملكة المتحدة'),
(77762, 3285581616, 3285581695, 'FR', 'FRA', 'فرنسا'),
(77763, 3285581696, 3285581759, 'LV', 'LVA', 'لاتفيا'),
(77764, 3285581760, 3285581823, 'FR', 'FRA', 'فرنسا'),
(77765, 3285581824, 3285595135, 'DE', 'DEU', 'ألمانيا'),
(77766, 3285595136, 3285595167, 'CZ', 'CZE', 'التشيك'),
(77767, 3285595168, 3285595175, 'US', 'USA', 'الولايات المتحدة'),
(77768, 3285595176, 3285595263, 'DE', 'DEU', 'ألمانيا'),
(77769, 3285595264, 3285595423, 'US', 'USA', 'الولايات المتحدة'),
(77770, 3285595424, 3285596159, 'DE', 'DEU', 'ألمانيا'),
(77771, 3285596160, 3285596191, 'US', 'USA', 'الولايات المتحدة'),
(77772, 3285596192, 3285596223, 'DE', 'DEU', 'ألمانيا'),
(77773, 3285596224, 3285596255, 'US', 'USA', 'الولايات المتحدة'),
(77774, 3285596256, 3285596287, 'DE', 'DEU', 'ألمانيا'),
(77775, 3285596288, 3285596319, 'US', 'USA', 'الولايات المتحدة'),
(77776, 3285596320, 3285596351, 'DE', 'DEU', 'ألمانيا'),
(77777, 3285596352, 3285596383, 'FR', 'FRA', 'فرنسا'),
(77778, 3285596384, 3285597183, 'DE', 'DEU', 'ألمانيا'),
(77779, 3285597184, 3285597215, 'US', 'USA', 'الولايات المتحدة'),
(77780, 3285597216, 3285606399, 'DE', 'DEU', 'ألمانيا'),
(77781, 3285606400, 3285614591, 'GB', 'GBR', 'المملكة المتحدة'),
(77782, 3285614592, 3285630975, 'TR', 'TUR', 'تركيا'),
(77783, 3285630976, 3285633023, 'UA', 'UKR', 'أوكرانيا'),
(77784, 3285633024, 3285635071, 'NO', 'NOR', 'النرويج'),
(77785, 3285635072, 3285637119, 'UA', 'UKR', 'أوكرانيا'),
(77786, 3285637120, 3285638143, 'DE', 'DEU', 'ألمانيا'),
(77787, 3285638144, 3285639167, 'UA', 'UKR', 'أوكرانيا'),
(77788, 3285639168, 3285641215, 'FR', 'FRA', 'فرنسا'),
(77789, 3285641216, 3285642239, 'RU', 'RUS', 'الإتحاد الروسي'),
(77790, 3285642240, 3285643263, 'UA', 'UKR', 'أوكرانيا'),
(77791, 3285643264, 3285645311, 'FR', 'FRA', 'فرنسا'),
(77792, 3285645312, 3285647359, 'BG', 'BGR', 'بلغاريا'),
(77793, 3285647360, 3285712895, 'DK', 'DNK', 'الدنيمارك'),
(77794, 3285712896, 3285721087, 'GB', 'GBR', 'المملكة المتحدة'),
(77795, 3285721088, 3285729279, 'SE', 'SWE', 'السويد'),
(77796, 3285729280, 3285734143, 'CH', 'CHE', 'سويسرا'),
(77797, 3285734144, 3285734159, 'GB', 'GBR', 'المملكة المتحدة'),
(77798, 3285734160, 3285734335, 'CH', 'CHE', 'سويسرا'),
(77799, 3285734336, 3285734351, 'LI', 'LIE', 'ليختنشتاين'),
(77800, 3285734352, 3285737471, 'CH', 'CHE', 'سويسرا'),
(77801, 3285737472, 3285745663, 'PL', 'POL', 'بولندا'),
(77802, 3285745664, 3285753855, 'IT', 'ITA', 'إيطاليا'),
(77803, 3285753856, 3285762047, 'LV', 'LVA', 'لاتفيا'),
(77804, 3285762048, 3285762559, 'FR', 'FRA', 'فرنسا'),
(77805, 3285762560, 3285763071, 'RU', 'RUS', 'الإتحاد الروسي'),
(77806, 3285763072, 3285763583, 'GB', 'GBR', 'المملكة المتحدة'),
(77807, 3285763584, 3285764095, 'DE', 'DEU', 'ألمانيا'),
(77808, 3285764608, 3285765119, 'RU', 'RUS', 'الإتحاد الروسي'),
(77809, 3285765120, 3285766143, 'UA', 'UKR', 'أوكرانيا'),
(77810, 3285766144, 3285766655, 'DE', 'DEU', 'ألمانيا'),
(77811, 3285766656, 3285767679, 'UA', 'UKR', 'أوكرانيا'),
(77812, 3285767680, 3285768191, 'FR', 'FRA', 'فرنسا'),
(77813, 3285768192, 3285768703, 'RU', 'RUS', 'الإتحاد الروسي'),
(77814, 3285768704, 3285769215, 'CH', 'CHE', 'سويسرا'),
(77815, 3285769216, 3285769727, 'DE', 'DEU', 'ألمانيا'),
(77816, 3285769728, 3285770239, 'RO', 'ROM', 'رومانيا'),
(77817, 3285770240, 3285770495, 'NL', 'NLD', 'هولندا'),
(77818, 3285770496, 3285770751, 'US', 'USA', 'الولايات المتحدة'),
(77819, 3285770752, 3285771007, 'UA', 'UKR', 'أوكرانيا'),
(77820, 3285771008, 3285771263, 'CH', 'CHE', 'سويسرا'),
(77821, 3285771264, 3285771519, 'BG', 'BGR', 'بلغاريا'),
(77822, 3285771520, 3285771775, 'AT', 'AUT', 'النمسا'),
(77823, 3285771776, 3285772031, 'RO', 'ROM', 'رومانيا'),
(77824, 3285772032, 3285772287, 'SE', 'SWE', 'السويد'),
(77825, 3285772288, 3285772543, 'TR', 'TUR', 'تركيا'),
(77826, 3285772544, 3285772799, 'LT', 'LTU', 'ليتوانيا'),
(77827, 3285772800, 3285773055, 'MT', 'MLT', 'مالطا'),
(77828, 3285773056, 3285773311, 'DE', 'DEU', 'ألمانيا'),
(77829, 3285773312, 3285773567, 'LV', 'LVA', 'لاتفيا'),
(77830, 3285773568, 3285773823, 'KG', 'KGZ', 'قيرغيزستان'),
(77831, 3285773824, 3285774079, 'RU', 'RUS', 'الإتحاد الروسي'),
(77832, 3285774080, 3285774335, 'RO', 'ROM', 'رومانيا'),
(77833, 3285774336, 3285774591, 'CZ', 'CZE', 'التشيك'),
(77834, 3285774592, 3285774847, 'RU', 'RUS', 'الإتحاد الروسي'),
(77835, 3285774848, 3285775103, 'FR', 'FRA', 'فرنسا'),
(77836, 3285775104, 3285775359, 'GB', 'GBR', 'المملكة المتحدة'),
(77837, 3285775360, 3285775615, 'RU', 'RUS', 'الإتحاد الروسي'),
(77838, 3285775616, 3285775871, 'NG', 'NGA', 'نيجيريا'),
(77839, 3285775872, 3285776127, 'NL', 'NLD', 'هولندا'),
(77840, 3285776128, 3285776383, 'RO', 'ROM', 'رومانيا'),
(77841, 3285776384, 3285776639, 'UA', 'UKR', 'أوكرانيا'),
(77842, 3285776640, 3285776895, 'FR', 'FRA', 'فرنسا'),
(77843, 3285776896, 3285777151, 'PL', 'POL', 'بولندا'),
(77844, 3285777152, 3285777407, 'HU', 'HUN', 'هنغاريا'),
(77845, 3285777408, 3285777663, 'IL', 'ISR', 'إسرائيل'),
(77846, 3285777920, 3285778175, 'PL', 'POL', 'بولندا'),
(77847, 3285778176, 3285778431, 'DE', 'DEU', 'ألمانيا'),
(77848, 3285778432, 3285843967, 'GB', 'GBR', 'المملكة المتحدة'),
(77849, 3285843968, 3285852159, 'LU', 'LUX', 'لوكسيمبورغ'),
(77850, 3285852160, 3285860351, 'GB', 'GBR', 'المملكة المتحدة'),
(77851, 3285860352, 3285868543, 'FI', 'FIN', 'فنلندا'),
(77852, 3285868544, 3285876735, 'IE', 'IRL', 'إيرلندا'),
(77853, 3285876736, 3285909503, 'RU', 'RUS', 'الإتحاد الروسي'),
(77854, 3285909504, 3285910015, 'GB', 'GBR', 'المملكة المتحدة'),
(77855, 3285910272, 3285910303, 'ES', 'ESP', 'إسبانيا'),
(77856, 3285910400, 3285910407, 'IT', 'ITA', 'إيطاليا'),
(77857, 3285910408, 3285910463, 'GB', 'GBR', 'المملكة المتحدة'),
(77858, 3285910464, 3285910527, 'ES', 'ESP', 'إسبانيا'),
(77859, 3285910528, 3285911551, 'GB', 'GBR', 'المملكة المتحدة'),
(77860, 3285912576, 3285913087, 'GB', 'GBR', 'المملكة المتحدة'),
(77861, 3285913088, 3285913215, 'ES', 'ESP', 'إسبانيا'),
(77862, 3285913344, 3285913599, 'GB', 'GBR', 'المملكة المتحدة'),
(77863, 3285915648, 3285915903, 'GB', 'GBR', 'المملكة المتحدة'),
(77864, 3285915904, 3285916159, 'AT', 'AUT', 'النمسا'),
(77865, 3285916160, 3285916415, 'FR', 'FRA', 'فرنسا'),
(77866, 3285916416, 3285916671, 'YE', 'YEM', 'اليمن'),
(77867, 3285916672, 3285916703, 'BH', 'BHR', 'البحرين'),
(77868, 3285916704, 3285916711, 'DE', 'DEU', 'ألمانيا'),
(77869, 3285916712, 3285916719, 'CY', 'CYP', 'قبرص'),
(77870, 3285916720, 3285916735, 'ES', 'ESP', 'إسبانيا'),
(77871, 3285916736, 3285916799, 'GB', 'GBR', 'المملكة المتحدة'),
(77872, 3285916928, 3285917183, 'YE', 'YEM', 'اليمن'),
(77873, 3285917184, 3285917439, 'ES', 'ESP', 'إسبانيا'),
(77874, 3285917440, 3285917695, 'YE', 'YEM', 'اليمن'),
(77875, 3285918976, 3285919231, 'YE', 'YEM', 'اليمن'),
(77876, 3285919232, 3285919487, 'GB', 'GBR', 'المملكة المتحدة'),
(77877, 3285919488, 3285919743, 'UA', 'UKR', 'أوكرانيا'),
(77878, 3285919744, 3285921791, 'QA', 'QAT', 'قطر'),
(77879, 3285921792, 3285921823, 'CZ', 'CZE', 'التشيك'),
(77880, 3285921824, 3285921855, 'GB', 'GBR', 'المملكة المتحدة'),
(77881, 3285921920, 3285921983, 'GB', 'GBR', 'المملكة المتحدة'),
(77882, 3285922112, 3285922175, 'FR', 'FRA', 'فرنسا'),
(77883, 3285922176, 3285922183, 'GB', 'GBR', 'المملكة المتحدة'),
(77884, 3285922184, 3285922191, 'RU', 'RUS', 'الإتحاد الروسي'),
(77885, 3285922192, 3285922207, 'DE', 'DEU', 'ألمانيا'),
(77886, 3285922208, 3285922239, 'ES', 'ESP', 'إسبانيا'),
(77887, 3285922240, 3285922303, 'RU', 'RUS', 'الإتحاد الروسي'),
(77888, 3285922560, 3285922815, 'GB', 'GBR', 'المملكة المتحدة'),
(77889, 3285922816, 3285923327, 'KW', 'KWT', 'الكويت'),
(77890, 3285923328, 3285924415, 'ES', 'ESP', 'إسبانيا'),
(77891, 3285924416, 3285924431, 'DE', 'DEU', 'ألمانيا'),
(77892, 3285924432, 3285924479, 'GB', 'GBR', 'المملكة المتحدة'),
(77893, 3285924480, 3285924863, 'ES', 'ESP', 'إسبانيا'),
(77894, 3285925888, 3285926143, 'NL', 'NLD', 'هولندا'),
(77895, 3285926144, 3285926399, 'YE', 'YEM', 'اليمن'),
(77896, 3285926400, 3285926407, 'GB', 'GBR', 'المملكة المتحدة'),
(77897, 3285926408, 3285926415, 'ES', 'ESP', 'إسبانيا'),
(77898, 3285926416, 3285926431, 'GB', 'GBR', 'المملكة المتحدة'),
(77899, 3285926432, 3285926463, 'CH', 'CHE', 'سويسرا'),
(77900, 3285926848, 3285926911, 'GB', 'GBR', 'المملكة المتحدة'),
(77901, 3285926912, 3285927423, 'DE', 'DEU', 'ألمانيا'),
(77902, 3285927424, 3285927679, 'GB', 'GBR', 'المملكة المتحدة'),
(77903, 3285927680, 3285927935, 'IR', 'IRN', 'إيران'),
(77904, 3285928064, 3285928191, 'ES', 'ESP', 'إسبانيا'),
(77905, 3285928192, 3285928207, 'PL', 'POL', 'بولندا'),
(77906, 3285928208, 3285928223, 'GB', 'GBR', 'المملكة المتحدة'),
(77907, 3285928224, 3285928255, 'DE', 'DEU', 'ألمانيا'),
(77908, 3285928256, 3285928271, 'GB', 'GBR', 'المملكة المتحدة'),
(77909, 3285928272, 3285928287, 'DE', 'DEU', 'ألمانيا'),
(77910, 3285928448, 3285928959, 'ES', 'ESP', 'إسبانيا'),
(77911, 3285929984, 3285930495, 'GB', 'GBR', 'المملكة المتحدة'),
(77912, 3285930560, 3285930575, 'ES', 'ESP', 'إسبانيا'),
(77913, 3285930576, 3285930623, 'GB', 'GBR', 'المملكة المتحدة'),
(77914, 3285930632, 3285930639, 'GB', 'GBR', 'المملكة المتحدة'),
(77915, 3285930640, 3285930655, 'ES', 'ESP', 'إسبانيا'),
(77916, 3285930680, 3285930687, 'DE', 'DEU', 'ألمانيا'),
(77917, 3285930752, 3285931007, 'GB', 'GBR', 'المملكة المتحدة'),
(77918, 3285932032, 3285932287, 'NL', 'NLD', 'هولندا'),
(77919, 3285932288, 3285932799, 'GB', 'GBR', 'المملكة المتحدة'),
(77920, 3285932800, 3285933055, 'ES', 'ESP', 'إسبانيا'),
(77921, 3285933056, 3285933311, 'DE', 'DEU', 'ألمانيا'),
(77922, 3285933312, 3285933567, 'ES', 'ESP', 'إسبانيا'),
(77923, 3285933568, 3285934079, 'DE', 'DEU', 'ألمانيا'),
(77924, 3285934080, 3285934591, 'GB', 'GBR', 'المملكة المتحدة'),
(77925, 3285935104, 3285935615, 'GB', 'GBR', 'المملكة المتحدة'),
(77926, 3285938176, 3285938431, 'ES', 'ESP', 'إسبانيا'),
(77927, 3285938560, 3285938607, 'GB', 'GBR', 'المملكة المتحدة'),
(77928, 3285938632, 3285938639, 'ES', 'ESP', 'إسبانيا'),
(77929, 3285938640, 3285938655, 'GB', 'GBR', 'المملكة المتحدة'),
(77930, 3285938688, 3285938943, 'ES', 'ESP', 'إسبانيا'),
(77931, 3285938952, 3285938959, 'NL', 'NLD', 'هولندا'),
(77932, 3285938976, 3285939039, 'ES', 'ESP', 'إسبانيا'),
(77933, 3285939200, 3285939711, 'ES', 'ESP', 'إسبانيا'),
(77934, 3285940224, 3285940735, 'ES', 'ESP', 'إسبانيا'),
(77935, 3285940736, 3285941247, 'GB', 'GBR', 'المملكة المتحدة'),
(77936, 3285942656, 3285942783, 'IR', 'IRN', 'إيران'),
(77937, 3285942784, 3285943039, 'ES', 'ESP', 'إسبانيا'),
(77938, 3285943040, 3285943295, 'SE', 'SWE', 'السويد'),
(77939, 3285943296, 3285943551, 'ES', 'ESP', 'إسبانيا'),
(77940, 3285943552, 3285943559, 'DK', 'DNK', 'الدنيمارك'),
(77941, 3285943568, 3285943575, 'ES', 'ESP', 'إسبانيا'),
(77942, 3285943576, 3285943583, 'DE', 'DEU', 'ألمانيا'),
(77943, 3285943584, 3285943615, 'ES', 'ESP', 'إسبانيا'),
(77944, 3285943680, 3285943807, 'GB', 'GBR', 'المملكة المتحدة'),
(77945, 3285944320, 3285944831, 'US', 'USA', 'الولايات المتحدة'),
(77946, 3285944832, 3285945343, 'DK', 'DNK', 'الدنيمارك'),
(77947, 3285945344, 3285945599, 'ES', 'ESP', 'إسبانيا'),
(77948, 3285945664, 3285945695, 'FR', 'FRA', 'فرنسا'),
(77949, 3285945696, 3285945727, 'GB', 'GBR', 'المملكة المتحدة'),
(77950, 3285945856, 3285946111, 'GB', 'GBR', 'المملكة المتحدة'),
(77951, 3285946112, 3285946367, 'ES', 'ESP', 'إسبانيا'),
(77952, 3285946368, 3285946879, 'GB', 'GBR', 'المملكة المتحدة'),
(77953, 3285947392, 3285947647, 'DE', 'DEU', 'ألمانيا'),
(77954, 3285947648, 3285947903, 'ES', 'ESP', 'إسبانيا'),
(77955, 3285947904, 3285948159, 'NL', 'NLD', 'هولندا'),
(77956, 3285948160, 3285948671, 'GB', 'GBR', 'المملكة المتحدة'),
(77957, 3285948672, 3285948927, 'SA', 'SAU', 'السعودية'),
(77958, 3285949184, 3285949439, 'ES', 'ESP', 'إسبانيا'),
(77959, 3285949696, 3285949823, 'ES', 'ESP', 'إسبانيا'),
(77960, 3285949856, 3285949887, 'ES', 'ESP', 'إسبانيا'),
(77961, 3285949952, 3285950463, 'ES', 'ESP', 'إسبانيا'),
(77962, 3285950464, 3285950719, 'GB', 'GBR', 'المملكة المتحدة'),
(77963, 3285950720, 3285950783, 'US', 'USA', 'الولايات المتحدة'),
(77964, 3285950976, 3285951231, 'NL', 'NLD', 'هولندا'),
(77965, 3285951232, 3285951487, 'IT', 'ITA', 'إيطاليا'),
(77966, 3285951648, 3285951679, 'ES', 'ESP', 'إسبانيا'),
(77967, 3285951744, 3285951999, 'GB', 'GBR', 'المملكة المتحدة'),
(77968, 3285952000, 3285952255, 'IT', 'ITA', 'إيطاليا'),
(77969, 3285952256, 3285952511, 'SA', 'SAU', 'السعودية'),
(77970, 3285955584, 3285955839, 'DE', 'DEU', 'ألمانيا'),
(77971, 3285955840, 3285956095, 'ES', 'ESP', 'إسبانيا'),
(77972, 3285956096, 3285956351, 'FR', 'FRA', 'فرنسا'),
(77973, 3285956352, 3285956607, 'DE', 'DEU', 'ألمانيا'),
(77974, 3285956608, 3285956863, 'GB', 'GBR', 'المملكة المتحدة'),
(77975, 3285956864, 3285957631, 'PT', 'PRT', 'البورتوغال'),
(77976, 3285957632, 3285957887, 'PL', 'POL', 'بولندا'),
(77977, 3285957888, 3285958143, 'GB', 'GBR', 'المملكة المتحدة'),
(77978, 3285958848, 3285958895, 'NL', 'NLD', 'هولندا'),
(77979, 3285958912, 3285959039, 'GB', 'GBR', 'المملكة المتحدة'),
(77980, 3285959040, 3285959167, 'DE', 'DEU', 'ألمانيا'),
(77981, 3285959424, 3285959935, 'GB', 'GBR', 'المملكة المتحدة'),
(77982, 3285959936, 3285960191, 'ES', 'ESP', 'إسبانيا'),
(77983, 3285960192, 3285960447, 'FR', 'FRA', 'فرنسا'),
(77984, 3285960448, 3285960703, 'GB', 'GBR', 'المملكة المتحدة'),
(77985, 3285962752, 3285963775, 'DE', 'DEU', 'ألمانيا'),
(77986, 3285963776, 3285964287, 'GB', 'GBR', 'المملكة المتحدة'),
(77987, 3285964288, 3285964799, 'FR', 'FRA', 'فرنسا'),
(77988, 3285966848, 3285967103, 'FR', 'FRA', 'فرنسا'),
(77989, 3285967104, 3285967359, 'PL', 'POL', 'بولندا'),
(77990, 3285967360, 3285967615, 'ES', 'ESP', 'إسبانيا'),
(77991, 3285967616, 3285968383, 'BE', 'BEL', 'بلجيكا'),
(77992, 3285968384, 3285968639, 'ES', 'ESP', 'إسبانيا'),
(77993, 3285968640, 3285968895, 'PL', 'POL', 'بولندا'),
(77994, 3285971200, 3285971455, 'FR', 'FRA', 'فرنسا'),
(77995, 3285971456, 3285971711, 'DE', 'DEU', 'ألمانيا'),
(77996, 3285971712, 3285971967, 'GB', 'GBR', 'المملكة المتحدة'),
(77997, 3285971968, 3285972223, 'ES', 'ESP', 'إسبانيا'),
(77998, 3285972480, 3285972735, 'PL', 'POL', 'بولندا'),
(77999, 3285972736, 3285972991, 'FR', 'FRA', 'فرنسا'),
(78000, 3285972992, 3285975039, 'GB', 'GBR', 'المملكة المتحدة'),
(78001, 3285975040, 3286106111, 'FR', 'FRA', 'فرنسا'),
(78002, 3286106112, 3286106687, 'EE', 'EST', 'إستونيا'),
(78003, 3286106688, 3286106691, 'FI', 'FIN', 'فنلندا'),
(78004, 3286106692, 3286114303, 'EE', 'EST', 'إستونيا'),
(78005, 3286114304, 3286122495, 'BA', 'BIH', 'البوسنه والهرسك'),
(78006, 3286122496, 3286130687, 'BY', 'BLR', 'روسيا البيضاء'),
(78007, 3286130688, 3286131711, 'RS', 'SRB', 'صربيا'),
(78008, 3286131712, 3286132735, 'PL', 'POL', 'بولندا'),
(78009, 3286132736, 3286133759, 'RO', 'ROM', 'رومانيا'),
(78010, 3286133760, 3286134783, 'IE', 'IRL', 'إيرلندا'),
(78011, 3286134784, 3286135807, 'PL', 'POL', 'بولندا'),
(78012, 3286135808, 3286136831, 'NL', 'NLD', 'هولندا'),
(78013, 3286136832, 3286137855, 'AT', 'AUT', 'النمسا'),
(78014, 3286137856, 3286138879, 'UA', 'UKR', 'أوكرانيا'),
(78015, 3286138880, 3286155263, 'RU', 'RUS', 'الإتحاد الروسي'),
(78016, 3286155264, 3286171647, 'DE', 'DEU', 'ألمانيا'),
(78017, 3286171648, 3286237183, 'IT', 'ITA', 'إيطاليا'),
(78018, 3286237184, 3286243583, 'GB', 'GBR', 'المملكة المتحدة'),
(78019, 3286243584, 3286243839, 'US', 'USA', 'الولايات المتحدة'),
(78020, 3286243840, 3286245887, 'GB', 'GBR', 'المملكة المتحدة'),
(78021, 3286245888, 3286246143, 'US', 'USA', 'الولايات المتحدة'),
(78022, 3286246144, 3286254167, 'GB', 'GBR', 'المملكة المتحدة'),
(78023, 3286254168, 3286254175, 'NL', 'NLD', 'هولندا'),
(78024, 3286254176, 3286264879, 'GB', 'GBR', 'المملكة المتحدة'),
(78025, 3286264880, 3286264895, 'NL', 'NLD', 'هولندا'),
(78026, 3286264896, 3286279423, 'GB', 'GBR', 'المملكة المتحدة'),
(78027, 3286279424, 3286279679, 'US', 'USA', 'الولايات المتحدة'),
(78028, 3286279680, 3286289919, 'GB', 'GBR', 'المملكة المتحدة'),
(78029, 3286289920, 3286290175, 'US', 'USA', 'الولايات المتحدة'),
(78030, 3286290176, 3286291807, 'GB', 'GBR', 'المملكة المتحدة'),
(78031, 3286291808, 3286291823, 'US', 'USA', 'الولايات المتحدة'),
(78032, 3286291824, 3286302719, 'GB', 'GBR', 'المملكة المتحدة'),
(78033, 3286302720, 3286310911, 'NO', 'NOR', 'النرويج'),
(78034, 3286310912, 3286311423, 'CH', 'CHE', 'سويسرا'),
(78035, 3286311424, 3286311935, 'NL', 'NLD', 'هولندا'),
(78036, 3286311936, 3286312447, 'PL', 'POL', 'بولندا'),
(78037, 3286312448, 3286312959, 'RU', 'RUS', 'الإتحاد الروسي'),
(78038, 3286312960, 3286313983, 'RO', 'ROM', 'رومانيا'),
(78039, 3286313984, 3286314495, 'CH', 'CHE', 'سويسرا'),
(78040, 3286314496, 3286315007, 'IL', 'ISR', 'إسرائيل'),
(78041, 3286315520, 3286316031, 'DE', 'DEU', 'ألمانيا'),
(78042, 3286316032, 3286316543, 'UA', 'UKR', 'أوكرانيا'),
(78043, 3286316544, 3286317055, 'NL', 'NLD', 'هولندا'),
(78044, 3286317056, 3286317567, 'RU', 'RUS', 'الإتحاد الروسي'),
(78045, 3286317568, 3286318079, 'RO', 'ROM', 'رومانيا'),
(78046, 3286318080, 3286318591, 'CH', 'CHE', 'سويسرا'),
(78047, 3286319104, 3286320127, 'RO', 'ROM', 'رومانيا'),
(78048, 3286320128, 3286321151, 'PL', 'POL', 'بولندا'),
(78049, 3286321152, 3286322175, 'CZ', 'CZE', 'التشيك'),
(78050, 3286322176, 3286323199, 'PL', 'POL', 'بولندا'),
(78051, 3286323200, 3286324223, 'GB', 'GBR', 'المملكة المتحدة'),
(78052, 3286324224, 3286325247, 'RO', 'ROM', 'رومانيا'),
(78053, 3286325248, 3286326271, 'DK', 'DNK', 'الدنيمارك'),
(78054, 3286326272, 3286327295, 'PL', 'POL', 'بولندا'),
(78055, 3286327296, 3286329343, 'NL', 'NLD', 'هولندا'),
(78056, 3286329344, 3286330367, 'DE', 'DEU', 'ألمانيا'),
(78057, 3286330368, 3286331391, 'RO', 'ROM', 'رومانيا'),
(78058, 3286331392, 3286332415, 'UA', 'UKR', 'أوكرانيا'),
(78059, 3286332416, 3286333439, 'CH', 'CHE', 'سويسرا'),
(78060, 3286333440, 3286334463, 'PL', 'POL', 'بولندا'),
(78061, 3286334464, 3286335487, 'BG', 'BGR', 'بلغاريا'),
(78062, 3286335488, 3286336511, 'RU', 'RUS', 'الإتحاد الروسي'),
(78063, 3286336512, 3286337535, 'DE', 'DEU', 'ألمانيا'),
(78064, 3286338560, 3286339583, 'RO', 'ROM', 'رومانيا'),
(78065, 3286339584, 3286340607, 'UA', 'UKR', 'أوكرانيا'),
(78066, 3286340608, 3286342655, 'DE', 'DEU', 'ألمانيا'),
(78067, 3286342656, 3286343679, 'UA', 'UKR', 'أوكرانيا'),
(78068, 3286343680, 3286344703, 'RU', 'RUS', 'الإتحاد الروسي'),
(78069, 3286344704, 3286345727, 'BE', 'BEL', 'بلجيكا'),
(78070, 3286345728, 3286346751, 'IT', 'ITA', 'إيطاليا'),
(78071, 3286346752, 3286347775, 'UA', 'UKR', 'أوكرانيا'),
(78072, 3286347776, 3286348799, 'PA', 'PAN', 'بنما'),
(78073, 3286348800, 3286349823, 'PL', 'POL', 'بولندا'),
(78074, 3286349824, 3286350847, 'SE', 'SWE', 'السويد'),
(78075, 3286350848, 3286351871, 'GB', 'GBR', 'المملكة المتحدة'),
(78076, 3286351872, 3286352895, 'CH', 'CHE', 'سويسرا'),
(78077, 3286352896, 3286353919, 'DE', 'DEU', 'ألمانيا'),
(78078, 3286353920, 3286354943, 'LI', 'LIE', 'ليختنشتاين'),
(78079, 3286354944, 3286355967, 'FR', 'FRA', 'فرنسا'),
(78080, 3286355968, 3286356991, 'DE', 'DEU', 'ألمانيا'),
(78081, 3286356992, 3286358015, 'PL', 'POL', 'بولندا'),
(78082, 3286358016, 3286359039, 'GB', 'GBR', 'المملكة المتحدة'),
(78083, 3286359040, 3286360063, 'PT', 'PRT', 'البورتوغال'),
(78084, 3286360064, 3286361087, 'IT', 'ITA', 'إيطاليا'),
(78085, 3286361088, 3286362111, 'UA', 'UKR', 'أوكرانيا'),
(78086, 3286362112, 3286363135, 'RU', 'RUS', 'الإتحاد الروسي'),
(78087, 3286363136, 3286364159, 'AT', 'AUT', 'النمسا'),
(78088, 3286364160, 3286365183, 'DE', 'DEU', 'ألمانيا'),
(78089, 3286365184, 3286367231, 'PL', 'POL', 'بولندا'),
(78090, 3286367232, 3286368255, 'BG', 'BGR', 'بلغاريا'),
(78091, 3286368256, 3286376447, 'CH', 'CHE', 'سويسرا'),
(78092, 3286376448, 3286384639, 'GB', 'GBR', 'المملكة المتحدة'),
(78093, 3286384640, 3286401023, 'DE', 'DEU', 'ألمانيا'),
(78094, 3286401024, 3286409215, 'GB', 'GBR', 'المملكة المتحدة'),
(78095, 3286409216, 3286417407, 'DE', 'DEU', 'ألمانيا'),
(78096, 3286417664, 3286417919, 'IT', 'ITA', 'إيطاليا'),
(78097, 3286425600, 3286433791, 'KW', 'KWT', 'الكويت'),
(78098, 3286433792, 3286499327, 'DE', 'DEU', 'ألمانيا'),
(78099, 3286499328, 3286564863, 'HU', 'HUN', 'هنغاريا'),
(78100, 3286564864, 3286566143, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(78101, 3286566144, 3286566271, 'TZ', 'TZA', 'تانزانيا'),
(78102, 3286566272, 3286566655, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(78103, 3286566656, 3286567423, 'KW', 'KWT', 'الكويت'),
(78104, 3286567424, 3286568191, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(78105, 3286568192, 3286568703, 'KW', 'KWT', 'الكويت'),
(78106, 3286568704, 3286571007, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(78107, 3286571008, 3286571775, 'KW', 'KWT', 'الكويت'),
(78108, 3286571776, 3286630399, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(78109, 3286630400, 3286638591, 'BG', 'BGR', 'بلغاريا'),
(78110, 3286638592, 3286646783, 'AT', 'AUT', 'النمسا'),
(78111, 3286646784, 3286654975, 'RU', 'RUS', 'الإتحاد الروسي'),
(78112, 3286654976, 3286655231, 'UA', 'UKR', 'أوكرانيا'),
(78113, 3286655232, 3286655487, 'KZ', 'KAZ', 'كازاخستان'),
(78114, 3286655488, 3286655743, 'LT', 'LTU', 'ليتوانيا'),
(78115, 3286655744, 3286655999, 'UA', 'UKR', 'أوكرانيا'),
(78116, 3286656000, 3286656255, 'CH', 'CHE', 'سويسرا'),
(78117, 3286656256, 3286656511, 'RU', 'RUS', 'الإتحاد الروسي'),
(78118, 3286656512, 3286656767, 'GR', 'GRC', 'اليونان'),
(78119, 3286656768, 3286657023, 'UA', 'UKR', 'أوكرانيا'),
(78120, 3286657024, 3286657279, 'BE', 'BEL', 'بلجيكا'),
(78121, 3286657280, 3286657535, 'ES', 'ESP', 'إسبانيا'),
(78122, 3286657536, 3286657791, 'HU', 'HUN', 'هنغاريا'),
(78123, 3286657792, 3286658047, 'RU', 'RUS', 'الإتحاد الروسي'),
(78124, 3286658048, 3286658303, 'US', 'USA', 'الولايات المتحدة'),
(78125, 3286658304, 3286658559, 'RU', 'RUS', 'الإتحاد الروسي'),
(78126, 3286658560, 3286658815, 'NL', 'NLD', 'هولندا'),
(78127, 3286658816, 3286659071, 'RU', 'RUS', 'الإتحاد الروسي'),
(78128, 3286659072, 3286659327, 'UA', 'UKR', 'أوكرانيا'),
(78129, 3286659328, 3286659583, 'PL', 'POL', 'بولندا'),
(78130, 3286659584, 3286659839, 'DE', 'DEU', 'ألمانيا'),
(78131, 3286659840, 3286660095, 'UA', 'UKR', 'أوكرانيا'),
(78132, 3286660096, 3286660351, 'DE', 'DEU', 'ألمانيا'),
(78133, 3286660352, 3286660607, 'CH', 'CHE', 'سويسرا'),
(78134, 3286660608, 3286660863, 'GB', 'GBR', 'المملكة المتحدة'),
(78135, 3286660864, 3286661119, 'UA', 'UKR', 'أوكرانيا'),
(78136, 3286661120, 3286661375, 'PL', 'POL', 'بولندا'),
(78137, 3286661376, 3286661631, 'SI', 'SVN', 'سلوفينيا'),
(78138, 3286661632, 3286661887, 'GB', 'GBR', 'المملكة المتحدة'),
(78139, 3286661888, 3286662143, 'RU', 'RUS', 'الإتحاد الروسي'),
(78140, 3286662144, 3286662399, 'DE', 'DEU', 'ألمانيا'),
(78141, 3286662400, 3286662655, 'UA', 'UKR', 'أوكرانيا'),
(78142, 3286662656, 3286662911, 'DE', 'DEU', 'ألمانيا'),
(78143, 3286662912, 3286671359, 'UA', 'UKR', 'أوكرانيا'),
(78144, 3286671360, 3286679551, 'AT', 'AUT', 'النمسا'),
(78145, 3286679552, 3286681631, 'IT', 'ITA', 'إيطاليا'),
(78146, 3286681632, 3286681647, 'DE', 'DEU', 'ألمانيا'),
(78147, 3286681648, 3286681655, 'GB', 'GBR', 'المملكة المتحدة'),
(78148, 3286681656, 3286681659, 'BE', 'BEL', 'بلجيكا'),
(78149, 3286681660, 3286681663, 'ES', 'ESP', 'إسبانيا'),
(78150, 3286681664, 3286681695, 'FR', 'FRA', 'فرنسا'),
(78151, 3286681696, 3286681699, 'ES', 'ESP', 'إسبانيا'),
(78152, 3286681700, 3286681711, 'IT', 'ITA', 'إيطاليا'),
(78153, 3286681712, 3286681727, 'CH', 'CHE', 'سويسرا'),
(78154, 3286681728, 3286681743, 'HK', 'HKG', 'هونغ كونغ'),
(78155, 3286681744, 3286681751, 'ES', 'ESP', 'إسبانيا'),
(78156, 3286681752, 3286681767, 'IT', 'ITA', 'إيطاليا'),
(78157, 3286681768, 3286681775, 'DE', 'DEU', 'ألمانيا'),
(78158, 3286681776, 3286681815, 'IT', 'ITA', 'إيطاليا'),
(78159, 3286681816, 3286681823, 'FR', 'FRA', 'فرنسا'),
(78160, 3286681824, 3286682431, 'IT', 'ITA', 'إيطاليا'),
(78161, 3286682432, 3286682463, 'FR', 'FRA', 'فرنسا'),
(78162, 3286682464, 3286682495, 'RO', 'ROM', 'رومانيا'),
(78163, 3286682496, 3286682623, 'IT', 'ITA', 'إيطاليا'),
(78164, 3286682624, 3286682879, 'SM', 'SMR', 'سان مارينو'),
(78165, 3286682880, 3286695935, 'IT', 'ITA', 'إيطاليا'),
(78166, 3286695936, 3286761471, 'DK', 'DNK', 'الدنيمارك'),
(78167, 3286761472, 3286761727, 'DE', 'DEU', 'ألمانيا'),
(78168, 3286761728, 3286769663, 'GB', 'GBR', 'المملكة المتحدة'),
(78169, 3286769664, 3286769919, 'DE', 'DEU', 'ألمانيا'),
(78170, 3286769920, 3286773759, 'GB', 'GBR', 'المملكة المتحدة'),
(78171, 3286773760, 3286777855, 'DE', 'DEU', 'ألمانيا'),
(78172, 3286777856, 3286781951, 'FR', 'FRA', 'فرنسا'),
(78173, 3286781952, 3286782207, 'GB', 'GBR', 'المملكة المتحدة'),
(78174, 3286782208, 3286782463, 'DE', 'DEU', 'ألمانيا'),
(78175, 3286782464, 3286782535, 'GB', 'GBR', 'المملكة المتحدة'),
(78176, 3286782536, 3286782543, 'FR', 'FRA', 'فرنسا'),
(78177, 3286782544, 3286782575, 'GB', 'GBR', 'المملكة المتحدة'),
(78178, 3286782576, 3286782583, 'DE', 'DEU', 'ألمانيا'),
(78179, 3286782584, 3286783599, 'GB', 'GBR', 'المملكة المتحدة'),
(78180, 3286783600, 3286783615, 'CH', 'CHE', 'سويسرا'),
(78181, 3286783616, 3286783679, 'DE', 'DEU', 'ألمانيا'),
(78182, 3286783680, 3286784511, 'GB', 'GBR', 'المملكة المتحدة'),
(78183, 3286784512, 3286784767, 'CH', 'CHE', 'سويسرا'),
(78184, 3286784768, 3286785023, 'DE', 'DEU', 'ألمانيا'),
(78185, 3286785024, 3286787071, 'GB', 'GBR', 'المملكة المتحدة'),
(78186, 3286787072, 3286787327, 'FR', 'FRA', 'فرنسا'),
(78187, 3286787328, 3286787583, 'DE', 'DEU', 'ألمانيا'),
(78188, 3286787584, 3286788095, 'GB', 'GBR', 'المملكة المتحدة'),
(78189, 3286788096, 3286788351, 'DE', 'DEU', 'ألمانيا'),
(78190, 3286788352, 3286788607, 'FR', 'FRA', 'فرنسا'),
(78191, 3286788608, 3286789119, 'GB', 'GBR', 'المملكة المتحدة'),
(78192, 3286789120, 3286789631, 'DE', 'DEU', 'ألمانيا'),
(78193, 3286789632, 3286790143, 'FR', 'FRA', 'فرنسا'),
(78194, 3286790144, 3286790655, 'GB', 'GBR', 'المملكة المتحدة'),
(78195, 3286790656, 3286790911, 'DE', 'DEU', 'ألمانيا'),
(78196, 3286790912, 3286791679, 'GB', 'GBR', 'المملكة المتحدة'),
(78197, 3286791680, 3286791935, 'AT', 'AUT', 'النمسا'),
(78198, 3286791936, 3286794239, 'GB', 'GBR', 'المملكة المتحدة'),
(78199, 3286794240, 3286892543, 'DE', 'DEU', 'ألمانيا'),
(78200, 3286892544, 3286893055, 'LI', 'LIE', 'ليختنشتاين'),
(78201, 3286893056, 3286893567, 'RU', 'RUS', 'الإتحاد الروسي'),
(78202, 3286893568, 3286894591, 'UA', 'UKR', 'أوكرانيا'),
(78203, 3286895104, 3286895615, 'GB', 'GBR', 'المملكة المتحدة'),
(78204, 3286895616, 3286896127, 'DE', 'DEU', 'ألمانيا'),
(78205, 3286896128, 3286896639, 'SE', 'SWE', 'السويد'),
(78206, 3286896640, 3286897151, 'PL', 'POL', 'بولندا'),
(78207, 3286897152, 3286897663, 'AT', 'AUT', 'النمسا'),
(78208, 3286897664, 3286898175, 'PL', 'POL', 'بولندا'),
(78209, 3286898176, 3286898687, 'HR', 'HRV', 'كرواتيا'),
(78210, 3286899200, 3286899711, 'IL', 'ISR', 'إسرائيل'),
(78211, 3286899712, 3286900223, 'HU', 'HUN', 'هنغاريا'),
(78212, 3286900224, 3286900735, 'RO', 'ROM', 'رومانيا'),
(78213, 3286900736, 3286900991, 'BE', 'BEL', 'بلجيكا'),
(78214, 3286900992, 3286901503, 'DE', 'DEU', 'ألمانيا'),
(78215, 3286901504, 3286902015, 'FR', 'FRA', 'فرنسا'),
(78216, 3286902016, 3286902527, 'CH', 'CHE', 'سويسرا'),
(78217, 3286902528, 3286902783, 'GB', 'GBR', 'المملكة المتحدة'),
(78218, 3286902784, 3286903039, 'PL', 'POL', 'بولندا'),
(78219, 3286903040, 3286903551, 'FR', 'FRA', 'فرنسا'),
(78220, 3286903552, 3286903807, 'CH', 'CHE', 'سويسرا'),
(78221, 3286903808, 3286904063, 'AT', 'AUT', 'النمسا'),
(78222, 3286904064, 3286904319, 'BE', 'BEL', 'بلجيكا'),
(78223, 3286904320, 3286904575, 'FR', 'FRA', 'فرنسا'),
(78224, 3286904576, 3286904831, 'PT', 'PRT', 'البورتوغال'),
(78225, 3286904832, 3286905087, 'GB', 'GBR', 'المملكة المتحدة'),
(78226, 3286905088, 3286905343, 'GR', 'GRC', 'اليونان'),
(78227, 3286905344, 3286905599, 'DE', 'DEU', 'ألمانيا'),
(78228, 3286905600, 3286905855, 'MT', 'MLT', 'مالطا'),
(78229, 3286905856, 3286906111, 'TR', 'TUR', 'تركيا'),
(78230, 3286906112, 3286906367, 'BE', 'BEL', 'بلجيكا'),
(78231, 3286906368, 3286906879, 'RO', 'ROM', 'رومانيا'),
(78232, 3286906880, 3286907135, 'RU', 'RUS', 'الإتحاد الروسي'),
(78233, 3286907136, 3286907391, 'SE', 'SWE', 'السويد'),
(78234, 3286907392, 3286907647, 'AT', 'AUT', 'النمسا'),
(78235, 3286907648, 3286907903, 'ES', 'ESP', 'إسبانيا'),
(78236, 3286907904, 3286908159, 'CH', 'CHE', 'سويسرا'),
(78237, 3286908160, 3286908415, 'UA', 'UKR', 'أوكرانيا'),
(78238, 3286908416, 3286908671, 'FR', 'FRA', 'فرنسا'),
(78239, 3286908672, 3286908927, 'PL', 'POL', 'بولندا'),
(78240, 3286908928, 3286909951, 'CH', 'CHE', 'سويسرا'),
(78241, 3286909952, 3286913023, 'UA', 'UKR', 'أوكرانيا'),
(78242, 3286913024, 3286914047, 'DE', 'DEU', 'ألمانيا'),
(78243, 3286914048, 3286915071, 'BG', 'BGR', 'بلغاريا'),
(78244, 3286915072, 3286916095, 'FR', 'FRA', 'فرنسا'),
(78245, 3286916096, 3286917119, 'DE', 'DEU', 'ألمانيا'),
(78246, 3286917120, 3286917631, 'RU', 'RUS', 'الإتحاد الروسي'),
(78247, 3286918144, 3286919167, 'AT', 'AUT', 'النمسا'),
(78248, 3286919168, 3286920191, 'DE', 'DEU', 'ألمانيا'),
(78249, 3286920192, 3286921215, 'RU', 'RUS', 'الإتحاد الروسي'),
(78250, 3286921216, 3286922239, 'UA', 'UKR', 'أوكرانيا'),
(78251, 3286922240, 3286923263, 'GB', 'GBR', 'المملكة المتحدة'),
(78252, 3286924288, 3286925311, 'UA', 'UKR', 'أوكرانيا'),
(78253, 3286925312, 3286925567, 'DE', 'DEU', 'ألمانيا'),
(78254, 3286925568, 3286925823, 'CH', 'CHE', 'سويسرا'),
(78255, 3286925824, 3286926079, 'RO', 'ROM', 'رومانيا'),
(78256, 3286926080, 3286926335, 'LV', 'LVA', 'لاتفيا'),
(78257, 3286926336, 3286926591, 'UA', 'UKR', 'أوكرانيا'),
(78258, 3286926592, 3286926847, 'DE', 'DEU', 'ألمانيا'),
(78259, 3286926848, 3286927103, 'PT', 'PRT', 'البورتوغال'),
(78260, 3286927104, 3286927359, 'FI', 'FIN', 'فنلندا'),
(78261, 3286927360, 3286927615, 'DE', 'DEU', 'ألمانيا'),
(78262, 3286927616, 3286927871, 'SI', 'SVN', 'سلوفينيا'),
(78263, 3286927872, 3286928383, 'DE', 'DEU', 'ألمانيا'),
(78264, 3286928384, 3286928639, 'ES', 'ESP', 'إسبانيا'),
(78265, 3286928640, 3286928895, 'PL', 'POL', 'بولندا'),
(78266, 3286928896, 3286929151, 'FI', 'FIN', 'فنلندا'),
(78267, 3286929152, 3286929407, 'DE', 'DEU', 'ألمانيا'),
(78268, 3286929408, 3286929663, 'LV', 'LVA', 'لاتفيا'),
(78269, 3286929664, 3286929919, 'BE', 'BEL', 'بلجيكا'),
(78270, 3286929920, 3286930175, 'SE', 'SWE', 'السويد'),
(78271, 3286930176, 3286930431, 'RU', 'RUS', 'الإتحاد الروسي'),
(78272, 3286930432, 3286930687, 'UA', 'UKR', 'أوكرانيا'),
(78273, 3286930688, 3286930943, 'DE', 'DEU', 'ألمانيا'),
(78274, 3286930944, 3286931199, 'SE', 'SWE', 'السويد'),
(78275, 3286931200, 3286931455, 'AT', 'AUT', 'النمسا'),
(78276, 3286931456, 3286931711, 'DE', 'DEU', 'ألمانيا'),
(78277, 3286931712, 3286931967, 'GB', 'GBR', 'المملكة المتحدة'),
(78278, 3286931968, 3286932223, 'FR', 'FRA', 'فرنسا'),
(78279, 3286932224, 3286932479, 'DK', 'DNK', 'الدنيمارك'),
(78280, 3286932480, 3286932735, 'GB', 'GBR', 'المملكة المتحدة'),
(78281, 3286932736, 3286932991, 'AT', 'AUT', 'النمسا'),
(78282, 3286932992, 3286933503, 'IL', 'ISR', 'إسرائيل'),
(78283, 3286933504, 3286933759, 'DK', 'DNK', 'الدنيمارك'),
(78284, 3286933760, 3286934015, 'RO', 'ROM', 'رومانيا'),
(78285, 3286934016, 3286934271, 'BE', 'BEL', 'بلجيكا'),
(78286, 3286934272, 3286934527, 'CH', 'CHE', 'سويسرا'),
(78287, 3286934528, 3286934783, 'PL', 'POL', 'بولندا'),
(78288, 3286934784, 3286935039, 'TR', 'TUR', 'تركيا'),
(78289, 3286935040, 3286935551, 'ES', 'ESP', 'إسبانيا'),
(78290, 3286935808, 3286936063, 'RO', 'ROM', 'رومانيا'),
(78291, 3286936064, 3286936319, 'RU', 'RUS', 'الإتحاد الروسي'),
(78292, 3286936320, 3286936575, 'IT', 'ITA', 'إيطاليا'),
(78293, 3286936576, 3286936831, 'RO', 'ROM', 'رومانيا'),
(78294, 3286936832, 3286937087, 'NL', 'NLD', 'هولندا'),
(78295, 3286937088, 3286937343, 'UA', 'UKR', 'أوكرانيا'),
(78296, 3286937344, 3286937599, 'GB', 'GBR', 'المملكة المتحدة'),
(78297, 3286937600, 3286937855, 'CH', 'CHE', 'سويسرا'),
(78298, 3286937856, 3286938111, 'RO', 'ROM', 'رومانيا'),
(78299, 3286938112, 3286938367, 'DE', 'DEU', 'ألمانيا'),
(78300, 3286938368, 3286938623, 'ES', 'ESP', 'إسبانيا'),
(78301, 3286938624, 3286938879, 'CH', 'CHE', 'سويسرا'),
(78302, 3286938880, 3286939391, 'RO', 'ROM', 'رومانيا'),
(78303, 3286939392, 3286939647, 'DE', 'DEU', 'ألمانيا'),
(78304, 3286939648, 3286939903, 'BE', 'BEL', 'بلجيكا'),
(78305, 3286940160, 3286940415, 'BE', 'BEL', 'بلجيكا'),
(78306, 3286940416, 3286940671, 'CH', 'CHE', 'سويسرا'),
(78307, 3286940672, 3286940927, 'RO', 'ROM', 'رومانيا'),
(78308, 3286940928, 3286941183, 'PL', 'POL', 'بولندا'),
(78309, 3286941184, 3286941439, 'RU', 'RUS', 'الإتحاد الروسي');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(78310, 3286941440, 3286941695, 'RO', 'ROM', 'رومانيا'),
(78311, 3286941696, 3286942719, 'DE', 'DEU', 'ألمانيا'),
(78312, 3286942720, 3286943743, 'FI', 'FIN', 'فنلندا'),
(78313, 3286943744, 3286944767, 'UA', 'UKR', 'أوكرانيا'),
(78314, 3286944768, 3286945791, 'CZ', 'CZE', 'التشيك'),
(78315, 3286945792, 3286946815, 'RU', 'RUS', 'الإتحاد الروسي'),
(78316, 3286946816, 3286947839, 'UA', 'UKR', 'أوكرانيا'),
(78317, 3286947840, 3286948863, 'DE', 'DEU', 'ألمانيا'),
(78318, 3286948864, 3286949887, 'UA', 'UKR', 'أوكرانيا'),
(78319, 3286949888, 3286950911, 'CH', 'CHE', 'سويسرا'),
(78320, 3286950912, 3286951935, 'DE', 'DEU', 'ألمانيا'),
(78321, 3286951936, 3286952959, 'IT', 'ITA', 'إيطاليا'),
(78322, 3286952960, 3286953983, 'BG', 'BGR', 'بلغاريا'),
(78323, 3286953984, 3286955007, 'GB', 'GBR', 'المملكة المتحدة'),
(78324, 3286955008, 3286956031, 'DE', 'DEU', 'ألمانيا'),
(78325, 3286956032, 3286957055, 'FR', 'FRA', 'فرنسا'),
(78326, 3286958080, 3287023615, 'ES', 'ESP', 'إسبانيا'),
(78327, 3287023616, 3287154687, 'FI', 'FIN', 'فنلندا'),
(78328, 3287154688, 3287162879, 'BE', 'BEL', 'بلجيكا'),
(78329, 3287162880, 3287171071, 'DE', 'DEU', 'ألمانيا'),
(78330, 3287171072, 3287171583, 'LT', 'LTU', 'ليتوانيا'),
(78331, 3287171584, 3287172095, 'PL', 'POL', 'بولندا'),
(78332, 3287172096, 3287172607, 'DE', 'DEU', 'ألمانيا'),
(78333, 3287172608, 3287173119, 'PL', 'POL', 'بولندا'),
(78334, 3287173120, 3287173631, 'RU', 'RUS', 'الإتحاد الروسي'),
(78335, 3287173632, 3287174143, 'NL', 'NLD', 'هولندا'),
(78336, 3287174144, 3287174655, 'SE', 'SWE', 'السويد'),
(78337, 3287174656, 3287175167, 'GB', 'GBR', 'المملكة المتحدة'),
(78338, 3287175168, 3287176191, 'RO', 'ROM', 'رومانيا'),
(78339, 3287176192, 3287176703, 'BG', 'BGR', 'بلغاريا'),
(78340, 3287176704, 3287177215, 'NL', 'NLD', 'هولندا'),
(78341, 3287177216, 3287178239, 'RO', 'ROM', 'رومانيا'),
(78342, 3287178240, 3287178751, 'UA', 'UKR', 'أوكرانيا'),
(78343, 3287178752, 3287179263, 'RO', 'ROM', 'رومانيا'),
(78344, 3287179264, 3287180287, 'FR', 'FRA', 'فرنسا'),
(78345, 3287180288, 3287181311, 'RU', 'RUS', 'الإتحاد الروسي'),
(78346, 3287181312, 3287182335, 'UZ', 'UZB', 'أوزباكستان'),
(78347, 3287182336, 3287185407, 'UA', 'UKR', 'أوكرانيا'),
(78348, 3287185408, 3287186431, 'SE', 'SWE', 'السويد'),
(78349, 3287186432, 3287187455, 'FI', 'FIN', 'فنلندا'),
(78350, 3287187456, 3287196671, 'DE', 'DEU', 'ألمانيا'),
(78351, 3287196672, 3287198719, 'PL', 'POL', 'بولندا'),
(78352, 3287198720, 3287199743, 'GB', 'GBR', 'المملكة المتحدة'),
(78353, 3287199744, 3287201791, 'UA', 'UKR', 'أوكرانيا'),
(78354, 3287201792, 3287202815, 'PL', 'POL', 'بولندا'),
(78355, 3287202816, 3287203839, 'UA', 'UKR', 'أوكرانيا'),
(78356, 3287203840, 3287204895, 'FI', 'FIN', 'فنلندا'),
(78357, 3287204896, 3287204951, 'EE', 'EST', 'إستونيا'),
(78358, 3287204952, 3287204959, 'FI', 'FIN', 'فنلندا'),
(78359, 3287204960, 3287205055, 'EE', 'EST', 'إستونيا'),
(78360, 3287205056, 3287212031, 'FI', 'FIN', 'فنلندا'),
(78361, 3287212032, 3287212543, 'DE', 'DEU', 'ألمانيا'),
(78362, 3287212544, 3287212799, 'FR', 'FRA', 'فرنسا'),
(78363, 3287212800, 3287213311, 'PL', 'POL', 'بولندا'),
(78364, 3287213312, 3287213567, 'FR', 'FRA', 'فرنسا'),
(78365, 3287213568, 3287214079, 'RU', 'RUS', 'الإتحاد الروسي'),
(78366, 3287214080, 3287214335, 'GB', 'GBR', 'المملكة المتحدة'),
(78367, 3287214336, 3287214847, 'DE', 'DEU', 'ألمانيا'),
(78368, 3287214848, 3287215103, 'IT', 'ITA', 'إيطاليا'),
(78369, 3287215104, 3287215359, 'PL', 'POL', 'بولندا'),
(78370, 3287215360, 3287215615, 'GB', 'GBR', 'المملكة المتحدة'),
(78371, 3287215616, 3287215871, 'DE', 'DEU', 'ألمانيا'),
(78372, 3287215872, 3287216127, 'RU', 'RUS', 'الإتحاد الروسي'),
(78373, 3287216128, 3287216639, 'GB', 'GBR', 'المملكة المتحدة'),
(78374, 3287216640, 3287216895, 'MD', 'MDA', 'مولدوفا'),
(78375, 3287216896, 3287217151, 'GB', 'GBR', 'المملكة المتحدة'),
(78376, 3287217152, 3287217407, 'NL', 'NLD', 'هولندا'),
(78377, 3287217408, 3287217663, 'PL', 'POL', 'بولندا'),
(78378, 3287217664, 3287217919, 'RU', 'RUS', 'الإتحاد الروسي'),
(78379, 3287217920, 3287218175, 'PL', 'POL', 'بولندا'),
(78380, 3287218176, 3287218431, 'DE', 'DEU', 'ألمانيا'),
(78381, 3287218432, 3287218687, 'GB', 'GBR', 'المملكة المتحدة'),
(78382, 3287218688, 3287218943, 'RU', 'RUS', 'الإتحاد الروسي'),
(78383, 3287219200, 3287219455, 'DE', 'DEU', 'ألمانيا'),
(78384, 3287219456, 3287219711, 'CH', 'CHE', 'سويسرا'),
(78385, 3287219712, 3287220223, 'SE', 'SWE', 'السويد'),
(78386, 3287220224, 3287223807, 'RU', 'RUS', 'الإتحاد الروسي'),
(78387, 3287223808, 3287224063, 'UZ', 'UZB', 'أوزباكستان'),
(78388, 3287224064, 3287259375, 'RU', 'RUS', 'الإتحاد الروسي'),
(78389, 3287259376, 3287259383, 'DK', 'DNK', 'الدنيمارك'),
(78390, 3287259384, 3287267191, 'RU', 'RUS', 'الإتحاد الروسي'),
(78391, 3287267192, 3287267201, 'KZ', 'KAZ', 'كازاخستان'),
(78392, 3287267202, 3287271119, 'RU', 'RUS', 'الإتحاد الروسي'),
(78393, 3287271120, 3287271127, 'UZ', 'UZB', 'أوزباكستان'),
(78394, 3287271128, 3287285759, 'RU', 'RUS', 'الإتحاد الروسي'),
(78395, 3287285760, 3287416831, 'NL', 'NLD', 'هولندا'),
(78396, 3287416832, 3287425023, 'RU', 'RUS', 'الإتحاد الروسي'),
(78397, 3287425024, 3287427759, 'SE', 'SWE', 'السويد'),
(78398, 3287427760, 3287427775, 'GB', 'GBR', 'المملكة المتحدة'),
(78399, 3287427776, 3287433215, 'SE', 'SWE', 'السويد'),
(78400, 3287433728, 3287434239, 'DE', 'DEU', 'ألمانيا'),
(78401, 3287434240, 3287434751, 'PL', 'POL', 'بولندا'),
(78402, 3287434752, 3287435263, 'GB', 'GBR', 'المملكة المتحدة'),
(78403, 3287435264, 3287435775, 'NL', 'NLD', 'هولندا'),
(78404, 3287435776, 3287436287, 'GB', 'GBR', 'المملكة المتحدة'),
(78405, 3287436288, 3287436799, 'RS', 'SRB', 'صربيا'),
(78406, 3287436800, 3287437311, 'RO', 'ROM', 'رومانيا'),
(78407, 3287437312, 3287437823, 'UA', 'UKR', 'أوكرانيا'),
(78408, 3287437824, 3287438335, 'RU', 'RUS', 'الإتحاد الروسي'),
(78409, 3287438336, 3287438847, 'CH', 'CHE', 'سويسرا'),
(78410, 3287438848, 3287439359, 'GB', 'GBR', 'المملكة المتحدة'),
(78411, 3287439360, 3287439871, 'RO', 'ROM', 'رومانيا'),
(78412, 3287439872, 3287440895, 'PL', 'POL', 'بولندا'),
(78413, 3287440896, 3287441407, 'UA', 'UKR', 'أوكرانيا'),
(78414, 3287441408, 3287442431, 'NL', 'NLD', 'هولندا'),
(78415, 3287442432, 3287442943, 'PL', 'POL', 'بولندا'),
(78416, 3287442944, 3287443967, 'DE', 'DEU', 'ألمانيا'),
(78417, 3287443968, 3287444479, 'BG', 'BGR', 'بلغاريا'),
(78418, 3287444480, 3287444991, 'PL', 'POL', 'بولندا'),
(78419, 3287444992, 3287445503, 'DE', 'DEU', 'ألمانيا'),
(78420, 3287445504, 3287446527, 'UA', 'UKR', 'أوكرانيا'),
(78421, 3287446528, 3287447039, 'PL', 'POL', 'بولندا'),
(78422, 3287447040, 3287447551, 'IL', 'ISR', 'إسرائيل'),
(78423, 3287447552, 3287448063, 'DK', 'DNK', 'الدنيمارك'),
(78424, 3287448064, 3287448575, 'GB', 'GBR', 'المملكة المتحدة'),
(78425, 3287448576, 3287449087, 'PL', 'POL', 'بولندا'),
(78426, 3287449088, 3287449599, 'BG', 'BGR', 'بلغاريا'),
(78427, 3287449600, 3287450111, 'MD', 'MDA', 'مولدوفا'),
(78428, 3287450112, 3287450623, 'DK', 'DNK', 'الدنيمارك'),
(78429, 3287450624, 3287451135, 'SE', 'SWE', 'السويد'),
(78430, 3287451136, 3287451647, 'PL', 'POL', 'بولندا'),
(78431, 3287451648, 3287452159, 'ES', 'ESP', 'إسبانيا'),
(78432, 3287452672, 3287453183, 'CH', 'CHE', 'سويسرا'),
(78433, 3287453184, 3287454207, 'RU', 'RUS', 'الإتحاد الروسي'),
(78434, 3287454208, 3287454719, 'SE', 'SWE', 'السويد'),
(78435, 3287454720, 3287455743, 'UA', 'UKR', 'أوكرانيا'),
(78436, 3287455744, 3287456255, 'NL', 'NLD', 'هولندا'),
(78437, 3287456256, 3287457279, 'GB', 'GBR', 'المملكة المتحدة'),
(78438, 3287457280, 3287457791, 'RO', 'ROM', 'رومانيا'),
(78439, 3287457792, 3287458047, 'NL', 'NLD', 'هولندا'),
(78440, 3287458048, 3287458303, 'UA', 'UKR', 'أوكرانيا'),
(78441, 3287458304, 3287458559, 'DE', 'DEU', 'ألمانيا'),
(78442, 3287458560, 3287459327, 'CH', 'CHE', 'سويسرا'),
(78443, 3287459328, 3287459583, 'AT', 'AUT', 'النمسا'),
(78444, 3287459584, 3287459839, 'DE', 'DEU', 'ألمانيا'),
(78445, 3287459840, 3287460095, 'AT', 'AUT', 'النمسا'),
(78446, 3287460096, 3287460351, 'ME', 'MNE', 'الجبل الأسود'),
(78447, 3287460352, 3287460607, 'CY', 'CYP', 'قبرص'),
(78448, 3287460608, 3287460863, 'NL', 'NLD', 'هولندا'),
(78449, 3287460864, 3287461119, 'BE', 'BEL', 'بلجيكا'),
(78450, 3287461120, 3287461375, 'DE', 'DEU', 'ألمانيا'),
(78451, 3287461376, 3287461631, 'CH', 'CHE', 'سويسرا'),
(78452, 3287461632, 3287461887, 'AT', 'AUT', 'النمسا'),
(78453, 3287461888, 3287462143, 'PL', 'POL', 'بولندا'),
(78454, 3287462144, 3287462399, 'SA', 'SAU', 'السعودية'),
(78455, 3287462400, 3287462655, 'BE', 'BEL', 'بلجيكا'),
(78456, 3287462656, 3287462911, 'UA', 'UKR', 'أوكرانيا'),
(78457, 3287462912, 3287463167, 'FR', 'FRA', 'فرنسا'),
(78458, 3287463168, 3287463423, 'IT', 'ITA', 'إيطاليا'),
(78459, 3287463424, 3287463679, 'RO', 'ROM', 'رومانيا'),
(78460, 3287463680, 3287463935, 'PL', 'POL', 'بولندا'),
(78461, 3287463936, 3287464191, 'AT', 'AUT', 'النمسا'),
(78462, 3287464192, 3287464447, 'SK', 'SVK', 'سلوفاكيا'),
(78463, 3287464448, 3287464703, 'PL', 'POL', 'بولندا'),
(78464, 3287464704, 3287464959, 'NL', 'NLD', 'هولندا'),
(78465, 3287464960, 3287465215, 'SA', 'SAU', 'السعودية'),
(78466, 3287465216, 3287465471, 'NO', 'NOR', 'النرويج'),
(78467, 3287465472, 3287465727, 'DE', 'DEU', 'ألمانيا'),
(78468, 3287465728, 3287465983, 'FR', 'FRA', 'فرنسا'),
(78469, 3287465984, 3287467007, 'DK', 'DNK', 'الدنيمارك'),
(78470, 3287467008, 3287468031, 'SA', 'SAU', 'السعودية'),
(78471, 3287469056, 3287471103, 'DE', 'DEU', 'ألمانيا'),
(78472, 3287471104, 3287472127, 'GB', 'GBR', 'المملكة المتحدة'),
(78473, 3287472128, 3287473151, 'FI', 'FIN', 'فنلندا'),
(78474, 3287473152, 3287474175, 'GB', 'GBR', 'المملكة المتحدة'),
(78475, 3287474176, 3287476223, 'DE', 'DEU', 'ألمانيا'),
(78476, 3287476224, 3287477247, 'PL', 'POL', 'بولندا'),
(78477, 3287477248, 3287478271, 'GB', 'GBR', 'المملكة المتحدة'),
(78478, 3287478272, 3287479295, 'BG', 'BGR', 'بلغاريا'),
(78479, 3287479296, 3287480319, 'RO', 'ROM', 'رومانيا'),
(78480, 3287480320, 3287481343, 'AT', 'AUT', 'النمسا'),
(78481, 3287481344, 3287482367, 'PL', 'POL', 'بولندا'),
(78482, 3287482368, 3287499279, 'DE', 'DEU', 'ألمانيا'),
(78483, 3287499280, 3287499287, 'FR', 'FRA', 'فرنسا'),
(78484, 3287499288, 3287499295, 'US', 'USA', 'الولايات المتحدة'),
(78485, 3287499296, 3287499439, 'DE', 'DEU', 'ألمانيا'),
(78486, 3287499440, 3287499471, 'GB', 'GBR', 'المملكة المتحدة'),
(78487, 3287499472, 3287499487, 'DE', 'DEU', 'ألمانيا'),
(78488, 3287499488, 3287499503, 'GB', 'GBR', 'المملكة المتحدة'),
(78489, 3287499504, 3287501359, 'DE', 'DEU', 'ألمانيا'),
(78490, 3287501360, 3287501367, 'NL', 'NLD', 'هولندا'),
(78491, 3287501368, 3287507983, 'DE', 'DEU', 'ألمانيا'),
(78492, 3287507984, 3287507991, 'FR', 'FRA', 'فرنسا'),
(78493, 3287507992, 3287515375, 'DE', 'DEU', 'ألمانيا'),
(78494, 3287515376, 3287515383, 'CZ', 'CZE', 'التشيك'),
(78495, 3287515384, 3287523303, 'DE', 'DEU', 'ألمانيا'),
(78496, 3287523304, 3287523311, 'US', 'USA', 'الولايات المتحدة'),
(78497, 3287523312, 3287526303, 'DE', 'DEU', 'ألمانيا'),
(78498, 3287526304, 3287526311, 'LU', 'LUX', 'لوكسيمبورغ'),
(78499, 3287526312, 3287534807, 'DE', 'DEU', 'ألمانيا'),
(78500, 3287534808, 3287534815, 'IT', 'ITA', 'إيطاليا'),
(78501, 3287534816, 3287541087, 'DE', 'DEU', 'ألمانيا'),
(78502, 3287541088, 3287541095, 'CZ', 'CZE', 'التشيك'),
(78503, 3287541096, 3287542815, 'DE', 'DEU', 'ألمانيا'),
(78504, 3287542816, 3287542831, 'US', 'USA', 'الولايات المتحدة'),
(78505, 3287542832, 3287544647, 'DE', 'DEU', 'ألمانيا'),
(78506, 3287544648, 3287544655, 'CH', 'CHE', 'سويسرا'),
(78507, 3287544656, 3287548927, 'DE', 'DEU', 'ألمانيا'),
(78508, 3287548928, 3287549439, 'UA', 'UKR', 'أوكرانيا'),
(78509, 3287549440, 3287549951, 'SE', 'SWE', 'السويد'),
(78510, 3287549952, 3287550463, 'UA', 'UKR', 'أوكرانيا'),
(78511, 3287550464, 3287550975, 'DE', 'DEU', 'ألمانيا'),
(78512, 3287550976, 3287551487, 'LT', 'LTU', 'ليتوانيا'),
(78513, 3287551488, 3287551999, 'RO', 'ROM', 'رومانيا'),
(78514, 3287552000, 3287552511, 'GB', 'GBR', 'المملكة المتحدة'),
(78515, 3287552512, 3287553023, 'RO', 'ROM', 'رومانيا'),
(78516, 3287553024, 3287553535, 'FR', 'FRA', 'فرنسا'),
(78517, 3287553536, 3287554047, 'IL', 'ISR', 'إسرائيل'),
(78518, 3287554048, 3287554559, 'RU', 'RUS', 'الإتحاد الروسي'),
(78519, 3287554560, 3287555071, 'PL', 'POL', 'بولندا'),
(78520, 3287555072, 3287555583, 'GB', 'GBR', 'المملكة المتحدة'),
(78521, 3287555584, 3287556095, 'FR', 'FRA', 'فرنسا'),
(78522, 3287556096, 3287564287, 'TR', 'TUR', 'تركيا'),
(78523, 3287564288, 3287572479, 'FI', 'FIN', 'فنلندا'),
(78524, 3287572480, 3287578863, 'DE', 'DEU', 'ألمانيا'),
(78525, 3287578864, 3287578879, 'LI', 'LIE', 'ليختنشتاين'),
(78526, 3287578880, 3287580671, 'DE', 'DEU', 'ألمانيا'),
(78527, 3287580672, 3287588863, 'LV', 'LVA', 'لاتفيا'),
(78528, 3287588864, 3287597055, 'BE', 'BEL', 'بلجيكا'),
(78529, 3287597056, 3287605247, 'GI', 'GIB', 'جبل طارق'),
(78530, 3287605248, 3287630335, 'DE', 'DEU', 'ألمانيا'),
(78531, 3287630336, 3287631359, 'PL', 'POL', 'بولندا'),
(78532, 3287631360, 3287631871, 'IR', 'IRN', 'إيران'),
(78533, 3287631872, 3287632383, 'RU', 'RUS', 'الإتحاد الروسي'),
(78534, 3287632384, 3287632895, 'SE', 'SWE', 'السويد'),
(78535, 3287632896, 3287633407, 'RU', 'RUS', 'الإتحاد الروسي'),
(78536, 3287633408, 3287633919, 'SK', 'SVK', 'سلوفاكيا'),
(78537, 3287633920, 3287634431, 'UA', 'UKR', 'أوكرانيا'),
(78538, 3287634432, 3287634943, 'RO', 'ROM', 'رومانيا'),
(78539, 3287634944, 3287635455, 'PL', 'POL', 'بولندا'),
(78540, 3287635456, 3287635967, 'DE', 'DEU', 'ألمانيا'),
(78541, 3287635968, 3287636479, 'RO', 'ROM', 'رومانيا'),
(78542, 3287636480, 3287636991, 'IE', 'IRL', 'إيرلندا'),
(78543, 3287636992, 3287637503, 'AT', 'AUT', 'النمسا'),
(78544, 3287637504, 3287638015, 'PL', 'POL', 'بولندا'),
(78545, 3287638016, 3287638527, 'UA', 'UKR', 'أوكرانيا'),
(78546, 3287638528, 3287639039, 'DE', 'DEU', 'ألمانيا'),
(78547, 3287639040, 3287639551, 'GB', 'GBR', 'المملكة المتحدة'),
(78548, 3287639552, 3287640063, 'RU', 'RUS', 'الإتحاد الروسي'),
(78549, 3287640064, 3287640575, 'DE', 'DEU', 'ألمانيا'),
(78550, 3287640576, 3287641087, 'SI', 'SVN', 'سلوفينيا'),
(78551, 3287641600, 3287642111, 'FI', 'FIN', 'فنلندا'),
(78552, 3287642112, 3287642623, 'UA', 'UKR', 'أوكرانيا'),
(78553, 3287642624, 3287643135, 'BE', 'BEL', 'بلجيكا'),
(78554, 3287643136, 3287643647, 'IT', 'ITA', 'إيطاليا'),
(78555, 3287643648, 3287644671, 'UA', 'UKR', 'أوكرانيا'),
(78556, 3287644672, 3287645183, 'NL', 'NLD', 'هولندا'),
(78557, 3287646208, 3287662591, 'PT', 'PRT', 'البورتوغال'),
(78558, 3287662592, 3287662847, 'DE', 'DEU', 'ألمانيا'),
(78559, 3287662848, 3287663103, 'DK', 'DNK', 'الدنيمارك'),
(78560, 3287663104, 3287663359, 'LV', 'LVA', 'لاتفيا'),
(78561, 3287663360, 3287663615, 'GB', 'GBR', 'المملكة المتحدة'),
(78562, 3287663616, 3287663871, 'ES', 'ESP', 'إسبانيا'),
(78563, 3287663872, 3287664127, 'PT', 'PRT', 'البورتوغال'),
(78564, 3287664128, 3287664383, 'PL', 'POL', 'بولندا'),
(78565, 3287664384, 3287664639, 'NL', 'NLD', 'هولندا'),
(78566, 3287664640, 3287664895, 'UA', 'UKR', 'أوكرانيا'),
(78567, 3287664896, 3287665151, 'GB', 'GBR', 'المملكة المتحدة'),
(78568, 3287665152, 3287665407, 'NO', 'NOR', 'النرويج'),
(78569, 3287665408, 3287665919, 'PL', 'POL', 'بولندا'),
(78570, 3287665920, 3287666175, 'AT', 'AUT', 'النمسا'),
(78571, 3287666176, 3287666431, 'RU', 'RUS', 'الإتحاد الروسي'),
(78572, 3287666432, 3287666687, 'DK', 'DNK', 'الدنيمارك'),
(78573, 3287666688, 3287666943, 'SI', 'SVN', 'سلوفينيا'),
(78574, 3287666944, 3287667199, 'CZ', 'CZE', 'التشيك'),
(78575, 3287667200, 3287667455, 'DK', 'DNK', 'الدنيمارك'),
(78576, 3287667456, 3287667711, 'RU', 'RUS', 'الإتحاد الروسي'),
(78577, 3287667712, 3287667967, 'ES', 'ESP', 'إسبانيا'),
(78578, 3287667968, 3287668223, 'PL', 'POL', 'بولندا'),
(78579, 3287668224, 3287668479, 'RO', 'ROM', 'رومانيا'),
(78580, 3287668480, 3287668735, 'UA', 'UKR', 'أوكرانيا'),
(78581, 3287668736, 3287668991, 'SI', 'SVN', 'سلوفينيا'),
(78582, 3287668992, 3287669247, 'PL', 'POL', 'بولندا'),
(78583, 3287669248, 3287669503, 'LI', 'LIE', 'ليختنشتاين'),
(78584, 3287669504, 3287669759, 'IE', 'IRL', 'إيرلندا'),
(78585, 3287669760, 3287670015, 'RO', 'ROM', 'رومانيا'),
(78586, 3287670016, 3287670271, 'UA', 'UKR', 'أوكرانيا'),
(78587, 3287670272, 3287670527, 'PL', 'POL', 'بولندا'),
(78588, 3287670528, 3287670783, 'GB', 'GBR', 'المملكة المتحدة'),
(78589, 3287670784, 3287671039, 'PL', 'POL', 'بولندا'),
(78590, 3287671040, 3287671295, 'AT', 'AUT', 'النمسا'),
(78591, 3287671296, 3287671551, 'PL', 'POL', 'بولندا'),
(78592, 3287671552, 3287671807, 'TR', 'TUR', 'تركيا'),
(78593, 3287671808, 3287672063, 'CH', 'CHE', 'سويسرا'),
(78594, 3287672064, 3287672319, 'LT', 'LTU', 'ليتوانيا'),
(78595, 3287672320, 3287672575, 'DE', 'DEU', 'ألمانيا'),
(78596, 3287672576, 3287672831, 'NL', 'NLD', 'هولندا'),
(78597, 3287672832, 3287673087, 'RU', 'RUS', 'الإتحاد الروسي'),
(78598, 3287673088, 3287673343, 'SK', 'SVK', 'سلوفاكيا'),
(78599, 3287673344, 3287673599, 'PT', 'PRT', 'البورتوغال'),
(78600, 3287673600, 3287673855, 'GB', 'GBR', 'المملكة المتحدة'),
(78601, 3287673856, 3287674111, 'NL', 'NLD', 'هولندا'),
(78602, 3287674112, 3287674367, 'CH', 'CHE', 'سويسرا'),
(78603, 3287674368, 3287674623, 'DE', 'DEU', 'ألمانيا'),
(78604, 3287674624, 3287674879, 'RO', 'ROM', 'رومانيا'),
(78605, 3287674880, 3287675135, 'SE', 'SWE', 'السويد'),
(78606, 3287675136, 3287675391, 'GB', 'GBR', 'المملكة المتحدة'),
(78607, 3287675392, 3287675647, 'SE', 'SWE', 'السويد'),
(78608, 3287675648, 3287675903, 'DE', 'DEU', 'ألمانيا'),
(78609, 3287675904, 3287676159, 'BE', 'BEL', 'بلجيكا'),
(78610, 3287676160, 3287676415, 'DE', 'DEU', 'ألمانيا'),
(78611, 3287676416, 3287676671, 'RU', 'RUS', 'الإتحاد الروسي'),
(78612, 3287676672, 3287676927, 'GB', 'GBR', 'المملكة المتحدة'),
(78613, 3287676928, 3287677183, 'ES', 'ESP', 'إسبانيا'),
(78614, 3287677184, 3287677439, 'RU', 'RUS', 'الإتحاد الروسي'),
(78615, 3287677440, 3287677695, 'SI', 'SVN', 'سلوفينيا'),
(78616, 3287677696, 3287677951, 'RO', 'ROM', 'رومانيا'),
(78617, 3287677952, 3287678207, 'GB', 'GBR', 'المملكة المتحدة'),
(78618, 3287678208, 3287678463, 'UA', 'UKR', 'أوكرانيا'),
(78619, 3287678464, 3287678719, 'DE', 'DEU', 'ألمانيا'),
(78620, 3287678720, 3287678975, 'HR', 'HRV', 'كرواتيا'),
(78621, 3287678976, 3287687167, 'SI', 'SVN', 'سلوفينيا'),
(78622, 3287687168, 3287695104, 'EG', 'EGY', 'مصر'),
(78623, 3287695360, 3287703551, 'CH', 'CHE', 'سويسرا'),
(78624, 3287703552, 3287704063, 'CZ', 'CZE', 'التشيك'),
(78625, 3287704064, 3287704575, 'NL', 'NLD', 'هولندا'),
(78626, 3287704576, 3287705087, 'LU', 'LUX', 'لوكسيمبورغ'),
(78627, 3287705088, 3287705599, 'RU', 'RUS', 'الإتحاد الروسي'),
(78628, 3287706112, 3287706623, 'RU', 'RUS', 'الإتحاد الروسي'),
(78629, 3287706624, 3287707135, 'GB', 'GBR', 'المملكة المتحدة'),
(78630, 3287707136, 3287707647, 'FR', 'FRA', 'فرنسا'),
(78631, 3287707648, 3287708159, 'BE', 'BEL', 'بلجيكا'),
(78632, 3287708160, 3287708671, 'NL', 'NLD', 'هولندا'),
(78633, 3287709184, 3287709695, 'RU', 'RUS', 'الإتحاد الروسي'),
(78634, 3287709696, 3287710207, 'SE', 'SWE', 'السويد'),
(78635, 3287710208, 3287710719, 'RU', 'RUS', 'الإتحاد الروسي'),
(78636, 3287711232, 3287711743, 'PL', 'POL', 'بولندا'),
(78637, 3287711744, 3287711983, 'GB', 'GBR', 'المملكة المتحدة'),
(78638, 3287711984, 3287711999, 'FR', 'FRA', 'فرنسا'),
(78639, 3287712000, 3287712512, 'GB', 'GBR', 'المملكة المتحدة'),
(78640, 3287712513, 3287713023, 'FR', 'FRA', 'فرنسا'),
(78641, 3287713024, 3287713439, 'GB', 'GBR', 'المملكة المتحدة'),
(78642, 3287713440, 3287713471, 'FR', 'FRA', 'فرنسا'),
(78643, 3287713472, 3287713535, 'GB', 'GBR', 'المملكة المتحدة'),
(78644, 3287713536, 3287713567, 'FR', 'FRA', 'فرنسا'),
(78645, 3287713568, 3287713591, 'GB', 'GBR', 'المملكة المتحدة'),
(78646, 3287713592, 3287713598, 'FR', 'FRA', 'فرنسا'),
(78647, 3287713599, 3287713599, 'GB', 'GBR', 'المملكة المتحدة'),
(78648, 3287713600, 3287713603, 'FR', 'FRA', 'فرنسا'),
(78649, 3287713604, 3287713611, 'GB', 'GBR', 'المملكة المتحدة'),
(78650, 3287713612, 3287713615, 'FR', 'FRA', 'فرنسا'),
(78651, 3287713616, 3287713623, 'GB', 'GBR', 'المملكة المتحدة'),
(78652, 3287713624, 3287713667, 'FR', 'FRA', 'فرنسا'),
(78653, 3287713668, 3287713711, 'GB', 'GBR', 'المملكة المتحدة'),
(78654, 3287713712, 3287713727, 'FR', 'FRA', 'فرنسا'),
(78655, 3287713728, 3287713775, 'GB', 'GBR', 'المملكة المتحدة'),
(78656, 3287713776, 3287713791, 'FR', 'FRA', 'فرنسا'),
(78657, 3287713792, 3287714047, 'GB', 'GBR', 'المملكة المتحدة'),
(78658, 3287714048, 3287715071, 'FR', 'FRA', 'فرنسا'),
(78659, 3287715072, 3287715327, 'GB', 'GBR', 'المملكة المتحدة'),
(78660, 3287715328, 3287715839, 'FR', 'FRA', 'فرنسا'),
(78661, 3287715840, 3287716127, 'GB', 'GBR', 'المملكة المتحدة'),
(78662, 3287716128, 3287716143, 'FR', 'FRA', 'فرنسا'),
(78663, 3287716144, 3287717631, 'GB', 'GBR', 'المملكة المتحدة'),
(78664, 3287717632, 3287717887, 'FR', 'FRA', 'فرنسا'),
(78665, 3287717888, 3287718719, 'GB', 'GBR', 'المملكة المتحدة'),
(78666, 3287718720, 3287718731, 'FR', 'FRA', 'فرنسا'),
(78667, 3287718732, 3287718735, 'GB', 'GBR', 'المملكة المتحدة'),
(78668, 3287718736, 3287719935, 'FR', 'FRA', 'فرنسا'),
(78669, 3287719936, 3287728127, 'DE', 'DEU', 'ألمانيا'),
(78670, 3287728128, 3287729407, 'IT', 'ITA', 'إيطاليا'),
(78671, 3287729408, 3287729663, 'SE', 'SWE', 'السويد'),
(78672, 3287729664, 3287729919, 'DK', 'DNK', 'الدنيمارك'),
(78673, 3287729920, 3287730175, 'HU', 'HUN', 'هنغاريا'),
(78674, 3287730176, 3287730431, 'PL', 'POL', 'بولندا'),
(78675, 3287730432, 3287730687, 'GB', 'GBR', 'المملكة المتحدة'),
(78676, 3287730688, 3287732223, 'DE', 'DEU', 'ألمانيا'),
(78677, 3287732224, 3287734271, 'IT', 'ITA', 'إيطاليا'),
(78678, 3287734272, 3287734527, 'PL', 'POL', 'بولندا'),
(78679, 3287734528, 3287734783, 'UA', 'UKR', 'أوكرانيا'),
(78680, 3287735040, 3287735295, 'SE', 'SWE', 'السويد'),
(78681, 3287735296, 3287736319, 'IT', 'ITA', 'إيطاليا'),
(78682, 3287736320, 3287736831, 'PL', 'POL', 'بولندا'),
(78683, 3287736832, 3287737343, 'LV', 'LVA', 'لاتفيا'),
(78684, 3287737344, 3287737855, 'GB', 'GBR', 'المملكة المتحدة'),
(78685, 3287737856, 3287738367, 'FR', 'FRA', 'فرنسا'),
(78686, 3287738368, 3287738879, 'GB', 'GBR', 'المملكة المتحدة'),
(78687, 3287738880, 3287739391, 'DE', 'DEU', 'ألمانيا'),
(78688, 3287739392, 3287739903, 'NL', 'NLD', 'هولندا'),
(78689, 3287739904, 3287740415, 'PT', 'PRT', 'البورتوغال'),
(78690, 3287740416, 3287740927, 'BG', 'BGR', 'بلغاريا'),
(78691, 3287740928, 3287741439, 'RO', 'ROM', 'رومانيا'),
(78692, 3287741440, 3287741951, 'CH', 'CHE', 'سويسرا'),
(78693, 3287741952, 3287742463, 'RO', 'ROM', 'رومانيا'),
(78694, 3287742464, 3287742975, 'RU', 'RUS', 'الإتحاد الروسي'),
(78695, 3287742976, 3287743487, 'RO', 'ROM', 'رومانيا'),
(78696, 3287743488, 3287743999, 'DE', 'DEU', 'ألمانيا'),
(78697, 3287744000, 3287744511, 'FR', 'FRA', 'فرنسا'),
(78698, 3287744512, 3287810047, 'DE', 'DEU', 'ألمانيا'),
(78699, 3287810048, 3287818239, 'FR', 'FRA', 'فرنسا'),
(78700, 3287818240, 3287826431, 'AT', 'AUT', 'النمسا'),
(78701, 3287826432, 3287826687, 'LV', 'LVA', 'لاتفيا'),
(78702, 3287826688, 3287826943, 'RO', 'ROM', 'رومانيا'),
(78703, 3287826944, 3287827199, 'RU', 'RUS', 'الإتحاد الروسي'),
(78704, 3287827200, 3287827455, 'DE', 'DEU', 'ألمانيا'),
(78705, 3287827456, 3287827711, 'SI', 'SVN', 'سلوفينيا'),
(78706, 3287827712, 3287827967, 'RU', 'RUS', 'الإتحاد الروسي'),
(78707, 3287827968, 3287828223, 'GB', 'GBR', 'المملكة المتحدة'),
(78708, 3287828224, 3287828479, 'DE', 'DEU', 'ألمانيا'),
(78709, 3287828480, 3287828735, 'PL', 'POL', 'بولندا'),
(78710, 3287828736, 3287828991, 'AT', 'AUT', 'النمسا'),
(78711, 3287828992, 3287829247, 'DE', 'DEU', 'ألمانيا'),
(78712, 3287829248, 3287829503, 'GB', 'GBR', 'المملكة المتحدة'),
(78713, 3287829504, 3287829759, 'RO', 'ROM', 'رومانيا'),
(78714, 3287829760, 3287830015, 'NL', 'NLD', 'هولندا'),
(78715, 3287830016, 3287830271, 'NO', 'NOR', 'النرويج'),
(78716, 3287830272, 3287830527, 'RO', 'ROM', 'رومانيا'),
(78717, 3287830528, 3287830783, 'IE', 'IRL', 'إيرلندا'),
(78718, 3287830784, 3287831039, 'GB', 'GBR', 'المملكة المتحدة'),
(78719, 3287831040, 3287831295, 'RU', 'RUS', 'الإتحاد الروسي'),
(78720, 3287831296, 3287831551, 'CH', 'CHE', 'سويسرا'),
(78721, 3287831552, 3287831807, 'RO', 'ROM', 'رومانيا'),
(78722, 3287831808, 3287832063, 'AT', 'AUT', 'النمسا'),
(78723, 3287832064, 3287832319, 'FI', 'FIN', 'فنلندا'),
(78724, 3287832320, 3287832575, 'NL', 'NLD', 'هولندا'),
(78725, 3287832576, 3287832831, 'PL', 'POL', 'بولندا'),
(78726, 3287832832, 3287833087, 'DE', 'DEU', 'ألمانيا'),
(78727, 3287833088, 3287833343, 'GB', 'GBR', 'المملكة المتحدة'),
(78728, 3287833344, 3287833855, 'CH', 'CHE', 'سويسرا'),
(78729, 3287833856, 3287834111, 'UA', 'UKR', 'أوكرانيا'),
(78730, 3287834112, 3287834367, 'RU', 'RUS', 'الإتحاد الروسي'),
(78731, 3287834368, 3287834623, 'HU', 'HUN', 'هنغاريا'),
(78732, 3287834624, 3287842815, 'GB', 'GBR', 'المملكة المتحدة'),
(78733, 3287842816, 3287851007, 'DE', 'DEU', 'ألمانيا'),
(78734, 3287851008, 3287859199, 'UA', 'UKR', 'أوكرانيا'),
(78735, 3287859200, 3287859455, 'GB', 'GBR', 'المملكة المتحدة'),
(78736, 3287859456, 3287859711, 'FK', 'FLK', 'جزر فوكلاند (مالفيناس)'),
(78737, 3287859968, 3287860479, 'GB', 'GBR', 'المملكة المتحدة'),
(78738, 3287861248, 3287862015, 'GB', 'GBR', 'المملكة المتحدة'),
(78739, 3287863808, 3287864063, 'GB', 'GBR', 'المملكة المتحدة'),
(78740, 3287866384, 3287866439, 'GB', 'GBR', 'المملكة المتحدة'),
(78741, 3287866496, 3287866591, 'GB', 'GBR', 'المملكة المتحدة'),
(78742, 3287866608, 3287866623, 'GB', 'GBR', 'المملكة المتحدة'),
(78743, 3287867392, 3287867903, 'UA', 'UKR', 'أوكرانيا'),
(78744, 3287867904, 3287868415, 'PL', 'POL', 'بولندا'),
(78745, 3287868416, 3287868927, 'RO', 'ROM', 'رومانيا'),
(78746, 3287868928, 3287869439, 'ES', 'ESP', 'إسبانيا'),
(78747, 3287869440, 3287869951, 'RU', 'RUS', 'الإتحاد الروسي'),
(78748, 3287869952, 3287870463, 'UA', 'UKR', 'أوكرانيا'),
(78749, 3287870464, 3287870975, 'RU', 'RUS', 'الإتحاد الروسي'),
(78750, 3287870976, 3287871487, 'NL', 'NLD', 'هولندا'),
(78751, 3287871488, 3287871999, 'PL', 'POL', 'بولندا'),
(78752, 3287872000, 3287872511, 'RU', 'RUS', 'الإتحاد الروسي'),
(78753, 3287872512, 3287873023, 'GB', 'GBR', 'المملكة المتحدة'),
(78754, 3287873024, 3287873535, 'PL', 'POL', 'بولندا'),
(78755, 3287873536, 3287874047, 'RU', 'RUS', 'الإتحاد الروسي'),
(78756, 3287874048, 3287874559, 'FR', 'FRA', 'فرنسا'),
(78757, 3287874560, 3287875071, 'DE', 'DEU', 'ألمانيا'),
(78758, 3287875072, 3287875583, 'PL', 'POL', 'بولندا'),
(78759, 3287875584, 3287941119, 'DK', 'DNK', 'الدنيمارك'),
(78760, 3287941120, 3287949311, 'IT', 'ITA', 'إيطاليا'),
(78761, 3287949312, 3287949567, 'AT', 'AUT', 'النمسا'),
(78762, 3287949568, 3287949823, 'IL', 'ISR', 'إسرائيل'),
(78763, 3287949824, 3287950079, 'IT', 'ITA', 'إيطاليا'),
(78764, 3287950080, 3287950335, 'DE', 'DEU', 'ألمانيا'),
(78765, 3287950336, 3287950591, 'UA', 'UKR', 'أوكرانيا'),
(78766, 3287950592, 3287950847, 'PL', 'POL', 'بولندا'),
(78767, 3287950848, 3287951103, 'DE', 'DEU', 'ألمانيا'),
(78768, 3287951104, 3287951359, 'HU', 'HUN', 'هنغاريا'),
(78769, 3287951360, 3287951615, 'FR', 'FRA', 'فرنسا'),
(78770, 3287951616, 3287951871, 'CH', 'CHE', 'سويسرا'),
(78771, 3287951872, 3287952127, 'RU', 'RUS', 'الإتحاد الروسي'),
(78772, 3287952128, 3287952383, 'UA', 'UKR', 'أوكرانيا'),
(78773, 3287952384, 3287953151, 'CH', 'CHE', 'سويسرا'),
(78774, 3287953152, 3287953407, 'IL', 'ISR', 'إسرائيل'),
(78775, 3287953408, 3287953663, 'DE', 'DEU', 'ألمانيا'),
(78776, 3287953664, 3287953919, 'GB', 'GBR', 'المملكة المتحدة'),
(78777, 3287953920, 3287954175, 'DE', 'DEU', 'ألمانيا'),
(78778, 3287954176, 3287954431, 'RU', 'RUS', 'الإتحاد الروسي'),
(78779, 3287954432, 3287954687, 'CH', 'CHE', 'سويسرا'),
(78780, 3287954688, 3287954943, 'RO', 'ROM', 'رومانيا'),
(78781, 3287954944, 3287955199, 'PL', 'POL', 'بولندا'),
(78782, 3287955200, 3287955711, 'RU', 'RUS', 'الإتحاد الروسي'),
(78783, 3287955712, 3287955967, 'DE', 'DEU', 'ألمانيا'),
(78784, 3287955968, 3287956223, 'SI', 'SVN', 'سلوفينيا'),
(78785, 3287956224, 3287956479, 'RO', 'ROM', 'رومانيا'),
(78786, 3287956480, 3287956735, 'FR', 'FRA', 'فرنسا'),
(78787, 3287956736, 3287956991, 'SE', 'SWE', 'السويد'),
(78788, 3287956992, 3287957247, 'UA', 'UKR', 'أوكرانيا'),
(78789, 3287957248, 3287957503, 'GB', 'GBR', 'المملكة المتحدة'),
(78790, 3287957504, 3287965695, 'AM', 'ARM', 'أرمينيا'),
(78791, 3287965696, 3287967743, 'RS', 'SRB', 'صربيا'),
(78792, 3287967744, 3287967871, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78793, 3287967872, 3287967878, 'RS', 'SRB', 'صربيا'),
(78794, 3287967879, 3287967879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78795, 3287967880, 3287967883, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78796, 3287967884, 3287967884, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78797, 3287967885, 3287967885, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78798, 3287967886, 3287967886, 'RS', 'SRB', 'صربيا'),
(78799, 3287967887, 3287967888, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78800, 3287967889, 3287967889, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78801, 3287967890, 3287967905, 'RS', 'SRB', 'صربيا'),
(78802, 3287967906, 3287967906, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78803, 3287967907, 3287967935, 'RS', 'SRB', 'صربيا'),
(78804, 3287967936, 3287967967, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78805, 3287967968, 3287967999, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78806, 3287968000, 3287968335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78807, 3287968336, 3287968463, 'RS', 'SRB', 'صربيا'),
(78808, 3287968464, 3287968479, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78809, 3287968480, 3287968495, 'RS', 'SRB', 'صربيا'),
(78810, 3287968496, 3287968543, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78811, 3287968544, 3287968575, 'RS', 'SRB', 'صربيا'),
(78812, 3287968576, 3287968607, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78813, 3287968608, 3287968639, 'RS', 'SRB', 'صربيا'),
(78814, 3287968640, 3287969023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78815, 3287969024, 3287969791, 'RS', 'SRB', 'صربيا'),
(78816, 3287969792, 3287969951, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78817, 3287969952, 3287969999, 'RS', 'SRB', 'صربيا'),
(78818, 3287970000, 3287970191, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78819, 3287970192, 3287970207, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78820, 3287970208, 3287970239, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78821, 3287970240, 3287970271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78822, 3287970272, 3287970527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78823, 3287970528, 3287970559, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78824, 3287970560, 3287970815, 'RS', 'SRB', 'صربيا'),
(78825, 3287970816, 3287970943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78826, 3287970944, 3287971071, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78827, 3287971072, 3287971327, 'RS', 'SRB', 'صربيا'),
(78828, 3287971328, 3287971391, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78829, 3287971392, 3287971583, 'RS', 'SRB', 'صربيا'),
(78830, 3287971584, 3287971711, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78831, 3287971712, 3287971839, 'RS', 'SRB', 'صربيا'),
(78832, 3287971840, 3287972351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78833, 3287972352, 3287973887, 'RS', 'SRB', 'صربيا'),
(78834, 3287973888, 3287982079, 'CZ', 'CZE', 'التشيك'),
(78835, 3287982080, 3287990271, 'EE', 'EST', 'إستونيا'),
(78836, 3287990272, 3287998463, 'SI', 'SVN', 'سلوفينيا'),
(78837, 3287998464, 3288006655, 'IT', 'ITA', 'إيطاليا'),
(78838, 3288006656, 3288072191, 'GR', 'GRC', 'اليونان'),
(78839, 3288072192, 3288088575, 'SE', 'SWE', 'السويد'),
(78840, 3288088576, 3288090111, 'RS', 'SRB', 'صربيا'),
(78841, 3288090112, 3288090367, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78842, 3288090368, 3288090623, 'RS', 'SRB', 'صربيا'),
(78843, 3288090624, 3288091647, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78844, 3288091648, 3288092159, 'RS', 'SRB', 'صربيا'),
(78845, 3288092160, 3288093183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78846, 3288093184, 3288093439, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78847, 3288093440, 3288094719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78848, 3288094720, 3288097279, 'RS', 'SRB', 'صربيا'),
(78849, 3288097280, 3288097663, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78850, 3288097664, 3288097791, 'RS', 'SRB', 'صربيا'),
(78851, 3288097792, 3288098815, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78852, 3288098816, 3288099455, 'RS', 'SRB', 'صربيا'),
(78853, 3288099456, 3288099583, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78854, 3288099584, 3288099719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78855, 3288099720, 3288099727, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78856, 3288099728, 3288099735, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78857, 3288099736, 3288099775, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78858, 3288099776, 3288099783, 'RS', 'SRB', 'صربيا'),
(78859, 3288099784, 3288099799, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78860, 3288099800, 3288099839, 'RS', 'SRB', 'صربيا'),
(78861, 3288099840, 3288100095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78862, 3288100096, 3288100543, 'RS', 'SRB', 'صربيا'),
(78863, 3288100544, 3288100607, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78864, 3288100608, 3288100735, 'RS', 'SRB', 'صربيا'),
(78865, 3288100736, 3288100863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78866, 3288100864, 3288101247, 'RS', 'SRB', 'صربيا'),
(78867, 3288101248, 3288101375, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78868, 3288101376, 3288101631, 'RS', 'SRB', 'صربيا'),
(78869, 3288101632, 3288101887, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78870, 3288101888, 3288102143, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78871, 3288102144, 3288102399, 'RS', 'SRB', 'صربيا'),
(78872, 3288102400, 3288102527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78873, 3288102528, 3288102543, 'RS', 'SRB', 'صربيا'),
(78874, 3288102544, 3288102551, 'DK', 'DNK', 'الدنيمارك'),
(78875, 3288102552, 3288102911, 'RS', 'SRB', 'صربيا'),
(78876, 3288102912, 3288103167, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78877, 3288103168, 3288103423, 'RS', 'SRB', 'صربيا'),
(78878, 3288103424, 3288103935, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78879, 3288103936, 3288104447, 'RS', 'SRB', 'صربيا'),
(78880, 3288104448, 3288104703, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(78881, 3288104704, 3288104959, 'RS', 'SRB', 'صربيا'),
(78882, 3288104960, 3288143615, 'DE', 'DEU', 'ألمانيا'),
(78883, 3288143616, 3288143871, 'CH', 'CHE', 'سويسرا'),
(78884, 3288143872, 3288145663, 'DE', 'DEU', 'ألمانيا'),
(78885, 3288145664, 3288146175, 'CH', 'CHE', 'سويسرا'),
(78886, 3288146176, 3288150015, 'DE', 'DEU', 'ألمانيا'),
(78887, 3288150016, 3288151551, 'NL', 'NLD', 'هولندا'),
(78888, 3288151552, 3288236031, 'DE', 'DEU', 'ألمانيا'),
(78889, 3288236032, 3288236543, 'LI', 'LIE', 'ليختنشتاين'),
(78890, 3288236544, 3288237055, 'FR', 'FRA', 'فرنسا'),
(78891, 3288237056, 3288238591, 'RO', 'ROM', 'رومانيا'),
(78892, 3288238592, 3288239103, 'PL', 'POL', 'بولندا'),
(78893, 3288239104, 3288239615, 'RO', 'ROM', 'رومانيا'),
(78894, 3288239616, 3288240127, 'UA', 'UKR', 'أوكرانيا'),
(78895, 3288240128, 3288240639, 'CH', 'CHE', 'سويسرا'),
(78896, 3288240640, 3288241151, 'FR', 'FRA', 'فرنسا'),
(78897, 3288241152, 3288241663, 'ES', 'ESP', 'إسبانيا'),
(78898, 3288241664, 3288242175, 'UA', 'UKR', 'أوكرانيا'),
(78899, 3288242176, 3288242687, 'RO', 'ROM', 'رومانيا'),
(78900, 3288242688, 3288243199, 'FR', 'FRA', 'فرنسا'),
(78901, 3288243200, 3288243711, 'PL', 'POL', 'بولندا'),
(78902, 3288243712, 3288244223, 'FR', 'FRA', 'فرنسا'),
(78903, 3288252416, 3288260607, 'NO', 'NOR', 'النرويج'),
(78904, 3288260608, 3288268799, 'IT', 'ITA', 'إيطاليا'),
(78905, 3288268800, 3288334335, 'FI', 'FIN', 'فنلندا'),
(78906, 3288400128, 3288400383, 'IN', 'IND', 'الهند'),
(78907, 3288400384, 3288400639, 'PR', 'PRI', 'بورتو ريكو'),
(78908, 3288400640, 3288400895, 'SA', 'SAU', 'السعودية'),
(78909, 3288401152, 3288401407, 'RU', 'RUS', 'الإتحاد الروسي'),
(78910, 3288401408, 3288401663, 'SA', 'SAU', 'السعودية'),
(78911, 3288416256, 3288417279, 'SA', 'SAU', 'السعودية'),
(78912, 3288417280, 3288417535, 'IN', 'IND', 'الهند'),
(78913, 3288417536, 3288418047, 'KW', 'KWT', 'الكويت'),
(78914, 3288418304, 3288418815, 'US', 'USA', 'الولايات المتحدة'),
(78915, 3288426496, 3288427263, 'IN', 'IND', 'الهند'),
(78916, 3288427264, 3288427519, 'BM', 'BMU', 'برمودا'),
(78917, 3288427520, 3288428543, 'IN', 'IND', 'الهند'),
(78918, 3288428544, 3288428799, 'CU', 'CUB', 'كوبا'),
(78919, 3288428800, 3288429311, 'IN', 'IND', 'الهند'),
(78920, 3288434176, 3288434431, 'IN', 'IND', 'الهند'),
(78921, 3288434432, 3288434687, 'CU', 'CUB', 'كوبا'),
(78922, 3288434688, 3288434943, 'JM', 'JAM', 'جامايكا'),
(78923, 3288435200, 3288435711, 'JM', 'JAM', 'جامايكا'),
(78924, 3288435712, 3288435967, 'US', 'USA', 'الولايات المتحدة'),
(78925, 3288435968, 3288436223, 'PR', 'PRI', 'بورتو ريكو'),
(78926, 3288436224, 3288436479, 'US', 'USA', 'الولايات المتحدة'),
(78927, 3288440832, 3288441103, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(78928, 3288441104, 3288442879, 'BB', 'BRB', 'باربادوس'),
(78929, 3288442880, 3288443135, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(78930, 3288443136, 3288443391, 'BB', 'BRB', 'باربادوس'),
(78931, 3288443392, 3288443647, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(78932, 3288443648, 3288444927, 'BB', 'BRB', 'باربادوس'),
(78933, 3288465408, 3288465919, 'JM', 'JAM', 'جامايكا'),
(78934, 3288466432, 3288467455, 'SY', 'SYR', 'سوريا'),
(78935, 3288530944, 3288532991, 'JM', 'JAM', 'جامايكا'),
(78936, 3288532992, 3288534527, 'PR', 'PRI', 'بورتو ريكو'),
(78937, 3288535040, 3288539135, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(78938, 3288539136, 3288545535, 'US', 'USA', 'الولايات المتحدة'),
(78939, 3288547584, 3288547839, 'IN', 'IND', 'الهند'),
(78940, 3288547840, 3288548095, 'SA', 'SAU', 'السعودية'),
(78941, 3288548096, 3288549375, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(78942, 3288549376, 3288549631, 'PK', 'PAK', 'باكستان'),
(78943, 3288549632, 3288549887, 'GD', 'GRD', 'غرينادا'),
(78944, 3288549888, 3288553983, 'DO', 'DOM', 'الدومينيكان'),
(78945, 3288554240, 3288554495, 'IR', 'IRN', 'إيران'),
(78946, 3288555264, 3288555519, 'JM', 'JAM', 'جامايكا'),
(78947, 3288557568, 3288557823, 'JM', 'JAM', 'جامايكا'),
(78948, 3288558080, 3288558335, 'DO', 'DOM', 'الدومينيكان'),
(78949, 3288564736, 3288568831, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(78950, 3288569856, 3288570111, 'CU', 'CUB', 'كوبا'),
(78951, 3288570112, 3288570367, 'JM', 'JAM', 'جامايكا'),
(78952, 3288578048, 3288580095, 'JM', 'JAM', 'جامايكا'),
(78953, 3288580096, 3288588287, 'BB', 'BRB', 'باربادوس'),
(78954, 3288608256, 3288614655, 'US', 'USA', 'الولايات المتحدة'),
(78955, 3289120768, 3289123327, 'PR', 'PRI', 'بورتو ريكو'),
(78956, 3289128960, 3289137151, 'IN', 'IND', 'الهند'),
(78957, 3289137152, 3289153535, 'BM', 'BMU', 'برمودا'),
(78958, 3289161728, 3289163263, 'PR', 'PRI', 'بورتو ريكو'),
(78959, 3289163264, 3289163519, 'US', 'USA', 'الولايات المتحدة'),
(78960, 3289163520, 3289169919, 'PR', 'PRI', 'بورتو ريكو'),
(78961, 3289321472, 3289325567, 'IN', 'IND', 'الهند'),
(78962, 3289325568, 3289333759, 'SA', 'SAU', 'السعودية'),
(78963, 3290103808, 3290104831, 'US', 'USA', 'الولايات المتحدة'),
(78964, 3290104832, 3290105855, 'VE', 'VEN', 'فنزويلا'),
(78965, 3290105856, 3290107351, 'US', 'USA', 'الولايات المتحدة'),
(78966, 3290107352, 3290107359, 'CA', 'CAN', 'كندا'),
(78967, 3290107360, 3290107375, 'US', 'USA', 'الولايات المتحدة'),
(78968, 3290107376, 3290107383, 'CA', 'CAN', 'كندا'),
(78969, 3290107384, 3290111999, 'US', 'USA', 'الولايات المتحدة'),
(78970, 3290112000, 3290112127, 'CA', 'CAN', 'كندا'),
(78971, 3290112128, 3290120191, 'US', 'USA', 'الولايات المتحدة'),
(78972, 3290181632, 3290181887, 'US', 'USA', 'الولايات المتحدة'),
(78973, 3290181888, 3290181951, 'PR', 'PRI', 'بورتو ريكو'),
(78974, 3290181952, 3290181959, 'US', 'USA', 'الولايات المتحدة'),
(78975, 3290181960, 3290181967, 'PR', 'PRI', 'بورتو ريكو'),
(78976, 3290181968, 3290182031, 'US', 'USA', 'الولايات المتحدة'),
(78977, 3290182032, 3290182399, 'PR', 'PRI', 'بورتو ريكو'),
(78978, 3290182400, 3290182655, 'US', 'USA', 'الولايات المتحدة'),
(78979, 3290182656, 3290183230, 'PR', 'PRI', 'بورتو ريكو'),
(78980, 3290183231, 3290183262, 'US', 'USA', 'الولايات المتحدة'),
(78981, 3290183263, 3290183326, 'PR', 'PRI', 'بورتو ريكو'),
(78982, 3290183327, 3290183679, 'US', 'USA', 'الولايات المتحدة'),
(78983, 3290183680, 3290185727, 'PR', 'PRI', 'بورتو ريكو'),
(78984, 3290251264, 3290259455, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(78985, 3290431488, 3290433535, 'JM', 'JAM', 'جامايكا'),
(78986, 3290439680, 3290447871, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(78987, 3290447872, 3290456063, 'AR', 'ARG', 'الأرجنتين'),
(78988, 3290464256, 3290472447, 'PR', 'PRI', 'بورتو ريكو'),
(78989, 3290955776, 3290980351, 'CR', 'CRI', 'كوستا ريكا'),
(78990, 3291086848, 3291103231, 'PR', 'PRI', 'بورتو ريكو'),
(78991, 3302449152, 3302449279, 'DK', 'DNK', 'الدنيمارك'),
(78992, 3302490368, 3302490623, 'US', 'USA', 'الولايات المتحدة'),
(78993, 3321956352, 3321960959, 'US', 'USA', 'الولايات المتحدة'),
(78994, 3321962496, 3321967615, 'US', 'USA', 'الولايات المتحدة'),
(78995, 3322019840, 3322023935, 'US', 'USA', 'الولايات المتحدة'),
(78996, 3322023936, 3322028031, 'CL', 'CHL', 'تشيلي'),
(78997, 3322085376, 3322167295, 'US', 'USA', 'الولايات المتحدة'),
(78998, 3322167296, 3322167807, 'GB', 'GBR', 'المملكة المتحدة'),
(78999, 3322167808, 3322351615, 'US', 'USA', 'الولايات المتحدة'),
(79000, 3322355712, 3322361855, 'US', 'USA', 'الولايات المتحدة'),
(79001, 3322363904, 3322372095, 'US', 'USA', 'الولايات المتحدة'),
(79002, 3322380288, 3322396671, 'US', 'USA', 'الولايات المتحدة'),
(79003, 3322404864, 3322427647, 'US', 'USA', 'الولايات المتحدة'),
(79004, 3322429440, 3322430975, 'US', 'USA', 'الولايات المتحدة'),
(79005, 3322445824, 3322609663, 'US', 'USA', 'الولايات المتحدة'),
(79006, 3322609664, 3322610687, 'SA', 'SAU', 'السعودية'),
(79007, 3322610688, 3322611711, 'US', 'USA', 'الولايات المتحدة'),
(79008, 3322613760, 3322638847, 'US', 'USA', 'الولايات المتحدة'),
(79009, 3322675200, 3322677759, 'US', 'USA', 'الولايات المتحدة'),
(79010, 3322679296, 3322683391, 'US', 'USA', 'الولايات المتحدة'),
(79011, 3322683392, 3322691583, 'BR', 'BRA', 'البرازيل'),
(79012, 3322740736, 3322759679, 'US', 'USA', 'الولايات المتحدة'),
(79013, 3322806272, 3322855423, 'US', 'USA', 'الولايات المتحدة'),
(79014, 3322872832, 3322875903, 'US', 'USA', 'الولايات المتحدة'),
(79015, 3322875904, 3322888191, 'AU', 'AUS', 'أستراليا'),
(79016, 3322937344, 3322938367, 'US', 'USA', 'الولايات المتحدة'),
(79017, 3322939392, 3322943743, 'US', 'USA', 'الولايات المتحدة'),
(79018, 3323003136, 3323003391, 'JP', 'JPN', 'اليابان'),
(79019, 3323003392, 3323003647, 'US', 'USA', 'الولايات المتحدة'),
(79020, 3323004160, 3323004671, 'US', 'USA', 'الولايات المتحدة'),
(79021, 3323004672, 3323004927, 'CN', 'CHN', 'الصين'),
(79022, 3323004928, 3323007743, 'US', 'USA', 'الولايات المتحدة'),
(79023, 3323009024, 3323011071, 'US', 'USA', 'الولايات المتحدة'),
(79024, 3323011328, 3323013631, 'US', 'USA', 'الولايات المتحدة'),
(79025, 3323013888, 3323014143, 'CA', 'CAN', 'كندا'),
(79026, 3323014400, 3323015679, 'US', 'USA', 'الولايات المتحدة'),
(79027, 3323016192, 3323017727, 'US', 'USA', 'الولايات المتحدة'),
(79028, 3323017728, 3323017983, 'CA', 'CAN', 'كندا'),
(79029, 3323017984, 3323018239, 'US', 'USA', 'الولايات المتحدة'),
(79030, 3323018752, 3323020799, 'US', 'USA', 'الولايات المتحدة'),
(79031, 3323020800, 3323021055, 'SG', 'SGP', 'سنغافورة'),
(79032, 3323021056, 3323022591, 'US', 'USA', 'الولايات المتحدة'),
(79033, 3323022592, 3323022847, 'GB', 'GBR', 'المملكة المتحدة'),
(79034, 3323022848, 3323024383, 'US', 'USA', 'الولايات المتحدة'),
(79035, 3323024640, 3323025663, 'US', 'USA', 'الولايات المتحدة'),
(79036, 3323025920, 3323027199, 'US', 'USA', 'الولايات المتحدة'),
(79037, 3323027712, 3323030015, 'US', 'USA', 'الولايات المتحدة'),
(79038, 3323030016, 3323030271, 'AU', 'AUS', 'أستراليا'),
(79039, 3323030272, 3323031039, 'US', 'USA', 'الولايات المتحدة'),
(79040, 3323031808, 3323032575, 'AU', 'AUS', 'أستراليا'),
(79041, 3323032576, 3323032831, 'US', 'USA', 'الولايات المتحدة'),
(79042, 3323032832, 3323033087, 'IT', 'ITA', 'إيطاليا'),
(79043, 3323033600, 3323034111, 'BR', 'BRA', 'البرازيل'),
(79044, 3323034112, 3323035135, 'US', 'USA', 'الولايات المتحدة'),
(79045, 3323035392, 3323038463, 'US', 'USA', 'الولايات المتحدة'),
(79046, 3323038720, 3323038975, 'CA', 'CAN', 'كندا'),
(79047, 3323038976, 3323043839, 'US', 'USA', 'الولايات المتحدة'),
(79048, 3323044096, 3323046399, 'US', 'USA', 'الولايات المتحدة'),
(79049, 3323046912, 3323048447, 'US', 'USA', 'الولايات المتحدة'),
(79050, 3323048704, 3323048959, 'US', 'USA', 'الولايات المتحدة'),
(79051, 3323048960, 3323049727, 'NL', 'NLD', 'هولندا'),
(79052, 3323049728, 3323056895, 'US', 'USA', 'الولايات المتحدة'),
(79053, 3323057408, 3323058175, 'US', 'USA', 'الولايات المتحدة'),
(79054, 3323058432, 3323058943, 'US', 'USA', 'الولايات المتحدة'),
(79055, 3323059200, 3323061247, 'US', 'USA', 'الولايات المتحدة'),
(79056, 3323061248, 3323061503, 'SG', 'SGP', 'سنغافورة'),
(79057, 3323061504, 3323062015, 'US', 'USA', 'الولايات المتحدة'),
(79058, 3323062016, 3323062527, 'BR', 'BRA', 'البرازيل'),
(79059, 3323062784, 3323064319, 'US', 'USA', 'الولايات المتحدة'),
(79060, 3323064320, 3323064831, 'AU', 'AUS', 'أستراليا'),
(79061, 3323064832, 3323066367, 'US', 'USA', 'الولايات المتحدة'),
(79062, 3323066624, 3323067135, 'US', 'USA', 'الولايات المتحدة'),
(79063, 3323067392, 3323068159, 'US', 'USA', 'الولايات المتحدة'),
(79064, 3323068416, 3323199487, 'US', 'USA', 'الولايات المتحدة'),
(79065, 3323201536, 3323203583, 'CA', 'CAN', 'كندا'),
(79066, 3323203584, 3323207679, 'US', 'USA', 'الولايات المتحدة'),
(79067, 3323207680, 3323215871, 'CA', 'CAN', 'كندا'),
(79068, 3323267072, 3323286015, 'US', 'USA', 'الولايات المتحدة'),
(79069, 3323330816, 3323331071, 'US', 'USA', 'الولايات المتحدة'),
(79070, 3323331840, 3323333119, 'US', 'USA', 'الولايات المتحدة'),
(79071, 3323333376, 3323339263, 'US', 'USA', 'الولايات المتحدة'),
(79072, 3323339264, 3323339519, 'AU', 'AUS', 'أستراليا'),
(79073, 3323339520, 3323339775, 'TH', 'THA', 'تايلند'),
(79074, 3323340032, 3323340287, 'NZ', 'NZL', 'نيوزيلاندا'),
(79075, 3323340288, 3323340799, 'US', 'USA', 'الولايات المتحدة'),
(79076, 3323341056, 3323342335, 'US', 'USA', 'الولايات المتحدة'),
(79077, 3323342592, 3323343615, 'AU', 'AUS', 'أستراليا'),
(79078, 3323343616, 3323343871, 'DE', 'DEU', 'ألمانيا'),
(79079, 3323343872, 3323345919, 'US', 'USA', 'الولايات المتحدة'),
(79080, 3323346176, 3323346431, 'AU', 'AUS', 'أستراليا'),
(79081, 3323346432, 3323354367, 'US', 'USA', 'الولايات المتحدة'),
(79082, 3323354368, 3323355647, 'DE', 'DEU', 'ألمانيا'),
(79083, 3323355904, 3323356671, 'US', 'USA', 'الولايات المتحدة'),
(79084, 3323356672, 3323356927, 'CA', 'CAN', 'كندا'),
(79085, 3323356928, 3323357695, 'US', 'USA', 'الولايات المتحدة'),
(79086, 3323358208, 3323365119, 'US', 'USA', 'الولايات المتحدة'),
(79087, 3323365632, 3323365887, 'US', 'USA', 'الولايات المتحدة'),
(79088, 3323366144, 3323367423, 'US', 'USA', 'الولايات المتحدة'),
(79089, 3323367680, 3323374079, 'US', 'USA', 'الولايات المتحدة'),
(79090, 3323374336, 3323376127, 'US', 'USA', 'الولايات المتحدة'),
(79091, 3323376384, 3323376639, 'US', 'USA', 'الولايات المتحدة'),
(79092, 3323376896, 3323378687, 'US', 'USA', 'الولايات المتحدة'),
(79093, 3323378688, 3323378943, 'CA', 'CAN', 'كندا'),
(79094, 3323378944, 3323380479, 'US', 'USA', 'الولايات المتحدة'),
(79095, 3323380736, 3323382271, 'US', 'USA', 'الولايات المتحدة'),
(79096, 3323383552, 3323383807, 'US', 'USA', 'الولايات المتحدة'),
(79097, 3323386112, 3323388927, 'US', 'USA', 'الولايات المتحدة'),
(79098, 3323389184, 3323391231, 'US', 'USA', 'الولايات المتحدة'),
(79099, 3323391232, 3323391487, 'CA', 'CAN', 'كندا'),
(79100, 3323391488, 3323394559, 'US', 'USA', 'الولايات المتحدة'),
(79101, 3323394560, 3323395071, 'CL', 'CHL', 'تشيلي'),
(79102, 3323395072, 3323395327, 'US', 'USA', 'الولايات المتحدة'),
(79103, 3323395584, 3323395839, 'US', 'USA', 'الولايات المتحدة'),
(79104, 3323396096, 3323402751, 'US', 'USA', 'الولايات المتحدة'),
(79105, 3323404288, 3323408383, 'US', 'USA', 'الولايات المتحدة'),
(79106, 3323461632, 3323464191, 'US', 'USA', 'الولايات المتحدة'),
(79107, 3323465728, 3323469823, 'US', 'USA', 'الولايات المتحدة'),
(79108, 3323527168, 3323658239, 'US', 'USA', 'الولايات المتحدة'),
(79109, 3323658496, 3323659263, 'US', 'USA', 'الولايات المتحدة'),
(79110, 3323659264, 3323660543, 'NZ', 'NZL', 'نيوزيلاندا'),
(79111, 3323662336, 3323665407, 'US', 'USA', 'الولايات المتحدة'),
(79112, 3323666432, 3323672831, 'US', 'USA', 'الولايات المتحدة'),
(79113, 3323723776, 3323727103, 'US', 'USA', 'الولايات المتحدة'),
(79114, 3323727872, 3323730943, 'US', 'USA', 'الولايات المتحدة'),
(79115, 3323731968, 3323791103, 'US', 'USA', 'الولايات المتحدة'),
(79116, 3323791360, 3323797503, 'US', 'USA', 'الولايات المتحدة'),
(79117, 3323805696, 3323806207, 'CA', 'CAN', 'كندا'),
(79118, 3323806208, 3323854335, 'US', 'USA', 'الولايات المتحدة'),
(79119, 3323854848, 3324051455, 'US', 'USA', 'الولايات المتحدة'),
(79120, 3324051456, 3324182527, 'CA', 'CAN', 'كندا'),
(79121, 3324182528, 3324189183, 'US', 'USA', 'الولايات المتحدة'),
(79122, 3324190720, 3324193279, 'US', 'USA', 'الولايات المتحدة'),
(79123, 3324198912, 3324211711, 'US', 'USA', 'الولايات المتحدة'),
(79124, 3324215296, 3324251135, 'US', 'USA', 'الولايات المتحدة'),
(79125, 3324252160, 3324255231, 'US', 'USA', 'الولايات المتحدة'),
(79126, 3324256256, 3324259327, 'SA', 'SAU', 'السعودية'),
(79127, 3324259328, 3324259583, 'US', 'USA', 'الولايات المتحدة'),
(79128, 3324259584, 3324259839, 'SA', 'SAU', 'السعودية'),
(79129, 3324259840, 3324260095, 'US', 'USA', 'الولايات المتحدة'),
(79130, 3324264448, 3324277247, 'US', 'USA', 'الولايات المتحدة'),
(79131, 3324280832, 3324315391, 'US', 'USA', 'الولايات المتحدة'),
(79132, 3324315648, 3324320767, 'US', 'USA', 'الولايات المتحدة'),
(79133, 3324321792, 3324325631, 'US', 'USA', 'الولايات المتحدة'),
(79134, 3324329984, 3324337663, 'US', 'USA', 'الولايات المتحدة'),
(79135, 3324346368, 3324347647, 'US', 'USA', 'الولايات المتحدة'),
(79136, 3324379136, 3324380159, 'CA', 'CAN', 'كندا'),
(79137, 3324380160, 3324380927, 'US', 'USA', 'الولايات المتحدة'),
(79138, 3324381184, 3324382463, 'US', 'USA', 'الولايات المتحدة'),
(79139, 3324383232, 3324391423, 'US', 'USA', 'الولايات المتحدة'),
(79140, 3324395520, 3324398079, 'US', 'USA', 'الولايات المتحدة'),
(79141, 3324411904, 3324521471, 'US', 'USA', 'الولايات المتحدة'),
(79142, 3324526592, 3324567551, 'US', 'USA', 'الولايات المتحدة'),
(79143, 3324575744, 3324579327, 'US', 'USA', 'الولايات المتحدة'),
(79144, 3324579840, 3324582911, 'NZ', 'NZL', 'نيوزيلاندا'),
(79145, 3324583936, 3324587775, 'CL', 'CHL', 'تشيلي'),
(79146, 3324592128, 3324596223, 'US', 'USA', 'الولايات المتحدة'),
(79147, 3324641280, 3324772351, 'US', 'USA', 'الولايات المتحدة'),
(79148, 3324837888, 3324840959, 'US', 'USA', 'الولايات المتحدة'),
(79149, 3324841984, 3324850175, 'US', 'USA', 'الولايات المتحدة'),
(79150, 3324854272, 3324867071, 'US', 'USA', 'الولايات المتحدة'),
(79151, 3324903424, 3324905983, 'US', 'USA', 'الولايات المتحدة'),
(79152, 3324911616, 3324915711, 'US', 'USA', 'الولايات المتحدة'),
(79153, 3324919808, 3324923903, 'US', 'USA', 'الولايات المتحدة'),
(79154, 3324968960, 3324972287, 'US', 'USA', 'الولايات المتحدة'),
(79155, 3324973056, 3324976895, 'US', 'USA', 'الولايات المتحدة'),
(79156, 3324977152, 3324979967, 'US', 'USA', 'الولايات المتحدة'),
(79157, 3324985344, 3324991743, 'US', 'USA', 'الولايات المتحدة'),
(79158, 3325034496, 3325035519, 'NZ', 'NZL', 'نيوزيلاندا'),
(79159, 3325035520, 3325045759, 'US', 'USA', 'الولايات المتحدة'),
(79160, 3325050880, 3325059071, 'US', 'USA', 'الولايات المتحدة'),
(79161, 3325100288, 3325100543, 'US', 'USA', 'الولايات المتحدة'),
(79162, 3325100544, 3325100799, 'HK', 'HKG', 'هونغ كونغ');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(79163, 3325100800, 3325101055, 'NZ', 'NZL', 'نيوزيلاندا'),
(79164, 3325101312, 3325102335, 'US', 'USA', 'الولايات المتحدة'),
(79165, 3325102592, 3325105919, 'US', 'USA', 'الولايات المتحدة'),
(79166, 3325106176, 3325108223, 'US', 'USA', 'الولايات المتحدة'),
(79167, 3325108224, 3325110271, 'AU', 'AUS', 'أستراليا'),
(79168, 3325110272, 3325111807, 'US', 'USA', 'الولايات المتحدة'),
(79169, 3325120768, 3325122047, 'US', 'USA', 'الولايات المتحدة'),
(79170, 3325122304, 3325122559, 'AU', 'AUS', 'أستراليا'),
(79171, 3325123328, 3325124351, 'US', 'USA', 'الولايات المتحدة'),
(79172, 3325124608, 3325125375, 'US', 'USA', 'الولايات المتحدة'),
(79173, 3325125888, 3325126143, 'US', 'USA', 'الولايات المتحدة'),
(79174, 3325126400, 3325128703, 'US', 'USA', 'الولايات المتحدة'),
(79175, 3325128704, 3325129215, 'TH', 'THA', 'تايلند'),
(79176, 3325129216, 3325131775, 'US', 'USA', 'الولايات المتحدة'),
(79177, 3325131776, 3325132031, 'AU', 'AUS', 'أستراليا'),
(79178, 3325132032, 3325132799, 'US', 'USA', 'الولايات المتحدة'),
(79179, 3325132800, 3325134335, 'BR', 'BRA', 'البرازيل'),
(79180, 3325134336, 3325134591, 'US', 'USA', 'الولايات المتحدة'),
(79181, 3325134848, 3325135359, 'US', 'USA', 'الولايات المتحدة'),
(79182, 3325136128, 3325136383, 'CA', 'CAN', 'كندا'),
(79183, 3325136384, 3325136639, 'US', 'USA', 'الولايات المتحدة'),
(79184, 3325136896, 3325137919, 'US', 'USA', 'الولايات المتحدة'),
(79185, 3325138176, 3325141503, 'US', 'USA', 'الولايات المتحدة'),
(79186, 3325141760, 3325142015, 'US', 'USA', 'الولايات المتحدة'),
(79187, 3325142016, 3325142271, 'AR', 'ARG', 'الأرجنتين'),
(79188, 3325142272, 3325144831, 'US', 'USA', 'الولايات المتحدة'),
(79189, 3325144832, 3325145087, 'CA', 'CAN', 'كندا'),
(79190, 3325145088, 3325145599, 'US', 'USA', 'الولايات المتحدة'),
(79191, 3325145856, 3325151231, 'US', 'USA', 'الولايات المتحدة'),
(79192, 3325151488, 3325162239, 'US', 'USA', 'الولايات المتحدة'),
(79193, 3325162496, 3325165311, 'US', 'USA', 'الولايات المتحدة'),
(79194, 3325165568, 3325169663, 'US', 'USA', 'الولايات المتحدة'),
(79195, 3325169664, 3325171711, 'BR', 'BRA', 'البرازيل'),
(79196, 3325173760, 3325190143, 'US', 'USA', 'الولايات المتحدة'),
(79197, 3325231360, 3325232127, 'US', 'USA', 'الولايات المتحدة'),
(79198, 3325232128, 3325233151, 'AU', 'AUS', 'أستراليا'),
(79199, 3325233408, 3325234175, 'US', 'USA', 'الولايات المتحدة'),
(79200, 3325234176, 3325234431, 'SA', 'SAU', 'السعودية'),
(79201, 3325234432, 3325242367, 'US', 'USA', 'الولايات المتحدة'),
(79202, 3325242880, 3325247231, 'US', 'USA', 'الولايات المتحدة'),
(79203, 3325247488, 3325249279, 'US', 'USA', 'الولايات المتحدة'),
(79204, 3325249280, 3325249535, 'CO', 'COL', 'كولومبيا'),
(79205, 3325249536, 3325250303, 'US', 'USA', 'الولايات المتحدة'),
(79206, 3325250816, 3325253631, 'US', 'USA', 'الولايات المتحدة'),
(79207, 3325253888, 3325256447, 'US', 'USA', 'الولايات المتحدة'),
(79208, 3325256448, 3325256703, 'HK', 'HKG', 'هونغ كونغ'),
(79209, 3325256704, 3325256959, 'US', 'USA', 'الولايات المتحدة'),
(79210, 3325256960, 3325257215, 'ID', 'IDN', 'إندونيسيا'),
(79211, 3325257216, 3325257727, 'US', 'USA', 'الولايات المتحدة'),
(79212, 3325258752, 3325259775, 'US', 'USA', 'الولايات المتحدة'),
(79213, 3325259776, 3325261311, 'CA', 'CAN', 'كندا'),
(79214, 3325261312, 3325264639, 'US', 'USA', 'الولايات المتحدة'),
(79215, 3325267200, 3325267711, 'US', 'USA', 'الولايات المتحدة'),
(79216, 3325267712, 3325268735, 'SY', 'SYR', 'سوريا'),
(79217, 3325268736, 3325269759, 'US', 'USA', 'الولايات المتحدة'),
(79218, 3325269760, 3325270015, 'CA', 'CAN', 'كندا'),
(79219, 3325270272, 3325271039, 'US', 'USA', 'الولايات المتحدة'),
(79220, 3325271040, 3325271295, 'CA', 'CAN', 'كندا'),
(79221, 3325271296, 3325271551, 'US', 'USA', 'الولايات المتحدة'),
(79222, 3325271808, 3325272575, 'US', 'USA', 'الولايات المتحدة'),
(79223, 3325272832, 3325274111, 'US', 'USA', 'الولايات المتحدة'),
(79224, 3325274624, 3325278719, 'US', 'USA', 'الولايات المتحدة'),
(79225, 3325278720, 3325278975, 'AU', 'AUS', 'أستراليا'),
(79226, 3325278976, 3325281023, 'US', 'USA', 'الولايات المتحدة'),
(79227, 3325281024, 3325281279, 'NZ', 'NZL', 'نيوزيلاندا'),
(79228, 3325281280, 3325281535, 'AU', 'AUS', 'أستراليا'),
(79229, 3325281536, 3325284863, 'US', 'USA', 'الولايات المتحدة'),
(79230, 3325284864, 3325285375, 'AU', 'AUS', 'أستراليا'),
(79231, 3325285632, 3325292543, 'US', 'USA', 'الولايات المتحدة'),
(79232, 3325292800, 3325296383, 'US', 'USA', 'الولايات المتحدة'),
(79233, 3325296640, 3325298687, 'US', 'USA', 'الولايات المتحدة'),
(79234, 3325300736, 3325303295, 'US', 'USA', 'الولايات المتحدة'),
(79235, 3325304832, 3325307647, 'CA', 'CAN', 'كندا'),
(79236, 3325307648, 3325307903, 'BB', 'BRB', 'باربادوس'),
(79237, 3325307904, 3325308927, 'CA', 'CAN', 'كندا'),
(79238, 3325313024, 3325319423, 'US', 'USA', 'الولايات المتحدة'),
(79239, 3325362176, 3325427711, 'CA', 'CAN', 'كندا'),
(79240, 3325493248, 3325497343, 'US', 'USA', 'الولايات المتحدة'),
(79241, 3325497344, 3325499903, 'PR', 'PRI', 'بورتو ريكو'),
(79242, 3325501440, 3325503999, 'US', 'USA', 'الولايات المتحدة'),
(79243, 3325509632, 3325517311, 'US', 'USA', 'الولايات المتحدة'),
(79244, 3325526016, 3325551615, 'US', 'USA', 'الولايات المتحدة'),
(79245, 3325558784, 3325562879, 'US', 'USA', 'الولايات المتحدة'),
(79246, 3325562880, 3325565439, 'PH', 'PHL', 'الفلبين'),
(79247, 3325566976, 3325572095, 'US', 'USA', 'الولايات المتحدة'),
(79248, 3325575168, 3325591551, 'US', 'USA', 'الولايات المتحدة'),
(79249, 3325626368, 3325630975, 'US', 'USA', 'الولايات المتحدة'),
(79250, 3325632512, 3325635583, 'US', 'USA', 'الولايات المتحدة'),
(79251, 3325640704, 3325644799, 'CA', 'CAN', 'كندا'),
(79252, 3325689856, 3325690367, 'JM', 'JAM', 'جامايكا'),
(79253, 3325690368, 3325691647, 'US', 'USA', 'الولايات المتحدة'),
(79254, 3325691904, 3325693183, 'BR', 'BRA', 'البرازيل'),
(79255, 3325693952, 3325697023, 'US', 'USA', 'الولايات المتحدة'),
(79256, 3325698048, 3325699839, 'US', 'USA', 'الولايات المتحدة'),
(79257, 3325706240, 3325708287, 'US', 'USA', 'الولايات المتحدة'),
(79258, 3325755392, 3325886463, 'US', 'USA', 'الولايات المتحدة'),
(79259, 3325886720, 3325887487, 'NZ', 'NZL', 'نيوزيلاندا'),
(79260, 3325887488, 3325888255, 'US', 'USA', 'الولايات المتحدة'),
(79261, 3325888512, 3325890559, 'AU', 'AUS', 'أستراليا'),
(79262, 3325890560, 3325901055, 'US', 'USA', 'الولايات المتحدة'),
(79263, 3325902848, 3325911039, 'US', 'USA', 'الولايات المتحدة'),
(79264, 3325952000, 3325956095, 'US', 'USA', 'الولايات المتحدة'),
(79265, 3325956096, 3325960191, 'CA', 'CAN', 'كندا'),
(79266, 3325960192, 3325967871, 'US', 'USA', 'الولايات المتحدة'),
(79267, 3325968384, 3325976063, 'US', 'USA', 'الولايات المتحدة'),
(79268, 3325976064, 3325976319, 'CA', 'CAN', 'كندا'),
(79269, 3325976320, 3325979903, 'US', 'USA', 'الولايات المتحدة'),
(79270, 3325980160, 3325980671, 'US', 'USA', 'الولايات المتحدة'),
(79271, 3325980672, 3325980927, 'CA', 'CAN', 'كندا'),
(79272, 3325980928, 3325982719, 'US', 'USA', 'الولايات المتحدة'),
(79273, 3325983488, 3325986815, 'US', 'USA', 'الولايات المتحدة'),
(79274, 3325987072, 3325992447, 'US', 'USA', 'الولايات المتحدة'),
(79275, 3325992448, 3325992959, 'CA', 'CAN', 'كندا'),
(79276, 3325992960, 3325993215, 'US', 'USA', 'الولايات المتحدة'),
(79277, 3325993472, 3325993727, 'US', 'USA', 'الولايات المتحدة'),
(79278, 3325994240, 3325996799, 'US', 'USA', 'الولايات المتحدة'),
(79279, 3325996800, 3325997055, 'CA', 'CAN', 'كندا'),
(79280, 3325997056, 3326003455, 'US', 'USA', 'الولايات المتحدة'),
(79281, 3326004224, 3326004991, 'US', 'USA', 'الولايات المتحدة'),
(79282, 3326005248, 3326010623, 'US', 'USA', 'الولايات المتحدة'),
(79283, 3326010880, 3326017279, 'US', 'USA', 'الولايات المتحدة'),
(79284, 3326017536, 3326349823, 'US', 'USA', 'الولايات المتحدة'),
(79285, 3326349824, 3326350335, 'EC', 'ECU', 'الإكوادور'),
(79286, 3326350336, 3326390527, 'US', 'USA', 'الولايات المتحدة'),
(79287, 3326390528, 3326390535, 'CA', 'CAN', 'كندا'),
(79288, 3326390536, 3326492239, 'US', 'USA', 'الولايات المتحدة'),
(79289, 3326492240, 3326492255, 'CA', 'CAN', 'كندا'),
(79290, 3326492256, 3326543359, 'US', 'USA', 'الولايات المتحدة'),
(79291, 3326543872, 3326548991, 'US', 'USA', 'الولايات المتحدة'),
(79292, 3326550016, 3326553087, 'US', 'USA', 'الولايات المتحدة'),
(79293, 3326558208, 3326561279, 'US', 'USA', 'الولايات المتحدة'),
(79294, 3326607360, 3326608895, 'US', 'USA', 'الولايات المتحدة'),
(79295, 3326609408, 3326610687, 'US', 'USA', 'الولايات المتحدة'),
(79296, 3326611456, 3326613503, 'US', 'USA', 'الولايات المتحدة'),
(79297, 3326615552, 3326618111, 'US', 'USA', 'الولايات المتحدة'),
(79298, 3326623744, 3326627327, 'US', 'USA', 'الولايات المتحدة'),
(79299, 3326680832, 3326681087, 'CA', 'CAN', 'كندا'),
(79300, 3326681344, 3326682623, 'CA', 'CAN', 'كندا'),
(79301, 3326682624, 3326682879, 'US', 'USA', 'الولايات المتحدة'),
(79302, 3326682880, 3326697215, 'CA', 'CAN', 'كندا'),
(79303, 3326699776, 3326713343, 'CA', 'CAN', 'كندا'),
(79304, 3326713344, 3326714111, 'US', 'USA', 'الولايات المتحدة'),
(79305, 3326714112, 3326716927, 'CA', 'CAN', 'كندا'),
(79306, 3326716928, 3326717951, 'US', 'USA', 'الولايات المتحدة'),
(79307, 3326717952, 3326726399, 'CA', 'CAN', 'كندا'),
(79308, 3326726912, 3326728703, 'CA', 'CAN', 'كندا'),
(79309, 3326728960, 3326729215, 'CA', 'CAN', 'كندا'),
(79310, 3326729216, 3326729471, 'JP', 'JPN', 'اليابان'),
(79311, 3326729472, 3326729727, 'CA', 'CAN', 'كندا'),
(79312, 3326729728, 3326730495, 'US', 'USA', 'الولايات المتحدة'),
(79313, 3326731264, 3326734335, 'US', 'USA', 'الولايات المتحدة'),
(79314, 3326734336, 3326737663, 'CA', 'CAN', 'كندا'),
(79315, 3326737664, 3326737919, 'US', 'USA', 'الولايات المتحدة'),
(79316, 3326737920, 3326738175, 'CA', 'CAN', 'كندا'),
(79317, 3326738432, 3326739455, 'US', 'USA', 'الولايات المتحدة'),
(79318, 3326740480, 3326745599, 'US', 'USA', 'الولايات المتحدة'),
(79319, 3326754816, 3326757375, 'US', 'USA', 'الولايات المتحدة'),
(79320, 3326771200, 3326796799, 'US', 'USA', 'الولايات المتحدة'),
(79321, 3326803968, 3327397119, 'US', 'USA', 'الولايات المتحدة'),
(79322, 3327397888, 3327408127, 'US', 'USA', 'الولايات المتحدة'),
(79323, 3327459328, 3327723263, 'US', 'USA', 'الولايات المتحدة'),
(79324, 3327723520, 3327725311, 'CA', 'CAN', 'كندا'),
(79325, 3327725568, 3327728127, 'US', 'USA', 'الولايات المتحدة'),
(79326, 3327729664, 3327732735, 'US', 'USA', 'الولايات المتحدة'),
(79327, 3327737856, 3327743231, 'US', 'USA', 'الولايات المتحدة'),
(79328, 3327754240, 3327769087, 'US', 'USA', 'الولايات المتحدة'),
(79329, 3327770368, 3327779839, 'US', 'USA', 'الولايات المتحدة'),
(79330, 3327787008, 3327788287, 'US', 'USA', 'الولايات المتحدة'),
(79331, 3327789056, 3327790591, 'US', 'USA', 'الولايات المتحدة'),
(79332, 3327791104, 3327792127, 'US', 'USA', 'الولايات المتحدة'),
(79333, 3327795200, 3327805695, 'US', 'USA', 'الولايات المتحدة'),
(79334, 3327819776, 3327856127, 'US', 'USA', 'الولايات المتحدة'),
(79335, 3327856640, 3327857919, 'US', 'USA', 'الولايات المتحدة'),
(79336, 3327860736, 3327863295, 'US', 'USA', 'الولايات المتحدة'),
(79337, 3327868928, 3327871487, 'US', 'USA', 'الولايات المتحدة'),
(79338, 3327918080, 3328028671, 'US', 'USA', 'الولايات المتحدة'),
(79339, 3328028672, 3328030719, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(79340, 3328030720, 3328180223, 'US', 'USA', 'الولايات المتحدة'),
(79341, 3328180480, 3328181247, 'CA', 'CAN', 'كندا'),
(79342, 3328181760, 3328185855, 'CA', 'CAN', 'كندا'),
(79343, 3328186112, 3328187647, 'CA', 'CAN', 'كندا'),
(79344, 3328187904, 3328196351, 'CA', 'CAN', 'كندا'),
(79345, 3328196608, 3328202751, 'CA', 'CAN', 'كندا'),
(79346, 3328204800, 3328210175, 'CA', 'CAN', 'كندا'),
(79347, 3328210176, 3328210943, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(79348, 3328210944, 3328214783, 'CA', 'CAN', 'كندا'),
(79349, 3328214784, 3328215295, 'GB', 'GBR', 'المملكة المتحدة'),
(79350, 3328215296, 3328233983, 'CA', 'CAN', 'كندا'),
(79351, 3328233984, 3328234239, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(79352, 3328234240, 3328235007, 'CA', 'CAN', 'كندا'),
(79353, 3328235008, 3328235263, 'US', 'USA', 'الولايات المتحدة'),
(79354, 3328235520, 3328236799, 'CA', 'CAN', 'كندا'),
(79355, 3328237312, 3328241663, 'CA', 'CAN', 'كندا'),
(79356, 3328241664, 3328243199, 'US', 'USA', 'الولايات المتحدة'),
(79357, 3328243200, 3328245759, 'CA', 'CAN', 'كندا'),
(79358, 3328245760, 3328249087, 'US', 'USA', 'الولايات المتحدة'),
(79359, 3328249856, 3328253439, 'US', 'USA', 'الولايات المتحدة'),
(79360, 3328253952, 3328259071, 'US', 'USA', 'الولايات المتحدة'),
(79361, 3328259584, 3328265471, 'US', 'USA', 'الولايات المتحدة'),
(79362, 3328265728, 3328271871, 'US', 'USA', 'الولايات المتحدة'),
(79363, 3328272128, 3328297215, 'US', 'USA', 'الولايات المتحدة'),
(79364, 3328298240, 3328298495, 'US', 'USA', 'الولايات المتحدة'),
(79365, 3328298752, 3328299775, 'US', 'USA', 'الولايات المتحدة'),
(79366, 3328303872, 3328304127, 'US', 'USA', 'الولايات المتحدة'),
(79367, 3328305664, 3328306431, 'US', 'USA', 'الولايات المتحدة'),
(79368, 3328307200, 3328307455, 'US', 'USA', 'الولايات المتحدة'),
(79369, 3328307968, 3328309247, 'US', 'USA', 'الولايات المتحدة'),
(79370, 3328309504, 3328311039, 'US', 'USA', 'الولايات المتحدة'),
(79371, 3328311296, 3328313087, 'US', 'USA', 'الولايات المتحدة'),
(79372, 3328313344, 3328314623, 'US', 'USA', 'الولايات المتحدة'),
(79373, 3328315392, 3328316927, 'US', 'USA', 'الولايات المتحدة'),
(79374, 3328319488, 3328323583, 'US', 'USA', 'الولايات المتحدة'),
(79375, 3328327680, 3328332799, 'US', 'USA', 'الولايات المتحدة'),
(79376, 3328344064, 3328356863, 'US', 'USA', 'الولايات المتحدة'),
(79377, 3328376832, 3328383487, 'US', 'USA', 'الولايات المتحدة'),
(79378, 3328385024, 3328412159, 'US', 'USA', 'الولايات المتحدة'),
(79379, 3328412416, 3328412927, 'US', 'USA', 'الولايات المتحدة'),
(79380, 3328413184, 3328414719, 'US', 'USA', 'الولايات المتحدة'),
(79381, 3328414720, 3328414975, 'CH', 'CHE', 'سويسرا'),
(79382, 3328414976, 3328417279, 'US', 'USA', 'الولايات المتحدة'),
(79383, 3328417792, 3328420351, 'US', 'USA', 'الولايات المتحدة'),
(79384, 3328420352, 3328420607, 'CA', 'CAN', 'كندا'),
(79385, 3328420608, 3328421119, 'US', 'USA', 'الولايات المتحدة'),
(79386, 3328421120, 3328421375, 'HK', 'HKG', 'هونغ كونغ'),
(79387, 3328421376, 3328427007, 'US', 'USA', 'الولايات المتحدة'),
(79388, 3328427264, 3328432639, 'US', 'USA', 'الولايات المتحدة'),
(79389, 3328432640, 3328433663, 'CA', 'CAN', 'كندا'),
(79390, 3328433664, 3328433919, 'CH', 'CHE', 'سويسرا'),
(79391, 3328433920, 3328442111, 'US', 'USA', 'الولايات المتحدة'),
(79392, 3328442368, 3328447999, 'US', 'USA', 'الولايات المتحدة'),
(79393, 3328450560, 3328453119, 'US', 'USA', 'الولايات المتحدة'),
(79394, 3328458752, 3328466431, 'US', 'USA', 'الولايات المتحدة'),
(79395, 3328475136, 3328477183, 'CA', 'CAN', 'كندا'),
(79396, 3328507904, 3328509695, 'US', 'USA', 'الولايات المتحدة'),
(79397, 3328512000, 3328514559, 'US', 'USA', 'الولايات المتحدة'),
(79398, 3328516096, 3328520191, 'US', 'USA', 'الولايات المتحدة'),
(79399, 3328573440, 3328574463, 'US', 'USA', 'الولايات المتحدة'),
(79400, 3328574720, 3328575487, 'US', 'USA', 'الولايات المتحدة'),
(79401, 3328577536, 3328580607, 'US', 'USA', 'الولايات المتحدة'),
(79402, 3328581632, 3328591359, 'US', 'USA', 'الولايات المتحدة'),
(79403, 3328591872, 3328592895, 'US', 'USA', 'الولايات المتحدة'),
(79404, 3328594688, 3328617983, 'US', 'USA', 'الولايات المتحدة'),
(79405, 3328617984, 3328618239, 'CA', 'CAN', 'كندا'),
(79406, 3328618240, 3328630015, 'US', 'USA', 'الولايات المتحدة'),
(79407, 3328630272, 3328630783, 'US', 'USA', 'الولايات المتحدة'),
(79408, 3328630784, 3328631807, 'CA', 'CAN', 'كندا'),
(79409, 3328631808, 3328636671, 'US', 'USA', 'الولايات المتحدة'),
(79410, 3328636928, 3328638719, 'US', 'USA', 'الولايات المتحدة'),
(79411, 3328638976, 3328704511, 'CA', 'CAN', 'كندا'),
(79412, 3328704512, 3328771839, 'US', 'USA', 'الولايات المتحدة'),
(79413, 3328772096, 3328773375, 'US', 'USA', 'الولايات المتحدة'),
(79414, 3328774144, 3328776703, 'US', 'USA', 'الولايات المتحدة'),
(79415, 3328778240, 3328782335, 'US', 'USA', 'الولايات المتحدة'),
(79416, 3328786432, 3328790527, 'US', 'USA', 'الولايات المتحدة'),
(79417, 3328802816, 3328810495, 'US', 'USA', 'الولايات المتحدة'),
(79418, 3328819200, 3328821247, 'US', 'USA', 'الولايات المتحدة'),
(79419, 3328829440, 3328830463, 'US', 'USA', 'الولايات المتحدة'),
(79420, 3328835584, 3330607103, 'US', 'USA', 'الولايات المتحدة'),
(79421, 3330609152, 3330614271, 'US', 'USA', 'الولايات المتحدة'),
(79422, 3330614272, 3330614527, 'CA', 'CAN', 'كندا'),
(79423, 3330614528, 3330621439, 'US', 'USA', 'الولايات المتحدة'),
(79424, 3330621440, 3330623743, 'CA', 'CAN', 'كندا'),
(79425, 3330623744, 3330624255, 'US', 'USA', 'الولايات المتحدة'),
(79426, 3330624512, 3330625535, 'US', 'USA', 'الولايات المتحدة'),
(79427, 3330625536, 3330627071, 'GB', 'GBR', 'المملكة المتحدة'),
(79428, 3330627072, 3330637823, 'US', 'USA', 'الولايات المتحدة'),
(79429, 3330638080, 3330640895, 'US', 'USA', 'الولايات المتحدة'),
(79430, 3330640896, 3330641151, 'CH', 'CHE', 'سويسرا'),
(79431, 3330641152, 3330641663, 'US', 'USA', 'الولايات المتحدة'),
(79432, 3330641920, 3330645247, 'US', 'USA', 'الولايات المتحدة'),
(79433, 3330645504, 3330646527, 'US', 'USA', 'الولايات المتحدة'),
(79434, 3330646528, 3330647295, 'CA', 'CAN', 'كندا'),
(79435, 3330647296, 3330647807, 'US', 'USA', 'الولايات المتحدة'),
(79436, 3330648064, 3330648831, 'US', 'USA', 'الولايات المتحدة'),
(79437, 3330649088, 3330649343, 'US', 'USA', 'الولايات المتحدة'),
(79438, 3330649600, 3330649855, 'CA', 'CAN', 'كندا'),
(79439, 3330649856, 3330657791, 'US', 'USA', 'الولايات المتحدة'),
(79440, 3330657792, 3330658047, 'JP', 'JPN', 'اليابان'),
(79441, 3330658048, 3330662911, 'US', 'USA', 'الولايات المتحدة'),
(79442, 3330662912, 3330663167, 'GB', 'GBR', 'المملكة المتحدة'),
(79443, 3330663168, 3330664191, 'US', 'USA', 'الولايات المتحدة'),
(79444, 3330664192, 3330664447, 'CA', 'CAN', 'كندا'),
(79445, 3330664448, 3330665983, 'US', 'USA', 'الولايات المتحدة'),
(79446, 3330666240, 3330668543, 'US', 'USA', 'الولايات المتحدة'),
(79447, 3330668800, 3330670335, 'US', 'USA', 'الولايات المتحدة'),
(79448, 3330670592, 3330671871, 'US', 'USA', 'الولايات المتحدة'),
(79449, 3330672640, 3330674175, 'US', 'USA', 'الولايات المتحدة'),
(79450, 3330674688, 3330677759, 'US', 'USA', 'الولايات المتحدة'),
(79451, 3330678784, 3330697215, 'US', 'USA', 'الولايات المتحدة'),
(79452, 3330703360, 3330714367, 'US', 'USA', 'الولايات المتحدة'),
(79453, 3330714368, 3330714623, 'CA', 'CAN', 'كندا'),
(79454, 3330714624, 3330723839, 'US', 'USA', 'الولايات المتحدة'),
(79455, 3330724096, 3330726655, 'US', 'USA', 'الولايات المتحدة'),
(79456, 3330726656, 3330726911, 'CA', 'CAN', 'كندا'),
(79457, 3330726912, 3330735871, 'US', 'USA', 'الولايات المتحدة'),
(79458, 3330736128, 3330743295, 'US', 'USA', 'الولايات المتحدة'),
(79459, 3330744320, 3330748159, 'US', 'USA', 'الولايات المتحدة'),
(79460, 3330752512, 3330754559, 'US', 'USA', 'الولايات المتحدة'),
(79461, 3330754560, 3330754815, 'CA', 'CAN', 'كندا'),
(79462, 3330754816, 3330755071, 'US', 'USA', 'الولايات المتحدة'),
(79463, 3330755328, 3330756607, 'US', 'USA', 'الولايات المتحدة'),
(79464, 3330756864, 3330763519, 'US', 'USA', 'الولايات المتحدة'),
(79465, 3330763520, 3330763775, 'CA', 'CAN', 'كندا'),
(79466, 3330763776, 3330765823, 'US', 'USA', 'الولايات المتحدة'),
(79467, 3330765824, 3330766335, 'CA', 'CAN', 'كندا'),
(79468, 3330766336, 3330767871, 'US', 'USA', 'الولايات المتحدة'),
(79469, 3330768640, 3330769151, 'US', 'USA', 'الولايات المتحدة'),
(79470, 3330769408, 3330771199, 'US', 'USA', 'الولايات المتحدة'),
(79471, 3330771200, 3330771711, 'CH', 'CHE', 'سويسرا'),
(79472, 3330771712, 3330778879, 'US', 'USA', 'الولايات المتحدة'),
(79473, 3330778880, 3330779135, 'GB', 'GBR', 'المملكة المتحدة'),
(79474, 3330779136, 3330784255, 'US', 'USA', 'الولايات المتحدة'),
(79475, 3330785792, 3330791423, 'US', 'USA', 'الولايات المتحدة'),
(79476, 3330791424, 3330791679, 'CA', 'CAN', 'كندا'),
(79477, 3330791680, 3330795775, 'US', 'USA', 'الولايات المتحدة'),
(79478, 3330796032, 3330796543, 'US', 'USA', 'الولايات المتحدة'),
(79479, 3330796800, 3330798847, 'US', 'USA', 'الولايات المتحدة'),
(79480, 3330799104, 3330799871, 'US', 'USA', 'الولايات المتحدة'),
(79481, 3330800128, 3330801407, 'US', 'USA', 'الولايات المتحدة'),
(79482, 3330801664, 3330807807, 'US', 'USA', 'الولايات المتحدة'),
(79483, 3330809856, 3330812415, 'US', 'USA', 'الولايات المتحدة'),
(79484, 3330818048, 3330841599, 'US', 'USA', 'الولايات المتحدة'),
(79485, 3330841856, 3330844159, 'US', 'USA', 'الولايات المتحدة'),
(79486, 3330844416, 3330848767, 'US', 'USA', 'الولايات المتحدة'),
(79487, 3330849024, 3330862591, 'US', 'USA', 'الولايات المتحدة'),
(79488, 3330862848, 3330866943, 'US', 'USA', 'الولايات المتحدة'),
(79489, 3330867200, 3330904575, 'US', 'USA', 'الولايات المتحدة'),
(79490, 3330904832, 3330906623, 'US', 'USA', 'الولايات المتحدة'),
(79491, 3330906880, 3330908415, 'US', 'USA', 'الولايات المتحدة'),
(79492, 3330908672, 3330918655, 'US', 'USA', 'الولايات المتحدة'),
(79493, 3330918912, 3330923263, 'US', 'USA', 'الولايات المتحدة'),
(79494, 3330923520, 3330928127, 'US', 'USA', 'الولايات المتحدة'),
(79495, 3330928384, 3330930175, 'US', 'USA', 'الولايات المتحدة'),
(79496, 3330930944, 3330932479, 'US', 'USA', 'الولايات المتحدة'),
(79497, 3330932736, 3331065343, 'US', 'USA', 'الولايات المتحدة'),
(79498, 3331065856, 3331070463, 'US', 'USA', 'الولايات المتحدة'),
(79499, 3331072000, 3331092991, 'US', 'USA', 'الولايات المتحدة'),
(79500, 3331096576, 3331098111, 'US', 'USA', 'الولايات المتحدة'),
(79501, 3331098368, 3331102463, 'US', 'USA', 'الولايات المتحدة'),
(79502, 3331102464, 3331102719, 'CA', 'CAN', 'كندا'),
(79503, 3331102720, 3331103231, 'US', 'USA', 'الولايات المتحدة'),
(79504, 3331104000, 3331110143, 'US', 'USA', 'الولايات المتحدة'),
(79505, 3331110656, 3331117567, 'US', 'USA', 'الولايات المتحدة'),
(79506, 3331117824, 3331125759, 'US', 'USA', 'الولايات المتحدة'),
(79507, 3331126016, 3331129087, 'US', 'USA', 'الولايات المتحدة'),
(79508, 3331129344, 3331194879, 'US', 'USA', 'الولايات المتحدة'),
(79509, 3331194880, 3331260415, 'AU', 'AUS', 'أستراليا'),
(79510, 3331260416, 3331268607, 'US', 'USA', 'الولايات المتحدة'),
(79511, 3331276800, 3331284991, 'US', 'USA', 'الولايات المتحدة'),
(79512, 3331293184, 3331301375, 'US', 'USA', 'الولايات المتحدة'),
(79513, 3331309568, 3331330047, 'US', 'USA', 'الولايات المتحدة'),
(79514, 3331334144, 3331338239, 'US', 'USA', 'الولايات المتحدة'),
(79515, 3331342336, 3331350527, 'US', 'USA', 'الولايات المتحدة'),
(79516, 3331358720, 3331362815, 'US', 'USA', 'الولايات المتحدة'),
(79517, 3331366912, 3331371007, 'US', 'USA', 'الولايات المتحدة'),
(79518, 3331375104, 3331387391, 'US', 'USA', 'الولايات المتحدة'),
(79519, 3331391488, 3331527679, 'US', 'USA', 'الولايات المتحدة'),
(79520, 3331530752, 3331557375, 'US', 'USA', 'الولايات المتحدة'),
(79521, 3331557632, 3331562495, 'US', 'USA', 'الولايات المتحدة'),
(79522, 3331562752, 3331563519, 'US', 'USA', 'الولايات المتحدة'),
(79523, 3331563520, 3331563775, 'CH', 'CHE', 'سويسرا'),
(79524, 3331563776, 3331565567, 'US', 'USA', 'الولايات المتحدة'),
(79525, 3331566080, 3331567615, 'US', 'USA', 'الولايات المتحدة'),
(79526, 3331567872, 3331574271, 'US', 'USA', 'الولايات المتحدة'),
(79527, 3331574528, 3331575295, 'US', 'USA', 'الولايات المتحدة'),
(79528, 3331577344, 3331578623, 'US', 'USA', 'الولايات المتحدة'),
(79529, 3331578880, 3331585791, 'US', 'USA', 'الولايات المتحدة'),
(79530, 3331586048, 3331587839, 'US', 'USA', 'الولايات المتحدة'),
(79531, 3331588096, 3331589631, 'US', 'USA', 'الولايات المتحدة'),
(79532, 3331590144, 3331591935, 'US', 'USA', 'الولايات المتحدة'),
(79533, 3331592192, 3331594751, 'US', 'USA', 'الولايات المتحدة'),
(79534, 3331596288, 3331607807, 'US', 'USA', 'الولايات المتحدة'),
(79535, 3331620864, 3331627007, 'US', 'USA', 'الولايات المتحدة'),
(79536, 3331627520, 3331631359, 'US', 'USA', 'الولايات المتحدة'),
(79537, 3331632128, 3331632383, 'US', 'USA', 'الولايات المتحدة'),
(79538, 3331632896, 3331633407, 'US', 'USA', 'الولايات المتحدة'),
(79539, 3331633408, 3331633919, 'CH', 'CHE', 'سويسرا'),
(79540, 3331633920, 3331647231, 'US', 'USA', 'الولايات المتحدة'),
(79541, 3331647232, 3331647487, 'CA', 'CAN', 'كندا'),
(79542, 3331647488, 3331649279, 'US', 'USA', 'الولايات المتحدة'),
(79543, 3331649280, 3331649535, 'CA', 'CAN', 'كندا'),
(79544, 3331649536, 3331653375, 'US', 'USA', 'الولايات المتحدة'),
(79545, 3331653632, 3331818495, 'US', 'USA', 'الولايات المتحدة'),
(79546, 3331818496, 3331818751, 'MX', 'MEX', 'المكسيك'),
(79547, 3331818752, 3331819775, 'US', 'USA', 'الولايات المتحدة'),
(79548, 3331820032, 3331821567, 'US', 'USA', 'الولايات المتحدة'),
(79549, 3331821824, 3331825151, 'US', 'USA', 'الولايات المتحدة'),
(79550, 3331825408, 3331837183, 'US', 'USA', 'الولايات المتحدة'),
(79551, 3331837696, 3331839999, 'US', 'USA', 'الولايات المتحدة'),
(79552, 3331840256, 3331849215, 'US', 'USA', 'الولايات المتحدة'),
(79553, 3331849472, 3331849983, 'US', 'USA', 'الولايات المتحدة'),
(79554, 3331850240, 3331930623, 'US', 'USA', 'الولايات المتحدة'),
(79555, 3331932160, 3331934719, 'US', 'USA', 'الولايات المتحدة'),
(79556, 3331948544, 3331962879, 'US', 'USA', 'الولايات المتحدة'),
(79557, 3331964416, 3331968767, 'US', 'USA', 'الولايات المتحدة'),
(79558, 3331969024, 3331971839, 'US', 'USA', 'الولايات المتحدة'),
(79559, 3331972096, 3331972863, 'US', 'USA', 'الولايات المتحدة'),
(79560, 3331973120, 3331981055, 'US', 'USA', 'الولايات المتحدة'),
(79561, 3331981312, 3331983103, 'US', 'USA', 'الولايات المتحدة'),
(79562, 3331983360, 3331987967, 'US', 'USA', 'الولايات المتحدة'),
(79563, 3331989504, 3331996671, 'US', 'USA', 'الولايات المتحدة'),
(79564, 3331997696, 3332001535, 'US', 'USA', 'الولايات المتحدة'),
(79565, 3332014080, 3332026879, 'US', 'USA', 'الولايات المتحدة'),
(79566, 3332046848, 3332375807, 'US', 'USA', 'الولايات المتحدة'),
(79567, 3332376576, 3332381183, 'US', 'USA', 'الولايات المتحدة'),
(79568, 3332382720, 3332389375, 'US', 'USA', 'الولايات المتحدة'),
(79569, 3332390912, 3332418303, 'US', 'USA', 'الولايات المتحدة'),
(79570, 3332418560, 3332418815, 'US', 'USA', 'الولايات المتحدة'),
(79571, 3332419072, 3332423423, 'US', 'USA', 'الولايات المتحدة'),
(79572, 3332423680, 3332430079, 'US', 'USA', 'الولايات المتحدة'),
(79573, 3332430336, 3332435199, 'US', 'USA', 'الولايات المتحدة'),
(79574, 3332435456, 3332438015, 'US', 'USA', 'الولايات المتحدة'),
(79575, 3332438272, 3332439807, 'US', 'USA', 'الولايات المتحدة'),
(79576, 3332440320, 3332460543, 'CA', 'CAN', 'كندا'),
(79577, 3332460544, 3332460799, 'US', 'USA', 'الولايات المتحدة'),
(79578, 3332460800, 3332461311, 'CA', 'CAN', 'كندا'),
(79579, 3332461568, 3332462335, 'CA', 'CAN', 'كندا'),
(79580, 3332462592, 3332473855, 'CA', 'CAN', 'كندا'),
(79581, 3332477952, 3332482303, 'CA', 'CAN', 'كندا'),
(79582, 3332484096, 3332491263, 'CA', 'CAN', 'كندا'),
(79583, 3332492032, 3332500735, 'CA', 'CAN', 'كندا'),
(79584, 3332500992, 3332505343, 'CA', 'CAN', 'كندا'),
(79585, 3332505856, 3332508671, 'CA', 'CAN', 'كندا'),
(79586, 3332508928, 3332528127, 'CA', 'CAN', 'كندا'),
(79587, 3332529664, 3332554751, 'CA', 'CAN', 'كندا'),
(79588, 3332558848, 3332562943, 'CA', 'CAN', 'كندا'),
(79589, 3332562944, 3332563455, 'US', 'USA', 'الولايات المتحدة'),
(79590, 3332563456, 3332564479, 'CA', 'CAN', 'كندا'),
(79591, 3332564736, 3332570879, 'CA', 'CAN', 'كندا'),
(79592, 3332571392, 3332579327, 'CA', 'CAN', 'كندا'),
(79593, 3332581376, 3332590079, 'CA', 'CAN', 'كندا'),
(79594, 3332590080, 3332590591, 'US', 'USA', 'الولايات المتحدة'),
(79595, 3332590592, 3332594687, 'CA', 'CAN', 'كندا'),
(79596, 3332594944, 3332595455, 'CA', 'CAN', 'كندا'),
(79597, 3332595712, 3332610559, 'CA', 'CAN', 'كندا'),
(79598, 3332611072, 3332611327, 'CA', 'CAN', 'كندا'),
(79599, 3332611584, 3332617471, 'CA', 'CAN', 'كندا'),
(79600, 3332618240, 3332624383, 'US', 'USA', 'الولايات المتحدة'),
(79601, 3332624384, 3332625919, 'CA', 'CAN', 'كندا'),
(79602, 3332626688, 3332636415, 'CA', 'CAN', 'كندا'),
(79603, 3332636672, 3332833279, 'CA', 'CAN', 'كندا'),
(79604, 3332833536, 3332841471, 'CA', 'CAN', 'كندا'),
(79605, 3332841728, 3332866303, 'CA', 'CAN', 'كندا'),
(79606, 3332874240, 3332875007, 'CA', 'CAN', 'كندا'),
(79607, 3332897280, 3332898559, 'CA', 'CAN', 'كندا'),
(79608, 3332899072, 3332899327, 'CA', 'CAN', 'كندا'),
(79609, 3332899328, 3332899583, 'US', 'USA', 'الولايات المتحدة'),
(79610, 3332899584, 3332899839, 'CA', 'CAN', 'كندا'),
(79611, 3332899840, 3332900095, 'US', 'USA', 'الولايات المتحدة'),
(79612, 3332900096, 3332909823, 'CA', 'CAN', 'كندا'),
(79613, 3332910080, 3332922879, 'CA', 'CAN', 'كندا'),
(79614, 3332923392, 3332925695, 'CA', 'CAN', 'كندا'),
(79615, 3332929024, 3332930559, 'CA', 'CAN', 'كندا'),
(79616, 3332931328, 3332947967, 'CA', 'CAN', 'كندا'),
(79617, 3332947968, 3332948223, 'US', 'USA', 'الولايات المتحدة'),
(79618, 3332948224, 3332964095, 'CA', 'CAN', 'كندا'),
(79619, 3332964352, 3332966143, 'CA', 'CAN', 'كندا'),
(79620, 3332966144, 3332966399, 'US', 'USA', 'الولايات المتحدة'),
(79621, 3332966400, 3332966911, 'CA', 'CAN', 'كندا'),
(79622, 3332967424, 3332979967, 'CA', 'CAN', 'كندا'),
(79623, 3332980736, 3332988927, 'CA', 'CAN', 'كندا'),
(79624, 3332989952, 3332997119, 'CA', 'CAN', 'كندا'),
(79625, 3332997376, 3333008383, 'CA', 'CAN', 'كندا'),
(79626, 3333008896, 3333012479, 'CA', 'CAN', 'كندا'),
(79627, 3333012480, 3333012991, 'US', 'USA', 'الولايات المتحدة'),
(79628, 3333012992, 3333014015, 'CA', 'CAN', 'كندا'),
(79629, 3333014528, 3333017599, 'CA', 'CAN', 'كندا'),
(79630, 3333018112, 3333023231, 'CA', 'CAN', 'كندا'),
(79631, 3333025280, 3333029631, 'CA', 'CAN', 'كندا'),
(79632, 3333029888, 3333389311, 'US', 'USA', 'الولايات المتحدة'),
(79633, 3333390336, 3333406463, 'US', 'USA', 'الولايات المتحدة'),
(79634, 3333406720, 3333422847, 'US', 'USA', 'الولايات المتحدة'),
(79635, 3333423104, 3333429759, 'US', 'USA', 'الولايات المتحدة'),
(79636, 3333431296, 3333434111, 'US', 'USA', 'الولايات المتحدة'),
(79637, 3333439488, 3333461247, 'US', 'USA', 'الولايات المتحدة'),
(79638, 3333461504, 3333462527, 'US', 'USA', 'الولايات المتحدة'),
(79639, 3333462784, 3333480191, 'US', 'USA', 'الولايات المتحدة'),
(79640, 3333480192, 3333481471, 'DE', 'DEU', 'ألمانيا'),
(79641, 3333481472, 3333482495, 'US', 'USA', 'الولايات المتحدة'),
(79642, 3333482752, 3333488383, 'US', 'USA', 'الولايات المتحدة'),
(79643, 3333488640, 3333490175, 'US', 'USA', 'الولايات المتحدة'),
(79644, 3333490688, 3333495807, 'US', 'USA', 'الولايات المتحدة'),
(79645, 3333496832, 3333501951, 'US', 'USA', 'الولايات المتحدة'),
(79646, 3333505024, 3333517823, 'US', 'USA', 'الولايات المتحدة'),
(79647, 3333521408, 3333534975, 'US', 'USA', 'الولايات المتحدة'),
(79648, 3333535232, 3333535743, 'US', 'USA', 'الولايات المتحدة'),
(79649, 3333536256, 3333541631, 'US', 'USA', 'الولايات المتحدة'),
(79650, 3333541888, 3333550335, 'US', 'USA', 'الولايات المتحدة'),
(79651, 3333550592, 3333553919, 'US', 'USA', 'الولايات المتحدة'),
(79652, 3333554176, 3333561343, 'US', 'USA', 'الولايات المتحدة'),
(79653, 3333562368, 3333568511, 'US', 'USA', 'الولايات المتحدة'),
(79654, 3333570560, 3333583359, 'US', 'USA', 'الولايات المتحدة'),
(79655, 3333586944, 3333591295, 'US', 'USA', 'الولايات المتحدة'),
(79656, 3333591552, 3333593855, 'US', 'USA', 'الولايات المتحدة'),
(79657, 3333594112, 3333595647, 'US', 'USA', 'الولايات المتحدة'),
(79658, 3333595904, 3333619455, 'US', 'USA', 'الولايات المتحدة'),
(79659, 3333619712, 3333620991, 'US', 'USA', 'الولايات المتحدة'),
(79660, 3333621760, 3333624319, 'US', 'USA', 'الولايات المتحدة'),
(79661, 3333624576, 3333627391, 'US', 'USA', 'الولايات المتحدة'),
(79662, 3333627904, 3333633023, 'US', 'USA', 'الولايات المتحدة'),
(79663, 3333652480, 3333654015, 'US', 'USA', 'الولايات المتحدة'),
(79664, 3333654272, 3333665023, 'US', 'USA', 'الولايات المتحدة'),
(79665, 3333665280, 3333669887, 'US', 'USA', 'الولايات المتحدة'),
(79666, 3333670144, 3333675775, 'US', 'USA', 'الولايات المتحدة'),
(79667, 3333676288, 3333684991, 'US', 'USA', 'الولايات المتحدة'),
(79668, 3333685248, 3333723647, 'US', 'USA', 'الولايات المتحدة'),
(79669, 3333723648, 3333724671, 'JP', 'JPN', 'اليابان'),
(79670, 3333724672, 3333725951, 'US', 'USA', 'الولايات المتحدة'),
(79671, 3333726208, 3333732863, 'US', 'USA', 'الولايات المتحدة'),
(79672, 3333733376, 3333734143, 'US', 'USA', 'الولايات المتحدة'),
(79673, 3333734400, 3333735935, 'US', 'USA', 'الولايات المتحدة'),
(79674, 3333736192, 3333737215, 'US', 'USA', 'الولايات المتحدة'),
(79675, 3333737472, 3333750527, 'US', 'USA', 'الولايات المتحدة'),
(79676, 3333750784, 3333766655, 'US', 'USA', 'الولايات المتحدة'),
(79677, 3333767168, 3333779967, 'US', 'USA', 'الولايات المتحدة'),
(79678, 3333783552, 3333791487, 'US', 'USA', 'الولايات المتحدة'),
(79679, 3333791744, 3333793279, 'US', 'USA', 'الولايات المتحدة'),
(79680, 3333794048, 3333796351, 'US', 'USA', 'الولايات المتحدة'),
(79681, 3333796608, 3333801727, 'US', 'USA', 'الولايات المتحدة'),
(79682, 3333802496, 3333816063, 'US', 'USA', 'الولايات المتحدة'),
(79683, 3333816320, 3333859839, 'US', 'USA', 'الولايات المتحدة'),
(79684, 3333859840, 3333860095, 'BM', 'BMU', 'برمودا'),
(79685, 3333860096, 3333870847, 'US', 'USA', 'الولايات المتحدة'),
(79686, 3333871104, 3333876479, 'US', 'USA', 'الولايات المتحدة'),
(79687, 3333876736, 3333881343, 'US', 'USA', 'الولايات المتحدة'),
(79688, 3333881856, 3333927423, 'US', 'USA', 'الولايات المتحدة'),
(79689, 3333927936, 3333933823, 'US', 'USA', 'الولايات المتحدة'),
(79690, 3333934080, 3333937919, 'US', 'USA', 'الولايات المتحدة'),
(79691, 3333939200, 3333939455, 'US', 'USA', 'الولايات المتحدة'),
(79692, 3333939968, 3333947135, 'US', 'USA', 'الولايات المتحدة'),
(79693, 3333947392, 3333950719, 'US', 'USA', 'الولايات المتحدة'),
(79694, 3333951488, 3333954047, 'US', 'USA', 'الولايات المتحدة'),
(79695, 3333955584, 3333963263, 'US', 'USA', 'الولايات المتحدة'),
(79696, 3333963776, 3333988607, 'US', 'USA', 'الولايات المتحدة'),
(79697, 3333988608, 3333988863, 'BR', 'BRA', 'البرازيل'),
(79698, 3333988864, 3333997823, 'US', 'USA', 'الولايات المتحدة'),
(79699, 3333997824, 3333998079, 'CA', 'CAN', 'كندا'),
(79700, 3333998080, 3334012671, 'US', 'USA', 'الولايات المتحدة'),
(79701, 3334012928, 3334019583, 'US', 'USA', 'الولايات المتحدة'),
(79702, 3334021120, 3334028799, 'US', 'USA', 'الولايات المتحدة'),
(79703, 3334029312, 3334053631, 'US', 'USA', 'الولايات المتحدة'),
(79704, 3334053888, 3334055167, 'US', 'USA', 'الولايات المتحدة'),
(79705, 3334055680, 3334079999, 'US', 'USA', 'الولايات المتحدة'),
(79706, 3334082560, 3334116607, 'US', 'USA', 'الولايات المتحدة'),
(79707, 3334116864, 3334119935, 'US', 'USA', 'الولايات المتحدة'),
(79708, 3334120448, 3334138623, 'US', 'USA', 'الولايات المتحدة'),
(79709, 3334138624, 3334138879, 'BM', 'BMU', 'برمودا'),
(79710, 3334139136, 3334143743, 'US', 'USA', 'الولايات المتحدة'),
(79711, 3334144000, 3334151167, 'US', 'USA', 'الولايات المتحدة'),
(79712, 3334152192, 3334179071, 'US', 'USA', 'الولايات المتحدة'),
(79713, 3334180096, 3334181631, 'US', 'USA', 'الولايات المتحدة'),
(79714, 3334182400, 3334187775, 'US', 'USA', 'الولايات المتحدة'),
(79715, 3334187776, 3334188031, 'BM', 'BMU', 'برمودا'),
(79716, 3334188032, 3334196735, 'US', 'USA', 'الولايات المتحدة'),
(79717, 3334196992, 3334201087, 'US', 'USA', 'الولايات المتحدة'),
(79718, 3334201344, 3334205183, 'US', 'USA', 'الولايات المتحدة'),
(79719, 3334205440, 3334209279, 'US', 'USA', 'الولايات المتحدة'),
(79720, 3334209536, 3334343935, 'US', 'USA', 'الولايات المتحدة'),
(79721, 3334344704, 3334348543, 'US', 'USA', 'الولايات المتحدة'),
(79722, 3334348800, 3334355967, 'US', 'USA', 'الولايات المتحدة'),
(79723, 3334373376, 3334374143, 'US', 'USA', 'الولايات المتحدة'),
(79724, 3334374656, 3334391039, 'US', 'USA', 'الولايات المتحدة'),
(79725, 3334391552, 3334392063, 'US', 'USA', 'الولايات المتحدة'),
(79726, 3334392320, 3334400255, 'US', 'USA', 'الولايات المتحدة'),
(79727, 3334400768, 3334405887, 'US', 'USA', 'الولايات المتحدة'),
(79728, 3334406144, 3334932223, 'US', 'USA', 'الولايات المتحدة'),
(79729, 3334932480, 3334934015, 'US', 'USA', 'الولايات المتحدة'),
(79730, 3334934528, 3334943743, 'US', 'USA', 'الولايات المتحدة'),
(79731, 3334963200, 3334974207, 'US', 'USA', 'الولايات المتحدة'),
(79732, 3334974464, 3334977791, 'US', 'USA', 'الولايات المتحدة'),
(79733, 3334978048, 3334979071, 'US', 'USA', 'الولايات المتحدة'),
(79734, 3334979328, 3334983167, 'US', 'USA', 'الولايات المتحدة'),
(79735, 3334983424, 3334987263, 'US', 'USA', 'الولايات المتحدة'),
(79736, 3334987520, 3334988031, 'US', 'USA', 'الولايات المتحدة'),
(79737, 3334988288, 3334993663, 'US', 'USA', 'الولايات المتحدة'),
(79738, 3334993920, 3334995711, 'US', 'USA', 'الولايات المتحدة'),
(79739, 3334995968, 3334998527, 'PH', 'PHL', 'الفلبين'),
(79740, 3335000064, 3335003135, 'US', 'USA', 'الولايات المتحدة'),
(79741, 3335028736, 3335032063, 'US', 'USA', 'الولايات المتحدة'),
(79742, 3335032320, 3335033343, 'US', 'USA', 'الولايات المتحدة'),
(79743, 3335033600, 3335033855, 'US', 'USA', 'الولايات المتحدة'),
(79744, 3335034112, 3335043327, 'US', 'USA', 'الولايات المتحدة'),
(79745, 3335043584, 3335048191, 'US', 'USA', 'الولايات المتحدة'),
(79746, 3335048448, 3335057407, 'US', 'USA', 'الولايات المتحدة'),
(79747, 3335058176, 3335163135, 'US', 'USA', 'الولايات المتحدة'),
(79748, 3335163904, 3335180287, 'US', 'USA', 'الولايات المتحدة'),
(79749, 3335180544, 3335181567, 'US', 'USA', 'الولايات المتحدة'),
(79750, 3335181824, 3335192319, 'US', 'USA', 'الولايات المتحدة'),
(79751, 3335192576, 3335199231, 'US', 'USA', 'الولايات المتحدة'),
(79752, 3335200768, 3335235839, 'US', 'USA', 'الولايات المتحدة'),
(79753, 3335236096, 3335247103, 'US', 'USA', 'الولايات المتحدة'),
(79754, 3335247360, 3335249407, 'US', 'USA', 'الولايات المتحدة'),
(79755, 3335249664, 3335251967, 'US', 'USA', 'الولايات المتحدة'),
(79756, 3335252224, 3335252735, 'US', 'USA', 'الولايات المتحدة'),
(79757, 3335252736, 3335252991, 'CA', 'CAN', 'كندا'),
(79758, 3335252992, 3335257855, 'US', 'USA', 'الولايات المتحدة'),
(79759, 3335258112, 3335265535, 'US', 'USA', 'الولايات المتحدة'),
(79760, 3335266304, 3335273983, 'US', 'USA', 'الولايات المتحدة'),
(79761, 3335274496, 3335276287, 'US', 'USA', 'الولايات المتحدة'),
(79762, 3335276288, 3335276799, 'PR', 'PRI', 'بورتو ريكو'),
(79763, 3335276800, 3335310079, 'US', 'USA', 'الولايات المتحدة'),
(79764, 3335323648, 3335324927, 'US', 'USA', 'الولايات المتحدة'),
(79765, 3335325696, 3335327487, 'US', 'USA', 'الولايات المتحدة'),
(79766, 3335327744, 3335349247, 'US', 'USA', 'الولايات المتحدة'),
(79767, 3335356416, 3335422463, 'US', 'USA', 'الولايات المتحدة'),
(79768, 3335424000, 3335439615, 'US', 'USA', 'الولايات المتحدة'),
(79769, 3335439616, 3335439871, 'CH', 'CHE', 'سويسرا'),
(79770, 3335439872, 3335440383, 'US', 'USA', 'الولايات المتحدة'),
(79771, 3335440384, 3335441151, 'CH', 'CHE', 'سويسرا'),
(79772, 3335441152, 3335447039, 'US', 'USA', 'الولايات المتحدة'),
(79773, 3335447296, 3335451903, 'US', 'USA', 'الولايات المتحدة'),
(79774, 3335452160, 3335452671, 'US', 'USA', 'الولايات المتحدة'),
(79775, 3335453696, 3335454463, 'US', 'USA', 'الولايات المتحدة'),
(79776, 3335454720, 3335458815, 'US', 'USA', 'الولايات المتحدة'),
(79777, 3335458816, 3335460863, 'BM', 'BMU', 'برمودا'),
(79778, 3335462912, 3335487743, 'US', 'USA', 'الولايات المتحدة'),
(79779, 3335488000, 3335501311, 'US', 'USA', 'الولايات المتحدة'),
(79780, 3335501568, 3335502591, 'US', 'USA', 'الولايات المتحدة'),
(79781, 3335502848, 3335511295, 'US', 'USA', 'الولايات المتحدة'),
(79782, 3335511552, 3335519999, 'US', 'USA', 'الولايات المتحدة'),
(79783, 3335520256, 3335654911, 'US', 'USA', 'الولايات المتحدة'),
(79784, 3335659520, 3335667711, 'US', 'USA', 'الولايات المتحدة'),
(79785, 3335684096, 3335716863, 'US', 'USA', 'الولايات المتحدة'),
(79786, 3335733248, 3335741439, 'US', 'USA', 'الولايات المتحدة'),
(79787, 3335753728, 3335784191, 'US', 'USA', 'الولايات المتحدة'),
(79788, 3335784448, 3335789567, 'US', 'USA', 'الولايات المتحدة'),
(79789, 3335790592, 3335795199, 'US', 'USA', 'الولايات المتحدة'),
(79790, 3335798784, 3336111359, 'US', 'USA', 'الولايات المتحدة'),
(79791, 3336112128, 3336116223, 'US', 'USA', 'الولايات المتحدة'),
(79792, 3336118272, 3336139263, 'US', 'USA', 'الولايات المتحدة'),
(79793, 3336142848, 3337029119, 'US', 'USA', 'الولايات المتحدة'),
(79794, 3337029632, 3337031167, 'US', 'USA', 'الولايات المتحدة'),
(79795, 3337031680, 3337034239, 'US', 'USA', 'الولايات المتحدة'),
(79796, 3337035776, 3337055231, 'US', 'USA', 'الولايات المتحدة'),
(79797, 3337055232, 3337060351, 'CA', 'CAN', 'كندا'),
(79798, 3337060352, 3337119743, 'US', 'USA', 'الولايات المتحدة'),
(79799, 3337125888, 3337127167, 'US', 'USA', 'الولايات المتحدة'),
(79800, 3337127424, 3337134079, 'US', 'USA', 'الولايات المتحدة'),
(79801, 3337134336, 3337139967, 'US', 'USA', 'الولايات المتحدة'),
(79802, 3337140224, 3337148927, 'US', 'USA', 'الولايات المتحدة'),
(79803, 3337149696, 3337149951, 'US', 'USA', 'الولايات المتحدة'),
(79804, 3337150464, 3337155071, 'US', 'USA', 'الولايات المتحدة'),
(79805, 3337155328, 3337157887, 'US', 'USA', 'الولايات المتحدة'),
(79806, 3337158656, 3337289727, 'US', 'USA', 'الولايات المتحدة'),
(79807, 3337289984, 3337297919, 'CA', 'CAN', 'كندا'),
(79808, 3337297920, 3337302015, 'US', 'USA', 'الولايات المتحدة'),
(79809, 3337302016, 3337303551, 'CA', 'CAN', 'كندا'),
(79810, 3337304064, 3337322495, 'CA', 'CAN', 'كندا'),
(79811, 3337322752, 3337323007, 'CA', 'CAN', 'كندا'),
(79812, 3337324544, 3337335295, 'CA', 'CAN', 'كندا'),
(79813, 3337335296, 3337335807, 'US', 'USA', 'الولايات المتحدة'),
(79814, 3337335808, 3337341951, 'CA', 'CAN', 'كندا'),
(79815, 3337342464, 3337355007, 'CA', 'CAN', 'كندا'),
(79816, 3337355264, 3337650175, 'US', 'USA', 'الولايات المتحدة'),
(79817, 3337650176, 3337650687, 'GB', 'GBR', 'المملكة المتحدة'),
(79818, 3337650688, 3337650943, 'US', 'USA', 'الولايات المتحدة'),
(79819, 3337650944, 3337651199, 'HK', 'HKG', 'هونغ كونغ'),
(79820, 3337651200, 3337651455, 'CH', 'CHE', 'سويسرا'),
(79821, 3337651456, 3337651711, 'SG', 'SGP', 'سنغافورة'),
(79822, 3337651712, 3337653503, 'CH', 'CHE', 'سويسرا'),
(79823, 3337653504, 3337653759, 'JP', 'JPN', 'اليابان'),
(79824, 3337653760, 3337654783, 'CH', 'CHE', 'سويسرا'),
(79825, 3337654784, 3337655039, 'AU', 'AUS', 'أستراليا'),
(79826, 3337655040, 3337682943, 'CH', 'CHE', 'سويسرا'),
(79827, 3337682944, 3337685503, 'US', 'USA', 'الولايات المتحدة'),
(79828, 3337687040, 3337694207, 'US', 'USA', 'الولايات المتحدة'),
(79829, 3337699328, 3337882111, 'US', 'USA', 'الولايات المتحدة'),
(79830, 3337883648, 3337891583, 'US', 'USA', 'الولايات المتحدة'),
(79831, 3337912320, 3337948415, 'US', 'USA', 'الولايات المتحدة'),
(79832, 3337949184, 3337955839, 'US', 'USA', 'الولايات المتحدة'),
(79833, 3337977856, 3337980671, 'US', 'USA', 'الولايات المتحدة'),
(79834, 3337980672, 3337980927, 'PR', 'PRI', 'بورتو ريكو'),
(79835, 3337980928, 3337986047, 'US', 'USA', 'الولايات المتحدة'),
(79836, 3337986048, 3337986303, 'BB', 'BRB', 'باربادوس'),
(79837, 3337986304, 3337989375, 'US', 'USA', 'الولايات المتحدة'),
(79838, 3337990912, 3338010367, 'US', 'USA', 'الولايات المتحدة'),
(79839, 3338010624, 3338017279, 'US', 'USA', 'الولايات المتحدة'),
(79840, 3338018816, 3338021887, 'US', 'USA', 'الولايات المتحدة'),
(79841, 3338027008, 3338051583, 'US', 'USA', 'الولايات المتحدة'),
(79842, 3338051840, 3338058239, 'US', 'USA', 'الولايات المتحدة'),
(79843, 3338059776, 3338063871, 'US', 'USA', 'الولايات المتحدة'),
(79844, 3338064128, 3338069247, 'US', 'USA', 'الولايات المتحدة'),
(79845, 3338069248, 3338069759, 'BB', 'BRB', 'باربادوس'),
(79846, 3338069760, 3338075903, 'US', 'USA', 'الولايات المتحدة'),
(79847, 3338076160, 3338342143, 'US', 'USA', 'الولايات المتحدة'),
(79848, 3338342400, 3338346239, 'US', 'USA', 'الولايات المتحدة'),
(79849, 3338346496, 3338348543, 'US', 'USA', 'الولايات المتحدة'),
(79850, 3338403840, 3338439167, 'US', 'USA', 'الولايات المتحدة'),
(79851, 3338439424, 3338444799, 'US', 'USA', 'الولايات المتحدة'),
(79852, 3338445056, 3338445311, 'US', 'USA', 'الولايات المتحدة'),
(79853, 3338445824, 3338455551, 'US', 'USA', 'الولايات المتحدة'),
(79854, 3338456576, 3338460671, 'US', 'USA', 'الولايات المتحدة'),
(79855, 3338460928, 3338462719, 'US', 'USA', 'الولايات المتحدة'),
(79856, 3338462976, 3338469119, 'US', 'USA', 'الولايات المتحدة'),
(79857, 3338469376, 3338541567, 'US', 'USA', 'الولايات المتحدة'),
(79858, 3338543104, 3338551295, 'US', 'USA', 'الولايات المتحدة'),
(79859, 3338665984, 3338686463, 'US', 'USA', 'الولايات المتحدة'),
(79860, 3338686464, 3338688511, 'AW', 'ABW', 'أروبا'),
(79861, 3338688512, 3338689535, 'US', 'USA', 'الولايات المتحدة'),
(79862, 3338689536, 3338689791, 'SL', 'SLE', 'سيراليون'),
(79863, 3338689792, 3338825727, 'US', 'USA', 'الولايات المتحدة'),
(79864, 3338825728, 3338827775, 'AW', 'ABW', 'أروبا'),
(79865, 3338827776, 3338912767, 'US', 'USA', 'الولايات المتحدة'),
(79866, 3338912768, 3338913023, 'EC', 'ECU', 'الإكوادور'),
(79867, 3338913024, 3338916351, 'US', 'USA', 'الولايات المتحدة'),
(79868, 3338916352, 3338916479, 'CN', 'CHN', 'الصين'),
(79869, 3338916480, 3338964991, 'US', 'USA', 'الولايات المتحدة'),
(79870, 3338965248, 3338969343, 'US', 'USA', 'الولايات المتحدة'),
(79871, 3338970112, 3338976767, 'US', 'USA', 'الولايات المتحدة'),
(79872, 3338977024, 3338993407, 'US', 'USA', 'الولايات المتحدة'),
(79873, 3338993664, 3339000319, 'US', 'USA', 'الولايات المتحدة'),
(79874, 3339000832, 3339028735, 'US', 'USA', 'الولايات المتحدة'),
(79875, 3339028992, 3339031295, 'US', 'USA', 'الولايات المتحدة'),
(79876, 3339031552, 3339042047, 'US', 'USA', 'الولايات المتحدة'),
(79877, 3339042304, 3339043327, 'US', 'USA', 'الولايات المتحدة'),
(79878, 3339043584, 3339045119, 'US', 'USA', 'الولايات المتحدة'),
(79879, 3339045376, 3339050751, 'US', 'USA', 'الولايات المتحدة'),
(79880, 3339051008, 3339058943, 'US', 'USA', 'الولايات المتحدة'),
(79881, 3339059200, 3339063039, 'US', 'USA', 'الولايات المتحدة'),
(79882, 3339063296, 3339076863, 'US', 'USA', 'الولايات المتحدة'),
(79883, 3339076864, 3339077631, 'JP', 'JPN', 'اليابان'),
(79884, 3339077632, 3339079167, 'US', 'USA', 'الولايات المتحدة'),
(79885, 3339079168, 3339079679, 'DE', 'DEU', 'ألمانيا'),
(79886, 3339079680, 3339091967, 'US', 'USA', 'الولايات المتحدة'),
(79887, 3339091968, 3339094015, 'NL', 'NLD', 'هولندا'),
(79888, 3339094016, 3339136767, 'US', 'USA', 'الولايات المتحدة'),
(79889, 3339137024, 3339142655, 'US', 'USA', 'الولايات المتحدة'),
(79890, 3339142656, 3339142911, 'NL', 'NLD', 'هولندا'),
(79891, 3339142912, 3339145727, 'US', 'USA', 'الولايات المتحدة'),
(79892, 3339145728, 3339145983, 'NL', 'NLD', 'هولندا'),
(79893, 3339145984, 3339146239, 'US', 'USA', 'الولايات المتحدة'),
(79894, 3339146496, 3339147007, 'US', 'USA', 'الولايات المتحدة'),
(79895, 3339147008, 3339147775, 'CA', 'CAN', 'كندا'),
(79896, 3339147776, 3339148031, 'MS', 'MSR', 'مونتسيرات'),
(79897, 3339148032, 3339148543, 'US', 'USA', 'الولايات المتحدة'),
(79898, 3339148800, 3339149311, 'US', 'USA', 'الولايات المتحدة'),
(79899, 3339190272, 3339256575, 'US', 'USA', 'الولايات المتحدة'),
(79900, 3339256832, 3339259135, 'US', 'USA', 'الولايات المتحدة'),
(79901, 3339259904, 3339270399, 'US', 'USA', 'الولايات المتحدة'),
(79902, 3339271168, 3339322367, 'US', 'USA', 'الولايات المتحدة'),
(79903, 3339323392, 3339324927, 'US', 'USA', 'الولايات المتحدة'),
(79904, 3339325440, 3339327999, 'US', 'USA', 'الولايات المتحدة'),
(79905, 3339329536, 3339337727, 'US', 'USA', 'الولايات المتحدة'),
(79906, 3339337984, 3339338239, 'US', 'USA', 'الولايات المتحدة'),
(79907, 3339338496, 3339342847, 'US', 'USA', 'الولايات المتحدة'),
(79908, 3339343104, 3339343615, 'US', 'USA', 'الولايات المتحدة'),
(79909, 3339343872, 3339348223, 'US', 'USA', 'الولايات المتحدة'),
(79910, 3339348480, 3339352831, 'US', 'USA', 'الولايات المتحدة'),
(79911, 3339353088, 3339367423, 'US', 'USA', 'الولايات المتحدة'),
(79912, 3339367680, 3339373055, 'US', 'USA', 'الولايات المتحدة'),
(79913, 3339373568, 3339386111, 'US', 'USA', 'الولايات المتحدة'),
(79914, 3339386880, 3339655679, 'US', 'USA', 'الولايات المتحدة'),
(79915, 3339656192, 3339667967, 'US', 'USA', 'الولايات المتحدة'),
(79916, 3339668480, 3339669503, 'US', 'USA', 'الولايات المتحدة'),
(79917, 3339669504, 3339671807, 'CA', 'CAN', 'كندا'),
(79918, 3339672576, 3339673599, 'US', 'USA', 'الولايات المتحدة'),
(79919, 3339714560, 3339722495, 'US', 'USA', 'الولايات المتحدة'),
(79920, 3339730944, 3339739135, 'US', 'USA', 'الولايات المتحدة'),
(79921, 3339780096, 3339911167, 'US', 'USA', 'الولايات المتحدة'),
(79922, 3339913216, 3339923455, 'US', 'USA', 'الولايات المتحدة'),
(79923, 3339923456, 3339926015, 'CA', 'CAN', 'كندا'),
(79924, 3339926528, 3339927551, 'CA', 'CAN', 'كندا'),
(79925, 3339976704, 3340046079, 'US', 'USA', 'الولايات المتحدة'),
(79926, 3340046336, 3340058623, 'US', 'USA', 'الولايات المتحدة'),
(79927, 3340107776, 3340369919, 'CA', 'CAN', 'كندا'),
(79928, 3340369920, 3340383487, 'US', 'USA', 'الولايات المتحدة'),
(79929, 3340384256, 3340386559, 'US', 'USA', 'الولايات المتحدة'),
(79930, 3340387328, 3340388351, 'CA', 'CAN', 'كندا'),
(79931, 3340388352, 3340390399, 'US', 'USA', 'الولايات المتحدة'),
(79932, 3340394496, 3340404735, 'US', 'USA', 'الولايات المتحدة'),
(79933, 3340404992, 3340411903, 'US', 'USA', 'الولايات المتحدة'),
(79934, 3340412160, 3340414975, 'US', 'USA', 'الولايات المتحدة'),
(79935, 3340415232, 3340416767, 'US', 'USA', 'الولايات المتحدة'),
(79936, 3340417280, 3340419071, 'US', 'USA', 'الولايات المتحدة'),
(79937, 3340419328, 3340425983, 'US', 'USA', 'الولايات المتحدة'),
(79938, 3340426752, 3340429823, 'US', 'USA', 'الولايات المتحدة'),
(79939, 3340429824, 3340430079, 'PA', 'PAN', 'بنما'),
(79940, 3340430080, 3340431871, 'US', 'USA', 'الولايات المتحدة'),
(79941, 3340432384, 3340435199, 'US', 'USA', 'الولايات المتحدة'),
(79942, 3340435456, 3340436991, 'US', 'USA', 'الولايات المتحدة'),
(79943, 3340437504, 3340443135, 'US', 'USA', 'الولايات المتحدة'),
(79944, 3340443648, 3340451839, 'US', 'USA', 'الولايات المتحدة'),
(79945, 3340500992, 3340643839, 'US', 'USA', 'الولايات المتحدة'),
(79946, 3340697600, 3340835327, 'US', 'USA', 'الولايات المتحدة'),
(79947, 3340835840, 3340865279, 'US', 'USA', 'الولايات المتحدة'),
(79948, 3340865536, 3340882431, 'US', 'USA', 'الولايات المتحدة'),
(79949, 3340882688, 3340884479, 'US', 'USA', 'الولايات المتحدة'),
(79950, 3340884992, 3340886527, 'US', 'USA', 'الولايات المتحدة'),
(79951, 3340886784, 3340887551, 'US', 'USA', 'الولايات المتحدة'),
(79952, 3340888576, 3340893951, 'US', 'USA', 'الولايات المتحدة'),
(79953, 3340894208, 3340923391, 'US', 'USA', 'الولايات المتحدة'),
(79954, 3340923904, 3340955647, 'US', 'USA', 'الولايات المتحدة'),
(79955, 3340959744, 3341027839, 'US', 'USA', 'الولايات المتحدة'),
(79956, 3341028352, 3341031935, 'US', 'USA', 'الولايات المتحدة'),
(79957, 3341032448, 3341041663, 'US', 'USA', 'الولايات المتحدة'),
(79958, 3341090816, 3341162751, 'US', 'USA', 'الولايات المتحدة'),
(79959, 3341163520, 3341172735, 'US', 'USA', 'الولايات المتحدة'),
(79960, 3341189120, 3341192959, 'US', 'USA', 'الولايات المتحدة'),
(79961, 3341193216, 3341194239, 'US', 'USA', 'الولايات المتحدة'),
(79962, 3341194496, 3341196799, 'US', 'USA', 'الولايات المتحدة'),
(79963, 3341221888, 3341484287, 'US', 'USA', 'الولايات المتحدة'),
(79964, 3341484288, 3341485055, 'CA', 'CAN', 'كندا'),
(79965, 3341485056, 3341511679, 'US', 'USA', 'الولايات المتحدة'),
(79966, 3341511680, 3341513215, 'CA', 'CAN', 'كندا'),
(79967, 3341513728, 3341517823, 'CA', 'CAN', 'كندا'),
(79968, 3341517824, 3341518847, 'US', 'USA', 'الولايات المتحدة'),
(79969, 3341518848, 3341520895, 'CA', 'CAN', 'كندا'),
(79970, 3341520896, 3341521663, 'US', 'USA', 'الولايات المتحدة'),
(79971, 3341521664, 3341531135, 'CA', 'CAN', 'كندا'),
(79972, 3341531392, 3341533951, 'US', 'USA', 'الولايات المتحدة'),
(79973, 3341534976, 3341536767, 'CA', 'CAN', 'كندا'),
(79974, 3341537280, 3341541375, 'US', 'USA', 'الولايات المتحدة'),
(79975, 3341541888, 3341546239, 'US', 'USA', 'الولايات المتحدة'),
(79976, 3341546240, 3341547007, 'CA', 'CAN', 'كندا'),
(79977, 3341547008, 3341547519, 'CH', 'CHE', 'سويسرا'),
(79978, 3341547520, 3341549311, 'CA', 'CAN', 'كندا'),
(79979, 3341549568, 3341705215, 'US', 'USA', 'الولايات المتحدة'),
(79980, 3341713408, 3341750015, 'US', 'USA', 'الولايات المتحدة'),
(79981, 3341750272, 3341755647, 'US', 'USA', 'الولايات المتحدة'),
(79982, 3341756416, 3341758463, 'US', 'USA', 'الولايات المتحدة'),
(79983, 3341811712, 3341815039, 'US', 'USA', 'الولايات المتحدة'),
(79984, 3341815808, 3341823999, 'US', 'USA', 'الولايات المتحدة'),
(79985, 3341877248, 3342139391, 'US', 'USA', 'الولايات المتحدة'),
(79986, 3342139392, 3342204927, 'CH', 'CHE', 'سويسرا'),
(79987, 3342204928, 3342470399, 'US', 'USA', 'الولايات المتحدة'),
(79988, 3342471168, 3342483455, 'US', 'USA', 'الولايات المتحدة'),
(79989, 3342532608, 3342534143, 'US', 'USA', 'الولايات المتحدة'),
(79990, 3342534656, 3342540543, 'US', 'USA', 'الولايات المتحدة'),
(79991, 3342540800, 3342543359, 'US', 'USA', 'الولايات المتحدة'),
(79992, 3342543872, 3342544895, 'US', 'USA', 'الولايات المتحدة'),
(79993, 3342598144, 3342603263, 'CA', 'CAN', 'كندا'),
(79994, 3342603264, 3342604799, 'US', 'USA', 'الولايات المتحدة'),
(79995, 3342604800, 3342605311, 'CA', 'CAN', 'كندا'),
(79996, 3342605312, 3342605567, 'US', 'USA', 'الولايات المتحدة'),
(79997, 3342605568, 3342614271, 'CA', 'CAN', 'كندا'),
(79998, 3342614528, 3342623743, 'CA', 'CAN', 'كندا'),
(79999, 3342624256, 3342627839, 'CA', 'CAN', 'كندا'),
(80000, 3342628096, 3342657535, 'CA', 'CAN', 'كندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(80001, 3342657792, 3342663423, 'CA', 'CAN', 'كندا'),
(80002, 3342663680, 3342999039, 'US', 'USA', 'الولايات المتحدة'),
(80003, 3342999552, 3343007743, 'US', 'USA', 'الولايات المتحدة'),
(80004, 3343056896, 3343123967, 'US', 'USA', 'الولايات المتحدة'),
(80005, 3343124480, 3343126015, 'US', 'USA', 'الولايات المتحدة'),
(80006, 3343126528, 3343129087, 'US', 'USA', 'الولايات المتحدة'),
(80007, 3343129600, 3343135999, 'US', 'USA', 'الولايات المتحدة'),
(80008, 3343136768, 3343148543, 'US', 'USA', 'الولايات المتحدة'),
(80009, 3343149056, 3343151103, 'US', 'USA', 'الولايات المتحدة'),
(80010, 3343187968, 3343319295, 'US', 'USA', 'الولايات المتحدة'),
(80011, 3343319296, 3343342847, 'CA', 'CAN', 'كندا'),
(80012, 3343343104, 3343346175, 'CA', 'CAN', 'كندا'),
(80013, 3343346688, 3343355391, 'CA', 'CAN', 'كندا'),
(80014, 3343355904, 3343359743, 'CA', 'CAN', 'كندا'),
(80015, 3343360000, 3343364095, 'CA', 'CAN', 'كندا'),
(80016, 3343364096, 3343365119, 'US', 'USA', 'الولايات المتحدة'),
(80017, 3343365632, 3343366655, 'CA', 'CAN', 'كندا'),
(80018, 3343366912, 3343372543, 'CA', 'CAN', 'كندا'),
(80019, 3343373312, 3343376383, 'US', 'USA', 'الولايات المتحدة'),
(80020, 3343380480, 3343384319, 'CA', 'CAN', 'كندا'),
(80021, 3343384576, 3343452671, 'US', 'USA', 'الولايات المتحدة'),
(80022, 3343453184, 3343456511, 'US', 'USA', 'الولايات المتحدة'),
(80023, 3343457280, 3343460863, 'US', 'USA', 'الولايات المتحدة'),
(80024, 3343461376, 3343462399, 'US', 'USA', 'الولايات المتحدة'),
(80025, 3343466496, 3343470847, 'US', 'USA', 'الولايات المتحدة'),
(80026, 3343471616, 3343474687, 'US', 'USA', 'الولايات المتحدة'),
(80027, 3343482880, 3343568127, 'US', 'USA', 'الولايات المتحدة'),
(80028, 3343568384, 3343575807, 'US', 'USA', 'الولايات المتحدة'),
(80029, 3343576064, 3343580927, 'US', 'USA', 'الولايات المتحدة'),
(80030, 3343581184, 3343855615, 'US', 'USA', 'الولايات المتحدة'),
(80031, 3343859712, 3343887359, 'US', 'USA', 'الولايات المتحدة'),
(80032, 3343887616, 3343890687, 'US', 'USA', 'الولايات المتحدة'),
(80033, 3343890944, 3343902463, 'US', 'USA', 'الولايات المتحدة'),
(80034, 3343902720, 3343905023, 'US', 'USA', 'الولايات المتحدة'),
(80035, 3343905280, 3343908607, 'US', 'USA', 'الولايات المتحدة'),
(80036, 3343908864, 3344109055, 'US', 'USA', 'الولايات المتحدة'),
(80037, 3344109568, 3344111871, 'US', 'USA', 'الولايات المتحدة'),
(80038, 3344112640, 3344116223, 'US', 'USA', 'الولايات المتحدة'),
(80039, 3344116736, 3344117759, 'US', 'USA', 'الولايات المتحدة'),
(80040, 3344121856, 3344125951, 'US', 'USA', 'الولايات المتحدة'),
(80041, 3344171264, 3344236287, 'CA', 'CAN', 'كندا'),
(80042, 3344237056, 3344242175, 'CA', 'CAN', 'كندا'),
(80043, 3344242688, 3344252671, 'CA', 'CAN', 'كندا'),
(80044, 3344252928, 3344255999, 'CA', 'CAN', 'كندا'),
(80045, 3344256000, 3344257023, 'US', 'USA', 'الولايات المتحدة'),
(80046, 3344261888, 3344266239, 'CA', 'CAN', 'كندا'),
(80047, 3344266752, 3344268543, 'CA', 'CAN', 'كندا'),
(80048, 3344268544, 3344269311, 'US', 'USA', 'الولايات المتحدة'),
(80049, 3344269312, 3344287743, 'CA', 'CAN', 'كندا'),
(80050, 3344288000, 3344288767, 'CA', 'CAN', 'كندا'),
(80051, 3344288768, 3344289791, 'PR', 'PRI', 'بورتو ريكو'),
(80052, 3344289792, 3344292863, 'US', 'USA', 'الولايات المتحدة'),
(80053, 3344292864, 3344296447, 'CA', 'CAN', 'كندا'),
(80054, 3344296960, 3344297983, 'GD', 'GRD', 'غرينادا'),
(80055, 3344297984, 3344299007, 'US', 'USA', 'الولايات المتحدة'),
(80056, 3344299264, 3344299519, 'CA', 'CAN', 'كندا'),
(80057, 3344299520, 3344299775, 'US', 'USA', 'الولايات المتحدة'),
(80058, 3344299776, 3344300543, 'CA', 'CAN', 'كندا'),
(80059, 3344300544, 3344300799, 'US', 'USA', 'الولايات المتحدة'),
(80060, 3344300800, 3344301823, 'CA', 'CAN', 'كندا'),
(80061, 3344302080, 3344374271, 'US', 'USA', 'الولايات المتحدة'),
(80062, 3344374784, 3344379903, 'US', 'USA', 'الولايات المتحدة'),
(80063, 3344384000, 3344387071, 'US', 'USA', 'الولايات المتحدة'),
(80064, 3344433152, 3344466431, 'US', 'USA', 'الولايات المتحدة'),
(80065, 3344466688, 3344467455, 'US', 'USA', 'الولايات المتحدة'),
(80066, 3344468480, 3344469247, 'US', 'USA', 'الولايات المتحدة'),
(80067, 3344469504, 3344482047, 'US', 'USA', 'الولايات المتحدة'),
(80068, 3344482304, 3344486399, 'US', 'USA', 'الولايات المتحدة'),
(80069, 3344486400, 3344488447, 'NL', 'NLD', 'هولندا'),
(80070, 3344488448, 3344495871, 'US', 'USA', 'الولايات المتحدة'),
(80071, 3344496640, 3344497919, 'US', 'USA', 'الولايات المتحدة'),
(80072, 3344498176, 3344498431, 'US', 'USA', 'الولايات المتحدة'),
(80073, 3344498688, 3344511231, 'US', 'USA', 'الولايات المتحدة'),
(80074, 3344512000, 3344531711, 'US', 'USA', 'الولايات المتحدة'),
(80075, 3344531968, 3344534271, 'US', 'USA', 'الولايات المتحدة'),
(80076, 3344534528, 3344536831, 'US', 'USA', 'الولايات المتحدة'),
(80077, 3344537088, 3344548351, 'US', 'USA', 'الولايات المتحدة'),
(80078, 3344548608, 3344555007, 'US', 'USA', 'الولايات المتحدة'),
(80079, 3344555264, 3344556031, 'US', 'USA', 'الولايات المتحدة'),
(80080, 3344556288, 3344563967, 'US', 'USA', 'الولايات المتحدة'),
(80081, 3344564224, 3344633855, 'US', 'USA', 'الولايات المتحدة'),
(80082, 3344633856, 3344637951, 'CH', 'CHE', 'سويسرا'),
(80083, 3344637952, 3344640511, 'US', 'USA', 'الولايات المتحدة'),
(80084, 3344641024, 3344642047, 'US', 'USA', 'الولايات المتحدة'),
(80085, 3344695296, 3344959999, 'US', 'USA', 'الولايات المتحدة'),
(80086, 3344960512, 3344964607, 'US', 'USA', 'الولايات المتحدة'),
(80087, 3344964608, 3344965631, 'CA', 'CAN', 'كندا'),
(80088, 3344965632, 3344969727, 'US', 'USA', 'الولايات المتحدة'),
(80089, 3345022976, 3345291775, 'US', 'USA', 'الولايات المتحدة'),
(80090, 3345292288, 3345295871, 'US', 'USA', 'الولايات المتحدة'),
(80091, 3345296384, 3345297407, 'US', 'USA', 'الولايات المتحدة'),
(80092, 3345350656, 3345362943, 'US', 'USA', 'الولايات المتحدة'),
(80093, 3345416192, 3345418239, 'US', 'USA', 'الولايات المتحدة'),
(80094, 3345418240, 3345419519, 'NL', 'NLD', 'هولندا'),
(80095, 3345419520, 3345422847, 'US', 'USA', 'الولايات المتحدة'),
(80096, 3345423360, 3345424383, 'TC', 'TCA', 'جزر تركس وكايكوس'),
(80097, 3345424384, 3345430527, 'US', 'USA', 'الولايات المتحدة'),
(80098, 3345430528, 3345432575, 'CA', 'CAN', 'كندا'),
(80099, 3345432576, 3345433599, 'GB', 'GBR', 'المملكة المتحدة'),
(80100, 3345433600, 3345433855, 'SG', 'SGP', 'سنغافورة'),
(80101, 3345433856, 3345434879, 'US', 'USA', 'الولايات المتحدة'),
(80102, 3345434880, 3345435135, 'ES', 'ESP', 'إسبانيا'),
(80103, 3345435136, 3345435391, 'LU', 'LUX', 'لوكسيمبورغ'),
(80104, 3345435392, 3345436671, 'DE', 'DEU', 'ألمانيا'),
(80105, 3345436672, 3345436927, 'US', 'USA', 'الولايات المتحدة'),
(80106, 3345436928, 3345437183, 'ES', 'ESP', 'إسبانيا'),
(80107, 3345437184, 3345437695, 'GB', 'GBR', 'المملكة المتحدة'),
(80108, 3345437696, 3345437951, 'NL', 'NLD', 'هولندا'),
(80109, 3345438208, 3345438463, 'GB', 'GBR', 'المملكة المتحدة'),
(80110, 3345438464, 3345438975, 'FR', 'FRA', 'فرنسا'),
(80111, 3345439232, 3345439743, 'US', 'USA', 'الولايات المتحدة'),
(80112, 3345439744, 3345439999, 'FR', 'FRA', 'فرنسا'),
(80113, 3345440000, 3345440255, 'DE', 'DEU', 'ألمانيا'),
(80114, 3345440256, 3345440767, 'US', 'USA', 'الولايات المتحدة'),
(80115, 3345441024, 3345441791, 'DE', 'DEU', 'ألمانيا'),
(80116, 3345442304, 3345442559, 'CL', 'CHL', 'تشيلي'),
(80117, 3345442560, 3345442815, 'JP', 'JPN', 'اليابان'),
(80118, 3345442816, 3345443327, 'AT', 'AUT', 'النمسا'),
(80119, 3345443328, 3345443583, 'CH', 'CHE', 'سويسرا'),
(80120, 3345443584, 3345443839, 'DE', 'DEU', 'ألمانيا'),
(80121, 3345444096, 3345444607, 'US', 'USA', 'الولايات المتحدة'),
(80122, 3345444608, 3345445119, 'CH', 'CHE', 'سويسرا'),
(80123, 3345445120, 3345445375, 'US', 'USA', 'الولايات المتحدة'),
(80124, 3345445376, 3345446399, 'GB', 'GBR', 'المملكة المتحدة'),
(80125, 3345446656, 3345446911, 'IT', 'ITA', 'إيطاليا'),
(80126, 3345446912, 3345447679, 'US', 'USA', 'الولايات المتحدة'),
(80127, 3345447680, 3345448959, 'BE', 'BEL', 'بلجيكا'),
(80128, 3345448960, 3346138879, 'US', 'USA', 'الولايات المتحدة'),
(80129, 3346139136, 3346140415, 'US', 'USA', 'الولايات المتحدة'),
(80130, 3346141184, 3346188543, 'US', 'USA', 'الولايات المتحدة'),
(80131, 3346189312, 3346190335, 'US', 'USA', 'الولايات المتحدة'),
(80132, 3346202624, 3346209279, 'US', 'USA', 'الولايات المتحدة'),
(80133, 3346209792, 3346216447, 'US', 'USA', 'الولايات المتحدة'),
(80134, 3346216960, 3346219007, 'US', 'USA', 'الولايات المتحدة'),
(80135, 3346268160, 3346269695, 'US', 'USA', 'الولايات المتحدة'),
(80136, 3346270208, 3346282495, 'US', 'USA', 'الولايات المتحدة'),
(80137, 3346282496, 3346284543, 'PR', 'PRI', 'بورتو ريكو'),
(80138, 3346333696, 3346471423, 'US', 'USA', 'الولايات المتحدة'),
(80139, 3346471936, 3346481151, 'US', 'USA', 'الولايات المتحدة'),
(80140, 3346530304, 3346545151, 'US', 'USA', 'الولايات المتحدة'),
(80141, 3346545664, 3346578431, 'US', 'USA', 'الولايات المتحدة'),
(80142, 3346578688, 3346583807, 'US', 'USA', 'الولايات المتحدة'),
(80143, 3346584064, 3346595583, 'US', 'USA', 'الولايات المتحدة'),
(80144, 3346595840, 3346660863, 'US', 'USA', 'الولايات المتحدة'),
(80145, 3346661376, 3346662143, 'US', 'USA', 'الولايات المتحدة'),
(80146, 3346662400, 3346663167, 'US', 'USA', 'الولايات المتحدة'),
(80147, 3346663424, 3346690047, 'US', 'USA', 'الولايات المتحدة'),
(80148, 3346694144, 3346726911, 'US', 'USA', 'الولايات المتحدة'),
(80149, 3346727936, 3346730239, 'US', 'USA', 'الولايات المتحدة'),
(80150, 3346731008, 3346734591, 'US', 'USA', 'الولايات المتحدة'),
(80151, 3346735104, 3346793215, 'US', 'USA', 'الولايات المتحدة'),
(80152, 3346793472, 3346793983, 'US', 'USA', 'الولايات المتحدة'),
(80153, 3346794496, 3346798847, 'US', 'USA', 'الولايات المتحدة'),
(80154, 3346799616, 3346807039, 'US', 'USA', 'الولايات المتحدة'),
(80155, 3346807808, 3346861823, 'US', 'USA', 'الولايات المتحدة'),
(80156, 3346862080, 3346923519, 'US', 'USA', 'الولايات المتحدة'),
(80157, 3346923520, 3346989055, 'CA', 'CAN', 'كندا'),
(80158, 3346989056, 3346996991, 'US', 'USA', 'الولايات المتحدة'),
(80159, 3346997248, 3346999807, 'US', 'USA', 'الولايات المتحدة'),
(80160, 3347000320, 3347001343, 'US', 'USA', 'الولايات المتحدة'),
(80161, 3347054592, 3349446911, 'US', 'USA', 'الولايات المتحدة'),
(80162, 3349446912, 3349447167, 'CA', 'CAN', 'كندا'),
(80163, 3349447168, 3349450495, 'US', 'USA', 'الولايات المتحدة'),
(80164, 3349450752, 3349461503, 'US', 'USA', 'الولايات المتحدة'),
(80165, 3349461760, 3349462783, 'US', 'USA', 'الولايات المتحدة'),
(80166, 3349463296, 3349479167, 'US', 'USA', 'الولايات المتحدة'),
(80167, 3349479424, 3349533695, 'US', 'USA', 'الولايات المتحدة'),
(80168, 3349533952, 3349544703, 'US', 'USA', 'الولايات المتحدة'),
(80169, 3349545216, 3349545727, 'CA', 'CAN', 'كندا'),
(80170, 3349545984, 3349549567, 'CA', 'CAN', 'كندا'),
(80171, 3349550080, 3349551103, 'CA', 'CAN', 'كندا'),
(80172, 3349551104, 3349553663, 'US', 'USA', 'الولايات المتحدة'),
(80173, 3349553664, 3349607423, 'CA', 'CAN', 'كندا'),
(80174, 3349607936, 3349608447, 'CA', 'CAN', 'كندا'),
(80175, 3349608448, 3349609215, 'US', 'USA', 'الولايات المتحدة'),
(80176, 3349609216, 3349610239, 'CA', 'CAN', 'كندا'),
(80177, 3349610496, 3349614591, 'US', 'USA', 'الولايات المتحدة'),
(80178, 3349676032, 3349678591, 'US', 'USA', 'الولايات المتحدة'),
(80179, 3349679104, 3349682431, 'US', 'USA', 'الولايات المتحدة'),
(80180, 3349683200, 3349686527, 'US', 'USA', 'الولايات المتحدة'),
(80181, 3349687296, 3349688319, 'US', 'USA', 'الولايات المتحدة'),
(80182, 3349741568, 3349987327, 'US', 'USA', 'الولايات المتحدة'),
(80183, 3349987328, 3349996543, 'BM', 'BMU', 'برمودا'),
(80184, 3349996544, 3349997055, 'KY', 'CYM', 'جزر كايمان'),
(80185, 3349997056, 3350003711, 'BM', 'BMU', 'برمودا'),
(80186, 3350003712, 3350134783, 'US', 'USA', 'الولايات المتحدة'),
(80187, 3350135040, 3350145791, 'CA', 'CAN', 'كندا'),
(80188, 3350146048, 3350147071, 'US', 'USA', 'الولايات المتحدة'),
(80189, 3350151168, 3350160639, 'CA', 'CAN', 'كندا'),
(80190, 3350160896, 3350175743, 'CA', 'CAN', 'كندا'),
(80191, 3350176512, 3350181887, 'CA', 'CAN', 'كندا'),
(80192, 3350181888, 3350182911, 'US', 'USA', 'الولايات المتحدة'),
(80193, 3350183168, 3350200063, 'CA', 'CAN', 'كندا'),
(80194, 3350200320, 3350466303, 'US', 'USA', 'الولايات المتحدة'),
(80195, 3350466560, 3350469119, 'US', 'USA', 'الولايات المتحدة'),
(80196, 3350469632, 3350470655, 'CA', 'CAN', 'كندا'),
(80197, 3350470656, 3350475775, 'US', 'USA', 'الولايات المتحدة'),
(80198, 3350475776, 3350476799, 'CA', 'CAN', 'كندا'),
(80199, 3350476800, 3350478847, 'US', 'USA', 'الولايات المتحدة'),
(80200, 3350528000, 3350545151, 'US', 'USA', 'الولايات المتحدة'),
(80201, 3350545408, 3350548735, 'US', 'USA', 'الولايات المتحدة'),
(80202, 3350549248, 3350552575, 'US', 'USA', 'الولايات المتحدة'),
(80203, 3350552832, 3350565887, 'US', 'USA', 'الولايات المتحدة'),
(80204, 3350566144, 3350574591, 'US', 'USA', 'الولايات المتحدة'),
(80205, 3350575104, 3350577151, 'US', 'USA', 'الولايات المتحدة'),
(80206, 3350577664, 3350588927, 'US', 'USA', 'الولايات المتحدة'),
(80207, 3350589696, 3350591231, 'US', 'USA', 'الولايات المتحدة'),
(80208, 3350591488, 3350593279, 'US', 'USA', 'الولايات المتحدة'),
(80209, 3350614016, 3350618111, 'US', 'USA', 'الولايات المتحدة'),
(80210, 3350630400, 3350634495, 'US', 'USA', 'الولايات المتحدة'),
(80211, 3350654976, 3350728191, 'US', 'USA', 'الولايات المتحدة'),
(80212, 3350728704, 3350746367, 'US', 'USA', 'الولايات المتحدة'),
(80213, 3350746624, 3350756607, 'US', 'USA', 'الولايات المتحدة'),
(80214, 3350757376, 3350760959, 'US', 'USA', 'الولايات المتحدة'),
(80215, 3350766080, 3350771967, 'US', 'USA', 'الولايات المتحدة'),
(80216, 3350772224, 3350774271, 'US', 'USA', 'الولايات المتحدة'),
(80217, 3350774528, 3350778623, 'US', 'USA', 'الولايات المتحدة'),
(80218, 3350778880, 3350789887, 'US', 'USA', 'الولايات المتحدة'),
(80219, 3350790400, 3350814975, 'CA', 'CAN', 'كندا'),
(80220, 3350815232, 3350823423, 'CA', 'CAN', 'كندا'),
(80221, 3350823936, 3350825727, 'CA', 'CAN', 'كندا'),
(80222, 3350825728, 3350825983, 'GB', 'GBR', 'المملكة المتحدة'),
(80223, 3350825984, 3350834687, 'CA', 'CAN', 'كندا'),
(80224, 3350835200, 3350836223, 'CA', 'CAN', 'كندا'),
(80225, 3350836992, 3350837247, 'CA', 'CAN', 'كندا'),
(80226, 3350837760, 3350843391, 'CA', 'CAN', 'كندا'),
(80227, 3350843648, 3350855679, 'CA', 'CAN', 'كندا'),
(80228, 3350855680, 3350862079, 'US', 'USA', 'الولايات المتحدة'),
(80229, 3350862080, 3350864639, 'CL', 'CHL', 'تشيلي'),
(80230, 3350864640, 3350925055, 'US', 'USA', 'الولايات المتحدة'),
(80231, 3350925312, 3350950399, 'US', 'USA', 'الولايات المتحدة'),
(80232, 3350950912, 3350953983, 'US', 'USA', 'الولايات المتحدة'),
(80233, 3350986752, 3350988031, 'US', 'USA', 'الولايات المتحدة'),
(80234, 3350988800, 3350990335, 'US', 'USA', 'الولايات المتحدة'),
(80235, 3350990848, 3350999039, 'US', 'USA', 'الولايات المتحدة'),
(80236, 3351052288, 3351053823, 'US', 'USA', 'الولايات المتحدة'),
(80237, 3351054336, 3351058943, 'US', 'USA', 'الولايات المتحدة'),
(80238, 3351060480, 3351068159, 'US', 'USA', 'الولايات المتحدة'),
(80239, 3351117824, 3351129087, 'US', 'USA', 'الولايات المتحدة'),
(80240, 3351134208, 3351151359, 'US', 'USA', 'الولايات المتحدة'),
(80241, 3351151616, 3351151871, 'US', 'USA', 'الولايات المتحدة'),
(80242, 3351152128, 3351158527, 'US', 'USA', 'الولايات المتحدة'),
(80243, 3351158784, 3351159295, 'US', 'USA', 'الولايات المتحدة'),
(80244, 3351159552, 3351160063, 'US', 'USA', 'الولايات المتحدة'),
(80245, 3351160320, 3351160575, 'US', 'USA', 'الولايات المتحدة'),
(80246, 3351161088, 3351167487, 'US', 'USA', 'الولايات المتحدة'),
(80247, 3351168512, 3351183103, 'US', 'USA', 'الولايات المتحدة'),
(80248, 3351183360, 3351212031, 'US', 'USA', 'الولايات المتحدة'),
(80249, 3351216128, 3351251967, 'US', 'USA', 'الولايات المتحدة'),
(80250, 3351252992, 3351265279, 'US', 'USA', 'الولايات المتحدة'),
(80251, 3351314432, 3351315967, 'US', 'USA', 'الولايات المتحدة'),
(80252, 3351316480, 3351318015, 'US', 'USA', 'الولايات المتحدة'),
(80253, 3351318528, 3351322367, 'US', 'USA', 'الولايات المتحدة'),
(80254, 3351322624, 3351326719, 'US', 'USA', 'الولايات المتحدة'),
(80255, 3351379968, 3351446783, 'US', 'USA', 'الولايات المتحدة'),
(80256, 3351447552, 3351448831, 'US', 'USA', 'الولايات المتحدة'),
(80257, 3351449600, 3351458815, 'US', 'USA', 'الولايات المتحدة'),
(80258, 3351459840, 3351474687, 'US', 'USA', 'الولايات المتحدة'),
(80259, 3351476224, 3351478271, 'US', 'USA', 'الولايات المتحدة'),
(80260, 3351511040, 3351512319, 'US', 'USA', 'الولايات المتحدة'),
(80261, 3351513088, 3351579135, 'US', 'USA', 'الولايات المتحدة'),
(80262, 3351580672, 3351642111, 'US', 'USA', 'الولايات المتحدة'),
(80263, 3351642112, 3351695871, 'CA', 'CAN', 'كندا'),
(80264, 3351696384, 3351696639, 'CA', 'CAN', 'كندا'),
(80265, 3351697408, 3351698431, 'CA', 'CAN', 'كندا'),
(80266, 3351698432, 3351707391, 'US', 'USA', 'الولايات المتحدة'),
(80267, 3351707648, 3351774463, 'US', 'USA', 'الولايات المتحدة'),
(80268, 3351775232, 3351776767, 'US', 'USA', 'الولايات المتحدة'),
(80269, 3351777280, 3351780351, 'US', 'USA', 'الولايات المتحدة'),
(80270, 3351781376, 3351785471, 'US', 'USA', 'الولايات المتحدة'),
(80271, 3351789568, 3351797759, 'US', 'USA', 'الولايات المتحدة'),
(80272, 3351805952, 3351855103, 'US', 'USA', 'الولايات المتحدة'),
(80273, 3351871488, 3351894015, 'US', 'USA', 'الولايات المتحدة'),
(80274, 3351894272, 3351895295, 'US', 'USA', 'الولايات المتحدة'),
(80275, 3351895808, 3351896319, 'US', 'USA', 'الولايات المتحدة'),
(80276, 3351896576, 3351900671, 'US', 'USA', 'الولايات المتحدة'),
(80277, 3351900928, 3351903999, 'US', 'USA', 'الولايات المتحدة'),
(80278, 3351912448, 3351927551, 'CA', 'CAN', 'كندا'),
(80279, 3351927552, 3351927807, 'US', 'USA', 'الولايات المتحدة'),
(80280, 3351927808, 3351959551, 'CA', 'CAN', 'كندا'),
(80281, 3351961600, 3351963647, 'CA', 'CAN', 'كندا'),
(80282, 3351964160, 3351969791, 'CA', 'CAN', 'كندا'),
(80283, 3351969792, 3351971839, 'US', 'USA', 'الولايات المتحدة'),
(80284, 3351971840, 3351972095, 'IL', 'ISR', 'إسرائيل'),
(80285, 3351972096, 3351972863, 'US', 'USA', 'الولايات المتحدة'),
(80286, 3351972864, 3351973119, 'IL', 'ISR', 'إسرائيل'),
(80287, 3351973120, 3351975935, 'US', 'USA', 'الولايات المتحدة'),
(80288, 3351975936, 3351976447, 'IL', 'ISR', 'إسرائيل'),
(80289, 3351976448, 3351976703, 'US', 'USA', 'الولايات المتحدة'),
(80290, 3351976704, 3351976959, 'IL', 'ISR', 'إسرائيل'),
(80291, 3351976960, 3351979519, 'US', 'USA', 'الولايات المتحدة'),
(80292, 3351979520, 3351979583, 'IL', 'ISR', 'إسرائيل'),
(80293, 3351979584, 3351986943, 'US', 'USA', 'الولايات المتحدة'),
(80294, 3351986944, 3351987199, 'IL', 'ISR', 'إسرائيل'),
(80295, 3351987200, 3351995647, 'US', 'USA', 'الولايات المتحدة'),
(80296, 3351995648, 3351995903, 'IL', 'ISR', 'إسرائيل'),
(80297, 3351995904, 3351996927, 'US', 'USA', 'الولايات المتحدة'),
(80298, 3351996928, 3351997439, 'IL', 'ISR', 'إسرائيل'),
(80299, 3351997440, 3352004351, 'US', 'USA', 'الولايات المتحدة'),
(80300, 3352004352, 3352004607, 'IL', 'ISR', 'إسرائيل'),
(80301, 3352004608, 3352005887, 'US', 'USA', 'الولايات المتحدة'),
(80302, 3352005888, 3352006143, 'IL', 'ISR', 'إسرائيل'),
(80303, 3352006144, 3352006399, 'US', 'USA', 'الولايات المتحدة'),
(80304, 3352006400, 3352006527, 'IL', 'ISR', 'إسرائيل'),
(80305, 3352006528, 3352006591, 'US', 'USA', 'الولايات المتحدة'),
(80306, 3352006592, 3352006655, 'IL', 'ISR', 'إسرائيل'),
(80307, 3352006656, 3352007391, 'US', 'USA', 'الولايات المتحدة'),
(80308, 3352007392, 3352007423, 'IL', 'ISR', 'إسرائيل'),
(80309, 3352007424, 3352007583, 'US', 'USA', 'الولايات المتحدة'),
(80310, 3352007584, 3352007679, 'IL', 'ISR', 'إسرائيل'),
(80311, 3352007680, 3352007967, 'US', 'USA', 'الولايات المتحدة'),
(80312, 3352007968, 3352008063, 'IL', 'ISR', 'إسرائيل'),
(80313, 3352008064, 3352009311, 'US', 'USA', 'الولايات المتحدة'),
(80314, 3352009312, 3352009343, 'IL', 'ISR', 'إسرائيل'),
(80315, 3352009344, 3352010815, 'US', 'USA', 'الولايات المتحدة'),
(80316, 3352010816, 3352010879, 'IL', 'ISR', 'إسرائيل'),
(80317, 3352010880, 3352011199, 'US', 'USA', 'الولايات المتحدة'),
(80318, 3352011200, 3352011263, 'IL', 'ISR', 'إسرائيل'),
(80319, 3352011264, 3352014719, 'US', 'USA', 'الولايات المتحدة'),
(80320, 3352014720, 3352014847, 'IL', 'ISR', 'إسرائيل'),
(80321, 3352014848, 3352014927, 'US', 'USA', 'الولايات المتحدة'),
(80322, 3352014928, 3352014943, 'IL', 'ISR', 'إسرائيل'),
(80323, 3352014944, 3352015999, 'US', 'USA', 'الولايات المتحدة'),
(80324, 3352016000, 3352016127, 'IL', 'ISR', 'إسرائيل'),
(80325, 3352016128, 3352020671, 'US', 'USA', 'الولايات المتحدة'),
(80326, 3352020672, 3352020703, 'IL', 'ISR', 'إسرائيل'),
(80327, 3352020704, 3352023039, 'US', 'USA', 'الولايات المتحدة'),
(80328, 3352023040, 3352023167, 'IL', 'ISR', 'إسرائيل'),
(80329, 3352023168, 3352023343, 'US', 'USA', 'الولايات المتحدة'),
(80330, 3352023344, 3352023359, 'IL', 'ISR', 'إسرائيل'),
(80331, 3352023360, 3352023679, 'US', 'USA', 'الولايات المتحدة'),
(80332, 3352023680, 3352023807, 'IL', 'ISR', 'إسرائيل'),
(80333, 3352023808, 3352024319, 'US', 'USA', 'الولايات المتحدة'),
(80334, 3352024320, 3352024447, 'IL', 'ISR', 'إسرائيل'),
(80335, 3352024448, 3352025087, 'US', 'USA', 'الولايات المتحدة'),
(80336, 3352025088, 3352025215, 'IL', 'ISR', 'إسرائيل'),
(80337, 3352025216, 3352026623, 'US', 'USA', 'الولايات المتحدة'),
(80338, 3352026624, 3352026751, 'IL', 'ISR', 'إسرائيل'),
(80339, 3352026752, 3352027295, 'US', 'USA', 'الولايات المتحدة'),
(80340, 3352027296, 3352027327, 'IL', 'ISR', 'إسرائيل'),
(80341, 3352027328, 3352028799, 'US', 'USA', 'الولايات المتحدة'),
(80342, 3352028800, 3352028927, 'IL', 'ISR', 'إسرائيل'),
(80343, 3352028928, 3352030047, 'US', 'USA', 'الولايات المتحدة'),
(80344, 3352030048, 3352030079, 'IL', 'ISR', 'إسرائيل'),
(80345, 3352030080, 3352030143, 'US', 'USA', 'الولايات المتحدة'),
(80346, 3352030144, 3352030175, 'IL', 'ISR', 'إسرائيل'),
(80347, 3352030176, 3352030383, 'US', 'USA', 'الولايات المتحدة'),
(80348, 3352030384, 3352030399, 'IL', 'ISR', 'إسرائيل'),
(80349, 3352030400, 3352032719, 'US', 'USA', 'الولايات المتحدة'),
(80350, 3352032720, 3352032735, 'IL', 'ISR', 'إسرائيل'),
(80351, 3352032736, 3352034303, 'US', 'USA', 'الولايات المتحدة'),
(80352, 3352034304, 3352034815, 'IL', 'ISR', 'إسرائيل'),
(80353, 3352034816, 3352035327, 'US', 'USA', 'الولايات المتحدة'),
(80354, 3352035328, 3352036351, 'CA', 'CAN', 'كندا'),
(80355, 3352036352, 3352046591, 'US', 'USA', 'الولايات المتحدة'),
(80356, 3352046592, 3352049663, 'CA', 'CAN', 'كندا'),
(80357, 3352049664, 3352051711, 'US', 'USA', 'الولايات المتحدة'),
(80358, 3352051712, 3352055807, 'CA', 'CAN', 'كندا'),
(80359, 3352055808, 3352061951, 'US', 'USA', 'الولايات المتحدة'),
(80360, 3352100864, 3352559871, 'US', 'USA', 'الولايات المتحدة'),
(80361, 3352559872, 3352563199, 'CA', 'CAN', 'كندا'),
(80362, 3352563456, 3352570111, 'CA', 'CAN', 'كندا'),
(80363, 3352570368, 3352573951, 'CA', 'CAN', 'كندا'),
(80364, 3352574208, 3352581631, 'CA', 'CAN', 'كندا'),
(80365, 3352582144, 3352583935, 'CA', 'CAN', 'كندا'),
(80366, 3352584192, 3352591359, 'CA', 'CAN', 'كندا'),
(80367, 3352591616, 3352615423, 'CA', 'CAN', 'كندا'),
(80368, 3352615424, 3352616959, 'US', 'USA', 'الولايات المتحدة'),
(80369, 3352616960, 3352624895, 'CA', 'CAN', 'كندا'),
(80370, 3352625152, 3352887295, 'CA', 'CAN', 'كندا'),
(80371, 3352887296, 3352911871, 'US', 'USA', 'الولايات المتحدة'),
(80372, 3352920064, 3353309695, 'US', 'USA', 'الولايات المتحدة'),
(80373, 3353311232, 3353333759, 'US', 'USA', 'الولايات المتحدة'),
(80374, 3353346048, 3353729023, 'US', 'USA', 'الولايات المتحدة'),
(80375, 3353729024, 3353729279, 'HK', 'HKG', 'هونغ كونغ'),
(80376, 3353729280, 3353730047, 'US', 'USA', 'الولايات المتحدة'),
(80377, 3353739264, 3353741823, 'US', 'USA', 'الولايات المتحدة'),
(80378, 3353743360, 3353746943, 'US', 'USA', 'الولايات المتحدة'),
(80379, 3353747456, 3353752575, 'US', 'USA', 'الولايات المتحدة'),
(80380, 3353753600, 3353767935, 'US', 'USA', 'الولايات المتحدة'),
(80381, 3353772032, 3353806335, 'US', 'USA', 'الولايات المتحدة'),
(80382, 3353806848, 3353818111, 'US', 'USA', 'الولايات المتحدة'),
(80383, 3353819136, 3353821183, 'US', 'USA', 'الولايات المتحدة'),
(80384, 3353837568, 3353843455, 'US', 'USA', 'الولايات المتحدة'),
(80385, 3353843712, 3353845759, 'US', 'USA', 'الولايات المتحدة'),
(80386, 3353870336, 3353939455, 'US', 'USA', 'الولايات المتحدة'),
(80387, 3353939968, 3353942527, 'US', 'USA', 'الولايات المتحدة'),
(80388, 3353944064, 3353948159, 'US', 'USA', 'الولايات المتحدة'),
(80389, 3353952256, 3353953279, 'US', 'USA', 'الولايات المتحدة'),
(80390, 3353953536, 3353959423, 'US', 'USA', 'الولايات المتحدة'),
(80391, 3353959680, 3353960191, 'US', 'USA', 'الولايات المتحدة'),
(80392, 3353960448, 3353966079, 'US', 'USA', 'الولايات المتحدة'),
(80393, 3353966336, 3353967871, 'US', 'USA', 'الولايات المتحدة'),
(80394, 3353968128, 3353969663, 'US', 'USA', 'الولايات المتحدة'),
(80395, 3353969920, 3353977343, 'US', 'USA', 'الولايات المتحدة'),
(80396, 3353977600, 3353979647, 'US', 'USA', 'الولايات المتحدة'),
(80397, 3353979648, 3353979903, 'CA', 'CAN', 'كندا'),
(80398, 3353979904, 3353982719, 'US', 'USA', 'الولايات المتحدة'),
(80399, 3353982720, 3353983231, 'CA', 'CAN', 'كندا'),
(80400, 3353983232, 3353985023, 'US', 'USA', 'الولايات المتحدة'),
(80401, 3353985280, 3353987583, 'US', 'USA', 'الولايات المتحدة'),
(80402, 3353988352, 3353991679, 'US', 'USA', 'الولايات المتحدة'),
(80403, 3354001408, 3354066943, 'US', 'USA', 'الولايات المتحدة'),
(80404, 3354066944, 3354132479, 'CA', 'CAN', 'كندا'),
(80405, 3354132480, 3354463743, 'US', 'USA', 'الولايات المتحدة'),
(80406, 3354464256, 3354466815, 'US', 'USA', 'الولايات المتحدة'),
(80407, 3354468352, 3354476031, 'US', 'USA', 'الولايات المتحدة'),
(80408, 3354476544, 3354484735, 'US', 'USA', 'الولايات المتحدة'),
(80409, 3354525696, 3354532351, 'US', 'USA', 'الولايات المتحدة'),
(80410, 3354533888, 3354560255, 'US', 'USA', 'الولايات المتحدة'),
(80411, 3354560512, 3354562559, 'US', 'USA', 'الولايات المتحدة'),
(80412, 3354562816, 3354568703, 'US', 'USA', 'الولايات المتحدة'),
(80413, 3354568960, 3354570239, 'US', 'USA', 'الولايات المتحدة'),
(80414, 3354570496, 3354582527, 'US', 'USA', 'الولايات المتحدة'),
(80415, 3354582784, 3354588415, 'US', 'USA', 'الولايات المتحدة'),
(80416, 3354588672, 3354590975, 'US', 'USA', 'الولايات المتحدة'),
(80417, 3354591232, 3354656767, 'CA', 'CAN', 'كندا'),
(80418, 3354656768, 3354660351, 'US', 'USA', 'الولايات المتحدة'),
(80419, 3354660864, 3354663423, 'US', 'USA', 'الولايات المتحدة'),
(80420, 3354664960, 3354670079, 'US', 'USA', 'الولايات المتحدة'),
(80421, 3354671104, 3354673151, 'US', 'USA', 'الولايات المتحدة'),
(80422, 3354689536, 3354707455, 'US', 'USA', 'الولايات المتحدة'),
(80423, 3354709248, 3354720511, 'US', 'USA', 'الولايات المتحدة'),
(80424, 3354722304, 3354735615, 'US', 'USA', 'الولايات المتحدة'),
(80425, 3354738688, 3354747391, 'US', 'USA', 'الولايات المتحدة'),
(80426, 3354748416, 3354751999, 'US', 'USA', 'الولايات المتحدة'),
(80427, 3354752256, 3354758399, 'US', 'USA', 'الولايات المتحدة'),
(80428, 3354759424, 3354767359, 'US', 'USA', 'الولايات المتحدة'),
(80429, 3354767616, 3354770687, 'US', 'USA', 'الولايات المتحدة'),
(80430, 3354770944, 3354775551, 'US', 'USA', 'الولايات المتحدة'),
(80431, 3354776064, 3354782719, 'US', 'USA', 'الولايات المتحدة'),
(80432, 3354782720, 3354782975, 'CA', 'CAN', 'كندا'),
(80433, 3354782976, 3354787071, 'US', 'USA', 'الولايات المتحدة'),
(80434, 3354787328, 3354787583, 'US', 'USA', 'الولايات المتحدة'),
(80435, 3354788096, 3354807551, 'CA', 'CAN', 'كندا'),
(80436, 3354807552, 3354810367, 'US', 'USA', 'الولايات المتحدة'),
(80437, 3354810368, 3354814975, 'CA', 'CAN', 'كندا'),
(80438, 3354814976, 3354815231, 'US', 'USA', 'الولايات المتحدة'),
(80439, 3354815232, 3354817535, 'CA', 'CAN', 'كندا'),
(80440, 3354817792, 3354823423, 'CA', 'CAN', 'كندا'),
(80441, 3354823680, 3354830847, 'CA', 'CAN', 'كندا'),
(80442, 3354831360, 3354853119, 'CA', 'CAN', 'كندا'),
(80443, 3354853376, 3354918911, 'CA', 'CAN', 'كندا'),
(80444, 3354918912, 3354920447, 'US', 'USA', 'الولايات المتحدة'),
(80445, 3354920960, 3354926847, 'US', 'USA', 'الولايات المتحدة'),
(80446, 3354927104, 3354934783, 'US', 'USA', 'الولايات المتحدة'),
(80447, 3354935296, 3354955775, 'US', 'USA', 'الولايات المتحدة'),
(80448, 3354955776, 3354956031, 'AR', 'ARG', 'الأرجنتين'),
(80449, 3354956032, 3354967295, 'US', 'USA', 'الولايات المتحدة'),
(80450, 3354967552, 3354969855, 'US', 'USA', 'الولايات المتحدة'),
(80451, 3354970112, 3354972159, 'US', 'USA', 'الولايات المتحدة'),
(80452, 3354972416, 3354978303, 'US', 'USA', 'الولايات المتحدة'),
(80453, 3354978560, 3354988031, 'US', 'USA', 'الولايات المتحدة'),
(80454, 3354988544, 3355012351, 'US', 'USA', 'الولايات المتحدة'),
(80455, 3355013120, 3355017215, 'CA', 'CAN', 'كندا'),
(80456, 3355017216, 3355025919, 'US', 'USA', 'الولايات المتحدة'),
(80457, 3355026176, 3355032063, 'US', 'USA', 'الولايات المتحدة'),
(80458, 3355032320, 3355043583, 'US', 'USA', 'الولايات المتحدة'),
(80459, 3355045120, 3355049727, 'US', 'USA', 'الولايات المتحدة'),
(80460, 3355049984, 3355052287, 'US', 'USA', 'الولايات المتحدة'),
(80461, 3355052288, 3355053311, 'CA', 'CAN', 'كندا'),
(80462, 3355053312, 3355053567, 'US', 'USA', 'الولايات المتحدة'),
(80463, 3355054080, 3355065343, 'US', 'USA', 'الولايات المتحدة'),
(80464, 3355066368, 3355249151, 'US', 'USA', 'الولايات المتحدة'),
(80465, 3355250688, 3355253247, 'US', 'USA', 'الولايات المتحدة'),
(80466, 3355254784, 3355260927, 'US', 'USA', 'الولايات المتحدة'),
(80467, 3355260928, 3355262719, 'CA', 'CAN', 'كندا'),
(80468, 3355262976, 3355292927, 'US', 'USA', 'الولايات المتحدة'),
(80469, 3355293184, 3355310335, 'US', 'USA', 'الولايات المتحدة'),
(80470, 3355310592, 3355311103, 'CA', 'CAN', 'كندا'),
(80471, 3355312128, 3355319295, 'US', 'USA', 'الولايات المتحدة'),
(80472, 3355319296, 3355320319, 'CA', 'CAN', 'كندا'),
(80473, 3355320320, 3355324415, 'US', 'USA', 'الولايات المتحدة'),
(80474, 3355324416, 3355328511, 'CA', 'CAN', 'كندا'),
(80475, 3355328512, 3355336703, 'US', 'USA', 'الولايات المتحدة'),
(80476, 3355344896, 3355350271, 'US', 'USA', 'الولايات المتحدة'),
(80477, 3355350528, 3355351039, 'US', 'USA', 'الولايات المتحدة'),
(80478, 3355351040, 3355351295, 'CA', 'CAN', 'كندا'),
(80479, 3355351296, 3355372287, 'US', 'USA', 'الولايات المتحدة'),
(80480, 3355372288, 3355372543, 'CA', 'CAN', 'كندا'),
(80481, 3355372544, 3355377663, 'US', 'USA', 'الولايات المتحدة'),
(80482, 3355443200, 3355445247, 'CO', 'COL', 'كولومبيا'),
(80483, 3355445248, 3355447295, 'BR', 'BRA', 'البرازيل'),
(80484, 3355447296, 3355447551, 'CU', 'CUB', 'كوبا'),
(80485, 3355447552, 3355447807, 'AR', 'ARG', 'الأرجنتين'),
(80486, 3355447808, 3355448063, 'HT', 'HTI', 'هايتي'),
(80487, 3355448320, 3355449343, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80488, 3355449344, 3355450367, 'CU', 'CUB', 'كوبا'),
(80489, 3355450368, 3355451391, 'EC', 'ECU', 'الإكوادور'),
(80490, 3355451392, 3355459071, 'BR', 'BRA', 'البرازيل'),
(80491, 3355459328, 3355459583, 'EC', 'ECU', 'الإكوادور'),
(80492, 3355459584, 3355459839, 'PA', 'PAN', 'بنما'),
(80493, 3355459840, 3355460095, 'VE', 'VEN', 'فنزويلا'),
(80494, 3355460096, 3355460351, 'CL', 'CHL', 'تشيلي'),
(80495, 3355460352, 3355461887, 'BR', 'BRA', 'البرازيل'),
(80496, 3355461888, 3355463423, 'EC', 'ECU', 'الإكوادور'),
(80497, 3355463424, 3355463935, 'AR', 'ARG', 'الأرجنتين'),
(80498, 3355463936, 3355464191, 'BR', 'BRA', 'البرازيل'),
(80499, 3355464192, 3355464447, 'CL', 'CHL', 'تشيلي'),
(80500, 3355464448, 3355464959, 'MX', 'MEX', 'المكسيك'),
(80501, 3355464960, 3355465727, 'BR', 'BRA', 'البرازيل'),
(80502, 3355465728, 3355465983, 'UY', 'URY', 'الأوروغواي'),
(80503, 3355465984, 3355467263, 'BR', 'BRA', 'البرازيل'),
(80504, 3355467264, 3355467519, 'US', 'USA', 'الولايات المتحدة'),
(80505, 3355467520, 3355467775, 'MX', 'MEX', 'المكسيك'),
(80506, 3355467776, 3355468799, 'AR', 'ARG', 'الأرجنتين'),
(80507, 3355468800, 3355469567, 'BR', 'BRA', 'البرازيل'),
(80508, 3355469568, 3355470591, 'MX', 'MEX', 'المكسيك'),
(80509, 3355470592, 3355470847, 'PE', 'PER', 'بيرو'),
(80510, 3355470848, 3355471103, 'CL', 'CHL', 'تشيلي'),
(80511, 3355471104, 3355471359, 'MX', 'MEX', 'المكسيك'),
(80512, 3355471360, 3355471615, 'PE', 'PER', 'بيرو'),
(80513, 3355471616, 3355472383, 'MX', 'MEX', 'المكسيك'),
(80514, 3355472384, 3355472639, 'BR', 'BRA', 'البرازيل'),
(80515, 3355472640, 3355473407, 'CL', 'CHL', 'تشيلي'),
(80516, 3355473408, 3355473919, 'PE', 'PER', 'بيرو'),
(80517, 3355473920, 3355475199, 'CL', 'CHL', 'تشيلي'),
(80518, 3355475200, 3355477503, 'MX', 'MEX', 'المكسيك'),
(80519, 3355478016, 3355478271, 'PE', 'PER', 'بيرو'),
(80520, 3355478272, 3355478783, 'US', 'USA', 'الولايات المتحدة'),
(80521, 3355478784, 3355479039, 'VE', 'VEN', 'فنزويلا'),
(80522, 3355479040, 3355479551, 'CL', 'CHL', 'تشيلي'),
(80523, 3355479552, 3355479807, 'PE', 'PER', 'بيرو'),
(80524, 3355479808, 3355480063, 'MX', 'MEX', 'المكسيك'),
(80525, 3355480064, 3355485183, 'CL', 'CHL', 'تشيلي'),
(80526, 3355485184, 3355487743, 'PE', 'PER', 'بيرو'),
(80527, 3355487744, 3355487999, 'CL', 'CHL', 'تشيلي'),
(80528, 3355488000, 3355488255, 'AR', 'ARG', 'الأرجنتين'),
(80529, 3355488256, 3355488767, 'GT', 'GTM', 'غواتيمالا'),
(80530, 3355488768, 3355489023, 'PA', 'PAN', 'بنما'),
(80531, 3355489024, 3355489279, 'CR', 'CRI', 'كوستا ريكا'),
(80532, 3355489280, 3355489535, 'SV', 'SLV', 'السلفادور'),
(80533, 3355489536, 3355491071, 'AR', 'ARG', 'الأرجنتين'),
(80534, 3355491072, 3355491327, 'CO', 'COL', 'كولومبيا'),
(80535, 3355491328, 3355494655, 'AR', 'ARG', 'الأرجنتين'),
(80536, 3355494656, 3355494911, 'CO', 'COL', 'كولومبيا'),
(80537, 3355494912, 3355495423, 'PA', 'PAN', 'بنما'),
(80538, 3355495424, 3355496447, 'UY', 'URY', 'الأوروغواي'),
(80539, 3355496448, 3355498495, 'AR', 'ARG', 'الأرجنتين'),
(80540, 3355498496, 3355500543, 'US', 'USA', 'الولايات المتحدة'),
(80541, 3355500544, 3355508735, 'AR', 'ARG', 'الأرجنتين'),
(80542, 3355508736, 3355510271, 'VE', 'VEN', 'فنزويلا'),
(80543, 3355510272, 3355510527, 'EC', 'ECU', 'الإكوادور'),
(80544, 3355510528, 3355510783, 'AR', 'ARG', 'الأرجنتين'),
(80545, 3355510784, 3355512831, 'VE', 'VEN', 'فنزويلا'),
(80546, 3355512832, 3355516927, 'CL', 'CHL', 'تشيلي'),
(80547, 3355516928, 3355525119, 'AR', 'ARG', 'الأرجنتين'),
(80548, 3355525120, 3355535359, 'CO', 'COL', 'كولومبيا'),
(80549, 3355535360, 3355537407, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(80550, 3355537664, 3355537919, 'AR', 'ARG', 'الأرجنتين'),
(80551, 3355537920, 3355538175, 'NI', 'NIC', 'نيكاراغوا'),
(80552, 3355538176, 3355538431, 'CL', 'CHL', 'تشيلي'),
(80553, 3355538432, 3355539199, 'AR', 'ARG', 'الأرجنتين'),
(80554, 3355539200, 3355539455, 'VE', 'VEN', 'فنزويلا'),
(80555, 3355539456, 3355540479, 'CL', 'CHL', 'تشيلي'),
(80556, 3355540480, 3355540735, 'CO', 'COL', 'كولومبيا'),
(80557, 3355540736, 3355540991, 'BZ', 'BLZ', 'بليز'),
(80558, 3355540992, 3355541503, 'CO', 'COL', 'كولومبيا'),
(80559, 3355541504, 3355545599, 'CL', 'CHL', 'تشيلي'),
(80560, 3355545600, 3355547647, 'VE', 'VEN', 'فنزويلا'),
(80561, 3355547648, 3355547903, 'NI', 'NIC', 'نيكاراغوا'),
(80562, 3355547904, 3355548159, 'GT', 'GTM', 'غواتيمالا'),
(80563, 3355548160, 3355548671, 'DO', 'DOM', 'الدومينيكان'),
(80564, 3355548672, 3355549695, 'SR', 'SUR', 'سورينام'),
(80565, 3355549696, 3355549951, 'US', 'USA', 'الولايات المتحدة'),
(80566, 3355549952, 3355550207, 'EC', 'ECU', 'الإكوادور'),
(80567, 3355550208, 3355552767, 'VE', 'VEN', 'فنزويلا'),
(80568, 3355552768, 3355553023, 'EC', 'ECU', 'الإكوادور'),
(80569, 3355553024, 3355553279, 'CO', 'COL', 'كولومبيا'),
(80570, 3355553280, 3355553535, 'CL', 'CHL', 'تشيلي'),
(80571, 3355553536, 3355553791, 'CO', 'COL', 'كولومبيا'),
(80572, 3355553792, 3355555839, 'PE', 'PER', 'بيرو'),
(80573, 3355555840, 3355557887, 'VE', 'VEN', 'فنزويلا'),
(80574, 3355557888, 3355559935, 'CO', 'COL', 'كولومبيا'),
(80575, 3355559936, 3355561983, 'PY', 'PRY', 'باراغواي'),
(80576, 3355561984, 3355564031, 'SR', 'SUR', 'سورينام'),
(80577, 3355566080, 3355574271, 'AR', 'ARG', 'الأرجنتين'),
(80578, 3355574272, 3355576319, 'CL', 'CHL', 'تشيلي'),
(80579, 3355576320, 3355578367, 'VE', 'VEN', 'فنزويلا'),
(80580, 3355578368, 3355582463, 'CL', 'CHL', 'تشيلي'),
(80581, 3355582464, 3355590655, 'UY', 'URY', 'الأوروغواي'),
(80582, 3355590656, 3355592703, 'CO', 'COL', 'كولومبيا'),
(80583, 3355592704, 3355599871, 'CL', 'CHL', 'تشيلي'),
(80584, 3355600896, 3355604991, 'CL', 'CHL', 'تشيلي'),
(80585, 3355604992, 3355607039, 'AR', 'ARG', 'الأرجنتين'),
(80586, 3355607040, 3355615231, 'HT', 'HTI', 'هايتي'),
(80587, 3355615232, 3355623423, 'SR', 'SUR', 'سورينام'),
(80588, 3355623424, 3355639807, 'CL', 'CHL', 'تشيلي'),
(80589, 3355639808, 3355642367, 'VE', 'VEN', 'فنزويلا'),
(80590, 3355642368, 3355642879, 'PA', 'PAN', 'بنما'),
(80591, 3355642880, 3355643903, 'UY', 'URY', 'الأوروغواي'),
(80592, 3355643904, 3355647999, 'BR', 'BRA', 'البرازيل'),
(80593, 3355648000, 3355668991, 'AR', 'ARG', 'الأرجنتين'),
(80594, 3355668992, 3355669247, 'PE', 'PER', 'بيرو'),
(80595, 3355669248, 3355672575, 'AR', 'ARG', 'الأرجنتين'),
(80596, 3355672576, 3355677183, 'CO', 'COL', 'كولومبيا'),
(80597, 3355677184, 3355677439, 'GT', 'GTM', 'غواتيمالا'),
(80598, 3355677440, 3355682815, 'CO', 'COL', 'كولومبيا'),
(80599, 3355682816, 3355684863, 'AR', 'ARG', 'الأرجنتين'),
(80600, 3355684864, 3355686911, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(80601, 3355686912, 3355688959, 'AR', 'ARG', 'الأرجنتين'),
(80602, 3355688960, 3355689471, 'CO', 'COL', 'كولومبيا'),
(80603, 3355689472, 3355689727, 'HN', 'HND', 'هندوراس'),
(80604, 3355689728, 3355689983, 'AR', 'ARG', 'الأرجنتين'),
(80605, 3355689984, 3355693055, 'PA', 'PAN', 'بنما'),
(80606, 3355693056, 3355695103, 'CL', 'CHL', 'تشيلي'),
(80607, 3355695104, 3355697151, 'AR', 'ARG', 'الأرجنتين'),
(80608, 3355697152, 3355701503, 'HN', 'HND', 'هندوراس'),
(80609, 3355701504, 3355702015, 'PE', 'PER', 'بيرو'),
(80610, 3355702016, 3355702271, 'AR', 'ARG', 'الأرجنتين'),
(80611, 3355702272, 3355703295, 'CO', 'COL', 'كولومبيا'),
(80612, 3355703296, 3355705343, 'PY', 'PRY', 'باراغواي'),
(80613, 3355705344, 3355709439, 'MX', 'MEX', 'المكسيك'),
(80614, 3355709440, 3355713535, 'CO', 'COL', 'كولومبيا'),
(80615, 3355713536, 3355720447, 'MX', 'MEX', 'المكسيك'),
(80616, 3355720448, 3355720703, 'AR', 'ARG', 'الأرجنتين'),
(80617, 3355720704, 3355722751, 'MX', 'MEX', 'المكسيك'),
(80618, 3355722752, 3355723263, 'AR', 'ARG', 'الأرجنتين'),
(80619, 3355723264, 3355746303, 'MX', 'MEX', 'المكسيك'),
(80620, 3355746304, 3355754495, 'HT', 'HTI', 'هايتي'),
(80621, 3355754496, 3355770879, 'PE', 'PER', 'بيرو'),
(80622, 3355770880, 3355773183, 'US', 'USA', 'الولايات المتحدة'),
(80623, 3355773184, 3355773439, 'BR', 'BRA', 'البرازيل'),
(80624, 3355773440, 3355773695, 'AR', 'ARG', 'الأرجنتين'),
(80625, 3355773696, 3355773951, 'US', 'USA', 'الولايات المتحدة'),
(80626, 3355773952, 3355774975, 'CU', 'CUB', 'كوبا'),
(80627, 3355774976, 3355779071, 'VE', 'VEN', 'فنزويلا'),
(80628, 3355781120, 3355783167, 'VE', 'VEN', 'فنزويلا'),
(80629, 3355783168, 3355785215, 'AR', 'ARG', 'الأرجنتين'),
(80630, 3355785216, 3355787263, 'CO', 'COL', 'كولومبيا'),
(80631, 3355787264, 3355803647, 'AR', 'ARG', 'الأرجنتين'),
(80632, 3355803648, 3355820031, 'VE', 'VEN', 'فنزويلا'),
(80633, 3355820032, 3355836415, 'AR', 'ARG', 'الأرجنتين'),
(80634, 3355836416, 3355841023, 'EC', 'ECU', 'الإكوادور'),
(80635, 3355841024, 3355841279, 'CL', 'CHL', 'تشيلي'),
(80636, 3355841280, 3355843327, 'EC', 'ECU', 'الإكوادور'),
(80637, 3355843328, 3355843583, 'VE', 'VEN', 'فنزويلا'),
(80638, 3355843584, 3355844863, 'EC', 'ECU', 'الإكوادور'),
(80639, 3355844864, 3355845119, 'CL', 'CHL', 'تشيلي'),
(80640, 3355845120, 3355845375, 'EC', 'ECU', 'الإكوادور'),
(80641, 3355845376, 3355848959, 'BR', 'BRA', 'البرازيل'),
(80642, 3355848960, 3355849215, 'CL', 'CHL', 'تشيلي'),
(80643, 3355849728, 3355849983, 'PA', 'PAN', 'بنما'),
(80644, 3355849984, 3355850495, 'CL', 'CHL', 'تشيلي'),
(80645, 3355850496, 3355850751, 'NI', 'NIC', 'نيكاراغوا'),
(80646, 3355850752, 3355852799, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80647, 3355852800, 3355856639, 'CL', 'CHL', 'تشيلي'),
(80648, 3355856640, 3355856895, 'PA', 'PAN', 'بنما'),
(80649, 3355856896, 3355858943, 'EC', 'ECU', 'الإكوادور'),
(80650, 3355858944, 3355860991, 'DO', 'DOM', 'الدومينيكان'),
(80651, 3355860992, 3355869183, 'CL', 'CHL', 'تشيلي'),
(80652, 3355869184, 3355870719, 'BR', 'BRA', 'البرازيل'),
(80653, 3355873280, 3355875327, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80654, 3355875328, 3355877375, 'VE', 'VEN', 'فنزويلا'),
(80655, 3355877376, 3355885567, 'CO', 'COL', 'كولومبيا'),
(80656, 3355885568, 3355901951, 'GT', 'GTM', 'غواتيمالا'),
(80657, 3355901952, 3355902975, 'BR', 'BRA', 'البرازيل'),
(80658, 3355902976, 3355903999, 'CL', 'CHL', 'تشيلي'),
(80659, 3355904000, 3355905535, 'BR', 'BRA', 'البرازيل'),
(80660, 3355905536, 3355905791, 'PY', 'PRY', 'باراغواي'),
(80661, 3355905792, 3355906047, 'AR', 'ARG', 'الأرجنتين'),
(80662, 3355906048, 3355910143, 'CL', 'CHL', 'تشيلي'),
(80663, 3355910144, 3355911503, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80664, 3355911504, 3355911519, 'TF', 'ATF', 'الأقاليم الجنوبية الفرنسية'),
(80665, 3355911520, 3355918335, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80666, 3355918336, 3355923455, 'EC', 'ECU', 'الإكوادور'),
(80667, 3355923456, 3355924479, 'UY', 'URY', 'الأوروغواي'),
(80668, 3355924480, 3355926527, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(80669, 3355934720, 3355938815, 'AR', 'ARG', 'الأرجنتين'),
(80670, 3355942912, 3355947007, 'BO', 'BOL', 'بوليفيا'),
(80671, 3355947008, 3355949055, 'AR', 'ARG', 'الأرجنتين'),
(80672, 3355949056, 3355951103, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80673, 3355951104, 3355967487, 'EC', 'ECU', 'الإكوادور'),
(80674, 3355967488, 3356033023, 'VE', 'VEN', 'فنزويلا'),
(80675, 3356033024, 3356033791, 'BR', 'BRA', 'البرازيل'),
(80676, 3356033792, 3356034047, 'CL', 'CHL', 'تشيلي'),
(80677, 3356034048, 3356035071, 'PY', 'PRY', 'باراغواي'),
(80678, 3356035072, 3356037119, 'MX', 'MEX', 'المكسيك'),
(80679, 3356037120, 3356041215, 'CO', 'COL', 'كولومبيا'),
(80680, 3356041216, 3356049407, 'CR', 'CRI', 'كوستا ريكا'),
(80681, 3356049408, 3356049663, 'CL', 'CHL', 'تشيلي'),
(80682, 3356049664, 3356051455, 'BR', 'BRA', 'البرازيل'),
(80683, 3356051456, 3356051711, 'CO', 'COL', 'كولومبيا'),
(80684, 3356051712, 3356051967, 'CL', 'CHL', 'تشيلي'),
(80685, 3356051968, 3356052223, 'GT', 'GTM', 'غواتيمالا'),
(80686, 3356052224, 3356052479, 'AR', 'ARG', 'الأرجنتين'),
(80687, 3356052480, 3356052991, 'BR', 'BRA', 'البرازيل'),
(80688, 3356053248, 3356054015, 'CL', 'CHL', 'تشيلي'),
(80689, 3356054016, 3356054527, 'US', 'USA', 'الولايات المتحدة'),
(80690, 3356054528, 3356057599, 'BR', 'BRA', 'البرازيل'),
(80691, 3356057600, 3356057855, 'EC', 'ECU', 'الإكوادور'),
(80692, 3356057856, 3356059135, 'CL', 'CHL', 'تشيلي'),
(80693, 3356059136, 3356060671, 'BR', 'BRA', 'البرازيل'),
(80694, 3356060672, 3356061695, 'CL', 'CHL', 'تشيلي'),
(80695, 3356061696, 3356062463, 'BR', 'BRA', 'البرازيل'),
(80696, 3356062464, 3356062719, 'US', 'USA', 'الولايات المتحدة'),
(80697, 3356062720, 3356064255, 'BR', 'BRA', 'البرازيل'),
(80698, 3356064256, 3356064511, 'CL', 'CHL', 'تشيلي'),
(80699, 3356064512, 3356065791, 'BR', 'BRA', 'البرازيل'),
(80700, 3356065792, 3356066047, 'CL', 'CHL', 'تشيلي'),
(80701, 3356066048, 3356069119, 'BR', 'BRA', 'البرازيل'),
(80702, 3356069120, 3356069631, 'CL', 'CHL', 'تشيلي'),
(80703, 3356069632, 3356070143, 'BR', 'BRA', 'البرازيل'),
(80704, 3356070144, 3356070655, 'CL', 'CHL', 'تشيلي'),
(80705, 3356070656, 3356070911, 'AR', 'ARG', 'الأرجنتين'),
(80706, 3356070912, 3356071423, 'BR', 'BRA', 'البرازيل'),
(80707, 3356071424, 3356072447, 'CL', 'CHL', 'تشيلي'),
(80708, 3356072448, 3356073215, 'CR', 'CRI', 'كوستا ريكا'),
(80709, 3356073216, 3356073471, 'UY', 'URY', 'الأوروغواي'),
(80710, 3356073472, 3356075263, 'BR', 'BRA', 'البرازيل'),
(80711, 3356075264, 3356076287, 'BO', 'BOL', 'بوليفيا'),
(80712, 3356076288, 3356078079, 'BR', 'BRA', 'البرازيل'),
(80713, 3356078080, 3356078335, 'EC', 'ECU', 'الإكوادور'),
(80714, 3356078336, 3356079359, 'CL', 'CHL', 'تشيلي'),
(80715, 3356079360, 3356080895, 'BR', 'BRA', 'البرازيل'),
(80716, 3356080896, 3356082431, 'NI', 'NIC', 'نيكاراغوا'),
(80717, 3356082432, 3356082687, 'CL', 'CHL', 'تشيلي'),
(80718, 3356082688, 3356082943, 'AR', 'ARG', 'الأرجنتين'),
(80719, 3356082944, 3356083967, 'CL', 'CHL', 'تشيلي'),
(80720, 3356083968, 3356084479, 'BR', 'BRA', 'البرازيل'),
(80721, 3356084480, 3356084735, 'CL', 'CHL', 'تشيلي'),
(80722, 3356084736, 3356085247, 'BR', 'BRA', 'البرازيل'),
(80723, 3356085248, 3356085759, 'CL', 'CHL', 'تشيلي'),
(80724, 3356085760, 3356086271, 'BR', 'BRA', 'البرازيل'),
(80725, 3356086272, 3356086527, 'AR', 'ARG', 'الأرجنتين'),
(80726, 3356086528, 3356086783, 'CR', 'CRI', 'كوستا ريكا'),
(80727, 3356086784, 3356087039, 'VE', 'VEN', 'فنزويلا'),
(80728, 3356087040, 3356087295, 'CO', 'COL', 'كولومبيا'),
(80729, 3356087296, 3356087807, 'AR', 'ARG', 'الأرجنتين'),
(80730, 3356087808, 3356088063, 'BR', 'BRA', 'البرازيل'),
(80731, 3356088064, 3356088319, 'CL', 'CHL', 'تشيلي'),
(80732, 3356088320, 3356089087, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(80733, 3356089088, 3356089343, 'AR', 'ARG', 'الأرجنتين'),
(80734, 3356089344, 3356090623, 'BR', 'BRA', 'البرازيل'),
(80735, 3356090624, 3356090879, 'CL', 'CHL', 'تشيلي'),
(80736, 3356090880, 3356091135, 'BR', 'BRA', 'البرازيل'),
(80737, 3356091136, 3356091391, 'AR', 'ARG', 'الأرجنتين'),
(80738, 3356091392, 3356091647, 'CL', 'CHL', 'تشيلي'),
(80739, 3356091648, 3356091903, 'BR', 'BRA', 'البرازيل'),
(80740, 3356091904, 3356092927, 'CL', 'CHL', 'تشيلي'),
(80741, 3356092928, 3356093183, 'BR', 'BRA', 'البرازيل'),
(80742, 3356093184, 3356093951, 'AR', 'ARG', 'الأرجنتين'),
(80743, 3356093952, 3356094975, 'CL', 'CHL', 'تشيلي'),
(80744, 3356094976, 3356096255, 'AR', 'ARG', 'الأرجنتين'),
(80745, 3356096256, 3356096511, 'CL', 'CHL', 'تشيلي'),
(80746, 3356096512, 3356096767, 'EC', 'ECU', 'الإكوادور'),
(80747, 3356096768, 3356097791, 'BR', 'BRA', 'البرازيل'),
(80748, 3356097792, 3356098303, 'AR', 'ARG', 'الأرجنتين'),
(80749, 3356098304, 3356098559, 'GT', 'GTM', 'غواتيمالا'),
(80750, 3356098560, 3356099583, 'CL', 'CHL', 'تشيلي'),
(80751, 3356099584, 3356100607, 'BR', 'BRA', 'البرازيل'),
(80752, 3356100608, 3356102399, 'CL', 'CHL', 'تشيلي'),
(80753, 3356102400, 3356102655, 'PA', 'PAN', 'بنما'),
(80754, 3356102656, 3356105727, 'CL', 'CHL', 'تشيلي'),
(80755, 3356105728, 3356106751, 'SV', 'SLV', 'السلفادور'),
(80756, 3356106752, 3356113919, 'BR', 'BRA', 'البرازيل'),
(80757, 3356113920, 3356114431, 'UY', 'URY', 'الأوروغواي'),
(80758, 3356114944, 3356123135, 'PE', 'PER', 'بيرو'),
(80759, 3356123136, 3356131839, 'AR', 'ARG', 'الأرجنتين'),
(80760, 3356131840, 3356132351, 'PE', 'PER', 'بيرو'),
(80761, 3356132352, 3356134143, 'BR', 'BRA', 'البرازيل'),
(80762, 3356134144, 3356134655, 'AR', 'ARG', 'الأرجنتين'),
(80763, 3356134656, 3356134911, 'BR', 'BRA', 'البرازيل'),
(80764, 3356134912, 3356135167, 'DO', 'DOM', 'الدومينيكان'),
(80765, 3356135168, 3356135423, 'MX', 'MEX', 'المكسيك'),
(80766, 3356135424, 3356135679, 'BR', 'BRA', 'البرازيل'),
(80767, 3356135680, 3356135935, 'CL', 'CHL', 'تشيلي'),
(80768, 3356135936, 3356136191, 'BR', 'BRA', 'البرازيل'),
(80769, 3356136192, 3356137471, 'EC', 'ECU', 'الإكوادور'),
(80770, 3356137472, 3356137727, 'US', 'USA', 'الولايات المتحدة'),
(80771, 3356137728, 3356138239, 'BR', 'BRA', 'البرازيل'),
(80772, 3356138240, 3356138495, 'US', 'USA', 'الولايات المتحدة'),
(80773, 3356138496, 3356139519, 'BR', 'BRA', 'البرازيل'),
(80774, 3356139520, 3356139775, 'US', 'USA', 'الولايات المتحدة'),
(80775, 3356139776, 3356140031, 'AR', 'ARG', 'الأرجنتين'),
(80776, 3356140032, 3356140287, 'DO', 'DOM', 'الدومينيكان'),
(80777, 3356140288, 3356140799, 'BR', 'BRA', 'البرازيل'),
(80778, 3356140800, 3356141311, 'US', 'USA', 'الولايات المتحدة'),
(80779, 3356141312, 3356142847, 'CL', 'CHL', 'تشيلي'),
(80780, 3356142848, 3356145151, 'BR', 'BRA', 'البرازيل'),
(80781, 3356145152, 3356145407, 'CL', 'CHL', 'تشيلي'),
(80782, 3356145408, 3356145663, 'BR', 'BRA', 'البرازيل'),
(80783, 3356145664, 3356145919, 'CL', 'CHL', 'تشيلي'),
(80784, 3356145920, 3356146175, 'BR', 'BRA', 'البرازيل'),
(80785, 3356146176, 3356146431, 'AR', 'ARG', 'الأرجنتين'),
(80786, 3356146432, 3356146687, 'BR', 'BRA', 'البرازيل'),
(80787, 3356146688, 3356146943, 'PE', 'PER', 'بيرو'),
(80788, 3356146944, 3356147199, 'BR', 'BRA', 'البرازيل'),
(80789, 3356147200, 3356147455, 'CL', 'CHL', 'تشيلي'),
(80790, 3356147456, 3356148223, 'BR', 'BRA', 'البرازيل'),
(80791, 3356148224, 3356148479, 'BZ', 'BLZ', 'بليز'),
(80792, 3356148480, 3356148735, 'CL', 'CHL', 'تشيلي'),
(80793, 3356148736, 3356148991, 'AR', 'ARG', 'الأرجنتين'),
(80794, 3356148992, 3356149503, 'MX', 'MEX', 'المكسيك'),
(80795, 3356149504, 3356149759, 'AR', 'ARG', 'الأرجنتين'),
(80796, 3356149760, 3356150015, 'MX', 'MEX', 'المكسيك'),
(80797, 3356150016, 3356150527, 'AR', 'ARG', 'الأرجنتين'),
(80798, 3356150528, 3356150783, 'PA', 'PAN', 'بنما'),
(80799, 3356150784, 3356151039, 'AR', 'ARG', 'الأرجنتين'),
(80800, 3356151040, 3356151295, 'NI', 'NIC', 'نيكاراغوا'),
(80801, 3356151296, 3356151807, 'AR', 'ARG', 'الأرجنتين'),
(80802, 3356151808, 3356152063, 'CL', 'CHL', 'تشيلي'),
(80803, 3356152064, 3356152575, 'BR', 'BRA', 'البرازيل'),
(80804, 3356152576, 3356152831, 'CL', 'CHL', 'تشيلي'),
(80805, 3356152832, 3356154623, 'MX', 'MEX', 'المكسيك'),
(80806, 3356154624, 3356154879, 'AR', 'ARG', 'الأرجنتين'),
(80807, 3356154880, 3356156671, 'CL', 'CHL', 'تشيلي'),
(80808, 3356156672, 3356156927, 'BR', 'BRA', 'البرازيل'),
(80809, 3356156928, 3356157951, 'PY', 'PRY', 'باراغواي'),
(80810, 3356157952, 3356158207, 'CL', 'CHL', 'تشيلي'),
(80811, 3356158208, 3356158463, 'MX', 'MEX', 'المكسيك'),
(80812, 3356158464, 3356158719, 'CL', 'CHL', 'تشيلي'),
(80813, 3356158720, 3356158975, 'AR', 'ARG', 'الأرجنتين'),
(80814, 3356158976, 3356159743, 'CL', 'CHL', 'تشيلي'),
(80815, 3356160000, 3356160255, 'MX', 'MEX', 'المكسيك'),
(80816, 3356160256, 3356160511, 'GT', 'GTM', 'غواتيمالا'),
(80817, 3356160512, 3356160767, 'CL', 'CHL', 'تشيلي'),
(80818, 3356160768, 3356161279, 'MX', 'MEX', 'المكسيك'),
(80819, 3356161280, 3356161535, 'BR', 'BRA', 'البرازيل'),
(80820, 3356161536, 3356162559, 'MX', 'MEX', 'المكسيك'),
(80821, 3356162560, 3356162815, 'PE', 'PER', 'بيرو'),
(80822, 3356162816, 3356163583, 'CL', 'CHL', 'تشيلي'),
(80823, 3356163584, 3356163839, 'VE', 'VEN', 'فنزويلا'),
(80824, 3356163840, 3356164095, 'CL', 'CHL', 'تشيلي'),
(80825, 3356164096, 3356171519, 'BR', 'BRA', 'البرازيل'),
(80826, 3356171520, 3356171775, 'AR', 'ARG', 'الأرجنتين'),
(80827, 3356171776, 3356172031, 'NI', 'NIC', 'نيكاراغوا'),
(80828, 3356172032, 3356172287, 'SV', 'SLV', 'السلفادور'),
(80829, 3356172288, 3356172543, 'PE', 'PER', 'بيرو'),
(80830, 3356172544, 3356172799, 'AR', 'ARG', 'الأرجنتين'),
(80831, 3356172800, 3356174335, 'PE', 'PER', 'بيرو'),
(80832, 3356174336, 3356176383, 'CO', 'COL', 'كولومبيا'),
(80833, 3356176384, 3356180479, 'PE', 'PER', 'بيرو'),
(80834, 3356180480, 3356190719, 'CL', 'CHL', 'تشيلي'),
(80835, 3356190720, 3356192767, 'DO', 'DOM', 'الدومينيكان'),
(80836, 3356192768, 3356194815, 'AR', 'ARG', 'الأرجنتين'),
(80837, 3356196864, 3356229631, 'VE', 'VEN', 'فنزويلا'),
(80838, 3356229632, 3356233727, 'BR', 'BRA', 'البرازيل'),
(80839, 3356233728, 3356237823, 'CL', 'CHL', 'تشيلي'),
(80840, 3356237824, 3356246015, 'GT', 'GTM', 'غواتيمالا'),
(80841, 3356246016, 3356262655, 'MX', 'MEX', 'المكسيك'),
(80842, 3356262656, 3356263167, 'CL', 'CHL', 'تشيلي'),
(80843, 3356263168, 3356263423, 'BR', 'BRA', 'البرازيل'),
(80844, 3356263424, 3356263679, 'CL', 'CHL', 'تشيلي'),
(80845, 3356263680, 3356265215, 'AR', 'ARG', 'الأرجنتين'),
(80846, 3356265216, 3356265471, 'BR', 'BRA', 'البرازيل'),
(80847, 3356265472, 3356267007, 'CL', 'CHL', 'تشيلي'),
(80848, 3356267008, 3356267263, 'PY', 'PRY', 'باراغواي'),
(80849, 3356267264, 3356268799, 'CL', 'CHL', 'تشيلي'),
(80850, 3356269056, 3356269311, 'AR', 'ARG', 'الأرجنتين'),
(80851, 3356269312, 3356269823, 'UY', 'URY', 'الأوروغواي'),
(80852, 3356269824, 3356270079, 'BR', 'BRA', 'البرازيل'),
(80853, 3356270080, 3356272383, 'MX', 'MEX', 'المكسيك'),
(80854, 3356272384, 3356272639, 'CR', 'CRI', 'كوستا ريكا'),
(80855, 3356272640, 3356272895, 'US', 'USA', 'الولايات المتحدة'),
(80856, 3356272896, 3356273151, 'EC', 'ECU', 'الإكوادور'),
(80857, 3356273152, 3356273407, 'CO', 'COL', 'كولومبيا'),
(80858, 3356273664, 3356274431, 'SV', 'SLV', 'السلفادور'),
(80859, 3356274432, 3356278783, 'CO', 'COL', 'كولومبيا'),
(80860, 3356279040, 3356279295, 'VE', 'VEN', 'فنزويلا'),
(80861, 3356280832, 3356282879, 'AR', 'ARG', 'الأرجنتين'),
(80862, 3356282880, 3356284927, 'PA', 'PAN', 'بنما'),
(80863, 3356284928, 3356286975, 'AR', 'ARG', 'الأرجنتين'),
(80864, 3356286976, 3356286991, 'US', 'USA', 'الولايات المتحدة'),
(80865, 3356286992, 3356287007, 'GT', 'GTM', 'غواتيمالا'),
(80866, 3356287008, 3356287023, 'HN', 'HND', 'هندوراس'),
(80867, 3356287024, 3356287039, 'GT', 'GTM', 'غواتيمالا'),
(80868, 3356287040, 3356287047, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(80869, 3356287048, 3356287071, 'GT', 'GTM', 'غواتيمالا'),
(80870, 3356287072, 3356287135, 'US', 'USA', 'الولايات المتحدة'),
(80871, 3356287136, 3356287151, 'GT', 'GTM', 'غواتيمالا'),
(80872, 3356287152, 3356287359, 'US', 'USA', 'الولايات المتحدة'),
(80873, 3356287360, 3356287367, 'GT', 'GTM', 'غواتيمالا'),
(80874, 3356287368, 3356287487, 'US', 'USA', 'الولايات المتحدة'),
(80875, 3356287488, 3356287743, 'SV', 'SLV', 'السلفادور'),
(80876, 3356287744, 3356288255, 'HN', 'HND', 'هندوراس'),
(80877, 3356288256, 3356288767, 'SV', 'SLV', 'السلفادور'),
(80878, 3356288768, 3356289023, 'GT', 'GTM', 'غواتيمالا'),
(80879, 3356289024, 3356289791, 'SV', 'SLV', 'السلفادور'),
(80880, 3356289792, 3356289799, 'US', 'USA', 'الولايات المتحدة'),
(80881, 3356289800, 3356289807, 'GT', 'GTM', 'غواتيمالا'),
(80882, 3356289808, 3356289823, 'SV', 'SLV', 'السلفادور'),
(80883, 3356289824, 3356289887, 'US', 'USA', 'الولايات المتحدة'),
(80884, 3356289888, 3356289919, 'SV', 'SLV', 'السلفادور'),
(80885, 3356289920, 3356289951, 'US', 'USA', 'الولايات المتحدة'),
(80886, 3356289952, 3356289983, 'GT', 'GTM', 'غواتيمالا'),
(80887, 3356289984, 3356290303, 'US', 'USA', 'الولايات المتحدة'),
(80888, 3356290304, 3356290559, 'SV', 'SLV', 'السلفادور'),
(80889, 3356290560, 3356291071, 'CR', 'CRI', 'كوستا ريكا'),
(80890, 3356291072, 3356293119, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(80891, 3356293120, 3356295167, 'AW', 'ABW', 'أروبا'),
(80892, 3356295168, 3356297215, 'CL', 'CHL', 'تشيلي'),
(80893, 3356297216, 3356299263, 'BR', 'BRA', 'البرازيل'),
(80894, 3356299264, 3356305663, 'MX', 'MEX', 'المكسيك'),
(80895, 3356305664, 3356305919, 'AR', 'ARG', 'الأرجنتين'),
(80896, 3356307456, 3356316415, 'MX', 'MEX', 'المكسيك'),
(80897, 3356317696, 3356328959, 'MX', 'MEX', 'المكسيك'),
(80898, 3356329984, 3356332031, 'GF', 'GUF', 'غيانا الفرنسية'),
(80899, 3356332032, 3356334079, 'CU', 'CUB', 'كوبا'),
(80900, 3356334080, 3356336127, 'BO', 'BOL', 'بوليفيا'),
(80901, 3356336128, 3356336639, 'SV', 'SLV', 'السلفادور'),
(80902, 3356336640, 3356338175, 'HN', 'HND', 'هندوراس'),
(80903, 3356338176, 3356339967, 'SV', 'SLV', 'السلفادور'),
(80904, 3356339968, 3356341247, 'HN', 'HND', 'هندوراس'),
(80905, 3356341248, 3356341503, 'SV', 'SLV', 'السلفادور'),
(80906, 3356341504, 3356342271, 'HN', 'HND', 'هندوراس'),
(80907, 3356342272, 3356343039, 'SV', 'SLV', 'السلفادور'),
(80908, 3356343040, 3356343551, 'HN', 'HND', 'هندوراس'),
(80909, 3356343552, 3356344319, 'SV', 'SLV', 'السلفادور'),
(80910, 3356344320, 3356360703, 'CO', 'COL', 'كولومبيا'),
(80911, 3356360704, 3356362751, 'CL', 'CHL', 'تشيلي'),
(80912, 3356362752, 3356364799, 'VE', 'VEN', 'فنزويلا'),
(80913, 3356364800, 3356368895, 'MX', 'MEX', 'المكسيك'),
(80914, 3356368896, 3356369407, 'BR', 'BRA', 'البرازيل'),
(80915, 3356369408, 3356369663, 'EC', 'ECU', 'الإكوادور'),
(80916, 3356369664, 3356370175, 'BR', 'BRA', 'البرازيل'),
(80917, 3356370944, 3356372991, 'CO', 'COL', 'كولومبيا'),
(80918, 3356372992, 3356375039, 'CU', 'CUB', 'كوبا'),
(80919, 3356375040, 3356377087, 'HN', 'HND', 'هندوراس'),
(80920, 3356377088, 3356379647, 'CL', 'CHL', 'تشيلي'),
(80921, 3356380160, 3356380927, 'CL', 'CHL', 'تشيلي'),
(80922, 3356381184, 3356381439, 'CL', 'CHL', 'تشيلي'),
(80923, 3356382208, 3356389119, 'CL', 'CHL', 'تشيلي'),
(80924, 3356389376, 3356389887, 'CO', 'COL', 'كولومبيا'),
(80925, 3356389888, 3356390399, 'CL', 'CHL', 'تشيلي'),
(80926, 3356390656, 3356391167, 'CL', 'CHL', 'تشيلي'),
(80927, 3356393472, 3356426239, 'CL', 'CHL', 'تشيلي'),
(80928, 3356426240, 3356491775, 'US', 'USA', 'الولايات المتحدة'),
(80929, 3356491776, 3356493823, 'PE', 'PER', 'بيرو'),
(80930, 3356493824, 3356495871, 'MU', 'MUS', 'موريشيوس'),
(80931, 3356495872, 3356499967, 'AR', 'ARG', 'الأرجنتين'),
(80932, 3356499968, 3356508159, 'MX', 'MEX', 'المكسيك'),
(80933, 3356508160, 3356508671, 'AR', 'ARG', 'الأرجنتين'),
(80934, 3356510208, 3356511999, 'AR', 'ARG', 'الأرجنتين'),
(80935, 3356512256, 3356514303, 'AR', 'ARG', 'الأرجنتين'),
(80936, 3356514304, 3356514559, 'US', 'USA', 'الولايات المتحدة'),
(80937, 3356516352, 3356520447, 'AR', 'ARG', 'الأرجنتين'),
(80938, 3356521472, 3356521727, 'AR', 'ARG', 'الأرجنتين'),
(80939, 3356522496, 3356557311, 'AR', 'ARG', 'الأرجنتين'),
(80940, 3356557312, 3356819455, 'BR', 'BRA', 'البرازيل'),
(80941, 3356819456, 3356884991, 'CO', 'COL', 'كولومبيا'),
(80942, 3356884992, 3356950527, 'CL', 'CHL', 'تشيلي'),
(80943, 3356950528, 3357016063, 'MX', 'MEX', 'المكسيك'),
(80944, 3357016064, 3357018623, 'CO', 'COL', 'كولومبيا'),
(80945, 3357020160, 3357048831, 'CO', 'COL', 'كولومبيا'),
(80946, 3357057024, 3357065215, 'PE', 'PER', 'بيرو'),
(80947, 3357065216, 3357073407, 'EC', 'ECU', 'الإكوادور'),
(80948, 3357073408, 3357077503, 'CL', 'CHL', 'تشيلي'),
(80949, 3357077504, 3357081599, 'AR', 'ARG', 'الأرجنتين'),
(80950, 3357081600, 3357114367, 'CO', 'COL', 'كولومبيا'),
(80951, 3357114368, 3357138943, 'EC', 'ECU', 'الإكوادور'),
(80952, 3357138944, 3357147135, 'CO', 'COL', 'كولومبيا'),
(80953, 3357147136, 3357179903, 'AR', 'ARG', 'الأرجنتين'),
(80954, 3357179904, 3357188095, 'CO', 'COL', 'كولومبيا'),
(80955, 3357188096, 3357190143, 'VE', 'VEN', 'فنزويلا'),
(80956, 3357190144, 3357192191, 'DO', 'DOM', 'الدومينيكان'),
(80957, 3357192192, 3357194239, 'PY', 'PRY', 'باراغواي'),
(80958, 3357194240, 3357196287, 'AR', 'ARG', 'الأرجنتين'),
(80959, 3357196288, 3357212671, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(80960, 3357212672, 3357368319, 'CL', 'CHL', 'تشيلي'),
(80961, 3357368320, 3357376511, 'CO', 'COL', 'كولومبيا'),
(80962, 3357376512, 3357403135, 'CL', 'CHL', 'تشيلي'),
(80963, 3357403136, 3357405183, 'CO', 'COL', 'كولومبيا'),
(80964, 3357405184, 3357407231, 'EC', 'ECU', 'الإكوادور'),
(80965, 3357407232, 3357409279, 'AR', 'ARG', 'الأرجنتين'),
(80966, 3357409280, 3357413119, 'US', 'USA', 'الولايات المتحدة'),
(80967, 3357413120, 3357413375, 'FR', 'FRA', 'فرنسا'),
(80968, 3357413376, 3357421311, 'US', 'USA', 'الولايات المتحدة'),
(80969, 3357421312, 3357421567, 'CO', 'COL', 'كولومبيا'),
(80970, 3357421568, 3357422847, 'US', 'USA', 'الولايات المتحدة'),
(80971, 3357422848, 3357423103, 'PR', 'PRI', 'بورتو ريكو'),
(80972, 3357423104, 3357423615, 'US', 'USA', 'الولايات المتحدة'),
(80973, 3357423616, 3357424639, 'VE', 'VEN', 'فنزويلا'),
(80974, 3357424640, 3357425663, 'US', 'USA', 'الولايات المتحدة'),
(80975, 3357425664, 3357442047, 'CO', 'COL', 'كولومبيا'),
(80976, 3357442048, 3357442303, 'NI', 'NIC', 'نيكاراغوا'),
(80977, 3357442304, 3357442447, 'HN', 'HND', 'هندوراس'),
(80978, 3357442448, 3357442455, 'SV', 'SLV', 'السلفادور'),
(80979, 3357442456, 3357442559, 'HN', 'HND', 'هندوراس'),
(80980, 3357442560, 3357442815, 'NI', 'NIC', 'نيكاراغوا'),
(80981, 3357442816, 3357443071, 'SV', 'SLV', 'السلفادور'),
(80982, 3357443072, 3357443327, 'NI', 'NIC', 'نيكاراغوا'),
(80983, 3357443328, 3357443583, 'GT', 'GTM', 'غواتيمالا'),
(80984, 3357443584, 3357444607, 'HN', 'HND', 'هندوراس'),
(80985, 3357444608, 3357444863, 'SV', 'SLV', 'السلفادور'),
(80986, 3357444864, 3357448191, 'GT', 'GTM', 'غواتيمالا'),
(80987, 3357448192, 3357448703, 'SV', 'SLV', 'السلفادور'),
(80988, 3357448704, 3357448959, 'GT', 'GTM', 'غواتيمالا'),
(80989, 3357448960, 3357449727, 'HN', 'HND', 'هندوراس'),
(80990, 3357449728, 3357450751, 'GT', 'GTM', 'غواتيمالا'),
(80991, 3357450752, 3357451007, 'SV', 'SLV', 'السلفادور'),
(80992, 3357451008, 3357451519, 'HN', 'HND', 'هندوراس'),
(80993, 3357451520, 3357451775, 'NI', 'NIC', 'نيكاراغوا'),
(80994, 3357451776, 3357452287, 'GT', 'GTM', 'غواتيمالا'),
(80995, 3357452288, 3357452799, 'HN', 'HND', 'هندوراس'),
(80996, 3357452800, 3357453055, 'NI', 'NIC', 'نيكاراغوا'),
(80997, 3357453056, 3357453311, 'SV', 'SLV', 'السلفادور'),
(80998, 3357453312, 3357454591, 'GT', 'GTM', 'غواتيمالا'),
(80999, 3357454592, 3357454847, 'NI', 'NIC', 'نيكاراغوا'),
(81000, 3357454848, 3357455103, 'HN', 'HND', 'هندوراس'),
(81001, 3357455104, 3357455359, 'SV', 'SLV', 'السلفادور'),
(81002, 3357455360, 3357455871, 'GT', 'GTM', 'غواتيمالا'),
(81003, 3357455872, 3357456127, 'NI', 'NIC', 'نيكاراغوا'),
(81004, 3357456128, 3357456639, 'GT', 'GTM', 'غواتيمالا'),
(81005, 3357456640, 3357456895, 'HN', 'HND', 'هندوراس'),
(81006, 3357456896, 3357457663, 'GT', 'GTM', 'غواتيمالا'),
(81007, 3357457664, 3357457919, 'CR', 'CRI', 'كوستا ريكا'),
(81008, 3357457920, 3357458431, 'HN', 'HND', 'هندوراس'),
(81009, 3357458432, 3357474815, 'CL', 'CHL', 'تشيلي'),
(81010, 3357474816, 3357474843, 'US', 'USA', 'الولايات المتحدة'),
(81011, 3357474844, 3357474847, 'PE', 'PER', 'بيرو'),
(81012, 3357474848, 3357474851, 'VE', 'VEN', 'فنزويلا'),
(81013, 3357474852, 3357474855, 'EC', 'ECU', 'الإكوادور'),
(81014, 3357474856, 3357474863, 'US', 'USA', 'الولايات المتحدة'),
(81015, 3357474864, 3357474867, 'EC', 'ECU', 'الإكوادور'),
(81016, 3357474868, 3357474875, 'CO', 'COL', 'كولومبيا'),
(81017, 3357474876, 3357474879, 'EC', 'ECU', 'الإكوادور'),
(81018, 3357474880, 3357474883, 'VE', 'VEN', 'فنزويلا'),
(81019, 3357474884, 3357474887, 'US', 'USA', 'الولايات المتحدة'),
(81020, 3357474888, 3357474891, 'CO', 'COL', 'كولومبيا'),
(81021, 3357474892, 3357474895, 'US', 'USA', 'الولايات المتحدة'),
(81022, 3357474896, 3357474899, 'CO', 'COL', 'كولومبيا'),
(81023, 3357474900, 3357474903, 'US', 'USA', 'الولايات المتحدة'),
(81024, 3357474904, 3357474907, 'VE', 'VEN', 'فنزويلا'),
(81025, 3357474908, 3357474923, 'US', 'USA', 'الولايات المتحدة'),
(81026, 3357474924, 3357474927, 'VE', 'VEN', 'فنزويلا'),
(81027, 3357474928, 3357474931, 'CO', 'COL', 'كولومبيا'),
(81028, 3357474932, 3357474935, 'US', 'USA', 'الولايات المتحدة'),
(81029, 3357474936, 3357474939, 'PE', 'PER', 'بيرو'),
(81030, 3357474940, 3357474951, 'US', 'USA', 'الولايات المتحدة'),
(81031, 3357474952, 3357474955, 'VE', 'VEN', 'فنزويلا'),
(81032, 3357474956, 3357474959, 'US', 'USA', 'الولايات المتحدة'),
(81033, 3357474960, 3357474963, 'CO', 'COL', 'كولومبيا'),
(81034, 3357474964, 3357474967, 'US', 'USA', 'الولايات المتحدة'),
(81035, 3357474968, 3357474975, 'EC', 'ECU', 'الإكوادور'),
(81036, 3357474976, 3357474983, 'US', 'USA', 'الولايات المتحدة'),
(81037, 3357474984, 3357474987, 'EC', 'ECU', 'الإكوادور'),
(81038, 3357474988, 3357474991, 'CO', 'COL', 'كولومبيا'),
(81039, 3357474992, 3357474995, 'CL', 'CHL', 'تشيلي'),
(81040, 3357474996, 3357475023, 'US', 'USA', 'الولايات المتحدة'),
(81041, 3357475024, 3357475027, 'CO', 'COL', 'كولومبيا'),
(81042, 3357475028, 3357475051, 'US', 'USA', 'الولايات المتحدة'),
(81043, 3357475052, 3357475055, 'CO', 'COL', 'كولومبيا'),
(81044, 3357475056, 3357475059, 'US', 'USA', 'الولايات المتحدة'),
(81045, 3357475060, 3357475071, 'EC', 'ECU', 'الإكوادور'),
(81046, 3357475072, 3357475839, 'AR', 'ARG', 'الأرجنتين'),
(81047, 3357475840, 3357476351, 'VE', 'VEN', 'فنزويلا'),
(81048, 3357476352, 3357476607, 'EC', 'ECU', 'الإكوادور'),
(81049, 3357476608, 3357476863, 'US', 'USA', 'الولايات المتحدة'),
(81050, 3357476864, 3357477631, 'EC', 'ECU', 'الإكوادور'),
(81051, 3357477632, 3357477887, 'AR', 'ARG', 'الأرجنتين'),
(81052, 3357477888, 3357478199, 'CO', 'COL', 'كولومبيا'),
(81053, 3357478200, 3357478207, 'EC', 'ECU', 'الإكوادور'),
(81054, 3357478208, 3357480871, 'CO', 'COL', 'كولومبيا'),
(81055, 3357480872, 3357480879, 'EC', 'ECU', 'الإكوادور'),
(81056, 3357480880, 3357480959, 'CO', 'COL', 'كولومبيا'),
(81057, 3357480960, 3357483007, 'EC', 'ECU', 'الإكوادور'),
(81058, 3357483008, 3357491199, 'CL', 'CHL', 'تشيلي'),
(81059, 3357491200, 3357491843, 'CO', 'COL', 'كولومبيا'),
(81060, 3357491844, 3357491847, 'CR', 'CRI', 'كوستا ريكا'),
(81061, 3357491848, 3357495375, 'CO', 'COL', 'كولومبيا'),
(81062, 3357495376, 3357495383, 'US', 'USA', 'الولايات المتحدة'),
(81063, 3357495384, 3357496599, 'CO', 'COL', 'كولومبيا'),
(81064, 3357496600, 3357496607, 'LA', 'LAO', 'لاو'),
(81065, 3357496608, 3357496643, 'CO', 'COL', 'كولومبيا'),
(81066, 3357496644, 3357496647, 'CR', 'CRI', 'كوستا ريكا'),
(81067, 3357496648, 3357499391, 'CO', 'COL', 'كولومبيا'),
(81068, 3357499392, 3357507583, 'PE', 'PER', 'بيرو'),
(81069, 3357507584, 3357515775, 'VE', 'VEN', 'فنزويلا'),
(81070, 3357515776, 3357523967, 'SV', 'SLV', 'السلفادور'),
(81071, 3357523968, 3357532159, 'CO', 'COL', 'كولومبيا'),
(81072, 3357532160, 3357536255, 'AR', 'ARG', 'الأرجنتين'),
(81073, 3357540352, 3357556735, 'AR', 'ARG', 'الأرجنتين'),
(81074, 3357556736, 3357556991, 'VE', 'VEN', 'فنزويلا'),
(81075, 3357556992, 3357557759, 'MX', 'MEX', 'المكسيك'),
(81076, 3357557760, 3357559295, 'EC', 'ECU', 'الإكوادور'),
(81077, 3357559296, 3357559551, 'CA', 'CAN', 'كندا'),
(81078, 3357559552, 3357559807, 'US', 'USA', 'الولايات المتحدة'),
(81079, 3357559808, 3357560319, 'VE', 'VEN', 'فنزويلا'),
(81080, 3357560320, 3357560575, 'MX', 'MEX', 'المكسيك'),
(81081, 3357560576, 3357560831, 'US', 'USA', 'الولايات المتحدة'),
(81082, 3357560832, 3357561855, 'CO', 'COL', 'كولومبيا'),
(81083, 3357561856, 3357562351, 'AR', 'ARG', 'الأرجنتين'),
(81084, 3357562352, 3357562367, 'US', 'USA', 'الولايات المتحدة'),
(81085, 3357562368, 3357563047, 'AR', 'ARG', 'الأرجنتين'),
(81086, 3357563048, 3357563055, 'CL', 'CHL', 'تشيلي'),
(81087, 3357563056, 3357573003, 'AR', 'ARG', 'الأرجنتين'),
(81088, 3357573004, 3357573007, 'CL', 'CHL', 'تشيلي'),
(81089, 3357573008, 3357581311, 'AR', 'ARG', 'الأرجنتين'),
(81090, 3357581312, 3357589503, 'CL', 'CHL', 'تشيلي'),
(81091, 3357589504, 3357605887, 'BZ', 'BLZ', 'بليز'),
(81092, 3357605888, 3357736959, 'MX', 'MEX', 'المكسيك'),
(81093, 3357736960, 3357745151, 'VE', 'VEN', 'فنزويلا'),
(81094, 3357745152, 3357753343, 'CO', 'COL', 'كولومبيا'),
(81095, 3357753344, 3357757487, 'VE', 'VEN', 'فنزويلا'),
(81096, 3357757488, 3357757495, 'BO', 'BOL', 'بوليفيا'),
(81097, 3357757496, 3357773823, 'VE', 'VEN', 'فنزويلا'),
(81098, 3357773824, 3357775871, 'PA', 'PAN', 'بنما'),
(81099, 3357775872, 3357775895, 'UY', 'URY', 'الأوروغواي'),
(81100, 3357775896, 3357775903, 'AR', 'ARG', 'الأرجنتين'),
(81101, 3357775904, 3357777919, 'UY', 'URY', 'الأوروغواي'),
(81102, 3357777920, 3357777923, 'SV', 'SLV', 'السلفادور'),
(81103, 3357777924, 3357778059, 'GT', 'GTM', 'غواتيمالا'),
(81104, 3357778060, 3357778063, 'SV', 'SLV', 'السلفادور'),
(81105, 3357778064, 3357778071, 'GT', 'GTM', 'غواتيمالا'),
(81106, 3357778072, 3357778075, 'SV', 'SLV', 'السلفادور'),
(81107, 3357778076, 3357778339, 'GT', 'GTM', 'غواتيمالا'),
(81108, 3357778340, 3357778343, 'SV', 'SLV', 'السلفادور'),
(81109, 3357778344, 3357778415, 'GT', 'GTM', 'غواتيمالا'),
(81110, 3357778416, 3357778423, 'SV', 'SLV', 'السلفادور'),
(81111, 3357778424, 3357778687, 'GT', 'GTM', 'غواتيمالا'),
(81112, 3357778688, 3357778695, 'SV', 'SLV', 'السلفادور'),
(81113, 3357778696, 3357779047, 'GT', 'GTM', 'غواتيمالا'),
(81114, 3357779048, 3357779055, 'SV', 'SLV', 'السلفادور'),
(81115, 3357779056, 3357779071, 'GT', 'GTM', 'غواتيمالا'),
(81116, 3357779072, 3357779079, 'SV', 'SLV', 'السلفادور'),
(81117, 3357779080, 3357779143, 'GT', 'GTM', 'غواتيمالا'),
(81118, 3357779144, 3357779151, 'SV', 'SLV', 'السلفادور'),
(81119, 3357779152, 3357779183, 'GT', 'GTM', 'غواتيمالا'),
(81120, 3357779184, 3357779199, 'SV', 'SLV', 'السلفادور'),
(81121, 3357779200, 3357779839, 'GT', 'GTM', 'غواتيمالا'),
(81122, 3357779840, 3357779855, 'SV', 'SLV', 'السلفادور'),
(81123, 3357779856, 3357780559, 'GT', 'GTM', 'غواتيمالا'),
(81124, 3357780560, 3357780575, 'SV', 'SLV', 'السلفادور'),
(81125, 3357780576, 3357782535, 'GT', 'GTM', 'غواتيمالا'),
(81126, 3357782536, 3357782543, 'SV', 'SLV', 'السلفادور'),
(81127, 3357782544, 3357784319, 'GT', 'GTM', 'غواتيمالا'),
(81128, 3357784320, 3357784479, 'SV', 'SLV', 'السلفادور'),
(81129, 3357784480, 3357784487, 'GT', 'GTM', 'غواتيمالا'),
(81130, 3357784488, 3357784511, 'SV', 'SLV', 'السلفادور'),
(81131, 3357784512, 3357784543, 'GT', 'GTM', 'غواتيمالا'),
(81132, 3357784544, 3357784551, 'SV', 'SLV', 'السلفادور'),
(81133, 3357784552, 3357785087, 'GT', 'GTM', 'غواتيمالا'),
(81134, 3357785088, 3357785163, 'SV', 'SLV', 'السلفادور'),
(81135, 3357785164, 3357785167, 'GT', 'GTM', 'غواتيمالا'),
(81136, 3357785168, 3357785215, 'SV', 'SLV', 'السلفادور'),
(81137, 3357785216, 3357785219, 'GT', 'GTM', 'غواتيمالا'),
(81138, 3357785220, 3357785223, 'SV', 'SLV', 'السلفادور'),
(81139, 3357785224, 3357785227, 'GT', 'GTM', 'غواتيمالا'),
(81140, 3357785228, 3357785247, 'SV', 'SLV', 'السلفادور'),
(81141, 3357785248, 3357785255, 'GT', 'GTM', 'غواتيمالا'),
(81142, 3357785256, 3357785599, 'SV', 'SLV', 'السلفادور'),
(81143, 3357785600, 3357785603, 'GT', 'GTM', 'غواتيمالا'),
(81144, 3357785604, 3357785855, 'SV', 'SLV', 'السلفادور'),
(81145, 3357785856, 3357786111, 'GT', 'GTM', 'غواتيمالا'),
(81146, 3357786112, 3357802495, 'VE', 'VEN', 'فنزويلا'),
(81147, 3357802496, 3357868031, 'MX', 'MEX', 'المكسيك'),
(81148, 3357868032, 3357933567, 'PE', 'PER', 'بيرو'),
(81149, 3357933568, 3358064639, 'MX', 'MEX', 'المكسيك'),
(81150, 3358064640, 3358130175, 'UY', 'URY', 'الأوروغواي'),
(81151, 3358130176, 3358131199, 'EC', 'ECU', 'الإكوادور'),
(81152, 3358131200, 3358132223, 'CO', 'COL', 'كولومبيا'),
(81153, 3358132224, 3358132479, 'AR', 'ARG', 'الأرجنتين'),
(81154, 3358132480, 3358132735, 'CO', 'COL', 'كولومبيا'),
(81155, 3358132736, 3358133247, 'EC', 'ECU', 'الإكوادور'),
(81156, 3358133248, 3358133759, 'VE', 'VEN', 'فنزويلا'),
(81157, 3358133760, 3358140471, 'AR', 'ARG', 'الأرجنتين'),
(81158, 3358140472, 3358140475, 'US', 'USA', 'الولايات المتحدة'),
(81159, 3358140476, 3358140547, 'AR', 'ARG', 'الأرجنتين'),
(81160, 3358140548, 3358140551, 'CL', 'CHL', 'تشيلي'),
(81161, 3358140552, 3358140623, 'AR', 'ARG', 'الأرجنتين'),
(81162, 3358140624, 3358140627, 'US', 'USA', 'الولايات المتحدة'),
(81163, 3358140628, 3358142719, 'AR', 'ARG', 'الأرجنتين'),
(81164, 3358142720, 3358142975, 'US', 'USA', 'الولايات المتحدة'),
(81165, 3358142976, 3358143231, 'CO', 'COL', 'كولومبيا'),
(81166, 3358143232, 3358143487, 'VE', 'VEN', 'فنزويلا'),
(81167, 3358143488, 3358143999, 'US', 'USA', 'الولايات المتحدة'),
(81168, 3358144000, 3358144511, 'CL', 'CHL', 'تشيلي'),
(81169, 3358144512, 3358145023, 'VE', 'VEN', 'فنزويلا'),
(81170, 3358145024, 3358147135, 'AR', 'ARG', 'الأرجنتين'),
(81171, 3358147136, 3358147167, 'US', 'USA', 'الولايات المتحدة'),
(81172, 3358147168, 3358149631, 'AR', 'ARG', 'الأرجنتين'),
(81173, 3358149632, 3358150655, 'CO', 'COL', 'كولومبيا'),
(81174, 3358150656, 3358151679, 'EC', 'ECU', 'الإكوادور'),
(81175, 3358151680, 3358152703, 'PE', 'PER', 'بيرو'),
(81176, 3358152704, 3358152959, 'US', 'USA', 'الولايات المتحدة'),
(81177, 3358152960, 3358153215, 'EC', 'ECU', 'الإكوادور'),
(81178, 3358153216, 3358153247, 'HT', 'HTI', 'هايتي'),
(81179, 3358153248, 3358153327, 'US', 'USA', 'الولايات المتحدة'),
(81180, 3358153328, 3358153343, 'AR', 'ARG', 'الأرجنتين'),
(81181, 3358153344, 3358153559, 'US', 'USA', 'الولايات المتحدة'),
(81182, 3358153560, 3358153567, 'CL', 'CHL', 'تشيلي'),
(81183, 3358153568, 3358153583, 'BR', 'BRA', 'البرازيل'),
(81184, 3358153584, 3358153727, 'US', 'USA', 'الولايات المتحدة'),
(81185, 3358153728, 3358153983, 'EC', 'ECU', 'الإكوادور'),
(81186, 3358153984, 3358154239, 'US', 'USA', 'الولايات المتحدة'),
(81187, 3358154240, 3358154751, 'CL', 'CHL', 'تشيلي'),
(81188, 3358154752, 3358158847, 'PE', 'PER', 'بيرو'),
(81189, 3358158848, 3358159103, 'AR', 'ARG', 'الأرجنتين'),
(81190, 3358159104, 3358159151, 'US', 'USA', 'الولايات المتحدة'),
(81191, 3358159152, 3358159159, 'AR', 'ARG', 'الأرجنتين'),
(81192, 3358159160, 3358159167, 'US', 'USA', 'الولايات المتحدة'),
(81193, 3358159168, 3358159359, 'AR', 'ARG', 'الأرجنتين'),
(81194, 3358159360, 3358159615, 'EC', 'ECU', 'الإكوادور'),
(81195, 3358159616, 3358159871, 'US', 'USA', 'الولايات المتحدة'),
(81196, 3358159872, 3358160895, 'VE', 'VEN', 'فنزويلا'),
(81197, 3358160896, 3358191615, 'AR', 'ARG', 'الأرجنتين'),
(81198, 3358191616, 3358192639, 'CL', 'CHL', 'تشيلي'),
(81199, 3358192640, 3358236671, 'AR', 'ARG', 'الأرجنتين'),
(81200, 3358236672, 3358244863, 'CL', 'CHL', 'تشيلي'),
(81201, 3358244864, 3358249367, 'DO', 'DOM', 'الدومينيكان'),
(81202, 3358249368, 3358249375, 'US', 'USA', 'الولايات المتحدة'),
(81203, 3358249376, 3358251839, 'DO', 'DOM', 'الدومينيكان'),
(81204, 3358251840, 3358251847, 'US', 'USA', 'الولايات المتحدة'),
(81205, 3358251848, 3358252007, 'DO', 'DOM', 'الدومينيكان'),
(81206, 3358252008, 3358252015, 'US', 'USA', 'الولايات المتحدة'),
(81207, 3358252016, 3358261247, 'DO', 'DOM', 'الدومينيكان'),
(81208, 3358261248, 3358264063, 'AR', 'ARG', 'الأرجنتين'),
(81209, 3358264064, 3358264319, 'PY', 'PRY', 'باراغواي'),
(81210, 3358264320, 3358326783, 'AR', 'ARG', 'الأرجنتين'),
(81211, 3358326784, 3358392319, 'VE', 'VEN', 'فنزويلا'),
(81212, 3358392320, 3358411263, 'AR', 'ARG', 'الأرجنتين'),
(81213, 3358411264, 3358411279, 'UY', 'URY', 'الأوروغواي'),
(81214, 3358411280, 3358457855, 'AR', 'ARG', 'الأرجنتين'),
(81215, 3358457856, 3358523391, 'PA', 'PAN', 'بنما'),
(81216, 3358523392, 3358543615, 'AR', 'ARG', 'الأرجنتين'),
(81217, 3358543616, 3358543871, 'VE', 'VEN', 'فنزويلا'),
(81218, 3358543872, 3358544127, 'MX', 'MEX', 'المكسيك'),
(81219, 3358544128, 3358558463, 'AR', 'ARG', 'الأرجنتين'),
(81220, 3358558464, 3358558975, 'PY', 'PRY', 'باراغواي'),
(81221, 3358558976, 3358559231, 'AR', 'ARG', 'الأرجنتين'),
(81222, 3358559232, 3358560255, 'VE', 'VEN', 'فنزويلا'),
(81223, 3358560256, 3358561791, 'AR', 'ARG', 'الأرجنتين'),
(81224, 3358561792, 3358562303, 'VE', 'VEN', 'فنزويلا'),
(81225, 3358562304, 3358563327, 'PE', 'PER', 'بيرو'),
(81226, 3358563328, 3358564095, 'CO', 'COL', 'كولومبيا'),
(81227, 3358564096, 3358564351, 'MX', 'MEX', 'المكسيك'),
(81228, 3358564352, 3358564479, 'AR', 'ARG', 'الأرجنتين'),
(81229, 3358564480, 3358564511, 'US', 'USA', 'الولايات المتحدة'),
(81230, 3358564512, 3358567423, 'AR', 'ARG', 'الأرجنتين'),
(81231, 3358567424, 3358568959, 'CO', 'COL', 'كولومبيا'),
(81232, 3358568960, 3358569471, 'MX', 'MEX', 'المكسيك'),
(81233, 3358569472, 3358570495, 'VE', 'VEN', 'فنزويلا'),
(81234, 3358570496, 3358570751, 'MX', 'MEX', 'المكسيك'),
(81235, 3358570752, 3358571263, 'PE', 'PER', 'بيرو'),
(81236, 3358571264, 3358572543, 'MX', 'MEX', 'المكسيك'),
(81237, 3358572544, 3358577151, 'AR', 'ARG', 'الأرجنتين'),
(81238, 3358577152, 3358577407, 'PE', 'PER', 'بيرو'),
(81239, 3358577408, 3358578431, 'AR', 'ARG', 'الأرجنتين'),
(81240, 3358578432, 3358578687, 'VE', 'VEN', 'فنزويلا'),
(81241, 3358578688, 3358579967, 'CO', 'COL', 'كولومبيا'),
(81242, 3358579968, 3358580223, 'AR', 'ARG', 'الأرجنتين'),
(81243, 3358580224, 3358580735, 'MX', 'MEX', 'المكسيك'),
(81244, 3358580736, 3358588927, 'AR', 'ARG', 'الأرجنتين'),
(81245, 3358588928, 3358654463, 'PE', 'PER', 'بيرو'),
(81246, 3358654464, 3358658559, 'AR', 'ARG', 'الأرجنتين'),
(81247, 3358658560, 3358660607, 'CL', 'CHL', 'تشيلي'),
(81248, 3358660608, 3358662655, 'AR', 'ARG', 'الأرجنتين'),
(81249, 3358666752, 3358695423, 'AR', 'ARG', 'الأرجنتين'),
(81250, 3358695424, 3358703615, 'GT', 'GTM', 'غواتيمالا'),
(81251, 3358703616, 3358715903, 'AR', 'ARG', 'الأرجنتين'),
(81252, 3358715904, 3358717951, 'EC', 'ECU', 'الإكوادور'),
(81253, 3358717952, 3358719999, 'AR', 'ARG', 'الأرجنتين'),
(81254, 3358720000, 3358728191, 'US', 'USA', 'الولايات المتحدة'),
(81255, 3358728192, 3358736383, 'CL', 'CHL', 'تشيلي'),
(81256, 3358736384, 3358737111, 'US', 'USA', 'الولايات المتحدة'),
(81257, 3358737112, 3358737119, 'CA', 'CAN', 'كندا'),
(81258, 3358737120, 3358744575, 'US', 'USA', 'الولايات المتحدة'),
(81259, 3358744576, 3358752767, 'CL', 'CHL', 'تشيلي'),
(81260, 3358752768, 3358756863, 'BB', 'BRB', 'باربادوس'),
(81261, 3358756864, 3358760959, 'CL', 'CHL', 'تشيلي'),
(81262, 3358760960, 3358769151, 'AR', 'ARG', 'الأرجنتين'),
(81263, 3358769152, 3358777343, 'HT', 'HTI', 'هايتي'),
(81264, 3358777344, 3358779391, 'CR', 'CRI', 'كوستا ريكا'),
(81265, 3358779392, 3358781439, 'EC', 'ECU', 'الإكوادور'),
(81266, 3358781440, 3358851071, 'AR', 'ARG', 'الأرجنتين'),
(81267, 3358851072, 3358982143, 'MX', 'MEX', 'المكسيك'),
(81268, 3358982144, 3359047679, 'CL', 'CHL', 'تشيلي'),
(81269, 3359047680, 3359057007, 'AR', 'ARG', 'الأرجنتين'),
(81270, 3359057008, 3359057023, 'CL', 'CHL', 'تشيلي'),
(81271, 3359057024, 3359080447, 'AR', 'ARG', 'الأرجنتين'),
(81272, 3359080448, 3359093295, 'CU', 'CUB', 'كوبا'),
(81273, 3359093296, 3359093303, 'EC', 'ECU', 'الإكوادور'),
(81274, 3359093304, 3359093335, 'CU', 'CUB', 'كوبا'),
(81275, 3359093336, 3359093343, 'DO', 'DOM', 'الدومينيكان'),
(81276, 3359093344, 3359095719, 'CU', 'CUB', 'كوبا'),
(81277, 3359095720, 3359095727, 'EC', 'ECU', 'الإكوادور'),
(81278, 3359095728, 3359096831, 'CU', 'CUB', 'كوبا'),
(81279, 3359096832, 3359105023, 'CL', 'CHL', 'تشيلي'),
(81280, 3359105024, 3359109119, 'EC', 'ECU', 'الإكوادور'),
(81281, 3359109120, 3359111167, 'AR', 'ARG', 'الأرجنتين'),
(81282, 3359111168, 3359113215, 'EC', 'ECU', 'الإكوادور'),
(81283, 3359113216, 3359244287, 'MX', 'MEX', 'المكسيك'),
(81284, 3359244288, 3359249695, 'US', 'USA', 'الولايات المتحدة'),
(81285, 3359249696, 3359249727, 'BR', 'BRA', 'البرازيل'),
(81286, 3359249728, 3359260671, 'US', 'USA', 'الولايات المتحدة'),
(81287, 3359260672, 3359268863, 'BO', 'BOL', 'بوليفيا'),
(81288, 3359268864, 3359275519, 'AR', 'ARG', 'الأرجنتين'),
(81289, 3359275520, 3359275551, 'VE', 'VEN', 'فنزويلا'),
(81290, 3359275552, 3359277055, 'AR', 'ARG', 'الأرجنتين'),
(81291, 3359277056, 3359285247, 'UY', 'URY', 'الأوروغواي'),
(81292, 3359285248, 3359293439, 'BO', 'BOL', 'بوليفيا'),
(81293, 3359293440, 3359305727, 'CO', 'COL', 'كولومبيا'),
(81294, 3359305728, 3359307775, 'DO', 'DOM', 'الدومينيكان'),
(81295, 3359307776, 3359309823, 'CL', 'CHL', 'تشيلي'),
(81296, 3359309824, 3359313919, 'AR', 'ARG', 'الأرجنتين'),
(81297, 3359313920, 3359315967, 'CR', 'CRI', 'كوستا ريكا'),
(81298, 3359315968, 3359318015, 'HN', 'HND', 'هندوراس'),
(81299, 3359318016, 3359356927, 'AR', 'ARG', 'الأرجنتين'),
(81300, 3359356928, 3359358975, 'VE', 'VEN', 'فنزويلا'),
(81301, 3359358976, 3359363071, 'AR', 'ARG', 'الأرجنتين'),
(81302, 3359367168, 3359375359, 'AR', 'ARG', 'الأرجنتين'),
(81303, 3359375360, 3359440895, 'PE', 'PER', 'بيرو'),
(81304, 3359440896, 3359457487, 'AR', 'ARG', 'الأرجنتين'),
(81305, 3359457488, 3359457503, 'EC', 'ECU', 'الإكوادور'),
(81306, 3359457504, 3359457663, 'AR', 'ARG', 'الأرجنتين'),
(81307, 3359457664, 3359457679, 'EC', 'ECU', 'الإكوادور'),
(81308, 3359457680, 3359457695, 'AR', 'ARG', 'الأرجنتين'),
(81309, 3359457696, 3359457727, 'BO', 'BOL', 'بوليفيا'),
(81310, 3359457728, 3359461951, 'AR', 'ARG', 'الأرجنتين'),
(81311, 3359461952, 3359462015, 'HN', 'HND', 'هندوراس'),
(81312, 3359462016, 3359462271, 'AR', 'ARG', 'الأرجنتين'),
(81313, 3359462272, 3359462335, 'UY', 'URY', 'الأوروغواي'),
(81314, 3359462336, 3359463399, 'AR', 'ARG', 'الأرجنتين'),
(81315, 3359463400, 3359463407, 'CO', 'COL', 'كولومبيا'),
(81316, 3359463408, 3359463423, 'BO', 'BOL', 'بوليفيا'),
(81317, 3359463424, 3359463679, 'AR', 'ARG', 'الأرجنتين'),
(81318, 3359463680, 3359463743, 'HN', 'HND', 'هندوراس'),
(81319, 3359463744, 3359464447, 'AR', 'ARG', 'الأرجنتين'),
(81320, 3359464448, 3359465471, 'UY', 'URY', 'الأوروغواي'),
(81321, 3359465472, 3359466495, 'AR', 'ARG', 'الأرجنتين'),
(81322, 3359466496, 3359466751, 'BO', 'BOL', 'بوليفيا'),
(81323, 3359466752, 3359472639, 'AR', 'ARG', 'الأرجنتين'),
(81324, 3359472640, 3359473663, 'PY', 'PRY', 'باراغواي'),
(81325, 3359473664, 3359498239, 'AR', 'ARG', 'الأرجنتين'),
(81326, 3359498240, 3359502335, 'PY', 'PRY', 'باراغواي'),
(81327, 3359506432, 3359508479, 'US', 'USA', 'الولايات المتحدة'),
(81328, 3359508480, 3359514623, 'VE', 'VEN', 'فنزويلا'),
(81329, 3359514624, 3359516671, 'US', 'USA', 'الولايات المتحدة'),
(81330, 3359516672, 3359516927, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(81331, 3359516928, 3359517183, 'US', 'USA', 'الولايات المتحدة'),
(81332, 3359517184, 3359517439, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(81333, 3359517440, 3359517695, 'US', 'USA', 'الولايات المتحدة'),
(81334, 3359517696, 3359517951, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(81335, 3359517952, 3359520255, 'US', 'USA', 'الولايات المتحدة'),
(81336, 3359520256, 3359520767, 'AR', 'ARG', 'الأرجنتين'),
(81337, 3359520768, 3359522815, 'US', 'USA', 'الولايات المتحدة'),
(81338, 3359522816, 3359539199, 'NI', 'NIC', 'نيكاراغوا'),
(81339, 3359539200, 3359550319, 'PE', 'PER', 'بيرو'),
(81340, 3359550320, 3359550335, 'NI', 'NIC', 'نيكاراغوا'),
(81341, 3359550336, 3359571967, 'PE', 'PER', 'بيرو'),
(81342, 3359571968, 3359582207, 'AR', 'ARG', 'الأرجنتين'),
(81343, 3359582208, 3359583871, 'PA', 'PAN', 'بنما'),
(81344, 3359583872, 3359583879, 'VE', 'VEN', 'فنزويلا'),
(81345, 3359583880, 3359584255, 'PA', 'PAN', 'بنما'),
(81346, 3359584256, 3359586303, 'AR', 'ARG', 'الأرجنتين'),
(81347, 3359586304, 3359588351, 'CL', 'CHL', 'تشيلي'),
(81348, 3359588352, 3359596543, 'AR', 'ARG', 'الأرجنتين'),
(81349, 3359596544, 3359598591, 'CL', 'CHL', 'تشيلي'),
(81350, 3359598592, 3359598655, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81351, 3359598656, 3359599039, 'PA', 'PAN', 'بنما'),
(81352, 3359599040, 3359599231, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81353, 3359599232, 3359599615, 'PA', 'PAN', 'بنما'),
(81354, 3359599616, 3359600511, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81355, 3359600512, 3359600639, 'PA', 'PAN', 'بنما'),
(81356, 3359600640, 3359621119, 'AR', 'ARG', 'الأرجنتين'),
(81357, 3359621120, 3359637503, 'EC', 'ECU', 'الإكوادور'),
(81358, 3359637504, 3359789583, 'MX', 'MEX', 'المكسيك'),
(81359, 3359789584, 3359789599, 'US', 'USA', 'الولايات المتحدة'),
(81360, 3359789600, 3359789823, 'MX', 'MEX', 'المكسيك'),
(81361, 3359789824, 3359789887, 'US', 'USA', 'الولايات المتحدة'),
(81362, 3359789888, 3359899647, 'MX', 'MEX', 'المكسيك'),
(81363, 3359899648, 3359916031, 'CL', 'CHL', 'تشيلي'),
(81364, 3359916032, 3359918143, 'AR', 'ARG', 'الأرجنتين'),
(81365, 3359918144, 3359918175, 'US', 'USA', 'الولايات المتحدة'),
(81366, 3359918176, 3359932415, 'AR', 'ARG', 'الأرجنتين'),
(81367, 3359932416, 3359948799, 'CO', 'COL', 'كولومبيا'),
(81368, 3359948800, 3359966719, 'AR', 'ARG', 'الأرجنتين'),
(81369, 3359966720, 3359966735, 'AW', 'ABW', 'أروبا'),
(81370, 3359966736, 3359989759, 'AR', 'ARG', 'الأرجنتين'),
(81371, 3359989760, 3359997951, 'CO', 'COL', 'كولومبيا'),
(81372, 3359997952, 3360006143, 'AR', 'ARG', 'الأرجنتين'),
(81373, 3360006144, 3360014335, 'EC', 'ECU', 'الإكوادور'),
(81374, 3360014336, 3360096255, 'AR', 'ARG', 'الأرجنتين'),
(81375, 3360096256, 3360104447, 'UY', 'URY', 'الأوروغواي'),
(81376, 3360104448, 3360116735, 'CO', 'COL', 'كولومبيا'),
(81377, 3360116736, 3360118783, 'BO', 'BOL', 'بوليفيا'),
(81378, 3360118784, 3360120831, 'AR', 'ARG', 'الأرجنتين'),
(81379, 3360120832, 3360124927, 'CO', 'COL', 'كولومبيا'),
(81380, 3360129024, 3360145407, 'VE', 'VEN', 'فنزويلا'),
(81381, 3360145408, 3360153599, 'CL', 'CHL', 'تشيلي'),
(81382, 3360153600, 3360157695, 'AR', 'ARG', 'الأرجنتين'),
(81383, 3360157696, 3360159743, 'VE', 'VEN', 'فنزويلا'),
(81384, 3360159744, 3360161791, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81385, 3360161792, 3360227327, 'CL', 'CHL', 'تشيلي'),
(81386, 3360227328, 3360227839, 'CO', 'COL', 'كولومبيا'),
(81387, 3360227840, 3360228863, 'CL', 'CHL', 'تشيلي'),
(81388, 3360228864, 3360229007, 'CO', 'COL', 'كولومبيا'),
(81389, 3360229008, 3360229023, 'US', 'USA', 'الولايات المتحدة'),
(81390, 3360229024, 3360230143, 'CO', 'COL', 'كولومبيا'),
(81391, 3360230144, 3360230399, 'CL', 'CHL', 'تشيلي'),
(81392, 3360230400, 3360231423, 'CO', 'COL', 'كولومبيا'),
(81393, 3360231424, 3360231775, 'CL', 'CHL', 'تشيلي'),
(81394, 3360231776, 3360231807, 'US', 'USA', 'الولايات المتحدة'),
(81395, 3360231808, 3360231935, 'CL', 'CHL', 'تشيلي'),
(81396, 3360231936, 3360232447, 'CO', 'COL', 'كولومبيا'),
(81397, 3360232448, 3360233471, 'CL', 'CHL', 'تشيلي'),
(81398, 3360233472, 3360235263, 'CO', 'COL', 'كولومبيا'),
(81399, 3360235264, 3360235271, 'CL', 'CHL', 'تشيلي'),
(81400, 3360235272, 3360235487, 'CO', 'COL', 'كولومبيا'),
(81401, 3360235488, 3360235495, 'CL', 'CHL', 'تشيلي'),
(81402, 3360235496, 3360235519, 'CO', 'COL', 'كولومبيا'),
(81403, 3360235520, 3360235775, 'CL', 'CHL', 'تشيلي'),
(81404, 3360235776, 3360236375, 'CO', 'COL', 'كولومبيا'),
(81405, 3360236376, 3360236383, 'CL', 'CHL', 'تشيلي'),
(81406, 3360236384, 3360236511, 'CO', 'COL', 'كولومبيا'),
(81407, 3360236512, 3360236519, 'CL', 'CHL', 'تشيلي'),
(81408, 3360236520, 3360236799, 'CO', 'COL', 'كولومبيا'),
(81409, 3360236800, 3360237055, 'CL', 'CHL', 'تشيلي'),
(81410, 3360237056, 3360238847, 'CO', 'COL', 'كولومبيا'),
(81411, 3360238848, 3360239103, 'CL', 'CHL', 'تشيلي'),
(81412, 3360239104, 3360240639, 'CO', 'COL', 'كولومبيا'),
(81413, 3360240640, 3360241151, 'CL', 'CHL', 'تشيلي'),
(81414, 3360241152, 3360242175, 'CO', 'COL', 'كولومبيا'),
(81415, 3360242176, 3360242431, 'CL', 'CHL', 'تشيلي'),
(81416, 3360242432, 3360243199, 'CO', 'COL', 'كولومبيا'),
(81417, 3360243200, 3360243455, 'CL', 'CHL', 'تشيلي'),
(81418, 3360243456, 3360243711, 'CO', 'COL', 'كولومبيا'),
(81419, 3360243712, 3360243967, 'CL', 'CHL', 'تشيلي'),
(81420, 3360243968, 3360244095, 'CO', 'COL', 'كولومبيا'),
(81421, 3360244096, 3360244127, 'CL', 'CHL', 'تشيلي'),
(81422, 3360244128, 3360244479, 'CO', 'COL', 'كولومبيا'),
(81423, 3360244480, 3360244735, 'CL', 'CHL', 'تشيلي'),
(81424, 3360244736, 3360245119, 'CO', 'COL', 'كولومبيا'),
(81425, 3360245120, 3360245123, 'CL', 'CHL', 'تشيلي'),
(81426, 3360245124, 3360245199, 'CO', 'COL', 'كولومبيا'),
(81427, 3360245200, 3360245203, 'CL', 'CHL', 'تشيلي'),
(81428, 3360245204, 3360245759, 'CO', 'COL', 'كولومبيا'),
(81429, 3360245760, 3360247863, 'CL', 'CHL', 'تشيلي'),
(81430, 3360247864, 3360247871, 'US', 'USA', 'الولايات المتحدة'),
(81431, 3360247872, 3360248831, 'CL', 'CHL', 'تشيلي'),
(81432, 3360248832, 3360251135, 'CO', 'COL', 'كولومبيا'),
(81433, 3360251136, 3360251391, 'CL', 'CHL', 'تشيلي'),
(81434, 3360251392, 3360251903, 'CO', 'COL', 'كولومبيا'),
(81435, 3360251904, 3360253951, 'BO', 'BOL', 'بوليفيا'),
(81436, 3360253952, 3360255999, 'SV', 'SLV', 'السلفادور'),
(81437, 3360258048, 3360260095, 'CL', 'CHL', 'تشيلي'),
(81438, 3360260096, 3360276479, 'AR', 'ARG', 'الأرجنتين'),
(81439, 3360276480, 3360278527, 'VE', 'VEN', 'فنزويلا'),
(81440, 3360278528, 3360280575, 'EC', 'ECU', 'الإكوادور'),
(81441, 3360280576, 3360282623, 'CL', 'CHL', 'تشيلي'),
(81442, 3360282624, 3360284671, 'CO', 'COL', 'كولومبيا'),
(81443, 3360284672, 3360325631, 'CL', 'CHL', 'تشيلي'),
(81444, 3360325632, 3360333823, 'CO', 'COL', 'كولومبيا'),
(81445, 3360333824, 3360342015, 'CL', 'CHL', 'تشيلي'),
(81446, 3360342016, 3360354303, 'VE', 'VEN', 'فنزويلا'),
(81447, 3360354304, 3360356351, 'PA', 'PAN', 'بنما'),
(81448, 3360356352, 3360358399, 'CR', 'CRI', 'كوستا ريكا'),
(81449, 3360358400, 3360358911, 'CL', 'CHL', 'تشيلي'),
(81450, 3360358912, 3360358919, 'CO', 'COL', 'كولومبيا'),
(81451, 3360358920, 3360366591, 'CL', 'CHL', 'تشيلي'),
(81452, 3360366592, 3360382975, 'CO', 'COL', 'كولومبيا'),
(81453, 3360382976, 3360399359, 'VE', 'VEN', 'فنزويلا'),
(81454, 3360399360, 3360403455, 'BO', 'BOL', 'بوليفيا'),
(81455, 3360403456, 3360405503, 'AR', 'ARG', 'الأرجنتين'),
(81456, 3360405504, 3360407551, 'HN', 'HND', 'هندوراس'),
(81457, 3360407552, 3360423935, 'PA', 'PAN', 'بنما'),
(81458, 3360423936, 3360455935, 'MX', 'MEX', 'المكسيك'),
(81459, 3360455936, 3360456703, 'US', 'USA', 'الولايات المتحدة'),
(81460, 3360456704, 3360547983, 'MX', 'MEX', 'المكسيك'),
(81461, 3360547984, 3360547999, 'NI', 'NIC', 'نيكاراغوا'),
(81462, 3360548000, 3360686079, 'MX', 'MEX', 'المكسيك'),
(81463, 3360686080, 3360687871, 'CO', 'COL', 'كولومبيا'),
(81464, 3360687872, 3360687975, 'AR', 'ARG', 'الأرجنتين'),
(81465, 3360687976, 3360687983, 'CO', 'COL', 'كولومبيا'),
(81466, 3360687984, 3360688079, 'AR', 'ARG', 'الأرجنتين'),
(81467, 3360688080, 3360688119, 'CO', 'COL', 'كولومبيا'),
(81468, 3360688120, 3360688127, 'AR', 'ARG', 'الأرجنتين'),
(81469, 3360688128, 3360688639, 'CO', 'COL', 'كولومبيا'),
(81470, 3360688640, 3360688895, 'AR', 'ARG', 'الأرجنتين'),
(81471, 3360688896, 3360689151, 'CO', 'COL', 'كولومبيا'),
(81472, 3360689152, 3360690175, 'AR', 'ARG', 'الأرجنتين'),
(81473, 3360690176, 3360690199, 'CO', 'COL', 'كولومبيا'),
(81474, 3360690200, 3360690215, 'AR', 'ARG', 'الأرجنتين'),
(81475, 3360690216, 3360690223, 'CO', 'COL', 'كولومبيا'),
(81476, 3360690224, 3360690231, 'AR', 'ARG', 'الأرجنتين'),
(81477, 3360690232, 3360690303, 'CO', 'COL', 'كولومبيا'),
(81478, 3360690304, 3360690327, 'AR', 'ARG', 'الأرجنتين'),
(81479, 3360690328, 3360690351, 'CO', 'COL', 'كولومبيا'),
(81480, 3360690352, 3360690415, 'AR', 'ARG', 'الأرجنتين'),
(81481, 3360690416, 3360690623, 'CO', 'COL', 'كولومبيا'),
(81482, 3360690624, 3360690687, 'AR', 'ARG', 'الأرجنتين'),
(81483, 3360690688, 3360690703, 'CO', 'COL', 'كولومبيا'),
(81484, 3360690704, 3360690719, 'AR', 'ARG', 'الأرجنتين'),
(81485, 3360690720, 3360690735, 'CO', 'COL', 'كولومبيا'),
(81486, 3360690736, 3360690879, 'AR', 'ARG', 'الأرجنتين'),
(81487, 3360690880, 3360691199, 'CO', 'COL', 'كولومبيا'),
(81488, 3360691200, 3360691391, 'AR', 'ARG', 'الأرجنتين'),
(81489, 3360691392, 3360691455, 'CO', 'COL', 'كولومبيا'),
(81490, 3360691456, 3360691967, 'AR', 'ARG', 'الأرجنتين'),
(81491, 3360691968, 3360692319, 'CO', 'COL', 'كولومبيا'),
(81492, 3360692320, 3360692367, 'AR', 'ARG', 'الأرجنتين'),
(81493, 3360692368, 3360692431, 'CO', 'COL', 'كولومبيا'),
(81494, 3360692432, 3360692439, 'AR', 'ARG', 'الأرجنتين'),
(81495, 3360692440, 3360692479, 'CO', 'COL', 'كولومبيا'),
(81496, 3360692480, 3360692671, 'AR', 'ARG', 'الأرجنتين'),
(81497, 3360692672, 3360692735, 'CO', 'COL', 'كولومبيا'),
(81498, 3360692736, 3360692799, 'AR', 'ARG', 'الأرجنتين'),
(81499, 3360692800, 3360692863, 'CO', 'COL', 'كولومبيا'),
(81500, 3360692864, 3360693263, 'AR', 'ARG', 'الأرجنتين'),
(81501, 3360693264, 3360693279, 'CO', 'COL', 'كولومبيا'),
(81502, 3360693280, 3360693351, 'AR', 'ARG', 'الأرجنتين'),
(81503, 3360693352, 3360693407, 'CO', 'COL', 'كولومبيا'),
(81504, 3360693408, 3360693423, 'AR', 'ARG', 'الأرجنتين'),
(81505, 3360693424, 3360693503, 'CO', 'COL', 'كولومبيا'),
(81506, 3360693504, 3360693799, 'AR', 'ARG', 'الأرجنتين'),
(81507, 3360693800, 3360693855, 'CO', 'COL', 'كولومبيا'),
(81508, 3360693856, 3360694015, 'AR', 'ARG', 'الأرجنتين'),
(81509, 3360694016, 3360694071, 'CO', 'COL', 'كولومبيا'),
(81510, 3360694072, 3360694079, 'AR', 'ARG', 'الأرجنتين'),
(81511, 3360694080, 3360694239, 'CO', 'COL', 'كولومبيا'),
(81512, 3360694240, 3360694247, 'AR', 'ARG', 'الأرجنتين'),
(81513, 3360694248, 3360694391, 'CO', 'COL', 'كولومبيا'),
(81514, 3360694392, 3360694415, 'AR', 'ARG', 'الأرجنتين'),
(81515, 3360694416, 3360694431, 'CO', 'COL', 'كولومبيا'),
(81516, 3360694432, 3360694447, 'AR', 'ARG', 'الأرجنتين'),
(81517, 3360694448, 3360694463, 'CO', 'COL', 'كولومبيا'),
(81518, 3360694464, 3360694783, 'AR', 'ARG', 'الأرجنتين'),
(81519, 3360694784, 3360695039, 'CO', 'COL', 'كولومبيا'),
(81520, 3360695040, 3360695263, 'AR', 'ARG', 'الأرجنتين'),
(81521, 3360695264, 3360695295, 'CO', 'COL', 'كولومبيا'),
(81522, 3360695296, 3360696447, 'AR', 'ARG', 'الأرجنتين'),
(81523, 3360696448, 3360696487, 'CO', 'COL', 'كولومبيا'),
(81524, 3360696488, 3360696495, 'AR', 'ARG', 'الأرجنتين'),
(81525, 3360696496, 3360696511, 'CO', 'COL', 'كولومبيا'),
(81526, 3360696512, 3360696543, 'AR', 'ARG', 'الأرجنتين'),
(81527, 3360696544, 3360696575, 'CO', 'COL', 'كولومبيا'),
(81528, 3360696576, 3360696703, 'AR', 'ARG', 'الأرجنتين'),
(81529, 3360696704, 3360696719, 'CO', 'COL', 'كولومبيا'),
(81530, 3360696720, 3360696735, 'AR', 'ARG', 'الأرجنتين'),
(81531, 3360696736, 3360696767, 'CO', 'COL', 'كولومبيا'),
(81532, 3360696768, 3360696783, 'AR', 'ARG', 'الأرجنتين'),
(81533, 3360696784, 3360697343, 'CO', 'COL', 'كولومبيا'),
(81534, 3360697344, 3360697599, 'AR', 'ARG', 'الأرجنتين'),
(81535, 3360697600, 3360697855, 'CO', 'COL', 'كولومبيا'),
(81536, 3360697856, 3360698111, 'AR', 'ARG', 'الأرجنتين'),
(81537, 3360698112, 3360698879, 'CO', 'COL', 'كولومبيا'),
(81538, 3360698880, 3360698911, 'AR', 'ARG', 'الأرجنتين'),
(81539, 3360698912, 3360698991, 'CO', 'COL', 'كولومبيا'),
(81540, 3360698992, 3360699007, 'AR', 'ARG', 'الأرجنتين'),
(81541, 3360699008, 3360699647, 'CO', 'COL', 'كولومبيا'),
(81542, 3360699648, 3360699903, 'AR', 'ARG', 'الأرجنتين'),
(81543, 3360699904, 3360700415, 'CO', 'COL', 'كولومبيا'),
(81544, 3360700416, 3360701311, 'AR', 'ARG', 'الأرجنتين'),
(81545, 3360701312, 3360701695, 'CO', 'COL', 'كولومبيا'),
(81546, 3360701696, 3360701951, 'AR', 'ARG', 'الأرجنتين'),
(81547, 3360701952, 3360702207, 'CO', 'COL', 'كولومبيا'),
(81548, 3360702208, 3360705023, 'AR', 'ARG', 'الأرجنتين'),
(81549, 3360705024, 3360706559, 'US', 'USA', 'الولايات المتحدة'),
(81550, 3360706560, 3360708863, 'AR', 'ARG', 'الأرجنتين'),
(81551, 3360708864, 3360710655, 'US', 'USA', 'الولايات المتحدة'),
(81552, 3360710656, 3360718847, 'HT', 'HTI', 'هايتي'),
(81553, 3360718848, 3360763903, 'AR', 'ARG', 'الأرجنتين'),
(81554, 3360763904, 3360765951, 'GT', 'GTM', 'غواتيمالا'),
(81555, 3360765952, 3360767999, 'CO', 'COL', 'كولومبيا'),
(81556, 3360768000, 3360772351, 'AR', 'ARG', 'الأرجنتين'),
(81557, 3360772352, 3360772479, 'BO', 'BOL', 'بوليفيا'),
(81558, 3360772480, 3360780319, 'AR', 'ARG', 'الأرجنتين'),
(81559, 3360780320, 3360780323, 'BR', 'BRA', 'البرازيل'),
(81560, 3360780324, 3360780815, 'AR', 'ARG', 'الأرجنتين'),
(81561, 3360780816, 3360780827, 'BR', 'BRA', 'البرازيل'),
(81562, 3360780828, 3360780863, 'AR', 'ARG', 'الأرجنتين'),
(81563, 3360780864, 3360780871, 'BR', 'BRA', 'البرازيل'),
(81564, 3360780872, 3360780927, 'AR', 'ARG', 'الأرجنتين'),
(81565, 3360780928, 3360780931, 'BR', 'BRA', 'البرازيل'),
(81566, 3360780932, 3360780935, 'AR', 'ARG', 'الأرجنتين'),
(81567, 3360780936, 3360780943, 'BR', 'BRA', 'البرازيل'),
(81568, 3360780944, 3360780951, 'AR', 'ARG', 'الأرجنتين'),
(81569, 3360780952, 3360780955, 'BR', 'BRA', 'البرازيل'),
(81570, 3360780956, 3360780971, 'AR', 'ARG', 'الأرجنتين'),
(81571, 3360780972, 3360780975, 'BR', 'BRA', 'البرازيل'),
(81572, 3360780976, 3360780991, 'AR', 'ARG', 'الأرجنتين'),
(81573, 3360780992, 3360780995, 'BR', 'BRA', 'البرازيل'),
(81574, 3360780996, 3360781379, 'AR', 'ARG', 'الأرجنتين'),
(81575, 3360781380, 3360781387, 'MX', 'MEX', 'المكسيك'),
(81576, 3360781388, 3360781439, 'AR', 'ARG', 'الأرجنتين'),
(81577, 3360781440, 3360781443, 'VE', 'VEN', 'فنزويلا'),
(81578, 3360781444, 3360781447, 'AR', 'ARG', 'الأرجنتين'),
(81579, 3360781448, 3360781451, 'US', 'USA', 'الولايات المتحدة'),
(81580, 3360781452, 3360781455, 'AR', 'ARG', 'الأرجنتين'),
(81581, 3360781456, 3360781459, 'CO', 'COL', 'كولومبيا'),
(81582, 3360781460, 3360781461, 'DO', 'DOM', 'الدومينيكان'),
(81583, 3360781462, 3360781463, 'AR', 'ARG', 'الأرجنتين'),
(81584, 3360781464, 3360781471, 'PR', 'PRI', 'بورتو ريكو'),
(81585, 3360781472, 3360781479, 'DO', 'DOM', 'الدومينيكان'),
(81586, 3360781480, 3360781483, 'VE', 'VEN', 'فنزويلا'),
(81587, 3360781484, 3360781491, 'MX', 'MEX', 'المكسيك'),
(81588, 3360781492, 3360781495, 'AR', 'ARG', 'الأرجنتين'),
(81589, 3360781496, 3360781507, 'MX', 'MEX', 'المكسيك'),
(81590, 3360781508, 3360781511, 'AR', 'ARG', 'الأرجنتين'),
(81591, 3360781512, 3360781515, 'MX', 'MEX', 'المكسيك'),
(81592, 3360781516, 3360781519, 'AR', 'ARG', 'الأرجنتين'),
(81593, 3360781520, 3360781523, 'MX', 'MEX', 'المكسيك'),
(81594, 3360781524, 3360781527, 'CO', 'COL', 'كولومبيا'),
(81595, 3360781528, 3360781539, 'VE', 'VEN', 'فنزويلا'),
(81596, 3360781540, 3360781543, 'AR', 'ARG', 'الأرجنتين'),
(81597, 3360781544, 3360781547, 'PR', 'PRI', 'بورتو ريكو'),
(81598, 3360781548, 3360781551, 'AR', 'ARG', 'الأرجنتين'),
(81599, 3360781552, 3360781555, 'VE', 'VEN', 'فنزويلا'),
(81600, 3360781556, 3360781559, 'MX', 'MEX', 'المكسيك'),
(81601, 3360781560, 3360781563, 'GT', 'GTM', 'غواتيمالا'),
(81602, 3360781564, 3360781567, 'PR', 'PRI', 'بورتو ريكو'),
(81603, 3360781568, 3360788479, 'AR', 'ARG', 'الأرجنتين'),
(81604, 3360788480, 3360790527, 'CL', 'CHL', 'تشيلي'),
(81605, 3360790528, 3360849919, 'AR', 'ARG', 'الأرجنتين'),
(81606, 3360849920, 3360882687, 'VE', 'VEN', 'فنزويلا'),
(81607, 3360882688, 3360948223, 'CL', 'CHL', 'تشيلي'),
(81608, 3360948224, 3361013759, 'VE', 'VEN', 'فنزويلا'),
(81609, 3361013760, 3361021951, 'SV', 'SLV', 'السلفادور'),
(81610, 3361021952, 3361030143, 'PY', 'PRY', 'باراغواي'),
(81611, 3361030144, 3361034239, 'VE', 'VEN', 'فنزويلا'),
(81612, 3361034240, 3361036287, 'EC', 'ECU', 'الإكوادور'),
(81613, 3361036288, 3361046527, 'AR', 'ARG', 'الأرجنتين'),
(81614, 3361046528, 3361052671, 'BO', 'BOL', 'بوليفيا'),
(81615, 3361052672, 3361054719, 'AR', 'ARG', 'الأرجنتين'),
(81616, 3361054720, 3361058815, 'NI', 'NIC', 'نيكاراغوا'),
(81617, 3361058816, 3361062911, 'AR', 'ARG', 'الأرجنتين'),
(81618, 3361062912, 3361071103, 'CL', 'CHL', 'تشيلي'),
(81619, 3361071104, 3361079295, 'CO', 'COL', 'كولومبيا'),
(81620, 3361079296, 3361144831, 'CL', 'CHL', 'تشيلي'),
(81621, 3361144832, 3361210367, 'BO', 'BOL', 'بوليفيا'),
(81622, 3361210368, 3361275903, 'DO', 'DOM', 'الدومينيكان'),
(81623, 3361275904, 3361276639, 'PE', 'PER', 'بيرو'),
(81624, 3361276640, 3361276647, 'US', 'USA', 'الولايات المتحدة'),
(81625, 3361276648, 3361284095, 'PE', 'PER', 'بيرو'),
(81626, 3361284096, 3361296383, 'CL', 'CHL', 'تشيلي'),
(81627, 3361296384, 3361298431, 'SV', 'SLV', 'السلفادور'),
(81628, 3361298432, 3361300479, 'DO', 'DOM', 'الدومينيكان'),
(81629, 3361300480, 3361308671, 'CO', 'COL', 'كولومبيا'),
(81630, 3361308672, 3361325055, 'AR', 'ARG', 'الأرجنتين'),
(81631, 3361325056, 3361341439, 'CO', 'COL', 'كولومبيا'),
(81632, 3361341440, 3361374207, 'VE', 'VEN', 'فنزويلا'),
(81633, 3361374208, 3361378303, 'PA', 'PAN', 'بنما'),
(81634, 3361378304, 3361380351, 'BO', 'BOL', 'بوليفيا'),
(81635, 3361380352, 3361382399, 'EC', 'ECU', 'الإكوادور'),
(81636, 3361382400, 3361415167, 'CL', 'CHL', 'تشيلي'),
(81637, 3361415168, 3361417215, 'AR', 'ARG', 'الأرجنتين'),
(81638, 3361417216, 3361419263, 'CL', 'CHL', 'تشيلي'),
(81639, 3361419264, 3361423359, 'AR', 'ARG', 'الأرجنتين'),
(81640, 3361423360, 3361456127, 'CR', 'CRI', 'كوستا ريكا'),
(81641, 3361456128, 3361471131, 'CO', 'COL', 'كولومبيا'),
(81642, 3361471132, 3361471135, 'CL', 'CHL', 'تشيلي'),
(81643, 3361471136, 3361472511, 'CO', 'COL', 'كولومبيا'),
(81644, 3361472512, 3361538047, 'MX', 'MEX', 'المكسيك'),
(81645, 3361538048, 3361570815, 'VE', 'VEN', 'فنزويلا'),
(81646, 3361570816, 3361587199, 'CO', 'COL', 'كولومبيا'),
(81647, 3361587200, 3361599487, 'EC', 'ECU', 'الإكوادور'),
(81648, 3361599488, 3361600767, 'UY', 'URY', 'الأوروغواي'),
(81649, 3361601536, 3361603583, 'EC', 'ECU', 'الإكوادور'),
(81650, 3361603584, 3361734655, 'MX', 'MEX', 'المكسيك'),
(81651, 3361734656, 3362258943, 'BR', 'BRA', 'البرازيل'),
(81652, 3362258944, 3362324479, 'CL', 'CHL', 'تشيلي'),
(81653, 3362324480, 3362324735, 'AR', 'ARG', 'الأرجنتين'),
(81654, 3362324736, 3362325247, 'US', 'USA', 'الولايات المتحدة'),
(81655, 3362325248, 3362325759, 'AR', 'ARG', 'الأرجنتين'),
(81656, 3362325760, 3362326271, 'US', 'USA', 'الولايات المتحدة'),
(81657, 3362326272, 3362327039, 'AR', 'ARG', 'الأرجنتين'),
(81658, 3362327040, 3362327551, 'US', 'USA', 'الولايات المتحدة'),
(81659, 3362327552, 3362328063, 'AR', 'ARG', 'الأرجنتين'),
(81660, 3362328064, 3362328575, 'US', 'USA', 'الولايات المتحدة'),
(81661, 3362328576, 3362330623, 'CO', 'COL', 'كولومبيا'),
(81662, 3362330624, 3362337279, 'AR', 'ARG', 'الأرجنتين'),
(81663, 3362337280, 3362338047, 'US', 'USA', 'الولايات المتحدة'),
(81664, 3362338048, 3362338559, 'AR', 'ARG', 'الأرجنتين'),
(81665, 3362338560, 3362339071, 'US', 'USA', 'الولايات المتحدة'),
(81666, 3362339072, 3362339327, 'AR', 'ARG', 'الأرجنتين'),
(81667, 3362339328, 3362339839, 'US', 'USA', 'الولايات المتحدة'),
(81668, 3362339840, 3362342143, 'AR', 'ARG', 'الأرجنتين'),
(81669, 3362342144, 3362342399, 'PA', 'PAN', 'بنما'),
(81670, 3362342400, 3362342911, 'US', 'USA', 'الولايات المتحدة'),
(81671, 3362342912, 3362343423, 'AR', 'ARG', 'الأرجنتين'),
(81672, 3362343424, 3362343679, 'US', 'USA', 'الولايات المتحدة'),
(81673, 3362343680, 3362343935, 'CO', 'COL', 'كولومبيا'),
(81674, 3362343936, 3362344447, 'AR', 'ARG', 'الأرجنتين'),
(81675, 3362344448, 3362344959, 'US', 'USA', 'الولايات المتحدة'),
(81676, 3362344960, 3362347007, 'PA', 'PAN', 'بنما'),
(81677, 3362347008, 3362347519, 'AR', 'ARG', 'الأرجنتين'),
(81678, 3362347520, 3362347775, 'CO', 'COL', 'كولومبيا'),
(81679, 3362347776, 3362348799, 'AR', 'ARG', 'الأرجنتين'),
(81680, 3362348800, 3362349055, 'US', 'USA', 'الولايات المتحدة'),
(81681, 3362349056, 3362351103, 'CR', 'CRI', 'كوستا ريكا'),
(81682, 3362351104, 3362353151, 'AR', 'ARG', 'الأرجنتين'),
(81683, 3362353152, 3362355199, 'EC', 'ECU', 'الإكوادور'),
(81684, 3362355200, 3362357247, 'AR', 'ARG', 'الأرجنتين'),
(81685, 3362357248, 3362381823, 'BO', 'BOL', 'بوليفيا'),
(81686, 3362381824, 3362390015, 'EC', 'ECU', 'الإكوادور'),
(81687, 3362390016, 3362422783, 'PE', 'PER', 'بيرو'),
(81688, 3362422784, 3362426879, 'CO', 'COL', 'كولومبيا'),
(81689, 3362426880, 3362428927, 'PA', 'PAN', 'بنما'),
(81690, 3362428928, 3362430975, 'CL', 'CHL', 'تشيلي'),
(81691, 3362430976, 3362447359, 'CO', 'COL', 'كولومبيا'),
(81692, 3362447360, 3362449407, 'HN', 'HND', 'هندوراس'),
(81693, 3362449408, 3362450175, 'SV', 'SLV', 'السلفادور'),
(81694, 3362450176, 3362451455, 'HN', 'HND', 'هندوراس'),
(81695, 3362455552, 3362471935, 'EC', 'ECU', 'الإكوادور'),
(81696, 3362471936, 3362476031, 'CL', 'CHL', 'تشيلي'),
(81697, 3362476032, 3362476287, 'HN', 'HND', 'هندوراس'),
(81698, 3362476288, 3362476543, 'AR', 'ARG', 'الأرجنتين'),
(81699, 3362476544, 3362477055, 'CR', 'CRI', 'كوستا ريكا'),
(81700, 3362484224, 3362486271, 'AR', 'ARG', 'الأرجنتين'),
(81701, 3362486272, 3362488319, 'HN', 'HND', 'هندوراس'),
(81702, 3362488320, 3362504703, 'PE', 'PER', 'بيرو'),
(81703, 3362504704, 3362506751, 'VE', 'VEN', 'فنزويلا'),
(81704, 3362506752, 3362508799, 'AR', 'ARG', 'الأرجنتين'),
(81705, 3362508800, 3362510847, 'HN', 'HND', 'هندوراس'),
(81706, 3362510848, 3362512895, 'GT', 'GTM', 'غواتيمالا'),
(81707, 3362512896, 3362514943, 'AR', 'ARG', 'الأرجنتين'),
(81708, 3362514944, 3362516991, 'HN', 'HND', 'هندوراس'),
(81709, 3362516992, 3362519039, 'BO', 'BOL', 'بوليفيا'),
(81710, 3362519040, 3362521087, 'EC', 'ECU', 'الإكوادور'),
(81711, 3362521088, 3362529279, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(81712, 3362529280, 3362533375, 'PA', 'PAN', 'بنما'),
(81713, 3362537472, 3362545663, 'AR', 'ARG', 'الأرجنتين'),
(81714, 3362545664, 3362549759, 'PE', 'PER', 'بيرو'),
(81715, 3362553856, 3362557951, 'PY', 'PRY', 'باراغواي'),
(81716, 3362570240, 3362586623, 'UY', 'URY', 'الأوروغواي'),
(81717, 3362586624, 3362652159, 'VE', 'VEN', 'فنزويلا'),
(81718, 3362652160, 3362664447, 'PE', 'PER', 'بيرو'),
(81719, 3362668544, 3362676735, 'EC', 'ECU', 'الإكوادور'),
(81720, 3362680832, 3362684927, 'EC', 'ECU', 'الإكوادور'),
(81721, 3362684928, 3362688767, 'AR', 'ARG', 'الأرجنتين'),
(81722, 3362688768, 3362689279, 'CO', 'COL', 'كولومبيا'),
(81723, 3362689280, 3362689311, 'AR', 'ARG', 'الأرجنتين'),
(81724, 3362689312, 3362689535, 'CO', 'COL', 'كولومبيا'),
(81725, 3362689536, 3362689567, 'AR', 'ARG', 'الأرجنتين'),
(81726, 3362689568, 3362689599, 'CO', 'COL', 'كولومبيا'),
(81727, 3362689600, 3362689615, 'AR', 'ARG', 'الأرجنتين'),
(81728, 3362689616, 3362690015, 'CO', 'COL', 'كولومبيا'),
(81729, 3362690016, 3362690047, 'AR', 'ARG', 'الأرجنتين'),
(81730, 3362690048, 3362690367, 'CO', 'COL', 'كولومبيا'),
(81731, 3362690368, 3362690431, 'AR', 'ARG', 'الأرجنتين'),
(81732, 3362690432, 3362691071, 'CO', 'COL', 'كولومبيا'),
(81733, 3362691072, 3362692095, 'PA', 'PAN', 'بنما'),
(81734, 3362692096, 3362692223, 'AR', 'ARG', 'الأرجنتين'),
(81735, 3362692224, 3362692231, 'CO', 'COL', 'كولومبيا'),
(81736, 3362692232, 3362692239, 'AR', 'ARG', 'الأرجنتين'),
(81737, 3362692240, 3362692351, 'CO', 'COL', 'كولومبيا'),
(81738, 3362692352, 3362692607, 'MX', 'MEX', 'المكسيك'),
(81739, 3362692608, 3362692863, 'CO', 'COL', 'كولومبيا'),
(81740, 3362692864, 3362695167, 'AR', 'ARG', 'الأرجنتين'),
(81741, 3362695168, 3362697215, 'CO', 'COL', 'كولومبيا'),
(81742, 3362697216, 3362703359, 'AR', 'ARG', 'الأرجنتين'),
(81743, 3362705408, 3362711551, 'AR', 'ARG', 'الأرجنتين'),
(81744, 3362711552, 3362713599, 'EC', 'ECU', 'الإكوادور'),
(81745, 3362713600, 3362717695, 'GT', 'GTM', 'غواتيمالا'),
(81746, 3362717696, 3362815999, 'CL', 'CHL', 'تشيلي'),
(81747, 3362816000, 3362832383, 'AR', 'ARG', 'الأرجنتين'),
(81748, 3362832384, 3362836479, 'BO', 'BOL', 'بوليفيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(81749, 3362840576, 3362893999, 'CL', 'CHL', 'تشيلي'),
(81750, 3362894000, 3362894007, 'AW', 'ABW', 'أروبا'),
(81751, 3362894008, 3362897919, 'CL', 'CHL', 'تشيلي'),
(81752, 3362897920, 3362906111, 'HT', 'HTI', 'هايتي'),
(81753, 3362914304, 3362930687, 'CO', 'COL', 'كولومبيا'),
(81754, 3362934784, 3362936831, 'AR', 'ARG', 'الأرجنتين'),
(81755, 3362936832, 3362938879, 'CL', 'CHL', 'تشيلي'),
(81756, 3362938880, 3362942975, 'AR', 'ARG', 'الأرجنتين'),
(81757, 3362942976, 3362945023, 'GT', 'GTM', 'غواتيمالا'),
(81758, 3362945024, 3362983935, 'AR', 'ARG', 'الأرجنتين'),
(81759, 3362988032, 3362992127, 'EC', 'ECU', 'الإكوادور'),
(81760, 3362996224, 3363000319, 'UY', 'URY', 'الأوروغواي'),
(81761, 3363004416, 3363008511, 'CO', 'COL', 'كولومبيا'),
(81762, 3363008512, 3363012607, 'US', 'USA', 'الولايات المتحدة'),
(81763, 3363012608, 3363013967, 'PA', 'PAN', 'بنما'),
(81764, 3363013968, 3363013975, 'NI', 'NIC', 'نيكاراغوا'),
(81765, 3363013976, 3363024895, 'PA', 'PAN', 'بنما'),
(81766, 3363028992, 3363045375, 'AR', 'ARG', 'الأرجنتين'),
(81767, 3363045376, 3363110911, 'CO', 'COL', 'كولومبيا'),
(81768, 3363110912, 3363112063, 'AR', 'ARG', 'الأرجنتين'),
(81769, 3363112064, 3363112079, 'PY', 'PRY', 'باراغواي'),
(81770, 3363112080, 3363112127, 'AR', 'ARG', 'الأرجنتين'),
(81771, 3363112128, 3363112143, 'PY', 'PRY', 'باراغواي'),
(81772, 3363112144, 3363176447, 'AR', 'ARG', 'الأرجنتين'),
(81773, 3363176448, 3363274751, 'CO', 'COL', 'كولومبيا'),
(81774, 3363274752, 3363291135, 'GT', 'GTM', 'غواتيمالا'),
(81775, 3363291136, 3363299327, 'BO', 'BOL', 'بوليفيا'),
(81776, 3363299328, 3363373055, 'CL', 'CHL', 'تشيلي'),
(81777, 3363373056, 3363438591, 'PE', 'PER', 'بيرو'),
(81778, 3363438592, 3363471359, 'AR', 'ARG', 'الأرجنتين'),
(81779, 3363471360, 3363487743, 'CR', 'CRI', 'كوستا ريكا'),
(81780, 3363487744, 3363504127, 'CO', 'COL', 'كولومبيا'),
(81781, 3363504128, 3363512319, 'PE', 'PER', 'بيرو'),
(81782, 3363520512, 3363553599, 'AR', 'ARG', 'الأرجنتين'),
(81783, 3363553600, 3363553663, 'US', 'USA', 'الولايات المتحدة'),
(81784, 3363553664, 3363553791, 'AR', 'ARG', 'الأرجنتين'),
(81785, 3363553792, 3363554303, 'US', 'USA', 'الولايات المتحدة'),
(81786, 3363554304, 3363554431, 'BR', 'BRA', 'البرازيل'),
(81787, 3363554432, 3363554815, 'AR', 'ARG', 'الأرجنتين'),
(81788, 3363554816, 3363554943, 'US', 'USA', 'الولايات المتحدة'),
(81789, 3363554944, 3363557375, 'AR', 'ARG', 'الأرجنتين'),
(81790, 3363561472, 3363565567, 'CO', 'COL', 'كولومبيا'),
(81791, 3363569664, 3363577855, 'PA', 'PAN', 'بنما'),
(81792, 3363577856, 3363586047, 'CL', 'CHL', 'تشيلي'),
(81793, 3363602432, 3363610623, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81794, 3363610624, 3363614719, 'CO', 'COL', 'كولومبيا'),
(81795, 3363618816, 3363622911, 'UY', 'URY', 'الأوروغواي'),
(81796, 3363627008, 3363635199, 'EC', 'ECU', 'الإكوادور'),
(81797, 3363635200, 3363651583, 'UY', 'URY', 'الأوروغواي'),
(81798, 3363651584, 3363667967, 'AR', 'ARG', 'الأرجنتين'),
(81799, 3363667968, 3363676159, 'EC', 'ECU', 'الإكوادور'),
(81800, 3363676160, 3363678207, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(81801, 3363680256, 3363682303, 'GT', 'GTM', 'غواتيمالا'),
(81802, 3363682304, 3363684351, 'VE', 'VEN', 'فنزويلا'),
(81803, 3363684352, 3363708927, 'EC', 'ECU', 'الإكوادور'),
(81804, 3363717120, 3363733503, 'CL', 'CHL', 'تشيلي'),
(81805, 3363733504, 3363831807, 'AR', 'ARG', 'الأرجنتين'),
(81806, 3363831808, 3378511871, 'BR', 'BRA', 'البرازيل'),
(81807, 3378511872, 3382675583, 'MX', 'MEX', 'المكسيك'),
(81808, 3382675584, 3382675599, 'CL', 'CHL', 'تشيلي'),
(81809, 3382675600, 3383754751, 'MX', 'MEX', 'المكسيك'),
(81810, 3384737792, 3385851903, 'CR', 'CRI', 'كوستا ريكا'),
(81811, 3385851904, 3386114047, 'VE', 'VEN', 'فنزويلا'),
(81812, 3386114048, 3386245119, 'AR', 'ARG', 'الأرجنتين'),
(81813, 3386245120, 3386376191, 'CL', 'CHL', 'تشيلي'),
(81814, 3386376192, 3386392575, 'CO', 'COL', 'كولومبيا'),
(81815, 3386392576, 3386408959, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81816, 3386408960, 3386425343, 'GT', 'GTM', 'غواتيمالا'),
(81817, 3386425344, 3386429855, 'AR', 'ARG', 'الأرجنتين'),
(81818, 3386429856, 3386429863, 'US', 'USA', 'الولايات المتحدة'),
(81819, 3386429864, 3386441727, 'AR', 'ARG', 'الأرجنتين'),
(81820, 3386441728, 3386458111, 'PY', 'PRY', 'باراغواي'),
(81821, 3386458112, 3386474495, 'EC', 'ECU', 'الإكوادور'),
(81822, 3386474496, 3386490879, 'UY', 'URY', 'الأوروغواي'),
(81823, 3386490880, 3386499071, 'CO', 'COL', 'كولومبيا'),
(81824, 3386507264, 3386523647, 'EC', 'ECU', 'الإكوادور'),
(81825, 3386523648, 3386540031, 'PA', 'PAN', 'بنما'),
(81826, 3386540032, 3386548223, 'CL', 'CHL', 'تشيلي'),
(81827, 3386556416, 3386572799, 'PA', 'PAN', 'بنما'),
(81828, 3386572800, 3386589183, 'EC', 'ECU', 'الإكوادور'),
(81829, 3386589184, 3386597375, 'AR', 'ARG', 'الأرجنتين'),
(81830, 3386605568, 3386613759, 'CL', 'CHL', 'تشيلي'),
(81831, 3386621952, 3386630143, 'CO', 'COL', 'كولومبيا'),
(81832, 3386638336, 3386642431, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81833, 3386646528, 3386662911, 'CO', 'COL', 'كولومبيا'),
(81834, 3386662912, 3386671103, 'CL', 'CHL', 'تشيلي'),
(81835, 3386671104, 3386675199, 'HN', 'HND', 'هندوراس'),
(81836, 3386679296, 3386687487, 'AR', 'ARG', 'الأرجنتين'),
(81837, 3386687488, 3386695679, 'CU', 'CUB', 'كوبا'),
(81838, 3386695680, 3386703871, 'CL', 'CHL', 'تشيلي'),
(81839, 3386703872, 3386720255, 'UY', 'URY', 'الأوروغواي'),
(81840, 3386720256, 3386728447, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(81841, 3386728448, 3386732543, 'AR', 'ARG', 'الأرجنتين'),
(81842, 3386732544, 3386734591, 'CL', 'CHL', 'تشيلي'),
(81843, 3386736640, 3386753023, 'CO', 'COL', 'كولومبيا'),
(81844, 3386753024, 3386761215, 'CL', 'CHL', 'تشيلي'),
(81845, 3386761216, 3386769407, 'PA', 'PAN', 'بنما'),
(81846, 3386769408, 3386773503, 'VE', 'VEN', 'فنزويلا'),
(81847, 3386777600, 3386781695, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(81848, 3386785792, 3386802175, 'BO', 'BOL', 'بوليفيا'),
(81849, 3386802176, 3386900479, 'CL', 'CHL', 'تشيلي'),
(81850, 3386900480, 3387162623, 'PA', 'PAN', 'بنما'),
(81851, 3387162624, 3387228159, 'CO', 'COL', 'كولومبيا'),
(81852, 3387228160, 3387244543, 'AW', 'ABW', 'أروبا'),
(81853, 3387260928, 3387293695, 'DO', 'DOM', 'الدومينيكان'),
(81854, 3387293696, 3387359231, 'PE', 'PER', 'بيرو'),
(81855, 3387359232, 3387424767, 'AR', 'ARG', 'الأرجنتين'),
(81856, 3387424768, 3387555839, 'CO', 'COL', 'كولومبيا'),
(81857, 3387555840, 3387559999, 'AR', 'ARG', 'الأرجنتين'),
(81858, 3387560000, 3387560063, 'BR', 'BRA', 'البرازيل'),
(81859, 3387560064, 3387568127, 'AR', 'ARG', 'الأرجنتين'),
(81860, 3387568128, 3387572223, 'PE', 'PER', 'بيرو'),
(81861, 3387572224, 3387576319, 'CO', 'COL', 'كولومبيا'),
(81862, 3387576320, 3387578367, 'EC', 'ECU', 'الإكوادور'),
(81863, 3387578368, 3387584511, 'AR', 'ARG', 'الأرجنتين'),
(81864, 3387584512, 3387588607, 'PE', 'PER', 'بيرو'),
(81865, 3387588608, 3387600895, 'AR', 'ARG', 'الأرجنتين'),
(81866, 3387600896, 3387604991, 'CO', 'COL', 'كولومبيا'),
(81867, 3387604992, 3387613183, 'EC', 'ECU', 'الإكوادور'),
(81868, 3387613184, 3387617279, 'VE', 'VEN', 'فنزويلا'),
(81869, 3387617280, 3387617327, 'CO', 'COL', 'كولومبيا'),
(81870, 3387617328, 3387617335, 'CL', 'CHL', 'تشيلي'),
(81871, 3387617336, 3387619327, 'CO', 'COL', 'كولومبيا'),
(81872, 3387619328, 3387686911, 'AR', 'ARG', 'الأرجنتين'),
(81873, 3387686912, 3387736063, 'CL', 'CHL', 'تشيلي'),
(81874, 3387736064, 3387752447, 'CO', 'COL', 'كولومبيا'),
(81875, 3387752448, 3387817983, 'CR', 'CRI', 'كوستا ريكا'),
(81876, 3387817984, 3387834367, 'VE', 'VEN', 'فنزويلا'),
(81877, 3387834368, 3387850751, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(81878, 3387850752, 3387867135, 'EC', 'ECU', 'الإكوادور'),
(81879, 3387867136, 3387949055, 'CL', 'CHL', 'تشيلي'),
(81880, 3387949056, 3388014591, 'PE', 'PER', 'بيرو'),
(81881, 3388014592, 3388080127, 'CL', 'CHL', 'تشيلي'),
(81882, 3388080128, 3388211199, 'VE', 'VEN', 'فنزويلا'),
(81883, 3388211200, 3388323671, 'CO', 'COL', 'كولومبيا'),
(81884, 3388323672, 3388323679, 'GS', 'SGS', 'جورجيا الجنوبية وجزر ساندويتش الجنوبية'),
(81885, 3388323680, 3388342271, 'CO', 'COL', 'كولومبيا'),
(81886, 3388342272, 3388407807, 'CL', 'CHL', 'تشيلي'),
(81887, 3388407808, 3388473343, 'SV', 'SLV', 'السلفادور'),
(81888, 3388473344, 3388604415, 'VE', 'VEN', 'فنزويلا'),
(81889, 3388604416, 3388827407, 'AR', 'ARG', 'الأرجنتين'),
(81890, 3388827408, 3388827415, 'AW', 'ABW', 'أروبا'),
(81891, 3388827416, 3388997631, 'AR', 'ARG', 'الأرجنتين'),
(81892, 3388997632, 3389001727, 'AU', 'AUS', 'أستراليا'),
(81893, 3389001728, 3389005823, 'PH', 'PHL', 'الفلبين'),
(81894, 3389005824, 3389014015, 'NZ', 'NZL', 'نيوزيلاندا'),
(81895, 3389014016, 3389014271, 'AU', 'AUS', 'أستراليا'),
(81896, 3389014272, 3389014783, 'JP', 'JPN', 'اليابان'),
(81897, 3389014784, 3389015807, 'AU', 'AUS', 'أستراليا'),
(81898, 3389015808, 3389016063, 'SG', 'SGP', 'سنغافورة'),
(81899, 3389016064, 3389016575, 'JP', 'JPN', 'اليابان'),
(81900, 3389016576, 3389017087, 'AU', 'AUS', 'أستراليا'),
(81901, 3389017088, 3389017343, 'JP', 'JPN', 'اليابان'),
(81902, 3389017344, 3389017855, 'HK', 'HKG', 'هونغ كونغ'),
(81903, 3389017856, 3389018111, 'AU', 'AUS', 'أستراليا'),
(81904, 3389018112, 3389018367, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(81905, 3389018368, 3389018623, 'ID', 'IDN', 'إندونيسيا'),
(81906, 3389018624, 3389019135, 'AU', 'AUS', 'أستراليا'),
(81907, 3389019136, 3389019391, 'NZ', 'NZL', 'نيوزيلاندا'),
(81908, 3389019392, 3389020159, 'AU', 'AUS', 'أستراليا'),
(81909, 3389020160, 3389020671, 'SG', 'SGP', 'سنغافورة'),
(81910, 3389020672, 3389020927, 'AU', 'AUS', 'أستراليا'),
(81911, 3389020928, 3389021183, 'PH', 'PHL', 'الفلبين'),
(81912, 3389021184, 3389021439, 'AU', 'AUS', 'أستراليا'),
(81913, 3389021440, 3389021695, 'JP', 'JPN', 'اليابان'),
(81914, 3389021696, 3389021951, 'MY', 'MYS', 'ماليزيا'),
(81915, 3389021952, 3389022463, 'AU', 'AUS', 'أستراليا'),
(81916, 3389022464, 3389022719, 'NZ', 'NZL', 'نيوزيلاندا'),
(81917, 3389022720, 3389023231, 'AU', 'AUS', 'أستراليا'),
(81918, 3389023232, 3389023487, 'HK', 'HKG', 'هونغ كونغ'),
(81919, 3389023488, 3389023999, 'AU', 'AUS', 'أستراليا'),
(81920, 3389024000, 3389024255, 'ID', 'IDN', 'إندونيسيا'),
(81921, 3389024256, 3389024511, 'HK', 'HKG', 'هونغ كونغ'),
(81922, 3389024512, 3389025791, 'AU', 'AUS', 'أستراليا'),
(81923, 3389025792, 3389026047, 'CN', 'CHN', 'الصين'),
(81924, 3389026048, 3389026303, 'TH', 'THA', 'تايلند'),
(81925, 3389026304, 3389026559, 'HK', 'HKG', 'هونغ كونغ'),
(81926, 3389026560, 3389027327, 'AU', 'AUS', 'أستراليا'),
(81927, 3389027328, 3389027583, 'ID', 'IDN', 'إندونيسيا'),
(81928, 3389027584, 3389028607, 'TH', 'THA', 'تايلند'),
(81929, 3389028608, 3389028863, 'NZ', 'NZL', 'نيوزيلاندا'),
(81930, 3389028864, 3389029375, 'HK', 'HKG', 'هونغ كونغ'),
(81931, 3389029376, 3389029887, 'NZ', 'NZL', 'نيوزيلاندا'),
(81932, 3389029888, 3389030399, 'SG', 'SGP', 'سنغافورة'),
(81933, 3389030400, 3389035519, 'HK', 'HKG', 'هونغ كونغ'),
(81934, 3389035520, 3389035775, 'AU', 'AUS', 'أستراليا'),
(81935, 3389035776, 3389036287, 'SG', 'SGP', 'سنغافورة'),
(81936, 3389036288, 3389036543, 'NZ', 'NZL', 'نيوزيلاندا'),
(81937, 3389036544, 3389036799, 'SG', 'SGP', 'سنغافورة'),
(81938, 3389036800, 3389037055, 'NZ', 'NZL', 'نيوزيلاندا'),
(81939, 3389037056, 3389037567, 'AU', 'AUS', 'أستراليا'),
(81940, 3389037568, 3389038591, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(81941, 3389038592, 3389044735, 'HK', 'HKG', 'هونغ كونغ'),
(81942, 3389044736, 3389045759, 'AU', 'AUS', 'أستراليا'),
(81943, 3389045760, 3389046783, 'FR', 'FRA', 'فرنسا'),
(81944, 3389046784, 3389063167, 'US', 'USA', 'الولايات المتحدة'),
(81945, 3389063168, 3389064447, 'AU', 'AUS', 'أستراليا'),
(81946, 3389064448, 3389064703, 'SG', 'SGP', 'سنغافورة'),
(81947, 3389064704, 3389065215, 'HK', 'HKG', 'هونغ كونغ'),
(81948, 3389065216, 3389067263, 'NZ', 'NZL', 'نيوزيلاندا'),
(81949, 3389067264, 3389071359, 'AU', 'AUS', 'أستراليا'),
(81950, 3389071360, 3389079551, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(81951, 3389079552, 3389092351, 'SG', 'SGP', 'سنغافورة'),
(81952, 3389092352, 3389092863, 'PH', 'PHL', 'الفلبين'),
(81953, 3389092864, 3389093887, 'AU', 'AUS', 'أستراليا'),
(81954, 3389093888, 3389095935, 'IN', 'IND', 'الهند'),
(81955, 3389095936, 3389104127, 'SG', 'SGP', 'سنغافورة'),
(81956, 3389104128, 3389112319, 'SB', 'SLB', 'جزر سليمان'),
(81957, 3389112320, 3389116415, 'MV', 'MDV', 'جزر المالديف'),
(81958, 3389116416, 3389120511, 'JP', 'JPN', 'اليابان'),
(81959, 3389120512, 3389122559, 'AU', 'AUS', 'أستراليا'),
(81960, 3389122560, 3389122815, 'HK', 'HKG', 'هونغ كونغ'),
(81961, 3389122816, 3389123583, 'AU', 'AUS', 'أستراليا'),
(81962, 3389123584, 3389123839, 'ID', 'IDN', 'إندونيسيا'),
(81963, 3389123840, 3389124351, 'AU', 'AUS', 'أستراليا'),
(81964, 3389124352, 3389124607, 'SG', 'SGP', 'سنغافورة'),
(81965, 3389124608, 3389128703, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(81966, 3389128704, 3389129727, 'AU', 'AUS', 'أستراليا'),
(81967, 3389129728, 3389132799, 'NZ', 'NZL', 'نيوزيلاندا'),
(81968, 3389132800, 3389136895, 'AU', 'AUS', 'أستراليا'),
(81969, 3389136896, 3389142015, 'HK', 'HKG', 'هونغ كونغ'),
(81970, 3389142016, 3389143039, 'TW', 'TWN', 'تايوان'),
(81971, 3389143040, 3389145087, 'AU', 'AUS', 'أستراليا'),
(81972, 3389145088, 3389151231, 'HK', 'HKG', 'هونغ كونغ'),
(81973, 3389151232, 3389152255, 'JP', 'JPN', 'اليابان'),
(81974, 3389152256, 3389153279, 'AU', 'AUS', 'أستراليا'),
(81975, 3389153280, 3389161471, 'TV', 'TUV', 'توفالو'),
(81976, 3389161472, 3389165286, 'JP', 'JPN', 'اليابان'),
(81977, 3389165287, 3389165287, 'SG', 'SGP', 'سنغافورة'),
(81978, 3389165288, 3389165631, 'JP', 'JPN', 'اليابان'),
(81979, 3389165632, 3389165695, 'CN', 'CHN', 'الصين'),
(81980, 3389165696, 3389194239, 'JP', 'JPN', 'اليابان'),
(81981, 3389194240, 3389195775, 'AU', 'AUS', 'أستراليا'),
(81982, 3389195776, 3389196287, 'HK', 'HKG', 'هونغ كونغ'),
(81983, 3389196288, 3389197567, 'AU', 'AUS', 'أستراليا'),
(81984, 3389197568, 3389197823, 'IN', 'IND', 'الهند'),
(81985, 3389197824, 3389198079, 'AU', 'AUS', 'أستراليا'),
(81986, 3389198080, 3389198335, 'IN', 'IND', 'الهند'),
(81987, 3389198336, 3389202431, 'NZ', 'NZL', 'نيوزيلاندا'),
(81988, 3389202432, 3389210623, 'AU', 'AUS', 'أستراليا'),
(81989, 3389210624, 3389210879, 'IN', 'IND', 'الهند'),
(81990, 3389210880, 3389211135, 'AU', 'AUS', 'أستراليا'),
(81991, 3389211136, 3389211391, 'IN', 'IND', 'الهند'),
(81992, 3389211392, 3389211647, 'AU', 'AUS', 'أستراليا'),
(81993, 3389211648, 3389212671, 'TH', 'THA', 'تايلند'),
(81994, 3389212672, 3389213439, 'AU', 'AUS', 'أستراليا'),
(81995, 3389213440, 3389214207, 'IN', 'IND', 'الهند'),
(81996, 3389214208, 3389222911, 'AU', 'AUS', 'أستراليا'),
(81997, 3389222912, 3389225983, 'IN', 'IND', 'الهند'),
(81998, 3389225984, 3389226239, 'HK', 'HKG', 'هونغ كونغ'),
(81999, 3389226240, 3389226495, 'IN', 'IND', 'الهند'),
(82000, 3389226496, 3389226751, 'SG', 'SGP', 'سنغافورة'),
(82001, 3389226752, 3389227007, 'JP', 'JPN', 'اليابان'),
(82002, 3389227008, 3389227263, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(82003, 3389227264, 3389227519, 'AU', 'AUS', 'أستراليا'),
(82004, 3389227520, 3389228031, 'PK', 'PAK', 'باكستان'),
(82005, 3389228032, 3389228799, 'AU', 'AUS', 'أستراليا'),
(82006, 3389228800, 3389229055, 'SG', 'SGP', 'سنغافورة'),
(82007, 3389229056, 3389229311, 'JP', 'JPN', 'اليابان'),
(82008, 3389229312, 3389229567, 'AU', 'AUS', 'أستراليا'),
(82009, 3389229568, 3389230079, 'SG', 'SGP', 'سنغافورة'),
(82010, 3389230080, 3389235199, 'JP', 'JPN', 'اليابان'),
(82011, 3389235200, 3389243391, 'TW', 'TWN', 'تايوان'),
(82012, 3389243392, 3389247487, 'AU', 'AUS', 'أستراليا'),
(82013, 3389247488, 3389251583, 'ID', 'IDN', 'إندونيسيا'),
(82014, 3389251584, 3389259775, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(82015, 3389259776, 3389263871, 'PH', 'PHL', 'الفلبين'),
(82016, 3389263872, 3389266175, 'NZ', 'NZL', 'نيوزيلاندا'),
(82017, 3389266176, 3389266431, 'IN', 'IND', 'الهند'),
(82018, 3389266432, 3389266943, 'HK', 'HKG', 'هونغ كونغ'),
(82019, 3389266944, 3389267967, 'AU', 'AUS', 'أستراليا'),
(82020, 3389267968, 3389276159, 'WS', 'WSM', 'ساموا'),
(82021, 3389276160, 3389284351, 'AU', 'AUS', 'أستراليا'),
(82022, 3389284352, 3389292543, 'BD', 'BGD', 'بنغالاديش'),
(82023, 3389292544, 3389300735, 'CN', 'CHN', 'الصين'),
(82024, 3389300736, 3389301247, 'ID', 'IDN', 'إندونيسيا'),
(82025, 3389301248, 3389301759, 'AU', 'AUS', 'أستراليا'),
(82026, 3389301760, 3389302015, 'IN', 'IND', 'الهند'),
(82027, 3389302016, 3389302527, 'AU', 'AUS', 'أستراليا'),
(82028, 3389302528, 3389302783, 'PK', 'PAK', 'باكستان'),
(82029, 3389302784, 3389303039, 'VN', 'VNM', 'فييتنام'),
(82030, 3389303040, 3389303295, 'TW', 'TWN', 'تايوان'),
(82031, 3389303296, 3389303807, 'ID', 'IDN', 'إندونيسيا'),
(82032, 3389303808, 3389304063, 'IN', 'IND', 'الهند'),
(82033, 3389304064, 3389304319, 'BD', 'BGD', 'بنغالاديش'),
(82034, 3389304320, 3389304575, 'PH', 'PHL', 'الفلبين'),
(82035, 3389304576, 3389304831, 'AU', 'AUS', 'أستراليا'),
(82036, 3389304832, 3389305087, 'VN', 'VNM', 'فييتنام'),
(82037, 3389305088, 3389305599, 'IN', 'IND', 'الهند'),
(82038, 3389305600, 3389305855, 'ID', 'IDN', 'إندونيسيا'),
(82039, 3389305856, 3389306111, 'IN', 'IND', 'الهند'),
(82040, 3389306112, 3389306367, 'AU', 'AUS', 'أستراليا'),
(82041, 3389306368, 3389306623, 'IN', 'IND', 'الهند'),
(82042, 3389306624, 3389306879, 'AU', 'AUS', 'أستراليا'),
(82043, 3389306880, 3389307135, 'FJ', 'FJI', 'فيجي'),
(82044, 3389307136, 3389307647, 'ID', 'IDN', 'إندونيسيا'),
(82045, 3389307648, 3389307903, 'JP', 'JPN', 'اليابان'),
(82046, 3389307904, 3389308159, 'AU', 'AUS', 'أستراليا'),
(82047, 3389308160, 3389308415, 'KH', 'KHM', 'كامبوديا'),
(82048, 3389308416, 3389308671, 'AU', 'AUS', 'أستراليا'),
(82049, 3389308672, 3389308927, 'PH', 'PHL', 'الفلبين'),
(82050, 3389308928, 3389317119, 'HK', 'HKG', 'هونغ كونغ'),
(82051, 3389317120, 3389322239, 'AU', 'AUS', 'أستراليا'),
(82052, 3389322240, 3389324031, 'JP', 'JPN', 'اليابان'),
(82053, 3389324032, 3389324287, 'VU', 'VUT', 'فانواتو'),
(82054, 3389324288, 3389325311, 'CN', 'CHN', 'الصين'),
(82055, 3389325312, 3389326335, 'AU', 'AUS', 'أستراليا'),
(82056, 3389326336, 3389326847, 'TW', 'TWN', 'تايوان'),
(82057, 3389326848, 3389327359, 'AU', 'AUS', 'أستراليا'),
(82058, 3389327360, 3389329407, 'TW', 'TWN', 'تايوان'),
(82059, 3389329408, 3389333503, 'AU', 'AUS', 'أستراليا'),
(82060, 3389333504, 3389341695, 'BD', 'BGD', 'بنغالاديش'),
(82061, 3389341696, 3389345791, 'JP', 'JPN', 'اليابان'),
(82062, 3389345792, 3389349887, 'TH', 'THA', 'تايلند'),
(82063, 3389349888, 3389358079, 'AU', 'AUS', 'أستراليا'),
(82064, 3389358080, 3389366271, 'PK', 'PAK', 'باكستان'),
(82065, 3389366272, 3389374463, 'AU', 'AUS', 'أستراليا'),
(82066, 3389374464, 3389382655, 'MN', 'MNG', 'منغوليا'),
(82067, 3389382656, 3389390847, 'TW', 'TWN', 'تايوان'),
(82068, 3389390848, 3389391359, 'HK', 'HKG', 'هونغ كونغ'),
(82069, 3389391360, 3389391615, 'VN', 'VNM', 'فييتنام'),
(82070, 3389391616, 3389392127, 'AU', 'AUS', 'أستراليا'),
(82071, 3389392128, 3389392895, 'NZ', 'NZL', 'نيوزيلاندا'),
(82072, 3389392896, 3389411327, 'AU', 'AUS', 'أستراليا'),
(82073, 3389411328, 3389411583, 'IN', 'IND', 'الهند'),
(82074, 3389411584, 3389412351, 'AU', 'AUS', 'أستراليا'),
(82075, 3389412352, 3389412863, 'NZ', 'NZL', 'نيوزيلاندا'),
(82076, 3389412864, 3389413119, 'AU', 'AUS', 'أستراليا'),
(82077, 3389413120, 3389413375, 'NZ', 'NZL', 'نيوزيلاندا'),
(82078, 3389413376, 3389413887, 'AU', 'AUS', 'أستراليا'),
(82079, 3389413888, 3389414143, 'TH', 'THA', 'تايلند'),
(82080, 3389414144, 3389414911, 'AU', 'AUS', 'أستراليا'),
(82081, 3389414912, 3389415167, 'HK', 'HKG', 'هونغ كونغ'),
(82082, 3389415168, 3389415423, 'KR', 'KOR', 'جمهورية كوريا'),
(82083, 3389415424, 3389415935, 'VN', 'VNM', 'فييتنام'),
(82084, 3389415936, 3389416191, 'JP', 'JPN', 'اليابان'),
(82085, 3389416192, 3389416447, 'IN', 'IND', 'الهند'),
(82086, 3389416448, 3389416959, 'TH', 'THA', 'تايلند'),
(82087, 3389416960, 3389417215, 'SG', 'SGP', 'سنغافورة'),
(82088, 3389417216, 3389417471, 'JP', 'JPN', 'اليابان'),
(82089, 3389417472, 3389417983, 'TW', 'TWN', 'تايوان'),
(82090, 3389417984, 3389418239, 'AU', 'AUS', 'أستراليا'),
(82091, 3389418240, 3389418495, 'TH', 'THA', 'تايلند'),
(82092, 3389418496, 3389418751, 'AU', 'AUS', 'أستراليا'),
(82093, 3389418752, 3389419263, 'NZ', 'NZL', 'نيوزيلاندا'),
(82094, 3389419264, 3389419519, 'TH', 'THA', 'تايلند'),
(82095, 3389419520, 3389420543, 'AU', 'AUS', 'أستراليا'),
(82096, 3389420544, 3389421055, 'NZ', 'NZL', 'نيوزيلاندا'),
(82097, 3389421056, 3389421311, 'AU', 'AUS', 'أستراليا'),
(82098, 3389421312, 3389421567, 'JP', 'JPN', 'اليابان'),
(82099, 3389421568, 3389422591, 'KI', 'KIR', 'كيريباتي'),
(82100, 3389422592, 3389431807, 'AU', 'AUS', 'أستراليا'),
(82101, 3389431808, 3389435903, 'SG', 'SGP', 'سنغافورة'),
(82102, 3389435904, 3389439999, 'AU', 'AUS', 'أستراليا'),
(82103, 3389440000, 3389444095, 'HK', 'HKG', 'هونغ كونغ'),
(82104, 3389444096, 3389452287, 'ID', 'IDN', 'إندونيسيا'),
(82105, 3389452288, 3389453311, 'SG', 'SGP', 'سنغافورة'),
(82106, 3389453312, 3389454335, 'JP', 'JPN', 'اليابان'),
(82107, 3389454336, 3389455359, 'AU', 'AUS', 'أستراليا'),
(82108, 3389455360, 3389456383, 'JP', 'JPN', 'اليابان'),
(82109, 3389456384, 3389456895, 'NZ', 'NZL', 'نيوزيلاندا'),
(82110, 3389456896, 3389457407, 'AU', 'AUS', 'أستراليا'),
(82111, 3389457408, 3389458431, 'NZ', 'NZL', 'نيوزيلاندا'),
(82112, 3389458432, 3389460479, 'AU', 'AUS', 'أستراليا'),
(82113, 3389460480, 3389464575, 'JP', 'JPN', 'اليابان'),
(82114, 3389464576, 3389469695, 'NZ', 'NZL', 'نيوزيلاندا'),
(82115, 3389469696, 3389471743, 'IN', 'IND', 'الهند'),
(82116, 3389471744, 3389472767, 'NZ', 'NZL', 'نيوزيلاندا'),
(82117, 3389472768, 3389480959, 'AU', 'AUS', 'أستراليا'),
(82118, 3389480960, 3389489151, 'JP', 'JPN', 'اليابان'),
(82119, 3389489152, 3389493247, 'HK', 'HKG', 'هونغ كونغ'),
(82120, 3389493248, 3389521919, 'AU', 'AUS', 'أستراليا'),
(82121, 3389521920, 3389523455, 'SG', 'SGP', 'سنغافورة'),
(82122, 3389523456, 3389523967, 'JP', 'JPN', 'اليابان'),
(82123, 3389523968, 3389525503, 'NZ', 'NZL', 'نيوزيلاندا'),
(82124, 3389525504, 3389526015, 'TW', 'TWN', 'تايوان'),
(82125, 3389526016, 3389528319, 'AU', 'AUS', 'أستراليا'),
(82126, 3389528320, 3389528575, 'TH', 'THA', 'تايلند'),
(82127, 3389528576, 3389529087, 'JP', 'JPN', 'اليابان'),
(82128, 3389529088, 3389529599, 'ID', 'IDN', 'إندونيسيا'),
(82129, 3389529600, 3389529855, 'PH', 'PHL', 'الفلبين'),
(82130, 3389529856, 3389532159, 'AU', 'AUS', 'أستراليا'),
(82131, 3389532160, 3389533183, 'SG', 'SGP', 'سنغافورة'),
(82132, 3389533184, 3389534207, 'NZ', 'NZL', 'نيوزيلاندا'),
(82133, 3389534208, 3389538303, 'JP', 'JPN', 'اليابان'),
(82134, 3389538304, 3389538559, 'AU', 'AUS', 'أستراليا'),
(82135, 3389538560, 3389540351, 'TH', 'THA', 'تايلند'),
(82136, 3389540352, 3389541887, 'AU', 'AUS', 'أستراليا'),
(82137, 3389541888, 3389542399, 'TH', 'THA', 'تايلند'),
(82138, 3389542400, 3389543423, 'JP', 'JPN', 'اليابان'),
(82139, 3389543424, 3389544447, 'TH', 'THA', 'تايلند'),
(82140, 3389544448, 3389545471, 'HK', 'HKG', 'هونغ كونغ'),
(82141, 3389545472, 3389545727, 'AU', 'AUS', 'أستراليا'),
(82142, 3389545728, 3389545983, 'HK', 'HKG', 'هونغ كونغ'),
(82143, 3389545984, 3389546495, 'SG', 'SGP', 'سنغافورة'),
(82144, 3389546496, 3389554687, 'AU', 'AUS', 'أستراليا'),
(82145, 3389554688, 3389562879, 'CN', 'CHN', 'الصين'),
(82146, 3389562880, 3389575167, 'AU', 'AUS', 'أستراليا'),
(82147, 3389575168, 3389579233, 'JP', 'JPN', 'اليابان'),
(82148, 3389579234, 3389579263, 'AU', 'AUS', 'أستراليا'),
(82149, 3389579264, 3389587455, 'PH', 'PHL', 'الفلبين'),
(82150, 3389587456, 3389612031, 'AU', 'AUS', 'أستراليا'),
(82151, 3389612032, 3389616127, 'MY', 'MYS', 'ماليزيا'),
(82152, 3389616128, 3389640703, 'IN', 'IND', 'الهند'),
(82153, 3389640704, 3389644799, 'JP', 'JPN', 'اليابان'),
(82154, 3389644800, 3389652991, 'NZ', 'NZL', 'نيوزيلاندا'),
(82155, 3389652992, 3389661183, 'AU', 'AUS', 'أستراليا'),
(82156, 3389661184, 3389669375, 'ID', 'IDN', 'إندونيسيا'),
(82157, 3389669376, 3389673471, 'CN', 'CHN', 'الصين'),
(82158, 3389673472, 3389677567, 'AU', 'AUS', 'أستراليا'),
(82159, 3389677568, 3389685759, 'JP', 'JPN', 'اليابان'),
(82160, 3389685760, 3389718527, 'AU', 'AUS', 'أستراليا'),
(82161, 3389718528, 3389784063, 'JP', 'JPN', 'اليابان'),
(82162, 3389784064, 3389784319, 'NZ', 'NZL', 'نيوزيلاندا'),
(82163, 3389784320, 3389784575, 'AU', 'AUS', 'أستراليا'),
(82164, 3389784576, 3389784831, 'SG', 'SGP', 'سنغافورة'),
(82165, 3389784832, 3389785087, 'NZ', 'NZL', 'نيوزيلاندا'),
(82166, 3389785088, 3389786111, 'HK', 'HKG', 'هونغ كونغ'),
(82167, 3389786112, 3389788159, 'JP', 'JPN', 'اليابان'),
(82168, 3389788160, 3389788415, 'IN', 'IND', 'الهند'),
(82169, 3389788416, 3389788927, 'PH', 'PHL', 'الفلبين'),
(82170, 3389788928, 3389789695, 'US', 'USA', 'الولايات المتحدة'),
(82171, 3389789696, 3389790719, 'AU', 'AUS', 'أستراليا'),
(82172, 3389790720, 3389790975, 'BN', 'BRN', 'بروناي دار السلام'),
(82173, 3389790976, 3389791231, 'JP', 'JPN', 'اليابان'),
(82174, 3389791232, 3389791743, 'AU', 'AUS', 'أستراليا'),
(82175, 3389791744, 3389791999, 'JP', 'JPN', 'اليابان'),
(82176, 3389792000, 3389801983, 'AU', 'AUS', 'أستراليا'),
(82177, 3389801984, 3389802239, 'NZ', 'NZL', 'نيوزيلاندا'),
(82178, 3389802240, 3389802751, 'AU', 'AUS', 'أستراليا'),
(82179, 3389802752, 3389803263, 'TH', 'THA', 'تايلند'),
(82180, 3389803264, 3389803519, 'AU', 'AUS', 'أستراليا'),
(82181, 3389803520, 3389806079, 'NZ', 'NZL', 'نيوزيلاندا'),
(82182, 3389806080, 3389807359, 'AU', 'AUS', 'أستراليا'),
(82183, 3389807360, 3389807615, 'NZ', 'NZL', 'نيوزيلاندا'),
(82184, 3389807616, 3389808127, 'AU', 'AUS', 'أستراليا'),
(82185, 3389808128, 3389808639, 'SG', 'SGP', 'سنغافورة'),
(82186, 3389808640, 3389808895, 'NZ', 'NZL', 'نيوزيلاندا'),
(82187, 3389808896, 3389809151, 'TH', 'THA', 'تايلند'),
(82188, 3389809152, 3389809919, 'AU', 'AUS', 'أستراليا'),
(82189, 3389809920, 3389810175, 'IN', 'IND', 'الهند'),
(82190, 3389810176, 3389810687, 'AU', 'AUS', 'أستراليا'),
(82191, 3389810688, 3389811199, 'NZ', 'NZL', 'نيوزيلاندا'),
(82192, 3389811200, 3389811711, 'AU', 'AUS', 'أستراليا'),
(82193, 3389811712, 3389811967, 'NZ', 'NZL', 'نيوزيلاندا'),
(82194, 3389811968, 3389813759, 'AU', 'AUS', 'أستراليا'),
(82195, 3389813760, 3389814527, 'TH', 'THA', 'تايلند'),
(82196, 3389814528, 3389815295, 'AU', 'AUS', 'أستراليا'),
(82197, 3389815296, 3389816063, 'NZ', 'NZL', 'نيوزيلاندا'),
(82198, 3389816064, 3389816575, 'AU', 'AUS', 'أستراليا'),
(82199, 3389816576, 3389816831, 'US', 'USA', 'الولايات المتحدة'),
(82200, 3389816832, 3389846271, 'AU', 'AUS', 'أستراليا'),
(82201, 3389846272, 3389847551, 'JP', 'JPN', 'اليابان'),
(82202, 3389847552, 3389849599, 'NZ', 'NZL', 'نيوزيلاندا'),
(82203, 3389849600, 3389915135, 'JP', 'JPN', 'اليابان'),
(82204, 3389915136, 3389917183, 'AU', 'AUS', 'أستراليا'),
(82205, 3389917184, 3389919231, 'TW', 'TWN', 'تايوان'),
(82206, 3389919232, 3389931519, 'NZ', 'NZL', 'نيوزيلاندا'),
(82207, 3389931520, 3389932287, 'AU', 'AUS', 'أستراليا'),
(82208, 3389932288, 3389932799, 'HK', 'HKG', 'هونغ كونغ'),
(82209, 3389932800, 3389933055, 'AU', 'AUS', 'أستراليا'),
(82210, 3389933056, 3389933567, 'PK', 'PAK', 'باكستان'),
(82211, 3389933568, 3389933823, 'IN', 'IND', 'الهند'),
(82212, 3389933824, 3389934591, 'NZ', 'NZL', 'نيوزيلاندا'),
(82213, 3389934592, 3389935615, 'AU', 'AUS', 'أستراليا'),
(82214, 3389935616, 3389935871, 'HK', 'HKG', 'هونغ كونغ'),
(82215, 3389935872, 3389936127, 'AU', 'AUS', 'أستراليا'),
(82216, 3389936128, 3389936895, 'NZ', 'NZL', 'نيوزيلاندا'),
(82217, 3389936896, 3389937663, 'PH', 'PHL', 'الفلبين'),
(82218, 3389937664, 3389937919, 'CN', 'CHN', 'الصين'),
(82219, 3389937920, 3389939711, 'AU', 'AUS', 'أستراليا'),
(82220, 3389939712, 3389940223, 'NZ', 'NZL', 'نيوزيلاندا'),
(82221, 3389940224, 3389940479, 'AU', 'AUS', 'أستراليا'),
(82222, 3389940480, 3389940991, 'NZ', 'NZL', 'نيوزيلاندا'),
(82223, 3389940992, 3389941247, 'AU', 'AUS', 'أستراليا'),
(82224, 3389941248, 3389941503, 'NZ', 'NZL', 'نيوزيلاندا'),
(82225, 3389941504, 3389941759, 'KR', 'KOR', 'جمهورية كوريا'),
(82226, 3389941760, 3389942271, 'AU', 'AUS', 'أستراليا'),
(82227, 3389942272, 3389943295, 'NZ', 'NZL', 'نيوزيلاندا'),
(82228, 3389943296, 3389944319, 'AU', 'AUS', 'أستراليا'),
(82229, 3389944320, 3389944831, 'NZ', 'NZL', 'نيوزيلاندا'),
(82230, 3389944832, 3389945087, 'HK', 'HKG', 'هونغ كونغ'),
(82231, 3389945088, 3389945343, 'TH', 'THA', 'تايلند'),
(82232, 3389945344, 3389947647, 'AU', 'AUS', 'أستراليا'),
(82233, 3389947648, 3389947903, 'NZ', 'NZL', 'نيوزيلاندا'),
(82234, 3389947904, 3389949695, 'AU', 'AUS', 'أستراليا'),
(82235, 3389949696, 3389950207, 'NZ', 'NZL', 'نيوزيلاندا'),
(82236, 3389950208, 3389950975, 'AU', 'AUS', 'أستراليا'),
(82237, 3389950976, 3389951743, 'NZ', 'NZL', 'نيوزيلاندا'),
(82238, 3389951744, 3389953279, 'AU', 'AUS', 'أستراليا'),
(82239, 3389953280, 3389953535, 'NZ', 'NZL', 'نيوزيلاندا'),
(82240, 3389953536, 3389954303, 'AU', 'AUS', 'أستراليا'),
(82241, 3389954304, 3389954815, 'SG', 'SGP', 'سنغافورة'),
(82242, 3389954816, 3389956607, 'AU', 'AUS', 'أستراليا'),
(82243, 3389956608, 3389957375, 'TH', 'THA', 'تايلند'),
(82244, 3389957376, 3389957631, 'KR', 'KOR', 'جمهورية كوريا'),
(82245, 3389957632, 3389957887, 'AU', 'AUS', 'أستراليا'),
(82246, 3389957888, 3389958399, 'NZ', 'NZL', 'نيوزيلاندا'),
(82247, 3389958400, 3389970431, 'AU', 'AUS', 'أستراليا'),
(82248, 3389970432, 3389971199, 'NZ', 'NZL', 'نيوزيلاندا'),
(82249, 3389971200, 3389971967, 'AU', 'AUS', 'أستراليا'),
(82250, 3389971968, 3389972223, 'HK', 'HKG', 'هونغ كونغ'),
(82251, 3389972224, 3389972735, 'AU', 'AUS', 'أستراليا'),
(82252, 3389972736, 3389973759, 'NZ', 'NZL', 'نيوزيلاندا'),
(82253, 3389973760, 3389975295, 'AU', 'AUS', 'أستراليا'),
(82254, 3389975296, 3389976319, 'CN', 'CHN', 'الصين'),
(82255, 3389976320, 3389979647, 'AU', 'AUS', 'أستراليا'),
(82256, 3389979648, 3389980415, 'NZ', 'NZL', 'نيوزيلاندا'),
(82257, 3389980416, 3389980671, 'ID', 'IDN', 'إندونيسيا'),
(82258, 3389980672, 3390308351, 'JP', 'JPN', 'اليابان'),
(82259, 3390308352, 3390310399, 'NZ', 'NZL', 'نيوزيلاندا'),
(82260, 3390310400, 3390316543, 'AU', 'AUS', 'أستراليا'),
(82261, 3390316544, 3390325247, 'NZ', 'NZL', 'نيوزيلاندا'),
(82262, 3390325248, 3390325503, 'HK', 'HKG', 'هونغ كونغ'),
(82263, 3390325504, 3390327807, 'AU', 'AUS', 'أستراليا'),
(82264, 3390327808, 3390329087, 'NZ', 'NZL', 'نيوزيلاندا'),
(82265, 3390329088, 3390329343, 'AU', 'AUS', 'أستراليا'),
(82266, 3390329344, 3390330623, 'KR', 'KOR', 'جمهورية كوريا'),
(82267, 3390330624, 3390330879, 'TH', 'THA', 'تايلند'),
(82268, 3390330880, 3390331391, 'HK', 'HKG', 'هونغ كونغ'),
(82269, 3390331392, 3390331647, 'JP', 'JPN', 'اليابان'),
(82270, 3390331648, 3390332415, 'NZ', 'NZL', 'نيوزيلاندا'),
(82271, 3390332416, 3390332927, 'HK', 'HKG', 'هونغ كونغ'),
(82272, 3390332928, 3390333439, 'NZ', 'NZL', 'نيوزيلاندا'),
(82273, 3390333440, 3390333695, 'AU', 'AUS', 'أستراليا'),
(82274, 3390333696, 3390333951, 'KR', 'KOR', 'جمهورية كوريا'),
(82275, 3390333952, 3390334463, 'HK', 'HKG', 'هونغ كونغ'),
(82276, 3390334464, 3390335231, 'NZ', 'NZL', 'نيوزيلاندا'),
(82277, 3390335232, 3390335487, 'TH', 'THA', 'تايلند'),
(82278, 3390335488, 3390336511, 'ID', 'IDN', 'إندونيسيا'),
(82279, 3390336512, 3390337023, 'AU', 'AUS', 'أستراليا'),
(82280, 3390337024, 3390337279, 'GU', 'GUM', 'غوام'),
(82281, 3390337280, 3390337535, 'NZ', 'NZL', 'نيوزيلاندا'),
(82282, 3390337536, 3390338303, 'SG', 'SGP', 'سنغافورة'),
(82283, 3390338304, 3390338815, 'HK', 'HKG', 'هونغ كونغ'),
(82284, 3390338816, 3390339071, 'KR', 'KOR', 'جمهورية كوريا'),
(82285, 3390339072, 3390339327, 'CN', 'CHN', 'الصين'),
(82286, 3390339328, 3390339839, 'NZ', 'NZL', 'نيوزيلاندا'),
(82287, 3390339840, 3390340351, 'JP', 'JPN', 'اليابان'),
(82288, 3390340352, 3390341119, 'HK', 'HKG', 'هونغ كونغ'),
(82289, 3390341120, 3390375935, 'KR', 'KOR', 'جمهورية كوريا'),
(82290, 3390375936, 3390377983, 'AU', 'AUS', 'أستراليا'),
(82291, 3390377984, 3390382079, 'NZ', 'NZL', 'نيوزيلاندا'),
(82292, 3390382080, 3390390271, 'LK', 'LKA', 'سيريلانكا'),
(82293, 3390390272, 3390402559, 'NZ', 'NZL', 'نيوزيلاندا'),
(82294, 3390402560, 3390406655, 'JP', 'JPN', 'اليابان'),
(82295, 3390406656, 3390406911, 'NZ', 'NZL', 'نيوزيلاندا'),
(82296, 3390406912, 3390407167, 'AU', 'AUS', 'أستراليا'),
(82297, 3390407168, 3390408191, 'NZ', 'NZL', 'نيوزيلاندا'),
(82298, 3390408192, 3390408703, 'IN', 'IND', 'الهند'),
(82299, 3390408704, 3390409727, 'NZ', 'NZL', 'نيوزيلاندا'),
(82300, 3390409728, 3390409983, 'TH', 'THA', 'تايلند'),
(82301, 3390409984, 3390410751, 'NZ', 'NZL', 'نيوزيلاندا'),
(82302, 3390410752, 3390411007, 'TH', 'THA', 'تايلند'),
(82303, 3390411008, 3390411519, 'SG', 'SGP', 'سنغافورة'),
(82304, 3390411520, 3390411775, 'IN', 'IND', 'الهند'),
(82305, 3390411776, 3390412031, 'MY', 'MYS', 'ماليزيا'),
(82306, 3390412032, 3390412287, 'TH', 'THA', 'تايلند'),
(82307, 3390412288, 3390413311, 'JP', 'JPN', 'اليابان'),
(82308, 3390413312, 3390413567, 'SG', 'SGP', 'سنغافورة'),
(82309, 3390413568, 3390414335, 'NZ', 'NZL', 'نيوزيلاندا'),
(82310, 3390414336, 3390414847, 'SG', 'SGP', 'سنغافورة'),
(82311, 3390414848, 3390418943, 'JP', 'JPN', 'اليابان'),
(82312, 3390418944, 3390423039, 'MV', 'MDV', 'جزر المالديف'),
(82313, 3390423040, 3390429439, 'SG', 'SGP', 'سنغافورة'),
(82314, 3390429440, 3390429951, 'HK', 'HKG', 'هونغ كونغ'),
(82315, 3390429952, 3390439423, 'SG', 'SGP', 'سنغافورة'),
(82316, 3390439424, 3390441471, 'NZ', 'NZL', 'نيوزيلاندا'),
(82317, 3390441472, 3390443519, 'TH', 'THA', 'تايلند'),
(82318, 3390443520, 3390447359, 'NZ', 'NZL', 'نيوزيلاندا'),
(82319, 3390447360, 3390447615, 'ID', 'IDN', 'إندونيسيا'),
(82320, 3390447616, 3390455807, 'KR', 'KOR', 'جمهورية كوريا'),
(82321, 3390455808, 3390472191, 'JP', 'JPN', 'اليابان'),
(82322, 3390472192, 3390480383, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(82323, 3390480384, 3390484479, 'AU', 'AUS', 'أستراليا'),
(82324, 3390484480, 3390488575, 'GU', 'GUM', 'غوام'),
(82325, 3390488576, 3390492671, 'BD', 'BGD', 'بنغالاديش'),
(82326, 3390492672, 3390496767, 'JP', 'JPN', 'اليابان'),
(82327, 3390496768, 3390500863, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(82328, 3390500864, 3390502911, 'HK', 'HKG', 'هونغ كونغ'),
(82329, 3390502912, 3390504959, 'CN', 'CHN', 'الصين'),
(82330, 3390504960, 3390767103, 'JP', 'JPN', 'اليابان'),
(82331, 3390767104, 3390769407, 'NZ', 'NZL', 'نيوزيلاندا'),
(82332, 3390769408, 3390769663, 'IN', 'IND', 'الهند'),
(82333, 3390769664, 3390770175, 'TH', 'THA', 'تايلند'),
(82334, 3390770176, 3390770687, 'AU', 'AUS', 'أستراليا'),
(82335, 3390770688, 3390770943, 'JP', 'JPN', 'اليابان'),
(82336, 3390770944, 3390771199, 'AU', 'AUS', 'أستراليا'),
(82337, 3390771200, 3390775295, 'SG', 'SGP', 'سنغافورة'),
(82338, 3390775296, 3390790399, 'NZ', 'NZL', 'نيوزيلاندا'),
(82339, 3390790400, 3390790655, 'AU', 'AUS', 'أستراليا'),
(82340, 3390790656, 3390796287, 'NZ', 'NZL', 'نيوزيلاندا'),
(82341, 3390796288, 3390796543, 'AU', 'AUS', 'أستراليا'),
(82342, 3390796544, 3390800383, 'NZ', 'NZL', 'نيوزيلاندا'),
(82343, 3390800384, 3390800895, 'AU', 'AUS', 'أستراليا'),
(82344, 3390800896, 3390801151, 'NZ', 'NZL', 'نيوزيلاندا'),
(82345, 3390801152, 3390801407, 'AU', 'AUS', 'أستراليا'),
(82346, 3390801408, 3390815231, 'NZ', 'NZL', 'نيوزيلاندا'),
(82347, 3390815232, 3390815359, 'AU', 'AUS', 'أستراليا'),
(82348, 3390815360, 3390819583, 'NZ', 'NZL', 'نيوزيلاندا'),
(82349, 3390819584, 3390820351, 'AU', 'AUS', 'أستراليا'),
(82350, 3390820352, 3390832639, 'NZ', 'NZL', 'نيوزيلاندا'),
(82351, 3390832640, 3390963711, 'TH', 'THA', 'تايلند'),
(82352, 3390963712, 3391094783, 'KR', 'KOR', 'جمهورية كوريا'),
(82353, 3391094784, 3391356927, 'JP', 'JPN', 'اليابان'),
(82354, 3391356928, 3391364095, 'NZ', 'NZL', 'نيوزيلاندا'),
(82355, 3391364096, 3391364351, 'AU', 'AUS', 'أستراليا'),
(82356, 3391364352, 3391375871, 'NZ', 'NZL', 'نيوزيلاندا'),
(82357, 3391375872, 3391376127, 'AU', 'AUS', 'أستراليا'),
(82358, 3391376128, 3391379199, 'NZ', 'NZL', 'نيوزيلاندا'),
(82359, 3391379200, 3391379455, 'AU', 'AUS', 'أستراليا'),
(82360, 3391379456, 3391386623, 'NZ', 'NZL', 'نيوزيلاندا'),
(82361, 3391386624, 3391387135, 'AU', 'AUS', 'أستراليا'),
(82362, 3391387136, 3391414783, 'NZ', 'NZL', 'نيوزيلاندا'),
(82363, 3391414784, 3391415039, 'AU', 'AUS', 'أستراليا'),
(82364, 3391415040, 3391432703, 'NZ', 'NZL', 'نيوزيلاندا'),
(82365, 3391432704, 3391433215, 'AU', 'AUS', 'أستراليا'),
(82366, 3391433216, 3391434239, 'NZ', 'NZL', 'نيوزيلاندا'),
(82367, 3391434240, 3391434751, 'AU', 'AUS', 'أستراليا'),
(82368, 3391434752, 3391440255, 'NZ', 'NZL', 'نيوزيلاندا'),
(82369, 3391440256, 3391440383, 'AU', 'AUS', 'أستراليا'),
(82370, 3391440384, 3391440639, 'NZ', 'NZL', 'نيوزيلاندا'),
(82371, 3391440640, 3391440895, 'AU', 'AUS', 'أستراليا'),
(82372, 3391440896, 3391441407, 'NZ', 'NZL', 'نيوزيلاندا'),
(82373, 3391441408, 3391441663, 'AU', 'AUS', 'أستراليا'),
(82374, 3391441664, 3391444479, 'NZ', 'NZL', 'نيوزيلاندا'),
(82375, 3391444480, 3391444991, 'AU', 'AUS', 'أستراليا'),
(82376, 3391444992, 3391453183, 'NZ', 'NZL', 'نيوزيلاندا'),
(82377, 3391453184, 3391453439, 'AU', 'AUS', 'أستراليا'),
(82378, 3391453440, 3391456511, 'NZ', 'NZL', 'نيوزيلاندا'),
(82379, 3391456512, 3391456767, 'AU', 'AUS', 'أستراليا'),
(82380, 3391456768, 3391461375, 'NZ', 'NZL', 'نيوزيلاندا'),
(82381, 3391461376, 3391461631, 'AU', 'AUS', 'أستراليا'),
(82382, 3391461632, 3391464959, 'NZ', 'NZL', 'نيوزيلاندا'),
(82383, 3391464960, 3391465215, 'AU', 'AUS', 'أستراليا'),
(82384, 3391465216, 3391469055, 'NZ', 'NZL', 'نيوزيلاندا'),
(82385, 3391469056, 3391469311, 'AU', 'AUS', 'أستراليا'),
(82386, 3391469312, 3391473407, 'NZ', 'NZL', 'نيوزيلاندا'),
(82387, 3391473408, 3391473663, 'AU', 'AUS', 'أستراليا'),
(82388, 3391473664, 3391482623, 'NZ', 'NZL', 'نيوزيلاندا'),
(82389, 3391482624, 3391482879, 'AU', 'AUS', 'أستراليا'),
(82390, 3391482880, 3391487999, 'NZ', 'NZL', 'نيوزيلاندا'),
(82391, 3391488000, 3391492095, 'CN', 'CHN', 'الصين'),
(82392, 3391492096, 3391496191, 'HK', 'HKG', 'هونغ كونغ'),
(82393, 3391496192, 3391500287, 'SG', 'SGP', 'سنغافورة'),
(82394, 3391500288, 3391504383, 'AU', 'AUS', 'أستراليا'),
(82395, 3391504384, 3391523583, 'CN', 'CHN', 'الصين'),
(82396, 3391523584, 3391523839, 'AU', 'AUS', 'أستراليا'),
(82397, 3391523840, 3391524863, 'CN', 'CHN', 'الصين'),
(82398, 3391524864, 3391525375, 'AU', 'AUS', 'أستراليا'),
(82399, 3391525376, 3391525887, 'CN', 'CHN', 'الصين'),
(82400, 3391525888, 3391526143, 'AU', 'AUS', 'أستراليا'),
(82401, 3391526144, 3391526655, 'CN', 'CHN', 'الصين'),
(82402, 3391526656, 3391526911, 'SG', 'SGP', 'سنغافورة'),
(82403, 3391526912, 3391528191, 'CN', 'CHN', 'الصين'),
(82404, 3391528192, 3391528959, 'AU', 'AUS', 'أستراليا'),
(82405, 3391528960, 3391529471, 'CN', 'CHN', 'الصين'),
(82406, 3391529472, 3391529983, 'AU', 'AUS', 'أستراليا'),
(82407, 3391529984, 3391533567, 'CN', 'CHN', 'الصين'),
(82408, 3391533568, 3391534079, 'HK', 'HKG', 'هونغ كونغ'),
(82409, 3391534080, 3391535103, 'AU', 'AUS', 'أستراليا'),
(82410, 3391535104, 3391553535, 'CN', 'CHN', 'الصين'),
(82411, 3391553536, 3391619071, 'TW', 'TWN', 'تايوان'),
(82412, 3391619072, 3391620607, 'HK', 'HKG', 'هونغ كونغ'),
(82413, 3391620608, 3391620863, 'IN', 'IND', 'الهند'),
(82414, 3391620864, 3391660799, 'HK', 'HKG', 'هونغ كونغ'),
(82415, 3391660800, 3391661055, 'AU', 'AUS', 'أستراليا'),
(82416, 3391661056, 3391663103, 'HK', 'HKG', 'هونغ كونغ'),
(82417, 3391663104, 3391664127, 'PH', 'PHL', 'الفلبين'),
(82418, 3391664128, 3391668223, 'BD', 'BGD', 'بنغالاديش'),
(82419, 3391668224, 3391676415, 'HK', 'HKG', 'هونغ كونغ'),
(82420, 3391676416, 3391684607, 'SG', 'SGP', 'سنغافورة'),
(82421, 3391684608, 3391688191, 'IN', 'IND', 'الهند'),
(82422, 3391688192, 3391688703, 'AU', 'AUS', 'أستراليا'),
(82423, 3391688704, 3391717887, 'IN', 'IND', 'الهند'),
(82424, 3391717888, 3391718143, 'US', 'USA', 'الولايات المتحدة'),
(82425, 3391718144, 3391718911, 'IN', 'IND', 'الهند'),
(82426, 3391718912, 3391719167, 'JP', 'JPN', 'اليابان'),
(82427, 3391719168, 3391719423, 'AU', 'AUS', 'أستراليا'),
(82428, 3391719424, 3391720703, 'NZ', 'NZL', 'نيوزيلاندا'),
(82429, 3391720704, 3391720959, 'SG', 'SGP', 'سنغافورة'),
(82430, 3391720960, 3391721215, 'CN', 'CHN', 'الصين'),
(82431, 3391721216, 3391721471, 'HK', 'HKG', 'هونغ كونغ'),
(82432, 3391721472, 3391721727, 'AU', 'AUS', 'أستراليا'),
(82433, 3391721728, 3391721983, 'KR', 'KOR', 'جمهورية كوريا'),
(82434, 3391721984, 3391722239, 'TW', 'TWN', 'تايوان'),
(82435, 3391722240, 3391722495, 'PH', 'PHL', 'الفلبين'),
(82436, 3391722496, 3391723519, 'IN', 'IND', 'الهند'),
(82437, 3391723520, 3391725567, 'CN', 'CHN', 'الصين'),
(82438, 3391725568, 3391733759, 'TH', 'THA', 'تايلند'),
(82439, 3391733760, 3391734015, 'IN', 'IND', 'الهند'),
(82440, 3391734016, 3391734783, 'AU', 'AUS', 'أستراليا'),
(82441, 3391734784, 3391736831, 'JP', 'JPN', 'اليابان'),
(82442, 3391736832, 3391737855, 'IN', 'IND', 'الهند'),
(82443, 3391737856, 3391741951, 'JP', 'JPN', 'اليابان'),
(82444, 3391741952, 3391744959, 'IN', 'IND', 'الهند'),
(82445, 3391744960, 3391744991, 'SG', 'SGP', 'سنغافورة'),
(82446, 3391744992, 3391746047, 'IN', 'IND', 'الهند'),
(82447, 3391746048, 3391750143, 'CN', 'CHN', 'الصين'),
(82448, 3391750144, 3391815679, 'SG', 'SGP', 'سنغافورة'),
(82449, 3391815680, 3391817727, 'AU', 'AUS', 'أستراليا'),
(82450, 3391817728, 3391819775, 'TO', 'TON', 'تونغا'),
(82451, 3391819776, 3391823871, 'JP', 'JPN', 'اليابان'),
(82452, 3391823872, 3391827967, 'TH', 'THA', 'تايلند'),
(82453, 3391827968, 3391832063, 'KR', 'KOR', 'جمهورية كوريا'),
(82454, 3391832064, 3391832575, 'ID', 'IDN', 'إندونيسيا'),
(82455, 3391832576, 3391832831, 'AU', 'AUS', 'أستراليا'),
(82456, 3391832832, 3391833087, 'IN', 'IND', 'الهند'),
(82457, 3391833088, 3391834111, 'JP', 'JPN', 'اليابان'),
(82458, 3391834112, 3391835135, 'ID', 'IDN', 'إندونيسيا'),
(82459, 3391835136, 3391836159, 'CN', 'CHN', 'الصين'),
(82460, 3391836160, 3391836671, 'AU', 'AUS', 'أستراليا'),
(82461, 3391836672, 3391837183, 'HK', 'HKG', 'هونغ كونغ'),
(82462, 3391837184, 3391838207, 'AU', 'AUS', 'أستراليا'),
(82463, 3391838208, 3391838719, 'ID', 'IDN', 'إندونيسيا'),
(82464, 3391838720, 3391838975, 'PH', 'PHL', 'الفلبين'),
(82465, 3391838976, 3391839231, 'AU', 'AUS', 'أستراليا'),
(82466, 3391839232, 3391840255, 'ID', 'IDN', 'إندونيسيا'),
(82467, 3391840256, 3391841279, 'JP', 'JPN', 'اليابان'),
(82468, 3391841280, 3391842303, 'MY', 'MYS', 'ماليزيا'),
(82469, 3391842304, 3391843327, 'JP', 'JPN', 'اليابان'),
(82470, 3391843328, 3391844351, 'VN', 'VNM', 'فييتنام'),
(82471, 3391844352, 3391845887, 'ID', 'IDN', 'إندونيسيا'),
(82472, 3391845888, 3391846399, 'PK', 'PAK', 'باكستان'),
(82473, 3391846400, 3391847423, 'TW', 'TWN', 'تايوان'),
(82474, 3391847424, 3391848447, 'PK', 'PAK', 'باكستان'),
(82475, 3391848448, 3391852543, 'AU', 'AUS', 'أستراليا'),
(82476, 3391852544, 3391856639, 'CN', 'CHN', 'الصين'),
(82477, 3391856640, 3391864831, 'ID', 'IDN', 'إندونيسيا'),
(82478, 3391864832, 3391868927, 'US', 'USA', 'الولايات المتحدة'),
(82479, 3391868928, 3391870975, 'SG', 'SGP', 'سنغافورة'),
(82480, 3391870976, 3391873023, 'US', 'USA', 'الولايات المتحدة'),
(82481, 3391873024, 3391877119, 'AU', 'AUS', 'أستراليا'),
(82482, 3391877120, 3391879167, 'JP', 'JPN', 'اليابان'),
(82483, 3391879168, 3391881215, 'ID', 'IDN', 'إندونيسيا'),
(82484, 3391881216, 3391895551, 'TH', 'THA', 'تايلند'),
(82485, 3391895552, 3391896575, 'IN', 'IND', 'الهند'),
(82486, 3391896576, 3391900415, 'TH', 'THA', 'تايلند'),
(82487, 3391900416, 3391901695, 'AU', 'AUS', 'أستراليا'),
(82488, 3391901696, 3391905791, 'PK', 'PAK', 'باكستان'),
(82489, 3391905792, 3391906047, 'TH', 'THA', 'تايلند'),
(82490, 3391906048, 3391906303, 'JP', 'JPN', 'اليابان'),
(82491, 3391906304, 3391906815, 'AU', 'AUS', 'أستراليا'),
(82492, 3391906816, 3391907839, 'PH', 'PHL', 'الفلبين'),
(82493, 3391907840, 3391909887, 'BD', 'BGD', 'بنغالاديش'),
(82494, 3391909888, 3391910911, 'IO', 'IOT', 'إقليم المحيط الهندي البريطاني'),
(82495, 3391910912, 3391911935, 'AU', 'AUS', 'أستراليا'),
(82496, 3391911936, 3391913983, 'HK', 'HKG', 'هونغ كونغ'),
(82497, 3391913984, 3391915519, 'TH', 'THA', 'تايلند'),
(82498, 3391915520, 3391915775, 'AU', 'AUS', 'أستراليا'),
(82499, 3391915776, 3391916287, 'TH', 'THA', 'تايلند'),
(82500, 3391916288, 3391916543, 'AU', 'AUS', 'أستراليا'),
(82501, 3391916544, 3391920127, 'TH', 'THA', 'تايلند'),
(82502, 3391920128, 3391930367, 'AU', 'AUS', 'أستراليا'),
(82503, 3391930368, 3391946751, 'TH', 'THA', 'تايلند'),
(82504, 3391946752, 3391947007, 'DE', 'DEU', 'ألمانيا'),
(82505, 3391947008, 3391947519, 'HK', 'HKG', 'هونغ كونغ'),
(82506, 3391947520, 3391947775, 'AU', 'AUS', 'أستراليا'),
(82507, 3391947776, 3391948287, 'HK', 'HKG', 'هونغ كونغ'),
(82508, 3391948288, 3391948799, 'IN', 'IND', 'الهند'),
(82509, 3391948800, 3391949311, 'HK', 'HKG', 'هونغ كونغ'),
(82510, 3391949312, 3391949823, 'IN', 'IND', 'الهند'),
(82511, 3391949824, 3391950079, 'JP', 'JPN', 'اليابان'),
(82512, 3391950080, 3391950335, 'AU', 'AUS', 'أستراليا'),
(82513, 3391950336, 3391971327, 'HK', 'HKG', 'هونغ كونغ'),
(82514, 3391971328, 3391979519, 'AU', 'AUS', 'أستراليا'),
(82515, 3391979520, 3391979775, 'HK', 'HKG', 'هونغ كونغ'),
(82516, 3391979776, 3391980031, 'JP', 'JPN', 'اليابان'),
(82517, 3391980032, 3391980543, 'HK', 'HKG', 'هونغ كونغ'),
(82518, 3391980544, 3391983615, 'MY', 'MYS', 'ماليزيا'),
(82519, 3391983616, 3391984639, 'NP', 'NPL', 'نيبال'),
(82520, 3391984640, 3391984895, 'HK', 'HKG', 'هونغ كونغ'),
(82521, 3391984896, 3391985151, 'ID', 'IDN', 'إندونيسيا'),
(82522, 3391985152, 3391986687, 'AU', 'AUS', 'أستراليا'),
(82523, 3391986688, 3391987199, 'PK', 'PAK', 'باكستان'),
(82524, 3391987200, 3391987455, 'AU', 'AUS', 'أستراليا'),
(82525, 3391987456, 3391987711, 'BD', 'BGD', 'بنغالاديش'),
(82526, 3391987712, 3391988527, 'JP', 'JPN', 'اليابان'),
(82527, 3391988528, 3391988543, 'US', 'USA', 'الولايات المتحدة'),
(82528, 3391988544, 3391991807, 'JP', 'JPN', 'اليابان'),
(82529, 3391991808, 3392012287, 'HK', 'HKG', 'هونغ كونغ'),
(82530, 3392012288, 3392017151, 'ID', 'IDN', 'إندونيسيا'),
(82531, 3392017152, 3392017407, 'IN', 'IND', 'الهند'),
(82532, 3392017408, 3392017919, 'ID', 'IDN', 'إندونيسيا'),
(82533, 3392017920, 3392018431, 'IN', 'IND', 'الهند'),
(82534, 3392018432, 3392020479, 'ID', 'IDN', 'إندونيسيا'),
(82535, 3392020480, 3392028671, 'CN', 'CHN', 'الصين'),
(82536, 3392028672, 3392040959, 'ID', 'IDN', 'إندونيسيا'),
(82537, 3392040960, 3392045055, 'MY', 'MYS', 'ماليزيا'),
(82538, 3392045056, 3392046079, 'ID', 'IDN', 'إندونيسيا'),
(82539, 3392046080, 3392049151, 'AU', 'AUS', 'أستراليا'),
(82540, 3392049152, 3392053247, 'ID', 'IDN', 'إندونيسيا'),
(82541, 3392053248, 3392061439, 'NZ', 'NZL', 'نيوزيلاندا'),
(82542, 3392061440, 3392069631, 'IN', 'IND', 'الهند'),
(82543, 3392069632, 3392073727, 'CN', 'CHN', 'الصين'),
(82544, 3392073728, 3392077823, 'ID', 'IDN', 'إندونيسيا'),
(82545, 3392077824, 3392081919, 'AU', 'AUS', 'أستراليا'),
(82546, 3392081920, 3392086015, 'JP', 'JPN', 'اليابان'),
(82547, 3392086016, 3392094207, 'AU', 'AUS', 'أستراليا'),
(82548, 3392094208, 3392098559, 'ID', 'IDN', 'إندونيسيا'),
(82549, 3392098560, 3392098815, 'AU', 'AUS', 'أستراليا'),
(82550, 3392098816, 3392099327, 'PH', 'PHL', 'الفلبين'),
(82551, 3392099328, 3392100095, 'AU', 'AUS', 'أستراليا'),
(82552, 3392100096, 3392100351, 'VN', 'VNM', 'فييتنام'),
(82553, 3392100352, 3392100607, 'ID', 'IDN', 'إندونيسيا'),
(82554, 3392100608, 3392100863, 'SG', 'SGP', 'سنغافورة'),
(82555, 3392100864, 3392101887, 'ID', 'IDN', 'إندونيسيا'),
(82556, 3392101888, 3392102143, 'PK', 'PAK', 'باكستان'),
(82557, 3392102144, 3392102399, 'AU', 'AUS', 'أستراليا'),
(82558, 3392102400, 3392106495, 'KH', 'KHM', 'كامبوديا'),
(82559, 3392106496, 3392109567, 'AU', 'AUS', 'أستراليا'),
(82560, 3392109568, 3392109823, 'IN', 'IND', 'الهند'),
(82561, 3392109824, 3392110335, 'PH', 'PHL', 'الفلبين'),
(82562, 3392110336, 3392110591, 'IN', 'IND', 'الهند'),
(82563, 3392110592, 3392111103, 'PH', 'PHL', 'الفلبين'),
(82564, 3392111104, 3392111359, 'DE', 'DEU', 'ألمانيا'),
(82565, 3392111360, 3392112127, 'PH', 'PHL', 'الفلبين'),
(82566, 3392112128, 3392112639, 'AU', 'AUS', 'أستراليا'),
(82567, 3392112640, 3392114175, 'PH', 'PHL', 'الفلبين'),
(82568, 3392114176, 3392114431, 'VN', 'VNM', 'فييتنام'),
(82569, 3392114432, 3392114687, 'KR', 'KOR', 'جمهورية كوريا'),
(82570, 3392114688, 3392118783, 'GU', 'GUM', 'غوام'),
(82571, 3392118784, 3392126975, 'MY', 'MYS', 'ماليزيا'),
(82572, 3392126976, 3392135167, 'ID', 'IDN', 'إندونيسيا'),
(82573, 3392135168, 3392143359, 'TH', 'THA', 'تايلند'),
(82574, 3392143360, 3392208895, 'JP', 'JPN', 'اليابان'),
(82575, 3392208896, 3392229375, 'NZ', 'NZL', 'نيوزيلاندا'),
(82576, 3392229376, 3392229887, 'AU', 'AUS', 'أستراليا'),
(82577, 3392229888, 3392230335, 'NZ', 'NZL', 'نيوزيلاندا'),
(82578, 3392230336, 3392230399, 'AU', 'AUS', 'أستراليا'),
(82579, 3392230400, 3392233471, 'NZ', 'NZL', 'نيوزيلاندا'),
(82580, 3392233472, 3392235519, 'AU', 'AUS', 'أستراليا'),
(82581, 3392235520, 3392238079, 'NZ', 'NZL', 'نيوزيلاندا'),
(82582, 3392238080, 3392238335, 'AU', 'AUS', 'أستراليا'),
(82583, 3392238336, 3392272383, 'NZ', 'NZL', 'نيوزيلاندا'),
(82584, 3392272384, 3392272639, 'AU', 'AUS', 'أستراليا'),
(82585, 3392272640, 3392286719, 'NZ', 'NZL', 'نيوزيلاندا'),
(82586, 3392286720, 3392286975, 'AU', 'AUS', 'أستراليا'),
(82587, 3392286976, 3392287231, 'US', 'USA', 'الولايات المتحدة'),
(82588, 3392287232, 3392287743, 'NZ', 'NZL', 'نيوزيلاندا'),
(82589, 3392287744, 3392288767, 'AU', 'AUS', 'أستراليا'),
(82590, 3392288768, 3392293887, 'NZ', 'NZL', 'نيوزيلاندا'),
(82591, 3392293888, 3392294399, 'AU', 'AUS', 'أستراليا'),
(82592, 3392294400, 3392295935, 'NZ', 'NZL', 'نيوزيلاندا'),
(82593, 3392295936, 3392296191, 'AU', 'AUS', 'أستراليا'),
(82594, 3392296192, 3392307199, 'NZ', 'NZL', 'نيوزيلاندا'),
(82595, 3392307200, 3392307455, 'AU', 'AUS', 'أستراليا'),
(82596, 3392307456, 3392307711, 'NZ', 'NZL', 'نيوزيلاندا'),
(82597, 3392307712, 3392309503, 'AU', 'AUS', 'أستراليا'),
(82598, 3392309504, 3392324607, 'NZ', 'NZL', 'نيوزيلاندا'),
(82599, 3392324608, 3392325119, 'AU', 'AUS', 'أستراليا'),
(82600, 3392325120, 3392325631, 'NZ', 'NZL', 'نيوزيلاندا'),
(82601, 3392325632, 3392326655, 'AU', 'AUS', 'أستراليا'),
(82602, 3392326656, 3392336159, 'NZ', 'NZL', 'نيوزيلاندا'),
(82603, 3392336160, 3392336639, 'AU', 'AUS', 'أستراليا'),
(82604, 3392336640, 3392339727, 'NZ', 'NZL', 'نيوزيلاندا'),
(82605, 3392339728, 3392339743, 'AU', 'AUS', 'أستراليا'),
(82606, 3392339744, 3392339967, 'NZ', 'NZL', 'نيوزيلاندا'),
(82607, 3392339968, 3392340991, 'NP', 'NPL', 'نيبال'),
(82608, 3392340992, 3392344063, 'JP', 'JPN', 'اليابان'),
(82609, 3392344064, 3392348159, 'ID', 'IDN', 'إندونيسيا'),
(82610, 3392348160, 3392354303, 'JP', 'JPN', 'اليابان'),
(82611, 3392354304, 3392356351, 'ID', 'IDN', 'إندونيسيا'),
(82612, 3392356352, 3392364543, 'NP', 'NPL', 'نيبال'),
(82613, 3392364544, 3392372735, 'ID', 'IDN', 'إندونيسيا'),
(82614, 3392372736, 3392385023, 'AU', 'AUS', 'أستراليا'),
(82615, 3392385024, 3392389119, 'BD', 'BGD', 'بنغالاديش'),
(82616, 3392389120, 3392401407, 'ID', 'IDN', 'إندونيسيا'),
(82617, 3392401408, 3392403455, 'SG', 'SGP', 'سنغافورة'),
(82618, 3392403456, 3392404479, 'AU', 'AUS', 'أستراليا'),
(82619, 3392404480, 3392405503, 'ID', 'IDN', 'إندونيسيا'),
(82620, 3392405504, 3392406015, 'NP', 'NPL', 'نيبال'),
(82621, 3392406016, 3392406527, 'IN', 'IND', 'الهند'),
(82622, 3392406528, 3392407551, 'TH', 'THA', 'تايلند'),
(82623, 3392407552, 3392409599, 'ID', 'IDN', 'إندونيسيا'),
(82624, 3392409600, 3392413695, 'JP', 'JPN', 'اليابان'),
(82625, 3392413696, 3392421887, 'AU', 'AUS', 'أستراليا'),
(82626, 3392421888, 3392430271, 'SG', 'SGP', 'سنغافورة'),
(82627, 3392430272, 3392430303, 'TW', 'TWN', 'تايوان'),
(82628, 3392430304, 3392432511, 'SG', 'SGP', 'سنغافورة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(82629, 3392432512, 3392432543, 'TW', 'TWN', 'تايوان'),
(82630, 3392432544, 3392438271, 'SG', 'SGP', 'سنغافورة'),
(82631, 3392438272, 3392446463, 'AU', 'AUS', 'أستراليا'),
(82632, 3392446464, 3392450559, 'PH', 'PHL', 'الفلبين'),
(82633, 3392450560, 3392454655, 'JP', 'JPN', 'اليابان'),
(82634, 3392454656, 3392462847, 'HK', 'HKG', 'هونغ كونغ'),
(82635, 3392462848, 3392472063, 'NP', 'NPL', 'نيبال'),
(82636, 3392472064, 3392473087, 'AU', 'AUS', 'أستراليا'),
(82637, 3392473088, 3392475135, 'IN', 'IND', 'الهند'),
(82638, 3392475136, 3392479231, 'JP', 'JPN', 'اليابان'),
(82639, 3392479232, 3392487423, 'AU', 'AUS', 'أستراليا'),
(82640, 3392487424, 3392499711, 'IN', 'IND', 'الهند'),
(82641, 3392499712, 3392503807, 'JP', 'JPN', 'اليابان'),
(82642, 3392503808, 3392511999, 'HK', 'HKG', 'هونغ كونغ'),
(82643, 3392512000, 3392516095, 'BD', 'BGD', 'بنغالاديش'),
(82644, 3392516096, 3392520191, 'NZ', 'NZL', 'نيوزيلاندا'),
(82645, 3392520192, 3392524287, 'AU', 'AUS', 'أستراليا'),
(82646, 3392524288, 3392528383, 'JP', 'JPN', 'اليابان'),
(82647, 3392528384, 3392536575, 'ID', 'IDN', 'إندونيسيا'),
(82648, 3392536576, 3392610303, 'IN', 'IND', 'الهند'),
(82649, 3392610304, 3392618495, 'HK', 'HKG', 'هونغ كونغ'),
(82650, 3392618496, 3392626687, 'SG', 'SGP', 'سنغافورة'),
(82651, 3392626688, 3392630783, 'NZ', 'NZL', 'نيوزيلاندا'),
(82652, 3392630784, 3392634879, 'JP', 'JPN', 'اليابان'),
(82653, 3392634880, 3392635903, 'PK', 'PAK', 'باكستان'),
(82654, 3392635904, 3392636927, 'VN', 'VNM', 'فييتنام'),
(82655, 3392636928, 3392637951, 'JP', 'JPN', 'اليابان'),
(82656, 3392637952, 3392638975, 'TH', 'THA', 'تايلند'),
(82657, 3392638976, 3392643071, 'AU', 'AUS', 'أستراليا'),
(82658, 3392643072, 3392647167, 'ID', 'IDN', 'إندونيسيا'),
(82659, 3392647168, 3392651263, 'MN', 'MNG', 'منغوليا'),
(82660, 3392651264, 3392659455, 'JP', 'JPN', 'اليابان'),
(82661, 3392659456, 3392660831, 'TW', 'TWN', 'تايوان'),
(82662, 3392660832, 3392660847, 'SG', 'SGP', 'سنغافورة'),
(82663, 3392660848, 3392660911, 'TW', 'TWN', 'تايوان'),
(82664, 3392660912, 3392660927, 'SG', 'SGP', 'سنغافورة'),
(82665, 3392660928, 3392667647, 'TW', 'TWN', 'تايوان'),
(82666, 3392667648, 3392668671, 'IN', 'IND', 'الهند'),
(82667, 3392668672, 3392669695, 'BD', 'BGD', 'بنغالاديش'),
(82668, 3392669696, 3392670815, 'HK', 'HKG', 'هونغ كونغ'),
(82669, 3392670816, 3392670847, 'US', 'USA', 'الولايات المتحدة'),
(82670, 3392670848, 3392671743, 'HK', 'HKG', 'هونغ كونغ'),
(82671, 3392671744, 3392675839, 'JP', 'JPN', 'اليابان'),
(82672, 3392675840, 3392681983, 'NZ', 'NZL', 'نيوزيلاندا'),
(82673, 3392681984, 3392682239, 'SG', 'SGP', 'سنغافورة'),
(82674, 3392682240, 3392682495, 'VN', 'VNM', 'فييتنام'),
(82675, 3392682496, 3392683007, 'IN', 'IND', 'الهند'),
(82676, 3392683008, 3392684031, 'AU', 'AUS', 'أستراليا'),
(82677, 3392684032, 3392688127, 'JP', 'JPN', 'اليابان'),
(82678, 3392688128, 3392692223, 'MY', 'MYS', 'ماليزيا'),
(82679, 3392692224, 3392700415, 'IN', 'IND', 'الهند'),
(82680, 3392700416, 3392708607, 'SG', 'SGP', 'سنغافورة'),
(82681, 3392708608, 3392712703, 'ID', 'IDN', 'إندونيسيا'),
(82682, 3392712704, 3392716799, 'AF', 'AFG', 'أفغانستان'),
(82683, 3392716800, 3392733183, 'IN', 'IND', 'الهند'),
(82684, 3392733184, 3392741375, 'ID', 'IDN', 'إندونيسيا'),
(82685, 3392741376, 3392765951, 'PH', 'PHL', 'الفلبين'),
(82686, 3392765952, 3392782335, 'TH', 'THA', 'تايلند'),
(82687, 3392782336, 3392790527, 'HK', 'HKG', 'هونغ كونغ'),
(82688, 3392790528, 3392794623, 'JP', 'JPN', 'اليابان'),
(82689, 3392794624, 3392798719, 'AU', 'AUS', 'أستراليا'),
(82690, 3392798720, 3392798975, 'LA', 'LAO', 'لاو'),
(82691, 3392798976, 3392799231, 'JP', 'JPN', 'اليابان'),
(82692, 3392799232, 3392799487, 'PH', 'PHL', 'الفلبين'),
(82693, 3392799488, 3392799743, 'AU', 'AUS', 'أستراليا'),
(82694, 3392799744, 3392800767, 'JP', 'JPN', 'اليابان'),
(82695, 3392800768, 3392801375, 'SG', 'SGP', 'سنغافورة'),
(82696, 3392801376, 3392801391, 'HK', 'HKG', 'هونغ كونغ'),
(82697, 3392801392, 3392802815, 'SG', 'SGP', 'سنغافورة'),
(82698, 3392802816, 3392806911, 'JP', 'JPN', 'اليابان'),
(82699, 3392806912, 3392815103, 'AU', 'AUS', 'أستراليا'),
(82700, 3392815104, 3392819199, 'ID', 'IDN', 'إندونيسيا'),
(82701, 3392819200, 3392823295, 'MY', 'MYS', 'ماليزيا'),
(82702, 3392823296, 3392824319, 'KH', 'KHM', 'كامبوديا'),
(82703, 3392824320, 3392824831, 'AU', 'AUS', 'أستراليا'),
(82704, 3392824832, 3392825343, 'IN', 'IND', 'الهند'),
(82705, 3392825344, 3392826367, 'JP', 'JPN', 'اليابان'),
(82706, 3392826368, 3392827391, 'PH', 'PHL', 'الفلبين'),
(82707, 3392827392, 3392828415, 'AU', 'AUS', 'أستراليا'),
(82708, 3392828416, 3392829439, 'JP', 'JPN', 'اليابان'),
(82709, 3392829440, 3392830463, 'IN', 'IND', 'الهند'),
(82710, 3392830464, 3392830719, 'ID', 'IDN', 'إندونيسيا'),
(82711, 3392830720, 3392830975, 'IN', 'IND', 'الهند'),
(82712, 3392830976, 3392831231, 'TH', 'THA', 'تايلند'),
(82713, 3392831232, 3392831487, 'IN', 'IND', 'الهند'),
(82714, 3392831488, 3392832511, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(82715, 3392832512, 3392833535, 'IN', 'IND', 'الهند'),
(82716, 3392833536, 3392835583, 'AU', 'AUS', 'أستراليا'),
(82717, 3392835584, 3392839679, 'JP', 'JPN', 'اليابان'),
(82718, 3392839680, 3392845823, 'ID', 'IDN', 'إندونيسيا'),
(82719, 3392845824, 3392847871, 'HK', 'HKG', 'هونغ كونغ'),
(82720, 3392847872, 3392856063, 'ID', 'IDN', 'إندونيسيا'),
(82721, 3392856064, 3392857087, 'AU', 'AUS', 'أستراليا'),
(82722, 3392857088, 3392857343, 'IN', 'IND', 'الهند'),
(82723, 3392857344, 3392858111, 'AU', 'AUS', 'أستراليا'),
(82724, 3392858112, 3392858623, 'IN', 'IND', 'الهند'),
(82725, 3392858624, 3392858879, 'JP', 'JPN', 'اليابان'),
(82726, 3392858880, 3392859135, 'AU', 'AUS', 'أستراليا'),
(82727, 3392859136, 3392859647, 'PH', 'PHL', 'الفلبين'),
(82728, 3392859648, 3392860159, 'ID', 'IDN', 'إندونيسيا'),
(82729, 3392860160, 3392860671, 'AU', 'AUS', 'أستراليا'),
(82730, 3392860672, 3392861183, 'ID', 'IDN', 'إندونيسيا'),
(82731, 3392861184, 3392861439, 'TH', 'THA', 'تايلند'),
(82732, 3392861440, 3392861695, 'VN', 'VNM', 'فييتنام'),
(82733, 3392861696, 3392864255, 'AU', 'AUS', 'أستراليا'),
(82734, 3392864256, 3392864511, 'TO', 'TON', 'تونغا'),
(82735, 3392864512, 3392864767, 'AU', 'AUS', 'أستراليا'),
(82736, 3392864768, 3392865279, 'IN', 'IND', 'الهند'),
(82737, 3392865280, 3392866303, 'NU', 'NIU', 'نيوي'),
(82738, 3392866304, 3392880639, 'AU', 'AUS', 'أستراليا'),
(82739, 3392880640, 3392888831, 'PK', 'PAK', 'باكستان'),
(82740, 3392888832, 3392892927, 'AU', 'AUS', 'أستراليا'),
(82741, 3392892928, 3392897023, 'JP', 'JPN', 'اليابان'),
(82742, 3392897024, 3392901119, 'BD', 'BGD', 'بنغالاديش'),
(82743, 3392901120, 3392903167, 'JP', 'JPN', 'اليابان'),
(82744, 3392903168, 3392905215, 'HK', 'HKG', 'هونغ كونغ'),
(82745, 3392905216, 3392909311, 'ID', 'IDN', 'إندونيسيا'),
(82746, 3392909312, 3392913407, 'JP', 'JPN', 'اليابان'),
(82747, 3392913408, 3392917503, 'ID', 'IDN', 'إندونيسيا'),
(82748, 3392917504, 3392918527, 'BD', 'BGD', 'بنغالاديش'),
(82749, 3392918528, 3392929791, 'AU', 'AUS', 'أستراليا'),
(82750, 3392929792, 3392931839, 'MU', 'MUS', 'موريشيوس'),
(82751, 3392931840, 3392933887, 'PH', 'PHL', 'الفلبين'),
(82752, 3392933888, 3392942079, 'JP', 'JPN', 'اليابان'),
(82753, 3392942080, 3392944127, 'AU', 'AUS', 'أستراليا'),
(82754, 3392944128, 3392945151, 'MY', 'MYS', 'ماليزيا'),
(82755, 3392945152, 3392946175, 'IN', 'IND', 'الهند'),
(82756, 3392946176, 3392956415, 'AU', 'AUS', 'أستراليا'),
(82757, 3392956416, 3392958463, 'VN', 'VNM', 'فييتنام'),
(82758, 3392958464, 3392962559, 'CN', 'CHN', 'الصين'),
(82759, 3392962560, 3392963583, 'IN', 'IND', 'الهند'),
(82760, 3392963584, 3392970751, 'AU', 'AUS', 'أستراليا'),
(82761, 3392970752, 3392978943, 'JP', 'JPN', 'اليابان'),
(82762, 3392978944, 3392983039, 'TH', 'THA', 'تايلند'),
(82763, 3392983040, 3392987135, 'IN', 'IND', 'الهند'),
(82764, 3392987136, 3392995327, 'HK', 'HKG', 'هونغ كونغ'),
(82765, 3392995328, 3392995583, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(82766, 3392995584, 3392995839, 'JP', 'JPN', 'اليابان'),
(82767, 3392995840, 3392996351, 'NZ', 'NZL', 'نيوزيلاندا'),
(82768, 3392996352, 3392997375, 'AU', 'AUS', 'أستراليا'),
(82769, 3392997376, 3392998399, 'IN', 'IND', 'الهند'),
(82770, 3392998400, 3392999423, 'AU', 'AUS', 'أستراليا'),
(82771, 3392999424, 3393003519, 'JP', 'JPN', 'اليابان'),
(82772, 3393003520, 3393011711, 'PK', 'PAK', 'باكستان'),
(82773, 3393011712, 3393060863, 'AU', 'AUS', 'أستراليا'),
(82774, 3393060864, 3393062911, 'FJ', 'FJI', 'فيجي'),
(82775, 3393062912, 3393069055, 'ID', 'IDN', 'إندونيسيا'),
(82776, 3393069056, 3393077247, 'AU', 'AUS', 'أستراليا'),
(82777, 3393077248, 3393085439, 'IN', 'IND', 'الهند'),
(82778, 3393085440, 3393089535, 'LA', 'LAO', 'لاو'),
(82779, 3393089536, 3393090559, 'AU', 'AUS', 'أستراليا'),
(82780, 3393090560, 3393091071, 'IN', 'IND', 'الهند'),
(82781, 3393091072, 3393093631, 'FJ', 'FJI', 'فيجي'),
(82782, 3393093632, 3393101823, 'AU', 'AUS', 'أستراليا'),
(82783, 3393101824, 3393110015, 'JP', 'JPN', 'اليابان'),
(82784, 3393110016, 3393118207, 'HK', 'HKG', 'هونغ كونغ'),
(82785, 3393118208, 3393122303, 'IN', 'IND', 'الهند'),
(82786, 3393122304, 3393123327, 'AU', 'AUS', 'أستراليا'),
(82787, 3393123328, 3393123583, 'IN', 'IND', 'الهند'),
(82788, 3393123584, 3393123839, 'NZ', 'NZL', 'نيوزيلاندا'),
(82789, 3393123840, 3393124351, 'IN', 'IND', 'الهند'),
(82790, 3393124352, 3393125631, 'AU', 'AUS', 'أستراليا'),
(82791, 3393125632, 3393125887, 'JP', 'JPN', 'اليابان'),
(82792, 3393125888, 3393126399, 'AU', 'AUS', 'أستراليا'),
(82793, 3393126400, 3393134591, 'HK', 'HKG', 'هونغ كونغ'),
(82794, 3393134592, 3393146879, 'AU', 'AUS', 'أستراليا'),
(82795, 3393146880, 3393147135, 'PK', 'PAK', 'باكستان'),
(82796, 3393147136, 3393150975, 'AU', 'AUS', 'أستراليا'),
(82797, 3393150976, 3393159167, 'IN', 'IND', 'الهند'),
(82798, 3393159168, 3393167359, 'SG', 'SGP', 'سنغافورة'),
(82799, 3393167360, 3393175551, 'IN', 'IND', 'الهند'),
(82800, 3393175552, 3393183743, 'PK', 'PAK', 'باكستان'),
(82801, 3393183744, 3393187839, 'SG', 'SGP', 'سنغافورة'),
(82802, 3393187840, 3393189887, 'NP', 'NPL', 'نيبال'),
(82803, 3393189888, 3393190911, 'CN', 'CHN', 'الصين'),
(82804, 3393190912, 3393191423, 'IN', 'IND', 'الهند'),
(82805, 3393191424, 3393191935, 'SB', 'SLB', 'جزر سليمان'),
(82806, 3393191936, 3393257471, 'HK', 'HKG', 'هونغ كونغ'),
(82807, 3393257472, 3393260031, 'AU', 'AUS', 'أستراليا'),
(82808, 3393260032, 3393260543, 'BD', 'BGD', 'بنغالاديش'),
(82809, 3393260544, 3393265663, 'AU', 'AUS', 'أستراليا'),
(82810, 3393265664, 3393273855, 'CK', 'COK', 'جزر كوك'),
(82811, 3393273856, 3393282047, 'AU', 'AUS', 'أستراليا'),
(82812, 3393282048, 3393286143, 'HK', 'HKG', 'هونغ كونغ'),
(82813, 3393286144, 3393290239, 'ID', 'IDN', 'إندونيسيا'),
(82814, 3393290240, 3393298431, 'IN', 'IND', 'الهند'),
(82815, 3393298432, 3393300479, 'NZ', 'NZL', 'نيوزيلاندا'),
(82816, 3393300480, 3393302527, 'BD', 'BGD', 'بنغالاديش'),
(82817, 3393302528, 3393306623, 'PH', 'PHL', 'الفلبين'),
(82818, 3393306624, 3393314815, 'HK', 'HKG', 'هونغ كونغ'),
(82819, 3393314816, 3393318911, 'ID', 'IDN', 'إندونيسيا'),
(82820, 3393318912, 3393320959, 'SG', 'SGP', 'سنغافورة'),
(82821, 3393320960, 3393355775, 'HK', 'HKG', 'هونغ كونغ'),
(82822, 3393355776, 3393372159, 'AU', 'AUS', 'أستراليا'),
(82823, 3393372160, 3393389567, 'HK', 'HKG', 'هونغ كونغ'),
(82824, 3393389568, 3393390591, 'IN', 'IND', 'الهند'),
(82825, 3393390592, 3393392639, 'ID', 'IDN', 'إندونيسيا'),
(82826, 3393392640, 3393396735, 'JP', 'JPN', 'اليابان'),
(82827, 3393396736, 3393400831, 'ID', 'IDN', 'إندونيسيا'),
(82828, 3393400832, 3393404927, 'JP', 'JPN', 'اليابان'),
(82829, 3393404928, 3393421311, 'AU', 'AUS', 'أستراليا'),
(82830, 3393421312, 3393470463, 'HK', 'HKG', 'هونغ كونغ'),
(82831, 3393470464, 3393474559, 'AU', 'AUS', 'أستراليا'),
(82832, 3393474560, 3393478655, 'NZ', 'NZL', 'نيوزيلاندا'),
(82833, 3393478656, 3393486847, 'AU', 'AUS', 'أستراليا'),
(82834, 3393486848, 3393495039, 'IN', 'IND', 'الهند'),
(82835, 3393495040, 3393499135, 'AU', 'AUS', 'أستراليا'),
(82836, 3393499136, 3393503231, 'SG', 'SGP', 'سنغافورة'),
(82837, 3393503232, 3393507327, 'HK', 'HKG', 'هونغ كونغ'),
(82838, 3393507328, 3393511423, 'SG', 'SGP', 'سنغافورة'),
(82839, 3393511424, 3393519615, 'KR', 'KOR', 'جمهورية كوريا'),
(82840, 3393519616, 3393520639, 'HK', 'HKG', 'هونغ كونغ'),
(82841, 3393520640, 3393521663, 'CN', 'CHN', 'الصين'),
(82842, 3393521664, 3393523711, 'PK', 'PAK', 'باكستان'),
(82843, 3393523712, 3393527807, 'CN', 'CHN', 'الصين'),
(82844, 3393527808, 3393535999, 'PK', 'PAK', 'باكستان'),
(82845, 3393536000, 3393544191, 'HK', 'HKG', 'هونغ كونغ'),
(82846, 3393544192, 3393548287, 'ID', 'IDN', 'إندونيسيا'),
(82847, 3393548288, 3393552383, 'JP', 'JPN', 'اليابان'),
(82848, 3393552384, 3393553407, 'HK', 'HKG', 'هونغ كونغ'),
(82849, 3393553408, 3393554431, 'AU', 'AUS', 'أستراليا'),
(82850, 3393554432, 3393556479, 'TH', 'THA', 'تايلند'),
(82851, 3393556480, 3393560575, 'SG', 'SGP', 'سنغافورة'),
(82852, 3393560576, 3393568767, 'PH', 'PHL', 'الفلبين'),
(82853, 3393568768, 3393572863, 'LK', 'LKA', 'سيريلانكا'),
(82854, 3393572864, 3393576959, 'AU', 'AUS', 'أستراليا'),
(82855, 3393576960, 3393581055, 'JP', 'JPN', 'اليابان'),
(82856, 3393581056, 3393585151, 'HK', 'HKG', 'هونغ كونغ'),
(82857, 3393585152, 3393593343, 'CN', 'CHN', 'الصين'),
(82858, 3393593344, 3393597439, 'MN', 'MNG', 'منغوليا'),
(82859, 3393597440, 3393601535, 'ID', 'IDN', 'إندونيسيا'),
(82860, 3393601536, 3393609727, 'NP', 'NPL', 'نيبال'),
(82861, 3393609728, 3393613823, 'AU', 'AUS', 'أستراليا'),
(82862, 3393613824, 3393617919, 'AS', 'ASM', 'ساموا الأمريكية'),
(82863, 3393617920, 3393618431, 'AU', 'AUS', 'أستراليا'),
(82864, 3393618432, 3393618687, 'NZ', 'NZL', 'نيوزيلاندا'),
(82865, 3393618688, 3393618943, 'IN', 'IND', 'الهند'),
(82866, 3393618944, 3393620223, 'ID', 'IDN', 'إندونيسيا'),
(82867, 3393620224, 3393620479, 'AU', 'AUS', 'أستراليا'),
(82868, 3393620480, 3393620735, 'ID', 'IDN', 'إندونيسيا'),
(82869, 3393620736, 3393620991, 'AU', 'AUS', 'أستراليا'),
(82870, 3393620992, 3393621247, 'JP', 'JPN', 'اليابان'),
(82871, 3393621248, 3393622015, 'AU', 'AUS', 'أستراليا'),
(82872, 3393622016, 3393626111, 'PK', 'PAK', 'باكستان'),
(82873, 3393626112, 3393626367, 'HK', 'HKG', 'هونغ كونغ'),
(82874, 3393626368, 3393630207, 'CN', 'CHN', 'الصين'),
(82875, 3393630208, 3393634303, 'JP', 'JPN', 'اليابان'),
(82876, 3393634304, 3393638399, 'IN', 'IND', 'الهند'),
(82877, 3393638400, 3393650687, 'JP', 'JPN', 'اليابان'),
(82878, 3393650688, 3393658879, 'AU', 'AUS', 'أستراليا'),
(82879, 3393658880, 3393662975, 'KH', 'KHM', 'كامبوديا'),
(82880, 3393662976, 3393675263, 'JP', 'JPN', 'اليابان'),
(82881, 3393675264, 3393679359, 'MY', 'MYS', 'ماليزيا'),
(82882, 3393679360, 3393683455, 'TH', 'THA', 'تايلند'),
(82883, 3393683456, 3393691647, 'IN', 'IND', 'الهند'),
(82884, 3393691648, 3393695743, 'AU', 'AUS', 'أستراليا'),
(82885, 3393695744, 3393699839, 'PH', 'PHL', 'الفلبين'),
(82886, 3393699840, 3393724415, 'HK', 'HKG', 'هونغ كونغ'),
(82887, 3393724416, 3393728511, 'AU', 'AUS', 'أستراليا'),
(82888, 3393728512, 3393736703, 'JP', 'JPN', 'اليابان'),
(82889, 3393736704, 3393740799, 'AU', 'AUS', 'أستراليا'),
(82890, 3393740800, 3393741055, 'KH', 'KHM', 'كامبوديا'),
(82891, 3393741056, 3393741311, 'BD', 'BGD', 'بنغالاديش'),
(82892, 3393741312, 3393741567, 'NP', 'NPL', 'نيبال'),
(82893, 3393741568, 3393741575, 'BD', 'BGD', 'بنغالاديش'),
(82894, 3393741576, 3393741791, 'US', 'USA', 'الولايات المتحدة'),
(82895, 3393741792, 3393741823, 'MG', 'MDG', 'مدغشقر'),
(82896, 3393741824, 3393742847, 'SC', 'SYC', 'سيشيل'),
(82897, 3393742848, 3393743871, 'TL', 'TLS', 'تيمور الشرقية'),
(82898, 3393743872, 3393744127, 'US', 'USA', 'الولايات المتحدة'),
(82899, 3393744128, 3393744143, 'TK', 'TKL', 'توكيلاو'),
(82900, 3393744144, 3393744159, 'US', 'USA', 'الولايات المتحدة'),
(82901, 3393744160, 3393744175, 'TK', 'TKL', 'توكيلاو'),
(82902, 3393744176, 3393744383, 'US', 'USA', 'الولايات المتحدة'),
(82903, 3393744384, 3393744415, 'SC', 'SYC', 'سيشيل'),
(82904, 3393744416, 3393744447, 'US', 'USA', 'الولايات المتحدة'),
(82905, 3393744448, 3393744479, 'MG', 'MDG', 'مدغشقر'),
(82906, 3393744480, 3393744511, 'BD', 'BGD', 'بنغالاديش'),
(82907, 3393744512, 3393744639, 'US', 'USA', 'الولايات المتحدة'),
(82908, 3393744640, 3393744895, 'KH', 'KHM', 'كامبوديا'),
(82909, 3393744896, 3393748991, 'PH', 'PHL', 'الفلبين'),
(82910, 3393748992, 3393765375, 'AU', 'AUS', 'أستراليا'),
(82911, 3393765376, 3393773567, 'ID', 'IDN', 'إندونيسيا'),
(82912, 3393773568, 3393775615, 'AU', 'AUS', 'أستراليا'),
(82913, 3393775616, 3393777663, 'BD', 'BGD', 'بنغالاديش'),
(82914, 3393777664, 3393779711, 'MN', 'MNG', 'منغوليا'),
(82915, 3393779712, 3393780735, 'IN', 'IND', 'الهند'),
(82916, 3393780736, 3393782783, 'HK', 'HKG', 'هونغ كونغ'),
(82917, 3393782784, 3393783807, 'BD', 'BGD', 'بنغالاديش'),
(82918, 3393783808, 3393785855, 'MY', 'MYS', 'ماليزيا'),
(82919, 3393785856, 3393789951, 'ID', 'IDN', 'إندونيسيا'),
(82920, 3393789952, 3393798143, 'SG', 'SGP', 'سنغافورة'),
(82921, 3393798144, 3393806335, 'JP', 'JPN', 'اليابان'),
(82922, 3393806336, 3393814527, 'ID', 'IDN', 'إندونيسيا'),
(82923, 3393814528, 3393815551, 'AU', 'AUS', 'أستراليا'),
(82924, 3393815552, 3393816575, 'KR', 'KOR', 'جمهورية كوريا'),
(82925, 3393816576, 3393818623, 'JP', 'JPN', 'اليابان'),
(82926, 3393818624, 3393822719, 'AU', 'AUS', 'أستراليا'),
(82927, 3393822720, 3393830911, 'PH', 'PHL', 'الفلبين'),
(82928, 3393830912, 3393835007, 'NZ', 'NZL', 'نيوزيلاندا'),
(82929, 3393835008, 3393839103, 'JP', 'JPN', 'اليابان'),
(82930, 3393839104, 3393843199, 'ID', 'IDN', 'إندونيسيا'),
(82931, 3393843200, 3393848319, 'HK', 'HKG', 'هونغ كونغ'),
(82932, 3393848320, 3393849343, 'JP', 'JPN', 'اليابان'),
(82933, 3393849344, 3393851391, 'CN', 'CHN', 'الصين'),
(82934, 3393851392, 3393855487, 'JP', 'JPN', 'اليابان'),
(82935, 3393855488, 3393865727, 'AU', 'AUS', 'أستراليا'),
(82936, 3393865728, 3393867775, 'ID', 'IDN', 'إندونيسيا'),
(82937, 3393867776, 3393871871, 'AU', 'AUS', 'أستراليا'),
(82938, 3393871872, 3393880063, 'HK', 'HKG', 'هونغ كونغ'),
(82939, 3393880064, 3393896447, 'AU', 'AUS', 'أستراليا'),
(82940, 3393896448, 3393906687, 'NZ', 'NZL', 'نيوزيلاندا'),
(82941, 3393906688, 3393908735, 'AU', 'AUS', 'أستراليا'),
(82942, 3393908736, 3393910783, 'BD', 'BGD', 'بنغالاديش'),
(82943, 3393910784, 3393911807, 'PH', 'PHL', 'الفلبين'),
(82944, 3393911808, 3393912063, 'AU', 'AUS', 'أستراليا'),
(82945, 3393912064, 3393912319, 'JP', 'JPN', 'اليابان'),
(82946, 3393912320, 3393913855, 'HK', 'HKG', 'هونغ كونغ'),
(82947, 3393913856, 3393914879, 'MY', 'MYS', 'ماليزيا'),
(82948, 3393914880, 3393916927, 'JP', 'JPN', 'اليابان'),
(82949, 3393916928, 3393921023, 'ID', 'IDN', 'إندونيسيا'),
(82950, 3393921024, 3393929215, 'MY', 'MYS', 'ماليزيا'),
(82951, 3393929216, 3393937407, 'HK', 'HKG', 'هونغ كونغ'),
(82952, 3393937408, 3393941503, 'ID', 'IDN', 'إندونيسيا'),
(82953, 3393941504, 3393945599, 'JP', 'JPN', 'اليابان'),
(82954, 3393945600, 3393961983, 'MY', 'MYS', 'ماليزيا'),
(82955, 3393961984, 3393966079, 'IN', 'IND', 'الهند'),
(82956, 3393966080, 3393970175, 'CN', 'CHN', 'الصين'),
(82957, 3393970176, 3393974271, 'JP', 'JPN', 'اليابان'),
(82958, 3393974272, 3393976319, 'SG', 'SGP', 'سنغافورة'),
(82959, 3393976320, 3393977343, 'MO', 'MAC', 'ماكاو'),
(82960, 3393977344, 3394011135, 'HK', 'HKG', 'هونغ كونغ'),
(82961, 3394011136, 3394027519, 'AU', 'AUS', 'أستراليا'),
(82962, 3394027520, 3394035711, 'JP', 'JPN', 'اليابان'),
(82963, 3394035712, 3394039807, 'MY', 'MYS', 'ماليزيا'),
(82964, 3394039808, 3394041855, 'US', 'USA', 'الولايات المتحدة'),
(82965, 3394041856, 3394042879, 'AU', 'AUS', 'أستراليا'),
(82966, 3394042880, 3394060287, 'HK', 'HKG', 'هونغ كونغ'),
(82967, 3394060288, 3394064383, 'ID', 'IDN', 'إندونيسيا'),
(82968, 3394064384, 3394068479, 'AU', 'AUS', 'أستراليا'),
(82969, 3394068480, 3394076671, 'ID', 'IDN', 'إندونيسيا'),
(82970, 3394076672, 3394078719, 'HK', 'HKG', 'هونغ كونغ'),
(82971, 3394078720, 3394078975, 'AU', 'AUS', 'أستراليا'),
(82972, 3394078976, 3394079231, 'IN', 'IND', 'الهند'),
(82973, 3394079232, 3394079743, 'AU', 'AUS', 'أستراليا'),
(82974, 3394079744, 3394087471, 'HK', 'HKG', 'هونغ كونغ'),
(82975, 3394087472, 3394087487, 'CN', 'CHN', 'الصين'),
(82976, 3394087488, 3394111487, 'HK', 'HKG', 'هونغ كونغ'),
(82977, 3394111488, 3394113535, 'AU', 'AUS', 'أستراليا'),
(82978, 3394113536, 3394117631, 'SG', 'SGP', 'سنغافورة'),
(82979, 3394117632, 3394121727, 'AU', 'AUS', 'أستراليا'),
(82980, 3394121728, 3394125823, 'SG', 'SGP', 'سنغافورة'),
(82981, 3394125824, 3394142207, 'PH', 'PHL', 'الفلبين'),
(82982, 3394142208, 3394150399, 'NZ', 'NZL', 'نيوزيلاندا'),
(82983, 3394150400, 3394154495, 'IN', 'IND', 'الهند'),
(82984, 3394154496, 3394158591, 'JP', 'JPN', 'اليابان'),
(82985, 3394158592, 3394162687, 'ID', 'IDN', 'إندونيسيا'),
(82986, 3394162688, 3394166783, 'JP', 'JPN', 'اليابان'),
(82987, 3394166784, 3394168831, 'VN', 'VNM', 'فييتنام'),
(82988, 3394168832, 3394170879, 'IN', 'IND', 'الهند'),
(82989, 3394170880, 3394172927, 'NZ', 'NZL', 'نيوزيلاندا'),
(82990, 3394172928, 3394173695, 'JP', 'JPN', 'اليابان'),
(82991, 3394173696, 3394173951, 'IN', 'IND', 'الهند'),
(82992, 3394173952, 3394174975, 'HK', 'HKG', 'هونغ كونغ'),
(82993, 3394174976, 3394179071, 'JP', 'JPN', 'اليابان'),
(82994, 3394179072, 3394181119, 'BD', 'BGD', 'بنغالاديش'),
(82995, 3394181120, 3394183167, 'KH', 'KHM', 'كامبوديا'),
(82996, 3394183168, 3394191359, 'NP', 'NPL', 'نيبال'),
(82997, 3394191360, 3394207743, 'SG', 'SGP', 'سنغافورة'),
(82998, 3394207744, 3394215935, 'JP', 'JPN', 'اليابان'),
(82999, 3394215936, 3394220031, 'AU', 'AUS', 'أستراليا'),
(83000, 3394220032, 3394232319, 'SG', 'SGP', 'سنغافورة'),
(83001, 3394232320, 3394234367, 'AU', 'AUS', 'أستراليا'),
(83002, 3394234368, 3394236415, 'VN', 'VNM', 'فييتنام'),
(83003, 3394236416, 3394238463, 'JP', 'JPN', 'اليابان'),
(83004, 3394238464, 3394239487, 'AU', 'AUS', 'أستراليا'),
(83005, 3394239488, 3394248703, 'HK', 'HKG', 'هونغ كونغ'),
(83006, 3394248704, 3394252799, 'VU', 'VUT', 'فانواتو'),
(83007, 3394252800, 3394256895, 'IN', 'IND', 'الهند'),
(83008, 3394256896, 3394265087, 'AU', 'AUS', 'أستراليا'),
(83009, 3394265088, 3394267135, 'JP', 'JPN', 'اليابان'),
(83010, 3394267136, 3394269183, 'TW', 'TWN', 'تايوان'),
(83011, 3394269184, 3394273279, 'ID', 'IDN', 'إندونيسيا'),
(83012, 3394273280, 3394277375, 'HK', 'HKG', 'هونغ كونغ'),
(83013, 3394277376, 3394279423, 'AU', 'AUS', 'أستراليا'),
(83014, 3394279424, 3394281471, 'PH', 'PHL', 'الفلبين'),
(83015, 3394281472, 3394285567, 'SG', 'SGP', 'سنغافورة'),
(83016, 3394285568, 3394289663, 'AU', 'AUS', 'أستراليا'),
(83017, 3394289664, 3394290687, 'HK', 'HKG', 'هونغ كونغ'),
(83018, 3394290688, 3394293759, 'AU', 'AUS', 'أستراليا'),
(83019, 3394293760, 3394297855, 'ID', 'IDN', 'إندونيسيا'),
(83020, 3394297856, 3394306047, 'TH', 'THA', 'تايلند'),
(83021, 3394306048, 3394307071, 'HK', 'HKG', 'هونغ كونغ'),
(83022, 3394307072, 3394308095, 'SG', 'SGP', 'سنغافورة'),
(83023, 3394308096, 3394310143, 'JP', 'JPN', 'اليابان'),
(83024, 3394310144, 3394314239, 'AU', 'AUS', 'أستراليا'),
(83025, 3394314240, 3394322431, 'ID', 'IDN', 'إندونيسيا'),
(83026, 3394322432, 3394326527, 'AU', 'AUS', 'أستراليا'),
(83027, 3394326528, 3394330623, 'JP', 'JPN', 'اليابان'),
(83028, 3394330624, 3394338815, 'AU', 'AUS', 'أستراليا'),
(83029, 3394338816, 3394347007, 'IN', 'IND', 'الهند'),
(83030, 3394347008, 3394355199, 'PH', 'PHL', 'الفلبين'),
(83031, 3394355200, 3394359295, 'IN', 'IND', 'الهند'),
(83032, 3394359296, 3394363391, 'AU', 'AUS', 'أستراليا'),
(83033, 3394363392, 3394437119, 'HK', 'HKG', 'هونغ كونغ'),
(83034, 3394437120, 3394438143, 'AU', 'AUS', 'أستراليا'),
(83035, 3394438144, 3394441215, 'HK', 'HKG', 'هونغ كونغ'),
(83036, 3394441216, 3394453503, 'IN', 'IND', 'الهند'),
(83037, 3394453504, 3394461695, 'AU', 'AUS', 'أستراليا'),
(83038, 3394461696, 3394465791, 'SG', 'SGP', 'سنغافورة'),
(83039, 3394465792, 3394467839, 'AU', 'AUS', 'أستراليا'),
(83040, 3394467840, 3394469887, 'MY', 'MYS', 'ماليزيا'),
(83041, 3394469888, 3394478079, 'JP', 'JPN', 'اليابان'),
(83042, 3394478080, 3394482175, 'PK', 'PAK', 'باكستان'),
(83043, 3394482176, 3394484223, 'AU', 'AUS', 'أستراليا'),
(83044, 3394484224, 3394486271, 'JP', 'JPN', 'اليابان'),
(83045, 3394486272, 3394494463, 'HK', 'HKG', 'هونغ كونغ'),
(83046, 3394494464, 3394498559, 'JP', 'JPN', 'اليابان'),
(83047, 3394498560, 3394500607, 'HK', 'HKG', 'هونغ كونغ'),
(83048, 3394500608, 3394501631, 'SG', 'SGP', 'سنغافورة'),
(83049, 3394501632, 3394503679, 'HK', 'HKG', 'هونغ كونغ'),
(83050, 3394503680, 3394506751, 'AU', 'AUS', 'أستراليا'),
(83051, 3394506752, 3394507263, 'HK', 'HKG', 'هونغ كونغ'),
(83052, 3394507264, 3394507775, 'JP', 'JPN', 'اليابان'),
(83053, 3394507776, 3394508799, 'PH', 'PHL', 'الفلبين'),
(83054, 3394508800, 3394510847, 'AU', 'AUS', 'أستراليا'),
(83055, 3394510848, 3394514943, 'BD', 'BGD', 'بنغالاديش'),
(83056, 3394514944, 3394519039, 'JP', 'JPN', 'اليابان'),
(83057, 3394519040, 3394521087, 'BD', 'BGD', 'بنغالاديش'),
(83058, 3394521088, 3394523135, 'KH', 'KHM', 'كامبوديا'),
(83059, 3394523136, 3394527231, 'JP', 'JPN', 'اليابان'),
(83060, 3394527232, 3394535423, 'PH', 'PHL', 'الفلبين'),
(83061, 3394535424, 3394565631, 'HK', 'HKG', 'هونغ كونغ'),
(83062, 3394565632, 3394565887, 'PK', 'PAK', 'باكستان'),
(83063, 3394565888, 3394621439, 'HK', 'HKG', 'هونغ كونغ'),
(83064, 3394621440, 3394625535, 'CN', 'CHN', 'الصين'),
(83065, 3394625536, 3394629631, 'HK', 'HKG', 'هونغ كونغ'),
(83066, 3394629632, 3394631679, 'AU', 'AUS', 'أستراليا'),
(83067, 3394631680, 3394634751, 'HK', 'HKG', 'هونغ كونغ'),
(83068, 3394634752, 3394635775, 'IN', 'IND', 'الهند'),
(83069, 3394635776, 3394637823, 'KR', 'KOR', 'جمهورية كوريا'),
(83070, 3394637824, 3394641919, 'AF', 'AFG', 'أفغانستان'),
(83071, 3394641920, 3394648063, 'AU', 'AUS', 'أستراليا'),
(83072, 3394648064, 3394650111, 'JP', 'JPN', 'اليابان'),
(83073, 3394650112, 3394658303, 'HK', 'HKG', 'هونغ كونغ'),
(83074, 3394658304, 3394662399, 'NZ', 'NZL', 'نيوزيلاندا'),
(83075, 3394662400, 3394664447, 'AU', 'AUS', 'أستراليا'),
(83076, 3394664448, 3394666495, 'JP', 'JPN', 'اليابان'),
(83077, 3394666496, 3394682367, 'MO', 'MAC', 'ماكاو'),
(83078, 3394682368, 3394682879, 'HK', 'HKG', 'هونغ كونغ'),
(83079, 3394682880, 3394686975, 'PH', 'PHL', 'الفلبين'),
(83080, 3394686976, 3394689023, 'AU', 'AUS', 'أستراليا'),
(83081, 3394689024, 3394691071, 'BD', 'BGD', 'بنغالاديش'),
(83082, 3394691072, 3394697215, 'JP', 'JPN', 'اليابان'),
(83083, 3394697216, 3394697471, 'SG', 'SGP', 'سنغافورة'),
(83084, 3394697472, 3394697983, 'AU', 'AUS', 'أستراليا'),
(83085, 3394697984, 3394698239, 'IN', 'IND', 'الهند'),
(83086, 3394698240, 3394699263, 'AU', 'AUS', 'أستراليا'),
(83087, 3394699264, 3394700287, 'HK', 'HKG', 'هونغ كونغ'),
(83088, 3394700288, 3394707455, 'AU', 'AUS', 'أستراليا'),
(83089, 3394707456, 3394715647, 'IN', 'IND', 'الهند'),
(83090, 3394715648, 3394719743, 'JP', 'JPN', 'اليابان'),
(83091, 3394719744, 3394732031, 'AU', 'AUS', 'أستراليا'),
(83092, 3394732032, 3394740223, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(83093, 3394740224, 3394744319, 'AU', 'AUS', 'أستراليا'),
(83094, 3394744320, 3394752511, 'ID', 'IDN', 'إندونيسيا'),
(83095, 3394752512, 3394753535, 'WS', 'WSM', 'ساموا'),
(83096, 3394753536, 3394754559, 'VN', 'VNM', 'فييتنام'),
(83097, 3394754560, 3394756607, 'MY', 'MYS', 'ماليزيا'),
(83098, 3394756608, 3394760703, 'JP', 'JPN', 'اليابان'),
(83099, 3394760704, 3394764799, 'ID', 'IDN', 'إندونيسيا'),
(83100, 3394764800, 3394772991, 'HK', 'HKG', 'هونغ كونغ'),
(83101, 3394772992, 3394777087, 'PK', 'PAK', 'باكستان'),
(83102, 3394777088, 3394781183, 'JP', 'JPN', 'اليابان'),
(83103, 3394781184, 3394789375, 'MP', 'MNP', 'جزر ماريانا الشمالية'),
(83104, 3394789376, 3394797567, 'HK', 'HKG', 'هونغ كونغ'),
(83105, 3394797568, 3394813951, 'IN', 'IND', 'الهند'),
(83106, 3394813952, 3394815999, 'JP', 'JPN', 'اليابان'),
(83107, 3394816000, 3394818047, 'HK', 'HKG', 'هونغ كونغ'),
(83108, 3394818048, 3394830335, 'IN', 'IND', 'الهند'),
(83109, 3394830336, 3394831359, 'HK', 'HKG', 'هونغ كونغ'),
(83110, 3394831360, 3394832383, 'NZ', 'NZL', 'نيوزيلاندا'),
(83111, 3394832384, 3394834431, 'AU', 'AUS', 'أستراليا'),
(83112, 3394834432, 3394834687, 'HK', 'HKG', 'هونغ كونغ'),
(83113, 3394834688, 3394834943, 'JP', 'JPN', 'اليابان'),
(83114, 3394834944, 3394834959, 'HK', 'HKG', 'هونغ كونغ'),
(83115, 3394834960, 3394834975, 'JP', 'JPN', 'اليابان'),
(83116, 3394834976, 3394835199, 'HK', 'HKG', 'هونغ كونغ'),
(83117, 3394835200, 3394835455, 'JP', 'JPN', 'اليابان'),
(83118, 3394835456, 3394835583, 'SG', 'SGP', 'سنغافورة'),
(83119, 3394835584, 3394835711, 'JP', 'JPN', 'اليابان'),
(83120, 3394835712, 3394835967, 'CN', 'CHN', 'الصين'),
(83121, 3394835968, 3394836239, 'JP', 'JPN', 'اليابان'),
(83122, 3394836240, 3394836247, 'AS', 'ASM', 'ساموا الأمريكية'),
(83123, 3394836248, 3394836479, 'JP', 'JPN', 'اليابان'),
(83124, 3394836480, 3394838527, 'BT', 'BTN', 'بوتان'),
(83125, 3394838528, 3394846719, 'NZ', 'NZL', 'نيوزيلاندا'),
(83126, 3394846720, 3394850815, 'IN', 'IND', 'الهند'),
(83127, 3394850816, 3394854911, 'JP', 'JPN', 'اليابان'),
(83128, 3394854912, 3394855935, 'PH', 'PHL', 'الفلبين'),
(83129, 3394855936, 3394856959, 'AU', 'AUS', 'أستراليا'),
(83130, 3394856960, 3394859007, 'IN', 'IND', 'الهند'),
(83131, 3394859008, 3394860031, 'JP', 'JPN', 'اليابان'),
(83132, 3394860032, 3394860543, 'ID', 'IDN', 'إندونيسيا'),
(83133, 3394860544, 3394861055, 'IN', 'IND', 'الهند'),
(83134, 3394861056, 3394861311, 'KR', 'KOR', 'جمهورية كوريا'),
(83135, 3394861312, 3394862079, 'TW', 'TWN', 'تايوان'),
(83136, 3394862080, 3394863103, 'KR', 'KOR', 'جمهورية كوريا'),
(83137, 3394863104, 3394871295, 'NZ', 'NZL', 'نيوزيلاندا'),
(83138, 3394871296, 3394879487, 'AU', 'AUS', 'أستراليا'),
(83139, 3394879488, 3394883583, 'PH', 'PHL', 'الفلبين'),
(83140, 3394883584, 3394887679, 'ID', 'IDN', 'إندونيسيا'),
(83141, 3394887680, 3394893823, 'JP', 'JPN', 'اليابان'),
(83142, 3394893824, 3394894847, 'KR', 'KOR', 'جمهورية كوريا'),
(83143, 3394894848, 3394895871, 'HK', 'HKG', 'هونغ كونغ'),
(83144, 3394895872, 3394896895, 'CN', 'CHN', 'الصين'),
(83145, 3394896896, 3394897919, 'TH', 'THA', 'تايلند'),
(83146, 3394897920, 3394899967, 'JP', 'JPN', 'اليابان'),
(83147, 3394899968, 3394904063, 'SG', 'SGP', 'سنغافورة'),
(83148, 3394904064, 3394905087, 'AU', 'AUS', 'أستراليا'),
(83149, 3394905088, 3394905343, 'BN', 'BRN', 'بروناي دار السلام'),
(83150, 3394905344, 3394912255, 'AU', 'AUS', 'أستراليا'),
(83151, 3394912256, 3394920447, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(83152, 3394920448, 3394924543, 'IN', 'IND', 'الهند'),
(83153, 3394924544, 3394928639, 'TH', 'THA', 'تايلند'),
(83154, 3394928640, 3394936831, 'PH', 'PHL', 'الفلبين'),
(83155, 3394936832, 3394940927, 'AU', 'AUS', 'أستراليا'),
(83156, 3394940928, 3394945023, 'JP', 'JPN', 'اليابان'),
(83157, 3394945024, 3394945279, 'IN', 'IND', 'الهند'),
(83158, 3394945280, 3394945535, 'AU', 'AUS', 'أستراليا'),
(83159, 3394945536, 3394946047, 'ID', 'IDN', 'إندونيسيا'),
(83160, 3394946048, 3394946559, 'AU', 'AUS', 'أستراليا'),
(83161, 3394946560, 3394947071, 'ID', 'IDN', 'إندونيسيا'),
(83162, 3394947072, 3394948095, 'BD', 'BGD', 'بنغالاديش'),
(83163, 3394948096, 3394948351, 'IN', 'IND', 'الهند'),
(83164, 3394948352, 3394948607, 'PH', 'PHL', 'الفلبين'),
(83165, 3394948608, 3394949119, 'AU', 'AUS', 'أستراليا'),
(83166, 3394949120, 3394953215, 'JP', 'JPN', 'اليابان'),
(83167, 3394953216, 3394957311, 'CN', 'CHN', 'الصين'),
(83168, 3394957312, 3394959359, 'AU', 'AUS', 'أستراليا'),
(83169, 3394959360, 3394960383, 'HK', 'HKG', 'هونغ كونغ'),
(83170, 3394960384, 3394962431, 'CN', 'CHN', 'الصين'),
(83171, 3394962432, 3394963455, 'AU', 'AUS', 'أستراليا'),
(83172, 3394963456, 3394965503, 'ID', 'IDN', 'إندونيسيا'),
(83173, 3394965504, 3394967551, 'TH', 'THA', 'تايلند'),
(83174, 3394967552, 3394969599, 'ID', 'IDN', 'إندونيسيا'),
(83175, 3394969600, 3394973695, 'SG', 'SGP', 'سنغافورة'),
(83176, 3394973696, 3394977791, 'JP', 'JPN', 'اليابان'),
(83177, 3394977792, 3394985983, 'IN', 'IND', 'الهند'),
(83178, 3394985984, 3394990079, 'AU', 'AUS', 'أستراليا'),
(83179, 3394990080, 3394994175, 'JP', 'JPN', 'اليابان'),
(83180, 3394994176, 3394995199, 'CN', 'CHN', 'الصين'),
(83181, 3394995200, 3394998271, 'IN', 'IND', 'الهند'),
(83182, 3394998272, 3395002367, 'JP', 'JPN', 'اليابان'),
(83183, 3395002368, 3395006463, 'PH', 'PHL', 'الفلبين'),
(83184, 3395006464, 3395010559, 'CN', 'CHN', 'الصين'),
(83185, 3395010560, 3395014655, 'AU', 'AUS', 'أستراليا'),
(83186, 3395014656, 3395018751, 'JP', 'JPN', 'اليابان'),
(83187, 3395018752, 3395027967, 'CN', 'CHN', 'الصين'),
(83188, 3395027968, 3395028991, 'VN', 'VNM', 'فييتنام'),
(83189, 3395028992, 3395031039, 'AU', 'AUS', 'أستراليا'),
(83190, 3395031040, 3395035135, 'PK', 'PAK', 'باكستان'),
(83191, 3395035136, 3395059711, 'AU', 'AUS', 'أستراليا'),
(83192, 3395059712, 3395067903, 'PH', 'PHL', 'الفلبين'),
(83193, 3395067904, 3395076095, 'HK', 'HKG', 'هونغ كونغ'),
(83194, 3395076096, 3395080191, 'ID', 'IDN', 'إندونيسيا'),
(83195, 3395080192, 3395084287, 'AU', 'AUS', 'أستراليا'),
(83196, 3395084288, 3395088383, 'IN', 'IND', 'الهند'),
(83197, 3395088384, 3395091455, 'AU', 'AUS', 'أستراليا'),
(83198, 3395091456, 3395093503, 'CN', 'CHN', 'الصين'),
(83199, 3395093504, 3395094015, 'AU', 'AUS', 'أستراليا'),
(83200, 3395094016, 3395094527, 'KR', 'KOR', 'جمهورية كوريا'),
(83201, 3395094528, 3395096575, 'KH', 'KHM', 'كامبوديا'),
(83202, 3395096576, 3395104767, 'ID', 'IDN', 'إندونيسيا'),
(83203, 3395104768, 3395108863, 'TH', 'THA', 'تايلند'),
(83204, 3395108864, 3395117055, 'JP', 'JPN', 'اليابان'),
(83205, 3395117056, 3395121151, 'AU', 'AUS', 'أستراليا'),
(83206, 3395121152, 3395129343, 'ID', 'IDN', 'إندونيسيا'),
(83207, 3395129344, 3395131391, 'JP', 'JPN', 'اليابان'),
(83208, 3395131392, 3395131647, 'AU', 'AUS', 'أستراليا'),
(83209, 3395131648, 3395131903, 'KH', 'KHM', 'كامبوديا'),
(83210, 3395131904, 3395132159, 'IN', 'IND', 'الهند'),
(83211, 3395132160, 3395132415, 'AU', 'AUS', 'أستراليا'),
(83212, 3395132416, 3395133439, 'VN', 'VNM', 'فييتنام'),
(83213, 3395133440, 3395141631, 'AU', 'AUS', 'أستراليا'),
(83214, 3395141632, 3395145727, 'HK', 'HKG', 'هونغ كونغ'),
(83215, 3395145728, 3395149823, 'BN', 'BRN', 'بروناي دار السلام'),
(83216, 3395149824, 3395155967, 'ID', 'IDN', 'إندونيسيا'),
(83217, 3395155968, 3395156991, 'AU', 'AUS', 'أستراليا'),
(83218, 3395156992, 3395158015, 'CN', 'CHN', 'الصين'),
(83219, 3395158016, 3395170303, 'AU', 'AUS', 'أستراليا'),
(83220, 3395170304, 3395174399, 'JP', 'JPN', 'اليابان'),
(83221, 3395174400, 3395182591, 'AU', 'AUS', 'أستراليا'),
(83222, 3395182592, 3395190783, 'SG', 'SGP', 'سنغافورة'),
(83223, 3395190784, 3395198975, 'JP', 'JPN', 'اليابان'),
(83224, 3395198976, 3395203071, 'MY', 'MYS', 'ماليزيا'),
(83225, 3395203072, 3395215359, 'JP', 'JPN', 'اليابان'),
(83226, 3395215360, 3395219455, 'HK', 'HKG', 'هونغ كونغ'),
(83227, 3395219456, 3395223551, 'TH', 'THA', 'تايلند'),
(83228, 3395223552, 3395231743, 'CN', 'CHN', 'الصين'),
(83229, 3395231744, 3395239935, 'JP', 'JPN', 'اليابان'),
(83230, 3395239936, 3395254751, 'SG', 'SGP', 'سنغافورة'),
(83231, 3395254752, 3395254767, 'JP', 'JPN', 'اليابان'),
(83232, 3395254768, 3395256319, 'SG', 'SGP', 'سنغافورة'),
(83233, 3395256320, 3395264511, 'ID', 'IDN', 'إندونيسيا'),
(83234, 3395264512, 3395272703, 'JP', 'JPN', 'اليابان'),
(83235, 3395272704, 3395276799, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(83236, 3395276800, 3395280895, 'JP', 'JPN', 'اليابان'),
(83237, 3395280896, 3395284991, 'PH', 'PHL', 'الفلبين'),
(83238, 3395284992, 3395287039, 'AU', 'AUS', 'أستراليا'),
(83239, 3395287040, 3395287551, 'JP', 'JPN', 'اليابان'),
(83240, 3395287552, 3395287807, 'NZ', 'NZL', 'نيوزيلاندا'),
(83241, 3395287808, 3395288063, 'IN', 'IND', 'الهند'),
(83242, 3395288064, 3396868319, 'CN', 'CHN', 'الصين'),
(83243, 3396868320, 3396868351, 'SG', 'SGP', 'سنغافورة'),
(83244, 3396868352, 3396995071, 'CN', 'CHN', 'الصين'),
(83245, 3396995072, 3396997119, 'ID', 'IDN', 'إندونيسيا'),
(83246, 3396997120, 3396999167, 'IN', 'IND', 'الهند'),
(83247, 3396999168, 3397001215, 'JP', 'JPN', 'اليابان'),
(83248, 3397001216, 3397003263, 'CN', 'CHN', 'الصين'),
(83249, 3397003264, 3397005311, 'TH', 'THA', 'تايلند'),
(83250, 3397005312, 3397009407, 'JP', 'JPN', 'اليابان'),
(83251, 3397009408, 3397017599, 'CN', 'CHN', 'الصين'),
(83252, 3397017600, 3397021695, 'HK', 'HKG', 'هونغ كونغ'),
(83253, 3397021696, 3397023743, 'CN', 'CHN', 'الصين'),
(83254, 3397023744, 3397025791, 'AU', 'AUS', 'أستراليا'),
(83255, 3397025792, 3397026047, 'CN', 'CHN', 'الصين'),
(83256, 3397026048, 3397026303, 'AU', 'AUS', 'أستراليا'),
(83257, 3397026304, 3397026815, 'TH', 'THA', 'تايلند'),
(83258, 3397026816, 3397027071, 'AU', 'AUS', 'أستراليا'),
(83259, 3397027072, 3397027327, 'PH', 'PHL', 'الفلبين'),
(83260, 3397027328, 3397027839, 'IN', 'IND', 'الهند'),
(83261, 3397027840, 3397029887, 'JP', 'JPN', 'اليابان'),
(83262, 3397029888, 3397033983, 'MY', 'MYS', 'ماليزيا'),
(83263, 3397033984, 3397038079, 'ID', 'IDN', 'إندونيسيا'),
(83264, 3397038080, 3397058559, 'JP', 'JPN', 'اليابان'),
(83265, 3397058560, 3397066751, 'AU', 'AUS', 'أستراليا'),
(83266, 3397066752, 3397070847, 'IN', 'IND', 'الهند'),
(83267, 3397070848, 3397074943, 'PH', 'PHL', 'الفلبين'),
(83268, 3397074944, 3397083135, 'HK', 'HKG', 'هونغ كونغ'),
(83269, 3397083136, 3397087231, 'CN', 'CHN', 'الصين'),
(83270, 3397087232, 3397091327, 'JP', 'JPN', 'اليابان'),
(83271, 3397091328, 3397099519, 'GU', 'GUM', 'غوام'),
(83272, 3397099520, 3397103615, 'HK', 'HKG', 'هونغ كونغ'),
(83273, 3397103616, 3397105663, 'LA', 'LAO', 'لاو'),
(83274, 3397105664, 3397107711, 'JP', 'JPN', 'اليابان'),
(83275, 3397107712, 3397115903, 'HK', 'HKG', 'هونغ كونغ'),
(83276, 3397115904, 3397119999, 'ID', 'IDN', 'إندونيسيا'),
(83277, 3397120000, 3397124095, 'PK', 'PAK', 'باكستان'),
(83278, 3397124096, 3397128191, 'JP', 'JPN', 'اليابان'),
(83279, 3397128192, 3397131263, 'AU', 'AUS', 'أستراليا'),
(83280, 3397131264, 3397132287, 'HK', 'HKG', 'هونغ كونغ'),
(83281, 3397132288, 3397136383, 'AU', 'AUS', 'أستراليا'),
(83282, 3397136384, 3397140479, 'JP', 'JPN', 'اليابان'),
(83283, 3397140480, 3397148671, 'AU', 'AUS', 'أستراليا'),
(83284, 3397148672, 3397156863, 'NZ', 'NZL', 'نيوزيلاندا'),
(83285, 3397156864, 3397165055, 'PH', 'PHL', 'الفلبين'),
(83286, 3397165056, 3397173247, 'LK', 'LKA', 'سيريلانكا'),
(83287, 3397173248, 3397173503, 'AU', 'AUS', 'أستراليا'),
(83288, 3397173504, 3397173759, 'PH', 'PHL', 'الفلبين'),
(83289, 3397173760, 3397174015, 'IN', 'IND', 'الهند'),
(83290, 3397174016, 3397174271, 'AU', 'AUS', 'أستراليا'),
(83291, 3397174272, 3397175295, 'ID', 'IDN', 'إندونيسيا'),
(83292, 3397175296, 3397175807, 'AU', 'AUS', 'أستراليا'),
(83293, 3397175808, 3397176063, 'IN', 'IND', 'الهند'),
(83294, 3397176064, 3397176319, 'ID', 'IDN', 'إندونيسيا'),
(83295, 3397176320, 3397176575, 'VN', 'VNM', 'فييتنام'),
(83296, 3397176576, 3397176831, 'ID', 'IDN', 'إندونيسيا'),
(83297, 3397176832, 3397177343, 'AU', 'AUS', 'أستراليا'),
(83298, 3397177344, 3397181439, 'JP', 'JPN', 'اليابان'),
(83299, 3397181440, 3397185535, 'PW', 'PLW', 'بالاو'),
(83300, 3397185536, 3397201919, 'AU', 'AUS', 'أستراليا'),
(83301, 3397201920, 3397206015, 'JP', 'JPN', 'اليابان'),
(83302, 3397206016, 3397210111, 'BD', 'BGD', 'بنغالاديش'),
(83303, 3397210112, 3397211135, 'ID', 'IDN', 'إندونيسيا'),
(83304, 3397211136, 3397211647, 'TH', 'THA', 'تايلند'),
(83305, 3397211648, 3397212159, 'AU', 'AUS', 'أستراليا'),
(83306, 3397212160, 3397212671, 'ID', 'IDN', 'إندونيسيا'),
(83307, 3397212672, 3397213183, 'HK', 'HKG', 'هونغ كونغ'),
(83308, 3397213184, 3397213439, 'IN', 'IND', 'الهند'),
(83309, 3397213440, 3397213695, 'AU', 'AUS', 'أستراليا'),
(83310, 3397213696, 3397214207, 'ID', 'IDN', 'إندونيسيا'),
(83311, 3397214208, 3397215231, 'AU', 'AUS', 'أستراليا'),
(83312, 3397215232, 3397215743, 'ID', 'IDN', 'إندونيسيا'),
(83313, 3397215744, 3397216255, 'PH', 'PHL', 'الفلبين'),
(83314, 3397216256, 3397216767, 'AU', 'AUS', 'أستراليا'),
(83315, 3397216768, 3397217023, 'IN', 'IND', 'الهند'),
(83316, 3397217024, 3397217279, 'SG', 'SGP', 'سنغافورة'),
(83317, 3397217280, 3397217791, 'AU', 'AUS', 'أستراليا'),
(83318, 3397217792, 3397218047, 'NZ', 'NZL', 'نيوزيلاندا'),
(83319, 3397218048, 3397222399, 'AU', 'AUS', 'أستراليا'),
(83320, 3397222400, 3397230591, 'PK', 'PAK', 'باكستان'),
(83321, 3397230592, 3397234687, 'AU', 'AUS', 'أستراليا'),
(83322, 3397234688, 3397238783, 'CN', 'CHN', 'الصين'),
(83323, 3397238784, 3397255167, 'HK', 'HKG', 'هونغ كونغ'),
(83324, 3397255168, 3397255607, 'JP', 'JPN', 'اليابان'),
(83325, 3397255608, 3397255615, 'SG', 'SGP', 'سنغافورة'),
(83326, 3397255616, 3397255711, 'JP', 'JPN', 'اليابان'),
(83327, 3397255712, 3397255727, 'SG', 'SGP', 'سنغافورة'),
(83328, 3397255728, 3397255807, 'JP', 'JPN', 'اليابان'),
(83329, 3397255808, 3397255823, 'HK', 'HKG', 'هونغ كونغ'),
(83330, 3397255824, 3397256655, 'JP', 'JPN', 'اليابان'),
(83331, 3397256656, 3397256671, 'HK', 'HKG', 'هونغ كونغ'),
(83332, 3397256672, 3397256975, 'JP', 'JPN', 'اليابان'),
(83333, 3397256976, 3397256983, 'SG', 'SGP', 'سنغافورة'),
(83334, 3397256984, 3397257327, 'JP', 'JPN', 'اليابان'),
(83335, 3397257328, 3397257343, 'SG', 'SGP', 'سنغافورة'),
(83336, 3397257344, 3397257983, 'JP', 'JPN', 'اليابان'),
(83337, 3397257984, 3397258007, 'SG', 'SGP', 'سنغافورة'),
(83338, 3397258008, 3397258015, 'JP', 'JPN', 'اليابان'),
(83339, 3397258016, 3397258063, 'SG', 'SGP', 'سنغافورة'),
(83340, 3397258064, 3397263359, 'JP', 'JPN', 'اليابان'),
(83341, 3397263360, 3397267455, 'PH', 'PHL', 'الفلبين'),
(83342, 3397267456, 3397271551, 'HK', 'HKG', 'هونغ كونغ'),
(83343, 3397271552, 3397275647, 'TW', 'TWN', 'تايوان'),
(83344, 3397275648, 3397277695, 'NZ', 'NZL', 'نيوزيلاندا'),
(83345, 3397277696, 3397279743, 'MN', 'MNG', 'منغوليا'),
(83346, 3397279744, 3397283839, 'AU', 'AUS', 'أستراليا'),
(83347, 3397283840, 3397285887, 'KR', 'KOR', 'جمهورية كوريا'),
(83348, 3397285888, 3397287935, 'BD', 'BGD', 'بنغالاديش'),
(83349, 3397287936, 3397304319, 'SG', 'SGP', 'سنغافورة'),
(83350, 3397304320, 3397308415, 'NZ', 'NZL', 'نيوزيلاندا'),
(83351, 3397308416, 3397312511, 'HK', 'HKG', 'هونغ كونغ'),
(83352, 3397312512, 3397320703, 'JP', 'JPN', 'اليابان'),
(83353, 3397320704, 3397322751, 'CN', 'CHN', 'الصين'),
(83354, 3397322752, 3397323775, 'NZ', 'NZL', 'نيوزيلاندا'),
(83355, 3397323776, 3397328895, 'CN', 'CHN', 'الصين'),
(83356, 3397328896, 3397330943, 'ID', 'IDN', 'إندونيسيا'),
(83357, 3397330944, 3397337087, 'CN', 'CHN', 'الصين'),
(83358, 3397337088, 3397341183, 'HK', 'HKG', 'هونغ كونغ'),
(83359, 3397341184, 3397345279, 'JP', 'JPN', 'اليابان'),
(83360, 3397345280, 3397349375, 'ID', 'IDN', 'إندونيسيا'),
(83361, 3397349376, 3397363711, 'CN', 'CHN', 'الصين'),
(83362, 3397363712, 3397365759, 'HK', 'HKG', 'هونغ كونغ'),
(83363, 3397365760, 3397369855, 'JP', 'JPN', 'اليابان'),
(83364, 3397369856, 3397374463, 'CN', 'CHN', 'الصين'),
(83365, 3397374464, 3397374975, 'AU', 'AUS', 'أستراليا'),
(83366, 3397374976, 3397386239, 'CN', 'CHN', 'الصين'),
(83367, 3397386240, 3397394431, 'GU', 'GUM', 'غوام'),
(83368, 3397394432, 3397402623, 'PH', 'PHL', 'الفلبين'),
(83369, 3397402624, 3397410815, 'GU', 'GUM', 'غوام'),
(83370, 3397410816, 3397419007, 'AU', 'AUS', 'أستراليا'),
(83371, 3397419008, 3397419535, 'HK', 'HKG', 'هونغ كونغ'),
(83372, 3397419536, 3397419551, 'KR', 'KOR', 'جمهورية كوريا'),
(83373, 3397419552, 3397419743, 'HK', 'HKG', 'هونغ كونغ'),
(83374, 3397419744, 3397419759, 'KR', 'KOR', 'جمهورية كوريا'),
(83375, 3397419760, 3397419871, 'HK', 'HKG', 'هونغ كونغ'),
(83376, 3397419872, 3397419904, 'KR', 'KOR', 'جمهورية كوريا'),
(83377, 3397419905, 3397427199, 'HK', 'HKG', 'هونغ كونغ'),
(83378, 3397427200, 3397443583, 'SG', 'SGP', 'سنغافورة'),
(83379, 3397443584, 3397451775, 'HK', 'HKG', 'هونغ كونغ'),
(83380, 3397451776, 3397468159, 'TH', 'THA', 'تايلند'),
(83381, 3397468160, 3397492735, 'AU', 'AUS', 'أستراليا'),
(83382, 3397492736, 3397496831, 'MY', 'MYS', 'ماليزيا'),
(83383, 3397496832, 3397498879, 'JP', 'JPN', 'اليابان'),
(83384, 3397498880, 3397500927, 'ID', 'IDN', 'إندونيسيا'),
(83385, 3397500928, 3397501951, 'BD', 'BGD', 'بنغالاديش'),
(83386, 3397501952, 3397503999, 'IN', 'IND', 'الهند'),
(83387, 3397504000, 3397505023, 'TH', 'THA', 'تايلند'),
(83388, 3397505024, 3397505279, 'NZ', 'NZL', 'نيوزيلاندا'),
(83389, 3397505280, 3397506559, 'IN', 'IND', 'الهند'),
(83390, 3397506560, 3397506815, 'AU', 'AUS', 'أستراليا'),
(83391, 3397506816, 3397507071, 'IN', 'IND', 'الهند'),
(83392, 3397507072, 3397507583, 'ID', 'IDN', 'إندونيسيا'),
(83393, 3397507584, 3397507839, 'AU', 'AUS', 'أستراليا'),
(83394, 3397507840, 3397508095, 'IN', 'IND', 'الهند'),
(83395, 3397508096, 3397509119, 'PH', 'PHL', 'الفلبين'),
(83396, 3397509120, 3397510143, 'ID', 'IDN', 'إندونيسيا'),
(83397, 3397510144, 3397511167, 'FJ', 'FJI', 'فيجي'),
(83398, 3397511168, 3397512191, 'LK', 'LKA', 'سيريلانكا'),
(83399, 3397512192, 3397512447, 'KH', 'KHM', 'كامبوديا'),
(83400, 3397512448, 3397512703, 'AU', 'AUS', 'أستراليا'),
(83401, 3397512704, 3397512959, 'PH', 'PHL', 'الفلبين'),
(83402, 3397512960, 3397513727, 'IN', 'IND', 'الهند'),
(83403, 3397513728, 3397514239, 'SG', 'SGP', 'سنغافورة'),
(83404, 3397514240, 3397515263, 'AU', 'AUS', 'أستراليا'),
(83405, 3397515264, 3397516287, 'NP', 'NPL', 'نيبال'),
(83406, 3397516288, 3397516543, 'AU', 'AUS', 'أستراليا'),
(83407, 3397516544, 3397516799, 'NZ', 'NZL', 'نيوزيلاندا'),
(83408, 3397516800, 3397517055, 'JP', 'JPN', 'اليابان'),
(83409, 3397517056, 3397517311, 'AU', 'AUS', 'أستراليا'),
(83410, 3397517312, 3397525503, 'CN', 'CHN', 'الصين'),
(83411, 3397525504, 3397526527, 'AU', 'AUS', 'أستراليا'),
(83412, 3397526528, 3397527039, 'VN', 'VNM', 'فييتنام'),
(83413, 3397527040, 3397527295, 'AU', 'AUS', 'أستراليا'),
(83414, 3397527296, 3397527551, 'JP', 'JPN', 'اليابان'),
(83415, 3397527552, 3397528575, 'IN', 'IND', 'الهند'),
(83416, 3397528576, 3397530623, 'AU', 'AUS', 'أستراليا'),
(83417, 3397530624, 3397531647, 'ID', 'IDN', 'إندونيسيا'),
(83418, 3397531648, 3397532671, 'SG', 'SGP', 'سنغافورة'),
(83419, 3397532672, 3397533695, 'JP', 'JPN', 'اليابان'),
(83420, 3397533696, 3397555903, 'HK', 'HKG', 'هونغ كونغ'),
(83421, 3397555904, 3397555935, 'JP', 'JPN', 'اليابان'),
(83422, 3397555936, 3397566263, 'HK', 'HKG', 'هونغ كونغ'),
(83423, 3397566264, 3397566271, 'TW', 'TWN', 'تايوان'),
(83424, 3397566272, 3397566463, 'HK', 'HKG', 'هونغ كونغ'),
(83425, 3397566464, 3397574655, 'AU', 'AUS', 'أستراليا'),
(83426, 3397574656, 3397582847, 'CN', 'CHN', 'الصين'),
(83427, 3397582848, 3397584895, 'MN', 'MNG', 'منغوليا'),
(83428, 3397584896, 3397586943, 'JP', 'JPN', 'اليابان'),
(83429, 3397586944, 3397588991, 'CN', 'CHN', 'الصين'),
(83430, 3397588992, 3397591039, 'KR', 'KOR', 'جمهورية كوريا'),
(83431, 3397591040, 3397595135, 'HK', 'HKG', 'هونغ كونغ'),
(83432, 3397595136, 3397599231, 'CN', 'CHN', 'الصين'),
(83433, 3397599232, 3397603327, 'HK', 'HKG', 'هونغ كونغ'),
(83434, 3397603328, 3397605375, 'KH', 'KHM', 'كامبوديا'),
(83435, 3397605376, 3397607423, 'AU', 'AUS', 'أستراليا'),
(83436, 3397607424, 3397623807, 'IN', 'IND', 'الهند'),
(83437, 3397623808, 3397631999, 'GU', 'GUM', 'غوام'),
(83438, 3397632000, 3397636095, 'JP', 'JPN', 'اليابان'),
(83439, 3397636096, 3397640191, 'CN', 'CHN', 'الصين'),
(83440, 3397640192, 3397648383, 'MN', 'MNG', 'منغوليا'),
(83441, 3397648384, 3397713919, 'TW', 'TWN', 'تايوان'),
(83442, 3397713920, 3397715967, 'ID', 'IDN', 'إندونيسيا'),
(83443, 3397715968, 3397716431, 'HK', 'HKG', 'هونغ كونغ'),
(83444, 3397716432, 3397716447, 'ID', 'IDN', 'إندونيسيا'),
(83445, 3397716448, 3397716471, 'HK', 'HKG', 'هونغ كونغ'),
(83446, 3397716472, 3397716479, 'AF', 'AFG', 'أفغانستان'),
(83447, 3397716480, 3397717255, 'HK', 'HKG', 'هونغ كونغ'),
(83448, 3397717256, 3397717279, 'AF', 'AFG', 'أفغانستان'),
(83449, 3397717280, 3397717287, 'ID', 'IDN', 'إندونيسيا'),
(83450, 3397717288, 3397717295, 'AF', 'AFG', 'أفغانستان'),
(83451, 3397717296, 3397717303, 'HK', 'HKG', 'هونغ كونغ'),
(83452, 3397717304, 3397717311, 'AF', 'AFG', 'أفغانستان'),
(83453, 3397717312, 3397717711, 'HK', 'HKG', 'هونغ كونغ'),
(83454, 3397717712, 3397717727, 'BD', 'BGD', 'بنغالاديش'),
(83455, 3397717728, 3397718015, 'HK', 'HKG', 'هونغ كونغ'),
(83456, 3397718016, 3397722111, 'KR', 'KOR', 'جمهورية كوريا'),
(83457, 3397722112, 3397726207, 'AU', 'AUS', 'أستراليا'),
(83458, 3397726208, 3397730303, 'IN', 'IND', 'الهند'),
(83459, 3397730304, 3397734399, 'AU', 'AUS', 'أستراليا'),
(83460, 3397734400, 3397738495, 'ID', 'IDN', 'إندونيسيا'),
(83461, 3397738496, 3397742591, 'MY', 'MYS', 'ماليزيا'),
(83462, 3397742592, 3397746687, 'JP', 'JPN', 'اليابان'),
(83463, 3397746688, 3397763071, 'TH', 'THA', 'تايلند'),
(83464, 3397763072, 3397771263, 'PH', 'PHL', 'الفلبين'),
(83465, 3397771264, 3397775887, 'TW', 'TWN', 'تايوان'),
(83466, 3397775888, 3397775919, 'HK', 'HKG', 'هونغ كونغ'),
(83467, 3397775920, 3397777535, 'TW', 'TWN', 'تايوان'),
(83468, 3397777536, 3397777551, 'CR', 'CRI', 'كوستا ريكا'),
(83469, 3397777552, 3397777583, 'TW', 'TWN', 'تايوان'),
(83470, 3397777584, 3397777599, 'CR', 'CRI', 'كوستا ريكا'),
(83471, 3397777600, 3397777791, 'TW', 'TWN', 'تايوان'),
(83472, 3397777792, 3397777807, 'CR', 'CRI', 'كوستا ريكا'),
(83473, 3397777808, 3397777839, 'TW', 'TWN', 'تايوان'),
(83474, 3397777840, 3397777855, 'CR', 'CRI', 'كوستا ريكا'),
(83475, 3397777856, 3397778175, 'TW', 'TWN', 'تايوان'),
(83476, 3397778176, 3397778191, 'US', 'USA', 'الولايات المتحدة'),
(83477, 3397778192, 3397779455, 'TW', 'TWN', 'تايوان'),
(83478, 3397779456, 3397781503, 'ID', 'IDN', 'إندونيسيا'),
(83479, 3397781504, 3397783551, 'BD', 'BGD', 'بنغالاديش'),
(83480, 3397783552, 3397785599, 'VN', 'VNM', 'فييتنام'),
(83481, 3397785600, 3397787647, 'TO', 'TON', 'تونغا'),
(83482, 3397787648, 3397791743, 'AU', 'AUS', 'أستراليا'),
(83483, 3397791744, 3397791999, 'NZ', 'NZL', 'نيوزيلاندا'),
(83484, 3397792000, 3397792767, 'AU', 'AUS', 'أستراليا'),
(83485, 3397792768, 3397793023, 'IN', 'IND', 'الهند'),
(83486, 3397793024, 3397793279, 'NZ', 'NZL', 'نيوزيلاندا'),
(83487, 3397793280, 3397793535, 'VN', 'VNM', 'فييتنام'),
(83488, 3397793536, 3397793791, 'HK', 'HKG', 'هونغ كونغ'),
(83489, 3397793792, 3397794303, 'PH', 'PHL', 'الفلبين'),
(83490, 3397794304, 3397794559, 'AU', 'AUS', 'أستراليا'),
(83491, 3397794560, 3397794815, 'IN', 'IND', 'الهند'),
(83492, 3397794816, 3397812223, 'HK', 'HKG', 'هونغ كونغ'),
(83493, 3397812224, 3397816319, 'AU', 'AUS', 'أستراليا'),
(83494, 3397816320, 3397832703, 'IN', 'IND', 'الهند'),
(83495, 3397832704, 3397836799, 'JP', 'JPN', 'اليابان'),
(83496, 3397836800, 3397844991, 'AU', 'AUS', 'أستراليا'),
(83497, 3397844992, 3397853695, 'JP', 'JPN', 'اليابان'),
(83498, 3397853696, 3397853951, 'NZ', 'NZL', 'نيوزيلاندا'),
(83499, 3397853952, 3397854207, 'HK', 'HKG', 'هونغ كونغ'),
(83500, 3397854208, 3397855231, 'JP', 'JPN', 'اليابان'),
(83501, 3397855232, 3397855239, 'HK', 'HKG', 'هونغ كونغ'),
(83502, 3397855240, 3397857535, 'JP', 'JPN', 'اليابان'),
(83503, 3397857536, 3397857791, 'NZ', 'NZL', 'نيوزيلاندا'),
(83504, 3397857792, 3397873407, 'JP', 'JPN', 'اليابان'),
(83505, 3397873408, 3397873663, 'NZ', 'NZL', 'نيوزيلاندا'),
(83506, 3397873664, 3397881503, 'JP', 'JPN', 'اليابان'),
(83507, 3397881504, 3397881535, 'NZ', 'NZL', 'نيوزيلاندا'),
(83508, 3397881536, 3397903103, 'JP', 'JPN', 'اليابان'),
(83509, 3397903104, 3397903359, 'HK', 'HKG', 'هونغ كونغ'),
(83510, 3397903360, 3397910015, 'JP', 'JPN', 'اليابان'),
(83511, 3397910016, 3397910271, 'SG', 'SGP', 'سنغافورة'),
(83512, 3397910272, 3397910527, 'JP', 'JPN', 'اليابان'),
(83513, 3397910528, 3397918719, 'SG', 'SGP', 'سنغافورة'),
(83514, 3397918720, 3397922815, 'AU', 'AUS', 'أستراليا'),
(83515, 3397922816, 3397926911, 'CN', 'CHN', 'الصين'),
(83516, 3397926912, 3397935103, 'ID', 'IDN', 'إندونيسيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(83517, 3397935104, 3397939199, 'AU', 'AUS', 'أستراليا'),
(83518, 3397939200, 3397951487, 'KR', 'KOR', 'جمهورية كوريا'),
(83519, 3397951488, 3397959679, 'SG', 'SGP', 'سنغافورة'),
(83520, 3397959680, 3397963775, 'JP', 'JPN', 'اليابان'),
(83521, 3397963776, 3397971967, 'CN', 'CHN', 'الصين'),
(83522, 3397971968, 3397974015, 'LA', 'LAO', 'لاو'),
(83523, 3397974016, 3397975039, 'IN', 'IND', 'الهند'),
(83524, 3397975040, 3397976063, 'AU', 'AUS', 'أستراليا'),
(83525, 3397976064, 3397984255, 'ID', 'IDN', 'إندونيسيا'),
(83526, 3397984256, 3397992447, 'JP', 'JPN', 'اليابان'),
(83527, 3397992448, 3398004735, 'AU', 'AUS', 'أستراليا'),
(83528, 3398004736, 3398008831, 'PH', 'PHL', 'الفلبين'),
(83529, 3398008832, 3398017023, 'LA', 'LAO', 'لاو'),
(83530, 3398017024, 3398021119, 'AU', 'AUS', 'أستراليا'),
(83531, 3398021120, 3398023167, 'FJ', 'FJI', 'فيجي'),
(83532, 3398023168, 3398025215, 'JP', 'JPN', 'اليابان'),
(83533, 3398025216, 3398029311, 'AU', 'AUS', 'أستراليا'),
(83534, 3398029312, 3398033407, 'IN', 'IND', 'الهند'),
(83535, 3398033408, 3398033663, 'NZ', 'NZL', 'نيوزيلاندا'),
(83536, 3398033664, 3398033919, 'ID', 'IDN', 'إندونيسيا'),
(83537, 3398033920, 3398034943, 'IN', 'IND', 'الهند'),
(83538, 3398034944, 3398035199, 'ID', 'IDN', 'إندونيسيا'),
(83539, 3398035200, 3398035455, 'AU', 'AUS', 'أستراليا'),
(83540, 3398035456, 3398037503, 'IN', 'IND', 'الهند'),
(83541, 3398037504, 3398039551, 'NZ', 'NZL', 'نيوزيلاندا'),
(83542, 3398039552, 3398040575, 'IN', 'IND', 'الهند'),
(83543, 3398040576, 3398041599, 'MY', 'MYS', 'ماليزيا'),
(83544, 3398041600, 3398062079, 'AU', 'AUS', 'أستراليا'),
(83545, 3398062080, 3398066175, 'JP', 'JPN', 'اليابان'),
(83546, 3398066176, 3398074367, 'IN', 'IND', 'الهند'),
(83547, 3398074368, 3398090751, 'PH', 'PHL', 'الفلبين'),
(83548, 3398090752, 3398098943, 'AU', 'AUS', 'أستراليا'),
(83549, 3398098944, 3398107135, 'ID', 'IDN', 'إندونيسيا'),
(83550, 3398107136, 3398156287, 'AU', 'AUS', 'أستراليا'),
(83551, 3398156288, 3398164479, 'TH', 'THA', 'تايلند'),
(83552, 3398164480, 3398172671, 'AU', 'AUS', 'أستراليا'),
(83553, 3398172672, 3398180863, 'JP', 'JPN', 'اليابان'),
(83554, 3398180864, 3398189055, 'IN', 'IND', 'الهند'),
(83555, 3398189056, 3398205439, 'HK', 'HKG', 'هونغ كونغ'),
(83556, 3398205440, 3398213631, 'IN', 'IND', 'الهند'),
(83557, 3398213632, 3398221823, 'AU', 'AUS', 'أستراليا'),
(83558, 3398221824, 3398230015, 'JP', 'JPN', 'اليابان'),
(83559, 3398230016, 3398238207, 'HK', 'HKG', 'هونغ كونغ'),
(83560, 3398238208, 3398279167, 'IN', 'IND', 'الهند'),
(83561, 3398279168, 3398287359, 'CN', 'CHN', 'الصين'),
(83562, 3398287360, 3398291455, 'JP', 'JPN', 'اليابان'),
(83563, 3398291456, 3398295551, 'AU', 'AUS', 'أستراليا'),
(83564, 3398295552, 3398303743, 'PK', 'PAK', 'باكستان'),
(83565, 3398303744, 3398305791, 'IN', 'IND', 'الهند'),
(83566, 3398305792, 3398307839, 'JP', 'JPN', 'اليابان'),
(83567, 3398307840, 3398311935, 'CN', 'CHN', 'الصين'),
(83568, 3398311936, 3398320127, 'AU', 'AUS', 'أستراليا'),
(83569, 3398320128, 3398336511, 'IN', 'IND', 'الهند'),
(83570, 3398336512, 3398340607, 'AU', 'AUS', 'أستراليا'),
(83571, 3398340608, 3398352895, 'PK', 'PAK', 'باكستان'),
(83572, 3398352896, 3398361087, 'TH', 'THA', 'تايلند'),
(83573, 3398361088, 3398369279, 'JP', 'JPN', 'اليابان'),
(83574, 3398369280, 3398369791, 'IN', 'IND', 'الهند'),
(83575, 3398369792, 3398370303, 'JP', 'JPN', 'اليابان'),
(83576, 3398370304, 3398371327, 'AU', 'AUS', 'أستراليا'),
(83577, 3398371328, 3398373375, 'JP', 'JPN', 'اليابان'),
(83578, 3398373376, 3398377471, 'CN', 'CHN', 'الصين'),
(83579, 3398377472, 3398385663, 'AU', 'AUS', 'أستراليا'),
(83580, 3398385664, 3398393855, 'JP', 'JPN', 'اليابان'),
(83581, 3398393856, 3398397951, 'ID', 'IDN', 'إندونيسيا'),
(83582, 3398397952, 3398402047, 'PK', 'PAK', 'باكستان'),
(83583, 3398402048, 3398418431, 'TH', 'THA', 'تايلند'),
(83584, 3398418432, 3398434815, 'JP', 'JPN', 'اليابان'),
(83585, 3398434816, 3398467583, 'IN', 'IND', 'الهند'),
(83586, 3398467584, 3398475775, 'BT', 'BTN', 'بوتان'),
(83587, 3398475776, 3398481919, 'AU', 'AUS', 'أستراليا'),
(83588, 3398481920, 3398483967, 'LA', 'LAO', 'لاو'),
(83589, 3398483968, 3398488063, 'MY', 'MYS', 'ماليزيا'),
(83590, 3398488064, 3398492159, 'TW', 'TWN', 'تايوان'),
(83591, 3398492160, 3398500351, 'AU', 'AUS', 'أستراليا'),
(83592, 3398500352, 3398504447, 'ID', 'IDN', 'إندونيسيا'),
(83593, 3398504448, 3398508543, 'JP', 'JPN', 'اليابان'),
(83594, 3398508544, 3398565887, 'TW', 'TWN', 'تايوان'),
(83595, 3398565888, 3398567423, 'ID', 'IDN', 'إندونيسيا'),
(83596, 3398567424, 3398569983, 'AU', 'AUS', 'أستراليا'),
(83597, 3398569984, 3398572031, 'JP', 'JPN', 'اليابان'),
(83598, 3398572032, 3398574079, 'AU', 'AUS', 'أستراليا'),
(83599, 3398574080, 3398582271, 'ID', 'IDN', 'إندونيسيا'),
(83600, 3398582272, 3398590463, 'MY', 'MYS', 'ماليزيا'),
(83601, 3398590464, 3398598655, 'HK', 'HKG', 'هونغ كونغ'),
(83602, 3398598656, 3398606847, 'ID', 'IDN', 'إندونيسيا'),
(83603, 3398606848, 3398610943, 'AU', 'AUS', 'أستراليا'),
(83604, 3398610944, 3398612991, 'ID', 'IDN', 'إندونيسيا'),
(83605, 3398612992, 3398613503, 'AU', 'AUS', 'أستراليا'),
(83606, 3398613504, 3398613759, 'NZ', 'NZL', 'نيوزيلاندا'),
(83607, 3398613760, 3398615039, 'AU', 'AUS', 'أستراليا'),
(83608, 3398615040, 3398616063, 'IN', 'IND', 'الهند'),
(83609, 3398616064, 3398621183, 'AU', 'AUS', 'أستراليا'),
(83610, 3398621184, 3398623231, 'HK', 'HKG', 'هونغ كونغ'),
(83611, 3398623232, 3398631423, 'ID', 'IDN', 'إندونيسيا'),
(83612, 3398631424, 3398631935, 'AU', 'AUS', 'أستراليا'),
(83613, 3398631936, 3398631951, 'JP', 'JPN', 'اليابان'),
(83614, 3398631952, 3398631967, 'AU', 'AUS', 'أستراليا'),
(83615, 3398631968, 3398632015, 'JP', 'JPN', 'اليابان'),
(83616, 3398632016, 3398632023, 'AU', 'AUS', 'أستراليا'),
(83617, 3398632024, 3398632047, 'JP', 'JPN', 'اليابان'),
(83618, 3398632048, 3398632063, 'AU', 'AUS', 'أستراليا'),
(83619, 3398632064, 3398632143, 'JP', 'JPN', 'اليابان'),
(83620, 3398632144, 3398632175, 'AU', 'AUS', 'أستراليا'),
(83621, 3398632176, 3398632191, 'JP', 'JPN', 'اليابان'),
(83622, 3398632192, 3398632255, 'AU', 'AUS', 'أستراليا'),
(83623, 3398632256, 3398632383, 'JP', 'JPN', 'اليابان'),
(83624, 3398632384, 3398632399, 'AU', 'AUS', 'أستراليا'),
(83625, 3398632400, 3398632575, 'JP', 'JPN', 'اليابان'),
(83626, 3398632576, 3398632639, 'AU', 'AUS', 'أستراليا'),
(83627, 3398632640, 3398632655, 'JP', 'JPN', 'اليابان'),
(83628, 3398632656, 3398632671, 'AU', 'AUS', 'أستراليا'),
(83629, 3398632672, 3398632679, 'JP', 'JPN', 'اليابان'),
(83630, 3398632680, 3398632687, 'AU', 'AUS', 'أستراليا'),
(83631, 3398632688, 3398632703, 'JP', 'JPN', 'اليابان'),
(83632, 3398632704, 3398632767, 'AU', 'AUS', 'أستراليا'),
(83633, 3398632768, 3398632959, 'JP', 'JPN', 'اليابان'),
(83634, 3398632960, 3398633983, 'AU', 'AUS', 'أستراليا'),
(83635, 3398633984, 3398634111, 'KR', 'KOR', 'جمهورية كوريا'),
(83636, 3398634112, 3398634303, 'AU', 'AUS', 'أستراليا'),
(83637, 3398634304, 3398634319, 'KR', 'KOR', 'جمهورية كوريا'),
(83638, 3398634320, 3398634343, 'AU', 'AUS', 'أستراليا'),
(83639, 3398634344, 3398634367, 'KR', 'KOR', 'جمهورية كوريا'),
(83640, 3398634368, 3398634399, 'AU', 'AUS', 'أستراليا'),
(83641, 3398634400, 3398634415, 'KR', 'KOR', 'جمهورية كوريا'),
(83642, 3398634416, 3398634431, 'AU', 'AUS', 'أستراليا'),
(83643, 3398634432, 3398634447, 'KR', 'KOR', 'جمهورية كوريا'),
(83644, 3398634448, 3398634463, 'AU', 'AUS', 'أستراليا'),
(83645, 3398634464, 3398634479, 'KR', 'KOR', 'جمهورية كوريا'),
(83646, 3398634480, 3398634495, 'AU', 'AUS', 'أستراليا'),
(83647, 3398634496, 3398634527, 'KR', 'KOR', 'جمهورية كوريا'),
(83648, 3398634528, 3398634559, 'AU', 'AUS', 'أستراليا'),
(83649, 3398634560, 3398634591, 'KR', 'KOR', 'جمهورية كوريا'),
(83650, 3398634592, 3398634751, 'AU', 'AUS', 'أستراليا'),
(83651, 3398634752, 3398634783, 'KR', 'KOR', 'جمهورية كوريا'),
(83652, 3398634784, 3398635263, 'AU', 'AUS', 'أستراليا'),
(83653, 3398635264, 3398635391, 'KR', 'KOR', 'جمهورية كوريا'),
(83654, 3398635392, 3398636047, 'AU', 'AUS', 'أستراليا'),
(83655, 3398636048, 3398636063, 'HK', 'HKG', 'هونغ كونغ'),
(83656, 3398636064, 3398636079, 'AU', 'AUS', 'أستراليا'),
(83657, 3398636080, 3398636087, 'HK', 'HKG', 'هونغ كونغ'),
(83658, 3398636088, 3398636095, 'AU', 'AUS', 'أستراليا'),
(83659, 3398636096, 3398636127, 'HK', 'HKG', 'هونغ كونغ'),
(83660, 3398636128, 3398636351, 'AU', 'AUS', 'أستراليا'),
(83661, 3398636352, 3398636367, 'HK', 'HKG', 'هونغ كونغ'),
(83662, 3398636368, 3398636375, 'AU', 'AUS', 'أستراليا'),
(83663, 3398636376, 3398636383, 'HK', 'HKG', 'هونغ كونغ'),
(83664, 3398636384, 3398636447, 'AU', 'AUS', 'أستراليا'),
(83665, 3398636448, 3398636511, 'HK', 'HKG', 'هونغ كونغ'),
(83666, 3398636512, 3398636543, 'AU', 'AUS', 'أستراليا'),
(83667, 3398636544, 3398636583, 'HK', 'HKG', 'هونغ كونغ'),
(83668, 3398636584, 3398636607, 'AU', 'AUS', 'أستراليا'),
(83669, 3398636608, 3398636719, 'HK', 'HKG', 'هونغ كونغ'),
(83670, 3398636720, 3398636767, 'AU', 'AUS', 'أستراليا'),
(83671, 3398636768, 3398636775, 'HK', 'HKG', 'هونغ كونغ'),
(83672, 3398636776, 3398636783, 'AU', 'AUS', 'أستراليا'),
(83673, 3398636784, 3398636799, 'HK', 'HKG', 'هونغ كونغ'),
(83674, 3398636800, 3398637183, 'AU', 'AUS', 'أستراليا'),
(83675, 3398637184, 3398637215, 'HK', 'HKG', 'هونغ كونغ'),
(83676, 3398637216, 3398637247, 'AU', 'AUS', 'أستراليا'),
(83677, 3398637248, 3398637311, 'HK', 'HKG', 'هونغ كونغ'),
(83678, 3398637312, 3398637455, 'AU', 'AUS', 'أستراليا'),
(83679, 3398637456, 3398637503, 'HK', 'HKG', 'هونغ كونغ'),
(83680, 3398637504, 3398637511, 'AU', 'AUS', 'أستراليا'),
(83681, 3398637512, 3398637519, 'HK', 'HKG', 'هونغ كونغ'),
(83682, 3398637520, 3398637551, 'AU', 'AUS', 'أستراليا'),
(83683, 3398637552, 3398637567, 'HK', 'HKG', 'هونغ كونغ'),
(83684, 3398637568, 3398638095, 'AU', 'AUS', 'أستراليا'),
(83685, 3398638096, 3398638111, 'PH', 'PHL', 'الفلبين'),
(83686, 3398638112, 3398638159, 'AU', 'AUS', 'أستراليا'),
(83687, 3398638160, 3398638167, 'PH', 'PHL', 'الفلبين'),
(83688, 3398638168, 3398638175, 'AU', 'AUS', 'أستراليا'),
(83689, 3398638176, 3398638191, 'TW', 'TWN', 'تايوان'),
(83690, 3398638192, 3398638207, 'PH', 'PHL', 'الفلبين'),
(83691, 3398638208, 3398638367, 'AU', 'AUS', 'أستراليا'),
(83692, 3398638368, 3398638383, 'TW', 'TWN', 'تايوان'),
(83693, 3398638384, 3398638399, 'AU', 'AUS', 'أستراليا'),
(83694, 3398638400, 3398638415, 'TW', 'TWN', 'تايوان'),
(83695, 3398638416, 3398638431, 'AU', 'AUS', 'أستراليا'),
(83696, 3398638432, 3398638447, 'PH', 'PHL', 'الفلبين'),
(83697, 3398638448, 3398638479, 'AU', 'AUS', 'أستراليا'),
(83698, 3398638480, 3398638495, 'TW', 'TWN', 'تايوان'),
(83699, 3398638496, 3398638879, 'AU', 'AUS', 'أستراليا'),
(83700, 3398638880, 3398638911, 'PH', 'PHL', 'الفلبين'),
(83701, 3398638912, 3398639007, 'AU', 'AUS', 'أستراليا'),
(83702, 3398639008, 3398639231, 'PH', 'PHL', 'الفلبين'),
(83703, 3398639232, 3398639247, 'AU', 'AUS', 'أستراليا'),
(83704, 3398639248, 3398639263, 'PH', 'PHL', 'الفلبين'),
(83705, 3398639264, 3398639271, 'TW', 'TWN', 'تايوان'),
(83706, 3398639272, 3398639423, 'AU', 'AUS', 'أستراليا'),
(83707, 3398639424, 3398639455, 'PH', 'PHL', 'الفلبين'),
(83708, 3398639456, 3398640127, 'AU', 'AUS', 'أستراليا'),
(83709, 3398640128, 3398640159, 'SG', 'SGP', 'سنغافورة'),
(83710, 3398640160, 3398640303, 'AU', 'AUS', 'أستراليا'),
(83711, 3398640304, 3398640311, 'SG', 'SGP', 'سنغافورة'),
(83712, 3398640312, 3398640639, 'AU', 'AUS', 'أستراليا'),
(83713, 3398640640, 3398640695, 'SG', 'SGP', 'سنغافورة'),
(83714, 3398640696, 3398640783, 'AU', 'AUS', 'أستراليا'),
(83715, 3398640784, 3398640799, 'SG', 'SGP', 'سنغافورة'),
(83716, 3398640800, 3398640911, 'AU', 'AUS', 'أستراليا'),
(83717, 3398640912, 3398640959, 'SG', 'SGP', 'سنغافورة'),
(83718, 3398640960, 3398641007, 'AU', 'AUS', 'أستراليا'),
(83719, 3398641008, 3398641039, 'SG', 'SGP', 'سنغافورة'),
(83720, 3398641040, 3398641055, 'AU', 'AUS', 'أستراليا'),
(83721, 3398641056, 3398641087, 'SG', 'SGP', 'سنغافورة'),
(83722, 3398641088, 3398641095, 'AU', 'AUS', 'أستراليا'),
(83723, 3398641096, 3398641103, 'SG', 'SGP', 'سنغافورة'),
(83724, 3398641104, 3398641119, 'AU', 'AUS', 'أستراليا'),
(83725, 3398641120, 3398641311, 'SG', 'SGP', 'سنغافورة'),
(83726, 3398641312, 3398641423, 'AU', 'AUS', 'أستراليا'),
(83727, 3398641424, 3398641431, 'SG', 'SGP', 'سنغافورة'),
(83728, 3398641432, 3398641447, 'MY', 'MYS', 'ماليزيا'),
(83729, 3398641448, 3398641455, 'AU', 'AUS', 'أستراليا'),
(83730, 3398641456, 3398641503, 'SG', 'SGP', 'سنغافورة'),
(83731, 3398641504, 3398641535, 'AU', 'AUS', 'أستراليا'),
(83732, 3398641536, 3398641543, 'SG', 'SGP', 'سنغافورة'),
(83733, 3398641544, 3398641567, 'AU', 'AUS', 'أستراليا'),
(83734, 3398641568, 3398641631, 'MY', 'MYS', 'ماليزيا'),
(83735, 3398641632, 3398642591, 'AU', 'AUS', 'أستراليا'),
(83736, 3398642592, 3398642599, 'NZ', 'NZL', 'نيوزيلاندا'),
(83737, 3398642600, 3398643015, 'AU', 'AUS', 'أستراليا'),
(83738, 3398643016, 3398643023, 'NZ', 'NZL', 'نيوزيلاندا'),
(83739, 3398643024, 3398643223, 'AU', 'AUS', 'أستراليا'),
(83740, 3398643224, 3398643247, 'NZ', 'NZL', 'نيوزيلاندا'),
(83741, 3398643248, 3398643375, 'AU', 'AUS', 'أستراليا'),
(83742, 3398643376, 3398643383, 'NZ', 'NZL', 'نيوزيلاندا'),
(83743, 3398643384, 3398643711, 'AU', 'AUS', 'أستراليا'),
(83744, 3398643712, 3398643967, 'SG', 'SGP', 'سنغافورة'),
(83745, 3398643968, 3398647295, 'AU', 'AUS', 'أستراليا'),
(83746, 3398647296, 3398647551, 'TW', 'TWN', 'تايوان'),
(83747, 3398647552, 3398672383, 'AU', 'AUS', 'أستراليا'),
(83748, 3398672384, 3398680575, 'PK', 'PAK', 'باكستان'),
(83749, 3398680576, 3398684671, 'ID', 'IDN', 'إندونيسيا'),
(83750, 3398684672, 3398688767, 'JP', 'JPN', 'اليابان'),
(83751, 3398688768, 3398705151, 'ID', 'IDN', 'إندونيسيا'),
(83752, 3398705152, 3398711295, 'AU', 'AUS', 'أستراليا'),
(83753, 3398711296, 3398713343, 'BD', 'BGD', 'بنغالاديش'),
(83754, 3398713344, 3398721535, 'AU', 'AUS', 'أستراليا'),
(83755, 3398721536, 3398729727, 'CN', 'CHN', 'الصين'),
(83756, 3398729728, 3398737919, 'AU', 'AUS', 'أستراليا'),
(83757, 3398737920, 3398742015, 'SG', 'SGP', 'سنغافورة'),
(83758, 3398742016, 3398746111, 'TH', 'THA', 'تايلند'),
(83759, 3398746112, 3398750207, 'IN', 'IND', 'الهند'),
(83760, 3398750208, 3398754303, 'TW', 'TWN', 'تايوان'),
(83761, 3398754304, 3398758399, 'AU', 'AUS', 'أستراليا'),
(83762, 3398758400, 3398768639, 'JP', 'JPN', 'اليابان'),
(83763, 3398768640, 3398770687, 'TH', 'THA', 'تايلند'),
(83764, 3398770688, 3398778879, 'IN', 'IND', 'الهند'),
(83765, 3398778880, 3398787071, 'ID', 'IDN', 'إندونيسيا'),
(83766, 3398787072, 3398795263, 'TH', 'THA', 'تايلند'),
(83767, 3398795264, 3398803455, 'ID', 'IDN', 'إندونيسيا'),
(83768, 3398803456, 3398811647, 'CN', 'CHN', 'الصين'),
(83769, 3398811648, 3398819839, 'IN', 'IND', 'الهند'),
(83770, 3398819840, 3398828031, 'CN', 'CHN', 'الصين'),
(83771, 3398828032, 3398829055, 'KH', 'KHM', 'كامبوديا'),
(83772, 3398829056, 3398830079, 'IN', 'IND', 'الهند'),
(83773, 3398830080, 3398831103, 'KH', 'KHM', 'كامبوديا'),
(83774, 3398831104, 3398832127, 'AU', 'AUS', 'أستراليا'),
(83775, 3398832128, 3398836223, 'CN', 'CHN', 'الصين'),
(83776, 3398836224, 3398840319, 'AU', 'AUS', 'أستراليا'),
(83777, 3398840320, 3398842367, 'JP', 'JPN', 'اليابان'),
(83778, 3398842368, 3398844415, 'AU', 'AUS', 'أستراليا'),
(83779, 3398844416, 3398852607, 'ID', 'IDN', 'إندونيسيا'),
(83780, 3398852608, 3398860799, 'NZ', 'NZL', 'نيوزيلاندا'),
(83781, 3398860800, 3398873087, 'ID', 'IDN', 'إندونيسيا'),
(83782, 3398873088, 3398877183, 'KR', 'KOR', 'جمهورية كوريا'),
(83783, 3398877184, 3398881279, 'AU', 'AUS', 'أستراليا'),
(83784, 3398881280, 3398885375, 'SG', 'SGP', 'سنغافورة'),
(83785, 3398885376, 3398893567, 'AU', 'AUS', 'أستراليا'),
(83786, 3398893568, 3398894591, 'ID', 'IDN', 'إندونيسيا'),
(83787, 3398894592, 3398895615, 'TH', 'THA', 'تايلند'),
(83788, 3398895616, 3398897663, 'ID', 'IDN', 'إندونيسيا'),
(83789, 3398897664, 3398901759, 'FJ', 'FJI', 'فيجي'),
(83790, 3398901760, 3398902015, 'AU', 'AUS', 'أستراليا'),
(83791, 3398902016, 3398902271, 'HK', 'HKG', 'هونغ كونغ'),
(83792, 3398902272, 3398902783, 'PH', 'PHL', 'الفلبين'),
(83793, 3398902784, 3398903807, 'AU', 'AUS', 'أستراليا'),
(83794, 3398903808, 3398905855, 'TH', 'THA', 'تايلند'),
(83795, 3398905856, 3398909951, 'TW', 'TWN', 'تايوان'),
(83796, 3398909952, 3398918143, 'GU', 'GUM', 'غوام'),
(83797, 3398918144, 3398926335, 'JP', 'JPN', 'اليابان'),
(83798, 3398926336, 3398934527, 'IN', 'IND', 'الهند'),
(83799, 3398934528, 3398938623, 'VN', 'VNM', 'فييتنام'),
(83800, 3398938624, 3398942719, 'TH', 'THA', 'تايلند'),
(83801, 3398942720, 3398959103, 'MY', 'MYS', 'ماليزيا'),
(83802, 3398959104, 3398975487, 'ID', 'IDN', 'إندونيسيا'),
(83803, 3398975488, 3398983679, 'BN', 'BRN', 'بروناي دار السلام'),
(83804, 3398983680, 3398991871, 'JP', 'JPN', 'اليابان'),
(83805, 3398991872, 3399004159, 'ID', 'IDN', 'إندونيسيا'),
(83806, 3399004160, 3399008255, 'CN', 'CHN', 'الصين'),
(83807, 3399008256, 3399012351, 'ID', 'IDN', 'إندونيسيا'),
(83808, 3399012352, 3399016447, 'JP', 'JPN', 'اليابان'),
(83809, 3399016448, 3399024639, 'ID', 'IDN', 'إندونيسيا'),
(83810, 3399024640, 3399025663, 'TH', 'THA', 'تايلند'),
(83811, 3399025664, 3399026175, 'JP', 'JPN', 'اليابان'),
(83812, 3399026176, 3399026431, 'SG', 'SGP', 'سنغافورة'),
(83813, 3399026432, 3399026687, 'AU', 'AUS', 'أستراليا'),
(83814, 3399026688, 3399028735, 'HK', 'HKG', 'هونغ كونغ'),
(83815, 3399028736, 3399032831, 'ID', 'IDN', 'إندونيسيا'),
(83816, 3399032832, 3399036927, 'IN', 'IND', 'الهند'),
(83817, 3399036928, 3399041023, 'CN', 'CHN', 'الصين'),
(83818, 3399041024, 3399045119, 'AU', 'AUS', 'أستراليا'),
(83819, 3399045120, 3399047167, 'MV', 'MDV', 'جزر المالديف'),
(83820, 3399047168, 3399057407, 'HK', 'HKG', 'هونغ كونغ'),
(83821, 3399057408, 3399065599, 'ID', 'IDN', 'إندونيسيا'),
(83822, 3399065600, 3399074495, 'TW', 'TWN', 'تايوان'),
(83823, 3399074496, 3399074527, 'CN', 'CHN', 'الصين'),
(83824, 3399074528, 3399075487, 'TW', 'TWN', 'تايوان'),
(83825, 3399075488, 3399075503, 'CR', 'CRI', 'كوستا ريكا'),
(83826, 3399075504, 3399076431, 'TW', 'TWN', 'تايوان'),
(83827, 3399076432, 3399076447, 'CR', 'CRI', 'كوستا ريكا'),
(83828, 3399076448, 3399076607, 'TW', 'TWN', 'تايوان'),
(83829, 3399076608, 3399076639, 'HK', 'HKG', 'هونغ كونغ'),
(83830, 3399076640, 3399076687, 'TW', 'TWN', 'تايوان'),
(83831, 3399076688, 3399076703, 'HK', 'HKG', 'هونغ كونغ'),
(83832, 3399076704, 3399077079, 'TW', 'TWN', 'تايوان'),
(83833, 3399077080, 3399077087, 'HK', 'HKG', 'هونغ كونغ'),
(83834, 3399077088, 3399077359, 'TW', 'TWN', 'تايوان'),
(83835, 3399077360, 3399077375, 'CR', 'CRI', 'كوستا ريكا'),
(83836, 3399077376, 3399077887, 'TW', 'TWN', 'تايوان'),
(83837, 3399077888, 3399081983, 'AU', 'AUS', 'أستراليا'),
(83838, 3399081984, 3399106559, 'ID', 'IDN', 'إندونيسيا'),
(83839, 3399106560, 3399122943, 'AU', 'AUS', 'أستراليا'),
(83840, 3399122944, 3399131135, 'NZ', 'NZL', 'نيوزيلاندا'),
(83841, 3399131136, 3399135231, 'IN', 'IND', 'الهند'),
(83842, 3399135232, 3399139327, 'ID', 'IDN', 'إندونيسيا'),
(83843, 3399139328, 3399147519, 'TW', 'TWN', 'تايوان'),
(83844, 3399147520, 3399155711, 'PK', 'PAK', 'باكستان'),
(83845, 3399155712, 3399196671, 'ID', 'IDN', 'إندونيسيا'),
(83846, 3399196672, 3399204863, 'AU', 'AUS', 'أستراليا'),
(83847, 3399204864, 3399221247, 'HK', 'HKG', 'هونغ كونغ'),
(83848, 3399221248, 3399286783, 'SG', 'SGP', 'سنغافورة'),
(83849, 3399286784, 3399303167, 'JP', 'JPN', 'اليابان'),
(83850, 3399303168, 3399311359, 'IN', 'IND', 'الهند'),
(83851, 3399311360, 3399319551, 'JP', 'JPN', 'اليابان'),
(83852, 3399319552, 3399331839, 'SG', 'SGP', 'سنغافورة'),
(83853, 3399331840, 3399332351, 'MY', 'MYS', 'ماليزيا'),
(83854, 3399332352, 3399332863, 'SG', 'SGP', 'سنغافورة'),
(83855, 3399332864, 3399333375, 'HK', 'HKG', 'هونغ كونغ'),
(83856, 3399333376, 3399335423, 'MY', 'MYS', 'ماليزيا'),
(83857, 3399335424, 3399335935, 'IN', 'IND', 'الهند'),
(83858, 3399335936, 3399344127, 'AU', 'AUS', 'أستراليا'),
(83859, 3399344128, 3399352319, 'JP', 'JPN', 'اليابان'),
(83860, 3399352320, 3399389183, 'ID', 'IDN', 'إندونيسيا'),
(83861, 3399389184, 3399393279, 'KR', 'KOR', 'جمهورية كوريا'),
(83862, 3399393280, 3399401471, 'CN', 'CHN', 'الصين'),
(83863, 3399401472, 3399409663, 'AU', 'AUS', 'أستراليا'),
(83864, 3399409664, 3399413759, 'JP', 'JPN', 'اليابان'),
(83865, 3399413760, 3399414271, 'AU', 'AUS', 'أستراليا'),
(83866, 3399414272, 3399414527, 'JP', 'JPN', 'اليابان'),
(83867, 3399414528, 3399414783, 'AU', 'AUS', 'أستراليا'),
(83868, 3399414784, 3399415807, 'VN', 'VNM', 'فييتنام'),
(83869, 3399415808, 3399416831, 'SG', 'SGP', 'سنغافورة'),
(83870, 3399416832, 3399417087, 'ID', 'IDN', 'إندونيسيا'),
(83871, 3399417088, 3399417855, 'AU', 'AUS', 'أستراليا'),
(83872, 3399417856, 3399450623, 'ID', 'IDN', 'إندونيسيا'),
(83873, 3399450624, 3399467007, 'AU', 'AUS', 'أستراليا'),
(83874, 3399467008, 3399483391, 'IN', 'IND', 'الهند'),
(83875, 3399483392, 3399495679, 'BN', 'BRN', 'بروناي دار السلام'),
(83876, 3399495680, 3399499775, 'NZ', 'NZL', 'نيوزيلاندا'),
(83877, 3399499776, 3399507967, 'TW', 'TWN', 'تايوان'),
(83878, 3399507968, 3399512063, 'AU', 'AUS', 'أستراليا'),
(83879, 3399512064, 3399514111, 'NZ', 'NZL', 'نيوزيلاندا'),
(83880, 3399514112, 3399515135, 'SG', 'SGP', 'سنغافورة'),
(83881, 3399515136, 3399515647, 'VN', 'VNM', 'فييتنام'),
(83882, 3399515648, 3399524351, 'AU', 'AUS', 'أستراليا'),
(83883, 3399524352, 3399528447, 'IN', 'IND', 'الهند'),
(83884, 3399528448, 3399532543, 'CN', 'CHN', 'الصين'),
(83885, 3399532544, 3399544575, 'SG', 'SGP', 'سنغافورة'),
(83886, 3399544576, 3399544831, 'IN', 'IND', 'الهند'),
(83887, 3399544832, 3399546879, 'SG', 'SGP', 'سنغافورة'),
(83888, 3399546880, 3399547135, 'US', 'USA', 'الولايات المتحدة'),
(83889, 3399547136, 3399547903, 'SG', 'SGP', 'سنغافورة'),
(83890, 3399547904, 3399548159, 'PK', 'PAK', 'باكستان'),
(83891, 3399548160, 3399548415, 'SG', 'SGP', 'سنغافورة'),
(83892, 3399548416, 3399548671, 'ID', 'IDN', 'إندونيسيا'),
(83893, 3399548672, 3399548927, 'SG', 'SGP', 'سنغافورة'),
(83894, 3399548928, 3399557119, 'AU', 'AUS', 'أستراليا'),
(83895, 3399557120, 3399565311, 'SG', 'SGP', 'سنغافورة'),
(83896, 3399565312, 3399581695, 'AU', 'AUS', 'أستراليا'),
(83897, 3399581696, 3399583487, 'US', 'USA', 'الولايات المتحدة'),
(83898, 3399583488, 3399583743, 'NP', 'NPL', 'نيبال'),
(83899, 3399583744, 3399584255, 'US', 'USA', 'الولايات المتحدة'),
(83900, 3399584256, 3399584511, 'BD', 'BGD', 'بنغالاديش'),
(83901, 3399584512, 3399587839, 'US', 'USA', 'الولايات المتحدة'),
(83902, 3399587840, 3399588095, 'BD', 'BGD', 'بنغالاديش'),
(83903, 3399588096, 3399589631, 'US', 'USA', 'الولايات المتحدة'),
(83904, 3399589632, 3399589887, 'NP', 'NPL', 'نيبال'),
(83905, 3399589888, 3399593983, 'HK', 'HKG', 'هونغ كونغ'),
(83906, 3399593984, 3399598079, 'BD', 'BGD', 'بنغالاديش'),
(83907, 3399598080, 3399614463, 'JP', 'JPN', 'اليابان'),
(83908, 3399614464, 3399622655, 'MY', 'MYS', 'ماليزيا'),
(83909, 3399622656, 3399626751, 'ID', 'IDN', 'إندونيسيا'),
(83910, 3399626752, 3399630847, 'IN', 'IND', 'الهند'),
(83911, 3399630848, 3399631871, 'AU', 'AUS', 'أستراليا'),
(83912, 3399631872, 3399632895, 'SG', 'SGP', 'سنغافورة'),
(83913, 3399632896, 3399633407, 'NZ', 'NZL', 'نيوزيلاندا'),
(83914, 3399633408, 3399633919, 'AU', 'AUS', 'أستراليا'),
(83915, 3399633920, 3399634943, 'TH', 'THA', 'تايلند'),
(83916, 3399634944, 3399639039, 'JP', 'JPN', 'اليابان'),
(83917, 3399639040, 3399643135, 'AU', 'AUS', 'أستراليا'),
(83918, 3399643136, 3399655423, 'JP', 'JPN', 'اليابان'),
(83919, 3399655424, 3399659519, 'PH', 'PHL', 'الفلبين'),
(83920, 3399659520, 3399661567, 'NZ', 'NZL', 'نيوزيلاندا'),
(83921, 3399661568, 3399662591, 'HK', 'HKG', 'هونغ كونغ'),
(83922, 3399662592, 3399663615, 'IN', 'IND', 'الهند'),
(83923, 3399663616, 3399671807, 'ID', 'IDN', 'إندونيسيا'),
(83924, 3399671808, 3399679999, 'IN', 'IND', 'الهند'),
(83925, 3399680000, 3399688191, 'HK', 'HKG', 'هونغ كونغ'),
(83926, 3399688192, 3399696383, 'SG', 'SGP', 'سنغافورة'),
(83927, 3399696384, 3399712767, 'PK', 'PAK', 'باكستان'),
(83928, 3399712768, 3399720959, 'KR', 'KOR', 'جمهورية كوريا'),
(83929, 3399720960, 3399729151, 'JP', 'JPN', 'اليابان'),
(83930, 3399729152, 3399745535, 'PH', 'PHL', 'الفلبين'),
(83931, 3399745536, 3399749631, 'CN', 'CHN', 'الصين'),
(83932, 3399749632, 3399751679, 'AU', 'AUS', 'أستراليا'),
(83933, 3399751680, 3399752191, 'IN', 'IND', 'الهند'),
(83934, 3399752192, 3399752447, 'AU', 'AUS', 'أستراليا'),
(83935, 3399752448, 3399752703, 'HK', 'HKG', 'هونغ كونغ'),
(83936, 3399752704, 3399753727, 'NZ', 'NZL', 'نيوزيلاندا'),
(83937, 3399753728, 3399761919, 'IN', 'IND', 'الهند'),
(83938, 3399761920, 3399770111, 'JP', 'JPN', 'اليابان'),
(83939, 3399770112, 3399778303, 'AU', 'AUS', 'أستراليا'),
(83940, 3399778304, 3399786495, 'IN', 'IND', 'الهند'),
(83941, 3399786496, 3399794687, 'PH', 'PHL', 'الفلبين'),
(83942, 3399794688, 3399798783, 'AU', 'AUS', 'أستراليا'),
(83943, 3399798784, 3399800831, 'BD', 'BGD', 'بنغالاديش'),
(83944, 3399800832, 3399802879, 'ID', 'IDN', 'إندونيسيا'),
(83945, 3399802880, 3399811071, 'JP', 'JPN', 'اليابان'),
(83946, 3399811072, 3399819263, 'MY', 'MYS', 'ماليزيا'),
(83947, 3399819264, 3399823359, 'ID', 'IDN', 'إندونيسيا'),
(83948, 3399823360, 3399825407, 'JP', 'JPN', 'اليابان'),
(83949, 3399825408, 3399826431, 'KR', 'KOR', 'جمهورية كوريا'),
(83950, 3399826432, 3399826943, 'PH', 'PHL', 'الفلبين'),
(83951, 3399826944, 3399827455, 'IN', 'IND', 'الهند'),
(83952, 3399827456, 3399839743, 'AU', 'AUS', 'أستراليا'),
(83953, 3399839744, 3399841791, 'JP', 'JPN', 'اليابان'),
(83954, 3399841792, 3399846399, 'TW', 'TWN', 'تايوان'),
(83955, 3399846400, 3399846407, 'US', 'USA', 'الولايات المتحدة'),
(83956, 3399846408, 3399846919, 'TW', 'TWN', 'تايوان'),
(83957, 3399846920, 3399846935, 'US', 'USA', 'الولايات المتحدة'),
(83958, 3399846936, 3399847247, 'TW', 'TWN', 'تايوان'),
(83959, 3399847248, 3399847263, 'US', 'USA', 'الولايات المتحدة'),
(83960, 3399847264, 3399852031, 'TW', 'TWN', 'تايوان'),
(83961, 3399852032, 3399856127, 'JP', 'JPN', 'اليابان'),
(83962, 3399856128, 3399860223, 'CN', 'CHN', 'الصين'),
(83963, 3399860224, 3399864319, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(83964, 3399864320, 3399868415, 'CN', 'CHN', 'الصين'),
(83965, 3399868416, 3399872255, 'PK', 'PAK', 'باكستان'),
(83966, 3399872256, 3399873023, 'AU', 'AUS', 'أستراليا'),
(83967, 3399873024, 3399873279, 'PK', 'PAK', 'باكستان'),
(83968, 3399873280, 3399873535, 'AU', 'AUS', 'أستراليا'),
(83969, 3399873536, 3399873791, 'PK', 'PAK', 'باكستان'),
(83970, 3399873792, 3399874047, 'AU', 'AUS', 'أستراليا'),
(83971, 3399874048, 3399875327, 'PK', 'PAK', 'باكستان'),
(83972, 3399875328, 3399876607, 'AU', 'AUS', 'أستراليا'),
(83973, 3399876608, 3399917567, 'SG', 'SGP', 'سنغافورة'),
(83974, 3399917568, 3399921663, 'AU', 'AUS', 'أستراليا'),
(83975, 3399921664, 3399923711, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(83976, 3399923712, 3399923967, 'IN', 'IND', 'الهند'),
(83977, 3399923968, 3399924223, 'JP', 'JPN', 'اليابان'),
(83978, 3399924224, 3399924735, 'AU', 'AUS', 'أستراليا'),
(83979, 3399924736, 3399925759, 'PH', 'PHL', 'الفلبين'),
(83980, 3399925760, 3399933951, 'NP', 'NPL', 'نيبال'),
(83981, 3399933952, 3399950335, 'AU', 'AUS', 'أستراليا'),
(83982, 3399950336, 3399967871, 'US', 'USA', 'الولايات المتحدة'),
(83983, 3399967872, 3399967999, 'HK', 'HKG', 'هونغ كونغ'),
(83984, 3399968000, 3399974911, 'US', 'USA', 'الولايات المتحدة'),
(83985, 3399974912, 3399979007, 'AU', 'AUS', 'أستراليا'),
(83986, 3399979008, 3399982959, 'US', 'USA', 'الولايات المتحدة'),
(83987, 3399982960, 3399982975, 'SG', 'SGP', 'سنغافورة'),
(83988, 3399982976, 3399995391, 'US', 'USA', 'الولايات المتحدة'),
(83989, 3399995392, 3399999487, 'KR', 'KOR', 'جمهورية كوريا'),
(83990, 3399999488, 3400002047, 'SG', 'SGP', 'سنغافورة'),
(83991, 3400002048, 3400002559, 'HK', 'HKG', 'هونغ كونغ'),
(83992, 3400002560, 3400003583, 'JP', 'JPN', 'اليابان'),
(83993, 3400003584, 3400004799, 'SG', 'SGP', 'سنغافورة'),
(83994, 3400004800, 3400004807, 'MY', 'MYS', 'ماليزيا'),
(83995, 3400004808, 3400004831, 'SG', 'SGP', 'سنغافورة'),
(83996, 3400004832, 3400004863, 'US', 'USA', 'الولايات المتحدة'),
(83997, 3400004864, 3400005823, 'SG', 'SGP', 'سنغافورة'),
(83998, 3400005824, 3400005863, 'HK', 'HKG', 'هونغ كونغ'),
(83999, 3400005864, 3400006143, 'SG', 'SGP', 'سنغافورة'),
(84000, 3400006144, 3400006399, 'HK', 'HKG', 'هونغ كونغ'),
(84001, 3400006400, 3400007295, 'SG', 'SGP', 'سنغافورة'),
(84002, 3400007296, 3400007303, 'JP', 'JPN', 'اليابان'),
(84003, 3400007304, 3400007679, 'SG', 'SGP', 'سنغافورة'),
(84004, 3400007680, 3400024063, 'AU', 'AUS', 'أستراليا'),
(84005, 3400024064, 3400028159, 'MY', 'MYS', 'ماليزيا'),
(84006, 3400028160, 3400030207, 'AU', 'AUS', 'أستراليا'),
(84007, 3400030208, 3400031231, 'IN', 'IND', 'الهند'),
(84008, 3400031232, 3400031743, 'SG', 'SGP', 'سنغافورة'),
(84009, 3400031744, 3400031999, 'IN', 'IND', 'الهند'),
(84010, 3400032000, 3400032255, 'HK', 'HKG', 'هونغ كونغ'),
(84011, 3400032256, 3400048639, 'AU', 'AUS', 'أستراليا'),
(84012, 3400048640, 3400056831, 'CN', 'CHN', 'الصين'),
(84013, 3400056832, 3400060927, 'TW', 'TWN', 'تايوان'),
(84014, 3400060928, 3400062975, 'HK', 'HKG', 'هونغ كونغ'),
(84015, 3400062976, 3400065023, 'JP', 'JPN', 'اليابان'),
(84016, 3400065024, 3400073215, 'BD', 'BGD', 'بنغالاديش'),
(84017, 3400073216, 3400077311, 'HK', 'HKG', 'هونغ كونغ'),
(84018, 3400077312, 3400079359, 'AU', 'AUS', 'أستراليا'),
(84019, 3400079360, 3400081407, 'MY', 'MYS', 'ماليزيا'),
(84020, 3400081408, 3400089599, 'ID', 'IDN', 'إندونيسيا'),
(84021, 3400089600, 3400097791, 'JP', 'JPN', 'اليابان'),
(84022, 3400097792, 3400105983, 'AU', 'AUS', 'أستراليا'),
(84023, 3400105984, 3400114175, 'JP', 'JPN', 'اليابان'),
(84024, 3400114176, 3400118271, 'TW', 'TWN', 'تايوان'),
(84025, 3400118272, 3400120319, 'AU', 'AUS', 'أستراليا'),
(84026, 3400120320, 3400122367, 'JP', 'JPN', 'اليابان'),
(84027, 3400122368, 3400130559, 'NZ', 'NZL', 'نيوزيلاندا'),
(84028, 3400130560, 3400138751, 'ID', 'IDN', 'إندونيسيا'),
(84029, 3400138752, 3400146943, 'HK', 'HKG', 'هونغ كونغ'),
(84030, 3400146944, 3400151039, 'FJ', 'FJI', 'فيجي'),
(84031, 3400151040, 3400155135, 'MY', 'MYS', 'ماليزيا'),
(84032, 3400155136, 3400163327, 'MN', 'MNG', 'منغوليا'),
(84033, 3400163328, 3400167423, 'JP', 'JPN', 'اليابان'),
(84034, 3400167424, 3400171519, 'TH', 'THA', 'تايلند'),
(84035, 3400171520, 3400179711, 'CN', 'CHN', 'الصين'),
(84036, 3400179712, 3400183807, 'NZ', 'NZL', 'نيوزيلاندا'),
(84037, 3400183808, 3400187903, 'JP', 'JPN', 'اليابان'),
(84038, 3400187904, 3400191999, 'AU', 'AUS', 'أستراليا'),
(84039, 3400192000, 3400194047, 'JP', 'JPN', 'اليابان'),
(84040, 3400194048, 3400196095, 'CN', 'CHN', 'الصين'),
(84041, 3400196096, 3400204287, 'AU', 'AUS', 'أستراليا'),
(84042, 3400204288, 3400212479, 'ID', 'IDN', 'إندونيسيا'),
(84043, 3400212480, 3400220671, 'MY', 'MYS', 'ماليزيا'),
(84044, 3400220672, 3400221055, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(84045, 3400221056, 3400221119, 'NZ', 'NZL', 'نيوزيلاندا'),
(84046, 3400221120, 3400224767, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(84047, 3400224768, 3400228863, 'JP', 'JPN', 'اليابان'),
(84048, 3400228864, 3400232959, 'AU', 'AUS', 'أستراليا'),
(84049, 3400232960, 3400245247, 'JP', 'JPN', 'اليابان'),
(84050, 3400245248, 3400253439, 'AU', 'AUS', 'أستراليا'),
(84051, 3400253440, 3400257535, 'MY', 'MYS', 'ماليزيا'),
(84052, 3400257536, 3400259583, 'HK', 'HKG', 'هونغ كونغ'),
(84053, 3400259584, 3400261631, 'AU', 'AUS', 'أستراليا'),
(84054, 3400261632, 3400263679, 'JP', 'JPN', 'اليابان'),
(84055, 3400263680, 3400263935, 'AU', 'AUS', 'أستراليا'),
(84056, 3400263936, 3400264191, 'ID', 'IDN', 'إندونيسيا'),
(84057, 3400264192, 3400264447, 'IN', 'IND', 'الهند'),
(84058, 3400264448, 3400264703, 'AU', 'AUS', 'أستراليا'),
(84059, 3400264704, 3400265215, 'ID', 'IDN', 'إندونيسيا'),
(84060, 3400265216, 3400265471, 'AU', 'AUS', 'أستراليا'),
(84061, 3400265472, 3400265727, 'IN', 'IND', 'الهند'),
(84062, 3400265728, 3400267775, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(84063, 3400267776, 3400268799, 'KR', 'KOR', 'جمهورية كوريا'),
(84064, 3400268800, 3400270847, 'MO', 'MAC', 'ماكاو'),
(84065, 3400270848, 3400271359, 'VN', 'VNM', 'فييتنام'),
(84066, 3400271360, 3400271615, 'AU', 'AUS', 'أستراليا'),
(84067, 3400271616, 3400271871, 'IN', 'IND', 'الهند'),
(84068, 3400271872, 3400273919, 'AU', 'AUS', 'أستراليا'),
(84069, 3400273920, 3400275967, 'TH', 'THA', 'تايلند'),
(84070, 3400275968, 3400278015, 'JP', 'JPN', 'اليابان'),
(84071, 3400278016, 3400286207, 'SG', 'SGP', 'سنغافورة'),
(84072, 3400286208, 3400294399, 'JP', 'JPN', 'اليابان'),
(84073, 3400294400, 3400310783, 'AU', 'AUS', 'أستراليا'),
(84074, 3400310784, 3400335359, 'SG', 'SGP', 'سنغافورة'),
(84075, 3400335360, 3400336383, 'MO', 'MAC', 'ماكاو'),
(84076, 3400336384, 3400336639, 'PH', 'PHL', 'الفلبين'),
(84077, 3400336640, 3400336895, 'JP', 'JPN', 'اليابان'),
(84078, 3400336896, 3400337151, 'AU', 'AUS', 'أستراليا'),
(84079, 3400337152, 3400337407, 'PH', 'PHL', 'الفلبين'),
(84080, 3400337408, 3400339455, 'CN', 'CHN', 'الصين'),
(84081, 3400339456, 3400341503, 'ID', 'IDN', 'إندونيسيا'),
(84082, 3400341504, 3400343551, 'AU', 'AUS', 'أستراليا'),
(84083, 3400343552, 3400351743, 'TW', 'TWN', 'تايوان'),
(84084, 3400351744, 3400359935, 'ID', 'IDN', 'إندونيسيا'),
(84085, 3400359936, 3400368127, 'JP', 'JPN', 'اليابان'),
(84086, 3400368128, 3400388607, 'AU', 'AUS', 'أستراليا'),
(84087, 3400388608, 3400392703, 'TH', 'THA', 'تايلند'),
(84088, 3400392704, 3400400895, 'CN', 'CHN', 'الصين'),
(84089, 3400400896, 3400401919, 'MO', 'MAC', 'ماكاو'),
(84090, 3400401920, 3400402175, 'TW', 'TWN', 'تايوان'),
(84091, 3400402176, 3400402431, 'IN', 'IND', 'الهند'),
(84092, 3400402432, 3400402943, 'NZ', 'NZL', 'نيوزيلاندا'),
(84093, 3400402944, 3400404991, 'AU', 'AUS', 'أستراليا'),
(84094, 3400404992, 3400409087, 'TW', 'TWN', 'تايوان'),
(84095, 3400409088, 3400413183, 'AU', 'AUS', 'أستراليا'),
(84096, 3400413184, 3400417279, 'JP', 'JPN', 'اليابان'),
(84097, 3400417280, 3400423423, 'AU', 'AUS', 'أستراليا'),
(84098, 3400423424, 3400424447, 'KR', 'KOR', 'جمهورية كوريا'),
(84099, 3400424448, 3400425471, 'IN', 'IND', 'الهند'),
(84100, 3400425472, 3400429567, 'AU', 'AUS', 'أستراليا'),
(84101, 3400429568, 3400431615, 'NZ', 'NZL', 'نيوزيلاندا'),
(84102, 3400431616, 3400431871, 'IN', 'IND', 'الهند'),
(84103, 3400431872, 3400432127, 'HK', 'HKG', 'هونغ كونغ'),
(84104, 3400432128, 3400432639, 'IN', 'IND', 'الهند'),
(84105, 3400432640, 3400433663, 'AU', 'AUS', 'أستراليا'),
(84106, 3400433664, 3400434431, 'HK', 'HKG', 'هونغ كونغ'),
(84107, 3400434432, 3400434463, 'MY', 'MYS', 'ماليزيا'),
(84108, 3400434464, 3400434471, 'HK', 'HKG', 'هونغ كونغ'),
(84109, 3400434472, 3400434479, 'MY', 'MYS', 'ماليزيا'),
(84110, 3400434480, 3400434487, 'HK', 'HKG', 'هونغ كونغ'),
(84111, 3400434488, 3400434519, 'MY', 'MYS', 'ماليزيا'),
(84112, 3400434520, 3400434527, 'MV', 'MDV', 'جزر المالديف'),
(84113, 3400434528, 3400434535, 'HK', 'HKG', 'هونغ كونغ'),
(84114, 3400434536, 3400434543, 'KZ', 'KAZ', 'كازاخستان'),
(84115, 3400434544, 3400434551, 'MY', 'MYS', 'ماليزيا'),
(84116, 3400434552, 3400434559, 'KZ', 'KAZ', 'كازاخستان'),
(84117, 3400434560, 3400434567, 'MV', 'MDV', 'جزر المالديف'),
(84118, 3400434568, 3400434575, 'MY', 'MYS', 'ماليزيا'),
(84119, 3400434576, 3400434583, 'MV', 'MDV', 'جزر المالديف'),
(84120, 3400434584, 3400434599, 'MY', 'MYS', 'ماليزيا'),
(84121, 3400434600, 3400434607, 'HK', 'HKG', 'هونغ كونغ'),
(84122, 3400434608, 3400434647, 'MV', 'MDV', 'جزر المالديف'),
(84123, 3400434648, 3400434655, 'KZ', 'KAZ', 'كازاخستان'),
(84124, 3400434656, 3400434663, 'MV', 'MDV', 'جزر المالديف'),
(84125, 3400434664, 3400434679, 'MY', 'MYS', 'ماليزيا'),
(84126, 3400434680, 3400434687, 'HK', 'HKG', 'هونغ كونغ'),
(84127, 3400434688, 3400434895, 'MY', 'MYS', 'ماليزيا'),
(84128, 3400434896, 3400434911, 'MV', 'MDV', 'جزر المالديف'),
(84129, 3400434912, 3400434927, 'KZ', 'KAZ', 'كازاخستان'),
(84130, 3400434928, 3400434935, 'MV', 'MDV', 'جزر المالديف'),
(84131, 3400434936, 3400434951, 'HK', 'HKG', 'هونغ كونغ'),
(84132, 3400434952, 3400434959, 'AF', 'AFG', 'أفغانستان'),
(84133, 3400434960, 3400434975, 'HK', 'HKG', 'هونغ كونغ'),
(84134, 3400434976, 3400434991, 'AF', 'AFG', 'أفغانستان'),
(84135, 3400434992, 3400435007, 'MA', 'MAR', 'المغرب'),
(84136, 3400435008, 3400435071, 'MY', 'MYS', 'ماليزيا'),
(84137, 3400435072, 3400435087, 'MA', 'MAR', 'المغرب'),
(84138, 3400435088, 3400435095, 'AF', 'AFG', 'أفغانستان'),
(84139, 3400435096, 3400435119, 'MA', 'MAR', 'المغرب'),
(84140, 3400435120, 3400435143, 'HK', 'HKG', 'هونغ كونغ'),
(84141, 3400435144, 3400435151, 'MA', 'MAR', 'المغرب'),
(84142, 3400435152, 3400435159, 'HK', 'HKG', 'هونغ كونغ'),
(84143, 3400435160, 3400435175, 'MA', 'MAR', 'المغرب'),
(84144, 3400435176, 3400435183, 'MY', 'MYS', 'ماليزيا'),
(84145, 3400435184, 3400435199, 'MV', 'MDV', 'جزر المالديف'),
(84146, 3400435200, 3400435207, 'AF', 'AFG', 'أفغانستان'),
(84147, 3400435208, 3400435239, 'HK', 'HKG', 'هونغ كونغ'),
(84148, 3400435240, 3400435263, 'ID', 'IDN', 'إندونيسيا'),
(84149, 3400435264, 3400435391, 'MY', 'MYS', 'ماليزيا'),
(84150, 3400435392, 3400435423, 'HK', 'HKG', 'هونغ كونغ'),
(84151, 3400435424, 3400435439, 'ID', 'IDN', 'إندونيسيا'),
(84152, 3400435440, 3400435455, 'KZ', 'KAZ', 'كازاخستان'),
(84153, 3400435456, 3400435575, 'MY', 'MYS', 'ماليزيا'),
(84154, 3400435576, 3400435639, 'HK', 'HKG', 'هونغ كونغ'),
(84155, 3400435640, 3400435647, 'MY', 'MYS', 'ماليزيا'),
(84156, 3400435648, 3400435663, 'HK', 'HKG', 'هونغ كونغ'),
(84157, 3400435664, 3400435711, 'MY', 'MYS', 'ماليزيا'),
(84158, 3400435712, 3400436479, 'HK', 'HKG', 'هونغ كونغ'),
(84159, 3400436480, 3400436735, 'NP', 'NPL', 'نيبال'),
(84160, 3400436736, 3400437247, 'BD', 'BGD', 'بنغالاديش'),
(84161, 3400437248, 3400437375, 'PK', 'PAK', 'باكستان'),
(84162, 3400437376, 3400437439, 'BD', 'BGD', 'بنغالاديش'),
(84163, 3400437440, 3400437527, 'HK', 'HKG', 'هونغ كونغ'),
(84164, 3400437528, 3400437543, 'MY', 'MYS', 'ماليزيا'),
(84165, 3400437544, 3400437551, 'HK', 'HKG', 'هونغ كونغ'),
(84166, 3400437552, 3400437591, 'MY', 'MYS', 'ماليزيا'),
(84167, 3400437592, 3400437599, 'BD', 'BGD', 'بنغالاديش'),
(84168, 3400437600, 3400437607, 'MN', 'MNG', 'منغوليا'),
(84169, 3400437608, 3400437615, 'MY', 'MYS', 'ماليزيا'),
(84170, 3400437616, 3400437631, 'HK', 'HKG', 'هونغ كونغ'),
(84171, 3400437632, 3400437647, 'MY', 'MYS', 'ماليزيا'),
(84172, 3400437648, 3400437655, 'HK', 'HKG', 'هونغ كونغ'),
(84173, 3400437656, 3400437663, 'MY', 'MYS', 'ماليزيا'),
(84174, 3400437664, 3400437679, 'HK', 'HKG', 'هونغ كونغ'),
(84175, 3400437680, 3400437687, 'MN', 'MNG', 'منغوليا'),
(84176, 3400437688, 3400437703, 'ID', 'IDN', 'إندونيسيا'),
(84177, 3400437704, 3400437711, 'HK', 'HKG', 'هونغ كونغ'),
(84178, 3400437712, 3400437719, 'MY', 'MYS', 'ماليزيا'),
(84179, 3400437720, 3400437735, 'HK', 'HKG', 'هونغ كونغ'),
(84180, 3400437736, 3400437759, 'ID', 'IDN', 'إندونيسيا'),
(84181, 3400437760, 3400437767, 'AF', 'AFG', 'أفغانستان'),
(84182, 3400437768, 3400437775, 'MY', 'MYS', 'ماليزيا'),
(84183, 3400437776, 3400437783, 'HK', 'HKG', 'هونغ كونغ'),
(84184, 3400437784, 3400437791, 'ID', 'IDN', 'إندونيسيا'),
(84185, 3400437792, 3400437807, 'NP', 'NPL', 'نيبال'),
(84186, 3400437808, 3400437815, 'MN', 'MNG', 'منغوليا'),
(84187, 3400437816, 3400437823, 'ID', 'IDN', 'إندونيسيا'),
(84188, 3400437824, 3400437831, 'MY', 'MYS', 'ماليزيا'),
(84189, 3400437832, 3400437847, 'ID', 'IDN', 'إندونيسيا'),
(84190, 3400437848, 3400437887, 'MY', 'MYS', 'ماليزيا'),
(84191, 3400437888, 3400437895, 'HK', 'HKG', 'هونغ كونغ'),
(84192, 3400437896, 3400437903, 'MY', 'MYS', 'ماليزيا'),
(84193, 3400437904, 3400437911, 'ID', 'IDN', 'إندونيسيا'),
(84194, 3400437912, 3400437927, 'MY', 'MYS', 'ماليزيا'),
(84195, 3400437928, 3400437935, 'ID', 'IDN', 'إندونيسيا'),
(84196, 3400437936, 3400437951, 'BD', 'BGD', 'بنغالاديش'),
(84197, 3400437952, 3400437959, 'MN', 'MNG', 'منغوليا'),
(84198, 3400437960, 3400437967, 'ID', 'IDN', 'إندونيسيا'),
(84199, 3400437968, 3400437975, 'MY', 'MYS', 'ماليزيا'),
(84200, 3400437976, 3400437983, 'AF', 'AFG', 'أفغانستان'),
(84201, 3400437984, 3400438191, 'HK', 'HKG', 'هونغ كونغ'),
(84202, 3400438192, 3400438207, 'US', 'USA', 'الولايات المتحدة'),
(84203, 3400438208, 3400438399, 'HK', 'HKG', 'هونغ كونغ'),
(84204, 3400438400, 3400438591, 'BD', 'BGD', 'بنغالاديش'),
(84205, 3400438592, 3400438783, 'HK', 'HKG', 'هونغ كونغ'),
(84206, 3400438784, 3400438815, 'KZ', 'KAZ', 'كازاخستان'),
(84207, 3400438816, 3400438831, 'PK', 'PAK', 'باكستان'),
(84208, 3400438832, 3400438839, 'AF', 'AFG', 'أفغانستان'),
(84209, 3400438840, 3400438847, 'ID', 'IDN', 'إندونيسيا'),
(84210, 3400438848, 3400438863, 'BD', 'BGD', 'بنغالاديش'),
(84211, 3400438864, 3400438871, 'HK', 'HKG', 'هونغ كونغ'),
(84212, 3400438872, 3400438879, 'ID', 'IDN', 'إندونيسيا'),
(84213, 3400438880, 3400438911, 'NP', 'NPL', 'نيبال'),
(84214, 3400438912, 3400438919, 'AF', 'AFG', 'أفغانستان'),
(84215, 3400438920, 3400438927, 'IN', 'IND', 'الهند'),
(84216, 3400438928, 3400438943, 'BD', 'BGD', 'بنغالاديش'),
(84217, 3400438944, 3400438959, 'HK', 'HKG', 'هونغ كونغ'),
(84218, 3400438960, 3400438991, 'ID', 'IDN', 'إندونيسيا'),
(84219, 3400438992, 3400438999, 'HK', 'HKG', 'هونغ كونغ'),
(84220, 3400439000, 3400439007, 'PK', 'PAK', 'باكستان'),
(84221, 3400439008, 3400439023, 'BD', 'BGD', 'بنغالاديش'),
(84222, 3400439024, 3400439039, 'ID', 'IDN', 'إندونيسيا'),
(84223, 3400439040, 3400439295, 'HK', 'HKG', 'هونغ كونغ'),
(84224, 3400439296, 3400439551, 'PK', 'PAK', 'باكستان'),
(84225, 3400439552, 3400439615, 'BD', 'BGD', 'بنغالاديش'),
(84226, 3400439616, 3400439679, 'HK', 'HKG', 'هونغ كونغ'),
(84227, 3400439680, 3400439711, 'BD', 'BGD', 'بنغالاديش'),
(84228, 3400439712, 3400439743, 'KZ', 'KAZ', 'كازاخستان'),
(84229, 3400439744, 3400439807, 'BD', 'BGD', 'بنغالاديش'),
(84230, 3400439808, 3400439871, 'HK', 'HKG', 'هونغ كونغ'),
(84231, 3400439872, 3400439935, 'NP', 'NPL', 'نيبال'),
(84232, 3400439936, 3400440063, 'HK', 'HKG', 'هونغ كونغ'),
(84233, 3400440064, 3400440079, 'NP', 'NPL', 'نيبال'),
(84234, 3400440080, 3400440087, 'MN', 'MNG', 'منغوليا'),
(84235, 3400440088, 3400440095, 'MY', 'MYS', 'ماليزيا'),
(84236, 3400440096, 3400440111, 'MN', 'MNG', 'منغوليا'),
(84237, 3400440112, 3400440127, 'MY', 'MYS', 'ماليزيا'),
(84238, 3400440128, 3400440135, 'MN', 'MNG', 'منغوليا'),
(84239, 3400440136, 3400440143, 'HK', 'HKG', 'هونغ كونغ'),
(84240, 3400440144, 3400440159, 'MY', 'MYS', 'ماليزيا'),
(84241, 3400440160, 3400440167, 'BD', 'BGD', 'بنغالاديش'),
(84242, 3400440168, 3400440175, 'MY', 'MYS', 'ماليزيا'),
(84243, 3400440176, 3400440191, 'BD', 'BGD', 'بنغالاديش'),
(84244, 3400440192, 3400440199, 'KZ', 'KAZ', 'كازاخستان'),
(84245, 3400440200, 3400440207, 'MN', 'MNG', 'منغوليا'),
(84246, 3400440208, 3400440223, 'MY', 'MYS', 'ماليزيا'),
(84247, 3400440224, 3400440239, 'BD', 'BGD', 'بنغالاديش'),
(84248, 3400440240, 3400440247, 'ID', 'IDN', 'إندونيسيا'),
(84249, 3400440248, 3400440255, 'AF', 'AFG', 'أفغانستان'),
(84250, 3400440256, 3400440263, 'ID', 'IDN', 'إندونيسيا'),
(84251, 3400440264, 3400440271, 'MN', 'MNG', 'منغوليا'),
(84252, 3400440272, 3400440295, 'ID', 'IDN', 'إندونيسيا'),
(84253, 3400440296, 3400440303, 'BD', 'BGD', 'بنغالاديش'),
(84254, 3400440304, 3400440319, 'MY', 'MYS', 'ماليزيا'),
(84255, 3400440320, 3400440327, 'AF', 'AFG', 'أفغانستان'),
(84256, 3400440328, 3400440335, 'ID', 'IDN', 'إندونيسيا'),
(84257, 3400440336, 3400440343, 'NP', 'NPL', 'نيبال'),
(84258, 3400440344, 3400440351, 'AF', 'AFG', 'أفغانستان'),
(84259, 3400440352, 3400440359, 'HK', 'HKG', 'هونغ كونغ'),
(84260, 3400440360, 3400440367, 'ID', 'IDN', 'إندونيسيا'),
(84261, 3400440368, 3400440375, 'HK', 'HKG', 'هونغ كونغ'),
(84262, 3400440376, 3400440383, 'ID', 'IDN', 'إندونيسيا'),
(84263, 3400440384, 3400440391, 'MN', 'MNG', 'منغوليا'),
(84264, 3400440392, 3400440415, 'ID', 'IDN', 'إندونيسيا'),
(84265, 3400440416, 3400440431, 'AF', 'AFG', 'أفغانستان'),
(84266, 3400440432, 3400440439, 'MY', 'MYS', 'ماليزيا'),
(84267, 3400440440, 3400440447, 'HK', 'HKG', 'هونغ كونغ'),
(84268, 3400440448, 3400440455, 'AF', 'AFG', 'أفغانستان'),
(84269, 3400440456, 3400440463, 'BD', 'BGD', 'بنغالاديش'),
(84270, 3400440464, 3400440467, 'ID', 'IDN', 'إندونيسيا'),
(84271, 3400440468, 3400440475, 'HK', 'HKG', 'هونغ كونغ'),
(84272, 3400440476, 3400440479, 'NP', 'NPL', 'نيبال'),
(84273, 3400440480, 3400440487, 'AF', 'AFG', 'أفغانستان'),
(84274, 3400440488, 3400440495, 'MY', 'MYS', 'ماليزيا'),
(84275, 3400440496, 3400440499, 'LK', 'LKA', 'سيريلانكا'),
(84276, 3400440500, 3400440507, 'AF', 'AFG', 'أفغانستان'),
(84277, 3400440508, 3400440519, 'HK', 'HKG', 'هونغ كونغ'),
(84278, 3400440520, 3400440531, 'ID', 'IDN', 'إندونيسيا'),
(84279, 3400440532, 3400440535, 'AF', 'AFG', 'أفغانستان'),
(84280, 3400440536, 3400440539, 'ID', 'IDN', 'إندونيسيا'),
(84281, 3400440540, 3400440543, 'HK', 'HKG', 'هونغ كونغ'),
(84282, 3400440544, 3400440551, 'MN', 'MNG', 'منغوليا'),
(84283, 3400440552, 3400440575, 'NP', 'NPL', 'نيبال'),
(84284, 3400440576, 3400440583, 'ID', 'IDN', 'إندونيسيا'),
(84285, 3400440584, 3400440591, 'HK', 'HKG', 'هونغ كونغ'),
(84286, 3400440592, 3400440607, 'PK', 'PAK', 'باكستان'),
(84287, 3400440608, 3400440623, 'HK', 'HKG', 'هونغ كونغ'),
(84288, 3400440624, 3400440639, 'ID', 'IDN', 'إندونيسيا'),
(84289, 3400440640, 3400440703, 'HK', 'HKG', 'هونغ كونغ'),
(84290, 3400440704, 3400440711, 'AF', 'AFG', 'أفغانستان'),
(84291, 3400440712, 3400440719, 'ID', 'IDN', 'إندونيسيا'),
(84292, 3400440720, 3400440727, 'AF', 'AFG', 'أفغانستان'),
(84293, 3400440728, 3400440735, 'KZ', 'KAZ', 'كازاخستان'),
(84294, 3400440736, 3400440743, 'BD', 'BGD', 'بنغالاديش'),
(84295, 3400440744, 3400440750, 'ID', 'IDN', 'إندونيسيا'),
(84296, 3400440751, 3400440751, 'HK', 'HKG', 'هونغ كونغ'),
(84297, 3400440752, 3400440759, 'ID', 'IDN', 'إندونيسيا'),
(84298, 3400440760, 3400440767, 'MY', 'MYS', 'ماليزيا'),
(84299, 3400440768, 3400440775, 'ID', 'IDN', 'إندونيسيا'),
(84300, 3400440776, 3400440783, 'HK', 'HKG', 'هونغ كونغ'),
(84301, 3400440784, 3400440791, 'MN', 'MNG', 'منغوليا'),
(84302, 3400440792, 3400440799, 'AF', 'AFG', 'أفغانستان'),
(84303, 3400440800, 3400440807, 'BD', 'BGD', 'بنغالاديش'),
(84304, 3400440808, 3400440815, 'MY', 'MYS', 'ماليزيا'),
(84305, 3400440816, 3400440823, 'AF', 'AFG', 'أفغانستان'),
(84306, 3400440824, 3400440831, 'MY', 'MYS', 'ماليزيا'),
(84307, 3400440832, 3400440895, 'BD', 'BGD', 'بنغالاديش'),
(84308, 3400440896, 3400441023, 'HK', 'HKG', 'هونغ كونغ'),
(84309, 3400441024, 3400441047, 'AF', 'AFG', 'أفغانستان'),
(84310, 3400441048, 3400441055, 'BD', 'BGD', 'بنغالاديش'),
(84311, 3400441056, 3400441063, 'PK', 'PAK', 'باكستان'),
(84312, 3400441064, 3400441071, 'HK', 'HKG', 'هونغ كونغ'),
(84313, 3400441072, 3400441079, 'ID', 'IDN', 'إندونيسيا'),
(84314, 3400441080, 3400441087, 'AF', 'AFG', 'أفغانستان'),
(84315, 3400441088, 3400441151, 'PK', 'PAK', 'باكستان'),
(84316, 3400441152, 3400441215, 'BD', 'BGD', 'بنغالاديش'),
(84317, 3400441216, 3400441279, 'HK', 'HKG', 'هونغ كونغ'),
(84318, 3400441280, 3400441311, 'AF', 'AFG', 'أفغانستان'),
(84319, 3400441312, 3400441319, 'LK', 'LKA', 'سيريلانكا'),
(84320, 3400441320, 3400441327, 'AF', 'AFG', 'أفغانستان'),
(84321, 3400441328, 3400441335, 'LK', 'LKA', 'سيريلانكا'),
(84322, 3400441336, 3400441855, 'HK', 'HKG', 'هونغ كونغ'),
(84323, 3400441856, 3400450047, 'NZ', 'NZL', 'نيوزيلاندا'),
(84324, 3400450048, 3400458239, 'JP', 'JPN', 'اليابان'),
(84325, 3400458240, 3400466431, 'AU', 'AUS', 'أستراليا'),
(84326, 3400466432, 3400499199, 'MO', 'MAC', 'ماكاو'),
(84327, 3400499200, 3400503295, 'NZ', 'NZL', 'نيوزيلاندا'),
(84328, 3400503296, 3400507391, 'JP', 'JPN', 'اليابان'),
(84329, 3400507392, 3400515583, 'MO', 'MAC', 'ماكاو'),
(84330, 3400515584, 3400531967, 'PH', 'PHL', 'الفلبين'),
(84331, 3400531968, 3400534015, 'AU', 'AUS', 'أستراليا'),
(84332, 3400534016, 3400535039, 'JP', 'JPN', 'اليابان'),
(84333, 3400535040, 3400535551, 'MY', 'MYS', 'ماليزيا'),
(84334, 3400535552, 3400536063, 'AU', 'AUS', 'أستراليا'),
(84335, 3400536064, 3400548351, 'JP', 'JPN', 'اليابان'),
(84336, 3400548352, 3400581119, 'TH', 'THA', 'تايلند'),
(84337, 3400581120, 3400589311, 'SG', 'SGP', 'سنغافورة'),
(84338, 3400589312, 3400597503, 'AU', 'AUS', 'أستراليا'),
(84339, 3400597504, 3400605695, 'HK', 'HKG', 'هونغ كونغ'),
(84340, 3400605696, 3400607743, 'JP', 'JPN', 'اليابان'),
(84341, 3400607744, 3400608767, 'AU', 'AUS', 'أستراليا'),
(84342, 3400608768, 3400609791, 'IN', 'IND', 'الهند'),
(84343, 3400609792, 3400630271, 'JP', 'JPN', 'اليابان'),
(84344, 3400630272, 3400646655, 'IN', 'IND', 'الهند'),
(84345, 3400646656, 3400647043, 'SG', 'SGP', 'سنغافورة'),
(84346, 3400647044, 3400647047, 'JP', 'JPN', 'اليابان'),
(84347, 3400647048, 3400647623, 'SG', 'SGP', 'سنغافورة'),
(84348, 3400647624, 3400647631, 'JP', 'JPN', 'اليابان'),
(84349, 3400647632, 3400648735, 'SG', 'SGP', 'سنغافورة'),
(84350, 3400648736, 3400648743, 'DE', 'DEU', 'ألمانيا'),
(84351, 3400648744, 3400648767, 'SG', 'SGP', 'سنغافورة'),
(84352, 3400648768, 3400648807, 'US', 'USA', 'الولايات المتحدة'),
(84353, 3400648808, 3400649191, 'SG', 'SGP', 'سنغافورة'),
(84354, 3400649192, 3400649199, 'HK', 'HKG', 'هونغ كونغ'),
(84355, 3400649200, 3400649519, 'SG', 'SGP', 'سنغافورة'),
(84356, 3400649520, 3400649527, 'JP', 'JPN', 'اليابان'),
(84357, 3400649528, 3400649983, 'SG', 'SGP', 'سنغافورة'),
(84358, 3400649984, 3400650047, 'HK', 'HKG', 'هونغ كونغ'),
(84359, 3400650048, 3400650215, 'SG', 'SGP', 'سنغافورة'),
(84360, 3400650216, 3400650223, 'US', 'USA', 'الولايات المتحدة'),
(84361, 3400650224, 3400650751, 'SG', 'SGP', 'سنغافورة'),
(84362, 3400650752, 3400651007, 'JP', 'JPN', 'اليابان'),
(84363, 3400651008, 3400654847, 'SG', 'SGP', 'سنغافورة'),
(84364, 3400654848, 3400663039, 'IN', 'IND', 'الهند'),
(84365, 3400663040, 3400683519, 'MY', 'MYS', 'ماليزيا'),
(84366, 3400683520, 3400691711, 'JP', 'JPN', 'اليابان'),
(84367, 3400691712, 3400695807, 'KH', 'KHM', 'كامبوديا'),
(84368, 3400695808, 3400728575, 'TW', 'TWN', 'تايوان'),
(84369, 3400728576, 3400736767, 'MN', 'MNG', 'منغوليا'),
(84370, 3400736768, 3400744959, 'JP', 'JPN', 'اليابان'),
(84371, 3400744960, 3400753151, 'IN', 'IND', 'الهند'),
(84372, 3400753152, 3400761343, 'MY', 'MYS', 'ماليزيا'),
(84373, 3400761344, 3400769535, 'AU', 'AUS', 'أستراليا'),
(84374, 3400769536, 3400773631, 'JP', 'JPN', 'اليابان'),
(84375, 3400773632, 3400775679, 'KR', 'KOR', 'جمهورية كوريا'),
(84376, 3400775680, 3400777727, 'ID', 'IDN', 'إندونيسيا'),
(84377, 3400777728, 3400790015, 'JP', 'JPN', 'اليابان'),
(84378, 3400790016, 3400794111, 'CN', 'CHN', 'الصين'),
(84379, 3400794112, 3400802303, 'ID', 'IDN', 'إندونيسيا'),
(84380, 3400802304, 3400806399, 'JP', 'JPN', 'اليابان'),
(84381, 3400806400, 3400808447, 'ID', 'IDN', 'إندونيسيا'),
(84382, 3400808448, 3400810495, 'JP', 'JPN', 'اليابان'),
(84383, 3400810496, 3400826879, 'NZ', 'NZL', 'نيوزيلاندا'),
(84384, 3400826880, 3400835071, 'CN', 'CHN', 'الصين'),
(84385, 3400835072, 3400839167, 'HK', 'HKG', 'هونغ كونغ'),
(84386, 3400839168, 3400847359, 'JP', 'JPN', 'اليابان'),
(84387, 3400847360, 3400849407, 'AU', 'AUS', 'أستراليا'),
(84388, 3400849408, 3400851455, 'MN', 'MNG', 'منغوليا'),
(84389, 3400851456, 3400884223, 'AU', 'AUS', 'أستراليا'),
(84390, 3400884224, 3400888319, 'JP', 'JPN', 'اليابان'),
(84391, 3400888320, 3400892415, 'CN', 'CHN', 'الصين'),
(84392, 3400892416, 3400925183, 'HK', 'HKG', 'هونغ كونغ'),
(84393, 3400925184, 3400933375, 'TH', 'THA', 'تايلند'),
(84394, 3400933376, 3400937471, 'AU', 'AUS', 'أستراليا'),
(84395, 3400937472, 3400941567, 'ID', 'IDN', 'إندونيسيا'),
(84396, 3400941568, 3400966143, 'AU', 'AUS', 'أستراليا'),
(84397, 3400966144, 3400974335, 'ID', 'IDN', 'إندونيسيا'),
(84398, 3400974336, 3400982527, 'AU', 'AUS', 'أستراليا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(84399, 3400982528, 3400990719, 'HK', 'HKG', 'هونغ كونغ'),
(84400, 3400990720, 3400998911, 'ID', 'IDN', 'إندونيسيا'),
(84401, 3400998912, 3401003007, 'PH', 'PHL', 'الفلبين'),
(84402, 3401003008, 3401007103, 'JP', 'JPN', 'اليابان'),
(84403, 3401007104, 3401011199, 'IN', 'IND', 'الهند'),
(84404, 3401011200, 3401015295, 'JP', 'JPN', 'اليابان'),
(84405, 3401015296, 3401023487, 'AU', 'AUS', 'أستراليا'),
(84406, 3401023488, 3401056255, 'TH', 'THA', 'تايلند'),
(84407, 3401056256, 3401383935, 'MY', 'MYS', 'ماليزيا'),
(84408, 3401383936, 3401404415, 'AU', 'AUS', 'أستراليا'),
(84409, 3401404416, 3401408511, 'CN', 'CHN', 'الصين'),
(84410, 3401408512, 3401416703, 'HK', 'HKG', 'هونغ كونغ'),
(84411, 3401416704, 3401420799, 'KR', 'KOR', 'جمهورية كوريا'),
(84412, 3401420800, 3401424895, 'JP', 'JPN', 'اليابان'),
(84413, 3401424896, 3401428991, 'NZ', 'NZL', 'نيوزيلاندا'),
(84414, 3401428992, 3401431039, 'JP', 'JPN', 'اليابان'),
(84415, 3401431040, 3401433087, 'AU', 'AUS', 'أستراليا'),
(84416, 3401433088, 3401441279, 'JP', 'JPN', 'اليابان'),
(84417, 3401441280, 3401449471, 'IN', 'IND', 'الهند'),
(84418, 3401449472, 3401515007, 'MY', 'MYS', 'ماليزيا'),
(84419, 3401515008, 3401515263, 'DE', 'DEU', 'ألمانيا'),
(84420, 3401515264, 3401515519, 'AU', 'AUS', 'أستراليا'),
(84421, 3401515520, 3401516031, 'ID', 'IDN', 'إندونيسيا'),
(84422, 3401516032, 3401519103, 'AU', 'AUS', 'أستراليا'),
(84423, 3401519104, 3401523199, 'JP', 'JPN', 'اليابان'),
(84424, 3401523200, 3401527295, 'NZ', 'NZL', 'نيوزيلاندا'),
(84425, 3401527296, 3401529343, 'AU', 'AUS', 'أستراليا'),
(84426, 3401529344, 3401530367, 'VN', 'VNM', 'فييتنام'),
(84427, 3401530368, 3401531391, 'AU', 'AUS', 'أستراليا'),
(84428, 3401531392, 3401532415, 'IN', 'IND', 'الهند'),
(84429, 3401532416, 3401543679, 'AU', 'AUS', 'أستراليا'),
(84430, 3401543680, 3401545727, 'JP', 'JPN', 'اليابان'),
(84431, 3401545728, 3401547775, 'BD', 'BGD', 'بنغالاديش'),
(84432, 3401547776, 3401580543, 'MY', 'MYS', 'ماليزيا'),
(84433, 3401580544, 3401642495, 'CN', 'CHN', 'الصين'),
(84434, 3401642496, 3401642751, 'TW', 'TWN', 'تايوان'),
(84435, 3401642752, 3402629119, 'CN', 'CHN', 'الصين'),
(84436, 3402629120, 3404857954, 'JP', 'JPN', 'اليابان'),
(84437, 3404857955, 3404857955, 'ID', 'IDN', 'إندونيسيا'),
(84438, 3404857956, 3404857966, 'JP', 'JPN', 'اليابان'),
(84439, 3404857967, 3404857967, 'IN', 'IND', 'الهند'),
(84440, 3404857968, 3405774847, 'JP', 'JPN', 'اليابان'),
(84441, 3405774848, 3406071807, 'AU', 'AUS', 'أستراليا'),
(84442, 3406071808, 3406073855, 'US', 'USA', 'الولايات المتحدة'),
(84443, 3406073856, 3406077951, 'AU', 'AUS', 'أستراليا'),
(84444, 3406077952, 3406078207, 'TH', 'THA', 'تايلند'),
(84445, 3406078208, 3406327039, 'AU', 'AUS', 'أستراليا'),
(84446, 3406327040, 3406327295, 'IN', 'IND', 'الهند'),
(84447, 3406327296, 3406384639, 'AU', 'AUS', 'أستراليا'),
(84448, 3406384640, 3406385151, 'SG', 'SGP', 'سنغافورة'),
(84449, 3406385152, 3406409727, 'AU', 'AUS', 'أستراليا'),
(84450, 3406409728, 3406411775, 'NZ', 'NZL', 'نيوزيلاندا'),
(84451, 3406411776, 3406434303, 'AU', 'AUS', 'أستراليا'),
(84452, 3406434304, 3406436351, 'MY', 'MYS', 'ماليزيا'),
(84453, 3406436352, 3406542847, 'AU', 'AUS', 'أستراليا'),
(84454, 3406542848, 3406543103, 'SG', 'SGP', 'سنغافورة'),
(84455, 3406543104, 3406565887, 'AU', 'AUS', 'أستراليا'),
(84456, 3406565888, 3406566143, 'PH', 'PHL', 'الفلبين'),
(84457, 3406566144, 3406591487, 'AU', 'AUS', 'أستراليا'),
(84458, 3406591488, 3406591743, 'NP', 'NPL', 'نيبال'),
(84459, 3406591744, 3406617599, 'AU', 'AUS', 'أستراليا'),
(84460, 3406617600, 3406617855, 'MY', 'MYS', 'ماليزيا'),
(84461, 3406617856, 3406618111, 'AU', 'AUS', 'أستراليا'),
(84462, 3406618112, 3406618623, 'IN', 'IND', 'الهند'),
(84463, 3406618624, 3406625023, 'AU', 'AUS', 'أستراليا'),
(84464, 3406625024, 3406625279, 'NF', 'NFK', 'جزيرة نورفولك'),
(84465, 3406625280, 3406663935, 'AU', 'AUS', 'أستراليا'),
(84466, 3406663936, 3406664191, 'CN', 'CHN', 'الصين'),
(84467, 3406664192, 3406664447, 'IN', 'IND', 'الهند'),
(84468, 3406664448, 3406669823, 'AU', 'AUS', 'أستراليا'),
(84469, 3406669824, 3406670847, 'IN', 'IND', 'الهند'),
(84470, 3406670848, 3406696959, 'AU', 'AUS', 'أستراليا'),
(84471, 3406696960, 3406697215, 'IN', 'IND', 'الهند'),
(84472, 3406697216, 3406737407, 'AU', 'AUS', 'أستراليا'),
(84473, 3406737408, 3406737663, 'ID', 'IDN', 'إندونيسيا'),
(84474, 3406737664, 3406739199, 'AU', 'AUS', 'أستراليا'),
(84475, 3406739200, 3406739455, 'ID', 'IDN', 'إندونيسيا'),
(84476, 3406739456, 3406746623, 'AU', 'AUS', 'أستراليا'),
(84477, 3406746624, 3406746879, 'HK', 'HKG', 'هونغ كونغ'),
(84478, 3406746880, 3406865663, 'AU', 'AUS', 'أستراليا'),
(84479, 3406865664, 3406865919, 'IN', 'IND', 'الهند'),
(84480, 3406865920, 3406946815, 'AU', 'AUS', 'أستراليا'),
(84481, 3406946816, 3406947071, 'KR', 'KOR', 'جمهورية كوريا'),
(84482, 3406947072, 3406950399, 'AU', 'AUS', 'أستراليا'),
(84483, 3406950400, 3406951423, 'NF', 'NFK', 'جزيرة نورفولك'),
(84484, 3406951424, 3406961151, 'AU', 'AUS', 'أستراليا'),
(84485, 3406961152, 3406961407, 'IN', 'IND', 'الهند'),
(84486, 3406961408, 3406967295, 'AU', 'AUS', 'أستراليا'),
(84487, 3406967296, 3406967551, 'CN', 'CHN', 'الصين'),
(84488, 3406967552, 3406989567, 'AU', 'AUS', 'أستراليا'),
(84489, 3406989568, 3406989823, 'IN', 'IND', 'الهند'),
(84490, 3406989824, 3407020287, 'AU', 'AUS', 'أستراليا'),
(84491, 3407020288, 3407020543, 'SG', 'SGP', 'سنغافورة'),
(84492, 3407020544, 3407020799, 'AU', 'AUS', 'أستراليا'),
(84493, 3407020800, 3407021055, 'IN', 'IND', 'الهند'),
(84494, 3407021056, 3407021311, 'ID', 'IDN', 'إندونيسيا'),
(84495, 3407021312, 3407045887, 'AU', 'AUS', 'أستراليا'),
(84496, 3407045888, 3407046143, 'HK', 'HKG', 'هونغ كونغ'),
(84497, 3407046144, 3407057663, 'AU', 'AUS', 'أستراليا'),
(84498, 3407057664, 3407057919, 'JP', 'JPN', 'اليابان'),
(84499, 3407057920, 3407096831, 'AU', 'AUS', 'أستراليا'),
(84500, 3407096832, 3407097087, 'JP', 'JPN', 'اليابان'),
(84501, 3407097088, 3407112447, 'AU', 'AUS', 'أستراليا'),
(84502, 3407112448, 3407112703, 'SG', 'SGP', 'سنغافورة'),
(84503, 3407112704, 3407152895, 'AU', 'AUS', 'أستراليا'),
(84504, 3407152896, 3407153151, 'IN', 'IND', 'الهند'),
(84505, 3407153152, 3407157559, 'AU', 'AUS', 'أستراليا'),
(84506, 3407157560, 3407157563, 'NZ', 'NZL', 'نيوزيلاندا'),
(84507, 3407157564, 3407157579, 'AU', 'AUS', 'أستراليا'),
(84508, 3407157580, 3407157583, 'NZ', 'NZL', 'نيوزيلاندا'),
(84509, 3407157584, 3407157611, 'AU', 'AUS', 'أستراليا'),
(84510, 3407157612, 3407157615, 'NZ', 'NZL', 'نيوزيلاندا'),
(84511, 3407157616, 3407157643, 'AU', 'AUS', 'أستراليا'),
(84512, 3407157644, 3407157647, 'NZ', 'NZL', 'نيوزيلاندا'),
(84513, 3407157648, 3407157703, 'AU', 'AUS', 'أستراليا'),
(84514, 3407157704, 3407157711, 'NZ', 'NZL', 'نيوزيلاندا'),
(84515, 3407157712, 3407158015, 'AU', 'AUS', 'أستراليا'),
(84516, 3407158016, 3407158047, 'NZ', 'NZL', 'نيوزيلاندا'),
(84517, 3407158048, 3407158051, 'AU', 'AUS', 'أستراليا'),
(84518, 3407158052, 3407158055, 'NZ', 'NZL', 'نيوزيلاندا'),
(84519, 3407158056, 3407158167, 'AU', 'AUS', 'أستراليا'),
(84520, 3407158168, 3407158175, 'NZ', 'NZL', 'نيوزيلاندا'),
(84521, 3407158176, 3407158207, 'AU', 'AUS', 'أستراليا'),
(84522, 3407158208, 3407158223, 'NZ', 'NZL', 'نيوزيلاندا'),
(84523, 3407158224, 3407158239, 'AU', 'AUS', 'أستراليا'),
(84524, 3407158240, 3407158271, 'NZ', 'NZL', 'نيوزيلاندا'),
(84525, 3407158272, 3407159115, 'AU', 'AUS', 'أستراليا'),
(84526, 3407159116, 3407159135, 'NZ', 'NZL', 'نيوزيلاندا'),
(84527, 3407159136, 3407159191, 'AU', 'AUS', 'أستراليا'),
(84528, 3407159192, 3407159195, 'NZ', 'NZL', 'نيوزيلاندا'),
(84529, 3407159196, 3407159207, 'AU', 'AUS', 'أستراليا'),
(84530, 3407159208, 3407159215, 'NZ', 'NZL', 'نيوزيلاندا'),
(84531, 3407159216, 3407159231, 'AU', 'AUS', 'أستراليا'),
(84532, 3407159232, 3407159239, 'NZ', 'NZL', 'نيوزيلاندا'),
(84533, 3407159240, 3407159263, 'AU', 'AUS', 'أستراليا'),
(84534, 3407159264, 3407159295, 'NZ', 'NZL', 'نيوزيلاندا'),
(84535, 3407159296, 3407243263, 'AU', 'AUS', 'أستراليا'),
(84536, 3407243264, 3407243775, 'HK', 'HKG', 'هونغ كونغ'),
(84537, 3407243776, 3407268863, 'AU', 'AUS', 'أستراليا'),
(84538, 3407268864, 3407269119, 'US', 'USA', 'الولايات المتحدة'),
(84539, 3407269120, 3407329791, 'AU', 'AUS', 'أستراليا'),
(84540, 3407329792, 3407330047, 'IN', 'IND', 'الهند'),
(84541, 3407330048, 3407367167, 'AU', 'AUS', 'أستراليا'),
(84542, 3407367168, 3407367679, 'ID', 'IDN', 'إندونيسيا'),
(84543, 3407367680, 3407369983, 'AU', 'AUS', 'أستراليا'),
(84544, 3407369984, 3407370239, 'IN', 'IND', 'الهند'),
(84545, 3407370240, 3407498495, 'AU', 'AUS', 'أستراليا'),
(84546, 3407498496, 3407498751, 'PK', 'PAK', 'باكستان'),
(84547, 3407498752, 3407524607, 'AU', 'AUS', 'أستراليا'),
(84548, 3407524608, 3407524863, 'NZ', 'NZL', 'نيوزيلاندا'),
(84549, 3407524864, 3407602943, 'AU', 'AUS', 'أستراليا'),
(84550, 3407602944, 3407603199, 'JP', 'JPN', 'اليابان'),
(84551, 3407603200, 3407604479, 'AU', 'AUS', 'أستراليا'),
(84552, 3407604480, 3407604735, 'IN', 'IND', 'الهند'),
(84553, 3407604736, 3407608715, 'AU', 'AUS', 'أستراليا'),
(84554, 3407608716, 3407608736, 'JP', 'JPN', 'اليابان'),
(84555, 3407608737, 3407682047, 'AU', 'AUS', 'أستراليا'),
(84556, 3407682048, 3407682559, 'ID', 'IDN', 'إندونيسيا'),
(84557, 3407682560, 3407732223, 'AU', 'AUS', 'أستراليا'),
(84558, 3407732224, 3407732479, 'HK', 'HKG', 'هونغ كونغ'),
(84559, 3407732480, 3407750655, 'AU', 'AUS', 'أستراليا'),
(84560, 3407750656, 3407751167, 'SG', 'SGP', 'سنغافورة'),
(84561, 3407751168, 3407753215, 'AU', 'AUS', 'أستراليا'),
(84562, 3407753216, 3407753727, 'HK', 'HKG', 'هونغ كونغ'),
(84563, 3407753728, 3407785471, 'AU', 'AUS', 'أستراليا'),
(84564, 3407785472, 3407785727, 'NZ', 'NZL', 'نيوزيلاندا'),
(84565, 3407785728, 3407801343, 'AU', 'AUS', 'أستراليا'),
(84566, 3407801344, 3407801855, 'ID', 'IDN', 'إندونيسيا'),
(84567, 3407801856, 3407805951, 'AU', 'AUS', 'أستراليا'),
(84568, 3407805952, 3407806463, 'ID', 'IDN', 'إندونيسيا'),
(84569, 3407806464, 3407814655, 'AU', 'AUS', 'أستراليا'),
(84570, 3407814656, 3407815167, 'HK', 'HKG', 'هونغ كونغ'),
(84571, 3407815168, 3407828991, 'AU', 'AUS', 'أستراليا'),
(84572, 3407828992, 3407829503, 'US', 'USA', 'الولايات المتحدة'),
(84573, 3407829504, 3407837183, 'AU', 'AUS', 'أستراليا'),
(84574, 3407837184, 3407837439, 'US', 'USA', 'الولايات المتحدة'),
(84575, 3407837440, 3407848447, 'AU', 'AUS', 'أستراليا'),
(84576, 3407848448, 3407848959, 'ID', 'IDN', 'إندونيسيا'),
(84577, 3407848960, 3407866367, 'AU', 'AUS', 'أستراليا'),
(84578, 3407866368, 3407866623, 'GB', 'GBR', 'المملكة المتحدة'),
(84579, 3407866624, 3407873023, 'AU', 'AUS', 'أستراليا'),
(84580, 3407873024, 3407873535, 'IN', 'IND', 'الهند'),
(84581, 3407873536, 3407928575, 'AU', 'AUS', 'أستراليا'),
(84582, 3407928576, 3407928831, 'IN', 'IND', 'الهند'),
(84583, 3407928832, 3407985919, 'AU', 'AUS', 'أستراليا'),
(84584, 3407985920, 3407986175, 'KH', 'KHM', 'كامبوديا'),
(84585, 3407986176, 3407987711, 'AU', 'AUS', 'أستراليا'),
(84586, 3407987712, 3407987967, 'PH', 'PHL', 'الفلبين'),
(84587, 3407987968, 3407988223, 'AU', 'AUS', 'أستراليا'),
(84588, 3407988224, 3407988735, 'IN', 'IND', 'الهند'),
(84589, 3407988736, 3407998975, 'AU', 'AUS', 'أستراليا'),
(84590, 3407998976, 3407999231, 'TH', 'THA', 'تايلند'),
(84591, 3407999232, 3408012543, 'AU', 'AUS', 'أستراليا'),
(84592, 3408012544, 3408012799, 'MN', 'MNG', 'منغوليا'),
(84593, 3408012800, 3408023807, 'AU', 'AUS', 'أستراليا'),
(84594, 3408023808, 3408024063, 'JP', 'JPN', 'اليابان'),
(84595, 3408024064, 3408032767, 'AU', 'AUS', 'أستراليا'),
(84596, 3408032768, 3408033279, 'IN', 'IND', 'الهند'),
(84597, 3408033280, 3408033791, 'ID', 'IDN', 'إندونيسيا'),
(84598, 3408033792, 3408039935, 'AU', 'AUS', 'أستراليا'),
(84599, 3408039936, 3408040191, 'VN', 'VNM', 'فييتنام'),
(84600, 3408040192, 3408042495, 'AU', 'AUS', 'أستراليا'),
(84601, 3408042496, 3408042751, 'HK', 'HKG', 'هونغ كونغ'),
(84602, 3408042752, 3408066047, 'AU', 'AUS', 'أستراليا'),
(84603, 3408066048, 3408066303, 'PH', 'PHL', 'الفلبين'),
(84604, 3408066304, 3409396479, 'AU', 'AUS', 'أستراليا'),
(84605, 3409396480, 3409396735, 'PH', 'PHL', 'الفلبين'),
(84606, 3409396736, 3409418495, 'AU', 'AUS', 'أستراليا'),
(84607, 3409418496, 3409418751, 'PL', 'POL', 'بولندا'),
(84608, 3409418752, 3409420287, 'AU', 'AUS', 'أستراليا'),
(84609, 3409420288, 3409420543, 'IN', 'IND', 'الهند'),
(84610, 3409420544, 3409423615, 'AU', 'AUS', 'أستراليا'),
(84611, 3409423616, 3409423871, 'IN', 'IND', 'الهند'),
(84612, 3409423872, 3409491711, 'AU', 'AUS', 'أستراليا'),
(84613, 3409491712, 3409491967, 'SG', 'SGP', 'سنغافورة'),
(84614, 3409491968, 3409503999, 'AU', 'AUS', 'أستراليا'),
(84615, 3409504000, 3409504255, 'HK', 'HKG', 'هونغ كونغ'),
(84616, 3409504256, 3409505023, 'AU', 'AUS', 'أستراليا'),
(84617, 3409505024, 3409505279, 'US', 'USA', 'الولايات المتحدة'),
(84618, 3409505280, 3409506559, 'AU', 'AUS', 'أستراليا'),
(84619, 3409506560, 3409506815, 'IN', 'IND', 'الهند'),
(84620, 3409506816, 3409509631, 'AU', 'AUS', 'أستراليا'),
(84621, 3409509632, 3409509887, 'HK', 'HKG', 'هونغ كونغ'),
(84622, 3409509888, 3409510367, 'AU', 'AUS', 'أستراليا'),
(84623, 3409510368, 3409510383, 'IN', 'IND', 'الهند'),
(84624, 3409510384, 3409516543, 'AU', 'AUS', 'أستراليا'),
(84625, 3409516544, 3409517055, 'ID', 'IDN', 'إندونيسيا'),
(84626, 3409517056, 3409547519, 'AU', 'AUS', 'أستراليا'),
(84627, 3409547520, 3409547775, 'NZ', 'NZL', 'نيوزيلاندا'),
(84628, 3409547776, 3409802831, 'AU', 'AUS', 'أستراليا'),
(84629, 3409802832, 3409802847, 'MT', 'MLT', 'مالطا'),
(84630, 3409802848, 3409838335, 'AU', 'AUS', 'أستراليا'),
(84631, 3409838336, 3409838591, 'MY', 'MYS', 'ماليزيا'),
(84632, 3409838592, 3409876991, 'AU', 'AUS', 'أستراليا'),
(84633, 3409876992, 3409878015, 'TH', 'THA', 'تايلند'),
(84634, 3409878016, 3409882111, 'AU', 'AUS', 'أستراليا'),
(84635, 3409882112, 3409883135, 'IN', 'IND', 'الهند'),
(84636, 3409883136, 3409887999, 'AU', 'AUS', 'أستراليا'),
(84637, 3409888000, 3409888255, 'SG', 'SGP', 'سنغافورة'),
(84638, 3409888256, 3409969151, 'AU', 'AUS', 'أستراليا'),
(84639, 3409969152, 3410755583, 'TW', 'TWN', 'تايوان'),
(84640, 3410755584, 3410771967, 'AU', 'AUS', 'أستراليا'),
(84641, 3410771968, 3410780159, 'JP', 'JPN', 'اليابان'),
(84642, 3410780160, 3410788351, 'BD', 'BGD', 'بنغالاديش'),
(84643, 3410788352, 3410792447, 'IN', 'IND', 'الهند'),
(84644, 3410792448, 3410796543, 'BD', 'BGD', 'بنغالاديش'),
(84645, 3410796544, 3410797567, 'KH', 'KHM', 'كامبوديا'),
(84646, 3410797568, 3410798591, 'JP', 'JPN', 'اليابان'),
(84647, 3410798592, 3410799615, 'IN', 'IND', 'الهند'),
(84648, 3410799616, 3410800639, 'SG', 'SGP', 'سنغافورة'),
(84649, 3410800640, 3410804735, 'IN', 'IND', 'الهند'),
(84650, 3410804736, 3410821119, 'PH', 'PHL', 'الفلبين'),
(84651, 3410821120, 3410853887, 'TW', 'TWN', 'تايوان'),
(84652, 3410853888, 3410862079, 'HK', 'HKG', 'هونغ كونغ'),
(84653, 3410862080, 3410866175, 'AU', 'AUS', 'أستراليا'),
(84654, 3410866176, 3410866431, 'KR', 'KOR', 'جمهورية كوريا'),
(84655, 3410866432, 3410866687, 'IN', 'IND', 'الهند'),
(84656, 3410866688, 3410866943, 'VN', 'VNM', 'فييتنام'),
(84657, 3410866944, 3410867199, 'AU', 'AUS', 'أستراليا'),
(84658, 3410867200, 3410868223, 'HK', 'HKG', 'هونغ كونغ'),
(84659, 3410868224, 3410870271, 'US', 'USA', 'الولايات المتحدة'),
(84660, 3410870272, 3410874367, 'IN', 'IND', 'الهند'),
(84661, 3410874368, 3410886655, 'ID', 'IDN', 'إندونيسيا'),
(84662, 3410886656, 3410887679, 'TW', 'TWN', 'تايوان'),
(84663, 3410887680, 3410887935, 'IN', 'IND', 'الهند'),
(84664, 3410887936, 3410888703, 'HK', 'HKG', 'هونغ كونغ'),
(84665, 3410888704, 3410890751, 'SG', 'SGP', 'سنغافورة'),
(84666, 3410890752, 3410894847, 'AU', 'AUS', 'أستراليا'),
(84667, 3410894848, 3410898943, 'HK', 'HKG', 'هونغ كونغ'),
(84668, 3410898944, 3410903039, 'AU', 'AUS', 'أستراليا'),
(84669, 3410903040, 3410911231, 'HK', 'HKG', 'هونغ كونغ'),
(84670, 3410911232, 3410915327, 'TH', 'THA', 'تايلند'),
(84671, 3410915328, 3410919423, 'ID', 'IDN', 'إندونيسيا'),
(84672, 3410919424, 3410927615, 'IN', 'IND', 'الهند'),
(84673, 3410927616, 3410931711, 'NP', 'NPL', 'نيبال'),
(84674, 3410931712, 3410935807, 'TW', 'TWN', 'تايوان'),
(84675, 3410935808, 3410939903, 'MY', 'MYS', 'ماليزيا'),
(84676, 3410939904, 3410943999, 'IN', 'IND', 'الهند'),
(84677, 3410944000, 3410952191, 'JP', 'JPN', 'اليابان'),
(84678, 3410952192, 3410956287, 'CN', 'CHN', 'الصين'),
(84679, 3410956288, 3410958335, 'AU', 'AUS', 'أستراليا'),
(84680, 3410958336, 3410958847, 'IN', 'IND', 'الهند'),
(84681, 3410958848, 3410959359, 'ID', 'IDN', 'إندونيسيا'),
(84682, 3410959360, 3410959615, 'VN', 'VNM', 'فييتنام'),
(84683, 3410959616, 3410959871, 'ID', 'IDN', 'إندونيسيا'),
(84684, 3410959872, 3410960383, 'AU', 'AUS', 'أستراليا'),
(84685, 3410960384, 3410964479, 'GB', 'GBR', 'المملكة المتحدة'),
(84686, 3410964480, 3410968575, 'JP', 'JPN', 'اليابان'),
(84687, 3410968576, 3410984959, 'NZ', 'NZL', 'نيوزيلاندا'),
(84688, 3410984960, 3411017727, 'TW', 'TWN', 'تايوان'),
(84689, 3411017728, 3411018751, 'HK', 'HKG', 'هونغ كونغ'),
(84690, 3411018752, 3411019263, 'AU', 'AUS', 'أستراليا'),
(84691, 3411019264, 3411019775, 'JP', 'JPN', 'اليابان'),
(84692, 3411019776, 3411021823, 'ID', 'IDN', 'إندونيسيا'),
(84693, 3411021824, 3411023871, 'MY', 'MYS', 'ماليزيا'),
(84694, 3411023872, 3411025919, 'JP', 'JPN', 'اليابان'),
(84695, 3411025920, 3411030015, 'AU', 'AUS', 'أستراليا'),
(84696, 3411030016, 3411032063, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(84697, 3411032064, 3411032319, 'TH', 'THA', 'تايلند'),
(84698, 3411032320, 3411033087, 'AU', 'AUS', 'أستراليا'),
(84699, 3411033088, 3411034111, 'NZ', 'NZL', 'نيوزيلاندا'),
(84700, 3411034112, 3411050495, 'HK', 'HKG', 'هونغ كونغ'),
(84701, 3411050496, 3411051519, 'PK', 'PAK', 'باكستان'),
(84702, 3411051520, 3411054591, 'AU', 'AUS', 'أستراليا'),
(84703, 3411054592, 3411058687, 'CN', 'CHN', 'الصين'),
(84704, 3411058688, 3411062783, 'AU', 'AUS', 'أستراليا'),
(84705, 3411062784, 3411063231, 'HK', 'HKG', 'هونغ كونغ'),
(84706, 3411063232, 3411063295, 'PK', 'PAK', 'باكستان'),
(84707, 3411063296, 3411083263, 'HK', 'HKG', 'هونغ كونغ'),
(84708, 3411083264, 3411085311, 'AU', 'AUS', 'أستراليا'),
(84709, 3411085312, 3411086335, 'KR', 'KOR', 'جمهورية كوريا'),
(84710, 3411086336, 3411087359, 'JP', 'JPN', 'اليابان'),
(84711, 3411087360, 3411091455, 'CN', 'CHN', 'الصين'),
(84712, 3411091456, 3411099647, 'SG', 'SGP', 'سنغافورة'),
(84713, 3411099648, 3411107839, 'MM', 'MMR', 'ميانمار'),
(84714, 3411107840, 3411111935, 'LK', 'LKA', 'سيريلانكا'),
(84715, 3411111936, 3411116031, 'JP', 'JPN', 'اليابان'),
(84716, 3411116032, 3411124223, 'KR', 'KOR', 'جمهورية كوريا'),
(84717, 3411124224, 3411128319, 'MM', 'MMR', 'ميانمار'),
(84718, 3411128320, 3411130367, 'HK', 'HKG', 'هونغ كونغ'),
(84719, 3411130368, 3411132415, 'ID', 'IDN', 'إندونيسيا'),
(84720, 3411132416, 3411144703, 'PK', 'PAK', 'باكستان'),
(84721, 3411144704, 3411146751, 'JP', 'JPN', 'اليابان'),
(84722, 3411146752, 3411147775, 'ID', 'IDN', 'إندونيسيا'),
(84723, 3411147776, 3411149311, 'HK', 'HKG', 'هونغ كونغ'),
(84724, 3411149312, 3411149823, 'MV', 'MDV', 'جزر المالديف'),
(84725, 3411149824, 3411150847, 'IN', 'IND', 'الهند'),
(84726, 3411150848, 3411152895, 'HK', 'HKG', 'هونغ كونغ'),
(84727, 3411152896, 3411154943, 'AU', 'AUS', 'أستراليا'),
(84728, 3411154944, 3411156991, 'JP', 'JPN', 'اليابان'),
(84729, 3411156992, 3411161087, 'PH', 'PHL', 'الفلبين'),
(84730, 3411161088, 3411165183, 'PK', 'PAK', 'باكستان'),
(84731, 3411165184, 3411173375, 'MY', 'MYS', 'ماليزيا'),
(84732, 3411173376, 3411177471, 'AU', 'AUS', 'أستراليا'),
(84733, 3411177472, 3411189759, 'JP', 'JPN', 'اليابان'),
(84734, 3411189760, 3411197951, 'AU', 'AUS', 'أستراليا'),
(84735, 3411197952, 3411202047, 'BD', 'BGD', 'بنغالاديش'),
(84736, 3411202048, 3411204607, 'AU', 'AUS', 'أستراليا'),
(84737, 3411204608, 3411204863, 'IN', 'IND', 'الهند'),
(84738, 3411204864, 3411205631, 'KR', 'KOR', 'جمهورية كوريا'),
(84739, 3411205632, 3411206143, 'HK', 'HKG', 'هونغ كونغ'),
(84740, 3411206144, 3411210239, 'KH', 'KHM', 'كامبوديا'),
(84741, 3411210240, 3411212287, 'KR', 'KOR', 'جمهورية كوريا'),
(84742, 3411212288, 3411212799, 'PH', 'PHL', 'الفلبين'),
(84743, 3411212800, 3411213311, 'IN', 'IND', 'الهند'),
(84744, 3411213312, 3411215359, 'HK', 'HKG', 'هونغ كونغ'),
(84745, 3411215360, 3411216383, 'AU', 'AUS', 'أستراليا'),
(84746, 3411216384, 3411218431, 'JP', 'JPN', 'اليابان'),
(84747, 3411218432, 3411220479, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(84748, 3411220480, 3411226623, 'ID', 'IDN', 'إندونيسيا'),
(84749, 3411226624, 3411228671, 'IO', 'IOT', 'إقليم المحيط الهندي البريطاني'),
(84750, 3411228672, 3411230719, 'CN', 'CHN', 'الصين'),
(84751, 3411230720, 3411247103, 'HK', 'HKG', 'هونغ كونغ'),
(84752, 3411247104, 3411255295, 'KR', 'KOR', 'جمهورية كوريا'),
(84753, 3411255296, 3411263487, 'BD', 'BGD', 'بنغالاديش'),
(84754, 3411263488, 3411269631, 'AU', 'AUS', 'أستراليا'),
(84755, 3411269632, 3411270143, 'TW', 'TWN', 'تايوان'),
(84756, 3411270144, 3411270399, 'NZ', 'NZL', 'نيوزيلاندا'),
(84757, 3411270400, 3411270655, 'AU', 'AUS', 'أستراليا'),
(84758, 3411270656, 3411271679, 'JP', 'JPN', 'اليابان'),
(84759, 3411271680, 3411275775, 'AU', 'AUS', 'أستراليا'),
(84760, 3411275776, 3411277823, 'JP', 'JPN', 'اليابان'),
(84761, 3411277824, 3411278335, 'IN', 'IND', 'الهند'),
(84762, 3411278336, 3411278591, 'SG', 'SGP', 'سنغافورة'),
(84763, 3411278592, 3411278847, 'FJ', 'FJI', 'فيجي'),
(84764, 3411278848, 3411296255, 'HK', 'HKG', 'هونغ كونغ'),
(84765, 3411296256, 3411312639, 'AU', 'AUS', 'أستراليا'),
(84766, 3411312640, 3411313151, 'HK', 'HKG', 'هونغ كونغ'),
(84767, 3411313152, 3411313663, 'TW', 'TWN', 'تايوان'),
(84768, 3411313664, 3411313919, 'AU', 'AUS', 'أستراليا'),
(84769, 3411313920, 3411314175, 'HK', 'HKG', 'هونغ كونغ'),
(84770, 3411314176, 3411314687, 'NZ', 'NZL', 'نيوزيلاندا'),
(84771, 3411314688, 3411316735, 'ID', 'IDN', 'إندونيسيا'),
(84772, 3411316736, 3411318783, 'TW', 'TWN', 'تايوان'),
(84773, 3411318784, 3411320831, 'ID', 'IDN', 'إندونيسيا'),
(84774, 3411320832, 3411329023, 'PH', 'PHL', 'الفلبين'),
(84775, 3411329024, 3411341311, 'AU', 'AUS', 'أستراليا'),
(84776, 3411341312, 3411345407, 'KR', 'KOR', 'جمهورية كوريا'),
(84777, 3411345408, 3411410943, 'HK', 'HKG', 'هونغ كونغ'),
(84778, 3411410944, 3411435519, 'CN', 'CHN', 'الصين'),
(84779, 3411435520, 3411443711, 'AU', 'AUS', 'أستراليا'),
(84780, 3411443712, 3411460095, 'HK', 'HKG', 'هونغ كونغ'),
(84781, 3411460096, 3411464191, 'NZ', 'NZL', 'نيوزيلاندا'),
(84782, 3411464192, 3411468287, 'AU', 'AUS', 'أستراليا'),
(84783, 3411468288, 3411470335, 'JP', 'JPN', 'اليابان'),
(84784, 3411470336, 3411472383, 'HK', 'HKG', 'هونغ كونغ'),
(84785, 3411472384, 3411475199, 'JP', 'JPN', 'اليابان'),
(84786, 3411475200, 3411475455, 'AU', 'AUS', 'أستراليا'),
(84787, 3411475456, 3411475967, 'HK', 'HKG', 'هونغ كونغ'),
(84788, 3411475968, 3411509247, 'AU', 'AUS', 'أستراليا'),
(84789, 3411509248, 3411542015, 'PH', 'PHL', 'الفلبين'),
(84790, 3411542016, 3411550207, 'IN', 'IND', 'الهند'),
(84791, 3411550208, 3411558399, 'CN', 'CHN', 'الصين'),
(84792, 3411558400, 3411558911, 'HK', 'HKG', 'هونغ كونغ'),
(84793, 3411558912, 3411558927, 'ID', 'IDN', 'إندونيسيا'),
(84794, 3411558928, 3411558943, 'HK', 'HKG', 'هونغ كونغ'),
(84795, 3411558944, 3411558959, 'ID', 'IDN', 'إندونيسيا'),
(84796, 3411558960, 3411558975, 'HK', 'HKG', 'هونغ كونغ'),
(84797, 3411558976, 3411558983, 'AF', 'AFG', 'أفغانستان'),
(84798, 3411558984, 3411559007, 'HK', 'HKG', 'هونغ كونغ'),
(84799, 3411559008, 3411559015, 'MY', 'MYS', 'ماليزيا'),
(84800, 3411559016, 3411559023, 'HK', 'HKG', 'هونغ كونغ'),
(84801, 3411559024, 3411559031, 'ID', 'IDN', 'إندونيسيا'),
(84802, 3411559032, 3411559035, 'NP', 'NPL', 'نيبال'),
(84803, 3411559036, 3411559039, 'PK', 'PAK', 'باكستان'),
(84804, 3411559040, 3411559063, 'ID', 'IDN', 'إندونيسيا'),
(84805, 3411559064, 3411559071, 'MY', 'MYS', 'ماليزيا'),
(84806, 3411559072, 3411559079, 'AF', 'AFG', 'أفغانستان'),
(84807, 3411559080, 3411559087, 'MY', 'MYS', 'ماليزيا'),
(84808, 3411559088, 3411559095, 'ID', 'IDN', 'إندونيسيا'),
(84809, 3411559096, 3411559103, 'PK', 'PAK', 'باكستان'),
(84810, 3411559104, 3411559111, 'MY', 'MYS', 'ماليزيا'),
(84811, 3411559112, 3411559135, 'PK', 'PAK', 'باكستان'),
(84812, 3411559136, 3411559143, 'HK', 'HKG', 'هونغ كونغ'),
(84813, 3411559144, 3411559167, 'MY', 'MYS', 'ماليزيا'),
(84814, 3411559168, 3411559199, 'BD', 'BGD', 'بنغالاديش'),
(84815, 3411559200, 3411559231, 'HK', 'HKG', 'هونغ كونغ'),
(84816, 3411559232, 3411559295, 'BD', 'BGD', 'بنغالاديش'),
(84817, 3411559296, 3411559303, 'ID', 'IDN', 'إندونيسيا'),
(84818, 3411559304, 3411559311, 'HK', 'HKG', 'هونغ كونغ'),
(84819, 3411559312, 3411559327, 'NP', 'NPL', 'نيبال'),
(84820, 3411559328, 3411559343, 'HK', 'HKG', 'هونغ كونغ'),
(84821, 3411559344, 3411559359, 'ID', 'IDN', 'إندونيسيا'),
(84822, 3411559360, 3411559423, 'BD', 'BGD', 'بنغالاديش'),
(84823, 3411559424, 3411559455, 'HK', 'HKG', 'هونغ كونغ'),
(84824, 3411559456, 3411559487, 'BD', 'BGD', 'بنغالاديش'),
(84825, 3411559488, 3411559551, 'HK', 'HKG', 'هونغ كونغ'),
(84826, 3411559552, 3411559559, 'BD', 'BGD', 'بنغالاديش'),
(84827, 3411559560, 3411559567, 'HK', 'HKG', 'هونغ كونغ'),
(84828, 3411559568, 3411559679, 'BD', 'BGD', 'بنغالاديش'),
(84829, 3411559680, 3411559935, 'ID', 'IDN', 'إندونيسيا'),
(84830, 3411559936, 3411560031, 'BD', 'BGD', 'بنغالاديش'),
(84831, 3411560032, 3411560063, 'HK', 'HKG', 'هونغ كونغ'),
(84832, 3411560064, 3411560319, 'BD', 'BGD', 'بنغالاديش'),
(84833, 3411560320, 3411560447, 'HK', 'HKG', 'هونغ كونغ'),
(84834, 3411560448, 3411560703, 'NP', 'NPL', 'نيبال'),
(84835, 3411560704, 3411561983, 'BD', 'BGD', 'بنغالاديش'),
(84836, 3411561984, 3411562047, 'HK', 'HKG', 'هونغ كونغ'),
(84837, 3411562048, 3411562111, 'PK', 'PAK', 'باكستان'),
(84838, 3411562112, 3411562495, 'HK', 'HKG', 'هونغ كونغ'),
(84839, 3411562496, 3411563015, 'MY', 'MYS', 'ماليزيا'),
(84840, 3411563016, 3411563023, 'TH', 'THA', 'تايلند'),
(84841, 3411563024, 3411563047, 'ID', 'IDN', 'إندونيسيا'),
(84842, 3411563048, 3411563055, 'LK', 'LKA', 'سيريلانكا'),
(84843, 3411563056, 3411563135, 'ID', 'IDN', 'إندونيسيا'),
(84844, 3411563136, 3411563143, 'TH', 'THA', 'تايلند'),
(84845, 3411563144, 3411563183, 'ID', 'IDN', 'إندونيسيا'),
(84846, 3411563184, 3411563191, 'HK', 'HKG', 'هونغ كونغ'),
(84847, 3411563192, 3411563247, 'ID', 'IDN', 'إندونيسيا'),
(84848, 3411563248, 3411563255, 'AF', 'AFG', 'أفغانستان'),
(84849, 3411563256, 3411563263, 'ID', 'IDN', 'إندونيسيا'),
(84850, 3411563264, 3411563519, 'MY', 'MYS', 'ماليزيا'),
(84851, 3411563520, 3411563775, 'BD', 'BGD', 'بنغالاديش'),
(84852, 3411563776, 3411564031, 'HK', 'HKG', 'هونغ كونغ'),
(84853, 3411564032, 3411564039, 'ID', 'IDN', 'إندونيسيا'),
(84854, 3411564040, 3411564047, 'HK', 'HKG', 'هونغ كونغ'),
(84855, 3411564048, 3411564063, 'ID', 'IDN', 'إندونيسيا'),
(84856, 3411564064, 3411564175, 'HK', 'HKG', 'هونغ كونغ'),
(84857, 3411564176, 3411564183, 'ID', 'IDN', 'إندونيسيا'),
(84858, 3411564184, 3411564199, 'HK', 'HKG', 'هونغ كونغ'),
(84859, 3411564200, 3411564207, 'ID', 'IDN', 'إندونيسيا'),
(84860, 3411564208, 3411564223, 'HK', 'HKG', 'هونغ كونغ'),
(84861, 3411564224, 3411564231, 'ID', 'IDN', 'إندونيسيا'),
(84862, 3411564232, 3411564247, 'HK', 'HKG', 'هونغ كونغ'),
(84863, 3411564248, 3411564255, 'ID', 'IDN', 'إندونيسيا'),
(84864, 3411564256, 3411564287, 'HK', 'HKG', 'هونغ كونغ'),
(84865, 3411564288, 3411564543, 'BD', 'BGD', 'بنغالاديش'),
(84866, 3411564544, 3411564551, 'ID', 'IDN', 'إندونيسيا'),
(84867, 3411564552, 3411564559, 'HK', 'HKG', 'هونغ كونغ'),
(84868, 3411564560, 3411564567, 'ID', 'IDN', 'إندونيسيا'),
(84869, 3411564568, 3411564571, 'HK', 'HKG', 'هونغ كونغ'),
(84870, 3411564572, 3411564611, 'AF', 'AFG', 'أفغانستان'),
(84871, 3411564612, 3411564615, 'HK', 'HKG', 'هونغ كونغ'),
(84872, 3411564616, 3411564623, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(84873, 3411564624, 3411564631, 'HK', 'HKG', 'هونغ كونغ'),
(84874, 3411564632, 3411564663, 'MY', 'MYS', 'ماليزيا'),
(84875, 3411564664, 3411564671, 'US', 'USA', 'الولايات المتحدة'),
(84876, 3411564672, 3411564679, 'ID', 'IDN', 'إندونيسيا'),
(84877, 3411564680, 3411564687, 'AF', 'AFG', 'أفغانستان'),
(84878, 3411564688, 3411564743, 'HK', 'HKG', 'هونغ كونغ'),
(84879, 3411564744, 3411564751, 'MY', 'MYS', 'ماليزيا'),
(84880, 3411564752, 3411565055, 'HK', 'HKG', 'هونغ كونغ'),
(84881, 3411565056, 3411565119, 'BD', 'BGD', 'بنغالاديش'),
(84882, 3411565120, 3411565151, 'HK', 'HKG', 'هونغ كونغ'),
(84883, 3411565152, 3411565183, 'BD', 'BGD', 'بنغالاديش'),
(84884, 3411565184, 3411565311, 'IQ', 'IRQ', 'العراق'),
(84885, 3411565312, 3411565567, 'HK', 'HKG', 'هونغ كونغ'),
(84886, 3411565568, 3411565823, 'AF', 'AFG', 'أفغانستان'),
(84887, 3411565824, 3411566591, 'HK', 'HKG', 'هونغ كونغ'),
(84888, 3411566592, 3411570687, 'BD', 'BGD', 'بنغالاديش'),
(84889, 3411570688, 3411574783, 'AU', 'AUS', 'أستراليا'),
(84890, 3411574784, 3411582975, 'IN', 'IND', 'الهند'),
(84891, 3411582976, 3411587071, 'HK', 'HKG', 'هونغ كونغ'),
(84892, 3411587072, 3411591167, 'JP', 'JPN', 'اليابان'),
(84893, 3411591168, 3411599359, 'CN', 'CHN', 'الصين'),
(84894, 3411599360, 3411607551, 'AU', 'AUS', 'أستراليا'),
(84895, 3411607552, 3411608575, 'CN', 'CHN', 'الصين'),
(84896, 3411608576, 3411608831, 'IN', 'IND', 'الهند'),
(84897, 3411608832, 3411609087, 'AU', 'AUS', 'أستراليا'),
(84898, 3411609088, 3411609599, 'HK', 'HKG', 'هونغ كونغ'),
(84899, 3411609600, 3411611647, 'AU', 'AUS', 'أستراليا'),
(84900, 3411611648, 3411615743, 'ID', 'IDN', 'إندونيسيا'),
(84901, 3411615744, 3411623935, 'JP', 'JPN', 'اليابان'),
(84902, 3411623936, 3411640319, 'AU', 'AUS', 'أستراليا'),
(84903, 3411640320, 3411641343, 'JP', 'JPN', 'اليابان'),
(84904, 3411641344, 3411641599, 'IN', 'IND', 'الهند'),
(84905, 3411641600, 3411641855, 'HK', 'HKG', 'هونغ كونغ'),
(84906, 3411641856, 3411642367, 'IN', 'IND', 'الهند'),
(84907, 3411642368, 3411643391, 'AU', 'AUS', 'أستراليا'),
(84908, 3411643392, 3411644415, 'VN', 'VNM', 'فييتنام'),
(84909, 3411644416, 3411644927, 'AU', 'AUS', 'أستراليا'),
(84910, 3411644928, 3411645951, 'ID', 'IDN', 'إندونيسيا'),
(84911, 3411645952, 3411646207, 'SG', 'SGP', 'سنغافورة'),
(84912, 3411646208, 3411647487, 'IN', 'IND', 'الهند'),
(84913, 3411647488, 3411648511, 'HK', 'HKG', 'هونغ كونغ'),
(84914, 3411648512, 3411656703, 'NZ', 'NZL', 'نيوزيلاندا'),
(84915, 3411656704, 3411673087, 'AU', 'AUS', 'أستراليا'),
(84916, 3411673088, 3411674111, 'CN', 'CHN', 'الصين'),
(84917, 3411674112, 3411674623, 'IN', 'IND', 'الهند'),
(84918, 3411674624, 3411675135, 'HK', 'HKG', 'هونغ كونغ'),
(84919, 3411675136, 3411676159, 'AU', 'AUS', 'أستراليا'),
(84920, 3411676160, 3411677183, 'PK', 'PAK', 'باكستان'),
(84921, 3411677184, 3411679231, 'JP', 'JPN', 'اليابان'),
(84922, 3411679232, 3411681279, 'AU', 'AUS', 'أستراليا'),
(84923, 3411681280, 3411689471, 'KR', 'KOR', 'جمهورية كوريا'),
(84924, 3411689472, 3411705855, 'IN', 'IND', 'الهند'),
(84925, 3411705856, 3411730431, 'CN', 'CHN', 'الصين'),
(84926, 3411730432, 3411738623, 'HK', 'HKG', 'هونغ كونغ'),
(84927, 3411738624, 3411746815, 'TW', 'TWN', 'تايوان'),
(84928, 3411746816, 3411755007, 'CN', 'CHN', 'الصين'),
(84929, 3411755008, 3411763199, 'AU', 'AUS', 'أستراليا'),
(84930, 3411763200, 3411767295, 'CN', 'CHN', 'الصين'),
(84931, 3411767296, 3411769343, 'MN', 'MNG', 'منغوليا'),
(84932, 3411769344, 3411771391, 'CN', 'CHN', 'الصين'),
(84933, 3411771392, 3411773439, 'HK', 'HKG', 'هونغ كونغ'),
(84934, 3411773440, 3411773695, 'SC', 'SYC', 'سيشيل'),
(84935, 3411773696, 3411773951, 'HK', 'HKG', 'هونغ كونغ'),
(84936, 3411773952, 3411774463, 'BD', 'BGD', 'بنغالاديش'),
(84937, 3411774464, 3411776511, 'HK', 'HKG', 'هونغ كونغ'),
(84938, 3411776512, 3411776767, 'SC', 'SYC', 'سيشيل'),
(84939, 3411776768, 3411777663, 'HK', 'HKG', 'هونغ كونغ'),
(84940, 3411777664, 3411777791, 'BD', 'BGD', 'بنغالاديش'),
(84941, 3411777792, 3411779519, 'HK', 'HKG', 'هونغ كونغ'),
(84942, 3411779520, 3411779535, 'ID', 'IDN', 'إندونيسيا'),
(84943, 3411779536, 3411779583, 'HK', 'HKG', 'هونغ كونغ'),
(84944, 3411779584, 3411787775, 'JP', 'JPN', 'اليابان'),
(84945, 3411787776, 3411795967, 'IN', 'IND', 'الهند'),
(84946, 3411795968, 3411804159, 'AU', 'AUS', 'أستراليا'),
(84947, 3411804160, 3411805183, 'CN', 'CHN', 'الصين'),
(84948, 3411805184, 3411805695, 'PK', 'PAK', 'باكستان'),
(84949, 3411805696, 3411805951, 'JP', 'JPN', 'اليابان'),
(84950, 3411805952, 3411806207, 'AU', 'AUS', 'أستراليا'),
(84951, 3411806208, 3411808255, 'PH', 'PHL', 'الفلبين'),
(84952, 3411808256, 3411810303, 'JP', 'JPN', 'اليابان'),
(84953, 3411810304, 3411810559, 'MN', 'MNG', 'منغوليا'),
(84954, 3411810560, 3411810815, 'NZ', 'NZL', 'نيوزيلاندا'),
(84955, 3411810816, 3411812351, 'AU', 'AUS', 'أستراليا'),
(84956, 3411812352, 3411820543, 'IN', 'IND', 'الهند'),
(84957, 3411820544, 3411836927, 'SG', 'SGP', 'سنغافورة'),
(84958, 3411836928, 3411845119, 'MY', 'MYS', 'ماليزيا'),
(84959, 3411845120, 3411853311, 'CN', 'CHN', 'الصين'),
(84960, 3411853312, 3411857407, 'IN', 'IND', 'الهند'),
(84961, 3411857408, 3411857663, 'TW', 'TWN', 'تايوان'),
(84962, 3411857664, 3411857919, 'JP', 'JPN', 'اليابان'),
(84963, 3411857920, 3411858175, 'SG', 'SGP', 'سنغافورة'),
(84964, 3411858176, 3411858431, 'HK', 'HKG', 'هونغ كونغ'),
(84965, 3411858432, 3411858687, 'JP', 'JPN', 'اليابان'),
(84966, 3411858688, 3411858943, 'NZ', 'NZL', 'نيوزيلاندا'),
(84967, 3411858944, 3411859199, 'JP', 'JPN', 'اليابان'),
(84968, 3411859200, 3411859455, 'SG', 'SGP', 'سنغافورة'),
(84969, 3411859456, 3411860991, 'HK', 'HKG', 'هونغ كونغ'),
(84970, 3411860992, 3411861375, 'JP', 'JPN', 'اليابان'),
(84971, 3411861376, 3411861487, 'HK', 'HKG', 'هونغ كونغ'),
(84972, 3411861488, 3411861503, 'JP', 'JPN', 'اليابان'),
(84973, 3411861504, 3411869695, 'AU', 'AUS', 'أستراليا'),
(84974, 3411869696, 3411943423, 'CN', 'CHN', 'الصين'),
(84975, 3411943424, 3411951615, 'AU', 'AUS', 'أستراليا'),
(84976, 3411951616, 3411967999, 'LK', 'LKA', 'سيريلانكا'),
(84977, 3411968000, 3411984383, 'AU', 'AUS', 'أستراليا'),
(84978, 3411984384, 3412000767, 'IN', 'IND', 'الهند'),
(84979, 3412000768, 3412002815, 'CN', 'CHN', 'الصين'),
(84980, 3412002816, 3412004863, 'GU', 'GUM', 'غوام'),
(84981, 3412004864, 3412017151, 'JP', 'JPN', 'اليابان'),
(84982, 3412017152, 3412025343, 'SG', 'SGP', 'سنغافورة'),
(84983, 3412025344, 3412033535, 'CN', 'CHN', 'الصين'),
(84984, 3412033536, 3412049919, 'AU', 'AUS', 'أستراليا'),
(84985, 3412049920, 3412058111, 'TW', 'TWN', 'تايوان'),
(84986, 3412058112, 3412066303, 'AU', 'AUS', 'أستراليا'),
(84987, 3412066304, 3412107263, 'NZ', 'NZL', 'نيوزيلاندا'),
(84988, 3412107264, 3412115455, 'AU', 'AUS', 'أستراليا'),
(84989, 3412115456, 3412123647, 'NZ', 'NZL', 'نيوزيلاندا'),
(84990, 3412123648, 3412131839, 'AU', 'AUS', 'أستراليا'),
(84991, 3412131840, 3412213759, 'NZ', 'NZL', 'نيوزيلاندا'),
(84992, 3412213760, 3412221951, 'AU', 'AUS', 'أستراليا'),
(84993, 3412221952, 3412230143, 'IN', 'IND', 'الهند'),
(84994, 3412230144, 3412246527, 'HK', 'HKG', 'هونغ كونغ'),
(84995, 3412246528, 3412246783, 'AU', 'AUS', 'أستراليا'),
(84996, 3412246784, 3412246799, 'HK', 'HKG', 'هونغ كونغ'),
(84997, 3412246800, 3412246847, 'AU', 'AUS', 'أستراليا'),
(84998, 3412246848, 3412246911, 'IN', 'IND', 'الهند'),
(84999, 3412246912, 3412246927, 'SG', 'SGP', 'سنغافورة'),
(85000, 3412246928, 3412246951, 'AU', 'AUS', 'أستراليا'),
(85001, 3412246952, 3412246959, 'CN', 'CHN', 'الصين'),
(85002, 3412246960, 3412246967, 'JP', 'JPN', 'اليابان'),
(85003, 3412246968, 3412246975, 'AU', 'AUS', 'أستراليا'),
(85004, 3412246976, 3412247007, 'JP', 'JPN', 'اليابان'),
(85005, 3412247008, 3412247023, 'IN', 'IND', 'الهند'),
(85006, 3412247024, 3412247031, 'CN', 'CHN', 'الصين'),
(85007, 3412247032, 3412247039, 'NZ', 'NZL', 'نيوزيلاندا'),
(85008, 3412247040, 3412247055, 'HK', 'HKG', 'هونغ كونغ'),
(85009, 3412247056, 3412247071, 'CN', 'CHN', 'الصين'),
(85010, 3412247072, 3412247103, 'JP', 'JPN', 'اليابان'),
(85011, 3412247104, 3412247167, 'AU', 'AUS', 'أستراليا'),
(85012, 3412247168, 3412247319, 'IN', 'IND', 'الهند'),
(85013, 3412247320, 3412247327, 'AU', 'AUS', 'أستراليا'),
(85014, 3412247328, 3412247335, 'IN', 'IND', 'الهند'),
(85015, 3412247336, 3412247343, 'SG', 'SGP', 'سنغافورة'),
(85016, 3412247344, 3412247359, 'CN', 'CHN', 'الصين'),
(85017, 3412247360, 3412247375, 'AU', 'AUS', 'أستراليا'),
(85018, 3412247376, 3412247391, 'MY', 'MYS', 'ماليزيا'),
(85019, 3412247392, 3412247399, 'SG', 'SGP', 'سنغافورة'),
(85020, 3412247400, 3412247423, 'AU', 'AUS', 'أستراليا'),
(85021, 3412247424, 3412247439, 'HK', 'HKG', 'هونغ كونغ'),
(85022, 3412247440, 3412247455, 'IN', 'IND', 'الهند'),
(85023, 3412247456, 3412247487, 'AU', 'AUS', 'أستراليا'),
(85024, 3412247488, 3412247551, 'CN', 'CHN', 'الصين'),
(85025, 3412247552, 3412248831, 'AU', 'AUS', 'أستراليا'),
(85026, 3412248832, 3412249087, 'CN', 'CHN', 'الصين'),
(85027, 3412249088, 3412249103, 'HK', 'HKG', 'هونغ كونغ'),
(85028, 3412249104, 3412249119, 'IN', 'IND', 'الهند'),
(85029, 3412249120, 3412249151, 'AU', 'AUS', 'أستراليا'),
(85030, 3412249152, 3412249215, 'CN', 'CHN', 'الصين'),
(85031, 3412249216, 3412249231, 'AU', 'AUS', 'أستراليا'),
(85032, 3412249232, 3412249239, 'HK', 'HKG', 'هونغ كونغ'),
(85033, 3412249240, 3412249243, 'SG', 'SGP', 'سنغافورة'),
(85034, 3412249244, 3412249247, 'AU', 'AUS', 'أستراليا'),
(85035, 3412249248, 3412249271, 'CN', 'CHN', 'الصين'),
(85036, 3412249272, 3412249279, 'MY', 'MYS', 'ماليزيا'),
(85037, 3412249280, 3412249471, 'IN', 'IND', 'الهند'),
(85038, 3412249472, 3412249599, 'TW', 'TWN', 'تايوان'),
(85039, 3412249600, 3412249855, 'AU', 'AUS', 'أستراليا'),
(85040, 3412249856, 3412249863, 'SG', 'SGP', 'سنغافورة'),
(85041, 3412249864, 3412249871, 'AU', 'AUS', 'أستراليا'),
(85042, 3412249872, 3412249879, 'HK', 'HKG', 'هونغ كونغ'),
(85043, 3412249880, 3412249887, 'JP', 'JPN', 'اليابان'),
(85044, 3412249888, 3412249903, 'CN', 'CHN', 'الصين'),
(85045, 3412249904, 3412249983, 'SG', 'SGP', 'سنغافورة'),
(85046, 3412249984, 3412250015, 'IN', 'IND', 'الهند'),
(85047, 3412250016, 3412250023, 'HK', 'HKG', 'هونغ كونغ'),
(85048, 3412250024, 3412250031, 'CN', 'CHN', 'الصين'),
(85049, 3412250032, 3412250063, 'IN', 'IND', 'الهند'),
(85050, 3412250064, 3412250079, 'AU', 'AUS', 'أستراليا'),
(85051, 3412250080, 3412250087, 'KR', 'KOR', 'جمهورية كوريا'),
(85052, 3412250088, 3412250367, 'HK', 'HKG', 'هونغ كونغ'),
(85053, 3412250368, 3412250375, 'CN', 'CHN', 'الصين'),
(85054, 3412250376, 3412250383, 'TW', 'TWN', 'تايوان'),
(85055, 3412250384, 3412250399, 'SG', 'SGP', 'سنغافورة'),
(85056, 3412250400, 3412250431, 'KR', 'KOR', 'جمهورية كوريا'),
(85057, 3412250432, 3412250447, 'IN', 'IND', 'الهند'),
(85058, 3412250448, 3412250479, 'CN', 'CHN', 'الصين'),
(85059, 3412250480, 3412250495, 'HK', 'HKG', 'هونغ كونغ'),
(85060, 3412250496, 3412250503, 'JP', 'JPN', 'اليابان'),
(85061, 3412250504, 3412250511, 'HK', 'HKG', 'هونغ كونغ'),
(85062, 3412250512, 3412250527, 'TW', 'TWN', 'تايوان'),
(85063, 3412250528, 3412250559, 'IN', 'IND', 'الهند'),
(85064, 3412250560, 3412250575, 'SG', 'SGP', 'سنغافورة'),
(85065, 3412250576, 3412250599, 'HK', 'HKG', 'هونغ كونغ'),
(85066, 3412250600, 3412250607, 'AU', 'AUS', 'أستراليا'),
(85067, 3412250608, 3412250615, 'KR', 'KOR', 'جمهورية كوريا'),
(85068, 3412250616, 3412250623, 'AU', 'AUS', 'أستراليا'),
(85069, 3412250624, 3412250879, 'JP', 'JPN', 'اليابان'),
(85070, 3412250880, 3412250927, 'AU', 'AUS', 'أستراليا'),
(85071, 3412250928, 3412250959, 'SG', 'SGP', 'سنغافورة'),
(85072, 3412250960, 3412250991, 'JP', 'JPN', 'اليابان'),
(85073, 3412250992, 3412251007, 'HK', 'HKG', 'هونغ كونغ'),
(85074, 3412251008, 3412251071, 'CN', 'CHN', 'الصين'),
(85075, 3412251072, 3412251103, 'AU', 'AUS', 'أستراليا'),
(85076, 3412251104, 3412251119, 'PH', 'PHL', 'الفلبين'),
(85077, 3412251120, 3412251135, 'AU', 'AUS', 'أستراليا'),
(85078, 3412251136, 3412251151, 'CN', 'CHN', 'الصين'),
(85079, 3412251152, 3412251167, 'AU', 'AUS', 'أستراليا'),
(85080, 3412251168, 3412251231, 'HK', 'HKG', 'هونغ كونغ'),
(85081, 3412251232, 3412251239, 'CN', 'CHN', 'الصين'),
(85082, 3412251240, 3412251247, 'AU', 'AUS', 'أستراليا'),
(85083, 3412251248, 3412251263, 'IN', 'IND', 'الهند'),
(85084, 3412251264, 3412251391, 'AU', 'AUS', 'أستراليا'),
(85085, 3412251392, 3412251647, 'TW', 'TWN', 'تايوان'),
(85086, 3412251648, 3412251903, 'AU', 'AUS', 'أستراليا'),
(85087, 3412251904, 3412251919, 'HK', 'HKG', 'هونغ كونغ'),
(85088, 3412251920, 3412251927, 'AU', 'AUS', 'أستراليا'),
(85089, 3412251928, 3412251935, 'CN', 'CHN', 'الصين'),
(85090, 3412251936, 3412251967, 'HK', 'HKG', 'هونغ كونغ'),
(85091, 3412251968, 3412252031, 'SG', 'SGP', 'سنغافورة'),
(85092, 3412252032, 3412252079, 'HK', 'HKG', 'هونغ كونغ'),
(85093, 3412252080, 3412252087, 'CN', 'CHN', 'الصين'),
(85094, 3412252088, 3412252095, 'HK', 'HKG', 'هونغ كونغ'),
(85095, 3412252096, 3412252103, 'JP', 'JPN', 'اليابان'),
(85096, 3412252104, 3412252111, 'HK', 'HKG', 'هونغ كونغ'),
(85097, 3412252112, 3412252159, 'IN', 'IND', 'الهند'),
(85098, 3412252160, 3412252415, 'KR', 'KOR', 'جمهورية كوريا'),
(85099, 3412252416, 3412252671, 'JP', 'JPN', 'اليابان'),
(85100, 3412252672, 3412252927, 'HK', 'HKG', 'هونغ كونغ'),
(85101, 3412252928, 3412253087, 'AU', 'AUS', 'أستراليا'),
(85102, 3412253088, 3412253091, 'JP', 'JPN', 'اليابان'),
(85103, 3412253092, 3412253099, 'AU', 'AUS', 'أستراليا'),
(85104, 3412253100, 3412253103, 'HK', 'HKG', 'هونغ كونغ'),
(85105, 3412253104, 3412253183, 'AU', 'AUS', 'أستراليا'),
(85106, 3412253184, 3412253439, 'SG', 'SGP', 'سنغافورة'),
(85107, 3412253440, 3412253695, 'KR', 'KOR', 'جمهورية كوريا'),
(85108, 3412253696, 3412254719, 'JP', 'JPN', 'اليابان'),
(85109, 3412254720, 3412262911, 'NR', 'NRU', 'ناورو'),
(85110, 3412262912, 3412264959, 'JP', 'JPN', 'اليابان'),
(85111, 3412264960, 3412267007, 'AU', 'AUS', 'أستراليا'),
(85112, 3412267008, 3412271103, 'CN', 'CHN', 'الصين'),
(85113, 3412271104, 3412273151, 'NZ', 'NZL', 'نيوزيلاندا'),
(85114, 3412273152, 3412275199, 'IN', 'IND', 'الهند'),
(85115, 3412275200, 3412279295, 'PK', 'PAK', 'باكستان'),
(85116, 3412279296, 3412281343, 'NZ', 'NZL', 'نيوزيلاندا'),
(85117, 3412281344, 3412283391, 'JP', 'JPN', 'اليابان'),
(85118, 3412283392, 3412287487, 'CN', 'CHN', 'الصين'),
(85119, 3412287488, 3412295679, 'ID', 'IDN', 'إندونيسيا'),
(85120, 3412295680, 3412296191, 'NZ', 'NZL', 'نيوزيلاندا'),
(85121, 3412296192, 3412296703, 'ID', 'IDN', 'إندونيسيا'),
(85122, 3412296704, 3412297727, 'NZ', 'NZL', 'نيوزيلاندا'),
(85123, 3412297728, 3412298495, 'SC', 'SYC', 'سيشيل'),
(85124, 3412298496, 3412298751, 'MY', 'MYS', 'ماليزيا'),
(85125, 3412298752, 3412299263, 'CN', 'CHN', 'الصين'),
(85126, 3412299264, 3412299519, 'AU', 'AUS', 'أستراليا'),
(85127, 3412299520, 3412299775, 'HK', 'HKG', 'هونغ كونغ'),
(85128, 3412299776, 3412302847, 'AU', 'AUS', 'أستراليا'),
(85129, 3412302848, 3412303871, 'WS', 'WSM', 'ساموا'),
(85130, 3412303872, 3412312063, 'PK', 'PAK', 'باكستان'),
(85131, 3412312064, 3412320255, 'IN', 'IND', 'الهند'),
(85132, 3412320256, 3412322303, 'JP', 'JPN', 'اليابان'),
(85133, 3412322304, 3412324351, 'PH', 'PHL', 'الفلبين'),
(85134, 3412324352, 3412326399, 'JP', 'JPN', 'اليابان'),
(85135, 3412326400, 3412327423, 'VN', 'VNM', 'فييتنام'),
(85136, 3412327424, 3412327935, 'TH', 'THA', 'تايلند'),
(85137, 3412327936, 3412328191, 'HK', 'HKG', 'هونغ كونغ'),
(85138, 3412328192, 3412328447, 'WS', 'WSM', 'ساموا'),
(85139, 3412328448, 3412336639, 'AU', 'AUS', 'أستراليا'),
(85140, 3412336640, 3412340735, 'CN', 'CHN', 'الصين'),
(85141, 3412340736, 3412343039, 'AU', 'AUS', 'أستراليا'),
(85142, 3412343040, 3412343295, 'IN', 'IND', 'الهند'),
(85143, 3412343296, 3412344319, 'AU', 'AUS', 'أستراليا'),
(85144, 3412344320, 3412344575, 'SG', 'SGP', 'سنغافورة'),
(85145, 3412344576, 3412344831, 'AU', 'AUS', 'أستراليا'),
(85146, 3412344832, 3412348927, 'IN', 'IND', 'الهند'),
(85147, 3412348928, 3412361215, 'CN', 'CHN', 'الصين'),
(85148, 3412361216, 3412369407, 'AU', 'AUS', 'أستراليا'),
(85149, 3412369408, 3412377599, 'KR', 'KOR', 'جمهورية كوريا'),
(85150, 3412377600, 3412381695, 'CN', 'CHN', 'الصين'),
(85151, 3412381696, 3412385791, 'NZ', 'NZL', 'نيوزيلاندا'),
(85152, 3412385792, 3412393983, 'AU', 'AUS', 'أستراليا'),
(85153, 3412393984, 3412426751, 'IN', 'IND', 'الهند'),
(85154, 3412426752, 3412434943, 'TH', 'THA', 'تايلند'),
(85155, 3412434944, 3412443135, 'PK', 'PAK', 'باكستان'),
(85156, 3412443136, 3412451327, 'SG', 'SGP', 'سنغافورة'),
(85157, 3412451328, 3412594687, 'AU', 'AUS', 'أستراليا'),
(85158, 3412594688, 3412596735, 'IN', 'IND', 'الهند'),
(85159, 3412596736, 3412598783, 'MV', 'MDV', 'جزر المالديف'),
(85160, 3412598784, 3412602879, 'AU', 'AUS', 'أستراليا'),
(85161, 3412602880, 3412606975, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(85162, 3412606976, 3412615167, 'PH', 'PHL', 'الفلبين'),
(85163, 3412615168, 3412656127, 'JP', 'JPN', 'اليابان'),
(85164, 3412656128, 3412672511, 'HK', 'HKG', 'هونغ كونغ'),
(85165, 3412672512, 3412680703, 'JP', 'JPN', 'اليابان'),
(85166, 3412680704, 3412697087, 'AU', 'AUS', 'أستراليا'),
(85167, 3412697088, 3412705279, 'IN', 'IND', 'الهند'),
(85168, 3412705280, 3412713471, 'AU', 'AUS', 'أستراليا'),
(85169, 3412713472, 3412721663, 'TW', 'TWN', 'تايوان'),
(85170, 3412721664, 3412787199, 'MY', 'MYS', 'ماليزيا'),
(85171, 3412787200, 3412819967, 'AU', 'AUS', 'أستراليا'),
(85172, 3412819968, 3412852735, 'TH', 'THA', 'تايلند'),
(85173, 3412852736, 3412918271, 'AU', 'AUS', 'أستراليا'),
(85174, 3412918272, 3412926463, 'KR', 'KOR', 'جمهورية كوريا'),
(85175, 3412926464, 3412934655, 'MY', 'MYS', 'ماليزيا'),
(85176, 3412934656, 3412951039, 'IN', 'IND', 'الهند'),
(85177, 3412951040, 3413000191, 'NZ', 'NZL', 'نيوزيلاندا'),
(85178, 3413000192, 3413004287, 'LA', 'LAO', 'لاو'),
(85179, 3413004288, 3413008383, 'IN', 'IND', 'الهند'),
(85180, 3413008384, 3413016575, 'JP', 'JPN', 'اليابان'),
(85181, 3413016576, 3413024767, 'AU', 'AUS', 'أستراليا'),
(85182, 3413024768, 3413032959, 'CN', 'CHN', 'الصين'),
(85183, 3413032960, 3413037055, 'AU', 'AUS', 'أستراليا'),
(85184, 3413037056, 3413041151, 'IN', 'IND', 'الهند'),
(85185, 3413041152, 3413043199, 'JP', 'JPN', 'اليابان'),
(85186, 3413043200, 3413044479, 'AU', 'AUS', 'أستراليا'),
(85187, 3413044480, 3413044735, 'SG', 'SGP', 'سنغافورة'),
(85188, 3413044736, 3413045247, 'AU', 'AUS', 'أستراليا'),
(85189, 3413045248, 3413047295, 'IN', 'IND', 'الهند'),
(85190, 3413047296, 3413102591, 'AU', 'AUS', 'أستراليا'),
(85191, 3413102592, 3413106687, 'TW', 'TWN', 'تايوان'),
(85192, 3413106688, 3413110783, 'PH', 'PHL', 'الفلبين'),
(85193, 3413110784, 3413112831, 'JP', 'JPN', 'اليابان'),
(85194, 3413112832, 3413113855, 'IN', 'IND', 'الهند'),
(85195, 3413113856, 3413133311, 'JP', 'JPN', 'اليابان'),
(85196, 3413133312, 3413135359, 'BD', 'BGD', 'بنغالاديش'),
(85197, 3413135360, 3413139455, 'HK', 'HKG', 'هونغ كونغ'),
(85198, 3413139456, 3413147647, 'AU', 'AUS', 'أستراليا'),
(85199, 3413147648, 3413155839, 'IN', 'IND', 'الهند'),
(85200, 3413155840, 3413164031, 'SG', 'SGP', 'سنغافورة'),
(85201, 3413164032, 3413172223, 'BD', 'BGD', 'بنغالاديش'),
(85202, 3413172224, 3413180415, 'MY', 'MYS', 'ماليزيا'),
(85203, 3413180416, 3413213183, 'TH', 'THA', 'تايلند'),
(85204, 3413213184, 3413229567, 'VN', 'VNM', 'فييتنام'),
(85205, 3413229568, 3413245951, 'AU', 'AUS', 'أستراليا'),
(85206, 3413245952, 3413262335, 'MY', 'MYS', 'ماليزيا'),
(85207, 3413262336, 3413270527, 'PH', 'PHL', 'الفلبين'),
(85208, 3413270528, 3413278719, 'TH', 'THA', 'تايلند'),
(85209, 3413278720, 3413295103, 'NZ', 'NZL', 'نيوزيلاندا'),
(85210, 3413295104, 3413303295, 'JP', 'JPN', 'اليابان'),
(85211, 3413303296, 3413304319, 'ID', 'IDN', 'إندونيسيا'),
(85212, 3413304320, 3413305343, 'JP', 'JPN', 'اليابان'),
(85213, 3413305344, 3413306367, 'IN', 'IND', 'الهند'),
(85214, 3413306368, 3413307391, 'PH', 'PHL', 'الفلبين'),
(85215, 3413307392, 3413308415, 'IN', 'IND', 'الهند'),
(85216, 3413308416, 3413309439, 'CN', 'CHN', 'الصين'),
(85217, 3413309440, 3413310463, 'JP', 'JPN', 'اليابان'),
(85218, 3413310464, 3413311487, 'HK', 'HKG', 'هونغ كونغ'),
(85219, 3413311488, 3413327871, 'LK', 'LKA', 'سيريلانكا'),
(85220, 3413327872, 3413344255, 'IN', 'IND', 'الهند'),
(85221, 3413344256, 3413360639, 'PH', 'PHL', 'الفلبين'),
(85222, 3413360640, 3413377023, 'MY', 'MYS', 'ماليزيا'),
(85223, 3413377024, 3413524479, 'SG', 'SGP', 'سنغافورة'),
(85224, 3413524480, 3413540863, 'TH', 'THA', 'تايلند'),
(85225, 3413540864, 3413557247, 'NZ', 'NZL', 'نيوزيلاندا'),
(85226, 3413557248, 3413565439, 'CN', 'CHN', 'الصين'),
(85227, 3413565440, 3413569535, 'TW', 'TWN', 'تايوان'),
(85228, 3413569536, 3413569791, 'SG', 'SGP', 'سنغافورة'),
(85229, 3413569792, 3413570047, 'NZ', 'NZL', 'نيوزيلاندا'),
(85230, 3413570048, 3413570303, 'KH', 'KHM', 'كامبوديا'),
(85231, 3413570304, 3413570559, 'AU', 'AUS', 'أستراليا'),
(85232, 3413570560, 3413571583, 'PH', 'PHL', 'الفلبين'),
(85233, 3413571584, 3413572607, 'CN', 'CHN', 'الصين'),
(85234, 3413572608, 3413573631, 'JP', 'JPN', 'اليابان'),
(85235, 3413573632, 3413573887, 'AU', 'AUS', 'أستراليا'),
(85236, 3413573888, 3413574143, 'JP', 'JPN', 'اليابان'),
(85237, 3413574144, 3413574399, 'HK', 'HKG', 'هونغ كونغ'),
(85238, 3413574400, 3413574655, 'TW', 'TWN', 'تايوان'),
(85239, 3413574656, 3413575679, 'PH', 'PHL', 'الفلبين'),
(85240, 3413575680, 3413576703, 'VN', 'VNM', 'فييتنام'),
(85241, 3413576704, 3413576959, 'AU', 'AUS', 'أستراليا'),
(85242, 3413576960, 3413577215, 'ID', 'IDN', 'إندونيسيا'),
(85243, 3413577216, 3413579007, 'AU', 'AUS', 'أستراليا'),
(85244, 3413579008, 3413579775, 'NL', 'NLD', 'هولندا'),
(85245, 3413579776, 3413582847, 'CN', 'CHN', 'الصين'),
(85246, 3413582848, 3413583871, 'VN', 'VNM', 'فييتنام'),
(85247, 3413583872, 3413584127, 'JP', 'JPN', 'اليابان'),
(85248, 3413584128, 3413584383, 'ID', 'IDN', 'إندونيسيا'),
(85249, 3413584384, 3413584895, 'AU', 'AUS', 'أستراليا'),
(85250, 3413584896, 3413585919, 'VN', 'VNM', 'فييتنام'),
(85251, 3413585920, 3413586175, 'ID', 'IDN', 'إندونيسيا'),
(85252, 3413586176, 3413586687, 'IN', 'IND', 'الهند'),
(85253, 3413586688, 3413586943, 'AU', 'AUS', 'أستراليا'),
(85254, 3413586944, 3413587967, 'ID', 'IDN', 'إندونيسيا'),
(85255, 3413587968, 3413588223, 'NZ', 'NZL', 'نيوزيلاندا'),
(85256, 3413588224, 3413588479, 'MY', 'MYS', 'ماليزيا'),
(85257, 3413588480, 3413593087, 'VN', 'VNM', 'فييتنام'),
(85258, 3413593088, 3413593599, 'AU', 'AUS', 'أستراليا'),
(85259, 3413593600, 3413593855, 'SG', 'SGP', 'سنغافورة'),
(85260, 3413593856, 3413594111, 'KH', 'KHM', 'كامبوديا'),
(85261, 3413594112, 3413595135, 'CN', 'CHN', 'الصين'),
(85262, 3413595136, 3413595391, 'NZ', 'NZL', 'نيوزيلاندا'),
(85263, 3413595392, 3413595647, 'JP', 'JPN', 'اليابان'),
(85264, 3413595648, 3413596671, 'AU', 'AUS', 'أستراليا'),
(85265, 3413596672, 3413597183, 'NP', 'NPL', 'نيبال'),
(85266, 3413597184, 3413639167, 'AU', 'AUS', 'أستراليا'),
(85267, 3413639168, 3413704703, 'SG', 'SGP', 'سنغافورة'),
(85268, 3413704704, 3413737471, 'MY', 'MYS', 'ماليزيا'),
(85269, 3413737472, 3413753855, 'TH', 'THA', 'تايلند'),
(85270, 3413753856, 3413762047, 'AU', 'AUS', 'أستراليا'),
(85271, 3413762048, 3413770239, 'TW', 'TWN', 'تايوان'),
(85272, 3413770240, 3413786623, 'IN', 'IND', 'الهند'),
(85273, 3413786624, 3413835775, 'AU', 'AUS', 'أستراليا'),
(85274, 3413835776, 3413843967, 'SG', 'SGP', 'سنغافورة'),
(85275, 3413843968, 3413848063, 'IN', 'IND', 'الهند'),
(85276, 3413848064, 3413850111, 'SG', 'SGP', 'سنغافورة'),
(85277, 3413850112, 3413850879, 'JP', 'JPN', 'اليابان'),
(85278, 3413850880, 3413851135, 'AU', 'AUS', 'أستراليا'),
(85279, 3413851136, 3413852159, 'ID', 'IDN', 'إندونيسيا'),
(85280, 3413852160, 3413868543, 'AU', 'AUS', 'أستراليا'),
(85281, 3413868544, 3413884927, 'IN', 'IND', 'الهند'),
(85282, 3413884928, 3413893119, 'KR', 'KOR', 'جمهورية كوريا'),
(85283, 3413893120, 3413899199, 'ID', 'IDN', 'إندونيسيا'),
(85284, 3413899200, 3413899203, 'IN', 'IND', 'الهند');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(85285, 3413899204, 3413901311, 'ID', 'IDN', 'إندونيسيا'),
(85286, 3413901312, 3413902847, 'SG', 'SGP', 'سنغافورة'),
(85287, 3413902848, 3413903359, 'JP', 'JPN', 'اليابان'),
(85288, 3413903360, 3413905407, 'HK', 'HKG', 'هونغ كونغ'),
(85289, 3413905408, 3413907455, 'IN', 'IND', 'الهند'),
(85290, 3413907456, 3413917695, 'PK', 'PAK', 'باكستان'),
(85291, 3413917696, 3413925887, 'JP', 'JPN', 'اليابان'),
(85292, 3413925888, 3413934079, 'AU', 'AUS', 'أستراليا'),
(85293, 3413934080, 3413946367, 'IN', 'IND', 'الهند'),
(85294, 3413946368, 3413950463, 'AU', 'AUS', 'أستراليا'),
(85295, 3413950464, 3413966847, 'IN', 'IND', 'الهند'),
(85296, 3413966848, 3414050303, 'SG', 'SGP', 'سنغافورة'),
(85297, 3414050304, 3414050815, 'US', 'USA', 'الولايات المتحدة'),
(85298, 3414050816, 3414098175, 'SG', 'SGP', 'سنغافورة'),
(85299, 3414098176, 3414098191, 'ID', 'IDN', 'إندونيسيا'),
(85300, 3414098192, 3414155519, 'SG', 'SGP', 'سنغافورة'),
(85301, 3414155520, 3414155775, 'PH', 'PHL', 'الفلبين'),
(85302, 3414155776, 3414163455, 'SG', 'SGP', 'سنغافورة'),
(85303, 3414163456, 3414171647, 'PK', 'PAK', 'باكستان'),
(85304, 3414171648, 3414179839, 'CN', 'CHN', 'الصين'),
(85305, 3414179840, 3414188031, 'ID', 'IDN', 'إندونيسيا'),
(85306, 3414188032, 3414196223, 'CN', 'CHN', 'الصين'),
(85307, 3414196224, 3414204415, 'AU', 'AUS', 'أستراليا'),
(85308, 3414204416, 3414220799, 'KR', 'KOR', 'جمهورية كوريا'),
(85309, 3414220800, 3414223871, 'AU', 'AUS', 'أستراليا'),
(85310, 3414223872, 3414224895, 'KR', 'KOR', 'جمهورية كوريا'),
(85311, 3414224896, 3414226943, 'VN', 'VNM', 'فييتنام'),
(85312, 3414226944, 3414227967, 'ID', 'IDN', 'إندونيسيا'),
(85313, 3414227968, 3414230015, 'PK', 'PAK', 'باكستان'),
(85314, 3414230016, 3414230527, 'PH', 'PHL', 'الفلبين'),
(85315, 3414230528, 3414231039, 'KR', 'KOR', 'جمهورية كوريا'),
(85316, 3414231040, 3414245375, 'AU', 'AUS', 'أستراليا'),
(85317, 3414245376, 3414253567, 'HK', 'HKG', 'هونغ كونغ'),
(85318, 3414253568, 3414261759, 'JP', 'JPN', 'اليابان'),
(85319, 3414261760, 3414269951, 'AU', 'AUS', 'أستراليا'),
(85320, 3414269952, 3414278143, 'JP', 'JPN', 'اليابان'),
(85321, 3414278144, 3414294527, 'IN', 'IND', 'الهند'),
(85322, 3414294528, 3414302719, 'PK', 'PAK', 'باكستان'),
(85323, 3414302720, 3414310911, 'CN', 'CHN', 'الصين'),
(85324, 3414310912, 3414327295, 'KR', 'KOR', 'جمهورية كوريا'),
(85325, 3414327296, 3414335487, 'TH', 'THA', 'تايلند'),
(85326, 3414335488, 3414339583, 'AU', 'AUS', 'أستراليا'),
(85327, 3414339584, 3414343679, 'KR', 'KOR', 'جمهورية كوريا'),
(85328, 3414343680, 3414360063, 'ID', 'IDN', 'إندونيسيا'),
(85329, 3414360064, 3414376447, 'AU', 'AUS', 'أستراليا'),
(85330, 3414376448, 3414409215, 'PH', 'PHL', 'الفلبين'),
(85331, 3414409216, 3414413311, 'JP', 'JPN', 'اليابان'),
(85332, 3414413312, 3414417407, 'TH', 'THA', 'تايلند'),
(85333, 3414417408, 3414425599, 'HK', 'HKG', 'هونغ كونغ'),
(85334, 3414425600, 3414433791, 'AU', 'AUS', 'أستراليا'),
(85335, 3414433792, 3414441983, 'CN', 'CHN', 'الصين'),
(85336, 3414441984, 3414450175, 'AU', 'AUS', 'أستراليا'),
(85337, 3414450176, 3414458367, 'JP', 'JPN', 'اليابان'),
(85338, 3414458368, 3414466559, 'IN', 'IND', 'الهند'),
(85339, 3414466560, 3414474751, 'KR', 'KOR', 'جمهورية كوريا'),
(85340, 3414474752, 3414478847, 'HK', 'HKG', 'هونغ كونغ'),
(85341, 3414478848, 3414482943, 'IN', 'IND', 'الهند'),
(85342, 3414482944, 3414491135, 'AU', 'AUS', 'أستراليا'),
(85343, 3414491136, 3414523903, 'TW', 'TWN', 'تايوان'),
(85344, 3414523904, 3414532095, 'JP', 'JPN', 'اليابان'),
(85345, 3414532096, 3414540287, 'KR', 'KOR', 'جمهورية كوريا'),
(85346, 3414540288, 3414555647, 'JP', 'JPN', 'اليابان'),
(85347, 3414555648, 3414556671, 'PK', 'PAK', 'باكستان'),
(85348, 3414556672, 3414605823, 'AU', 'AUS', 'أستراليا'),
(85349, 3414605824, 3414616063, 'IN', 'IND', 'الهند'),
(85350, 3414616064, 3414618111, 'ID', 'IDN', 'إندونيسيا'),
(85351, 3414618112, 3414620159, 'CN', 'CHN', 'الصين'),
(85352, 3414620160, 3414621183, 'IN', 'IND', 'الهند'),
(85353, 3414621184, 3414638591, 'PK', 'PAK', 'باكستان'),
(85354, 3414638592, 3414646783, 'TW', 'TWN', 'تايوان'),
(85355, 3414646784, 3414654975, 'CN', 'CHN', 'الصين'),
(85356, 3414654976, 3414663167, 'HK', 'HKG', 'هونغ كونغ'),
(85357, 3414663168, 3414667263, 'CN', 'CHN', 'الصين'),
(85358, 3414667264, 3414669311, 'ID', 'IDN', 'إندونيسيا'),
(85359, 3414669312, 3414670335, 'AU', 'AUS', 'أستراليا'),
(85360, 3414670336, 3414670591, 'IN', 'IND', 'الهند'),
(85361, 3414670592, 3414670847, 'SG', 'SGP', 'سنغافورة'),
(85362, 3414670848, 3414671359, 'MY', 'MYS', 'ماليزيا'),
(85363, 3414671360, 3415080959, 'JP', 'JPN', 'اليابان'),
(85364, 3415080960, 3415083007, 'MY', 'MYS', 'ماليزيا'),
(85365, 3415083008, 3415083519, 'SG', 'SGP', 'سنغافورة'),
(85366, 3415083520, 3415084031, 'HK', 'HKG', 'هونغ كونغ'),
(85367, 3415084032, 3415084543, 'CN', 'CHN', 'الصين'),
(85368, 3415084544, 3415085055, 'US', 'USA', 'الولايات المتحدة'),
(85369, 3415085056, 3415087615, 'SG', 'SGP', 'سنغافورة'),
(85370, 3415087616, 3415087871, 'US', 'USA', 'الولايات المتحدة'),
(85371, 3415087872, 3415088127, 'SG', 'SGP', 'سنغافورة'),
(85372, 3415088128, 3415089151, 'HK', 'HKG', 'هونغ كونغ'),
(85373, 3415089152, 3415097343, 'MY', 'MYS', 'ماليزيا'),
(85374, 3415097344, 3415103487, 'ID', 'IDN', 'إندونيسيا'),
(85375, 3415103488, 3415113727, 'HK', 'HKG', 'هونغ كونغ'),
(85376, 3415113728, 3415121919, 'AU', 'AUS', 'أستراليا'),
(85377, 3415121920, 3415130111, 'KR', 'KOR', 'جمهورية كوريا'),
(85378, 3415130112, 3415136255, 'JP', 'JPN', 'اليابان'),
(85379, 3415136256, 3415136767, 'KR', 'KOR', 'جمهورية كوريا'),
(85380, 3415136768, 3415137279, 'AU', 'AUS', 'أستراليا'),
(85381, 3415137280, 3415137535, 'IN', 'IND', 'الهند'),
(85382, 3415137536, 3415137791, 'NF', 'NFK', 'جزيرة نورفولك'),
(85383, 3415137792, 3415146495, 'AU', 'AUS', 'أستراليا'),
(85384, 3415146496, 3415162879, 'LK', 'LKA', 'سيريلانكا'),
(85385, 3415162880, 3415171071, 'AU', 'AUS', 'أستراليا'),
(85386, 3415171072, 3415179263, 'JP', 'JPN', 'اليابان'),
(85387, 3415179264, 3415187455, 'SG', 'SGP', 'سنغافورة'),
(85388, 3415187456, 3415191551, 'AU', 'AUS', 'أستراليا'),
(85389, 3415191552, 3415195647, 'IN', 'IND', 'الهند'),
(85390, 3415195648, 3415220223, 'AU', 'AUS', 'أستراليا'),
(85391, 3415220224, 3415224319, 'NZ', 'NZL', 'نيوزيلاندا'),
(85392, 3415224320, 3415228415, 'US', 'USA', 'الولايات المتحدة'),
(85393, 3415228416, 3415236607, 'KH', 'KHM', 'كامبوديا'),
(85394, 3415236608, 3415244799, 'AU', 'AUS', 'أستراليا'),
(85395, 3415244800, 3415277567, 'TH', 'THA', 'تايلند'),
(85396, 3415277568, 3415293951, 'AU', 'AUS', 'أستراليا'),
(85397, 3415293952, 3415302143, 'HK', 'HKG', 'هونغ كونغ'),
(85398, 3415302144, 3415306239, 'AU', 'AUS', 'أستراليا'),
(85399, 3415306240, 3415308287, 'TH', 'THA', 'تايلند'),
(85400, 3415308288, 3415310335, 'JP', 'JPN', 'اليابان'),
(85401, 3415310336, 3415326719, 'IN', 'IND', 'الهند'),
(85402, 3415326720, 3415334911, 'TW', 'TWN', 'تايوان'),
(85403, 3415334912, 3415343103, 'JP', 'JPN', 'اليابان'),
(85404, 3415343104, 3415425023, 'TH', 'THA', 'تايلند'),
(85405, 3415425024, 3415431167, 'NC', 'NCL', 'كاليدونيا الجديدة'),
(85406, 3415431168, 3415432191, 'IN', 'IND', 'الهند'),
(85407, 3415432192, 3415435263, 'AU', 'AUS', 'أستراليا'),
(85408, 3415435264, 3415436287, 'PH', 'PHL', 'الفلبين'),
(85409, 3415436288, 3415436799, 'AU', 'AUS', 'أستراليا'),
(85410, 3415436800, 3415437311, 'HK', 'HKG', 'هونغ كونغ'),
(85411, 3415437312, 3415474175, 'AU', 'AUS', 'أستراليا'),
(85412, 3415474176, 3415490559, 'CN', 'CHN', 'الصين'),
(85413, 3415490560, 3415494655, 'AU', 'AUS', 'أستراليا'),
(85414, 3415494656, 3415495679, 'PH', 'PHL', 'الفلبين'),
(85415, 3415495680, 3415496191, 'ID', 'IDN', 'إندونيسيا'),
(85416, 3415496192, 3415496703, 'AU', 'AUS', 'أستراليا'),
(85417, 3415496704, 3415497727, 'MY', 'MYS', 'ماليزيا'),
(85418, 3415497728, 3415497983, 'TW', 'TWN', 'تايوان'),
(85419, 3415497984, 3415498751, 'AU', 'AUS', 'أستراليا'),
(85420, 3415498752, 3415506943, 'JP', 'JPN', 'اليابان'),
(85421, 3415506944, 3415556095, 'TH', 'THA', 'تايلند'),
(85422, 3415556096, 3415564287, 'AU', 'AUS', 'أستراليا'),
(85423, 3415564288, 3415568383, 'JP', 'JPN', 'اليابان'),
(85424, 3415568384, 3415572479, 'KR', 'KOR', 'جمهورية كوريا'),
(85425, 3415572480, 3415605247, 'SG', 'SGP', 'سنغافورة'),
(85426, 3415605248, 3415752703, 'TH', 'THA', 'تايلند'),
(85427, 3415752704, 3415760895, 'CN', 'CHN', 'الصين'),
(85428, 3415760896, 3415769087, 'NZ', 'NZL', 'نيوزيلاندا'),
(85429, 3415769088, 3415777279, 'AU', 'AUS', 'أستراليا'),
(85430, 3415777280, 3415785471, 'KR', 'KOR', 'جمهورية كوريا'),
(85431, 3415785472, 3415793663, 'JP', 'JPN', 'اليابان'),
(85432, 3415793664, 3415801855, 'AU', 'AUS', 'أستراليا'),
(85433, 3415801856, 3415802879, 'ID', 'IDN', 'إندونيسيا'),
(85434, 3415802880, 3415803391, 'HK', 'HKG', 'هونغ كونغ'),
(85435, 3415803392, 3415805951, 'PH', 'PHL', 'الفلبين'),
(85436, 3415805952, 3415807999, 'MY', 'MYS', 'ماليزيا'),
(85437, 3415808000, 3415810047, 'ID', 'IDN', 'إندونيسيا'),
(85438, 3415810048, 3415814399, 'IN', 'IND', 'الهند'),
(85439, 3415814400, 3415814655, 'ID', 'IDN', 'إندونيسيا'),
(85440, 3415814656, 3415815167, 'TH', 'THA', 'تايلند'),
(85441, 3415815168, 3415816191, 'IN', 'IND', 'الهند'),
(85442, 3415816192, 3415817215, 'JP', 'JPN', 'اليابان'),
(85443, 3415817216, 3415818239, 'ID', 'IDN', 'إندونيسيا'),
(85444, 3415818240, 3415822335, 'AU', 'AUS', 'أستراليا'),
(85445, 3415822336, 3415826431, 'MY', 'MYS', 'ماليزيا'),
(85446, 3415826432, 3415834623, 'ID', 'IDN', 'إندونيسيا'),
(85447, 3415834624, 3415838719, 'TH', 'THA', 'تايلند'),
(85448, 3415838720, 3415842815, 'KR', 'KOR', 'جمهورية كوريا'),
(85449, 3415842816, 3415851007, 'TH', 'THA', 'تايلند'),
(85450, 3415851008, 3415855103, 'AU', 'AUS', 'أستراليا'),
(85451, 3415855104, 3415855615, 'HK', 'HKG', 'هونغ كونغ'),
(85452, 3415855616, 3415856127, 'IN', 'IND', 'الهند'),
(85453, 3415856128, 3415858175, 'ID', 'IDN', 'إندونيسيا'),
(85454, 3415858176, 3415859199, 'LK', 'LKA', 'سيريلانكا'),
(85455, 3415859200, 3415867391, 'AU', 'AUS', 'أستراليا'),
(85456, 3415867392, 3416047615, 'TH', 'THA', 'تايلند'),
(85457, 3416047616, 3416063999, 'CN', 'CHN', 'الصين'),
(85458, 3416064000, 3416131583, 'TH', 'THA', 'تايلند'),
(85459, 3416131584, 3416133631, 'PH', 'PHL', 'الفلبين'),
(85460, 3416133632, 3416135679, 'CN', 'CHN', 'الصين'),
(85461, 3416135680, 3416137727, 'MY', 'MYS', 'ماليزيا'),
(85462, 3416137728, 3416145919, 'AU', 'AUS', 'أستراليا'),
(85463, 3416145920, 3416154111, 'IN', 'IND', 'الهند'),
(85464, 3416154112, 3416260607, 'TH', 'THA', 'تايلند'),
(85465, 3416260608, 3416261119, 'VN', 'VNM', 'فييتنام'),
(85466, 3416261120, 3416261631, 'AU', 'AUS', 'أستراليا'),
(85467, 3416261632, 3416262655, 'TH', 'THA', 'تايلند'),
(85468, 3416262656, 3416264703, 'AU', 'AUS', 'أستراليا'),
(85469, 3416264704, 3416268799, 'JP', 'JPN', 'اليابان'),
(85470, 3416268800, 3416272895, 'HK', 'HKG', 'هونغ كونغ'),
(85471, 3416272896, 3416274943, 'MN', 'MNG', 'منغوليا'),
(85472, 3416274944, 3416276991, 'ID', 'IDN', 'إندونيسيا'),
(85473, 3416276992, 3416285183, 'HK', 'HKG', 'هونغ كونغ'),
(85474, 3416285184, 3416287231, 'VN', 'VNM', 'فييتنام'),
(85475, 3416287232, 3416289279, 'AU', 'AUS', 'أستراليا'),
(85476, 3416289280, 3416293375, 'NZ', 'NZL', 'نيوزيلاندا'),
(85477, 3416293376, 3416293631, 'ID', 'IDN', 'إندونيسيا'),
(85478, 3416293632, 3416295423, 'AU', 'AUS', 'أستراليا'),
(85479, 3416295424, 3416295679, 'IN', 'IND', 'الهند'),
(85480, 3416295680, 3416295935, 'TH', 'THA', 'تايلند'),
(85481, 3416295936, 3416296447, 'IN', 'IND', 'الهند'),
(85482, 3416296448, 3416297471, 'KR', 'KOR', 'جمهورية كوريا'),
(85483, 3416297472, 3416301567, 'TW', 'TWN', 'تايوان'),
(85484, 3416301568, 3416309759, 'PH', 'PHL', 'الفلبين'),
(85485, 3416309760, 3416317951, 'AU', 'AUS', 'أستراليا'),
(85486, 3416317952, 3416326143, 'TW', 'TWN', 'تايوان'),
(85487, 3416326144, 3416327167, 'VN', 'VNM', 'فييتنام'),
(85488, 3416327168, 3416328191, 'HK', 'HKG', 'هونغ كونغ'),
(85489, 3416328192, 3416330239, 'AU', 'AUS', 'أستراليا'),
(85490, 3416330240, 3416334335, 'ID', 'IDN', 'إندونيسيا'),
(85491, 3416334336, 3416337919, 'SG', 'SGP', 'سنغافورة'),
(85492, 3416337920, 3416338175, 'IN', 'IND', 'الهند'),
(85493, 3416338176, 3416338431, 'SG', 'SGP', 'سنغافورة'),
(85494, 3416338432, 3416338687, 'MY', 'MYS', 'ماليزيا'),
(85495, 3416338688, 3416338943, 'SG', 'SGP', 'سنغافورة'),
(85496, 3416338944, 3416339199, 'IN', 'IND', 'الهند'),
(85497, 3416339200, 3416339455, 'SG', 'SGP', 'سنغافورة'),
(85498, 3416339456, 3416339711, 'IN', 'IND', 'الهند'),
(85499, 3416339712, 3416339967, 'SG', 'SGP', 'سنغافورة'),
(85500, 3416339968, 3416340223, 'IN', 'IND', 'الهند'),
(85501, 3416340224, 3416340735, 'SG', 'SGP', 'سنغافورة'),
(85502, 3416340736, 3416340991, 'IN', 'IND', 'الهند'),
(85503, 3416340992, 3416341247, 'SG', 'SGP', 'سنغافورة'),
(85504, 3416341248, 3416341503, 'IN', 'IND', 'الهند'),
(85505, 3416341504, 3416341759, 'SG', 'SGP', 'سنغافورة'),
(85506, 3416341760, 3416342015, 'IN', 'IND', 'الهند'),
(85507, 3416342016, 3416342271, 'SG', 'SGP', 'سنغافورة'),
(85508, 3416342272, 3416342527, 'IN', 'IND', 'الهند'),
(85509, 3416342528, 3416371199, 'AU', 'AUS', 'أستراليا'),
(85510, 3416371200, 3416371711, 'PH', 'PHL', 'الفلبين'),
(85511, 3416371712, 3416371967, 'VN', 'VNM', 'فييتنام'),
(85512, 3416371968, 3416372223, 'IN', 'IND', 'الهند'),
(85513, 3416372224, 3416372479, 'CN', 'CHN', 'الصين'),
(85514, 3416372480, 3416372735, 'SG', 'SGP', 'سنغافورة'),
(85515, 3416372736, 3416372991, 'AU', 'AUS', 'أستراليا'),
(85516, 3416372992, 3416373247, 'SG', 'SGP', 'سنغافورة'),
(85517, 3416373248, 3416373503, 'AU', 'AUS', 'أستراليا'),
(85518, 3416373504, 3416373759, 'SG', 'SGP', 'سنغافورة'),
(85519, 3416373760, 3416374271, 'AU', 'AUS', 'أستراليا'),
(85520, 3416374272, 3416374527, 'PH', 'PHL', 'الفلبين'),
(85521, 3416374528, 3416374783, 'IN', 'IND', 'الهند'),
(85522, 3416374784, 3416375295, 'ID', 'IDN', 'إندونيسيا'),
(85523, 3416375296, 3416383487, 'CN', 'CHN', 'الصين'),
(85524, 3416383488, 3416391679, 'HK', 'HKG', 'هونغ كونغ'),
(85525, 3416391680, 3416457215, 'VN', 'VNM', 'فييتنام'),
(85526, 3416457216, 3416460799, 'JP', 'JPN', 'اليابان'),
(85527, 3416460800, 3416461055, 'SG', 'SGP', 'سنغافورة'),
(85528, 3416461056, 3416465663, 'JP', 'JPN', 'اليابان'),
(85529, 3416465664, 3416465919, 'HK', 'HKG', 'هونغ كونغ'),
(85530, 3416465920, 3416471039, 'JP', 'JPN', 'اليابان'),
(85531, 3416471040, 3416471295, 'NZ', 'NZL', 'نيوزيلاندا'),
(85532, 3416471296, 3416473727, 'JP', 'JPN', 'اليابان'),
(85533, 3416473728, 3416473855, 'PH', 'PHL', 'الفلبين'),
(85534, 3416473856, 3416474111, 'JP', 'JPN', 'اليابان'),
(85535, 3416474112, 3416474239, 'ID', 'IDN', 'إندونيسيا'),
(85536, 3416474240, 3416474615, 'JP', 'JPN', 'اليابان'),
(85537, 3416474616, 3416474623, 'LK', 'LKA', 'سيريلانكا'),
(85538, 3416474624, 3416474639, 'JP', 'JPN', 'اليابان'),
(85539, 3416474640, 3416474671, 'NZ', 'NZL', 'نيوزيلاندا'),
(85540, 3416474672, 3416474687, 'JP', 'JPN', 'اليابان'),
(85541, 3416474688, 3416474740, 'NZ', 'NZL', 'نيوزيلاندا'),
(85542, 3416474741, 3416474743, 'JP', 'JPN', 'اليابان'),
(85543, 3416474744, 3416474759, 'NZ', 'NZL', 'نيوزيلاندا'),
(85544, 3416474760, 3416474775, 'JP', 'JPN', 'اليابان'),
(85545, 3416474776, 3416474783, 'NZ', 'NZL', 'نيوزيلاندا'),
(85546, 3416474784, 3416474847, 'JP', 'JPN', 'اليابان'),
(85547, 3416474848, 3416474855, 'NZ', 'NZL', 'نيوزيلاندا'),
(85548, 3416474856, 3416475199, 'JP', 'JPN', 'اليابان'),
(85549, 3416475200, 3416475263, 'NZ', 'NZL', 'نيوزيلاندا'),
(85550, 3416475264, 3416475455, 'JP', 'JPN', 'اليابان'),
(85551, 3416475456, 3416475487, 'NZ', 'NZL', 'نيوزيلاندا'),
(85552, 3416475488, 3416475615, 'JP', 'JPN', 'اليابان'),
(85553, 3416475616, 3416475647, 'NZ', 'NZL', 'نيوزيلاندا'),
(85554, 3416475648, 3416475903, 'TW', 'TWN', 'تايوان'),
(85555, 3416475904, 3416475919, 'SG', 'SGP', 'سنغافورة'),
(85556, 3416475920, 3416475951, 'JP', 'JPN', 'اليابان'),
(85557, 3416475952, 3416475959, 'SG', 'SGP', 'سنغافورة'),
(85558, 3416475960, 3416476047, 'JP', 'JPN', 'اليابان'),
(85559, 3416476048, 3416476063, 'SG', 'SGP', 'سنغافورة'),
(85560, 3416476064, 3416476071, 'JP', 'JPN', 'اليابان'),
(85561, 3416476072, 3416476079, 'SG', 'SGP', 'سنغافورة'),
(85562, 3416476080, 3416476111, 'JP', 'JPN', 'اليابان'),
(85563, 3416476112, 3416476127, 'SG', 'SGP', 'سنغافورة'),
(85564, 3416476128, 3416477199, 'JP', 'JPN', 'اليابان'),
(85565, 3416477200, 3416477207, 'MY', 'MYS', 'ماليزيا'),
(85566, 3416477208, 3416477215, 'JP', 'JPN', 'اليابان'),
(85567, 3416477216, 3416477239, 'MY', 'MYS', 'ماليزيا'),
(85568, 3416477240, 3416477247, 'SG', 'SGP', 'سنغافورة'),
(85569, 3416477248, 3416477263, 'MY', 'MYS', 'ماليزيا'),
(85570, 3416477264, 3416477759, 'JP', 'JPN', 'اليابان'),
(85571, 3416477760, 3416477823, 'SG', 'SGP', 'سنغافورة'),
(85572, 3416477824, 3416477887, 'JP', 'JPN', 'اليابان'),
(85573, 3416477888, 3416477951, 'SG', 'SGP', 'سنغافورة'),
(85574, 3416477952, 3416477983, 'ID', 'IDN', 'إندونيسيا'),
(85575, 3416477984, 3416478143, 'JP', 'JPN', 'اليابان'),
(85576, 3416478144, 3416478175, 'ID', 'IDN', 'إندونيسيا'),
(85577, 3416478176, 3416478239, 'JP', 'JPN', 'اليابان'),
(85578, 3416478240, 3416478271, 'HK', 'HKG', 'هونغ كونغ'),
(85579, 3416478272, 3416478303, 'JP', 'JPN', 'اليابان'),
(85580, 3416478304, 3416478335, 'HK', 'HKG', 'هونغ كونغ'),
(85581, 3416478336, 3416478463, 'JP', 'JPN', 'اليابان'),
(85582, 3416478464, 3416478479, 'TW', 'TWN', 'تايوان'),
(85583, 3416478480, 3416478527, 'JP', 'JPN', 'اليابان'),
(85584, 3416478528, 3416478543, 'TW', 'TWN', 'تايوان'),
(85585, 3416478544, 3416478655, 'JP', 'JPN', 'اليابان'),
(85586, 3416478656, 3416478671, 'HK', 'HKG', 'هونغ كونغ'),
(85587, 3416478672, 3416478687, 'TW', 'TWN', 'تايوان'),
(85588, 3416478688, 3416478783, 'JP', 'JPN', 'اليابان'),
(85589, 3416478784, 3416478799, 'KR', 'KOR', 'جمهورية كوريا'),
(85590, 3416478800, 3416478847, 'JP', 'JPN', 'اليابان'),
(85591, 3416478848, 3416478911, 'TW', 'TWN', 'تايوان'),
(85592, 3416478912, 3416478927, 'KR', 'KOR', 'جمهورية كوريا'),
(85593, 3416478928, 3416480255, 'JP', 'JPN', 'اليابان'),
(85594, 3416480256, 3416480383, 'TW', 'TWN', 'تايوان'),
(85595, 3416480384, 3416481559, 'JP', 'JPN', 'اليابان'),
(85596, 3416481560, 3416481567, 'IN', 'IND', 'الهند'),
(85597, 3416481568, 3416481807, 'JP', 'JPN', 'اليابان'),
(85598, 3416481808, 3416481815, 'HK', 'HKG', 'هونغ كونغ'),
(85599, 3416481816, 3416481855, 'JP', 'JPN', 'اليابان'),
(85600, 3416481856, 3416481871, 'HK', 'HKG', 'هونغ كونغ'),
(85601, 3416481872, 3416481887, 'JP', 'JPN', 'اليابان'),
(85602, 3416481888, 3416481919, 'HK', 'HKG', 'هونغ كونغ'),
(85603, 3416481920, 3416482047, 'JP', 'JPN', 'اليابان'),
(85604, 3416482048, 3416482079, 'SG', 'SGP', 'سنغافورة'),
(85605, 3416482080, 3416482159, 'JP', 'JPN', 'اليابان'),
(85606, 3416482160, 3416482191, 'SG', 'SGP', 'سنغافورة'),
(85607, 3416482192, 3416482255, 'JP', 'JPN', 'اليابان'),
(85608, 3416482256, 3416482287, 'SG', 'SGP', 'سنغافورة'),
(85609, 3416482288, 3416482719, 'JP', 'JPN', 'اليابان'),
(85610, 3416482720, 3416482783, 'SG', 'SGP', 'سنغافورة'),
(85611, 3416482784, 3416482815, 'HK', 'HKG', 'هونغ كونغ'),
(85612, 3416482816, 3416482879, 'KR', 'KOR', 'جمهورية كوريا'),
(85613, 3416482880, 3416483167, 'JP', 'JPN', 'اليابان'),
(85614, 3416483168, 3416483199, 'SG', 'SGP', 'سنغافورة'),
(85615, 3416483200, 3416483231, 'JP', 'JPN', 'اليابان'),
(85616, 3416483232, 3416483295, 'SG', 'SGP', 'سنغافورة'),
(85617, 3416483296, 3416483319, 'JP', 'JPN', 'اليابان'),
(85618, 3416483320, 3416483327, 'SG', 'SGP', 'سنغافورة'),
(85619, 3416483328, 3416483343, 'JP', 'JPN', 'اليابان'),
(85620, 3416483344, 3416483391, 'HK', 'HKG', 'هونغ كونغ'),
(85621, 3416483392, 3416483407, 'JP', 'JPN', 'اليابان'),
(85622, 3416483408, 3416483423, 'HK', 'HKG', 'هونغ كونغ'),
(85623, 3416483424, 3416483567, 'JP', 'JPN', 'اليابان'),
(85624, 3416483568, 3416483583, 'HK', 'HKG', 'هونغ كونغ'),
(85625, 3416483584, 3416483663, 'SG', 'SGP', 'سنغافورة'),
(85626, 3416483664, 3416483671, 'JP', 'JPN', 'اليابان'),
(85627, 3416483672, 3416483703, 'SG', 'SGP', 'سنغافورة'),
(85628, 3416483704, 3416483863, 'JP', 'JPN', 'اليابان'),
(85629, 3416483864, 3416483871, 'KR', 'KOR', 'جمهورية كوريا'),
(85630, 3416483872, 3416483903, 'JP', 'JPN', 'اليابان'),
(85631, 3416483904, 3416483911, 'KR', 'KOR', 'جمهورية كوريا'),
(85632, 3416483912, 3416483919, 'HK', 'HKG', 'هونغ كونغ'),
(85633, 3416483920, 3416483943, 'JP', 'JPN', 'اليابان'),
(85634, 3416483944, 3416483951, 'KR', 'KOR', 'جمهورية كوريا'),
(85635, 3416483952, 3416483975, 'JP', 'JPN', 'اليابان'),
(85636, 3416483976, 3416483983, 'HK', 'HKG', 'هونغ كونغ'),
(85637, 3416483984, 3416483991, 'JP', 'JPN', 'اليابان'),
(85638, 3416483992, 3416484023, 'HK', 'HKG', 'هونغ كونغ'),
(85639, 3416484024, 3416484039, 'JP', 'JPN', 'اليابان'),
(85640, 3416484040, 3416484055, 'KR', 'KOR', 'جمهورية كوريا'),
(85641, 3416484056, 3416484143, 'JP', 'JPN', 'اليابان'),
(85642, 3416484144, 3416484159, 'MY', 'MYS', 'ماليزيا'),
(85643, 3416484160, 3416484175, 'JP', 'JPN', 'اليابان'),
(85644, 3416484176, 3416484183, 'MY', 'MYS', 'ماليزيا'),
(85645, 3416484184, 3416484191, 'JP', 'JPN', 'اليابان'),
(85646, 3416484192, 3416484223, 'MY', 'MYS', 'ماليزيا'),
(85647, 3416484224, 3416484319, 'JP', 'JPN', 'اليابان'),
(85648, 3416484320, 3416484335, 'HK', 'HKG', 'هونغ كونغ'),
(85649, 3416484336, 3416484351, 'JP', 'JPN', 'اليابان'),
(85650, 3416484352, 3416484407, 'SG', 'SGP', 'سنغافورة'),
(85651, 3416484408, 3416484447, 'JP', 'JPN', 'اليابان'),
(85652, 3416484448, 3416484607, 'SG', 'SGP', 'سنغافورة'),
(85653, 3416484608, 3416484671, 'JP', 'JPN', 'اليابان'),
(85654, 3416484672, 3416484735, 'HK', 'HKG', 'هونغ كونغ'),
(85655, 3416484736, 3416485823, 'JP', 'JPN', 'اليابان'),
(85656, 3416485824, 3416485903, 'SG', 'SGP', 'سنغافورة'),
(85657, 3416485904, 3416485911, 'JP', 'JPN', 'اليابان'),
(85658, 3416485912, 3416485927, 'SG', 'SGP', 'سنغافورة'),
(85659, 3416485928, 3416485935, 'JP', 'JPN', 'اليابان'),
(85660, 3416485936, 3416485943, 'SG', 'SGP', 'سنغافورة'),
(85661, 3416485944, 3416485967, 'JP', 'JPN', 'اليابان'),
(85662, 3416485968, 3416485975, 'SG', 'SGP', 'سنغافورة'),
(85663, 3416485976, 3416486039, 'JP', 'JPN', 'اليابان'),
(85664, 3416486040, 3416486047, 'SG', 'SGP', 'سنغافورة'),
(85665, 3416486048, 3416486063, 'JP', 'JPN', 'اليابان'),
(85666, 3416486064, 3416486103, 'SG', 'SGP', 'سنغافورة'),
(85667, 3416486104, 3416486111, 'JP', 'JPN', 'اليابان'),
(85668, 3416486112, 3416486119, 'SG', 'SGP', 'سنغافورة'),
(85669, 3416486120, 3416486127, 'HK', 'HKG', 'هونغ كونغ'),
(85670, 3416486128, 3416486143, 'SG', 'SGP', 'سنغافورة'),
(85671, 3416486144, 3416487167, 'JP', 'JPN', 'اليابان'),
(85672, 3416487168, 3416487175, 'HK', 'HKG', 'هونغ كونغ'),
(85673, 3416487176, 3416487183, 'JP', 'JPN', 'اليابان'),
(85674, 3416487184, 3416487191, 'HK', 'HKG', 'هونغ كونغ'),
(85675, 3416487192, 3416487255, 'JP', 'JPN', 'اليابان'),
(85676, 3416487256, 3416487263, 'HK', 'HKG', 'هونغ كونغ'),
(85677, 3416487264, 3416487303, 'JP', 'JPN', 'اليابان'),
(85678, 3416487304, 3416487343, 'HK', 'HKG', 'هونغ كونغ'),
(85679, 3416487344, 3416487359, 'JP', 'JPN', 'اليابان'),
(85680, 3416487360, 3416487383, 'HK', 'HKG', 'هونغ كونغ'),
(85681, 3416487384, 3416487391, 'JP', 'JPN', 'اليابان'),
(85682, 3416487392, 3416487407, 'HK', 'HKG', 'هونغ كونغ'),
(85683, 3416487408, 3416487423, 'JP', 'JPN', 'اليابان'),
(85684, 3416487424, 3416487487, 'PH', 'PHL', 'الفلبين'),
(85685, 3416487488, 3416488578, 'JP', 'JPN', 'اليابان'),
(85686, 3416488579, 3416488579, 'TW', 'TWN', 'تايوان'),
(85687, 3416488580, 3416488580, 'SG', 'SGP', 'سنغافورة'),
(85688, 3416488581, 3416488581, 'JP', 'JPN', 'اليابان'),
(85689, 3416488582, 3416488582, 'HK', 'HKG', 'هونغ كونغ'),
(85690, 3416488583, 3416489983, 'JP', 'JPN', 'اليابان'),
(85691, 3416489984, 3416506367, 'AU', 'AUS', 'أستراليا'),
(85692, 3416506368, 3416514559, 'TW', 'TWN', 'تايوان'),
(85693, 3416514560, 3416522751, 'IN', 'IND', 'الهند'),
(85694, 3416522752, 3416588287, 'AU', 'AUS', 'أستراليا'),
(85695, 3416588288, 3416653823, 'JP', 'JPN', 'اليابان'),
(85696, 3416653824, 3416656583, 'AU', 'AUS', 'أستراليا'),
(85697, 3416656584, 3416656591, 'IN', 'IND', 'الهند'),
(85698, 3416656592, 3416667135, 'AU', 'AUS', 'أستراليا'),
(85699, 3416667136, 3416668159, 'US', 'USA', 'الولايات المتحدة'),
(85700, 3416668160, 3416684175, 'AU', 'AUS', 'أستراليا'),
(85701, 3416684176, 3416684183, 'NZ', 'NZL', 'نيوزيلاندا'),
(85702, 3416684184, 3416686591, 'AU', 'AUS', 'أستراليا'),
(85703, 3416686592, 3416687627, 'SG', 'SGP', 'سنغافورة'),
(85704, 3416687628, 3416687631, 'HK', 'HKG', 'هونغ كونغ'),
(85705, 3416687632, 3416687635, 'CH', 'CHE', 'سويسرا'),
(85706, 3416687636, 3416687639, 'JP', 'JPN', 'اليابان'),
(85707, 3416687640, 3416694783, 'SG', 'SGP', 'سنغافورة'),
(85708, 3416694784, 3416702975, 'CN', 'CHN', 'الصين'),
(85709, 3416702976, 3416707071, 'ID', 'IDN', 'إندونيسيا'),
(85710, 3416707072, 3416709119, 'KR', 'KOR', 'جمهورية كوريا'),
(85711, 3416709120, 3416709375, 'AU', 'AUS', 'أستراليا'),
(85712, 3416709376, 3416709631, 'ID', 'IDN', 'إندونيسيا'),
(85713, 3416709632, 3416710143, 'AU', 'AUS', 'أستراليا'),
(85714, 3416710144, 3416711167, 'HK', 'HKG', 'هونغ كونغ'),
(85715, 3416711168, 3416719359, 'AU', 'AUS', 'أستراليا'),
(85716, 3416719360, 3416727551, 'PH', 'PHL', 'الفلبين'),
(85717, 3416727552, 3416735743, 'JP', 'JPN', 'اليابان'),
(85718, 3416735744, 3416752127, 'PH', 'PHL', 'الفلبين'),
(85719, 3416752128, 3416784895, 'NZ', 'NZL', 'نيوزيلاندا'),
(85720, 3416784896, 3416801279, 'AU', 'AUS', 'أستراليا'),
(85721, 3416801280, 3416817663, 'JP', 'JPN', 'اليابان'),
(85722, 3416817664, 3416850431, 'HK', 'HKG', 'هونغ كونغ'),
(85723, 3416850432, 3416851455, 'PH', 'PHL', 'الفلبين'),
(85724, 3416851456, 3416851967, 'KR', 'KOR', 'جمهورية كوريا'),
(85725, 3416851968, 3416852479, 'SG', 'SGP', 'سنغافورة'),
(85726, 3416852480, 3416854527, 'JP', 'JPN', 'اليابان'),
(85727, 3416854528, 3416856575, 'AU', 'AUS', 'أستراليا'),
(85728, 3416856576, 3416858623, 'BD', 'BGD', 'بنغالاديش'),
(85729, 3416858624, 3416862719, 'HK', 'HKG', 'هونغ كونغ'),
(85730, 3416862720, 3416864767, 'MN', 'MNG', 'منغوليا'),
(85731, 3416864768, 3416864895, 'JP', 'JPN', 'اليابان'),
(85732, 3416864896, 3416865023, 'SG', 'SGP', 'سنغافورة'),
(85733, 3416865024, 3416865151, 'HK', 'HKG', 'هونغ كونغ'),
(85734, 3416865152, 3416865279, 'SG', 'SGP', 'سنغافورة'),
(85735, 3416865280, 3416865287, 'JP', 'JPN', 'اليابان'),
(85736, 3416865288, 3416865407, 'AU', 'AUS', 'أستراليا'),
(85737, 3416865408, 3416865599, 'JP', 'JPN', 'اليابان'),
(85738, 3416865600, 3416865607, 'HK', 'HKG', 'هونغ كونغ'),
(85739, 3416865608, 3416865655, 'AU', 'AUS', 'أستراليا'),
(85740, 3416865656, 3416865791, 'JP', 'JPN', 'اليابان'),
(85741, 3416865792, 3416866055, 'HK', 'HKG', 'هونغ كونغ'),
(85742, 3416866056, 3416866071, 'SG', 'SGP', 'سنغافورة'),
(85743, 3416866072, 3416866303, 'AU', 'AUS', 'أستراليا'),
(85744, 3416866304, 3416866559, 'HK', 'HKG', 'هونغ كونغ'),
(85745, 3416866560, 3416883199, 'SG', 'SGP', 'سنغافورة'),
(85746, 3416883200, 3416915967, 'HK', 'HKG', 'هونغ كونغ'),
(85747, 3416915968, 3416920063, 'AU', 'AUS', 'أستراليا'),
(85748, 3416920064, 3416921087, 'TH', 'THA', 'تايلند'),
(85749, 3416921088, 3416922111, 'PH', 'PHL', 'الفلبين'),
(85750, 3416922112, 3416922367, 'AU', 'AUS', 'أستراليا'),
(85751, 3416922368, 3416922623, 'IN', 'IND', 'الهند'),
(85752, 3416922624, 3416923135, 'VN', 'VNM', 'فييتنام'),
(85753, 3416923136, 3416924159, 'AU', 'AUS', 'أستراليا'),
(85754, 3416924160, 3416928255, 'JP', 'JPN', 'اليابان'),
(85755, 3416928256, 3416928511, 'IN', 'IND', 'الهند'),
(85756, 3416928512, 3416928767, 'HK', 'HKG', 'هونغ كونغ'),
(85757, 3416928768, 3416929279, 'TH', 'THA', 'تايلند'),
(85758, 3416929280, 3416930303, 'JP', 'JPN', 'اليابان'),
(85759, 3416930304, 3416930559, 'NZ', 'NZL', 'نيوزيلاندا'),
(85760, 3416930560, 3416931327, 'AU', 'AUS', 'أستراليا'),
(85761, 3416931328, 3416932351, 'IN', 'IND', 'الهند'),
(85762, 3416932352, 3416936447, 'PK', 'PAK', 'باكستان'),
(85763, 3416936448, 3416938495, 'AU', 'AUS', 'أستراليا'),
(85764, 3416938496, 3416938751, 'NZ', 'NZL', 'نيوزيلاندا'),
(85765, 3416938752, 3416939007, 'AU', 'AUS', 'أستراليا'),
(85766, 3416939008, 3416939519, 'HK', 'HKG', 'هونغ كونغ'),
(85767, 3416939520, 3416940543, 'AU', 'AUS', 'أستراليا'),
(85768, 3416940544, 3416948735, 'KR', 'KOR', 'جمهورية كوريا'),
(85769, 3416948736, 3416981503, 'TH', 'THA', 'تايلند'),
(85770, 3416981504, 3416982527, 'PH', 'PHL', 'الفلبين'),
(85771, 3416982528, 3416982783, 'NZ', 'NZL', 'نيوزيلاندا'),
(85772, 3416982784, 3416983039, 'AU', 'AUS', 'أستراليا'),
(85773, 3416983040, 3416983551, 'PH', 'PHL', 'الفلبين'),
(85774, 3416983552, 3416985599, 'JP', 'JPN', 'اليابان'),
(85775, 3416985600, 3416989695, 'VN', 'VNM', 'فييتنام'),
(85776, 3416989696, 3416997887, 'NZ', 'NZL', 'نيوزيلاندا'),
(85777, 3416997888, 3417014271, 'AU', 'AUS', 'أستراليا'),
(85778, 3417014272, 3417022463, 'JP', 'JPN', 'اليابان'),
(85779, 3417022464, 3417030655, 'KR', 'KOR', 'جمهورية كوريا'),
(85780, 3417030656, 3417034751, 'AU', 'AUS', 'أستراليا'),
(85781, 3417034752, 3417035007, 'NZ', 'NZL', 'نيوزيلاندا'),
(85782, 3417035008, 3417035775, 'IN', 'IND', 'الهند'),
(85783, 3417035776, 3417036799, 'JP', 'JPN', 'اليابان'),
(85784, 3417036800, 3417037823, 'ID', 'IDN', 'إندونيسيا'),
(85785, 3417037824, 3417038079, 'AU', 'AUS', 'أستراليا'),
(85786, 3417038080, 3417038335, 'ID', 'IDN', 'إندونيسيا'),
(85787, 3417038336, 3417038591, 'IN', 'IND', 'الهند'),
(85788, 3417038592, 3417038847, 'NZ', 'NZL', 'نيوزيلاندا'),
(85789, 3417038848, 3417042943, 'CN', 'CHN', 'الصين'),
(85790, 3417042944, 3417044991, 'IN', 'IND', 'الهند'),
(85791, 3417044992, 3417047039, 'AU', 'AUS', 'أستراليا'),
(85792, 3417047040, 3417055231, 'PH', 'PHL', 'الفلبين'),
(85793, 3417055232, 3417112575, 'TH', 'THA', 'تايلند'),
(85794, 3417112576, 3417128959, 'AU', 'AUS', 'أستراليا'),
(85795, 3417128960, 3417135103, 'JP', 'JPN', 'اليابان'),
(85796, 3417135104, 3417137151, 'ID', 'IDN', 'إندونيسيا'),
(85797, 3417137152, 3417145343, 'KR', 'KOR', 'جمهورية كوريا'),
(85798, 3417145344, 3417178111, 'NZ', 'NZL', 'نيوزيلاندا'),
(85799, 3417178112, 3417179135, 'PH', 'PHL', 'الفلبين'),
(85800, 3417179136, 3417179391, 'AU', 'AUS', 'أستراليا'),
(85801, 3417179392, 3417179647, 'ID', 'IDN', 'إندونيسيا'),
(85802, 3417179648, 3417179903, 'IN', 'IND', 'الهند'),
(85803, 3417179904, 3417180159, 'CN', 'CHN', 'الصين'),
(85804, 3417180160, 3417182207, 'ID', 'IDN', 'إندونيسيا'),
(85805, 3417182208, 3417184767, 'AU', 'AUS', 'أستراليا'),
(85806, 3417184768, 3417185023, 'NZ', 'NZL', 'نيوزيلاندا'),
(85807, 3417185024, 3417185279, 'AF', 'AFG', 'أفغانستان'),
(85808, 3417185280, 3417185791, 'SG', 'SGP', 'سنغافورة'),
(85809, 3417185792, 3417186303, 'NZ', 'NZL', 'نيوزيلاندا'),
(85810, 3417186304, 3417194495, 'HK', 'HKG', 'هونغ كونغ'),
(85811, 3417194496, 3417198591, 'JP', 'JPN', 'اليابان'),
(85812, 3417198592, 3417200639, 'SG', 'SGP', 'سنغافورة'),
(85813, 3417200640, 3417202687, 'JP', 'JPN', 'اليابان'),
(85814, 3417202688, 3417210879, 'CN', 'CHN', 'الصين'),
(85815, 3417210880, 3417227263, 'AU', 'AUS', 'أستراليا'),
(85816, 3417227264, 3417243647, 'JP', 'JPN', 'اليابان'),
(85817, 3417243648, 3417244671, 'PH', 'PHL', 'الفلبين'),
(85818, 3417244672, 3417245695, 'IN', 'IND', 'الهند'),
(85819, 3417245696, 3417247743, 'BT', 'BTN', 'بوتان'),
(85820, 3417247744, 3417251839, 'JP', 'JPN', 'اليابان'),
(85821, 3417251840, 3417260031, 'KR', 'KOR', 'جمهورية كوريا'),
(85822, 3417260032, 3417264127, 'PK', 'PAK', 'باكستان'),
(85823, 3417264128, 3417268223, 'JP', 'JPN', 'اليابان'),
(85824, 3417268224, 3417272319, 'PK', 'PAK', 'باكستان'),
(85825, 3417272320, 3417274367, 'NZ', 'NZL', 'نيوزيلاندا'),
(85826, 3417274368, 3417275391, 'AU', 'AUS', 'أستراليا'),
(85827, 3417275392, 3417276415, 'PH', 'PHL', 'الفلبين'),
(85828, 3417276416, 3417284607, 'CN', 'CHN', 'الصين'),
(85829, 3417284608, 3417288703, 'SG', 'SGP', 'سنغافورة'),
(85830, 3417288704, 3417289215, 'IN', 'IND', 'الهند'),
(85831, 3417289216, 3417289727, 'AU', 'AUS', 'أستراليا'),
(85832, 3417289728, 3417291263, 'IN', 'IND', 'الهند'),
(85833, 3417291264, 3417291775, 'AU', 'AUS', 'أستراليا'),
(85834, 3417291776, 3417292799, 'KR', 'KOR', 'جمهورية كوريا'),
(85835, 3417292800, 3417309183, 'CN', 'CHN', 'الصين'),
(85836, 3417309184, 3417337855, 'AU', 'AUS', 'أستراليا'),
(85837, 3417337856, 3417338367, 'IN', 'IND', 'الهند'),
(85838, 3417338368, 3417338879, 'HK', 'HKG', 'هونغ كونغ'),
(85839, 3417338880, 3417339903, 'PH', 'PHL', 'الفلبين'),
(85840, 3417339904, 3417340415, 'AU', 'AUS', 'أستراليا'),
(85841, 3417340416, 3417341951, 'NZ', 'NZL', 'نيوزيلاندا'),
(85842, 3417341952, 3417346047, 'CA', 'CAN', 'كندا'),
(85843, 3417346048, 3417348095, 'MY', 'MYS', 'ماليزيا'),
(85844, 3417348096, 3417348351, 'AU', 'AUS', 'أستراليا'),
(85845, 3417348352, 3417348607, 'IN', 'IND', 'الهند'),
(85846, 3417348608, 3417349119, 'NZ', 'NZL', 'نيوزيلاندا'),
(85847, 3417349120, 3417349631, 'IN', 'IND', 'الهند'),
(85848, 3417349632, 3417350143, 'AU', 'AUS', 'أستراليا'),
(85849, 3417350144, 3417352191, 'VN', 'VNM', 'فييتنام'),
(85850, 3417352192, 3417354239, 'CN', 'CHN', 'الصين'),
(85851, 3417354240, 3417356287, 'ID', 'IDN', 'إندونيسيا'),
(85852, 3417356288, 3417357311, 'AU', 'AUS', 'أستراليا'),
(85853, 3417357312, 3417357567, 'NZ', 'NZL', 'نيوزيلاندا'),
(85854, 3417357568, 3417357823, 'AU', 'AUS', 'أستراليا'),
(85855, 3417357824, 3417358335, 'PK', 'PAK', 'باكستان'),
(85856, 3417358336, 3417374719, 'HK', 'HKG', 'هونغ كونغ'),
(85857, 3417374720, 3417440255, 'PH', 'PHL', 'الفلبين'),
(85858, 3417440256, 3417706095, 'JP', 'JPN', 'اليابان'),
(85859, 3417706096, 3417706099, 'HK', 'HKG', 'هونغ كونغ'),
(85860, 3417706100, 3417716655, 'JP', 'JPN', 'اليابان'),
(85861, 3417716656, 3417716659, 'HK', 'HKG', 'هونغ كونغ'),
(85862, 3417716660, 3417833471, 'JP', 'JPN', 'اليابان'),
(85863, 3417833472, 3417849855, 'NZ', 'NZL', 'نيوزيلاندا'),
(85864, 3417849856, 3417853951, 'AU', 'AUS', 'أستراليا'),
(85865, 3417853952, 3417858047, 'CN', 'CHN', 'الصين'),
(85866, 3417858048, 3417866239, 'JP', 'JPN', 'اليابان'),
(85867, 3417866240, 3417915391, 'HK', 'HKG', 'هونغ كونغ'),
(85868, 3417915392, 3417939967, 'TH', 'THA', 'تايلند'),
(85869, 3417939968, 3417946111, 'PF', 'PYF', 'بولينيزيا الفرنسية'),
(85870, 3417946112, 3417947135, 'AU', 'AUS', 'أستراليا'),
(85871, 3417947136, 3417947391, 'IN', 'IND', 'الهند'),
(85872, 3417947392, 3417947647, 'HK', 'HKG', 'هونغ كونغ'),
(85873, 3417947648, 3417947903, 'AU', 'AUS', 'أستراليا'),
(85874, 3417947904, 3417948159, 'IN', 'IND', 'الهند'),
(85875, 3417948160, 3417964543, 'AU', 'AUS', 'أستراليا'),
(85876, 3417964544, 3418030079, 'HK', 'HKG', 'هونغ كونغ'),
(85877, 3418030080, 3418062847, 'TW', 'TWN', 'تايوان'),
(85878, 3418062848, 3418063615, 'US', 'USA', 'الولايات المتحدة'),
(85879, 3418063616, 3418063679, 'IN', 'IND', 'الهند'),
(85880, 3418063680, 3418063711, 'US', 'USA', 'الولايات المتحدة'),
(85881, 3418063712, 3418063775, 'IN', 'IND', 'الهند'),
(85882, 3418063776, 3418063807, 'US', 'USA', 'الولايات المتحدة'),
(85883, 3418063808, 3418063839, 'IN', 'IND', 'الهند'),
(85884, 3418063840, 3418063871, 'US', 'USA', 'الولايات المتحدة'),
(85885, 3418063872, 3418064127, 'IN', 'IND', 'الهند'),
(85886, 3418064128, 3418064447, 'US', 'USA', 'الولايات المتحدة'),
(85887, 3418064448, 3418064513, 'IN', 'IND', 'الهند'),
(85888, 3418064514, 3418065023, 'US', 'USA', 'الولايات المتحدة'),
(85889, 3418065024, 3418065039, 'IN', 'IND', 'الهند'),
(85890, 3418065040, 3418066527, 'US', 'USA', 'الولايات المتحدة'),
(85891, 3418066528, 3418066591, 'IN', 'IND', 'الهند'),
(85892, 3418066592, 3418066703, 'US', 'USA', 'الولايات المتحدة'),
(85893, 3418066704, 3418066719, 'IN', 'IND', 'الهند'),
(85894, 3418066720, 3418067071, 'US', 'USA', 'الولايات المتحدة'),
(85895, 3418067072, 3418067135, 'SG', 'SGP', 'سنغافورة'),
(85896, 3418067136, 3418067967, 'US', 'USA', 'الولايات المتحدة'),
(85897, 3418067968, 3418068223, 'IN', 'IND', 'الهند'),
(85898, 3418068224, 3418068479, 'US', 'USA', 'الولايات المتحدة'),
(85899, 3418068480, 3418068607, 'IN', 'IND', 'الهند'),
(85900, 3418068608, 3418069119, 'US', 'USA', 'الولايات المتحدة'),
(85901, 3418069120, 3418069135, 'IN', 'IND', 'الهند'),
(85902, 3418069136, 3418071039, 'US', 'USA', 'الولايات المتحدة'),
(85903, 3418071040, 3418079231, 'CN', 'CHN', 'الصين'),
(85904, 3418079232, 3418095615, 'IN', 'IND', 'الهند'),
(85905, 3418095616, 3418111999, 'TH', 'THA', 'تايلند'),
(85906, 3418112000, 3418128383, 'HK', 'HKG', 'هونغ كونغ'),
(85907, 3418128384, 3418136575, 'AU', 'AUS', 'أستراليا'),
(85908, 3418136576, 3418144767, 'BD', 'BGD', 'بنغالاديش'),
(85909, 3418144768, 3418148863, 'TW', 'TWN', 'تايوان'),
(85910, 3418148864, 3418150911, 'JP', 'JPN', 'اليابان'),
(85911, 3418150912, 3418152959, 'AU', 'AUS', 'أستراليا'),
(85912, 3418152960, 3418155007, 'IN', 'IND', 'الهند'),
(85913, 3418155008, 3418157055, 'MY', 'MYS', 'ماليزيا'),
(85914, 3418157056, 3418161663, 'BD', 'BGD', 'بنغالاديش'),
(85915, 3418161664, 3418162431, 'AU', 'AUS', 'أستراليا'),
(85916, 3418162432, 3418162687, 'IN', 'IND', 'الهند'),
(85917, 3418162688, 3418163199, 'AU', 'AUS', 'أستراليا'),
(85918, 3418163200, 3418165247, 'PH', 'PHL', 'الفلبين'),
(85919, 3418165248, 3418167295, 'MY', 'MYS', 'ماليزيا'),
(85920, 3418167296, 3418167551, 'IN', 'IND', 'الهند'),
(85921, 3418167552, 3418167807, 'AU', 'AUS', 'أستراليا'),
(85922, 3418167808, 3418168319, 'HK', 'HKG', 'هونغ كونغ'),
(85923, 3418168320, 3418169343, 'VN', 'VNM', 'فييتنام'),
(85924, 3418169344, 3418177535, 'JP', 'JPN', 'اليابان'),
(85925, 3418177536, 3418181631, 'LK', 'LKA', 'سيريلانكا'),
(85926, 3418181632, 3418183679, 'AU', 'AUS', 'أستراليا'),
(85927, 3418183680, 3418184191, 'ID', 'IDN', 'إندونيسيا'),
(85928, 3418184192, 3418184959, 'IN', 'IND', 'الهند'),
(85929, 3418184960, 3418190847, 'AU', 'AUS', 'أستراليا'),
(85930, 3418190848, 3418191871, 'TH', 'THA', 'تايلند'),
(85931, 3418191872, 3418192895, 'ID', 'IDN', 'إندونيسيا'),
(85932, 3418192896, 3418193919, 'AU', 'AUS', 'أستراليا'),
(85933, 3418193920, 3418202111, 'KH', 'KHM', 'كامبوديا'),
(85934, 3418202112, 3418206207, 'HK', 'HKG', 'هونغ كونغ'),
(85935, 3418206208, 3418208255, 'IN', 'IND', 'الهند'),
(85936, 3418208256, 3418210303, 'LK', 'LKA', 'سيريلانكا'),
(85937, 3418210304, 3418218495, 'AU', 'AUS', 'أستراليا'),
(85938, 3418218496, 3418227711, 'BD', 'BGD', 'بنغالاديش'),
(85939, 3418227712, 3418228735, 'AU', 'AUS', 'أستراليا'),
(85940, 3418228736, 3418230783, 'BD', 'BGD', 'بنغالاديش'),
(85941, 3418230784, 3418232831, 'TW', 'TWN', 'تايوان'),
(85942, 3418232832, 3418233343, 'AU', 'AUS', 'أستراليا'),
(85943, 3418233344, 3418233855, 'KR', 'KOR', 'جمهورية كوريا'),
(85944, 3418233856, 3418234879, 'JP', 'JPN', 'اليابان'),
(85945, 3418234880, 3418235903, 'BD', 'BGD', 'بنغالاديش'),
(85946, 3418235904, 3418236415, 'ID', 'IDN', 'إندونيسيا'),
(85947, 3418236416, 3418236927, 'AU', 'AUS', 'أستراليا'),
(85948, 3418236928, 3418241023, 'ID', 'IDN', 'إندونيسيا'),
(85949, 3418241024, 3418243071, 'JP', 'JPN', 'اليابان'),
(85950, 3418243072, 3418246015, 'PH', 'PHL', 'الفلبين'),
(85951, 3418246016, 3418246023, 'SG', 'SGP', 'سنغافورة'),
(85952, 3418246024, 3418251263, 'PH', 'PHL', 'الفلبين'),
(85953, 3418251264, 3418255359, 'CN', 'CHN', 'الصين'),
(85954, 3418255360, 3418257407, 'ID', 'IDN', 'إندونيسيا'),
(85955, 3418257408, 3418259367, 'HK', 'HKG', 'هونغ كونغ'),
(85956, 3418259368, 3418259373, 'SG', 'SGP', 'سنغافورة'),
(85957, 3418259374, 3418259455, 'HK', 'HKG', 'هونغ كونغ'),
(85958, 3418259456, 3418267647, 'IN', 'IND', 'الهند'),
(85959, 3418267648, 3418271743, 'VN', 'VNM', 'فييتنام'),
(85960, 3418271744, 3418273791, 'SG', 'SGP', 'سنغافورة'),
(85961, 3418273792, 3418275839, 'ID', 'IDN', 'إندونيسيا'),
(85962, 3418275840, 3418279935, 'AU', 'AUS', 'أستراليا'),
(85963, 3418279936, 3418281983, 'NZ', 'NZL', 'نيوزيلاندا'),
(85964, 3418281984, 3418282239, 'IN', 'IND', 'الهند'),
(85965, 3418282240, 3418282495, 'AU', 'AUS', 'أستراليا'),
(85966, 3418282496, 3418283519, 'PH', 'PHL', 'الفلبين'),
(85967, 3418283520, 3418284031, 'AU', 'AUS', 'أستراليا'),
(85968, 3418284032, 3418285055, 'SG', 'SGP', 'سنغافورة'),
(85969, 3418285056, 3418285823, 'JP', 'JPN', 'اليابان'),
(85970, 3418285824, 3418287691, 'SG', 'SGP', 'سنغافورة'),
(85971, 3418287692, 3418287695, 'JP', 'JPN', 'اليابان'),
(85972, 3418287696, 3418287699, 'SG', 'SGP', 'سنغافورة'),
(85973, 3418287700, 3418287703, 'JP', 'JPN', 'اليابان'),
(85974, 3418287704, 3418287719, 'SG', 'SGP', 'سنغافورة'),
(85975, 3418287720, 3418287730, 'JP', 'JPN', 'اليابان'),
(85976, 3418287731, 3418287732, 'SG', 'SGP', 'سنغافورة'),
(85977, 3418287733, 3418287734, 'JP', 'JPN', 'اليابان'),
(85978, 3418287735, 3418287735, 'SG', 'SGP', 'سنغافورة'),
(85979, 3418287736, 3418287743, 'JP', 'JPN', 'اليابان'),
(85980, 3418287744, 3418288127, 'SG', 'SGP', 'سنغافورة'),
(85981, 3418288128, 3418290175, 'ID', 'IDN', 'إندونيسيا'),
(85982, 3418290176, 3418290431, 'IN', 'IND', 'الهند'),
(85983, 3418290432, 3418290687, 'AU', 'AUS', 'أستراليا'),
(85984, 3418290688, 3418291199, 'TH', 'THA', 'تايلند'),
(85985, 3418291200, 3418291711, 'AU', 'AUS', 'أستراليا'),
(85986, 3418291712, 3418292735, 'BD', 'BGD', 'بنغالاديش'),
(85987, 3418292736, 3418292991, 'JP', 'JPN', 'اليابان'),
(85988, 3418292992, 3418293247, 'HK', 'HKG', 'هونغ كونغ'),
(85989, 3418293248, 3418293503, 'JP', 'JPN', 'اليابان'),
(85990, 3418293504, 3418293759, 'IN', 'IND', 'الهند'),
(85991, 3418293760, 3418294015, 'AU', 'AUS', 'أستراليا'),
(85992, 3418294016, 3418294271, 'NZ', 'NZL', 'نيوزيلاندا'),
(85993, 3418294272, 3418296319, 'VN', 'VNM', 'فييتنام'),
(85994, 3418296320, 3418300415, 'CN', 'CHN', 'الصين'),
(85995, 3418300416, 3418300927, 'BD', 'BGD', 'بنغالاديش'),
(85996, 3418300928, 3418301439, 'IN', 'IND', 'الهند'),
(85997, 3418301440, 3418302463, 'AU', 'AUS', 'أستراليا'),
(85998, 3418302464, 3418304511, 'ID', 'IDN', 'إندونيسيا'),
(85999, 3418304512, 3418306559, 'VN', 'VNM', 'فييتنام'),
(86000, 3418306560, 3418308607, 'MN', 'MNG', 'منغوليا'),
(86001, 3418308608, 3418324991, 'CN', 'CHN', 'الصين'),
(86002, 3418324992, 3418326015, 'BD', 'BGD', 'بنغالاديش'),
(86003, 3418326016, 3418326527, 'AU', 'AUS', 'أستراليا'),
(86004, 3418326528, 3418327039, 'PH', 'PHL', 'الفلبين'),
(86005, 3418327040, 3418329087, 'JP', 'JPN', 'اليابان'),
(86006, 3418329088, 3418333183, 'CN', 'CHN', 'الصين'),
(86007, 3418333184, 3418345471, 'AU', 'AUS', 'أستراليا'),
(86008, 3418345472, 3418357759, 'JP', 'JPN', 'اليابان'),
(86009, 3418357760, 3418365951, 'CN', 'CHN', 'الصين'),
(86010, 3418365952, 3418374143, 'TH', 'THA', 'تايلند'),
(86011, 3418374144, 3418382335, 'AU', 'AUS', 'أستراليا'),
(86012, 3418382336, 3418390527, 'JP', 'JPN', 'اليابان'),
(86013, 3418390528, 3418392319, 'AU', 'AUS', 'أستراليا'),
(86014, 3418392320, 3418392335, 'HK', 'HKG', 'هونغ كونغ'),
(86015, 3418392336, 3418392343, 'AU', 'AUS', 'أستراليا'),
(86016, 3418392344, 3418392383, 'HK', 'HKG', 'هونغ كونغ'),
(86017, 3418392384, 3418392447, 'AU', 'AUS', 'أستراليا'),
(86018, 3418392448, 3418392463, 'HK', 'HKG', 'هونغ كونغ'),
(86019, 3418392464, 3418392479, 'AU', 'AUS', 'أستراليا'),
(86020, 3418392480, 3418392575, 'HK', 'HKG', 'هونغ كونغ'),
(86021, 3418392576, 3418392831, 'AU', 'AUS', 'أستراليا'),
(86022, 3418392832, 3418393087, 'HK', 'HKG', 'هونغ كونغ'),
(86023, 3418393088, 3418393135, 'SG', 'SGP', 'سنغافورة'),
(86024, 3418393136, 3418393143, 'MY', 'MYS', 'ماليزيا'),
(86025, 3418393144, 3418393167, 'SG', 'SGP', 'سنغافورة'),
(86026, 3418393168, 3418393183, 'MY', 'MYS', 'ماليزيا'),
(86027, 3418393184, 3418393247, 'SG', 'SGP', 'سنغافورة'),
(86028, 3418393248, 3418393279, 'AU', 'AUS', 'أستراليا'),
(86029, 3418393280, 3418393295, 'SG', 'SGP', 'سنغافورة'),
(86030, 3418393296, 3418393311, 'MY', 'MYS', 'ماليزيا'),
(86031, 3418393312, 3418393343, 'SG', 'SGP', 'سنغافورة'),
(86032, 3418393344, 3418393599, 'AU', 'AUS', 'أستراليا'),
(86033, 3418393600, 3418393607, 'JP', 'JPN', 'اليابان'),
(86034, 3418393608, 3418393679, 'AU', 'AUS', 'أستراليا'),
(86035, 3418393680, 3418393855, 'JP', 'JPN', 'اليابان'),
(86036, 3418393856, 3418393911, 'AU', 'AUS', 'أستراليا'),
(86037, 3418393912, 3418393919, 'NZ', 'NZL', 'نيوزيلاندا'),
(86038, 3418393920, 3418394047, 'AU', 'AUS', 'أستراليا'),
(86039, 3418394048, 3418394063, 'MY', 'MYS', 'ماليزيا'),
(86040, 3418394064, 3418394079, 'NZ', 'NZL', 'نيوزيلاندا'),
(86041, 3418394080, 3418394111, 'AU', 'AUS', 'أستراليا'),
(86042, 3418394112, 3418394367, 'KR', 'KOR', 'جمهورية كوريا'),
(86043, 3418394368, 3418394623, 'TW', 'TWN', 'تايوان'),
(86044, 3418394624, 3418394879, 'AU', 'AUS', 'أستراليا'),
(86045, 3418394880, 3418395135, 'JP', 'JPN', 'اليابان'),
(86046, 3418395136, 3418395391, 'AU', 'AUS', 'أستراليا'),
(86047, 3418395392, 3418395647, 'JP', 'JPN', 'اليابان'),
(86048, 3418395648, 3418395671, 'KR', 'KOR', 'جمهورية كوريا'),
(86049, 3418395672, 3418395679, 'AU', 'AUS', 'أستراليا'),
(86050, 3418395680, 3418395695, 'KR', 'KOR', 'جمهورية كوريا'),
(86051, 3418395696, 3418395711, 'AU', 'AUS', 'أستراليا'),
(86052, 3418395712, 3418395759, 'KR', 'KOR', 'جمهورية كوريا'),
(86053, 3418395760, 3418395775, 'AU', 'AUS', 'أستراليا'),
(86054, 3418395776, 3418395903, 'KR', 'KOR', 'جمهورية كوريا'),
(86055, 3418395904, 3418396415, 'JP', 'JPN', 'اليابان'),
(86056, 3418396416, 3418396423, 'PH', 'PHL', 'الفلبين'),
(86057, 3418396424, 3418396479, 'TW', 'TWN', 'تايوان'),
(86058, 3418396480, 3418396543, 'PH', 'PHL', 'الفلبين'),
(86059, 3418396544, 3418396575, 'TW', 'TWN', 'تايوان'),
(86060, 3418396576, 3418396671, 'PH', 'PHL', 'الفلبين'),
(86061, 3418396672, 3418396703, 'TW', 'TWN', 'تايوان'),
(86062, 3418396704, 3418396719, 'PH', 'PHL', 'الفلبين'),
(86063, 3418396720, 3418396735, 'TW', 'TWN', 'تايوان'),
(86064, 3418396736, 3418396751, 'AU', 'AUS', 'أستراليا'),
(86065, 3418396752, 3418396775, 'TW', 'TWN', 'تايوان'),
(86066, 3418396776, 3418396783, 'PH', 'PHL', 'الفلبين'),
(86067, 3418396784, 3418396799, 'TW', 'TWN', 'تايوان'),
(86068, 3418396800, 3418396815, 'PH', 'PHL', 'الفلبين'),
(86069, 3418396816, 3418396831, 'TW', 'TWN', 'تايوان'),
(86070, 3418396832, 3418396839, 'PH', 'PHL', 'الفلبين'),
(86071, 3418396840, 3418396863, 'TW', 'TWN', 'تايوان'),
(86072, 3418396864, 3418396895, 'PH', 'PHL', 'الفلبين'),
(86073, 3418396896, 3418396927, 'TW', 'TWN', 'تايوان'),
(86074, 3418396928, 3418397695, 'AU', 'AUS', 'أستراليا'),
(86075, 3418397696, 3418397703, 'HK', 'HKG', 'هونغ كونغ'),
(86076, 3418397704, 3418397711, 'AU', 'AUS', 'أستراليا'),
(86077, 3418397712, 3418397759, 'HK', 'HKG', 'هونغ كونغ'),
(86078, 3418397760, 3418397775, 'AU', 'AUS', 'أستراليا'),
(86079, 3418397776, 3418397951, 'HK', 'HKG', 'هونغ كونغ'),
(86080, 3418397952, 3418398063, 'KR', 'KOR', 'جمهورية كوريا'),
(86081, 3418398064, 3418398079, 'AU', 'AUS', 'أستراليا'),
(86082, 3418398080, 3418398207, 'KR', 'KOR', 'جمهورية كوريا'),
(86083, 3418398208, 3418399103, 'AU', 'AUS', 'أستراليا'),
(86084, 3418399104, 3418399135, 'JP', 'JPN', 'اليابان'),
(86085, 3418399136, 3418399439, 'AU', 'AUS', 'أستراليا'),
(86086, 3418399440, 3418399455, 'PH', 'PHL', 'الفلبين'),
(86087, 3418399456, 3418399471, 'AU', 'AUS', 'أستراليا'),
(86088, 3418399472, 3418399487, 'TW', 'TWN', 'تايوان'),
(86089, 3418399488, 3418401535, 'AU', 'AUS', 'أستراليا'),
(86090, 3418401536, 3418401599, 'PH', 'PHL', 'الفلبين'),
(86091, 3418401600, 3418401615, 'AU', 'AUS', 'أستراليا'),
(86092, 3418401616, 3418401647, 'PH', 'PHL', 'الفلبين'),
(86093, 3418401648, 3418401719, 'TW', 'TWN', 'تايوان'),
(86094, 3418401720, 3418401727, 'PH', 'PHL', 'الفلبين'),
(86095, 3418401728, 3418401799, 'TW', 'TWN', 'تايوان'),
(86096, 3418401800, 3418401807, 'AU', 'AUS', 'أستراليا'),
(86097, 3418401808, 3418401823, 'TW', 'TWN', 'تايوان'),
(86098, 3418401824, 3418401855, 'PH', 'PHL', 'الفلبين'),
(86099, 3418401856, 3418401871, 'AU', 'AUS', 'أستراليا'),
(86100, 3418401872, 3418401903, 'PH', 'PHL', 'الفلبين'),
(86101, 3418401904, 3418401919, 'TW', 'TWN', 'تايوان'),
(86102, 3418401920, 3418401935, 'PH', 'PHL', 'الفلبين'),
(86103, 3418401936, 3418401983, 'TW', 'TWN', 'تايوان'),
(86104, 3418401984, 3418402007, 'PH', 'PHL', 'الفلبين'),
(86105, 3418402008, 3418402015, 'AU', 'AUS', 'أستراليا'),
(86106, 3418402016, 3418402031, 'TW', 'TWN', 'تايوان'),
(86107, 3418402032, 3418402047, 'AU', 'AUS', 'أستراليا'),
(86108, 3418402048, 3418402223, 'JP', 'JPN', 'اليابان'),
(86109, 3418402224, 3418402239, 'AU', 'AUS', 'أستراليا'),
(86110, 3418402240, 3418402255, 'JP', 'JPN', 'اليابان'),
(86111, 3418402256, 3418402263, 'AU', 'AUS', 'أستراليا'),
(86112, 3418402264, 3418402271, 'JP', 'JPN', 'اليابان'),
(86113, 3418402272, 3418402279, 'AU', 'AUS', 'أستراليا'),
(86114, 3418402280, 3418402287, 'JP', 'JPN', 'اليابان'),
(86115, 3418402288, 3418403071, 'AU', 'AUS', 'أستراليا'),
(86116, 3418403072, 3418403103, 'MY', 'MYS', 'ماليزيا'),
(86117, 3418403104, 3418403151, 'SG', 'SGP', 'سنغافورة'),
(86118, 3418403152, 3418403167, 'AU', 'AUS', 'أستراليا'),
(86119, 3418403168, 3418403183, 'MY', 'MYS', 'ماليزيا'),
(86120, 3418403184, 3418403199, 'SG', 'SGP', 'سنغافورة'),
(86121, 3418403200, 3418403207, 'MY', 'MYS', 'ماليزيا'),
(86122, 3418403208, 3418403215, 'AU', 'AUS', 'أستراليا'),
(86123, 3418403216, 3418403327, 'SG', 'SGP', 'سنغافورة'),
(86124, 3418403328, 3418403775, 'AU', 'AUS', 'أستراليا'),
(86125, 3418403776, 3418403783, 'NZ', 'NZL', 'نيوزيلاندا'),
(86126, 3418403784, 3418403839, 'AU', 'AUS', 'أستراليا'),
(86127, 3418403840, 3418403991, 'HK', 'HKG', 'هونغ كونغ'),
(86128, 3418403992, 3418403999, 'AU', 'AUS', 'أستراليا'),
(86129, 3418404000, 3418404063, 'HK', 'HKG', 'هونغ كونغ'),
(86130, 3418404064, 3418404159, 'AU', 'AUS', 'أستراليا'),
(86131, 3418404160, 3418404175, 'TW', 'TWN', 'تايوان'),
(86132, 3418404176, 3418404351, 'AU', 'AUS', 'أستراليا'),
(86133, 3418404352, 3418404479, 'KR', 'KOR', 'جمهورية كوريا'),
(86134, 3418404480, 3418405631, 'AU', 'AUS', 'أستراليا'),
(86135, 3418405632, 3418405647, 'HK', 'HKG', 'هونغ كونغ'),
(86136, 3418405648, 3418405855, 'AU', 'AUS', 'أستراليا'),
(86137, 3418405856, 3418405887, 'SG', 'SGP', 'سنغافورة'),
(86138, 3418405888, 3418406655, 'AU', 'AUS', 'أستراليا'),
(86139, 3418406656, 3418406687, 'PH', 'PHL', 'الفلبين'),
(86140, 3418406688, 3418406711, 'AU', 'AUS', 'أستراليا'),
(86141, 3418406712, 3418406719, 'TW', 'TWN', 'تايوان'),
(86142, 3418406720, 3418406783, 'PH', 'PHL', 'الفلبين'),
(86143, 3418406784, 3418406799, 'TW', 'TWN', 'تايوان'),
(86144, 3418406800, 3418406815, 'AU', 'AUS', 'أستراليا'),
(86145, 3418406816, 3418406831, 'PH', 'PHL', 'الفلبين'),
(86146, 3418406832, 3418406847, 'TW', 'TWN', 'تايوان'),
(86147, 3418406848, 3418406911, 'AU', 'AUS', 'أستراليا'),
(86148, 3418406912, 3418423295, 'IN', 'IND', 'الهند'),
(86149, 3418423296, 3418435711, 'HK', 'HKG', 'هونغ كونغ'),
(86150, 3418435712, 3418435743, 'JP', 'JPN', 'اليابان'),
(86151, 3418435744, 3418448639, 'HK', 'HKG', 'هونغ كونغ'),
(86152, 3418448640, 3418448895, 'SG', 'SGP', 'سنغافورة'),
(86153, 3418448896, 3418453064, 'HK', 'HKG', 'هونغ كونغ'),
(86154, 3418453065, 3418453065, 'AS', 'ASM', 'ساموا الأمريكية'),
(86155, 3418453066, 3418453071, 'US', 'USA', 'الولايات المتحدة'),
(86156, 3418453072, 3418453087, 'HK', 'HKG', 'هونغ كونغ'),
(86157, 3418453088, 3418453091, 'US', 'USA', 'الولايات المتحدة'),
(86158, 3418453092, 3418453247, 'HK', 'HKG', 'هونغ كونغ'),
(86159, 3418453248, 3418453375, 'AS', 'ASM', 'ساموا الأمريكية'),
(86160, 3418453376, 3418453407, 'US', 'USA', 'الولايات المتحدة'),
(86161, 3418453408, 3418453411, 'HK', 'HKG', 'هونغ كونغ'),
(86162, 3418453412, 3418453412, 'KR', 'KOR', 'جمهورية كوريا'),
(86163, 3418453413, 3418453415, 'HK', 'HKG', 'هونغ كونغ'),
(86164, 3418453416, 3418453423, 'KR', 'KOR', 'جمهورية كوريا'),
(86165, 3418453424, 3418453631, 'HK', 'HKG', 'هونغ كونغ'),
(86166, 3418453632, 3418453759, 'US', 'USA', 'الولايات المتحدة'),
(86167, 3418453760, 3418456063, 'HK', 'HKG', 'هونغ كونغ'),
(86168, 3418456064, 3418472447, 'IN', 'IND', 'الهند'),
(86169, 3418472448, 3418505215, 'AU', 'AUS', 'أستراليا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(86170, 3418505216, 3418506831, 'JP', 'JPN', 'اليابان'),
(86171, 3418506832, 3418506863, 'ID', 'IDN', 'إندونيسيا'),
(86172, 3418506864, 3418506895, 'JP', 'JPN', 'اليابان'),
(86173, 3418506896, 3418506911, 'NZ', 'NZL', 'نيوزيلاندا'),
(86174, 3418506912, 3418507043, 'JP', 'JPN', 'اليابان'),
(86175, 3418507044, 3418507047, 'ID', 'IDN', 'إندونيسيا'),
(86176, 3418507048, 3418507071, 'JP', 'JPN', 'اليابان'),
(86177, 3418507072, 3418507075, 'ID', 'IDN', 'إندونيسيا'),
(86178, 3418507076, 3418507295, 'JP', 'JPN', 'اليابان'),
(86179, 3418507296, 3418507335, 'HK', 'HKG', 'هونغ كونغ'),
(86180, 3418507336, 3418507903, 'JP', 'JPN', 'اليابان'),
(86181, 3418507904, 3418507919, 'MY', 'MYS', 'ماليزيا'),
(86182, 3418507920, 3418507927, 'JP', 'JPN', 'اليابان'),
(86183, 3418507928, 3418507935, 'MY', 'MYS', 'ماليزيا'),
(86184, 3418507936, 3418507967, 'JP', 'JPN', 'اليابان'),
(86185, 3418507968, 3418507971, 'MY', 'MYS', 'ماليزيا'),
(86186, 3418507972, 3418507975, 'JP', 'JPN', 'اليابان'),
(86187, 3418507976, 3418507983, 'MY', 'MYS', 'ماليزيا'),
(86188, 3418507984, 3418508543, 'JP', 'JPN', 'اليابان'),
(86189, 3418508544, 3418508607, 'HK', 'HKG', 'هونغ كونغ'),
(86190, 3418508608, 3418508959, 'JP', 'JPN', 'اليابان'),
(86191, 3418508960, 3418509024, 'SG', 'SGP', 'سنغافورة'),
(86192, 3418509025, 3418509055, 'JP', 'JPN', 'اليابان'),
(86193, 3418509056, 3418509119, 'TW', 'TWN', 'تايوان'),
(86194, 3418509120, 3418509327, 'JP', 'JPN', 'اليابان'),
(86195, 3418509328, 3418509455, 'HK', 'HKG', 'هونغ كونغ'),
(86196, 3418509456, 3418510271, 'JP', 'JPN', 'اليابان'),
(86197, 3418510272, 3418510279, 'TW', 'TWN', 'تايوان'),
(86198, 3418510280, 3418510287, 'JP', 'JPN', 'اليابان'),
(86199, 3418510288, 3418510303, 'HK', 'HKG', 'هونغ كونغ'),
(86200, 3418510304, 3418510328, 'JP', 'JPN', 'اليابان'),
(86201, 3418510329, 3418510329, 'TW', 'TWN', 'تايوان'),
(86202, 3418510330, 3418510591, 'JP', 'JPN', 'اليابان'),
(86203, 3418510592, 3418510847, 'TW', 'TWN', 'تايوان'),
(86204, 3418510848, 3418510927, 'JP', 'JPN', 'اليابان'),
(86205, 3418510928, 3418510943, 'HK', 'HKG', 'هونغ كونغ'),
(86206, 3418510944, 3418510991, 'JP', 'JPN', 'اليابان'),
(86207, 3418510992, 3418511007, 'HK', 'HKG', 'هونغ كونغ'),
(86208, 3418511008, 3418511031, 'JP', 'JPN', 'اليابان'),
(86209, 3418511032, 3418511055, 'HK', 'HKG', 'هونغ كونغ'),
(86210, 3418511056, 3418511087, 'JP', 'JPN', 'اليابان'),
(86211, 3418511088, 3418511103, 'HK', 'HKG', 'هونغ كونغ'),
(86212, 3418511104, 3418511107, 'JP', 'JPN', 'اليابان'),
(86213, 3418511108, 3418511115, 'SG', 'SGP', 'سنغافورة'),
(86214, 3418511116, 3418511116, 'JP', 'JPN', 'اليابان'),
(86215, 3418511117, 3418511117, 'SG', 'SGP', 'سنغافورة'),
(86216, 3418511118, 3418511135, 'JP', 'JPN', 'اليابان'),
(86217, 3418511136, 3418511359, 'SG', 'SGP', 'سنغافورة'),
(86218, 3418511360, 3418511391, 'JP', 'JPN', 'اليابان'),
(86219, 3418511392, 3418511399, 'TW', 'TWN', 'تايوان'),
(86220, 3418511400, 3418511407, 'JP', 'JPN', 'اليابان'),
(86221, 3418511408, 3418511415, 'TW', 'TWN', 'تايوان'),
(86222, 3418511416, 3418511423, 'SG', 'SGP', 'سنغافورة'),
(86223, 3418511424, 3418511439, 'TW', 'TWN', 'تايوان'),
(86224, 3418511440, 3418513031, 'JP', 'JPN', 'اليابان'),
(86225, 3418513032, 3418513039, 'HK', 'HKG', 'هونغ كونغ'),
(86226, 3418513040, 3418513215, 'JP', 'JPN', 'اليابان'),
(86227, 3418513216, 3418513231, 'TW', 'TWN', 'تايوان'),
(86228, 3418513232, 3418513247, 'JP', 'JPN', 'اليابان'),
(86229, 3418513248, 3418513279, 'TW', 'TWN', 'تايوان'),
(86230, 3418513280, 3418513407, 'JP', 'JPN', 'اليابان'),
(86231, 3418513408, 3418517503, 'IN', 'IND', 'الهند'),
(86232, 3418517504, 3418519551, 'MN', 'MNG', 'منغوليا'),
(86233, 3418519552, 3418521599, 'AU', 'AUS', 'أستراليا'),
(86234, 3418521600, 3418554367, 'HK', 'HKG', 'هونغ كونغ'),
(86235, 3418554368, 3418578943, 'AU', 'AUS', 'أستراليا'),
(86236, 3418578944, 3418583039, 'TH', 'THA', 'تايلند'),
(86237, 3418583040, 3418585087, 'AU', 'AUS', 'أستراليا'),
(86238, 3418585088, 3418586111, 'TH', 'THA', 'تايلند'),
(86239, 3418586112, 3418586367, 'AU', 'AUS', 'أستراليا'),
(86240, 3418586368, 3418586623, 'SG', 'SGP', 'سنغافورة'),
(86241, 3418586624, 3418619903, 'AU', 'AUS', 'أستراليا'),
(86242, 3418619904, 3418621951, 'CN', 'CHN', 'الصين'),
(86243, 3418621952, 3418623999, 'AU', 'AUS', 'أستراليا'),
(86244, 3418624000, 3418626047, 'JP', 'JPN', 'اليابان'),
(86245, 3418626048, 3418628095, 'KI', 'KIR', 'كيريباتي'),
(86246, 3418628096, 3418636287, 'AU', 'AUS', 'أستراليا'),
(86247, 3418636288, 3418642943, 'JP', 'JPN', 'اليابان'),
(86248, 3418642944, 3418643199, 'ID', 'IDN', 'إندونيسيا'),
(86249, 3418643200, 3418643455, 'JP', 'JPN', 'اليابان'),
(86250, 3418643456, 3418644479, 'AU', 'AUS', 'أستراليا'),
(86251, 3418644480, 3418644991, 'JP', 'JPN', 'اليابان'),
(86252, 3418644992, 3418645247, 'TW', 'TWN', 'تايوان'),
(86253, 3418645248, 3418645503, 'SG', 'SGP', 'سنغافورة'),
(86254, 3418645504, 3418645759, 'JP', 'JPN', 'اليابان'),
(86255, 3418645760, 3418646271, 'NZ', 'NZL', 'نيوزيلاندا'),
(86256, 3418646272, 3418646527, 'HK', 'HKG', 'هونغ كونغ'),
(86257, 3418646528, 3418646783, 'JP', 'JPN', 'اليابان'),
(86258, 3418646784, 3418647039, 'TW', 'TWN', 'تايوان'),
(86259, 3418647040, 3418648063, 'JP', 'JPN', 'اليابان'),
(86260, 3418648064, 3418648575, 'SG', 'SGP', 'سنغافورة'),
(86261, 3418648576, 3418648783, 'JP', 'JPN', 'اليابان'),
(86262, 3418648784, 3418648799, 'SG', 'SGP', 'سنغافورة'),
(86263, 3418648800, 3418648815, 'NZ', 'NZL', 'نيوزيلاندا'),
(86264, 3418648816, 3418648831, 'HK', 'HKG', 'هونغ كونغ'),
(86265, 3418648832, 3418649439, 'JP', 'JPN', 'اليابان'),
(86266, 3418649440, 3418649503, 'SG', 'SGP', 'سنغافورة'),
(86267, 3418649504, 3418649519, 'JP', 'JPN', 'اليابان'),
(86268, 3418649520, 3418649551, 'SG', 'SGP', 'سنغافورة'),
(86269, 3418649552, 3418649583, 'JP', 'JPN', 'اليابان'),
(86270, 3418649584, 3418649599, 'SG', 'SGP', 'سنغافورة'),
(86271, 3418649600, 3418649887, 'JP', 'JPN', 'اليابان'),
(86272, 3418649888, 3418649951, 'PH', 'PHL', 'الفلبين'),
(86273, 3418649952, 3418650751, 'JP', 'JPN', 'اليابان'),
(86274, 3418650752, 3418650808, 'HK', 'HKG', 'هونغ كونغ'),
(86275, 3418650809, 3418650823, 'JP', 'JPN', 'اليابان'),
(86276, 3418650824, 3418650839, 'HK', 'HKG', 'هونغ كونغ'),
(86277, 3418650840, 3418650846, 'JP', 'JPN', 'اليابان'),
(86278, 3418650847, 3418650879, 'HK', 'HKG', 'هونغ كونغ'),
(86279, 3418650880, 3418651039, 'NZ', 'NZL', 'نيوزيلاندا'),
(86280, 3418651040, 3418651135, 'JP', 'JPN', 'اليابان'),
(86281, 3418651136, 3418651391, 'SG', 'SGP', 'سنغافورة'),
(86282, 3418651392, 3418651903, 'JP', 'JPN', 'اليابان'),
(86283, 3418651904, 3418652159, 'HK', 'HKG', 'هونغ كونغ'),
(86284, 3418652160, 3418652163, 'PH', 'PHL', 'الفلبين'),
(86285, 3418652164, 3418652167, 'JP', 'JPN', 'اليابان'),
(86286, 3418652168, 3418652171, 'PH', 'PHL', 'الفلبين'),
(86287, 3418652172, 3418652191, 'JP', 'JPN', 'اليابان'),
(86288, 3418652192, 3418652215, 'PH', 'PHL', 'الفلبين'),
(86289, 3418652216, 3418652415, 'JP', 'JPN', 'اليابان'),
(86290, 3418652416, 3418652671, 'HK', 'HKG', 'هونغ كونغ'),
(86291, 3418652672, 3418750975, 'IN', 'IND', 'الهند'),
(86292, 3418750976, 3418816511, 'HK', 'HKG', 'هونغ كونغ'),
(86293, 3418816512, 3418947583, 'IN', 'IND', 'الهند'),
(86294, 3418947584, 3418955775, 'AU', 'AUS', 'أستراليا'),
(86295, 3418955776, 3418959871, 'TW', 'TWN', 'تايوان'),
(86296, 3418959872, 3418960383, 'BD', 'BGD', 'بنغالاديش'),
(86297, 3418960384, 3418960895, 'ID', 'IDN', 'إندونيسيا'),
(86298, 3418960896, 3418961919, 'SG', 'SGP', 'سنغافورة'),
(86299, 3418961920, 3418962943, 'VN', 'VNM', 'فييتنام'),
(86300, 3418962944, 3418963967, 'IN', 'IND', 'الهند'),
(86301, 3418963968, 3418988543, 'AU', 'AUS', 'أستراليا'),
(86302, 3418988544, 3418992639, 'ID', 'IDN', 'إندونيسيا'),
(86303, 3418992640, 3418993919, 'SG', 'SGP', 'سنغافورة'),
(86304, 3418993920, 3418994175, 'MN', 'MNG', 'منغوليا'),
(86305, 3418994176, 3418994431, 'MY', 'MYS', 'ماليزيا'),
(86306, 3418994432, 3418994687, 'AU', 'AUS', 'أستراليا'),
(86307, 3418994688, 3418995711, 'MY', 'MYS', 'ماليزيا'),
(86308, 3418995712, 3418996735, 'JP', 'JPN', 'اليابان'),
(86309, 3418996736, 3419013119, 'IN', 'IND', 'الهند'),
(86310, 3419013120, 3419062271, 'AU', 'AUS', 'أستراليا'),
(86311, 3419062272, 3419070463, 'JP', 'JPN', 'اليابان'),
(86312, 3419070464, 3419071999, 'HK', 'HKG', 'هونغ كونغ'),
(86313, 3419072000, 3419072255, 'ID', 'IDN', 'إندونيسيا'),
(86314, 3419072256, 3419072511, 'HK', 'HKG', 'هونغ كونغ'),
(86315, 3419072512, 3419073023, 'JP', 'JPN', 'اليابان'),
(86316, 3419073024, 3419073279, 'SG', 'SGP', 'سنغافورة'),
(86317, 3419073280, 3419073535, 'FJ', 'FJI', 'فيجي'),
(86318, 3419073536, 3419074047, 'AU', 'AUS', 'أستراليا'),
(86319, 3419074048, 3419074559, 'CN', 'CHN', 'الصين'),
(86320, 3419074560, 3419078655, 'BD', 'BGD', 'بنغالاديش'),
(86321, 3419078656, 3419209727, 'TW', 'TWN', 'تايوان'),
(86322, 3419209728, 3419238399, 'AU', 'AUS', 'أستراليا'),
(86323, 3419238400, 3419242495, 'JP', 'JPN', 'اليابان'),
(86324, 3419242496, 3419340799, 'AU', 'AUS', 'أستراليا'),
(86325, 3419340800, 3419344895, 'TW', 'TWN', 'تايوان'),
(86326, 3419344896, 3419348991, 'KR', 'KOR', 'جمهورية كوريا'),
(86327, 3419348992, 3419353087, 'TW', 'TWN', 'تايوان'),
(86328, 3419353088, 3419354111, 'JP', 'JPN', 'اليابان'),
(86329, 3419354112, 3419356159, 'ID', 'IDN', 'إندونيسيا'),
(86330, 3419356160, 3419356671, 'NZ', 'NZL', 'نيوزيلاندا'),
(86331, 3419356672, 3419357183, 'IN', 'IND', 'الهند'),
(86332, 3419357184, 3419411455, 'CN', 'CHN', 'الصين'),
(86333, 3419411456, 3419411711, 'HK', 'HKG', 'هونغ كونغ'),
(86334, 3419411712, 3419411967, 'NZ', 'NZL', 'نيوزيلاندا'),
(86335, 3419411968, 3419412223, 'AU', 'AUS', 'أستراليا'),
(86336, 3419412224, 3419412479, 'JP', 'JPN', 'اليابان'),
(86337, 3419412480, 3419414527, 'PH', 'PHL', 'الفلبين'),
(86338, 3419414528, 3419422719, 'CN', 'CHN', 'الصين'),
(86339, 3419422720, 3419439103, 'AU', 'AUS', 'أستراليا'),
(86340, 3419439104, 3419448703, 'SG', 'SGP', 'سنغافورة'),
(86341, 3419448704, 3419448735, 'NP', 'NPL', 'نيبال'),
(86342, 3419448736, 3419449023, 'SG', 'SGP', 'سنغافورة'),
(86343, 3419449024, 3419449055, 'BD', 'BGD', 'بنغالاديش'),
(86344, 3419449056, 3419456911, 'SG', 'SGP', 'سنغافورة'),
(86345, 3419456912, 3419456927, 'JP', 'JPN', 'اليابان'),
(86346, 3419456928, 3419458927, 'SG', 'SGP', 'سنغافورة'),
(86347, 3419458928, 3419458943, 'HK', 'HKG', 'هونغ كونغ'),
(86348, 3419458944, 3419459007, 'SG', 'SGP', 'سنغافورة'),
(86349, 3419459008, 3419459071, 'AF', 'AFG', 'أفغانستان'),
(86350, 3419459072, 3419459327, 'CN', 'CHN', 'الصين'),
(86351, 3419459328, 3419471871, 'SG', 'SGP', 'سنغافورة'),
(86352, 3419471872, 3419504639, 'TH', 'THA', 'تايلند'),
(86353, 3419504640, 3419508735, 'HK', 'HKG', 'هونغ كونغ'),
(86354, 3419508736, 3419512831, 'JP', 'JPN', 'اليابان'),
(86355, 3419512832, 3419516927, 'AU', 'AUS', 'أستراليا'),
(86356, 3419516928, 3419517951, 'JP', 'JPN', 'اليابان'),
(86357, 3419517952, 3419518975, 'VN', 'VNM', 'فييتنام'),
(86358, 3419518976, 3419519999, 'TW', 'TWN', 'تايوان'),
(86359, 3419520000, 3419520767, 'ID', 'IDN', 'إندونيسيا'),
(86360, 3419520768, 3419521023, 'TH', 'THA', 'تايلند'),
(86361, 3419521024, 3419529215, 'AU', 'AUS', 'أستراليا'),
(86362, 3419529216, 3419537407, 'CN', 'CHN', 'الصين'),
(86363, 3419537408, 3419541503, 'HK', 'HKG', 'هونغ كونغ'),
(86364, 3419541504, 3419553791, 'KR', 'KOR', 'جمهورية كوريا'),
(86365, 3419553792, 3419557887, 'AU', 'AUS', 'أستراليا'),
(86366, 3419557888, 3419558399, 'ID', 'IDN', 'إندونيسيا'),
(86367, 3419558400, 3419558655, 'AU', 'AUS', 'أستراليا'),
(86368, 3419558656, 3419559935, 'ID', 'IDN', 'إندونيسيا'),
(86369, 3419559936, 3419560959, 'JP', 'JPN', 'اليابان'),
(86370, 3419560960, 3419561983, 'IN', 'IND', 'الهند'),
(86371, 3419561984, 3419570175, 'AU', 'AUS', 'أستراليا'),
(86372, 3419570176, 3419602943, 'VN', 'VNM', 'فييتنام'),
(86373, 3419602944, 3419611135, 'TW', 'TWN', 'تايوان'),
(86374, 3419611136, 3419617279, 'JP', 'JPN', 'اليابان'),
(86375, 3419617280, 3419618303, 'AU', 'AUS', 'أستراليا'),
(86376, 3419618304, 3419619327, 'SG', 'SGP', 'سنغافورة'),
(86377, 3419619328, 3419635711, 'NZ', 'NZL', 'نيوزيلاندا'),
(86378, 3419635712, 3419643903, 'SG', 'SGP', 'سنغافورة'),
(86379, 3419643904, 3419668479, 'JP', 'JPN', 'اليابان'),
(86380, 3419668480, 3419672575, 'CN', 'CHN', 'الصين'),
(86381, 3419672576, 3419674623, 'AU', 'AUS', 'أستراليا'),
(86382, 3419674624, 3419675647, 'IN', 'IND', 'الهند'),
(86383, 3419675648, 3419676671, 'MN', 'MNG', 'منغوليا'),
(86384, 3419676672, 3419684863, 'JP', 'JPN', 'اليابان'),
(86385, 3419684864, 3419688959, 'IN', 'IND', 'الهند'),
(86386, 3419688960, 3419693055, 'CN', 'CHN', 'الصين'),
(86387, 3419693056, 3419701247, 'KR', 'KOR', 'جمهورية كوريا'),
(86388, 3419701248, 3419709439, 'AU', 'AUS', 'أستراليا'),
(86389, 3419709440, 3419717631, 'KR', 'KOR', 'جمهورية كوريا'),
(86390, 3419717632, 3419734015, 'IN', 'IND', 'الهند'),
(86391, 3419734016, 3419774975, 'AU', 'AUS', 'أستراليا'),
(86392, 3419774976, 3419783167, 'JP', 'JPN', 'اليابان'),
(86393, 3419783168, 3419791359, 'PH', 'PHL', 'الفلبين'),
(86394, 3419791360, 3419873279, 'AU', 'AUS', 'أستراليا'),
(86395, 3419873280, 3419877375, 'AF', 'AFG', 'أفغانستان'),
(86396, 3419877376, 3419877631, 'ID', 'IDN', 'إندونيسيا'),
(86397, 3419877632, 3419877887, 'KH', 'KHM', 'كامبوديا'),
(86398, 3419877888, 3419878143, 'ID', 'IDN', 'إندونيسيا'),
(86399, 3419878144, 3419878399, 'IN', 'IND', 'الهند'),
(86400, 3419878400, 3419879423, 'AU', 'AUS', 'أستراليا'),
(86401, 3419879424, 3419880447, 'JP', 'JPN', 'اليابان'),
(86402, 3419880448, 3419881471, 'MY', 'MYS', 'ماليزيا'),
(86403, 3419881472, 3419897855, 'PH', 'PHL', 'الفلبين'),
(86404, 3419897856, 3419899903, 'JP', 'JPN', 'اليابان'),
(86405, 3419899904, 3419900159, 'FR', 'FRA', 'فرنسا'),
(86406, 3419900160, 3419900415, 'BE', 'BEL', 'بلجيكا'),
(86407, 3419900416, 3419901439, 'AU', 'AUS', 'أستراليا'),
(86408, 3419901440, 3419901951, 'NZ', 'NZL', 'نيوزيلاندا'),
(86409, 3419901952, 3419902207, 'AU', 'AUS', 'أستراليا'),
(86410, 3419902208, 3419902463, 'HK', 'HKG', 'هونغ كونغ'),
(86411, 3419902464, 3419902719, 'CN', 'CHN', 'الصين'),
(86412, 3419902720, 3419902975, 'HK', 'HKG', 'هونغ كونغ'),
(86413, 3419902976, 3419903231, 'AU', 'AUS', 'أستراليا'),
(86414, 3419903232, 3419903487, 'JP', 'JPN', 'اليابان'),
(86415, 3419903488, 3419906047, 'AU', 'AUS', 'أستراليا'),
(86416, 3419906048, 3419914239, 'PK', 'PAK', 'باكستان'),
(86417, 3419914240, 3419922431, 'KR', 'KOR', 'جمهورية كوريا'),
(86418, 3419922432, 3419924479, 'JP', 'JPN', 'اليابان'),
(86419, 3419924480, 3419926527, 'AU', 'AUS', 'أستراليا'),
(86420, 3419926528, 3419930623, 'HK', 'HKG', 'هونغ كونغ'),
(86421, 3419930624, 3419971583, 'JP', 'JPN', 'اليابان'),
(86422, 3419971584, 3419979775, 'KR', 'KOR', 'جمهورية كوريا'),
(86423, 3419979776, 3419996159, 'JP', 'JPN', 'اليابان'),
(86424, 3419996160, 3420020735, 'AU', 'AUS', 'أستراليا'),
(86425, 3420020736, 3420028927, 'TW', 'TWN', 'تايوان'),
(86426, 3420028928, 3420029951, 'MY', 'MYS', 'ماليزيا'),
(86427, 3420029952, 3420030975, 'ID', 'IDN', 'إندونيسيا'),
(86428, 3420030976, 3420031999, 'IN', 'IND', 'الهند'),
(86429, 3420032000, 3420032255, 'ID', 'IDN', 'إندونيسيا'),
(86430, 3420032256, 3420032511, 'AU', 'AUS', 'أستراليا'),
(86431, 3420032512, 3420033023, 'NZ', 'NZL', 'نيوزيلاندا'),
(86432, 3420033024, 3420034047, 'IN', 'IND', 'الهند'),
(86433, 3420034048, 3420036095, 'AU', 'AUS', 'أستراليا'),
(86434, 3420036096, 3420037119, 'JP', 'JPN', 'اليابان'),
(86435, 3420037120, 3420039167, 'AU', 'AUS', 'أستراليا'),
(86436, 3420039168, 3420040191, 'KH', 'KHM', 'كامبوديا'),
(86437, 3420040192, 3420040703, 'ID', 'IDN', 'إندونيسيا'),
(86438, 3420040704, 3420040959, 'IN', 'IND', 'الهند'),
(86439, 3420040960, 3420041215, 'HK', 'HKG', 'هونغ كونغ'),
(86440, 3420041216, 3420042239, 'MY', 'MYS', 'ماليزيا'),
(86441, 3420042240, 3420043263, 'JP', 'JPN', 'اليابان'),
(86442, 3420043264, 3420044287, 'SG', 'SGP', 'سنغافورة'),
(86443, 3420044288, 3420045311, 'ID', 'IDN', 'إندونيسيا'),
(86444, 3420045312, 3420061695, 'KR', 'KOR', 'جمهورية كوريا'),
(86445, 3420061696, 3420127231, 'HK', 'HKG', 'هونغ كونغ'),
(86446, 3420127232, 3420323839, 'AU', 'AUS', 'أستراليا'),
(86447, 3420323840, 3420332031, 'TW', 'TWN', 'تايوان'),
(86448, 3420332032, 3420334591, 'AU', 'AUS', 'أستراليا'),
(86449, 3420334592, 3420334623, 'HK', 'HKG', 'هونغ كونغ'),
(86450, 3420334624, 3420334639, 'AU', 'AUS', 'أستراليا'),
(86451, 3420334640, 3420334643, 'SG', 'SGP', 'سنغافورة'),
(86452, 3420334644, 3420334647, 'AU', 'AUS', 'أستراليا'),
(86453, 3420334648, 3420334687, 'HK', 'HKG', 'هونغ كونغ'),
(86454, 3420334688, 3420334695, 'SG', 'SGP', 'سنغافورة'),
(86455, 3420334696, 3420334703, 'JP', 'JPN', 'اليابان'),
(86456, 3420334704, 3420334719, 'HK', 'HKG', 'هونغ كونغ'),
(86457, 3420334720, 3420334847, 'SG', 'SGP', 'سنغافورة'),
(86458, 3420334848, 3420335271, 'HK', 'HKG', 'هونغ كونغ'),
(86459, 3420335272, 3420335279, 'CN', 'CHN', 'الصين'),
(86460, 3420335280, 3420335615, 'HK', 'HKG', 'هونغ كونغ'),
(86461, 3420335616, 3420335623, 'KR', 'KOR', 'جمهورية كوريا'),
(86462, 3420335624, 3420335631, 'SG', 'SGP', 'سنغافورة'),
(86463, 3420335632, 3420335640, 'JP', 'JPN', 'اليابان'),
(86464, 3420335641, 3420335647, 'AU', 'AUS', 'أستراليا'),
(86465, 3420335648, 3420335871, 'JP', 'JPN', 'اليابان'),
(86466, 3420335872, 3420336127, 'SG', 'SGP', 'سنغافورة'),
(86467, 3420336128, 3420336183, 'JP', 'JPN', 'اليابان'),
(86468, 3420336184, 3420336199, 'SG', 'SGP', 'سنغافورة'),
(86469, 3420336200, 3420336207, 'JP', 'JPN', 'اليابان'),
(86470, 3420336208, 3420336223, 'HK', 'HKG', 'هونغ كونغ'),
(86471, 3420336224, 3420336255, 'SG', 'SGP', 'سنغافورة'),
(86472, 3420336256, 3420336287, 'JP', 'JPN', 'اليابان'),
(86473, 3420336288, 3420336319, 'SG', 'SGP', 'سنغافورة'),
(86474, 3420336320, 3420336351, 'JP', 'JPN', 'اليابان'),
(86475, 3420336352, 3420336367, 'KR', 'KOR', 'جمهورية كوريا'),
(86476, 3420336368, 3420336383, 'SG', 'SGP', 'سنغافورة'),
(86477, 3420336384, 3420336655, 'JP', 'JPN', 'اليابان'),
(86478, 3420336656, 3420336671, 'AU', 'AUS', 'أستراليا'),
(86479, 3420336672, 3420336895, 'JP', 'JPN', 'اليابان'),
(86480, 3420336896, 3420337151, 'HK', 'HKG', 'هونغ كونغ'),
(86481, 3420337152, 3420337167, 'SG', 'SGP', 'سنغافورة'),
(86482, 3420337168, 3420337171, 'AU', 'AUS', 'أستراليا'),
(86483, 3420337172, 3420337175, 'SG', 'SGP', 'سنغافورة'),
(86484, 3420337176, 3420337183, 'AU', 'AUS', 'أستراليا'),
(86485, 3420337184, 3420337599, 'SG', 'SGP', 'سنغافورة'),
(86486, 3420337600, 3420337631, 'HK', 'HKG', 'هونغ كونغ'),
(86487, 3420337632, 3420337635, 'AU', 'AUS', 'أستراليا'),
(86488, 3420337636, 3420337643, 'SG', 'SGP', 'سنغافورة'),
(86489, 3420337644, 3420337647, 'AU', 'AUS', 'أستراليا'),
(86490, 3420337648, 3420337663, 'SG', 'SGP', 'سنغافورة'),
(86491, 3420337664, 3420337727, 'AU', 'AUS', 'أستراليا'),
(86492, 3420337728, 3420337743, 'NZ', 'NZL', 'نيوزيلاندا'),
(86493, 3420337744, 3420337835, 'AU', 'AUS', 'أستراليا'),
(86494, 3420337836, 3420337839, 'NZ', 'NZL', 'نيوزيلاندا'),
(86495, 3420337840, 3420340019, 'AU', 'AUS', 'أستراليا'),
(86496, 3420340020, 3420340023, 'NZ', 'NZL', 'نيوزيلاندا'),
(86497, 3420340024, 3420340143, 'AU', 'AUS', 'أستراليا'),
(86498, 3420340144, 3420340159, 'NZ', 'NZL', 'نيوزيلاندا'),
(86499, 3420340160, 3420365847, 'AU', 'AUS', 'أستراليا'),
(86500, 3420365848, 3420365855, 'TW', 'TWN', 'تايوان'),
(86501, 3420365856, 3420365887, 'AU', 'AUS', 'أستراليا'),
(86502, 3420365888, 3420366047, 'HK', 'HKG', 'هونغ كونغ'),
(86503, 3420366048, 3420366055, 'TW', 'TWN', 'تايوان'),
(86504, 3420366056, 3420366059, 'HK', 'HKG', 'هونغ كونغ'),
(86505, 3420366060, 3420366063, 'AU', 'AUS', 'أستراليا'),
(86506, 3420366064, 3420366079, 'TW', 'TWN', 'تايوان'),
(86507, 3420366080, 3420366335, 'HK', 'HKG', 'هونغ كونغ'),
(86508, 3420366336, 3420366431, 'SG', 'SGP', 'سنغافورة'),
(86509, 3420366432, 3420366439, 'CN', 'CHN', 'الصين'),
(86510, 3420366440, 3420366447, 'SG', 'SGP', 'سنغافورة'),
(86511, 3420366448, 3420366463, 'US', 'USA', 'الولايات المتحدة'),
(86512, 3420366464, 3420366471, 'SG', 'SGP', 'سنغافورة'),
(86513, 3420366472, 3420366479, 'IN', 'IND', 'الهند'),
(86514, 3420366480, 3420366495, 'SG', 'SGP', 'سنغافورة'),
(86515, 3420366496, 3420366511, 'HK', 'HKG', 'هونغ كونغ'),
(86516, 3420366512, 3420366527, 'SG', 'SGP', 'سنغافورة'),
(86517, 3420366528, 3420366591, 'CN', 'CHN', 'الصين'),
(86518, 3420366592, 3420366639, 'HK', 'HKG', 'هونغ كونغ'),
(86519, 3420366640, 3420366647, 'TW', 'TWN', 'تايوان'),
(86520, 3420366648, 3420366655, 'CN', 'CHN', 'الصين'),
(86521, 3420366656, 3420366719, 'HK', 'HKG', 'هونغ كونغ'),
(86522, 3420366720, 3420366735, 'CN', 'CHN', 'الصين'),
(86523, 3420366736, 3420366751, 'KR', 'KOR', 'جمهورية كوريا'),
(86524, 3420366752, 3420366847, 'HK', 'HKG', 'هونغ كونغ'),
(86525, 3420366848, 3420366871, 'JP', 'JPN', 'اليابان'),
(86526, 3420366872, 3420366879, 'KR', 'KOR', 'جمهورية كوريا'),
(86527, 3420366880, 3420366911, 'AU', 'AUS', 'أستراليا'),
(86528, 3420366912, 3420366959, 'JP', 'JPN', 'اليابان'),
(86529, 3420366960, 3420366975, 'KR', 'KOR', 'جمهورية كوريا'),
(86530, 3420366976, 3420367039, 'JP', 'JPN', 'اليابان'),
(86531, 3420367040, 3420367055, 'KR', 'KOR', 'جمهورية كوريا'),
(86532, 3420367056, 3420367103, 'JP', 'JPN', 'اليابان'),
(86533, 3420367104, 3420367359, 'HK', 'HKG', 'هونغ كونغ'),
(86534, 3420367360, 3420367383, 'JP', 'JPN', 'اليابان'),
(86535, 3420367384, 3420367423, 'KR', 'KOR', 'جمهورية كوريا'),
(86536, 3420367424, 3420367495, 'JP', 'JPN', 'اليابان'),
(86537, 3420367496, 3420367503, 'KR', 'KOR', 'جمهورية كوريا'),
(86538, 3420367504, 3420367519, 'AU', 'AUS', 'أستراليا'),
(86539, 3420367520, 3420367631, 'JP', 'JPN', 'اليابان'),
(86540, 3420367632, 3420367647, 'AU', 'AUS', 'أستراليا'),
(86541, 3420367648, 3420367663, 'JP', 'JPN', 'اليابان'),
(86542, 3420367664, 3420367679, 'KR', 'KOR', 'جمهورية كوريا'),
(86543, 3420367680, 3420367743, 'JP', 'JPN', 'اليابان'),
(86544, 3420367744, 3420367775, 'AU', 'AUS', 'أستراليا'),
(86545, 3420367776, 3420367791, 'TW', 'TWN', 'تايوان'),
(86546, 3420367792, 3420367807, 'IN', 'IND', 'الهند'),
(86547, 3420367808, 3420367871, 'JP', 'JPN', 'اليابان'),
(86548, 3420367872, 3420368015, 'AU', 'AUS', 'أستراليا'),
(86549, 3420368016, 3420368031, 'NZ', 'NZL', 'نيوزيلاندا'),
(86550, 3420368032, 3420368063, 'AU', 'AUS', 'أستراليا'),
(86551, 3420368064, 3420368067, 'NZ', 'NZL', 'نيوزيلاندا'),
(86552, 3420368068, 3420368583, 'AU', 'AUS', 'أستراليا'),
(86553, 3420368584, 3420368591, 'CN', 'CHN', 'الصين'),
(86554, 3420368592, 3420368639, 'AU', 'AUS', 'أستراليا'),
(86555, 3420368640, 3420368895, 'NZ', 'NZL', 'نيوزيلاندا'),
(86556, 3420368896, 3420368935, 'HK', 'HKG', 'هونغ كونغ'),
(86557, 3420368936, 3420368943, 'TW', 'TWN', 'تايوان'),
(86558, 3420368944, 3420368991, 'HK', 'HKG', 'هونغ كونغ'),
(86559, 3420368992, 3420369023, 'AU', 'AUS', 'أستراليا'),
(86560, 3420369024, 3420369055, 'HK', 'HKG', 'هونغ كونغ'),
(86561, 3420369056, 3420369087, 'AU', 'AUS', 'أستراليا'),
(86562, 3420369088, 3420369139, 'HK', 'HKG', 'هونغ كونغ'),
(86563, 3420369140, 3420369223, 'CN', 'CHN', 'الصين'),
(86564, 3420369224, 3420369239, 'HK', 'HKG', 'هونغ كونغ'),
(86565, 3420369240, 3420369255, 'TW', 'TWN', 'تايوان'),
(86566, 3420369256, 3420369263, 'CN', 'CHN', 'الصين'),
(86567, 3420369264, 3420369279, 'AU', 'AUS', 'أستراليا'),
(86568, 3420369280, 3420369343, 'HK', 'HKG', 'هونغ كونغ'),
(86569, 3420369344, 3420369407, 'CN', 'CHN', 'الصين'),
(86570, 3420369408, 3420370431, 'AU', 'AUS', 'أستراليا'),
(86571, 3420370432, 3420370527, 'HK', 'HKG', 'هونغ كونغ'),
(86572, 3420370528, 3420370543, 'CN', 'CHN', 'الصين'),
(86573, 3420370544, 3420370559, 'HK', 'HKG', 'هونغ كونغ'),
(86574, 3420370560, 3420370575, 'JP', 'JPN', 'اليابان'),
(86575, 3420370576, 3420370591, 'CN', 'CHN', 'الصين'),
(86576, 3420370592, 3420370623, 'AU', 'AUS', 'أستراليا'),
(86577, 3420370624, 3420370943, 'HK', 'HKG', 'هونغ كونغ'),
(86578, 3420370944, 3420371199, 'JP', 'JPN', 'اليابان'),
(86579, 3420371200, 3420371711, 'AU', 'AUS', 'أستراليا'),
(86580, 3420371712, 3420371775, 'JP', 'JPN', 'اليابان'),
(86581, 3420371776, 3420371807, 'KR', 'KOR', 'جمهورية كوريا'),
(86582, 3420371808, 3420371823, 'HK', 'HKG', 'هونغ كونغ'),
(86583, 3420371824, 3420371839, 'KR', 'KOR', 'جمهورية كوريا'),
(86584, 3420371840, 3420371879, 'IN', 'IND', 'الهند'),
(86585, 3420371880, 3420371887, 'SG', 'SGP', 'سنغافورة'),
(86586, 3420371888, 3420371895, 'CN', 'CHN', 'الصين'),
(86587, 3420371896, 3420371903, 'AU', 'AUS', 'أستراليا'),
(86588, 3420371904, 3420371967, 'IN', 'IND', 'الهند'),
(86589, 3420371968, 3420372223, 'AU', 'AUS', 'أستراليا'),
(86590, 3420372224, 3420372735, 'HK', 'HKG', 'هونغ كونغ'),
(86591, 3420372736, 3420372767, 'TW', 'TWN', 'تايوان'),
(86592, 3420372768, 3420372799, 'SG', 'SGP', 'سنغافورة'),
(86593, 3420372800, 3420372831, 'JP', 'JPN', 'اليابان'),
(86594, 3420372832, 3420372863, 'KR', 'KOR', 'جمهورية كوريا'),
(86595, 3420372864, 3420372895, 'PH', 'PHL', 'الفلبين'),
(86596, 3420372896, 3420372927, 'SG', 'SGP', 'سنغافورة'),
(86597, 3420372928, 3420372943, 'HK', 'HKG', 'هونغ كونغ'),
(86598, 3420372944, 3420372967, 'SG', 'SGP', 'سنغافورة'),
(86599, 3420372968, 3420372975, 'AU', 'AUS', 'أستراليا'),
(86600, 3420372976, 3420372991, 'IN', 'IND', 'الهند'),
(86601, 3420372992, 3420377087, 'HK', 'HKG', 'هونغ كونغ'),
(86602, 3420377088, 3420389375, 'JP', 'JPN', 'اليابان'),
(86603, 3420389376, 3420393471, 'US', 'USA', 'الولايات المتحدة'),
(86604, 3420393472, 3420395519, 'AU', 'AUS', 'أستراليا'),
(86605, 3420395520, 3420397567, 'JP', 'JPN', 'اليابان'),
(86606, 3420397568, 3420401663, 'KH', 'KHM', 'كامبوديا'),
(86607, 3420401664, 3420411903, 'JP', 'JPN', 'اليابان'),
(86608, 3420411904, 3420412415, 'TH', 'THA', 'تايلند'),
(86609, 3420412416, 3420412927, 'ID', 'IDN', 'إندونيسيا'),
(86610, 3420412928, 3420413951, 'BD', 'BGD', 'بنغالاديش'),
(86611, 3420413952, 3420422143, 'KR', 'KOR', 'جمهورية كوريا'),
(86612, 3420422144, 3420430335, 'MY', 'MYS', 'ماليزيا'),
(86613, 3420430336, 3420434431, 'PK', 'PAK', 'باكستان'),
(86614, 3420434432, 3420434687, 'IN', 'IND', 'الهند'),
(86615, 3420434688, 3420434943, 'KR', 'KOR', 'جمهورية كوريا'),
(86616, 3420434944, 3420435199, 'HK', 'HKG', 'هونغ كونغ'),
(86617, 3420435200, 3420435455, 'AU', 'AUS', 'أستراليا'),
(86618, 3420435456, 3420436479, 'JP', 'JPN', 'اليابان'),
(86619, 3420436480, 3420437503, 'AU', 'AUS', 'أستراليا'),
(86620, 3420437504, 3420438527, 'IN', 'IND', 'الهند'),
(86621, 3420438528, 3420454911, 'HK', 'HKG', 'هونغ كونغ'),
(86622, 3420454912, 3422552063, 'KR', 'KOR', 'جمهورية كوريا'),
(86623, 3422552064, 3422848511, 'US', 'USA', 'الولايات المتحدة'),
(86624, 3422848512, 3422848767, 'GB', 'GBR', 'المملكة المتحدة'),
(86625, 3422848768, 3423092735, 'US', 'USA', 'الولايات المتحدة'),
(86626, 3423092736, 3423093759, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(86627, 3423093760, 3423094783, 'US', 'USA', 'الولايات المتحدة'),
(86628, 3423094784, 3423095807, 'CA', 'CAN', 'كندا'),
(86629, 3423095808, 3423111167, 'US', 'USA', 'الولايات المتحدة'),
(86630, 3423113216, 3423119359, 'US', 'USA', 'الولايات المتحدة'),
(86631, 3423120384, 3423143935, 'US', 'USA', 'الولايات المتحدة'),
(86632, 3423143936, 3423145983, 'CA', 'CAN', 'كندا'),
(86633, 3423145984, 3423182847, 'US', 'USA', 'الولايات المتحدة'),
(86634, 3423182848, 3423183743, 'CA', 'CAN', 'كندا'),
(86635, 3423183744, 3423183871, 'EE', 'EST', 'إستونيا'),
(86636, 3423183872, 3423184207, 'CA', 'CAN', 'كندا'),
(86637, 3423184208, 3423184215, 'EE', 'EST', 'إستونيا'),
(86638, 3423184216, 3423184895, 'CA', 'CAN', 'كندا'),
(86639, 3423184896, 3423197183, 'US', 'USA', 'الولايات المتحدة'),
(86640, 3423198208, 3423204095, 'US', 'USA', 'الولايات المتحدة'),
(86641, 3423204096, 3423204351, 'CA', 'CAN', 'كندا'),
(86642, 3423204352, 3423221759, 'US', 'USA', 'الولايات المتحدة'),
(86643, 3423221760, 3423222783, 'CA', 'CAN', 'كندا'),
(86644, 3423222784, 3423235871, 'US', 'USA', 'الولايات المتحدة'),
(86645, 3423235872, 3423235903, 'CA', 'CAN', 'كندا'),
(86646, 3423235904, 3423236095, 'US', 'USA', 'الولايات المتحدة'),
(86647, 3423236096, 3423238143, 'JM', 'JAM', 'جامايكا'),
(86648, 3423238144, 3423258623, 'US', 'USA', 'الولايات المتحدة'),
(86649, 3423258624, 3423260671, 'CA', 'CAN', 'كندا'),
(86650, 3423262720, 3423264831, 'US', 'USA', 'الولايات المتحدة'),
(86651, 3423264832, 3423264863, 'NG', 'NGA', 'نيجيريا'),
(86652, 3423264864, 3423265247, 'US', 'USA', 'الولايات المتحدة'),
(86653, 3423265248, 3423265263, 'EC', 'ECU', 'الإكوادور'),
(86654, 3423265264, 3423268863, 'US', 'USA', 'الولايات المتحدة'),
(86655, 3423268864, 3423269887, 'CA', 'CAN', 'كندا'),
(86656, 3423269888, 3423285247, 'US', 'USA', 'الولايات المتحدة'),
(86657, 3423285248, 3423287295, 'CA', 'CAN', 'كندا'),
(86658, 3423287296, 3423290367, 'US', 'USA', 'الولايات المتحدة'),
(86659, 3423291392, 3423303679, 'US', 'USA', 'الولايات المتحدة'),
(86660, 3423303680, 3423304703, 'CA', 'CAN', 'كندا'),
(86661, 3423304704, 3423311871, 'US', 'USA', 'الولايات المتحدة'),
(86662, 3423311872, 3423313919, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(86663, 3423313920, 3423371263, 'US', 'USA', 'الولايات المتحدة'),
(86664, 3423375360, 3423379455, 'CA', 'CAN', 'كندا'),
(86665, 3423379456, 3423401151, 'US', 'USA', 'الولايات المتحدة'),
(86666, 3423401152, 3423401159, 'RU', 'RUS', 'الإتحاد الروسي'),
(86667, 3423401160, 3423412223, 'US', 'USA', 'الولايات المتحدة'),
(86668, 3423412224, 3423412239, 'CA', 'CAN', 'كندا'),
(86669, 3423412240, 3423412255, 'GR', 'GRC', 'اليونان'),
(86670, 3423412256, 3423412287, 'TK', 'TKL', 'توكيلاو'),
(86671, 3423412288, 3423412319, 'RU', 'RUS', 'الإتحاد الروسي'),
(86672, 3423412320, 3423412415, 'CA', 'CAN', 'كندا'),
(86673, 3423412416, 3423412479, 'SA', 'SAU', 'السعودية'),
(86674, 3423412480, 3423412495, 'CA', 'CAN', 'كندا'),
(86675, 3423412496, 3423412511, 'US', 'USA', 'الولايات المتحدة'),
(86676, 3423412512, 3423412543, 'CA', 'CAN', 'كندا'),
(86677, 3423412544, 3423412623, 'FR', 'FRA', 'فرنسا'),
(86678, 3423412624, 3423412639, 'NO', 'NOR', 'النرويج'),
(86679, 3423412640, 3423412655, 'CA', 'CAN', 'كندا'),
(86680, 3423412656, 3423412671, 'RU', 'RUS', 'الإتحاد الروسي'),
(86681, 3423412672, 3423412703, 'CA', 'CAN', 'كندا'),
(86682, 3423412704, 3423412719, 'RU', 'RUS', 'الإتحاد الروسي'),
(86683, 3423412720, 3423412727, 'US', 'USA', 'الولايات المتحدة'),
(86684, 3423412728, 3423412751, 'CA', 'CAN', 'كندا'),
(86685, 3423412752, 3423412767, 'US', 'USA', 'الولايات المتحدة'),
(86686, 3423412768, 3423412783, 'FI', 'FIN', 'فنلندا'),
(86687, 3423412784, 3423412799, 'CA', 'CAN', 'كندا'),
(86688, 3423412800, 3423412815, 'US', 'USA', 'الولايات المتحدة'),
(86689, 3423412816, 3423412831, 'GR', 'GRC', 'اليونان'),
(86690, 3423412832, 3423412847, 'CA', 'CAN', 'كندا'),
(86691, 3423412848, 3423412863, 'US', 'USA', 'الولايات المتحدة'),
(86692, 3423412864, 3423412927, 'CA', 'CAN', 'كندا'),
(86693, 3423412928, 3423412991, 'NL', 'NLD', 'هولندا'),
(86694, 3423412992, 3423413055, 'CA', 'CAN', 'كندا'),
(86695, 3423413056, 3423413071, 'US', 'USA', 'الولايات المتحدة'),
(86696, 3423413072, 3423413151, 'CA', 'CAN', 'كندا'),
(86697, 3423413152, 3423413167, 'US', 'USA', 'الولايات المتحدة'),
(86698, 3423413168, 3423413183, 'CA', 'CAN', 'كندا'),
(86699, 3423413184, 3423413247, 'RS', 'SRB', 'صربيا'),
(86700, 3423413248, 3423413279, 'US', 'USA', 'الولايات المتحدة'),
(86701, 3423413280, 3423413295, 'SE', 'SWE', 'السويد'),
(86702, 3423413296, 3423413311, 'CA', 'CAN', 'كندا'),
(86703, 3423413312, 3423413327, 'PT', 'PRT', 'البورتوغال'),
(86704, 3423413328, 3423413343, 'US', 'USA', 'الولايات المتحدة'),
(86705, 3423413344, 3423413375, 'CA', 'CAN', 'كندا'),
(86706, 3423413376, 3423413759, 'US', 'USA', 'الولايات المتحدة'),
(86707, 3423413760, 3423414143, 'CA', 'CAN', 'كندا'),
(86708, 3423414144, 3423414159, 'FR', 'FRA', 'فرنسا'),
(86709, 3423414160, 3423414271, 'CA', 'CAN', 'كندا'),
(86710, 3423414272, 3423416319, 'US', 'USA', 'الولايات المتحدة'),
(86711, 3423417344, 3423453183, 'US', 'USA', 'الولايات المتحدة'),
(86712, 3423455232, 3423473663, 'US', 'USA', 'الولايات المتحدة'),
(86713, 3423473664, 3423474687, 'CA', 'CAN', 'كندا'),
(86714, 3423474688, 3423493631, 'US', 'USA', 'الولايات المتحدة'),
(86715, 3423493632, 3423493887, 'CA', 'CAN', 'كندا'),
(86716, 3423493888, 3423533055, 'US', 'USA', 'الولايات المتحدة'),
(86717, 3423533056, 3423535103, 'AI', 'AIA', 'أنغيلا'),
(86718, 3423535104, 3423543295, 'US', 'USA', 'الولايات المتحدة'),
(86719, 3423543296, 3423545343, 'CA', 'CAN', 'كندا'),
(86720, 3423545344, 3423549439, 'US', 'USA', 'الولايات المتحدة'),
(86721, 3423551488, 3423571967, 'US', 'USA', 'الولايات المتحدة'),
(86722, 3423571968, 3423574015, 'PR', 'PRI', 'بورتو ريكو'),
(86723, 3423574016, 3423578111, 'US', 'USA', 'الولايات المتحدة'),
(86724, 3423580160, 3423582207, 'US', 'USA', 'الولايات المتحدة'),
(86725, 3423582208, 3423586303, 'CA', 'CAN', 'كندا'),
(86726, 3423586304, 3423602687, 'US', 'USA', 'الولايات المتحدة'),
(86727, 3423602688, 3423603711, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(86728, 3423603712, 3423609855, 'US', 'USA', 'الولايات المتحدة'),
(86729, 3423610880, 3423626239, 'US', 'USA', 'الولايات المتحدة'),
(86730, 3423626240, 3423627263, 'CA', 'CAN', 'كندا'),
(86731, 3423627264, 3423629311, 'US', 'USA', 'الولايات المتحدة'),
(86732, 3423632384, 3423637503, 'US', 'USA', 'الولايات المتحدة'),
(86733, 3423637504, 3423639551, 'CA', 'CAN', 'كندا'),
(86734, 3423639552, 3423651839, 'US', 'USA', 'الولايات المتحدة'),
(86735, 3423651840, 3423653887, 'CA', 'CAN', 'كندا'),
(86736, 3423653888, 3423705599, 'US', 'USA', 'الولايات المتحدة'),
(86737, 3423705856, 3423718399, 'US', 'USA', 'الولايات المتحدة'),
(86738, 3423718656, 3423722239, 'US', 'USA', 'الولايات المتحدة'),
(86739, 3423722496, 3423731455, 'US', 'USA', 'الولايات المتحدة'),
(86740, 3423731712, 3423797247, 'US', 'USA', 'الولايات المتحدة'),
(86741, 3423797504, 3423801087, 'CA', 'CAN', 'كندا'),
(86742, 3423801344, 3423823359, 'CA', 'CAN', 'كندا'),
(86743, 3423823360, 3423823871, 'US', 'USA', 'الولايات المتحدة'),
(86744, 3423823872, 3423827711, 'CA', 'CAN', 'كندا'),
(86745, 3423827712, 3423827967, 'US', 'USA', 'الولايات المتحدة'),
(86746, 3423827968, 3423830271, 'CA', 'CAN', 'كندا'),
(86747, 3423830528, 3423838719, 'CA', 'CAN', 'كندا'),
(86748, 3423838976, 3423848447, 'CA', 'CAN', 'كندا'),
(86749, 3423848448, 3423849471, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(86750, 3423849984, 3423850495, 'CA', 'CAN', 'كندا'),
(86751, 3423850752, 3423854335, 'CA', 'CAN', 'كندا'),
(86752, 3423854592, 3423858175, 'CA', 'CAN', 'كندا'),
(86753, 3423858176, 3423858687, 'US', 'USA', 'الولايات المتحدة'),
(86754, 3423858688, 3423858943, 'CA', 'CAN', 'كندا'),
(86755, 3423859456, 3423859711, 'CA', 'CAN', 'كندا'),
(86756, 3423859968, 3423862527, 'CA', 'CAN', 'كندا'),
(86757, 3423862784, 3424270847, 'US', 'USA', 'الولايات المتحدة'),
(86758, 3424271360, 3424321279, 'US', 'USA', 'الولايات المتحدة'),
(86759, 3424321536, 3424334847, 'US', 'USA', 'الولايات المتحدة'),
(86760, 3424334848, 3424335871, 'CA', 'CAN', 'كندا'),
(86761, 3424335872, 3424371967, 'US', 'USA', 'الولايات المتحدة'),
(86762, 3424372224, 3424375295, 'US', 'USA', 'الولايات المتحدة'),
(86763, 3424375552, 3424378879, 'US', 'USA', 'الولايات المتحدة'),
(86764, 3424378880, 3424379135, 'PR', 'PRI', 'بورتو ريكو'),
(86765, 3424379136, 3424389631, 'US', 'USA', 'الولايات المتحدة'),
(86766, 3424390144, 3424412415, 'US', 'USA', 'الولايات المتحدة'),
(86767, 3424412672, 3424413695, 'US', 'USA', 'الولايات المتحدة'),
(86768, 3424415744, 3424444159, 'US', 'USA', 'الولايات المتحدة'),
(86769, 3424444416, 3424448511, 'US', 'USA', 'الولايات المتحدة'),
(86770, 3424452608, 3424455423, 'US', 'USA', 'الولايات المتحدة'),
(86771, 3424455680, 3424493823, 'US', 'USA', 'الولايات المتحدة'),
(86772, 3424493824, 3424494079, 'CA', 'CAN', 'كندا'),
(86773, 3424494080, 3424494335, 'US', 'USA', 'الولايات المتحدة'),
(86774, 3424494592, 3424496383, 'US', 'USA', 'الولايات المتحدة'),
(86775, 3424496640, 3424499967, 'US', 'USA', 'الولايات المتحدة'),
(86776, 3424500224, 3424500991, 'US', 'USA', 'الولايات المتحدة'),
(86777, 3424501248, 3424502015, 'US', 'USA', 'الولايات المتحدة'),
(86778, 3424502272, 3424502783, 'US', 'USA', 'الولايات المتحدة'),
(86779, 3424503296, 3424505599, 'US', 'USA', 'الولايات المتحدة'),
(86780, 3424505856, 3424507135, 'US', 'USA', 'الولايات المتحدة'),
(86781, 3424507392, 3425173503, 'US', 'USA', 'الولايات المتحدة'),
(86782, 3425173504, 3425304575, 'CA', 'CAN', 'كندا'),
(86783, 3425304576, 3425450239, 'US', 'USA', 'الولايات المتحدة'),
(86784, 3425451008, 3425470975, 'US', 'USA', 'الولايات المتحدة'),
(86785, 3425471488, 3425475839, 'US', 'USA', 'الولايات المتحدة'),
(86786, 3425476608, 3425697791, 'US', 'USA', 'الولايات المتحدة'),
(86787, 3425697792, 3425699839, 'CA', 'CAN', 'كندا'),
(86788, 3425699840, 3425705983, 'US', 'USA', 'الولايات المتحدة'),
(86789, 3425706752, 3425708287, 'US', 'USA', 'الولايات المتحدة'),
(86790, 3425709824, 3425711359, 'US', 'USA', 'الولايات المتحدة'),
(86791, 3425713408, 3425728255, 'US', 'USA', 'الولايات المتحدة'),
(86792, 3425728512, 3425828863, 'US', 'USA', 'الولايات المتحدة'),
(86793, 3425828864, 3425855231, 'CA', 'CAN', 'كندا'),
(86794, 3425855232, 3425855487, 'US', 'USA', 'الولايات المتحدة'),
(86795, 3425855488, 3425894399, 'CA', 'CAN', 'كندا'),
(86796, 3425894400, 3425962495, 'US', 'USA', 'الولايات المتحدة'),
(86797, 3425963008, 3426010111, 'US', 'USA', 'الولايات المتحدة'),
(86798, 3426010368, 3426012671, 'US', 'USA', 'الولايات المتحدة'),
(86799, 3426012928, 3426013183, 'US', 'USA', 'الولايات المتحدة'),
(86800, 3426013184, 3426013439, 'IL', 'ISR', 'إسرائيل'),
(86801, 3426013440, 3426019327, 'US', 'USA', 'الولايات المتحدة'),
(86802, 3426019584, 3426369023, 'US', 'USA', 'الولايات المتحدة'),
(86803, 3426369536, 3426386687, 'US', 'USA', 'الولايات المتحدة'),
(86804, 3426386944, 3426387711, 'US', 'USA', 'الولايات المتحدة'),
(86805, 3426387968, 3426388991, 'MX', 'MEX', 'المكسيك'),
(86806, 3426388992, 3426390783, 'US', 'USA', 'الولايات المتحدة'),
(86807, 3426391040, 3426415615, 'US', 'USA', 'الولايات المتحدة'),
(86808, 3426415872, 3426416895, 'US', 'USA', 'الولايات المتحدة'),
(86809, 3426417152, 3426418175, 'US', 'USA', 'الولايات المتحدة'),
(86810, 3426418688, 3426553343, 'US', 'USA', 'الولايات المتحدة'),
(86811, 3426553856, 3426557439, 'US', 'USA', 'الولايات المتحدة'),
(86812, 3426557952, 3426602751, 'US', 'USA', 'الولايات المتحدة'),
(86813, 3426603008, 3426605567, 'US', 'USA', 'الولايات المتحدة'),
(86814, 3426606080, 3426617855, 'US', 'USA', 'الولايات المتحدة'),
(86815, 3426618368, 3426644479, 'US', 'USA', 'الولايات المتحدة'),
(86816, 3426644992, 3426646015, 'US', 'USA', 'الولايات المتحدة'),
(86817, 3426646016, 3426647039, 'CA', 'CAN', 'كندا'),
(86818, 3426647040, 3426653695, 'US', 'USA', 'الولايات المتحدة'),
(86819, 3426654208, 3426714879, 'US', 'USA', 'الولايات المتحدة'),
(86820, 3426715648, 3426725375, 'US', 'USA', 'الولايات المتحدة'),
(86821, 3426725888, 3426729471, 'US', 'USA', 'الولايات المتحدة'),
(86822, 3426729984, 3426735359, 'US', 'USA', 'الولايات المتحدة'),
(86823, 3426736128, 3426744319, 'US', 'USA', 'الولايات المتحدة'),
(86824, 3426744320, 3426746367, 'CA', 'CAN', 'كندا'),
(86825, 3426746368, 3427055615, 'US', 'USA', 'الولايات المتحدة'),
(86826, 3427055872, 3427061503, 'US', 'USA', 'الولايات المتحدة'),
(86827, 3427061760, 3427073535, 'US', 'USA', 'الولايات المتحدة'),
(86828, 3427074048, 3427110911, 'US', 'USA', 'الولايات المتحدة'),
(86829, 3427111168, 3427112959, 'US', 'USA', 'الولايات المتحدة'),
(86830, 3427113216, 3427113471, 'US', 'USA', 'الولايات المتحدة'),
(86831, 3427113984, 3427116543, 'US', 'USA', 'الولايات المتحدة'),
(86832, 3427117312, 3427127295, 'US', 'USA', 'الولايات المتحدة'),
(86833, 3427127296, 3427127551, 'CA', 'CAN', 'كندا'),
(86834, 3427127552, 3427127807, 'US', 'USA', 'الولايات المتحدة'),
(86835, 3427128064, 3427128831, 'US', 'USA', 'الولايات المتحدة'),
(86836, 3427129344, 3427130623, 'US', 'USA', 'الولايات المتحدة'),
(86837, 3427130880, 3427134207, 'US', 'USA', 'الولايات المتحدة'),
(86838, 3427134464, 3427136511, 'US', 'USA', 'الولايات المتحدة'),
(86839, 3427137024, 3427139327, 'US', 'USA', 'الولايات المتحدة'),
(86840, 3427139584, 3427404287, 'US', 'USA', 'الولايات المتحدة'),
(86841, 3427404800, 3427454719, 'US', 'USA', 'الولايات المتحدة'),
(86842, 3427454976, 3427470079, 'US', 'USA', 'الولايات المتحدة'),
(86843, 3427470336, 3427503103, 'US', 'USA', 'الولايات المتحدة'),
(86844, 3427503360, 3427503871, 'US', 'USA', 'الولايات المتحدة'),
(86845, 3427504640, 3427507455, 'US', 'USA', 'الولايات المتحدة'),
(86846, 3427507968, 3427511295, 'US', 'USA', 'الولايات المتحدة'),
(86847, 3427511808, 3427540223, 'US', 'USA', 'الولايات المتحدة'),
(86848, 3427540992, 3427567103, 'US', 'USA', 'الولايات المتحدة'),
(86849, 3427567616, 3427572991, 'US', 'USA', 'الولايات المتحدة'),
(86850, 3427573248, 3427582975, 'US', 'USA', 'الولايات المتحدة'),
(86851, 3427583488, 3427584767, 'US', 'USA', 'الولايات المتحدة'),
(86852, 3427585536, 3427586815, 'US', 'USA', 'الولايات المتحدة'),
(86853, 3427587584, 3427589119, 'US', 'USA', 'الولايات المتحدة'),
(86854, 3427589632, 3427597823, 'US', 'USA', 'الولايات المتحدة'),
(86855, 3427598336, 3427605247, 'US', 'USA', 'الولايات المتحدة'),
(86856, 3427605504, 3427632639, 'US', 'USA', 'الولايات المتحدة'),
(86857, 3427633152, 3427635455, 'US', 'USA', 'الولايات المتحدة'),
(86858, 3427635712, 3427636223, 'US', 'USA', 'الولايات المتحدة'),
(86859, 3427636736, 3427636991, 'US', 'USA', 'الولايات المتحدة'),
(86860, 3427637248, 3427637503, 'US', 'USA', 'الولايات المتحدة'),
(86861, 3427637760, 3427639551, 'US', 'USA', 'الولايات المتحدة'),
(86862, 3427640320, 3427641343, 'US', 'USA', 'الولايات المتحدة'),
(86863, 3427641856, 3427642111, 'US', 'USA', 'الولايات المتحدة'),
(86864, 3427642368, 3427646719, 'US', 'USA', 'الولايات المتحدة'),
(86865, 3427646976, 3427647743, 'US', 'USA', 'الولايات المتحدة'),
(86866, 3427648768, 3427649279, 'US', 'USA', 'الولايات المتحدة'),
(86867, 3427649536, 3427651071, 'US', 'USA', 'الولايات المتحدة'),
(86868, 3427651328, 3427652607, 'US', 'USA', 'الولايات المتحدة'),
(86869, 3427653376, 3427653631, 'US', 'USA', 'الولايات المتحدة'),
(86870, 3427654144, 3427655167, 'US', 'USA', 'الولايات المتحدة'),
(86871, 3427655680, 3427742975, 'US', 'USA', 'الولايات المتحدة'),
(86872, 3427742976, 3427743231, 'GB', 'GBR', 'المملكة المتحدة'),
(86873, 3427743232, 3427762175, 'US', 'USA', 'الولايات المتحدة'),
(86874, 3427762176, 3427762431, 'DE', 'DEU', 'ألمانيا'),
(86875, 3427762432, 3427762687, 'CA', 'CAN', 'كندا'),
(86876, 3427762688, 3427763455, 'IT', 'ITA', 'إيطاليا'),
(86877, 3427763456, 3427763711, 'AU', 'AUS', 'أستراليا'),
(86878, 3427763712, 3427763967, 'GB', 'GBR', 'المملكة المتحدة'),
(86879, 3427763968, 3427764223, 'US', 'USA', 'الولايات المتحدة'),
(86880, 3427764224, 3427764479, 'FR', 'FRA', 'فرنسا'),
(86881, 3427764480, 3427765503, 'US', 'USA', 'الولايات المتحدة'),
(86882, 3427765504, 3427765759, 'GB', 'GBR', 'المملكة المتحدة'),
(86883, 3427765760, 3427766271, 'US', 'USA', 'الولايات المتحدة'),
(86884, 3427766272, 3427766783, 'GB', 'GBR', 'المملكة المتحدة'),
(86885, 3427766784, 3427767039, 'SE', 'SWE', 'السويد'),
(86886, 3427767040, 3427767807, 'DE', 'DEU', 'ألمانيا'),
(86887, 3427767808, 3427769599, 'US', 'USA', 'الولايات المتحدة'),
(86888, 3427769600, 3427770111, 'JP', 'JPN', 'اليابان'),
(86889, 3427770112, 3427770367, 'NO', 'NOR', 'النرويج'),
(86890, 3427770368, 3427770623, 'GB', 'GBR', 'المملكة المتحدة'),
(86891, 3427770624, 3427771391, 'CH', 'CHE', 'سويسرا'),
(86892, 3427771392, 3427771647, 'US', 'USA', 'الولايات المتحدة'),
(86893, 3427771648, 3427771903, 'CA', 'CAN', 'كندا'),
(86894, 3427771904, 3427772415, 'CH', 'CHE', 'سويسرا'),
(86895, 3427772416, 3427772671, 'DE', 'DEU', 'ألمانيا'),
(86896, 3427772672, 3427772927, 'HK', 'HKG', 'هونغ كونغ'),
(86897, 3427772928, 3427773183, 'BE', 'BEL', 'بلجيكا'),
(86898, 3427773184, 3427773439, 'DE', 'DEU', 'ألمانيا'),
(86899, 3427773440, 3427773695, 'US', 'USA', 'الولايات المتحدة'),
(86900, 3427773696, 3427773951, 'FR', 'FRA', 'فرنسا'),
(86901, 3427773952, 3427774719, 'US', 'USA', 'الولايات المتحدة'),
(86902, 3427774720, 3427775231, 'DE', 'DEU', 'ألمانيا'),
(86903, 3427775232, 3427775999, 'US', 'USA', 'الولايات المتحدة'),
(86904, 3427776000, 3427776511, 'HK', 'HKG', 'هونغ كونغ'),
(86905, 3427776512, 3427776767, 'CZ', 'CZE', 'التشيك'),
(86906, 3427776768, 3427777023, 'US', 'USA', 'الولايات المتحدة'),
(86907, 3427777024, 3427777279, 'NL', 'NLD', 'هولندا'),
(86908, 3427777280, 3427777535, 'DE', 'DEU', 'ألمانيا'),
(86909, 3427777536, 3427777791, 'US', 'USA', 'الولايات المتحدة'),
(86910, 3427777792, 3427778047, 'HK', 'HKG', 'هونغ كونغ'),
(86911, 3427778048, 3427778303, 'US', 'USA', 'الولايات المتحدة'),
(86912, 3427778304, 3427778559, 'SE', 'SWE', 'السويد'),
(86913, 3427778560, 3427779071, 'NO', 'NOR', 'النرويج'),
(86914, 3427779072, 3427779327, 'GB', 'GBR', 'المملكة المتحدة'),
(86915, 3427779328, 3427780095, 'US', 'USA', 'الولايات المتحدة'),
(86916, 3427780096, 3427780351, 'GB', 'GBR', 'المملكة المتحدة'),
(86917, 3427780352, 3427780607, 'DE', 'DEU', 'ألمانيا'),
(86918, 3427780608, 3427781375, 'US', 'USA', 'الولايات المتحدة'),
(86919, 3427781376, 3427781631, 'GB', 'GBR', 'المملكة المتحدة'),
(86920, 3427781632, 3427781887, 'BE', 'BEL', 'بلجيكا'),
(86921, 3427781888, 3427782399, 'US', 'USA', 'الولايات المتحدة'),
(86922, 3427782400, 3427782655, 'GB', 'GBR', 'المملكة المتحدة'),
(86923, 3427782656, 3427783423, 'FR', 'FRA', 'فرنسا'),
(86924, 3427783424, 3427783679, 'GB', 'GBR', 'المملكة المتحدة'),
(86925, 3427783680, 3427783935, 'US', 'USA', 'الولايات المتحدة'),
(86926, 3427783936, 3427784703, 'GB', 'GBR', 'المملكة المتحدة'),
(86927, 3427784704, 3427785215, 'US', 'USA', 'الولايات المتحدة'),
(86928, 3427785216, 3427785471, 'JP', 'JPN', 'اليابان'),
(86929, 3427785472, 3427785727, 'NO', 'NOR', 'النرويج'),
(86930, 3427785728, 3427786751, 'US', 'USA', 'الولايات المتحدة'),
(86931, 3427786752, 3427787263, 'LU', 'LUX', 'لوكسيمبورغ'),
(86932, 3427787264, 3427787775, 'US', 'USA', 'الولايات المتحدة'),
(86933, 3427787776, 3427788031, 'FR', 'FRA', 'فرنسا'),
(86934, 3427788032, 3427788287, 'CH', 'CHE', 'سويسرا'),
(86935, 3427788288, 3427788799, 'GB', 'GBR', 'المملكة المتحدة'),
(86936, 3427788800, 3427789567, 'NO', 'NOR', 'النرويج'),
(86937, 3427789568, 3427790079, 'DE', 'DEU', 'ألمانيا'),
(86938, 3427790080, 3427790847, 'US', 'USA', 'الولايات المتحدة'),
(86939, 3427790848, 3427791103, 'IT', 'ITA', 'إيطاليا'),
(86940, 3427791104, 3427791615, 'DE', 'DEU', 'ألمانيا'),
(86941, 3427791616, 3427791871, 'GB', 'GBR', 'المملكة المتحدة'),
(86942, 3427791872, 3427792383, 'CA', 'CAN', 'كندا'),
(86943, 3427792384, 3427793919, 'NL', 'NLD', 'هولندا'),
(86944, 3427793920, 3427794175, 'US', 'USA', 'الولايات المتحدة'),
(86945, 3427794176, 3427794943, 'NL', 'NLD', 'هولندا'),
(86946, 3427794944, 3427796991, 'CA', 'CAN', 'كندا'),
(86947, 3427796992, 3427811327, 'US', 'USA', 'الولايات المتحدة'),
(86948, 3427811584, 3427816959, 'US', 'USA', 'الولايات المتحدة'),
(86949, 3427817472, 3427831551, 'US', 'USA', 'الولايات المتحدة'),
(86950, 3427831552, 3427831807, 'MX', 'MEX', 'المكسيك'),
(86951, 3427831808, 3427835647, 'US', 'USA', 'الولايات المتحدة'),
(86952, 3427835904, 3427848959, 'US', 'USA', 'الولايات المتحدة'),
(86953, 3427849216, 3427860479, 'US', 'USA', 'الولايات المتحدة'),
(86954, 3427860480, 3428057087, 'CA', 'CAN', 'كندا'),
(86955, 3428057088, 3428191487, 'US', 'USA', 'الولايات المتحدة'),
(86956, 3428192256, 3428217855, 'US', 'USA', 'الولايات المتحدة'),
(86957, 3428218880, 3428221439, 'US', 'USA', 'الولايات المتحدة'),
(86958, 3428221952, 3428237823, 'US', 'USA', 'الولايات المتحدة'),
(86959, 3428238336, 3428251903, 'US', 'USA', 'الولايات المتحدة'),
(86960, 3428252672, 3428286719, 'US', 'USA', 'الولايات المتحدة'),
(86961, 3428286720, 3428286975, 'CA', 'CAN', 'كندا'),
(86962, 3428286976, 3428290047, 'US', 'USA', 'الولايات المتحدة'),
(86963, 3428290304, 3428296959, 'US', 'USA', 'الولايات المتحدة'),
(86964, 3428296960, 3428297215, 'CL', 'CHL', 'تشيلي'),
(86965, 3428297472, 3428297983, 'US', 'USA', 'الولايات المتحدة'),
(86966, 3428298240, 3428299519, 'US', 'USA', 'الولايات المتحدة'),
(86967, 3428299776, 3428302079, 'US', 'USA', 'الولايات المتحدة'),
(86968, 3428302336, 3428305663, 'US', 'USA', 'الولايات المتحدة'),
(86969, 3428305920, 3428306175, 'US', 'USA', 'الولايات المتحدة'),
(86970, 3428306432, 3428310527, 'US', 'USA', 'الولايات المتحدة'),
(86971, 3428310784, 3428311039, 'US', 'USA', 'الولايات المتحدة'),
(86972, 3428311296, 3428318975, 'US', 'USA', 'الولايات المتحدة'),
(86973, 3428319232, 3428367871, 'US', 'USA', 'الولايات المتحدة'),
(86974, 3428368384, 3428388863, 'US', 'USA', 'الولايات المتحدة'),
(86975, 3428391936, 3428399359, 'US', 'USA', 'الولايات المتحدة'),
(86976, 3428400128, 3428421375, 'US', 'USA', 'الولايات المتحدة'),
(86977, 3428421632, 3428423679, 'US', 'USA', 'الولايات المتحدة'),
(86978, 3428423936, 3428433919, 'US', 'USA', 'الولايات المتحدة'),
(86979, 3428434176, 3428434943, 'US', 'USA', 'الولايات المتحدة'),
(86980, 3428435200, 3428437503, 'US', 'USA', 'الولايات المتحدة'),
(86981, 3428437504, 3428437759, 'MX', 'MEX', 'المكسيك'),
(86982, 3428437760, 3428439551, 'US', 'USA', 'الولايات المتحدة'),
(86983, 3428439808, 3428440575, 'US', 'USA', 'الولايات المتحدة'),
(86984, 3428440832, 3428442367, 'US', 'USA', 'الولايات المتحدة'),
(86985, 3428442624, 3428445695, 'US', 'USA', 'الولايات المتحدة'),
(86986, 3428445952, 3428452863, 'US', 'USA', 'الولايات المتحدة'),
(86987, 3428453376, 3428471807, 'US', 'USA', 'الولايات المتحدة'),
(86988, 3428472064, 3428472831, 'US', 'USA', 'الولايات المتحدة'),
(86989, 3428473088, 3428475391, 'US', 'USA', 'الولايات المتحدة'),
(86990, 3428475648, 3428477439, 'US', 'USA', 'الولايات المتحدة'),
(86991, 3428477696, 3428496639, 'US', 'USA', 'الولايات المتحدة'),
(86992, 3428496640, 3428497151, 'NL', 'NLD', 'هولندا'),
(86993, 3428497152, 3428582655, 'US', 'USA', 'الولايات المتحدة'),
(86994, 3428582656, 3428582911, 'CA', 'CAN', 'كندا'),
(86995, 3428582912, 3428585023, 'US', 'USA', 'الولايات المتحدة'),
(86996, 3428585024, 3428585055, 'CA', 'CAN', 'كندا'),
(86997, 3428585056, 3428585151, 'US', 'USA', 'الولايات المتحدة'),
(86998, 3428585152, 3428585215, 'CA', 'CAN', 'كندا'),
(86999, 3428585216, 3428586239, 'US', 'USA', 'الولايات المتحدة'),
(87000, 3428586240, 3428586495, 'CA', 'CAN', 'كندا'),
(87001, 3428586496, 3428586751, 'US', 'USA', 'الولايات المتحدة'),
(87002, 3428586752, 3428586879, 'CA', 'CAN', 'كندا'),
(87003, 3428586880, 3428587007, 'US', 'USA', 'الولايات المتحدة'),
(87004, 3428587008, 3428587263, 'CA', 'CAN', 'كندا'),
(87005, 3428587264, 3428587775, 'US', 'USA', 'الولايات المتحدة'),
(87006, 3428587776, 3428588287, 'CA', 'CAN', 'كندا'),
(87007, 3428588288, 3428591631, 'US', 'USA', 'الولايات المتحدة'),
(87008, 3428591632, 3428591647, 'CA', 'CAN', 'كندا'),
(87009, 3428591648, 3428591655, 'US', 'USA', 'الولايات المتحدة'),
(87010, 3428591656, 3428591663, 'CA', 'CAN', 'كندا'),
(87011, 3428591664, 3428594687, 'US', 'USA', 'الولايات المتحدة'),
(87012, 3428594688, 3428594943, 'CA', 'CAN', 'كندا'),
(87013, 3428594944, 3428595551, 'US', 'USA', 'الولايات المتحدة'),
(87014, 3428595552, 3428595583, 'CA', 'CAN', 'كندا'),
(87015, 3428595584, 3428598527, 'US', 'USA', 'الولايات المتحدة'),
(87016, 3428598528, 3428598559, 'CA', 'CAN', 'كندا'),
(87017, 3428598560, 3428599551, 'US', 'USA', 'الولايات المتحدة'),
(87018, 3428599552, 3428599807, 'CA', 'CAN', 'كندا'),
(87019, 3428599808, 3428600063, 'US', 'USA', 'الولايات المتحدة'),
(87020, 3428600064, 3428600319, 'CA', 'CAN', 'كندا'),
(87021, 3428600320, 3428601343, 'US', 'USA', 'الولايات المتحدة'),
(87022, 3428601344, 3428601599, 'CA', 'CAN', 'كندا'),
(87023, 3428601600, 3428607999, 'US', 'USA', 'الولايات المتحدة'),
(87024, 3428608000, 3428609023, 'CA', 'CAN', 'كندا'),
(87025, 3428609024, 3428610815, 'US', 'USA', 'الولايات المتحدة'),
(87026, 3428610816, 3428611071, 'CA', 'CAN', 'كندا'),
(87027, 3428611072, 3428612607, 'US', 'USA', 'الولايات المتحدة'),
(87028, 3428612608, 3428612863, 'CA', 'CAN', 'كندا'),
(87029, 3428612864, 3428613119, 'US', 'USA', 'الولايات المتحدة'),
(87030, 3428613120, 3428613631, 'CA', 'CAN', 'كندا'),
(87031, 3428613632, 3428614143, 'US', 'USA', 'الولايات المتحدة'),
(87032, 3428614144, 3428620095, 'CA', 'CAN', 'كندا'),
(87033, 3428620096, 3428620287, 'US', 'USA', 'الولايات المتحدة'),
(87034, 3428620288, 3428621887, 'CA', 'CAN', 'كندا'),
(87035, 3428621888, 3428622047, 'US', 'USA', 'الولايات المتحدة'),
(87036, 3428622048, 3428622095, 'CA', 'CAN', 'كندا'),
(87037, 3428622096, 3428622335, 'US', 'USA', 'الولايات المتحدة'),
(87038, 3428622336, 3428623615, 'CA', 'CAN', 'كندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(87039, 3428623616, 3428623871, 'US', 'USA', 'الولايات المتحدة'),
(87040, 3428623872, 3428624639, 'CA', 'CAN', 'كندا'),
(87041, 3428624640, 3428625407, 'US', 'USA', 'الولايات المتحدة'),
(87042, 3428625408, 3428627199, 'CA', 'CAN', 'كندا'),
(87043, 3428627200, 3428634879, 'US', 'USA', 'الولايات المتحدة'),
(87044, 3428634880, 3428635135, 'CA', 'CAN', 'كندا'),
(87045, 3428635136, 3428635903, 'US', 'USA', 'الولايات المتحدة'),
(87046, 3428635904, 3428636927, 'CA', 'CAN', 'كندا'),
(87047, 3428636928, 3428637439, 'US', 'USA', 'الولايات المتحدة'),
(87048, 3428637440, 3428637951, 'CA', 'CAN', 'كندا'),
(87049, 3428637952, 3428638975, 'US', 'USA', 'الولايات المتحدة'),
(87050, 3428638976, 3428639231, 'CA', 'CAN', 'كندا'),
(87051, 3428639232, 3428642047, 'US', 'USA', 'الولايات المتحدة'),
(87052, 3428642048, 3428642303, 'CA', 'CAN', 'كندا'),
(87053, 3428642304, 3428696063, 'US', 'USA', 'الولايات المتحدة'),
(87054, 3428712448, 3428739327, 'US', 'USA', 'الولايات المتحدة'),
(87055, 3428739328, 3428739343, 'GB', 'GBR', 'المملكة المتحدة'),
(87056, 3428739344, 3428752383, 'US', 'USA', 'الولايات المتحدة'),
(87057, 3428752384, 3428753407, 'GH', 'GHA', 'غانا'),
(87058, 3428753408, 3428756479, 'US', 'USA', 'الولايات المتحدة'),
(87059, 3428756480, 3428756487, 'SE', 'SWE', 'السويد'),
(87060, 3428756488, 3428818727, 'US', 'USA', 'الولايات المتحدة'),
(87061, 3428818728, 3428818735, 'GB', 'GBR', 'المملكة المتحدة'),
(87062, 3428818736, 3428894039, 'US', 'USA', 'الولايات المتحدة'),
(87063, 3428894040, 3428894047, 'CA', 'CAN', 'كندا'),
(87064, 3428894048, 3428958207, 'US', 'USA', 'الولايات المتحدة'),
(87065, 3428958208, 3428962303, 'CO', 'COL', 'كولومبيا'),
(87066, 3428962304, 3429171199, 'US', 'USA', 'الولايات المتحدة'),
(87067, 3429171200, 3429236735, 'CA', 'CAN', 'كندا'),
(87068, 3429236736, 3429396223, 'US', 'USA', 'الولايات المتحدة'),
(87069, 3429396224, 3429396479, 'DE', 'DEU', 'ألمانيا'),
(87070, 3429396480, 3429408511, 'US', 'USA', 'الولايات المتحدة'),
(87071, 3429408512, 3429408767, 'DE', 'DEU', 'ألمانيا'),
(87072, 3429408768, 3429411583, 'US', 'USA', 'الولايات المتحدة'),
(87073, 3429411584, 3429411839, 'DE', 'DEU', 'ألمانيا'),
(87074, 3429411840, 3429500927, 'US', 'USA', 'الولايات المتحدة'),
(87075, 3429500928, 3429502975, 'CA', 'CAN', 'كندا'),
(87076, 3429502976, 3429566975, 'US', 'USA', 'الولايات المتحدة'),
(87077, 3429567488, 3429571071, 'US', 'USA', 'الولايات المتحدة'),
(87078, 3429571584, 3429580799, 'US', 'USA', 'الولايات المتحدة'),
(87079, 3429581056, 3429583103, 'US', 'USA', 'الولايات المتحدة'),
(87080, 3429583360, 3429583615, 'US', 'USA', 'الولايات المتحدة'),
(87081, 3429583872, 3429586431, 'US', 'USA', 'الولايات المتحدة'),
(87082, 3429586688, 3429587199, 'US', 'USA', 'الولايات المتحدة'),
(87083, 3429587456, 3429588223, 'US', 'USA', 'الولايات المتحدة'),
(87084, 3429588480, 3429593855, 'US', 'USA', 'الولايات المتحدة'),
(87085, 3429594112, 3429595647, 'US', 'USA', 'الولايات المتحدة'),
(87086, 3429595904, 3429600511, 'US', 'USA', 'الولايات المتحدة'),
(87087, 3429600768, 3429601535, 'US', 'USA', 'الولايات المتحدة'),
(87088, 3429601792, 3429603071, 'US', 'USA', 'الولايات المتحدة'),
(87089, 3429603328, 3429616639, 'US', 'USA', 'الولايات المتحدة'),
(87090, 3429616896, 3429619711, 'US', 'USA', 'الولايات المتحدة'),
(87091, 3429619968, 3429632767, 'US', 'USA', 'الولايات المتحدة'),
(87092, 3429633024, 3429636607, 'US', 'USA', 'الولايات المتحدة'),
(87093, 3429637120, 3429698815, 'US', 'USA', 'الولايات المتحدة'),
(87094, 3429699584, 3429775359, 'US', 'USA', 'الولايات المتحدة'),
(87095, 3429775360, 3429777407, 'TC', 'TCA', 'جزر تركس وكايكوس'),
(87096, 3429777408, 3429808639, 'US', 'USA', 'الولايات المتحدة'),
(87097, 3429809152, 3429816831, 'US', 'USA', 'الولايات المتحدة'),
(87098, 3429817344, 3429892095, 'US', 'USA', 'الولايات المتحدة'),
(87099, 3429892096, 3429957631, 'CA', 'CAN', 'كندا'),
(87100, 3429957632, 3430025471, 'US', 'USA', 'الولايات المتحدة'),
(87101, 3430026240, 3430090239, 'US', 'USA', 'الولايات المتحدة'),
(87102, 3430090752, 3430092287, 'US', 'USA', 'الولايات المتحدة'),
(87103, 3430092800, 3430094335, 'US', 'USA', 'الولايات المتحدة'),
(87104, 3430094848, 3430104575, 'US', 'USA', 'الولايات المتحدة'),
(87105, 3430105088, 3430110975, 'US', 'USA', 'الولايات المتحدة'),
(87106, 3430111232, 3430114559, 'US', 'USA', 'الولايات المتحدة'),
(87107, 3430115328, 3430116863, 'US', 'USA', 'الولايات المتحدة'),
(87108, 3430117376, 3430118655, 'US', 'USA', 'الولايات المتحدة'),
(87109, 3430119424, 3430120959, 'US', 'USA', 'الولايات المتحدة'),
(87110, 3430121472, 3430127103, 'US', 'USA', 'الولايات المتحدة'),
(87111, 3430127616, 3430137343, 'US', 'USA', 'الولايات المتحدة'),
(87112, 3430137856, 3430141439, 'US', 'USA', 'الولايات المتحدة'),
(87113, 3430141952, 3430146047, 'US', 'USA', 'الولايات المتحدة'),
(87114, 3430148096, 3430153727, 'US', 'USA', 'الولايات المتحدة'),
(87115, 3430154240, 3430291295, 'US', 'USA', 'الولايات المتحدة'),
(87116, 3430291296, 3430291327, 'IS', 'ISL', 'أيسلندا'),
(87117, 3430291328, 3430313967, 'US', 'USA', 'الولايات المتحدة'),
(87118, 3430313968, 3430313983, 'CA', 'CAN', 'كندا'),
(87119, 3430313984, 3430319135, 'US', 'USA', 'الولايات المتحدة'),
(87120, 3430319136, 3430319143, 'SE', 'SWE', 'السويد'),
(87121, 3430319144, 3430328831, 'US', 'USA', 'الولايات المتحدة'),
(87122, 3430328832, 3430329087, 'GH', 'GHA', 'غانا'),
(87123, 3430329088, 3430354943, 'US', 'USA', 'الولايات المتحدة'),
(87124, 3430354944, 3430356991, 'PR', 'PRI', 'بورتو ريكو'),
(87125, 3430356992, 3430681343, 'US', 'USA', 'الولايات المتحدة'),
(87126, 3430681600, 3430682367, 'US', 'USA', 'الولايات المتحدة'),
(87127, 3430682624, 3430683391, 'US', 'USA', 'الولايات المتحدة'),
(87128, 3430683648, 3430699775, 'US', 'USA', 'الولايات المتحدة'),
(87129, 3430700032, 3430700799, 'US', 'USA', 'الولايات المتحدة'),
(87130, 3430701056, 3430702079, 'CA', 'CAN', 'كندا'),
(87131, 3430702080, 3430702847, 'US', 'USA', 'الولايات المتحدة'),
(87132, 3430703104, 3430703871, 'US', 'USA', 'الولايات المتحدة'),
(87133, 3430704128, 3430705151, 'US', 'USA', 'الولايات المتحدة'),
(87134, 3430705152, 3430706175, 'MX', 'MEX', 'المكسيك'),
(87135, 3430706176, 3430707967, 'US', 'USA', 'الولايات المتحدة'),
(87136, 3430708224, 3430714367, 'US', 'USA', 'الولايات المتحدة'),
(87137, 3430715392, 3430719231, 'US', 'USA', 'الولايات المتحدة'),
(87138, 3430719488, 3430721279, 'US', 'USA', 'الولايات المتحدة'),
(87139, 3430721536, 3430722303, 'US', 'USA', 'الولايات المتحدة'),
(87140, 3430722560, 3430727423, 'US', 'USA', 'الولايات المتحدة'),
(87141, 3430727680, 3430730495, 'US', 'USA', 'الولايات المتحدة'),
(87142, 3430730752, 3430734591, 'US', 'USA', 'الولايات المتحدة'),
(87143, 3430734848, 3430738687, 'US', 'USA', 'الولايات المتحدة'),
(87144, 3430738944, 3430739711, 'US', 'USA', 'الولايات المتحدة'),
(87145, 3430739968, 3430742783, 'US', 'USA', 'الولايات المتحدة'),
(87146, 3430743040, 3430812159, 'US', 'USA', 'الولايات المتحدة'),
(87147, 3430812672, 3430813183, 'MX', 'MEX', 'المكسيك'),
(87148, 3430813184, 3430814207, 'US', 'USA', 'الولايات المتحدة'),
(87149, 3430814720, 3430828287, 'US', 'USA', 'الولايات المتحدة'),
(87150, 3430828544, 3430836735, 'US', 'USA', 'الولايات المتحدة'),
(87151, 3430837248, 3430842367, 'US', 'USA', 'الولايات المتحدة'),
(87152, 3430842368, 3430842879, 'DO', 'DOM', 'الدومينيكان'),
(87153, 3430842880, 3430845439, 'US', 'USA', 'الولايات المتحدة'),
(87154, 3430845440, 3430845951, 'MX', 'MEX', 'المكسيك'),
(87155, 3430845952, 3430849535, 'US', 'USA', 'الولايات المتحدة'),
(87156, 3430850048, 3430861823, 'US', 'USA', 'الولايات المتحدة'),
(87157, 3430862336, 3430874367, 'US', 'USA', 'الولايات المتحدة'),
(87158, 3430874624, 3430976767, 'US', 'USA', 'الولايات المتحدة'),
(87159, 3430977024, 3430977791, 'US', 'USA', 'الولايات المتحدة'),
(87160, 3430978304, 3430993151, 'US', 'USA', 'الولايات المتحدة'),
(87161, 3430993408, 3430994431, 'US', 'USA', 'الولايات المتحدة'),
(87162, 3430994688, 3431005183, 'US', 'USA', 'الولايات المتحدة'),
(87163, 3431005440, 3431107583, 'US', 'USA', 'الولايات المتحدة'),
(87164, 3431107840, 3431114495, 'US', 'USA', 'الولايات المتحدة'),
(87165, 3431114496, 3431114751, 'CA', 'CAN', 'كندا'),
(87166, 3431114752, 3431133183, 'US', 'USA', 'الولايات المتحدة'),
(87167, 3431133440, 3431467519, 'US', 'USA', 'الولايات المتحدة'),
(87168, 3431468032, 3431469055, 'CA', 'CAN', 'كندا'),
(87169, 3431469056, 3431537151, 'US', 'USA', 'الولايات المتحدة'),
(87170, 3431537664, 3431596031, 'US', 'USA', 'الولايات المتحدة'),
(87171, 3431596288, 3431602687, 'CA', 'CAN', 'كندا'),
(87172, 3431602944, 3431613439, 'CA', 'CAN', 'كندا'),
(87173, 3431613440, 3431613695, 'US', 'USA', 'الولايات المتحدة'),
(87174, 3431613696, 3431620095, 'CA', 'CAN', 'كندا'),
(87175, 3431620352, 3431621375, 'CA', 'CAN', 'كندا'),
(87176, 3431622400, 3431622655, 'CA', 'CAN', 'كندا'),
(87177, 3431622912, 3431624703, 'CA', 'CAN', 'كندا'),
(87178, 3431624960, 3431625215, 'CA', 'CAN', 'كندا'),
(87179, 3431625472, 3431638783, 'CA', 'CAN', 'كندا'),
(87180, 3431639040, 3431641855, 'CA', 'CAN', 'كندا'),
(87181, 3431642624, 3431657471, 'CA', 'CAN', 'كندا'),
(87182, 3431657472, 3431658495, 'US', 'USA', 'الولايات المتحدة'),
(87183, 3431658496, 3431661311, 'CA', 'CAN', 'كندا'),
(87184, 3431661568, 3431675903, 'US', 'USA', 'الولايات المتحدة'),
(87185, 3431677952, 3431731199, 'US', 'USA', 'الولايات المتحدة'),
(87186, 3431734272, 3431753727, 'US', 'USA', 'الولايات المتحدة'),
(87187, 3431753728, 3431759615, 'CA', 'CAN', 'كندا'),
(87188, 3431759616, 3432003839, 'US', 'USA', 'الولايات المتحدة'),
(87189, 3432004608, 3432005631, 'CA', 'CAN', 'كندا'),
(87190, 3432005632, 3432009215, 'US', 'USA', 'الولايات المتحدة'),
(87191, 3432009216, 3432009471, 'PR', 'PRI', 'بورتو ريكو'),
(87192, 3432009472, 3432019455, 'US', 'USA', 'الولايات المتحدة'),
(87193, 3432019968, 3432075263, 'US', 'USA', 'الولايات المتحدة'),
(87194, 3432079360, 3432084479, 'US', 'USA', 'الولايات المتحدة'),
(87195, 3432085248, 3432095231, 'US', 'USA', 'الولايات المتحدة'),
(87196, 3432095488, 3432099839, 'US', 'USA', 'الولايات المتحدة'),
(87197, 3432100096, 3432106239, 'US', 'USA', 'الولايات المتحدة'),
(87198, 3432106240, 3432106495, 'MX', 'MEX', 'المكسيك'),
(87199, 3432106496, 3432108543, 'US', 'USA', 'الولايات المتحدة'),
(87200, 3432108800, 3432110847, 'US', 'USA', 'الولايات المتحدة'),
(87201, 3432111104, 3432112639, 'US', 'USA', 'الولايات المتحدة'),
(87202, 3432112896, 3432113407, 'US', 'USA', 'الولايات المتحدة'),
(87203, 3432113408, 3432113663, 'CA', 'CAN', 'كندا'),
(87204, 3432113664, 3432116479, 'US', 'USA', 'الولايات المتحدة'),
(87205, 3432116736, 3432205311, 'US', 'USA', 'الولايات المتحدة'),
(87206, 3432205312, 3432206335, 'CA', 'CAN', 'كندا'),
(87207, 3432206336, 3432237567, 'US', 'USA', 'الولايات المتحدة'),
(87208, 3432238080, 3432513535, 'US', 'USA', 'الولايات المتحدة'),
(87209, 3432514048, 3432515071, 'US', 'USA', 'الولايات المتحدة'),
(87210, 3432515584, 3432517119, 'US', 'USA', 'الولايات المتحدة'),
(87211, 3432517632, 3432518143, 'US', 'USA', 'الولايات المتحدة'),
(87212, 3432518656, 3432519167, 'US', 'USA', 'الولايات المتحدة'),
(87213, 3432519680, 3432520703, 'US', 'USA', 'الولايات المتحدة'),
(87214, 3432520704, 3432520959, 'GB', 'GBR', 'المملكة المتحدة'),
(87215, 3432520960, 3432523263, 'US', 'USA', 'الولايات المتحدة'),
(87216, 3432523776, 3432526335, 'US', 'USA', 'الولايات المتحدة'),
(87217, 3432526848, 3432536575, 'US', 'USA', 'الولايات المتحدة'),
(87218, 3432537088, 3432538879, 'US', 'USA', 'الولايات المتحدة'),
(87219, 3432539136, 3432540415, 'US', 'USA', 'الولايات المتحدة'),
(87220, 3432540672, 3432550911, 'US', 'USA', 'الولايات المتحدة'),
(87221, 3432551424, 3432551935, 'US', 'USA', 'الولايات المتحدة'),
(87222, 3432552448, 3432579071, 'US', 'USA', 'الولايات المتحدة'),
(87223, 3432580096, 3432580863, 'US', 'USA', 'الولايات المتحدة'),
(87224, 3432581120, 3432585215, 'US', 'USA', 'الولايات المتحدة'),
(87225, 3432585216, 3432585727, 'MX', 'MEX', 'المكسيك'),
(87226, 3432586240, 3432588031, 'US', 'USA', 'الولايات المتحدة'),
(87227, 3432588288, 3432589055, 'US', 'USA', 'الولايات المتحدة'),
(87228, 3432589312, 3432593151, 'US', 'USA', 'الولايات المتحدة'),
(87229, 3432593408, 3432596223, 'US', 'USA', 'الولايات المتحدة'),
(87230, 3432596480, 3432605695, 'US', 'USA', 'الولايات المتحدة'),
(87231, 3432605952, 3432610559, 'US', 'USA', 'الولايات المتحدة'),
(87232, 3432610816, 3432611839, 'US', 'USA', 'الولايات المتحدة'),
(87233, 3432612864, 3432613631, 'US', 'USA', 'الولايات المتحدة'),
(87234, 3432613888, 3432614655, 'US', 'USA', 'الولايات المتحدة'),
(87235, 3432614912, 3432615679, 'US', 'USA', 'الولايات المتحدة'),
(87236, 3432615936, 3432634111, 'US', 'USA', 'الولايات المتحدة'),
(87237, 3432634368, 3432635135, 'US', 'USA', 'الولايات المتحدة'),
(87238, 3432635392, 3432660991, 'US', 'USA', 'الولايات المتحدة'),
(87239, 3432660992, 3432662527, 'DE', 'DEU', 'ألمانيا'),
(87240, 3432662528, 3432662531, 'PT', 'PRT', 'البورتوغال'),
(87241, 3432662532, 3432663039, 'DE', 'DEU', 'ألمانيا'),
(87242, 3432663040, 3432668671, 'US', 'USA', 'الولايات المتحدة'),
(87243, 3432669184, 3432670719, 'US', 'USA', 'الولايات المتحدة'),
(87244, 3432671232, 3432672511, 'US', 'USA', 'الولايات المتحدة'),
(87245, 3432673280, 3432675583, 'US', 'USA', 'الولايات المتحدة'),
(87246, 3432677376, 3432680703, 'US', 'USA', 'الولايات المتحدة'),
(87247, 3432681472, 3432683263, 'US', 'USA', 'الولايات المتحدة'),
(87248, 3432683520, 3432688895, 'US', 'USA', 'الولايات المتحدة'),
(87249, 3432689664, 3432695807, 'US', 'USA', 'الولايات المتحدة'),
(87250, 3432697856, 3432703231, 'US', 'USA', 'الولايات المتحدة'),
(87251, 3432704000, 3432716799, 'US', 'USA', 'الولايات المتحدة'),
(87252, 3432717312, 3432734463, 'US', 'USA', 'الولايات المتحدة'),
(87253, 3432734720, 3432806655, 'US', 'USA', 'الولايات المتحدة'),
(87254, 3432807424, 3432808447, 'CA', 'CAN', 'كندا'),
(87255, 3432808448, 3433955327, 'US', 'USA', 'الولايات المتحدة'),
(87256, 3433955584, 3433964799, 'CA', 'CAN', 'كندا'),
(87257, 3433965056, 3433967359, 'CA', 'CAN', 'كندا'),
(87258, 3433967616, 3433981951, 'CA', 'CAN', 'كندا'),
(87259, 3433981952, 3433983999, 'US', 'USA', 'الولايات المتحدة'),
(87260, 3433984000, 3434012671, 'CA', 'CAN', 'كندا'),
(87261, 3434012928, 3434014719, 'CA', 'CAN', 'كندا'),
(87262, 3434015232, 3434020607, 'CA', 'CAN', 'كندا'),
(87263, 3434020864, 3434299391, 'US', 'USA', 'الولايات المتحدة'),
(87264, 3434299392, 3434303487, 'VE', 'VEN', 'فنزويلا'),
(87265, 3434303488, 3434423295, 'US', 'USA', 'الولايات المتحدة'),
(87266, 3434423296, 3434423303, 'CA', 'CAN', 'كندا'),
(87267, 3434423304, 3434427391, 'US', 'USA', 'الولايات المتحدة'),
(87268, 3434427392, 3434428415, 'HN', 'HND', 'هندوراس'),
(87269, 3434428416, 3434433279, 'US', 'USA', 'الولايات المتحدة'),
(87270, 3434433280, 3434433535, 'PR', 'PRI', 'بورتو ريكو'),
(87271, 3434433536, 3434571775, 'US', 'USA', 'الولايات المتحدة'),
(87272, 3434571776, 3434573823, 'CO', 'COL', 'كولومبيا'),
(87273, 3434573824, 3434577407, 'US', 'USA', 'الولايات المتحدة'),
(87274, 3434577408, 3434577663, 'CA', 'CAN', 'كندا'),
(87275, 3434577664, 3434583039, 'US', 'USA', 'الولايات المتحدة'),
(87276, 3434583040, 3434584063, 'NL', 'NLD', 'هولندا'),
(87277, 3434584064, 3434807295, 'US', 'USA', 'الولايات المتحدة'),
(87278, 3434807552, 3434810111, 'CA', 'CAN', 'كندا'),
(87279, 3434810368, 3434824191, 'CA', 'CAN', 'كندا'),
(87280, 3434824448, 3434831359, 'CA', 'CAN', 'كندا'),
(87281, 3434831360, 3434831615, 'US', 'USA', 'الولايات المتحدة'),
(87282, 3434831616, 3434872575, 'CA', 'CAN', 'كندا'),
(87283, 3434872832, 3434907647, 'US', 'USA', 'الولايات المتحدة'),
(87284, 3434907648, 3434909695, 'PA', 'PAN', 'بنما'),
(87285, 3434909696, 3434913791, 'US', 'USA', 'الولايات المتحدة'),
(87286, 3434913792, 3434914047, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87287, 3434914048, 3434914303, 'DM', 'DMA', 'دومينيكا'),
(87288, 3434914304, 3434914815, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87289, 3434914816, 3434915071, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(87290, 3434915072, 3434915327, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87291, 3434915328, 3434915583, 'DM', 'DMA', 'دومينيكا'),
(87292, 3434915584, 3434915839, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(87293, 3434915840, 3434916095, 'LC', 'LCA', 'سانت لوسيا'),
(87294, 3434916096, 3434916351, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87295, 3434916352, 3434916607, 'DM', 'DMA', 'دومينيكا'),
(87296, 3434916608, 3434917119, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87297, 3434917120, 3434917375, 'LC', 'LCA', 'سانت لوسيا'),
(87298, 3434917376, 3434917887, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87299, 3434917888, 3435069439, 'US', 'USA', 'الولايات المتحدة'),
(87300, 3435069440, 3435134975, 'CA', 'CAN', 'كندا'),
(87301, 3435134976, 3435267839, 'US', 'USA', 'الولايات المتحدة'),
(87302, 3435268096, 3435271423, 'US', 'USA', 'الولايات المتحدة'),
(87303, 3435272192, 3435294463, 'US', 'USA', 'الولايات المتحدة'),
(87304, 3435294720, 3435319039, 'US', 'USA', 'الولايات المتحدة'),
(87305, 3435319296, 3435320831, 'US', 'USA', 'الولايات المتحدة'),
(87306, 3435321344, 3435322879, 'US', 'USA', 'الولايات المتحدة'),
(87307, 3435323392, 3435364351, 'US', 'USA', 'الولايات المتحدة'),
(87308, 3435397120, 3435495423, 'US', 'USA', 'الولايات المتحدة'),
(87309, 3435528192, 3436249087, 'US', 'USA', 'الولايات المتحدة'),
(87310, 3436249344, 3436255743, 'CA', 'CAN', 'كندا'),
(87311, 3436256256, 3436278271, 'CA', 'CAN', 'كندا'),
(87312, 3436278528, 3436282367, 'CA', 'CAN', 'كندا'),
(87313, 3436282368, 3436282623, 'US', 'USA', 'الولايات المتحدة'),
(87314, 3436282624, 3436289791, 'CA', 'CAN', 'كندا'),
(87315, 3436289792, 3436290047, 'US', 'USA', 'الولايات المتحدة'),
(87316, 3436290048, 3436314367, 'CA', 'CAN', 'كندا'),
(87317, 3436314624, 3436476415, 'US', 'USA', 'الولايات المتحدة'),
(87318, 3436476416, 3436478463, 'AW', 'ABW', 'أروبا'),
(87319, 3436478464, 3436697087, 'US', 'USA', 'الولايات المتحدة'),
(87320, 3436697088, 3436697343, 'VE', 'VEN', 'فنزويلا'),
(87321, 3436697344, 3437297663, 'US', 'USA', 'الولايات المتحدة'),
(87322, 3437297920, 3437307391, 'CA', 'CAN', 'كندا'),
(87323, 3437307904, 3437310975, 'CA', 'CAN', 'كندا'),
(87324, 3437310976, 3437311487, 'US', 'USA', 'الولايات المتحدة'),
(87325, 3437311488, 3437331711, 'CA', 'CAN', 'كندا'),
(87326, 3437331712, 3437331967, 'US', 'USA', 'الولايات المتحدة'),
(87327, 3437331968, 3437332479, 'CA', 'CAN', 'كندا'),
(87328, 3437332736, 3437334015, 'CA', 'CAN', 'كندا'),
(87329, 3437334016, 3437334271, 'US', 'USA', 'الولايات المتحدة'),
(87330, 3437334272, 3437334783, 'CA', 'CAN', 'كندا'),
(87331, 3437335552, 3437336063, 'CA', 'CAN', 'كندا'),
(87332, 3437336320, 3437341695, 'CA', 'CAN', 'كندا'),
(87333, 3437341696, 3437341951, 'US', 'USA', 'الولايات المتحدة'),
(87334, 3437341952, 3437343231, 'CA', 'CAN', 'كندا'),
(87335, 3437343488, 3437346303, 'CA', 'CAN', 'كندا'),
(87336, 3437346560, 3437350911, 'CA', 'CAN', 'كندا'),
(87337, 3437351424, 3437354751, 'CA', 'CAN', 'كندا'),
(87338, 3437355008, 3437358847, 'CA', 'CAN', 'كندا'),
(87339, 3437358848, 3437359103, 'US', 'USA', 'الولايات المتحدة'),
(87340, 3437359104, 3437362943, 'CA', 'CAN', 'كندا'),
(87341, 3437363200, 3437428735, 'CA', 'CAN', 'كندا'),
(87342, 3437428736, 3437715711, 'US', 'USA', 'الولايات المتحدة'),
(87343, 3437715712, 3437715967, 'IT', 'ITA', 'إيطاليا'),
(87344, 3437715968, 3437736447, 'US', 'USA', 'الولايات المتحدة'),
(87345, 3437736448, 3437737471, 'CL', 'CHL', 'تشيلي'),
(87346, 3437737472, 3437748223, 'US', 'USA', 'الولايات المتحدة'),
(87347, 3437748224, 3437748479, 'GB', 'GBR', 'المملكة المتحدة'),
(87348, 3437748480, 3437748991, 'NL', 'NLD', 'هولندا'),
(87349, 3437748992, 3437749247, 'US', 'USA', 'الولايات المتحدة'),
(87350, 3437749248, 3437749503, 'DE', 'DEU', 'ألمانيا'),
(87351, 3437749504, 3437749759, 'US', 'USA', 'الولايات المتحدة'),
(87352, 3437749760, 3437750015, 'JP', 'JPN', 'اليابان'),
(87353, 3437750016, 3437750271, 'BE', 'BEL', 'بلجيكا'),
(87354, 3437750272, 3437750527, 'GB', 'GBR', 'المملكة المتحدة'),
(87355, 3437750528, 3437751551, 'US', 'USA', 'الولايات المتحدة'),
(87356, 3437751552, 3437751807, 'IT', 'ITA', 'إيطاليا'),
(87357, 3437751808, 3437752063, 'GB', 'GBR', 'المملكة المتحدة'),
(87358, 3437752064, 3437752319, 'ES', 'ESP', 'إسبانيا'),
(87359, 3437752320, 3437752575, 'IE', 'IRL', 'إيرلندا'),
(87360, 3437752832, 3437755135, 'US', 'USA', 'الولايات المتحدة'),
(87361, 3437755136, 3437755647, 'JP', 'JPN', 'اليابان'),
(87362, 3437755648, 3437755903, 'GB', 'GBR', 'المملكة المتحدة'),
(87363, 3437755904, 3437756159, 'US', 'USA', 'الولايات المتحدة'),
(87364, 3437756160, 3437756415, 'IE', 'IRL', 'إيرلندا'),
(87365, 3437756416, 3437772799, 'US', 'USA', 'الولايات المتحدة'),
(87366, 3437772800, 3437776895, 'CA', 'CAN', 'كندا'),
(87367, 3437789184, 3437961215, 'US', 'USA', 'الولايات المتحدة'),
(87368, 3437964288, 3437979903, 'US', 'USA', 'الولايات المتحدة'),
(87369, 3437980672, 3437984255, 'US', 'USA', 'الولايات المتحدة'),
(87370, 3437984768, 3437989375, 'US', 'USA', 'الولايات المتحدة'),
(87371, 3437989888, 3438006271, 'US', 'USA', 'الولايات المتحدة'),
(87372, 3438006272, 3438010367, 'CA', 'CAN', 'كندا'),
(87373, 3438010368, 3438034943, 'US', 'USA', 'الولايات المتحدة'),
(87374, 3438034944, 3438051327, 'BS', 'BHS', 'جزر البهاما'),
(87375, 3438051328, 3438084095, 'US', 'USA', 'الولايات المتحدة'),
(87376, 3438084096, 3438116863, 'CA', 'CAN', 'كندا'),
(87377, 3438116864, 3438160895, 'US', 'USA', 'الولايات المتحدة'),
(87378, 3438161152, 3438200063, 'US', 'USA', 'الولايات المتحدة'),
(87379, 3438200576, 3438214655, 'US', 'USA', 'الولايات المتحدة'),
(87380, 3438214912, 3438215167, 'US', 'USA', 'الولايات المتحدة'),
(87381, 3438215424, 3438215935, 'CA', 'CAN', 'كندا'),
(87382, 3438216192, 3438217983, 'CA', 'CAN', 'كندا'),
(87383, 3438218240, 3438218751, 'CA', 'CAN', 'كندا'),
(87384, 3438219264, 3438219519, 'CA', 'CAN', 'كندا'),
(87385, 3438219776, 3438246911, 'CA', 'CAN', 'كندا'),
(87386, 3438247168, 3438252543, 'CA', 'CAN', 'كندا'),
(87387, 3438252800, 3438261759, 'CA', 'CAN', 'كندا'),
(87388, 3438262016, 3438280447, 'CA', 'CAN', 'كندا'),
(87389, 3438280704, 3438542847, 'US', 'USA', 'الولايات المتحدة'),
(87390, 3438542848, 3438545423, 'CA', 'CAN', 'كندا'),
(87391, 3438545424, 3438545431, 'US', 'USA', 'الولايات المتحدة'),
(87392, 3438545432, 3438545471, 'CA', 'CAN', 'كندا'),
(87393, 3438545472, 3438545479, 'US', 'USA', 'الولايات المتحدة'),
(87394, 3438545480, 3438550071, 'CA', 'CAN', 'كندا'),
(87395, 3438550072, 3438550079, 'US', 'USA', 'الولايات المتحدة'),
(87396, 3438550080, 3438550447, 'CA', 'CAN', 'كندا'),
(87397, 3438550448, 3438550463, 'US', 'USA', 'الولايات المتحدة'),
(87398, 3438550464, 3438552271, 'CA', 'CAN', 'كندا'),
(87399, 3438552272, 3438552287, 'US', 'USA', 'الولايات المتحدة'),
(87400, 3438552288, 3438570031, 'CA', 'CAN', 'كندا'),
(87401, 3438570032, 3438570047, 'MY', 'MYS', 'ماليزيا'),
(87402, 3438570048, 3438600319, 'CA', 'CAN', 'كندا'),
(87403, 3438600320, 3438600351, 'US', 'USA', 'الولايات المتحدة'),
(87404, 3438600352, 3438608383, 'CA', 'CAN', 'كندا'),
(87405, 3438608384, 3438813183, 'US', 'USA', 'الولايات المتحدة'),
(87406, 3438813184, 3438814207, 'GH', 'GHA', 'غانا'),
(87407, 3438814208, 3438895103, 'US', 'USA', 'الولايات المتحدة'),
(87408, 3438895104, 3438896639, 'HN', 'HND', 'هندوراس'),
(87409, 3438896640, 3439059711, 'US', 'USA', 'الولايات المتحدة'),
(87410, 3439059712, 3439059967, 'PR', 'PRI', 'بورتو ريكو'),
(87411, 3439059968, 3439183359, 'US', 'USA', 'الولايات المتحدة'),
(87412, 3439183360, 3439183871, 'HT', 'HTI', 'هايتي'),
(87413, 3439183872, 3447991551, 'US', 'USA', 'الولايات المتحدة'),
(87414, 3447991808, 3448004095, 'US', 'USA', 'الولايات المتحدة'),
(87415, 3448004608, 3448263423, 'US', 'USA', 'الولايات المتحدة'),
(87416, 3448263424, 3448263935, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87417, 3448263936, 3448338687, 'US', 'USA', 'الولايات المتحدة'),
(87418, 3448338688, 3448339455, 'GB', 'GBR', 'المملكة المتحدة'),
(87419, 3448339456, 3448377343, 'US', 'USA', 'الولايات المتحدة'),
(87420, 3448377344, 3448377855, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87421, 3448377856, 3448379415, 'US', 'USA', 'الولايات المتحدة'),
(87422, 3448379416, 3448379423, 'IL', 'ISR', 'إسرائيل'),
(87423, 3448379424, 3448379439, 'US', 'USA', 'الولايات المتحدة'),
(87424, 3448379440, 3448379447, 'SG', 'SGP', 'سنغافورة'),
(87425, 3448379448, 3448379519, 'US', 'USA', 'الولايات المتحدة'),
(87426, 3448379520, 3448379647, 'IN', 'IND', 'الهند'),
(87427, 3448379648, 3448379903, 'SG', 'SGP', 'سنغافورة'),
(87428, 3448379904, 3448380063, 'US', 'USA', 'الولايات المتحدة'),
(87429, 3448380064, 3448380079, 'SG', 'SGP', 'سنغافورة'),
(87430, 3448380080, 3448380095, 'US', 'USA', 'الولايات المتحدة'),
(87431, 3448380096, 3448380239, 'SG', 'SGP', 'سنغافورة'),
(87432, 3448380240, 3448380255, 'US', 'USA', 'الولايات المتحدة'),
(87433, 3448380256, 3448380287, 'SG', 'SGP', 'سنغافورة'),
(87434, 3448380288, 3448380415, 'US', 'USA', 'الولايات المتحدة'),
(87435, 3448380416, 3448380719, 'SG', 'SGP', 'سنغافورة'),
(87436, 3448380720, 3448380735, 'US', 'USA', 'الولايات المتحدة'),
(87437, 3448380736, 3448380775, 'SG', 'SGP', 'سنغافورة'),
(87438, 3448380776, 3448380783, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(87439, 3448380784, 3448380799, 'SG', 'SGP', 'سنغافورة'),
(87440, 3448380800, 3448380839, 'US', 'USA', 'الولايات المتحدة'),
(87441, 3448380840, 3448380847, 'SG', 'SGP', 'سنغافورة'),
(87442, 3448380848, 3448380927, 'US', 'USA', 'الولايات المتحدة'),
(87443, 3448380928, 3448380943, 'SG', 'SGP', 'سنغافورة'),
(87444, 3448380944, 3448381183, 'US', 'USA', 'الولايات المتحدة'),
(87445, 3448381184, 3448381439, 'SG', 'SGP', 'سنغافورة'),
(87446, 3448381440, 3448381695, 'GB', 'GBR', 'المملكة المتحدة'),
(87447, 3448381696, 3448382343, 'US', 'USA', 'الولايات المتحدة'),
(87448, 3448382344, 3448382351, 'IE', 'IRL', 'إيرلندا'),
(87449, 3448382352, 3448382415, 'US', 'USA', 'الولايات المتحدة'),
(87450, 3448382416, 3448382423, 'GB', 'GBR', 'المملكة المتحدة'),
(87451, 3448382424, 3448397887, 'US', 'USA', 'الولايات المتحدة'),
(87452, 3448397888, 3448397967, 'CA', 'CAN', 'كندا'),
(87453, 3448397968, 3448398335, 'US', 'USA', 'الولايات المتحدة'),
(87454, 3448398336, 3448399103, 'CA', 'CAN', 'كندا'),
(87455, 3448399104, 3448399359, 'US', 'USA', 'الولايات المتحدة'),
(87456, 3448399360, 3448399871, 'CA', 'CAN', 'كندا'),
(87457, 3448399872, 3448411391, 'US', 'USA', 'الولايات المتحدة'),
(87458, 3448411392, 3448411455, 'CA', 'CAN', 'كندا'),
(87459, 3448411456, 3448461311, 'US', 'USA', 'الولايات المتحدة'),
(87460, 3448461312, 3448461391, 'GB', 'GBR', 'المملكة المتحدة'),
(87461, 3448461392, 3448461415, 'US', 'USA', 'الولايات المتحدة'),
(87462, 3448461416, 3448461423, 'SG', 'SGP', 'سنغافورة'),
(87463, 3448461424, 3448461431, 'US', 'USA', 'الولايات المتحدة'),
(87464, 3448461432, 3448461439, 'GB', 'GBR', 'المملكة المتحدة'),
(87465, 3448461440, 3448461543, 'US', 'USA', 'الولايات المتحدة'),
(87466, 3448461544, 3448461551, 'GB', 'GBR', 'المملكة المتحدة'),
(87467, 3448461552, 3448461559, 'US', 'USA', 'الولايات المتحدة'),
(87468, 3448461560, 3448461567, 'GB', 'GBR', 'المملكة المتحدة'),
(87469, 3448461568, 3448461599, 'SG', 'SGP', 'سنغافورة'),
(87470, 3448461600, 3448461631, 'US', 'USA', 'الولايات المتحدة'),
(87471, 3448461632, 3448461695, 'SG', 'SGP', 'سنغافورة'),
(87472, 3448461696, 3448461735, 'US', 'USA', 'الولايات المتحدة'),
(87473, 3448461736, 3448461743, 'GB', 'GBR', 'المملكة المتحدة'),
(87474, 3448461744, 3448462111, 'US', 'USA', 'الولايات المتحدة'),
(87475, 3448462112, 3448462127, 'SG', 'SGP', 'سنغافورة'),
(87476, 3448462128, 3448462143, 'US', 'USA', 'الولايات المتحدة'),
(87477, 3448462144, 3448462223, 'SG', 'SGP', 'سنغافورة'),
(87478, 3448462224, 3448462239, 'GB', 'GBR', 'المملكة المتحدة'),
(87479, 3448462240, 3448462255, 'US', 'USA', 'الولايات المتحدة'),
(87480, 3448462256, 3448462271, 'GB', 'GBR', 'المملكة المتحدة'),
(87481, 3448462272, 3448500479, 'US', 'USA', 'الولايات المتحدة'),
(87482, 3448500480, 3448500735, 'SG', 'SGP', 'سنغافورة'),
(87483, 3448500736, 3448556671, 'US', 'USA', 'الولايات المتحدة'),
(87484, 3448556672, 3448556735, 'GB', 'GBR', 'المملكة المتحدة'),
(87485, 3448556736, 3448556799, 'US', 'USA', 'الولايات المتحدة'),
(87486, 3448556800, 3448556815, 'GB', 'GBR', 'المملكة المتحدة'),
(87487, 3448556816, 3448558911, 'US', 'USA', 'الولايات المتحدة'),
(87488, 3448558912, 3448558919, 'GB', 'GBR', 'المملكة المتحدة'),
(87489, 3448558920, 3448559103, 'US', 'USA', 'الولايات المتحدة'),
(87490, 3448559104, 3448559359, 'GB', 'GBR', 'المملكة المتحدة'),
(87491, 3448559360, 3448637183, 'US', 'USA', 'الولايات المتحدة'),
(87492, 3448637440, 3448638975, 'US', 'USA', 'الولايات المتحدة'),
(87493, 3448639488, 3448647423, 'US', 'USA', 'الولايات المتحدة'),
(87494, 3448647680, 3448651775, 'US', 'USA', 'الولايات المتحدة'),
(87495, 3448652800, 3448871935, 'US', 'USA', 'الولايات المتحدة'),
(87496, 3448872448, 3448872703, 'US', 'USA', 'الولايات المتحدة'),
(87497, 3448872960, 3449001245, 'US', 'USA', 'الولايات المتحدة'),
(87498, 3449001246, 3449001246, 'MC', 'MCO', 'موناكو'),
(87499, 3449001247, 3449096191, 'US', 'USA', 'الولايات المتحدة'),
(87500, 3449098240, 3449159679, 'US', 'USA', 'الولايات المتحدة'),
(87501, 3449159680, 3449159935, 'CA', 'CAN', 'كندا'),
(87502, 3449159936, 3449160191, 'US', 'USA', 'الولايات المتحدة'),
(87503, 3449160192, 3449160447, 'CA', 'CAN', 'كندا'),
(87504, 3449160448, 3449163775, 'US', 'USA', 'الولايات المتحدة'),
(87505, 3449163776, 3449164031, 'CA', 'CAN', 'كندا'),
(87506, 3449164032, 3449164799, 'US', 'USA', 'الولايات المتحدة'),
(87507, 3449164800, 3449165055, 'CA', 'CAN', 'كندا'),
(87508, 3449165056, 3449166847, 'US', 'USA', 'الولايات المتحدة'),
(87509, 3449166848, 3449167103, 'CA', 'CAN', 'كندا'),
(87510, 3449167104, 3449167359, 'US', 'USA', 'الولايات المتحدة'),
(87511, 3449167360, 3449167615, 'CA', 'CAN', 'كندا'),
(87512, 3449167616, 3449168383, 'US', 'USA', 'الولايات المتحدة'),
(87513, 3449168384, 3449168639, 'CA', 'CAN', 'كندا'),
(87514, 3449168640, 3449171711, 'US', 'USA', 'الولايات المتحدة'),
(87515, 3449171712, 3449172223, 'CA', 'CAN', 'كندا'),
(87516, 3449172224, 3449174015, 'US', 'USA', 'الولايات المتحدة'),
(87517, 3449174016, 3449174783, 'CA', 'CAN', 'كندا'),
(87518, 3449174784, 3449176063, 'US', 'USA', 'الولايات المتحدة'),
(87519, 3449176064, 3449176319, 'CA', 'CAN', 'كندا'),
(87520, 3449176320, 3449176831, 'US', 'USA', 'الولايات المتحدة'),
(87521, 3449176832, 3449177599, 'CA', 'CAN', 'كندا'),
(87522, 3449177600, 3449178111, 'US', 'USA', 'الولايات المتحدة'),
(87523, 3449178112, 3449178367, 'CA', 'CAN', 'كندا'),
(87524, 3449178368, 3449178623, 'US', 'USA', 'الولايات المتحدة'),
(87525, 3449178624, 3449179647, 'CA', 'CAN', 'كندا'),
(87526, 3449179648, 3449180671, 'US', 'USA', 'الولايات المتحدة'),
(87527, 3449180672, 3449180927, 'CA', 'CAN', 'كندا'),
(87528, 3449180928, 3449181439, 'US', 'USA', 'الولايات المتحدة'),
(87529, 3449181440, 3449181695, 'CA', 'CAN', 'كندا'),
(87530, 3449181696, 3449182719, 'US', 'USA', 'الولايات المتحدة'),
(87531, 3449182720, 3449182975, 'CA', 'CAN', 'كندا'),
(87532, 3449182976, 3449184255, 'US', 'USA', 'الولايات المتحدة'),
(87533, 3449184256, 3449184511, 'CA', 'CAN', 'كندا'),
(87534, 3449184512, 3449185535, 'US', 'USA', 'الولايات المتحدة'),
(87535, 3449185536, 3449185791, 'CA', 'CAN', 'كندا'),
(87536, 3449185792, 3449186559, 'US', 'USA', 'الولايات المتحدة'),
(87537, 3449186560, 3449186815, 'CA', 'CAN', 'كندا'),
(87538, 3449186816, 3449187839, 'US', 'USA', 'الولايات المتحدة'),
(87539, 3449187840, 3449188095, 'CA', 'CAN', 'كندا'),
(87540, 3449188096, 3449188607, 'US', 'USA', 'الولايات المتحدة'),
(87541, 3449188608, 3449188671, 'CA', 'CAN', 'كندا'),
(87542, 3449188672, 3449188703, 'US', 'USA', 'الولايات المتحدة'),
(87543, 3449188704, 3449188767, 'CA', 'CAN', 'كندا'),
(87544, 3449188768, 3449188863, 'US', 'USA', 'الولايات المتحدة'),
(87545, 3449188864, 3449189119, 'CA', 'CAN', 'كندا'),
(87546, 3449189120, 3449191223, 'US', 'USA', 'الولايات المتحدة'),
(87547, 3449191224, 3449191231, 'CA', 'CAN', 'كندا'),
(87548, 3449191232, 3449191295, 'US', 'USA', 'الولايات المتحدة'),
(87549, 3449191296, 3449191303, 'CA', 'CAN', 'كندا'),
(87550, 3449191304, 3449191351, 'US', 'USA', 'الولايات المتحدة'),
(87551, 3449191352, 3449191359, 'CA', 'CAN', 'كندا'),
(87552, 3449191360, 3449191423, 'US', 'USA', 'الولايات المتحدة'),
(87553, 3449191424, 3449191679, 'CA', 'CAN', 'كندا'),
(87554, 3449191680, 3449194495, 'US', 'USA', 'الولايات المتحدة'),
(87555, 3449194496, 3449194751, 'CA', 'CAN', 'كندا'),
(87556, 3449194752, 3449196031, 'US', 'USA', 'الولايات المتحدة'),
(87557, 3449196032, 3449196287, 'CA', 'CAN', 'كندا'),
(87558, 3449196288, 3449198879, 'US', 'USA', 'الولايات المتحدة'),
(87559, 3449198880, 3449199103, 'CA', 'CAN', 'كندا'),
(87560, 3449199104, 3449202983, 'US', 'USA', 'الولايات المتحدة'),
(87561, 3449202984, 3449202991, 'CA', 'CAN', 'كندا'),
(87562, 3449202992, 3449203175, 'US', 'USA', 'الولايات المتحدة'),
(87563, 3449203176, 3449203183, 'CA', 'CAN', 'كندا'),
(87564, 3449203184, 3449203543, 'US', 'USA', 'الولايات المتحدة'),
(87565, 3449203544, 3449203551, 'CA', 'CAN', 'كندا'),
(87566, 3449203552, 3449203695, 'US', 'USA', 'الولايات المتحدة'),
(87567, 3449203696, 3449203703, 'CA', 'CAN', 'كندا'),
(87568, 3449203704, 3449204735, 'US', 'USA', 'الولايات المتحدة'),
(87569, 3449204736, 3449205759, 'CA', 'CAN', 'كندا'),
(87570, 3449205760, 3449210623, 'US', 'USA', 'الولايات المتحدة'),
(87571, 3449210624, 3449211391, 'CA', 'CAN', 'كندا'),
(87572, 3449211392, 3449211647, 'US', 'USA', 'الولايات المتحدة'),
(87573, 3449211648, 3449211903, 'CA', 'CAN', 'كندا'),
(87574, 3449211904, 3449213183, 'US', 'USA', 'الولايات المتحدة'),
(87575, 3449213184, 3449213695, 'CA', 'CAN', 'كندا'),
(87576, 3449213696, 3449214551, 'US', 'USA', 'الولايات المتحدة'),
(87577, 3449214552, 3449214559, 'CA', 'CAN', 'كندا'),
(87578, 3449214560, 3449214975, 'US', 'USA', 'الولايات المتحدة'),
(87579, 3449214976, 3449215231, 'CA', 'CAN', 'كندا'),
(87580, 3449215232, 3449215487, 'US', 'USA', 'الولايات المتحدة'),
(87581, 3449215488, 3449215743, 'CA', 'CAN', 'كندا'),
(87582, 3449215744, 3449220863, 'US', 'USA', 'الولايات المتحدة'),
(87583, 3449220864, 3449221119, 'CA', 'CAN', 'كندا'),
(87584, 3449221120, 3449222655, 'US', 'USA', 'الولايات المتحدة'),
(87585, 3449222656, 3449223423, 'CA', 'CAN', 'كندا'),
(87586, 3449223424, 3449224191, 'US', 'USA', 'الولايات المتحدة'),
(87587, 3449224192, 3449224447, 'CA', 'CAN', 'كندا'),
(87588, 3449224448, 3449224703, 'US', 'USA', 'الولايات المتحدة'),
(87589, 3449224704, 3449224959, 'CA', 'CAN', 'كندا'),
(87590, 3449224960, 3449225215, 'US', 'USA', 'الولايات المتحدة'),
(87591, 3449225472, 3449254143, 'CA', 'CAN', 'كندا'),
(87592, 3449254912, 3449273599, 'CA', 'CAN', 'كندا'),
(87593, 3449273856, 3449278975, 'CA', 'CAN', 'كندا'),
(87594, 3449280000, 3449290495, 'CA', 'CAN', 'كندا'),
(87595, 3449290752, 3449409535, 'US', 'USA', 'الولايات المتحدة'),
(87596, 3449410560, 3449598207, 'US', 'USA', 'الولايات المتحدة'),
(87597, 3449598208, 3449598463, 'GB', 'GBR', 'المملكة المتحدة'),
(87598, 3449598464, 3449755391, 'US', 'USA', 'الولايات المتحدة'),
(87599, 3449755648, 3449758207, 'US', 'USA', 'الولايات المتحدة'),
(87600, 3449758464, 3449760767, 'US', 'USA', 'الولايات المتحدة'),
(87601, 3449761024, 3449767935, 'US', 'USA', 'الولايات المتحدة'),
(87602, 3449768192, 3449769727, 'US', 'USA', 'الولايات المتحدة'),
(87603, 3449769984, 3449782271, 'US', 'USA', 'الولايات المتحدة'),
(87604, 3449782528, 3449783551, 'US', 'USA', 'الولايات المتحدة'),
(87605, 3449783808, 3449813503, 'US', 'USA', 'الولايات المتحدة'),
(87606, 3449813760, 3449814783, 'US', 'USA', 'الولايات المتحدة'),
(87607, 3449815040, 3449843199, 'US', 'USA', 'الولايات المتحدة'),
(87608, 3449843200, 3449843711, 'YE', 'YEM', 'اليمن'),
(87609, 3449843712, 3449874687, 'US', 'USA', 'الولايات المتحدة'),
(87610, 3449874688, 3449874943, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87611, 3449874944, 3449910719, 'US', 'USA', 'الولايات المتحدة'),
(87612, 3449910720, 3449910783, 'CA', 'CAN', 'كندا'),
(87613, 3449910784, 3449960127, 'US', 'USA', 'الولايات المتحدة'),
(87614, 3449960128, 3449960159, 'CA', 'CAN', 'كندا'),
(87615, 3449960160, 3450213887, 'US', 'USA', 'الولايات المتحدة'),
(87616, 3450214144, 3450217215, 'US', 'USA', 'الولايات المتحدة'),
(87617, 3450217216, 3450217471, 'LC', 'LCA', 'سانت لوسيا'),
(87618, 3450217472, 3450228735, 'US', 'USA', 'الولايات المتحدة'),
(87619, 3450228992, 3450235903, 'US', 'USA', 'الولايات المتحدة'),
(87620, 3450236160, 3450239743, 'US', 'USA', 'الولايات المتحدة'),
(87621, 3450240000, 3450245375, 'US', 'USA', 'الولايات المتحدة'),
(87622, 3450245632, 3450248703, 'US', 'USA', 'الولايات المتحدة'),
(87623, 3450248960, 3450252031, 'US', 'USA', 'الولايات المتحدة'),
(87624, 3450252288, 3450254079, 'US', 'USA', 'الولايات المتحدة'),
(87625, 3450254336, 3450254591, 'US', 'USA', 'الولايات المتحدة'),
(87626, 3450254848, 3450271487, 'US', 'USA', 'الولايات المتحدة'),
(87627, 3450271744, 3450272511, 'US', 'USA', 'الولايات المتحدة'),
(87628, 3450272512, 3450272767, 'MX', 'MEX', 'المكسيك'),
(87629, 3450272768, 3450273535, 'US', 'USA', 'الولايات المتحدة'),
(87630, 3450273792, 3450293759, 'US', 'USA', 'الولايات المتحدة'),
(87631, 3450294272, 3450328831, 'US', 'USA', 'الولايات المتحدة'),
(87632, 3450329088, 3450334719, 'US', 'USA', 'الولايات المتحدة'),
(87633, 3450335232, 3450345231, 'US', 'USA', 'الولايات المتحدة'),
(87634, 3450345232, 3450345247, 'FR', 'FRA', 'فرنسا'),
(87635, 3450345248, 3450345263, 'IT', 'ITA', 'إيطاليا'),
(87636, 3450345264, 3450345439, 'US', 'USA', 'الولايات المتحدة'),
(87637, 3450345440, 3450345471, 'GE', 'GEO', 'جورجيا'),
(87638, 3450345472, 3450612479, 'US', 'USA', 'الولايات المتحدة'),
(87639, 3450612736, 3450685183, 'US', 'USA', 'الولايات المتحدة'),
(87640, 3450685440, 3450686719, 'US', 'USA', 'الولايات المتحدة'),
(87641, 3450687488, 3450699007, 'US', 'USA', 'الولايات المتحدة'),
(87642, 3450699776, 3450731519, 'US', 'USA', 'الولايات المتحدة'),
(87643, 3450731520, 3450732543, 'CA', 'CAN', 'كندا'),
(87644, 3450732544, 3450773503, 'US', 'USA', 'الولايات المتحدة'),
(87645, 3450773504, 3450777599, 'CA', 'CAN', 'كندا'),
(87646, 3450777600, 3451482111, 'US', 'USA', 'الولايات المتحدة'),
(87647, 3451486208, 3451506687, 'US', 'USA', 'الولايات المتحدة'),
(87648, 3451506688, 3451507199, 'BR', 'BRA', 'البرازيل'),
(87649, 3451507200, 3451547647, 'US', 'USA', 'الولايات المتحدة'),
(87650, 3451551744, 3451715583, 'US', 'USA', 'الولايات المتحدة'),
(87651, 3451715840, 3451724543, 'CA', 'CAN', 'كندا'),
(87652, 3451725568, 3451726847, 'CA', 'CAN', 'كندا'),
(87653, 3451727360, 3451737343, 'CA', 'CAN', 'كندا'),
(87654, 3451737344, 3451737599, 'US', 'USA', 'الولايات المتحدة'),
(87655, 3451737600, 3451740927, 'CA', 'CAN', 'كندا'),
(87656, 3451741184, 3451741695, 'CA', 'CAN', 'كندا'),
(87657, 3451742208, 3451744255, 'CA', 'CAN', 'كندا'),
(87658, 3451744256, 3451745535, 'US', 'USA', 'الولايات المتحدة'),
(87659, 3451745536, 3451749887, 'CA', 'CAN', 'كندا'),
(87660, 3451750144, 3451766783, 'CA', 'CAN', 'كندا'),
(87661, 3451767296, 3451767551, 'CA', 'CAN', 'كندا'),
(87662, 3451767808, 3451780863, 'CA', 'CAN', 'كندا'),
(87663, 3451781120, 3451912191, 'US', 'USA', 'الولايات المتحدة'),
(87664, 3451912192, 3452174335, 'CA', 'CAN', 'كندا'),
(87665, 3452174592, 3452174847, 'US', 'USA', 'الولايات المتحدة'),
(87666, 3452176128, 3452177407, 'US', 'USA', 'الولايات المتحدة'),
(87667, 3452177920, 3452178175, 'US', 'USA', 'الولايات المتحدة'),
(87668, 3452178432, 3452187135, 'US', 'USA', 'الولايات المتحدة'),
(87669, 3452187392, 3452190463, 'US', 'USA', 'الولايات المتحدة'),
(87670, 3452191488, 3452192255, 'US', 'USA', 'الولايات المتحدة'),
(87671, 3452192512, 3452194047, 'US', 'USA', 'الولايات المتحدة'),
(87672, 3452194816, 3452199423, 'US', 'USA', 'الولايات المتحدة'),
(87673, 3452199680, 3452204287, 'US', 'USA', 'الولايات المتحدة'),
(87674, 3452205056, 3452216831, 'US', 'USA', 'الولايات المتحدة'),
(87675, 3452217344, 3452225791, 'US', 'USA', 'الولايات المتحدة'),
(87676, 3452226560, 3452436479, 'US', 'USA', 'الولايات المتحدة'),
(87677, 3452436480, 3452502015, 'CA', 'CAN', 'كندا'),
(87678, 3452502016, 3452534783, 'US', 'USA', 'الولايات المتحدة'),
(87679, 3452538880, 3452678143, 'US', 'USA', 'الولايات المتحدة'),
(87680, 3452678144, 3452682239, 'BE', 'BEL', 'بلجيكا'),
(87681, 3452682240, 3452702719, 'US', 'USA', 'الولايات المتحدة'),
(87682, 3452731392, 3452764159, 'US', 'USA', 'الولايات المتحدة'),
(87683, 3452764160, 3452895231, 'CA', 'CAN', 'كندا'),
(87684, 3452895488, 3452902399, 'CA', 'CAN', 'كندا'),
(87685, 3452902656, 3452914175, 'CA', 'CAN', 'كندا'),
(87686, 3452914176, 3452914431, 'US', 'USA', 'الولايات المتحدة'),
(87687, 3452914432, 3452919551, 'CA', 'CAN', 'كندا'),
(87688, 3452919808, 3452920831, 'CA', 'CAN', 'كندا'),
(87689, 3452920832, 3452922879, 'US', 'USA', 'الولايات المتحدة'),
(87690, 3452923392, 3452931327, 'CA', 'CAN', 'كندا'),
(87691, 3452931584, 3452934911, 'CA', 'CAN', 'كندا'),
(87692, 3452934912, 3452936191, 'US', 'USA', 'الولايات المتحدة'),
(87693, 3452936192, 3452940799, 'CA', 'CAN', 'كندا'),
(87694, 3452941056, 3452942847, 'CA', 'CAN', 'كندا'),
(87695, 3452943104, 3452953087, 'CA', 'CAN', 'كندا'),
(87696, 3452953344, 3452960511, 'CA', 'CAN', 'كندا'),
(87697, 3452960768, 3453026303, 'US', 'USA', 'الولايات المتحدة'),
(87698, 3453026560, 3453028095, 'CA', 'CAN', 'كندا'),
(87699, 3453028352, 3453028607, 'CA', 'CAN', 'كندا'),
(87700, 3453029376, 3453091839, 'US', 'USA', 'الولايات المتحدة'),
(87701, 3453092096, 3453101055, 'CA', 'CAN', 'كندا'),
(87702, 3453101056, 3453101311, 'US', 'USA', 'الولايات المتحدة'),
(87703, 3453101312, 3453123839, 'CA', 'CAN', 'كندا'),
(87704, 3453124096, 3453128959, 'CA', 'CAN', 'كندا'),
(87705, 3453129216, 3453129983, 'CA', 'CAN', 'كندا'),
(87706, 3453130240, 3453133823, 'CA', 'CAN', 'كندا'),
(87707, 3453134848, 3453139455, 'CA', 'CAN', 'كندا'),
(87708, 3453139968, 3453140991, 'US', 'USA', 'الولايات المتحدة'),
(87709, 3453140992, 3453149183, 'CA', 'CAN', 'كندا'),
(87710, 3453149184, 3453149439, 'US', 'USA', 'الولايات المتحدة'),
(87711, 3453149440, 3453151743, 'CA', 'CAN', 'كندا'),
(87712, 3453152000, 3453155327, 'CA', 'CAN', 'كندا'),
(87713, 3453155584, 3453157119, 'CA', 'CAN', 'كندا'),
(87714, 3453157632, 3453159423, 'CA', 'CAN', 'كندا'),
(87715, 3453159424, 3453159935, 'BM', 'BMU', 'برمودا'),
(87716, 3453159936, 3453163519, 'CA', 'CAN', 'كندا'),
(87717, 3453164032, 3453180671, 'CA', 'CAN', 'كندا'),
(87718, 3453180928, 3453195263, 'CA', 'CAN', 'كندا'),
(87719, 3453195520, 3453199871, 'CA', 'CAN', 'كندا'),
(87720, 3453200384, 3453206527, 'CA', 'CAN', 'كندا'),
(87721, 3453206528, 3453207551, 'HN', 'HND', 'هندوراس'),
(87722, 3453207552, 3453207807, 'NI', 'NIC', 'نيكاراغوا'),
(87723, 3453207808, 3453208575, 'HN', 'HND', 'هندوراس'),
(87724, 3453208576, 3453208831, 'NI', 'NIC', 'نيكاراغوا'),
(87725, 3453208832, 3453209599, 'HN', 'HND', 'هندوراس'),
(87726, 3453209600, 3453209855, 'US', 'USA', 'الولايات المتحدة'),
(87727, 3453209856, 3453210367, 'HN', 'HND', 'هندوراس'),
(87728, 3453210368, 3453210623, 'SV', 'SLV', 'السلفادور'),
(87729, 3453210624, 3453213183, 'CR', 'CRI', 'كوستا ريكا'),
(87730, 3453213184, 3453214719, 'HN', 'HND', 'هندوراس'),
(87731, 3453214720, 3453215231, 'GT', 'GTM', 'غواتيمالا'),
(87732, 3453215232, 3453215999, 'SV', 'SLV', 'السلفادور'),
(87733, 3453216000, 3453217023, 'CR', 'CRI', 'كوستا ريكا'),
(87734, 3453217024, 3453217791, 'SV', 'SLV', 'السلفادور'),
(87735, 3453217792, 3453219327, 'CR', 'CRI', 'كوستا ريكا'),
(87736, 3453219328, 3453219583, 'US', 'USA', 'الولايات المتحدة'),
(87737, 3453219584, 3453219839, 'SV', 'SLV', 'السلفادور'),
(87738, 3453219840, 3453220607, 'US', 'USA', 'الولايات المتحدة'),
(87739, 3453220608, 3453222911, 'HN', 'HND', 'هندوراس'),
(87740, 3453222912, 3453375999, 'US', 'USA', 'الولايات المتحدة'),
(87741, 3453376000, 3453376255, 'CA', 'CAN', 'كندا'),
(87742, 3453376256, 3453403135, 'US', 'USA', 'الولايات المتحدة'),
(87743, 3453403136, 3453405951, 'BB', 'BRB', 'باربادوس'),
(87744, 3453405952, 3453406207, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(87745, 3453406208, 3453406463, 'BB', 'BRB', 'باربادوس'),
(87746, 3453406464, 3453406975, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(87747, 3453406976, 3453407231, 'GD', 'GRD', 'غرينادا'),
(87748, 3453407232, 3453407743, 'BB', 'BRB', 'باربادوس'),
(87749, 3453407744, 3453408255, 'GD', 'GRD', 'غرينادا'),
(87750, 3453408256, 3453409023, 'BB', 'BRB', 'باربادوس'),
(87751, 3453409024, 3453409535, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(87752, 3453409536, 3453411327, 'BB', 'BRB', 'باربادوس'),
(87753, 3453411328, 3453551839, 'US', 'USA', 'الولايات المتحدة'),
(87754, 3453551840, 3453551879, 'GB', 'GBR', 'المملكة المتحدة'),
(87755, 3453551880, 3453551895, 'US', 'USA', 'الولايات المتحدة'),
(87756, 3453551896, 3453551903, 'GB', 'GBR', 'المملكة المتحدة'),
(87757, 3453551904, 3453551935, 'US', 'USA', 'الولايات المتحدة'),
(87758, 3453551936, 3453551967, 'GB', 'GBR', 'المملكة المتحدة'),
(87759, 3453551968, 3453552039, 'US', 'USA', 'الولايات المتحدة'),
(87760, 3453552040, 3453552047, 'GB', 'GBR', 'المملكة المتحدة'),
(87761, 3453552048, 3453552399, 'US', 'USA', 'الولايات المتحدة'),
(87762, 3453552400, 3453552407, 'GB', 'GBR', 'المملكة المتحدة'),
(87763, 3453552408, 3453552455, 'US', 'USA', 'الولايات المتحدة'),
(87764, 3453552456, 3453552463, 'IE', 'IRL', 'إيرلندا'),
(87765, 3453552464, 3453552471, 'GB', 'GBR', 'المملكة المتحدة'),
(87766, 3453552472, 3453552511, 'US', 'USA', 'الولايات المتحدة'),
(87767, 3453552512, 3453552639, 'IE', 'IRL', 'إيرلندا'),
(87768, 3453552640, 3453552895, 'GB', 'GBR', 'المملكة المتحدة'),
(87769, 3453552896, 3453553151, 'US', 'USA', 'الولايات المتحدة'),
(87770, 3453553152, 3453553407, 'GB', 'GBR', 'المملكة المتحدة'),
(87771, 3453553408, 3453553631, 'US', 'USA', 'الولايات المتحدة'),
(87772, 3453553632, 3453553639, 'GB', 'GBR', 'المملكة المتحدة'),
(87773, 3453553640, 3453553919, 'US', 'USA', 'الولايات المتحدة'),
(87774, 3453553920, 3453553983, 'GB', 'GBR', 'المملكة المتحدة'),
(87775, 3453553984, 3453554063, 'US', 'USA', 'الولايات المتحدة'),
(87776, 3453554064, 3453554095, 'GB', 'GBR', 'المملكة المتحدة'),
(87777, 3453554096, 3453554159, 'US', 'USA', 'الولايات المتحدة'),
(87778, 3453554160, 3453554175, 'GB', 'GBR', 'المملكة المتحدة'),
(87779, 3453554176, 3453554207, 'US', 'USA', 'الولايات المتحدة'),
(87780, 3453554208, 3453554215, 'GB', 'GBR', 'المملكة المتحدة'),
(87781, 3453554216, 3453554431, 'US', 'USA', 'الولايات المتحدة'),
(87782, 3453554432, 3453554687, 'GB', 'GBR', 'المملكة المتحدة'),
(87783, 3453554688, 3453554863, 'US', 'USA', 'الولايات المتحدة'),
(87784, 3453554864, 3453554879, 'NL', 'NLD', 'هولندا'),
(87785, 3453554880, 3453555711, 'US', 'USA', 'الولايات المتحدة'),
(87786, 3453555712, 3453555767, 'GB', 'GBR', 'المملكة المتحدة'),
(87787, 3453555768, 3453607935, 'US', 'USA', 'الولايات المتحدة'),
(87788, 3453607936, 3453608959, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(87789, 3453608960, 3453609983, 'LC', 'LCA', 'سانت لوسيا'),
(87790, 3453609984, 3453612543, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87791, 3453612544, 3453613055, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(87792, 3453613056, 3453615359, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87793, 3453615360, 3453615615, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(87794, 3453615616, 3453616127, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87795, 3453616128, 3454436351, 'US', 'USA', 'الولايات المتحدة'),
(87796, 3454436352, 3454436607, 'GU', 'GUM', 'غوام'),
(87797, 3454436608, 3454599167, 'US', 'USA', 'الولايات المتحدة'),
(87798, 3454599424, 3454601215, 'CA', 'CAN', 'كندا'),
(87799, 3454601216, 3454602239, 'US', 'USA', 'الولايات المتحدة'),
(87800, 3454603008, 3454603519, 'CA', 'CAN', 'كندا'),
(87801, 3454604032, 3454604799, 'CA', 'CAN', 'كندا'),
(87802, 3454604800, 3454607359, 'US', 'USA', 'الولايات المتحدة'),
(87803, 3454607360, 3454608127, 'CA', 'CAN', 'كندا'),
(87804, 3454608128, 3454608383, 'US', 'USA', 'الولايات المتحدة'),
(87805, 3454608384, 3454609151, 'CA', 'CAN', 'كندا'),
(87806, 3454609408, 3454611455, 'US', 'USA', 'الولايات المتحدة'),
(87807, 3454611456, 3454617343, 'CA', 'CAN', 'كندا'),
(87808, 3454617600, 3454617855, 'CA', 'CAN', 'كندا'),
(87809, 3454618112, 3454618367, 'CA', 'CAN', 'كندا'),
(87810, 3454618624, 3454619647, 'US', 'USA', 'الولايات المتحدة'),
(87811, 3454619648, 3454631423, 'CA', 'CAN', 'كندا'),
(87812, 3454631936, 3454634751, 'CA', 'CAN', 'كندا'),
(87813, 3454635008, 3454636031, 'US', 'USA', 'الولايات المتحدة'),
(87814, 3454636032, 3454636799, 'CA', 'CAN', 'كندا'),
(87815, 3454636800, 3454637055, 'US', 'USA', 'الولايات المتحدة'),
(87816, 3454637056, 3454652159, 'CA', 'CAN', 'كندا'),
(87817, 3454652416, 3454661631, 'CA', 'CAN', 'كندا'),
(87818, 3454661632, 3454662655, 'US', 'USA', 'الولايات المتحدة'),
(87819, 3454662656, 3454664447, 'CA', 'CAN', 'كندا'),
(87820, 3454664704, 3454672895, 'US', 'USA', 'الولايات المتحدة'),
(87821, 3454672896, 3454681087, 'CA', 'CAN', 'كندا'),
(87822, 3454681088, 3454705151, 'US', 'USA', 'الولايات المتحدة'),
(87823, 3454705152, 3454705215, 'GB', 'GBR', 'المملكة المتحدة'),
(87824, 3454705216, 3454730239, 'US', 'USA', 'الولايات المتحدة'),
(87825, 3454730240, 3454732287, 'EC', 'ECU', 'الإكوادور'),
(87826, 3454732288, 3454795775, 'US', 'USA', 'الولايات المتحدة'),
(87827, 3454796032, 3454808831, 'CA', 'CAN', 'كندا'),
(87828, 3454808832, 3454809087, 'US', 'USA', 'الولايات المتحدة'),
(87829, 3454809088, 3454810111, 'CA', 'CAN', 'كندا'),
(87830, 3454810368, 3454814975, 'CA', 'CAN', 'كندا'),
(87831, 3454814976, 3454815231, 'US', 'USA', 'الولايات المتحدة'),
(87832, 3454815232, 3454815743, 'CA', 'CAN', 'كندا'),
(87833, 3454816256, 3454816511, 'CA', 'CAN', 'كندا'),
(87834, 3454816768, 3454828287, 'CA', 'CAN', 'كندا'),
(87835, 3454828544, 3454861055, 'CA', 'CAN', 'كندا'),
(87836, 3454861568, 3454867711, 'CA', 'CAN', 'كندا'),
(87837, 3454867968, 3454881535, 'CA', 'CAN', 'كندا'),
(87838, 3454881792, 3454883839, 'CA', 'CAN', 'كندا'),
(87839, 3454883840, 3454914559, 'US', 'USA', 'الولايات المتحدة'),
(87840, 3454915072, 3454926591, 'CA', 'CAN', 'كندا'),
(87841, 3454926848, 3455109119, 'US', 'USA', 'الولايات المتحدة'),
(87842, 3455109120, 3455111167, 'HN', 'HND', 'هندوراس'),
(87843, 3455111168, 3455122879, 'US', 'USA', 'الولايات المتحدة'),
(87844, 3455122880, 3455122887, 'PR', 'PRI', 'بورتو ريكو'),
(87845, 3455122888, 3455132159, 'US', 'USA', 'الولايات المتحدة'),
(87846, 3455132160, 3455133695, 'BO', 'BOL', 'بوليفيا'),
(87847, 3455133696, 3455242407, 'US', 'USA', 'الولايات المتحدة'),
(87848, 3455242408, 3455242415, 'CA', 'CAN', 'كندا'),
(87849, 3455242416, 3455244847, 'US', 'USA', 'الولايات المتحدة'),
(87850, 3455244848, 3455244855, 'CA', 'CAN', 'كندا'),
(87851, 3455244856, 3455320063, 'US', 'USA', 'الولايات المتحدة'),
(87852, 3455320064, 3455322111, 'FR', 'FRA', 'فرنسا'),
(87853, 3455322112, 3455323623, 'US', 'USA', 'الولايات المتحدة'),
(87854, 3455323624, 3455323631, 'CA', 'CAN', 'كندا'),
(87855, 3455323632, 3455378351, 'US', 'USA', 'الولايات المتحدة'),
(87856, 3455378352, 3455378367, 'CA', 'CAN', 'كندا'),
(87857, 3455378368, 3455551999, 'US', 'USA', 'الولايات المتحدة'),
(87858, 3455552000, 3455552255, 'EC', 'ECU', 'الإكوادور'),
(87859, 3455552256, 3455566079, 'US', 'USA', 'الولايات المتحدة'),
(87860, 3455566080, 3455566335, 'EC', 'ECU', 'الإكوادور'),
(87861, 3455566336, 3455713279, 'US', 'USA', 'الولايات المتحدة'),
(87862, 3455713280, 3455778815, 'CA', 'CAN', 'كندا'),
(87863, 3455778816, 3455819775, 'US', 'USA', 'الولايات المتحدة'),
(87864, 3455844352, 3456303103, 'US', 'USA', 'الولايات المتحدة'),
(87865, 3456303104, 3456311295, 'JP', 'JPN', 'اليابان'),
(87866, 3456311296, 3456892927, 'US', 'USA', 'الولايات المتحدة'),
(87867, 3456892928, 3456958463, 'CA', 'CAN', 'كندا'),
(87868, 3456958464, 3457683967, 'US', 'USA', 'الولايات المتحدة'),
(87869, 3457683968, 3457684735, 'CA', 'CAN', 'كندا'),
(87870, 3457684736, 3457723535, 'US', 'USA', 'الولايات المتحدة'),
(87871, 3457723536, 3457723551, 'GB', 'GBR', 'المملكة المتحدة'),
(87872, 3457723552, 3457859839, 'US', 'USA', 'الولايات المتحدة'),
(87873, 3457859840, 3457860095, 'CA', 'CAN', 'كندا'),
(87874, 3457860096, 3457862847, 'US', 'USA', 'الولايات المتحدة'),
(87875, 3457862848, 3457862911, 'CA', 'CAN', 'كندا'),
(87876, 3457862912, 3458141631, 'US', 'USA', 'الولايات المتحدة'),
(87877, 3458141632, 3458141655, 'GB', 'GBR', 'المملكة المتحدة'),
(87878, 3458141656, 3458195455, 'US', 'USA', 'الولايات المتحدة'),
(87879, 3458195456, 3458196479, 'SG', 'SGP', 'سنغافورة'),
(87880, 3458196480, 3458811903, 'US', 'USA', 'الولايات المتحدة'),
(87881, 3458813952, 3458818047, 'CA', 'CAN', 'كندا'),
(87882, 3458818048, 3458820095, 'US', 'USA', 'الولايات المتحدة'),
(87883, 3458822144, 3459055615, 'US', 'USA', 'الولايات المتحدة'),
(87884, 3459055616, 3459121151, 'CA', 'CAN', 'كندا'),
(87885, 3459121152, 3459186687, 'US', 'USA', 'الولايات المتحدة'),
(87886, 3459186688, 3459252223, 'CA', 'CAN', 'كندا'),
(87887, 3459252224, 3459266559, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(87888, 3459266560, 3459267583, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87889, 3459267584, 3459267839, 'LC', 'LCA', 'سانت لوسيا'),
(87890, 3459267840, 3459268607, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87891, 3459268608, 3459295231, 'US', 'USA', 'الولايات المتحدة'),
(87892, 3459295232, 3459296255, 'KR', 'KOR', 'جمهورية كوريا'),
(87893, 3459296256, 3459326463, 'US', 'USA', 'الولايات المتحدة'),
(87894, 3459326464, 3459327487, 'CA', 'CAN', 'كندا'),
(87895, 3459327488, 3459327999, 'CO', 'COL', 'كولومبيا'),
(87896, 3459328000, 3459329023, 'CL', 'CHL', 'تشيلي'),
(87897, 3459329024, 3459330047, 'US', 'USA', 'الولايات المتحدة'),
(87898, 3459330048, 3459330303, 'CL', 'CHL', 'تشيلي'),
(87899, 3459330304, 3459331071, 'US', 'USA', 'الولايات المتحدة'),
(87900, 3459331072, 3459331583, 'MX', 'MEX', 'المكسيك'),
(87901, 3459331584, 3459332607, 'PA', 'PAN', 'بنما'),
(87902, 3459332608, 3459334399, 'US', 'USA', 'الولايات المتحدة'),
(87903, 3459334400, 3459334655, 'CA', 'CAN', 'كندا'),
(87904, 3459334656, 3459340031, 'US', 'USA', 'الولايات المتحدة'),
(87905, 3459340032, 3459340287, 'VE', 'VEN', 'فنزويلا'),
(87906, 3459340288, 3459340543, 'MX', 'MEX', 'المكسيك'),
(87907, 3459340544, 3459341823, 'US', 'USA', 'الولايات المتحدة'),
(87908, 3459341824, 3459342079, 'IL', 'ISR', 'إسرائيل'),
(87909, 3459342080, 3459342335, 'US', 'USA', 'الولايات المتحدة'),
(87910, 3459342336, 3459342591, 'VE', 'VEN', 'فنزويلا'),
(87911, 3459342592, 3459342847, 'US', 'USA', 'الولايات المتحدة'),
(87912, 3459342848, 3459343103, 'VE', 'VEN', 'فنزويلا'),
(87913, 3459343104, 3459343615, 'US', 'USA', 'الولايات المتحدة'),
(87914, 3459343616, 3459344127, 'OM', 'OMN', 'عمان'),
(87915, 3459344128, 3459345663, 'US', 'USA', 'الولايات المتحدة'),
(87916, 3459345664, 3459346175, 'OM', 'OMN', 'عمان'),
(87917, 3459346176, 3459347967, 'US', 'USA', 'الولايات المتحدة'),
(87918, 3459347968, 3459348223, 'PR', 'PRI', 'بورتو ريكو'),
(87919, 3459348224, 3459348479, 'AG', 'ATG', 'انتيغوا وبربودا'),
(87920, 3459348480, 3459348991, 'US', 'USA', 'الولايات المتحدة'),
(87921, 3459348992, 3459349503, 'IT', 'ITA', 'إيطاليا'),
(87922, 3459349504, 3459350527, 'US', 'USA', 'الولايات المتحدة'),
(87923, 3459350528, 3459352575, 'VE', 'VEN', 'فنزويلا'),
(87924, 3459352576, 3459352831, 'US', 'USA', 'الولايات المتحدة'),
(87925, 3459352832, 3459353087, 'FM', 'FSM', 'ولايات ميكرونيزيا الموحدة'),
(87926, 3459353088, 3459353599, 'US', 'USA', 'الولايات المتحدة'),
(87927, 3459353600, 3459354623, 'CO', 'COL', 'كولومبيا'),
(87928, 3459354624, 3459357183, 'NI', 'NIC', 'نيكاراغوا'),
(87929, 3459357184, 3459357439, 'VE', 'VEN', 'فنزويلا'),
(87930, 3459357440, 3459362815, 'US', 'USA', 'الولايات المتحدة'),
(87931, 3459362816, 3459364863, 'CO', 'COL', 'كولومبيا'),
(87932, 3459364864, 3459366911, 'AR', 'ARG', 'الأرجنتين'),
(87933, 3459366912, 3459368959, 'VE', 'VEN', 'فنزويلا'),
(87934, 3459368960, 3459371007, 'MX', 'MEX', 'المكسيك'),
(87935, 3459371008, 3459373055, 'PE', 'PER', 'بيرو'),
(87936, 3459373056, 3459373311, 'US', 'USA', 'الولايات المتحدة'),
(87937, 3459373312, 3459375103, 'CL', 'CHL', 'تشيلي'),
(87938, 3459375104, 3459448831, 'US', 'USA', 'الولايات المتحدة'),
(87939, 3459449088, 3459450623, 'CA', 'CAN', 'كندا'),
(87940, 3459450624, 3459450879, 'US', 'USA', 'الولايات المتحدة'),
(87941, 3459450880, 3459456511, 'CA', 'CAN', 'كندا'),
(87942, 3459456512, 3459456767, 'US', 'USA', 'الولايات المتحدة'),
(87943, 3459456768, 3459457279, 'CA', 'CAN', 'كندا'),
(87944, 3459457280, 3459457535, 'US', 'USA', 'الولايات المتحدة'),
(87945, 3459457536, 3459457791, 'CA', 'CAN', 'كندا'),
(87946, 3459457792, 3459458047, 'PR', 'PRI', 'بورتو ريكو'),
(87947, 3459458048, 3459510271, 'US', 'USA', 'الولايات المتحدة'),
(87948, 3459512320, 3459513855, 'CA', 'CAN', 'كندا'),
(87949, 3459513856, 3459592191, 'US', 'USA', 'الولايات المتحدة'),
(87950, 3459592192, 3459596287, 'CA', 'CAN', 'كندا'),
(87951, 3459596288, 3459614719, 'US', 'USA', 'الولايات المتحدة'),
(87952, 3459616768, 3459620863, 'CA', 'CAN', 'كندا'),
(87953, 3459620864, 3459622911, 'US', 'USA', 'الولايات المتحدة'),
(87954, 3459624960, 3459629055, 'BM', 'BMU', 'برمودا'),
(87955, 3459629056, 3459631103, 'US', 'USA', 'الولايات المتحدة'),
(87956, 3459633152, 3459731455, 'US', 'USA', 'الولايات المتحدة'),
(87957, 3459731456, 3459735551, 'CA', 'CAN', 'كندا'),
(87958, 3459735552, 3460108895, 'US', 'USA', 'الولايات المتحدة'),
(87959, 3460108896, 3460108903, 'FI', 'FIN', 'فنلندا'),
(87960, 3460108904, 3460111871, 'US', 'USA', 'الولايات المتحدة'),
(87961, 3460111872, 3460111887, 'CA', 'CAN', 'كندا'),
(87962, 3460111888, 3460161535, 'US', 'USA', 'الولايات المتحدة'),
(87963, 3460161536, 3460163583, 'PR', 'PRI', 'بورتو ريكو'),
(87964, 3460163584, 3460453631, 'US', 'USA', 'الولايات المتحدة'),
(87965, 3460453632, 3460453887, 'BS', 'BHS', 'جزر البهاما'),
(87966, 3460453888, 3460761599, 'US', 'USA', 'الولايات المتحدة'),
(87967, 3460763648, 3460794367, 'US', 'USA', 'الولايات المتحدة'),
(87968, 3460796416, 3460894847, 'US', 'USA', 'الولايات المتحدة'),
(87969, 3460894848, 3460894975, 'NL', 'NLD', 'هولندا'),
(87970, 3460894976, 3460933887, 'US', 'USA', 'الولايات المتحدة'),
(87971, 3460933888, 3460934143, 'DE', 'DEU', 'ألمانيا'),
(87972, 3460934144, 3461021695, 'US', 'USA', 'الولايات المتحدة'),
(87973, 3461021696, 3461031935, 'CA', 'CAN', 'كندا'),
(87974, 3461031936, 3461032191, 'US', 'USA', 'الولايات المتحدة'),
(87975, 3461032192, 3461087231, 'CA', 'CAN', 'كندا'),
(87976, 3461087232, 3461285887, 'US', 'USA', 'الولايات المتحدة'),
(87977, 3461285888, 3461285975, 'GB', 'GBR', 'المملكة المتحدة'),
(87978, 3461285976, 3461286143, 'US', 'USA', 'الولايات المتحدة'),
(87979, 3461286144, 3461286335, 'FR', 'FRA', 'فرنسا'),
(87980, 3461286336, 3461286399, 'US', 'USA', 'الولايات المتحدة'),
(87981, 3461286400, 3461286463, 'FR', 'FRA', 'فرنسا'),
(87982, 3461286464, 3461286471, 'GB', 'GBR', 'المملكة المتحدة'),
(87983, 3461286472, 3461330943, 'US', 'USA', 'الولايات المتحدة'),
(87984, 3461330944, 3461331199, 'SG', 'SGP', 'سنغافورة'),
(87985, 3461331200, 3461331295, 'US', 'USA', 'الولايات المتحدة'),
(87986, 3461331296, 3461331311, 'SG', 'SGP', 'سنغافورة'),
(87987, 3461331312, 3461331327, 'US', 'USA', 'الولايات المتحدة'),
(87988, 3461331328, 3461331551, 'SG', 'SGP', 'سنغافورة'),
(87989, 3461331552, 3461331567, 'US', 'USA', 'الولايات المتحدة'),
(87990, 3461331568, 3461331583, 'SG', 'SGP', 'سنغافورة'),
(87991, 3461331584, 3461331711, 'US', 'USA', 'الولايات المتحدة'),
(87992, 3461331712, 3461331967, 'SG', 'SGP', 'سنغافورة'),
(87993, 3461331968, 3461332223, 'US', 'USA', 'الولايات المتحدة'),
(87994, 3461332224, 3461332479, 'SG', 'SGP', 'سنغافورة'),
(87995, 3461332480, 3461332735, 'US', 'USA', 'الولايات المتحدة'),
(87996, 3461332736, 3461332991, 'SG', 'SGP', 'سنغافورة'),
(87997, 3461332992, 3461408767, 'US', 'USA', 'الولايات المتحدة'),
(87998, 3461410816, 3461414911, 'CA', 'CAN', 'كندا'),
(87999, 3461414912, 3461435647, 'US', 'USA', 'الولايات المتحدة'),
(88000, 3461435904, 3461436159, 'US', 'USA', 'الولايات المتحدة'),
(88001, 3461436416, 3461441535, 'US', 'USA', 'الولايات المتحدة'),
(88002, 3461443584, 3461507071, 'US', 'USA', 'الولايات المتحدة'),
(88003, 3461509120, 3461513215, 'US', 'USA', 'الولايات المتحدة'),
(88004, 3461513216, 3461517311, 'CA', 'CAN', 'كندا'),
(88005, 3461517312, 3461548031, 'US', 'USA', 'الولايات المتحدة'),
(88006, 3461550080, 3461554175, 'US', 'USA', 'الولايات المتحدة'),
(88007, 3461554176, 3461556223, 'CA', 'CAN', 'كندا'),
(88008, 3461558272, 3461580799, 'US', 'USA', 'الولايات المتحدة'),
(88009, 3461582848, 3461808127, 'US', 'USA', 'الولايات المتحدة'),
(88010, 3461808128, 3461873663, 'CA', 'CAN', 'كندا'),
(88011, 3461873664, 3462478559, 'US', 'USA', 'الولايات المتحدة'),
(88012, 3462478560, 3462478591, 'IL', 'ISR', 'إسرائيل'),
(88013, 3462478592, 3462478623, 'US', 'USA', 'الولايات المتحدة'),
(88014, 3462478624, 3462478655, 'IL', 'ISR', 'إسرائيل'),
(88015, 3462478656, 3462478943, 'US', 'USA', 'الولايات المتحدة'),
(88016, 3462478944, 3462478975, 'IL', 'ISR', 'إسرائيل'),
(88017, 3462478976, 3462571095, 'US', 'USA', 'الولايات المتحدة'),
(88018, 3462571096, 3462571103, 'CA', 'CAN', 'كندا'),
(88019, 3462571104, 3462571663, 'US', 'USA', 'الولايات المتحدة'),
(88020, 3462571664, 3462571671, 'CA', 'CAN', 'كندا'),
(88021, 3462571672, 3462593791, 'US', 'USA', 'الولايات المتحدة'),
(88022, 3462593792, 3462594559, 'GN', 'GIN', 'غينيا'),
(88023, 3462594560, 3462605823, 'US', 'USA', 'الولايات المتحدة'),
(88024, 3462605824, 3462608895, 'UY', 'URY', 'الأوروغواي'),
(88025, 3462608896, 3462633471, 'US', 'USA', 'الولايات المتحدة'),
(88026, 3462633472, 3462633727, 'SG', 'SGP', 'سنغافورة'),
(88027, 3462633728, 3462633799, 'BV', 'BVT', 'جزيرة بوفيت'),
(88028, 3462633800, 3462633823, 'US', 'USA', 'الولايات المتحدة'),
(88029, 3462633824, 3462633855, 'SG', 'SGP', 'سنغافورة'),
(88030, 3462633856, 3462633983, 'US', 'USA', 'الولايات المتحدة'),
(88031, 3462633984, 3462634239, 'SG', 'SGP', 'سنغافورة'),
(88032, 3462634240, 3462634247, 'US', 'USA', 'الولايات المتحدة'),
(88033, 3462634248, 3462634271, 'SG', 'SGP', 'سنغافورة'),
(88034, 3462634272, 3462634367, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(88035, 3462634368, 3462634495, 'SG', 'SGP', 'سنغافورة'),
(88036, 3462634496, 3462634751, 'US', 'USA', 'الولايات المتحدة'),
(88037, 3462634752, 3462635007, 'SG', 'SGP', 'سنغافورة'),
(88038, 3462635008, 3462635263, 'US', 'USA', 'الولايات المتحدة'),
(88039, 3462635264, 3462635519, 'SG', 'SGP', 'سنغافورة'),
(88040, 3462635520, 3462889479, 'US', 'USA', 'الولايات المتحدة'),
(88041, 3462889480, 3462889487, 'GB', 'GBR', 'المملكة المتحدة'),
(88042, 3462889488, 3462991183, 'US', 'USA', 'الولايات المتحدة'),
(88043, 3462991184, 3462991191, 'CA', 'CAN', 'كندا'),
(88044, 3462991192, 3463089151, 'US', 'USA', 'الولايات المتحدة'),
(88045, 3463089152, 3463090175, 'CA', 'CAN', 'كندا'),
(88046, 3463090176, 3463156735, 'US', 'USA', 'الولايات المتحدة'),
(88047, 3463156736, 3463157759, 'BO', 'BOL', 'بوليفيا'),
(88048, 3463157760, 3463184383, 'US', 'USA', 'الولايات المتحدة'),
(88049, 3463184384, 3463194623, 'CA', 'CAN', 'كندا'),
(88050, 3463194624, 3463198719, 'US', 'USA', 'الولايات المتحدة'),
(88051, 3463198720, 3463213311, 'CA', 'CAN', 'كندا'),
(88052, 3463213312, 3463213567, 'US', 'USA', 'الولايات المتحدة'),
(88053, 3463214080, 3463215103, 'US', 'USA', 'الولايات المتحدة'),
(88054, 3463215104, 3463229327, 'CA', 'CAN', 'كندا'),
(88055, 3463229328, 3463229335, 'US', 'USA', 'الولايات المتحدة'),
(88056, 3463229336, 3463243775, 'CA', 'CAN', 'كندا'),
(88057, 3463243776, 3463244799, 'US', 'USA', 'الولايات المتحدة'),
(88058, 3463245056, 3463249663, 'CA', 'CAN', 'كندا'),
(88059, 3463249920, 3463480063, 'US', 'USA', 'الولايات المتحدة'),
(88060, 3463480064, 3463480319, 'CA', 'CAN', 'كندا'),
(88061, 3463480320, 3463518207, 'US', 'USA', 'الولايات المتحدة'),
(88062, 3463518208, 3463520255, 'NL', 'NLD', 'هولندا'),
(88063, 3463520256, 3463602687, 'US', 'USA', 'الولايات المتحدة'),
(88064, 3463602688, 3463602943, 'PH', 'PHL', 'الفلبين'),
(88065, 3463602944, 3463632383, 'US', 'USA', 'الولايات المتحدة'),
(88066, 3463632384, 3463632391, 'CA', 'CAN', 'كندا'),
(88067, 3463632392, 3463632399, 'US', 'USA', 'الولايات المتحدة'),
(88068, 3463632400, 3463632415, 'CA', 'CAN', 'كندا'),
(88069, 3463632416, 3463708671, 'US', 'USA', 'الولايات المتحدة'),
(88070, 3463708672, 3463774207, 'CA', 'CAN', 'كندا'),
(88071, 3463774208, 3464167423, 'US', 'USA', 'الولايات المتحدة'),
(88072, 3464167680, 3464169215, 'CA', 'CAN', 'كندا'),
(88073, 3464169472, 3464171775, 'CA', 'CAN', 'كندا'),
(88074, 3464171776, 3464172031, 'US', 'USA', 'الولايات المتحدة'),
(88075, 3464172032, 3464173567, 'CA', 'CAN', 'كندا'),
(88076, 3464173824, 3464174591, 'CA', 'CAN', 'كندا'),
(88077, 3464175360, 3464180735, 'CA', 'CAN', 'كندا'),
(88078, 3464180736, 3464190463, 'US', 'USA', 'الولايات المتحدة'),
(88079, 3464190464, 3464190719, 'CA', 'CAN', 'كندا'),
(88080, 3464190720, 3464195543, 'US', 'USA', 'الولايات المتحدة'),
(88081, 3464195544, 3464195551, 'IT', 'ITA', 'إيطاليا'),
(88082, 3464195552, 3464195951, 'US', 'USA', 'الولايات المتحدة'),
(88083, 3464195952, 3464195959, 'IT', 'ITA', 'إيطاليا'),
(88084, 3464195960, 3464196183, 'US', 'USA', 'الولايات المتحدة'),
(88085, 3464196184, 3464196191, 'IT', 'ITA', 'إيطاليا'),
(88086, 3464196192, 3464208383, 'US', 'USA', 'الولايات المتحدة'),
(88087, 3464208384, 3464216575, 'CA', 'CAN', 'كندا'),
(88088, 3464216576, 3464243199, 'US', 'USA', 'الولايات المتحدة'),
(88089, 3464245248, 3464259583, 'US', 'USA', 'الولايات المتحدة'),
(88090, 3464261632, 3464340479, 'US', 'USA', 'الولايات المتحدة'),
(88091, 3464340480, 3464341503, 'CA', 'CAN', 'كندا'),
(88092, 3464341504, 3464349695, 'US', 'USA', 'الولايات المتحدة'),
(88093, 3464351744, 3464382463, 'US', 'USA', 'الولايات المتحدة'),
(88094, 3464384512, 3464388607, 'CA', 'CAN', 'كندا'),
(88095, 3464388608, 3464389631, 'US', 'USA', 'الولايات المتحدة'),
(88096, 3464389888, 3464391935, 'US', 'USA', 'الولايات المتحدة'),
(88097, 3464392192, 3464392703, 'US', 'USA', 'الولايات المتحدة'),
(88098, 3464392960, 3464393727, 'US', 'USA', 'الولايات المتحدة'),
(88099, 3464393984, 3464394751, 'US', 'USA', 'الولايات المتحدة'),
(88100, 3464394752, 3464396799, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(88101, 3464396800, 3464415231, 'US', 'USA', 'الولايات المتحدة'),
(88102, 3464417280, 3464464383, 'US', 'USA', 'الولايات المتحدة'),
(88103, 3464466432, 3464472575, 'US', 'USA', 'الولايات المتحدة'),
(88104, 3464474624, 3464519679, 'US', 'USA', 'الولايات المتحدة'),
(88105, 3464523776, 3464548607, 'US', 'USA', 'الولايات المتحدة'),
(88106, 3464548608, 3464548863, 'LC', 'LCA', 'سانت لوسيا'),
(88107, 3464548864, 3464549119, 'US', 'USA', 'الولايات المتحدة'),
(88108, 3464549120, 3464549375, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(88109, 3464549376, 3464550143, 'US', 'USA', 'الولايات المتحدة'),
(88110, 3464550144, 3464550399, 'LC', 'LCA', 'سانت لوسيا'),
(88111, 3464550400, 3464626175, 'US', 'USA', 'الولايات المتحدة'),
(88112, 3464626432, 3464626687, 'CA', 'CAN', 'كندا'),
(88113, 3464627968, 3464628735, 'CA', 'CAN', 'كندا'),
(88114, 3464628992, 3464630015, 'CA', 'CAN', 'كندا'),
(88115, 3464630272, 3464631295, 'US', 'USA', 'الولايات المتحدة'),
(88116, 3464631296, 3464631807, 'CA', 'CAN', 'كندا'),
(88117, 3464632064, 3464641791, 'CA', 'CAN', 'كندا'),
(88118, 3464642560, 3464642815, 'CA', 'CAN', 'كندا'),
(88119, 3464643072, 3464647935, 'CA', 'CAN', 'كندا'),
(88120, 3464648192, 3464648703, 'CA', 'CAN', 'كندا'),
(88121, 3464649216, 3464650239, 'CA', 'CAN', 'كندا'),
(88122, 3464650752, 3464664063, 'US', 'USA', 'الولايات المتحدة'),
(88123, 3464664320, 3464684543, 'CA', 'CAN', 'كندا'),
(88124, 3464684800, 3464688383, 'CA', 'CAN', 'كندا'),
(88125, 3464688640, 3464691455, 'CA', 'CAN', 'كندا'),
(88126, 3464691712, 3464768607, 'US', 'USA', 'الولايات المتحدة'),
(88127, 3464768608, 3464768623, 'IT', 'ITA', 'إيطاليا'),
(88128, 3464768624, 3464768767, 'US', 'USA', 'الولايات المتحدة'),
(88129, 3464768768, 3464768895, 'CA', 'CAN', 'كندا'),
(88130, 3464768896, 3464769535, 'US', 'USA', 'الولايات المتحدة'),
(88131, 3464769536, 3464773631, 'CA', 'CAN', 'كندا'),
(88132, 3464773632, 3464802303, 'US', 'USA', 'الولايات المتحدة'),
(88133, 3464802304, 3464806399, 'CA', 'CAN', 'كندا'),
(88134, 3464806400, 3465154559, 'US', 'USA', 'الولايات المتحدة'),
(88135, 3465154560, 3465158655, 'BS', 'BHS', 'جزر البهاما'),
(88136, 3465158656, 3465177087, 'US', 'USA', 'الولايات المتحدة'),
(88137, 3465177088, 3465179135, 'PE', 'PER', 'بيرو'),
(88138, 3465179136, 3465510911, 'US', 'USA', 'الولايات المتحدة'),
(88139, 3465510912, 3465543679, 'JP', 'JPN', 'اليابان'),
(88140, 3465543680, 3465982991, 'US', 'USA', 'الولايات المتحدة'),
(88141, 3465982992, 3465983007, 'GB', 'GBR', 'المملكة المتحدة'),
(88142, 3465983008, 3465983023, 'US', 'USA', 'الولايات المتحدة'),
(88143, 3465983024, 3465983127, 'GB', 'GBR', 'المملكة المتحدة'),
(88144, 3465983128, 3465983167, 'US', 'USA', 'الولايات المتحدة'),
(88145, 3465983168, 3465983199, 'GB', 'GBR', 'المملكة المتحدة'),
(88146, 3465983200, 3465983207, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(88147, 3465983208, 3465983263, 'GB', 'GBR', 'المملكة المتحدة'),
(88148, 3465983264, 3465983271, 'US', 'USA', 'الولايات المتحدة'),
(88149, 3465983272, 3465983311, 'GB', 'GBR', 'المملكة المتحدة'),
(88150, 3465983312, 3465983463, 'US', 'USA', 'الولايات المتحدة'),
(88151, 3465983464, 3465983487, 'GB', 'GBR', 'المملكة المتحدة'),
(88152, 3465983488, 3466044903, 'US', 'USA', 'الولايات المتحدة'),
(88153, 3466044904, 3466044911, 'PH', 'PHL', 'الفلبين'),
(88154, 3466044912, 3466158079, 'US', 'USA', 'الولايات المتحدة'),
(88155, 3466158080, 3466166271, 'PA', 'PAN', 'بنما'),
(88156, 3466166272, 3466282111, 'US', 'USA', 'الولايات المتحدة'),
(88157, 3466282112, 3466282119, 'GB', 'GBR', 'المملكة المتحدة'),
(88158, 3466282120, 3466282727, 'US', 'USA', 'الولايات المتحدة'),
(88159, 3466282728, 3466282743, 'CA', 'CAN', 'كندا'),
(88160, 3466282744, 3466283327, 'US', 'USA', 'الولايات المتحدة'),
(88161, 3466283328, 3466283391, 'CA', 'CAN', 'كندا'),
(88162, 3466283392, 3466313727, 'US', 'USA', 'الولايات المتحدة'),
(88163, 3466313728, 3466317823, 'CA', 'CAN', 'كندا'),
(88164, 3466317824, 3466489855, 'US', 'USA', 'الولايات المتحدة'),
(88165, 3466489856, 3466490111, 'CA', 'CAN', 'كندا'),
(88166, 3466490112, 3466555199, 'US', 'USA', 'الولايات المتحدة'),
(88167, 3466555200, 3466555215, 'CA', 'CAN', 'كندا'),
(88168, 3466555216, 3466558207, 'US', 'USA', 'الولايات المتحدة'),
(88169, 3466558208, 3466558463, 'EC', 'ECU', 'الإكوادور'),
(88170, 3466558464, 3466560255, 'US', 'USA', 'الولايات المتحدة'),
(88171, 3466560256, 3466560511, 'GH', 'GHA', 'غانا'),
(88172, 3466560512, 3466627007, 'US', 'USA', 'الولايات المتحدة'),
(88173, 3466627008, 3466627039, 'PR', 'PRI', 'بورتو ريكو'),
(88174, 3466627040, 3466756095, 'US', 'USA', 'الولايات المتحدة'),
(88175, 3466756096, 3466772479, 'CA', 'CAN', 'كندا'),
(88176, 3466772480, 3466784767, 'US', 'USA', 'الولايات المتحدة'),
(88177, 3466788864, 3466846207, 'US', 'USA', 'الولايات المتحدة'),
(88178, 3466846208, 3466854399, 'CA', 'CAN', 'كندا'),
(88179, 3466854400, 3467051007, 'US', 'USA', 'الولايات المتحدة'),
(88180, 3467051008, 3467068927, 'CA', 'CAN', 'كندا'),
(88181, 3467069440, 3467116543, 'CA', 'CAN', 'كندا'),
(88182, 3467116544, 3467378687, 'US', 'USA', 'الولايات المتحدة'),
(88183, 3467378688, 3467444223, 'CA', 'CAN', 'كندا'),
(88184, 3467444224, 3467554815, 'US', 'USA', 'الولايات المتحدة'),
(88185, 3467554816, 3467567103, 'CA', 'CAN', 'كندا'),
(88186, 3467567104, 3467706367, 'US', 'USA', 'الولايات المتحدة'),
(88187, 3467706368, 3467902975, 'CA', 'CAN', 'كندا'),
(88188, 3467902976, 3467964415, 'US', 'USA', 'الولايات المتحدة'),
(88189, 3467968512, 3468084991, 'US', 'USA', 'الولايات المتحدة'),
(88190, 3468084992, 3468085055, 'CA', 'CAN', 'كندا'),
(88191, 3468085056, 3468085119, 'US', 'USA', 'الولايات المتحدة'),
(88192, 3468085120, 3468085183, 'CA', 'CAN', 'كندا'),
(88193, 3468085184, 3468127999, 'US', 'USA', 'الولايات المتحدة'),
(88194, 3468128000, 3468128255, 'IN', 'IND', 'الهند'),
(88195, 3468128256, 3468142591, 'US', 'USA', 'الولايات المتحدة'),
(88196, 3468144640, 3468296191, 'US', 'USA', 'الولايات المتحدة'),
(88197, 3468296192, 3468361727, 'CA', 'CAN', 'كندا'),
(88198, 3468361728, 3468443647, 'US', 'USA', 'الولايات المتحدة'),
(88199, 3468443648, 3468460031, 'CA', 'CAN', 'كندا'),
(88200, 3468460032, 3468468223, 'BM', 'BMU', 'برمودا'),
(88201, 3468468224, 3468623871, 'US', 'USA', 'الولايات المتحدة'),
(88202, 3468623872, 3468656639, 'CA', 'CAN', 'كندا'),
(88203, 3468656640, 3469050623, 'US', 'USA', 'الولايات المتحدة'),
(88204, 3469050880, 3469055743, 'US', 'USA', 'الولايات المتحدة'),
(88205, 3469055744, 3469055999, 'CA', 'CAN', 'كندا'),
(88206, 3469056000, 3469068287, 'US', 'USA', 'الولايات المتحدة'),
(88207, 3469068800, 3469070335, 'US', 'USA', 'الولايات المتحدة'),
(88208, 3469070592, 3469893631, 'US', 'USA', 'الولايات المتحدة'),
(88209, 3469893632, 3469901823, 'CA', 'CAN', 'كندا'),
(88210, 3469901824, 3469989887, 'US', 'USA', 'الولايات المتحدة'),
(88211, 3469990400, 3470131199, 'US', 'USA', 'الولايات المتحدة'),
(88212, 3470131200, 3470139391, 'AG', 'ATG', 'انتيغوا وبربودا'),
(88213, 3470147584, 3470148095, 'US', 'USA', 'الولايات المتحدة'),
(88214, 3470148096, 3470148351, 'CA', 'CAN', 'كندا'),
(88215, 3470148352, 3470148607, 'US', 'USA', 'الولايات المتحدة'),
(88216, 3470148608, 3470149119, 'CA', 'CAN', 'كندا'),
(88217, 3470149120, 3470151935, 'US', 'USA', 'الولايات المتحدة'),
(88218, 3470151936, 3470152703, 'CA', 'CAN', 'كندا'),
(88219, 3470152704, 3470184544, 'US', 'USA', 'الولايات المتحدة'),
(88220, 3470184545, 3470184545, 'MY', 'MYS', 'ماليزيا'),
(88221, 3470184546, 3470184722, 'US', 'USA', 'الولايات المتحدة'),
(88222, 3470184723, 3470184723, 'MY', 'MYS', 'ماليزيا'),
(88223, 3470184724, 3470184975, 'US', 'USA', 'الولايات المتحدة'),
(88224, 3470184976, 3470184976, 'MY', 'MYS', 'ماليزيا'),
(88225, 3470184977, 3470185294, 'US', 'USA', 'الولايات المتحدة'),
(88226, 3470185295, 3470185295, 'MY', 'MYS', 'ماليزيا'),
(88227, 3470185296, 3470192639, 'US', 'USA', 'الولايات المتحدة'),
(88228, 3470196736, 3470331903, 'US', 'USA', 'الولايات المتحدة'),
(88229, 3470336000, 3470364671, 'US', 'USA', 'الولايات المتحدة'),
(88230, 3470368768, 3470458879, 'US', 'USA', 'الولايات المتحدة'),
(88231, 3470458880, 3470475263, 'KR', 'KOR', 'جمهورية كوريا'),
(88232, 3470475264, 3470558207, 'US', 'USA', 'الولايات المتحدة'),
(88233, 3470558208, 3470559231, 'HK', 'HKG', 'هونغ كونغ'),
(88234, 3470559232, 3470573567, 'US', 'USA', 'الولايات المتحدة'),
(88235, 3470573568, 3470575615, 'CA', 'CAN', 'كندا'),
(88236, 3470575616, 3470610431, 'US', 'USA', 'الولايات المتحدة'),
(88237, 3470610432, 3470614527, 'BR', 'BRA', 'البرازيل'),
(88238, 3470614528, 3470651391, 'US', 'USA', 'الولايات المتحدة'),
(88239, 3470651392, 3470655487, 'CA', 'CAN', 'كندا'),
(88240, 3470655488, 3470671871, 'US', 'USA', 'الولايات المتحدة'),
(88241, 3470671872, 3470680063, 'CA', 'CAN', 'كندا'),
(88242, 3470680064, 3470744063, 'US', 'USA', 'الولايات المتحدة'),
(88243, 3470744064, 3470744575, 'CA', 'CAN', 'كندا'),
(88244, 3470744576, 3470745855, 'US', 'USA', 'الولايات المتحدة'),
(88245, 3470745856, 3470746111, 'CA', 'CAN', 'كندا'),
(88246, 3470746112, 3470749951, 'US', 'USA', 'الولايات المتحدة'),
(88247, 3470749952, 3470750207, 'CA', 'CAN', 'كندا'),
(88248, 3470750208, 3470751999, 'US', 'USA', 'الولايات المتحدة'),
(88249, 3470752256, 3470752767, 'US', 'USA', 'الولايات المتحدة'),
(88250, 3470752768, 3470753023, 'CO', 'COL', 'كولومبيا'),
(88251, 3470753024, 3470754303, 'US', 'USA', 'الولايات المتحدة'),
(88252, 3470754304, 3470754559, 'PE', 'PER', 'بيرو'),
(88253, 3470754560, 3470755839, 'US', 'USA', 'الولايات المتحدة'),
(88254, 3470756096, 3470761983, 'US', 'USA', 'الولايات المتحدة'),
(88255, 3470761984, 3470762751, 'CA', 'CAN', 'كندا'),
(88256, 3470762752, 3470762759, 'NL', 'NLD', 'هولندا'),
(88257, 3470762760, 3470767871, 'CA', 'CAN', 'كندا'),
(88258, 3470767872, 3470768127, 'IE', 'IRL', 'إيرلندا'),
(88259, 3470768128, 3470770175, 'CA', 'CAN', 'كندا'),
(88260, 3470770176, 3470778367, 'US', 'USA', 'الولايات المتحدة'),
(88261, 3470778368, 3470786559, 'CA', 'CAN', 'كندا'),
(88262, 3470786560, 3470794751, 'US', 'USA', 'الولايات المتحدة'),
(88263, 3470794752, 3470802943, 'PA', 'PAN', 'بنما'),
(88264, 3470802944, 3470884863, 'US', 'USA', 'الولايات المتحدة'),
(88265, 3470884864, 3470885887, 'HK', 'HKG', 'هونغ كونغ'),
(88266, 3470885888, 3471057919, 'US', 'USA', 'الولايات المتحدة'),
(88267, 3471057920, 3471058943, 'VE', 'VEN', 'فنزويلا'),
(88268, 3471058944, 3471059455, 'US', 'USA', 'الولايات المتحدة'),
(88269, 3471059456, 3471060223, 'ES', 'ESP', 'إسبانيا'),
(88270, 3471060224, 3471060991, 'US', 'USA', 'الولايات المتحدة'),
(88271, 3471060992, 3471061247, 'NL', 'NLD', 'هولندا'),
(88272, 3471061248, 3471061503, 'US', 'USA', 'الولايات المتحدة'),
(88273, 3471061504, 3471061759, 'NL', 'NLD', 'هولندا'),
(88274, 3471061760, 3471095271, 'US', 'USA', 'الولايات المتحدة'),
(88275, 3471095272, 3471095279, 'CA', 'CAN', 'كندا'),
(88276, 3471095280, 3471529215, 'US', 'USA', 'الولايات المتحدة'),
(88277, 3471529216, 3471529983, 'CA', 'CAN', 'كندا'),
(88278, 3471529984, 3471558655, 'US', 'USA', 'الولايات المتحدة'),
(88279, 3471558656, 3471560703, 'CA', 'CAN', 'كندا'),
(88280, 3471560704, 3471570943, 'US', 'USA', 'الولايات المتحدة'),
(88281, 3471570944, 3471572991, 'CA', 'CAN', 'كندا'),
(88282, 3471572992, 3472375807, 'US', 'USA', 'الولايات المتحدة'),
(88283, 3472375808, 3472392191, 'PR', 'PRI', 'بورتو ريكو'),
(88284, 3472392192, 3472408575, 'CA', 'CAN', 'كندا'),
(88285, 3472408576, 3472721919, 'US', 'USA', 'الولايات المتحدة'),
(88286, 3472723968, 3473039359, 'US', 'USA', 'الولايات المتحدة'),
(88287, 3473039360, 3473041407, 'BM', 'BMU', 'برمودا'),
(88288, 3473041408, 3473108991, 'US', 'USA', 'الولايات المتحدة'),
(88289, 3473108992, 3473113087, 'UY', 'URY', 'الأوروغواي'),
(88290, 3473113088, 3473276927, 'US', 'USA', 'الولايات المتحدة'),
(88291, 3473276928, 3473342463, 'CA', 'CAN', 'كندا'),
(88292, 3473342464, 3473755391, 'US', 'USA', 'الولايات المتحدة'),
(88293, 3473755392, 3473755647, 'HN', 'HND', 'هندوراس'),
(88294, 3473755648, 3473765887, 'US', 'USA', 'الولايات المتحدة'),
(88295, 3473765888, 3473766399, 'EC', 'ECU', 'الإكوادور'),
(88296, 3473766400, 3473813567, 'US', 'USA', 'الولايات المتحدة'),
(88297, 3473813568, 3473813599, 'CA', 'CAN', 'كندا'),
(88298, 3473813600, 3473901055, 'US', 'USA', 'الولايات المتحدة'),
(88299, 3473901056, 3473901311, 'EC', 'ECU', 'الإكوادور'),
(88300, 3473901312, 3474046463, 'US', 'USA', 'الولايات المتحدة'),
(88301, 3474046464, 3474046975, 'MX', 'MEX', 'المكسيك'),
(88302, 3474046976, 3474053119, 'US', 'USA', 'الولايات المتحدة'),
(88303, 3474053120, 3474055167, 'PE', 'PER', 'بيرو'),
(88304, 3474055168, 3474391039, 'US', 'USA', 'الولايات المتحدة'),
(88305, 3474391040, 3474456575, 'CA', 'CAN', 'كندا'),
(88306, 3474456576, 3475112191, 'US', 'USA', 'الولايات المتحدة'),
(88307, 3475112192, 3475113215, 'CA', 'CAN', 'كندا'),
(88308, 3475113216, 3475115007, 'US', 'USA', 'الولايات المتحدة'),
(88309, 3475115008, 3475120127, 'CA', 'CAN', 'كندا'),
(88310, 3475120128, 3475124223, 'US', 'USA', 'الولايات المتحدة'),
(88311, 3475124224, 3475243007, 'CA', 'CAN', 'كندا'),
(88312, 3475243008, 3475589887, 'US', 'USA', 'الولايات المتحدة'),
(88313, 3475589888, 3475590143, 'EC', 'ECU', 'الإكوادور'),
(88314, 3475590144, 3475670015, 'US', 'USA', 'الولايات المتحدة'),
(88315, 3475670016, 3475671039, 'AG', 'ATG', 'انتيغوا وبربودا'),
(88316, 3475671040, 3475719231, 'US', 'USA', 'الولايات المتحدة'),
(88317, 3475719232, 3475719295, 'PR', 'PRI', 'بورتو ريكو'),
(88318, 3475719296, 3475745503, 'US', 'USA', 'الولايات المتحدة'),
(88319, 3475745504, 3475745535, 'CA', 'CAN', 'كندا'),
(88320, 3475745536, 3475851263, 'US', 'USA', 'الولايات المتحدة'),
(88321, 3475853312, 3475881983, 'US', 'USA', 'الولايات المتحدة'),
(88322, 3475881984, 3475884319, 'CA', 'CAN', 'كندا'),
(88323, 3475884320, 3475884327, 'US', 'USA', 'الولايات المتحدة'),
(88324, 3475884328, 3475890175, 'CA', 'CAN', 'كندا'),
(88325, 3475890176, 3475996671, 'US', 'USA', 'الولايات المتحدة'),
(88326, 3475996672, 3476029439, 'CA', 'CAN', 'كندا'),
(88327, 3476029440, 3476111359, 'US', 'USA', 'الولايات المتحدة'),
(88328, 3476111360, 3476111871, 'CA', 'CAN', 'كندا'),
(88329, 3476111872, 3476221951, 'US', 'USA', 'الولايات المتحدة'),
(88330, 3476221952, 3476223999, 'UY', 'URY', 'الأوروغواي'),
(88331, 3476224000, 3476418559, 'US', 'USA', 'الولايات المتحدة'),
(88332, 3476418560, 3476422655, 'CA', 'CAN', 'كندا'),
(88333, 3476422656, 3476447231, 'US', 'USA', 'الولايات المتحدة'),
(88334, 3476447232, 3476455423, 'CA', 'CAN', 'كندا'),
(88335, 3476455424, 3476881407, 'US', 'USA', 'الولايات المتحدة'),
(88336, 3476881408, 3476946943, 'CA', 'CAN', 'كندا'),
(88337, 3476946944, 3477577727, 'US', 'USA', 'الولايات المتحدة'),
(88338, 3477581824, 3478114303, 'US', 'USA', 'الولايات المتحدة'),
(88339, 3478114304, 3478118399, 'PE', 'PER', 'بيرو'),
(88340, 3478118400, 3478192127, 'US', 'USA', 'الولايات المتحدة'),
(88341, 3478192128, 3478257663, 'CA', 'CAN', 'كندا'),
(88342, 3478257664, 3478294527, 'US', 'USA', 'الولايات المتحدة'),
(88343, 3478294528, 3478294543, 'GB', 'GBR', 'المملكة المتحدة'),
(88344, 3478294544, 3478352111, 'US', 'USA', 'الولايات المتحدة'),
(88345, 3478352112, 3478352119, 'GB', 'GBR', 'المملكة المتحدة'),
(88346, 3478352120, 3478364159, 'US', 'USA', 'الولايات المتحدة'),
(88347, 3478364160, 3478364167, 'BR', 'BRA', 'البرازيل'),
(88348, 3478364168, 3479207935, 'US', 'USA', 'الولايات المتحدة'),
(88349, 3479207936, 3479214079, 'CA', 'CAN', 'كندا'),
(88350, 3479214080, 3479214335, 'US', 'USA', 'الولايات المتحدة'),
(88351, 3479214336, 3479240703, 'CA', 'CAN', 'كندا'),
(88352, 3479240704, 3479568383, 'US', 'USA', 'الولايات المتحدة'),
(88353, 3479568384, 3479633919, 'CA', 'CAN', 'كندا'),
(88354, 3479633920, 3479896063, 'US', 'USA', 'الولايات المتحدة'),
(88355, 3479896064, 3479961599, 'CA', 'CAN', 'كندا'),
(88356, 3479961600, 3480223743, 'US', 'USA', 'الولايات المتحدة'),
(88357, 3480223744, 3480256511, 'CA', 'CAN', 'كندا'),
(88358, 3480256512, 3480284159, 'US', 'USA', 'الولايات المتحدة'),
(88359, 3480284160, 3480284671, 'CA', 'CAN', 'كندا'),
(88360, 3480284672, 3480444927, 'US', 'USA', 'الولايات المتحدة'),
(88361, 3480444928, 3480449023, 'CA', 'CAN', 'كندا'),
(88362, 3480449024, 3481169151, 'US', 'USA', 'الولايات المتحدة'),
(88363, 3481169152, 3481169407, 'NZ', 'NZL', 'نيوزيلاندا'),
(88364, 3481169408, 3481176063, 'US', 'USA', 'الولايات المتحدة'),
(88365, 3481178112, 3481665535, 'US', 'USA', 'الولايات المتحدة'),
(88366, 3481665536, 3481731071, 'CA', 'CAN', 'كندا'),
(88367, 3481731072, 3481812991, 'US', 'USA', 'الولايات المتحدة'),
(88368, 3481812992, 3481829375, 'CA', 'CAN', 'كندا'),
(88369, 3481829376, 3481993215, 'US', 'USA', 'الولايات المتحدة'),
(88370, 3481993216, 3481993887, 'CA', 'CAN', 'كندا'),
(88371, 3481993888, 3481993895, 'US', 'USA', 'الولايات المتحدة'),
(88372, 3481993896, 3482058751, 'CA', 'CAN', 'كندا'),
(88373, 3482058752, 3482583039, 'US', 'USA', 'الولايات المتحدة'),
(88374, 3482583040, 3482632191, 'CA', 'CAN', 'كندا'),
(88375, 3482632192, 3482775551, 'US', 'USA', 'الولايات المتحدة'),
(88376, 3482775552, 3482779647, 'PR', 'PRI', 'بورتو ريكو'),
(88377, 3482779648, 3482910719, 'US', 'USA', 'الولايات المتحدة'),
(88378, 3482910720, 3482927103, 'CA', 'CAN', 'كندا'),
(88379, 3482927104, 3483296004, 'US', 'USA', 'الولايات المتحدة'),
(88380, 3483296005, 3483296005, 'BE', 'BEL', 'بلجيكا'),
(88381, 3483296006, 3483435007, 'US', 'USA', 'الولايات المتحدة'),
(88382, 3483435008, 3483533311, 'CA', 'CAN', 'كندا'),
(88383, 3483533312, 3483631615, 'US', 'USA', 'الولايات المتحدة'),
(88384, 3483631616, 3483697151, 'CA', 'CAN', 'كندا'),
(88385, 3483697152, 3483791359, 'US', 'USA', 'الولايات المتحدة'),
(88386, 3483791360, 3483795455, 'PR', 'PRI', 'بورتو ريكو'),
(88387, 3483795456, 3483828223, 'US', 'USA', 'الولايات المتحدة'),
(88388, 3483828224, 3483836415, 'CA', 'CAN', 'كندا'),
(88389, 3483836416, 3483877375, 'US', 'USA', 'الولايات المتحدة'),
(88390, 3483877376, 3483893759, 'CA', 'CAN', 'كندا'),
(88391, 3483893760, 3484319743, 'US', 'USA', 'الولايات المتحدة'),
(88392, 3484320256, 3484320511, 'US', 'USA', 'الولايات المتحدة'),
(88393, 3484322048, 3484323839, 'US', 'USA', 'الولايات المتحدة'),
(88394, 3484327168, 3484327423, 'US', 'USA', 'الولايات المتحدة'),
(88395, 3484331264, 3484331519, 'US', 'USA', 'الولايات المتحدة'),
(88396, 3484331776, 3484332031, 'US', 'USA', 'الولايات المتحدة'),
(88397, 3484338432, 3484338943, 'US', 'USA', 'الولايات المتحدة'),
(88398, 3484340736, 3484341247, 'US', 'USA', 'الولايات المتحدة'),
(88399, 3484352512, 3484450815, 'US', 'USA', 'الولايات المتحدة'),
(88400, 3484450816, 3484451327, 'CA', 'CAN', 'كندا'),
(88401, 3484451328, 3484451871, 'US', 'USA', 'الولايات المتحدة'),
(88402, 3484451872, 3484451903, 'CA', 'CAN', 'كندا'),
(88403, 3484451904, 3484451967, 'US', 'USA', 'الولايات المتحدة'),
(88404, 3484451968, 3484451999, 'CA', 'CAN', 'كندا'),
(88405, 3484452000, 3484452031, 'US', 'USA', 'الولايات المتحدة'),
(88406, 3484452032, 3484452063, 'CA', 'CAN', 'كندا'),
(88407, 3484452064, 3484452095, 'US', 'USA', 'الولايات المتحدة'),
(88408, 3484452096, 3484452351, 'CA', 'CAN', 'كندا'),
(88409, 3484452352, 3484453887, 'US', 'USA', 'الولايات المتحدة'),
(88410, 3484453888, 3484455167, 'CA', 'CAN', 'كندا'),
(88411, 3484455168, 3484455199, 'US', 'USA', 'الولايات المتحدة'),
(88412, 3484455200, 3484455231, 'CA', 'CAN', 'كندا'),
(88413, 3484455232, 3484455359, 'US', 'USA', 'الولايات المتحدة'),
(88414, 3484455360, 3484455423, 'CA', 'CAN', 'كندا'),
(88415, 3484455424, 3484457215, 'US', 'USA', 'الولايات المتحدة'),
(88416, 3484457216, 3484457471, 'CA', 'CAN', 'كندا'),
(88417, 3484457472, 3484459007, 'US', 'USA', 'الولايات المتحدة'),
(88418, 3484459008, 3484459775, 'CA', 'CAN', 'كندا'),
(88419, 3484459776, 3484460735, 'US', 'USA', 'الولايات المتحدة'),
(88420, 3484460736, 3484460751, 'CA', 'CAN', 'كندا'),
(88421, 3484460752, 3484462335, 'US', 'USA', 'الولايات المتحدة'),
(88422, 3484462336, 3484462591, 'CA', 'CAN', 'كندا'),
(88423, 3484462592, 3484463615, 'US', 'USA', 'الولايات المتحدة'),
(88424, 3484463616, 3484464143, 'CA', 'CAN', 'كندا'),
(88425, 3484464144, 3484464831, 'US', 'USA', 'الولايات المتحدة'),
(88426, 3484464832, 3484464895, 'CA', 'CAN', 'كندا'),
(88427, 3484464896, 3484465663, 'US', 'USA', 'الولايات المتحدة'),
(88428, 3484465664, 3484465919, 'CA', 'CAN', 'كندا'),
(88429, 3484465920, 3484466687, 'US', 'USA', 'الولايات المتحدة'),
(88430, 3484466688, 3484467199, 'CA', 'CAN', 'كندا'),
(88431, 3484467200, 3484467967, 'US', 'USA', 'الولايات المتحدة'),
(88432, 3484467968, 3484468223, 'CA', 'CAN', 'كندا'),
(88433, 3484468224, 3484468479, 'US', 'USA', 'الولايات المتحدة'),
(88434, 3484468480, 3484468991, 'CA', 'CAN', 'كندا'),
(88435, 3484468992, 3484469247, 'US', 'USA', 'الولايات المتحدة'),
(88436, 3484469248, 3484469759, 'CA', 'CAN', 'كندا'),
(88437, 3484469760, 3484470271, 'US', 'USA', 'الولايات المتحدة'),
(88438, 3484470272, 3484470527, 'CA', 'CAN', 'كندا'),
(88439, 3484470528, 3484471807, 'US', 'USA', 'الولايات المتحدة'),
(88440, 3484471808, 3484472063, 'CA', 'CAN', 'كندا'),
(88441, 3484472064, 3484473343, 'US', 'USA', 'الولايات المتحدة'),
(88442, 3484473344, 3484473599, 'CA', 'CAN', 'كندا'),
(88443, 3484473600, 3484473855, 'US', 'USA', 'الولايات المتحدة'),
(88444, 3484473856, 3484474623, 'CA', 'CAN', 'كندا'),
(88445, 3484474624, 3484475135, 'US', 'USA', 'الولايات المتحدة'),
(88446, 3484475136, 3484475647, 'CA', 'CAN', 'كندا'),
(88447, 3484475648, 3484475903, 'US', 'USA', 'الولايات المتحدة'),
(88448, 3484475904, 3484476159, 'CA', 'CAN', 'كندا'),
(88449, 3484476160, 3484476415, 'US', 'USA', 'الولايات المتحدة'),
(88450, 3484476416, 3484476927, 'CA', 'CAN', 'كندا'),
(88451, 3484476928, 3484480255, 'US', 'USA', 'الولايات المتحدة'),
(88452, 3484480256, 3484481279, 'CA', 'CAN', 'كندا'),
(88453, 3484481280, 3484481791, 'US', 'USA', 'الولايات المتحدة'),
(88454, 3484481792, 3484482047, 'CA', 'CAN', 'كندا'),
(88455, 3484482048, 3484482559, 'US', 'USA', 'الولايات المتحدة'),
(88456, 3484482560, 3484482815, 'CA', 'CAN', 'كندا'),
(88457, 3484482816, 3484483071, 'US', 'USA', 'الولايات المتحدة'),
(88458, 3484483072, 3484483327, 'CA', 'CAN', 'كندا'),
(88459, 3484483328, 3484647423, 'US', 'USA', 'الولايات المتحدة'),
(88460, 3484647424, 3484663807, 'CA', 'CAN', 'كندا'),
(88461, 3484663808, 3484746815, 'US', 'USA', 'الولايات المتحدة'),
(88462, 3484746816, 3484746943, 'GB', 'GBR', 'المملكة المتحدة'),
(88463, 3484746944, 3484762111, 'US', 'USA', 'الولايات المتحدة'),
(88464, 3484762112, 3484778495, 'CA', 'CAN', 'كندا'),
(88465, 3484778496, 3484884991, 'US', 'USA', 'الولايات المتحدة'),
(88466, 3484884992, 3484893183, 'CA', 'CAN', 'كندا'),
(88467, 3484893184, 3485220863, 'US', 'USA', 'الولايات المتحدة'),
(88468, 3485220864, 3485229055, 'CA', 'CAN', 'كندا'),
(88469, 3485229056, 3485278207, 'US', 'USA', 'الولايات المتحدة'),
(88470, 3485286400, 3485290463, 'US', 'USA', 'الولايات المتحدة'),
(88471, 3485290464, 3485290479, 'GB', 'GBR', 'المملكة المتحدة'),
(88472, 3485290480, 3485327359, 'US', 'USA', 'الولايات المتحدة'),
(88473, 3485327360, 3485335551, 'CA', 'CAN', 'كندا'),
(88474, 3485335552, 3485442047, 'US', 'USA', 'الولايات المتحدة'),
(88475, 3485446144, 3485462527, 'US', 'USA', 'الولايات المتحدة'),
(88476, 3485462528, 3485466623, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(88477, 3485466624, 3485597695, 'US', 'USA', 'الولايات المتحدة'),
(88478, 3485597696, 3485671583, 'CA', 'CAN', 'كندا'),
(88479, 3485671584, 3485671615, 'US', 'USA', 'الولايات المتحدة'),
(88480, 3485671616, 3485672543, 'CA', 'CAN', 'كندا'),
(88481, 3485672544, 3485672551, 'US', 'USA', 'الولايات المتحدة'),
(88482, 3485672552, 3485695999, 'CA', 'CAN', 'كندا'),
(88483, 3485696000, 3485700095, 'US', 'USA', 'الولايات المتحدة'),
(88484, 3485704192, 3486023679, 'US', 'USA', 'الولايات المتحدة'),
(88485, 3486023680, 3486031871, 'CA', 'CAN', 'كندا'),
(88486, 3486031872, 3486269439, 'US', 'USA', 'الولايات المتحدة'),
(88487, 3486269440, 3486285823, 'JM', 'JAM', 'جامايكا'),
(88488, 3486285824, 3486302207, 'PR', 'PRI', 'بورتو ريكو'),
(88489, 3486302208, 3486310399, 'CA', 'CAN', 'كندا'),
(88490, 3486318592, 3486646271, 'US', 'USA', 'الولايات المتحدة'),
(88491, 3486646272, 3486662655, 'CA', 'CAN', 'كندا'),
(88492, 3486662656, 3486699519, 'US', 'USA', 'الولايات المتحدة'),
(88493, 3486699520, 3486699775, 'CA', 'CAN', 'كندا'),
(88494, 3486699776, 3486700399, 'US', 'USA', 'الولايات المتحدة'),
(88495, 3486700400, 3486700407, 'CA', 'CAN', 'كندا'),
(88496, 3486700408, 3486701311, 'US', 'USA', 'الولايات المتحدة'),
(88497, 3486701312, 3486701567, 'CA', 'CAN', 'كندا'),
(88498, 3486701568, 3486711551, 'US', 'USA', 'الولايات المتحدة'),
(88499, 3486711552, 3486711807, 'CA', 'CAN', 'كندا'),
(88500, 3486711808, 3487039487, 'US', 'USA', 'الولايات المتحدة'),
(88501, 3487039488, 3487105023, 'CA', 'CAN', 'كندا'),
(88502, 3487105024, 3487187199, 'US', 'USA', 'الولايات المتحدة'),
(88503, 3487187200, 3487187215, 'GB', 'GBR', 'المملكة المتحدة'),
(88504, 3487187216, 3487189247, 'US', 'USA', 'الولايات المتحدة'),
(88505, 3487189248, 3487189503, 'DK', 'DNK', 'الدنيمارك'),
(88506, 3487189504, 3487193599, 'US', 'USA', 'الولايات المتحدة'),
(88507, 3487193600, 3487193855, 'DK', 'DNK', 'الدنيمارك'),
(88508, 3487193856, 3487197183, 'US', 'USA', 'الولايات المتحدة'),
(88509, 3487197184, 3487197439, 'DK', 'DNK', 'الدنيمارك'),
(88510, 3487197440, 3487203071, 'US', 'USA', 'الولايات المتحدة'),
(88511, 3487203072, 3487203327, 'DK', 'DNK', 'الدنيمارك'),
(88512, 3487203328, 3487236095, 'US', 'USA', 'الولايات المتحدة'),
(88513, 3487236096, 3487301631, 'CA', 'CAN', 'كندا'),
(88514, 3487301632, 3487502335, 'US', 'USA', 'الولايات المتحدة'),
(88515, 3487514624, 3487526911, 'US', 'USA', 'الولايات المتحدة'),
(88516, 3487531008, 3487543295, 'US', 'USA', 'الولايات المتحدة'),
(88517, 3487547392, 3487766527, 'US', 'USA', 'الولايات المتحدة'),
(88518, 3487766528, 3487768575, 'CA', 'CAN', 'كندا'),
(88519, 3487768576, 3487842303, 'US', 'USA', 'الولايات المتحدة'),
(88520, 3487842304, 3487858687, 'CA', 'CAN', 'كندا'),
(88521, 3487858688, 3487859199, 'KY', 'CYM', 'جزر كايمان'),
(88522, 3487859200, 3487861759, 'BM', 'BMU', 'برمودا'),
(88523, 3487861760, 3487862015, 'KY', 'CYM', 'جزر كايمان'),
(88524, 3487862016, 3487875071, 'BM', 'BMU', 'برمودا'),
(88525, 3487875072, 3487891455, 'US', 'USA', 'الولايات المتحدة'),
(88526, 3487891456, 3487907839, 'CA', 'CAN', 'كندا'),
(88527, 3487907840, 3488014335, 'US', 'USA', 'الولايات المتحدة'),
(88528, 3488014336, 3488022527, 'CA', 'CAN', 'كندا'),
(88529, 3488022528, 3488049151, 'US', 'USA', 'الولايات المتحدة'),
(88530, 3488051200, 3488065535, 'US', 'USA', 'الولايات المتحدة'),
(88531, 3488067584, 3488071679, 'US', 'USA', 'الولايات المتحدة'),
(88532, 3488071680, 3488072703, 'CA', 'CAN', 'كندا'),
(88533, 3488072704, 3488079871, 'US', 'USA', 'الولايات المتحدة'),
(88534, 3488079872, 3488083967, 'CA', 'CAN', 'كندا'),
(88535, 3488083968, 3488089119, 'US', 'USA', 'الولايات المتحدة'),
(88536, 3488089120, 3488089151, 'IL', 'ISR', 'إسرائيل'),
(88537, 3488089152, 3488089215, 'US', 'USA', 'الولايات المتحدة'),
(88538, 3488089216, 3488089343, 'IL', 'ISR', 'إسرائيل'),
(88539, 3488089344, 3488089887, 'US', 'USA', 'الولايات المتحدة'),
(88540, 3488089888, 3488089983, 'IL', 'ISR', 'إسرائيل'),
(88541, 3488089984, 3488090527, 'US', 'USA', 'الولايات المتحدة'),
(88542, 3488090528, 3488090559, 'IL', 'ISR', 'إسرائيل'),
(88543, 3488090560, 3488090623, 'US', 'USA', 'الولايات المتحدة'),
(88544, 3488090624, 3488090687, 'IL', 'ISR', 'إسرائيل'),
(88545, 3488090688, 3488090719, 'US', 'USA', 'الولايات المتحدة'),
(88546, 3488090720, 3488090879, 'IL', 'ISR', 'إسرائيل'),
(88547, 3488090880, 3488090943, 'US', 'USA', 'الولايات المتحدة'),
(88548, 3488090944, 3488090975, 'IL', 'ISR', 'إسرائيل'),
(88549, 3488090976, 3488091647, 'US', 'USA', 'الولايات المتحدة'),
(88550, 3488091648, 3488091775, 'IL', 'ISR', 'إسرائيل'),
(88551, 3488091776, 3488092943, 'US', 'USA', 'الولايات المتحدة'),
(88552, 3488092944, 3488092959, 'IL', 'ISR', 'إسرائيل'),
(88553, 3488092960, 3488092991, 'US', 'USA', 'الولايات المتحدة'),
(88554, 3488092992, 3488093055, 'IL', 'ISR', 'إسرائيل'),
(88555, 3488093056, 3488093951, 'US', 'USA', 'الولايات المتحدة'),
(88556, 3488093952, 3488094015, 'IL', 'ISR', 'إسرائيل'),
(88557, 3488094016, 3488094719, 'US', 'USA', 'الولايات المتحدة'),
(88558, 3488094720, 3488094735, 'IL', 'ISR', 'إسرائيل'),
(88559, 3488094736, 3488094751, 'US', 'USA', 'الولايات المتحدة'),
(88560, 3488094752, 3488094783, 'IL', 'ISR', 'إسرائيل'),
(88561, 3488094784, 3488094831, 'US', 'USA', 'الولايات المتحدة'),
(88562, 3488094832, 3488094847, 'IL', 'ISR', 'إسرائيل'),
(88563, 3488094848, 3488095103, 'US', 'USA', 'الولايات المتحدة'),
(88564, 3488095104, 3488095119, 'IL', 'ISR', 'إسرائيل'),
(88565, 3488095120, 3488112639, 'US', 'USA', 'الولايات المتحدة'),
(88566, 3488112640, 3488120831, 'CA', 'CAN', 'كندا'),
(88567, 3488120832, 3488350207, 'US', 'USA', 'الولايات المتحدة'),
(88568, 3488350208, 3488415743, 'CA', 'CAN', 'كندا'),
(88569, 3488415744, 3488722687, 'US', 'USA', 'الولايات المتحدة'),
(88570, 3488722688, 3488723199, 'JM', 'JAM', 'جامايكا'),
(88571, 3488723200, 3488909311, 'US', 'USA', 'الولايات المتحدة'),
(88572, 3488911360, 3488940031, 'US', 'USA', 'الولايات المتحدة'),
(88573, 3488940032, 3488956415, 'CA', 'CAN', 'كندا'),
(88574, 3488956416, 3488989183, 'US', 'USA', 'الولايات المتحدة'),
(88575, 3488989184, 3489005567, 'CA', 'CAN', 'كندا'),
(88576, 3489005568, 3489136639, 'US', 'USA', 'الولايات المتحدة'),
(88577, 3489136640, 3489267711, 'MX', 'MEX', 'المكسيك'),
(88578, 3489267712, 3489341439, 'US', 'USA', 'الولايات المتحدة'),
(88579, 3489341440, 3489345535, 'CA', 'CAN', 'كندا'),
(88580, 3489345536, 3489398783, 'US', 'USA', 'الولايات المتحدة'),
(88581, 3489398784, 3489399039, 'IT', 'ITA', 'إيطاليا'),
(88582, 3489399040, 3489464319, 'US', 'USA', 'الولايات المتحدة'),
(88583, 3489464320, 3489529855, 'CA', 'CAN', 'كندا'),
(88584, 3489529856, 3489562623, 'US', 'USA', 'الولايات المتحدة'),
(88585, 3489562624, 3489566719, 'JM', 'JAM', 'جامايكا'),
(88586, 3489566720, 3489583103, 'US', 'USA', 'الولايات المتحدة'),
(88587, 3489587200, 3489717759, 'US', 'USA', 'الولايات المتحدة'),
(88588, 3489717760, 3489718015, 'PR', 'PRI', 'بورتو ريكو'),
(88589, 3489718016, 3489718271, 'US', 'USA', 'الولايات المتحدة'),
(88590, 3489718272, 3489718527, 'AG', 'ATG', 'انتيغوا وبربودا'),
(88591, 3489718528, 3489719039, 'LC', 'LCA', 'سانت لوسيا'),
(88592, 3489719040, 3489720063, 'AG', 'ATG', 'انتيغوا وبربودا'),
(88593, 3489720064, 3489720319, 'LC', 'LCA', 'سانت لوسيا'),
(88594, 3489720320, 3489738751, 'US', 'USA', 'الولايات المتحدة'),
(88595, 3489738752, 3489740799, 'PH', 'PHL', 'الفلبين'),
(88596, 3489740800, 3489741783, 'US', 'USA', 'الولايات المتحدة'),
(88597, 3489741784, 3489741791, 'CA', 'CAN', 'كندا'),
(88598, 3489741792, 3489749503, 'US', 'USA', 'الولايات المتحدة'),
(88599, 3489749504, 3489749519, 'CA', 'CAN', 'كندا'),
(88600, 3489749520, 3489756119, 'US', 'USA', 'الولايات المتحدة'),
(88601, 3489756120, 3489756127, 'DE', 'DEU', 'ألمانيا'),
(88602, 3489756128, 3489761743, 'US', 'USA', 'الولايات المتحدة'),
(88603, 3489761744, 3489761759, 'CA', 'CAN', 'كندا'),
(88604, 3489761760, 3489774831, 'US', 'USA', 'الولايات المتحدة'),
(88605, 3489774832, 3489774839, 'GB', 'GBR', 'المملكة المتحدة'),
(88606, 3489774840, 3489775103, 'US', 'USA', 'الولايات المتحدة'),
(88607, 3489775104, 3489775359, 'BO', 'BOL', 'بوليفيا'),
(88608, 3489775360, 3490041503, 'US', 'USA', 'الولايات المتحدة'),
(88609, 3490041504, 3490041535, 'CA', 'CAN', 'كندا'),
(88610, 3490041536, 3490263039, 'US', 'USA', 'الولايات المتحدة'),
(88611, 3490263040, 3490267135, 'CO', 'COL', 'كولومبيا'),
(88612, 3490267136, 3490653871, 'US', 'USA', 'الولايات المتحدة'),
(88613, 3490653872, 3490653887, 'CA', 'CAN', 'كندا'),
(88614, 3490653888, 3490703615, 'US', 'USA', 'الولايات المتحدة'),
(88615, 3490703616, 3490703871, 'PR', 'PRI', 'بورتو ريكو'),
(88616, 3490703872, 3490732431, 'US', 'USA', 'الولايات المتحدة'),
(88617, 3490732432, 3490732447, 'CA', 'CAN', 'كندا'),
(88618, 3490732448, 3490786047, 'US', 'USA', 'الولايات المتحدة'),
(88619, 3490786048, 3490786303, 'PR', 'PRI', 'بورتو ريكو'),
(88620, 3490786304, 3490879231, 'US', 'USA', 'الولايات المتحدة'),
(88621, 3490879232, 3490879487, 'PR', 'PRI', 'بورتو ريكو'),
(88622, 3490879488, 3491226687, 'US', 'USA', 'الولايات المتحدة'),
(88623, 3491226688, 3491226719, 'CA', 'CAN', 'كندا'),
(88624, 3491226720, 3491231807, 'US', 'USA', 'الولايات المتحدة'),
(88625, 3491231808, 3491231823, 'PR', 'PRI', 'بورتو ريكو'),
(88626, 3491231824, 3491358183, 'US', 'USA', 'الولايات المتحدة'),
(88627, 3491358184, 3491358191, 'PR', 'PRI', 'بورتو ريكو'),
(88628, 3491358192, 3491381247, 'US', 'USA', 'الولايات المتحدة'),
(88629, 3491381248, 3491389439, 'BM', 'BMU', 'برمودا'),
(88630, 3491389440, 3491476991, 'US', 'USA', 'الولايات المتحدة'),
(88631, 3491476992, 3491478527, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(88632, 3491478528, 3491506631, 'US', 'USA', 'الولايات المتحدة'),
(88633, 3491506632, 3491506639, 'DK', 'DNK', 'الدنيمارك'),
(88634, 3491506640, 3491637247, 'US', 'USA', 'الولايات المتحدة'),
(88635, 3491637248, 3491637759, 'CO', 'COL', 'كولومبيا'),
(88636, 3491637760, 3491651583, 'US', 'USA', 'الولايات المتحدة'),
(88637, 3491651584, 3491659775, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(88638, 3491659776, 3491743743, 'US', 'USA', 'الولايات المتحدة'),
(88639, 3491743744, 3491745791, 'CO', 'COL', 'كولومبيا'),
(88640, 3491745792, 3491764783, 'US', 'USA', 'الولايات المتحدة'),
(88641, 3491764784, 3491764791, 'PR', 'PRI', 'بورتو ريكو'),
(88642, 3491764792, 3491780607, 'US', 'USA', 'الولايات المتحدة'),
(88643, 3491780608, 3491781631, 'EC', 'ECU', 'الإكوادور'),
(88644, 3491781632, 3491968423, 'US', 'USA', 'الولايات المتحدة'),
(88645, 3491968424, 3491968431, 'PR', 'PRI', 'بورتو ريكو'),
(88646, 3491968432, 3491968447, 'AF', 'AFG', 'أفغانستان'),
(88647, 3491968448, 3491971607, 'US', 'USA', 'الولايات المتحدة'),
(88648, 3491971608, 3491971615, 'IT', 'ITA', 'إيطاليا'),
(88649, 3491971616, 3491971751, 'US', 'USA', 'الولايات المتحدة'),
(88650, 3491971752, 3491971759, 'AU', 'AUS', 'أستراليا'),
(88651, 3491971760, 3491971951, 'US', 'USA', 'الولايات المتحدة'),
(88652, 3491971952, 3491971967, 'HK', 'HKG', 'هونغ كونغ'),
(88653, 3491971968, 3491973151, 'US', 'USA', 'الولايات المتحدة'),
(88654, 3491973152, 3491973159, 'VE', 'VEN', 'فنزويلا'),
(88655, 3491973160, 3492005375, 'US', 'USA', 'الولايات المتحدة'),
(88656, 3492005376, 3492005391, 'DK', 'DNK', 'الدنيمارك'),
(88657, 3492005392, 3492005439, 'US', 'USA', 'الولايات المتحدة'),
(88658, 3492005440, 3492005447, 'DK', 'DNK', 'الدنيمارك'),
(88659, 3492005448, 3492005463, 'US', 'USA', 'الولايات المتحدة'),
(88660, 3492005464, 3492005487, 'AU', 'AUS', 'أستراليا'),
(88661, 3492005488, 3492151295, 'US', 'USA', 'الولايات المتحدة'),
(88662, 3492151296, 3492167679, 'CA', 'CAN', 'كندا'),
(88663, 3492167680, 3492188799, 'US', 'USA', 'الولايات المتحدة'),
(88664, 3492188800, 3492188831, 'CH', 'CHE', 'سويسرا'),
(88665, 3492188832, 3492208639, 'US', 'USA', 'الولايات المتحدة'),
(88666, 3492216832, 3492669951, 'US', 'USA', 'الولايات المتحدة'),
(88667, 3492669952, 3492671487, 'PA', 'PAN', 'بنما'),
(88668, 3492671488, 3492827391, 'US', 'USA', 'الولايات المتحدة'),
(88669, 3492827392, 3492827423, 'CA', 'CAN', 'كندا'),
(88670, 3492827424, 3492827431, 'US', 'USA', 'الولايات المتحدة'),
(88671, 3492827432, 3492827439, 'DE', 'DEU', 'ألمانيا'),
(88672, 3492827440, 3492827455, 'AU', 'AUS', 'أستراليا'),
(88673, 3492827456, 3492827519, 'US', 'USA', 'الولايات المتحدة'),
(88674, 3492827520, 3492827647, 'AU', 'AUS', 'أستراليا'),
(88675, 3492827648, 3492827903, 'US', 'USA', 'الولايات المتحدة'),
(88676, 3492827904, 3492827967, 'AU', 'AUS', 'أستراليا'),
(88677, 3492827968, 3493070847, 'US', 'USA', 'الولايات المتحدة'),
(88678, 3493070848, 3493071871, 'HT', 'HTI', 'هايتي'),
(88679, 3493071872, 3493073151, 'US', 'USA', 'الولايات المتحدة'),
(88680, 3493073152, 3493073407, 'BO', 'BOL', 'بوليفيا'),
(88681, 3493073408, 3493073663, 'US', 'USA', 'الولايات المتحدة'),
(88682, 3493073664, 3493073919, 'BO', 'BOL', 'بوليفيا'),
(88683, 3493073920, 3493074175, 'US', 'USA', 'الولايات المتحدة'),
(88684, 3493074176, 3493074431, 'BO', 'BOL', 'بوليفيا'),
(88685, 3493074432, 3493078527, 'HT', 'HTI', 'هايتي'),
(88686, 3493078528, 3493079039, 'US', 'USA', 'الولايات المتحدة'),
(88687, 3493079040, 3493081087, 'HT', 'HTI', 'هايتي'),
(88688, 3493081088, 3493081599, 'US', 'USA', 'الولايات المتحدة'),
(88689, 3493081600, 3493082623, 'PY', 'PRY', 'باراغواي'),
(88690, 3493082624, 3493091327, 'US', 'USA', 'الولايات المتحدة'),
(88691, 3493091328, 3493092351, 'BO', 'BOL', 'بوليفيا'),
(88692, 3493092352, 3493092607, 'NA', 'NAM', 'ناميبيا'),
(88693, 3493092608, 3493141279, 'US', 'USA', 'الولايات المتحدة'),
(88694, 3493141280, 3493141311, 'CY', 'CYP', 'قبرص'),
(88695, 3493141312, 3493244927, 'US', 'USA', 'الولايات المتحدة'),
(88696, 3493244928, 3493249023, 'PR', 'PRI', 'بورتو ريكو'),
(88697, 3493249024, 3493866495, 'US', 'USA', 'الولايات المتحدة'),
(88698, 3493866496, 3493867519, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(88699, 3493867520, 3493874687, 'US', 'USA', 'الولايات المتحدة'),
(88700, 3493874688, 3493875711, 'BM', 'BMU', 'برمودا'),
(88701, 3493875712, 3493881855, 'US', 'USA', 'الولايات المتحدة'),
(88702, 3493881856, 3493882879, 'CA', 'CAN', 'كندا'),
(88703, 3493882880, 3493903551, 'US', 'USA', 'الولايات المتحدة'),
(88704, 3493903552, 3493903567, 'KW', 'KWT', 'الكويت'),
(88705, 3493903568, 3493936127, 'US', 'USA', 'الولايات المتحدة'),
(88706, 3493936128, 3493937151, 'CA', 'CAN', 'كندا'),
(88707, 3493937152, 3493939199, 'US', 'USA', 'الولايات المتحدة'),
(88708, 3493939200, 3493941247, 'CA', 'CAN', 'كندا'),
(88709, 3493941248, 3493980159, 'US', 'USA', 'الولايات المتحدة'),
(88710, 3493981184, 3493982207, 'US', 'USA', 'الولايات المتحدة'),
(88711, 3493982208, 3493984255, 'CA', 'CAN', 'كندا'),
(88712, 3493984256, 3493986303, 'US', 'USA', 'الولايات المتحدة'),
(88713, 3493986304, 3493987327, 'CA', 'CAN', 'كندا'),
(88714, 3493987328, 3493990399, 'US', 'USA', 'الولايات المتحدة'),
(88715, 3493990400, 3493991423, 'CA', 'CAN', 'كندا'),
(88716, 3493991424, 3493998591, 'US', 'USA', 'الولايات المتحدة'),
(88717, 3493998592, 3494000639, 'AI', 'AIA', 'أنغيلا'),
(88718, 3494000640, 3494003711, 'US', 'USA', 'الولايات المتحدة'),
(88719, 3494003712, 3494004735, 'CA', 'CAN', 'كندا'),
(88720, 3494004736, 3494009855, 'US', 'USA', 'الولايات المتحدة'),
(88721, 3494009856, 3494010879, 'CA', 'CAN', 'كندا'),
(88722, 3494010880, 3494014975, 'US', 'USA', 'الولايات المتحدة'),
(88723, 3494014976, 3494017023, 'CA', 'CAN', 'كندا'),
(88724, 3494017024, 3494025215, 'US', 'USA', 'الولايات المتحدة'),
(88725, 3494027264, 3494035455, 'US', 'USA', 'الولايات المتحدة'),
(88726, 3494036480, 3494044671, 'US', 'USA', 'الولايات المتحدة'),
(88727, 3494044672, 3494045695, 'CA', 'CAN', 'كندا'),
(88728, 3494045696, 3494049791, 'US', 'USA', 'الولايات المتحدة'),
(88729, 3494049792, 3494051839, 'CA', 'CAN', 'كندا'),
(88730, 3494053888, 3494055935, 'US', 'USA', 'الولايات المتحدة'),
(88731, 3494057984, 3494064127, 'US', 'USA', 'الولايات المتحدة'),
(88732, 3494066176, 3494067199, 'US', 'USA', 'الولايات المتحدة'),
(88733, 3494068224, 3494072319, 'US', 'USA', 'الولايات المتحدة'),
(88734, 3494074368, 3494075391, 'US', 'USA', 'الولايات المتحدة'),
(88735, 3494075392, 3494076415, 'CA', 'CAN', 'كندا'),
(88736, 3494076416, 3494088703, 'US', 'USA', 'الولايات المتحدة'),
(88737, 3494088704, 3494090751, 'CA', 'CAN', 'كندا'),
(88738, 3494090752, 3494094847, 'US', 'USA', 'الولايات المتحدة'),
(88739, 3494094848, 3494095871, 'CA', 'CAN', 'كندا'),
(88740, 3494095872, 3494113279, 'US', 'USA', 'الولايات المتحدة'),
(88741, 3494115328, 3494121471, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(88742, 3494121472, 3494122495, 'CA', 'CAN', 'كندا'),
(88743, 3494122496, 3494134783, 'US', 'USA', 'الولايات المتحدة'),
(88744, 3494135808, 3494136831, 'CA', 'CAN', 'كندا'),
(88745, 3494136832, 3494139903, 'US', 'USA', 'الولايات المتحدة'),
(88746, 3494139904, 3494141735, 'CA', 'CAN', 'كندا'),
(88747, 3494141736, 3494141743, 'US', 'USA', 'الولايات المتحدة'),
(88748, 3494141744, 3494141951, 'CA', 'CAN', 'كندا'),
(88749, 3494141952, 3494143999, 'US', 'USA', 'الولايات المتحدة'),
(88750, 3494144000, 3494145023, 'CA', 'CAN', 'كندا'),
(88751, 3494145024, 3494168575, 'US', 'USA', 'الولايات المتحدة'),
(88752, 3494168576, 3494170623, 'CA', 'CAN', 'كندا'),
(88753, 3494170624, 3494184959, 'US', 'USA', 'الولايات المتحدة'),
(88754, 3494184960, 3494187007, 'CA', 'CAN', 'كندا'),
(88755, 3494187008, 3494197247, 'US', 'USA', 'الولايات المتحدة'),
(88756, 3494197248, 3494198271, 'CA', 'CAN', 'كندا'),
(88757, 3494198272, 3494244351, 'US', 'USA', 'الولايات المتحدة'),
(88758, 3494244352, 3494246399, 'CA', 'CAN', 'كندا'),
(88759, 3494246400, 3494247423, 'US', 'USA', 'الولايات المتحدة'),
(88760, 3494247424, 3494250495, 'CA', 'CAN', 'كندا'),
(88761, 3494250496, 3494262783, 'US', 'USA', 'الولايات المتحدة'),
(88762, 3494262784, 3494264831, 'CA', 'CAN', 'كندا'),
(88763, 3494264832, 3494271999, 'US', 'USA', 'الولايات المتحدة'),
(88764, 3494272000, 3494273023, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(88765, 3494273024, 3494275071, 'US', 'USA', 'الولايات المتحدة'),
(88766, 3494275072, 3494277119, 'CA', 'CAN', 'كندا'),
(88767, 3494277120, 3494290943, 'US', 'USA', 'الولايات المتحدة'),
(88768, 3494290944, 3494291455, 'GB', 'GBR', 'المملكة المتحدة'),
(88769, 3494291456, 3494294527, 'US', 'USA', 'الولايات المتحدة'),
(88770, 3494295040, 3494302719, 'US', 'USA', 'الولايات المتحدة'),
(88771, 3494302720, 3494303743, 'CA', 'CAN', 'كندا'),
(88772, 3494303744, 3494310911, 'US', 'USA', 'الولايات المتحدة'),
(88773, 3494310912, 3494311935, 'CA', 'CAN', 'كندا'),
(88774, 3494311936, 3494316031, 'US', 'USA', 'الولايات المتحدة'),
(88775, 3494316032, 3494317055, 'CA', 'CAN', 'كندا'),
(88776, 3494317056, 3494336511, 'US', 'USA', 'الولايات المتحدة'),
(88777, 3494336512, 3494337535, 'CA', 'CAN', 'كندا'),
(88778, 3494337536, 3494342655, 'US', 'USA', 'الولايات المتحدة'),
(88779, 3494342656, 3494344703, 'CA', 'CAN', 'كندا'),
(88780, 3494344704, 3494355967, 'US', 'USA', 'الولايات المتحدة'),
(88781, 3494356992, 3494359039, 'US', 'USA', 'الولايات المتحدة'),
(88782, 3494359040, 3494360063, 'CA', 'CAN', 'كندا'),
(88783, 3494360064, 3494361087, 'US', 'USA', 'الولايات المتحدة'),
(88784, 3494361088, 3494362111, 'CA', 'CAN', 'كندا'),
(88785, 3494362112, 3494380543, 'US', 'USA', 'الولايات المتحدة'),
(88786, 3494380544, 3494381567, 'CA', 'CAN', 'كندا'),
(88787, 3494381568, 3494409215, 'US', 'USA', 'الولايات المتحدة'),
(88788, 3494410240, 3494412287, 'CA', 'CAN', 'كندا'),
(88789, 3494412288, 3494422527, 'US', 'USA', 'الولايات المتحدة'),
(88790, 3494424576, 3494425599, 'CA', 'CAN', 'كندا'),
(88791, 3494425600, 3494432767, 'US', 'USA', 'الولايات المتحدة'),
(88792, 3494432768, 3494433791, 'CA', 'CAN', 'كندا'),
(88793, 3494433792, 3494437887, 'US', 'USA', 'الولايات المتحدة'),
(88794, 3494437888, 3494438143, 'GP', 'GLP', 'جوادلوب'),
(88795, 3494438144, 3494438399, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(88796, 3494438400, 3494438911, 'GP', 'GLP', 'جوادلوب'),
(88797, 3494439936, 3494446079, 'US', 'USA', 'الولايات المتحدة'),
(88798, 3494447104, 3494449151, 'US', 'USA', 'الولايات المتحدة'),
(88799, 3494449152, 3494451199, 'CA', 'CAN', 'كندا'),
(88800, 3494451200, 3494454128, 'US', 'USA', 'الولايات المتحدة'),
(88801, 3494454129, 3494454158, 'PH', 'PHL', 'الفلبين'),
(88802, 3494454159, 3494455295, 'US', 'USA', 'الولايات المتحدة'),
(88803, 3494455296, 3494456319, 'CA', 'CAN', 'كندا'),
(88804, 3494456320, 3494459391, 'US', 'USA', 'الولايات المتحدة'),
(88805, 3494459392, 3494460415, 'CA', 'CAN', 'كندا'),
(88806, 3494460416, 3494464511, 'US', 'USA', 'الولايات المتحدة'),
(88807, 3494464512, 3494465535, 'CA', 'CAN', 'كندا'),
(88808, 3494465536, 3494467583, 'US', 'USA', 'الولايات المتحدة'),
(88809, 3494469632, 3494510591, 'US', 'USA', 'الولايات المتحدة'),
(88810, 3494510592, 3494512639, 'CA', 'CAN', 'كندا'),
(88811, 3494512640, 3494516735, 'US', 'USA', 'الولايات المتحدة'),
(88812, 3494516736, 3494517759, 'CA', 'CAN', 'كندا'),
(88813, 3494517760, 3494545407, 'US', 'USA', 'الولايات المتحدة'),
(88814, 3494546432, 3494563839, 'US', 'USA', 'الولايات المتحدة'),
(88815, 3494563840, 3494565887, 'CA', 'CAN', 'كندا'),
(88816, 3494565888, 3494576127, 'US', 'USA', 'الولايات المتحدة'),
(88817, 3494577152, 3494582271, 'US', 'USA', 'الولايات المتحدة'),
(88818, 3494584320, 3494594559, 'US', 'USA', 'الولايات المتحدة'),
(88819, 3494594560, 3494595583, 'CA', 'CAN', 'كندا'),
(88820, 3494595584, 3494605823, 'US', 'USA', 'الولايات المتحدة'),
(88821, 3494605824, 3494606847, 'CA', 'CAN', 'كندا'),
(88822, 3494606848, 3494610943, 'US', 'USA', 'الولايات المتحدة'),
(88823, 3494610944, 3494611967, 'CA', 'CAN', 'كندا'),
(88824, 3494611968, 3494624255, 'US', 'USA', 'الولايات المتحدة'),
(88825, 3494624256, 3494625279, 'CA', 'CAN', 'كندا'),
(88826, 3494625280, 3494627327, 'US', 'USA', 'الولايات المتحدة'),
(88827, 3494627328, 3494628351, 'BM', 'BMU', 'برمودا'),
(88828, 3494628352, 3494648831, 'US', 'USA', 'الولايات المتحدة'),
(88829, 3494649856, 3494651903, 'US', 'USA', 'الولايات المتحدة'),
(88830, 3494651904, 3494652927, 'CA', 'CAN', 'كندا'),
(88831, 3494652928, 3494653951, 'US', 'USA', 'الولايات المتحدة'),
(88832, 3494656000, 3494660095, 'US', 'USA', 'الولايات المتحدة'),
(88833, 3494660096, 3494661119, 'CA', 'CAN', 'كندا'),
(88834, 3494661120, 3494668287, 'US', 'USA', 'الولايات المتحدة'),
(88835, 3494668288, 3494669375, 'CA', 'CAN', 'كندا'),
(88836, 3494669376, 3494669439, 'US', 'USA', 'الولايات المتحدة'),
(88837, 3494669440, 3494670335, 'CA', 'CAN', 'كندا'),
(88838, 3494670336, 3494682623, 'US', 'USA', 'الولايات المتحدة'),
(88839, 3494684672, 3494700031, 'US', 'USA', 'الولايات المتحدة'),
(88840, 3494700032, 3494701055, 'CA', 'CAN', 'كندا'),
(88841, 3494701056, 3494727679, 'US', 'USA', 'الولايات المتحدة'),
(88842, 3494727680, 3494729727, 'CA', 'CAN', 'كندا'),
(88843, 3494729728, 3494730751, 'US', 'USA', 'الولايات المتحدة'),
(88844, 3494730752, 3494731775, 'CA', 'CAN', 'كندا'),
(88845, 3494731776, 3494743039, 'US', 'USA', 'الولايات المتحدة'),
(88846, 3494743040, 3494744063, 'CA', 'CAN', 'كندا'),
(88847, 3494744064, 3494747135, 'US', 'USA', 'الولايات المتحدة'),
(88848, 3494748160, 3494757375, 'US', 'USA', 'الولايات المتحدة'),
(88849, 3494757376, 3494758399, 'CA', 'CAN', 'كندا'),
(88850, 3494758400, 3494764543, 'US', 'USA', 'الولايات المتحدة'),
(88851, 3494766592, 3494776831, 'US', 'USA', 'الولايات المتحدة'),
(88852, 3494776832, 3494777855, 'CA', 'CAN', 'كندا'),
(88853, 3494777856, 3494785023, 'US', 'USA', 'الولايات المتحدة'),
(88854, 3494785024, 3494787071, 'MF', 'MAF', 'سانت مارتن'),
(88855, 3494787072, 3494789119, 'CA', 'CAN', 'كندا'),
(88856, 3494789120, 3494814719, 'US', 'USA', 'الولايات المتحدة'),
(88857, 3494815744, 3494820863, 'US', 'USA', 'الولايات المتحدة'),
(88858, 3494821888, 3494850559, 'US', 'USA', 'الولايات المتحدة'),
(88859, 3494851584, 3494852607, 'US', 'USA', 'الولايات المتحدة'),
(88860, 3494852608, 3494854655, 'CA', 'CAN', 'كندا'),
(88861, 3494854656, 3494862847, 'US', 'USA', 'الولايات المتحدة'),
(88862, 3494862848, 3494863615, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(88863, 3494863616, 3494863871, 'GP', 'GLP', 'جوادلوب'),
(88864, 3494863872, 3494866943, 'US', 'USA', 'الولايات المتحدة'),
(88865, 3494866944, 3494867967, 'CA', 'CAN', 'كندا'),
(88866, 3494867968, 3494893567, 'US', 'USA', 'الولايات المتحدة'),
(88867, 3494893568, 3494894591, 'CA', 'CAN', 'كندا'),
(88868, 3494894592, 3494895615, 'US', 'USA', 'الولايات المتحدة'),
(88869, 3494896640, 3494904831, 'US', 'USA', 'الولايات المتحدة'),
(88870, 3494905856, 3494917119, 'US', 'USA', 'الولايات المتحدة'),
(88871, 3494917120, 3494918143, 'CA', 'CAN', 'كندا'),
(88872, 3494918144, 3494928383, 'US', 'USA', 'الولايات المتحدة'),
(88873, 3494928384, 3494930431, 'CA', 'CAN', 'كندا'),
(88874, 3494930432, 3494938623, 'US', 'USA', 'الولايات المتحدة'),
(88875, 3494938624, 3494939647, 'CA', 'CAN', 'كندا'),
(88876, 3494939648, 3494946815, 'US', 'USA', 'الولايات المتحدة'),
(88877, 3494948864, 3494964223, 'US', 'USA', 'الولايات المتحدة'),
(88878, 3494964224, 3494965247, 'PR', 'PRI', 'بورتو ريكو'),
(88879, 3494965248, 3494968319, 'US', 'USA', 'الولايات المتحدة'),
(88880, 3494968320, 3494972415, 'CA', 'CAN', 'كندا'),
(88881, 3494972416, 3494978559, 'US', 'USA', 'الولايات المتحدة'),
(88882, 3494979584, 3494981631, 'CA', 'CAN', 'كندا'),
(88883, 3494981632, 3495000063, 'US', 'USA', 'الولايات المتحدة'),
(88884, 3495000064, 3495001087, 'CA', 'CAN', 'كندا'),
(88885, 3495001088, 3495006207, 'US', 'USA', 'الولايات المتحدة'),
(88886, 3495006208, 3495007231, 'CA', 'CAN', 'كندا'),
(88887, 3495007232, 3495010303, 'US', 'USA', 'الولايات المتحدة'),
(88888, 3495010304, 3495011327, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(88889, 3495012352, 3495014399, 'PR', 'PRI', 'بورتو ريكو'),
(88890, 3495014400, 3495023615, 'US', 'USA', 'الولايات المتحدة'),
(88891, 3495023616, 3495024639, 'CA', 'CAN', 'كندا'),
(88892, 3495024640, 3495057407, 'US', 'USA', 'الولايات المتحدة'),
(88893, 3495059456, 3495065599, 'US', 'USA', 'الولايات المتحدة'),
(88894, 3495065600, 3495066623, 'CA', 'CAN', 'كندا'),
(88895, 3495066624, 3495068223, 'US', 'USA', 'الولايات المتحدة'),
(88896, 3495068224, 3495068239, 'PL', 'POL', 'بولندا'),
(88897, 3495068240, 3495068655, 'US', 'USA', 'الولايات المتحدة'),
(88898, 3495068656, 3495068671, 'PL', 'POL', 'بولندا'),
(88899, 3495068672, 3495076863, 'US', 'USA', 'الولايات المتحدة'),
(88900, 3495076864, 3495077887, 'BM', 'BMU', 'برمودا'),
(88901, 3495077888, 3495090175, 'US', 'USA', 'الولايات المتحدة'),
(88902, 3495090176, 3495091199, 'KY', 'CYM', 'جزر كايمان'),
(88903, 3495091200, 3495098367, 'US', 'USA', 'الولايات المتحدة'),
(88904, 3495098368, 3495100415, 'CA', 'CAN', 'كندا'),
(88905, 3495100416, 3495104511, 'US', 'USA', 'الولايات المتحدة'),
(88906, 3495105536, 3495120895, 'US', 'USA', 'الولايات المتحدة'),
(88907, 3495120896, 3495122943, 'AG', 'ATG', 'انتيغوا وبربودا'),
(88908, 3495122944, 3495147519, 'US', 'USA', 'الولايات المتحدة'),
(88909, 3495149568, 3495153663, 'US', 'USA', 'الولايات المتحدة'),
(88910, 3495153664, 3495155711, 'CA', 'CAN', 'كندا'),
(88911, 3495155712, 3495190527, 'US', 'USA', 'الولايات المتحدة'),
(88912, 3495192576, 3495193599, 'CA', 'CAN', 'كندا'),
(88913, 3495193600, 3495199743, 'US', 'USA', 'الولايات المتحدة'),
(88914, 3495200768, 3495215103, 'US', 'USA', 'الولايات المتحدة'),
(88915, 3495215104, 3495217151, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(88916, 3495217152, 3495219199, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(88917, 3495219200, 3495251967, 'US', 'USA', 'الولايات المتحدة'),
(88918, 3495251968, 3495254015, 'CA', 'CAN', 'كندا'),
(88919, 3495254016, 3495260159, 'US', 'USA', 'الولايات المتحدة'),
(88920, 3495260160, 3495261183, 'CA', 'CAN', 'كندا'),
(88921, 3495261184, 3495276287, 'US', 'USA', 'الولايات المتحدة'),
(88922, 3495276288, 3495276351, 'IN', 'IND', 'الهند'),
(88923, 3495276352, 3495276543, 'US', 'USA', 'الولايات المتحدة'),
(88924, 3495278592, 3495286783, 'US', 'USA', 'الولايات المتحدة'),
(88925, 3495286784, 3495288831, 'CA', 'CAN', 'كندا'),
(88926, 3495288832, 3495332863, 'US', 'USA', 'الولايات المتحدة'),
(88927, 3495332864, 3495333887, 'CA', 'CAN', 'كندا'),
(88928, 3495333888, 3495349247, 'US', 'USA', 'الولايات المتحدة'),
(88929, 3495349248, 3495350271, 'CA', 'CAN', 'كندا'),
(88930, 3495350272, 3495358463, 'US', 'USA', 'الولايات المتحدة'),
(88931, 3495358464, 3495359487, 'CA', 'CAN', 'كندا'),
(88932, 3495359488, 3495367679, 'US', 'USA', 'الولايات المتحدة'),
(88933, 3495367680, 3495368703, 'CA', 'CAN', 'كندا'),
(88934, 3495368704, 3495370751, 'US', 'USA', 'الولايات المتحدة'),
(88935, 3495370752, 3495372799, 'BS', 'BHS', 'جزر البهاما'),
(88936, 3495372800, 3495375871, 'US', 'USA', 'الولايات المتحدة'),
(88937, 3495375872, 3495376895, 'CA', 'CAN', 'كندا'),
(88938, 3495376896, 3495399423, 'US', 'USA', 'الولايات المتحدة'),
(88939, 3495399424, 3495400447, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(88940, 3495400448, 3495401471, 'US', 'USA', 'الولايات المتحدة'),
(88941, 3495403520, 3495411711, 'US', 'USA', 'الولايات المتحدة'),
(88942, 3495412736, 3495413759, 'CA', 'CAN', 'كندا'),
(88943, 3495413760, 3495424033, 'US', 'USA', 'الولايات المتحدة'),
(88944, 3495424034, 3495424042, 'IN', 'IND', 'الهند'),
(88945, 3495424043, 3495424286, 'US', 'USA', 'الولايات المتحدة'),
(88946, 3495424287, 3495424308, 'IN', 'IND', 'الهند'),
(88947, 3495424309, 3495424321, 'US', 'USA', 'الولايات المتحدة'),
(88948, 3495424322, 3495424346, 'IN', 'IND', 'الهند'),
(88949, 3495424347, 3495424355, 'US', 'USA', 'الولايات المتحدة'),
(88950, 3495424356, 3495424381, 'IN', 'IND', 'الهند'),
(88951, 3495424382, 3495424629, 'US', 'USA', 'الولايات المتحدة'),
(88952, 3495424630, 3495424637, 'IN', 'IND', 'الهند'),
(88953, 3495424638, 3495424789, 'US', 'USA', 'الولايات المتحدة'),
(88954, 3495424790, 3495424797, 'IN', 'IND', 'الهند'),
(88955, 3495424798, 3495424865, 'US', 'USA', 'الولايات المتحدة'),
(88956, 3495424866, 3495424878, 'IN', 'IND', 'الهند'),
(88957, 3495424879, 3495424913, 'US', 'USA', 'الولايات المتحدة'),
(88958, 3495424914, 3495424919, 'IN', 'IND', 'الهند'),
(88959, 3495424920, 3495429119, 'US', 'USA', 'الولايات المتحدة'),
(88960, 3495429120, 3495430143, 'CA', 'CAN', 'كندا'),
(88961, 3495430144, 3495440799, 'US', 'USA', 'الولايات المتحدة'),
(88962, 3495440800, 3495440815, 'PL', 'POL', 'بولندا'),
(88963, 3495440816, 3495440895, 'US', 'USA', 'الولايات المتحدة'),
(88964, 3495440896, 3495440911, 'PL', 'POL', 'بولندا'),
(88965, 3495440912, 3495441151, 'US', 'USA', 'الولايات المتحدة'),
(88966, 3495441152, 3495441167, 'PL', 'POL', 'بولندا'),
(88967, 3495441168, 3495441407, 'US', 'USA', 'الولايات المتحدة'),
(88968, 3495441408, 3495441423, 'PL', 'POL', 'بولندا'),
(88969, 3495441424, 3495441663, 'US', 'USA', 'الولايات المتحدة'),
(88970, 3495441664, 3495441679, 'PL', 'POL', 'بولندا'),
(88971, 3495441680, 3495441919, 'US', 'USA', 'الولايات المتحدة'),
(88972, 3495441920, 3495441935, 'PL', 'POL', 'بولندا'),
(88973, 3495441936, 3495454719, 'US', 'USA', 'الولايات المتحدة'),
(88974, 3495455744, 3495456767, 'CA', 'CAN', 'كندا'),
(88975, 3495456768, 3495463935, 'US', 'USA', 'الولايات المتحدة'),
(88976, 3495463936, 3495464959, 'CA', 'CAN', 'كندا'),
(88977, 3495464960, 3495475199, 'US', 'USA', 'الولايات المتحدة'),
(88978, 3495475200, 3495477247, 'CA', 'CAN', 'كندا'),
(88979, 3495477248, 3495478271, 'US', 'USA', 'الولايات المتحدة'),
(88980, 3495478272, 3495479295, 'CA', 'CAN', 'كندا'),
(88981, 3495479296, 3495505919, 'US', 'USA', 'الولايات المتحدة'),
(88982, 3495505920, 3495507967, 'CA', 'CAN', 'كندا'),
(88983, 3495507968, 3495515135, 'US', 'USA', 'الولايات المتحدة'),
(88984, 3495515136, 3495516159, 'CA', 'CAN', 'كندا'),
(88985, 3495516160, 3495520375, 'US', 'USA', 'الولايات المتحدة'),
(88986, 3495520376, 3495520379, 'SG', 'SGP', 'سنغافورة'),
(88987, 3495520380, 3495526399, 'US', 'USA', 'الولايات المتحدة'),
(88988, 3495526400, 3495527423, 'CA', 'CAN', 'كندا'),
(88989, 3495527424, 3495549238, 'US', 'USA', 'الولايات المتحدة'),
(88990, 3495549239, 3495549302, 'CA', 'CAN', 'كندا'),
(88991, 3495549303, 3495549366, 'US', 'USA', 'الولايات المتحدة'),
(88992, 3495549367, 3495549430, 'CA', 'CAN', 'كندا'),
(88993, 3495549431, 3495549917, 'US', 'USA', 'الولايات المتحدة'),
(88994, 3495549918, 3495549923, 'CA', 'CAN', 'كندا'),
(88995, 3495549924, 3495551999, 'US', 'USA', 'الولايات المتحدة'),
(88996, 3495552000, 3495553023, 'BM', 'BMU', 'برمودا'),
(88997, 3495553024, 3495579647, 'US', 'USA', 'الولايات المتحدة'),
(88998, 3495579648, 3495581695, 'CA', 'CAN', 'كندا'),
(88999, 3495581696, 3495583743, 'US', 'USA', 'الولايات المتحدة'),
(89000, 3495583744, 3495585791, 'CA', 'CAN', 'كندا'),
(89001, 3495585792, 3495587839, 'US', 'USA', 'الولايات المتحدة'),
(89002, 3495587840, 3495588863, 'MS', 'MSR', 'مونتسيرات'),
(89003, 3495588864, 3495618559, 'US', 'USA', 'الولايات المتحدة'),
(89004, 3495618560, 3495619583, 'CA', 'CAN', 'كندا'),
(89005, 3495619584, 3495620607, 'US', 'USA', 'الولايات المتحدة'),
(89006, 3495620608, 3495622655, 'CA', 'CAN', 'كندا'),
(89007, 3495622656, 3495632895, 'US', 'USA', 'الولايات المتحدة'),
(89008, 3495633920, 3495647231, 'US', 'USA', 'الولايات المتحدة'),
(89009, 3495648000, 3495648255, 'US', 'USA', 'الولايات المتحدة'),
(89010, 3495649280, 3495653375, 'US', 'USA', 'الولايات المتحدة'),
(89011, 3495653376, 3495654399, 'CA', 'CAN', 'كندا'),
(89012, 3495655424, 3495673855, 'US', 'USA', 'الولايات المتحدة'),
(89013, 3495673856, 3495674879, 'MF', 'MAF', 'سانت مارتن'),
(89014, 3495674880, 3495686143, 'US', 'USA', 'الولايات المتحدة'),
(89015, 3495687168, 3495688191, 'US', 'USA', 'الولايات المتحدة'),
(89016, 3495688192, 3495689215, 'CA', 'CAN', 'كندا'),
(89017, 3495689216, 3495694335, 'US', 'USA', 'الولايات المتحدة'),
(89018, 3495694336, 3495696383, 'CA', 'CAN', 'كندا'),
(89019, 3495698432, 3495703551, 'US', 'USA', 'الولايات المتحدة'),
(89020, 3495703552, 3495704575, 'CA', 'CAN', 'كندا'),
(89021, 3495704576, 3495718911, 'US', 'USA', 'الولايات المتحدة'),
(89022, 3495718912, 3495720959, 'CA', 'CAN', 'كندا'),
(89023, 3495720960, 3495724031, 'US', 'USA', 'الولايات المتحدة'),
(89024, 3495724032, 3495727103, 'CA', 'CAN', 'كندا'),
(89025, 3495727104, 3495740415, 'US', 'USA', 'الولايات المتحدة'),
(89026, 3495740416, 3495741439, 'CA', 'CAN', 'كندا'),
(89027, 3495741440, 3495749631, 'US', 'USA', 'الولايات المتحدة'),
(89028, 3495749632, 3495750655, 'CA', 'CAN', 'كندا'),
(89029, 3495750656, 3495794687, 'US', 'USA', 'الولايات المتحدة'),
(89030, 3495795712, 3495814143, 'US', 'USA', 'الولايات المتحدة'),
(89031, 3495815168, 3495817215, 'CA', 'CAN', 'كندا'),
(89032, 3495817216, 3495828479, 'US', 'USA', 'الولايات المتحدة'),
(89033, 3495828480, 3495829503, 'CA', 'CAN', 'كندا'),
(89034, 3495831552, 3495847935, 'US', 'USA', 'الولايات المتحدة'),
(89035, 3495847936, 3495849983, 'CA', 'CAN', 'كندا'),
(89036, 3495849984, 3495862271, 'US', 'USA', 'الولايات المتحدة'),
(89037, 3495862272, 3495864319, 'CA', 'CAN', 'كندا'),
(89038, 3495864320, 3495865343, 'GP', 'GLP', 'جوادلوب'),
(89039, 3495865344, 3495865599, 'CA', 'CAN', 'كندا'),
(89040, 3495865600, 3495865631, 'BD', 'BGD', 'بنغالاديش'),
(89041, 3495865632, 3495866207, 'CA', 'CAN', 'كندا'),
(89042, 3495866208, 3495866239, 'BD', 'BGD', 'بنغالاديش'),
(89043, 3495866240, 3495866359, 'CA', 'CAN', 'كندا'),
(89044, 3495866360, 3495866363, 'US', 'USA', 'الولايات المتحدة'),
(89045, 3495866364, 3495866367, 'CA', 'CAN', 'كندا'),
(89046, 3495866368, 3495868415, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(89047, 3495868416, 3495871487, 'US', 'USA', 'الولايات المتحدة'),
(89048, 3495871488, 3495872511, 'CA', 'CAN', 'كندا'),
(89049, 3495872512, 3495896063, 'US', 'USA', 'الولايات المتحدة'),
(89050, 3495896064, 3495897087, 'PR', 'PRI', 'بورتو ريكو'),
(89051, 3495897088, 3495930879, 'US', 'USA', 'الولايات المتحدة'),
(89052, 3495930880, 3495931903, 'CA', 'CAN', 'كندا'),
(89053, 3495931904, 3495934975, 'US', 'USA', 'الولايات المتحدة'),
(89054, 3495936000, 3495968767, 'US', 'USA', 'الولايات المتحدة'),
(89055, 3495968768, 3495985151, 'CA', 'CAN', 'كندا'),
(89056, 3495985152, 3495988223, 'NI', 'NIC', 'نيكاراغوا'),
(89057, 3495988224, 3495989247, 'GT', 'GTM', 'غواتيمالا'),
(89058, 3495989248, 3496034303, 'US', 'USA', 'الولايات المتحدة'),
(89059, 3496034304, 3496050687, 'CA', 'CAN', 'كندا'),
(89060, 3496050688, 3496132607, 'US', 'USA', 'الولايات المتحدة'),
(89061, 3496132608, 3496145951, 'CA', 'CAN', 'كندا'),
(89062, 3496145952, 3496145983, 'US', 'USA', 'الولايات المتحدة'),
(89063, 3496145984, 3496148991, 'CA', 'CAN', 'كندا'),
(89064, 3496148992, 3496181759, 'US', 'USA', 'الولايات المتحدة'),
(89065, 3496181760, 3496189951, 'CA', 'CAN', 'كندا'),
(89066, 3496189952, 3496292319, 'US', 'USA', 'الولايات المتحدة'),
(89067, 3496292320, 3496292335, 'PH', 'PHL', 'الفلبين'),
(89068, 3496292336, 3496295839, 'US', 'USA', 'الولايات المتحدة'),
(89069, 3496295840, 3496295871, 'AR', 'ARG', 'الأرجنتين'),
(89070, 3496295872, 3496296447, 'US', 'USA', 'الولايات المتحدة'),
(89071, 3496296448, 3496312831, 'CA', 'CAN', 'كندا'),
(89072, 3496312832, 3496341503, 'US', 'USA', 'الولايات المتحدة'),
(89073, 3496345600, 3496468479, 'US', 'USA', 'الولايات المتحدة'),
(89074, 3496468480, 3496476671, 'CA', 'CAN', 'كندا'),
(89075, 3496476672, 3496878079, 'US', 'USA', 'الولايات المتحدة'),
(89076, 3496878080, 3496882175, 'CA', 'CAN', 'كندا'),
(89077, 3496882176, 3496893695, 'US', 'USA', 'الولايات المتحدة'),
(89078, 3496893696, 3496893703, 'RU', 'RUS', 'الإتحاد الروسي'),
(89079, 3496893704, 3496894463, 'US', 'USA', 'الولايات المتحدة'),
(89080, 3496894464, 3496902655, 'CA', 'CAN', 'كندا'),
(89081, 3496902656, 3496951807, 'US', 'USA', 'الولايات المتحدة'),
(89082, 3496951808, 3496959999, 'CA', 'CAN', 'كندا'),
(89083, 3496960000, 3497066495, 'US', 'USA', 'الولايات المتحدة'),
(89084, 3497066496, 3497082879, 'CA', 'CAN', 'كندا'),
(89085, 3497082880, 3497164799, 'US', 'USA', 'الولايات المتحدة'),
(89086, 3497164800, 3497181183, 'CA', 'CAN', 'كندا'),
(89087, 3497181184, 3497264127, 'US', 'USA', 'الولايات المتحدة'),
(89088, 3497264128, 3497264159, 'CA', 'CAN', 'كندا'),
(89089, 3497264160, 3497264913, 'US', 'USA', 'الولايات المتحدة'),
(89090, 3497264914, 3497264950, 'GB', 'GBR', 'المملكة المتحدة'),
(89091, 3497264951, 3497266527, 'US', 'USA', 'الولايات المتحدة'),
(89092, 3497266528, 3497266535, 'GB', 'GBR', 'المملكة المتحدة'),
(89093, 3497266536, 3497268223, 'US', 'USA', 'الولايات المتحدة'),
(89094, 3497268224, 3497268287, 'GB', 'GBR', 'المملكة المتحدة'),
(89095, 3497268288, 3497268703, 'US', 'USA', 'الولايات المتحدة'),
(89096, 3497268704, 3497268719, 'CA', 'CAN', 'كندا'),
(89097, 3497268720, 3497268815, 'US', 'USA', 'الولايات المتحدة'),
(89098, 3497268816, 3497268831, 'CA', 'CAN', 'كندا'),
(89099, 3497268832, 3497273919, 'US', 'USA', 'الولايات المتحدة'),
(89100, 3497273920, 3497273927, 'CA', 'CAN', 'كندا'),
(89101, 3497273928, 3497274175, 'US', 'USA', 'الولايات المتحدة'),
(89102, 3497274176, 3497274207, 'CA', 'CAN', 'كندا'),
(89103, 3497274208, 3497328639, 'US', 'USA', 'الولايات المتحدة'),
(89104, 3497353216, 3497410559, 'US', 'USA', 'الولايات المتحدة'),
(89105, 3497410560, 3497431039, 'CA', 'CAN', 'كندا'),
(89106, 3497431040, 3497447423, 'US', 'USA', 'الولايات المتحدة'),
(89107, 3497447424, 3497451519, 'CA', 'CAN', 'كندا'),
(89108, 3497451520, 3497717759, 'US', 'USA', 'الولايات المتحدة'),
(89109, 3497717760, 3497718783, 'CA', 'CAN', 'كندا'),
(89110, 3497718784, 3497719295, 'US', 'USA', 'الولايات المتحدة'),
(89111, 3497719296, 3497721855, 'CA', 'CAN', 'كندا'),
(89112, 3497721856, 3497739327, 'US', 'USA', 'الولايات المتحدة'),
(89113, 3497739328, 3497739351, 'IN', 'IND', 'الهند'),
(89114, 3497739352, 3497739679, 'US', 'USA', 'الولايات المتحدة'),
(89115, 3497739680, 3497739687, 'CA', 'CAN', 'كندا'),
(89116, 3497739688, 3497820159, 'US', 'USA', 'الولايات المتحدة'),
(89117, 3497820160, 3497852927, 'CA', 'CAN', 'كندا'),
(89118, 3497852928, 3498254591, 'US', 'USA', 'الولايات المتحدة'),
(89119, 3498254592, 3498254847, 'JM', 'JAM', 'جامايكا'),
(89120, 3498254848, 3498287103, 'US', 'USA', 'الولايات المتحدة'),
(89121, 3498287104, 3498292543, 'JM', 'JAM', 'جامايكا'),
(89122, 3498292544, 3498292551, 'US', 'USA', 'الولايات المتحدة'),
(89123, 3498292552, 3498295295, 'JM', 'JAM', 'جامايكا'),
(89124, 3498295296, 3498405887, 'US', 'USA', 'الولايات المتحدة'),
(89125, 3498405888, 3498409983, 'CA', 'CAN', 'كندا'),
(89126, 3498409984, 3498428415, 'US', 'USA', 'الولايات المتحدة'),
(89127, 3498428416, 3498429439, 'CR', 'CRI', 'كوستا ريكا'),
(89128, 3498429440, 3498429951, 'US', 'USA', 'الولايات المتحدة'),
(89129, 3498429952, 3498430207, 'CR', 'CRI', 'كوستا ريكا'),
(89130, 3498430208, 3498505343, 'US', 'USA', 'الولايات المتحدة'),
(89131, 3498505344, 3498505375, 'SG', 'SGP', 'سنغافورة'),
(89132, 3498505376, 3498509055, 'US', 'USA', 'الولايات المتحدة'),
(89133, 3498509056, 3498510335, 'PR', 'PRI', 'بورتو ريكو'),
(89134, 3498510336, 3498513151, 'US', 'USA', 'الولايات المتحدة'),
(89135, 3498513152, 3498513407, 'CL', 'CHL', 'تشيلي'),
(89136, 3498513408, 3498513919, 'US', 'USA', 'الولايات المتحدة'),
(89137, 3498513920, 3498514431, 'CL', 'CHL', 'تشيلي'),
(89138, 3498514432, 3498587135, 'US', 'USA', 'الولايات المتحدة'),
(89139, 3498587136, 3498588159, 'NL', 'NLD', 'هولندا'),
(89140, 3498588160, 3498708991, 'US', 'USA', 'الولايات المتحدة'),
(89141, 3498708992, 3498713639, 'JM', 'JAM', 'جامايكا'),
(89142, 3498713640, 3498713647, 'CA', 'CAN', 'كندا'),
(89143, 3498713648, 3498717183, 'JM', 'JAM', 'جامايكا'),
(89144, 3498717184, 3498760191, 'US', 'USA', 'الولايات المتحدة'),
(89145, 3498760192, 3498762239, 'PR', 'PRI', 'بورتو ريكو'),
(89146, 3498762240, 3499403263, 'US', 'USA', 'الولايات المتحدة'),
(89147, 3499403264, 3499403775, 'MW', 'MWI', 'ملاوي'),
(89148, 3499403776, 3499436031, 'US', 'USA', 'الولايات المتحدة'),
(89149, 3499436032, 3499436287, 'DE', 'DEU', 'ألمانيا'),
(89150, 3499436288, 3499437055, 'US', 'USA', 'الولايات المتحدة'),
(89151, 3499437056, 3499437151, 'DE', 'DEU', 'ألمانيا'),
(89152, 3499437152, 3499437423, 'US', 'USA', 'الولايات المتحدة'),
(89153, 3499437424, 3499437431, 'IT', 'ITA', 'إيطاليا'),
(89154, 3499437432, 3499450367, 'US', 'USA', 'الولايات المتحدة'),
(89155, 3499450368, 3499451391, 'IN', 'IND', 'الهند'),
(89156, 3499451392, 3499705343, 'US', 'USA', 'الولايات المتحدة'),
(89157, 3499705344, 3499705855, 'TZ', 'TZA', 'تانزانيا'),
(89158, 3499705856, 3499706367, 'MG', 'MDG', 'مدغشقر'),
(89159, 3499706368, 3499986943, 'US', 'USA', 'الولايات المتحدة'),
(89160, 3499986944, 3499988991, 'KY', 'CYM', 'جزر كايمان'),
(89161, 3499988992, 3500015615, 'US', 'USA', 'الولايات المتحدة'),
(89162, 3500015616, 3500016383, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89163, 3500016384, 3500016639, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89164, 3500016640, 3500019711, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89165, 3500019712, 3500076415, 'US', 'USA', 'الولايات المتحدة'),
(89166, 3500076416, 3500076543, 'SG', 'SGP', 'سنغافورة'),
(89167, 3500076544, 3500144639, 'US', 'USA', 'الولايات المتحدة'),
(89168, 3500144640, 3500144895, 'IT', 'ITA', 'إيطاليا'),
(89169, 3500144896, 3500274175, 'US', 'USA', 'الولايات المتحدة'),
(89170, 3500274176, 3500274239, 'IE', 'IRL', 'إيرلندا'),
(89171, 3500274240, 3500351487, 'US', 'USA', 'الولايات المتحدة'),
(89172, 3500351488, 3500359679, 'JM', 'JAM', 'جامايكا'),
(89173, 3500359680, 3500371583, 'US', 'USA', 'الولايات المتحدة'),
(89174, 3500371584, 3500371599, 'GB', 'GBR', 'المملكة المتحدة'),
(89175, 3500371600, 3500396831, 'US', 'USA', 'الولايات المتحدة'),
(89176, 3500396832, 3500396863, 'GB', 'GBR', 'المملكة المتحدة'),
(89177, 3500396864, 3500486655, 'US', 'USA', 'الولايات المتحدة'),
(89178, 3500486656, 3500490751, 'CR', 'CRI', 'كوستا ريكا'),
(89179, 3500490752, 3500689407, 'US', 'USA', 'الولايات المتحدة'),
(89180, 3500689408, 3500689919, 'CL', 'CHL', 'تشيلي'),
(89181, 3500689920, 3500724991, 'US', 'USA', 'الولايات المتحدة'),
(89182, 3500724992, 3500725503, 'EC', 'ECU', 'الإكوادور'),
(89183, 3500725504, 3500725759, 'US', 'USA', 'الولايات المتحدة'),
(89184, 3500725760, 3500726015, 'EC', 'ECU', 'الإكوادور'),
(89185, 3500726016, 3500728319, 'US', 'USA', 'الولايات المتحدة'),
(89186, 3500728320, 3500736511, 'KY', 'CYM', 'جزر كايمان'),
(89187, 3500736512, 3500752895, 'US', 'USA', 'الولايات المتحدة'),
(89188, 3500752896, 3500761087, 'KY', 'CYM', 'جزر كايمان'),
(89189, 3500761088, 3501181703, 'US', 'USA', 'الولايات المتحدة'),
(89190, 3501181704, 3501181711, 'AU', 'AUS', 'أستراليا'),
(89191, 3501181712, 3501181727, 'KR', 'KOR', 'جمهورية كوريا'),
(89192, 3501181728, 3501182975, 'US', 'USA', 'الولايات المتحدة'),
(89193, 3501182976, 3501183007, 'SG', 'SGP', 'سنغافورة'),
(89194, 3501183008, 3501183039, 'US', 'USA', 'الولايات المتحدة'),
(89195, 3501183040, 3501183047, 'SG', 'SGP', 'سنغافورة'),
(89196, 3501183048, 3501183167, 'US', 'USA', 'الولايات المتحدة'),
(89197, 3501183168, 3501183231, 'SG', 'SGP', 'سنغافورة'),
(89198, 3501183232, 3501183487, 'US', 'USA', 'الولايات المتحدة'),
(89199, 3501183488, 3501183743, 'GB', 'GBR', 'المملكة المتحدة'),
(89200, 3501183744, 3501183959, 'US', 'USA', 'الولايات المتحدة'),
(89201, 3501183960, 3501183967, 'IL', 'ISR', 'إسرائيل'),
(89202, 3501183968, 3501183999, 'SG', 'SGP', 'سنغافورة'),
(89203, 3501184000, 3501522943, 'US', 'USA', 'الولايات المتحدة'),
(89204, 3501522944, 3501588479, 'CA', 'CAN', 'كندا'),
(89205, 3501588480, 3502418175, 'US', 'USA', 'الولايات المتحدة'),
(89206, 3502418176, 3502418431, 'GU', 'GUM', 'غوام'),
(89207, 3502418432, 3502929663, 'US', 'USA', 'الولايات المتحدة'),
(89208, 3502929664, 3502929919, 'GU', 'GUM', 'غوام'),
(89209, 3502929920, 3502993407, 'US', 'USA', 'الولايات المتحدة'),
(89210, 3502993408, 3502993919, 'NL', 'NLD', 'هولندا'),
(89211, 3502993920, 3503215623, 'US', 'USA', 'الولايات المتحدة'),
(89212, 3503215624, 3503215639, 'NL', 'NLD', 'هولندا'),
(89213, 3503215640, 3503473151, 'US', 'USA', 'الولايات المتحدة'),
(89214, 3503473152, 3503473663, 'NA', 'NAM', 'ناميبيا'),
(89215, 3503473664, 3503757823, 'US', 'USA', 'الولايات المتحدة'),
(89216, 3503757824, 3503758335, 'GU', 'GUM', 'غوام'),
(89217, 3503758336, 3503890431, 'US', 'USA', 'الولايات المتحدة'),
(89218, 3503890432, 3503894527, 'CO', 'COL', 'كولومبيا'),
(89219, 3503894528, 3504193535, 'US', 'USA', 'الولايات المتحدة'),
(89220, 3504193536, 3504194559, 'EC', 'ECU', 'الإكوادور'),
(89221, 3504194560, 3504521215, 'US', 'USA', 'الولايات المتحدة'),
(89222, 3504521216, 3504521727, 'GU', 'GUM', 'غوام'),
(89223, 3504521728, 3505004543, 'US', 'USA', 'الولايات المتحدة'),
(89224, 3505004544, 3505012735, 'PR', 'PRI', 'بورتو ريكو'),
(89225, 3505012736, 3505661951, 'US', 'USA', 'الولايات المتحدة'),
(89226, 3505661952, 3505662463, 'JM', 'JAM', 'جامايكا'),
(89227, 3505662464, 3505818623, 'US', 'USA', 'الولايات المتحدة'),
(89228, 3505818624, 3505819647, 'BS', 'BHS', 'جزر البهاما'),
(89229, 3505819648, 3506043135, 'US', 'USA', 'الولايات المتحدة'),
(89230, 3506043136, 3506044927, 'PA', 'PAN', 'بنما'),
(89231, 3506044928, 3506765823, 'US', 'USA', 'الولايات المتحدة'),
(89232, 3506765824, 3506831359, 'CA', 'CAN', 'كندا'),
(89233, 3506831360, 3507290111, 'US', 'USA', 'الولايات المتحدة'),
(89234, 3507290112, 3507355647, 'AR', 'ARG', 'الأرجنتين'),
(89235, 3507355648, 3507540015, 'US', 'USA', 'الولايات المتحدة'),
(89236, 3507540016, 3507540031, 'IN', 'IND', 'الهند'),
(89237, 3507540032, 3507585023, 'US', 'USA', 'الولايات المتحدة'),
(89238, 3507585024, 3507601407, 'CA', 'CAN', 'كندا'),
(89239, 3507601408, 3507748863, 'US', 'USA', 'الولايات المتحدة'),
(89240, 3507748864, 3507765247, 'CA', 'CAN', 'كندا'),
(89241, 3507765248, 3508118527, 'US', 'USA', 'الولايات المتحدة'),
(89242, 3508118528, 3508118559, 'AU', 'AUS', 'أستراليا'),
(89243, 3508118560, 3508219903, 'US', 'USA', 'الولايات المتحدة'),
(89244, 3508220928, 3508221951, 'KY', 'CYM', 'جزر كايمان'),
(89245, 3508221952, 3508222975, 'US', 'USA', 'الولايات المتحدة'),
(89246, 3508222976, 3508223999, 'KY', 'CYM', 'جزر كايمان'),
(89247, 3508224000, 3508224255, 'BM', 'BMU', 'برمودا'),
(89248, 3508224256, 3508243967, 'US', 'USA', 'الولايات المتحدة'),
(89249, 3508243968, 3508244223, 'BM', 'BMU', 'برمودا'),
(89250, 3508244224, 3508338687, 'US', 'USA', 'الولايات المتحدة'),
(89251, 3508338688, 3508404223, 'CA', 'CAN', 'كندا'),
(89252, 3508404224, 3508690943, 'US', 'USA', 'الولايات المتحدة'),
(89253, 3508690944, 3508695039, 'CA', 'CAN', 'كندا'),
(89254, 3508695040, 3509157887, 'US', 'USA', 'الولايات المتحدة'),
(89255, 3509157888, 3509166079, 'CA', 'CAN', 'كندا'),
(89256, 3509166080, 3509215231, 'US', 'USA', 'الولايات المتحدة'),
(89257, 3509215232, 3509223423, 'CA', 'CAN', 'كندا'),
(89258, 3509223424, 3509326079, 'US', 'USA', 'الولايات المتحدة'),
(89259, 3509326080, 3509326087, 'CA', 'CAN', 'كندا'),
(89260, 3509326088, 3509327695, 'US', 'USA', 'الولايات المتحدة'),
(89261, 3509327696, 3509327711, 'CA', 'CAN', 'كندا'),
(89262, 3509327712, 3509327807, 'US', 'USA', 'الولايات المتحدة'),
(89263, 3509327808, 3509327871, 'CA', 'CAN', 'كندا'),
(89264, 3509327872, 3509346303, 'US', 'USA', 'الولايات المتحدة'),
(89265, 3509346304, 3509347103, 'CA', 'CAN', 'كندا'),
(89266, 3509347104, 3509347119, 'US', 'USA', 'الولايات المتحدة'),
(89267, 3509347120, 3509354495, 'CA', 'CAN', 'كندا'),
(89268, 3509354496, 3509387263, 'US', 'USA', 'الولايات المتحدة'),
(89269, 3509387264, 3509420031, 'PE', 'PER', 'بيرو'),
(89270, 3509420032, 3509519871, 'US', 'USA', 'الولايات المتحدة'),
(89271, 3509519872, 3509520255, 'CA', 'CAN', 'كندا'),
(89272, 3509520256, 3509521407, 'US', 'USA', 'الولايات المتحدة'),
(89273, 3509521408, 3509521663, 'CA', 'CAN', 'كندا'),
(89274, 3509521664, 3509522175, 'US', 'USA', 'الولايات المتحدة'),
(89275, 3509522176, 3509522431, 'CA', 'CAN', 'كندا'),
(89276, 3509522432, 3509522687, 'KW', 'KWT', 'الكويت'),
(89277, 3509522688, 3509522943, 'CA', 'CAN', 'كندا'),
(89278, 3509522944, 3509523839, 'US', 'USA', 'الولايات المتحدة'),
(89279, 3509523840, 3509523903, 'CA', 'CAN', 'كندا'),
(89280, 3509523904, 3509524223, 'US', 'USA', 'الولايات المتحدة'),
(89281, 3509524224, 3509524479, 'CA', 'CAN', 'كندا'),
(89282, 3509524480, 3509524991, 'US', 'USA', 'الولايات المتحدة'),
(89283, 3509524992, 3509525247, 'CA', 'CAN', 'كندا'),
(89284, 3509525248, 3509526015, 'US', 'USA', 'الولايات المتحدة'),
(89285, 3509526016, 3509526271, 'CA', 'CAN', 'كندا'),
(89286, 3509526272, 3509527215, 'US', 'USA', 'الولايات المتحدة'),
(89287, 3509527216, 3509527231, 'CA', 'CAN', 'كندا'),
(89288, 3509527232, 3509529855, 'US', 'USA', 'الولايات المتحدة'),
(89289, 3509529856, 3509529887, 'CA', 'CAN', 'كندا'),
(89290, 3509529888, 3509529951, 'US', 'USA', 'الولايات المتحدة'),
(89291, 3509529952, 3509530111, 'CA', 'CAN', 'كندا'),
(89292, 3509530112, 3509530367, 'US', 'USA', 'الولايات المتحدة'),
(89293, 3509530368, 3509530431, 'CA', 'CAN', 'كندا'),
(89294, 3509530432, 3509530623, 'US', 'USA', 'الولايات المتحدة'),
(89295, 3509530624, 3509532671, 'CA', 'CAN', 'كندا'),
(89296, 3509532672, 3509534719, 'US', 'USA', 'الولايات المتحدة'),
(89297, 3509534720, 3509535231, 'CA', 'CAN', 'كندا'),
(89298, 3509535232, 3509535487, 'US', 'USA', 'الولايات المتحدة'),
(89299, 3509535488, 3509535503, 'CA', 'CAN', 'كندا'),
(89300, 3509535504, 3509536255, 'US', 'USA', 'الولايات المتحدة'),
(89301, 3509536256, 3509536511, 'CA', 'CAN', 'كندا'),
(89302, 3509536512, 3509537279, 'US', 'USA', 'الولايات المتحدة'),
(89303, 3509537280, 3509538303, 'CA', 'CAN', 'كندا'),
(89304, 3509538304, 3509538463, 'US', 'USA', 'الولايات المتحدة'),
(89305, 3509538464, 3509538479, 'CA', 'CAN', 'كندا'),
(89306, 3509538480, 3509539071, 'US', 'USA', 'الولايات المتحدة'),
(89307, 3509539072, 3509539327, 'CA', 'CAN', 'كندا'),
(89308, 3509539328, 3509542783, 'US', 'USA', 'الولايات المتحدة'),
(89309, 3509542784, 3509542815, 'CA', 'CAN', 'كندا'),
(89310, 3509542816, 3509543359, 'US', 'USA', 'الولايات المتحدة'),
(89311, 3509543360, 3509543423, 'CA', 'CAN', 'كندا'),
(89312, 3509543424, 3509543999, 'US', 'USA', 'الولايات المتحدة'),
(89313, 3509544000, 3509544063, 'CA', 'CAN', 'كندا'),
(89314, 3509544064, 3509544191, 'US', 'USA', 'الولايات المتحدة'),
(89315, 3509544192, 3509544447, 'CA', 'CAN', 'كندا'),
(89316, 3509544448, 3509544703, 'US', 'USA', 'الولايات المتحدة'),
(89317, 3509544704, 3509544959, 'CA', 'CAN', 'كندا'),
(89318, 3509544960, 3509554175, 'US', 'USA', 'الولايات المتحدة'),
(89319, 3509554176, 3509554431, 'CA', 'CAN', 'كندا'),
(89320, 3509554432, 3509555455, 'US', 'USA', 'الولايات المتحدة'),
(89321, 3509555456, 3509555711, 'CA', 'CAN', 'كندا'),
(89322, 3509555712, 3509555967, 'US', 'USA', 'الولايات المتحدة'),
(89323, 3509555968, 3509556479, 'CA', 'CAN', 'كندا'),
(89324, 3509556480, 3509558015, 'US', 'USA', 'الولايات المتحدة'),
(89325, 3509558016, 3509558079, 'CA', 'CAN', 'كندا'),
(89326, 3509558080, 3509559039, 'US', 'USA', 'الولايات المتحدة'),
(89327, 3509559040, 3509559295, 'KW', 'KWT', 'الكويت'),
(89328, 3509559296, 3509559551, 'US', 'USA', 'الولايات المتحدة'),
(89329, 3509559552, 3509559807, 'CA', 'CAN', 'كندا'),
(89330, 3509559808, 3509559999, 'US', 'USA', 'الولايات المتحدة'),
(89331, 3509560000, 3509560015, 'CA', 'CAN', 'كندا'),
(89332, 3509560016, 3509560063, 'US', 'USA', 'الولايات المتحدة'),
(89333, 3509560064, 3509560319, 'CA', 'CAN', 'كندا'),
(89334, 3509560320, 3509560831, 'US', 'USA', 'الولايات المتحدة'),
(89335, 3509560832, 3509561087, 'CA', 'CAN', 'كندا'),
(89336, 3509561088, 3509561599, 'US', 'USA', 'الولايات المتحدة'),
(89337, 3509561600, 3509562111, 'CA', 'CAN', 'كندا'),
(89338, 3509562112, 3509562367, 'US', 'USA', 'الولايات المتحدة'),
(89339, 3509562368, 3509562623, 'CA', 'CAN', 'كندا'),
(89340, 3509562624, 3509563903, 'US', 'USA', 'الولايات المتحدة'),
(89341, 3509563904, 3509564223, 'CA', 'CAN', 'كندا'),
(89342, 3509564224, 3509564415, 'US', 'USA', 'الولايات المتحدة'),
(89343, 3509564416, 3509564927, 'CA', 'CAN', 'كندا'),
(89344, 3509564928, 3509565183, 'US', 'USA', 'الولايات المتحدة'),
(89345, 3509565184, 3509565951, 'CA', 'CAN', 'كندا'),
(89346, 3509565952, 3509566767, 'US', 'USA', 'الولايات المتحدة'),
(89347, 3509566768, 3509566783, 'CA', 'CAN', 'كندا'),
(89348, 3509566784, 3509567487, 'US', 'USA', 'الولايات المتحدة'),
(89349, 3509567488, 3509567743, 'CA', 'CAN', 'كندا'),
(89350, 3509567744, 3509568511, 'US', 'USA', 'الولايات المتحدة'),
(89351, 3509568512, 3509569023, 'CA', 'CAN', 'كندا'),
(89352, 3509569024, 3509570079, 'US', 'USA', 'الولايات المتحدة'),
(89353, 3509570080, 3509570111, 'CA', 'CAN', 'كندا'),
(89354, 3509570112, 3509571071, 'US', 'USA', 'الولايات المتحدة'),
(89355, 3509571072, 3509571327, 'CA', 'CAN', 'كندا'),
(89356, 3509571328, 3509572351, 'US', 'USA', 'الولايات المتحدة'),
(89357, 3509572352, 3509572863, 'CA', 'CAN', 'كندا'),
(89358, 3509572864, 3509574143, 'US', 'USA', 'الولايات المتحدة'),
(89359, 3509574144, 3509574655, 'CA', 'CAN', 'كندا'),
(89360, 3509574656, 3509575935, 'US', 'USA', 'الولايات المتحدة'),
(89361, 3509575936, 3509576191, 'CA', 'CAN', 'كندا'),
(89362, 3509576192, 3509580031, 'US', 'USA', 'الولايات المتحدة'),
(89363, 3509580032, 3509580287, 'CA', 'CAN', 'كندا'),
(89364, 3509580288, 3509580799, 'US', 'USA', 'الولايات المتحدة'),
(89365, 3509580800, 3509581055, 'CA', 'CAN', 'كندا'),
(89366, 3509581056, 3509581823, 'US', 'USA', 'الولايات المتحدة'),
(89367, 3509581824, 3509582335, 'CA', 'CAN', 'كندا'),
(89368, 3509582336, 3509582591, 'US', 'USA', 'الولايات المتحدة'),
(89369, 3509582592, 3509582847, 'CA', 'CAN', 'كندا'),
(89370, 3509582848, 3509583615, 'US', 'USA', 'الولايات المتحدة'),
(89371, 3509583616, 3509583871, 'CA', 'CAN', 'كندا'),
(89372, 3509583872, 3509731327, 'US', 'USA', 'الولايات المتحدة'),
(89373, 3509731328, 3509739519, 'CA', 'CAN', 'كندا'),
(89374, 3509739520, 3509846015, 'US', 'USA', 'الولايات المتحدة'),
(89375, 3509846016, 3509977087, 'CA', 'CAN', 'كندا'),
(89376, 3510042624, 3510239231, 'US', 'USA', 'الولايات المتحدة'),
(89377, 3510239232, 3510241063, 'CA', 'CAN', 'كندا'),
(89378, 3510241064, 3510241071, 'US', 'USA', 'الولايات المتحدة'),
(89379, 3510241072, 3510255439, 'CA', 'CAN', 'كندا'),
(89380, 3510255440, 3510255447, 'US', 'USA', 'الولايات المتحدة'),
(89381, 3510255448, 3510271999, 'CA', 'CAN', 'كندا'),
(89382, 3510272000, 3510321151, 'US', 'USA', 'الولايات المتحدة'),
(89383, 3510321152, 3510321663, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(89384, 3510321664, 3510321919, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89385, 3510321920, 3510322175, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89386, 3510322176, 3510323199, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89387, 3510323200, 3510324223, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89388, 3510324224, 3510324735, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89389, 3510324736, 3510324991, 'AI', 'AIA', 'أنغيلا'),
(89390, 3510324992, 3510326271, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89391, 3510326272, 3510327295, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(89392, 3510327296, 3510328319, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89393, 3510328320, 3510328575, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89394, 3510328576, 3510331391, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89395, 3510331392, 3510332415, 'DM', 'DMA', 'دومينيكا'),
(89396, 3510332416, 3510332927, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89397, 3510332928, 3510333183, 'LC', 'LCA', 'سانت لوسيا'),
(89398, 3510333184, 3510333439, 'MS', 'MSR', 'مونتسيرات'),
(89399, 3510333440, 3510333951, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89400, 3510333952, 3510334975, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89401, 3510334976, 3510335231, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(89402, 3510335232, 3510335487, 'AI', 'AIA', 'أنغيلا'),
(89403, 3510335488, 3510335743, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89404, 3510335744, 3510335999, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(89405, 3510336000, 3510337279, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89406, 3510337280, 3510337535, 'LC', 'LCA', 'سانت لوسيا'),
(89407, 3510337536, 3510362111, 'US', 'USA', 'الولايات المتحدة'),
(89408, 3510370304, 3510831527, 'US', 'USA', 'الولايات المتحدة'),
(89409, 3510831528, 3510831535, 'GB', 'GBR', 'المملكة المتحدة'),
(89410, 3510831536, 3510833423, 'US', 'USA', 'الولايات المتحدة'),
(89411, 3510833424, 3510833439, 'CA', 'CAN', 'كندا'),
(89412, 3510833440, 3510836671, 'US', 'USA', 'الولايات المتحدة'),
(89413, 3510836672, 3510836687, 'CA', 'CAN', 'كندا'),
(89414, 3510836688, 3510839135, 'US', 'USA', 'الولايات المتحدة'),
(89415, 3510839136, 3510839151, 'GB', 'GBR', 'المملكة المتحدة'),
(89416, 3510839152, 3510839215, 'US', 'USA', 'الولايات المتحدة'),
(89417, 3510839216, 3510839231, 'GB', 'GBR', 'المملكة المتحدة'),
(89418, 3510839232, 3510839311, 'US', 'USA', 'الولايات المتحدة'),
(89419, 3510839312, 3510839327, 'IN', 'IND', 'الهند'),
(89420, 3510839328, 3510843087, 'US', 'USA', 'الولايات المتحدة'),
(89421, 3510843088, 3510843095, 'CA', 'CAN', 'كندا'),
(89422, 3510843096, 3510843103, 'GB', 'GBR', 'المملكة المتحدة'),
(89423, 3510843104, 3510844415, 'US', 'USA', 'الولايات المتحدة'),
(89424, 3510844416, 3510844927, 'CA', 'CAN', 'كندا'),
(89425, 3510844928, 3510846527, 'US', 'USA', 'الولايات المتحدة'),
(89426, 3510846528, 3510846559, 'CA', 'CAN', 'كندا'),
(89427, 3510846560, 3510897442, 'US', 'USA', 'الولايات المتحدة'),
(89428, 3510897443, 3510897443, 'IE', 'IRL', 'إيرلندا'),
(89429, 3510897444, 3510935551, 'US', 'USA', 'الولايات المتحدة'),
(89430, 3510935552, 3510943743, 'CA', 'CAN', 'كندا'),
(89431, 3510943744, 3511140351, 'US', 'USA', 'الولايات المتحدة'),
(89432, 3511140352, 3511156735, 'CA', 'CAN', 'كندا'),
(89433, 3511156736, 3511314431, 'US', 'USA', 'الولايات المتحدة'),
(89434, 3511320576, 3511331199, 'US', 'USA', 'الولايات المتحدة'),
(89435, 3511331200, 3511331231, 'CA', 'CAN', 'كندا'),
(89436, 3511331232, 3511812095, 'US', 'USA', 'الولايات المتحدة'),
(89437, 3511812096, 3511844863, 'CA', 'CAN', 'كندا'),
(89438, 3511844864, 3512011311, 'US', 'USA', 'الولايات المتحدة'),
(89439, 3512011312, 3512011327, 'UM', 'UMI', 'جزر الولايات المتحدة البعيدة الصغيرة'),
(89440, 3512011328, 3512011359, 'US', 'USA', 'الولايات المتحدة'),
(89441, 3512011360, 3512011375, 'TR', 'TUR', 'تركيا'),
(89442, 3512011376, 3512011807, 'US', 'USA', 'الولايات المتحدة'),
(89443, 3512011808, 3512011823, 'TW', 'TWN', 'تايوان'),
(89444, 3512011824, 3512011855, 'US', 'USA', 'الولايات المتحدة'),
(89445, 3512011856, 3512011871, 'SE', 'SWE', 'السويد'),
(89446, 3512011872, 3512011903, 'IN', 'IND', 'الهند'),
(89447, 3512011904, 3512012095, 'US', 'USA', 'الولايات المتحدة'),
(89448, 3512012096, 3512012159, 'GB', 'GBR', 'المملكة المتحدة'),
(89449, 3512012160, 3512012175, 'MX', 'MEX', 'المكسيك'),
(89450, 3512012176, 3512012191, 'US', 'USA', 'الولايات المتحدة'),
(89451, 3512012192, 3512012223, 'BR', 'BRA', 'البرازيل'),
(89452, 3512012224, 3512012255, 'US', 'USA', 'الولايات المتحدة'),
(89453, 3512012256, 3512012287, 'GB', 'GBR', 'المملكة المتحدة'),
(89454, 3512012288, 3512013583, 'US', 'USA', 'الولايات المتحدة'),
(89455, 3512013584, 3512013599, 'CA', 'CAN', 'كندا'),
(89456, 3512013600, 3512013647, 'US', 'USA', 'الولايات المتحدة'),
(89457, 3512013648, 3512013663, 'CA', 'CAN', 'كندا'),
(89458, 3512013664, 3512013679, 'US', 'USA', 'الولايات المتحدة'),
(89459, 3512013680, 3512013695, 'GR', 'GRC', 'اليونان'),
(89460, 3512013696, 3512013791, 'US', 'USA', 'الولايات المتحدة'),
(89461, 3512013792, 3512013823, 'IN', 'IND', 'الهند'),
(89462, 3512013824, 3512016543, 'US', 'USA', 'الولايات المتحدة'),
(89463, 3512016544, 3512016559, 'IT', 'ITA', 'إيطاليا'),
(89464, 3512016560, 3512016575, 'US', 'USA', 'الولايات المتحدة'),
(89465, 3512016576, 3512016591, 'TW', 'TWN', 'تايوان'),
(89466, 3512016592, 3512016607, 'US', 'USA', 'الولايات المتحدة'),
(89467, 3512016608, 3512016623, 'CA', 'CAN', 'كندا'),
(89468, 3512016624, 3512016767, 'GB', 'GBR', 'المملكة المتحدة'),
(89469, 3512016768, 3512016831, 'US', 'USA', 'الولايات المتحدة'),
(89470, 3512016832, 3512016895, 'JO', 'JOR', 'الأردن'),
(89471, 3512016896, 3512017183, 'US', 'USA', 'الولايات المتحدة'),
(89472, 3512017184, 3512017199, 'AR', 'ARG', 'الأرجنتين'),
(89473, 3512017200, 3512017231, 'US', 'USA', 'الولايات المتحدة'),
(89474, 3512017232, 3512017247, 'ES', 'ESP', 'إسبانيا'),
(89475, 3512017248, 3512017263, 'MX', 'MEX', 'المكسيك'),
(89476, 3512017264, 3512017279, 'GB', 'GBR', 'المملكة المتحدة'),
(89477, 3512017280, 3512017359, 'US', 'USA', 'الولايات المتحدة'),
(89478, 3512017360, 3512017375, 'RU', 'RUS', 'الإتحاد الروسي'),
(89479, 3512017376, 3512017407, 'GB', 'GBR', 'المملكة المتحدة'),
(89480, 3512017408, 3512017663, 'BR', 'BRA', 'البرازيل'),
(89481, 3512017664, 3512017695, 'CA', 'CAN', 'كندا'),
(89482, 3512017696, 3512017727, 'RU', 'RUS', 'الإتحاد الروسي'),
(89483, 3512017728, 3512017743, 'US', 'USA', 'الولايات المتحدة'),
(89484, 3512017744, 3512017759, 'IT', 'ITA', 'إيطاليا'),
(89485, 3512017760, 3512017791, 'US', 'USA', 'الولايات المتحدة'),
(89486, 3512017792, 3512017807, 'LT', 'LTU', 'ليتوانيا'),
(89487, 3512017808, 3512017823, 'US', 'USA', 'الولايات المتحدة'),
(89488, 3512017824, 3512017855, 'JO', 'JOR', 'الأردن'),
(89489, 3512017856, 3512019071, 'US', 'USA', 'الولايات المتحدة'),
(89490, 3512019072, 3512019135, 'GB', 'GBR', 'المملكة المتحدة'),
(89491, 3512019136, 3512019151, 'MX', 'MEX', 'المكسيك'),
(89492, 3512019152, 3512019199, 'US', 'USA', 'الولايات المتحدة'),
(89493, 3512019200, 3512019263, 'ES', 'ESP', 'إسبانيا'),
(89494, 3512019264, 3512019295, 'US', 'USA', 'الولايات المتحدة'),
(89495, 3512019296, 3512019311, 'CA', 'CAN', 'كندا'),
(89496, 3512019312, 3512019327, 'US', 'USA', 'الولايات المتحدة'),
(89497, 3512019328, 3512019359, 'CA', 'CAN', 'كندا'),
(89498, 3512019360, 3512020095, 'US', 'USA', 'الولايات المتحدة'),
(89499, 3512020096, 3512020223, 'ES', 'ESP', 'إسبانيا'),
(89500, 3512020224, 3512020479, 'US', 'USA', 'الولايات المتحدة'),
(89501, 3512020480, 3512020511, 'GB', 'GBR', 'المملكة المتحدة'),
(89502, 3512020512, 3512020543, 'US', 'USA', 'الولايات المتحدة'),
(89503, 3512020544, 3512020607, 'CA', 'CAN', 'كندا'),
(89504, 3512020608, 3512021503, 'US', 'USA', 'الولايات المتحدة'),
(89505, 3512021504, 3512021759, 'GB', 'GBR', 'المملكة المتحدة'),
(89506, 3512021760, 3512022335, 'US', 'USA', 'الولايات المتحدة'),
(89507, 3512022336, 3512022399, 'ES', 'ESP', 'إسبانيا'),
(89508, 3512022400, 3512022431, 'US', 'USA', 'الولايات المتحدة'),
(89509, 3512022432, 3512022447, 'IN', 'IND', 'الهند'),
(89510, 3512022448, 3512022463, 'GB', 'GBR', 'المملكة المتحدة'),
(89511, 3512022464, 3512023807, 'US', 'USA', 'الولايات المتحدة'),
(89512, 3512023808, 3512023839, 'CA', 'CAN', 'كندا'),
(89513, 3512023840, 3512023855, 'GB', 'GBR', 'المملكة المتحدة'),
(89514, 3512023856, 3512023887, 'US', 'USA', 'الولايات المتحدة'),
(89515, 3512023888, 3512023903, 'MX', 'MEX', 'المكسيك'),
(89516, 3512023904, 3512023999, 'US', 'USA', 'الولايات المتحدة'),
(89517, 3512024000, 3512024063, 'BR', 'BRA', 'البرازيل'),
(89518, 3512024064, 3512024319, 'US', 'USA', 'الولايات المتحدة'),
(89519, 3512024320, 3512024575, 'AU', 'AUS', 'أستراليا'),
(89520, 3512024576, 3512024591, 'CA', 'CAN', 'كندا'),
(89521, 3512024592, 3512025087, 'US', 'USA', 'الولايات المتحدة'),
(89522, 3512025088, 3512025103, 'CA', 'CAN', 'كندا'),
(89523, 3512025104, 3512025183, 'US', 'USA', 'الولايات المتحدة'),
(89524, 3512025184, 3512025215, 'CA', 'CAN', 'كندا'),
(89525, 3512025216, 3512025343, 'US', 'USA', 'الولايات المتحدة'),
(89526, 3512025344, 3512025359, 'CA', 'CAN', 'كندا'),
(89527, 3512025360, 3512027391, 'US', 'USA', 'الولايات المتحدة'),
(89528, 3512027392, 3512027519, 'AU', 'AUS', 'أستراليا'),
(89529, 3512027520, 3512028271, 'US', 'USA', 'الولايات المتحدة'),
(89530, 3512028272, 3512028287, 'GB', 'GBR', 'المملكة المتحدة'),
(89531, 3512028288, 3512029119, 'US', 'USA', 'الولايات المتحدة'),
(89532, 3512029120, 3512029135, 'CA', 'CAN', 'كندا'),
(89533, 3512029136, 3512029263, 'US', 'USA', 'الولايات المتحدة'),
(89534, 3512029264, 3512029279, 'CA', 'CAN', 'كندا'),
(89535, 3512029280, 3512031295, 'US', 'USA', 'الولايات المتحدة'),
(89536, 3512031296, 3512031359, 'JO', 'JOR', 'الأردن'),
(89537, 3512031360, 3512031375, 'CA', 'CAN', 'كندا'),
(89538, 3512031376, 3512031535, 'US', 'USA', 'الولايات المتحدة'),
(89539, 3512031536, 3512031551, 'CA', 'CAN', 'كندا'),
(89540, 3512031552, 3512031759, 'US', 'USA', 'الولايات المتحدة'),
(89541, 3512031760, 3512031775, 'CA', 'CAN', 'كندا'),
(89542, 3512031776, 3512037247, 'US', 'USA', 'الولايات المتحدة'),
(89543, 3512037248, 3512037311, 'AU', 'AUS', 'أستراليا'),
(89544, 3512037312, 3512038863, 'US', 'USA', 'الولايات المتحدة'),
(89545, 3512038864, 3512038879, 'CA', 'CAN', 'كندا'),
(89546, 3512038880, 3512040143, 'US', 'USA', 'الولايات المتحدة'),
(89547, 3512040144, 3512040159, 'CA', 'CAN', 'كندا'),
(89548, 3512040160, 3512139775, 'US', 'USA', 'الولايات المتحدة'),
(89549, 3512139776, 3512156159, 'CA', 'CAN', 'كندا'),
(89550, 3512156160, 3512172543, 'US', 'USA', 'الولايات المتحدة'),
(89551, 3512172544, 3512176639, 'CA', 'CAN', 'كندا'),
(89552, 3512176640, 3512197119, 'US', 'USA', 'الولايات المتحدة'),
(89553, 3512197120, 3512205311, 'CA', 'CAN', 'كندا'),
(89554, 3512205312, 3512207359, 'US', 'USA', 'الولايات المتحدة'),
(89555, 3512207360, 3512209407, 'CO', 'COL', 'كولومبيا'),
(89556, 3512209408, 3512221695, 'US', 'USA', 'الولايات المتحدة'),
(89557, 3512221696, 3512223231, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89558, 3512223232, 3512223487, 'LC', 'LCA', 'سانت لوسيا'),
(89559, 3512223488, 3512223743, 'AG', 'ATG', 'انتيغوا وبربودا'),
(89560, 3512223744, 3512228351, 'US', 'USA', 'الولايات المتحدة'),
(89561, 3512228352, 3512229887, 'ZW', 'ZWE', 'زمبابواي'),
(89562, 3512229888, 3512230143, 'VE', 'VEN', 'فنزويلا'),
(89563, 3512230144, 3512233215, 'US', 'USA', 'الولايات المتحدة'),
(89564, 3512233216, 3512233471, 'CL', 'CHL', 'تشيلي'),
(89565, 3512233472, 3512233727, 'US', 'USA', 'الولايات المتحدة'),
(89566, 3512233728, 3512233983, 'HN', 'HND', 'هندوراس'),
(89567, 3512233984, 3512244991, 'US', 'USA', 'الولايات المتحدة'),
(89568, 3512244992, 3512246015, 'IL', 'ISR', 'إسرائيل'),
(89569, 3512246016, 3512249343, 'US', 'USA', 'الولايات المتحدة'),
(89570, 3512249344, 3512256511, 'IL', 'ISR', 'إسرائيل'),
(89571, 3512256512, 3512258559, 'CL', 'CHL', 'تشيلي'),
(89572, 3512258560, 3512263679, 'US', 'USA', 'الولايات المتحدة'),
(89573, 3512263680, 3512264703, 'VE', 'VEN', 'فنزويلا'),
(89574, 3512264704, 3512269055, 'US', 'USA', 'الولايات المتحدة'),
(89575, 3512269056, 3512269311, 'PR', 'PRI', 'بورتو ريكو'),
(89576, 3512269312, 3512270847, 'US', 'USA', 'الولايات المتحدة'),
(89577, 3512270848, 3512336383, 'CA', 'CAN', 'كندا'),
(89578, 3512336384, 3512369151, 'US', 'USA', 'الولايات المتحدة'),
(89579, 3512369152, 3512385535, 'CA', 'CAN', 'كندا'),
(89580, 3512385536, 3512397823, 'US', 'USA', 'الولايات المتحدة'),
(89581, 3512397824, 3512401919, 'CA', 'CAN', 'كندا'),
(89582, 3512401920, 3512418303, 'US', 'USA', 'الولايات المتحدة'),
(89583, 3512418304, 3512451071, 'CA', 'CAN', 'كندا'),
(89584, 3512451072, 3512467455, 'PR', 'PRI', 'بورتو ريكو'),
(89585, 3512467456, 3512647679, 'US', 'USA', 'الولايات المتحدة'),
(89586, 3512647680, 3512655871, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(89587, 3512655872, 3512696831, 'US', 'USA', 'الولايات المتحدة'),
(89588, 3512696832, 3512699775, 'SE', 'SWE', 'السويد'),
(89589, 3512699776, 3512699903, 'US', 'USA', 'الولايات المتحدة'),
(89590, 3512699904, 3512705023, 'SE', 'SWE', 'السويد'),
(89591, 3512705024, 3512844287, 'US', 'USA', 'الولايات المتحدة'),
(89592, 3512844288, 3512852479, 'CA', 'CAN', 'كندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(89593, 3512852480, 3512983551, 'US', 'USA', 'الولايات المتحدة'),
(89594, 3512983552, 3512987647, 'AR', 'ARG', 'الأرجنتين'),
(89595, 3512987648, 3513171967, 'US', 'USA', 'الولايات المتحدة'),
(89596, 3513180160, 3513188351, 'US', 'USA', 'الولايات المتحدة'),
(89597, 3513188352, 3513204735, 'CA', 'CAN', 'كندا'),
(89598, 3513204736, 3513270271, 'US', 'USA', 'الولايات المتحدة'),
(89599, 3513270272, 3513286655, 'CA', 'CAN', 'كندا'),
(89600, 3513286656, 3513294847, 'US', 'USA', 'الولايات المتحدة'),
(89601, 3513294848, 3513303039, 'CA', 'CAN', 'كندا'),
(89602, 3513303040, 3513368575, 'US', 'USA', 'الولايات المتحدة'),
(89603, 3513368576, 3513376767, 'CA', 'CAN', 'كندا'),
(89604, 3513384960, 3513475071, 'US', 'USA', 'الولايات المتحدة'),
(89605, 3513475072, 3513483263, 'CA', 'CAN', 'كندا'),
(89606, 3513483264, 3513778175, 'US', 'USA', 'الولايات المتحدة'),
(89607, 3513778176, 3513794559, 'CA', 'CAN', 'كندا'),
(89608, 3513794560, 3513917439, 'US', 'USA', 'الولايات المتحدة'),
(89609, 3513925632, 3514007551, 'US', 'USA', 'الولايات المتحدة'),
(89610, 3514007552, 3514040319, 'CA', 'CAN', 'كندا'),
(89611, 3514040320, 3514367999, 'US', 'USA', 'الولايات المتحدة'),
(89612, 3514368000, 3514433535, 'CA', 'CAN', 'كندا'),
(89613, 3514433536, 3514589439, 'US', 'USA', 'الولايات المتحدة'),
(89614, 3514589440, 3514589695, 'GT', 'GTM', 'غواتيمالا'),
(89615, 3514589696, 3514590207, 'SV', 'SLV', 'السلفادور'),
(89616, 3514590208, 3514590719, 'US', 'USA', 'الولايات المتحدة'),
(89617, 3514590720, 3514591103, 'SV', 'SLV', 'السلفادور'),
(89618, 3514591104, 3514591487, 'US', 'USA', 'الولايات المتحدة'),
(89619, 3514591488, 3514592255, 'NI', 'NIC', 'نيكاراغوا'),
(89620, 3514592256, 3514592767, 'SV', 'SLV', 'السلفادور'),
(89621, 3514592768, 3514596863, 'US', 'USA', 'الولايات المتحدة'),
(89622, 3514596864, 3514597375, 'SV', 'SLV', 'السلفادور'),
(89623, 3514597376, 3514826751, 'US', 'USA', 'الولايات المتحدة'),
(89624, 3514826752, 3514843135, 'CA', 'CAN', 'كندا'),
(89625, 3514843136, 3515185151, 'US', 'USA', 'الولايات المتحدة'),
(89626, 3515185152, 3515185407, 'CA', 'CAN', 'كندا'),
(89627, 3515185408, 3515301887, 'US', 'USA', 'الولايات المتحدة'),
(89628, 3515301888, 3515318271, 'CA', 'CAN', 'كندا'),
(89629, 3515318272, 3515596799, 'US', 'USA', 'الولايات المتحدة'),
(89630, 3515596800, 3515613183, 'CA', 'CAN', 'كندا'),
(89631, 3515744256, 3515867151, 'US', 'USA', 'الولايات المتحدة'),
(89632, 3515867152, 3515867167, 'AU', 'AUS', 'أستراليا'),
(89633, 3515867168, 3515867391, 'US', 'USA', 'الولايات المتحدة'),
(89634, 3515867392, 3515867519, 'AU', 'AUS', 'أستراليا'),
(89635, 3515867520, 3515868463, 'US', 'USA', 'الولايات المتحدة'),
(89636, 3515868464, 3515868479, 'IT', 'ITA', 'إيطاليا'),
(89637, 3515868480, 3515913631, 'US', 'USA', 'الولايات المتحدة'),
(89638, 3515913632, 3515913663, 'CA', 'CAN', 'كندا'),
(89639, 3515913664, 3515916519, 'US', 'USA', 'الولايات المتحدة'),
(89640, 3515916520, 3515916527, 'AU', 'AUS', 'أستراليا'),
(89641, 3515916528, 3515965439, 'US', 'USA', 'الولايات المتحدة'),
(89642, 3515965440, 3515973631, 'CA', 'CAN', 'كندا'),
(89643, 3515973632, 3515990015, 'US', 'USA', 'الولايات المتحدة'),
(89644, 3516006400, 3516039167, 'US', 'USA', 'الولايات المتحدة'),
(89645, 3516039168, 3516071935, 'CA', 'CAN', 'كندا'),
(89646, 3516071936, 3516153855, 'US', 'USA', 'الولايات المتحدة'),
(89647, 3516153856, 3516162047, 'CA', 'CAN', 'كندا'),
(89648, 3516162048, 3516170239, 'US', 'USA', 'الولايات المتحدة'),
(89649, 3516170240, 3516203007, 'CA', 'CAN', 'كندا'),
(89650, 3516203008, 3516334079, 'US', 'USA', 'الولايات المتحدة'),
(89651, 3516334080, 3516342271, 'CA', 'CAN', 'كندا'),
(89652, 3516342272, 3516355663, 'US', 'USA', 'الولايات المتحدة'),
(89653, 3516355664, 3516355679, 'CA', 'CAN', 'كندا'),
(89654, 3516355680, 3516366847, 'US', 'USA', 'الولايات المتحدة'),
(89655, 3516366848, 3516370943, 'CA', 'CAN', 'كندا'),
(89656, 3516370944, 3516379135, 'US', 'USA', 'الولايات المتحدة'),
(89657, 3516383232, 3516514303, 'US', 'USA', 'الولايات المتحدة'),
(89658, 3516514304, 3516530687, 'CA', 'CAN', 'كندا'),
(89659, 3516530688, 3516899327, 'US', 'USA', 'الولايات المتحدة'),
(89660, 3516899328, 3516899839, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(89661, 3516899840, 3516899847, 'US', 'USA', 'الولايات المتحدة'),
(89662, 3516899848, 3516899855, 'NG', 'NGA', 'نيجيريا'),
(89663, 3516899856, 3516899887, 'US', 'USA', 'الولايات المتحدة'),
(89664, 3516899888, 3516899903, 'NG', 'NGA', 'نيجيريا'),
(89665, 3516899904, 3516899935, 'EC', 'ECU', 'الإكوادور'),
(89666, 3516899936, 3516900015, 'NG', 'NGA', 'نيجيريا'),
(89667, 3516900016, 3516900095, 'US', 'USA', 'الولايات المتحدة'),
(89668, 3516900096, 3516900351, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(89669, 3516900352, 3516900607, 'NG', 'NGA', 'نيجيريا'),
(89670, 3516900608, 3516900863, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(89671, 3516900864, 3516901119, 'NG', 'NGA', 'نيجيريا'),
(89672, 3516901120, 3516901887, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(89673, 3516901888, 3516902399, 'NG', 'NGA', 'نيجيريا'),
(89674, 3516902400, 3516902655, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(89675, 3516902656, 3516902911, 'NG', 'NGA', 'نيجيريا'),
(89676, 3516902912, 3516903167, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(89677, 3516903168, 3516903423, 'NG', 'NGA', 'نيجيريا'),
(89678, 3516903424, 3516907519, 'CA', 'CAN', 'كندا'),
(89679, 3516907520, 3517038591, 'US', 'USA', 'الولايات المتحدة'),
(89680, 3517038592, 3517054975, 'CA', 'CAN', 'كندا'),
(89681, 3517054976, 3517095935, 'US', 'USA', 'الولايات المتحدة'),
(89682, 3517095936, 3517100031, 'CA', 'CAN', 'كندا'),
(89683, 3517100032, 3517112319, 'US', 'USA', 'الولايات المتحدة'),
(89684, 3517112320, 3517116159, 'CA', 'CAN', 'كندا'),
(89685, 3517116160, 3517116415, 'US', 'USA', 'الولايات المتحدة'),
(89686, 3517116416, 3517120511, 'CA', 'CAN', 'كندا'),
(89687, 3517120512, 3517233151, 'US', 'USA', 'الولايات المتحدة'),
(89688, 3517233152, 3517235199, 'GU', 'GUM', 'غوام'),
(89689, 3517235200, 3517309951, 'US', 'USA', 'الولايات المتحدة'),
(89690, 3517309952, 3517313023, 'CA', 'CAN', 'كندا'),
(89691, 3517313024, 3517382911, 'US', 'USA', 'الولايات المتحدة'),
(89692, 3517382912, 3517383167, 'CA', 'CAN', 'كندا'),
(89693, 3517383168, 3517385983, 'US', 'USA', 'الولايات المتحدة'),
(89694, 3517385984, 3517386239, 'CA', 'CAN', 'كندا'),
(89695, 3517386240, 3517388287, 'US', 'USA', 'الولايات المتحدة'),
(89696, 3517388288, 3517388543, 'CA', 'CAN', 'كندا'),
(89697, 3517388544, 3517391103, 'US', 'USA', 'الولايات المتحدة'),
(89698, 3517391104, 3517391359, 'CA', 'CAN', 'كندا'),
(89699, 3517391360, 3517391439, 'US', 'USA', 'الولايات المتحدة'),
(89700, 3517391440, 3517391455, 'CA', 'CAN', 'كندا'),
(89701, 3517391456, 3517391871, 'US', 'USA', 'الولايات المتحدة'),
(89702, 3517391872, 3517392127, 'CA', 'CAN', 'كندا'),
(89703, 3517392128, 3517392383, 'US', 'USA', 'الولايات المتحدة'),
(89704, 3517392384, 3517392639, 'CA', 'CAN', 'كندا'),
(89705, 3517392640, 3517394687, 'US', 'USA', 'الولايات المتحدة'),
(89706, 3517394688, 3517394943, 'CA', 'CAN', 'كندا'),
(89707, 3517394944, 3517396063, 'US', 'USA', 'الولايات المتحدة'),
(89708, 3517396064, 3517396079, 'CA', 'CAN', 'كندا'),
(89709, 3517396080, 3517396175, 'US', 'USA', 'الولايات المتحدة'),
(89710, 3517396176, 3517396183, 'CA', 'CAN', 'كندا'),
(89711, 3517396184, 3517396479, 'US', 'USA', 'الولايات المتحدة'),
(89712, 3517396480, 3517396543, 'CA', 'CAN', 'كندا'),
(89713, 3517396544, 3517396815, 'US', 'USA', 'الولايات المتحدة'),
(89714, 3517396816, 3517396831, 'CA', 'CAN', 'كندا'),
(89715, 3517396832, 3517400063, 'US', 'USA', 'الولايات المتحدة'),
(89716, 3517400064, 3517400319, 'CA', 'CAN', 'كندا'),
(89717, 3517400320, 3517400511, 'US', 'USA', 'الولايات المتحدة'),
(89718, 3517400512, 3517400543, 'CA', 'CAN', 'كندا'),
(89719, 3517400544, 3517401343, 'US', 'USA', 'الولايات المتحدة'),
(89720, 3517401344, 3517401375, 'CA', 'CAN', 'كندا'),
(89721, 3517401376, 3517401439, 'US', 'USA', 'الولايات المتحدة'),
(89722, 3517401440, 3517401471, 'CA', 'CAN', 'كندا'),
(89723, 3517401472, 3517401855, 'US', 'USA', 'الولايات المتحدة'),
(89724, 3517401856, 3517402111, 'CA', 'CAN', 'كندا'),
(89725, 3517402112, 3517403903, 'US', 'USA', 'الولايات المتحدة'),
(89726, 3517403904, 3517404159, 'CA', 'CAN', 'كندا'),
(89727, 3517404160, 3517404671, 'US', 'USA', 'الولايات المتحدة'),
(89728, 3517404672, 3517404927, 'CA', 'CAN', 'كندا'),
(89729, 3517404928, 3517405183, 'US', 'USA', 'الولايات المتحدة'),
(89730, 3517405184, 3517405439, 'CA', 'CAN', 'كندا'),
(89731, 3517405440, 3517405631, 'US', 'USA', 'الولايات المتحدة'),
(89732, 3517405632, 3517405647, 'CA', 'CAN', 'كندا'),
(89733, 3517405648, 3517405695, 'US', 'USA', 'الولايات المتحدة'),
(89734, 3517405696, 3517406463, 'CA', 'CAN', 'كندا'),
(89735, 3517406464, 3517407231, 'US', 'USA', 'الولايات المتحدة'),
(89736, 3517407232, 3517407359, 'CA', 'CAN', 'كندا'),
(89737, 3517407360, 3517407743, 'US', 'USA', 'الولايات المتحدة'),
(89738, 3517407744, 3517408255, 'CA', 'CAN', 'كندا'),
(89739, 3517408256, 3517408959, 'US', 'USA', 'الولايات المتحدة'),
(89740, 3517408960, 3517408975, 'CA', 'CAN', 'كندا'),
(89741, 3517408976, 3517409007, 'US', 'USA', 'الولايات المتحدة'),
(89742, 3517409008, 3517409279, 'CA', 'CAN', 'كندا'),
(89743, 3517409280, 3517409791, 'US', 'USA', 'الولايات المتحدة'),
(89744, 3517409792, 3517410815, 'CA', 'CAN', 'كندا'),
(89745, 3517410816, 3517411327, 'US', 'USA', 'الولايات المتحدة'),
(89746, 3517411328, 3517411583, 'CA', 'CAN', 'كندا'),
(89747, 3517411584, 3517413119, 'US', 'USA', 'الولايات المتحدة'),
(89748, 3517413120, 3517414399, 'CA', 'CAN', 'كندا'),
(89749, 3517414400, 3517414751, 'US', 'USA', 'الولايات المتحدة'),
(89750, 3517414752, 3517414767, 'CA', 'CAN', 'كندا'),
(89751, 3517414768, 3517415167, 'US', 'USA', 'الولايات المتحدة'),
(89752, 3517415168, 3517415423, 'CA', 'CAN', 'كندا'),
(89753, 3517415424, 3517416527, 'US', 'USA', 'الولايات المتحدة'),
(89754, 3517416528, 3517416543, 'CA', 'CAN', 'كندا'),
(89755, 3517416544, 3517416655, 'US', 'USA', 'الولايات المتحدة'),
(89756, 3517416656, 3517416687, 'CA', 'CAN', 'كندا'),
(89757, 3517416688, 3517416903, 'US', 'USA', 'الولايات المتحدة'),
(89758, 3517416904, 3517416911, 'CA', 'CAN', 'كندا'),
(89759, 3517416912, 3517416959, 'US', 'USA', 'الولايات المتحدة'),
(89760, 3517416960, 3517417471, 'CA', 'CAN', 'كندا'),
(89761, 3517417472, 3517417599, 'US', 'USA', 'الولايات المتحدة'),
(89762, 3517417600, 3517417631, 'CA', 'CAN', 'كندا'),
(89763, 3517417632, 3517418303, 'US', 'USA', 'الولايات المتحدة'),
(89764, 3517418304, 3517418335, 'CA', 'CAN', 'كندا'),
(89765, 3517418336, 3517419295, 'US', 'USA', 'الولايات المتحدة'),
(89766, 3517419296, 3517419391, 'CA', 'CAN', 'كندا'),
(89767, 3517419392, 3517419423, 'US', 'USA', 'الولايات المتحدة'),
(89768, 3517419424, 3517419775, 'CA', 'CAN', 'كندا'),
(89769, 3517419776, 3517420031, 'US', 'USA', 'الولايات المتحدة'),
(89770, 3517420032, 3517420159, 'CA', 'CAN', 'كندا'),
(89771, 3517420160, 3517423871, 'US', 'USA', 'الولايات المتحدة'),
(89772, 3517423872, 3517424127, 'CA', 'CAN', 'كندا'),
(89773, 3517424128, 3517424607, 'US', 'USA', 'الولايات المتحدة'),
(89774, 3517424608, 3517424623, 'CA', 'CAN', 'كندا'),
(89775, 3517424624, 3517428991, 'US', 'USA', 'الولايات المتحدة'),
(89776, 3517428992, 3517429247, 'CA', 'CAN', 'كندا'),
(89777, 3517429248, 3517429887, 'US', 'USA', 'الولايات المتحدة'),
(89778, 3517429888, 3517429919, 'CA', 'CAN', 'كندا'),
(89779, 3517429920, 3517430223, 'US', 'USA', 'الولايات المتحدة'),
(89780, 3517430224, 3517430239, 'CA', 'CAN', 'كندا'),
(89781, 3517430240, 3517432319, 'US', 'USA', 'الولايات المتحدة'),
(89782, 3517432320, 3517432575, 'CA', 'CAN', 'كندا'),
(89783, 3517432576, 3517434111, 'US', 'USA', 'الولايات المتحدة'),
(89784, 3517434112, 3517434367, 'CA', 'CAN', 'كندا'),
(89785, 3517434368, 3517434447, 'US', 'USA', 'الولايات المتحدة'),
(89786, 3517434448, 3517434455, 'CA', 'CAN', 'كندا'),
(89787, 3517434456, 3517435583, 'US', 'USA', 'الولايات المتحدة'),
(89788, 3517435584, 3517435647, 'CA', 'CAN', 'كندا'),
(89789, 3517435648, 3517438879, 'US', 'USA', 'الولايات المتحدة'),
(89790, 3517438880, 3517438911, 'KW', 'KWT', 'الكويت'),
(89791, 3517438912, 3517439423, 'US', 'USA', 'الولايات المتحدة'),
(89792, 3517439424, 3517439487, 'CA', 'CAN', 'كندا'),
(89793, 3517439488, 3517439999, 'US', 'USA', 'الولايات المتحدة'),
(89794, 3517440000, 3517440255, 'CA', 'CAN', 'كندا'),
(89795, 3517440256, 3517440511, 'US', 'USA', 'الولايات المتحدة'),
(89796, 3517440512, 3517441535, 'CA', 'CAN', 'كندا'),
(89797, 3517441536, 3517441791, 'US', 'USA', 'الولايات المتحدة'),
(89798, 3517441792, 3517442047, 'CA', 'CAN', 'كندا'),
(89799, 3517442048, 3517442527, 'US', 'USA', 'الولايات المتحدة'),
(89800, 3517442528, 3517442543, 'CA', 'CAN', 'كندا'),
(89801, 3517442544, 3517442751, 'US', 'USA', 'الولايات المتحدة'),
(89802, 3517442752, 3517443071, 'CA', 'CAN', 'كندا'),
(89803, 3517443072, 3517443327, 'US', 'USA', 'الولايات المتحدة'),
(89804, 3517443328, 3517443583, 'CA', 'CAN', 'كندا'),
(89805, 3517443584, 3517443839, 'US', 'USA', 'الولايات المتحدة'),
(89806, 3517443840, 3517443903, 'CA', 'CAN', 'كندا'),
(89807, 3517443904, 3517444031, 'US', 'USA', 'الولايات المتحدة'),
(89808, 3517444032, 3517444095, 'CA', 'CAN', 'كندا'),
(89809, 3517444096, 3517445631, 'US', 'USA', 'الولايات المتحدة'),
(89810, 3517445632, 3517445887, 'CA', 'CAN', 'كندا'),
(89811, 3517445888, 3517446015, 'US', 'USA', 'الولايات المتحدة'),
(89812, 3517446016, 3517446143, 'CA', 'CAN', 'كندا'),
(89813, 3517446144, 3517447423, 'US', 'USA', 'الولايات المتحدة'),
(89814, 3517447424, 3517447679, 'CA', 'CAN', 'كندا'),
(89815, 3517447680, 3517447743, 'US', 'USA', 'الولايات المتحدة'),
(89816, 3517447744, 3517447759, 'CA', 'CAN', 'كندا'),
(89817, 3517447760, 3517447927, 'US', 'USA', 'الولايات المتحدة'),
(89818, 3517447928, 3517448191, 'CA', 'CAN', 'كندا'),
(89819, 3517448192, 3517546495, 'US', 'USA', 'الولايات المتحدة'),
(89820, 3517546496, 3517562879, 'CA', 'CAN', 'كندا'),
(89821, 3517562880, 3517596671, 'US', 'USA', 'الولايات المتحدة'),
(89822, 3517596672, 3517596927, 'NO', 'NOR', 'النرويج'),
(89823, 3517596928, 3517597183, 'SE', 'SWE', 'السويد'),
(89824, 3517597184, 3517597695, 'US', 'USA', 'الولايات المتحدة'),
(89825, 3517597696, 3517598719, 'SE', 'SWE', 'السويد'),
(89826, 3517598720, 3517599231, 'US', 'USA', 'الولايات المتحدة'),
(89827, 3517599232, 3517600767, 'SE', 'SWE', 'السويد'),
(89828, 3517600768, 3517601279, 'US', 'USA', 'الولايات المتحدة'),
(89829, 3517601280, 3517602047, 'SE', 'SWE', 'السويد'),
(89830, 3517602048, 3517602303, 'DE', 'DEU', 'ألمانيا'),
(89831, 3517602304, 3517605119, 'SE', 'SWE', 'السويد'),
(89832, 3517605120, 3517605375, 'US', 'USA', 'الولايات المتحدة'),
(89833, 3517605376, 3517605775, 'SE', 'SWE', 'السويد'),
(89834, 3517605776, 3517605791, 'US', 'USA', 'الولايات المتحدة'),
(89835, 3517605792, 3517605887, 'SE', 'SWE', 'السويد'),
(89836, 3517605888, 3517606143, 'US', 'USA', 'الولايات المتحدة'),
(89837, 3517606144, 3517606911, 'SE', 'SWE', 'السويد'),
(89838, 3517606912, 3517607935, 'US', 'USA', 'الولايات المتحدة'),
(89839, 3517607936, 3517608191, 'DE', 'DEU', 'ألمانيا'),
(89840, 3517608192, 3517608447, 'US', 'USA', 'الولايات المتحدة'),
(89841, 3517608448, 3517608703, 'GB', 'GBR', 'المملكة المتحدة'),
(89842, 3517608704, 3517610495, 'SE', 'SWE', 'السويد'),
(89843, 3517610496, 3517611263, 'IE', 'IRL', 'إيرلندا'),
(89844, 3517611264, 3517612031, 'SE', 'SWE', 'السويد'),
(89845, 3517612032, 3517644799, 'US', 'USA', 'الولايات المتحدة'),
(89846, 3517644800, 3517710335, 'CA', 'CAN', 'كندا'),
(89847, 3517710336, 3517718527, 'US', 'USA', 'الولايات المتحدة'),
(89848, 3517718528, 3517726719, 'CA', 'CAN', 'كندا'),
(89849, 3517726720, 3517979103, 'US', 'USA', 'الولايات المتحدة'),
(89850, 3517979104, 3517979111, 'CA', 'CAN', 'كندا'),
(89851, 3517979112, 3517989487, 'US', 'USA', 'الولايات المتحدة'),
(89852, 3517989488, 3517989503, 'CA', 'CAN', 'كندا'),
(89853, 3517989504, 3517989695, 'US', 'USA', 'الولايات المتحدة'),
(89854, 3517989696, 3517989727, 'CA', 'CAN', 'كندا'),
(89855, 3517989728, 3517990023, 'US', 'USA', 'الولايات المتحدة'),
(89856, 3517990024, 3517990031, 'CA', 'CAN', 'كندا'),
(89857, 3517990032, 3517990911, 'US', 'USA', 'الولايات المتحدة'),
(89858, 3517990912, 3517991423, 'CA', 'CAN', 'كندا'),
(89859, 3517991424, 3518056447, 'US', 'USA', 'الولايات المتحدة'),
(89860, 3518058496, 3518062591, 'US', 'USA', 'الولايات المتحدة'),
(89861, 3518062592, 3518066687, 'CA', 'CAN', 'كندا'),
(89862, 3518066688, 3518078975, 'US', 'USA', 'الولايات المتحدة'),
(89863, 3518083072, 3518431231, 'US', 'USA', 'الولايات المتحدة'),
(89864, 3518431232, 3518439423, 'CA', 'CAN', 'كندا'),
(89865, 3518439424, 3518463999, 'US', 'USA', 'الولايات المتحدة'),
(89866, 3518464000, 3518472191, 'CA', 'CAN', 'كندا'),
(89867, 3518472192, 3518758911, 'US', 'USA', 'الولايات المتحدة'),
(89868, 3518758912, 3518758975, 'CY', 'CYP', 'قبرص'),
(89869, 3518758976, 3518759407, 'US', 'USA', 'الولايات المتحدة'),
(89870, 3518759408, 3518759423, 'CY', 'CYP', 'قبرص'),
(89871, 3518759424, 3518760511, 'US', 'USA', 'الولايات المتحدة'),
(89872, 3518760512, 3518760575, 'AU', 'AUS', 'أستراليا'),
(89873, 3518760576, 3518760703, 'HU', 'HUN', 'هنغاريا'),
(89874, 3518760704, 3518762495, 'US', 'USA', 'الولايات المتحدة'),
(89875, 3518762496, 3518762751, 'GB', 'GBR', 'المملكة المتحدة'),
(89876, 3518762752, 3518764031, 'US', 'USA', 'الولايات المتحدة'),
(89877, 3518764032, 3518764287, 'GB', 'GBR', 'المملكة المتحدة'),
(89878, 3518764288, 3518764671, 'US', 'USA', 'الولايات المتحدة'),
(89879, 3518764672, 3518764703, 'NL', 'NLD', 'هولندا'),
(89880, 3518764704, 3518765311, 'US', 'USA', 'الولايات المتحدة'),
(89881, 3518765312, 3518765567, 'CA', 'CAN', 'كندا'),
(89882, 3518765568, 3518766879, 'US', 'USA', 'الولايات المتحدة'),
(89883, 3518766880, 3518766911, 'TH', 'THA', 'تايلند'),
(89884, 3518766912, 3518894439, 'US', 'USA', 'الولايات المتحدة'),
(89885, 3518894440, 3518894447, 'TR', 'TUR', 'تركيا'),
(89886, 3518894448, 3518911743, 'US', 'USA', 'الولايات المتحدة'),
(89887, 3518911744, 3518911999, 'GB', 'GBR', 'المملكة المتحدة'),
(89888, 3518912000, 3518912511, 'US', 'USA', 'الولايات المتحدة'),
(89889, 3518912512, 3518912767, 'IN', 'IND', 'الهند'),
(89890, 3518912768, 3518929535, 'US', 'USA', 'الولايات المتحدة'),
(89891, 3518929536, 3518929599, 'CA', 'CAN', 'كندا'),
(89892, 3518929600, 3519234047, 'US', 'USA', 'الولايات المتحدة'),
(89893, 3519234048, 3519250431, 'CA', 'CAN', 'كندا'),
(89894, 3519250432, 3519340543, 'US', 'USA', 'الولايات المتحدة'),
(89895, 3519340544, 3519344639, 'CA', 'CAN', 'كندا'),
(89896, 3519344640, 3519350079, 'US', 'USA', 'الولايات المتحدة'),
(89897, 3519350080, 3519350087, 'NL', 'NLD', 'هولندا'),
(89898, 3519350088, 3519352895, 'US', 'USA', 'الولايات المتحدة'),
(89899, 3519352896, 3519352903, 'NL', 'NLD', 'هولندا'),
(89900, 3519352904, 3519381503, 'US', 'USA', 'الولايات المتحدة'),
(89901, 3519381504, 3519397887, 'CA', 'CAN', 'كندا'),
(89902, 3519397888, 3519406503, 'US', 'USA', 'الولايات المتحدة'),
(89903, 3519406504, 3519406511, 'CA', 'CAN', 'كندا'),
(89904, 3519406512, 3519409295, 'US', 'USA', 'الولايات المتحدة'),
(89905, 3519409296, 3519409303, 'CA', 'CAN', 'كندا'),
(89906, 3519409304, 3519428095, 'US', 'USA', 'الولايات المتحدة'),
(89907, 3519428096, 3519428351, 'RO', 'ROM', 'رومانيا'),
(89908, 3519428352, 3519463423, 'US', 'USA', 'الولايات المتحدة'),
(89909, 3519469568, 3519676415, 'US', 'USA', 'الولايات المتحدة'),
(89910, 3519676416, 3519702319, 'CA', 'CAN', 'كندا'),
(89911, 3519702320, 3519702327, 'US', 'USA', 'الولايات المتحدة'),
(89912, 3519702328, 3519709183, 'CA', 'CAN', 'كندا'),
(89913, 3519709184, 3519709311, 'US', 'USA', 'الولايات المتحدة'),
(89914, 3519709312, 3519709343, 'CA', 'CAN', 'كندا'),
(89915, 3519709344, 3519712447, 'US', 'USA', 'الولايات المتحدة'),
(89916, 3519712448, 3519712511, 'CA', 'CAN', 'كندا'),
(89917, 3519712512, 3519715295, 'US', 'USA', 'الولايات المتحدة'),
(89918, 3519715296, 3519715327, 'GB', 'GBR', 'المملكة المتحدة'),
(89919, 3519715328, 3519716863, 'US', 'USA', 'الولايات المتحدة'),
(89920, 3519716864, 3519716991, 'CA', 'CAN', 'كندا'),
(89921, 3519716992, 3519741951, 'US', 'USA', 'الولايات المتحدة'),
(89922, 3519758336, 3519791103, 'US', 'USA', 'الولايات المتحدة'),
(89923, 3519799296, 3519873023, 'US', 'USA', 'الولايات المتحدة'),
(89924, 3519873024, 3519901695, 'CA', 'CAN', 'كندا'),
(89925, 3519901696, 3519934463, 'US', 'USA', 'الولايات المتحدة'),
(89926, 3519934464, 3519938559, 'CA', 'CAN', 'كندا'),
(89927, 3519938560, 3520020479, 'US', 'USA', 'الولايات المتحدة'),
(89928, 3520020480, 3520036863, 'CA', 'CAN', 'كندا'),
(89929, 3520036864, 3520356351, 'US', 'USA', 'الولايات المتحدة'),
(89930, 3520364544, 3520397311, 'US', 'USA', 'الولايات المتحدة'),
(89931, 3520401408, 3520454655, 'US', 'USA', 'الولايات المتحدة'),
(89932, 3520454656, 3520462847, 'CA', 'CAN', 'كندا'),
(89933, 3520462848, 3520626687, 'US', 'USA', 'الولايات المتحدة'),
(89934, 3520626688, 3520634879, 'CA', 'CAN', 'كندا'),
(89935, 3520634880, 3520675839, 'US', 'USA', 'الولايات المتحدة'),
(89936, 3520675840, 3520692223, 'CA', 'CAN', 'كندا'),
(89937, 3520692224, 3520716799, 'US', 'USA', 'الولايات المتحدة'),
(89938, 3520724992, 3520749871, 'US', 'USA', 'الولايات المتحدة'),
(89939, 3520749872, 3520749879, 'CA', 'CAN', 'كندا'),
(89940, 3520749880, 3520937983, 'US', 'USA', 'الولايات المتحدة'),
(89941, 3520937984, 3520954367, 'CA', 'CAN', 'كندا'),
(89942, 3520954368, 3520999423, 'US', 'USA', 'الولايات المتحدة'),
(89943, 3520999424, 3521003519, 'CA', 'CAN', 'كندا'),
(89944, 3521003520, 3521028095, 'US', 'USA', 'الولايات المتحدة'),
(89945, 3521028096, 3521032191, 'CA', 'CAN', 'كندا'),
(89946, 3521032192, 3521044479, 'US', 'USA', 'الولايات المتحدة'),
(89947, 3521044480, 3521048575, 'CA', 'CAN', 'كندا'),
(89948, 3521048576, 3521049599, 'US', 'USA', 'الولايات المتحدة'),
(89949, 3521052672, 3521074687, 'US', 'USA', 'الولايات المتحدة'),
(89950, 3521074688, 3521074695, 'CA', 'CAN', 'كندا'),
(89951, 3521074696, 3521074735, 'US', 'USA', 'الولايات المتحدة'),
(89952, 3521074736, 3521074751, 'AU', 'AUS', 'أستراليا'),
(89953, 3521074752, 3521086207, 'US', 'USA', 'الولايات المتحدة'),
(89954, 3521086208, 3521086463, 'AU', 'AUS', 'أستراليا'),
(89955, 3521086464, 3521098551, 'US', 'USA', 'الولايات المتحدة'),
(89956, 3521098552, 3521098559, 'MX', 'MEX', 'المكسيك'),
(89957, 3521098560, 3521103231, 'US', 'USA', 'الولايات المتحدة'),
(89958, 3521103232, 3521103263, 'CA', 'CAN', 'كندا'),
(89959, 3521103264, 3521106527, 'US', 'USA', 'الولايات المتحدة'),
(89960, 3521106528, 3521106543, 'CA', 'CAN', 'كندا'),
(89961, 3521106544, 3521186623, 'US', 'USA', 'الولايات المتحدة'),
(89962, 3521186624, 3521186687, 'AR', 'ARG', 'الأرجنتين'),
(89963, 3521186688, 3521192703, 'US', 'USA', 'الولايات المتحدة'),
(89964, 3521192704, 3521192735, 'FR', 'FRA', 'فرنسا'),
(89965, 3521192736, 3521196287, 'US', 'USA', 'الولايات المتحدة'),
(89966, 3521196288, 3521196543, 'AR', 'ARG', 'الأرجنتين'),
(89967, 3521196544, 3521249279, 'US', 'USA', 'الولايات المتحدة'),
(89968, 3521249280, 3521314815, 'CA', 'CAN', 'كندا'),
(89969, 3521314816, 3521904639, 'US', 'USA', 'الولايات المتحدة'),
(89970, 3521904640, 3521921023, 'JM', 'JAM', 'جامايكا'),
(89971, 3521921024, 3522101247, 'US', 'USA', 'الولايات المتحدة'),
(89972, 3522101248, 3522109439, 'CA', 'CAN', 'كندا'),
(89973, 3522109440, 3522121983, 'US', 'USA', 'الولايات المتحدة'),
(89974, 3522121984, 3522122239, 'AW', 'ABW', 'أروبا'),
(89975, 3522122240, 3522146303, 'US', 'USA', 'الولايات المتحدة'),
(89976, 3522150400, 3522174975, 'US', 'USA', 'الولايات المتحدة'),
(89977, 3522174976, 3522179071, 'BM', 'BMU', 'برمودا'),
(89978, 3522179072, 3522195455, 'US', 'USA', 'الولايات المتحدة'),
(89979, 3522195456, 3522199551, 'CA', 'CAN', 'كندا'),
(89980, 3522199552, 3522854911, 'US', 'USA', 'الولايات المتحدة'),
(89981, 3522854912, 3522871295, 'CA', 'CAN', 'كندا'),
(89982, 3522871296, 3522893823, 'US', 'USA', 'الولايات المتحدة'),
(89983, 3522895872, 3522937855, 'US', 'USA', 'الولايات المتحدة'),
(89984, 3522937856, 3522938367, 'GB', 'GBR', 'المملكة المتحدة'),
(89985, 3522938368, 3523215359, 'US', 'USA', 'الولايات المتحدة'),
(89986, 3523215360, 3523223551, 'AU', 'AUS', 'أستراليا'),
(89987, 3523223552, 3523231743, 'KR', 'KOR', 'جمهورية كوريا'),
(89988, 3523231744, 3523248127, 'AU', 'AUS', 'أستراليا'),
(89989, 3523248128, 3523280895, 'HK', 'HKG', 'هونغ كونغ'),
(89990, 3523280896, 3523297279, 'TH', 'THA', 'تايلند'),
(89991, 3523297280, 3523317759, 'PH', 'PHL', 'الفلبين'),
(89992, 3523317760, 3523330047, 'JP', 'JPN', 'اليابان'),
(89993, 3523330048, 3523342335, 'AU', 'AUS', 'أستراليا'),
(89994, 3523342336, 3523346431, 'BD', 'BGD', 'بنغالاديش'),
(89995, 3523346432, 3523354623, 'CN', 'CHN', 'الصين'),
(89996, 3523354624, 3523362815, 'KR', 'KOR', 'جمهورية كوريا'),
(89997, 3523362816, 3523379199, 'AU', 'AUS', 'أستراليا'),
(89998, 3523379200, 3523395583, 'PK', 'PAK', 'باكستان'),
(89999, 3523395584, 3523411967, 'JP', 'JPN', 'اليابان'),
(90000, 3523411968, 3523477503, 'HK', 'HKG', 'هونغ كونغ'),
(90001, 3523477504, 3523493887, 'PH', 'PHL', 'الفلبين'),
(90002, 3523493888, 3523497983, 'BD', 'BGD', 'بنغالاديش'),
(90003, 3523497984, 3523500031, 'AU', 'AUS', 'أستراليا'),
(90004, 3523500032, 3523502079, 'KR', 'KOR', 'جمهورية كوريا'),
(90005, 3523502080, 3523510271, 'PH', 'PHL', 'الفلبين'),
(90006, 3523510272, 3523518463, 'TH', 'THA', 'تايلند'),
(90007, 3523518464, 3523526655, 'JP', 'JPN', 'اليابان'),
(90008, 3523526656, 3523530751, 'US', 'USA', 'الولايات المتحدة'),
(90009, 3523530752, 3523532799, 'NZ', 'NZL', 'نيوزيلاندا'),
(90010, 3523532800, 3523534847, 'KR', 'KOR', 'جمهورية كوريا'),
(90011, 3523534848, 3523538943, 'AU', 'AUS', 'أستراليا'),
(90012, 3523538944, 3523543039, 'JP', 'JPN', 'اليابان'),
(90013, 3523543040, 3523551231, 'CN', 'CHN', 'الصين'),
(90014, 3523551232, 3523553279, 'AU', 'AUS', 'أستراليا'),
(90015, 3523553280, 3523555327, 'MY', 'MYS', 'ماليزيا'),
(90016, 3523555328, 3523557375, 'NZ', 'NZL', 'نيوزيلاندا'),
(90017, 3523557376, 3523559423, 'AU', 'AUS', 'أستراليا'),
(90018, 3523559424, 3523575807, 'PH', 'PHL', 'الفلبين'),
(90019, 3523575808, 3523579903, 'AU', 'AUS', 'أستراليا'),
(90020, 3523579904, 3523583999, 'CN', 'CHN', 'الصين'),
(90021, 3523584000, 3523592479, 'HK', 'HKG', 'هونغ كونغ'),
(90022, 3523592480, 3523592495, 'YE', 'YEM', 'اليمن'),
(90023, 3523592496, 3523592511, 'HK', 'HKG', 'هونغ كونغ'),
(90024, 3523592512, 3523592575, 'PK', 'PAK', 'باكستان'),
(90025, 3523592576, 3523592703, 'LB', 'LBN', 'لبنان'),
(90026, 3523592704, 3523592735, 'HK', 'HKG', 'هونغ كونغ'),
(90027, 3523592736, 3523592751, 'AF', 'AFG', 'أفغانستان'),
(90028, 3523592752, 3523593215, 'HK', 'HKG', 'هونغ كونغ'),
(90029, 3523593216, 3523593231, 'KW', 'KWT', 'الكويت'),
(90030, 3523593232, 3523593239, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90031, 3523593240, 3523593279, 'HK', 'HKG', 'هونغ كونغ'),
(90032, 3523593280, 3523593343, 'IR', 'IRN', 'إيران'),
(90033, 3523593344, 3523593535, 'HK', 'HKG', 'هونغ كونغ'),
(90034, 3523593536, 3523593599, 'IR', 'IRN', 'إيران'),
(90035, 3523593600, 3523593743, 'HK', 'HKG', 'هونغ كونغ'),
(90036, 3523593744, 3523593751, 'IQ', 'IRQ', 'العراق'),
(90037, 3523593752, 3523593759, 'HK', 'HKG', 'هونغ كونغ'),
(90038, 3523593760, 3523593767, 'IR', 'IRN', 'إيران'),
(90039, 3523593768, 3523593775, 'HK', 'HKG', 'هونغ كونغ'),
(90040, 3523593776, 3523593791, 'IQ', 'IRQ', 'العراق'),
(90041, 3523593792, 3523593807, 'IR', 'IRN', 'إيران'),
(90042, 3523593808, 3523593823, 'HK', 'HKG', 'هونغ كونغ'),
(90043, 3523593824, 3523593951, 'IR', 'IRN', 'إيران'),
(90044, 3523593952, 3523593959, 'HK', 'HKG', 'هونغ كونغ'),
(90045, 3523593960, 3523593983, 'IQ', 'IRQ', 'العراق'),
(90046, 3523593984, 3523594239, 'PK', 'PAK', 'باكستان'),
(90047, 3523594240, 3523595263, 'IN', 'IND', 'الهند'),
(90048, 3523595264, 3523595391, 'IR', 'IRN', 'إيران'),
(90049, 3523595392, 3523595519, 'PK', 'PAK', 'باكستان'),
(90050, 3523595520, 3523595583, 'IR', 'IRN', 'إيران'),
(90051, 3523595584, 3523595591, 'HK', 'HKG', 'هونغ كونغ'),
(90052, 3523595592, 3523595599, 'KE', 'KEN', 'كينيا'),
(90053, 3523595600, 3523595631, 'IQ', 'IRQ', 'العراق'),
(90054, 3523595632, 3523595647, 'LB', 'LBN', 'لبنان'),
(90055, 3523595648, 3523596287, 'PK', 'PAK', 'باكستان'),
(90056, 3523596288, 3523596351, 'IR', 'IRN', 'إيران'),
(90057, 3523596352, 3523596359, 'HK', 'HKG', 'هونغ كونغ'),
(90058, 3523596360, 3523596375, 'PK', 'PAK', 'باكستان'),
(90059, 3523596376, 3523596415, 'HK', 'HKG', 'هونغ كونغ'),
(90060, 3523596416, 3523596671, 'IR', 'IRN', 'إيران'),
(90061, 3523596672, 3523596735, 'PK', 'PAK', 'باكستان'),
(90062, 3523596736, 3523596751, 'IN', 'IND', 'الهند'),
(90063, 3523596752, 3523596759, 'US', 'USA', 'الولايات المتحدة'),
(90064, 3523596760, 3523596767, 'HK', 'HKG', 'هونغ كونغ'),
(90065, 3523596768, 3523596775, 'IN', 'IND', 'الهند'),
(90066, 3523596776, 3523596783, 'HK', 'HKG', 'هونغ كونغ'),
(90067, 3523596784, 3523596791, 'PK', 'PAK', 'باكستان'),
(90068, 3523596792, 3523596815, 'HK', 'HKG', 'هونغ كونغ'),
(90069, 3523596816, 3523596831, 'IQ', 'IRQ', 'العراق'),
(90070, 3523596832, 3523596863, 'HK', 'HKG', 'هونغ كونغ'),
(90071, 3523596864, 3523596927, 'IQ', 'IRQ', 'العراق'),
(90072, 3523596928, 3523597127, 'PK', 'PAK', 'باكستان'),
(90073, 3523597128, 3523597311, 'HK', 'HKG', 'هونغ كونغ'),
(90074, 3523597312, 3523597567, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90075, 3523597568, 3523597823, 'PK', 'PAK', 'باكستان'),
(90076, 3523597824, 3523597887, 'AF', 'AFG', 'أفغانستان'),
(90077, 3523597888, 3523597951, 'TZ', 'TZA', 'تانزانيا'),
(90078, 3523597952, 3523597959, 'HK', 'HKG', 'هونغ كونغ'),
(90079, 3523597960, 3523597983, 'IQ', 'IRQ', 'العراق'),
(90080, 3523597984, 3523597991, 'KZ', 'KAZ', 'كازاخستان'),
(90081, 3523597992, 3523597999, 'US', 'USA', 'الولايات المتحدة'),
(90082, 3523598000, 3523598015, 'HK', 'HKG', 'هونغ كونغ'),
(90083, 3523598016, 3523598079, 'IR', 'IRN', 'إيران'),
(90084, 3523598080, 3523598207, 'LB', 'LBN', 'لبنان'),
(90085, 3523598208, 3523598335, 'HK', 'HKG', 'هونغ كونغ'),
(90086, 3523598336, 3523598591, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90087, 3523598592, 3523598847, 'PK', 'PAK', 'باكستان'),
(90088, 3523598848, 3523598911, 'HK', 'HKG', 'هونغ كونغ'),
(90089, 3523598912, 3523599103, 'IR', 'IRN', 'إيران'),
(90090, 3523599104, 3523599359, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90091, 3523599360, 3523599615, 'HK', 'HKG', 'هونغ كونغ'),
(90092, 3523599616, 3523599623, 'PK', 'PAK', 'باكستان'),
(90093, 3523599624, 3523599631, 'HK', 'HKG', 'هونغ كونغ'),
(90094, 3523599632, 3523599647, 'PK', 'PAK', 'باكستان'),
(90095, 3523599648, 3523599871, 'HK', 'HKG', 'هونغ كونغ'),
(90096, 3523599872, 3523600383, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90097, 3523600384, 3523600895, 'HK', 'HKG', 'هونغ كونغ'),
(90098, 3523600896, 3523601151, 'AF', 'AFG', 'أفغانستان'),
(90099, 3523601152, 3523602431, 'HK', 'HKG', 'هونغ كونغ'),
(90100, 3523602432, 3523602559, 'IR', 'IRN', 'إيران'),
(90101, 3523602560, 3523602687, 'TR', 'TUR', 'تركيا'),
(90102, 3523602688, 3523602879, 'IR', 'IRN', 'إيران'),
(90103, 3523602880, 3523602895, 'IQ', 'IRQ', 'العراق'),
(90104, 3523602896, 3523602903, 'HK', 'HKG', 'هونغ كونغ'),
(90105, 3523602904, 3523602943, 'IQ', 'IRQ', 'العراق'),
(90106, 3523602944, 3523603207, 'HK', 'HKG', 'هونغ كونغ'),
(90107, 3523603208, 3523603247, 'IQ', 'IRQ', 'العراق'),
(90108, 3523603248, 3523603255, 'HK', 'HKG', 'هونغ كونغ'),
(90109, 3523603256, 3523603263, 'IQ', 'IRQ', 'العراق'),
(90110, 3523603264, 3523603279, 'HK', 'HKG', 'هونغ كونغ'),
(90111, 3523603280, 3523603311, 'IQ', 'IRQ', 'العراق'),
(90112, 3523603312, 3523603319, 'HK', 'HKG', 'هونغ كونغ'),
(90113, 3523603320, 3523603343, 'IQ', 'IRQ', 'العراق'),
(90114, 3523603344, 3523603383, 'HK', 'HKG', 'هونغ كونغ'),
(90115, 3523603384, 3523603415, 'IQ', 'IRQ', 'العراق'),
(90116, 3523603416, 3523603455, 'HK', 'HKG', 'هونغ كونغ'),
(90117, 3523603456, 3523603503, 'IQ', 'IRQ', 'العراق'),
(90118, 3523603504, 3523603535, 'HK', 'HKG', 'هونغ كونغ'),
(90119, 3523603536, 3523603559, 'IQ', 'IRQ', 'العراق'),
(90120, 3523603560, 3523603575, 'HK', 'HKG', 'هونغ كونغ'),
(90121, 3523603576, 3523603583, 'IQ', 'IRQ', 'العراق'),
(90122, 3523603584, 3523603607, 'HK', 'HKG', 'هونغ كونغ'),
(90123, 3523603608, 3523603615, 'IQ', 'IRQ', 'العراق'),
(90124, 3523603616, 3523603647, 'HK', 'HKG', 'هونغ كونغ'),
(90125, 3523603648, 3523603663, 'IQ', 'IRQ', 'العراق'),
(90126, 3523603664, 3523603679, 'HK', 'HKG', 'هونغ كونغ'),
(90127, 3523603680, 3523603695, 'IQ', 'IRQ', 'العراق'),
(90128, 3523603696, 3523603703, 'HK', 'HKG', 'هونغ كونغ'),
(90129, 3523603704, 3523603711, 'IQ', 'IRQ', 'العراق'),
(90130, 3523603712, 3523604223, 'HK', 'HKG', 'هونغ كونغ'),
(90131, 3523604224, 3523604479, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90132, 3523604480, 3523604991, 'HK', 'HKG', 'هونغ كونغ'),
(90133, 3523604992, 3523605503, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90134, 3523605504, 3523606015, 'HK', 'HKG', 'هونغ كونغ'),
(90135, 3523606016, 3523606527, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90136, 3523606528, 3523608319, 'HK', 'HKG', 'هونغ كونغ'),
(90137, 3523608320, 3523608575, 'QA', 'QAT', 'قطر'),
(90138, 3523608576, 3523674111, 'HK', 'HKG', 'هونغ كونغ'),
(90139, 3523674112, 3523682303, 'FJ', 'FJI', 'فيجي'),
(90140, 3523682304, 3523686399, 'NZ', 'NZL', 'نيوزيلاندا'),
(90141, 3523686400, 3523690495, 'AU', 'AUS', 'أستراليا'),
(90142, 3523690496, 3523698687, 'IN', 'IND', 'الهند'),
(90143, 3523698688, 3523698863, 'HK', 'HKG', 'هونغ كونغ'),
(90144, 3523698864, 3523698879, 'AU', 'AUS', 'أستراليا'),
(90145, 3523698880, 3523698943, 'HK', 'HKG', 'هونغ كونغ'),
(90146, 3523698944, 3523698975, 'AU', 'AUS', 'أستراليا'),
(90147, 3523698976, 3523699007, 'HK', 'HKG', 'هونغ كونغ'),
(90148, 3523699008, 3523699071, 'AU', 'AUS', 'أستراليا'),
(90149, 3523699072, 3523699199, 'HK', 'HKG', 'هونغ كونغ'),
(90150, 3523699200, 3523699711, 'US', 'USA', 'الولايات المتحدة'),
(90151, 3523699712, 3523700223, 'AU', 'AUS', 'أستراليا'),
(90152, 3523700224, 3523700287, 'US', 'USA', 'الولايات المتحدة'),
(90153, 3523700288, 3523700351, 'AU', 'AUS', 'أستراليا'),
(90154, 3523700352, 3523700415, 'US', 'USA', 'الولايات المتحدة'),
(90155, 3523700416, 3523700671, 'AU', 'AUS', 'أستراليا'),
(90156, 3523700672, 3523700679, 'HK', 'HKG', 'هونغ كونغ'),
(90157, 3523700680, 3523700735, 'AU', 'AUS', 'أستراليا'),
(90158, 3523700736, 3523701759, 'HK', 'HKG', 'هونغ كونغ'),
(90159, 3523701760, 3523702783, 'AU', 'AUS', 'أستراليا'),
(90160, 3523702784, 3523702799, 'SG', 'SGP', 'سنغافورة'),
(90161, 3523702800, 3523702807, 'SN', 'SEN', 'السنغال'),
(90162, 3523702808, 3523702847, 'SG', 'SGP', 'سنغافورة'),
(90163, 3523702848, 3523702871, 'AU', 'AUS', 'أستراليا'),
(90164, 3523702872, 3523702911, 'SG', 'SGP', 'سنغافورة'),
(90165, 3523702912, 3523703039, 'AU', 'AUS', 'أستراليا'),
(90166, 3523703040, 3523703103, 'SG', 'SGP', 'سنغافورة'),
(90167, 3523703104, 3523704703, 'AU', 'AUS', 'أستراليا'),
(90168, 3523704704, 3523704719, 'SG', 'SGP', 'سنغافورة'),
(90169, 3523704720, 3523704751, 'AU', 'AUS', 'أستراليا'),
(90170, 3523704752, 3523704783, 'SG', 'SGP', 'سنغافورة'),
(90171, 3523704784, 3523704791, 'AU', 'AUS', 'أستراليا'),
(90172, 3523704792, 3523704831, 'SG', 'SGP', 'سنغافورة'),
(90173, 3523704832, 3523704839, 'HK', 'HKG', 'هونغ كونغ'),
(90174, 3523704840, 3523707135, 'AU', 'AUS', 'أستراليا'),
(90175, 3523707136, 3523707903, 'GB', 'GBR', 'المملكة المتحدة'),
(90176, 3523707904, 3523713279, 'AU', 'AUS', 'أستراليا'),
(90177, 3523713280, 3523713535, 'NL', 'NLD', 'هولندا'),
(90178, 3523713536, 3523714943, 'AU', 'AUS', 'أستراليا'),
(90179, 3523714944, 3523715007, 'GB', 'GBR', 'المملكة المتحدة'),
(90180, 3523715008, 3523723263, 'AU', 'AUS', 'أستراليا'),
(90181, 3523723264, 3523725311, 'US', 'USA', 'الولايات المتحدة'),
(90182, 3523725312, 3523731455, 'AU', 'AUS', 'أستراليا'),
(90183, 3523731456, 3523731503, 'JP', 'JPN', 'اليابان'),
(90184, 3523731504, 3523731519, 'AU', 'AUS', 'أستراليا'),
(90185, 3523731520, 3523731567, 'JP', 'JPN', 'اليابان'),
(90186, 3523731568, 3523731583, 'AU', 'AUS', 'أستراليا'),
(90187, 3523731584, 3523731615, 'JP', 'JPN', 'اليابان'),
(90188, 3523731616, 3523737599, 'AU', 'AUS', 'أستراليا'),
(90189, 3523737600, 3523738111, 'US', 'USA', 'الولايات المتحدة'),
(90190, 3523738112, 3523739135, 'AU', 'AUS', 'أستراليا'),
(90191, 3523739136, 3523739455, 'JP', 'JPN', 'اليابان'),
(90192, 3523739456, 3523739519, 'AU', 'AUS', 'أستراليا'),
(90193, 3523739520, 3523739551, 'JP', 'JPN', 'اليابان'),
(90194, 3523739552, 3523739575, 'AU', 'AUS', 'أستراليا'),
(90195, 3523739576, 3523739647, 'JP', 'JPN', 'اليابان'),
(90196, 3523739648, 3524001791, 'AU', 'AUS', 'أستراليا'),
(90197, 3524001792, 3524132863, 'CN', 'CHN', 'الصين'),
(90198, 3524132864, 3524145151, 'PH', 'PHL', 'الفلبين'),
(90199, 3524145152, 3524149247, 'JP', 'JPN', 'اليابان'),
(90200, 3524149248, 3524157439, 'CN', 'CHN', 'الصين'),
(90201, 3524157440, 3524161535, 'AU', 'AUS', 'أستراليا'),
(90202, 3524161536, 3524247551, 'CN', 'CHN', 'الصين'),
(90203, 3524247552, 3524263935, 'AU', 'AUS', 'أستراليا'),
(90204, 3524263936, 3524266495, 'PH', 'PHL', 'الفلبين'),
(90205, 3524266496, 3524266751, 'SG', 'SGP', 'سنغافورة'),
(90206, 3524266752, 3524274175, 'PH', 'PHL', 'الفلبين'),
(90207, 3524274176, 3524274431, 'SG', 'SGP', 'سنغافورة'),
(90208, 3524274432, 3524296703, 'PH', 'PHL', 'الفلبين'),
(90209, 3524296704, 3524313087, 'CN', 'CHN', 'الصين'),
(90210, 3524313088, 3524329471, 'KR', 'KOR', 'جمهورية كوريا'),
(90211, 3524329472, 3524362239, 'TW', 'TWN', 'تايوان'),
(90212, 3524362240, 3524395007, 'HK', 'HKG', 'هونغ كونغ'),
(90213, 3524395008, 3524444159, 'IN', 'IND', 'الهند'),
(90214, 3524444160, 3524460543, 'AU', 'AUS', 'أستراليا'),
(90215, 3524460544, 3524526079, 'MY', 'MYS', 'ماليزيا'),
(90216, 3524526080, 3524591615, 'JP', 'JPN', 'اليابان'),
(90217, 3524591616, 3524722687, 'CN', 'CHN', 'الصين'),
(90218, 3524722688, 3524730879, 'SG', 'SGP', 'سنغافورة'),
(90219, 3524730880, 3524739071, 'CN', 'CHN', 'الصين'),
(90220, 3524739072, 3524743167, 'ID', 'IDN', 'إندونيسيا'),
(90221, 3524743168, 3524747263, 'MP', 'MNP', 'جزر ماريانا الشمالية'),
(90222, 3524747264, 3524755455, 'PH', 'PHL', 'الفلبين'),
(90223, 3524755456, 3524763647, 'AU', 'AUS', 'أستراليا'),
(90224, 3524763648, 3524781791, 'PH', 'PHL', 'الفلبين'),
(90225, 3524781792, 3524781823, 'SG', 'SGP', 'سنغافورة'),
(90226, 3524781824, 3524788223, 'PH', 'PHL', 'الفلبين'),
(90227, 3524788224, 3524853759, 'SG', 'SGP', 'سنغافورة'),
(90228, 3524853760, 3525300739, 'CN', 'CHN', 'الصين'),
(90229, 3525300740, 3525300743, 'US', 'USA', 'الولايات المتحدة'),
(90230, 3525300744, 3526361087, 'CN', 'CHN', 'الصين'),
(90231, 3526361088, 3526393855, 'NZ', 'NZL', 'نيوزيلاندا'),
(90232, 3526393856, 3526395903, 'JP', 'JPN', 'اليابان'),
(90233, 3526395904, 3526397951, 'AU', 'AUS', 'أستراليا'),
(90234, 3526397952, 3526402047, 'MY', 'MYS', 'ماليزيا'),
(90235, 3526402048, 3526410239, 'NZ', 'NZL', 'نيوزيلاندا'),
(90236, 3526410240, 3526414335, 'MY', 'MYS', 'ماليزيا'),
(90237, 3526414336, 3526416383, 'AU', 'AUS', 'أستراليا'),
(90238, 3526416384, 3526418431, 'MY', 'MYS', 'ماليزيا'),
(90239, 3526418432, 3526426623, 'JP', 'JPN', 'اليابان'),
(90240, 3526426624, 3526557695, 'AU', 'AUS', 'أستراليا'),
(90241, 3526557696, 3526754303, 'CN', 'CHN', 'الصين'),
(90242, 3526754304, 3526885375, 'NZ', 'NZL', 'نيوزيلاندا'),
(90243, 3526885376, 3526893567, 'PK', 'PAK', 'باكستان'),
(90244, 3526893568, 3526897663, 'NZ', 'NZL', 'نيوزيلاندا'),
(90245, 3526897664, 3526901759, 'HK', 'HKG', 'هونغ كونغ'),
(90246, 3526901760, 3526909951, 'AU', 'AUS', 'أستراليا'),
(90247, 3526909952, 3526918143, 'IN', 'IND', 'الهند'),
(90248, 3526918144, 3526922239, 'SG', 'SGP', 'سنغافورة'),
(90249, 3526922240, 3526926335, 'AU', 'AUS', 'أستراليا'),
(90250, 3526926336, 3526934527, 'JP', 'JPN', 'اليابان'),
(90251, 3526934528, 3526942719, 'CN', 'CHN', 'الصين'),
(90252, 3526942720, 3526950911, 'AU', 'AUS', 'أستراليا'),
(90253, 3526950912, 3527004159, 'JP', 'JPN', 'اليابان'),
(90254, 3527004160, 3527008255, 'ID', 'IDN', 'إندونيسيا'),
(90255, 3527008256, 3527016447, 'KR', 'KOR', 'جمهورية كوريا'),
(90256, 3527016448, 3527933951, 'TW', 'TWN', 'تايوان'),
(90257, 3527933952, 3528392703, 'CN', 'CHN', 'الصين'),
(90258, 3528392704, 3528396799, 'JP', 'JPN', 'اليابان'),
(90259, 3528396800, 3528400895, 'AU', 'AUS', 'أستراليا'),
(90260, 3528400896, 3528404991, 'JP', 'JPN', 'اليابان'),
(90261, 3528404992, 3528407039, 'NZ', 'NZL', 'نيوزيلاندا'),
(90262, 3528407040, 3528409087, 'AU', 'AUS', 'أستراليا'),
(90263, 3528409088, 3528425471, 'CN', 'CHN', 'الصين'),
(90264, 3528425472, 3528445951, 'JP', 'JPN', 'اليابان'),
(90265, 3528445952, 3528450047, 'ID', 'IDN', 'إندونيسيا'),
(90266, 3528450048, 3528458239, 'CN', 'CHN', 'الصين'),
(90267, 3528458240, 3528464895, 'AU', 'AUS', 'أستراليا'),
(90268, 3528464896, 3528465151, 'HK', 'HKG', 'هونغ كونغ'),
(90269, 3528465152, 3528474623, 'AU', 'AUS', 'أستراليا'),
(90270, 3528474624, 3528482815, 'TW', 'TWN', 'تايوان'),
(90271, 3528482816, 3528491007, 'KR', 'KOR', 'جمهورية كوريا'),
(90272, 3528491008, 3528505007, 'AU', 'AUS', 'أستراليا'),
(90273, 3528505008, 3528505023, 'HK', 'HKG', 'هونغ كونغ'),
(90274, 3528505024, 3528506543, 'AU', 'AUS', 'أستراليا'),
(90275, 3528506544, 3528506559, 'NZ', 'NZL', 'نيوزيلاندا'),
(90276, 3528506560, 3528507391, 'AU', 'AUS', 'أستراليا'),
(90277, 3528507392, 3528589311, 'JP', 'JPN', 'اليابان'),
(90278, 3528589312, 3528720383, 'CN', 'CHN', 'الصين'),
(90279, 3528720384, 3528785919, 'AU', 'AUS', 'أستراليا'),
(90280, 3528785920, 3528851455, 'TW', 'TWN', 'تايوان'),
(90281, 3528851456, 3528884223, 'NZ', 'NZL', 'نيوزيلاندا'),
(90282, 3528884224, 3528908799, 'TH', 'THA', 'تايلند'),
(90283, 3528908800, 3528912895, 'VN', 'VNM', 'فييتنام'),
(90284, 3528912896, 3528933375, 'AU', 'AUS', 'أستراليا'),
(90285, 3528933376, 3528949759, 'JP', 'JPN', 'اليابان'),
(90286, 3528949760, 3528966143, 'CN', 'CHN', 'الصين'),
(90287, 3528966144, 3528974335, 'KR', 'KOR', 'جمهورية كوريا'),
(90288, 3528974336, 3528978431, 'JP', 'JPN', 'اليابان'),
(90289, 3528978432, 3528982527, 'HK', 'HKG', 'هونغ كونغ'),
(90290, 3528982528, 3529011135, 'JP', 'JPN', 'اليابان'),
(90291, 3529011136, 3529011151, 'NZ', 'NZL', 'نيوزيلاندا'),
(90292, 3529011152, 3529056255, 'JP', 'JPN', 'اليابان'),
(90293, 3529056256, 3529064447, 'IN', 'IND', 'الهند'),
(90294, 3529064448, 3529065247, 'HK', 'HKG', 'هونغ كونغ'),
(90295, 3529065248, 3529065255, 'ID', 'IDN', 'إندونيسيا'),
(90296, 3529065256, 3529065343, 'HK', 'HKG', 'هونغ كونغ'),
(90297, 3529065344, 3529065347, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(90298, 3529065348, 3529065359, 'HK', 'HKG', 'هونغ كونغ'),
(90299, 3529065360, 3529065367, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(90300, 3529065368, 3529065743, 'HK', 'HKG', 'هونغ كونغ'),
(90301, 3529065744, 3529065759, 'PK', 'PAK', 'باكستان'),
(90302, 3529065760, 3529065791, 'AF', 'AFG', 'أفغانستان'),
(90303, 3529065792, 3529065823, 'PH', 'PHL', 'الفلبين'),
(90304, 3529065824, 3529065839, 'MY', 'MYS', 'ماليزيا'),
(90305, 3529065840, 3529065863, 'AF', 'AFG', 'أفغانستان'),
(90306, 3529065864, 3529065871, 'HK', 'HKG', 'هونغ كونغ'),
(90307, 3529065872, 3529065879, 'AF', 'AFG', 'أفغانستان'),
(90308, 3529065880, 3529065887, 'HK', 'HKG', 'هونغ كونغ'),
(90309, 3529065888, 3529065903, 'AF', 'AFG', 'أفغانستان'),
(90310, 3529065904, 3529066239, 'HK', 'HKG', 'هونغ كونغ'),
(90311, 3529066240, 3529066287, 'AF', 'AFG', 'أفغانستان'),
(90312, 3529066288, 3529066487, 'HK', 'HKG', 'هونغ كونغ'),
(90313, 3529066488, 3529066503, 'AF', 'AFG', 'أفغانستان'),
(90314, 3529066504, 3529066527, 'HK', 'HKG', 'هونغ كونغ'),
(90315, 3529066528, 3529066543, 'AF', 'AFG', 'أفغانستان'),
(90316, 3529066544, 3529066551, 'HK', 'HKG', 'هونغ كونغ'),
(90317, 3529066552, 3529066567, 'AF', 'AFG', 'أفغانستان'),
(90318, 3529066568, 3529066575, 'HK', 'HKG', 'هونغ كونغ'),
(90319, 3529066576, 3529066583, 'AF', 'AFG', 'أفغانستان'),
(90320, 3529066584, 3529066631, 'HK', 'HKG', 'هونغ كونغ'),
(90321, 3529066632, 3529066639, 'AF', 'AFG', 'أفغانستان'),
(90322, 3529066640, 3529066647, 'HK', 'HKG', 'هونغ كونغ'),
(90323, 3529066648, 3529066655, 'AF', 'AFG', 'أفغانستان'),
(90324, 3529066656, 3529066663, 'HK', 'HKG', 'هونغ كونغ'),
(90325, 3529066664, 3529066679, 'PK', 'PAK', 'باكستان'),
(90326, 3529066680, 3529066703, 'HK', 'HKG', 'هونغ كونغ'),
(90327, 3529066704, 3529066711, 'AF', 'AFG', 'أفغانستان'),
(90328, 3529066712, 3529066735, 'HK', 'HKG', 'هونغ كونغ'),
(90329, 3529066736, 3529066743, 'AF', 'AFG', 'أفغانستان'),
(90330, 3529066744, 3529067007, 'HK', 'HKG', 'هونغ كونغ'),
(90331, 3529067008, 3529067255, 'AF', 'AFG', 'أفغانستان'),
(90332, 3529067256, 3529067263, 'HK', 'HKG', 'هونغ كونغ'),
(90333, 3529067264, 3529067303, 'PK', 'PAK', 'باكستان'),
(90334, 3529067304, 3529067311, 'AF', 'AFG', 'أفغانستان'),
(90335, 3529067312, 3529067319, 'PK', 'PAK', 'باكستان'),
(90336, 3529067320, 3529067431, 'AF', 'AFG', 'أفغانستان'),
(90337, 3529067432, 3529067439, 'HK', 'HKG', 'هونغ كونغ'),
(90338, 3529067440, 3529067463, 'AF', 'AFG', 'أفغانستان'),
(90339, 3529067464, 3529067471, 'PK', 'PAK', 'باكستان'),
(90340, 3529067472, 3529067487, 'HK', 'HKG', 'هونغ كونغ'),
(90341, 3529067488, 3529067503, 'AF', 'AFG', 'أفغانستان'),
(90342, 3529067504, 3529067519, 'HK', 'HKG', 'هونغ كونغ'),
(90343, 3529067520, 3529067535, 'AF', 'AFG', 'أفغانستان'),
(90344, 3529067536, 3529067543, 'HK', 'HKG', 'هونغ كونغ'),
(90345, 3529067544, 3529067551, 'AF', 'AFG', 'أفغانستان'),
(90346, 3529067552, 3529067559, 'HK', 'HKG', 'هونغ كونغ'),
(90347, 3529067560, 3529067575, 'AF', 'AFG', 'أفغانستان'),
(90348, 3529067576, 3529067583, 'HK', 'HKG', 'هونغ كونغ'),
(90349, 3529067584, 3529067599, 'AF', 'AFG', 'أفغانستان'),
(90350, 3529067600, 3529067607, 'HK', 'HKG', 'هونغ كونغ'),
(90351, 3529067608, 3529067631, 'AF', 'AFG', 'أفغانستان'),
(90352, 3529067632, 3529067639, 'HK', 'HKG', 'هونغ كونغ'),
(90353, 3529067640, 3529067655, 'AF', 'AFG', 'أفغانستان'),
(90354, 3529067656, 3529067663, 'HK', 'HKG', 'هونغ كونغ'),
(90355, 3529067664, 3529067703, 'AF', 'AFG', 'أفغانستان'),
(90356, 3529067704, 3529067711, 'PK', 'PAK', 'باكستان'),
(90357, 3529067712, 3529067727, 'HK', 'HKG', 'هونغ كونغ'),
(90358, 3529067728, 3529067751, 'AF', 'AFG', 'أفغانستان'),
(90359, 3529067752, 3529067759, 'HK', 'HKG', 'هونغ كونغ'),
(90360, 3529067760, 3529067775, 'AF', 'AFG', 'أفغانستان'),
(90361, 3529067776, 3529067799, 'HK', 'HKG', 'هونغ كونغ'),
(90362, 3529067800, 3529067807, 'AF', 'AFG', 'أفغانستان'),
(90363, 3529067808, 3529068031, 'HK', 'HKG', 'هونغ كونغ'),
(90364, 3529068032, 3529068047, 'AF', 'AFG', 'أفغانستان'),
(90365, 3529068048, 3529068063, 'HK', 'HKG', 'هونغ كونغ'),
(90366, 3529068064, 3529068087, 'AF', 'AFG', 'أفغانستان'),
(90367, 3529068088, 3529068103, 'HK', 'HKG', 'هونغ كونغ'),
(90368, 3529068104, 3529068111, 'AF', 'AFG', 'أفغانستان'),
(90369, 3529068112, 3529068127, 'PK', 'PAK', 'باكستان'),
(90370, 3529068128, 3529068159, 'AF', 'AFG', 'أفغانستان'),
(90371, 3529068160, 3529068175, 'HK', 'HKG', 'هونغ كونغ'),
(90372, 3529068176, 3529068207, 'AF', 'AFG', 'أفغانستان'),
(90373, 3529068208, 3529068239, 'HK', 'HKG', 'هونغ كونغ'),
(90374, 3529068240, 3529068255, 'AF', 'AFG', 'أفغانستان'),
(90375, 3529068256, 3529068271, 'HK', 'HKG', 'هونغ كونغ'),
(90376, 3529068272, 3529068279, 'MM', 'MMR', 'ميانمار'),
(90377, 3529068280, 3529068303, 'AF', 'AFG', 'أفغانستان'),
(90378, 3529068304, 3529068319, 'HK', 'HKG', 'هونغ كونغ'),
(90379, 3529068320, 3529068335, 'AF', 'AFG', 'أفغانستان'),
(90380, 3529068336, 3529068351, 'HK', 'HKG', 'هونغ كونغ'),
(90381, 3529068352, 3529068415, 'AF', 'AFG', 'أفغانستان'),
(90382, 3529068416, 3529068431, 'HK', 'HKG', 'هونغ كونغ'),
(90383, 3529068432, 3529068471, 'AF', 'AFG', 'أفغانستان'),
(90384, 3529068472, 3529068487, 'HK', 'HKG', 'هونغ كونغ'),
(90385, 3529068488, 3529068543, 'AF', 'AFG', 'أفغانستان'),
(90386, 3529068544, 3529068551, 'PK', 'PAK', 'باكستان'),
(90387, 3529068552, 3529068559, 'AF', 'AFG', 'أفغانستان'),
(90388, 3529068560, 3529068575, 'HK', 'HKG', 'هونغ كونغ'),
(90389, 3529068576, 3529068599, 'AF', 'AFG', 'أفغانستان'),
(90390, 3529068600, 3529068607, 'HK', 'HKG', 'هونغ كونغ'),
(90391, 3529068608, 3529068615, 'AF', 'AFG', 'أفغانستان'),
(90392, 3529068616, 3529068623, 'HK', 'HKG', 'هونغ كونغ'),
(90393, 3529068624, 3529068647, 'AF', 'AFG', 'أفغانستان'),
(90394, 3529068648, 3529068655, 'HK', 'HKG', 'هونغ كونغ'),
(90395, 3529068656, 3529068663, 'AF', 'AFG', 'أفغانستان'),
(90396, 3529068664, 3529068671, 'HK', 'HKG', 'هونغ كونغ'),
(90397, 3529068672, 3529068727, 'AF', 'AFG', 'أفغانستان'),
(90398, 3529068728, 3529068735, 'HK', 'HKG', 'هونغ كونغ'),
(90399, 3529068736, 3529068743, 'AF', 'AFG', 'أفغانستان'),
(90400, 3529068744, 3529068799, 'HK', 'HKG', 'هونغ كونغ'),
(90401, 3529068800, 3529068815, 'AF', 'AFG', 'أفغانستان'),
(90402, 3529068816, 3529068823, 'HK', 'HKG', 'هونغ كونغ'),
(90403, 3529068824, 3529068831, 'PK', 'PAK', 'باكستان'),
(90404, 3529068832, 3529068895, 'HK', 'HKG', 'هونغ كونغ'),
(90405, 3529068896, 3529068911, 'AF', 'AFG', 'أفغانستان'),
(90406, 3529068912, 3529068919, 'HK', 'HKG', 'هونغ كونغ'),
(90407, 3529068920, 3529068943, 'AF', 'AFG', 'أفغانستان'),
(90408, 3529068944, 3529068959, 'HK', 'HKG', 'هونغ كونغ'),
(90409, 3529068960, 3529068967, 'AF', 'AFG', 'أفغانستان'),
(90410, 3529068968, 3529068975, 'HK', 'HKG', 'هونغ كونغ'),
(90411, 3529068976, 3529069007, 'AF', 'AFG', 'أفغانستان'),
(90412, 3529069008, 3529069023, 'HK', 'HKG', 'هونغ كونغ'),
(90413, 3529069024, 3529069039, 'AF', 'AFG', 'أفغانستان'),
(90414, 3529069040, 3529069311, 'HK', 'HKG', 'هونغ كونغ'),
(90415, 3529069312, 3529069567, 'BD', 'BGD', 'بنغالاديش'),
(90416, 3529069568, 3529070335, 'HK', 'HKG', 'هونغ كونغ'),
(90417, 3529070336, 3529070591, 'AF', 'AFG', 'أفغانستان'),
(90418, 3529070592, 3529071887, 'HK', 'HKG', 'هونغ كونغ'),
(90419, 3529071888, 3529071903, 'AF', 'AFG', 'أفغانستان'),
(90420, 3529071904, 3529071935, 'HK', 'HKG', 'هونغ كونغ'),
(90421, 3529071936, 3529071999, 'US', 'USA', 'الولايات المتحدة'),
(90422, 3529072000, 3529072063, 'HK', 'HKG', 'هونغ كونغ'),
(90423, 3529072064, 3529072095, 'BD', 'BGD', 'بنغالاديش'),
(90424, 3529072096, 3529072127, 'AF', 'AFG', 'أفغانستان'),
(90425, 3529072128, 3529072639, 'HK', 'HKG', 'هونغ كونغ'),
(90426, 3529072640, 3529080831, 'JP', 'JPN', 'اليابان'),
(90427, 3529080832, 3529089023, 'AU', 'AUS', 'أستراليا'),
(90428, 3529089024, 3529097215, 'KR', 'KOR', 'جمهورية كوريا'),
(90429, 3529097216, 3529113599, 'JP', 'JPN', 'اليابان'),
(90430, 3529113600, 3531603967, 'KR', 'KOR', 'جمهورية كوريا'),
(90431, 3531603968, 3534749695, 'JP', 'JPN', 'اليابان'),
(90432, 3534749696, 3534757887, 'HK', 'HKG', 'هونغ كونغ'),
(90433, 3534757888, 3534757951, 'IN', 'IND', 'الهند'),
(90434, 3534757952, 3534757983, 'HK', 'HKG', 'هونغ كونغ'),
(90435, 3534757984, 3534761023, 'IN', 'IND', 'الهند'),
(90436, 3534761024, 3534761119, 'HK', 'HKG', 'هونغ كونغ'),
(90437, 3534761120, 3534761983, 'IN', 'IND', 'الهند'),
(90438, 3534761984, 3534880767, 'HK', 'HKG', 'هونغ كونغ'),
(90439, 3534880768, 3535273983, 'KR', 'KOR', 'جمهورية كوريا'),
(90440, 3535273984, 3535339519, 'HK', 'HKG', 'هونغ كونغ'),
(90441, 3535339520, 3535355903, 'NZ', 'NZL', 'نيوزيلاندا'),
(90442, 3535355904, 3535372287, 'AU', 'AUS', 'أستراليا'),
(90443, 3535372288, 3535380479, 'JP', 'JPN', 'اليابان'),
(90444, 3535380480, 3535388671, 'PH', 'PHL', 'الفلبين'),
(90445, 3535388672, 3535405055, 'CN', 'CHN', 'الصين'),
(90446, 3535405056, 3535480703, 'MY', 'MYS', 'ماليزيا'),
(90447, 3535480704, 3535480831, 'TH', 'THA', 'تايلند'),
(90448, 3535480832, 3535536127, 'MY', 'MYS', 'ماليزيا'),
(90449, 3535536128, 3535798271, 'JP', 'JPN', 'اليابان'),
(90450, 3535798272, 3535814655, 'TW', 'TWN', 'تايوان'),
(90451, 3535814656, 3535822847, 'KR', 'KOR', 'جمهورية كوريا'),
(90452, 3535822848, 3535831039, 'CN', 'CHN', 'الصين'),
(90453, 3535831040, 3535863807, 'TW', 'TWN', 'تايوان'),
(90454, 3535863808, 3535880191, 'SG', 'SGP', 'سنغافورة'),
(90455, 3535880192, 3535896575, 'JP', 'JPN', 'اليابان'),
(90456, 3535896576, 3535929343, 'AU', 'AUS', 'أستراليا'),
(90457, 3535929344, 3535994879, 'JP', 'JPN', 'اليابان');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(90458, 3535994880, 3536060415, 'MY', 'MYS', 'ماليزيا'),
(90459, 3536060416, 3536322559, 'JP', 'JPN', 'اليابان'),
(90460, 3536322560, 3536551935, 'TW', 'TWN', 'تايوان'),
(90461, 3536551936, 3536568319, 'TH', 'THA', 'تايلند'),
(90462, 3536568320, 3536584703, 'JP', 'JPN', 'اليابان'),
(90463, 3536584704, 3536846847, 'KR', 'KOR', 'جمهورية كوريا'),
(90464, 3536846848, 3536928767, 'TW', 'TWN', 'تايوان'),
(90465, 3536928768, 3536945151, 'HK', 'HKG', 'هونغ كونغ'),
(90466, 3536945152, 3536977919, 'TW', 'TWN', 'تايوان'),
(90467, 3536977920, 3537010687, 'IN', 'IND', 'الهند'),
(90468, 3537010688, 3537027071, 'ID', 'IDN', 'إندونيسيا'),
(90469, 3537027072, 3537043455, 'KR', 'KOR', 'جمهورية كوريا'),
(90470, 3537043456, 3537047551, 'AU', 'AUS', 'أستراليا'),
(90471, 3537047552, 3537049599, 'ID', 'IDN', 'إندونيسيا'),
(90472, 3537049600, 3537051647, 'HK', 'HKG', 'هونغ كونغ'),
(90473, 3537051648, 3537057791, 'JP', 'JPN', 'اليابان'),
(90474, 3537057792, 3537059839, 'AU', 'AUS', 'أستراليا'),
(90475, 3537059840, 3537068031, 'KR', 'KOR', 'جمهورية كوريا'),
(90476, 3537068032, 3537076223, 'VN', 'VNM', 'فييتنام'),
(90477, 3537076224, 3537174527, 'IN', 'IND', 'الهند'),
(90478, 3537174528, 3537190911, 'TH', 'THA', 'تايلند'),
(90479, 3537190912, 3537240063, 'PH', 'PHL', 'الفلبين'),
(90480, 3537240064, 3537305599, 'IN', 'IND', 'الهند'),
(90481, 3537305600, 3537371135, 'AU', 'AUS', 'أستراليا'),
(90482, 3537371136, 3537895423, 'KR', 'KOR', 'جمهورية كوريا'),
(90483, 3537895424, 3538943999, 'JP', 'JPN', 'اليابان'),
(90484, 3538944000, 3539271679, 'TW', 'TWN', 'تايوان'),
(90485, 3539271680, 3539304447, 'VN', 'VNM', 'فييتنام'),
(90486, 3539304448, 3539337215, 'HK', 'HKG', 'هونغ كونغ'),
(90487, 3539337216, 3539353599, 'NZ', 'NZL', 'نيوزيلاندا'),
(90488, 3539353600, 3539402751, 'TH', 'THA', 'تايلند'),
(90489, 3539402752, 3539435519, 'JP', 'JPN', 'اليابان'),
(90490, 3539435520, 3539468287, 'AU', 'AUS', 'أستراليا'),
(90491, 3539468288, 3541303295, 'JP', 'JPN', 'اليابان'),
(90492, 3541303296, 3541565439, 'TW', 'TWN', 'تايوان'),
(90493, 3541565440, 3541696511, 'MY', 'MYS', 'ماليزيا'),
(90494, 3541696512, 3542089727, 'AU', 'AUS', 'أستراليا'),
(90495, 3542089728, 3544186879, 'KR', 'KOR', 'جمهورية كوريا'),
(90496, 3544186880, 3544711167, 'CN', 'CHN', 'الصين'),
(90497, 3544711168, 3545235455, 'TW', 'TWN', 'تايوان'),
(90498, 3545235456, 3546808319, 'CN', 'CHN', 'الصين'),
(90499, 3546808320, 3547856895, 'KR', 'KOR', 'جمهورية كوريا'),
(90500, 3547856896, 3548905471, 'JP', 'JPN', 'اليابان'),
(90501, 3548905472, 3551002623, 'CN', 'CHN', 'الصين'),
(90502, 3551002624, 3554544607, 'KR', 'KOR', 'جمهورية كوريا'),
(90503, 3554544608, 3554544639, 'DE', 'DEU', 'ألمانيا'),
(90504, 3554544640, 3556769791, 'KR', 'KOR', 'جمهورية كوريا'),
(90505, 3556769792, 3556774399, 'DE', 'DEU', 'ألمانيا'),
(90506, 3556786176, 3556794367, 'RU', 'RUS', 'الإتحاد الروسي'),
(90507, 3556794368, 3556795647, 'ES', 'ESP', 'إسبانيا'),
(90508, 3556795648, 3556795679, 'IT', 'ITA', 'إيطاليا'),
(90509, 3556795680, 3556797767, 'ES', 'ESP', 'إسبانيا'),
(90510, 3556797768, 3556797775, 'GB', 'GBR', 'المملكة المتحدة'),
(90511, 3556797776, 3556797839, 'ES', 'ESP', 'إسبانيا'),
(90512, 3556797840, 3556797847, 'PT', 'PRT', 'البورتوغال'),
(90513, 3556797848, 3556800799, 'ES', 'ESP', 'إسبانيا'),
(90514, 3556800800, 3556800807, 'FR', 'FRA', 'فرنسا'),
(90515, 3556800808, 3556802559, 'ES', 'ESP', 'إسبانيا'),
(90516, 3556810752, 3556818943, 'PT', 'PRT', 'البورتوغال'),
(90517, 3556818944, 3556827135, 'MD', 'MDA', 'مولدوفا'),
(90518, 3556827136, 3556843519, 'NL', 'NLD', 'هولندا'),
(90519, 3556843520, 3556847935, 'DE', 'DEU', 'ألمانيا'),
(90520, 3556847936, 3556847967, 'US', 'USA', 'الولايات المتحدة'),
(90521, 3556847968, 3556851711, 'DE', 'DEU', 'ألمانيا'),
(90522, 3556851712, 3556868095, 'UA', 'UKR', 'أوكرانيا'),
(90523, 3556868096, 3556876287, 'GB', 'GBR', 'المملكة المتحدة'),
(90524, 3556876288, 3556884479, 'NL', 'NLD', 'هولندا'),
(90525, 3556884480, 3556900863, 'RU', 'RUS', 'الإتحاد الروسي'),
(90526, 3556900864, 3556909055, 'GB', 'GBR', 'المملكة المتحدة'),
(90527, 3556909056, 3556925439, 'DE', 'DEU', 'ألمانيا'),
(90528, 3556925440, 3556933631, 'PL', 'POL', 'بولندا'),
(90529, 3556933632, 3556941823, 'UA', 'UKR', 'أوكرانيا'),
(90530, 3556941824, 3556950015, 'IE', 'IRL', 'إيرلندا'),
(90531, 3556950016, 3556958207, 'TR', 'TUR', 'تركيا'),
(90532, 3556958208, 3556966399, 'KG', 'KGZ', 'قيرغيزستان'),
(90533, 3556966400, 3556974591, 'SE', 'SWE', 'السويد'),
(90534, 3556974592, 3556982783, 'ES', 'ESP', 'إسبانيا'),
(90535, 3556982784, 3556984623, 'DE', 'DEU', 'ألمانيا'),
(90536, 3556984624, 3556984631, 'FR', 'FRA', 'فرنسا'),
(90537, 3556984632, 3556990975, 'DE', 'DEU', 'ألمانيا'),
(90538, 3556990976, 3556999167, 'UA', 'UKR', 'أوكرانيا'),
(90539, 3556999168, 3557007359, 'RU', 'RUS', 'الإتحاد الروسي'),
(90540, 3557007360, 3557015551, 'GB', 'GBR', 'المملكة المتحدة'),
(90541, 3557015552, 3557023743, 'DE', 'DEU', 'ألمانيا'),
(90542, 3557023744, 3557023879, 'BE', 'BEL', 'بلجيكا'),
(90543, 3557023880, 3557023903, 'GB', 'GBR', 'المملكة المتحدة'),
(90544, 3557023904, 3557023999, 'BE', 'BEL', 'بلجيكا'),
(90545, 3557024000, 3557024255, 'GB', 'GBR', 'المملكة المتحدة'),
(90546, 3557024256, 3557025279, 'BE', 'BEL', 'بلجيكا'),
(90547, 3557025280, 3557025791, 'GB', 'GBR', 'المملكة المتحدة'),
(90548, 3557025792, 3557026047, 'BE', 'BEL', 'بلجيكا'),
(90549, 3557026048, 3557026303, 'GB', 'GBR', 'المملكة المتحدة'),
(90550, 3557026304, 3557026815, 'BE', 'BEL', 'بلجيكا'),
(90551, 3557026816, 3557027071, 'GB', 'GBR', 'المملكة المتحدة'),
(90552, 3557027072, 3557027839, 'BE', 'BEL', 'بلجيكا'),
(90553, 3557027840, 3557027863, 'GB', 'GBR', 'المملكة المتحدة'),
(90554, 3557027864, 3557027871, 'BE', 'BEL', 'بلجيكا'),
(90555, 3557027872, 3557027887, 'GB', 'GBR', 'المملكة المتحدة'),
(90556, 3557027888, 3557028031, 'BE', 'BEL', 'بلجيكا'),
(90557, 3557028032, 3557028063, 'GB', 'GBR', 'المملكة المتحدة'),
(90558, 3557028064, 3557028095, 'BE', 'BEL', 'بلجيكا'),
(90559, 3557028096, 3557028351, 'GB', 'GBR', 'المملكة المتحدة'),
(90560, 3557028352, 3557028735, 'BE', 'BEL', 'بلجيكا'),
(90561, 3557028736, 3557028799, 'GB', 'GBR', 'المملكة المتحدة'),
(90562, 3557028800, 3557028911, 'BE', 'BEL', 'بلجيكا'),
(90563, 3557028912, 3557028927, 'GB', 'GBR', 'المملكة المتحدة'),
(90564, 3557028928, 3557029059, 'BE', 'BEL', 'بلجيكا'),
(90565, 3557029060, 3557029071, 'GB', 'GBR', 'المملكة المتحدة'),
(90566, 3557029072, 3557029567, 'BE', 'BEL', 'بلجيكا'),
(90567, 3557029568, 3557029631, 'GB', 'GBR', 'المملكة المتحدة'),
(90568, 3557029632, 3557029887, 'BE', 'BEL', 'بلجيكا'),
(90569, 3557029888, 3557029951, 'GB', 'GBR', 'المملكة المتحدة'),
(90570, 3557029952, 3557030079, 'BE', 'BEL', 'بلجيكا'),
(90571, 3557030080, 3557030143, 'GB', 'GBR', 'المملكة المتحدة'),
(90572, 3557030144, 3557030719, 'BE', 'BEL', 'بلجيكا'),
(90573, 3557030720, 3557030751, 'GB', 'GBR', 'المملكة المتحدة'),
(90574, 3557030752, 3557030767, 'BE', 'BEL', 'بلجيكا'),
(90575, 3557030768, 3557030783, 'GB', 'GBR', 'المملكة المتحدة'),
(90576, 3557030784, 3557030975, 'BE', 'BEL', 'بلجيكا'),
(90577, 3557030976, 3557031039, 'GB', 'GBR', 'المملكة المتحدة'),
(90578, 3557031040, 3557031423, 'BE', 'BEL', 'بلجيكا'),
(90579, 3557031424, 3557031679, 'GB', 'GBR', 'المملكة المتحدة'),
(90580, 3557031680, 3557031807, 'BE', 'BEL', 'بلجيكا'),
(90581, 3557031808, 3557031935, 'GB', 'GBR', 'المملكة المتحدة'),
(90582, 3557031936, 3557033575, 'IT', 'ITA', 'إيطاليا'),
(90583, 3557033576, 3557033583, 'GB', 'GBR', 'المملكة المتحدة'),
(90584, 3557033584, 3557040127, 'IT', 'ITA', 'إيطاليا'),
(90585, 3557040128, 3557048319, 'NO', 'NOR', 'النرويج'),
(90586, 3557048320, 3557056511, 'CH', 'CHE', 'سويسرا'),
(90587, 3557056512, 3557064703, 'ES', 'ESP', 'إسبانيا'),
(90588, 3557064704, 3557072895, 'CZ', 'CZE', 'التشيك'),
(90589, 3557072896, 3557081087, 'DE', 'DEU', 'ألمانيا'),
(90590, 3557081088, 3557086015, 'NL', 'NLD', 'هولندا'),
(90591, 3557086016, 3557086047, 'DE', 'DEU', 'ألمانيا'),
(90592, 3557086048, 3557086079, 'GB', 'GBR', 'المملكة المتحدة'),
(90593, 3557086080, 3557086719, 'NL', 'NLD', 'هولندا'),
(90594, 3557086720, 3557086783, 'CH', 'CHE', 'سويسرا'),
(90595, 3557086784, 3557086847, 'IT', 'ITA', 'إيطاليا'),
(90596, 3557086848, 3557089279, 'NL', 'NLD', 'هولندا'),
(90597, 3557089280, 3557105663, 'DE', 'DEU', 'ألمانيا'),
(90598, 3557105664, 3557113855, 'BG', 'BGR', 'بلغاريا'),
(90599, 3557113856, 3557130239, 'RU', 'RUS', 'الإتحاد الروسي'),
(90600, 3557130240, 3557138431, 'BG', 'BGR', 'بلغاريا'),
(90601, 3557138432, 3557146623, 'RU', 'RUS', 'الإتحاد الروسي'),
(90602, 3557146624, 3557154815, 'SK', 'SVK', 'سلوفاكيا'),
(90603, 3557154816, 3557171199, 'RU', 'RUS', 'الإتحاد الروسي'),
(90604, 3557171200, 3557172991, 'IR', 'IRN', 'إيران'),
(90605, 3557172992, 3557173503, 'IQ', 'IRQ', 'العراق'),
(90606, 3557173504, 3557173631, 'IR', 'IRN', 'إيران'),
(90607, 3557173632, 3557173695, 'IQ', 'IRQ', 'العراق'),
(90608, 3557173696, 3557173703, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90609, 3557173704, 3557173759, 'IT', 'ITA', 'إيطاليا'),
(90610, 3557173760, 3557174015, 'IR', 'IRN', 'إيران'),
(90611, 3557174016, 3557174527, 'IT', 'ITA', 'إيطاليا'),
(90612, 3557174528, 3557174783, 'IR', 'IRN', 'إيران'),
(90613, 3557174784, 3557175039, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90614, 3557175040, 3557176063, 'IR', 'IRN', 'إيران'),
(90615, 3557176064, 3557176319, 'IT', 'ITA', 'إيطاليا'),
(90616, 3557176320, 3557176619, 'NE', 'NER', 'النيجر'),
(90617, 3557176620, 3557176831, 'IT', 'ITA', 'إيطاليا'),
(90618, 3557176832, 3557177023, 'IQ', 'IRQ', 'العراق'),
(90619, 3557177024, 3557177199, 'IT', 'ITA', 'إيطاليا'),
(90620, 3557177200, 3557177215, 'IR', 'IRN', 'إيران'),
(90621, 3557177216, 3557178367, 'IT', 'ITA', 'إيطاليا'),
(90622, 3557178368, 3557179391, 'IR', 'IRN', 'إيران'),
(90623, 3557179392, 3557213351, 'DE', 'DEU', 'ألمانيا'),
(90624, 3557213352, 3557213359, 'US', 'USA', 'الولايات المتحدة'),
(90625, 3557213360, 3557228543, 'DE', 'DEU', 'ألمانيا'),
(90626, 3557228544, 3557236735, 'EE', 'EST', 'إستونيا'),
(90627, 3557236736, 3557244927, 'ES', 'ESP', 'إسبانيا'),
(90628, 3557244928, 3557253119, 'IT', 'ITA', 'إيطاليا'),
(90629, 3557253120, 3557261311, 'RU', 'RUS', 'الإتحاد الروسي'),
(90630, 3557261312, 3557277695, 'DE', 'DEU', 'ألمانيا'),
(90631, 3557285888, 3557294079, 'RU', 'RUS', 'الإتحاد الروسي'),
(90632, 3557294080, 3557302271, 'DE', 'DEU', 'ألمانيا'),
(90633, 3557302272, 3557310463, 'UA', 'UKR', 'أوكرانيا'),
(90634, 3557310464, 3557326847, 'ES', 'ESP', 'إسبانيا'),
(90635, 3557326848, 3557335039, 'DE', 'DEU', 'ألمانيا'),
(90636, 3557335040, 3557335391, 'BE', 'BEL', 'بلجيكا'),
(90637, 3557335456, 3557335535, 'BE', 'BEL', 'بلجيكا'),
(90638, 3557335552, 3557335951, 'BE', 'BEL', 'بلجيكا'),
(90639, 3557335952, 3557335967, 'LU', 'LUX', 'لوكسيمبورغ'),
(90640, 3557335968, 3557336191, 'BE', 'BEL', 'بلجيكا'),
(90641, 3557336256, 3557336639, 'BE', 'BEL', 'بلجيكا'),
(90642, 3557336648, 3557336655, 'BE', 'BEL', 'بلجيكا'),
(90643, 3557336704, 3557336767, 'BE', 'BEL', 'بلجيكا'),
(90644, 3557338112, 3557338367, 'BE', 'BEL', 'بلجيكا'),
(90645, 3557338496, 3557339175, 'BE', 'BEL', 'بلجيكا'),
(90646, 3557339184, 3557339199, 'BE', 'BEL', 'بلجيكا'),
(90647, 3557339216, 3557339223, 'BE', 'BEL', 'بلجيكا'),
(90648, 3557339232, 3557339267, 'BE', 'BEL', 'بلجيكا'),
(90649, 3557339272, 3557340159, 'BE', 'BEL', 'بلجيكا'),
(90650, 3557340192, 3557340927, 'BE', 'BEL', 'بلجيكا'),
(90651, 3557341184, 3557341455, 'BE', 'BEL', 'بلجيكا'),
(90652, 3557341472, 3557341527, 'BE', 'BEL', 'بلجيكا'),
(90653, 3557341536, 3557341551, 'BE', 'BEL', 'بلجيكا'),
(90654, 3557341560, 3557341567, 'BE', 'BEL', 'بلجيكا'),
(90655, 3557341664, 3557341679, 'BE', 'BEL', 'بلجيكا'),
(90656, 3557341952, 3557342479, 'BE', 'BEL', 'بلجيكا'),
(90657, 3557342496, 3557342511, 'BE', 'BEL', 'بلجيكا'),
(90658, 3557342528, 3557342543, 'BE', 'BEL', 'بلجيكا'),
(90659, 3557342560, 3557342623, 'BE', 'BEL', 'بلجيكا'),
(90660, 3557342720, 3557343231, 'BE', 'BEL', 'بلجيكا'),
(90661, 3557343232, 3557351423, 'DE', 'DEU', 'ألمانيا'),
(90662, 3557351424, 3557359615, 'RU', 'RUS', 'الإتحاد الروسي'),
(90663, 3557359616, 3557359791, 'GB', 'GBR', 'المملكة المتحدة'),
(90664, 3557359792, 3557359871, 'JE', 'JEY', 'جيرسي'),
(90665, 3557359872, 3557360406, 'GB', 'GBR', 'المملكة المتحدة'),
(90666, 3557360407, 3557360407, 'JE', 'JEY', 'جيرسي'),
(90667, 3557360408, 3557360471, 'GB', 'GBR', 'المملكة المتحدة'),
(90668, 3557360472, 3557360479, 'JE', 'JEY', 'جيرسي'),
(90669, 3557360480, 3557360495, 'GB', 'GBR', 'المملكة المتحدة'),
(90670, 3557360496, 3557360527, 'JE', 'JEY', 'جيرسي'),
(90671, 3557360528, 3557360535, 'GB', 'GBR', 'المملكة المتحدة'),
(90672, 3557360536, 3557360567, 'JE', 'JEY', 'جيرسي'),
(90673, 3557360568, 3557360623, 'GB', 'GBR', 'المملكة المتحدة'),
(90674, 3557360624, 3557360639, 'JE', 'JEY', 'جيرسي'),
(90675, 3557360640, 3557360680, 'GB', 'GBR', 'المملكة المتحدة'),
(90676, 3557360681, 3557360687, 'JE', 'JEY', 'جيرسي'),
(90677, 3557360688, 3557360767, 'GB', 'GBR', 'المملكة المتحدة'),
(90678, 3557360768, 3557360895, 'JE', 'JEY', 'جيرسي'),
(90679, 3557360896, 3557360927, 'GB', 'GBR', 'المملكة المتحدة'),
(90680, 3557360928, 3557360943, 'JE', 'JEY', 'جيرسي'),
(90681, 3557360944, 3557360959, 'GB', 'GBR', 'المملكة المتحدة'),
(90682, 3557360960, 3557360967, 'JE', 'JEY', 'جيرسي'),
(90683, 3557360968, 3557360991, 'GB', 'GBR', 'المملكة المتحدة'),
(90684, 3557360992, 3557361023, 'JE', 'JEY', 'جيرسي'),
(90685, 3557361024, 3557361055, 'GB', 'GBR', 'المملكة المتحدة'),
(90686, 3557361056, 3557361151, 'JE', 'JEY', 'جيرسي'),
(90687, 3557361152, 3557361159, 'GB', 'GBR', 'المملكة المتحدة'),
(90688, 3557361160, 3557361167, 'JE', 'JEY', 'جيرسي'),
(90689, 3557361168, 3557361375, 'GB', 'GBR', 'المملكة المتحدة'),
(90690, 3557361376, 3557361391, 'JE', 'JEY', 'جيرسي'),
(90691, 3557361392, 3557361415, 'GB', 'GBR', 'المملكة المتحدة'),
(90692, 3557361416, 3557361423, 'JE', 'JEY', 'جيرسي'),
(90693, 3557361424, 3557361607, 'GB', 'GBR', 'المملكة المتحدة'),
(90694, 3557361608, 3557361615, 'JE', 'JEY', 'جيرسي'),
(90695, 3557361616, 3557361919, 'GB', 'GBR', 'المملكة المتحدة'),
(90696, 3557361920, 3557362175, 'JE', 'JEY', 'جيرسي'),
(90697, 3557362176, 3557363199, 'GB', 'GBR', 'المملكة المتحدة'),
(90698, 3557363200, 3557363455, 'JE', 'JEY', 'جيرسي'),
(90699, 3557363456, 3557363511, 'GB', 'GBR', 'المملكة المتحدة'),
(90700, 3557363512, 3557363783, 'JE', 'JEY', 'جيرسي'),
(90701, 3557363784, 3557363791, 'GB', 'GBR', 'المملكة المتحدة'),
(90702, 3557363792, 3557364223, 'JE', 'JEY', 'جيرسي'),
(90703, 3557364224, 3557364479, 'GB', 'GBR', 'المملكة المتحدة'),
(90704, 3557364480, 3557364495, 'JE', 'JEY', 'جيرسي'),
(90705, 3557364496, 3557364527, 'GB', 'GBR', 'المملكة المتحدة'),
(90706, 3557364528, 3557364535, 'JE', 'JEY', 'جيرسي'),
(90707, 3557364536, 3557364543, 'GB', 'GBR', 'المملكة المتحدة'),
(90708, 3557364544, 3557364559, 'JE', 'JEY', 'جيرسي'),
(90709, 3557364560, 3557364587, 'GB', 'GBR', 'المملكة المتحدة'),
(90710, 3557364588, 3557364607, 'JE', 'JEY', 'جيرسي'),
(90711, 3557364608, 3557364727, 'GB', 'GBR', 'المملكة المتحدة'),
(90712, 3557364728, 3557364732, 'JE', 'JEY', 'جيرسي'),
(90713, 3557364733, 3557364733, 'GB', 'GBR', 'المملكة المتحدة'),
(90714, 3557364734, 3557364735, 'JE', 'JEY', 'جيرسي'),
(90715, 3557364736, 3557364791, 'GB', 'GBR', 'المملكة المتحدة'),
(90716, 3557364792, 3557364847, 'JE', 'JEY', 'جيرسي'),
(90717, 3557364848, 3557364959, 'GB', 'GBR', 'المملكة المتحدة'),
(90718, 3557364960, 3557364975, 'JE', 'JEY', 'جيرسي'),
(90719, 3557364976, 3557364984, 'GB', 'GBR', 'المملكة المتحدة'),
(90720, 3557364985, 3557364991, 'JE', 'JEY', 'جيرسي'),
(90721, 3557364992, 3557365055, 'GB', 'GBR', 'المملكة المتحدة'),
(90722, 3557365056, 3557365103, 'JE', 'JEY', 'جيرسي'),
(90723, 3557365104, 3557365111, 'GB', 'GBR', 'المملكة المتحدة'),
(90724, 3557365112, 3557365119, 'JE', 'JEY', 'جيرسي'),
(90725, 3557365120, 3557365183, 'GB', 'GBR', 'المملكة المتحدة'),
(90726, 3557365184, 3557365215, 'JE', 'JEY', 'جيرسي'),
(90727, 3557365216, 3557365231, 'GB', 'GBR', 'المملكة المتحدة'),
(90728, 3557365232, 3557365247, 'JE', 'JEY', 'جيرسي'),
(90729, 3557365248, 3557365407, 'GB', 'GBR', 'المملكة المتحدة'),
(90730, 3557365408, 3557365503, 'JE', 'JEY', 'جيرسي'),
(90731, 3557365504, 3557365551, 'GB', 'GBR', 'المملكة المتحدة'),
(90732, 3557365552, 3557365559, 'JE', 'JEY', 'جيرسي'),
(90733, 3557365560, 3557365847, 'GB', 'GBR', 'المملكة المتحدة'),
(90734, 3557365848, 3557365863, 'JE', 'JEY', 'جيرسي'),
(90735, 3557365864, 3557365887, 'GB', 'GBR', 'المملكة المتحدة'),
(90736, 3557365888, 3557365895, 'JE', 'JEY', 'جيرسي'),
(90737, 3557365896, 3557365911, 'GB', 'GBR', 'المملكة المتحدة'),
(90738, 3557365912, 3557365919, 'JE', 'JEY', 'جيرسي'),
(90739, 3557365920, 3557365935, 'GB', 'GBR', 'المملكة المتحدة'),
(90740, 3557365936, 3557366015, 'JE', 'JEY', 'جيرسي'),
(90741, 3557366016, 3557367807, 'GB', 'GBR', 'المملكة المتحدة'),
(90742, 3557367808, 3557375999, 'DE', 'DEU', 'ألمانيا'),
(90743, 3557376000, 3557384191, 'ES', 'ESP', 'إسبانيا'),
(90744, 3557384192, 3557392383, 'GB', 'GBR', 'المملكة المتحدة'),
(90745, 3557392384, 3557400575, 'AT', 'AUT', 'النمسا'),
(90746, 3557400576, 3557404703, 'DE', 'DEU', 'ألمانيا'),
(90747, 3557404704, 3557404719, 'CH', 'CHE', 'سويسرا'),
(90748, 3557404720, 3557404735, 'DE', 'DEU', 'ألمانيا'),
(90749, 3557404736, 3557404799, 'CH', 'CHE', 'سويسرا'),
(90750, 3557404800, 3557408767, 'DE', 'DEU', 'ألمانيا'),
(90751, 3557408768, 3557416959, 'GB', 'GBR', 'المملكة المتحدة'),
(90752, 3557416960, 3557425151, 'UA', 'UKR', 'أوكرانيا'),
(90753, 3557425152, 3557490687, 'DK', 'DNK', 'الدنيمارك'),
(90754, 3557490688, 3557507071, 'FR', 'FRA', 'فرنسا'),
(90755, 3557507072, 3557515263, 'GB', 'GBR', 'المملكة المتحدة'),
(90756, 3557515264, 3557523455, 'CZ', 'CZE', 'التشيك'),
(90757, 3557523456, 3557531647, 'RU', 'RUS', 'الإتحاد الروسي'),
(90758, 3557531648, 3557539839, 'SA', 'SAU', 'السعودية'),
(90759, 3557539840, 3557548031, 'SY', 'SYR', 'سوريا'),
(90760, 3557548032, 3557556223, 'DE', 'DEU', 'ألمانيا'),
(90761, 3557556224, 3557564415, 'RU', 'RUS', 'الإتحاد الروسي'),
(90762, 3557564416, 3557570319, 'DE', 'DEU', 'ألمانيا'),
(90763, 3557570320, 3557570335, 'ES', 'ESP', 'إسبانيا'),
(90764, 3557570336, 3557571295, 'DE', 'DEU', 'ألمانيا'),
(90765, 3557571296, 3557571315, 'GB', 'GBR', 'المملكة المتحدة'),
(90766, 3557571316, 3557572607, 'DE', 'DEU', 'ألمانيا'),
(90767, 3557572608, 3557580799, 'RU', 'RUS', 'الإتحاد الروسي'),
(90768, 3557580800, 3557584287, 'DE', 'DEU', 'ألمانيا'),
(90769, 3557584288, 3557584319, 'GB', 'GBR', 'المملكة المتحدة'),
(90770, 3557584320, 3557585151, 'DE', 'DEU', 'ألمانيا'),
(90771, 3557585152, 3557585279, 'CH', 'CHE', 'سويسرا'),
(90772, 3557585280, 3557585695, 'DE', 'DEU', 'ألمانيا'),
(90773, 3557585696, 3557585711, 'CH', 'CHE', 'سويسرا'),
(90774, 3557585712, 3557585887, 'DE', 'DEU', 'ألمانيا'),
(90775, 3557585888, 3557585903, 'CH', 'CHE', 'سويسرا'),
(90776, 3557585904, 3557588991, 'DE', 'DEU', 'ألمانيا'),
(90777, 3557588992, 3557597183, 'TR', 'TUR', 'تركيا'),
(90778, 3557597184, 3557597711, 'SA', 'SAU', 'السعودية'),
(90779, 3557597712, 3557597719, 'AS', 'ASM', 'ساموا الأمريكية'),
(90780, 3557597720, 3557605375, 'SA', 'SAU', 'السعودية'),
(90781, 3557605376, 3557613567, 'LT', 'LTU', 'ليتوانيا'),
(90782, 3557621760, 3557629951, 'RU', 'RUS', 'الإتحاد الروسي'),
(90783, 3557629952, 3557638143, 'PT', 'PRT', 'البورتوغال'),
(90784, 3557638144, 3557646335, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(90785, 3557646336, 3557654527, 'RU', 'RUS', 'الإتحاد الروسي'),
(90786, 3557654528, 3557670911, 'KZ', 'KAZ', 'كازاخستان'),
(90787, 3557670912, 3557679103, 'GB', 'GBR', 'المملكة المتحدة'),
(90788, 3557679104, 3557687295, 'SI', 'SVN', 'سلوفينيا'),
(90789, 3557687296, 3557703679, 'PL', 'POL', 'بولندا'),
(90790, 3557703680, 3557711871, 'DE', 'DEU', 'ألمانيا'),
(90791, 3557711872, 3557720063, 'ES', 'ESP', 'إسبانيا'),
(90792, 3557720064, 3557728255, 'IT', 'ITA', 'إيطاليا'),
(90793, 3557728256, 3557744639, 'RU', 'RUS', 'الإتحاد الروسي'),
(90794, 3557744640, 3557752831, 'PS', 'PSE', 'فلسطين المحتلة'),
(90795, 3557752832, 3557761023, 'TR', 'TUR', 'تركيا'),
(90796, 3557761024, 3557769215, 'RU', 'RUS', 'الإتحاد الروسي'),
(90797, 3557769216, 3557777407, 'GB', 'GBR', 'المملكة المتحدة'),
(90798, 3557777408, 3557785599, 'RU', 'RUS', 'الإتحاد الروسي'),
(90799, 3557785600, 3557793791, 'UA', 'UKR', 'أوكرانيا'),
(90800, 3557793792, 3557801983, 'HR', 'HRV', 'كرواتيا'),
(90801, 3557801984, 3557810175, 'DE', 'DEU', 'ألمانيا'),
(90802, 3557810176, 3557818367, 'ES', 'ESP', 'إسبانيا'),
(90803, 3557818368, 3557826559, 'RU', 'RUS', 'الإتحاد الروسي'),
(90804, 3557826560, 3557834751, 'AT', 'AUT', 'النمسا'),
(90805, 3557834752, 3557842943, 'IR', 'IRN', 'إيران'),
(90806, 3557842944, 3557851135, 'FI', 'FIN', 'فنلندا'),
(90807, 3557851136, 3557859327, 'HU', 'HUN', 'هنغاريا'),
(90808, 3557859328, 3557867519, 'SE', 'SWE', 'السويد'),
(90809, 3557867520, 3557875711, 'RU', 'RUS', 'الإتحاد الروسي'),
(90810, 3557875712, 3557883903, 'DE', 'DEU', 'ألمانيا'),
(90811, 3557883904, 3557892095, 'RU', 'RUS', 'الإتحاد الروسي'),
(90812, 3557892096, 3557900287, 'IE', 'IRL', 'إيرلندا'),
(90813, 3557900288, 3557916671, 'AT', 'AUT', 'النمسا'),
(90814, 3557916672, 3557924863, 'NO', 'NOR', 'النرويج'),
(90815, 3557924864, 3557933055, 'FI', 'FIN', 'فنلندا'),
(90816, 3557933056, 3557941247, 'IT', 'ITA', 'إيطاليا'),
(90817, 3557941248, 3557945183, 'DE', 'DEU', 'ألمانيا'),
(90818, 3557945184, 3557945199, 'GB', 'GBR', 'المملكة المتحدة'),
(90819, 3557945200, 3557957631, 'DE', 'DEU', 'ألمانيا'),
(90820, 3557957632, 3557960975, 'SI', 'SVN', 'سلوفينيا'),
(90821, 3557960976, 3557960983, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90822, 3557960984, 3557961375, 'SI', 'SVN', 'سلوفينيا'),
(90823, 3557961376, 3557961407, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(90824, 3557961408, 3557965823, 'SI', 'SVN', 'سلوفينيا'),
(90825, 3557965824, 3557974015, 'DE', 'DEU', 'ألمانيا'),
(90826, 3557974016, 3557982207, 'CH', 'CHE', 'سويسرا'),
(90827, 3557982208, 3557990399, 'NO', 'NOR', 'النرويج'),
(90828, 3557990400, 3557998591, 'PT', 'PRT', 'البورتوغال'),
(90829, 3557998592, 3558006783, 'DE', 'DEU', 'ألمانيا'),
(90830, 3558006784, 3558014975, 'GB', 'GBR', 'المملكة المتحدة'),
(90831, 3558014976, 3558023167, 'RU', 'RUS', 'الإتحاد الروسي'),
(90832, 3558023168, 3558023199, 'GB', 'GBR', 'المملكة المتحدة'),
(90833, 3558023200, 3558030655, 'DE', 'DEU', 'ألمانيا'),
(90834, 3558030656, 3558030659, 'CH', 'CHE', 'سويسرا'),
(90835, 3558030660, 3558031359, 'DE', 'DEU', 'ألمانيا'),
(90836, 3558031360, 3558039551, 'GB', 'GBR', 'المملكة المتحدة'),
(90837, 3558039552, 3558047743, 'IT', 'ITA', 'إيطاليا'),
(90838, 3558047744, 3558055935, 'KZ', 'KAZ', 'كازاخستان'),
(90839, 3558055936, 3558064127, 'FR', 'FRA', 'فرنسا'),
(90840, 3558064128, 3558067839, 'NL', 'NLD', 'هولندا'),
(90841, 3558067840, 3558067855, 'US', 'USA', 'الولايات المتحدة'),
(90842, 3558067856, 3558080511, 'NL', 'NLD', 'هولندا'),
(90843, 3558080512, 3558096895, 'RU', 'RUS', 'الإتحاد الروسي'),
(90844, 3558096896, 3558113279, 'CZ', 'CZE', 'التشيك'),
(90845, 3558113280, 3558122767, 'DE', 'DEU', 'ألمانيا'),
(90846, 3558122768, 3558122783, 'CH', 'CHE', 'سويسرا'),
(90847, 3558122784, 3558129663, 'DE', 'DEU', 'ألمانيا'),
(90848, 3558129664, 3558137855, 'NO', 'NOR', 'النرويج'),
(90849, 3558137856, 3558146047, 'GB', 'GBR', 'المملكة المتحدة'),
(90850, 3558146048, 3558154239, 'RU', 'RUS', 'الإتحاد الروسي'),
(90851, 3558154240, 3558154367, 'NG', 'NGA', 'نيجيريا'),
(90852, 3558154368, 3558154495, 'SD', 'SDN', 'السودان'),
(90853, 3558154496, 3558154623, 'MZ', 'MOZ', 'موزامبيق'),
(90854, 3558154624, 3558154751, 'CI', 'CIV', 'كوت ديفوار'),
(90855, 3558154752, 3558154879, 'CM', 'CMR', 'الكاميرون'),
(90856, 3558154880, 3558155007, 'SD', 'SDN', 'السودان'),
(90857, 3558155008, 3558155135, 'DE', 'DEU', 'ألمانيا'),
(90858, 3558155136, 3558155263, 'SD', 'SDN', 'السودان'),
(90859, 3558155264, 3558155391, 'ET', 'ETH', 'إثيوبيا'),
(90860, 3558155392, 3558155519, 'DE', 'DEU', 'ألمانيا'),
(90861, 3558155520, 3558156031, 'SD', 'SDN', 'السودان'),
(90862, 3558156032, 3558156032, 'DE', 'DEU', 'ألمانيا'),
(90863, 3558156033, 3558156287, 'KG', 'KGZ', 'قيرغيزستان'),
(90864, 3558156288, 3558170623, 'DE', 'DEU', 'ألمانيا'),
(90865, 3558170624, 3558178815, 'GB', 'GBR', 'المملكة المتحدة'),
(90866, 3558178816, 3558187007, 'BG', 'BGR', 'بلغاريا'),
(90867, 3558187008, 3558195199, 'DE', 'DEU', 'ألمانيا'),
(90868, 3558195200, 3558195455, 'BE', 'BEL', 'بلجيكا'),
(90869, 3558195456, 3558196031, 'ES', 'ESP', 'إسبانيا'),
(90870, 3558196032, 3558196035, 'IT', 'ITA', 'إيطاليا'),
(90871, 3558196036, 3558196039, 'ES', 'ESP', 'إسبانيا'),
(90872, 3558196040, 3558196047, 'IT', 'ITA', 'إيطاليا'),
(90873, 3558196048, 3558196119, 'ES', 'ESP', 'إسبانيا'),
(90874, 3558196120, 3558196127, 'IT', 'ITA', 'إيطاليا'),
(90875, 3558196128, 3558196159, 'ES', 'ESP', 'إسبانيا'),
(90876, 3558196160, 3558196167, 'IT', 'ITA', 'إيطاليا'),
(90877, 3558196168, 3558196175, 'ES', 'ESP', 'إسبانيا'),
(90878, 3558196176, 3558196191, 'IT', 'ITA', 'إيطاليا'),
(90879, 3558196192, 3558196199, 'ES', 'ESP', 'إسبانيا'),
(90880, 3558196200, 3558196271, 'IT', 'ITA', 'إيطاليا'),
(90881, 3558196272, 3558196351, 'ES', 'ESP', 'إسبانيا'),
(90882, 3558196352, 3558196415, 'IT', 'ITA', 'إيطاليا'),
(90883, 3558196416, 3558196543, 'ES', 'ESP', 'إسبانيا'),
(90884, 3558196544, 3558196607, 'IT', 'ITA', 'إيطاليا'),
(90885, 3558196608, 3558196719, 'ES', 'ESP', 'إسبانيا'),
(90886, 3558196720, 3558196727, 'IT', 'ITA', 'إيطاليا'),
(90887, 3558196728, 3558196735, 'ES', 'ESP', 'إسبانيا'),
(90888, 3558196736, 3558203391, 'US', 'USA', 'الولايات المتحدة'),
(90889, 3558203392, 3558211583, 'ES', 'ESP', 'إسبانيا'),
(90890, 3558211584, 3558219775, 'GB', 'GBR', 'المملكة المتحدة'),
(90891, 3558219776, 3558227967, 'ES', 'ESP', 'إسبانيا'),
(90892, 3558227968, 3558236159, 'RU', 'RUS', 'الإتحاد الروسي'),
(90893, 3558236160, 3558244351, 'GB', 'GBR', 'المملكة المتحدة'),
(90894, 3558244352, 3558252543, 'IT', 'ITA', 'إيطاليا'),
(90895, 3558260736, 3558268927, 'UA', 'UKR', 'أوكرانيا'),
(90896, 3558268928, 3558269439, 'GB', 'GBR', 'المملكة المتحدة'),
(90897, 3558269440, 3558269951, 'GI', 'GIB', 'جبل طارق'),
(90898, 3558269952, 3558270463, 'GB', 'GBR', 'المملكة المتحدة'),
(90899, 3558270464, 3558271231, 'GI', 'GIB', 'جبل طارق'),
(90900, 3558271232, 3558271487, 'GB', 'GBR', 'المملكة المتحدة'),
(90901, 3558271488, 3558276095, 'GI', 'GIB', 'جبل طارق'),
(90902, 3558276096, 3558276863, 'GB', 'GBR', 'المملكة المتحدة'),
(90903, 3558276864, 3558277119, 'GI', 'GIB', 'جبل طارق'),
(90904, 3558277120, 3558285567, 'GB', 'GBR', 'المملكة المتحدة'),
(90905, 3558285568, 3558285823, 'DE', 'DEU', 'ألمانيا'),
(90906, 3558285824, 3558285951, 'GB', 'GBR', 'المملكة المتحدة'),
(90907, 3558285952, 3558286079, 'DE', 'DEU', 'ألمانيا'),
(90908, 3558286080, 3558286591, 'GB', 'GBR', 'المملكة المتحدة'),
(90909, 3558286592, 3558286655, 'FR', 'FRA', 'فرنسا'),
(90910, 3558286656, 3558286719, 'GB', 'GBR', 'المملكة المتحدة'),
(90911, 3558286720, 3558286847, 'FR', 'FRA', 'فرنسا'),
(90912, 3558286848, 3558287679, 'GB', 'GBR', 'المملكة المتحدة'),
(90913, 3558287680, 3558287743, 'BE', 'BEL', 'بلجيكا'),
(90914, 3558287744, 3558287871, 'NL', 'NLD', 'هولندا'),
(90915, 3558287872, 3558287935, 'FR', 'FRA', 'فرنسا'),
(90916, 3558287936, 3558287999, 'IT', 'ITA', 'إيطاليا'),
(90917, 3558288000, 3558288063, 'DE', 'DEU', 'ألمانيا'),
(90918, 3558288064, 3558288127, 'ES', 'ESP', 'إسبانيا'),
(90919, 3558288128, 3558288191, 'AT', 'AUT', 'النمسا'),
(90920, 3558288192, 3558288255, 'SE', 'SWE', 'السويد'),
(90921, 3558288256, 3558288319, 'US', 'USA', 'الولايات المتحدة'),
(90922, 3558288320, 3558288383, 'CH', 'CHE', 'سويسرا'),
(90923, 3558288384, 3558288423, 'US', 'USA', 'الولايات المتحدة'),
(90924, 3558288424, 3558288447, 'GB', 'GBR', 'المملكة المتحدة'),
(90925, 3558288448, 3558288483, 'US', 'USA', 'الولايات المتحدة'),
(90926, 3558288484, 3558288487, 'GB', 'GBR', 'المملكة المتحدة'),
(90927, 3558288488, 3558288639, 'US', 'USA', 'الولايات المتحدة'),
(90928, 3558288640, 3558288671, 'BE', 'BEL', 'بلجيكا'),
(90929, 3558288672, 3558288687, 'DE', 'DEU', 'ألمانيا'),
(90930, 3558288688, 3558288703, 'BE', 'BEL', 'بلجيكا'),
(90931, 3558288704, 3558288719, 'GB', 'GBR', 'المملكة المتحدة'),
(90932, 3558288720, 3558288895, 'BE', 'BEL', 'بلجيكا'),
(90933, 3558288896, 3558289103, 'FR', 'FRA', 'فرنسا'),
(90934, 3558289104, 3558289119, 'GB', 'GBR', 'المملكة المتحدة'),
(90935, 3558289120, 3558289151, 'FR', 'FRA', 'فرنسا'),
(90936, 3558289152, 3558289407, 'GB', 'GBR', 'المملكة المتحدة'),
(90937, 3558289408, 3558289663, 'NL', 'NLD', 'هولندا'),
(90938, 3558289664, 3558289747, 'IT', 'ITA', 'إيطاليا'),
(90939, 3558289748, 3558289751, 'GB', 'GBR', 'المملكة المتحدة'),
(90940, 3558289752, 3558289775, 'IT', 'ITA', 'إيطاليا'),
(90941, 3558289776, 3558289783, 'GB', 'GBR', 'المملكة المتحدة'),
(90942, 3558289784, 3558289919, 'IT', 'ITA', 'إيطاليا'),
(90943, 3558289920, 3558290175, 'CZ', 'CZE', 'التشيك'),
(90944, 3558290176, 3558290431, 'GB', 'GBR', 'المملكة المتحدة'),
(90945, 3558290432, 3558290575, 'BE', 'BEL', 'بلجيكا'),
(90946, 3558290576, 3558290591, 'GB', 'GBR', 'المملكة المتحدة'),
(90947, 3558290592, 3558290599, 'BE', 'BEL', 'بلجيكا'),
(90948, 3558290600, 3558290655, 'GB', 'GBR', 'المملكة المتحدة'),
(90949, 3558290656, 3558290663, 'BE', 'BEL', 'بلجيكا'),
(90950, 3558290664, 3558290671, 'GB', 'GBR', 'المملكة المتحدة'),
(90951, 3558290672, 3558290687, 'BE', 'BEL', 'بلجيكا'),
(90952, 3558290688, 3558290871, 'ES', 'ESP', 'إسبانيا'),
(90953, 3558290872, 3558290879, 'GB', 'GBR', 'المملكة المتحدة'),
(90954, 3558290880, 3558290943, 'ES', 'ESP', 'إسبانيا'),
(90955, 3558290944, 3558290959, 'DE', 'DEU', 'ألمانيا'),
(90956, 3558290960, 3558290967, 'NL', 'NLD', 'هولندا'),
(90957, 3558290968, 3558290975, 'GB', 'GBR', 'المملكة المتحدة'),
(90958, 3558290976, 3558290991, 'NL', 'NLD', 'هولندا'),
(90959, 3558290992, 3558291023, 'DE', 'DEU', 'ألمانيا'),
(90960, 3558291024, 3558291031, 'SE', 'SWE', 'السويد'),
(90961, 3558291032, 3558291135, 'DE', 'DEU', 'ألمانيا'),
(90962, 3558291136, 3558291199, 'GB', 'GBR', 'المملكة المتحدة'),
(90963, 3558291200, 3558291215, 'CH', 'CHE', 'سويسرا'),
(90964, 3558291216, 3558291231, 'AT', 'AUT', 'النمسا'),
(90965, 3558291232, 3558291239, 'CH', 'CHE', 'سويسرا'),
(90966, 3558291240, 3558291247, 'GB', 'GBR', 'المملكة المتحدة'),
(90967, 3558291248, 3558291263, 'CH', 'CHE', 'سويسرا'),
(90968, 3558291264, 3558291279, 'AT', 'AUT', 'النمسا'),
(90969, 3558291280, 3558291295, 'GB', 'GBR', 'المملكة المتحدة'),
(90970, 3558291296, 3558291455, 'CH', 'CHE', 'سويسرا'),
(90971, 3558291456, 3558292223, 'GB', 'GBR', 'المملكة المتحدة'),
(90972, 3558292224, 3558292287, 'SE', 'SWE', 'السويد'),
(90973, 3558292288, 3558292543, 'NL', 'NLD', 'هولندا'),
(90974, 3558292544, 3558292607, 'GB', 'GBR', 'المملكة المتحدة'),
(90975, 3558292608, 3558292735, 'NL', 'NLD', 'هولندا'),
(90976, 3558292736, 3558292863, 'GB', 'GBR', 'المملكة المتحدة'),
(90977, 3558292864, 3558292871, 'DE', 'DEU', 'ألمانيا'),
(90978, 3558292872, 3558292991, 'NL', 'NLD', 'هولندا'),
(90979, 3558292992, 3558293247, 'GB', 'GBR', 'المملكة المتحدة'),
(90980, 3558293248, 3558293503, 'NL', 'NLD', 'هولندا'),
(90981, 3558293504, 3558301695, 'RU', 'RUS', 'الإتحاد الروسي'),
(90982, 3558301696, 3558310319, 'DE', 'DEU', 'ألمانيا'),
(90983, 3558310320, 3558310327, 'CH', 'CHE', 'سويسرا'),
(90984, 3558310328, 3558310511, 'DE', 'DEU', 'ألمانيا'),
(90985, 3558310512, 3558310519, 'CH', 'CHE', 'سويسرا'),
(90986, 3558310520, 3558312791, 'DE', 'DEU', 'ألمانيا'),
(90987, 3558312792, 3558312799, 'CH', 'CHE', 'سويسرا'),
(90988, 3558312800, 3558318079, 'DE', 'DEU', 'ألمانيا'),
(90989, 3558318080, 3558319889, 'FR', 'FRA', 'فرنسا'),
(90990, 3558319890, 3558319891, 'ES', 'ESP', 'إسبانيا'),
(90991, 3558319892, 3558334463, 'FR', 'FRA', 'فرنسا'),
(90992, 3558334464, 3558334935, 'CH', 'CHE', 'سويسرا'),
(90993, 3558334936, 3558334943, 'FR', 'FRA', 'فرنسا'),
(90994, 3558334944, 3558335499, 'CH', 'CHE', 'سويسرا'),
(90995, 3558335500, 3558335503, 'DE', 'DEU', 'ألمانيا'),
(90996, 3558335504, 3558335511, 'CH', 'CHE', 'سويسرا'),
(90997, 3558335512, 3558335519, 'DE', 'DEU', 'ألمانيا'),
(90998, 3558335520, 3558337515, 'CH', 'CHE', 'سويسرا'),
(90999, 3558337516, 3558337519, 'ES', 'ESP', 'إسبانيا'),
(91000, 3558337520, 3558337783, 'CH', 'CHE', 'سويسرا'),
(91001, 3558337784, 3558337787, 'DE', 'DEU', 'ألمانيا'),
(91002, 3558337788, 3558339359, 'CH', 'CHE', 'سويسرا'),
(91003, 3558339360, 3558339367, 'ES', 'ESP', 'إسبانيا'),
(91004, 3558339368, 3558339699, 'CH', 'CHE', 'سويسرا'),
(91005, 3558339700, 3558339703, 'DE', 'DEU', 'ألمانيا'),
(91006, 3558339704, 3558340039, 'CH', 'CHE', 'سويسرا'),
(91007, 3558340040, 3558340043, 'DE', 'DEU', 'ألمانيا'),
(91008, 3558340044, 3558342655, 'CH', 'CHE', 'سويسرا'),
(91009, 3558342656, 3558350847, 'IT', 'ITA', 'إيطاليا'),
(91010, 3558350848, 3558359039, 'RU', 'RUS', 'الإتحاد الروسي'),
(91011, 3558359040, 3558367231, 'GB', 'GBR', 'المملكة المتحدة'),
(91012, 3558367232, 3558367271, 'AT', 'AUT', 'النمسا'),
(91013, 3558367272, 3558367279, 'GI', 'GIB', 'جبل طارق'),
(91014, 3558367280, 3558368015, 'AT', 'AUT', 'النمسا'),
(91015, 3558368016, 3558368031, 'AR', 'ARG', 'الأرجنتين'),
(91016, 3558368032, 3558368063, 'CL', 'CHL', 'تشيلي'),
(91017, 3558368064, 3558368079, 'ES', 'ESP', 'إسبانيا'),
(91018, 3558368080, 3558368095, 'DE', 'DEU', 'ألمانيا'),
(91019, 3558368096, 3558368111, 'US', 'USA', 'الولايات المتحدة'),
(91020, 3558368112, 3558368127, 'GB', 'GBR', 'المملكة المتحدة'),
(91021, 3558368128, 3558368159, 'AT', 'AUT', 'النمسا'),
(91022, 3558368160, 3558368191, 'DE', 'DEU', 'ألمانيا'),
(91023, 3558368192, 3558368207, 'US', 'USA', 'الولايات المتحدة'),
(91024, 3558368208, 3558368223, 'GB', 'GBR', 'المملكة المتحدة'),
(91025, 3558368224, 3558368239, 'ES', 'ESP', 'إسبانيا'),
(91026, 3558368240, 3558368255, 'AR', 'ARG', 'الأرجنتين'),
(91027, 3558368256, 3558368271, 'AT', 'AUT', 'النمسا'),
(91028, 3558368272, 3558368287, 'GB', 'GBR', 'المملكة المتحدة'),
(91029, 3558368288, 3558368319, 'CL', 'CHL', 'تشيلي'),
(91030, 3558368320, 3558368383, 'AR', 'ARG', 'الأرجنتين'),
(91031, 3558368384, 3558368447, 'AT', 'AUT', 'النمسا'),
(91032, 3558368448, 3558368479, 'DE', 'DEU', 'ألمانيا'),
(91033, 3558368480, 3558368495, 'ES', 'ESP', 'إسبانيا'),
(91034, 3558368496, 3558368511, 'US', 'USA', 'الولايات المتحدة'),
(91035, 3558368512, 3558369503, 'AT', 'AUT', 'النمسا'),
(91036, 3558369504, 3558369519, 'FR', 'FRA', 'فرنسا'),
(91037, 3558369520, 3558372351, 'AT', 'AUT', 'النمسا'),
(91038, 3558372352, 3558372607, 'BG', 'BGR', 'بلغاريا'),
(91039, 3558372608, 3558372735, 'AT', 'AUT', 'النمسا'),
(91040, 3558372736, 3558372863, 'ES', 'ESP', 'إسبانيا'),
(91041, 3558372864, 3558375423, 'AT', 'AUT', 'النمسا'),
(91042, 3558375424, 3558383615, 'CZ', 'CZE', 'التشيك'),
(91043, 3558383616, 3558391807, 'HU', 'HUN', 'هنغاريا'),
(91044, 3558391808, 3558399999, 'LU', 'LUX', 'لوكسيمبورغ'),
(91045, 3558400000, 3558408191, 'SA', 'SAU', 'السعودية'),
(91046, 3558408192, 3558412095, 'CH', 'CHE', 'سويسرا'),
(91047, 3558412096, 3558412103, 'GB', 'GBR', 'المملكة المتحدة'),
(91048, 3558412104, 3558416383, 'CH', 'CHE', 'سويسرا'),
(91049, 3558416384, 3558424575, 'BG', 'BGR', 'بلغاريا'),
(91050, 3558424576, 3558440959, 'IL', 'ISR', 'إسرائيل'),
(91051, 3558449152, 3558457343, 'IT', 'ITA', 'إيطاليا'),
(91052, 3558457344, 3558457407, 'BE', 'BEL', 'بلجيكا'),
(91053, 3558457408, 3558457599, 'GB', 'GBR', 'المملكة المتحدة'),
(91054, 3558457600, 3558457727, 'FR', 'FRA', 'فرنسا'),
(91055, 3558457728, 3558465535, 'NL', 'NLD', 'هولندا'),
(91056, 3558465536, 3558473727, 'GB', 'GBR', 'المملكة المتحدة'),
(91057, 3558473728, 3558506495, 'SA', 'SAU', 'السعودية'),
(91058, 3558506496, 3558514687, 'UA', 'UKR', 'أوكرانيا'),
(91059, 3558514688, 3558522879, 'SK', 'SVK', 'سلوفاكيا'),
(91060, 3558522880, 3558531071, 'NL', 'NLD', 'هولندا'),
(91061, 3558531072, 3558539263, 'RU', 'RUS', 'الإتحاد الروسي'),
(91062, 3558539264, 3558543359, 'SE', 'SWE', 'السويد'),
(91063, 3558543360, 3558547455, 'DK', 'DNK', 'الدنيمارك'),
(91064, 3558547456, 3558555647, 'FR', 'FRA', 'فرنسا'),
(91065, 3558555648, 3558572031, 'AT', 'AUT', 'النمسا'),
(91066, 3558572032, 3558580223, 'DE', 'DEU', 'ألمانيا'),
(91067, 3558580224, 3558581119, 'CH', 'CHE', 'سويسرا'),
(91068, 3558581120, 3558581151, 'DE', 'DEU', 'ألمانيا'),
(91069, 3558581152, 3558581423, 'CH', 'CHE', 'سويسرا'),
(91070, 3558581424, 3558581439, 'DE', 'DEU', 'ألمانيا'),
(91071, 3558581440, 3558586303, 'CH', 'CHE', 'سويسرا'),
(91072, 3558586304, 3558586335, 'NL', 'NLD', 'هولندا'),
(91073, 3558586336, 3558588415, 'CH', 'CHE', 'سويسرا'),
(91074, 3558588416, 3558596607, 'CZ', 'CZE', 'التشيك'),
(91075, 3558596608, 3558604799, 'EE', 'EST', 'إستونيا'),
(91076, 3558604800, 3558612991, 'GB', 'GBR', 'المملكة المتحدة'),
(91077, 3558612992, 3558621183, 'DE', 'DEU', 'ألمانيا'),
(91078, 3558621184, 3558629375, 'MD', 'MDA', 'مولدوفا'),
(91079, 3558629376, 3558637567, 'DE', 'DEU', 'ألمانيا'),
(91080, 3558637568, 3558645759, 'CH', 'CHE', 'سويسرا'),
(91081, 3558645760, 3558653951, 'IT', 'ITA', 'إيطاليا'),
(91082, 3558653952, 3558662143, 'SE', 'SWE', 'السويد'),
(91083, 3558662144, 3558670335, 'LB', 'LBN', 'لبنان'),
(91084, 3558670336, 3558686719, 'DE', 'DEU', 'ألمانيا'),
(91085, 3558686720, 3558703103, 'TR', 'TUR', 'تركيا'),
(91086, 3558703104, 3558711295, 'IT', 'ITA', 'إيطاليا'),
(91087, 3558711296, 3558719487, 'NL', 'NLD', 'هولندا'),
(91088, 3558719488, 3558735871, 'IL', 'ISR', 'إسرائيل'),
(91089, 3558735872, 3558744063, 'GB', 'GBR', 'المملكة المتحدة'),
(91090, 3558744064, 3558752255, 'LB', 'LBN', 'لبنان'),
(91091, 3558752256, 3558760447, 'SI', 'SVN', 'سلوفينيا'),
(91092, 3558760448, 3558768639, 'FR', 'FRA', 'فرنسا'),
(91093, 3558768640, 3558785023, 'RU', 'RUS', 'الإتحاد الروسي'),
(91094, 3558785024, 3558801407, 'IS', 'ISL', 'أيسلندا'),
(91095, 3558801408, 3558809599, 'TR', 'TUR', 'تركيا'),
(91096, 3558809600, 3558817791, 'ES', 'ESP', 'إسبانيا'),
(91097, 3558817792, 3558821655, 'AT', 'AUT', 'النمسا'),
(91098, 3558821656, 3558821663, 'DE', 'DEU', 'ألمانيا'),
(91099, 3558821664, 3558821795, 'AT', 'AUT', 'النمسا'),
(91100, 3558821796, 3558821799, 'DE', 'DEU', 'ألمانيا'),
(91101, 3558821800, 3558821823, 'AT', 'AUT', 'النمسا'),
(91102, 3558821824, 3558821831, 'DE', 'DEU', 'ألمانيا'),
(91103, 3558821832, 3558825983, 'AT', 'AUT', 'النمسا'),
(91104, 3558825984, 3558832383, 'CY', 'CYP', 'قبرص'),
(91105, 3558832384, 3558832639, 'LB', 'LBN', 'لبنان'),
(91106, 3558832640, 3558834175, 'CY', 'CYP', 'قبرص'),
(91107, 3558834176, 3558842367, 'FR', 'FRA', 'فرنسا'),
(91108, 3558842368, 3558850559, 'SE', 'SWE', 'السويد'),
(91109, 3558850560, 3558850815, 'ES', 'ESP', 'إسبانيا'),
(91110, 3558850816, 3558851327, 'US', 'USA', 'الولايات المتحدة'),
(91111, 3558851328, 3558851359, 'ES', 'ESP', 'إسبانيا'),
(91112, 3558851360, 3558851391, 'GB', 'GBR', 'المملكة المتحدة'),
(91113, 3558851392, 3558851471, 'ES', 'ESP', 'إسبانيا'),
(91114, 3558851472, 3558851479, 'NO', 'NOR', 'النرويج'),
(91115, 3558851480, 3558853119, 'ES', 'ESP', 'إسبانيا'),
(91116, 3558853120, 3558853375, 'BE', 'BEL', 'بلجيكا'),
(91117, 3558853376, 3558853399, 'ES', 'ESP', 'إسبانيا'),
(91118, 3558853400, 3558853407, 'DE', 'DEU', 'ألمانيا'),
(91119, 3558853408, 3558853439, 'ES', 'ESP', 'إسبانيا'),
(91120, 3558853440, 3558853455, 'DE', 'DEU', 'ألمانيا'),
(91121, 3558853456, 3558853463, 'ES', 'ESP', 'إسبانيا'),
(91122, 3558853464, 3558853467, 'DE', 'DEU', 'ألمانيا'),
(91123, 3558853468, 3558853503, 'ES', 'ESP', 'إسبانيا'),
(91124, 3558853504, 3558853511, 'DE', 'DEU', 'ألمانيا'),
(91125, 3558853512, 3558853535, 'ES', 'ESP', 'إسبانيا'),
(91126, 3558853536, 3558853547, 'DE', 'DEU', 'ألمانيا'),
(91127, 3558853548, 3558854655, 'ES', 'ESP', 'إسبانيا'),
(91128, 3558854656, 3558854911, 'US', 'USA', 'الولايات المتحدة'),
(91129, 3558854912, 3558854975, 'ES', 'ESP', 'إسبانيا'),
(91130, 3558854976, 3558855039, 'US', 'USA', 'الولايات المتحدة'),
(91131, 3558855040, 3558855167, 'GB', 'GBR', 'المملكة المتحدة'),
(91132, 3558855168, 3558855183, 'US', 'USA', 'الولايات المتحدة'),
(91133, 3558855184, 3558855423, 'ES', 'ESP', 'إسبانيا'),
(91134, 3558855424, 3558855431, 'NL', 'NLD', 'هولندا'),
(91135, 3558855432, 3558855935, 'ES', 'ESP', 'إسبانيا'),
(91136, 3558855936, 3558856191, 'US', 'USA', 'الولايات المتحدة'),
(91137, 3558856192, 3558856575, 'GB', 'GBR', 'المملكة المتحدة'),
(91138, 3558856576, 3558856639, 'ES', 'ESP', 'إسبانيا'),
(91139, 3558856640, 3558856703, 'NL', 'NLD', 'هولندا'),
(91140, 3558856704, 3558858751, 'US', 'USA', 'الولايات المتحدة'),
(91141, 3558858752, 3558860967, 'IT', 'ITA', 'إيطاليا'),
(91142, 3558860968, 3558860975, 'IE', 'IRL', 'إيرلندا'),
(91143, 3558860976, 3558864695, 'IT', 'ITA', 'إيطاليا'),
(91144, 3558864696, 3558864703, 'GB', 'GBR', 'المملكة المتحدة'),
(91145, 3558864704, 3558866943, 'IT', 'ITA', 'إيطاليا'),
(91146, 3558866944, 3558899711, 'GB', 'GBR', 'المملكة المتحدة'),
(91147, 3558899712, 3558916095, 'SE', 'SWE', 'السويد'),
(91148, 3558916096, 3558924287, 'RU', 'RUS', 'الإتحاد الروسي'),
(91149, 3558924288, 3558932479, 'NL', 'NLD', 'هولندا'),
(91150, 3558932480, 3558940671, 'RU', 'RUS', 'الإتحاد الروسي'),
(91151, 3558940672, 3558948863, 'AT', 'AUT', 'النمسا'),
(91152, 3558948864, 3558957055, 'PL', 'POL', 'بولندا'),
(91153, 3558957056, 3558965247, 'PS', 'PSE', 'فلسطين المحتلة'),
(91154, 3558965248, 3558973439, 'NO', 'NOR', 'النرويج'),
(91155, 3558973440, 3558981631, 'SA', 'SAU', 'السعودية'),
(91156, 3558981632, 3558989823, 'IR', 'IRN', 'إيران'),
(91157, 3558989824, 3558998015, 'RU', 'RUS', 'الإتحاد الروسي'),
(91158, 3558998016, 3559006207, 'JO', 'JOR', 'الأردن'),
(91159, 3559006208, 3559014399, 'RU', 'RUS', 'الإتحاد الروسي'),
(91160, 3559014400, 3559016191, 'DE', 'DEU', 'ألمانيا'),
(91161, 3559016192, 3559016207, 'GB', 'GBR', 'المملكة المتحدة'),
(91162, 3559016208, 3559022591, 'DE', 'DEU', 'ألمانيا'),
(91163, 3559022592, 3559030783, 'RU', 'RUS', 'الإتحاد الروسي'),
(91164, 3559030784, 3559038720, 'ES', 'ESP', 'إسبانيا'),
(91165, 3559038721, 3559038975, 'US', 'USA', 'الولايات المتحدة'),
(91166, 3559038976, 3559047167, 'DE', 'DEU', 'ألمانيا'),
(91167, 3559047168, 3559055359, 'IT', 'ITA', 'إيطاليا'),
(91168, 3559055360, 3559063551, 'AM', 'ARM', 'أرمينيا'),
(91169, 3559063552, 3559079935, 'CH', 'CHE', 'سويسرا'),
(91170, 3559079936, 3559088127, 'JO', 'JOR', 'الأردن'),
(91171, 3559088128, 3559088255, 'BE', 'BEL', 'بلجيكا'),
(91172, 3559088256, 3559088259, 'GB', 'GBR', 'المملكة المتحدة'),
(91173, 3559088260, 3559088367, 'BE', 'BEL', 'بلجيكا'),
(91174, 3559088368, 3559088371, 'GB', 'GBR', 'المملكة المتحدة'),
(91175, 3559088372, 3559089055, 'BE', 'BEL', 'بلجيكا'),
(91176, 3559089056, 3559089063, 'DE', 'DEU', 'ألمانيا'),
(91177, 3559089064, 3559089607, 'BE', 'BEL', 'بلجيكا'),
(91178, 3559089608, 3559089611, 'GB', 'GBR', 'المملكة المتحدة'),
(91179, 3559089612, 3559089623, 'BE', 'BEL', 'بلجيكا'),
(91180, 3559089624, 3559089627, 'GB', 'GBR', 'المملكة المتحدة'),
(91181, 3559089628, 3559089639, 'BE', 'BEL', 'بلجيكا'),
(91182, 3559089640, 3559089643, 'GB', 'GBR', 'المملكة المتحدة'),
(91183, 3559089644, 3559090071, 'BE', 'BEL', 'بلجيكا'),
(91184, 3559090072, 3559090079, 'NL', 'NLD', 'هولندا'),
(91185, 3559090080, 3559090519, 'BE', 'BEL', 'بلجيكا'),
(91186, 3559090520, 3559090527, 'GB', 'GBR', 'المملكة المتحدة'),
(91187, 3559090528, 3559090815, 'BE', 'BEL', 'بلجيكا'),
(91188, 3559090816, 3559090823, 'GB', 'GBR', 'المملكة المتحدة'),
(91189, 3559090824, 3559090895, 'BE', 'BEL', 'بلجيكا'),
(91190, 3559090896, 3559090899, 'GB', 'GBR', 'المملكة المتحدة'),
(91191, 3559090900, 3559090923, 'BE', 'BEL', 'بلجيكا'),
(91192, 3559090924, 3559090927, 'GB', 'GBR', 'المملكة المتحدة'),
(91193, 3559090928, 3559091111, 'BE', 'BEL', 'بلجيكا'),
(91194, 3559091112, 3559091115, 'GB', 'GBR', 'المملكة المتحدة'),
(91195, 3559091116, 3559091223, 'BE', 'BEL', 'بلجيكا'),
(91196, 3559091224, 3559091231, 'GB', 'GBR', 'المملكة المتحدة'),
(91197, 3559091232, 3559091239, 'BE', 'BEL', 'بلجيكا'),
(91198, 3559091240, 3559091247, 'GB', 'GBR', 'المملكة المتحدة'),
(91199, 3559091248, 3559091327, 'BE', 'BEL', 'بلجيكا'),
(91200, 3559091328, 3559091391, 'GB', 'GBR', 'المملكة المتحدة'),
(91201, 3559091392, 3559091399, 'BE', 'BEL', 'بلجيكا'),
(91202, 3559091400, 3559091407, 'GB', 'GBR', 'المملكة المتحدة'),
(91203, 3559091408, 3559091423, 'BE', 'BEL', 'بلجيكا'),
(91204, 3559091424, 3559091427, 'GB', 'GBR', 'المملكة المتحدة'),
(91205, 3559091428, 3559091507, 'BE', 'BEL', 'بلجيكا'),
(91206, 3559091508, 3559091511, 'GB', 'GBR', 'المملكة المتحدة'),
(91207, 3559091512, 3559091519, 'BE', 'BEL', 'بلجيكا'),
(91208, 3559091520, 3559091543, 'GB', 'GBR', 'المملكة المتحدة'),
(91209, 3559091544, 3559091583, 'BE', 'BEL', 'بلجيكا'),
(91210, 3559091584, 3559091615, 'GB', 'GBR', 'المملكة المتحدة'),
(91211, 3559091616, 3559091631, 'BE', 'BEL', 'بلجيكا'),
(91212, 3559091632, 3559091635, 'GB', 'GBR', 'المملكة المتحدة'),
(91213, 3559091636, 3559092159, 'BE', 'BEL', 'بلجيكا'),
(91214, 3559092160, 3559092160, 'GB', 'GBR', 'المملكة المتحدة'),
(91215, 3559092161, 3559092222, 'BE', 'BEL', 'بلجيكا'),
(91216, 3559092223, 3559092223, 'GB', 'GBR', 'المملكة المتحدة'),
(91217, 3559092224, 3559092231, 'BE', 'BEL', 'بلجيكا'),
(91218, 3559092232, 3559092239, 'GB', 'GBR', 'المملكة المتحدة'),
(91219, 3559092240, 3559092479, 'BE', 'BEL', 'بلجيكا'),
(91220, 3559092480, 3559092739, 'GB', 'GBR', 'المملكة المتحدة'),
(91221, 3559092740, 3559092831, 'BE', 'BEL', 'بلجيكا'),
(91222, 3559092832, 3559092839, 'GB', 'GBR', 'المملكة المتحدة'),
(91223, 3559092840, 3559092855, 'BE', 'BEL', 'بلجيكا'),
(91224, 3559092856, 3559092863, 'GB', 'GBR', 'المملكة المتحدة'),
(91225, 3559092864, 3559092871, 'BE', 'BEL', 'بلجيكا'),
(91226, 3559092872, 3559092895, 'GB', 'GBR', 'المملكة المتحدة'),
(91227, 3559092896, 3559092959, 'BE', 'BEL', 'بلجيكا'),
(91228, 3559092960, 3559092975, 'GB', 'GBR', 'المملكة المتحدة'),
(91229, 3559092976, 3559093007, 'BE', 'BEL', 'بلجيكا'),
(91230, 3559093008, 3559093015, 'GB', 'GBR', 'المملكة المتحدة'),
(91231, 3559093016, 3559093019, 'BE', 'BEL', 'بلجيكا'),
(91232, 3559093020, 3559093023, 'GB', 'GBR', 'المملكة المتحدة'),
(91233, 3559093024, 3559093083, 'BE', 'BEL', 'بلجيكا'),
(91234, 3559093084, 3559093087, 'GB', 'GBR', 'المملكة المتحدة'),
(91235, 3559093088, 3559093135, 'BE', 'BEL', 'بلجيكا'),
(91236, 3559093136, 3559093159, 'GB', 'GBR', 'المملكة المتحدة'),
(91237, 3559093160, 3559093311, 'BE', 'BEL', 'بلجيكا'),
(91238, 3559093312, 3559093319, 'GB', 'GBR', 'المملكة المتحدة'),
(91239, 3559093320, 3559093351, 'BE', 'BEL', 'بلجيكا'),
(91240, 3559093352, 3559093355, 'GB', 'GBR', 'المملكة المتحدة'),
(91241, 3559093356, 3559093567, 'BE', 'BEL', 'بلجيكا'),
(91242, 3559093568, 3559093599, 'IT', 'ITA', 'إيطاليا'),
(91243, 3559093600, 3559093679, 'BE', 'BEL', 'بلجيكا'),
(91244, 3559093680, 3559093699, 'GB', 'GBR', 'المملكة المتحدة'),
(91245, 3559093700, 3559093967, 'BE', 'BEL', 'بلجيكا'),
(91246, 3559093968, 3559093975, 'GB', 'GBR', 'المملكة المتحدة'),
(91247, 3559093976, 3559094087, 'BE', 'BEL', 'بلجيكا'),
(91248, 3559094088, 3559094095, 'GB', 'GBR', 'المملكة المتحدة'),
(91249, 3559094096, 3559094103, 'BE', 'BEL', 'بلجيكا'),
(91250, 3559094104, 3559094111, 'GB', 'GBR', 'المملكة المتحدة'),
(91251, 3559094112, 3559094151, 'BE', 'BEL', 'بلجيكا'),
(91252, 3559094152, 3559094159, 'GB', 'GBR', 'المملكة المتحدة'),
(91253, 3559094160, 3559094183, 'BE', 'BEL', 'بلجيكا'),
(91254, 3559094184, 3559094191, 'GB', 'GBR', 'المملكة المتحدة'),
(91255, 3559094192, 3559094303, 'BE', 'BEL', 'بلجيكا'),
(91256, 3559094304, 3559094335, 'GB', 'GBR', 'المملكة المتحدة'),
(91257, 3559094336, 3559094415, 'BE', 'BEL', 'بلجيكا'),
(91258, 3559094416, 3559094431, 'GB', 'GBR', 'المملكة المتحدة'),
(91259, 3559094432, 3559094527, 'BE', 'BEL', 'بلجيكا'),
(91260, 3559094528, 3559095039, 'GB', 'GBR', 'المملكة المتحدة'),
(91261, 3559095040, 3559095063, 'BE', 'BEL', 'بلجيكا'),
(91262, 3559095064, 3559095071, 'GB', 'GBR', 'المملكة المتحدة'),
(91263, 3559095072, 3559095119, 'BE', 'BEL', 'بلجيكا'),
(91264, 3559095120, 3559095135, 'GB', 'GBR', 'المملكة المتحدة'),
(91265, 3559095136, 3559095263, 'BE', 'BEL', 'بلجيكا'),
(91266, 3559095264, 3559095303, 'GB', 'GBR', 'المملكة المتحدة'),
(91267, 3559095304, 3559095351, 'BE', 'BEL', 'بلجيكا'),
(91268, 3559095352, 3559095359, 'GB', 'GBR', 'المملكة المتحدة'),
(91269, 3559095360, 3559095423, 'BE', 'BEL', 'بلجيكا'),
(91270, 3559095424, 3559095455, 'GB', 'GBR', 'المملكة المتحدة'),
(91271, 3559095456, 3559095487, 'BE', 'BEL', 'بلجيكا'),
(91272, 3559095488, 3559095551, 'GB', 'GBR', 'المملكة المتحدة'),
(91273, 3559095552, 3559095575, 'BE', 'BEL', 'بلجيكا'),
(91274, 3559095576, 3559095583, 'GB', 'GBR', 'المملكة المتحدة'),
(91275, 3559095584, 3559095591, 'BE', 'BEL', 'بلجيكا'),
(91276, 3559095592, 3559095623, 'GB', 'GBR', 'المملكة المتحدة'),
(91277, 3559095624, 3559095631, 'BE', 'BEL', 'بلجيكا'),
(91278, 3559095632, 3559095647, 'GB', 'GBR', 'المملكة المتحدة'),
(91279, 3559095648, 3559096087, 'BE', 'BEL', 'بلجيكا'),
(91280, 3559096088, 3559096095, 'GB', 'GBR', 'المملكة المتحدة'),
(91281, 3559096096, 3559096103, 'BE', 'BEL', 'بلجيكا'),
(91282, 3559096104, 3559096111, 'GB', 'GBR', 'المملكة المتحدة'),
(91283, 3559096112, 3559096123, 'BE', 'BEL', 'بلجيكا'),
(91284, 3559096124, 3559096127, 'GB', 'GBR', 'المملكة المتحدة'),
(91285, 3559096128, 3559096215, 'BE', 'BEL', 'بلجيكا'),
(91286, 3559096216, 3559096223, 'NL', 'NLD', 'هولندا'),
(91287, 3559096224, 3559096247, 'BE', 'BEL', 'بلجيكا'),
(91288, 3559096248, 3559096251, 'GB', 'GBR', 'المملكة المتحدة'),
(91289, 3559096252, 3559096319, 'BE', 'BEL', 'بلجيكا'),
(91290, 3559096320, 3559103231, 'RO', 'ROM', 'رومانيا'),
(91291, 3559103232, 3559103487, 'GB', 'GBR', 'المملكة المتحدة'),
(91292, 3559103488, 3559104511, 'RO', 'ROM', 'رومانيا'),
(91293, 3559104512, 3559112703, 'UA', 'UKR', 'أوكرانيا'),
(91294, 3559112704, 3559120895, 'IT', 'ITA', 'إيطاليا'),
(91295, 3559120896, 3559129087, 'GB', 'GBR', 'المملكة المتحدة'),
(91296, 3559129088, 3559137279, 'BG', 'BGR', 'بلغاريا'),
(91297, 3559137280, 3559145471, 'GB', 'GBR', 'المملكة المتحدة'),
(91298, 3559145472, 3559153663, 'ES', 'ESP', 'إسبانيا'),
(91299, 3559153664, 3559177215, 'GB', 'GBR', 'المملكة المتحدة'),
(91300, 3559177216, 3559177471, 'DE', 'DEU', 'ألمانيا'),
(91301, 3559177472, 3559177727, 'GB', 'GBR', 'المملكة المتحدة'),
(91302, 3559177728, 3559178239, 'DE', 'DEU', 'ألمانيا'),
(91303, 3559178240, 3559186431, 'LB', 'LBN', 'لبنان'),
(91304, 3559186432, 3559194623, 'RU', 'RUS', 'الإتحاد الروسي'),
(91305, 3559194624, 3559202815, 'SE', 'SWE', 'السويد'),
(91306, 3559202816, 3559211007, 'DE', 'DEU', 'ألمانيا'),
(91307, 3559211008, 3559219199, 'GR', 'GRC', 'اليونان'),
(91308, 3559219200, 3559227391, 'SE', 'SWE', 'السويد'),
(91309, 3559227392, 3559235583, 'DK', 'DNK', 'الدنيمارك'),
(91310, 3559235584, 3559243775, 'DE', 'DEU', 'ألمانيا'),
(91311, 3559243776, 3559251967, 'FR', 'FRA', 'فرنسا'),
(91312, 3559251968, 3559260159, 'NO', 'NOR', 'النرويج'),
(91313, 3559260160, 3559268351, 'DE', 'DEU', 'ألمانيا'),
(91314, 3559268352, 3559276543, 'IT', 'ITA', 'إيطاليا'),
(91315, 3559276544, 3559284735, 'GB', 'GBR', 'المملكة المتحدة'),
(91316, 3559284736, 3559284895, 'RU', 'RUS', 'الإتحاد الروسي'),
(91317, 3559284896, 3559284911, 'UA', 'UKR', 'أوكرانيا'),
(91318, 3559284912, 3559288175, 'RU', 'RUS', 'الإتحاد الروسي'),
(91319, 3559288176, 3559288191, 'UA', 'UKR', 'أوكرانيا'),
(91320, 3559288192, 3559288207, 'AZ', 'AZE', 'أذربيجان'),
(91321, 3559288208, 3559288831, 'RU', 'RUS', 'الإتحاد الروسي'),
(91322, 3559288832, 3559289855, 'AZ', 'AZE', 'أذربيجان');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(91323, 3559289856, 3559292927, 'RU', 'RUS', 'الإتحاد الروسي'),
(91324, 3559292928, 3559301119, 'JO', 'JOR', 'الأردن'),
(91325, 3559301120, 3559309311, 'GB', 'GBR', 'المملكة المتحدة'),
(91326, 3559309312, 3559317503, 'PL', 'POL', 'بولندا'),
(91327, 3559317504, 3559325695, 'FI', 'FIN', 'فنلندا'),
(91328, 3559325696, 3559333887, 'IT', 'ITA', 'إيطاليا'),
(91329, 3559333888, 3559336447, 'SE', 'SWE', 'السويد'),
(91330, 3559336448, 3559336703, 'US', 'USA', 'الولايات المتحدة'),
(91331, 3559336704, 3559342079, 'SE', 'SWE', 'السويد'),
(91332, 3559342080, 3559350271, 'BG', 'BGR', 'بلغاريا'),
(91333, 3559350272, 3559358463, 'BA', 'BIH', 'البوسنه والهرسك'),
(91334, 3559358464, 3559366655, 'FR', 'FRA', 'فرنسا'),
(91335, 3559366656, 3559374847, 'GB', 'GBR', 'المملكة المتحدة'),
(91336, 3559374848, 3559383039, 'AT', 'AUT', 'النمسا'),
(91337, 3559383040, 3559391231, 'GB', 'GBR', 'المملكة المتحدة'),
(91338, 3559391232, 3559399423, 'CH', 'CHE', 'سويسرا'),
(91339, 3559399424, 3559407615, 'UA', 'UKR', 'أوكرانيا'),
(91340, 3559407616, 3559423999, 'HU', 'HUN', 'هنغاريا'),
(91341, 3559424000, 3559432191, 'LB', 'LBN', 'لبنان'),
(91342, 3559432192, 3559440383, 'DE', 'DEU', 'ألمانيا'),
(91343, 3559440384, 3559448575, 'RU', 'RUS', 'الإتحاد الروسي'),
(91344, 3559448576, 3559456767, 'ES', 'ESP', 'إسبانيا'),
(91345, 3559456768, 3559473151, 'RU', 'RUS', 'الإتحاد الروسي'),
(91346, 3559473152, 3559489535, 'CH', 'CHE', 'سويسرا'),
(91347, 3559489536, 3559490591, 'NL', 'NLD', 'هولندا'),
(91348, 3559490592, 3559490623, 'DE', 'DEU', 'ألمانيا'),
(91349, 3559490624, 3559490687, 'NL', 'NLD', 'هولندا'),
(91350, 3559490688, 3559490719, 'ES', 'ESP', 'إسبانيا'),
(91351, 3559490720, 3559490751, 'NL', 'NLD', 'هولندا'),
(91352, 3559490752, 3559490783, 'ES', 'ESP', 'إسبانيا'),
(91353, 3559490784, 3559490791, 'CH', 'CHE', 'سويسرا'),
(91354, 3559490792, 3559490799, 'BE', 'BEL', 'بلجيكا'),
(91355, 3559490800, 3559490815, 'ES', 'ESP', 'إسبانيا'),
(91356, 3559490816, 3559491135, 'NL', 'NLD', 'هولندا'),
(91357, 3559491136, 3559491167, 'ES', 'ESP', 'إسبانيا'),
(91358, 3559491168, 3559491247, 'NL', 'NLD', 'هولندا'),
(91359, 3559491248, 3559491263, 'ES', 'ESP', 'إسبانيا'),
(91360, 3559491264, 3559491327, 'NL', 'NLD', 'هولندا'),
(91361, 3559491328, 3559491359, 'ES', 'ESP', 'إسبانيا'),
(91362, 3559491360, 3559491447, 'NL', 'NLD', 'هولندا'),
(91363, 3559491448, 3559491455, 'ES', 'ESP', 'إسبانيا'),
(91364, 3559491456, 3559491839, 'NL', 'NLD', 'هولندا'),
(91365, 3559491840, 3559491871, 'ES', 'ESP', 'إسبانيا'),
(91366, 3559491872, 3559491903, 'GB', 'GBR', 'المملكة المتحدة'),
(91367, 3559491904, 3559491967, 'ES', 'ESP', 'إسبانيا'),
(91368, 3559491968, 3559491999, 'NL', 'NLD', 'هولندا'),
(91369, 3559492000, 3559492007, 'ES', 'ESP', 'إسبانيا'),
(91370, 3559492008, 3559492013, 'NL', 'NLD', 'هولندا'),
(91371, 3559492014, 3559492015, 'ES', 'ESP', 'إسبانيا'),
(91372, 3559492016, 3559492023, 'NL', 'NLD', 'هولندا'),
(91373, 3559492024, 3559492031, 'ES', 'ESP', 'إسبانيا'),
(91374, 3559492032, 3559493151, 'NL', 'NLD', 'هولندا'),
(91375, 3559493152, 3559493167, 'ES', 'ESP', 'إسبانيا'),
(91376, 3559493168, 3559493247, 'NL', 'NLD', 'هولندا'),
(91377, 3559493248, 3559493279, 'ES', 'ESP', 'إسبانيا'),
(91378, 3559493280, 3559493311, 'GB', 'GBR', 'المملكة المتحدة'),
(91379, 3559493312, 3559493349, 'NL', 'NLD', 'هولندا'),
(91380, 3559493350, 3559493359, 'ES', 'ESP', 'إسبانيا'),
(91381, 3559493360, 3559497727, 'NL', 'NLD', 'هولندا'),
(91382, 3559497728, 3559505919, 'GB', 'GBR', 'المملكة المتحدة'),
(91383, 3559505920, 3559514111, 'CH', 'CHE', 'سويسرا'),
(91384, 3559514112, 3559522303, 'AT', 'AUT', 'النمسا'),
(91385, 3559522304, 3559530495, 'GB', 'GBR', 'المملكة المتحدة'),
(91386, 3559530496, 3559538687, 'RU', 'RUS', 'الإتحاد الروسي'),
(91387, 3559538688, 3559546879, 'UA', 'UKR', 'أوكرانيا'),
(91388, 3559546880, 3559555071, 'KG', 'KGZ', 'قيرغيزستان'),
(91389, 3559555072, 3559563263, 'CH', 'CHE', 'سويسرا'),
(91390, 3559563264, 3559571455, 'GB', 'GBR', 'المملكة المتحدة'),
(91391, 3559571456, 3559579647, 'AM', 'ARM', 'أرمينيا'),
(91392, 3559579648, 3559586271, 'DE', 'DEU', 'ألمانيا'),
(91393, 3559586272, 3559586303, 'US', 'USA', 'الولايات المتحدة'),
(91394, 3559586304, 3559587839, 'DE', 'DEU', 'ألمانيا'),
(91395, 3559587840, 3559596031, 'KW', 'KWT', 'الكويت'),
(91396, 3559596032, 3559604223, 'BG', 'BGR', 'بلغاريا'),
(91397, 3559604224, 3559612415, 'DE', 'DEU', 'ألمانيا'),
(91398, 3559612416, 3559620607, 'IT', 'ITA', 'إيطاليا'),
(91399, 3559620608, 3559628799, 'CH', 'CHE', 'سويسرا'),
(91400, 3559628800, 3559636991, 'GB', 'GBR', 'المملكة المتحدة'),
(91401, 3559636992, 3559653375, 'FR', 'FRA', 'فرنسا'),
(91402, 3559653376, 3559669759, 'GB', 'GBR', 'المملكة المتحدة'),
(91403, 3559669760, 3559677951, 'RU', 'RUS', 'الإتحاد الروسي'),
(91404, 3559677952, 3559686143, 'SI', 'SVN', 'سلوفينيا'),
(91405, 3559686144, 3559694335, 'RU', 'RUS', 'الإتحاد الروسي'),
(91406, 3559694336, 3559702655, 'DE', 'DEU', 'ألمانيا'),
(91407, 3559702656, 3559702719, 'RU', 'RUS', 'الإتحاد الروسي'),
(91408, 3559702720, 3559703039, 'DE', 'DEU', 'ألمانيا'),
(91409, 3559703040, 3559703551, 'UA', 'UKR', 'أوكرانيا'),
(91410, 3559703552, 3559703679, 'IR', 'IRN', 'إيران'),
(91411, 3559703680, 3559703807, 'DE', 'DEU', 'ألمانيا'),
(91412, 3559703808, 3559704063, 'IR', 'IRN', 'إيران'),
(91413, 3559704064, 3559710463, 'DE', 'DEU', 'ألمانيا'),
(91414, 3559710464, 3559710719, 'IR', 'IRN', 'إيران'),
(91415, 3559710720, 3559718911, 'FR', 'FRA', 'فرنسا'),
(91416, 3559718912, 3559727103, 'RU', 'RUS', 'الإتحاد الروسي'),
(91417, 3559727104, 3559735295, 'NL', 'NLD', 'هولندا'),
(91418, 3559735296, 3559743487, 'BG', 'BGR', 'بلغاريا'),
(91419, 3559743488, 3559745535, 'IT', 'ITA', 'إيطاليا'),
(91420, 3559745536, 3559747583, 'DE', 'DEU', 'ألمانيا'),
(91421, 3559747584, 3559751679, 'DK', 'DNK', 'الدنيمارك'),
(91422, 3559751680, 3559759871, 'IT', 'ITA', 'إيطاليا'),
(91423, 3559759872, 3559768063, 'NO', 'NOR', 'النرويج'),
(91424, 3559768064, 3559776255, 'CH', 'CHE', 'سويسرا'),
(91425, 3559776256, 3559792639, 'RU', 'RUS', 'الإتحاد الروسي'),
(91426, 3559792640, 3559800831, 'SA', 'SAU', 'السعودية'),
(91427, 3559800832, 3559809023, 'IT', 'ITA', 'إيطاليا'),
(91428, 3559809024, 3559817215, 'DE', 'DEU', 'ألمانيا'),
(91429, 3559817216, 3559825407, 'GB', 'GBR', 'المملكة المتحدة'),
(91430, 3559825408, 3559833599, 'IT', 'ITA', 'إيطاليا'),
(91431, 3559833600, 3559849983, 'RU', 'RUS', 'الإتحاد الروسي'),
(91432, 3559849984, 3559858175, 'CZ', 'CZE', 'التشيك'),
(91433, 3559858176, 3559866367, 'IT', 'ITA', 'إيطاليا'),
(91434, 3559866368, 3559874559, 'GB', 'GBR', 'المملكة المتحدة'),
(91435, 3559874560, 3559877951, 'LT', 'LTU', 'ليتوانيا'),
(91436, 3559877952, 3559877967, 'CH', 'CHE', 'سويسرا'),
(91437, 3559877968, 3559882751, 'LT', 'LTU', 'ليتوانيا'),
(91438, 3559882752, 3559890943, 'AZ', 'AZE', 'أذربيجان'),
(91439, 3559890944, 3559899135, 'CH', 'CHE', 'سويسرا'),
(91440, 3559899136, 3559899391, 'DE', 'DEU', 'ألمانيا'),
(91441, 3559899392, 3559899395, 'EE', 'EST', 'إستونيا'),
(91442, 3559899396, 3559899487, 'DE', 'DEU', 'ألمانيا'),
(91443, 3559899488, 3559899519, 'EE', 'EST', 'إستونيا'),
(91444, 3559899520, 3559899791, 'DE', 'DEU', 'ألمانيا'),
(91445, 3559899792, 3559899807, 'EE', 'EST', 'إستونيا'),
(91446, 3559899808, 3559899855, 'DE', 'DEU', 'ألمانيا'),
(91447, 3559899856, 3559899871, 'EE', 'EST', 'إستونيا'),
(91448, 3559899872, 3559899903, 'DE', 'DEU', 'ألمانيا'),
(91449, 3559899904, 3559899911, 'EE', 'EST', 'إستونيا'),
(91450, 3559899912, 3559899935, 'RU', 'RUS', 'الإتحاد الروسي'),
(91451, 3559899936, 3559899951, 'DE', 'DEU', 'ألمانيا'),
(91452, 3559899952, 3559899955, 'EE', 'EST', 'إستونيا'),
(91453, 3559899956, 3559899959, 'DE', 'DEU', 'ألمانيا'),
(91454, 3559899960, 3559899991, 'RU', 'RUS', 'الإتحاد الروسي'),
(91455, 3559899992, 3559900275, 'DE', 'DEU', 'ألمانيا'),
(91456, 3559900276, 3559900279, 'EE', 'EST', 'إستونيا'),
(91457, 3559900280, 3559900423, 'DE', 'DEU', 'ألمانيا'),
(91458, 3559900424, 3559900432, 'EE', 'EST', 'إستونيا'),
(91459, 3559900433, 3559900439, 'DE', 'DEU', 'ألمانيا'),
(91460, 3559900440, 3559900447, 'EE', 'EST', 'إستونيا'),
(91461, 3559900448, 3559900471, 'DE', 'DEU', 'ألمانيا'),
(91462, 3559900472, 3559900479, 'EE', 'EST', 'إستونيا'),
(91463, 3559900480, 3559900483, 'DE', 'DEU', 'ألمانيا'),
(91464, 3559900484, 3559900487, 'EE', 'EST', 'إستونيا'),
(91465, 3559900488, 3559900492, 'DE', 'DEU', 'ألمانيا'),
(91466, 3559900493, 3559900493, 'EE', 'EST', 'إستونيا'),
(91467, 3559900494, 3559900494, 'DE', 'DEU', 'ألمانيا'),
(91468, 3559900495, 3559900495, 'EE', 'EST', 'إستونيا'),
(91469, 3559900496, 3559900503, 'DE', 'DEU', 'ألمانيا'),
(91470, 3559900504, 3559900511, 'EE', 'EST', 'إستونيا'),
(91471, 3559900512, 3559900519, 'DE', 'DEU', 'ألمانيا'),
(91472, 3559900520, 3559900523, 'EE', 'EST', 'إستونيا'),
(91473, 3559900524, 3559900611, 'DE', 'DEU', 'ألمانيا'),
(91474, 3559900612, 3559900624, 'EE', 'EST', 'إستونيا'),
(91475, 3559900625, 3559900927, 'DE', 'DEU', 'ألمانيا'),
(91476, 3559900928, 3559900951, 'EE', 'EST', 'إستونيا'),
(91477, 3559900952, 3559900959, 'DE', 'DEU', 'ألمانيا'),
(91478, 3559900960, 3559900975, 'SE', 'SWE', 'السويد'),
(91479, 3559900976, 3559900983, 'PL', 'POL', 'بولندا'),
(91480, 3559900984, 3559900991, 'GB', 'GBR', 'المملكة المتحدة'),
(91481, 3559900992, 3559901007, 'RU', 'RUS', 'الإتحاد الروسي'),
(91482, 3559901008, 3559901183, 'DE', 'DEU', 'ألمانيا'),
(91483, 3559901184, 3559902011, 'EE', 'EST', 'إستونيا'),
(91484, 3559902012, 3559902015, 'DE', 'DEU', 'ألمانيا'),
(91485, 3559902016, 3559902031, 'EE', 'EST', 'إستونيا'),
(91486, 3559902032, 3559902047, 'DE', 'DEU', 'ألمانيا'),
(91487, 3559902048, 3559902055, 'EE', 'EST', 'إستونيا'),
(91488, 3559902056, 3559902063, 'DE', 'DEU', 'ألمانيا'),
(91489, 3559902064, 3559902071, 'UA', 'UKR', 'أوكرانيا'),
(91490, 3559902072, 3559902079, 'EE', 'EST', 'إستونيا'),
(91491, 3559902080, 3559902175, 'DE', 'DEU', 'ألمانيا'),
(91492, 3559902176, 3559902187, 'EE', 'EST', 'إستونيا'),
(91493, 3559902188, 3559902191, 'DE', 'DEU', 'ألمانيا'),
(91494, 3559902192, 3559902207, 'EE', 'EST', 'إستونيا'),
(91495, 3559902208, 3559902623, 'DE', 'DEU', 'ألمانيا'),
(91496, 3559902624, 3559902631, 'EE', 'EST', 'إستونيا'),
(91497, 3559902632, 3559902975, 'DE', 'DEU', 'ألمانيا'),
(91498, 3559902976, 3559903231, 'EE', 'EST', 'إستونيا'),
(91499, 3559903232, 3559903743, 'DE', 'DEU', 'ألمانيا'),
(91500, 3559903744, 3559904023, 'EE', 'EST', 'إستونيا'),
(91501, 3559904024, 3559904607, 'DE', 'DEU', 'ألمانيا'),
(91502, 3559904608, 3559904639, 'EE', 'EST', 'إستونيا'),
(91503, 3559904640, 3559905019, 'DE', 'DEU', 'ألمانيا'),
(91504, 3559905020, 3559905039, 'EE', 'EST', 'إستونيا'),
(91505, 3559905040, 3559905055, 'DE', 'DEU', 'ألمانيا'),
(91506, 3559905056, 3559905139, 'EE', 'EST', 'إستونيا'),
(91507, 3559905140, 3559905151, 'DE', 'DEU', 'ألمانيا'),
(91508, 3559905152, 3559905155, 'EE', 'EST', 'إستونيا'),
(91509, 3559905156, 3559905159, 'DE', 'DEU', 'ألمانيا'),
(91510, 3559905160, 3559905285, 'EE', 'EST', 'إستونيا'),
(91511, 3559905286, 3559905287, 'DE', 'DEU', 'ألمانيا'),
(91512, 3559905288, 3559905295, 'EE', 'EST', 'إستونيا'),
(91513, 3559905296, 3559905535, 'DE', 'DEU', 'ألمانيا'),
(91514, 3559905536, 3559905623, 'EE', 'EST', 'إستونيا'),
(91515, 3559905624, 3559905631, 'DE', 'DEU', 'ألمانيا'),
(91516, 3559905632, 3559905719, 'EE', 'EST', 'إستونيا'),
(91517, 3559905720, 3559905727, 'DE', 'DEU', 'ألمانيا'),
(91518, 3559905728, 3559906255, 'EE', 'EST', 'إستونيا'),
(91519, 3559906256, 3559906263, 'DE', 'DEU', 'ألمانيا'),
(91520, 3559906264, 3559906735, 'EE', 'EST', 'إستونيا'),
(91521, 3559906736, 3559906815, 'DE', 'DEU', 'ألمانيا'),
(91522, 3559906816, 3559906975, 'EE', 'EST', 'إستونيا'),
(91523, 3559906976, 3559907071, 'DE', 'DEU', 'ألمانيا'),
(91524, 3559907072, 3559907327, 'EE', 'EST', 'إستونيا'),
(91525, 3559907328, 3559915519, 'FR', 'FRA', 'فرنسا'),
(91526, 3559915520, 3559923711, 'IT', 'ITA', 'إيطاليا'),
(91527, 3559923712, 3559931903, 'RU', 'RUS', 'الإتحاد الروسي'),
(91528, 3559931904, 3559940095, 'IL', 'ISR', 'إسرائيل'),
(91529, 3559940096, 3559945471, 'DE', 'DEU', 'ألمانيا'),
(91530, 3559945472, 3559945727, 'US', 'USA', 'الولايات المتحدة'),
(91531, 3559945728, 3559948287, 'DE', 'DEU', 'ألمانيا'),
(91532, 3559948288, 3559956479, 'RU', 'RUS', 'الإتحاد الروسي'),
(91533, 3559956480, 3559956543, 'IT', 'ITA', 'إيطاليا'),
(91534, 3559956544, 3559956551, 'NL', 'NLD', 'هولندا'),
(91535, 3559956552, 3559957567, 'IT', 'ITA', 'إيطاليا'),
(91536, 3559957568, 3559957599, 'NL', 'NLD', 'هولندا'),
(91537, 3559957600, 3559964159, 'IT', 'ITA', 'إيطاليا'),
(91538, 3559964160, 3559964415, 'HU', 'HUN', 'هنغاريا'),
(91539, 3559964416, 3559964671, 'IT', 'ITA', 'إيطاليا'),
(91540, 3559964672, 3559972863, 'RU', 'RUS', 'الإتحاد الروسي'),
(91541, 3559981056, 3559989247, 'EE', 'EST', 'إستونيا'),
(91542, 3559989248, 3559997439, 'PL', 'POL', 'بولندا'),
(91543, 3560005632, 3560013823, 'RU', 'RUS', 'الإتحاد الروسي'),
(91544, 3560013824, 3560030207, 'ES', 'ESP', 'إسبانيا'),
(91545, 3560030208, 3560046591, 'GB', 'GBR', 'المملكة المتحدة'),
(91546, 3560046592, 3560054783, 'BG', 'BGR', 'بلغاريا'),
(91547, 3560054784, 3560062975, 'TR', 'TUR', 'تركيا'),
(91548, 3560062976, 3560071167, 'BG', 'BGR', 'بلغاريا'),
(91549, 3560071168, 3560079359, 'CY', 'CYP', 'قبرص'),
(91550, 3560079360, 3560087551, 'FI', 'FIN', 'فنلندا'),
(91551, 3560087552, 3560095743, 'GB', 'GBR', 'المملكة المتحدة'),
(91552, 3560095744, 3560103935, 'FI', 'FIN', 'فنلندا'),
(91553, 3560103936, 3560112127, 'IR', 'IRN', 'إيران'),
(91554, 3560112128, 3560120319, 'DE', 'DEU', 'ألمانيا'),
(91555, 3560120320, 3560128511, 'ES', 'ESP', 'إسبانيا'),
(91556, 3560128512, 3560144895, 'HU', 'HUN', 'هنغاريا'),
(91557, 3560144896, 3560153087, 'CH', 'CHE', 'سويسرا'),
(91558, 3560153088, 3560161279, 'FR', 'FRA', 'فرنسا'),
(91559, 3560161280, 3560169471, 'PL', 'POL', 'بولندا'),
(91560, 3560169472, 3560177663, 'AT', 'AUT', 'النمسا'),
(91561, 3560177664, 3560185855, 'NL', 'NLD', 'هولندا'),
(91562, 3560185856, 3560194047, 'LT', 'LTU', 'ليتوانيا'),
(91563, 3560194048, 3560210431, 'IT', 'ITA', 'إيطاليا'),
(91564, 3560218624, 3560226815, 'HU', 'HUN', 'هنغاريا'),
(91565, 3560226816, 3560235007, 'AT', 'AUT', 'النمسا'),
(91566, 3560235008, 3560243199, 'DE', 'DEU', 'ألمانيا'),
(91567, 3560243200, 3560247295, 'BE', 'BEL', 'بلجيكا'),
(91568, 3560247296, 3560247999, 'NL', 'NLD', 'هولندا'),
(91569, 3560248000, 3560248319, 'BE', 'BEL', 'بلجيكا'),
(91570, 3560248320, 3560249087, 'NL', 'NLD', 'هولندا'),
(91571, 3560249088, 3560251391, 'BE', 'BEL', 'بلجيكا'),
(91572, 3560251392, 3560253439, 'RU', 'RUS', 'الإتحاد الروسي'),
(91573, 3560253440, 3560253695, 'CZ', 'CZE', 'التشيك'),
(91574, 3560253696, 3560259583, 'RU', 'RUS', 'الإتحاد الروسي'),
(91575, 3560259584, 3560267775, 'GB', 'GBR', 'المملكة المتحدة'),
(91576, 3560267776, 3560275967, 'CH', 'CHE', 'سويسرا'),
(91577, 3560275968, 3560308735, 'DE', 'DEU', 'ألمانيا'),
(91578, 3560308736, 3560316927, 'FI', 'FIN', 'فنلندا'),
(91579, 3560316928, 3560325119, 'NL', 'NLD', 'هولندا'),
(91580, 3560325120, 3560333311, 'DK', 'DNK', 'الدنيمارك'),
(91581, 3560333312, 3560341503, 'RO', 'ROM', 'رومانيا'),
(91582, 3560341504, 3560349695, 'PT', 'PRT', 'البورتوغال'),
(91583, 3560349696, 3560357887, 'GB', 'GBR', 'المملكة المتحدة'),
(91584, 3560357888, 3560366079, 'GR', 'GRC', 'اليونان'),
(91585, 3560366080, 3560366687, 'CH', 'CHE', 'سويسرا'),
(91586, 3560366688, 3560366695, 'IT', 'ITA', 'إيطاليا'),
(91587, 3560366696, 3560366703, 'CH', 'CHE', 'سويسرا'),
(91588, 3560366704, 3560366711, 'IT', 'ITA', 'إيطاليا'),
(91589, 3560366712, 3560374271, 'CH', 'CHE', 'سويسرا'),
(91590, 3560374272, 3560382463, 'ES', 'ESP', 'إسبانيا'),
(91591, 3560382464, 3560387103, 'FO', 'FRO', 'جزر فارو'),
(91592, 3560387104, 3560387111, 'DK', 'DNK', 'الدنيمارك'),
(91593, 3560387112, 3560390655, 'FO', 'FRO', 'جزر فارو'),
(91594, 3560390656, 3560407039, 'RU', 'RUS', 'الإتحاد الروسي'),
(91595, 3560407040, 3560423423, 'PT', 'PRT', 'البورتوغال'),
(91596, 3560423424, 3560431615, 'CH', 'CHE', 'سويسرا'),
(91597, 3560431616, 3560439807, 'SK', 'SVK', 'سلوفاكيا'),
(91598, 3560439808, 3560447999, 'BG', 'BGR', 'بلغاريا'),
(91599, 3560448000, 3560449791, 'GB', 'GBR', 'المملكة المتحدة'),
(91600, 3560449792, 3560450047, 'US', 'USA', 'الولايات المتحدة'),
(91601, 3560450048, 3560472575, 'GB', 'GBR', 'المملكة المتحدة'),
(91602, 3560472576, 3560480767, 'MT', 'MLT', 'مالطا'),
(91603, 3560480768, 3560488959, 'IT', 'ITA', 'إيطاليا'),
(91604, 3560488960, 3560497151, 'MD', 'MDA', 'مولدوفا'),
(91605, 3560497152, 3560505343, 'LU', 'LUX', 'لوكسيمبورغ'),
(91606, 3560505344, 3560513535, 'TR', 'TUR', 'تركيا'),
(91607, 3560513536, 3560515583, 'SK', 'SVK', 'سلوفاكيا'),
(91608, 3560515584, 3560517631, 'RS', 'SRB', 'صربيا'),
(91609, 3560517632, 3560521727, 'NL', 'NLD', 'هولندا'),
(91610, 3560521728, 3560529919, 'PT', 'PRT', 'البورتوغال'),
(91611, 3560529920, 3560554495, 'RU', 'RUS', 'الإتحاد الروسي'),
(91612, 3560554496, 3560562687, 'SA', 'SAU', 'السعودية'),
(91613, 3560562688, 3560570879, 'GB', 'GBR', 'المملكة المتحدة'),
(91614, 3560570880, 3560579071, 'TR', 'TUR', 'تركيا'),
(91615, 3560579072, 3560587263, 'GB', 'GBR', 'المملكة المتحدة'),
(91616, 3560587264, 3560595455, 'DE', 'DEU', 'ألمانيا'),
(91617, 3560595456, 3560603647, 'GE', 'GEO', 'جورجيا'),
(91618, 3560603648, 3560611839, 'GB', 'GBR', 'المملكة المتحدة'),
(91619, 3560611840, 3560620031, 'UA', 'UKR', 'أوكرانيا'),
(91620, 3560620032, 3560628223, 'RU', 'RUS', 'الإتحاد الروسي'),
(91621, 3560628224, 3560632207, 'GB', 'GBR', 'المملكة المتحدة'),
(91622, 3560632208, 3560632215, 'NL', 'NLD', 'هولندا'),
(91623, 3560632216, 3560636415, 'GB', 'GBR', 'المملكة المتحدة'),
(91624, 3560636416, 3560644607, 'LT', 'LTU', 'ليتوانيا'),
(91625, 3560644608, 3560652799, 'DE', 'DEU', 'ألمانيا'),
(91626, 3560652800, 3560660991, 'GB', 'GBR', 'المملكة المتحدة'),
(91627, 3560660992, 3560669183, 'RU', 'RUS', 'الإتحاد الروسي'),
(91628, 3560669184, 3560685567, 'CH', 'CHE', 'سويسرا'),
(91629, 3560685568, 3560693759, 'ES', 'ESP', 'إسبانيا'),
(91630, 3560693760, 3560701951, 'PL', 'POL', 'بولندا'),
(91631, 3560701952, 3560710143, 'DE', 'DEU', 'ألمانيا'),
(91632, 3560710144, 3560718335, 'CH', 'CHE', 'سويسرا'),
(91633, 3560726528, 3560734719, 'DK', 'DNK', 'الدنيمارك'),
(91634, 3560734720, 3560742623, 'DE', 'DEU', 'ألمانيا'),
(91635, 3560742624, 3560742631, 'GB', 'GBR', 'المملكة المتحدة'),
(91636, 3560742632, 3560742911, 'DE', 'DEU', 'ألمانيا'),
(91637, 3560742912, 3560751103, 'AT', 'AUT', 'النمسا'),
(91638, 3560751104, 3560767487, 'DE', 'DEU', 'ألمانيا'),
(91639, 3560767488, 3560832255, 'NL', 'NLD', 'هولندا'),
(91640, 3560832256, 3560832511, 'GB', 'GBR', 'المملكة المتحدة'),
(91641, 3560832512, 3560832791, 'NL', 'NLD', 'هولندا'),
(91642, 3560832792, 3560832799, 'BE', 'BEL', 'بلجيكا'),
(91643, 3560832800, 3560833023, 'NL', 'NLD', 'هولندا'),
(91644, 3560833024, 3560841215, 'GB', 'GBR', 'المملكة المتحدة'),
(91645, 3560841216, 3560842415, 'RS', 'SRB', 'صربيا'),
(91646, 3560842416, 3560842423, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(91647, 3560842424, 3560844607, 'RS', 'SRB', 'صربيا'),
(91648, 3560844608, 3560844623, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(91649, 3560844624, 3560845631, 'RS', 'SRB', 'صربيا'),
(91650, 3560845632, 3560845663, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(91651, 3560845664, 3560849407, 'RS', 'SRB', 'صربيا'),
(91652, 3560849408, 3560849663, 'DE', 'DEU', 'ألمانيا'),
(91653, 3560849664, 3560849727, 'NL', 'NLD', 'هولندا'),
(91654, 3560849728, 3560852911, 'DE', 'DEU', 'ألمانيا'),
(91655, 3560852912, 3560852919, 'TH', 'THA', 'تايلند'),
(91656, 3560852920, 3560852959, 'DE', 'DEU', 'ألمانيا'),
(91657, 3560852960, 3560852967, 'GB', 'GBR', 'المملكة المتحدة'),
(91658, 3560852968, 3560857599, 'DE', 'DEU', 'ألمانيا'),
(91659, 3560857600, 3560865791, 'SA', 'SAU', 'السعودية'),
(91660, 3560865792, 3560882175, 'FR', 'FRA', 'فرنسا'),
(91661, 3560882176, 3560890367, 'DE', 'DEU', 'ألمانيا'),
(91662, 3560890368, 3560898559, 'NO', 'NOR', 'النرويج'),
(91663, 3560898560, 3560906751, 'FI', 'FIN', 'فنلندا'),
(91664, 3560906752, 3560916383, 'DE', 'DEU', 'ألمانيا'),
(91665, 3560916384, 3560916391, 'CH', 'CHE', 'سويسرا'),
(91666, 3560916392, 3560919047, 'DE', 'DEU', 'ألمانيا'),
(91667, 3560919048, 3560919055, 'CH', 'CHE', 'سويسرا'),
(91668, 3560919056, 3560923135, 'DE', 'DEU', 'ألمانيا'),
(91669, 3560923136, 3560931327, 'ES', 'ESP', 'إسبانيا'),
(91670, 3560931328, 3560939523, 'DE', 'DEU', 'ألمانيا'),
(91671, 3560939524, 3560939527, 'AT', 'AUT', 'النمسا'),
(91672, 3560939528, 3560939535, 'DE', 'DEU', 'ألمانيا'),
(91673, 3560939536, 3560939539, 'PT', 'PRT', 'البورتوغال'),
(91674, 3560939540, 3560939543, 'IT', 'ITA', 'إيطاليا'),
(91675, 3560939544, 3560939555, 'DE', 'DEU', 'ألمانيا'),
(91676, 3560939556, 3560939559, 'ES', 'ESP', 'إسبانيا'),
(91677, 3560939560, 3560939567, 'DE', 'DEU', 'ألمانيا'),
(91678, 3560939568, 3560939571, 'NL', 'NLD', 'هولندا'),
(91679, 3560939572, 3560939579, 'ES', 'ESP', 'إسبانيا'),
(91680, 3560939580, 3560939583, 'BE', 'BEL', 'بلجيكا'),
(91681, 3560939584, 3560939587, 'DE', 'DEU', 'ألمانيا'),
(91682, 3560939588, 3560939591, 'BE', 'BEL', 'بلجيكا'),
(91683, 3560939592, 3560939607, 'DE', 'DEU', 'ألمانيا'),
(91684, 3560939608, 3560939611, 'IT', 'ITA', 'إيطاليا'),
(91685, 3560939612, 3560939627, 'DE', 'DEU', 'ألمانيا'),
(91686, 3560939628, 3560939631, 'CH', 'CHE', 'سويسرا'),
(91687, 3560939632, 3560939643, 'DE', 'DEU', 'ألمانيا'),
(91688, 3560939644, 3560939647, 'BE', 'BEL', 'بلجيكا'),
(91689, 3560939648, 3560939655, 'DE', 'DEU', 'ألمانيا'),
(91690, 3560939656, 3560939659, 'CH', 'CHE', 'سويسرا'),
(91691, 3560939660, 3560939663, 'DE', 'DEU', 'ألمانيا'),
(91692, 3560939664, 3560939667, 'DK', 'DNK', 'الدنيمارك'),
(91693, 3560939668, 3560939675, 'DE', 'DEU', 'ألمانيا'),
(91694, 3560939676, 3560939679, 'PL', 'POL', 'بولندا'),
(91695, 3560939680, 3560939683, 'IT', 'ITA', 'إيطاليا'),
(91696, 3560939684, 3560939687, 'AT', 'AUT', 'النمسا'),
(91697, 3560939688, 3560939691, 'ES', 'ESP', 'إسبانيا'),
(91698, 3560939692, 3560939695, 'FR', 'FRA', 'فرنسا'),
(91699, 3560939696, 3560939703, 'DE', 'DEU', 'ألمانيا'),
(91700, 3560939704, 3560939707, 'ES', 'ESP', 'إسبانيا'),
(91701, 3560939708, 3560939719, 'DE', 'DEU', 'ألمانيا'),
(91702, 3560939720, 3560939727, 'GR', 'GRC', 'اليونان'),
(91703, 3560939728, 3560939735, 'NL', 'NLD', 'هولندا'),
(91704, 3560939736, 3560939751, 'FR', 'FRA', 'فرنسا'),
(91705, 3560939752, 3560939755, 'IT', 'ITA', 'إيطاليا'),
(91706, 3560939756, 3560939759, 'DE', 'DEU', 'ألمانيا'),
(91707, 3560939760, 3560939763, 'IT', 'ITA', 'إيطاليا'),
(91708, 3560939764, 3560939767, 'DE', 'DEU', 'ألمانيا'),
(91709, 3560939768, 3560939771, 'IE', 'IRL', 'إيرلندا'),
(91710, 3560939772, 3560939775, 'CZ', 'CZE', 'التشيك'),
(91711, 3560939776, 3560939779, 'BE', 'BEL', 'بلجيكا'),
(91712, 3560939780, 3560939791, 'DE', 'DEU', 'ألمانيا'),
(91713, 3560939792, 3560939795, 'FR', 'FRA', 'فرنسا'),
(91714, 3560939796, 3560939799, 'GB', 'GBR', 'المملكة المتحدة'),
(91715, 3560939800, 3560939803, 'DE', 'DEU', 'ألمانيا'),
(91716, 3560939804, 3560939807, 'IT', 'ITA', 'إيطاليا'),
(91717, 3560939808, 3560939811, 'FR', 'FRA', 'فرنسا'),
(91718, 3560939812, 3560939815, 'DE', 'DEU', 'ألمانيا'),
(91719, 3560939816, 3560939819, 'CH', 'CHE', 'سويسرا'),
(91720, 3560939820, 3560939823, 'DE', 'DEU', 'ألمانيا'),
(91721, 3560939824, 3560939827, 'LI', 'LIE', 'ليختنشتاين'),
(91722, 3560939828, 3560939831, 'FR', 'FRA', 'فرنسا'),
(91723, 3560939832, 3560939839, 'DE', 'DEU', 'ألمانيا'),
(91724, 3560939840, 3560939843, 'GB', 'GBR', 'المملكة المتحدة'),
(91725, 3560939844, 3560939847, 'ES', 'ESP', 'إسبانيا'),
(91726, 3560939848, 3560939851, 'BE', 'BEL', 'بلجيكا'),
(91727, 3560939852, 3560939855, 'ES', 'ESP', 'إسبانيا'),
(91728, 3560939856, 3560939859, 'FR', 'FRA', 'فرنسا'),
(91729, 3560939860, 3560939863, 'HU', 'HUN', 'هنغاريا'),
(91730, 3560939864, 3560939867, 'ES', 'ESP', 'إسبانيا'),
(91731, 3560939868, 3560939875, 'DE', 'DEU', 'ألمانيا'),
(91732, 3560939876, 3560939879, 'CH', 'CHE', 'سويسرا'),
(91733, 3560939880, 3560939887, 'DE', 'DEU', 'ألمانيا'),
(91734, 3560939888, 3560939891, 'CH', 'CHE', 'سويسرا'),
(91735, 3560939892, 3560939895, 'DE', 'DEU', 'ألمانيا'),
(91736, 3560939896, 3560939899, 'ES', 'ESP', 'إسبانيا'),
(91737, 3560939900, 3560939903, 'GB', 'GBR', 'المملكة المتحدة'),
(91738, 3560939904, 3560939907, 'BR', 'BRA', 'البرازيل'),
(91739, 3560939908, 3560939911, 'NL', 'NLD', 'هولندا'),
(91740, 3560939912, 3560939915, 'RE', 'REU', 'ريونيون'),
(91741, 3560939916, 3560939919, 'ES', 'ESP', 'إسبانيا'),
(91742, 3560939920, 3560939927, 'DE', 'DEU', 'ألمانيا'),
(91743, 3560939928, 3560939931, 'NL', 'NLD', 'هولندا'),
(91744, 3560939932, 3560939935, 'IT', 'ITA', 'إيطاليا'),
(91745, 3560939936, 3560939939, 'DE', 'DEU', 'ألمانيا'),
(91746, 3560939940, 3560939943, 'AT', 'AUT', 'النمسا'),
(91747, 3560939944, 3560939951, 'FR', 'FRA', 'فرنسا'),
(91748, 3560939952, 3560939955, 'DE', 'DEU', 'ألمانيا'),
(91749, 3560939956, 3560939959, 'AT', 'AUT', 'النمسا'),
(91750, 3560939960, 3560939963, 'CH', 'CHE', 'سويسرا'),
(91751, 3560939964, 3560939967, 'DE', 'DEU', 'ألمانيا'),
(91752, 3560939968, 3560939971, 'ES', 'ESP', 'إسبانيا'),
(91753, 3560939972, 3560939975, 'DE', 'DEU', 'ألمانيا'),
(91754, 3560939976, 3560939983, 'BE', 'BEL', 'بلجيكا'),
(91755, 3560939984, 3560939987, 'FR', 'FRA', 'فرنسا'),
(91756, 3560939988, 3560939991, 'ES', 'ESP', 'إسبانيا'),
(91757, 3560939992, 3560939995, 'IT', 'ITA', 'إيطاليا'),
(91758, 3560939996, 3560939999, 'DE', 'DEU', 'ألمانيا'),
(91759, 3560940000, 3560940007, 'ES', 'ESP', 'إسبانيا'),
(91760, 3560940008, 3560940015, 'DE', 'DEU', 'ألمانيا'),
(91761, 3560940016, 3560940019, 'BE', 'BEL', 'بلجيكا'),
(91762, 3560940020, 3560940023, 'GB', 'GBR', 'المملكة المتحدة'),
(91763, 3560940024, 3560940027, 'GR', 'GRC', 'اليونان'),
(91764, 3560940028, 3560940043, 'DE', 'DEU', 'ألمانيا'),
(91765, 3560940044, 3560940047, 'GB', 'GBR', 'المملكة المتحدة'),
(91766, 3560940048, 3560940051, 'ES', 'ESP', 'إسبانيا'),
(91767, 3560940052, 3560940055, 'BE', 'BEL', 'بلجيكا'),
(91768, 3560940056, 3560940059, 'NL', 'NLD', 'هولندا'),
(91769, 3560940060, 3560940063, 'LU', 'LUX', 'لوكسيمبورغ'),
(91770, 3560940064, 3560940067, 'CH', 'CHE', 'سويسرا'),
(91771, 3560940068, 3560940071, 'FR', 'FRA', 'فرنسا'),
(91772, 3560940072, 3560940075, 'DE', 'DEU', 'ألمانيا'),
(91773, 3560940076, 3560940079, 'ES', 'ESP', 'إسبانيا'),
(91774, 3560940080, 3560940087, 'DE', 'DEU', 'ألمانيا'),
(91775, 3560940088, 3560940091, 'IT', 'ITA', 'إيطاليا'),
(91776, 3560940092, 3560940095, 'CH', 'CHE', 'سويسرا'),
(91777, 3560940096, 3560940099, 'IT', 'ITA', 'إيطاليا'),
(91778, 3560940100, 3560940103, 'FR', 'FRA', 'فرنسا'),
(91779, 3560940104, 3560940115, 'DE', 'DEU', 'ألمانيا'),
(91780, 3560940116, 3560940119, 'FR', 'FRA', 'فرنسا'),
(91781, 3560940120, 3560940123, 'GB', 'GBR', 'المملكة المتحدة'),
(91782, 3560940124, 3560940127, 'DE', 'DEU', 'ألمانيا'),
(91783, 3560940128, 3560940135, 'IT', 'ITA', 'إيطاليا'),
(91784, 3560940136, 3560940139, 'AT', 'AUT', 'النمسا'),
(91785, 3560940140, 3560940143, 'HU', 'HUN', 'هنغاريا'),
(91786, 3560940144, 3560940147, 'DE', 'DEU', 'ألمانيا'),
(91787, 3560940148, 3560940151, 'IT', 'ITA', 'إيطاليا'),
(91788, 3560940152, 3560940155, 'FR', 'FRA', 'فرنسا'),
(91789, 3560940156, 3560940159, 'ES', 'ESP', 'إسبانيا'),
(91790, 3560940160, 3560940163, 'IT', 'ITA', 'إيطاليا'),
(91791, 3560940164, 3560940171, 'FR', 'FRA', 'فرنسا'),
(91792, 3560940172, 3560940175, 'DE', 'DEU', 'ألمانيا'),
(91793, 3560940176, 3560940179, 'FR', 'FRA', 'فرنسا'),
(91794, 3560940180, 3560940183, 'BE', 'BEL', 'بلجيكا'),
(91795, 3560940184, 3560940187, 'FR', 'FRA', 'فرنسا'),
(91796, 3560940188, 3560940191, 'IT', 'ITA', 'إيطاليا'),
(91797, 3560940192, 3560940195, 'AT', 'AUT', 'النمسا'),
(91798, 3560940196, 3560940199, 'DE', 'DEU', 'ألمانيا'),
(91799, 3560940200, 3560940203, 'CY', 'CYP', 'قبرص'),
(91800, 3560940204, 3560940207, 'DE', 'DEU', 'ألمانيا'),
(91801, 3560940208, 3560940211, 'ES', 'ESP', 'إسبانيا'),
(91802, 3560940212, 3560940215, 'FR', 'FRA', 'فرنسا'),
(91803, 3560940216, 3560940219, 'IE', 'IRL', 'إيرلندا'),
(91804, 3560940220, 3560940227, 'DE', 'DEU', 'ألمانيا'),
(91805, 3560940228, 3560940231, 'CH', 'CHE', 'سويسرا'),
(91806, 3560940232, 3560940235, 'IT', 'ITA', 'إيطاليا'),
(91807, 3560940236, 3560940239, 'DE', 'DEU', 'ألمانيا'),
(91808, 3560940240, 3560940243, 'PT', 'PRT', 'البورتوغال'),
(91809, 3560940244, 3560940247, 'GB', 'GBR', 'المملكة المتحدة'),
(91810, 3560940248, 3560940251, 'DE', 'DEU', 'ألمانيا'),
(91811, 3560940252, 3560940255, 'CH', 'CHE', 'سويسرا'),
(91812, 3560940256, 3560940263, 'DE', 'DEU', 'ألمانيا'),
(91813, 3560940264, 3560940267, 'AT', 'AUT', 'النمسا'),
(91814, 3560940268, 3560940275, 'GB', 'GBR', 'المملكة المتحدة'),
(91815, 3560940276, 3560940279, 'FR', 'FRA', 'فرنسا'),
(91816, 3560940280, 3560940283, 'AT', 'AUT', 'النمسا'),
(91817, 3560940284, 3560940287, 'DE', 'DEU', 'ألمانيا'),
(91818, 3560940288, 3560940291, 'FR', 'FRA', 'فرنسا'),
(91819, 3560940292, 3560940307, 'DE', 'DEU', 'ألمانيا'),
(91820, 3560940308, 3560940311, 'BE', 'BEL', 'بلجيكا'),
(91821, 3560940312, 3560940327, 'DE', 'DEU', 'ألمانيا'),
(91822, 3560940328, 3560940331, 'ES', 'ESP', 'إسبانيا'),
(91823, 3560940332, 3560940339, 'DE', 'DEU', 'ألمانيا'),
(91824, 3560940340, 3560940343, 'CH', 'CHE', 'سويسرا'),
(91825, 3560940344, 3560940347, 'NL', 'NLD', 'هولندا'),
(91826, 3560940348, 3560940367, 'DE', 'DEU', 'ألمانيا'),
(91827, 3560940368, 3560940371, 'FR', 'FRA', 'فرنسا'),
(91828, 3560940372, 3560940379, 'CH', 'CHE', 'سويسرا'),
(91829, 3560940380, 3560940387, 'DE', 'DEU', 'ألمانيا'),
(91830, 3560940388, 3560940391, 'ES', 'ESP', 'إسبانيا'),
(91831, 3560940392, 3560940395, 'DE', 'DEU', 'ألمانيا'),
(91832, 3560940396, 3560940399, 'IL', 'ISR', 'إسرائيل'),
(91833, 3560940400, 3560940403, 'CH', 'CHE', 'سويسرا'),
(91834, 3560940404, 3560940407, 'DE', 'DEU', 'ألمانيا'),
(91835, 3560940408, 3560940411, 'IT', 'ITA', 'إيطاليا'),
(91836, 3560940412, 3560940419, 'DE', 'DEU', 'ألمانيا'),
(91837, 3560940420, 3560940423, 'GR', 'GRC', 'اليونان'),
(91838, 3560940424, 3560940431, 'DE', 'DEU', 'ألمانيا'),
(91839, 3560940432, 3560940435, 'FR', 'FRA', 'فرنسا'),
(91840, 3560940436, 3560940439, 'DE', 'DEU', 'ألمانيا'),
(91841, 3560940440, 3560940443, 'BE', 'BEL', 'بلجيكا'),
(91842, 3560940444, 3560940447, 'SL', 'SLE', 'سيراليون'),
(91843, 3560940448, 3560940451, 'DE', 'DEU', 'ألمانيا'),
(91844, 3560940452, 3560940455, 'NL', 'NLD', 'هولندا'),
(91845, 3560940456, 3560940459, 'DE', 'DEU', 'ألمانيا'),
(91846, 3560940460, 3560940463, 'HU', 'HUN', 'هنغاريا'),
(91847, 3560940464, 3560940467, 'CY', 'CYP', 'قبرص'),
(91848, 3560940468, 3560940471, 'DE', 'DEU', 'ألمانيا'),
(91849, 3560940472, 3560940475, 'FR', 'FRA', 'فرنسا'),
(91850, 3560940476, 3560940479, 'CH', 'CHE', 'سويسرا'),
(91851, 3560940480, 3560940487, 'ES', 'ESP', 'إسبانيا'),
(91852, 3560940488, 3560940491, 'CZ', 'CZE', 'التشيك'),
(91853, 3560940492, 3560940495, 'ES', 'ESP', 'إسبانيا'),
(91854, 3560940496, 3560940499, 'IT', 'ITA', 'إيطاليا'),
(91855, 3560940500, 3560940503, 'DE', 'DEU', 'ألمانيا'),
(91856, 3560940504, 3560940507, 'GB', 'GBR', 'المملكة المتحدة'),
(91857, 3560940508, 3560940511, 'IT', 'ITA', 'إيطاليا'),
(91858, 3560940512, 3560940523, 'DE', 'DEU', 'ألمانيا'),
(91859, 3560940524, 3560940527, 'FR', 'FRA', 'فرنسا'),
(91860, 3560940528, 3560940531, 'DE', 'DEU', 'ألمانيا'),
(91861, 3560940532, 3560940535, 'FR', 'FRA', 'فرنسا'),
(91862, 3560940536, 3560940539, 'HU', 'HUN', 'هنغاريا'),
(91863, 3560940540, 3560940543, 'IT', 'ITA', 'إيطاليا'),
(91864, 3560940544, 3560940547, 'DE', 'DEU', 'ألمانيا'),
(91865, 3560940548, 3560940551, 'IE', 'IRL', 'إيرلندا'),
(91866, 3560940552, 3560940563, 'DE', 'DEU', 'ألمانيا'),
(91867, 3560940564, 3560940567, 'GB', 'GBR', 'المملكة المتحدة'),
(91868, 3560940568, 3560940571, 'DE', 'DEU', 'ألمانيا'),
(91869, 3560940572, 3560940575, 'DK', 'DNK', 'الدنيمارك'),
(91870, 3560940576, 3560940579, 'ES', 'ESP', 'إسبانيا'),
(91871, 3560940580, 3560940583, 'IT', 'ITA', 'إيطاليا'),
(91872, 3560940584, 3560940587, 'FR', 'FRA', 'فرنسا'),
(91873, 3560940588, 3560940591, 'IT', 'ITA', 'إيطاليا'),
(91874, 3560940592, 3560940595, 'GR', 'GRC', 'اليونان'),
(91875, 3560940596, 3560940599, 'CH', 'CHE', 'سويسرا'),
(91876, 3560940600, 3560940603, 'MA', 'MAR', 'المغرب'),
(91877, 3560940604, 3560940607, 'GB', 'GBR', 'المملكة المتحدة'),
(91878, 3560940608, 3560940611, 'FR', 'FRA', 'فرنسا'),
(91879, 3560940612, 3560940615, 'CH', 'CHE', 'سويسرا'),
(91880, 3560940616, 3560940619, 'DE', 'DEU', 'ألمانيا'),
(91881, 3560940620, 3560940623, 'AT', 'AUT', 'النمسا'),
(91882, 3560940624, 3560940627, 'SM', 'SMR', 'سان مارينو'),
(91883, 3560940628, 3560940631, 'PL', 'POL', 'بولندا'),
(91884, 3560940632, 3560940635, 'AT', 'AUT', 'النمسا'),
(91885, 3560940636, 3560940639, 'DE', 'DEU', 'ألمانيا'),
(91886, 3560940640, 3560940647, 'GB', 'GBR', 'المملكة المتحدة'),
(91887, 3560940648, 3560940655, 'DE', 'DEU', 'ألمانيا'),
(91888, 3560940656, 3560940663, 'IT', 'ITA', 'إيطاليا'),
(91889, 3560940664, 3560940683, 'DE', 'DEU', 'ألمانيا'),
(91890, 3560940684, 3560940687, 'DK', 'DNK', 'الدنيمارك'),
(91891, 3560940688, 3560940691, 'IT', 'ITA', 'إيطاليا'),
(91892, 3560940692, 3560940695, 'NO', 'NOR', 'النرويج'),
(91893, 3560940696, 3560940699, 'FR', 'FRA', 'فرنسا'),
(91894, 3560940700, 3560940703, 'GB', 'GBR', 'المملكة المتحدة'),
(91895, 3560940704, 3560940707, 'ES', 'ESP', 'إسبانيا'),
(91896, 3560940708, 3560940711, 'BE', 'BEL', 'بلجيكا'),
(91897, 3560940712, 3560940715, 'DE', 'DEU', 'ألمانيا'),
(91898, 3560940716, 3560940719, 'ES', 'ESP', 'إسبانيا'),
(91899, 3560940720, 3560940723, 'PL', 'POL', 'بولندا'),
(91900, 3560940724, 3560940727, 'DE', 'DEU', 'ألمانيا'),
(91901, 3560940728, 3560940731, 'FR', 'FRA', 'فرنسا'),
(91902, 3560940732, 3560940735, 'DE', 'DEU', 'ألمانيا'),
(91903, 3560940736, 3560940739, 'DK', 'DNK', 'الدنيمارك'),
(91904, 3560940740, 3560940743, 'IT', 'ITA', 'إيطاليا'),
(91905, 3560940744, 3560940751, 'DE', 'DEU', 'ألمانيا'),
(91906, 3560940752, 3560940755, 'IE', 'IRL', 'إيرلندا'),
(91907, 3560940756, 3560940763, 'FR', 'FRA', 'فرنسا'),
(91908, 3560940764, 3560940767, 'CH', 'CHE', 'سويسرا'),
(91909, 3560940768, 3560940779, 'DE', 'DEU', 'ألمانيا'),
(91910, 3560940780, 3560940783, 'IT', 'ITA', 'إيطاليا'),
(91911, 3560940784, 3560940787, 'NL', 'NLD', 'هولندا'),
(91912, 3560940788, 3560940791, 'GB', 'GBR', 'المملكة المتحدة'),
(91913, 3560940792, 3560940799, 'ES', 'ESP', 'إسبانيا'),
(91914, 3560940800, 3560940803, 'DE', 'DEU', 'ألمانيا'),
(91915, 3560940804, 3560940807, 'GB', 'GBR', 'المملكة المتحدة'),
(91916, 3560940808, 3560940811, 'IT', 'ITA', 'إيطاليا'),
(91917, 3560940812, 3560940815, 'DE', 'DEU', 'ألمانيا'),
(91918, 3560940816, 3560940819, 'FR', 'FRA', 'فرنسا'),
(91919, 3560940820, 3560940823, 'NL', 'NLD', 'هولندا'),
(91920, 3560940824, 3560940827, 'IT', 'ITA', 'إيطاليا'),
(91921, 3560940828, 3560940831, 'ES', 'ESP', 'إسبانيا'),
(91922, 3560940832, 3560940839, 'DE', 'DEU', 'ألمانيا'),
(91923, 3560940840, 3560940843, 'IT', 'ITA', 'إيطاليا'),
(91924, 3560940844, 3560940851, 'ES', 'ESP', 'إسبانيا'),
(91925, 3560940852, 3560940859, 'DE', 'DEU', 'ألمانيا'),
(91926, 3560940860, 3560940863, 'PT', 'PRT', 'البورتوغال'),
(91927, 3560940864, 3560940867, 'IT', 'ITA', 'إيطاليا'),
(91928, 3560940868, 3560940875, 'DE', 'DEU', 'ألمانيا'),
(91929, 3560940876, 3560940879, 'FR', 'FRA', 'فرنسا'),
(91930, 3560940880, 3560940883, 'IT', 'ITA', 'إيطاليا'),
(91931, 3560940884, 3560940887, 'NL', 'NLD', 'هولندا'),
(91932, 3560940888, 3560940891, 'LU', 'LUX', 'لوكسيمبورغ'),
(91933, 3560940892, 3560940895, 'ES', 'ESP', 'إسبانيا'),
(91934, 3560940896, 3560940899, 'DE', 'DEU', 'ألمانيا'),
(91935, 3560940900, 3560940903, 'NL', 'NLD', 'هولندا'),
(91936, 3560940904, 3560940907, 'DE', 'DEU', 'ألمانيا'),
(91937, 3560940908, 3560940915, 'GB', 'GBR', 'المملكة المتحدة'),
(91938, 3560940916, 3560940923, 'DE', 'DEU', 'ألمانيا'),
(91939, 3560940924, 3560940927, 'ES', 'ESP', 'إسبانيا'),
(91940, 3560940928, 3560940931, 'GR', 'GRC', 'اليونان'),
(91941, 3560940932, 3560940935, 'CH', 'CHE', 'سويسرا'),
(91942, 3560940936, 3560940939, 'IT', 'ITA', 'إيطاليا'),
(91943, 3560940940, 3560940951, 'DE', 'DEU', 'ألمانيا'),
(91944, 3560940952, 3560940955, 'AT', 'AUT', 'النمسا'),
(91945, 3560940956, 3560940963, 'NL', 'NLD', 'هولندا'),
(91946, 3560940964, 3560940967, 'DE', 'DEU', 'ألمانيا'),
(91947, 3560940968, 3560940971, 'NL', 'NLD', 'هولندا'),
(91948, 3560940972, 3560940975, 'DE', 'DEU', 'ألمانيا'),
(91949, 3560940976, 3560940979, 'FR', 'FRA', 'فرنسا'),
(91950, 3560940980, 3560940983, 'LU', 'LUX', 'لوكسيمبورغ'),
(91951, 3560940984, 3560940987, 'IT', 'ITA', 'إيطاليا'),
(91952, 3560940988, 3560940995, 'DE', 'DEU', 'ألمانيا'),
(91953, 3560940996, 3560940999, 'DK', 'DNK', 'الدنيمارك'),
(91954, 3560941000, 3560941003, 'ES', 'ESP', 'إسبانيا'),
(91955, 3560941004, 3560941007, 'PL', 'POL', 'بولندا'),
(91956, 3560941008, 3560941011, 'DE', 'DEU', 'ألمانيا'),
(91957, 3560941012, 3560941015, 'FR', 'FRA', 'فرنسا'),
(91958, 3560941016, 3560941019, 'DE', 'DEU', 'ألمانيا'),
(91959, 3560941020, 3560941023, 'IT', 'ITA', 'إيطاليا'),
(91960, 3560941024, 3560941027, 'FR', 'FRA', 'فرنسا'),
(91961, 3560941028, 3560941031, 'CH', 'CHE', 'سويسرا'),
(91962, 3560941032, 3560941035, 'FR', 'FRA', 'فرنسا'),
(91963, 3560941036, 3560941039, 'DE', 'DEU', 'ألمانيا'),
(91964, 3560941040, 3560941043, 'FR', 'FRA', 'فرنسا'),
(91965, 3560941044, 3560941047, 'DE', 'DEU', 'ألمانيا'),
(91966, 3560941048, 3560941051, 'GR', 'GRC', 'اليونان'),
(91967, 3560941052, 3560941059, 'FR', 'FRA', 'فرنسا'),
(91968, 3560941060, 3560941063, 'GB', 'GBR', 'المملكة المتحدة'),
(91969, 3560941064, 3560941071, 'FR', 'FRA', 'فرنسا'),
(91970, 3560941072, 3560941075, 'NL', 'NLD', 'هولندا'),
(91971, 3560941076, 3560941079, 'GB', 'GBR', 'المملكة المتحدة'),
(91972, 3560941080, 3560941083, 'BE', 'BEL', 'بلجيكا'),
(91973, 3560941084, 3560941087, 'IT', 'ITA', 'إيطاليا'),
(91974, 3560941088, 3560941091, 'DE', 'DEU', 'ألمانيا'),
(91975, 3560941092, 3560941095, 'BE', 'BEL', 'بلجيكا'),
(91976, 3560941096, 3560941099, 'AT', 'AUT', 'النمسا'),
(91977, 3560941100, 3560941103, 'IT', 'ITA', 'إيطاليا'),
(91978, 3560941104, 3560941107, 'FR', 'FRA', 'فرنسا'),
(91979, 3560941108, 3560941119, 'DE', 'DEU', 'ألمانيا'),
(91980, 3560941120, 3560941123, 'BE', 'BEL', 'بلجيكا'),
(91981, 3560941124, 3560941127, 'FR', 'FRA', 'فرنسا'),
(91982, 3560941128, 3560941131, 'DE', 'DEU', 'ألمانيا'),
(91983, 3560941132, 3560941135, 'GB', 'GBR', 'المملكة المتحدة'),
(91984, 3560941136, 3560941139, 'ES', 'ESP', 'إسبانيا'),
(91985, 3560941140, 3560941147, 'DE', 'DEU', 'ألمانيا'),
(91986, 3560941148, 3560941151, 'IT', 'ITA', 'إيطاليا'),
(91987, 3560941152, 3560941155, 'DK', 'DNK', 'الدنيمارك'),
(91988, 3560941156, 3560941159, 'ES', 'ESP', 'إسبانيا'),
(91989, 3560941160, 3560941163, 'IT', 'ITA', 'إيطاليا'),
(91990, 3560941164, 3560941167, 'DE', 'DEU', 'ألمانيا'),
(91991, 3560941168, 3560941171, 'NL', 'NLD', 'هولندا'),
(91992, 3560941172, 3560941175, 'DE', 'DEU', 'ألمانيا'),
(91993, 3560941176, 3560941179, 'ES', 'ESP', 'إسبانيا'),
(91994, 3560941180, 3560941183, 'GB', 'GBR', 'المملكة المتحدة'),
(91995, 3560941184, 3560941187, 'IT', 'ITA', 'إيطاليا'),
(91996, 3560941188, 3560941191, 'ES', 'ESP', 'إسبانيا'),
(91997, 3560941192, 3560941195, 'CH', 'CHE', 'سويسرا'),
(91998, 3560941196, 3560941199, 'FR', 'FRA', 'فرنسا'),
(91999, 3560941200, 3560941203, 'DE', 'DEU', 'ألمانيا'),
(92000, 3560941204, 3560941207, 'IT', 'ITA', 'إيطاليا'),
(92001, 3560941208, 3560941211, 'MA', 'MAR', 'المغرب'),
(92002, 3560941212, 3560941215, 'DE', 'DEU', 'ألمانيا'),
(92003, 3560941216, 3560941219, 'NL', 'NLD', 'هولندا'),
(92004, 3560941220, 3560941223, 'GB', 'GBR', 'المملكة المتحدة'),
(92005, 3560941224, 3560941227, 'DE', 'DEU', 'ألمانيا'),
(92006, 3560941228, 3560941231, 'SE', 'SWE', 'السويد'),
(92007, 3560941232, 3560941235, 'FR', 'FRA', 'فرنسا'),
(92008, 3560941236, 3560941243, 'DE', 'DEU', 'ألمانيا'),
(92009, 3560941244, 3560941251, 'IT', 'ITA', 'إيطاليا'),
(92010, 3560941252, 3560941255, 'FR', 'FRA', 'فرنسا'),
(92011, 3560941256, 3560941259, 'AT', 'AUT', 'النمسا'),
(92012, 3560941260, 3560941263, 'GB', 'GBR', 'المملكة المتحدة'),
(92013, 3560941264, 3560941271, 'ES', 'ESP', 'إسبانيا'),
(92014, 3560941272, 3560941275, 'DK', 'DNK', 'الدنيمارك'),
(92015, 3560941276, 3560941279, 'GR', 'GRC', 'اليونان'),
(92016, 3560941280, 3560941283, 'NL', 'NLD', 'هولندا'),
(92017, 3560941284, 3560941287, 'DE', 'DEU', 'ألمانيا'),
(92018, 3560941288, 3560941291, 'ES', 'ESP', 'إسبانيا'),
(92019, 3560941292, 3560941295, 'DE', 'DEU', 'ألمانيا'),
(92020, 3560941296, 3560941303, 'IT', 'ITA', 'إيطاليا'),
(92021, 3560941304, 3560941307, 'FR', 'FRA', 'فرنسا'),
(92022, 3560941308, 3560941315, 'DE', 'DEU', 'ألمانيا'),
(92023, 3560941316, 3560941319, 'SE', 'SWE', 'السويد'),
(92024, 3560941320, 3560941323, 'ES', 'ESP', 'إسبانيا'),
(92025, 3560941324, 3560941331, 'IT', 'ITA', 'إيطاليا'),
(92026, 3560941332, 3560941335, 'PT', 'PRT', 'البورتوغال'),
(92027, 3560941336, 3560941339, 'BE', 'BEL', 'بلجيكا'),
(92028, 3560941340, 3560941343, 'GB', 'GBR', 'المملكة المتحدة'),
(92029, 3560941344, 3560941347, 'FR', 'FRA', 'فرنسا'),
(92030, 3560941348, 3560941351, 'IE', 'IRL', 'إيرلندا'),
(92031, 3560941352, 3560941355, 'NL', 'NLD', 'هولندا'),
(92032, 3560941356, 3560941359, 'ES', 'ESP', 'إسبانيا'),
(92033, 3560941360, 3560941367, 'DE', 'DEU', 'ألمانيا'),
(92034, 3560941368, 3560941371, 'DK', 'DNK', 'الدنيمارك'),
(92035, 3560941372, 3560941379, 'DE', 'DEU', 'ألمانيا'),
(92036, 3560941380, 3560941383, 'CH', 'CHE', 'سويسرا'),
(92037, 3560941384, 3560941387, 'IE', 'IRL', 'إيرلندا'),
(92038, 3560941388, 3560941391, 'SE', 'SWE', 'السويد'),
(92039, 3560941392, 3560941395, 'DK', 'DNK', 'الدنيمارك'),
(92040, 3560941396, 3560941399, 'IS', 'ISL', 'أيسلندا'),
(92041, 3560941400, 3560941407, 'DE', 'DEU', 'ألمانيا'),
(92042, 3560941408, 3560941411, 'CH', 'CHE', 'سويسرا'),
(92043, 3560941412, 3560941415, 'IT', 'ITA', 'إيطاليا'),
(92044, 3560941416, 3560941419, 'DE', 'DEU', 'ألمانيا'),
(92045, 3560941420, 3560941423, 'FR', 'FRA', 'فرنسا'),
(92046, 3560941424, 3560941427, 'DE', 'DEU', 'ألمانيا'),
(92047, 3560941428, 3560941431, 'FR', 'FRA', 'فرنسا'),
(92048, 3560941432, 3560941435, 'DE', 'DEU', 'ألمانيا'),
(92049, 3560941436, 3560941439, 'IN', 'IND', 'الهند'),
(92050, 3560941440, 3560941443, 'DE', 'DEU', 'ألمانيا'),
(92051, 3560941444, 3560941447, 'ES', 'ESP', 'إسبانيا'),
(92052, 3560941448, 3560941459, 'GB', 'GBR', 'المملكة المتحدة'),
(92053, 3560941460, 3560941467, 'DE', 'DEU', 'ألمانيا'),
(92054, 3560941468, 3560941471, 'CH', 'CHE', 'سويسرا'),
(92055, 3560941472, 3560941475, 'BE', 'BEL', 'بلجيكا'),
(92056, 3560941476, 3560941479, 'ES', 'ESP', 'إسبانيا'),
(92057, 3560941480, 3560941483, 'DE', 'DEU', 'ألمانيا'),
(92058, 3560941484, 3560941487, 'ES', 'ESP', 'إسبانيا'),
(92059, 3560941488, 3560941491, 'DE', 'DEU', 'ألمانيا'),
(92060, 3560941492, 3560941495, 'GB', 'GBR', 'المملكة المتحدة'),
(92061, 3560941496, 3560941499, 'FR', 'FRA', 'فرنسا'),
(92062, 3560941500, 3560941503, 'ES', 'ESP', 'إسبانيا'),
(92063, 3560941504, 3560941507, 'DE', 'DEU', 'ألمانيا'),
(92064, 3560941508, 3560941511, 'IT', 'ITA', 'إيطاليا'),
(92065, 3560941512, 3560941515, 'AT', 'AUT', 'النمسا'),
(92066, 3560941516, 3560941519, 'SE', 'SWE', 'السويد'),
(92067, 3560941520, 3560941523, 'NO', 'NOR', 'النرويج'),
(92068, 3560941524, 3560941535, 'DE', 'DEU', 'ألمانيا'),
(92069, 3560941536, 3560941539, 'DK', 'DNK', 'الدنيمارك'),
(92070, 3560941540, 3560941543, 'FR', 'FRA', 'فرنسا'),
(92071, 3560941544, 3560941547, 'GB', 'GBR', 'المملكة المتحدة'),
(92072, 3560941548, 3560941551, 'DE', 'DEU', 'ألمانيا'),
(92073, 3560941552, 3560941555, 'IT', 'ITA', 'إيطاليا'),
(92074, 3560941556, 3560941559, 'DE', 'DEU', 'ألمانيا'),
(92075, 3560941560, 3560941563, 'GB', 'GBR', 'المملكة المتحدة'),
(92076, 3560941564, 3560941567, 'GR', 'GRC', 'اليونان'),
(92077, 3560941568, 3560941587, 'DE', 'DEU', 'ألمانيا'),
(92078, 3560941588, 3560941591, 'ES', 'ESP', 'إسبانيا'),
(92079, 3560941592, 3560941599, 'DE', 'DEU', 'ألمانيا'),
(92080, 3560941600, 3560941603, 'FR', 'FRA', 'فرنسا'),
(92081, 3560941604, 3560941607, 'CH', 'CHE', 'سويسرا'),
(92082, 3560941608, 3560941611, 'GB', 'GBR', 'المملكة المتحدة'),
(92083, 3560941612, 3560941623, 'DE', 'DEU', 'ألمانيا'),
(92084, 3560941624, 3560941627, 'GB', 'GBR', 'المملكة المتحدة'),
(92085, 3560941628, 3560941631, 'ES', 'ESP', 'إسبانيا'),
(92086, 3560941632, 3560941635, 'NL', 'NLD', 'هولندا'),
(92087, 3560941636, 3560941639, 'BE', 'BEL', 'بلجيكا'),
(92088, 3560941640, 3560941643, 'GB', 'GBR', 'المملكة المتحدة'),
(92089, 3560941644, 3560941647, 'BE', 'BEL', 'بلجيكا'),
(92090, 3560941648, 3560941651, 'NO', 'NOR', 'النرويج'),
(92091, 3560941652, 3560941655, 'DE', 'DEU', 'ألمانيا'),
(92092, 3560941656, 3560941659, 'GB', 'GBR', 'المملكة المتحدة'),
(92093, 3560941660, 3560941663, 'NL', 'NLD', 'هولندا'),
(92094, 3560941664, 3560941671, 'DE', 'DEU', 'ألمانيا'),
(92095, 3560941672, 3560941679, 'FR', 'FRA', 'فرنسا'),
(92096, 3560941680, 3560941683, 'GB', 'GBR', 'المملكة المتحدة'),
(92097, 3560941684, 3560941687, 'IT', 'ITA', 'إيطاليا'),
(92098, 3560941688, 3560941691, 'DE', 'DEU', 'ألمانيا'),
(92099, 3560941692, 3560941695, 'IT', 'ITA', 'إيطاليا'),
(92100, 3560941696, 3560941699, 'FR', 'FRA', 'فرنسا'),
(92101, 3560941700, 3560941703, 'GB', 'GBR', 'المملكة المتحدة'),
(92102, 3560941704, 3560941707, 'DE', 'DEU', 'ألمانيا'),
(92103, 3560941708, 3560941711, 'CH', 'CHE', 'سويسرا'),
(92104, 3560941712, 3560941715, 'FR', 'FRA', 'فرنسا'),
(92105, 3560941716, 3560941723, 'DE', 'DEU', 'ألمانيا'),
(92106, 3560941724, 3560941727, 'FR', 'FRA', 'فرنسا'),
(92107, 3560941728, 3560941735, 'DE', 'DEU', 'ألمانيا'),
(92108, 3560941736, 3560941739, 'NL', 'NLD', 'هولندا'),
(92109, 3560941740, 3560941743, 'NO', 'NOR', 'النرويج'),
(92110, 3560941744, 3560941747, 'FR', 'FRA', 'فرنسا'),
(92111, 3560941748, 3560941751, 'ES', 'ESP', 'إسبانيا'),
(92112, 3560941752, 3560941755, 'BE', 'BEL', 'بلجيكا'),
(92113, 3560941756, 3560941771, 'DE', 'DEU', 'ألمانيا'),
(92114, 3560941772, 3560941787, 'GB', 'GBR', 'المملكة المتحدة'),
(92115, 3560941788, 3560941791, 'DE', 'DEU', 'ألمانيا'),
(92116, 3560941792, 3560941795, 'ES', 'ESP', 'إسبانيا'),
(92117, 3560941796, 3560941799, 'FR', 'FRA', 'فرنسا'),
(92118, 3560941800, 3560941803, 'NL', 'NLD', 'هولندا'),
(92119, 3560941804, 3560941807, 'ES', 'ESP', 'إسبانيا'),
(92120, 3560941808, 3560941811, 'FR', 'FRA', 'فرنسا'),
(92121, 3560941812, 3560941815, 'NO', 'NOR', 'النرويج'),
(92122, 3560941816, 3560941819, 'FR', 'FRA', 'فرنسا'),
(92123, 3560941820, 3560941823, 'NL', 'NLD', 'هولندا'),
(92124, 3560941824, 3560941827, 'DE', 'DEU', 'ألمانيا'),
(92125, 3560941828, 3560941831, 'ES', 'ESP', 'إسبانيا'),
(92126, 3560941832, 3560941835, 'GB', 'GBR', 'المملكة المتحدة'),
(92127, 3560941836, 3560941839, 'DE', 'DEU', 'ألمانيا'),
(92128, 3560941840, 3560941843, 'GB', 'GBR', 'المملكة المتحدة'),
(92129, 3560941844, 3560941847, 'IT', 'ITA', 'إيطاليا'),
(92130, 3560941848, 3560941851, 'BE', 'BEL', 'بلجيكا'),
(92131, 3560941852, 3560941855, 'CH', 'CHE', 'سويسرا'),
(92132, 3560941856, 3560941859, 'BE', 'BEL', 'بلجيكا'),
(92133, 3560941860, 3560941867, 'DE', 'DEU', 'ألمانيا'),
(92134, 3560941868, 3560941871, 'AT', 'AUT', 'النمسا'),
(92135, 3560941872, 3560941875, 'GB', 'GBR', 'المملكة المتحدة'),
(92136, 3560941876, 3560941879, 'NL', 'NLD', 'هولندا'),
(92137, 3560941880, 3560941883, 'BG', 'BGR', 'بلغاريا'),
(92138, 3560941884, 3560941887, 'DE', 'DEU', 'ألمانيا'),
(92139, 3560941888, 3560941891, 'ES', 'ESP', 'إسبانيا'),
(92140, 3560941892, 3560941895, 'IT', 'ITA', 'إيطاليا'),
(92141, 3560941896, 3560941899, 'ES', 'ESP', 'إسبانيا'),
(92142, 3560941900, 3560941903, 'DE', 'DEU', 'ألمانيا'),
(92143, 3560941904, 3560941907, 'GB', 'GBR', 'المملكة المتحدة'),
(92144, 3560941908, 3560941911, 'DE', 'DEU', 'ألمانيا'),
(92145, 3560941912, 3560941919, 'FR', 'FRA', 'فرنسا'),
(92146, 3560941920, 3560941931, 'DE', 'DEU', 'ألمانيا'),
(92147, 3560941932, 3560941935, 'CH', 'CHE', 'سويسرا'),
(92148, 3560941936, 3560941947, 'DE', 'DEU', 'ألمانيا'),
(92149, 3560941948, 3560941951, 'DK', 'DNK', 'الدنيمارك'),
(92150, 3560941952, 3560941955, 'IT', 'ITA', 'إيطاليا'),
(92151, 3560941956, 3560941959, 'DE', 'DEU', 'ألمانيا'),
(92152, 3560941960, 3560941963, 'LU', 'LUX', 'لوكسيمبورغ'),
(92153, 3560941964, 3560941967, 'FR', 'FRA', 'فرنسا'),
(92154, 3560941968, 3560941971, 'DE', 'DEU', 'ألمانيا'),
(92155, 3560941972, 3560941975, 'DK', 'DNK', 'الدنيمارك'),
(92156, 3560941976, 3560941979, 'IT', 'ITA', 'إيطاليا'),
(92157, 3560941980, 3560941983, 'DE', 'DEU', 'ألمانيا'),
(92158, 3560941984, 3560941987, 'NL', 'NLD', 'هولندا'),
(92159, 3560941988, 3560941991, 'DE', 'DEU', 'ألمانيا'),
(92160, 3560941992, 3560941995, 'GB', 'GBR', 'المملكة المتحدة'),
(92161, 3560941996, 3560941999, 'BE', 'BEL', 'بلجيكا'),
(92162, 3560942000, 3560942003, 'FR', 'FRA', 'فرنسا'),
(92163, 3560942004, 3560942007, 'GB', 'GBR', 'المملكة المتحدة'),
(92164, 3560942008, 3560942011, 'IT', 'ITA', 'إيطاليا'),
(92165, 3560942012, 3560942015, 'DE', 'DEU', 'ألمانيا'),
(92166, 3560942016, 3560942019, 'NL', 'NLD', 'هولندا'),
(92167, 3560942020, 3560942023, 'ES', 'ESP', 'إسبانيا'),
(92168, 3560942024, 3560942027, 'CH', 'CHE', 'سويسرا'),
(92169, 3560942028, 3560942035, 'DE', 'DEU', 'ألمانيا'),
(92170, 3560942036, 3560942039, 'GB', 'GBR', 'المملكة المتحدة'),
(92171, 3560942040, 3560942047, 'DE', 'DEU', 'ألمانيا'),
(92172, 3560942048, 3560942051, 'IT', 'ITA', 'إيطاليا'),
(92173, 3560942052, 3560942055, 'DE', 'DEU', 'ألمانيا'),
(92174, 3560942056, 3560942059, 'IS', 'ISL', 'أيسلندا'),
(92175, 3560942060, 3560942063, 'GB', 'GBR', 'المملكة المتحدة'),
(92176, 3560942064, 3560942067, 'ES', 'ESP', 'إسبانيا'),
(92177, 3560942068, 3560942071, 'BE', 'BEL', 'بلجيكا'),
(92178, 3560942072, 3560942083, 'DE', 'DEU', 'ألمانيا'),
(92179, 3560942084, 3560942087, 'FR', 'FRA', 'فرنسا'),
(92180, 3560942088, 3560942095, 'DE', 'DEU', 'ألمانيا'),
(92181, 3560942096, 3560942099, 'FR', 'FRA', 'فرنسا'),
(92182, 3560942100, 3560942103, 'DE', 'DEU', 'ألمانيا'),
(92183, 3560942104, 3560942107, 'NL', 'NLD', 'هولندا'),
(92184, 3560942108, 3560942115, 'DE', 'DEU', 'ألمانيا'),
(92185, 3560942116, 3560942119, 'HU', 'HUN', 'هنغاريا'),
(92186, 3560942120, 3560942123, 'AT', 'AUT', 'النمسا'),
(92187, 3560942124, 3560942127, 'BE', 'BEL', 'بلجيكا'),
(92188, 3560942128, 3560942131, 'DE', 'DEU', 'ألمانيا'),
(92189, 3560942132, 3560942135, 'ES', 'ESP', 'إسبانيا'),
(92190, 3560942136, 3560942143, 'DE', 'DEU', 'ألمانيا'),
(92191, 3560942144, 3560942147, 'GB', 'GBR', 'المملكة المتحدة'),
(92192, 3560942148, 3560942151, 'DE', 'DEU', 'ألمانيا'),
(92193, 3560942152, 3560942155, 'IT', 'ITA', 'إيطاليا'),
(92194, 3560942156, 3560942159, 'ES', 'ESP', 'إسبانيا'),
(92195, 3560942160, 3560942163, 'DE', 'DEU', 'ألمانيا'),
(92196, 3560942164, 3560942171, 'ES', 'ESP', 'إسبانيا'),
(92197, 3560942172, 3560942175, 'SE', 'SWE', 'السويد'),
(92198, 3560942176, 3560942179, 'BE', 'BEL', 'بلجيكا'),
(92199, 3560942180, 3560942183, 'ES', 'ESP', 'إسبانيا'),
(92200, 3560942184, 3560942191, 'DE', 'DEU', 'ألمانيا'),
(92201, 3560942192, 3560942195, 'HU', 'HUN', 'هنغاريا'),
(92202, 3560942196, 3560942199, 'ES', 'ESP', 'إسبانيا'),
(92203, 3560942200, 3560942203, 'FR', 'FRA', 'فرنسا'),
(92204, 3560942204, 3560942207, 'AT', 'AUT', 'النمسا'),
(92205, 3560942208, 3560942211, 'DE', 'DEU', 'ألمانيا'),
(92206, 3560942212, 3560942219, 'IT', 'ITA', 'إيطاليا'),
(92207, 3560942220, 3560942227, 'FR', 'FRA', 'فرنسا'),
(92208, 3560942228, 3560942231, 'IT', 'ITA', 'إيطاليا'),
(92209, 3560942232, 3560942243, 'DE', 'DEU', 'ألمانيا'),
(92210, 3560942244, 3560942247, 'IT', 'ITA', 'إيطاليا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(92211, 3560942248, 3560942251, 'TR', 'TUR', 'تركيا'),
(92212, 3560942252, 3560942255, 'GB', 'GBR', 'المملكة المتحدة'),
(92213, 3560942256, 3560942259, 'DE', 'DEU', 'ألمانيا'),
(92214, 3560942260, 3560942263, 'ES', 'ESP', 'إسبانيا'),
(92215, 3560942264, 3560942267, 'NL', 'NLD', 'هولندا'),
(92216, 3560942268, 3560942271, 'DE', 'DEU', 'ألمانيا'),
(92217, 3560942272, 3560942275, 'PL', 'POL', 'بولندا'),
(92218, 3560942276, 3560942279, 'IT', 'ITA', 'إيطاليا'),
(92219, 3560942280, 3560942283, 'NL', 'NLD', 'هولندا'),
(92220, 3560942284, 3560942287, 'DK', 'DNK', 'الدنيمارك'),
(92221, 3560942288, 3560942291, 'FR', 'FRA', 'فرنسا'),
(92222, 3560942292, 3560942295, 'BH', 'BHR', 'البحرين'),
(92223, 3560942296, 3560942299, 'MA', 'MAR', 'المغرب'),
(92224, 3560942300, 3560942307, 'DE', 'DEU', 'ألمانيا'),
(92225, 3560942308, 3560942319, 'ES', 'ESP', 'إسبانيا'),
(92226, 3560942320, 3560942323, 'DE', 'DEU', 'ألمانيا'),
(92227, 3560942324, 3560942327, 'IT', 'ITA', 'إيطاليا'),
(92228, 3560942328, 3560942339, 'PT', 'PRT', 'البورتوغال'),
(92229, 3560942340, 3560942343, 'DE', 'DEU', 'ألمانيا'),
(92230, 3560942344, 3560942347, 'FR', 'FRA', 'فرنسا'),
(92231, 3560942348, 3560942351, 'GR', 'GRC', 'اليونان'),
(92232, 3560942352, 3560942355, 'ES', 'ESP', 'إسبانيا'),
(92233, 3560942356, 3560942359, 'IT', 'ITA', 'إيطاليا'),
(92234, 3560942360, 3560942363, 'AT', 'AUT', 'النمسا'),
(92235, 3560942364, 3560942367, 'DE', 'DEU', 'ألمانيا'),
(92236, 3560942368, 3560942375, 'FR', 'FRA', 'فرنسا'),
(92237, 3560942376, 3560942379, 'DE', 'DEU', 'ألمانيا'),
(92238, 3560942380, 3560942383, 'GB', 'GBR', 'المملكة المتحدة'),
(92239, 3560942384, 3560942387, 'DE', 'DEU', 'ألمانيا'),
(92240, 3560942388, 3560942391, 'IT', 'ITA', 'إيطاليا'),
(92241, 3560942392, 3560942407, 'DE', 'DEU', 'ألمانيا'),
(92242, 3560942408, 3560942411, 'GB', 'GBR', 'المملكة المتحدة'),
(92243, 3560942412, 3560942415, 'DE', 'DEU', 'ألمانيا'),
(92244, 3560942416, 3560942419, 'IT', 'ITA', 'إيطاليا'),
(92245, 3560942420, 3560942423, 'FR', 'FRA', 'فرنسا'),
(92246, 3560942424, 3560942427, 'NO', 'NOR', 'النرويج'),
(92247, 3560942428, 3560942447, 'DE', 'DEU', 'ألمانيا'),
(92248, 3560942448, 3560942455, 'CH', 'CHE', 'سويسرا'),
(92249, 3560942456, 3560942459, 'ES', 'ESP', 'إسبانيا'),
(92250, 3560942460, 3560942463, 'RU', 'RUS', 'الإتحاد الروسي'),
(92251, 3560942464, 3560942467, 'BE', 'BEL', 'بلجيكا'),
(92252, 3560942468, 3560942471, 'ES', 'ESP', 'إسبانيا'),
(92253, 3560942472, 3560942475, 'DE', 'DEU', 'ألمانيا'),
(92254, 3560942476, 3560942479, 'CH', 'CHE', 'سويسرا'),
(92255, 3560942480, 3560942483, 'ES', 'ESP', 'إسبانيا'),
(92256, 3560942484, 3560942487, 'HU', 'HUN', 'هنغاريا'),
(92257, 3560942488, 3560942495, 'FR', 'FRA', 'فرنسا'),
(92258, 3560942496, 3560942499, 'ES', 'ESP', 'إسبانيا'),
(92259, 3560942500, 3560942503, 'DE', 'DEU', 'ألمانيا'),
(92260, 3560942504, 3560942511, 'ES', 'ESP', 'إسبانيا'),
(92261, 3560942512, 3560942515, 'IT', 'ITA', 'إيطاليا'),
(92262, 3560942516, 3560942523, 'DE', 'DEU', 'ألمانيا'),
(92263, 3560942524, 3560942527, 'NL', 'NLD', 'هولندا'),
(92264, 3560942528, 3560942535, 'DE', 'DEU', 'ألمانيا'),
(92265, 3560942536, 3560942539, 'FR', 'FRA', 'فرنسا'),
(92266, 3560942540, 3560942543, 'DE', 'DEU', 'ألمانيا'),
(92267, 3560942544, 3560942547, 'CH', 'CHE', 'سويسرا'),
(92268, 3560942548, 3560942551, 'DK', 'DNK', 'الدنيمارك'),
(92269, 3560942552, 3560942555, 'DE', 'DEU', 'ألمانيا'),
(92270, 3560942556, 3560942559, 'FR', 'FRA', 'فرنسا'),
(92271, 3560942560, 3560942563, 'IT', 'ITA', 'إيطاليا'),
(92272, 3560942564, 3560942567, 'ES', 'ESP', 'إسبانيا'),
(92273, 3560942568, 3560942571, 'DE', 'DEU', 'ألمانيا'),
(92274, 3560942572, 3560942579, 'FR', 'FRA', 'فرنسا'),
(92275, 3560942580, 3560942583, 'DE', 'DEU', 'ألمانيا'),
(92276, 3560942584, 3560942587, 'GB', 'GBR', 'المملكة المتحدة'),
(92277, 3560942588, 3560942590, 'ES', 'ESP', 'إسبانيا'),
(92278, 3560942591, 3560942599, 'DE', 'DEU', 'ألمانيا'),
(92279, 3560942600, 3560942603, 'DK', 'DNK', 'الدنيمارك'),
(92280, 3560942604, 3560942607, 'LU', 'LUX', 'لوكسيمبورغ'),
(92281, 3560942608, 3560942619, 'DE', 'DEU', 'ألمانيا'),
(92282, 3560942620, 3560942623, 'BE', 'BEL', 'بلجيكا'),
(92283, 3560942624, 3560942627, 'IT', 'ITA', 'إيطاليا'),
(92284, 3560942628, 3560942631, 'GB', 'GBR', 'المملكة المتحدة'),
(92285, 3560942632, 3560942635, 'FR', 'FRA', 'فرنسا'),
(92286, 3560942636, 3560942643, 'DE', 'DEU', 'ألمانيا'),
(92287, 3560942644, 3560942647, 'FR', 'FRA', 'فرنسا'),
(92288, 3560942648, 3560942651, 'DE', 'DEU', 'ألمانيا'),
(92289, 3560942652, 3560942655, 'GR', 'GRC', 'اليونان'),
(92290, 3560942656, 3560942663, 'ES', 'ESP', 'إسبانيا'),
(92291, 3560942664, 3560942667, 'NL', 'NLD', 'هولندا'),
(92292, 3560942668, 3560942675, 'IT', 'ITA', 'إيطاليا'),
(92293, 3560942676, 3560942679, 'BE', 'BEL', 'بلجيكا'),
(92294, 3560942680, 3560942683, 'DE', 'DEU', 'ألمانيا'),
(92295, 3560942684, 3560942687, 'BE', 'BEL', 'بلجيكا'),
(92296, 3560942688, 3560942691, 'NL', 'NLD', 'هولندا'),
(92297, 3560942692, 3560942695, 'LU', 'LUX', 'لوكسيمبورغ'),
(92298, 3560942696, 3560942699, 'DE', 'DEU', 'ألمانيا'),
(92299, 3560942700, 3560942703, 'ES', 'ESP', 'إسبانيا'),
(92300, 3560942704, 3560942707, 'DE', 'DEU', 'ألمانيا'),
(92301, 3560942708, 3560942711, 'IT', 'ITA', 'إيطاليا'),
(92302, 3560942712, 3560942715, 'LU', 'LUX', 'لوكسيمبورغ'),
(92303, 3560942716, 3560942719, 'BE', 'BEL', 'بلجيكا'),
(92304, 3560942720, 3560942727, 'IT', 'ITA', 'إيطاليا'),
(92305, 3560942728, 3560942731, 'GB', 'GBR', 'المملكة المتحدة'),
(92306, 3560942732, 3560942735, 'DE', 'DEU', 'ألمانيا'),
(92307, 3560942736, 3560942739, 'CH', 'CHE', 'سويسرا'),
(92308, 3560942740, 3560942743, 'ES', 'ESP', 'إسبانيا'),
(92309, 3560942744, 3560942751, 'GB', 'GBR', 'المملكة المتحدة'),
(92310, 3560942752, 3560942763, 'DE', 'DEU', 'ألمانيا'),
(92311, 3560942764, 3560942767, 'FR', 'FRA', 'فرنسا'),
(92312, 3560942768, 3560942771, 'DE', 'DEU', 'ألمانيا'),
(92313, 3560942772, 3560942775, 'ES', 'ESP', 'إسبانيا'),
(92314, 3560942776, 3560942779, 'DE', 'DEU', 'ألمانيا'),
(92315, 3560942780, 3560942783, 'CH', 'CHE', 'سويسرا'),
(92316, 3560942784, 3560942787, 'DE', 'DEU', 'ألمانيا'),
(92317, 3560942788, 3560942791, 'HU', 'HUN', 'هنغاريا'),
(92318, 3560942792, 3560942795, 'DE', 'DEU', 'ألمانيا'),
(92319, 3560942796, 3560942799, 'FR', 'FRA', 'فرنسا'),
(92320, 3560942800, 3560942803, 'AT', 'AUT', 'النمسا'),
(92321, 3560942804, 3560942807, 'TR', 'TUR', 'تركيا'),
(92322, 3560942808, 3560942811, 'AT', 'AUT', 'النمسا'),
(92323, 3560942812, 3560942815, 'FR', 'FRA', 'فرنسا'),
(92324, 3560942816, 3560942819, 'TR', 'TUR', 'تركيا'),
(92325, 3560942820, 3560942823, 'ES', 'ESP', 'إسبانيا'),
(92326, 3560942824, 3560942827, 'GB', 'GBR', 'المملكة المتحدة'),
(92327, 3560942828, 3560942831, 'AT', 'AUT', 'النمسا'),
(92328, 3560942832, 3560942835, 'IT', 'ITA', 'إيطاليا'),
(92329, 3560942836, 3560942839, 'CH', 'CHE', 'سويسرا'),
(92330, 3560942840, 3560942843, 'BE', 'BEL', 'بلجيكا'),
(92331, 3560942844, 3560942847, 'ES', 'ESP', 'إسبانيا'),
(92332, 3560942848, 3560942851, 'IT', 'ITA', 'إيطاليا'),
(92333, 3560942852, 3560942855, 'ES', 'ESP', 'إسبانيا'),
(92334, 3560942856, 3560942859, 'DE', 'DEU', 'ألمانيا'),
(92335, 3560942860, 3560942863, 'IT', 'ITA', 'إيطاليا'),
(92336, 3560942864, 3560942871, 'DE', 'DEU', 'ألمانيا'),
(92337, 3560942872, 3560942875, 'IT', 'ITA', 'إيطاليا'),
(92338, 3560942876, 3560942879, 'PL', 'POL', 'بولندا'),
(92339, 3560942880, 3560942883, 'GB', 'GBR', 'المملكة المتحدة'),
(92340, 3560942884, 3560942887, 'DE', 'DEU', 'ألمانيا'),
(92341, 3560942888, 3560942891, 'FR', 'FRA', 'فرنسا'),
(92342, 3560942892, 3560942895, 'DE', 'DEU', 'ألمانيا'),
(92343, 3560942896, 3560942899, 'ES', 'ESP', 'إسبانيا'),
(92344, 3560942900, 3560942903, 'DE', 'DEU', 'ألمانيا'),
(92345, 3560942904, 3560942907, 'CH', 'CHE', 'سويسرا'),
(92346, 3560942908, 3560942911, 'DE', 'DEU', 'ألمانيا'),
(92347, 3560942912, 3560942915, 'ES', 'ESP', 'إسبانيا'),
(92348, 3560942916, 3560942919, 'BE', 'BEL', 'بلجيكا'),
(92349, 3560942920, 3560942923, 'DE', 'DEU', 'ألمانيا'),
(92350, 3560942924, 3560942927, 'IT', 'ITA', 'إيطاليا'),
(92351, 3560942928, 3560942931, 'SE', 'SWE', 'السويد'),
(92352, 3560942932, 3560942935, 'AT', 'AUT', 'النمسا'),
(92353, 3560942936, 3560942939, 'DE', 'DEU', 'ألمانيا'),
(92354, 3560942940, 3560942943, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(92355, 3560942944, 3560942951, 'DE', 'DEU', 'ألمانيا'),
(92356, 3560942952, 3560942955, 'ES', 'ESP', 'إسبانيا'),
(92357, 3560942956, 3560942959, 'DE', 'DEU', 'ألمانيا'),
(92358, 3560942960, 3560942963, 'GB', 'GBR', 'المملكة المتحدة'),
(92359, 3560942964, 3560942975, 'DE', 'DEU', 'ألمانيا'),
(92360, 3560942976, 3560942979, 'IT', 'ITA', 'إيطاليا'),
(92361, 3560942980, 3560942983, 'DE', 'DEU', 'ألمانيا'),
(92362, 3560942984, 3560942987, 'BE', 'BEL', 'بلجيكا'),
(92363, 3560942988, 3560942999, 'IT', 'ITA', 'إيطاليا'),
(92364, 3560943000, 3560943003, 'PL', 'POL', 'بولندا'),
(92365, 3560943004, 3560943007, 'DK', 'DNK', 'الدنيمارك'),
(92366, 3560943008, 3560943011, 'CH', 'CHE', 'سويسرا'),
(92367, 3560943012, 3560943015, 'IT', 'ITA', 'إيطاليا'),
(92368, 3560943016, 3560943019, 'ES', 'ESP', 'إسبانيا'),
(92369, 3560943020, 3560943023, 'DE', 'DEU', 'ألمانيا'),
(92370, 3560943024, 3560943027, 'GR', 'GRC', 'اليونان'),
(92371, 3560943028, 3560943031, 'DE', 'DEU', 'ألمانيا'),
(92372, 3560943032, 3560943035, 'FR', 'FRA', 'فرنسا'),
(92373, 3560943036, 3560943039, 'PL', 'POL', 'بولندا'),
(92374, 3560943040, 3560943043, 'NO', 'NOR', 'النرويج'),
(92375, 3560943044, 3560943047, 'ES', 'ESP', 'إسبانيا'),
(92376, 3560943048, 3560943051, 'HR', 'HRV', 'كرواتيا'),
(92377, 3560943052, 3560943055, 'CY', 'CYP', 'قبرص'),
(92378, 3560943056, 3560943059, 'BE', 'BEL', 'بلجيكا'),
(92379, 3560943060, 3560943075, 'DE', 'DEU', 'ألمانيا'),
(92380, 3560943076, 3560943079, 'ES', 'ESP', 'إسبانيا'),
(92381, 3560943080, 3560943095, 'DE', 'DEU', 'ألمانيا'),
(92382, 3560943096, 3560943099, 'PL', 'POL', 'بولندا'),
(92383, 3560943100, 3560943109, 'DE', 'DEU', 'ألمانيا'),
(92384, 3560943110, 3560943111, 'ES', 'ESP', 'إسبانيا'),
(92385, 3560943112, 3560943113, 'DE', 'DEU', 'ألمانيا'),
(92386, 3560943114, 3560943115, 'ES', 'ESP', 'إسبانيا'),
(92387, 3560943116, 3560943116, 'DK', 'DNK', 'الدنيمارك'),
(92388, 3560943117, 3560943117, 'IL', 'ISR', 'إسرائيل'),
(92389, 3560943118, 3560943118, 'DE', 'DEU', 'ألمانيا'),
(92390, 3560943119, 3560943119, 'IT', 'ITA', 'إيطاليا'),
(92391, 3560943120, 3560943120, 'DE', 'DEU', 'ألمانيا'),
(92392, 3560943121, 3560943121, 'CH', 'CHE', 'سويسرا'),
(92393, 3560943122, 3560943122, 'ES', 'ESP', 'إسبانيا'),
(92394, 3560943123, 3560943125, 'DE', 'DEU', 'ألمانيا'),
(92395, 3560943126, 3560943126, 'FR', 'FRA', 'فرنسا'),
(92396, 3560943127, 3560943127, 'HU', 'HUN', 'هنغاريا'),
(92397, 3560943128, 3560943129, 'DE', 'DEU', 'ألمانيا'),
(92398, 3560943130, 3560943130, 'BE', 'BEL', 'بلجيكا'),
(92399, 3560943131, 3560943131, 'RU', 'RUS', 'الإتحاد الروسي'),
(92400, 3560943132, 3560943132, 'BE', 'BEL', 'بلجيكا'),
(92401, 3560943133, 3560943133, 'ES', 'ESP', 'إسبانيا'),
(92402, 3560943134, 3560943136, 'DE', 'DEU', 'ألمانيا'),
(92403, 3560943137, 3560943137, 'ES', 'ESP', 'إسبانيا'),
(92404, 3560943138, 3560943138, 'CH', 'CHE', 'سويسرا'),
(92405, 3560943139, 3560943139, 'DE', 'DEU', 'ألمانيا'),
(92406, 3560943140, 3560943140, 'ES', 'ESP', 'إسبانيا'),
(92407, 3560943141, 3560943141, 'CH', 'CHE', 'سويسرا'),
(92408, 3560943142, 3560943142, 'DE', 'DEU', 'ألمانيا'),
(92409, 3560943143, 3560943145, 'HU', 'HUN', 'هنغاريا'),
(92410, 3560943146, 3560943146, 'IE', 'IRL', 'إيرلندا'),
(92411, 3560943147, 3560943147, 'CH', 'CHE', 'سويسرا'),
(92412, 3560943148, 3560943149, 'DE', 'DEU', 'ألمانيا'),
(92413, 3560943150, 3560943150, 'ES', 'ESP', 'إسبانيا'),
(92414, 3560943151, 3560943151, 'IT', 'ITA', 'إيطاليا'),
(92415, 3560943152, 3560943152, 'HU', 'HUN', 'هنغاريا'),
(92416, 3560943153, 3560943154, 'DE', 'DEU', 'ألمانيا'),
(92417, 3560943155, 3560943155, 'FR', 'FRA', 'فرنسا'),
(92418, 3560943156, 3560943157, 'DE', 'DEU', 'ألمانيا'),
(92419, 3560943158, 3560943158, 'FR', 'FRA', 'فرنسا'),
(92420, 3560943159, 3560943159, 'IT', 'ITA', 'إيطاليا'),
(92421, 3560943160, 3560943160, 'NO', 'NOR', 'النرويج'),
(92422, 3560943161, 3560943161, 'BE', 'BEL', 'بلجيكا'),
(92423, 3560943162, 3560943162, 'GR', 'GRC', 'اليونان'),
(92424, 3560943163, 3560943163, 'CH', 'CHE', 'سويسرا'),
(92425, 3560943164, 3560943164, 'PL', 'POL', 'بولندا'),
(92426, 3560943165, 3560943165, 'FR', 'FRA', 'فرنسا'),
(92427, 3560943166, 3560943166, 'GB', 'GBR', 'المملكة المتحدة'),
(92428, 3560943167, 3560943167, 'FR', 'FRA', 'فرنسا'),
(92429, 3560943168, 3560943168, 'ES', 'ESP', 'إسبانيا'),
(92430, 3560943169, 3560943169, 'DE', 'DEU', 'ألمانيا'),
(92431, 3560943170, 3560943170, 'ES', 'ESP', 'إسبانيا'),
(92432, 3560943171, 3560943171, 'IT', 'ITA', 'إيطاليا'),
(92433, 3560943172, 3560943172, 'ES', 'ESP', 'إسبانيا'),
(92434, 3560943173, 3560943173, 'BE', 'BEL', 'بلجيكا'),
(92435, 3560943174, 3560943175, 'DE', 'DEU', 'ألمانيا'),
(92436, 3560943176, 3560943177, 'CH', 'CHE', 'سويسرا'),
(92437, 3560943178, 3560943178, 'IT', 'ITA', 'إيطاليا'),
(92438, 3560943179, 3560943179, 'PL', 'POL', 'بولندا'),
(92439, 3560943180, 3560943180, 'GB', 'GBR', 'المملكة المتحدة'),
(92440, 3560943181, 3560943181, 'DE', 'DEU', 'ألمانيا'),
(92441, 3560943182, 3560943183, 'ES', 'ESP', 'إسبانيا'),
(92442, 3560943184, 3560943184, 'IT', 'ITA', 'إيطاليا'),
(92443, 3560943185, 3560943185, 'DK', 'DNK', 'الدنيمارك'),
(92444, 3560943186, 3560943186, 'ES', 'ESP', 'إسبانيا'),
(92445, 3560943187, 3560943187, 'PT', 'PRT', 'البورتوغال'),
(92446, 3560943188, 3560943188, 'IT', 'ITA', 'إيطاليا'),
(92447, 3560943189, 3560943192, 'DE', 'DEU', 'ألمانيا'),
(92448, 3560943193, 3560943193, 'ES', 'ESP', 'إسبانيا'),
(92449, 3560943194, 3560943194, 'AT', 'AUT', 'النمسا'),
(92450, 3560943195, 3560943195, 'PL', 'POL', 'بولندا'),
(92451, 3560943196, 3560943197, 'IT', 'ITA', 'إيطاليا'),
(92452, 3560943198, 3560943198, 'DE', 'DEU', 'ألمانيا'),
(92453, 3560943199, 3560943199, 'PT', 'PRT', 'البورتوغال'),
(92454, 3560943200, 3560943200, 'AT', 'AUT', 'النمسا'),
(92455, 3560943201, 3560943201, 'IT', 'ITA', 'إيطاليا'),
(92456, 3560943202, 3560943202, 'IL', 'ISR', 'إسرائيل'),
(92457, 3560943203, 3560943203, 'DE', 'DEU', 'ألمانيا'),
(92458, 3560943204, 3560943204, 'CH', 'CHE', 'سويسرا'),
(92459, 3560943205, 3560943205, 'IT', 'ITA', 'إيطاليا'),
(92460, 3560943206, 3560943207, 'DE', 'DEU', 'ألمانيا'),
(92461, 3560943208, 3560943208, 'AT', 'AUT', 'النمسا'),
(92462, 3560943209, 3560943210, 'ES', 'ESP', 'إسبانيا'),
(92463, 3560943211, 3560943211, 'FR', 'FRA', 'فرنسا'),
(92464, 3560943212, 3560943212, 'DE', 'DEU', 'ألمانيا'),
(92465, 3560943213, 3560943213, 'FR', 'FRA', 'فرنسا'),
(92466, 3560943214, 3560943214, 'PL', 'POL', 'بولندا'),
(92467, 3560943215, 3560943218, 'DE', 'DEU', 'ألمانيا'),
(92468, 3560943219, 3560943219, 'ES', 'ESP', 'إسبانيا'),
(92469, 3560943220, 3560943221, 'DE', 'DEU', 'ألمانيا'),
(92470, 3560943222, 3560943222, 'ES', 'ESP', 'إسبانيا'),
(92471, 3560943223, 3560943223, 'FR', 'FRA', 'فرنسا'),
(92472, 3560943224, 3560943224, 'DE', 'DEU', 'ألمانيا'),
(92473, 3560943225, 3560943226, 'GR', 'GRC', 'اليونان'),
(92474, 3560943227, 3560943227, 'DE', 'DEU', 'ألمانيا'),
(92475, 3560943228, 3560943230, 'NL', 'NLD', 'هولندا'),
(92476, 3560943231, 3560943232, 'FR', 'FRA', 'فرنسا'),
(92477, 3560943233, 3560943233, 'PL', 'POL', 'بولندا'),
(92478, 3560943234, 3560943234, 'EE', 'EST', 'إستونيا'),
(92479, 3560943235, 3560943235, 'CH', 'CHE', 'سويسرا'),
(92480, 3560943236, 3560943237, 'NL', 'NLD', 'هولندا'),
(92481, 3560943238, 3560943238, 'ES', 'ESP', 'إسبانيا'),
(92482, 3560943239, 3560943239, 'FR', 'FRA', 'فرنسا'),
(92483, 3560943240, 3560943240, 'GB', 'GBR', 'المملكة المتحدة'),
(92484, 3560943241, 3560943241, 'FR', 'FRA', 'فرنسا'),
(92485, 3560943242, 3560943242, 'DE', 'DEU', 'ألمانيا'),
(92486, 3560943243, 3560943243, 'FR', 'FRA', 'فرنسا'),
(92487, 3560943244, 3560943244, 'PL', 'POL', 'بولندا'),
(92488, 3560943245, 3560943245, 'CH', 'CHE', 'سويسرا'),
(92489, 3560943246, 3560943247, 'DE', 'DEU', 'ألمانيا'),
(92490, 3560943248, 3560943248, 'GR', 'GRC', 'اليونان'),
(92491, 3560943249, 3560943249, 'CH', 'CHE', 'سويسرا'),
(92492, 3560943250, 3560943250, 'AT', 'AUT', 'النمسا'),
(92493, 3560943251, 3560943251, 'GB', 'GBR', 'المملكة المتحدة'),
(92494, 3560943252, 3560943252, 'BE', 'BEL', 'بلجيكا'),
(92495, 3560943253, 3560943253, 'DE', 'DEU', 'ألمانيا'),
(92496, 3560943254, 3560943254, 'ES', 'ESP', 'إسبانيا'),
(92497, 3560943255, 3560943255, 'GB', 'GBR', 'المملكة المتحدة'),
(92498, 3560943256, 3560943256, 'DE', 'DEU', 'ألمانيا'),
(92499, 3560943257, 3560943257, 'ES', 'ESP', 'إسبانيا'),
(92500, 3560943258, 3560943258, 'FR', 'FRA', 'فرنسا'),
(92501, 3560943259, 3560943259, 'DE', 'DEU', 'ألمانيا'),
(92502, 3560943260, 3560943260, 'ES', 'ESP', 'إسبانيا'),
(92503, 3560943261, 3560943261, 'IE', 'IRL', 'إيرلندا'),
(92504, 3560943262, 3560943262, 'DE', 'DEU', 'ألمانيا'),
(92505, 3560943263, 3560943263, 'IT', 'ITA', 'إيطاليا'),
(92506, 3560943264, 3560943264, 'CZ', 'CZE', 'التشيك'),
(92507, 3560943265, 3560943265, 'DE', 'DEU', 'ألمانيا'),
(92508, 3560943266, 3560943266, 'GB', 'GBR', 'المملكة المتحدة'),
(92509, 3560943267, 3560943267, 'DE', 'DEU', 'ألمانيا'),
(92510, 3560943268, 3560943269, 'IT', 'ITA', 'إيطاليا'),
(92511, 3560943270, 3560943270, 'GB', 'GBR', 'المملكة المتحدة'),
(92512, 3560943271, 3560943271, 'IT', 'ITA', 'إيطاليا'),
(92513, 3560943272, 3560943272, 'ES', 'ESP', 'إسبانيا'),
(92514, 3560943273, 3560943273, 'FR', 'FRA', 'فرنسا'),
(92515, 3560943274, 3560943274, 'GB', 'GBR', 'المملكة المتحدة'),
(92516, 3560943275, 3560943275, 'DE', 'DEU', 'ألمانيا'),
(92517, 3560943276, 3560943276, 'FR', 'FRA', 'فرنسا'),
(92518, 3560943277, 3560943277, 'IT', 'ITA', 'إيطاليا'),
(92519, 3560943278, 3560943278, 'DE', 'DEU', 'ألمانيا'),
(92520, 3560943279, 3560943279, 'FR', 'FRA', 'فرنسا'),
(92521, 3560943280, 3560943280, 'GR', 'GRC', 'اليونان'),
(92522, 3560943281, 3560943281, 'ES', 'ESP', 'إسبانيا'),
(92523, 3560943282, 3560943282, 'FR', 'FRA', 'فرنسا'),
(92524, 3560943283, 3560943283, 'ES', 'ESP', 'إسبانيا'),
(92525, 3560943284, 3560943286, 'DE', 'DEU', 'ألمانيا'),
(92526, 3560943287, 3560943287, 'NL', 'NLD', 'هولندا'),
(92527, 3560943288, 3560943290, 'FR', 'FRA', 'فرنسا'),
(92528, 3560943291, 3560943292, 'IT', 'ITA', 'إيطاليا'),
(92529, 3560943293, 3560943293, 'ES', 'ESP', 'إسبانيا'),
(92530, 3560943294, 3560943294, 'IT', 'ITA', 'إيطاليا'),
(92531, 3560943295, 3560943295, 'DE', 'DEU', 'ألمانيا'),
(92532, 3560943296, 3560943296, 'RU', 'RUS', 'الإتحاد الروسي'),
(92533, 3560943297, 3560943297, 'ES', 'ESP', 'إسبانيا'),
(92534, 3560943298, 3560943298, 'FR', 'FRA', 'فرنسا'),
(92535, 3560943299, 3560943299, 'GB', 'GBR', 'المملكة المتحدة'),
(92536, 3560943300, 3560943300, 'DE', 'DEU', 'ألمانيا'),
(92537, 3560943301, 3560943301, 'FR', 'FRA', 'فرنسا'),
(92538, 3560943302, 3560943302, 'ES', 'ESP', 'إسبانيا'),
(92539, 3560943303, 3560943303, 'IT', 'ITA', 'إيطاليا'),
(92540, 3560943304, 3560943304, 'FR', 'FRA', 'فرنسا'),
(92541, 3560943305, 3560943306, 'DE', 'DEU', 'ألمانيا'),
(92542, 3560943307, 3560943307, 'ES', 'ESP', 'إسبانيا'),
(92543, 3560943308, 3560943309, 'DE', 'DEU', 'ألمانيا'),
(92544, 3560943310, 3560943311, 'IT', 'ITA', 'إيطاليا'),
(92545, 3560943312, 3560943312, 'PL', 'POL', 'بولندا'),
(92546, 3560943313, 3560943313, 'DE', 'DEU', 'ألمانيا'),
(92547, 3560943314, 3560943314, 'ES', 'ESP', 'إسبانيا'),
(92548, 3560943315, 3560943315, 'IT', 'ITA', 'إيطاليا'),
(92549, 3560943316, 3560943316, 'GB', 'GBR', 'المملكة المتحدة'),
(92550, 3560943317, 3560943317, 'IT', 'ITA', 'إيطاليا'),
(92551, 3560943318, 3560943318, 'CH', 'CHE', 'سويسرا'),
(92552, 3560943319, 3560943319, 'ES', 'ESP', 'إسبانيا'),
(92553, 3560943320, 3560943320, 'IT', 'ITA', 'إيطاليا'),
(92554, 3560943321, 3560943321, 'GB', 'GBR', 'المملكة المتحدة'),
(92555, 3560943322, 3560943322, 'DE', 'DEU', 'ألمانيا'),
(92556, 3560943323, 3560943323, 'NL', 'NLD', 'هولندا'),
(92557, 3560943324, 3560943324, 'DE', 'DEU', 'ألمانيا'),
(92558, 3560943325, 3560943325, 'CH', 'CHE', 'سويسرا'),
(92559, 3560943326, 3560943326, 'RU', 'RUS', 'الإتحاد الروسي'),
(92560, 3560943327, 3560943329, 'DE', 'DEU', 'ألمانيا'),
(92561, 3560943330, 3560943331, 'IT', 'ITA', 'إيطاليا'),
(92562, 3560943332, 3560943335, 'DE', 'DEU', 'ألمانيا'),
(92563, 3560943336, 3560943336, 'ES', 'ESP', 'إسبانيا'),
(92564, 3560943337, 3560943337, 'IT', 'ITA', 'إيطاليا'),
(92565, 3560943338, 3560943338, 'BE', 'BEL', 'بلجيكا'),
(92566, 3560943339, 3560943339, 'NL', 'NLD', 'هولندا'),
(92567, 3560943340, 3560943341, 'DE', 'DEU', 'ألمانيا'),
(92568, 3560943342, 3560943342, 'ES', 'ESP', 'إسبانيا'),
(92569, 3560943343, 3560943343, 'FR', 'FRA', 'فرنسا'),
(92570, 3560943344, 3560943344, 'NL', 'NLD', 'هولندا'),
(92571, 3560943345, 3560943345, 'CH', 'CHE', 'سويسرا'),
(92572, 3560943346, 3560943346, 'IT', 'ITA', 'إيطاليا'),
(92573, 3560943347, 3560943347, 'ES', 'ESP', 'إسبانيا'),
(92574, 3560943348, 3560943348, 'FR', 'FRA', 'فرنسا'),
(92575, 3560943349, 3560943349, 'DE', 'DEU', 'ألمانيا'),
(92576, 3560943350, 3560943350, 'BE', 'BEL', 'بلجيكا'),
(92577, 3560943351, 3560943351, 'SE', 'SWE', 'السويد'),
(92578, 3560943352, 3560943352, 'IT', 'ITA', 'إيطاليا'),
(92579, 3560943353, 3560943354, 'DE', 'DEU', 'ألمانيا'),
(92580, 3560943355, 3560943355, 'IT', 'ITA', 'إيطاليا'),
(92581, 3560943356, 3560943356, 'DE', 'DEU', 'ألمانيا'),
(92582, 3560943357, 3560943357, 'ES', 'ESP', 'إسبانيا'),
(92583, 3560943358, 3560943358, 'BE', 'BEL', 'بلجيكا'),
(92584, 3560943359, 3560943361, 'DE', 'DEU', 'ألمانيا'),
(92585, 3560943362, 3560943362, 'GB', 'GBR', 'المملكة المتحدة'),
(92586, 3560943363, 3560943365, 'DE', 'DEU', 'ألمانيا'),
(92587, 3560943366, 3560943367, 'IT', 'ITA', 'إيطاليا'),
(92588, 3560943368, 3560943368, 'DE', 'DEU', 'ألمانيا'),
(92589, 3560943369, 3560943369, 'GR', 'GRC', 'اليونان'),
(92590, 3560943370, 3560943370, 'DE', 'DEU', 'ألمانيا'),
(92591, 3560943371, 3560943371, 'AT', 'AUT', 'النمسا'),
(92592, 3560943372, 3560943372, 'FR', 'FRA', 'فرنسا'),
(92593, 3560943373, 3560943375, 'DE', 'DEU', 'ألمانيا'),
(92594, 3560943376, 3560943376, 'ES', 'ESP', 'إسبانيا'),
(92595, 3560943377, 3560943377, 'GB', 'GBR', 'المملكة المتحدة'),
(92596, 3560943378, 3560943378, 'DE', 'DEU', 'ألمانيا'),
(92597, 3560943379, 3560943380, 'ES', 'ESP', 'إسبانيا'),
(92598, 3560943381, 3560943383, 'DE', 'DEU', 'ألمانيا'),
(92599, 3560943384, 3560943384, 'FR', 'FRA', 'فرنسا'),
(92600, 3560943385, 3560943385, 'ES', 'ESP', 'إسبانيا'),
(92601, 3560943386, 3560943386, 'CH', 'CHE', 'سويسرا'),
(92602, 3560943387, 3560943387, 'GB', 'GBR', 'المملكة المتحدة'),
(92603, 3560943388, 3560943391, 'DE', 'DEU', 'ألمانيا'),
(92604, 3560943392, 3560943392, 'GB', 'GBR', 'المملكة المتحدة'),
(92605, 3560943393, 3560943393, 'DE', 'DEU', 'ألمانيا'),
(92606, 3560943394, 3560943394, 'ES', 'ESP', 'إسبانيا'),
(92607, 3560943395, 3560943395, 'NL', 'NLD', 'هولندا'),
(92608, 3560943396, 3560943396, 'BE', 'BEL', 'بلجيكا'),
(92609, 3560943397, 3560943397, 'DE', 'DEU', 'ألمانيا'),
(92610, 3560943398, 3560943398, 'BE', 'BEL', 'بلجيكا'),
(92611, 3560943399, 3560943399, 'CH', 'CHE', 'سويسرا'),
(92612, 3560943400, 3560943400, 'IT', 'ITA', 'إيطاليا'),
(92613, 3560943401, 3560943401, 'DE', 'DEU', 'ألمانيا'),
(92614, 3560943402, 3560943402, 'NL', 'NLD', 'هولندا'),
(92615, 3560943403, 3560943403, 'DE', 'DEU', 'ألمانيا'),
(92616, 3560943404, 3560943404, 'BE', 'BEL', 'بلجيكا'),
(92617, 3560943405, 3560943405, 'DE', 'DEU', 'ألمانيا'),
(92618, 3560943406, 3560943407, 'ES', 'ESP', 'إسبانيا'),
(92619, 3560943408, 3560943408, 'IT', 'ITA', 'إيطاليا'),
(92620, 3560943409, 3560943409, 'ES', 'ESP', 'إسبانيا'),
(92621, 3560943410, 3560943410, 'NL', 'NLD', 'هولندا'),
(92622, 3560943411, 3560943411, 'DE', 'DEU', 'ألمانيا'),
(92623, 3560943412, 3560943412, 'IT', 'ITA', 'إيطاليا'),
(92624, 3560943413, 3560943413, 'ES', 'ESP', 'إسبانيا'),
(92625, 3560943414, 3560943415, 'DE', 'DEU', 'ألمانيا'),
(92626, 3560943416, 3560943416, 'FR', 'FRA', 'فرنسا'),
(92627, 3560943417, 3560943417, 'DE', 'DEU', 'ألمانيا'),
(92628, 3560943418, 3560943418, 'GB', 'GBR', 'المملكة المتحدة'),
(92629, 3560943419, 3560943419, 'FR', 'FRA', 'فرنسا'),
(92630, 3560943420, 3560943420, 'DE', 'DEU', 'ألمانيا'),
(92631, 3560943421, 3560943421, 'HU', 'HUN', 'هنغاريا'),
(92632, 3560943422, 3560943422, 'CH', 'CHE', 'سويسرا'),
(92633, 3560943423, 3560943423, 'FR', 'FRA', 'فرنسا'),
(92634, 3560943424, 3560943424, 'DE', 'DEU', 'ألمانيا'),
(92635, 3560943425, 3560943425, 'ES', 'ESP', 'إسبانيا'),
(92636, 3560943426, 3560943426, 'IT', 'ITA', 'إيطاليا'),
(92637, 3560943427, 3560943427, 'FR', 'FRA', 'فرنسا'),
(92638, 3560943428, 3560943428, 'NO', 'NOR', 'النرويج'),
(92639, 3560943429, 3560943430, 'NL', 'NLD', 'هولندا'),
(92640, 3560943431, 3560943432, 'DE', 'DEU', 'ألمانيا'),
(92641, 3560943433, 3560943433, 'GB', 'GBR', 'المملكة المتحدة'),
(92642, 3560943434, 3560943434, 'SE', 'SWE', 'السويد'),
(92643, 3560943435, 3560943435, 'DE', 'DEU', 'ألمانيا'),
(92644, 3560943436, 3560943436, 'FR', 'FRA', 'فرنسا'),
(92645, 3560943437, 3560943437, 'ES', 'ESP', 'إسبانيا'),
(92646, 3560943438, 3560943438, 'FR', 'FRA', 'فرنسا'),
(92647, 3560943439, 3560943439, 'NO', 'NOR', 'النرويج'),
(92648, 3560943440, 3560943440, 'FR', 'FRA', 'فرنسا'),
(92649, 3560943441, 3560943441, 'DE', 'DEU', 'ألمانيا'),
(92650, 3560943442, 3560943442, 'ES', 'ESP', 'إسبانيا'),
(92651, 3560943443, 3560943443, 'BE', 'BEL', 'بلجيكا'),
(92652, 3560943444, 3560943444, 'CH', 'CHE', 'سويسرا'),
(92653, 3560943445, 3560943445, 'PT', 'PRT', 'البورتوغال'),
(92654, 3560943446, 3560943446, 'DE', 'DEU', 'ألمانيا'),
(92655, 3560943447, 3560943447, 'GB', 'GBR', 'المملكة المتحدة'),
(92656, 3560943448, 3560943450, 'DE', 'DEU', 'ألمانيا'),
(92657, 3560943451, 3560943451, 'PL', 'POL', 'بولندا'),
(92658, 3560943452, 3560943452, 'GB', 'GBR', 'المملكة المتحدة'),
(92659, 3560943453, 3560943454, 'DE', 'DEU', 'ألمانيا'),
(92660, 3560943455, 3560943456, 'GB', 'GBR', 'المملكة المتحدة'),
(92661, 3560943457, 3560943457, 'ES', 'ESP', 'إسبانيا'),
(92662, 3560943458, 3560943459, 'IT', 'ITA', 'إيطاليا'),
(92663, 3560943460, 3560943460, 'ES', 'ESP', 'إسبانيا'),
(92664, 3560943461, 3560943461, 'CH', 'CHE', 'سويسرا'),
(92665, 3560943462, 3560943462, 'FR', 'FRA', 'فرنسا'),
(92666, 3560943463, 3560943463, 'NL', 'NLD', 'هولندا'),
(92667, 3560943464, 3560943464, 'ES', 'ESP', 'إسبانيا'),
(92668, 3560943465, 3560943465, 'FR', 'FRA', 'فرنسا'),
(92669, 3560943466, 3560943466, 'NO', 'NOR', 'النرويج'),
(92670, 3560943467, 3560943467, 'IT', 'ITA', 'إيطاليا'),
(92671, 3560943468, 3560943468, 'CH', 'CHE', 'سويسرا'),
(92672, 3560943469, 3560943469, 'IT', 'ITA', 'إيطاليا'),
(92673, 3560943470, 3560943470, 'DE', 'DEU', 'ألمانيا'),
(92674, 3560943471, 3560943471, 'GB', 'GBR', 'المملكة المتحدة'),
(92675, 3560943472, 3560943472, 'BE', 'BEL', 'بلجيكا'),
(92676, 3560943473, 3560943473, 'AT', 'AUT', 'النمسا'),
(92677, 3560943474, 3560943474, 'CH', 'CHE', 'سويسرا'),
(92678, 3560943475, 3560943475, 'ES', 'ESP', 'إسبانيا'),
(92679, 3560943476, 3560943476, 'BE', 'BEL', 'بلجيكا'),
(92680, 3560943477, 3560943477, 'DE', 'DEU', 'ألمانيا'),
(92681, 3560943478, 3560943478, 'IT', 'ITA', 'إيطاليا'),
(92682, 3560943479, 3560943479, 'GB', 'GBR', 'المملكة المتحدة'),
(92683, 3560943480, 3560943480, 'NL', 'NLD', 'هولندا'),
(92684, 3560943481, 3560943481, 'BG', 'BGR', 'بلغاريا'),
(92685, 3560943482, 3560943482, 'DE', 'DEU', 'ألمانيا'),
(92686, 3560943483, 3560943486, 'ES', 'ESP', 'إسبانيا'),
(92687, 3560943487, 3560943487, 'DE', 'DEU', 'ألمانيا'),
(92688, 3560943488, 3560943488, 'ES', 'ESP', 'إسبانيا'),
(92689, 3560943489, 3560943489, 'DE', 'DEU', 'ألمانيا'),
(92690, 3560943490, 3560943490, 'GB', 'GBR', 'المملكة المتحدة'),
(92691, 3560943491, 3560943491, 'DE', 'DEU', 'ألمانيا'),
(92692, 3560943492, 3560943493, 'FR', 'FRA', 'فرنسا'),
(92693, 3560943494, 3560943494, 'GB', 'GBR', 'المملكة المتحدة'),
(92694, 3560943495, 3560943495, 'IT', 'ITA', 'إيطاليا'),
(92695, 3560943496, 3560943499, 'DE', 'DEU', 'ألمانيا'),
(92696, 3560943500, 3560943500, 'CH', 'CHE', 'سويسرا'),
(92697, 3560943501, 3560943501, 'ES', 'ESP', 'إسبانيا'),
(92698, 3560943502, 3560943507, 'DE', 'DEU', 'ألمانيا'),
(92699, 3560943508, 3560943508, 'DK', 'DNK', 'الدنيمارك'),
(92700, 3560943509, 3560943510, 'DE', 'DEU', 'ألمانيا'),
(92701, 3560943511, 3560943511, 'IT', 'ITA', 'إيطاليا'),
(92702, 3560943512, 3560943512, 'DE', 'DEU', 'ألمانيا'),
(92703, 3560943513, 3560943513, 'LU', 'LUX', 'لوكسيمبورغ'),
(92704, 3560943514, 3560943515, 'ES', 'ESP', 'إسبانيا'),
(92705, 3560943516, 3560943517, 'DE', 'DEU', 'ألمانيا'),
(92706, 3560943518, 3560943518, 'LU', 'LUX', 'لوكسيمبورغ'),
(92707, 3560943519, 3560943519, 'DE', 'DEU', 'ألمانيا'),
(92708, 3560943520, 3560943520, 'DK', 'DNK', 'الدنيمارك'),
(92709, 3560943521, 3560943521, 'DE', 'DEU', 'ألمانيا'),
(92710, 3560943522, 3560943522, 'GB', 'GBR', 'المملكة المتحدة'),
(92711, 3560943523, 3560943523, 'IT', 'ITA', 'إيطاليا'),
(92712, 3560943524, 3560943524, 'DE', 'DEU', 'ألمانيا'),
(92713, 3560943525, 3560943525, 'NL', 'NLD', 'هولندا'),
(92714, 3560943526, 3560943526, 'IT', 'ITA', 'إيطاليا'),
(92715, 3560943527, 3560943527, 'DE', 'DEU', 'ألمانيا'),
(92716, 3560943528, 3560943528, 'FR', 'FRA', 'فرنسا'),
(92717, 3560943529, 3560943529, 'DE', 'DEU', 'ألمانيا'),
(92718, 3560943530, 3560943530, 'CH', 'CHE', 'سويسرا'),
(92719, 3560943531, 3560943532, 'DE', 'DEU', 'ألمانيا'),
(92720, 3560943533, 3560943533, 'HU', 'HUN', 'هنغاريا'),
(92721, 3560943534, 3560943534, 'BY', 'BLR', 'روسيا البيضاء'),
(92722, 3560943535, 3560943535, 'FR', 'FRA', 'فرنسا'),
(92723, 3560943536, 3560943536, 'BE', 'BEL', 'بلجيكا'),
(92724, 3560943537, 3560943537, 'DE', 'DEU', 'ألمانيا'),
(92725, 3560943538, 3560943538, 'GB', 'GBR', 'المملكة المتحدة'),
(92726, 3560943539, 3560943539, 'DE', 'DEU', 'ألمانيا'),
(92727, 3560943540, 3560943540, 'BE', 'BEL', 'بلجيكا'),
(92728, 3560943541, 3560943541, 'NL', 'NLD', 'هولندا'),
(92729, 3560943542, 3560943542, 'DE', 'DEU', 'ألمانيا'),
(92730, 3560943543, 3560943543, 'NL', 'NLD', 'هولندا'),
(92731, 3560943544, 3560943544, 'ES', 'ESP', 'إسبانيا'),
(92732, 3560943545, 3560943546, 'DE', 'DEU', 'ألمانيا'),
(92733, 3560943547, 3560943547, 'SI', 'SVN', 'سلوفينيا'),
(92734, 3560943548, 3560943548, 'GB', 'GBR', 'المملكة المتحدة'),
(92735, 3560943549, 3560943549, 'DE', 'DEU', 'ألمانيا'),
(92736, 3560943550, 3560943550, 'HU', 'HUN', 'هنغاريا'),
(92737, 3560943551, 3560943551, 'FR', 'FRA', 'فرنسا'),
(92738, 3560943552, 3560943552, 'IT', 'ITA', 'إيطاليا'),
(92739, 3560943553, 3560943553, 'DE', 'DEU', 'ألمانيا'),
(92740, 3560943554, 3560943554, 'IS', 'ISL', 'أيسلندا'),
(92741, 3560943555, 3560943555, 'FR', 'FRA', 'فرنسا'),
(92742, 3560943556, 3560943556, 'DE', 'DEU', 'ألمانيا'),
(92743, 3560943557, 3560943557, 'ES', 'ESP', 'إسبانيا'),
(92744, 3560943558, 3560943558, 'DE', 'DEU', 'ألمانيا'),
(92745, 3560943559, 3560943559, 'GB', 'GBR', 'المملكة المتحدة'),
(92746, 3560943560, 3560943562, 'IT', 'ITA', 'إيطاليا'),
(92747, 3560943563, 3560943563, 'HU', 'HUN', 'هنغاريا'),
(92748, 3560943564, 3560943564, 'DE', 'DEU', 'ألمانيا'),
(92749, 3560943565, 3560943565, 'GB', 'GBR', 'المملكة المتحدة'),
(92750, 3560943566, 3560943566, 'DE', 'DEU', 'ألمانيا'),
(92751, 3560943567, 3560943567, 'FR', 'FRA', 'فرنسا'),
(92752, 3560943568, 3560943568, 'GB', 'GBR', 'المملكة المتحدة'),
(92753, 3560943569, 3560943570, 'FR', 'FRA', 'فرنسا'),
(92754, 3560943571, 3560943572, 'DE', 'DEU', 'ألمانيا'),
(92755, 3560943573, 3560943573, 'FR', 'FRA', 'فرنسا'),
(92756, 3560943574, 3560943574, 'NO', 'NOR', 'النرويج'),
(92757, 3560943575, 3560943575, 'BE', 'BEL', 'بلجيكا'),
(92758, 3560943576, 3560943576, 'IT', 'ITA', 'إيطاليا'),
(92759, 3560943577, 3560943577, 'DK', 'DNK', 'الدنيمارك'),
(92760, 3560943578, 3560943578, 'ES', 'ESP', 'إسبانيا'),
(92761, 3560943579, 3560943580, 'DE', 'DEU', 'ألمانيا'),
(92762, 3560943581, 3560943581, 'NL', 'NLD', 'هولندا'),
(92763, 3560943582, 3560943582, 'DE', 'DEU', 'ألمانيا'),
(92764, 3560943583, 3560943583, 'ES', 'ESP', 'إسبانيا'),
(92765, 3560943584, 3560943584, 'IT', 'ITA', 'إيطاليا'),
(92766, 3560943585, 3560943585, 'FR', 'FRA', 'فرنسا'),
(92767, 3560943586, 3560943586, 'ES', 'ESP', 'إسبانيا'),
(92768, 3560943587, 3560943587, 'DE', 'DEU', 'ألمانيا'),
(92769, 3560943588, 3560943588, 'IT', 'ITA', 'إيطاليا'),
(92770, 3560943589, 3560943589, 'NL', 'NLD', 'هولندا'),
(92771, 3560943590, 3560943590, 'HU', 'HUN', 'هنغاريا'),
(92772, 3560943591, 3560943591, 'AT', 'AUT', 'النمسا'),
(92773, 3560943592, 3560943592, 'SK', 'SVK', 'سلوفاكيا'),
(92774, 3560943593, 3560943593, 'PL', 'POL', 'بولندا'),
(92775, 3560943594, 3560943594, 'FR', 'FRA', 'فرنسا'),
(92776, 3560943595, 3560943596, 'ES', 'ESP', 'إسبانيا'),
(92777, 3560943597, 3560943599, 'DE', 'DEU', 'ألمانيا'),
(92778, 3560943600, 3560943600, 'AT', 'AUT', 'النمسا'),
(92779, 3560943601, 3560943602, 'IT', 'ITA', 'إيطاليا'),
(92780, 3560943603, 3560943603, 'CH', 'CHE', 'سويسرا'),
(92781, 3560943604, 3560943604, 'ES', 'ESP', 'إسبانيا'),
(92782, 3560943605, 3560943605, 'GB', 'GBR', 'المملكة المتحدة'),
(92783, 3560943606, 3560943607, 'DE', 'DEU', 'ألمانيا'),
(92784, 3560943608, 3560943608, 'IT', 'ITA', 'إيطاليا'),
(92785, 3560943609, 3560943610, 'DE', 'DEU', 'ألمانيا'),
(92786, 3560943611, 3560943611, 'FR', 'FRA', 'فرنسا'),
(92787, 3560943612, 3560943612, 'DE', 'DEU', 'ألمانيا'),
(92788, 3560943613, 3560943613, 'ES', 'ESP', 'إسبانيا'),
(92789, 3560943614, 3560943617, 'DE', 'DEU', 'ألمانيا'),
(92790, 3560943618, 3560943618, 'FR', 'FRA', 'فرنسا'),
(92791, 3560943619, 3560943620, 'ES', 'ESP', 'إسبانيا'),
(92792, 3560943621, 3560943621, 'SE', 'SWE', 'السويد'),
(92793, 3560943622, 3560943622, 'BE', 'BEL', 'بلجيكا'),
(92794, 3560943623, 3560943623, 'DE', 'DEU', 'ألمانيا'),
(92795, 3560943624, 3560943624, 'ES', 'ESP', 'إسبانيا'),
(92796, 3560943625, 3560943625, 'AT', 'AUT', 'النمسا'),
(92797, 3560943626, 3560943626, 'ES', 'ESP', 'إسبانيا'),
(92798, 3560943627, 3560943627, 'DK', 'DNK', 'الدنيمارك'),
(92799, 3560943628, 3560943628, 'DE', 'DEU', 'ألمانيا'),
(92800, 3560943629, 3560943629, 'IT', 'ITA', 'إيطاليا'),
(92801, 3560943630, 3560943630, 'DE', 'DEU', 'ألمانيا'),
(92802, 3560943631, 3560943631, 'HU', 'HUN', 'هنغاريا'),
(92803, 3560943632, 3560943632, 'CH', 'CHE', 'سويسرا'),
(92804, 3560943633, 3560943633, 'ES', 'ESP', 'إسبانيا'),
(92805, 3560943634, 3560943634, 'FR', 'FRA', 'فرنسا'),
(92806, 3560943635, 3560943635, 'ES', 'ESP', 'إسبانيا'),
(92807, 3560943636, 3560943636, 'DE', 'DEU', 'ألمانيا'),
(92808, 3560943637, 3560943637, 'PL', 'POL', 'بولندا'),
(92809, 3560943638, 3560943638, 'IT', 'ITA', 'إيطاليا'),
(92810, 3560943639, 3560943639, 'ES', 'ESP', 'إسبانيا'),
(92811, 3560943640, 3560943640, 'FR', 'FRA', 'فرنسا'),
(92812, 3560943641, 3560943643, 'IT', 'ITA', 'إيطاليا'),
(92813, 3560943644, 3560943644, 'DE', 'DEU', 'ألمانيا'),
(92814, 3560943645, 3560943645, 'GB', 'GBR', 'المملكة المتحدة'),
(92815, 3560943646, 3560943646, 'DE', 'DEU', 'ألمانيا'),
(92816, 3560943647, 3560943647, 'ES', 'ESP', 'إسبانيا'),
(92817, 3560943648, 3560943648, 'DE', 'DEU', 'ألمانيا'),
(92818, 3560943649, 3560943649, 'NL', 'NLD', 'هولندا'),
(92819, 3560943650, 3560943651, 'DE', 'DEU', 'ألمانيا'),
(92820, 3560943652, 3560943652, 'AT', 'AUT', 'النمسا'),
(92821, 3560943653, 3560943653, 'DE', 'DEU', 'ألمانيا'),
(92822, 3560943654, 3560943654, 'IT', 'ITA', 'إيطاليا'),
(92823, 3560943655, 3560943655, 'DE', 'DEU', 'ألمانيا'),
(92824, 3560943656, 3560943656, 'IT', 'ITA', 'إيطاليا'),
(92825, 3560943657, 3560943657, 'DE', 'DEU', 'ألمانيا'),
(92826, 3560943658, 3560943658, 'GB', 'GBR', 'المملكة المتحدة'),
(92827, 3560943659, 3560943659, 'DE', 'DEU', 'ألمانيا'),
(92828, 3560943660, 3560943660, 'PT', 'PRT', 'البورتوغال'),
(92829, 3560943661, 3560943661, 'DK', 'DNK', 'الدنيمارك'),
(92830, 3560943662, 3560943662, 'DE', 'DEU', 'ألمانيا'),
(92831, 3560943663, 3560943664, 'NL', 'NLD', 'هولندا'),
(92832, 3560943665, 3560943666, 'DE', 'DEU', 'ألمانيا'),
(92833, 3560943667, 3560943667, 'PL', 'POL', 'بولندا'),
(92834, 3560943668, 3560943668, 'DK', 'DNK', 'الدنيمارك'),
(92835, 3560943669, 3560943669, 'FR', 'FRA', 'فرنسا'),
(92836, 3560943670, 3560943671, 'DE', 'DEU', 'ألمانيا'),
(92837, 3560943672, 3560943672, 'BH', 'BHR', 'البحرين'),
(92838, 3560943673, 3560943673, 'SE', 'SWE', 'السويد'),
(92839, 3560943674, 3560943674, 'MA', 'MAR', 'المغرب'),
(92840, 3560943675, 3560943675, 'FR', 'FRA', 'فرنسا'),
(92841, 3560943676, 3560943677, 'DE', 'DEU', 'ألمانيا'),
(92842, 3560943678, 3560943680, 'ES', 'ESP', 'إسبانيا'),
(92843, 3560943681, 3560943682, 'DE', 'DEU', 'ألمانيا'),
(92844, 3560943683, 3560943683, 'GR', 'GRC', 'اليونان'),
(92845, 3560943684, 3560943684, 'NL', 'NLD', 'هولندا'),
(92846, 3560943685, 3560943685, 'IT', 'ITA', 'إيطاليا'),
(92847, 3560943686, 3560943686, 'FR', 'FRA', 'فرنسا'),
(92848, 3560943687, 3560943687, 'PT', 'PRT', 'البورتوغال'),
(92849, 3560943688, 3560943688, 'DE', 'DEU', 'ألمانيا'),
(92850, 3560943689, 3560943689, 'PT', 'PRT', 'البورتوغال'),
(92851, 3560943690, 3560943690, 'IT', 'ITA', 'إيطاليا'),
(92852, 3560943691, 3560943691, 'DE', 'DEU', 'ألمانيا'),
(92853, 3560943692, 3560943692, 'SE', 'SWE', 'السويد'),
(92854, 3560943693, 3560943693, 'DE', 'DEU', 'ألمانيا'),
(92855, 3560943694, 3560943694, 'FR', 'FRA', 'فرنسا'),
(92856, 3560943695, 3560943695, 'GR', 'GRC', 'اليونان'),
(92857, 3560943696, 3560943697, 'CH', 'CHE', 'سويسرا'),
(92858, 3560943698, 3560943698, 'DE', 'DEU', 'ألمانيا'),
(92859, 3560943699, 3560943699, 'IT', 'ITA', 'إيطاليا'),
(92860, 3560943700, 3560943700, 'DE', 'DEU', 'ألمانيا'),
(92861, 3560943701, 3560943701, 'AT', 'AUT', 'النمسا'),
(92862, 3560943702, 3560943702, 'DE', 'DEU', 'ألمانيا'),
(92863, 3560943703, 3560943703, 'FR', 'FRA', 'فرنسا'),
(92864, 3560943704, 3560943704, 'DE', 'DEU', 'ألمانيا'),
(92865, 3560943705, 3560943705, 'CH', 'CHE', 'سويسرا'),
(92866, 3560943706, 3560943706, 'LI', 'LIE', 'ليختنشتاين'),
(92867, 3560943707, 3560943709, 'DE', 'DEU', 'ألمانيا'),
(92868, 3560943710, 3560943710, 'NL', 'NLD', 'هولندا'),
(92869, 3560943711, 3560943711, 'DE', 'DEU', 'ألمانيا'),
(92870, 3560943712, 3560943712, 'IT', 'ITA', 'إيطاليا'),
(92871, 3560943713, 3560943713, 'PL', 'POL', 'بولندا'),
(92872, 3560943714, 3560943714, 'NL', 'NLD', 'هولندا'),
(92873, 3560943715, 3560943715, 'DE', 'DEU', 'ألمانيا'),
(92874, 3560943716, 3560943716, 'GB', 'GBR', 'المملكة المتحدة'),
(92875, 3560943717, 3560943717, 'FR', 'FRA', 'فرنسا'),
(92876, 3560943718, 3560943719, 'DE', 'DEU', 'ألمانيا'),
(92877, 3560943720, 3560943721, 'IT', 'ITA', 'إيطاليا'),
(92878, 3560943722, 3560943726, 'DE', 'DEU', 'ألمانيا'),
(92879, 3560943727, 3560943727, 'ES', 'ESP', 'إسبانيا'),
(92880, 3560943728, 3560943728, 'GB', 'GBR', 'المملكة المتحدة'),
(92881, 3560943729, 3560943729, 'DE', 'DEU', 'ألمانيا'),
(92882, 3560943730, 3560943730, 'NL', 'NLD', 'هولندا'),
(92883, 3560943731, 3560943731, 'IT', 'ITA', 'إيطاليا'),
(92884, 3560943732, 3560943732, 'FR', 'FRA', 'فرنسا'),
(92885, 3560943733, 3560943733, 'NO', 'NOR', 'النرويج'),
(92886, 3560943734, 3560943736, 'DE', 'DEU', 'ألمانيا'),
(92887, 3560943737, 3560943737, 'GR', 'GRC', 'اليونان'),
(92888, 3560943738, 3560943738, 'PT', 'PRT', 'البورتوغال'),
(92889, 3560943739, 3560943740, 'DE', 'DEU', 'ألمانيا'),
(92890, 3560943741, 3560943741, 'FR', 'FRA', 'فرنسا'),
(92891, 3560943742, 3560943742, 'DE', 'DEU', 'ألمانيا'),
(92892, 3560943743, 3560943743, 'PL', 'POL', 'بولندا'),
(92893, 3560943744, 3560943744, 'DE', 'DEU', 'ألمانيا'),
(92894, 3560943745, 3560943745, 'PL', 'POL', 'بولندا'),
(92895, 3560943746, 3560943748, 'DE', 'DEU', 'ألمانيا'),
(92896, 3560943749, 3560943749, 'GB', 'GBR', 'المملكة المتحدة'),
(92897, 3560943750, 3560943750, 'DE', 'DEU', 'ألمانيا'),
(92898, 3560943751, 3560943751, 'IT', 'ITA', 'إيطاليا'),
(92899, 3560943752, 3560943752, 'DE', 'DEU', 'ألمانيا'),
(92900, 3560943753, 3560943753, 'ES', 'ESP', 'إسبانيا'),
(92901, 3560943754, 3560943754, 'HU', 'HUN', 'هنغاريا'),
(92902, 3560943755, 3560943755, 'BE', 'BEL', 'بلجيكا'),
(92903, 3560943756, 3560943756, 'IT', 'ITA', 'إيطاليا'),
(92904, 3560943757, 3560943757, 'DE', 'DEU', 'ألمانيا'),
(92905, 3560943758, 3560943758, 'CZ', 'CZE', 'التشيك'),
(92906, 3560943759, 3560943759, 'IE', 'IRL', 'إيرلندا'),
(92907, 3560943760, 3560943760, 'NO', 'NOR', 'النرويج'),
(92908, 3560943761, 3560943761, 'GB', 'GBR', 'المملكة المتحدة'),
(92909, 3560943762, 3560943762, 'IT', 'ITA', 'إيطاليا'),
(92910, 3560943763, 3560943763, 'FR', 'FRA', 'فرنسا'),
(92911, 3560943764, 3560943764, 'PL', 'POL', 'بولندا'),
(92912, 3560943765, 3560943765, 'SE', 'SWE', 'السويد'),
(92913, 3560943766, 3560943766, 'CY', 'CYP', 'قبرص'),
(92914, 3560943767, 3560943768, 'DE', 'DEU', 'ألمانيا'),
(92915, 3560943769, 3560943769, 'FR', 'FRA', 'فرنسا'),
(92916, 3560943770, 3560943770, 'NL', 'NLD', 'هولندا'),
(92917, 3560943771, 3560943771, 'IT', 'ITA', 'إيطاليا'),
(92918, 3560943772, 3560943774, 'DE', 'DEU', 'ألمانيا'),
(92919, 3560943775, 3560943775, 'FR', 'FRA', 'فرنسا'),
(92920, 3560943776, 3560943780, 'DE', 'DEU', 'ألمانيا'),
(92921, 3560943781, 3560943781, 'ES', 'ESP', 'إسبانيا'),
(92922, 3560943782, 3560943782, 'DE', 'DEU', 'ألمانيا'),
(92923, 3560943783, 3560943783, 'BE', 'BEL', 'بلجيكا'),
(92924, 3560943784, 3560943786, 'DE', 'DEU', 'ألمانيا'),
(92925, 3560943787, 3560943787, 'ES', 'ESP', 'إسبانيا'),
(92926, 3560943788, 3560943788, 'DK', 'DNK', 'الدنيمارك'),
(92927, 3560943789, 3560943789, 'IT', 'ITA', 'إيطاليا'),
(92928, 3560943790, 3560943790, 'DE', 'DEU', 'ألمانيا'),
(92929, 3560943791, 3560943791, 'IT', 'ITA', 'إيطاليا'),
(92930, 3560943792, 3560943793, 'DE', 'DEU', 'ألمانيا'),
(92931, 3560943794, 3560943794, 'FR', 'FRA', 'فرنسا'),
(92932, 3560943795, 3560943795, 'DE', 'DEU', 'ألمانيا'),
(92933, 3560943796, 3560943796, 'IT', 'ITA', 'إيطاليا'),
(92934, 3560943797, 3560943797, 'DE', 'DEU', 'ألمانيا'),
(92935, 3560943798, 3560943798, 'DK', 'DNK', 'الدنيمارك'),
(92936, 3560943799, 3560943799, 'DE', 'DEU', 'ألمانيا'),
(92937, 3560943800, 3560943800, 'CH', 'CHE', 'سويسرا'),
(92938, 3560943801, 3560943801, 'FR', 'FRA', 'فرنسا'),
(92939, 3560943802, 3560943802, 'IT', 'ITA', 'إيطاليا'),
(92940, 3560943803, 3560943803, 'HU', 'HUN', 'هنغاريا'),
(92941, 3560943804, 3560943804, 'ES', 'ESP', 'إسبانيا'),
(92942, 3560943805, 3560943805, 'DE', 'DEU', 'ألمانيا'),
(92943, 3560943806, 3560943806, 'ES', 'ESP', 'إسبانيا'),
(92944, 3560943807, 3560943807, 'DK', 'DNK', 'الدنيمارك'),
(92945, 3560943808, 3560943810, 'DE', 'DEU', 'ألمانيا'),
(92946, 3560943811, 3560943811, 'ES', 'ESP', 'إسبانيا'),
(92947, 3560943812, 3560943812, 'IT', 'ITA', 'إيطاليا'),
(92948, 3560943813, 3560943813, 'CH', 'CHE', 'سويسرا'),
(92949, 3560943814, 3560943814, 'DE', 'DEU', 'ألمانيا'),
(92950, 3560943815, 3560943815, 'IT', 'ITA', 'إيطاليا'),
(92951, 3560943816, 3560943817, 'FR', 'FRA', 'فرنسا'),
(92952, 3560943818, 3560943818, 'PT', 'PRT', 'البورتوغال'),
(92953, 3560943819, 3560943819, 'DE', 'DEU', 'ألمانيا'),
(92954, 3560943820, 3560943820, 'FR', 'FRA', 'فرنسا'),
(92955, 3560943821, 3560943821, 'IT', 'ITA', 'إيطاليا'),
(92956, 3560943822, 3560943822, 'DE', 'DEU', 'ألمانيا'),
(92957, 3560943823, 3560943823, 'GR', 'GRC', 'اليونان'),
(92958, 3560943824, 3560943827, 'DE', 'DEU', 'ألمانيا'),
(92959, 3560943828, 3560943828, 'ES', 'ESP', 'إسبانيا'),
(92960, 3560943829, 3560943829, 'NL', 'NLD', 'هولندا'),
(92961, 3560943830, 3560943830, 'DK', 'DNK', 'الدنيمارك'),
(92962, 3560943831, 3560943833, 'FR', 'FRA', 'فرنسا'),
(92963, 3560943834, 3560943836, 'DE', 'DEU', 'ألمانيا'),
(92964, 3560943837, 3560943837, 'CH', 'CHE', 'سويسرا'),
(92965, 3560943838, 3560943838, 'DE', 'DEU', 'ألمانيا'),
(92966, 3560943839, 3560943839, 'NO', 'NOR', 'النرويج'),
(92967, 3560943840, 3560943840, 'LU', 'LUX', 'لوكسيمبورغ'),
(92968, 3560943841, 3560943841, 'GB', 'GBR', 'المملكة المتحدة'),
(92969, 3560943842, 3560943842, 'DE', 'DEU', 'ألمانيا'),
(92970, 3560943843, 3560943843, 'GB', 'GBR', 'المملكة المتحدة'),
(92971, 3560943844, 3560943844, 'BE', 'BEL', 'بلجيكا'),
(92972, 3560943845, 3560943845, 'CZ', 'CZE', 'التشيك'),
(92973, 3560943846, 3560943846, 'LU', 'LUX', 'لوكسيمبورغ'),
(92974, 3560943847, 3560943847, 'CZ', 'CZE', 'التشيك'),
(92975, 3560943848, 3560943848, 'FR', 'FRA', 'فرنسا'),
(92976, 3560943849, 3560943849, 'DE', 'DEU', 'ألمانيا'),
(92977, 3560943850, 3560943850, 'NL', 'NLD', 'هولندا'),
(92978, 3560943851, 3560943857, 'DE', 'DEU', 'ألمانيا'),
(92979, 3560943858, 3560943858, 'GB', 'GBR', 'المملكة المتحدة'),
(92980, 3560943859, 3560943859, 'DE', 'DEU', 'ألمانيا'),
(92981, 3560943860, 3560943860, 'GB', 'GBR', 'المملكة المتحدة'),
(92982, 3560943861, 3560943865, 'DE', 'DEU', 'ألمانيا'),
(92983, 3560943866, 3560943866, 'BE', 'BEL', 'بلجيكا'),
(92984, 3560943867, 3560943867, 'ES', 'ESP', 'إسبانيا'),
(92985, 3560943868, 3560943868, 'FR', 'FRA', 'فرنسا'),
(92986, 3560943869, 3560943869, 'LU', 'LUX', 'لوكسيمبورغ'),
(92987, 3560943870, 3560943871, 'DE', 'DEU', 'ألمانيا'),
(92988, 3560943872, 3560943875, 'BR', 'BRA', 'البرازيل'),
(92989, 3560943876, 3560943879, 'DE', 'DEU', 'ألمانيا'),
(92990, 3560943880, 3560943887, 'US', 'USA', 'الولايات المتحدة'),
(92991, 3560943888, 3560943891, 'CA', 'CAN', 'كندا'),
(92992, 3560943892, 3560943895, 'DE', 'DEU', 'ألمانيا'),
(92993, 3560943896, 3560943899, 'CL', 'CHL', 'تشيلي'),
(92994, 3560943900, 3560943903, 'MX', 'MEX', 'المكسيك'),
(92995, 3560943904, 3560943915, 'US', 'USA', 'الولايات المتحدة'),
(92996, 3560943916, 3560943919, 'CA', 'CAN', 'كندا'),
(92997, 3560943920, 3560943923, 'US', 'USA', 'الولايات المتحدة'),
(92998, 3560943924, 3560943927, 'MX', 'MEX', 'المكسيك'),
(92999, 3560943928, 3560943935, 'US', 'USA', 'الولايات المتحدة'),
(93000, 3560943936, 3560943939, 'PE', 'PER', 'بيرو'),
(93001, 3560943940, 3560943943, 'DE', 'DEU', 'ألمانيا'),
(93002, 3560943944, 3560943947, 'US', 'USA', 'الولايات المتحدة'),
(93003, 3560943948, 3560943975, 'DE', 'DEU', 'ألمانيا'),
(93004, 3560943976, 3560943979, 'US', 'USA', 'الولايات المتحدة'),
(93005, 3560943980, 3560943983, 'DE', 'DEU', 'ألمانيا'),
(93006, 3560943984, 3560943987, 'US', 'USA', 'الولايات المتحدة'),
(93007, 3560943988, 3560943991, 'DE', 'DEU', 'ألمانيا'),
(93008, 3560943992, 3560943999, 'US', 'USA', 'الولايات المتحدة'),
(93009, 3560944000, 3560944023, 'DE', 'DEU', 'ألمانيا'),
(93010, 3560944024, 3560944031, 'US', 'USA', 'الولايات المتحدة'),
(93011, 3560944032, 3560944035, 'MX', 'MEX', 'المكسيك'),
(93012, 3560944036, 3560944039, 'US', 'USA', 'الولايات المتحدة'),
(93013, 3560944040, 3560944043, 'MX', 'MEX', 'المكسيك'),
(93014, 3560944044, 3560944059, 'DE', 'DEU', 'ألمانيا'),
(93015, 3560944060, 3560944063, 'US', 'USA', 'الولايات المتحدة'),
(93016, 3560944064, 3560944067, 'DE', 'DEU', 'ألمانيا'),
(93017, 3560944068, 3560944071, 'US', 'USA', 'الولايات المتحدة'),
(93018, 3560944072, 3560944079, 'DE', 'DEU', 'ألمانيا'),
(93019, 3560944080, 3560944083, 'US', 'USA', 'الولايات المتحدة'),
(93020, 3560944084, 3560944087, 'CL', 'CHL', 'تشيلي'),
(93021, 3560944088, 3560944103, 'DE', 'DEU', 'ألمانيا'),
(93022, 3560944104, 3560944107, 'US', 'USA', 'الولايات المتحدة'),
(93023, 3560944108, 3560944119, 'DE', 'DEU', 'ألمانيا'),
(93024, 3560944120, 3560944135, 'US', 'USA', 'الولايات المتحدة'),
(93025, 3560944136, 3560944139, 'DE', 'DEU', 'ألمانيا'),
(93026, 3560944140, 3560944159, 'US', 'USA', 'الولايات المتحدة'),
(93027, 3560944160, 3560944163, 'MX', 'MEX', 'المكسيك'),
(93028, 3560944164, 3560944167, 'AR', 'ARG', 'الأرجنتين'),
(93029, 3560944168, 3560944175, 'US', 'USA', 'الولايات المتحدة'),
(93030, 3560944176, 3560944179, 'BR', 'BRA', 'البرازيل'),
(93031, 3560944180, 3560944183, 'PA', 'PAN', 'بنما'),
(93032, 3560944184, 3560944187, 'US', 'USA', 'الولايات المتحدة'),
(93033, 3560944188, 3560944191, 'CA', 'CAN', 'كندا'),
(93034, 3560944192, 3560944195, 'US', 'USA', 'الولايات المتحدة'),
(93035, 3560944196, 3560944199, 'DE', 'DEU', 'ألمانيا'),
(93036, 3560944200, 3560944203, 'BO', 'BOL', 'بوليفيا'),
(93037, 3560944204, 3560944207, 'DE', 'DEU', 'ألمانيا'),
(93038, 3560944208, 3560944211, 'CA', 'CAN', 'كندا'),
(93039, 3560944212, 3560944215, 'DE', 'DEU', 'ألمانيا'),
(93040, 3560944216, 3560944219, 'BR', 'BRA', 'البرازيل'),
(93041, 3560944220, 3560944227, 'US', 'USA', 'الولايات المتحدة'),
(93042, 3560944228, 3560944231, 'IT', 'ITA', 'إيطاليا'),
(93043, 3560944232, 3560944235, 'US', 'USA', 'الولايات المتحدة'),
(93044, 3560944236, 3560944239, 'CA', 'CAN', 'كندا'),
(93045, 3560944240, 3560944243, 'US', 'USA', 'الولايات المتحدة'),
(93046, 3560944244, 3560944247, 'MX', 'MEX', 'المكسيك'),
(93047, 3560944248, 3560944267, 'US', 'USA', 'الولايات المتحدة'),
(93048, 3560944268, 3560944271, 'CO', 'COL', 'كولومبيا'),
(93049, 3560944272, 3560944275, 'BR', 'BRA', 'البرازيل'),
(93050, 3560944276, 3560944279, 'PE', 'PER', 'بيرو'),
(93051, 3560944280, 3560944283, 'DE', 'DEU', 'ألمانيا'),
(93052, 3560944284, 3560944295, 'US', 'USA', 'الولايات المتحدة'),
(93053, 3560944296, 3560944299, 'CO', 'COL', 'كولومبيا'),
(93054, 3560944300, 3560944307, 'US', 'USA', 'الولايات المتحدة'),
(93055, 3560944308, 3560944311, 'MX', 'MEX', 'المكسيك'),
(93056, 3560944312, 3560944315, 'US', 'USA', 'الولايات المتحدة'),
(93057, 3560944316, 3560944323, 'AR', 'ARG', 'الأرجنتين'),
(93058, 3560944324, 3560944339, 'US', 'USA', 'الولايات المتحدة'),
(93059, 3560944340, 3560944343, 'CO', 'COL', 'كولومبيا'),
(93060, 3560944344, 3560944351, 'US', 'USA', 'الولايات المتحدة'),
(93061, 3560944352, 3560944355, 'GT', 'GTM', 'غواتيمالا'),
(93062, 3560944356, 3560944359, 'CA', 'CAN', 'كندا'),
(93063, 3560944360, 3560944363, 'DO', 'DOM', 'الدومينيكان'),
(93064, 3560944364, 3560944367, 'AR', 'ARG', 'الأرجنتين'),
(93065, 3560944368, 3560944371, 'BR', 'BRA', 'البرازيل'),
(93066, 3560944372, 3560944375, 'DE', 'DEU', 'ألمانيا'),
(93067, 3560944376, 3560944379, 'AR', 'ARG', 'الأرجنتين'),
(93068, 3560944380, 3560944383, 'DE', 'DEU', 'ألمانيا'),
(93069, 3560944384, 3560944395, 'US', 'USA', 'الولايات المتحدة'),
(93070, 3560944396, 3560944399, 'PR', 'PRI', 'بورتو ريكو'),
(93071, 3560944400, 3560944403, 'CA', 'CAN', 'كندا'),
(93072, 3560944404, 3560944411, 'DE', 'DEU', 'ألمانيا'),
(93073, 3560944412, 3560944415, 'US', 'USA', 'الولايات المتحدة'),
(93074, 3560944416, 3560944419, 'SG', 'SGP', 'سنغافورة'),
(93075, 3560944420, 3560944431, 'US', 'USA', 'الولايات المتحدة'),
(93076, 3560944432, 3560944435, 'DE', 'DEU', 'ألمانيا'),
(93077, 3560944436, 3560944447, 'US', 'USA', 'الولايات المتحدة'),
(93078, 3560944448, 3560944451, 'DE', 'DEU', 'ألمانيا'),
(93079, 3560944452, 3560944459, 'US', 'USA', 'الولايات المتحدة'),
(93080, 3560944460, 3560944460, 'AR', 'ARG', 'الأرجنتين'),
(93081, 3560944461, 3560944463, 'DE', 'DEU', 'ألمانيا'),
(93082, 3560944464, 3560944467, 'CA', 'CAN', 'كندا'),
(93083, 3560944468, 3560944471, 'BR', 'BRA', 'البرازيل'),
(93084, 3560944472, 3560944475, 'US', 'USA', 'الولايات المتحدة'),
(93085, 3560944476, 3560944479, 'AR', 'ARG', 'الأرجنتين'),
(93086, 3560944480, 3560944487, 'US', 'USA', 'الولايات المتحدة'),
(93087, 3560944488, 3560944491, 'CA', 'CAN', 'كندا'),
(93088, 3560944492, 3560944519, 'US', 'USA', 'الولايات المتحدة'),
(93089, 3560944520, 3560944523, 'DE', 'DEU', 'ألمانيا'),
(93090, 3560944524, 3560944531, 'US', 'USA', 'الولايات المتحدة'),
(93091, 3560944532, 3560944535, 'MX', 'MEX', 'المكسيك'),
(93092, 3560944536, 3560944551, 'US', 'USA', 'الولايات المتحدة'),
(93093, 3560944552, 3560944555, 'BR', 'BRA', 'البرازيل'),
(93094, 3560944556, 3560944559, 'MX', 'MEX', 'المكسيك'),
(93095, 3560944560, 3560944563, 'US', 'USA', 'الولايات المتحدة'),
(93096, 3560944564, 3560944567, 'ES', 'ESP', 'إسبانيا'),
(93097, 3560944568, 3560944575, 'US', 'USA', 'الولايات المتحدة'),
(93098, 3560944576, 3560944579, 'BR', 'BRA', 'البرازيل'),
(93099, 3560944580, 3560944603, 'US', 'USA', 'الولايات المتحدة'),
(93100, 3560944604, 3560944607, 'CA', 'CAN', 'كندا'),
(93101, 3560944608, 3560944615, 'US', 'USA', 'الولايات المتحدة'),
(93102, 3560944616, 3560944619, 'EC', 'ECU', 'الإكوادور'),
(93103, 3560944620, 3560944623, 'US', 'USA', 'الولايات المتحدة'),
(93104, 3560944624, 3560944627, 'CL', 'CHL', 'تشيلي'),
(93105, 3560944628, 3560944631, 'DE', 'DEU', 'ألمانيا'),
(93106, 3560944632, 3560944635, 'CA', 'CAN', 'كندا'),
(93107, 3560944636, 3560944639, 'DE', 'DEU', 'ألمانيا'),
(93108, 3560944640, 3560944643, 'TR', 'TUR', 'تركيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(93109, 3560944644, 3560944647, 'ES', 'ESP', 'إسبانيا'),
(93110, 3560944648, 3560944651, 'TR', 'TUR', 'تركيا'),
(93111, 3560944652, 3560944655, 'HU', 'HUN', 'هنغاريا'),
(93112, 3560944656, 3560944659, 'TR', 'TUR', 'تركيا'),
(93113, 3560944660, 3560944663, 'MZ', 'MOZ', 'موزامبيق'),
(93114, 3560944664, 3560944667, 'FR', 'FRA', 'فرنسا'),
(93115, 3560944668, 3560944671, 'TR', 'TUR', 'تركيا'),
(93116, 3560944672, 3560944675, 'KZ', 'KAZ', 'كازاخستان'),
(93117, 3560944676, 3560944679, 'GR', 'GRC', 'اليونان'),
(93118, 3560944680, 3560944687, 'TR', 'TUR', 'تركيا'),
(93119, 3560944688, 3560944691, 'FR', 'FRA', 'فرنسا'),
(93120, 3560944692, 3560944695, 'SA', 'SAU', 'السعودية'),
(93121, 3560944696, 3560944699, 'TR', 'TUR', 'تركيا'),
(93122, 3560944700, 3560944703, 'CU', 'CUB', 'كوبا'),
(93123, 3560944704, 3560944707, 'ZW', 'ZWE', 'زمبابواي'),
(93124, 3560944708, 3560944711, 'TR', 'TUR', 'تركيا'),
(93125, 3560944712, 3560944715, 'IL', 'ISR', 'إسرائيل'),
(93126, 3560944716, 3560944719, 'ZW', 'ZWE', 'زمبابواي'),
(93127, 3560944720, 3560944723, 'SK', 'SVK', 'سلوفاكيا'),
(93128, 3560944724, 3560944727, 'TR', 'TUR', 'تركيا'),
(93129, 3560944728, 3560944731, 'KZ', 'KAZ', 'كازاخستان'),
(93130, 3560944732, 3560944735, 'TR', 'TUR', 'تركيا'),
(93131, 3560944736, 3560944743, 'FR', 'FRA', 'فرنسا'),
(93132, 3560944744, 3560944747, 'GR', 'GRC', 'اليونان'),
(93133, 3560944748, 3560944755, 'TR', 'TUR', 'تركيا'),
(93134, 3560944756, 3560944759, 'MZ', 'MOZ', 'موزامبيق'),
(93135, 3560944760, 3560944767, 'TR', 'TUR', 'تركيا'),
(93136, 3560944768, 3560944771, 'MZ', 'MOZ', 'موزامبيق'),
(93137, 3560944772, 3560944779, 'DE', 'DEU', 'ألمانيا'),
(93138, 3560944780, 3560944783, 'ES', 'ESP', 'إسبانيا'),
(93139, 3560944784, 3560944787, 'FR', 'FRA', 'فرنسا'),
(93140, 3560944788, 3560944791, 'NL', 'NLD', 'هولندا'),
(93141, 3560944792, 3560944795, 'ES', 'ESP', 'إسبانيا'),
(93142, 3560944796, 3560944799, 'GB', 'GBR', 'المملكة المتحدة'),
(93143, 3560944800, 3560944803, 'ES', 'ESP', 'إسبانيا'),
(93144, 3560944804, 3560944807, 'FR', 'FRA', 'فرنسا'),
(93145, 3560944808, 3560944811, 'DE', 'DEU', 'ألمانيا'),
(93146, 3560944812, 3560944815, 'ES', 'ESP', 'إسبانيا'),
(93147, 3560944816, 3560944823, 'IT', 'ITA', 'إيطاليا'),
(93148, 3560944824, 3560944827, 'DE', 'DEU', 'ألمانيا'),
(93149, 3560944828, 3560944831, 'IE', 'IRL', 'إيرلندا'),
(93150, 3560944832, 3560944835, 'DE', 'DEU', 'ألمانيا'),
(93151, 3560944836, 3560944839, 'IT', 'ITA', 'إيطاليا'),
(93152, 3560944840, 3560944843, 'TR', 'TUR', 'تركيا'),
(93153, 3560944844, 3560944847, 'DE', 'DEU', 'ألمانيا'),
(93154, 3560944848, 3560944855, 'FR', 'FRA', 'فرنسا'),
(93155, 3560944856, 3560944859, 'NL', 'NLD', 'هولندا'),
(93156, 3560944860, 3560944863, 'DK', 'DNK', 'الدنيمارك'),
(93157, 3560944864, 3560944871, 'FR', 'FRA', 'فرنسا'),
(93158, 3560944872, 3560944875, 'DE', 'DEU', 'ألمانيا'),
(93159, 3560944876, 3560944879, 'ES', 'ESP', 'إسبانيا'),
(93160, 3560944880, 3560944883, 'SA', 'SAU', 'السعودية'),
(93161, 3560944884, 3560944887, 'ES', 'ESP', 'إسبانيا'),
(93162, 3560944888, 3560944891, 'CH', 'CHE', 'سويسرا'),
(93163, 3560944892, 3560944895, 'DE', 'DEU', 'ألمانيا'),
(93164, 3560944896, 3560944899, 'TW', 'TWN', 'تايوان'),
(93165, 3560944900, 3560944903, 'SG', 'SGP', 'سنغافورة'),
(93166, 3560944904, 3560944907, 'MY', 'MYS', 'ماليزيا'),
(93167, 3560944908, 3560944919, 'SG', 'SGP', 'سنغافورة'),
(93168, 3560944920, 3560944923, 'MY', 'MYS', 'ماليزيا'),
(93169, 3560944924, 3560944927, 'CN', 'CHN', 'الصين'),
(93170, 3560944928, 3560944931, 'MY', 'MYS', 'ماليزيا'),
(93171, 3560944932, 3560944935, 'SG', 'SGP', 'سنغافورة'),
(93172, 3560944936, 3560944943, 'CN', 'CHN', 'الصين'),
(93173, 3560944944, 3560944947, 'MY', 'MYS', 'ماليزيا'),
(93174, 3560944948, 3560944951, 'SG', 'SGP', 'سنغافورة'),
(93175, 3560944952, 3560944955, 'TW', 'TWN', 'تايوان'),
(93176, 3560944956, 3560944959, 'SG', 'SGP', 'سنغافورة'),
(93177, 3560944960, 3560944963, 'IN', 'IND', 'الهند'),
(93178, 3560944964, 3560944967, 'MY', 'MYS', 'ماليزيا'),
(93179, 3560944968, 3560944971, 'SG', 'SGP', 'سنغافورة'),
(93180, 3560944972, 3560944975, 'CN', 'CHN', 'الصين'),
(93181, 3560944976, 3560944987, 'IN', 'IND', 'الهند'),
(93182, 3560944988, 3560944991, 'SG', 'SGP', 'سنغافورة'),
(93183, 3560944992, 3560944995, 'MY', 'MYS', 'ماليزيا'),
(93184, 3560944996, 3560944999, 'SG', 'SGP', 'سنغافورة'),
(93185, 3560945000, 3560945003, 'MY', 'MYS', 'ماليزيا'),
(93186, 3560945004, 3560945007, 'IN', 'IND', 'الهند'),
(93187, 3560945008, 3560945011, 'SG', 'SGP', 'سنغافورة'),
(93188, 3560945012, 3560945015, 'DE', 'DEU', 'ألمانيا'),
(93189, 3560945016, 3560945027, 'IN', 'IND', 'الهند'),
(93190, 3560945028, 3560945031, 'MY', 'MYS', 'ماليزيا'),
(93191, 3560945032, 3560945035, 'IN', 'IND', 'الهند'),
(93192, 3560945036, 3560945039, 'CN', 'CHN', 'الصين'),
(93193, 3560945040, 3560945043, 'SG', 'SGP', 'سنغافورة'),
(93194, 3560945044, 3560945047, 'TW', 'TWN', 'تايوان'),
(93195, 3560945048, 3560945059, 'IN', 'IND', 'الهند'),
(93196, 3560945060, 3560945063, 'SG', 'SGP', 'سنغافورة'),
(93197, 3560945064, 3560945067, 'MY', 'MYS', 'ماليزيا'),
(93198, 3560945068, 3560945075, 'IN', 'IND', 'الهند'),
(93199, 3560945076, 3560945083, 'CN', 'CHN', 'الصين'),
(93200, 3560945084, 3560945091, 'IN', 'IND', 'الهند'),
(93201, 3560945092, 3560945095, 'SG', 'SGP', 'سنغافورة'),
(93202, 3560945096, 3560945099, 'CN', 'CHN', 'الصين'),
(93203, 3560945100, 3560945103, 'SG', 'SGP', 'سنغافورة'),
(93204, 3560945104, 3560945107, 'MY', 'MYS', 'ماليزيا'),
(93205, 3560945108, 3560945111, 'TW', 'TWN', 'تايوان'),
(93206, 3560945112, 3560945115, 'SG', 'SGP', 'سنغافورة'),
(93207, 3560945116, 3560945119, 'IN', 'IND', 'الهند'),
(93208, 3560945120, 3560945123, 'CN', 'CHN', 'الصين'),
(93209, 3560945124, 3560945131, 'SG', 'SGP', 'سنغافورة'),
(93210, 3560945132, 3560945135, 'TW', 'TWN', 'تايوان'),
(93211, 3560945136, 3560945139, 'MY', 'MYS', 'ماليزيا'),
(93212, 3560945140, 3560945143, 'SG', 'SGP', 'سنغافورة'),
(93213, 3560945144, 3560945147, 'IN', 'IND', 'الهند'),
(93214, 3560945148, 3560945151, 'SG', 'SGP', 'سنغافورة'),
(93215, 3560945152, 3560945153, 'DE', 'DEU', 'ألمانيا'),
(93216, 3560945154, 3560945156, 'AU', 'AUS', 'أستراليا'),
(93217, 3560945157, 3560945157, 'NZ', 'NZL', 'نيوزيلاندا'),
(93218, 3560945158, 3560945167, 'AU', 'AUS', 'أستراليا'),
(93219, 3560945168, 3560945168, 'DE', 'DEU', 'ألمانيا'),
(93220, 3560945169, 3560945169, 'AU', 'AUS', 'أستراليا'),
(93221, 3560945170, 3560945191, 'DE', 'DEU', 'ألمانيا'),
(93222, 3560945192, 3560945192, 'AU', 'AUS', 'أستراليا'),
(93223, 3560945193, 3560945194, 'DE', 'DEU', 'ألمانيا'),
(93224, 3560945195, 3560945195, 'AU', 'AUS', 'أستراليا'),
(93225, 3560945196, 3560945204, 'DE', 'DEU', 'ألمانيا'),
(93226, 3560945205, 3560945205, 'AU', 'AUS', 'أستراليا'),
(93227, 3560945206, 3560945206, 'IN', 'IND', 'الهند'),
(93228, 3560945207, 3560945209, 'AU', 'AUS', 'أستراليا'),
(93229, 3560945210, 3560945227, 'DE', 'DEU', 'ألمانيا'),
(93230, 3560945228, 3560945231, 'IN', 'IND', 'الهند'),
(93231, 3560945232, 3560945267, 'DE', 'DEU', 'ألمانيا'),
(93232, 3560945268, 3560945271, 'AU', 'AUS', 'أستراليا'),
(93233, 3560945272, 3560945275, 'DE', 'DEU', 'ألمانيا'),
(93234, 3560945276, 3560945279, 'AU', 'AUS', 'أستراليا'),
(93235, 3560945280, 3560945355, 'JP', 'JPN', 'اليابان'),
(93236, 3560945356, 3560945359, 'TH', 'THA', 'تايلند'),
(93237, 3560945360, 3560945403, 'JP', 'JPN', 'اليابان'),
(93238, 3560945404, 3560945407, 'TH', 'THA', 'تايلند'),
(93239, 3560945408, 3560945409, 'DE', 'DEU', 'ألمانيا'),
(93240, 3560945410, 3560945410, 'MY', 'MYS', 'ماليزيا'),
(93241, 3560945411, 3560945411, 'TW', 'TWN', 'تايوان'),
(93242, 3560945412, 3560945412, 'CN', 'CHN', 'الصين'),
(93243, 3560945413, 3560945413, 'SG', 'SGP', 'سنغافورة'),
(93244, 3560945414, 3560945414, 'IN', 'IND', 'الهند'),
(93245, 3560945415, 3560945416, 'SG', 'SGP', 'سنغافورة'),
(93246, 3560945417, 3560945418, 'CN', 'CHN', 'الصين'),
(93247, 3560945419, 3560945419, 'MY', 'MYS', 'ماليزيا'),
(93248, 3560945420, 3560945420, 'IN', 'IND', 'الهند'),
(93249, 3560945421, 3560945422, 'SG', 'SGP', 'سنغافورة'),
(93250, 3560945423, 3560945423, 'CN', 'CHN', 'الصين'),
(93251, 3560945424, 3560945424, 'MY', 'MYS', 'ماليزيا'),
(93252, 3560945425, 3560945425, 'IN', 'IND', 'الهند'),
(93253, 3560945426, 3560945426, 'MY', 'MYS', 'ماليزيا'),
(93254, 3560945427, 3560945427, 'CN', 'CHN', 'الصين'),
(93255, 3560945428, 3560945428, 'SG', 'SGP', 'سنغافورة'),
(93256, 3560945429, 3560945429, 'TW', 'TWN', 'تايوان'),
(93257, 3560945430, 3560945430, 'MY', 'MYS', 'ماليزيا'),
(93258, 3560945431, 3560945431, 'CN', 'CHN', 'الصين'),
(93259, 3560945432, 3560945433, 'IN', 'IND', 'الهند'),
(93260, 3560945434, 3560945434, 'TW', 'TWN', 'تايوان'),
(93261, 3560945435, 3560945435, 'MY', 'MYS', 'ماليزيا'),
(93262, 3560945436, 3560945436, 'CN', 'CHN', 'الصين'),
(93263, 3560945437, 3560945437, 'SG', 'SGP', 'سنغافورة'),
(93264, 3560945438, 3560945438, 'TW', 'TWN', 'تايوان'),
(93265, 3560945439, 3560945439, 'SG', 'SGP', 'سنغافورة'),
(93266, 3560945440, 3560945440, 'ID', 'IDN', 'إندونيسيا'),
(93267, 3560945441, 3560945441, 'SG', 'SGP', 'سنغافورة'),
(93268, 3560945442, 3560945443, 'IN', 'IND', 'الهند'),
(93269, 3560945444, 3560945448, 'SG', 'SGP', 'سنغافورة'),
(93270, 3560945449, 3560945449, 'IN', 'IND', 'الهند'),
(93271, 3560945450, 3560945450, 'SG', 'SGP', 'سنغافورة'),
(93272, 3560945451, 3560945451, 'IN', 'IND', 'الهند'),
(93273, 3560945452, 3560945452, 'SG', 'SGP', 'سنغافورة'),
(93274, 3560945453, 3560945453, 'IN', 'IND', 'الهند'),
(93275, 3560945454, 3560945458, 'SG', 'SGP', 'سنغافورة'),
(93276, 3560945459, 3560945459, 'TW', 'TWN', 'تايوان'),
(93277, 3560945460, 3560945461, 'SG', 'SGP', 'سنغافورة'),
(93278, 3560945462, 3560945462, 'IN', 'IND', 'الهند'),
(93279, 3560945463, 3560945465, 'SG', 'SGP', 'سنغافورة'),
(93280, 3560945466, 3560945466, 'CN', 'CHN', 'الصين'),
(93281, 3560945467, 3560945467, 'MY', 'MYS', 'ماليزيا'),
(93282, 3560945468, 3560945469, 'SG', 'SGP', 'سنغافورة'),
(93283, 3560945470, 3560945470, 'CN', 'CHN', 'الصين'),
(93284, 3560945471, 3560945471, 'SG', 'SGP', 'سنغافورة'),
(93285, 3560945472, 3560945472, 'CN', 'CHN', 'الصين'),
(93286, 3560945473, 3560945473, 'TW', 'TWN', 'تايوان'),
(93287, 3560945474, 3560945475, 'SG', 'SGP', 'سنغافورة'),
(93288, 3560945476, 3560945476, 'CN', 'CHN', 'الصين'),
(93289, 3560945477, 3560945477, 'TW', 'TWN', 'تايوان'),
(93290, 3560945478, 3560945478, 'IN', 'IND', 'الهند'),
(93291, 3560945479, 3560945479, 'SG', 'SGP', 'سنغافورة'),
(93292, 3560945480, 3560945481, 'IN', 'IND', 'الهند'),
(93293, 3560945482, 3560945482, 'DE', 'DEU', 'ألمانيا'),
(93294, 3560945483, 3560945485, 'MY', 'MYS', 'ماليزيا'),
(93295, 3560945486, 3560945487, 'IN', 'IND', 'الهند'),
(93296, 3560945488, 3560945488, 'DE', 'DEU', 'ألمانيا'),
(93297, 3560945489, 3560945489, 'MY', 'MYS', 'ماليزيا'),
(93298, 3560945490, 3560945490, 'TH', 'THA', 'تايلند'),
(93299, 3560945491, 3560945492, 'IN', 'IND', 'الهند'),
(93300, 3560945493, 3560945495, 'DE', 'DEU', 'ألمانيا'),
(93301, 3560945496, 3560945496, 'IN', 'IND', 'الهند'),
(93302, 3560945497, 3560945497, 'DE', 'DEU', 'ألمانيا'),
(93303, 3560945498, 3560945499, 'IN', 'IND', 'الهند'),
(93304, 3560945500, 3560945500, 'SG', 'SGP', 'سنغافورة'),
(93305, 3560945501, 3560945501, 'US', 'USA', 'الولايات المتحدة'),
(93306, 3560945502, 3560945502, 'IN', 'IND', 'الهند'),
(93307, 3560945503, 3560945535, 'DE', 'DEU', 'ألمانيا'),
(93308, 3560945536, 3560945539, 'IN', 'IND', 'الهند'),
(93309, 3560945540, 3560945543, 'SG', 'SGP', 'سنغافورة'),
(93310, 3560945544, 3560945559, 'IN', 'IND', 'الهند'),
(93311, 3560945560, 3560945563, 'DE', 'DEU', 'ألمانيا'),
(93312, 3560945564, 3560945567, 'SG', 'SGP', 'سنغافورة'),
(93313, 3560945568, 3560945575, 'IN', 'IND', 'الهند'),
(93314, 3560945576, 3560945579, 'SG', 'SGP', 'سنغافورة'),
(93315, 3560945580, 3560945583, 'MY', 'MYS', 'ماليزيا'),
(93316, 3560945584, 3560945587, 'SG', 'SGP', 'سنغافورة'),
(93317, 3560945588, 3560945591, 'TW', 'TWN', 'تايوان'),
(93318, 3560945592, 3560945603, 'SG', 'SGP', 'سنغافورة'),
(93319, 3560945604, 3560945607, 'US', 'USA', 'الولايات المتحدة'),
(93320, 3560945608, 3560945611, 'IN', 'IND', 'الهند'),
(93321, 3560945612, 3560945619, 'SG', 'SGP', 'سنغافورة'),
(93322, 3560945620, 3560945627, 'CN', 'CHN', 'الصين'),
(93323, 3560945628, 3560945635, 'SG', 'SGP', 'سنغافورة'),
(93324, 3560945636, 3560945639, 'CN', 'CHN', 'الصين'),
(93325, 3560945640, 3560945643, 'IN', 'IND', 'الهند'),
(93326, 3560945644, 3560945647, 'MY', 'MYS', 'ماليزيا'),
(93327, 3560945648, 3560945651, 'IN', 'IND', 'الهند'),
(93328, 3560945652, 3560945659, 'DE', 'DEU', 'ألمانيا'),
(93329, 3560945660, 3560945663, 'IN', 'IND', 'الهند'),
(93330, 3560945664, 3560945667, 'US', 'USA', 'الولايات المتحدة'),
(93331, 3560945668, 3560945671, 'BR', 'BRA', 'البرازيل'),
(93332, 3560945672, 3560945675, 'US', 'USA', 'الولايات المتحدة'),
(93333, 3560945676, 3560945679, 'PE', 'PER', 'بيرو'),
(93334, 3560945680, 3560945683, 'BR', 'BRA', 'البرازيل'),
(93335, 3560945684, 3560945691, 'CO', 'COL', 'كولومبيا'),
(93336, 3560945692, 3560945699, 'US', 'USA', 'الولايات المتحدة'),
(93337, 3560945700, 3560945703, 'CO', 'COL', 'كولومبيا'),
(93338, 3560945704, 3560945707, 'US', 'USA', 'الولايات المتحدة'),
(93339, 3560945708, 3560945711, 'CO', 'COL', 'كولومبيا'),
(93340, 3560945712, 3560945727, 'US', 'USA', 'الولايات المتحدة'),
(93341, 3560945728, 3560945731, 'AR', 'ARG', 'الأرجنتين'),
(93342, 3560945732, 3560945739, 'US', 'USA', 'الولايات المتحدة'),
(93343, 3560945740, 3560945743, 'BR', 'BRA', 'البرازيل'),
(93344, 3560945744, 3560945747, 'US', 'USA', 'الولايات المتحدة'),
(93345, 3560945748, 3560945751, 'AR', 'ARG', 'الأرجنتين'),
(93346, 3560945752, 3560945763, 'US', 'USA', 'الولايات المتحدة'),
(93347, 3560945764, 3560945767, 'AR', 'ARG', 'الأرجنتين'),
(93348, 3560945768, 3560945771, 'BR', 'BRA', 'البرازيل'),
(93349, 3560945772, 3560945775, 'CA', 'CAN', 'كندا'),
(93350, 3560945776, 3560945787, 'US', 'USA', 'الولايات المتحدة'),
(93351, 3560945788, 3560945791, 'CO', 'COL', 'كولومبيا'),
(93352, 3560945792, 3560945795, 'AR', 'ARG', 'الأرجنتين'),
(93353, 3560945796, 3560945799, 'US', 'USA', 'الولايات المتحدة'),
(93354, 3560945800, 3560945803, 'BR', 'BRA', 'البرازيل'),
(93355, 3560945804, 3560945807, 'US', 'USA', 'الولايات المتحدة'),
(93356, 3560945808, 3560945811, 'CO', 'COL', 'كولومبيا'),
(93357, 3560945812, 3560945815, 'US', 'USA', 'الولايات المتحدة'),
(93358, 3560945816, 3560945819, 'AR', 'ARG', 'الأرجنتين'),
(93359, 3560945820, 3560945823, 'US', 'USA', 'الولايات المتحدة'),
(93360, 3560945824, 3560945827, 'BR', 'BRA', 'البرازيل'),
(93361, 3560945828, 3560945835, 'US', 'USA', 'الولايات المتحدة'),
(93362, 3560945836, 3560945839, 'CL', 'CHL', 'تشيلي'),
(93363, 3560945840, 3560945843, 'BR', 'BRA', 'البرازيل'),
(93364, 3560945844, 3560945851, 'US', 'USA', 'الولايات المتحدة'),
(93365, 3560945852, 3560945855, 'DE', 'DEU', 'ألمانيا'),
(93366, 3560945856, 3560945859, 'US', 'USA', 'الولايات المتحدة'),
(93367, 3560945860, 3560945863, 'DE', 'DEU', 'ألمانيا'),
(93368, 3560945864, 3560945867, 'US', 'USA', 'الولايات المتحدة'),
(93369, 3560945868, 3560945871, 'DE', 'DEU', 'ألمانيا'),
(93370, 3560945872, 3560945875, 'CA', 'CAN', 'كندا'),
(93371, 3560945876, 3560945911, 'US', 'USA', 'الولايات المتحدة'),
(93372, 3560945912, 3560945915, 'CA', 'CAN', 'كندا'),
(93373, 3560945916, 3560945919, 'US', 'USA', 'الولايات المتحدة'),
(93374, 3560945920, 3560946017, 'DE', 'DEU', 'ألمانيا'),
(93375, 3560946018, 3560946018, 'FI', 'FIN', 'فنلندا'),
(93376, 3560946019, 3560946019, 'CZ', 'CZE', 'التشيك'),
(93377, 3560946020, 3560946176, 'DE', 'DEU', 'ألمانيا'),
(93378, 3560946177, 3560946189, 'US', 'USA', 'الولايات المتحدة'),
(93379, 3560946190, 3560946190, 'AR', 'ARG', 'الأرجنتين'),
(93380, 3560946191, 3560946194, 'US', 'USA', 'الولايات المتحدة'),
(93381, 3560946195, 3560946195, 'PE', 'PER', 'بيرو'),
(93382, 3560946196, 3560946196, 'CA', 'CAN', 'كندا'),
(93383, 3560946197, 3560946197, 'US', 'USA', 'الولايات المتحدة'),
(93384, 3560946198, 3560946198, 'CA', 'CAN', 'كندا'),
(93385, 3560946199, 3560946199, 'AR', 'ARG', 'الأرجنتين'),
(93386, 3560946200, 3560946200, 'US', 'USA', 'الولايات المتحدة'),
(93387, 3560946201, 3560946201, 'CA', 'CAN', 'كندا'),
(93388, 3560946202, 3560946202, 'DE', 'DEU', 'ألمانيا'),
(93389, 3560946203, 3560946203, 'CA', 'CAN', 'كندا'),
(93390, 3560946204, 3560946204, 'US', 'USA', 'الولايات المتحدة'),
(93391, 3560946205, 3560946205, 'PE', 'PER', 'بيرو'),
(93392, 3560946206, 3560946208, 'US', 'USA', 'الولايات المتحدة'),
(93393, 3560946209, 3560946209, 'CA', 'CAN', 'كندا'),
(93394, 3560946210, 3560946212, 'US', 'USA', 'الولايات المتحدة'),
(93395, 3560946213, 3560946213, 'CO', 'COL', 'كولومبيا'),
(93396, 3560946214, 3560946214, 'CA', 'CAN', 'كندا'),
(93397, 3560946215, 3560946215, 'PE', 'PER', 'بيرو'),
(93398, 3560946216, 3560946229, 'US', 'USA', 'الولايات المتحدة'),
(93399, 3560946230, 3560946230, 'AR', 'ARG', 'الأرجنتين'),
(93400, 3560946231, 3560946231, 'US', 'USA', 'الولايات المتحدة'),
(93401, 3560946232, 3560946232, 'CA', 'CAN', 'كندا'),
(93402, 3560946233, 3560946234, 'US', 'USA', 'الولايات المتحدة'),
(93403, 3560946235, 3560946235, 'CL', 'CHL', 'تشيلي'),
(93404, 3560946236, 3560946237, 'US', 'USA', 'الولايات المتحدة'),
(93405, 3560946238, 3560946238, 'AR', 'ARG', 'الأرجنتين'),
(93406, 3560946239, 3560946253, 'US', 'USA', 'الولايات المتحدة'),
(93407, 3560946254, 3560946254, 'SG', 'SGP', 'سنغافورة'),
(93408, 3560946255, 3560946256, 'US', 'USA', 'الولايات المتحدة'),
(93409, 3560946257, 3560946257, 'MX', 'MEX', 'المكسيك'),
(93410, 3560946258, 3560946259, 'US', 'USA', 'الولايات المتحدة'),
(93411, 3560946260, 3560946260, 'AR', 'ARG', 'الأرجنتين'),
(93412, 3560946261, 3560946262, 'US', 'USA', 'الولايات المتحدة'),
(93413, 3560946263, 3560946263, 'AR', 'ARG', 'الأرجنتين'),
(93414, 3560946264, 3560946266, 'US', 'USA', 'الولايات المتحدة'),
(93415, 3560946267, 3560946267, 'CA', 'CAN', 'كندا'),
(93416, 3560946268, 3560946271, 'US', 'USA', 'الولايات المتحدة'),
(93417, 3560946272, 3560946272, 'DE', 'DEU', 'ألمانيا'),
(93418, 3560946273, 3560946273, 'CA', 'CAN', 'كندا'),
(93419, 3560946274, 3560946279, 'US', 'USA', 'الولايات المتحدة'),
(93420, 3560946280, 3560946280, 'ES', 'ESP', 'إسبانيا'),
(93421, 3560946281, 3560946282, 'US', 'USA', 'الولايات المتحدة'),
(93422, 3560946283, 3560946283, 'CL', 'CHL', 'تشيلي'),
(93423, 3560946284, 3560946284, 'US', 'USA', 'الولايات المتحدة'),
(93424, 3560946285, 3560946285, 'CO', 'COL', 'كولومبيا'),
(93425, 3560946286, 3560946290, 'US', 'USA', 'الولايات المتحدة'),
(93426, 3560946291, 3560946291, 'CA', 'CAN', 'كندا'),
(93427, 3560946292, 3560946295, 'US', 'USA', 'الولايات المتحدة'),
(93428, 3560946296, 3560946296, 'CL', 'CHL', 'تشيلي'),
(93429, 3560946297, 3560946297, 'DE', 'DEU', 'ألمانيا'),
(93430, 3560946298, 3560946298, 'US', 'USA', 'الولايات المتحدة'),
(93431, 3560946299, 3560946299, 'DE', 'DEU', 'ألمانيا'),
(93432, 3560946300, 3560946300, 'CL', 'CHL', 'تشيلي'),
(93433, 3560946301, 3560946311, 'DE', 'DEU', 'ألمانيا'),
(93434, 3560946312, 3560946312, 'US', 'USA', 'الولايات المتحدة'),
(93435, 3560946313, 3560946317, 'DE', 'DEU', 'ألمانيا'),
(93436, 3560946318, 3560946319, 'US', 'USA', 'الولايات المتحدة'),
(93437, 3560946320, 3560946320, 'DE', 'DEU', 'ألمانيا'),
(93438, 3560946321, 3560946326, 'US', 'USA', 'الولايات المتحدة'),
(93439, 3560946327, 3560946327, 'CA', 'CAN', 'كندا'),
(93440, 3560946328, 3560946328, 'US', 'USA', 'الولايات المتحدة'),
(93441, 3560946329, 3560946329, 'DO', 'DOM', 'الدومينيكان'),
(93442, 3560946330, 3560946330, 'US', 'USA', 'الولايات المتحدة'),
(93443, 3560946331, 3560946331, 'DO', 'DOM', 'الدومينيكان'),
(93444, 3560946332, 3560946333, 'CA', 'CAN', 'كندا'),
(93445, 3560946334, 3560946335, 'US', 'USA', 'الولايات المتحدة'),
(93446, 3560946336, 3560946336, 'CA', 'CAN', 'كندا'),
(93447, 3560946337, 3560946337, 'DE', 'DEU', 'ألمانيا'),
(93448, 3560946338, 3560946338, 'CA', 'CAN', 'كندا'),
(93449, 3560946339, 3560946339, 'US', 'USA', 'الولايات المتحدة'),
(93450, 3560946340, 3560946340, 'CL', 'CHL', 'تشيلي'),
(93451, 3560946341, 3560946342, 'CA', 'CAN', 'كندا'),
(93452, 3560946343, 3560946343, 'DO', 'DOM', 'الدومينيكان'),
(93453, 3560946344, 3560946344, 'AR', 'ARG', 'الأرجنتين'),
(93454, 3560946345, 3560946345, 'US', 'USA', 'الولايات المتحدة'),
(93455, 3560946346, 3560946346, 'PE', 'PER', 'بيرو'),
(93456, 3560946347, 3560946347, 'US', 'USA', 'الولايات المتحدة'),
(93457, 3560946348, 3560946361, 'DE', 'DEU', 'ألمانيا'),
(93458, 3560946362, 3560946363, 'US', 'USA', 'الولايات المتحدة'),
(93459, 3560946364, 3560946367, 'DE', 'DEU', 'ألمانيا'),
(93460, 3560946368, 3560946368, 'US', 'USA', 'الولايات المتحدة'),
(93461, 3560946369, 3560946372, 'DE', 'DEU', 'ألمانيا'),
(93462, 3560946373, 3560946373, 'US', 'USA', 'الولايات المتحدة'),
(93463, 3560946374, 3560946374, 'DE', 'DEU', 'ألمانيا'),
(93464, 3560946375, 3560946375, 'US', 'USA', 'الولايات المتحدة'),
(93465, 3560946376, 3560946398, 'DE', 'DEU', 'ألمانيا'),
(93466, 3560946399, 3560946399, 'US', 'USA', 'الولايات المتحدة'),
(93467, 3560946400, 3560946408, 'DE', 'DEU', 'ألمانيا'),
(93468, 3560946409, 3560946409, 'US', 'USA', 'الولايات المتحدة'),
(93469, 3560946410, 3560946419, 'DE', 'DEU', 'ألمانيا'),
(93470, 3560946420, 3560946420, 'US', 'USA', 'الولايات المتحدة'),
(93471, 3560946421, 3560946431, 'DE', 'DEU', 'ألمانيا'),
(93472, 3560946432, 3560946443, 'US', 'USA', 'الولايات المتحدة'),
(93473, 3560946444, 3560946447, 'BR', 'BRA', 'البرازيل'),
(93474, 3560946448, 3560946451, 'DE', 'DEU', 'ألمانيا'),
(93475, 3560946452, 3560946455, 'BO', 'BOL', 'بوليفيا'),
(93476, 3560946456, 3560946467, 'US', 'USA', 'الولايات المتحدة'),
(93477, 3560946468, 3560946471, 'BR', 'BRA', 'البرازيل'),
(93478, 3560946472, 3560946483, 'US', 'USA', 'الولايات المتحدة'),
(93479, 3560946484, 3560946487, 'MX', 'MEX', 'المكسيك'),
(93480, 3560946488, 3560946491, 'US', 'USA', 'الولايات المتحدة'),
(93481, 3560946492, 3560946495, 'BR', 'BRA', 'البرازيل'),
(93482, 3560946496, 3560946499, 'VE', 'VEN', 'فنزويلا'),
(93483, 3560946500, 3560946503, 'AR', 'ARG', 'الأرجنتين'),
(93484, 3560946504, 3560946507, 'US', 'USA', 'الولايات المتحدة'),
(93485, 3560946508, 3560946511, 'MX', 'MEX', 'المكسيك'),
(93486, 3560946512, 3560946523, 'US', 'USA', 'الولايات المتحدة'),
(93487, 3560946524, 3560946527, 'MX', 'MEX', 'المكسيك'),
(93488, 3560946528, 3560946531, 'US', 'USA', 'الولايات المتحدة'),
(93489, 3560946532, 3560946535, 'CA', 'CAN', 'كندا'),
(93490, 3560946536, 3560946539, 'PE', 'PER', 'بيرو'),
(93491, 3560946540, 3560946543, 'US', 'USA', 'الولايات المتحدة'),
(93492, 3560946544, 3560946547, 'CA', 'CAN', 'كندا'),
(93493, 3560946548, 3560946551, 'US', 'USA', 'الولايات المتحدة'),
(93494, 3560946552, 3560946555, 'PE', 'PER', 'بيرو'),
(93495, 3560946556, 3560946559, 'US', 'USA', 'الولايات المتحدة'),
(93496, 3560946560, 3560946563, 'BR', 'BRA', 'البرازيل'),
(93497, 3560946564, 3560946567, 'US', 'USA', 'الولايات المتحدة'),
(93498, 3560946568, 3560946571, 'BR', 'BRA', 'البرازيل'),
(93499, 3560946572, 3560946579, 'US', 'USA', 'الولايات المتحدة'),
(93500, 3560946580, 3560946583, 'CA', 'CAN', 'كندا'),
(93501, 3560946584, 3560946587, 'US', 'USA', 'الولايات المتحدة'),
(93502, 3560946588, 3560946591, 'AR', 'ARG', 'الأرجنتين'),
(93503, 3560946592, 3560946603, 'US', 'USA', 'الولايات المتحدة'),
(93504, 3560946604, 3560946607, 'AR', 'ARG', 'الأرجنتين'),
(93505, 3560946608, 3560946611, 'BR', 'BRA', 'البرازيل'),
(93506, 3560946612, 3560946623, 'US', 'USA', 'الولايات المتحدة'),
(93507, 3560946624, 3560946635, 'MX', 'MEX', 'المكسيك'),
(93508, 3560946636, 3560946643, 'US', 'USA', 'الولايات المتحدة'),
(93509, 3560946644, 3560946647, 'AR', 'ARG', 'الأرجنتين'),
(93510, 3560946648, 3560946651, 'MX', 'MEX', 'المكسيك'),
(93511, 3560946652, 3560946655, 'CL', 'CHL', 'تشيلي'),
(93512, 3560946656, 3560946659, 'BR', 'BRA', 'البرازيل'),
(93513, 3560946660, 3560946663, 'MX', 'MEX', 'المكسيك'),
(93514, 3560946664, 3560946667, 'US', 'USA', 'الولايات المتحدة'),
(93515, 3560946668, 3560946671, 'MX', 'MEX', 'المكسيك'),
(93516, 3560946672, 3560946679, 'BR', 'BRA', 'البرازيل'),
(93517, 3560946680, 3560946687, 'US', 'USA', 'الولايات المتحدة'),
(93518, 3560946688, 3560946689, 'DE', 'DEU', 'ألمانيا'),
(93519, 3560946690, 3560946695, 'US', 'USA', 'الولايات المتحدة'),
(93520, 3560946696, 3560946696, 'BR', 'BRA', 'البرازيل'),
(93521, 3560946697, 3560946698, 'US', 'USA', 'الولايات المتحدة'),
(93522, 3560946699, 3560946700, 'DE', 'DEU', 'ألمانيا'),
(93523, 3560946701, 3560946701, 'CO', 'COL', 'كولومبيا'),
(93524, 3560946702, 3560946706, 'US', 'USA', 'الولايات المتحدة'),
(93525, 3560946707, 3560946707, 'VE', 'VEN', 'فنزويلا'),
(93526, 3560946708, 3560946708, 'BR', 'BRA', 'البرازيل'),
(93527, 3560946709, 3560946710, 'VE', 'VEN', 'فنزويلا'),
(93528, 3560946711, 3560946711, 'US', 'USA', 'الولايات المتحدة'),
(93529, 3560946712, 3560946712, 'VE', 'VEN', 'فنزويلا'),
(93530, 3560946713, 3560946714, 'US', 'USA', 'الولايات المتحدة'),
(93531, 3560946715, 3560946715, 'CO', 'COL', 'كولومبيا'),
(93532, 3560946716, 3560946716, 'US', 'USA', 'الولايات المتحدة'),
(93533, 3560946717, 3560946717, 'AR', 'ARG', 'الأرجنتين'),
(93534, 3560946718, 3560946718, 'US', 'USA', 'الولايات المتحدة'),
(93535, 3560946719, 3560946720, 'BR', 'BRA', 'البرازيل'),
(93536, 3560946721, 3560946723, 'CO', 'COL', 'كولومبيا'),
(93537, 3560946724, 3560946724, 'MX', 'MEX', 'المكسيك'),
(93538, 3560946725, 3560946729, 'US', 'USA', 'الولايات المتحدة'),
(93539, 3560946730, 3560946730, 'MX', 'MEX', 'المكسيك'),
(93540, 3560946731, 3560946733, 'US', 'USA', 'الولايات المتحدة'),
(93541, 3560946734, 3560946734, 'PR', 'PRI', 'بورتو ريكو'),
(93542, 3560946735, 3560946747, 'US', 'USA', 'الولايات المتحدة'),
(93543, 3560946748, 3560946748, 'DE', 'DEU', 'ألمانيا'),
(93544, 3560946749, 3560946760, 'US', 'USA', 'الولايات المتحدة'),
(93545, 3560946761, 3560946761, 'DE', 'DEU', 'ألمانيا'),
(93546, 3560946762, 3560946767, 'US', 'USA', 'الولايات المتحدة'),
(93547, 3560946768, 3560946768, 'CA', 'CAN', 'كندا'),
(93548, 3560946769, 3560946769, 'US', 'USA', 'الولايات المتحدة'),
(93549, 3560946770, 3560946825, 'DE', 'DEU', 'ألمانيا'),
(93550, 3560946826, 3560946826, 'US', 'USA', 'الولايات المتحدة'),
(93551, 3560946827, 3560946835, 'DE', 'DEU', 'ألمانيا'),
(93552, 3560946836, 3560946836, 'US', 'USA', 'الولايات المتحدة'),
(93553, 3560946837, 3560946839, 'DE', 'DEU', 'ألمانيا'),
(93554, 3560946840, 3560946840, 'US', 'USA', 'الولايات المتحدة'),
(93555, 3560946841, 3560946943, 'DE', 'DEU', 'ألمانيا'),
(93556, 3560946944, 3560946947, 'US', 'USA', 'الولايات المتحدة'),
(93557, 3560946948, 3560946951, 'BR', 'BRA', 'البرازيل'),
(93558, 3560946952, 3560946955, 'MX', 'MEX', 'المكسيك'),
(93559, 3560946956, 3560946959, 'CO', 'COL', 'كولومبيا'),
(93560, 3560946960, 3560946963, 'MX', 'MEX', 'المكسيك'),
(93561, 3560946964, 3560946967, 'AR', 'ARG', 'الأرجنتين'),
(93562, 3560946968, 3560946979, 'US', 'USA', 'الولايات المتحدة'),
(93563, 3560946980, 3560946987, 'DE', 'DEU', 'ألمانيا'),
(93564, 3560946988, 3560946991, 'US', 'USA', 'الولايات المتحدة'),
(93565, 3560946992, 3560946995, 'DE', 'DEU', 'ألمانيا'),
(93566, 3560946996, 3560946999, 'UY', 'URY', 'الأوروغواي'),
(93567, 3560947000, 3560947015, 'US', 'USA', 'الولايات المتحدة'),
(93568, 3560947016, 3560947019, 'AR', 'ARG', 'الأرجنتين'),
(93569, 3560947020, 3560947027, 'US', 'USA', 'الولايات المتحدة'),
(93570, 3560947028, 3560947031, 'CO', 'COL', 'كولومبيا'),
(93571, 3560947032, 3560947039, 'US', 'USA', 'الولايات المتحدة'),
(93572, 3560947040, 3560947043, 'BR', 'BRA', 'البرازيل'),
(93573, 3560947044, 3560947067, 'US', 'USA', 'الولايات المتحدة'),
(93574, 3560947068, 3560947071, 'AR', 'ARG', 'الأرجنتين'),
(93575, 3560947072, 3560947075, 'BR', 'BRA', 'البرازيل'),
(93576, 3560947076, 3560947095, 'US', 'USA', 'الولايات المتحدة'),
(93577, 3560947096, 3560947099, 'MX', 'MEX', 'المكسيك'),
(93578, 3560947100, 3560947107, 'US', 'USA', 'الولايات المتحدة'),
(93579, 3560947108, 3560947111, 'DE', 'DEU', 'ألمانيا'),
(93580, 3560947112, 3560947123, 'US', 'USA', 'الولايات المتحدة'),
(93581, 3560947124, 3560947127, 'CO', 'COL', 'كولومبيا'),
(93582, 3560947128, 3560947143, 'US', 'USA', 'الولايات المتحدة'),
(93583, 3560947144, 3560947147, 'DE', 'DEU', 'ألمانيا'),
(93584, 3560947148, 3560947191, 'US', 'USA', 'الولايات المتحدة'),
(93585, 3560947192, 3560947195, 'VE', 'VEN', 'فنزويلا'),
(93586, 3560947196, 3560947199, 'DE', 'DEU', 'ألمانيا'),
(93587, 3560947200, 3560947203, 'CA', 'CAN', 'كندا'),
(93588, 3560947204, 3560947207, 'US', 'USA', 'الولايات المتحدة'),
(93589, 3560947208, 3560947211, 'DE', 'DEU', 'ألمانيا'),
(93590, 3560947212, 3560947231, 'US', 'USA', 'الولايات المتحدة'),
(93591, 3560947232, 3560947235, 'CA', 'CAN', 'كندا'),
(93592, 3560947236, 3560947239, 'CO', 'COL', 'كولومبيا'),
(93593, 3560947240, 3560947247, 'US', 'USA', 'الولايات المتحدة'),
(93594, 3560947248, 3560947251, 'CA', 'CAN', 'كندا'),
(93595, 3560947252, 3560947267, 'US', 'USA', 'الولايات المتحدة'),
(93596, 3560947268, 3560947271, 'CO', 'COL', 'كولومبيا'),
(93597, 3560947272, 3560947275, 'US', 'USA', 'الولايات المتحدة'),
(93598, 3560947276, 3560947279, 'AR', 'ARG', 'الأرجنتين'),
(93599, 3560947280, 3560947283, 'MX', 'MEX', 'المكسيك'),
(93600, 3560947284, 3560947287, 'US', 'USA', 'الولايات المتحدة'),
(93601, 3560947288, 3560947291, 'BR', 'BRA', 'البرازيل'),
(93602, 3560947292, 3560947331, 'US', 'USA', 'الولايات المتحدة'),
(93603, 3560947332, 3560947335, 'MX', 'MEX', 'المكسيك'),
(93604, 3560947336, 3560947343, 'US', 'USA', 'الولايات المتحدة'),
(93605, 3560947344, 3560947347, 'MX', 'MEX', 'المكسيك'),
(93606, 3560947348, 3560947351, 'CO', 'COL', 'كولومبيا'),
(93607, 3560947352, 3560947355, 'US', 'USA', 'الولايات المتحدة'),
(93608, 3560947356, 3560947359, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(93609, 3560947360, 3560947363, 'US', 'USA', 'الولايات المتحدة'),
(93610, 3560947364, 3560947367, 'HN', 'HND', 'هندوراس'),
(93611, 3560947368, 3560947371, 'BR', 'BRA', 'البرازيل'),
(93612, 3560947372, 3560947375, 'CA', 'CAN', 'كندا'),
(93613, 3560947376, 3560947383, 'US', 'USA', 'الولايات المتحدة'),
(93614, 3560947384, 3560947391, 'CO', 'COL', 'كولومبيا'),
(93615, 3560947392, 3560947395, 'MX', 'MEX', 'المكسيك'),
(93616, 3560947396, 3560947399, 'US', 'USA', 'الولايات المتحدة'),
(93617, 3560947400, 3560947407, 'AR', 'ARG', 'الأرجنتين'),
(93618, 3560947408, 3560947411, 'US', 'USA', 'الولايات المتحدة'),
(93619, 3560947412, 3560947415, 'AR', 'ARG', 'الأرجنتين'),
(93620, 3560947416, 3560947431, 'US', 'USA', 'الولايات المتحدة'),
(93621, 3560947432, 3560947435, 'MX', 'MEX', 'المكسيك'),
(93622, 3560947436, 3560947439, 'DE', 'DEU', 'ألمانيا'),
(93623, 3560947440, 3560947443, 'BR', 'BRA', 'البرازيل'),
(93624, 3560947444, 3560947455, 'US', 'USA', 'الولايات المتحدة'),
(93625, 3560947456, 3560947495, 'JP', 'JPN', 'اليابان'),
(93626, 3560947496, 3560947499, 'KR', 'KOR', 'جمهورية كوريا'),
(93627, 3560947500, 3560947686, 'JP', 'JPN', 'اليابان'),
(93628, 3560947687, 3560947687, 'DE', 'DEU', 'ألمانيا'),
(93629, 3560947688, 3560947711, 'JP', 'JPN', 'اليابان'),
(93630, 3560947712, 3560950863, 'SE', 'SWE', 'السويد'),
(93631, 3560950864, 3560950867, 'DK', 'DNK', 'الدنيمارك'),
(93632, 3560950868, 3560950871, 'ES', 'ESP', 'إسبانيا'),
(93633, 3560950872, 3560951027, 'SE', 'SWE', 'السويد'),
(93634, 3560951028, 3560951031, 'DK', 'DNK', 'الدنيمارك'),
(93635, 3560951032, 3560951039, 'SE', 'SWE', 'السويد'),
(93636, 3560951040, 3560951043, 'NO', 'NOR', 'النرويج'),
(93637, 3560951044, 3560951103, 'SE', 'SWE', 'السويد'),
(93638, 3560951104, 3560951107, 'DE', 'DEU', 'ألمانيا'),
(93639, 3560951108, 3560951111, 'DK', 'DNK', 'الدنيمارك'),
(93640, 3560951112, 3560951115, 'FR', 'FRA', 'فرنسا'),
(93641, 3560951116, 3560951195, 'SE', 'SWE', 'السويد'),
(93642, 3560951196, 3560951199, 'DK', 'DNK', 'الدنيمارك'),
(93643, 3560951200, 3560951207, 'SE', 'SWE', 'السويد'),
(93644, 3560951208, 3560951211, 'DK', 'DNK', 'الدنيمارك'),
(93645, 3560951212, 3560951307, 'SE', 'SWE', 'السويد'),
(93646, 3560951308, 3560951311, 'IT', 'ITA', 'إيطاليا'),
(93647, 3560951312, 3560951383, 'SE', 'SWE', 'السويد'),
(93648, 3560951384, 3560951387, 'NO', 'NOR', 'النرويج'),
(93649, 3560951388, 3560951391, 'SE', 'SWE', 'السويد'),
(93650, 3560951392, 3560951395, 'IT', 'ITA', 'إيطاليا'),
(93651, 3560951396, 3560951399, 'DE', 'DEU', 'ألمانيا'),
(93652, 3560951400, 3560951403, 'SE', 'SWE', 'السويد'),
(93653, 3560951404, 3560951407, 'NO', 'NOR', 'النرويج'),
(93654, 3560951408, 3560951423, 'SE', 'SWE', 'السويد'),
(93655, 3560951424, 3560951427, 'NL', 'NLD', 'هولندا'),
(93656, 3560951428, 3560951447, 'SE', 'SWE', 'السويد'),
(93657, 3560951448, 3560951451, 'FR', 'FRA', 'فرنسا'),
(93658, 3560951452, 3560951551, 'SE', 'SWE', 'السويد'),
(93659, 3560951552, 3560951555, 'ES', 'ESP', 'إسبانيا'),
(93660, 3560951556, 3560951559, 'NO', 'NOR', 'النرويج'),
(93661, 3560951560, 3560951583, 'SE', 'SWE', 'السويد'),
(93662, 3560951584, 3560951587, 'FI', 'FIN', 'فنلندا'),
(93663, 3560951588, 3560951679, 'SE', 'SWE', 'السويد'),
(93664, 3560951680, 3560951683, 'DE', 'DEU', 'ألمانيا'),
(93665, 3560951684, 3560951915, 'SE', 'SWE', 'السويد'),
(93666, 3560951916, 3560951919, 'PL', 'POL', 'بولندا'),
(93667, 3560951920, 3560951935, 'SE', 'SWE', 'السويد'),
(93668, 3560951936, 3560951940, 'NL', 'NLD', 'هولندا'),
(93669, 3560951941, 3560953103, 'SE', 'SWE', 'السويد'),
(93670, 3560953104, 3560953119, 'JP', 'JPN', 'اليابان'),
(93671, 3560953120, 3560954111, 'SE', 'SWE', 'السويد'),
(93672, 3560954112, 3560954367, 'AX', 'FIN', 'فنلندا'),
(93673, 3560954368, 3560955903, 'SE', 'SWE', 'السويد'),
(93674, 3560955904, 3560964095, 'BE', 'BEL', 'بلجيكا'),
(93675, 3560964096, 3560996863, 'NL', 'NLD', 'هولندا'),
(93676, 3560996864, 3561005055, 'GB', 'GBR', 'المملكة المتحدة'),
(93677, 3561005056, 3561013247, 'ES', 'ESP', 'إسبانيا'),
(93678, 3561013248, 3561021439, 'TR', 'TUR', 'تركيا'),
(93679, 3561021440, 3561022719, 'DE', 'DEU', 'ألمانيا'),
(93680, 3561022720, 3561022975, 'AT', 'AUT', 'النمسا'),
(93681, 3561022976, 3561037823, 'DE', 'DEU', 'ألمانيا'),
(93682, 3561037824, 3561039231, 'BE', 'BEL', 'بلجيكا'),
(93683, 3561039232, 3561039263, 'NL', 'NLD', 'هولندا'),
(93684, 3561039264, 3561039327, 'BE', 'BEL', 'بلجيكا'),
(93685, 3561039328, 3561039330, 'NL', 'NLD', 'هولندا'),
(93686, 3561039331, 3561046015, 'BE', 'BEL', 'بلجيكا'),
(93687, 3561046016, 3561054207, 'RU', 'RUS', 'الإتحاد الروسي'),
(93688, 3561054208, 3561062399, 'MT', 'MLT', 'مالطا'),
(93689, 3561062400, 3561070591, 'TR', 'TUR', 'تركيا'),
(93690, 3561070592, 3561070847, 'DE', 'DEU', 'ألمانيا'),
(93691, 3561070848, 3561078783, 'CH', 'CHE', 'سويسرا'),
(93692, 3561078784, 3561095167, 'CZ', 'CZE', 'التشيك'),
(93693, 3561095168, 3561103359, 'DE', 'DEU', 'ألمانيا'),
(93694, 3561103360, 3561111551, 'UA', 'UKR', 'أوكرانيا'),
(93695, 3561111552, 3561119743, 'LU', 'LUX', 'لوكسيمبورغ'),
(93696, 3561119744, 3561127935, 'IT', 'ITA', 'إيطاليا'),
(93697, 3561127936, 3561136127, 'DE', 'DEU', 'ألمانيا'),
(93698, 3561136128, 3561144319, 'ES', 'ESP', 'إسبانيا'),
(93699, 3561144320, 3561152511, 'FI', 'FIN', 'فنلندا'),
(93700, 3561152512, 3561160703, 'IT', 'ITA', 'إيطاليا'),
(93701, 3561160704, 3561168895, 'RU', 'RUS', 'الإتحاد الروسي'),
(93702, 3561168896, 3561177087, 'FR', 'FRA', 'فرنسا'),
(93703, 3561177088, 3561185279, 'CZ', 'CZE', 'التشيك'),
(93704, 3561185280, 3561193471, 'GB', 'GBR', 'المملكة المتحدة'),
(93705, 3561193472, 3561201663, 'PL', 'POL', 'بولندا'),
(93706, 3561201664, 3561206655, 'NL', 'NLD', 'هولندا'),
(93707, 3561206656, 3561206663, 'BE', 'BEL', 'بلجيكا'),
(93708, 3561206664, 3561209855, 'NL', 'NLD', 'هولندا'),
(93709, 3561209856, 3561218047, 'GB', 'GBR', 'المملكة المتحدة'),
(93710, 3561218048, 3561226239, 'AT', 'AUT', 'النمسا'),
(93711, 3561226240, 3561234431, 'FI', 'FIN', 'فنلندا'),
(93712, 3561234432, 3561242623, 'TR', 'TUR', 'تركيا'),
(93713, 3561242624, 3561259007, 'DE', 'DEU', 'ألمانيا'),
(93714, 3561259008, 3561267199, 'IL', 'ISR', 'إسرائيل'),
(93715, 3561267200, 3561275391, 'UA', 'UKR', 'أوكرانيا'),
(93716, 3561275392, 3561291775, 'BE', 'BEL', 'بلجيكا'),
(93717, 3561291776, 3561299967, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(93718, 3561299968, 3561308159, 'GB', 'GBR', 'المملكة المتحدة'),
(93719, 3561308160, 3561316351, 'PL', 'POL', 'بولندا'),
(93720, 3561316352, 3561324543, 'RU', 'RUS', 'الإتحاد الروسي'),
(93721, 3561324544, 3561332735, 'IT', 'ITA', 'إيطاليا'),
(93722, 3561332736, 3561340927, 'AT', 'AUT', 'النمسا'),
(93723, 3561340928, 3561357311, 'GB', 'GBR', 'المملكة المتحدة'),
(93724, 3561357312, 3561365503, 'DK', 'DNK', 'الدنيمارك'),
(93725, 3561365504, 3561373695, 'SA', 'SAU', 'السعودية'),
(93726, 3561373696, 3561381887, 'GB', 'GBR', 'المملكة المتحدة'),
(93727, 3561381888, 3561382479, 'AT', 'AUT', 'النمسا'),
(93728, 3561382480, 3561382495, 'DE', 'DEU', 'ألمانيا'),
(93729, 3561382496, 3561390079, 'AT', 'AUT', 'النمسا'),
(93730, 3561390080, 3561398271, 'BG', 'BGR', 'بلغاريا'),
(93731, 3561398272, 3561406463, 'LV', 'LVA', 'لاتفيا'),
(93732, 3561406464, 3561414655, 'GR', 'GRC', 'اليونان'),
(93733, 3561414656, 3561422847, 'IT', 'ITA', 'إيطاليا'),
(93734, 3561422848, 3561427207, 'BE', 'BEL', 'بلجيكا'),
(93735, 3561427208, 3561427211, 'NL', 'NLD', 'هولندا'),
(93736, 3561427212, 3561428135, 'BE', 'BEL', 'بلجيكا'),
(93737, 3561428136, 3561428143, 'NL', 'NLD', 'هولندا'),
(93738, 3561428144, 3561429279, 'BE', 'BEL', 'بلجيكا'),
(93739, 3561429280, 3561429287, 'NL', 'NLD', 'هولندا'),
(93740, 3561429288, 3561431039, 'BE', 'BEL', 'بلجيكا'),
(93741, 3561431040, 3561439231, 'SA', 'SAU', 'السعودية'),
(93742, 3561439232, 3561447423, 'NO', 'NOR', 'النرويج'),
(93743, 3561447424, 3561455615, 'CH', 'CHE', 'سويسرا'),
(93744, 3561455616, 3561471999, 'CZ', 'CZE', 'التشيك'),
(93745, 3561472000, 3561480191, 'DE', 'DEU', 'ألمانيا'),
(93746, 3561480192, 3561488383, 'GB', 'GBR', 'المملكة المتحدة'),
(93747, 3561488384, 3561496575, 'OM', 'OMN', 'عمان'),
(93748, 3561496576, 3561496831, 'NL', 'NLD', 'هولندا'),
(93749, 3561496832, 3561496887, 'GB', 'GBR', 'المملكة المتحدة'),
(93750, 3561496888, 3561496891, 'NL', 'NLD', 'هولندا'),
(93751, 3561496892, 3561496955, 'GB', 'GBR', 'المملكة المتحدة'),
(93752, 3561496956, 3561496959, 'NL', 'NLD', 'هولندا'),
(93753, 3561496960, 3561497215, 'GB', 'GBR', 'المملكة المتحدة'),
(93754, 3561497216, 3561497423, 'NL', 'NLD', 'هولندا'),
(93755, 3561497424, 3561497471, 'GB', 'GBR', 'المملكة المتحدة'),
(93756, 3561497472, 3561497535, 'NL', 'NLD', 'هولندا'),
(93757, 3561497536, 3561497599, 'GB', 'GBR', 'المملكة المتحدة'),
(93758, 3561497600, 3561498111, 'NL', 'NLD', 'هولندا'),
(93759, 3561498112, 3561498399, 'GB', 'GBR', 'المملكة المتحدة'),
(93760, 3561498400, 3561498431, 'NL', 'NLD', 'هولندا'),
(93761, 3561498432, 3561498487, 'GB', 'GBR', 'المملكة المتحدة'),
(93762, 3561498488, 3561498491, 'NL', 'NLD', 'هولندا'),
(93763, 3561498492, 3561498495, 'GB', 'GBR', 'المملكة المتحدة'),
(93764, 3561498496, 3561498559, 'NL', 'NLD', 'هولندا'),
(93765, 3561498560, 3561498607, 'GB', 'GBR', 'المملكة المتحدة'),
(93766, 3561498608, 3561498615, 'NL', 'NLD', 'هولندا'),
(93767, 3561498616, 3561498623, 'GB', 'GBR', 'المملكة المتحدة'),
(93768, 3561498624, 3561500415, 'NL', 'NLD', 'هولندا'),
(93769, 3561500416, 3561500671, 'GB', 'GBR', 'المملكة المتحدة'),
(93770, 3561500672, 3561500703, 'NL', 'NLD', 'هولندا'),
(93771, 3561500704, 3561500719, 'GB', 'GBR', 'المملكة المتحدة'),
(93772, 3561500720, 3561500751, 'NL', 'NLD', 'هولندا'),
(93773, 3561500752, 3561500763, 'GB', 'GBR', 'المملكة المتحدة'),
(93774, 3561500764, 3561500767, 'NL', 'NLD', 'هولندا'),
(93775, 3561500768, 3561500775, 'GB', 'GBR', 'المملكة المتحدة'),
(93776, 3561500776, 3561501311, 'NL', 'NLD', 'هولندا'),
(93777, 3561501312, 3561501343, 'GB', 'GBR', 'المملكة المتحدة'),
(93778, 3561501344, 3561501375, 'NL', 'NLD', 'هولندا'),
(93779, 3561501376, 3561501407, 'GB', 'GBR', 'المملكة المتحدة'),
(93780, 3561501408, 3561501443, 'NL', 'NLD', 'هولندا'),
(93781, 3561501444, 3561501487, 'GB', 'GBR', 'المملكة المتحدة'),
(93782, 3561501488, 3561501503, 'NL', 'NLD', 'هولندا'),
(93783, 3561501504, 3561501535, 'GB', 'GBR', 'المملكة المتحدة'),
(93784, 3561501536, 3561501631, 'NL', 'NLD', 'هولندا'),
(93785, 3561501632, 3561501695, 'GB', 'GBR', 'المملكة المتحدة'),
(93786, 3561501696, 3561502047, 'NL', 'NLD', 'هولندا'),
(93787, 3561502048, 3561502079, 'GB', 'GBR', 'المملكة المتحدة'),
(93788, 3561502080, 3561502143, 'NL', 'NLD', 'هولندا'),
(93789, 3561502144, 3561502207, 'GB', 'GBR', 'المملكة المتحدة'),
(93790, 3561502208, 3561502631, 'NL', 'NLD', 'هولندا'),
(93791, 3561502632, 3561502655, 'GB', 'GBR', 'المملكة المتحدة'),
(93792, 3561502656, 3561504255, 'NL', 'NLD', 'هولندا'),
(93793, 3561504256, 3561504383, 'GB', 'GBR', 'المملكة المتحدة'),
(93794, 3561504384, 3561504767, 'NL', 'NLD', 'هولندا'),
(93795, 3561504768, 3561512959, 'DE', 'DEU', 'ألمانيا'),
(93796, 3561512960, 3561521151, 'SI', 'SVN', 'سلوفينيا'),
(93797, 3561521152, 3561529343, 'GE', 'GEO', 'جورجيا'),
(93798, 3561529344, 3561534559, 'DE', 'DEU', 'ألمانيا'),
(93799, 3561534560, 3561534575, 'US', 'USA', 'الولايات المتحدة'),
(93800, 3561534576, 3561537535, 'DE', 'DEU', 'ألمانيا'),
(93801, 3561537536, 3561545727, 'BG', 'BGR', 'بلغاريا'),
(93802, 3561545728, 3561553919, 'NL', 'NLD', 'هولندا'),
(93803, 3561553920, 3561562111, 'SE', 'SWE', 'السويد'),
(93804, 3561562112, 3561570303, 'ES', 'ESP', 'إسبانيا'),
(93805, 3561570304, 3561578495, 'AM', 'ARM', 'أرمينيا'),
(93806, 3561578496, 3561586687, 'RU', 'RUS', 'الإتحاد الروسي'),
(93807, 3561586688, 3561594879, 'BG', 'BGR', 'بلغاريا'),
(93808, 3561594880, 3561594935, 'SE', 'SWE', 'السويد'),
(93809, 3561594936, 3561594939, 'DK', 'DNK', 'الدنيمارك'),
(93810, 3561594940, 3561594975, 'SE', 'SWE', 'السويد'),
(93811, 3561594976, 3561595007, 'DK', 'DNK', 'الدنيمارك'),
(93812, 3561595008, 3561603071, 'SE', 'SWE', 'السويد'),
(93813, 3561603072, 3561603263, 'FR', 'FRA', 'فرنسا'),
(93814, 3561603264, 3561603295, 'GB', 'GBR', 'المملكة المتحدة'),
(93815, 3561603296, 3561603455, 'FR', 'FRA', 'فرنسا'),
(93816, 3561603456, 3561603487, 'GB', 'GBR', 'المملكة المتحدة'),
(93817, 3561603488, 3561604351, 'FR', 'FRA', 'فرنسا'),
(93818, 3561604352, 3561604895, 'GB', 'GBR', 'المملكة المتحدة'),
(93819, 3561604896, 3561604911, 'FR', 'FRA', 'فرنسا'),
(93820, 3561604912, 3561605119, 'GB', 'GBR', 'المملكة المتحدة'),
(93821, 3561605120, 3561607231, 'FR', 'FRA', 'فرنسا'),
(93822, 3561607232, 3561607235, 'GB', 'GBR', 'المملكة المتحدة'),
(93823, 3561607236, 3561607239, 'FR', 'FRA', 'فرنسا'),
(93824, 3561607240, 3561607247, 'GB', 'GBR', 'المملكة المتحدة'),
(93825, 3561607248, 3561607343, 'FR', 'FRA', 'فرنسا'),
(93826, 3561607344, 3561607359, 'GB', 'GBR', 'المملكة المتحدة'),
(93827, 3561607360, 3561607679, 'FR', 'FRA', 'فرنسا'),
(93828, 3561607680, 3561607711, 'GB', 'GBR', 'المملكة المتحدة'),
(93829, 3561607712, 3561607727, 'FR', 'FRA', 'فرنسا'),
(93830, 3561607728, 3561607743, 'GB', 'GBR', 'المملكة المتحدة'),
(93831, 3561607744, 3561610239, 'FR', 'FRA', 'فرنسا'),
(93832, 3561610240, 3561610495, 'US', 'USA', 'الولايات المتحدة'),
(93833, 3561610496, 3561610527, 'FR', 'FRA', 'فرنسا'),
(93834, 3561610528, 3561610719, 'GB', 'GBR', 'المملكة المتحدة'),
(93835, 3561610720, 3561611295, 'FR', 'FRA', 'فرنسا'),
(93836, 3561611296, 3561611559, 'GB', 'GBR', 'المملكة المتحدة'),
(93837, 3561611560, 3561611567, 'FR', 'FRA', 'فرنسا'),
(93838, 3561611568, 3561614175, 'GB', 'GBR', 'المملكة المتحدة'),
(93839, 3561614176, 3561614199, 'FR', 'FRA', 'فرنسا'),
(93840, 3561614200, 3561614335, 'GB', 'GBR', 'المملكة المتحدة'),
(93841, 3561614336, 3561614591, 'FR', 'FRA', 'فرنسا'),
(93842, 3561614592, 3561615359, 'GB', 'GBR', 'المملكة المتحدة'),
(93843, 3561615360, 3561615615, 'FR', 'FRA', 'فرنسا'),
(93844, 3561615616, 3561615871, 'IT', 'ITA', 'إيطاليا'),
(93845, 3561615872, 3561616383, 'FR', 'FRA', 'فرنسا'),
(93846, 3561616384, 3561616495, 'GB', 'GBR', 'المملكة المتحدة'),
(93847, 3561616496, 3561616543, 'FR', 'FRA', 'فرنسا'),
(93848, 3561616544, 3561616559, 'GB', 'GBR', 'المملكة المتحدة'),
(93849, 3561616560, 3561616575, 'FR', 'FRA', 'فرنسا'),
(93850, 3561616576, 3561616895, 'GB', 'GBR', 'المملكة المتحدة'),
(93851, 3561616896, 3561616959, 'FR', 'FRA', 'فرنسا'),
(93852, 3561616960, 3561617151, 'GB', 'GBR', 'المملكة المتحدة'),
(93853, 3561617152, 3561617407, 'FR', 'FRA', 'فرنسا'),
(93854, 3561617408, 3561617919, 'CH', 'CHE', 'سويسرا'),
(93855, 3561617920, 3561618175, 'SE', 'SWE', 'السويد'),
(93856, 3561618176, 3561618431, 'IE', 'IRL', 'إيرلندا'),
(93857, 3561618432, 3561618687, 'DK', 'DNK', 'الدنيمارك'),
(93858, 3561618688, 3561618815, 'FR', 'FRA', 'فرنسا'),
(93859, 3561618816, 3561618943, 'PL', 'POL', 'بولندا'),
(93860, 3561618944, 3561636863, 'GB', 'GBR', 'المملكة المتحدة'),
(93861, 3561636864, 3561637119, 'BE', 'BEL', 'بلجيكا'),
(93862, 3561637120, 3561637375, 'ES', 'ESP', 'إسبانيا'),
(93863, 3561637376, 3561637631, 'CH', 'CHE', 'سويسرا'),
(93864, 3561637632, 3561637887, 'IT', 'ITA', 'إيطاليا'),
(93865, 3561637888, 3561638143, 'AT', 'AUT', 'النمسا'),
(93866, 3561638144, 3561638399, 'SE', 'SWE', 'السويد'),
(93867, 3561638400, 3561638655, 'US', 'USA', 'الولايات المتحدة'),
(93868, 3561638656, 3561638911, 'DK', 'DNK', 'الدنيمارك'),
(93869, 3561638912, 3561639167, 'DE', 'DEU', 'ألمانيا'),
(93870, 3561639168, 3561639423, 'GB', 'GBR', 'المملكة المتحدة'),
(93871, 3561639424, 3561639679, 'DE', 'DEU', 'ألمانيا'),
(93872, 3561639680, 3561640575, 'GB', 'GBR', 'المملكة المتحدة'),
(93873, 3561640576, 3561640831, 'FR', 'FRA', 'فرنسا'),
(93874, 3561640832, 3561641983, 'GB', 'GBR', 'المملكة المتحدة'),
(93875, 3561641984, 3561642239, 'DE', 'DEU', 'ألمانيا'),
(93876, 3561642240, 3561652223, 'GB', 'GBR', 'المملكة المتحدة'),
(93877, 3561652224, 3561668607, 'CH', 'CHE', 'سويسرا'),
(93878, 3561668608, 3561679359, 'RU', 'RUS', 'الإتحاد الروسي'),
(93879, 3561679360, 3561679615, 'UA', 'UKR', 'أوكرانيا'),
(93880, 3561679616, 3561684991, 'RU', 'RUS', 'الإتحاد الروسي'),
(93881, 3561684992, 3561693183, 'BG', 'BGR', 'بلغاريا'),
(93882, 3561693184, 3561694487, 'DE', 'DEU', 'ألمانيا'),
(93883, 3561694488, 3561694495, 'CH', 'CHE', 'سويسرا'),
(93884, 3561694496, 3561701375, 'DE', 'DEU', 'ألمانيا'),
(93885, 3561701376, 3561706031, 'SE', 'SWE', 'السويد'),
(93886, 3561706032, 3561706047, 'DK', 'DNK', 'الدنيمارك'),
(93887, 3561706048, 3561709567, 'SE', 'SWE', 'السويد'),
(93888, 3561709568, 3561717759, 'PL', 'POL', 'بولندا'),
(93889, 3561717760, 3561725951, 'RU', 'RUS', 'الإتحاد الروسي'),
(93890, 3561725952, 3561734143, 'ES', 'ESP', 'إسبانيا'),
(93891, 3561734144, 3561742335, 'RU', 'RUS', 'الإتحاد الروسي'),
(93892, 3561750528, 3561758719, 'KZ', 'KAZ', 'كازاخستان'),
(93893, 3561758720, 3561766911, 'PL', 'POL', 'بولندا'),
(93894, 3561766912, 3561775103, 'SA', 'SAU', 'السعودية'),
(93895, 3561775104, 3561783295, 'IL', 'ISR', 'إسرائيل'),
(93896, 3561783296, 3561799679, 'RU', 'RUS', 'الإتحاد الروسي'),
(93897, 3561799680, 3561807871, 'DE', 'DEU', 'ألمانيا'),
(93898, 3561807872, 3561816063, 'BE', 'BEL', 'بلجيكا'),
(93899, 3561816064, 3561824255, 'VA', 'VAT', 'دولة الفاتيكان'),
(93900, 3561824256, 3561832447, 'LI', 'LIE', 'ليختنشتاين'),
(93901, 3561832448, 3561840639, 'IT', 'ITA', 'إيطاليا'),
(93902, 3561840640, 3561848831, 'PL', 'POL', 'بولندا'),
(93903, 3561848832, 3561857023, 'RU', 'RUS', 'الإتحاد الروسي'),
(93904, 3561857024, 3561865215, 'DE', 'DEU', 'ألمانيا'),
(93905, 3561865216, 3561873407, 'QA', 'QAT', 'قطر'),
(93906, 3561873408, 3561881599, 'DE', 'DEU', 'ألمانيا'),
(93907, 3561881600, 3561889791, 'IT', 'ITA', 'إيطاليا'),
(93908, 3561889792, 3561897983, 'FR', 'FRA', 'فرنسا'),
(93909, 3561897984, 3561906175, 'GB', 'GBR', 'المملكة المتحدة'),
(93910, 3561906176, 3561907759, 'DE', 'DEU', 'ألمانيا'),
(93911, 3561907760, 3561907763, 'GB', 'GBR', 'المملكة المتحدة'),
(93912, 3561907764, 3561910207, 'DE', 'DEU', 'ألمانيا'),
(93913, 3561910208, 3561910223, 'GB', 'GBR', 'المملكة المتحدة'),
(93914, 3561910224, 3561914367, 'DE', 'DEU', 'ألمانيا'),
(93915, 3561914368, 3561922559, 'ES', 'ESP', 'إسبانيا'),
(93916, 3561922560, 3561922855, 'NL', 'NLD', 'هولندا'),
(93917, 3561922856, 3561922911, 'GB', 'GBR', 'المملكة المتحدة'),
(93918, 3561922912, 3561922975, 'NL', 'NLD', 'هولندا'),
(93919, 3561922976, 3561922991, 'GB', 'GBR', 'المملكة المتحدة'),
(93920, 3561922992, 3561923015, 'NL', 'NLD', 'هولندا'),
(93921, 3561923016, 3561923063, 'GB', 'GBR', 'المملكة المتحدة'),
(93922, 3561923064, 3561923067, 'NL', 'NLD', 'هولندا'),
(93923, 3561923068, 3561923071, 'GB', 'GBR', 'المملكة المتحدة'),
(93924, 3561923072, 3561923327, 'NL', 'NLD', 'هولندا'),
(93925, 3561923328, 3561923403, 'GB', 'GBR', 'المملكة المتحدة'),
(93926, 3561923404, 3561923407, 'NL', 'NLD', 'هولندا'),
(93927, 3561923408, 3561923455, 'GB', 'GBR', 'المملكة المتحدة'),
(93928, 3561923456, 3561923551, 'NL', 'NLD', 'هولندا'),
(93929, 3561923552, 3561923583, 'GB', 'GBR', 'المملكة المتحدة'),
(93930, 3561923584, 3561923679, 'NL', 'NLD', 'هولندا'),
(93931, 3561923680, 3561923871, 'GB', 'GBR', 'المملكة المتحدة'),
(93932, 3561923872, 3561924191, 'NL', 'NLD', 'هولندا'),
(93933, 3561924192, 3561924199, 'GB', 'GBR', 'المملكة المتحدة'),
(93934, 3561924200, 3561924351, 'NL', 'NLD', 'هولندا'),
(93935, 3561924352, 3561924631, 'GB', 'GBR', 'المملكة المتحدة'),
(93936, 3561924632, 3561924647, 'NL', 'NLD', 'هولندا'),
(93937, 3561924648, 3561924655, 'GB', 'GBR', 'المملكة المتحدة'),
(93938, 3561924656, 3561924671, 'NL', 'NLD', 'هولندا'),
(93939, 3561924672, 3561924679, 'GB', 'GBR', 'المملكة المتحدة'),
(93940, 3561924680, 3561924687, 'NL', 'NLD', 'هولندا'),
(93941, 3561924688, 3561924703, 'GB', 'GBR', 'المملكة المتحدة'),
(93942, 3561924704, 3561924719, 'NL', 'NLD', 'هولندا'),
(93943, 3561924720, 3561924911, 'GB', 'GBR', 'المملكة المتحدة'),
(93944, 3561924912, 3561924959, 'NL', 'NLD', 'هولندا'),
(93945, 3561924960, 3561925007, 'GB', 'GBR', 'المملكة المتحدة'),
(93946, 3561925008, 3561925039, 'NL', 'NLD', 'هولندا'),
(93947, 3561925040, 3561925087, 'GB', 'GBR', 'المملكة المتحدة'),
(93948, 3561925088, 3561925119, 'NL', 'NLD', 'هولندا'),
(93949, 3561925120, 3561926943, 'GB', 'GBR', 'المملكة المتحدة'),
(93950, 3561926944, 3561926975, 'NL', 'NLD', 'هولندا'),
(93951, 3561926976, 3561927167, 'GB', 'GBR', 'المملكة المتحدة'),
(93952, 3561927168, 3561927423, 'NL', 'NLD', 'هولندا'),
(93953, 3561927424, 3561927551, 'GB', 'GBR', 'المملكة المتحدة'),
(93954, 3561927552, 3561927647, 'NL', 'NLD', 'هولندا'),
(93955, 3561927648, 3561927663, 'GB', 'GBR', 'المملكة المتحدة'),
(93956, 3561927664, 3561927679, 'NL', 'NLD', 'هولندا'),
(93957, 3561927680, 3561927823, 'GB', 'GBR', 'المملكة المتحدة'),
(93958, 3561927824, 3561927839, 'NL', 'NLD', 'هولندا'),
(93959, 3561927840, 3561928191, 'GB', 'GBR', 'المملكة المتحدة'),
(93960, 3561928192, 3561929727, 'NL', 'NLD', 'هولندا'),
(93961, 3561929728, 3561929743, 'GB', 'GBR', 'المملكة المتحدة'),
(93962, 3561929744, 3561929791, 'NL', 'NLD', 'هولندا'),
(93963, 3561929792, 3561929879, 'GB', 'GBR', 'المملكة المتحدة'),
(93964, 3561929880, 3561929919, 'NL', 'NLD', 'هولندا'),
(93965, 3561929920, 3561929967, 'GB', 'GBR', 'المملكة المتحدة'),
(93966, 3561929968, 3561930335, 'NL', 'NLD', 'هولندا'),
(93967, 3561930336, 3561930503, 'GB', 'GBR', 'المملكة المتحدة'),
(93968, 3561930504, 3561930511, 'NL', 'NLD', 'هولندا'),
(93969, 3561930512, 3561930751, 'GB', 'GBR', 'المملكة المتحدة'),
(93970, 3561938944, 3561940991, 'IE', 'IRL', 'إيرلندا'),
(93971, 3561940992, 3561942015, 'GB', 'GBR', 'المملكة المتحدة'),
(93972, 3561942016, 3561947135, 'IE', 'IRL', 'إيرلندا'),
(93973, 3561947136, 3561963143, 'DE', 'DEU', 'ألمانيا'),
(93974, 3561963144, 3561963151, 'AU', 'AUS', 'أستراليا'),
(93975, 3561963152, 3561963519, 'DE', 'DEU', 'ألمانيا'),
(93976, 3561963520, 3561971711, 'BE', 'BEL', 'بلجيكا'),
(93977, 3561971712, 3561975807, 'TR', 'TUR', 'تركيا'),
(93978, 3561979904, 3561988095, 'ES', 'ESP', 'إسبانيا'),
(93979, 3561988096, 3562004479, 'DE', 'DEU', 'ألمانيا'),
(93980, 3562004480, 3562012479, 'NL', 'NLD', 'هولندا'),
(93981, 3562012480, 3562012483, 'KN', 'KNA', 'سانت كيتس ونيفيس'),
(93982, 3562012484, 3562012671, 'NL', 'NLD', 'هولندا'),
(93983, 3562012672, 3562020863, 'IR', 'IRN', 'إيران');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(93984, 3562020864, 3562029055, 'UA', 'UKR', 'أوكرانيا'),
(93985, 3562029056, 3562037247, 'CZ', 'CZE', 'التشيك'),
(93986, 3562037248, 3562045439, 'CH', 'CHE', 'سويسرا'),
(93987, 3562045440, 3562056711, 'ES', 'ESP', 'إسبانيا'),
(93988, 3562056712, 3562056719, 'NL', 'NLD', 'هولندا'),
(93989, 3562056720, 3562056911, 'ES', 'ESP', 'إسبانيا'),
(93990, 3562056912, 3562056927, 'FR', 'FRA', 'فرنسا'),
(93991, 3562056928, 3562057215, 'ES', 'ESP', 'إسبانيا'),
(93992, 3562057216, 3562057247, 'NL', 'NLD', 'هولندا'),
(93993, 3562057248, 3562057263, 'BE', 'BEL', 'بلجيكا'),
(93994, 3562057264, 3562057471, 'ES', 'ESP', 'إسبانيا'),
(93995, 3562057472, 3562057727, 'DE', 'DEU', 'ألمانيا'),
(93996, 3562057728, 3562057975, 'ES', 'ESP', 'إسبانيا'),
(93997, 3562057976, 3562057983, 'FR', 'FRA', 'فرنسا'),
(93998, 3562057984, 3562058303, 'ES', 'ESP', 'إسبانيا'),
(93999, 3562058304, 3562058367, 'IT', 'ITA', 'إيطاليا'),
(94000, 3562058368, 3562059327, 'ES', 'ESP', 'إسبانيا'),
(94001, 3562059328, 3562059335, 'CH', 'CHE', 'سويسرا'),
(94002, 3562059336, 3562059391, 'ES', 'ESP', 'إسبانيا'),
(94003, 3562059392, 3562059775, 'CH', 'CHE', 'سويسرا'),
(94004, 3562059776, 3562061823, 'ES', 'ESP', 'إسبانيا'),
(94005, 3562061824, 3562070015, 'IT', 'ITA', 'إيطاليا'),
(94006, 3562070016, 3562078207, 'DE', 'DEU', 'ألمانيا'),
(94007, 3562078208, 3562086399, 'SK', 'SVK', 'سلوفاكيا'),
(94008, 3562086400, 3562087423, 'SE', 'SWE', 'السويد'),
(94009, 3562087424, 3562088447, 'GB', 'GBR', 'المملكة المتحدة'),
(94010, 3562088448, 3562094591, 'SE', 'SWE', 'السويد'),
(94011, 3562094592, 3562094975, 'GB', 'GBR', 'المملكة المتحدة'),
(94012, 3562094976, 3562095775, 'FR', 'FRA', 'فرنسا'),
(94013, 3562095776, 3562095807, 'GB', 'GBR', 'المملكة المتحدة'),
(94014, 3562095808, 3562095887, 'FR', 'FRA', 'فرنسا'),
(94015, 3562095888, 3562095903, 'GB', 'GBR', 'المملكة المتحدة'),
(94016, 3562095904, 3562096383, 'FR', 'FRA', 'فرنسا'),
(94017, 3562096384, 3562096639, 'GB', 'GBR', 'المملكة المتحدة'),
(94018, 3562096640, 3562096767, 'FR', 'FRA', 'فرنسا'),
(94019, 3562096768, 3562096927, 'GB', 'GBR', 'المملكة المتحدة'),
(94020, 3562096928, 3562097055, 'FR', 'FRA', 'فرنسا'),
(94021, 3562097056, 3562097151, 'GB', 'GBR', 'المملكة المتحدة'),
(94022, 3562097152, 3562097687, 'FR', 'FRA', 'فرنسا'),
(94023, 3562097688, 3562097695, 'GB', 'GBR', 'المملكة المتحدة'),
(94024, 3562097696, 3562097727, 'FR', 'FRA', 'فرنسا'),
(94025, 3562097728, 3562097791, 'GB', 'GBR', 'المملكة المتحدة'),
(94026, 3562097792, 3562097919, 'FR', 'FRA', 'فرنسا'),
(94027, 3562097920, 3562098175, 'GB', 'GBR', 'المملكة المتحدة'),
(94028, 3562098176, 3562098207, 'FR', 'FRA', 'فرنسا'),
(94029, 3562098208, 3562098223, 'GB', 'GBR', 'المملكة المتحدة'),
(94030, 3562098224, 3562098271, 'FR', 'FRA', 'فرنسا'),
(94031, 3562098272, 3562098367, 'GB', 'GBR', 'المملكة المتحدة'),
(94032, 3562098368, 3562098375, 'FR', 'FRA', 'فرنسا'),
(94033, 3562098376, 3562098383, 'GB', 'GBR', 'المملكة المتحدة'),
(94034, 3562098384, 3562098431, 'FR', 'FRA', 'فرنسا'),
(94035, 3562098432, 3562098687, 'GB', 'GBR', 'المملكة المتحدة'),
(94036, 3562098688, 3562098879, 'FR', 'FRA', 'فرنسا'),
(94037, 3562098880, 3562098895, 'BE', 'BEL', 'بلجيكا'),
(94038, 3562098896, 3562098911, 'FR', 'FRA', 'فرنسا'),
(94039, 3562098912, 3562099199, 'GB', 'GBR', 'المملكة المتحدة'),
(94040, 3562099200, 3562099359, 'FR', 'FRA', 'فرنسا'),
(94041, 3562099360, 3562099391, 'GB', 'GBR', 'المملكة المتحدة'),
(94042, 3562099392, 3562099423, 'FR', 'FRA', 'فرنسا'),
(94043, 3562099424, 3562099519, 'GB', 'GBR', 'المملكة المتحدة'),
(94044, 3562099520, 3562099583, 'FR', 'FRA', 'فرنسا'),
(94045, 3562099584, 3562099615, 'GB', 'GBR', 'المملكة المتحدة'),
(94046, 3562099616, 3562099647, 'FR', 'FRA', 'فرنسا'),
(94047, 3562099648, 3562099903, 'GB', 'GBR', 'المملكة المتحدة'),
(94048, 3562099904, 3562099935, 'FR', 'FRA', 'فرنسا'),
(94049, 3562099936, 3562100223, 'GB', 'GBR', 'المملكة المتحدة'),
(94050, 3562100224, 3562100351, 'FR', 'FRA', 'فرنسا'),
(94051, 3562100352, 3562100415, 'GB', 'GBR', 'المملكة المتحدة'),
(94052, 3562100416, 3562100479, 'FR', 'FRA', 'فرنسا'),
(94053, 3562100480, 3562100543, 'GB', 'GBR', 'المملكة المتحدة'),
(94054, 3562100544, 3562100575, 'FR', 'FRA', 'فرنسا'),
(94055, 3562100576, 3562100703, 'GB', 'GBR', 'المملكة المتحدة'),
(94056, 3562100704, 3562100735, 'FR', 'FRA', 'فرنسا'),
(94057, 3562100736, 3562100863, 'GB', 'GBR', 'المملكة المتحدة'),
(94058, 3562100864, 3562101215, 'FR', 'FRA', 'فرنسا'),
(94059, 3562101216, 3562101375, 'GB', 'GBR', 'المملكة المتحدة'),
(94060, 3562101376, 3562101439, 'FR', 'FRA', 'فرنسا'),
(94061, 3562101440, 3562101471, 'GB', 'GBR', 'المملكة المتحدة'),
(94062, 3562101472, 3562101535, 'FR', 'FRA', 'فرنسا'),
(94063, 3562101536, 3562101631, 'GB', 'GBR', 'المملكة المتحدة'),
(94064, 3562101632, 3562101647, 'FR', 'FRA', 'فرنسا'),
(94065, 3562101648, 3562101663, 'GB', 'GBR', 'المملكة المتحدة'),
(94066, 3562101664, 3562101695, 'FR', 'FRA', 'فرنسا'),
(94067, 3562101696, 3562101759, 'GB', 'GBR', 'المملكة المتحدة'),
(94068, 3562101760, 3562101887, 'FR', 'FRA', 'فرنسا'),
(94069, 3562101888, 3562101951, 'GB', 'GBR', 'المملكة المتحدة'),
(94070, 3562101952, 3562101983, 'FR', 'FRA', 'فرنسا'),
(94071, 3562101984, 3562102015, 'GB', 'GBR', 'المملكة المتحدة'),
(94072, 3562102016, 3562102111, 'FR', 'FRA', 'فرنسا'),
(94073, 3562102112, 3562102143, 'GB', 'GBR', 'المملكة المتحدة'),
(94074, 3562102144, 3562102335, 'FR', 'FRA', 'فرنسا'),
(94075, 3562102336, 3562102367, 'GB', 'GBR', 'المملكة المتحدة'),
(94076, 3562102368, 3562102415, 'FR', 'FRA', 'فرنسا'),
(94077, 3562102416, 3562102431, 'NL', 'NLD', 'هولندا'),
(94078, 3562102432, 3562102463, 'DE', 'DEU', 'ألمانيا'),
(94079, 3562102464, 3562102655, 'FR', 'FRA', 'فرنسا'),
(94080, 3562102656, 3562102719, 'GB', 'GBR', 'المملكة المتحدة'),
(94081, 3562102720, 3562102735, 'FR', 'FRA', 'فرنسا'),
(94082, 3562102736, 3562102751, 'GB', 'GBR', 'المملكة المتحدة'),
(94083, 3562102752, 3562102783, 'FR', 'FRA', 'فرنسا'),
(94084, 3562102784, 3562103039, 'GB', 'GBR', 'المملكة المتحدة'),
(94085, 3562103040, 3562103295, 'FR', 'FRA', 'فرنسا'),
(94086, 3562103296, 3562103423, 'GB', 'GBR', 'المملكة المتحدة'),
(94087, 3562103424, 3562103647, 'FR', 'FRA', 'فرنسا'),
(94088, 3562103648, 3562103711, 'GB', 'GBR', 'المملكة المتحدة'),
(94089, 3562103712, 3562103743, 'FR', 'FRA', 'فرنسا'),
(94090, 3562103744, 3562103807, 'GB', 'GBR', 'المملكة المتحدة'),
(94091, 3562103808, 3562103903, 'FR', 'FRA', 'فرنسا'),
(94092, 3562103904, 3562103967, 'GB', 'GBR', 'المملكة المتحدة'),
(94093, 3562103968, 3562103999, 'FR', 'FRA', 'فرنسا'),
(94094, 3562104000, 3562104351, 'GB', 'GBR', 'المملكة المتحدة'),
(94095, 3562104352, 3562104383, 'FR', 'FRA', 'فرنسا'),
(94096, 3562104384, 3562104447, 'GB', 'GBR', 'المملكة المتحدة'),
(94097, 3562104448, 3562104511, 'FR', 'FRA', 'فرنسا'),
(94098, 3562104512, 3562104831, 'GB', 'GBR', 'المملكة المتحدة'),
(94099, 3562104832, 3562104927, 'FR', 'FRA', 'فرنسا'),
(94100, 3562104928, 3562104959, 'GB', 'GBR', 'المملكة المتحدة'),
(94101, 3562104960, 3562105007, 'FR', 'FRA', 'فرنسا'),
(94102, 3562105008, 3562105119, 'GB', 'GBR', 'المملكة المتحدة'),
(94103, 3562105120, 3562105151, 'FR', 'FRA', 'فرنسا'),
(94104, 3562105152, 3562105167, 'GB', 'GBR', 'المملكة المتحدة'),
(94105, 3562105168, 3562105199, 'FR', 'FRA', 'فرنسا'),
(94106, 3562105200, 3562105247, 'GB', 'GBR', 'المملكة المتحدة'),
(94107, 3562105248, 3562105343, 'FR', 'FRA', 'فرنسا'),
(94108, 3562105344, 3562105471, 'GB', 'GBR', 'المملكة المتحدة'),
(94109, 3562105472, 3562105487, 'FR', 'FRA', 'فرنسا'),
(94110, 3562105488, 3562105503, 'GB', 'GBR', 'المملكة المتحدة'),
(94111, 3562105504, 3562105535, 'DE', 'DEU', 'ألمانيا'),
(94112, 3562105536, 3562105567, 'FR', 'FRA', 'فرنسا'),
(94113, 3562105568, 3562105599, 'GB', 'GBR', 'المملكة المتحدة'),
(94114, 3562105600, 3562105855, 'FR', 'FRA', 'فرنسا'),
(94115, 3562105856, 3562106143, 'GB', 'GBR', 'المملكة المتحدة'),
(94116, 3562106144, 3562106159, 'FR', 'FRA', 'فرنسا'),
(94117, 3562106160, 3562106191, 'GB', 'GBR', 'المملكة المتحدة'),
(94118, 3562106192, 3562106271, 'FR', 'FRA', 'فرنسا'),
(94119, 3562106272, 3562106367, 'GB', 'GBR', 'المملكة المتحدة'),
(94120, 3562106368, 3562106495, 'FR', 'FRA', 'فرنسا'),
(94121, 3562106496, 3562106527, 'GB', 'GBR', 'المملكة المتحدة'),
(94122, 3562106528, 3562106559, 'FR', 'FRA', 'فرنسا'),
(94123, 3562106560, 3562106623, 'GB', 'GBR', 'المملكة المتحدة'),
(94124, 3562106624, 3562106911, 'FR', 'FRA', 'فرنسا'),
(94125, 3562106912, 3562106927, 'GB', 'GBR', 'المملكة المتحدة'),
(94126, 3562106928, 3562106959, 'FR', 'FRA', 'فرنسا'),
(94127, 3562106960, 3562107007, 'GB', 'GBR', 'المملكة المتحدة'),
(94128, 3562107008, 3562107103, 'FR', 'FRA', 'فرنسا'),
(94129, 3562107104, 3562107119, 'GB', 'GBR', 'المملكة المتحدة'),
(94130, 3562107120, 3562107135, 'FR', 'FRA', 'فرنسا'),
(94131, 3562107136, 3562107231, 'GB', 'GBR', 'المملكة المتحدة'),
(94132, 3562107232, 3562107263, 'FR', 'FRA', 'فرنسا'),
(94133, 3562107264, 3562107327, 'GB', 'GBR', 'المملكة المتحدة'),
(94134, 3562107328, 3562107391, 'FR', 'FRA', 'فرنسا'),
(94135, 3562107392, 3562107503, 'GB', 'GBR', 'المملكة المتحدة'),
(94136, 3562107504, 3562107583, 'FR', 'FRA', 'فرنسا'),
(94137, 3562107584, 3562107647, 'GB', 'GBR', 'المملكة المتحدة'),
(94138, 3562107648, 3562107711, 'FR', 'FRA', 'فرنسا'),
(94139, 3562107712, 3562107775, 'GB', 'GBR', 'المملكة المتحدة'),
(94140, 3562107776, 3562107807, 'FR', 'FRA', 'فرنسا'),
(94141, 3562107808, 3562107887, 'GB', 'GBR', 'المملكة المتحدة'),
(94142, 3562107888, 3562108063, 'FR', 'FRA', 'فرنسا'),
(94143, 3562108064, 3562108159, 'GB', 'GBR', 'المملكة المتحدة'),
(94144, 3562108160, 3562108415, 'FR', 'FRA', 'فرنسا'),
(94145, 3562108416, 3562108959, 'GB', 'GBR', 'المملكة المتحدة'),
(94146, 3562108960, 3562108991, 'FR', 'FRA', 'فرنسا'),
(94147, 3562108992, 3562109119, 'GB', 'GBR', 'المملكة المتحدة'),
(94148, 3562109120, 3562109183, 'FR', 'FRA', 'فرنسا'),
(94149, 3562109184, 3562109567, 'GB', 'GBR', 'المملكة المتحدة'),
(94150, 3562109568, 3562109583, 'FR', 'FRA', 'فرنسا'),
(94151, 3562109584, 3562109759, 'GB', 'GBR', 'المملكة المتحدة'),
(94152, 3562109760, 3562109791, 'FR', 'FRA', 'فرنسا'),
(94153, 3562109792, 3562109823, 'GB', 'GBR', 'المملكة المتحدة'),
(94154, 3562109824, 3562110207, 'FR', 'FRA', 'فرنسا'),
(94155, 3562110208, 3562110399, 'GB', 'GBR', 'المملكة المتحدة'),
(94156, 3562110400, 3562110719, 'FR', 'FRA', 'فرنسا'),
(94157, 3562110720, 3562110943, 'GB', 'GBR', 'المملكة المتحدة'),
(94158, 3562110944, 3562110959, 'FR', 'FRA', 'فرنسا'),
(94159, 3562110960, 3562110967, 'GB', 'GBR', 'المملكة المتحدة'),
(94160, 3562110968, 3562110975, 'FR', 'FRA', 'فرنسا'),
(94161, 3562110976, 3562143743, 'ES', 'ESP', 'إسبانيا'),
(94162, 3562143744, 3562151935, 'GB', 'GBR', 'المملكة المتحدة'),
(94163, 3562151936, 3562160127, 'DE', 'DEU', 'ألمانيا'),
(94164, 3562160128, 3562161151, 'GB', 'GBR', 'المملكة المتحدة'),
(94165, 3562161152, 3562161183, 'NL', 'NLD', 'هولندا'),
(94166, 3562161184, 3562169343, 'GB', 'GBR', 'المملكة المتحدة'),
(94167, 3562169344, 3562170367, 'CH', 'CHE', 'سويسرا'),
(94168, 3562170368, 3562172415, 'IE', 'IRL', 'إيرلندا'),
(94169, 3562172416, 3562173951, 'CH', 'CHE', 'سويسرا'),
(94170, 3562173952, 3562174463, 'GB', 'GBR', 'المملكة المتحدة'),
(94171, 3562174464, 3562176511, 'CH', 'CHE', 'سويسرا'),
(94172, 3562176512, 3562184703, 'FR', 'FRA', 'فرنسا'),
(94173, 3562184704, 3562192895, 'DE', 'DEU', 'ألمانيا'),
(94174, 3562192896, 3562201087, 'UA', 'UKR', 'أوكرانيا'),
(94175, 3562201088, 3562209279, 'DE', 'DEU', 'ألمانيا'),
(94176, 3562209280, 3562217471, 'RU', 'RUS', 'الإتحاد الروسي'),
(94177, 3562217472, 3562220287, 'DE', 'DEU', 'ألمانيا'),
(94178, 3562220288, 3562220799, 'CH', 'CHE', 'سويسرا'),
(94179, 3562220800, 3562225663, 'DE', 'DEU', 'ألمانيا'),
(94180, 3562225664, 3562233855, 'NL', 'NLD', 'هولندا'),
(94181, 3562233856, 3562242047, 'FI', 'FIN', 'فنلندا'),
(94182, 3562242048, 3562258431, 'FR', 'FRA', 'فرنسا'),
(94183, 3562258432, 3562263975, 'NL', 'NLD', 'هولندا'),
(94184, 3562263976, 3562263983, 'BE', 'BEL', 'بلجيكا'),
(94185, 3562263984, 3562283007, 'NL', 'NLD', 'هولندا'),
(94186, 3562283008, 3562291199, 'IT', 'ITA', 'إيطاليا'),
(94187, 3562291200, 3562307583, 'GB', 'GBR', 'المملكة المتحدة'),
(94188, 3562307584, 3562315775, 'NL', 'NLD', 'هولندا'),
(94189, 3562315776, 3562323967, 'GB', 'GBR', 'المملكة المتحدة'),
(94190, 3562323968, 3562340351, 'DE', 'DEU', 'ألمانيا'),
(94191, 3562340352, 3562348543, 'GB', 'GBR', 'المملكة المتحدة'),
(94192, 3562348544, 3562356735, 'ES', 'ESP', 'إسبانيا'),
(94193, 3562356736, 3562364927, 'SE', 'SWE', 'السويد'),
(94194, 3562364928, 3562373119, 'PL', 'POL', 'بولندا'),
(94195, 3562373120, 3562381311, 'FR', 'FRA', 'فرنسا'),
(94196, 3562381312, 3562389503, 'IT', 'ITA', 'إيطاليا'),
(94197, 3562397696, 3562405887, 'GB', 'GBR', 'المملكة المتحدة'),
(94198, 3562405888, 3562414079, 'FI', 'FIN', 'فنلندا'),
(94199, 3562414080, 3562422271, 'DE', 'DEU', 'ألمانيا'),
(94200, 3562430464, 3562438655, 'UA', 'UKR', 'أوكرانيا'),
(94201, 3562438656, 3562463231, 'DE', 'DEU', 'ألمانيا'),
(94202, 3562463232, 3562471423, 'UA', 'UKR', 'أوكرانيا'),
(94203, 3562471424, 3562479615, 'PL', 'POL', 'بولندا'),
(94204, 3562479616, 3562487807, 'DE', 'DEU', 'ألمانيا'),
(94205, 3562487808, 3562495999, 'GB', 'GBR', 'المملكة المتحدة'),
(94206, 3562496000, 3562504191, 'BE', 'BEL', 'بلجيكا'),
(94207, 3562504192, 3562512383, 'DE', 'DEU', 'ألمانيا'),
(94208, 3562512384, 3562520575, 'UA', 'UKR', 'أوكرانيا'),
(94209, 3562520576, 3562528767, 'ES', 'ESP', 'إسبانيا'),
(94210, 3562528768, 3562536959, 'PL', 'POL', 'بولندا'),
(94211, 3562536960, 3562545151, 'AT', 'AUT', 'النمسا'),
(94212, 3562545152, 3562553343, 'GB', 'GBR', 'المملكة المتحدة'),
(94213, 3562553344, 3562561535, 'DK', 'DNK', 'الدنيمارك'),
(94214, 3562569728, 3562572143, 'DE', 'DEU', 'ألمانيا'),
(94215, 3562572144, 3562572159, 'LU', 'LUX', 'لوكسيمبورغ'),
(94216, 3562572160, 3562572223, 'DE', 'DEU', 'ألمانيا'),
(94217, 3562572224, 3562572239, 'US', 'USA', 'الولايات المتحدة'),
(94218, 3562572240, 3562572543, 'DE', 'DEU', 'ألمانيا'),
(94219, 3562572544, 3562572799, 'LU', 'LUX', 'لوكسيمبورغ'),
(94220, 3562572800, 3562577919, 'DE', 'DEU', 'ألمانيا'),
(94221, 3562577920, 3562586111, 'AT', 'AUT', 'النمسا'),
(94222, 3562586112, 3562594303, 'DE', 'DEU', 'ألمانيا'),
(94223, 3562594304, 3562595423, 'BE', 'BEL', 'بلجيكا'),
(94224, 3562595424, 3562595455, 'LU', 'LUX', 'لوكسيمبورغ'),
(94225, 3562595456, 3562598207, 'BE', 'BEL', 'بلجيكا'),
(94226, 3562598208, 3562598223, 'LU', 'LUX', 'لوكسيمبورغ'),
(94227, 3562598224, 3562602495, 'BE', 'BEL', 'بلجيكا'),
(94228, 3562602496, 3562610687, 'ES', 'ESP', 'إسبانيا'),
(94229, 3562610688, 3562618879, 'NO', 'NOR', 'النرويج'),
(94230, 3562618880, 3562627071, 'GB', 'GBR', 'المملكة المتحدة'),
(94231, 3562627072, 3562643455, 'DE', 'DEU', 'ألمانيا'),
(94232, 3562643456, 3562651647, 'AT', 'AUT', 'النمسا'),
(94233, 3562651648, 3562659839, 'DE', 'DEU', 'ألمانيا'),
(94234, 3562659840, 3562668031, 'SK', 'SVK', 'سلوفاكيا'),
(94235, 3562668032, 3562676223, 'IT', 'ITA', 'إيطاليا'),
(94236, 3562676224, 3562684415, 'GB', 'GBR', 'المملكة المتحدة'),
(94237, 3562684416, 3562692607, 'FI', 'FIN', 'فنلندا'),
(94238, 3562692608, 3562695375, 'UA', 'UKR', 'أوكرانيا'),
(94239, 3562695376, 3562695379, 'CZ', 'CZE', 'التشيك'),
(94240, 3562695380, 3562700799, 'UA', 'UKR', 'أوكرانيا'),
(94241, 3562700800, 3562708991, 'DE', 'DEU', 'ألمانيا'),
(94242, 3562708992, 3562717183, 'UA', 'UKR', 'أوكرانيا'),
(94243, 3562717184, 3562725375, 'CH', 'CHE', 'سويسرا'),
(94244, 3562725376, 3562733567, 'CZ', 'CZE', 'التشيك'),
(94245, 3562733568, 3562741759, 'PL', 'POL', 'بولندا'),
(94246, 3562741760, 3562758143, 'IT', 'ITA', 'إيطاليا'),
(94247, 3562758144, 3562766335, 'HR', 'HRV', 'كرواتيا'),
(94248, 3562766336, 3562774527, 'SE', 'SWE', 'السويد'),
(94249, 3562774528, 3562782719, 'BG', 'BGR', 'بلغاريا'),
(94250, 3562782720, 3562790911, 'RU', 'RUS', 'الإتحاد الروسي'),
(94251, 3562790912, 3562799103, 'DE', 'DEU', 'ألمانيا'),
(94252, 3562799104, 3562803471, 'HU', 'HUN', 'هنغاريا'),
(94253, 3562803472, 3562803479, 'UA', 'UKR', 'أوكرانيا'),
(94254, 3562803480, 3562807295, 'HU', 'HUN', 'هنغاريا'),
(94255, 3562807296, 3562815487, 'ES', 'ESP', 'إسبانيا'),
(94256, 3562815488, 3562823679, 'NL', 'NLD', 'هولندا'),
(94257, 3562823680, 3562848255, 'RU', 'RUS', 'الإتحاد الروسي'),
(94258, 3562848256, 3562856447, 'HR', 'HRV', 'كرواتيا'),
(94259, 3562856448, 3562864639, 'UA', 'UKR', 'أوكرانيا'),
(94260, 3562864640, 3562872831, 'DE', 'DEU', 'ألمانيا'),
(94261, 3562872832, 3562881023, 'DK', 'DNK', 'الدنيمارك'),
(94262, 3562881024, 3562889215, 'GB', 'GBR', 'المملكة المتحدة'),
(94263, 3562889216, 3562897407, 'LV', 'LVA', 'لاتفيا'),
(94264, 3562897408, 3562905599, 'RO', 'ROM', 'رومانيا'),
(94265, 3562905600, 3562921983, 'SA', 'SAU', 'السعودية'),
(94266, 3562921984, 3562930175, 'SI', 'SVN', 'سلوفينيا'),
(94267, 3562930176, 3562938367, 'RU', 'RUS', 'الإتحاد الروسي'),
(94268, 3562938368, 3562946559, 'CH', 'CHE', 'سويسرا'),
(94269, 3562946560, 3562954751, 'FI', 'FIN', 'فنلندا'),
(94270, 3562954752, 3562962943, 'RU', 'RUS', 'الإتحاد الروسي'),
(94271, 3562962944, 3562971135, 'IT', 'ITA', 'إيطاليا'),
(94272, 3562971136, 3562987519, 'FR', 'FRA', 'فرنسا'),
(94273, 3562987520, 3562995711, 'DE', 'DEU', 'ألمانيا'),
(94274, 3562995712, 3563003903, 'AT', 'AUT', 'النمسا'),
(94275, 3563003904, 3563005183, 'DE', 'DEU', 'ألمانيا'),
(94276, 3563005184, 3563005311, 'KZ', 'KAZ', 'كازاخستان'),
(94277, 3563005312, 3563005439, 'DE', 'DEU', 'ألمانيا'),
(94278, 3563005440, 3563005695, 'TR', 'TUR', 'تركيا'),
(94279, 3563005696, 3563005951, 'DE', 'DEU', 'ألمانيا'),
(94280, 3563005952, 3563006463, 'TR', 'TUR', 'تركيا'),
(94281, 3563006464, 3563006591, 'DE', 'DEU', 'ألمانيا'),
(94282, 3563006592, 3563006719, 'CA', 'CAN', 'كندا'),
(94283, 3563006720, 3563006729, 'DE', 'DEU', 'ألمانيا'),
(94284, 3563006730, 3563006847, 'CN', 'CHN', 'الصين'),
(94285, 3563006848, 3563006975, 'CA', 'CAN', 'كندا'),
(94286, 3563006976, 3563007487, 'DE', 'DEU', 'ألمانيا'),
(94287, 3563007488, 3563007999, 'TR', 'TUR', 'تركيا'),
(94288, 3563008000, 3563008255, 'DE', 'DEU', 'ألمانيا'),
(94289, 3563008256, 3563008511, 'PL', 'POL', 'بولندا'),
(94290, 3563008512, 3563009279, 'DE', 'DEU', 'ألمانيا'),
(94291, 3563009280, 3563009535, 'LT', 'LTU', 'ليتوانيا'),
(94292, 3563009536, 3563009791, 'BY', 'BLR', 'روسيا البيضاء'),
(94293, 3563009792, 3563010047, 'HK', 'HKG', 'هونغ كونغ'),
(94294, 3563010048, 3563010063, 'DE', 'DEU', 'ألمانيا'),
(94295, 3563010064, 3563010079, 'KZ', 'KAZ', 'كازاخستان'),
(94296, 3563010080, 3563010303, 'DE', 'DEU', 'ألمانيا'),
(94297, 3563010304, 3563010559, 'NL', 'NLD', 'هولندا'),
(94298, 3563010560, 3563010815, 'BY', 'BLR', 'روسيا البيضاء'),
(94299, 3563010816, 3563011071, 'PL', 'POL', 'بولندا'),
(94300, 3563011072, 3563011583, 'DE', 'DEU', 'ألمانيا'),
(94301, 3563011584, 3563011839, 'ES', 'ESP', 'إسبانيا'),
(94302, 3563011840, 3563012095, 'BY', 'BLR', 'روسيا البيضاء'),
(94303, 3563012096, 3563020287, 'FR', 'FRA', 'فرنسا'),
(94304, 3563020288, 3563028479, 'DE', 'DEU', 'ألمانيا'),
(94305, 3563028480, 3563036671, 'IR', 'IRN', 'إيران'),
(94306, 3563036672, 3563044863, 'BG', 'BGR', 'بلغاريا'),
(94307, 3563044864, 3563053055, 'ES', 'ESP', 'إسبانيا'),
(94308, 3563053056, 3563053503, 'GB', 'GBR', 'المملكة المتحدة'),
(94309, 3563053504, 3563053527, 'US', 'USA', 'الولايات المتحدة'),
(94310, 3563053528, 3563061247, 'GB', 'GBR', 'المملكة المتحدة'),
(94311, 3563069440, 3563077631, 'HU', 'HUN', 'هنغاريا'),
(94312, 3563077632, 3563085823, 'FR', 'FRA', 'فرنسا'),
(94313, 3563085824, 3563094015, 'RU', 'RUS', 'الإتحاد الروسي'),
(94314, 3563094016, 3563096255, 'DE', 'DEU', 'ألمانيا'),
(94315, 3563096256, 3563096287, 'GB', 'GBR', 'المملكة المتحدة'),
(94316, 3563096288, 3563097087, 'DE', 'DEU', 'ألمانيا'),
(94317, 3563097088, 3563097119, 'GB', 'GBR', 'المملكة المتحدة'),
(94318, 3563097120, 3563097151, 'DE', 'DEU', 'ألمانيا'),
(94319, 3563097152, 3563097183, 'GB', 'GBR', 'المملكة المتحدة'),
(94320, 3563097184, 3563097215, 'DE', 'DEU', 'ألمانيا'),
(94321, 3563097216, 3563097247, 'GB', 'GBR', 'المملكة المتحدة'),
(94322, 3563097248, 3563097311, 'DE', 'DEU', 'ألمانيا'),
(94323, 3563097312, 3563097343, 'GB', 'GBR', 'المملكة المتحدة'),
(94324, 3563097344, 3563102207, 'DE', 'DEU', 'ألمانيا'),
(94325, 3563102208, 3563110399, 'CZ', 'CZE', 'التشيك'),
(94326, 3563110400, 3563118591, 'RU', 'RUS', 'الإتحاد الروسي'),
(94327, 3563118592, 3563126783, 'DE', 'DEU', 'ألمانيا'),
(94328, 3563126784, 3563134975, 'KG', 'KGZ', 'قيرغيزستان'),
(94329, 3563134976, 3563143167, 'IT', 'ITA', 'إيطاليا'),
(94330, 3563143168, 3563151359, 'GB', 'GBR', 'المملكة المتحدة'),
(94331, 3563151360, 3563159551, 'DE', 'DEU', 'ألمانيا'),
(94332, 3563159552, 3563163647, 'DK', 'DNK', 'الدنيمارك'),
(94333, 3563163648, 3563164159, 'SE', 'SWE', 'السويد'),
(94334, 3563164160, 3563167743, 'DK', 'DNK', 'الدنيمارك'),
(94335, 3563167744, 3563175935, 'ES', 'ESP', 'إسبانيا'),
(94336, 3563175936, 3563192319, 'DK', 'DNK', 'الدنيمارك'),
(94337, 3563192320, 3563200511, 'TR', 'TUR', 'تركيا'),
(94338, 3563200512, 3563208703, 'CH', 'CHE', 'سويسرا'),
(94339, 3563208704, 3563225087, 'DK', 'DNK', 'الدنيمارك'),
(94340, 3563225088, 3563233279, 'LB', 'LBN', 'لبنان'),
(94341, 3563233280, 3563241471, 'BY', 'BLR', 'روسيا البيضاء'),
(94342, 3563241472, 3563257855, 'TR', 'TUR', 'تركيا'),
(94343, 3563257856, 3563290623, 'FR', 'FRA', 'فرنسا'),
(94344, 3563290624, 3563315199, 'DE', 'DEU', 'ألمانيا'),
(94345, 3563315200, 3563323391, 'DK', 'DNK', 'الدنيمارك'),
(94346, 3563323392, 3563329791, 'GB', 'GBR', 'المملكة المتحدة'),
(94347, 3563331584, 3563339775, 'DE', 'DEU', 'ألمانيا'),
(94348, 3563347968, 3563356159, 'GB', 'GBR', 'المملكة المتحدة'),
(94349, 3563356160, 3563364351, 'RU', 'RUS', 'الإتحاد الروسي'),
(94350, 3563364352, 3563372543, 'BE', 'BEL', 'بلجيكا'),
(94351, 3563372544, 3563380735, 'SA', 'SAU', 'السعودية'),
(94352, 3563380736, 3563381951, 'GB', 'GBR', 'المملكة المتحدة'),
(94353, 3563381952, 3563381959, 'IT', 'ITA', 'إيطاليا'),
(94354, 3563381960, 3563382383, 'GB', 'GBR', 'المملكة المتحدة'),
(94355, 3563382384, 3563382391, 'AU', 'AUS', 'أستراليا'),
(94356, 3563382392, 3563382495, 'GB', 'GBR', 'المملكة المتحدة'),
(94357, 3563382496, 3563382503, 'AT', 'AUT', 'النمسا'),
(94358, 3563382504, 3563382583, 'GB', 'GBR', 'المملكة المتحدة'),
(94359, 3563382584, 3563382587, 'AT', 'AUT', 'النمسا'),
(94360, 3563382588, 3563382589, 'DE', 'DEU', 'ألمانيا'),
(94361, 3563382590, 3563382767, 'GB', 'GBR', 'المملكة المتحدة'),
(94362, 3563382768, 3563382775, 'IE', 'IRL', 'إيرلندا'),
(94363, 3563382776, 3563388927, 'GB', 'GBR', 'المملكة المتحدة'),
(94364, 3563388928, 3563397119, 'CH', 'CHE', 'سويسرا'),
(94365, 3563405312, 3563407871, 'ES', 'ESP', 'إسبانيا'),
(94366, 3563407872, 3563407903, 'US', 'USA', 'الولايات المتحدة'),
(94367, 3563407904, 3563413503, 'ES', 'ESP', 'إسبانيا'),
(94368, 3563413504, 3563421695, 'TR', 'TUR', 'تركيا'),
(94369, 3563421696, 3563438079, 'SI', 'SVN', 'سلوفينيا'),
(94370, 3563438080, 3563446271, 'DE', 'DEU', 'ألمانيا'),
(94371, 3563446272, 3563454463, 'LB', 'LBN', 'لبنان'),
(94372, 3563454464, 3563462655, 'SA', 'SAU', 'السعودية'),
(94373, 3563462656, 3563479039, 'IT', 'ITA', 'إيطاليا'),
(94374, 3563479040, 3563487231, 'GB', 'GBR', 'المملكة المتحدة'),
(94375, 3563487232, 3563491327, 'RS', 'SRB', 'صربيا'),
(94376, 3563491328, 3563491583, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(94377, 3563491584, 3563491835, 'RS', 'SRB', 'صربيا'),
(94378, 3563491836, 3563492095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(94379, 3563492096, 3563495423, 'RS', 'SRB', 'صربيا'),
(94380, 3563495424, 3563503615, 'DE', 'DEU', 'ألمانيا'),
(94381, 3563503616, 3563511807, 'GB', 'GBR', 'المملكة المتحدة'),
(94382, 3563511808, 3563519999, 'DE', 'DEU', 'ألمانيا'),
(94383, 3563520000, 3563528191, 'FR', 'FRA', 'فرنسا'),
(94384, 3563528192, 3563536383, 'DE', 'DEU', 'ألمانيا'),
(94385, 3563536384, 3563539087, 'CH', 'CHE', 'سويسرا'),
(94386, 3563539088, 3563539095, 'US', 'USA', 'الولايات المتحدة'),
(94387, 3563539096, 3563539119, 'CH', 'CHE', 'سويسرا'),
(94388, 3563539120, 3563539135, 'DE', 'DEU', 'ألمانيا'),
(94389, 3563539136, 3563544575, 'CH', 'CHE', 'سويسرا'),
(94390, 3563544576, 3563552767, 'RU', 'RUS', 'الإتحاد الروسي'),
(94391, 3563552768, 3563560959, 'SI', 'SVN', 'سلوفينيا'),
(94392, 3563569152, 3563577343, 'IT', 'ITA', 'إيطاليا'),
(94393, 3563577344, 3563585535, 'GB', 'GBR', 'المملكة المتحدة'),
(94394, 3563585536, 3563601919, 'IT', 'ITA', 'إيطاليا'),
(94395, 3563610112, 3563618303, 'BG', 'BGR', 'بلغاريا'),
(94396, 3563618304, 3563626495, 'GB', 'GBR', 'المملكة المتحدة'),
(94397, 3563626496, 3563634687, 'ES', 'ESP', 'إسبانيا'),
(94398, 3563634688, 3563651071, 'NL', 'NLD', 'هولندا'),
(94399, 3563651072, 3563683839, 'SE', 'SWE', 'السويد'),
(94400, 3563683840, 3563692031, 'BE', 'BEL', 'بلجيكا'),
(94401, 3563700224, 3563708415, 'DE', 'DEU', 'ألمانيا'),
(94402, 3563708416, 3563716607, 'HU', 'HUN', 'هنغاريا'),
(94403, 3563716608, 3563724799, 'PL', 'POL', 'بولندا'),
(94404, 3563724800, 3563732991, 'RU', 'RUS', 'الإتحاد الروسي'),
(94405, 3563732992, 3563741183, 'PS', 'PSE', 'فلسطين المحتلة'),
(94406, 3563741184, 3563749375, 'GB', 'GBR', 'المملكة المتحدة'),
(94407, 3563749376, 3563765759, 'PL', 'POL', 'بولندا'),
(94408, 3563765760, 3563782143, 'ES', 'ESP', 'إسبانيا'),
(94409, 3563782144, 3563790335, 'GR', 'GRC', 'اليونان'),
(94410, 3563790336, 3563798527, 'EE', 'EST', 'إستونيا'),
(94411, 3563798528, 3563800447, 'FR', 'FRA', 'فرنسا'),
(94412, 3563800448, 3563800463, 'GB', 'GBR', 'المملكة المتحدة'),
(94413, 3563800464, 3563800495, 'FR', 'FRA', 'فرنسا'),
(94414, 3563800496, 3563800511, 'GB', 'GBR', 'المملكة المتحدة'),
(94415, 3563800512, 3563800607, 'FR', 'FRA', 'فرنسا'),
(94416, 3563800608, 3563800623, 'GB', 'GBR', 'المملكة المتحدة'),
(94417, 3563800624, 3563800767, 'FR', 'FRA', 'فرنسا'),
(94418, 3563800768, 3563800783, 'GB', 'GBR', 'المملكة المتحدة'),
(94419, 3563800784, 3563800911, 'FR', 'FRA', 'فرنسا'),
(94420, 3563800912, 3563800927, 'GB', 'GBR', 'المملكة المتحدة'),
(94421, 3563800928, 3563800943, 'FR', 'FRA', 'فرنسا'),
(94422, 3563800944, 3563800991, 'GB', 'GBR', 'المملكة المتحدة'),
(94423, 3563800992, 3563801135, 'FR', 'FRA', 'فرنسا'),
(94424, 3563801136, 3563801151, 'DE', 'DEU', 'ألمانيا'),
(94425, 3563801152, 3563801183, 'FR', 'FRA', 'فرنسا'),
(94426, 3563801184, 3563801199, 'DE', 'DEU', 'ألمانيا'),
(94427, 3563801200, 3563801279, 'FR', 'FRA', 'فرنسا'),
(94428, 3563801280, 3563801295, 'NL', 'NLD', 'هولندا'),
(94429, 3563801296, 3563801375, 'FR', 'FRA', 'فرنسا'),
(94430, 3563801376, 3563801391, 'GB', 'GBR', 'المملكة المتحدة'),
(94431, 3563801392, 3563801407, 'IT', 'ITA', 'إيطاليا'),
(94432, 3563801408, 3563801423, 'DE', 'DEU', 'ألمانيا'),
(94433, 3563801424, 3563801455, 'FR', 'FRA', 'فرنسا'),
(94434, 3563801456, 3563801519, 'GB', 'GBR', 'المملكة المتحدة'),
(94435, 3563801520, 3563801551, 'FR', 'FRA', 'فرنسا'),
(94436, 3563801552, 3563801567, 'GB', 'GBR', 'المملكة المتحدة'),
(94437, 3563801568, 3563801599, 'FR', 'FRA', 'فرنسا'),
(94438, 3563801600, 3563801631, 'GB', 'GBR', 'المملكة المتحدة'),
(94439, 3563801632, 3563801647, 'FR', 'FRA', 'فرنسا'),
(94440, 3563801648, 3563801743, 'GB', 'GBR', 'المملكة المتحدة'),
(94441, 3563801744, 3563801775, 'FR', 'FRA', 'فرنسا'),
(94442, 3563801776, 3563801791, 'BE', 'BEL', 'بلجيكا'),
(94443, 3563801792, 3563801839, 'FR', 'FRA', 'فرنسا'),
(94444, 3563801840, 3563801855, 'GB', 'GBR', 'المملكة المتحدة'),
(94445, 3563801856, 3563801871, 'FR', 'FRA', 'فرنسا'),
(94446, 3563801872, 3563801887, 'GB', 'GBR', 'المملكة المتحدة'),
(94447, 3563801888, 3563801922, 'FR', 'FRA', 'فرنسا'),
(94448, 3563801923, 3563801935, 'GB', 'GBR', 'المملكة المتحدة'),
(94449, 3563801936, 3563802015, 'FR', 'FRA', 'فرنسا'),
(94450, 3563802016, 3563802031, 'BE', 'BEL', 'بلجيكا'),
(94451, 3563802032, 3563802047, 'FR', 'FRA', 'فرنسا'),
(94452, 3563802048, 3563802063, 'IT', 'ITA', 'إيطاليا'),
(94453, 3563802064, 3563802207, 'FR', 'FRA', 'فرنسا'),
(94454, 3563802208, 3563802223, 'GB', 'GBR', 'المملكة المتحدة'),
(94455, 3563802224, 3563802255, 'FR', 'FRA', 'فرنسا'),
(94456, 3563802256, 3563802271, 'GB', 'GBR', 'المملكة المتحدة'),
(94457, 3563802272, 3563802303, 'FR', 'FRA', 'فرنسا'),
(94458, 3563802304, 3563802319, 'IT', 'ITA', 'إيطاليا'),
(94459, 3563802320, 3563802447, 'FR', 'FRA', 'فرنسا'),
(94460, 3563802448, 3563802463, 'GB', 'GBR', 'المملكة المتحدة'),
(94461, 3563802464, 3563802623, 'FR', 'FRA', 'فرنسا'),
(94462, 3563802624, 3563802655, 'GB', 'GBR', 'المملكة المتحدة'),
(94463, 3563802656, 3563802735, 'FR', 'FRA', 'فرنسا'),
(94464, 3563802736, 3563802751, 'US', 'USA', 'الولايات المتحدة'),
(94465, 3563802752, 3563802783, 'GB', 'GBR', 'المملكة المتحدة'),
(94466, 3563802784, 3563803007, 'FR', 'FRA', 'فرنسا'),
(94467, 3563803008, 3563803023, 'GB', 'GBR', 'المملكة المتحدة'),
(94468, 3563803024, 3563803039, 'FR', 'FRA', 'فرنسا'),
(94469, 3563803040, 3563803055, 'GB', 'GBR', 'المملكة المتحدة'),
(94470, 3563803056, 3563803119, 'FR', 'FRA', 'فرنسا'),
(94471, 3563803120, 3563803135, 'NL', 'NLD', 'هولندا'),
(94472, 3563803136, 3563803151, 'FR', 'FRA', 'فرنسا'),
(94473, 3563803152, 3563803167, 'GB', 'GBR', 'المملكة المتحدة'),
(94474, 3563803168, 3563803183, 'FR', 'FRA', 'فرنسا'),
(94475, 3563803184, 3563803215, 'GB', 'GBR', 'المملكة المتحدة'),
(94476, 3563803216, 3563803247, 'FR', 'FRA', 'فرنسا'),
(94477, 3563803248, 3563803263, 'GB', 'GBR', 'المملكة المتحدة'),
(94478, 3563803264, 3563803279, 'FR', 'FRA', 'فرنسا'),
(94479, 3563803280, 3563803295, 'GB', 'GBR', 'المملكة المتحدة'),
(94480, 3563803296, 3563803311, 'FR', 'FRA', 'فرنسا'),
(94481, 3563803312, 3563803327, 'GB', 'GBR', 'المملكة المتحدة'),
(94482, 3563803328, 3563803359, 'FR', 'FRA', 'فرنسا'),
(94483, 3563803360, 3563803423, 'GB', 'GBR', 'المملكة المتحدة'),
(94484, 3563803424, 3563803439, 'FR', 'FRA', 'فرنسا'),
(94485, 3563803440, 3563803455, 'DE', 'DEU', 'ألمانيا'),
(94486, 3563803456, 3563803487, 'GB', 'GBR', 'المملكة المتحدة'),
(94487, 3563803488, 3563803503, 'US', 'USA', 'الولايات المتحدة'),
(94488, 3563803504, 3563803519, 'GB', 'GBR', 'المملكة المتحدة'),
(94489, 3563803520, 3563803631, 'FR', 'FRA', 'فرنسا'),
(94490, 3563803632, 3563803647, 'GB', 'GBR', 'المملكة المتحدة'),
(94491, 3563803648, 3563803967, 'FR', 'FRA', 'فرنسا'),
(94492, 3563803968, 3563803983, 'BE', 'BEL', 'بلجيكا'),
(94493, 3563803984, 3563804695, 'FR', 'FRA', 'فرنسا'),
(94494, 3563804696, 3563804703, 'GB', 'GBR', 'المملكة المتحدة'),
(94495, 3563804704, 3563804719, 'FR', 'FRA', 'فرنسا'),
(94496, 3563804720, 3563804727, 'GB', 'GBR', 'المملكة المتحدة'),
(94497, 3563804728, 3563806543, 'FR', 'FRA', 'فرنسا'),
(94498, 3563806544, 3563806559, 'DE', 'DEU', 'ألمانيا'),
(94499, 3563806560, 3563806687, 'FR', 'FRA', 'فرنسا'),
(94500, 3563806688, 3563806703, 'DE', 'DEU', 'ألمانيا'),
(94501, 3563806704, 3563806719, 'FR', 'FRA', 'فرنسا'),
(94502, 3563806720, 3563814911, 'SA', 'SAU', 'السعودية'),
(94503, 3563814912, 3563823103, 'SE', 'SWE', 'السويد'),
(94504, 3563823104, 3563831295, 'DE', 'DEU', 'ألمانيا'),
(94505, 3563831296, 3563847679, 'RU', 'RUS', 'الإتحاد الروسي'),
(94506, 3563847680, 3563848231, 'NL', 'NLD', 'هولندا'),
(94507, 3563848232, 3563848239, 'GB', 'GBR', 'المملكة المتحدة'),
(94508, 3563848240, 3563848319, 'NL', 'NLD', 'هولندا'),
(94509, 3563848320, 3563848327, 'ES', 'ESP', 'إسبانيا'),
(94510, 3563848328, 3563848383, 'NL', 'NLD', 'هولندا'),
(94511, 3563848384, 3563848447, 'ES', 'ESP', 'إسبانيا'),
(94512, 3563848448, 3563848575, 'NL', 'NLD', 'هولندا'),
(94513, 3563848576, 3563848583, 'ES', 'ESP', 'إسبانيا'),
(94514, 3563848584, 3563848639, 'NL', 'NLD', 'هولندا'),
(94515, 3563848640, 3563848959, 'ES', 'ESP', 'إسبانيا'),
(94516, 3563848960, 3563848967, 'NL', 'NLD', 'هولندا'),
(94517, 3563848968, 3563848975, 'ES', 'ESP', 'إسبانيا'),
(94518, 3563848976, 3563848979, 'NL', 'NLD', 'هولندا'),
(94519, 3563848980, 3563848983, 'ES', 'ESP', 'إسبانيا'),
(94520, 3563848984, 3563848987, 'NL', 'NLD', 'هولندا'),
(94521, 3563848988, 3563848991, 'ES', 'ESP', 'إسبانيا'),
(94522, 3563848992, 3563849151, 'NL', 'NLD', 'هولندا'),
(94523, 3563849152, 3563849183, 'ES', 'ESP', 'إسبانيا'),
(94524, 3563849184, 3563849197, 'NL', 'NLD', 'هولندا'),
(94525, 3563849198, 3563849199, 'ES', 'ESP', 'إسبانيا'),
(94526, 3563849200, 3563849207, 'NL', 'NLD', 'هولندا'),
(94527, 3563849208, 3563849215, 'ES', 'ESP', 'إسبانيا'),
(94528, 3563849216, 3563849727, 'GB', 'GBR', 'المملكة المتحدة'),
(94529, 3563849728, 3563849991, 'NL', 'NLD', 'هولندا'),
(94530, 3563849992, 3563849999, 'SA', 'SAU', 'السعودية'),
(94531, 3563850000, 3563850007, 'FI', 'FIN', 'فنلندا'),
(94532, 3563850008, 3563850239, 'NL', 'NLD', 'هولندا'),
(94533, 3563850240, 3563850751, 'GB', 'GBR', 'المملكة المتحدة'),
(94534, 3563850752, 3563850767, 'NL', 'NLD', 'هولندا'),
(94535, 3563850768, 3563850783, 'ES', 'ESP', 'إسبانيا'),
(94536, 3563850784, 3563850815, 'NL', 'NLD', 'هولندا'),
(94537, 3563850816, 3563850831, 'ES', 'ESP', 'إسبانيا'),
(94538, 3563850832, 3563850847, 'NL', 'NLD', 'هولندا'),
(94539, 3563850848, 3563850879, 'ES', 'ESP', 'إسبانيا'),
(94540, 3563850880, 3563851007, 'NL', 'NLD', 'هولندا'),
(94541, 3563851008, 3563851199, 'ES', 'ESP', 'إسبانيا'),
(94542, 3563851200, 3563851839, 'NL', 'NLD', 'هولندا'),
(94543, 3563851840, 3563852095, 'ES', 'ESP', 'إسبانيا'),
(94544, 3563852096, 3563852191, 'NL', 'NLD', 'هولندا'),
(94545, 3563852192, 3563852207, 'GB', 'GBR', 'المملكة المتحدة'),
(94546, 3563852208, 3563852216, 'NL', 'NLD', 'هولندا'),
(94547, 3563852217, 3563852223, 'ES', 'ESP', 'إسبانيا'),
(94548, 3563852224, 3563852543, 'NL', 'NLD', 'هولندا'),
(94549, 3563852544, 3563852799, 'ES', 'ESP', 'إسبانيا'),
(94550, 3563852800, 3563853319, 'NL', 'NLD', 'هولندا'),
(94551, 3563853320, 3563853327, 'ES', 'ESP', 'إسبانيا'),
(94552, 3563853328, 3563853375, 'NL', 'NLD', 'هولندا'),
(94553, 3563853376, 3563853439, 'ES', 'ESP', 'إسبانيا'),
(94554, 3563853440, 3563853567, 'NL', 'NLD', 'هولندا'),
(94555, 3563853568, 3563854079, 'ES', 'ESP', 'إسبانيا'),
(94556, 3563854080, 3563854095, 'NL', 'NLD', 'هولندا'),
(94557, 3563854096, 3563854103, 'ES', 'ESP', 'إسبانيا'),
(94558, 3563854104, 3563854175, 'NL', 'NLD', 'هولندا'),
(94559, 3563854176, 3563854239, 'ES', 'ESP', 'إسبانيا'),
(94560, 3563854240, 3563854259, 'NL', 'NLD', 'هولندا'),
(94561, 3563854260, 3563854591, 'ES', 'ESP', 'إسبانيا'),
(94562, 3563854592, 3563854847, 'NL', 'NLD', 'هولندا'),
(94563, 3563854848, 3563855359, 'ES', 'ESP', 'إسبانيا'),
(94564, 3563855360, 3563855487, 'NL', 'NLD', 'هولندا'),
(94565, 3563855488, 3563855551, 'ES', 'ESP', 'إسبانيا'),
(94566, 3563855552, 3563855583, 'NL', 'NLD', 'هولندا'),
(94567, 3563855584, 3563855615, 'ES', 'ESP', 'إسبانيا'),
(94568, 3563855616, 3563855871, 'US', 'USA', 'الولايات المتحدة'),
(94569, 3563855872, 3563864063, 'AT', 'AUT', 'النمسا'),
(94570, 3563864064, 3563872255, 'GB', 'GBR', 'المملكة المتحدة'),
(94571, 3563872256, 3563880447, 'RU', 'RUS', 'الإتحاد الروسي'),
(94572, 3563880448, 3563888639, 'TR', 'TUR', 'تركيا'),
(94573, 3563888640, 3563896831, 'DE', 'DEU', 'ألمانيا'),
(94574, 3563896832, 3563899391, 'HU', 'HUN', 'هنغاريا'),
(94575, 3563899392, 3563899647, 'SK', 'SVK', 'سلوفاكيا'),
(94576, 3563899648, 3563899903, 'HU', 'HUN', 'هنغاريا'),
(94577, 3563899904, 3563900159, 'SK', 'SVK', 'سلوفاكيا'),
(94578, 3563900160, 3563900415, 'HU', 'HUN', 'هنغاريا'),
(94579, 3563900416, 3563900671, 'SK', 'SVK', 'سلوفاكيا'),
(94580, 3563900672, 3563902975, 'HU', 'HUN', 'هنغاريا'),
(94581, 3563902976, 3563903231, 'SK', 'SVK', 'سلوفاكيا'),
(94582, 3563903232, 3563913215, 'HU', 'HUN', 'هنغاريا'),
(94583, 3563913216, 3563921407, 'RU', 'RUS', 'الإتحاد الروسي'),
(94584, 3563921408, 3563929599, 'UA', 'UKR', 'أوكرانيا'),
(94585, 3563929600, 3563937791, 'CH', 'CHE', 'سويسرا'),
(94586, 3563937792, 3563945983, 'TR', 'TUR', 'تركيا'),
(94587, 3563945984, 3563954175, 'PL', 'POL', 'بولندا'),
(94588, 3563954176, 3563962367, 'IT', 'ITA', 'إيطاليا'),
(94589, 3563962368, 3563970559, 'RU', 'RUS', 'الإتحاد الروسي'),
(94590, 3563970560, 3563978751, 'TR', 'TUR', 'تركيا'),
(94591, 3563978752, 3563995135, 'IT', 'ITA', 'إيطاليا'),
(94592, 3563995136, 3564003327, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(94593, 3564003328, 3564008191, 'DE', 'DEU', 'ألمانيا'),
(94594, 3564008192, 3564008223, 'CH', 'CHE', 'سويسرا'),
(94595, 3564008224, 3564011519, 'DE', 'DEU', 'ألمانيا'),
(94596, 3564011520, 3564019711, 'UA', 'UKR', 'أوكرانيا'),
(94597, 3564019712, 3564027903, 'GB', 'GBR', 'المملكة المتحدة'),
(94598, 3564027904, 3564041215, 'DE', 'DEU', 'ألمانيا'),
(94599, 3564041216, 3564041727, 'RU', 'RUS', 'الإتحاد الروسي'),
(94600, 3564041728, 3564044287, 'DE', 'DEU', 'ألمانيا'),
(94601, 3564044288, 3564052479, 'CZ', 'CZE', 'التشيك'),
(94602, 3564052480, 3564060671, 'GB', 'GBR', 'المملكة المتحدة'),
(94603, 3564060672, 3564068863, 'RU', 'RUS', 'الإتحاد الروسي'),
(94604, 3564068864, 3564077055, 'ES', 'ESP', 'إسبانيا'),
(94605, 3564077056, 3564093439, 'GB', 'GBR', 'المملكة المتحدة'),
(94606, 3564093440, 3564101631, 'UA', 'UKR', 'أوكرانيا'),
(94607, 3564101632, 3564109823, 'DE', 'DEU', 'ألمانيا'),
(94608, 3564109824, 3564126207, 'SE', 'SWE', 'السويد'),
(94609, 3564126208, 3564134399, 'IT', 'ITA', 'إيطاليا'),
(94610, 3564134400, 3564142591, 'KG', 'KGZ', 'قيرغيزستان'),
(94611, 3564142592, 3564146175, 'DE', 'DEU', 'ألمانيا'),
(94612, 3564146176, 3564150783, 'DK', 'DNK', 'الدنيمارك'),
(94613, 3564150784, 3564152607, 'SE', 'SWE', 'السويد'),
(94614, 3564152608, 3564152639, 'NO', 'NOR', 'النرويج'),
(94615, 3564152640, 3564153087, 'SE', 'SWE', 'السويد'),
(94616, 3564153088, 3564153151, 'NO', 'NOR', 'النرويج'),
(94617, 3564153152, 3564157207, 'SE', 'SWE', 'السويد'),
(94618, 3564157208, 3564157215, 'NO', 'NOR', 'النرويج'),
(94619, 3564157216, 3564158975, 'SE', 'SWE', 'السويد'),
(94620, 3564158976, 3564161855, 'DE', 'DEU', 'ألمانيا'),
(94621, 3564161856, 3564161891, 'NL', 'NLD', 'هولندا'),
(94622, 3564161892, 3564165119, 'DE', 'DEU', 'ألمانيا'),
(94623, 3564165120, 3564165439, 'NL', 'NLD', 'هولندا'),
(94624, 3564165440, 3564175359, 'DE', 'DEU', 'ألمانيا'),
(94625, 3564175360, 3564183551, 'GB', 'GBR', 'المملكة المتحدة'),
(94626, 3564183552, 3564185087, 'UA', 'UKR', 'أوكرانيا'),
(94627, 3564185088, 3564185343, 'DE', 'DEU', 'ألمانيا'),
(94628, 3564185344, 3564191743, 'UA', 'UKR', 'أوكرانيا'),
(94629, 3564191744, 3564199935, 'BE', 'BEL', 'بلجيكا'),
(94630, 3564199936, 3564208127, 'RU', 'RUS', 'الإتحاد الروسي'),
(94631, 3564208128, 3564216319, 'GB', 'GBR', 'المملكة المتحدة'),
(94632, 3564216320, 3564224511, 'PT', 'PRT', 'البورتوغال'),
(94633, 3564224512, 3564232703, 'GB', 'GBR', 'المملكة المتحدة'),
(94634, 3564232704, 3564240895, 'RU', 'RUS', 'الإتحاد الروسي'),
(94635, 3564240896, 3564241407, 'TJ', 'TJK', 'طاجيكيستان'),
(94636, 3564241408, 3564249087, 'RU', 'RUS', 'الإتحاد الروسي'),
(94637, 3564249088, 3564260735, 'DE', 'DEU', 'ألمانيا'),
(94638, 3564260736, 3564260863, 'NL', 'NLD', 'هولندا'),
(94639, 3564260864, 3564265471, 'DE', 'DEU', 'ألمانيا'),
(94640, 3564273664, 3564292151, 'DE', 'DEU', 'ألمانيا'),
(94641, 3564292152, 3564292159, 'AT', 'AUT', 'النمسا'),
(94642, 3564292160, 3564302655, 'DE', 'DEU', 'ألمانيا'),
(94643, 3564302656, 3564302687, 'BE', 'BEL', 'بلجيكا'),
(94644, 3564302688, 3564306431, 'DE', 'DEU', 'ألمانيا'),
(94645, 3564306432, 3564314623, 'TR', 'TUR', 'تركيا'),
(94646, 3564314624, 3564322815, 'GB', 'GBR', 'المملكة المتحدة'),
(94647, 3564322816, 3564331007, 'IT', 'ITA', 'إيطاليا'),
(94648, 3564331008, 3564339199, 'ES', 'ESP', 'إسبانيا'),
(94649, 3564339200, 3564339967, 'GB', 'GBR', 'المملكة المتحدة'),
(94650, 3564339968, 3564339999, 'NL', 'NLD', 'هولندا'),
(94651, 3564340000, 3564340351, 'GB', 'GBR', 'المملكة المتحدة'),
(94652, 3564340352, 3564340415, 'NL', 'NLD', 'هولندا'),
(94653, 3564340416, 3564340479, 'GB', 'GBR', 'المملكة المتحدة'),
(94654, 3564340480, 3564340735, 'NL', 'NLD', 'هولندا'),
(94655, 3564340736, 3564340991, 'GB', 'GBR', 'المملكة المتحدة'),
(94656, 3564340992, 3564341119, 'NL', 'NLD', 'هولندا'),
(94657, 3564341120, 3564341183, 'GB', 'GBR', 'المملكة المتحدة'),
(94658, 3564341184, 3564341247, 'NL', 'NLD', 'هولندا'),
(94659, 3564341248, 3564341759, 'GB', 'GBR', 'المملكة المتحدة'),
(94660, 3564341760, 3564342063, 'NL', 'NLD', 'هولندا'),
(94661, 3564342064, 3564342207, 'GB', 'GBR', 'المملكة المتحدة'),
(94662, 3564342208, 3564342271, 'NL', 'NLD', 'هولندا'),
(94663, 3564342272, 3564342335, 'GB', 'GBR', 'المملكة المتحدة'),
(94664, 3564342336, 3564342431, 'NL', 'NLD', 'هولندا'),
(94665, 3564342432, 3564342527, 'GB', 'GBR', 'المملكة المتحدة'),
(94666, 3564342528, 3564342783, 'NL', 'NLD', 'هولندا'),
(94667, 3564342784, 3564343583, 'GB', 'GBR', 'المملكة المتحدة'),
(94668, 3564343584, 3564343615, 'NL', 'NLD', 'هولندا'),
(94669, 3564343616, 3564343679, 'GB', 'GBR', 'المملكة المتحدة'),
(94670, 3564343680, 3564343743, 'NL', 'NLD', 'هولندا'),
(94671, 3564343744, 3564343775, 'GB', 'GBR', 'المملكة المتحدة'),
(94672, 3564343776, 3564343807, 'NL', 'NLD', 'هولندا'),
(94673, 3564343808, 3564343839, 'GB', 'GBR', 'المملكة المتحدة'),
(94674, 3564343840, 3564343871, 'NL', 'NLD', 'هولندا'),
(94675, 3564343872, 3564343967, 'GB', 'GBR', 'المملكة المتحدة'),
(94676, 3564343968, 3564343999, 'NL', 'NLD', 'هولندا'),
(94677, 3564344000, 3564344031, 'GB', 'GBR', 'المملكة المتحدة'),
(94678, 3564344032, 3564344231, 'NL', 'NLD', 'هولندا'),
(94679, 3564344232, 3564344239, 'GB', 'GBR', 'المملكة المتحدة'),
(94680, 3564344240, 3564344247, 'NL', 'NLD', 'هولندا'),
(94681, 3564344248, 3564344575, 'GB', 'GBR', 'المملكة المتحدة'),
(94682, 3564344576, 3564344831, 'NL', 'NLD', 'هولندا'),
(94683, 3564344832, 3564344895, 'GB', 'GBR', 'المملكة المتحدة'),
(94684, 3564344896, 3564344959, 'NL', 'NLD', 'هولندا'),
(94685, 3564344960, 3564345023, 'GB', 'GBR', 'المملكة المتحدة'),
(94686, 3564345024, 3564345087, 'NL', 'NLD', 'هولندا'),
(94687, 3564345088, 3564345127, 'GB', 'GBR', 'المملكة المتحدة'),
(94688, 3564345128, 3564345131, 'NL', 'NLD', 'هولندا'),
(94689, 3564345132, 3564345135, 'GB', 'GBR', 'المملكة المتحدة'),
(94690, 3564345136, 3564345151, 'NL', 'NLD', 'هولندا'),
(94691, 3564345152, 3564345215, 'GB', 'GBR', 'المملكة المتحدة'),
(94692, 3564345216, 3564345343, 'NL', 'NLD', 'هولندا'),
(94693, 3564345344, 3564346143, 'GB', 'GBR', 'المملكة المتحدة'),
(94694, 3564346144, 3564346175, 'NL', 'NLD', 'هولندا'),
(94695, 3564346176, 3564346207, 'GB', 'GBR', 'المملكة المتحدة'),
(94696, 3564346208, 3564346239, 'NL', 'NLD', 'هولندا'),
(94697, 3564346240, 3564346271, 'GB', 'GBR', 'المملكة المتحدة'),
(94698, 3564346272, 3564346303, 'NL', 'NLD', 'هولندا'),
(94699, 3564346304, 3564347391, 'GB', 'GBR', 'المملكة المتحدة'),
(94700, 3564347392, 3564347583, 'NL', 'NLD', 'هولندا'),
(94701, 3564347584, 3564347647, 'GB', 'GBR', 'المملكة المتحدة'),
(94702, 3564347648, 3564348159, 'NL', 'NLD', 'هولندا'),
(94703, 3564348160, 3564348191, 'GB', 'GBR', 'المملكة المتحدة'),
(94704, 3564348192, 3564348239, 'NL', 'NLD', 'هولندا'),
(94705, 3564348240, 3564348255, 'GB', 'GBR', 'المملكة المتحدة'),
(94706, 3564348256, 3564348287, 'NL', 'NLD', 'هولندا'),
(94707, 3564348288, 3564348399, 'GB', 'GBR', 'المملكة المتحدة'),
(94708, 3564348400, 3564348415, 'NL', 'NLD', 'هولندا'),
(94709, 3564348416, 3564348479, 'GB', 'GBR', 'المملكة المتحدة'),
(94710, 3564348480, 3564348495, 'NL', 'NLD', 'هولندا'),
(94711, 3564348496, 3564348527, 'GB', 'GBR', 'المملكة المتحدة'),
(94712, 3564348528, 3564348543, 'NL', 'NLD', 'هولندا'),
(94713, 3564348544, 3564348559, 'GB', 'GBR', 'المملكة المتحدة'),
(94714, 3564348560, 3564348639, 'NL', 'NLD', 'هولندا'),
(94715, 3564348640, 3564348671, 'GB', 'GBR', 'المملكة المتحدة'),
(94716, 3564348672, 3564348991, 'NL', 'NLD', 'هولندا'),
(94717, 3564348992, 3564349183, 'GB', 'GBR', 'المملكة المتحدة'),
(94718, 3564349184, 3564349311, 'NL', 'NLD', 'هولندا'),
(94719, 3564349312, 3564349375, 'GB', 'GBR', 'المملكة المتحدة'),
(94720, 3564349376, 3564349407, 'NL', 'NLD', 'هولندا'),
(94721, 3564349408, 3564349503, 'GB', 'GBR', 'المملكة المتحدة'),
(94722, 3564349504, 3564349583, 'NL', 'NLD', 'هولندا'),
(94723, 3564349584, 3564349615, 'GB', 'GBR', 'المملكة المتحدة'),
(94724, 3564349616, 3564349695, 'NL', 'NLD', 'هولندا'),
(94725, 3564349696, 3564350335, 'GB', 'GBR', 'المملكة المتحدة'),
(94726, 3564350336, 3564350351, 'NL', 'NLD', 'هولندا'),
(94727, 3564350352, 3564350367, 'GB', 'GBR', 'المملكة المتحدة'),
(94728, 3564350368, 3564350719, 'NL', 'NLD', 'هولندا'),
(94729, 3564350720, 3564351231, 'GB', 'GBR', 'المملكة المتحدة'),
(94730, 3564351232, 3564351295, 'NL', 'NLD', 'هولندا'),
(94731, 3564351296, 3564351375, 'GB', 'GBR', 'المملكة المتحدة'),
(94732, 3564351376, 3564351391, 'NL', 'NLD', 'هولندا'),
(94733, 3564351392, 3564351439, 'GB', 'GBR', 'المملكة المتحدة'),
(94734, 3564351440, 3564351455, 'NL', 'NLD', 'هولندا'),
(94735, 3564351456, 3564351471, 'GB', 'GBR', 'المملكة المتحدة'),
(94736, 3564351472, 3564351487, 'NL', 'NLD', 'هولندا'),
(94737, 3564351488, 3564351503, 'GB', 'GBR', 'المملكة المتحدة'),
(94738, 3564351504, 3564351679, 'NL', 'NLD', 'هولندا'),
(94739, 3564351680, 3564351999, 'GB', 'GBR', 'المملكة المتحدة'),
(94740, 3564352000, 3564352063, 'NL', 'NLD', 'هولندا'),
(94741, 3564352064, 3564352095, 'GB', 'GBR', 'المملكة المتحدة'),
(94742, 3564352096, 3564352127, 'NL', 'NLD', 'هولندا'),
(94743, 3564352128, 3564352191, 'GB', 'GBR', 'المملكة المتحدة'),
(94744, 3564352192, 3564352511, 'NL', 'NLD', 'هولندا'),
(94745, 3564352512, 3564352543, 'GB', 'GBR', 'المملكة المتحدة'),
(94746, 3564352544, 3564352575, 'NL', 'NLD', 'هولندا'),
(94747, 3564352576, 3564352735, 'GB', 'GBR', 'المملكة المتحدة'),
(94748, 3564352736, 3564352767, 'NL', 'NLD', 'هولندا'),
(94749, 3564352768, 3564353023, 'GB', 'GBR', 'المملكة المتحدة'),
(94750, 3564353024, 3564353087, 'NL', 'NLD', 'هولندا'),
(94751, 3564353088, 3564353111, 'GB', 'GBR', 'المملكة المتحدة'),
(94752, 3564353112, 3564353151, 'NL', 'NLD', 'هولندا'),
(94753, 3564353152, 3564353199, 'GB', 'GBR', 'المملكة المتحدة'),
(94754, 3564353200, 3564353215, 'NL', 'NLD', 'هولندا'),
(94755, 3564353216, 3564353223, 'GB', 'GBR', 'المملكة المتحدة'),
(94756, 3564353224, 3564353263, 'NL', 'NLD', 'هولندا'),
(94757, 3564353264, 3564353295, 'GB', 'GBR', 'المملكة المتحدة'),
(94758, 3564353296, 3564353311, 'NL', 'NLD', 'هولندا'),
(94759, 3564353312, 3564353343, 'GB', 'GBR', 'المملكة المتحدة'),
(94760, 3564353344, 3564353359, 'NL', 'NLD', 'هولندا'),
(94761, 3564353360, 3564353407, 'GB', 'GBR', 'المملكة المتحدة'),
(94762, 3564353408, 3564353487, 'NL', 'NLD', 'هولندا'),
(94763, 3564353488, 3564353503, 'GB', 'GBR', 'المملكة المتحدة'),
(94764, 3564353504, 3564353535, 'NL', 'NLD', 'هولندا'),
(94765, 3564353536, 3564353791, 'GB', 'GBR', 'المملكة المتحدة'),
(94766, 3564353792, 3564353919, 'NL', 'NLD', 'هولندا'),
(94767, 3564353920, 3564354063, 'GB', 'GBR', 'المملكة المتحدة'),
(94768, 3564354064, 3564354079, 'NL', 'NLD', 'هولندا'),
(94769, 3564354080, 3564354303, 'GB', 'GBR', 'المملكة المتحدة'),
(94770, 3564354304, 3564354335, 'NL', 'NLD', 'هولندا'),
(94771, 3564354336, 3564354367, 'GB', 'GBR', 'المملكة المتحدة'),
(94772, 3564354368, 3564354559, 'NL', 'NLD', 'هولندا'),
(94773, 3564354560, 3564354943, 'GB', 'GBR', 'المملكة المتحدة'),
(94774, 3564354944, 3564355039, 'NL', 'NLD', 'هولندا'),
(94775, 3564355040, 3564355135, 'GB', 'GBR', 'المملكة المتحدة'),
(94776, 3564355136, 3564355199, 'NL', 'NLD', 'هولندا'),
(94777, 3564355200, 3564355295, 'GB', 'GBR', 'المملكة المتحدة'),
(94778, 3564355296, 3564355311, 'NL', 'NLD', 'هولندا'),
(94779, 3564355312, 3564355583, 'GB', 'GBR', 'المملكة المتحدة'),
(94780, 3564355584, 3564363775, 'NL', 'NLD', 'هولندا'),
(94781, 3564363776, 3564371967, 'UA', 'UKR', 'أوكرانيا'),
(94782, 3564371968, 3564380159, 'DE', 'DEU', 'ألمانيا'),
(94783, 3564380160, 3564388351, 'FI', 'FIN', 'فنلندا'),
(94784, 3564388352, 3564392959, 'SE', 'SWE', 'السويد'),
(94785, 3564392960, 3564393087, 'NO', 'NOR', 'النرويج'),
(94786, 3564393088, 3564396543, 'SE', 'SWE', 'السويد'),
(94787, 3564396544, 3564404735, 'RU', 'RUS', 'الإتحاد الروسي'),
(94788, 3564404736, 3564412927, 'BG', 'BGR', 'بلغاريا'),
(94789, 3564412928, 3564421119, 'IL', 'ISR', 'إسرائيل'),
(94790, 3564421120, 3564429311, 'SA', 'SAU', 'السعودية'),
(94791, 3564429312, 3564431567, 'KZ', 'KAZ', 'كازاخستان'),
(94792, 3564431568, 3564431583, 'AF', 'AFG', 'أفغانستان'),
(94793, 3564431584, 3564437503, 'KZ', 'KAZ', 'كازاخستان'),
(94794, 3564437504, 3564445695, 'LT', 'LTU', 'ليتوانيا'),
(94795, 3564445696, 3564453887, 'BG', 'BGR', 'بلغاريا'),
(94796, 3564453888, 3564462079, 'DE', 'DEU', 'ألمانيا'),
(94797, 3564462080, 3564470271, 'CH', 'CHE', 'سويسرا'),
(94798, 3564470272, 3564478463, 'IL', 'ISR', 'إسرائيل'),
(94799, 3564478464, 3564486655, 'LU', 'LUX', 'لوكسيمبورغ'),
(94800, 3564486656, 3564494847, 'CH', 'CHE', 'سويسرا'),
(94801, 3564494848, 3564494907, 'GB', 'GBR', 'المملكة المتحدة'),
(94802, 3564494908, 3564494911, 'FR', 'FRA', 'فرنسا'),
(94803, 3564494912, 3564494975, 'GB', 'GBR', 'المملكة المتحدة'),
(94804, 3564494976, 3564494983, 'CH', 'CHE', 'سويسرا'),
(94805, 3564494984, 3564495103, 'GB', 'GBR', 'المملكة المتحدة'),
(94806, 3564495104, 3564495167, 'DE', 'DEU', 'ألمانيا'),
(94807, 3564495168, 3564495203, 'GB', 'GBR', 'المملكة المتحدة'),
(94808, 3564495616, 3564495743, 'GB', 'GBR', 'المملكة المتحدة'),
(94809, 3564495872, 3564495927, 'GB', 'GBR', 'المملكة المتحدة'),
(94810, 3564495936, 3564496111, 'GB', 'GBR', 'المملكة المتحدة'),
(94811, 3564496128, 3564496175, 'GB', 'GBR', 'المملكة المتحدة'),
(94812, 3564496184, 3564496199, 'GB', 'GBR', 'المملكة المتحدة'),
(94813, 3564496208, 3564496215, 'GB', 'GBR', 'المملكة المتحدة'),
(94814, 3564496224, 3564496263, 'GB', 'GBR', 'المملكة المتحدة'),
(94815, 3564496272, 3564496319, 'GB', 'GBR', 'المملكة المتحدة'),
(94816, 3564496320, 3564496327, 'FR', 'FRA', 'فرنسا'),
(94817, 3564496336, 3564496607, 'GB', 'GBR', 'المملكة المتحدة'),
(94818, 3564496640, 3564496655, 'GB', 'GBR', 'المملكة المتحدة'),
(94819, 3564496672, 3564496847, 'GB', 'GBR', 'المملكة المتحدة'),
(94820, 3564496848, 3564496863, 'FR', 'FRA', 'فرنسا'),
(94821, 3564496864, 3564496895, 'GB', 'GBR', 'المملكة المتحدة'),
(94822, 3564498944, 3564499007, 'NL', 'NLD', 'هولندا'),
(94823, 3564499008, 3564499055, 'GB', 'GBR', 'المملكة المتحدة'),
(94824, 3564499200, 3564499215, 'NL', 'NLD', 'هولندا'),
(94825, 3564499216, 3564499231, 'DK', 'DNK', 'الدنيمارك'),
(94826, 3564499232, 3564499239, 'NL', 'NLD', 'هولندا'),
(94827, 3564499248, 3564499335, 'GB', 'GBR', 'المملكة المتحدة'),
(94828, 3564499456, 3564499551, 'NL', 'NLD', 'هولندا'),
(94829, 3564499552, 3564499711, 'GB', 'GBR', 'المملكة المتحدة'),
(94830, 3564500992, 3564500999, 'SE', 'SWE', 'السويد'),
(94831, 3564501248, 3564501263, 'DE', 'DEU', 'ألمانيا'),
(94832, 3564501264, 3564501279, 'SE', 'SWE', 'السويد'),
(94833, 3564501280, 3564501311, 'GB', 'GBR', 'المملكة المتحدة'),
(94834, 3564501504, 3564501507, 'SE', 'SWE', 'السويد'),
(94835, 3564501508, 3564501511, 'DE', 'DEU', 'ألمانيا'),
(94836, 3564501760, 3564501887, 'DE', 'DEU', 'ألمانيا'),
(94837, 3564502528, 3564502559, 'DE', 'DEU', 'ألمانيا'),
(94838, 3564502560, 3564502591, 'GB', 'GBR', 'المملكة المتحدة'),
(94839, 3564503040, 3564511231, 'JO', 'JOR', 'الأردن'),
(94840, 3564511232, 3564519423, 'RU', 'RUS', 'الإتحاد الروسي'),
(94841, 3564519424, 3564527615, 'SI', 'SVN', 'سلوفينيا'),
(94842, 3564527616, 3564543999, 'SA', 'SAU', 'السعودية'),
(94843, 3564544000, 3564560383, 'DE', 'DEU', 'ألمانيا'),
(94844, 3564560384, 3564560391, 'US', 'USA', 'الولايات المتحدة'),
(94845, 3564560392, 3564560399, 'CA', 'CAN', 'كندا'),
(94846, 3564560400, 3564560415, 'US', 'USA', 'الولايات المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(94847, 3564560416, 3564560511, 'GB', 'GBR', 'المملكة المتحدة'),
(94848, 3564560512, 3564560595, 'US', 'USA', 'الولايات المتحدة'),
(94849, 3564560596, 3564560927, 'GB', 'GBR', 'المملكة المتحدة'),
(94850, 3564560928, 3564560959, 'US', 'USA', 'الولايات المتحدة'),
(94851, 3564560960, 3564561039, 'GB', 'GBR', 'المملكة المتحدة'),
(94852, 3564561040, 3564561055, 'US', 'USA', 'الولايات المتحدة'),
(94853, 3564561056, 3564561071, 'GB', 'GBR', 'المملكة المتحدة'),
(94854, 3564561072, 3564561087, 'US', 'USA', 'الولايات المتحدة'),
(94855, 3564561088, 3564561151, 'GB', 'GBR', 'المملكة المتحدة'),
(94856, 3564561152, 3564561407, 'US', 'USA', 'الولايات المتحدة'),
(94857, 3564561408, 3564561663, 'GB', 'GBR', 'المملكة المتحدة'),
(94858, 3564561664, 3564561671, 'US', 'USA', 'الولايات المتحدة'),
(94859, 3564561672, 3564561679, 'GB', 'GBR', 'المملكة المتحدة'),
(94860, 3564561680, 3564561687, 'US', 'USA', 'الولايات المتحدة'),
(94861, 3564561688, 3564561695, 'GB', 'GBR', 'المملكة المتحدة'),
(94862, 3564561696, 3564561791, 'US', 'USA', 'الولايات المتحدة'),
(94863, 3564561792, 3564561919, 'GB', 'GBR', 'المملكة المتحدة'),
(94864, 3564561920, 3564562431, 'CH', 'CHE', 'سويسرا'),
(94865, 3564562432, 3564562687, 'GB', 'GBR', 'المملكة المتحدة'),
(94866, 3564562688, 3564562815, 'US', 'USA', 'الولايات المتحدة'),
(94867, 3564562816, 3564562879, 'GB', 'GBR', 'المملكة المتحدة'),
(94868, 3564562880, 3564562943, 'US', 'USA', 'الولايات المتحدة'),
(94869, 3564562944, 3564563711, 'GB', 'GBR', 'المملكة المتحدة'),
(94870, 3564563712, 3564563967, 'US', 'USA', 'الولايات المتحدة'),
(94871, 3564563968, 3564564223, 'GB', 'GBR', 'المملكة المتحدة'),
(94872, 3564564224, 3564564239, 'US', 'USA', 'الولايات المتحدة'),
(94873, 3564564240, 3564565231, 'GB', 'GBR', 'المملكة المتحدة'),
(94874, 3564565232, 3564565239, 'US', 'USA', 'الولايات المتحدة'),
(94875, 3564565240, 3564565247, 'GB', 'GBR', 'المملكة المتحدة'),
(94876, 3564565248, 3564565279, 'US', 'USA', 'الولايات المتحدة'),
(94877, 3564565280, 3564565327, 'GB', 'GBR', 'المملكة المتحدة'),
(94878, 3564565328, 3564565407, 'US', 'USA', 'الولايات المتحدة'),
(94879, 3564565408, 3564566047, 'GB', 'GBR', 'المملكة المتحدة'),
(94880, 3564566048, 3564566079, 'US', 'USA', 'الولايات المتحدة'),
(94881, 3564566080, 3564566143, 'GB', 'GBR', 'المملكة المتحدة'),
(94882, 3564566144, 3564566175, 'US', 'USA', 'الولايات المتحدة'),
(94883, 3564566176, 3564566271, 'GB', 'GBR', 'المملكة المتحدة'),
(94884, 3564566272, 3564566527, 'US', 'USA', 'الولايات المتحدة'),
(94885, 3564566528, 3564567047, 'GB', 'GBR', 'المملكة المتحدة'),
(94886, 3564567048, 3564567055, 'US', 'USA', 'الولايات المتحدة'),
(94887, 3564567056, 3564567143, 'GB', 'GBR', 'المملكة المتحدة'),
(94888, 3564567144, 3564567151, 'US', 'USA', 'الولايات المتحدة'),
(94889, 3564567152, 3564567247, 'GB', 'GBR', 'المملكة المتحدة'),
(94890, 3564567248, 3564567255, 'US', 'USA', 'الولايات المتحدة'),
(94891, 3564567256, 3564567295, 'GB', 'GBR', 'المملكة المتحدة'),
(94892, 3564567296, 3564567423, 'US', 'USA', 'الولايات المتحدة'),
(94893, 3564567424, 3564567807, 'GB', 'GBR', 'المملكة المتحدة'),
(94894, 3564567808, 3564567935, 'US', 'USA', 'الولايات المتحدة'),
(94895, 3564567936, 3564568039, 'GB', 'GBR', 'المملكة المتحدة'),
(94896, 3564568040, 3564568183, 'US', 'USA', 'الولايات المتحدة'),
(94897, 3564568184, 3564568223, 'GB', 'GBR', 'المملكة المتحدة'),
(94898, 3564568224, 3564568231, 'US', 'USA', 'الولايات المتحدة'),
(94899, 3564568232, 3564568255, 'GB', 'GBR', 'المملكة المتحدة'),
(94900, 3564568256, 3564568319, 'US', 'USA', 'الولايات المتحدة'),
(94901, 3564568320, 3564571055, 'GB', 'GBR', 'المملكة المتحدة'),
(94902, 3564571056, 3564571071, 'DE', 'DEU', 'ألمانيا'),
(94903, 3564571072, 3564571135, 'GB', 'GBR', 'المملكة المتحدة'),
(94904, 3564571136, 3564571455, 'FR', 'FRA', 'فرنسا'),
(94905, 3564571456, 3564571479, 'GB', 'GBR', 'المملكة المتحدة'),
(94906, 3564571480, 3564571487, 'FR', 'FRA', 'فرنسا'),
(94907, 3564571488, 3564571511, 'GB', 'GBR', 'المملكة المتحدة'),
(94908, 3564571512, 3564571519, 'FR', 'FRA', 'فرنسا'),
(94909, 3564571520, 3564571567, 'GB', 'GBR', 'المملكة المتحدة'),
(94910, 3564571568, 3564571583, 'FR', 'FRA', 'فرنسا'),
(94911, 3564571584, 3564571591, 'GB', 'GBR', 'المملكة المتحدة'),
(94912, 3564571592, 3564571599, 'FR', 'FRA', 'فرنسا'),
(94913, 3564571600, 3564572271, 'GB', 'GBR', 'المملكة المتحدة'),
(94914, 3564572272, 3564572287, 'DE', 'DEU', 'ألمانيا'),
(94915, 3564572288, 3564576767, 'GB', 'GBR', 'المملكة المتحدة'),
(94916, 3564576768, 3564584959, 'RU', 'RUS', 'الإتحاد الروسي'),
(94917, 3564584960, 3564593151, 'SA', 'SAU', 'السعودية'),
(94918, 3564593152, 3564601343, 'RU', 'RUS', 'الإتحاد الروسي'),
(94919, 3564601344, 3564609535, 'AT', 'AUT', 'النمسا'),
(94920, 3564609536, 3564634111, 'RU', 'RUS', 'الإتحاد الروسي'),
(94921, 3564634112, 3564642303, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(94922, 3564642304, 3564650495, 'CH', 'CHE', 'سويسرا'),
(94923, 3564650496, 3564666879, 'NL', 'NLD', 'هولندا'),
(94924, 3564666880, 3564668943, 'IE', 'IRL', 'إيرلندا'),
(94925, 3564668944, 3564668991, 'GB', 'GBR', 'المملكة المتحدة'),
(94926, 3564668992, 3564669103, 'IE', 'IRL', 'إيرلندا'),
(94927, 3564669104, 3564669119, 'GB', 'GBR', 'المملكة المتحدة'),
(94928, 3564669120, 3564669407, 'IE', 'IRL', 'إيرلندا'),
(94929, 3564669408, 3564669439, 'GB', 'GBR', 'المملكة المتحدة'),
(94930, 3564669440, 3564670207, 'IE', 'IRL', 'إيرلندا'),
(94931, 3564670208, 3564670239, 'GB', 'GBR', 'المملكة المتحدة'),
(94932, 3564670240, 3564673023, 'IE', 'IRL', 'إيرلندا'),
(94933, 3564673024, 3564673055, 'GB', 'GBR', 'المملكة المتحدة'),
(94934, 3564673056, 3564673135, 'IE', 'IRL', 'إيرلندا'),
(94935, 3564673136, 3564673215, 'GB', 'GBR', 'المملكة المتحدة'),
(94936, 3564673216, 3564673407, 'IE', 'IRL', 'إيرلندا'),
(94937, 3564673408, 3564673663, 'GB', 'GBR', 'المملكة المتحدة'),
(94938, 3564673664, 3564673791, 'IE', 'IRL', 'إيرلندا'),
(94939, 3564673792, 3564673807, 'GB', 'GBR', 'المملكة المتحدة'),
(94940, 3564673808, 3564673823, 'IE', 'IRL', 'إيرلندا'),
(94941, 3564673824, 3564673839, 'GB', 'GBR', 'المملكة المتحدة'),
(94942, 3564673840, 3564674047, 'IE', 'IRL', 'إيرلندا'),
(94943, 3564674048, 3564674431, 'GB', 'GBR', 'المملكة المتحدة'),
(94944, 3564674432, 3564675071, 'IE', 'IRL', 'إيرلندا'),
(94945, 3564675072, 3564683263, 'RU', 'RUS', 'الإتحاد الروسي'),
(94946, 3564683264, 3564691455, 'IR', 'IRN', 'إيران'),
(94947, 3564691456, 3564699647, 'GI', 'GIB', 'جبل طارق'),
(94948, 3564699648, 3564716031, 'GB', 'GBR', 'المملكة المتحدة'),
(94949, 3564716032, 3564724223, 'IT', 'ITA', 'إيطاليا'),
(94950, 3564724224, 3564732415, 'NL', 'NLD', 'هولندا'),
(94951, 3564732416, 3564732711, 'GB', 'GBR', 'المملكة المتحدة'),
(94952, 3564732712, 3564732715, 'DE', 'DEU', 'ألمانيا'),
(94953, 3564732716, 3564732927, 'GB', 'GBR', 'المملكة المتحدة'),
(94954, 3564732928, 3564734239, 'DE', 'DEU', 'ألمانيا'),
(94955, 3564734240, 3564734271, 'GB', 'GBR', 'المملكة المتحدة'),
(94956, 3564734272, 3564734287, 'DE', 'DEU', 'ألمانيا'),
(94957, 3564734288, 3564734303, 'GB', 'GBR', 'المملكة المتحدة'),
(94958, 3564734304, 3564734335, 'DE', 'DEU', 'ألمانيا'),
(94959, 3564734336, 3564734431, 'GB', 'GBR', 'المملكة المتحدة'),
(94960, 3564734432, 3564734719, 'DE', 'DEU', 'ألمانيا'),
(94961, 3564734720, 3564734807, 'GB', 'GBR', 'المملكة المتحدة'),
(94962, 3564734808, 3564734815, 'DE', 'DEU', 'ألمانيا'),
(94963, 3564734816, 3564734819, 'GB', 'GBR', 'المملكة المتحدة'),
(94964, 3564734820, 3564735231, 'DE', 'DEU', 'ألمانيا'),
(94965, 3564735232, 3564735487, 'GB', 'GBR', 'المملكة المتحدة'),
(94966, 3564735488, 3564736511, 'DE', 'DEU', 'ألمانيا'),
(94967, 3564736512, 3564736527, 'GB', 'GBR', 'المملكة المتحدة'),
(94968, 3564736528, 3564736583, 'DE', 'DEU', 'ألمانيا'),
(94969, 3564736584, 3564736603, 'GB', 'GBR', 'المملكة المتحدة'),
(94970, 3564736604, 3564736607, 'DE', 'DEU', 'ألمانيا'),
(94971, 3564736608, 3564736611, 'GB', 'GBR', 'المملكة المتحدة'),
(94972, 3564736612, 3564736767, 'DE', 'DEU', 'ألمانيا'),
(94973, 3564736768, 3564736887, 'GB', 'GBR', 'المملكة المتحدة'),
(94974, 3564736888, 3564736895, 'DE', 'DEU', 'ألمانيا'),
(94975, 3564736896, 3564736903, 'GB', 'GBR', 'المملكة المتحدة'),
(94976, 3564736904, 3564736911, 'DE', 'DEU', 'ألمانيا'),
(94977, 3564736912, 3564736959, 'GB', 'GBR', 'المملكة المتحدة'),
(94978, 3564736960, 3564736967, 'DE', 'DEU', 'ألمانيا'),
(94979, 3564736968, 3564736975, 'GB', 'GBR', 'المملكة المتحدة'),
(94980, 3564736976, 3564736991, 'DE', 'DEU', 'ألمانيا'),
(94981, 3564736992, 3564737023, 'GB', 'GBR', 'المملكة المتحدة'),
(94982, 3564737024, 3564737535, 'DE', 'DEU', 'ألمانيا'),
(94983, 3564737536, 3564737791, 'GB', 'GBR', 'المملكة المتحدة'),
(94984, 3564737792, 3564738047, 'DE', 'DEU', 'ألمانيا'),
(94985, 3564738048, 3564738303, 'GB', 'GBR', 'المملكة المتحدة'),
(94986, 3564738304, 3564739327, 'DE', 'DEU', 'ألمانيا'),
(94987, 3564739328, 3564739335, 'GB', 'GBR', 'المملكة المتحدة'),
(94988, 3564739336, 3564739351, 'DE', 'DEU', 'ألمانيا'),
(94989, 3564739352, 3564739391, 'GB', 'GBR', 'المملكة المتحدة'),
(94990, 3564739392, 3564739455, 'DE', 'DEU', 'ألمانيا'),
(94991, 3564739456, 3564739503, 'GB', 'GBR', 'المملكة المتحدة'),
(94992, 3564739504, 3564739519, 'DE', 'DEU', 'ألمانيا'),
(94993, 3564739520, 3564739807, 'GB', 'GBR', 'المملكة المتحدة'),
(94994, 3564739808, 3564739815, 'DE', 'DEU', 'ألمانيا'),
(94995, 3564739816, 3564739823, 'GB', 'GBR', 'المملكة المتحدة'),
(94996, 3564739824, 3564740351, 'DE', 'DEU', 'ألمانيا'),
(94997, 3564740352, 3564740383, 'GB', 'GBR', 'المملكة المتحدة'),
(94998, 3564740384, 3564740415, 'DE', 'DEU', 'ألمانيا'),
(94999, 3564740416, 3564740447, 'GB', 'GBR', 'المملكة المتحدة'),
(95000, 3564740448, 3564740455, 'DE', 'DEU', 'ألمانيا'),
(95001, 3564740456, 3564740459, 'GB', 'GBR', 'المملكة المتحدة'),
(95002, 3564740460, 3564740463, 'DE', 'DEU', 'ألمانيا'),
(95003, 3564740464, 3564740471, 'GB', 'GBR', 'المملكة المتحدة'),
(95004, 3564740472, 3564740479, 'DE', 'DEU', 'ألمانيا'),
(95005, 3564740480, 3564740495, 'GB', 'GBR', 'المملكة المتحدة'),
(95006, 3564740496, 3564740503, 'DE', 'DEU', 'ألمانيا'),
(95007, 3564740504, 3564740527, 'GB', 'GBR', 'المملكة المتحدة'),
(95008, 3564740528, 3564740543, 'DE', 'DEU', 'ألمانيا'),
(95009, 3564740544, 3564740575, 'GB', 'GBR', 'المملكة المتحدة'),
(95010, 3564740576, 3564740591, 'DE', 'DEU', 'ألمانيا'),
(95011, 3564740592, 3564740595, 'GB', 'GBR', 'المملكة المتحدة'),
(95012, 3564740596, 3564740599, 'DE', 'DEU', 'ألمانيا'),
(95013, 3564740600, 3564740603, 'GB', 'GBR', 'المملكة المتحدة'),
(95014, 3564740604, 3564740607, 'DE', 'DEU', 'ألمانيا'),
(95015, 3564740608, 3564748799, 'FR', 'FRA', 'فرنسا'),
(95016, 3564748800, 3564756991, 'GB', 'GBR', 'المملكة المتحدة'),
(95017, 3564756992, 3564765183, 'ES', 'ESP', 'إسبانيا'),
(95018, 3564765184, 3564773375, 'RU', 'RUS', 'الإتحاد الروسي'),
(95019, 3564773376, 3564781567, 'DE', 'DEU', 'ألمانيا'),
(95020, 3564781568, 3564789759, 'LT', 'LTU', 'ليتوانيا'),
(95021, 3564789760, 3564797951, 'ES', 'ESP', 'إسبانيا'),
(95022, 3564797952, 3564806143, 'DE', 'DEU', 'ألمانيا'),
(95023, 3564806144, 3564814335, 'BG', 'BGR', 'بلغاريا'),
(95024, 3564814336, 3564822527, 'PL', 'POL', 'بولندا'),
(95025, 3564830720, 3564838911, 'BE', 'BEL', 'بلجيكا'),
(95026, 3564838912, 3564847103, 'DE', 'DEU', 'ألمانيا'),
(95027, 3564847104, 3564855295, 'IT', 'ITA', 'إيطاليا'),
(95028, 3564855296, 3564862863, 'DE', 'DEU', 'ألمانيا'),
(95029, 3564862864, 3564862871, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(95030, 3564862872, 3564863487, 'DE', 'DEU', 'ألمانيا'),
(95031, 3564863488, 3564880919, 'NL', 'NLD', 'هولندا'),
(95032, 3564880920, 3564880927, 'GB', 'GBR', 'المملكة المتحدة'),
(95033, 3564880928, 3564880935, 'NL', 'NLD', 'هولندا'),
(95034, 3564880936, 3564880943, 'GB', 'GBR', 'المملكة المتحدة'),
(95035, 3564880944, 3564880951, 'NL', 'NLD', 'هولندا'),
(95036, 3564880952, 3564880991, 'GB', 'GBR', 'المملكة المتحدة'),
(95037, 3564880992, 3564881007, 'NL', 'NLD', 'هولندا'),
(95038, 3564881008, 3564881103, 'GB', 'GBR', 'المملكة المتحدة'),
(95039, 3564881104, 3564881151, 'NL', 'NLD', 'هولندا'),
(95040, 3564881152, 3564881183, 'GB', 'GBR', 'المملكة المتحدة'),
(95041, 3564881184, 3564881199, 'NL', 'NLD', 'هولندا'),
(95042, 3564881200, 3564881231, 'GB', 'GBR', 'المملكة المتحدة'),
(95043, 3564881232, 3564881263, 'NL', 'NLD', 'هولندا'),
(95044, 3564881264, 3564881343, 'GB', 'GBR', 'المملكة المتحدة'),
(95045, 3564881344, 3564881359, 'NL', 'NLD', 'هولندا'),
(95046, 3564881360, 3564881375, 'GB', 'GBR', 'المملكة المتحدة'),
(95047, 3564881376, 3564881407, 'NL', 'NLD', 'هولندا'),
(95048, 3564881408, 3564881455, 'GB', 'GBR', 'المملكة المتحدة'),
(95049, 3564881456, 3564881471, 'NL', 'NLD', 'هولندا'),
(95050, 3564881472, 3564881519, 'GB', 'GBR', 'المملكة المتحدة'),
(95051, 3564881520, 3564881551, 'NL', 'NLD', 'هولندا'),
(95052, 3564881552, 3564881599, 'GB', 'GBR', 'المملكة المتحدة'),
(95053, 3564881600, 3564881631, 'NL', 'NLD', 'هولندا'),
(95054, 3564881632, 3564881663, 'GB', 'GBR', 'المملكة المتحدة'),
(95055, 3564881664, 3564881727, 'NL', 'NLD', 'هولندا'),
(95056, 3564881728, 3564881935, 'GB', 'GBR', 'المملكة المتحدة'),
(95057, 3564881936, 3564881939, 'NL', 'NLD', 'هولندا'),
(95058, 3564881940, 3564881983, 'GB', 'GBR', 'المملكة المتحدة'),
(95059, 3564881984, 3564881991, 'NL', 'NLD', 'هولندا'),
(95060, 3564881992, 3564881999, 'GB', 'GBR', 'المملكة المتحدة'),
(95061, 3564882000, 3564882079, 'NL', 'NLD', 'هولندا'),
(95062, 3564882080, 3564882095, 'GB', 'GBR', 'المملكة المتحدة'),
(95063, 3564882096, 3564882119, 'NL', 'NLD', 'هولندا'),
(95064, 3564882120, 3564882127, 'GB', 'GBR', 'المملكة المتحدة'),
(95065, 3564882128, 3564882135, 'NL', 'NLD', 'هولندا'),
(95066, 3564882136, 3564882143, 'GB', 'GBR', 'المملكة المتحدة'),
(95067, 3564882144, 3564882239, 'NL', 'NLD', 'هولندا'),
(95068, 3564882240, 3564882255, 'GB', 'GBR', 'المملكة المتحدة'),
(95069, 3564882256, 3564882271, 'NL', 'NLD', 'هولندا'),
(95070, 3564882272, 3564882335, 'GB', 'GBR', 'المملكة المتحدة'),
(95071, 3564882336, 3564882367, 'NL', 'NLD', 'هولندا'),
(95072, 3564882368, 3564882399, 'GB', 'GBR', 'المملكة المتحدة'),
(95073, 3564882400, 3564882943, 'NL', 'NLD', 'هولندا'),
(95074, 3564882944, 3564883007, 'GB', 'GBR', 'المملكة المتحدة'),
(95075, 3564883008, 3564883039, 'NL', 'NLD', 'هولندا'),
(95076, 3564883040, 3564883071, 'GB', 'GBR', 'المملكة المتحدة'),
(95077, 3564883072, 3564883095, 'NL', 'NLD', 'هولندا'),
(95078, 3564883096, 3564883199, 'GB', 'GBR', 'المملكة المتحدة'),
(95079, 3564883200, 3564883967, 'NL', 'NLD', 'هولندا'),
(95080, 3564883968, 3564884223, 'GB', 'GBR', 'المملكة المتحدة'),
(95081, 3564884224, 3564884235, 'NL', 'NLD', 'هولندا'),
(95082, 3564884236, 3564884239, 'GB', 'GBR', 'المملكة المتحدة'),
(95083, 3564884240, 3564884255, 'NL', 'NLD', 'هولندا'),
(95084, 3564884256, 3564884303, 'GB', 'GBR', 'المملكة المتحدة'),
(95085, 3564884304, 3564884319, 'NL', 'NLD', 'هولندا'),
(95086, 3564884320, 3564884335, 'GB', 'GBR', 'المملكة المتحدة'),
(95087, 3564884336, 3564884343, 'NL', 'NLD', 'هولندا'),
(95088, 3564884344, 3564884359, 'GB', 'GBR', 'المملكة المتحدة'),
(95089, 3564884360, 3564884367, 'NL', 'NLD', 'هولندا'),
(95090, 3564884368, 3564884375, 'GB', 'GBR', 'المملكة المتحدة'),
(95091, 3564884376, 3564884399, 'NL', 'NLD', 'هولندا'),
(95092, 3564884400, 3564884407, 'GB', 'GBR', 'المملكة المتحدة'),
(95093, 3564884408, 3564884415, 'NL', 'NLD', 'هولندا'),
(95094, 3564884416, 3564884431, 'GB', 'GBR', 'المملكة المتحدة'),
(95095, 3564884432, 3564884439, 'NL', 'NLD', 'هولندا'),
(95096, 3564884440, 3564884455, 'GB', 'GBR', 'المملكة المتحدة'),
(95097, 3564884456, 3564884463, 'NL', 'NLD', 'هولندا'),
(95098, 3564884464, 3564885007, 'GB', 'GBR', 'المملكة المتحدة'),
(95099, 3564885008, 3564885031, 'NL', 'NLD', 'هولندا'),
(95100, 3564885032, 3564885087, 'GB', 'GBR', 'المملكة المتحدة'),
(95101, 3564885088, 3564885119, 'NL', 'NLD', 'هولندا'),
(95102, 3564885120, 3564885215, 'GB', 'GBR', 'المملكة المتحدة'),
(95103, 3564885216, 3564885311, 'NL', 'NLD', 'هولندا'),
(95104, 3564885312, 3564885487, 'GB', 'GBR', 'المملكة المتحدة'),
(95105, 3564885488, 3564885495, 'NL', 'NLD', 'هولندا'),
(95106, 3564885496, 3564885519, 'GB', 'GBR', 'المملكة المتحدة'),
(95107, 3564885520, 3564885535, 'NL', 'NLD', 'هولندا'),
(95108, 3564885536, 3564885567, 'GB', 'GBR', 'المملكة المتحدة'),
(95109, 3564885568, 3564885599, 'NL', 'NLD', 'هولندا'),
(95110, 3564885600, 3564885615, 'GB', 'GBR', 'المملكة المتحدة'),
(95111, 3564885616, 3564885631, 'NL', 'NLD', 'هولندا'),
(95112, 3564885632, 3564885647, 'GB', 'GBR', 'المملكة المتحدة'),
(95113, 3564885648, 3564885695, 'NL', 'NLD', 'هولندا'),
(95114, 3564885696, 3564885727, 'GB', 'GBR', 'المملكة المتحدة'),
(95115, 3564885728, 3564885743, 'NL', 'NLD', 'هولندا'),
(95116, 3564885744, 3564885759, 'GB', 'GBR', 'المملكة المتحدة'),
(95117, 3564885760, 3564885775, 'NL', 'NLD', 'هولندا'),
(95118, 3564885776, 3564885791, 'GB', 'GBR', 'المملكة المتحدة'),
(95119, 3564885792, 3564885799, 'NL', 'NLD', 'هولندا'),
(95120, 3564885800, 3564885839, 'GB', 'GBR', 'المملكة المتحدة'),
(95121, 3564885840, 3564885887, 'NL', 'NLD', 'هولندا'),
(95122, 3564885888, 3564885919, 'GB', 'GBR', 'المملكة المتحدة'),
(95123, 3564885920, 3564885935, 'NL', 'NLD', 'هولندا'),
(95124, 3564885936, 3564885951, 'GB', 'GBR', 'المملكة المتحدة'),
(95125, 3564885952, 3564885967, 'NL', 'NLD', 'هولندا'),
(95126, 3564885968, 3564885999, 'GB', 'GBR', 'المملكة المتحدة'),
(95127, 3564886000, 3564886031, 'NL', 'NLD', 'هولندا'),
(95128, 3564886032, 3564886063, 'GB', 'GBR', 'المملكة المتحدة'),
(95129, 3564886064, 3564886079, 'NL', 'NLD', 'هولندا'),
(95130, 3564886080, 3564886127, 'GB', 'GBR', 'المملكة المتحدة'),
(95131, 3564886128, 3564886143, 'NL', 'NLD', 'هولندا'),
(95132, 3564886144, 3564886159, 'GB', 'GBR', 'المملكة المتحدة'),
(95133, 3564886160, 3564886207, 'NL', 'NLD', 'هولندا'),
(95134, 3564886208, 3564886271, 'GB', 'GBR', 'المملكة المتحدة'),
(95135, 3564886272, 3564886279, 'NL', 'NLD', 'هولندا'),
(95136, 3564886280, 3564886287, 'GB', 'GBR', 'المملكة المتحدة'),
(95137, 3564886288, 3564886295, 'NL', 'NLD', 'هولندا'),
(95138, 3564886296, 3564886303, 'GB', 'GBR', 'المملكة المتحدة'),
(95139, 3564886304, 3564886367, 'NL', 'NLD', 'هولندا'),
(95140, 3564886368, 3564886383, 'GB', 'GBR', 'المملكة المتحدة'),
(95141, 3564886384, 3564886415, 'NL', 'NLD', 'هولندا'),
(95142, 3564886416, 3564886431, 'GB', 'GBR', 'المملكة المتحدة'),
(95143, 3564886432, 3564886527, 'NL', 'NLD', 'هولندا'),
(95144, 3564886528, 3564886655, 'GB', 'GBR', 'المملكة المتحدة'),
(95145, 3564886656, 3564886751, 'NL', 'NLD', 'هولندا'),
(95146, 3564886752, 3564886943, 'GB', 'GBR', 'المملكة المتحدة'),
(95147, 3564886944, 3564886951, 'NL', 'NLD', 'هولندا'),
(95148, 3564886952, 3564887039, 'GB', 'GBR', 'المملكة المتحدة'),
(95149, 3564887040, 3564888207, 'NL', 'NLD', 'هولندا'),
(95150, 3564888208, 3564888223, 'GB', 'GBR', 'المملكة المتحدة'),
(95151, 3564888224, 3564888327, 'NL', 'NLD', 'هولندا'),
(95152, 3564888328, 3564888335, 'GB', 'GBR', 'المملكة المتحدة'),
(95153, 3564888336, 3564888367, 'NL', 'NLD', 'هولندا'),
(95154, 3564888368, 3564888383, 'GB', 'GBR', 'المملكة المتحدة'),
(95155, 3564888384, 3564888463, 'NL', 'NLD', 'هولندا'),
(95156, 3564888464, 3564888479, 'DE', 'DEU', 'ألمانيا'),
(95157, 3564888480, 3564888503, 'NL', 'NLD', 'هولندا'),
(95158, 3564888504, 3564888511, 'GB', 'GBR', 'المملكة المتحدة'),
(95159, 3564888512, 3564888527, 'DE', 'DEU', 'ألمانيا'),
(95160, 3564888528, 3564888591, 'NL', 'NLD', 'هولندا'),
(95161, 3564888592, 3564888607, 'GB', 'GBR', 'المملكة المتحدة'),
(95162, 3564888608, 3564888655, 'NL', 'NLD', 'هولندا'),
(95163, 3564888656, 3564888663, 'BE', 'BEL', 'بلجيكا'),
(95164, 3564888664, 3564888671, 'NL', 'NLD', 'هولندا'),
(95165, 3564888672, 3564888735, 'BE', 'BEL', 'بلجيكا'),
(95166, 3564888736, 3564888815, 'NL', 'NLD', 'هولندا'),
(95167, 3564888816, 3564888823, 'GB', 'GBR', 'المملكة المتحدة'),
(95168, 3564888824, 3564888991, 'NL', 'NLD', 'هولندا'),
(95169, 3564888992, 3564889023, 'FR', 'FRA', 'فرنسا'),
(95170, 3564889024, 3564889087, 'NL', 'NLD', 'هولندا'),
(95171, 3564889088, 3564889119, 'GB', 'GBR', 'المملكة المتحدة'),
(95172, 3564889120, 3564889135, 'NL', 'NLD', 'هولندا'),
(95173, 3564889136, 3564889151, 'GB', 'GBR', 'المملكة المتحدة'),
(95174, 3564889152, 3564889167, 'NL', 'NLD', 'هولندا'),
(95175, 3564889168, 3564889199, 'GB', 'GBR', 'المملكة المتحدة'),
(95176, 3564889200, 3564889215, 'NL', 'NLD', 'هولندا'),
(95177, 3564889216, 3564889295, 'GB', 'GBR', 'المملكة المتحدة'),
(95178, 3564889296, 3564889311, 'NL', 'NLD', 'هولندا'),
(95179, 3564889312, 3564889375, 'GB', 'GBR', 'المملكة المتحدة'),
(95180, 3564889376, 3564889631, 'NL', 'NLD', 'هولندا'),
(95181, 3564889632, 3564889647, 'GB', 'GBR', 'المملكة المتحدة'),
(95182, 3564889648, 3564889695, 'NL', 'NLD', 'هولندا'),
(95183, 3564889696, 3564889727, 'DE', 'DEU', 'ألمانيا'),
(95184, 3564889728, 3564889791, 'NL', 'NLD', 'هولندا'),
(95185, 3564889792, 3564889807, 'GB', 'GBR', 'المملكة المتحدة'),
(95186, 3564889808, 3564889839, 'BE', 'BEL', 'بلجيكا'),
(95187, 3564889840, 3564889847, 'NL', 'NLD', 'هولندا'),
(95188, 3564889848, 3564889855, 'GB', 'GBR', 'المملكة المتحدة'),
(95189, 3564889856, 3564889887, 'NL', 'NLD', 'هولندا'),
(95190, 3564889888, 3564889983, 'GB', 'GBR', 'المملكة المتحدة'),
(95191, 3564889984, 3564890111, 'NL', 'NLD', 'هولندا'),
(95192, 3564890112, 3564890143, 'GB', 'GBR', 'المملكة المتحدة'),
(95193, 3564890144, 3564890151, 'NL', 'NLD', 'هولندا'),
(95194, 3564890152, 3564890159, 'GB', 'GBR', 'المملكة المتحدة'),
(95195, 3564890160, 3564890183, 'BE', 'BEL', 'بلجيكا'),
(95196, 3564890184, 3564890191, 'GB', 'GBR', 'المملكة المتحدة'),
(95197, 3564890192, 3564890207, 'NL', 'NLD', 'هولندا'),
(95198, 3564890208, 3564890231, 'GB', 'GBR', 'المملكة المتحدة'),
(95199, 3564890232, 3564890271, 'NL', 'NLD', 'هولندا'),
(95200, 3564890272, 3564890303, 'GB', 'GBR', 'المملكة المتحدة'),
(95201, 3564890304, 3564890367, 'NL', 'NLD', 'هولندا'),
(95202, 3564890368, 3564890399, 'FR', 'FRA', 'فرنسا'),
(95203, 3564890400, 3564890527, 'NL', 'NLD', 'هولندا'),
(95204, 3564890528, 3564890535, 'BE', 'BEL', 'بلجيكا'),
(95205, 3564890536, 3564890579, 'NL', 'NLD', 'هولندا'),
(95206, 3564890580, 3564890591, 'GB', 'GBR', 'المملكة المتحدة'),
(95207, 3564890592, 3564890623, 'NL', 'NLD', 'هولندا'),
(95208, 3564890624, 3564890631, 'GB', 'GBR', 'المملكة المتحدة'),
(95209, 3564890632, 3564890639, 'BE', 'BEL', 'بلجيكا'),
(95210, 3564890640, 3564890655, 'NL', 'NLD', 'هولندا'),
(95211, 3564890656, 3564890671, 'GB', 'GBR', 'المملكة المتحدة'),
(95212, 3564890672, 3564890679, 'NL', 'NLD', 'هولندا'),
(95213, 3564890680, 3564890687, 'GB', 'GBR', 'المملكة المتحدة'),
(95214, 3564890688, 3564890719, 'NL', 'NLD', 'هولندا'),
(95215, 3564890720, 3564890751, 'GB', 'GBR', 'المملكة المتحدة'),
(95216, 3564890752, 3564890783, 'NL', 'NLD', 'هولندا'),
(95217, 3564890784, 3564890799, 'GB', 'GBR', 'المملكة المتحدة'),
(95218, 3564890800, 3564890831, 'NL', 'NLD', 'هولندا'),
(95219, 3564890832, 3564890847, 'BE', 'BEL', 'بلجيكا'),
(95220, 3564890848, 3564890863, 'GB', 'GBR', 'المملكة المتحدة'),
(95221, 3564890864, 3564890879, 'BE', 'BEL', 'بلجيكا'),
(95222, 3564890880, 3564890943, 'NL', 'NLD', 'هولندا'),
(95223, 3564890944, 3564890991, 'BE', 'BEL', 'بلجيكا'),
(95224, 3564890992, 3564891023, 'NL', 'NLD', 'هولندا'),
(95225, 3564891024, 3564892415, 'GB', 'GBR', 'المملكة المتحدة'),
(95226, 3564892416, 3564892495, 'NL', 'NLD', 'هولندا'),
(95227, 3564892496, 3564892511, 'GB', 'GBR', 'المملكة المتحدة'),
(95228, 3564892512, 3564892543, 'NL', 'NLD', 'هولندا'),
(95229, 3564892544, 3564892575, 'GB', 'GBR', 'المملكة المتحدة'),
(95230, 3564892576, 3564892687, 'NL', 'NLD', 'هولندا'),
(95231, 3564892688, 3564892735, 'GB', 'GBR', 'المملكة المتحدة'),
(95232, 3564892736, 3564892751, 'NL', 'NLD', 'هولندا'),
(95233, 3564892752, 3564892767, 'GB', 'GBR', 'المملكة المتحدة'),
(95234, 3564892768, 3564892799, 'NL', 'NLD', 'هولندا'),
(95235, 3564892800, 3564893039, 'GB', 'GBR', 'المملكة المتحدة'),
(95236, 3564893040, 3564893055, 'NL', 'NLD', 'هولندا'),
(95237, 3564893056, 3564893375, 'GB', 'GBR', 'المملكة المتحدة'),
(95238, 3564893376, 3564893759, 'NL', 'NLD', 'هولندا'),
(95239, 3564893760, 3564893951, 'GB', 'GBR', 'المملكة المتحدة'),
(95240, 3564893952, 3564895743, 'NL', 'NLD', 'هولندا'),
(95241, 3564895744, 3564896255, 'GB', 'GBR', 'المملكة المتحدة'),
(95242, 3564896256, 3564904447, 'RU', 'RUS', 'الإتحاد الروسي'),
(95243, 3564904448, 3564912639, 'DE', 'DEU', 'ألمانيا'),
(95244, 3564912640, 3564920831, 'BG', 'BGR', 'بلغاريا'),
(95245, 3564920832, 3564922879, 'ES', 'ESP', 'إسبانيا'),
(95246, 3564922880, 3564923007, 'US', 'USA', 'الولايات المتحدة'),
(95247, 3564923008, 3564923391, 'ES', 'ESP', 'إسبانيا'),
(95248, 3564923392, 3564923647, 'US', 'USA', 'الولايات المتحدة'),
(95249, 3564923648, 3564924927, 'ES', 'ESP', 'إسبانيا'),
(95250, 3564924928, 3564926975, 'US', 'USA', 'الولايات المتحدة'),
(95251, 3564926976, 3564929023, 'RU', 'RUS', 'الإتحاد الروسي'),
(95252, 3564929024, 3564937215, 'AT', 'AUT', 'النمسا'),
(95253, 3564937216, 3564941311, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(95254, 3564941312, 3564945407, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(95255, 3564945408, 3564947175, 'GB', 'GBR', 'المملكة المتحدة'),
(95256, 3564947176, 3564947183, 'FR', 'FRA', 'فرنسا'),
(95257, 3564947184, 3564948063, 'GB', 'GBR', 'المملكة المتحدة'),
(95258, 3564948064, 3564948071, 'IE', 'IRL', 'إيرلندا'),
(95259, 3564948072, 3564948319, 'GB', 'GBR', 'المملكة المتحدة'),
(95260, 3564948320, 3564948351, 'IE', 'IRL', 'إيرلندا'),
(95261, 3564948352, 3564953647, 'GB', 'GBR', 'المملكة المتحدة'),
(95262, 3564953648, 3564953651, 'CH', 'CHE', 'سويسرا'),
(95263, 3564953652, 3564953727, 'GB', 'GBR', 'المملكة المتحدة'),
(95264, 3564953728, 3564953743, 'AT', 'AUT', 'النمسا'),
(95265, 3564953744, 3564953744, 'GB', 'GBR', 'المملكة المتحدة'),
(95266, 3564953745, 3564953759, 'AT', 'AUT', 'النمسا'),
(95267, 3564953760, 3564953791, 'GB', 'GBR', 'المملكة المتحدة'),
(95268, 3564953792, 3564953855, 'AT', 'AUT', 'النمسا'),
(95269, 3564953856, 3564954111, 'GB', 'GBR', 'المملكة المتحدة'),
(95270, 3564954112, 3564954131, 'AT', 'AUT', 'النمسا'),
(95271, 3564954132, 3564954139, 'GB', 'GBR', 'المملكة المتحدة'),
(95272, 3564954140, 3564954143, 'AT', 'AUT', 'النمسا'),
(95273, 3564954144, 3564954155, 'GB', 'GBR', 'المملكة المتحدة'),
(95274, 3564954156, 3564954159, 'AT', 'AUT', 'النمسا'),
(95275, 3564954160, 3564954175, 'DE', 'DEU', 'ألمانيا'),
(95276, 3564954176, 3564954183, 'AT', 'AUT', 'النمسا'),
(95277, 3564954184, 3564954191, 'CH', 'CHE', 'سويسرا'),
(95278, 3564954192, 3564954211, 'AT', 'AUT', 'النمسا'),
(95279, 3564954212, 3564954231, 'GB', 'GBR', 'المملكة المتحدة'),
(95280, 3564954232, 3564954239, 'AT', 'AUT', 'النمسا'),
(95281, 3564954240, 3564954303, 'GB', 'GBR', 'المملكة المتحدة'),
(95282, 3564954304, 3564954311, 'AT', 'AUT', 'النمسا'),
(95283, 3564954312, 3564954367, 'GB', 'GBR', 'المملكة المتحدة'),
(95284, 3564954368, 3564954383, 'AT', 'AUT', 'النمسا'),
(95285, 3564954384, 3564954415, 'GB', 'GBR', 'المملكة المتحدة'),
(95286, 3564954416, 3564954431, 'DE', 'DEU', 'ألمانيا'),
(95287, 3564954432, 3564956160, 'GB', 'GBR', 'المملكة المتحدة'),
(95288, 3564956161, 3564956671, 'AT', 'AUT', 'النمسا'),
(95289, 3564956672, 3564956687, 'GB', 'GBR', 'المملكة المتحدة'),
(95290, 3564956688, 3564956719, 'AT', 'AUT', 'النمسا'),
(95291, 3564956720, 3564956735, 'GB', 'GBR', 'المملكة المتحدة'),
(95292, 3564956736, 3564956751, 'AT', 'AUT', 'النمسا'),
(95293, 3564956752, 3564956767, 'US', 'USA', 'الولايات المتحدة'),
(95294, 3564956768, 3564956855, 'AT', 'AUT', 'النمسا'),
(95295, 3564956856, 3564956903, 'GB', 'GBR', 'المملكة المتحدة'),
(95296, 3564956904, 3564956907, 'AT', 'AUT', 'النمسا'),
(95297, 3564956908, 3564956911, 'CH', 'CHE', 'سويسرا'),
(95298, 3564956912, 3564956927, 'AT', 'AUT', 'النمسا'),
(95299, 3564956928, 3564956967, 'GB', 'GBR', 'المملكة المتحدة'),
(95300, 3564956968, 3564956971, 'CH', 'CHE', 'سويسرا'),
(95301, 3564956972, 3564956975, 'US', 'USA', 'الولايات المتحدة'),
(95302, 3564956976, 3564956979, 'GB', 'GBR', 'المملكة المتحدة'),
(95303, 3564956980, 3564956991, 'AT', 'AUT', 'النمسا'),
(95304, 3564956992, 3564956999, 'GB', 'GBR', 'المملكة المتحدة'),
(95305, 3564957000, 3564957007, 'AT', 'AUT', 'النمسا'),
(95306, 3564957008, 3564957023, 'GB', 'GBR', 'المملكة المتحدة'),
(95307, 3564957024, 3564957039, 'AT', 'AUT', 'النمسا'),
(95308, 3564957040, 3564957087, 'GB', 'GBR', 'المملكة المتحدة'),
(95309, 3564957088, 3564957255, 'AT', 'AUT', 'النمسا'),
(95310, 3564957256, 3564957263, 'GB', 'GBR', 'المملكة المتحدة'),
(95311, 3564957264, 3564957439, 'AT', 'AUT', 'النمسا'),
(95312, 3564957440, 3564957447, 'GB', 'GBR', 'المملكة المتحدة'),
(95313, 3564957448, 3564957455, 'CH', 'CHE', 'سويسرا'),
(95314, 3564957456, 3564957459, 'AT', 'AUT', 'النمسا'),
(95315, 3564957460, 3564957471, 'GB', 'GBR', 'المملكة المتحدة'),
(95316, 3564957472, 3564957499, 'AT', 'AUT', 'النمسا'),
(95317, 3564957500, 3564957503, 'GB', 'GBR', 'المملكة المتحدة'),
(95318, 3564957504, 3564957507, 'AT', 'AUT', 'النمسا'),
(95319, 3564957508, 3564957511, 'GB', 'GBR', 'المملكة المتحدة'),
(95320, 3564957512, 3564957519, 'AT', 'AUT', 'النمسا'),
(95321, 3564957520, 3564957527, 'GB', 'GBR', 'المملكة المتحدة'),
(95322, 3564957528, 3564957531, 'AT', 'AUT', 'النمسا'),
(95323, 3564957532, 3564957547, 'GB', 'GBR', 'المملكة المتحدة'),
(95324, 3564957548, 3564957551, 'AT', 'AUT', 'النمسا'),
(95325, 3564957552, 3564957559, 'GB', 'GBR', 'المملكة المتحدة'),
(95326, 3564957560, 3564957591, 'AT', 'AUT', 'النمسا'),
(95327, 3564957592, 3564957595, 'GB', 'GBR', 'المملكة المتحدة'),
(95328, 3564957596, 3564957599, 'AT', 'AUT', 'النمسا'),
(95329, 3564957600, 3564957607, 'GB', 'GBR', 'المملكة المتحدة'),
(95330, 3564957608, 3564957615, 'AT', 'AUT', 'النمسا'),
(95331, 3564957616, 3564957619, 'GB', 'GBR', 'المملكة المتحدة'),
(95332, 3564957620, 3564957631, 'AT', 'AUT', 'النمسا'),
(95333, 3564957632, 3564957663, 'GB', 'GBR', 'المملكة المتحدة'),
(95334, 3564957664, 3564957671, 'AT', 'AUT', 'النمسا'),
(95335, 3564957672, 3564957679, 'GB', 'GBR', 'المملكة المتحدة'),
(95336, 3564957680, 3564957695, 'AT', 'AUT', 'النمسا'),
(95337, 3564957696, 3564957855, 'GB', 'GBR', 'المملكة المتحدة'),
(95338, 3564957856, 3564957859, 'ES', 'ESP', 'إسبانيا'),
(95339, 3564957860, 3564957863, 'AT', 'AUT', 'النمسا'),
(95340, 3564957864, 3564957867, 'IT', 'ITA', 'إيطاليا'),
(95341, 3564957868, 3564957871, 'AT', 'AUT', 'النمسا'),
(95342, 3564957872, 3564957891, 'GB', 'GBR', 'المملكة المتحدة'),
(95343, 3564957892, 3564957903, 'AT', 'AUT', 'النمسا'),
(95344, 3564957904, 3564957911, 'GB', 'GBR', 'المملكة المتحدة'),
(95345, 3564957912, 3564957919, 'AT', 'AUT', 'النمسا'),
(95346, 3564957920, 3564957951, 'GB', 'GBR', 'المملكة المتحدة'),
(95347, 3564957952, 3564957967, 'AT', 'AUT', 'النمسا'),
(95348, 3564957968, 3564957987, 'GB', 'GBR', 'المملكة المتحدة'),
(95349, 3564957988, 3564958015, 'AT', 'AUT', 'النمسا'),
(95350, 3564958016, 3564958111, 'GB', 'GBR', 'المملكة المتحدة'),
(95351, 3564958112, 3564958143, 'AT', 'AUT', 'النمسا'),
(95352, 3564958144, 3564958147, 'GB', 'GBR', 'المملكة المتحدة'),
(95353, 3564958148, 3564958155, 'AT', 'AUT', 'النمسا'),
(95354, 3564958156, 3564958159, 'GB', 'GBR', 'المملكة المتحدة'),
(95355, 3564958160, 3564958179, 'AT', 'AUT', 'النمسا'),
(95356, 3564958180, 3564958183, 'US', 'USA', 'الولايات المتحدة'),
(95357, 3564958184, 3564958191, 'AT', 'AUT', 'النمسا'),
(95358, 3564958192, 3564958207, 'GB', 'GBR', 'المملكة المتحدة'),
(95359, 3564958208, 3564958463, 'AT', 'AUT', 'النمسا'),
(95360, 3564958464, 3564958487, 'GB', 'GBR', 'المملكة المتحدة'),
(95361, 3564958488, 3564958591, 'AT', 'AUT', 'النمسا'),
(95362, 3564958592, 3564958719, 'GB', 'GBR', 'المملكة المتحدة'),
(95363, 3564958720, 3564958799, 'AT', 'AUT', 'النمسا'),
(95364, 3564958800, 3564958807, 'GB', 'GBR', 'المملكة المتحدة'),
(95365, 3564958808, 3564958847, 'AT', 'AUT', 'النمسا'),
(95366, 3564958848, 3564958911, 'GB', 'GBR', 'المملكة المتحدة'),
(95367, 3564958912, 3564958975, 'AT', 'AUT', 'النمسا'),
(95368, 3564958976, 3564959007, 'NL', 'NLD', 'هولندا'),
(95369, 3564959008, 3564959055, 'AT', 'AUT', 'النمسا'),
(95370, 3564959056, 3564959075, 'GB', 'GBR', 'المملكة المتحدة'),
(95371, 3564959076, 3564959091, 'AT', 'AUT', 'النمسا'),
(95372, 3564959092, 3564959095, 'GB', 'GBR', 'المملكة المتحدة'),
(95373, 3564959096, 3564959103, 'AT', 'AUT', 'النمسا'),
(95374, 3564959104, 3564959119, 'GB', 'GBR', 'المملكة المتحدة'),
(95375, 3564959120, 3564959127, 'AT', 'AUT', 'النمسا'),
(95376, 3564959128, 3564959135, 'GB', 'GBR', 'المملكة المتحدة'),
(95377, 3564959136, 3564959155, 'AT', 'AUT', 'النمسا'),
(95378, 3564959156, 3564959191, 'GB', 'GBR', 'المملكة المتحدة'),
(95379, 3564959192, 3564959195, 'AT', 'AUT', 'النمسا'),
(95380, 3564959196, 3564959199, 'GB', 'GBR', 'المملكة المتحدة'),
(95381, 3564959200, 3564959227, 'AT', 'AUT', 'النمسا'),
(95382, 3564959228, 3564959231, 'GB', 'GBR', 'المملكة المتحدة'),
(95383, 3564959232, 3564959359, 'AT', 'AUT', 'النمسا'),
(95384, 3564959360, 3564959383, 'GB', 'GBR', 'المملكة المتحدة'),
(95385, 3564959384, 3564959391, 'AT', 'AUT', 'النمسا'),
(95386, 3564959392, 3564959399, 'SA', 'SAU', 'السعودية'),
(95387, 3564959400, 3564959407, 'AT', 'AUT', 'النمسا'),
(95388, 3564959408, 3564959423, 'CH', 'CHE', 'سويسرا'),
(95389, 3564959424, 3564959443, 'GB', 'GBR', 'المملكة المتحدة'),
(95390, 3564959444, 3564959451, 'AT', 'AUT', 'النمسا'),
(95391, 3564959452, 3564959455, 'FR', 'FRA', 'فرنسا'),
(95392, 3564959456, 3564959471, 'GB', 'GBR', 'المملكة المتحدة'),
(95393, 3564959472, 3564959479, 'AT', 'AUT', 'النمسا'),
(95394, 3564959480, 3564959487, 'GB', 'GBR', 'المملكة المتحدة'),
(95395, 3564959488, 3564959495, 'AT', 'AUT', 'النمسا'),
(95396, 3564959496, 3564959499, 'GB', 'GBR', 'المملكة المتحدة'),
(95397, 3564959500, 3564959519, 'AT', 'AUT', 'النمسا'),
(95398, 3564959520, 3564959535, 'GB', 'GBR', 'المملكة المتحدة'),
(95399, 3564959536, 3564959551, 'AT', 'AUT', 'النمسا'),
(95400, 3564959552, 3564959567, 'GB', 'GBR', 'المملكة المتحدة'),
(95401, 3564959568, 3564959579, 'AT', 'AUT', 'النمسا'),
(95402, 3564959580, 3564959583, 'GB', 'GBR', 'المملكة المتحدة'),
(95403, 3564959584, 3564959615, 'AT', 'AUT', 'النمسا'),
(95404, 3564959616, 3564959623, 'GB', 'GBR', 'المملكة المتحدة'),
(95405, 3564959624, 3564959639, 'AT', 'AUT', 'النمسا'),
(95406, 3564959640, 3564959655, 'GB', 'GBR', 'المملكة المتحدة'),
(95407, 3564959656, 3564959663, 'CH', 'CHE', 'سويسرا'),
(95408, 3564959664, 3564959679, 'AT', 'AUT', 'النمسا'),
(95409, 3564959680, 3564959695, 'GB', 'GBR', 'المملكة المتحدة'),
(95410, 3564959696, 3564959711, 'AT', 'AUT', 'النمسا'),
(95411, 3564959712, 3564959755, 'GB', 'GBR', 'المملكة المتحدة'),
(95412, 3564959756, 3564959759, 'AT', 'AUT', 'النمسا'),
(95413, 3564959760, 3564959775, 'GB', 'GBR', 'المملكة المتحدة'),
(95414, 3564959776, 3564959807, 'AT', 'AUT', 'النمسا'),
(95415, 3564959808, 3564959839, 'GB', 'GBR', 'المملكة المتحدة'),
(95416, 3564959840, 3564959903, 'AT', 'AUT', 'النمسا'),
(95417, 3564959904, 3564959904, 'GB', 'GBR', 'المملكة المتحدة'),
(95418, 3564959905, 3564959967, 'AT', 'AUT', 'النمسا'),
(95419, 3564959968, 3564959999, 'GB', 'GBR', 'المملكة المتحدة'),
(95420, 3564960000, 3564960127, 'AT', 'AUT', 'النمسا'),
(95421, 3564960128, 3564960135, 'DE', 'DEU', 'ألمانيا'),
(95422, 3564960136, 3564960159, 'GB', 'GBR', 'المملكة المتحدة'),
(95423, 3564960160, 3564960195, 'AT', 'AUT', 'النمسا'),
(95424, 3564960196, 3564960211, 'GB', 'GBR', 'المملكة المتحدة'),
(95425, 3564960212, 3564960223, 'AT', 'AUT', 'النمسا'),
(95426, 3564960224, 3564960231, 'GB', 'GBR', 'المملكة المتحدة'),
(95427, 3564960232, 3564960511, 'AT', 'AUT', 'النمسا'),
(95428, 3564960512, 3564960543, 'GB', 'GBR', 'المملكة المتحدة'),
(95429, 3564960544, 3564960559, 'AT', 'AUT', 'النمسا'),
(95430, 3564960560, 3564960615, 'GB', 'GBR', 'المملكة المتحدة'),
(95431, 3564960616, 3564960623, 'FR', 'FRA', 'فرنسا'),
(95432, 3564960624, 3564960631, 'GB', 'GBR', 'المملكة المتحدة'),
(95433, 3564960632, 3564960639, 'AT', 'AUT', 'النمسا'),
(95434, 3564960640, 3564960767, 'GB', 'GBR', 'المملكة المتحدة'),
(95435, 3564960768, 3564960879, 'AT', 'AUT', 'النمسا'),
(95436, 3564960880, 3564960927, 'GB', 'GBR', 'المملكة المتحدة'),
(95437, 3564960928, 3564960959, 'AT', 'AUT', 'النمسا'),
(95438, 3564960960, 3564960991, 'GB', 'GBR', 'المملكة المتحدة'),
(95439, 3564960992, 3564961007, 'AT', 'AUT', 'النمسا'),
(95440, 3564961008, 3564961023, 'GB', 'GBR', 'المملكة المتحدة'),
(95441, 3564961024, 3564961079, 'AT', 'AUT', 'النمسا'),
(95442, 3564961080, 3564961151, 'GB', 'GBR', 'المملكة المتحدة'),
(95443, 3564961152, 3564961311, 'AT', 'AUT', 'النمسا'),
(95444, 3564961312, 3564961319, 'GB', 'GBR', 'المملكة المتحدة'),
(95445, 3564961320, 3564961791, 'AT', 'AUT', 'النمسا'),
(95446, 3564961792, 3564969983, 'TR', 'TUR', 'تركيا'),
(95447, 3564969984, 3564972607, 'DE', 'DEU', 'ألمانيا'),
(95448, 3564972608, 3564972631, 'AT', 'AUT', 'النمسا'),
(95449, 3564972632, 3564972639, 'LI', 'LIE', 'ليختنشتاين'),
(95450, 3564972640, 3564978175, 'DE', 'DEU', 'ألمانيا'),
(95451, 3564978176, 3564986367, 'GB', 'GBR', 'المملكة المتحدة'),
(95452, 3564986368, 3564994559, 'DE', 'DEU', 'ألمانيا'),
(95453, 3564994560, 3565002751, 'NL', 'NLD', 'هولندا'),
(95454, 3565002752, 3565007247, 'NO', 'NOR', 'النرويج'),
(95455, 3565007248, 3565007251, 'SE', 'SWE', 'السويد'),
(95456, 3565007252, 3565027327, 'NO', 'NOR', 'النرويج'),
(95457, 3565027328, 3565035519, 'PL', 'POL', 'بولندا'),
(95458, 3565035520, 3565043711, 'IE', 'IRL', 'إيرلندا'),
(95459, 3565043712, 3565047807, 'AT', 'AUT', 'النمسا'),
(95460, 3565047808, 3565048063, 'LI', 'LIE', 'ليختنشتاين'),
(95461, 3565048064, 3565051903, 'AT', 'AUT', 'النمسا'),
(95462, 3565060096, 3565068287, 'GB', 'GBR', 'المملكة المتحدة'),
(95463, 3565068288, 3565076479, 'CH', 'CHE', 'سويسرا'),
(95464, 3565076480, 3565084671, 'DE', 'DEU', 'ألمانيا'),
(95465, 3565084672, 3565092863, 'IS', 'ISL', 'أيسلندا'),
(95466, 3565092864, 3565093391, 'GB', 'GBR', 'المملكة المتحدة'),
(95467, 3565093392, 3565093399, 'NO', 'NOR', 'النرويج'),
(95468, 3565093400, 3565096759, 'GB', 'GBR', 'المملكة المتحدة'),
(95469, 3565096760, 3565096767, 'IE', 'IRL', 'إيرلندا'),
(95470, 3565096768, 3565099647, 'GB', 'GBR', 'المملكة المتحدة'),
(95471, 3565099648, 3565099651, 'US', 'USA', 'الولايات المتحدة'),
(95472, 3565099652, 3565101055, 'GB', 'GBR', 'المملكة المتحدة'),
(95473, 3565101056, 3565109247, 'DE', 'DEU', 'ألمانيا'),
(95474, 3565109248, 3565117439, 'PL', 'POL', 'بولندا'),
(95475, 3565117440, 3565125631, 'TR', 'TUR', 'تركيا'),
(95476, 3565125632, 3565158399, 'NL', 'NLD', 'هولندا'),
(95477, 3565158400, 3565223935, 'ES', 'ESP', 'إسبانيا'),
(95478, 3565223936, 3565240319, 'FR', 'FRA', 'فرنسا'),
(95479, 3565240320, 3565248511, 'IE', 'IRL', 'إيرلندا'),
(95480, 3565248512, 3565256703, 'RU', 'RUS', 'الإتحاد الروسي'),
(95481, 3565256704, 3565289471, 'NL', 'NLD', 'هولندا'),
(95482, 3565289472, 3565355007, 'DK', 'DNK', 'الدنيمارك'),
(95483, 3565355008, 3565420543, 'IT', 'ITA', 'إيطاليا'),
(95484, 3565420544, 3565486079, 'GB', 'GBR', 'المملكة المتحدة'),
(95485, 3565486080, 3565486335, 'IE', 'IRL', 'إيرلندا'),
(95486, 3565486336, 3565486975, 'FR', 'FRA', 'فرنسا'),
(95487, 3565486976, 3565487615, 'NL', 'NLD', 'هولندا'),
(95488, 3565487616, 3565487871, 'SE', 'SWE', 'السويد'),
(95489, 3565487872, 3565488383, 'GB', 'GBR', 'المملكة المتحدة'),
(95490, 3565488384, 3565488639, 'ES', 'ESP', 'إسبانيا'),
(95491, 3565488640, 3565488895, 'GB', 'GBR', 'المملكة المتحدة'),
(95492, 3565488896, 3565489535, 'DE', 'DEU', 'ألمانيا'),
(95493, 3565489536, 3565489791, 'GB', 'GBR', 'المملكة المتحدة'),
(95494, 3565489792, 3565489823, 'DE', 'DEU', 'ألمانيا'),
(95495, 3565489824, 3565490175, 'GB', 'GBR', 'المملكة المتحدة'),
(95496, 3565490176, 3565490431, 'NL', 'NLD', 'هولندا'),
(95497, 3565490432, 3565491199, 'GB', 'GBR', 'المملكة المتحدة'),
(95498, 3565491200, 3565491215, 'FR', 'FRA', 'فرنسا'),
(95499, 3565491216, 3565491455, 'GB', 'GBR', 'المملكة المتحدة'),
(95500, 3565491456, 3565491711, 'IT', 'ITA', 'إيطاليا'),
(95501, 3565491712, 3565491839, 'GB', 'GBR', 'المملكة المتحدة'),
(95502, 3565491840, 3565491903, 'IT', 'ITA', 'إيطاليا'),
(95503, 3565491904, 3565491967, 'NL', 'NLD', 'هولندا'),
(95504, 3565491968, 3565492295, 'GB', 'GBR', 'المملكة المتحدة'),
(95505, 3565492296, 3565492303, 'IE', 'IRL', 'إيرلندا'),
(95506, 3565492304, 3565492319, 'GB', 'GBR', 'المملكة المتحدة'),
(95507, 3565492320, 3565492327, 'DE', 'DEU', 'ألمانيا'),
(95508, 3565492328, 3565492335, 'GB', 'GBR', 'المملكة المتحدة'),
(95509, 3565492336, 3565492351, 'FR', 'FRA', 'فرنسا'),
(95510, 3565492352, 3565492479, 'GB', 'GBR', 'المملكة المتحدة'),
(95511, 3565492480, 3565492607, 'NL', 'NLD', 'هولندا'),
(95512, 3565492608, 3565492639, 'GB', 'GBR', 'المملكة المتحدة'),
(95513, 3565492640, 3565492655, 'FR', 'FRA', 'فرنسا'),
(95514, 3565492656, 3565492671, 'GB', 'GBR', 'المملكة المتحدة'),
(95515, 3565492672, 3565492735, 'IT', 'ITA', 'إيطاليا'),
(95516, 3565492736, 3565492991, 'CH', 'CHE', 'سويسرا'),
(95517, 3565492992, 3565493247, 'NL', 'NLD', 'هولندا'),
(95518, 3565493248, 3565493583, 'GB', 'GBR', 'المملكة المتحدة'),
(95519, 3565493584, 3565493591, 'DE', 'DEU', 'ألمانيا'),
(95520, 3565493592, 3565493679, 'GB', 'GBR', 'المملكة المتحدة'),
(95521, 3565493680, 3565493687, 'FR', 'FRA', 'فرنسا'),
(95522, 3565493688, 3565493759, 'GB', 'GBR', 'المملكة المتحدة'),
(95523, 3565493760, 3565493775, 'NL', 'NLD', 'هولندا'),
(95524, 3565493776, 3565493983, 'GB', 'GBR', 'المملكة المتحدة'),
(95525, 3565493984, 3565494055, 'DE', 'DEU', 'ألمانيا'),
(95526, 3565494056, 3565494063, 'GB', 'GBR', 'المملكة المتحدة'),
(95527, 3565494064, 3565494079, 'NL', 'NLD', 'هولندا'),
(95528, 3565494080, 3565494143, 'GB', 'GBR', 'المملكة المتحدة'),
(95529, 3565494144, 3565494271, 'DE', 'DEU', 'ألمانيا'),
(95530, 3565494272, 3565494527, 'IS', 'ISL', 'أيسلندا'),
(95531, 3565494528, 3565494543, 'GB', 'GBR', 'المملكة المتحدة'),
(95532, 3565494544, 3565494551, 'IT', 'ITA', 'إيطاليا'),
(95533, 3565494552, 3565494559, 'DE', 'DEU', 'ألمانيا'),
(95534, 3565494560, 3565494591, 'GB', 'GBR', 'المملكة المتحدة'),
(95535, 3565494592, 3565494655, 'FR', 'FRA', 'فرنسا'),
(95536, 3565494656, 3565494671, 'SE', 'SWE', 'السويد'),
(95537, 3565494672, 3565494687, 'DE', 'DEU', 'ألمانيا'),
(95538, 3565494688, 3565494703, 'SE', 'SWE', 'السويد'),
(95539, 3565494704, 3565494719, 'DK', 'DNK', 'الدنيمارك'),
(95540, 3565494720, 3565494735, 'GB', 'GBR', 'المملكة المتحدة'),
(95541, 3565494736, 3565494743, 'CA', 'CAN', 'كندا'),
(95542, 3565494744, 3565495295, 'GB', 'GBR', 'المملكة المتحدة'),
(95543, 3565495296, 3565496447, 'FR', 'FRA', 'فرنسا'),
(95544, 3565496448, 3565496511, 'DE', 'DEU', 'ألمانيا'),
(95545, 3565496512, 3565496575, 'US', 'USA', 'الولايات المتحدة'),
(95546, 3565496576, 3565496831, 'GB', 'GBR', 'المملكة المتحدة'),
(95547, 3565496832, 3565497087, 'IT', 'ITA', 'إيطاليا'),
(95548, 3565497088, 3565497103, 'GB', 'GBR', 'المملكة المتحدة'),
(95549, 3565497104, 3565497119, 'IE', 'IRL', 'إيرلندا'),
(95550, 3565497120, 3565497151, 'DE', 'DEU', 'ألمانيا'),
(95551, 3565497152, 3565497159, 'IE', 'IRL', 'إيرلندا'),
(95552, 3565497160, 3565497167, 'US', 'USA', 'الولايات المتحدة'),
(95553, 3565497168, 3565497199, 'GB', 'GBR', 'المملكة المتحدة'),
(95554, 3565497200, 3565497207, 'IT', 'ITA', 'إيطاليا'),
(95555, 3565497208, 3565497215, 'GB', 'GBR', 'المملكة المتحدة'),
(95556, 3565497216, 3565497279, 'CZ', 'CZE', 'التشيك'),
(95557, 3565497280, 3565497287, 'NL', 'NLD', 'هولندا'),
(95558, 3565497288, 3565497343, 'GB', 'GBR', 'المملكة المتحدة'),
(95559, 3565497344, 3565497599, 'US', 'USA', 'الولايات المتحدة'),
(95560, 3565497600, 3565497871, 'GB', 'GBR', 'المملكة المتحدة'),
(95561, 3565497872, 3565497887, 'DE', 'DEU', 'ألمانيا'),
(95562, 3565497888, 3565497903, 'GB', 'GBR', 'المملكة المتحدة'),
(95563, 3565497904, 3565497911, 'IE', 'IRL', 'إيرلندا'),
(95564, 3565497912, 3565497919, 'DE', 'DEU', 'ألمانيا'),
(95565, 3565497920, 3565497927, 'PR', 'PRI', 'بورتو ريكو'),
(95566, 3565497928, 3565497951, 'GB', 'GBR', 'المملكة المتحدة'),
(95567, 3565497952, 3565497967, 'US', 'USA', 'الولايات المتحدة'),
(95568, 3565497968, 3565498111, 'GB', 'GBR', 'المملكة المتحدة'),
(95569, 3565498112, 3565498367, 'NL', 'NLD', 'هولندا'),
(95570, 3565498368, 3565498431, 'FR', 'FRA', 'فرنسا'),
(95571, 3565498432, 3565498479, 'US', 'USA', 'الولايات المتحدة'),
(95572, 3565498480, 3565498519, 'GB', 'GBR', 'المملكة المتحدة'),
(95573, 3565498520, 3565498527, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(95574, 3565498528, 3565499815, 'GB', 'GBR', 'المملكة المتحدة'),
(95575, 3565499816, 3565499823, 'FR', 'FRA', 'فرنسا'),
(95576, 3565499824, 3565500479, 'GB', 'GBR', 'المملكة المتحدة'),
(95577, 3565500480, 3565500543, 'DE', 'DEU', 'ألمانيا'),
(95578, 3565500544, 3565500567, 'GB', 'GBR', 'المملكة المتحدة'),
(95579, 3565500568, 3565500575, 'IE', 'IRL', 'إيرلندا'),
(95580, 3565500576, 3565500591, 'GB', 'GBR', 'المملكة المتحدة'),
(95581, 3565500592, 3565500599, 'DE', 'DEU', 'ألمانيا'),
(95582, 3565500600, 3565500607, 'GB', 'GBR', 'المملكة المتحدة'),
(95583, 3565500608, 3565500623, 'FR', 'FRA', 'فرنسا'),
(95584, 3565500624, 3565501095, 'GB', 'GBR', 'المملكة المتحدة'),
(95585, 3565501096, 3565501103, 'FR', 'FRA', 'فرنسا'),
(95586, 3565501104, 3565501119, 'FI', 'FIN', 'فنلندا'),
(95587, 3565501120, 3565501231, 'GB', 'GBR', 'المملكة المتحدة'),
(95588, 3565501232, 3565501247, 'DE', 'DEU', 'ألمانيا'),
(95589, 3565501248, 3565501311, 'GB', 'GBR', 'المملكة المتحدة'),
(95590, 3565501312, 3565501439, 'DE', 'DEU', 'ألمانيا'),
(95591, 3565501440, 3565501679, 'GB', 'GBR', 'المملكة المتحدة'),
(95592, 3565501680, 3565501695, 'IE', 'IRL', 'إيرلندا'),
(95593, 3565501696, 3565502207, 'GB', 'GBR', 'المملكة المتحدة'),
(95594, 3565502208, 3565502239, 'IT', 'ITA', 'إيطاليا'),
(95595, 3565502240, 3565502463, 'GB', 'GBR', 'المملكة المتحدة'),
(95596, 3565502464, 3565503487, 'NL', 'NLD', 'هولندا'),
(95597, 3565503488, 3565503999, 'GB', 'GBR', 'المملكة المتحدة'),
(95598, 3565504000, 3565504511, 'NL', 'NLD', 'هولندا'),
(95599, 3565504512, 3565510655, 'GB', 'GBR', 'المملكة المتحدة'),
(95600, 3565510656, 3565511679, 'NL', 'NLD', 'هولندا'),
(95601, 3565511680, 3565512191, 'CH', 'CHE', 'سويسرا'),
(95602, 3565512192, 3565512703, 'DE', 'DEU', 'ألمانيا'),
(95603, 3565512704, 3565512767, 'GB', 'GBR', 'المملكة المتحدة'),
(95604, 3565512768, 3565512959, 'DE', 'DEU', 'ألمانيا'),
(95605, 3565512960, 3565514111, 'GB', 'GBR', 'المملكة المتحدة'),
(95606, 3565514112, 3565514239, 'DE', 'DEU', 'ألمانيا'),
(95607, 3565514240, 3565514495, 'DK', 'DNK', 'الدنيمارك'),
(95608, 3565514496, 3565518847, 'GB', 'GBR', 'المملكة المتحدة'),
(95609, 3565518848, 3565551615, 'TR', 'TUR', 'تركيا'),
(95610, 3565551616, 3565578495, 'GB', 'GBR', 'المملكة المتحدة'),
(95611, 3565578496, 3565578751, 'CA', 'CAN', 'كندا'),
(95612, 3565578752, 3565641487, 'GB', 'GBR', 'المملكة المتحدة'),
(95613, 3565641488, 3565641503, 'DE', 'DEU', 'ألمانيا'),
(95614, 3565641504, 3565682687, 'GB', 'GBR', 'المملكة المتحدة'),
(95615, 3565682688, 3565688063, 'NL', 'NLD', 'هولندا'),
(95616, 3565688064, 3565688319, 'GB', 'GBR', 'المملكة المتحدة'),
(95617, 3565688320, 3565748223, 'NL', 'NLD', 'هولندا'),
(95618, 3565748224, 3565752407, 'GB', 'GBR', 'المملكة المتحدة'),
(95619, 3565752416, 3565752463, 'GB', 'GBR', 'المملكة المتحدة'),
(95620, 3565752472, 3565752479, 'GB', 'GBR', 'المملكة المتحدة'),
(95621, 3565752488, 3565752535, 'GB', 'GBR', 'المملكة المتحدة'),
(95622, 3565752544, 3565752839, 'GB', 'GBR', 'المملكة المتحدة'),
(95623, 3565752856, 3565752879, 'GB', 'GBR', 'المملكة المتحدة'),
(95624, 3565752888, 3565752983, 'GB', 'GBR', 'المملكة المتحدة'),
(95625, 3565752992, 3565752999, 'GB', 'GBR', 'المملكة المتحدة'),
(95626, 3565753016, 3565753031, 'GB', 'GBR', 'المملكة المتحدة'),
(95627, 3565753040, 3565753071, 'GB', 'GBR', 'المملكة المتحدة'),
(95628, 3565753080, 3565753183, 'GB', 'GBR', 'المملكة المتحدة'),
(95629, 3565753248, 3565753279, 'GB', 'GBR', 'المملكة المتحدة'),
(95630, 3565753344, 3565753791, 'GB', 'GBR', 'المملكة المتحدة'),
(95631, 3565753800, 3565753815, 'GB', 'GBR', 'المملكة المتحدة'),
(95632, 3565753824, 3565753831, 'GB', 'GBR', 'المملكة المتحدة'),
(95633, 3565753840, 3565753847, 'GB', 'GBR', 'المملكة المتحدة'),
(95634, 3565753984, 3565754367, 'GB', 'GBR', 'المملكة المتحدة'),
(95635, 3565754496, 3565754511, 'GB', 'GBR', 'المملكة المتحدة'),
(95636, 3565754624, 3565755263, 'GB', 'GBR', 'المملكة المتحدة'),
(95637, 3565755280, 3565755359, 'GB', 'GBR', 'المملكة المتحدة'),
(95638, 3565755376, 3565755583, 'GB', 'GBR', 'المملكة المتحدة'),
(95639, 3565755648, 3565755695, 'GB', 'GBR', 'المملكة المتحدة'),
(95640, 3565755704, 3565755727, 'GB', 'GBR', 'المملكة المتحدة'),
(95641, 3565755736, 3565755831, 'GB', 'GBR', 'المملكة المتحدة'),
(95642, 3565755840, 3565755847, 'GB', 'GBR', 'المملكة المتحدة'),
(95643, 3565755856, 3565755871, 'GB', 'GBR', 'المملكة المتحدة'),
(95644, 3565755880, 3565755919, 'GB', 'GBR', 'المملكة المتحدة'),
(95645, 3565755928, 3565755935, 'GB', 'GBR', 'المملكة المتحدة'),
(95646, 3565755944, 3565755959, 'GB', 'GBR', 'المملكة المتحدة'),
(95647, 3565755968, 3565755999, 'GB', 'GBR', 'المملكة المتحدة'),
(95648, 3565756008, 3565756063, 'GB', 'GBR', 'المملكة المتحدة'),
(95649, 3565756072, 3565756087, 'GB', 'GBR', 'المملكة المتحدة'),
(95650, 3565756096, 3565756119, 'GB', 'GBR', 'المملكة المتحدة'),
(95651, 3565756136, 3565756159, 'GB', 'GBR', 'المملكة المتحدة'),
(95652, 3565756288, 3565760783, 'GB', 'GBR', 'المملكة المتحدة'),
(95653, 3565760792, 3565760799, 'GB', 'GBR', 'المملكة المتحدة'),
(95654, 3565760808, 3565760823, 'GB', 'GBR', 'المملكة المتحدة'),
(95655, 3565760832, 3565760855, 'GB', 'GBR', 'المملكة المتحدة'),
(95656, 3565760864, 3565760935, 'GB', 'GBR', 'المملكة المتحدة'),
(95657, 3565760944, 3565760967, 'GB', 'GBR', 'المملكة المتحدة'),
(95658, 3565760976, 3565761007, 'GB', 'GBR', 'المملكة المتحدة'),
(95659, 3565761016, 3565761279, 'GB', 'GBR', 'المملكة المتحدة'),
(95660, 3565761344, 3565761535, 'GB', 'GBR', 'المملكة المتحدة'),
(95661, 3565761544, 3565761599, 'GB', 'GBR', 'المملكة المتحدة'),
(95662, 3565761616, 3565761631, 'GB', 'GBR', 'المملكة المتحدة'),
(95663, 3565761640, 3565761647, 'GB', 'GBR', 'المملكة المتحدة'),
(95664, 3565761656, 3565761687, 'GB', 'GBR', 'المملكة المتحدة'),
(95665, 3565761704, 3565761727, 'GB', 'GBR', 'المملكة المتحدة'),
(95666, 3565761752, 3565761783, 'GB', 'GBR', 'المملكة المتحدة'),
(95667, 3565761792, 3565762047, 'GB', 'GBR', 'المملكة المتحدة'),
(95668, 3565762048, 3565762303, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(95669, 3565762560, 3565762815, 'GB', 'GBR', 'المملكة المتحدة'),
(95670, 3565763072, 3565763455, 'GB', 'GBR', 'المملكة المتحدة'),
(95671, 3565763488, 3565763599, 'GB', 'GBR', 'المملكة المتحدة'),
(95672, 3565763616, 3565763671, 'GB', 'GBR', 'المملكة المتحدة'),
(95673, 3565763680, 3565763703, 'GB', 'GBR', 'المملكة المتحدة'),
(95674, 3565763720, 3565763735, 'GB', 'GBR', 'المملكة المتحدة'),
(95675, 3565763744, 3565763751, 'GB', 'GBR', 'المملكة المتحدة'),
(95676, 3565763760, 3565763799, 'GB', 'GBR', 'المملكة المتحدة'),
(95677, 3565763808, 3565763815, 'GB', 'GBR', 'المملكة المتحدة'),
(95678, 3565763832, 3565763839, 'GB', 'GBR', 'المملكة المتحدة'),
(95679, 3565763884, 3565763891, 'GB', 'GBR', 'المملكة المتحدة'),
(95680, 3565764096, 3565764183, 'GB', 'GBR', 'المملكة المتحدة'),
(95681, 3565764192, 3565764207, 'GB', 'GBR', 'المملكة المتحدة'),
(95682, 3565764256, 3565764367, 'GB', 'GBR', 'المملكة المتحدة'),
(95683, 3565764376, 3565764439, 'GB', 'GBR', 'المملكة المتحدة'),
(95684, 3565764448, 3565764455, 'GB', 'GBR', 'المملكة المتحدة'),
(95685, 3565764464, 3565764551, 'GB', 'GBR', 'المملكة المتحدة'),
(95686, 3565764576, 3565766655, 'GB', 'GBR', 'المملكة المتحدة'),
(95687, 3565766912, 3565767167, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(95688, 3565767176, 3565767255, 'GB', 'GBR', 'المملكة المتحدة'),
(95689, 3565767272, 3565767287, 'GB', 'GBR', 'المملكة المتحدة'),
(95690, 3565767296, 3565767351, 'GB', 'GBR', 'المملكة المتحدة'),
(95691, 3565767360, 3565767399, 'GB', 'GBR', 'المملكة المتحدة'),
(95692, 3565767408, 3565767439, 'GB', 'GBR', 'المملكة المتحدة'),
(95693, 3565767456, 3565767487, 'GB', 'GBR', 'المملكة المتحدة'),
(95694, 3565767504, 3565767599, 'GB', 'GBR', 'المملكة المتحدة'),
(95695, 3565767616, 3565767631, 'GB', 'GBR', 'المملكة المتحدة'),
(95696, 3565767680, 3565767999, 'GB', 'GBR', 'المملكة المتحدة'),
(95697, 3565768208, 3565768271, 'GB', 'GBR', 'المملكة المتحدة'),
(95698, 3565768280, 3565768295, 'GB', 'GBR', 'المملكة المتحدة'),
(95699, 3565768312, 3565768335, 'GB', 'GBR', 'المملكة المتحدة'),
(95700, 3565768448, 3565768575, 'GB', 'GBR', 'المملكة المتحدة'),
(95701, 3565768704, 3565768983, 'GB', 'GBR', 'المملكة المتحدة'),
(95702, 3565769216, 3565769471, 'GB', 'GBR', 'المملكة المتحدة'),
(95703, 3565777920, 3565813759, 'GB', 'GBR', 'المملكة المتحدة'),
(95704, 3565813760, 3565879295, 'SA', 'SAU', 'السعودية'),
(95705, 3565879296, 3566010367, 'GB', 'GBR', 'المملكة المتحدة'),
(95706, 3566010368, 3566075903, 'IT', 'ITA', 'إيطاليا'),
(95707, 3566075904, 3566092287, 'NL', 'NLD', 'هولندا'),
(95708, 3566092288, 3566108671, 'LV', 'LVA', 'لاتفيا'),
(95709, 3566108672, 3566141439, 'ES', 'ESP', 'إسبانيا'),
(95710, 3566141440, 3566206975, 'IL', 'ISR', 'إسرائيل'),
(95711, 3566206976, 3566272511, 'DE', 'DEU', 'ألمانيا'),
(95712, 3566272512, 3566338047, 'ES', 'ESP', 'إسبانيا'),
(95713, 3566338048, 3566354431, 'FI', 'FIN', 'فنلندا'),
(95714, 3566354432, 3566370815, 'RO', 'ROM', 'رومانيا'),
(95715, 3566370816, 3566403583, 'TR', 'TUR', 'تركيا'),
(95716, 3566403584, 3566436351, 'CH', 'CHE', 'سويسرا'),
(95717, 3566436352, 3566439615, 'IE', 'IRL', 'إيرلندا'),
(95718, 3566439616, 3566439631, 'GB', 'GBR', 'المملكة المتحدة'),
(95719, 3566439632, 3566469119, 'IE', 'IRL', 'إيرلندا'),
(95720, 3566469120, 3566534655, 'GB', 'GBR', 'المملكة المتحدة'),
(95721, 3566534656, 3566551039, 'DE', 'DEU', 'ألمانيا'),
(95722, 3566551040, 3566574747, 'FI', 'FIN', 'فنلندا'),
(95723, 3566574748, 3566574751, 'SE', 'SWE', 'السويد'),
(95724, 3566574752, 3566600191, 'FI', 'FIN', 'فنلندا'),
(95725, 3566600192, 3566665727, 'IL', 'ISR', 'إسرائيل'),
(95726, 3566665728, 3566723071, 'SE', 'SWE', 'السويد'),
(95727, 3566723072, 3566723327, 'FR', 'FRA', 'فرنسا'),
(95728, 3566723328, 3566739455, 'SE', 'SWE', 'السويد'),
(95729, 3566739456, 3566747647, 'RU', 'RUS', 'الإتحاد الروسي'),
(95730, 3566747648, 3566764031, 'GR', 'GRC', 'اليونان'),
(95731, 3566764032, 3566796799, 'AT', 'AUT', 'النمسا'),
(95732, 3566796800, 3566816511, 'NL', 'NLD', 'هولندا'),
(95733, 3566816512, 3566816767, 'US', 'USA', 'الولايات المتحدة'),
(95734, 3566816768, 3566862335, 'NL', 'NLD', 'هولندا'),
(95735, 3566862336, 3566895103, 'TR', 'TUR', 'تركيا'),
(95736, 3566895104, 3566897279, 'KZ', 'KAZ', 'كازاخستان'),
(95737, 3566897280, 3566897311, 'KG', 'KGZ', 'قيرغيزستان'),
(95738, 3566897312, 3566927871, 'KZ', 'KAZ', 'كازاخستان'),
(95739, 3566927872, 3566960127, 'FR', 'FRA', 'فرنسا'),
(95740, 3566960128, 3566960143, 'GB', 'GBR', 'المملكة المتحدة'),
(95741, 3566960144, 3566993407, 'FR', 'FRA', 'فرنسا'),
(95742, 3566993408, 3567058943, 'TR', 'TUR', 'تركيا'),
(95743, 3567058944, 3567103047, 'FR', 'FRA', 'فرنسا'),
(95744, 3567103048, 3567103055, 'IT', 'ITA', 'إيطاليا'),
(95745, 3567103056, 3567108255, 'FR', 'FRA', 'فرنسا'),
(95746, 3567108256, 3567108263, 'SE', 'SWE', 'السويد'),
(95747, 3567108264, 3567124479, 'FR', 'FRA', 'فرنسا'),
(95748, 3567124992, 3567125023, 'GB', 'GBR', 'المملكة المتحدة'),
(95749, 3567125248, 3567125503, 'GB', 'GBR', 'المملكة المتحدة'),
(95750, 3567126688, 3567126759, 'GB', 'GBR', 'المملكة المتحدة'),
(95751, 3567127552, 3567127807, 'GB', 'GBR', 'المملكة المتحدة'),
(95752, 3567129856, 3567129887, 'GB', 'GBR', 'المملكة المتحدة'),
(95753, 3567130016, 3567130079, 'GB', 'GBR', 'المملكة المتحدة'),
(95754, 3567131384, 3567131647, 'GB', 'GBR', 'المملكة المتحدة'),
(95755, 3567133216, 3567133247, 'GB', 'GBR', 'المملكة المتحدة'),
(95756, 3567133368, 3567133375, 'GB', 'GBR', 'المملكة المتحدة'),
(95757, 3567134208, 3567134335, 'GB', 'GBR', 'المملكة المتحدة'),
(95758, 3567134848, 3567134975, 'GB', 'GBR', 'المملكة المتحدة'),
(95759, 3567136000, 3567136255, 'GB', 'GBR', 'المملكة المتحدة'),
(95760, 3567136512, 3567136575, 'GB', 'GBR', 'المملكة المتحدة'),
(95761, 3567136640, 3567136671, 'GB', 'GBR', 'المملكة المتحدة'),
(95762, 3567136768, 3567136895, 'GB', 'GBR', 'المملكة المتحدة'),
(95763, 3567137024, 3567137279, 'GB', 'GBR', 'المملكة المتحدة'),
(95764, 3567137600, 3567137663, 'GB', 'GBR', 'المملكة المتحدة'),
(95765, 3567137988, 3567137991, 'GB', 'GBR', 'المملكة المتحدة'),
(95766, 3567138000, 3567138003, 'GB', 'GBR', 'المملكة المتحدة'),
(95767, 3567138040, 3567138047, 'GB', 'GBR', 'المملكة المتحدة'),
(95768, 3567140096, 3567140351, 'GB', 'GBR', 'المملكة المتحدة'),
(95769, 3567140864, 3567140927, 'GB', 'GBR', 'المملكة المتحدة'),
(95770, 3567141632, 3567141887, 'GB', 'GBR', 'المملكة المتحدة'),
(95771, 3567142272, 3567142399, 'GB', 'GBR', 'المملكة المتحدة'),
(95772, 3567143432, 3567143439, 'GB', 'GBR', 'المملكة المتحدة'),
(95773, 3567143520, 3567143551, 'GB', 'GBR', 'المملكة المتحدة'),
(95774, 3567143680, 3567143687, 'GB', 'GBR', 'المملكة المتحدة'),
(95775, 3567143872, 3567143935, 'GB', 'GBR', 'المملكة المتحدة'),
(95776, 3567143952, 3567143967, 'GB', 'GBR', 'المملكة المتحدة'),
(95777, 3567144048, 3567144063, 'GB', 'GBR', 'المملكة المتحدة'),
(95778, 3567144172, 3567144175, 'GB', 'GBR', 'المملكة المتحدة'),
(95779, 3567144320, 3567144447, 'GB', 'GBR', 'المملكة المتحدة'),
(95780, 3567144768, 3567144831, 'GB', 'GBR', 'المملكة المتحدة'),
(95781, 3567147528, 3567147535, 'GB', 'GBR', 'المملكة المتحدة'),
(95782, 3567147552, 3567147559, 'GB', 'GBR', 'المملكة المتحدة'),
(95783, 3567147936, 3567147967, 'GB', 'GBR', 'المملكة المتحدة'),
(95784, 3567148520, 3567148527, 'GB', 'GBR', 'المملكة المتحدة'),
(95785, 3567148800, 3567149055, 'GB', 'GBR', 'المملكة المتحدة'),
(95786, 3567149088, 3567149119, 'GB', 'GBR', 'المملكة المتحدة'),
(95787, 3567149904, 3567149911, 'GB', 'GBR', 'المملكة المتحدة'),
(95788, 3567149920, 3567149935, 'GB', 'GBR', 'المملكة المتحدة'),
(95789, 3567151136, 3567151199, 'GB', 'GBR', 'المملكة المتحدة'),
(95790, 3567151232, 3567151263, 'GB', 'GBR', 'المملكة المتحدة'),
(95791, 3567152000, 3567152127, 'GB', 'GBR', 'المملكة المتحدة'),
(95792, 3567152160, 3567152191, 'GB', 'GBR', 'المملكة المتحدة'),
(95793, 3567152256, 3567152383, 'GB', 'GBR', 'المملكة المتحدة'),
(95794, 3567152392, 3567152407, 'GB', 'GBR', 'المملكة المتحدة'),
(95795, 3567152640, 3567152647, 'GB', 'GBR', 'المملكة المتحدة'),
(95796, 3567152664, 3567152671, 'GB', 'GBR', 'المملكة المتحدة'),
(95797, 3567152744, 3567152751, 'GB', 'GBR', 'المملكة المتحدة'),
(95798, 3567152832, 3567152863, 'GB', 'GBR', 'المملكة المتحدة'),
(95799, 3567152960, 3567152991, 'GB', 'GBR', 'المملكة المتحدة'),
(95800, 3567153024, 3567153055, 'GB', 'GBR', 'المملكة المتحدة'),
(95801, 3567153600, 3567153623, 'GB', 'GBR', 'المملكة المتحدة'),
(95802, 3567153648, 3567153663, 'GB', 'GBR', 'المملكة المتحدة'),
(95803, 3567153688, 3567153703, 'GB', 'GBR', 'المملكة المتحدة'),
(95804, 3567153720, 3567153727, 'GB', 'GBR', 'المملكة المتحدة'),
(95805, 3567153824, 3567153847, 'GB', 'GBR', 'المملكة المتحدة'),
(95806, 3567154304, 3567154367, 'GB', 'GBR', 'المملكة المتحدة'),
(95807, 3567155200, 3567155967, 'GB', 'GBR', 'المملكة المتحدة'),
(95808, 3567156416, 3567156607, 'GB', 'GBR', 'المملكة المتحدة'),
(95809, 3567156992, 3567157247, 'GB', 'GBR', 'المملكة المتحدة'),
(95810, 3567157248, 3567165439, 'CZ', 'CZE', 'التشيك'),
(95811, 3567165440, 3567169535, 'RU', 'RUS', 'الإتحاد الروسي'),
(95812, 3567169536, 3567173631, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(95813, 3567173632, 3567239167, 'GB', 'GBR', 'المملكة المتحدة'),
(95814, 3567239168, 3567250143, 'NL', 'NLD', 'هولندا'),
(95815, 3567250176, 3567250943, 'NL', 'NLD', 'هولندا'),
(95816, 3567255552, 3567321087, 'PL', 'POL', 'بولندا'),
(95817, 3567321088, 3567353855, 'GB', 'GBR', 'المملكة المتحدة'),
(95818, 3567353856, 3567386623, 'CH', 'CHE', 'سويسرا'),
(95819, 3567386624, 3567386879, 'GB', 'GBR', 'المملكة المتحدة'),
(95820, 3567386880, 3567386883, 'DE', 'DEU', 'ألمانيا'),
(95821, 3567386884, 3567386975, 'GB', 'GBR', 'المملكة المتحدة'),
(95822, 3567386976, 3567387007, 'DE', 'DEU', 'ألمانيا'),
(95823, 3567387008, 3567387071, 'GB', 'GBR', 'المملكة المتحدة'),
(95824, 3567387072, 3567387391, 'DE', 'DEU', 'ألمانيا'),
(95825, 3567387392, 3567387439, 'GB', 'GBR', 'المملكة المتحدة'),
(95826, 3567387440, 3567387455, 'DE', 'DEU', 'ألمانيا'),
(95827, 3567387456, 3567387487, 'GB', 'GBR', 'المملكة المتحدة'),
(95828, 3567387488, 3567387539, 'DE', 'DEU', 'ألمانيا'),
(95829, 3567387540, 3567387543, 'GB', 'GBR', 'المملكة المتحدة'),
(95830, 3567387544, 3567387547, 'DE', 'DEU', 'ألمانيا'),
(95831, 3567387548, 3567387583, 'GB', 'GBR', 'المملكة المتحدة'),
(95832, 3567387584, 3567388031, 'DE', 'DEU', 'ألمانيا'),
(95833, 3567388032, 3567388159, 'GB', 'GBR', 'المملكة المتحدة'),
(95834, 3567388160, 3567388399, 'DE', 'DEU', 'ألمانيا'),
(95835, 3567388400, 3567388415, 'GB', 'GBR', 'المملكة المتحدة'),
(95836, 3567388416, 3567388479, 'DE', 'DEU', 'ألمانيا'),
(95837, 3567388480, 3567388543, 'GB', 'GBR', 'المملكة المتحدة'),
(95838, 3567388544, 3567388607, 'DE', 'DEU', 'ألمانيا'),
(95839, 3567388608, 3567388671, 'GB', 'GBR', 'المملكة المتحدة'),
(95840, 3567388672, 3567388927, 'CZ', 'CZE', 'التشيك'),
(95841, 3567388928, 3567389183, 'DE', 'DEU', 'ألمانيا'),
(95842, 3567389184, 3567389695, 'GB', 'GBR', 'المملكة المتحدة'),
(95843, 3567389696, 3567390975, 'DE', 'DEU', 'ألمانيا'),
(95844, 3567390976, 3567391107, 'GB', 'GBR', 'المملكة المتحدة'),
(95845, 3567391108, 3567391111, 'DE', 'DEU', 'ألمانيا'),
(95846, 3567391112, 3567391147, 'GB', 'GBR', 'المملكة المتحدة'),
(95847, 3567391148, 3567391151, 'DE', 'DEU', 'ألمانيا'),
(95848, 3567391152, 3567391231, 'GB', 'GBR', 'المملكة المتحدة'),
(95849, 3567391232, 3567391615, 'DE', 'DEU', 'ألمانيا'),
(95850, 3567391616, 3567391759, 'GB', 'GBR', 'المملكة المتحدة'),
(95851, 3567391760, 3567391791, 'DE', 'DEU', 'ألمانيا'),
(95852, 3567391792, 3567391807, 'GB', 'GBR', 'المملكة المتحدة'),
(95853, 3567391808, 3567391839, 'DE', 'DEU', 'ألمانيا'),
(95854, 3567391840, 3567392767, 'GB', 'GBR', 'المملكة المتحدة'),
(95855, 3567392768, 3567393023, 'DE', 'DEU', 'ألمانيا'),
(95856, 3567393024, 3567393279, 'FR', 'FRA', 'فرنسا'),
(95857, 3567393280, 3567393535, 'HU', 'HUN', 'هنغاريا'),
(95858, 3567393536, 3567394975, 'GB', 'GBR', 'المملكة المتحدة'),
(95859, 3567394976, 3567395007, 'DE', 'DEU', 'ألمانيا'),
(95860, 3567395008, 3567395071, 'GB', 'GBR', 'المملكة المتحدة'),
(95861, 3567395072, 3567395327, 'DE', 'DEU', 'ألمانيا'),
(95862, 3567395328, 3567396863, 'GB', 'GBR', 'المملكة المتحدة'),
(95863, 3567396864, 3567397119, 'DE', 'DEU', 'ألمانيا'),
(95864, 3567397120, 3567397375, 'GB', 'GBR', 'المملكة المتحدة'),
(95865, 3567397376, 3567397503, 'ES', 'ESP', 'إسبانيا'),
(95866, 3567397504, 3567397887, 'GB', 'GBR', 'المملكة المتحدة'),
(95867, 3567397888, 3567398143, 'DE', 'DEU', 'ألمانيا'),
(95868, 3567398144, 3567398191, 'GB', 'GBR', 'المملكة المتحدة'),
(95869, 3567398192, 3567398199, 'DE', 'DEU', 'ألمانيا'),
(95870, 3567398200, 3567398655, 'GB', 'GBR', 'المملكة المتحدة'),
(95871, 3567398656, 3567398911, 'DE', 'DEU', 'ألمانيا'),
(95872, 3567398912, 3567398991, 'GB', 'GBR', 'المملكة المتحدة'),
(95873, 3567398992, 3567399031, 'DE', 'DEU', 'ألمانيا'),
(95874, 3567399032, 3567399039, 'GB', 'GBR', 'المملكة المتحدة'),
(95875, 3567399040, 3567399047, 'DE', 'DEU', 'ألمانيا'),
(95876, 3567399048, 3567399071, 'GB', 'GBR', 'المملكة المتحدة'),
(95877, 3567399072, 3567399103, 'DE', 'DEU', 'ألمانيا'),
(95878, 3567399104, 3567399167, 'GB', 'GBR', 'المملكة المتحدة'),
(95879, 3567399168, 3567399263, 'DE', 'DEU', 'ألمانيا'),
(95880, 3567399264, 3567399295, 'GB', 'GBR', 'المملكة المتحدة'),
(95881, 3567399296, 3567399359, 'DE', 'DEU', 'ألمانيا'),
(95882, 3567399360, 3567399423, 'GB', 'GBR', 'المملكة المتحدة'),
(95883, 3567399424, 3567399439, 'DE', 'DEU', 'ألمانيا'),
(95884, 3567399440, 3567399487, 'GB', 'GBR', 'المملكة المتحدة'),
(95885, 3567399488, 3567399679, 'DE', 'DEU', 'ألمانيا'),
(95886, 3567399680, 3567399687, 'GB', 'GBR', 'المملكة المتحدة'),
(95887, 3567399688, 3567399695, 'DE', 'DEU', 'ألمانيا'),
(95888, 3567399696, 3567399743, 'GB', 'GBR', 'المملكة المتحدة'),
(95889, 3567399744, 3567399871, 'DE', 'DEU', 'ألمانيا'),
(95890, 3567399872, 3567399935, 'GB', 'GBR', 'المملكة المتحدة'),
(95891, 3567399936, 3567400447, 'DE', 'DEU', 'ألمانيا'),
(95892, 3567400448, 3567400735, 'GB', 'GBR', 'المملكة المتحدة'),
(95893, 3567400736, 3567400751, 'DE', 'DEU', 'ألمانيا'),
(95894, 3567400752, 3567400959, 'GB', 'GBR', 'المملكة المتحدة'),
(95895, 3567400960, 3567401471, 'DE', 'DEU', 'ألمانيا'),
(95896, 3567401472, 3567401503, 'GB', 'GBR', 'المملكة المتحدة'),
(95897, 3567401504, 3567401519, 'DE', 'DEU', 'ألمانيا'),
(95898, 3567401520, 3567401543, 'GB', 'GBR', 'المملكة المتحدة'),
(95899, 3567401544, 3567401551, 'DE', 'DEU', 'ألمانيا'),
(95900, 3567401552, 3567401727, 'GB', 'GBR', 'المملكة المتحدة'),
(95901, 3567401728, 3567402367, 'DE', 'DEU', 'ألمانيا'),
(95902, 3567402368, 3567402495, 'GB', 'GBR', 'المملكة المتحدة'),
(95903, 3567402496, 3567403007, 'DE', 'DEU', 'ألمانيا'),
(95904, 3567403008, 3567419391, 'IT', 'ITA', 'إيطاليا'),
(95905, 3567419392, 3567427583, 'SA', 'SAU', 'السعودية'),
(95906, 3567427584, 3567435775, 'SE', 'SWE', 'السويد'),
(95907, 3567435776, 3567436543, 'GB', 'GBR', 'المملكة المتحدة'),
(95908, 3567436544, 3567436595, 'IN', 'IND', 'الهند'),
(95909, 3567436596, 3567436599, 'GB', 'GBR', 'المملكة المتحدة'),
(95910, 3567436600, 3567436603, 'IN', 'IND', 'الهند'),
(95911, 3567436604, 3567436799, 'GB', 'GBR', 'المملكة المتحدة'),
(95912, 3567436800, 3567436895, 'IN', 'IND', 'الهند'),
(95913, 3567436896, 3567441375, 'GB', 'GBR', 'المملكة المتحدة'),
(95914, 3567441376, 3567441407, 'NL', 'NLD', 'هولندا'),
(95915, 3567441408, 3567444223, 'GB', 'GBR', 'المملكة المتحدة'),
(95916, 3567444224, 3567444479, 'TZ', 'TZA', 'تانزانيا'),
(95917, 3567444480, 3567445951, 'GB', 'GBR', 'المملكة المتحدة'),
(95918, 3567445952, 3567445983, 'NL', 'NLD', 'هولندا'),
(95919, 3567445984, 3567452031, 'GB', 'GBR', 'المملكة المتحدة'),
(95920, 3567452032, 3567452047, 'GR', 'GRC', 'اليونان'),
(95921, 3567452048, 3567452159, 'GB', 'GBR', 'المملكة المتحدة'),
(95922, 3567452160, 3567507455, 'ES', 'ESP', 'إسبانيا'),
(95923, 3567507456, 3567509503, 'NL', 'NLD', 'هولندا'),
(95924, 3567509504, 3567512575, 'ES', 'ESP', 'إسبانيا'),
(95925, 3567512576, 3567513599, 'NL', 'NLD', 'هولندا'),
(95926, 3567513600, 3567517695, 'ES', 'ESP', 'إسبانيا'),
(95927, 3567517696, 3567583231, 'RU', 'RUS', 'الإتحاد الروسي'),
(95928, 3567583232, 3567583487, 'AT', 'AUT', 'النمسا'),
(95929, 3567583744, 3567583871, 'AT', 'AUT', 'النمسا'),
(95930, 3567583936, 3567583999, 'AT', 'AUT', 'النمسا'),
(95931, 3567584256, 3567584383, 'AT', 'AUT', 'النمسا'),
(95932, 3567584400, 3567584407, 'AT', 'AUT', 'النمسا'),
(95933, 3567584512, 3567584639, 'AT', 'AUT', 'النمسا'),
(95934, 3567585792, 3567586303, 'GB', 'GBR', 'المملكة المتحدة'),
(95935, 3567587328, 3567591423, 'GB', 'GBR', 'المملكة المتحدة'),
(95936, 3567591424, 3567599615, 'IT', 'ITA', 'إيطاليا'),
(95937, 3567599616, 3567615999, 'NL', 'NLD', 'هولندا'),
(95938, 3567616000, 3567616511, 'BD', 'BGD', 'بنغالاديش'),
(95939, 3567616512, 3567617087, 'GB', 'GBR', 'المملكة المتحدة'),
(95940, 3567617088, 3567617119, 'NG', 'NGA', 'نيجيريا'),
(95941, 3567617120, 3567617151, 'GB', 'GBR', 'المملكة المتحدة'),
(95942, 3567617152, 3567617279, 'NG', 'NGA', 'نيجيريا'),
(95943, 3567617280, 3567617535, 'IN', 'IND', 'الهند'),
(95944, 3567617536, 3567617791, 'KE', 'KEN', 'كينيا'),
(95945, 3567617792, 3567618047, 'NG', 'NGA', 'نيجيريا'),
(95946, 3567618048, 3567619071, 'IN', 'IND', 'الهند'),
(95947, 3567619072, 3567619075, 'NG', 'NGA', 'نيجيريا'),
(95948, 3567619076, 3567619087, 'GB', 'GBR', 'المملكة المتحدة'),
(95949, 3567619088, 3567619095, 'NG', 'NGA', 'نيجيريا'),
(95950, 3567619096, 3567619103, 'GB', 'GBR', 'المملكة المتحدة'),
(95951, 3567619104, 3567619111, 'KE', 'KEN', 'كينيا'),
(95952, 3567619112, 3567619135, 'GB', 'GBR', 'المملكة المتحدة'),
(95953, 3567619136, 3567619583, 'NG', 'NGA', 'نيجيريا'),
(95954, 3567619584, 3567620095, 'TZ', 'TZA', 'تانزانيا'),
(95955, 3567620096, 3567620351, 'GB', 'GBR', 'المملكة المتحدة'),
(95956, 3567620352, 3567620479, 'TZ', 'TZA', 'تانزانيا'),
(95957, 3567620480, 3567620623, 'GB', 'GBR', 'المملكة المتحدة'),
(95958, 3567620624, 3567620631, 'PK', 'PAK', 'باكستان'),
(95959, 3567620632, 3567620639, 'IN', 'IND', 'الهند'),
(95960, 3567620640, 3567620679, 'PK', 'PAK', 'باكستان'),
(95961, 3567620680, 3567620695, 'GB', 'GBR', 'المملكة المتحدة'),
(95962, 3567620696, 3567620719, 'PK', 'PAK', 'باكستان'),
(95963, 3567620720, 3567620727, 'GB', 'GBR', 'المملكة المتحدة'),
(95964, 3567620728, 3567620735, 'IN', 'IND', 'الهند'),
(95965, 3567620736, 3567620863, 'GB', 'GBR', 'المملكة المتحدة'),
(95966, 3567620864, 3567620927, 'NG', 'NGA', 'نيجيريا'),
(95967, 3567620928, 3567620931, 'GB', 'GBR', 'المملكة المتحدة'),
(95968, 3567620932, 3567620935, 'TZ', 'TZA', 'تانزانيا'),
(95969, 3567620936, 3567620959, 'KE', 'KEN', 'كينيا'),
(95970, 3567620960, 3567620991, 'GB', 'GBR', 'المملكة المتحدة'),
(95971, 3567620992, 3567621055, 'NG', 'NGA', 'نيجيريا'),
(95972, 3567621056, 3567621119, 'KE', 'KEN', 'كينيا'),
(95973, 3567621120, 3567621631, 'GB', 'GBR', 'المملكة المتحدة'),
(95974, 3567621632, 3567621887, 'ID', 'IDN', 'إندونيسيا'),
(95975, 3567621888, 3567621895, 'TZ', 'TZA', 'تانزانيا'),
(95976, 3567621896, 3567621903, 'KE', 'KEN', 'كينيا'),
(95977, 3567621904, 3567621911, 'NG', 'NGA', 'نيجيريا'),
(95978, 3567621912, 3567621919, 'TZ', 'TZA', 'تانزانيا'),
(95979, 3567621920, 3567621951, 'NG', 'NGA', 'نيجيريا'),
(95980, 3567621952, 3567622655, 'GB', 'GBR', 'المملكة المتحدة'),
(95981, 3567622656, 3567622951, 'KE', 'KEN', 'كينيا'),
(95982, 3567622952, 3567622959, 'GB', 'GBR', 'المملكة المتحدة'),
(95983, 3567622960, 3567622963, 'TZ', 'TZA', 'تانزانيا'),
(95984, 3567622964, 3567622967, 'NG', 'NGA', 'نيجيريا'),
(95985, 3567622968, 3567622975, 'GB', 'GBR', 'المملكة المتحدة'),
(95986, 3567622976, 3567623039, 'TZ', 'TZA', 'تانزانيا'),
(95987, 3567623040, 3567623055, 'GA', 'GAB', 'الغابون'),
(95988, 3567623056, 3567623071, 'NG', 'NGA', 'نيجيريا'),
(95989, 3567623072, 3567623087, 'TZ', 'TZA', 'تانزانيا'),
(95990, 3567623088, 3567623095, 'GB', 'GBR', 'المملكة المتحدة'),
(95991, 3567623096, 3567623103, 'GA', 'GAB', 'الغابون'),
(95992, 3567623104, 3567623135, 'TZ', 'TZA', 'تانزانيا'),
(95993, 3567623136, 3567623143, 'GB', 'GBR', 'المملكة المتحدة'),
(95994, 3567623144, 3567623151, 'TZ', 'TZA', 'تانزانيا'),
(95995, 3567623152, 3567623167, 'GB', 'GBR', 'المملكة المتحدة'),
(95996, 3567623168, 3567623423, 'KE', 'KEN', 'كينيا'),
(95997, 3567623424, 3567623471, 'GB', 'GBR', 'المملكة المتحدة'),
(95998, 3567623472, 3567623479, 'KE', 'KEN', 'كينيا'),
(95999, 3567623480, 3567623727, 'GB', 'GBR', 'المملكة المتحدة'),
(96000, 3567623728, 3567623759, 'PK', 'PAK', 'باكستان'),
(96001, 3567623760, 3567623767, 'GB', 'GBR', 'المملكة المتحدة'),
(96002, 3567623768, 3567623775, 'PK', 'PAK', 'باكستان'),
(96003, 3567623776, 3567623791, 'GB', 'GBR', 'المملكة المتحدة'),
(96004, 3567623792, 3567623839, 'PK', 'PAK', 'باكستان'),
(96005, 3567623840, 3567623935, 'GB', 'GBR', 'المملكة المتحدة'),
(96006, 3567623936, 3567624191, 'PK', 'PAK', 'باكستان'),
(96007, 3567624192, 3567624447, 'GB', 'GBR', 'المملكة المتحدة'),
(96008, 3567624448, 3567625727, 'TZ', 'TZA', 'تانزانيا'),
(96009, 3567625728, 3567625983, 'CG', 'COG', 'الكونغو'),
(96010, 3567625984, 3567626239, 'KE', 'KEN', 'كينيا'),
(96011, 3567626240, 3567627008, 'NG', 'NGA', 'نيجيريا'),
(96012, 3567627009, 3567629311, 'GB', 'GBR', 'المملكة المتحدة'),
(96013, 3567629312, 3567630207, 'TJ', 'TJK', 'طاجيكيستان'),
(96014, 3567630208, 3567648767, 'GB', 'GBR', 'المملكة المتحدة'),
(96015, 3567648768, 3567665151, 'BE', 'BEL', 'بلجيكا'),
(96016, 3567665152, 3567673343, 'ES', 'ESP', 'إسبانيا'),
(96017, 3567673344, 3567673647, 'AT', 'AUT', 'النمسا'),
(96018, 3567673648, 3567673655, 'GI', 'GIB', 'جبل طارق'),
(96019, 3567673656, 3567681535, 'AT', 'AUT', 'النمسا'),
(96020, 3567681536, 3567714303, 'ES', 'ESP', 'إسبانيا'),
(96021, 3567714304, 3567715327, 'GB', 'GBR', 'المملكة المتحدة'),
(96022, 3567715584, 3567715839, 'GB', 'GBR', 'المملكة المتحدة'),
(96023, 3567716352, 3567716383, 'GB', 'GBR', 'المملكة المتحدة'),
(96024, 3567716608, 3567716639, 'IL', 'ISR', 'إسرائيل'),
(96025, 3567716944, 3567717119, 'GB', 'GBR', 'المملكة المتحدة'),
(96026, 3567717120, 3567717375, 'DE', 'DEU', 'ألمانيا'),
(96027, 3567717376, 3567717631, 'GB', 'GBR', 'المملكة المتحدة'),
(96028, 3567717632, 3567717679, 'DE', 'DEU', 'ألمانيا'),
(96029, 3567717760, 3567717887, 'DE', 'DEU', 'ألمانيا'),
(96030, 3567717888, 3567718015, 'GB', 'GBR', 'المملكة المتحدة'),
(96031, 3567718144, 3567718399, 'CH', 'CHE', 'سويسرا'),
(96032, 3567718400, 3567719423, 'US', 'USA', 'الولايات المتحدة'),
(96033, 3567719424, 3567719679, 'GB', 'GBR', 'المملكة المتحدة'),
(96034, 3567779840, 3567845375, 'DE', 'DEU', 'ألمانيا'),
(96035, 3567845376, 3567861759, 'GB', 'GBR', 'المملكة المتحدة'),
(96036, 3567861760, 3567878143, 'NO', 'NOR', 'النرويج'),
(96037, 3567878144, 3567976447, 'ES', 'ESP', 'إسبانيا'),
(96038, 3567976448, 3568041983, 'IT', 'ITA', 'إيطاليا'),
(96039, 3568041984, 3568107519, 'DE', 'DEU', 'ألمانيا'),
(96040, 3568107520, 3568153759, 'GB', 'GBR', 'المملكة المتحدة'),
(96041, 3568153760, 3568153767, 'CH', 'CHE', 'سويسرا'),
(96042, 3568153768, 3568173055, 'GB', 'GBR', 'المملكة المتحدة'),
(96043, 3568173056, 3568304127, 'TR', 'TUR', 'تركيا'),
(96044, 3568304128, 3568309775, 'RU', 'RUS', 'الإتحاد الروسي'),
(96045, 3568309776, 3568309791, 'UZ', 'UZB', 'أوزباكستان'),
(96046, 3568309792, 3568309919, 'BY', 'BLR', 'روسيا البيضاء'),
(96047, 3568309920, 3568309951, 'RU', 'RUS', 'الإتحاد الروسي'),
(96048, 3568309952, 3568310015, 'BY', 'BLR', 'روسيا البيضاء'),
(96049, 3568310016, 3568369663, 'RU', 'RUS', 'الإتحاد الروسي'),
(96050, 3568369664, 3568435199, 'IT', 'ITA', 'إيطاليا'),
(96051, 3568435200, 3568443391, 'UA', 'UKR', 'أوكرانيا'),
(96052, 3568443392, 3568476159, 'NL', 'NLD', 'هولندا'),
(96053, 3568476160, 3568484351, 'DK', 'DNK', 'الدنيمارك'),
(96054, 3568484352, 3568492543, 'NL', 'NLD', 'هولندا'),
(96055, 3568492544, 3568493055, 'RS', 'SRB', 'صربيا'),
(96056, 3568493056, 3568493567, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96057, 3568493568, 3568494591, 'RS', 'SRB', 'صربيا'),
(96058, 3568494592, 3568496639, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96059, 3568496640, 3568498687, 'RS', 'SRB', 'صربيا'),
(96060, 3568498688, 3568498943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96061, 3568498944, 3568500735, 'RS', 'SRB', 'صربيا'),
(96062, 3568500736, 3568566271, 'IL', 'ISR', 'إسرائيل'),
(96063, 3568566272, 3568599039, 'FR', 'FRA', 'فرنسا'),
(96064, 3568599040, 3568631807, 'PL', 'POL', 'بولندا'),
(96065, 3568631808, 3568697343, 'SE', 'SWE', 'السويد'),
(96066, 3568697344, 3568730111, 'PL', 'POL', 'بولندا'),
(96067, 3568730112, 3568746495, 'NL', 'NLD', 'هولندا'),
(96068, 3568746496, 3568752895, 'FI', 'FIN', 'فنلندا'),
(96069, 3568752896, 3568752959, 'EE', 'EST', 'إستونيا'),
(96070, 3568752960, 3568762879, 'FI', 'FIN', 'فنلندا'),
(96071, 3568762880, 3568795647, 'AT', 'AUT', 'النمسا'),
(96072, 3568795648, 3568803839, 'GB', 'GBR', 'المملكة المتحدة'),
(96073, 3568803840, 3568812031, 'IT', 'ITA', 'إيطاليا'),
(96074, 3568812032, 3568828415, 'ES', 'ESP', 'إسبانيا'),
(96075, 3568828416, 3568829631, 'DE', 'DEU', 'ألمانيا'),
(96076, 3568829632, 3568829639, 'CH', 'CHE', 'سويسرا'),
(96077, 3568829640, 3568848791, 'DE', 'DEU', 'ألمانيا'),
(96078, 3568848792, 3568848799, 'PL', 'POL', 'بولندا'),
(96079, 3568848800, 3568848871, 'DE', 'DEU', 'ألمانيا'),
(96080, 3568848872, 3568848879, 'GB', 'GBR', 'المملكة المتحدة'),
(96081, 3568848880, 3568876159, 'DE', 'DEU', 'ألمانيا'),
(96082, 3568876160, 3568876287, 'ES', 'ESP', 'إسبانيا'),
(96083, 3568876288, 3568916399, 'DE', 'DEU', 'ألمانيا'),
(96084, 3568916400, 3568916407, 'IT', 'ITA', 'إيطاليا'),
(96085, 3568916408, 3568938311, 'DE', 'DEU', 'ألمانيا'),
(96086, 3568938312, 3568938319, 'FI', 'FIN', 'فنلندا'),
(96087, 3568938320, 3568939519, 'DE', 'DEU', 'ألمانيا'),
(96088, 3568939520, 3568939527, 'IT', 'ITA', 'إيطاليا'),
(96089, 3568939528, 3568959487, 'DE', 'DEU', 'ألمانيا'),
(96090, 3568959488, 3569025023, 'AT', 'AUT', 'النمسا'),
(96091, 3569025024, 3569057791, 'NL', 'NLD', 'هولندا'),
(96092, 3569057792, 3569068415, 'GB', 'GBR', 'المملكة المتحدة'),
(96093, 3569068416, 3569068543, 'DE', 'DEU', 'ألمانيا'),
(96094, 3569068544, 3569068671, 'BG', 'BGR', 'بلغاريا'),
(96095, 3569068672, 3569068951, 'GB', 'GBR', 'المملكة المتحدة'),
(96096, 3569068952, 3569068991, 'DE', 'DEU', 'ألمانيا'),
(96097, 3569068992, 3569075711, 'GB', 'GBR', 'المملكة المتحدة'),
(96098, 3569075712, 3569075839, 'FR', 'FRA', 'فرنسا'),
(96099, 3569075840, 3569083903, 'GB', 'GBR', 'المملكة المتحدة'),
(96100, 3569083904, 3569084159, 'US', 'USA', 'الولايات المتحدة'),
(96101, 3569084160, 3569090559, 'GB', 'GBR', 'المملكة المتحدة'),
(96102, 3569090560, 3569123327, 'RU', 'RUS', 'الإتحاد الروسي'),
(96103, 3569123328, 3569156095, 'GB', 'GBR', 'المملكة المتحدة'),
(96104, 3569156096, 3569188863, 'NL', 'NLD', 'هولندا'),
(96105, 3569188864, 3569221631, 'IT', 'ITA', 'إيطاليا'),
(96106, 3569221632, 3569238399, 'BE', 'BEL', 'بلجيكا'),
(96107, 3569238400, 3569238527, 'AT', 'AUT', 'النمسا'),
(96108, 3569238528, 3569239071, 'BE', 'BEL', 'بلجيكا'),
(96109, 3569239072, 3569239103, 'LU', 'LUX', 'لوكسيمبورغ'),
(96110, 3569239104, 3569239231, 'BE', 'BEL', 'بلجيكا'),
(96111, 3569239232, 3569239263, 'LU', 'LUX', 'لوكسيمبورغ'),
(96112, 3569239264, 3569239519, 'BE', 'BEL', 'بلجيكا'),
(96113, 3569239520, 3569239551, 'LU', 'LUX', 'لوكسيمبورغ'),
(96114, 3569239552, 3569239983, 'BE', 'BEL', 'بلجيكا'),
(96115, 3569239984, 3569239999, 'BN', 'BRN', 'بروناي دار السلام'),
(96116, 3569240000, 3569240031, 'BE', 'BEL', 'بلجيكا'),
(96117, 3569240032, 3569240063, 'FR', 'FRA', 'فرنسا'),
(96118, 3569240064, 3569241583, 'BE', 'BEL', 'بلجيكا'),
(96119, 3569241584, 3569241599, 'LU', 'LUX', 'لوكسيمبورغ'),
(96120, 3569241600, 3569241887, 'BE', 'BEL', 'بلجيكا'),
(96121, 3569241888, 3569241903, 'LU', 'LUX', 'لوكسيمبورغ'),
(96122, 3569241904, 3569242047, 'BE', 'BEL', 'بلجيكا'),
(96123, 3569242048, 3569242111, 'LU', 'LUX', 'لوكسيمبورغ'),
(96124, 3569242112, 3569242551, 'BE', 'BEL', 'بلجيكا'),
(96125, 3569242552, 3569242559, 'LU', 'LUX', 'لوكسيمبورغ'),
(96126, 3569242560, 3569242879, 'BE', 'BEL', 'بلجيكا'),
(96127, 3569242880, 3569243135, 'US', 'USA', 'الولايات المتحدة'),
(96128, 3569243136, 3569243903, 'BE', 'BEL', 'بلجيكا'),
(96129, 3569243904, 3569244031, 'NL', 'NLD', 'هولندا'),
(96130, 3569244032, 3569244303, 'BE', 'BEL', 'بلجيكا'),
(96131, 3569244304, 3569244319, 'LU', 'LUX', 'لوكسيمبورغ'),
(96132, 3569244320, 3569245695, 'BE', 'BEL', 'بلجيكا'),
(96133, 3569245696, 3569245727, 'LU', 'LUX', 'لوكسيمبورغ'),
(96134, 3569245728, 3569250879, 'BE', 'BEL', 'بلجيكا'),
(96135, 3569250880, 3569250895, 'LU', 'LUX', 'لوكسيمبورغ'),
(96136, 3569250896, 3569251071, 'BE', 'BEL', 'بلجيكا'),
(96137, 3569251072, 3569251327, 'LU', 'LUX', 'لوكسيمبورغ'),
(96138, 3569251328, 3569251839, 'US', 'USA', 'الولايات المتحدة'),
(96139, 3569251840, 3569252991, 'BE', 'BEL', 'بلجيكا'),
(96140, 3569252992, 3569253007, 'LU', 'LUX', 'لوكسيمبورغ'),
(96141, 3569253008, 3569253095, 'BE', 'BEL', 'بلجيكا'),
(96142, 3569253096, 3569253103, 'LU', 'LUX', 'لوكسيمبورغ'),
(96143, 3569253104, 3569254911, 'BE', 'BEL', 'بلجيكا'),
(96144, 3569254912, 3569254943, 'LU', 'LUX', 'لوكسيمبورغ'),
(96145, 3569254944, 3569255007, 'BE', 'BEL', 'بلجيكا'),
(96146, 3569255008, 3569255055, 'LU', 'LUX', 'لوكسيمبورغ'),
(96147, 3569255056, 3569255071, 'BE', 'BEL', 'بلجيكا'),
(96148, 3569255072, 3569255103, 'LU', 'LUX', 'لوكسيمبورغ'),
(96149, 3569255104, 3569258815, 'BE', 'BEL', 'بلجيكا'),
(96150, 3569258816, 3569258847, 'US', 'USA', 'الولايات المتحدة'),
(96151, 3569258848, 3569258975, 'BE', 'BEL', 'بلجيكا'),
(96152, 3569258976, 3569259007, 'LU', 'LUX', 'لوكسيمبورغ'),
(96153, 3569259008, 3569271815, 'BE', 'BEL', 'بلجيكا'),
(96154, 3569271816, 3569271823, 'LU', 'LUX', 'لوكسيمبورغ'),
(96155, 3569271824, 3569271871, 'BE', 'BEL', 'بلجيكا'),
(96156, 3569271872, 3569271903, 'NL', 'NLD', 'هولندا'),
(96157, 3569271904, 3569271911, 'BE', 'BEL', 'بلجيكا'),
(96158, 3569271912, 3569271919, 'DE', 'DEU', 'ألمانيا'),
(96159, 3569271920, 3569271935, 'BE', 'BEL', 'بلجيكا'),
(96160, 3569271936, 3569271943, 'IT', 'ITA', 'إيطاليا'),
(96161, 3569271944, 3569272063, 'BE', 'BEL', 'بلجيكا'),
(96162, 3569272064, 3569272079, 'LU', 'LUX', 'لوكسيمبورغ'),
(96163, 3569272080, 3569272239, 'BE', 'BEL', 'بلجيكا'),
(96164, 3569272240, 3569272255, 'LU', 'LUX', 'لوكسيمبورغ'),
(96165, 3569272256, 3569273167, 'BE', 'BEL', 'بلجيكا'),
(96166, 3569273168, 3569273183, 'LU', 'LUX', 'لوكسيمبورغ'),
(96167, 3569273184, 3569273791, 'BE', 'BEL', 'بلجيكا'),
(96168, 3569273792, 3569273823, 'LU', 'LUX', 'لوكسيمبورغ'),
(96169, 3569273824, 3569273935, 'BE', 'BEL', 'بلجيكا'),
(96170, 3569273936, 3569273951, 'LI', 'LIE', 'ليختنشتاين'),
(96171, 3569273952, 3569274303, 'BE', 'BEL', 'بلجيكا'),
(96172, 3569274304, 3569274311, 'LU', 'LUX', 'لوكسيمبورغ'),
(96173, 3569274312, 3569274335, 'BE', 'BEL', 'بلجيكا'),
(96174, 3569274336, 3569274383, 'LU', 'LUX', 'لوكسيمبورغ'),
(96175, 3569274384, 3569274495, 'BE', 'BEL', 'بلجيكا'),
(96176, 3569274496, 3569274559, 'LU', 'LUX', 'لوكسيمبورغ'),
(96177, 3569274560, 3569274687, 'BE', 'BEL', 'بلجيكا'),
(96178, 3569274688, 3569274719, 'LU', 'LUX', 'لوكسيمبورغ'),
(96179, 3569274720, 3569277183, 'BE', 'BEL', 'بلجيكا'),
(96180, 3569277184, 3569277439, 'LU', 'LUX', 'لوكسيمبورغ'),
(96181, 3569277440, 3569278703, 'BE', 'BEL', 'بلجيكا'),
(96182, 3569278704, 3569278719, 'NL', 'NLD', 'هولندا'),
(96183, 3569278720, 3569279223, 'BE', 'BEL', 'بلجيكا'),
(96184, 3569279224, 3569279231, 'US', 'USA', 'الولايات المتحدة'),
(96185, 3569279232, 3569279263, 'BE', 'BEL', 'بلجيكا'),
(96186, 3569279264, 3569279279, 'US', 'USA', 'الولايات المتحدة'),
(96187, 3569279280, 3569287167, 'BE', 'BEL', 'بلجيكا'),
(96188, 3569287168, 3569352703, 'PL', 'POL', 'بولندا'),
(96189, 3569352704, 3569483775, 'RU', 'RUS', 'الإتحاد الروسي'),
(96190, 3569483776, 3569614847, 'FR', 'FRA', 'فرنسا'),
(96191, 3569614848, 3569680383, 'GB', 'GBR', 'المملكة المتحدة'),
(96192, 3569680384, 3569683711, 'SK', 'SVK', 'سلوفاكيا'),
(96193, 3569683712, 3569683719, 'IQ', 'IRQ', 'العراق'),
(96194, 3569683720, 3569710959, 'SK', 'SVK', 'سلوفاكيا'),
(96195, 3569710960, 3569710975, 'NL', 'NLD', 'هولندا'),
(96196, 3569710976, 3569713151, 'SK', 'SVK', 'سلوفاكيا'),
(96197, 3569713152, 3569729535, 'AT', 'AUT', 'النمسا'),
(96198, 3569729536, 3569731167, 'FR', 'FRA', 'فرنسا'),
(96199, 3569731168, 3569731183, 'IT', 'ITA', 'إيطاليا'),
(96200, 3569731184, 3569731215, 'GB', 'GBR', 'المملكة المتحدة'),
(96201, 3569731216, 3569731231, 'FR', 'FRA', 'فرنسا'),
(96202, 3569731232, 3569731247, 'DE', 'DEU', 'ألمانيا'),
(96203, 3569731248, 3569731263, 'GB', 'GBR', 'المملكة المتحدة'),
(96204, 3569731264, 3569731311, 'FR', 'FRA', 'فرنسا'),
(96205, 3569731312, 3569731327, 'GB', 'GBR', 'المملكة المتحدة'),
(96206, 3569731328, 3569731375, 'FR', 'FRA', 'فرنسا'),
(96207, 3569731376, 3569731391, 'GB', 'GBR', 'المملكة المتحدة'),
(96208, 3569731392, 3569731423, 'FR', 'FRA', 'فرنسا'),
(96209, 3569731424, 3569731439, 'GB', 'GBR', 'المملكة المتحدة'),
(96210, 3569731440, 3569731455, 'FR', 'FRA', 'فرنسا'),
(96211, 3569731456, 3569731471, 'GB', 'GBR', 'المملكة المتحدة'),
(96212, 3569731472, 3569731487, 'FR', 'FRA', 'فرنسا'),
(96213, 3569731488, 3569731503, 'GB', 'GBR', 'المملكة المتحدة'),
(96214, 3569731504, 3569731519, 'IT', 'ITA', 'إيطاليا'),
(96215, 3569731520, 3569731551, 'GB', 'GBR', 'المملكة المتحدة'),
(96216, 3569731552, 3569731583, 'FR', 'FRA', 'فرنسا'),
(96217, 3569731584, 3569731599, 'GB', 'GBR', 'المملكة المتحدة'),
(96218, 3569731600, 3569731615, 'FR', 'FRA', 'فرنسا'),
(96219, 3569731616, 3569731631, 'DE', 'DEU', 'ألمانيا'),
(96220, 3569731632, 3569731647, 'IT', 'ITA', 'إيطاليا'),
(96221, 3569731648, 3569731727, 'FR', 'FRA', 'فرنسا'),
(96222, 3569731728, 3569731743, 'GB', 'GBR', 'المملكة المتحدة'),
(96223, 3569731744, 3569731791, 'FR', 'FRA', 'فرنسا'),
(96224, 3569731792, 3569731807, 'GB', 'GBR', 'المملكة المتحدة'),
(96225, 3569731808, 3569731839, 'FR', 'FRA', 'فرنسا'),
(96226, 3569731840, 3569731871, 'GB', 'GBR', 'المملكة المتحدة'),
(96227, 3569731872, 3569731903, 'FR', 'FRA', 'فرنسا'),
(96228, 3569731904, 3569731919, 'BE', 'BEL', 'بلجيكا'),
(96229, 3569731920, 3569731951, 'FR', 'FRA', 'فرنسا'),
(96230, 3569731952, 3569731967, 'NL', 'NLD', 'هولندا'),
(96231, 3569731968, 3569731983, 'GB', 'GBR', 'المملكة المتحدة'),
(96232, 3569731984, 3569732031, 'FR', 'FRA', 'فرنسا'),
(96233, 3569732032, 3569732047, 'DE', 'DEU', 'ألمانيا'),
(96234, 3569732048, 3569732063, 'GB', 'GBR', 'المملكة المتحدة'),
(96235, 3569732064, 3569732079, 'FR', 'FRA', 'فرنسا'),
(96236, 3569732080, 3569732095, 'GB', 'GBR', 'المملكة المتحدة'),
(96237, 3569732096, 3569732143, 'FR', 'FRA', 'فرنسا'),
(96238, 3569732144, 3569732191, 'GB', 'GBR', 'المملكة المتحدة'),
(96239, 3569732192, 3569732207, 'DE', 'DEU', 'ألمانيا'),
(96240, 3569732208, 3569732287, 'FR', 'FRA', 'فرنسا'),
(96241, 3569732288, 3569732303, 'GB', 'GBR', 'المملكة المتحدة'),
(96242, 3569732304, 3569732319, 'DE', 'DEU', 'ألمانيا'),
(96243, 3569732320, 3569732335, 'FR', 'FRA', 'فرنسا'),
(96244, 3569732336, 3569732351, 'GB', 'GBR', 'المملكة المتحدة'),
(96245, 3569732352, 3569732383, 'FR', 'FRA', 'فرنسا'),
(96246, 3569732384, 3569732399, 'US', 'USA', 'الولايات المتحدة'),
(96247, 3569732400, 3569732447, 'FR', 'FRA', 'فرنسا'),
(96248, 3569732448, 3569732479, 'US', 'USA', 'الولايات المتحدة'),
(96249, 3569732480, 3569732495, 'GB', 'GBR', 'المملكة المتحدة'),
(96250, 3569732496, 3569732543, 'FR', 'FRA', 'فرنسا'),
(96251, 3569732544, 3569732575, 'GB', 'GBR', 'المملكة المتحدة'),
(96252, 3569732576, 3569732607, 'FR', 'FRA', 'فرنسا'),
(96253, 3569732608, 3569732639, 'GB', 'GBR', 'المملكة المتحدة'),
(96254, 3569732640, 3569732671, 'FR', 'FRA', 'فرنسا'),
(96255, 3569732672, 3569732703, 'GB', 'GBR', 'المملكة المتحدة'),
(96256, 3569732704, 3569732719, 'FR', 'FRA', 'فرنسا'),
(96257, 3569732720, 3569732735, 'GB', 'GBR', 'المملكة المتحدة'),
(96258, 3569732736, 3569732751, 'FR', 'FRA', 'فرنسا'),
(96259, 3569732752, 3569732767, 'GB', 'GBR', 'المملكة المتحدة'),
(96260, 3569732768, 3569732783, 'FR', 'FRA', 'فرنسا'),
(96261, 3569732784, 3569732847, 'GB', 'GBR', 'المملكة المتحدة'),
(96262, 3569732848, 3569732863, 'FR', 'FRA', 'فرنسا'),
(96263, 3569732864, 3569732879, 'GB', 'GBR', 'المملكة المتحدة'),
(96264, 3569732880, 3569732895, 'FR', 'FRA', 'فرنسا'),
(96265, 3569732896, 3569732911, 'IT', 'ITA', 'إيطاليا'),
(96266, 3569732912, 3569733007, 'FR', 'FRA', 'فرنسا'),
(96267, 3569733008, 3569733023, 'IE', 'IRL', 'إيرلندا'),
(96268, 3569733024, 3569733055, 'FR', 'FRA', 'فرنسا'),
(96269, 3569733056, 3569733087, 'GB', 'GBR', 'المملكة المتحدة'),
(96270, 3569733088, 3569733103, 'IT', 'ITA', 'إيطاليا'),
(96271, 3569733104, 3569733183, 'FR', 'FRA', 'فرنسا'),
(96272, 3569733184, 3569733199, 'GB', 'GBR', 'المملكة المتحدة'),
(96273, 3569733200, 3569733263, 'FR', 'FRA', 'فرنسا'),
(96274, 3569733264, 3569733279, 'US', 'USA', 'الولايات المتحدة'),
(96275, 3569733280, 3569733295, 'DE', 'DEU', 'ألمانيا'),
(96276, 3569733296, 3569733311, 'GB', 'GBR', 'المملكة المتحدة'),
(96277, 3569733312, 3569733327, 'FR', 'FRA', 'فرنسا'),
(96278, 3569733328, 3569733343, 'GB', 'GBR', 'المملكة المتحدة'),
(96279, 3569733344, 3569733423, 'FR', 'FRA', 'فرنسا'),
(96280, 3569733424, 3569733439, 'GB', 'GBR', 'المملكة المتحدة'),
(96281, 3569733440, 3569733471, 'FR', 'FRA', 'فرنسا'),
(96282, 3569733472, 3569733487, 'GB', 'GBR', 'المملكة المتحدة'),
(96283, 3569733488, 3569733519, 'FR', 'FRA', 'فرنسا'),
(96284, 3569733520, 3569733535, 'GB', 'GBR', 'المملكة المتحدة'),
(96285, 3569733536, 3569733551, 'NL', 'NLD', 'هولندا'),
(96286, 3569733552, 3569733567, 'FR', 'FRA', 'فرنسا'),
(96287, 3569733568, 3569733583, 'GB', 'GBR', 'المملكة المتحدة'),
(96288, 3569733584, 3569733599, 'FR', 'FRA', 'فرنسا'),
(96289, 3569733600, 3569733615, 'GB', 'GBR', 'المملكة المتحدة'),
(96290, 3569733616, 3569733647, 'FR', 'FRA', 'فرنسا'),
(96291, 3569733648, 3569733663, 'GB', 'GBR', 'المملكة المتحدة'),
(96292, 3569733664, 3569733679, 'FR', 'FRA', 'فرنسا'),
(96293, 3569733680, 3569733695, 'GB', 'GBR', 'المملكة المتحدة'),
(96294, 3569733696, 3569733775, 'FR', 'FRA', 'فرنسا'),
(96295, 3569733776, 3569733791, 'IE', 'IRL', 'إيرلندا'),
(96296, 3569733792, 3569733807, 'FR', 'FRA', 'فرنسا'),
(96297, 3569733808, 3569733823, 'GB', 'GBR', 'المملكة المتحدة'),
(96298, 3569733824, 3569733887, 'FR', 'FRA', 'فرنسا'),
(96299, 3569733888, 3569733919, 'GB', 'GBR', 'المملكة المتحدة'),
(96300, 3569733920, 3569733935, 'FR', 'FRA', 'فرنسا'),
(96301, 3569733936, 3569733951, 'GB', 'GBR', 'المملكة المتحدة'),
(96302, 3569733952, 3569733967, 'FR', 'FRA', 'فرنسا'),
(96303, 3569733968, 3569733983, 'ES', 'ESP', 'إسبانيا'),
(96304, 3569733984, 3569733999, 'GB', 'GBR', 'المملكة المتحدة'),
(96305, 3569734000, 3569734047, 'FR', 'FRA', 'فرنسا'),
(96306, 3569734048, 3569734079, 'GB', 'GBR', 'المملكة المتحدة'),
(96307, 3569734080, 3569734143, 'FR', 'FRA', 'فرنسا'),
(96308, 3569734144, 3569734159, 'GB', 'GBR', 'المملكة المتحدة'),
(96309, 3569734160, 3569734191, 'FR', 'FRA', 'فرنسا'),
(96310, 3569734192, 3569734207, 'GB', 'GBR', 'المملكة المتحدة'),
(96311, 3569734208, 3569734367, 'FR', 'FRA', 'فرنسا'),
(96312, 3569734368, 3569734399, 'GB', 'GBR', 'المملكة المتحدة'),
(96313, 3569734400, 3569734447, 'BE', 'BEL', 'بلجيكا'),
(96314, 3569734448, 3569734463, 'FR', 'FRA', 'فرنسا'),
(96315, 3569734464, 3569734511, 'BE', 'BEL', 'بلجيكا'),
(96316, 3569734512, 3569736047, 'FR', 'FRA', 'فرنسا'),
(96317, 3569736048, 3569736063, 'GB', 'GBR', 'المملكة المتحدة'),
(96318, 3569736064, 3569736071, 'FR', 'FRA', 'فرنسا'),
(96319, 3569736072, 3569736079, 'ES', 'ESP', 'إسبانيا'),
(96320, 3569736080, 3569736191, 'FR', 'FRA', 'فرنسا'),
(96321, 3569736192, 3569736223, 'NL', 'NLD', 'هولندا'),
(96322, 3569736224, 3569736239, 'FR', 'FRA', 'فرنسا'),
(96323, 3569736240, 3569736383, 'NL', 'NLD', 'هولندا'),
(96324, 3569736384, 3569736399, 'SE', 'SWE', 'السويد'),
(96325, 3569736400, 3569736655, 'NL', 'NLD', 'هولندا'),
(96326, 3569736656, 3569736671, 'FR', 'FRA', 'فرنسا'),
(96327, 3569736672, 3569736703, 'NL', 'NLD', 'هولندا'),
(96328, 3569736704, 3569739263, 'FR', 'FRA', 'فرنسا'),
(96329, 3569739264, 3569739295, 'NL', 'NLD', 'هولندا'),
(96330, 3569739296, 3569739327, 'FR', 'FRA', 'فرنسا'),
(96331, 3569739328, 3569739471, 'NL', 'NLD', 'هولندا'),
(96332, 3569739472, 3569739487, 'FR', 'FRA', 'فرنسا'),
(96333, 3569739488, 3569739599, 'NL', 'NLD', 'هولندا'),
(96334, 3569739600, 3569739631, 'FR', 'FRA', 'فرنسا'),
(96335, 3569739632, 3569739647, 'NL', 'NLD', 'هولندا'),
(96336, 3569739648, 3569739663, 'FR', 'FRA', 'فرنسا'),
(96337, 3569739664, 3569739679, 'NL', 'NLD', 'هولندا'),
(96338, 3569739680, 3569739695, 'FR', 'FRA', 'فرنسا'),
(96339, 3569739696, 3569739839, 'NL', 'NLD', 'هولندا'),
(96340, 3569739840, 3569739855, 'FR', 'FRA', 'فرنسا'),
(96341, 3569739856, 3569739903, 'NL', 'NLD', 'هولندا'),
(96342, 3569739904, 3569739919, 'FR', 'FRA', 'فرنسا'),
(96343, 3569739920, 3569739935, 'NL', 'NLD', 'هولندا'),
(96344, 3569739936, 3569739951, 'FR', 'FRA', 'فرنسا'),
(96345, 3569739952, 3569740047, 'NL', 'NLD', 'هولندا'),
(96346, 3569740048, 3569740063, 'FR', 'FRA', 'فرنسا'),
(96347, 3569740064, 3569740111, 'NL', 'NLD', 'هولندا'),
(96348, 3569740112, 3569740127, 'FR', 'FRA', 'فرنسا'),
(96349, 3569740128, 3569740255, 'NL', 'NLD', 'هولندا'),
(96350, 3569740256, 3569740271, 'FR', 'FRA', 'فرنسا'),
(96351, 3569740272, 3569740303, 'NL', 'NLD', 'هولندا'),
(96352, 3569740304, 3569740319, 'FR', 'FRA', 'فرنسا'),
(96353, 3569740320, 3569740367, 'NL', 'NLD', 'هولندا'),
(96354, 3569740368, 3569740383, 'FR', 'FRA', 'فرنسا'),
(96355, 3569740384, 3569740415, 'NL', 'NLD', 'هولندا'),
(96356, 3569740416, 3569740431, 'FR', 'FRA', 'فرنسا'),
(96357, 3569740432, 3569740463, 'NL', 'NLD', 'هولندا'),
(96358, 3569740464, 3569740479, 'FR', 'FRA', 'فرنسا'),
(96359, 3569740480, 3569740495, 'NL', 'NLD', 'هولندا'),
(96360, 3569740496, 3569740511, 'FR', 'FRA', 'فرنسا'),
(96361, 3569740512, 3569740543, 'NL', 'NLD', 'هولندا'),
(96362, 3569740544, 3569740559, 'FR', 'FRA', 'فرنسا'),
(96363, 3569740560, 3569740655, 'NL', 'NLD', 'هولندا'),
(96364, 3569740656, 3569740671, 'FR', 'FRA', 'فرنسا'),
(96365, 3569740672, 3569740687, 'NL', 'NLD', 'هولندا'),
(96366, 3569740688, 3569740703, 'FR', 'FRA', 'فرنسا'),
(96367, 3569740704, 3569740799, 'NL', 'NLD', 'هولندا'),
(96368, 3569740800, 3569741311, 'FR', 'FRA', 'فرنسا'),
(96369, 3569741312, 3569741823, 'BE', 'BEL', 'بلجيكا'),
(96370, 3569741824, 3569742335, 'FR', 'FRA', 'فرنسا'),
(96371, 3569742336, 3569742351, 'BE', 'BEL', 'بلجيكا'),
(96372, 3569742352, 3569742383, 'FR', 'FRA', 'فرنسا'),
(96373, 3569742384, 3569742399, 'BE', 'BEL', 'بلجيكا'),
(96374, 3569742400, 3569742415, 'FR', 'FRA', 'فرنسا'),
(96375, 3569742416, 3569742511, 'BE', 'BEL', 'بلجيكا'),
(96376, 3569742512, 3569742527, 'FR', 'FRA', 'فرنسا'),
(96377, 3569742528, 3569742623, 'BE', 'BEL', 'بلجيكا'),
(96378, 3569742624, 3569742639, 'FR', 'FRA', 'فرنسا'),
(96379, 3569742640, 3569742671, 'BE', 'BEL', 'بلجيكا'),
(96380, 3569742672, 3569742687, 'FR', 'FRA', 'فرنسا'),
(96381, 3569742688, 3569742735, 'BE', 'BEL', 'بلجيكا'),
(96382, 3569742736, 3569742751, 'FR', 'FRA', 'فرنسا'),
(96383, 3569742752, 3569742767, 'BE', 'BEL', 'بلجيكا'),
(96384, 3569742768, 3569742783, 'FR', 'FRA', 'فرنسا'),
(96385, 3569742784, 3569742927, 'BE', 'BEL', 'بلجيكا'),
(96386, 3569742928, 3569742943, 'FR', 'FRA', 'فرنسا'),
(96387, 3569742944, 3569743087, 'BE', 'BEL', 'بلجيكا'),
(96388, 3569743088, 3569743103, 'FR', 'FRA', 'فرنسا'),
(96389, 3569743104, 3569743135, 'BE', 'BEL', 'بلجيكا'),
(96390, 3569743136, 3569743199, 'FR', 'FRA', 'فرنسا'),
(96391, 3569743200, 3569743215, 'BE', 'BEL', 'بلجيكا'),
(96392, 3569743216, 3569743359, 'FR', 'FRA', 'فرنسا'),
(96393, 3569743360, 3569743391, 'BE', 'BEL', 'بلجيكا'),
(96394, 3569743392, 3569743407, 'FR', 'FRA', 'فرنسا'),
(96395, 3569743408, 3569743423, 'BE', 'BEL', 'بلجيكا'),
(96396, 3569743424, 3569743455, 'FR', 'FRA', 'فرنسا'),
(96397, 3569743456, 3569743583, 'BE', 'BEL', 'بلجيكا'),
(96398, 3569743584, 3569743599, 'NL', 'NLD', 'هولندا'),
(96399, 3569743600, 3569743615, 'FR', 'FRA', 'فرنسا'),
(96400, 3569743616, 3569743631, 'BE', 'BEL', 'بلجيكا'),
(96401, 3569743632, 3569743647, 'FR', 'FRA', 'فرنسا'),
(96402, 3569743648, 3569743679, 'BE', 'BEL', 'بلجيكا'),
(96403, 3569743680, 3569743711, 'FR', 'FRA', 'فرنسا'),
(96404, 3569743712, 3569743775, 'BE', 'BEL', 'بلجيكا'),
(96405, 3569743776, 3569743791, 'FR', 'FRA', 'فرنسا'),
(96406, 3569743792, 3569743871, 'BE', 'BEL', 'بلجيكا'),
(96407, 3569743872, 3569743983, 'NL', 'NLD', 'هولندا'),
(96408, 3569743984, 3569743999, 'FR', 'FRA', 'فرنسا'),
(96409, 3569744000, 3569744047, 'NL', 'NLD', 'هولندا'),
(96410, 3569744048, 3569744063, 'FR', 'FRA', 'فرنسا'),
(96411, 3569744064, 3569744127, 'NL', 'NLD', 'هولندا'),
(96412, 3569744128, 3569744143, 'FR', 'FRA', 'فرنسا'),
(96413, 3569744144, 3569744543, 'NL', 'NLD', 'هولندا'),
(96414, 3569744544, 3569744559, 'FR', 'FRA', 'فرنسا'),
(96415, 3569744560, 3569744575, 'NL', 'NLD', 'هولندا'),
(96416, 3569744576, 3569744623, 'FR', 'FRA', 'فرنسا'),
(96417, 3569744624, 3569744815, 'NL', 'NLD', 'هولندا'),
(96418, 3569744816, 3569744831, 'FR', 'FRA', 'فرنسا'),
(96419, 3569744832, 3569744911, 'NL', 'NLD', 'هولندا'),
(96420, 3569744912, 3569744927, 'FR', 'FRA', 'فرنسا'),
(96421, 3569744928, 3569744975, 'NL', 'NLD', 'هولندا'),
(96422, 3569744976, 3569744991, 'FR', 'FRA', 'فرنسا'),
(96423, 3569744992, 3569745007, 'NL', 'NLD', 'هولندا'),
(96424, 3569745008, 3569745023, 'FR', 'FRA', 'فرنسا'),
(96425, 3569745024, 3569745039, 'NL', 'NLD', 'هولندا'),
(96426, 3569745040, 3569745055, 'FR', 'FRA', 'فرنسا'),
(96427, 3569745056, 3569745103, 'NL', 'NLD', 'هولندا'),
(96428, 3569745104, 3569745119, 'FR', 'FRA', 'فرنسا'),
(96429, 3569745120, 3569745167, 'NL', 'NLD', 'هولندا'),
(96430, 3569745168, 3569745183, 'FR', 'FRA', 'فرنسا'),
(96431, 3569745184, 3569745215, 'NL', 'NLD', 'هولندا'),
(96432, 3569745216, 3569745231, 'FR', 'FRA', 'فرنسا'),
(96433, 3569745232, 3569745247, 'NL', 'NLD', 'هولندا'),
(96434, 3569745248, 3569745279, 'FR', 'FRA', 'فرنسا'),
(96435, 3569745280, 3569745311, 'NL', 'NLD', 'هولندا'),
(96436, 3569745312, 3569745327, 'FR', 'FRA', 'فرنسا'),
(96437, 3569745328, 3569745359, 'NL', 'NLD', 'هولندا'),
(96438, 3569745360, 3569745375, 'FR', 'FRA', 'فرنسا'),
(96439, 3569745376, 3569745407, 'NL', 'NLD', 'هولندا'),
(96440, 3569745408, 3569745663, 'FR', 'FRA', 'فرنسا'),
(96441, 3569745664, 3569745727, 'NL', 'NLD', 'هولندا'),
(96442, 3569745728, 3569745743, 'FR', 'FRA', 'فرنسا'),
(96443, 3569745744, 3569745813, 'NL', 'NLD', 'هولندا'),
(96444, 3569745814, 3569745823, 'FR', 'FRA', 'فرنسا'),
(96445, 3569745824, 3569745839, 'NL', 'NLD', 'هولندا'),
(96446, 3569745840, 3569745871, 'FR', 'FRA', 'فرنسا'),
(96447, 3569745872, 3569745887, 'NL', 'NLD', 'هولندا'),
(96448, 3569745888, 3569745903, 'FR', 'FRA', 'فرنسا'),
(96449, 3569745904, 3569745919, 'NL', 'NLD', 'هولندا'),
(96450, 3569745920, 3569811455, 'FR', 'FRA', 'فرنسا'),
(96451, 3569811456, 3569830463, 'IL', 'ISR', 'إسرائيل'),
(96452, 3569830464, 3569830527, 'GB', 'GBR', 'المملكة المتحدة'),
(96453, 3569830528, 3569876991, 'IL', 'ISR', 'إسرائيل'),
(96454, 3569876992, 3569877247, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96455, 3569877248, 3569877759, 'RS', 'SRB', 'صربيا'),
(96456, 3569877760, 3569878015, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96457, 3569878016, 3569879551, 'RS', 'SRB', 'صربيا'),
(96458, 3569879552, 3569880575, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96459, 3569880576, 3569885183, 'RS', 'SRB', 'صربيا'),
(96460, 3569885184, 3569885439, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96461, 3569885440, 3569885951, 'RS', 'SRB', 'صربيا'),
(96462, 3569885952, 3569889791, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96463, 3569889792, 3569890047, 'RS', 'SRB', 'صربيا'),
(96464, 3569890048, 3569890575, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96465, 3569890576, 3569890591, 'RS', 'SRB', 'صربيا'),
(96466, 3569890592, 3569890615, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96467, 3569890616, 3569890623, 'RS', 'SRB', 'صربيا'),
(96468, 3569890624, 3569890751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96469, 3569890752, 3569890815, 'RS', 'SRB', 'صربيا'),
(96470, 3569890816, 3569890911, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96471, 3569890912, 3569890943, 'RS', 'SRB', 'صربيا'),
(96472, 3569890944, 3569891071, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96473, 3569891072, 3569891327, 'RS', 'SRB', 'صربيا'),
(96474, 3569891328, 3569891583, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96475, 3569891584, 3569891839, 'RS', 'SRB', 'صربيا'),
(96476, 3569891840, 3569892351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96477, 3569892352, 3569892607, 'RS', 'SRB', 'صربيا'),
(96478, 3569892608, 3569892863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96479, 3569892864, 3569893375, 'RS', 'SRB', 'صربيا'),
(96480, 3569893376, 3569893887, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96481, 3569893888, 3569894143, 'RS', 'SRB', 'صربيا'),
(96482, 3569894144, 3569894527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96483, 3569894528, 3569894559, 'RS', 'SRB', 'صربيا'),
(96484, 3569894560, 3569895943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96485, 3569895944, 3569895951, 'RS', 'SRB', 'صربيا'),
(96486, 3569895952, 3569896047, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96487, 3569896048, 3569896063, 'RS', 'SRB', 'صربيا'),
(96488, 3569896064, 3569896083, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96489, 3569896084, 3569896095, 'RS', 'SRB', 'صربيا'),
(96490, 3569896096, 3569896103, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96491, 3569896104, 3569896111, 'RS', 'SRB', 'صربيا'),
(96492, 3569896112, 3569896143, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96493, 3569896144, 3569896155, 'RS', 'SRB', 'صربيا'),
(96494, 3569896156, 3569896447, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96495, 3569896448, 3569896703, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96496, 3569896704, 3569898495, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96497, 3569898496, 3569899007, 'RS', 'SRB', 'صربيا'),
(96498, 3569899008, 3569899775, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96499, 3569899776, 3569900031, 'RS', 'SRB', 'صربيا'),
(96500, 3569900032, 3569902847, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96501, 3569902848, 3569903359, 'RS', 'SRB', 'صربيا'),
(96502, 3569903360, 3569903999, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96503, 3569904000, 3569904127, 'RS', 'SRB', 'صربيا'),
(96504, 3569904128, 3569905471, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96505, 3569905472, 3569905503, 'RS', 'SRB', 'صربيا'),
(96506, 3569905504, 3569905535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96507, 3569905536, 3569905543, 'RS', 'SRB', 'صربيا'),
(96508, 3569905544, 3569905583, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96509, 3569905584, 3569906047, 'RS', 'SRB', 'صربيا'),
(96510, 3569906048, 3569907711, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96511, 3569907712, 3569907719, 'RS', 'SRB', 'صربيا'),
(96512, 3569907720, 3569907723, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96513, 3569907724, 3569907731, 'RS', 'SRB', 'صربيا'),
(96514, 3569907732, 3569907787, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96515, 3569907788, 3569907807, 'RS', 'SRB', 'صربيا'),
(96516, 3569907808, 3569907839, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96517, 3569907840, 3569907855, 'RS', 'SRB', 'صربيا'),
(96518, 3569907856, 3569907911, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96519, 3569907912, 3569907927, 'RS', 'SRB', 'صربيا'),
(96520, 3569907928, 3569907935, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96521, 3569907936, 3569907943, 'RS', 'SRB', 'صربيا'),
(96522, 3569907944, 3569907975, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96523, 3569907976, 3569907983, 'RS', 'SRB', 'صربيا'),
(96524, 3569907984, 3569908015, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96525, 3569908016, 3569908031, 'RS', 'SRB', 'صربيا'),
(96526, 3569908032, 3569908159, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96527, 3569908160, 3569908191, 'RS', 'SRB', 'صربيا'),
(96528, 3569908192, 3569910063, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96529, 3569910064, 3569910079, 'RS', 'SRB', 'صربيا'),
(96530, 3569910080, 3569911039, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96531, 3569911040, 3569911295, 'RS', 'SRB', 'صربيا'),
(96532, 3569911296, 3569912623, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96533, 3569912624, 3569912627, 'RS', 'SRB', 'صربيا'),
(96534, 3569912628, 3569912751, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96535, 3569912752, 3569912831, 'RS', 'SRB', 'صربيا'),
(96536, 3569912832, 3569913599, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96537, 3569913600, 3569913607, 'RS', 'SRB', 'صربيا'),
(96538, 3569913608, 3569913655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96539, 3569913656, 3569913663, 'RS', 'SRB', 'صربيا'),
(96540, 3569913664, 3569913703, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96541, 3569913704, 3569913719, 'RS', 'SRB', 'صربيا'),
(96542, 3569913720, 3569913927, 'CS', 'SCG', 'صربيا والجبل الأسود');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(96543, 3569913928, 3569913935, 'RS', 'SRB', 'صربيا'),
(96544, 3569913936, 3569914007, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96545, 3569914008, 3569914047, 'RS', 'SRB', 'صربيا'),
(96546, 3569914048, 3569914175, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96547, 3569914176, 3569914239, 'RS', 'SRB', 'صربيا'),
(96548, 3569914240, 3569914351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96549, 3569914352, 3569914495, 'RS', 'SRB', 'صربيا'),
(96550, 3569914496, 3569914623, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96551, 3569914624, 3569915391, 'RS', 'SRB', 'صربيا'),
(96552, 3569915392, 3569915759, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96553, 3569915760, 3569915775, 'RS', 'SRB', 'صربيا'),
(96554, 3569915776, 3569915831, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96555, 3569915832, 3569915839, 'RS', 'SRB', 'صربيا'),
(96556, 3569915840, 3569915903, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96557, 3569915904, 3569916159, 'RS', 'SRB', 'صربيا'),
(96558, 3569916160, 3569916295, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96559, 3569916296, 3569916303, 'RS', 'SRB', 'صربيا'),
(96560, 3569916304, 3569916319, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96561, 3569916320, 3569916327, 'RS', 'SRB', 'صربيا'),
(96562, 3569916328, 3569916331, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96563, 3569916332, 3569916335, 'RS', 'SRB', 'صربيا'),
(96564, 3569916336, 3569916359, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96565, 3569916360, 3569916383, 'RS', 'SRB', 'صربيا'),
(96566, 3569916384, 3569916671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96567, 3569916672, 3569916735, 'RS', 'SRB', 'صربيا'),
(96568, 3569916736, 3569916799, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96569, 3569916800, 3569916927, 'RS', 'SRB', 'صربيا'),
(96570, 3569916928, 3569918463, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96571, 3569918464, 3569918719, 'RS', 'SRB', 'صربيا'),
(96572, 3569918720, 3569918847, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96573, 3569918848, 3569918855, 'RS', 'SRB', 'صربيا'),
(96574, 3569918856, 3569918863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96575, 3569918864, 3569918951, 'RS', 'SRB', 'صربيا'),
(96576, 3569918952, 3569918975, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96577, 3569918976, 3569919487, 'RS', 'SRB', 'صربيا'),
(96578, 3569919488, 3569921023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96579, 3569921024, 3569921535, 'RS', 'SRB', 'صربيا'),
(96580, 3569921536, 3569922047, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96581, 3569922048, 3569925119, 'RS', 'SRB', 'صربيا'),
(96582, 3569925120, 3569934335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96583, 3569934336, 3569936895, 'RS', 'SRB', 'صربيا'),
(96584, 3569936896, 3569937407, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96585, 3569937408, 3569938431, 'RS', 'SRB', 'صربيا'),
(96586, 3569938432, 3569940479, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96587, 3569940480, 3569940991, 'RS', 'SRB', 'صربيا'),
(96588, 3569940992, 3569942527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(96589, 3569942528, 3570073599, 'DE', 'DEU', 'ألمانيا'),
(96590, 3570073600, 3570076943, 'NL', 'NLD', 'هولندا'),
(96591, 3570076944, 3570076951, 'PH', 'PHL', 'الفلبين'),
(96592, 3570076952, 3570081791, 'NL', 'NLD', 'هولندا'),
(96593, 3570081792, 3570102463, 'CH', 'CHE', 'سويسرا'),
(96594, 3570102464, 3570102479, 'ES', 'ESP', 'إسبانيا'),
(96595, 3570102480, 3570106367, 'CH', 'CHE', 'سويسرا'),
(96596, 3570106368, 3570139135, 'PL', 'POL', 'بولندا'),
(96597, 3570139136, 3570170079, 'DE', 'DEU', 'ألمانيا'),
(96598, 3570170080, 3570170111, 'BE', 'BEL', 'بلجيكا'),
(96599, 3570170112, 3570171903, 'DE', 'DEU', 'ألمانيا'),
(96600, 3570171904, 3570204671, 'NL', 'NLD', 'هولندا'),
(96601, 3570204672, 3570215679, 'GR', 'GRC', 'اليونان'),
(96602, 3570215680, 3570215807, 'DE', 'DEU', 'ألمانيا'),
(96603, 3570215808, 3570223103, 'GR', 'GRC', 'اليونان'),
(96604, 3570223104, 3570223231, 'DE', 'DEU', 'ألمانيا'),
(96605, 3570223232, 3570236927, 'GR', 'GRC', 'اليونان'),
(96606, 3570236928, 3570237183, 'DE', 'DEU', 'ألمانيا'),
(96607, 3570237184, 3570241791, 'GR', 'GRC', 'اليونان'),
(96608, 3570241792, 3570242047, 'DE', 'DEU', 'ألمانيا'),
(96609, 3570242048, 3570270207, 'GR', 'GRC', 'اليونان'),
(96610, 3570270208, 3570335743, 'NL', 'NLD', 'هولندا'),
(96611, 3570335744, 3570401279, 'GB', 'GBR', 'المملكة المتحدة'),
(96612, 3570401280, 3570442687, 'FR', 'FRA', 'فرنسا'),
(96613, 3570442688, 3570442695, 'IT', 'ITA', 'إيطاليا'),
(96614, 3570442696, 3570466815, 'FR', 'FRA', 'فرنسا'),
(96615, 3570466816, 3570507439, 'SE', 'SWE', 'السويد'),
(96616, 3570507440, 3570507455, 'CH', 'CHE', 'سويسرا'),
(96617, 3570507456, 3570532351, 'SE', 'SWE', 'السويد'),
(96618, 3570532352, 3570597887, 'IT', 'ITA', 'إيطاليا'),
(96619, 3570597888, 3570607103, 'GB', 'GBR', 'المملكة المتحدة'),
(96620, 3570607104, 3570608127, 'DE', 'DEU', 'ألمانيا'),
(96621, 3570608128, 3570611199, 'GB', 'GBR', 'المملكة المتحدة'),
(96622, 3570611200, 3570611455, 'FR', 'FRA', 'فرنسا'),
(96623, 3570611456, 3570614271, 'GB', 'GBR', 'المملكة المتحدة'),
(96624, 3570614272, 3570617343, 'DE', 'DEU', 'ألمانيا'),
(96625, 3570617344, 3570617855, 'GB', 'GBR', 'المملكة المتحدة'),
(96626, 3570617856, 3570622463, 'DE', 'DEU', 'ألمانيا'),
(96627, 3570622464, 3570630655, 'GB', 'GBR', 'المملكة المتحدة'),
(96628, 3570630656, 3570633343, 'DE', 'DEU', 'ألمانيا'),
(96629, 3570633344, 3570633471, 'CH', 'CHE', 'سويسرا'),
(96630, 3570633472, 3570663423, 'DE', 'DEU', 'ألمانيا'),
(96631, 3570663424, 3570728959, 'GB', 'GBR', 'المملكة المتحدة'),
(96632, 3570728960, 3570729983, 'FI', 'FIN', 'فنلندا'),
(96633, 3570729984, 3570731007, 'SE', 'SWE', 'السويد'),
(96634, 3570731008, 3570756191, 'FI', 'FIN', 'فنلندا'),
(96635, 3570756192, 3570756223, 'RU', 'RUS', 'الإتحاد الروسي'),
(96636, 3570756224, 3570760543, 'FI', 'FIN', 'فنلندا'),
(96637, 3570760544, 3570760575, 'RU', 'RUS', 'الإتحاد الروسي'),
(96638, 3570760576, 3570794495, 'FI', 'FIN', 'فنلندا'),
(96639, 3570794496, 3570860031, 'SE', 'SWE', 'السويد'),
(96640, 3570860032, 3570892799, 'CH', 'CHE', 'سويسرا'),
(96641, 3570892800, 3570925567, 'SA', 'SAU', 'السعودية'),
(96642, 3570925568, 3570991103, 'IT', 'ITA', 'إيطاليا'),
(96643, 3571023872, 3571056639, 'SE', 'SWE', 'السويد'),
(96644, 3571056640, 3571122175, 'DE', 'DEU', 'ألمانيا'),
(96645, 3571122176, 3571187711, 'GB', 'GBR', 'المملكة المتحدة'),
(96646, 3571187712, 3571253247, 'RU', 'RUS', 'الإتحاد الروسي'),
(96647, 3571253248, 3571259551, 'BE', 'BEL', 'بلجيكا'),
(96648, 3571259552, 3571259583, 'LU', 'LUX', 'لوكسيمبورغ'),
(96649, 3571259584, 3571261359, 'BE', 'BEL', 'بلجيكا'),
(96650, 3571261360, 3571261367, 'LU', 'LUX', 'لوكسيمبورغ'),
(96651, 3571261368, 3571262335, 'BE', 'BEL', 'بلجيكا'),
(96652, 3571262336, 3571262367, 'LU', 'LUX', 'لوكسيمبورغ'),
(96653, 3571262368, 3571264607, 'BE', 'BEL', 'بلجيكا'),
(96654, 3571264608, 3571264639, 'FR', 'FRA', 'فرنسا'),
(96655, 3571264640, 3571265935, 'BE', 'BEL', 'بلجيكا'),
(96656, 3571265936, 3571265951, 'LU', 'LUX', 'لوكسيمبورغ'),
(96657, 3571265952, 3571267199, 'BE', 'BEL', 'بلجيكا'),
(96658, 3571267200, 3571267263, 'LU', 'LUX', 'لوكسيمبورغ'),
(96659, 3571267264, 3571268607, 'BE', 'BEL', 'بلجيكا'),
(96660, 3571268608, 3571268639, 'LU', 'LUX', 'لوكسيمبورغ'),
(96661, 3571268640, 3571269823, 'BE', 'BEL', 'بلجيكا'),
(96662, 3571269824, 3571269855, 'LU', 'LUX', 'لوكسيمبورغ'),
(96663, 3571269856, 3571271423, 'BE', 'BEL', 'بلجيكا'),
(96664, 3571271424, 3571271439, 'LU', 'LUX', 'لوكسيمبورغ'),
(96665, 3571271440, 3571271551, 'BE', 'BEL', 'بلجيكا'),
(96666, 3571271552, 3571271679, 'LU', 'LUX', 'لوكسيمبورغ'),
(96667, 3571271680, 3571272447, 'BE', 'BEL', 'بلجيكا'),
(96668, 3571272448, 3571272575, 'LU', 'LUX', 'لوكسيمبورغ'),
(96669, 3571272576, 3571277119, 'BE', 'BEL', 'بلجيكا'),
(96670, 3571277120, 3571277151, 'DE', 'DEU', 'ألمانيا'),
(96671, 3571277152, 3571286015, 'BE', 'BEL', 'بلجيكا'),
(96672, 3571286016, 3571318911, 'DE', 'DEU', 'ألمانيا'),
(96673, 3571318912, 3571319167, 'GB', 'GBR', 'المملكة المتحدة'),
(96674, 3571319168, 3571319295, 'DE', 'DEU', 'ألمانيا'),
(96675, 3571319296, 3571319679, 'GB', 'GBR', 'المملكة المتحدة'),
(96676, 3571319680, 3571319935, 'DE', 'DEU', 'ألمانيا'),
(96677, 3571319936, 3571320063, 'GB', 'GBR', 'المملكة المتحدة'),
(96678, 3571320064, 3571320575, 'DE', 'DEU', 'ألمانيا'),
(96679, 3571320576, 3571320855, 'GB', 'GBR', 'المملكة المتحدة'),
(96680, 3571320856, 3571320863, 'DE', 'DEU', 'ألمانيا'),
(96681, 3571320864, 3571320927, 'GB', 'GBR', 'المملكة المتحدة'),
(96682, 3571320928, 3571320991, 'DE', 'DEU', 'ألمانيا'),
(96683, 3571320992, 3571321023, 'GB', 'GBR', 'المملكة المتحدة'),
(96684, 3571321024, 3571321055, 'DE', 'DEU', 'ألمانيا'),
(96685, 3571321056, 3571321151, 'GB', 'GBR', 'المملكة المتحدة'),
(96686, 3571321152, 3571321247, 'DE', 'DEU', 'ألمانيا'),
(96687, 3571321248, 3571321279, 'GB', 'GBR', 'المملكة المتحدة'),
(96688, 3571321280, 3571321727, 'DE', 'DEU', 'ألمانيا'),
(96689, 3571321728, 3571321791, 'GB', 'GBR', 'المملكة المتحدة'),
(96690, 3571321792, 3571321855, 'DE', 'DEU', 'ألمانيا'),
(96691, 3571321856, 3571321887, 'GB', 'GBR', 'المملكة المتحدة'),
(96692, 3571321888, 3571321919, 'DE', 'DEU', 'ألمانيا'),
(96693, 3571321920, 3571321983, 'GB', 'GBR', 'المملكة المتحدة'),
(96694, 3571321984, 3571321999, 'DE', 'DEU', 'ألمانيا'),
(96695, 3571322000, 3571322015, 'GB', 'GBR', 'المملكة المتحدة'),
(96696, 3571322016, 3571322111, 'DE', 'DEU', 'ألمانيا'),
(96697, 3571322112, 3571322559, 'GB', 'GBR', 'المملكة المتحدة'),
(96698, 3571322560, 3571322591, 'DE', 'DEU', 'ألمانيا'),
(96699, 3571322592, 3571322879, 'GB', 'GBR', 'المملكة المتحدة'),
(96700, 3571322880, 3571323135, 'DE', 'DEU', 'ألمانيا'),
(96701, 3571323136, 3571323391, 'GB', 'GBR', 'المملكة المتحدة'),
(96702, 3571323392, 3571323455, 'DE', 'DEU', 'ألمانيا'),
(96703, 3571323456, 3571323487, 'GB', 'GBR', 'المملكة المتحدة'),
(96704, 3571323488, 3571323519, 'DE', 'DEU', 'ألمانيا'),
(96705, 3571323520, 3571323711, 'GB', 'GBR', 'المملكة المتحدة'),
(96706, 3571323712, 3571323743, 'DE', 'DEU', 'ألمانيا'),
(96707, 3571323744, 3571323775, 'GB', 'GBR', 'المملكة المتحدة'),
(96708, 3571323776, 3571323903, 'DE', 'DEU', 'ألمانيا'),
(96709, 3571323904, 3571323935, 'GB', 'GBR', 'المملكة المتحدة'),
(96710, 3571323936, 3571324031, 'DE', 'DEU', 'ألمانيا'),
(96711, 3571324032, 3571324095, 'GB', 'GBR', 'المملكة المتحدة'),
(96712, 3571324096, 3571324127, 'DE', 'DEU', 'ألمانيا'),
(96713, 3571324128, 3571324415, 'GB', 'GBR', 'المملكة المتحدة'),
(96714, 3571324416, 3571324527, 'DE', 'DEU', 'ألمانيا'),
(96715, 3571324528, 3571324927, 'GB', 'GBR', 'المملكة المتحدة'),
(96716, 3571324928, 3571324959, 'DE', 'DEU', 'ألمانيا'),
(96717, 3571324960, 3571324991, 'GB', 'GBR', 'المملكة المتحدة'),
(96718, 3571324992, 3571325023, 'DE', 'DEU', 'ألمانيا'),
(96719, 3571325024, 3571325183, 'GB', 'GBR', 'المملكة المتحدة'),
(96720, 3571325184, 3571325247, 'DE', 'DEU', 'ألمانيا'),
(96721, 3571325248, 3571325407, 'GB', 'GBR', 'المملكة المتحدة'),
(96722, 3571325408, 3571325439, 'DE', 'DEU', 'ألمانيا'),
(96723, 3571325440, 3571325567, 'GB', 'GBR', 'المملكة المتحدة'),
(96724, 3571325568, 3571325631, 'DE', 'DEU', 'ألمانيا'),
(96725, 3571325632, 3571326207, 'GB', 'GBR', 'المملكة المتحدة'),
(96726, 3571326208, 3571326255, 'DE', 'DEU', 'ألمانيا'),
(96727, 3571326256, 3571326259, 'BE', 'BEL', 'بلجيكا'),
(96728, 3571326260, 3571326263, 'DE', 'DEU', 'ألمانيا'),
(96729, 3571326264, 3571326463, 'GB', 'GBR', 'المملكة المتحدة'),
(96730, 3571326464, 3571326591, 'DE', 'DEU', 'ألمانيا'),
(96731, 3571326592, 3571326975, 'GB', 'GBR', 'المملكة المتحدة'),
(96732, 3571326976, 3571327039, 'DE', 'DEU', 'ألمانيا'),
(96733, 3571327040, 3571327135, 'GB', 'GBR', 'المملكة المتحدة'),
(96734, 3571327136, 3571327167, 'DE', 'DEU', 'ألمانيا'),
(96735, 3571327168, 3571327615, 'GB', 'GBR', 'المملكة المتحدة'),
(96736, 3571327616, 3571327679, 'DE', 'DEU', 'ألمانيا'),
(96737, 3571327680, 3571327711, 'GB', 'GBR', 'المملكة المتحدة'),
(96738, 3571327712, 3571328063, 'DE', 'DEU', 'ألمانيا'),
(96739, 3571328064, 3571328223, 'GB', 'GBR', 'المملكة المتحدة'),
(96740, 3571328224, 3571328255, 'DE', 'DEU', 'ألمانيا'),
(96741, 3571328256, 3571328447, 'GB', 'GBR', 'المملكة المتحدة'),
(96742, 3571328448, 3571328543, 'DE', 'DEU', 'ألمانيا'),
(96743, 3571328544, 3571328767, 'GB', 'GBR', 'المملكة المتحدة'),
(96744, 3571328768, 3571328831, 'DE', 'DEU', 'ألمانيا'),
(96745, 3571328832, 3571328863, 'GB', 'GBR', 'المملكة المتحدة'),
(96746, 3571328864, 3571329119, 'DE', 'DEU', 'ألمانيا'),
(96747, 3571329120, 3571329183, 'GB', 'GBR', 'المملكة المتحدة'),
(96748, 3571329184, 3571329247, 'DE', 'DEU', 'ألمانيا'),
(96749, 3571329248, 3571329439, 'GB', 'GBR', 'المملكة المتحدة'),
(96750, 3571329440, 3571329455, 'DE', 'DEU', 'ألمانيا'),
(96751, 3571329456, 3571329535, 'GB', 'GBR', 'المملكة المتحدة'),
(96752, 3571329536, 3571329791, 'DE', 'DEU', 'ألمانيا'),
(96753, 3571329792, 3571330047, 'GB', 'GBR', 'المملكة المتحدة'),
(96754, 3571330048, 3571330079, 'DE', 'DEU', 'ألمانيا'),
(96755, 3571330080, 3571330111, 'GB', 'GBR', 'المملكة المتحدة'),
(96756, 3571330112, 3571330175, 'DE', 'DEU', 'ألمانيا'),
(96757, 3571330176, 3571330239, 'GB', 'GBR', 'المملكة المتحدة'),
(96758, 3571330240, 3571330271, 'DE', 'DEU', 'ألمانيا'),
(96759, 3571330272, 3571330911, 'GB', 'GBR', 'المملكة المتحدة'),
(96760, 3571330912, 3571331071, 'DE', 'DEU', 'ألمانيا'),
(96761, 3571331072, 3571331455, 'GB', 'GBR', 'المملكة المتحدة'),
(96762, 3571331456, 3571331519, 'DE', 'DEU', 'ألمانيا'),
(96763, 3571331520, 3571331647, 'GB', 'GBR', 'المملكة المتحدة'),
(96764, 3571331648, 3571331775, 'DE', 'DEU', 'ألمانيا'),
(96765, 3571331776, 3571331807, 'GB', 'GBR', 'المملكة المتحدة'),
(96766, 3571331808, 3571332415, 'DE', 'DEU', 'ألمانيا'),
(96767, 3571332416, 3571332479, 'GB', 'GBR', 'المملكة المتحدة'),
(96768, 3571332480, 3571332607, 'DE', 'DEU', 'ألمانيا'),
(96769, 3571332608, 3571332735, 'GB', 'GBR', 'المملكة المتحدة'),
(96770, 3571332736, 3571332751, 'DE', 'DEU', 'ألمانيا'),
(96771, 3571332752, 3571332831, 'GB', 'GBR', 'المملكة المتحدة'),
(96772, 3571332832, 3571333631, 'DE', 'DEU', 'ألمانيا'),
(96773, 3571333632, 3571333759, 'GB', 'GBR', 'المملكة المتحدة'),
(96774, 3571333760, 3571333791, 'DE', 'DEU', 'ألمانيا'),
(96775, 3571333792, 3571333887, 'GB', 'GBR', 'المملكة المتحدة'),
(96776, 3571333888, 3571333951, 'DE', 'DEU', 'ألمانيا'),
(96777, 3571333952, 3571334079, 'GB', 'GBR', 'المملكة المتحدة'),
(96778, 3571334080, 3571334111, 'DE', 'DEU', 'ألمانيا'),
(96779, 3571334112, 3571334175, 'GB', 'GBR', 'المملكة المتحدة'),
(96780, 3571334176, 3571334207, 'DE', 'DEU', 'ألمانيا'),
(96781, 3571334208, 3571334303, 'GB', 'GBR', 'المملكة المتحدة'),
(96782, 3571334304, 3571334335, 'DE', 'DEU', 'ألمانيا'),
(96783, 3571334336, 3571334911, 'GB', 'GBR', 'المملكة المتحدة'),
(96784, 3571334912, 3571334943, 'DE', 'DEU', 'ألمانيا'),
(96785, 3571334944, 3571335103, 'GB', 'GBR', 'المملكة المتحدة'),
(96786, 3571335104, 3571335455, 'DE', 'DEU', 'ألمانيا'),
(96787, 3571335456, 3571335487, 'GB', 'GBR', 'المملكة المتحدة'),
(96788, 3571335488, 3571335519, 'DE', 'DEU', 'ألمانيا'),
(96789, 3571335520, 3571335583, 'GB', 'GBR', 'المملكة المتحدة'),
(96790, 3571335584, 3571335647, 'DE', 'DEU', 'ألمانيا'),
(96791, 3571335648, 3571335807, 'GB', 'GBR', 'المملكة المتحدة'),
(96792, 3571335808, 3571335935, 'DE', 'DEU', 'ألمانيا'),
(96793, 3571335936, 3571336063, 'GB', 'GBR', 'المملكة المتحدة'),
(96794, 3571336064, 3571336191, 'DE', 'DEU', 'ألمانيا'),
(96795, 3571336192, 3571336223, 'GB', 'GBR', 'المملكة المتحدة'),
(96796, 3571336224, 3571336255, 'DE', 'DEU', 'ألمانيا'),
(96797, 3571336256, 3571336319, 'GB', 'GBR', 'المملكة المتحدة'),
(96798, 3571336320, 3571336447, 'DE', 'DEU', 'ألمانيا'),
(96799, 3571336448, 3571336927, 'GB', 'GBR', 'المملكة المتحدة'),
(96800, 3571336928, 3571336959, 'DE', 'DEU', 'ألمانيا'),
(96801, 3571336960, 3571337215, 'GB', 'GBR', 'المملكة المتحدة'),
(96802, 3571337216, 3571337279, 'DE', 'DEU', 'ألمانيا'),
(96803, 3571337280, 3571337407, 'GB', 'GBR', 'المملكة المتحدة'),
(96804, 3571337408, 3571337439, 'DE', 'DEU', 'ألمانيا'),
(96805, 3571337440, 3571338367, 'GB', 'GBR', 'المملكة المتحدة'),
(96806, 3571338368, 3571338751, 'DE', 'DEU', 'ألمانيا'),
(96807, 3571338752, 3571338879, 'GB', 'GBR', 'المملكة المتحدة'),
(96808, 3571338880, 3571338975, 'DE', 'DEU', 'ألمانيا'),
(96809, 3571338976, 3571339135, 'GB', 'GBR', 'المملكة المتحدة'),
(96810, 3571339136, 3571339199, 'DE', 'DEU', 'ألمانيا'),
(96811, 3571339200, 3571339391, 'GB', 'GBR', 'المملكة المتحدة'),
(96812, 3571339392, 3571339583, 'DE', 'DEU', 'ألمانيا'),
(96813, 3571339584, 3571339903, 'GB', 'GBR', 'المملكة المتحدة'),
(96814, 3571339904, 3571339967, 'DE', 'DEU', 'ألمانيا'),
(96815, 3571339968, 3571340095, 'GB', 'GBR', 'المملكة المتحدة'),
(96816, 3571340096, 3571340159, 'DE', 'DEU', 'ألمانيا'),
(96817, 3571340160, 3571340383, 'GB', 'GBR', 'المملكة المتحدة'),
(96818, 3571340384, 3571340447, 'DE', 'DEU', 'ألمانيا'),
(96819, 3571340448, 3571340511, 'GB', 'GBR', 'المملكة المتحدة'),
(96820, 3571340512, 3571340543, 'DE', 'DEU', 'ألمانيا'),
(96821, 3571340544, 3571340799, 'GB', 'GBR', 'المملكة المتحدة'),
(96822, 3571340800, 3571341375, 'DE', 'DEU', 'ألمانيا'),
(96823, 3571341376, 3571341487, 'GB', 'GBR', 'المملكة المتحدة'),
(96824, 3571341488, 3571341503, 'DE', 'DEU', 'ألمانيا'),
(96825, 3571341504, 3571341567, 'GB', 'GBR', 'المملكة المتحدة'),
(96826, 3571341568, 3571341823, 'DE', 'DEU', 'ألمانيا'),
(96827, 3571341824, 3571342015, 'GB', 'GBR', 'المملكة المتحدة'),
(96828, 3571342016, 3571342047, 'DE', 'DEU', 'ألمانيا'),
(96829, 3571342048, 3571342079, 'GB', 'GBR', 'المملكة المتحدة'),
(96830, 3571342080, 3571342591, 'DE', 'DEU', 'ألمانيا'),
(96831, 3571342592, 3571342623, 'GB', 'GBR', 'المملكة المتحدة'),
(96832, 3571342624, 3571342655, 'DE', 'DEU', 'ألمانيا'),
(96833, 3571342656, 3571342719, 'GB', 'GBR', 'المملكة المتحدة'),
(96834, 3571342720, 3571342751, 'DE', 'DEU', 'ألمانيا'),
(96835, 3571342752, 3571343039, 'GB', 'GBR', 'المملكة المتحدة'),
(96836, 3571343040, 3571343071, 'DE', 'DEU', 'ألمانيا'),
(96837, 3571343072, 3571343103, 'GB', 'GBR', 'المملكة المتحدة'),
(96838, 3571343104, 3571343359, 'DE', 'DEU', 'ألمانيا'),
(96839, 3571343360, 3571343391, 'GB', 'GBR', 'المملكة المتحدة'),
(96840, 3571343392, 3571343455, 'DE', 'DEU', 'ألمانيا'),
(96841, 3571343456, 3571343487, 'GB', 'GBR', 'المملكة المتحدة'),
(96842, 3571343488, 3571343495, 'DE', 'DEU', 'ألمانيا'),
(96843, 3571343496, 3571343503, 'ES', 'ESP', 'إسبانيا'),
(96844, 3571343504, 3571343515, 'DE', 'DEU', 'ألمانيا'),
(96845, 3571343516, 3571343519, 'GB', 'GBR', 'المملكة المتحدة'),
(96846, 3571343520, 3571343551, 'DE', 'DEU', 'ألمانيا'),
(96847, 3571343552, 3571343615, 'GB', 'GBR', 'المملكة المتحدة'),
(96848, 3571343616, 3571343871, 'DE', 'DEU', 'ألمانيا'),
(96849, 3571343872, 3571344095, 'GB', 'GBR', 'المملكة المتحدة'),
(96850, 3571344096, 3571344127, 'DE', 'DEU', 'ألمانيا'),
(96851, 3571344128, 3571344191, 'GB', 'GBR', 'المملكة المتحدة'),
(96852, 3571344192, 3571344255, 'DE', 'DEU', 'ألمانيا'),
(96853, 3571344256, 3571345215, 'GB', 'GBR', 'المملكة المتحدة'),
(96854, 3571345216, 3571346463, 'DE', 'DEU', 'ألمانيا'),
(96855, 3571346464, 3571346495, 'GB', 'GBR', 'المملكة المتحدة'),
(96856, 3571346496, 3571346559, 'DE', 'DEU', 'ألمانيا'),
(96857, 3571346560, 3571346591, 'GB', 'GBR', 'المملكة المتحدة'),
(96858, 3571346592, 3571346623, 'DE', 'DEU', 'ألمانيا'),
(96859, 3571346624, 3571346831, 'GB', 'GBR', 'المملكة المتحدة'),
(96860, 3571346832, 3571346847, 'DE', 'DEU', 'ألمانيا'),
(96861, 3571346848, 3571346879, 'GB', 'GBR', 'المملكة المتحدة'),
(96862, 3571346880, 3571346911, 'DE', 'DEU', 'ألمانيا'),
(96863, 3571346912, 3571347071, 'GB', 'GBR', 'المملكة المتحدة'),
(96864, 3571347072, 3571347191, 'DE', 'DEU', 'ألمانيا'),
(96865, 3571347192, 3571347199, 'GB', 'GBR', 'المملكة المتحدة'),
(96866, 3571347200, 3571347455, 'DE', 'DEU', 'ألمانيا'),
(96867, 3571347456, 3571347711, 'BE', 'BEL', 'بلجيكا'),
(96868, 3571347712, 3571347967, 'GB', 'GBR', 'المملكة المتحدة'),
(96869, 3571347968, 3571348223, 'DE', 'DEU', 'ألمانيا'),
(96870, 3571348224, 3571348255, 'GB', 'GBR', 'المملكة المتحدة'),
(96871, 3571348256, 3571348287, 'DE', 'DEU', 'ألمانيا'),
(96872, 3571348288, 3571348383, 'GB', 'GBR', 'المملكة المتحدة'),
(96873, 3571348384, 3571348399, 'DE', 'DEU', 'ألمانيا'),
(96874, 3571348400, 3571348447, 'GB', 'GBR', 'المملكة المتحدة'),
(96875, 3571348448, 3571348511, 'DE', 'DEU', 'ألمانيا'),
(96876, 3571348512, 3571348543, 'GB', 'GBR', 'المملكة المتحدة'),
(96877, 3571348544, 3571348735, 'DE', 'DEU', 'ألمانيا'),
(96878, 3571348736, 3571348991, 'GB', 'GBR', 'المملكة المتحدة'),
(96879, 3571348992, 3571349135, 'DE', 'DEU', 'ألمانيا'),
(96880, 3571349136, 3571349151, 'GB', 'GBR', 'المملكة المتحدة'),
(96881, 3571349152, 3571349231, 'DE', 'DEU', 'ألمانيا'),
(96882, 3571349232, 3571349239, 'GB', 'GBR', 'المملكة المتحدة'),
(96883, 3571349240, 3571349263, 'DE', 'DEU', 'ألمانيا'),
(96884, 3571349264, 3571349311, 'GB', 'GBR', 'المملكة المتحدة'),
(96885, 3571349312, 3571349343, 'DE', 'DEU', 'ألمانيا'),
(96886, 3571349344, 3571349743, 'GB', 'GBR', 'المملكة المتحدة'),
(96887, 3571349744, 3571349759, 'CH', 'CHE', 'سويسرا'),
(96888, 3571349760, 3571349791, 'DE', 'DEU', 'ألمانيا'),
(96889, 3571349792, 3571349799, 'SE', 'SWE', 'السويد'),
(96890, 3571349800, 3571349807, 'DE', 'DEU', 'ألمانيا'),
(96891, 3571349808, 3571349815, 'BE', 'BEL', 'بلجيكا'),
(96892, 3571349816, 3571349819, 'SE', 'SWE', 'السويد'),
(96893, 3571349820, 3571349887, 'GB', 'GBR', 'المملكة المتحدة'),
(96894, 3571349888, 3571349919, 'DE', 'DEU', 'ألمانيا'),
(96895, 3571349920, 3571350511, 'GB', 'GBR', 'المملكة المتحدة'),
(96896, 3571350512, 3571350527, 'DE', 'DEU', 'ألمانيا'),
(96897, 3571350528, 3571351551, 'GB', 'GBR', 'المملكة المتحدة'),
(96898, 3571351552, 3571351807, 'DE', 'DEU', 'ألمانيا'),
(96899, 3571351808, 3571351871, 'GB', 'GBR', 'المملكة المتحدة'),
(96900, 3571351872, 3571352031, 'DE', 'DEU', 'ألمانيا'),
(96901, 3571352032, 3571352063, 'GB', 'GBR', 'المملكة المتحدة'),
(96902, 3571352064, 3571352415, 'DE', 'DEU', 'ألمانيا'),
(96903, 3571352416, 3571352527, 'GB', 'GBR', 'المملكة المتحدة'),
(96904, 3571352528, 3571352639, 'DE', 'DEU', 'ألمانيا'),
(96905, 3571352640, 3571352735, 'GB', 'GBR', 'المملكة المتحدة'),
(96906, 3571352736, 3571352783, 'DE', 'DEU', 'ألمانيا'),
(96907, 3571352784, 3571352831, 'GB', 'GBR', 'المملكة المتحدة'),
(96908, 3571352832, 3571353215, 'DE', 'DEU', 'ألمانيا'),
(96909, 3571353216, 3571353231, 'GB', 'GBR', 'المملكة المتحدة'),
(96910, 3571353232, 3571353279, 'DE', 'DEU', 'ألمانيا'),
(96911, 3571353280, 3571353311, 'GB', 'GBR', 'المملكة المتحدة'),
(96912, 3571353312, 3571353343, 'DE', 'DEU', 'ألمانيا'),
(96913, 3571353344, 3571353471, 'GB', 'GBR', 'المملكة المتحدة'),
(96914, 3571353472, 3571353599, 'DE', 'DEU', 'ألمانيا'),
(96915, 3571353600, 3571353791, 'GB', 'GBR', 'المملكة المتحدة'),
(96916, 3571353792, 3571353807, 'DE', 'DEU', 'ألمانيا'),
(96917, 3571353808, 3571353855, 'GB', 'GBR', 'المملكة المتحدة'),
(96918, 3571353856, 3571354111, 'DE', 'DEU', 'ألمانيا'),
(96919, 3571354112, 3571354463, 'GB', 'GBR', 'المملكة المتحدة'),
(96920, 3571354464, 3571354495, 'DE', 'DEU', 'ألمانيا'),
(96921, 3571354496, 3571355007, 'GB', 'GBR', 'المملكة المتحدة'),
(96922, 3571355008, 3571355135, 'DE', 'DEU', 'ألمانيا'),
(96923, 3571355136, 3571355167, 'GB', 'GBR', 'المملكة المتحدة'),
(96924, 3571355168, 3571355183, 'DE', 'DEU', 'ألمانيا'),
(96925, 3571355184, 3571355391, 'GB', 'GBR', 'المملكة المتحدة'),
(96926, 3571355392, 3571355935, 'DE', 'DEU', 'ألمانيا'),
(96927, 3571355936, 3571355967, 'GB', 'GBR', 'المملكة المتحدة'),
(96928, 3571355968, 3571356031, 'DE', 'DEU', 'ألمانيا'),
(96929, 3571356032, 3571356159, 'GB', 'GBR', 'المملكة المتحدة'),
(96930, 3571356160, 3571356415, 'DE', 'DEU', 'ألمانيا'),
(96931, 3571356416, 3571356543, 'GB', 'GBR', 'المملكة المتحدة'),
(96932, 3571356544, 3571356607, 'DE', 'DEU', 'ألمانيا'),
(96933, 3571356608, 3571356671, 'GB', 'GBR', 'المملكة المتحدة'),
(96934, 3571356672, 3571357071, 'DE', 'DEU', 'ألمانيا'),
(96935, 3571357072, 3571357183, 'GB', 'GBR', 'المملكة المتحدة'),
(96936, 3571357184, 3571357695, 'DE', 'DEU', 'ألمانيا'),
(96937, 3571357696, 3571357791, 'GB', 'GBR', 'المملكة المتحدة'),
(96938, 3571357792, 3571357855, 'DE', 'DEU', 'ألمانيا'),
(96939, 3571357856, 3571357871, 'GB', 'GBR', 'المملكة المتحدة'),
(96940, 3571357872, 3571357951, 'DE', 'DEU', 'ألمانيا'),
(96941, 3571357952, 3571358047, 'GB', 'GBR', 'المملكة المتحدة'),
(96942, 3571358048, 3571358079, 'DE', 'DEU', 'ألمانيا'),
(96943, 3571358080, 3571358223, 'GB', 'GBR', 'المملكة المتحدة'),
(96944, 3571358224, 3571358255, 'DE', 'DEU', 'ألمانيا'),
(96945, 3571358256, 3571358319, 'GB', 'GBR', 'المملكة المتحدة'),
(96946, 3571358320, 3571358335, 'DE', 'DEU', 'ألمانيا'),
(96947, 3571358336, 3571358399, 'GB', 'GBR', 'المملكة المتحدة'),
(96948, 3571358400, 3571358415, 'DE', 'DEU', 'ألمانيا'),
(96949, 3571358416, 3571358431, 'GB', 'GBR', 'المملكة المتحدة'),
(96950, 3571358432, 3571358447, 'DE', 'DEU', 'ألمانيا'),
(96951, 3571358448, 3571358463, 'GB', 'GBR', 'المملكة المتحدة'),
(96952, 3571358464, 3571358495, 'DE', 'DEU', 'ألمانيا'),
(96953, 3571358496, 3571358503, 'GB', 'GBR', 'المملكة المتحدة'),
(96954, 3571358504, 3571358559, 'DE', 'DEU', 'ألمانيا'),
(96955, 3571358560, 3571358575, 'GB', 'GBR', 'المملكة المتحدة'),
(96956, 3571358576, 3571358591, 'DE', 'DEU', 'ألمانيا'),
(96957, 3571358592, 3571358975, 'GB', 'GBR', 'المملكة المتحدة'),
(96958, 3571358976, 3571358991, 'DE', 'DEU', 'ألمانيا'),
(96959, 3571358992, 3571358999, 'GB', 'GBR', 'المملكة المتحدة'),
(96960, 3571359000, 3571359079, 'DE', 'DEU', 'ألمانيا'),
(96961, 3571359080, 3571359095, 'GB', 'GBR', 'المملكة المتحدة'),
(96962, 3571359096, 3571359151, 'DE', 'DEU', 'ألمانيا'),
(96963, 3571359152, 3571359159, 'GB', 'GBR', 'المملكة المتحدة'),
(96964, 3571359160, 3571359167, 'DE', 'DEU', 'ألمانيا'),
(96965, 3571359168, 3571359175, 'GB', 'GBR', 'المملكة المتحدة'),
(96966, 3571359176, 3571359207, 'DE', 'DEU', 'ألمانيا'),
(96967, 3571359208, 3571359215, 'GB', 'GBR', 'المملكة المتحدة'),
(96968, 3571359216, 3571359319, 'DE', 'DEU', 'ألمانيا'),
(96969, 3571359320, 3571359327, 'GB', 'GBR', 'المملكة المتحدة'),
(96970, 3571359328, 3571359335, 'DE', 'DEU', 'ألمانيا'),
(96971, 3571359336, 3571359343, 'GB', 'GBR', 'المملكة المتحدة'),
(96972, 3571359344, 3571359351, 'DE', 'DEU', 'ألمانيا'),
(96973, 3571359352, 3571359359, 'GB', 'GBR', 'المملكة المتحدة'),
(96974, 3571359360, 3571359415, 'DE', 'DEU', 'ألمانيا'),
(96975, 3571359416, 3571359419, 'GB', 'GBR', 'المملكة المتحدة'),
(96976, 3571359420, 3571359463, 'DE', 'DEU', 'ألمانيا'),
(96977, 3571359464, 3571359471, 'GB', 'GBR', 'المملكة المتحدة'),
(96978, 3571359472, 3571359487, 'DE', 'DEU', 'ألمانيا'),
(96979, 3571359488, 3571359999, 'GB', 'GBR', 'المملكة المتحدة'),
(96980, 3571360000, 3571360767, 'DE', 'DEU', 'ألمانيا'),
(96981, 3571360768, 3571361151, 'GB', 'GBR', 'المملكة المتحدة'),
(96982, 3571361152, 3571361215, 'DE', 'DEU', 'ألمانيا'),
(96983, 3571361216, 3571361247, 'GB', 'GBR', 'المملكة المتحدة'),
(96984, 3571361248, 3571361407, 'DE', 'DEU', 'ألمانيا'),
(96985, 3571361408, 3571361439, 'GB', 'GBR', 'المملكة المتحدة'),
(96986, 3571361440, 3571361455, 'DE', 'DEU', 'ألمانيا'),
(96987, 3571361456, 3571361471, 'GB', 'GBR', 'المملكة المتحدة'),
(96988, 3571361472, 3571361535, 'DE', 'DEU', 'ألمانيا'),
(96989, 3571361536, 3571361983, 'GB', 'GBR', 'المملكة المتحدة'),
(96990, 3571361984, 3571362303, 'DE', 'DEU', 'ألمانيا'),
(96991, 3571362304, 3571362559, 'GB', 'GBR', 'المملكة المتحدة'),
(96992, 3571362560, 3571362879, 'DE', 'DEU', 'ألمانيا'),
(96993, 3571362880, 3571363007, 'GB', 'GBR', 'المملكة المتحدة'),
(96994, 3571363008, 3571363039, 'DE', 'DEU', 'ألمانيا'),
(96995, 3571363040, 3571363327, 'GB', 'GBR', 'المملكة المتحدة'),
(96996, 3571363328, 3571364095, 'DE', 'DEU', 'ألمانيا'),
(96997, 3571364096, 3571364287, 'GB', 'GBR', 'المملكة المتحدة'),
(96998, 3571364288, 3571364319, 'DE', 'DEU', 'ألمانيا'),
(96999, 3571364320, 3571364919, 'GB', 'GBR', 'المملكة المتحدة'),
(97000, 3571364920, 3571364927, 'DE', 'DEU', 'ألمانيا'),
(97001, 3571364928, 3571364955, 'GB', 'GBR', 'المملكة المتحدة'),
(97002, 3571364956, 3571364975, 'DE', 'DEU', 'ألمانيا'),
(97003, 3571364976, 3571364983, 'GB', 'GBR', 'المملكة المتحدة'),
(97004, 3571364984, 3571364991, 'DE', 'DEU', 'ألمانيا'),
(97005, 3571364992, 3571365023, 'GB', 'GBR', 'المملكة المتحدة'),
(97006, 3571365024, 3571365031, 'DE', 'DEU', 'ألمانيا'),
(97007, 3571365032, 3571365039, 'GB', 'GBR', 'المملكة المتحدة'),
(97008, 3571365040, 3571365047, 'DE', 'DEU', 'ألمانيا'),
(97009, 3571365048, 3571365055, 'GB', 'GBR', 'المملكة المتحدة'),
(97010, 3571365056, 3571365071, 'DE', 'DEU', 'ألمانيا'),
(97011, 3571365072, 3571365079, 'GB', 'GBR', 'المملكة المتحدة'),
(97012, 3571365080, 3571365087, 'DE', 'DEU', 'ألمانيا'),
(97013, 3571365088, 3571365183, 'GB', 'GBR', 'المملكة المتحدة'),
(97014, 3571365184, 3571365247, 'DE', 'DEU', 'ألمانيا'),
(97015, 3571365248, 3571365999, 'GB', 'GBR', 'المملكة المتحدة'),
(97016, 3571366000, 3571366007, 'DE', 'DEU', 'ألمانيا'),
(97017, 3571366008, 3571366143, 'GB', 'GBR', 'المملكة المتحدة'),
(97018, 3571366144, 3571366151, 'DE', 'DEU', 'ألمانيا'),
(97019, 3571366152, 3571366399, 'GB', 'GBR', 'المملكة المتحدة'),
(97020, 3571366400, 3571366511, 'NL', 'NLD', 'هولندا'),
(97021, 3571366512, 3571366519, 'DE', 'DEU', 'ألمانيا'),
(97022, 3571366520, 3571366559, 'GB', 'GBR', 'المملكة المتحدة'),
(97023, 3571366560, 3571366591, 'DE', 'DEU', 'ألمانيا'),
(97024, 3571366592, 3571366655, 'GB', 'GBR', 'المملكة المتحدة'),
(97025, 3571366656, 3571366911, 'DE', 'DEU', 'ألمانيا'),
(97026, 3571366912, 3571368447, 'GB', 'GBR', 'المملكة المتحدة'),
(97027, 3571368448, 3571368479, 'DE', 'DEU', 'ألمانيا'),
(97028, 3571368480, 3571368511, 'GB', 'GBR', 'المملكة المتحدة'),
(97029, 3571368512, 3571368575, 'DE', 'DEU', 'ألمانيا'),
(97030, 3571368576, 3571368623, 'GB', 'GBR', 'المملكة المتحدة'),
(97031, 3571368624, 3571368687, 'DE', 'DEU', 'ألمانيا'),
(97032, 3571368688, 3571368695, 'GB', 'GBR', 'المملكة المتحدة'),
(97033, 3571368696, 3571368959, 'DE', 'DEU', 'ألمانيا'),
(97034, 3571368960, 3571369215, 'GB', 'GBR', 'المملكة المتحدة'),
(97035, 3571369216, 3571369279, 'DE', 'DEU', 'ألمانيا'),
(97036, 3571369280, 3571369727, 'GB', 'GBR', 'المملكة المتحدة'),
(97037, 3571369728, 3571369759, 'DE', 'DEU', 'ألمانيا'),
(97038, 3571369760, 3571369807, 'GB', 'GBR', 'المملكة المتحدة'),
(97039, 3571369808, 3571369823, 'DE', 'DEU', 'ألمانيا'),
(97040, 3571369824, 3571369983, 'GB', 'GBR', 'المملكة المتحدة'),
(97041, 3571369984, 3571371299, 'DE', 'DEU', 'ألمانيا'),
(97042, 3571371300, 3571371303, 'GB', 'GBR', 'المملكة المتحدة'),
(97043, 3571371304, 3571371319, 'DE', 'DEU', 'ألمانيا'),
(97044, 3571371320, 3571371327, 'GB', 'GBR', 'المملكة المتحدة'),
(97045, 3571371328, 3571371359, 'DE', 'DEU', 'ألمانيا'),
(97046, 3571371360, 3571372303, 'GB', 'GBR', 'المملكة المتحدة'),
(97047, 3571372304, 3571372319, 'DE', 'DEU', 'ألمانيا'),
(97048, 3571372320, 3571375327, 'GB', 'GBR', 'المملكة المتحدة'),
(97049, 3571375328, 3571375343, 'DE', 'DEU', 'ألمانيا'),
(97050, 3571375344, 3571379199, 'GB', 'GBR', 'المملكة المتحدة'),
(97051, 3571379200, 3571379231, 'DE', 'DEU', 'ألمانيا'),
(97052, 3571379232, 3571379247, 'GB', 'GBR', 'المملكة المتحدة'),
(97053, 3571379248, 3571379311, 'DE', 'DEU', 'ألمانيا'),
(97054, 3571379312, 3571379315, 'NL', 'NLD', 'هولندا'),
(97055, 3571379316, 3571379351, 'DE', 'DEU', 'ألمانيا'),
(97056, 3571379352, 3571379359, 'GB', 'GBR', 'المملكة المتحدة'),
(97057, 3571379360, 3571379367, 'DE', 'DEU', 'ألمانيا'),
(97058, 3571379368, 3571379375, 'GB', 'GBR', 'المملكة المتحدة'),
(97059, 3571379376, 3571379631, 'DE', 'DEU', 'ألمانيا'),
(97060, 3571379632, 3571379647, 'GB', 'GBR', 'المملكة المتحدة'),
(97061, 3571379648, 3571379871, 'DE', 'DEU', 'ألمانيا'),
(97062, 3571379872, 3571379887, 'GB', 'GBR', 'المملكة المتحدة'),
(97063, 3571379888, 3571379903, 'DE', 'DEU', 'ألمانيا'),
(97064, 3571379904, 3571381151, 'GB', 'GBR', 'المملكة المتحدة'),
(97065, 3571381152, 3571381631, 'DE', 'DEU', 'ألمانيا'),
(97066, 3571381632, 3571381695, 'AT', 'AUT', 'النمسا'),
(97067, 3571381696, 3571381711, 'DE', 'DEU', 'ألمانيا'),
(97068, 3571381712, 3571381727, 'GB', 'GBR', 'المملكة المتحدة'),
(97069, 3571381728, 3571381791, 'DE', 'DEU', 'ألمانيا'),
(97070, 3571381792, 3571381887, 'GB', 'GBR', 'المملكة المتحدة'),
(97071, 3571381888, 3571381951, 'DE', 'DEU', 'ألمانيا'),
(97072, 3571381952, 3571382015, 'GB', 'GBR', 'المملكة المتحدة'),
(97073, 3571382016, 3571382207, 'DE', 'DEU', 'ألمانيا'),
(97074, 3571382208, 3571382271, 'GB', 'GBR', 'المملكة المتحدة'),
(97075, 3571382272, 3571382303, 'DE', 'DEU', 'ألمانيا'),
(97076, 3571382304, 3571382351, 'GB', 'GBR', 'المملكة المتحدة'),
(97077, 3571382352, 3571382367, 'DE', 'DEU', 'ألمانيا'),
(97078, 3571382368, 3571382623, 'GB', 'GBR', 'المملكة المتحدة'),
(97079, 3571382624, 3571382783, 'DE', 'DEU', 'ألمانيا'),
(97080, 3571382784, 3571383039, 'AT', 'AUT', 'النمسا'),
(97081, 3571383040, 3571383135, 'DE', 'DEU', 'ألمانيا'),
(97082, 3571383136, 3571383151, 'AT', 'AUT', 'النمسا'),
(97083, 3571383152, 3571383167, 'GB', 'GBR', 'المملكة المتحدة'),
(97084, 3571383168, 3571383175, 'DE', 'DEU', 'ألمانيا'),
(97085, 3571383176, 3571383999, 'GB', 'GBR', 'المملكة المتحدة'),
(97086, 3571384000, 3571384063, 'DE', 'DEU', 'ألمانيا'),
(97087, 3571384064, 3571384319, 'GB', 'GBR', 'المملكة المتحدة'),
(97088, 3571384320, 3571385151, 'DE', 'DEU', 'ألمانيا'),
(97089, 3571385152, 3571385183, 'GB', 'GBR', 'المملكة المتحدة'),
(97090, 3571385184, 3571385631, 'DE', 'DEU', 'ألمانيا'),
(97091, 3571385632, 3571385663, 'GB', 'GBR', 'المملكة المتحدة'),
(97092, 3571385664, 3571389503, 'DE', 'DEU', 'ألمانيا'),
(97093, 3571389504, 3571389519, 'HU', 'HUN', 'هنغاريا'),
(97094, 3571389520, 3571414015, 'DE', 'DEU', 'ألمانيا'),
(97095, 3571414016, 3571414271, 'IE', 'IRL', 'إيرلندا'),
(97096, 3571414272, 3571414783, 'DE', 'DEU', 'ألمانيا'),
(97097, 3571414784, 3571414799, 'IE', 'IRL', 'إيرلندا'),
(97098, 3571414800, 3571425695, 'DE', 'DEU', 'ألمانيا'),
(97099, 3571425696, 3571425727, 'ES', 'ESP', 'إسبانيا'),
(97100, 3571425728, 3571426895, 'DE', 'DEU', 'ألمانيا'),
(97101, 3571426896, 3571426899, 'ES', 'ESP', 'إسبانيا'),
(97102, 3571426900, 3571426931, 'DE', 'DEU', 'ألمانيا'),
(97103, 3571426932, 3571426935, 'ES', 'ESP', 'إسبانيا'),
(97104, 3571426936, 3571456575, 'DE', 'DEU', 'ألمانيا'),
(97105, 3571456576, 3571456591, 'GB', 'GBR', 'المملكة المتحدة'),
(97106, 3571456592, 3571473151, 'DE', 'DEU', 'ألمانيا'),
(97107, 3571473152, 3571473407, 'NL', 'NLD', 'هولندا'),
(97108, 3571473408, 3571481343, 'DE', 'DEU', 'ألمانيا'),
(97109, 3571481344, 3571481359, 'AT', 'AUT', 'النمسا'),
(97110, 3571481360, 3571481375, 'DE', 'DEU', 'ألمانيا'),
(97111, 3571481376, 3571481391, 'NL', 'NLD', 'هولندا'),
(97112, 3571481392, 3571481471, 'DE', 'DEU', 'ألمانيا'),
(97113, 3571481472, 3571481599, 'NL', 'NLD', 'هولندا'),
(97114, 3571481600, 3571482367, 'DE', 'DEU', 'ألمانيا'),
(97115, 3571482368, 3571482623, 'CH', 'CHE', 'سويسرا'),
(97116, 3571482624, 3571515391, 'BE', 'BEL', 'بلجيكا'),
(97117, 3571515392, 3571548159, 'GB', 'GBR', 'المملكة المتحدة'),
(97118, 3571548160, 3571580927, 'ES', 'ESP', 'إسبانيا'),
(97119, 3571580928, 3571646463, 'FI', 'FIN', 'فنلندا'),
(97120, 3571646464, 3571675679, 'DE', 'DEU', 'ألمانيا'),
(97121, 3571675680, 3571675687, 'GB', 'GBR', 'المملكة المتحدة'),
(97122, 3571675688, 3571711999, 'DE', 'DEU', 'ألمانيا'),
(97123, 3571712000, 3571843071, 'GB', 'GBR', 'المملكة المتحدة'),
(97124, 3571843072, 3571974143, 'ES', 'ESP', 'إسبانيا'),
(97125, 3571974144, 3571978239, 'RU', 'RUS', 'الإتحاد الروسي'),
(97126, 3571978240, 3571980287, 'SK', 'SVK', 'سلوفاكيا'),
(97127, 3571980288, 3571982335, 'AT', 'AUT', 'النمسا'),
(97128, 3571990528, 3572006911, 'RU', 'RUS', 'الإتحاد الروسي'),
(97129, 3572006912, 3572039679, 'CH', 'CHE', 'سويسرا'),
(97130, 3572039680, 3572047871, 'BE', 'BEL', 'بلجيكا'),
(97131, 3572047872, 3572052479, 'LU', 'LUX', 'لوكسيمبورغ'),
(97132, 3572052480, 3572052735, 'BE', 'BEL', 'بلجيكا'),
(97133, 3572052736, 3572054303, 'LU', 'LUX', 'لوكسيمبورغ'),
(97134, 3572054304, 3572054431, 'BE', 'BEL', 'بلجيكا'),
(97135, 3572054432, 3572054527, 'LU', 'LUX', 'لوكسيمبورغ'),
(97136, 3572054528, 3572055551, 'BE', 'BEL', 'بلجيكا'),
(97137, 3572055552, 3572055743, 'LU', 'LUX', 'لوكسيمبورغ'),
(97138, 3572055744, 3572056063, 'BE', 'BEL', 'بلجيكا'),
(97139, 3572056064, 3572072447, 'RU', 'RUS', 'الإتحاد الروسي'),
(97140, 3572072448, 3572105215, 'BG', 'BGR', 'بلغاريا'),
(97141, 3572105216, 3572170751, 'FR', 'FRA', 'فرنسا'),
(97142, 3572170752, 3572195791, 'IL', 'ISR', 'إسرائيل'),
(97143, 3572195792, 3572195807, 'GB', 'GBR', 'المملكة المتحدة'),
(97144, 3572195808, 3572203519, 'IL', 'ISR', 'إسرائيل'),
(97145, 3572203520, 3572236287, 'SI', 'SVN', 'سلوفينيا'),
(97146, 3572236288, 3572301823, 'AT', 'AUT', 'النمسا'),
(97147, 3572301824, 3572367359, 'DK', 'DNK', 'الدنيمارك'),
(97148, 3572367360, 3572432895, 'NL', 'NLD', 'هولندا'),
(97149, 3572432896, 3572436047, 'IT', 'ITA', 'إيطاليا'),
(97150, 3572436048, 3572436063, 'GB', 'GBR', 'المملكة المتحدة'),
(97151, 3572436064, 3572442495, 'IT', 'ITA', 'إيطاليا'),
(97152, 3572442496, 3572442511, 'NL', 'NLD', 'هولندا'),
(97153, 3572442512, 3572447231, 'IT', 'ITA', 'إيطاليا'),
(97154, 3572447232, 3572447239, 'AT', 'AUT', 'النمسا'),
(97155, 3572447240, 3572447247, 'FR', 'FRA', 'فرنسا'),
(97156, 3572447248, 3572447255, 'GB', 'GBR', 'المملكة المتحدة'),
(97157, 3572447256, 3572447263, 'ES', 'ESP', 'إسبانيا'),
(97158, 3572447264, 3572465663, 'IT', 'ITA', 'إيطاليا'),
(97159, 3572465664, 3572498431, 'BE', 'BEL', 'بلجيكا'),
(97160, 3572498432, 3572563967, 'GB', 'GBR', 'المملكة المتحدة'),
(97161, 3572563968, 3572572159, 'KG', 'KGZ', 'قيرغيزستان'),
(97162, 3572572160, 3572580351, 'NL', 'NLD', 'هولندا'),
(97163, 3572580352, 3572596735, 'AT', 'AUT', 'النمسا'),
(97164, 3572596736, 3572629503, 'GB', 'GBR', 'المملكة المتحدة'),
(97165, 3572629504, 3572695039, 'DK', 'DNK', 'الدنيمارك'),
(97166, 3572695040, 3572704951, 'CH', 'CHE', 'سويسرا'),
(97167, 3572704952, 3572704959, 'DE', 'DEU', 'ألمانيا'),
(97168, 3572704960, 3572705479, 'CH', 'CHE', 'سويسرا'),
(97169, 3572705480, 3572705487, 'NL', 'NLD', 'هولندا'),
(97170, 3572705488, 3572715519, 'CH', 'CHE', 'سويسرا'),
(97171, 3572715520, 3572715775, 'GB', 'GBR', 'المملكة المتحدة'),
(97172, 3572715776, 3572760575, 'CH', 'CHE', 'سويسرا'),
(97173, 3572760576, 3572826111, 'PL', 'POL', 'بولندا'),
(97174, 3572826112, 3572891647, 'IT', 'ITA', 'إيطاليا'),
(97175, 3572891648, 3572957183, 'FI', 'FIN', 'فنلندا'),
(97176, 3572957184, 3573022719, 'SE', 'SWE', 'السويد'),
(97177, 3573022720, 3573055487, 'RU', 'RUS', 'الإتحاد الروسي'),
(97178, 3573055488, 3573088255, 'GB', 'GBR', 'المملكة المتحدة'),
(97179, 3573088256, 3573088263, 'CH', 'CHE', 'سويسرا'),
(97180, 3573088264, 3573088271, 'DE', 'DEU', 'ألمانيا'),
(97181, 3573088272, 3573089759, 'CH', 'CHE', 'سويسرا'),
(97182, 3573089760, 3573089791, 'AT', 'AUT', 'النمسا'),
(97183, 3573089792, 3573090055, 'CH', 'CHE', 'سويسرا'),
(97184, 3573090056, 3573090063, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(97185, 3573090064, 3573142015, 'CH', 'CHE', 'سويسرا'),
(97186, 3573142016, 3573142271, 'AT', 'AUT', 'النمسا'),
(97187, 3573142272, 3573153791, 'CH', 'CHE', 'سويسرا'),
(97188, 3573153792, 3573175711, 'GB', 'GBR', 'المملكة المتحدة'),
(97189, 3573175712, 3573175727, 'IE', 'IRL', 'إيرلندا'),
(97190, 3573175728, 3573208511, 'GB', 'GBR', 'المملكة المتحدة'),
(97191, 3573208512, 3573208543, 'IE', 'IRL', 'إيرلندا'),
(97192, 3573208544, 3573219327, 'GB', 'GBR', 'المملكة المتحدة'),
(97193, 3573219328, 3573252095, 'GR', 'GRC', 'اليونان'),
(97194, 3573252096, 3573284863, 'NO', 'NOR', 'النرويج'),
(97195, 3573284864, 3573415935, 'TR', 'TUR', 'تركيا'),
(97196, 3573415936, 3573481471, 'CH', 'CHE', 'سويسرا'),
(97197, 3573481472, 3573547007, 'DE', 'DEU', 'ألمانيا'),
(97198, 3573547008, 3573612543, 'ES', 'ESP', 'إسبانيا'),
(97199, 3573612544, 3573743615, 'GB', 'GBR', 'المملكة المتحدة'),
(97200, 3573743616, 3573809151, 'CH', 'CHE', 'سويسرا'),
(97201, 3573809152, 3573874687, 'ES', 'ESP', 'إسبانيا'),
(97202, 3573874688, 3573878783, 'PL', 'POL', 'بولندا'),
(97203, 3573878784, 3573882879, 'RU', 'RUS', 'الإتحاد الروسي'),
(97204, 3573882880, 3573884927, 'DK', 'DNK', 'الدنيمارك'),
(97205, 3573884928, 3573886975, 'PL', 'POL', 'بولندا'),
(97206, 3573886976, 3573889023, 'RU', 'RUS', 'الإتحاد الروسي'),
(97207, 3573889024, 3573891071, 'HR', 'HRV', 'كرواتيا'),
(97208, 3573891072, 3573893119, 'NL', 'NLD', 'هولندا'),
(97209, 3573893120, 3573897215, 'RU', 'RUS', 'الإتحاد الروسي'),
(97210, 3573897216, 3573899263, 'GB', 'GBR', 'المملكة المتحدة'),
(97211, 3573899264, 3573903359, 'RU', 'RUS', 'الإتحاد الروسي'),
(97212, 3573903360, 3573905407, 'SI', 'SVN', 'سلوفينيا'),
(97213, 3573905408, 3573909503, 'RU', 'RUS', 'الإتحاد الروسي'),
(97214, 3573909504, 3573913599, 'PL', 'POL', 'بولندا'),
(97215, 3573913600, 3573915647, 'CH', 'CHE', 'سويسرا'),
(97216, 3573915648, 3573917695, 'RU', 'RUS', 'الإتحاد الروسي'),
(97217, 3573917696, 3573919743, 'SA', 'SAU', 'السعودية'),
(97218, 3573919744, 3573921791, 'GB', 'GBR', 'المملكة المتحدة'),
(97219, 3573921792, 3573923839, 'RU', 'RUS', 'الإتحاد الروسي'),
(97220, 3573923840, 3573925887, 'UA', 'UKR', 'أوكرانيا'),
(97221, 3573925888, 3573929983, 'PL', 'POL', 'بولندا'),
(97222, 3573929984, 3573938175, 'RU', 'RUS', 'الإتحاد الروسي'),
(97223, 3573938176, 3573940223, 'PL', 'POL', 'بولندا'),
(97224, 3573940224, 3574005759, 'PS', 'PSE', 'فلسطين المحتلة'),
(97225, 3574005760, 3574071295, 'CY', 'CYP', 'قبرص'),
(97226, 3574071296, 3574136831, 'IL', 'ISR', 'إسرائيل'),
(97227, 3574136832, 3574137783, 'DE', 'DEU', 'ألمانيا'),
(97228, 3574137784, 3574137791, 'AT', 'AUT', 'النمسا'),
(97229, 3574137792, 3574137823, 'DE', 'DEU', 'ألمانيا'),
(97230, 3574137824, 3574137855, 'NL', 'NLD', 'هولندا'),
(97231, 3574137856, 3574138559, 'DE', 'DEU', 'ألمانيا'),
(97232, 3574138560, 3574138623, 'NL', 'NLD', 'هولندا'),
(97233, 3574138624, 3574138735, 'DE', 'DEU', 'ألمانيا'),
(97234, 3574138736, 3574138751, 'NL', 'NLD', 'هولندا'),
(97235, 3574138752, 3574138767, 'DE', 'DEU', 'ألمانيا'),
(97236, 3574138768, 3574138775, 'NL', 'NLD', 'هولندا'),
(97237, 3574138776, 3574151823, 'DE', 'DEU', 'ألمانيا'),
(97238, 3574151824, 3574151831, 'AT', 'AUT', 'النمسا'),
(97239, 3574151832, 3574153359, 'DE', 'DEU', 'ألمانيا'),
(97240, 3574153360, 3574153367, 'AT', 'AUT', 'النمسا'),
(97241, 3574153368, 3574153615, 'DE', 'DEU', 'ألمانيا'),
(97242, 3574153616, 3574153623, 'AT', 'AUT', 'النمسا'),
(97243, 3574153624, 3574153731, 'DE', 'DEU', 'ألمانيا'),
(97244, 3574153732, 3574153735, 'HU', 'HUN', 'هنغاريا'),
(97245, 3574153736, 3574155627, 'DE', 'DEU', 'ألمانيا'),
(97246, 3574155628, 3574155631, 'NL', 'NLD', 'هولندا'),
(97247, 3574155632, 3574155727, 'DE', 'DEU', 'ألمانيا'),
(97248, 3574155728, 3574155731, 'AT', 'AUT', 'النمسا'),
(97249, 3574155732, 3574155739, 'DE', 'DEU', 'ألمانيا'),
(97250, 3574155740, 3574155743, 'AT', 'AUT', 'النمسا'),
(97251, 3574155744, 3574155819, 'DE', 'DEU', 'ألمانيا'),
(97252, 3574155820, 3574155823, 'NO', 'NOR', 'النرويج'),
(97253, 3574155824, 3574155851, 'DE', 'DEU', 'ألمانيا'),
(97254, 3574155852, 3574155855, 'NO', 'NOR', 'النرويج'),
(97255, 3574155856, 3574155859, 'DE', 'DEU', 'ألمانيا'),
(97256, 3574155860, 3574155863, 'NO', 'NOR', 'النرويج'),
(97257, 3574155864, 3574159919, 'DE', 'DEU', 'ألمانيا'),
(97258, 3574159920, 3574159927, 'NL', 'NLD', 'هولندا'),
(97259, 3574159928, 3574160931, 'DE', 'DEU', 'ألمانيا'),
(97260, 3574160932, 3574160935, 'NL', 'NLD', 'هولندا'),
(97261, 3574160936, 3574161039, 'DE', 'DEU', 'ألمانيا'),
(97262, 3574161040, 3574161043, 'NL', 'NLD', 'هولندا'),
(97263, 3574161044, 3574161055, 'DE', 'DEU', 'ألمانيا'),
(97264, 3574161056, 3574161087, 'NL', 'NLD', 'هولندا'),
(97265, 3574161088, 3574161107, 'DE', 'DEU', 'ألمانيا'),
(97266, 3574161108, 3574161111, 'NL', 'NLD', 'هولندا'),
(97267, 3574161112, 3574161171, 'DE', 'DEU', 'ألمانيا'),
(97268, 3574161172, 3574161175, 'NO', 'NOR', 'النرويج'),
(97269, 3574161176, 3574161319, 'DE', 'DEU', 'ألمانيا'),
(97270, 3574161320, 3574161323, 'NO', 'NOR', 'النرويج'),
(97271, 3574161324, 3574161335, 'DE', 'DEU', 'ألمانيا'),
(97272, 3574161336, 3574161339, 'AI', 'AIA', 'أنغيلا'),
(97273, 3574161340, 3574161391, 'DE', 'DEU', 'ألمانيا'),
(97274, 3574161392, 3574161395, 'NO', 'NOR', 'النرويج'),
(97275, 3574161396, 3574169599, 'DE', 'DEU', 'ألمانيا'),
(97276, 3574169600, 3574202367, 'ES', 'ESP', 'إسبانيا'),
(97277, 3574202368, 3574267903, 'NL', 'NLD', 'هولندا'),
(97278, 3574267904, 3574333439, 'FR', 'FRA', 'فرنسا'),
(97279, 3574333440, 3574341631, 'GB', 'GBR', 'المملكة المتحدة'),
(97280, 3574348288, 3574348543, 'GB', 'GBR', 'المملكة المتحدة'),
(97281, 3574398976, 3574464511, 'PT', 'PRT', 'البورتوغال'),
(97282, 3574464512, 3574530047, 'TR', 'TUR', 'تركيا'),
(97283, 3574530048, 3574563679, 'SE', 'SWE', 'السويد'),
(97284, 3574563680, 3574563695, 'FI', 'FIN', 'فنلندا'),
(97285, 3574563696, 3574563727, 'SE', 'SWE', 'السويد'),
(97286, 3574563728, 3574563775, 'FI', 'FIN', 'فنلندا'),
(97287, 3574563776, 3574563807, 'SE', 'SWE', 'السويد'),
(97288, 3574563808, 3574563823, 'FI', 'FIN', 'فنلندا'),
(97289, 3574563824, 3574563839, 'SE', 'SWE', 'السويد'),
(97290, 3574563840, 3574564863, 'FI', 'FIN', 'فنلندا'),
(97291, 3574564864, 3574565887, 'SE', 'SWE', 'السويد'),
(97292, 3574565888, 3574565951, 'FI', 'FIN', 'فنلندا'),
(97293, 3574565952, 3574566207, 'SE', 'SWE', 'السويد'),
(97294, 3574566208, 3574566271, 'FI', 'FIN', 'فنلندا'),
(97295, 3574566272, 3574566447, 'SE', 'SWE', 'السويد'),
(97296, 3574566448, 3574566463, 'FI', 'FIN', 'فنلندا'),
(97297, 3574566464, 3574594559, 'SE', 'SWE', 'السويد'),
(97298, 3574594560, 3574595583, 'GB', 'GBR', 'المملكة المتحدة'),
(97299, 3574595584, 3574596351, 'FR', 'FRA', 'فرنسا'),
(97300, 3574596352, 3574596607, 'MQ', 'MTQ', 'مارتينيك'),
(97301, 3574596608, 3574597631, 'FR', 'FRA', 'فرنسا'),
(97302, 3574597632, 3574597887, 'GP', 'GLP', 'جوادلوب'),
(97303, 3574597888, 3574598655, 'FR', 'FRA', 'فرنسا'),
(97304, 3574598656, 3574599679, 'MQ', 'MTQ', 'مارتينيك'),
(97305, 3574599680, 3574600191, 'FR', 'FRA', 'فرنسا'),
(97306, 3574600192, 3574601215, 'MQ', 'MTQ', 'مارتينيك'),
(97307, 3574601216, 3574601471, 'RE', 'REU', 'ريونيون'),
(97308, 3574601472, 3574601983, 'MQ', 'MTQ', 'مارتينيك'),
(97309, 3574601984, 3574602239, 'GF', 'GUF', 'غيانا الفرنسية'),
(97310, 3574602240, 3574602495, 'FR', 'FRA', 'فرنسا'),
(97311, 3574602496, 3574603263, 'MQ', 'MTQ', 'مارتينيك'),
(97312, 3574603264, 3574603775, 'FR', 'FRA', 'فرنسا'),
(97313, 3574603776, 3574611967, 'BG', 'BGR', 'بلغاريا'),
(97314, 3574611968, 3574628351, 'HU', 'HUN', 'هنغاريا'),
(97315, 3574628352, 3574661119, 'GR', 'GRC', 'اليونان'),
(97316, 3574661120, 3574693887, 'NL', 'NLD', 'هولندا'),
(97317, 3574693888, 3574726655, 'PL', 'POL', 'بولندا'),
(97318, 3574726656, 3574792191, 'GB', 'GBR', 'المملكة المتحدة'),
(97319, 3574792192, 3574824959, 'CZ', 'CZE', 'التشيك'),
(97320, 3574824960, 3574825279, 'GB', 'GBR', 'المملكة المتحدة'),
(97321, 3574825280, 3574825407, 'NL', 'NLD', 'هولندا'),
(97322, 3574825408, 3574825471, 'GB', 'GBR', 'المملكة المتحدة'),
(97323, 3574825472, 3574826111, 'NL', 'NLD', 'هولندا'),
(97324, 3574826112, 3574826239, 'GB', 'GBR', 'المملكة المتحدة'),
(97325, 3574826240, 3574826751, 'NL', 'NLD', 'هولندا'),
(97326, 3574826752, 3574827007, 'GB', 'GBR', 'المملكة المتحدة'),
(97327, 3574827008, 3574829311, 'NL', 'NLD', 'هولندا'),
(97328, 3574829312, 3574829567, 'GB', 'GBR', 'المملكة المتحدة'),
(97329, 3574829568, 3574829823, 'NL', 'NLD', 'هولندا'),
(97330, 3574829824, 3574830079, 'GB', 'GBR', 'المملكة المتحدة'),
(97331, 3574830080, 3574831359, 'NL', 'NLD', 'هولندا'),
(97332, 3574831360, 3574833279, 'GB', 'GBR', 'المملكة المتحدة'),
(97333, 3574833280, 3574833311, 'NL', 'NLD', 'هولندا'),
(97334, 3574833312, 3574833343, 'GB', 'GBR', 'المملكة المتحدة'),
(97335, 3574833344, 3574833359, 'NL', 'NLD', 'هولندا'),
(97336, 3574833360, 3574833407, 'GB', 'GBR', 'المملكة المتحدة'),
(97337, 3574833408, 3574833439, 'NL', 'NLD', 'هولندا'),
(97338, 3574833440, 3574834431, 'GB', 'GBR', 'المملكة المتحدة'),
(97339, 3574834432, 3574834559, 'NL', 'NLD', 'هولندا'),
(97340, 3574834560, 3574834687, 'GB', 'GBR', 'المملكة المتحدة'),
(97341, 3574834688, 3574835199, 'NL', 'NLD', 'هولندا'),
(97342, 3574835200, 3574836351, 'GB', 'GBR', 'المملكة المتحدة'),
(97343, 3574836352, 3574838015, 'NL', 'NLD', 'هولندا'),
(97344, 3574838016, 3574838271, 'GB', 'GBR', 'المملكة المتحدة'),
(97345, 3574838272, 3574838527, 'NL', 'NLD', 'هولندا'),
(97346, 3574838528, 3574857727, 'GB', 'GBR', 'المملكة المتحدة'),
(97347, 3574857728, 3574917375, 'DE', 'DEU', 'ألمانيا'),
(97348, 3574917376, 3574917631, 'CH', 'CHE', 'سويسرا'),
(97349, 3574917632, 3574919359, 'DE', 'DEU', 'ألمانيا'),
(97350, 3574919360, 3574919391, 'FR', 'FRA', 'فرنسا'),
(97351, 3574919392, 3574923263, 'DE', 'DEU', 'ألمانيا'),
(97352, 3574923264, 3574939647, 'RU', 'RUS', 'الإتحاد الروسي'),
(97353, 3574939648, 3574956031, 'SE', 'SWE', 'السويد'),
(97354, 3574956032, 3574972415, 'IT', 'ITA', 'إيطاليا'),
(97355, 3574972416, 3574988799, 'LV', 'LVA', 'لاتفيا'),
(97356, 3574988800, 3575054335, 'PT', 'PRT', 'البورتوغال'),
(97357, 3575054336, 3575086175, 'DE', 'DEU', 'ألمانيا'),
(97358, 3575086176, 3575086207, 'MT', 'MLT', 'مالطا'),
(97359, 3575086208, 3575119871, 'DE', 'DEU', 'ألمانيا'),
(97360, 3575119872, 3575185407, 'RU', 'RUS', 'الإتحاد الروسي'),
(97361, 3575185408, 3575250943, 'PL', 'POL', 'بولندا'),
(97362, 3575250944, 3575316479, 'IT', 'ITA', 'إيطاليا'),
(97363, 3575316480, 3575349247, 'RU', 'RUS', 'الإتحاد الروسي'),
(97364, 3575349248, 3575355231, 'ES', 'ESP', 'إسبانيا'),
(97365, 3575355232, 3575355247, 'GB', 'GBR', 'المملكة المتحدة'),
(97366, 3575355248, 3575360199, 'ES', 'ESP', 'إسبانيا'),
(97367, 3575360200, 3575360207, 'FR', 'FRA', 'فرنسا'),
(97368, 3575360208, 3575367111, 'ES', 'ESP', 'إسبانيا'),
(97369, 3575367112, 3575367119, 'DE', 'DEU', 'ألمانيا'),
(97370, 3575367120, 3575372159, 'ES', 'ESP', 'إسبانيا'),
(97371, 3575372160, 3575372167, 'GB', 'GBR', 'المملكة المتحدة'),
(97372, 3575372168, 3575372239, 'ES', 'ESP', 'إسبانيا'),
(97373, 3575372240, 3575372247, 'PT', 'PRT', 'البورتوغال'),
(97374, 3575372248, 3575382015, 'ES', 'ESP', 'إسبانيا'),
(97375, 3575382016, 3575412991, 'FI', 'FIN', 'فنلندا'),
(97376, 3575412992, 3575413119, 'RU', 'RUS', 'الإتحاد الروسي'),
(97377, 3575413120, 3575447551, 'FI', 'FIN', 'فنلندا'),
(97378, 3575447552, 3575513087, 'CZ', 'CZE', 'التشيك'),
(97379, 3575513088, 3575545855, 'PT', 'PRT', 'البورتوغال'),
(97380, 3575545856, 3575562239, 'FR', 'FRA', 'فرنسا'),
(97381, 3575562240, 3575578623, 'DE', 'DEU', 'ألمانيا'),
(97382, 3575578624, 3575578879, 'BE', 'BEL', 'بلجيكا'),
(97383, 3575578880, 3575579135, 'AU', 'AUS', 'أستراليا'),
(97384, 3575579136, 3575579647, 'BE', 'BEL', 'بلجيكا'),
(97385, 3575579648, 3575579903, 'AU', 'AUS', 'أستراليا'),
(97386, 3575579904, 3575581439, 'BE', 'BEL', 'بلجيكا'),
(97387, 3575581440, 3575581567, 'GB', 'GBR', 'المملكة المتحدة'),
(97388, 3575581568, 3575581695, 'IT', 'ITA', 'إيطاليا'),
(97389, 3575581696, 3575582207, 'BE', 'BEL', 'بلجيكا'),
(97390, 3575582208, 3575582463, 'CH', 'CHE', 'سويسرا'),
(97391, 3575582464, 3575582719, 'FR', 'FRA', 'فرنسا'),
(97392, 3575582720, 3575583103, 'BE', 'BEL', 'بلجيكا'),
(97393, 3575583104, 3575583111, 'HU', 'HUN', 'هنغاريا'),
(97394, 3575583112, 3575583115, 'GB', 'GBR', 'المملكة المتحدة'),
(97395, 3575583116, 3575583119, 'FR', 'FRA', 'فرنسا'),
(97396, 3575583120, 3575583231, 'BE', 'BEL', 'بلجيكا'),
(97397, 3575583232, 3575583487, 'IT', 'ITA', 'إيطاليا'),
(97398, 3575583488, 3575585791, 'BE', 'BEL', 'بلجيكا'),
(97399, 3575585792, 3575586047, 'EG', 'EGY', 'مصر'),
(97400, 3575586048, 3575586303, 'IT', 'ITA', 'إيطاليا'),
(97401, 3575586304, 3575586815, 'BE', 'BEL', 'بلجيكا'),
(97402, 3575586816, 3575587071, 'GB', 'GBR', 'المملكة المتحدة'),
(97403, 3575587072, 3575587231, 'BE', 'BEL', 'بلجيكا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(97404, 3575587232, 3575587247, 'NL', 'NLD', 'هولندا'),
(97405, 3575587248, 3575587255, 'FR', 'FRA', 'فرنسا'),
(97406, 3575587256, 3575587263, 'BE', 'BEL', 'بلجيكا'),
(97407, 3575587264, 3575587271, 'CH', 'CHE', 'سويسرا'),
(97408, 3575587272, 3575587287, 'BE', 'BEL', 'بلجيكا'),
(97409, 3575587288, 3575587295, 'PL', 'POL', 'بولندا'),
(97410, 3575587296, 3575587319, 'BE', 'BEL', 'بلجيكا'),
(97411, 3575587320, 3575587323, 'PL', 'POL', 'بولندا'),
(97412, 3575587324, 3575587839, 'BE', 'BEL', 'بلجيكا'),
(97413, 3575587840, 3575588351, 'GB', 'GBR', 'المملكة المتحدة'),
(97414, 3575588352, 3575588863, 'BE', 'BEL', 'بلجيكا'),
(97415, 3575588864, 3575589887, 'FR', 'FRA', 'فرنسا'),
(97416, 3575589888, 3575590399, 'BE', 'BEL', 'بلجيكا'),
(97417, 3575590400, 3575590911, 'FR', 'FRA', 'فرنسا'),
(97418, 3575590912, 3575595007, 'BE', 'BEL', 'بلجيكا'),
(97419, 3575595008, 3575595519, 'GB', 'GBR', 'المملكة المتحدة'),
(97420, 3575595520, 3575596287, 'BE', 'BEL', 'بلجيكا'),
(97421, 3575596288, 3575596415, 'GB', 'GBR', 'المملكة المتحدة'),
(97422, 3575596416, 3575596543, 'BE', 'BEL', 'بلجيكا'),
(97423, 3575596544, 3575596799, 'FR', 'FRA', 'فرنسا'),
(97424, 3575596800, 3575622607, 'BE', 'BEL', 'بلجيكا'),
(97425, 3575622608, 3575622611, 'GB', 'GBR', 'المملكة المتحدة'),
(97426, 3575622612, 3575622655, 'BE', 'BEL', 'بلجيكا'),
(97427, 3575622656, 3575622815, 'GB', 'GBR', 'المملكة المتحدة'),
(97428, 3575622816, 3575622847, 'BE', 'BEL', 'بلجيكا'),
(97429, 3575622848, 3575622879, 'IT', 'ITA', 'إيطاليا'),
(97430, 3575622880, 3575622911, 'FI', 'FIN', 'فنلندا'),
(97431, 3575622912, 3575623167, 'GB', 'GBR', 'المملكة المتحدة'),
(97432, 3575623168, 3575624703, 'BE', 'BEL', 'بلجيكا'),
(97433, 3575624704, 3575624831, 'FR', 'FRA', 'فرنسا'),
(97434, 3575624832, 3575624839, 'PT', 'PRT', 'البورتوغال'),
(97435, 3575624840, 3575624863, 'GB', 'GBR', 'المملكة المتحدة'),
(97436, 3575624864, 3575624895, 'IL', 'ISR', 'إسرائيل'),
(97437, 3575624896, 3575624911, 'GB', 'GBR', 'المملكة المتحدة'),
(97438, 3575624912, 3575624959, 'BE', 'BEL', 'بلجيكا'),
(97439, 3575624960, 3575624991, 'GB', 'GBR', 'المملكة المتحدة'),
(97440, 3575624992, 3575624999, 'IT', 'ITA', 'إيطاليا'),
(97441, 3575625000, 3575625007, 'GB', 'GBR', 'المملكة المتحدة'),
(97442, 3575625008, 3575625023, 'NL', 'NLD', 'هولندا'),
(97443, 3575625024, 3575625027, 'EG', 'EGY', 'مصر'),
(97444, 3575625028, 3575625035, 'BE', 'BEL', 'بلجيكا'),
(97445, 3575625036, 3575625039, 'GB', 'GBR', 'المملكة المتحدة'),
(97446, 3575625040, 3575625047, 'BE', 'BEL', 'بلجيكا'),
(97447, 3575625048, 3575625055, 'FI', 'FIN', 'فنلندا'),
(97448, 3575625056, 3575625071, 'BE', 'BEL', 'بلجيكا'),
(97449, 3575625072, 3575625087, 'PL', 'POL', 'بولندا'),
(97450, 3575625088, 3575625103, 'BE', 'BEL', 'بلجيكا'),
(97451, 3575625104, 3575625151, 'GB', 'GBR', 'المملكة المتحدة'),
(97452, 3575625152, 3575625351, 'BE', 'BEL', 'بلجيكا'),
(97453, 3575625352, 3575625359, 'GB', 'GBR', 'المملكة المتحدة'),
(97454, 3575625360, 3575625375, 'BE', 'BEL', 'بلجيكا'),
(97455, 3575625376, 3575625407, 'IT', 'ITA', 'إيطاليا'),
(97456, 3575625408, 3575625439, 'BE', 'BEL', 'بلجيكا'),
(97457, 3575625440, 3575625455, 'ES', 'ESP', 'إسبانيا'),
(97458, 3575625456, 3575625471, 'BE', 'BEL', 'بلجيكا'),
(97459, 3575625472, 3575625503, 'NO', 'NOR', 'النرويج'),
(97460, 3575625504, 3575625983, 'BE', 'BEL', 'بلجيكا'),
(97461, 3575625984, 3575625991, 'SE', 'SWE', 'السويد'),
(97462, 3575625992, 3575626047, 'BE', 'BEL', 'بلجيكا'),
(97463, 3575626048, 3575626111, 'FR', 'FRA', 'فرنسا'),
(97464, 3575626112, 3575626319, 'BE', 'BEL', 'بلجيكا'),
(97465, 3575626320, 3575626335, 'GB', 'GBR', 'المملكة المتحدة'),
(97466, 3575626336, 3575626351, 'ES', 'ESP', 'إسبانيا'),
(97467, 3575626352, 3575626367, 'DE', 'DEU', 'ألمانيا'),
(97468, 3575626368, 3575626503, 'BE', 'BEL', 'بلجيكا'),
(97469, 3575626504, 3575626511, 'CH', 'CHE', 'سويسرا'),
(97470, 3575626512, 3575626519, 'BE', 'BEL', 'بلجيكا'),
(97471, 3575626520, 3575626527, 'FR', 'FRA', 'فرنسا'),
(97472, 3575626528, 3575626567, 'BE', 'BEL', 'بلجيكا'),
(97473, 3575626568, 3575626575, 'RO', 'ROM', 'رومانيا'),
(97474, 3575626576, 3575626599, 'BE', 'BEL', 'بلجيكا'),
(97475, 3575626600, 3575626607, 'IE', 'IRL', 'إيرلندا'),
(97476, 3575626608, 3575626631, 'BE', 'BEL', 'بلجيكا'),
(97477, 3575626632, 3575626639, 'GB', 'GBR', 'المملكة المتحدة'),
(97478, 3575626640, 3575626647, 'DE', 'DEU', 'ألمانيا'),
(97479, 3575626648, 3575626655, 'IT', 'ITA', 'إيطاليا'),
(97480, 3575626656, 3575627311, 'BE', 'BEL', 'بلجيكا'),
(97481, 3575627312, 3575627327, 'ES', 'ESP', 'إسبانيا'),
(97482, 3575627328, 3575627335, 'SE', 'SWE', 'السويد'),
(97483, 3575627336, 3575627359, 'BE', 'BEL', 'بلجيكا'),
(97484, 3575627360, 3575627367, 'ES', 'ESP', 'إسبانيا'),
(97485, 3575627368, 3575627423, 'BE', 'BEL', 'بلجيكا'),
(97486, 3575627424, 3575627431, 'DE', 'DEU', 'ألمانيا'),
(97487, 3575627432, 3575627487, 'BE', 'BEL', 'بلجيكا'),
(97488, 3575627488, 3575627503, 'GB', 'GBR', 'المملكة المتحدة'),
(97489, 3575627504, 3575627711, 'BE', 'BEL', 'بلجيكا'),
(97490, 3575627712, 3575627775, 'GB', 'GBR', 'المملكة المتحدة'),
(97491, 3575627776, 3575628543, 'NL', 'NLD', 'هولندا'),
(97492, 3575628544, 3575628631, 'BE', 'BEL', 'بلجيكا'),
(97493, 3575628632, 3575628639, 'GB', 'GBR', 'المملكة المتحدة'),
(97494, 3575628640, 3575628815, 'BE', 'BEL', 'بلجيكا'),
(97495, 3575628816, 3575628823, 'ES', 'ESP', 'إسبانيا'),
(97496, 3575628824, 3575628831, 'FR', 'FRA', 'فرنسا'),
(97497, 3575628832, 3575629183, 'BE', 'BEL', 'بلجيكا'),
(97498, 3575629184, 3575629247, 'NL', 'NLD', 'هولندا'),
(97499, 3575629248, 3575629279, 'BE', 'BEL', 'بلجيكا'),
(97500, 3575629280, 3575629287, 'GB', 'GBR', 'المملكة المتحدة'),
(97501, 3575629288, 3575629295, 'BE', 'BEL', 'بلجيكا'),
(97502, 3575629296, 3575629303, 'NL', 'NLD', 'هولندا'),
(97503, 3575629304, 3575629823, 'BE', 'BEL', 'بلجيكا'),
(97504, 3575629824, 3575629855, 'GR', 'GRC', 'اليونان'),
(97505, 3575629856, 3575629871, 'DE', 'DEU', 'ألمانيا'),
(97506, 3575629872, 3575629935, 'BE', 'BEL', 'بلجيكا'),
(97507, 3575629936, 3575629951, 'FR', 'FRA', 'فرنسا'),
(97508, 3575629952, 3575630015, 'BE', 'BEL', 'بلجيكا'),
(97509, 3575630016, 3575630023, 'GR', 'GRC', 'اليونان'),
(97510, 3575630024, 3575630063, 'BE', 'BEL', 'بلجيكا'),
(97511, 3575630064, 3575630079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(97512, 3575630080, 3575630335, 'BE', 'BEL', 'بلجيكا'),
(97513, 3575630336, 3575630463, 'IT', 'ITA', 'إيطاليا'),
(97514, 3575630464, 3575630591, 'CH', 'CHE', 'سويسرا'),
(97515, 3575630592, 3575630847, 'IL', 'ISR', 'إسرائيل'),
(97516, 3575630848, 3575630975, 'BE', 'BEL', 'بلجيكا'),
(97517, 3575630976, 3575630991, 'FR', 'FRA', 'فرنسا'),
(97518, 3575630992, 3575631103, 'BE', 'BEL', 'بلجيكا'),
(97519, 3575631104, 3575631111, 'AT', 'AUT', 'النمسا'),
(97520, 3575631112, 3575631119, 'CH', 'CHE', 'سويسرا'),
(97521, 3575631120, 3575631127, 'DE', 'DEU', 'ألمانيا'),
(97522, 3575631128, 3575631135, 'BE', 'BEL', 'بلجيكا'),
(97523, 3575631136, 3575631143, 'HU', 'HUN', 'هنغاريا'),
(97524, 3575631144, 3575631159, 'BE', 'BEL', 'بلجيكا'),
(97525, 3575631160, 3575631167, 'GB', 'GBR', 'المملكة المتحدة'),
(97526, 3575631168, 3575631199, 'NL', 'NLD', 'هولندا'),
(97527, 3575631200, 3575631207, 'IE', 'IRL', 'إيرلندا'),
(97528, 3575631208, 3575631223, 'BE', 'BEL', 'بلجيكا'),
(97529, 3575631224, 3575631231, 'IL', 'ISR', 'إسرائيل'),
(97530, 3575631232, 3575631295, 'CH', 'CHE', 'سويسرا'),
(97531, 3575631296, 3575631615, 'BE', 'BEL', 'بلجيكا'),
(97532, 3575631616, 3575631631, 'SE', 'SWE', 'السويد'),
(97533, 3575631632, 3575631639, 'BE', 'BEL', 'بلجيكا'),
(97534, 3575631640, 3575631647, 'CH', 'CHE', 'سويسرا'),
(97535, 3575631648, 3575631663, 'SE', 'SWE', 'السويد'),
(97536, 3575631664, 3575631679, 'DE', 'DEU', 'ألمانيا'),
(97537, 3575631680, 3575631695, 'SE', 'SWE', 'السويد'),
(97538, 3575631696, 3575631711, 'IT', 'ITA', 'إيطاليا'),
(97539, 3575631712, 3575631759, 'BE', 'BEL', 'بلجيكا'),
(97540, 3575631760, 3575631775, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(97541, 3575631776, 3575631791, 'BE', 'BEL', 'بلجيكا'),
(97542, 3575631792, 3575631799, 'ES', 'ESP', 'إسبانيا'),
(97543, 3575631800, 3575631807, 'CZ', 'CZE', 'التشيك'),
(97544, 3575631808, 3575631855, 'BE', 'BEL', 'بلجيكا'),
(97545, 3575631856, 3575631863, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(97546, 3575631864, 3575631871, 'BE', 'BEL', 'بلجيكا'),
(97547, 3575631872, 3575632639, 'IL', 'ISR', 'إسرائيل'),
(97548, 3575632640, 3575632655, 'NO', 'NOR', 'النرويج'),
(97549, 3575632656, 3575632703, 'BE', 'BEL', 'بلجيكا'),
(97550, 3575632704, 3575632711, 'GB', 'GBR', 'المملكة المتحدة'),
(97551, 3575632712, 3575632783, 'BE', 'BEL', 'بلجيكا'),
(97552, 3575632784, 3575632791, 'GB', 'GBR', 'المملكة المتحدة'),
(97553, 3575632792, 3575632847, 'BE', 'BEL', 'بلجيكا'),
(97554, 3575632848, 3575632863, 'CH', 'CHE', 'سويسرا'),
(97555, 3575632864, 3575632879, 'BE', 'BEL', 'بلجيكا'),
(97556, 3575632880, 3575632895, 'DE', 'DEU', 'ألمانيا'),
(97557, 3575632896, 3575632967, 'BE', 'BEL', 'بلجيكا'),
(97558, 3575632968, 3575632975, 'GB', 'GBR', 'المملكة المتحدة'),
(97559, 3575632976, 3575632991, 'BE', 'BEL', 'بلجيكا'),
(97560, 3575632992, 3575632999, 'IT', 'ITA', 'إيطاليا'),
(97561, 3575633000, 3575633039, 'BE', 'BEL', 'بلجيكا'),
(97562, 3575633040, 3575633055, 'DE', 'DEU', 'ألمانيا'),
(97563, 3575633056, 3575633063, 'SE', 'SWE', 'السويد'),
(97564, 3575633064, 3575633071, 'NL', 'NLD', 'هولندا'),
(97565, 3575633072, 3575633087, 'BE', 'BEL', 'بلجيكا'),
(97566, 3575633088, 3575633119, 'GB', 'GBR', 'المملكة المتحدة'),
(97567, 3575633120, 3575633135, 'BE', 'BEL', 'بلجيكا'),
(97568, 3575633136, 3575633143, 'GB', 'GBR', 'المملكة المتحدة'),
(97569, 3575633144, 3575633599, 'BE', 'BEL', 'بلجيكا'),
(97570, 3575633600, 3575633663, 'NL', 'NLD', 'هولندا'),
(97571, 3575633664, 3575633727, 'BE', 'BEL', 'بلجيكا'),
(97572, 3575633728, 3575633735, 'AT', 'AUT', 'النمسا'),
(97573, 3575633736, 3575633743, 'IT', 'ITA', 'إيطاليا'),
(97574, 3575633744, 3575633783, 'BE', 'BEL', 'بلجيكا'),
(97575, 3575633784, 3575633791, 'DE', 'DEU', 'ألمانيا'),
(97576, 3575633792, 3575633887, 'BE', 'BEL', 'بلجيكا'),
(97577, 3575633888, 3575633895, 'SE', 'SWE', 'السويد'),
(97578, 3575633896, 3575633919, 'BE', 'BEL', 'بلجيكا'),
(97579, 3575633920, 3575633983, 'CH', 'CHE', 'سويسرا'),
(97580, 3575633984, 3575633991, 'DE', 'DEU', 'ألمانيا'),
(97581, 3575633992, 3575633999, 'BE', 'BEL', 'بلجيكا'),
(97582, 3575634000, 3575634007, 'PT', 'PRT', 'البورتوغال'),
(97583, 3575634008, 3575634015, 'DK', 'DNK', 'الدنيمارك'),
(97584, 3575634016, 3575634047, 'GB', 'GBR', 'المملكة المتحدة'),
(97585, 3575634048, 3575634183, 'BE', 'BEL', 'بلجيكا'),
(97586, 3575634184, 3575634191, 'AT', 'AUT', 'النمسا'),
(97587, 3575634192, 3575634255, 'BE', 'BEL', 'بلجيكا'),
(97588, 3575634256, 3575634271, 'IT', 'ITA', 'إيطاليا'),
(97589, 3575634272, 3575634367, 'BE', 'BEL', 'بلجيكا'),
(97590, 3575634368, 3575634399, 'NO', 'NOR', 'النرويج'),
(97591, 3575634400, 3575634431, 'GB', 'GBR', 'المملكة المتحدة'),
(97592, 3575634432, 3575634455, 'BE', 'BEL', 'بلجيكا'),
(97593, 3575634456, 3575634463, 'DE', 'DEU', 'ألمانيا'),
(97594, 3575634464, 3575634495, 'BE', 'BEL', 'بلجيكا'),
(97595, 3575634496, 3575634511, 'FI', 'FIN', 'فنلندا'),
(97596, 3575634512, 3575634519, 'CH', 'CHE', 'سويسرا'),
(97597, 3575634520, 3575634591, 'BE', 'BEL', 'بلجيكا'),
(97598, 3575634592, 3575634599, 'ES', 'ESP', 'إسبانيا'),
(97599, 3575634600, 3575634607, 'BE', 'BEL', 'بلجيكا'),
(97600, 3575634608, 3575634615, 'GB', 'GBR', 'المملكة المتحدة'),
(97601, 3575634616, 3575634623, 'DE', 'DEU', 'ألمانيا'),
(97602, 3575634624, 3575634695, 'BE', 'BEL', 'بلجيكا'),
(97603, 3575634696, 3575634703, 'FI', 'FIN', 'فنلندا'),
(97604, 3575634704, 3575634711, 'BE', 'BEL', 'بلجيكا'),
(97605, 3575634712, 3575634719, 'DE', 'DEU', 'ألمانيا'),
(97606, 3575634720, 3575634767, 'BE', 'BEL', 'بلجيكا'),
(97607, 3575634768, 3575634775, 'NO', 'NOR', 'النرويج'),
(97608, 3575634776, 3575634783, 'BE', 'BEL', 'بلجيكا'),
(97609, 3575634784, 3575634791, 'FR', 'FRA', 'فرنسا'),
(97610, 3575634792, 3575634799, 'ES', 'ESP', 'إسبانيا'),
(97611, 3575634800, 3575634807, 'BE', 'BEL', 'بلجيكا'),
(97612, 3575634808, 3575634815, 'SE', 'SWE', 'السويد'),
(97613, 3575634816, 3575634879, 'BE', 'BEL', 'بلجيكا'),
(97614, 3575634880, 3575634911, 'GB', 'GBR', 'المملكة المتحدة'),
(97615, 3575634912, 3575634919, 'SE', 'SWE', 'السويد'),
(97616, 3575634920, 3575634927, 'GB', 'GBR', 'المملكة المتحدة'),
(97617, 3575634928, 3575634935, 'IT', 'ITA', 'إيطاليا'),
(97618, 3575634936, 3575635015, 'BE', 'BEL', 'بلجيكا'),
(97619, 3575635016, 3575635023, 'CH', 'CHE', 'سويسرا'),
(97620, 3575635024, 3575635039, 'ES', 'ESP', 'إسبانيا'),
(97621, 3575635040, 3575635055, 'BE', 'BEL', 'بلجيكا'),
(97622, 3575635056, 3575635063, 'CH', 'CHE', 'سويسرا'),
(97623, 3575635064, 3575635071, 'BE', 'BEL', 'بلجيكا'),
(97624, 3575635072, 3575635087, 'SE', 'SWE', 'السويد'),
(97625, 3575635088, 3575635103, 'BE', 'BEL', 'بلجيكا'),
(97626, 3575635104, 3575635119, 'PT', 'PRT', 'البورتوغال'),
(97627, 3575635120, 3575635135, 'PL', 'POL', 'بولندا'),
(97628, 3575635136, 3575635151, 'DE', 'DEU', 'ألمانيا'),
(97629, 3575635152, 3575635159, 'PT', 'PRT', 'البورتوغال'),
(97630, 3575635160, 3575635167, 'DE', 'DEU', 'ألمانيا'),
(97631, 3575635168, 3575635175, 'GB', 'GBR', 'المملكة المتحدة'),
(97632, 3575635176, 3575635199, 'BE', 'BEL', 'بلجيكا'),
(97633, 3575635200, 3575635455, 'NO', 'NOR', 'النرويج'),
(97634, 3575635456, 3575635463, 'RU', 'RUS', 'الإتحاد الروسي'),
(97635, 3575635464, 3575635471, 'GB', 'GBR', 'المملكة المتحدة'),
(97636, 3575635472, 3575635583, 'BE', 'BEL', 'بلجيكا'),
(97637, 3575635584, 3575635615, 'EG', 'EGY', 'مصر'),
(97638, 3575635616, 3575635631, 'FI', 'FIN', 'فنلندا'),
(97639, 3575635632, 3575635647, 'BE', 'BEL', 'بلجيكا'),
(97640, 3575635648, 3575635679, 'GB', 'GBR', 'المملكة المتحدة'),
(97641, 3575635680, 3575635695, 'BE', 'BEL', 'بلجيكا'),
(97642, 3575635696, 3575635703, 'GB', 'GBR', 'المملكة المتحدة'),
(97643, 3575635704, 3575635775, 'BE', 'BEL', 'بلجيكا'),
(97644, 3575635776, 3575635839, 'CH', 'CHE', 'سويسرا'),
(97645, 3575635840, 3575635847, 'GB', 'GBR', 'المملكة المتحدة'),
(97646, 3575635848, 3575635855, 'FR', 'FRA', 'فرنسا'),
(97647, 3575635856, 3575635871, 'TR', 'TUR', 'تركيا'),
(97648, 3575635872, 3575635983, 'BE', 'BEL', 'بلجيكا'),
(97649, 3575635984, 3575635999, 'DE', 'DEU', 'ألمانيا'),
(97650, 3575636000, 3575636143, 'BE', 'BEL', 'بلجيكا'),
(97651, 3575636144, 3575636151, 'HU', 'HUN', 'هنغاريا'),
(97652, 3575636152, 3575636607, 'BE', 'BEL', 'بلجيكا'),
(97653, 3575636608, 3575636735, 'FR', 'FRA', 'فرنسا'),
(97654, 3575636736, 3575636807, 'BE', 'BEL', 'بلجيكا'),
(97655, 3575636808, 3575636815, 'GB', 'GBR', 'المملكة المتحدة'),
(97656, 3575636816, 3575636823, 'BE', 'BEL', 'بلجيكا'),
(97657, 3575636824, 3575636831, 'RU', 'RUS', 'الإتحاد الروسي'),
(97658, 3575636832, 3575636855, 'BE', 'BEL', 'بلجيكا'),
(97659, 3575636856, 3575636863, 'DE', 'DEU', 'ألمانيا'),
(97660, 3575636864, 3575636871, 'BE', 'BEL', 'بلجيكا'),
(97661, 3575636872, 3575636879, 'CZ', 'CZE', 'التشيك'),
(97662, 3575636880, 3575636895, 'BE', 'BEL', 'بلجيكا'),
(97663, 3575636896, 3575636903, 'PL', 'POL', 'بولندا'),
(97664, 3575636904, 3575636911, 'CZ', 'CZE', 'التشيك'),
(97665, 3575636912, 3575636927, 'BE', 'BEL', 'بلجيكا'),
(97666, 3575636928, 3575636959, 'DE', 'DEU', 'ألمانيا'),
(97667, 3575636960, 3575636983, 'BE', 'BEL', 'بلجيكا'),
(97668, 3575636984, 3575636991, 'FR', 'FRA', 'فرنسا'),
(97669, 3575636992, 3575637039, 'BE', 'BEL', 'بلجيكا'),
(97670, 3575637040, 3575637055, 'DE', 'DEU', 'ألمانيا'),
(97671, 3575637056, 3575637151, 'BE', 'BEL', 'بلجيكا'),
(97672, 3575637152, 3575637183, 'GB', 'GBR', 'المملكة المتحدة'),
(97673, 3575637184, 3575637407, 'BE', 'BEL', 'بلجيكا'),
(97674, 3575637408, 3575637439, 'LU', 'LUX', 'لوكسيمبورغ'),
(97675, 3575637440, 3575637471, 'GB', 'GBR', 'المملكة المتحدة'),
(97676, 3575637472, 3575638103, 'BE', 'BEL', 'بلجيكا'),
(97677, 3575638104, 3575638111, 'GB', 'GBR', 'المملكة المتحدة'),
(97678, 3575638112, 3575638175, 'BE', 'BEL', 'بلجيكا'),
(97679, 3575638176, 3575638239, 'GB', 'GBR', 'المملكة المتحدة'),
(97680, 3575638240, 3575638279, 'BE', 'BEL', 'بلجيكا'),
(97681, 3575638280, 3575638287, 'RU', 'RUS', 'الإتحاد الروسي'),
(97682, 3575638288, 3575638303, 'BE', 'BEL', 'بلجيكا'),
(97683, 3575638304, 3575638335, 'NO', 'NOR', 'النرويج'),
(97684, 3575638336, 3575638527, 'BE', 'BEL', 'بلجيكا'),
(97685, 3575638528, 3575638543, 'DE', 'DEU', 'ألمانيا'),
(97686, 3575638544, 3575638559, 'BE', 'BEL', 'بلجيكا'),
(97687, 3575638560, 3575638591, 'GB', 'GBR', 'المملكة المتحدة'),
(97688, 3575638592, 3575638623, 'BE', 'BEL', 'بلجيكا'),
(97689, 3575638624, 3575638639, 'PL', 'POL', 'بولندا'),
(97690, 3575638640, 3575638719, 'BE', 'BEL', 'بلجيكا'),
(97691, 3575638720, 3575638735, 'NL', 'NLD', 'هولندا'),
(97692, 3575638736, 3575638751, 'GR', 'GRC', 'اليونان'),
(97693, 3575638752, 3575638767, 'BE', 'BEL', 'بلجيكا'),
(97694, 3575638768, 3575638783, 'SE', 'SWE', 'السويد'),
(97695, 3575638784, 3575638911, 'BE', 'BEL', 'بلجيكا'),
(97696, 3575638912, 3575638943, 'FR', 'FRA', 'فرنسا'),
(97697, 3575638944, 3575638975, 'GB', 'GBR', 'المملكة المتحدة'),
(97698, 3575638976, 3575639007, 'BE', 'BEL', 'بلجيكا'),
(97699, 3575639008, 3575639011, 'GB', 'GBR', 'المملكة المتحدة'),
(97700, 3575639012, 3575639023, 'IE', 'IRL', 'إيرلندا'),
(97701, 3575639024, 3575639039, 'PL', 'POL', 'بولندا'),
(97702, 3575639040, 3575644159, 'BE', 'BEL', 'بلجيكا'),
(97703, 3575644160, 3575709695, 'DK', 'DNK', 'الدنيمارك'),
(97704, 3575709696, 3575730175, 'AT', 'AUT', 'النمسا'),
(97705, 3575730176, 3575730191, 'SA', 'SAU', 'السعودية'),
(97706, 3575730192, 3575732735, 'AT', 'AUT', 'النمسا'),
(97707, 3575732736, 3575732991, 'LI', 'LIE', 'ليختنشتاين'),
(97708, 3575732992, 3575736319, 'AT', 'AUT', 'النمسا'),
(97709, 3575736320, 3575736895, 'LI', 'LIE', 'ليختنشتاين'),
(97710, 3575736896, 3575738407, 'AT', 'AUT', 'النمسا'),
(97711, 3575738408, 3575738415, 'SA', 'SAU', 'السعودية'),
(97712, 3575738416, 3575738431, 'AT', 'AUT', 'النمسا'),
(97713, 3575738432, 3575738463, 'SA', 'SAU', 'السعودية'),
(97714, 3575738464, 3575738751, 'AT', 'AUT', 'النمسا'),
(97715, 3575738752, 3575738759, 'SA', 'SAU', 'السعودية'),
(97716, 3575738760, 3575742463, 'AT', 'AUT', 'النمسا'),
(97717, 3575742464, 3575775231, 'RU', 'RUS', 'الإتحاد الروسي'),
(97718, 3575775232, 3575775295, 'AT', 'AUT', 'النمسا'),
(97719, 3575775296, 3575775487, 'NL', 'NLD', 'هولندا'),
(97720, 3575775488, 3575775743, 'AT', 'AUT', 'النمسا'),
(97721, 3575775744, 3575824383, 'NL', 'NLD', 'هولندا'),
(97722, 3575824384, 3575832575, 'KW', 'KWT', 'الكويت'),
(97723, 3575832576, 3575857151, 'NL', 'NLD', 'هولندا'),
(97724, 3575857152, 3575857407, 'BE', 'BEL', 'بلجيكا'),
(97725, 3575857408, 3575858529, 'NL', 'NLD', 'هولندا'),
(97726, 3575858530, 3575858543, 'US', 'USA', 'الولايات المتحدة'),
(97727, 3575858544, 3575860299, 'NL', 'NLD', 'هولندا'),
(97728, 3575860300, 3575860303, 'BE', 'BEL', 'بلجيكا'),
(97729, 3575860304, 3575866367, 'NL', 'NLD', 'هولندا'),
(97730, 3575866368, 3575867135, 'US', 'USA', 'الولايات المتحدة'),
(97731, 3575867136, 3575873535, 'NL', 'NLD', 'هولندا'),
(97732, 3575873536, 3575906303, 'EE', 'EST', 'إستونيا'),
(97733, 3575906304, 3575971839, 'FR', 'FRA', 'فرنسا'),
(97734, 3575971840, 3576037375, 'ES', 'ESP', 'إسبانيا'),
(97735, 3576038208, 3576038271, 'GB', 'GBR', 'المملكة المتحدة'),
(97736, 3576038336, 3576038463, 'GB', 'GBR', 'المملكة المتحدة'),
(97737, 3576038528, 3576038591, 'GB', 'GBR', 'المملكة المتحدة'),
(97738, 3576038912, 3576038975, 'GB', 'GBR', 'المملكة المتحدة'),
(97739, 3576039168, 3576039231, 'GB', 'GBR', 'المملكة المتحدة'),
(97740, 3576039360, 3576039383, 'GB', 'GBR', 'المملكة المتحدة'),
(97741, 3576039392, 3576039455, 'GB', 'GBR', 'المملكة المتحدة'),
(97742, 3576039520, 3576039551, 'GB', 'GBR', 'المملكة المتحدة'),
(97743, 3576039584, 3576039647, 'GB', 'GBR', 'المملكة المتحدة'),
(97744, 3576039808, 3576039839, 'GB', 'GBR', 'المملكة المتحدة'),
(97745, 3576039904, 3576039935, 'GB', 'GBR', 'المملكة المتحدة'),
(97746, 3576040064, 3576040127, 'GB', 'GBR', 'المملكة المتحدة'),
(97747, 3576040216, 3576040223, 'GB', 'GBR', 'المملكة المتحدة'),
(97748, 3576040272, 3576040287, 'GB', 'GBR', 'المملكة المتحدة'),
(97749, 3576040352, 3576040383, 'GB', 'GBR', 'المملكة المتحدة'),
(97750, 3576040832, 3576040959, 'GB', 'GBR', 'المملكة المتحدة'),
(97751, 3576041472, 3576041535, 'GB', 'GBR', 'المملكة المتحدة'),
(97752, 3576041728, 3576041799, 'GB', 'GBR', 'المملكة المتحدة'),
(97753, 3576041832, 3576041847, 'GB', 'GBR', 'المملكة المتحدة'),
(97754, 3576041864, 3576041871, 'GB', 'GBR', 'المملكة المتحدة'),
(97755, 3576041880, 3576041887, 'GB', 'GBR', 'المملكة المتحدة'),
(97756, 3576041904, 3576041919, 'GB', 'GBR', 'المملكة المتحدة'),
(97757, 3576041936, 3576041943, 'GB', 'GBR', 'المملكة المتحدة'),
(97758, 3576041952, 3576041975, 'GB', 'GBR', 'المملكة المتحدة'),
(97759, 3576042112, 3576042239, 'GB', 'GBR', 'المملكة المتحدة'),
(97760, 3576042496, 3576042623, 'GB', 'GBR', 'المملكة المتحدة'),
(97761, 3576042688, 3576042815, 'GB', 'GBR', 'المملكة المتحدة'),
(97762, 3576045568, 3576045599, 'GB', 'GBR', 'المملكة المتحدة'),
(97763, 3576045664, 3576045679, 'GB', 'GBR', 'المملكة المتحدة'),
(97764, 3576045712, 3576045735, 'GB', 'GBR', 'المملكة المتحدة'),
(97765, 3576045800, 3576045807, 'GB', 'GBR', 'المملكة المتحدة'),
(97766, 3576045816, 3576045823, 'GB', 'GBR', 'المملكة المتحدة'),
(97767, 3576048640, 3576048767, 'GB', 'GBR', 'المملكة المتحدة'),
(97768, 3576048960, 3576049023, 'GB', 'GBR', 'المملكة المتحدة'),
(97769, 3576049152, 3576050047, 'GB', 'GBR', 'المملكة المتحدة'),
(97770, 3576053760, 3576054911, 'GB', 'GBR', 'المملكة المتحدة'),
(97771, 3576055104, 3576055111, 'GB', 'GBR', 'المملكة المتحدة'),
(97772, 3576055120, 3576055127, 'GB', 'GBR', 'المملكة المتحدة'),
(97773, 3576055152, 3576055167, 'GB', 'GBR', 'المملكة المتحدة'),
(97774, 3576055184, 3576055199, 'GB', 'GBR', 'المملكة المتحدة'),
(97775, 3576055208, 3576055215, 'GB', 'GBR', 'المملكة المتحدة'),
(97776, 3576055280, 3576055551, 'GB', 'GBR', 'المملكة المتحدة'),
(97777, 3576055680, 3576055871, 'GB', 'GBR', 'المملكة المتحدة'),
(97778, 3576055936, 3576055999, 'GB', 'GBR', 'المملكة المتحدة'),
(97779, 3576056192, 3576056255, 'GB', 'GBR', 'المملكة المتحدة'),
(97780, 3576056320, 3576056447, 'GB', 'GBR', 'المملكة المتحدة'),
(97781, 3576056704, 3576056767, 'GB', 'GBR', 'المملكة المتحدة'),
(97782, 3576056856, 3576056871, 'GB', 'GBR', 'المملكة المتحدة'),
(97783, 3576056880, 3576056887, 'GB', 'GBR', 'المملكة المتحدة'),
(97784, 3576056896, 3576056903, 'GB', 'GBR', 'المملكة المتحدة'),
(97785, 3576056920, 3576056927, 'GB', 'GBR', 'المملكة المتحدة'),
(97786, 3576056936, 3576056943, 'GB', 'GBR', 'المملكة المتحدة'),
(97787, 3576056952, 3576056975, 'GB', 'GBR', 'المملكة المتحدة'),
(97788, 3576056992, 3576057007, 'GB', 'GBR', 'المملكة المتحدة'),
(97789, 3576057040, 3576057055, 'GB', 'GBR', 'المملكة المتحدة'),
(97790, 3576057632, 3576057647, 'GB', 'GBR', 'المملكة المتحدة'),
(97791, 3576057712, 3576057743, 'GB', 'GBR', 'المملكة المتحدة'),
(97792, 3576057760, 3576057775, 'GB', 'GBR', 'المملكة المتحدة'),
(97793, 3576057824, 3576057839, 'GB', 'GBR', 'المملكة المتحدة'),
(97794, 3576058880, 3576059007, 'GB', 'GBR', 'المملكة المتحدة'),
(97795, 3576059648, 3576059679, 'GB', 'GBR', 'المملكة المتحدة'),
(97796, 3576059712, 3576059743, 'GB', 'GBR', 'المملكة المتحدة'),
(97797, 3576059776, 3576059807, 'GB', 'GBR', 'المملكة المتحدة'),
(97798, 3576060096, 3576060159, 'GB', 'GBR', 'المملكة المتحدة'),
(97799, 3576060288, 3576060351, 'GB', 'GBR', 'المملكة المتحدة'),
(97800, 3576061040, 3576061055, 'GB', 'GBR', 'المملكة المتحدة'),
(97801, 3576061120, 3576061135, 'GB', 'GBR', 'المملكة المتحدة'),
(97802, 3576061184, 3576061247, 'GB', 'GBR', 'المملكة المتحدة'),
(97803, 3576061312, 3576061439, 'GB', 'GBR', 'المملكة المتحدة'),
(97804, 3576061584, 3576061591, 'GB', 'GBR', 'المملكة المتحدة'),
(97805, 3576061620, 3576061631, 'GB', 'GBR', 'المملكة المتحدة'),
(97806, 3576061640, 3576061647, 'GB', 'GBR', 'المملكة المتحدة'),
(97807, 3576061688, 3576061695, 'GB', 'GBR', 'المملكة المتحدة'),
(97808, 3576062464, 3576062479, 'GB', 'GBR', 'المملكة المتحدة'),
(97809, 3576064320, 3576064448, 'GB', 'GBR', 'المملكة المتحدة'),
(97810, 3576064544, 3576064559, 'GB', 'GBR', 'المملكة المتحدة'),
(97811, 3576065408, 3576065535, 'GB', 'GBR', 'المملكة المتحدة'),
(97812, 3576065856, 3576065887, 'GB', 'GBR', 'المملكة المتحدة'),
(97813, 3576066288, 3576066295, 'GB', 'GBR', 'المملكة المتحدة'),
(97814, 3576066304, 3576066431, 'GB', 'GBR', 'المملكة المتحدة'),
(97815, 3576067072, 3576067199, 'GB', 'GBR', 'المملكة المتحدة'),
(97816, 3576067248, 3576067255, 'GB', 'GBR', 'المملكة المتحدة'),
(97817, 3576068352, 3576068479, 'GB', 'GBR', 'المملكة المتحدة'),
(97818, 3576068864, 3576068927, 'GB', 'GBR', 'المملكة المتحدة'),
(97819, 3576069056, 3576069119, 'GB', 'GBR', 'المملكة المتحدة'),
(97820, 3576069248, 3576069279, 'GB', 'GBR', 'المملكة المتحدة'),
(97821, 3576069312, 3576069343, 'GB', 'GBR', 'المملكة المتحدة'),
(97822, 3576070696, 3576070703, 'GB', 'GBR', 'المملكة المتحدة'),
(97823, 3576070712, 3576070719, 'GB', 'GBR', 'المملكة المتحدة'),
(97824, 3576070728, 3576070735, 'GB', 'GBR', 'المملكة المتحدة'),
(97825, 3576070776, 3576070783, 'GB', 'GBR', 'المملكة المتحدة'),
(97826, 3576071296, 3576071423, 'GB', 'GBR', 'المملكة المتحدة'),
(97827, 3576071552, 3576071679, 'GB', 'GBR', 'المملكة المتحدة'),
(97828, 3576071936, 3576071951, 'GB', 'GBR', 'المملكة المتحدة'),
(97829, 3576072064, 3576072079, 'GB', 'GBR', 'المملكة المتحدة'),
(97830, 3576072288, 3576072319, 'GB', 'GBR', 'المملكة المتحدة'),
(97831, 3576072416, 3576072511, 'GB', 'GBR', 'المملكة المتحدة'),
(97832, 3576073216, 3576073279, 'GB', 'GBR', 'المملكة المتحدة'),
(97833, 3576074752, 3576074879, 'GB', 'GBR', 'المملكة المتحدة'),
(97834, 3576075104, 3576075135, 'GB', 'GBR', 'المملكة المتحدة'),
(97835, 3576075264, 3576075327, 'GB', 'GBR', 'المملكة المتحدة'),
(97836, 3576075648, 3576075711, 'GB', 'GBR', 'المملكة المتحدة'),
(97837, 3576075776, 3576075903, 'GB', 'GBR', 'المملكة المتحدة'),
(97838, 3576076272, 3576076351, 'GB', 'GBR', 'المملكة المتحدة'),
(97839, 3576076568, 3576076575, 'GB', 'GBR', 'المملكة المتحدة'),
(97840, 3576076624, 3576076631, 'GB', 'GBR', 'المملكة المتحدة'),
(97841, 3576076704, 3576076719, 'GB', 'GBR', 'المملكة المتحدة'),
(97842, 3576076784, 3576076791, 'GB', 'GBR', 'المملكة المتحدة'),
(97843, 3576077440, 3576077471, 'GB', 'GBR', 'المملكة المتحدة'),
(97844, 3576077568, 3576077695, 'GB', 'GBR', 'المملكة المتحدة'),
(97845, 3576077872, 3576077887, 'GB', 'GBR', 'المملكة المتحدة'),
(97846, 3576077936, 3576077967, 'GB', 'GBR', 'المملكة المتحدة'),
(97847, 3576078080, 3576078175, 'GB', 'GBR', 'المملكة المتحدة'),
(97848, 3576078464, 3576078591, 'GB', 'GBR', 'المملكة المتحدة'),
(97849, 3576079616, 3576079871, 'GB', 'GBR', 'المملكة المتحدة'),
(97850, 3576080000, 3576080127, 'GB', 'GBR', 'المملكة المتحدة'),
(97851, 3576080224, 3576080255, 'GB', 'GBR', 'المملكة المتحدة'),
(97852, 3576080776, 3576080799, 'GB', 'GBR', 'المملكة المتحدة'),
(97853, 3576080808, 3576080815, 'GB', 'GBR', 'المملكة المتحدة'),
(97854, 3576080824, 3576080831, 'GB', 'GBR', 'المملكة المتحدة'),
(97855, 3576082080, 3576082111, 'GB', 'GBR', 'المملكة المتحدة'),
(97856, 3576082192, 3576082223, 'GB', 'GBR', 'المملكة المتحدة'),
(97857, 3576082688, 3576082943, 'GB', 'GBR', 'المملكة المتحدة'),
(97858, 3576083968, 3576084031, 'GB', 'GBR', 'المملكة المتحدة'),
(97859, 3576084480, 3576084543, 'GB', 'GBR', 'المملكة المتحدة'),
(97860, 3576084608, 3576084671, 'GB', 'GBR', 'المملكة المتحدة'),
(97861, 3576084704, 3576084735, 'GB', 'GBR', 'المملكة المتحدة'),
(97862, 3576084864, 3576084927, 'GB', 'GBR', 'المملكة المتحدة'),
(97863, 3576085184, 3576085215, 'GB', 'GBR', 'المملكة المتحدة'),
(97864, 3576085696, 3576085711, 'GB', 'GBR', 'المملكة المتحدة'),
(97865, 3576086016, 3576086143, 'GB', 'GBR', 'المملكة المتحدة'),
(97866, 3576086368, 3576086431, 'GB', 'GBR', 'المملكة المتحدة'),
(97867, 3576086496, 3576086527, 'GB', 'GBR', 'المملكة المتحدة'),
(97868, 3576086568, 3576086571, 'GB', 'GBR', 'المملكة المتحدة'),
(97869, 3576086576, 3576086591, 'GB', 'GBR', 'المملكة المتحدة'),
(97870, 3576086600, 3576086603, 'GB', 'GBR', 'المملكة المتحدة'),
(97871, 3576087808, 3576087823, 'GB', 'GBR', 'المملكة المتحدة'),
(97872, 3576087952, 3576087967, 'GB', 'GBR', 'المملكة المتحدة'),
(97873, 3576088032, 3576088047, 'GB', 'GBR', 'المملكة المتحدة'),
(97874, 3576088224, 3576088231, 'GB', 'GBR', 'المملكة المتحدة'),
(97875, 3576088376, 3576088383, 'GB', 'GBR', 'المملكة المتحدة'),
(97876, 3576088480, 3576088511, 'GB', 'GBR', 'المملكة المتحدة'),
(97877, 3576088960, 3576088967, 'GB', 'GBR', 'المملكة المتحدة'),
(97878, 3576089024, 3576089039, 'GB', 'GBR', 'المملكة المتحدة'),
(97879, 3576089440, 3576089471, 'GB', 'GBR', 'المملكة المتحدة'),
(97880, 3576089776, 3576089791, 'GB', 'GBR', 'المملكة المتحدة'),
(97881, 3576089824, 3576089839, 'GB', 'GBR', 'المملكة المتحدة'),
(97882, 3576091408, 3576091423, 'GB', 'GBR', 'المملكة المتحدة'),
(97883, 3576091456, 3576091479, 'GB', 'GBR', 'المملكة المتحدة'),
(97884, 3576091520, 3576091535, 'GB', 'GBR', 'المملكة المتحدة'),
(97885, 3576091968, 3576091983, 'GB', 'GBR', 'المملكة المتحدة'),
(97886, 3576092000, 3576092031, 'GB', 'GBR', 'المملكة المتحدة'),
(97887, 3576092128, 3576092159, 'GB', 'GBR', 'المملكة المتحدة'),
(97888, 3576092864, 3576092895, 'GB', 'GBR', 'المملكة المتحدة'),
(97889, 3576093064, 3576093071, 'GB', 'GBR', 'المملكة المتحدة'),
(97890, 3576093184, 3576093247, 'GB', 'GBR', 'المملكة المتحدة'),
(97891, 3576095232, 3576096767, 'GB', 'GBR', 'المملكة المتحدة'),
(97892, 3576099072, 3576100863, 'GB', 'GBR', 'المملكة المتحدة'),
(97893, 3576101376, 3576102911, 'GB', 'GBR', 'المملكة المتحدة'),
(97894, 3576102912, 3576103167, 'FR', 'FRA', 'فرنسا'),
(97895, 3576103168, 3576103247, 'GB', 'GBR', 'المملكة المتحدة'),
(97896, 3576103248, 3576103295, 'FR', 'FRA', 'فرنسا'),
(97897, 3576103296, 3576103327, 'GB', 'GBR', 'المملكة المتحدة'),
(97898, 3576103328, 3576103367, 'FR', 'FRA', 'فرنسا'),
(97899, 3576103368, 3576103375, 'GB', 'GBR', 'المملكة المتحدة'),
(97900, 3576103376, 3576103455, 'FR', 'FRA', 'فرنسا'),
(97901, 3576103456, 3576103583, 'GB', 'GBR', 'المملكة المتحدة'),
(97902, 3576103584, 3576103599, 'FR', 'FRA', 'فرنسا'),
(97903, 3576103600, 3576103615, 'GB', 'GBR', 'المملكة المتحدة'),
(97904, 3576103616, 3576103631, 'FR', 'FRA', 'فرنسا'),
(97905, 3576103632, 3576103679, 'GB', 'GBR', 'المملكة المتحدة'),
(97906, 3576103680, 3576103935, 'FR', 'FRA', 'فرنسا'),
(97907, 3576103936, 3576104111, 'GB', 'GBR', 'المملكة المتحدة'),
(97908, 3576104112, 3576104127, 'FR', 'FRA', 'فرنسا'),
(97909, 3576104128, 3576104175, 'GB', 'GBR', 'المملكة المتحدة'),
(97910, 3576104176, 3576104191, 'FR', 'FRA', 'فرنسا'),
(97911, 3576104192, 3576104319, 'GB', 'GBR', 'المملكة المتحدة'),
(97912, 3576104320, 3576104351, 'FR', 'FRA', 'فرنسا'),
(97913, 3576104352, 3576104447, 'GB', 'GBR', 'المملكة المتحدة'),
(97914, 3576104448, 3576104495, 'FR', 'FRA', 'فرنسا'),
(97915, 3576104496, 3576104575, 'GB', 'GBR', 'المملكة المتحدة'),
(97916, 3576104576, 3576104607, 'FR', 'FRA', 'فرنسا'),
(97917, 3576104608, 3576104639, 'GB', 'GBR', 'المملكة المتحدة'),
(97918, 3576104640, 3576104655, 'FR', 'FRA', 'فرنسا'),
(97919, 3576104656, 3576104703, 'GB', 'GBR', 'المملكة المتحدة'),
(97920, 3576104704, 3576104959, 'FR', 'FRA', 'فرنسا'),
(97921, 3576104960, 3576105055, 'GB', 'GBR', 'المملكة المتحدة'),
(97922, 3576105056, 3576105183, 'FR', 'FRA', 'فرنسا'),
(97923, 3576105184, 3576105215, 'GB', 'GBR', 'المملكة المتحدة'),
(97924, 3576105216, 3576105535, 'FR', 'FRA', 'فرنسا'),
(97925, 3576105536, 3576105599, 'GB', 'GBR', 'المملكة المتحدة'),
(97926, 3576105600, 3576105727, 'FR', 'FRA', 'فرنسا'),
(97927, 3576105728, 3576105759, 'GB', 'GBR', 'المملكة المتحدة'),
(97928, 3576105760, 3576105855, 'FR', 'FRA', 'فرنسا'),
(97929, 3576105856, 3576105991, 'GB', 'GBR', 'المملكة المتحدة'),
(97930, 3576105992, 3576106047, 'FR', 'FRA', 'فرنسا'),
(97931, 3576106048, 3576106055, 'GB', 'GBR', 'المملكة المتحدة'),
(97932, 3576106056, 3576106111, 'FR', 'FRA', 'فرنسا'),
(97933, 3576106112, 3576106239, 'GB', 'GBR', 'المملكة المتحدة'),
(97934, 3576106240, 3576106287, 'FR', 'FRA', 'فرنسا'),
(97935, 3576106288, 3576106559, 'GB', 'GBR', 'المملكة المتحدة'),
(97936, 3576106560, 3576106751, 'FR', 'FRA', 'فرنسا'),
(97937, 3576106752, 3576107007, 'GB', 'GBR', 'المملكة المتحدة'),
(97938, 3576107008, 3576107135, 'FR', 'FRA', 'فرنسا'),
(97939, 3576107136, 3576107183, 'GB', 'GBR', 'المملكة المتحدة'),
(97940, 3576107184, 3576107231, 'FR', 'FRA', 'فرنسا'),
(97941, 3576107232, 3576107263, 'GB', 'GBR', 'المملكة المتحدة'),
(97942, 3576107264, 3576107295, 'FR', 'FRA', 'فرنسا'),
(97943, 3576107296, 3576107391, 'GB', 'GBR', 'المملكة المتحدة'),
(97944, 3576107392, 3576107519, 'FR', 'FRA', 'فرنسا'),
(97945, 3576107520, 3576107647, 'GB', 'GBR', 'المملكة المتحدة'),
(97946, 3576107648, 3576107679, 'FR', 'FRA', 'فرنسا'),
(97947, 3576107680, 3576107695, 'GB', 'GBR', 'المملكة المتحدة'),
(97948, 3576107696, 3576107759, 'FR', 'FRA', 'فرنسا'),
(97949, 3576107760, 3576107775, 'GB', 'GBR', 'المملكة المتحدة'),
(97950, 3576107776, 3576107903, 'FR', 'FRA', 'فرنسا'),
(97951, 3576107904, 3576108031, 'GB', 'GBR', 'المملكة المتحدة'),
(97952, 3576108032, 3576108063, 'FR', 'FRA', 'فرنسا'),
(97953, 3576108064, 3576108079, 'GB', 'GBR', 'المملكة المتحدة'),
(97954, 3576108080, 3576108159, 'FR', 'FRA', 'فرنسا'),
(97955, 3576108160, 3576108255, 'GB', 'GBR', 'المملكة المتحدة'),
(97956, 3576108256, 3576108263, 'FR', 'FRA', 'فرنسا'),
(97957, 3576108264, 3576108271, 'GB', 'GBR', 'المملكة المتحدة'),
(97958, 3576108272, 3576108351, 'FR', 'FRA', 'فرنسا'),
(97959, 3576108352, 3576108511, 'GB', 'GBR', 'المملكة المتحدة'),
(97960, 3576108512, 3576108799, 'FR', 'FRA', 'فرنسا'),
(97961, 3576108800, 3576108815, 'GB', 'GBR', 'المملكة المتحدة'),
(97962, 3576108816, 3576108863, 'FR', 'FRA', 'فرنسا'),
(97963, 3576108864, 3576108991, 'GB', 'GBR', 'المملكة المتحدة'),
(97964, 3576108992, 3576109023, 'FR', 'FRA', 'فرنسا'),
(97965, 3576109024, 3576109055, 'DE', 'DEU', 'ألمانيا'),
(97966, 3576109056, 3576109567, 'FR', 'FRA', 'فرنسا'),
(97967, 3576109568, 3576109695, 'GB', 'GBR', 'المملكة المتحدة'),
(97968, 3576109696, 3576109791, 'FR', 'FRA', 'فرنسا'),
(97969, 3576109792, 3576109799, 'GB', 'GBR', 'المملكة المتحدة'),
(97970, 3576109800, 3576109815, 'FR', 'FRA', 'فرنسا'),
(97971, 3576109816, 3576110079, 'GB', 'GBR', 'المملكة المتحدة'),
(97972, 3576110080, 3576110207, 'FR', 'FRA', 'فرنسا'),
(97973, 3576110208, 3576110271, 'GB', 'GBR', 'المملكة المتحدة'),
(97974, 3576110272, 3576110335, 'FR', 'FRA', 'فرنسا'),
(97975, 3576110336, 3576110367, 'GB', 'GBR', 'المملكة المتحدة'),
(97976, 3576110368, 3576110463, 'FR', 'FRA', 'فرنسا'),
(97977, 3576110464, 3576110575, 'GB', 'GBR', 'المملكة المتحدة'),
(97978, 3576110576, 3576110847, 'FR', 'FRA', 'فرنسا'),
(97979, 3576110848, 3576111103, 'GB', 'GBR', 'المملكة المتحدة'),
(97980, 3576111104, 3576111231, 'FR', 'FRA', 'فرنسا'),
(97981, 3576111232, 3576111423, 'GB', 'GBR', 'المملكة المتحدة'),
(97982, 3576111424, 3576111599, 'FR', 'FRA', 'فرنسا'),
(97983, 3576111600, 3576111615, 'GB', 'GBR', 'المملكة المتحدة'),
(97984, 3576111616, 3576111647, 'FR', 'FRA', 'فرنسا'),
(97985, 3576111648, 3576111679, 'GB', 'GBR', 'المملكة المتحدة'),
(97986, 3576111680, 3576111711, 'FR', 'FRA', 'فرنسا'),
(97987, 3576111712, 3576111727, 'GB', 'GBR', 'المملكة المتحدة'),
(97988, 3576111728, 3576111807, 'FR', 'FRA', 'فرنسا'),
(97989, 3576111808, 3576112383, 'GB', 'GBR', 'المملكة المتحدة'),
(97990, 3576112384, 3576112543, 'FR', 'FRA', 'فرنسا'),
(97991, 3576112544, 3576113407, 'GB', 'GBR', 'المملكة المتحدة'),
(97992, 3576113408, 3576113535, 'FR', 'FRA', 'فرنسا'),
(97993, 3576113536, 3576119295, 'GB', 'GBR', 'المملكة المتحدة'),
(97994, 3576119296, 3576119455, 'CH', 'CHE', 'سويسرا'),
(97995, 3576119456, 3576119471, 'BE', 'BEL', 'بلجيكا'),
(97996, 3576119472, 3576127487, 'CH', 'CHE', 'سويسرا'),
(97997, 3576127488, 3576127615, 'GB', 'GBR', 'المملكة المتحدة'),
(97998, 3576127616, 3576127647, 'FR', 'FRA', 'فرنسا'),
(97999, 3576127648, 3576127679, 'GB', 'GBR', 'المملكة المتحدة'),
(98000, 3576127680, 3576127687, 'FR', 'FRA', 'فرنسا'),
(98001, 3576127688, 3576127695, 'GB', 'GBR', 'المملكة المتحدة'),
(98002, 3576127696, 3576127703, 'FR', 'FRA', 'فرنسا'),
(98003, 3576127704, 3576131583, 'GB', 'GBR', 'المملكة المتحدة'),
(98004, 3576131584, 3576135679, 'CH', 'CHE', 'سويسرا'),
(98005, 3576135680, 3576168447, 'DE', 'DEU', 'ألمانيا'),
(98006, 3576168448, 3576233983, 'GB', 'GBR', 'المملكة المتحدة'),
(98007, 3576233984, 3576236671, 'FR', 'FRA', 'فرنسا'),
(98008, 3576236672, 3576236703, 'GB', 'GBR', 'المملكة المتحدة'),
(98009, 3576236704, 3576236879, 'FR', 'FRA', 'فرنسا'),
(98010, 3576236880, 3576236927, 'GB', 'GBR', 'المملكة المتحدة'),
(98011, 3576236928, 3576237063, 'FR', 'FRA', 'فرنسا'),
(98012, 3576237064, 3576237071, 'GB', 'GBR', 'المملكة المتحدة'),
(98013, 3576237072, 3576237087, 'FR', 'FRA', 'فرنسا'),
(98014, 3576237088, 3576237119, 'GB', 'GBR', 'المملكة المتحدة'),
(98015, 3576237120, 3576237231, 'FR', 'FRA', 'فرنسا'),
(98016, 3576237232, 3576237279, 'GB', 'GBR', 'المملكة المتحدة'),
(98017, 3576237280, 3576237455, 'FR', 'FRA', 'فرنسا'),
(98018, 3576237456, 3576237503, 'GB', 'GBR', 'المملكة المتحدة'),
(98019, 3576237504, 3576237567, 'FR', 'FRA', 'فرنسا'),
(98020, 3576237568, 3576237583, 'GB', 'GBR', 'المملكة المتحدة'),
(98021, 3576237584, 3576237599, 'FR', 'FRA', 'فرنسا'),
(98022, 3576237600, 3576237647, 'GB', 'GBR', 'المملكة المتحدة'),
(98023, 3576237648, 3576237711, 'FR', 'FRA', 'فرنسا'),
(98024, 3576237712, 3576237743, 'GB', 'GBR', 'المملكة المتحدة'),
(98025, 3576237744, 3576237855, 'FR', 'FRA', 'فرنسا'),
(98026, 3576237856, 3576237871, 'GB', 'GBR', 'المملكة المتحدة'),
(98027, 3576237872, 3576237887, 'FR', 'FRA', 'فرنسا'),
(98028, 3576237888, 3576237919, 'GB', 'GBR', 'المملكة المتحدة'),
(98029, 3576237920, 3576237935, 'FR', 'FRA', 'فرنسا'),
(98030, 3576237936, 3576237967, 'GB', 'GBR', 'المملكة المتحدة'),
(98031, 3576237968, 3576237983, 'FR', 'FRA', 'فرنسا'),
(98032, 3576237984, 3576238015, 'GB', 'GBR', 'المملكة المتحدة'),
(98033, 3576238016, 3576238143, 'FR', 'FRA', 'فرنسا'),
(98034, 3576238144, 3576238159, 'GB', 'GBR', 'المملكة المتحدة'),
(98035, 3576238160, 3576238271, 'FR', 'FRA', 'فرنسا'),
(98036, 3576238272, 3576238335, 'GB', 'GBR', 'المملكة المتحدة'),
(98037, 3576238336, 3576238447, 'FR', 'FRA', 'فرنسا'),
(98038, 3576238448, 3576238463, 'GB', 'GBR', 'المملكة المتحدة'),
(98039, 3576238464, 3576238511, 'FR', 'FRA', 'فرنسا'),
(98040, 3576238512, 3576238527, 'GB', 'GBR', 'المملكة المتحدة'),
(98041, 3576238528, 3576238559, 'FR', 'FRA', 'فرنسا'),
(98042, 3576238560, 3576238575, 'GB', 'GBR', 'المملكة المتحدة'),
(98043, 3576238576, 3576238607, 'FR', 'FRA', 'فرنسا'),
(98044, 3576238608, 3576238623, 'GB', 'GBR', 'المملكة المتحدة'),
(98045, 3576238624, 3576238639, 'FR', 'FRA', 'فرنسا'),
(98046, 3576238640, 3576238879, 'GB', 'GBR', 'المملكة المتحدة'),
(98047, 3576238880, 3576238895, 'FR', 'FRA', 'فرنسا'),
(98048, 3576238896, 3576238911, 'GB', 'GBR', 'المملكة المتحدة'),
(98049, 3576238912, 3576238927, 'FR', 'FRA', 'فرنسا'),
(98050, 3576238928, 3576238975, 'GB', 'GBR', 'المملكة المتحدة'),
(98051, 3576238976, 3576239007, 'FR', 'FRA', 'فرنسا'),
(98052, 3576239008, 3576239023, 'GB', 'GBR', 'المملكة المتحدة'),
(98053, 3576239024, 3576239039, 'FR', 'FRA', 'فرنسا'),
(98054, 3576239040, 3576239071, 'GB', 'GBR', 'المملكة المتحدة'),
(98055, 3576239072, 3576239087, 'FR', 'FRA', 'فرنسا'),
(98056, 3576239088, 3576239103, 'GB', 'GBR', 'المملكة المتحدة'),
(98057, 3576239104, 3576239623, 'FR', 'FRA', 'فرنسا'),
(98058, 3576239624, 3576239871, 'GB', 'GBR', 'المملكة المتحدة'),
(98059, 3576239872, 3576240039, 'FR', 'FRA', 'فرنسا'),
(98060, 3576240040, 3576240047, 'GB', 'GBR', 'المملكة المتحدة'),
(98061, 3576240048, 3576240111, 'FR', 'FRA', 'فرنسا'),
(98062, 3576240112, 3576240127, 'GB', 'GBR', 'المملكة المتحدة'),
(98063, 3576240128, 3576240383, 'FR', 'FRA', 'فرنسا'),
(98064, 3576240384, 3576240511, 'GB', 'GBR', 'المملكة المتحدة'),
(98065, 3576240512, 3576240575, 'FR', 'FRA', 'فرنسا'),
(98066, 3576240576, 3576240895, 'GB', 'GBR', 'المملكة المتحدة'),
(98067, 3576240896, 3576241183, 'FR', 'FRA', 'فرنسا'),
(98068, 3576241184, 3576241215, 'GB', 'GBR', 'المملكة المتحدة'),
(98069, 3576241216, 3576241287, 'FR', 'FRA', 'فرنسا'),
(98070, 3576241288, 3576241295, 'GB', 'GBR', 'المملكة المتحدة'),
(98071, 3576241296, 3576241343, 'FR', 'FRA', 'فرنسا'),
(98072, 3576241344, 3576241351, 'GB', 'GBR', 'المملكة المتحدة'),
(98073, 3576241352, 3576241383, 'FR', 'FRA', 'فرنسا'),
(98074, 3576241384, 3576241399, 'GB', 'GBR', 'المملكة المتحدة'),
(98075, 3576241400, 3576241951, 'FR', 'FRA', 'فرنسا'),
(98076, 3576241952, 3576242047, 'GB', 'GBR', 'المملكة المتحدة'),
(98077, 3576242048, 3576242111, 'FR', 'FRA', 'فرنسا'),
(98078, 3576242112, 3576242175, 'GB', 'GBR', 'المملكة المتحدة'),
(98079, 3576242176, 3576242183, 'FR', 'FRA', 'فرنسا'),
(98080, 3576242184, 3576242191, 'GB', 'GBR', 'المملكة المتحدة'),
(98081, 3576242192, 3576243967, 'FR', 'FRA', 'فرنسا'),
(98082, 3576243968, 3576244223, 'GB', 'GBR', 'المملكة المتحدة'),
(98083, 3576244224, 3576246399, 'FR', 'FRA', 'فرنسا'),
(98084, 3576246400, 3576246527, 'GB', 'GBR', 'المملكة المتحدة'),
(98085, 3576246528, 3576246656, 'FR', 'FRA', 'فرنسا'),
(98086, 3576246657, 3576246727, 'GB', 'GBR', 'المملكة المتحدة'),
(98087, 3576246728, 3576246735, 'FR', 'FRA', 'فرنسا'),
(98088, 3576246736, 3576246927, 'GB', 'GBR', 'المملكة المتحدة'),
(98089, 3576246928, 3576246931, 'FR', 'FRA', 'فرنسا'),
(98090, 3576246932, 3576247036, 'GB', 'GBR', 'المملكة المتحدة'),
(98091, 3576247037, 3576247037, 'FR', 'FRA', 'فرنسا'),
(98092, 3576247038, 3576247039, 'GB', 'GBR', 'المملكة المتحدة'),
(98093, 3576247040, 3576249359, 'FR', 'FRA', 'فرنسا'),
(98094, 3576249360, 3576249367, 'GB', 'GBR', 'المملكة المتحدة'),
(98095, 3576249368, 3576249463, 'FR', 'FRA', 'فرنسا'),
(98096, 3576249464, 3576249471, 'GB', 'GBR', 'المملكة المتحدة'),
(98097, 3576249472, 3576249527, 'FR', 'FRA', 'فرنسا'),
(98098, 3576249528, 3576249535, 'GB', 'GBR', 'المملكة المتحدة'),
(98099, 3576249536, 3576249743, 'FR', 'FRA', 'فرنسا'),
(98100, 3576249744, 3576249791, 'GB', 'GBR', 'المملكة المتحدة'),
(98101, 3576249792, 3576249807, 'FR', 'FRA', 'فرنسا'),
(98102, 3576249808, 3576249823, 'GB', 'GBR', 'المملكة المتحدة'),
(98103, 3576249824, 3576249831, 'FR', 'FRA', 'فرنسا'),
(98104, 3576249832, 3576249839, 'GB', 'GBR', 'المملكة المتحدة'),
(98105, 3576249840, 3576250623, 'FR', 'FRA', 'فرنسا'),
(98106, 3576250624, 3576250879, 'GB', 'GBR', 'المملكة المتحدة'),
(98107, 3576250880, 3576251407, 'FR', 'FRA', 'فرنسا'),
(98108, 3576251408, 3576251519, 'GB', 'GBR', 'المملكة المتحدة'),
(98109, 3576251520, 3576251583, 'FR', 'FRA', 'فرنسا'),
(98110, 3576251584, 3576251599, 'GB', 'GBR', 'المملكة المتحدة'),
(98111, 3576251600, 3576251615, 'FR', 'FRA', 'فرنسا'),
(98112, 3576251616, 3576251647, 'GB', 'GBR', 'المملكة المتحدة'),
(98113, 3576251648, 3576252415, 'FR', 'FRA', 'فرنسا'),
(98114, 3576252416, 3576252671, 'GB', 'GBR', 'المملكة المتحدة'),
(98115, 3576252672, 3576253007, 'FR', 'FRA', 'فرنسا'),
(98116, 3576253008, 3576253023, 'GB', 'GBR', 'المملكة المتحدة'),
(98117, 3576253024, 3576253159, 'FR', 'FRA', 'فرنسا'),
(98118, 3576253160, 3576253183, 'GB', 'GBR', 'المملكة المتحدة'),
(98119, 3576253184, 3576254487, 'FR', 'FRA', 'فرنسا'),
(98120, 3576254488, 3576254495, 'GB', 'GBR', 'المملكة المتحدة'),
(98121, 3576254496, 3576254551, 'FR', 'FRA', 'فرنسا'),
(98122, 3576254552, 3576254559, 'GB', 'GBR', 'المملكة المتحدة'),
(98123, 3576254560, 3576254607, 'FR', 'FRA', 'فرنسا'),
(98124, 3576254608, 3576254615, 'GB', 'GBR', 'المملكة المتحدة'),
(98125, 3576254616, 3576254623, 'FR', 'FRA', 'فرنسا'),
(98126, 3576254624, 3576254639, 'GB', 'GBR', 'المملكة المتحدة'),
(98127, 3576254640, 3576254655, 'FR', 'FRA', 'فرنسا'),
(98128, 3576254656, 3576254687, 'GB', 'GBR', 'المملكة المتحدة'),
(98129, 3576254688, 3576254847, 'FR', 'FRA', 'فرنسا'),
(98130, 3576254848, 3576254855, 'GB', 'GBR', 'المملكة المتحدة'),
(98131, 3576254856, 3576254863, 'FR', 'FRA', 'فرنسا'),
(98132, 3576254864, 3576254879, 'GB', 'GBR', 'المملكة المتحدة'),
(98133, 3576254880, 3576254895, 'FR', 'FRA', 'فرنسا'),
(98134, 3576254896, 3576254903, 'GB', 'GBR', 'المملكة المتحدة'),
(98135, 3576254904, 3576255087, 'FR', 'FRA', 'فرنسا'),
(98136, 3576255088, 3576255199, 'GB', 'GBR', 'المملكة المتحدة'),
(98137, 3576255200, 3576255215, 'FR', 'FRA', 'فرنسا'),
(98138, 3576255216, 3576255263, 'GB', 'GBR', 'المملكة المتحدة'),
(98139, 3576255264, 3576255319, 'FR', 'FRA', 'فرنسا'),
(98140, 3576255320, 3576255327, 'GB', 'GBR', 'المملكة المتحدة'),
(98141, 3576255328, 3576255375, 'FR', 'FRA', 'فرنسا'),
(98142, 3576255376, 3576255383, 'GB', 'GBR', 'المملكة المتحدة'),
(98143, 3576255384, 3576255407, 'FR', 'FRA', 'فرنسا'),
(98144, 3576255408, 3576255423, 'GB', 'GBR', 'المملكة المتحدة'),
(98145, 3576255424, 3576255431, 'FR', 'FRA', 'فرنسا'),
(98146, 3576255432, 3576255439, 'GB', 'GBR', 'المملكة المتحدة'),
(98147, 3576255440, 3576255503, 'FR', 'FRA', 'فرنسا'),
(98148, 3576255504, 3576255511, 'GB', 'GBR', 'المملكة المتحدة'),
(98149, 3576255512, 3576255519, 'FR', 'FRA', 'فرنسا'),
(98150, 3576255520, 3576255527, 'GB', 'GBR', 'المملكة المتحدة'),
(98151, 3576255528, 3576255543, 'FR', 'FRA', 'فرنسا'),
(98152, 3576255544, 3576255551, 'GB', 'GBR', 'المملكة المتحدة'),
(98153, 3576255552, 3576255575, 'FR', 'FRA', 'فرنسا'),
(98154, 3576255576, 3576255583, 'GB', 'GBR', 'المملكة المتحدة'),
(98155, 3576255584, 3576255631, 'FR', 'FRA', 'فرنسا'),
(98156, 3576255632, 3576255647, 'GB', 'GBR', 'المملكة المتحدة'),
(98157, 3576255648, 3576255671, 'FR', 'FRA', 'فرنسا'),
(98158, 3576255672, 3576255679, 'GB', 'GBR', 'المملكة المتحدة'),
(98159, 3576255680, 3576255703, 'FR', 'FRA', 'فرنسا'),
(98160, 3576255704, 3576255719, 'GB', 'GBR', 'المملكة المتحدة'),
(98161, 3576255720, 3576255743, 'FR', 'FRA', 'فرنسا'),
(98162, 3576255744, 3576255759, 'GB', 'GBR', 'المملكة المتحدة'),
(98163, 3576255760, 3576255839, 'FR', 'FRA', 'فرنسا'),
(98164, 3576255840, 3576255871, 'GB', 'GBR', 'المملكة المتحدة'),
(98165, 3576255872, 3576255887, 'FR', 'FRA', 'فرنسا'),
(98166, 3576255888, 3576255919, 'GB', 'GBR', 'المملكة المتحدة'),
(98167, 3576255920, 3576255943, 'FR', 'FRA', 'فرنسا'),
(98168, 3576255944, 3576255975, 'GB', 'GBR', 'المملكة المتحدة'),
(98169, 3576255976, 3576255983, 'FR', 'FRA', 'فرنسا'),
(98170, 3576255984, 3576256047, 'GB', 'GBR', 'المملكة المتحدة'),
(98171, 3576256048, 3576256111, 'FR', 'FRA', 'فرنسا'),
(98172, 3576256112, 3576256143, 'GB', 'GBR', 'المملكة المتحدة'),
(98173, 3576256144, 3576256239, 'FR', 'FRA', 'فرنسا'),
(98174, 3576256240, 3576256255, 'GB', 'GBR', 'المملكة المتحدة'),
(98175, 3576256256, 3576256351, 'FR', 'FRA', 'فرنسا'),
(98176, 3576256352, 3576256367, 'GB', 'GBR', 'المملكة المتحدة'),
(98177, 3576256368, 3576256383, 'FR', 'FRA', 'فرنسا'),
(98178, 3576256384, 3576256415, 'GB', 'GBR', 'المملكة المتحدة'),
(98179, 3576256416, 3576256431, 'FR', 'FRA', 'فرنسا'),
(98180, 3576256432, 3576256527, 'GB', 'GBR', 'المملكة المتحدة'),
(98181, 3576256528, 3576256543, 'FR', 'FRA', 'فرنسا'),
(98182, 3576256544, 3576256559, 'GB', 'GBR', 'المملكة المتحدة'),
(98183, 3576256560, 3576256607, 'FR', 'FRA', 'فرنسا'),
(98184, 3576256608, 3576256623, 'GB', 'GBR', 'المملكة المتحدة'),
(98185, 3576256624, 3576256639, 'FR', 'FRA', 'فرنسا'),
(98186, 3576256640, 3576256671, 'GB', 'GBR', 'المملكة المتحدة'),
(98187, 3576256672, 3576256687, 'FR', 'FRA', 'فرنسا'),
(98188, 3576256688, 3576256767, 'GB', 'GBR', 'المملكة المتحدة'),
(98189, 3576256768, 3576256895, 'FR', 'FRA', 'فرنسا'),
(98190, 3576256896, 3576256959, 'GB', 'GBR', 'المملكة المتحدة'),
(98191, 3576256960, 3576256991, 'FR', 'FRA', 'فرنسا'),
(98192, 3576256992, 3576257007, 'GB', 'GBR', 'المملكة المتحدة'),
(98193, 3576257008, 3576257079, 'FR', 'FRA', 'فرنسا'),
(98194, 3576257080, 3576257087, 'GB', 'GBR', 'المملكة المتحدة'),
(98195, 3576257088, 3576257103, 'FR', 'FRA', 'فرنسا'),
(98196, 3576257104, 3576257111, 'GB', 'GBR', 'المملكة المتحدة'),
(98197, 3576257112, 3576257135, 'FR', 'FRA', 'فرنسا'),
(98198, 3576257136, 3576257151, 'GB', 'GBR', 'المملكة المتحدة'),
(98199, 3576257152, 3576257159, 'FR', 'FRA', 'فرنسا'),
(98200, 3576257160, 3576257167, 'GB', 'GBR', 'المملكة المتحدة'),
(98201, 3576257168, 3576257287, 'FR', 'FRA', 'فرنسا'),
(98202, 3576257288, 3576257295, 'GB', 'GBR', 'المملكة المتحدة'),
(98203, 3576257296, 3576257327, 'FR', 'FRA', 'فرنسا'),
(98204, 3576257328, 3576257359, 'GB', 'GBR', 'المملكة المتحدة'),
(98205, 3576257360, 3576257367, 'FR', 'FRA', 'فرنسا'),
(98206, 3576257368, 3576257375, 'GB', 'GBR', 'المملكة المتحدة'),
(98207, 3576257376, 3576257487, 'FR', 'FRA', 'فرنسا'),
(98208, 3576257488, 3576257495, 'GB', 'GBR', 'المملكة المتحدة'),
(98209, 3576257496, 3576257503, 'FR', 'FRA', 'فرنسا'),
(98210, 3576257504, 3576257535, 'GB', 'GBR', 'المملكة المتحدة'),
(98211, 3576257536, 3576257551, 'FR', 'FRA', 'فرنسا'),
(98212, 3576257552, 3576257583, 'GB', 'GBR', 'المملكة المتحدة'),
(98213, 3576257584, 3576257631, 'FR', 'FRA', 'فرنسا'),
(98214, 3576257632, 3576257647, 'GB', 'GBR', 'المملكة المتحدة'),
(98215, 3576257648, 3576257727, 'FR', 'FRA', 'فرنسا'),
(98216, 3576257728, 3576257807, 'GB', 'GBR', 'المملكة المتحدة'),
(98217, 3576257808, 3576257823, 'FR', 'FRA', 'فرنسا'),
(98218, 3576257824, 3576257839, 'GB', 'GBR', 'المملكة المتحدة'),
(98219, 3576257840, 3576257855, 'FR', 'FRA', 'فرنسا'),
(98220, 3576257856, 3576257871, 'GB', 'GBR', 'المملكة المتحدة'),
(98221, 3576257872, 3576257887, 'FR', 'FRA', 'فرنسا'),
(98222, 3576257888, 3576257903, 'GB', 'GBR', 'المملكة المتحدة'),
(98223, 3576257904, 3576257983, 'FR', 'FRA', 'فرنسا'),
(98224, 3576257984, 3576257999, 'GB', 'GBR', 'المملكة المتحدة'),
(98225, 3576258000, 3576258055, 'FR', 'FRA', 'فرنسا'),
(98226, 3576258056, 3576258063, 'GB', 'GBR', 'المملكة المتحدة'),
(98227, 3576258064, 3576258079, 'FR', 'FRA', 'فرنسا'),
(98228, 3576258080, 3576258095, 'GB', 'GBR', 'المملكة المتحدة'),
(98229, 3576258096, 3576258167, 'FR', 'FRA', 'فرنسا'),
(98230, 3576258168, 3576258175, 'GB', 'GBR', 'المملكة المتحدة'),
(98231, 3576258176, 3576258351, 'FR', 'FRA', 'فرنسا'),
(98232, 3576258352, 3576258399, 'GB', 'GBR', 'المملكة المتحدة'),
(98233, 3576258400, 3576258415, 'FR', 'FRA', 'فرنسا'),
(98234, 3576258416, 3576258431, 'GB', 'GBR', 'المملكة المتحدة'),
(98235, 3576258432, 3576258447, 'FR', 'FRA', 'فرنسا'),
(98236, 3576258448, 3576258479, 'GB', 'GBR', 'المملكة المتحدة'),
(98237, 3576258480, 3576258495, 'FR', 'FRA', 'فرنسا'),
(98238, 3576258496, 3576258511, 'GB', 'GBR', 'المملكة المتحدة'),
(98239, 3576258512, 3576258527, 'FR', 'FRA', 'فرنسا'),
(98240, 3576258528, 3576258575, 'GB', 'GBR', 'المملكة المتحدة'),
(98241, 3576258576, 3576258591, 'FR', 'FRA', 'فرنسا'),
(98242, 3576258592, 3576258623, 'GB', 'GBR', 'المملكة المتحدة'),
(98243, 3576258624, 3576258671, 'FR', 'FRA', 'فرنسا'),
(98244, 3576258672, 3576258687, 'GB', 'GBR', 'المملكة المتحدة'),
(98245, 3576258688, 3576258703, 'FR', 'FRA', 'فرنسا'),
(98246, 3576258704, 3576258783, 'GB', 'GBR', 'المملكة المتحدة'),
(98247, 3576258784, 3576258863, 'FR', 'FRA', 'فرنسا'),
(98248, 3576258864, 3576258895, 'GB', 'GBR', 'المملكة المتحدة'),
(98249, 3576258896, 3576258943, 'FR', 'FRA', 'فرنسا'),
(98250, 3576258944, 3576259007, 'GB', 'GBR', 'المملكة المتحدة'),
(98251, 3576259008, 3576259023, 'FR', 'FRA', 'فرنسا'),
(98252, 3576259024, 3576259039, 'GB', 'GBR', 'المملكة المتحدة'),
(98253, 3576259040, 3576259071, 'FR', 'FRA', 'فرنسا'),
(98254, 3576259072, 3576259087, 'GB', 'GBR', 'المملكة المتحدة'),
(98255, 3576259088, 3576259103, 'FR', 'FRA', 'فرنسا'),
(98256, 3576259104, 3576259199, 'GB', 'GBR', 'المملكة المتحدة'),
(98257, 3576259200, 3576259231, 'FR', 'FRA', 'فرنسا'),
(98258, 3576259232, 3576259247, 'GB', 'GBR', 'المملكة المتحدة'),
(98259, 3576259248, 3576259279, 'FR', 'FRA', 'فرنسا'),
(98260, 3576259280, 3576259295, 'GB', 'GBR', 'المملكة المتحدة'),
(98261, 3576259296, 3576259311, 'FR', 'FRA', 'فرنسا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(98262, 3576259312, 3576259327, 'GB', 'GBR', 'المملكة المتحدة'),
(98263, 3576259328, 3576259343, 'FR', 'FRA', 'فرنسا'),
(98264, 3576259344, 3576259391, 'GB', 'GBR', 'المملكة المتحدة'),
(98265, 3576259392, 3576259423, 'FR', 'FRA', 'فرنسا'),
(98266, 3576259424, 3576259439, 'GB', 'GBR', 'المملكة المتحدة'),
(98267, 3576259440, 3576259471, 'FR', 'FRA', 'فرنسا'),
(98268, 3576259472, 3576259487, 'GB', 'GBR', 'المملكة المتحدة'),
(98269, 3576259488, 3576259519, 'FR', 'FRA', 'فرنسا'),
(98270, 3576259520, 3576259583, 'GB', 'GBR', 'المملكة المتحدة'),
(98271, 3576259584, 3576259967, 'FR', 'FRA', 'فرنسا'),
(98272, 3576259968, 3576259975, 'GB', 'GBR', 'المملكة المتحدة'),
(98273, 3576259976, 3576259991, 'FR', 'FRA', 'فرنسا'),
(98274, 3576259992, 3576259999, 'GB', 'GBR', 'المملكة المتحدة'),
(98275, 3576260000, 3576260015, 'FR', 'FRA', 'فرنسا'),
(98276, 3576260016, 3576260031, 'GB', 'GBR', 'المملكة المتحدة'),
(98277, 3576260032, 3576260079, 'FR', 'FRA', 'فرنسا'),
(98278, 3576260080, 3576260095, 'GB', 'GBR', 'المملكة المتحدة'),
(98279, 3576260096, 3576260175, 'FR', 'FRA', 'فرنسا'),
(98280, 3576260176, 3576260191, 'GB', 'GBR', 'المملكة المتحدة'),
(98281, 3576260192, 3576260207, 'FR', 'FRA', 'فرنسا'),
(98282, 3576260208, 3576260223, 'GB', 'GBR', 'المملكة المتحدة'),
(98283, 3576260224, 3576260239, 'FR', 'FRA', 'فرنسا'),
(98284, 3576260240, 3576260255, 'GB', 'GBR', 'المملكة المتحدة'),
(98285, 3576260256, 3576260271, 'FR', 'FRA', 'فرنسا'),
(98286, 3576260272, 3576260287, 'GB', 'GBR', 'المملكة المتحدة'),
(98287, 3576260288, 3576260303, 'FR', 'FRA', 'فرنسا'),
(98288, 3576260304, 3576260335, 'GB', 'GBR', 'المملكة المتحدة'),
(98289, 3576260336, 3576260463, 'FR', 'FRA', 'فرنسا'),
(98290, 3576260464, 3576260543, 'GB', 'GBR', 'المملكة المتحدة'),
(98291, 3576260544, 3576260559, 'FR', 'FRA', 'فرنسا'),
(98292, 3576260560, 3576260607, 'GB', 'GBR', 'المملكة المتحدة'),
(98293, 3576260608, 3576260655, 'FR', 'FRA', 'فرنسا'),
(98294, 3576260656, 3576260663, 'GB', 'GBR', 'المملكة المتحدة'),
(98295, 3576260664, 3576260671, 'FR', 'FRA', 'فرنسا'),
(98296, 3576260672, 3576260679, 'GB', 'GBR', 'المملكة المتحدة'),
(98297, 3576260680, 3576260703, 'FR', 'FRA', 'فرنسا'),
(98298, 3576260704, 3576260735, 'GB', 'GBR', 'المملكة المتحدة'),
(98299, 3576260736, 3576260903, 'FR', 'FRA', 'فرنسا'),
(98300, 3576260904, 3576260927, 'GB', 'GBR', 'المملكة المتحدة'),
(98301, 3576260928, 3576260959, 'FR', 'FRA', 'فرنسا'),
(98302, 3576260960, 3576260999, 'GB', 'GBR', 'المملكة المتحدة'),
(98303, 3576261000, 3576261015, 'FR', 'FRA', 'فرنسا'),
(98304, 3576261016, 3576261023, 'GB', 'GBR', 'المملكة المتحدة'),
(98305, 3576261024, 3576261047, 'FR', 'FRA', 'فرنسا'),
(98306, 3576261048, 3576261055, 'GB', 'GBR', 'المملكة المتحدة'),
(98307, 3576261056, 3576261063, 'FR', 'FRA', 'فرنسا'),
(98308, 3576261064, 3576261071, 'GB', 'GBR', 'المملكة المتحدة'),
(98309, 3576261072, 3576261079, 'FR', 'FRA', 'فرنسا'),
(98310, 3576261080, 3576261095, 'GB', 'GBR', 'المملكة المتحدة'),
(98311, 3576261096, 3576261103, 'FR', 'FRA', 'فرنسا'),
(98312, 3576261104, 3576261111, 'GB', 'GBR', 'المملكة المتحدة'),
(98313, 3576261112, 3576261375, 'FR', 'FRA', 'فرنسا'),
(98314, 3576261376, 3576261631, 'GB', 'GBR', 'المملكة المتحدة'),
(98315, 3576261632, 3576261927, 'FR', 'FRA', 'فرنسا'),
(98316, 3576261928, 3576261935, 'GB', 'GBR', 'المملكة المتحدة'),
(98317, 3576261936, 3576263439, 'FR', 'FRA', 'فرنسا'),
(98318, 3576263440, 3576263487, 'GB', 'GBR', 'المملكة المتحدة'),
(98319, 3576263488, 3576263519, 'FR', 'FRA', 'فرنسا'),
(98320, 3576263520, 3576263527, 'GB', 'GBR', 'المملكة المتحدة'),
(98321, 3576263528, 3576263535, 'FR', 'FRA', 'فرنسا'),
(98322, 3576263536, 3576263551, 'GB', 'GBR', 'المملكة المتحدة'),
(98323, 3576263552, 3576263567, 'FR', 'FRA', 'فرنسا'),
(98324, 3576263568, 3576263575, 'GB', 'GBR', 'المملكة المتحدة'),
(98325, 3576263576, 3576263583, 'FR', 'FRA', 'فرنسا'),
(98326, 3576263584, 3576263599, 'GB', 'GBR', 'المملكة المتحدة'),
(98327, 3576263600, 3576263615, 'FR', 'FRA', 'فرنسا'),
(98328, 3576263616, 3576263623, 'GB', 'GBR', 'المملكة المتحدة'),
(98329, 3576263624, 3576263751, 'FR', 'FRA', 'فرنسا'),
(98330, 3576263752, 3576263759, 'GB', 'GBR', 'المملكة المتحدة'),
(98331, 3576263760, 3576263791, 'FR', 'FRA', 'فرنسا'),
(98332, 3576263792, 3576263887, 'GB', 'GBR', 'المملكة المتحدة'),
(98333, 3576263888, 3576263911, 'FR', 'FRA', 'فرنسا'),
(98334, 3576263912, 3576263919, 'GB', 'GBR', 'المملكة المتحدة'),
(98335, 3576263920, 3576264295, 'FR', 'FRA', 'فرنسا'),
(98336, 3576264296, 3576264319, 'GB', 'GBR', 'المملكة المتحدة'),
(98337, 3576264320, 3576264383, 'FR', 'FRA', 'فرنسا'),
(98338, 3576264384, 3576264399, 'GB', 'GBR', 'المملكة المتحدة'),
(98339, 3576264400, 3576264447, 'FR', 'FRA', 'فرنسا'),
(98340, 3576264448, 3576264511, 'GB', 'GBR', 'المملكة المتحدة'),
(98341, 3576264512, 3576264543, 'FR', 'FRA', 'فرنسا'),
(98342, 3576264544, 3576264559, 'GB', 'GBR', 'المملكة المتحدة'),
(98343, 3576264560, 3576264575, 'FR', 'FRA', 'فرنسا'),
(98344, 3576264576, 3576264623, 'GB', 'GBR', 'المملكة المتحدة'),
(98345, 3576264624, 3576264639, 'FR', 'FRA', 'فرنسا'),
(98346, 3576264640, 3576264687, 'GB', 'GBR', 'المملكة المتحدة'),
(98347, 3576264688, 3576265375, 'FR', 'FRA', 'فرنسا'),
(98348, 3576265376, 3576265383, 'GB', 'GBR', 'المملكة المتحدة'),
(98349, 3576265384, 3576265399, 'FR', 'FRA', 'فرنسا'),
(98350, 3576265400, 3576265423, 'GB', 'GBR', 'المملكة المتحدة'),
(98351, 3576265424, 3576265463, 'FR', 'FRA', 'فرنسا'),
(98352, 3576265464, 3576265471, 'GB', 'GBR', 'المملكة المتحدة'),
(98353, 3576265472, 3576265807, 'FR', 'FRA', 'فرنسا'),
(98354, 3576265808, 3576265823, 'GB', 'GBR', 'المملكة المتحدة'),
(98355, 3576265824, 3576265831, 'FR', 'FRA', 'فرنسا'),
(98356, 3576265832, 3576265839, 'GB', 'GBR', 'المملكة المتحدة'),
(98357, 3576265840, 3576265847, 'FR', 'FRA', 'فرنسا'),
(98358, 3576265848, 3576265863, 'GB', 'GBR', 'المملكة المتحدة'),
(98359, 3576265864, 3576265879, 'FR', 'FRA', 'فرنسا'),
(98360, 3576265880, 3576265895, 'GB', 'GBR', 'المملكة المتحدة'),
(98361, 3576265896, 3576266663, 'FR', 'FRA', 'فرنسا'),
(98362, 3576266664, 3576266671, 'GB', 'GBR', 'المملكة المتحدة'),
(98363, 3576266672, 3576266687, 'FR', 'FRA', 'فرنسا'),
(98364, 3576266688, 3576266751, 'GB', 'GBR', 'المملكة المتحدة'),
(98365, 3576266752, 3576299519, 'FR', 'FRA', 'فرنسا'),
(98366, 3576299520, 3576365055, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(98367, 3576365056, 3576430591, 'TR', 'TUR', 'تركيا'),
(98368, 3576430592, 3576496127, 'FR', 'FRA', 'فرنسا'),
(98369, 3576496128, 3576561663, 'IT', 'ITA', 'إيطاليا'),
(98370, 3576561664, 3576603135, 'NL', 'NLD', 'هولندا'),
(98371, 3576603136, 3576603391, 'BE', 'BEL', 'بلجيكا'),
(98372, 3576603392, 3576603647, 'FR', 'FRA', 'فرنسا'),
(98373, 3576603648, 3576604159, 'NL', 'NLD', 'هولندا'),
(98374, 3576604160, 3576604415, 'HU', 'HUN', 'هنغاريا'),
(98375, 3576604416, 3576605183, 'NL', 'NLD', 'هولندا'),
(98376, 3576605184, 3576605439, 'RO', 'ROM', 'رومانيا'),
(98377, 3576605440, 3576605695, 'NL', 'NLD', 'هولندا'),
(98378, 3576605696, 3576605951, 'CZ', 'CZE', 'التشيك'),
(98379, 3576605952, 3576606207, 'AT', 'AUT', 'النمسا'),
(98380, 3576606208, 3576606463, 'GB', 'GBR', 'المملكة المتحدة'),
(98381, 3576606464, 3576606719, 'NL', 'NLD', 'هولندا'),
(98382, 3576606720, 3576606975, 'SE', 'SWE', 'السويد'),
(98383, 3576606976, 3576607231, 'NO', 'NOR', 'النرويج'),
(98384, 3576607232, 3576607487, 'PL', 'POL', 'بولندا'),
(98385, 3576607488, 3576607743, 'DE', 'DEU', 'ألمانيا'),
(98386, 3576607744, 3576620031, 'NL', 'NLD', 'هولندا'),
(98387, 3576620032, 3576620543, 'SE', 'SWE', 'السويد'),
(98388, 3576620544, 3576620799, 'GB', 'GBR', 'المملكة المتحدة'),
(98389, 3576620800, 3576622079, 'NL', 'NLD', 'هولندا'),
(98390, 3576622080, 3576622591, 'GB', 'GBR', 'المملكة المتحدة'),
(98391, 3576622592, 3576623871, 'NL', 'NLD', 'هولندا'),
(98392, 3576623872, 3576624127, 'AT', 'AUT', 'النمسا'),
(98393, 3576624128, 3576626943, 'NL', 'NLD', 'هولندا'),
(98394, 3576626944, 3576692735, 'AT', 'AUT', 'النمسا'),
(98395, 3576692736, 3576758271, 'GB', 'GBR', 'المملكة المتحدة'),
(98396, 3576758272, 3576823807, 'BE', 'BEL', 'بلجيكا'),
(98397, 3576823808, 3576889343, 'SE', 'SWE', 'السويد'),
(98398, 3576889344, 3576954879, 'NL', 'NLD', 'هولندا'),
(98399, 3576954880, 3576987647, 'NO', 'NOR', 'النرويج'),
(98400, 3576987648, 3577001983, 'GB', 'GBR', 'المملكة المتحدة'),
(98401, 3577001984, 3577002495, 'NL', 'NLD', 'هولندا'),
(98402, 3577002496, 3577020415, 'GB', 'GBR', 'المملكة المتحدة'),
(98403, 3577020416, 3577085951, 'NL', 'NLD', 'هولندا'),
(98404, 3577085952, 3577151487, 'DE', 'DEU', 'ألمانيا'),
(98405, 3577151488, 3577167871, 'GB', 'GBR', 'المملكة المتحدة'),
(98406, 3577184256, 3577217023, 'CH', 'CHE', 'سويسرا'),
(98407, 3577217024, 3577263167, 'FR', 'FRA', 'فرنسا'),
(98408, 3577263168, 3577263199, 'US', 'USA', 'الولايات المتحدة'),
(98409, 3577263200, 3577282559, 'FR', 'FRA', 'فرنسا'),
(98410, 3577282560, 3577348095, 'IL', 'ISR', 'إسرائيل'),
(98411, 3577348096, 3577392767, 'PT', 'PRT', 'البورتوغال'),
(98412, 3577392768, 3577392783, 'DE', 'DEU', 'ألمانيا'),
(98413, 3577392784, 3577413631, 'PT', 'PRT', 'البورتوغال'),
(98414, 3577413632, 3577417519, 'RU', 'RUS', 'الإتحاد الروسي'),
(98415, 3577417520, 3577417535, 'KZ', 'KAZ', 'كازاخستان'),
(98416, 3577417536, 3577479167, 'RU', 'RUS', 'الإتحاد الروسي'),
(98417, 3577479168, 3577544703, 'ES', 'ESP', 'إسبانيا'),
(98418, 3577544704, 3577545863, 'DE', 'DEU', 'ألمانيا'),
(98419, 3577545864, 3577545871, 'US', 'USA', 'الولايات المتحدة'),
(98420, 3577545872, 3577545983, 'DE', 'DEU', 'ألمانيا'),
(98421, 3577545984, 3577546111, 'SE', 'SWE', 'السويد'),
(98422, 3577546112, 3577546239, 'DE', 'DEU', 'ألمانيا'),
(98423, 3577546240, 3577546367, 'US', 'USA', 'الولايات المتحدة'),
(98424, 3577546368, 3577547455, 'DE', 'DEU', 'ألمانيا'),
(98425, 3577547456, 3577547519, 'FR', 'FRA', 'فرنسا'),
(98426, 3577547520, 3577551407, 'DE', 'DEU', 'ألمانيا'),
(98427, 3577551408, 3577551411, 'US', 'USA', 'الولايات المتحدة'),
(98428, 3577551412, 3577557215, 'DE', 'DEU', 'ألمانيا'),
(98429, 3577557216, 3577557231, 'US', 'USA', 'الولايات المتحدة'),
(98430, 3577557232, 3577559775, 'DE', 'DEU', 'ألمانيا'),
(98431, 3577559776, 3577559783, 'FR', 'FRA', 'فرنسا'),
(98432, 3577559784, 3577562391, 'DE', 'DEU', 'ألمانيا'),
(98433, 3577562392, 3577562399, 'GB', 'GBR', 'المملكة المتحدة'),
(98434, 3577562400, 3577577231, 'DE', 'DEU', 'ألمانيا'),
(98435, 3577577232, 3577577247, 'US', 'USA', 'الولايات المتحدة'),
(98436, 3577577248, 3577592431, 'DE', 'DEU', 'ألمانيا'),
(98437, 3577592432, 3577592447, 'FR', 'FRA', 'فرنسا'),
(98438, 3577592448, 3577592743, 'DE', 'DEU', 'ألمانيا'),
(98439, 3577592744, 3577592751, 'IE', 'IRL', 'إيرلندا'),
(98440, 3577592752, 3577608743, 'DE', 'DEU', 'ألمانيا'),
(98441, 3577608744, 3577608751, 'ES', 'ESP', 'إسبانيا'),
(98442, 3577608752, 3577610367, 'DE', 'DEU', 'ألمانيا'),
(98443, 3577610368, 3577610495, 'GB', 'GBR', 'المملكة المتحدة'),
(98444, 3577610496, 3577610751, 'DE', 'DEU', 'ألمانيا'),
(98445, 3577610752, 3577611199, 'CH', 'CHE', 'سويسرا'),
(98446, 3577611264, 3577612287, 'DE', 'DEU', 'ألمانيا'),
(98447, 3577612320, 3577612383, 'DE', 'DEU', 'ألمانيا'),
(98448, 3577612416, 3577612543, 'NO', 'NOR', 'النرويج'),
(98449, 3577612544, 3577612799, 'HU', 'HUN', 'هنغاريا'),
(98450, 3577612800, 3577613055, 'FI', 'FIN', 'فنلندا'),
(98451, 3577613312, 3577613567, 'DE', 'DEU', 'ألمانيا'),
(98452, 3577613888, 3577613951, 'TR', 'TUR', 'تركيا'),
(98453, 3577614080, 3577614111, 'DE', 'DEU', 'ألمانيا'),
(98454, 3577614144, 3577614207, 'DE', 'DEU', 'ألمانيا'),
(98455, 3577618432, 3577618447, 'GB', 'GBR', 'المملكة المتحدة'),
(98456, 3577618448, 3577618463, 'NL', 'NLD', 'هولندا'),
(98457, 3577618464, 3577618559, 'GB', 'GBR', 'المملكة المتحدة'),
(98458, 3577618560, 3577618623, 'BE', 'BEL', 'بلجيكا'),
(98459, 3577618656, 3577618671, 'AT', 'AUT', 'النمسا'),
(98460, 3577618688, 3577619935, 'GB', 'GBR', 'المملكة المتحدة'),
(98461, 3577619968, 3577620575, 'GB', 'GBR', 'المملكة المتحدة'),
(98462, 3577620624, 3577620671, 'GB', 'GBR', 'المملكة المتحدة'),
(98463, 3577620672, 3577620735, 'TR', 'TUR', 'تركيا'),
(98464, 3577620992, 3577621055, 'GB', 'GBR', 'المملكة المتحدة'),
(98465, 3577621120, 3577621151, 'GB', 'GBR', 'المملكة المتحدة'),
(98466, 3577621216, 3577621223, 'SK', 'SVK', 'سلوفاكيا'),
(98467, 3577621248, 3577622143, 'GB', 'GBR', 'المملكة المتحدة'),
(98468, 3577622144, 3577622271, 'DE', 'DEU', 'ألمانيا'),
(98469, 3577622272, 3577622527, 'GB', 'GBR', 'المملكة المتحدة'),
(98470, 3577622592, 3577622927, 'GB', 'GBR', 'المملكة المتحدة'),
(98471, 3577623040, 3577623935, 'GB', 'GBR', 'المملكة المتحدة'),
(98472, 3577624064, 3577624319, 'GB', 'GBR', 'المملكة المتحدة'),
(98473, 3577624448, 3577624879, 'GB', 'GBR', 'المملكة المتحدة'),
(98474, 3577624896, 3577625199, 'GB', 'GBR', 'المملكة المتحدة'),
(98475, 3577625208, 3577625215, 'GB', 'GBR', 'المملكة المتحدة'),
(98476, 3577625232, 3577625599, 'GB', 'GBR', 'المملكة المتحدة'),
(98477, 3577625824, 3577625839, 'GB', 'GBR', 'المملكة المتحدة'),
(98478, 3577625840, 3577625855, 'DE', 'DEU', 'ألمانيا'),
(98479, 3577625856, 3577626175, 'GB', 'GBR', 'المملكة المتحدة'),
(98480, 3577626240, 3577626367, 'GB', 'GBR', 'المملكة المتحدة'),
(98481, 3577626624, 3577627135, 'FR', 'FRA', 'فرنسا'),
(98482, 3577627392, 3577627647, 'GB', 'GBR', 'المملكة المتحدة'),
(98483, 3577627648, 3577627967, 'FR', 'FRA', 'فرنسا'),
(98484, 3577628000, 3577628671, 'FR', 'FRA', 'فرنسا'),
(98485, 3577628672, 3577630719, 'CH', 'CHE', 'سويسرا'),
(98486, 3577630720, 3577631743, 'GB', 'GBR', 'المملكة المتحدة'),
(98487, 3577633792, 3577633951, 'CZ', 'CZE', 'التشيك'),
(98488, 3577633960, 3577633967, 'CZ', 'CZE', 'التشيك'),
(98489, 3577634048, 3577634239, 'CZ', 'CZE', 'التشيك'),
(98490, 3577634816, 3577635455, 'FR', 'FRA', 'فرنسا'),
(98491, 3577635520, 3577635839, 'FR', 'FRA', 'فرنسا'),
(98492, 3577635840, 3577636863, 'DE', 'DEU', 'ألمانيا'),
(98493, 3577636864, 3577638143, 'GB', 'GBR', 'المملكة المتحدة'),
(98494, 3577638144, 3577638399, 'BE', 'BEL', 'بلجيكا'),
(98495, 3577638400, 3577638911, 'GB', 'GBR', 'المملكة المتحدة'),
(98496, 3577638912, 3577638959, 'FR', 'FRA', 'فرنسا'),
(98497, 3577638968, 3577639239, 'FR', 'FRA', 'فرنسا'),
(98498, 3577639248, 3577639679, 'FR', 'FRA', 'فرنسا'),
(98499, 3577639760, 3577639783, 'FR', 'FRA', 'فرنسا'),
(98500, 3577639800, 3577639807, 'FR', 'FRA', 'فرنسا'),
(98501, 3577639840, 3577639847, 'FR', 'FRA', 'فرنسا'),
(98502, 3577639864, 3577639871, 'FR', 'FRA', 'فرنسا'),
(98503, 3577639936, 3577640719, 'FR', 'FRA', 'فرنسا'),
(98504, 3577640728, 3577641151, 'FR', 'FRA', 'فرنسا'),
(98505, 3577641160, 3577641175, 'FR', 'FRA', 'فرنسا'),
(98506, 3577641184, 3577641199, 'FR', 'FRA', 'فرنسا'),
(98507, 3577641216, 3577641423, 'FR', 'FRA', 'فرنسا'),
(98508, 3577641472, 3577641727, 'FR', 'FRA', 'فرنسا'),
(98509, 3577641984, 3577642111, 'GB', 'GBR', 'المملكة المتحدة'),
(98510, 3577642176, 3577642239, 'GB', 'GBR', 'المملكة المتحدة'),
(98511, 3577642240, 3577642623, 'FR', 'FRA', 'فرنسا'),
(98512, 3577642752, 3577643007, 'FR', 'FRA', 'فرنسا'),
(98513, 3577643008, 3577643231, 'NL', 'NLD', 'هولندا'),
(98514, 3577643232, 3577643247, 'GB', 'GBR', 'المملكة المتحدة'),
(98515, 3577643248, 3577643263, 'NL', 'NLD', 'هولندا'),
(98516, 3577645432, 3577645447, 'NL', 'NLD', 'هولندا'),
(98517, 3577645456, 3577645503, 'NL', 'NLD', 'هولندا'),
(98518, 3577645504, 3577645567, 'SK', 'SVK', 'سلوفاكيا'),
(98519, 3577645824, 3577645887, 'NL', 'NLD', 'هولندا'),
(98520, 3577645904, 3577645951, 'NL', 'NLD', 'هولندا'),
(98521, 3577646080, 3577646207, 'NL', 'NLD', 'هولندا'),
(98522, 3577646208, 3577646335, 'NO', 'NOR', 'النرويج'),
(98523, 3577646336, 3577646407, 'NL', 'NLD', 'هولندا'),
(98524, 3577646416, 3577646527, 'NL', 'NLD', 'هولندا'),
(98525, 3577646592, 3577646847, 'NL', 'NLD', 'هولندا'),
(98526, 3577647104, 3577647911, 'DK', 'DNK', 'الدنيمارك'),
(98527, 3577647936, 3577647967, 'DK', 'DNK', 'الدنيمارك'),
(98528, 3577648000, 3577648127, 'DK', 'DNK', 'الدنيمارك'),
(98529, 3577648384, 3577649151, 'NL', 'NLD', 'هولندا'),
(98530, 3577651200, 3577651455, 'GB', 'GBR', 'المملكة المتحدة'),
(98531, 3577652224, 3577652671, 'IT', 'ITA', 'إيطاليا'),
(98532, 3577652736, 3577652743, 'NO', 'NOR', 'النرويج'),
(98533, 3577652752, 3577652767, 'NO', 'NOR', 'النرويج'),
(98534, 3577652864, 3577652943, 'NO', 'NOR', 'النرويج'),
(98535, 3577652992, 3577653119, 'NO', 'NOR', 'النرويج'),
(98536, 3577653248, 3577655295, 'IT', 'ITA', 'إيطاليا'),
(98537, 3577655296, 3577655519, 'AT', 'AUT', 'النمسا'),
(98538, 3577655552, 3577655647, 'AT', 'AUT', 'النمسا'),
(98539, 3577655664, 3577655679, 'AT', 'AUT', 'النمسا'),
(98540, 3577655712, 3577655743, 'AT', 'AUT', 'النمسا'),
(98541, 3577655808, 3577656447, 'AT', 'AUT', 'النمسا'),
(98542, 3577657344, 3577657599, 'GB', 'GBR', 'المملكة المتحدة'),
(98543, 3577657664, 3577659391, 'GB', 'GBR', 'المملكة المتحدة'),
(98544, 3577659392, 3577659679, 'GR', 'GRC', 'اليونان'),
(98545, 3577659712, 3577659743, 'GR', 'GRC', 'اليونان'),
(98546, 3577660160, 3577660607, 'BE', 'BEL', 'بلجيكا'),
(98547, 3577660672, 3577661439, 'BE', 'BEL', 'بلجيكا'),
(98548, 3577663488, 3577665215, 'SE', 'SWE', 'السويد'),
(98549, 3577665248, 3577665311, 'SE', 'SWE', 'السويد'),
(98550, 3577665344, 3577665375, 'SE', 'SWE', 'السويد'),
(98551, 3577665408, 3577665455, 'SE', 'SWE', 'السويد'),
(98552, 3577665536, 3577665591, 'ES', 'ESP', 'إسبانيا'),
(98553, 3577665600, 3577665607, 'ES', 'ESP', 'إسبانيا'),
(98554, 3577665616, 3577665679, 'ES', 'ESP', 'إسبانيا'),
(98555, 3577665792, 3577665823, 'BE', 'BEL', 'بلجيكا'),
(98556, 3577665824, 3577665855, 'RO', 'ROM', 'رومانيا'),
(98557, 3577665856, 3577665919, 'LU', 'LUX', 'لوكسيمبورغ'),
(98558, 3577666048, 3577666175, 'ES', 'ESP', 'إسبانيا'),
(98559, 3577667584, 3577667743, 'PL', 'POL', 'بولندا'),
(98560, 3577668640, 3577668671, 'IE', 'IRL', 'إيرلندا'),
(98561, 3577668736, 3577668799, 'IE', 'IRL', 'إيرلندا'),
(98562, 3577669120, 3577669383, 'HU', 'HUN', 'هنغاريا'),
(98563, 3577669504, 3577669631, 'HU', 'HUN', 'هنغاريا'),
(98564, 3577669632, 3577671679, 'BE', 'BEL', 'بلجيكا'),
(98565, 3577671680, 3577672191, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(98566, 3577672192, 3577673727, 'DE', 'DEU', 'ألمانيا'),
(98567, 3577675776, 3577741311, 'PT', 'PRT', 'البورتوغال'),
(98568, 3577741312, 3578003455, 'SE', 'SWE', 'السويد'),
(98569, 3578003456, 3578049023, 'DE', 'DEU', 'ألمانيا'),
(98570, 3578049024, 3578049055, 'CH', 'CHE', 'سويسرا'),
(98571, 3578049056, 3578208127, 'DE', 'DEU', 'ألمانيا'),
(98572, 3578208128, 3578208191, 'PK', 'PAK', 'باكستان'),
(98573, 3578208192, 3578234759, 'DE', 'DEU', 'ألمانيا'),
(98574, 3578234760, 3578234767, 'US', 'USA', 'الولايات المتحدة'),
(98575, 3578234768, 3578236791, 'DE', 'DEU', 'ألمانيا'),
(98576, 3578236792, 3578236799, 'PL', 'POL', 'بولندا'),
(98577, 3578236800, 3578265599, 'DE', 'DEU', 'ألمانيا'),
(98578, 3578265600, 3578331135, 'GB', 'GBR', 'المملكة المتحدة'),
(98579, 3578331136, 3578339327, 'PL', 'POL', 'بولندا'),
(98580, 3578339328, 3578347519, 'ES', 'ESP', 'إسبانيا'),
(98581, 3578347520, 3578363903, 'DE', 'DEU', 'ألمانيا'),
(98582, 3578363904, 3578396671, 'NL', 'NLD', 'هولندا'),
(98583, 3578396672, 3578462207, 'TR', 'TUR', 'تركيا'),
(98584, 3578462208, 3578527743, 'NL', 'NLD', 'هولندا'),
(98585, 3578527744, 3578658815, 'PL', 'POL', 'بولندا'),
(98586, 3578658816, 3578724351, 'GB', 'GBR', 'المملكة المتحدة'),
(98587, 3578724352, 3578732543, 'RU', 'RUS', 'الإتحاد الروسي'),
(98588, 3578732544, 3578740735, 'IE', 'IRL', 'إيرلندا'),
(98589, 3578740736, 3578757119, 'RU', 'RUS', 'الإتحاد الروسي'),
(98590, 3578757120, 3578822655, 'SE', 'SWE', 'السويد'),
(98591, 3578822656, 3578855423, 'RU', 'RUS', 'الإتحاد الروسي'),
(98592, 3578855424, 3578888191, 'GB', 'GBR', 'المملكة المتحدة'),
(98593, 3578888192, 3578920959, 'SK', 'SVK', 'سلوفاكيا'),
(98594, 3578920960, 3578986495, 'IT', 'ITA', 'إيطاليا'),
(98595, 3578986496, 3578988095, 'DE', 'DEU', 'ألمانيا'),
(98596, 3578988096, 3578988099, 'CH', 'CHE', 'سويسرا'),
(98597, 3578988100, 3578996999, 'DE', 'DEU', 'ألمانيا'),
(98598, 3578997000, 3578997007, 'CH', 'CHE', 'سويسرا'),
(98599, 3578997008, 3578997935, 'DE', 'DEU', 'ألمانيا'),
(98600, 3578997936, 3578997943, 'FR', 'FRA', 'فرنسا'),
(98601, 3578997944, 3578998575, 'DE', 'DEU', 'ألمانيا'),
(98602, 3578998576, 3578998583, 'GB', 'GBR', 'المملكة المتحدة'),
(98603, 3578998584, 3579002879, 'DE', 'DEU', 'ألمانيا'),
(98604, 3579002880, 3579019263, 'GB', 'GBR', 'المملكة المتحدة'),
(98605, 3579019264, 3579052031, 'DK', 'DNK', 'الدنيمارك'),
(98606, 3579052032, 3579117567, 'NL', 'NLD', 'هولندا'),
(98607, 3579117568, 3579132159, 'RU', 'RUS', 'الإتحاد الروسي'),
(98608, 3579132160, 3579132415, 'BY', 'BLR', 'روسيا البيضاء'),
(98609, 3579132416, 3579183103, 'RU', 'RUS', 'الإتحاد الروسي'),
(98610, 3579183104, 3579191759, 'GB', 'GBR', 'المملكة المتحدة'),
(98611, 3579191760, 3579191775, 'DE', 'DEU', 'ألمانيا'),
(98612, 3579191776, 3579193599, 'GB', 'GBR', 'المملكة المتحدة'),
(98613, 3579193600, 3579193703, 'NL', 'NLD', 'هولندا'),
(98614, 3579193704, 3579193704, 'GB', 'GBR', 'المملكة المتحدة'),
(98615, 3579193705, 3579193705, 'NL', 'NLD', 'هولندا'),
(98616, 3579193706, 3579193711, 'GB', 'GBR', 'المملكة المتحدة'),
(98617, 3579193712, 3579193727, 'BE', 'BEL', 'بلجيكا'),
(98618, 3579193728, 3579193799, 'NL', 'NLD', 'هولندا'),
(98619, 3579193800, 3579193807, 'GB', 'GBR', 'المملكة المتحدة'),
(98620, 3579193808, 3579193815, 'NL', 'NLD', 'هولندا'),
(98621, 3579193816, 3579193823, 'ES', 'ESP', 'إسبانيا'),
(98622, 3579193824, 3579193855, 'NL', 'NLD', 'هولندا'),
(98623, 3579193856, 3579197055, 'GB', 'GBR', 'المملكة المتحدة'),
(98624, 3579197056, 3579197183, 'US', 'USA', 'الولايات المتحدة'),
(98625, 3579197184, 3579197887, 'GB', 'GBR', 'المملكة المتحدة'),
(98626, 3579197888, 3579197903, 'IT', 'ITA', 'إيطاليا'),
(98627, 3579197904, 3579228191, 'GB', 'GBR', 'المملكة المتحدة'),
(98628, 3579228192, 3579228207, 'IT', 'ITA', 'إيطاليا'),
(98629, 3579228208, 3579228223, 'ES', 'ESP', 'إسبانيا'),
(98630, 3579228224, 3579228671, 'GB', 'GBR', 'المملكة المتحدة'),
(98631, 3579228672, 3579228799, 'US', 'USA', 'الولايات المتحدة'),
(98632, 3579228800, 3579241151, 'GB', 'GBR', 'المملكة المتحدة'),
(98633, 3579241152, 3579241215, 'IE', 'IRL', 'إيرلندا'),
(98634, 3579241216, 3579248639, 'GB', 'GBR', 'المملكة المتحدة'),
(98635, 3579248640, 3579314175, 'RU', 'RUS', 'الإتحاد الروسي'),
(98636, 3579346944, 3579361535, 'SE', 'SWE', 'السويد'),
(98637, 3579361536, 3579361791, 'NO', 'NOR', 'النرويج'),
(98638, 3579361792, 3579362047, 'SE', 'SWE', 'السويد'),
(98639, 3579362048, 3579362063, 'NO', 'NOR', 'النرويج'),
(98640, 3579362064, 3579362303, 'SE', 'SWE', 'السويد'),
(98641, 3579362304, 3579362559, 'NO', 'NOR', 'النرويج'),
(98642, 3579362560, 3579362815, 'SE', 'SWE', 'السويد'),
(98643, 3579362816, 3579363327, 'NO', 'NOR', 'النرويج'),
(98644, 3579363328, 3579445247, 'SE', 'SWE', 'السويد'),
(98645, 3579445248, 3579463679, 'AT', 'AUT', 'النمسا'),
(98646, 3579463680, 3579463683, 'US', 'USA', 'الولايات المتحدة'),
(98647, 3579463684, 3579478015, 'AT', 'AUT', 'النمسا'),
(98648, 3579478016, 3579480847, 'FR', 'FRA', 'فرنسا'),
(98649, 3579480848, 3579480855, 'NL', 'NLD', 'هولندا'),
(98650, 3579480856, 3579480863, 'FR', 'FRA', 'فرنسا'),
(98651, 3579480864, 3579480871, 'NL', 'NLD', 'هولندا'),
(98652, 3579480872, 3579481095, 'FR', 'FRA', 'فرنسا'),
(98653, 3579481096, 3579481103, 'CH', 'CHE', 'سويسرا'),
(98654, 3579481104, 3579481119, 'FR', 'FRA', 'فرنسا'),
(98655, 3579481120, 3579481127, 'GB', 'GBR', 'المملكة المتحدة'),
(98656, 3579481128, 3579481143, 'FR', 'FRA', 'فرنسا'),
(98657, 3579481144, 3579481151, 'CH', 'CHE', 'سويسرا'),
(98658, 3579481152, 3579481159, 'FR', 'FRA', 'فرنسا'),
(98659, 3579481160, 3579481167, 'GB', 'GBR', 'المملكة المتحدة'),
(98660, 3579481168, 3579481191, 'FR', 'FRA', 'فرنسا'),
(98661, 3579481192, 3579481199, 'CH', 'CHE', 'سويسرا'),
(98662, 3579481200, 3579481247, 'FR', 'FRA', 'فرنسا'),
(98663, 3579481248, 3579481255, 'GB', 'GBR', 'المملكة المتحدة'),
(98664, 3579481256, 3579481263, 'CH', 'CHE', 'سويسرا'),
(98665, 3579481264, 3579481279, 'FR', 'FRA', 'فرنسا'),
(98666, 3579481280, 3579481287, 'GB', 'GBR', 'المملكة المتحدة'),
(98667, 3579481288, 3579482623, 'FR', 'FRA', 'فرنسا'),
(98668, 3579482624, 3579482783, 'NL', 'NLD', 'هولندا'),
(98669, 3579482784, 3579482799, 'FR', 'FRA', 'فرنسا'),
(98670, 3579482800, 3579482927, 'NL', 'NLD', 'هولندا'),
(98671, 3579482928, 3579482943, 'FR', 'FRA', 'فرنسا'),
(98672, 3579482944, 3579482991, 'NL', 'NLD', 'هولندا'),
(98673, 3579482992, 3579483151, 'FR', 'FRA', 'فرنسا'),
(98674, 3579483152, 3579483263, 'NL', 'NLD', 'هولندا'),
(98675, 3579483264, 3579483295, 'FR', 'FRA', 'فرنسا'),
(98676, 3579483296, 3579483311, 'NL', 'NLD', 'هولندا'),
(98677, 3579483312, 3579483359, 'FR', 'FRA', 'فرنسا'),
(98678, 3579483360, 3579483375, 'NL', 'NLD', 'هولندا'),
(98679, 3579483376, 3579484751, 'FR', 'FRA', 'فرنسا'),
(98680, 3579484752, 3579484767, 'BE', 'BEL', 'بلجيكا'),
(98681, 3579484768, 3579485263, 'FR', 'FRA', 'فرنسا'),
(98682, 3579485264, 3579485279, 'BE', 'BEL', 'بلجيكا'),
(98683, 3579485280, 3579485695, 'FR', 'FRA', 'فرنسا'),
(98684, 3579485696, 3579485711, 'GB', 'GBR', 'المملكة المتحدة'),
(98685, 3579485712, 3579485714, 'FR', 'FRA', 'فرنسا'),
(98686, 3579485715, 3579485727, 'GB', 'GBR', 'المملكة المتحدة'),
(98687, 3579485728, 3579485807, 'FR', 'FRA', 'فرنسا'),
(98688, 3579485808, 3579485823, 'GB', 'GBR', 'المملكة المتحدة'),
(98689, 3579485824, 3579485887, 'FR', 'FRA', 'فرنسا'),
(98690, 3579485888, 3579485888, 'GB', 'GBR', 'المملكة المتحدة'),
(98691, 3579485889, 3579485903, 'FR', 'FRA', 'فرنسا'),
(98692, 3579485904, 3579485919, 'DE', 'DEU', 'ألمانيا'),
(98693, 3579485920, 3579485983, 'FR', 'FRA', 'فرنسا'),
(98694, 3579485984, 3579485999, 'CH', 'CHE', 'سويسرا'),
(98695, 3579486000, 3579486015, 'FR', 'FRA', 'فرنسا'),
(98696, 3579486016, 3579486031, 'GB', 'GBR', 'المملكة المتحدة'),
(98697, 3579486032, 3579486047, 'DE', 'DEU', 'ألمانيا'),
(98698, 3579486048, 3579486095, 'GB', 'GBR', 'المملكة المتحدة'),
(98699, 3579486096, 3579486143, 'FR', 'FRA', 'فرنسا'),
(98700, 3579486144, 3579486175, 'GB', 'GBR', 'المملكة المتحدة'),
(98701, 3579486176, 3579486191, 'FR', 'FRA', 'فرنسا'),
(98702, 3579486192, 3579486207, 'GB', 'GBR', 'المملكة المتحدة'),
(98703, 3579486208, 3579486271, 'FR', 'FRA', 'فرنسا'),
(98704, 3579486272, 3579486287, 'GB', 'GBR', 'المملكة المتحدة'),
(98705, 3579486288, 3579486303, 'FR', 'FRA', 'فرنسا'),
(98706, 3579486304, 3579486319, 'GB', 'GBR', 'المملكة المتحدة'),
(98707, 3579486320, 3579486335, 'FR', 'FRA', 'فرنسا'),
(98708, 3579486336, 3579486351, 'GB', 'GBR', 'المملكة المتحدة'),
(98709, 3579486352, 3579486367, 'FR', 'FRA', 'فرنسا'),
(98710, 3579486368, 3579486383, 'IT', 'ITA', 'إيطاليا'),
(98711, 3579486384, 3579486399, 'DE', 'DEU', 'ألمانيا'),
(98712, 3579486400, 3579486415, 'FR', 'FRA', 'فرنسا'),
(98713, 3579486416, 3579486431, 'DE', 'DEU', 'ألمانيا'),
(98714, 3579486432, 3579486447, 'GB', 'GBR', 'المملكة المتحدة'),
(98715, 3579486448, 3579486735, 'FR', 'FRA', 'فرنسا'),
(98716, 3579486736, 3579486751, 'DE', 'DEU', 'ألمانيا'),
(98717, 3579486752, 3579486831, 'FR', 'FRA', 'فرنسا'),
(98718, 3579486832, 3579486847, 'BE', 'BEL', 'بلجيكا'),
(98719, 3579486848, 3579486863, 'FR', 'FRA', 'فرنسا'),
(98720, 3579486864, 3579486879, 'GB', 'GBR', 'المملكة المتحدة'),
(98721, 3579486880, 3579487007, 'FR', 'FRA', 'فرنسا'),
(98722, 3579487008, 3579487039, 'GB', 'GBR', 'المملكة المتحدة'),
(98723, 3579487040, 3579487055, 'DE', 'DEU', 'ألمانيا'),
(98724, 3579487056, 3579487103, 'FR', 'FRA', 'فرنسا'),
(98725, 3579487104, 3579487119, 'GB', 'GBR', 'المملكة المتحدة'),
(98726, 3579487120, 3579487215, 'FR', 'FRA', 'فرنسا'),
(98727, 3579487216, 3579487231, 'GB', 'GBR', 'المملكة المتحدة'),
(98728, 3579487232, 3579487247, 'FR', 'FRA', 'فرنسا'),
(98729, 3579487248, 3579487263, 'GB', 'GBR', 'المملكة المتحدة'),
(98730, 3579487264, 3579487471, 'FR', 'FRA', 'فرنسا'),
(98731, 3579487472, 3579487487, 'ES', 'ESP', 'إسبانيا'),
(98732, 3579487488, 3579487519, 'FR', 'FRA', 'فرنسا'),
(98733, 3579487520, 3579487531, 'IT', 'ITA', 'إيطاليا'),
(98734, 3579487532, 3579487535, 'FR', 'FRA', 'فرنسا'),
(98735, 3579487536, 3579487551, 'GB', 'GBR', 'المملكة المتحدة'),
(98736, 3579487552, 3579487567, 'FR', 'FRA', 'فرنسا'),
(98737, 3579487568, 3579487583, 'GB', 'GBR', 'المملكة المتحدة'),
(98738, 3579487584, 3579487599, 'FR', 'FRA', 'فرنسا'),
(98739, 3579487600, 3579487615, 'IT', 'ITA', 'إيطاليا'),
(98740, 3579487616, 3579487663, 'FR', 'FRA', 'فرنسا'),
(98741, 3579487664, 3579487711, 'DE', 'DEU', 'ألمانيا'),
(98742, 3579487712, 3579487727, 'SE', 'SWE', 'السويد'),
(98743, 3579487728, 3579487743, 'GB', 'GBR', 'المملكة المتحدة'),
(98744, 3579487744, 3579487807, 'FR', 'FRA', 'فرنسا'),
(98745, 3579487808, 3579487823, 'GB', 'GBR', 'المملكة المتحدة'),
(98746, 3579487824, 3579487855, 'FR', 'FRA', 'فرنسا'),
(98747, 3579487856, 3579487871, 'GB', 'GBR', 'المملكة المتحدة'),
(98748, 3579487872, 3579487887, 'IE', 'IRL', 'إيرلندا'),
(98749, 3579487888, 3579487903, 'DE', 'DEU', 'ألمانيا'),
(98750, 3579487904, 3579487951, 'FR', 'FRA', 'فرنسا'),
(98751, 3579487952, 3579487967, 'GB', 'GBR', 'المملكة المتحدة'),
(98752, 3579487968, 3579487983, 'IT', 'ITA', 'إيطاليا'),
(98753, 3579487984, 3579487999, 'GB', 'GBR', 'المملكة المتحدة'),
(98754, 3579488000, 3579488047, 'FR', 'FRA', 'فرنسا'),
(98755, 3579488048, 3579488079, 'GB', 'GBR', 'المملكة المتحدة'),
(98756, 3579488080, 3579490559, 'FR', 'FRA', 'فرنسا'),
(98757, 3579490560, 3579490655, 'PT', 'PRT', 'البورتوغال'),
(98758, 3579490656, 3579490671, 'FR', 'FRA', 'فرنسا'),
(98759, 3579490672, 3579490719, 'PT', 'PRT', 'البورتوغال'),
(98760, 3579490720, 3579490735, 'NL', 'NLD', 'هولندا'),
(98761, 3579490736, 3579490751, 'FR', 'FRA', 'فرنسا'),
(98762, 3579490752, 3579490799, 'PT', 'PRT', 'البورتوغال'),
(98763, 3579490800, 3579490831, 'FR', 'FRA', 'فرنسا'),
(98764, 3579490832, 3579490943, 'PT', 'PRT', 'البورتوغال'),
(98765, 3579490944, 3579490959, 'FR', 'FRA', 'فرنسا'),
(98766, 3579490960, 3579490975, 'PT', 'PRT', 'البورتوغال'),
(98767, 3579490976, 3579491007, 'FR', 'FRA', 'فرنسا'),
(98768, 3579491008, 3579491023, 'PT', 'PRT', 'البورتوغال'),
(98769, 3579491024, 3579491231, 'FR', 'FRA', 'فرنسا'),
(98770, 3579491232, 3579491247, 'PT', 'PRT', 'البورتوغال'),
(98771, 3579491248, 3579491263, 'NL', 'NLD', 'هولندا'),
(98772, 3579491264, 3579491471, 'FR', 'FRA', 'فرنسا'),
(98773, 3579491472, 3579491487, 'PT', 'PRT', 'البورتوغال'),
(98774, 3579491488, 3579497983, 'FR', 'FRA', 'فرنسا'),
(98775, 3579497984, 3579497991, 'NL', 'NLD', 'هولندا'),
(98776, 3579497992, 3579527167, 'FR', 'FRA', 'فرنسا'),
(98777, 3579527168, 3579543551, 'BA', 'BIH', 'البوسنه والهرسك'),
(98778, 3579543552, 3579576319, 'BG', 'BGR', 'بلغاريا'),
(98779, 3579576320, 3579579263, 'IT', 'ITA', 'إيطاليا'),
(98780, 3579579264, 3579579295, 'US', 'USA', 'الولايات المتحدة'),
(98781, 3579579296, 3579582367, 'IT', 'ITA', 'إيطاليا'),
(98782, 3579582368, 3579582399, 'US', 'USA', 'الولايات المتحدة'),
(98783, 3579582400, 3579596927, 'IT', 'ITA', 'إيطاليا'),
(98784, 3579596928, 3579597055, 'GR', 'GRC', 'اليونان'),
(98785, 3579597056, 3579600191, 'IT', 'ITA', 'إيطاليا'),
(98786, 3579600192, 3579600207, 'US', 'USA', 'الولايات المتحدة'),
(98787, 3579600208, 3579601471, 'IT', 'ITA', 'إيطاليا'),
(98788, 3579601472, 3579601487, 'US', 'USA', 'الولايات المتحدة'),
(98789, 3579601488, 3579605487, 'IT', 'ITA', 'إيطاليا'),
(98790, 3579605488, 3579605503, 'DE', 'DEU', 'ألمانيا'),
(98791, 3579605504, 3579607551, 'IT', 'ITA', 'إيطاليا'),
(98792, 3579607552, 3579607807, 'US', 'USA', 'الولايات المتحدة'),
(98793, 3579607808, 3579609087, 'IT', 'ITA', 'إيطاليا'),
(98794, 3579609088, 3579641855, 'PL', 'POL', 'بولندا'),
(98795, 3579641856, 3579707391, 'NL', 'NLD', 'هولندا'),
(98796, 3579707392, 3579723775, 'ES', 'ESP', 'إسبانيا'),
(98797, 3579723776, 3579740159, 'AT', 'AUT', 'النمسا'),
(98798, 3579740160, 3579772927, 'IE', 'IRL', 'إيرلندا'),
(98799, 3579772928, 3579838463, 'DE', 'DEU', 'ألمانيا'),
(98800, 3579838464, 3580100607, 'ES', 'ESP', 'إسبانيا'),
(98801, 3580100608, 3580198911, 'SE', 'SWE', 'السويد'),
(98802, 3580198912, 3580199423, 'LV', 'LVA', 'لاتفيا'),
(98803, 3580199424, 3580199935, 'SE', 'SWE', 'السويد'),
(98804, 3580199936, 3580200447, 'EE', 'EST', 'إستونيا'),
(98805, 3580200448, 3580200959, 'SE', 'SWE', 'السويد'),
(98806, 3580200960, 3580201471, 'LT', 'LTU', 'ليتوانيا'),
(98807, 3580201472, 3580203519, 'SE', 'SWE', 'السويد'),
(98808, 3580203520, 3580204543, 'RU', 'RUS', 'الإتحاد الروسي'),
(98809, 3580204544, 3580205055, 'SE', 'SWE', 'السويد'),
(98810, 3580205056, 3580207103, 'HR', 'HRV', 'كرواتيا'),
(98811, 3580207104, 3580208127, 'SE', 'SWE', 'السويد'),
(98812, 3580208128, 3580208639, 'EE', 'EST', 'إستونيا'),
(98813, 3580208640, 3580213247, 'SE', 'SWE', 'السويد'),
(98814, 3580213248, 3580214271, 'CH', 'CHE', 'سويسرا'),
(98815, 3580214272, 3580214783, 'LV', 'LVA', 'لاتفيا'),
(98816, 3580214784, 3580223487, 'SE', 'SWE', 'السويد'),
(98817, 3580223488, 3580231679, 'DE', 'DEU', 'ألمانيا'),
(98818, 3580231680, 3580231935, 'LT', 'LTU', 'ليتوانيا'),
(98819, 3580231936, 3580232447, 'LV', 'LVA', 'لاتفيا'),
(98820, 3580232448, 3580233727, 'LT', 'LTU', 'ليتوانيا'),
(98821, 3580233728, 3580235263, 'SE', 'SWE', 'السويد'),
(98822, 3580235264, 3580236799, 'LT', 'LTU', 'ليتوانيا'),
(98823, 3580236800, 3580237567, 'LV', 'LVA', 'لاتفيا'),
(98824, 3580237568, 3580237823, 'LT', 'LTU', 'ليتوانيا'),
(98825, 3580237824, 3580239359, 'SE', 'SWE', 'السويد'),
(98826, 3580239360, 3580239871, 'LV', 'LVA', 'لاتفيا'),
(98827, 3580239872, 3580241919, 'SE', 'SWE', 'السويد'),
(98828, 3580241920, 3580243967, 'CH', 'CHE', 'سويسرا'),
(98829, 3580243968, 3580248063, 'NL', 'NLD', 'هولندا'),
(98830, 3580248064, 3580250111, 'ES', 'ESP', 'إسبانيا'),
(98831, 3580250112, 3580252671, 'SE', 'SWE', 'السويد'),
(98832, 3580252672, 3580254207, 'EE', 'EST', 'إستونيا'),
(98833, 3580254208, 3580260351, 'DE', 'DEU', 'ألمانيا'),
(98834, 3580260352, 3580265727, 'AT', 'AUT', 'النمسا'),
(98835, 3580265728, 3580338175, 'SE', 'SWE', 'السويد'),
(98836, 3580338176, 3580338432, 'HR', 'HRV', 'كرواتيا'),
(98837, 3580338433, 3580362751, 'SE', 'SWE', 'السويد'),
(98838, 3580362752, 3580473375, 'GB', 'GBR', 'المملكة المتحدة'),
(98839, 3580473376, 3580473391, 'IE', 'IRL', 'إيرلندا'),
(98840, 3580473392, 3580473503, 'GB', 'GBR', 'المملكة المتحدة'),
(98841, 3580473504, 3580473511, 'IE', 'IRL', 'إيرلندا'),
(98842, 3580473512, 3580473519, 'GB', 'GBR', 'المملكة المتحدة'),
(98843, 3580473520, 3580473527, 'IE', 'IRL', 'إيرلندا'),
(98844, 3580473528, 3580473695, 'GB', 'GBR', 'المملكة المتحدة'),
(98845, 3580473696, 3580473727, 'IE', 'IRL', 'إيرلندا'),
(98846, 3580473728, 3580473759, 'GB', 'GBR', 'المملكة المتحدة'),
(98847, 3580473760, 3580473887, 'IE', 'IRL', 'إيرلندا'),
(98848, 3580473888, 3580473951, 'GB', 'GBR', 'المملكة المتحدة'),
(98849, 3580473952, 3580473959, 'IE', 'IRL', 'إيرلندا'),
(98850, 3580473960, 3580473967, 'GB', 'GBR', 'المملكة المتحدة'),
(98851, 3580473968, 3580473983, 'IE', 'IRL', 'إيرلندا'),
(98852, 3580473984, 3580473999, 'GB', 'GBR', 'المملكة المتحدة'),
(98853, 3580474000, 3580474007, 'IE', 'IRL', 'إيرلندا'),
(98854, 3580474008, 3580474095, 'GB', 'GBR', 'المملكة المتحدة'),
(98855, 3580474096, 3580474111, 'IE', 'IRL', 'إيرلندا'),
(98856, 3580474112, 3580474495, 'GB', 'GBR', 'المملكة المتحدة'),
(98857, 3580474496, 3580474559, 'IE', 'IRL', 'إيرلندا'),
(98858, 3580474560, 3580474639, 'GB', 'GBR', 'المملكة المتحدة'),
(98859, 3580474640, 3580474647, 'IE', 'IRL', 'إيرلندا'),
(98860, 3580474648, 3580474655, 'GB', 'GBR', 'المملكة المتحدة'),
(98861, 3580474656, 3580474671, 'IE', 'IRL', 'إيرلندا'),
(98862, 3580474672, 3580474687, 'GB', 'GBR', 'المملكة المتحدة'),
(98863, 3580474688, 3580474703, 'IE', 'IRL', 'إيرلندا'),
(98864, 3580474704, 3580474719, 'GB', 'GBR', 'المملكة المتحدة'),
(98865, 3580474720, 3580474735, 'IE', 'IRL', 'إيرلندا'),
(98866, 3580474736, 3580474807, 'GB', 'GBR', 'المملكة المتحدة'),
(98867, 3580474808, 3580474879, 'IE', 'IRL', 'إيرلندا'),
(98868, 3580474880, 3580475055, 'GB', 'GBR', 'المملكة المتحدة'),
(98869, 3580475056, 3580475063, 'IE', 'IRL', 'إيرلندا'),
(98870, 3580475064, 3580475123, 'GB', 'GBR', 'المملكة المتحدة'),
(98871, 3580475124, 3580475127, 'IE', 'IRL', 'إيرلندا'),
(98872, 3580475128, 3580475343, 'GB', 'GBR', 'المملكة المتحدة'),
(98873, 3580475344, 3580475351, 'IE', 'IRL', 'إيرلندا'),
(98874, 3580475352, 3580624895, 'GB', 'GBR', 'المملكة المتحدة'),
(98875, 3580624896, 3580626943, 'RU', 'RUS', 'الإتحاد الروسي'),
(98876, 3580626944, 3580628991, 'PL', 'POL', 'بولندا'),
(98877, 3580628992, 3580631039, 'RU', 'RUS', 'الإتحاد الروسي'),
(98878, 3580631040, 3580632575, 'NL', 'NLD', 'هولندا'),
(98879, 3580632576, 3580632831, 'DE', 'DEU', 'ألمانيا'),
(98880, 3580632832, 3580633087, 'GB', 'GBR', 'المملكة المتحدة'),
(98881, 3580633088, 3580635135, 'RU', 'RUS', 'الإتحاد الروسي'),
(98882, 3580635136, 3580637183, 'UA', 'UKR', 'أوكرانيا'),
(98883, 3580637184, 3580639231, 'KZ', 'KAZ', 'كازاخستان'),
(98884, 3580641280, 3580643327, 'FR', 'FRA', 'فرنسا'),
(98885, 3580643328, 3580645375, 'UA', 'UKR', 'أوكرانيا'),
(98886, 3580645376, 3580647423, 'PL', 'POL', 'بولندا'),
(98887, 3580647424, 3580649471, 'DE', 'DEU', 'ألمانيا'),
(98888, 3580649472, 3580651519, 'SE', 'SWE', 'السويد'),
(98889, 3580651520, 3580653567, 'NL', 'NLD', 'هولندا'),
(98890, 3580653568, 3580655615, 'PL', 'POL', 'بولندا'),
(98891, 3580655616, 3580657663, 'SK', 'SVK', 'سلوفاكيا'),
(98892, 3580657664, 3580663807, 'RU', 'RUS', 'الإتحاد الروسي'),
(98893, 3580663808, 3580665855, 'PL', 'POL', 'بولندا'),
(98894, 3580665856, 3580667903, 'CZ', 'CZE', 'التشيك'),
(98895, 3580667904, 3580669951, 'RU', 'RUS', 'الإتحاد الروسي'),
(98896, 3580669952, 3580671999, 'UA', 'UKR', 'أوكرانيا'),
(98897, 3580672000, 3580682239, 'RU', 'RUS', 'الإتحاد الروسي'),
(98898, 3580682240, 3580684287, 'PL', 'POL', 'بولندا'),
(98899, 3580684288, 3580686335, 'FR', 'FRA', 'فرنسا'),
(98900, 3580686336, 3580688383, 'BG', 'BGR', 'بلغاريا'),
(98901, 3580688384, 3580698623, 'RU', 'RUS', 'الإتحاد الروسي'),
(98902, 3580698624, 3580702719, 'PL', 'POL', 'بولندا'),
(98903, 3580702720, 3580710911, 'RU', 'RUS', 'الإتحاد الروسي'),
(98904, 3580710912, 3580715007, 'UA', 'UKR', 'أوكرانيا'),
(98905, 3580715008, 3580719103, 'RU', 'RUS', 'الإتحاد الروسي'),
(98906, 3580719104, 3580723199, 'NL', 'NLD', 'هولندا'),
(98907, 3580723200, 3580727295, 'UA', 'UKR', 'أوكرانيا'),
(98908, 3580727296, 3580731391, 'RU', 'RUS', 'الإتحاد الروسي'),
(98909, 3580731392, 3580739583, 'RO', 'ROM', 'رومانيا'),
(98910, 3580739584, 3580743679, 'RU', 'RUS', 'الإتحاد الروسي'),
(98911, 3580743680, 3580751871, 'UA', 'UKR', 'أوكرانيا'),
(98912, 3580751872, 3580755967, 'IR', 'IRN', 'إيران'),
(98913, 3580755968, 3580772351, 'RU', 'RUS', 'الإتحاد الروسي'),
(98914, 3580772352, 3580780543, 'LV', 'LVA', 'لاتفيا'),
(98915, 3580780544, 3580805119, 'UA', 'UKR', 'أوكرانيا'),
(98916, 3580805120, 3580821503, 'RU', 'RUS', 'الإتحاد الروسي'),
(98917, 3580821504, 3580837887, 'FR', 'FRA', 'فرنسا'),
(98918, 3580837888, 3580870655, 'UA', 'UKR', 'أوكرانيا'),
(98919, 3580887040, 3581149183, 'SE', 'SWE', 'السويد'),
(98920, 3581150368, 3581150463, 'IE', 'IRL', 'إيرلندا'),
(98921, 3581150592, 3581150719, 'NL', 'NLD', 'هولندا'),
(98922, 3581150720, 3581150783, 'SE', 'SWE', 'السويد'),
(98923, 3581150976, 3581151039, 'SE', 'SWE', 'السويد'),
(98924, 3581151232, 3581151295, 'SE', 'SWE', 'السويد'),
(98925, 3581154048, 3581154303, 'NL', 'NLD', 'هولندا'),
(98926, 3581157120, 3581158655, 'AT', 'AUT', 'النمسا'),
(98927, 3581159168, 3581159295, 'AT', 'AUT', 'النمسا'),
(98928, 3581159424, 3581161471, 'IE', 'IRL', 'إيرلندا'),
(98929, 3581173760, 3581196799, 'NL', 'NLD', 'هولندا'),
(98930, 3581197312, 3581197567, 'IE', 'IRL', 'إيرلندا'),
(98931, 3581197824, 3581198335, 'GB', 'GBR', 'المملكة المتحدة'),
(98932, 3581198336, 3581200127, 'NL', 'NLD', 'هولندا'),
(98933, 3581203968, 3581214719, 'SE', 'SWE', 'السويد'),
(98934, 3581214720, 3581231103, 'NL', 'NLD', 'هولندا'),
(98935, 3581239296, 3581241343, 'NL', 'NLD', 'هولندا'),
(98936, 3581255680, 3581259263, 'FR', 'FRA', 'فرنسا'),
(98937, 3581261312, 3581261439, 'FR', 'FRA', 'فرنسا'),
(98938, 3581279104, 3581279199, 'NL', 'NLD', 'هولندا'),
(98939, 3581280256, 3581411327, 'BE', 'BEL', 'بلجيكا'),
(98940, 3581411328, 3581673471, 'GB', 'GBR', 'المملكة المتحدة'),
(98941, 3581673472, 3581935615, 'NL', 'NLD', 'هولندا'),
(98942, 3581935616, 3581943807, 'RU', 'RUS', 'الإتحاد الروسي'),
(98943, 3581943808, 3581951999, 'FR', 'FRA', 'فرنسا'),
(98944, 3581952000, 3581960191, 'TR', 'TUR', 'تركيا'),
(98945, 3581960192, 3581976575, 'DE', 'DEU', 'ألمانيا'),
(98946, 3581976576, 3581984767, 'NO', 'NOR', 'النرويج'),
(98947, 3581984768, 3581992959, 'RU', 'RUS', 'الإتحاد الروسي'),
(98948, 3581992960, 3582001151, 'GB', 'GBR', 'المملكة المتحدة'),
(98949, 3582001152, 3582009343, 'DK', 'DNK', 'الدنيمارك'),
(98950, 3582009344, 3582017535, 'RU', 'RUS', 'الإتحاد الروسي'),
(98951, 3582017536, 3582025727, 'GB', 'GBR', 'المملكة المتحدة'),
(98952, 3582025728, 3582033919, 'RU', 'RUS', 'الإتحاد الروسي'),
(98953, 3582033920, 3582042111, 'CZ', 'CZE', 'التشيك'),
(98954, 3582042112, 3582050303, 'ES', 'ESP', 'إسبانيا'),
(98955, 3582050304, 3582058495, 'NL', 'NLD', 'هولندا'),
(98956, 3582058496, 3582066687, 'AT', 'AUT', 'النمسا'),
(98957, 3582066688, 3582074879, 'UA', 'UKR', 'أوكرانيا'),
(98958, 3582074880, 3582078631, 'GB', 'GBR', 'المملكة المتحدة'),
(98959, 3582078632, 3582078639, 'DE', 'DEU', 'ألمانيا'),
(98960, 3582078640, 3582083071, 'GB', 'GBR', 'المملكة المتحدة'),
(98961, 3582083072, 3582091263, 'BG', 'BGR', 'بلغاريا'),
(98962, 3582091264, 3582099455, 'QA', 'QAT', 'قطر'),
(98963, 3582099456, 3582107647, 'GB', 'GBR', 'المملكة المتحدة'),
(98964, 3582107648, 3582115839, 'NL', 'NLD', 'هولندا'),
(98965, 3582115840, 3582124031, 'SE', 'SWE', 'السويد'),
(98966, 3582124032, 3582132223, 'FI', 'FIN', 'فنلندا'),
(98967, 3582132224, 3582140415, 'RU', 'RUS', 'الإتحاد الروسي'),
(98968, 3582140416, 3582148607, 'GE', 'GEO', 'جورجيا'),
(98969, 3582156800, 3582164991, 'GB', 'GBR', 'المملكة المتحدة'),
(98970, 3582164992, 3582173183, 'SE', 'SWE', 'السويد'),
(98971, 3582173184, 3582181375, 'GB', 'GBR', 'المملكة المتحدة'),
(98972, 3582181376, 3582190847, 'DE', 'DEU', 'ألمانيا'),
(98973, 3582190848, 3582190879, 'CH', 'CHE', 'سويسرا'),
(98974, 3582190880, 3582190927, 'DE', 'DEU', 'ألمانيا'),
(98975, 3582190928, 3582190931, 'FR', 'FRA', 'فرنسا'),
(98976, 3582190932, 3582191023, 'DE', 'DEU', 'ألمانيا'),
(98977, 3582191024, 3582191031, 'BE', 'BEL', 'بلجيكا'),
(98978, 3582191032, 3582192127, 'DE', 'DEU', 'ألمانيا'),
(98979, 3582192128, 3582192143, 'NL', 'NLD', 'هولندا'),
(98980, 3582192144, 3582192287, 'DE', 'DEU', 'ألمانيا'),
(98981, 3582192288, 3582192303, 'CH', 'CHE', 'سويسرا'),
(98982, 3582192304, 3582194775, 'DE', 'DEU', 'ألمانيا'),
(98983, 3582194776, 3582194783, 'CY', 'CYP', 'قبرص'),
(98984, 3582194784, 3582194863, 'DE', 'DEU', 'ألمانيا'),
(98985, 3582194864, 3582194879, 'CH', 'CHE', 'سويسرا'),
(98986, 3582194880, 3582195135, 'DE', 'DEU', 'ألمانيا'),
(98987, 3582195136, 3582195143, 'CH', 'CHE', 'سويسرا'),
(98988, 3582195144, 3582196183, 'DE', 'DEU', 'ألمانيا'),
(98989, 3582196184, 3582196191, 'BE', 'BEL', 'بلجيكا'),
(98990, 3582196192, 3582197127, 'DE', 'DEU', 'ألمانيا'),
(98991, 3582197128, 3582197135, 'BZ', 'BLZ', 'بليز'),
(98992, 3582197136, 3582197759, 'DE', 'DEU', 'ألمانيا'),
(98993, 3582197760, 3582205951, 'DK', 'DNK', 'الدنيمارك'),
(98994, 3582205952, 3582214143, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(98995, 3582214144, 3582222335, 'RU', 'RUS', 'الإتحاد الروسي'),
(98996, 3582222336, 3582222511, 'SE', 'SWE', 'السويد'),
(98997, 3582222512, 3582222527, 'DK', 'DNK', 'الدنيمارك'),
(98998, 3582222528, 3582222863, 'SE', 'SWE', 'السويد'),
(98999, 3582222864, 3582222879, 'NO', 'NOR', 'النرويج'),
(99000, 3582222880, 3582223967, 'SE', 'SWE', 'السويد'),
(99001, 3582223968, 3582223975, 'NO', 'NOR', 'النرويج'),
(99002, 3582223976, 3582226599, 'SE', 'SWE', 'السويد'),
(99003, 3582226600, 3582226607, 'FI', 'FIN', 'فنلندا'),
(99004, 3582226608, 3582230527, 'SE', 'SWE', 'السويد'),
(99005, 3582230528, 3582238719, 'BE', 'BEL', 'بلجيكا'),
(99006, 3582238720, 3582255103, 'NL', 'NLD', 'هولندا'),
(99007, 3582255104, 3582263295, 'KW', 'KWT', 'الكويت'),
(99008, 3582263296, 3582271487, 'ME', 'MNE', 'الجبل الأسود'),
(99009, 3582271488, 3582279679, 'NL', 'NLD', 'هولندا'),
(99010, 3582279680, 3582287871, 'GB', 'GBR', 'المملكة المتحدة'),
(99011, 3582287872, 3582296063, 'DE', 'DEU', 'ألمانيا'),
(99012, 3582296064, 3582304255, 'GB', 'GBR', 'المملكة المتحدة'),
(99013, 3582304256, 3582312447, 'UA', 'UKR', 'أوكرانيا'),
(99014, 3582312448, 3582320639, 'GB', 'GBR', 'المملكة المتحدة'),
(99015, 3582320640, 3582328831, 'CH', 'CHE', 'سويسرا'),
(99016, 3582328832, 3582337023, 'HU', 'HUN', 'هنغاريا'),
(99017, 3582337024, 3582341119, 'ES', 'ESP', 'إسبانيا'),
(99018, 3582341120, 3582343167, 'PT', 'PRT', 'البورتوغال'),
(99019, 3582343168, 3582345215, 'ES', 'ESP', 'إسبانيا'),
(99020, 3582345216, 3582353407, 'IT', 'ITA', 'إيطاليا'),
(99021, 3582353408, 3582361599, 'SE', 'SWE', 'السويد'),
(99022, 3582361600, 3582377983, 'PL', 'POL', 'بولندا'),
(99023, 3582377984, 3582386175, 'RU', 'RUS', 'الإتحاد الروسي'),
(99024, 3582386176, 3582394367, 'NL', 'NLD', 'هولندا'),
(99025, 3582394368, 3582402559, 'DE', 'DEU', 'ألمانيا'),
(99026, 3582402560, 3582410751, 'PL', 'POL', 'بولندا'),
(99027, 3582410752, 3582435327, 'RU', 'RUS', 'الإتحاد الروسي'),
(99028, 3582435328, 3582443519, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(99029, 3582443520, 3582451711, 'DE', 'DEU', 'ألمانيا'),
(99030, 3582451712, 3582459903, 'LU', 'LUX', 'لوكسيمبورغ'),
(99031, 3582459904, 3582467135, 'NL', 'NLD', 'هولندا'),
(99032, 3582467136, 3582467199, 'DE', 'DEU', 'ألمانيا'),
(99033, 3582467200, 3582468095, 'NL', 'NLD', 'هولندا'),
(99034, 3582468096, 3582476287, 'SE', 'SWE', 'السويد'),
(99035, 3582476288, 3582484479, 'DE', 'DEU', 'ألمانيا'),
(99036, 3582492672, 3582509055, 'IT', 'ITA', 'إيطاليا'),
(99037, 3582509056, 3582517247, 'SA', 'SAU', 'السعودية'),
(99038, 3582517248, 3582525439, 'PL', 'POL', 'بولندا'),
(99039, 3582525440, 3582533631, 'GB', 'GBR', 'المملكة المتحدة'),
(99040, 3582533632, 3582538183, 'BG', 'BGR', 'بلغاريا'),
(99041, 3582538184, 3582538191, 'GB', 'GBR', 'المملكة المتحدة'),
(99042, 3582538192, 3582541823, 'BG', 'BGR', 'بلغاريا'),
(99043, 3582541824, 3582550015, 'US', 'USA', 'الولايات المتحدة'),
(99044, 3582550016, 3582558207, 'RS', 'SRB', 'صربيا'),
(99045, 3582558208, 3582566399, 'MC', 'MCO', 'موناكو'),
(99046, 3582566432, 3582566479, 'BE', 'BEL', 'بلجيكا'),
(99047, 3582566528, 3582566591, 'BE', 'BEL', 'بلجيكا'),
(99048, 3582566736, 3582566743, 'BE', 'BEL', 'بلجيكا'),
(99049, 3582566752, 3582566767, 'BE', 'BEL', 'بلجيكا'),
(99050, 3582566784, 3582566847, 'BE', 'BEL', 'بلجيكا'),
(99051, 3582566864, 3582566879, 'BE', 'BEL', 'بلجيكا'),
(99052, 3582566912, 3582567019, 'BE', 'BEL', 'بلجيكا'),
(99053, 3582567024, 3582567039, 'BE', 'BEL', 'بلجيكا'),
(99054, 3582567136, 3582567151, 'BE', 'BEL', 'بلجيكا'),
(99055, 3582567232, 3582567295, 'BE', 'BEL', 'بلجيكا'),
(99056, 3582567392, 3582567399, 'BE', 'BEL', 'بلجيكا'),
(99057, 3582567424, 3582567807, 'US', 'USA', 'الولايات المتحدة'),
(99058, 3582567904, 3582567935, 'US', 'USA', 'الولايات المتحدة'),
(99059, 3582568216, 3582568223, 'SE', 'SWE', 'السويد'),
(99060, 3582568248, 3582568263, 'SE', 'SWE', 'السويد'),
(99061, 3582568336, 3582568339, 'SE', 'SWE', 'السويد'),
(99062, 3582568440, 3582568447, 'SE', 'SWE', 'السويد'),
(99063, 3582568448, 3582568703, 'US', 'USA', 'الولايات المتحدة'),
(99064, 3582568832, 3582568959, 'US', 'USA', 'الولايات المتحدة'),
(99065, 3582568960, 3582568967, 'HU', 'HUN', 'هنغاريا'),
(99066, 3582568992, 3582569023, 'CZ', 'CZE', 'التشيك'),
(99067, 3582569032, 3582569035, 'AT', 'AUT', 'النمسا'),
(99068, 3582569036, 3582569039, 'DE', 'DEU', 'ألمانيا'),
(99069, 3582569040, 3582569043, 'AT', 'AUT', 'النمسا'),
(99070, 3582569080, 3582569087, 'HU', 'HUN', 'هنغاريا'),
(99071, 3582569096, 3582569103, 'HU', 'HUN', 'هنغاريا'),
(99072, 3582569208, 3582569215, 'AT', 'AUT', 'النمسا'),
(99073, 3582569280, 3582569303, 'AT', 'AUT', 'النمسا'),
(99074, 3582569472, 3582569535, 'FR', 'FRA', 'فرنسا'),
(99075, 3582570240, 3582570367, 'DE', 'DEU', 'ألمانيا'),
(99076, 3582570400, 3582570431, 'FR', 'FRA', 'فرنسا'),
(99077, 3582570464, 3582570471, 'FR', 'FRA', 'فرنسا'),
(99078, 3582570752, 3582570823, 'FR', 'FRA', 'فرنسا'),
(99079, 3582570848, 3582570855, 'FR', 'FRA', 'فرنسا'),
(99080, 3582570880, 3582570883, 'FR', 'FRA', 'فرنسا'),
(99081, 3582570888, 3582570895, 'FR', 'FRA', 'فرنسا'),
(99082, 3582570904, 3582570975, 'FR', 'FRA', 'فرنسا'),
(99083, 3582570984, 3582571031, 'FR', 'FRA', 'فرنسا'),
(99084, 3582571136, 3582571199, 'FR', 'FRA', 'فرنسا'),
(99085, 3582571304, 3582571307, 'CH', 'CHE', 'سويسرا'),
(99086, 3582571308, 3582571311, 'FR', 'FRA', 'فرنسا'),
(99087, 3582571376, 3582571391, 'FR', 'FRA', 'فرنسا'),
(99088, 3582571408, 3582571423, 'FR', 'FRA', 'فرنسا'),
(99089, 3582571456, 3582571487, 'FR', 'FRA', 'فرنسا'),
(99090, 3582571648, 3582571687, 'IE', 'IRL', 'إيرلندا'),
(99091, 3582571692, 3582571707, 'IE', 'IRL', 'إيرلندا'),
(99092, 3582571728, 3582571839, 'IE', 'IRL', 'إيرلندا'),
(99093, 3582571856, 3582571871, 'IE', 'IRL', 'إيرلندا'),
(99094, 3582571976, 3582571979, 'IE', 'IRL', 'إيرلندا'),
(99095, 3582572000, 3582572015, 'IE', 'IRL', 'إيرلندا'),
(99096, 3582572024, 3582572031, 'IE', 'IRL', 'إيرلندا'),
(99097, 3582572416, 3582572431, 'CH', 'CHE', 'سويسرا'),
(99098, 3582572448, 3582572451, 'CH', 'CHE', 'سويسرا'),
(99099, 3582572456, 3582572459, 'CH', 'CHE', 'سويسرا'),
(99100, 3582572480, 3582572543, 'CH', 'CHE', 'سويسرا'),
(99101, 3582572560, 3582572567, 'DE', 'DEU', 'ألمانيا'),
(99102, 3582572800, 3582572863, 'DE', 'DEU', 'ألمانيا'),
(99103, 3582572944, 3582572951, 'DE', 'DEU', 'ألمانيا'),
(99104, 3582572976, 3582572983, 'DE', 'DEU', 'ألمانيا'),
(99105, 3582573024, 3582573055, 'DE', 'DEU', 'ألمانيا'),
(99106, 3582573088, 3582573095, 'DE', 'DEU', 'ألمانيا'),
(99107, 3582573104, 3582573111, 'DE', 'DEU', 'ألمانيا'),
(99108, 3582573128, 3582573135, 'DE', 'DEU', 'ألمانيا'),
(99109, 3582573184, 3582573215, 'DE', 'DEU', 'ألمانيا'),
(99110, 3582573408, 3582573423, 'DE', 'DEU', 'ألمانيا'),
(99111, 3582573432, 3582573439, 'DE', 'DEU', 'ألمانيا'),
(99112, 3582573512, 3582573519, 'DE', 'DEU', 'ألمانيا'),
(99113, 3582573552, 3582573567, 'DE', 'DEU', 'ألمانيا'),
(99114, 3582573600, 3582573615, 'CH', 'CHE', 'سويسرا'),
(99115, 3582573632, 3582573695, 'CH', 'CHE', 'سويسرا'),
(99116, 3582573728, 3582573759, 'CH', 'CHE', 'سويسرا'),
(99117, 3582573824, 3582573887, 'CH', 'CHE', 'سويسرا'),
(99118, 3582573896, 3582573903, 'CH', 'CHE', 'سويسرا'),
(99119, 3582573912, 3582574015, 'CH', 'CHE', 'سويسرا'),
(99120, 3582574432, 3582574435, 'CH', 'CHE', 'سويسرا'),
(99121, 3582574456, 3582574479, 'CH', 'CHE', 'سويسرا'),
(99122, 3582574592, 3582582783, 'DE', 'DEU', 'ألمانيا'),
(99123, 3582582784, 3582590975, 'RU', 'RUS', 'الإتحاد الروسي'),
(99124, 3582590976, 3582599167, 'FR', 'FRA', 'فرنسا'),
(99125, 3582599168, 3582607359, 'DE', 'DEU', 'ألمانيا'),
(99126, 3582607360, 3582615551, 'RU', 'RUS', 'الإتحاد الروسي'),
(99127, 3582615552, 3582619391, 'CY', 'CYP', 'قبرص'),
(99128, 3582619392, 3582619647, 'UA', 'UKR', 'أوكرانيا'),
(99129, 3582619648, 3582622591, 'CY', 'CYP', 'قبرص'),
(99130, 3582622592, 3582622719, 'LB', 'LBN', 'لبنان'),
(99131, 3582622720, 3582623743, 'CY', 'CYP', 'قبرص'),
(99132, 3582623744, 3582631935, 'FI', 'FIN', 'فنلندا'),
(99133, 3582631936, 3582640127, 'NO', 'NOR', 'النرويج');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(99134, 3582640128, 3582648319, 'RU', 'RUS', 'الإتحاد الروسي'),
(99135, 3582648320, 3582656511, 'PT', 'PRT', 'البورتوغال'),
(99136, 3582656512, 3582664047, 'ES', 'ESP', 'إسبانيا'),
(99137, 3582664048, 3582664055, 'FR', 'FRA', 'فرنسا'),
(99138, 3582664056, 3582664703, 'ES', 'ESP', 'إسبانيا'),
(99139, 3582664704, 3582672895, 'JO', 'JOR', 'الأردن'),
(99140, 3582672896, 3582681087, 'DE', 'DEU', 'ألمانيا'),
(99141, 3582681088, 3582689279, 'FR', 'FRA', 'فرنسا'),
(99142, 3582689280, 3582697471, 'DE', 'DEU', 'ألمانيا'),
(99143, 3582697472, 3582705663, 'FI', 'FIN', 'فنلندا'),
(99144, 3582705664, 3582722047, 'TR', 'TUR', 'تركيا'),
(99145, 3582722048, 3582730239, 'IT', 'ITA', 'إيطاليا'),
(99146, 3582730240, 3582736383, 'ES', 'ESP', 'إسبانيا'),
(99147, 3582736384, 3582737407, 'DZ', 'DZA', 'الجزائر'),
(99148, 3582737408, 3582737919, 'MA', 'MAR', 'المغرب'),
(99149, 3582737920, 3582738431, 'ES', 'ESP', 'إسبانيا'),
(99150, 3582738432, 3582746623, 'DK', 'DNK', 'الدنيمارك'),
(99151, 3582746624, 3582754815, 'RU', 'RUS', 'الإتحاد الروسي'),
(99152, 3582754816, 3582763007, 'GR', 'GRC', 'اليونان'),
(99153, 3582763008, 3582771199, 'FI', 'FIN', 'فنلندا'),
(99154, 3582771200, 3582779391, 'IT', 'ITA', 'إيطاليا'),
(99155, 3582779392, 3582787583, 'RU', 'RUS', 'الإتحاد الروسي'),
(99156, 3582787584, 3582795775, 'PT', 'PRT', 'البورتوغال'),
(99157, 3582795776, 3582803967, 'ES', 'ESP', 'إسبانيا'),
(99158, 3582803968, 3582812159, 'SE', 'SWE', 'السويد'),
(99159, 3582812160, 3582820351, 'FI', 'FIN', 'فنلندا'),
(99160, 3582820352, 3582828543, 'RU', 'RUS', 'الإتحاد الروسي'),
(99161, 3582828544, 3582836735, 'KZ', 'KAZ', 'كازاخستان'),
(99162, 3582836736, 3582853119, 'RU', 'RUS', 'الإتحاد الروسي'),
(99163, 3582853120, 3582861311, 'SE', 'SWE', 'السويد'),
(99164, 3582861312, 3582869503, 'RU', 'RUS', 'الإتحاد الروسي'),
(99165, 3582869504, 3582877695, 'NO', 'NOR', 'النرويج'),
(99166, 3582877696, 3582885887, 'AT', 'AUT', 'النمسا'),
(99167, 3582885888, 3582894079, 'TR', 'TUR', 'تركيا'),
(99168, 3582894080, 3582902271, 'CH', 'CHE', 'سويسرا'),
(99169, 3582902272, 3582910463, 'RU', 'RUS', 'الإتحاد الروسي'),
(99170, 3582910464, 3582918655, 'SI', 'SVN', 'سلوفينيا'),
(99171, 3582918656, 3582926847, 'GB', 'GBR', 'المملكة المتحدة'),
(99172, 3582926848, 3582935039, 'ES', 'ESP', 'إسبانيا'),
(99173, 3582935040, 3582943231, 'SI', 'SVN', 'سلوفينيا'),
(99174, 3582943232, 3582951423, 'AT', 'AUT', 'النمسا'),
(99175, 3582951424, 3582959615, 'GB', 'GBR', 'المملكة المتحدة'),
(99176, 3582959616, 3582967807, 'FI', 'FIN', 'فنلندا'),
(99177, 3582967808, 3582975999, 'DE', 'DEU', 'ألمانيا'),
(99178, 3582976000, 3582984191, 'TR', 'TUR', 'تركيا'),
(99179, 3582984192, 3582992383, 'DE', 'DEU', 'ألمانيا'),
(99180, 3582992384, 3583000575, 'ES', 'ESP', 'إسبانيا'),
(99181, 3583000576, 3583008767, 'IT', 'ITA', 'إيطاليا'),
(99182, 3583008768, 3583016959, 'TR', 'TUR', 'تركيا'),
(99183, 3583016960, 3583019367, 'CH', 'CHE', 'سويسرا'),
(99184, 3583019368, 3583019375, 'DE', 'DEU', 'ألمانيا'),
(99185, 3583019376, 3583023215, 'CH', 'CHE', 'سويسرا'),
(99186, 3583023216, 3583023223, 'DE', 'DEU', 'ألمانيا'),
(99187, 3583023224, 3583025151, 'CH', 'CHE', 'سويسرا'),
(99188, 3583025152, 3583029119, 'IT', 'ITA', 'إيطاليا'),
(99189, 3583029120, 3583029247, 'US', 'USA', 'الولايات المتحدة'),
(99190, 3583029248, 3583029375, 'SG', 'SGP', 'سنغافورة'),
(99191, 3583029376, 3583029503, 'FR', 'FRA', 'فرنسا'),
(99192, 3583029504, 3583029759, 'IT', 'ITA', 'إيطاليا'),
(99193, 3583029760, 3583030015, 'GR', 'GRC', 'اليونان'),
(99194, 3583030016, 3583030783, 'IT', 'ITA', 'إيطاليا'),
(99195, 3583030784, 3583030847, 'IE', 'IRL', 'إيرلندا'),
(99196, 3583030848, 3583031039, 'GR', 'GRC', 'اليونان'),
(99197, 3583031040, 3583031295, 'FR', 'FRA', 'فرنسا'),
(99198, 3583031296, 3583031839, 'GR', 'GRC', 'اليونان'),
(99199, 3583031840, 3583031847, 'IT', 'ITA', 'إيطاليا'),
(99200, 3583031848, 3583031895, 'GR', 'GRC', 'اليونان'),
(99201, 3583031896, 3583031903, 'IT', 'ITA', 'إيطاليا'),
(99202, 3583031904, 3583031919, 'LB', 'LBN', 'لبنان'),
(99203, 3583031920, 3583032095, 'IT', 'ITA', 'إيطاليا'),
(99204, 3583032096, 3583032127, 'GR', 'GRC', 'اليونان'),
(99205, 3583032128, 3583032159, 'IT', 'ITA', 'إيطاليا'),
(99206, 3583032160, 3583032191, 'FR', 'FRA', 'فرنسا'),
(99207, 3583032192, 3583032319, 'IT', 'ITA', 'إيطاليا'),
(99208, 3583032320, 3583032575, 'FR', 'FRA', 'فرنسا'),
(99209, 3583032576, 3583032831, 'IT', 'ITA', 'إيطاليا'),
(99210, 3583032832, 3583033087, 'GR', 'GRC', 'اليونان'),
(99211, 3583033088, 3583033343, 'IT', 'ITA', 'إيطاليا'),
(99212, 3583033344, 3583041535, 'FR', 'FRA', 'فرنسا'),
(99213, 3583041536, 3583049727, 'NL', 'NLD', 'هولندا'),
(99214, 3583057920, 3583066111, 'RU', 'RUS', 'الإتحاد الروسي'),
(99215, 3583066112, 3583074303, 'DE', 'DEU', 'ألمانيا'),
(99216, 3583074304, 3583082495, 'BG', 'BGR', 'بلغاريا'),
(99217, 3583082496, 3583090687, 'KG', 'KGZ', 'قيرغيزستان'),
(99218, 3583090688, 3583098879, 'NO', 'NOR', 'النرويج'),
(99219, 3583098880, 3583107071, 'FI', 'FIN', 'فنلندا'),
(99220, 3583107072, 3583115263, 'AT', 'AUT', 'النمسا'),
(99221, 3583115264, 3583123455, 'CH', 'CHE', 'سويسرا'),
(99222, 3583123456, 3583131647, 'PL', 'POL', 'بولندا'),
(99223, 3583131648, 3583139839, 'SE', 'SWE', 'السويد'),
(99224, 3583139840, 3583141727, 'DE', 'DEU', 'ألمانيا'),
(99225, 3583141728, 3583141735, 'AT', 'AUT', 'النمسا'),
(99226, 3583141736, 3583148031, 'DE', 'DEU', 'ألمانيا'),
(99227, 3583148032, 3583157247, 'GB', 'GBR', 'المملكة المتحدة'),
(99228, 3583157248, 3583157279, 'IE', 'IRL', 'إيرلندا'),
(99229, 3583157280, 3583157439, 'GB', 'GBR', 'المملكة المتحدة'),
(99230, 3583157440, 3583157471, 'IE', 'IRL', 'إيرلندا'),
(99231, 3583157472, 3583157487, 'GB', 'GBR', 'المملكة المتحدة'),
(99232, 3583157488, 3583157503, 'IE', 'IRL', 'إيرلندا'),
(99233, 3583157504, 3583158511, 'GB', 'GBR', 'المملكة المتحدة'),
(99234, 3583158512, 3583158527, 'IE', 'IRL', 'إيرلندا'),
(99235, 3583158528, 3583159039, 'DE', 'DEU', 'ألمانيا'),
(99236, 3583159040, 3583159359, 'GB', 'GBR', 'المملكة المتحدة'),
(99237, 3583159360, 3583159375, 'DE', 'DEU', 'ألمانيا'),
(99238, 3583159376, 3583160319, 'GB', 'GBR', 'المملكة المتحدة'),
(99239, 3583160320, 3583161343, 'DE', 'DEU', 'ألمانيا'),
(99240, 3583161344, 3583162271, 'GB', 'GBR', 'المملكة المتحدة'),
(99241, 3583162272, 3583162303, 'IE', 'IRL', 'إيرلندا'),
(99242, 3583162304, 3583162367, 'GB', 'GBR', 'المملكة المتحدة'),
(99243, 3583162368, 3583162623, 'DE', 'DEU', 'ألمانيا'),
(99244, 3583162624, 3583163391, 'GB', 'GBR', 'المملكة المتحدة'),
(99245, 3583163392, 3583163903, 'IE', 'IRL', 'إيرلندا'),
(99246, 3583163904, 3583164415, 'GB', 'GBR', 'المملكة المتحدة'),
(99247, 3583164416, 3583172607, 'PT', 'PRT', 'البورتوغال'),
(99248, 3583172608, 3583188991, 'DE', 'DEU', 'ألمانيا'),
(99249, 3583188992, 3583197183, 'RU', 'RUS', 'الإتحاد الروسي'),
(99250, 3583205376, 3583213567, 'HR', 'HRV', 'كرواتيا'),
(99251, 3583213568, 3583221759, 'IR', 'IRN', 'إيران'),
(99252, 3583221760, 3583229951, 'AT', 'AUT', 'النمسا'),
(99253, 3583229952, 3583238143, 'RU', 'RUS', 'الإتحاد الروسي'),
(99254, 3583238144, 3583246335, 'GB', 'GBR', 'المملكة المتحدة'),
(99255, 3583246336, 3583254527, 'RU', 'RUS', 'الإتحاد الروسي'),
(99256, 3583254528, 3583262719, 'GB', 'GBR', 'المملكة المتحدة'),
(99257, 3583262720, 3583270911, 'TR', 'TUR', 'تركيا'),
(99258, 3583279104, 3583287295, 'DE', 'DEU', 'ألمانيا'),
(99259, 3583287296, 3583295487, 'RU', 'RUS', 'الإتحاد الروسي'),
(99260, 3583295488, 3583303679, 'ES', 'ESP', 'إسبانيا'),
(99261, 3583303680, 3583311871, 'NL', 'NLD', 'هولندا'),
(99262, 3583311872, 3583320063, 'RU', 'RUS', 'الإتحاد الروسي'),
(99263, 3583320064, 3583328255, 'HR', 'HRV', 'كرواتيا'),
(99264, 3583328256, 3583336447, 'DE', 'DEU', 'ألمانيا'),
(99265, 3583336448, 3583337727, 'ME', 'MNE', 'الجبل الأسود'),
(99266, 3583337728, 3583337983, 'AL', 'ALB', 'ألبانيا'),
(99267, 3583337984, 3583338015, 'ME', 'MNE', 'الجبل الأسود'),
(99268, 3583338016, 3583338023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99269, 3583338024, 3583338031, 'ME', 'MNE', 'الجبل الأسود'),
(99270, 3583338032, 3583338047, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99271, 3583338048, 3583338143, 'ME', 'MNE', 'الجبل الأسود'),
(99272, 3583338144, 3583338175, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99273, 3583338176, 3583339519, 'ME', 'MNE', 'الجبل الأسود'),
(99274, 3583339520, 3583339775, 'AL', 'ALB', 'ألبانيا'),
(99275, 3583339776, 3583341039, 'ME', 'MNE', 'الجبل الأسود'),
(99276, 3583341040, 3583341055, 'AL', 'ALB', 'ألبانيا'),
(99277, 3583341056, 3583342335, 'ME', 'MNE', 'الجبل الأسود'),
(99278, 3583342336, 3583342591, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99279, 3583342592, 3583344639, 'ME', 'MNE', 'الجبل الأسود'),
(99280, 3583344640, 3583345663, 'BG', 'BGR', 'بلغاريا'),
(99281, 3583345664, 3583346175, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(99282, 3583346176, 3583350271, 'BG', 'BGR', 'بلغاريا'),
(99283, 3583350272, 3583351039, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(99284, 3583351040, 3583352319, 'BG', 'BGR', 'بلغاريا'),
(99285, 3583352320, 3583352575, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(99286, 3583352576, 3583352831, 'BG', 'BGR', 'بلغاريا'),
(99287, 3583352832, 3583361023, 'CY', 'CYP', 'قبرص'),
(99288, 3583361024, 3583369215, 'IT', 'ITA', 'إيطاليا'),
(99289, 3583369216, 3583377407, 'ES', 'ESP', 'إسبانيا'),
(99290, 3583377408, 3583385599, 'AT', 'AUT', 'النمسا'),
(99291, 3583385600, 3583393791, 'DK', 'DNK', 'الدنيمارك'),
(99292, 3583393792, 3583401983, 'RU', 'RUS', 'الإتحاد الروسي'),
(99293, 3583410176, 3583418367, 'SE', 'SWE', 'السويد'),
(99294, 3583434752, 3583442943, 'AT', 'AUT', 'النمسا'),
(99295, 3583442944, 3583451135, 'UA', 'UKR', 'أوكرانيا'),
(99296, 3583451136, 3583459327, 'IL', 'ISR', 'إسرائيل'),
(99297, 3583459328, 3583463891, 'CZ', 'CZE', 'التشيك'),
(99298, 3583463892, 3583463895, 'PL', 'POL', 'بولندا'),
(99299, 3583463896, 3583467519, 'CZ', 'CZE', 'التشيك'),
(99300, 3583467520, 3583475711, 'ES', 'ESP', 'إسبانيا'),
(99301, 3583475712, 3583483903, 'NO', 'NOR', 'النرويج'),
(99302, 3583483904, 3583492095, 'FR', 'FRA', 'فرنسا'),
(99303, 3583492096, 3583508479, 'SK', 'SVK', 'سلوفاكيا'),
(99304, 3583508480, 3583516671, 'FR', 'FRA', 'فرنسا'),
(99305, 3583516672, 3583524863, 'GB', 'GBR', 'المملكة المتحدة'),
(99306, 3583533056, 3583541247, 'DE', 'DEU', 'ألمانيا'),
(99307, 3583541248, 3583549439, 'RU', 'RUS', 'الإتحاد الروسي'),
(99308, 3583549440, 3583558399, 'IT', 'ITA', 'إيطاليا'),
(99309, 3583558400, 3583558527, 'SM', 'SMR', 'سان مارينو'),
(99310, 3583558528, 3583565823, 'IT', 'ITA', 'إيطاليا'),
(99311, 3583565824, 3583574015, 'GB', 'GBR', 'المملكة المتحدة'),
(99312, 3583574016, 3583582207, 'NO', 'NOR', 'النرويج'),
(99313, 3583582208, 3583590399, 'AT', 'AUT', 'النمسا'),
(99314, 3583590400, 3583598591, 'DE', 'DEU', 'ألمانيا'),
(99315, 3583598592, 3583606783, 'SE', 'SWE', 'السويد'),
(99316, 3583606784, 3583639551, 'TR', 'TUR', 'تركيا'),
(99317, 3583639552, 3583647743, 'AZ', 'AZE', 'أذربيجان'),
(99318, 3583664128, 3583680511, 'RO', 'ROM', 'رومانيا'),
(99319, 3583680512, 3583688703, 'RU', 'RUS', 'الإتحاد الروسي'),
(99320, 3583688704, 3583696895, 'UA', 'UKR', 'أوكرانيا'),
(99321, 3583696896, 3583705087, 'NL', 'NLD', 'هولندا'),
(99322, 3583705088, 3583705175, 'UA', 'UKR', 'أوكرانيا'),
(99323, 3583705176, 3583705223, 'NA', 'NAM', 'ناميبيا'),
(99324, 3583705224, 3583705239, 'UA', 'UKR', 'أوكرانيا'),
(99325, 3583705240, 3583705247, 'NA', 'NAM', 'ناميبيا'),
(99326, 3583705248, 3583705255, 'UA', 'UKR', 'أوكرانيا'),
(99327, 3583705256, 3583705263, 'NA', 'NAM', 'ناميبيا'),
(99328, 3583705264, 3583705287, 'UA', 'UKR', 'أوكرانيا'),
(99329, 3583705288, 3583705295, 'NA', 'NAM', 'ناميبيا'),
(99330, 3583705296, 3583705303, 'UA', 'UKR', 'أوكرانيا'),
(99331, 3583705304, 3583705319, 'NA', 'NAM', 'ناميبيا'),
(99332, 3583705320, 3583705335, 'UA', 'UKR', 'أوكرانيا'),
(99333, 3583705336, 3583705343, 'NA', 'NAM', 'ناميبيا'),
(99334, 3583705344, 3583705471, 'UA', 'UKR', 'أوكرانيا'),
(99335, 3583705472, 3583705487, 'NA', 'NAM', 'ناميبيا'),
(99336, 3583705488, 3583705495, 'UA', 'UKR', 'أوكرانيا'),
(99337, 3583705496, 3583705503, 'NA', 'NAM', 'ناميبيا'),
(99338, 3583705504, 3583705603, 'UA', 'UKR', 'أوكرانيا'),
(99339, 3583705604, 3583705607, 'NA', 'NAM', 'ناميبيا'),
(99340, 3583705608, 3583705647, 'UA', 'UKR', 'أوكرانيا'),
(99341, 3583705648, 3583705791, 'NA', 'NAM', 'ناميبيا'),
(99342, 3583705792, 3583705831, 'UA', 'UKR', 'أوكرانيا'),
(99343, 3583705832, 3583705839, 'NA', 'NAM', 'ناميبيا'),
(99344, 3583705840, 3583705847, 'UA', 'UKR', 'أوكرانيا'),
(99345, 3583705848, 3583705855, 'NA', 'NAM', 'ناميبيا'),
(99346, 3583705856, 3583705859, 'UA', 'UKR', 'أوكرانيا'),
(99347, 3583705860, 3583705863, 'NA', 'NAM', 'ناميبيا'),
(99348, 3583705864, 3583705887, 'UA', 'UKR', 'أوكرانيا'),
(99349, 3583705888, 3583705895, 'RU', 'RUS', 'الإتحاد الروسي'),
(99350, 3583705896, 3583705903, 'UA', 'UKR', 'أوكرانيا'),
(99351, 3583705904, 3583705911, 'NA', 'NAM', 'ناميبيا'),
(99352, 3583705912, 3583705919, 'RU', 'RUS', 'الإتحاد الروسي'),
(99353, 3583705920, 3583706023, 'UA', 'UKR', 'أوكرانيا'),
(99354, 3583706024, 3583706031, 'NA', 'NAM', 'ناميبيا'),
(99355, 3583706032, 3583706055, 'UA', 'UKR', 'أوكرانيا'),
(99356, 3583706056, 3583706063, 'RU', 'RUS', 'الإتحاد الروسي'),
(99357, 3583706064, 3583706103, 'UA', 'UKR', 'أوكرانيا'),
(99358, 3583706104, 3583706107, 'NA', 'NAM', 'ناميبيا'),
(99359, 3583706108, 3583706151, 'UA', 'UKR', 'أوكرانيا'),
(99360, 3583706152, 3583706159, 'NA', 'NAM', 'ناميبيا'),
(99361, 3583706160, 3583706175, 'UA', 'UKR', 'أوكرانيا'),
(99362, 3583706176, 3583706183, 'NA', 'NAM', 'ناميبيا'),
(99363, 3583706184, 3583706191, 'UA', 'UKR', 'أوكرانيا'),
(99364, 3583706192, 3583706199, 'NA', 'NAM', 'ناميبيا'),
(99365, 3583706200, 3583706223, 'UA', 'UKR', 'أوكرانيا'),
(99366, 3583706224, 3583706231, 'NA', 'NAM', 'ناميبيا'),
(99367, 3583706232, 3583706295, 'UA', 'UKR', 'أوكرانيا'),
(99368, 3583706296, 3583706319, 'NA', 'NAM', 'ناميبيا'),
(99369, 3583706320, 3583706343, 'UA', 'UKR', 'أوكرانيا'),
(99370, 3583706344, 3583706351, 'NA', 'NAM', 'ناميبيا'),
(99371, 3583706352, 3583706375, 'UA', 'UKR', 'أوكرانيا'),
(99372, 3583706376, 3583706383, 'NA', 'NAM', 'ناميبيا'),
(99373, 3583706384, 3583706463, 'UA', 'UKR', 'أوكرانيا'),
(99374, 3583706464, 3583706471, 'NA', 'NAM', 'ناميبيا'),
(99375, 3583706472, 3583706495, 'UA', 'UKR', 'أوكرانيا'),
(99376, 3583706496, 3583706511, 'NA', 'NAM', 'ناميبيا'),
(99377, 3583706512, 3583706519, 'UA', 'UKR', 'أوكرانيا'),
(99378, 3583706520, 3583706527, 'NA', 'NAM', 'ناميبيا'),
(99379, 3583706528, 3583706535, 'UA', 'UKR', 'أوكرانيا'),
(99380, 3583706536, 3583706543, 'NA', 'NAM', 'ناميبيا'),
(99381, 3583706544, 3583706575, 'UA', 'UKR', 'أوكرانيا'),
(99382, 3583706576, 3583706583, 'NA', 'NAM', 'ناميبيا'),
(99383, 3583706584, 3583706591, 'UA', 'UKR', 'أوكرانيا'),
(99384, 3583706592, 3583706607, 'NA', 'NAM', 'ناميبيا'),
(99385, 3583706608, 3583706615, 'UA', 'UKR', 'أوكرانيا'),
(99386, 3583706616, 3583706623, 'NA', 'NAM', 'ناميبيا'),
(99387, 3583706624, 3583706647, 'UA', 'UKR', 'أوكرانيا'),
(99388, 3583706648, 3583706655, 'NA', 'NAM', 'ناميبيا'),
(99389, 3583706656, 3583706679, 'UA', 'UKR', 'أوكرانيا'),
(99390, 3583706680, 3583706687, 'NA', 'NAM', 'ناميبيا'),
(99391, 3583706688, 3583706695, 'UA', 'UKR', 'أوكرانيا'),
(99392, 3583706696, 3583706711, 'NA', 'NAM', 'ناميبيا'),
(99393, 3583706712, 3583706743, 'UA', 'UKR', 'أوكرانيا'),
(99394, 3583706744, 3583706767, 'NA', 'NAM', 'ناميبيا'),
(99395, 3583706768, 3583706775, 'UA', 'UKR', 'أوكرانيا'),
(99396, 3583706776, 3583706791, 'NA', 'NAM', 'ناميبيا'),
(99397, 3583706792, 3583706807, 'UA', 'UKR', 'أوكرانيا'),
(99398, 3583706808, 3583706815, 'NA', 'NAM', 'ناميبيا'),
(99399, 3583706816, 3583706863, 'UA', 'UKR', 'أوكرانيا'),
(99400, 3583706864, 3583706879, 'NA', 'NAM', 'ناميبيا'),
(99401, 3583706880, 3583706883, 'UA', 'UKR', 'أوكرانيا'),
(99402, 3583706884, 3583706887, 'NA', 'NAM', 'ناميبيا'),
(99403, 3583706888, 3583706895, 'UA', 'UKR', 'أوكرانيا'),
(99404, 3583706896, 3583706911, 'NA', 'NAM', 'ناميبيا'),
(99405, 3583706912, 3583706927, 'UA', 'UKR', 'أوكرانيا'),
(99406, 3583706928, 3583706943, 'NA', 'NAM', 'ناميبيا'),
(99407, 3583706944, 3583706959, 'UA', 'UKR', 'أوكرانيا'),
(99408, 3583706960, 3583706967, 'NA', 'NAM', 'ناميبيا'),
(99409, 3583706968, 3583706991, 'UA', 'UKR', 'أوكرانيا'),
(99410, 3583706992, 3583706999, 'NA', 'NAM', 'ناميبيا'),
(99411, 3583707000, 3583707015, 'UA', 'UKR', 'أوكرانيا'),
(99412, 3583707016, 3583707023, 'NA', 'NAM', 'ناميبيا'),
(99413, 3583707024, 3583707031, 'UA', 'UKR', 'أوكرانيا'),
(99414, 3583707032, 3583707039, 'NA', 'NAM', 'ناميبيا'),
(99415, 3583707040, 3583707071, 'UA', 'UKR', 'أوكرانيا'),
(99416, 3583707072, 3583707111, 'NA', 'NAM', 'ناميبيا'),
(99417, 3583707112, 3583707127, 'UA', 'UKR', 'أوكرانيا'),
(99418, 3583707128, 3583707135, 'NA', 'NAM', 'ناميبيا'),
(99419, 3583707136, 3583707215, 'UA', 'UKR', 'أوكرانيا'),
(99420, 3583707216, 3583707223, 'NA', 'NAM', 'ناميبيا'),
(99421, 3583707224, 3583707519, 'UA', 'UKR', 'أوكرانيا'),
(99422, 3583707520, 3583707535, 'NA', 'NAM', 'ناميبيا'),
(99423, 3583707536, 3583707663, 'UA', 'UKR', 'أوكرانيا'),
(99424, 3583707664, 3583707679, 'NA', 'NAM', 'ناميبيا'),
(99425, 3583707680, 3583707751, 'UA', 'UKR', 'أوكرانيا'),
(99426, 3583707752, 3583707767, 'NA', 'NAM', 'ناميبيا'),
(99427, 3583707768, 3583707775, 'UA', 'UKR', 'أوكرانيا'),
(99428, 3583707776, 3583707791, 'NA', 'NAM', 'ناميبيا'),
(99429, 3583707792, 3583707807, 'UA', 'UKR', 'أوكرانيا'),
(99430, 3583707808, 3583707815, 'NA', 'NAM', 'ناميبيا'),
(99431, 3583707816, 3583707839, 'UA', 'UKR', 'أوكرانيا'),
(99432, 3583707840, 3583707855, 'NA', 'NAM', 'ناميبيا'),
(99433, 3583707856, 3583708031, 'UA', 'UKR', 'أوكرانيا'),
(99434, 3583708032, 3583708095, 'NA', 'NAM', 'ناميبيا'),
(99435, 3583708096, 3583708167, 'UA', 'UKR', 'أوكرانيا'),
(99436, 3583708168, 3583708175, 'NA', 'NAM', 'ناميبيا'),
(99437, 3583708176, 3583708223, 'UA', 'UKR', 'أوكرانيا'),
(99438, 3583708224, 3583708239, 'NA', 'NAM', 'ناميبيا'),
(99439, 3583708240, 3583708255, 'UA', 'UKR', 'أوكرانيا'),
(99440, 3583708256, 3583708263, 'RU', 'RUS', 'الإتحاد الروسي'),
(99441, 3583708264, 3583708423, 'UA', 'UKR', 'أوكرانيا'),
(99442, 3583708424, 3583708431, 'NA', 'NAM', 'ناميبيا'),
(99443, 3583708432, 3583708455, 'UA', 'UKR', 'أوكرانيا'),
(99444, 3583708456, 3583708463, 'NA', 'NAM', 'ناميبيا'),
(99445, 3583708464, 3583708479, 'UA', 'UKR', 'أوكرانيا'),
(99446, 3583708480, 3583708543, 'NA', 'NAM', 'ناميبيا'),
(99447, 3583708544, 3583708575, 'UA', 'UKR', 'أوكرانيا'),
(99448, 3583708576, 3583708583, 'NA', 'NAM', 'ناميبيا'),
(99449, 3583708584, 3583708607, 'UA', 'UKR', 'أوكرانيا'),
(99450, 3583708608, 3583708623, 'NA', 'NAM', 'ناميبيا'),
(99451, 3583708624, 3583709447, 'UA', 'UKR', 'أوكرانيا'),
(99452, 3583709448, 3583709455, 'NA', 'NAM', 'ناميبيا'),
(99453, 3583709456, 3583709479, 'UA', 'UKR', 'أوكرانيا'),
(99454, 3583709480, 3583709487, 'NA', 'NAM', 'ناميبيا'),
(99455, 3583709488, 3583709503, 'UA', 'UKR', 'أوكرانيا'),
(99456, 3583709504, 3583709519, 'NA', 'NAM', 'ناميبيا'),
(99457, 3583709520, 3583709527, 'UA', 'UKR', 'أوكرانيا'),
(99458, 3583709528, 3583709543, 'NA', 'NAM', 'ناميبيا'),
(99459, 3583709544, 3583709551, 'UA', 'UKR', 'أوكرانيا'),
(99460, 3583709552, 3583709559, 'NA', 'NAM', 'ناميبيا'),
(99461, 3583709560, 3583709575, 'UA', 'UKR', 'أوكرانيا'),
(99462, 3583709576, 3583709583, 'NA', 'NAM', 'ناميبيا'),
(99463, 3583709584, 3583709599, 'UA', 'UKR', 'أوكرانيا'),
(99464, 3583709600, 3583709615, 'NA', 'NAM', 'ناميبيا'),
(99465, 3583709616, 3583709623, 'UA', 'UKR', 'أوكرانيا'),
(99466, 3583709624, 3583709639, 'NA', 'NAM', 'ناميبيا'),
(99467, 3583709640, 3583709663, 'UA', 'UKR', 'أوكرانيا'),
(99468, 3583709664, 3583709671, 'NA', 'NAM', 'ناميبيا'),
(99469, 3583709672, 3583709699, 'UA', 'UKR', 'أوكرانيا'),
(99470, 3583709700, 3583709703, 'NA', 'NAM', 'ناميبيا'),
(99471, 3583709704, 3583709727, 'UA', 'UKR', 'أوكرانيا'),
(99472, 3583709728, 3583709751, 'NA', 'NAM', 'ناميبيا'),
(99473, 3583709752, 3583709759, 'UA', 'UKR', 'أوكرانيا'),
(99474, 3583709760, 3583709767, 'NA', 'NAM', 'ناميبيا'),
(99475, 3583709768, 3583709791, 'UA', 'UKR', 'أوكرانيا'),
(99476, 3583709792, 3583709799, 'NA', 'NAM', 'ناميبيا'),
(99477, 3583709800, 3583709823, 'UA', 'UKR', 'أوكرانيا'),
(99478, 3583709824, 3583709831, 'NA', 'NAM', 'ناميبيا'),
(99479, 3583709832, 3583709839, 'UA', 'UKR', 'أوكرانيا'),
(99480, 3583709840, 3583709863, 'NA', 'NAM', 'ناميبيا'),
(99481, 3583709864, 3583709871, 'UA', 'UKR', 'أوكرانيا'),
(99482, 3583709872, 3583709911, 'NA', 'NAM', 'ناميبيا'),
(99483, 3583709912, 3583709927, 'UA', 'UKR', 'أوكرانيا'),
(99484, 3583709928, 3583709943, 'NA', 'NAM', 'ناميبيا'),
(99485, 3583709944, 3583710055, 'UA', 'UKR', 'أوكرانيا'),
(99486, 3583710056, 3583710087, 'NA', 'NAM', 'ناميبيا'),
(99487, 3583710088, 3583710103, 'UA', 'UKR', 'أوكرانيا'),
(99488, 3583710104, 3583710111, 'NA', 'NAM', 'ناميبيا'),
(99489, 3583710112, 3583710119, 'UA', 'UKR', 'أوكرانيا'),
(99490, 3583710120, 3583710135, 'NA', 'NAM', 'ناميبيا'),
(99491, 3583710136, 3583710211, 'UA', 'UKR', 'أوكرانيا'),
(99492, 3583710212, 3583710231, 'NA', 'NAM', 'ناميبيا'),
(99493, 3583710232, 3583710239, 'UA', 'UKR', 'أوكرانيا'),
(99494, 3583710240, 3583710247, 'NA', 'NAM', 'ناميبيا'),
(99495, 3583710248, 3583710319, 'UA', 'UKR', 'أوكرانيا'),
(99496, 3583710320, 3583710335, 'NA', 'NAM', 'ناميبيا'),
(99497, 3583710336, 3583710375, 'UA', 'UKR', 'أوكرانيا'),
(99498, 3583710376, 3583710383, 'NA', 'NAM', 'ناميبيا'),
(99499, 3583710384, 3583710407, 'UA', 'UKR', 'أوكرانيا'),
(99500, 3583710408, 3583710415, 'NA', 'NAM', 'ناميبيا'),
(99501, 3583710416, 3583710455, 'UA', 'UKR', 'أوكرانيا'),
(99502, 3583710456, 3583710459, 'NA', 'NAM', 'ناميبيا'),
(99503, 3583710460, 3583710495, 'UA', 'UKR', 'أوكرانيا'),
(99504, 3583710496, 3583710503, 'NA', 'NAM', 'ناميبيا'),
(99505, 3583710504, 3583710519, 'UA', 'UKR', 'أوكرانيا'),
(99506, 3583710520, 3583710527, 'NA', 'NAM', 'ناميبيا'),
(99507, 3583710528, 3583710631, 'UA', 'UKR', 'أوكرانيا'),
(99508, 3583710632, 3583710639, 'NA', 'NAM', 'ناميبيا'),
(99509, 3583710640, 3583710671, 'UA', 'UKR', 'أوكرانيا'),
(99510, 3583710672, 3583710679, 'NA', 'NAM', 'ناميبيا'),
(99511, 3583710680, 3583710703, 'UA', 'UKR', 'أوكرانيا'),
(99512, 3583710704, 3583710711, 'NA', 'NAM', 'ناميبيا'),
(99513, 3583710712, 3583710823, 'UA', 'UKR', 'أوكرانيا'),
(99514, 3583710824, 3583710831, 'NA', 'NAM', 'ناميبيا'),
(99515, 3583710832, 3583710855, 'UA', 'UKR', 'أوكرانيا'),
(99516, 3583710856, 3583710863, 'NA', 'NAM', 'ناميبيا'),
(99517, 3583710864, 3583710871, 'UA', 'UKR', 'أوكرانيا'),
(99518, 3583710872, 3583710879, 'NA', 'NAM', 'ناميبيا'),
(99519, 3583710880, 3583710887, 'UA', 'UKR', 'أوكرانيا'),
(99520, 3583710888, 3583710911, 'NA', 'NAM', 'ناميبيا'),
(99521, 3583710912, 3583710935, 'UA', 'UKR', 'أوكرانيا'),
(99522, 3583710936, 3583710943, 'NA', 'NAM', 'ناميبيا'),
(99523, 3583710944, 3583710959, 'UA', 'UKR', 'أوكرانيا'),
(99524, 3583710960, 3583710967, 'NA', 'NAM', 'ناميبيا'),
(99525, 3583710968, 3583710991, 'UA', 'UKR', 'أوكرانيا'),
(99526, 3583710992, 3583710999, 'NA', 'NAM', 'ناميبيا'),
(99527, 3583711000, 3583711007, 'UA', 'UKR', 'أوكرانيا'),
(99528, 3583711008, 3583711023, 'NA', 'NAM', 'ناميبيا'),
(99529, 3583711024, 3583711079, 'UA', 'UKR', 'أوكرانيا'),
(99530, 3583711080, 3583711095, 'NA', 'NAM', 'ناميبيا'),
(99531, 3583711096, 3583711247, 'UA', 'UKR', 'أوكرانيا'),
(99532, 3583711248, 3583711255, 'NA', 'NAM', 'ناميبيا'),
(99533, 3583711256, 3583711295, 'UA', 'UKR', 'أوكرانيا'),
(99534, 3583711296, 3583711303, 'NA', 'NAM', 'ناميبيا'),
(99535, 3583711304, 3583711311, 'UA', 'UKR', 'أوكرانيا'),
(99536, 3583711312, 3583711319, 'NA', 'NAM', 'ناميبيا'),
(99537, 3583711320, 3583711327, 'UA', 'UKR', 'أوكرانيا'),
(99538, 3583711328, 3583711335, 'NA', 'NAM', 'ناميبيا'),
(99539, 3583711336, 3583711359, 'UA', 'UKR', 'أوكرانيا'),
(99540, 3583711360, 3583711367, 'NA', 'NAM', 'ناميبيا'),
(99541, 3583711368, 3583711375, 'UA', 'UKR', 'أوكرانيا'),
(99542, 3583711376, 3583711383, 'NA', 'NAM', 'ناميبيا'),
(99543, 3583711384, 3583711495, 'UA', 'UKR', 'أوكرانيا'),
(99544, 3583711496, 3583711503, 'NA', 'NAM', 'ناميبيا'),
(99545, 3583711504, 3583711551, 'UA', 'UKR', 'أوكرانيا'),
(99546, 3583711552, 3583711559, 'NA', 'NAM', 'ناميبيا'),
(99547, 3583711560, 3583711567, 'UA', 'UKR', 'أوكرانيا'),
(99548, 3583711568, 3583711591, 'NA', 'NAM', 'ناميبيا'),
(99549, 3583711592, 3583711607, 'UA', 'UKR', 'أوكرانيا'),
(99550, 3583711608, 3583711615, 'NA', 'NAM', 'ناميبيا'),
(99551, 3583711616, 3583711695, 'UA', 'UKR', 'أوكرانيا'),
(99552, 3583711696, 3583711703, 'NA', 'NAM', 'ناميبيا'),
(99553, 3583711704, 3583711711, 'UA', 'UKR', 'أوكرانيا'),
(99554, 3583711712, 3583711727, 'NA', 'NAM', 'ناميبيا'),
(99555, 3583711728, 3583711759, 'UA', 'UKR', 'أوكرانيا'),
(99556, 3583711760, 3583711767, 'NA', 'NAM', 'ناميبيا'),
(99557, 3583711768, 3583711783, 'UA', 'UKR', 'أوكرانيا'),
(99558, 3583711784, 3583711799, 'NA', 'NAM', 'ناميبيا'),
(99559, 3583711800, 3583711807, 'UA', 'UKR', 'أوكرانيا'),
(99560, 3583711808, 3583711823, 'NA', 'NAM', 'ناميبيا'),
(99561, 3583711824, 3583711831, 'UA', 'UKR', 'أوكرانيا'),
(99562, 3583711832, 3583711839, 'NA', 'NAM', 'ناميبيا'),
(99563, 3583711840, 3583711863, 'UA', 'UKR', 'أوكرانيا'),
(99564, 3583711864, 3583711879, 'NA', 'NAM', 'ناميبيا'),
(99565, 3583711880, 3583712015, 'UA', 'UKR', 'أوكرانيا'),
(99566, 3583712016, 3583712031, 'NA', 'NAM', 'ناميبيا'),
(99567, 3583712032, 3583712095, 'UA', 'UKR', 'أوكرانيا'),
(99568, 3583712096, 3583712111, 'NA', 'NAM', 'ناميبيا'),
(99569, 3583712112, 3583712119, 'UA', 'UKR', 'أوكرانيا'),
(99570, 3583712120, 3583712127, 'NA', 'NAM', 'ناميبيا'),
(99571, 3583712128, 3583712159, 'UA', 'UKR', 'أوكرانيا'),
(99572, 3583712160, 3583712199, 'NA', 'NAM', 'ناميبيا'),
(99573, 3583712200, 3583712287, 'UA', 'UKR', 'أوكرانيا'),
(99574, 3583712288, 3583712295, 'NA', 'NAM', 'ناميبيا'),
(99575, 3583712296, 3583712303, 'UA', 'UKR', 'أوكرانيا'),
(99576, 3583712304, 3583712311, 'RU', 'RUS', 'الإتحاد الروسي'),
(99577, 3583712312, 3583712319, 'NA', 'NAM', 'ناميبيا'),
(99578, 3583712320, 3583712399, 'UA', 'UKR', 'أوكرانيا'),
(99579, 3583712400, 3583712407, 'NA', 'NAM', 'ناميبيا'),
(99580, 3583712408, 3583712415, 'UA', 'UKR', 'أوكرانيا'),
(99581, 3583712416, 3583712423, 'NA', 'NAM', 'ناميبيا'),
(99582, 3583712424, 3583712439, 'UA', 'UKR', 'أوكرانيا'),
(99583, 3583712440, 3583712479, 'NA', 'NAM', 'ناميبيا'),
(99584, 3583712480, 3583712591, 'UA', 'UKR', 'أوكرانيا'),
(99585, 3583712592, 3583712599, 'NA', 'NAM', 'ناميبيا'),
(99586, 3583712600, 3583712623, 'UA', 'UKR', 'أوكرانيا'),
(99587, 3583712624, 3583712631, 'NA', 'NAM', 'ناميبيا'),
(99588, 3583712632, 3583712639, 'UA', 'UKR', 'أوكرانيا'),
(99589, 3583712640, 3583712647, 'NA', 'NAM', 'ناميبيا'),
(99590, 3583712648, 3583712655, 'UA', 'UKR', 'أوكرانيا'),
(99591, 3583712656, 3583712663, 'NA', 'NAM', 'ناميبيا'),
(99592, 3583712664, 3583712703, 'UA', 'UKR', 'أوكرانيا'),
(99593, 3583712704, 3583712719, 'NA', 'NAM', 'ناميبيا'),
(99594, 3583712720, 3583712735, 'UA', 'UKR', 'أوكرانيا'),
(99595, 3583712736, 3583712743, 'NA', 'NAM', 'ناميبيا'),
(99596, 3583712744, 3583712759, 'UA', 'UKR', 'أوكرانيا'),
(99597, 3583712760, 3583712763, 'NA', 'NAM', 'ناميبيا'),
(99598, 3583712764, 3583712775, 'UA', 'UKR', 'أوكرانيا'),
(99599, 3583712776, 3583712783, 'NA', 'NAM', 'ناميبيا'),
(99600, 3583712784, 3583712839, 'UA', 'UKR', 'أوكرانيا'),
(99601, 3583712840, 3583712847, 'NA', 'NAM', 'ناميبيا'),
(99602, 3583712848, 3583712911, 'UA', 'UKR', 'أوكرانيا'),
(99603, 3583712912, 3583712943, 'NA', 'NAM', 'ناميبيا'),
(99604, 3583712944, 3583712959, 'UA', 'UKR', 'أوكرانيا'),
(99605, 3583712960, 3583712983, 'NA', 'NAM', 'ناميبيا'),
(99606, 3583712984, 3583713031, 'UA', 'UKR', 'أوكرانيا'),
(99607, 3583713032, 3583713039, 'NA', 'NAM', 'ناميبيا'),
(99608, 3583713040, 3583713071, 'UA', 'UKR', 'أوكرانيا'),
(99609, 3583713072, 3583713079, 'NA', 'NAM', 'ناميبيا'),
(99610, 3583713080, 3583713103, 'UA', 'UKR', 'أوكرانيا'),
(99611, 3583713104, 3583713111, 'NA', 'NAM', 'ناميبيا'),
(99612, 3583713112, 3583713127, 'UA', 'UKR', 'أوكرانيا'),
(99613, 3583713128, 3583713135, 'NA', 'NAM', 'ناميبيا'),
(99614, 3583713136, 3583713143, 'UA', 'UKR', 'أوكرانيا'),
(99615, 3583713144, 3583713151, 'NA', 'NAM', 'ناميبيا'),
(99616, 3583713152, 3583713159, 'UA', 'UKR', 'أوكرانيا'),
(99617, 3583713160, 3583713167, 'NA', 'NAM', 'ناميبيا'),
(99618, 3583713168, 3583713183, 'UA', 'UKR', 'أوكرانيا'),
(99619, 3583713184, 3583713191, 'NA', 'NAM', 'ناميبيا'),
(99620, 3583713192, 3583713223, 'UA', 'UKR', 'أوكرانيا'),
(99621, 3583713224, 3583713231, 'NA', 'NAM', 'ناميبيا'),
(99622, 3583713232, 3583713279, 'UA', 'UKR', 'أوكرانيا'),
(99623, 3583713280, 3583721471, 'CZ', 'CZE', 'التشيك'),
(99624, 3583721472, 3583729663, 'DE', 'DEU', 'ألمانيا'),
(99625, 3583729664, 3583737855, 'TR', 'TUR', 'تركيا'),
(99626, 3583740672, 3583740927, 'GB', 'GBR', 'المملكة المتحدة'),
(99627, 3583741440, 3583741695, 'GB', 'GBR', 'المملكة المتحدة'),
(99628, 3583741696, 3583741951, 'NL', 'NLD', 'هولندا'),
(99629, 3583742720, 3583743487, 'DE', 'DEU', 'ألمانيا'),
(99630, 3583743976, 3583743983, 'GB', 'GBR', 'المملكة المتحدة'),
(99631, 3583744068, 3583744071, 'GB', 'GBR', 'المملكة المتحدة'),
(99632, 3583744128, 3583744255, 'GB', 'GBR', 'المملكة المتحدة'),
(99633, 3583744288, 3583744303, 'GB', 'GBR', 'المملكة المتحدة'),
(99634, 3583744320, 3583744447, 'GB', 'GBR', 'المملكة المتحدة'),
(99635, 3583744512, 3583744767, 'GB', 'GBR', 'المملكة المتحدة'),
(99636, 3583744832, 3583744847, 'GB', 'GBR', 'المملكة المتحدة'),
(99637, 3583744960, 3583744991, 'GB', 'GBR', 'المملكة المتحدة'),
(99638, 3583745280, 3583745535, 'GB', 'GBR', 'المملكة المتحدة'),
(99639, 3583745536, 3583745663, 'SE', 'SWE', 'السويد'),
(99640, 3583745800, 3583745807, 'NL', 'NLD', 'هولندا'),
(99641, 3583745808, 3583745823, 'GB', 'GBR', 'المملكة المتحدة'),
(99642, 3583746048, 3583754239, 'PL', 'POL', 'بولندا'),
(99643, 3583754240, 3583762431, 'IT', 'ITA', 'إيطاليا'),
(99644, 3583762432, 3583770623, 'CZ', 'CZE', 'التشيك'),
(99645, 3583770624, 3583772351, 'NL', 'NLD', 'هولندا'),
(99646, 3583772352, 3583772367, 'IT', 'ITA', 'إيطاليا'),
(99647, 3583772368, 3583778815, 'NL', 'NLD', 'هولندا'),
(99648, 3583778816, 3583787007, 'IT', 'ITA', 'إيطاليا'),
(99649, 3583787008, 3583795199, 'UA', 'UKR', 'أوكرانيا'),
(99650, 3583795200, 3583803391, 'PL', 'POL', 'بولندا'),
(99651, 3583803392, 3583806719, 'RU', 'RUS', 'الإتحاد الروسي'),
(99652, 3583806720, 3583806975, 'BY', 'BLR', 'روسيا البيضاء'),
(99653, 3583806976, 3583811583, 'RU', 'RUS', 'الإتحاد الروسي'),
(99654, 3583811584, 3583811839, 'GB', 'GBR', 'المملكة المتحدة'),
(99655, 3583811840, 3583819775, 'DE', 'DEU', 'ألمانيا'),
(99656, 3583819776, 3583827967, 'RU', 'RUS', 'الإتحاد الروسي'),
(99657, 3583827968, 3583836159, 'CH', 'CHE', 'سويسرا'),
(99658, 3583836160, 3583844351, 'DE', 'DEU', 'ألمانيا'),
(99659, 3583844352, 3583852543, 'KZ', 'KAZ', 'كازاخستان'),
(99660, 3583852544, 3583854591, 'FI', 'FIN', 'فنلندا'),
(99661, 3583854592, 3583854726, 'GB', 'GBR', 'المملكة المتحدة'),
(99662, 3583854727, 3583854735, 'FI', 'FIN', 'فنلندا'),
(99663, 3583854736, 3583854871, 'GB', 'GBR', 'المملكة المتحدة'),
(99664, 3583854872, 3583854879, 'FI', 'FIN', 'فنلندا'),
(99665, 3583854880, 3583855103, 'GB', 'GBR', 'المملكة المتحدة'),
(99666, 3583855104, 3583855167, 'US', 'USA', 'الولايات المتحدة'),
(99667, 3583855168, 3583855175, 'FI', 'FIN', 'فنلندا'),
(99668, 3583855176, 3583855183, 'US', 'USA', 'الولايات المتحدة'),
(99669, 3583855184, 3583855191, 'FI', 'FIN', 'فنلندا'),
(99670, 3583855192, 3583855199, 'US', 'USA', 'الولايات المتحدة'),
(99671, 3583855200, 3583855207, 'FI', 'FIN', 'فنلندا'),
(99672, 3583855208, 3583855247, 'US', 'USA', 'الولايات المتحدة'),
(99673, 3583855248, 3583855311, 'FI', 'FIN', 'فنلندا'),
(99674, 3583855312, 3583855327, 'US', 'USA', 'الولايات المتحدة'),
(99675, 3583855328, 3583856383, 'FI', 'FIN', 'فنلندا'),
(99676, 3583856384, 3583856447, 'SG', 'SGP', 'سنغافورة'),
(99677, 3583856448, 3583856615, 'FI', 'FIN', 'فنلندا'),
(99678, 3583856616, 3583856639, 'SG', 'SGP', 'سنغافورة'),
(99679, 3583856640, 3583860735, 'FI', 'FIN', 'فنلندا'),
(99680, 3583860736, 3583868927, 'HU', 'HUN', 'هنغاريا'),
(99681, 3583868928, 3583877119, 'AT', 'AUT', 'النمسا'),
(99682, 3583877120, 3583882239, 'RO', 'ROM', 'رومانيا'),
(99683, 3583882240, 3583882751, 'HU', 'HUN', 'هنغاريا'),
(99684, 3583882752, 3583885311, 'RO', 'ROM', 'رومانيا'),
(99685, 3583885312, 3583893503, 'GE', 'GEO', 'جورجيا'),
(99686, 3583893504, 3583901695, 'SI', 'SVN', 'سلوفينيا'),
(99687, 3583901696, 3583909887, 'RU', 'RUS', 'الإتحاد الروسي'),
(99688, 3583909888, 3583918079, 'SE', 'SWE', 'السويد'),
(99689, 3583918080, 3583926271, 'IT', 'ITA', 'إيطاليا'),
(99690, 3583926272, 3583934463, 'DE', 'DEU', 'ألمانيا'),
(99691, 3583934464, 3583942655, 'CH', 'CHE', 'سويسرا'),
(99692, 3583950848, 3583959039, 'PL', 'POL', 'بولندا'),
(99693, 3583959040, 3583967231, 'NO', 'NOR', 'النرويج'),
(99694, 3583967232, 3583975423, 'NL', 'NLD', 'هولندا'),
(99695, 3583975424, 3583983615, 'LT', 'LTU', 'ليتوانيا'),
(99696, 3583983616, 3583999999, 'RU', 'RUS', 'الإتحاد الروسي'),
(99697, 3584000000, 3584008191, 'IE', 'IRL', 'إيرلندا'),
(99698, 3584008192, 3584016383, 'SE', 'SWE', 'السويد'),
(99699, 3584016384, 3584024575, 'RU', 'RUS', 'الإتحاد الروسي'),
(99700, 3584024576, 3584032767, 'UA', 'UKR', 'أوكرانيا'),
(99701, 3584032768, 3584040959, 'DE', 'DEU', 'ألمانيا'),
(99702, 3584040960, 3584049151, 'CH', 'CHE', 'سويسرا'),
(99703, 3584049152, 3584055911, 'DE', 'DEU', 'ألمانيا'),
(99704, 3584055912, 3584055919, 'TR', 'TUR', 'تركيا'),
(99705, 3584055920, 3584057343, 'DE', 'DEU', 'ألمانيا'),
(99706, 3584057344, 3584065535, 'GB', 'GBR', 'المملكة المتحدة'),
(99707, 3584065536, 3584073727, 'UA', 'UKR', 'أوكرانيا'),
(99708, 3584073728, 3584081919, 'SK', 'SVK', 'سلوفاكيا'),
(99709, 3584081920, 3584081951, 'AT', 'AUT', 'النمسا'),
(99710, 3584081952, 3584081959, 'NL', 'NLD', 'هولندا'),
(99711, 3584081960, 3584082143, 'AT', 'AUT', 'النمسا'),
(99712, 3584082144, 3584082175, 'NL', 'NLD', 'هولندا'),
(99713, 3584082176, 3584082279, 'AT', 'AUT', 'النمسا'),
(99714, 3584082280, 3584082287, 'NL', 'NLD', 'هولندا'),
(99715, 3584082288, 3584082943, 'AT', 'AUT', 'النمسا'),
(99716, 3584082944, 3584089087, 'NL', 'NLD', 'هولندا'),
(99717, 3584089088, 3584089855, 'AT', 'AUT', 'النمسا'),
(99718, 3584089856, 3584089871, 'NL', 'NLD', 'هولندا'),
(99719, 3584089872, 3584089903, 'AT', 'AUT', 'النمسا'),
(99720, 3584089904, 3584089919, 'NL', 'NLD', 'هولندا'),
(99721, 3584089920, 3584090111, 'AT', 'AUT', 'النمسا'),
(99722, 3584090112, 3584090623, 'NO', 'NOR', 'النرويج'),
(99723, 3584090624, 3584090879, 'NL', 'NLD', 'هولندا'),
(99724, 3584090880, 3584090887, 'NO', 'NOR', 'النرويج'),
(99725, 3584090888, 3584090895, 'NL', 'NLD', 'هولندا'),
(99726, 3584090896, 3584090943, 'NO', 'NOR', 'النرويج'),
(99727, 3584090944, 3584090959, 'NL', 'NLD', 'هولندا'),
(99728, 3584090960, 3584093783, 'NO', 'NOR', 'النرويج'),
(99729, 3584093784, 3584093791, 'NL', 'NLD', 'هولندا'),
(99730, 3584093792, 3584094893, 'NO', 'NOR', 'النرويج'),
(99731, 3584094894, 3584094895, 'NL', 'NLD', 'هولندا'),
(99732, 3584094896, 3584095935, 'NO', 'NOR', 'النرويج'),
(99733, 3584095936, 3584095999, 'NL', 'NLD', 'هولندا'),
(99734, 3584096000, 3584096255, 'NO', 'NOR', 'النرويج'),
(99735, 3584096256, 3584098303, 'NL', 'NLD', 'هولندا'),
(99736, 3584098304, 3584106495, 'SI', 'SVN', 'سلوفينيا'),
(99737, 3584106496, 3584114687, 'FI', 'FIN', 'فنلندا'),
(99738, 3584114688, 3584122879, 'GB', 'GBR', 'المملكة المتحدة'),
(99739, 3584122880, 3584131071, 'PL', 'POL', 'بولندا'),
(99740, 3584131072, 3584139263, 'TR', 'TUR', 'تركيا'),
(99741, 3584139264, 3584147455, 'NO', 'NOR', 'النرويج'),
(99742, 3584147456, 3584155647, 'FR', 'FRA', 'فرنسا'),
(99743, 3584155648, 3584163839, 'NO', 'NOR', 'النرويج'),
(99744, 3584163840, 3584172031, 'CH', 'CHE', 'سويسرا'),
(99745, 3584172032, 3584180223, 'FR', 'FRA', 'فرنسا'),
(99746, 3584180224, 3584188415, 'AT', 'AUT', 'النمسا'),
(99747, 3584188416, 3584196607, 'GB', 'GBR', 'المملكة المتحدة'),
(99748, 3584196608, 3584204799, 'DE', 'DEU', 'ألمانيا'),
(99749, 3584204800, 3584212991, 'NL', 'NLD', 'هولندا'),
(99750, 3584212992, 3584221183, 'ES', 'ESP', 'إسبانيا'),
(99751, 3584221184, 3584229375, 'NO', 'NOR', 'النرويج'),
(99752, 3584229376, 3584245759, 'HU', 'HUN', 'هنغاريا'),
(99753, 3584245760, 3584253951, 'NL', 'NLD', 'هولندا'),
(99754, 3584253952, 3584254463, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99755, 3584254464, 3584254975, 'RS', 'SRB', 'صربيا'),
(99756, 3584254976, 3584255743, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99757, 3584255744, 3584255999, 'RS', 'SRB', 'صربيا'),
(99758, 3584256000, 3584257023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99759, 3584257024, 3584260095, 'RS', 'SRB', 'صربيا'),
(99760, 3584260096, 3584260135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99761, 3584260136, 3584260139, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99762, 3584260140, 3584260151, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99763, 3584260152, 3584260155, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99764, 3584260156, 3584260231, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99765, 3584260232, 3584260239, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99766, 3584260240, 3584260247, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99767, 3584260248, 3584260255, 'RS', 'SRB', 'صربيا'),
(99768, 3584260256, 3584260351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99769, 3584260352, 3584260415, 'RS', 'SRB', 'صربيا'),
(99770, 3584260416, 3584260511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99771, 3584260512, 3584260607, 'RS', 'SRB', 'صربيا'),
(99772, 3584260608, 3584261375, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99773, 3584261376, 3584261631, 'RS', 'SRB', 'صربيا'),
(99774, 3584261632, 3584262143, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(99775, 3584262144, 3584270335, 'SE', 'SWE', 'السويد'),
(99776, 3584270336, 3584278527, 'FR', 'FRA', 'فرنسا'),
(99777, 3584278528, 3584286719, 'GB', 'GBR', 'المملكة المتحدة'),
(99778, 3584286720, 3584295719, 'AT', 'AUT', 'النمسا'),
(99779, 3584295720, 3584295727, 'NL', 'NLD', 'هولندا'),
(99780, 3584295728, 3584295759, 'AT', 'AUT', 'النمسا'),
(99781, 3584295760, 3584295767, 'PT', 'PRT', 'البورتوغال'),
(99782, 3584295768, 3584295807, 'AT', 'AUT', 'النمسا'),
(99783, 3584295808, 3584295815, 'PT', 'PRT', 'البورتوغال'),
(99784, 3584295816, 3584295935, 'AT', 'AUT', 'النمسا'),
(99785, 3584295936, 3584295943, 'AS', 'ASM', 'ساموا الأمريكية'),
(99786, 3584295944, 3584303103, 'AT', 'AUT', 'النمسا'),
(99787, 3584303104, 3584311295, 'ES', 'ESP', 'إسبانيا'),
(99788, 3584311296, 3584319487, 'DE', 'DEU', 'ألمانيا'),
(99789, 3584319488, 3584327679, 'LT', 'LTU', 'ليتوانيا'),
(99790, 3584327680, 3584335871, 'DE', 'DEU', 'ألمانيا'),
(99791, 3584335872, 3584344063, 'ES', 'ESP', 'إسبانيا'),
(99792, 3584344064, 3584352255, 'SE', 'SWE', 'السويد'),
(99793, 3584352256, 3584360447, 'RO', 'ROM', 'رومانيا'),
(99794, 3584360448, 3584368639, 'GB', 'GBR', 'المملكة المتحدة'),
(99795, 3584368640, 3584376831, 'LB', 'LBN', 'لبنان'),
(99796, 3584376832, 3584393215, 'DE', 'DEU', 'ألمانيا'),
(99797, 3584393216, 3584401407, 'GB', 'GBR', 'المملكة المتحدة'),
(99798, 3584401408, 3584409599, 'MT', 'MLT', 'مالطا'),
(99799, 3584409600, 3584413439, 'RU', 'RUS', 'الإتحاد الروسي'),
(99800, 3584413440, 3584413695, 'DE', 'DEU', 'ألمانيا'),
(99801, 3584413696, 3584414207, 'GB', 'GBR', 'المملكة المتحدة'),
(99802, 3584414208, 3584414719, 'RU', 'RUS', 'الإتحاد الروسي'),
(99803, 3584414720, 3584414975, 'DE', 'DEU', 'ألمانيا'),
(99804, 3584414976, 3584416255, 'RU', 'RUS', 'الإتحاد الروسي'),
(99805, 3584416256, 3584416767, 'GB', 'GBR', 'المملكة المتحدة'),
(99806, 3584416768, 3584417791, 'RU', 'RUS', 'الإتحاد الروسي'),
(99807, 3584417792, 3584434175, 'GB', 'GBR', 'المملكة المتحدة'),
(99808, 3584434176, 3584442367, 'LU', 'LUX', 'لوكسيمبورغ'),
(99809, 3584442368, 3584450559, 'GB', 'GBR', 'المملكة المتحدة'),
(99810, 3584458752, 3584466943, 'SA', 'SAU', 'السعودية'),
(99811, 3584466944, 3584475135, 'NO', 'NOR', 'النرويج'),
(99812, 3584475136, 3584483327, 'FR', 'FRA', 'فرنسا'),
(99813, 3584483328, 3584491519, 'DE', 'DEU', 'ألمانيا'),
(99814, 3584491520, 3584499711, 'BG', 'BGR', 'بلغاريا'),
(99815, 3584499712, 3584507903, 'RU', 'RUS', 'الإتحاد الروسي'),
(99816, 3584507904, 3584508927, 'GB', 'GBR', 'المملكة المتحدة'),
(99817, 3584508928, 3584508943, 'CY', 'CYP', 'قبرص'),
(99818, 3584508944, 3584508951, 'KY', 'CYM', 'جزر كايمان'),
(99819, 3584508952, 3584509031, 'GB', 'GBR', 'المملكة المتحدة'),
(99820, 3584509032, 3584509039, 'NL', 'NLD', 'هولندا'),
(99821, 3584509040, 3584509231, 'GB', 'GBR', 'المملكة المتحدة'),
(99822, 3584509232, 3584509239, 'AW', 'ABW', 'أروبا'),
(99823, 3584509240, 3584509359, 'GB', 'GBR', 'المملكة المتحدة'),
(99824, 3584509360, 3584509367, 'KY', 'CYM', 'جزر كايمان'),
(99825, 3584509368, 3584510623, 'GB', 'GBR', 'المملكة المتحدة'),
(99826, 3584510624, 3584510655, 'NL', 'NLD', 'هولندا'),
(99827, 3584510656, 3584510999, 'GB', 'GBR', 'المملكة المتحدة'),
(99828, 3584511000, 3584511007, 'KY', 'CYM', 'جزر كايمان'),
(99829, 3584511008, 3584511023, 'GB', 'GBR', 'المملكة المتحدة'),
(99830, 3584511024, 3584511039, 'KY', 'CYM', 'جزر كايمان'),
(99831, 3584511040, 3584511055, 'GB', 'GBR', 'المملكة المتحدة'),
(99832, 3584511056, 3584511071, 'NL', 'NLD', 'هولندا'),
(99833, 3584511072, 3584511135, 'GB', 'GBR', 'المملكة المتحدة'),
(99834, 3584511136, 3584511143, 'HK', 'HKG', 'هونغ كونغ'),
(99835, 3584511144, 3584511807, 'GB', 'GBR', 'المملكة المتحدة'),
(99836, 3584511808, 3584511935, 'MT', 'MLT', 'مالطا'),
(99837, 3584511936, 3584513535, 'GB', 'GBR', 'المملكة المتحدة'),
(99838, 3584513536, 3584513567, 'US', 'USA', 'الولايات المتحدة'),
(99839, 3584513568, 3584516071, 'GB', 'GBR', 'المملكة المتحدة'),
(99840, 3584516072, 3584516079, 'BB', 'BRB', 'باربادوس'),
(99841, 3584516080, 3584516095, 'GB', 'GBR', 'المملكة المتحدة'),
(99842, 3584516096, 3584524287, 'NO', 'NOR', 'النرويج'),
(99843, 3584524288, 3584532479, 'IS', 'ISL', 'أيسلندا'),
(99844, 3584532480, 3584540671, 'DE', 'DEU', 'ألمانيا'),
(99845, 3584540672, 3584548863, 'RU', 'RUS', 'الإتحاد الروسي'),
(99846, 3584548864, 3584557055, 'ES', 'ESP', 'إسبانيا'),
(99847, 3584557056, 3584565247, 'EE', 'EST', 'إستونيا'),
(99848, 3584565248, 3584573439, 'RU', 'RUS', 'الإتحاد الروسي'),
(99849, 3584573440, 3584589823, 'DE', 'DEU', 'ألمانيا'),
(99850, 3584589824, 3584598015, 'RU', 'RUS', 'الإتحاد الروسي'),
(99851, 3584598016, 3584606207, 'CZ', 'CZE', 'التشيك'),
(99852, 3584606208, 3584614399, 'DE', 'DEU', 'ألمانيا'),
(99853, 3584614400, 3584614463, 'GB', 'GBR', 'المملكة المتحدة'),
(99854, 3584614464, 3584614623, 'IE', 'IRL', 'إيرلندا'),
(99855, 3584614624, 3584614655, 'GB', 'GBR', 'المملكة المتحدة'),
(99856, 3584614656, 3584614751, 'IE', 'IRL', 'إيرلندا'),
(99857, 3584614752, 3584614767, 'GB', 'GBR', 'المملكة المتحدة'),
(99858, 3584614768, 3584622335, 'IE', 'IRL', 'إيرلندا'),
(99859, 3584622336, 3584622591, 'GB', 'GBR', 'المملكة المتحدة'),
(99860, 3584622592, 3584630783, 'FI', 'FIN', 'فنلندا'),
(99861, 3584630784, 3584638975, 'BG', 'BGR', 'بلغاريا'),
(99862, 3584638976, 3584647167, 'UA', 'UKR', 'أوكرانيا'),
(99863, 3584647168, 3584655359, 'LU', 'LUX', 'لوكسيمبورغ'),
(99864, 3584655360, 3584663551, 'CY', 'CYP', 'قبرص'),
(99865, 3584663552, 3584671743, 'FR', 'FRA', 'فرنسا'),
(99866, 3584671744, 3584688127, 'NL', 'NLD', 'هولندا'),
(99867, 3584688128, 3584696319, 'GB', 'GBR', 'المملكة المتحدة'),
(99868, 3584696320, 3584701751, 'ES', 'ESP', 'إسبانيا'),
(99869, 3584701752, 3584701823, 'NL', 'NLD', 'هولندا'),
(99870, 3584701824, 3584701991, 'ES', 'ESP', 'إسبانيا'),
(99871, 3584701992, 3584702007, 'CH', 'CHE', 'سويسرا'),
(99872, 3584702008, 3584703095, 'ES', 'ESP', 'إسبانيا'),
(99873, 3584703096, 3584703103, 'BE', 'BEL', 'بلجيكا'),
(99874, 3584703104, 3584704511, 'ES', 'ESP', 'إسبانيا'),
(99875, 3584704512, 3584720895, 'RU', 'RUS', 'الإتحاد الروسي'),
(99876, 3584720896, 3584729087, 'GB', 'GBR', 'المملكة المتحدة'),
(99877, 3584729088, 3584737279, 'DE', 'DEU', 'ألمانيا'),
(99878, 3584737280, 3584745471, 'GR', 'GRC', 'اليونان'),
(99879, 3584745472, 3584753663, 'DK', 'DNK', 'الدنيمارك'),
(99880, 3584753664, 3584770047, 'RU', 'RUS', 'الإتحاد الروسي'),
(99881, 3584770048, 3584778239, 'NL', 'NLD', 'هولندا'),
(99882, 3584778240, 3584786431, 'IT', 'ITA', 'إيطاليا'),
(99883, 3584786432, 3584794623, 'NL', 'NLD', 'هولندا'),
(99884, 3584794624, 3584802815, 'IT', 'ITA', 'إيطاليا'),
(99885, 3584802816, 3584811007, 'GB', 'GBR', 'المملكة المتحدة'),
(99886, 3584811008, 3584819199, 'ES', 'ESP', 'إسبانيا'),
(99887, 3584819200, 3584827391, 'RU', 'RUS', 'الإتحاد الروسي'),
(99888, 3584827392, 3584835583, 'ES', 'ESP', 'إسبانيا'),
(99889, 3584835584, 3584843775, 'AZ', 'AZE', 'أذربيجان'),
(99890, 3584843776, 3584851967, 'DE', 'DEU', 'ألمانيا'),
(99891, 3584860160, 3584868351, 'PL', 'POL', 'بولندا'),
(99892, 3584868352, 3584876543, 'NO', 'NOR', 'النرويج'),
(99893, 3584876544, 3584884735, 'SI', 'SVN', 'سلوفينيا'),
(99894, 3584884736, 3584892927, 'DE', 'DEU', 'ألمانيا'),
(99895, 3584892928, 3584901119, 'IL', 'ISR', 'إسرائيل'),
(99896, 3584901120, 3584909311, 'AT', 'AUT', 'النمسا'),
(99897, 3584909312, 3584917503, 'IT', 'ITA', 'إيطاليا'),
(99898, 3584917504, 3584925695, 'FI', 'FIN', 'فنلندا'),
(99899, 3584925696, 3584928275, 'CH', 'CHE', 'سويسرا'),
(99900, 3584928276, 3584928279, 'IT', 'ITA', 'إيطاليا'),
(99901, 3584928280, 3584929599, 'CH', 'CHE', 'سويسرا'),
(99902, 3584929600, 3584929727, 'DE', 'DEU', 'ألمانيا'),
(99903, 3584929728, 3584931375, 'CH', 'CHE', 'سويسرا'),
(99904, 3584931376, 3584931391, 'ES', 'ESP', 'إسبانيا'),
(99905, 3584931392, 3584932191, 'CH', 'CHE', 'سويسرا'),
(99906, 3584932192, 3584932199, 'GB', 'GBR', 'المملكة المتحدة'),
(99907, 3584932200, 3584933887, 'CH', 'CHE', 'سويسرا'),
(99908, 3584933888, 3584942079, 'PL', 'POL', 'بولندا'),
(99909, 3584942080, 3584950271, 'DK', 'DNK', 'الدنيمارك'),
(99910, 3584958464, 3584966655, 'DE', 'DEU', 'ألمانيا'),
(99911, 3584966656, 3584974847, 'DK', 'DNK', 'الدنيمارك'),
(99912, 3584974848, 3584983039, 'FR', 'FRA', 'فرنسا'),
(99913, 3584983040, 3584983807, 'US', 'USA', 'الولايات المتحدة'),
(99914, 3584983808, 3584984063, 'NL', 'NLD', 'هولندا'),
(99915, 3584984064, 3584984319, 'US', 'USA', 'الولايات المتحدة'),
(99916, 3584984320, 3584984575, 'NL', 'NLD', 'هولندا'),
(99917, 3584984576, 3584988311, 'US', 'USA', 'الولايات المتحدة'),
(99918, 3584988312, 3584988319, 'NL', 'NLD', 'هولندا'),
(99919, 3584988320, 3584988607, 'US', 'USA', 'الولايات المتحدة'),
(99920, 3584988608, 3584988623, 'NL', 'NLD', 'هولندا'),
(99921, 3584988624, 3584988639, 'US', 'USA', 'الولايات المتحدة'),
(99922, 3584988640, 3584988671, 'NL', 'NLD', 'هولندا'),
(99923, 3584988672, 3584990239, 'US', 'USA', 'الولايات المتحدة'),
(99924, 3584990240, 3584990527, 'NL', 'NLD', 'هولندا'),
(99925, 3584990528, 3584990591, 'US', 'USA', 'الولايات المتحدة'),
(99926, 3584990592, 3584990719, 'NL', 'NLD', 'هولندا'),
(99927, 3584990720, 3584991231, 'US', 'USA', 'الولايات المتحدة'),
(99928, 3584991232, 3584999423, 'IT', 'ITA', 'إيطاليا'),
(99929, 3584999424, 3585007615, 'GB', 'GBR', 'المملكة المتحدة'),
(99930, 3585007616, 3585015807, 'AT', 'AUT', 'النمسا'),
(99931, 3585015808, 3585023999, 'IT', 'ITA', 'إيطاليا'),
(99932, 3585024000, 3585032191, 'CZ', 'CZE', 'التشيك'),
(99933, 3585032192, 3585048575, 'LV', 'LVA', 'لاتفيا'),
(99934, 3585048576, 3585050623, 'IQ', 'IRQ', 'العراق'),
(99935, 3585050624, 3585054719, 'GB', 'GBR', 'المملكة المتحدة'),
(99936, 3585054720, 3585055063, 'NG', 'NGA', 'نيجيريا'),
(99937, 3585055064, 3585055071, 'GB', 'GBR', 'المملكة المتحدة'),
(99938, 3585055072, 3585055087, 'NG', 'NGA', 'نيجيريا'),
(99939, 3585055088, 3585056767, 'GB', 'GBR', 'المملكة المتحدة'),
(99940, 3585056768, 3585064959, 'LB', 'LBN', 'لبنان'),
(99941, 3585064960, 3585081343, 'GB', 'GBR', 'المملكة المتحدة'),
(99942, 3585081344, 3585114111, 'IR', 'IRN', 'إيران'),
(99943, 3585114112, 3585122303, 'IS', 'ISL', 'أيسلندا'),
(99944, 3585122304, 3585130495, 'ES', 'ESP', 'إسبانيا'),
(99945, 3585130496, 3585138687, 'FR', 'FRA', 'فرنسا'),
(99946, 3585138688, 3585146879, 'RU', 'RUS', 'الإتحاد الروسي'),
(99947, 3585146880, 3585155071, 'RO', 'ROM', 'رومانيا'),
(99948, 3585155072, 3585163263, 'GB', 'GBR', 'المملكة المتحدة'),
(99949, 3585163264, 3585171455, 'BE', 'BEL', 'بلجيكا'),
(99950, 3585171456, 3585179647, 'RU', 'RUS', 'الإتحاد الروسي'),
(99951, 3585179648, 3585189887, 'BE', 'BEL', 'بلجيكا'),
(99952, 3585189888, 3585190399, 'DZ', 'DZA', 'الجزائر'),
(99953, 3585190400, 3585190527, 'BE', 'BEL', 'بلجيكا'),
(99954, 3585190528, 3585190655, 'DZ', 'DZA', 'الجزائر'),
(99955, 3585190656, 3585196031, 'BE', 'BEL', 'بلجيكا'),
(99956, 3585196032, 3585204223, 'ES', 'ESP', 'إسبانيا'),
(99957, 3585204224, 3585212415, 'GB', 'GBR', 'المملكة المتحدة'),
(99958, 3585212416, 3585220607, 'DE', 'DEU', 'ألمانيا'),
(99959, 3585220608, 3585228799, 'RU', 'RUS', 'الإتحاد الروسي'),
(99960, 3585228800, 3585236991, 'DE', 'DEU', 'ألمانيا'),
(99961, 3585236992, 3585245183, 'HU', 'HUN', 'هنغاريا'),
(99962, 3585245184, 3585253375, 'GB', 'GBR', 'المملكة المتحدة'),
(99963, 3585253376, 3585261567, 'DE', 'DEU', 'ألمانيا'),
(99964, 3585261568, 3585269759, 'IT', 'ITA', 'إيطاليا'),
(99965, 3585269760, 3585277951, 'SY', 'SYR', 'سوريا'),
(99966, 3585277952, 3585286143, 'SE', 'SWE', 'السويد'),
(99967, 3585286144, 3585294335, 'NO', 'NOR', 'النرويج'),
(99968, 3585294336, 3585302527, 'DE', 'DEU', 'ألمانيا'),
(99969, 3585302528, 3585310719, 'ES', 'ESP', 'إسبانيا'),
(99970, 3585310720, 3585318911, 'DE', 'DEU', 'ألمانيا'),
(99971, 3585327104, 3585335295, 'NL', 'NLD', 'هولندا'),
(99972, 3585335296, 3585343487, 'UA', 'UKR', 'أوكرانيا'),
(99973, 3585343488, 3585351679, 'EE', 'EST', 'إستونيا'),
(99974, 3585351680, 3585359871, 'CZ', 'CZE', 'التشيك'),
(99975, 3585359872, 3585368063, 'SE', 'SWE', 'السويد'),
(99976, 3585368064, 3585376255, 'LV', 'LVA', 'لاتفيا'),
(99977, 3585376256, 3585384447, 'PL', 'POL', 'بولندا'),
(99978, 3585384448, 3585392639, 'CH', 'CHE', 'سويسرا'),
(99979, 3585392640, 3585400831, 'RU', 'RUS', 'الإتحاد الروسي'),
(99980, 3585400832, 3585409023, 'FR', 'FRA', 'فرنسا'),
(99981, 3585409024, 3585417215, 'RU', 'RUS', 'الإتحاد الروسي'),
(99982, 3585417216, 3585425407, 'BE', 'BEL', 'بلجيكا'),
(99983, 3585425408, 3585433599, 'ES', 'ESP', 'إسبانيا'),
(99984, 3585433600, 3585441791, 'IS', 'ISL', 'أيسلندا'),
(99985, 3585441792, 3585449983, 'SK', 'SVK', 'سلوفاكيا'),
(99986, 3585449984, 3585458175, 'SA', 'SAU', 'السعودية'),
(99987, 3585458176, 3585466367, 'HU', 'HUN', 'هنغاريا'),
(99988, 3585474560, 3585482751, 'DE', 'DEU', 'ألمانيا'),
(99989, 3585482752, 3585490943, 'FR', 'FRA', 'فرنسا'),
(99990, 3585490944, 3585499135, 'IT', 'ITA', 'إيطاليا'),
(99991, 3585499136, 3585515519, 'DE', 'DEU', 'ألمانيا'),
(99992, 3585515520, 3585523711, 'RU', 'RUS', 'الإتحاد الروسي'),
(99993, 3585523712, 3585531903, 'LV', 'LVA', 'لاتفيا'),
(99994, 3585531904, 3585540095, 'AT', 'AUT', 'النمسا'),
(99995, 3585540096, 3585548287, 'DE', 'DEU', 'ألمانيا'),
(99996, 3585548288, 3585556479, 'RU', 'RUS', 'الإتحاد الروسي'),
(99997, 3585556480, 3585564671, 'DE', 'DEU', 'ألمانيا'),
(99998, 3585564672, 3585572863, 'RU', 'RUS', 'الإتحاد الروسي'),
(99999, 3585572864, 3585581055, 'IT', 'ITA', 'إيطاليا'),
(100000, 3585581056, 3585597439, 'DE', 'DEU', 'ألمانيا'),
(100001, 3585597440, 3585605631, 'RU', 'RUS', 'الإتحاد الروسي'),
(100002, 3585605632, 3585613823, 'PL', 'POL', 'بولندا'),
(100003, 3585613824, 3585622015, 'EE', 'EST', 'إستونيا'),
(100004, 3585622016, 3585630207, 'RU', 'RUS', 'الإتحاد الروسي'),
(100005, 3585630208, 3585630783, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100006, 3585630784, 3585630975, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100007, 3585630976, 3585630983, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100008, 3585630984, 3585630999, 'RS', 'SRB', 'صربيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(100009, 3585631000, 3585631007, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100010, 3585631008, 3585631023, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100011, 3585631024, 3585631031, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100012, 3585631032, 3585631103, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100013, 3585631104, 3585631135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100014, 3585631136, 3585631199, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100015, 3585631200, 3585631223, 'RS', 'SRB', 'صربيا'),
(100016, 3585631224, 3585631227, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100017, 3585631228, 3585631231, 'RS', 'SRB', 'صربيا'),
(100018, 3585631232, 3585631255, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100019, 3585631256, 3585631263, 'RS', 'SRB', 'صربيا'),
(100020, 3585631264, 3585631307, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100021, 3585631308, 3585631311, 'RS', 'SRB', 'صربيا'),
(100022, 3585631312, 3585631503, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100023, 3585631504, 3585631519, 'RS', 'SRB', 'صربيا'),
(100024, 3585631520, 3585638399, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100025, 3585638400, 3585646591, 'RU', 'RUS', 'الإتحاد الروسي'),
(100026, 3585646592, 3585654783, 'SA', 'SAU', 'السعودية'),
(100027, 3585654784, 3585655631, 'NO', 'NOR', 'النرويج'),
(100028, 3585655632, 3585655639, 'US', 'USA', 'الولايات المتحدة'),
(100029, 3585655640, 3585662975, 'NO', 'NOR', 'النرويج'),
(100030, 3585662976, 3585671167, 'BY', 'BLR', 'روسيا البيضاء'),
(100031, 3585671168, 3585672191, 'SE', 'SWE', 'السويد'),
(100032, 3585672192, 3585672447, 'DK', 'DNK', 'الدنيمارك'),
(100033, 3585672448, 3585672959, 'SE', 'SWE', 'السويد'),
(100034, 3585672960, 3585673983, 'DK', 'DNK', 'الدنيمارك'),
(100035, 3585673984, 3585674239, 'SE', 'SWE', 'السويد'),
(100036, 3585674240, 3585675775, 'DK', 'DNK', 'الدنيمارك'),
(100037, 3585675776, 3585676287, 'SE', 'SWE', 'السويد'),
(100038, 3585676288, 3585677055, 'DK', 'DNK', 'الدنيمارك'),
(100039, 3585677056, 3585677311, 'SE', 'SWE', 'السويد'),
(100040, 3585677312, 3585677567, 'DK', 'DNK', 'الدنيمارك'),
(100041, 3585677568, 3585679359, 'SE', 'SWE', 'السويد'),
(100042, 3585679360, 3585687551, 'FI', 'FIN', 'فنلندا'),
(100043, 3585687552, 3585695743, 'DE', 'DEU', 'ألمانيا'),
(100044, 3585695744, 3585695999, 'CM', 'CMR', 'الكاميرون'),
(100045, 3585696000, 3585696063, 'BD', 'BGD', 'بنغالاديش'),
(100046, 3585696064, 3585696511, 'GB', 'GBR', 'المملكة المتحدة'),
(100047, 3585696512, 3585696767, 'LB', 'LBN', 'لبنان'),
(100048, 3585696768, 3585696799, 'NO', 'NOR', 'النرويج'),
(100049, 3585696800, 3585696831, 'LR', 'LBR', 'ليبيريا'),
(100050, 3585696832, 3585697279, 'GB', 'GBR', 'المملكة المتحدة'),
(100051, 3585697280, 3585697535, 'NO', 'NOR', 'النرويج'),
(100052, 3585697536, 3585697791, 'GB', 'GBR', 'المملكة المتحدة'),
(100053, 3585697792, 3585698047, 'NG', 'NGA', 'نيجيريا'),
(100054, 3585698048, 3585698303, 'GB', 'GBR', 'المملكة المتحدة'),
(100055, 3585698304, 3585698815, 'NG', 'NGA', 'نيجيريا'),
(100056, 3585698816, 3585699583, 'GB', 'GBR', 'المملكة المتحدة'),
(100057, 3585699584, 3585699711, 'US', 'USA', 'الولايات المتحدة'),
(100058, 3585699712, 3585699839, 'AU', 'AUS', 'أستراليا'),
(100059, 3585699840, 3585700159, 'US', 'USA', 'الولايات المتحدة'),
(100060, 3585700160, 3585700191, 'GB', 'GBR', 'المملكة المتحدة'),
(100061, 3585700192, 3585700222, 'US', 'USA', 'الولايات المتحدة'),
(100062, 3585700223, 3585700231, 'GB', 'GBR', 'المملكة المتحدة'),
(100063, 3585700232, 3585700239, 'US', 'USA', 'الولايات المتحدة'),
(100064, 3585700240, 3585700255, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(100065, 3585700256, 3585700271, 'GB', 'GBR', 'المملكة المتحدة'),
(100066, 3585700272, 3585700287, 'NG', 'NGA', 'نيجيريا'),
(100067, 3585700288, 3585700303, 'GB', 'GBR', 'المملكة المتحدة'),
(100068, 3585700304, 3585700319, 'NG', 'NGA', 'نيجيريا'),
(100069, 3585700320, 3585700343, 'AU', 'AUS', 'أستراليا'),
(100070, 3585700344, 3585700351, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(100071, 3585700352, 3585700607, 'NG', 'NGA', 'نيجيريا'),
(100072, 3585700608, 3585700863, 'TZ', 'TZA', 'تانزانيا'),
(100073, 3585700864, 3585701119, 'IQ', 'IRQ', 'العراق'),
(100074, 3585701120, 3585701375, 'US', 'USA', 'الولايات المتحدة'),
(100075, 3585701376, 3585701439, 'MW', 'MWI', 'ملاوي'),
(100076, 3585701440, 3585701503, 'GB', 'GBR', 'المملكة المتحدة'),
(100077, 3585701504, 3585701519, 'NG', 'NGA', 'نيجيريا'),
(100078, 3585701520, 3585701535, 'CA', 'CAN', 'كندا'),
(100079, 3585701536, 3585701631, 'NG', 'NGA', 'نيجيريا'),
(100080, 3585701632, 3585701887, 'GB', 'GBR', 'المملكة المتحدة'),
(100081, 3585701888, 3585702143, 'FR', 'FRA', 'فرنسا'),
(100082, 3585702144, 3585702399, 'LR', 'LBR', 'ليبيريا'),
(100083, 3585702400, 3585702463, 'US', 'USA', 'الولايات المتحدة'),
(100084, 3585702464, 3585702527, 'GB', 'GBR', 'المملكة المتحدة'),
(100085, 3585702528, 3585702655, 'TZ', 'TZA', 'تانزانيا'),
(100086, 3585702656, 3585702911, 'TG', 'TGO', 'توغو'),
(100087, 3585702912, 3585703167, 'NG', 'NGA', 'نيجيريا'),
(100088, 3585703168, 3585703423, 'FR', 'FRA', 'فرنسا'),
(100089, 3585703424, 3585703935, 'GB', 'GBR', 'المملكة المتحدة'),
(100090, 3585703936, 3585712127, 'DE', 'DEU', 'ألمانيا'),
(100091, 3585712128, 3585716415, 'AT', 'AUT', 'النمسا'),
(100092, 3585716416, 3585716423, 'DE', 'DEU', 'ألمانيا'),
(100093, 3585716424, 3585720319, 'AT', 'AUT', 'النمسا'),
(100094, 3585720320, 3585728511, 'GB', 'GBR', 'المملكة المتحدة'),
(100095, 3585728512, 3585736703, 'SE', 'SWE', 'السويد'),
(100096, 3585736704, 3585744895, 'GB', 'GBR', 'المملكة المتحدة'),
(100097, 3585744896, 3585750335, 'FR', 'FRA', 'فرنسا'),
(100098, 3585750336, 3585750351, 'GB', 'GBR', 'المملكة المتحدة'),
(100099, 3585750352, 3585750367, 'DE', 'DEU', 'ألمانيا'),
(100100, 3585750368, 3585750383, 'ES', 'ESP', 'إسبانيا'),
(100101, 3585750384, 3585750399, 'PT', 'PRT', 'البورتوغال'),
(100102, 3585750400, 3585753087, 'FR', 'FRA', 'فرنسا'),
(100103, 3585753088, 3585761279, 'PL', 'POL', 'بولندا'),
(100104, 3585761280, 3585769471, 'UA', 'UKR', 'أوكرانيا'),
(100105, 3585769472, 3585777663, 'TR', 'TUR', 'تركيا'),
(100106, 3585777664, 3585785855, 'JO', 'JOR', 'الأردن'),
(100107, 3585785856, 3585794047, 'UA', 'UKR', 'أوكرانيا'),
(100108, 3585794048, 3585802239, 'FI', 'FIN', 'فنلندا'),
(100109, 3585802240, 3585810431, 'IT', 'ITA', 'إيطاليا'),
(100110, 3585810432, 3585818623, 'GB', 'GBR', 'المملكة المتحدة'),
(100111, 3585818624, 3585826815, 'DE', 'DEU', 'ألمانيا'),
(100112, 3585826816, 3585835007, 'RU', 'RUS', 'الإتحاد الروسي'),
(100113, 3585835008, 3585835023, 'GB', 'GBR', 'المملكة المتحدة'),
(100114, 3585835024, 3585835039, 'US', 'USA', 'الولايات المتحدة'),
(100115, 3585835040, 3585835071, 'NL', 'NLD', 'هولندا'),
(100116, 3585835072, 3585835263, 'US', 'USA', 'الولايات المتحدة'),
(100117, 3585835264, 3585835395, 'NL', 'NLD', 'هولندا'),
(100118, 3585835396, 3585835399, 'US', 'USA', 'الولايات المتحدة'),
(100119, 3585835400, 3585835423, 'NL', 'NLD', 'هولندا'),
(100120, 3585835424, 3585835519, 'US', 'USA', 'الولايات المتحدة'),
(100121, 3585835520, 3585835583, 'NL', 'NLD', 'هولندا'),
(100122, 3585835584, 3585835647, 'IQ', 'IRQ', 'العراق'),
(100123, 3585835648, 3585835711, 'NL', 'NLD', 'هولندا'),
(100124, 3585835712, 3585835775, 'US', 'USA', 'الولايات المتحدة'),
(100125, 3585835776, 3585835791, 'NL', 'NLD', 'هولندا'),
(100126, 3585835792, 3585835839, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(100127, 3585835840, 3585835847, 'AO', 'AGO', 'أنغولا'),
(100128, 3585835848, 3585835855, 'NL', 'NLD', 'هولندا'),
(100129, 3585835856, 3585835863, 'US', 'USA', 'الولايات المتحدة'),
(100130, 3585835864, 3585835871, 'NL', 'NLD', 'هولندا'),
(100131, 3585835872, 3585835879, 'IQ', 'IRQ', 'العراق'),
(100132, 3585835880, 3585835887, 'NL', 'NLD', 'هولندا'),
(100133, 3585835888, 3585835895, 'US', 'USA', 'الولايات المتحدة'),
(100134, 3585835896, 3585835903, 'IQ', 'IRQ', 'العراق'),
(100135, 3585835904, 3585835911, 'NL', 'NLD', 'هولندا'),
(100136, 3585835912, 3585835919, 'KE', 'KEN', 'كينيا'),
(100137, 3585835920, 3585835927, 'SO', 'SOM', 'الصومال'),
(100138, 3585835928, 3585835935, 'SC', 'SYC', 'سيشيل'),
(100139, 3585835936, 3585835943, 'SD', 'SDN', 'السودان'),
(100140, 3585835944, 3585835951, 'DJ', 'DJI', 'جيبوتي'),
(100141, 3585835952, 3585835959, 'SO', 'SOM', 'الصومال'),
(100142, 3585835960, 3585835967, 'TD', 'TCD', 'تشاد'),
(100143, 3585835968, 3585835983, 'ER', 'ERI', 'إريتريا'),
(100144, 3585835984, 3585836007, 'US', 'USA', 'الولايات المتحدة'),
(100145, 3585836008, 3585836023, 'IQ', 'IRQ', 'العراق'),
(100146, 3585836024, 3585836031, 'US', 'USA', 'الولايات المتحدة'),
(100147, 3585836032, 3585836287, 'NL', 'NLD', 'هولندا'),
(100148, 3585836288, 3585836543, 'SA', 'SAU', 'السعودية'),
(100149, 3585836544, 3585837055, 'DZ', 'DZA', 'الجزائر'),
(100150, 3585837056, 3585837311, 'NG', 'NGA', 'نيجيريا'),
(100151, 3585837312, 3585837439, 'NL', 'NLD', 'هولندا'),
(100152, 3585837440, 3585837567, 'NG', 'NGA', 'نيجيريا'),
(100153, 3585837568, 3585838143, 'AO', 'AGO', 'أنغولا'),
(100154, 3585838144, 3585838207, 'NA', 'NAM', 'ناميبيا'),
(100155, 3585838208, 3585838247, 'US', 'USA', 'الولايات المتحدة'),
(100156, 3585838248, 3585838255, 'AO', 'AGO', 'أنغولا'),
(100157, 3585838256, 3585838271, 'US', 'USA', 'الولايات المتحدة'),
(100158, 3585838272, 3585838279, 'AO', 'AGO', 'أنغولا'),
(100159, 3585838280, 3585838295, 'US', 'USA', 'الولايات المتحدة'),
(100160, 3585838296, 3585838303, 'AO', 'AGO', 'أنغولا'),
(100161, 3585838304, 3585838335, 'US', 'USA', 'الولايات المتحدة'),
(100162, 3585838336, 3585838719, 'NL', 'NLD', 'هولندا'),
(100163, 3585838720, 3585838847, 'NG', 'NGA', 'نيجيريا'),
(100164, 3585838848, 3585838879, 'NL', 'NLD', 'هولندا'),
(100165, 3585838880, 3585838911, 'IQ', 'IRQ', 'العراق'),
(100166, 3585838912, 3585838975, 'NG', 'NGA', 'نيجيريا'),
(100167, 3585838976, 3585839103, 'DZ', 'DZA', 'الجزائر'),
(100168, 3585839104, 3585839615, 'NL', 'NLD', 'هولندا'),
(100169, 3585839616, 3585841151, 'US', 'USA', 'الولايات المتحدة'),
(100170, 3585841152, 3585841663, 'IQ', 'IRQ', 'العراق'),
(100171, 3585841664, 3585841919, 'DZ', 'DZA', 'الجزائر'),
(100172, 3585841920, 3585842175, 'NG', 'NGA', 'نيجيريا'),
(100173, 3585842176, 3585842199, 'IQ', 'IRQ', 'العراق'),
(100174, 3585842200, 3585842207, 'NL', 'NLD', 'هولندا'),
(100175, 3585842208, 3585842687, 'IQ', 'IRQ', 'العراق'),
(100176, 3585842688, 3585842943, 'NL', 'NLD', 'هولندا'),
(100177, 3585842944, 3585843199, 'SE', 'SWE', 'السويد'),
(100178, 3585843200, 3585851391, 'NO', 'NOR', 'النرويج'),
(100179, 3585851392, 3585859583, 'SE', 'SWE', 'السويد'),
(100180, 3585859584, 3585860607, 'RU', 'RUS', 'الإتحاد الروسي'),
(100181, 3585860608, 3585865727, 'DE', 'DEU', 'ألمانيا'),
(100182, 3585865728, 3585867775, 'RU', 'RUS', 'الإتحاد الروسي'),
(100183, 3585867776, 3585875967, 'NO', 'NOR', 'النرويج'),
(100184, 3585875968, 3585884159, 'CH', 'CHE', 'سويسرا'),
(100185, 3585884160, 3585892351, 'IQ', 'IRQ', 'العراق'),
(100186, 3585892352, 3585900543, 'DE', 'DEU', 'ألمانيا'),
(100187, 3585900544, 3585902239, 'NO', 'NOR', 'النرويج'),
(100188, 3585902240, 3585902271, 'GB', 'GBR', 'المملكة المتحدة'),
(100189, 3585902272, 3585902447, 'NO', 'NOR', 'النرويج'),
(100190, 3585902448, 3585902463, 'GB', 'GBR', 'المملكة المتحدة'),
(100191, 3585902464, 3585908735, 'NO', 'NOR', 'النرويج'),
(100192, 3585908736, 3585909759, 'FR', 'FRA', 'فرنسا'),
(100193, 3585909760, 3585910271, 'MQ', 'MTQ', 'مارتينيك'),
(100194, 3585910272, 3585910783, 'FR', 'FRA', 'فرنسا'),
(100195, 3585910784, 3585911039, 'MQ', 'MTQ', 'مارتينيك'),
(100196, 3585911040, 3585911551, 'FR', 'FRA', 'فرنسا'),
(100197, 3585911552, 3585911807, 'GP', 'GLP', 'جوادلوب'),
(100198, 3585911808, 3585912063, 'FR', 'FRA', 'فرنسا'),
(100199, 3585912064, 3585912319, 'GP', 'GLP', 'جوادلوب'),
(100200, 3585912320, 3585912575, 'FR', 'FRA', 'فرنسا'),
(100201, 3585912576, 3585912831, 'GP', 'GLP', 'جوادلوب'),
(100202, 3585912832, 3585916671, 'FR', 'FRA', 'فرنسا'),
(100203, 3585916672, 3585916927, 'MQ', 'MTQ', 'مارتينيك'),
(100204, 3585916928, 3585925119, 'IT', 'ITA', 'إيطاليا'),
(100205, 3585925120, 3585933311, 'CH', 'CHE', 'سويسرا'),
(100206, 3585933312, 3585936127, 'NL', 'NLD', 'هولندا'),
(100207, 3585936128, 3585937407, 'US', 'USA', 'الولايات المتحدة'),
(100208, 3585937408, 3585940479, 'NL', 'NLD', 'هولندا'),
(100209, 3585940480, 3585940735, 'BE', 'BEL', 'بلجيكا'),
(100210, 3585940736, 3585941503, 'NL', 'NLD', 'هولندا'),
(100211, 3585941504, 3585949695, 'PL', 'POL', 'بولندا'),
(100212, 3585949696, 3585957887, 'KW', 'KWT', 'الكويت'),
(100213, 3585957888, 3585966079, 'SE', 'SWE', 'السويد'),
(100214, 3585966080, 3585974271, 'CH', 'CHE', 'سويسرا'),
(100215, 3585974272, 3585982463, 'BE', 'BEL', 'بلجيكا'),
(100216, 3585982464, 3585998847, 'RU', 'RUS', 'الإتحاد الروسي'),
(100217, 3585998848, 3586007039, 'ES', 'ESP', 'إسبانيا'),
(100218, 3586007040, 3586015231, 'LT', 'LTU', 'ليتوانيا'),
(100219, 3586015232, 3586023423, 'FR', 'FRA', 'فرنسا'),
(100220, 3586023424, 3586031615, 'IS', 'ISL', 'أيسلندا'),
(100221, 3586031616, 3586039807, 'IE', 'IRL', 'إيرلندا'),
(100222, 3586039808, 3586047999, 'GB', 'GBR', 'المملكة المتحدة'),
(100223, 3586048000, 3586056191, 'PT', 'PRT', 'البورتوغال'),
(100224, 3586056192, 3586072575, 'RU', 'RUS', 'الإتحاد الروسي'),
(100225, 3586072576, 3586088959, 'DE', 'DEU', 'ألمانيا'),
(100226, 3586088960, 3586097151, 'CZ', 'CZE', 'التشيك'),
(100227, 3586097152, 3586105343, 'HR', 'HRV', 'كرواتيا'),
(100228, 3586105344, 3586105599, 'IE', 'IRL', 'إيرلندا'),
(100229, 3586105600, 3586105727, 'ER', 'ERI', 'إريتريا'),
(100230, 3586105728, 3586113535, 'IE', 'IRL', 'إيرلندا'),
(100231, 3586113536, 3586121727, 'BG', 'BGR', 'بلغاريا'),
(100232, 3586121728, 3586129919, 'IE', 'IRL', 'إيرلندا'),
(100233, 3586129920, 3586146303, 'CZ', 'CZE', 'التشيك'),
(100234, 3586146304, 3586162687, 'PL', 'POL', 'بولندا'),
(100235, 3586162688, 3586179071, 'FI', 'FIN', 'فنلندا'),
(100236, 3586179072, 3586191871, 'ES', 'ESP', 'إسبانيا'),
(100237, 3586191872, 3586191887, 'FR', 'FRA', 'فرنسا'),
(100238, 3586191888, 3586195455, 'ES', 'ESP', 'إسبانيا'),
(100239, 3586211840, 3586220287, 'CH', 'CHE', 'سويسرا'),
(100240, 3586220288, 3586220303, 'FR', 'FRA', 'فرنسا'),
(100241, 3586220304, 3586225295, 'CH', 'CHE', 'سويسرا'),
(100242, 3586225296, 3586225311, 'FR', 'FRA', 'فرنسا'),
(100243, 3586225312, 3586228223, 'CH', 'CHE', 'سويسرا'),
(100244, 3586228224, 3586237695, 'BE', 'BEL', 'بلجيكا'),
(100245, 3586237696, 3586237951, 'NL', 'NLD', 'هولندا'),
(100246, 3586237952, 3586244607, 'BE', 'BEL', 'بلجيكا'),
(100247, 3586244608, 3586244863, 'NL', 'NLD', 'هولندا'),
(100248, 3586244864, 3586246655, 'GB', 'GBR', 'المملكة المتحدة'),
(100249, 3586246656, 3586248703, 'BE', 'BEL', 'بلجيكا'),
(100250, 3586248704, 3586250449, 'NL', 'NLD', 'هولندا'),
(100251, 3586250450, 3586250457, 'BE', 'BEL', 'بلجيكا'),
(100252, 3586250458, 3586252799, 'NL', 'NLD', 'هولندا'),
(100253, 3586252800, 3586254847, 'BE', 'BEL', 'بلجيكا'),
(100254, 3586254848, 3586258943, 'NL', 'NLD', 'هولندا'),
(100255, 3586258944, 3586259455, 'BE', 'BEL', 'بلجيكا'),
(100256, 3586259456, 3586269343, 'NL', 'NLD', 'هولندا'),
(100257, 3586269344, 3586269415, 'ES', 'ESP', 'إسبانيا'),
(100258, 3586269416, 3586269423, 'NL', 'NLD', 'هولندا'),
(100259, 3586269424, 3586269439, 'ES', 'ESP', 'إسبانيا'),
(100260, 3586269440, 3586269471, 'NL', 'NLD', 'هولندا'),
(100261, 3586269472, 3586269487, 'ES', 'ESP', 'إسبانيا'),
(100262, 3586269488, 3586269495, 'NL', 'NLD', 'هولندا'),
(100263, 3586269496, 3586269503, 'ES', 'ESP', 'إسبانيا'),
(100264, 3586269504, 3586269535, 'NL', 'NLD', 'هولندا'),
(100265, 3586269536, 3586269607, 'GB', 'GBR', 'المملكة المتحدة'),
(100266, 3586269608, 3586269695, 'ES', 'ESP', 'إسبانيا'),
(100267, 3586269696, 3586269759, 'NL', 'NLD', 'هولندا'),
(100268, 3586269760, 3586269823, 'ES', 'ESP', 'إسبانيا'),
(100269, 3586269824, 3586269855, 'NL', 'NLD', 'هولندا'),
(100270, 3586269856, 3586269887, 'ES', 'ESP', 'إسبانيا'),
(100271, 3586269888, 3586269951, 'NL', 'NLD', 'هولندا'),
(100272, 3586269952, 3586270079, 'ES', 'ESP', 'إسبانيا'),
(100273, 3586270080, 3586270207, 'NL', 'NLD', 'هولندا'),
(100274, 3586270208, 3586271231, 'ES', 'ESP', 'إسبانيا'),
(100275, 3586271232, 3586271487, 'NL', 'NLD', 'هولندا'),
(100276, 3586271488, 3586271831, 'ES', 'ESP', 'إسبانيا'),
(100277, 3586271832, 3586271839, 'IT', 'ITA', 'إيطاليا'),
(100278, 3586271840, 3586271999, 'ES', 'ESP', 'إسبانيا'),
(100279, 3586272000, 3586272255, 'IT', 'ITA', 'إيطاليا'),
(100280, 3586272256, 3586272383, 'NL', 'NLD', 'هولندا'),
(100281, 3586272384, 3586272767, 'ES', 'ESP', 'إسبانيا'),
(100282, 3586272768, 3586272799, 'NL', 'NLD', 'هولندا'),
(100283, 3586272800, 3586272807, 'IT', 'ITA', 'إيطاليا'),
(100284, 3586272808, 3586272815, 'ES', 'ESP', 'إسبانيا'),
(100285, 3586272816, 3586272831, 'IT', 'ITA', 'إيطاليا'),
(100286, 3586272832, 3586272895, 'NL', 'NLD', 'هولندا'),
(100287, 3586272896, 3586272959, 'IT', 'ITA', 'إيطاليا'),
(100288, 3586272960, 3586272991, 'ES', 'ESP', 'إسبانيا'),
(100289, 3586272992, 3586273023, 'IT', 'ITA', 'إيطاليا'),
(100290, 3586273024, 3586276351, 'NL', 'NLD', 'هولندا'),
(100291, 3586276352, 3586276863, 'ES', 'ESP', 'إسبانيا'),
(100292, 3586276864, 3586277375, 'NL', 'NLD', 'هولندا'),
(100293, 3586277376, 3586293759, 'TR', 'TUR', 'تركيا'),
(100294, 3586293760, 3586310143, 'ES', 'ESP', 'إسبانيا'),
(100295, 3586310144, 3586326527, 'CZ', 'CZE', 'التشيك'),
(100296, 3586326528, 3586342911, 'IR', 'IRN', 'إيران'),
(100297, 3586342912, 3586359295, 'ES', 'ESP', 'إسبانيا'),
(100298, 3586359296, 3586375679, 'PL', 'POL', 'بولندا'),
(100299, 3586375680, 3586392063, 'CZ', 'CZE', 'التشيك'),
(100300, 3586392064, 3586408447, 'NL', 'NLD', 'هولندا'),
(100301, 3586408448, 3586424831, 'BA', 'BIH', 'البوسنه والهرسك'),
(100302, 3586424832, 3586441215, 'CH', 'CHE', 'سويسرا'),
(100303, 3586441216, 3586457599, 'DE', 'DEU', 'ألمانيا'),
(100304, 3586457600, 3586473983, 'NL', 'NLD', 'هولندا'),
(100305, 3586473984, 3586473987, 'SK', 'SVK', 'سلوفاكيا'),
(100306, 3586473988, 3586476287, 'HU', 'HUN', 'هنغاريا'),
(100307, 3586476288, 3586476295, 'SK', 'SVK', 'سلوفاكيا'),
(100308, 3586476296, 3586476311, 'HU', 'HUN', 'هنغاريا'),
(100309, 3586476312, 3586476319, 'AT', 'AUT', 'النمسا'),
(100310, 3586476320, 3586476351, 'HU', 'HUN', 'هنغاريا'),
(100311, 3586476352, 3586476383, 'AT', 'AUT', 'النمسا'),
(100312, 3586476384, 3586476407, 'UA', 'UKR', 'أوكرانيا'),
(100313, 3586476408, 3586478079, 'HU', 'HUN', 'هنغاريا'),
(100314, 3586478080, 3586478591, 'SK', 'SVK', 'سلوفاكيا'),
(100315, 3586478592, 3586490367, 'HU', 'HUN', 'هنغاريا'),
(100316, 3586490368, 3586506751, 'LT', 'LTU', 'ليتوانيا'),
(100317, 3586506752, 3586523135, 'NL', 'NLD', 'هولندا'),
(100318, 3586523136, 3586543519, 'DE', 'DEU', 'ألمانيا'),
(100319, 3586543520, 3586543527, 'GB', 'GBR', 'المملكة المتحدة'),
(100320, 3586543528, 3586543759, 'DE', 'DEU', 'ألمانيا'),
(100321, 3586543760, 3586543791, 'GB', 'GBR', 'المملكة المتحدة'),
(100322, 3586543792, 3586545679, 'DE', 'DEU', 'ألمانيا'),
(100323, 3586545680, 3586545703, 'GB', 'GBR', 'المملكة المتحدة'),
(100324, 3586545704, 3586546375, 'DE', 'DEU', 'ألمانيا'),
(100325, 3586546376, 3586546383, 'GB', 'GBR', 'المملكة المتحدة'),
(100326, 3586546384, 3586555903, 'DE', 'DEU', 'ألمانيا'),
(100327, 3586555904, 3586572287, 'IT', 'ITA', 'إيطاليا'),
(100328, 3586572288, 3586585087, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100329, 3586585088, 3586585119, 'RS', 'SRB', 'صربيا'),
(100330, 3586585120, 3586585127, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100331, 3586585128, 3586585151, 'RS', 'SRB', 'صربيا'),
(100332, 3586585152, 3586585159, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100333, 3586585160, 3586585175, 'RS', 'SRB', 'صربيا'),
(100334, 3586585176, 3586585183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100335, 3586585184, 3586585215, 'RS', 'SRB', 'صربيا'),
(100336, 3586585216, 3586585223, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100337, 3586585224, 3586585263, 'RS', 'SRB', 'صربيا'),
(100338, 3586585264, 3586585279, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100339, 3586585280, 3586585319, 'RS', 'SRB', 'صربيا'),
(100340, 3586585320, 3586585335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100341, 3586585336, 3586585375, 'RS', 'SRB', 'صربيا'),
(100342, 3586585376, 3586585391, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100343, 3586585392, 3586585463, 'RS', 'SRB', 'صربيا'),
(100344, 3586585464, 3586585471, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100345, 3586585472, 3586585479, 'RS', 'SRB', 'صربيا'),
(100346, 3586585480, 3586585487, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100347, 3586585488, 3586585495, 'RS', 'SRB', 'صربيا'),
(100348, 3586585496, 3586585511, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100349, 3586585512, 3586585519, 'RS', 'SRB', 'صربيا'),
(100350, 3586585520, 3586585535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100351, 3586585536, 3586585543, 'RS', 'SRB', 'صربيا'),
(100352, 3586585544, 3586585559, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100353, 3586585560, 3586585583, 'RS', 'SRB', 'صربيا'),
(100354, 3586585584, 3586585591, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100355, 3586585592, 3586585599, 'RS', 'SRB', 'صربيا'),
(100356, 3586585600, 3586585615, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100357, 3586585616, 3586585671, 'RS', 'SRB', 'صربيا'),
(100358, 3586585672, 3586585679, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100359, 3586585680, 3586585687, 'RS', 'SRB', 'صربيا'),
(100360, 3586585688, 3586585703, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100361, 3586585704, 3586585711, 'RS', 'SRB', 'صربيا'),
(100362, 3586585712, 3586585719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100363, 3586585720, 3586585727, 'RS', 'SRB', 'صربيا'),
(100364, 3586585728, 3586585735, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100365, 3586585736, 3586585751, 'RS', 'SRB', 'صربيا'),
(100366, 3586585752, 3586585759, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100367, 3586585760, 3586585847, 'RS', 'SRB', 'صربيا'),
(100368, 3586585848, 3586585863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100369, 3586585864, 3586585879, 'RS', 'SRB', 'صربيا'),
(100370, 3586585880, 3586585895, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100371, 3586585896, 3586585927, 'RS', 'SRB', 'صربيا'),
(100372, 3586585928, 3586585943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100373, 3586585944, 3586585951, 'RS', 'SRB', 'صربيا'),
(100374, 3586585952, 3586585959, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100375, 3586585960, 3586585983, 'RS', 'SRB', 'صربيا'),
(100376, 3586585984, 3586585999, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100377, 3586586000, 3586586007, 'RS', 'SRB', 'صربيا'),
(100378, 3586586008, 3586586111, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100379, 3586586112, 3586586135, 'RS', 'SRB', 'صربيا'),
(100380, 3586586136, 3586586151, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100381, 3586586152, 3586586175, 'RS', 'SRB', 'صربيا'),
(100382, 3586586176, 3586586183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100383, 3586586184, 3586586191, 'RS', 'SRB', 'صربيا'),
(100384, 3586586192, 3586586207, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100385, 3586586208, 3586586255, 'RS', 'SRB', 'صربيا'),
(100386, 3586586256, 3586586263, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100387, 3586586264, 3586586271, 'RS', 'SRB', 'صربيا'),
(100388, 3586586272, 3586588671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(100389, 3586588672, 3586596863, 'IT', 'ITA', 'إيطاليا'),
(100390, 3586596864, 3586605055, 'GB', 'GBR', 'المملكة المتحدة'),
(100391, 3586605056, 3586621439, 'SE', 'SWE', 'السويد'),
(100392, 3586621440, 3586625535, 'IE', 'IRL', 'إيرلندا'),
(100393, 3586625536, 3586629631, 'GB', 'GBR', 'المملكة المتحدة'),
(100394, 3586629632, 3586637823, 'IE', 'IRL', 'إيرلندا'),
(100395, 3586637824, 3586654207, 'PL', 'POL', 'بولندا'),
(100396, 3586654208, 3586662399, 'GE', 'GEO', 'جورجيا'),
(100397, 3586662400, 3586670591, 'UA', 'UKR', 'أوكرانيا'),
(100398, 3586670592, 3586677183, 'DE', 'DEU', 'ألمانيا'),
(100399, 3586677184, 3586677247, 'IE', 'IRL', 'إيرلندا'),
(100400, 3586677248, 3586677311, 'DE', 'DEU', 'ألمانيا'),
(100401, 3586677312, 3586677327, 'IE', 'IRL', 'إيرلندا'),
(100402, 3586677328, 3586677375, 'DE', 'DEU', 'ألمانيا'),
(100403, 3586677376, 3586677487, 'IE', 'IRL', 'إيرلندا'),
(100404, 3586677488, 3586677759, 'DE', 'DEU', 'ألمانيا'),
(100405, 3586677760, 3586678015, 'GR', 'GRC', 'اليونان'),
(100406, 3586678016, 3586678335, 'IE', 'IRL', 'إيرلندا'),
(100407, 3586678336, 3586678399, 'US', 'USA', 'الولايات المتحدة'),
(100408, 3586678400, 3586678415, 'GB', 'GBR', 'المملكة المتحدة'),
(100409, 3586678416, 3586678671, 'IE', 'IRL', 'إيرلندا'),
(100410, 3586678672, 3586678679, 'GB', 'GBR', 'المملكة المتحدة'),
(100411, 3586678680, 3586678687, 'MU', 'MUS', 'موريشيوس'),
(100412, 3586678688, 3586678783, 'GB', 'GBR', 'المملكة المتحدة'),
(100413, 3586678784, 3586679039, 'IT', 'ITA', 'إيطاليا'),
(100414, 3586679040, 3586679103, 'US', 'USA', 'الولايات المتحدة'),
(100415, 3586679104, 3586679167, 'DE', 'DEU', 'ألمانيا'),
(100416, 3586679168, 3586679231, 'US', 'USA', 'الولايات المتحدة'),
(100417, 3586679232, 3586679327, 'IE', 'IRL', 'إيرلندا'),
(100418, 3586679328, 3586679343, 'DK', 'DNK', 'الدنيمارك'),
(100419, 3586679344, 3586679359, 'IE', 'IRL', 'إيرلندا'),
(100420, 3586679360, 3586679423, 'DE', 'DEU', 'ألمانيا'),
(100421, 3586679424, 3586679583, 'IE', 'IRL', 'إيرلندا'),
(100422, 3586679584, 3586679599, 'IT', 'ITA', 'إيطاليا'),
(100423, 3586679600, 3586679647, 'IE', 'IRL', 'إيرلندا'),
(100424, 3586679648, 3586679711, 'IT', 'ITA', 'إيطاليا'),
(100425, 3586679712, 3586679727, 'IE', 'IRL', 'إيرلندا'),
(100426, 3586679728, 3586679743, 'IT', 'ITA', 'إيطاليا'),
(100427, 3586679744, 3586679839, 'IE', 'IRL', 'إيرلندا'),
(100428, 3586679840, 3586679855, 'FR', 'FRA', 'فرنسا'),
(100429, 3586679856, 3586680063, 'IE', 'IRL', 'إيرلندا'),
(100430, 3586680064, 3586680319, 'IT', 'ITA', 'إيطاليا'),
(100431, 3586680320, 3586680447, 'ES', 'ESP', 'إسبانيا'),
(100432, 3586680448, 3586680463, 'IE', 'IRL', 'إيرلندا'),
(100433, 3586680464, 3586680479, 'ES', 'ESP', 'إسبانيا'),
(100434, 3586680480, 3586680511, 'IE', 'IRL', 'إيرلندا'),
(100435, 3586680512, 3586680543, 'ES', 'ESP', 'إسبانيا'),
(100436, 3586680544, 3586680559, 'IE', 'IRL', 'إيرلندا'),
(100437, 3586680560, 3586680575, 'ES', 'ESP', 'إسبانيا'),
(100438, 3586680576, 3586680607, 'IE', 'IRL', 'إيرلندا'),
(100439, 3586680608, 3586680615, 'ES', 'ESP', 'إسبانيا'),
(100440, 3586680616, 3586680767, 'IE', 'IRL', 'إيرلندا'),
(100441, 3586680768, 3586680831, 'ES', 'ESP', 'إسبانيا'),
(100442, 3586680832, 3586680959, 'FR', 'FRA', 'فرنسا'),
(100443, 3586680960, 3586681015, 'IE', 'IRL', 'إيرلندا'),
(100444, 3586681016, 3586681087, 'FR', 'FRA', 'فرنسا'),
(100445, 3586681088, 3586681343, 'IT', 'ITA', 'إيطاليا'),
(100446, 3586681344, 3586681599, 'IE', 'IRL', 'إيرلندا'),
(100447, 3586681600, 3586681615, 'FR', 'FRA', 'فرنسا'),
(100448, 3586681616, 3586681695, 'IE', 'IRL', 'إيرلندا'),
(100449, 3586681696, 3586682111, 'FR', 'FRA', 'فرنسا'),
(100450, 3586682112, 3586682175, 'US', 'USA', 'الولايات المتحدة'),
(100451, 3586682176, 3586682239, 'IE', 'IRL', 'إيرلندا'),
(100452, 3586682240, 3586682367, 'US', 'USA', 'الولايات المتحدة'),
(100453, 3586682368, 3586682399, 'AT', 'AUT', 'النمسا'),
(100454, 3586682400, 3586682431, 'IE', 'IRL', 'إيرلندا'),
(100455, 3586682432, 3586682879, 'FR', 'FRA', 'فرنسا'),
(100456, 3586682880, 3586686975, 'US', 'USA', 'الولايات المتحدة'),
(100457, 3586686976, 3586703359, 'SE', 'SWE', 'السويد'),
(100458, 3586703360, 3586719743, 'CH', 'CHE', 'سويسرا'),
(100459, 3586719744, 3586752511, 'ES', 'ESP', 'إسبانيا'),
(100460, 3586752512, 3586785279, 'NL', 'NLD', 'هولندا'),
(100461, 3586785280, 3586793471, 'RU', 'RUS', 'الإتحاد الروسي'),
(100462, 3586793472, 3586801663, 'CH', 'CHE', 'سويسرا'),
(100463, 3586801664, 3586818047, 'HR', 'HRV', 'كرواتيا'),
(100464, 3586818048, 3586834431, 'IE', 'IRL', 'إيرلندا'),
(100465, 3586834432, 3586850495, 'DE', 'DEU', 'ألمانيا'),
(100466, 3586850496, 3586850511, 'US', 'USA', 'الولايات المتحدة'),
(100467, 3586850512, 3586850543, 'DE', 'DEU', 'ألمانيا'),
(100468, 3586850544, 3586850559, 'GR', 'GRC', 'اليونان'),
(100469, 3586850560, 3586850815, 'DE', 'DEU', 'ألمانيا'),
(100470, 3586850816, 3586867199, 'NO', 'NOR', 'النرويج'),
(100471, 3586867200, 3586883583, 'FR', 'FRA', 'فرنسا'),
(100472, 3586883584, 3586899967, 'IT', 'ITA', 'إيطاليا'),
(100473, 3586899968, 3586900287, 'DE', 'DEU', 'ألمانيا'),
(100474, 3586900288, 3586900351, 'NL', 'NLD', 'هولندا'),
(100475, 3586900352, 3586902271, 'DE', 'DEU', 'ألمانيا'),
(100476, 3586902272, 3586902335, 'CH', 'CHE', 'سويسرا'),
(100477, 3586902336, 3586902411, 'DE', 'DEU', 'ألمانيا'),
(100478, 3586902412, 3586902415, 'CH', 'CHE', 'سويسرا'),
(100479, 3586902416, 3586903263, 'DE', 'DEU', 'ألمانيا'),
(100480, 3586903264, 3586903295, 'CH', 'CHE', 'سويسرا'),
(100481, 3586903296, 3586904223, 'DE', 'DEU', 'ألمانيا'),
(100482, 3586904224, 3586904255, 'CH', 'CHE', 'سويسرا'),
(100483, 3586904256, 3586904319, 'DE', 'DEU', 'ألمانيا'),
(100484, 3586904320, 3586904415, 'CH', 'CHE', 'سويسرا'),
(100485, 3586904416, 3586904831, 'DE', 'DEU', 'ألمانيا'),
(100486, 3586904832, 3586904839, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(100487, 3586904840, 3586905039, 'DE', 'DEU', 'ألمانيا'),
(100488, 3586905040, 3586905055, 'CH', 'CHE', 'سويسرا'),
(100489, 3586905056, 3586905071, 'DE', 'DEU', 'ألمانيا'),
(100490, 3586905072, 3586905079, 'CH', 'CHE', 'سويسرا'),
(100491, 3586905080, 3586905087, 'DE', 'DEU', 'ألمانيا'),
(100492, 3586905088, 3586905119, 'CH', 'CHE', 'سويسرا'),
(100493, 3586905120, 3586905167, 'DE', 'DEU', 'ألمانيا'),
(100494, 3586905168, 3586905199, 'CH', 'CHE', 'سويسرا'),
(100495, 3586905200, 3586905215, 'GB', 'GBR', 'المملكة المتحدة'),
(100496, 3586905216, 3586905247, 'DE', 'DEU', 'ألمانيا'),
(100497, 3586905248, 3586905279, 'CH', 'CHE', 'سويسرا'),
(100498, 3586905280, 3586905287, 'DE', 'DEU', 'ألمانيا'),
(100499, 3586905288, 3586905295, 'CY', 'CYP', 'قبرص'),
(100500, 3586905296, 3586906391, 'DE', 'DEU', 'ألمانيا'),
(100501, 3586906392, 3586906399, 'CH', 'CHE', 'سويسرا'),
(100502, 3586906400, 3586906423, 'DE', 'DEU', 'ألمانيا'),
(100503, 3586906424, 3586906427, 'CH', 'CHE', 'سويسرا'),
(100504, 3586906428, 3586906719, 'DE', 'DEU', 'ألمانيا'),
(100505, 3586906720, 3586906735, 'CH', 'CHE', 'سويسرا'),
(100506, 3586906736, 3586907903, 'DE', 'DEU', 'ألمانيا'),
(100507, 3586907904, 3586908031, 'CH', 'CHE', 'سويسرا'),
(100508, 3586908032, 3586909695, 'DE', 'DEU', 'ألمانيا'),
(100509, 3586909696, 3586909823, 'CH', 'CHE', 'سويسرا'),
(100510, 3586909824, 3586910559, 'DE', 'DEU', 'ألمانيا'),
(100511, 3586910560, 3586910567, 'NL', 'NLD', 'هولندا'),
(100512, 3586910568, 3586910575, 'CY', 'CYP', 'قبرص'),
(100513, 3586910576, 3586910587, 'NL', 'NLD', 'هولندا'),
(100514, 3586910588, 3586910655, 'DE', 'DEU', 'ألمانيا'),
(100515, 3586910656, 3586910703, 'NL', 'NLD', 'هولندا'),
(100516, 3586910704, 3586910711, 'DE', 'DEU', 'ألمانيا'),
(100517, 3586910712, 3586910719, 'NL', 'NLD', 'هولندا'),
(100518, 3586910720, 3586910991, 'DE', 'DEU', 'ألمانيا'),
(100519, 3586910992, 3586911007, 'BE', 'BEL', 'بلجيكا'),
(100520, 3586911008, 3586911039, 'DE', 'DEU', 'ألمانيا'),
(100521, 3586911040, 3586911103, 'GB', 'GBR', 'المملكة المتحدة'),
(100522, 3586911104, 3586911167, 'NL', 'NLD', 'هولندا'),
(100523, 3586911168, 3586911191, 'DE', 'DEU', 'ألمانيا'),
(100524, 3586911192, 3586911195, 'BE', 'BEL', 'بلجيكا'),
(100525, 3586911196, 3586912511, 'DE', 'DEU', 'ألمانيا'),
(100526, 3586912512, 3586912575, 'FR', 'FRA', 'فرنسا'),
(100527, 3586912576, 3586912647, 'DE', 'DEU', 'ألمانيا'),
(100528, 3586912648, 3586912651, 'FR', 'FRA', 'فرنسا'),
(100529, 3586912652, 3586916351, 'DE', 'DEU', 'ألمانيا'),
(100530, 3586916352, 3586924031, 'IT', 'ITA', 'إيطاليا'),
(100531, 3586924032, 3586924047, 'US', 'USA', 'الولايات المتحدة'),
(100532, 3586924048, 3586924543, 'IT', 'ITA', 'إيطاليا'),
(100533, 3586924544, 3586924743, 'FI', 'FIN', 'فنلندا'),
(100534, 3586924744, 3586924751, 'AX', 'FIN', 'فنلندا'),
(100535, 3586924752, 3586924767, 'FI', 'FIN', 'فنلندا'),
(100536, 3586924768, 3586924799, 'AX', 'FIN', 'فنلندا'),
(100537, 3586924800, 3586924871, 'FI', 'FIN', 'فنلندا'),
(100538, 3586924872, 3586924879, 'AX', 'FIN', 'فنلندا'),
(100539, 3586924880, 3586924919, 'FI', 'FIN', 'فنلندا'),
(100540, 3586924920, 3586924927, 'AX', 'FIN', 'فنلندا'),
(100541, 3586924928, 3586924943, 'FI', 'FIN', 'فنلندا'),
(100542, 3586924944, 3586924959, 'AX', 'FIN', 'فنلندا'),
(100543, 3586924960, 3586924983, 'FI', 'FIN', 'فنلندا'),
(100544, 3586924984, 3586925055, 'AX', 'FIN', 'فنلندا'),
(100545, 3586925056, 3586925103, 'FI', 'FIN', 'فنلندا'),
(100546, 3586925104, 3586925135, 'AX', 'FIN', 'فنلندا'),
(100547, 3586925136, 3586925471, 'FI', 'FIN', 'فنلندا'),
(100548, 3586925472, 3586925503, 'AX', 'FIN', 'فنلندا'),
(100549, 3586925504, 3586925535, 'FI', 'FIN', 'فنلندا'),
(100550, 3586925536, 3586925567, 'AX', 'FIN', 'فنلندا'),
(100551, 3586925568, 3586925695, 'FI', 'FIN', 'فنلندا'),
(100552, 3586925696, 3586925759, 'AX', 'FIN', 'فنلندا'),
(100553, 3586925760, 3586925791, 'FI', 'FIN', 'فنلندا'),
(100554, 3586925792, 3586925823, 'AX', 'FIN', 'فنلندا'),
(100555, 3586925824, 3586925831, 'FI', 'FIN', 'فنلندا'),
(100556, 3586925832, 3586925855, 'AX', 'FIN', 'فنلندا'),
(100557, 3586925856, 3586925887, 'FI', 'FIN', 'فنلندا'),
(100558, 3586925888, 3586925919, 'AX', 'FIN', 'فنلندا'),
(100559, 3586925920, 3586925983, 'FI', 'FIN', 'فنلندا'),
(100560, 3586925984, 3586926003, 'AX', 'FIN', 'فنلندا'),
(100561, 3586926004, 3586926015, 'FI', 'FIN', 'فنلندا'),
(100562, 3586926016, 3586926047, 'AX', 'FIN', 'فنلندا'),
(100563, 3586926048, 3586926079, 'FI', 'FIN', 'فنلندا'),
(100564, 3586926080, 3586926591, 'AX', 'FIN', 'فنلندا'),
(100565, 3586926592, 3586926847, 'SE', 'SWE', 'السويد'),
(100566, 3586926848, 3586927103, 'FI', 'FIN', 'فنلندا'),
(100567, 3586927104, 3586927999, 'AX', 'FIN', 'فنلندا'),
(100568, 3586928000, 3586928159, 'FI', 'FIN', 'فنلندا'),
(100569, 3586928160, 3586928175, 'AX', 'FIN', 'فنلندا'),
(100570, 3586928176, 3586928303, 'FI', 'FIN', 'فنلندا'),
(100571, 3586928304, 3586928319, 'AX', 'FIN', 'فنلندا'),
(100572, 3586928320, 3586928639, 'FI', 'FIN', 'فنلندا'),
(100573, 3586928640, 3586932735, 'AX', 'FIN', 'فنلندا'),
(100574, 3586932736, 3586949119, 'LB', 'LBN', 'لبنان'),
(100575, 3586949120, 3586965503, 'SE', 'SWE', 'السويد'),
(100576, 3586965504, 3586981887, 'NL', 'NLD', 'هولندا'),
(100577, 3586981888, 3586998271, 'IT', 'ITA', 'إيطاليا'),
(100578, 3586998272, 3587006463, 'PT', 'PRT', 'البورتوغال'),
(100579, 3587006464, 3587014655, 'FR', 'FRA', 'فرنسا'),
(100580, 3587014656, 3587051007, 'GB', 'GBR', 'المملكة المتحدة'),
(100581, 3587051008, 3587051775, 'DE', 'DEU', 'ألمانيا'),
(100582, 3587051776, 3587052031, 'GB', 'GBR', 'المملكة المتحدة'),
(100583, 3587052032, 3587052799, 'NL', 'NLD', 'هولندا'),
(100584, 3587052800, 3587053055, 'GB', 'GBR', 'المملكة المتحدة'),
(100585, 3587053056, 3587053823, 'FR', 'FRA', 'فرنسا'),
(100586, 3587053824, 3587055615, 'GB', 'GBR', 'المملكة المتحدة'),
(100587, 3587055616, 3587063807, 'UZ', 'UZB', 'أوزباكستان'),
(100588, 3587063808, 3587071583, 'NL', 'NLD', 'هولندا'),
(100589, 3587071584, 3587071599, 'BE', 'BEL', 'بلجيكا'),
(100590, 3587071600, 3587071615, 'NL', 'NLD', 'هولندا'),
(100591, 3587071616, 3587071631, 'DE', 'DEU', 'ألمانيا'),
(100592, 3587071632, 3587072095, 'NL', 'NLD', 'هولندا'),
(100593, 3587072096, 3587072127, 'DE', 'DEU', 'ألمانيا'),
(100594, 3587072128, 3587074415, 'NL', 'NLD', 'هولندا'),
(100595, 3587074416, 3587074431, 'BE', 'BEL', 'بلجيكا'),
(100596, 3587074432, 3587080191, 'NL', 'NLD', 'هولندا'),
(100597, 3587080192, 3587082367, 'GB', 'GBR', 'المملكة المتحدة'),
(100598, 3587082368, 3587082431, 'US', 'USA', 'الولايات المتحدة'),
(100599, 3587082432, 3587088383, 'GB', 'GBR', 'المملكة المتحدة'),
(100600, 3587088384, 3587096575, 'DE', 'DEU', 'ألمانيا'),
(100601, 3587096576, 3587121151, 'NL', 'NLD', 'هولندا'),
(100602, 3587121152, 3587129343, 'AL', 'ALB', 'ألبانيا'),
(100603, 3587129344, 3587134463, 'NL', 'NLD', 'هولندا'),
(100604, 3587134464, 3587134591, 'ES', 'ESP', 'إسبانيا'),
(100605, 3587134592, 3587145727, 'NL', 'NLD', 'هولندا'),
(100606, 3587145728, 3587162111, 'CY', 'CYP', 'قبرص'),
(100607, 3587162112, 3587178495, 'IR', 'IRN', 'إيران'),
(100608, 3587178496, 3587178795, 'AT', 'AUT', 'النمسا'),
(100609, 3587178796, 3587178799, 'US', 'USA', 'الولايات المتحدة'),
(100610, 3587178800, 3587179279, 'AT', 'AUT', 'النمسا'),
(100611, 3587179280, 3587179287, 'AU', 'AUS', 'أستراليا'),
(100612, 3587179288, 3587179439, 'AT', 'AUT', 'النمسا'),
(100613, 3587179440, 3587179455, 'GB', 'GBR', 'المملكة المتحدة'),
(100614, 3587179456, 3587179463, 'TR', 'TUR', 'تركيا'),
(100615, 3587179464, 3587179471, 'CH', 'CHE', 'سويسرا'),
(100616, 3587179472, 3587186687, 'AT', 'AUT', 'النمسا'),
(100617, 3587186688, 3587194495, 'DE', 'DEU', 'ألمانيا'),
(100618, 3587194496, 3587194511, 'RU', 'RUS', 'الإتحاد الروسي'),
(100619, 3587194512, 3587194879, 'DE', 'DEU', 'ألمانيا'),
(100620, 3587194880, 3587211263, 'GB', 'GBR', 'المملكة المتحدة'),
(100621, 3587211264, 3587211531, 'AT', 'AUT', 'النمسا'),
(100622, 3587211532, 3587211535, 'DE', 'DEU', 'ألمانيا'),
(100623, 3587211536, 3587211663, 'AT', 'AUT', 'النمسا'),
(100624, 3587211664, 3587211671, 'IT', 'ITA', 'إيطاليا'),
(100625, 3587211672, 3587213911, 'AT', 'AUT', 'النمسا'),
(100626, 3587213912, 3587213919, 'UY', 'URY', 'الأوروغواي'),
(100627, 3587213920, 3587219455, 'AT', 'AUT', 'النمسا'),
(100628, 3587219456, 3587227647, 'RU', 'RUS', 'الإتحاد الروسي'),
(100629, 3587227648, 3587227655, 'NL', 'NLD', 'هولندا'),
(100630, 3587227656, 3587227663, 'GB', 'GBR', 'المملكة المتحدة'),
(100631, 3587227664, 3587227679, 'NL', 'NLD', 'هولندا'),
(100632, 3587227680, 3587227759, 'GB', 'GBR', 'المملكة المتحدة'),
(100633, 3587227760, 3587227791, 'NL', 'NLD', 'هولندا'),
(100634, 3587227792, 3587227807, 'GB', 'GBR', 'المملكة المتحدة'),
(100635, 3587227808, 3587227823, 'NL', 'NLD', 'هولندا'),
(100636, 3587227824, 3587227871, 'GB', 'GBR', 'المملكة المتحدة'),
(100637, 3587227872, 3587227887, 'NL', 'NLD', 'هولندا'),
(100638, 3587227888, 3587227919, 'GB', 'GBR', 'المملكة المتحدة'),
(100639, 3587227920, 3587227935, 'NL', 'NLD', 'هولندا'),
(100640, 3587227936, 3587227967, 'GB', 'GBR', 'المملكة المتحدة'),
(100641, 3587227968, 3587227983, 'DE', 'DEU', 'ألمانيا'),
(100642, 3587227984, 3587228015, 'NL', 'NLD', 'هولندا'),
(100643, 3587228016, 3587228047, 'GB', 'GBR', 'المملكة المتحدة'),
(100644, 3587228048, 3587228087, 'NL', 'NLD', 'هولندا'),
(100645, 3587228088, 3587228127, 'GB', 'GBR', 'المملكة المتحدة'),
(100646, 3587228128, 3587228207, 'NL', 'NLD', 'هولندا'),
(100647, 3587228208, 3587228223, 'GB', 'GBR', 'المملكة المتحدة'),
(100648, 3587228224, 3587228239, 'NL', 'NLD', 'هولندا'),
(100649, 3587228240, 3587228255, 'GB', 'GBR', 'المملكة المتحدة'),
(100650, 3587228256, 3587228271, 'NL', 'NLD', 'هولندا'),
(100651, 3587228272, 3587228287, 'GB', 'GBR', 'المملكة المتحدة'),
(100652, 3587228288, 3587228319, 'NL', 'NLD', 'هولندا'),
(100653, 3587228320, 3587228335, 'GB', 'GBR', 'المملكة المتحدة'),
(100654, 3587228336, 3587228367, 'NL', 'NLD', 'هولندا'),
(100655, 3587228368, 3587228447, 'GB', 'GBR', 'المملكة المتحدة'),
(100656, 3587228448, 3587228463, 'NL', 'NLD', 'هولندا'),
(100657, 3587228464, 3587228647, 'GB', 'GBR', 'المملكة المتحدة'),
(100658, 3587228648, 3587228663, 'NL', 'NLD', 'هولندا'),
(100659, 3587228664, 3587228667, 'GB', 'GBR', 'المملكة المتحدة'),
(100660, 3587228668, 3587228927, 'NL', 'NLD', 'هولندا'),
(100661, 3587228928, 3587229455, 'GB', 'GBR', 'المملكة المتحدة'),
(100662, 3587229456, 3587229487, 'NL', 'NLD', 'هولندا'),
(100663, 3587229488, 3587229535, 'GB', 'GBR', 'المملكة المتحدة'),
(100664, 3587229536, 3587229583, 'NL', 'NLD', 'هولندا'),
(100665, 3587229584, 3587229647, 'GB', 'GBR', 'المملكة المتحدة'),
(100666, 3587229648, 3587229663, 'NL', 'NLD', 'هولندا'),
(100667, 3587229664, 3587229791, 'GB', 'GBR', 'المملكة المتحدة'),
(100668, 3587229792, 3587229807, 'NL', 'NLD', 'هولندا'),
(100669, 3587229808, 3587229855, 'GB', 'GBR', 'المملكة المتحدة'),
(100670, 3587229856, 3587229887, 'NL', 'NLD', 'هولندا'),
(100671, 3587229888, 3587229951, 'GB', 'GBR', 'المملكة المتحدة'),
(100672, 3587229952, 3587229967, 'NL', 'NLD', 'هولندا'),
(100673, 3587229968, 3587230047, 'GB', 'GBR', 'المملكة المتحدة'),
(100674, 3587230048, 3587230079, 'NL', 'NLD', 'هولندا'),
(100675, 3587230080, 3587230095, 'GB', 'GBR', 'المملكة المتحدة'),
(100676, 3587230096, 3587230111, 'NL', 'NLD', 'هولندا'),
(100677, 3587230112, 3587230239, 'GB', 'GBR', 'المملكة المتحدة'),
(100678, 3587230240, 3587230271, 'NL', 'NLD', 'هولندا'),
(100679, 3587230272, 3587230319, 'GB', 'GBR', 'المملكة المتحدة'),
(100680, 3587230320, 3587230351, 'NL', 'NLD', 'هولندا'),
(100681, 3587230352, 3587230447, 'GB', 'GBR', 'المملكة المتحدة'),
(100682, 3587230448, 3587230463, 'NL', 'NLD', 'هولندا'),
(100683, 3587230464, 3587230511, 'GB', 'GBR', 'المملكة المتحدة'),
(100684, 3587230512, 3587230519, 'NL', 'NLD', 'هولندا'),
(100685, 3587230520, 3587230527, 'GB', 'GBR', 'المملكة المتحدة'),
(100686, 3587230528, 3587230543, 'NL', 'NLD', 'هولندا'),
(100687, 3587230544, 3587230607, 'GB', 'GBR', 'المملكة المتحدة'),
(100688, 3587230608, 3587230623, 'NL', 'NLD', 'هولندا'),
(100689, 3587230624, 3587230687, 'GB', 'GBR', 'المملكة المتحدة'),
(100690, 3587230688, 3587230719, 'NL', 'NLD', 'هولندا'),
(100691, 3587230720, 3587230791, 'GB', 'GBR', 'المملكة المتحدة'),
(100692, 3587230792, 3587230799, 'NL', 'NLD', 'هولندا'),
(100693, 3587230800, 3587230807, 'GB', 'GBR', 'المملكة المتحدة'),
(100694, 3587230808, 3587230815, 'NL', 'NLD', 'هولندا'),
(100695, 3587230816, 3587230847, 'GB', 'GBR', 'المملكة المتحدة'),
(100696, 3587230848, 3587230911, 'NL', 'NLD', 'هولندا'),
(100697, 3587230912, 3587230943, 'GB', 'GBR', 'المملكة المتحدة'),
(100698, 3587230944, 3587230967, 'DE', 'DEU', 'ألمانيا'),
(100699, 3587230968, 3587230991, 'NL', 'NLD', 'هولندا'),
(100700, 3587230992, 3587231295, 'GB', 'GBR', 'المملكة المتحدة'),
(100701, 3587231296, 3587231327, 'NL', 'NLD', 'هولندا'),
(100702, 3587231328, 3587231359, 'GB', 'GBR', 'المملكة المتحدة'),
(100703, 3587231360, 3587232255, 'NL', 'NLD', 'هولندا'),
(100704, 3587232256, 3587232415, 'GB', 'GBR', 'المملكة المتحدة'),
(100705, 3587232416, 3587232439, 'NL', 'NLD', 'هولندا'),
(100706, 3587232440, 3587232511, 'GB', 'GBR', 'المملكة المتحدة'),
(100707, 3587232512, 3587232535, 'NL', 'NLD', 'هولندا'),
(100708, 3587232536, 3587232711, 'GB', 'GBR', 'المملكة المتحدة'),
(100709, 3587232712, 3587232719, 'NL', 'NLD', 'هولندا'),
(100710, 3587232720, 3587232767, 'GB', 'GBR', 'المملكة المتحدة'),
(100711, 3587232768, 3587232831, 'NL', 'NLD', 'هولندا'),
(100712, 3587232832, 3587232847, 'GB', 'GBR', 'المملكة المتحدة'),
(100713, 3587232848, 3587232863, 'NL', 'NLD', 'هولندا'),
(100714, 3587232864, 3587232879, 'GB', 'GBR', 'المملكة المتحدة'),
(100715, 3587232880, 3587232895, 'NL', 'NLD', 'هولندا'),
(100716, 3587232896, 3587232911, 'GB', 'GBR', 'المملكة المتحدة'),
(100717, 3587232912, 3587232927, 'NL', 'NLD', 'هولندا'),
(100718, 3587232928, 3587232967, 'GB', 'GBR', 'المملكة المتحدة'),
(100719, 3587232968, 3587232975, 'NL', 'NLD', 'هولندا'),
(100720, 3587232976, 3587232991, 'GB', 'GBR', 'المملكة المتحدة'),
(100721, 3587232992, 3587233007, 'NL', 'NLD', 'هولندا'),
(100722, 3587233008, 3587233023, 'GB', 'GBR', 'المملكة المتحدة'),
(100723, 3587233024, 3587233095, 'NL', 'NLD', 'هولندا'),
(100724, 3587233096, 3587233103, 'GB', 'GBR', 'المملكة المتحدة'),
(100725, 3587233104, 3587233119, 'NL', 'NLD', 'هولندا'),
(100726, 3587233120, 3587233151, 'GB', 'GBR', 'المملكة المتحدة'),
(100727, 3587233152, 3587233175, 'NL', 'NLD', 'هولندا'),
(100728, 3587233176, 3587233199, 'GB', 'GBR', 'المملكة المتحدة'),
(100729, 3587233200, 3587233215, 'NL', 'NLD', 'هولندا'),
(100730, 3587233216, 3587233231, 'GB', 'GBR', 'المملكة المتحدة'),
(100731, 3587233232, 3587233295, 'NL', 'NLD', 'هولندا'),
(100732, 3587233296, 3587233311, 'GB', 'GBR', 'المملكة المتحدة'),
(100733, 3587233312, 3587233343, 'NL', 'NLD', 'هولندا'),
(100734, 3587233344, 3587233359, 'GB', 'GBR', 'المملكة المتحدة'),
(100735, 3587233360, 3587233407, 'NL', 'NLD', 'هولندا'),
(100736, 3587233408, 3587233471, 'GB', 'GBR', 'المملكة المتحدة'),
(100737, 3587233472, 3587233519, 'NL', 'NLD', 'هولندا'),
(100738, 3587233520, 3587233535, 'GB', 'GBR', 'المملكة المتحدة'),
(100739, 3587233536, 3587233543, 'NL', 'NLD', 'هولندا'),
(100740, 3587233544, 3587233599, 'GB', 'GBR', 'المملكة المتحدة'),
(100741, 3587233600, 3587233807, 'NL', 'NLD', 'هولندا'),
(100742, 3587233808, 3587233823, 'GB', 'GBR', 'المملكة المتحدة'),
(100743, 3587233824, 3587233839, 'NL', 'NLD', 'هولندا'),
(100744, 3587233840, 3587233903, 'GB', 'GBR', 'المملكة المتحدة'),
(100745, 3587233904, 3587233935, 'NL', 'NLD', 'هولندا'),
(100746, 3587233936, 3587233951, 'GB', 'GBR', 'المملكة المتحدة'),
(100747, 3587233952, 3587233967, 'NL', 'NLD', 'هولندا'),
(100748, 3587233968, 3587233983, 'GB', 'GBR', 'المملكة المتحدة'),
(100749, 3587233984, 3587233999, 'NL', 'NLD', 'هولندا'),
(100750, 3587234000, 3587234015, 'GB', 'GBR', 'المملكة المتحدة'),
(100751, 3587234016, 3587234031, 'NL', 'NLD', 'هولندا'),
(100752, 3587234032, 3587234047, 'GB', 'GBR', 'المملكة المتحدة'),
(100753, 3587234048, 3587234079, 'NL', 'NLD', 'هولندا'),
(100754, 3587234080, 3587234095, 'GB', 'GBR', 'المملكة المتحدة'),
(100755, 3587234096, 3587234143, 'NL', 'NLD', 'هولندا'),
(100756, 3587234144, 3587234159, 'GB', 'GBR', 'المملكة المتحدة'),
(100757, 3587234160, 3587234207, 'NL', 'NLD', 'هولندا'),
(100758, 3587234208, 3587234815, 'GB', 'GBR', 'المملكة المتحدة'),
(100759, 3587234816, 3587236227, 'NL', 'NLD', 'هولندا'),
(100760, 3587236228, 3587236231, 'BE', 'BEL', 'بلجيكا'),
(100761, 3587236232, 3587236471, 'NL', 'NLD', 'هولندا'),
(100762, 3587236472, 3587236479, 'GB', 'GBR', 'المملكة المتحدة'),
(100763, 3587236480, 3587236511, 'NL', 'NLD', 'هولندا'),
(100764, 3587236512, 3587236543, 'GB', 'GBR', 'المملكة المتحدة'),
(100765, 3587236544, 3587236607, 'NL', 'NLD', 'هولندا'),
(100766, 3587236608, 3587236863, 'GB', 'GBR', 'المملكة المتحدة'),
(100767, 3587236864, 3587237375, 'NL', 'NLD', 'هولندا'),
(100768, 3587237376, 3587237391, 'GB', 'GBR', 'المملكة المتحدة'),
(100769, 3587237392, 3587237399, 'NL', 'NLD', 'هولندا'),
(100770, 3587237400, 3587237407, 'GB', 'GBR', 'المملكة المتحدة'),
(100771, 3587237408, 3587237439, 'NL', 'NLD', 'هولندا'),
(100772, 3587237440, 3587237447, 'GB', 'GBR', 'المملكة المتحدة'),
(100773, 3587237448, 3587237471, 'NL', 'NLD', 'هولندا'),
(100774, 3587237472, 3587237487, 'GB', 'GBR', 'المملكة المتحدة'),
(100775, 3587237488, 3587237495, 'NL', 'NLD', 'هولندا'),
(100776, 3587237496, 3587237519, 'GB', 'GBR', 'المملكة المتحدة'),
(100777, 3587237520, 3587237567, 'NL', 'NLD', 'هولندا'),
(100778, 3587237568, 3587237887, 'GB', 'GBR', 'المملكة المتحدة'),
(100779, 3587237888, 3587238535, 'NL', 'NLD', 'هولندا'),
(100780, 3587238536, 3587238543, 'GB', 'GBR', 'المملكة المتحدة'),
(100781, 3587238544, 3587238607, 'NL', 'NLD', 'هولندا'),
(100782, 3587238608, 3587238911, 'GB', 'GBR', 'المملكة المتحدة'),
(100783, 3587238912, 3587239295, 'NL', 'NLD', 'هولندا'),
(100784, 3587239296, 3587239311, 'GB', 'GBR', 'المملكة المتحدة'),
(100785, 3587239312, 3587239735, 'NL', 'NLD', 'هولندا'),
(100786, 3587239736, 3587239743, 'GB', 'GBR', 'المملكة المتحدة'),
(100787, 3587239744, 3587239759, 'NL', 'NLD', 'هولندا'),
(100788, 3587239760, 3587239935, 'GB', 'GBR', 'المملكة المتحدة'),
(100789, 3587239936, 3587240055, 'NL', 'NLD', 'هولندا'),
(100790, 3587240056, 3587240063, 'GB', 'GBR', 'المملكة المتحدة'),
(100791, 3587240064, 3587240103, 'NL', 'NLD', 'هولندا'),
(100792, 3587240104, 3587240107, 'GB', 'GBR', 'المملكة المتحدة'),
(100793, 3587240108, 3587240111, 'NL', 'NLD', 'هولندا'),
(100794, 3587240112, 3587240119, 'GB', 'GBR', 'المملكة المتحدة'),
(100795, 3587240120, 3587240431, 'NL', 'NLD', 'هولندا'),
(100796, 3587240432, 3587240439, 'GB', 'GBR', 'المملكة المتحدة'),
(100797, 3587240440, 3587240511, 'NL', 'NLD', 'هولندا'),
(100798, 3587240512, 3587240575, 'GB', 'GBR', 'المملكة المتحدة'),
(100799, 3587240576, 3587240615, 'NL', 'NLD', 'هولندا'),
(100800, 3587240616, 3587240623, 'GB', 'GBR', 'المملكة المتحدة'),
(100801, 3587240624, 3587240639, 'NL', 'NLD', 'هولندا'),
(100802, 3587240640, 3587240703, 'GB', 'GBR', 'المملكة المتحدة'),
(100803, 3587240704, 3587241015, 'NL', 'NLD', 'هولندا'),
(100804, 3587241016, 3587241031, 'GB', 'GBR', 'المملكة المتحدة'),
(100805, 3587241032, 3587241087, 'NL', 'NLD', 'هولندا'),
(100806, 3587241088, 3587241095, 'GB', 'GBR', 'المملكة المتحدة'),
(100807, 3587241096, 3587241119, 'NL', 'NLD', 'هولندا'),
(100808, 3587241120, 3587241151, 'GB', 'GBR', 'المملكة المتحدة'),
(100809, 3587241152, 3587241215, 'NL', 'NLD', 'هولندا'),
(100810, 3587241216, 3587241279, 'GB', 'GBR', 'المملكة المتحدة'),
(100811, 3587241280, 3587241295, 'NL', 'NLD', 'هولندا'),
(100812, 3587241296, 3587241311, 'GB', 'GBR', 'المملكة المتحدة'),
(100813, 3587241312, 3587241343, 'NL', 'NLD', 'هولندا'),
(100814, 3587241344, 3587241727, 'GB', 'GBR', 'المملكة المتحدة'),
(100815, 3587241728, 3587242063, 'NL', 'NLD', 'هولندا'),
(100816, 3587242064, 3587242071, 'BE', 'BEL', 'بلجيكا'),
(100817, 3587242072, 3587243279, 'NL', 'NLD', 'هولندا'),
(100818, 3587243280, 3587243295, 'GB', 'GBR', 'المملكة المتحدة'),
(100819, 3587243296, 3587243647, 'NL', 'NLD', 'هولندا'),
(100820, 3587243648, 3587243775, 'GB', 'GBR', 'المملكة المتحدة'),
(100821, 3587243776, 3587243935, 'NL', 'NLD', 'هولندا'),
(100822, 3587243936, 3587243943, 'GB', 'GBR', 'المملكة المتحدة'),
(100823, 3587243944, 3587244031, 'NL', 'NLD', 'هولندا'),
(100824, 3587244032, 3587260415, 'IT', 'ITA', 'إيطاليا'),
(100825, 3587260416, 3587284991, 'DE', 'DEU', 'ألمانيا'),
(100826, 3587284992, 3587285135, 'IT', 'ITA', 'إيطاليا'),
(100827, 3587285136, 3587285159, 'HK', 'HKG', 'هونغ كونغ'),
(100828, 3587285160, 3587287043, 'IT', 'ITA', 'إيطاليا'),
(100829, 3587287044, 3587287047, 'LY', 'LBY', 'ليبيا'),
(100830, 3587287048, 3587287055, 'IT', 'ITA', 'إيطاليا'),
(100831, 3587287056, 3587287059, 'LY', 'LBY', 'ليبيا'),
(100832, 3587287060, 3587287295, 'IT', 'ITA', 'إيطاليا'),
(100833, 3587287296, 3587287307, 'GE', 'GEO', 'جورجيا'),
(100834, 3587287308, 3587287311, 'DE', 'DEU', 'ألمانيا'),
(100835, 3587287312, 3587287319, 'GE', 'GEO', 'جورجيا'),
(100836, 3587287320, 3587287327, 'FR', 'FRA', 'فرنسا'),
(100837, 3587287328, 3587287335, 'GB', 'GBR', 'المملكة المتحدة'),
(100838, 3587287336, 3587287339, 'DE', 'DEU', 'ألمانيا'),
(100839, 3587287340, 3587287343, 'PL', 'POL', 'بولندا'),
(100840, 3587287344, 3587287351, 'GE', 'GEO', 'جورجيا'),
(100841, 3587287352, 3587287359, 'IS', 'ISL', 'أيسلندا'),
(100842, 3587287360, 3587287363, 'NL', 'NLD', 'هولندا'),
(100843, 3587287364, 3587287367, 'IT', 'ITA', 'إيطاليا'),
(100844, 3587287368, 3587287387, 'NL', 'NLD', 'هولندا'),
(100845, 3587287388, 3587287391, 'CZ', 'CZE', 'التشيك'),
(100846, 3587287392, 3587287395, 'DE', 'DEU', 'ألمانيا'),
(100847, 3587287396, 3587287403, 'IS', 'ISL', 'أيسلندا'),
(100848, 3587287404, 3587287411, 'PL', 'POL', 'بولندا'),
(100849, 3587287412, 3587287415, 'DE', 'DEU', 'ألمانيا'),
(100850, 3587287416, 3587287419, 'IQ', 'IRQ', 'العراق'),
(100851, 3587287420, 3587287423, 'DE', 'DEU', 'ألمانيا'),
(100852, 3587287424, 3587287427, 'SE', 'SWE', 'السويد'),
(100853, 3587287428, 3587287431, 'DE', 'DEU', 'ألمانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(100854, 3587287432, 3587287435, 'IT', 'ITA', 'إيطاليا'),
(100855, 3587287436, 3587287439, 'DE', 'DEU', 'ألمانيا'),
(100856, 3587287440, 3587287447, 'TR', 'TUR', 'تركيا'),
(100857, 3587287448, 3587287451, 'DE', 'DEU', 'ألمانيا'),
(100858, 3587287452, 3587287455, 'IT', 'ITA', 'إيطاليا'),
(100859, 3587287456, 3587287459, 'DE', 'DEU', 'ألمانيا'),
(100860, 3587287460, 3587287463, 'IT', 'ITA', 'إيطاليا'),
(100861, 3587287464, 3587287475, 'SE', 'SWE', 'السويد'),
(100862, 3587287476, 3587287479, 'PL', 'POL', 'بولندا'),
(100863, 3587287480, 3587287535, 'IT', 'ITA', 'إيطاليا'),
(100864, 3587287536, 3587287543, 'DE', 'DEU', 'ألمانيا'),
(100865, 3587287544, 3587287551, 'PL', 'POL', 'بولندا'),
(100866, 3587287552, 3587287559, 'GB', 'GBR', 'المملكة المتحدة'),
(100867, 3587287560, 3587287563, 'FR', 'FRA', 'فرنسا'),
(100868, 3587287564, 3587287571, 'PL', 'POL', 'بولندا'),
(100869, 3587287572, 3587287575, 'DE', 'DEU', 'ألمانيا'),
(100870, 3587287576, 3587287579, 'FR', 'FRA', 'فرنسا'),
(100871, 3587287580, 3587287583, 'DE', 'DEU', 'ألمانيا'),
(100872, 3587287584, 3587287591, 'FR', 'FRA', 'فرنسا'),
(100873, 3587287592, 3587287599, 'GB', 'GBR', 'المملكة المتحدة'),
(100874, 3587287600, 3587287679, 'IT', 'ITA', 'إيطاليا'),
(100875, 3587287680, 3587287687, 'NL', 'NLD', 'هولندا'),
(100876, 3587287688, 3587287711, 'IS', 'ISL', 'أيسلندا'),
(100877, 3587287712, 3587287719, 'GE', 'GEO', 'جورجيا'),
(100878, 3587287720, 3587287723, 'IT', 'ITA', 'إيطاليا'),
(100879, 3587287724, 3587287727, 'SE', 'SWE', 'السويد'),
(100880, 3587287728, 3587287807, 'IT', 'ITA', 'إيطاليا'),
(100881, 3587287808, 3587287815, 'IS', 'ISL', 'أيسلندا'),
(100882, 3587287816, 3587287823, 'GB', 'GBR', 'المملكة المتحدة'),
(100883, 3587287824, 3587287835, 'FR', 'FRA', 'فرنسا'),
(100884, 3587287836, 3587287847, 'GB', 'GBR', 'المملكة المتحدة'),
(100885, 3587287848, 3587287851, 'SE', 'SWE', 'السويد'),
(100886, 3587287852, 3587287879, 'IQ', 'IRQ', 'العراق'),
(100887, 3587287880, 3587287887, 'FR', 'FRA', 'فرنسا'),
(100888, 3587287888, 3587287935, 'IT', 'ITA', 'إيطاليا'),
(100889, 3587287936, 3587287943, 'FR', 'FRA', 'فرنسا'),
(100890, 3587287944, 3587287947, 'DE', 'DEU', 'ألمانيا'),
(100891, 3587287948, 3587287959, 'IT', 'ITA', 'إيطاليا'),
(100892, 3587287960, 3587287963, 'FR', 'FRA', 'فرنسا'),
(100893, 3587287964, 3587287967, 'GB', 'GBR', 'المملكة المتحدة'),
(100894, 3587287968, 3587287983, 'DE', 'DEU', 'ألمانيا'),
(100895, 3587287984, 3587288575, 'IT', 'ITA', 'إيطاليا'),
(100896, 3587288576, 3587288703, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(100897, 3587288704, 3587288707, 'DE', 'DEU', 'ألمانيا'),
(100898, 3587288708, 3587288759, 'NL', 'NLD', 'هولندا'),
(100899, 3587288760, 3587288959, 'IT', 'ITA', 'إيطاليا'),
(100900, 3587288960, 3587289087, 'DE', 'DEU', 'ألمانيا'),
(100901, 3587289088, 3587289343, 'FR', 'FRA', 'فرنسا'),
(100902, 3587289344, 3587289347, 'ES', 'ESP', 'إسبانيا'),
(100903, 3587289348, 3587289351, 'FR', 'FRA', 'فرنسا'),
(100904, 3587289352, 3587289359, 'PT', 'PRT', 'البورتوغال'),
(100905, 3587289360, 3587289367, 'ES', 'ESP', 'إسبانيا'),
(100906, 3587289368, 3587289375, 'FR', 'FRA', 'فرنسا'),
(100907, 3587289376, 3587289383, 'IT', 'ITA', 'إيطاليا'),
(100908, 3587289384, 3587289387, 'GB', 'GBR', 'المملكة المتحدة'),
(100909, 3587289388, 3587289391, 'ES', 'ESP', 'إسبانيا'),
(100910, 3587289392, 3587289399, 'GB', 'GBR', 'المملكة المتحدة'),
(100911, 3587289400, 3587289407, 'ES', 'ESP', 'إسبانيا'),
(100912, 3587289408, 3587289411, 'IT', 'ITA', 'إيطاليا'),
(100913, 3587289412, 3587289415, 'FR', 'FRA', 'فرنسا'),
(100914, 3587289416, 3587289423, 'IT', 'ITA', 'إيطاليا'),
(100915, 3587289424, 3587289467, 'GB', 'GBR', 'المملكة المتحدة'),
(100916, 3587289468, 3587289855, 'IT', 'ITA', 'إيطاليا'),
(100917, 3587289856, 3587289859, 'FR', 'FRA', 'فرنسا'),
(100918, 3587289860, 3587289863, 'IT', 'ITA', 'إيطاليا'),
(100919, 3587289864, 3587289871, 'GB', 'GBR', 'المملكة المتحدة'),
(100920, 3587289872, 3587289895, 'IT', 'ITA', 'إيطاليا'),
(100921, 3587289896, 3587289907, 'GB', 'GBR', 'المملكة المتحدة'),
(100922, 3587289908, 3587289911, 'ES', 'ESP', 'إسبانيا'),
(100923, 3587289912, 3587289915, 'IT', 'ITA', 'إيطاليا'),
(100924, 3587289916, 3587289919, 'FR', 'FRA', 'فرنسا'),
(100925, 3587289920, 3587290367, 'IT', 'ITA', 'إيطاليا'),
(100926, 3587290368, 3587290622, 'GB', 'GBR', 'المملكة المتحدة'),
(100927, 3587290623, 3587290623, 'IT', 'ITA', 'إيطاليا'),
(100928, 3587290624, 3587291135, 'FR', 'FRA', 'فرنسا'),
(100929, 3587291136, 3587291139, 'NL', 'NLD', 'هولندا'),
(100930, 3587291140, 3587291967, 'IT', 'ITA', 'إيطاليا'),
(100931, 3587291968, 3587292031, 'AL', 'ALB', 'ألبانيا'),
(100932, 3587292032, 3587292415, 'IT', 'ITA', 'إيطاليا'),
(100933, 3587292416, 3587292419, 'ES', 'ESP', 'إسبانيا'),
(100934, 3587292420, 3587292799, 'IT', 'ITA', 'إيطاليا'),
(100935, 3587292800, 3587292863, 'AT', 'AUT', 'النمسا'),
(100936, 3587292864, 3587309567, 'IT', 'ITA', 'إيطاليا'),
(100937, 3587309568, 3587325951, 'GB', 'GBR', 'المملكة المتحدة'),
(100938, 3587325952, 3587342335, 'RU', 'RUS', 'الإتحاد الروسي'),
(100939, 3587342336, 3587358719, 'CZ', 'CZE', 'التشيك'),
(100940, 3587358720, 3587375103, 'SA', 'SAU', 'السعودية'),
(100941, 3587375104, 3587383295, 'TR', 'TUR', 'تركيا'),
(100942, 3587383296, 3587391487, 'CZ', 'CZE', 'التشيك'),
(100943, 3587391488, 3587407871, 'KZ', 'KAZ', 'كازاخستان'),
(100944, 3587407872, 3587424255, 'NL', 'NLD', 'هولندا'),
(100945, 3587424256, 3587440639, 'DE', 'DEU', 'ألمانيا'),
(100946, 3587440640, 3587457023, 'SE', 'SWE', 'السويد'),
(100947, 3587457024, 3587459263, 'GB', 'GBR', 'المملكة المتحدة'),
(100948, 3587459264, 3587459295, 'DE', 'DEU', 'ألمانيا'),
(100949, 3587459296, 3587473407, 'GB', 'GBR', 'المملكة المتحدة'),
(100950, 3587473408, 3587489791, 'IT', 'ITA', 'إيطاليا'),
(100951, 3587506176, 3587538943, 'IT', 'ITA', 'إيطاليا'),
(100952, 3587538944, 3587547135, 'IS', 'ISL', 'أيسلندا'),
(100953, 3587547136, 3587555327, 'CH', 'CHE', 'سويسرا'),
(100954, 3587555328, 3587571711, 'BE', 'BEL', 'بلجيكا'),
(100955, 3587571712, 3587579903, 'DE', 'DEU', 'ألمانيا'),
(100956, 3587579904, 3587588095, 'BE', 'BEL', 'بلجيكا'),
(100957, 3587588096, 3587596287, 'BG', 'BGR', 'بلغاريا'),
(100958, 3587596288, 3587604479, 'NL', 'NLD', 'هولندا'),
(100959, 3587604480, 3587620863, 'FI', 'FIN', 'فنلندا'),
(100960, 3587620864, 3587637247, 'SE', 'SWE', 'السويد'),
(100961, 3587637248, 3587653631, 'FR', 'FRA', 'فرنسا'),
(100962, 3587653632, 3587670015, 'SK', 'SVK', 'سلوفاكيا'),
(100963, 3587670016, 3587686031, 'IT', 'ITA', 'إيطاليا'),
(100964, 3587686032, 3587686039, 'FR', 'FRA', 'فرنسا'),
(100965, 3587686040, 3587687591, 'IT', 'ITA', 'إيطاليا'),
(100966, 3587687592, 3587687599, 'NL', 'NLD', 'هولندا'),
(100967, 3587687600, 3587702783, 'IT', 'ITA', 'إيطاليا'),
(100968, 3587702784, 3587710975, 'DE', 'DEU', 'ألمانيا'),
(100969, 3587710976, 3587719167, 'CZ', 'CZE', 'التشيك'),
(100970, 3587719168, 3587735551, 'PL', 'POL', 'بولندا'),
(100971, 3587735552, 3587751935, 'GB', 'GBR', 'المملكة المتحدة'),
(100972, 3587751936, 3587768319, 'FI', 'FIN', 'فنلندا'),
(100973, 3587768320, 3587776511, 'DE', 'DEU', 'ألمانيا'),
(100974, 3587776512, 3587784703, 'IR', 'IRN', 'إيران'),
(100975, 3587784704, 3587801087, 'DE', 'DEU', 'ألمانيا'),
(100976, 3587801088, 3587817471, 'IT', 'ITA', 'إيطاليا'),
(100977, 3587817472, 3587833855, 'MT', 'MLT', 'مالطا'),
(100978, 3587833856, 3587842047, 'DE', 'DEU', 'ألمانيا'),
(100979, 3587842048, 3587850239, 'IT', 'ITA', 'إيطاليا'),
(100980, 3587850240, 3587854335, 'NL', 'NLD', 'هولندا'),
(100981, 3587854336, 3587866623, 'PL', 'POL', 'بولندا'),
(100982, 3587866624, 3587874815, 'FR', 'FRA', 'فرنسا'),
(100983, 3587874816, 3587877383, 'DE', 'DEU', 'ألمانيا'),
(100984, 3587877384, 3587877391, 'US', 'USA', 'الولايات المتحدة'),
(100985, 3587877392, 3587877407, 'DE', 'DEU', 'ألمانيا'),
(100986, 3587877408, 3587877439, 'NL', 'NLD', 'هولندا'),
(100987, 3587877440, 3587878527, 'DE', 'DEU', 'ألمانيا'),
(100988, 3587878528, 3587878559, 'AT', 'AUT', 'النمسا'),
(100989, 3587878560, 3587883007, 'DE', 'DEU', 'ألمانيا'),
(100990, 3587883008, 3587915775, 'GB', 'GBR', 'المملكة المتحدة'),
(100991, 3587915776, 3587932159, 'EE', 'EST', 'إستونيا'),
(100992, 3587932160, 3587932415, 'NL', 'NLD', 'هولندا'),
(100993, 3587932416, 3587944447, 'BE', 'BEL', 'بلجيكا'),
(100994, 3587944448, 3587945471, 'NL', 'NLD', 'هولندا'),
(100995, 3587945472, 3587948031, 'BE', 'BEL', 'بلجيكا'),
(100996, 3587948032, 3587948543, 'NL', 'NLD', 'هولندا'),
(100997, 3587948544, 3587964927, 'RU', 'RUS', 'الإتحاد الروسي'),
(100998, 3587964928, 3587981311, 'ES', 'ESP', 'إسبانيا'),
(100999, 3587981312, 3587997695, 'IS', 'ISL', 'أيسلندا'),
(101000, 3587997696, 3588014079, 'DE', 'DEU', 'ألمانيا'),
(101001, 3588014080, 3588030463, 'CZ', 'CZE', 'التشيك'),
(101002, 3588030464, 3588046847, 'RU', 'RUS', 'الإتحاد الروسي'),
(101003, 3588046848, 3588060351, 'DE', 'DEU', 'ألمانيا'),
(101004, 3588060352, 3588060359, 'CH', 'CHE', 'سويسرا'),
(101005, 3588060360, 3588063231, 'DE', 'DEU', 'ألمانيا'),
(101006, 3588063232, 3588071423, 'CH', 'CHE', 'سويسرا'),
(101007, 3588071424, 3588079615, 'GB', 'GBR', 'المملكة المتحدة'),
(101008, 3588079616, 3588095999, 'CH', 'CHE', 'سويسرا'),
(101009, 3588096000, 3588104191, 'NL', 'NLD', 'هولندا'),
(101010, 3588104192, 3588112383, 'BG', 'BGR', 'بلغاريا'),
(101011, 3588112384, 3588128767, 'FR', 'FRA', 'فرنسا'),
(101012, 3588128768, 3588145151, 'HU', 'HUN', 'هنغاريا'),
(101013, 3588145152, 3588161535, 'PL', 'POL', 'بولندا'),
(101014, 3588161536, 3588227071, 'FR', 'FRA', 'فرنسا'),
(101015, 3588227072, 3588292607, 'BE', 'BEL', 'بلجيكا'),
(101016, 3588292608, 3588308991, 'AT', 'AUT', 'النمسا'),
(101017, 3588308992, 3588325375, 'NO', 'NOR', 'النرويج'),
(101018, 3588325376, 3588333567, 'GB', 'GBR', 'المملكة المتحدة'),
(101019, 3588333568, 3588341759, 'FR', 'FRA', 'فرنسا'),
(101020, 3588341760, 3588358143, 'IT', 'ITA', 'إيطاليا'),
(101021, 3588358144, 3588374527, 'BG', 'BGR', 'بلغاريا'),
(101022, 3588374528, 3588390911, 'SE', 'SWE', 'السويد'),
(101023, 3588390912, 3588393983, 'LT', 'LTU', 'ليتوانيا'),
(101024, 3588393984, 3588394495, 'LV', 'LVA', 'لاتفيا'),
(101025, 3588394496, 3588407295, 'LT', 'LTU', 'ليتوانيا'),
(101026, 3588407296, 3588423679, 'CZ', 'CZE', 'التشيك'),
(101027, 3588423680, 3588440063, 'ES', 'ESP', 'إسبانيا'),
(101028, 3588440064, 3588456447, 'PL', 'POL', 'بولندا'),
(101029, 3588456448, 3588464639, 'NL', 'NLD', 'هولندا'),
(101030, 3588464640, 3588472831, 'AT', 'AUT', 'النمسا'),
(101031, 3588472832, 3588489215, 'UA', 'UKR', 'أوكرانيا'),
(101032, 3588489216, 3588505599, 'FR', 'FRA', 'فرنسا'),
(101033, 3588505600, 3588521983, 'RU', 'RUS', 'الإتحاد الروسي'),
(101034, 3588521984, 3588538367, 'PT', 'PRT', 'البورتوغال'),
(101035, 3588538368, 3588544383, 'GB', 'GBR', 'المملكة المتحدة'),
(101036, 3588544384, 3588544391, 'IE', 'IRL', 'إيرلندا'),
(101037, 3588544392, 3588547327, 'GB', 'GBR', 'المملكة المتحدة'),
(101038, 3588547328, 3588547583, 'IE', 'IRL', 'إيرلندا'),
(101039, 3588547584, 3588550447, 'GB', 'GBR', 'المملكة المتحدة'),
(101040, 3588550448, 3588550463, 'IE', 'IRL', 'إيرلندا'),
(101041, 3588550464, 3588553983, 'GB', 'GBR', 'المملكة المتحدة'),
(101042, 3588553984, 3588554239, 'IE', 'IRL', 'إيرلندا'),
(101043, 3588554240, 3588554687, 'GB', 'GBR', 'المملكة المتحدة'),
(101044, 3588554688, 3588554751, 'IE', 'IRL', 'إيرلندا'),
(101045, 3588554752, 3588571135, 'AT', 'AUT', 'النمسا'),
(101046, 3588571136, 3588587519, 'GB', 'GBR', 'المملكة المتحدة'),
(101047, 3588587520, 3588590175, 'ES', 'ESP', 'إسبانيا'),
(101048, 3588590176, 3588590207, 'BE', 'BEL', 'بلجيكا'),
(101049, 3588590208, 3588594751, 'ES', 'ESP', 'إسبانيا'),
(101050, 3588594752, 3588594759, 'DE', 'DEU', 'ألمانيا'),
(101051, 3588594760, 3588603903, 'ES', 'ESP', 'إسبانيا'),
(101052, 3588603904, 3588620287, 'SI', 'SVN', 'سلوفينيا'),
(101053, 3588620288, 3588628479, 'SA', 'SAU', 'السعودية'),
(101054, 3588628480, 3588636671, 'CH', 'CHE', 'سويسرا'),
(101055, 3588636672, 3588653055, 'UZ', 'UZB', 'أوزباكستان'),
(101056, 3588653056, 3588661247, 'IT', 'ITA', 'إيطاليا'),
(101057, 3588661248, 3588669439, 'NO', 'NOR', 'النرويج'),
(101058, 3588669440, 3588685823, 'GB', 'GBR', 'المملكة المتحدة'),
(101059, 3588685824, 3588702207, 'UA', 'UKR', 'أوكرانيا'),
(101060, 3588702208, 3588718591, 'ES', 'ESP', 'إسبانيا'),
(101061, 3588718592, 3588734975, 'BG', 'BGR', 'بلغاريا'),
(101062, 3588734976, 3588751359, 'PL', 'POL', 'بولندا'),
(101063, 3588751360, 3588767743, 'TR', 'TUR', 'تركيا'),
(101064, 3588767744, 3588773759, 'GB', 'GBR', 'المملكة المتحدة'),
(101065, 3588773760, 3588773887, 'SL', 'SLE', 'سيراليون'),
(101066, 3588773888, 3588775935, 'GB', 'GBR', 'المملكة المتحدة'),
(101067, 3588775936, 3588776191, 'NG', 'NGA', 'نيجيريا'),
(101068, 3588776192, 3588784127, 'GB', 'GBR', 'المملكة المتحدة'),
(101069, 3588784128, 3588800511, 'CH', 'CHE', 'سويسرا'),
(101070, 3588800512, 3588816895, 'RU', 'RUS', 'الإتحاد الروسي'),
(101071, 3588816896, 3588833279, 'IT', 'ITA', 'إيطاليا'),
(101072, 3588833280, 3588848767, 'RO', 'ROM', 'رومانيا'),
(101073, 3588848768, 3588848775, 'FR', 'FRA', 'فرنسا'),
(101074, 3588848776, 3588849663, 'RO', 'ROM', 'رومانيا'),
(101075, 3588849664, 3588857855, 'IE', 'IRL', 'إيرلندا'),
(101076, 3588857856, 3588866047, 'IR', 'IRN', 'إيران'),
(101077, 3588866048, 3588882431, 'NL', 'NLD', 'هولندا'),
(101078, 3588882432, 3588890623, 'RU', 'RUS', 'الإتحاد الروسي'),
(101079, 3588890624, 3588898815, 'GB', 'GBR', 'المملكة المتحدة'),
(101080, 3588898816, 3588915199, 'NO', 'NOR', 'النرويج'),
(101081, 3588915200, 3588931583, 'IT', 'ITA', 'إيطاليا'),
(101082, 3588931584, 3588947967, 'RU', 'RUS', 'الإتحاد الروسي'),
(101083, 3588947968, 3588964351, 'GB', 'GBR', 'المملكة المتحدة'),
(101084, 3588964352, 3588997119, 'CZ', 'CZE', 'التشيك'),
(101085, 3588997120, 3589013503, 'AT', 'AUT', 'النمسا'),
(101086, 3589013504, 3589021695, 'ES', 'ESP', 'إسبانيا'),
(101087, 3589021696, 3589029887, 'SA', 'SAU', 'السعودية'),
(101088, 3589029888, 3589030015, 'NL', 'NLD', 'هولندا'),
(101089, 3589030016, 3589030143, 'ES', 'ESP', 'إسبانيا'),
(101090, 3589030144, 3589030183, 'NL', 'NLD', 'هولندا'),
(101091, 3589030184, 3589030191, 'FR', 'FRA', 'فرنسا'),
(101092, 3589030192, 3589030207, 'NL', 'NLD', 'هولندا'),
(101093, 3589030208, 3589030239, 'ES', 'ESP', 'إسبانيا'),
(101094, 3589030240, 3589030303, 'NL', 'NLD', 'هولندا'),
(101095, 3589030304, 3589030335, 'FR', 'FRA', 'فرنسا'),
(101096, 3589030336, 3589031423, 'NL', 'NLD', 'هولندا'),
(101097, 3589031424, 3589031935, 'ES', 'ESP', 'إسبانيا'),
(101098, 3589031936, 3589034015, 'NL', 'NLD', 'هولندا'),
(101099, 3589034016, 3589034111, 'ES', 'ESP', 'إسبانيا'),
(101100, 3589034112, 3589034143, 'NL', 'NLD', 'هولندا'),
(101101, 3589034144, 3589034159, 'ES', 'ESP', 'إسبانيا'),
(101102, 3589034160, 3589034167, 'GB', 'GBR', 'المملكة المتحدة'),
(101103, 3589034168, 3589034175, 'NL', 'NLD', 'هولندا'),
(101104, 3589034176, 3589034183, 'ES', 'ESP', 'إسبانيا'),
(101105, 3589034184, 3589034191, 'GB', 'GBR', 'المملكة المتحدة'),
(101106, 3589034192, 3589034207, 'DE', 'DEU', 'ألمانيا'),
(101107, 3589034208, 3589034223, 'ES', 'ESP', 'إسبانيا'),
(101108, 3589034224, 3589034271, 'NL', 'NLD', 'هولندا'),
(101109, 3589034272, 3589034303, 'ES', 'ESP', 'إسبانيا'),
(101110, 3589034304, 3589034335, 'DE', 'DEU', 'ألمانيا'),
(101111, 3589034336, 3589034367, 'FR', 'FRA', 'فرنسا'),
(101112, 3589034368, 3589034431, 'NL', 'NLD', 'هولندا'),
(101113, 3589034432, 3589034495, 'FR', 'FRA', 'فرنسا'),
(101114, 3589034496, 3589037311, 'ES', 'ESP', 'إسبانيا'),
(101115, 3589037312, 3589037343, 'NL', 'NLD', 'هولندا'),
(101116, 3589037344, 3589037375, 'SE', 'SWE', 'السويد'),
(101117, 3589037376, 3589037391, 'NL', 'NLD', 'هولندا'),
(101118, 3589037392, 3589037407, 'ES', 'ESP', 'إسبانيا'),
(101119, 3589037408, 3589037423, 'NL', 'NLD', 'هولندا'),
(101120, 3589037424, 3589037439, 'ES', 'ESP', 'إسبانيا'),
(101121, 3589037440, 3589037487, 'NL', 'NLD', 'هولندا'),
(101122, 3589037488, 3589037495, 'ES', 'ESP', 'إسبانيا'),
(101123, 3589037496, 3589037503, 'CH', 'CHE', 'سويسرا'),
(101124, 3589037504, 3589037535, 'NL', 'NLD', 'هولندا'),
(101125, 3589037536, 3589037551, 'ES', 'ESP', 'إسبانيا'),
(101126, 3589037552, 3589037559, 'BE', 'BEL', 'بلجيكا'),
(101127, 3589037560, 3589037567, 'NL', 'NLD', 'هولندا'),
(101128, 3589037568, 3589038079, 'ES', 'ESP', 'إسبانيا'),
(101129, 3589038080, 3589040127, 'NL', 'NLD', 'هولندا'),
(101130, 3589040128, 3589042207, 'ES', 'ESP', 'إسبانيا'),
(101131, 3589042208, 3589042367, 'NL', 'NLD', 'هولندا'),
(101132, 3589042368, 3589043231, 'ES', 'ESP', 'إسبانيا'),
(101133, 3589043232, 3589043327, 'NL', 'NLD', 'هولندا'),
(101134, 3589043328, 3589043455, 'ES', 'ESP', 'إسبانيا'),
(101135, 3589043456, 3589043711, 'NL', 'NLD', 'هولندا'),
(101136, 3589043712, 3589044223, 'ES', 'ESP', 'إسبانيا'),
(101137, 3589044224, 3589044319, 'NL', 'NLD', 'هولندا'),
(101138, 3589044320, 3589046271, 'ES', 'ESP', 'إسبانيا'),
(101139, 3589046272, 3589079039, 'NO', 'NOR', 'النرويج'),
(101140, 3589079040, 3589092223, 'DK', 'DNK', 'الدنيمارك'),
(101141, 3589092224, 3589092227, 'SE', 'SWE', 'السويد'),
(101142, 3589092228, 3589128191, 'DK', 'DNK', 'الدنيمارك'),
(101143, 3589128192, 3589144575, 'GB', 'GBR', 'المملكة المتحدة'),
(101144, 3589144576, 3589152767, 'UA', 'UKR', 'أوكرانيا'),
(101145, 3589152768, 3589152927, 'DE', 'DEU', 'ألمانيا'),
(101146, 3589152928, 3589152935, 'CH', 'CHE', 'سويسرا'),
(101147, 3589152936, 3589153027, 'DE', 'DEU', 'ألمانيا'),
(101148, 3589153028, 3589153031, 'ES', 'ESP', 'إسبانيا'),
(101149, 3589153032, 3589156591, 'DE', 'DEU', 'ألمانيا'),
(101150, 3589156592, 3589156607, 'CH', 'CHE', 'سويسرا'),
(101151, 3589156608, 3589160959, 'DE', 'DEU', 'ألمانيا'),
(101152, 3589160960, 3589177343, 'PL', 'POL', 'بولندا'),
(101153, 3589177344, 3589193727, 'TR', 'TUR', 'تركيا'),
(101154, 3589193728, 3589210111, 'SE', 'SWE', 'السويد'),
(101155, 3589210112, 3589226495, 'NL', 'NLD', 'هولندا'),
(101156, 3589226496, 3589230415, 'NO', 'NOR', 'النرويج'),
(101157, 3589230416, 3589230431, 'DK', 'DNK', 'الدنيمارك'),
(101158, 3589230432, 3589230759, 'NO', 'NOR', 'النرويج'),
(101159, 3589230760, 3589230775, 'GB', 'GBR', 'المملكة المتحدة'),
(101160, 3589230776, 3589242879, 'NO', 'NOR', 'النرويج'),
(101161, 3589242880, 3589248511, 'NL', 'NLD', 'هولندا'),
(101162, 3589248512, 3589248767, 'GB', 'GBR', 'المملكة المتحدة'),
(101163, 3589248768, 3589256191, 'NL', 'NLD', 'هولندا'),
(101164, 3589256192, 3589256447, 'GR', 'GRC', 'اليونان'),
(101165, 3589256448, 3589258495, 'NL', 'NLD', 'هولندا'),
(101166, 3589258496, 3589258751, 'GB', 'GBR', 'المملكة المتحدة'),
(101167, 3589258752, 3589259263, 'NL', 'NLD', 'هولندا'),
(101168, 3589259264, 3589269455, 'DE', 'DEU', 'ألمانيا'),
(101169, 3589269456, 3589269471, 'AT', 'AUT', 'النمسا'),
(101170, 3589269472, 3589275647, 'DE', 'DEU', 'ألمانيا'),
(101171, 3589275648, 3589283327, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101172, 3589283328, 3589283343, 'RS', 'SRB', 'صربيا'),
(101173, 3589283344, 3589283535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101174, 3589283536, 3589283543, 'RS', 'SRB', 'صربيا'),
(101175, 3589283544, 3589283567, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101176, 3589283568, 3589283575, 'RS', 'SRB', 'صربيا'),
(101177, 3589283576, 3589284975, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101178, 3589284976, 3589285015, 'RS', 'SRB', 'صربيا'),
(101179, 3589285016, 3589285047, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101180, 3589285048, 3589285055, 'RS', 'SRB', 'صربيا'),
(101181, 3589285056, 3589285103, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101182, 3589285104, 3589285279, 'RS', 'SRB', 'صربيا'),
(101183, 3589285280, 3589288015, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101184, 3589288016, 3589288023, 'RS', 'SRB', 'صربيا'),
(101185, 3589288024, 3589288127, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101186, 3589288128, 3589288159, 'RS', 'SRB', 'صربيا'),
(101187, 3589288160, 3589288431, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101188, 3589288432, 3589288447, 'RS', 'SRB', 'صربيا'),
(101189, 3589288448, 3589289831, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101190, 3589289832, 3589289839, 'RS', 'SRB', 'صربيا'),
(101191, 3589289840, 3589289855, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101192, 3589289856, 3589289871, 'RS', 'SRB', 'صربيا'),
(101193, 3589289872, 3589289879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101194, 3589289880, 3589289887, 'RS', 'SRB', 'صربيا'),
(101195, 3589289888, 3589292031, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101196, 3589292032, 3589308415, 'AT', 'AUT', 'النمسا'),
(101197, 3589308416, 3589317887, 'DE', 'DEU', 'ألمانيا'),
(101198, 3589317888, 3589317951, 'GB', 'GBR', 'المملكة المتحدة'),
(101199, 3589317952, 3589324799, 'DE', 'DEU', 'ألمانيا'),
(101200, 3589324800, 3589341183, 'BG', 'BGR', 'بلغاريا'),
(101201, 3589341184, 3589373951, 'PL', 'POL', 'بولندا'),
(101202, 3589373952, 3589375495, 'DE', 'DEU', 'ألمانيا'),
(101203, 3589375496, 3589375503, 'CI', 'CIV', 'كوت ديفوار'),
(101204, 3589375504, 3589390335, 'DE', 'DEU', 'ألمانيا'),
(101205, 3589390336, 3589423103, 'RU', 'RUS', 'الإتحاد الروسي'),
(101206, 3589423104, 3589423615, 'IT', 'ITA', 'إيطاليا'),
(101207, 3589423616, 3589424127, 'CH', 'CHE', 'سويسرا'),
(101208, 3589424128, 3589424639, 'SE', 'SWE', 'السويد'),
(101209, 3589424640, 3589425151, 'ES', 'ESP', 'إسبانيا'),
(101210, 3589425152, 3589425663, 'CH', 'CHE', 'سويسرا'),
(101211, 3589425664, 3589426175, 'GB', 'GBR', 'المملكة المتحدة'),
(101212, 3589426176, 3589426303, 'FR', 'FRA', 'فرنسا'),
(101213, 3589426304, 3589427199, 'GB', 'GBR', 'المملكة المتحدة'),
(101214, 3589427200, 3589427247, 'FR', 'FRA', 'فرنسا'),
(101215, 3589427248, 3589429247, 'GB', 'GBR', 'المملكة المتحدة'),
(101216, 3589429248, 3589429503, 'FR', 'FRA', 'فرنسا'),
(101217, 3589429504, 3589430271, 'GB', 'GBR', 'المملكة المتحدة'),
(101218, 3589430272, 3589430543, 'FR', 'FRA', 'فرنسا'),
(101219, 3589430544, 3589431295, 'GB', 'GBR', 'المملكة المتحدة'),
(101220, 3589431296, 3589431343, 'FR', 'FRA', 'فرنسا'),
(101221, 3589431344, 3589432319, 'GB', 'GBR', 'المملكة المتحدة'),
(101222, 3589432320, 3589432575, 'CH', 'CHE', 'سويسرا'),
(101223, 3589432576, 3589432895, 'FR', 'FRA', 'فرنسا'),
(101224, 3589432896, 3589433343, 'GB', 'GBR', 'المملكة المتحدة'),
(101225, 3589433344, 3589433375, 'IT', 'ITA', 'إيطاليا'),
(101226, 3589433376, 3589433407, 'CH', 'CHE', 'سويسرا'),
(101227, 3589433408, 3589433439, 'SE', 'SWE', 'السويد'),
(101228, 3589433440, 3589433471, 'ES', 'ESP', 'إسبانيا'),
(101229, 3589433472, 3589433503, 'CH', 'CHE', 'سويسرا'),
(101230, 3589433504, 3589433535, 'IE', 'IRL', 'إيرلندا'),
(101231, 3589433536, 3589433567, 'DK', 'DNK', 'الدنيمارك'),
(101232, 3589433568, 3589433599, 'GB', 'GBR', 'المملكة المتحدة'),
(101233, 3589433600, 3589434111, 'IE', 'IRL', 'إيرلندا'),
(101234, 3589434112, 3589434623, 'DK', 'DNK', 'الدنيمارك'),
(101235, 3589434624, 3589434751, 'GB', 'GBR', 'المملكة المتحدة'),
(101236, 3589434752, 3589434879, 'ES', 'ESP', 'إسبانيا'),
(101237, 3589434880, 3589435391, 'FR', 'FRA', 'فرنسا'),
(101238, 3589435392, 3589435519, 'PL', 'POL', 'بولندا'),
(101239, 3589435520, 3589435775, 'ES', 'ESP', 'إسبانيا'),
(101240, 3589435776, 3589435903, 'GB', 'GBR', 'المملكة المتحدة'),
(101241, 3589435904, 3589436159, 'ES', 'ESP', 'إسبانيا'),
(101242, 3589436160, 3589436415, 'GB', 'GBR', 'المملكة المتحدة'),
(101243, 3589436416, 3589436671, 'FR', 'FRA', 'فرنسا'),
(101244, 3589436672, 3589439487, 'GB', 'GBR', 'المملكة المتحدة'),
(101245, 3589439488, 3589444631, 'SE', 'SWE', 'السويد'),
(101246, 3589444632, 3589444639, 'NO', 'NOR', 'النرويج'),
(101247, 3589444640, 3589455871, 'SE', 'SWE', 'السويد'),
(101248, 3589455872, 3589472255, 'RU', 'RUS', 'الإتحاد الروسي'),
(101249, 3589472256, 3589488639, 'TR', 'TUR', 'تركيا'),
(101250, 3589488640, 3589491711, 'RU', 'RUS', 'الإتحاد الروسي'),
(101251, 3589491712, 3589491743, 'TJ', 'TJK', 'طاجيكيستان'),
(101252, 3589491744, 3589505023, 'RU', 'RUS', 'الإتحاد الروسي'),
(101253, 3589505024, 3589521407, 'FI', 'FIN', 'فنلندا'),
(101254, 3589521408, 3589537791, 'IT', 'ITA', 'إيطاليا'),
(101255, 3589537792, 3589545983, 'FR', 'FRA', 'فرنسا'),
(101256, 3589545984, 3589554175, 'DE', 'DEU', 'ألمانيا'),
(101257, 3589554176, 3589570559, 'PS', 'PSE', 'فلسطين المحتلة'),
(101258, 3589570560, 3589570655, 'NL', 'NLD', 'هولندا'),
(101259, 3589570656, 3589578751, 'GB', 'GBR', 'المملكة المتحدة'),
(101260, 3589578752, 3589579263, 'NL', 'NLD', 'هولندا'),
(101261, 3589579264, 3589579775, 'GB', 'GBR', 'المملكة المتحدة'),
(101262, 3589579776, 3589580799, 'NL', 'NLD', 'هولندا'),
(101263, 3589580800, 3589580895, 'GB', 'GBR', 'المملكة المتحدة'),
(101264, 3589580896, 3589581055, 'NL', 'NLD', 'هولندا'),
(101265, 3589581056, 3589581199, 'GB', 'GBR', 'المملكة المتحدة'),
(101266, 3589581200, 3589581215, 'NL', 'NLD', 'هولندا'),
(101267, 3589581216, 3589581327, 'GB', 'GBR', 'المملكة المتحدة'),
(101268, 3589581328, 3589581439, 'NL', 'NLD', 'هولندا'),
(101269, 3589581440, 3589581567, 'GB', 'GBR', 'المملكة المتحدة'),
(101270, 3589581568, 3589581791, 'NL', 'NLD', 'هولندا'),
(101271, 3589581792, 3589581823, 'GB', 'GBR', 'المملكة المتحدة'),
(101272, 3589581824, 3589582591, 'NL', 'NLD', 'هولندا'),
(101273, 3589582592, 3589582607, 'GB', 'GBR', 'المملكة المتحدة'),
(101274, 3589582608, 3589582639, 'NL', 'NLD', 'هولندا'),
(101275, 3589582640, 3589582655, 'GB', 'GBR', 'المملكة المتحدة'),
(101276, 3589582656, 3589583359, 'NL', 'NLD', 'هولندا'),
(101277, 3589583360, 3589583647, 'GB', 'GBR', 'المملكة المتحدة'),
(101278, 3589583648, 3589583663, 'NL', 'NLD', 'هولندا'),
(101279, 3589583664, 3589583743, 'GB', 'GBR', 'المملكة المتحدة'),
(101280, 3589583744, 3589583871, 'DE', 'DEU', 'ألمانيا'),
(101281, 3589583872, 3589584127, 'GB', 'GBR', 'المملكة المتحدة'),
(101282, 3589584128, 3589584271, 'NL', 'NLD', 'هولندا'),
(101283, 3589584272, 3589584639, 'GB', 'GBR', 'المملكة المتحدة'),
(101284, 3589584640, 3589585279, 'NL', 'NLD', 'هولندا'),
(101285, 3589585280, 3589585407, 'GB', 'GBR', 'المملكة المتحدة'),
(101286, 3589585408, 3589585983, 'NL', 'NLD', 'هولندا'),
(101287, 3589585984, 3589586431, 'GB', 'GBR', 'المملكة المتحدة'),
(101288, 3589586432, 3589586687, 'NL', 'NLD', 'هولندا'),
(101289, 3589586688, 3589586943, 'GB', 'GBR', 'المملكة المتحدة'),
(101290, 3589586944, 3589596487, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101291, 3589596488, 3589596511, 'RS', 'SRB', 'صربيا'),
(101292, 3589596512, 3589597559, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101293, 3589597560, 3589597567, 'RS', 'SRB', 'صربيا'),
(101294, 3589597568, 3589603327, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101295, 3589603328, 3589668863, 'FR', 'FRA', 'فرنسا'),
(101296, 3589668864, 3589677055, 'RU', 'RUS', 'الإتحاد الروسي'),
(101297, 3589677056, 3589680287, 'FR', 'FRA', 'فرنسا'),
(101298, 3589680288, 3589680303, 'MQ', 'MTQ', 'مارتينيك'),
(101299, 3589680304, 3589680751, 'FR', 'FRA', 'فرنسا'),
(101300, 3589680752, 3589680767, 'MQ', 'MTQ', 'مارتينيك'),
(101301, 3589680768, 3589685247, 'FR', 'FRA', 'فرنسا'),
(101302, 3589685248, 3589718015, 'GB', 'GBR', 'المملكة المتحدة'),
(101303, 3589718016, 3589724271, 'BE', 'BEL', 'بلجيكا'),
(101304, 3589724272, 3589724287, 'NL', 'NLD', 'هولندا'),
(101305, 3589724288, 3589727439, 'BE', 'BEL', 'بلجيكا'),
(101306, 3589727440, 3589727447, 'GB', 'GBR', 'المملكة المتحدة'),
(101307, 3589727448, 3589733375, 'BE', 'BEL', 'بلجيكا'),
(101308, 3589733376, 3589733439, 'LU', 'LUX', 'لوكسيمبورغ'),
(101309, 3589733440, 3589734399, 'BE', 'BEL', 'بلجيكا'),
(101310, 3589742592, 3589742687, 'NL', 'NLD', 'هولندا'),
(101311, 3589742688, 3589742695, 'AT', 'AUT', 'النمسا'),
(101312, 3589742696, 3589742975, 'NL', 'NLD', 'هولندا'),
(101313, 3589742976, 3589743039, 'IE', 'IRL', 'إيرلندا'),
(101314, 3589743040, 3589743458, 'NL', 'NLD', 'هولندا'),
(101315, 3589743459, 3589743460, 'US', 'USA', 'الولايات المتحدة'),
(101316, 3589743461, 3589744895, 'NL', 'NLD', 'هولندا'),
(101317, 3589744896, 3589744959, 'BE', 'BEL', 'بلجيكا'),
(101318, 3589744960, 3589745119, 'NL', 'NLD', 'هولندا'),
(101319, 3589745120, 3589745151, 'BE', 'BEL', 'بلجيكا'),
(101320, 3589745152, 3589746087, 'NL', 'NLD', 'هولندا'),
(101321, 3589746088, 3589746095, 'DE', 'DEU', 'ألمانيا'),
(101322, 3589746096, 3589747071, 'NL', 'NLD', 'هولندا'),
(101323, 3589747072, 3589747103, 'ES', 'ESP', 'إسبانيا'),
(101324, 3589747104, 3589767167, 'NL', 'NLD', 'هولندا'),
(101325, 3589767168, 3589816319, 'RU', 'RUS', 'الإتحاد الروسي'),
(101326, 3589827072, 3589827327, 'SE', 'SWE', 'السويد'),
(101327, 3589827328, 3589827583, 'FR', 'FRA', 'فرنسا'),
(101328, 3589827648, 3589827679, 'DE', 'DEU', 'ألمانيا'),
(101329, 3589827712, 3589828095, 'DE', 'DEU', 'ألمانيا'),
(101330, 3589828096, 3589828111, 'FR', 'FRA', 'فرنسا'),
(101331, 3589828128, 3589828159, 'DE', 'DEU', 'ألمانيا'),
(101332, 3589828160, 3589828607, 'FR', 'FRA', 'فرنسا'),
(101333, 3589828608, 3589828639, 'SE', 'SWE', 'السويد'),
(101334, 3589828640, 3589828671, 'NL', 'NLD', 'هولندا'),
(101335, 3589828736, 3589828863, 'NL', 'NLD', 'هولندا'),
(101336, 3589829120, 3589829183, 'GB', 'GBR', 'المملكة المتحدة'),
(101337, 3589829376, 3589830655, 'GB', 'GBR', 'المملكة المتحدة'),
(101338, 3589830656, 3589831167, 'DE', 'DEU', 'ألمانيا'),
(101339, 3589831168, 3589831679, 'US', 'USA', 'الولايات المتحدة'),
(101340, 3589831680, 3589832703, 'FR', 'FRA', 'فرنسا'),
(101341, 3589832704, 3589849087, 'TR', 'TUR', 'تركيا'),
(101342, 3589849088, 3589865471, 'GB', 'GBR', 'المملكة المتحدة'),
(101343, 3589865472, 3589881855, 'GR', 'GRC', 'اليونان'),
(101344, 3589881856, 3589890047, 'NL', 'NLD', 'هولندا'),
(101345, 3589890048, 3589890175, 'BE', 'BEL', 'بلجيكا'),
(101346, 3589890176, 3589890303, 'GB', 'GBR', 'المملكة المتحدة'),
(101347, 3589890304, 3589890367, 'BE', 'BEL', 'بلجيكا'),
(101348, 3589890368, 3589890431, 'GB', 'GBR', 'المملكة المتحدة'),
(101349, 3589890432, 3589890559, 'BE', 'BEL', 'بلجيكا'),
(101350, 3589890560, 3589890687, 'GB', 'GBR', 'المملكة المتحدة'),
(101351, 3589890688, 3589891327, 'BE', 'BEL', 'بلجيكا'),
(101352, 3589891328, 3589891615, 'GB', 'GBR', 'المملكة المتحدة'),
(101353, 3589891616, 3589891631, 'BE', 'BEL', 'بلجيكا'),
(101354, 3589891632, 3589931007, 'GB', 'GBR', 'المملكة المتحدة'),
(101355, 3589931008, 3589947391, 'SI', 'SVN', 'سلوفينيا'),
(101356, 3589947392, 3589963775, 'FI', 'FIN', 'فنلندا'),
(101357, 3589963776, 3589971231, 'ES', 'ESP', 'إسبانيا'),
(101358, 3589971232, 3589971247, 'CA', 'CAN', 'كندا'),
(101359, 3589971248, 3589980159, 'ES', 'ESP', 'إسبانيا'),
(101360, 3589980160, 3589996543, 'CZ', 'CZE', 'التشيك'),
(101361, 3589996544, 3589996623, 'NL', 'NLD', 'هولندا'),
(101362, 3589996624, 3589996639, 'GB', 'GBR', 'المملكة المتحدة'),
(101363, 3589996640, 3589996655, 'NL', 'NLD', 'هولندا'),
(101364, 3589996656, 3589996703, 'GB', 'GBR', 'المملكة المتحدة'),
(101365, 3589996704, 3589996799, 'NL', 'NLD', 'هولندا'),
(101366, 3589996800, 3589996863, 'GB', 'GBR', 'المملكة المتحدة'),
(101367, 3589996864, 3589996879, 'NL', 'NLD', 'هولندا'),
(101368, 3589996880, 3589996911, 'GB', 'GBR', 'المملكة المتحدة'),
(101369, 3589996912, 3589996931, 'NL', 'NLD', 'هولندا'),
(101370, 3589996932, 3589996959, 'GB', 'GBR', 'المملكة المتحدة'),
(101371, 3589996960, 3589996991, 'NL', 'NLD', 'هولندا'),
(101372, 3589996992, 3589997055, 'GB', 'GBR', 'المملكة المتحدة'),
(101373, 3589997056, 3589997311, 'NL', 'NLD', 'هولندا'),
(101374, 3589997312, 3589997439, 'GB', 'GBR', 'المملكة المتحدة'),
(101375, 3589997440, 3589997503, 'NL', 'NLD', 'هولندا'),
(101376, 3589997504, 3589997535, 'GB', 'GBR', 'المملكة المتحدة'),
(101377, 3589997536, 3589997543, 'NL', 'NLD', 'هولندا'),
(101378, 3589997544, 3589997559, 'GB', 'GBR', 'المملكة المتحدة'),
(101379, 3589997560, 3589997567, 'NL', 'NLD', 'هولندا'),
(101380, 3589997568, 3590012927, 'GB', 'GBR', 'المملكة المتحدة'),
(101381, 3590012928, 3590029311, 'BE', 'BEL', 'بلجيكا'),
(101382, 3590029312, 3590045695, 'FR', 'FRA', 'فرنسا'),
(101383, 3590045696, 3590062079, 'RU', 'RUS', 'الإتحاد الروسي'),
(101384, 3590062080, 3590078463, 'DE', 'DEU', 'ألمانيا'),
(101385, 3590078464, 3590094847, 'RU', 'RUS', 'الإتحاد الروسي'),
(101386, 3590094848, 3590111231, 'DE', 'DEU', 'ألمانيا'),
(101387, 3590111232, 3590113023, 'LT', 'LTU', 'ليتوانيا'),
(101388, 3590113024, 3590113279, 'LV', 'LVA', 'لاتفيا'),
(101389, 3590113280, 3590127615, 'LT', 'LTU', 'ليتوانيا'),
(101390, 3590127616, 3590143999, 'GB', 'GBR', 'المملكة المتحدة'),
(101391, 3590144000, 3590151143, 'SI', 'SVN', 'سلوفينيا'),
(101392, 3590151144, 3590151151, 'HR', 'HRV', 'كرواتيا'),
(101393, 3590151152, 3590154047, 'SI', 'SVN', 'سلوفينيا'),
(101394, 3590154048, 3590154063, 'HR', 'HRV', 'كرواتيا'),
(101395, 3590154064, 3590155799, 'SI', 'SVN', 'سلوفينيا'),
(101396, 3590155800, 3590155807, 'HR', 'HRV', 'كرواتيا'),
(101397, 3590155808, 3590155815, 'SI', 'SVN', 'سلوفينيا'),
(101398, 3590155816, 3590155823, 'HR', 'HRV', 'كرواتيا'),
(101399, 3590155824, 3590156287, 'SI', 'SVN', 'سلوفينيا'),
(101400, 3590156288, 3590156959, 'HR', 'HRV', 'كرواتيا'),
(101401, 3590156960, 3590156991, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101402, 3590156992, 3590157311, 'HR', 'HRV', 'كرواتيا'),
(101403, 3590157312, 3590157335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101404, 3590157336, 3590157343, 'RS', 'SRB', 'صربيا'),
(101405, 3590157344, 3590157351, 'SI', 'SVN', 'سلوفينيا'),
(101406, 3590157352, 3590157359, 'RS', 'SRB', 'صربيا'),
(101407, 3590157360, 3590157439, 'SI', 'SVN', 'سلوفينيا'),
(101408, 3590157440, 3590157471, 'RS', 'SRB', 'صربيا'),
(101409, 3590157472, 3590157487, 'SI', 'SVN', 'سلوفينيا'),
(101410, 3590157488, 3590157567, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101411, 3590157568, 3590157631, 'SI', 'SVN', 'سلوفينيا'),
(101412, 3590157632, 3590157647, 'RS', 'SRB', 'صربيا'),
(101413, 3590157648, 3590157655, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101414, 3590157656, 3590157663, 'RS', 'SRB', 'صربيا'),
(101415, 3590157664, 3590157671, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101416, 3590157672, 3590157679, 'RS', 'SRB', 'صربيا'),
(101417, 3590157680, 3590157687, 'SI', 'SVN', 'سلوفينيا'),
(101418, 3590157688, 3590157695, 'RS', 'SRB', 'صربيا'),
(101419, 3590157696, 3590157743, 'SI', 'SVN', 'سلوفينيا'),
(101420, 3590157744, 3590157783, 'RS', 'SRB', 'صربيا'),
(101421, 3590157784, 3590157823, 'SI', 'SVN', 'سلوفينيا'),
(101422, 3590157824, 3590157831, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101423, 3590157832, 3590157839, 'RS', 'SRB', 'صربيا'),
(101424, 3590157840, 3590158335, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101425, 3590158336, 3590158343, 'RS', 'SRB', 'صربيا'),
(101426, 3590158344, 3590158407, 'SI', 'SVN', 'سلوفينيا'),
(101427, 3590158408, 3590158415, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101428, 3590158416, 3590158431, 'SI', 'SVN', 'سلوفينيا'),
(101429, 3590158432, 3590158439, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101430, 3590158440, 3590158455, 'SI', 'SVN', 'سلوفينيا'),
(101431, 3590158456, 3590158463, 'RS', 'SRB', 'صربيا'),
(101432, 3590158464, 3590158479, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101433, 3590158480, 3590158495, 'SI', 'SVN', 'سلوفينيا'),
(101434, 3590158496, 3590158503, 'RS', 'SRB', 'صربيا'),
(101435, 3590158504, 3590158527, 'SI', 'SVN', 'سلوفينيا'),
(101436, 3590158528, 3590158535, 'RS', 'SRB', 'صربيا'),
(101437, 3590158536, 3590158591, 'SI', 'SVN', 'سلوفينيا'),
(101438, 3590158592, 3590159359, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(101439, 3590159360, 3590160383, 'SI', 'SVN', 'سلوفينيا'),
(101440, 3590160384, 3590176767, 'GB', 'GBR', 'المملكة المتحدة'),
(101441, 3590176768, 3590178615, 'HU', 'HUN', 'هنغاريا'),
(101442, 3590178616, 3590178623, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(101443, 3590178624, 3590193151, 'HU', 'HUN', 'هنغاريا'),
(101444, 3590193152, 3590201343, 'IT', 'ITA', 'إيطاليا'),
(101445, 3590201344, 3590209535, 'DE', 'DEU', 'ألمانيا'),
(101446, 3590209536, 3590225919, 'ES', 'ESP', 'إسبانيا'),
(101447, 3590225920, 3590234111, 'TR', 'TUR', 'تركيا'),
(101448, 3590234112, 3590242303, 'GB', 'GBR', 'المملكة المتحدة'),
(101449, 3590242304, 3590244351, 'US', 'USA', 'الولايات المتحدة'),
(101450, 3590244352, 3590244607, 'IE', 'IRL', 'إيرلندا'),
(101451, 3590244608, 3590244863, 'DE', 'DEU', 'ألمانيا'),
(101452, 3590244864, 3590245119, 'GR', 'GRC', 'اليونان'),
(101453, 3590245120, 3590245151, 'BE', 'BEL', 'بلجيكا'),
(101454, 3590245152, 3590245183, 'IE', 'IRL', 'إيرلندا'),
(101455, 3590245184, 3590245215, 'FR', 'FRA', 'فرنسا'),
(101456, 3590245216, 3590245279, 'IE', 'IRL', 'إيرلندا'),
(101457, 3590245280, 3590245311, 'BE', 'BEL', 'بلجيكا'),
(101458, 3590245312, 3590245439, 'US', 'USA', 'الولايات المتحدة'),
(101459, 3590245440, 3590245503, 'FR', 'FRA', 'فرنسا'),
(101460, 3590245504, 3590245567, 'GB', 'GBR', 'المملكة المتحدة'),
(101461, 3590245568, 3590245631, 'US', 'USA', 'الولايات المتحدة'),
(101462, 3590245632, 3590245887, 'FR', 'FRA', 'فرنسا'),
(101463, 3590245888, 3590245983, 'US', 'USA', 'الولايات المتحدة'),
(101464, 3590245984, 3590246015, 'IE', 'IRL', 'إيرلندا'),
(101465, 3590246016, 3590246175, 'FR', 'FRA', 'فرنسا'),
(101466, 3590246176, 3590246207, 'AU', 'AUS', 'أستراليا'),
(101467, 3590246208, 3590246271, 'FR', 'FRA', 'فرنسا'),
(101468, 3590246272, 3590246287, 'DE', 'DEU', 'ألمانيا'),
(101469, 3590246288, 3590246303, 'IE', 'IRL', 'إيرلندا'),
(101470, 3590246304, 3590246399, 'FR', 'FRA', 'فرنسا'),
(101471, 3590246400, 3590246911, 'US', 'USA', 'الولايات المتحدة'),
(101472, 3590246912, 3590247039, 'DE', 'DEU', 'ألمانيا'),
(101473, 3590247040, 3590247055, 'IT', 'ITA', 'إيطاليا'),
(101474, 3590247056, 3590247063, 'DE', 'DEU', 'ألمانيا'),
(101475, 3590247064, 3590247071, 'IE', 'IRL', 'إيرلندا'),
(101476, 3590247072, 3590247087, 'IT', 'ITA', 'إيطاليا'),
(101477, 3590247088, 3590247167, 'IE', 'IRL', 'إيرلندا'),
(101478, 3590247168, 3590247231, 'US', 'USA', 'الولايات المتحدة'),
(101479, 3590247232, 3590247295, 'IT', 'ITA', 'إيطاليا'),
(101480, 3590247296, 3590247423, 'US', 'USA', 'الولايات المتحدة'),
(101481, 3590247424, 3590247487, 'IT', 'ITA', 'إيطاليا'),
(101482, 3590247488, 3590247551, 'US', 'USA', 'الولايات المتحدة'),
(101483, 3590247552, 3590247679, 'IT', 'ITA', 'إيطاليا'),
(101484, 3590247680, 3590247687, 'GB', 'GBR', 'المملكة المتحدة'),
(101485, 3590247688, 3590247711, 'IE', 'IRL', 'إيرلندا'),
(101486, 3590247712, 3590247743, 'HK', 'HKG', 'هونغ كونغ'),
(101487, 3590247744, 3590248447, 'IE', 'IRL', 'إيرلندا'),
(101488, 3590248448, 3590248959, 'US', 'USA', 'الولايات المتحدة'),
(101489, 3590248960, 3590249471, 'ES', 'ESP', 'إسبانيا'),
(101490, 3590249472, 3590249983, 'IE', 'IRL', 'إيرلندا'),
(101491, 3590249984, 3590250495, 'GR', 'GRC', 'اليونان'),
(101492, 3590250496, 3590250751, 'IE', 'IRL', 'إيرلندا'),
(101493, 3590250752, 3590251007, 'GR', 'GRC', 'اليونان'),
(101494, 3590251008, 3590251263, 'IT', 'ITA', 'إيطاليا'),
(101495, 3590251264, 3590251519, 'DE', 'DEU', 'ألمانيا'),
(101496, 3590251520, 3590251551, 'ES', 'ESP', 'إسبانيا'),
(101497, 3590251552, 3590251583, 'IE', 'IRL', 'إيرلندا'),
(101498, 3590251584, 3590251647, 'US', 'USA', 'الولايات المتحدة'),
(101499, 3590251648, 3590251775, 'NL', 'NLD', 'هولندا'),
(101500, 3590251776, 3590251839, 'IE', 'IRL', 'إيرلندا'),
(101501, 3590251840, 3590251903, 'ES', 'ESP', 'إسبانيا'),
(101502, 3590251904, 3590251967, 'IE', 'IRL', 'إيرلندا'),
(101503, 3590251968, 3590252543, 'ES', 'ESP', 'إسبانيا'),
(101504, 3590252544, 3590253055, 'GB', 'GBR', 'المملكة المتحدة'),
(101505, 3590253056, 3590253311, 'DE', 'DEU', 'ألمانيا'),
(101506, 3590253312, 3590253375, 'IE', 'IRL', 'إيرلندا'),
(101507, 3590253376, 3590253407, 'US', 'USA', 'الولايات المتحدة'),
(101508, 3590253408, 3590254079, 'IE', 'IRL', 'إيرلندا'),
(101509, 3590254080, 3590254087, 'DE', 'DEU', 'ألمانيا'),
(101510, 3590254088, 3590254095, 'IE', 'IRL', 'إيرلندا'),
(101511, 3590254096, 3590254111, 'DE', 'DEU', 'ألمانيا'),
(101512, 3590254112, 3590254127, 'IE', 'IRL', 'إيرلندا'),
(101513, 3590254128, 3590254135, 'RU', 'RUS', 'الإتحاد الروسي'),
(101514, 3590254136, 3590254143, 'IE', 'IRL', 'إيرلندا'),
(101515, 3590254144, 3590254207, 'US', 'USA', 'الولايات المتحدة'),
(101516, 3590254208, 3590254303, 'IE', 'IRL', 'إيرلندا'),
(101517, 3590254304, 3590254335, 'US', 'USA', 'الولايات المتحدة'),
(101518, 3590254336, 3590254591, 'IE', 'IRL', 'إيرلندا'),
(101519, 3590254592, 3590254879, 'ES', 'ESP', 'إسبانيا'),
(101520, 3590254880, 3590254911, 'IE', 'IRL', 'إيرلندا'),
(101521, 3590254912, 3590254975, 'ES', 'ESP', 'إسبانيا'),
(101522, 3590254976, 3590255047, 'IE', 'IRL', 'إيرلندا'),
(101523, 3590255048, 3590255071, 'ES', 'ESP', 'إسبانيا'),
(101524, 3590255072, 3590255103, 'IE', 'IRL', 'إيرلندا'),
(101525, 3590255104, 3590255359, 'ES', 'ESP', 'إسبانيا'),
(101526, 3590255360, 3590255935, 'IE', 'IRL', 'إيرلندا'),
(101527, 3590255936, 3590255999, 'US', 'USA', 'الولايات المتحدة'),
(101528, 3590256000, 3590256383, 'IE', 'IRL', 'إيرلندا'),
(101529, 3590256384, 3590256639, 'IT', 'ITA', 'إيطاليا'),
(101530, 3590256640, 3590256703, 'US', 'USA', 'الولايات المتحدة'),
(101531, 3590256704, 3590256719, 'BE', 'BEL', 'بلجيكا'),
(101532, 3590256720, 3590256735, 'IE', 'IRL', 'إيرلندا'),
(101533, 3590256736, 3590256767, 'BE', 'BEL', 'بلجيكا'),
(101534, 3590256768, 3590257151, 'IE', 'IRL', 'إيرلندا'),
(101535, 3590257152, 3590258175, 'DE', 'DEU', 'ألمانيا'),
(101536, 3590258176, 3590258387, 'IE', 'IRL', 'إيرلندا'),
(101537, 3590258388, 3590258391, 'DE', 'DEU', 'ألمانيا'),
(101538, 3590258392, 3590258431, 'IE', 'IRL', 'إيرلندا'),
(101539, 3590258432, 3590258447, 'GB', 'GBR', 'المملكة المتحدة'),
(101540, 3590258448, 3590258463, 'IE', 'IRL', 'إيرلندا'),
(101541, 3590258464, 3590258495, 'US', 'USA', 'الولايات المتحدة'),
(101542, 3590258496, 3590258687, 'IE', 'IRL', 'إيرلندا'),
(101543, 3590258688, 3590291455, 'IT', 'ITA', 'إيطاليا'),
(101544, 3590299648, 3590307839, 'FI', 'FIN', 'فنلندا'),
(101545, 3590307840, 3590307903, 'GB', 'GBR', 'المملكة المتحدة'),
(101546, 3590307904, 3590307935, 'UA', 'UKR', 'أوكرانيا'),
(101547, 3590307936, 3590307951, 'GB', 'GBR', 'المملكة المتحدة'),
(101548, 3590307952, 3590307967, 'NG', 'NGA', 'نيجيريا'),
(101549, 3590307968, 3590308031, 'GB', 'GBR', 'المملكة المتحدة'),
(101550, 3590308032, 3590308047, 'UG', 'UGA', 'أوغاندا'),
(101551, 3590308048, 3590308063, 'GB', 'GBR', 'المملكة المتحدة'),
(101552, 3590308064, 3590308071, 'ZW', 'ZWE', 'زمبابواي'),
(101553, 3590308072, 3590308079, 'GB', 'GBR', 'المملكة المتحدة'),
(101554, 3590308080, 3590308087, 'MW', 'MWI', 'ملاوي'),
(101555, 3590308088, 3590308095, 'AO', 'AGO', 'أنغولا'),
(101556, 3590308096, 3590308119, 'GB', 'GBR', 'المملكة المتحدة'),
(101557, 3590308120, 3590308127, 'IQ', 'IRQ', 'العراق'),
(101558, 3590308128, 3590308175, 'GB', 'GBR', 'المملكة المتحدة'),
(101559, 3590308176, 3590308183, 'NG', 'NGA', 'نيجيريا'),
(101560, 3590308184, 3590308191, 'IQ', 'IRQ', 'العراق'),
(101561, 3590308192, 3590308199, 'GB', 'GBR', 'المملكة المتحدة'),
(101562, 3590308200, 3590308231, 'IQ', 'IRQ', 'العراق'),
(101563, 3590308232, 3590308247, 'GB', 'GBR', 'المملكة المتحدة'),
(101564, 3590308248, 3590308263, 'IQ', 'IRQ', 'العراق'),
(101565, 3590308264, 3590308271, 'GB', 'GBR', 'المملكة المتحدة'),
(101566, 3590308272, 3590308287, 'IQ', 'IRQ', 'العراق'),
(101567, 3590308288, 3590308295, 'GB', 'GBR', 'المملكة المتحدة'),
(101568, 3590308296, 3590308303, 'IQ', 'IRQ', 'العراق'),
(101569, 3590308304, 3590308311, 'SO', 'SOM', 'الصومال'),
(101570, 3590308312, 3590308319, 'IQ', 'IRQ', 'العراق'),
(101571, 3590308320, 3590308327, 'GB', 'GBR', 'المملكة المتحدة'),
(101572, 3590308328, 3590308343, 'IQ', 'IRQ', 'العراق'),
(101573, 3590308344, 3590308607, 'GB', 'GBR', 'المملكة المتحدة'),
(101574, 3590308608, 3590308735, 'NG', 'NGA', 'نيجيريا'),
(101575, 3590308736, 3590308767, 'GB', 'GBR', 'المملكة المتحدة'),
(101576, 3590308768, 3590308775, 'RW', 'RWA', 'رواندا'),
(101577, 3590308776, 3590308783, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101578, 3590308784, 3590308799, 'ZW', 'ZWE', 'زمبابواي'),
(101579, 3590308800, 3590308807, 'GB', 'GBR', 'المملكة المتحدة'),
(101580, 3590308808, 3590308815, 'ZM', 'ZMB', 'زامبيا'),
(101581, 3590308816, 3590308831, 'KE', 'KEN', 'كينيا'),
(101582, 3590308832, 3590308839, 'ZW', 'ZWE', 'زمبابواي'),
(101583, 3590308840, 3590308847, 'ET', 'ETH', 'إثيوبيا'),
(101584, 3590308848, 3590308855, 'GB', 'GBR', 'المملكة المتحدة'),
(101585, 3590308856, 3590308863, 'NG', 'NGA', 'نيجيريا'),
(101586, 3590308864, 3590308911, 'GB', 'GBR', 'المملكة المتحدة'),
(101587, 3590308912, 3590308927, 'ZW', 'ZWE', 'زمبابواي'),
(101588, 3590308928, 3590308951, 'GB', 'GBR', 'المملكة المتحدة'),
(101589, 3590308952, 3590308959, 'GH', 'GHA', 'غانا'),
(101590, 3590308960, 3590308991, 'GB', 'GBR', 'المملكة المتحدة'),
(101591, 3590308992, 3590308999, 'NG', 'NGA', 'نيجيريا'),
(101592, 3590309000, 3590309007, 'UG', 'UGA', 'أوغاندا'),
(101593, 3590309008, 3590309023, 'TZ', 'TZA', 'تانزانيا'),
(101594, 3590309024, 3590309055, 'ZW', 'ZWE', 'زمبابواي'),
(101595, 3590309056, 3590309063, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(101596, 3590309064, 3590309071, 'LU', 'LUX', 'لوكسيمبورغ'),
(101597, 3590309072, 3590309079, 'MW', 'MWI', 'ملاوي'),
(101598, 3590309080, 3590309087, 'GH', 'GHA', 'غانا'),
(101599, 3590309088, 3590309103, 'NG', 'NGA', 'نيجيريا'),
(101600, 3590309104, 3590309111, 'ZW', 'ZWE', 'زمبابواي'),
(101601, 3590309112, 3590309503, 'GB', 'GBR', 'المملكة المتحدة'),
(101602, 3590309504, 3590309511, 'NG', 'NGA', 'نيجيريا'),
(101603, 3590309512, 3590309519, 'AO', 'AGO', 'أنغولا'),
(101604, 3590309520, 3590309527, 'NG', 'NGA', 'نيجيريا'),
(101605, 3590309528, 3590309535, 'CM', 'CMR', 'الكاميرون'),
(101606, 3590309536, 3590309543, 'SO', 'SOM', 'الصومال'),
(101607, 3590309544, 3590309551, 'AM', 'ARM', 'أرمينيا'),
(101608, 3590309552, 3590309575, 'GB', 'GBR', 'المملكة المتحدة'),
(101609, 3590309576, 3590309583, 'NG', 'NGA', 'نيجيريا'),
(101610, 3590309584, 3590309615, 'GB', 'GBR', 'المملكة المتحدة'),
(101611, 3590309616, 3590309623, 'UG', 'UGA', 'أوغاندا'),
(101612, 3590309624, 3590309631, 'ZW', 'ZWE', 'زمبابواي'),
(101613, 3590309632, 3590309647, 'IQ', 'IRQ', 'العراق'),
(101614, 3590309648, 3590309679, 'GB', 'GBR', 'المملكة المتحدة'),
(101615, 3590309680, 3590309695, 'IQ', 'IRQ', 'العراق'),
(101616, 3590309696, 3590309711, 'GB', 'GBR', 'المملكة المتحدة'),
(101617, 3590309712, 3590309719, 'IQ', 'IRQ', 'العراق'),
(101618, 3590309720, 3590309727, 'GB', 'GBR', 'المملكة المتحدة'),
(101619, 3590309728, 3590309759, 'IQ', 'IRQ', 'العراق'),
(101620, 3590309760, 3590309775, 'GB', 'GBR', 'المملكة المتحدة'),
(101621, 3590309776, 3590309783, 'IQ', 'IRQ', 'العراق'),
(101622, 3590309784, 3590309799, 'GB', 'GBR', 'المملكة المتحدة'),
(101623, 3590309800, 3590309807, 'IQ', 'IRQ', 'العراق'),
(101624, 3590309808, 3590309823, 'GB', 'GBR', 'المملكة المتحدة'),
(101625, 3590309824, 3590309839, 'IQ', 'IRQ', 'العراق'),
(101626, 3590309840, 3590309863, 'GB', 'GBR', 'المملكة المتحدة'),
(101627, 3590309864, 3590309871, 'IQ', 'IRQ', 'العراق'),
(101628, 3590309872, 3590309879, 'GB', 'GBR', 'المملكة المتحدة'),
(101629, 3590309880, 3590309887, 'IQ', 'IRQ', 'العراق'),
(101630, 3590309888, 3590310143, 'GB', 'GBR', 'المملكة المتحدة'),
(101631, 3590310144, 3590310159, 'MZ', 'MOZ', 'موزامبيق'),
(101632, 3590310160, 3590310167, 'IQ', 'IRQ', 'العراق'),
(101633, 3590310168, 3590310175, 'GB', 'GBR', 'المملكة المتحدة'),
(101634, 3590310176, 3590310183, 'LR', 'LBR', 'ليبيريا'),
(101635, 3590310184, 3590310191, 'IQ', 'IRQ', 'العراق'),
(101636, 3590310192, 3590310247, 'GB', 'GBR', 'المملكة المتحدة'),
(101637, 3590310248, 3590310255, 'IQ', 'IRQ', 'العراق'),
(101638, 3590310256, 3590310279, 'GB', 'GBR', 'المملكة المتحدة'),
(101639, 3590310280, 3590310287, 'IQ', 'IRQ', 'العراق'),
(101640, 3590310288, 3590310288, 'GB', 'GBR', 'المملكة المتحدة'),
(101641, 3590310289, 3590310303, 'IQ', 'IRQ', 'العراق'),
(101642, 3590310304, 3590310327, 'GB', 'GBR', 'المملكة المتحدة'),
(101643, 3590310328, 3590310335, 'NG', 'NGA', 'نيجيريا'),
(101644, 3590310336, 3590310351, 'IQ', 'IRQ', 'العراق'),
(101645, 3590310352, 3590310367, 'GB', 'GBR', 'المملكة المتحدة'),
(101646, 3590310368, 3590310399, 'IQ', 'IRQ', 'العراق'),
(101647, 3590310400, 3590310655, 'UA', 'UKR', 'أوكرانيا'),
(101648, 3590310656, 3590311679, 'GB', 'GBR', 'المملكة المتحدة'),
(101649, 3590311680, 3590311935, 'YT', 'MYT', 'مايوت'),
(101650, 3590311936, 3590312703, 'MW', 'MWI', 'ملاوي'),
(101651, 3590312704, 3590312799, 'GB', 'GBR', 'المملكة المتحدة'),
(101652, 3590312800, 3590312807, 'KE', 'KEN', 'كينيا'),
(101653, 3590312808, 3590312895, 'GB', 'GBR', 'المملكة المتحدة'),
(101654, 3590312896, 3590312903, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101655, 3590312904, 3590312911, 'AO', 'AGO', 'أنغولا'),
(101656, 3590312912, 3590312919, 'NG', 'NGA', 'نيجيريا'),
(101657, 3590312920, 3590312927, 'GB', 'GBR', 'المملكة المتحدة'),
(101658, 3590312928, 3590312943, 'UG', 'UGA', 'أوغاندا'),
(101659, 3590312944, 3590312951, 'GB', 'GBR', 'المملكة المتحدة'),
(101660, 3590312952, 3590312959, 'KE', 'KEN', 'كينيا'),
(101661, 3590312960, 3590314623, 'GB', 'GBR', 'المملكة المتحدة'),
(101662, 3590314624, 3590314639, 'ET', 'ETH', 'إثيوبيا'),
(101663, 3590314640, 3590314655, 'GH', 'GHA', 'غانا'),
(101664, 3590314656, 3590314671, 'GB', 'GBR', 'المملكة المتحدة'),
(101665, 3590314672, 3590314679, 'UG', 'UGA', 'أوغاندا'),
(101666, 3590314680, 3590314687, 'GB', 'GBR', 'المملكة المتحدة'),
(101667, 3590314688, 3590314703, 'NG', 'NGA', 'نيجيريا'),
(101668, 3590314704, 3590314719, 'GB', 'GBR', 'المملكة المتحدة'),
(101669, 3590314720, 3590314727, 'TG', 'TGO', 'توغو'),
(101670, 3590314728, 3590314735, 'UG', 'UGA', 'أوغاندا'),
(101671, 3590314736, 3590314743, 'NG', 'NGA', 'نيجيريا'),
(101672, 3590314744, 3590314823, 'GB', 'GBR', 'المملكة المتحدة'),
(101673, 3590314824, 3590314831, 'ZW', 'ZWE', 'زمبابواي'),
(101674, 3590314832, 3590314887, 'GB', 'GBR', 'المملكة المتحدة'),
(101675, 3590314888, 3590314895, 'NG', 'NGA', 'نيجيريا'),
(101676, 3590314896, 3590314903, 'GB', 'GBR', 'المملكة المتحدة'),
(101677, 3590314904, 3590314911, 'KE', 'KEN', 'كينيا'),
(101678, 3590314912, 3590314927, 'GH', 'GHA', 'غانا'),
(101679, 3590314928, 3590314943, 'NG', 'NGA', 'نيجيريا'),
(101680, 3590314944, 3590314967, 'GB', 'GBR', 'المملكة المتحدة'),
(101681, 3590314968, 3590314973, 'YT', 'MYT', 'مايوت'),
(101682, 3590314974, 3590314975, 'GB', 'GBR', 'المملكة المتحدة'),
(101683, 3590314976, 3590314983, 'UG', 'UGA', 'أوغاندا'),
(101684, 3590314984, 3590316031, 'GB', 'GBR', 'المملكة المتحدة'),
(101685, 3590316032, 3590316039, 'TZ', 'TZA', 'تانزانيا'),
(101686, 3590316040, 3590316047, 'GB', 'GBR', 'المملكة المتحدة'),
(101687, 3590316048, 3590316055, 'GH', 'GHA', 'غانا'),
(101688, 3590316056, 3590316079, 'IQ', 'IRQ', 'العراق'),
(101689, 3590316080, 3590316087, 'LB', 'LBN', 'لبنان'),
(101690, 3590316088, 3590316095, 'GB', 'GBR', 'المملكة المتحدة'),
(101691, 3590316096, 3590316127, 'IQ', 'IRQ', 'العراق'),
(101692, 3590316128, 3590316151, 'NG', 'NGA', 'نيجيريا'),
(101693, 3590316152, 3590316159, 'GB', 'GBR', 'المملكة المتحدة'),
(101694, 3590316160, 3590316175, 'LB', 'LBN', 'لبنان'),
(101695, 3590316176, 3590316199, 'GB', 'GBR', 'المملكة المتحدة'),
(101696, 3590316200, 3590316215, 'IQ', 'IRQ', 'العراق'),
(101697, 3590316216, 3590316231, 'GB', 'GBR', 'المملكة المتحدة'),
(101698, 3590316232, 3590316239, 'LB', 'LBN', 'لبنان'),
(101699, 3590316240, 3590316271, 'GB', 'GBR', 'المملكة المتحدة'),
(101700, 3590316272, 3590316279, 'IQ', 'IRQ', 'العراق'),
(101701, 3590316280, 3590316287, 'GB', 'GBR', 'المملكة المتحدة'),
(101702, 3590316288, 3590316543, 'LB', 'LBN', 'لبنان'),
(101703, 3590316544, 3590316567, 'GB', 'GBR', 'المملكة المتحدة'),
(101704, 3590316568, 3590316575, 'IQ', 'IRQ', 'العراق'),
(101705, 3590316576, 3590316591, 'GB', 'GBR', 'المملكة المتحدة'),
(101706, 3590316592, 3590316599, 'IQ', 'IRQ', 'العراق'),
(101707, 3590316600, 3590316647, 'GB', 'GBR', 'المملكة المتحدة'),
(101708, 3590316648, 3590316655, 'LY', 'LBY', 'ليبيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(101709, 3590316656, 3590316663, 'IQ', 'IRQ', 'العراق'),
(101710, 3590316664, 3590316671, 'LY', 'LBY', 'ليبيا'),
(101711, 3590316672, 3590316727, 'GB', 'GBR', 'المملكة المتحدة'),
(101712, 3590316728, 3590316735, 'LB', 'LBN', 'لبنان'),
(101713, 3590316736, 3590316815, 'GB', 'GBR', 'المملكة المتحدة'),
(101714, 3590316816, 3590316831, 'IQ', 'IRQ', 'العراق'),
(101715, 3590316832, 3590317055, 'GB', 'GBR', 'المملكة المتحدة'),
(101716, 3590317056, 3590317311, 'NG', 'NGA', 'نيجيريا'),
(101717, 3590317312, 3590317343, 'AO', 'AGO', 'أنغولا'),
(101718, 3590317344, 3590317407, 'GB', 'GBR', 'المملكة المتحدة'),
(101719, 3590317408, 3590317439, 'US', 'USA', 'الولايات المتحدة'),
(101720, 3590317440, 3590317447, 'AM', 'ARM', 'أرمينيا'),
(101721, 3590317448, 3590317455, 'LB', 'LBN', 'لبنان'),
(101722, 3590317456, 3590317471, 'IQ', 'IRQ', 'العراق'),
(101723, 3590317472, 3590317479, 'MW', 'MWI', 'ملاوي'),
(101724, 3590317480, 3590317487, 'US', 'USA', 'الولايات المتحدة'),
(101725, 3590317488, 3590317495, 'GB', 'GBR', 'المملكة المتحدة'),
(101726, 3590317496, 3590317503, 'LB', 'LBN', 'لبنان'),
(101727, 3590317504, 3590317519, 'GB', 'GBR', 'المملكة المتحدة'),
(101728, 3590317520, 3590317527, 'LY', 'LBY', 'ليبيا'),
(101729, 3590317528, 3590317823, 'IQ', 'IRQ', 'العراق'),
(101730, 3590317824, 3590317951, 'GB', 'GBR', 'المملكة المتحدة'),
(101731, 3590317952, 3590318047, 'UA', 'UKR', 'أوكرانيا'),
(101732, 3590318048, 3590319167, 'GB', 'GBR', 'المملكة المتحدة'),
(101733, 3590319168, 3590319231, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101734, 3590319232, 3590319335, 'GB', 'GBR', 'المملكة المتحدة'),
(101735, 3590319336, 3590319359, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101736, 3590319360, 3590319423, 'GB', 'GBR', 'المملكة المتحدة'),
(101737, 3590319424, 3590319455, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101738, 3590319456, 3590319967, 'GB', 'GBR', 'المملكة المتحدة'),
(101739, 3590319968, 3590319999, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101740, 3590320000, 3590320191, 'GB', 'GBR', 'المملكة المتحدة'),
(101741, 3590320192, 3590320199, 'LB', 'LBN', 'لبنان'),
(101742, 3590320200, 3590320207, 'IQ', 'IRQ', 'العراق'),
(101743, 3590320208, 3590320231, 'GB', 'GBR', 'المملكة المتحدة'),
(101744, 3590320232, 3590320239, 'IQ', 'IRQ', 'العراق'),
(101745, 3590320240, 3590320247, 'GB', 'GBR', 'المملكة المتحدة'),
(101746, 3590320248, 3590320255, 'LB', 'LBN', 'لبنان'),
(101747, 3590320256, 3590320271, 'GB', 'GBR', 'المملكة المتحدة'),
(101748, 3590320272, 3590320295, 'IQ', 'IRQ', 'العراق'),
(101749, 3590320296, 3590320303, 'GB', 'GBR', 'المملكة المتحدة'),
(101750, 3590320304, 3590320319, 'IQ', 'IRQ', 'العراق'),
(101751, 3590320320, 3590320335, 'GB', 'GBR', 'المملكة المتحدة'),
(101752, 3590320336, 3590320343, 'UG', 'UGA', 'أوغاندا'),
(101753, 3590320344, 3590320367, 'IQ', 'IRQ', 'العراق'),
(101754, 3590320368, 3590320375, 'GB', 'GBR', 'المملكة المتحدة'),
(101755, 3590320376, 3590320383, 'IQ', 'IRQ', 'العراق'),
(101756, 3590320384, 3590321151, 'GB', 'GBR', 'المملكة المتحدة'),
(101757, 3590321152, 3590321663, 'IQ', 'IRQ', 'العراق'),
(101758, 3590321664, 3590321679, 'GB', 'GBR', 'المملكة المتحدة'),
(101759, 3590321680, 3590321687, 'CM', 'CMR', 'الكاميرون'),
(101760, 3590321688, 3590321695, 'IQ', 'IRQ', 'العراق'),
(101761, 3590321696, 3590321711, 'ZW', 'ZWE', 'زمبابواي'),
(101762, 3590321712, 3590321727, 'IQ', 'IRQ', 'العراق'),
(101763, 3590321728, 3590321791, 'GB', 'GBR', 'المملكة المتحدة'),
(101764, 3590321792, 3590321823, 'IQ', 'IRQ', 'العراق'),
(101765, 3590321824, 3590321839, 'GB', 'GBR', 'المملكة المتحدة'),
(101766, 3590321840, 3590321855, 'US', 'USA', 'الولايات المتحدة'),
(101767, 3590321856, 3590321887, 'IQ', 'IRQ', 'العراق'),
(101768, 3590321888, 3590321927, 'GB', 'GBR', 'المملكة المتحدة'),
(101769, 3590321928, 3590321935, 'IQ', 'IRQ', 'العراق'),
(101770, 3590321936, 3590321943, 'LY', 'LBY', 'ليبيا'),
(101771, 3590321944, 3590321959, 'IQ', 'IRQ', 'العراق'),
(101772, 3590321960, 3590321967, 'GB', 'GBR', 'المملكة المتحدة'),
(101773, 3590321968, 3590321983, 'TR', 'TUR', 'تركيا'),
(101774, 3590321984, 3590322007, 'GB', 'GBR', 'المملكة المتحدة'),
(101775, 3590322008, 3590322015, 'IQ', 'IRQ', 'العراق'),
(101776, 3590322016, 3590322047, 'GB', 'GBR', 'المملكة المتحدة'),
(101777, 3590322048, 3590322055, 'NG', 'NGA', 'نيجيريا'),
(101778, 3590322056, 3590322063, 'GB', 'GBR', 'المملكة المتحدة'),
(101779, 3590322064, 3590322079, 'IQ', 'IRQ', 'العراق'),
(101780, 3590322080, 3590322111, 'GB', 'GBR', 'المملكة المتحدة'),
(101781, 3590322112, 3590322119, 'BJ', 'BEN', 'بنين'),
(101782, 3590322120, 3590322127, 'IQ', 'IRQ', 'العراق'),
(101783, 3590322128, 3590322135, 'GH', 'GHA', 'غانا'),
(101784, 3590322136, 3590322151, 'GB', 'GBR', 'المملكة المتحدة'),
(101785, 3590322152, 3590322159, 'LY', 'LBY', 'ليبيا'),
(101786, 3590322160, 3590322167, 'GB', 'GBR', 'المملكة المتحدة'),
(101787, 3590322168, 3590322239, 'IQ', 'IRQ', 'العراق'),
(101788, 3590322240, 3590322255, 'GB', 'GBR', 'المملكة المتحدة'),
(101789, 3590322256, 3590322271, 'RW', 'RWA', 'رواندا'),
(101790, 3590322272, 3590322335, 'GB', 'GBR', 'المملكة المتحدة'),
(101791, 3590322336, 3590322351, 'MG', 'MDG', 'مدغشقر'),
(101792, 3590322352, 3590322375, 'GB', 'GBR', 'المملكة المتحدة'),
(101793, 3590322376, 3590322383, 'LY', 'LBY', 'ليبيا'),
(101794, 3590322384, 3590322399, 'IQ', 'IRQ', 'العراق'),
(101795, 3590322400, 3590322415, 'AO', 'AGO', 'أنغولا'),
(101796, 3590322416, 3590322423, 'LR', 'LBR', 'ليبيريا'),
(101797, 3590322424, 3590322431, 'GB', 'GBR', 'المملكة المتحدة'),
(101798, 3590322432, 3590322559, 'LB', 'LBN', 'لبنان'),
(101799, 3590322560, 3590322575, 'GB', 'GBR', 'المملكة المتحدة'),
(101800, 3590322576, 3590322687, 'LB', 'LBN', 'لبنان'),
(101801, 3590322688, 3590323199, 'IQ', 'IRQ', 'العراق'),
(101802, 3590323200, 3590323711, 'MW', 'MWI', 'ملاوي'),
(101803, 3590323712, 3590323903, 'GB', 'GBR', 'المملكة المتحدة'),
(101804, 3590323904, 3590323911, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(101805, 3590323912, 3590324031, 'GB', 'GBR', 'المملكة المتحدة'),
(101806, 3590324032, 3590324095, 'NG', 'NGA', 'نيجيريا'),
(101807, 3590324096, 3590324223, 'GB', 'GBR', 'المملكة المتحدة'),
(101808, 3590324224, 3623890943, 'US', 'USA', 'الولايات المتحدة'),
(101809, 3623890944, 3623891199, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101810, 3623891200, 3623891455, 'US', 'USA', 'الولايات المتحدة'),
(101811, 3623891456, 3623891711, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101812, 3623891712, 3623891967, 'US', 'USA', 'الولايات المتحدة'),
(101813, 3623891968, 3623892479, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101814, 3623892480, 3624054783, 'US', 'USA', 'الولايات المتحدة'),
(101815, 3624054784, 3624056831, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101816, 3624056832, 3624181759, 'US', 'USA', 'الولايات المتحدة'),
(101817, 3624181760, 3624182783, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101818, 3624182784, 3624206335, 'US', 'USA', 'الولايات المتحدة'),
(101819, 3624206336, 3624208383, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101820, 3624208384, 3624255487, 'US', 'USA', 'الولايات المتحدة'),
(101821, 3624255488, 3624257535, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101822, 3624257536, 3624271871, 'US', 'USA', 'الولايات المتحدة'),
(101823, 3624271872, 3624272383, 'SY', 'SYR', 'سوريا'),
(101824, 3624272384, 3624279071, 'CA', 'CAN', 'كندا'),
(101825, 3624279072, 3624279087, 'BD', 'BGD', 'بنغالاديش'),
(101826, 3624279088, 3624288255, 'CA', 'CAN', 'كندا'),
(101827, 3624288256, 3624290303, 'IN', 'IND', 'الهند'),
(101828, 3624290304, 3624292351, 'CA', 'CAN', 'كندا'),
(101829, 3624292352, 3624292607, 'MF', 'MAF', 'سانت مارتن'),
(101830, 3624292608, 3624297471, 'CA', 'CAN', 'كندا'),
(101831, 3624297472, 3624298495, 'CO', 'COL', 'كولومبيا'),
(101832, 3624298496, 3624299519, 'PH', 'PHL', 'الفلبين'),
(101833, 3624299520, 3624303743, 'CA', 'CAN', 'كندا'),
(101834, 3624303744, 3624303759, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(101835, 3624303760, 3624304639, 'CA', 'CAN', 'كندا'),
(101836, 3624304640, 3624321023, 'US', 'USA', 'الولايات المتحدة'),
(101837, 3624321024, 3624325119, 'CA', 'CAN', 'كندا'),
(101838, 3624325120, 3624330511, 'US', 'USA', 'الولايات المتحدة'),
(101839, 3624330512, 3624330519, 'IN', 'IND', 'الهند'),
(101840, 3624330520, 3624333183, 'US', 'USA', 'الولايات المتحدة'),
(101841, 3624333184, 3624333215, 'IN', 'IND', 'الهند'),
(101842, 3624333216, 3624359679, 'US', 'USA', 'الولايات المتحدة'),
(101843, 3624359680, 3624360703, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(101844, 3624360704, 3624384767, 'US', 'USA', 'الولايات المتحدة'),
(101845, 3624384768, 3624385023, 'CA', 'CAN', 'كندا'),
(101846, 3624385024, 3624386559, 'US', 'USA', 'الولايات المتحدة'),
(101847, 3624386560, 3624394751, 'CA', 'CAN', 'كندا'),
(101848, 3624394752, 3624435711, 'US', 'USA', 'الولايات المتحدة'),
(101849, 3624435712, 3624452095, 'CA', 'CAN', 'كندا'),
(101850, 3624452096, 3624480767, 'US', 'USA', 'الولايات المتحدة'),
(101851, 3624480768, 3624484863, 'CA', 'CAN', 'كندا'),
(101852, 3624484864, 3624529919, 'US', 'USA', 'الولايات المتحدة'),
(101853, 3624529920, 3624534015, 'CA', 'CAN', 'كندا'),
(101854, 3624534016, 3624534271, 'PA', 'PAN', 'بنما'),
(101855, 3624534272, 3624536063, 'CA', 'CAN', 'كندا'),
(101856, 3624536064, 3624587263, 'US', 'USA', 'الولايات المتحدة'),
(101857, 3624587264, 3624591359, 'JM', 'JAM', 'جامايكا'),
(101858, 3624591360, 3624730623, 'US', 'USA', 'الولايات المتحدة'),
(101859, 3624730624, 3624796159, 'CA', 'CAN', 'كندا'),
(101860, 3624812544, 3624820735, 'US', 'USA', 'الولايات المتحدة'),
(101861, 3624820736, 3624820799, 'CY', 'CYP', 'قبرص'),
(101862, 3624820800, 3624821695, 'US', 'USA', 'الولايات المتحدة'),
(101863, 3624821696, 3624821703, 'GB', 'GBR', 'المملكة المتحدة'),
(101864, 3624821704, 3624828927, 'US', 'USA', 'الولايات المتحدة'),
(101865, 3624828928, 3624833023, 'CA', 'CAN', 'كندا'),
(101866, 3624833024, 3624845311, 'US', 'USA', 'الولايات المتحدة'),
(101867, 3624845312, 3624849407, 'AU', 'AUS', 'أستراليا'),
(101868, 3624849408, 3624903167, 'US', 'USA', 'الولايات المتحدة'),
(101869, 3624903168, 3624903423, 'CA', 'CAN', 'كندا'),
(101870, 3624903424, 3624903679, 'US', 'USA', 'الولايات المتحدة'),
(101871, 3624903680, 3624904447, 'CA', 'CAN', 'كندا'),
(101872, 3624904448, 3624905471, 'US', 'USA', 'الولايات المتحدة'),
(101873, 3624905472, 3624905727, 'CA', 'CAN', 'كندا'),
(101874, 3624905728, 3624964095, 'US', 'USA', 'الولايات المتحدة'),
(101875, 3624976384, 3624984575, 'US', 'USA', 'الولايات المتحدة'),
(101876, 3624984576, 3624990431, 'CA', 'CAN', 'كندا'),
(101877, 3624990432, 3624990463, 'US', 'USA', 'الولايات المتحدة'),
(101878, 3624990464, 3624991223, 'CA', 'CAN', 'كندا'),
(101879, 3624991224, 3624991231, 'US', 'USA', 'الولايات المتحدة'),
(101880, 3624991232, 3624992767, 'CA', 'CAN', 'كندا'),
(101881, 3624992768, 3625058303, 'US', 'USA', 'الولايات المتحدة'),
(101882, 3625058304, 3625091071, 'CA', 'CAN', 'كندا'),
(101883, 3625091072, 3625116671, 'US', 'USA', 'الولايات المتحدة'),
(101884, 3625116672, 3625116767, 'CA', 'CAN', 'كندا'),
(101885, 3625116768, 3625116775, 'US', 'USA', 'الولايات المتحدة'),
(101886, 3625116776, 3625116927, 'CA', 'CAN', 'كندا'),
(101887, 3625116928, 3625117775, 'US', 'USA', 'الولايات المتحدة'),
(101888, 3625117776, 3625117783, 'CA', 'CAN', 'كندا'),
(101889, 3625117784, 3625117791, 'US', 'USA', 'الولايات المتحدة'),
(101890, 3625117792, 3625117799, 'CA', 'CAN', 'كندا'),
(101891, 3625117800, 3625117807, 'US', 'USA', 'الولايات المتحدة'),
(101892, 3625117808, 3625117839, 'CA', 'CAN', 'كندا'),
(101893, 3625117840, 3625118233, 'US', 'USA', 'الولايات المتحدة'),
(101894, 3625118234, 3625118241, 'CA', 'CAN', 'كندا'),
(101895, 3625118242, 3625118271, 'US', 'USA', 'الولايات المتحدة'),
(101896, 3625118272, 3625118287, 'CA', 'CAN', 'كندا'),
(101897, 3625118288, 3625118975, 'US', 'USA', 'الولايات المتحدة'),
(101898, 3625118976, 3625119056, 'PL', 'POL', 'بولندا'),
(101899, 3625119057, 3625140223, 'US', 'USA', 'الولايات المتحدة'),
(101900, 3625140224, 3625148415, 'CA', 'CAN', 'كندا'),
(101901, 3625148416, 3625168895, 'US', 'USA', 'الولايات المتحدة'),
(101902, 3625168896, 3625172991, 'CA', 'CAN', 'كندا'),
(101903, 3625172992, 3625255935, 'US', 'USA', 'الولايات المتحدة'),
(101904, 3625256448, 3625256959, 'US', 'USA', 'الولايات المتحدة'),
(101905, 3625258496, 3625259519, 'US', 'USA', 'الولايات المتحدة'),
(101906, 3625260032, 3625287679, 'US', 'USA', 'الولايات المتحدة'),
(101907, 3625287680, 3625295871, 'CA', 'CAN', 'كندا'),
(101908, 3625295872, 3625304063, 'US', 'USA', 'الولايات المتحدة'),
(101909, 3625308160, 3625346047, 'US', 'USA', 'الولايات المتحدة'),
(101910, 3625346048, 3625346303, 'AR', 'ARG', 'الأرجنتين'),
(101911, 3625346304, 3625418751, 'US', 'USA', 'الولايات المتحدة'),
(101912, 3625418752, 3625420031, 'CA', 'CAN', 'كندا'),
(101913, 3625420032, 3625420543, 'US', 'USA', 'الولايات المتحدة'),
(101914, 3625420544, 3625422591, 'CA', 'CAN', 'كندا'),
(101915, 3625422592, 3625423103, 'US', 'USA', 'الولايات المتحدة'),
(101916, 3625423104, 3625426943, 'CA', 'CAN', 'كندا'),
(101917, 3625426944, 3625500671, 'US', 'USA', 'الولايات المتحدة'),
(101918, 3625504768, 3625508863, 'US', 'USA', 'الولايات المتحدة'),
(101919, 3625508864, 3625512959, 'CA', 'CAN', 'كندا'),
(101920, 3625512960, 3625517055, 'PR', 'PRI', 'بورتو ريكو'),
(101921, 3625517056, 3625631743, 'US', 'USA', 'الولايات المتحدة'),
(101922, 3625631744, 3625639935, 'CA', 'CAN', 'كندا'),
(101923, 3625639936, 3626025919, 'US', 'USA', 'الولايات المتحدة'),
(101924, 3626025920, 3626025951, 'LT', 'LTU', 'ليتوانيا'),
(101925, 3626025952, 3626060735, 'US', 'USA', 'الولايات المتحدة'),
(101926, 3626060736, 3626060743, 'BM', 'BMU', 'برمودا'),
(101927, 3626060744, 3626061903, 'US', 'USA', 'الولايات المتحدة'),
(101928, 3626061904, 3626061911, 'BM', 'BMU', 'برمودا'),
(101929, 3626061912, 3626069279, 'US', 'USA', 'الولايات المتحدة'),
(101930, 3626069280, 3626069311, 'NL', 'NLD', 'هولندا'),
(101931, 3626069312, 3626072959, 'US', 'USA', 'الولايات المتحدة'),
(101932, 3626072960, 3626072991, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101933, 3626072992, 3626073439, 'US', 'USA', 'الولايات المتحدة'),
(101934, 3626073440, 3626073455, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101935, 3626073456, 3626108895, 'US', 'USA', 'الولايات المتحدة'),
(101936, 3626108896, 3626108927, 'AU', 'AUS', 'أستراليا'),
(101937, 3626108928, 3626130415, 'US', 'USA', 'الولايات المتحدة'),
(101938, 3626130416, 3626130431, 'CA', 'CAN', 'كندا'),
(101939, 3626130432, 3626140479, 'US', 'USA', 'الولايات المتحدة'),
(101940, 3626140480, 3626140671, 'AU', 'AUS', 'أستراليا'),
(101941, 3626140672, 3626142623, 'US', 'USA', 'الولايات المتحدة'),
(101942, 3626142624, 3626142639, 'AU', 'AUS', 'أستراليا'),
(101943, 3626142640, 3626184191, 'US', 'USA', 'الولايات المتحدة'),
(101944, 3626184192, 3626184223, 'LT', 'LTU', 'ليتوانيا'),
(101945, 3626184224, 3626189359, 'US', 'USA', 'الولايات المتحدة'),
(101946, 3626189360, 3626189367, 'NO', 'NOR', 'النرويج'),
(101947, 3626189368, 3626189375, 'US', 'USA', 'الولايات المتحدة'),
(101948, 3626189376, 3626189383, 'IL', 'ISR', 'إسرائيل'),
(101949, 3626189384, 3626189431, 'US', 'USA', 'الولايات المتحدة'),
(101950, 3626189432, 3626189439, 'IL', 'ISR', 'إسرائيل'),
(101951, 3626189440, 3626191119, 'US', 'USA', 'الولايات المتحدة'),
(101952, 3626191120, 3626191135, 'GB', 'GBR', 'المملكة المتحدة'),
(101953, 3626191136, 3626192639, 'US', 'USA', 'الولايات المتحدة'),
(101954, 3626192640, 3626192703, 'CY', 'CYP', 'قبرص'),
(101955, 3626192704, 3626192767, 'US', 'USA', 'الولايات المتحدة'),
(101956, 3626192768, 3626192799, 'CH', 'CHE', 'سويسرا'),
(101957, 3626192800, 3626213439, 'US', 'USA', 'الولايات المتحدة'),
(101958, 3626213440, 3626213471, 'GB', 'GBR', 'المملكة المتحدة'),
(101959, 3626213472, 3626227167, 'US', 'USA', 'الولايات المتحدة'),
(101960, 3626227168, 3626227199, 'AR', 'ARG', 'الأرجنتين'),
(101961, 3626227200, 3626228463, 'US', 'USA', 'الولايات المتحدة'),
(101962, 3626228464, 3626228479, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(101963, 3626228480, 3626270719, 'US', 'USA', 'الولايات المتحدة'),
(101964, 3626270720, 3626287103, 'CA', 'CAN', 'كندا'),
(101965, 3626287104, 3626328063, 'US', 'USA', 'الولايات المتحدة'),
(101966, 3626336256, 3626508287, 'US', 'USA', 'الولايات المتحدة'),
(101967, 3626508288, 3626512383, 'CA', 'CAN', 'كندا'),
(101968, 3626512384, 3626524671, 'US', 'USA', 'الولايات المتحدة'),
(101969, 3626524672, 3626532863, 'CA', 'CAN', 'كندا'),
(101970, 3626532864, 3626852351, 'US', 'USA', 'الولايات المتحدة'),
(101971, 3626852352, 3626860543, 'CA', 'CAN', 'كندا'),
(101972, 3626860544, 3626893311, 'US', 'USA', 'الولايات المتحدة'),
(101973, 3626893312, 3626905599, 'CA', 'CAN', 'كندا'),
(101974, 3626905600, 3626926079, 'US', 'USA', 'الولايات المتحدة'),
(101975, 3626926080, 3626934271, 'CA', 'CAN', 'كندا'),
(101976, 3626934272, 3627044863, 'US', 'USA', 'الولايات المتحدة'),
(101977, 3627044864, 3627048959, 'CA', 'CAN', 'كندا'),
(101978, 3627048960, 3627065343, 'US', 'USA', 'الولايات المتحدة'),
(101979, 3627065344, 3627069439, 'CA', 'CAN', 'كندا'),
(101980, 3627069440, 3627387903, 'US', 'USA', 'الولايات المتحدة'),
(101981, 3627387904, 3627388415, 'BR', 'BRA', 'البرازيل'),
(101982, 3627388416, 3627400319, 'US', 'USA', 'الولايات المتحدة'),
(101983, 3627400320, 3627400351, 'BR', 'BRA', 'البرازيل'),
(101984, 3627400352, 3627401151, 'US', 'USA', 'الولايات المتحدة'),
(101985, 3627401152, 3627401215, 'BR', 'BRA', 'البرازيل'),
(101986, 3627401216, 3627507711, 'US', 'USA', 'الولايات المتحدة'),
(101987, 3627507712, 3627511807, 'CA', 'CAN', 'كندا'),
(101988, 3627511808, 3627532287, 'US', 'USA', 'الولايات المتحدة'),
(101989, 3627532288, 3627544575, 'CA', 'CAN', 'كندا'),
(101990, 3627544576, 3627659263, 'US', 'USA', 'الولايات المتحدة'),
(101991, 3627659264, 3627663359, 'CA', 'CAN', 'كندا'),
(101992, 3627663360, 3627665407, 'US', 'USA', 'الولايات المتحدة'),
(101993, 3627665408, 3627665439, 'CA', 'CAN', 'كندا'),
(101994, 3627665440, 3627666719, 'US', 'USA', 'الولايات المتحدة'),
(101995, 3627666720, 3627666751, 'CA', 'CAN', 'كندا'),
(101996, 3627666752, 3627679743, 'US', 'USA', 'الولايات المتحدة'),
(101997, 3627679744, 3627712511, 'CA', 'CAN', 'كندا'),
(101998, 3627712512, 3627728895, 'US', 'USA', 'الولايات المتحدة'),
(101999, 3627737088, 3627745343, 'US', 'USA', 'الولايات المتحدة'),
(102000, 3627745344, 3627745375, 'BE', 'BEL', 'بلجيكا'),
(102001, 3627745376, 3627746559, 'US', 'USA', 'الولايات المتحدة'),
(102002, 3627746560, 3627746815, 'IN', 'IND', 'الهند'),
(102003, 3627746816, 3627761663, 'US', 'USA', 'الولايات المتحدة'),
(102004, 3627778048, 3627802623, 'US', 'USA', 'الولايات المتحدة'),
(102005, 3627802624, 3627810815, 'CA', 'CAN', 'كندا'),
(102006, 3627810816, 3628123615, 'US', 'USA', 'الولايات المتحدة'),
(102007, 3628123616, 3628123647, 'CA', 'CAN', 'كندا'),
(102008, 3628123648, 3628123711, 'BM', 'BMU', 'برمودا'),
(102009, 3628123712, 3628123903, 'US', 'USA', 'الولايات المتحدة'),
(102010, 3628123904, 3628123935, 'GB', 'GBR', 'المملكة المتحدة'),
(102011, 3628123936, 3628128703, 'US', 'USA', 'الولايات المتحدة'),
(102012, 3628128704, 3628128719, 'CA', 'CAN', 'كندا'),
(102013, 3628128720, 3628129087, 'US', 'USA', 'الولايات المتحدة'),
(102014, 3628129088, 3628129103, 'CA', 'CAN', 'كندا'),
(102015, 3628129104, 3628139311, 'US', 'USA', 'الولايات المتحدة'),
(102016, 3628139312, 3628139327, 'SG', 'SGP', 'سنغافورة'),
(102017, 3628139328, 3628153087, 'US', 'USA', 'الولايات المتحدة'),
(102018, 3628153088, 3628153343, 'KW', 'KWT', 'الكويت'),
(102019, 3628153344, 3628154239, 'US', 'USA', 'الولايات المتحدة'),
(102020, 3628154240, 3628154303, 'PH', 'PHL', 'الفلبين'),
(102021, 3628154304, 3628154463, 'US', 'USA', 'الولايات المتحدة'),
(102022, 3628154464, 3628154495, 'GB', 'GBR', 'المملكة المتحدة'),
(102023, 3628154496, 3628155647, 'US', 'USA', 'الولايات المتحدة'),
(102024, 3628155648, 3628155903, 'CA', 'CAN', 'كندا'),
(102025, 3628155904, 3628179455, 'US', 'USA', 'الولايات المتحدة'),
(102026, 3628179456, 3628187647, 'CA', 'CAN', 'كندا'),
(102027, 3628187648, 3628208127, 'US', 'USA', 'الولايات المتحدة'),
(102028, 3628208128, 3628208383, 'IT', 'ITA', 'إيطاليا'),
(102029, 3628208384, 3628236799, 'US', 'USA', 'الولايات المتحدة'),
(102030, 3628236800, 3628257279, 'CA', 'CAN', 'كندا'),
(102031, 3628257280, 3628598271, 'US', 'USA', 'الولايات المتحدة'),
(102032, 3628598272, 3628599295, 'CO', 'COL', 'كولومبيا'),
(102033, 3628599296, 3628603391, 'CL', 'CHL', 'تشيلي'),
(102034, 3628603392, 3628604415, 'US', 'USA', 'الولايات المتحدة'),
(102035, 3628604416, 3628605439, 'GT', 'GTM', 'غواتيمالا'),
(102036, 3628605440, 3628608511, 'IL', 'ISR', 'إسرائيل'),
(102037, 3628608512, 3628609023, 'VE', 'VEN', 'فنزويلا'),
(102038, 3628609024, 3628616191, 'US', 'USA', 'الولايات المتحدة'),
(102039, 3628616192, 3628617215, 'PR', 'PRI', 'بورتو ريكو'),
(102040, 3628617216, 3628617471, 'HN', 'HND', 'هندوراس'),
(102041, 3628617472, 3628617727, 'US', 'USA', 'الولايات المتحدة'),
(102042, 3628617728, 3628618239, 'CO', 'COL', 'كولومبيا'),
(102043, 3628618240, 3628618495, 'US', 'USA', 'الولايات المتحدة'),
(102044, 3628618496, 3628619775, 'HN', 'HND', 'هندوراس'),
(102045, 3628619776, 3628622847, 'US', 'USA', 'الولايات المتحدة'),
(102046, 3628622848, 3628623871, 'PR', 'PRI', 'بورتو ريكو'),
(102047, 3628623872, 3628625919, 'NG', 'NGA', 'نيجيريا'),
(102048, 3628625920, 3628626175, 'US', 'USA', 'الولايات المتحدة'),
(102049, 3628626176, 3628626943, 'HN', 'HND', 'هندوراس'),
(102050, 3628626944, 3628627199, 'CO', 'COL', 'كولومبيا'),
(102051, 3628627200, 3628627455, 'IL', 'ISR', 'إسرائيل'),
(102052, 3628627456, 3628627711, 'HN', 'HND', 'هندوراس'),
(102053, 3628627712, 3628627967, 'US', 'USA', 'الولايات المتحدة'),
(102054, 3628627968, 3628628991, 'SV', 'SLV', 'السلفادور'),
(102055, 3628628992, 3628629247, 'GT', 'GTM', 'غواتيمالا'),
(102056, 3628629248, 3628629759, 'US', 'USA', 'الولايات المتحدة'),
(102057, 3628629760, 3628631807, 'VE', 'VEN', 'فنزويلا'),
(102058, 3628631808, 3628634111, 'US', 'USA', 'الولايات المتحدة'),
(102059, 3628634112, 3628636159, 'AR', 'ARG', 'الأرجنتين'),
(102060, 3628636160, 3628636671, 'VE', 'VEN', 'فنزويلا'),
(102061, 3628636672, 3628638207, 'US', 'USA', 'الولايات المتحدة'),
(102062, 3628638208, 3628646399, 'CL', 'CHL', 'تشيلي'),
(102063, 3628646400, 3628646911, 'US', 'USA', 'الولايات المتحدة'),
(102064, 3628646912, 3628647423, 'HN', 'HND', 'هندوراس'),
(102065, 3628647424, 3628647679, 'US', 'USA', 'الولايات المتحدة'),
(102066, 3628647680, 3628649727, 'CO', 'COL', 'كولومبيا'),
(102067, 3628649728, 3628655103, 'US', 'USA', 'الولايات المتحدة'),
(102068, 3628655104, 3628655359, 'VE', 'VEN', 'فنزويلا'),
(102069, 3628655360, 3628657407, 'CO', 'COL', 'كولومبيا'),
(102070, 3628657408, 3628657663, 'US', 'USA', 'الولايات المتحدة'),
(102071, 3628657664, 3628657919, 'VE', 'VEN', 'فنزويلا'),
(102072, 3628657920, 3628679167, 'US', 'USA', 'الولايات المتحدة'),
(102073, 3628679168, 3628683263, 'CA', 'CAN', 'كندا'),
(102074, 3628683264, 3628762335, 'US', 'USA', 'الولايات المتحدة'),
(102075, 3628762336, 3628762367, 'IL', 'ISR', 'إسرائيل'),
(102076, 3628762368, 3628762519, 'US', 'USA', 'الولايات المتحدة'),
(102077, 3628762520, 3628762527, 'CY', 'CYP', 'قبرص'),
(102078, 3628762528, 3628766143, 'US', 'USA', 'الولايات المتحدة'),
(102079, 3628766144, 3628766151, 'GB', 'GBR', 'المملكة المتحدة'),
(102080, 3628766152, 3628767039, 'US', 'USA', 'الولايات المتحدة'),
(102081, 3628767040, 3628767055, 'IE', 'IRL', 'إيرلندا'),
(102082, 3628767056, 3628767135, 'US', 'USA', 'الولايات المتحدة'),
(102083, 3628767136, 3628767167, 'GB', 'GBR', 'المملكة المتحدة'),
(102084, 3628767168, 3628767695, 'US', 'USA', 'الولايات المتحدة'),
(102085, 3628767696, 3628767703, 'NO', 'NOR', 'النرويج'),
(102086, 3628767704, 3628768223, 'US', 'USA', 'الولايات المتحدة'),
(102087, 3628768224, 3628768239, 'NO', 'NOR', 'النرويج'),
(102088, 3628768240, 3628770207, 'US', 'USA', 'الولايات المتحدة'),
(102089, 3628770208, 3628770215, 'NO', 'NOR', 'النرويج'),
(102090, 3628770216, 3628770367, 'US', 'USA', 'الولايات المتحدة'),
(102091, 3628770368, 3628770383, 'CY', 'CYP', 'قبرص'),
(102092, 3628770384, 3628771455, 'US', 'USA', 'الولايات المتحدة'),
(102093, 3628771456, 3628771647, 'GB', 'GBR', 'المملكة المتحدة'),
(102094, 3628771648, 3628771839, 'US', 'USA', 'الولايات المتحدة'),
(102095, 3628771840, 3628772095, 'NO', 'NOR', 'النرويج'),
(102096, 3628772096, 3628772415, 'US', 'USA', 'الولايات المتحدة'),
(102097, 3628772416, 3628772431, 'CA', 'CAN', 'كندا'),
(102098, 3628772432, 3628772447, 'GB', 'GBR', 'المملكة المتحدة'),
(102099, 3628772448, 3628834815, 'US', 'USA', 'الولايات المتحدة'),
(102100, 3628834816, 3628843007, 'CA', 'CAN', 'كندا'),
(102101, 3628843008, 3629187071, 'US', 'USA', 'الولايات المتحدة'),
(102102, 3629187072, 3629195263, 'CA', 'CAN', 'كندا'),
(102103, 3629195264, 3629199359, 'US', 'USA', 'الولايات المتحدة'),
(102104, 3629199360, 3629203455, 'CA', 'CAN', 'كندا'),
(102105, 3629203456, 3629318143, 'US', 'USA', 'الولايات المتحدة'),
(102106, 3629318144, 3629326335, 'CA', 'CAN', 'كندا'),
(102107, 3629326336, 3629539327, 'US', 'USA', 'الولايات المتحدة'),
(102108, 3629539328, 3629547519, 'CA', 'CAN', 'كندا'),
(102109, 3629547520, 3629662207, 'US', 'USA', 'الولايات المتحدة'),
(102110, 3629662208, 3629662463, 'GB', 'GBR', 'المملكة المتحدة'),
(102111, 3629662464, 3629735943, 'US', 'USA', 'الولايات المتحدة'),
(102112, 3629735944, 3629735951, 'CA', 'CAN', 'كندا'),
(102113, 3629735952, 3629736119, 'US', 'USA', 'الولايات المتحدة'),
(102114, 3629736120, 3629736127, 'CA', 'CAN', 'كندا'),
(102115, 3629736128, 3629737215, 'US', 'USA', 'الولايات المتحدة'),
(102116, 3629737216, 3629737471, 'CA', 'CAN', 'كندا'),
(102117, 3629737472, 3629761551, 'US', 'USA', 'الولايات المتحدة'),
(102118, 3629761552, 3629761567, 'CA', 'CAN', 'كندا'),
(102119, 3629761568, 3629767935, 'US', 'USA', 'الولايات المتحدة'),
(102120, 3629767936, 3629768191, 'CA', 'CAN', 'كندا'),
(102121, 3629768192, 3629789439, 'US', 'USA', 'الولايات المتحدة'),
(102122, 3629789440, 3629789695, 'CA', 'CAN', 'كندا'),
(102123, 3629789696, 3629789951, 'US', 'USA', 'الولايات المتحدة'),
(102124, 3629789952, 3629790207, 'CA', 'CAN', 'كندا'),
(102125, 3629790208, 3629808095, 'US', 'USA', 'الولايات المتحدة'),
(102126, 3629808096, 3629808127, 'CA', 'CAN', 'كندا'),
(102127, 3629808128, 3629838551, 'US', 'USA', 'الولايات المتحدة'),
(102128, 3629838552, 3629838559, 'CA', 'CAN', 'كندا'),
(102129, 3629838560, 3629838583, 'US', 'USA', 'الولايات المتحدة'),
(102130, 3629838584, 3629838591, 'CA', 'CAN', 'كندا'),
(102131, 3629838592, 3629841951, 'US', 'USA', 'الولايات المتحدة'),
(102132, 3629841952, 3629841983, 'CA', 'CAN', 'كندا'),
(102133, 3629841984, 3629859551, 'US', 'USA', 'الولايات المتحدة'),
(102134, 3629859552, 3629859583, 'CA', 'CAN', 'كندا'),
(102135, 3629859584, 3629875775, 'US', 'USA', 'الولايات المتحدة'),
(102136, 3629875776, 3629875807, 'CA', 'CAN', 'كندا'),
(102137, 3629875808, 3629876255, 'US', 'USA', 'الولايات المتحدة'),
(102138, 3629876256, 3629876263, 'CA', 'CAN', 'كندا'),
(102139, 3629876264, 3630039039, 'US', 'USA', 'الولايات المتحدة'),
(102140, 3630039040, 3630039295, 'CA', 'CAN', 'كندا'),
(102141, 3630039296, 3630040063, 'US', 'USA', 'الولايات المتحدة'),
(102142, 3630040064, 3630040319, 'CA', 'CAN', 'كندا'),
(102143, 3630040320, 3630040575, 'US', 'USA', 'الولايات المتحدة'),
(102144, 3630040576, 3630040831, 'CA', 'CAN', 'كندا'),
(102145, 3630040832, 3630041343, 'US', 'USA', 'الولايات المتحدة'),
(102146, 3630041344, 3630041599, 'CA', 'CAN', 'كندا'),
(102147, 3630041600, 3630041863, 'US', 'USA', 'الولايات المتحدة'),
(102148, 3630041864, 3630041871, 'CA', 'CAN', 'كندا'),
(102149, 3630041872, 3630041911, 'US', 'USA', 'الولايات المتحدة'),
(102150, 3630041912, 3630041919, 'CA', 'CAN', 'كندا'),
(102151, 3630041920, 3630042095, 'US', 'USA', 'الولايات المتحدة'),
(102152, 3630042096, 3630042103, 'CA', 'CAN', 'كندا'),
(102153, 3630042104, 3630042391, 'US', 'USA', 'الولايات المتحدة'),
(102154, 3630042392, 3630042399, 'CA', 'CAN', 'كندا'),
(102155, 3630042400, 3630042463, 'US', 'USA', 'الولايات المتحدة'),
(102156, 3630042464, 3630042471, 'CA', 'CAN', 'كندا'),
(102157, 3630042472, 3630042479, 'US', 'USA', 'الولايات المتحدة'),
(102158, 3630042480, 3630042487, 'CA', 'CAN', 'كندا'),
(102159, 3630042488, 3630042599, 'US', 'USA', 'الولايات المتحدة'),
(102160, 3630042600, 3630042607, 'CA', 'CAN', 'كندا'),
(102161, 3630042608, 3630044927, 'US', 'USA', 'الولايات المتحدة'),
(102162, 3630044928, 3630045183, 'CA', 'CAN', 'كندا'),
(102163, 3630045184, 3630045695, 'US', 'USA', 'الولايات المتحدة'),
(102164, 3630045696, 3630046207, 'CA', 'CAN', 'كندا'),
(102165, 3630046208, 3630046591, 'US', 'USA', 'الولايات المتحدة'),
(102166, 3630046592, 3630047231, 'CA', 'CAN', 'كندا'),
(102167, 3630047232, 3630048767, 'US', 'USA', 'الولايات المتحدة'),
(102168, 3630048768, 3630049023, 'CA', 'CAN', 'كندا'),
(102169, 3630049024, 3630049279, 'US', 'USA', 'الولايات المتحدة'),
(102170, 3630049280, 3630049535, 'CA', 'CAN', 'كندا'),
(102171, 3630049536, 3630050479, 'US', 'USA', 'الولايات المتحدة'),
(102172, 3630050480, 3630050487, 'CA', 'CAN', 'كندا'),
(102173, 3630050488, 3630050527, 'US', 'USA', 'الولايات المتحدة'),
(102174, 3630050528, 3630050535, 'CA', 'CAN', 'كندا'),
(102175, 3630050536, 3630050559, 'US', 'USA', 'الولايات المتحدة'),
(102176, 3630050560, 3630050815, 'CA', 'CAN', 'كندا'),
(102177, 3630050816, 3630051839, 'US', 'USA', 'الولايات المتحدة'),
(102178, 3630051840, 3630052351, 'CA', 'CAN', 'كندا'),
(102179, 3630052352, 3630054655, 'US', 'USA', 'الولايات المتحدة'),
(102180, 3630054656, 3630055167, 'CA', 'CAN', 'كندا'),
(102181, 3630055168, 3630055615, 'US', 'USA', 'الولايات المتحدة'),
(102182, 3630055616, 3630055647, 'CA', 'CAN', 'كندا'),
(102183, 3630055648, 3630055935, 'US', 'USA', 'الولايات المتحدة'),
(102184, 3630055936, 3630056959, 'CA', 'CAN', 'كندا'),
(102185, 3630056960, 3630060223, 'US', 'USA', 'الولايات المتحدة'),
(102186, 3630060224, 3630060287, 'CA', 'CAN', 'كندا'),
(102187, 3630060288, 3630062335, 'US', 'USA', 'الولايات المتحدة'),
(102188, 3630062336, 3630062591, 'CA', 'CAN', 'كندا'),
(102189, 3630062592, 3630062847, 'US', 'USA', 'الولايات المتحدة'),
(102190, 3630062848, 3630063103, 'CA', 'CAN', 'كندا'),
(102191, 3630063104, 3630066175, 'US', 'USA', 'الولايات المتحدة'),
(102192, 3630066176, 3630066431, 'CA', 'CAN', 'كندا'),
(102193, 3630066432, 3630066687, 'US', 'USA', 'الولايات المتحدة'),
(102194, 3630066688, 3630067967, 'CA', 'CAN', 'كندا'),
(102195, 3630067968, 3630069503, 'US', 'USA', 'الولايات المتحدة'),
(102196, 3630069504, 3630069759, 'CA', 'CAN', 'كندا'),
(102197, 3630069760, 3630070783, 'US', 'USA', 'الولايات المتحدة'),
(102198, 3630070784, 3630071039, 'CA', 'CAN', 'كندا'),
(102199, 3630071040, 3630073087, 'US', 'USA', 'الولايات المتحدة'),
(102200, 3630073088, 3630073343, 'CA', 'CAN', 'كندا'),
(102201, 3630073344, 3630073599, 'US', 'USA', 'الولايات المتحدة'),
(102202, 3630073600, 3630073855, 'CA', 'CAN', 'كندا'),
(102203, 3630073856, 3630074543, 'US', 'USA', 'الولايات المتحدة'),
(102204, 3630074544, 3630074551, 'CA', 'CAN', 'كندا'),
(102205, 3630074552, 3630074607, 'US', 'USA', 'الولايات المتحدة'),
(102206, 3630074608, 3630074615, 'CA', 'CAN', 'كندا'),
(102207, 3630074616, 3630074815, 'US', 'USA', 'الولايات المتحدة'),
(102208, 3630074816, 3630074879, 'CA', 'CAN', 'كندا'),
(102209, 3630074880, 3630075391, 'US', 'USA', 'الولايات المتحدة'),
(102210, 3630075392, 3630075647, 'CA', 'CAN', 'كندا'),
(102211, 3630075648, 3630077183, 'US', 'USA', 'الولايات المتحدة'),
(102212, 3630077184, 3630077439, 'CA', 'CAN', 'كندا'),
(102213, 3630077440, 3630077951, 'US', 'USA', 'الولايات المتحدة'),
(102214, 3630077952, 3630078015, 'CA', 'CAN', 'كندا'),
(102215, 3630078016, 3630078463, 'US', 'USA', 'الولايات المتحدة'),
(102216, 3630078464, 3630078719, 'CA', 'CAN', 'كندا'),
(102217, 3630078720, 3630080511, 'US', 'USA', 'الولايات المتحدة'),
(102218, 3630080512, 3630080575, 'CA', 'CAN', 'كندا'),
(102219, 3630080576, 3630081279, 'US', 'USA', 'الولايات المتحدة'),
(102220, 3630081280, 3630081535, 'CA', 'CAN', 'كندا'),
(102221, 3630081536, 3630082047, 'US', 'USA', 'الولايات المتحدة'),
(102222, 3630082048, 3630082303, 'CA', 'CAN', 'كندا'),
(102223, 3630082304, 3630085119, 'US', 'USA', 'الولايات المتحدة'),
(102224, 3630085120, 3630085375, 'CA', 'CAN', 'كندا'),
(102225, 3630085376, 3630088703, 'US', 'USA', 'الولايات المتحدة'),
(102226, 3630088704, 3630088959, 'CA', 'CAN', 'كندا'),
(102227, 3630088960, 3630089471, 'US', 'USA', 'الولايات المتحدة'),
(102228, 3630089472, 3630090239, 'CA', 'CAN', 'كندا'),
(102229, 3630090240, 3630091263, 'US', 'USA', 'الولايات المتحدة'),
(102230, 3630091264, 3630091519, 'CA', 'CAN', 'كندا'),
(102231, 3630091520, 3630092031, 'US', 'USA', 'الولايات المتحدة'),
(102232, 3630092032, 3630092287, 'CA', 'CAN', 'كندا'),
(102233, 3630092288, 3630093439, 'US', 'USA', 'الولايات المتحدة'),
(102234, 3630093440, 3630093447, 'CA', 'CAN', 'كندا'),
(102235, 3630093448, 3630093527, 'US', 'USA', 'الولايات المتحدة'),
(102236, 3630093528, 3630093535, 'CA', 'CAN', 'كندا'),
(102237, 3630093536, 3630094591, 'US', 'USA', 'الولايات المتحدة'),
(102238, 3630094592, 3630094847, 'CA', 'CAN', 'كندا'),
(102239, 3630094848, 3630095015, 'US', 'USA', 'الولايات المتحدة'),
(102240, 3630095016, 3630095023, 'CA', 'CAN', 'كندا'),
(102241, 3630095024, 3630095039, 'US', 'USA', 'الولايات المتحدة'),
(102242, 3630095040, 3630095047, 'CA', 'CAN', 'كندا'),
(102243, 3630095048, 3630097663, 'US', 'USA', 'الولايات المتحدة'),
(102244, 3630097664, 3630098175, 'KW', 'KWT', 'الكويت'),
(102245, 3630098176, 3630098687, 'US', 'USA', 'الولايات المتحدة'),
(102246, 3630098688, 3630100223, 'CA', 'CAN', 'كندا'),
(102247, 3630100224, 3630100479, 'KW', 'KWT', 'الكويت'),
(102248, 3630100480, 3630102783, 'US', 'USA', 'الولايات المتحدة'),
(102249, 3630102784, 3630103807, 'CA', 'CAN', 'كندا'),
(102250, 3630103808, 3630141503, 'US', 'USA', 'الولايات المتحدة'),
(102251, 3630141504, 3630141567, 'CA', 'CAN', 'كندا'),
(102252, 3630141568, 3630142463, 'US', 'USA', 'الولايات المتحدة'),
(102253, 3630142464, 3630143231, 'CA', 'CAN', 'كندا'),
(102254, 3630143232, 3630143615, 'US', 'USA', 'الولايات المتحدة'),
(102255, 3630143616, 3630143647, 'CA', 'CAN', 'كندا'),
(102256, 3630143648, 3630143711, 'US', 'USA', 'الولايات المتحدة'),
(102257, 3630143712, 3630143743, 'CA', 'CAN', 'كندا'),
(102258, 3630143744, 3630144511, 'US', 'USA', 'الولايات المتحدة'),
(102259, 3630144512, 3630145023, 'CA', 'CAN', 'كندا'),
(102260, 3630145024, 3630145535, 'US', 'USA', 'الولايات المتحدة'),
(102261, 3630145536, 3630145791, 'CA', 'CAN', 'كندا'),
(102262, 3630145792, 3630146047, 'US', 'USA', 'الولايات المتحدة'),
(102263, 3630146048, 3630146815, 'CA', 'CAN', 'كندا'),
(102264, 3630146816, 3630147327, 'US', 'USA', 'الولايات المتحدة'),
(102265, 3630147328, 3630147583, 'CA', 'CAN', 'كندا'),
(102266, 3630147584, 3630149535, 'US', 'USA', 'الولايات المتحدة'),
(102267, 3630149536, 3630149567, 'CA', 'CAN', 'كندا'),
(102268, 3630149568, 3630149631, 'US', 'USA', 'الولايات المتحدة'),
(102269, 3630149632, 3630149887, 'CA', 'CAN', 'كندا'),
(102270, 3630149888, 3630150911, 'US', 'USA', 'الولايات المتحدة'),
(102271, 3630150912, 3630151167, 'CA', 'CAN', 'كندا'),
(102272, 3630151168, 3630151455, 'US', 'USA', 'الولايات المتحدة'),
(102273, 3630151456, 3630151487, 'CA', 'CAN', 'كندا'),
(102274, 3630151488, 3630151615, 'US', 'USA', 'الولايات المتحدة'),
(102275, 3630151616, 3630151647, 'CA', 'CAN', 'كندا'),
(102276, 3630151648, 3630151679, 'US', 'USA', 'الولايات المتحدة'),
(102277, 3630151680, 3630152191, 'CA', 'CAN', 'كندا'),
(102278, 3630152192, 3630152447, 'US', 'USA', 'الولايات المتحدة'),
(102279, 3630152448, 3630152703, 'CA', 'CAN', 'كندا'),
(102280, 3630152704, 3630156031, 'US', 'USA', 'الولايات المتحدة'),
(102281, 3630156032, 3630156287, 'CA', 'CAN', 'كندا'),
(102282, 3630156288, 3630156543, 'US', 'USA', 'الولايات المتحدة'),
(102283, 3630156544, 3630156799, 'CA', 'CAN', 'كندا'),
(102284, 3630156800, 3630157055, 'US', 'USA', 'الولايات المتحدة'),
(102285, 3630157056, 3630157311, 'CA', 'CAN', 'كندا'),
(102286, 3630157312, 3630157567, 'US', 'USA', 'الولايات المتحدة'),
(102287, 3630157568, 3630158087, 'CA', 'CAN', 'كندا'),
(102288, 3630158088, 3630158231, 'US', 'USA', 'الولايات المتحدة'),
(102289, 3630158232, 3630158239, 'CA', 'CAN', 'كندا'),
(102290, 3630158240, 3630158303, 'US', 'USA', 'الولايات المتحدة'),
(102291, 3630158304, 3630158311, 'CA', 'CAN', 'كندا'),
(102292, 3630158312, 3630159007, 'US', 'USA', 'الولايات المتحدة'),
(102293, 3630159008, 3630159071, 'CA', 'CAN', 'كندا'),
(102294, 3630159072, 3630159103, 'US', 'USA', 'الولايات المتحدة'),
(102295, 3630159104, 3630159359, 'CA', 'CAN', 'كندا'),
(102296, 3630159360, 3630160487, 'US', 'USA', 'الولايات المتحدة'),
(102297, 3630160488, 3630160495, 'CA', 'CAN', 'كندا'),
(102298, 3630160496, 3630160591, 'US', 'USA', 'الولايات المتحدة'),
(102299, 3630160592, 3630160599, 'CA', 'CAN', 'كندا'),
(102300, 3630160600, 3630160607, 'US', 'USA', 'الولايات المتحدة'),
(102301, 3630160608, 3630160895, 'CA', 'CAN', 'كندا'),
(102302, 3630160896, 3630161151, 'US', 'USA', 'الولايات المتحدة'),
(102303, 3630161152, 3630161919, 'CA', 'CAN', 'كندا'),
(102304, 3630161920, 3630162687, 'US', 'USA', 'الولايات المتحدة'),
(102305, 3630162688, 3630162943, 'CA', 'CAN', 'كندا'),
(102306, 3630162944, 3630163887, 'US', 'USA', 'الولايات المتحدة'),
(102307, 3630163888, 3630163895, 'CA', 'CAN', 'كندا'),
(102308, 3630163896, 3630164223, 'US', 'USA', 'الولايات المتحدة'),
(102309, 3630164224, 3630164735, 'CA', 'CAN', 'كندا'),
(102310, 3630164736, 3630164751, 'US', 'USA', 'الولايات المتحدة'),
(102311, 3630164752, 3630164767, 'CA', 'CAN', 'كندا'),
(102312, 3630164768, 3630164783, 'US', 'USA', 'الولايات المتحدة'),
(102313, 3630164784, 3630164799, 'CA', 'CAN', 'كندا'),
(102314, 3630164800, 3630164815, 'US', 'USA', 'الولايات المتحدة'),
(102315, 3630164816, 3630164831, 'CA', 'CAN', 'كندا'),
(102316, 3630164832, 3630165247, 'US', 'USA', 'الولايات المتحدة'),
(102317, 3630165248, 3630165759, 'CA', 'CAN', 'كندا'),
(102318, 3630165760, 3630166015, 'US', 'USA', 'الولايات المتحدة'),
(102319, 3630166016, 3630166527, 'CA', 'CAN', 'كندا'),
(102320, 3630166528, 3630166687, 'US', 'USA', 'الولايات المتحدة'),
(102321, 3630166688, 3630166719, 'CA', 'CAN', 'كندا'),
(102322, 3630166720, 3630167583, 'US', 'USA', 'الولايات المتحدة'),
(102323, 3630167584, 3630167615, 'CA', 'CAN', 'كندا'),
(102324, 3630167616, 3630167711, 'US', 'USA', 'الولايات المتحدة'),
(102325, 3630167712, 3630167743, 'CA', 'CAN', 'كندا'),
(102326, 3630167744, 3630167807, 'US', 'USA', 'الولايات المتحدة'),
(102327, 3630167808, 3630167823, 'CA', 'CAN', 'كندا'),
(102328, 3630167824, 3630167903, 'US', 'USA', 'الولايات المتحدة'),
(102329, 3630167904, 3630167911, 'CA', 'CAN', 'كندا'),
(102330, 3630167912, 3630168319, 'US', 'USA', 'الولايات المتحدة'),
(102331, 3630168320, 3630169087, 'CA', 'CAN', 'كندا'),
(102332, 3630169088, 3630309375, 'US', 'USA', 'الولايات المتحدة'),
(102333, 3630309376, 3630317567, 'CA', 'CAN', 'كندا'),
(102334, 3630317568, 3630370815, 'US', 'USA', 'الولايات المتحدة'),
(102335, 3630372864, 3630374911, 'US', 'USA', 'الولايات المتحدة'),
(102336, 3630374912, 3630383103, 'CA', 'CAN', 'كندا'),
(102337, 3630383104, 3630391295, 'US', 'USA', 'الولايات المتحدة'),
(102338, 3630391296, 3630395391, 'CA', 'CAN', 'كندا'),
(102339, 3630395392, 3630718975, 'US', 'USA', 'الولايات المتحدة'),
(102340, 3630718976, 3630727167, 'CA', 'CAN', 'كندا'),
(102341, 3630727168, 3630746879, 'US', 'USA', 'الولايات المتحدة'),
(102342, 3630746880, 3630747391, 'TZ', 'TZA', 'تانزانيا'),
(102343, 3630747392, 3630780415, 'US', 'USA', 'الولايات المتحدة'),
(102344, 3630780416, 3630784511, 'CA', 'CAN', 'كندا'),
(102345, 3630784512, 3630850047, 'US', 'USA', 'الولايات المتحدة'),
(102346, 3630850048, 3630854143, 'CA', 'CAN', 'كندا'),
(102347, 3630854144, 3630956543, 'US', 'USA', 'الولايات المتحدة'),
(102348, 3630956544, 3631005695, 'CA', 'CAN', 'كندا'),
(102349, 3631005696, 3631039439, 'US', 'USA', 'الولايات المتحدة'),
(102350, 3631039440, 3631039455, 'CA', 'CAN', 'كندا'),
(102351, 3631039456, 3631039487, 'US', 'USA', 'الولايات المتحدة'),
(102352, 3631039488, 3631039743, 'CA', 'CAN', 'كندا'),
(102353, 3631039744, 3631043663, 'US', 'USA', 'الولايات المتحدة'),
(102354, 3631043664, 3631043679, 'CA', 'CAN', 'كندا'),
(102355, 3631043680, 3631043759, 'US', 'USA', 'الولايات المتحدة'),
(102356, 3631043760, 3631043767, 'CA', 'CAN', 'كندا'),
(102357, 3631043768, 3631045631, 'US', 'USA', 'الولايات المتحدة'),
(102358, 3631045632, 3631045759, 'CA', 'CAN', 'كندا'),
(102359, 3631045760, 3631045983, 'US', 'USA', 'الولايات المتحدة'),
(102360, 3631045984, 3631045991, 'CA', 'CAN', 'كندا'),
(102361, 3631045992, 3631112191, 'US', 'USA', 'الولايات المتحدة'),
(102362, 3631112192, 3631112703, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(102363, 3631112704, 3631116543, 'BB', 'BRB', 'باربادوس'),
(102364, 3631116544, 3631117567, 'GD', 'GRD', 'غرينادا'),
(102365, 3631117568, 3631117823, 'BB', 'BRB', 'باربادوس'),
(102366, 3631117824, 3631118079, 'GD', 'GRD', 'غرينادا'),
(102367, 3631118080, 3631119103, 'VC', 'VCT', 'سانت فنسنت وغرينادين'),
(102368, 3631119104, 3631119615, 'BB', 'BRB', 'باربادوس'),
(102369, 3631119616, 3631120383, 'GD', 'GRD', 'غرينادا'),
(102370, 3631120384, 3631144959, 'US', 'USA', 'الولايات المتحدة'),
(102371, 3631144960, 3631153151, 'CA', 'CAN', 'كندا'),
(102372, 3631153152, 3631284223, 'US', 'USA', 'الولايات المتحدة'),
(102373, 3631284224, 3631316991, 'CA', 'CAN', 'كندا'),
(102374, 3631316992, 3631333375, 'US', 'USA', 'الولايات المتحدة'),
(102375, 3631333376, 3631333679, 'CA', 'CAN', 'كندا'),
(102376, 3631333680, 3631333695, 'US', 'USA', 'الولايات المتحدة'),
(102377, 3631333696, 3631341567, 'CA', 'CAN', 'كندا'),
(102378, 3631341568, 3631480831, 'US', 'USA', 'الولايات المتحدة'),
(102379, 3631480832, 3631484927, 'CA', 'CAN', 'كندا'),
(102380, 3631484928, 3631515647, 'US', 'USA', 'الولايات المتحدة'),
(102381, 3631517696, 3631644671, 'US', 'USA', 'الولايات المتحدة'),
(102382, 3631644672, 3631652863, 'CA', 'CAN', 'كندا'),
(102383, 3631652864, 3631663151, 'US', 'USA', 'الولايات المتحدة'),
(102384, 3631663152, 3631663159, 'CA', 'CAN', 'كندا'),
(102385, 3631663160, 3631665151, 'US', 'USA', 'الولايات المتحدة'),
(102386, 3631665152, 3631669247, 'CA', 'CAN', 'كندا'),
(102387, 3631669248, 3631714303, 'US', 'USA', 'الولايات المتحدة'),
(102388, 3631718400, 3631841279, 'US', 'USA', 'الولايات المتحدة'),
(102389, 3631841280, 3631874047, 'CA', 'CAN', 'كندا'),
(102390, 3631874048, 3631939583, 'US', 'USA', 'الولايات المتحدة'),
(102391, 3631939584, 3632005119, 'CA', 'CAN', 'كندا'),
(102392, 3632005120, 3632136191, 'US', 'USA', 'الولايات المتحدة'),
(102393, 3632144384, 3632152575, 'US', 'USA', 'الولايات المتحدة'),
(102394, 3632152576, 3632168959, 'CA', 'CAN', 'كندا'),
(102395, 3632168960, 3632197631, 'US', 'USA', 'الولايات المتحدة'),
(102396, 3632197632, 3632201727, 'CA', 'CAN', 'كندا'),
(102397, 3632201728, 3632332799, 'US', 'USA', 'الولايات المتحدة'),
(102398, 3632332800, 3632357375, 'CA', 'CAN', 'كندا'),
(102399, 3632357376, 3632381951, 'US', 'USA', 'الولايات المتحدة'),
(102400, 3632381952, 3632390143, 'CA', 'CAN', 'كندا'),
(102401, 3632390144, 3632414719, 'US', 'USA', 'الولايات المتحدة'),
(102402, 3632414720, 3632422911, 'CA', 'CAN', 'كندا'),
(102403, 3632422912, 3632447487, 'US', 'USA', 'الولايات المتحدة'),
(102404, 3632455680, 3632467967, 'US', 'USA', 'الولايات المتحدة'),
(102405, 3632470016, 3632826495, 'US', 'USA', 'الولايات المتحدة'),
(102406, 3632826496, 3632826511, 'CN', 'CHN', 'الصين'),
(102407, 3632826512, 3632833231, 'US', 'USA', 'الولايات المتحدة'),
(102408, 3632833232, 3632833247, 'CN', 'CHN', 'الصين'),
(102409, 3632833248, 3632837135, 'US', 'USA', 'الولايات المتحدة'),
(102410, 3632837136, 3632837151, 'IN', 'IND', 'الهند'),
(102411, 3632837152, 3632838399, 'US', 'USA', 'الولايات المتحدة'),
(102412, 3632838400, 3632838431, 'TW', 'TWN', 'تايوان'),
(102413, 3632838432, 3632838583, 'US', 'USA', 'الولايات المتحدة'),
(102414, 3632838584, 3632838591, 'CN', 'CHN', 'الصين'),
(102415, 3632838592, 3632847279, 'US', 'USA', 'الولايات المتحدة'),
(102416, 3632847280, 3632847295, 'CN', 'CHN', 'الصين'),
(102417, 3632847296, 3632857087, 'US', 'USA', 'الولايات المتحدة'),
(102418, 3632857088, 3632861183, 'BS', 'BHS', 'جزر البهاما'),
(102419, 3632861184, 3632881663, 'US', 'USA', 'الولايات المتحدة'),
(102420, 3632881664, 3632889855, 'CA', 'CAN', 'كندا'),
(102421, 3632889856, 3632898047, 'US', 'USA', 'الولايات المتحدة'),
(102422, 3632898048, 3632902143, 'CA', 'CAN', 'كندا'),
(102423, 3632902144, 3632971775, 'US', 'USA', 'الولايات المتحدة'),
(102424, 3632971776, 3632988159, 'CA', 'CAN', 'كندا'),
(102425, 3632988160, 3633030159, 'US', 'USA', 'الولايات المتحدة'),
(102426, 3633030160, 3633030167, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102427, 3633030168, 3633030175, 'US', 'USA', 'الولايات المتحدة'),
(102428, 3633030176, 3633030183, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102429, 3633030184, 3633030191, 'US', 'USA', 'الولايات المتحدة'),
(102430, 3633030192, 3633030199, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102431, 3633030200, 3633030207, 'US', 'USA', 'الولايات المتحدة'),
(102432, 3633030208, 3633030215, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102433, 3633030216, 3633030223, 'NG', 'NGA', 'نيجيريا'),
(102434, 3633030224, 3633030231, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102435, 3633030232, 3633030287, 'US', 'USA', 'الولايات المتحدة'),
(102436, 3633030288, 3633030303, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102437, 3633030304, 3633030335, 'US', 'USA', 'الولايات المتحدة'),
(102438, 3633030336, 3633030359, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102439, 3633030360, 3633030655, 'US', 'USA', 'الولايات المتحدة'),
(102440, 3633030656, 3633030911, 'SN', 'SEN', 'السنغال'),
(102441, 3633030912, 3633031615, 'US', 'USA', 'الولايات المتحدة'),
(102442, 3633031616, 3633031623, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102443, 3633031624, 3633031647, 'US', 'USA', 'الولايات المتحدة'),
(102444, 3633031648, 3633031655, 'NG', 'NGA', 'نيجيريا'),
(102445, 3633031656, 3633031959, 'US', 'USA', 'الولايات المتحدة'),
(102446, 3633031960, 3633031967, 'NL', 'NLD', 'هولندا'),
(102447, 3633031968, 3633031983, 'US', 'USA', 'الولايات المتحدة'),
(102448, 3633031984, 3633031991, 'PG', 'PNG', 'بابوا غينيا الجديدة'),
(102449, 3633031992, 3633032087, 'US', 'USA', 'الولايات المتحدة'),
(102450, 3633032088, 3633032095, 'NL', 'NLD', 'هولندا'),
(102451, 3633032096, 3633032167, 'US', 'USA', 'الولايات المتحدة'),
(102452, 3633032168, 3633032175, 'NL', 'NLD', 'هولندا'),
(102453, 3633032176, 3633032223, 'US', 'USA', 'الولايات المتحدة'),
(102454, 3633032224, 3633032231, 'NG', 'NGA', 'نيجيريا'),
(102455, 3633032232, 3633032239, 'US', 'USA', 'الولايات المتحدة'),
(102456, 3633032240, 3633032247, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102457, 3633032248, 3633032271, 'US', 'USA', 'الولايات المتحدة'),
(102458, 3633032272, 3633032279, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102459, 3633032280, 3633032287, 'US', 'USA', 'الولايات المتحدة'),
(102460, 3633032288, 3633032319, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(102461, 3633032320, 3633032415, 'US', 'USA', 'الولايات المتحدة'),
(102462, 3633032416, 3633032431, 'NG', 'NGA', 'نيجيريا'),
(102463, 3633032432, 3633032439, 'US', 'USA', 'الولايات المتحدة'),
(102464, 3633032440, 3633032447, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102465, 3633032448, 3633032591, 'US', 'USA', 'الولايات المتحدة'),
(102466, 3633032592, 3633032607, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102467, 3633032608, 3633033247, 'US', 'USA', 'الولايات المتحدة'),
(102468, 3633033248, 3633033255, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102469, 3633033256, 3633033263, 'US', 'USA', 'الولايات المتحدة'),
(102470, 3633033264, 3633033271, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102471, 3633033272, 3633033287, 'US', 'USA', 'الولايات المتحدة'),
(102472, 3633033288, 3633033295, 'GH', 'GHA', 'غانا'),
(102473, 3633033296, 3633033303, 'NG', 'NGA', 'نيجيريا'),
(102474, 3633033304, 3633033319, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102475, 3633033320, 3633033327, 'NG', 'NGA', 'نيجيريا'),
(102476, 3633033328, 3633033335, 'US', 'USA', 'الولايات المتحدة'),
(102477, 3633033336, 3633033359, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102478, 3633033360, 3633033367, 'NG', 'NGA', 'نيجيريا'),
(102479, 3633033368, 3633033375, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102480, 3633033376, 3633033391, 'NG', 'NGA', 'نيجيريا'),
(102481, 3633033392, 3633033399, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102482, 3633033400, 3633034047, 'US', 'USA', 'الولايات المتحدة'),
(102483, 3633034048, 3633034079, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102484, 3633034080, 3633034519, 'US', 'USA', 'الولايات المتحدة'),
(102485, 3633034520, 3633034527, 'NG', 'NGA', 'نيجيريا'),
(102486, 3633034528, 3633034559, 'US', 'USA', 'الولايات المتحدة'),
(102487, 3633034560, 3633034751, 'NG', 'NGA', 'نيجيريا'),
(102488, 3633034752, 3633035015, 'US', 'USA', 'الولايات المتحدة'),
(102489, 3633035016, 3633035023, 'NL', 'NLD', 'هولندا'),
(102490, 3633035024, 3633035071, 'US', 'USA', 'الولايات المتحدة'),
(102491, 3633035072, 3633035087, 'NR', 'NRU', 'ناورو'),
(102492, 3633035088, 3633035095, 'CN', 'CHN', 'الصين'),
(102493, 3633035096, 3633035135, 'US', 'USA', 'الولايات المتحدة'),
(102494, 3633035136, 3633035151, 'NR', 'NRU', 'ناورو'),
(102495, 3633035152, 3633035199, 'US', 'USA', 'الولايات المتحدة'),
(102496, 3633035200, 3633035207, 'ID', 'IDN', 'إندونيسيا'),
(102497, 3633035208, 3633035311, 'US', 'USA', 'الولايات المتحدة'),
(102498, 3633035312, 3633035319, 'ID', 'IDN', 'إندونيسيا'),
(102499, 3633035320, 3633035439, 'US', 'USA', 'الولايات المتحدة'),
(102500, 3633035440, 3633035447, 'ID', 'IDN', 'إندونيسيا'),
(102501, 3633035448, 3633035455, 'US', 'USA', 'الولايات المتحدة'),
(102502, 3633035456, 3633035487, 'ID', 'IDN', 'إندونيسيا'),
(102503, 3633035488, 3633035527, 'US', 'USA', 'الولايات المتحدة'),
(102504, 3633035528, 3633035535, 'NG', 'NGA', 'نيجيريا'),
(102505, 3633035536, 3633035551, 'US', 'USA', 'الولايات المتحدة'),
(102506, 3633035552, 3633035599, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102507, 3633035600, 3633036031, 'US', 'USA', 'الولايات المتحدة'),
(102508, 3633036032, 3633036287, 'HT', 'HTI', 'هايتي'),
(102509, 3633036288, 3633036479, 'US', 'USA', 'الولايات المتحدة'),
(102510, 3633036480, 3633036511, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(102511, 3633036512, 3633036607, 'US', 'USA', 'الولايات المتحدة'),
(102512, 3633036608, 3633036671, 'GB', 'GBR', 'المملكة المتحدة'),
(102513, 3633036672, 3633039503, 'US', 'USA', 'الولايات المتحدة'),
(102514, 3633039504, 3633039519, 'CA', 'CAN', 'كندا'),
(102515, 3633039520, 3633336319, 'US', 'USA', 'الولايات المتحدة'),
(102516, 3633336320, 3633340415, 'KY', 'CYM', 'جزر كايمان'),
(102517, 3633340416, 3633344511, 'US', 'USA', 'الولايات المتحدة'),
(102518, 3633344512, 3633348607, 'CA', 'CAN', 'كندا'),
(102519, 3633348608, 3633377279, 'US', 'USA', 'الولايات المتحدة'),
(102520, 3633381376, 3633405951, 'US', 'USA', 'الولايات المتحدة'),
(102521, 3633405952, 3633410047, 'CA', 'CAN', 'كندا'),
(102522, 3633410048, 3633479679, 'US', 'USA', 'الولايات المتحدة'),
(102523, 3633479680, 3633483775, 'CA', 'CAN', 'كندا'),
(102524, 3633483776, 3633545215, 'US', 'USA', 'الولايات المتحدة'),
(102525, 3633545216, 3633545727, 'GA', 'GAB', 'الغابون'),
(102526, 3633545728, 3633546239, 'US', 'USA', 'الولايات المتحدة'),
(102527, 3633546240, 3633546751, 'GA', 'GAB', 'الغابون'),
(102528, 3633546752, 3633547263, 'US', 'USA', 'الولايات المتحدة'),
(102529, 3633547264, 3633548287, 'GA', 'GAB', 'الغابون'),
(102530, 3633548288, 3633548543, 'US', 'USA', 'الولايات المتحدة'),
(102531, 3633548544, 3633548799, 'GA', 'GAB', 'الغابون'),
(102532, 3633548800, 3633548927, 'US', 'USA', 'الولايات المتحدة'),
(102533, 3633548928, 3633549055, 'GA', 'GAB', 'الغابون'),
(102534, 3633549056, 3633549567, 'US', 'USA', 'الولايات المتحدة'),
(102535, 3633549568, 3633549823, 'GA', 'GAB', 'الغابون'),
(102536, 3633549824, 3633550847, 'US', 'USA', 'الولايات المتحدة'),
(102537, 3633550848, 3633551359, 'GA', 'GAB', 'الغابون'),
(102538, 3633551360, 3633552911, 'US', 'USA', 'الولايات المتحدة'),
(102539, 3633552912, 3633552927, 'GA', 'GAB', 'الغابون'),
(102540, 3633552928, 3633553151, 'US', 'USA', 'الولايات المتحدة'),
(102541, 3633553152, 3633553279, 'GW', 'GNB', 'غينيا بيساو'),
(102542, 3633553280, 3633785343, 'US', 'USA', 'الولايات المتحدة'),
(102543, 3633785600, 3633786367, 'US', 'USA', 'الولايات المتحدة'),
(102544, 3633786880, 3633815551, 'US', 'USA', 'الولايات المتحدة'),
(102545, 3633815552, 3633819647, 'CA', 'CAN', 'كندا'),
(102546, 3633819648, 3633881087, 'US', 'USA', 'الولايات المتحدة'),
(102547, 3633881088, 3633885183, 'AN', 'ANT', 'جزر الأنتيل الهولندية'),
(102548, 3633885184, 3633889279, 'US', 'USA', 'الولايات المتحدة'),
(102549, 3633889280, 3633893375, 'CA', 'CAN', 'كندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(102550, 3633893376, 3633971199, 'US', 'USA', 'الولايات المتحدة'),
(102551, 3633971200, 3634020351, 'CA', 'CAN', 'كندا'),
(102552, 3634020352, 3634053119, 'US', 'USA', 'الولايات المتحدة'),
(102553, 3634053120, 3634061311, 'CL', 'CHL', 'تشيلي'),
(102554, 3634061312, 3634094079, 'US', 'USA', 'الولايات المتحدة'),
(102555, 3634094080, 3634098175, 'SE', 'SWE', 'السويد'),
(102556, 3634098176, 3634511871, 'US', 'USA', 'الولايات المتحدة'),
(102557, 3634511872, 3634515967, 'CA', 'CAN', 'كندا'),
(102558, 3634515968, 3634524159, 'US', 'USA', 'الولايات المتحدة'),
(102559, 3634528256, 3634552831, 'US', 'USA', 'الولايات المتحدة'),
(102560, 3634552832, 3634556927, 'CA', 'CAN', 'كندا'),
(102561, 3634556928, 3634597887, 'US', 'USA', 'الولايات المتحدة'),
(102562, 3634601984, 3634741247, 'US', 'USA', 'الولايات المتحدة'),
(102563, 3634749440, 3634880511, 'US', 'USA', 'الولايات المتحدة'),
(102564, 3634880512, 3634888703, 'CA', 'CAN', 'كندا'),
(102565, 3634888704, 3634913279, 'US', 'USA', 'الولايات المتحدة'),
(102566, 3634913280, 3634921471, 'CA', 'CAN', 'كندا'),
(102567, 3634921472, 3634925567, 'US', 'USA', 'الولايات المتحدة'),
(102568, 3634925568, 3634929663, 'CA', 'CAN', 'كندا'),
(102569, 3634929664, 3635109887, 'US', 'USA', 'الولايات المتحدة'),
(102570, 3635109888, 3635110295, 'CA', 'CAN', 'كندا'),
(102571, 3635110296, 3635110303, 'US', 'USA', 'الولايات المتحدة'),
(102572, 3635110304, 3635113983, 'CA', 'CAN', 'كندا'),
(102573, 3635113984, 3635142655, 'US', 'USA', 'الولايات المتحدة'),
(102574, 3635142656, 3635146751, 'CA', 'CAN', 'كندا'),
(102575, 3635146752, 3635150847, 'US', 'USA', 'الولايات المتحدة'),
(102576, 3635216384, 3635314687, 'US', 'USA', 'الولايات المتحدة'),
(102577, 3635314688, 3635322879, 'CA', 'CAN', 'كندا'),
(102578, 3635322880, 3635425279, 'US', 'USA', 'الولايات المتحدة'),
(102579, 3635425280, 3635429375, 'CA', 'CAN', 'كندا'),
(102580, 3635429376, 3635466239, 'US', 'USA', 'الولايات المتحدة'),
(102581, 3635466240, 3635470335, 'CA', 'CAN', 'كندا'),
(102582, 3635470336, 3635658751, 'US', 'USA', 'الولايات المتحدة'),
(102583, 3635658752, 3635660799, 'CN', 'CHN', 'الصين'),
(102584, 3635660800, 3635847791, 'US', 'USA', 'الولايات المتحدة'),
(102585, 3635847792, 3635847807, 'CA', 'CAN', 'كندا'),
(102586, 3635847808, 3635856511, 'US', 'USA', 'الولايات المتحدة'),
(102587, 3635856512, 3635856543, 'CA', 'CAN', 'كندا'),
(102588, 3635856544, 3635871743, 'US', 'USA', 'الولايات المتحدة'),
(102589, 3635871744, 3635879935, 'CA', 'CAN', 'كندا'),
(102590, 3635879936, 3635892223, 'US', 'USA', 'الولايات المتحدة'),
(102591, 3635892224, 3635896319, 'CA', 'CAN', 'كندا'),
(102592, 3635896320, 3635904511, 'US', 'USA', 'الولايات المتحدة'),
(102593, 3635904512, 3635912703, 'CA', 'CAN', 'كندا'),
(102594, 3635912704, 3635945471, 'US', 'USA', 'الولايات المتحدة'),
(102595, 3635949568, 3635961855, 'US', 'USA', 'الولايات المتحدة'),
(102596, 3635961856, 3635963903, 'SV', 'SLV', 'السلفادور'),
(102597, 3635963904, 3635964159, 'US', 'USA', 'الولايات المتحدة'),
(102598, 3635964160, 3635964415, 'BO', 'BOL', 'بوليفيا'),
(102599, 3635964416, 3635965951, 'SV', 'SLV', 'السلفادور'),
(102600, 3635965952, 3635966975, 'BO', 'BOL', 'بوليفيا'),
(102601, 3635966976, 3635967999, 'PY', 'PRY', 'باراغواي'),
(102602, 3635968000, 3635970047, 'SV', 'SLV', 'السلفادور'),
(102603, 3635970048, 3636019199, 'US', 'USA', 'الولايات المتحدة'),
(102604, 3636019200, 3636027391, 'CA', 'CAN', 'كندا'),
(102605, 3636027392, 3636064255, 'US', 'USA', 'الولايات المتحدة'),
(102606, 3636064256, 3636068351, 'CA', 'CAN', 'كندا'),
(102607, 3636068352, 3636152287, 'US', 'USA', 'الولايات المتحدة'),
(102608, 3636152288, 3636152575, 'CA', 'CAN', 'كندا'),
(102609, 3636152576, 3636154111, 'US', 'USA', 'الولايات المتحدة'),
(102610, 3636154112, 3636154879, 'CA', 'CAN', 'كندا'),
(102611, 3636154880, 3636155903, 'US', 'USA', 'الولايات المتحدة'),
(102612, 3636155904, 3636156159, 'CA', 'CAN', 'كندا'),
(102613, 3636156160, 3636157055, 'US', 'USA', 'الولايات المتحدة'),
(102614, 3636157056, 3636157063, 'CA', 'CAN', 'كندا'),
(102615, 3636157064, 3636158111, 'US', 'USA', 'الولايات المتحدة'),
(102616, 3636158112, 3636158143, 'CA', 'CAN', 'كندا'),
(102617, 3636158144, 3636158463, 'US', 'USA', 'الولايات المتحدة'),
(102618, 3636158464, 3636158719, 'CA', 'CAN', 'كندا'),
(102619, 3636158720, 3636158783, 'US', 'USA', 'الولايات المتحدة'),
(102620, 3636158784, 3636158815, 'CA', 'CAN', 'كندا'),
(102621, 3636158816, 3636160511, 'US', 'USA', 'الولايات المتحدة'),
(102622, 3636160512, 3636160767, 'CA', 'CAN', 'كندا'),
(102623, 3636160768, 3636161791, 'US', 'USA', 'الولايات المتحدة'),
(102624, 3636161792, 3636161855, 'CA', 'CAN', 'كندا'),
(102625, 3636161856, 3636164095, 'US', 'USA', 'الولايات المتحدة'),
(102626, 3636164096, 3636164111, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(102627, 3636164112, 3636164159, 'US', 'USA', 'الولايات المتحدة'),
(102628, 3636164160, 3636164223, 'CA', 'CAN', 'كندا'),
(102629, 3636164224, 3636166143, 'US', 'USA', 'الولايات المتحدة'),
(102630, 3636166144, 3636166655, 'CA', 'CAN', 'كندا'),
(102631, 3636166656, 3636206079, 'US', 'USA', 'الولايات المتحدة'),
(102632, 3636206080, 3636206335, 'AU', 'AUS', 'أستراليا'),
(102633, 3636206336, 3636396031, 'US', 'USA', 'الولايات المتحدة'),
(102634, 3636396032, 3636461567, 'CA', 'CAN', 'كندا'),
(102635, 3636461568, 3636609023, 'US', 'USA', 'الولايات المتحدة'),
(102636, 3636609024, 3636610559, 'CA', 'CAN', 'كندا'),
(102637, 3636610560, 3636610815, 'US', 'USA', 'الولايات المتحدة'),
(102638, 3636610816, 3636621311, 'CA', 'CAN', 'كندا'),
(102639, 3636621312, 3636666367, 'US', 'USA', 'الولايات المتحدة'),
(102640, 3636674560, 3636822015, 'US', 'USA', 'الولايات المتحدة'),
(102641, 3636822016, 3636854783, 'CA', 'CAN', 'كندا'),
(102642, 3636854784, 3636887551, 'US', 'USA', 'الولايات المتحدة'),
(102643, 3636887552, 3636895743, 'CA', 'CAN', 'كندا'),
(102644, 3636895744, 3637071887, 'US', 'USA', 'الولايات المتحدة'),
(102645, 3637071888, 3637071903, 'AD', 'AND', 'أندورا'),
(102646, 3637071904, 3637071935, 'US', 'USA', 'الولايات المتحدة'),
(102647, 3637071936, 3637071943, 'SK', 'SVK', 'سلوفاكيا'),
(102648, 3637071944, 3637071951, 'US', 'USA', 'الولايات المتحدة'),
(102649, 3637071952, 3637071967, 'CY', 'CYP', 'قبرص'),
(102650, 3637071968, 3637072095, 'US', 'USA', 'الولايات المتحدة'),
(102651, 3637072096, 3637072127, 'GB', 'GBR', 'المملكة المتحدة'),
(102652, 3637072128, 3637072143, 'US', 'USA', 'الولايات المتحدة'),
(102653, 3637072144, 3637072159, 'CY', 'CYP', 'قبرص'),
(102654, 3637072160, 3637072895, 'US', 'USA', 'الولايات المتحدة'),
(102655, 3637072896, 3637073151, 'CY', 'CYP', 'قبرص'),
(102656, 3637073152, 3637073215, 'US', 'USA', 'الولايات المتحدة'),
(102657, 3637073216, 3637073231, 'CY', 'CYP', 'قبرص'),
(102658, 3637073232, 3637074239, 'US', 'USA', 'الولايات المتحدة'),
(102659, 3637074240, 3637074303, 'PA', 'PAN', 'بنما'),
(102660, 3637074304, 3637074687, 'US', 'USA', 'الولايات المتحدة'),
(102661, 3637074688, 3637074703, 'CA', 'CAN', 'كندا'),
(102662, 3637074704, 3637074751, 'US', 'USA', 'الولايات المتحدة'),
(102663, 3637074752, 3637074815, 'PA', 'PAN', 'بنما'),
(102664, 3637074816, 3637074943, 'US', 'USA', 'الولايات المتحدة'),
(102665, 3637074944, 3637074959, 'CA', 'CAN', 'كندا'),
(102666, 3637074960, 3637074975, 'US', 'USA', 'الولايات المتحدة'),
(102667, 3637074976, 3637075007, 'PA', 'PAN', 'بنما'),
(102668, 3637075008, 3637075231, 'US', 'USA', 'الولايات المتحدة'),
(102669, 3637075232, 3637075263, 'PA', 'PAN', 'بنما'),
(102670, 3637075264, 3637075487, 'US', 'USA', 'الولايات المتحدة'),
(102671, 3637075488, 3637075519, 'PA', 'PAN', 'بنما'),
(102672, 3637075520, 3637075743, 'US', 'USA', 'الولايات المتحدة'),
(102673, 3637075744, 3637075775, 'PA', 'PAN', 'بنما'),
(102674, 3637075776, 3637075967, 'US', 'USA', 'الولايات المتحدة'),
(102675, 3637075968, 3637080063, 'CA', 'CAN', 'كندا'),
(102676, 3637080064, 3637389335, 'US', 'USA', 'الولايات المتحدة'),
(102677, 3637389336, 3637389343, 'CA', 'CAN', 'كندا'),
(102678, 3637389344, 3637469439, 'US', 'USA', 'الولايات المتحدة'),
(102679, 3637469440, 3637469695, 'GE', 'GEO', 'جورجيا'),
(102680, 3637469696, 3637510143, 'US', 'USA', 'الولايات المتحدة'),
(102681, 3637510144, 3637641215, 'CA', 'CAN', 'كندا'),
(102682, 3637641216, 3637665791, 'US', 'USA', 'الولايات المتحدة'),
(102683, 3637665792, 3637667439, 'CA', 'CAN', 'كندا'),
(102684, 3637667440, 3637667518, 'US', 'USA', 'الولايات المتحدة'),
(102685, 3637667519, 3637669887, 'CA', 'CAN', 'كندا'),
(102686, 3637669888, 3637706751, 'US', 'USA', 'الولايات المتحدة'),
(102687, 3637706752, 3637739519, 'CA', 'CAN', 'كندا'),
(102688, 3637739520, 3637827327, 'US', 'USA', 'الولايات المتحدة'),
(102689, 3637827328, 3637827583, 'VI', 'VIR', 'الجزر العذراء, الولايات المتحدة'),
(102690, 3637827584, 3638165503, 'US', 'USA', 'الولايات المتحدة'),
(102691, 3638165504, 3638181887, 'CA', 'CAN', 'كندا'),
(102692, 3638181888, 3638247439, 'US', 'USA', 'الولايات المتحدة'),
(102693, 3638247440, 3638247455, 'GB', 'GBR', 'المملكة المتحدة'),
(102694, 3638247456, 3638247487, 'US', 'USA', 'الولايات المتحدة'),
(102695, 3638247488, 3638247551, 'GB', 'GBR', 'المملكة المتحدة'),
(102696, 3638247552, 3638247679, 'DE', 'DEU', 'ألمانيا'),
(102697, 3638247680, 3638247855, 'US', 'USA', 'الولايات المتحدة'),
(102698, 3638247856, 3638247871, 'DE', 'DEU', 'ألمانيا'),
(102699, 3638247872, 3638247903, 'US', 'USA', 'الولايات المتحدة'),
(102700, 3638247904, 3638248703, 'GB', 'GBR', 'المملكة المتحدة'),
(102701, 3638248704, 3638249215, 'FR', 'FRA', 'فرنسا'),
(102702, 3638249216, 3638249471, 'GB', 'GBR', 'المملكة المتحدة'),
(102703, 3638249472, 3638249751, 'US', 'USA', 'الولايات المتحدة'),
(102704, 3638249752, 3638249791, 'GB', 'GBR', 'المملكة المتحدة'),
(102705, 3638249792, 3638250535, 'US', 'USA', 'الولايات المتحدة'),
(102706, 3638250536, 3638250543, 'GB', 'GBR', 'المملكة المتحدة'),
(102707, 3638250544, 3638250559, 'US', 'USA', 'الولايات المتحدة'),
(102708, 3638250560, 3638250623, 'GB', 'GBR', 'المملكة المتحدة'),
(102709, 3638250624, 3638250687, 'US', 'USA', 'الولايات المتحدة'),
(102710, 3638250688, 3638250703, 'GB', 'GBR', 'المملكة المتحدة'),
(102711, 3638250704, 3638250719, 'US', 'USA', 'الولايات المتحدة'),
(102712, 3638250720, 3638250815, 'GB', 'GBR', 'المملكة المتحدة'),
(102713, 3638250816, 3638250831, 'US', 'USA', 'الولايات المتحدة'),
(102714, 3638250832, 3638250847, 'GB', 'GBR', 'المملكة المتحدة'),
(102715, 3638250848, 3638250863, 'US', 'USA', 'الولايات المتحدة'),
(102716, 3638250864, 3638250871, 'GB', 'GBR', 'المملكة المتحدة'),
(102717, 3638250872, 3638250895, 'US', 'USA', 'الولايات المتحدة'),
(102718, 3638250896, 3638250911, 'GB', 'GBR', 'المملكة المتحدة'),
(102719, 3638250912, 3638250919, 'CH', 'CHE', 'سويسرا'),
(102720, 3638250920, 3638250983, 'US', 'USA', 'الولايات المتحدة'),
(102721, 3638250984, 3638250991, 'GB', 'GBR', 'المملكة المتحدة'),
(102722, 3638250992, 3638304767, 'US', 'USA', 'الولايات المتحدة'),
(102723, 3638304768, 3638312959, 'CA', 'CAN', 'كندا'),
(102724, 3638312960, 3638370303, 'US', 'USA', 'الولايات المتحدة'),
(102725, 3638370304, 3638386687, 'CA', 'CAN', 'كندا'),
(102726, 3638386688, 3638398975, 'US', 'USA', 'الولايات المتحدة'),
(102727, 3638403072, 3638419455, 'US', 'USA', 'الولايات المتحدة'),
(102728, 3638423552, 3638509567, 'US', 'USA', 'الولايات المتحدة'),
(102729, 3638509568, 3638534143, 'CA', 'CAN', 'كندا'),
(102730, 3638534144, 3638697983, 'US', 'USA', 'الولايات المتحدة'),
(102731, 3638697984, 3638706175, 'CA', 'CAN', 'كندا'),
(102732, 3638706176, 3638738943, 'US', 'USA', 'الولايات المتحدة'),
(102733, 3638740992, 3638874111, 'US', 'USA', 'الولايات المتحدة'),
(102734, 3638874112, 3638878207, 'CA', 'CAN', 'كندا'),
(102735, 3638878208, 3638960383, 'US', 'USA', 'الولايات المتحدة'),
(102736, 3638960384, 3638960639, 'BR', 'BRA', 'البرازيل'),
(102737, 3638960640, 3638984703, 'US', 'USA', 'الولايات المتحدة'),
(102738, 3638984704, 3638992895, 'GT', 'GTM', 'غواتيمالا'),
(102739, 3638992896, 3639083007, 'US', 'USA', 'الولايات المتحدة'),
(102740, 3639083008, 3639148543, 'CA', 'CAN', 'كندا'),
(102741, 3639148544, 3639222271, 'US', 'USA', 'الولايات المتحدة'),
(102742, 3639222272, 3639230463, 'CA', 'CAN', 'كندا'),
(102743, 3639230464, 3639255039, 'US', 'USA', 'الولايات المتحدة'),
(102744, 3639255040, 3639258677, 'CA', 'CAN', 'كندا'),
(102745, 3639258678, 3639258678, 'IL', 'ISR', 'إسرائيل'),
(102746, 3639258679, 3639263231, 'CA', 'CAN', 'كندا'),
(102747, 3639263232, 3639279615, 'US', 'USA', 'الولايات المتحدة'),
(102748, 3639279616, 3639283711, 'CA', 'CAN', 'كندا'),
(102749, 3639283712, 3639376383, 'US', 'USA', 'الولايات المتحدة'),
(102750, 3639376384, 3639377407, 'GU', 'GUM', 'غوام'),
(102751, 3639377408, 3639390207, 'US', 'USA', 'الولايات المتحدة'),
(102752, 3639394304, 3639396351, 'US', 'USA', 'الولايات المتحدة'),
(102753, 3639396352, 3639396383, 'NE', 'NER', 'النيجر'),
(102754, 3639396384, 3639396415, 'US', 'USA', 'الولايات المتحدة'),
(102755, 3639396416, 3639396431, 'PK', 'PAK', 'باكستان'),
(102756, 3639396432, 3639396447, 'US', 'USA', 'الولايات المتحدة'),
(102757, 3639396448, 3639396463, 'NG', 'NGA', 'نيجيريا'),
(102758, 3639396464, 3639396471, 'TZ', 'TZA', 'تانزانيا'),
(102759, 3639396472, 3639396543, 'US', 'USA', 'الولايات المتحدة'),
(102760, 3639396544, 3639396551, 'TZ', 'TZA', 'تانزانيا'),
(102761, 3639396552, 3639396671, 'US', 'USA', 'الولايات المتحدة'),
(102762, 3639396672, 3639396735, 'NE', 'NER', 'النيجر'),
(102763, 3639396736, 3639396863, 'US', 'USA', 'الولايات المتحدة'),
(102764, 3639396864, 3639396879, 'NE', 'NER', 'النيجر'),
(102765, 3639396880, 3639396927, 'US', 'USA', 'الولايات المتحدة'),
(102766, 3639396928, 3639396959, 'FR', 'FRA', 'فرنسا'),
(102767, 3639396960, 3639396975, 'NG', 'NGA', 'نيجيريا'),
(102768, 3639396976, 3639396991, 'US', 'USA', 'الولايات المتحدة'),
(102769, 3639396992, 3639397023, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(102770, 3639397024, 3639397119, 'US', 'USA', 'الولايات المتحدة'),
(102771, 3639397120, 3639397375, 'IN', 'IND', 'الهند'),
(102772, 3639397376, 3639397631, 'US', 'USA', 'الولايات المتحدة'),
(102773, 3639397632, 3639397887, 'NG', 'NGA', 'نيجيريا'),
(102774, 3639397888, 3639398527, 'US', 'USA', 'الولايات المتحدة'),
(102775, 3639398528, 3639398591, 'SA', 'SAU', 'السعودية'),
(102776, 3639398592, 3639400447, 'US', 'USA', 'الولايات المتحدة'),
(102777, 3639400448, 3639401471, 'RS', 'SRB', 'صربيا'),
(102778, 3639401472, 3639401495, 'PK', 'PAK', 'باكستان'),
(102779, 3639401496, 3639401511, 'US', 'USA', 'الولايات المتحدة'),
(102780, 3639401512, 3639401519, 'ID', 'IDN', 'إندونيسيا'),
(102781, 3639401520, 3639401535, 'US', 'USA', 'الولايات المتحدة'),
(102782, 3639401536, 3639401551, 'TZ', 'TZA', 'تانزانيا'),
(102783, 3639401552, 3639401559, 'LK', 'LKA', 'سيريلانكا'),
(102784, 3639401560, 3639401623, 'US', 'USA', 'الولايات المتحدة'),
(102785, 3639401624, 3639401631, 'TZ', 'TZA', 'تانزانيا'),
(102786, 3639401632, 3639401647, 'US', 'USA', 'الولايات المتحدة'),
(102787, 3639401648, 3639401655, 'PK', 'PAK', 'باكستان'),
(102788, 3639401656, 3639401687, 'US', 'USA', 'الولايات المتحدة'),
(102789, 3639401688, 3639401727, 'PK', 'PAK', 'باكستان'),
(102790, 3639401728, 3639402015, 'US', 'USA', 'الولايات المتحدة'),
(102791, 3639402016, 3639402039, 'PK', 'PAK', 'باكستان'),
(102792, 3639402040, 3639402055, 'US', 'USA', 'الولايات المتحدة'),
(102793, 3639402056, 3639402071, 'PK', 'PAK', 'باكستان'),
(102794, 3639402072, 3639402079, 'US', 'USA', 'الولايات المتحدة'),
(102795, 3639402080, 3639402095, 'PK', 'PAK', 'باكستان'),
(102796, 3639402096, 3639402111, 'US', 'USA', 'الولايات المتحدة'),
(102797, 3639402112, 3639402175, 'NG', 'NGA', 'نيجيريا'),
(102798, 3639402176, 3639402191, 'PK', 'PAK', 'باكستان'),
(102799, 3639402192, 3639402199, 'US', 'USA', 'الولايات المتحدة'),
(102800, 3639402200, 3639402207, 'PK', 'PAK', 'باكستان'),
(102801, 3639402208, 3639402239, 'US', 'USA', 'الولايات المتحدة'),
(102802, 3639402240, 3639402495, 'GH', 'GHA', 'غانا'),
(102803, 3639402496, 3639476223, 'US', 'USA', 'الولايات المتحدة'),
(102804, 3639541760, 3639558143, 'US', 'USA', 'الولايات المتحدة'),
(102805, 3639558144, 3639566335, 'CA', 'CAN', 'كندا'),
(102806, 3639566336, 3639582719, 'US', 'USA', 'الولايات المتحدة'),
(102807, 3639590912, 3639607295, 'US', 'USA', 'الولايات المتحدة'),
(102808, 3639607296, 3639611391, 'CA', 'CAN', 'كندا'),
(102809, 3639611392, 3639656447, 'US', 'USA', 'الولايات المتحدة'),
(102810, 3639656448, 3639660543, 'CA', 'CAN', 'كندا'),
(102811, 3639660544, 3639664639, 'US', 'USA', 'الولايات المتحدة'),
(102812, 3639664640, 3639668735, 'CA', 'CAN', 'كندا'),
(102813, 3639668736, 3639672831, 'US', 'USA', 'الولايات المتحدة'),
(102814, 3639672832, 3639675391, 'CL', 'CHL', 'تشيلي'),
(102815, 3639675392, 3639676159, 'CO', 'COL', 'كولومبيا'),
(102816, 3639676160, 3639676647, 'CL', 'CHL', 'تشيلي'),
(102817, 3639676648, 3639676655, 'US', 'USA', 'الولايات المتحدة'),
(102818, 3639676656, 3639676927, 'CL', 'CHL', 'تشيلي'),
(102819, 3639676928, 3639676943, 'CO', 'COL', 'كولومبيا'),
(102820, 3639676944, 3639677023, 'CL', 'CHL', 'تشيلي'),
(102821, 3639677024, 3639677031, 'CO', 'COL', 'كولومبيا'),
(102822, 3639677032, 3639677103, 'CL', 'CHL', 'تشيلي'),
(102823, 3639677104, 3639677111, 'CO', 'COL', 'كولومبيا'),
(102824, 3639677112, 3639677279, 'CL', 'CHL', 'تشيلي'),
(102825, 3639677280, 3639677287, 'CO', 'COL', 'كولومبيا'),
(102826, 3639677288, 3639677423, 'CL', 'CHL', 'تشيلي'),
(102827, 3639677424, 3639677431, 'CO', 'COL', 'كولومبيا'),
(102828, 3639677432, 3639677455, 'CL', 'CHL', 'تشيلي'),
(102829, 3639677456, 3639677487, 'CO', 'COL', 'كولومبيا'),
(102830, 3639677488, 3639677711, 'CL', 'CHL', 'تشيلي'),
(102831, 3639677712, 3639677719, 'CO', 'COL', 'كولومبيا'),
(102832, 3639677720, 3639677791, 'CL', 'CHL', 'تشيلي'),
(102833, 3639677792, 3639677823, 'CO', 'COL', 'كولومبيا'),
(102834, 3639677824, 3639677871, 'CL', 'CHL', 'تشيلي'),
(102835, 3639677872, 3639677879, 'CO', 'COL', 'كولومبيا'),
(102836, 3639677880, 3639677959, 'CL', 'CHL', 'تشيلي'),
(102837, 3639677960, 3639677967, 'CO', 'COL', 'كولومبيا'),
(102838, 3639677968, 3639677983, 'CL', 'CHL', 'تشيلي'),
(102839, 3639677984, 3639677991, 'CO', 'COL', 'كولومبيا'),
(102840, 3639677992, 3639678007, 'CL', 'CHL', 'تشيلي'),
(102841, 3639678008, 3639678023, 'CO', 'COL', 'كولومبيا'),
(102842, 3639678024, 3639678055, 'CL', 'CHL', 'تشيلي'),
(102843, 3639678056, 3639678063, 'CO', 'COL', 'كولومبيا'),
(102844, 3639678064, 3639678071, 'CL', 'CHL', 'تشيلي'),
(102845, 3639678072, 3639678087, 'CO', 'COL', 'كولومبيا'),
(102846, 3639678088, 3639678119, 'CL', 'CHL', 'تشيلي'),
(102847, 3639678120, 3639678127, 'CO', 'COL', 'كولومبيا'),
(102848, 3639678128, 3639678143, 'CL', 'CHL', 'تشيلي'),
(102849, 3639678144, 3639678159, 'CO', 'COL', 'كولومبيا'),
(102850, 3639678160, 3639678167, 'CL', 'CHL', 'تشيلي'),
(102851, 3639678168, 3639678175, 'CO', 'COL', 'كولومبيا'),
(102852, 3639678176, 3639678191, 'CL', 'CHL', 'تشيلي'),
(102853, 3639678192, 3639678199, 'CO', 'COL', 'كولومبيا'),
(102854, 3639678200, 3639678527, 'CL', 'CHL', 'تشيلي'),
(102855, 3639678528, 3639678535, 'CO', 'COL', 'كولومبيا'),
(102856, 3639678536, 3639678583, 'CL', 'CHL', 'تشيلي'),
(102857, 3639678584, 3639678591, 'CO', 'COL', 'كولومبيا'),
(102858, 3639678592, 3639678639, 'CL', 'CHL', 'تشيلي'),
(102859, 3639678640, 3639678647, 'CO', 'COL', 'كولومبيا'),
(102860, 3639678648, 3639678663, 'CL', 'CHL', 'تشيلي'),
(102861, 3639678664, 3639678671, 'CO', 'COL', 'كولومبيا'),
(102862, 3639678672, 3639678783, 'CL', 'CHL', 'تشيلي'),
(102863, 3639678784, 3639678791, 'CO', 'COL', 'كولومبيا'),
(102864, 3639678792, 3639678799, 'CL', 'CHL', 'تشيلي'),
(102865, 3639678800, 3639678815, 'CO', 'COL', 'كولومبيا'),
(102866, 3639678816, 3639678823, 'CL', 'CHL', 'تشيلي'),
(102867, 3639678824, 3639678831, 'CO', 'COL', 'كولومبيا'),
(102868, 3639678832, 3639678839, 'CL', 'CHL', 'تشيلي'),
(102869, 3639678840, 3639678855, 'CO', 'COL', 'كولومبيا'),
(102870, 3639678856, 3639678887, 'CL', 'CHL', 'تشيلي'),
(102871, 3639678888, 3639678895, 'CO', 'COL', 'كولومبيا'),
(102872, 3639678896, 3639678911, 'CL', 'CHL', 'تشيلي'),
(102873, 3639678912, 3639678919, 'CO', 'COL', 'كولومبيا'),
(102874, 3639678920, 3639678935, 'CL', 'CHL', 'تشيلي'),
(102875, 3639678936, 3639678951, 'CO', 'COL', 'كولومبيا'),
(102876, 3639678952, 3639678975, 'CL', 'CHL', 'تشيلي'),
(102877, 3639678976, 3639679231, 'CO', 'COL', 'كولومبيا'),
(102878, 3639679232, 3639679247, 'CL', 'CHL', 'تشيلي'),
(102879, 3639679248, 3639679263, 'CO', 'COL', 'كولومبيا'),
(102880, 3639679264, 3639679383, 'CL', 'CHL', 'تشيلي'),
(102881, 3639679384, 3639679391, 'CO', 'COL', 'كولومبيا'),
(102882, 3639679392, 3639679415, 'CL', 'CHL', 'تشيلي'),
(102883, 3639679416, 3639679423, 'CO', 'COL', 'كولومبيا'),
(102884, 3639679424, 3639679447, 'CL', 'CHL', 'تشيلي'),
(102885, 3639679448, 3639679455, 'CO', 'COL', 'كولومبيا'),
(102886, 3639679456, 3639679487, 'CL', 'CHL', 'تشيلي'),
(102887, 3639679488, 3639679743, 'CO', 'COL', 'كولومبيا'),
(102888, 3639679744, 3639680271, 'CL', 'CHL', 'تشيلي'),
(102889, 3639680272, 3639680311, 'CO', 'COL', 'كولومبيا'),
(102890, 3639680312, 3639680319, 'CL', 'CHL', 'تشيلي'),
(102891, 3639680320, 3639680335, 'CO', 'COL', 'كولومبيا'),
(102892, 3639680336, 3639680383, 'CL', 'CHL', 'تشيلي'),
(102893, 3639680384, 3639680415, 'CO', 'COL', 'كولومبيا'),
(102894, 3639680416, 3639680431, 'CL', 'CHL', 'تشيلي'),
(102895, 3639680432, 3639680447, 'CO', 'COL', 'كولومبيا'),
(102896, 3639680448, 3639680767, 'CL', 'CHL', 'تشيلي'),
(102897, 3639680768, 3639680799, 'CO', 'COL', 'كولومبيا'),
(102898, 3639680800, 3639680831, 'CL', 'CHL', 'تشيلي'),
(102899, 3639680832, 3639680847, 'CO', 'COL', 'كولومبيا'),
(102900, 3639680848, 3639680871, 'CL', 'CHL', 'تشيلي'),
(102901, 3639680872, 3639680879, 'CO', 'COL', 'كولومبيا'),
(102902, 3639680880, 3639680887, 'CL', 'CHL', 'تشيلي'),
(102903, 3639680888, 3639680895, 'CO', 'COL', 'كولومبيا'),
(102904, 3639680896, 3639680967, 'CL', 'CHL', 'تشيلي'),
(102905, 3639680968, 3639680991, 'CO', 'COL', 'كولومبيا'),
(102906, 3639680992, 3639681023, 'CL', 'CHL', 'تشيلي'),
(102907, 3639681024, 3639730175, 'US', 'USA', 'الولايات المتحدة'),
(102908, 3639730176, 3639734271, 'CA', 'CAN', 'كندا'),
(102909, 3639734272, 3639865343, 'US', 'USA', 'الولايات المتحدة'),
(102910, 3639869440, 3639902207, 'US', 'USA', 'الولايات المتحدة'),
(102911, 3639902208, 3639903755, 'PE', 'PER', 'بيرو'),
(102912, 3639903756, 3639903759, 'PA', 'PAN', 'بنما'),
(102913, 3639903760, 3639904031, 'PE', 'PER', 'بيرو'),
(102914, 3639904032, 3639904035, 'CL', 'CHL', 'تشيلي'),
(102915, 3639904036, 3639912127, 'PE', 'PER', 'بيرو'),
(102916, 3639912128, 3639912143, 'CL', 'CHL', 'تشيلي'),
(102917, 3639912144, 3639914767, 'PE', 'PER', 'بيرو'),
(102918, 3639914768, 3639914775, 'PA', 'PAN', 'بنما'),
(102919, 3639914776, 3639918591, 'PE', 'PER', 'بيرو'),
(102920, 3639918592, 3639934975, 'AR', 'ARG', 'الأرجنتين'),
(102921, 3639934976, 3640057855, 'US', 'USA', 'الولايات المتحدة'),
(102922, 3640057856, 3640066047, 'CA', 'CAN', 'كندا'),
(102923, 3640066048, 3640197119, 'US', 'USA', 'الولايات المتحدة'),
(102924, 3640197120, 3640201215, 'CA', 'CAN', 'كندا'),
(102925, 3640201216, 3640205311, 'US', 'USA', 'الولايات المتحدة'),
(102926, 3640205312, 3640209407, 'BM', 'BMU', 'برمودا'),
(102927, 3640209408, 3640213503, 'CA', 'CAN', 'كندا'),
(102928, 3640213504, 3640287231, 'US', 'USA', 'الولايات المتحدة'),
(102929, 3640287232, 3640291327, 'CA', 'CAN', 'كندا'),
(102930, 3640295424, 3640312079, 'US', 'USA', 'الولايات المتحدة'),
(102931, 3640312080, 3640312095, 'ID', 'IDN', 'إندونيسيا'),
(102932, 3640312096, 3640312103, 'GB', 'GBR', 'المملكة المتحدة'),
(102933, 3640312104, 3640312159, 'US', 'USA', 'الولايات المتحدة'),
(102934, 3640312160, 3640312191, 'ID', 'IDN', 'إندونيسيا'),
(102935, 3640312192, 3640312575, 'US', 'USA', 'الولايات المتحدة'),
(102936, 3640312576, 3640312607, 'NG', 'NGA', 'نيجيريا'),
(102937, 3640312608, 3640314879, 'US', 'USA', 'الولايات المتحدة'),
(102938, 3640314880, 3640315135, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102939, 3640315136, 3640317327, 'US', 'USA', 'الولايات المتحدة'),
(102940, 3640317328, 3640317343, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102941, 3640317344, 3640317407, 'US', 'USA', 'الولايات المتحدة'),
(102942, 3640317408, 3640317423, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(102943, 3640317424, 3640317559, 'US', 'USA', 'الولايات المتحدة'),
(102944, 3640317560, 3640317567, 'NL', 'NLD', 'هولندا'),
(102945, 3640317568, 3640318975, 'US', 'USA', 'الولايات المتحدة'),
(102946, 3640318976, 3640319103, 'GQ', 'GNQ', 'غينيا الاستوائية'),
(102947, 3640319104, 3640360959, 'US', 'USA', 'الولايات المتحدة'),
(102948, 3640360960, 3640369151, 'CA', 'CAN', 'كندا'),
(102949, 3640369152, 3640377343, 'US', 'USA', 'الولايات المتحدة'),
(102950, 3640381440, 3640410111, 'US', 'USA', 'الولايات المتحدة'),
(102951, 3640410112, 3640418303, 'CA', 'CAN', 'كندا'),
(102952, 3640418304, 3640434943, 'US', 'USA', 'الولايات المتحدة'),
(102953, 3640438784, 3640442879, 'US', 'USA', 'الولايات المتحدة'),
(102954, 3640449024, 3640450047, 'US', 'USA', 'الولايات المتحدة'),
(102955, 3640451072, 3640557567, 'US', 'USA', 'الولايات المتحدة'),
(102956, 3640557568, 3640582143, 'CA', 'CAN', 'كندا'),
(102957, 3640582144, 3640635391, 'US', 'USA', 'الولايات المتحدة'),
(102958, 3640639488, 3640647679, 'US', 'USA', 'الولايات المتحدة'),
(102959, 3640647680, 3640651775, 'JP', 'JPN', 'اليابان'),
(102960, 3640651776, 3640655871, 'US', 'USA', 'الولايات المتحدة'),
(102961, 3640655872, 3641056319, 'DE', 'DEU', 'ألمانيا'),
(102962, 3641056320, 3641056327, 'HU', 'HUN', 'هنغاريا'),
(102963, 3641056328, 3641056359, 'DE', 'DEU', 'ألمانيا'),
(102964, 3641056360, 3641056367, 'AT', 'AUT', 'النمسا'),
(102965, 3641056368, 3641056375, 'PL', 'POL', 'بولندا'),
(102966, 3641056376, 3641057655, 'DE', 'DEU', 'ألمانيا'),
(102967, 3641057656, 3641057663, 'CZ', 'CZE', 'التشيك'),
(102968, 3641057664, 3641078559, 'DE', 'DEU', 'ألمانيا'),
(102969, 3641078560, 3641078567, 'BE', 'BEL', 'بلجيكا'),
(102970, 3641078568, 3641085687, 'DE', 'DEU', 'ألمانيا'),
(102971, 3641085688, 3641085695, 'CZ', 'CZE', 'التشيك'),
(102972, 3641085696, 3641087695, 'DE', 'DEU', 'ألمانيا'),
(102973, 3641087696, 3641087703, 'GB', 'GBR', 'المملكة المتحدة'),
(102974, 3641087704, 3641098191, 'DE', 'DEU', 'ألمانيا'),
(102975, 3641098192, 3641098207, 'ES', 'ESP', 'إسبانيا'),
(102976, 3641098208, 3641102607, 'DE', 'DEU', 'ألمانيا'),
(102977, 3641102608, 3641102615, 'FR', 'FRA', 'فرنسا'),
(102978, 3641102616, 3641103719, 'DE', 'DEU', 'ألمانيا'),
(102979, 3641103720, 3641103727, 'HU', 'HUN', 'هنغاريا'),
(102980, 3641103728, 3641106951, 'DE', 'DEU', 'ألمانيا'),
(102981, 3641106952, 3641106959, 'CH', 'CHE', 'سويسرا'),
(102982, 3641106960, 3641114031, 'DE', 'DEU', 'ألمانيا'),
(102983, 3641114032, 3641114039, 'SK', 'SVK', 'سلوفاكيا'),
(102984, 3641114040, 3641134367, 'DE', 'DEU', 'ألمانيا'),
(102985, 3641134368, 3641134375, 'BE', 'BEL', 'بلجيكا'),
(102986, 3641134376, 3641140671, 'DE', 'DEU', 'ألمانيا'),
(102987, 3641140672, 3641140679, 'US', 'USA', 'الولايات المتحدة'),
(102988, 3641140680, 3641147519, 'DE', 'DEU', 'ألمانيا'),
(102989, 3641147520, 3641147527, 'AT', 'AUT', 'النمسا'),
(102990, 3641147528, 3641150303, 'DE', 'DEU', 'ألمانيا'),
(102991, 3641150304, 3641150311, 'US', 'USA', 'الولايات المتحدة'),
(102992, 3641150312, 3641157951, 'DE', 'DEU', 'ألمانيا'),
(102993, 3641157952, 3641157959, 'AT', 'AUT', 'النمسا'),
(102994, 3641157960, 3641158031, 'DE', 'DEU', 'ألمانيا'),
(102995, 3641158032, 3641158055, 'FR', 'FRA', 'فرنسا'),
(102996, 3641158056, 3641158103, 'DE', 'DEU', 'ألمانيا'),
(102997, 3641158104, 3641158111, 'FR', 'FRA', 'فرنسا'),
(102998, 3641158112, 3641158127, 'DE', 'DEU', 'ألمانيا'),
(102999, 3641158128, 3641158135, 'ES', 'ESP', 'إسبانيا'),
(103000, 3641158136, 3641158199, 'DE', 'DEU', 'ألمانيا'),
(103001, 3641158200, 3641158207, 'NL', 'NLD', 'هولندا'),
(103002, 3641158208, 3641158335, 'DE', 'DEU', 'ألمانيا'),
(103003, 3641158336, 3641158343, 'ES', 'ESP', 'إسبانيا'),
(103004, 3641158344, 3641158423, 'DE', 'DEU', 'ألمانيا'),
(103005, 3641158424, 3641158431, 'IT', 'ITA', 'إيطاليا'),
(103006, 3641158432, 3641158519, 'DE', 'DEU', 'ألمانيا'),
(103007, 3641158520, 3641158527, 'ES', 'ESP', 'إسبانيا'),
(103008, 3641158528, 3641159679, 'DE', 'DEU', 'ألمانيا'),
(103009, 3641159680, 3641159687, 'ES', 'ESP', 'إسبانيا'),
(103010, 3641159688, 3641159727, 'DE', 'DEU', 'ألمانيا'),
(103011, 3641159728, 3641159743, 'ES', 'ESP', 'إسبانيا'),
(103012, 3641159744, 3641159767, 'DE', 'DEU', 'ألمانيا'),
(103013, 3641159768, 3641159775, 'ES', 'ESP', 'إسبانيا'),
(103014, 3641159776, 3641180159, 'DE', 'DEU', 'ألمانيا'),
(103015, 3641180160, 3641188351, 'GB', 'GBR', 'المملكة المتحدة'),
(103016, 3641188352, 3641192447, 'TJ', 'TJK', 'طاجيكيستان'),
(103017, 3641192448, 3641196543, 'DE', 'DEU', 'ألمانيا'),
(103018, 3641196544, 3641200639, 'SA', 'SAU', 'السعودية'),
(103019, 3641200640, 3641204735, 'RU', 'RUS', 'الإتحاد الروسي'),
(103020, 3641204736, 3641206015, 'NL', 'NLD', 'هولندا'),
(103021, 3641206016, 3641206271, 'CN', 'CHN', 'الصين'),
(103022, 3641206272, 3641208831, 'NL', 'NLD', 'هولندا'),
(103023, 3641208832, 3641212927, 'JO', 'JOR', 'الأردن'),
(103024, 3641212928, 3641221119, 'NO', 'NOR', 'النرويج'),
(103025, 3641221120, 3641229311, 'PL', 'POL', 'بولندا'),
(103026, 3641229312, 3641237503, 'CH', 'CHE', 'سويسرا'),
(103027, 3641237504, 3641241599, 'RU', 'RUS', 'الإتحاد الروسي'),
(103028, 3641241600, 3641245695, 'GB', 'GBR', 'المملكة المتحدة'),
(103029, 3641245696, 3641249791, 'UA', 'UKR', 'أوكرانيا'),
(103030, 3641249792, 3641262079, 'DE', 'DEU', 'ألمانيا'),
(103031, 3641262080, 3641266175, 'IT', 'ITA', 'إيطاليا'),
(103032, 3641266176, 3641270271, 'RU', 'RUS', 'الإتحاد الروسي'),
(103033, 3641270272, 3641278463, 'DE', 'DEU', 'ألمانيا'),
(103034, 3641278464, 3641282559, 'IS', 'ISL', 'أيسلندا'),
(103035, 3641282560, 3641286655, 'RU', 'RUS', 'الإتحاد الروسي'),
(103036, 3641286656, 3641294847, 'PL', 'POL', 'بولندا'),
(103037, 3641294848, 3641298943, 'GB', 'GBR', 'المملكة المتحدة'),
(103038, 3641298944, 3641303039, 'SE', 'SWE', 'السويد'),
(103039, 3641303040, 3641307135, 'BG', 'BGR', 'بلغاريا'),
(103040, 3641307136, 3641311231, 'LT', 'LTU', 'ليتوانيا'),
(103041, 3641311232, 3641315327, 'DE', 'DEU', 'ألمانيا'),
(103042, 3641315328, 3641319423, 'DK', 'DNK', 'الدنيمارك'),
(103043, 3641319424, 3641323519, 'RU', 'RUS', 'الإتحاد الروسي'),
(103044, 3641323520, 3641323775, 'US', 'USA', 'الولايات المتحدة'),
(103045, 3641323776, 3641331711, 'DE', 'DEU', 'ألمانيا'),
(103046, 3641331712, 3641335807, 'ES', 'ESP', 'إسبانيا'),
(103047, 3641335808, 3641343999, 'SE', 'SWE', 'السويد'),
(103048, 3641344000, 3641345199, 'GB', 'GBR', 'المملكة المتحدة'),
(103049, 3641345200, 3641345215, 'IE', 'IRL', 'إيرلندا'),
(103050, 3641345216, 3641353151, 'GB', 'GBR', 'المملكة المتحدة'),
(103051, 3641353152, 3641353183, 'BD', 'BGD', 'بنغالاديش'),
(103052, 3641353184, 3641353215, 'NG', 'NGA', 'نيجيريا'),
(103053, 3641353216, 3641353231, 'GB', 'GBR', 'المملكة المتحدة'),
(103054, 3641353232, 3641353247, 'IQ', 'IRQ', 'العراق'),
(103055, 3641353248, 3641353343, 'GB', 'GBR', 'المملكة المتحدة'),
(103056, 3641353344, 3641353727, 'BD', 'BGD', 'بنغالاديش'),
(103057, 3641353728, 3641353759, 'NG', 'NGA', 'نيجيريا'),
(103058, 3641353760, 3641353775, 'GB', 'GBR', 'المملكة المتحدة'),
(103059, 3641353776, 3641353807, 'NG', 'NGA', 'نيجيريا'),
(103060, 3641353808, 3641353983, 'GB', 'GBR', 'المملكة المتحدة'),
(103061, 3641353984, 3641354239, 'AF', 'AFG', 'أفغانستان'),
(103062, 3641354240, 3641354383, 'GB', 'GBR', 'المملكة المتحدة'),
(103063, 3641354384, 3641354479, 'IT', 'ITA', 'إيطاليا'),
(103064, 3641354480, 3641354751, 'GB', 'GBR', 'المملكة المتحدة'),
(103065, 3641354752, 3641355263, 'NG', 'NGA', 'نيجيريا'),
(103066, 3641355264, 3641355519, 'AO', 'AGO', 'أنغولا'),
(103067, 3641355520, 3641355775, 'GB', 'GBR', 'المملكة المتحدة'),
(103068, 3641355776, 3641356031, 'LB', 'LBN', 'لبنان'),
(103069, 3641356032, 3641356111, 'GB', 'GBR', 'المملكة المتحدة'),
(103070, 3641356112, 3641356119, 'NG', 'NGA', 'نيجيريا'),
(103071, 3641356120, 3641356191, 'GB', 'GBR', 'المملكة المتحدة'),
(103072, 3641356192, 3641356207, 'NG', 'NGA', 'نيجيريا'),
(103073, 3641356208, 3641359359, 'GB', 'GBR', 'المملكة المتحدة'),
(103074, 3641359360, 3641359615, 'IQ', 'IRQ', 'العراق'),
(103075, 3641359616, 3641360383, 'GB', 'GBR', 'المملكة المتحدة'),
(103076, 3641360384, 3641368575, 'RO', 'ROM', 'رومانيا'),
(103077, 3641368576, 3641372671, 'GB', 'GBR', 'المملكة المتحدة'),
(103078, 3641372672, 3641376767, 'BG', 'BGR', 'بلغاريا'),
(103079, 3641376768, 3641380863, 'IT', 'ITA', 'إيطاليا'),
(103080, 3641380864, 3641383991, 'IR', 'IRN', 'إيران'),
(103081, 3641383992, 3641383999, 'SE', 'SWE', 'السويد'),
(103082, 3641384000, 3641384959, 'IR', 'IRN', 'إيران'),
(103083, 3641384960, 3641389055, 'CH', 'CHE', 'سويسرا'),
(103084, 3641389056, 3641391807, 'DE', 'DEU', 'ألمانيا'),
(103085, 3641391808, 3641391823, 'AT', 'AUT', 'النمسا'),
(103086, 3641391824, 3641393151, 'DE', 'DEU', 'ألمانيا'),
(103087, 3641393152, 3641397247, 'KZ', 'KAZ', 'كازاخستان'),
(103088, 3641397248, 3641401343, 'IT', 'ITA', 'إيطاليا'),
(103089, 3641401344, 3641409535, 'ES', 'ESP', 'إسبانيا'),
(103090, 3641409536, 3641417727, 'PL', 'POL', 'بولندا'),
(103091, 3641417728, 3641421823, 'GE', 'GEO', 'جورجيا'),
(103092, 3641421824, 3641425919, 'TJ', 'TJK', 'طاجيكيستان'),
(103093, 3641425920, 3641430015, 'DE', 'DEU', 'ألمانيا'),
(103094, 3641430016, 3641434111, 'CH', 'CHE', 'سويسرا'),
(103095, 3641434112, 3641442303, 'CZ', 'CZE', 'التشيك'),
(103096, 3641442304, 3641446399, 'GB', 'GBR', 'المملكة المتحدة'),
(103097, 3641446400, 3641450495, 'ES', 'ESP', 'إسبانيا'),
(103098, 3641450496, 3641454591, 'RU', 'RUS', 'الإتحاد الروسي'),
(103099, 3641454592, 3641458687, 'SK', 'SVK', 'سلوفاكيا'),
(103100, 3641458688, 3641462783, 'RU', 'RUS', 'الإتحاد الروسي'),
(103101, 3641462784, 3641466879, 'UZ', 'UZB', 'أوزباكستان'),
(103102, 3641466880, 3641470975, 'RU', 'RUS', 'الإتحاد الروسي'),
(103103, 3641470976, 3641475071, 'MD', 'MDA', 'مولدوفا'),
(103104, 3641475072, 3641479167, 'IT', 'ITA', 'إيطاليا'),
(103105, 3641479168, 3641483263, 'GB', 'GBR', 'المملكة المتحدة'),
(103106, 3641483264, 3641491455, 'IT', 'ITA', 'إيطاليا'),
(103107, 3641491456, 3641493503, 'UA', 'UKR', 'أوكرانيا'),
(103108, 3641493504, 3641494015, 'RU', 'RUS', 'الإتحاد الروسي'),
(103109, 3641494016, 3641495551, 'UA', 'UKR', 'أوكرانيا'),
(103110, 3641495552, 3641496063, 'RU', 'RUS', 'الإتحاد الروسي'),
(103111, 3641496064, 3641499647, 'UA', 'UKR', 'أوكرانيا'),
(103112, 3641499648, 3641503743, 'SA', 'SAU', 'السعودية'),
(103113, 3641503744, 3641507839, 'RU', 'RUS', 'الإتحاد الروسي'),
(103114, 3641507840, 3641516031, 'NO', 'NOR', 'النرويج'),
(103115, 3641516032, 3641520127, 'HU', 'HUN', 'هنغاريا'),
(103116, 3641520128, 3641524223, 'FR', 'FRA', 'فرنسا'),
(103117, 3641524224, 3641528319, 'DE', 'DEU', 'ألمانيا'),
(103118, 3641528320, 3641532415, 'ES', 'ESP', 'إسبانيا'),
(103119, 3641532416, 3641536511, 'RO', 'ROM', 'رومانيا'),
(103120, 3641536512, 3641540607, 'ES', 'ESP', 'إسبانيا'),
(103121, 3641540608, 3641548799, 'GB', 'GBR', 'المملكة المتحدة'),
(103122, 3641548800, 3641552895, 'DE', 'DEU', 'ألمانيا'),
(103123, 3641552896, 3641556991, 'AT', 'AUT', 'النمسا'),
(103124, 3641556992, 3641559103, 'DE', 'DEU', 'ألمانيا'),
(103125, 3641559104, 3641559135, 'NL', 'NLD', 'هولندا'),
(103126, 3641559136, 3641560959, 'DE', 'DEU', 'ألمانيا'),
(103127, 3641560960, 3641561087, 'NL', 'NLD', 'هولندا'),
(103128, 3641561088, 3641565183, 'RU', 'RUS', 'الإتحاد الروسي'),
(103129, 3641565184, 3641573375, 'SE', 'SWE', 'السويد'),
(103130, 3641573376, 3641577471, 'NO', 'NOR', 'النرويج'),
(103131, 3641577472, 3641581567, 'RU', 'RUS', 'الإتحاد الروسي'),
(103132, 3641581568, 3641585663, 'ES', 'ESP', 'إسبانيا'),
(103133, 3641585664, 3641589759, 'RU', 'RUS', 'الإتحاد الروسي'),
(103134, 3641589760, 3641593855, 'CH', 'CHE', 'سويسرا'),
(103135, 3641597952, 3641602047, 'AZ', 'AZE', 'أذربيجان'),
(103136, 3641602048, 3641606143, 'DE', 'DEU', 'ألمانيا'),
(103137, 3641606144, 3641607695, 'GB', 'GBR', 'المملكة المتحدة'),
(103138, 3641607696, 3641607711, 'FR', 'FRA', 'فرنسا'),
(103139, 3641607712, 3641610239, 'GB', 'GBR', 'المملكة المتحدة'),
(103140, 3641610240, 3641618431, 'DE', 'DEU', 'ألمانيا'),
(103141, 3641618432, 3641622527, 'GB', 'GBR', 'المملكة المتحدة'),
(103142, 3641622528, 3641626623, 'RU', 'RUS', 'الإتحاد الروسي'),
(103143, 3641626624, 3641630719, 'HR', 'HRV', 'كرواتيا'),
(103144, 3641630720, 3641634815, 'AT', 'AUT', 'النمسا'),
(103145, 3641634816, 3641638911, 'RU', 'RUS', 'الإتحاد الروسي'),
(103146, 3641638912, 3641643007, 'AT', 'AUT', 'النمسا'),
(103147, 3641643008, 3641647103, 'RU', 'RUS', 'الإتحاد الروسي'),
(103148, 3641647104, 3641651199, 'ES', 'ESP', 'إسبانيا'),
(103149, 3641651200, 3641655295, 'RU', 'RUS', 'الإتحاد الروسي'),
(103150, 3641655296, 3641659391, 'GB', 'GBR', 'المملكة المتحدة'),
(103151, 3641659392, 3641663487, 'FR', 'FRA', 'فرنسا'),
(103152, 3641663488, 3641667583, 'MT', 'MLT', 'مالطا'),
(103153, 3641667584, 3641668607, 'GB', 'GBR', 'المملكة المتحدة'),
(103154, 3641668608, 3641670655, 'ZW', 'ZWE', 'زمبابواي'),
(103155, 3641670656, 3641670783, 'SO', 'SOM', 'الصومال'),
(103156, 3641670784, 3641670791, 'NG', 'NGA', 'نيجيريا'),
(103157, 3641670792, 3641670911, 'GB', 'GBR', 'المملكة المتحدة'),
(103158, 3641670912, 3641671679, 'LS', 'LSO', 'ليسوتو'),
(103159, 3641671680, 3641679871, 'RU', 'RUS', 'الإتحاد الروسي'),
(103160, 3641679872, 3641683967, 'GB', 'GBR', 'المملكة المتحدة'),
(103161, 3641683968, 3641688063, 'KZ', 'KAZ', 'كازاخستان'),
(103162, 3641688064, 3641692159, 'RU', 'RUS', 'الإتحاد الروسي'),
(103163, 3641692160, 3641696255, 'IT', 'ITA', 'إيطاليا'),
(103164, 3641696256, 3641700351, 'DE', 'DEU', 'ألمانيا'),
(103165, 3641700352, 3641704447, 'SE', 'SWE', 'السويد'),
(103166, 3641704448, 3641708543, 'FR', 'FRA', 'فرنسا'),
(103167, 3641708544, 3641712639, 'RU', 'RUS', 'الإتحاد الروسي'),
(103168, 3641712640, 3641713447, 'NL', 'NLD', 'هولندا'),
(103169, 3641713448, 3641713639, 'BE', 'BEL', 'بلجيكا'),
(103170, 3641713640, 3641716735, 'NL', 'NLD', 'هولندا'),
(103171, 3641716736, 3641720831, 'GB', 'GBR', 'المملكة المتحدة'),
(103172, 3641720832, 3641729023, 'MK', 'MKD', 'جمهورية مقدونيا اليوغوسلافية'),
(103173, 3641729024, 3641733119, 'DK', 'DNK', 'الدنيمارك'),
(103174, 3641733120, 3641737215, 'AT', 'AUT', 'النمسا'),
(103175, 3641737216, 3641741311, 'RS', 'SRB', 'صربيا'),
(103176, 3641741312, 3641745407, 'ES', 'ESP', 'إسبانيا'),
(103177, 3641745408, 3641749503, 'DE', 'DEU', 'ألمانيا'),
(103178, 3641749504, 3641753599, 'CZ', 'CZE', 'التشيك'),
(103179, 3641753600, 3641757695, 'SE', 'SWE', 'السويد'),
(103180, 3641757696, 3641761791, 'GB', 'GBR', 'المملكة المتحدة'),
(103181, 3641761792, 3641761795, 'CY', 'CYP', 'قبرص'),
(103182, 3641761796, 3641761851, 'GR', 'GRC', 'اليونان'),
(103183, 3641761852, 3641761855, 'CY', 'CYP', 'قبرص'),
(103184, 3641761856, 3641761863, 'GR', 'GRC', 'اليونان'),
(103185, 3641761864, 3641761867, 'CY', 'CYP', 'قبرص'),
(103186, 3641761868, 3641761895, 'GR', 'GRC', 'اليونان'),
(103187, 3641761896, 3641761899, 'CY', 'CYP', 'قبرص'),
(103188, 3641761900, 3641761923, 'GR', 'GRC', 'اليونان'),
(103189, 3641761924, 3641761927, 'CY', 'CYP', 'قبرص'),
(103190, 3641761928, 3641761935, 'GR', 'GRC', 'اليونان'),
(103191, 3641761936, 3641761939, 'CY', 'CYP', 'قبرص'),
(103192, 3641761940, 3641761967, 'GR', 'GRC', 'اليونان'),
(103193, 3641761968, 3641761971, 'CY', 'CYP', 'قبرص'),
(103194, 3641761972, 3641762007, 'GR', 'GRC', 'اليونان'),
(103195, 3641762008, 3641762011, 'CY', 'CYP', 'قبرص'),
(103196, 3641762012, 3641762047, 'GR', 'GRC', 'اليونان'),
(103197, 3641762048, 3641762571, 'CY', 'CYP', 'قبرص'),
(103198, 3641762572, 3641762575, 'GR', 'GRC', 'اليونان'),
(103199, 3641762576, 3641762591, 'CY', 'CYP', 'قبرص'),
(103200, 3641762592, 3641762595, 'GR', 'GRC', 'اليونان'),
(103201, 3641762596, 3641762607, 'CY', 'CYP', 'قبرص'),
(103202, 3641762608, 3641762611, 'GR', 'GRC', 'اليونان'),
(103203, 3641762612, 3641762647, 'CY', 'CYP', 'قبرص'),
(103204, 3641762648, 3641762655, 'GR', 'GRC', 'اليونان'),
(103205, 3641762656, 3641762687, 'CY', 'CYP', 'قبرص'),
(103206, 3641762688, 3641762691, 'GR', 'GRC', 'اليونان'),
(103207, 3641762692, 3641762703, 'CY', 'CYP', 'قبرص'),
(103208, 3641762704, 3641762711, 'GR', 'GRC', 'اليونان'),
(103209, 3641762712, 3641762755, 'CY', 'CYP', 'قبرص'),
(103210, 3641762756, 3641762759, 'GR', 'GRC', 'اليونان'),
(103211, 3641762760, 3641762907, 'CY', 'CYP', 'قبرص'),
(103212, 3641762908, 3641762911, 'GR', 'GRC', 'اليونان'),
(103213, 3641762912, 3641762943, 'CY', 'CYP', 'قبرص'),
(103214, 3641762944, 3641762947, 'GR', 'GRC', 'اليونان'),
(103215, 3641762948, 3641762951, 'CY', 'CYP', 'قبرص'),
(103216, 3641762952, 3641762999, 'GR', 'GRC', 'اليونان'),
(103217, 3641763000, 3641763003, 'CY', 'CYP', 'قبرص'),
(103218, 3641763004, 3641763023, 'GR', 'GRC', 'اليونان'),
(103219, 3641763024, 3641763035, 'CY', 'CYP', 'قبرص'),
(103220, 3641763036, 3641763063, 'GR', 'GRC', 'اليونان'),
(103221, 3641763064, 3641763331, 'CY', 'CYP', 'قبرص'),
(103222, 3641763332, 3641763339, 'GR', 'GRC', 'اليونان'),
(103223, 3641763340, 3641763343, 'CY', 'CYP', 'قبرص'),
(103224, 3641763344, 3641763347, 'GR', 'GRC', 'اليونان'),
(103225, 3641763348, 3641763367, 'CY', 'CYP', 'قبرص'),
(103226, 3641763368, 3641763371, 'GR', 'GRC', 'اليونان'),
(103227, 3641763372, 3641763427, 'CY', 'CYP', 'قبرص'),
(103228, 3641763428, 3641763431, 'GR', 'GRC', 'اليونان'),
(103229, 3641763432, 3641763439, 'CY', 'CYP', 'قبرص'),
(103230, 3641763440, 3641763443, 'GR', 'GRC', 'اليونان'),
(103231, 3641763444, 3641763451, 'CY', 'CYP', 'قبرص'),
(103232, 3641763452, 3641763455, 'GR', 'GRC', 'اليونان'),
(103233, 3641763456, 3641763475, 'CY', 'CYP', 'قبرص'),
(103234, 3641763476, 3641763479, 'GR', 'GRC', 'اليونان'),
(103235, 3641763480, 3641763491, 'CY', 'CYP', 'قبرص'),
(103236, 3641763492, 3641763503, 'GR', 'GRC', 'اليونان'),
(103237, 3641763504, 3641763511, 'CY', 'CYP', 'قبرص'),
(103238, 3641763512, 3641763519, 'GR', 'GRC', 'اليونان'),
(103239, 3641763520, 3641763582, 'CY', 'CYP', 'قبرص'),
(103240, 3641763583, 3641763583, 'GR', 'GRC', 'اليونان'),
(103241, 3641763584, 3641764111, 'CY', 'CYP', 'قبرص'),
(103242, 3641764112, 3641764115, 'GR', 'GRC', 'اليونان'),
(103243, 3641764116, 3641764223, 'CY', 'CYP', 'قبرص'),
(103244, 3641764224, 3641764227, 'GR', 'GRC', 'اليونان'),
(103245, 3641764228, 3641764231, 'CY', 'CYP', 'قبرص'),
(103246, 3641764232, 3641764239, 'GR', 'GRC', 'اليونان'),
(103247, 3641764240, 3641764279, 'CY', 'CYP', 'قبرص'),
(103248, 3641764280, 3641764291, 'GR', 'GRC', 'اليونان'),
(103249, 3641764292, 3641764303, 'CY', 'CYP', 'قبرص'),
(103250, 3641764304, 3641764307, 'GR', 'GRC', 'اليونان'),
(103251, 3641764308, 3641764319, 'CY', 'CYP', 'قبرص'),
(103252, 3641764320, 3641764327, 'GR', 'GRC', 'اليونان'),
(103253, 3641764328, 3641764347, 'CY', 'CYP', 'قبرص'),
(103254, 3641764348, 3641764351, 'GR', 'GRC', 'اليونان'),
(103255, 3641764352, 3641764607, 'CY', 'CYP', 'قبرص'),
(103256, 3641764608, 3641764679, 'GR', 'GRC', 'اليونان'),
(103257, 3641764680, 3641764683, 'CY', 'CYP', 'قبرص'),
(103258, 3641764684, 3641764699, 'GR', 'GRC', 'اليونان'),
(103259, 3641764700, 3641764703, 'CY', 'CYP', 'قبرص'),
(103260, 3641764704, 3641764711, 'GR', 'GRC', 'اليونان'),
(103261, 3641764712, 3641764715, 'CY', 'CYP', 'قبرص'),
(103262, 3641764716, 3641764775, 'GR', 'GRC', 'اليونان'),
(103263, 3641764776, 3641764783, 'CY', 'CYP', 'قبرص'),
(103264, 3641764784, 3641764787, 'GR', 'GRC', 'اليونان'),
(103265, 3641764788, 3641764791, 'CY', 'CYP', 'قبرص'),
(103266, 3641764792, 3641764847, 'GR', 'GRC', 'اليونان'),
(103267, 3641764848, 3641764856, 'CY', 'CYP', 'قبرص'),
(103268, 3641764857, 3641764863, 'GR', 'GRC', 'اليونان'),
(103269, 3641764864, 3641764875, 'CY', 'CYP', 'قبرص'),
(103270, 3641764876, 3641764927, 'GR', 'GRC', 'اليونان'),
(103271, 3641764928, 3641764935, 'CY', 'CYP', 'قبرص'),
(103272, 3641764936, 3641764943, 'GR', 'GRC', 'اليونان'),
(103273, 3641764944, 3641764951, 'CY', 'CYP', 'قبرص'),
(103274, 3641764952, 3641764963, 'GR', 'GRC', 'اليونان'),
(103275, 3641764964, 3641764967, 'CY', 'CYP', 'قبرص'),
(103276, 3641764968, 3641764975, 'GR', 'GRC', 'اليونان'),
(103277, 3641764976, 3641764979, 'CY', 'CYP', 'قبرص'),
(103278, 3641764980, 3641765023, 'GR', 'GRC', 'اليونان'),
(103279, 3641765024, 3641765031, 'CY', 'CYP', 'قبرص'),
(103280, 3641765032, 3641765083, 'GR', 'GRC', 'اليونان'),
(103281, 3641765084, 3641765087, 'CY', 'CYP', 'قبرص'),
(103282, 3641765088, 3641765119, 'GR', 'GRC', 'اليونان'),
(103283, 3641765120, 3641765631, 'CY', 'CYP', 'قبرص'),
(103284, 3641765632, 3641765887, 'GR', 'GRC', 'اليونان'),
(103285, 3641765888, 3641769983, 'ES', 'ESP', 'إسبانيا'),
(103286, 3641769984, 3641774079, 'NO', 'NOR', 'النرويج'),
(103287, 3641774080, 3641778175, 'DE', 'DEU', 'ألمانيا'),
(103288, 3641778176, 3641782271, 'PL', 'POL', 'بولندا'),
(103289, 3641782272, 3641784079, 'GB', 'GBR', 'المملكة المتحدة'),
(103290, 3641784080, 3641786367, 'BG', 'BGR', 'بلغاريا'),
(103291, 3641786368, 3641790463, 'SE', 'SWE', 'السويد'),
(103292, 3641790464, 3641794559, 'LT', 'LTU', 'ليتوانيا'),
(103293, 3641794560, 3641798655, 'RS', 'SRB', 'صربيا'),
(103294, 3641798656, 3641802751, 'RU', 'RUS', 'الإتحاد الروسي'),
(103295, 3641802752, 3641806847, 'NL', 'NLD', 'هولندا'),
(103296, 3641806848, 3641807871, 'TR', 'TUR', 'تركيا'),
(103297, 3641807872, 3641808895, 'NL', 'NLD', 'هولندا'),
(103298, 3641808896, 3641809663, 'TR', 'TUR', 'تركيا'),
(103299, 3641809664, 3641809919, 'NL', 'NLD', 'هولندا'),
(103300, 3641809920, 3641810315, 'TR', 'TUR', 'تركيا'),
(103301, 3641810316, 3641810431, 'CY', 'CYP', 'قبرص'),
(103302, 3641810432, 3641810439, 'NL', 'NLD', 'هولندا'),
(103303, 3641810440, 3641810447, 'US', 'USA', 'الولايات المتحدة'),
(103304, 3641810448, 3641810463, 'NL', 'NLD', 'هولندا'),
(103305, 3641810464, 3641810479, 'US', 'USA', 'الولايات المتحدة'),
(103306, 3641810480, 3641810559, 'TR', 'TUR', 'تركيا'),
(103307, 3641810560, 3641810623, 'US', 'USA', 'الولايات المتحدة'),
(103308, 3641810624, 3641810631, 'TR', 'TUR', 'تركيا'),
(103309, 3641810632, 3641810642, 'US', 'USA', 'الولايات المتحدة'),
(103310, 3641810643, 3641810687, 'TR', 'TUR', 'تركيا'),
(103311, 3641810688, 3641810943, 'CY', 'CYP', 'قبرص'),
(103312, 3641810944, 3641819135, 'RU', 'RUS', 'الإتحاد الروسي'),
(103313, 3641819136, 3641823231, 'DE', 'DEU', 'ألمانيا'),
(103314, 3641823232, 3641827327, 'NO', 'NOR', 'النرويج'),
(103315, 3641827328, 3641835519, 'BH', 'BHR', 'البحرين'),
(103316, 3641835520, 3641839615, 'IT', 'ITA', 'إيطاليا'),
(103317, 3641839616, 3641843711, 'GB', 'GBR', 'المملكة المتحدة'),
(103318, 3641843712, 3641847807, 'ES', 'ESP', 'إسبانيا'),
(103319, 3641847808, 3641851903, 'IT', 'ITA', 'إيطاليا'),
(103320, 3641851904, 3641855999, 'NL', 'NLD', 'هولندا'),
(103321, 3641856000, 3641860095, 'GB', 'GBR', 'المملكة المتحدة'),
(103322, 3641860096, 3641868287, 'IT', 'ITA', 'إيطاليا'),
(103323, 3641868288, 3641876479, 'RU', 'RUS', 'الإتحاد الروسي'),
(103324, 3641876480, 3641880575, 'ES', 'ESP', 'إسبانيا'),
(103325, 3641880576, 3641881343, 'DE', 'DEU', 'ألمانيا'),
(103326, 3641881344, 3641881359, 'US', 'USA', 'الولايات المتحدة'),
(103327, 3641881360, 3641881391, 'DE', 'DEU', 'ألمانيا'),
(103328, 3641881392, 3641881395, 'CH', 'CHE', 'سويسرا'),
(103329, 3641881396, 3641881399, 'DE', 'DEU', 'ألمانيا'),
(103330, 3641881400, 3641881407, 'CH', 'CHE', 'سويسرا'),
(103331, 3641881408, 3641881423, 'DE', 'DEU', 'ألمانيا'),
(103332, 3641881424, 3641881439, 'US', 'USA', 'الولايات المتحدة'),
(103333, 3641881440, 3641881447, 'DE', 'DEU', 'ألمانيا'),
(103334, 3641881448, 3641881455, 'CH', 'CHE', 'سويسرا'),
(103335, 3641881456, 3641881567, 'DE', 'DEU', 'ألمانيا'),
(103336, 3641881568, 3641881583, 'CH', 'CHE', 'سويسرا'),
(103337, 3641881584, 3641882727, 'DE', 'DEU', 'ألمانيا'),
(103338, 3641882728, 3641882735, 'CH', 'CHE', 'سويسرا'),
(103339, 3641882736, 3641884671, 'DE', 'DEU', 'ألمانيا'),
(103340, 3641884672, 3641888767, 'NO', 'NOR', 'النرويج'),
(103341, 3641888768, 3641892863, 'IT', 'ITA', 'إيطاليا'),
(103342, 3641892864, 3641896959, 'ES', 'ESP', 'إسبانيا'),
(103343, 3641896960, 3641901055, 'BG', 'BGR', 'بلغاريا'),
(103344, 3641901056, 3641905151, 'RO', 'ROM', 'رومانيا'),
(103345, 3641905152, 3641909247, 'NL', 'NLD', 'هولندا'),
(103346, 3641909248, 3641913343, 'AT', 'AUT', 'النمسا'),
(103347, 3641913344, 3641917439, 'FR', 'FRA', 'فرنسا'),
(103348, 3641917440, 3641925631, 'GR', 'GRC', 'اليونان'),
(103349, 3641925632, 3641933823, 'RU', 'RUS', 'الإتحاد الروسي'),
(103350, 3641933824, 3641937919, 'GB', 'GBR', 'المملكة المتحدة'),
(103351, 3641937920, 3641942015, 'IT', 'ITA', 'إيطاليا'),
(103352, 3641942016, 3641950207, 'DE', 'DEU', 'ألمانيا'),
(103353, 3641950208, 3641954303, 'FR', 'FRA', 'فرنسا'),
(103354, 3641954304, 3641957887, 'MD', 'MDA', 'مولدوفا'),
(103355, 3641957888, 3641957951, 'GB', 'GBR', 'المملكة المتحدة'),
(103356, 3641957952, 3641958143, 'MD', 'MDA', 'مولدوفا'),
(103357, 3641958144, 3641958207, 'GB', 'GBR', 'المملكة المتحدة'),
(103358, 3641958208, 3641958399, 'MD', 'MDA', 'مولدوفا'),
(103359, 3641958400, 3641960699, 'BE', 'BEL', 'بلجيكا'),
(103360, 3641960700, 3641960703, 'NL', 'NLD', 'هولندا'),
(103361, 3641960704, 3641961727, 'BE', 'BEL', 'بلجيكا'),
(103362, 3641961728, 3641961743, 'NL', 'NLD', 'هولندا'),
(103363, 3641961744, 3641961791, 'BE', 'BEL', 'بلجيكا'),
(103364, 3641961792, 3641961799, 'US', 'USA', 'الولايات المتحدة'),
(103365, 3641961800, 3641962495, 'BE', 'BEL', 'بلجيكا'),
(103366, 3641962496, 3641966591, 'GB', 'GBR', 'المملكة المتحدة'),
(103367, 3641966592, 3641970687, 'IT', 'ITA', 'إيطاليا'),
(103368, 3641970688, 3641978879, 'GB', 'GBR', 'المملكة المتحدة'),
(103369, 3641978880, 3641982975, 'DK', 'DNK', 'الدنيمارك'),
(103370, 3641982976, 3641991167, 'RU', 'RUS', 'الإتحاد الروسي'),
(103371, 3641991168, 3641995263, 'SE', 'SWE', 'السويد'),
(103372, 3641995264, 3641999359, 'DE', 'DEU', 'ألمانيا'),
(103373, 3641999360, 3642003455, 'HU', 'HUN', 'هنغاريا'),
(103374, 3642007552, 3642015743, 'UA', 'UKR', 'أوكرانيا'),
(103375, 3642015744, 3642019839, 'CH', 'CHE', 'سويسرا'),
(103376, 3642028032, 3642028287, 'GB', 'GBR', 'المملكة المتحدة'),
(103377, 3642028288, 3642028543, 'NG', 'NGA', 'نيجيريا'),
(103378, 3642028544, 3642028544, 'GB', 'GBR', 'المملكة المتحدة'),
(103379, 3642028545, 3642028799, 'NG', 'NGA', 'نيجيريا'),
(103380, 3642028800, 3642028800, 'GB', 'GBR', 'المملكة المتحدة'),
(103381, 3642028801, 3642028863, 'SO', 'SOM', 'الصومال'),
(103382, 3642028864, 3642028928, 'GB', 'GBR', 'المملكة المتحدة'),
(103383, 3642028929, 3642029055, 'NG', 'NGA', 'نيجيريا'),
(103384, 3642029056, 3642029056, 'GB', 'GBR', 'المملكة المتحدة'),
(103385, 3642029057, 3642029311, 'NG', 'NGA', 'نيجيريا'),
(103386, 3642029312, 3642029567, 'GB', 'GBR', 'المملكة المتحدة'),
(103387, 3642029568, 3642031359, 'NG', 'NGA', 'نيجيريا'),
(103388, 3642031360, 3642031616, 'GB', 'GBR', 'المملكة المتحدة'),
(103389, 3642031617, 3642031743, 'SL', 'SLE', 'سيراليون'),
(103390, 3642031744, 3642032127, 'GB', 'GBR', 'المملكة المتحدة'),
(103391, 3642032128, 3642036223, 'PS', 'PSE', 'فلسطين المحتلة'),
(103392, 3642036224, 3642040319, 'RU', 'RUS', 'الإتحاد الروسي'),
(103393, 3642040320, 3642048511, 'BY', 'BLR', 'روسيا البيضاء'),
(103394, 3642048512, 3642053439, 'GB', 'GBR', 'المملكة المتحدة'),
(103395, 3642053440, 3642053631, 'TZ', 'TZA', 'تانزانيا'),
(103396, 3642053632, 3642056703, 'GB', 'GBR', 'المملكة المتحدة'),
(103397, 3642056704, 3642060799, 'RU', 'RUS', 'الإتحاد الروسي'),
(103398, 3642064896, 3642068991, 'SE', 'SWE', 'السويد'),
(103399, 3642068992, 3642073087, 'NL', 'NLD', 'هولندا'),
(103400, 3642073088, 3642077183, 'LV', 'LVA', 'لاتفيا'),
(103401, 3642077184, 3642081279, 'BE', 'BEL', 'بلجيكا'),
(103402, 3642081280, 3642085375, 'NL', 'NLD', 'هولندا'),
(103403, 3642085376, 3642089471, 'RU', 'RUS', 'الإتحاد الروسي'),
(103404, 3642089472, 3642093567, 'SE', 'SWE', 'السويد'),
(103405, 3642093568, 3642097663, 'NL', 'NLD', 'هولندا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(103406, 3642097664, 3642101759, 'GB', 'GBR', 'المملكة المتحدة'),
(103407, 3642101760, 3642109951, 'NO', 'NOR', 'النرويج'),
(103408, 3642109952, 3642114047, 'BE', 'BEL', 'بلجيكا'),
(103409, 3642114048, 3642118143, 'NL', 'NLD', 'هولندا'),
(103410, 3642118144, 3642122239, 'GB', 'GBR', 'المملكة المتحدة'),
(103411, 3642122240, 3642126335, 'ES', 'ESP', 'إسبانيا'),
(103412, 3642126336, 3642130431, 'IL', 'ISR', 'إسرائيل'),
(103413, 3642130432, 3642134527, 'DE', 'DEU', 'ألمانيا'),
(103414, 3642134528, 3642138623, 'GB', 'GBR', 'المملكة المتحدة'),
(103415, 3642138624, 3642142719, 'RU', 'RUS', 'الإتحاد الروسي'),
(103416, 3642142720, 3642146815, 'MT', 'MLT', 'مالطا'),
(103417, 3642146816, 3642150911, 'DE', 'DEU', 'ألمانيا'),
(103418, 3642150912, 3642163199, 'IT', 'ITA', 'إيطاليا'),
(103419, 3642163200, 3642164046, 'NL', 'NLD', 'هولندا'),
(103420, 3642164047, 3642164048, 'AF', 'AFG', 'أفغانستان'),
(103421, 3642164049, 3642164595, 'NL', 'NLD', 'هولندا'),
(103422, 3642164596, 3642164663, 'HK', 'HKG', 'هونغ كونغ'),
(103423, 3642164664, 3642167295, 'NL', 'NLD', 'هولندا'),
(103424, 3642167296, 3642171391, 'RU', 'RUS', 'الإتحاد الروسي'),
(103425, 3642171392, 3642175487, 'JO', 'JOR', 'الأردن'),
(103426, 3642175488, 3642179583, 'DE', 'DEU', 'ألمانيا'),
(103427, 3642179584, 3642187775, 'RU', 'RUS', 'الإتحاد الروسي'),
(103428, 3642187776, 3642190591, 'DK', 'DNK', 'الدنيمارك'),
(103429, 3642190592, 3642190623, 'NO', 'NOR', 'النرويج'),
(103430, 3642190624, 3642191423, 'DK', 'DNK', 'الدنيمارك'),
(103431, 3642191424, 3642191455, 'ES', 'ESP', 'إسبانيا'),
(103432, 3642191456, 3642191487, 'TR', 'TUR', 'تركيا'),
(103433, 3642191488, 3642191519, 'CH', 'CHE', 'سويسرا'),
(103434, 3642191520, 3642191551, 'CY', 'CYP', 'قبرص'),
(103435, 3642191552, 3642191583, 'ES', 'ESP', 'إسبانيا'),
(103436, 3642191584, 3642191615, 'US', 'USA', 'الولايات المتحدة'),
(103437, 3642191616, 3642191647, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(103438, 3642191648, 3642191679, 'AU', 'AUS', 'أستراليا'),
(103439, 3642191680, 3642191711, 'TH', 'THA', 'تايلند'),
(103440, 3642191712, 3642191743, 'BR', 'BRA', 'البرازيل'),
(103441, 3642191744, 3642191871, 'DK', 'DNK', 'الدنيمارك'),
(103442, 3642191872, 3642195967, 'BY', 'BLR', 'روسيا البيضاء'),
(103443, 3642195968, 3642204159, 'RU', 'RUS', 'الإتحاد الروسي'),
(103444, 3642204160, 3642208255, 'GB', 'GBR', 'المملكة المتحدة'),
(103445, 3642208256, 3642212351, 'RU', 'RUS', 'الإتحاد الروسي'),
(103446, 3642212352, 3642216447, 'BA', 'BIH', 'البوسنه والهرسك'),
(103447, 3642216448, 3642220543, 'HU', 'HUN', 'هنغاريا'),
(103448, 3642220544, 3642224639, 'GB', 'GBR', 'المملكة المتحدة'),
(103449, 3642224640, 3642228735, 'SK', 'SVK', 'سلوفاكيا'),
(103450, 3642228736, 3642232831, 'DE', 'DEU', 'ألمانيا'),
(103451, 3642232832, 3642233855, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103452, 3642233856, 3642234879, 'RS', 'SRB', 'صربيا'),
(103453, 3642234880, 3642234943, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103454, 3642234944, 3642234999, 'RS', 'SRB', 'صربيا'),
(103455, 3642235000, 3642235007, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103456, 3642235008, 3642235903, 'RS', 'SRB', 'صربيا'),
(103457, 3642235904, 3642236927, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103458, 3642236928, 3642241023, 'CH', 'CHE', 'سويسرا'),
(103459, 3642241024, 3642245119, 'DE', 'DEU', 'ألمانيا'),
(103460, 3642245120, 3642249215, 'LV', 'LVA', 'لاتفيا'),
(103461, 3642249216, 3642253311, 'FR', 'FRA', 'فرنسا'),
(103462, 3642253312, 3642257407, 'FI', 'FIN', 'فنلندا'),
(103463, 3642257408, 3642261503, 'RU', 'RUS', 'الإتحاد الروسي'),
(103464, 3642261504, 3642265599, 'GB', 'GBR', 'المملكة المتحدة'),
(103465, 3642265600, 3642266111, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(103466, 3642266112, 3642266367, 'IR', 'IRN', 'إيران'),
(103467, 3642266368, 3642266623, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(103468, 3642266624, 3642269695, 'IR', 'IRN', 'إيران'),
(103469, 3642269696, 3642273791, 'UA', 'UKR', 'أوكرانيا'),
(103470, 3642273792, 3642277887, 'RU', 'RUS', 'الإتحاد الروسي'),
(103471, 3642277888, 3642290175, 'DE', 'DEU', 'ألمانيا'),
(103472, 3642290176, 3642294271, 'AL', 'ALB', 'ألبانيا'),
(103473, 3642294272, 3642298367, 'GB', 'GBR', 'المملكة المتحدة'),
(103474, 3642298368, 3642302463, 'AZ', 'AZE', 'أذربيجان'),
(103475, 3642302464, 3642302759, 'SE', 'SWE', 'السويد'),
(103476, 3642302760, 3642302764, 'GB', 'GBR', 'المملكة المتحدة'),
(103477, 3642302765, 3642302975, 'SE', 'SWE', 'السويد'),
(103478, 3642302976, 3642303007, 'GB', 'GBR', 'المملكة المتحدة'),
(103479, 3642303008, 3642304031, 'SE', 'SWE', 'السويد'),
(103480, 3642304032, 3642304036, 'GB', 'GBR', 'المملكة المتحدة'),
(103481, 3642304037, 3642306559, 'SE', 'SWE', 'السويد'),
(103482, 3642306560, 3642310655, 'IR', 'IRN', 'إيران'),
(103483, 3642310656, 3642314751, 'DE', 'DEU', 'ألمانيا'),
(103484, 3642314752, 3642318847, 'RU', 'RUS', 'الإتحاد الروسي'),
(103485, 3642318848, 3642322943, 'FI', 'FIN', 'فنلندا'),
(103486, 3642322944, 3642327039, 'AT', 'AUT', 'النمسا'),
(103487, 3642327040, 3642331135, 'DE', 'DEU', 'ألمانيا'),
(103488, 3642331136, 3642335231, 'RU', 'RUS', 'الإتحاد الروسي'),
(103489, 3642335232, 3642339327, 'DE', 'DEU', 'ألمانيا'),
(103490, 3642339328, 3642343423, 'FR', 'FRA', 'فرنسا'),
(103491, 3642343424, 3642347519, 'UA', 'UKR', 'أوكرانيا'),
(103492, 3642347520, 3642355711, 'RU', 'RUS', 'الإتحاد الروسي'),
(103493, 3642355712, 3642359807, 'SE', 'SWE', 'السويد'),
(103494, 3642359808, 3642367999, 'RU', 'RUS', 'الإتحاد الروسي'),
(103495, 3642368000, 3642376191, 'CH', 'CHE', 'سويسرا'),
(103496, 3642376192, 3642378127, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103497, 3642378128, 3642378143, 'RS', 'SRB', 'صربيا'),
(103498, 3642378144, 3642378911, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103499, 3642378912, 3642378943, 'RS', 'SRB', 'صربيا'),
(103500, 3642378944, 3642379519, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103501, 3642379520, 3642379711, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103502, 3642379712, 3642380031, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103503, 3642380032, 3642380063, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103504, 3642380064, 3642380095, 'RS', 'SRB', 'صربيا'),
(103505, 3642380096, 3642380287, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103506, 3642380288, 3642384383, 'IT', 'ITA', 'إيطاليا'),
(103507, 3642388480, 3642392575, 'NL', 'NLD', 'هولندا'),
(103508, 3642392576, 3642396671, 'AM', 'ARM', 'أرمينيا'),
(103509, 3642396672, 3642404863, 'MD', 'MDA', 'مولدوفا'),
(103510, 3642404864, 3642408959, 'RU', 'RUS', 'الإتحاد الروسي'),
(103511, 3642408960, 3642413055, 'FR', 'FRA', 'فرنسا'),
(103512, 3642413056, 3642414591, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(103513, 3642414592, 3642415627, 'GB', 'GBR', 'المملكة المتحدة'),
(103514, 3642415628, 3642415635, 'MT', 'MLT', 'مالطا'),
(103515, 3642415636, 3642415651, 'GB', 'GBR', 'المملكة المتحدة'),
(103516, 3642415652, 3642415655, 'MT', 'MLT', 'مالطا'),
(103517, 3642415656, 3642417151, 'GB', 'GBR', 'المملكة المتحدة'),
(103518, 3642417152, 3642421247, 'IT', 'ITA', 'إيطاليا'),
(103519, 3642421248, 3642429439, 'DE', 'DEU', 'ألمانيا'),
(103520, 3642429440, 3642433535, 'GB', 'GBR', 'المملكة المتحدة'),
(103521, 3642433536, 3642435583, 'CY', 'CYP', 'قبرص'),
(103522, 3642435584, 3642436607, 'RU', 'RUS', 'الإتحاد الروسي'),
(103523, 3642436608, 3642437119, 'GR', 'GRC', 'اليونان'),
(103524, 3642437120, 3642437631, 'GB', 'GBR', 'المملكة المتحدة'),
(103525, 3642437632, 3642439423, 'CY', 'CYP', 'قبرص'),
(103526, 3642439424, 3642439459, 'RU', 'RUS', 'الإتحاد الروسي'),
(103527, 3642439460, 3642439463, 'CY', 'CYP', 'قبرص'),
(103528, 3642439464, 3642439471, 'RU', 'RUS', 'الإتحاد الروسي'),
(103529, 3642439472, 3642439483, 'CY', 'CYP', 'قبرص'),
(103530, 3642439484, 3642439495, 'RU', 'RUS', 'الإتحاد الروسي'),
(103531, 3642439496, 3642439551, 'CY', 'CYP', 'قبرص'),
(103532, 3642439552, 3642439567, 'RU', 'RUS', 'الإتحاد الروسي'),
(103533, 3642439568, 3642441727, 'CY', 'CYP', 'قبرص'),
(103534, 3642441728, 3642449919, 'IT', 'ITA', 'إيطاليا'),
(103535, 3642449920, 3642454015, 'CH', 'CHE', 'سويسرا'),
(103536, 3642454016, 3642458111, 'IT', 'ITA', 'إيطاليا'),
(103537, 3642458112, 3642462207, 'RU', 'RUS', 'الإتحاد الروسي'),
(103538, 3642462208, 3642466303, 'UA', 'UKR', 'أوكرانيا'),
(103539, 3642466304, 3642474495, 'SE', 'SWE', 'السويد'),
(103540, 3642474496, 3642478591, 'DE', 'DEU', 'ألمانيا'),
(103541, 3642478592, 3642482687, 'HU', 'HUN', 'هنغاريا'),
(103542, 3642482688, 3642486783, 'NL', 'NLD', 'هولندا'),
(103543, 3642486784, 3642499071, 'GB', 'GBR', 'المملكة المتحدة'),
(103544, 3642499072, 3642503167, 'SE', 'SWE', 'السويد'),
(103545, 3642503168, 3642507263, 'LV', 'LVA', 'لاتفيا'),
(103546, 3642507264, 3642509311, 'FR', 'FRA', 'فرنسا'),
(103547, 3642511360, 3642515455, 'RU', 'RUS', 'الإتحاد الروسي'),
(103548, 3642515456, 3642519551, 'DE', 'DEU', 'ألمانيا'),
(103549, 3642519552, 3642523647, 'IT', 'ITA', 'إيطاليا'),
(103550, 3642523648, 3642527743, 'GB', 'GBR', 'المملكة المتحدة'),
(103551, 3642527744, 3642531839, 'PL', 'POL', 'بولندا'),
(103552, 3642531840, 3642532351, 'DK', 'DNK', 'الدنيمارك'),
(103553, 3642532352, 3642532607, 'GB', 'GBR', 'المملكة المتحدة'),
(103554, 3642532608, 3642532863, 'US', 'USA', 'الولايات المتحدة'),
(103555, 3642532864, 3642535935, 'DK', 'DNK', 'الدنيمارك'),
(103556, 3642535936, 3642539869, 'IS', 'ISL', 'أيسلندا'),
(103557, 3642539870, 3642539870, 'GB', 'GBR', 'المملكة المتحدة'),
(103558, 3642539871, 3642539971, 'IS', 'ISL', 'أيسلندا'),
(103559, 3642539972, 3642539975, 'DK', 'DNK', 'الدنيمارك'),
(103560, 3642539976, 3642540031, 'IS', 'ISL', 'أيسلندا'),
(103561, 3642540032, 3642544127, 'SE', 'SWE', 'السويد'),
(103562, 3642544128, 3642552319, 'RU', 'RUS', 'الإتحاد الروسي'),
(103563, 3642552320, 3642552639, 'DE', 'DEU', 'ألمانيا'),
(103564, 3642552640, 3642552655, 'EE', 'EST', 'إستونيا'),
(103565, 3642552656, 3642552663, 'HU', 'HUN', 'هنغاريا'),
(103566, 3642552664, 3642552665, 'EE', 'EST', 'إستونيا'),
(103567, 3642552666, 3642552671, 'DE', 'DEU', 'ألمانيا'),
(103568, 3642552672, 3642552687, 'SE', 'SWE', 'السويد'),
(103569, 3642552688, 3642552831, 'DE', 'DEU', 'ألمانيا'),
(103570, 3642552832, 3642552847, 'EE', 'EST', 'إستونيا'),
(103571, 3642552848, 3642553087, 'DE', 'DEU', 'ألمانيا'),
(103572, 3642553088, 3642553097, 'LV', 'LVA', 'لاتفيا'),
(103573, 3642553098, 3642553103, 'DE', 'DEU', 'ألمانيا'),
(103574, 3642553104, 3642553119, 'LV', 'LVA', 'لاتفيا'),
(103575, 3642553120, 3642553151, 'DE', 'DEU', 'ألمانيا'),
(103576, 3642553152, 3642553175, 'LV', 'LVA', 'لاتفيا'),
(103577, 3642553176, 3642553183, 'DE', 'DEU', 'ألمانيا'),
(103578, 3642553184, 3642553326, 'LV', 'LVA', 'لاتفيا'),
(103579, 3642553327, 3642553343, 'DE', 'DEU', 'ألمانيا'),
(103580, 3642553344, 3642553371, 'RU', 'RUS', 'الإتحاد الروسي'),
(103581, 3642553372, 3642553375, 'DE', 'DEU', 'ألمانيا'),
(103582, 3642553376, 3642553377, 'RU', 'RUS', 'الإتحاد الروسي'),
(103583, 3642553378, 3642553379, 'DE', 'DEU', 'ألمانيا'),
(103584, 3642553380, 3642553383, 'RU', 'RUS', 'الإتحاد الروسي'),
(103585, 3642553384, 3642553387, 'DE', 'DEU', 'ألمانيا'),
(103586, 3642553388, 3642553411, 'RU', 'RUS', 'الإتحاد الروسي'),
(103587, 3642553412, 3642553415, 'DE', 'DEU', 'ألمانيا'),
(103588, 3642553416, 3642553423, 'RU', 'RUS', 'الإتحاد الروسي'),
(103589, 3642553424, 3642553431, 'DE', 'DEU', 'ألمانيا'),
(103590, 3642553432, 3642553463, 'RU', 'RUS', 'الإتحاد الروسي'),
(103591, 3642553464, 3642553467, 'DE', 'DEU', 'ألمانيا'),
(103592, 3642553468, 3642553519, 'RU', 'RUS', 'الإتحاد الروسي'),
(103593, 3642553520, 3642553523, 'DE', 'DEU', 'ألمانيا'),
(103594, 3642553524, 3642553535, 'RU', 'RUS', 'الإتحاد الروسي'),
(103595, 3642553536, 3642553543, 'DE', 'DEU', 'ألمانيا'),
(103596, 3642553544, 3642553589, 'RU', 'RUS', 'الإتحاد الروسي'),
(103597, 3642553590, 3642553591, 'DE', 'DEU', 'ألمانيا'),
(103598, 3642553592, 3642553599, 'RU', 'RUS', 'الإتحاد الروسي'),
(103599, 3642553600, 3642553855, 'DE', 'DEU', 'ألمانيا'),
(103600, 3642553856, 3642553925, 'RU', 'RUS', 'الإتحاد الروسي'),
(103601, 3642553926, 3642553935, 'DE', 'DEU', 'ألمانيا'),
(103602, 3642553936, 3642553951, 'RU', 'RUS', 'الإتحاد الروسي'),
(103603, 3642553952, 3642554111, 'DE', 'DEU', 'ألمانيا'),
(103604, 3642554112, 3642554119, 'RU', 'RUS', 'الإتحاد الروسي'),
(103605, 3642554120, 3642554123, 'DE', 'DEU', 'ألمانيا'),
(103606, 3642554124, 3642554151, 'RU', 'RUS', 'الإتحاد الروسي'),
(103607, 3642554152, 3642554177, 'DE', 'DEU', 'ألمانيا'),
(103608, 3642554178, 3642554203, 'RU', 'RUS', 'الإتحاد الروسي'),
(103609, 3642554204, 3642554205, 'DE', 'DEU', 'ألمانيا'),
(103610, 3642554206, 3642554223, 'RU', 'RUS', 'الإتحاد الروسي'),
(103611, 3642554224, 3642554239, 'DE', 'DEU', 'ألمانيا'),
(103612, 3642554240, 3642554271, 'RU', 'RUS', 'الإتحاد الروسي'),
(103613, 3642554272, 3642554367, 'DE', 'DEU', 'ألمانيا'),
(103614, 3642554368, 3642554623, 'LT', 'LTU', 'ليتوانيا'),
(103615, 3642554624, 3642554631, 'DE', 'DEU', 'ألمانيا'),
(103616, 3642554632, 3642554671, 'LV', 'LVA', 'لاتفيا'),
(103617, 3642554672, 3642554675, 'DE', 'DEU', 'ألمانيا'),
(103618, 3642554676, 3642554679, 'EE', 'EST', 'إستونيا'),
(103619, 3642554680, 3642554687, 'LV', 'LVA', 'لاتفيا'),
(103620, 3642554688, 3642554751, 'DE', 'DEU', 'ألمانيا'),
(103621, 3642554752, 3642554787, 'LV', 'LVA', 'لاتفيا'),
(103622, 3642554788, 3642554807, 'DE', 'DEU', 'ألمانيا'),
(103623, 3642554808, 3642554815, 'LV', 'LVA', 'لاتفيا'),
(103624, 3642554816, 3642554847, 'DE', 'DEU', 'ألمانيا'),
(103625, 3642554848, 3642554879, 'LV', 'LVA', 'لاتفيا'),
(103626, 3642554880, 3642554911, 'DE', 'DEU', 'ألمانيا'),
(103627, 3642554912, 3642554919, 'NL', 'NLD', 'هولندا'),
(103628, 3642554920, 3642554931, 'DE', 'DEU', 'ألمانيا'),
(103629, 3642554932, 3642554951, 'UA', 'UKR', 'أوكرانيا'),
(103630, 3642554952, 3642554955, 'DE', 'DEU', 'ألمانيا'),
(103631, 3642554956, 3642554959, 'GE', 'GEO', 'جورجيا'),
(103632, 3642554960, 3642554963, 'DE', 'DEU', 'ألمانيا'),
(103633, 3642554964, 3642554967, 'UA', 'UKR', 'أوكرانيا'),
(103634, 3642554968, 3642554971, 'LV', 'LVA', 'لاتفيا'),
(103635, 3642554972, 3642554975, 'DE', 'DEU', 'ألمانيا'),
(103636, 3642554976, 3642554977, 'CZ', 'CZE', 'التشيك'),
(103637, 3642554978, 3642554979, 'FR', 'FRA', 'فرنسا'),
(103638, 3642554980, 3642554983, 'BE', 'BEL', 'بلجيكا'),
(103639, 3642554984, 3642554987, 'DE', 'DEU', 'ألمانيا'),
(103640, 3642554988, 3642554989, 'FR', 'FRA', 'فرنسا'),
(103641, 3642554990, 3642554991, 'UA', 'UKR', 'أوكرانيا'),
(103642, 3642554992, 3642555015, 'DE', 'DEU', 'ألمانيا'),
(103643, 3642555016, 3642555017, 'NL', 'NLD', 'هولندا'),
(103644, 3642555018, 3642555023, 'DE', 'DEU', 'ألمانيا'),
(103645, 3642555024, 3642555039, 'NL', 'NLD', 'هولندا'),
(103646, 3642555040, 3642555051, 'DE', 'DEU', 'ألمانيا'),
(103647, 3642555052, 3642555055, 'UA', 'UKR', 'أوكرانيا'),
(103648, 3642555056, 3642555067, 'DE', 'DEU', 'ألمانيا'),
(103649, 3642555068, 3642555069, 'NL', 'NLD', 'هولندا'),
(103650, 3642555070, 3642555071, 'DE', 'DEU', 'ألمانيا'),
(103651, 3642555072, 3642555087, 'GE', 'GEO', 'جورجيا'),
(103652, 3642555088, 3642555135, 'DE', 'DEU', 'ألمانيا'),
(103653, 3642555136, 3642555153, 'LT', 'LTU', 'ليتوانيا'),
(103654, 3642555154, 3642555167, 'DE', 'DEU', 'ألمانيا'),
(103655, 3642555168, 3642555183, 'LT', 'LTU', 'ليتوانيا'),
(103656, 3642555184, 3642555199, 'DE', 'DEU', 'ألمانيا'),
(103657, 3642555200, 3642555223, 'LT', 'LTU', 'ليتوانيا'),
(103658, 3642555224, 3642555227, 'LV', 'LVA', 'لاتفيا'),
(103659, 3642555228, 3642555391, 'LT', 'LTU', 'ليتوانيا'),
(103660, 3642555392, 3642555489, 'PL', 'POL', 'بولندا'),
(103661, 3642555490, 3642555647, 'DE', 'DEU', 'ألمانيا'),
(103662, 3642555648, 3642555683, 'SE', 'SWE', 'السويد'),
(103663, 3642555684, 3642555687, 'DE', 'DEU', 'ألمانيا'),
(103664, 3642555688, 3642555695, 'SE', 'SWE', 'السويد'),
(103665, 3642555696, 3642555703, 'LV', 'LVA', 'لاتفيا'),
(103666, 3642555704, 3642555707, 'FI', 'FIN', 'فنلندا'),
(103667, 3642555708, 3642555711, 'SE', 'SWE', 'السويد'),
(103668, 3642555712, 3642555727, 'RU', 'RUS', 'الإتحاد الروسي'),
(103669, 3642555728, 3642555735, 'SE', 'SWE', 'السويد'),
(103670, 3642555736, 3642555743, 'GB', 'GBR', 'المملكة المتحدة'),
(103671, 3642555744, 3642555759, 'SE', 'SWE', 'السويد'),
(103672, 3642555760, 3642555771, 'GB', 'GBR', 'المملكة المتحدة'),
(103673, 3642555772, 3642555775, 'DE', 'DEU', 'ألمانيا'),
(103674, 3642555776, 3642555783, 'SE', 'SWE', 'السويد'),
(103675, 3642555784, 3642555787, 'GB', 'GBR', 'المملكة المتحدة'),
(103676, 3642555788, 3642555789, 'DE', 'DEU', 'ألمانيا'),
(103677, 3642555790, 3642555791, 'SE', 'SWE', 'السويد'),
(103678, 3642555792, 3642555839, 'DE', 'DEU', 'ألمانيا'),
(103679, 3642555840, 3642555903, 'SE', 'SWE', 'السويد'),
(103680, 3642555904, 3642555935, 'DE', 'DEU', 'ألمانيا'),
(103681, 3642555936, 3642555983, 'UA', 'UKR', 'أوكرانيا'),
(103682, 3642555984, 3642556159, 'DE', 'DEU', 'ألمانيا'),
(103683, 3642556160, 3642556415, 'LV', 'LVA', 'لاتفيا'),
(103684, 3642556416, 3642560511, 'CZ', 'CZE', 'التشيك'),
(103685, 3642560512, 3642564607, 'KG', 'KGZ', 'قيرغيزستان'),
(103686, 3642564608, 3642568703, 'DE', 'DEU', 'ألمانيا'),
(103687, 3642568704, 3642572799, 'RU', 'RUS', 'الإتحاد الروسي'),
(103688, 3642572800, 3642576895, 'IT', 'ITA', 'إيطاليا'),
(103689, 3642576896, 3642580991, 'RU', 'RUS', 'الإتحاد الروسي'),
(103690, 3642580992, 3642585087, 'ES', 'ESP', 'إسبانيا'),
(103691, 3642585088, 3642589183, 'UZ', 'UZB', 'أوزباكستان'),
(103692, 3642593280, 3642597375, 'AT', 'AUT', 'النمسا'),
(103693, 3642597376, 3642601471, 'IT', 'ITA', 'إيطاليا'),
(103694, 3642601472, 3642605567, 'RU', 'RUS', 'الإتحاد الروسي'),
(103695, 3642605568, 3642609663, 'GB', 'GBR', 'المملكة المتحدة'),
(103696, 3642613760, 3642615583, 'FI', 'FIN', 'فنلندا'),
(103697, 3642615584, 3642615615, 'AX', 'FIN', 'فنلندا'),
(103698, 3642615616, 3642617855, 'FI', 'FIN', 'فنلندا'),
(103699, 3642617856, 3642621951, 'JO', 'JOR', 'الأردن'),
(103700, 3642621952, 3642626047, 'IT', 'ITA', 'إيطاليا'),
(103701, 3642626048, 3642630143, 'BE', 'BEL', 'بلجيكا'),
(103702, 3642630144, 3642634239, 'DK', 'DNK', 'الدنيمارك'),
(103703, 3642634240, 3642638335, 'DE', 'DEU', 'ألمانيا'),
(103704, 3642638336, 3642642431, 'CZ', 'CZE', 'التشيك'),
(103705, 3642642432, 3642646527, 'DK', 'DNK', 'الدنيمارك'),
(103706, 3642646528, 3642650623, 'MT', 'MLT', 'مالطا'),
(103707, 3642650624, 3642654719, 'GB', 'GBR', 'المملكة المتحدة'),
(103708, 3642654720, 3642662911, 'PL', 'POL', 'بولندا'),
(103709, 3642662912, 3642667007, 'UZ', 'UZB', 'أوزباكستان'),
(103710, 3642667008, 3642671103, 'FI', 'FIN', 'فنلندا'),
(103711, 3642671104, 3642675199, 'UA', 'UKR', 'أوكرانيا'),
(103712, 3642675200, 3642679295, 'BG', 'BGR', 'بلغاريا'),
(103713, 3642679296, 3642683391, 'DE', 'DEU', 'ألمانيا'),
(103714, 3642683392, 3642687487, 'RU', 'RUS', 'الإتحاد الروسي'),
(103715, 3642687488, 3642691583, 'GB', 'GBR', 'المملكة المتحدة'),
(103716, 3642691584, 3642695679, 'DE', 'DEU', 'ألمانيا'),
(103717, 3642695680, 3642699775, 'SK', 'SVK', 'سلوفاكيا'),
(103718, 3642699776, 3642703871, 'CZ', 'CZE', 'التشيك'),
(103719, 3642703872, 3642707967, 'LU', 'LUX', 'لوكسيمبورغ'),
(103720, 3642707968, 3642712063, 'DE', 'DEU', 'ألمانيا'),
(103721, 3642712064, 3642716159, 'NO', 'NOR', 'النرويج'),
(103722, 3642716160, 3642720255, 'IT', 'ITA', 'إيطاليا'),
(103723, 3642720256, 3642728447, 'GB', 'GBR', 'المملكة المتحدة'),
(103724, 3642728448, 3642736639, 'SE', 'SWE', 'السويد'),
(103725, 3642736640, 3642740735, 'CZ', 'CZE', 'التشيك'),
(103726, 3642740736, 3642744831, 'DE', 'DEU', 'ألمانيا'),
(103727, 3642744832, 3642753023, 'TR', 'TUR', 'تركيا'),
(103728, 3642753024, 3643801599, 'GB', 'GBR', 'المملكة المتحدة'),
(103729, 3643801600, 3644063743, 'DE', 'DEU', 'ألمانيا'),
(103730, 3644325888, 3644588031, 'IT', 'ITA', 'إيطاليا'),
(103731, 3644588032, 3644719103, 'DK', 'DNK', 'الدنيمارك'),
(103732, 3644719104, 3644809215, 'NL', 'NLD', 'هولندا'),
(103733, 3644809216, 3644817407, 'AM', 'ARM', 'أرمينيا'),
(103734, 3644817408, 3644850175, 'NL', 'NLD', 'هولندا'),
(103735, 3644850176, 3644854271, 'CZ', 'CZE', 'التشيك'),
(103736, 3644854272, 3644858367, 'AZ', 'AZE', 'أذربيجان'),
(103737, 3644862464, 3644866559, 'FR', 'FRA', 'فرنسا'),
(103738, 3644866560, 3644871167, 'DE', 'DEU', 'ألمانيا'),
(103739, 3644871168, 3644871423, 'AT', 'AUT', 'النمسا'),
(103740, 3644871424, 3644874751, 'DE', 'DEU', 'ألمانيا'),
(103741, 3644878848, 3644882943, 'GB', 'GBR', 'المملكة المتحدة'),
(103742, 3644882944, 3644887039, 'RU', 'RUS', 'الإتحاد الروسي'),
(103743, 3644887040, 3644891135, 'IR', 'IRN', 'إيران'),
(103744, 3644891136, 3644895231, 'DE', 'DEU', 'ألمانيا'),
(103745, 3644895232, 3644899327, 'FI', 'FIN', 'فنلندا'),
(103746, 3644899328, 3644903423, 'IT', 'ITA', 'إيطاليا'),
(103747, 3644903424, 3644907519, 'TR', 'TUR', 'تركيا'),
(103748, 3644907520, 3644908983, 'GB', 'GBR', 'المملكة المتحدة'),
(103749, 3644908984, 3644908991, 'IT', 'ITA', 'إيطاليا'),
(103750, 3644908992, 3644909855, 'GB', 'GBR', 'المملكة المتحدة'),
(103751, 3644909856, 3644909859, 'IS', 'ISL', 'أيسلندا'),
(103752, 3644909860, 3644911615, 'GB', 'GBR', 'المملكة المتحدة'),
(103753, 3644911616, 3644915711, 'BE', 'BEL', 'بلجيكا'),
(103754, 3644915712, 3644919807, 'RU', 'RUS', 'الإتحاد الروسي'),
(103755, 3644919808, 3644923903, 'DE', 'DEU', 'ألمانيا'),
(103756, 3644923904, 3644924159, 'IL', 'ISR', 'إسرائيل'),
(103757, 3644924160, 3644924671, 'GB', 'GBR', 'المملكة المتحدة'),
(103758, 3644924672, 3644924927, 'IL', 'ISR', 'إسرائيل'),
(103759, 3644924928, 3644925183, 'US', 'USA', 'الولايات المتحدة'),
(103760, 3644925184, 3644925439, 'IL', 'ISR', 'إسرائيل'),
(103761, 3644925440, 3644925695, 'GB', 'GBR', 'المملكة المتحدة'),
(103762, 3644925696, 3644925951, 'IL', 'ISR', 'إسرائيل'),
(103763, 3644925952, 3644927231, 'US', 'USA', 'الولايات المتحدة'),
(103764, 3644927232, 3644927743, 'IL', 'ISR', 'إسرائيل'),
(103765, 3644927744, 3644927999, 'US', 'USA', 'الولايات المتحدة'),
(103766, 3644928000, 3644932095, 'GI', 'GIB', 'جبل طارق'),
(103767, 3644932096, 3644936191, 'IT', 'ITA', 'إيطاليا'),
(103768, 3644936192, 3644940287, 'RU', 'RUS', 'الإتحاد الروسي'),
(103769, 3644940288, 3644948479, 'HU', 'HUN', 'هنغاريا'),
(103770, 3644948480, 3644952575, 'DE', 'DEU', 'ألمانيا'),
(103771, 3644952576, 3644960767, 'GB', 'GBR', 'المملكة المتحدة'),
(103772, 3644960768, 3644961311, 'DE', 'DEU', 'ألمانيا'),
(103773, 3644961312, 3644961343, 'TR', 'TUR', 'تركيا'),
(103774, 3644961344, 3644961791, 'DE', 'DEU', 'ألمانيا'),
(103775, 3644961792, 3644964351, 'TR', 'TUR', 'تركيا'),
(103776, 3644964352, 3644964383, 'DE', 'DEU', 'ألمانيا'),
(103777, 3644964384, 3644964863, 'TR', 'TUR', 'تركيا'),
(103778, 3644964864, 3644968959, 'RS', 'SRB', 'صربيا'),
(103779, 3644968960, 3644973055, 'RU', 'RUS', 'الإتحاد الروسي'),
(103780, 3644973056, 3644977151, 'NO', 'NOR', 'النرويج'),
(103781, 3644977152, 3644981247, 'UA', 'UKR', 'أوكرانيا'),
(103782, 3644981248, 3644985343, 'BE', 'BEL', 'بلجيكا'),
(103783, 3644985344, 3644989439, 'RU', 'RUS', 'الإتحاد الروسي'),
(103784, 3644989440, 3644997631, 'DE', 'DEU', 'ألمانيا'),
(103785, 3644997632, 3645005823, 'RU', 'RUS', 'الإتحاد الروسي'),
(103786, 3645005824, 3645009919, 'UA', 'UKR', 'أوكرانيا'),
(103787, 3645009920, 3645014015, 'FR', 'FRA', 'فرنسا'),
(103788, 3645014016, 3645018111, 'DE', 'DEU', 'ألمانيا'),
(103789, 3645018112, 3645022207, 'RU', 'RUS', 'الإتحاد الروسي'),
(103790, 3645022208, 3645023743, 'CZ', 'CZE', 'التشيك'),
(103791, 3645023744, 3645023999, 'SK', 'SVK', 'سلوفاكيا'),
(103792, 3645024000, 3645030143, 'CZ', 'CZE', 'التشيك'),
(103793, 3645030144, 3645030399, 'SK', 'SVK', 'سلوفاكيا'),
(103794, 3645030400, 3645038591, 'IR', 'IRN', 'إيران'),
(103795, 3645038592, 3645046783, 'PS', 'PSE', 'فلسطين المحتلة'),
(103796, 3645046784, 3645050879, 'RU', 'RUS', 'الإتحاد الروسي'),
(103797, 3645050880, 3645054975, 'SK', 'SVK', 'سلوفاكيا'),
(103798, 3645054976, 3645059071, 'DE', 'DEU', 'ألمانيا'),
(103799, 3645059072, 3645063167, 'GB', 'GBR', 'المملكة المتحدة'),
(103800, 3645063168, 3645067263, 'UA', 'UKR', 'أوكرانيا'),
(103801, 3645067264, 3645071359, 'SE', 'SWE', 'السويد'),
(103802, 3645071360, 3645075455, 'DE', 'DEU', 'ألمانيا'),
(103803, 3645075456, 3645079551, 'RU', 'RUS', 'الإتحاد الروسي'),
(103804, 3645079552, 3645083647, 'IE', 'IRL', 'إيرلندا'),
(103805, 3645083648, 3645087743, 'FR', 'FRA', 'فرنسا'),
(103806, 3645087744, 3645091839, 'ES', 'ESP', 'إسبانيا'),
(103807, 3645091840, 3645095935, 'RU', 'RUS', 'الإتحاد الروسي'),
(103808, 3645095936, 3645104127, 'PL', 'POL', 'بولندا'),
(103809, 3645104128, 3645112319, 'NL', 'NLD', 'هولندا'),
(103810, 3645112320, 3645116415, 'DE', 'DEU', 'ألمانيا'),
(103811, 3645116416, 3645120511, 'GB', 'GBR', 'المملكة المتحدة'),
(103812, 3645120512, 3645124607, 'SE', 'SWE', 'السويد'),
(103813, 3645124608, 3645128703, 'NL', 'NLD', 'هولندا'),
(103814, 3645128704, 3645132799, 'GB', 'GBR', 'المملكة المتحدة'),
(103815, 3645132800, 3645136895, 'HR', 'HRV', 'كرواتيا'),
(103816, 3645136896, 3645145087, 'NO', 'NOR', 'النرويج'),
(103817, 3645145088, 3645149183, 'GB', 'GBR', 'المملكة المتحدة'),
(103818, 3645149184, 3645149887, 'DE', 'DEU', 'ألمانيا'),
(103819, 3645149888, 3645149951, 'HK', 'HKG', 'هونغ كونغ'),
(103820, 3645149952, 3645150559, 'DE', 'DEU', 'ألمانيا'),
(103821, 3645150560, 3645150591, 'HK', 'HKG', 'هونغ كونغ'),
(103822, 3645150592, 3645150615, 'DE', 'DEU', 'ألمانيا'),
(103823, 3645150616, 3645150623, 'US', 'USA', 'الولايات المتحدة'),
(103824, 3645150624, 3645150975, 'DE', 'DEU', 'ألمانيا'),
(103825, 3645150976, 3645151231, 'US', 'USA', 'الولايات المتحدة'),
(103826, 3645151232, 3645151487, 'DE', 'DEU', 'ألمانيا'),
(103827, 3645151488, 3645151615, 'MT', 'MLT', 'مالطا'),
(103828, 3645151616, 3645152767, 'DE', 'DEU', 'ألمانيا'),
(103829, 3645152768, 3645152799, 'HK', 'HKG', 'هونغ كونغ'),
(103830, 3645152800, 3645161471, 'DE', 'DEU', 'ألمانيا'),
(103831, 3645161472, 3645165567, 'AT', 'AUT', 'النمسا'),
(103832, 3645165568, 3645169663, 'TR', 'TUR', 'تركيا'),
(103833, 3645169664, 3645173759, 'CH', 'CHE', 'سويسرا'),
(103834, 3645173760, 3645177855, 'GB', 'GBR', 'المملكة المتحدة'),
(103835, 3645177856, 3645181951, 'GR', 'GRC', 'اليونان'),
(103836, 3645181952, 3645183327, 'FR', 'FRA', 'فرنسا'),
(103837, 3645183328, 3645183359, 'GB', 'GBR', 'المملكة المتحدة'),
(103838, 3645183360, 3645183439, 'FR', 'FRA', 'فرنسا'),
(103839, 3645183440, 3645183455, 'US', 'USA', 'الولايات المتحدة'),
(103840, 3645183456, 3645183615, 'FR', 'FRA', 'فرنسا'),
(103841, 3645183616, 3645183679, 'SA', 'SAU', 'السعودية'),
(103842, 3645183680, 3645183743, 'FR', 'FRA', 'فرنسا'),
(103843, 3645183744, 3645183871, 'GB', 'GBR', 'المملكة المتحدة'),
(103844, 3645183872, 3645183903, 'FR', 'FRA', 'فرنسا'),
(103845, 3645183904, 3645183935, 'IE', 'IRL', 'إيرلندا'),
(103846, 3645183936, 3645183999, 'FR', 'FRA', 'فرنسا'),
(103847, 3645184000, 3645184255, 'US', 'USA', 'الولايات المتحدة'),
(103848, 3645184256, 3645184256, 'FR', 'FRA', 'فرنسا'),
(103849, 3645184257, 3645184383, 'GB', 'GBR', 'المملكة المتحدة'),
(103850, 3645184384, 3645186047, 'FR', 'FRA', 'فرنسا'),
(103851, 3645186048, 3645190143, 'GB', 'GBR', 'المملكة المتحدة'),
(103852, 3645190144, 3645194239, 'FI', 'FIN', 'فنلندا'),
(103853, 3645194240, 3645202431, 'DE', 'DEU', 'ألمانيا'),
(103854, 3645202432, 3645206527, 'CZ', 'CZE', 'التشيك'),
(103855, 3645206528, 3645208575, 'LV', 'LVA', 'لاتفيا'),
(103856, 3645208576, 3645210623, 'LT', 'LTU', 'ليتوانيا'),
(103857, 3645210624, 3645214719, 'RU', 'RUS', 'الإتحاد الروسي'),
(103858, 3645214720, 3645218815, 'NL', 'NLD', 'هولندا'),
(103859, 3645218816, 3645222911, 'DE', 'DEU', 'ألمانيا'),
(103860, 3645222912, 3645227007, 'KW', 'KWT', 'الكويت'),
(103861, 3645227008, 3645235199, 'RU', 'RUS', 'الإتحاد الروسي'),
(103862, 3645235200, 3645243391, 'DE', 'DEU', 'ألمانيا'),
(103863, 3645243392, 3645247487, 'ES', 'ESP', 'إسبانيا'),
(103864, 3645247488, 3645251583, 'RU', 'RUS', 'الإتحاد الروسي'),
(103865, 3645251584, 3645255679, 'SE', 'SWE', 'السويد'),
(103866, 3645255680, 3645259775, 'PL', 'POL', 'بولندا'),
(103867, 3645259776, 3645263871, 'PT', 'PRT', 'البورتوغال'),
(103868, 3645263872, 3645267967, 'FR', 'FRA', 'فرنسا'),
(103869, 3645267968, 3645276159, 'RU', 'RUS', 'الإتحاد الروسي'),
(103870, 3645276160, 3645280255, 'DE', 'DEU', 'ألمانيا'),
(103871, 3645280256, 3645281279, 'IT', 'ITA', 'إيطاليا'),
(103872, 3645281280, 3645281535, 'DE', 'DEU', 'ألمانيا'),
(103873, 3645281536, 3645281791, 'IT', 'ITA', 'إيطاليا'),
(103874, 3645281792, 3645281919, 'HU', 'HUN', 'هنغاريا'),
(103875, 3645281920, 3645284351, 'IT', 'ITA', 'إيطاليا'),
(103876, 3645284352, 3645288447, 'DE', 'DEU', 'ألمانيا'),
(103877, 3645288448, 3645292543, 'FR', 'FRA', 'فرنسا'),
(103878, 3645292544, 3645295103, 'DE', 'DEU', 'ألمانيا'),
(103879, 3645295104, 3645295359, 'NL', 'NLD', 'هولندا'),
(103880, 3645295360, 3645296639, 'DE', 'DEU', 'ألمانيا'),
(103881, 3645296640, 3645300735, 'NL', 'NLD', 'هولندا'),
(103882, 3645300736, 3645304831, 'BE', 'BEL', 'بلجيكا'),
(103883, 3645304832, 3645308927, 'ES', 'ESP', 'إسبانيا'),
(103884, 3645308928, 3645313023, 'DK', 'DNK', 'الدنيمارك'),
(103885, 3645313024, 3645317119, 'ES', 'ESP', 'إسبانيا'),
(103886, 3645317120, 3645321215, 'EE', 'EST', 'إستونيا'),
(103887, 3645321216, 3645325311, 'BA', 'BIH', 'البوسنه والهرسك'),
(103888, 3645325312, 3645329407, 'IT', 'ITA', 'إيطاليا'),
(103889, 3645329408, 3645333503, 'CH', 'CHE', 'سويسرا'),
(103890, 3645333504, 3645334031, 'DE', 'DEU', 'ألمانيا'),
(103891, 3645334272, 3645336927, 'DE', 'DEU', 'ألمانيا'),
(103892, 3645336936, 3645336991, 'DE', 'DEU', 'ألمانيا'),
(103893, 3645337008, 3645337023, 'DE', 'DEU', 'ألمانيا'),
(103894, 3645337088, 3645337599, 'DE', 'DEU', 'ألمانيا'),
(103895, 3645337600, 3645337631, 'FR', 'FRA', 'فرنسا'),
(103896, 3645337632, 3645337663, 'BE', 'BEL', 'بلجيكا'),
(103897, 3645337664, 3645338399, 'FR', 'FRA', 'فرنسا'),
(103898, 3645338400, 3645338431, 'BE', 'BEL', 'بلجيكا'),
(103899, 3645338432, 3645339295, 'FR', 'FRA', 'فرنسا'),
(103900, 3645339296, 3645339359, 'BE', 'BEL', 'بلجيكا'),
(103901, 3645339360, 3645339391, 'FR', 'FRA', 'فرنسا'),
(103902, 3645339392, 3645339647, 'NL', 'NLD', 'هولندا'),
(103903, 3645339648, 3645339903, 'FR', 'FRA', 'فرنسا'),
(103904, 3645339904, 3645339967, 'BE', 'BEL', 'بلجيكا'),
(103905, 3645339968, 3645340415, 'FR', 'FRA', 'فرنسا'),
(103906, 3645340416, 3645340447, 'NL', 'NLD', 'هولندا'),
(103907, 3645340448, 3645340543, 'FR', 'FRA', 'فرنسا'),
(103908, 3645340544, 3645340927, 'BE', 'BEL', 'بلجيكا'),
(103909, 3645340928, 3645341183, 'FR', 'FRA', 'فرنسا'),
(103910, 3645341184, 3645341439, 'BE', 'BEL', 'بلجيكا'),
(103911, 3645341440, 3645341695, 'FR', 'FRA', 'فرنسا'),
(103912, 3645341696, 3645345791, 'RU', 'RUS', 'الإتحاد الروسي'),
(103913, 3645345792, 3645349887, 'FI', 'FIN', 'فنلندا'),
(103914, 3645349888, 3645353983, 'RU', 'RUS', 'الإتحاد الروسي'),
(103915, 3645353984, 3645358079, 'MT', 'MLT', 'مالطا'),
(103916, 3645358080, 3645362175, 'ES', 'ESP', 'إسبانيا'),
(103917, 3645362176, 3645364223, 'FR', 'FRA', 'فرنسا'),
(103918, 3645366272, 3645370367, 'RU', 'RUS', 'الإتحاد الروسي'),
(103919, 3645370368, 3645374463, 'CH', 'CHE', 'سويسرا'),
(103920, 3645374464, 3645378559, 'RU', 'RUS', 'الإتحاد الروسي'),
(103921, 3645378560, 3645382655, 'SE', 'SWE', 'السويد'),
(103922, 3645382656, 3645386751, 'IT', 'ITA', 'إيطاليا'),
(103923, 3645386752, 3645390847, 'SE', 'SWE', 'السويد'),
(103924, 3645390848, 3645399039, 'SI', 'SVN', 'سلوفينيا'),
(103925, 3645399040, 3645403135, 'IT', 'ITA', 'إيطاليا'),
(103926, 3645403136, 3645407231, 'GB', 'GBR', 'المملكة المتحدة'),
(103927, 3645407232, 3645408255, 'DE', 'DEU', 'ألمانيا'),
(103928, 3645408256, 3645408319, 'CH', 'CHE', 'سويسرا'),
(103929, 3645408320, 3645411327, 'DE', 'DEU', 'ألمانيا'),
(103930, 3645411328, 3645415423, 'RU', 'RUS', 'الإتحاد الروسي'),
(103931, 3645415424, 3645423615, 'GB', 'GBR', 'المملكة المتحدة'),
(103932, 3645423616, 3645431807, 'DE', 'DEU', 'ألمانيا'),
(103933, 3645431808, 3645435903, 'BE', 'BEL', 'بلجيكا'),
(103934, 3645435904, 3645439999, 'GB', 'GBR', 'المملكة المتحدة'),
(103935, 3645440000, 3645444095, 'SE', 'SWE', 'السويد'),
(103936, 3645444096, 3645448191, 'SK', 'SVK', 'سلوفاكيا'),
(103937, 3645448192, 3645456383, 'DE', 'DEU', 'ألمانيا'),
(103938, 3645456384, 3645460479, 'GB', 'GBR', 'المملكة المتحدة'),
(103939, 3645460480, 3645464575, 'UA', 'UKR', 'أوكرانيا'),
(103940, 3645464576, 3645468671, 'SE', 'SWE', 'السويد'),
(103941, 3645468672, 3645472767, 'RU', 'RUS', 'الإتحاد الروسي'),
(103942, 3645472768, 3645476863, 'UA', 'UKR', 'أوكرانيا'),
(103943, 3645476864, 3645480959, 'DE', 'DEU', 'ألمانيا'),
(103944, 3645480960, 3645485055, 'RO', 'ROM', 'رومانيا'),
(103945, 3645485056, 3645489151, 'MT', 'MLT', 'مالطا'),
(103946, 3645489152, 3645493247, 'RU', 'RUS', 'الإتحاد الروسي'),
(103947, 3645493248, 3645501439, 'IT', 'ITA', 'إيطاليا'),
(103948, 3645501440, 3645505535, 'PL', 'POL', 'بولندا'),
(103949, 3645505536, 3645506559, 'DE', 'DEU', 'ألمانيا'),
(103950, 3645506560, 3645506815, 'AT', 'AUT', 'النمسا'),
(103951, 3645506816, 3645507583, 'DE', 'DEU', 'ألمانيا'),
(103952, 3645507584, 3645507587, 'AT', 'AUT', 'النمسا'),
(103953, 3645507588, 3645507591, 'DE', 'DEU', 'ألمانيا'),
(103954, 3645507592, 3645507595, 'AT', 'AUT', 'النمسا'),
(103955, 3645507596, 3645507599, 'DE', 'DEU', 'ألمانيا'),
(103956, 3645507600, 3645507607, 'AT', 'AUT', 'النمسا'),
(103957, 3645507608, 3645509631, 'DE', 'DEU', 'ألمانيا'),
(103958, 3645509632, 3645513727, 'GB', 'GBR', 'المملكة المتحدة'),
(103959, 3645513728, 3645517823, 'RU', 'RUS', 'الإتحاد الروسي'),
(103960, 3645517824, 3645521919, 'IE', 'IRL', 'إيرلندا'),
(103961, 3645521920, 3645526015, 'PL', 'POL', 'بولندا'),
(103962, 3645526016, 3645530111, 'SE', 'SWE', 'السويد'),
(103963, 3645530112, 3645534207, 'FR', 'FRA', 'فرنسا'),
(103964, 3645534208, 3645544959, 'RU', 'RUS', 'الإتحاد الروسي'),
(103965, 3645544960, 3645544991, 'KZ', 'KAZ', 'كازاخستان'),
(103966, 3645544992, 3645545087, 'RU', 'RUS', 'الإتحاد الروسي'),
(103967, 3645545088, 3645545215, 'TJ', 'TJK', 'طاجيكيستان'),
(103968, 3645545216, 3645550591, 'RU', 'RUS', 'الإتحاد الروسي'),
(103969, 3645550592, 3645558783, 'DE', 'DEU', 'ألمانيا'),
(103970, 3645558784, 3645562879, 'DK', 'DNK', 'الدنيمارك'),
(103971, 3645562880, 3645563135, 'ZW', 'ZWE', 'زمبابواي'),
(103972, 3645563136, 3645564671, 'LS', 'LSO', 'ليسوتو'),
(103973, 3645564672, 3645564927, 'ZW', 'ZWE', 'زمبابواي'),
(103974, 3645564928, 3645565055, 'SO', 'SOM', 'الصومال'),
(103975, 3645565056, 3645565695, 'GB', 'GBR', 'المملكة المتحدة'),
(103976, 3645565696, 3645566975, 'ZW', 'ZWE', 'زمبابواي'),
(103977, 3645566976, 3645571071, 'RU', 'RUS', 'الإتحاد الروسي'),
(103978, 3645571072, 3645575167, 'IE', 'IRL', 'إيرلندا'),
(103979, 3645575168, 3645579263, 'CH', 'CHE', 'سويسرا'),
(103980, 3645579264, 3645583359, 'NL', 'NLD', 'هولندا'),
(103981, 3645583360, 3645587455, 'PL', 'POL', 'بولندا'),
(103982, 3645587456, 3645595647, 'SK', 'SVK', 'سلوفاكيا'),
(103983, 3645595648, 3645597751, 'SE', 'SWE', 'السويد'),
(103984, 3645597752, 3645597759, 'GB', 'GBR', 'المملكة المتحدة'),
(103985, 3645597760, 3645601471, 'SE', 'SWE', 'السويد'),
(103986, 3645601472, 3645601487, 'NO', 'NOR', 'النرويج'),
(103987, 3645601488, 3645601759, 'SE', 'SWE', 'السويد'),
(103988, 3645601760, 3645601775, 'FR', 'FRA', 'فرنسا'),
(103989, 3645601776, 3645603839, 'SE', 'SWE', 'السويد'),
(103990, 3645603840, 3645612031, 'BG', 'BGR', 'بلغاريا'),
(103991, 3645612032, 3645616127, 'GB', 'GBR', 'المملكة المتحدة'),
(103992, 3645616128, 3645620223, 'AT', 'AUT', 'النمسا'),
(103993, 3645620224, 3645624319, 'BA', 'BIH', 'البوسنه والهرسك'),
(103994, 3645624320, 3645628415, 'CZ', 'CZE', 'التشيك'),
(103995, 3645628416, 3645636607, 'ES', 'ESP', 'إسبانيا'),
(103996, 3645636608, 3645640703, 'AM', 'ARM', 'أرمينيا'),
(103997, 3645640704, 3645644799, 'NL', 'NLD', 'هولندا'),
(103998, 3645644800, 3645648895, 'RU', 'RUS', 'الإتحاد الروسي'),
(103999, 3645648896, 3645652991, 'SE', 'SWE', 'السويد'),
(104000, 3645652992, 3645657087, 'KZ', 'KAZ', 'كازاخستان'),
(104001, 3645657088, 3645661183, 'SE', 'SWE', 'السويد'),
(104002, 3645661184, 3645665279, 'DE', 'DEU', 'ألمانيا'),
(104003, 3645665280, 3645669375, 'PL', 'POL', 'بولندا'),
(104004, 3645669376, 3645669631, 'ES', 'ESP', 'إسبانيا'),
(104005, 3645669632, 3645669855, 'FR', 'FRA', 'فرنسا'),
(104006, 3645669856, 3645670399, 'ES', 'ESP', 'إسبانيا'),
(104007, 3645670400, 3645670911, 'FR', 'FRA', 'فرنسا'),
(104008, 3645670912, 3645673471, 'ES', 'ESP', 'إسبانيا'),
(104009, 3645673472, 3645673535, 'FR', 'FRA', 'فرنسا'),
(104010, 3645673536, 3645675263, 'ES', 'ESP', 'إسبانيا'),
(104011, 3645675264, 3645675519, 'PT', 'PRT', 'البورتوغال'),
(104012, 3645675520, 3645675759, 'ES', 'ESP', 'إسبانيا'),
(104013, 3645675760, 3645675775, 'FR', 'FRA', 'فرنسا'),
(104014, 3645675776, 3645676015, 'ES', 'ESP', 'إسبانيا'),
(104015, 3645676016, 3645676031, 'FR', 'FRA', 'فرنسا'),
(104016, 3645676032, 3645677567, 'ES', 'ESP', 'إسبانيا'),
(104017, 3645677568, 3645681663, 'AT', 'AUT', 'النمسا'),
(104018, 3645681664, 3645685759, 'RU', 'RUS', 'الإتحاد الروسي'),
(104019, 3645685760, 3645689855, 'UA', 'UKR', 'أوكرانيا'),
(104020, 3645689856, 3645693951, 'IT', 'ITA', 'إيطاليا'),
(104021, 3645693952, 3645698047, 'BE', 'BEL', 'بلجيكا'),
(104022, 3645698048, 3645702143, 'ES', 'ESP', 'إسبانيا'),
(104023, 3645702144, 3645706239, 'GB', 'GBR', 'المملكة المتحدة'),
(104024, 3645706240, 3645710335, 'LT', 'LTU', 'ليتوانيا'),
(104025, 3645710336, 3645714431, 'NO', 'NOR', 'النرويج'),
(104026, 3645714432, 3645718527, 'RU', 'RUS', 'الإتحاد الروسي'),
(104027, 3645722624, 3645726719, 'IT', 'ITA', 'إيطاليا'),
(104028, 3645726720, 3645734911, 'RU', 'RUS', 'الإتحاد الروسي'),
(104029, 3645734912, 3645743103, 'NL', 'NLD', 'هولندا'),
(104030, 3645743104, 3645747199, 'CZ', 'CZE', 'التشيك'),
(104031, 3645747200, 3645751295, 'GB', 'GBR', 'المملكة المتحدة'),
(104032, 3645751296, 3645755391, 'FI', 'FIN', 'فنلندا'),
(104033, 3645755392, 3645759487, 'UA', 'UKR', 'أوكرانيا'),
(104034, 3645759488, 3645763583, 'FR', 'FRA', 'فرنسا'),
(104035, 3645763584, 3645763585, 'DE', 'DEU', 'ألمانيا'),
(104036, 3645763586, 3645763587, 'IT', 'ITA', 'إيطاليا'),
(104037, 3645763588, 3645763588, 'DE', 'DEU', 'ألمانيا'),
(104038, 3645763589, 3645763589, 'IE', 'IRL', 'إيرلندا'),
(104039, 3645763590, 3645763590, 'ES', 'ESP', 'إسبانيا'),
(104040, 3645763591, 3645763591, 'BE', 'BEL', 'بلجيكا'),
(104041, 3645763592, 3645763593, 'DE', 'DEU', 'ألمانيا'),
(104042, 3645763594, 3645763594, 'CH', 'CHE', 'سويسرا'),
(104043, 3645763595, 3645763595, 'IT', 'ITA', 'إيطاليا'),
(104044, 3645763596, 3645763597, 'DE', 'DEU', 'ألمانيا'),
(104045, 3645763598, 3645763598, 'NL', 'NLD', 'هولندا'),
(104046, 3645763599, 3645763600, 'DE', 'DEU', 'ألمانيا'),
(104047, 3645763601, 3645763601, 'GR', 'GRC', 'اليونان'),
(104048, 3645763602, 3645763603, 'FR', 'FRA', 'فرنسا'),
(104049, 3645763604, 3645763609, 'DE', 'DEU', 'ألمانيا'),
(104050, 3645763610, 3645763610, 'PL', 'POL', 'بولندا'),
(104051, 3645763611, 3645763612, 'DE', 'DEU', 'ألمانيا'),
(104052, 3645763613, 3645763613, 'HU', 'HUN', 'هنغاريا'),
(104053, 3645763614, 3645763614, 'CH', 'CHE', 'سويسرا'),
(104054, 3645763615, 3645763615, 'ES', 'ESP', 'إسبانيا'),
(104055, 3645763616, 3645763616, 'FR', 'FRA', 'فرنسا'),
(104056, 3645763617, 3645763617, 'DE', 'DEU', 'ألمانيا'),
(104057, 3645763618, 3645763618, 'ES', 'ESP', 'إسبانيا'),
(104058, 3645763619, 3645763619, 'DE', 'DEU', 'ألمانيا'),
(104059, 3645763620, 3645763620, 'FR', 'FRA', 'فرنسا'),
(104060, 3645763621, 3645763621, 'CH', 'CHE', 'سويسرا'),
(104061, 3645763622, 3645763622, 'GB', 'GBR', 'المملكة المتحدة'),
(104062, 3645763623, 3645763623, 'FR', 'FRA', 'فرنسا'),
(104063, 3645763624, 3645763624, 'DE', 'DEU', 'ألمانيا'),
(104064, 3645763625, 3645763625, 'FR', 'FRA', 'فرنسا'),
(104065, 3645763626, 3645763626, 'NL', 'NLD', 'هولندا'),
(104066, 3645763627, 3645763627, 'AT', 'AUT', 'النمسا'),
(104067, 3645763628, 3645763629, 'DE', 'DEU', 'ألمانيا'),
(104068, 3645763630, 3645763631, 'NL', 'NLD', 'هولندا'),
(104069, 3645763632, 3645763633, 'GB', 'GBR', 'المملكة المتحدة'),
(104070, 3645763634, 3645763634, 'NL', 'NLD', 'هولندا'),
(104071, 3645763635, 3645763635, 'DE', 'DEU', 'ألمانيا'),
(104072, 3645763636, 3645763636, 'AT', 'AUT', 'النمسا'),
(104073, 3645763637, 3645763637, 'FR', 'FRA', 'فرنسا'),
(104074, 3645763638, 3645763638, 'NL', 'NLD', 'هولندا'),
(104075, 3645763639, 3645763639, 'DE', 'DEU', 'ألمانيا'),
(104076, 3645763640, 3645763640, 'HU', 'HUN', 'هنغاريا'),
(104077, 3645763641, 3645763641, 'IT', 'ITA', 'إيطاليا'),
(104078, 3645763642, 3645763642, 'GB', 'GBR', 'المملكة المتحدة'),
(104079, 3645763643, 3645763645, 'DE', 'DEU', 'ألمانيا'),
(104080, 3645763646, 3645763647, 'ES', 'ESP', 'إسبانيا'),
(104081, 3645763648, 3645763648, 'DE', 'DEU', 'ألمانيا'),
(104082, 3645763649, 3645763649, 'IL', 'ISR', 'إسرائيل'),
(104083, 3645763650, 3645763650, 'DE', 'DEU', 'ألمانيا'),
(104084, 3645763651, 3645763651, 'NL', 'NLD', 'هولندا'),
(104085, 3645763652, 3645763653, 'DE', 'DEU', 'ألمانيا'),
(104086, 3645763654, 3645763654, 'ES', 'ESP', 'إسبانيا'),
(104087, 3645763655, 3645763660, 'DE', 'DEU', 'ألمانيا'),
(104088, 3645763661, 3645763662, 'FR', 'FRA', 'فرنسا'),
(104089, 3645763663, 3645763663, 'HU', 'HUN', 'هنغاريا'),
(104090, 3645763664, 3645763665, 'DE', 'DEU', 'ألمانيا'),
(104091, 3645763666, 3645763666, 'NL', 'NLD', 'هولندا'),
(104092, 3645763667, 3645763667, 'DE', 'DEU', 'ألمانيا'),
(104093, 3645763668, 3645763668, 'IT', 'ITA', 'إيطاليا'),
(104094, 3645763669, 3645763670, 'DE', 'DEU', 'ألمانيا'),
(104095, 3645763671, 3645763671, 'FR', 'FRA', 'فرنسا'),
(104096, 3645763672, 3645763672, 'DE', 'DEU', 'ألمانيا'),
(104097, 3645763673, 3645763673, 'BE', 'BEL', 'بلجيكا'),
(104098, 3645763674, 3645763674, 'DE', 'DEU', 'ألمانيا'),
(104099, 3645763675, 3645763675, 'NL', 'NLD', 'هولندا'),
(104100, 3645763676, 3645763676, 'DE', 'DEU', 'ألمانيا'),
(104101, 3645763677, 3645763678, 'HU', 'HUN', 'هنغاريا'),
(104102, 3645763679, 3645763679, 'IT', 'ITA', 'إيطاليا'),
(104103, 3645763680, 3645763680, 'DE', 'DEU', 'ألمانيا'),
(104104, 3645763681, 3645763681, 'CH', 'CHE', 'سويسرا'),
(104105, 3645763682, 3645763682, 'DE', 'DEU', 'ألمانيا'),
(104106, 3645763683, 3645763683, 'NO', 'NOR', 'النرويج'),
(104107, 3645763684, 3645763684, 'CH', 'CHE', 'سويسرا'),
(104108, 3645763685, 3645763685, 'NL', 'NLD', 'هولندا'),
(104109, 3645763686, 3645763686, 'DE', 'DEU', 'ألمانيا'),
(104110, 3645763687, 3645763687, 'ES', 'ESP', 'إسبانيا'),
(104111, 3645763688, 3645763690, 'NL', 'NLD', 'هولندا'),
(104112, 3645763691, 3645763691, 'CH', 'CHE', 'سويسرا'),
(104113, 3645763692, 3645763692, 'DE', 'DEU', 'ألمانيا'),
(104114, 3645763693, 3645763693, 'NL', 'NLD', 'هولندا'),
(104115, 3645763694, 3645763694, 'IE', 'IRL', 'إيرلندا'),
(104116, 3645763695, 3645763696, 'DE', 'DEU', 'ألمانيا'),
(104117, 3645763697, 3645763697, 'NL', 'NLD', 'هولندا'),
(104118, 3645763698, 3645763698, 'LU', 'LUX', 'لوكسيمبورغ'),
(104119, 3645763699, 3645763699, 'BE', 'BEL', 'بلجيكا'),
(104120, 3645763700, 3645763700, 'NL', 'NLD', 'هولندا'),
(104121, 3645763701, 3645763701, 'DE', 'DEU', 'ألمانيا'),
(104122, 3645763702, 3645763702, 'IT', 'ITA', 'إيطاليا'),
(104123, 3645763703, 3645763703, 'CH', 'CHE', 'سويسرا'),
(104124, 3645763704, 3645763705, 'DE', 'DEU', 'ألمانيا'),
(104125, 3645763706, 3645763706, 'GB', 'GBR', 'المملكة المتحدة'),
(104126, 3645763707, 3645763707, 'NL', 'NLD', 'هولندا'),
(104127, 3645763708, 3645763708, 'GR', 'GRC', 'اليونان'),
(104128, 3645763709, 3645763709, 'NL', 'NLD', 'هولندا'),
(104129, 3645763710, 3645763710, 'GB', 'GBR', 'المملكة المتحدة'),
(104130, 3645763711, 3645763713, 'NL', 'NLD', 'هولندا'),
(104131, 3645763714, 3645763714, 'DE', 'DEU', 'ألمانيا'),
(104132, 3645763715, 3645763715, 'NL', 'NLD', 'هولندا'),
(104133, 3645763716, 3645763716, 'DE', 'DEU', 'ألمانيا'),
(104134, 3645763717, 3645763717, 'NL', 'NLD', 'هولندا'),
(104135, 3645763718, 3645763718, 'DE', 'DEU', 'ألمانيا'),
(104136, 3645763719, 3645763719, 'NL', 'NLD', 'هولندا'),
(104137, 3645763720, 3645763720, 'IT', 'ITA', 'إيطاليا'),
(104138, 3645763721, 3645763721, 'DE', 'DEU', 'ألمانيا'),
(104139, 3645763722, 3645763722, 'GR', 'GRC', 'اليونان'),
(104140, 3645763723, 3645763723, 'NL', 'NLD', 'هولندا'),
(104141, 3645763724, 3645763726, 'IT', 'ITA', 'إيطاليا'),
(104142, 3645763727, 3645763727, 'NL', 'NLD', 'هولندا'),
(104143, 3645763728, 3645763728, 'GR', 'GRC', 'اليونان'),
(104144, 3645763729, 3645763730, 'IT', 'ITA', 'إيطاليا'),
(104145, 3645763731, 3645763732, 'DE', 'DEU', 'ألمانيا'),
(104146, 3645763733, 3645763733, 'FR', 'FRA', 'فرنسا'),
(104147, 3645763734, 3645763734, 'DE', 'DEU', 'ألمانيا'),
(104148, 3645763735, 3645763735, 'GB', 'GBR', 'المملكة المتحدة'),
(104149, 3645763736, 3645763736, 'FR', 'FRA', 'فرنسا'),
(104150, 3645763737, 3645763737, 'DE', 'DEU', 'ألمانيا'),
(104151, 3645763738, 3645763738, 'CH', 'CHE', 'سويسرا'),
(104152, 3645763739, 3645763741, 'ES', 'ESP', 'إسبانيا'),
(104153, 3645763742, 3645763742, 'DE', 'DEU', 'ألمانيا'),
(104154, 3645763743, 3645763743, 'IT', 'ITA', 'إيطاليا'),
(104155, 3645763744, 3645763744, 'DE', 'DEU', 'ألمانيا'),
(104156, 3645763745, 3645763745, 'FR', 'FRA', 'فرنسا'),
(104157, 3645763746, 3645763746, 'DE', 'DEU', 'ألمانيا'),
(104158, 3645763747, 3645763752, 'NL', 'NLD', 'هولندا'),
(104159, 3645763753, 3645763753, 'ES', 'ESP', 'إسبانيا'),
(104160, 3645763754, 3645763755, 'NL', 'NLD', 'هولندا'),
(104161, 3645763756, 3645763756, 'DE', 'DEU', 'ألمانيا'),
(104162, 3645763757, 3645763757, 'BE', 'BEL', 'بلجيكا'),
(104163, 3645763758, 3645763758, 'FR', 'FRA', 'فرنسا'),
(104164, 3645763759, 3645763760, 'NL', 'NLD', 'هولندا'),
(104165, 3645763761, 3645763761, 'SE', 'SWE', 'السويد'),
(104166, 3645763762, 3645763762, 'ES', 'ESP', 'إسبانيا'),
(104167, 3645763763, 3645763764, 'NL', 'NLD', 'هولندا'),
(104168, 3645763765, 3645763765, 'DE', 'DEU', 'ألمانيا'),
(104169, 3645763766, 3645763766, 'IL', 'ISR', 'إسرائيل'),
(104170, 3645763767, 3645763768, 'NL', 'NLD', 'هولندا'),
(104171, 3645763769, 3645763769, 'FR', 'FRA', 'فرنسا'),
(104172, 3645763770, 3645763770, 'NL', 'NLD', 'هولندا'),
(104173, 3645763771, 3645763771, 'GB', 'GBR', 'المملكة المتحدة'),
(104174, 3645763772, 3645763772, 'CH', 'CHE', 'سويسرا'),
(104175, 3645763773, 3645763773, 'DE', 'DEU', 'ألمانيا'),
(104176, 3645763774, 3645763774, 'NL', 'NLD', 'هولندا'),
(104177, 3645763775, 3645763775, 'DE', 'DEU', 'ألمانيا'),
(104178, 3645763776, 3645763776, 'NL', 'NLD', 'هولندا'),
(104179, 3645763777, 3645763777, 'BE', 'BEL', 'بلجيكا'),
(104180, 3645763778, 3645763779, 'DE', 'DEU', 'ألمانيا'),
(104181, 3645763780, 3645763780, 'CH', 'CHE', 'سويسرا'),
(104182, 3645763781, 3645763781, 'DE', 'DEU', 'ألمانيا'),
(104183, 3645763782, 3645763782, 'NL', 'NLD', 'هولندا'),
(104184, 3645763783, 3645763783, 'DE', 'DEU', 'ألمانيا'),
(104185, 3645763784, 3645763784, 'NL', 'NLD', 'هولندا'),
(104186, 3645763785, 3645763785, 'DE', 'DEU', 'ألمانيا'),
(104187, 3645763786, 3645763786, 'CH', 'CHE', 'سويسرا'),
(104188, 3645763787, 3645763787, 'NL', 'NLD', 'هولندا'),
(104189, 3645763788, 3645763788, 'IE', 'IRL', 'إيرلندا'),
(104190, 3645763789, 3645763789, 'AT', 'AUT', 'النمسا'),
(104191, 3645763790, 3645763790, 'ES', 'ESP', 'إسبانيا'),
(104192, 3645763791, 3645763791, 'IT', 'ITA', 'إيطاليا'),
(104193, 3645763792, 3645763792, 'FR', 'FRA', 'فرنسا'),
(104194, 3645763793, 3645763793, 'ES', 'ESP', 'إسبانيا'),
(104195, 3645763794, 3645763794, 'DE', 'DEU', 'ألمانيا'),
(104196, 3645763795, 3645763795, 'IT', 'ITA', 'إيطاليا'),
(104197, 3645763796, 3645763797, 'DE', 'DEU', 'ألمانيا'),
(104198, 3645763798, 3645763798, 'FR', 'FRA', 'فرنسا'),
(104199, 3645763799, 3645763801, 'DE', 'DEU', 'ألمانيا'),
(104200, 3645763802, 3645763802, 'ES', 'ESP', 'إسبانيا'),
(104201, 3645763803, 3645763803, 'NL', 'NLD', 'هولندا'),
(104202, 3645763804, 3645763806, 'DE', 'DEU', 'ألمانيا'),
(104203, 3645763807, 3645763807, 'IT', 'ITA', 'إيطاليا'),
(104204, 3645763808, 3645763808, 'DE', 'DEU', 'ألمانيا'),
(104205, 3645763809, 3645763809, 'IT', 'ITA', 'إيطاليا'),
(104206, 3645763810, 3645763810, 'NL', 'NLD', 'هولندا'),
(104207, 3645763811, 3645763813, 'DE', 'DEU', 'ألمانيا'),
(104208, 3645763814, 3645763814, 'IT', 'ITA', 'إيطاليا'),
(104209, 3645763815, 3645763816, 'DE', 'DEU', 'ألمانيا'),
(104210, 3645763817, 3645763817, 'GR', 'GRC', 'اليونان'),
(104211, 3645763818, 3645763818, 'ES', 'ESP', 'إسبانيا'),
(104212, 3645763819, 3645763822, 'DE', 'DEU', 'ألمانيا'),
(104213, 3645763823, 3645763823, 'ES', 'ESP', 'إسبانيا'),
(104214, 3645763824, 3645763825, 'DE', 'DEU', 'ألمانيا'),
(104215, 3645763826, 3645763826, 'IT', 'ITA', 'إيطاليا'),
(104216, 3645763827, 3645763827, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(104217, 3645763828, 3645763841, 'DE', 'DEU', 'ألمانيا'),
(104218, 3645763842, 3645763842, 'CH', 'CHE', 'سويسرا'),
(104219, 3645763843, 3645763845, 'DE', 'DEU', 'ألمانيا'),
(104220, 3645763846, 3645763846, 'FR', 'FRA', 'فرنسا'),
(104221, 3645763847, 3645763847, 'IT', 'ITA', 'إيطاليا'),
(104222, 3645763848, 3645763849, 'DE', 'DEU', 'ألمانيا'),
(104223, 3645763850, 3645763850, 'IT', 'ITA', 'إيطاليا'),
(104224, 3645763851, 3645763851, 'GB', 'GBR', 'المملكة المتحدة'),
(104225, 3645763852, 3645763852, 'DE', 'DEU', 'ألمانيا'),
(104226, 3645763853, 3645763853, 'CH', 'CHE', 'سويسرا'),
(104227, 3645763854, 3645763854, 'NL', 'NLD', 'هولندا'),
(104228, 3645763855, 3645763858, 'DE', 'DEU', 'ألمانيا'),
(104229, 3645763859, 3645763859, 'DK', 'DNK', 'الدنيمارك'),
(104230, 3645763860, 3645763860, 'IT', 'ITA', 'إيطاليا'),
(104231, 3645763861, 3645763861, 'DE', 'DEU', 'ألمانيا'),
(104232, 3645763862, 3645763862, 'FR', 'FRA', 'فرنسا'),
(104233, 3645763863, 3645763864, 'ES', 'ESP', 'إسبانيا'),
(104234, 3645763865, 3645763865, 'CH', 'CHE', 'سويسرا'),
(104235, 3645763866, 3645763866, 'DE', 'DEU', 'ألمانيا'),
(104236, 3645763867, 3645763868, 'GB', 'GBR', 'المملكة المتحدة'),
(104237, 3645763869, 3645763869, 'DE', 'DEU', 'ألمانيا'),
(104238, 3645763870, 3645763870, 'HU', 'HUN', 'هنغاريا'),
(104239, 3645763871, 3645763874, 'DE', 'DEU', 'ألمانيا'),
(104240, 3645763875, 3645763875, 'GB', 'GBR', 'المملكة المتحدة'),
(104241, 3645763876, 3645763876, 'PL', 'POL', 'بولندا'),
(104242, 3645763877, 3645763877, 'FR', 'FRA', 'فرنسا'),
(104243, 3645763878, 3645763879, 'DE', 'DEU', 'ألمانيا'),
(104244, 3645763880, 3645763881, 'FR', 'FRA', 'فرنسا'),
(104245, 3645763882, 3645763882, 'DE', 'DEU', 'ألمانيا'),
(104246, 3645763883, 3645763883, 'NL', 'NLD', 'هولندا'),
(104247, 3645763884, 3645763884, 'IT', 'ITA', 'إيطاليا'),
(104248, 3645763885, 3645763886, 'DE', 'DEU', 'ألمانيا'),
(104249, 3645763887, 3645763887, 'FR', 'FRA', 'فرنسا'),
(104250, 3645763888, 3645763888, 'DE', 'DEU', 'ألمانيا'),
(104251, 3645763889, 3645763889, 'GR', 'GRC', 'اليونان'),
(104252, 3645763890, 3645763890, 'ES', 'ESP', 'إسبانيا'),
(104253, 3645763891, 3645763894, 'DE', 'DEU', 'ألمانيا'),
(104254, 3645763895, 3645763895, 'ES', 'ESP', 'إسبانيا'),
(104255, 3645763896, 3645763896, 'DE', 'DEU', 'ألمانيا'),
(104256, 3645763897, 3645763897, 'BE', 'BEL', 'بلجيكا'),
(104257, 3645763898, 3645763898, 'NL', 'NLD', 'هولندا'),
(104258, 3645763899, 3645763899, 'ES', 'ESP', 'إسبانيا'),
(104259, 3645763900, 3645763900, 'NL', 'NLD', 'هولندا'),
(104260, 3645763901, 3645763902, 'LU', 'LUX', 'لوكسيمبورغ'),
(104261, 3645763903, 3645763903, 'DE', 'DEU', 'ألمانيا'),
(104262, 3645763904, 3645763904, 'BE', 'BEL', 'بلجيكا'),
(104263, 3645763905, 3645763905, 'CS', 'SCG', 'صربيا والجبل الأسود');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(104264, 3645763906, 3645763906, 'DE', 'DEU', 'ألمانيا'),
(104265, 3645763907, 3645763908, 'IT', 'ITA', 'إيطاليا'),
(104266, 3645763909, 3645763909, 'DE', 'DEU', 'ألمانيا'),
(104267, 3645763910, 3645763910, 'ES', 'ESP', 'إسبانيا'),
(104268, 3645763911, 3645763911, 'DE', 'DEU', 'ألمانيا'),
(104269, 3645763912, 3645763912, 'IE', 'IRL', 'إيرلندا'),
(104270, 3645763913, 3645763913, 'PT', 'PRT', 'البورتوغال'),
(104271, 3645763914, 3645763914, 'DE', 'DEU', 'ألمانيا'),
(104272, 3645763915, 3645763915, 'IL', 'ISR', 'إسرائيل'),
(104273, 3645763916, 3645763916, 'BE', 'BEL', 'بلجيكا'),
(104274, 3645763917, 3645763917, 'DE', 'DEU', 'ألمانيا'),
(104275, 3645763918, 3645763918, 'IT', 'ITA', 'إيطاليا'),
(104276, 3645763919, 3645763919, 'GB', 'GBR', 'المملكة المتحدة'),
(104277, 3645763920, 3645763920, 'DE', 'DEU', 'ألمانيا'),
(104278, 3645763921, 3645763921, 'CH', 'CHE', 'سويسرا'),
(104279, 3645763922, 3645763922, 'ES', 'ESP', 'إسبانيا'),
(104280, 3645763923, 3645763923, 'GB', 'GBR', 'المملكة المتحدة'),
(104281, 3645763924, 3645763924, 'PL', 'POL', 'بولندا'),
(104282, 3645763925, 3645763926, 'DE', 'DEU', 'ألمانيا'),
(104283, 3645763927, 3645763927, 'HU', 'HUN', 'هنغاريا'),
(104284, 3645763928, 3645763928, 'FR', 'FRA', 'فرنسا'),
(104285, 3645763929, 3645763929, 'NL', 'NLD', 'هولندا'),
(104286, 3645763930, 3645763930, 'ES', 'ESP', 'إسبانيا'),
(104287, 3645763931, 3645763931, 'FR', 'FRA', 'فرنسا'),
(104288, 3645763932, 3645763932, 'DE', 'DEU', 'ألمانيا'),
(104289, 3645763933, 3645763933, 'FR', 'FRA', 'فرنسا'),
(104290, 3645763934, 3645763934, 'IT', 'ITA', 'إيطاليا'),
(104291, 3645763935, 3645763935, 'FR', 'FRA', 'فرنسا'),
(104292, 3645763936, 3645763936, 'DE', 'DEU', 'ألمانيا'),
(104293, 3645763937, 3645763937, 'FR', 'FRA', 'فرنسا'),
(104294, 3645763938, 3645763938, 'ES', 'ESP', 'إسبانيا'),
(104295, 3645763939, 3645763939, 'NL', 'NLD', 'هولندا'),
(104296, 3645763940, 3645763941, 'DE', 'DEU', 'ألمانيا'),
(104297, 3645763942, 3645763942, 'CH', 'CHE', 'سويسرا'),
(104298, 3645763943, 3645763943, 'ES', 'ESP', 'إسبانيا'),
(104299, 3645763944, 3645763944, 'CH', 'CHE', 'سويسرا'),
(104300, 3645763945, 3645763945, 'DE', 'DEU', 'ألمانيا'),
(104301, 3645763946, 3645763947, 'HU', 'HUN', 'هنغاريا'),
(104302, 3645763948, 3645763949, 'DE', 'DEU', 'ألمانيا'),
(104303, 3645763950, 3645763950, 'ES', 'ESP', 'إسبانيا'),
(104304, 3645763951, 3645763951, 'CH', 'CHE', 'سويسرا'),
(104305, 3645763952, 3645763952, 'IT', 'ITA', 'إيطاليا'),
(104306, 3645763953, 3645763953, 'TR', 'TUR', 'تركيا'),
(104307, 3645763954, 3645763954, 'IT', 'ITA', 'إيطاليا'),
(104308, 3645763955, 3645763955, 'FR', 'FRA', 'فرنسا'),
(104309, 3645763956, 3645763956, 'DE', 'DEU', 'ألمانيا'),
(104310, 3645763957, 3645763957, 'GB', 'GBR', 'المملكة المتحدة'),
(104311, 3645763958, 3645763958, 'AT', 'AUT', 'النمسا'),
(104312, 3645763959, 3645763959, 'DE', 'DEU', 'ألمانيا'),
(104313, 3645763960, 3645763960, 'IT', 'ITA', 'إيطاليا'),
(104314, 3645763961, 3645763961, 'DE', 'DEU', 'ألمانيا'),
(104315, 3645763962, 3645763962, 'ES', 'ESP', 'إسبانيا'),
(104316, 3645763963, 3645763964, 'DE', 'DEU', 'ألمانيا'),
(104317, 3645763965, 3645763965, 'AT', 'AUT', 'النمسا'),
(104318, 3645763966, 3645763966, 'DE', 'DEU', 'ألمانيا'),
(104319, 3645763967, 3645763967, 'IT', 'ITA', 'إيطاليا'),
(104320, 3645763968, 3645763968, 'DE', 'DEU', 'ألمانيا'),
(104321, 3645763969, 3645763969, 'ES', 'ESP', 'إسبانيا'),
(104322, 3645763970, 3645763970, 'IT', 'ITA', 'إيطاليا'),
(104323, 3645763971, 3645763971, 'ES', 'ESP', 'إسبانيا'),
(104324, 3645763972, 3645763972, 'IT', 'ITA', 'إيطاليا'),
(104325, 3645763973, 3645763973, 'BE', 'BEL', 'بلجيكا'),
(104326, 3645763974, 3645763974, 'GB', 'GBR', 'المملكة المتحدة'),
(104327, 3645763975, 3645763975, 'AT', 'AUT', 'النمسا'),
(104328, 3645763976, 3645763976, 'IT', 'ITA', 'إيطاليا'),
(104329, 3645763977, 3645763977, 'DE', 'DEU', 'ألمانيا'),
(104330, 3645763978, 3645763978, 'NL', 'NLD', 'هولندا'),
(104331, 3645763979, 3645763979, 'IT', 'ITA', 'إيطاليا'),
(104332, 3645763980, 3645763981, 'DE', 'DEU', 'ألمانيا'),
(104333, 3645763982, 3645763982, 'IT', 'ITA', 'إيطاليا'),
(104334, 3645763983, 3645763984, 'FR', 'FRA', 'فرنسا'),
(104335, 3645763985, 3645763985, 'NL', 'NLD', 'هولندا'),
(104336, 3645763986, 3645763986, 'DE', 'DEU', 'ألمانيا'),
(104337, 3645763987, 3645763987, 'PL', 'POL', 'بولندا'),
(104338, 3645763988, 3645763988, 'CH', 'CHE', 'سويسرا'),
(104339, 3645763989, 3645763989, 'FR', 'FRA', 'فرنسا'),
(104340, 3645763990, 3645763991, 'DE', 'DEU', 'ألمانيا'),
(104341, 3645763992, 3645763992, 'NL', 'NLD', 'هولندا'),
(104342, 3645763993, 3645763993, 'DE', 'DEU', 'ألمانيا'),
(104343, 3645763994, 3645763994, 'IT', 'ITA', 'إيطاليا'),
(104344, 3645763995, 3645763995, 'ES', 'ESP', 'إسبانيا'),
(104345, 3645763996, 3645764000, 'DE', 'DEU', 'ألمانيا'),
(104346, 3645764001, 3645764001, 'IT', 'ITA', 'إيطاليا'),
(104347, 3645764002, 3645764007, 'DE', 'DEU', 'ألمانيا'),
(104348, 3645764008, 3645764008, 'PL', 'POL', 'بولندا'),
(104349, 3645764009, 3645764010, 'FR', 'FRA', 'فرنسا'),
(104350, 3645764011, 3645764012, 'DE', 'DEU', 'ألمانيا'),
(104351, 3645764013, 3645764013, 'HU', 'HUN', 'هنغاريا'),
(104352, 3645764014, 3645764015, 'GB', 'GBR', 'المملكة المتحدة'),
(104353, 3645764016, 3645764016, 'IT', 'ITA', 'إيطاليا'),
(104354, 3645764017, 3645764017, 'GB', 'GBR', 'المملكة المتحدة'),
(104355, 3645764018, 3645764018, 'ES', 'ESP', 'إسبانيا'),
(104356, 3645764019, 3645764019, 'NL', 'NLD', 'هولندا'),
(104357, 3645764020, 3645764020, 'IT', 'ITA', 'إيطاليا'),
(104358, 3645764021, 3645764021, 'DE', 'DEU', 'ألمانيا'),
(104359, 3645764022, 3645764022, 'ES', 'ESP', 'إسبانيا'),
(104360, 3645764023, 3645764023, 'FR', 'FRA', 'فرنسا'),
(104361, 3645764024, 3645764026, 'ES', 'ESP', 'إسبانيا'),
(104362, 3645764027, 3645764028, 'DE', 'DEU', 'ألمانيا'),
(104363, 3645764029, 3645764029, 'ES', 'ESP', 'إسبانيا'),
(104364, 3645764030, 3645764030, 'DE', 'DEU', 'ألمانيا'),
(104365, 3645764031, 3645764031, 'NL', 'NLD', 'هولندا'),
(104366, 3645764032, 3645764032, 'FR', 'FRA', 'فرنسا'),
(104367, 3645764033, 3645764034, 'DE', 'DEU', 'ألمانيا'),
(104368, 3645764035, 3645764035, 'IT', 'ITA', 'إيطاليا'),
(104369, 3645764036, 3645764037, 'ES', 'ESP', 'إسبانيا'),
(104370, 3645764038, 3645764038, 'IT', 'ITA', 'إيطاليا'),
(104371, 3645764039, 3645764039, 'HU', 'HUN', 'هنغاريا'),
(104372, 3645764040, 3645764040, 'ES', 'ESP', 'إسبانيا'),
(104373, 3645764041, 3645764041, 'DE', 'DEU', 'ألمانيا'),
(104374, 3645764042, 3645764042, 'CH', 'CHE', 'سويسرا'),
(104375, 3645764043, 3645764043, 'DE', 'DEU', 'ألمانيا'),
(104376, 3645764044, 3645764044, 'ES', 'ESP', 'إسبانيا'),
(104377, 3645764045, 3645764045, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(104378, 3645764046, 3645764046, 'ES', 'ESP', 'إسبانيا'),
(104379, 3645764047, 3645764047, 'DE', 'DEU', 'ألمانيا'),
(104380, 3645764048, 3645764048, 'BE', 'BEL', 'بلجيكا'),
(104381, 3645764049, 3645764049, 'ES', 'ESP', 'إسبانيا'),
(104382, 3645764050, 3645764051, 'DE', 'DEU', 'ألمانيا'),
(104383, 3645764052, 3645764052, 'FR', 'FRA', 'فرنسا'),
(104384, 3645764053, 3645764055, 'DE', 'DEU', 'ألمانيا'),
(104385, 3645764056, 3645764056, 'BE', 'BEL', 'بلجيكا'),
(104386, 3645764057, 3645764057, 'DE', 'DEU', 'ألمانيا'),
(104387, 3645764058, 3645764058, 'TR', 'TUR', 'تركيا'),
(104388, 3645764059, 3645764059, 'DE', 'DEU', 'ألمانيا'),
(104389, 3645764060, 3645764060, 'FR', 'FRA', 'فرنسا'),
(104390, 3645764061, 3645764061, 'IT', 'ITA', 'إيطاليا'),
(104391, 3645764062, 3645764062, 'SE', 'SWE', 'السويد'),
(104392, 3645764063, 3645764063, 'AT', 'AUT', 'النمسا'),
(104393, 3645764064, 3645764064, 'SI', 'SVN', 'سلوفينيا'),
(104394, 3645764065, 3645764065, 'DE', 'DEU', 'ألمانيا'),
(104395, 3645764066, 3645764066, 'IT', 'ITA', 'إيطاليا'),
(104396, 3645764067, 3645764067, 'DE', 'DEU', 'ألمانيا'),
(104397, 3645764068, 3645764068, 'IT', 'ITA', 'إيطاليا'),
(104398, 3645764069, 3645764069, 'CH', 'CHE', 'سويسرا'),
(104399, 3645764070, 3645764070, 'GB', 'GBR', 'المملكة المتحدة'),
(104400, 3645764071, 3645764074, 'DE', 'DEU', 'ألمانيا'),
(104401, 3645764075, 3645764075, 'SE', 'SWE', 'السويد'),
(104402, 3645764076, 3645764076, 'GR', 'GRC', 'اليونان'),
(104403, 3645764077, 3645764078, 'DE', 'DEU', 'ألمانيا'),
(104404, 3645764079, 3645764079, 'ES', 'ESP', 'إسبانيا'),
(104405, 3645764080, 3645764080, 'DE', 'DEU', 'ألمانيا'),
(104406, 3645764081, 3645764081, 'GB', 'GBR', 'المملكة المتحدة'),
(104407, 3645764082, 3645764084, 'DE', 'DEU', 'ألمانيا'),
(104408, 3645764085, 3645764085, 'IE', 'IRL', 'إيرلندا'),
(104409, 3645764086, 3645764086, 'IT', 'ITA', 'إيطاليا'),
(104410, 3645764087, 3645764087, 'CH', 'CHE', 'سويسرا'),
(104411, 3645764088, 3645764091, 'DE', 'DEU', 'ألمانيا'),
(104412, 3645764092, 3645764092, 'FR', 'FRA', 'فرنسا'),
(104413, 3645764093, 3645764093, 'DE', 'DEU', 'ألمانيا'),
(104414, 3645764094, 3645764094, 'IT', 'ITA', 'إيطاليا'),
(104415, 3645764095, 3645764097, 'DE', 'DEU', 'ألمانيا'),
(104416, 3645764098, 3645764098, 'IT', 'ITA', 'إيطاليا'),
(104417, 3645764099, 3645764099, 'DE', 'DEU', 'ألمانيا'),
(104418, 3645764100, 3645764100, 'BE', 'BEL', 'بلجيكا'),
(104419, 3645764101, 3645764102, 'DE', 'DEU', 'ألمانيا'),
(104420, 3645764103, 3645764103, 'SK', 'SVK', 'سلوفاكيا'),
(104421, 3645764104, 3645764105, 'IT', 'ITA', 'إيطاليا'),
(104422, 3645764106, 3645764106, 'NL', 'NLD', 'هولندا'),
(104423, 3645764107, 3645764107, 'GR', 'GRC', 'اليونان'),
(104424, 3645764108, 3645764108, 'PL', 'POL', 'بولندا'),
(104425, 3645764109, 3645764109, 'CH', 'CHE', 'سويسرا'),
(104426, 3645764110, 3645764110, 'DK', 'DNK', 'الدنيمارك'),
(104427, 3645764111, 3645764111, 'DE', 'DEU', 'ألمانيا'),
(104428, 3645764112, 3645764112, 'IT', 'ITA', 'إيطاليا'),
(104429, 3645764113, 3645764114, 'ES', 'ESP', 'إسبانيا'),
(104430, 3645764115, 3645764115, 'GB', 'GBR', 'المملكة المتحدة'),
(104431, 3645764116, 3645764116, 'GR', 'GRC', 'اليونان'),
(104432, 3645764117, 3645764117, 'DE', 'DEU', 'ألمانيا'),
(104433, 3645764118, 3645764118, 'GB', 'GBR', 'المملكة المتحدة'),
(104434, 3645764119, 3645764119, 'CH', 'CHE', 'سويسرا'),
(104435, 3645764120, 3645764120, 'FR', 'FRA', 'فرنسا'),
(104436, 3645764121, 3645764121, 'IT', 'ITA', 'إيطاليا'),
(104437, 3645764122, 3645764122, 'DE', 'DEU', 'ألمانيا'),
(104438, 3645764123, 3645764123, 'PL', 'POL', 'بولندا'),
(104439, 3645764124, 3645764124, 'DE', 'DEU', 'ألمانيا'),
(104440, 3645764125, 3645764125, 'NO', 'NOR', 'النرويج'),
(104441, 3645764126, 3645764126, 'LU', 'LUX', 'لوكسيمبورغ'),
(104442, 3645764127, 3645764127, 'GB', 'GBR', 'المملكة المتحدة'),
(104443, 3645764128, 3645764128, 'GR', 'GRC', 'اليونان'),
(104444, 3645764129, 3645764129, 'HR', 'HRV', 'كرواتيا'),
(104445, 3645764130, 3645764130, 'FR', 'FRA', 'فرنسا'),
(104446, 3645764131, 3645764131, 'DE', 'DEU', 'ألمانيا'),
(104447, 3645764132, 3645764132, 'ES', 'ESP', 'إسبانيا'),
(104448, 3645764133, 3645764133, 'CY', 'CYP', 'قبرص'),
(104449, 3645764134, 3645764134, 'DE', 'DEU', 'ألمانيا'),
(104450, 3645764135, 3645764135, 'IT', 'ITA', 'إيطاليا'),
(104451, 3645764136, 3645764136, 'BE', 'BEL', 'بلجيكا'),
(104452, 3645764137, 3645764137, 'DE', 'DEU', 'ألمانيا'),
(104453, 3645764138, 3645764138, 'CH', 'CHE', 'سويسرا'),
(104454, 3645764139, 3645764140, 'DE', 'DEU', 'ألمانيا'),
(104455, 3645764141, 3645764141, 'ES', 'ESP', 'إسبانيا'),
(104456, 3645764142, 3645764142, 'HU', 'HUN', 'هنغاريا'),
(104457, 3645764143, 3645764145, 'DE', 'DEU', 'ألمانيا'),
(104458, 3645764146, 3645764147, 'NL', 'NLD', 'هولندا'),
(104459, 3645764148, 3645764148, 'DK', 'DNK', 'الدنيمارك'),
(104460, 3645764149, 3645764149, 'DE', 'DEU', 'ألمانيا'),
(104461, 3645764150, 3645764150, 'ES', 'ESP', 'إسبانيا'),
(104462, 3645764151, 3645764154, 'DE', 'DEU', 'ألمانيا'),
(104463, 3645764155, 3645764155, 'ES', 'ESP', 'إسبانيا'),
(104464, 3645764156, 3645764156, 'AT', 'AUT', 'النمسا'),
(104465, 3645764157, 3645764158, 'DE', 'DEU', 'ألمانيا'),
(104466, 3645764159, 3645764159, 'IT', 'ITA', 'إيطاليا'),
(104467, 3645764160, 3645764160, 'BE', 'BEL', 'بلجيكا'),
(104468, 3645764161, 3645764161, 'ES', 'ESP', 'إسبانيا'),
(104469, 3645764162, 3645764162, 'DE', 'DEU', 'ألمانيا'),
(104470, 3645764163, 3645764163, 'NL', 'NLD', 'هولندا'),
(104471, 3645764164, 3645764164, 'DE', 'DEU', 'ألمانيا'),
(104472, 3645764165, 3645764165, 'CH', 'CHE', 'سويسرا'),
(104473, 3645764166, 3645764166, 'HU', 'HUN', 'هنغاريا'),
(104474, 3645764167, 3645764167, 'DE', 'DEU', 'ألمانيا'),
(104475, 3645764168, 3645764168, 'ES', 'ESP', 'إسبانيا'),
(104476, 3645764169, 3645764169, 'GR', 'GRC', 'اليونان'),
(104477, 3645764170, 3645764170, 'IT', 'ITA', 'إيطاليا'),
(104478, 3645764171, 3645764172, 'DE', 'DEU', 'ألمانيا'),
(104479, 3645764173, 3645764173, 'IT', 'ITA', 'إيطاليا'),
(104480, 3645764174, 3645764174, 'DE', 'DEU', 'ألمانيا'),
(104481, 3645764175, 3645764175, 'PL', 'POL', 'بولندا'),
(104482, 3645764176, 3645764176, 'DE', 'DEU', 'ألمانيا'),
(104483, 3645764177, 3645764177, 'GB', 'GBR', 'المملكة المتحدة'),
(104484, 3645764178, 3645764178, 'ES', 'ESP', 'إسبانيا'),
(104485, 3645764179, 3645764179, 'GR', 'GRC', 'اليونان'),
(104486, 3645764180, 3645764181, 'DE', 'DEU', 'ألمانيا'),
(104487, 3645764182, 3645764182, 'FR', 'FRA', 'فرنسا'),
(104488, 3645764183, 3645764184, 'DE', 'DEU', 'ألمانيا'),
(104489, 3645764185, 3645764185, 'IT', 'ITA', 'إيطاليا'),
(104490, 3645764186, 3645764186, 'FR', 'FRA', 'فرنسا'),
(104491, 3645764187, 3645764187, 'BE', 'BEL', 'بلجيكا'),
(104492, 3645764188, 3645764188, 'GB', 'GBR', 'المملكة المتحدة'),
(104493, 3645764189, 3645764189, 'FR', 'FRA', 'فرنسا'),
(104494, 3645764190, 3645764190, 'IT', 'ITA', 'إيطاليا'),
(104495, 3645764191, 3645764191, 'GB', 'GBR', 'المملكة المتحدة'),
(104496, 3645764192, 3645764192, 'DE', 'DEU', 'ألمانيا'),
(104497, 3645764193, 3645764194, 'ES', 'ESP', 'إسبانيا'),
(104498, 3645764195, 3645764195, 'DE', 'DEU', 'ألمانيا'),
(104499, 3645764196, 3645764196, 'IT', 'ITA', 'إيطاليا'),
(104500, 3645764197, 3645764197, 'DE', 'DEU', 'ألمانيا'),
(104501, 3645764198, 3645764198, 'GR', 'GRC', 'اليونان'),
(104502, 3645764199, 3645764199, 'DE', 'DEU', 'ألمانيا'),
(104503, 3645764200, 3645764200, 'IT', 'ITA', 'إيطاليا'),
(104504, 3645764201, 3645764201, 'BE', 'BEL', 'بلجيكا'),
(104505, 3645764202, 3645764202, 'IT', 'ITA', 'إيطاليا'),
(104506, 3645764203, 3645764203, 'DE', 'DEU', 'ألمانيا'),
(104507, 3645764204, 3645764204, 'ES', 'ESP', 'إسبانيا'),
(104508, 3645764205, 3645764205, 'FR', 'FRA', 'فرنسا'),
(104509, 3645764206, 3645764206, 'DE', 'DEU', 'ألمانيا'),
(104510, 3645764207, 3645764207, 'IT', 'ITA', 'إيطاليا'),
(104511, 3645764208, 3645764208, 'NO', 'NOR', 'النرويج'),
(104512, 3645764209, 3645764210, 'DE', 'DEU', 'ألمانيا'),
(104513, 3645764211, 3645764211, 'FR', 'FRA', 'فرنسا'),
(104514, 3645764212, 3645764212, 'NL', 'NLD', 'هولندا'),
(104515, 3645764213, 3645764213, 'GB', 'GBR', 'المملكة المتحدة'),
(104516, 3645764214, 3645764214, 'NL', 'NLD', 'هولندا'),
(104517, 3645764215, 3645764216, 'DE', 'DEU', 'ألمانيا'),
(104518, 3645764217, 3645764217, 'IT', 'ITA', 'إيطاليا'),
(104519, 3645764218, 3645764218, 'CH', 'CHE', 'سويسرا'),
(104520, 3645764219, 3645764219, 'FR', 'FRA', 'فرنسا'),
(104521, 3645764220, 3645764220, 'NL', 'NLD', 'هولندا'),
(104522, 3645764221, 3645764221, 'IT', 'ITA', 'إيطاليا'),
(104523, 3645764222, 3645764222, 'BE', 'BEL', 'بلجيكا'),
(104524, 3645764223, 3645764224, 'ES', 'ESP', 'إسبانيا'),
(104525, 3645764225, 3645764226, 'GB', 'GBR', 'المملكة المتحدة'),
(104526, 3645764227, 3645764227, 'CH', 'CHE', 'سويسرا'),
(104527, 3645764228, 3645764228, 'FR', 'FRA', 'فرنسا'),
(104528, 3645764229, 3645764229, 'PL', 'POL', 'بولندا'),
(104529, 3645764230, 3645764230, 'NL', 'NLD', 'هولندا'),
(104530, 3645764231, 3645764231, 'CH', 'CHE', 'سويسرا'),
(104531, 3645764232, 3645764234, 'DE', 'DEU', 'ألمانيا'),
(104532, 3645764235, 3645764235, 'FR', 'FRA', 'فرنسا'),
(104533, 3645764236, 3645764236, 'IT', 'ITA', 'إيطاليا'),
(104534, 3645764237, 3645764238, 'DE', 'DEU', 'ألمانيا'),
(104535, 3645764239, 3645764240, 'ES', 'ESP', 'إسبانيا'),
(104536, 3645764241, 3645764241, 'DE', 'DEU', 'ألمانيا'),
(104537, 3645764242, 3645764242, 'AT', 'AUT', 'النمسا'),
(104538, 3645764243, 3645764243, 'GR', 'GRC', 'اليونان'),
(104539, 3645764244, 3645764244, 'FR', 'FRA', 'فرنسا'),
(104540, 3645764245, 3645764246, 'NL', 'NLD', 'هولندا'),
(104541, 3645764247, 3645764247, 'IT', 'ITA', 'إيطاليا'),
(104542, 3645764248, 3645764250, 'DE', 'DEU', 'ألمانيا'),
(104543, 3645764251, 3645764251, 'FR', 'FRA', 'فرنسا'),
(104544, 3645764252, 3645764253, 'ES', 'ESP', 'إسبانيا'),
(104545, 3645764254, 3645764254, 'DE', 'DEU', 'ألمانيا'),
(104546, 3645764255, 3645764255, 'CH', 'CHE', 'سويسرا'),
(104547, 3645764256, 3645764257, 'DE', 'DEU', 'ألمانيا'),
(104548, 3645764258, 3645764258, 'NL', 'NLD', 'هولندا'),
(104549, 3645764259, 3645764259, 'IT', 'ITA', 'إيطاليا'),
(104550, 3645764260, 3645764260, 'DE', 'DEU', 'ألمانيا'),
(104551, 3645764261, 3645764261, 'GB', 'GBR', 'المملكة المتحدة'),
(104552, 3645764262, 3645764262, 'BE', 'BEL', 'بلجيكا'),
(104553, 3645764263, 3645764264, 'IT', 'ITA', 'إيطاليا'),
(104554, 3645764265, 3645764265, 'TR', 'TUR', 'تركيا'),
(104555, 3645764266, 3645764268, 'DE', 'DEU', 'ألمانيا'),
(104556, 3645764269, 3645764270, 'ES', 'ESP', 'إسبانيا'),
(104557, 3645764271, 3645764271, 'IT', 'ITA', 'إيطاليا'),
(104558, 3645764272, 3645764272, 'DE', 'DEU', 'ألمانيا'),
(104559, 3645764273, 3645764273, 'IT', 'ITA', 'إيطاليا'),
(104560, 3645764274, 3645764274, 'DE', 'DEU', 'ألمانيا'),
(104561, 3645764275, 3645764275, 'FR', 'FRA', 'فرنسا'),
(104562, 3645764276, 3645764277, 'DE', 'DEU', 'ألمانيا'),
(104563, 3645764278, 3645764278, 'NL', 'NLD', 'هولندا'),
(104564, 3645764279, 3645764279, 'ES', 'ESP', 'إسبانيا'),
(104565, 3645764280, 3645764280, 'IT', 'ITA', 'إيطاليا'),
(104566, 3645764281, 3645764281, 'DE', 'DEU', 'ألمانيا'),
(104567, 3645764282, 3645764282, 'NL', 'NLD', 'هولندا'),
(104568, 3645764283, 3645764284, 'FR', 'FRA', 'فرنسا'),
(104569, 3645764285, 3645764285, 'IT', 'ITA', 'إيطاليا'),
(104570, 3645764286, 3645764286, 'NL', 'NLD', 'هولندا'),
(104571, 3645764287, 3645764287, 'BE', 'BEL', 'بلجيكا'),
(104572, 3645764288, 3645764288, 'FR', 'FRA', 'فرنسا'),
(104573, 3645764289, 3645764289, 'NL', 'NLD', 'هولندا'),
(104574, 3645764290, 3645764290, 'DE', 'DEU', 'ألمانيا'),
(104575, 3645764291, 3645764291, 'NL', 'NLD', 'هولندا'),
(104576, 3645764292, 3645764292, 'FR', 'FRA', 'فرنسا'),
(104577, 3645764293, 3645764294, 'IT', 'ITA', 'إيطاليا'),
(104578, 3645764295, 3645764295, 'ES', 'ESP', 'إسبانيا'),
(104579, 3645764296, 3645764297, 'DE', 'DEU', 'ألمانيا'),
(104580, 3645764298, 3645764298, 'GR', 'GRC', 'اليونان'),
(104581, 3645764299, 3645764299, 'NL', 'NLD', 'هولندا'),
(104582, 3645764300, 3645764300, 'PL', 'POL', 'بولندا'),
(104583, 3645764301, 3645764301, 'GR', 'GRC', 'اليونان'),
(104584, 3645764302, 3645764302, 'IT', 'ITA', 'إيطاليا'),
(104585, 3645764303, 3645764303, 'DE', 'DEU', 'ألمانيا'),
(104586, 3645764304, 3645764304, 'ES', 'ESP', 'إسبانيا'),
(104587, 3645764305, 3645764305, 'GB', 'GBR', 'المملكة المتحدة'),
(104588, 3645764306, 3645764306, 'BM', 'BMU', 'برمودا'),
(104589, 3645764307, 3645764307, 'NL', 'NLD', 'هولندا'),
(104590, 3645764308, 3645764308, 'DE', 'DEU', 'ألمانيا'),
(104591, 3645764309, 3645764309, 'CH', 'CHE', 'سويسرا'),
(104592, 3645764310, 3645764310, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(104593, 3645764311, 3645764313, 'ES', 'ESP', 'إسبانيا'),
(104594, 3645764314, 3645764315, 'DE', 'DEU', 'ألمانيا'),
(104595, 3645764316, 3645764316, 'IT', 'ITA', 'إيطاليا'),
(104596, 3645764317, 3645764317, 'ES', 'ESP', 'إسبانيا'),
(104597, 3645764318, 3645764318, 'HU', 'HUN', 'هنغاريا'),
(104598, 3645764319, 3645764319, 'FR', 'FRA', 'فرنسا'),
(104599, 3645764320, 3645764320, 'IT', 'ITA', 'إيطاليا'),
(104600, 3645764321, 3645764321, 'DE', 'DEU', 'ألمانيا'),
(104601, 3645764322, 3645764322, 'CH', 'CHE', 'سويسرا'),
(104602, 3645764323, 3645764323, 'DE', 'DEU', 'ألمانيا'),
(104603, 3645764324, 3645764324, 'FR', 'FRA', 'فرنسا'),
(104604, 3645764325, 3645764325, 'DE', 'DEU', 'ألمانيا'),
(104605, 3645764326, 3645764326, 'ES', 'ESP', 'إسبانيا'),
(104606, 3645764327, 3645764327, 'DK', 'DNK', 'الدنيمارك'),
(104607, 3645764328, 3645764328, 'CH', 'CHE', 'سويسرا'),
(104608, 3645764329, 3645764329, 'ES', 'ESP', 'إسبانيا'),
(104609, 3645764330, 3645764330, 'DE', 'DEU', 'ألمانيا'),
(104610, 3645764331, 3645764331, 'RU', 'RUS', 'الإتحاد الروسي'),
(104611, 3645764332, 3645764332, 'NL', 'NLD', 'هولندا'),
(104612, 3645764333, 3645764333, 'GR', 'GRC', 'اليونان'),
(104613, 3645764334, 3645764334, 'ES', 'ESP', 'إسبانيا'),
(104614, 3645764335, 3645764335, 'DE', 'DEU', 'ألمانيا'),
(104615, 3645764336, 3645764336, 'MY', 'MYS', 'ماليزيا'),
(104616, 3645764337, 3645764337, 'HU', 'HUN', 'هنغاريا'),
(104617, 3645764338, 3645764338, 'NL', 'NLD', 'هولندا'),
(104618, 3645764339, 3645764340, 'DE', 'DEU', 'ألمانيا'),
(104619, 3645764341, 3645764341, 'IE', 'IRL', 'إيرلندا'),
(104620, 3645764342, 3645764342, 'IT', 'ITA', 'إيطاليا'),
(104621, 3645764343, 3645764343, 'ES', 'ESP', 'إسبانيا'),
(104622, 3645764344, 3645764345, 'DE', 'DEU', 'ألمانيا'),
(104623, 3645764346, 3645764346, 'IT', 'ITA', 'إيطاليا'),
(104624, 3645764347, 3645764347, 'IE', 'IRL', 'إيرلندا'),
(104625, 3645764348, 3645764348, 'NL', 'NLD', 'هولندا'),
(104626, 3645764349, 3645764349, 'BE', 'BEL', 'بلجيكا'),
(104627, 3645764350, 3645764350, 'IT', 'ITA', 'إيطاليا'),
(104628, 3645764351, 3645764356, 'DE', 'DEU', 'ألمانيا'),
(104629, 3645764357, 3645764357, 'RU', 'RUS', 'الإتحاد الروسي'),
(104630, 3645764358, 3645764358, 'FR', 'FRA', 'فرنسا'),
(104631, 3645764359, 3645764359, 'IT', 'ITA', 'إيطاليا'),
(104632, 3645764360, 3645764360, 'DE', 'DEU', 'ألمانيا'),
(104633, 3645764361, 3645764361, 'CH', 'CHE', 'سويسرا'),
(104634, 3645764362, 3645764362, 'GB', 'GBR', 'المملكة المتحدة'),
(104635, 3645764363, 3645764364, 'NL', 'NLD', 'هولندا'),
(104636, 3645764365, 3645764365, 'BE', 'BEL', 'بلجيكا'),
(104637, 3645764366, 3645764367, 'DE', 'DEU', 'ألمانيا'),
(104638, 3645764368, 3645764368, 'IT', 'ITA', 'إيطاليا'),
(104639, 3645764369, 3645764369, 'DE', 'DEU', 'ألمانيا'),
(104640, 3645764370, 3645764370, 'GB', 'GBR', 'المملكة المتحدة'),
(104641, 3645764371, 3645764371, 'ES', 'ESP', 'إسبانيا'),
(104642, 3645764372, 3645764373, 'FR', 'FRA', 'فرنسا'),
(104643, 3645764374, 3645764375, 'DE', 'DEU', 'ألمانيا'),
(104644, 3645764376, 3645764377, 'NL', 'NLD', 'هولندا'),
(104645, 3645764378, 3645764378, 'DE', 'DEU', 'ألمانيا'),
(104646, 3645764379, 3645764380, 'GB', 'GBR', 'المملكة المتحدة'),
(104647, 3645764381, 3645764381, 'DE', 'DEU', 'ألمانيا'),
(104648, 3645764382, 3645764382, 'NL', 'NLD', 'هولندا'),
(104649, 3645764383, 3645764383, 'FR', 'FRA', 'فرنسا'),
(104650, 3645764384, 3645764384, 'AT', 'AUT', 'النمسا'),
(104651, 3645764385, 3645764388, 'DE', 'DEU', 'ألمانيا'),
(104652, 3645764389, 3645764389, 'NL', 'NLD', 'هولندا'),
(104653, 3645764390, 3645764390, 'DE', 'DEU', 'ألمانيا'),
(104654, 3645764391, 3645764391, 'NL', 'NLD', 'هولندا'),
(104655, 3645764392, 3645764392, 'GR', 'GRC', 'اليونان'),
(104656, 3645764393, 3645764393, 'DE', 'DEU', 'ألمانيا'),
(104657, 3645764394, 3645764394, 'FR', 'FRA', 'فرنسا'),
(104658, 3645764395, 3645764396, 'NL', 'NLD', 'هولندا'),
(104659, 3645764397, 3645764397, 'DE', 'DEU', 'ألمانيا'),
(104660, 3645764398, 3645764398, 'NL', 'NLD', 'هولندا'),
(104661, 3645764399, 3645764399, 'DE', 'DEU', 'ألمانيا'),
(104662, 3645764400, 3645764401, 'NL', 'NLD', 'هولندا'),
(104663, 3645764402, 3645764403, 'FR', 'FRA', 'فرنسا'),
(104664, 3645764404, 3645764406, 'NL', 'NLD', 'هولندا'),
(104665, 3645764407, 3645764408, 'DE', 'DEU', 'ألمانيا'),
(104666, 3645764409, 3645764409, 'FR', 'FRA', 'فرنسا'),
(104667, 3645764410, 3645764410, 'DE', 'DEU', 'ألمانيا'),
(104668, 3645764411, 3645764411, 'FR', 'FRA', 'فرنسا'),
(104669, 3645764412, 3645764412, 'NL', 'NLD', 'هولندا'),
(104670, 3645764413, 3645764413, 'FR', 'FRA', 'فرنسا'),
(104671, 3645764414, 3645764417, 'NL', 'NLD', 'هولندا'),
(104672, 3645764418, 3645764418, 'DE', 'DEU', 'ألمانيا'),
(104673, 3645764419, 3645764419, 'NL', 'NLD', 'هولندا'),
(104674, 3645764420, 3645764420, 'GB', 'GBR', 'المملكة المتحدة'),
(104675, 3645764421, 3645764421, 'DE', 'DEU', 'ألمانيا'),
(104676, 3645764422, 3645764422, 'IT', 'ITA', 'إيطاليا'),
(104677, 3645764423, 3645764423, 'HU', 'HUN', 'هنغاريا'),
(104678, 3645764424, 3645764424, 'DE', 'DEU', 'ألمانيا'),
(104679, 3645764425, 3645764425, 'GB', 'GBR', 'المملكة المتحدة'),
(104680, 3645764426, 3645764433, 'DE', 'DEU', 'ألمانيا'),
(104681, 3645764434, 3645764434, 'NL', 'NLD', 'هولندا'),
(104682, 3645764435, 3645764435, 'AT', 'AUT', 'النمسا'),
(104683, 3645764436, 3645764436, 'NL', 'NLD', 'هولندا'),
(104684, 3645764437, 3645764437, 'FR', 'FRA', 'فرنسا'),
(104685, 3645764438, 3645764439, 'DE', 'DEU', 'ألمانيا'),
(104686, 3645764440, 3645764440, 'CH', 'CHE', 'سويسرا'),
(104687, 3645764441, 3645764441, 'DE', 'DEU', 'ألمانيا'),
(104688, 3645764442, 3645764442, 'IT', 'ITA', 'إيطاليا'),
(104689, 3645764443, 3645764444, 'DE', 'DEU', 'ألمانيا'),
(104690, 3645764445, 3645764445, 'GB', 'GBR', 'المملكة المتحدة'),
(104691, 3645764446, 3645764446, 'NL', 'NLD', 'هولندا'),
(104692, 3645764447, 3645764456, 'DE', 'DEU', 'ألمانيا'),
(104693, 3645764457, 3645764457, 'IT', 'ITA', 'إيطاليا'),
(104694, 3645764458, 3645764458, 'AT', 'AUT', 'النمسا'),
(104695, 3645764459, 3645764459, 'IT', 'ITA', 'إيطاليا'),
(104696, 3645764460, 3645764462, 'DE', 'DEU', 'ألمانيا'),
(104697, 3645764463, 3645764463, 'NL', 'NLD', 'هولندا'),
(104698, 3645764464, 3645764464, 'BE', 'BEL', 'بلجيكا'),
(104699, 3645764465, 3645764465, 'DE', 'DEU', 'ألمانيا'),
(104700, 3645764466, 3645764466, 'GR', 'GRC', 'اليونان'),
(104701, 3645764467, 3645764467, 'DE', 'DEU', 'ألمانيا'),
(104702, 3645764468, 3645764468, 'IT', 'ITA', 'إيطاليا'),
(104703, 3645764469, 3645764470, 'DE', 'DEU', 'ألمانيا'),
(104704, 3645764471, 3645764471, 'IT', 'ITA', 'إيطاليا'),
(104705, 3645764472, 3645764472, 'GR', 'GRC', 'اليونان'),
(104706, 3645764473, 3645764473, 'NL', 'NLD', 'هولندا'),
(104707, 3645764474, 3645764474, 'DE', 'DEU', 'ألمانيا'),
(104708, 3645764475, 3645764475, 'GR', 'GRC', 'اليونان'),
(104709, 3645764476, 3645764476, 'DE', 'DEU', 'ألمانيا'),
(104710, 3645764477, 3645764477, 'NL', 'NLD', 'هولندا'),
(104711, 3645764478, 3645764478, 'GB', 'GBR', 'المملكة المتحدة'),
(104712, 3645764479, 3645764479, 'DE', 'DEU', 'ألمانيا'),
(104713, 3645764480, 3645764481, 'NL', 'NLD', 'هولندا'),
(104714, 3645764482, 3645764482, 'DE', 'DEU', 'ألمانيا'),
(104715, 3645764483, 3645764483, 'NL', 'NLD', 'هولندا'),
(104716, 3645764484, 3645764484, 'FR', 'FRA', 'فرنسا'),
(104717, 3645764485, 3645764485, 'NL', 'NLD', 'هولندا'),
(104718, 3645764486, 3645764486, 'IE', 'IRL', 'إيرلندا'),
(104719, 3645764487, 3645764487, 'DE', 'DEU', 'ألمانيا'),
(104720, 3645764488, 3645764490, 'NL', 'NLD', 'هولندا'),
(104721, 3645764491, 3645764491, 'DE', 'DEU', 'ألمانيا'),
(104722, 3645764492, 3645764492, 'NL', 'NLD', 'هولندا'),
(104723, 3645764493, 3645764493, 'ES', 'ESP', 'إسبانيا'),
(104724, 3645764494, 3645764494, 'FR', 'FRA', 'فرنسا'),
(104725, 3645764495, 3645764495, 'NL', 'NLD', 'هولندا'),
(104726, 3645764496, 3645764496, 'DE', 'DEU', 'ألمانيا'),
(104727, 3645764497, 3645764497, 'NL', 'NLD', 'هولندا'),
(104728, 3645764498, 3645764498, 'FR', 'FRA', 'فرنسا'),
(104729, 3645764499, 3645764500, 'NL', 'NLD', 'هولندا'),
(104730, 3645764501, 3645764501, 'DE', 'DEU', 'ألمانيا'),
(104731, 3645764502, 3645764505, 'NL', 'NLD', 'هولندا'),
(104732, 3645764506, 3645764506, 'DE', 'DEU', 'ألمانيا'),
(104733, 3645764507, 3645764507, 'ES', 'ESP', 'إسبانيا'),
(104734, 3645764508, 3645764508, 'IT', 'ITA', 'إيطاليا'),
(104735, 3645764509, 3645764509, 'NL', 'NLD', 'هولندا'),
(104736, 3645764510, 3645764510, 'DE', 'DEU', 'ألمانيا'),
(104737, 3645764511, 3645764511, 'NL', 'NLD', 'هولندا'),
(104738, 3645764512, 3645764512, 'DE', 'DEU', 'ألمانيا'),
(104739, 3645764513, 3645764513, 'NL', 'NLD', 'هولندا'),
(104740, 3645764514, 3645764514, 'ES', 'ESP', 'إسبانيا'),
(104741, 3645764515, 3645764515, 'DE', 'DEU', 'ألمانيا'),
(104742, 3645764516, 3645764516, 'NL', 'NLD', 'هولندا'),
(104743, 3645764517, 3645764518, 'DE', 'DEU', 'ألمانيا'),
(104744, 3645764519, 3645764522, 'NL', 'NLD', 'هولندا'),
(104745, 3645764523, 3645764523, 'DE', 'DEU', 'ألمانيا'),
(104746, 3645764524, 3645764531, 'NL', 'NLD', 'هولندا'),
(104747, 3645764532, 3645764532, 'DE', 'DEU', 'ألمانيا'),
(104748, 3645764533, 3645764535, 'NL', 'NLD', 'هولندا'),
(104749, 3645764536, 3645764536, 'IT', 'ITA', 'إيطاليا'),
(104750, 3645764537, 3645764539, 'NL', 'NLD', 'هولندا'),
(104751, 3645764540, 3645764540, 'DE', 'DEU', 'ألمانيا'),
(104752, 3645764541, 3645764541, 'IT', 'ITA', 'إيطاليا'),
(104753, 3645764542, 3645764549, 'NL', 'NLD', 'هولندا'),
(104754, 3645764550, 3645764550, 'DE', 'DEU', 'ألمانيا'),
(104755, 3645764551, 3645764551, 'GR', 'GRC', 'اليونان'),
(104756, 3645764552, 3645764553, 'DE', 'DEU', 'ألمانيا'),
(104757, 3645764554, 3645764554, 'NL', 'NLD', 'هولندا'),
(104758, 3645764555, 3645764555, 'DE', 'DEU', 'ألمانيا'),
(104759, 3645764556, 3645764556, 'CH', 'CHE', 'سويسرا'),
(104760, 3645764557, 3645764557, 'NL', 'NLD', 'هولندا'),
(104761, 3645764558, 3645764561, 'DE', 'DEU', 'ألمانيا'),
(104762, 3645764562, 3645764562, 'FR', 'FRA', 'فرنسا'),
(104763, 3645764563, 3645764563, 'ES', 'ESP', 'إسبانيا'),
(104764, 3645764564, 3645764565, 'NL', 'NLD', 'هولندا'),
(104765, 3645764566, 3645764566, 'DE', 'DEU', 'ألمانيا'),
(104766, 3645764567, 3645764568, 'NL', 'NLD', 'هولندا'),
(104767, 3645764569, 3645764569, 'DE', 'DEU', 'ألمانيا'),
(104768, 3645764570, 3645764570, 'MA', 'MAR', 'المغرب'),
(104769, 3645764571, 3645765127, 'DE', 'DEU', 'ألمانيا'),
(104770, 3645765128, 3645765131, 'GR', 'GRC', 'اليونان'),
(104771, 3645765132, 3645765135, 'DE', 'DEU', 'ألمانيا'),
(104772, 3645765136, 3645765139, 'BE', 'BEL', 'بلجيكا'),
(104773, 3645765140, 3645765143, 'IT', 'ITA', 'إيطاليا'),
(104774, 3645765144, 3645765147, 'DE', 'DEU', 'ألمانيا'),
(104775, 3645765148, 3645765151, 'IT', 'ITA', 'إيطاليا'),
(104776, 3645765152, 3645765155, 'BE', 'BEL', 'بلجيكا'),
(104777, 3645765156, 3645765171, 'IT', 'ITA', 'إيطاليا'),
(104778, 3645765172, 3645765175, 'NO', 'NOR', 'النرويج'),
(104779, 3645765176, 3645765179, 'DE', 'DEU', 'ألمانيا'),
(104780, 3645765180, 3645765183, 'FR', 'FRA', 'فرنسا'),
(104781, 3645765184, 3645765187, 'GR', 'GRC', 'اليونان'),
(104782, 3645765188, 3645765195, 'DE', 'DEU', 'ألمانيا'),
(104783, 3645765196, 3645765199, 'CH', 'CHE', 'سويسرا'),
(104784, 3645765200, 3645765207, 'GB', 'GBR', 'المملكة المتحدة'),
(104785, 3645765208, 3645765211, 'FR', 'FRA', 'فرنسا'),
(104786, 3645765212, 3645765219, 'ES', 'ESP', 'إسبانيا'),
(104787, 3645765220, 3645765223, 'PL', 'POL', 'بولندا'),
(104788, 3645765224, 3645765227, 'BE', 'BEL', 'بلجيكا'),
(104789, 3645765228, 3645765231, 'GB', 'GBR', 'المملكة المتحدة'),
(104790, 3645765232, 3645765235, 'IT', 'ITA', 'إيطاليا'),
(104791, 3645765236, 3645765239, 'FR', 'FRA', 'فرنسا'),
(104792, 3645765240, 3645765243, 'GB', 'GBR', 'المملكة المتحدة'),
(104793, 3645765244, 3645765247, 'IT', 'ITA', 'إيطاليا'),
(104794, 3645765248, 3645765251, 'ES', 'ESP', 'إسبانيا'),
(104795, 3645765252, 3645765255, 'DE', 'DEU', 'ألمانيا'),
(104796, 3645765256, 3645765259, 'GR', 'GRC', 'اليونان'),
(104797, 3645765260, 3645765263, 'PL', 'POL', 'بولندا'),
(104798, 3645765264, 3645765267, 'IT', 'ITA', 'إيطاليا'),
(104799, 3645765268, 3645765271, 'PL', 'POL', 'بولندا'),
(104800, 3645765272, 3645765275, 'IT', 'ITA', 'إيطاليا'),
(104801, 3645765276, 3645765279, 'FR', 'FRA', 'فرنسا'),
(104802, 3645765280, 3645765283, 'DE', 'DEU', 'ألمانيا'),
(104803, 3645765284, 3645765287, 'ES', 'ESP', 'إسبانيا'),
(104804, 3645765288, 3645765295, 'DE', 'DEU', 'ألمانيا'),
(104805, 3645765296, 3645765299, 'ES', 'ESP', 'إسبانيا'),
(104806, 3645765300, 3645765303, 'FR', 'FRA', 'فرنسا'),
(104807, 3645765304, 3645765311, 'IT', 'ITA', 'إيطاليا'),
(104808, 3645765312, 3645765315, 'TR', 'TUR', 'تركيا'),
(104809, 3645765316, 3645765319, 'IT', 'ITA', 'إيطاليا'),
(104810, 3645765320, 3645765323, 'FR', 'FRA', 'فرنسا'),
(104811, 3645765324, 3645765331, 'ES', 'ESP', 'إسبانيا'),
(104812, 3645765332, 3645765335, 'FR', 'FRA', 'فرنسا'),
(104813, 3645765336, 3645765339, 'IT', 'ITA', 'إيطاليا'),
(104814, 3645765340, 3645765343, 'FR', 'FRA', 'فرنسا'),
(104815, 3645765344, 3645765347, 'PL', 'POL', 'بولندا'),
(104816, 3645765348, 3645765351, 'GR', 'GRC', 'اليونان'),
(104817, 3645765352, 3645765355, 'IT', 'ITA', 'إيطاليا'),
(104818, 3645765356, 3645765359, 'ES', 'ESP', 'إسبانيا'),
(104819, 3645765360, 3645765363, 'FR', 'FRA', 'فرنسا'),
(104820, 3645765364, 3645765367, 'ES', 'ESP', 'إسبانيا'),
(104821, 3645765368, 3645765371, 'IT', 'ITA', 'إيطاليا'),
(104822, 3645765372, 3645765375, 'CH', 'CHE', 'سويسرا'),
(104823, 3645765376, 3645765379, 'DE', 'DEU', 'ألمانيا'),
(104824, 3645765380, 3645765383, 'BM', 'BMU', 'برمودا'),
(104825, 3645765384, 3645765387, 'NL', 'NLD', 'هولندا'),
(104826, 3645765388, 3645765391, 'DE', 'DEU', 'ألمانيا'),
(104827, 3645765392, 3645765403, 'ES', 'ESP', 'إسبانيا'),
(104828, 3645765404, 3645765407, 'GR', 'GRC', 'اليونان'),
(104829, 3645765408, 3645765411, 'DK', 'DNK', 'الدنيمارك'),
(104830, 3645765412, 3645765415, 'IT', 'ITA', 'إيطاليا'),
(104831, 3645765416, 3645765419, 'FR', 'FRA', 'فرنسا'),
(104832, 3645765420, 3645765423, 'DE', 'DEU', 'ألمانيا'),
(104833, 3645765424, 3645765427, 'IT', 'ITA', 'إيطاليا'),
(104834, 3645765428, 3645765443, 'DE', 'DEU', 'ألمانيا'),
(104835, 3645765444, 3645765447, 'FR', 'FRA', 'فرنسا'),
(104836, 3645765448, 3645765451, 'ES', 'ESP', 'إسبانيا'),
(104837, 3645765452, 3645765455, 'FR', 'FRA', 'فرنسا'),
(104838, 3645765456, 3645765459, 'AT', 'AUT', 'النمسا'),
(104839, 3645765460, 3645765463, 'FR', 'FRA', 'فرنسا'),
(104840, 3645765464, 3645765467, 'GB', 'GBR', 'المملكة المتحدة'),
(104841, 3645765468, 3645765471, 'DE', 'DEU', 'ألمانيا'),
(104842, 3645765472, 3645765475, 'NL', 'NLD', 'هولندا'),
(104843, 3645765476, 3645765487, 'DE', 'DEU', 'ألمانيا'),
(104844, 3645765488, 3645765491, 'HU', 'HUN', 'هنغاريا'),
(104845, 3645765492, 3645765495, 'DE', 'DEU', 'ألمانيا'),
(104846, 3645765496, 3645765499, 'GB', 'GBR', 'المملكة المتحدة'),
(104847, 3645765500, 3645765503, 'NL', 'NLD', 'هولندا'),
(104848, 3645765504, 3645765507, 'CH', 'CHE', 'سويسرا'),
(104849, 3645765508, 3645765511, 'IT', 'ITA', 'إيطاليا'),
(104850, 3645765512, 3645765519, 'GB', 'GBR', 'المملكة المتحدة'),
(104851, 3645765520, 3645765523, 'FR', 'FRA', 'فرنسا'),
(104852, 3645765524, 3645765527, 'IT', 'ITA', 'إيطاليا'),
(104853, 3645765528, 3645765535, 'FR', 'FRA', 'فرنسا'),
(104854, 3645765536, 3645765539, 'SE', 'SWE', 'السويد'),
(104855, 3645765540, 3645765543, 'IL', 'ISR', 'إسرائيل'),
(104856, 3645765544, 3645765547, 'BE', 'BEL', 'بلجيكا'),
(104857, 3645765548, 3645765555, 'DE', 'DEU', 'ألمانيا'),
(104858, 3645765556, 3645765559, 'IT', 'ITA', 'إيطاليا'),
(104859, 3645765560, 3645765563, 'IE', 'IRL', 'إيرلندا'),
(104860, 3645765564, 3645765567, 'ES', 'ESP', 'إسبانيا'),
(104861, 3645765568, 3645765571, 'FR', 'FRA', 'فرنسا'),
(104862, 3645765572, 3645765575, 'DE', 'DEU', 'ألمانيا'),
(104863, 3645765576, 3645765579, 'IT', 'ITA', 'إيطاليا'),
(104864, 3645765580, 3645765591, 'DE', 'DEU', 'ألمانيا'),
(104865, 3645765592, 3645765595, 'IE', 'IRL', 'إيرلندا'),
(104866, 3645765596, 3645765611, 'DE', 'DEU', 'ألمانيا'),
(104867, 3645765612, 3645765615, 'IT', 'ITA', 'إيطاليا'),
(104868, 3645765616, 3645765619, 'GB', 'GBR', 'المملكة المتحدة'),
(104869, 3645765620, 3645765623, 'CH', 'CHE', 'سويسرا'),
(104870, 3645765624, 3645765627, 'FR', 'FRA', 'فرنسا'),
(104871, 3645765628, 3645765639, 'DE', 'DEU', 'ألمانيا'),
(104872, 3645765640, 3645765643, 'DK', 'DNK', 'الدنيمارك'),
(104873, 3645765644, 3645765647, 'GB', 'GBR', 'المملكة المتحدة'),
(104874, 3645765648, 3645765651, 'NL', 'NLD', 'هولندا'),
(104875, 3645765652, 3645765667, 'DE', 'DEU', 'ألمانيا'),
(104876, 3645765668, 3645765675, 'FR', 'FRA', 'فرنسا'),
(104877, 3645765676, 3645765679, 'DE', 'DEU', 'ألمانيا'),
(104878, 3645765680, 3645765683, 'FR', 'FRA', 'فرنسا'),
(104879, 3645765684, 3645765687, 'NL', 'NLD', 'هولندا'),
(104880, 3645765688, 3645765691, 'FR', 'FRA', 'فرنسا'),
(104881, 3645765692, 3645765695, 'CH', 'CHE', 'سويسرا'),
(104882, 3645765696, 3645765703, 'IT', 'ITA', 'إيطاليا'),
(104883, 3645765704, 3645765707, 'DE', 'DEU', 'ألمانيا'),
(104884, 3645765708, 3645765711, 'FR', 'FRA', 'فرنسا'),
(104885, 3645765712, 3645765715, 'DE', 'DEU', 'ألمانيا'),
(104886, 3645765716, 3645765719, 'FR', 'FRA', 'فرنسا'),
(104887, 3645765720, 3645766401, 'DE', 'DEU', 'ألمانيا'),
(104888, 3645766402, 3645766407, 'US', 'USA', 'الولايات المتحدة'),
(104889, 3645766408, 3645767187, 'DE', 'DEU', 'ألمانيا'),
(104890, 3645767188, 3645767188, 'US', 'USA', 'الولايات المتحدة'),
(104891, 3645767189, 3645767193, 'DE', 'DEU', 'ألمانيا'),
(104892, 3645767194, 3645767194, 'US', 'USA', 'الولايات المتحدة'),
(104893, 3645767195, 3645767195, 'DE', 'DEU', 'ألمانيا'),
(104894, 3645767196, 3645767196, 'US', 'USA', 'الولايات المتحدة'),
(104895, 3645767197, 3645767197, 'DE', 'DEU', 'ألمانيا'),
(104896, 3645767198, 3645767198, 'US', 'USA', 'الولايات المتحدة'),
(104897, 3645767199, 3645767208, 'DE', 'DEU', 'ألمانيا'),
(104898, 3645767209, 3645767209, 'US', 'USA', 'الولايات المتحدة'),
(104899, 3645767210, 3645767222, 'DE', 'DEU', 'ألمانيا'),
(104900, 3645767223, 3645767223, 'US', 'USA', 'الولايات المتحدة'),
(104901, 3645767224, 3645767240, 'DE', 'DEU', 'ألمانيا'),
(104902, 3645767241, 3645767241, 'US', 'USA', 'الولايات المتحدة'),
(104903, 3645767242, 3645767426, 'DE', 'DEU', 'ألمانيا'),
(104904, 3645767427, 3645767427, 'US', 'USA', 'الولايات المتحدة'),
(104905, 3645767428, 3645767428, 'DE', 'DEU', 'ألمانيا'),
(104906, 3645767429, 3645767429, 'US', 'USA', 'الولايات المتحدة'),
(104907, 3645767430, 3645767431, 'DE', 'DEU', 'ألمانيا'),
(104908, 3645767432, 3645767433, 'US', 'USA', 'الولايات المتحدة'),
(104909, 3645767434, 3645767434, 'CA', 'CAN', 'كندا'),
(104910, 3645767435, 3645767448, 'US', 'USA', 'الولايات المتحدة'),
(104911, 3645767449, 3645767449, 'DE', 'DEU', 'ألمانيا'),
(104912, 3645767450, 3645767455, 'US', 'USA', 'الولايات المتحدة'),
(104913, 3645767456, 3645767502, 'DE', 'DEU', 'ألمانيا'),
(104914, 3645767503, 3645767503, 'US', 'USA', 'الولايات المتحدة'),
(104915, 3645767504, 3645767679, 'DE', 'DEU', 'ألمانيا'),
(104916, 3645767680, 3645771775, 'IE', 'IRL', 'إيرلندا'),
(104917, 3645771776, 3645779967, 'SE', 'SWE', 'السويد'),
(104918, 3645779968, 3645784063, 'PS', 'PSE', 'فلسطين المحتلة'),
(104919, 3645788160, 3645792255, 'GB', 'GBR', 'المملكة المتحدة'),
(104920, 3645792256, 3645796351, 'NO', 'NOR', 'النرويج'),
(104921, 3645796352, 3645800447, 'CH', 'CHE', 'سويسرا'),
(104922, 3645800448, 3645804543, 'DE', 'DEU', 'ألمانيا'),
(104923, 3645804544, 3645808639, 'GB', 'GBR', 'المملكة المتحدة'),
(104924, 3645808640, 3645812735, 'DE', 'DEU', 'ألمانيا'),
(104925, 3645812736, 3645816831, 'RU', 'RUS', 'الإتحاد الروسي'),
(104926, 3645816832, 3645825023, 'FI', 'FIN', 'فنلندا'),
(104927, 3645825024, 3645829119, 'GR', 'GRC', 'اليونان'),
(104928, 3645829120, 3645833215, 'NL', 'NLD', 'هولندا'),
(104929, 3645833216, 3645841407, 'RU', 'RUS', 'الإتحاد الروسي'),
(104930, 3645841408, 3645845503, 'BG', 'BGR', 'بلغاريا'),
(104931, 3645845504, 3645849599, 'RU', 'RUS', 'الإتحاد الروسي'),
(104932, 3645849600, 3645857791, 'BG', 'BGR', 'بلغاريا'),
(104933, 3645857792, 3645865983, 'GB', 'GBR', 'المملكة المتحدة'),
(104934, 3645865984, 3645870079, 'HU', 'HUN', 'هنغاريا'),
(104935, 3645870080, 3645874175, 'PL', 'POL', 'بولندا'),
(104936, 3645874176, 3645878271, 'GB', 'GBR', 'المملكة المتحدة'),
(104937, 3645878272, 3645882367, 'DE', 'DEU', 'ألمانيا'),
(104938, 3645882368, 3645886463, 'CH', 'CHE', 'سويسرا'),
(104939, 3645886464, 3645886991, 'DE', 'DEU', 'ألمانيا'),
(104940, 3645886992, 3645886995, 'GB', 'GBR', 'المملكة المتحدة'),
(104941, 3645886996, 3645887067, 'DE', 'DEU', 'ألمانيا'),
(104942, 3645887068, 3645887071, 'US', 'USA', 'الولايات المتحدة'),
(104943, 3645887072, 3645888127, 'DE', 'DEU', 'ألمانيا'),
(104944, 3645888128, 3645888143, 'AT', 'AUT', 'النمسا'),
(104945, 3645888144, 3645888159, 'DE', 'DEU', 'ألمانيا'),
(104946, 3645888160, 3645888191, 'AT', 'AUT', 'النمسا'),
(104947, 3645888192, 3645889791, 'DE', 'DEU', 'ألمانيا'),
(104948, 3645889792, 3645889919, 'US', 'USA', 'الولايات المتحدة'),
(104949, 3645889920, 3645890559, 'DE', 'DEU', 'ألمانيا'),
(104950, 3645890560, 3645894655, 'RU', 'RUS', 'الإتحاد الروسي'),
(104951, 3645894656, 3645898751, 'NL', 'NLD', 'هولندا'),
(104952, 3645898752, 3646501711, 'DE', 'DEU', 'ألمانيا'),
(104953, 3646501712, 3646501719, 'US', 'USA', 'الولايات المتحدة'),
(104954, 3646501720, 3646513103, 'DE', 'DEU', 'ألمانيا'),
(104955, 3646513104, 3646513111, 'CA', 'CAN', 'كندا'),
(104956, 3646513112, 3646947327, 'DE', 'DEU', 'ألمانيا'),
(104957, 3646947328, 3647209471, 'PL', 'POL', 'بولندا'),
(104958, 3647209472, 3647602687, 'NL', 'NLD', 'هولندا'),
(104959, 3647602688, 3647658751, 'RU', 'RUS', 'الإتحاد الروسي'),
(104960, 3647658752, 3647659007, 'GE', 'GEO', 'جورجيا'),
(104961, 3647659008, 3647665151, 'RU', 'RUS', 'الإتحاد الروسي'),
(104962, 3647665152, 3647665407, 'GE', 'GEO', 'جورجيا'),
(104963, 3647665408, 3647722751, 'RU', 'RUS', 'الإتحاد الروسي'),
(104964, 3647722752, 3647722879, 'BY', 'BLR', 'روسيا البيضاء'),
(104965, 3647722880, 3647733759, 'RU', 'RUS', 'الإتحاد الروسي'),
(104966, 3647733760, 3647864831, 'FR', 'FRA', 'فرنسا'),
(104967, 3647864832, 3647912703, 'DE', 'DEU', 'ألمانيا'),
(104968, 3647912704, 3647912959, 'GB', 'GBR', 'المملكة المتحدة'),
(104969, 3647912960, 3647916799, 'DE', 'DEU', 'ألمانيا'),
(104970, 3647916800, 3647917055, 'SE', 'SWE', 'السويد'),
(104971, 3647917056, 3647917599, 'DE', 'DEU', 'ألمانيا'),
(104972, 3647917600, 3647917615, 'US', 'USA', 'الولايات المتحدة'),
(104973, 3647917616, 3647933823, 'DE', 'DEU', 'ألمانيا'),
(104974, 3647933824, 3647933855, 'GB', 'GBR', 'المملكة المتحدة'),
(104975, 3647933856, 3647954231, 'DE', 'DEU', 'ألمانيا'),
(104976, 3647954232, 3647954239, 'GB', 'GBR', 'المملكة المتحدة'),
(104977, 3647954240, 3647959567, 'DE', 'DEU', 'ألمانيا'),
(104978, 3647959568, 3647959575, 'ES', 'ESP', 'إسبانيا'),
(104979, 3647959576, 3647961215, 'DE', 'DEU', 'ألمانيا'),
(104980, 3647961216, 3647961247, 'IT', 'ITA', 'إيطاليا'),
(104981, 3647961248, 3647963167, 'DE', 'DEU', 'ألمانيا'),
(104982, 3647963168, 3647963183, 'BE', 'BEL', 'بلجيكا'),
(104983, 3647963184, 3647963231, 'DE', 'DEU', 'ألمانيا'),
(104984, 3647963232, 3647963263, 'BE', 'BEL', 'بلجيكا'),
(104985, 3647963264, 3647963647, 'DE', 'DEU', 'ألمانيا'),
(104986, 3647963648, 3647963711, 'BE', 'BEL', 'بلجيكا'),
(104987, 3647963712, 3647964415, 'DE', 'DEU', 'ألمانيا'),
(104988, 3647964416, 3647964567, 'ES', 'ESP', 'إسبانيا'),
(104989, 3647964568, 3647964583, 'DE', 'DEU', 'ألمانيا'),
(104990, 3647964584, 3647964599, 'ES', 'ESP', 'إسبانيا'),
(104991, 3647964600, 3647964607, 'DE', 'DEU', 'ألمانيا'),
(104992, 3647964608, 3647964615, 'ES', 'ESP', 'إسبانيا'),
(104993, 3647964616, 3647964623, 'DE', 'DEU', 'ألمانيا'),
(104994, 3647964624, 3647964671, 'ES', 'ESP', 'إسبانيا'),
(104995, 3647964672, 3647964679, 'DE', 'DEU', 'ألمانيا'),
(104996, 3647964680, 3647964703, 'ES', 'ESP', 'إسبانيا'),
(104997, 3647964704, 3647965183, 'DE', 'DEU', 'ألمانيا'),
(104998, 3647965184, 3647965255, 'ES', 'ESP', 'إسبانيا'),
(104999, 3647965256, 3647965279, 'DE', 'DEU', 'ألمانيا'),
(105000, 3647965280, 3647965311, 'ES', 'ESP', 'إسبانيا'),
(105001, 3647965312, 3647965327, 'DE', 'DEU', 'ألمانيا'),
(105002, 3647965328, 3647965359, 'ES', 'ESP', 'إسبانيا'),
(105003, 3647965360, 3647965375, 'DE', 'DEU', 'ألمانيا'),
(105004, 3647965376, 3647965407, 'ES', 'ESP', 'إسبانيا'),
(105005, 3647965408, 3647965439, 'DE', 'DEU', 'ألمانيا'),
(105006, 3647965440, 3647965695, 'ES', 'ESP', 'إسبانيا'),
(105007, 3647965696, 3647965951, 'CH', 'CHE', 'سويسرا'),
(105008, 3647965952, 3647966207, 'DE', 'DEU', 'ألمانيا'),
(105009, 3647966208, 3647966575, 'GB', 'GBR', 'المملكة المتحدة'),
(105010, 3647966576, 3647966583, 'DE', 'DEU', 'ألمانيا'),
(105011, 3647966584, 3647966631, 'GB', 'GBR', 'المملكة المتحدة'),
(105012, 3647966632, 3647966639, 'DE', 'DEU', 'ألمانيا'),
(105013, 3647966640, 3647966695, 'GB', 'GBR', 'المملكة المتحدة'),
(105014, 3647966696, 3647966703, 'DE', 'DEU', 'ألمانيا'),
(105015, 3647966704, 3647967231, 'GB', 'GBR', 'المملكة المتحدة'),
(105016, 3647967232, 3647968255, 'BE', 'BEL', 'بلجيكا'),
(105017, 3647968256, 3647968271, 'FR', 'FRA', 'فرنسا'),
(105018, 3647968272, 3647968279, 'DE', 'DEU', 'ألمانيا'),
(105019, 3647968280, 3647968479, 'FR', 'FRA', 'فرنسا'),
(105020, 3647968480, 3647968495, 'DE', 'DEU', 'ألمانيا'),
(105021, 3647968496, 3647968703, 'FR', 'FRA', 'فرنسا'),
(105022, 3647968704, 3647968767, 'DE', 'DEU', 'ألمانيا'),
(105023, 3647968768, 3647968775, 'FR', 'FRA', 'فرنسا'),
(105024, 3647968776, 3647968791, 'DE', 'DEU', 'ألمانيا'),
(105025, 3647968792, 3647968799, 'FR', 'FRA', 'فرنسا'),
(105026, 3647968800, 3647969279, 'DE', 'DEU', 'ألمانيا'),
(105027, 3647969280, 3647969791, 'IT', 'ITA', 'إيطاليا'),
(105028, 3647969792, 3647970111, 'BE', 'BEL', 'بلجيكا'),
(105029, 3647970112, 3647970119, 'DE', 'DEU', 'ألمانيا'),
(105030, 3647970120, 3647970303, 'BE', 'BEL', 'بلجيكا'),
(105031, 3647970304, 3647971327, 'FR', 'FRA', 'فرنسا'),
(105032, 3647971328, 3647971671, 'GB', 'GBR', 'المملكة المتحدة'),
(105033, 3647971672, 3647971679, 'DE', 'DEU', 'ألمانيا'),
(105034, 3647971680, 3647972255, 'GB', 'GBR', 'المملكة المتحدة'),
(105035, 3647972256, 3647972263, 'DE', 'DEU', 'ألمانيا'),
(105036, 3647972264, 3647972279, 'GB', 'GBR', 'المملكة المتحدة'),
(105037, 3647972280, 3647972287, 'DE', 'DEU', 'ألمانيا'),
(105038, 3647972288, 3647972319, 'GB', 'GBR', 'المملكة المتحدة'),
(105039, 3647972320, 3647972351, 'DE', 'DEU', 'ألمانيا'),
(105040, 3647972352, 3647973375, 'GB', 'GBR', 'المملكة المتحدة'),
(105041, 3647973376, 3647973503, 'IT', 'ITA', 'إيطاليا'),
(105042, 3647973504, 3647973511, 'DE', 'DEU', 'ألمانيا'),
(105043, 3647973512, 3647973783, 'IT', 'ITA', 'إيطاليا'),
(105044, 3647973784, 3647973791, 'DE', 'DEU', 'ألمانيا'),
(105045, 3647973792, 3647973807, 'IT', 'ITA', 'إيطاليا'),
(105046, 3647973808, 3647973815, 'DE', 'DEU', 'ألمانيا'),
(105047, 3647973816, 3647973919, 'IT', 'ITA', 'إيطاليا'),
(105048, 3647973920, 3647973927, 'DE', 'DEU', 'ألمانيا'),
(105049, 3647973928, 3647973951, 'IT', 'ITA', 'إيطاليا'),
(105050, 3647973952, 3647974399, 'DE', 'DEU', 'ألمانيا'),
(105051, 3647974400, 3647976447, 'ES', 'ESP', 'إسبانيا'),
(105052, 3647976448, 3647977471, 'BE', 'BEL', 'بلجيكا'),
(105053, 3647977472, 3647977791, 'GB', 'GBR', 'المملكة المتحدة'),
(105054, 3647977792, 3647977855, 'IE', 'IRL', 'إيرلندا'),
(105055, 3647977856, 3647978495, 'GB', 'GBR', 'المملكة المتحدة'),
(105056, 3647978496, 3647979007, 'NL', 'NLD', 'هولندا'),
(105057, 3647979008, 3647995903, 'DE', 'DEU', 'ألمانيا'),
(105058, 3647995904, 3648004095, 'RU', 'RUS', 'الإتحاد الروسي'),
(105059, 3648004096, 3648004607, 'GB', 'GBR', 'المملكة المتحدة'),
(105060, 3648004608, 3648004863, 'RU', 'RUS', 'الإتحاد الروسي'),
(105061, 3648004864, 3648005119, 'GB', 'GBR', 'المملكة المتحدة'),
(105062, 3648005120, 3648006271, 'RU', 'RUS', 'الإتحاد الروسي'),
(105063, 3648006272, 3648006399, 'GB', 'GBR', 'المملكة المتحدة'),
(105064, 3648006400, 3648007167, 'RU', 'RUS', 'الإتحاد الروسي'),
(105065, 3648007168, 3648008191, 'GB', 'GBR', 'المملكة المتحدة'),
(105066, 3648008192, 3648016383, 'FR', 'FRA', 'فرنسا'),
(105067, 3648016384, 3648020479, 'GB', 'GBR', 'المملكة المتحدة'),
(105068, 3648020480, 3648024575, 'IT', 'ITA', 'إيطاليا'),
(105069, 3648024576, 3648028671, 'NL', 'NLD', 'هولندا'),
(105070, 3648028672, 3648032767, 'HU', 'HUN', 'هنغاريا'),
(105071, 3648032768, 3648033023, 'IE', 'IRL', 'إيرلندا'),
(105072, 3648033040, 3648033087, 'IE', 'IRL', 'إيرلندا'),
(105073, 3648033104, 3648033119, 'IE', 'IRL', 'إيرلندا'),
(105074, 3648033536, 3648033791, 'IE', 'IRL', 'إيرلندا'),
(105075, 3648034048, 3648034051, 'IE', 'IRL', 'إيرلندا'),
(105076, 3648034056, 3648034095, 'IE', 'IRL', 'إيرلندا'),
(105077, 3648034176, 3648034191, 'IE', 'IRL', 'إيرلندا'),
(105078, 3648034816, 3648034847, 'DE', 'DEU', 'ألمانيا'),
(105079, 3648035040, 3648035071, 'NL', 'NLD', 'هولندا'),
(105080, 3648036864, 3648040959, 'CZ', 'CZE', 'التشيك'),
(105081, 3648040960, 3648041020, 'BE', 'BEL', 'بلجيكا'),
(105082, 3648041021, 3648041021, 'FR', 'FRA', 'فرنسا'),
(105083, 3648041022, 3648045055, 'BE', 'BEL', 'بلجيكا'),
(105084, 3648045056, 3648049151, 'FI', 'FIN', 'فنلندا'),
(105085, 3648049152, 3648053247, 'UA', 'UKR', 'أوكرانيا'),
(105086, 3648053248, 3648057343, 'FR', 'FRA', 'فرنسا'),
(105087, 3648057344, 3648061439, 'FI', 'FIN', 'فنلندا'),
(105088, 3648061440, 3648069631, 'AM', 'ARM', 'أرمينيا'),
(105089, 3648069632, 3648073727, 'DE', 'DEU', 'ألمانيا'),
(105090, 3648073728, 3648077823, 'HU', 'HUN', 'هنغاريا'),
(105091, 3648077824, 3648078079, 'BE', 'BEL', 'بلجيكا'),
(105092, 3648078080, 3648078335, 'CG', 'COG', 'الكونغو'),
(105093, 3648078336, 3648078463, 'BE', 'BEL', 'بلجيكا'),
(105094, 3648078464, 3648078495, 'BF', 'BFA', 'بوركينا فاسو'),
(105095, 3648078496, 3648078527, 'BE', 'BEL', 'بلجيكا'),
(105096, 3648078528, 3648078591, 'BF', 'BFA', 'بوركينا فاسو'),
(105097, 3648078592, 3648078847, 'CG', 'COG', 'الكونغو'),
(105098, 3648078848, 3648079103, 'BE', 'BEL', 'بلجيكا'),
(105099, 3648079104, 3648080383, 'UG', 'UGA', 'أوغاندا'),
(105100, 3648080384, 3648080511, 'TZ', 'TZA', 'تانزانيا'),
(105101, 3648080512, 3648080543, 'BF', 'BFA', 'بوركينا فاسو'),
(105102, 3648080544, 3648080639, 'TZ', 'TZA', 'تانزانيا'),
(105103, 3648080640, 3648080895, 'BE', 'BEL', 'بلجيكا'),
(105104, 3648080896, 3648080903, 'NE', 'NER', 'النيجر'),
(105105, 3648080904, 3648080919, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105106, 3648080920, 3648080927, 'GA', 'GAB', 'الغابون'),
(105107, 3648080928, 3648080959, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105108, 3648080960, 3648080991, 'TD', 'TCD', 'تشاد'),
(105109, 3648080992, 3648081007, 'SL', 'SLE', 'سيراليون'),
(105110, 3648081008, 3648081023, 'BE', 'BEL', 'بلجيكا'),
(105111, 3648081024, 3648081055, 'GB', 'GBR', 'المملكة المتحدة'),
(105112, 3648081056, 3648081407, 'BE', 'BEL', 'بلجيكا'),
(105113, 3648081408, 3648082175, 'MW', 'MWI', 'ملاوي'),
(105114, 3648082176, 3648082239, 'BE', 'BEL', 'بلجيكا'),
(105115, 3648082240, 3648082687, 'LR', 'LBR', 'ليبيريا'),
(105116, 3648082688, 3648085759, 'BE', 'BEL', 'بلجيكا'),
(105117, 3648085760, 3648086015, 'LR', 'LBR', 'ليبيريا'),
(105118, 3648086016, 3648090111, 'AT', 'AUT', 'النمسا'),
(105119, 3648090112, 3648094207, 'RU', 'RUS', 'الإتحاد الروسي'),
(105120, 3648094208, 3648102399, 'PL', 'POL', 'بولندا'),
(105121, 3648102400, 3648106495, 'GB', 'GBR', 'المملكة المتحدة'),
(105122, 3648106496, 3648110591, 'DE', 'DEU', 'ألمانيا'),
(105123, 3648110592, 3648114687, 'FR', 'FRA', 'فرنسا'),
(105124, 3648114688, 3648118783, 'IT', 'ITA', 'إيطاليا'),
(105125, 3648118784, 3648122879, 'PL', 'POL', 'بولندا'),
(105126, 3648122880, 3648126975, 'ES', 'ESP', 'إسبانيا'),
(105127, 3648126976, 3648139263, 'RU', 'RUS', 'الإتحاد الروسي'),
(105128, 3648139264, 3648143359, 'GB', 'GBR', 'المملكة المتحدة'),
(105129, 3648143360, 3648147455, 'DE', 'DEU', 'ألمانيا'),
(105130, 3648147456, 3648149503, 'SE', 'SWE', 'السويد'),
(105131, 3648149504, 3648150015, 'GB', 'GBR', 'المملكة المتحدة'),
(105132, 3648150016, 3648150271, 'SE', 'SWE', 'السويد'),
(105133, 3648150272, 3648150527, 'FI', 'FIN', 'فنلندا'),
(105134, 3648150528, 3648150783, 'DK', 'DNK', 'الدنيمارك'),
(105135, 3648150784, 3648151039, 'NO', 'NOR', 'النرويج'),
(105136, 3648151040, 3648151551, 'SE', 'SWE', 'السويد'),
(105137, 3648151552, 3648155647, 'NL', 'NLD', 'هولندا'),
(105138, 3648155648, 3648159743, 'CH', 'CHE', 'سويسرا'),
(105139, 3648159744, 3648163839, 'ES', 'ESP', 'إسبانيا');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(105140, 3648163840, 3648167935, 'RU', 'RUS', 'الإتحاد الروسي'),
(105141, 3648167936, 3648172031, 'IE', 'IRL', 'إيرلندا'),
(105142, 3648172032, 3648176127, 'RU', 'RUS', 'الإتحاد الروسي'),
(105143, 3648176128, 3648178687, 'FR', 'FRA', 'فرنسا'),
(105144, 3648178688, 3648178815, 'LU', 'LUX', 'لوكسيمبورغ'),
(105145, 3648178816, 3648180223, 'FR', 'FRA', 'فرنسا'),
(105146, 3648180224, 3648180767, 'DE', 'DEU', 'ألمانيا'),
(105147, 3648180768, 3648180799, 'AT', 'AUT', 'النمسا'),
(105148, 3648180800, 3648181023, 'DE', 'DEU', 'ألمانيا'),
(105149, 3648181024, 3648181055, 'AT', 'AUT', 'النمسا'),
(105150, 3648181056, 3648181311, 'DE', 'DEU', 'ألمانيا'),
(105151, 3648181312, 3648181343, 'AT', 'AUT', 'النمسا'),
(105152, 3648181344, 3648181375, 'DE', 'DEU', 'ألمانيا'),
(105153, 3648181376, 3648181407, 'RU', 'RUS', 'الإتحاد الروسي'),
(105154, 3648181408, 3648181423, 'DE', 'DEU', 'ألمانيا'),
(105155, 3648181424, 3648181439, 'CH', 'CHE', 'سويسرا'),
(105156, 3648181440, 3648181631, 'DE', 'DEU', 'ألمانيا'),
(105157, 3648181632, 3648181647, 'AT', 'AUT', 'النمسا'),
(105158, 3648181648, 3648181655, 'DE', 'DEU', 'ألمانيا'),
(105159, 3648181656, 3648181663, 'IT', 'ITA', 'إيطاليا'),
(105160, 3648181664, 3648181887, 'DE', 'DEU', 'ألمانيا'),
(105161, 3648181888, 3648181903, 'AT', 'AUT', 'النمسا'),
(105162, 3648181904, 3648182143, 'DE', 'DEU', 'ألمانيا'),
(105163, 3648182144, 3648182159, 'NL', 'NLD', 'هولندا'),
(105164, 3648182160, 3648182175, 'DE', 'DEU', 'ألمانيا'),
(105165, 3648182176, 3648182207, 'RU', 'RUS', 'الإتحاد الروسي'),
(105166, 3648182208, 3648182271, 'GB', 'GBR', 'المملكة المتحدة'),
(105167, 3648182272, 3648182303, 'CH', 'CHE', 'سويسرا'),
(105168, 3648182304, 3648182335, 'IT', 'ITA', 'إيطاليا'),
(105169, 3648182336, 3648182591, 'DE', 'DEU', 'ألمانيا'),
(105170, 3648182592, 3648182623, 'AT', 'AUT', 'النمسا'),
(105171, 3648182624, 3648182655, 'CH', 'CHE', 'سويسرا'),
(105172, 3648182656, 3648182783, 'DE', 'DEU', 'ألمانيا'),
(105173, 3648182784, 3648182799, 'IT', 'ITA', 'إيطاليا'),
(105174, 3648182800, 3648182815, 'AT', 'AUT', 'النمسا'),
(105175, 3648182816, 3648182823, 'US', 'USA', 'الولايات المتحدة'),
(105176, 3648182824, 3648182831, 'RU', 'RUS', 'الإتحاد الروسي'),
(105177, 3648182832, 3648182847, 'DE', 'DEU', 'ألمانيا'),
(105178, 3648182848, 3648182911, 'IT', 'ITA', 'إيطاليا'),
(105179, 3648182912, 3648183871, 'DE', 'DEU', 'ألمانيا'),
(105180, 3648183872, 3648183935, 'GB', 'GBR', 'المملكة المتحدة'),
(105181, 3648183936, 3648184319, 'DE', 'DEU', 'ألمانيا'),
(105182, 3648184320, 3648192511, 'RU', 'RUS', 'الإتحاد الروسي'),
(105183, 3648192512, 3648196607, 'DE', 'DEU', 'ألمانيا'),
(105184, 3648196608, 3648200703, 'IT', 'ITA', 'إيطاليا'),
(105185, 3648200704, 3648208895, 'SE', 'SWE', 'السويد'),
(105186, 3648208896, 3648212991, 'DE', 'DEU', 'ألمانيا'),
(105187, 3648212992, 3648217087, 'RU', 'RUS', 'الإتحاد الروسي'),
(105188, 3648221184, 3648225279, 'IE', 'IRL', 'إيرلندا'),
(105189, 3648225280, 3648231263, 'DE', 'DEU', 'ألمانيا'),
(105190, 3648231264, 3648231295, 'NL', 'NLD', 'هولندا'),
(105191, 3648231296, 3648233471, 'DE', 'DEU', 'ألمانيا'),
(105192, 3648233472, 3648237567, 'FR', 'FRA', 'فرنسا'),
(105193, 3648237568, 3648241663, 'RU', 'RUS', 'الإتحاد الروسي'),
(105194, 3648241664, 3648245759, 'NL', 'NLD', 'هولندا'),
(105195, 3648245760, 3648249855, 'RO', 'ROM', 'رومانيا'),
(105196, 3648249856, 3648253951, 'NL', 'NLD', 'هولندا'),
(105197, 3648253952, 3648258047, 'CZ', 'CZE', 'التشيك'),
(105198, 3648258048, 3648266239, 'ES', 'ESP', 'إسبانيا'),
(105199, 3648266240, 3648270335, 'HU', 'HUN', 'هنغاريا'),
(105200, 3648270336, 3648274431, 'RU', 'RUS', 'الإتحاد الروسي'),
(105201, 3648274432, 3648278527, 'AT', 'AUT', 'النمسا'),
(105202, 3648278528, 3648282623, 'NO', 'NOR', 'النرويج'),
(105203, 3648282624, 3648286719, 'PL', 'POL', 'بولندا'),
(105204, 3648286720, 3648290815, 'DE', 'DEU', 'ألمانيا'),
(105205, 3648290816, 3648299007, 'RU', 'RUS', 'الإتحاد الروسي'),
(105206, 3648299008, 3648303103, 'FI', 'FIN', 'فنلندا'),
(105207, 3648303104, 3648307199, 'AT', 'AUT', 'النمسا'),
(105208, 3648307200, 3648311295, 'TR', 'TUR', 'تركيا'),
(105209, 3648311296, 3648315615, 'DK', 'DNK', 'الدنيمارك'),
(105210, 3648315616, 3648315631, 'CA', 'CAN', 'كندا'),
(105211, 3648315632, 3648316079, 'DK', 'DNK', 'الدنيمارك'),
(105212, 3648316080, 3648316087, 'SE', 'SWE', 'السويد'),
(105213, 3648316088, 3648316127, 'DK', 'DNK', 'الدنيمارك'),
(105214, 3648316128, 3648316143, 'CA', 'CAN', 'كندا'),
(105215, 3648316144, 3648316415, 'DK', 'DNK', 'الدنيمارك'),
(105216, 3648316416, 3648316671, 'NL', 'NLD', 'هولندا'),
(105217, 3648316672, 3648316927, 'AT', 'AUT', 'النمسا'),
(105218, 3648316928, 3648317247, 'DK', 'DNK', 'الدنيمارك'),
(105219, 3648317248, 3648317263, 'CA', 'CAN', 'كندا'),
(105220, 3648317264, 3648319527, 'DK', 'DNK', 'الدنيمارك'),
(105221, 3648319528, 3648319535, 'CH', 'CHE', 'سويسرا'),
(105222, 3648319536, 3648321631, 'DK', 'DNK', 'الدنيمارك'),
(105223, 3648321632, 3648321639, 'CA', 'CAN', 'كندا'),
(105224, 3648321640, 3648321823, 'DK', 'DNK', 'الدنيمارك'),
(105225, 3648321824, 3648321839, 'GB', 'GBR', 'المملكة المتحدة'),
(105226, 3648321840, 3648323583, 'DK', 'DNK', 'الدنيمارك'),
(105227, 3648327680, 3648331775, 'LT', 'LTU', 'ليتوانيا'),
(105228, 3648331776, 3648339967, 'BE', 'BEL', 'بلجيكا'),
(105229, 3648339968, 3648344063, 'UA', 'UKR', 'أوكرانيا'),
(105230, 3648344064, 3648348159, 'RU', 'RUS', 'الإتحاد الروسي'),
(105231, 3648348160, 3648352255, 'DE', 'DEU', 'ألمانيا'),
(105232, 3648352256, 3648356351, 'RU', 'RUS', 'الإتحاد الروسي'),
(105233, 3648356352, 3648360447, 'PL', 'POL', 'بولندا'),
(105234, 3648360448, 3648364543, 'FR', 'FRA', 'فرنسا'),
(105235, 3648364544, 3648368639, 'CH', 'CHE', 'سويسرا'),
(105236, 3648368640, 3648372735, 'RU', 'RUS', 'الإتحاد الروسي'),
(105237, 3648372736, 3648376831, 'LU', 'LUX', 'لوكسيمبورغ'),
(105238, 3648376832, 3648380927, 'CZ', 'CZE', 'التشيك'),
(105239, 3648380928, 3648385023, 'NL', 'NLD', 'هولندا'),
(105240, 3648385024, 3648389119, 'RU', 'RUS', 'الإتحاد الروسي'),
(105241, 3648389120, 3648393215, 'IT', 'ITA', 'إيطاليا'),
(105242, 3648393216, 3648397311, 'DE', 'DEU', 'ألمانيا'),
(105243, 3648397312, 3648405503, 'NO', 'NOR', 'النرويج'),
(105244, 3648405504, 3648413695, 'RU', 'RUS', 'الإتحاد الروسي'),
(105245, 3648413696, 3648417791, 'SK', 'SVK', 'سلوفاكيا'),
(105246, 3648417792, 3648417807, 'AT', 'AUT', 'النمسا'),
(105247, 3648417808, 3648417815, 'GB', 'GBR', 'المملكة المتحدة'),
(105248, 3648417816, 3648417831, 'AT', 'AUT', 'النمسا'),
(105249, 3648417832, 3648417839, 'GB', 'GBR', 'المملكة المتحدة'),
(105250, 3648417840, 3648417879, 'AT', 'AUT', 'النمسا'),
(105251, 3648417880, 3648417919, 'GB', 'GBR', 'المملكة المتحدة'),
(105252, 3648417920, 3648418047, 'AT', 'AUT', 'النمسا'),
(105253, 3648418048, 3648418079, 'GB', 'GBR', 'المملكة المتحدة'),
(105254, 3648418080, 3648418095, 'ES', 'ESP', 'إسبانيا'),
(105255, 3648418096, 3648418111, 'GB', 'GBR', 'المملكة المتحدة'),
(105256, 3648418112, 3648418135, 'ES', 'ESP', 'إسبانيا'),
(105257, 3648418136, 3648418143, 'GB', 'GBR', 'المملكة المتحدة'),
(105258, 3648418144, 3648418247, 'ES', 'ESP', 'إسبانيا'),
(105259, 3648418248, 3648418255, 'CH', 'CHE', 'سويسرا'),
(105260, 3648418256, 3648418263, 'ES', 'ESP', 'إسبانيا'),
(105261, 3648418264, 3648418271, 'GB', 'GBR', 'المملكة المتحدة'),
(105262, 3648418272, 3648418303, 'ES', 'ESP', 'إسبانيا'),
(105263, 3648418304, 3648419327, 'GB', 'GBR', 'المملكة المتحدة'),
(105264, 3648419328, 3648419455, 'FR', 'FRA', 'فرنسا'),
(105265, 3648419456, 3648419519, 'IT', 'ITA', 'إيطاليا'),
(105266, 3648419520, 3648419583, 'ES', 'ESP', 'إسبانيا'),
(105267, 3648419584, 3648419839, 'GB', 'GBR', 'المملكة المتحدة'),
(105268, 3648419840, 3648419901, 'BE', 'BEL', 'بلجيكا'),
(105269, 3648419902, 3648420095, 'GB', 'GBR', 'المملكة المتحدة'),
(105270, 3648420096, 3648420351, 'NL', 'NLD', 'هولندا'),
(105271, 3648420352, 3648420863, 'GB', 'GBR', 'المملكة المتحدة'),
(105272, 3648420864, 3648421119, 'US', 'USA', 'الولايات المتحدة'),
(105273, 3648421120, 3648421375, 'GB', 'GBR', 'المملكة المتحدة'),
(105274, 3648421376, 3648421631, 'DE', 'DEU', 'ألمانيا'),
(105275, 3648421632, 3648421887, 'CH', 'CHE', 'سويسرا'),
(105276, 3648421888, 3648425983, 'GB', 'GBR', 'المملكة المتحدة'),
(105277, 3648425984, 3648430079, 'IT', 'ITA', 'إيطاليا'),
(105278, 3648430080, 3648434175, 'NL', 'NLD', 'هولندا'),
(105279, 3648434176, 3648438271, 'RU', 'RUS', 'الإتحاد الروسي'),
(105280, 3648438272, 3648442367, 'CH', 'CHE', 'سويسرا'),
(105281, 3648442368, 3648443743, 'SE', 'SWE', 'السويد'),
(105282, 3648443744, 3648443759, 'PA', 'PAN', 'بنما'),
(105283, 3648443760, 3648446463, 'SE', 'SWE', 'السويد'),
(105284, 3648446464, 3648447055, 'FR', 'FRA', 'فرنسا'),
(105285, 3648447056, 3648447063, 'ES', 'ESP', 'إسبانيا'),
(105286, 3648447064, 3648449119, 'FR', 'FRA', 'فرنسا'),
(105287, 3648449120, 3648449135, 'ES', 'ESP', 'إسبانيا'),
(105288, 3648449136, 3648450559, 'FR', 'FRA', 'فرنسا'),
(105289, 3648450560, 3648454655, 'IT', 'ITA', 'إيطاليا'),
(105290, 3648454656, 3648458751, 'NL', 'NLD', 'هولندا'),
(105291, 3648458752, 3648462847, 'RU', 'RUS', 'الإتحاد الروسي'),
(105292, 3648462848, 3648466943, 'FI', 'FIN', 'فنلندا'),
(105293, 3648466944, 3648469263, 'DE', 'DEU', 'ألمانيا'),
(105294, 3648469264, 3648469271, 'NL', 'NLD', 'هولندا'),
(105295, 3648469272, 3648469295, 'DE', 'DEU', 'ألمانيا'),
(105296, 3648469296, 3648469311, 'AT', 'AUT', 'النمسا'),
(105297, 3648469312, 3648471039, 'DE', 'DEU', 'ألمانيا'),
(105298, 3648471040, 3648475135, 'PL', 'POL', 'بولندا'),
(105299, 3648475136, 3648479231, 'RU', 'RUS', 'الإتحاد الروسي'),
(105300, 3648479232, 3648483327, 'CH', 'CHE', 'سويسرا'),
(105301, 3648483328, 3648487423, 'SK', 'SVK', 'سلوفاكيا'),
(105302, 3648487424, 3648491519, 'FR', 'FRA', 'فرنسا'),
(105303, 3648491520, 3648495615, 'CH', 'CHE', 'سويسرا'),
(105304, 3648495616, 3648499711, 'SE', 'SWE', 'السويد'),
(105305, 3648499712, 3648503807, 'FR', 'FRA', 'فرنسا'),
(105306, 3648503808, 3648511999, 'DE', 'DEU', 'ألمانيا'),
(105307, 3648512000, 3648516095, 'NL', 'NLD', 'هولندا'),
(105308, 3648516096, 3648520191, 'RS', 'SRB', 'صربيا'),
(105309, 3648520192, 3648782335, 'NL', 'NLD', 'هولندا'),
(105310, 3648782336, 3649044479, 'ES', 'ESP', 'إسبانيا'),
(105311, 3649044480, 3649110015, 'FR', 'FRA', 'فرنسا'),
(105312, 3649110016, 3649175551, 'PT', 'PRT', 'البورتوغال'),
(105313, 3649175552, 3649241087, 'ES', 'ESP', 'إسبانيا'),
(105314, 3649241088, 3649306623, 'TR', 'TUR', 'تركيا'),
(105315, 3649306624, 3649372159, 'IL', 'ISR', 'إسرائيل'),
(105316, 3649372160, 3649437695, 'IT', 'ITA', 'إيطاليا'),
(105317, 3649437696, 3649568767, 'GB', 'GBR', 'المملكة المتحدة'),
(105318, 3649568768, 3649634303, 'BE', 'BEL', 'بلجيكا'),
(105319, 3649634304, 3649700159, 'GB', 'GBR', 'المملكة المتحدة'),
(105320, 3649700160, 3649700247, 'US', 'USA', 'الولايات المتحدة'),
(105321, 3649700248, 3649700251, 'BB', 'BRB', 'باربادوس'),
(105322, 3649700252, 3649700287, 'US', 'USA', 'الولايات المتحدة'),
(105323, 3649700288, 3649700863, 'GB', 'GBR', 'المملكة المتحدة'),
(105324, 3649700864, 3649701119, 'US', 'USA', 'الولايات المتحدة'),
(105325, 3649701120, 3649708791, 'GB', 'GBR', 'المملكة المتحدة'),
(105326, 3649708792, 3649709055, 'GD', 'GRD', 'غرينادا'),
(105327, 3649709056, 3649709287, 'GB', 'GBR', 'المملكة المتحدة'),
(105328, 3649709288, 3649709295, 'BB', 'BRB', 'باربادوس'),
(105329, 3649709296, 3649709311, 'AG', 'ATG', 'انتيغوا وبربودا'),
(105330, 3649709312, 3649709815, 'GB', 'GBR', 'المملكة المتحدة'),
(105331, 3649709816, 3649709823, 'TT', 'TTO', 'ترينيداد وتوباغو'),
(105332, 3649709824, 3649765375, 'GB', 'GBR', 'المملكة المتحدة'),
(105333, 3649830912, 3649835007, 'NL', 'NLD', 'هولندا'),
(105334, 3649835008, 3649839103, 'ES', 'ESP', 'إسبانيا'),
(105335, 3649839104, 3649847295, 'GB', 'GBR', 'المملكة المتحدة'),
(105336, 3649847296, 3649855487, 'DE', 'DEU', 'ألمانيا'),
(105337, 3649855488, 3649856511, 'GB', 'GBR', 'المملكة المتحدة'),
(105338, 3649856512, 3649857023, 'US', 'USA', 'الولايات المتحدة'),
(105339, 3649857024, 3649857535, 'GB', 'GBR', 'المملكة المتحدة'),
(105340, 3649857536, 3649858047, 'JP', 'JPN', 'اليابان'),
(105341, 3649858048, 3649859071, 'GB', 'GBR', 'المملكة المتحدة'),
(105342, 3649859072, 3649859583, 'US', 'USA', 'الولايات المتحدة'),
(105343, 3649859584, 3649863679, 'SE', 'SWE', 'السويد'),
(105344, 3649863680, 3649896447, 'FI', 'FIN', 'فنلندا'),
(105345, 3649896448, 3649961983, 'IT', 'ITA', 'إيطاليا'),
(105346, 3649961984, 3650093055, 'SE', 'SWE', 'السويد'),
(105347, 3650093056, 3650097151, 'JO', 'JOR', 'الأردن'),
(105348, 3650097152, 3650101247, 'SK', 'SVK', 'سلوفاكيا'),
(105349, 3650101248, 3650105343, 'DE', 'DEU', 'ألمانيا'),
(105350, 3650105344, 3650109439, 'CH', 'CHE', 'سويسرا'),
(105351, 3650109440, 3650113535, 'UA', 'UKR', 'أوكرانيا'),
(105352, 3650113536, 3650117631, 'GB', 'GBR', 'المملكة المتحدة'),
(105353, 3650117632, 3650121727, 'RU', 'RUS', 'الإتحاد الروسي'),
(105354, 3650121728, 3650125823, 'FR', 'FRA', 'فرنسا'),
(105355, 3650125824, 3650129743, 'DE', 'DEU', 'ألمانيا'),
(105356, 3650129744, 3650129751, 'IE', 'IRL', 'إيرلندا'),
(105357, 3650129752, 3650129919, 'DE', 'DEU', 'ألمانيا'),
(105358, 3650129920, 3650134015, 'GB', 'GBR', 'المملكة المتحدة'),
(105359, 3650134016, 3650142207, 'RU', 'RUS', 'الإتحاد الروسي'),
(105360, 3650142208, 3650150399, 'PL', 'POL', 'بولندا'),
(105361, 3650150400, 3650158591, 'NO', 'NOR', 'النرويج'),
(105362, 3650158592, 3650162687, 'MT', 'MLT', 'مالطا'),
(105363, 3650162688, 3650166783, 'RU', 'RUS', 'الإتحاد الروسي'),
(105364, 3650166784, 3650167807, 'BE', 'BEL', 'بلجيكا'),
(105365, 3650167808, 3650168063, 'LU', 'LUX', 'لوكسيمبورغ'),
(105366, 3650168064, 3650170879, 'BE', 'BEL', 'بلجيكا'),
(105367, 3650170880, 3650174975, 'DK', 'DNK', 'الدنيمارك'),
(105368, 3650174976, 3650179071, 'GB', 'GBR', 'المملكة المتحدة'),
(105369, 3650179072, 3650183167, 'BG', 'BGR', 'بلغاريا'),
(105370, 3650183168, 3650187263, 'DE', 'DEU', 'ألمانيا'),
(105371, 3650187264, 3650195455, 'GB', 'GBR', 'المملكة المتحدة'),
(105372, 3650195456, 3650199551, 'RU', 'RUS', 'الإتحاد الروسي'),
(105373, 3650199552, 3650203647, 'BG', 'BGR', 'بلغاريا'),
(105374, 3650203648, 3650207743, 'ES', 'ESP', 'إسبانيا'),
(105375, 3650207744, 3650211839, 'SK', 'SVK', 'سلوفاكيا'),
(105376, 3650211840, 3650215935, 'LV', 'LVA', 'لاتفيا'),
(105377, 3650215936, 3650220031, 'GB', 'GBR', 'المملكة المتحدة'),
(105378, 3650220032, 3650224127, 'SA', 'SAU', 'السعودية'),
(105379, 3650224128, 3650225027, 'US', 'USA', 'الولايات المتحدة'),
(105380, 3650225028, 3650228223, 'IE', 'IRL', 'إيرلندا'),
(105381, 3650228224, 3650232319, 'US', 'USA', 'الولايات المتحدة'),
(105382, 3650232320, 3650236415, 'RU', 'RUS', 'الإتحاد الروسي'),
(105383, 3650236416, 3650240511, 'GB', 'GBR', 'المملكة المتحدة'),
(105384, 3650240512, 3650244607, 'EE', 'EST', 'إستونيا'),
(105385, 3650244608, 3650256895, 'GB', 'GBR', 'المملكة المتحدة'),
(105386, 3650256896, 3650265087, 'DE', 'DEU', 'ألمانيا'),
(105387, 3650265088, 3650269183, 'CH', 'CHE', 'سويسرا'),
(105388, 3650269184, 3650273279, 'GB', 'GBR', 'المملكة المتحدة'),
(105389, 3650273280, 3650277375, 'IT', 'ITA', 'إيطاليا'),
(105390, 3650277376, 3650281471, 'IR', 'IRN', 'إيران'),
(105391, 3650281472, 3650285567, 'FR', 'FRA', 'فرنسا'),
(105392, 3650285568, 3650289663, 'UA', 'UKR', 'أوكرانيا'),
(105393, 3650289664, 3650297855, 'RU', 'RUS', 'الإتحاد الروسي'),
(105394, 3650297856, 3650301951, 'LT', 'LTU', 'ليتوانيا'),
(105395, 3650301952, 3650306623, 'DE', 'DEU', 'ألمانيا'),
(105396, 3650306624, 3650306639, 'GE', 'GEO', 'جورجيا'),
(105397, 3650306640, 3650306775, 'DE', 'DEU', 'ألمانيا'),
(105398, 3650306776, 3650306779, 'GE', 'GEO', 'جورجيا'),
(105399, 3650306780, 3650306783, 'DE', 'DEU', 'ألمانيا'),
(105400, 3650306784, 3650306791, 'AT', 'AUT', 'النمسا'),
(105401, 3650306792, 3650306799, 'DE', 'DEU', 'ألمانيا'),
(105402, 3650306800, 3650306807, 'AT', 'AUT', 'النمسا'),
(105403, 3650306808, 3650306943, 'DE', 'DEU', 'ألمانيا'),
(105404, 3650306944, 3650306959, 'GB', 'GBR', 'المملكة المتحدة'),
(105405, 3650306960, 3650307007, 'DE', 'DEU', 'ألمانيا'),
(105406, 3650307008, 3650307010, 'GB', 'GBR', 'المملكة المتحدة'),
(105407, 3650307011, 3650310143, 'DE', 'DEU', 'ألمانيا'),
(105408, 3650310144, 3650314239, 'GB', 'GBR', 'المملكة المتحدة'),
(105409, 3650314240, 3650315271, 'DE', 'DEU', 'ألمانيا'),
(105410, 3650315272, 3650315272, 'BE', 'BEL', 'بلجيكا'),
(105411, 3650315273, 3650316711, 'DE', 'DEU', 'ألمانيا'),
(105412, 3650316712, 3650316715, 'FR', 'FRA', 'فرنسا'),
(105413, 3650316716, 3650318335, 'DE', 'DEU', 'ألمانيا'),
(105414, 3650318336, 3650320383, 'GI', 'GIB', 'جبل طارق'),
(105415, 3650320384, 3650322431, 'GB', 'GBR', 'المملكة المتحدة'),
(105416, 3650322432, 3650330623, 'IT', 'ITA', 'إيطاليا'),
(105417, 3650330624, 3650334719, 'UA', 'UKR', 'أوكرانيا'),
(105418, 3650334720, 3650338815, 'GB', 'GBR', 'المملكة المتحدة'),
(105419, 3650338816, 3650342911, 'FR', 'FRA', 'فرنسا'),
(105420, 3650342912, 3650344463, 'CH', 'CHE', 'سويسرا'),
(105421, 3650344464, 3650344479, 'AT', 'AUT', 'النمسا'),
(105422, 3650344480, 3650344879, 'CH', 'CHE', 'سويسرا'),
(105423, 3650344880, 3650344911, 'PT', 'PRT', 'البورتوغال'),
(105424, 3650344912, 3650345879, 'CH', 'CHE', 'سويسرا'),
(105425, 3650345880, 3650345887, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(105426, 3650345888, 3650345903, 'AT', 'AUT', 'النمسا'),
(105427, 3650345904, 3650345935, 'CH', 'CHE', 'سويسرا'),
(105428, 3650345936, 3650345951, 'PT', 'PRT', 'البورتوغال'),
(105429, 3650345952, 3650346207, 'CH', 'CHE', 'سويسرا'),
(105430, 3650346208, 3650346239, 'IM', 'IMN', 'جزيرة آيل أوف مان'),
(105431, 3650346240, 3650347007, 'CH', 'CHE', 'سويسرا'),
(105432, 3650347008, 3650351103, 'GE', 'GEO', 'جورجيا'),
(105433, 3650351104, 3650351871, 'GB', 'GBR', 'المملكة المتحدة'),
(105434, 3650351872, 3650351879, 'NL', 'NLD', 'هولندا'),
(105435, 3650351880, 3650351887, 'IT', 'ITA', 'إيطاليا'),
(105436, 3650351888, 3650351903, 'GB', 'GBR', 'المملكة المتحدة'),
(105437, 3650351904, 3650351911, 'FR', 'FRA', 'فرنسا'),
(105438, 3650351912, 3650351919, 'SE', 'SWE', 'السويد'),
(105439, 3650351920, 3650351927, 'DK', 'DNK', 'الدنيمارك'),
(105440, 3650351928, 3650351935, 'DE', 'DEU', 'ألمانيا'),
(105441, 3650351936, 3650351943, 'PL', 'POL', 'بولندا'),
(105442, 3650351944, 3650351951, 'ES', 'ESP', 'إسبانيا'),
(105443, 3650351952, 3650351959, 'BE', 'BEL', 'بلجيكا'),
(105444, 3650351960, 3650351967, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(105445, 3650351968, 3650351975, 'PT', 'PRT', 'البورتوغال'),
(105446, 3650351976, 3650351983, 'FI', 'FIN', 'فنلندا'),
(105447, 3650351984, 3650351991, 'NO', 'NOR', 'النرويج'),
(105448, 3650351992, 3650351999, 'HU', 'HUN', 'هنغاريا'),
(105449, 3650352000, 3650352007, 'GB', 'GBR', 'المملكة المتحدة'),
(105450, 3650352008, 3650352015, 'IE', 'IRL', 'إيرلندا'),
(105451, 3650352016, 3650352127, 'GB', 'GBR', 'المملكة المتحدة'),
(105452, 3650352128, 3650352247, 'DE', 'DEU', 'ألمانيا'),
(105453, 3650352248, 3650352255, 'IE', 'IRL', 'إيرلندا'),
(105454, 3650352256, 3650352271, 'DE', 'DEU', 'ألمانيا'),
(105455, 3650352272, 3650352279, 'NL', 'NLD', 'هولندا'),
(105456, 3650352280, 3650352287, 'IT', 'ITA', 'إيطاليا'),
(105457, 3650352288, 3650352295, 'FR', 'FRA', 'فرنسا'),
(105458, 3650352296, 3650352303, 'SE', 'SWE', 'السويد'),
(105459, 3650352304, 3650352311, 'DK', 'DNK', 'الدنيمارك'),
(105460, 3650352312, 3650352319, 'DE', 'DEU', 'ألمانيا'),
(105461, 3650352320, 3650352327, 'PL', 'POL', 'بولندا'),
(105462, 3650352328, 3650352335, 'ES', 'ESP', 'إسبانيا'),
(105463, 3650352336, 3650352343, 'BE', 'BEL', 'بلجيكا'),
(105464, 3650352344, 3650352351, 'ZA', 'ZAF', 'جنوب أفريقيا'),
(105465, 3650352352, 3650352359, 'PT', 'PRT', 'البورتوغال'),
(105466, 3650352360, 3650352367, 'FI', 'FIN', 'فنلندا'),
(105467, 3650352368, 3650352375, 'NL', 'NLD', 'هولندا'),
(105468, 3650352376, 3650352383, 'HU', 'HUN', 'هنغاريا'),
(105469, 3650352384, 3650352895, 'DE', 'DEU', 'ألمانيا'),
(105470, 3650352896, 3650355199, 'GB', 'GBR', 'المملكة المتحدة'),
(105471, 3650355200, 3650359295, 'CH', 'CHE', 'سويسرا'),
(105472, 3650359296, 3650363391, 'NL', 'NLD', 'هولندا'),
(105473, 3650363392, 3650367487, 'GB', 'GBR', 'المملكة المتحدة'),
(105474, 3650367488, 3650371583, 'RU', 'RUS', 'الإتحاد الروسي'),
(105475, 3650371584, 3650375679, 'ES', 'ESP', 'إسبانيا'),
(105476, 3650375680, 3650379775, 'NL', 'NLD', 'هولندا'),
(105477, 3650379776, 3650387967, 'IT', 'ITA', 'إيطاليا'),
(105478, 3650387968, 3650392063, 'DE', 'DEU', 'ألمانيا'),
(105479, 3650392064, 3650396159, 'NO', 'NOR', 'النرويج'),
(105480, 3650396160, 3650404351, 'NL', 'NLD', 'هولندا'),
(105481, 3650404352, 3650412543, 'RU', 'RUS', 'الإتحاد الروسي'),
(105482, 3650412544, 3650416639, 'DE', 'DEU', 'ألمانيا'),
(105483, 3650416640, 3650420735, 'BE', 'BEL', 'بلجيكا'),
(105484, 3650420736, 3650424831, 'ES', 'ESP', 'إسبانيا'),
(105485, 3650424832, 3650428927, 'RU', 'RUS', 'الإتحاد الروسي'),
(105486, 3650428928, 3650433023, 'NL', 'NLD', 'هولندا'),
(105487, 3650433024, 3650437119, 'FI', 'FIN', 'فنلندا'),
(105488, 3650437120, 3650441215, 'NL', 'NLD', 'هولندا'),
(105489, 3650441216, 3650445311, 'IT', 'ITA', 'إيطاليا'),
(105490, 3650445312, 3650449407, 'GB', 'GBR', 'المملكة المتحدة'),
(105491, 3650449408, 3650453503, 'NO', 'NOR', 'النرويج'),
(105492, 3650453504, 3650457599, 'NL', 'NLD', 'هولندا'),
(105493, 3650457600, 3650461695, 'ES', 'ESP', 'إسبانيا'),
(105494, 3650461696, 3650465791, 'AT', 'AUT', 'النمسا'),
(105495, 3650465792, 3650469887, 'RU', 'RUS', 'الإتحاد الروسي'),
(105496, 3650469888, 3650478079, 'NL', 'NLD', 'هولندا'),
(105497, 3650478080, 3650482175, 'AT', 'AUT', 'النمسا'),
(105498, 3650482176, 3650484687, 'PL', 'POL', 'بولندا'),
(105499, 3650484688, 3650484695, 'SE', 'SWE', 'السويد'),
(105500, 3650484696, 3650486271, 'PL', 'POL', 'بولندا'),
(105501, 3650486272, 3650502655, 'RU', 'RUS', 'الإتحاد الروسي'),
(105502, 3650502656, 3650510847, 'SE', 'SWE', 'السويد'),
(105503, 3650510848, 3650519039, 'GB', 'GBR', 'المملكة المتحدة'),
(105504, 3650519040, 3650523135, 'HU', 'HUN', 'هنغاريا'),
(105505, 3650523136, 3650527231, 'DE', 'DEU', 'ألمانيا'),
(105506, 3650527232, 3650535423, 'SE', 'SWE', 'السويد'),
(105507, 3650535424, 3650539519, 'RU', 'RUS', 'الإتحاد الروسي'),
(105508, 3650539520, 3650543615, 'ES', 'ESP', 'إسبانيا'),
(105509, 3650543616, 3650551807, 'CH', 'CHE', 'سويسرا'),
(105510, 3650551808, 3650555903, 'FR', 'FRA', 'فرنسا'),
(105511, 3650555904, 3650559999, 'RU', 'RUS', 'الإتحاد الروسي'),
(105512, 3650560000, 3650564095, 'GB', 'GBR', 'المملكة المتحدة'),
(105513, 3650564096, 3650568191, 'SE', 'SWE', 'السويد'),
(105514, 3650568192, 3650572287, 'RU', 'RUS', 'الإتحاد الروسي'),
(105515, 3650572288, 3650576383, 'DE', 'DEU', 'ألمانيا'),
(105516, 3650576384, 3650580479, 'GB', 'GBR', 'المملكة المتحدة'),
(105517, 3650580480, 3650584575, 'CH', 'CHE', 'سويسرا'),
(105518, 3650584576, 3650588671, 'RU', 'RUS', 'الإتحاد الروسي'),
(105519, 3650588672, 3650592767, 'DE', 'DEU', 'ألمانيا'),
(105520, 3650592768, 3650600959, 'IS', 'ISL', 'أيسلندا'),
(105521, 3650600960, 3650605055, 'SE', 'SWE', 'السويد'),
(105522, 3650605056, 3650609279, 'DE', 'DEU', 'ألمانيا'),
(105523, 3650609280, 3650609311, 'CY', 'CYP', 'قبرص'),
(105524, 3650609312, 3650609407, 'DE', 'DEU', 'ألمانيا'),
(105525, 3650609408, 3650609439, 'IQ', 'IRQ', 'العراق'),
(105526, 3650609440, 3650609447, 'KZ', 'KAZ', 'كازاخستان'),
(105527, 3650609448, 3650609455, 'RU', 'RUS', 'الإتحاد الروسي'),
(105528, 3650609456, 3650609663, 'DE', 'DEU', 'ألمانيا'),
(105529, 3650609664, 3650609919, 'KZ', 'KAZ', 'كازاخستان'),
(105530, 3650609920, 3650610175, 'RU', 'RUS', 'الإتحاد الروسي'),
(105531, 3650610176, 3650610687, 'KZ', 'KAZ', 'كازاخستان'),
(105532, 3650610688, 3650610943, 'RU', 'RUS', 'الإتحاد الروسي'),
(105533, 3650610944, 3650611711, 'DE', 'DEU', 'ألمانيا'),
(105534, 3650611712, 3650612735, 'KZ', 'KAZ', 'كازاخستان'),
(105535, 3650612736, 3650617343, 'DE', 'DEU', 'ألمانيا'),
(105536, 3650617344, 3650682879, 'FI', 'FIN', 'فنلندا'),
(105537, 3650682880, 3650748415, 'PL', 'POL', 'بولندا'),
(105538, 3650748416, 3650789375, 'GB', 'GBR', 'المملكة المتحدة'),
(105539, 3650789376, 3650790143, 'NL', 'NLD', 'هولندا'),
(105540, 3650790144, 3650879487, 'GB', 'GBR', 'المملكة المتحدة'),
(105541, 3650879488, 3650912255, 'RO', 'ROM', 'رومانيا'),
(105542, 3650912256, 3650912639, 'GB', 'GBR', 'المملكة المتحدة'),
(105543, 3650912640, 3650912671, 'FR', 'FRA', 'فرنسا'),
(105544, 3650912672, 3650945023, 'GB', 'GBR', 'المملكة المتحدة'),
(105545, 3650945024, 3651010559, 'DK', 'DNK', 'الدنيمارك'),
(105546, 3651010560, 3651076095, 'GB', 'GBR', 'المملكة المتحدة'),
(105547, 3651076096, 3651077375, 'DE', 'DEU', 'ألمانيا'),
(105548, 3651077376, 3651077887, 'GB', 'GBR', 'المملكة المتحدة'),
(105549, 3651077888, 3651078143, 'IE', 'IRL', 'إيرلندا'),
(105550, 3651078144, 3651078399, 'ES', 'ESP', 'إسبانيا'),
(105551, 3651078400, 3651078655, 'IE', 'IRL', 'إيرلندا'),
(105552, 3651078656, 3651078783, 'ES', 'ESP', 'إسبانيا'),
(105553, 3651078784, 3651078911, 'DE', 'DEU', 'ألمانيا'),
(105554, 3651078912, 3651079807, 'GB', 'GBR', 'المملكة المتحدة'),
(105555, 3651079808, 3651079935, 'ES', 'ESP', 'إسبانيا'),
(105556, 3651079936, 3651080191, 'DE', 'DEU', 'ألمانيا'),
(105557, 3651080192, 3651080831, 'GB', 'GBR', 'المملكة المتحدة'),
(105558, 3651080832, 3651081215, 'DE', 'DEU', 'ألمانيا'),
(105559, 3651081216, 3651081727, 'GB', 'GBR', 'المملكة المتحدة'),
(105560, 3651081728, 3651081983, 'AT', 'AUT', 'النمسا'),
(105561, 3651081984, 3651082239, 'DE', 'DEU', 'ألمانيا'),
(105562, 3651082240, 3651082751, 'GB', 'GBR', 'المملكة المتحدة'),
(105563, 3651082752, 3651083007, 'IE', 'IRL', 'إيرلندا'),
(105564, 3651083008, 3651083519, 'GB', 'GBR', 'المملكة المتحدة'),
(105565, 3651083520, 3651083775, 'DE', 'DEU', 'ألمانيا'),
(105566, 3651083776, 3651084031, 'IE', 'IRL', 'إيرلندا'),
(105567, 3651084032, 3651084543, 'FR', 'FRA', 'فرنسا'),
(105568, 3651084544, 3651084799, 'IE', 'IRL', 'إيرلندا'),
(105569, 3651084800, 3651085311, 'ES', 'ESP', 'إسبانيا'),
(105570, 3651085312, 3651085567, 'FR', 'FRA', 'فرنسا'),
(105571, 3651085568, 3651086079, 'DE', 'DEU', 'ألمانيا'),
(105572, 3651086080, 3651086335, 'IE', 'IRL', 'إيرلندا'),
(105573, 3651086336, 3651086463, 'DE', 'DEU', 'ألمانيا'),
(105574, 3651086464, 3651086591, 'IE', 'IRL', 'إيرلندا'),
(105575, 3651086592, 3651086719, 'GR', 'GRC', 'اليونان'),
(105576, 3651086720, 3651086847, 'DE', 'DEU', 'ألمانيا'),
(105577, 3651086848, 3651087103, 'FR', 'FRA', 'فرنسا'),
(105578, 3651087104, 3651087615, 'ES', 'ESP', 'إسبانيا'),
(105579, 3651087616, 3651087871, 'GB', 'GBR', 'المملكة المتحدة'),
(105580, 3651087872, 3651088127, 'DE', 'DEU', 'ألمانيا'),
(105581, 3651088128, 3651088383, 'IE', 'IRL', 'إيرلندا'),
(105582, 3651088384, 3651088639, 'GR', 'GRC', 'اليونان'),
(105583, 3651088640, 3651088895, 'SG', 'SGP', 'سنغافورة'),
(105584, 3651088896, 3651098111, 'DE', 'DEU', 'ألمانيا'),
(105585, 3651098112, 3651098367, 'IE', 'IRL', 'إيرلندا'),
(105586, 3651098368, 3651098623, 'FR', 'FRA', 'فرنسا'),
(105587, 3651098624, 3651101439, 'DE', 'DEU', 'ألمانيا'),
(105588, 3651101440, 3651101695, 'FR', 'FRA', 'فرنسا'),
(105589, 3651101696, 3651101951, 'CH', 'CHE', 'سويسرا'),
(105590, 3651101952, 3651102207, 'FR', 'FRA', 'فرنسا'),
(105591, 3651102208, 3651102719, 'DE', 'DEU', 'ألمانيا'),
(105592, 3651102720, 3651102975, 'GB', 'GBR', 'المملكة المتحدة'),
(105593, 3651102976, 3651103231, 'SL', 'SLE', 'سيراليون'),
(105594, 3651103232, 3651103487, 'IT', 'ITA', 'إيطاليا'),
(105595, 3651103488, 3651103743, 'FR', 'FRA', 'فرنسا'),
(105596, 3651103744, 3651103999, 'IT', 'ITA', 'إيطاليا'),
(105597, 3651104000, 3651104511, 'DE', 'DEU', 'ألمانيا'),
(105598, 3651104512, 3651104767, 'PL', 'POL', 'بولندا'),
(105599, 3651104768, 3651105535, 'DE', 'DEU', 'ألمانيا'),
(105600, 3651105536, 3651105791, 'IT', 'ITA', 'إيطاليا'),
(105601, 3651105792, 3651106047, 'ES', 'ESP', 'إسبانيا'),
(105602, 3651106048, 3651106559, 'GB', 'GBR', 'المملكة المتحدة'),
(105603, 3651106560, 3651106815, 'IE', 'IRL', 'إيرلندا'),
(105604, 3651106816, 3651107327, 'DE', 'DEU', 'ألمانيا'),
(105605, 3651107328, 3651107583, 'GB', 'GBR', 'المملكة المتحدة'),
(105606, 3651107584, 3651107839, 'NL', 'NLD', 'هولندا'),
(105607, 3651107840, 3651107967, 'GB', 'GBR', 'المملكة المتحدة'),
(105608, 3651107968, 3651108351, 'IE', 'IRL', 'إيرلندا'),
(105609, 3651108352, 3651108479, 'NL', 'NLD', 'هولندا'),
(105610, 3651108480, 3651108543, 'ES', 'ESP', 'إسبانيا'),
(105611, 3651108544, 3651108863, 'DE', 'DEU', 'ألمانيا'),
(105612, 3651108864, 3651141631, 'EE', 'EST', 'إستونيا'),
(105613, 3651141632, 3651173375, 'DE', 'DEU', 'ألمانيا'),
(105614, 3651173376, 3651173631, 'ES', 'ESP', 'إسبانيا'),
(105615, 3651173632, 3651199999, 'DE', 'DEU', 'ألمانيا'),
(105616, 3651200000, 3651200255, 'ES', 'ESP', 'إسبانيا'),
(105617, 3651200256, 3651201023, 'PL', 'POL', 'بولندا'),
(105618, 3651201024, 3651201279, 'ES', 'ESP', 'إسبانيا'),
(105619, 3651201280, 3651201535, 'PL', 'POL', 'بولندا'),
(105620, 3651201536, 3651201791, 'ES', 'ESP', 'إسبانيا'),
(105621, 3651201792, 3651201919, 'FR', 'FRA', 'فرنسا'),
(105622, 3651201920, 3651202047, 'ES', 'ESP', 'إسبانيا'),
(105623, 3651202048, 3651202175, 'FR', 'FRA', 'فرنسا'),
(105624, 3651202176, 3651202303, 'GB', 'GBR', 'المملكة المتحدة'),
(105625, 3651202304, 3651202815, 'ES', 'ESP', 'إسبانيا'),
(105626, 3651202816, 3651203071, 'GB', 'GBR', 'المملكة المتحدة'),
(105627, 3651203072, 3651207167, 'US', 'USA', 'الولايات المتحدة'),
(105628, 3651207168, 3651207199, 'GB', 'GBR', 'المملكة المتحدة'),
(105629, 3651207224, 3651207295, 'GB', 'GBR', 'المملكة المتحدة'),
(105630, 3651207424, 3651207615, 'GB', 'GBR', 'المملكة المتحدة'),
(105631, 3651207648, 3651208959, 'GB', 'GBR', 'المملكة المتحدة'),
(105632, 3651209216, 3651209231, 'US', 'USA', 'الولايات المتحدة'),
(105633, 3651209232, 3651209239, 'GB', 'GBR', 'المملكة المتحدة'),
(105634, 3651209240, 3651209243, 'DE', 'DEU', 'ألمانيا'),
(105635, 3651209472, 3651210751, 'GB', 'GBR', 'المملكة المتحدة'),
(105636, 3651211264, 3651211775, 'IR', 'IRN', 'إيران'),
(105637, 3651213824, 3651214207, 'US', 'USA', 'الولايات المتحدة'),
(105638, 3651215360, 3651215395, 'GB', 'GBR', 'المملكة المتحدة'),
(105639, 3651215616, 3651215871, 'GB', 'GBR', 'المملكة المتحدة'),
(105640, 3651217408, 3651217535, 'GI', 'GIB', 'جبل طارق'),
(105641, 3651219456, 3651219967, 'US', 'USA', 'الولايات المتحدة'),
(105642, 3651220384, 3651220479, 'GB', 'GBR', 'المملكة المتحدة'),
(105643, 3651221504, 3651221695, 'GB', 'GBR', 'المملكة المتحدة'),
(105644, 3651223552, 3651223567, 'GB', 'GBR', 'المملكة المتحدة'),
(105645, 3651223584, 3651223607, 'GB', 'GBR', 'المملكة المتحدة'),
(105646, 3651223648, 3651223663, 'ES', 'ESP', 'إسبانيا'),
(105647, 3651227136, 3651227391, 'GB', 'GBR', 'المملكة المتحدة'),
(105648, 3651230720, 3651231743, 'MU', 'MUS', 'موريشيوس'),
(105649, 3651232256, 3651232287, 'GB', 'GBR', 'المملكة المتحدة'),
(105650, 3651232320, 3651232383, 'GB', 'GBR', 'المملكة المتحدة'),
(105651, 3651232448, 3651232511, 'GB', 'GBR', 'المملكة المتحدة'),
(105652, 3651233792, 3651233855, 'GB', 'GBR', 'المملكة المتحدة'),
(105653, 3651236032, 3651236063, 'GB', 'GBR', 'المملكة المتحدة'),
(105654, 3651236864, 3651237631, 'SC', 'SYC', 'سيشيل'),
(105655, 3651237888, 3651238399, 'SC', 'SYC', 'سيشيل'),
(105656, 3651239936, 3651272703, 'GB', 'GBR', 'المملكة المتحدة'),
(105657, 3651272704, 3651338239, 'CH', 'CHE', 'سويسرا'),
(105658, 3651338240, 3651403775, 'GB', 'GBR', 'المملكة المتحدة'),
(105659, 3651403776, 3651534847, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(105660, 3651534848, 3651600383, 'NL', 'NLD', 'هولندا'),
(105661, 3651600384, 3651636696, 'FR', 'FRA', 'فرنسا'),
(105662, 3651636697, 3651636697, 'GB', 'GBR', 'المملكة المتحدة'),
(105663, 3651636698, 3651665919, 'FR', 'FRA', 'فرنسا'),
(105664, 3651665920, 3651670015, 'ES', 'ESP', 'إسبانيا'),
(105665, 3651670016, 3651674111, 'GB', 'GBR', 'المملكة المتحدة'),
(105666, 3651674112, 3651682303, 'CH', 'CHE', 'سويسرا'),
(105667, 3651682304, 3651686399, 'RU', 'RUS', 'الإتحاد الروسي'),
(105668, 3651686400, 3651690495, 'NO', 'NOR', 'النرويج'),
(105669, 3651690496, 3651694591, 'FR', 'FRA', 'فرنسا'),
(105670, 3651694592, 3651694719, 'GH', 'GHA', 'غانا'),
(105671, 3651694720, 3651694847, 'PT', 'PRT', 'البورتوغال'),
(105672, 3651694848, 3651694975, 'NG', 'NGA', 'نيجيريا'),
(105673, 3651694976, 3651695103, 'PT', 'PRT', 'البورتوغال'),
(105674, 3651695104, 3651695359, 'CV', 'CPV', 'الرأس الأخضر'),
(105675, 3651695360, 3651695871, 'AO', 'AGO', 'أنغولا'),
(105676, 3651695872, 3651696639, 'PT', 'PRT', 'البورتوغال'),
(105677, 3651696640, 3651698687, 'AO', 'AGO', 'أنغولا'),
(105678, 3651698688, 3651702783, 'PL', 'POL', 'بولندا'),
(105679, 3651702784, 3651706879, 'GB', 'GBR', 'المملكة المتحدة'),
(105680, 3651706880, 3651710975, 'MT', 'MLT', 'مالطا'),
(105681, 3651710976, 3651715071, 'AZ', 'AZE', 'أذربيجان'),
(105682, 3651715072, 3651719167, 'PL', 'POL', 'بولندا'),
(105683, 3651719168, 3651723263, 'CZ', 'CZE', 'التشيك'),
(105684, 3651723264, 3651727359, 'IT', 'ITA', 'إيطاليا'),
(105685, 3651727360, 3651731455, 'RU', 'RUS', 'الإتحاد الروسي'),
(105686, 3651731456, 3651747839, 'GB', 'GBR', 'المملكة المتحدة'),
(105687, 3651747840, 3651751935, 'FI', 'FIN', 'فنلندا'),
(105688, 3651751936, 3651756031, 'RU', 'RUS', 'الإتحاد الروسي'),
(105689, 3651756032, 3651764223, 'IT', 'ITA', 'إيطاليا'),
(105690, 3651764224, 3651764679, 'CH', 'CHE', 'سويسرا'),
(105691, 3651764680, 3651764687, 'FR', 'FRA', 'فرنسا'),
(105692, 3651764688, 3651772415, 'CH', 'CHE', 'سويسرا'),
(105693, 3651772416, 3651776511, 'GB', 'GBR', 'المملكة المتحدة'),
(105694, 3651776512, 3651780607, 'CZ', 'CZE', 'التشيك'),
(105695, 3651780608, 3651784703, 'TR', 'TUR', 'تركيا'),
(105696, 3651784704, 3651785215, 'RS', 'SRB', 'صربيا'),
(105697, 3651785216, 3651785227, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105698, 3651785228, 3651785239, 'RS', 'SRB', 'صربيا'),
(105699, 3651785240, 3651785271, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105700, 3651785272, 3651785279, 'RS', 'SRB', 'صربيا'),
(105701, 3651785280, 3651785295, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105702, 3651785296, 3651785303, 'RS', 'SRB', 'صربيا'),
(105703, 3651785304, 3651785311, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105704, 3651785312, 3651785319, 'RS', 'SRB', 'صربيا'),
(105705, 3651785320, 3651785327, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105706, 3651785328, 3651785335, 'RS', 'SRB', 'صربيا'),
(105707, 3651785336, 3651785351, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105708, 3651785352, 3651785359, 'RS', 'SRB', 'صربيا'),
(105709, 3651785360, 3651785391, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105710, 3651785392, 3651785399, 'RS', 'SRB', 'صربيا'),
(105711, 3651785400, 3651785415, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105712, 3651785416, 3651785419, 'RS', 'SRB', 'صربيا'),
(105713, 3651785420, 3651785455, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105714, 3651785456, 3651785499, 'RS', 'SRB', 'صربيا'),
(105715, 3651785500, 3651785503, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105716, 3651785504, 3651785527, 'RS', 'SRB', 'صربيا'),
(105717, 3651785528, 3651785535, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105718, 3651785536, 3651785555, 'RS', 'SRB', 'صربيا'),
(105719, 3651785556, 3651785559, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105720, 3651785560, 3651785563, 'RS', 'SRB', 'صربيا'),
(105721, 3651785564, 3651785591, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105722, 3651785592, 3651785603, 'RS', 'SRB', 'صربيا'),
(105723, 3651785604, 3651785611, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105724, 3651785612, 3651785615, 'RS', 'SRB', 'صربيا'),
(105725, 3651785616, 3651785623, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105726, 3651785624, 3651785627, 'RS', 'SRB', 'صربيا'),
(105727, 3651785628, 3651785631, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105728, 3651785632, 3651785635, 'RS', 'SRB', 'صربيا'),
(105729, 3651785636, 3651785647, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105730, 3651785648, 3651785655, 'RS', 'SRB', 'صربيا'),
(105731, 3651785656, 3651785659, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105732, 3651785660, 3651785663, 'RS', 'SRB', 'صربيا'),
(105733, 3651785664, 3651785687, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105734, 3651785688, 3651785691, 'RS', 'SRB', 'صربيا'),
(105735, 3651785692, 3651785699, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105736, 3651785700, 3651785703, 'RS', 'SRB', 'صربيا'),
(105737, 3651785704, 3651785707, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105738, 3651785708, 3651785711, 'RS', 'SRB', 'صربيا'),
(105739, 3651785712, 3651785719, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105740, 3651785720, 3651787615, 'RS', 'SRB', 'صربيا'),
(105741, 3651787616, 3651787711, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105742, 3651787712, 3651787743, 'RS', 'SRB', 'صربيا'),
(105743, 3651787744, 3651787759, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105744, 3651787760, 3651787791, 'RS', 'SRB', 'صربيا'),
(105745, 3651787792, 3651787799, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105746, 3651787800, 3651787839, 'RS', 'SRB', 'صربيا'),
(105747, 3651787840, 3651787863, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105748, 3651787864, 3651787875, 'RS', 'SRB', 'صربيا'),
(105749, 3651787876, 3651787879, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105750, 3651787880, 3651787887, 'RS', 'SRB', 'صربيا'),
(105751, 3651787888, 3651787891, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105752, 3651787892, 3651787895, 'RS', 'SRB', 'صربيا'),
(105753, 3651787896, 3651787903, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105754, 3651787904, 3651787911, 'RS', 'SRB', 'صربيا'),
(105755, 3651787912, 3651787939, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105756, 3651787940, 3651787943, 'RS', 'SRB', 'صربيا'),
(105757, 3651787944, 3651788039, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105758, 3651788040, 3651788043, 'RS', 'SRB', 'صربيا'),
(105759, 3651788044, 3651788059, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105760, 3651788060, 3651788063, 'RS', 'SRB', 'صربيا'),
(105761, 3651788064, 3651788095, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105762, 3651788096, 3651788175, 'RS', 'SRB', 'صربيا'),
(105763, 3651788176, 3651788183, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105764, 3651788184, 3651788207, 'RS', 'SRB', 'صربيا'),
(105765, 3651788208, 3651788239, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105766, 3651788240, 3651788251, 'RS', 'SRB', 'صربيا'),
(105767, 3651788252, 3651788255, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105768, 3651788256, 3651788263, 'RS', 'SRB', 'صربيا'),
(105769, 3651788264, 3651788279, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105770, 3651788280, 3651788543, 'RS', 'SRB', 'صربيا'),
(105771, 3651788544, 3651788799, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105772, 3651788800, 3651792895, 'NL', 'NLD', 'هولندا'),
(105773, 3651792896, 3651796991, 'FR', 'FRA', 'فرنسا'),
(105774, 3651796992, 3651813375, 'NL', 'NLD', 'هولندا'),
(105775, 3651813376, 3651821567, 'RU', 'RUS', 'الإتحاد الروسي'),
(105776, 3651821568, 3651825663, 'CZ', 'CZE', 'التشيك'),
(105777, 3651825664, 3651829759, 'RU', 'RUS', 'الإتحاد الروسي'),
(105778, 3651829760, 3651833855, 'NO', 'NOR', 'النرويج'),
(105779, 3651837952, 3651842047, 'PL', 'POL', 'بولندا'),
(105780, 3651842048, 3651846143, 'DE', 'DEU', 'ألمانيا'),
(105781, 3651846144, 3651850239, 'NO', 'NOR', 'النرويج'),
(105782, 3651850240, 3651854335, 'RU', 'RUS', 'الإتحاد الروسي'),
(105783, 3651854336, 3651858431, 'IT', 'ITA', 'إيطاليا'),
(105784, 3651858432, 3651862527, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(105785, 3651862528, 3651866623, 'RU', 'RUS', 'الإتحاد الروسي'),
(105786, 3651866624, 3651870719, 'FR', 'FRA', 'فرنسا'),
(105787, 3651870720, 3651874815, 'IT', 'ITA', 'إيطاليا'),
(105788, 3651874816, 3651878911, 'PL', 'POL', 'بولندا'),
(105789, 3651878912, 3651883007, 'RU', 'RUS', 'الإتحاد الروسي'),
(105790, 3651883008, 3651885823, 'BE', 'BEL', 'بلجيكا'),
(105791, 3651885824, 3651885843, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105792, 3651885844, 3651885851, 'BE', 'BEL', 'بلجيكا'),
(105793, 3651885852, 3651885855, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105794, 3651885856, 3651885867, 'BE', 'BEL', 'بلجيكا'),
(105795, 3651885868, 3651885875, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105796, 3651885876, 3651885903, 'BE', 'BEL', 'بلجيكا'),
(105797, 3651885904, 3651885919, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105798, 3651885920, 3651886335, 'BE', 'BEL', 'بلجيكا'),
(105799, 3651886336, 3651886347, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105800, 3651886348, 3651886367, 'BE', 'BEL', 'بلجيكا'),
(105801, 3651886368, 3651886383, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105802, 3651886384, 3651886387, 'BE', 'BEL', 'بلجيكا'),
(105803, 3651886388, 3651886395, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105804, 3651886396, 3651886399, 'BE', 'BEL', 'بلجيكا'),
(105805, 3651886400, 3651886403, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105806, 3651886404, 3651886431, 'BE', 'BEL', 'بلجيكا'),
(105807, 3651886432, 3651886451, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105808, 3651886452, 3651886455, 'BE', 'BEL', 'بلجيكا'),
(105809, 3651886456, 3651886459, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105810, 3651886460, 3651886463, 'BE', 'BEL', 'بلجيكا'),
(105811, 3651886464, 3651886471, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105812, 3651886472, 3651886479, 'BE', 'BEL', 'بلجيكا'),
(105813, 3651886480, 3651886495, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105814, 3651886496, 3651886511, 'BE', 'BEL', 'بلجيكا'),
(105815, 3651886512, 3651886519, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(105816, 3651886520, 3651887103, 'BE', 'BEL', 'بلجيكا'),
(105817, 3651887104, 3651891199, 'GB', 'GBR', 'المملكة المتحدة'),
(105818, 3651891200, 3651895295, 'DE', 'DEU', 'ألمانيا'),
(105819, 3651895296, 3651899391, 'GB', 'GBR', 'المملكة المتحدة'),
(105820, 3651899392, 3651903487, 'RU', 'RUS', 'الإتحاد الروسي'),
(105821, 3651903488, 3651907583, 'IT', 'ITA', 'إيطاليا'),
(105822, 3651907584, 3651908991, 'IQ', 'IRQ', 'العراق'),
(105823, 3651908992, 3651909311, 'DE', 'DEU', 'ألمانيا'),
(105824, 3651909312, 3651909375, 'IQ', 'IRQ', 'العراق'),
(105825, 3651909376, 3651909631, 'DE', 'DEU', 'ألمانيا'),
(105826, 3651909632, 3651910655, 'IQ', 'IRQ', 'العراق'),
(105827, 3651910656, 3651910783, 'DE', 'DEU', 'ألمانيا'),
(105828, 3651910784, 3651911167, 'IQ', 'IRQ', 'العراق'),
(105829, 3651911168, 3651911623, 'DE', 'DEU', 'ألمانيا'),
(105830, 3651911624, 3651911631, 'IQ', 'IRQ', 'العراق'),
(105831, 3651911632, 3651911643, 'DE', 'DEU', 'ألمانيا'),
(105832, 3651911644, 3651911647, 'IR', 'IRN', 'إيران'),
(105833, 3651911648, 3651911679, 'DE', 'DEU', 'ألمانيا'),
(105834, 3651911680, 3651915775, 'NO', 'NOR', 'النرويج'),
(105835, 3651915776, 3651919871, 'IS', 'ISL', 'أيسلندا'),
(105836, 3651919872, 3651923967, 'RU', 'RUS', 'الإتحاد الروسي'),
(105837, 3651923968, 3651928063, 'DE', 'DEU', 'ألمانيا'),
(105838, 3651928064, 3651932159, 'IT', 'ITA', 'إيطاليا'),
(105839, 3651932160, 3651936255, 'RU', 'RUS', 'الإتحاد الروسي'),
(105840, 3651936256, 3651938175, 'DE', 'DEU', 'ألمانيا'),
(105841, 3651938176, 3651938207, 'GB', 'GBR', 'المملكة المتحدة'),
(105842, 3651938208, 3651938255, 'DE', 'DEU', 'ألمانيا'),
(105843, 3651938256, 3651938271, 'PL', 'POL', 'بولندا'),
(105844, 3651938272, 3651938943, 'DE', 'DEU', 'ألمانيا'),
(105845, 3651938944, 3651938959, 'NL', 'NLD', 'هولندا'),
(105846, 3651938960, 3651938975, 'DE', 'DEU', 'ألمانيا'),
(105847, 3651938976, 3651939007, 'TR', 'TUR', 'تركيا'),
(105848, 3651939008, 3651939071, 'DE', 'DEU', 'ألمانيا'),
(105849, 3651939072, 3651939087, 'SE', 'SWE', 'السويد'),
(105850, 3651939088, 3651939135, 'DE', 'DEU', 'ألمانيا'),
(105851, 3651939136, 3651939151, 'PL', 'POL', 'بولندا'),
(105852, 3651939152, 3651939167, 'DE', 'DEU', 'ألمانيا'),
(105853, 3651939168, 3651939231, 'GB', 'GBR', 'المملكة المتحدة'),
(105854, 3651939232, 3651939263, 'DE', 'DEU', 'ألمانيا'),
(105855, 3651939264, 3651939295, 'IT', 'ITA', 'إيطاليا'),
(105856, 3651939296, 3651939327, 'PL', 'POL', 'بولندا'),
(105857, 3651939328, 3651939391, 'IT', 'ITA', 'إيطاليا'),
(105858, 3651939392, 3651939503, 'DE', 'DEU', 'ألمانيا'),
(105859, 3651939504, 3651939511, 'GB', 'GBR', 'المملكة المتحدة'),
(105860, 3651939512, 3651939519, 'DE', 'DEU', 'ألمانيا'),
(105861, 3651939520, 3651939527, 'RU', 'RUS', 'الإتحاد الروسي'),
(105862, 3651939528, 3651939583, 'PL', 'POL', 'بولندا'),
(105863, 3651939584, 3651939647, 'DE', 'DEU', 'ألمانيا'),
(105864, 3651939648, 3651939711, 'ES', 'ESP', 'إسبانيا'),
(105865, 3651939712, 3651939727, 'DE', 'DEU', 'ألمانيا'),
(105866, 3651939728, 3651939743, 'PL', 'POL', 'بولندا'),
(105867, 3651939744, 3651939791, 'DE', 'DEU', 'ألمانيا'),
(105868, 3651939792, 3651939799, 'RU', 'RUS', 'الإتحاد الروسي'),
(105869, 3651939800, 3651940351, 'DE', 'DEU', 'ألمانيا'),
(105870, 3651940352, 3651940383, 'TR', 'TUR', 'تركيا'),
(105871, 3651940384, 3651940415, 'US', 'USA', 'الولايات المتحدة'),
(105872, 3651940416, 3651940479, 'IT', 'ITA', 'إيطاليا'),
(105873, 3651940480, 3651940543, 'GB', 'GBR', 'المملكة المتحدة'),
(105874, 3651940544, 3651940639, 'DE', 'DEU', 'ألمانيا'),
(105875, 3651940640, 3651940671, 'BS', 'BHS', 'جزر البهاما'),
(105876, 3651940672, 3651940735, 'DE', 'DEU', 'ألمانيا'),
(105877, 3651940736, 3651940743, 'AU', 'AUS', 'أستراليا'),
(105878, 3651940744, 3651940751, 'RU', 'RUS', 'الإتحاد الروسي'),
(105879, 3651940752, 3651940799, 'DE', 'DEU', 'ألمانيا'),
(105880, 3651940800, 3651940863, 'ES', 'ESP', 'إسبانيا'),
(105881, 3651940864, 3651940927, 'GB', 'GBR', 'المملكة المتحدة'),
(105882, 3651940928, 3651940991, 'IT', 'ITA', 'إيطاليا'),
(105883, 3651940992, 3651941027, 'DE', 'DEU', 'ألمانيا'),
(105884, 3651941028, 3651941055, 'TR', 'TUR', 'تركيا'),
(105885, 3651941056, 3651941087, 'DE', 'DEU', 'ألمانيا'),
(105886, 3651941088, 3651941119, 'GB', 'GBR', 'المملكة المتحدة'),
(105887, 3651941120, 3651941183, 'DE', 'DEU', 'ألمانيا'),
(105888, 3651941184, 3651941215, 'IT', 'ITA', 'إيطاليا'),
(105889, 3651941216, 3651941249, 'TR', 'TUR', 'تركيا'),
(105890, 3651941250, 3651941695, 'DE', 'DEU', 'ألمانيا'),
(105891, 3651941696, 3651941759, 'IT', 'ITA', 'إيطاليا'),
(105892, 3651941760, 3651942655, 'DE', 'DEU', 'ألمانيا'),
(105893, 3651942656, 3651942719, 'GB', 'GBR', 'المملكة المتحدة'),
(105894, 3651942720, 3651942735, 'SE', 'SWE', 'السويد'),
(105895, 3651942736, 3651942751, 'US', 'USA', 'الولايات المتحدة'),
(105896, 3651942752, 3651942783, 'DE', 'DEU', 'ألمانيا'),
(105897, 3651942784, 3651942815, 'GB', 'GBR', 'المملكة المتحدة'),
(105898, 3651942816, 3651944447, 'DE', 'DEU', 'ألمانيا'),
(105899, 3651944448, 3651948543, 'ES', 'ESP', 'إسبانيا'),
(105900, 3651948544, 3651952639, 'FO', 'FRO', 'جزر فارو'),
(105901, 3651952640, 3651954175, 'IR', 'IRN', 'إيران'),
(105902, 3651954176, 3651954431, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(105903, 3651954432, 3651958271, 'IR', 'IRN', 'إيران'),
(105904, 3651958272, 3651958783, 'UA', 'UKR', 'أوكرانيا'),
(105905, 3651958784, 3651960831, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(105906, 3651960832, 3651964927, 'GB', 'GBR', 'المملكة المتحدة'),
(105907, 3651964928, 3651969023, 'SK', 'SVK', 'سلوفاكيا'),
(105908, 3651969024, 3651977215, 'DE', 'DEU', 'ألمانيا'),
(105909, 3651977216, 3651985407, 'IT', 'ITA', 'إيطاليا'),
(105910, 3651985408, 3651993599, 'PL', 'POL', 'بولندا'),
(105911, 3651993600, 3652001791, 'RU', 'RUS', 'الإتحاد الروسي'),
(105912, 3652001792, 3652005887, 'HU', 'HUN', 'هنغاريا'),
(105913, 3652005888, 3652009983, 'GB', 'GBR', 'المملكة المتحدة'),
(105914, 3652009984, 3652014079, 'RU', 'RUS', 'الإتحاد الروسي'),
(105915, 3652014080, 3652018175, 'SA', 'SAU', 'السعودية'),
(105916, 3652018176, 3652018239, 'IE', 'IRL', 'إيرلندا'),
(105917, 3652018240, 3652018303, 'GB', 'GBR', 'المملكة المتحدة'),
(105918, 3652018304, 3652018687, 'IE', 'IRL', 'إيرلندا'),
(105919, 3652018688, 3652018943, 'GB', 'GBR', 'المملكة المتحدة'),
(105920, 3652018944, 3652019169, 'IE', 'IRL', 'إيرلندا'),
(105921, 3652019170, 3652019199, 'GB', 'GBR', 'المملكة المتحدة'),
(105922, 3652019200, 3652019455, 'IE', 'IRL', 'إيرلندا'),
(105923, 3652019456, 3652019567, 'GB', 'GBR', 'المملكة المتحدة'),
(105924, 3652019568, 3652019663, 'IE', 'IRL', 'إيرلندا'),
(105925, 3652019664, 3652019679, 'GB', 'GBR', 'المملكة المتحدة'),
(105926, 3652019680, 3652019687, 'IE', 'IRL', 'إيرلندا'),
(105927, 3652019688, 3652019695, 'GB', 'GBR', 'المملكة المتحدة'),
(105928, 3652019696, 3652019711, 'IE', 'IRL', 'إيرلندا'),
(105929, 3652019712, 3652019751, 'GB', 'GBR', 'المملكة المتحدة'),
(105930, 3652019752, 3652019759, 'IE', 'IRL', 'إيرلندا'),
(105931, 3652019760, 3652019775, 'GB', 'GBR', 'المملكة المتحدة'),
(105932, 3652019776, 3652019791, 'IE', 'IRL', 'إيرلندا'),
(105933, 3652019792, 3652019807, 'GB', 'GBR', 'المملكة المتحدة'),
(105934, 3652019808, 3652019815, 'IE', 'IRL', 'إيرلندا'),
(105935, 3652019816, 3652019887, 'GB', 'GBR', 'المملكة المتحدة'),
(105936, 3652019888, 3652019935, 'IE', 'IRL', 'إيرلندا'),
(105937, 3652019936, 3652019951, 'GB', 'GBR', 'المملكة المتحدة'),
(105938, 3652019952, 3652020223, 'IE', 'IRL', 'إيرلندا'),
(105939, 3652020224, 3652020479, 'GB', 'GBR', 'المملكة المتحدة'),
(105940, 3652020480, 3652020735, 'IE', 'IRL', 'إيرلندا'),
(105941, 3652020736, 3652020767, 'GB', 'GBR', 'المملكة المتحدة'),
(105942, 3652020768, 3652020799, 'IE', 'IRL', 'إيرلندا'),
(105943, 3652020800, 3652020863, 'DE', 'DEU', 'ألمانيا'),
(105944, 3652020864, 3652020959, 'IE', 'IRL', 'إيرلندا'),
(105945, 3652020960, 3652021791, 'GB', 'GBR', 'المملكة المتحدة'),
(105946, 3652021792, 3652021887, 'IE', 'IRL', 'إيرلندا'),
(105947, 3652021888, 3652022271, 'GB', 'GBR', 'المملكة المتحدة'),
(105948, 3652022272, 3652026367, 'ES', 'ESP', 'إسبانيا'),
(105949, 3652026368, 3652028031, 'DE', 'DEU', 'ألمانيا'),
(105950, 3652028032, 3652028063, 'US', 'USA', 'الولايات المتحدة'),
(105951, 3652028064, 3652028095, 'CH', 'CHE', 'سويسرا'),
(105952, 3652028096, 3652028223, 'DE', 'DEU', 'ألمانيا'),
(105953, 3652028224, 3652028255, 'ES', 'ESP', 'إسبانيا'),
(105954, 3652028256, 3652031743, 'DE', 'DEU', 'ألمانيا'),
(105955, 3652031744, 3652031999, 'US', 'USA', 'الولايات المتحدة'),
(105956, 3652032000, 3652032767, 'DE', 'DEU', 'ألمانيا'),
(105957, 3652032768, 3652033791, 'NL', 'NLD', 'هولندا'),
(105958, 3652033792, 3652033855, 'GD', 'GRD', 'غرينادا'),
(105959, 3652033856, 3652033887, 'NL', 'NLD', 'هولندا'),
(105960, 3652033888, 3652033919, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(105961, 3652033920, 3652033935, 'TR', 'TUR', 'تركيا'),
(105962, 3652033936, 3652033951, 'DE', 'DEU', 'ألمانيا'),
(105963, 3652033952, 3652033967, 'CH', 'CHE', 'سويسرا'),
(105964, 3652033968, 3652033983, 'NL', 'NLD', 'هولندا'),
(105965, 3652033984, 3652034015, 'TR', 'TUR', 'تركيا'),
(105966, 3652034016, 3652034047, 'NL', 'NLD', 'هولندا'),
(105967, 3652034048, 3652034111, 'GD', 'GRD', 'غرينادا'),
(105968, 3652034112, 3652034143, 'TR', 'TUR', 'تركيا'),
(105969, 3652034144, 3652034175, 'CH', 'CHE', 'سويسرا'),
(105970, 3652034176, 3652034207, 'NL', 'NLD', 'هولندا'),
(105971, 3652034208, 3652034239, 'ES', 'ESP', 'إسبانيا'),
(105972, 3652034240, 3652034271, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(105973, 3652034272, 3652034367, 'GD', 'GRD', 'غرينادا'),
(105974, 3652034368, 3652034383, 'ES', 'ESP', 'إسبانيا'),
(105975, 3652034384, 3652034399, 'VG', 'VGB', 'جزر فيرجن البريطانية'),
(105976, 3652034400, 3652034559, 'GD', 'GRD', 'غرينادا'),
(105977, 3652034560, 3652046847, 'PL', 'POL', 'بولندا'),
(105978, 3652046848, 3652050499, 'IE', 'IRL', 'إيرلندا'),
(105979, 3652050500, 3652050503, 'GB', 'GBR', 'المملكة المتحدة'),
(105980, 3652050504, 3652050527, 'IE', 'IRL', 'إيرلندا'),
(105981, 3652050528, 3652050535, 'GB', 'GBR', 'المملكة المتحدة');
INSERT INTO `%%TBL-PREFIX%%base_geolocation_ip_to_country` (`id`, `ipFrom`, `ipTo`, `cc2`, `cc3`, `name`) VALUES
(105982, 3652050536, 3652050567, 'IE', 'IRL', 'إيرلندا'),
(105983, 3652050568, 3652050615, 'GB', 'GBR', 'المملكة المتحدة'),
(105984, 3652050616, 3652050619, 'IE', 'IRL', 'إيرلندا'),
(105985, 3652050620, 3652050671, 'GB', 'GBR', 'المملكة المتحدة'),
(105986, 3652050672, 3652050787, 'IE', 'IRL', 'إيرلندا'),
(105987, 3652050788, 3652050791, 'GB', 'GBR', 'المملكة المتحدة'),
(105988, 3652050792, 3652050943, 'IE', 'IRL', 'إيرلندا'),
(105989, 3652050944, 3652055039, 'LI', 'LIE', 'ليختنشتاين'),
(105990, 3652055040, 3652059135, 'NO', 'NOR', 'النرويج'),
(105991, 3652059136, 3652063231, 'RU', 'RUS', 'الإتحاد الروسي'),
(105992, 3652063232, 3652067327, 'IR', 'IRN', 'إيران'),
(105993, 3652067328, 3652071423, 'TR', 'TUR', 'تركيا'),
(105994, 3652071424, 3652075519, 'BG', 'BGR', 'بلغاريا'),
(105995, 3652075520, 3652083711, 'SE', 'SWE', 'السويد'),
(105996, 3652083712, 3652087807, 'RU', 'RUS', 'الإتحاد الروسي'),
(105997, 3652087808, 3652095999, 'IT', 'ITA', 'إيطاليا'),
(105998, 3652096000, 3652100095, 'BG', 'BGR', 'بلغاريا'),
(105999, 3652100096, 3652105471, 'RU', 'RUS', 'الإتحاد الروسي'),
(106000, 3652105472, 3652105535, 'US', 'USA', 'الولايات المتحدة'),
(106001, 3652105536, 3652108287, 'RU', 'RUS', 'الإتحاد الروسي'),
(106002, 3652108288, 3652116479, 'FR', 'FRA', 'فرنسا'),
(106003, 3652116480, 3652120575, 'TM', 'TKM', 'تركمينيستان'),
(106004, 3652120576, 3652124671, 'GB', 'GBR', 'المملكة المتحدة'),
(106005, 3652124672, 3652128767, 'UA', 'UKR', 'أوكرانيا'),
(106006, 3652128768, 3652136959, 'RU', 'RUS', 'الإتحاد الروسي'),
(106007, 3652136960, 3652141055, 'IT', 'ITA', 'إيطاليا'),
(106008, 3652141056, 3652144127, 'GB', 'GBR', 'المملكة المتحدة'),
(106009, 3652144128, 3652144383, 'KE', 'KEN', 'كينيا'),
(106010, 3652144384, 3652145151, 'GB', 'GBR', 'المملكة المتحدة'),
(106011, 3652145152, 3652149247, 'UA', 'UKR', 'أوكرانيا'),
(106012, 3652149248, 3652153343, 'DE', 'DEU', 'ألمانيا'),
(106013, 3652153344, 3652157439, 'SE', 'SWE', 'السويد'),
(106014, 3652157440, 3652165631, 'RU', 'RUS', 'الإتحاد الروسي'),
(106015, 3652165632, 3652173823, 'FR', 'FRA', 'فرنسا'),
(106016, 3652173824, 3652177919, 'AT', 'AUT', 'النمسا'),
(106017, 3652177920, 3652182015, 'CY', 'CYP', 'قبرص'),
(106018, 3652182016, 3652182527, 'DE', 'DEU', 'ألمانيا'),
(106019, 3652182528, 3652182783, 'AT', 'AUT', 'النمسا'),
(106020, 3652182784, 3652186591, 'DE', 'DEU', 'ألمانيا'),
(106021, 3652186592, 3652186623, 'CH', 'CHE', 'سويسرا'),
(106022, 3652186624, 3652186879, 'DE', 'DEU', 'ألمانيا'),
(106023, 3652186880, 3652187007, 'AT', 'AUT', 'النمسا'),
(106024, 3652187008, 3652190207, 'DE', 'DEU', 'ألمانيا'),
(106025, 3652190208, 3652714495, 'GB', 'GBR', 'المملكة المتحدة'),
(106026, 3652714496, 3652984927, 'DE', 'DEU', 'ألمانيا'),
(106027, 3652984928, 3652984935, 'NL', 'NLD', 'هولندا'),
(106028, 3652984936, 3652985039, 'DE', 'DEU', 'ألمانيا'),
(106029, 3652985040, 3652985047, 'FR', 'FRA', 'فرنسا'),
(106030, 3652985048, 3653039103, 'DE', 'DEU', 'ألمانيا'),
(106031, 3653039104, 3653039359, 'IT', 'ITA', 'إيطاليا'),
(106032, 3653039360, 3653238783, 'DE', 'DEU', 'ألمانيا'),
(106033, 3653238784, 3653334141, 'CH', 'CHE', 'سويسرا'),
(106034, 3653334142, 3653334142, 'AT', 'AUT', 'النمسا'),
(106035, 3653334143, 3653341871, 'CH', 'CHE', 'سويسرا'),
(106036, 3653341872, 3653341879, 'AT', 'AUT', 'النمسا'),
(106037, 3653341880, 3653369855, 'CH', 'CHE', 'سويسرا'),
(106038, 3653369856, 3653373951, 'IT', 'ITA', 'إيطاليا'),
(106039, 3653373952, 3653378047, 'NL', 'NLD', 'هولندا'),
(106040, 3653378048, 3653382143, 'DE', 'DEU', 'ألمانيا'),
(106041, 3653382144, 3653386239, 'CH', 'CHE', 'سويسرا'),
(106042, 3653386240, 3653390335, 'DE', 'DEU', 'ألمانيا'),
(106043, 3653390336, 3653394431, 'FR', 'FRA', 'فرنسا'),
(106044, 3653394432, 3653402623, 'NL', 'NLD', 'هولندا'),
(106045, 3653402624, 3653403135, 'AT', 'AUT', 'النمسا'),
(106046, 3653403136, 3653403647, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(106047, 3653403648, 3653403903, 'ZW', 'ZWE', 'زمبابواي'),
(106048, 3653403904, 3653403911, 'UA', 'UKR', 'أوكرانيا'),
(106049, 3653403912, 3653403919, 'IQ', 'IRQ', 'العراق'),
(106050, 3653403920, 3653403931, 'UA', 'UKR', 'أوكرانيا'),
(106051, 3653403932, 3653403935, 'GB', 'GBR', 'المملكة المتحدة'),
(106052, 3653403936, 3653403943, 'IQ', 'IRQ', 'العراق'),
(106053, 3653403944, 3653403951, 'LB', 'LBN', 'لبنان'),
(106054, 3653403952, 3653403959, 'IQ', 'IRQ', 'العراق'),
(106055, 3653403960, 3653403967, 'MW', 'MWI', 'ملاوي'),
(106056, 3653403968, 3653403983, 'NG', 'NGA', 'نيجيريا'),
(106057, 3653403984, 3653403999, 'UA', 'UKR', 'أوكرانيا'),
(106058, 3653404000, 3653404008, 'LB', 'LBN', 'لبنان'),
(106059, 3653404009, 3653404015, 'GB', 'GBR', 'المملكة المتحدة'),
(106060, 3653404016, 3653404023, 'LB', 'LBN', 'لبنان'),
(106061, 3653404024, 3653404039, 'GB', 'GBR', 'المملكة المتحدة'),
(106062, 3653404040, 3653404055, 'IQ', 'IRQ', 'العراق'),
(106063, 3653404056, 3653404063, 'GB', 'GBR', 'المملكة المتحدة'),
(106064, 3653404064, 3653404071, 'LB', 'LBN', 'لبنان'),
(106065, 3653404072, 3653404079, 'AO', 'AGO', 'أنغولا'),
(106066, 3653404080, 3653404087, 'UA', 'UKR', 'أوكرانيا'),
(106067, 3653404088, 3653404095, 'LB', 'LBN', 'لبنان'),
(106068, 3653404096, 3653404103, 'IQ', 'IRQ', 'العراق'),
(106069, 3653404104, 3653404111, 'GB', 'GBR', 'المملكة المتحدة'),
(106070, 3653404112, 3653404119, 'MD', 'MDA', 'مولدوفا'),
(106071, 3653404120, 3653404127, 'GB', 'GBR', 'المملكة المتحدة'),
(106072, 3653404128, 3653404135, 'CS', 'SCG', 'صربيا والجبل الأسود'),
(106073, 3653404136, 3653404159, 'GB', 'GBR', 'المملكة المتحدة'),
(106074, 3653404160, 3653404415, 'AT', 'AUT', 'النمسا'),
(106075, 3653404416, 3653404543, 'GB', 'GBR', 'المملكة المتحدة'),
(106076, 3653404544, 3653404559, 'NG', 'NGA', 'نيجيريا'),
(106077, 3653404560, 3653404567, 'IQ', 'IRQ', 'العراق'),
(106078, 3653404568, 3653404575, 'LY', 'LBY', 'ليبيا'),
(106079, 3653404576, 3653404591, 'TR', 'TUR', 'تركيا'),
(106080, 3653404592, 3653404607, 'GB', 'GBR', 'المملكة المتحدة'),
(106081, 3653404608, 3653404655, 'UA', 'UKR', 'أوكرانيا'),
(106082, 3653404656, 3653404671, 'GB', 'GBR', 'المملكة المتحدة'),
(106083, 3653404672, 3653404679, 'TR', 'TUR', 'تركيا'),
(106084, 3653404680, 3653404707, 'GB', 'GBR', 'المملكة المتحدة'),
(106085, 3653404708, 3653404713, 'IQ', 'IRQ', 'العراق'),
(106086, 3653404714, 3653404719, 'GB', 'GBR', 'المملكة المتحدة'),
(106087, 3653404720, 3653404735, 'LB', 'LBN', 'لبنان'),
(106088, 3653404736, 3653404751, 'GB', 'GBR', 'المملكة المتحدة'),
(106089, 3653404752, 3653404759, 'AM', 'ARM', 'أرمينيا'),
(106090, 3653404760, 3653404815, 'GB', 'GBR', 'المملكة المتحدة'),
(106091, 3653404816, 3653404831, 'LB', 'LBN', 'لبنان'),
(106092, 3653404832, 3653404847, 'NG', 'NGA', 'نيجيريا'),
(106093, 3653404848, 3653404855, 'GB', 'GBR', 'المملكة المتحدة'),
(106094, 3653404856, 3653404863, 'SL', 'SLE', 'سيراليون'),
(106095, 3653404864, 3653404871, 'LY', 'LBY', 'ليبيا'),
(106096, 3653404872, 3653404879, 'GB', 'GBR', 'المملكة المتحدة'),
(106097, 3653404880, 3653404887, 'UA', 'UKR', 'أوكرانيا'),
(106098, 3653404888, 3653404903, 'GB', 'GBR', 'المملكة المتحدة'),
(106099, 3653404904, 3653404911, 'IQ', 'IRQ', 'العراق'),
(106100, 3653404912, 3653404919, 'LY', 'LBY', 'ليبيا'),
(106101, 3653404920, 3653404959, 'GB', 'GBR', 'المملكة المتحدة'),
(106102, 3653404960, 3653404975, 'UA', 'UKR', 'أوكرانيا'),
(106103, 3653404976, 3653404983, 'GB', 'GBR', 'المملكة المتحدة'),
(106104, 3653404984, 3653404991, 'AM', 'ARM', 'أرمينيا'),
(106105, 3653404992, 3653404999, 'IQ', 'IRQ', 'العراق'),
(106106, 3653405000, 3653405007, 'GB', 'GBR', 'المملكة المتحدة'),
(106107, 3653405008, 3653405031, 'LB', 'LBN', 'لبنان'),
(106108, 3653405032, 3653405039, 'GB', 'GBR', 'المملكة المتحدة'),
(106109, 3653405040, 3653405047, 'LB', 'LBN', 'لبنان'),
(106110, 3653405048, 3653405055, 'IQ', 'IRQ', 'العراق'),
(106111, 3653405056, 3653405063, 'GB', 'GBR', 'المملكة المتحدة'),
(106112, 3653405064, 3653405079, 'IQ', 'IRQ', 'العراق'),
(106113, 3653405080, 3653405087, 'GB', 'GBR', 'المملكة المتحدة'),
(106114, 3653405088, 3653405095, 'LY', 'LBY', 'ليبيا'),
(106115, 3653405096, 3653405103, 'NG', 'NGA', 'نيجيريا'),
(106116, 3653405104, 3653405119, 'GB', 'GBR', 'المملكة المتحدة'),
(106117, 3653405120, 3653405135, 'ZW', 'ZWE', 'زمبابواي'),
(106118, 3653405136, 3653405151, 'UA', 'UKR', 'أوكرانيا'),
(106119, 3653405152, 3653405167, 'GB', 'GBR', 'المملكة المتحدة'),
(106120, 3653405168, 3653405183, 'UA', 'UKR', 'أوكرانيا'),
(106121, 3653405184, 3653405439, 'AT', 'AUT', 'النمسا'),
(106122, 3653405440, 3653407015, 'GB', 'GBR', 'المملكة المتحدة'),
(106123, 3653407016, 3653407023, 'UG', 'UGA', 'أوغاندا'),
(106124, 3653407024, 3653407031, 'GB', 'GBR', 'المملكة المتحدة'),
(106125, 3653407032, 3653407039, 'ZW', 'ZWE', 'زمبابواي'),
(106126, 3653407040, 3653407071, 'NG', 'NGA', 'نيجيريا'),
(106127, 3653407072, 3653407087, 'GB', 'GBR', 'المملكة المتحدة'),
(106128, 3653407088, 3653407095, 'NG', 'NGA', 'نيجيريا'),
(106129, 3653407096, 3653407103, 'GB', 'GBR', 'المملكة المتحدة'),
(106130, 3653407104, 3653407111, 'UG', 'UGA', 'أوغاندا'),
(106131, 3653407112, 3653407119, 'ZM', 'ZMB', 'زامبيا'),
(106132, 3653407120, 3653407127, 'ZW', 'ZWE', 'زمبابواي'),
(106133, 3653407128, 3653407167, 'GB', 'GBR', 'المملكة المتحدة'),
(106134, 3653407168, 3653407231, 'NG', 'NGA', 'نيجيريا'),
(106135, 3653407232, 3653407359, 'GB', 'GBR', 'المملكة المتحدة'),
(106136, 3653407360, 3653407375, 'NG', 'NGA', 'نيجيريا'),
(106137, 3653407376, 3653407391, 'GB', 'GBR', 'المملكة المتحدة'),
(106138, 3653407392, 3653407399, 'NG', 'NGA', 'نيجيريا'),
(106139, 3653407400, 3653407423, 'GB', 'GBR', 'المملكة المتحدة'),
(106140, 3653407424, 3653407487, 'ZW', 'ZWE', 'زمبابواي'),
(106141, 3653407488, 3653407615, 'GB', 'GBR', 'المملكة المتحدة'),
(106142, 3653407616, 3653407639, 'NG', 'NGA', 'نيجيريا'),
(106143, 3653407640, 3653407647, 'ZM', 'ZMB', 'زامبيا'),
(106144, 3653407648, 3653407679, 'GB', 'GBR', 'المملكة المتحدة'),
(106145, 3653407680, 3653407695, 'UG', 'UGA', 'أوغاندا'),
(106146, 3653407696, 3653407703, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(106147, 3653407704, 3653407711, 'NG', 'NGA', 'نيجيريا'),
(106148, 3653407712, 3653407727, 'GB', 'GBR', 'المملكة المتحدة'),
(106149, 3653407728, 3653407743, 'ZW', 'ZWE', 'زمبابواي'),
(106150, 3653407744, 3653407999, 'AT', 'AUT', 'النمسا'),
(106151, 3653408000, 3653408023, 'GB', 'GBR', 'المملكة المتحدة'),
(106152, 3653408024, 3653408031, 'UG', 'UGA', 'أوغاندا'),
(106153, 3653408032, 3653408047, 'ZW', 'ZWE', 'زمبابواي'),
(106154, 3653408048, 3653408063, 'GB', 'GBR', 'المملكة المتحدة'),
(106155, 3653408064, 3653408071, 'ZM', 'ZMB', 'زامبيا'),
(106156, 3653408072, 3653408079, 'NG', 'NGA', 'نيجيريا'),
(106157, 3653408080, 3653408087, 'MW', 'MWI', 'ملاوي'),
(106158, 3653408088, 3653408143, 'GB', 'GBR', 'المملكة المتحدة'),
(106159, 3653408144, 3653408151, 'NG', 'NGA', 'نيجيريا'),
(106160, 3653408152, 3653408159, 'ZM', 'ZMB', 'زامبيا'),
(106161, 3653408160, 3653408167, 'NG', 'NGA', 'نيجيريا'),
(106162, 3653408168, 3653408175, 'ZW', 'ZWE', 'زمبابواي'),
(106163, 3653408176, 3653408183, 'GB', 'GBR', 'المملكة المتحدة'),
(106164, 3653408184, 3653408191, 'MW', 'MWI', 'ملاوي'),
(106165, 3653408192, 3653408215, 'GB', 'GBR', 'المملكة المتحدة'),
(106166, 3653408216, 3653408223, 'MW', 'MWI', 'ملاوي'),
(106167, 3653408224, 3653408231, 'GB', 'GBR', 'المملكة المتحدة'),
(106168, 3653408232, 3653408239, 'KE', 'KEN', 'كينيا'),
(106169, 3653408240, 3653408247, 'ZM', 'ZMB', 'زامبيا'),
(106170, 3653408248, 3653408767, 'GB', 'GBR', 'المملكة المتحدة'),
(106171, 3653408768, 3653409023, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(106172, 3653409024, 3653409039, 'GB', 'GBR', 'المملكة المتحدة'),
(106173, 3653409040, 3653409047, 'NG', 'NGA', 'نيجيريا'),
(106174, 3653409048, 3653409087, 'GB', 'GBR', 'المملكة المتحدة'),
(106175, 3653409088, 3653409095, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(106176, 3653409096, 3653409103, 'GB', 'GBR', 'المملكة المتحدة'),
(106177, 3653409104, 3653409127, 'NG', 'NGA', 'نيجيريا'),
(106178, 3653409128, 3653409143, 'CD', 'COD', 'جمهورية الكونغو الديمقراطية'),
(106179, 3653409144, 3653409151, 'NG', 'NGA', 'نيجيريا'),
(106180, 3653409152, 3653409175, 'GB', 'GBR', 'المملكة المتحدة'),
(106181, 3653409176, 3653409183, 'NG', 'NGA', 'نيجيريا'),
(106182, 3653409184, 3653409191, 'GB', 'GBR', 'المملكة المتحدة'),
(106183, 3653409192, 3653409199, 'NG', 'NGA', 'نيجيريا'),
(106184, 3653409200, 3653409223, 'GB', 'GBR', 'المملكة المتحدة'),
(106185, 3653409224, 3653409231, 'NG', 'NGA', 'نيجيريا'),
(106186, 3653409232, 3653409279, 'GB', 'GBR', 'المملكة المتحدة'),
(106187, 3653409280, 3653409535, 'TZ', 'TZA', 'تانزانيا'),
(106188, 3653409536, 3653409559, 'UA', 'UKR', 'أوكرانيا'),
(106189, 3653409560, 3653409567, 'CM', 'CMR', 'الكاميرون'),
(106190, 3653409568, 3653409575, 'UA', 'UKR', 'أوكرانيا'),
(106191, 3653409576, 3653409615, 'GB', 'GBR', 'المملكة المتحدة'),
(106192, 3653409616, 3653409623, 'IQ', 'IRQ', 'العراق'),
(106193, 3653409624, 3653409639, 'NG', 'NGA', 'نيجيريا'),
(106194, 3653409640, 3653409647, 'GB', 'GBR', 'المملكة المتحدة'),
(106195, 3653409648, 3653409663, 'NG', 'NGA', 'نيجيريا'),
(106196, 3653409664, 3653409791, 'CM', 'CMR', 'الكاميرون'),
(106197, 3653409792, 3653409855, 'ZW', 'ZWE', 'زمبابواي'),
(106198, 3653409856, 3653409919, 'GB', 'GBR', 'المملكة المتحدة'),
(106199, 3653409920, 3653410047, 'NG', 'NGA', 'نيجيريا'),
(106200, 3653410048, 3653410063, 'YT', 'MYT', 'مايوت'),
(106201, 3653410064, 3653410079, 'UG', 'UGA', 'أوغاندا'),
(106202, 3653410080, 3653410087, 'GB', 'GBR', 'المملكة المتحدة'),
(106203, 3653410088, 3653410095, 'NG', 'NGA', 'نيجيريا'),
(106204, 3653410096, 3653410111, 'ZW', 'ZWE', 'زمبابواي'),
(106205, 3653410112, 3653410119, 'GB', 'GBR', 'المملكة المتحدة'),
(106206, 3653410120, 3653410127, 'NG', 'NGA', 'نيجيريا'),
(106207, 3653410128, 3653410143, 'GB', 'GBR', 'المملكة المتحدة'),
(106208, 3653410144, 3653410151, 'ET', 'ETH', 'إثيوبيا'),
(106209, 3653410152, 3653410159, 'KE', 'KEN', 'كينيا'),
(106210, 3653410160, 3653410175, 'NG', 'NGA', 'نيجيريا'),
(106211, 3653410176, 3653410183, 'KE', 'KEN', 'كينيا'),
(106212, 3653410184, 3653410191, 'MZ', 'MOZ', 'موزامبيق'),
(106213, 3653410192, 3653410199, 'ZW', 'ZWE', 'زمبابواي'),
(106214, 3653410200, 3653410215, 'GB', 'GBR', 'المملكة المتحدة'),
(106215, 3653410216, 3653410223, 'ZW', 'ZWE', 'زمبابواي'),
(106216, 3653410224, 3653410247, 'GB', 'GBR', 'المملكة المتحدة'),
(106217, 3653410248, 3653410255, 'ZM', 'ZMB', 'زامبيا'),
(106218, 3653410256, 3653410263, 'GB', 'GBR', 'المملكة المتحدة'),
(106219, 3653410264, 3653410271, 'NG', 'NGA', 'نيجيريا'),
(106220, 3653410272, 3653410279, 'SD', 'SDN', 'السودان'),
(106221, 3653410280, 3653410287, 'LU', 'LUX', 'لوكسيمبورغ'),
(106222, 3653410288, 3653410295, 'GB', 'GBR', 'المملكة المتحدة'),
(106223, 3653410296, 3653410303, 'MW', 'MWI', 'ملاوي'),
(106224, 3653410304, 3653410815, 'GB', 'GBR', 'المملكة المتحدة'),
(106225, 3653410816, 3653414911, 'CZ', 'CZE', 'التشيك'),
(106226, 3653414912, 3653419007, 'IT', 'ITA', 'إيطاليا'),
(106227, 3653419008, 3653423103, 'IL', 'ISR', 'إسرائيل'),
(106228, 3653423104, 3653427199, 'GB', 'GBR', 'المملكة المتحدة'),
(106229, 3653427200, 3653431295, 'DE', 'DEU', 'ألمانيا'),
(106230, 3653431296, 3653435391, 'RU', 'RUS', 'الإتحاد الروسي'),
(106231, 3653435392, 3653439487, 'DE', 'DEU', 'ألمانيا'),
(106232, 3653439488, 3653443583, 'FR', 'FRA', 'فرنسا'),
(106233, 3653443584, 3653444351, 'DE', 'DEU', 'ألمانيا'),
(106234, 3653444352, 3653444383, 'IT', 'ITA', 'إيطاليا'),
(106235, 3653444384, 3653447679, 'DE', 'DEU', 'ألمانيا'),
(106236, 3653447680, 3653451775, 'LV', 'LVA', 'لاتفيا'),
(106237, 3653451776, 3653464063, 'RU', 'RUS', 'الإتحاد الروسي'),
(106238, 3653464064, 3653468159, 'NL', 'NLD', 'هولندا'),
(106239, 3653468160, 3653472255, 'GR', 'GRC', 'اليونان'),
(106240, 3653472256, 3653472279, 'NL', 'NLD', 'هولندا'),
(106241, 3653472280, 3653472291, 'AF', 'AFG', 'أفغانستان'),
(106242, 3653472292, 3653472511, 'NL', 'NLD', 'هولندا'),
(106243, 3653472512, 3653472559, 'AF', 'AFG', 'أفغانستان'),
(106244, 3653472560, 3653472567, 'NL', 'NLD', 'هولندا'),
(106245, 3653472568, 3653472575, 'AF', 'AFG', 'أفغانستان'),
(106246, 3653472576, 3653472591, 'NL', 'NLD', 'هولندا'),
(106247, 3653472592, 3653472823, 'AF', 'AFG', 'أفغانستان'),
(106248, 3653472824, 3653472831, 'NL', 'NLD', 'هولندا'),
(106249, 3653472832, 3653472915, 'AF', 'AFG', 'أفغانستان'),
(106250, 3653472916, 3653472919, 'NL', 'NLD', 'هولندا'),
(106251, 3653472920, 3653472983, 'AF', 'AFG', 'أفغانستان'),
(106252, 3653472984, 3653472999, 'NL', 'NLD', 'هولندا'),
(106253, 3653473000, 3653473039, 'AF', 'AFG', 'أفغانستان'),
(106254, 3653473040, 3653474303, 'NL', 'NLD', 'هولندا'),
(106255, 3653474304, 3653474367, 'US', 'USA', 'الولايات المتحدة'),
(106256, 3653474368, 3653476351, 'NL', 'NLD', 'هولندا'),
(106257, 3653476352, 3653480447, 'CZ', 'CZE', 'التشيك'),
(106258, 3653480448, 3653484543, 'DK', 'DNK', 'الدنيمارك'),
(106259, 3653484544, 3653488639, 'TR', 'TUR', 'تركيا'),
(106260, 3653488640, 3653492735, 'RU', 'RUS', 'الإتحاد الروسي'),
(106261, 3653492736, 3653500927, 'NL', 'NLD', 'هولندا'),
(106262, 3653500928, 3653505023, 'GB', 'GBR', 'المملكة المتحدة'),
(106263, 3653505024, 3653509119, 'KZ', 'KAZ', 'كازاخستان'),
(106264, 3653509120, 3653513215, 'NL', 'NLD', 'هولندا'),
(106265, 3653513216, 3653517311, 'NO', 'NOR', 'النرويج'),
(106266, 3653517312, 3653518367, 'AT', 'AUT', 'النمسا'),
(106267, 3653518368, 3653518399, 'SK', 'SVK', 'سلوفاكيا'),
(106268, 3653518400, 3653518479, 'AT', 'AUT', 'النمسا'),
(106269, 3653518480, 3653518495, 'SK', 'SVK', 'سلوفاكيا'),
(106270, 3653518496, 3653519815, 'AT', 'AUT', 'النمسا'),
(106271, 3653519816, 3653519839, 'SK', 'SVK', 'سلوفاكيا'),
(106272, 3653519840, 3653520191, 'AT', 'AUT', 'النمسا'),
(106273, 3653520192, 3653520255, 'SK', 'SVK', 'سلوفاكيا'),
(106274, 3653520256, 3653522975, 'AT', 'AUT', 'النمسا'),
(106275, 3653522976, 3653522991, 'SK', 'SVK', 'سلوفاكيا'),
(106276, 3653522992, 3653523199, 'AT', 'AUT', 'النمسا'),
(106277, 3653523200, 3653523455, 'SK', 'SVK', 'سلوفاكيا'),
(106278, 3653523456, 3653523615, 'AT', 'AUT', 'النمسا'),
(106279, 3653523616, 3653523647, 'SK', 'SVK', 'سلوفاكيا'),
(106280, 3653523648, 3653524551, 'AT', 'AUT', 'النمسا'),
(106281, 3653524552, 3653524559, 'GR', 'GRC', 'اليونان'),
(106282, 3653524560, 3653524735, 'AT', 'AUT', 'النمسا'),
(106283, 3653524736, 3653524863, 'SK', 'SVK', 'سلوفاكيا'),
(106284, 3653524864, 3653524959, 'AT', 'AUT', 'النمسا'),
(106285, 3653524960, 3653525151, 'SK', 'SVK', 'سلوفاكيا'),
(106286, 3653525152, 3653525183, 'AT', 'AUT', 'النمسا'),
(106287, 3653525184, 3653525215, 'SK', 'SVK', 'سلوفاكيا'),
(106288, 3653525216, 3653525503, 'AT', 'AUT', 'النمسا'),
(106289, 3653533696, 3653537791, 'HU', 'HUN', 'هنغاريا'),
(106290, 3653537792, 3653541887, 'AT', 'AUT', 'النمسا'),
(106291, 3653541888, 3653545087, 'UA', 'UKR', 'أوكرانيا'),
(106292, 3653545088, 3653545215, 'AT', 'AUT', 'النمسا'),
(106293, 3653545216, 3653545343, 'UA', 'UKR', 'أوكرانيا'),
(106294, 3653545344, 3653545471, 'SE', 'SWE', 'السويد'),
(106295, 3653545472, 3653545727, 'UA', 'UKR', 'أوكرانيا'),
(106296, 3653545728, 3653545791, 'SE', 'SWE', 'السويد'),
(106297, 3653545792, 3653545855, 'UA', 'UKR', 'أوكرانيا'),
(106298, 3653545856, 3653545983, 'SE', 'SWE', 'السويد'),
(106299, 3653545984, 3653550079, 'CH', 'CHE', 'سويسرا'),
(106300, 3653550080, 3653554175, 'GB', 'GBR', 'المملكة المتحدة'),
(106301, 3653554176, 3653558271, 'CZ', 'CZE', 'التشيك'),
(106302, 3653558272, 3653559671, 'GB', 'GBR', 'المملكة المتحدة'),
(106303, 3653559672, 3653559679, 'US', 'USA', 'الولايات المتحدة'),
(106304, 3653559680, 3653566463, 'GB', 'GBR', 'المملكة المتحدة'),
(106305, 3653566464, 3653570559, 'RU', 'RUS', 'الإتحاد الروسي'),
(106306, 3653570560, 3653574655, 'NO', 'NOR', 'النرويج'),
(106307, 3653574656, 3653578751, 'CZ', 'CZE', 'التشيك'),
(106308, 3653578752, 3653582847, 'SE', 'SWE', 'السويد'),
(106309, 3653582848, 3653586943, 'PL', 'POL', 'بولندا'),
(106310, 3653586944, 3653591039, 'DE', 'DEU', 'ألمانيا'),
(106311, 3653591040, 3653595135, 'LU', 'LUX', 'لوكسيمبورغ'),
(106312, 3653595136, 3653599231, 'RU', 'RUS', 'الإتحاد الروسي'),
(106313, 3653599232, 3653603327, 'BG', 'BGR', 'بلغاريا'),
(106314, 3653603328, 3653607423, 'CZ', 'CZE', 'التشيك'),
(106315, 3653607424, 3653611519, 'PL', 'POL', 'بولندا'),
(106316, 3653611520, 3653615615, 'HU', 'HUN', 'هنغاريا'),
(106317, 3653615616, 3653619711, 'RU', 'RUS', 'الإتحاد الروسي'),
(106318, 3653619712, 3653623295, 'CH', 'CHE', 'سويسرا'),
(106319, 3653623296, 3653623551, 'JP', 'JPN', 'اليابان'),
(106320, 3653623552, 3653623807, 'US', 'USA', 'الولايات المتحدة'),
(106321, 3653623808, 3653636095, 'RU', 'RUS', 'الإتحاد الروسي'),
(106322, 3653636096, 3653640191, 'NL', 'NLD', 'هولندا'),
(106323, 3653640192, 3653644031, 'GB', 'GBR', 'المملكة المتحدة'),
(106324, 3653644032, 3653644047, 'BE', 'BEL', 'بلجيكا'),
(106325, 3653644048, 3653644271, 'GB', 'GBR', 'المملكة المتحدة'),
(106326, 3653644272, 3653644275, 'BE', 'BEL', 'بلجيكا'),
(106327, 3653644276, 3653648383, 'GB', 'GBR', 'المملكة المتحدة'),
(106328, 3653648384, 3653652479, 'SE', 'SWE', 'السويد'),
(106329, 3653652480, 3653656575, 'RU', 'RUS', 'الإتحاد الروسي'),
(106330, 3653656576, 3653660671, 'GB', 'GBR', 'المملكة المتحدة'),
(106331, 3653660672, 3653664767, 'CZ', 'CZE', 'التشيك'),
(106332, 3653664768, 3653668863, 'UA', 'UKR', 'أوكرانيا'),
(106333, 3653668864, 3653672959, 'SE', 'SWE', 'السويد'),
(106334, 3653672960, 3653681151, 'RU', 'RUS', 'الإتحاد الروسي'),
(106335, 3653685248, 3653689343, 'DK', 'DNK', 'الدنيمارك'),
(106336, 3653689344, 3653693439, 'LV', 'LVA', 'لاتفيا'),
(106337, 3653693440, 3653697535, 'DE', 'DEU', 'ألمانيا'),
(106338, 3653697536, 3653705727, 'IT', 'ITA', 'إيطاليا'),
(106339, 3653705728, 3653705735, 'SE', 'SWE', 'السويد'),
(106340, 3653705736, 3653705863, 'NO', 'NOR', 'النرويج'),
(106341, 3653705864, 3653705871, 'SE', 'SWE', 'السويد'),
(106342, 3653705872, 3653705895, 'NO', 'NOR', 'النرويج'),
(106343, 3653705896, 3653705903, 'BS', 'BHS', 'جزر البهاما'),
(106344, 3653705904, 3653706175, 'NO', 'NOR', 'النرويج'),
(106345, 3653706176, 3653706191, 'SE', 'SWE', 'السويد'),
(106346, 3653706192, 3653706271, 'NO', 'NOR', 'النرويج'),
(106347, 3653706272, 3653706303, 'SE', 'SWE', 'السويد'),
(106348, 3653706304, 3653706495, 'NO', 'NOR', 'النرويج'),
(106349, 3653706496, 3653706751, 'SE', 'SWE', 'السويد'),
(106350, 3653706752, 3653710847, 'NO', 'NOR', 'النرويج'),
(106351, 3653710848, 3653710911, 'SE', 'SWE', 'السويد'),
(106352, 3653710912, 3653713919, 'NO', 'NOR', 'النرويج'),
(106353, 3653713920, 3653718015, 'DE', 'DEU', 'ألمانيا'),
(106354, 3653718016, 3653722111, 'AT', 'AUT', 'النمسا'),
(106355, 3653722112, 3653730303, 'LV', 'LVA', 'لاتفيا'),
(106356, 3653730304, 3653734399, 'BA', 'BIH', 'البوسنه والهرسك'),
(106357, 3653738496, 3653740295, 'GB', 'GBR', 'المملكة المتحدة'),
(106358, 3653740296, 3653740303, 'US', 'USA', 'الولايات المتحدة'),
(106359, 3653740304, 3653744895, 'GB', 'GBR', 'المملكة المتحدة'),
(106360, 3653744896, 3653744959, 'AE', 'ARE', 'الإمارات العربية المتحدة'),
(106361, 3653744960, 3653746687, 'GB', 'GBR', 'المملكة المتحدة'),
(106362, 3653746688, 3653750783, 'DE', 'DEU', 'ألمانيا'),
(106363, 3653750784, 3653754879, 'RU', 'RUS', 'الإتحاد الروسي'),
(106364, 3653754880, 3653758975, 'UA', 'UKR', 'أوكرانيا'),
(106365, 3653758976, 3653763071, 'RU', 'RUS', 'الإتحاد الروسي'),
(106366, 3653763072, 3654025215, 'IT', 'ITA', 'إيطاليا'),
(106367, 3654025216, 3654034783, 'GB', 'GBR', 'المملكة المتحدة'),
(106368, 3654034784, 3654034799, 'LU', 'LUX', 'لوكسيمبورغ'),
(106369, 3654034800, 3654035583, 'GB', 'GBR', 'المملكة المتحدة'),
(106370, 3654035584, 3654035591, 'US', 'USA', 'الولايات المتحدة'),
(106371, 3654035592, 3654035607, 'GB', 'GBR', 'المملكة المتحدة'),
(106372, 3654035608, 3654035615, 'SE', 'SWE', 'السويد'),
(106373, 3654035616, 3654061035, 'GB', 'GBR', 'المملكة المتحدة'),
(106374, 3654061036, 3654061039, 'US', 'USA', 'الولايات المتحدة'),
(106375, 3654061040, 3654061951, 'GB', 'GBR', 'المملكة المتحدة'),
(106376, 3654061952, 3654062079, 'DE', 'DEU', 'ألمانيا'),
(106377, 3654062080, 3654066027, 'GB', 'GBR', 'المملكة المتحدة'),
(106378, 3654066028, 3654066031, 'MC', 'MCO', 'موناكو'),
(106379, 3654066032, 3654287359, 'GB', 'GBR', 'المملكة المتحدة'),
(106380, 3654287360, 3654607871, 'SE', 'SWE', 'السويد'),
(106381, 3654607872, 3654608127, 'NO', 'NOR', 'النرويج'),
(106382, 3654608128, 3654608895, 'SE', 'SWE', 'السويد'),
(106383, 3654608896, 3654609919, 'NO', 'NOR', 'النرويج'),
(106384, 3654609920, 3654613007, 'SE', 'SWE', 'السويد'),
(106385, 3654613008, 3654613015, 'RU', 'RUS', 'الإتحاد الروسي'),
(106386, 3654613016, 3654613055, 'SE', 'SWE', 'السويد'),
(106387, 3654613056, 3654613071, 'RU', 'RUS', 'الإتحاد الروسي'),
(106388, 3654613072, 3654613087, 'SE', 'SWE', 'السويد'),
(106389, 3654613088, 3654613151, 'RU', 'RUS', 'الإتحاد الروسي'),
(106390, 3654613152, 3654613247, 'SE', 'SWE', 'السويد'),
(106391, 3654613248, 3654614015, 'NO', 'NOR', 'النرويج'),
(106392, 3654614016, 3654614031, 'SE', 'SWE', 'السويد'),
(106393, 3654614032, 3654614047, 'US', 'USA', 'الولايات المتحدة'),
(106394, 3654614048, 3654614079, 'SE', 'SWE', 'السويد'),
(106395, 3654614080, 3654614271, 'FI', 'FIN', 'فنلندا'),
(106396, 3654614272, 3654614527, 'SE', 'SWE', 'السويد'),
(106397, 3654614528, 3654614783, 'RU', 'RUS', 'الإتحاد الروسي'),
(106398, 3654614784, 3654615039, 'NO', 'NOR', 'النرويج'),
(106399, 3654615040, 3654811647, 'SE', 'SWE', 'السويد'),
(106400, 3654811648, 3654942719, 'ES', 'ESP', 'إسبانيا'),
(106401, 3654942720, 3655073791, 'IR', 'IRN', 'إيران'),
(106402, 3655073792, 3655335935, 'IT', 'ITA', 'إيطاليا'),
(106403, 3655335936, 3656229703, 'DE', 'DEU', 'ألمانيا'),
(106404, 3656229704, 3656229711, 'ES', 'ESP', 'إسبانيا'),
(106405, 3656229712, 3656233999, 'DE', 'DEU', 'ألمانيا'),
(106406, 3656234000, 3656234007, 'NL', 'NLD', 'هولندا'),
(106407, 3656234008, 3656236527, 'DE', 'DEU', 'ألمانيا'),
(106408, 3656236528, 3656236535, 'GB', 'GBR', 'المملكة المتحدة'),
(106409, 3656236536, 3656236543, 'US', 'USA', 'الولايات المتحدة'),
(106410, 3656236544, 3656633487, 'DE', 'DEU', 'ألمانيا'),
(106411, 3656633488, 3656633495, 'GB', 'GBR', 'المملكة المتحدة'),
(106412, 3656633496, 3656633503, 'US', 'USA', 'الولايات المتحدة'),
(106413, 3656633504, 3656650583, 'DE', 'DEU', 'ألمانيا'),
(106414, 3656650584, 3656650591, 'US', 'USA', 'الولايات المتحدة'),
(106415, 3656650592, 3656661183, 'DE', 'DEU', 'ألمانيا'),
(106416, 3656661184, 3656661199, 'AT', 'AUT', 'النمسا'),
(106417, 3656661200, 3656661583, 'DE', 'DEU', 'ألمانيا'),
(106418, 3656661584, 3656661599, 'AT', 'AUT', 'النمسا'),
(106419, 3656661600, 3656661647, 'DE', 'DEU', 'ألمانيا'),
(106420, 3656661648, 3656661679, 'AT', 'AUT', 'النمسا'),
(106421, 3656661680, 3656662271, 'DE', 'DEU', 'ألمانيا'),
(106422, 3656662272, 3656662367, 'AT', 'AUT', 'النمسا'),
(106423, 3656662368, 3656662431, 'DE', 'DEU', 'ألمانيا'),
(106424, 3656662432, 3656662463, 'AT', 'AUT', 'النمسا'),
(106425, 3656662464, 3657433087, 'DE', 'DEU', 'ألمانيا'),
(106426, 3657433088, 3659530239, 'CN', 'CHN', 'الصين'),
(106427, 3659530240, 3659595775, 'TW', 'TWN', 'تايوان'),
(106428, 3659595776, 3659628543, 'ID', 'IDN', 'إندونيسيا'),
(106429, 3659628544, 3659661311, 'JP', 'JPN', 'اليابان'),
(106430, 3659661312, 3659792383, 'TW', 'TWN', 'تايوان'),
(106431, 3659792384, 3660054527, 'KR', 'KOR', 'جمهورية كوريا'),
(106432, 3660054528, 3660578815, 'JP', 'JPN', 'اليابان'),
(106433, 3660578816, 3661103103, 'KR', 'KOR', 'جمهورية كوريا'),
(106434, 3661103104, 3663986687, 'CN', 'CHN', 'الصين'),
(106435, 3663986688, 3663987711, 'AU', 'AUS', 'أستراليا'),
(106436, 3663987712, 3663987967, 'ID', 'IDN', 'إندونيسيا'),
(106437, 3663987968, 3663989247, 'JP', 'JPN', 'اليابان'),
(106438, 3663989248, 3663989503, 'VN', 'VNM', 'فييتنام'),
(106439, 3663989504, 3663989759, 'ID', 'IDN', 'إندونيسيا'),
(106440, 3663989760, 3663990271, 'AU', 'AUS', 'أستراليا'),
(106441, 3663990272, 3663990527, 'VN', 'VNM', 'فييتنام'),
(106442, 3663990528, 3663990783, 'JP', 'JPN', 'اليابان'),
(106443, 3663990784, 3663991295, 'HK', 'HKG', 'هونغ كونغ'),
(106444, 3663991296, 3663991551, 'MY', 'MYS', 'ماليزيا'),
(106445, 3663991552, 3663991807, 'AU', 'AUS', 'أستراليا'),
(106446, 3663991808, 3663992063, 'JP', 'JPN', 'اليابان'),
(106447, 3663992064, 3663992319, 'NZ', 'NZL', 'نيوزيلاندا'),
(106448, 3663992320, 3663992575, 'MY', 'MYS', 'ماليزيا'),
(106449, 3663992576, 3663993599, 'NZ', 'NZL', 'نيوزيلاندا'),
(106450, 3663993600, 3663996159, 'ID', 'IDN', 'إندونيسيا'),
(106451, 3663996160, 3663996415, 'BD', 'BGD', 'بنغالاديش'),
(106452, 3663996416, 3663996671, 'TH', 'THA', 'تايلند'),
(106453, 3663996672, 3663997183, 'AU', 'AUS', 'أستراليا'),
(106454, 3663997184, 3663997439, 'ID', 'IDN', 'إندونيسيا'),
(106455, 3663997440, 3663997695, 'JP', 'JPN', 'اليابان'),
(106456, 3663997696, 3663997951, 'AU', 'AUS', 'أستراليا'),
(106457, 3663997952, 3663998207, 'MY', 'MYS', 'ماليزيا'),
(106458, 3663998208, 3663998463, 'JP', 'JPN', 'اليابان'),
(106459, 3663998464, 3663998975, 'TH', 'THA', 'تايلند'),
(106460, 3663998976, 3663999487, 'IN', 'IND', 'الهند'),
(106461, 3663999488, 3663999743, 'AU', 'AUS', 'أستراليا'),
(106462, 3663999744, 3663999999, 'KH', 'KHM', 'كامبوديا'),
(106463, 3664000000, 3664000767, 'AU', 'AUS', 'أستراليا'),
(106464, 3664000768, 3664001023, 'ID', 'IDN', 'إندونيسيا'),
(106465, 3664001024, 3664001279, 'NZ', 'NZL', 'نيوزيلاندا'),
(106466, 3664001280, 3664001535, 'LK', 'LKA', 'سيريلانكا'),
(106467, 3664001536, 3664001791, 'MY', 'MYS', 'ماليزيا'),
(106468, 3664001792, 3664002047, 'AU', 'AUS', 'أستراليا'),
(106469, 3664002048, 3664002303, 'VN', 'VNM', 'فييتنام'),
(106470, 3664002304, 3664002559, 'LK', 'LKA', 'سيريلانكا'),
(106471, 3664002560, 3664003327, 'ID', 'IDN', 'إندونيسيا'),
(106472, 3664003328, 3664003583, 'NZ', 'NZL', 'نيوزيلاندا'),
(106473, 3664003584, 3664003839, 'TH', 'THA', 'تايلند'),
(106474, 3664003840, 3664004095, 'JP', 'JPN', 'اليابان'),
(106475, 3664004096, 3664004351, 'NZ', 'NZL', 'نيوزيلاندا'),
(106476, 3664004352, 3664004607, 'MY', 'MYS', 'ماليزيا'),
(106477, 3664004608, 3664052223, 'AU', 'AUS', 'أستراليا'),
(106478, 3664052224, 3664084991, 'NZ', 'NZL', 'نيوزيلاندا'),
(106479, 3664084992, 3664117759, 'KR', 'KOR', 'جمهورية كوريا'),
(106480, 3664117760, 3664248831, 'HK', 'HKG', 'هونغ كونغ'),
(106481, 3664248832, 3664642047, 'CN', 'CHN', 'الصين'),
(106482, 3664642048, 3664707583, 'JP', 'JPN', 'اليابان'),
(106483, 3664707584, 3664773119, 'MY', 'MYS', 'ماليزيا'),
(106484, 3664773120, 3666870271, 'JP', 'JPN', 'اليابان'),
(106485, 3666870272, 3667918847, 'KR', 'KOR', 'جمهورية كوريا'),
(106486, 3667918848, 3668967423, 'TW', 'TWN', 'تايوان'),
(106487, 3668967424, 3669491711, 'JP', 'JPN', 'اليابان'),
(106488, 3669491712, 3669557247, 'TW', 'TWN', 'تايوان'),
(106489, 3669557248, 3669590015, 'AU', 'AUS', 'أستراليا'),
(106490, 3669590016, 3669606399, 'JP', 'JPN', 'اليابان'),
(106491, 3669606400, 3669614591, 'CN', 'CHN', 'الصين'),
(106492, 3669614592, 3669616639, 'NZ', 'NZL', 'نيوزيلاندا'),
(106493, 3669616640, 3669620735, 'AU', 'AUS', 'أستراليا'),
(106494, 3669620736, 3669622783, 'JP', 'JPN', 'اليابان'),
(106495, 3669622784, 3669688319, 'SG', 'SGP', 'سنغافورة'),
(106496, 3669688320, 3669753855, 'TW', 'TWN', 'تايوان'),
(106497, 3669753856, 3669822719, 'HK', 'HKG', 'هونغ كونغ'),
(106498, 3669822720, 3669822735, 'US', 'USA', 'الولايات المتحدة'),
(106499, 3669822736, 3670015999, 'HK', 'HKG', 'هونغ كونغ'),
(106500, 3670016000, 3671064575, 'CN', 'CHN', 'الصين'),
(106501, 3671064576, 3671130111, 'MY', 'MYS', 'ماليزيا'),
(106502, 3671130112, 3671195647, 'KR', 'KOR', 'جمهورية كوريا'),
(106503, 3671195648, 3671326719, 'TW', 'TWN', 'تايوان'),
(106504, 3671326720, 3671392255, 'SG', 'SGP', 'سنغافورة'),
(106505, 3671392256, 3671457791, 'HK', 'HKG', 'هونغ كونغ'),
(106506, 3671457792, 3671588863, 'AU', 'AUS', 'أستراليا'),
(106507, 3671588864, 3672637439, 'JP', 'JPN', 'اليابان'),
(106508, 3672637440, 3673161727, 'KR', 'KOR', 'جمهورية كوريا'),
(106509, 3673161728, 3673686015, 'CN', 'CHN', 'الصين'),
(106510, 3673686016, 3673751551, 'IN', 'IND', 'الهند'),
(106511, 3673751552, 3673817087, 'CN', 'CHN', 'الصين'),
(106512, 3673817088, 3673882623, 'HK', 'HKG', 'هونغ كونغ'),
(106513, 3673882624, 3673948159, 'JP', 'JPN', 'اليابان'),
(106514, 3673948160, 3674210303, 'HK', 'HKG', 'هونغ كونغ'),
(106515, 3674210304, 3674431743, 'JP', 'JPN', 'اليابان'),
(106516, 3674431744, 3674431999, 'UA', 'UKR', 'أوكرانيا'),
(106517, 3674432000, 3678404607, 'JP', 'JPN', 'اليابان'),
(106518, 3678404608, 3678535679, 'IN', 'IND', 'الهند'),
(106519, 3678535680, 3678666751, 'JP', 'JPN', 'اليابان'),
(106520, 3678666752, 3678928895, 'TW', 'TWN', 'تايوان'),
(106521, 3678928896, 3678994431, 'CN', 'CHN', 'الصين'),
(106522, 3678994432, 3679027199, 'HK', 'HKG', 'هونغ كونغ'),
(106523, 3679027200, 3679059967, 'JP', 'JPN', 'اليابان'),
(106524, 3679059968, 3679158271, 'SG', 'SGP', 'سنغافورة'),
(106525, 3679158272, 3679191039, 'JP', 'JPN', 'اليابان'),
(106526, 3679191040, 3679453183, 'HK', 'HKG', 'هونغ كونغ'),
(106527, 3679453184, 3679584255, 'TW', 'TWN', 'تايوان'),
(106528, 3679584256, 3679649791, 'CN', 'CHN', 'الصين'),
(106529, 3679649792, 3679682559, 'ID', 'IDN', 'إندونيسيا'),
(106530, 3679682560, 3679715327, 'IN', 'IND', 'الهند'),
(106531, 3679715328, 3679977471, 'TW', 'TWN', 'تايوان'),
(106532, 3679977472, 3680108543, 'NZ', 'NZL', 'نيوزيلاندا'),
(106533, 3680108544, 3680124927, 'TW', 'TWN', 'تايوان'),
(106534, 3680124928, 3680133119, 'PH', 'PHL', 'الفلبين'),
(106535, 3680133120, 3680137215, 'IN', 'IND', 'الهند'),
(106536, 3680137216, 3680141311, 'HK', 'HKG', 'هونغ كونغ'),
(106537, 3680141312, 3680174079, 'AU', 'AUS', 'أستراليا'),
(106538, 3680174080, 3680206847, 'TW', 'TWN', 'تايوان'),
(106539, 3680206848, 3680239615, 'IN', 'IND', 'الهند'),
(106540, 3680239616, 3680403455, 'MY', 'MYS', 'ماليزيا'),
(106541, 3680403456, 3680436223, 'JP', 'JPN', 'اليابان'),
(106542, 3680436224, 3680501759, 'MY', 'MYS', 'ماليزيا'),
(106543, 3680501760, 3682598911, 'JP', 'JPN', 'اليابان'),
(106544, 3682598912, 3684696063, 'CN', 'CHN', 'الصين'),
(106545, 3684696064, 3688366079, 'JP', 'JPN', 'اليابان'),
(106546, 3688366080, 3689938943, 'CN', 'CHN', 'الصين'),
(106547, 3689938944, 3690070015, 'KR', 'KOR', 'جمهورية كوريا'),
(106548, 3690070016, 3690463231, 'CN', 'CHN', 'الصين'),
(106549, 3690463232, 3690987519, 'KR', 'KOR', 'جمهورية كوريا'),
(106550, 3690987520, 3695181823, 'JP', 'JPN', 'اليابان'),
(106551, 3695181824, 3697278975, 'KR', 'KOR', 'جمهورية كوريا'),
(106552, 3697278976, 3697606655, 'JP', 'JPN', 'اليابان'),
(106553, 3697606656, 3697655807, 'AU', 'AUS', 'أستراليا'),
(106554, 3697655808, 3697672191, 'CN', 'CHN', 'الصين'),
(106555, 3697672192, 3697737727, 'JP', 'JPN', 'اليابان'),
(106556, 3697737728, 3697803263, 'KR', 'KOR', 'جمهورية كوريا'),
(106557, 3697803264, 3698327551, 'JP', 'JPN', 'اليابان'),
(106558, 3698327552, 3698589695, 'CN', 'CHN', 'الصين'),
(106559, 3698589696, 3699376127, 'KR', 'KOR', 'جمهورية كوريا'),
(106560, 3699376128, 3700424703, 'TW', 'TWN', 'تايوان'),
(106561, 3700424704, 3700752383, 'JP', 'JPN', 'اليابان'),
(106562, 3700752384, 3700817919, 'KR', 'KOR', 'جمهورية كوريا'),
(106563, 3700817920, 3700977663, 'JP', 'JPN', 'اليابان'),
(106564, 3700977664, 3700979711, 'AU', 'AUS', 'أستراليا'),
(106565, 3700979712, 3700981759, 'JP', 'JPN', 'اليابان'),
(106566, 3700981760, 3701014527, 'CN', 'CHN', 'الصين'),
(106567, 3701014528, 3701080063, 'JP', 'JPN', 'اليابان'),
(106568, 3701080064, 3701211135, 'CN', 'CHN', 'الصين'),
(106569, 3701211136, 3701252095, 'JP', 'JPN', 'اليابان'),
(106570, 3701252096, 3701256191, 'AU', 'AUS', 'أستراليا'),
(106571, 3701256192, 3701258239, 'SG', 'SGP', 'سنغافورة'),
(106572, 3701258240, 3701260287, 'IN', 'IND', 'الهند'),
(106573, 3701260288, 3701293055, 'JP', 'JPN', 'اليابان'),
(106574, 3701293056, 3701301247, 'AU', 'AUS', 'أستراليا'),
(106575, 3701301248, 3701305343, 'ID', 'IDN', 'إندونيسيا'),
(106576, 3701305344, 3701309439, 'TW', 'TWN', 'تايوان'),
(106577, 3701309440, 3701473279, 'JP', 'JPN', 'اليابان'),
(106578, 3701473280, 3704619007, 'CN', 'CHN', 'الصين'),
(106579, 3704619008, 3705667583, 'JP', 'JPN', 'اليابان'),
(106580, 3705667584, 3705929727, 'IN', 'IND', 'الهند'),
(106581, 3705929728, 3706060799, 'TW', 'TWN', 'تايوان'),
(106582, 3706060800, 3706126335, 'KR', 'KOR', 'جمهورية كوريا'),
(106583, 3706126336, 3706142719, 'CN', 'CHN', 'الصين'),
(106584, 3706142720, 3706159103, 'VN', 'VNM', 'فييتنام'),
(106585, 3706159104, 3706191871, 'CN', 'CHN', 'الصين'),
(106586, 3706191872, 3706208255, 'SG', 'SGP', 'سنغافورة'),
(106587, 3706208256, 3706224639, 'CN', 'CHN', 'الصين'),
(106588, 3706224640, 3706257407, 'HK', 'HKG', 'هونغ كونغ'),
(106589, 3706257408, 3706322943, 'AU', 'AUS', 'أستراليا'),
(106590, 3706322944, 3706388479, 'CN', 'CHN', 'الصين'),
(106591, 3706388480, 3706781695, 'AU', 'AUS', 'أستراليا'),
(106592, 3706781696, 3706847231, 'HK', 'HKG', 'هونغ كونغ'),
(106593, 3706847232, 3706978303, 'CN', 'CHN', 'الصين'),
(106594, 3706978304, 3707109375, 'AU', 'AUS', 'أستراليا'),
(106595, 3707109376, 3707174911, 'HK', 'HKG', 'هونغ كونغ'),
(106596, 3707174912, 3707207679, 'JP', 'JPN', 'اليابان'),
(106597, 3707207680, 3707208703, 'TW', 'TWN', 'تايوان'),
(106598, 3707208704, 3707215871, 'AU', 'AUS', 'أستراليا'),
(106599, 3707215872, 3707217919, 'BD', 'BGD', 'بنغالاديش'),
(106600, 3707217920, 3707219967, 'ID', 'IDN', 'إندونيسيا'),
(106601, 3707219968, 3707222015, 'AU', 'AUS', 'أستراليا'),
(106602, 3707222016, 3707224063, 'JP', 'JPN', 'اليابان'),
(106603, 3707224064, 3707240447, 'LK', 'LKA', 'سيريلانكا'),
(106604, 3707240448, 3707568127, 'CN', 'CHN', 'الصين'),
(106605, 3707568128, 3707633663, 'AU', 'AUS', 'أستراليا'),
(106606, 3707633664, 3707699199, 'JP', 'JPN', 'اليابان'),
(106607, 3707699200, 3707764735, 'SG', 'SGP', 'سنغافورة'),
(106608, 3707764736, 3708600319, 'CN', 'CHN', 'الصين'),
(106609, 3708600320, 3708616703, 'JP', 'JPN', 'اليابان'),
(106610, 3708616704, 3708813311, 'CN', 'CHN', 'الصين'),
(106611, 3708813312, 3715629055, 'JP', 'JPN', 'اليابان'),
(106612, 3715629056, 3715653631, 'TW', 'TWN', 'تايوان'),
(106613, 3715653632, 3715655679, 'BD', 'BGD', 'بنغالاديش'),
(106614, 3715655680, 3715657727, 'IN', 'IND', 'الهند'),
(106615, 3715657728, 3715659775, 'AU', 'AUS', 'أستراليا'),
(106616, 3715659776, 3715661823, 'SG', 'SGP', 'سنغافورة'),
(106617, 3715661824, 3715674111, 'AU', 'AUS', 'أستراليا'),
(106618, 3715674112, 3715678207, 'HK', 'HKG', 'هونغ كونغ'),
(106619, 3715678208, 3715694591, 'PK', 'PAK', 'باكستان'),
(106620, 3715694592, 3715710975, 'VN', 'VNM', 'فييتنام'),
(106621, 3715710976, 3715719167, 'AU', 'AUS', 'أستراليا'),
(106622, 3715719168, 3715727359, 'PH', 'PHL', 'الفلبين'),
(106623, 3715727360, 3715735551, 'AU', 'AUS', 'أستراليا'),
(106624, 3715735552, 3715741695, 'JP', 'JPN', 'اليابان'),
(106625, 3715741696, 3715743743, 'PH', 'PHL', 'الفلبين'),
(106626, 3715743744, 3715760127, 'JP', 'JPN', 'اليابان'),
(106627, 3715760128, 3715891199, 'CN', 'CHN', 'الصين'),
(106628, 3715891200, 3716153343, 'HK', 'HKG', 'هونغ كونغ'),
(106629, 3716153344, 3716169727, 'SG', 'SGP', 'سنغافورة'),
(106630, 3716169728, 3716186111, 'TH', 'THA', 'تايلند'),
(106631, 3716186112, 3716218879, 'IN', 'IND', 'الهند'),
(106632, 3716218880, 3716415487, 'CN', 'CHN', 'الصين'),
(106633, 3716415488, 3716431871, 'VN', 'VNM', 'فييتنام'),
(106634, 3716431872, 3716440063, 'KR', 'KOR', 'جمهورية كوريا'),
(106635, 3716440064, 3716444159, 'JP', 'JPN', 'اليابان'),
(106636, 3716444160, 3716446207, 'PK', 'PAK', 'باكستان'),
(106637, 3716446208, 3716448255, 'AU', 'AUS', 'أستراليا'),
(106638, 3716448256, 3716464639, 'JP', 'JPN', 'اليابان'),
(106639, 3716464640, 3716481023, 'ID', 'IDN', 'إندونيسيا'),
(106640, 3716481024, 3716489215, 'VN', 'VNM', 'فييتنام'),
(106641, 3716489216, 3716493311, 'MY', 'MYS', 'ماليزيا'),
(106642, 3716493312, 3716497407, 'KR', 'KOR', 'جمهورية كوريا'),
(106643, 3716497408, 3716513791, 'JP', 'JPN', 'اليابان'),
(106644, 3716513792, 3716530175, 'KR', 'KOR', 'جمهورية كوريا'),
(106645, 3716530176, 3716536372, 'AU', 'AUS', 'أستراليا'),
(106646, 3716536373, 3716536373, 'AS', 'ASM', 'ساموا الأمريكية'),
(106647, 3716536374, 3716537111, 'AU', 'AUS', 'أستراليا'),
(106648, 3716537112, 3716537119, 'AS', 'ASM', 'ساموا الأمريكية'),
(106649, 3716537120, 3716537151, 'AU', 'AUS', 'أستراليا'),
(106650, 3716537152, 3716537183, 'AS', 'ASM', 'ساموا الأمريكية'),
(106651, 3716537184, 3716537199, 'AU', 'AUS', 'أستراليا'),
(106652, 3716537200, 3716537215, 'AS', 'ASM', 'ساموا الأمريكية'),
(106653, 3716537216, 3716537279, 'AU', 'AUS', 'أستراليا'),
(106654, 3716537280, 3716537343, 'AS', 'ASM', 'ساموا الأمريكية'),
(106655, 3716537344, 3716537407, 'AU', 'AUS', 'أستراليا'),
(106656, 3716537408, 3716537471, 'AS', 'ASM', 'ساموا الأمريكية'),
(106657, 3716537472, 3716537535, 'AU', 'AUS', 'أستراليا'),
(106658, 3716537536, 3716537567, 'HK', 'HKG', 'هونغ كونغ'),
(106659, 3716537568, 3716537599, 'JP', 'JPN', 'اليابان'),
(106660, 3716537600, 3716538367, 'AU', 'AUS', 'أستراليا'),
(106661, 3716538368, 3716546559, 'CN', 'CHN', 'الصين'),
(106662, 3716546560, 3716677631, 'IN', 'IND', 'الهند'),
(106663, 3716677632, 3716808703, 'CN', 'CHN', 'الصين'),
(106664, 3716808704, 3718840319, 'KR', 'KOR', 'جمهورية كوريا'),
(106665, 3718840320, 3718905855, 'TW', 'TWN', 'تايوان'),
(106666, 3718905856, 3719036927, 'JP', 'JPN', 'اليابان'),
(106667, 3719036928, 3719823359, 'CN', 'CHN', 'الصين'),
(106668, 3719823360, 3720347647, 'JP', 'JPN', 'اليابان'),
(106669, 3720347648, 3720859647, 'CN', 'CHN', 'الصين'),
(106670, 3720859648, 3720863743, 'AU', 'AUS', 'أستراليا'),
(106671, 3720863744, 3723493375, 'CN', 'CHN', 'الصين'),
(106672, 3723493376, 3725590527, 'JP', 'JPN', 'اليابان'),
(106673, 3725590528, 3730833407, 'CN', 'CHN', 'الصين'),
(106674, 3730833408, 3732602879, 'KR', 'KOR', 'جمهورية كوريا'),
(106675, 3732602880, 3732668415, 'TH', 'THA', 'تايلند'),
(106676, 3732668416, 3732733951, 'ID', 'IDN', 'إندونيسيا'),
(106677, 3732733952, 3732799487, 'CN', 'CHN', 'الصين'),
(106678, 3732799488, 3732832255, 'PH', 'PHL', 'الفلبين'),
(106679, 3732832256, 3732865023, 'CN', 'CHN', 'الصين'),
(106680, 3732865024, 3732930559, 'PH', 'PHL', 'الفلبين'),
(106681, 3732930560, 3733979135, 'CN', 'CHN', 'الصين'),
(106682, 3733979136, 3734503423, 'JP', 'JPN', 'اليابان'),
(106683, 3734503424, 3734765567, 'NZ', 'NZL', 'نيوزيلاندا'),
(106684, 3734765568, 3734896639, 'TW', 'TWN', 'تايوان'),
(106685, 3734896640, 3735027711, 'JP', 'JPN', 'اليابان'),
(106686, 3735027712, 3735289855, 'CN', 'CHN', 'الصين'),
(106687, 3735289856, 3735388159, 'SG', 'SGP', 'سنغافورة'),
(106688, 3735388160, 3735404543, 'LK', 'LKA', 'سيريلانكا'),
(106689, 3735404544, 3735420927, 'ID', 'IDN', 'إندونيسيا'),
(106690, 3735420928, 3735551999, 'HK', 'HKG', 'هونغ كونغ'),
(106691, 3735552000, 3739222015, 'CN', 'CHN', 'الصين'),
(106692, 3739222016, 3739570175, 'JP', 'JPN', 'اليابان'),
(106693, 3739570176, 3739572223, 'ID', 'IDN', 'إندونيسيا'),
(106694, 3739572224, 3739574271, 'AU', 'AUS', 'أستراليا'),
(106695, 3739574272, 3739680767, 'JP', 'JPN', 'اليابان'),
(106696, 3739680768, 3739697151, 'KR', 'KOR', 'جمهورية كوريا'),
(106697, 3739697152, 3739746303, 'JP', 'JPN', 'اليابان'),
(106698, 3739746304, 3740270591, 'KR', 'KOR', 'جمهورية كوريا'),
(106699, 3740270592, 3740925951, 'CN', 'CHN', 'الصين'),
(106700, 3740925952, 3741024255, 'TW', 'TWN', 'تايوان'),
(106701, 3741024256, 3741057023, 'KR', 'KOR', 'جمهورية كوريا'),
(106702, 3741057024, 3741319167, 'VN', 'VNM', 'فييتنام'),
(106703, 3741319168, 3758096383, 'AU', 'AUS', 'أستراليا'),
(106704, 3758096384, 4294967295, 'US', 'USA', 'الولايات المتحدة');

CREATE TABLE `%%TBL-PREFIX%%base_invite_code` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(255) NOT NULL,
  `expiration_stamp` int(11) NOT NULL,
  `userId` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_language` (
  `id` int(11) NOT NULL auto_increment,
  `tag` varchar(32) NOT NULL,
  `label` varchar(32) NOT NULL,
  `order` int(11) NOT NULL default '1',
  `status` enum('active','inactive') default 'inactive',
  `rtl` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `tag` (`tag`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_language` (`id`, `tag`, `label`, `order`, `status`, `rtl`) VALUES
(1, 'ar', 'العربية', 1, 'active', 0);

CREATE TABLE `%%TBL-PREFIX%%base_language_key` (
  `id` int(11) NOT NULL auto_increment,
  `prefixId` int(11) NOT NULL default '0',
  `key` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `prefix_key` (`prefixId`,`key`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_language_key` (`id`, `prefixId`, `key`) VALUES
(5837, 7, 'forgot_password_heading'),
(1603, 1, 'you_are_editing'),
(1604, 1, 'check_other_langs'),
(1605, 1, 'add_new_text'),
(1606, 1, 'go'),
(1607, 1, 'search_results_for_keyword'),
(1608, 1, 'search'),
(1609, 1, 'original_value'),
(1610, 1, 'translation'),
(1611, 1, 'delete'),
(1612, 1, 'custom_keys'),
(1613, 1, 'save_this_page'),
(1614, 1, 'section'),
(1615, 1, 'all_sections'),
(1616, 1, 'missing_text'),
(1617, 1, 'page_note_part_1'),
(1618, 1, 'page_note_part_2'),
(1619, 1, 'msg_one_active_constraint'),
(1620, 1, 'empty'),
(1621, 1, 'missing_keys2'),
(1622, 1, 'active_languages'),
(1623, 1, 'language'),
(1624, 1, 'btn_label_edit'),
(1625, 1, 'btn_label_clone'),
(1626, 1, 'btn_label_deactivate'),
(1627, 1, 'btn_label_activate'),
(1628, 1, 'btn_label_delete'),
(9030, 7, 'authorization_action_newsfeed_add_comment'),
(1682, 1, 'import_lang_note'),
(1683, 1, 'add_new_lang_or_pack'),
(1684, 1, 'select_items_to_import_note'),
(1685, 1, 'lang_import_check_all'),
(1686, 1, 'import_lang_button_label'),
(1687, 1, 'export_lang_header'),
(1688, 1, 'export_lang_note'),
(1689, 1, 'export_lang_button_label'),
(1690, 1, 'export_lang_note2'),
(1691, 1, 'export_lang_button_label2'),
(1692, 1, 'show'),
(1693, 1, 'edit_language'),
(1694, 1, 'available_languages'),
(1695, 1, 'add_key_form_lbl_key'),
(1696, 1, 'add_key_form_lbl_val'),
(1697, 1, 'add_key_form_lbl_add'),
(1698, 1, 'lang_file'),
(1699, 1, 'inactive_languages'),
(1700, 1, 'clone_language'),
(1701, 1, 'clone_form_lbl_label'),
(1702, 1, 'title_add_new_text'),
(1703, 1, 'clone_form_descr_label'),
(1704, 1, 'are_you_sure'),
(1705, 1, 'clone_form_lbl_tag'),
(1706, 1, 'clone_form_descr_tag'),
(1708, 1, 'clone_form_lbl_submit'),
(1709, 1, 'search_no_results_for_keyword'),
(1710, 1, 'no_values'),
(1711, 7, 'forgot_password_submit_label'),
(1712, 1, 'def'),
(1713, 1, 'msg_dublicate_key'),
(9029, 7, 'authorization_group_newsfeed'),
(1741, 7, 'month_2'),
(1742, 7, 'month_8'),
(1743, 7, 'month_9'),
(1745, 7, 'all'),
(1746, 7, 'archive'),
(1747, 7, 'are_you_sure'),
(15468, 1, 'themes_item_add_success_message'),
(1752, 7, 'comments_label'),
(1754, 7, 'by'),
(1755, 7, 'more'),
(5833, 7, 'forgot_password_no_user_error_message'),
(15469, 1, 'theme_add_duplicated_dir_error'),
(1768, 7, 'flag'),
(1769, 7, 'edit'),
(1770, 7, 'delete'),
(15467, 1, 'themes_add_theme_page_heading'),
(1773, 7, 'approve'),
(1774, 7, 'disapprove'),
(15472, 7, 'user_search_back_to_search'),
(15471, 7, 'edit_remote_field_synchronize_title'),
(1855, 7, 'avatar_avatar_is'),
(1856, 7, 'avatar_current'),
(1857, 7, 'avatar_new'),
(1858, 7, 'avatar_crop'),
(1859, 7, 'avatar_crop_instructions'),
(1860, 7, 'avatar_picture'),
(1861, 7, 'avatar_apply_crop'),
(1862, 7, 'avatar_back_profile_edit'),
(1863, 7, 'avatar_preview'),
(1886, 1, 'permissions_roles'),
(1887, 1, 'sidebar_menu_item_settings_language'),
(1889, 1, 'sidebar_menu_item_pages_manage'),
(1890, 1, 'themes_choose_activate_button_label'),
(1891, 1, 'theme_settings_form_submit_label'),
(2583, 1, 'permissions_edit_role'),
(1893, 1, 'theme_settings_no_controls_label'),
(1894, 7, 'not_valid_image'),
(1895, 7, 'questions_question_user_photo_label'),
(1896, 7, 'join_error_photo_file_is_not_valid'),
(1897, 1, 'sidebar_menu_item_theme_choose'),
(1898, 7, 'join_error_password_too_long'),
(1899, 7, 'join_error_password_too_short'),
(1900, 7, 'join_error_password_not_valid'),
(1901, 7, 'join_error_email_already_exist'),
(1902, 7, 'join_error_email_not_valid'),
(1903, 7, 'join_error_username_not_valid'),
(1904, 1, 'themes_choose_list_cap_title'),
(1905, 1, 'themes_choose_page_title'),
(1906, 7, 'join_error_username_already_exist'),
(1918, 1, 'delete_btn_label'),
(1919, 7, 'date_time_today'),
(1920, 1, 'save_btn_label'),
(1921, 1, 'updated_msg'),
(1922, 1, 'page_default_title'),
(1923, 1, 'page_default_heading'),
(1926, 11, 'page_custom_title'),
(1927, 7, 'main_menu_my_profile'),
(1928, 7, 'main_menu_index'),
(1930, 11, 'page_default_title'),
(1931, 11, 'page_default_heading'),
(1932, 11, 'page_default_description'),
(1933, 11, 'page_default_keywords'),
(1934, 1, 'themes_settings_page_title'),
(1935, 1, 'sidebar_menu_settings'),
(1936, 1, 'sidebar_menu_pages'),
(1937, 1, 'sidebar_menu_appearance'),
(1938, 1, 'sidebar_menu_users'),
(1939, 1, 'sidebar_menu_plugins'),
(1940, 7, 'sign_in_submit_label'),
(1942, 1, 'sidebar_menu_item_theme_edit'),
(1943, 1, 'theme_css_edit_css_box_cap_label'),
(1944, 1, 'theme_css_edit_submit_label'),
(1948, 7, 'tag_cloud_cap_label'),
(1949, 1, 'permissions_moderators'),
(1950, 1, 'permissions_index'),
(1951, 11, 'menu_item_main_photo_list'),
(1952, 11, 'menu_item_main_board'),
(1953, 1, 'theme_css_existing_css_box_cap_label'),
(1954, 1, 'theme_graphics_delete_success_message'),
(1955, 1, 'theme_graphics_upload_form_fail_message'),
(1956, 1, 'theme_graphics_upload_form_success_message'),
(1957, 1, 'theme_graphics_upload_form_submit_label'),
(1958, 1, 'theme_graphics_table_delete'),
(1959, 1, 'theme_graphics_table_url'),
(1960, 1, 'theme_graphics_table_preview'),
(1961, 1, 'theme_graphics_list_cap_label'),
(1962, 1, 'theme_graphics_upload_label'),
(1963, 7, 'questions_question_account_type_label'),
(2170, 1, 'site_tagline'),
(1965, 1, 'theme_settings_cap_label'),
(1966, 1, 'theme_info_author_url_label'),
(1967, 1, 'theme_info_author_label'),
(1968, 7, 'pages_label'),
(1970, 1, 'main_menu_admin'),
(1971, 7, 'date_time_within_one_minute'),
(1972, 7, 'date_time_one_minute_ago'),
(1973, 7, 'date_time_minutes_ago'),
(1974, 7, 'users_main_menu_item'),
(1976, 1, 'theme_info_compatibility_label'),
(1977, 7, 'cmp_add_new_content_box_cap_label'),
(1978, 1, 'theme_info_version_label'),
(2601, 1, 'permissions_default_role'),
(2556, 7, 'email_verify_template_html'),
(2476, 1, 'questions_question_description_label'),
(3807, 1, 'sidebar_menu_privacy'),
(1992, 7, 'comment_add_submit_label'),
(1993, 7, 'comment_box_cap_label'),
(1994, 7, 'avatar_btn_upload'),
(1995, 7, 'avatar_upload_types'),
(2643, 7, 'questions_question_realname_description'),
(1998, 7, 'avatar_change_avatar'),
(1999, 7, 'questions_no_section_label'),
(2000, 7, 'questions_add_new_account_type'),
(2008, 7, 'join_submit_button_continue'),
(2009, 7, 'join_submit_button_join'),
(2010, 7, 'questions_question_9221d78a4201eac23c972e1d4aa2cee6_label'),
(2011, 7, 'questions_question_c441a8a9b955647cdf4c81562d39068a_label'),
(2012, 7, 'questions_section_47f3a94e6cfe733857b31116ce21c337_label'),
(2013, 1, 'sidebar_menu_item_plugin_photo'),
(2014, 1, 'sidebar_menu_item_plugin_video'),
(2015, 7, 'comment_add_post_error'),
(2016, 7, 'comment_add_auth_error'),
(2017, 7, 'comment_no_comments'),
(2018, 7, 'comment_delete_label'),
(2019, 7, 'date_time_one_hour_ago'),
(2020, 7, 'date_time_hours_ago'),
(2021, 7, 'date_time_yesterday'),
(2022, 7, 'date_time_at_label'),
(2025, 7, 'date_time_month_short_9'),
(2026, 7, 'date_time_month_short_1'),
(2027, 7, 'date_time_month_short_2'),
(2028, 7, 'date_time_month_short_3'),
(2029, 7, 'date_time_month_short_4'),
(2030, 7, 'date_time_month_short_5'),
(2031, 7, 'date_time_month_short_6'),
(2032, 7, 'date_time_month_short_7'),
(2033, 7, 'date_time_month_short_8'),
(2034, 7, 'date_time_month_short_10'),
(2035, 7, 'date_time_month_short_11'),
(2036, 7, 'date_time_month_short_12'),
(2037, 1, 'sidebar_menu_item_graphics'),
(2038, 1, 'sidebar_menu_item_css'),
(2039, 1, 'sidebar_menu_item_settings'),
(2041, 7, 'questions_question_repeat_password_label'),
(2042, 7, 'questions_question_password_label'),
(2043, 7, 'questions_question_email_label'),
(2044, 1, 'sidebar_menu_item_questions'),
(2047, 7, 'questions_question_username_label'),
(2397, 7, 'questions_account_type_ef5e279523aed72d87fd8a1fd59d592f'),
(2427, 7, 'questions_section_f90cde5913235d172603cc4e7b9726e3_label'),
(2051, 1, 'sidebar_menu_item_permissions'),
(2058, 7, 'widgets_customize_btn'),
(2059, 7, 'avatar_change'),
(2060, 7, 'avatar_console_edit_profile'),
(2061, 7, 'base_document_404_heading'),
(2062, 7, 'base_document_404'),
(2065, 7, 'view_all'),
(2066, 7, 'month_12'),
(2070, 7, 'user_list_menu_item_latest'),
(2071, 7, 'user_list_menu_item_featured'),
(2072, 7, 'widgets_finish_customize_btn'),
(2073, 7, 'widgets_reset_customization'),
(2074, 7, 'custom_html_widget_default_title'),
(2075, 1, 'sidebar_menu_admin'),
(2076, 7, 'widgets_section_box_title'),
(2077, 1, 'sidebar_menu_dashboard'),
(2078, 1, 'sidebar_menu_item_user_dashboard'),
(2079, 1, 'sidebar_menu_item_user_profile'),
(2080, 7, 'join_index_join_button'),
(2081, 1, 'sidebar_menu_plugins_manage'),
(2082, 7, 'authorization_role_guest'),
(2611, 7, 'massmailing_unsubscribe_successful'),
(2085, 7, 'widgets_action_edit'),
(2086, 7, 'widgets_action_delete'),
(2088, 7, 'custom_html_widget_content_label'),
(2093, 7, 'custom_html_widget_nl2br_label'),
(2096, 7, 'authorization_group_video'),
(2097, 7, 'authorization_action_video_add'),
(2098, 7, 'authorization_action_video_view'),
(2099, 7, 'authorization_group_photo'),
(2100, 7, 'authorization_action_photo_view'),
(2101, 7, 'authorization_action_photo_upload'),
(2102, 7, 'authorization_action_photo_add_comment'),
(2103, 7, 'authorization_action_photo_delete_comment_by_content_owner'),
(2104, 7, 'authorization_group_base'),
(2105, 7, 'authorization_action_base_add_comment'),
(2106, 7, 'authorization_action_base_delete_comment_by_content_owner'),
(2107, 1, 'back_to_site_label'),
(2108, 7, 'widgets_fb_default_settings_label'),
(2109, 7, 'widgets_default_settings_title'),
(2110, 7, 'widgets_default_settings_show_title'),
(2111, 7, 'widgets_default_settings_icon'),
(2112, 7, 'widgets_default_settings_wib'),
(2113, 7, 'widgets_default_settings_freeze'),
(2114, 7, 'widgets_admin_section_information'),
(2115, 7, 'widgets_admin_legend'),
(2116, 7, 'widgets_allow_customize_legend'),
(2117, 7, 'widgets_delete_component_confirm'),
(2118, 7, 'widgets_allow_customize_label'),
(2122, 7, 'widgets_fb_setting_box_title'),
(2130, 1, 'main_menu_item'),
(2125, 7, 'cmp_widget_wall_comments_count'),
(2126, 7, 'cmp_widget_wall_comments_mode'),
(2127, 7, 'cmp_widget_wall_comments_mode_option_2'),
(2128, 7, 'cmp_widget_wall_comments_mode_option_1'),
(2131, 7, 'user_list_widget_empty'),
(2132, 7, 'user_list_menu_item_online'),
(2134, 7, 'widgets_customize_label'),
(2135, 7, 'questions_question_birthdate_label'),
(2997, 7, 'base_join_menu_item'),
(2141, 1, 'admin_dashboard'),
(2142, 1, 'sidebar_menu_item_users'),
(2143, 1, 'sidebar_menu_item_main_settings'),
(2144, 7, 'view_index'),
(2145, 7, 'rss_widget_default_title'),
(2146, 7, 'rss_widget_count_label'),
(2147, 7, 'rss_widget_url_label'),
(2148, 7, 'rss_widget_url_invalid_msg'),
(2555, 7, 'email_verify_send_verify_mail_button_label'),
(2257, 1, 'questions_delete_question_confirmation'),
(2155, 7, 'join_promo'),
(2536, 1, 'questions_add_new_account_type'),
(2523, 1, 'questions_add_values_description'),
(2161, 1, 'heading_main_settings'),
(2162, 1, 'menu_item_basics'),
(9873, 1, 'heading_user_settings'),
(2164, 7, 'questions_question_accountType_description'),
(2165, 7, 'questions_question_username_description'),
(2166, 7, 'questions_question_email_description'),
(2167, 7, 'join_index'),
(2168, 1, 'site_installation'),
(2169, 1, 'site_title'),
(2171, 1, 'site_tagline_desc'),
(2172, 1, 'site_description'),
(2173, 1, 'site_description_desc'),
(2174, 1, 'time_settings'),
(2175, 1, 'timezone'),
(2176, 1, 'use_relative_time'),
(2177, 1, 'site_relative_time_desc'),
(2178, 7, 'questions_question_sex_label'),
(2179, 7, 'questions_question_sex_description'),
(2180, 7, 'questions_question_sex_value_1'),
(2181, 7, 'questions_question_sex_value_2'),
(2182, 7, 'questions_question_accountType_label'),
(2183, 7, 'questions_checkbox_value_true'),
(2184, 7, 'questions_checkbox_value_false'),
(2185, 1, 'main_settings_updated'),
(2186, 7, 'widgets_no_content'),
(2187, 7, 'rss_widget_title_only_label'),
(2188, 7, 'view_no_section_label'),
(4717, 1, 'core_update_leave_button_label'),
(3812, 1, 'menu_item_users_recently_active'),
(2196, 1, 'menu_item_user_roles'),
(2200, 7, 'questions_empty_lang_value'),
(2207, 7, 'authorization_group_blogs'),
(2208, 7, 'authorization_action_blogs_add_comment'),
(2214, 7, 'about_me_widget_inv_text'),
(2215, 7, 'about_me_widget_default_title'),
(2216, 7, 'about_me_widget_content_saved'),
(2217, 1, 'heading_browse_users'),
(2218, 1, 'no_users'),
(2219, 7, 'check_all'),
(2220, 7, 'with_selected'),
(2231, 1, 'joined'),
(2232, 1, 'user'),
(2233, 7, 'form_element_select_field_invitation_label'),
(2234, 7, 'form_element_common_invitation_text'),
(2235, 1, 'user_delete_msg'),
(2236, 1, 'confirm_delete_users'),
(2238, 7, 'questions_question_repeatPassword_description'),
(2642, 7, 'questions_question_realname_label'),
(2554, 7, 'email_verify_index'),
(2582, 1, 'massmailing_send_mails_message'),
(5832, 7, 'forgot_password_form_text'),
(2256, 1, 'questions_question_was_deleted'),
(2269, 7, 'component_sign_in_login_invitation'),
(2270, 7, 'rates_box_cap_label'),
(2271, 1, 'questions_section_was_deleted'),
(2430, 7, 'questions_admin_description_label'),
(2429, 7, 'questions_admin_question_label'),
(2329, 7, 'questions_menu_add'),
(2330, 7, 'questions_menu_editAccountType'),
(2436, 7, 'copyright'),
(2324, 7, 'questions_account_type_was_added'),
(2314, 1, 'questions_account_type_was_deleted'),
(2307, 7, 'questions_admin_edit_label'),
(2308, 7, 'questions_admin_delete_label'),
(2660, 7, 'suspended_user_page_content'),
(2328, 7, 'questions_menu_index'),
(2312, 7, 'forgot_password_cap_label'),
(2313, 7, 'forgot_password_email_invitation_message'),
(2315, 7, 'forgot_password_mail_template_subject'),
(6052, 7, 'reset_password_mail_template_subject'),
(2365, 7, 'questions_menu_settings'),
(2420, 7, 'questions_admin_add_new_values'),
(2333, 7, 'comments_add_auth_message'),
(2334, 7, 'questions_question_presentation_text_label'),
(2335, 7, 'questions_question_presentation_select_label'),
(2336, 7, 'questions_question_presentation_radio_label'),
(2337, 7, 'questions_question_presentation_textarea_label'),
(2338, 7, 'questions_question_presentation_checkbox_label'),
(2339, 7, 'questions_question_presentation_multicheckbox_label'),
(2340, 7, 'questions_question_presentation_date_label'),
(2341, 7, 'questions_question_presentation_url_label'),
(2342, 7, 'questions_question_presentation_password_label'),
(2654, 7, 'email_verify_verify_mail_was_sent'),
(2655, 7, 'suspend_user_btn'),
(2656, 7, 'user_suspend_btn_lbl'),
(2366, 7, 'questions_config_user_view_presentation_description'),
(2355, 1, 'sidebar_menu_item_plugin_blogs'),
(2356, 1, 'sidebar_menu_item_plugin_links'),
(2367, 7, 'questions_config_user_view_presentation_label'),
(2368, 7, 'authorization_action_blogs_add'),
(2370, 7, 'authorization_action_blogs_view'),
(2374, 7, 'edit_button'),
(2375, 7, 'edit_successfull_edit'),
(2376, 7, 'edit_index'),
(2390, 1, 'questions_edit_section_name_title'),
(2381, 7, 'widgets_panel_dashboard_label'),
(2382, 1, 'page_title_manage_plugins'),
(2383, 1, 'manage_plugins_active_box_cap_label'),
(2384, 1, 'manage_plugins_inactive_box_cap_label'),
(2385, 1, 'manage_plugins_settings_button_label'),
(2386, 1, 'manage_plugins_deactivate_button_label'),
(2387, 1, 'manage_plugins_activate_button_label'),
(2388, 1, 'manage_plugins_uninstall_button_label'),
(2389, 1, 'manage_plugins_install_button_label'),
(2391, 1, 'questions_edit_question_value_title'),
(2392, 1, 'questions_edit_question_name_title'),
(2393, 1, 'questions_edit_question_description_title'),
(2394, 7, 'questions_account_type_all'),
(2395, 1, 'questions_edit_account_type_name_title'),
(2396, 1, 'manage_plugins_install_success_message'),
(2406, 7, 'questions_account_type_290365aadde35a97f11207ca7e4279cc'),
(2405, 1, 'questions_delete_account_type_confirmation'),
(2593, 7, 'massmailing_unsubscribe'),
(2594, 1, 'permissions_roles_deleted_msg'),
(2599, 1, 'permissions_user_role'),
(2600, 1, 'permissions_number_of_users'),
(2595, 1, 'permissions_please_select_role'),
(2589, 1, 'permissions_role_added_msg'),
(2588, 1, 'permissions_add_form_role_lbl'),
(2581, 7, 'rate_cmp_success_message'),
(2425, 7, 'auth_identity_not_found_error_message'),
(2426, 7, 'auth_invlid_password_error_message'),
(2431, 7, 'auth_success_message'),
(2468, 1, 'msg_lang_cloned'),
(2469, 1, 'heading_questions'),
(2472, 1, 'languages_page_heading'),
(2473, 1, 'questions_account_type_label'),
(2474, 1, 'questions_new_question_label'),
(2475, 1, 'questions_question_name_label'),
(2477, 1, 'questions_for_account_type_label'),
(2478, 1, 'questions_for_account_type_description'),
(2479, 1, 'questions_question_section_label'),
(2480, 1, 'questions_answer_type_label'),
(2485, 1, 'questions_possible_values_label'),
(2486, 1, 'questions_possible_values_description'),
(2487, 1, 'questions_columns_count_label'),
(2488, 1, 'questions_required_label'),
(2489, 1, 'questions_required_description'),
(2490, 1, 'questions_on_sing_up_label'),
(2491, 1, 'questions_on_sing_up_description'),
(2492, 1, 'questions_on_edit_label'),
(2493, 1, 'questions_on_edit_description'),
(2494, 1, 'questions_on_view_label'),
(2495, 1, 'questions_on_view_description'),
(2496, 1, 'questions_on_search_description'),
(2497, 1, 'questions_on_search_label'),
(2498, 1, 'questions_save_and_new_label'),
(2585, 1, 'massmailing_unsubscribe_link_text'),
(2584, 1, 'massmailing_unsubscribe_link_html'),
(2501, 1, 'questions_add_question_message'),
(2504, 1, 'questions_update_question_message'),
(2503, 1, 'pages_page_field_content_desc'),
(2505, 1, 'pages_new_form_or'),
(2506, 1, 'questions_edit_delete_value_confirm_message'),
(2511, 1, 'pages_page_field_meta_desc'),
(2514, 1, 'questions_admin_add_new_values'),
(2513, 1, 'questions_edit_question_description_label'),
(2515, 1, 'questions_admin_existing_values'),
(2516, 1, 'questions_admin_dragndrop_reorder'),
(2517, 1, 'questions_add_question_values_title'),
(2518, 1, 'questions_question_was_not_update_message'),
(2519, 1, 'questions_question_was_not_updated_message'),
(2541, 1, 'questions_section_was_added'),
(2522, 1, 'questions_add_values_label'),
(2525, 1, 'questions_add_values_submit_button'),
(2526, 1, 'pages_page_heading'),
(2531, 1, 'questions_empty_lang_value'),
(2529, 1, 'questions_question_is_not_exist'),
(2533, 1, 'questions_add_question_values_message'),
(2542, 1, 'questions_index_info_txt'),
(2540, 1, 'questions_account_type_was_added'),
(2543, 1, 'questions_index_drag_n_drop_info_txt'),
(2544, 1, 'questions_add_new_question_button'),
(2545, 1, 'questions_profile_question_sections_title'),
(2546, 1, 'questions_section_info_txt'),
(2547, 1, 'questions_new_section_label'),
(2549, 1, 'questions_delete_section_confirmation'),
(2557, 7, 'email_verify_template_text'),
(2558, 7, 'email_verify_email_verify_success'),
(2559, 1, 'questions_add_new_section_button'),
(2560, 7, 'questions_question_password_description'),
(2561, 7, 'new_message_count_text'),
(2562, 1, 'sidebar_menu_item_dev_langs'),
(2661, 7, 'user_feedback_profile_unsuspended'),
(2564, 7, 'email_verify_promo'),
(2565, 7, 'email_verify_email_verify_fail'),
(2568, 1, 'permissions_edit_role_btn'),
(2569, 1, 'permissions_add_role_btn'),
(2570, 1, 'massmailing_ignore_unsubscribe_label'),
(2571, 1, 'massmailing_email_format_html'),
(2572, 1, 'massmailing_email_format_text'),
(2573, 1, 'massmailing_body_label'),
(2574, 1, 'massmailing_subject_label'),
(2575, 1, 'massmailing_email_format_label'),
(2576, 1, 'massmailing_user_section_label'),
(2577, 1, 'massmailing_total_members'),
(2578, 1, 'massmailing_preview_label'),
(2579, 1, 'massmailing_compose_email'),
(2580, 1, 'massmailing_start_mailing_button'),
(2602, 1, 'permissions_check_all_selected'),
(2603, 1, 'permissions_delete_role'),
(2604, 1, 'permissions_are_you_sure'),
(2605, 1, 'permissions_go_to_permissions_page'),
(2609, 7, 'authorization_role_wqewq'),
(2612, 7, 'massmailing_unsubscribe_failed'),
(2613, 1, 'massmailing'),
(2615, 7, 'questions_section_user_photo_label'),
(2616, 7, 'questions_section_captcha_label'),
(2707, 7, 'questions_question_relationship_label'),
(2620, 1, 'massmailing_following_variables_text'),
(2850, 7, 'widgets_admin_customization_box_title'),
(2626, 1, 'user_display_settings'),
(2627, 1, 'user_avatar_settings'),
(2628, 1, 'user_settings_updated'),
(2629, 1, 'user_settings_avatar_size'),
(2630, 1, 'user_settings_big_avatar_size'),
(2632, 1, 'user_settings_display_name'),
(2633, 1, 'user_settings_display_name_desc'),
(2634, 1, 'user_settings_avatar_size_desc'),
(2635, 1, 'user_settings_big_avatar_size_desc'),
(2662, 7, 'user_unsuspend_btn_lbl'),
(2657, 7, 'user_feedback_profile_suspended'),
(2659, 1, 'user_feedback_profiles_suspended'),
(2736, 1, 'pages_edit_local_page_content'),
(2735, 1, 'pages_edit_local_visible_for'),
(2743, 1, 'themes_settings_reset_label'),
(2667, 7, 'widgets_admin_dashboard_heading'),
(2668, 7, 'widgets_admin_profile_heading'),
(2670, 7, 'join_successful_join'),
(2671, 7, 'user_page_suspended'),
(2672, 7, 'form_validate_common_error_message'),
(2673, 7, 'profile_view_title'),
(2674, 7, 'profile_view_heading'),
(2675, 7, 'my_profile_title'),
(2676, 1, 'my_profile_heading'),
(2677, 1, 'theme_settings_reset_confirm_message'),
(2680, 1, 'theme_graphics_image_delete_confirm_message'),
(2732, 1, 'pages_edit_local_menu_name'),
(2784, 1, 'permissions_successfully_updated'),
(2734, 1, 'pages_edit_local_page_url'),
(2733, 1, 'pages_edit_local_page_title'),
(2699, 7, 'questions_question_match_sex_description'),
(2698, 7, 'questions_question_match_sex_label'),
(2703, 7, 'questions_question_match_sex_value_2'),
(2702, 7, 'questions_question_match_sex_value_1'),
(2731, 1, 'pages_edit_external_visible_for'),
(2708, 7, 'questions_question_relationship_description'),
(2834, 1, 'permissions_go_to_role_management_page'),
(2727, 1, 'pages_edit_external_menu_name_label'),
(2728, 1, 'pages_edit_external_url_label'),
(2729, 7, 'comments_add_login_message'),
(2730, 1, 'pages_edit_external_url_open_in_new_window'),
(2723, 7, 'questions_question_relationship_value_1'),
(2724, 7, 'questions_question_relationship_value_2'),
(2725, 7, 'questions_question_relationship_value_4'),
(2726, 7, 'questions_question_relationship_value_8'),
(2737, 1, 'pages_edit_visible_for_guests'),
(2738, 1, 'pages_edit_visible_for_members'),
(2739, 1, 'pages_add_menu_name'),
(2740, 1, 'pages_add_page_content'),
(2741, 1, 'page_add_page_address'),
(2744, 7, 'alljordan'),
(2745, 7, 'alljordan_forum'),
(2746, 7, 'openwack'),
(2747, 1, 'themes_settings_graphics_preview_cap_label'),
(2748, 7, 'my_profile_heading'),
(3016, 7, 'local_page_title_page-283934'),
(2860, 7, 'component_add_new_box_cap_label'),
(2783, 1, 'permissions_page_heading'),
(2785, 1, 'permissions_feedback_user_not_found'),
(2786, 1, 'permissions_feedback_moderator_added'),
(2789, 1, 'permissions_feedback_user_kicked_from_moders'),
(2788, 1, 'permissions_feedback_user_is_already_moderator'),
(2790, 1, 'permissions_feedback_cant_remove_moder'),
(2791, 1, 'permissions_index_who_can_join'),
(2792, 1, 'permissions_index_anyone_can_join'),
(2793, 1, 'permissions_index_by_invitation_only_can_join'),
(2794, 1, 'permissions_index_who_can_invite'),
(2795, 1, 'permissions_index_all_users_can_invate'),
(2796, 1, 'permissions_index_admin_only_can_invate'),
(2798, 1, 'permissions_index_mandatory_member_approve'),
(2799, 1, 'permissions_index_moders_approve_members_manually'),
(2800, 1, 'permissions_index_guests_can_view_site'),
(2801, 1, 'permissions_index_yes'),
(2802, 1, 'permissions_index_no'),
(2804, 1, 'permissions_index_with_password'),
(2805, 1, 'permissions_idex_if_not_yes_will_override_settings'),
(2806, 1, 'permissions_index_save'),
(2807, 1, 'permissions_moders_content'),
(2809, 1, 'permissions_moders_add_moder'),
(2810, 1, 'permissions_moders_username'),
(2812, 1, 'permissions_moders_make_moderator'),
(2815, 7, 'empty_list'),
(2822, 1, 'sidebar_menu_item_plugin_mass_mailing'),
(2823, 7, 'authorization_action_video_add_comment'),
(2824, 7, 'authorization_action_video_delete_comment_by_content_owner'),
(2825, 1, 'confirm_suspend_users'),
(2827, 7, 'authorization_action_blogs_delete_comment_by_content_owner'),
(2829, 7, 'users_browse_page_heading'),
(2830, 1, 'manage_plugins_activate_success_message'),
(2831, 1, 'manage_plugins_deactivate_success_message'),
(2835, 7, 'authorization_failed_feedback'),
(2843, 7, 'authorization_failed_msg'),
(2844, 7, 'form_validator_required_error_message'),
(2845, 7, 'comments_widget_label'),
(2846, 7, 'avatar_widget'),
(2847, 7, 'email_verify_subject'),
(2868, 7, 'questions_question_d37d41b71a78dfb62b379d0aa7bd3ba5_value_1'),
(2869, 7, 'questions_question_birthdate_description'),
(2870, 7, 'questions_question_9221d78a4201eac23c972e1d4aa2cee6_description'),
(2871, 7, 'questions_question_c441a8a9b955647cdf4c81562d39068a_description'),
(2872, 7, 'questions_question_user_photo_description'),
(2876, 1, 'languages_values_updated'),
(2877, 7, 'user_no_users'),
(2880, 1, 'site_email'),
(2881, 1, 'site_email_desc'),
(2884, 7, 'activity_widget_title'),
(3011, 1, 'sidebar_menu_item_plugin_contact_importer'),
(3012, 7, 'rate_cmp_auth_error_message'),
(3021, 7, 'local_page_title_page-225003'),
(3029, 7, 'page-728242'),
(3018, 7, 'local_page_content_page-283934'),
(2895, 7, 'month_1'),
(2899, 7, 'user_feedback_marked_as_featured'),
(2900, 7, 'user_feedback_unmarked_as_featured'),
(2901, 7, 'user_action_mark_as_featured'),
(2902, 7, 'user_action_unmark_as_featured'),
(2903, 7, 'authorization_group_friends'),
(2904, 7, 'authorization_action_friends_add_friend'),
(2906, 7, 'avatar_select_image'),
(2923, 7, 'change_password'),
(2924, 7, 'change_password_old_password'),
(2925, 7, 'change_password_new_password'),
(2926, 7, 'change_password_repeat_password'),
(2927, 7, 'change_password_success'),
(2928, 7, 'change_password_error'),
(2932, 7, 'avatar_activity_string'),
(2934, 7, 'join_activity_string'),
(2935, 7, 'join_activity_user_avatar'),
(2936, 7, 'edit_activity_string'),
(2958, 7, 'widgets_reset_position_confirm'),
(5796, 7, 'authorization_group_membership'),
(2993, 7, 'unsuspend_user_btn'),
(2994, 7, 'user_feedback_profiles_unsuspended'),
(2995, 1, 'user_feedback_profiles_unsuspended'),
(3770, 7, 'flag_spam'),
(3023, 7, 'local_page_content_page-225003'),
(3025, 7, 'local_page_title_page-6940'),
(3027, 7, 'local_page_content_page-6940'),
(3030, 7, 'local_page_title_page-728242'),
(3032, 7, 'local_page_content_page-728242'),
(3037, 7, 'delete_user_cancel_button'),
(3034, 7, 'local_page_title_page-366195'),
(3036, 7, 'local_page_content_page-366195'),
(3038, 7, 'delete_user_delete_button'),
(3039, 7, 'delete_user_index'),
(3040, 7, 'edit_profile_link'),
(3041, 7, 'delete_profile'),
(3045, 7, 'delete_user_confirmation'),
(3046, 7, 'email_verify_verification_code_label'),
(3050, 7, 'email_verify_invalid_verification_code'),
(3048, 7, 'email_verify_verification_code_submit_button_label'),
(3049, 7, 'email_verify_form_promo'),
(3051, 7, 'questions_config_date_field_format_label'),
(3052, 7, 'questions_config_date_field_format_mdy'),
(3053, 7, 'questions_config_date_field_format_dmy'),
(3054, 1, 'question_settings_updated'),
(3056, 7, 'delete_user_content_label'),
(3066, 7, 'local_page_title_page-775058'),
(3068, 7, 'local_page_content_page-775058'),
(3070, 7, 'local_page_title_page-312097'),
(3072, 7, 'local_page_content_page-312097'),
(3077, 7, 'profile_toolbar_user_delete_label'),
(3078, 7, 'delete_user_confirmation_label'),
(3079, 7, 'delete_user_success_message'),
(3081, 7, 'admin_delete_user_text'),
(3082, 1, 'mail_settings_updated'),
(3083, 1, 'menu_item_mail_settings'),
(3084, 1, 'mail_smtp_title_enabled'),
(3085, 1, 'mail_smtp_title_enabled_desc'),
(3086, 1, 'mail_smtp_title_host'),
(3087, 1, 'mail_smtp_title_user'),
(3088, 1, 'mail_smtp_title_password'),
(3089, 1, 'mail_smtp_connection_prefix'),
(3090, 1, 'mail_smtp_connection_prefix_desc'),
(3092, 1, 'heading_mail_settings'),
(3097, 1, 'mail_smtp_secure_invitation'),
(3096, 1, 'mail_smtp_test_connection_title'),
(3098, 1, 'mail_smtp_connection_desc'),
(3099, 1, 'mail_smtp_test_connection_btn'),
(3100, 1, 'smtp_test_connection_success'),
(3101, 7, 'month_3'),
(3102, 7, 'month_4'),
(3104, 7, 'month_5'),
(3105, 7, 'month_6'),
(3106, 7, 'month_7'),
(3107, 7, 'month_10'),
(3108, 7, 'month_11'),
(3114, 7, 'questions_question_presentation_age_label'),
(3115, 7, 'questions_question_presentation_birthdate_label'),
(3116, 7, 'questions_age_year_old'),
(4661, 1, 'manage_plugins_core_update_request_box_cap_label'),
(4662, 1, 'manage_plugins_core_update_request_text'),
(3349, 1, 'sign_in_button_list_text'),
(3256, 1, 'splash_screen_page_title'),
(3257, 1, 'splash_screen_page_heading'),
(3230, 7, 'join_form_title'),
(3231, 7, 'join_connect_title'),
(3232, 7, 'join_or'),
(3352, 7, 'authorization_feedback_roles_updated'),
(3235, 1, 'permission_global_privacy_settings_success_message'),
(3236, 7, 'password_protection_cap_label'),
(3237, 7, 'password_protection_text'),
(3238, 7, 'password_protection_submit_label'),
(3239, 7, 'password_protection_success_message'),
(3240, 7, 'password_protection_error_message'),
(3241, 7, 'paging_label_first'),
(3242, 7, 'paging_label_prev'),
(3243, 7, 'paging_label_next'),
(3244, 7, 'paging_label_last'),
(3246, 1, 'splash_intro_label'),
(3247, 1, 'splash_intro_desc'),
(3248, 1, 'splash_button_label'),
(3249, 1, 'splash_button_label_desc'),
(3250, 1, 'splash_leave_url_label'),
(3251, 1, 'splash_leave_url_desc'),
(3252, 1, 'splash_intro_value'),
(3253, 1, 'splash_button_value'),
(3261, 1, 'sidebar_menu_item_splash_screen'),
(3258, 1, 'splash_screen_section_label'),
(3259, 1, 'splash_screen_submit_success_message'),
(3260, 1, 'splash_leave_button_label'),
(3274, 7, 'join_not_valid_invite_code'),
(3308, 7, 'authorization_user_roles'),
(3283, 1, 'splash_enable_label'),
(3284, 1, 'splash_enable_desc'),
(3285, 1, 'invite_members_button_label'),
(3286, 1, 'invite_members_cap_label'),
(3287, 1, 'invite_members_textarea_invitation_text'),
(3288, 1, 'invite_members_submit_label'),
(3289, 1, 'invite_members_max_limit_message'),
(3290, 1, 'invite_members_min_limit_message'),
(3291, 1, 'invite_members_success_message'),
(3292, 7, 'mail_template_admin_invite_user_subject'),
(3293, 7, 'mail_template_admin_invite_user_content_html'),
(3294, 7, 'mail_template_admin_invite_user_content_text'),
(3309, 7, 'authorization_give_user_role'),
(3345, 7, 'moderator_panel'),
(3346, 7, 'approve_users'),
(3347, 7, 'wait_for_approval'),
(3348, 1, 'permissions_index_user_approve'),
(3351, 7, 'profile_toolbar_user_approve_label'),
(3353, 7, 'user_approved'),
(3354, 7, 'user_approved_mail_subject'),
(3355, 7, 'user_approved_mail_txt'),
(3356, 7, 'user_approved_mail_html'),
(3371, 1, 'sidebar_menu_item_maintenance'),
(3372, 1, 'maintenance_page_heading'),
(3373, 1, 'maintenance_section_label'),
(3374, 1, 'maintenance_text_value'),
(3379, 1, 'maintenance_enable_label'),
(3380, 1, 'maintenance_enable_desc'),
(3381, 1, 'maintenance_text_label'),
(3382, 1, 'maintenance_text_desc'),
(3383, 1, 'maintenance_submit_success_message'),
(3391, 7, 'geolocation_country_name_ABW'),
(3392, 7, 'geolocation_country_name_AFG'),
(3393, 7, 'geolocation_country_name_AGO'),
(3394, 7, 'geolocation_country_name_AIA'),
(3395, 7, 'geolocation_country_name_ALB'),
(3396, 7, 'geolocation_country_name_AND'),
(3397, 7, 'geolocation_country_name_ANT'),
(3398, 7, 'geolocation_country_name_ARE'),
(3399, 7, 'geolocation_country_name_ARG'),
(3400, 7, 'geolocation_country_name_ARM'),
(3401, 7, 'geolocation_country_name_ASM'),
(3402, 7, 'geolocation_country_name_ATA'),
(3403, 7, 'geolocation_country_name_ATF'),
(3404, 7, 'geolocation_country_name_ATG'),
(3405, 7, 'geolocation_country_name_AUS'),
(3406, 7, 'geolocation_country_name_AUT'),
(3407, 7, 'geolocation_country_name_AZE'),
(3408, 7, 'geolocation_country_name_BDI'),
(3409, 7, 'geolocation_country_name_BEL'),
(3410, 7, 'geolocation_country_name_BEN'),
(3411, 7, 'geolocation_country_name_BFA'),
(3412, 7, 'geolocation_country_name_BGD'),
(3413, 7, 'geolocation_country_name_BGR'),
(3414, 7, 'geolocation_country_name_BHR'),
(3415, 7, 'geolocation_country_name_BHS'),
(3416, 7, 'geolocation_country_name_BIH'),
(3417, 7, 'geolocation_country_name_BLR'),
(3418, 7, 'geolocation_country_name_BLZ'),
(3419, 7, 'geolocation_country_name_BMU'),
(3420, 7, 'geolocation_country_name_BOL'),
(3421, 7, 'geolocation_country_name_BRA'),
(3422, 7, 'geolocation_country_name_BRB'),
(3423, 7, 'geolocation_country_name_BRN'),
(3424, 7, 'geolocation_country_name_BTN'),
(3425, 7, 'geolocation_country_name_BVT'),
(3426, 7, 'geolocation_country_name_BWA'),
(3427, 7, 'geolocation_country_name_CAF'),
(3428, 7, 'geolocation_country_name_CAN'),
(3429, 7, 'geolocation_country_name_CHE'),
(3430, 7, 'geolocation_country_name_CHL'),
(3431, 7, 'geolocation_country_name_CHN'),
(3432, 7, 'geolocation_country_name_CIV'),
(3433, 7, 'geolocation_country_name_CMR'),
(3434, 7, 'geolocation_country_name_COD'),
(3435, 7, 'geolocation_country_name_COG'),
(3436, 7, 'geolocation_country_name_COK'),
(3437, 7, 'geolocation_country_name_COL'),
(3438, 7, 'geolocation_country_name_COM'),
(3439, 7, 'geolocation_country_name_CPV'),
(3440, 7, 'geolocation_country_name_CRI'),
(3441, 7, 'geolocation_country_name_CUB'),
(3442, 7, 'geolocation_country_name_CYM'),
(3443, 7, 'geolocation_country_name_CYP'),
(3444, 7, 'geolocation_country_name_CZE'),
(3445, 7, 'geolocation_country_name_DEU'),
(3446, 7, 'geolocation_country_name_DJI'),
(3447, 7, 'geolocation_country_name_DMA'),
(3448, 7, 'geolocation_country_name_DNK'),
(3449, 7, 'geolocation_country_name_DOM'),
(3450, 7, 'geolocation_country_name_DZA'),
(3451, 7, 'geolocation_country_name_ECU'),
(3452, 7, 'geolocation_country_name_EGY'),
(3453, 7, 'geolocation_country_name_ERI'),
(3454, 7, 'geolocation_country_name_ESP'),
(3455, 7, 'geolocation_country_name_EST'),
(3456, 7, 'geolocation_country_name_ETH'),
(3457, 7, 'geolocation_country_name_FIN'),
(3458, 7, 'geolocation_country_name_FJI'),
(3459, 7, 'geolocation_country_name_FLK'),
(3460, 7, 'geolocation_country_name_FRA'),
(3461, 7, 'geolocation_country_name_FRO'),
(3462, 7, 'geolocation_country_name_FSM'),
(3463, 7, 'geolocation_country_name_GAB'),
(3464, 7, 'geolocation_country_name_GBR'),
(3465, 7, 'geolocation_country_name_GEO'),
(3466, 7, 'geolocation_country_name_GGY'),
(3467, 7, 'geolocation_country_name_GHA'),
(3468, 7, 'geolocation_country_name_GIB'),
(3469, 7, 'geolocation_country_name_GIN'),
(3470, 7, 'geolocation_country_name_GLP'),
(3471, 7, 'geolocation_country_name_GMB'),
(3472, 7, 'geolocation_country_name_GNB'),
(3473, 7, 'geolocation_country_name_GNQ'),
(3474, 7, 'geolocation_country_name_GRC'),
(3475, 7, 'geolocation_country_name_GRD'),
(3476, 7, 'geolocation_country_name_GRL'),
(3477, 7, 'geolocation_country_name_GTM'),
(3478, 7, 'geolocation_country_name_GUF'),
(3479, 7, 'geolocation_country_name_GUM'),
(3480, 7, 'geolocation_country_name_GUY'),
(3481, 7, 'geolocation_country_name_HKG'),
(3482, 7, 'geolocation_country_name_HND'),
(3483, 7, 'geolocation_country_name_HRV'),
(3484, 7, 'geolocation_country_name_HTI'),
(3485, 7, 'geolocation_country_name_HUN'),
(3486, 7, 'geolocation_country_name_IDN'),
(3487, 7, 'geolocation_country_name_IMN'),
(3488, 7, 'geolocation_country_name_IND'),
(3489, 7, 'geolocation_country_name_IOT'),
(3490, 7, 'geolocation_country_name_IRL'),
(3491, 7, 'geolocation_country_name_IRN'),
(3492, 7, 'geolocation_country_name_IRQ'),
(3493, 7, 'geolocation_country_name_ISL'),
(3494, 7, 'geolocation_country_name_ISR'),
(3495, 7, 'geolocation_country_name_ITA'),
(3496, 7, 'geolocation_country_name_JAM'),
(3497, 7, 'geolocation_country_name_JEY'),
(3498, 7, 'geolocation_country_name_JOR'),
(3499, 7, 'geolocation_country_name_JPN'),
(3500, 7, 'geolocation_country_name_KAZ'),
(3501, 7, 'geolocation_country_name_KEN'),
(3502, 7, 'geolocation_country_name_KGZ'),
(3503, 7, 'geolocation_country_name_KHM'),
(3504, 7, 'geolocation_country_name_KIR'),
(3505, 7, 'geolocation_country_name_KNA'),
(3506, 7, 'geolocation_country_name_KOR'),
(3507, 7, 'geolocation_country_name_KWT'),
(3508, 7, 'geolocation_country_name_LAO'),
(3509, 7, 'geolocation_country_name_LBN'),
(3510, 7, 'geolocation_country_name_LBR'),
(3511, 7, 'geolocation_country_name_LBY'),
(3512, 7, 'geolocation_country_name_LCA'),
(3513, 7, 'geolocation_country_name_LIE'),
(3514, 7, 'geolocation_country_name_LKA'),
(3515, 7, 'geolocation_country_name_LSO'),
(3516, 7, 'geolocation_country_name_LTU'),
(3517, 7, 'geolocation_country_name_LUX'),
(3518, 7, 'geolocation_country_name_LVA'),
(3519, 7, 'geolocation_country_name_MAC'),
(3520, 7, 'geolocation_country_name_MAF'),
(3521, 7, 'geolocation_country_name_MAR'),
(3522, 7, 'geolocation_country_name_MCO'),
(3523, 7, 'geolocation_country_name_MDA'),
(3524, 7, 'geolocation_country_name_MDG'),
(3525, 7, 'geolocation_country_name_MDV'),
(3526, 7, 'geolocation_country_name_MEX'),
(3527, 7, 'geolocation_country_name_MHL'),
(3528, 7, 'geolocation_country_name_MKD'),
(3529, 7, 'geolocation_country_name_MLI'),
(3530, 7, 'geolocation_country_name_MLT'),
(3531, 7, 'geolocation_country_name_MMR'),
(3532, 7, 'geolocation_country_name_MNE'),
(3533, 7, 'geolocation_country_name_MNG'),
(3534, 7, 'geolocation_country_name_MNP'),
(3535, 7, 'geolocation_country_name_MOZ'),
(3536, 7, 'geolocation_country_name_MRT'),
(3537, 7, 'geolocation_country_name_MSR'),
(3538, 7, 'geolocation_country_name_MTQ'),
(3539, 7, 'geolocation_country_name_MUS'),
(3540, 7, 'geolocation_country_name_MWI'),
(3541, 7, 'geolocation_country_name_MYS'),
(3542, 7, 'geolocation_country_name_MYT'),
(3543, 7, 'geolocation_country_name_NAM'),
(3544, 7, 'geolocation_country_name_NCL'),
(3545, 7, 'geolocation_country_name_NER'),
(3546, 7, 'geolocation_country_name_NFK'),
(3547, 7, 'geolocation_country_name_NGA'),
(3548, 7, 'geolocation_country_name_NIC'),
(3549, 7, 'geolocation_country_name_NIU'),
(3550, 7, 'geolocation_country_name_NLD'),
(3551, 7, 'geolocation_country_name_NOR'),
(3552, 7, 'geolocation_country_name_NPL'),
(3553, 7, 'geolocation_country_name_NRU'),
(3554, 7, 'geolocation_country_name_NZL'),
(3555, 7, 'geolocation_country_name_OMN'),
(3556, 7, 'geolocation_country_name_PAK'),
(3557, 7, 'geolocation_country_name_PAN'),
(3558, 7, 'geolocation_country_name_PER'),
(3559, 7, 'geolocation_country_name_PHL'),
(3560, 7, 'geolocation_country_name_PLW'),
(3561, 7, 'geolocation_country_name_PNG'),
(3562, 7, 'geolocation_country_name_POL'),
(3563, 7, 'geolocation_country_name_PRI'),
(3564, 7, 'geolocation_country_name_PRK'),
(3565, 7, 'geolocation_country_name_PRT'),
(3566, 7, 'geolocation_country_name_PRY'),
(3567, 7, 'geolocation_country_name_PSE'),
(3568, 7, 'geolocation_country_name_PYF'),
(3569, 7, 'geolocation_country_name_QAT'),
(3570, 7, 'geolocation_country_name_REU'),
(3571, 7, 'geolocation_country_name_ROM'),
(3572, 7, 'geolocation_country_name_RUS'),
(3573, 7, 'geolocation_country_name_RWA'),
(3574, 7, 'geolocation_country_name_SAU'),
(3575, 7, 'geolocation_country_name_SCG'),
(3576, 7, 'geolocation_country_name_SDN'),
(3577, 7, 'geolocation_country_name_SEN'),
(3578, 7, 'geolocation_country_name_SGP'),
(3579, 7, 'geolocation_country_name_SGS'),
(3580, 7, 'geolocation_country_name_SLB'),
(3581, 7, 'geolocation_country_name_SLE'),
(3582, 7, 'geolocation_country_name_SLV'),
(3583, 7, 'geolocation_country_name_SMR'),
(3584, 7, 'geolocation_country_name_SOM'),
(3585, 7, 'geolocation_country_name_SPM'),
(3586, 7, 'geolocation_country_name_SRB'),
(3587, 7, 'geolocation_country_name_STP'),
(3588, 7, 'geolocation_country_name_SUR'),
(3589, 7, 'geolocation_country_name_SVK'),
(3590, 7, 'geolocation_country_name_SVN'),
(3591, 7, 'geolocation_country_name_SWE'),
(3592, 7, 'geolocation_country_name_SWZ'),
(3593, 7, 'geolocation_country_name_SYC'),
(3594, 7, 'geolocation_country_name_SYR'),
(3595, 7, 'geolocation_country_name_TCA'),
(3596, 7, 'geolocation_country_name_TCD'),
(3597, 7, 'geolocation_country_name_TGO'),
(3598, 7, 'geolocation_country_name_THA'),
(3599, 7, 'geolocation_country_name_TJK'),
(3600, 7, 'geolocation_country_name_TKL'),
(3601, 7, 'geolocation_country_name_TKM'),
(3602, 7, 'geolocation_country_name_TLS'),
(3603, 7, 'geolocation_country_name_TON'),
(3604, 7, 'geolocation_country_name_TTO'),
(3605, 7, 'geolocation_country_name_TUN'),
(3606, 7, 'geolocation_country_name_TUR'),
(3607, 7, 'geolocation_country_name_TUV'),
(3608, 7, 'geolocation_country_name_TWN'),
(3609, 7, 'geolocation_country_name_TZA'),
(3610, 7, 'geolocation_country_name_UGA'),
(3611, 7, 'geolocation_country_name_UKR'),
(3612, 7, 'geolocation_country_name_UMI'),
(3613, 7, 'geolocation_country_name_URY'),
(3614, 7, 'geolocation_country_name_USA'),
(3615, 7, 'geolocation_country_name_UZB'),
(3616, 7, 'geolocation_country_name_VAT'),
(3617, 7, 'geolocation_country_name_VCT'),
(3618, 7, 'geolocation_country_name_VEN'),
(3619, 7, 'geolocation_country_name_VGB'),
(3620, 7, 'geolocation_country_name_VIR'),
(3621, 7, 'geolocation_country_name_VNM'),
(3622, 7, 'geolocation_country_name_VUT'),
(3623, 7, 'geolocation_country_name_WLF'),
(3624, 7, 'geolocation_country_name_WSM'),
(3625, 7, 'geolocation_country_name_YEM'),
(3626, 7, 'geolocation_country_name_ZAF'),
(3627, 7, 'geolocation_country_name_ZMB'),
(3628, 7, 'geolocation_country_name_ZWE'),
(3665, 7, 'unique_local_page_error'),
(15455, 1, 'ads_index_list_box_cap_label'),
(3790, 7, 'flags_users_reported'),
(3791, 7, 'flags_deleted'),
(3792, 7, 'dashboard_heading'),
(3798, 1, 'sidebar_menu_item_plugin_board'),
(3808, 1, 'maintenance_page_title'),
(3813, 1, 'menu_item_users_suspended'),
(3814, 1, 'menu_item_users_unverified'),
(3815, 1, 'menu_item_users_unapproved'),
(3816, 1, 'user_status'),
(3819, 1, 'user_status_unapproved'),
(3817, 1, 'user_status_suspended'),
(3818, 1, 'user_status_unverified'),
(3735, 1, 'search_by_name'),
(3771, 7, 'flag_offence'),
(3772, 7, 'flag_illegal'),
(3773, 7, 'flag_as'),
(3774, 7, 'flag_flag'),
(3776, 7, 'flag_accepted'),
(3777, 7, 'flag_already_flagged'),
(3823, 1, 'user_search_result'),
(3820, 7, 'activity_stamp'),
(3821, 7, 'activity_online'),
(3843, 7, 'pages_add_submit'),
(15466, 1, 'themes_add_new_box_cap_label'),
(3828, 7, 'users'),
(3829, 7, 'for_approval'),
(3830, 7, 'flagged_content'),
(3831, 1, 'heading_user_roles'),
(3832, 1, 'heading_user_role'),
(3833, 1, 'back_to_roles'),
(3834, 1, 'sidebar_menu_item_permission'),
(3835, 1, 'sidebar_menu_item_roles'),
(3836, 1, 'sidebar_menu_item_permission_roles'),
(3837, 1, 'sidebar_menu_item_permission_moders'),
(3844, 7, 'pages_add_item'),
(3845, 7, 'pages_back'),
(3854, 7, 'forgot_password_success_message'),
(3852, 1, 'theme_change_success_message'),
(3851, 7, 'dashboard'),
(3858, 1, 'sidebar_menu_plugins_installed'),
(3859, 1, 'sidebar_menu_plugins_available'),
(3860, 1, 'sidebar_menu_plugins_add'),
(3861, 1, 'finance_settings'),
(3862, 1, 'currency'),
(3863, 1, 'manage_plugins_available_box_cap_label'),
(3864, 1, 'manage_plugins_plugin_not_found'),
(3865, 1, 'manage_plugins_delete_confirm_message'),
(3866, 1, 'manage_plugins_delete_button_label'),
(3867, 1, 'manage_plugins_uninstall_success_message'),
(3868, 1, 'page_title_manage_plugins_ftp_info'),
(3869, 1, 'manage_plugins_ftp_box_cap_label'),
(3870, 7, 'upload'),
(3871, 1, 'plugins_manage_ftp_form_login_label'),
(3872, 1, 'plugins_manage_ftp_form_password_label'),
(3873, 1, 'plugins_manage_ftp_form_submit_label'),
(3874, 1, 'plugins_manage_need_ftp_attrs_message'),
(3875, 1, 'plugins_manage_ftp_form_port_label'),
(5840, 7, 'reset_password_request_submit_label'),
(3878, 1, 'plugins_manage_ftp_attrs_invalid_host_message'),
(4126, 7, 'user_list_menu_item_birthdays'),
(3887, 1, 'plugins_manage_ftp_form_host_label'),
(3888, 7, 'forgot_password_label'),
(5839, 7, 'reset_password_request_form_text'),
(3892, 7, 'sign_in_remember_me_label'),
(5842, 7, 'reset_password_request_invalid_code_error_message'),
(3902, 1, 'manage_plugins_delete_success_message'),
(5125, 1, 'user_settings_email'),
(5126, 1, 'user_settings_confirm_email'),
(5124, 1, 'user_settings_confirm_email_desc'),
(3918, 1, 'plugins_manage_add_submit_label'),
(3920, 1, 'manage_plugins_add_box_cap_label'),
(3921, 7, 'tf_allow_pics'),
(3922, 7, 'tf_max_img_size'),
(3923, 7, 'tf_sett_section'),
(3924, 7, 'tf_img_url'),
(3925, 7, 'tf_insert'),
(3926, 7, 'tf_img_types'),
(3927, 7, 'tf_img_max_size'),
(3928, 7, 'tf_img_choose_file'),
(3929, 7, 'tf_img_from_url'),
(3930, 7, 'tf_img_gal'),
(3931, 7, 'mp_gal_show'),
(3932, 7, 'mp_gal_hide'),
(3933, 7, 'mp_gal_pic_url'),
(3934, 7, 'mp_gal_delete'),
(3935, 7, 'mp_gal_preview'),
(3936, 7, 'mp_gal_fullsize'),
(3937, 7, 'mp_gal_align'),
(3938, 7, 'mp_gal_none'),
(3939, 7, 'mp_gal_left'),
(3940, 7, 'mp_gal_center'),
(3941, 7, 'mp_gal_right'),
(3942, 7, 'mp_gal_ins_into_post'),
(3943, 1, 'manage_plugins_update_button_label'),
(3945, 7, 'billing_no_gateways'),
(3950, 1, 'manage_plugins_update_request_box_cap_label'),
(3951, 1, 'free_plugin_request_text'),
(3952, 1, 'plugin_update_yes_button_label'),
(3953, 1, 'plugin_update_no_button_label'),
(3956, 7, 'billing_pay_with'),
(5841, 7, 'reset_password_request_heading'),
(3987, 1, 'plugins_manage_ftp_attrs_invalid_login_params_message'),
(3988, 7, 'billing_currency_not_supported'),
(4004, 1, 'com_plugin_request_key_label'),
(4005, 1, 'license_form_leave_label'),
(4006, 1, 'license_form_submit_label'),
(4010, 1, 'com_plugin_request_text'),
(4012, 7, 'date_time_week_0'),
(4013, 7, 'date_time_week_1'),
(4014, 7, 'date_time_week_2'),
(4015, 7, 'date_time_week_3'),
(4016, 7, 'date_time_week_4'),
(4017, 7, 'date_time_week_5'),
(4018, 7, 'date_time_week_6'),
(4019, 1, 'plugins_manage_invalid_license_key_error_message'),
(4020, 7, 'user_search_submit_button_label'),
(4021, 7, 'user_search_display_name_search_label'),
(4022, 7, 'user_search_page_heading'),
(4032, 7, 'user_search_main_search_label'),
(4034, 7, 'user_search_menu_item_label'),
(4035, 7, 'user_search_back_to_search_from'),
(15465, 1, 'sidebar_menu_themes_add'),
(4038, 7, 'form_element_from'),
(4039, 7, 'form_element_to'),
(4040, 7, 'form_element_age_range'),
(4043, 7, 'user_search_authorization_warning'),
(4044, 7, 'authorization_action_base_search_users'),
(4046, 7, 'rate_cmp_owner_cant_rate_error_message'),
(4047, 7, 'comment_delete_confirm_message'),
(4048, 7, 'year'),
(4049, 7, 'month'),
(4050, 7, 'day'),
(4051, 1, 'permission_global_privacy_empty_pass_error_message'),
(4078, 1, 'permission_global_privacy_pass_length_error_message'),
(4087, 1, 'manage_plugins_uninstall_confirm_message'),
(4090, 7, 'base_sign_in_cap_label'),
(4091, 7, 'base_sign_in_or_label'),
(4100, 7, 'confirm_page_ok_label'),
(4101, 7, 'confirm_page_cancel_label'),
(4102, 7, 'email_notifications_setting_user_comment'),
(4103, 7, 'profile_comment_notification'),
(5836, 7, 'forgot_password_code_exists_error_message'),
(4128, 1, 'verify_site_email'),
(4129, 1, 'send_verification_email'),
(4130, 1, 'email_already_verify'),
(4131, 1, 'site_email_verify_promo'),
(4132, 7, 'site_email_verify_subject'),
(4133, 7, 'site_email_verify_template_text'),
(4134, 7, 'site_email_verify_template_html'),
(4140, 7, 'date_time_tomorrow'),
(4145, 1, 'manage_plugins_uninstall_request_box_cap_label'),
(4146, 1, 'plugin_uninstall_request_text'),
(4149, 7, 'form_validator_captcha_error_message'),
(4165, 7, 'form_validator_float_error_message'),
(4164, 7, 'form_validator_date_error_message'),
(4166, 7, 'form_validator_int_error_message'),
(4167, 7, 'form_validator_alphanumeric_error_message'),
(4168, 7, 'form_validator_url_error_message'),
(4169, 7, 'form_validator_email_error_message'),
(4170, 7, 'form_validator_regexp_error_message'),
(4171, 7, 'form_validator_string_error_message'),
(4515, 7, 'console_item_label_preferences'),
(4516, 7, 'console_item_label_profile'),
(4514, 7, 'console_item_label_dashboard'),
(4517, 7, 'console_item_label_mailbox'),
(4518, 7, 'console_item_label_sign_out'),
(4519, 1, 'notification_soft_update'),
(4520, 1, 'notification_plugins_to_update'),
(5838, 7, 'reset_password_request_cap_label'),
(4595, 1, 'manage_plugins_uninstall_error_message'),
(4598, 7, 'media_panel_file_deleted'),
(4939, 1, 'manage_plugins_update_success_message'),
(4766, 7, 'my_avatar_widget'),
(4767, 1, 'page_title_finance'),
(4770, 1, 'sidebar_menu_item_dashboard_finance'),
(4769, 7, 'join_error_username_restricted'),
(5843, 7, 'reset_password_heading'),
(4772, 1, 'sidebar_menu_item_restricted_usernames'),
(4773, 1, 'restrictedusernames'),
(4774, 1, 'restrictedusernames_add_username'),
(4775, 1, 'restrictedusernames_username_label'),
(4776, 1, 'restrictedusernames_add_username_button'),
(4777, 1, 'restrictedusernames_restricted_list_label'),
(4783, 1, 'restrictedusernames_username_added'),
(4785, 1, 'manage_plugins_manual_update_request'),
(4786, 1, 'plugin_manual_update_button_label'),
(4793, 7, 'billing_gateway_not_found'),
(4832, 1, 'plugin'),
(4810, 7, 'billing_sale_not_found'),
(5853, 7, 'reset_password_success_message'),
(4843, 7, 'billing_amount'),
(4842, 7, 'time'),
(4811, 7, 'billing_order_init_failed'),
(5852, 7, 'reset_password_length_error_message'),
(5851, 7, 'reset_password_not_equal_error_message'),
(4854, 7, 'billing_details'),
(4855, 7, 'billing_gateway'),
(4856, 7, 'billing_transaction_id'),
(4857, 7, 'billing_statistics'),
(4868, 1, 'questions_config_year_range_label'),
(4869, 7, 'form_element_year_range'),
(4870, 7, 'billing_gateway_unavailable'),
(4871, 7, 'billing_order_canceled'),
(4872, 7, 'billing_order_failed'),
(4873, 7, 'billing_order_completed_successfully'),
(4874, 7, 'billing_order_verified'),
(4875, 7, 'billing_order_processing'),
(4906, 7, 'billing_order_page_heading'),
(4907, 7, 'billing_order_status_page_heading'),
(5849, 7, 'reset_password_repeat_field_label'),
(5848, 7, 'reset_password_field_label'),
(5846, 7, 'reset_password_form_text'),
(5845, 7, 'forgot_password_instructions'),
(5844, 7, 'reset_password_cap_label'),
(5576, 1, 'massmailing_expire_text'),
(6079, 7, 'questions_question_7f2450f06779439551c75a8566c4070e_value_1'),
(6073, 7, 'authorization_action_market_post_jobs'),
(5847, 7, 'reset_password_submit_label'),
(6051, 7, 'reset_password_mail_template_content_txt'),
(6050, 7, 'reset_password_mail_template_content_html'),
(6048, 7, 'authorization_action_market_delete_comment_by_content_owner'),
(6046, 7, 'authorization_group_market'),
(6045, 1, 'questions_edit_username_warning'),
(6082, 7, 'questions_question_7f2450f06779439551c75a8566c4070e_value_8'),
(6081, 7, 'questions_question_7f2450f06779439551c75a8566c4070e_value_4'),
(6080, 7, 'questions_question_7f2450f06779439551c75a8566c4070e_value_2'),
(6047, 7, 'authorization_action_market_add_comment'),
(6020, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_value_1'),
(6021, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_value_2'),
(6022, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_value_4'),
(6023, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_value_8'),
(6024, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_value_16'),
(6083, 7, 'questions_question_7f2450f06779439551c75a8566c4070e_value_16'),
(6084, 7, 'questions_question_7f2450f06779439551c75a8566c4070e_value_32'),
(6155, 7, 'authorization_group_links'),
(6156, 7, 'authorization_action_links_add_comment'),
(6157, 7, 'authorization_action_links_add'),
(6158, 7, 'authorization_action_links_delete_comment_by_content_owner'),
(6159, 7, 'authorization_action_links_view'),
(6377, 1, 'css_edit_success_message'),
(6378, 7, 'comment_view_all'),
(6406, 7, 'ajax_floatbox_users_title'),
(6697, 7, 'feed_user_join'),
(6696, 7, 'feed_user_edit_profile'),
(6241, 7, 'questions_question_9c187792aa5cda7256f032ed2e517512_description'),
(6242, 7, 'questions_question_9c187792aa5cda7256f032ed2e517512_label'),
(6275, 7, 'cannot_delete_admin_user_msg'),
(6301, 7, 'white_spaces_dissalowed'),
(6308, 1, 'user_feedback_email_verified'),
(6306, 7, 'mark_email_verified_btn'),
(9251, 7, 'tag_search'),
(6366, 1, 'user_settings_avatar_image'),
(8574, 7, 'authorization_action_virtualgifts_send_gift'),
(8573, 7, 'authorization_group_virtualgifts'),
(6376, 1, 'plugins_manage_ftp_attrs_invalid_user'),
(6473, 1, 'user_settings_avatar_image_desc'),
(6477, 7, 'change'),
(6478, 7, 'cancel'),
(6486, 1, 'confirm_avatar_delete'),
(6487, 1, 'default_avatar_deleted'),
(6489, 7, 'empty_user_avatar_list'),
(6497, 7, 'avatar_user_list_select_count_label'),
(6498, 7, 'avatar_user_list_select_button_label'),
(6516, 7, 'user_page_heading_status'),
(7918, 7, 'authorization_action_event_add_comment');
INSERT INTO `%%TBL-PREFIX%%base_language_key` (`id`, `prefixId`, `key`) VALUES
(7915, 7, 'authorization_group_event'),
(6568, 7, 'base_document_403_heading'),
(6569, 7, 'base_document_403'),
(6570, 7, 'base_document_404_title'),
(6571, 7, 'base_document_403_title'),
(7917, 7, 'authorization_action_event_view_event'),
(7916, 7, 'authorization_action_event_add_event'),
(9493, 7, 'form_element_submit_default_value'),
(7429, 7, 'empty_user_avatar_list_select'),
(9728, 7, 'questions_question_a5115de7f38988e748370a59ba0b311d_value_8'),
(9727, 7, 'questions_question_a5115de7f38988e748370a59ba0b311d_value_4'),
(9726, 7, 'questions_question_a5115de7f38988e748370a59ba0b311d_value_2'),
(9725, 7, 'questions_question_a5115de7f38988e748370a59ba0b311d_value_1'),
(8664, 7, 'authorization_group_usercredits'),
(6671, 7, 'avatar_feed_string'),
(6673, 7, 'widgets_enable_js'),
(6674, 7, 'widgets_disable_js'),
(6675, 7, 'reset_password_code_expired_cap_label'),
(6677, 7, 'reset_password_code_expired_text'),
(6678, 1, 'total_users'),
(6714, 7, 'avatar_user_select_empty_list_message'),
(6779, 7, 'authorization_group_mailbox'),
(6780, 7, 'authorization_action_mailbox_read_message'),
(6781, 7, 'authorization_action_mailbox_send_message'),
(6823, 7, 'manage_plugins_add_success_message'),
(9509, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_8'),
(9508, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_4'),
(9507, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_2'),
(9506, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_1'),
(6861, 7, 'date_time_cap_hour'),
(6862, 7, 'date_time_cap_minute'),
(9510, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_16'),
(6865, 7, 'local_page_content_page-354035'),
(6869, 7, 'local_page_meta_tags_page-396264'),
(9495, 7, 'user_list_widget_settings_count'),
(9494, 7, 'user_list_widget_settings_title'),
(6872, 7, 'local_page_title_page-396264'),
(6873, 7, 'local_page_title_page-939960'),
(6874, 7, 'page-354035'),
(6875, 7, 'page-396264'),
(6876, 7, 'page-518675'),
(6877, 7, 'page-939960'),
(6878, 7, 'questions_question_4bddc7149038118992db4e734414520d_description'),
(6879, 7, 'questions_question_4bddc7149038118992db4e734414520d_label'),
(6880, 7, 'questions_question_4bddc7149038118992db4e734414520d_value_1'),
(6881, 7, 'questions_question_4bddc7149038118992db4e734414520d_value_16'),
(6882, 7, 'questions_question_4bddc7149038118992db4e734414520d_value_2'),
(6883, 7, 'questions_question_4bddc7149038118992db4e734414520d_value_32'),
(6884, 7, 'questions_question_4bddc7149038118992db4e734414520d_value_4'),
(6885, 7, 'questions_question_4bddc7149038118992db4e734414520d_value_8'),
(6886, 7, 'questions_question_707a72f79f82d1bfbc35f9e857af97c5_description'),
(6887, 7, 'questions_question_707a72f79f82d1bfbc35f9e857af97c5_label'),
(6890, 1, 'plugins_manage_no_available_items'),
(7218, 7, 'manage_plugins_install_empty_key_error_message'),
(7219, 7, 'manage_plugins_install_error_message'),
(7302, 1, 'add_language_pack_empty_file_error_message'),
(7304, 1, 'language_import_complete_success_message'),
(7528, 7, 'questions_question_joinStamp_label'),
(7529, 7, 'questions_question_joinStamp_description'),
(7828, 1, 'warning_cron_is_not_active'),
(8987, 7, 'authorization_group_board'),
(8988, 7, 'authorization_action_board_view'),
(8989, 7, 'authorization_action_board_edit'),
(8990, 7, 'authorization_action_board_subscribe'),
(8993, 1, 'avatar_label'),
(8994, 7, 'yes'),
(8995, 7, 'no'),
(8996, 1, 'display_avatar_label'),
(8997, 1, 'avatar_label_color'),
(8999, 1, 'permissions_role_updated'),
(9106, 7, 'checkout'),
(9129, 1, 'permissions_role_actions_label'),
(9133, 1, 'sidebar_menu_item_users_roles'),
(15464, 1, 'manage_theme_add_extract_error'),
(15463, 1, 'sidebar_menu_item_ads'),
(15462, 1, 'page_title_ads'),
(15461, 1, 'page_heading_ads'),
(15460, 1, 'advertisement_menu_manage_banners'),
(15459, 1, 'advertisement_menu_banner_list'),
(15458, 1, 'ads_manage_select_plugin_text'),
(15457, 1, 'ads_manage_global_label'),
(15456, 1, 'ads_manage_add_banners_message'),
(9173, 7, 'usercredits_action_daily_login'),
(9174, 7, 'usercredits_action_user_join'),
(9175, 7, 'usercredits_action_search_users'),
(9176, 7, 'usercredits_action_add_comment'),
(9208, 7, 'your_rate_label'),
(9209, 7, 'total_score_label'),
(10306, 7, 'local_page_title_page_13904610'),
(10307, 7, 'local_page_meta_tags_page_13904610'),
(9285, 1, 'add_new_role_block_cap_label'),
(9286, 1, 'user_role_permissions_cap_label'),
(9288, 7, 'auth_group_label'),
(9297, 1, 'questions_edit_account_types_button'),
(9291, 7, 'add_comment'),
(9293, 1, 'questions_values_count'),
(9294, 7, 'delete_comment_by_content_owner'),
(9295, 7, 'search_users'),
(9296, 1, 'auth_group_label'),
(9375, 1, 'question_column_question'),
(9377, 1, 'question_column_type'),
(9381, 1, 'theme_info_cap_label'),
(9382, 1, 'question_column_values'),
(9386, 1, 'pages_and_menus_instructions'),
(9387, 1, 'pages_and_menus_main_menu_label'),
(9388, 1, 'question_column_require'),
(9389, 1, 'pages_and_menus_bottom_menu_label'),
(9390, 1, 'pages_and_menus_hidden_pages_label'),
(9391, 1, 'question_column_sign_up'),
(9392, 1, 'pages_and_menus_hidden_desc'),
(9393, 1, 'question_column_profile_edit'),
(9395, 1, 'question_column_view'),
(9396, 1, 'pages_and_menus_item_label'),
(9397, 1, 'pages_and_menus_legend_everyone_label'),
(9398, 1, 'question_column_search'),
(9399, 1, 'pages_and_menus_legend_guests_label'),
(9400, 1, 'pages_and_menus_legend_members_label'),
(9401, 7, 'auth_view_profile'),
(9402, 1, 'pages_and_menus_legend_label'),
(9403, 1, 'or'),
(9404, 1, 'question_column_account_type'),
(9405, 1, 'question_column_exclusive_questions'),
(9406, 7, 'view_profile_no_permission'),
(9407, 1, 'question_possible_values_label'),
(9417, 7, 'tag_search_empty_value_error'),
(9423, 7, 'form_element_submit_default_balue'),
(9462, 7, 'notification_section_label'),
(9469, 7, 'user_list_activity'),
(9467, 7, 'user_list_online'),
(9472, 1, 'soft_version'),
(9511, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_32'),
(9512, 7, 'questions_question_7fbd88047415229961f4d2aac620fe25_value_64'),
(9522, 1, 'clone_language_cap_label'),
(9528, 1, 'join_display_photo_upload'),
(9530, 1, 'join_display_terms_of_use'),
(9531, 1, 'join_page'),
(9532, 1, 'join_display_terms_of_use_desc'),
(9534, 1, 'join_display_photo_upload_desc'),
(9542, 7, 'local_page_title_page-119658'),
(9543, 7, 'local_page_meta_tags_page-119658'),
(9541, 7, 'page-119658'),
(9539, 7, 'questions_section_terms_of_use_label'),
(9540, 7, 'questions_question_user_terms_of_use_label'),
(9544, 7, 'local_page_content_page-119658'),
(9913, 1, 'language_edit_form_error_message'),
(9912, 1, 'language_edit_form_success_message'),
(9567, 1, 'use_military_time'),
(9568, 1, 'sidebar_menu_item_permission_role'),
(9683, 7, 'preference_index'),
(9694, 7, 'config_join_display_photo_upload_display_and_require_label'),
(9693, 7, 'config_join_display_photo_upload_display_label'),
(9686, 7, 'preference_submit_button'),
(9687, 7, 'preference_section_general'),
(9688, 7, 'preference_preference_data_was_saved'),
(9689, 7, 'preference_preference_data_not_changed'),
(9690, 7, 'preference_no_items'),
(9691, 7, 'preference_mass_mailing_subscribe_label'),
(9692, 7, 'preference_mass_mailing_subscribe_description'),
(9695, 7, 'config_join_display_photo_upload_not_display_label'),
(9911, 1, 'lang_edit_form_rtl_desc'),
(9910, 1, 'lang_edit_form_rtl_label'),
(9909, 1, 'edit_langs_cap_label'),
(9908, 1, 'btn_label_edit_values'),
(9870, 7, 'privacy_action_view_profile'),
(9871, 1, 'core_update_download_error'),
(9872, 1, 'sidebar_menu_item_user_settings'),
(9874, 1, 'menu_item_page_settings'),
(9875, 1, 'heading_page_settings'),
(9879, 1, 'page_settings_form_headcode_label'),
(9877, 1, 'settings_submit_error_message'),
(9878, 1, 'settings_submit_success_message'),
(9880, 1, 'page_settings_form_headcode_desc'),
(9881, 1, 'page_settings_form_bottomcode_label'),
(9882, 1, 'page_settings_form_bottomcode_desc'),
(9883, 1, 'page_settings_form_favicon_label'),
(9884, 1, 'page_settings_form_favicon_desc'),
(10253, 7, 'view_more_label'),
(10266, 7, 'ws_button_label_bold'),
(10267, 7, 'ws_button_label_italic'),
(10268, 7, 'ws_button_label_underline'),
(10269, 7, 'ws_button_label_orderedlist'),
(10270, 7, 'ws_button_label_unorderedlist'),
(10271, 7, 'ws_button_label_link'),
(10272, 7, 'ws_button_label_image'),
(10273, 7, 'ws_button_label_video'),
(10274, 7, 'ws_button_label_html'),
(10275, 7, 'ws_button_label_switch_html'),
(10282, 7, 'ws_add_label'),
(10283, 7, 'ws_insert_label'),
(10284, 7, 'ws_link_empty_fields'),
(10285, 7, 'ws_video_head_label'),
(10287, 7, 'ws_video_empty_field'),
(10288, 7, 'ws_html_head_label'),
(10289, 7, 'welcome_letter_subject'),
(10290, 7, 'welcome_letter_template_text'),
(10291, 7, 'welcome_letter_template_html'),
(10308, 7, 'local_page_content_page_13904610'),
(10578, 7, 'ws_button_label_more'),
(10580, 1, 'feed_content_registration'),
(10581, 1, 'feed_content_edit'),
(10689, 7, 'authorization_action_groups_add_topic'),
(10688, 7, 'authorization_action_groups_add_comment'),
(10687, 7, 'forgot_password_mail_template_content_txt'),
(10601, 1, 'menu_item_user_input_settings'),
(10602, 1, 'user_input_settings_user_content'),
(10605, 1, 'user_input_settings_comments'),
(10607, 1, 'user_input_settings_rich_media'),
(10608, 1, 'input_settings_allow_photo_upload_label'),
(10609, 1, 'input_settings_max_upload_size_label'),
(10610, 1, 'input_settings_resource_list_label'),
(10611, 1, 'heading_user_input_settings'),
(10612, 7, 'ws_html_textarea_label'),
(10613, 7, 'ws_video_textarea_label'),
(10614, 1, 'feed_content_user_comment'),
(15470, 1, 'theme_add_extract_error'),
(10618, 1, 'menu_item_user_settings_general'),
(10619, 1, 'menu_item_user_settings_content_input'),
(10666, 1, 'input_settings_user_rich_media_disable_label'),
(10665, 1, 'input_settings_user_custom_html_disable_desc'),
(10664, 1, 'input_settings_user_custom_html_disable_label'),
(10623, 1, 'input_settings_resource_list_desc'),
(10626, 7, 'privacy_action_view_my_presence_on_site'),
(10667, 1, 'input_settings_user_rich_media_disable_desc'),
(10668, 1, 'input_settings_comments_rich_media_disable_label'),
(10669, 1, 'input_settings_comments_rich_media_disable_desc'),
(10685, 1, 'menu_item_user_settings'),
(10686, 7, 'forgot_password_mail_template_content_html'),
(10676, 1, 'page_settings_favicon_submit_error_message'),
(10690, 7, 'authorization_action_groups_create'),
(10678, 7, 'local_page_title_page_7680520'),
(10679, 7, 'local_page_meta_tags_page_7680520'),
(10680, 7, 'local_page_content_page_7680520'),
(10691, 7, 'authorization_action_groups_delete_comment_by_content_owner'),
(10692, 7, 'authorization_group_groups'),
(15454, 1, 'ads_edit_banner_submit_label'),
(15453, 1, 'ads_edit_banner_button_label'),
(15452, 1, 'ads_delete_button_label'),
(15451, 1, 'ads_delete_banner_confirm_message'),
(15450, 1, 'ads_banner_edit_success_message'),
(15449, 1, 'ads_banner_delete_success_message'),
(15438, 1, 'ads_add_banner'),
(15439, 1, 'ads_add_banner_code_desc'),
(15440, 1, 'ads_add_banner_code_label'),
(15448, 1, 'ads_banner_all_region'),
(15447, 1, 'ads_banner_add_success_message'),
(15441, 1, 'ads_add_banner_country_desc'),
(15442, 1, 'ads_add_banner_country_label'),
(15443, 1, 'ads_add_banner_submit_label'),
(15444, 1, 'ads_add_banner_title_label'),
(15445, 1, 'ads_banners_add_floatbox_label'),
(15446, 1, 'ads_banners_count_label'),
(10719, 7, 'ads_widget_panel_title'),
(10720, 7, 'local_page_content_page-396264'),
(10721, 7, 'local_page_content_page-939960'),
(10722, 7, 'local_page_meta_tags_page-354035'),
(10723, 7, 'local_page_meta_tags_page-939960'),
(10724, 7, 'local_page_title_page-354035'),
(10725, 1, 'join_photo_upload_set_required'),
(10726, 1, 'join_photo_upload_set_required_desc'),
(10727, 7, 'local_page_content_page-290357'),
(10728, 7, 'local_page_meta_tags_page-290357'),
(10729, 7, 'local_page_title_page-290357'),
(10730, 7, 'page-290357'),
(10731, 7, 'local_page_content_page_24622628'),
(10732, 7, 'local_page_content_page_45248787'),
(10733, 7, 'local_page_content_page_88027910'),
(10734, 7, 'local_page_meta_tags_page_24622628'),
(10735, 7, 'local_page_meta_tags_page_45248787'),
(10736, 7, 'local_page_meta_tags_page_88027910'),
(10737, 7, 'local_page_title_page_24622628'),
(10738, 7, 'local_page_title_page_45248787'),
(10739, 7, 'local_page_title_page_88027910'),
(10740, 7, 'page_13904610'),
(10741, 7, 'page_24622628'),
(10742, 7, 'page_45248787'),
(10743, 7, 'page_88027910'),
(11634, 7, 'questions_section_e46697c921740b10b1ac7223a14155b2_label'),
(11631, 1, 'manage_plugins_add_ftp_move_error'),
(10835, 1, 'found_users'),
(10836, 1, 'search_by'),
(10839, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_1'),
(10923, 7, 'attch_video_add_button_label'),
(10924, 7, 'attch_video_button_label'),
(10925, 7, 'attch_photo_button_label'),
(10926, 7, 'attch_add_video_button_label'),
(10927, 7, 'attch_attachment_label'),
(10928, 7, 'upload_file_max_upload_filesize_error'),
(10929, 7, 'upload_file_file_partially_uploaded_error'),
(10930, 7, 'upload_file_no_file_error'),
(10931, 7, 'upload_file_no_tmp_dir_error'),
(10932, 7, 'upload_file_cant_write_file_error'),
(10933, 7, 'upload_file_invalid_extention_error'),
(10934, 7, 'upload_file_fail'),
(10940, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_4'),
(10939, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_2'),
(10941, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_8'),
(10942, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_16'),
(10943, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_32'),
(10944, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_64'),
(10945, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_128'),
(10946, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_256'),
(10947, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_value_512'),
(11296, 7, 'comment_required_validator_message'),
(11310, 7, 'sidebar_menu_view_all_questions'),
(11311, 1, 'sidebar_menu_question_settings'),
(11312, 1, 'sidebar_menu_basic_label'),
(11313, 1, 'sidebar_menu_theme_css_label'),
(11314, 1, 'sidebar_menu_pages_menus_label'),
(11317, 7, 'widgets_avaliable_legend'),
(11318, 7, 'widgets_avaliable_description'),
(11573, 1, 'core_update_unzip_error'),
(11574, 7, 'ws_link_text_label'),
(11579, 1, 'page_settings_no_favicon_label'),
(11577, 7, 'ws_link_url_label'),
(11578, 7, 'ws_link_new_window_label'),
(11635, 7, 'max_upload_filesize'),
(15361, 1, 'massmailing_user_roles_label'),
(15362, 1, 'settings_max_upload_size_error'),
(15363, 1, 'user_feedback_email_unverified'),
(15364, 7, 'authorization_action_board_move_topic_to_hidden'),
(15365, 7, 'authorization_role_gold'),
(15366, 7, 'authorization_role_silver'),
(15367, 7, 'authorization_role_silver1'),
(15368, 7, 'billing_gateway_products_binding'),
(15369, 7, 'billing_product'),
(15370, 7, 'billing_product_id'),
(15371, 7, 'block_user_confirmation_label'),
(15372, 7, 'cancel_button'),
(15373, 7, 'confirm_button'),
(15374, 7, 'local_page_content_page_10919570'),
(15375, 7, 'local_page_content_page_61525903'),
(15376, 7, 'local_page_meta_tags_page_10919570'),
(15377, 7, 'local_page_meta_tags_page_61525903'),
(15378, 7, 'local_page_title_page_10919570'),
(15379, 7, 'local_page_title_page_61525903'),
(15380, 7, 'maintenance_disable_message'),
(15381, 7, 'mark_email_unverified_btn'),
(15382, 7, 'massmailing_unsubscribe_confirmation'),
(15383, 7, 'page_10919570'),
(15384, 7, 'page_61525903'),
(15385, 7, 'questions_account_type_77f92557420351da5a45e37a13857657'),
(15386, 7, 'questions_account_type_db5c851569c8660abb5ad2441d38d3fc'),
(15387, 7, 'questions_account_type_df9807bd2ba1808afb2ab52a7b74fc90'),
(15388, 7, 'questions_question_06c1ce07a38cb0267e45ec955ed84a6f_description'),
(15389, 7, 'questions_question_06c1ce07a38cb0267e45ec955ed84a6f_label'),
(15390, 7, 'questions_question_2be5f9666f2a291d33705d58a902d84a_description'),
(15391, 7, 'questions_question_2be5f9666f2a291d33705d58a902d84a_label'),
(15392, 7, 'questions_question_739a83996f701966485290779f4ff2b5_description'),
(15393, 7, 'questions_question_739a83996f701966485290779f4ff2b5_label'),
(15394, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_1'),
(15395, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_1024'),
(15396, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_128'),
(15397, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_16'),
(15398, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_16384'),
(15399, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_2'),
(15400, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_2048'),
(15401, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_256'),
(15402, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_32'),
(15403, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_32768'),
(15404, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_4'),
(15405, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_4096'),
(15406, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_512'),
(15407, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_64'),
(15408, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_8'),
(15409, 7, 'questions_question_739a83996f701966485290779f4ff2b5_value_8192'),
(15410, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_description'),
(15411, 7, 'questions_question_c5dc53f371fe6ba3001a7c7e31bd95fc_label'),
(15412, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_description'),
(15413, 7, 'questions_question_d8aa20d67fbb6c6864e46c474d0bde10_label'),
(15414, 7, 'questions_question_ecef9fe729d11241c04609c3a7ca468e_description'),
(15415, 7, 'questions_question_ecef9fe729d11241c04609c3a7ca468e_label'),
(15416, 7, 'user_block_btn_lbl'),
(15417, 7, 'user_block_confirm_message'),
(15418, 7, 'user_block_message'),
(15419, 7, 'user_feedback_profile_blocked'),
(15420, 7, 'user_feedback_profile_unblocked'),
(15421, 7, 'user_unblock_btn_lbl'),
(15473, 1, 'manage_plugins_add_empty_field_error_message'),
(15474, 1, 'manage_plugins_add_size_error_message'),
(15475, 1, 'manage_plugins_update_process_error'),
(15476, 1, 'manage_plugins_up_to_date_message'),
(15477, 1, 'manage_plugin_add_extract_error'),
(15478, 1, 'plugin_update_download_error'),
(15479, 1, 'plugin_update_request_error'),
(15480, 7, 'forgot_password_request_exists_error_message'),
(15481, 1, 'user_feedback_profiles_approved'),
(15482, 1, 'user_feedback_profiles_disapproved'),
(15483, 1, 'user_settings_avatar_size_error'),
(15484, 1, 'user_settings_avatar_size_label'),
(15485, 1, 'user_settings_big_avatar_size_error'),
(15486, 1, 'user_settings_big_avatar_size_label'),
(15487, 1, 'warning_url_fopen_disabled'),
(15488, 7, 'ajax_attachment_select_image'),
(15489, 7, 'ajax_attachment_select_image_title'),
(15490, 7, 'approve_user_btn'),
(15491, 7, 'disapprove_user_btn'),
(15492, 7, 'feed_activity_avatar_string'),
(15493, 7, 'feed_activity_avatar_string_like'),
(15494, 7, 'feed_activity_join_profile_string'),
(15495, 7, 'feed_activity_join_profile_string_like'),
(15496, 7, 'not_writable_avatar_dir'),
(15497, 7, 'upload_file_extension_is_not_allowed');

CREATE TABLE `%%TBL-PREFIX%%base_language_prefix` (
  `id` int(11) NOT NULL auto_increment,
  `prefix` varchar(255) NOT NULL,
  `label` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `prefix` (`prefix`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_language_prefix` (`id`, `prefix`, `label`) VALUES
(1, 'admin', 'الإدارة'),
(6, 'ow_custom', 'التخصيص'),
(7, 'base', 'الأساسي'),
(11, 'nav', 'شريط التنقل');

CREATE TABLE `%%TBL-PREFIX%%base_language_value` (
  `id` int(11) NOT NULL auto_increment,
  `languageId` int(11) NOT NULL default '0',
  `keyId` int(11) NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `keyId` (`keyId`,`languageId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_language_value` (`id`, `languageId`, `keyId`, `value`) VALUES
(53, 1, 1603, 'أنت تقوم بتحرير'),
(54, 1, 1604, 'تحقق من <a href="languages/mod">اللغات الأخرى</a>'),
(55, 1, 1605, 'أضف نصاً جديداً'),
(56, 1, 1606, 'إذهب'),
(57, 1, 1607, 'نتائج البحث للكلمات المفتاحية: <i><b>{$keyword}</i></b>'),
(58, 1, 1608, 'البحث'),
(59, 1, 1609, 'القيمة الأصلية: {$label} ({$tag})'),
(60, 1, 1610, 'الترجمة: {$label} ({$tag})'),
(61, 1, 1611, 'حذف'),
(62, 1, 1612, 'مفاتيح مخصصة'),
(63, 1, 1613, 'حفظ هذه الصفحة'),
(64, 1, 1614, 'القسم'),
(65, 1, 1615, 'كل الأقسام'),
(66, 1, 1616, 'نص مفقود'),
(67, 1, 1617, 'سحب وإفلات'),
(68, 1, 1618, 'ترتيب اللغة الذي يظهر في الموقع . اللغة الأولى سيتم إعدادها كلغة إفتراضية في الموقع .'),
(69, 1, 1619, 'يجب أن يكون موجوداً لغة واحدة نشطة على الأقل.'),
(70, 1, 1620, 'فارغ'),
(71, 1, 1621, 'مفاتيح مفقودة'),
(72, 1, 1622, 'اللغات النشطة'),
(73, 1, 1623, 'اللغة'),
(74, 1, 1624, 'تحرير'),
(75, 1, 1625, 'إستنساخ'),
(76, 1, 1626, 'تعطيل'),
(77, 1, 1627, 'تنشيط'),
(78, 1, 1628, 'حذف'),
(132, 1, 1682, 'هنا يمكنك رفع الملف الذي يحتوي اللغة لواحد من الملحقات والإضافات البرمجية ( ملف <b>.XML</b>) أو عدة لغات للملحقات والإضافات البرمجية ( ملف <b>.ZIP</b> ).'),
(133, 1, 1683, 'أضف لغة جديدة (حزمة لغة)'),
(134, 1, 1684, 'إختر ما ترغب بإستيراده من حزمة اللغة هذه.'),
(135, 1, 1685, 'حدد كل اللغات لكل الملحقات البرمجية'),
(136, 1, 1686, 'إستيراد المحدد'),
(137, 1, 1687, 'تصدير اللغات'),
(138, 1, 1688, 'تستطيع تصدير/عمل نسخة إحتياطية لأي لغة لأي ملحفات برمجية قمت بتثبيتها على موقعك.'),
(139, 1, 1689, 'تصدير'),
(140, 1, 1690, 'إختر بنود العناصر التي ترغب في تصديرها من كل اللغات والملحقات البرمجية'),
(141, 1, 1691, 'تصدير المحدد'),
(142, 1, 1692, 'العرض: '),
(143, 1, 1693, 'تحرير اللغة'),
(144, 1, 1694, 'اللغات المتوفرة'),
(145, 1, 1695, 'المفتاح'),
(146, 1, 1696, 'النص في {$label} ( {$tag} )'),
(147, 1, 1697, 'أضف'),
(148, 1, 1698, 'ملف اللغة:'),
(149, 1, 1699, 'اللغات الغير نشطة'),
(150, 1, 1700, 'إستنساخ اللغة'),
(151, 1, 1701, 'اللغة'),
(152, 1, 1702, 'أضف نصاً جديداً'),
(153, 1, 1703, 'مثال : <b>Arabic</b>'),
(154, 1, 1704, 'هل أنت متأكد ؟'),
(155, 1, 1705, 'وسم ISO\r\n<a class="ow_lbutton ow_red" target="_blank" href="http://en.wikipedia.org/wiki/ISO_639">?</a>'),
(156, 1, 1706, 'مثال : <b>ar-JO </b>أو <b>ar-SA-custom</b>'),
(158, 1, 1708, 'أضف'),
(159, 1, 1709, 'لا يوجد قيم للكلمة الدليلية <i><b>{$keyword}</i></b>'),
(160, 1, 1710, 'لا يوجد قيم'),
(161, 1, 1711, 'إذهب'),
(162, 1, 1712, 'الإفتراضي'),
(163, 1, 1713, 'عذراً ، المفتاح موجود مسبقاً'),
(191, 1, 1741, 'شباط'),
(192, 1, 1742, 'آب'),
(193, 1, 1743, 'أيلول'),
(195, 1, 1745, 'الكل'),
(196, 1, 1746, 'الأرشيف'),
(197, 1, 1747, 'هل أنت متأكد ؟'),
(202, 1, 1752, 'التعليقات'),
(204, 1, 1754, 'بواسطة'),
(205, 1, 1755, 'المزيد'),
(218, 1, 1768, 'تقرير'),
(219, 1, 1769, 'تحرير'),
(220, 1, 1770, 'حذف'),
(223, 1, 1773, 'موافقة'),
(224, 1, 1774, 'رفض'),
(305, 1, 1855, 'الصورة الرمزية هي صورة رسومية/صورة عادية بحجم مصغر تعرض من أجل أن ترمز إلى ملفك الشخصي.'),
(306, 1, 1856, 'صورتك الرمزية'),
(307, 1, 1857, 'رفع صورة رمزية جديدة'),
(308, 1, 1858, 'إقتصاص الصورة الرمزية'),
(309, 1, 1859, 'إختر منطقة من الصورة الرمزية الخاصة بك من أجل إقتصاصها بمساعدة مؤشر الفأرة. نتيجة الإقتصاص سوف تعرض على اليسار . حالما تكون راضياً بالنتيجة إضغط زر "تطبيق القص".'),
(310, 1, 1860, 'صورة صورتك الرمزية'),
(311, 1, 1861, 'تطبيق القص'),
(312, 1, 1862, 'العودة إلى تحرير الملف الشخصي'),
(313, 1, 1863, 'معاينة'),
(336, 1, 1886, 'أدوار المستخدمين'),
(337, 1, 1887, 'اللغة'),
(339, 1, 1889, 'الصفحات والقوائم'),
(340, 1, 1890, 'تنشيط'),
(341, 1, 1891, 'حفظ'),
(1038, 1, 2582, '{$count} رسالة بريدية تم إرسالها'),
(343, 1, 1893, 'هذا الستايل ليس له أي إعدادات تخصيص.'),
(344, 1, 1894, 'الصورة غير صحيحة'),
(345, 1, 1895, 'صورة المستخدم'),
(346, 1, 1896, 'نوع الملف غير مسموح'),
(347, 1, 1897, 'إختيار الستايل'),
(348, 1, 1898, 'كلمة السر يجب أن تحتوي أقل من 15 حرفاً'),
(349, 1, 1899, 'كلمة السر يجب أن تحتوي أكثر من 4 حروف'),
(350, 1, 1900, 'من فضلك أدخل كلمة سر صحيحة'),
(351, 1, 1901, 'عذراً ، هذا البريد الالكتروني مستخدم مسبقاً'),
(352, 1, 1902, 'من فضلك أدخل عنوان بريد الكتروني صحيح'),
(353, 1, 1903, 'من فضلك أدخل إسم مستخدم صحيح'),
(354, 1, 1904, 'الأشكال المتوفرة'),
(355, 1, 1905, 'إختيار الستايل'),
(356, 1, 1906, 'عذراً ، هذا إسم المستخدم مستخدم مسبقاً'),
(368, 1, 1918, 'حذف'),
(369, 1, 1919, 'اليوم'),
(370, 1, 1920, 'حفظ'),
(371, 1, 1921, 'نجاح التحديث'),
(372, 1, 1922, 'صفحة مدير {$site_name}'),
(373, 1, 1923, 'مدير {$site_name}'),
(376, 1, 1926, '{$title}'),
(377, 1, 1927, 'ملفي الشخصي'),
(378, 1, 1928, 'الرئيسية'),
(380, 1, 1930, '{$site_name} - الشبكات الإجتماعية'),
(381, 1, 1931, '{$site_name}'),
(382, 1, 1932, 'مجتمع {$site_name}'),
(383, 1, 1933, 'صداقة مفتوحة، برمجيات حرة، برمجيات المصدر المفتوح، برمجيات المجتمع ، برمجيات المجتمع مفتوحة المصدر، برمجيات المجتمع الحرة، برمجيات الشبكات الاجتماعية مفتوحة المصدر ، برمجيات الشبكات الاجتماعية الحرة، php، mysql'),
(384, 1, 1934, 'تحرير الستايل'),
(385, 1, 1935, 'الإعدادات'),
(386, 1, 1936, 'الصفحات والقوائم'),
(387, 1, 1937, 'المظهر'),
(388, 1, 1938, 'المستخدمون'),
(389, 1, 1939, 'الملحقات البرمجية'),
(390, 1, 1940, 'تسجيل الدخول'),
(392, 1, 1942, 'تحرير الستايل'),
(393, 1, 1943, 'تحرير CSS'),
(394, 1, 1944, 'حفظ'),
(398, 1, 1948, 'تصفح بواسطة الوسوم'),
(399, 1, 1949, 'المشرفون'),
(400, 1, 1950, 'إعدادات الخصوصية العامة'),
(401, 1, 1951, 'الصورة'),
(402, 1, 1952, 'المنتدى'),
(403, 1, 1953, 'إستايلات CSS الموجودة (قراءة فقط)'),
(404, 1, 1954, 'الصورة تم حذفها'),
(405, 1, 1955, 'الصورة لم يتم رفعها'),
(406, 1, 1956, 'الصورة تم رفعها'),
(407, 1, 1957, 'رفع'),
(408, 1, 1958, 'حذف'),
(409, 1, 1959, 'الرابط'),
(410, 1, 1960, 'معاينة الصورة'),
(411, 1, 1961, 'قائمة الصور'),
(412, 1, 1962, 'رفع الصورة'),
(413, 1, 1963, 'نوع الحساب'),
(620, 1, 2170, 'وصف مختصر'),
(415, 1, 1965, 'تخصيص الستايل'),
(416, 1, 1966, 'رابط المؤلف'),
(417, 1, 1967, 'المؤلف'),
(418, 1, 1968, 'الصفحات :'),
(420, 1, 1970, 'الإدارة'),
(421, 1, 1971, 'خلال 1 دقيقة'),
(422, 1, 1972, 'منذ 1 دقيقة ماضية'),
(423, 1, 1973, 'منذ {$minutes} دقيقة ماضية'),
(424, 1, 1974, 'الأعضاء'),
(426, 1, 1976, 'التوافق'),
(427, 1, 1977, 'إضافة جديدة'),
(428, 1, 1978, 'الإصدار'),
(932, 1, 2476, 'الوصف'),
(10345, 1, 3807, 'الخصوصية والصلاحيات'),
(442, 1, 1992, 'أضف'),
(443, 1, 1993, 'الحائط'),
(444, 1, 1994, 'رفع'),
(445, 1, 1995, 'الصيغ المتوفرة لعملية رفع الصورة الرمزية هي <span class="ow_txt_value">JPG</span>/<span class="ow_txt_value">GIF</span>/<span class="ow_txt_value">PNG</span>'),
(448, 1, 1998, 'تغيير الصورة الرمزية'),
(449, 1, 1999, 'لا يوجد قسم'),
(450, 1, 2000, 'أضف نوع حساب جديد'),
(458, 1, 2008, 'المتابعة'),
(459, 1, 2009, 'الإشتراك'),
(460, 1, 2010, 'الموسيقى'),
(461, 1, 2011, 'الكتب المفضلة'),
(462, 1, 2012, 'الإهتمامات'),
(463, 1, 2013, 'الصورة'),
(464, 1, 2014, 'الفيديو'),
(465, 1, 2015, 'حدث خطأ أثناء معالجة طلبك'),
(466, 1, 2016, 'حدث خطأ أثناء إرسال التعليق'),
(467, 1, 2017, 'لا تعليقات'),
(468, 1, 2018, 'حذف'),
(469, 1, 2019, 'ساعة واحدة ماضية'),
(470, 1, 2020, 'منذ {$hours} ساعة ماضية'),
(471, 1, 2021, 'الأمس'),
(472, 1, 2022, 'في'),
(475, 1, 2025, 'أيلول'),
(476, 1, 2026, 'كانون2'),
(477, 1, 2027, 'شباط'),
(478, 1, 2028, 'آذار'),
(479, 1, 2029, 'نيسان'),
(480, 1, 2030, 'أيار'),
(481, 1, 2031, 'حزيران'),
(482, 1, 2032, 'تموز'),
(483, 1, 2033, 'آب'),
(484, 1, 2034, 'تشرين1'),
(485, 1, 2035, 'تشرين2'),
(486, 1, 2036, 'كانون1'),
(487, 1, 2037, 'الستايلات'),
(488, 1, 2038, 'CSS'),
(489, 1, 2039, 'إعدادات الستايل'),
(491, 1, 2041, 'إعادة كلمة السر'),
(492, 1, 2042, 'كلمة السر'),
(493, 1, 2043, 'البريد الالكتروني'),
(494, 1, 2044, 'أسئلة الملف الشخصي'),
(497, 1, 2047, 'إسم المستخدم'),
(850, 1, 2397, 'مستخدم عام'),
(501, 1, 2051, 'الخصوصية والصلاحيات'),
(508, 1, 2058, 'تخصيص هذه الصفحة'),
(509, 1, 2059, 'تغيير الصورة الرمزية'),
(510, 1, 2060, 'تحرير ملفي الشخصي'),
(511, 1, 2061, 'الصفحة غير موجودة'),
(512, 1, 2062, 'عذراً ، هذه الوثيقة غير موجودة.'),
(515, 1, 2065, 'عرض الكل'),
(516, 1, 2066, 'كانون الأول'),
(520, 1, 2070, 'الأحدث'),
(521, 1, 2071, 'المميز'),
(522, 1, 2072, 'إنتهاء التخصيص'),
(523, 1, 2073, 'إعادة تعيين'),
(524, 1, 2074, 'نص/HTML مخصص'),
(525, 1, 2075, 'لوحة التحكم'),
(526, 1, 2076, 'التطبيقات المصغرة المتوفرة'),
(527, 1, 2077, 'نظرة عامة'),
(528, 1, 2078, 'لوحة تحكم المستخدم'),
(529, 1, 2079, 'ملف المستخدم الشخصي'),
(530, 1, 2080, 'إشترك الآن'),
(531, 1, 2081, 'إدارة الملحقات البرمجية'),
(532, 1, 2082, 'الضيف'),
(1067, 1, 2611, 'تم إلغاء إشتراكك بنجاح.\r\n<br />\r\nشكراً لك.'),
(535, 1, 2085, 'تحرير'),
(536, 1, 2086, 'حذف'),
(538, 1, 2088, 'المحتوى (نص/HTML)'),
(543, 1, 2093, 'تحويل السطر الجديد إلى <br />'),
(546, 1, 2096, 'الفيديو'),
(547, 1, 2097, 'أضف فيديو'),
(548, 1, 2098, 'عرض الفيديو'),
(549, 1, 2099, 'الصور'),
(550, 1, 2100, 'عرض الصورة'),
(551, 1, 2101, 'رفع الصورة'),
(552, 1, 2102, 'التعليق على الصورة'),
(553, 1, 2103, 'مالك المحتوى يستطيع حذف التعليقات'),
(554, 1, 2104, 'التصاريح الأساسية'),
(555, 1, 2105, 'الكتابة على حوائط التعليقات'),
(556, 1, 2106, 'المؤلف يستطيع حذف تعليقات الحائط'),
(557, 1, 2107, 'العودة إلى الموقع'),
(558, 1, 2108, 'إعدادات التطبيق المصغر العامة'),
(559, 1, 2109, 'العنوان'),
(560, 1, 2110, 'عرض العنوان'),
(561, 1, 2111, 'الأيقونة'),
(562, 1, 2112, 'إلتفاف النص في الصندوق'),
(563, 1, 2113, 'تجميد'),
(564, 1, 2114, '<span class="ow_mild_green">سحب وإفلات</span> العناصر إلى مثال الصفحة لإضافة ميزات أو مكونات مخصصة.'),
(565, 1, 2115, '<span class="ow_mild_red">العناصر الحمراء</span> هي "مجمدة". أماكن العناصر المجمدة هي ثابتة ولا يمكن نقلها أو تحريرها بواسطة المستخدم . وهي دائماً تشغل الأماكن العليا في الحاويات.'),
(566, 1, 2116, 'يمكنك السماح للمستخدمين تخصيص مكونات هذه الصفحة. ومع ذلك فإنهم لن يكونوا قادرين على تغيير تصميم وتنسيق الصفحة.'),
(567, 1, 2117, 'هل أنت متأكد أنك تريد حذف هذا التطبيق ؟'),
(568, 1, 2118, 'السماح للمستخدمين تخصيص هذه الصفحة'),
(572, 1, 2122, 'الإعدادات'),
(580, 1, 2130, 'الإدارة'),
(575, 1, 2125, 'عدد التعليقات لعرضها'),
(576, 1, 2126, 'نمط العرض'),
(577, 1, 2127, 'مع ترحيل صفحات'),
(578, 1, 2128, 'قائمة كاملة'),
(581, 1, 2131, 'للأسف ، لا يوجد ملفات شخصية'),
(582, 1, 2132, 'متصل'),
(584, 1, 2134, 'تخصيص هذه الصفحة'),
(585, 1, 2135, 'عيد الميلاد'),
(591, 1, 2141, 'لوحة تحكم الإدارة'),
(592, 1, 2142, 'إستعراض المستخدمين'),
(593, 1, 2143, 'الإعدادات الرئيسية'),
(594, 1, 2144, 'تفاصيل الملف الشخصي'),
(595, 1, 2145, 'RSS'),
(596, 1, 2146, 'عدد العناصر'),
(597, 1, 2147, 'الرابط'),
(598, 1, 2148, 'أدخل رابطاً صحيحاً'),
(707, 1, 2257, 'هل أنت متأكد أنك تريد حذف هذا السؤال ؟'),
(605, 1, 2155, 'إشترك في موقعنا الإجتماعي سريع النمو . أعثر على أصدقاء جدد ، تعرف عليهم وقابلهم ، تشارك معهم الصور والفيديو.\r\nتمتع !'),
(611, 1, 2161, 'الإعدادات الرئيسية'),
(612, 1, 2162, 'الأساسي'),
(46644, 1, 9873, 'إعدادات المستخدم'),
(614, 1, 2164, 'إختر نوع الحساب'),
(615, 1, 2165, 'ينبغي أن يحتوي فقط على الأحرف والأرقام'),
(616, 1, 2166, 'يجب أن يكون صحيحاً'),
(617, 1, 2167, 'إنضم إلى موقعنا'),
(618, 1, 2168, 'تثبيت الموقع'),
(619, 1, 2169, 'إسم الموقع'),
(621, 1, 2171, 'وصف جذاب قصير لموقعك .'),
(622, 1, 2172, 'الوصف'),
(623, 1, 2173, 'الرجاء كتابة بضع جمل لوصف موقعك.'),
(624, 1, 2174, 'إعدادات الوقت'),
(625, 1, 2175, 'التوقيت/المنطقة الزمنية'),
(626, 1, 2176, 'إستخدام التاريخ / الوقت النسبي'),
(627, 1, 2177, '"الأمس, 5:31" بدلاً من "حزيران 1 ''09, 5:31"'),
(628, 1, 2178, 'الجنس'),
(629, 1, 2179, ''),
(630, 1, 2180, 'ذكر'),
(631, 1, 2181, 'أنثى'),
(632, 1, 2182, 'نوع الحساب'),
(633, 1, 2183, 'نعم'),
(634, 1, 2184, 'لا'),
(635, 1, 2185, 'الإعدادات تم تحديثها'),
(636, 1, 2186, 'لا يوجد محتوى'),
(637, 1, 2187, 'العناوين فقط'),
(638, 1, 2188, 'الأساسي'),
(10350, 1, 3812, 'نشط حالياً'),
(646, 1, 2196, 'أدوار المستخدمين'),
(650, 1, 2200, 'لا يوجد قيمة'),
(657, 1, 2207, 'المدونات'),
(658, 1, 2208, 'أضف تعليقات'),
(664, 1, 2214, 'أضف بعض المعلومات عن نفسك هنا'),
(665, 1, 2215, 'معلومات عني'),
(666, 1, 2216, 'تم تحديث الوصف'),
(667, 1, 2217, 'إستعراض المستخدمين'),
(668, 1, 2218, 'لا يوجد مستخدمون'),
(669, 1, 2219, 'تحديد الكل'),
(670, 1, 2220, 'المحدد : '),
(681, 1, 2231, 'إشترك بتاريخ'),
(682, 1, 2232, 'المستخدم'),
(683, 1, 2233, 'إختر'),
(684, 1, 2234, 'أكتب هنا...'),
(685, 1, 2235, '{$count} مستخدم(ين) تم حذفهم'),
(686, 1, 2236, 'هل أنت متأكد أنك تريد حذف المستخدمين المحددين ؟'),
(706, 1, 2256, 'السؤال تم حذفه'),
(16894, 1, 4514, 'رئيسية المستخدم'),
(1011, 1, 2555, 'أرسل'),
(719, 1, 2269, 'إسم المستخدم/البريد الالكتروني'),
(720, 1, 2270, 'تقييم'),
(721, 1, 2271, 'تم حذف القسم'),
(883, 1, 2427, 'الأساسي'),
(775, 1, 2324, 'نوع حساب تمت إضافته'),
(1262, 1, 2791, 'من يستطيع الإشتراك:'),
(758, 1, 2307, 'تحرير'),
(759, 1, 2308, 'حذف'),
(1261, 1, 2790, 'إزالة حقوق ''المدير'' من هذا المشرف قبل أن تتمكن من إزالتها كلياً.'),
(779, 1, 2328, 'أسئلة الملف الشخصي'),
(763, 1, 2312, 'أدخل بريدك الالكتروني'),
(764, 1, 2313, 'عنوان بريدك الالكتروني'),
(765, 1, 2314, 'نوع حساب تم حذفه'),
(766, 1, 2315, 'كلمة سر جديدة لحسابك'),
(20357, 1, 6052, 'كود إعادة إعداد لكلمة السر الجديدة'),
(780, 1, 2329, 'أضف سؤالاً'),
(781, 1, 2330, 'تحرير أنواع الحساب'),
(816, 1, 2365, 'الإعدادات'),
(873, 1, 2420, 'أضف قيماً جديدة'),
(784, 1, 2333, 'أنت غير مسموح لك كتابة تعليق'),
(785, 1, 2334, 'النص'),
(786, 1, 2335, 'خيار فردي'),
(787, 1, 2336, 'خيار فردي'),
(788, 1, 2337, 'نص ممتد'),
(789, 1, 2338, 'نعم/لا'),
(790, 1, 2339, 'إختيار متعدد'),
(791, 1, 2340, 'التاريخ'),
(792, 1, 2341, 'الرابط'),
(793, 1, 2342, 'كلمة السر'),
(992, 1, 2536, 'أضف نوع حساب جديد'),
(1116, 1, 2654, 'بريد التأكيد تم إرساله بنجاح'),
(1117, 1, 2655, 'إيقاف - تعليق'),
(1118, 1, 2656, 'إيقاف - تعليق'),
(1119, 1, 2657, 'الملف الشخصي تم تعليقه'),
(1121, 1, 2659, 'تم إيقاف - تعليق الملفات الشخصية'),
(1122, 1, 2660, '<center>عذراً ، تم إيقاف حسابك . من فضلك إتصل بمدير الموقع.</center>'),
(817, 1, 2366, 'إذا كان لديك عدة أسئلة ملف شخصي فإنه سيكون من المساعد لعرض الأقسام كعلامات تبويب على صفحة عرض الملف الشخصي.'),
(806, 1, 2355, 'المدونات'),
(807, 1, 2356, 'المواقع'),
(1263, 1, 2792, 'أي شخص'),
(818, 1, 2367, 'عرض الأقسام كعلامات تبويب'),
(819, 1, 2368, 'أضف مشاركة مدونة'),
(821, 1, 2370, 'العرض'),
(825, 1, 2374, 'حفظ'),
(826, 1, 2375, 'تم تحديث بيانات المستخدم'),
(827, 1, 2376, 'تحرير الملف الشخصي'),
(843, 1, 2390, 'تحرير إسم القسم'),
(834, 1, 2381, 'رئيسية المستخدم'),
(835, 1, 2382, 'إدارة الملحقات البرمجية'),
(836, 1, 2383, 'الملحقات البرمجية النشطة'),
(837, 1, 2384, 'الملحقات البرمجية الغير نشطة'),
(838, 1, 2385, 'الإعدادات'),
(839, 1, 2386, 'تعطيل'),
(840, 1, 2387, 'تشغيل'),
(841, 1, 2388, 'إلغاء التثبيت'),
(842, 1, 2389, 'التثبيت'),
(844, 1, 2391, 'تحرير قيمة السؤال'),
(845, 1, 2392, 'تحرير إسم السؤال'),
(846, 1, 2393, 'تحرير وصف السؤال'),
(847, 1, 2394, 'كل أنواع الحساب'),
(848, 1, 2395, 'تحرير إسم نوع الحساب'),
(849, 1, 2396, 'ملحق "{$plugin}" البرمجي تم تثبيته بنجاح'),
(859, 1, 2406, 'قياسي'),
(858, 1, 2405, 'هل أنت متأكد أنك تريد أن تحذف نوع الحساب ؟'),
(1041, 1, 2585, 'لإلغاء الإشتراك من هذه القائمة البريدية من فضلك إضغط هنا: {$link}'),
(1040, 1, 2584, '<br />\r\n<br />\r\nلإلغاء الإشتراك من هذه القائمة البريدية من فضلك <a href="{$link}" >إضغط هنا</a>'),
(1037, 1, 2581, 'نجاح التقييم'),
(1104, 1, 2642, 'الإسم الحقيقي'),
(1010, 1, 2554, 'تأكيد البريد الالكتروني'),
(880, 1, 2425, 'إسم المستخدم أو البريد الالكتروني غير صحيح'),
(881, 1, 2426, 'كلمة سر غير صحيحة'),
(885, 1, 2429, 'السؤال'),
(886, 1, 2430, 'وصف قصير إذا لزم الامر'),
(887, 1, 2431, 'نجاح المصادقة ، يرجى الانتظار ...'),
(892, 1, 2436, 'جميع الحقوق محفوظة لـ{$site_name}'),
(924, 1, 2468, 'تم الإستنساخ'),
(925, 1, 2469, 'أسئلة الملف الشخصي'),
(1264, 1, 2793, 'عن طريق دعوتي فقط'),
(928, 1, 2472, 'اللغة'),
(929, 1, 2473, 'يعرض أسئلة لنوع الحساب'),
(930, 1, 2474, 'قسم جديد'),
(931, 1, 2475, 'السؤال'),
(933, 1, 2477, 'لنوع الحساب'),
(934, 1, 2478, 'إختر نوع الحساب المناسب للسؤال <i>فقط</i> إذا لم تناسب أنواع أخرى.</b> ومثال على ذلك : <b><i>الجنس</i></b> يتوافق مع <b><i>فردي</i></b> ولكن لا يناسب <b><i>زوجان</i></b>.'),
(935, 1, 2479, 'القسم'),
(936, 1, 2480, 'نوع الجواب'),
(1215, 1, 2744, 'أوكسوول العربية'),
(941, 1, 2485, 'القيم المحتملة (واحدة لكل سطر)'),
(942, 1, 2486, 'يمكنك إضافة ما يصل إلى 31 قيمة'),
(943, 1, 2487, 'عدد الأعمدة'),
(944, 1, 2488, 'مطلوب'),
(945, 1, 2489, 'النموذج سوف لن يتم تقديمه إذا لم يدخل المستخدم جواباً صحيحاً لهذا السؤال'),
(946, 1, 2490, 'في <b>سجـّل الآن</b>'),
(947, 1, 2491, 'السؤال يجب أن يكون في صفحة التسجيل'),
(948, 1, 2492, 'في <b>تحرير الملف الشخصي</b>'),
(949, 1, 2493, 'السؤال يجب أن يكون متوفراً للمستخدم لتحريره'),
(950, 1, 2494, 'في <b>عرض الملف الشخصي</b>'),
(951, 1, 2495, 'السؤال يجب أن يكون معروضاً في صفحة عرض الملف الشخصي'),
(952, 1, 2496, 'السؤال يجب أن يتم إستخدامه لبحث المستخدم'),
(953, 1, 2497, 'في <b>البحث</b>'),
(954, 1, 2498, 'حفظ وإضافة جديدة'),
(1039, 1, 2583, 'تحرير الدور'),
(957, 1, 2501, 'تم إضافة سؤال'),
(960, 1, 2504, 'تم تحديث السؤال'),
(961, 1, 2505, 'أو'),
(959, 1, 2503, 'يدعم HTML/OWML <a href="{$url}"><img src="{$src}" /></a>'),
(962, 1, 2506, 'هل أنت متأكد ؟'),
(967, 1, 2511, 'وسوم ميتا تاج إضافية لقسم رأسية الصفحة الخاصة بك.'),
(970, 1, 2514, 'أضف قيماً جديدة'),
(969, 1, 2513, 'وصف السؤال'),
(971, 1, 2515, 'القيم الموجودة'),
(972, 1, 2516, 'سحب وإفلات لإعادة الترتيب'),
(973, 1, 2517, 'أضف قيم سؤال جديد'),
(974, 1, 2518, 'السؤال لم يتم تحديثه'),
(975, 1, 2519, 'السؤال لم يتم تحديثه'),
(978, 1, 2522, 'أضف قيم (واحدة لكل سطر)'),
(979, 1, 2523, 'يمكنك إضافة ما يصل إلى 31 قيمة'),
(1207, 1, 2736, 'محتوى الصفحة'),
(981, 1, 2525, 'أضف'),
(982, 1, 2526, 'الصفحات'),
(987, 1, 2531, 'لا يوجد قيمة'),
(985, 1, 2529, 'السؤال غير موجود'),
(989, 1, 2533, 'أضف {$count} قيمة سؤال'),
(997, 1, 2541, 'تم إضافة القسم'),
(996, 1, 2540, 'نوع حساب تمت إضافته'),
(998, 1, 2542, 'هنا يمكنك تغيير المعلومات المضافة بواسطة المستخدمين عن أنفسهم. يمكنك أن تقوم بتغيير ، إعادة ترتيب ، وإضافة أسئلة ملف شخصي جديدة.'),
(999, 1, 2543, '<span class="ow_highlight">سحب وإفلات</span> الأسئلة والأقسام لتغيير ترتيبها.'),
(1000, 1, 2544, 'أضف سؤالاً جديداً'),
(1001, 1, 2545, 'أقسام أسئلة الملف الشخصي'),
(1002, 1, 2546, 'إذا كان لديك بعض من أسئلة الملف الشخصي فإنك ربما تريد تقسيمها إلى أقسام . قد يكون لديك الأقسام التالية "<b><i>المعلومات الأساسية</i></b>", "<b><i>الإتصال</i></b>", "<b><i>الإهتمامات</i></b>", وهكذا.'),
(1003, 1, 2547, 'قسم جديد'),
(1005, 1, 2549, 'هل أنت متأكد أنك تريد أن تحذف هذا القسم ؟'),
(1012, 1, 2556, 'عزيزي {$username},<br />\r\n<br />\r\nشكراً لك على التسجيل في {$site_name}! الآن تحتاج إلى تأكيد البريد الإلكتروني الخاص بك عن طريق <a href="{$url}">الضغط هنا</a><br />\r\n<br />\r\nوبدلاً عن ذلك يمكنك إدارج هذا الكود في <a href="{$verification_page_url}">صفحة التحقق والتأكيد</a>: {$code}<br />\r\n<br />\r\nشكراً لك,<br />\r\nإدارة {$site_name}'),
(1013, 1, 2557, 'عزيزي {$username},\r\n\r\nشكراً لك على التسجيل في {$site_name}! الآن تحتاج إلى تأكيد البريد الإلكتروني الخاص بك عن طريق ضغط هذا الرابط: {$url}\r\n\r\nوبدلاً عن ذلك يمكنك إدارج هذا الكود في صفحة التحقق والتأكيد {$verification_page_url} : \r\n{$code}\r\n\r\nشكراً لك,\r\nإدارة {$site_name}'),
(1014, 1, 2558, 'عنوان البريد الالكتروني تم تأكيده'),
(1015, 1, 2559, 'أضف'),
(1016, 1, 2560, ''),
(1017, 1, 2561, 'لديك {$count} رسالة جديدة'),
(1018, 1, 2562, 'اللغة'),
(1020, 1, 2564, '<p>\r\nمن فضلك قم بتأكيد عنوان بريدك الالكتروني.<br />إضغط زر "أرسل" لتستلم رسالة مع كود التأكيد إلى عنوان بريدك الالكتروني.\r\n</p>\r\n<p>\r\n<b>إذا لم تستلم الرسالة البريدية</b> من فضلك أضف <i>{$site_email}</i> إلى قائمتك البيضاء/دفتر عناوينك/قائمة إتصالاتك.\r\n</p>'),
(1021, 1, 2565, 'عذراً ، عنوان البريد الالكتروني لم يتم تأكيده.<br/> على الأرجح:<br/> \r\n<br/> \r\n1) رابط التأكيد الذي إستخدمته غير صحيح . من فضلك إنسخ الرابط الصحيح وأدرجه في شريط العنوان.\r\n<br/><br/>\r\n2) رابط التأكيد إنتهى حيث لم يتم إستخدامه خلال 5 أيام . من فضلك أرسل طلب تأكيد مرة أخرى.'),
(1024, 1, 2568, 'تحرير'),
(1025, 1, 2569, 'أضف'),
(1026, 1, 2570, 'تجاهل تفضيل عدم الإشتراك'),
(1027, 1, 2571, 'HTML'),
(1028, 1, 2572, 'نص'),
(1029, 1, 2573, 'جسم (نص) الرسالة البريدية'),
(1030, 1, 2574, 'الموضوع'),
(1031, 1, 2575, 'تنسيق البريد الالكتروني'),
(1032, 1, 2576, 'إختيار المستخدم'),
(1033, 1, 2577, '<b>المجموع:</b> <i>{$count}</i> عضو نشيط'),
(1034, 1, 2578, 'معاينة'),
(1035, 1, 2579, 'إنشاء رسالة بريدية'),
(1036, 1, 2580, 'بدء إرسال البريد'),
(1044, 1, 2588, 'إسم الدور:'),
(1045, 1, 2589, 'تم إضافة دور جديد'),
(1051, 1, 2595, 'رجاءاً ، إختر دوراً واحداً على الأقل'),
(1049, 1, 2593, 'إلغاء الإشتراك'),
(1050, 1, 2594, 'تم حذف الدور (الأدوار)'),
(1055, 1, 2599, 'دور المستخدم'),
(1056, 1, 2600, '# المستخدمين'),
(1057, 1, 2601, 'إفتراضي'),
(1058, 1, 2602, 'إختيار الكل | المحدد :'),
(1059, 1, 2603, 'حذف'),
(1060, 1, 2604, 'هل أنت متأكد ؟'),
(1061, 1, 2605, 'إذهب إلى <a href="{$url}">صفحة الصلاحيات</a> لإعداد أي مميزات هي المسموحة لأدوار مستخدمين محددة.'),
(1065, 1, 2609, 'مجاني'),
(1068, 1, 2612, 'فشل إلغاء الإشتراك. \r\n<br />\r\nالرجاء التأكد أنك أدخلت رابط إلغاء الإشتراك بشكل صحيح.'),
(1069, 1, 2613, 'بريد جماعي'),
(1074, 1, 2615, 'صورة المستخدم'),
(1075, 1, 2616, 'صورة الأمان'),
(1079, 1, 2620, 'يمكنك استخدام المتغيرات التالية:'),
(6072, 1, 2850, 'تخصيص المستخدم'),
(1085, 1, 2626, 'إعدادات العرض'),
(1086, 1, 2627, 'إعدادات الصورة الرمزية'),
(1087, 1, 2628, 'إعدادات المستخدم تم تحديثها'),
(1088, 1, 2629, 'حجم الصورة الرمزية'),
(1089, 1, 2630, 'حجم صورة رمزية كبير'),
(1091, 1, 2632, 'عرض إسم الملف الشخصي بإستخدام :'),
(1092, 1, 2633, 'عادة قد تحتاج إلى الاختيار بين <b><i>إسم المستخدم</i></b> (تقليدي) و الإسم الحقيقي (كما هو الحال على الفيس بوك). هذا هو إعداد على مستوى الموقع.'),
(1093, 1, 2634, 'يظهر في جميع القوائم . سوف تحتاج أيضا إلى تغيير CSS الستايل الخاص بك.'),
(1094, 1, 2635, 'يعرض على صفحة الملف الشخصي'),
(1123, 1, 2661, 'الملف الشخصي تم إعادة تنشيطه'),
(1124, 1, 2662, 'إعادة تنشيط'),
(1214, 1, 2743, 'إعادة تعيين'),
(1206, 1, 2735, 'مرئي إلى'),
(6099, 1, 2877, 'لا يوجد مستخدمون'),
(1163, 1, 2698, 'أبحث عن'),
(1164, 1, 2699, ''),
(1296, 1, 2823, 'التعليق على الفيديو'),
(1203, 1, 2732, 'إسم القائمة'),
(1287, 1, 2815, '<center>لا يوجد عناصر</center>'),
(1129, 1, 2667, 'لوحة المستخدم الرئيسية'),
(1130, 1, 2668, 'إعدادات ملف المستخدم الشخصي'),
(1202, 1, 2731, 'مرئي إلى'),
(1201, 1, 2730, 'فتح في نافذة جديدة'),
(1132, 1, 2670, 'نجاح عملية التسجيل'),
(1133, 1, 2671, '<center>مستخدم موقوف</center>'),
(1134, 1, 2672, 'من فضلك إملأ النموذج بشكل صحيح'),
(1135, 1, 2673, '{$username} '),
(1136, 1, 2674, '{$username} '),
(1137, 1, 2675, 'ملفي الشخصي'),
(1138, 1, 2676, 'ملفي الشخصي'),
(1139, 1, 2677, 'هل أنت متأكد أنك تريد إعادة تعيين التخصيصات الخاصة بك ؟'),
(1142, 1, 2680, 'هل أنت متأكد أنك تريد حذف هذه الصورة ؟'),
(1170, 1, 2702, 'ذكر'),
(1171, 1, 2703, 'أنثى'),
(1176, 1, 2707, 'أنا هنا من أجل'),
(1177, 1, 2708, ''),
(1198, 1, 2727, 'إسم القائمة'),
(1199, 1, 2728, 'الرابط'),
(1200, 1, 2729, 'أنت تحتاج إلى تسجيل الدخول لإضافة تعليق'),
(1194, 1, 2723, 'المرح والمتعة'),
(1195, 1, 2724, 'أي شيء'),
(1196, 1, 2725, 'المواعدة'),
(1197, 1, 2726, 'الصداقة'),
(1208, 1, 2737, 'الضيوف'),
(1209, 1, 2738, 'الأعضاء المسجلون'),
(1210, 1, 2739, 'إسم القائمة'),
(1211, 1, 2740, 'محتوى الصفحة'),
(1212, 1, 2741, 'عنوان الصفحة'),
(1216, 1, 2745, 'الدعم العربي'),
(1217, 1, 2746, 'أوكسوول الأجنبية'),
(1218, 1, 2747, 'معاينة الصورة'),
(1295, 1, 2822, 'البريد الجماعي'),
(1255, 1, 2784, 'تم تحديث الصلاحيات بنجاح'),
(6082, 1, 2860, 'إضافة جديدة'),
(1254, 1, 2783, 'الخصوصية والصلاحيات'),
(1256, 1, 2785, 'لم يتم العثور على المستخدم'),
(1257, 1, 2786, 'تم إضافة مشرف'),
(1260, 1, 2789, 'المستخدم تمت إزالته من المشرفين'),
(1259, 1, 2788, '{$username} هو مشرف مسبقاً'),
(1105, 1, 2643, 'الإسم الأول والإسم الأخير'),
(1205, 1, 2734, 'الرابط'),
(1204, 1, 2733, 'عنوان الصفحة'),
(1265, 1, 2794, 'من يستطيع توجيه دعوة:'),
(1266, 1, 2795, 'كل المستخدمين'),
(1267, 1, 2796, 'الإدارة فقط'),
(1269, 1, 2798, 'موافقة عضو إلزامية'),
(1270, 1, 2799, 'المشرفون سوف يوافقون على كل الأعضاء يدوياً <b>قبل</b> السماح لهم بالدخول'),
(1271, 1, 2800, 'الضيوف يستطيعون مشاهدة الموقع'),
(1272, 1, 2801, 'نعم'),
(1273, 1, 2802, 'لا'),
(1275, 1, 2804, 'مع كلمة السر:'),
(1276, 1, 2805, 'إذا لم يكن <b>''نعم''</b> فسوف يتجاوز كل إعدادات الصلاحيات الأخرى'),
(1277, 1, 2806, 'حفظ'),
(1297, 1, 2824, 'مالك المحتوى يستطيع حذف التعليقات'),
(1279, 1, 2807, 'المستخدم'),
(1281, 1, 2809, 'أضف مشرفاً جديداً'),
(1282, 1, 2810, 'إسم المستخدم'),
(10328, 1, 3790, 'عدد المستخدمين الذين أرسلوا تقريراً عن هذا المحتوى'),
(1284, 1, 2812, 'إجعله مشرفاً'),
(1219, 1, 2748, 'ملفي الشخصي'),
(4993, 1, 2834, 'إذهب إلى <a href="{$url}">صفحة إدارة الدور</a> لإنشاء/تحرير/حذف أدوار المستخدمين.'),
(4984, 1, 2825, 'هل أنت متأكد أنك تريد تعليق المستخدم(ين) المحددين ؟'),
(4986, 1, 2827, 'مالك المحتوى يستطيع حذف التعليقات'),
(4988, 1, 2829, 'إستعراض المستخدمين'),
(4989, 1, 2830, 'الملحق البرمجي "{$plugin}" تم تنشيطه'),
(4990, 1, 2831, 'الملحق البرمجي "{$plugin}" تم تعطيله'),
(4994, 1, 2835, 'لا يمكنك مشاهدة هذه الصفحة بسبب الصلاحيات المحدودة'),
(6065, 1, 2844, 'مطلوب'),
(6066, 1, 2845, 'الحائط'),
(6067, 1, 2846, 'الصورة الرمزية'),
(6068, 1, 2847, 'تأكيد البريد الالكتروني'),
(6064, 1, 2843, 'عذراً ، يبدو أنك لا تمتلك صلاحيات كافية'),
(6090, 1, 2868, '123'),
(6091, 1, 2869, ''),
(6092, 1, 2870, ''),
(6093, 1, 2871, ''),
(6094, 1, 2872, ''),
(6098, 1, 2876, 'تم تحديث القيم'),
(6102, 1, 2880, 'بريد الموقع الالكتروني'),
(6103, 1, 2881, 'عنوان البريد الالكتروني والذي منه سوف يستلم المستخدمون لديك التبليغات والنشرات البريدية الجماعية.'),
(6106, 1, 2884, 'آخر نشاط'),
(6117, 1, 2895, 'كانون2'),
(6121, 1, 2899, 'المستخدم تم تعليمه كمميز'),
(6122, 1, 2900, 'المستخدم تم إزالته من قائمة المميزين'),
(6123, 1, 2901, 'التعيين كمميز'),
(6124, 1, 2902, 'الإزالة من المميزين'),
(6125, 1, 2903, 'الأصدقاء'),
(6126, 1, 2904, 'أضف صديق'),
(6128, 1, 2906, 'من فضلك إختر ملف صورة'),
(7434, 1, 3294, 'مرحباً,\r\n\r\nيسرنا أن ندعوك إلى الإنضمام إلى موقعنا - {$site_name}.\r\nمن فضلك إشترك الآن: {$url}\r\n\r\nالإدارة -\r\n{$site_url}'),
(7431, 1, 3291, 'الدعوات أرسلت بنجاح'),
(7430, 1, 3290, 'يتوجب عليك إدخال عنوان بريد الكتروني واحد على الأقل'),
(7429, 1, 3289, 'من فضلك أدخل كحد أقصى 50 عنوان بريد الكتروني'),
(7428, 1, 3288, 'أرسل دعوة'),
(7427, 1, 3287, 'أدخل قائمة العناوين البريدية (حد أقصى 50, عنوان بريدي واحد لكل سطر)'),
(7426, 1, 3286, 'إدعو أعضاء جدد'),
(7425, 1, 3285, 'إدعو أعضاء جدد'),
(7424, 1, 3284, 'مع الشاشة المتناثرة يمكنك أن تطلب من أعضاء موقعك بشكل واضح وصريح إذا ما كانوا يوافقون على دخول موقعك.'),
(7432, 1, 3292, 'دعوة إلى {$site_name}'),
(7433, 1, 3293, '<p>\r\nمرحباً,\r\n</p>\r\n<p>\r\nنحن ندعوك إلى الإشتراك في موقعنا - {$site_name}.<br />\r\nالرجاء التسجيل <a href="{$url}">هنا</a>\r\n</p>\r\nالإدارة<br />\r\n{$site_url}'),
(7423, 1, 3283, 'تفعيل'),
(9887, 1, 3349, 'أو سجــّل دخولك بإستخدام'),
(47078, 1, 10307, ''),
(7400, 1, 3260, 'المغادرة'),
(7399, 1, 3259, 'الإعدادات تم تحديثها'),
(7396, 1, 3256, 'إعدادات الشاشة المتناثرة'),
(7398, 1, 3258, 'إعدادات الشاشة المتناثرة'),
(7401, 1, 3261, 'الشاشة المتناثرة'),
(7393, 1, 3253, 'دخول'),
(7392, 1, 3252, 'هل أنت متأكد أنك تريد دخول هذا الموقع ؟'),
(7391, 1, 3251, 'حيث يذهب الزوار إذا إختاروا المغادرة'),
(7390, 1, 3250, 'رابط ''المغادرة'''),
(7389, 1, 3249, 'ملصق زر مخصص لدخول الموقع'),
(7388, 1, 3248, 'ملصق زر ''الدخول'''),
(7387, 1, 3247, 'محتوى الشاشة المتناثرة. يدعم HTML.'),
(7386, 1, 3246, 'نص/HTML'),
(7384, 1, 3244, 'آ»آ»'),
(7383, 1, 3243, 'آ»'),
(7382, 1, 3242, 'آ«'),
(7381, 1, 3241, 'آ«آ«'),
(7380, 1, 3240, 'كلمة سر غير صحيحة'),
(7379, 1, 3239, 'يتم إعادة التوجيه...'),
(7378, 1, 3238, 'دخول'),
(7377, 1, 3237, 'عذراً , المنتدى مغلق للعرض العام.'),
(7376, 1, 3236, 'أدخل كلمة السر'),
(7375, 1, 3235, 'الإعدادات حفظت'),
(10366, 1, 3828, 'المستخدمون'),
(9883, 1, 3345, 'لوحة المشرف'),
(9884, 1, 3346, 'الموافقة على المستخدمين'),
(7414, 1, 3274, 'عذراً ، التسجيل في الموقع مغلق'),
(7372, 1, 3232, 'أو'),
(7371, 1, 3231, 'سجــّل دخولك بإستخدام'),
(7370, 1, 3230, 'سجــّل ملفك الشخصي'),
(9891, 1, 3353, 'تمت الموافقة على المستخدم'),
(7397, 1, 3257, 'الشاشة المتناثرة'),
(9886, 1, 3348, 'موافقة مستخدم إلزامية'),
(7335, 1, 3116, 'سنة'),
(7334, 1, 3115, 'التاريخ'),
(7333, 1, 3114, 'التاريخ'),
(7327, 1, 3108, 'تشرين2'),
(7326, 1, 3107, 'تشرين1'),
(7324, 1, 3105, 'حزيران'),
(7325, 1, 3106, 'تموز'),
(7323, 1, 3104, 'أيار'),
(7321, 1, 3102, 'نيسان'),
(7320, 1, 3101, 'آذار'),
(7319, 1, 3100, 'تجربة SMTP نجحت . بإمكانك البدء بإرسال الرسائل البريدية يإستخدام هذا الإتصال .'),
(7318, 1, 3099, 'تجربة الإتصال'),
(7315, 1, 3096, 'تجربة إتصال SMTP'),
(7317, 1, 3098, 'تأكد أنك قمت بفحص إتصال SMTP الخاص بك قبل بدأك إرسال الرسائل البريدية بإستخدامه  . وإلا ، فإن موقعك قد يتوقف عن إرسال الرسائل البريدية بالكامل .'),
(7316, 1, 3097, 'معطل'),
(7311, 1, 3092, 'إعدادات SMTP'),
(7309, 1, 3090, 'نوع أمان إتصال SMTP'),
(7308, 1, 3089, 'إتصال آمن'),
(7307, 1, 3088, 'كلمة السر'),
(7306, 1, 3087, 'إسم المستخدم'),
(7305, 1, 3086, 'المستضيف:المنفذ'),
(7304, 1, 3085, 'من فضلك لا تقم بتفعيله إذا كنت لا تعلم ماذا تعمل بالضبط . موقعك قد يتوقف عن إرسال الرسائل البريدية!'),
(7303, 1, 3084, 'تفعيل'),
(7302, 1, 3083, 'SMTP'),
(7301, 1, 3082, 'إعدادات SMTP تم تحديثها'),
(7300, 1, 3081, 'هل أنت متأكد أنك تريد حذف هذا المستخدم ؟'),
(7298, 1, 3079, 'الحساب تمت إزالته<br />\r\nتوجه عائداً إلى <a href="{$site_url}">الموقع</a>'),
(7297, 1, 3078, 'تأكيد الحذف'),
(7296, 1, 3077, 'حذف'),
(43372, 1, 9399, 'مرئي للضيوف فقط'),
(7287, 1, 3068, 'qqqq'),
(7289, 1, 3070, 'qqq'),
(7291, 1, 3072, 'qqq'),
(7285, 1, 3066, 'aaa'),
(10396, 1, 3858, 'الملحقات البرمجية المثبتة'),
(7275, 1, 3056, 'حذف محتوى المستخدم'),
(7273, 1, 3054, 'الإعدادات تم تحديثها'),
(7272, 1, 3053, 'يوم/شهر/سنة'),
(7271, 1, 3052, 'شهر/يوم/سنة'),
(7270, 1, 3051, 'صيغة التاريخ'),
(7268, 1, 3049, 'من فضلك ، أدخل كود التأكيد.'),
(7267, 1, 3048, 'تقديم'),
(7269, 1, 3050, 'كود التأكيد غير صحيح'),
(7265, 1, 3046, 'الكود'),
(7264, 1, 3045, 'هل أنت متأكد أنك تريد حذف ملفك الشخصي ؟'),
(7260, 1, 3041, 'حذف الملف الشخصي'),
(7259, 1, 3040, 'تحرير تفاصيل الملف الشخصي'),
(7258, 1, 3039, 'حذف الملف الشخصي'),
(7257, 1, 3038, 'حذف'),
(7255, 1, 3036, 'sfdaf'),
(7253, 1, 3034, '2q3r3'),
(7256, 1, 3037, 'إلغاء'),
(7251, 1, 3032, 'sdfsdfsdf'),
(7249, 1, 3030, '8aaxaxa'),
(7246, 1, 3027, 'sdfsdf'),
(7244, 1, 3025, 'sdf'),
(7242, 1, 3023, 'sdffsdf'),
(7237, 1, 3018, 'whoohaa'),
(7248, 1, 3029, '8aaxaxa'),
(7235, 1, 3016, 'whoohaa'),
(7240, 1, 3021, 'sdfsd'),
(7231, 1, 3012, 'الضيوف غير مسموح لهم القيام بالتقييم'),
(7230, 1, 3011, 'جالب الإتصالات'),
(7216, 1, 2997, 'الإشتراك'),
(7142, 1, 2923, 'تغيير كلمة السر'),
(7143, 1, 2924, 'كلمة السر القديمة'),
(7144, 1, 2925, 'كلمة السر الجديدة'),
(7145, 1, 2926, 'إعادة كلمة السر الجديدة'),
(7146, 1, 2927, 'كلمة السر تغيرت'),
(7147, 1, 2928, 'كلمة السر لم تتغير'),
(7151, 1, 2932, '<a href="{$userUrl}">{$user}</a> قام بتغيير صورته الرمزية.'),
(7153, 1, 2934, '<a href="{$userUrl}">{$user}</a> إنضم إلى موقعنا !'),
(7154, 1, 2935, '<a href="{$userUrl}"><img src="{$avatarUrl}" alt="{$user}"></a>'),
(7155, 1, 2936, '<a href="{$userUrl}">{$user}</a> قام بتحرير تفاصيل ملفه الشخصي'),
(7177, 1, 2958, 'هل أنت متأكد أنك تريد إعادة تعيين تخصيص ملفك الشخصي ؟'),
(7212, 1, 2993, 'إعادة تفعيل'),
(7213, 1, 2994, 'المستخدمون المحددون تم إعادة تفعيلهم'),
(7214, 1, 2995, 'المستخدم(ون) المحددون تم إعادة تفعيلهم'),
(46459, 1, 9690, 'لا يوجد '),
(46460, 1, 9691, 'الإشتراك في النشرة الإخبارية'),
(46462, 1, 9693, 'عرض'),
(10589, 1, 4051, 'من فضلك أدخل كلمة السر'),
(10588, 1, 4050, 'اليوم'),
(10587, 1, 4049, 'الشهر'),
(10585, 1, 4047, 'هل أنت متأكد أنك تريد حذف التعليق ؟'),
(10586, 1, 4048, 'السنة'),
(10584, 1, 4046, 'لا يمكنك تقييم محتواك الخاص بك'),
(10581, 1, 4043, 'أنت غير مصرح لك البحث عن المستخدمين'),
(10582, 1, 4044, 'البحث في المستخدمين'),
(10577, 1, 4039, 'إلى'),
(10578, 1, 4040, '(متوسط العمر)'),
(10576, 1, 4038, 'من'),
(10573, 1, 4035, 'العودة إلى البحث من'),
(10572, 1, 4034, 'البحث'),
(10570, 1, 4032, 'البحث الرئيسي'),
(10554, 1, 4016, 'الخميس'),
(10555, 1, 4017, 'الجمعة'),
(10556, 1, 4018, 'السبت'),
(10557, 1, 4019, 'الرجاء إدخال مفتاح ترخيص صحيح'),
(10558, 1, 4020, 'البحث'),
(10559, 1, 4021, 'البحث بواسطة الإسم'),
(10560, 1, 4022, 'بحث المستخدم'),
(10552, 1, 4014, 'الثلاثاء'),
(10553, 1, 4015, 'الأربعاء'),
(10550, 1, 4012, 'الأحد'),
(10551, 1, 4013, 'الإثنين'),
(10548, 1, 4010, 'هل أنت متأكد أنك تريد تحديث الملحق البرمجي <i>''{$name}''</i> من النسخة <b>{$oldVersion}</b> إلى <b>{$newVersion}</b>؟ الملحق البرمجي تجاري ، لتحديثه من فضلك أدخل مفتاح الترخيص وإضغط زر ''تحديث''.'),
(10544, 1, 4006, 'تحديث'),
(10543, 1, 4005, 'العودة إلى قائمة الملحقات البرمجية'),
(10542, 1, 4004, 'مفتاح الترخيص'),
(10525, 1, 3987, 'تم تزويد معايير دخول FTP غير صحيحة'),
(10526, 1, 3988, 'مزود خدمة الدفع لا يدعم عملة الموقع النشطة (<b>{$currency}</b>)'),
(10494, 1, 3956, 'إدفع بأمان مع'),
(10491, 1, 3953, 'لا'),
(10490, 1, 3952, 'نعم'),
(10489, 1, 3951, 'هل أنت متأكد أنك تريد تحديث الملحق البرمجي <i>''{$name}''</i> من النسخة <b>{$oldVersion}</b> إلى <b>{$newVersion}</b>؟'),
(10488, 1, 3950, 'طلب تحديث ملحق برمجي'),
(10483, 1, 3945, 'لا يوجد بوابات دفع منشطة'),
(10473, 1, 3935, 'معاينة'),
(10474, 1, 3936, 'الحجم الكامل'),
(10475, 1, 3937, 'المحاذاة'),
(10476, 1, 3938, 'لا شيء'),
(10477, 1, 3939, 'يسار'),
(10478, 1, 3940, 'توسيط'),
(10479, 1, 3941, 'يمين'),
(10480, 1, 3942, 'إدراج في المشاركة'),
(10481, 1, 3943, 'تحديث'),
(10471, 1, 3933, 'الرابط'),
(10472, 1, 3934, 'إزالة'),
(10470, 1, 3932, 'إخفاء'),
(10469, 1, 3931, 'عرض'),
(10468, 1, 3930, 'المعرض'),
(10467, 1, 3929, 'من الرابط'),
(10466, 1, 3928, 'إختر ملفاً'),
(10465, 1, 3927, 'حد حجم الملف هو'),
(10462, 1, 3924, 'رابط الصورة'),
(10463, 1, 3925, 'إدراج'),
(10464, 1, 3926, 'أنواع الملفات المقبولة:'),
(10461, 1, 3923, 'إدخال تنسيق المستخدم'),
(10460, 1, 3922, 'الحد الأقصى لحجم الملف'),
(10459, 1, 3921, 'السماح برفع الصور'),
(10458, 1, 3920, 'أضف ملحق برمجي جديد'),
(10456, 1, 3918, 'رفع'),
(10440, 1, 3902, '"{$plugin}" تم حذفه'),
(10430, 1, 3892, 'تذكـّرني'),
(10425, 1, 3887, 'المستضيف'),
(10426, 1, 3888, 'نسيت كلمة السر'),
(14322, 1, 4126, 'أعياد الميلاد'),
(10416, 1, 3878, 'الإتصال فشل ، من فضلك تحقق من تفاصيل المستضيف والمنفذ'),
(10413, 1, 3875, 'المنفذ'),
(10411, 1, 3873, 'دخول'),
(10412, 1, 3874, 'وصول ودخول FTP يحتاج إلى إكمال العملية'),
(10409, 1, 3871, 'الدخول'),
(10410, 1, 3872, 'كلمة السر'),
(10408, 1, 3870, 'رفع'),
(10407, 1, 3869, 'أدخل الخصائص'),
(10406, 1, 3868, 'خصائص FTP'),
(10405, 1, 3867, 'الملحق البرمجي "{$plugin}" تم إلغاء تثبيته بنجاح'),
(10404, 1, 3866, 'حذف'),
(10401, 1, 3863, 'الملحقات البرمجية المتوفرة'),
(10403, 1, 3865, 'هل أنت متأكد أنك تريد حذف الملحق البرمجي `{$pluginName}` كاملاً'),
(10402, 1, 3864, 'الملحق البرمجي غير موجود'),
(10400, 1, 3862, 'العملة'),
(10399, 1, 3861, 'الشؤون المالية'),
(10398, 1, 3860, 'إضافة جديدة'),
(10397, 1, 3859, 'الملحقات البرمجية المتوفرة'),
(10392, 1, 3854, 'المعلومات حول تغيير وتأكيد كلمة السر الجديدة الخاصة بك أرسلت إلى بريدك الإلكتروني'),
(10389, 1, 3851, 'رئيسية المستخدم'),
(10390, 1, 3852, 'تم تغيير الستايل'),
(10383, 1, 3845, 'العودة'),
(10381, 1, 3843, 'تقديم'),
(10382, 1, 3844, 'أضف عنصراً'),
(10373, 1, 3835, 'أدوار المستخدمين'),
(10374, 1, 3836, 'أدوار المستخدمين'),
(10375, 1, 3837, 'المشرفون'),
(10372, 1, 3834, 'الخصوصية العامة'),
(10371, 1, 3833, 'العودة إلى أدوار المستخدمين'),
(10370, 1, 3832, 'دور المستخدم: {$role}'),
(10368, 1, 3830, 'محتوى ذات تقرير'),
(10369, 1, 3831, 'إدارة أدوار المستخدمين'),
(10367, 1, 3829, 'للموافقة'),
(10358, 1, 3820, 'النشاط:'),
(10359, 1, 3821, 'متصل الآن'),
(10361, 1, 3823, 'نتائج بحث المستخدم عن: "<b>{$for}</b>"'),
(10357, 1, 3819, 'غير موافق عليه'),
(10356, 1, 3818, 'غير مؤكد'),
(10355, 1, 3817, 'موقوف'),
(10354, 1, 3816, 'الحالة'),
(10353, 1, 3815, 'غير موافق عليه'),
(10352, 1, 3814, 'غير مؤكد'),
(10351, 1, 3813, 'موقوف'),
(10346, 1, 3808, 'صفحة الصيانة'),
(20387, 1, 6082, '123'),
(10312, 1, 3774, 'تقرير'),
(10309, 1, 3771, 'مخالفة'),
(10310, 1, 3772, 'غير قانوني'),
(10311, 1, 3773, 'أرسل تقريراً عن هذا العنصر كـ ...'),
(10166, 1, 3628, 'زمبابواي'),
(10165, 1, 3627, 'زامبيا'),
(10164, 1, 3626, 'جنوب أفريقيا'),
(10163, 1, 3625, 'اليمن'),
(10162, 1, 3624, 'ساموا'),
(10160, 1, 3622, 'فانواتو'),
(10161, 1, 3623, 'واليس وفوتونا'),
(10158, 1, 3620, 'الجزر العذراء, الولايات المتحدة'),
(10159, 1, 3621, 'فييتنام'),
(10157, 1, 3619, 'جزر فيرجن البريطانية'),
(10156, 1, 3618, 'فنزويلا'),
(10155, 1, 3617, 'سانت فنسنت وغرينادين'),
(10154, 1, 3616, 'دولة الفاتيكان'),
(10153, 1, 3615, 'أوزباكستان'),
(10152, 1, 3614, 'الولايات المتحدة'),
(10151, 1, 3613, 'الأوروغواي'),
(10147, 1, 3609, 'تانزانيا'),
(10148, 1, 3610, 'أوغاندا'),
(10149, 1, 3611, 'أوكرانيا'),
(10150, 1, 3612, 'جزر الولايات المتحدة البعيدة الصغيرة'),
(10146, 1, 3608, 'تايوان'),
(10143, 1, 3605, 'تونس'),
(10144, 1, 3606, 'تركيا'),
(10145, 1, 3607, 'توفالو'),
(10142, 1, 3604, 'ترينيداد وتوباغو'),
(10141, 1, 3603, 'تونغا'),
(10140, 1, 3602, 'تيمور الشرقية'),
(10139, 1, 3601, 'تركمينيستان'),
(10138, 1, 3600, 'توكيلاو'),
(10137, 1, 3599, 'طاجيكيستان'),
(10133, 1, 3595, 'جزر تركس وكايكوس'),
(10134, 1, 3596, 'تشاد'),
(10135, 1, 3597, 'توغو'),
(10136, 1, 3598, 'تايلند'),
(10132, 1, 3594, 'سوريا'),
(10131, 1, 3593, 'سيشيل'),
(10130, 1, 3592, 'سوازيلند'),
(10129, 1, 3591, 'السويد'),
(10128, 1, 3590, 'سلوفينيا'),
(10127, 1, 3589, 'سلوفاكيا'),
(10126, 1, 3588, 'سورينام'),
(10123, 1, 3585, 'سان بيار وميكلون'),
(10124, 1, 3586, 'صربيا'),
(10125, 1, 3587, 'ساو تومي وبرينسيبي'),
(10121, 1, 3583, 'سان مارينو'),
(10122, 1, 3584, 'الصومال'),
(43380, 1, 9407, 'القيم المحتملة'),
(10120, 1, 3582, 'السلفادور'),
(10116, 1, 3578, 'سنغافورة'),
(10117, 1, 3579, 'جورجيا الجنوبية وجزر ساندويتش الجنوبية'),
(10118, 1, 3580, 'جزر سليمان'),
(10119, 1, 3581, 'سيراليون'),
(10115, 1, 3577, 'السنغال'),
(43379, 1, 9406, 'أنت غير مسموح لك مشاهدة الملفات الشخصية'),
(10114, 1, 3576, 'السودان'),
(10113, 1, 3575, 'صربيا والجبل الأسود'),
(10112, 1, 3574, 'السعودية'),
(10111, 1, 3573, 'رواندا'),
(10110, 1, 3572, 'الإتحاد الروسي'),
(10109, 1, 3571, 'رومانيا'),
(10108, 1, 3570, 'ريونيون'),
(10107, 1, 3569, 'قطر'),
(10106, 1, 3568, 'بولينيزيا الفرنسية'),
(10105, 1, 3567, 'فلسطين المحتلة'),
(10104, 1, 3566, 'باراغواي'),
(10103, 1, 3565, 'البورتوغال'),
(10102, 1, 3564, 'جمهورية كوريا الشعبية الديمقراطية'),
(10101, 1, 3563, 'بورتو ريكو'),
(10100, 1, 3562, 'بولندا'),
(10099, 1, 3561, 'بابوا غينيا الجديدة'),
(10098, 1, 3560, 'بالاو'),
(10097, 1, 3559, 'الفلبين'),
(10096, 1, 3558, 'بيرو'),
(10095, 1, 3557, 'بنما'),
(10094, 1, 3556, 'باكستان'),
(10093, 1, 3555, 'عمان'),
(10092, 1, 3554, 'نيوزيلاندا'),
(10091, 1, 3553, 'ناورو'),
(10090, 1, 3552, 'نيبال'),
(10089, 1, 3551, 'النرويج'),
(10087, 1, 3549, 'نيوي'),
(10088, 1, 3550, 'هولندا'),
(10203, 1, 3665, 'عذراً ، صفحة بهذا العنوان موجودة مسبقاً'),
(10086, 1, 3548, 'نيكاراغوا'),
(10085, 1, 3547, 'نيجيريا'),
(10084, 1, 3546, 'جزيرة نورفولك'),
(10082, 1, 3544, 'كاليدونيا الجديدة'),
(10083, 1, 3545, 'النيجر'),
(10081, 1, 3543, 'ناميبيا'),
(10315, 1, 3777, 'لقد قمت بتأشير/تعليم هذا مسبقاً'),
(10080, 1, 3542, 'مايوت'),
(10078, 1, 3540, 'ملاوي'),
(10079, 1, 3541, 'ماليزيا'),
(10077, 1, 3539, 'موريشيوس'),
(10330, 1, 3792, 'لوحتي الرئيسية'),
(10076, 1, 3538, 'مارتينيك'),
(10075, 1, 3537, 'مونتسيرات'),
(10074, 1, 3536, 'موريتانيا'),
(10073, 1, 3535, 'موزامبيق'),
(10329, 1, 3791, 'التقرير تم حذفه'),
(10072, 1, 3534, 'جزر ماريانا الشمالية'),
(10068, 1, 3530, 'مالطا'),
(10069, 1, 3531, 'ميانمار'),
(10070, 1, 3532, 'الجبل الأسود'),
(10071, 1, 3533, 'منغوليا'),
(10067, 1, 3529, 'مالي'),
(10065, 1, 3527, 'جزر مارشال'),
(10066, 1, 3528, 'جمهورية مقدونيا اليوغوسلافية'),
(10064, 1, 3526, 'المكسيك'),
(10063, 1, 3525, 'جزر المالديف'),
(10062, 1, 3524, 'مدغشقر'),
(10061, 1, 3523, 'مولدوفا'),
(10060, 1, 3522, 'موناكو'),
(10059, 1, 3521, 'المغرب'),
(10058, 1, 3520, 'سانت مارتن'),
(10057, 1, 3519, 'ماكاو'),
(10054, 1, 3516, 'ليتوانيا'),
(10055, 1, 3517, 'لوكسيمبورغ'),
(10056, 1, 3518, 'لاتفيا'),
(10053, 1, 3515, 'ليسوتو'),
(10052, 1, 3514, 'سيريلانكا'),
(10049, 1, 3511, 'ليبيا'),
(10051, 1, 3513, 'ليختنشتاين'),
(10050, 1, 3512, 'سانت لوسيا'),
(10048, 1, 3510, 'ليبيريا'),
(10047, 1, 3509, 'لبنان'),
(10046, 1, 3508, 'لاو'),
(10045, 1, 3507, 'الكويت'),
(10044, 1, 3506, 'جمهورية كوريا'),
(10043, 1, 3505, 'سانت كيتس ونيفيس'),
(10042, 1, 3504, 'كيريباتي'),
(10041, 1, 3503, 'كامبوديا'),
(10040, 1, 3502, 'قيرغيزستان'),
(10039, 1, 3501, 'كينيا'),
(10038, 1, 3500, 'كازاخستان'),
(10037, 1, 3499, 'اليابان'),
(10036, 1, 3498, 'الأردن'),
(10035, 1, 3497, 'جيرسي'),
(10336, 1, 3798, 'المنتدى'),
(10034, 1, 3496, 'جامايكا'),
(10033, 1, 3495, 'إيطاليا'),
(10032, 1, 3494, 'إسرائيل'),
(10031, 1, 3493, 'أيسلندا'),
(10030, 1, 3492, 'العراق'),
(10029, 1, 3491, 'إيران'),
(10026, 1, 3488, 'الهند'),
(10027, 1, 3489, 'إقليم المحيط الهندي البريطاني'),
(10028, 1, 3490, 'إيرلندا'),
(10025, 1, 3487, 'جزيرة آيل أوف مان'),
(10024, 1, 3486, 'إندونيسيا'),
(10023, 1, 3485, 'هنغاريا'),
(43373, 1, 9400, 'مرئي للأعضاء فقط'),
(10022, 1, 3484, 'هايتي'),
(10021, 1, 3483, 'كرواتيا'),
(10020, 1, 3482, 'هندوراس'),
(10019, 1, 3481, 'هونغ كونغ'),
(10018, 1, 3480, 'غيانا'),
(10017, 1, 3479, 'غوام'),
(10016, 1, 3478, 'غيانا الفرنسية'),
(10015, 1, 3477, 'غواتيمالا'),
(10014, 1, 3476, 'غرينلاند'),
(10013, 1, 3475, 'غرينادا'),
(20388, 1, 6083, '12'),
(20389, 1, 6084, '321'),
(10012, 1, 3474, 'اليونان'),
(10011, 1, 3473, 'غينيا الاستوائية'),
(10010, 1, 3472, 'غينيا بيساو'),
(10006, 1, 3468, 'جبل طارق'),
(10007, 1, 3469, 'غينيا'),
(10009, 1, 3471, 'غامبيا'),
(10008, 1, 3470, 'جوادلوب'),
(10005, 1, 3467, 'غانا'),
(10002, 1, 3464, 'المملكة المتحدة'),
(10004, 1, 3466, 'غيرنسي'),
(10003, 1, 3465, 'جورجيا'),
(9998, 1, 3460, 'فرنسا'),
(9999, 1, 3461, 'جزر فارو'),
(10000, 1, 3462, 'ولايات ميكرونيزيا الموحدة'),
(10001, 1, 3463, 'الغابون'),
(9997, 1, 3459, 'جزر فوكلاند (مالفيناس)'),
(20386, 1, 6081, '21312'),
(9996, 1, 3458, 'فيجي'),
(9995, 1, 3457, 'فنلندا'),
(9994, 1, 3456, 'إثيوبيا'),
(9993, 1, 3455, 'إستونيا'),
(9992, 1, 3454, 'إسبانيا'),
(9991, 1, 3453, 'إريتريا'),
(9990, 1, 3452, 'مصر'),
(9989, 1, 3451, 'الإكوادور'),
(10273, 1, 3735, 'البحث بواسطة الإسم'),
(9988, 1, 3450, 'الجزائر'),
(9987, 1, 3449, 'الدومينيكان'),
(9986, 1, 3448, 'الدنيمارك'),
(9985, 1, 3447, 'دومينيكا'),
(9979, 1, 3441, 'كوبا'),
(9980, 1, 3442, 'جزر كايمان'),
(9981, 1, 3443, 'قبرص'),
(9982, 1, 3444, 'التشيك'),
(9983, 1, 3445, 'ألمانيا'),
(9984, 1, 3446, 'جيبوتي'),
(9978, 1, 3440, 'كوستا ريكا'),
(9976, 1, 3438, 'جزر القمر'),
(9977, 1, 3439, 'الرأس الأخضر'),
(9974, 1, 3436, 'جزر كوك'),
(9975, 1, 3437, 'كولومبيا'),
(9972, 1, 3434, 'جمهورية الكونغو الديمقراطية'),
(9973, 1, 3435, 'الكونغو'),
(9971, 1, 3433, 'الكاميرون'),
(9970, 1, 3432, 'كوت ديفوار'),
(9969, 1, 3431, 'الصين'),
(9968, 1, 3430, 'تشيلي'),
(9967, 1, 3429, 'سويسرا'),
(9966, 1, 3428, 'كندا'),
(9964, 1, 3426, 'بوتسوانا'),
(9965, 1, 3427, 'جمهورية أفريقيا الوسطى'),
(9963, 1, 3425, 'جزيرة بوفيت'),
(9962, 1, 3424, 'بوتان'),
(9961, 1, 3423, 'بروناي دار السلام'),
(9960, 1, 3422, 'باربادوس'),
(9959, 1, 3421, 'البرازيل'),
(9958, 1, 3420, 'بوليفيا'),
(9957, 1, 3419, 'برمودا'),
(9956, 1, 3418, 'بليز'),
(9955, 1, 3417, 'روسيا البيضاء'),
(9954, 1, 3416, 'البوسنه والهرسك'),
(9953, 1, 3415, 'جزر البهاما'),
(9952, 1, 3414, 'البحرين'),
(9951, 1, 3413, 'بلغاريا'),
(9949, 1, 3411, 'بوركينا فاسو'),
(9950, 1, 3412, 'بنغالاديش'),
(9948, 1, 3410, 'بنين'),
(9947, 1, 3409, 'بلجيكا'),
(9946, 1, 3408, 'بوروندي'),
(9945, 1, 3407, 'أذربيجان'),
(9944, 1, 3406, 'النمسا'),
(9943, 1, 3405, 'أستراليا'),
(9941, 1, 3403, 'الأقاليم الجنوبية الفرنسية'),
(9942, 1, 3404, 'انتيغوا وبربودا'),
(9940, 1, 3402, 'أنتاركتيكا'),
(9939, 1, 3401, 'ساموا الأمريكية'),
(9938, 1, 3400, 'أرمينيا'),
(9937, 1, 3399, 'الأرجنتين'),
(9936, 1, 3398, 'الإمارات العربية المتحدة'),
(9935, 1, 3397, 'جزر الأنتيل الهولندية'),
(9934, 1, 3396, 'أندورا'),
(43374, 1, 9401, 'عرض الملفات الشخصية'),
(9933, 1, 3395, 'ألبانيا'),
(9932, 1, 3394, 'أنغيلا'),
(10308, 1, 3770, 'إزعاج/إقتحام'),
(9931, 1, 3393, 'أنغولا'),
(9930, 1, 3392, 'أفغانستان'),
(9929, 1, 3391, 'أروبا'),
(9921, 1, 3383, 'نمط الصيانة تغير'),
(9919, 1, 3381, 'رسالة الصيانة'),
(9920, 1, 3382, 'HTML مسموح'),
(9918, 1, 3380, '<p>هذا سوف يجعل موقعك غير قابل للوصول إليه ويعرض لكل شخص رسالة الصيانة.</p>\r\n<b>سوف تبقى قادراً على الدخول كمدير من هنا: <a href="{$site_url}sign-in">{$site_url}sign-in</a></b>'),
(9917, 1, 3379, 'قم بتعطيل موقعك وضع صفحة الصيانة.'),
(43435, 1, 9462, 'الأساسية'),
(9911, 1, 3373, 'الإعدادات'),
(9912, 1, 3374, '<h1 class="ow_stdmargin ow_ic_gear_wheel">الموقع تحت الصيانة.</h1>\r\nعذراً ، هذا الموقع تحت الصيانة المعدة لذلك . سنعود قريباً.'),
(9910, 1, 3372, 'صفحة الصيانة'),
(9909, 1, 3371, 'صفحة الصيانة'),
(10314, 1, 3776, 'التقرير تم قبوله'),
(9894, 1, 3356, '<p>\r\nعزيزي {$user_name},\r\n</p>\r\n<p>\r\nنحن  سعداء أن نعلمك بأن حسابك في <a href="{$site_url}">{$site_name}</a> تمت الموافقة عليه . والآن يمكنك تسجيل الدخول هنا: <a href="{$site_url}">{$site_url}</a>\r\n</p>\r\n<p>\r\nنأمل أن تستمتع في موقعنا وعلى أكمل وجه.\r\n</p>\r\n<p>\r\nشكراً لك,<br />\r\nالإدارة<br />\r\n<a href="{$site_url}">{$site_name}</a>\r\n</p>'),
(17041, 1, 4661, 'طلب ترقية برمجية'),
(17042, 1, 4662, 'هل أنت متأكد أنك تريد تحديث البرمجية من النسخة <b>{$oldVersion}</b> إلى <b>{$newVersion}</b>؟{$info}'),
(9893, 1, 3355, 'عزيزي {$user_name},\r\n\r\nنحن  سعداء أن نعلمك بأن حسابك في {$site_name} تمت الموافقة عليه . والآن يمكنك تسجيل الدخول هنا: {$site_url}\r\n\r\nنأمل أن تستمتع في موقعنا وعلى أكمل وجه.\r\n\r\nشكراً لك,\r\nالإدارة -\r\n{$site_name}\r\n{$site_url}'),
(9892, 1, 3354, 'تمت الموافقة على حسابك'),
(17097, 1, 4717, 'لا'),
(9889, 1, 3351, 'موافقة'),
(9890, 1, 3352, 'تم التحديث'),
(9846, 1, 3308, 'أدوار المستخدمين'),
(9847, 1, 3309, 'تغيير الدور'),
(9885, 1, 3347, '<center>حسابك بانتظار الموافقة</center>'),
(14299, 1, 4103, '<a href="{$userUrl}">{$userName}</a> قام بالتعليق على ملفك الشخصي : <a href="{$profileUrl}">ملفي الشخصي</a>'),
(14297, 1, 4101, 'إلغاء'),
(14298, 1, 4102, 'شخص ما أضاف تعليقاً على ملفي الشخصي'),
(14296, 1, 4100, 'حسناً'),
(14283, 1, 4087, 'هل أنت متأكد أنك تريد إلغاء تثبيت الملحق البرمجي ؟'),
(14286, 1, 4090, 'رجاءاً سجـّل الدخول'),
(14287, 1, 4091, 'أو'),
(14274, 1, 4078, 'من فضلك أدخل كلمة سر صحيحة (على الأقل 3 رموز)'),
(14324, 1, 4128, 'تأكيد'),
(14327, 1, 4131, 'تحتاج إلى التحقق من عنوان البريد الإلكتروني هذا . لقد أرسلنا رسالة التحقق والتأكيد حال حفظ بياناتك ولكن قد تحتاج إلى إرسالها مرة أخرى.'),
(14325, 1, 4129, 'أرسل بريد التأكيد'),
(14326, 1, 4130, 'البريد الالكتروني مؤكد مسبقاً'),
(14328, 1, 4132, 'تأكيد البريد الالكتروني'),
(14329, 1, 4133, 'مرحباً,\r\n\r\nشخص ما (ربما أنت) قام بتعيين عنوان البريد الإلكتروني هذا على أنه عنوان البريد الإلكتروني الرسمي لموقع {$site_name} ({$site_url}).\r\n\r\nلإتمام هذه العملية فإنك تحتاج إلى التحقق من عنوان البريد الإلكتروني هذا عن طريق فتح الرابط التالي: {$url}\r\n\r\nوبدلاً من ذلك يمكنك فتح هذا الرابط: {$verification_page_url} وإلصاق الكود التالي هناك: {$code}\r\n\r\nإذا كنت لم تحاول القيام بهذا العمل فبكل راحة وأمان قم بتجاهل هذه الرسالة ولن يتم إستخدام بريدك الالكتروني.\r\n\r\nشكراً لك,\r\الإدارة\r\n{$site_name}\r\n{$site_url}'),
(14330, 1, 4134, '<p>\r\nمرحبا,\r\n</p>\r\n<p>\r\nشخص ما (ربما أنت) قام بتعيين عنوان البريد الإلكتروني هذا على أنه عنوان البريد الإلكتروني الرسمي لموقع <a href="{$site_url}">{$site_name}</a>.\r\n</p>\r\n<p>\r\nلإتمام هذه العملية فإنك تحتاج إلى التحقق من عنوان البريد الإلكتروني هذا عن طريق فتح الرابط التالي: <a href="{$url}">{$url}</a>\r\n</p>\r\n<p>\r\nوبدلاً من ذلك يمكنك فتح <a href="{$verification_page_url}">هذا الرابط</a> وإلصاق الكود التالي هناك: <b>{$code}</b>\r\n</p>\r\n<p>\r\nإذا كنت لم تحاول القيام بهذا العمل فبكل راحة وأمان قم بتجاهل هذه الرسالة ولن يتم إستخدام بريدك الالكتروني.\r\n</p>\r\n<p>\r\nشكراً لك,<br />\r\nالإدارة<br />\r\n{$site_name}<br />\r\n{$site_url}\r\n</p>'),
(16978, 1, 4598, 'تم الحذف'),
(16975, 1, 4595, 'خطأ في إلغاء تثبيت الملحق البرمجي'),
(14336, 1, 4140, 'غداً'),
(14341, 1, 4145, 'طلب إلغاء تثبيت ملحق برمجي'),
(14342, 1, 4146, 'هل أنت متأكد أنك تريد إلغاء تثبيت الملحق البرمجي ''{$name}'' ؟'),
(14345, 1, 4149, 'خطأ في مدقق صورة الأمان - كابتشا!'),
(43378, 1, 9405, 'الأسئلة الحصرية'),
(20385, 1, 6080, '12321'),
(20384, 1, 6079, '213'),
(20378, 1, 6073, 'أرسل مهمات - وظائف'),
(19881, 1, 5576, 'في المرة القادمة سوف تتمكن من بدء إرسال البريد الجماعي ليس قبل <b>{$hours}</b> ساعات .'),
(20151, 1, 5846, 'مرحباً {$username}, أدخل كلمتك السرية الجديدة في الأسفل:'),
(20152, 1, 5847, 'تقديم'),
(20153, 1, 5848, 'كلمة السر الجديدة'),
(20154, 1, 5849, 'إعادة كلمة السر'),
(20156, 1, 5851, 'القيم في حقول ''كلمة السر'' و ''إعادة كلمة السر'' يجب أن تكون متساوية ومتطابقة'),
(20157, 1, 5852, 'طول كلمة السر يجب أن يكون بين  {$min} و {$max} رموز'),
(20158, 1, 5853, 'تم تغيير كلمة السر الخاصة بك بنجاح'),
(16243, 1, 4164, 'خطأ في مدقق التاريخ!'),
(16244, 1, 4165, 'القيمة غير صحيحة أو أكبر من حد الخادم.'),
(16245, 1, 4166, 'خطأ في مدقق Int!'),
(16246, 1, 4167, 'خطأ في مدقق الأبجدية الرقمية!'),
(16247, 1, 4168, 'خطأ في مدقق الرابط!'),
(16248, 1, 4169, 'خطأ في مدقق البريد الالكتروني!'),
(16249, 1, 4170, 'خطأ في مدقق RegExp!'),
(16250, 1, 4171, 'خطأ في مدقق String!'),
(16900, 1, 4520, 'تحديثات الملحق البرمجي متوفرة: <b>{$count}</b>. <a href="{$link}">عرض</a>'),
(16898, 1, 4518, 'تسجيل الخروج'),
(16899, 1, 4519, 'تحديث البرمجية متوفر. <a href="{$link}">تحديث </a>'),
(16896, 1, 4516, 'ملفي الشخصي'),
(43396, 1, 9423, 'تقديم'),
(16895, 1, 4515, 'التفضيلات'),
(16897, 1, 4517, 'صندوق البريد'),
(20141, 1, 5836, 'لقد إستلمت مسبقاً كود إعادة التعيين اليوم . من فضلك حاول مرة أخرى خلال 24 ساعة.'),
(20138, 1, 5833, 'لا يوجد أي مستخدم لديه عنوان البريد الإلكتروني هذا'),
(20137, 1, 5832, 'أكتب عنوان البريد الإلكتروني الذي إستخدمته عند التسجيل.'),
(20101, 1, 5796, 'العضوية'),
(19427, 1, 5124, 'عند تحويله إلى تشغيل فالمستخدمون سوف يكون عليهم تأكيد عناوين البريد الالكتروني قبل الدخول إلى الموقع.'),
(19428, 1, 5125, 'إعدادات البريد الالكتروني'),
(19429, 1, 5126, 'تأكيد البريد الالكتروني'),
(20150, 1, 5845, 'لإعادة تعيين - إعداد كلمة السر فإنك تحتاج فقط إلى إدخال عنوان البريد الإلكتروني الخاص بك ، أحصل على رمز إعادة التعيين وإستخدمه لتغيير كلمتك السرية القديمة.'),
(20149, 1, 5844, 'أنشيء كلمة سر جديدة'),
(20146, 1, 5841, 'طلب إعادة تعيين كلمة السر'),
(20147, 1, 5842, 'من فضلك أدخل كود إعادة تعيين صحيح'),
(20148, 1, 5843, 'إعادة تعيين كلمتك السرية'),
(20145, 1, 5840, 'تقديم'),
(20142, 1, 5837, 'نسيت كلمة السر'),
(20143, 1, 5838, 'أدخل كود إعادة التعيين الخاص بك'),
(20144, 1, 5839, 'أكتب كود إعادة التعيين الذي أرسل لك . وبعدئذٍ يمكنك إدخال كلمة سر جديدة.'),
(19242, 1, 4939, 'الملحق البرمجي تم تحديثه بنجاح'),
(19069, 1, 4766, 'ملفي الشخصي'),
(19070, 1, 4767, 'الشؤون المالية'),
(19073, 1, 4770, 'الشؤون المالية'),
(19072, 1, 4769, 'عذراً ، هذا إسم المستخدم مقيـّد'),
(19075, 1, 4772, 'أسماء المستخدمين المقيدة'),
(19076, 1, 4773, 'أسماء المستخدمين المقيدة'),
(19077, 1, 4774, 'أضف إسم مستخدم مقيـّد'),
(19078, 1, 4775, 'إسم المستخدم'),
(19079, 1, 4776, 'أضف'),
(19080, 1, 4777, 'قائمة أسماء المستخدمين المقيدة'),
(19086, 1, 4783, 'إسم المستخدم تمت إضافته بنجاح'),
(19088, 1, 4785, 'كود المصدر للملحق البرمجي ''<i>{$name}</i>'' تم تحديثه . تحتاج إلى تحديث قاعدة بيانات الملحق البرمجي.'),
(19089, 1, 4786, 'تحديث'),
(19096, 1, 4793, 'بوابة الدفع لم يتم العثور عليها أو أنها غير نشطة'),
(19113, 1, 4810, 'المعلومات حول الطلب غير موجودة'),
(19114, 1, 4811, 'فشل في تهيئة الطلب'),
(19135, 1, 4832, 'الملحق البرمجي'),
(19145, 1, 4842, 'الوقت'),
(19146, 1, 4843, 'المبلغ'),
(19157, 1, 4854, 'التفاصيل'),
(19158, 1, 4855, 'بوابة الدفع'),
(19159, 1, 4856, 'معرّف عملية الدفع - الصفقة'),
(19160, 1, 4857, 'الإحصائيات'),
(19171, 1, 4868, 'معدل السنة'),
(19172, 1, 4869, '(معدل السنة)'),
(19173, 1, 4870, 'غير متوفر'),
(19174, 1, 4871, 'تم إلغاء طلبك'),
(19175, 1, 4872, 'حدث خطأ أثناء معالجة طلبك'),
(19176, 1, 4873, 'طلبك إكتمل بنجاح'),
(19177, 1, 4874, 'طلبك تم تأكيده'),
(19178, 1, 4875, 'يتم معالجة طلبك'),
(19209, 1, 4906, 'إدفع بأمان مع {$gateway}'),
(19210, 1, 4907, 'حالة طلبك'),
(20355, 1, 6050, 'عزيزي {$username},\r\n<br />\r\nلقد قمت بطلب إعادة تعيين كلمة السر الخاصة بك. إتبع هذا الرابط ({$resetUrl}) لتغيير كلمتك السرية.\r\n<br />\r\nإذا لم يعمل الرابط ، من فضلك أدخل الكود يدوياً هنا ({$requestUrl}). الكود: {$code}\r\n<br />\r\nإذا لم تقم بطلب إعادة تعيين كلمة السر ، من فضلك تجاهل هذه الرسالة البريدية.\r\n<br /><br />\r\nشكراً لك,\r\n{$site_name}<br />'),
(20353, 1, 6048, 'مالك المحتوى يستطيع حذف التعليقات'),
(20350, 1, 6045, '<b>نحن نوصي بعدم جعل حقل إسم المستخدم قابل للتحرير ، لأن تغيير إسم المستخدم سوف ينتج عنه تغيير في رابط الملف الشخصي.</b>'),
(20356, 1, 6051, 'عزيزي {$username},\r\n\r\nلقد قمت بطلب إعادة تعيين كلمة السر الخاصة بك. إتبع هذا الرابط ({$resetUrl}) لتغيير كلمتك السرية.\r\n\r\nإذا لم يعمل الرابط ، من فضلك أدخل الكود يدوياً هنا ({$requestUrl}). الكود: {$code}\r\n\r\nإذا لم تقم بطلب إعادة تعيين كلمة السر ، من فضلك تجاهل هذه الرسالة البريدية.\r\n\r\nشكراً لك,\r\n{$site_name}'),
(20351, 1, 6046, 'السوق'),
(20352, 1, 6047, 'التعليق على المهمات - الوظائف المرسلة'),
(20325, 1, 6020, 'التثبيت'),
(20326, 1, 6021, 'إستكشاف الأخطاء وإصلاحها');
INSERT INTO `%%TBL-PREFIX%%base_language_value` (`id`, `languageId`, `keyId`, `value`) VALUES
(20327, 1, 6022, 'تطوير الملحق البرمجي'),
(20328, 1, 6023, 'تصميم الستايل'),
(20329, 1, 6024, 'الإستشارات'),
(20703, 1, 6158, 'مالك المحتوى يستطيع حذف التعليقات'),
(20704, 1, 6159, 'عرض المواقع'),
(20700, 1, 6155, 'المواقع'),
(20701, 1, 6156, 'الكتابة على حائط التعليق'),
(20702, 1, 6157, 'أضف وصلة'),
(43269, 1, 9296, 'الإدارة'),
(43268, 1, 9295, 'البحث في المستخدمين'),
(43267, 1, 9294, 'حذف التعليق بواسطة مالك المحتوى'),
(43258, 1, 9285, 'أضف دور جديد'),
(43259, 1, 9286, 'صلاحيات دور المستخدم'),
(43261, 1, 9288, 'الأساسية'),
(43270, 1, 9297, 'تحرير الأنواع'),
(43264, 1, 9291, 'أضف تعليقات'),
(43266, 1, 9293, '{$count} قيمة'),
(43466, 1, 9493, 'تقديم'),
(43348, 1, 9375, 'السؤال'),
(43350, 1, 9377, 'النوع'),
(43354, 1, 9381, 'معلومات الستايل'),
(43355, 1, 9382, 'القيم'),
(43359, 1, 9386, 'هنا يمكنك عرض الصفحات الموجودة وعناصر القوائم . هذه هي صفحاتك المخصصة الخاصة بك والتي تم تفعيلها بواسطة الملحقات البرمجية. <span class="ow_highlight">سحب وإفلات</span> العناصر عبر القوائم لتغيير مواقعها.'),
(43360, 1, 9387, 'القائمة الرئيسية'),
(43361, 1, 9388, 'يتطلب'),
(43362, 1, 9389, 'قائمة الذيل'),
(43363, 1, 9390, 'الصفحات المخفية'),
(43364, 1, 9391, 'سجـّل الآن'),
(43365, 1, 9392, 'هنا الصفحات التي هي موجودة في الواقع ولكن لا تعرض في الموقع. قم <span class="ow_highlight">بسحب وإفلات</span> تلك العناصر التي تريد إخفاءها إلى هنا.'),
(43366, 1, 9393, 'تحرير'),
(43368, 1, 9395, 'عرض'),
(43369, 1, 9396, 'العنصر'),
(43370, 1, 9397, 'مرئي للكل'),
(43371, 1, 9398, 'البحث'),
(43445, 1, 9472, 'نسخة البرمجية <b>{$version}</b> (build {$build})'),
(43442, 1, 9469, 'النشاط'),
(43440, 1, 9467, 'متصل الآن'),
(23349, 1, 6301, 'الفراغات غير مسموحة'),
(23323, 1, 6275, 'أولاً يجب عليك إزالة هذا المستخدم من مشرفي الموقع'),
(51589, 1, 11573, 'لا يمكن فك ضغط الملف المضغوط الذي تم تحميله'),
(25807, 1, 6823, 'الملحق البرمجي تم رفعه وهو جاهز للتثبيت'),
(46497, 1, 9726, '12312'),
(37391, 1, 9251, 'بحث الوسوم'),
(25765, 1, 6781, 'أرسل رسالة خاصة'),
(25764, 1, 6780, 'قراءة الرسائل الواردة'),
(25763, 1, 6779, 'صندوق البريد'),
(25698, 1, 6714, 'سوف تحتاج أن تختار مستخدم(ين) للمتابعة'),
(25680, 1, 6696, 'قام بتحرير تفاصيل ملفه الشخصي'),
(25681, 1, 6697, 'إنضم إلى موقعنا !'),
(36714, 1, 8574, 'أرسل هدية'),
(36713, 1, 8573, 'الهدايا الإفتراضية'),
(25654, 1, 6678, 'الإجمالي: <b>{$count}</b> مستخدم'),
(25653, 1, 6677, 'لسوء الحظ كود إعادة التعيين الخاص بك هو غير صحيح أو منتهي . من فضلك إتبع <a href="{$url}">الرابط</a> وحاول أن تعيد تعيينه مرة أخرى.'),
(25651, 1, 6675, 'كود إعادة تعيين منتهي'),
(25650, 1, 6674, 'تعطيل الجافا سكريبت'),
(25649, 1, 6673, 'تفعيل الجافا سكريبت'),
(25647, 1, 6671, 'قام بتغيير صورته الرمزية'),
(37169, 1, 9029, 'تغذية الأخبار'),
(37170, 1, 9030, 'السماح بالتعليقات'),
(46498, 1, 9727, '123123'),
(46499, 1, 9728, '12312312'),
(36804, 1, 8664, 'أرصدة المستخدم'),
(46463, 1, 9694, 'عرض وإعداد إلى مطلوب'),
(36056, 1, 7916, 'أضف حدثاً'),
(36057, 1, 7917, 'عرض الحدث'),
(36058, 1, 7918, 'التعليق على الأحداث'),
(46458, 1, 9689, 'الإعدادات لم تتغير'),
(46457, 1, 9688, 'الإعدادات تغيرت'),
(46456, 1, 9687, 'عام'),
(25547, 1, 6571, 'ممنــوع'),
(25546, 1, 6570, 'الصفحة غير موجودة'),
(25545, 1, 6569, 'ليس لديك صلاحيات لدخول الصفحة.'),
(25544, 1, 6568, 'ممنــوع'),
(37128, 1, 8988, 'عرض الموضوع'),
(37129, 1, 8989, 'إنشاء/تحرير موضوع'),
(35552, 1, 7429, 'لا يوجد مستخدمون'),
(25492, 1, 6516, '{$username} <span class="ow_small">{$status}</span>'),
(46452, 1, 9683, 'تفضيلاتي'),
(37133, 1, 8993, 'الملصق على الصورة الرمزية'),
(37134, 1, 8994, 'نعم'),
(37135, 1, 8995, 'لا'),
(37136, 1, 8996, 'عرض ملصق الدور على الصورة الرمزية'),
(37127, 1, 8987, 'المنتدى'),
(25474, 1, 6498, 'تقديم'),
(25473, 1, 6497, '#count# مستخدمين تم تحديدهم'),
(37137, 1, 8997, 'لون الملصق'),
(37139, 1, 8999, 'تم تحديث الدور'),
(25465, 1, 6489, 'لا يوجد مستخدمون'),
(25463, 1, 6487, 'الصورة الرمزية الإفتراضية تم حذفها'),
(25453, 1, 6477, 'تغيير'),
(25454, 1, 6478, 'إلغاء'),
(30740, 1, 7218, 'لا يمكن تثبيت ملحق برمجي بمفتاح فارغ'),
(25462, 1, 6486, 'هل أنت متأكداً أنك تريد حذف صورة الصورة الرمزية الإفتراضية؟'),
(25449, 1, 6473, 'قم بالتغيير لتجاوز صورة الصورة الرمزية الإفتراضية للستايل'),
(51593, 1, 11577, 'إلى أي رابط يجب أن تتوجه هذه الوصلة :'),
(58755, 1, 15472, 'العودة إلى نموذج البحث'),
(58754, 1, 15471, 'إسحب البيانات من خدمات أخرى '),
(58753, 1, 15470, 'لا يمكن إستخراج سجل الستايل'),
(58735, 1, 15452, ''),
(58736, 1, 15453, ''),
(58737, 1, 15454, ''),
(58738, 1, 15455, ''),
(58739, 1, 15456, ''),
(58740, 1, 15457, ''),
(58741, 1, 15458, ''),
(58742, 1, 15459, ''),
(58743, 1, 15460, ''),
(58744, 1, 15461, ''),
(58745, 1, 15462, ''),
(58746, 1, 15463, ''),
(58747, 1, 15464, 'من فضلك إرفع ملف سجل ستايل صحيح '),
(58748, 1, 15465, 'أضف ستايل'),
(58749, 1, 15466, 'أضف ستايل جديد'),
(58750, 1, 15467, 'أضف ستايل جديد'),
(58751, 1, 15468, 'تم إضافة الستايل بنجاح '),
(58752, 1, 15469, 'لا يمكن رفع الستايل , مجلد الستايل  `{$dir}` موجود مسبقاً'),
(25382, 1, 6406, 'المستخدمون'),
(37130, 1, 8990, 'إشترك بمواضيع المنتدى'),
(25354, 1, 6378, 'عرض الكل ({$count})'),
(25353, 1, 6377, 'تم تحرير CSS المخصصة'),
(25352, 1, 6376, 'معطيات FTP غير صحيحة ! المستخدم الذي تم طرحه لا يمتلك التصاريح للكتابة على الملفات .'),
(25342, 1, 6366, 'صورة الصورة الرمزية الإفتراضية'),
(25239, 1, 6306, 'إجعل البريد الالكتروني مؤكداً'),
(25241, 1, 6308, 'عناوين بريد المستخدمين المحددة تم تأكيدها والتحقق منها'),
(27933, 1, 6890, 'ليس لديك ملحقات برمجية متوفرة هنا.'),
(47077, 1, 10306, 'صفحة مخصصة'),
(37349, 1, 9209, 'الإجمالي:</span> (<span class="ow_outline">{$ratesCount}</span> تقييم)'),
(37348, 1, 9208, 'تقييمك:'),
(37313, 1, 9173, 'الدخول اليومي'),
(37314, 1, 9174, 'إشتراك المستخدم'),
(37315, 1, 9175, 'البحث في المستخدمين'),
(37316, 1, 9176, 'الكتابة على حائط التعليق'),
(46496, 1, 9725, '112'),
(46464, 1, 9695, 'إخفاء'),
(37273, 1, 9133, 'أدوار المستخدمين'),
(46455, 1, 9686, 'حفظ'),
(37269, 1, 9129, 'الإجراءات'),
(37246, 1, 9106, 'أطلب الآن'),
(43390, 1, 9417, 'من فضلك أدخل وسماً'),
(43375, 1, 9402, 'الدلالات'),
(43376, 1, 9403, 'أو'),
(43377, 1, 9404, 'نوع الحساب'),
(51312, 1, 11296, 'من فضلك أدخل رسالة التعليق'),
(51328, 1, 11312, 'الأساسي'),
(51327, 1, 11311, 'إعدادات سؤال الملف الشخصي'),
(51326, 1, 11310, 'عرض كل الأسئلة'),
(30826, 1, 7304, 'اللغة/حزمة اللغة تم إستيرادها'),
(30824, 1, 7302, 'حزمة لغة فارغة أو غير صحيحة . الرجاء إختيار واحدة صحيحة وحاول مرة أخرى.'),
(30741, 1, 7219, 'أخطاء حدثت أثناء تثبيت الملحق البرمجي "{$plugin}". من فضلك قم بإلغاء تثبيته وحاول مرة أخرى.'),
(51595, 1, 11579, 'لا يوجد أيقونة مفضلة . قم بتحديده لتفعيلها .'),
(35651, 1, 7528, 'تاريخ الإشتراك'),
(35652, 1, 7529, ''),
(35968, 1, 7828, 'سكريبت كرون الخاص بـ Oxwall  غير نشط  . الرجاء إضافته إلى قائمة وظائف كرون ({$path}).'),
(51590, 1, 11574, 'النص المراد عرضه:'),
(36055, 1, 7915, 'الأحداث'),
(47061, 1, 10290, 'مرحباً بك في {$site_name}! شكراً على إنضمامك إلينا. هنا بعض الروابط السريعة التي تحتاجها إلى بدء طريقك:\r\n- الصفحة الرئيسية: {$site_url}\r\n- تغيير الصورة الرمزية: {$site_url}profile/avatar\r\n- تغيير تفاصيل الصورة الرمزية: {$site_url}profile/edit\r\n- معاينة/إعادة ترتيب ملفي الشخصي: {$site_url}my-profile\r\n- أنظر من يتواجد في الموقع: {$site_url}users\r\nلا تتردد في المشاركة في موقعنا الإجتماعي!\r\n{$site_name} - الإدارة\r\n{$site_url}'),
(47059, 1, 10288, 'إدراج HTML'),
(47060, 1, 10289, 'التسجيل في {$site_name}'),
(47024, 1, 10253, 'عرض المزيد'),
(47037, 1, 10266, 'نص سميك'),
(47038, 1, 10267, 'نص مائل'),
(47039, 1, 10268, 'نص تحته خط'),
(47040, 1, 10269, 'إدراج قائمة مرتبة'),
(47041, 1, 10270, 'إدراج قائمة غير مرتبة'),
(47042, 1, 10271, 'إدراج موقع'),
(47043, 1, 10272, 'إدراج صورة'),
(47044, 1, 10273, 'إدراج فيديو'),
(47045, 1, 10274, 'إدراج HTML'),
(47046, 1, 10275, 'إظهار/إخفاء عرض مصدر HTML'),
(47053, 1, 10282, 'أضف'),
(47054, 1, 10283, 'إدراج'),
(47055, 1, 10284, 'الرجاء تعبئة حقول `الملصق` و `الرابط` لإدراج الموقع'),
(47056, 1, 10285, 'إدراج فيديو'),
(47058, 1, 10287, 'أدخل كود الفيديو من فضلك'),
(54914, 1, 11631, 'لا يمكن رفع الملف المضغوط بواسطة برنامج FTP'),
(47536, 1, 10742, 'تجربة'),

(47537, 1, 10743, 'mmm'),
(47535, 1, 10741, 'صفحة مخصصة'),
(47534, 1, 10740, 'صفحة مخصصة'),
(47530, 1, 10736, ''),
(47531, 1, 10737, 'صفحة مخصصة'),
(47532, 1, 10738, 'تجربة تثبيت على XAMP'),
(47533, 1, 10739, 'mmm'),
(47528, 1, 10734, 'صفحة مخصصة'),
(47529, 1, 10735, ''),
(47524, 1, 10730, 'تجربة'),
(47525, 1, 10731, 'صفحة مخصصة'),
(47526, 1, 10732, ''),
(47527, 1, 10733, 'mmm'),
(47523, 1, 10729, 'تجربة'),
(47522, 1, 10728, ''),
(47521, 1, 10727, 'dsfsdfs\r\nsdfsfsdfsd\r\nsdfsdfsdf'),
(47520, 1, 10726, 'إجعل ''رفع الصورة'' حقلاً مطلوباً في صفحة الإشتراك.'),
(47517, 1, 6886, ''),
(47518, 1, 6887, ''),
(47519, 1, 10725, 'إجعل ''رفع الصورة'' حقلاً مطلوباً'),
(47516, 1, 6885, ''),
(47514, 1, 6883, ''),
(47515, 1, 6884, ''),
(47513, 1, 6882, ''),
(47512, 1, 6881, ''),
(47507, 1, 6875, ''),
(47508, 1, 6877, ''),
(47509, 1, 6878, ''),
(47510, 1, 6879, ''),
(47511, 1, 6880, ''),
(47501, 1, 6869, ''),
(47502, 1, 10723, ''),
(47503, 1, 10724, ''),
(47504, 1, 6872, ''),
(47505, 1, 6873, ''),
(47506, 1, 6874, ''),
(58730, 1, 15447, ''),
(47491, 1, 10719, ''),
(47492, 1, 6876, ''),
(47493, 1, 6241, ''),
(47494, 1, 6242, ''),
(47495, 1, 6861, 'ساعة'),
(47496, 1, 6862, 'دقيقة'),
(47497, 1, 6865, ''),
(47498, 1, 10720, ''),
(47499, 1, 10721, ''),
(47500, 1, 10722, ''),
(58732, 1, 15449, ''),
(58727, 1, 15444, ''),
(58728, 1, 15445, ''),
(58729, 1, 15446, ''),
(58731, 1, 15448, ''),
(58733, 1, 15450, ''),
(58734, 1, 15451, ''),
(58721, 1, 15438, ''),
(58722, 1, 15439, ''),
(58723, 1, 15440, ''),
(58724, 1, 15441, ''),
(58725, 1, 15442, ''),
(58726, 1, 15443, ''),
(47464, 1, 10692, 'المجموعات'),
(47463, 1, 10691, 'المؤلف (الكاتب) يستطيع حذف تعليقات الحائط'),
(47462, 1, 10690, 'إنشاء مجموعات'),
(47461, 1, 10689, 'إنشاء/تحرير موضوع'),
(47459, 1, 2238, ''),
(47460, 1, 10688, 'أكتب تعليق حائط'),
(47449, 1, 10678, 'jjj'),
(47450, 1, 10679, '<meta>وسم مخصص</meta>'),
(47451, 1, 10680, 'jjj'),
(47458, 1, 10687, 'عزيزي {$username},\r\n\r\nلقد طلبت إعادة تعيين كلمة السر الخاصة بك . ها هي كلمتك السرية الجديدة : {$password}\r\n\r\nلا تتردد في الدخول إلى حسابك في {$site_url} وقم بتغيير كلمة السر الخاصة بك مرة أخرى إذا لزم الأمر.\r\n\r\nشكراً لك,\r\n{$site_name}'),
(47447, 1, 10676, 'الرجاء تزويد صورة صحيحة بتنسيق ico'),
(47456, 1, 10685, 'إعدادات المستخدم'),
(47440, 1, 10669, 'حدد إذا كنت لا تريد السماح للمستخدمين بإضافة الوسائط الغنية (مثل الصور والفيديو) في التعليقات عبر الموقع.'),
(47457, 1, 10686, 'عزيزي {$username},<br />\r\n<br />\r\nلقد طلبت إعادة تعيين كلمة السر الخاصة بك . ها هي كلمتك السرية الجديدة : <b>{$password}</b><br />\r\n<br />\r\nلا تتردد في الدخول إلى حسابك في <a href="{$site_url}">{$site_url}</a> وقم بتغيير كلمة السر الخاصة بك مرة أخرى إذا لزم الأمر.<br />\r\n<br />\r\nشكراً لك,<br />\r\n{$site_name}'),
(47397, 1, 10626, 'عرض تواجدي في الموقع'),
(47435, 1, 10664, 'تعطيل HTML المخصص'),
(47394, 1, 10623, 'ضع في قائمة النطاقات التي منها تسمح بتضمين ملفات الفيديو . هذه يجب أن تكون مواقع فيديو والتي تزود الكود المضمن لملفات الفيديو . نطاق واحد لكل سطر.'),
(47436, 1, 10665, 'حدد إذا كنت لا تريد السماح للمستخدمين بكتابة أكواد HTML في المشاركات (مثل المدونات والمنتديات). يوصى به لأسباب أمنية.'),
(47437, 1, 10666, 'تعطيل الوسائط الغنية'),
(47438, 1, 10667, 'حدد إذا كنت لا تريد السماح للمستخدمين بإضافة الوسائط الغنية (مثل الصور والفيديو) في المشاركات (مثل المدونات والمنتديات).'),
(47390, 1, 10619, 'إدخال المحتوى'),
(47389, 1, 10618, 'عام'),
(47385, 1, 10614, 'تعليقات حائط الملف الشخصي'),
(47384, 1, 10613, 'قم بتضمين كود الفيديو خاصتك هنا:'),
(47383, 1, 10612, 'كود html خاصتك:'),
(47382, 1, 10611, 'إعدادات إدخال المستخدم'),
(47381, 1, 10610, 'السماح بقائمة مصادر الفيديو'),
(47379, 1, 10608, 'السماح برفع الصور'),
(47380, 1, 10609, 'الحد الأقصى لحجم رفع الملف'),
(47378, 1, 10607, 'إعدادات الوسائط الغنية'),
(47376, 1, 10605, 'تعليقات المحتوى'),
(47439, 1, 10668, 'تعطيل الوسائط الغنية'),
(47373, 1, 10602, 'محتوى نصي'),
(47372, 1, 10601, 'إعدادات إدخال المستخدم'),
(47352, 1, 10581, 'تحرير ملف المستخدم الشخصي'),
(47351, 1, 10580, 'تسجيل عضو جديد'),
(47349, 1, 10578, 'المزيد'),
(47079, 1, 10308, 'صفحة مخصصة'),
(47062, 1, 10291, 'مرحباً بك في <a href="{$site_url}">{$site_name}</a>! شكراً على إنضمامك إلينا. هنا بعض الروابط السريعة التي تحتاجها إلى بدء طريقك:<br/>\r\n- <a href="{$site_url}">الصفحة الرئيسية</a><br/>\r\n- <a href="{$site_url}profile/avatar">تغيير الصورة الرمزية</a><br/>\r\n- <a href="{$site_url}profile/edit">تغيير تفاصيل الصورة الرمزية</a><br/>\r\n- <a href="{$site_url}my-profile">معاينة/إعادة ترتيب ملفي الشخصي</a><br/>\r\n- <a href="{$site_url}users">أنظر من يتواجد في الموقع</a><br/>\r\nلا تتردد في المشاركة في موقعنا الإجتماعي!<br/>\r\n<a href="{$site_url}">{$site_name}</a> - الإدارة<br/>'),
(46655, 1, 9884, 'أيقونة الموقع بصيغة  .ico (16x16px)'),
(46654, 1, 9883, 'أيقونة المفضلة'),
(46652, 1, 9881, 'كود الذيل المخصص'),
(46653, 1, 9882, 'الكود يضاف إلى وثيقة HTML بالضبط قبل إغلاق وسم  &lt;/BODY&gt;  (Javascript مخصص).'),
(46651, 1, 9880, 'الكود يضاف إلى منطقة رأسية وثيقة الـ HTML (Javascript/CSS مخصصة أو معلومات META.'),
(46649, 1, 9878, 'الإعدادات حفظت'),
(46650, 1, 9879, 'كود الرأسية المخصص'),
(46648, 1, 9877, 'حدث خطأ أثناء حفظ البيانات، يرجى المحاولة مرة أخرى'),
(46646, 1, 9875, 'إعدادات الصفحة العامة'),
(46645, 1, 9874, 'إعدادات الصفحة'),
(46643, 1, 9872, 'إعدادات المستخدم'),
(46642, 1, 9871, 'خطأ في تحميل تحديث البرمجية'),
(46641, 1, 9870, 'عرض ملفي الشخصي'),
(46679, 1, 9908, 'القيم'),
(46680, 1, 9909, 'تحرير اللغة'),
(46681, 1, 9910, 'RTL'),
(46682, 1, 9911, 'حدد هذا إذا كنت تحتاج إتجاه النص من "اليسار إلى اليمين"'),
(46683, 1, 9912, 'تم تحرير اللغة , الرجاء الإنتظار ...'),
(46684, 1, 9913, 'تحرير اللغة فشل , من فضلك حاول مرة أخرى'),
(46336, 1, 9567, 'إستخدام التوقيت العسكري'),
(46337, 1, 9568, 'الأدوار'),
(46461, 1, 9692, 'إلغاء التحديد لهذا لإيقاف إستلام البريد الجماعي'),
(46309, 1, 9540, 'أنا موافق على <a target=''blank'' href=''{$site_url}terms-of-use'' >شروط الإستخدام</a>'),
(46312, 1, 9543, 'شروط الإستخدام'),
(46310, 1, 9541, 'شروط الإستخدام'),
(46308, 1, 9539, 'شروط الإستخدام'),
(46311, 1, 9542, 'شروط الإستخدام'),
(46303, 1, 9534, 'دع المستخدمين يرفعون الصورة الرمزية أثناء عملية التسجيل'),
(46301, 1, 9532, 'يتطلب موافقة المستخدمين على شروط الإستخدام أثناء عملية التسجيل'),
(46300, 1, 9531, 'التسجيل'),
(46299, 1, 9530, 'تمكين صندوق إختيار ''شروط الإستخدام'''),
(46313, 1, 9544, 'شروط الإستخدام'),
(46297, 1, 9528, 'رفع الصورة الرمزية'),
(46291, 1, 9522, 'إستنساخ اللغة'),
(46275, 1, 9506, 'werwrw'),
(46276, 1, 9507, 'wer'),
(46277, 1, 9508, 'wr'),
(46278, 1, 9509, 'wer'),
(46279, 1, 9510, 'ew'),
(46280, 1, 9511, 'r'),
(46281, 1, 9512, 'w'),
(46263, 1, 9494, 'المستخدمون'),
(46264, 1, 9495, 'العدد الإجمالي'),
(50855, 1, 10839, 'sdfsdfsdfsdf1333'),
(54917, 1, 11634, 'تجربة'),
(54918, 1, 11635, '(حد الخادم {$value} م . ب)'),
(51594, 1, 11578, 'فتح في نافذة جديدة'),
(51334, 1, 11318, '<span class="ow_highlight">سحب وإفلات</span> العناصر إلى الصفحة لإضافة مزايا أو مكونات مخصصة .\r\n            هذه هي العناصر المفعلة بواسطة <a href="{$pluginsUrl}">الإضافات البرمجية</a> . إذا كنت تريد من عنصر أن يبقى في كل الصفحات فضعه في الشريط الجانبي .'),
(51333, 1, 11317, 'رؤية العناصر:\r\n            <span class="ow_mild_green ow_small" style="border: 1px solid rgb(204, 204, 204); padding: 1px 3px;">الأعضاء فقط</span>\r\n            <span class="ow_mild_red ow_small" style="border: 1px solid rgb(204, 204, 204); padding: 1px 3px;">الضيوف فقط</span>\r\n            <span class="ow_box ow_small" style="border: 1px solid rgb(204, 204, 204); padding: 1px 3px;">الكل</span>'),
(51329, 1, 11313, 'CSS الستايل'),
(51330, 1, 11314, 'عرض كل الصفحات/القوائم'),
(50963, 1, 10947, 'sf'),
(50962, 1, 10946, 'fa'),
(50960, 1, 10944, 'asf'),
(50961, 1, 10945, 'as'),
(50958, 1, 10942, 'asf'),
(50959, 1, 10943, 'as'),
(50955, 1, 10939, 'safdas'),
(50950, 1, 10934, 'فشل رفع الملف !'),
(50957, 1, 10941, 'asfasf'),
(50956, 1, 10940, 'asfas'),
(50949, 1, 10933, 'إمتداد PHP أوقف رفع الملف . PHP لا يوفر وسيلة للتأكد أي إمتداد هو الذي تسبب في وقف رفع الملف.'),
(50948, 1, 10932, 'فشل في كتابة الملف إلى القرص'),
(50945, 1, 10929, 'الملف المرفوع تم رفعه جزئياً فقط.'),
(50946, 1, 10930, 'لم يتم تحميل أي ملف .'),
(50947, 1, 10931, 'مجلد مؤقت مفقود .'),
(50943, 1, 10927, 'المرفقات'),
(50944, 1, 10928, 'الملف المرفوع تجاوز الحجم الأقصى لرفع الملف.'),
(50942, 1, 10926, 'إضافة فيديو'),
(50941, 1, 10925, 'إرفاق صورة'),
(50939, 1, 10923, 'أضف'),
(50940, 1, 10924, 'إرفاق فيديو'),
(50851, 1, 10835, 'العثور على: <b>{$count}</b> مستخدم'),
(50852, 1, 10836, 'البحث بواسطة'),
(58644, 1, 15361, 'أدوار المستخدمين'),
(58645, 1, 15362, 'القيمة غير صحيحة أو أكبر من حد الخادم.'),
(58646, 1, 15363, 'عناوين بريد المستخدمين الالكترونية تم تحديدها بغير مؤكدة '),
(58647, 1, 15364, 'نقل المواضيع إلى الأقسام المخفية '),
(58648, 1, 15365, 'ذهبي'),
(58649, 1, 15366, 'مدير'),
(58650, 1, 15367, 'فضي'),
(58651, 1, 15368, 'منتجات بوابة الفواتير ملزم'),
(58652, 1, 15369, 'المنتج'),
(58653, 1, 15370, 'معرف منتج بوابة '),
(58654, 1, 15371, 'تأكيد المنع'),
(58655, 1, 15372, 'إلغاء'),
(58656, 1, 15373, 'تأكيد'),
(58657, 1, 15374, 'ppp'),
(58658, 1, 15375, 'base+local_page_content_page_61525903'),
(58659, 1, 15376, 'ppp'),
(58660, 1, 15377, 'base+local_page_meta_tags_page_61525903'),
(58661, 1, 15378, 'ppp'),
(58662, 1, 15379, 'base+local_page_title_page_61525903'),
(58663, 1, 15380, 'إتبع هذه <a href="{$url}">الوصلة</a> لتعطيل نمط الصيانة'),
(58664, 1, 15381, 'تعيين البريد الالكتروني كغير مؤكد'),
(58665, 1, 15382, 'من فضلك قم بتأكيد أنك لا تريد إستلام نشرات بريدية من هذا الموقع .'),
(58666, 1, 15383, 'ppp'),
(58667, 1, 15384, ''),
(58668, 1, 15385, 'تجربة11'),
(58669, 1, 15386, 'تجربة1'),
(58670, 1, 15387, 'تجربة تجربة تجربة'),
(58671, 1, 15388, 'تجربة'),
(58672, 1, 15389, 'تجربة'),
(58673, 1, 15390, 'تجربة1'),
(58674, 1, 15391, 'تجربة1'),
(58675, 1, 15392, 'eee'),
(58676, 1, 15393, 'eee'),
(58677, 1, 15394, 'aaaa'),
(58678, 1, 15395, 'd'),
(58679, 1, 15396, 'ddd'),
(58680, 1, 15397, 'aaa'),
(58681, 1, 15398, 'd'),
(58682, 1, 15399, 'aaa2'),
(58683, 1, 15400, 'c'),
(58684, 1, 15401, 'a'),
(58685, 1, 15402, 'sss'),
(58686, 1, 15403, 'd'),
(58687, 1, 15404, '33'),
(58688, 1, 15405, 'd'),
(58689, 1, 15406, 's'),
(58690, 1, 15407, 'a'),
(58691, 1, 15408, '44'),
(58692, 1, 15409, 'd'),
(58693, 1, 15410, ''),
(58694, 1, 15411, 'أستطيع مساعدة الآخرين بـ'),
(58695, 1, 15412, ''),
(58696, 1, 15413, '1'),
(58697, 1, 15414, 'تجربة2'),
(58698, 1, 15415, 'تجربة2'),
(58699, 1, 15416, 'منع'),
(58700, 1, 15417, 'هل أنت متأكد أنك تريد منع هذا المستخدم ؟ <br /><br /> هذا سوف يلغي ويمنع كل التواصل والتفاعل معك .'),
(58701, 1, 15418, 'عذراً , هذا المستخدم إختار أن لا يتواصل معك '),
(58702, 1, 15419, 'الملف الشخصي تم منعه '),
(58703, 1, 15420, 'الملف الشخصي تم إلغاء منعه'),
(58704, 1, 15421, 'إلغاء المنع'),
(58756, 1, 15473, 'سجل /لحق برمجي غير صحيح '),
(58757, 1, 15474, 'حجم سجل الملحق البرمجي أكبر من المسموح به '),
(58758, 1, 15475, 'لا يمكن تحديث الملحق البرمجي'),
(58759, 1, 15476, 'الملحق البرمجي يحمل آخر تحديث'),
(58760, 1, 15477, 'سجل ملحق برمجي غير صحيح'),
(58761, 1, 15478, 'سجل حزمة تحديث فارغ أو غير صحيح'),
(58762, 1, 15479, 'الملحق البرمجي غير موجود'),
(58763, 1, 15480, 'كود إعادة التعيين مرسل مسبقاً . من فضلك حاول مرة أخرى خلال 10 دقائق .'),
(58764, 1, 15481, 'Selected user(s) were approved'),
(58765, 1, 15482, 'Selected user(s) were disapproved'),
(58766, 1, 15483, 'The max reasonable avatar size is {$max}px'),
(58767, 1, 15484, 'Avatar image<br /> crop size'),
(58768, 1, 15485, 'The max reasonable big avatar size is {$max}px'),
(58769, 1, 15486, 'Big avatar image<br /> crop size'),
(58770, 1, 15487, 'Oxwall can''t connect to update server. Seems you need to enable `url_fopen` in your php settings.'),
(58771, 1, 15488, 'Change Image'),
(58772, 1, 15489, 'Choose image'),
(58773, 1, 15490, 'Approve'),
(58774, 1, 15491, 'Disapprove'),
(58775, 1, 15492, 'commented on {$user}''s new avatar'),
(58776, 1, 15493, 'liked {$user}''s new avatar'),
(58777, 1, 15494, 'commented on {$user}''s joining our site'),
(58778, 1, 15495, 'liked that {$user} joined our site'),
(58779, 1, 15496, 'Avatars folder is missing or not writable.'),
(58780, 1, 15497, 'The file extention is not allowed.');

CREATE TABLE `%%TBL-PREFIX%%base_log` (
  `id` int(11) NOT NULL auto_increment,
  `message` text NOT NULL,
  `type` varchar(100) NOT NULL,
  `key` varchar(100) default NULL,
  `timeStamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_login_cookie` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) default NULL,
  `cookie` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `userId` (`userId`),
  KEY `cookie` (`cookie`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_mail` (
  `id` int(11) NOT NULL auto_increment,
  `recipientEmail` varchar(100) NOT NULL,
  `senderEmail` varchar(100) NOT NULL,
  `senderName` varchar(100) NOT NULL,
  `subject` text NOT NULL,
  `textContent` text NOT NULL,
  `htmlContent` text,
  `sentTime` int(11) NOT NULL,
  `priority` int(11) NOT NULL default '1',
  `senderSuffix` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_mass_mailing_ignore_user` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_media_panel_file` (
  `id` int(11) NOT NULL auto_increment,
  `plugin` varchar(20) NOT NULL,
  `type` varchar(20) NOT NULL,
  `userId` int(11) NOT NULL,
  `data` text NOT NULL,
  `stamp` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_menu_item` (
  `id` int(11) NOT NULL auto_increment,
  `prefix` varchar(110) NOT NULL default '',
  `key` varchar(150) NOT NULL default '',
  `documentKey` varchar(255) NOT NULL default '',
  `type` varchar(70) NOT NULL default '',
  `order` int(11) default NULL,
  `routePath` varchar(255) default NULL,
  `externalUrl` varchar(255) default NULL,
  `newWindow` tinyint(1) default '0',
  `visibleFor` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `key` (`key`,`prefix`),
  KEY `documentKey` (`documentKey`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_menu_item` (`id`, `prefix`, `key`, `documentKey`, `type`, `order`, `routePath`, `externalUrl`, `newWindow`, `visibleFor`) VALUES
(23, 'base', 'main_menu_index', '', 'main', 2, 'base_index', NULL, 0, 3),
(4, 'base', 'openwack', '', 'bottom', 4, NULL, 'http://www.oxwall.org/', 1, 3),
(5, 'base', 'alljordan', '', 'bottom', 2, NULL, 'http://www.alljordan.net/', 1, 3),
(6, 'base', 'alljordan_forum', '', 'bottom', 3, NULL, 'http://alljordan.net/forum/', 1, 3),
(24, 'base', 'main_menu_my_profile', '', 'hidden', 1, 'base_member_profile', NULL, 0, 2),
(100, 'admin', 'sidebar_menu_item_user_dashboard', '', 'admin_pages', 2, 'admin_pages_user_dashboard', NULL, NULL, 3),
(41, 'base', 'users_main_menu_item', '', 'main', 4, 'users', NULL, NULL, 3),
(298, 'admin', 'sidebar_menu_item_permission', '', 'admin_privacy', 1, 'admin_permissions', NULL, 0, 2),
(170, 'admin', 'sidebar_menu_item_plugin_mass_mailing', '', 'admin_users', 4, 'admin_massmailing', NULL, NULL, 3),
(101, 'admin', 'sidebar_menu_item_user_profile', '', 'admin_pages', 3, 'admin_pages_user_profile', NULL, NULL, 3),
(97, 'admin', 'sidebar_menu_dashboard', '', 'admin', 1, 'admin_default', NULL, NULL, 3),
(58, 'admin', 'sidebar_menu_item_theme_edit', '', 'admin_appearance', 0, 'admin_themes_edit', NULL, NULL, 3),
(73, 'admin', 'sidebar_menu_item_theme_choose', '', 'admin_appearance', 1, 'admin_themes_choose', NULL, NULL, 3),
(74, 'admin', 'sidebar_menu_item_pages_manage', '', 'admin_pages', 1, 'admin_pages_main', NULL, NULL, 3),
(96, 'admin', 'sidebar_menu_item_settings_language', '', 'admin_settings', 3, 'admin_settings_language', NULL, NULL, 3),
(107, 'admin', 'sidebar_menu_item_users', '', 'admin_users', 1, 'admin_users_browse', NULL, NULL, 3),
(109, 'admin', 'sidebar_menu_item_main_settings', '', 'admin_settings', 1, 'admin_settings_main', NULL, NULL, 3),
(115, 'admin', 'sidebar_menu_item_questions', '', 'admin_users', 3, 'questions_index', NULL, 0, 3),
(120, 'admin', 'sidebar_menu_item_dev_langs', '', 'admin_dev', 1, 'admin_developer_tools_language', NULL, NULL, 3),
(211, 'base', 'base_join_menu_item', '', 'main', 3, 'base_join', NULL, NULL, 1),
(308, 'admin', 'sidebar_menu_plugins_add', '', 'admin_plugins', 3, 'admin_plugins_add', NULL, 0, 2),
(268, 'admin', 'sidebar_menu_item_maintenance', '', 'admin_pages', 7, 'admin_pages_maintenance', NULL, 0, 2),
(246, 'admin', 'sidebar_menu_item_splash_screen', '', 'admin_pages', 5, 'admin_pages_splash_screen', NULL, NULL, 2),
(307, 'admin', 'sidebar_menu_plugins_available', '', 'admin_plugins', 2, 'admin_plugins_available', NULL, NULL, 2),
(299, 'admin', 'sidebar_menu_item_permission_role', '', 'admin_privacy', 2, 'admin_permissions_roles', NULL, 0, 2),
(300, 'admin', 'sidebar_menu_item_permission_moders', '', 'admin_privacy', 3, 'admin_permissions_moderators', NULL, 0, 2),
(304, 'base', 'dashboard', '', 'main', 1, 'base_member_dashboard', NULL, NULL, 2),
(306, 'admin', 'sidebar_menu_plugins_installed', '', 'admin_plugins', 1, 'admin_plugins_installed', NULL, NULL, 2),
(340, 'admin', 'sidebar_menu_item_dashboard_finance', '', 'admin', 2, 'admin_finance', NULL, 0, 3),
(341, 'admin', 'sidebar_menu_item_restricted_usernames', '', 'admin_users', 5, 'admin_restrictedusernames', NULL, 0, 3),
(415, 'admin', 'sidebar_menu_item_user_settings', '', 'admin_settings', 2, 'admin_settings_user', NULL, 0, 3),
(405, 'admin', 'sidebar_menu_item_users_roles', '', 'admin_users', 2, 'admin_user_roles', NULL, 0, 3),
(411, 'base', 'page-119658', 'page-119658', 'bottom', 1, NULL, NULL, NULL, 3),
(467, 'admin', 'sidebar_menu_themes_add', '', 'admin_appearance', 3, 'admin_themes_add_new', NULL, 0, 3);

CREATE TABLE `%%TBL-PREFIX%%base_place` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(20) NOT NULL,
  `editableByUser` tinyint(1) default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_place` (`id`, `name`, `editableByUser`) VALUES
(1, 'dashboard', 1),
(2, 'index', 0),
(3, 'profile', 1);

CREATE TABLE `%%TBL-PREFIX%%base_place_entity_scheme` (
  `id` int(11) NOT NULL auto_increment,
  `placeId` int(11) default NULL,
  `schemeId` int(11) default NULL,
  `entityId` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `userId` (`entityId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_place_scheme` (
  `id` int(11) NOT NULL auto_increment,
  `placeId` int(11) default NULL,
  `schemeId` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_place_scheme` (`id`, `placeId`, `schemeId`) VALUES
(1, 1, 5),
(2, 2, 2),
(3, 3, 1),
(4, 4, 1);

CREATE TABLE `%%TBL-PREFIX%%base_plugin` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `module` varchar(255) NOT NULL,
  `key` varchar(255) NOT NULL,
  `developerKey` varchar(255) default NULL,
  `isSystem` tinyint(1) NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  `adminSettingsRoute` varchar(255) default NULL,
  `uninstallRoute` varchar(255) default NULL,
  `build` int(11) NOT NULL default '0',
  `update` tinyint(1) NOT NULL default '0',
  `licenseKey` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `key` (`key`),
  UNIQUE KEY `module` (`module`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_plugin` (`id`, `title`, `description`, `module`, `key`, `developerKey`, `isSystem`, `isActive`, `adminSettingsRoute`, `uninstallRoute`, `build`, `update`, `licenseKey`) VALUES
(1, 'Base OW plugin', 'الوصف', 'base', 'base', '', 1, 1, NULL, NULL, 1, 0, NULL),
(3, 'Admin Panel', 'لوحة تحكم المدير', 'admin', 'admin', '', 1, 1, NULL, NULL, 1, 0, NULL);

CREATE TABLE `%%TBL-PREFIX%%base_preference` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(100) NOT NULL,
  `defaultValue` text NOT NULL,
  `sectionName` varchar(100) NOT NULL,
  `sortOrder` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `key` (`key`),
  KEY `sortOrder` (`sortOrder`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_preference` (`id`, `key`, `defaultValue`, `sectionName`, `sortOrder`) VALUES
(1, 'mass_mailing_subscribe', 'true', 'general', 1),
(12, 'newsfeed_generate_action_set_timestamp', '0', 'general', 10000),
(25, 'send_wellcome_letter', '0', 'general', 99);

CREATE TABLE `%%TBL-PREFIX%%base_preference_data` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(100) NOT NULL,
  `userId` int(11) NOT NULL,
  `value` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`,`key`),
  KEY `key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_preference_section` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `sortOrder` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_preference_section` (`id`, `name`, `sortOrder`) VALUES
(1, 'general', 1);

CREATE TABLE `%%TBL-PREFIX%%base_question` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `sectionName` varchar(32) default NULL,
  `accountTypeName` varchar(32) default NULL,
  `type` enum('text','select','datetime','boolean','multiselect') NOT NULL default 'text',
  `presentation` enum('text','textarea','select','date','location','checkbox','multicheckbox','radio','url','password','age','birthdate') NOT NULL default 'text',
  `required` tinyint(1) NOT NULL default '0',
  `onJoin` tinyint(1) NOT NULL default '0',
  `onEdit` tinyint(1) NOT NULL default '0',
  `onSearch` tinyint(1) NOT NULL default '0',
  `onView` tinyint(1) NOT NULL default '0',
  `base` tinyint(1) NOT NULL default '0',
  `removable` tinyint(1) NOT NULL default '1',
  `columnCount` int(11) NOT NULL default '1',
  `sortOrder` int(11) NOT NULL default '0',
  `custom` varchar(2048) default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `sectionId` (`sectionName`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_question` (`id`, `name`, `sectionName`, `accountTypeName`, `type`, `presentation`, `required`, `onJoin`, `onEdit`, `onSearch`, `onView`, `base`, `removable`, `columnCount`, `sortOrder`, `custom`) VALUES
(112, 'relationship', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'select', 'multicheckbox', 0, 1, 1, 1, 1, 0, 1, 1, 7, '[]'),
(84, '9221d78a4201eac23c972e1d4aa2cee6', '47f3a94e6cfe733857b31116ce21c337', NULL, 'text', 'textarea', 0, 1, 1, 1, 1, 0, 1, 0, 0, '[]'),
(83, 'c441a8a9b955647cdf4c81562d39068a', '47f3a94e6cfe733857b31116ce21c337', NULL, 'text', 'textarea', 0, 1, 1, 1, 1, 0, 1, 0, 1, '[]'),
(81, 'password', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'text', 'password', 1, 1, 0, 0, 0, 1, 0, 1, 2, '[]'),
(104, 'realname', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'text', 'text', 1, 1, 1, 0, 1, 0, 0, 0, 3, '[]'),
(94, 'sex', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'select', 'radio', 1, 1, 1, 1, 1, 0, 0, 1, 4, '[]'),
(97, 'ab9fc810a1938e599b7d084efea97d91', '47f3a94e6cfe733857b31116ce21c337', '0590763b00b8bf3f55036f4ce8d25f1b', 'select', 'multicheckbox', 1, 1, 0, 0, 0, 0, 1, 2, 7, ' '),
(82, 'email', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'text', 'text', 1, 1, 1, 0, 0, 1, 0, 1, 1, '[]'),
(111, 'match_sex', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'select', 'multicheckbox', 0, 1, 1, 0, 1, 0, 1, 1, 6, '[]'),
(92, 'birthdate', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'datetime', 'birthdate', 1, 1, 1, 0, 0, 0, 0, 0, 5, '{"year_range":{"من":1930,"إلى":1992}}'),
(80, 'username', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'text', 'text', 1, 1, 1, 0, 0, 1, 0, 1, 0, '[]'),
(119, 'joinStamp', 'f90cde5913235d172603cc4e7b9726e3', NULL, 'select', 'date', 0, 0, 0, 0, 1, 1, 0, 0, 8, '{"year_range":{"من":1930,"إلى":1975}}');

CREATE TABLE `%%TBL-PREFIX%%base_question_account_type` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `sortOrder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`name`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_question_account_type` (`id`, `name`, `sortOrder`) VALUES
(53, '290365aadde35a97f11207ca7e4279cc', 0);

CREATE TABLE `%%TBL-PREFIX%%base_question_config` (
  `id` int(11) NOT NULL auto_increment,
  `questionPresentation` enum('text','textarea','select','date','location','checkbox','multicheckbox','radio','url','password','age','birthdate') NOT NULL default 'text',
  `name` varchar(255) NOT NULL,
  `description` varchar(1024) default NULL,
  `presentationClass` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_question_config` (`id`, `questionPresentation`, `name`, `description`, `presentationClass`) VALUES
(1, 'date', 'year_range', '', 'YearRange'),
(2, 'age', 'year_range', '', 'YearRange'),
(3, 'birthdate', 'year_range', '', 'YearRange');

CREATE TABLE `%%TBL-PREFIX%%base_question_data` (
  `id` int(11) NOT NULL auto_increment,
  `questionName` varchar(255) NOT NULL default '',
  `userId` int(11) NOT NULL default '0',
  `textValue` text NOT NULL,
  `intValue` int(11) NOT NULL default '0',
  `dateValue` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`,`questionName`),
  KEY `fieldName` (`questionName`),
  KEY `intValue` (`intValue`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_question_section` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(32) default NULL,
  `sortOrder` int(11) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `sectionName` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_question_section` (`id`, `name`, `sortOrder`) VALUES
(20, '47f3a94e6cfe733857b31116ce21c337', 1),
(34, 'f90cde5913235d172603cc4e7b9726e3', 0),
(35, 'e46697c921740b10b1ac7223a14155b2', 2);

CREATE TABLE `%%TBL-PREFIX%%base_question_value` (
  `id` int(11) NOT NULL auto_increment,
  `questionName` varchar(32) default NULL,
  `value` int(11) NOT NULL default '0',
  `sortOrder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `questionName` (`questionName`,`value`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_question_value` (`id`, `questionName`, `value`, `sortOrder`) VALUES
(335, 'd68489df439fe45427e305a0e2dbe349', 1, 0),
(336, 'd68489df439fe45427e305a0e2dbe349', 2, 1),
(305, '4971fc7002dca728f9a7f2a417c5284e', 32, 0),
(304, '28f881c609c933f6b1719cdf6dcf4cab', 8, 3),
(303, '28f881c609c933f6b1719cdf6dcf4cab', 4, 2),
(302, '28f881c609c933f6b1719cdf6dcf4cab', 2, 1),
(301, '28f881c609c933f6b1719cdf6dcf4cab', 1, 0),
(300, '490d035a492be91d7bf9589f881e2d22', 4, 2),
(299, '490d035a492be91d7bf9589f881e2d22', 2, 1),
(298, '490d035a492be91d7bf9589f881e2d22', 1, 0),
(297, '4971fc7002dca728f9a7f2a417c5284e', 16, 6),
(296, '4971fc7002dca728f9a7f2a417c5284e', 8, 8),
(295, '4971fc7002dca728f9a7f2a417c5284e', 4, 7),
(294, '4971fc7002dca728f9a7f2a417c5284e', 2, 1),
(334, '4971fc7002dca728f9a7f2a417c5284e', 1, 5),
(292, '92947e48441284286fe8a7b175f34a6e', 32, 5),
(291, '92947e48441284286fe8a7b175f34a6e', 16, 4),
(290, '92947e48441284286fe8a7b175f34a6e', 8, 3),
(289, '92947e48441284286fe8a7b175f34a6e', 4, 2),
(288, '92947e48441284286fe8a7b175f34a6e', 2, 1),
(287, '92947e48441284286fe8a7b175f34a6e', 1, 0),
(307, '4971fc7002dca728f9a7f2a417c5284e', 128, 2),
(337, 'd68489df439fe45427e305a0e2dbe349', 4, 2),
(309, '4971fc7002dca728f9a7f2a417c5284e', 512, 4),
(310, 'sex', 1, 0),
(311, 'sex', 2, 1),
(312, '28f881c609c933f6b1719cdf6dcf4cab', 16, 4),
(313, '28f881c609c933f6b1719cdf6dcf4cab', 32, 5),
(314, '28f881c609c933f6b1719cdf6dcf4cab', 64, 6),
(315, '28f881c609c933f6b1719cdf6dcf4cab', 128, 7),
(316, '28f881c609c933f6b1719cdf6dcf4cab', 256, 8),
(317, '28f881c609c933f6b1719cdf6dcf4cab', 512, 9),
(318, '28f881c609c933f6b1719cdf6dcf4cab', 1024, 10),
(319, '5d32f746a541b97f18a957ad5856318e', 1, 0),
(320, '5d32f746a541b97f18a957ad5856318e', 2, 1),
(321, '5d32f746a541b97f18a957ad5856318e', 4, 2),
(322, '5d32f746a541b97f18a957ad5856318e', 8, 3),
(323, '5d32f746a541b97f18a957ad5856318e', 16, 4),
(324, '5d32f746a541b97f18a957ad5856318e', 32, 5),
(325, '5d32f746a541b97f18a957ad5856318e', 64, 6),
(326, '5d32f746a541b97f18a957ad5856318e', 128, 7),
(327, 'ab9fc810a1938e599b7d084efea97d91', 1, 0),
(328, 'ab9fc810a1938e599b7d084efea97d91', 2, 1),
(329, 'ab9fc810a1938e599b7d084efea97d91', 4, 2),
(330, 'ab9fc810a1938e599b7d084efea97d91', 8, 3),
(333, '4971fc7002dca728f9a7f2a417c5284e', 256, 3),
(338, '1e615090f832c4fbee805ded8e9ced08', 1, 0),
(339, '1e615090f832c4fbee805ded8e9ced08', 2, 1),
(340, '1e615090f832c4fbee805ded8e9ced08', 4, 2),
(341, 'f8f4c260c54166c8fcf79057fd85aec0', 1, 0),
(342, 'f8f4c260c54166c8fcf79057fd85aec0', 2, 1),
(343, 'f8f4c260c54166c8fcf79057fd85aec0', 4, 2),
(347, 'match_sex', 2, 1),
(346, 'match_sex', 1, 0),
(356, 'relationship', 1, 0),
(357, 'relationship', 2, 3),
(358, 'relationship', 4, 2),
(359, 'relationship', 8, 1),
(360, '9ce3cf807fd94892c8c7bb75dc2af60d', 1, 0),
(361, '9ce3cf807fd94892c8c7bb75dc2af60d', 2, 1),
(362, '9ce3cf807fd94892c8c7bb75dc2af60d', 4, 2),
(364, '9ce3cf807fd94892c8c7bb75dc2af60d', 16, 4),
(365, '9ce3cf807fd94892c8c7bb75dc2af60d', 32, 5),
(366, '9ce3cf807fd94892c8c7bb75dc2af60d', 64, 6),
(367, '9ce3cf807fd94892c8c7bb75dc2af60d', 128, 7),
(368, '9ce3cf807fd94892c8c7bb75dc2af60d', 256, 8),
(369, '9ce3cf807fd94892c8c7bb75dc2af60d', 512, 9),
(370, '9ce3cf807fd94892c8c7bb75dc2af60d', 1024, 10),
(371, '9ce3cf807fd94892c8c7bb75dc2af60d', 2048, 11),
(372, '9ce3cf807fd94892c8c7bb75dc2af60d', 4096, 12),
(373, '9ce3cf807fd94892c8c7bb75dc2af60d', 8192, 13),
(374, '9ce3cf807fd94892c8c7bb75dc2af60d', 16384, 14),
(375, '9ce3cf807fd94892c8c7bb75dc2af60d', 32768, 15),
(376, '9ce3cf807fd94892c8c7bb75dc2af60d', 65536, 16),
(377, '9ce3cf807fd94892c8c7bb75dc2af60d', 131072, 17),
(378, '9ce3cf807fd94892c8c7bb75dc2af60d', 262144, 18),
(379, '9ce3cf807fd94892c8c7bb75dc2af60d', 524288, 19),
(380, '9ce3cf807fd94892c8c7bb75dc2af60d', 1048576, 20),
(381, '9ce3cf807fd94892c8c7bb75dc2af60d', 2097152, 21),
(382, '9ce3cf807fd94892c8c7bb75dc2af60d', 4194304, 22),
(383, '9ce3cf807fd94892c8c7bb75dc2af60d', 8388608, 23),
(384, '9ce3cf807fd94892c8c7bb75dc2af60d', 16777216, 24),
(385, '9ce3cf807fd94892c8c7bb75dc2af60d', 33554432, 25),
(386, '9ce3cf807fd94892c8c7bb75dc2af60d', 67108864, 26),
(387, '9ce3cf807fd94892c8c7bb75dc2af60d', 134217728, 27),
(388, '9ce3cf807fd94892c8c7bb75dc2af60d', 268435456, 28),
(389, '9ce3cf807fd94892c8c7bb75dc2af60d', 536870912, 29),
(390, '9ce3cf807fd94892c8c7bb75dc2af60d', 1073741824, 30),
(392, '8100f639e8becdefa741e05f0de73a15', 1, 0),
(393, '8100f639e8becdefa741e05f0de73a15', 2, 1),
(394, 'd37d41b71a78dfb62b379d0aa7bd3ba5', 1, 0),
(395, 'c5dc53f371fe6ba3001a7c7e31bd95fc', 1, 0),
(396, 'c5dc53f371fe6ba3001a7c7e31bd95fc', 2, 1),
(397, 'c5dc53f371fe6ba3001a7c7e31bd95fc', 4, 2),
(398, 'c5dc53f371fe6ba3001a7c7e31bd95fc', 8, 3),
(399, 'c5dc53f371fe6ba3001a7c7e31bd95fc', 16, 4),
(400, '7f2450f06779439551c75a8566c4070e', 1, 0),
(401, '7f2450f06779439551c75a8566c4070e', 2, 1),
(402, '7f2450f06779439551c75a8566c4070e', 4, 2),
(403, '7f2450f06779439551c75a8566c4070e', 8, 3),
(404, '7f2450f06779439551c75a8566c4070e', 16, 4),
(405, '7f2450f06779439551c75a8566c4070e', 32, 5),
(406, '7fbd88047415229961f4d2aac620fe25', 1, 0),
(407, '7fbd88047415229961f4d2aac620fe25', 2, 1),
(408, '7fbd88047415229961f4d2aac620fe25', 4, 2),
(409, '7fbd88047415229961f4d2aac620fe25', 8, 3),
(410, '7fbd88047415229961f4d2aac620fe25', 16, 4),
(411, '7fbd88047415229961f4d2aac620fe25', 32, 5),
(412, '7fbd88047415229961f4d2aac620fe25', 64, 6),
(413, 'a5115de7f38988e748370a59ba0b311d', 1, 0),
(414, 'a5115de7f38988e748370a59ba0b311d', 2, 1),
(415, 'a5115de7f38988e748370a59ba0b311d', 4, 2),
(416, 'a5115de7f38988e748370a59ba0b311d', 8, 3),
(417, 'd8aa20d67fbb6c6864e46c474d0bde10', 1, 0),
(418, 'd8aa20d67fbb6c6864e46c474d0bde10', 2, 1),
(419, 'd8aa20d67fbb6c6864e46c474d0bde10', 4, 2),
(420, 'd8aa20d67fbb6c6864e46c474d0bde10', 8, 3),
(421, 'd8aa20d67fbb6c6864e46c474d0bde10', 16, 4),
(422, 'd8aa20d67fbb6c6864e46c474d0bde10', 32, 5),
(423, 'd8aa20d67fbb6c6864e46c474d0bde10', 64, 6),
(424, 'd8aa20d67fbb6c6864e46c474d0bde10', 128, 7),
(425, 'd8aa20d67fbb6c6864e46c474d0bde10', 256, 8),
(426, 'd8aa20d67fbb6c6864e46c474d0bde10', 512, 9);

CREATE TABLE `%%TBL-PREFIX%%base_rate` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `entityType` varchar(255) NOT NULL,
  `entityId` int(10) unsigned NOT NULL,
  `userId` int(10) unsigned NOT NULL,
  `score` int(10) unsigned NOT NULL,
  `timeStamp` int(10) unsigned NOT NULL,
  `active` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `entityType` (`entityType`),
  KEY `entityId` (`entityId`),
  KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_remote_auth` (
  `id` int(11) NOT NULL auto_increment,
  `type` varchar(20) NOT NULL,
  `userId` int(11) NOT NULL,
  `remoteId` varchar(50) NOT NULL,
  `timeStamp` int(11) NOT NULL,
  `custom` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_restricted_usernames` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_scheme` (
  `id` tinyint(4) NOT NULL auto_increment,
  `rightCssClass` varchar(50) character set latin1 default NULL,
  `leftCssClass` varchar(50) character set latin1 default NULL,
  `cssClass` varchar(50) character set latin1 default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_scheme` (`id`, `rightCssClass`, `leftCssClass`, `cssClass`) VALUES
(1, 'ow_superwide', 'ow_supernarrow', 'ow_scheme_enew'),
(2, 'ow_wide', 'ow_narrow', 'ow_scheme_nw'),
(3, 'ow_column', 'ow_column', 'ow_scheme_equal'),
(4, 'ow_narrow', 'ow_wide', 'ow_scheme_wn'),
(5, 'ow_supernarrow', 'ow_superwide', 'ow_scheme_ewen');

CREATE TABLE `%%TBL-PREFIX%%base_search` (
  `id` int(11) NOT NULL auto_increment,
  `timeStamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `timeStamp` (`timeStamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_search_result` (
  `id` int(11) NOT NULL auto_increment,
  `searchId` int(11) NOT NULL default '0',
  `userId` int(11) NOT NULL,
  `sortOrder` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `searchResult` (`searchId`,`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_tag` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `label` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `label` (`label`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_theme` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `isActive` tinyint(1) NOT NULL default '0',
  `customCss` text,
  `customCssFileName` varchar(255) default NULL,
  `sidebarPosition` enum('left','right','none') NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `%%TBL-PREFIX%%base_theme` (`id`, `name`, `title`, `description`, `isActive`, `customCss`, `customCssFileName`, `sidebarPosition`) VALUES
(1, 'club', 'Club', '{"name":"Club","key":"club","description":"ستايل ''Club'' الأصلي","author":"مؤسسة Oxwall","authorEmail":"themes@oxwall.org","authorUrl":"http:\\/\\/www.oxwall.org\\/foundation","copyright":"(C) 2009 مؤسسة Oxwall. جميع الحقوق محفوظة.","license":"رخصة  BSD","licenseUrl":"http:\\/\\/www.opensource.org\\/licenses\\/bsd-license.php"}', 0, NULL, NULL, 'none'),
(8, 'graphite', 'Graphite', '{"name":"Graphite","key":"graphite","description":"ستايل ''Graphite'' الأصلي","author":"مؤسسة Oxwall","authorEmail":"themes@oxwall.org","authorUrl":"http:\\/\\/www.oxwall.org\\/foundation","copyright":"(C) 2009 مؤسسة Oxwall. جميع الحقوق محفوظة.","license":"رخصة  BSD","licenseUrl":"http:\\/\\/www.opensource.org\\/licenses\\/bsd-license.php"}', 0, NULL, NULL, 'none');

CREATE TABLE `%%TBL-PREFIX%%base_theme_content` (
  `id` int(11) NOT NULL auto_increment,
  `themeId` int(11) NOT NULL,
  `type` enum('decorator','master_page') NOT NULL,
  `value` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `themeId` (`themeId`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_theme_control` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `attribute` varchar(255) NOT NULL,
  `selector` text NOT NULL,
  `defaultValue` text NOT NULL,
  `type` enum('color','text','font','image') NOT NULL default 'text',
  `themeId` int(10) unsigned NOT NULL,
  `key` varchar(255) NOT NULL default '',
  `section` text NOT NULL,
  `label` text NOT NULL,
  `description` text,
  PRIMARY KEY  (`id`),
  KEY `name` (`key`),
  KEY `themeId` (`themeId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_theme_control_value` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `themeControlKey` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `themeId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `themeControlKey` (`themeControlKey`,`themeId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_theme_image` (
  `id` int(11) NOT NULL auto_increment,
  `filename` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_theme_master_page` (
  `id` int(11) NOT NULL auto_increment,
  `themeId` int(11) NOT NULL,
  `documentKey` varchar(255) NOT NULL,
  `masterPage` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `themeId` (`themeId`),
  KEY `documentKey` (`documentKey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_user` (
  `id` int(11) NOT NULL auto_increment,
  `email` varchar(128) NOT NULL default '',
  `username` varchar(32) NOT NULL default '',
  `password` varchar(64) NOT NULL default '',
  `joinStamp` int(11) NOT NULL default '0',
  `activityStamp` int(11) NOT NULL default '0',
  `accountType` varchar(32) NOT NULL default '',
  `emailVerify` tinyint(2) NOT NULL default '0',
  `joinIp` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `email` (`email`),
  UNIQUE KEY `username` (`username`),
  KEY `accountType` (`accountType`),
  KEY `joinStamp` (`joinStamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';

CREATE TABLE `%%TBL-PREFIX%%base_user_block` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  `blockedUserId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId_blockedUserId` (`userId`,`blockedUserId`),
  KEY `userId` (`userId`),
  KEY `blockedUserId` (`blockedUserId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_user_disapprove` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_user_featured` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 MIN_ROWS=20;

CREATE TABLE `%%TBL-PREFIX%%base_user_online` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  `activityStamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_user_reset_password` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL,
  `code` varchar(150) NOT NULL,
  `expirationTimeStamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_user_status` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) default NULL,
  `status` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_user_suspend` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) default NULL,
  `timestamp` int(11) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `%%TBL-PREFIX%%base_vote` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `userId` int(11) unsigned NOT NULL,
  `entityId` int(11) unsigned NOT NULL,
  `entityType` varchar(255) NOT NULL,
  `vote` tinyint(4) NOT NULL,
  `timeStamp` int(11) unsigned NOT NULL,
  `active` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `userId` (`userId`),
  KEY `entityId` (`entityId`),
  KEY `entityType` (`entityType`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;